#include "tree_sitter/parser.h"

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#ifdef _MSC_VER
#pragma optimize("", off)
#elif defined(__clang__)
#pragma clang optimize off
#elif defined(__GNUC__)
#pragma GCC optimize ("O0")
#endif

#define LANGUAGE_VERSION 14
#define STATE_COUNT 12818
#define LARGE_STATE_COUNT 614
#define SYMBOL_COUNT 223
#define ALIAS_COUNT 5
#define TOKEN_COUNT 90
#define EXTERNAL_TOKEN_COUNT 3
#define FIELD_COUNT 0
#define MAX_ALIAS_SEQUENCE_LENGTH 7
#define PRODUCTION_ID_COUNT 9

enum ts_symbol_identifiers {
  sym_id = 1,
  anon_sym_forall = 2,
  anon_sym_u2200 = 3,
  anon_sym_DASH_GT = 4,
  anon_sym_u2192 = 5,
  anon_sym_BSLASH = 6,
  anon_sym_u03bb = 7,
  anon_sym_DOT_DOT_DOT = 8,
  anon_sym_u2026 = 9,
  anon_sym_field = 10,
  anon_sym_overlap = 11,
  anon_sym_COLON = 12,
  anon_sym_instance = 13,
  anon_sym_EQ = 14,
  anon_sym_with = 15,
  anon_sym_rewrite = 16,
  anon_sym_module = 17,
  anon_sym_where = 18,
  anon_sym_data = 19,
  anon_sym_codata = 20,
  anon_sym_record = 21,
  anon_sym_constructor = 22,
  anon_sym_inductive = 23,
  anon_sym_coinductive = 24,
  anon_sym_eta_DASHequality = 25,
  anon_sym_no_DASHeta_DASHequality = 26,
  anon_sym_infix = 27,
  anon_sym_infixl = 28,
  anon_sym_infixr = 29,
  anon_sym_variable = 30,
  anon_sym_mutual = 31,
  anon_sym_abstract = 32,
  anon_sym_private = 33,
  anon_sym_macro = 34,
  anon_sym_postulate = 35,
  anon_sym_primitive = 36,
  anon_sym_open = 37,
  anon_sym_import = 38,
  anon_sym_public = 39,
  anon_sym_using = 40,
  anon_sym_LPAREN = 41,
  anon_sym_RPAREN = 42,
  anon_sym_hiding = 43,
  anon_sym_renaming = 44,
  anon_sym_SEMI = 45,
  anon_sym_to = 46,
  anon_sym_LBRACE_LBRACE = 47,
  anon_sym_RBRACE_RBRACE = 48,
  anon_sym_u2983 = 49,
  anon_sym_u2984 = 50,
  anon_sym__ = 51,
  sym_pragma = 52,
  anon_sym_LBRACE_DASH_POUND = 53,
  anon_sym_CATCHALL = 54,
  anon_sym_POUND_DASH_RBRACE = 55,
  anon_sym_syntax = 56,
  anon_sym_LBRACE = 57,
  anon_sym_RBRACE = 58,
  anon_sym_pattern = 59,
  anon_sym_unquoteDecl = 60,
  anon_sym_unquoteDef = 61,
  aux_sym__qid_token1 = 62,
  anon_sym_DOT = 63,
  anon_sym_DOT_DOT = 64,
  anon_sym_DASH = 65,
  anon_sym_AT = 66,
  anon_sym_PIPE = 67,
  anon_sym_quoteGoal = 68,
  anon_sym_in = 69,
  anon_sym_tactic = 70,
  anon_sym_Prop = 71,
  anon_sym_quote = 72,
  anon_sym_quoteTerm = 73,
  anon_sym_quoteContext = 74,
  anon_sym_unquote = 75,
  anon_sym_LPAREN_PIPE = 76,
  anon_sym_PIPE_RPAREN = 77,
  anon_sym_u2987 = 78,
  anon_sym_u2988 = 79,
  anon_sym_let = 80,
  anon_sym_do = 81,
  aux_sym_integer_token1 = 82,
  aux_sym_string_token1 = 83,
  sym_comment = 84,
  anon_sym_Set = 85,
  sym_PropN = 86,
  sym__newline = 87,
  sym__indent = 88,
  sym__dedent = 89,
  sym_source_file = 90,
  sym__FORALL = 91,
  sym__ARROW = 92,
  sym__LAMBDA = 93,
  sym__ELLIPSIS = 94,
  sym__declaration_block = 95,
  sym__declaration = 96,
  sym_fields = 97,
  sym__signature_block = 98,
  sym_signature = 99,
  sym__modal_arg_ids = 100,
  sym_function = 101,
  sym_lhs_decl = 102,
  sym_lhs_defn = 103,
  sym_rhs_decl = 104,
  sym_rhs_defn = 105,
  sym_with_expressions = 106,
  sym_rewrite_equations = 107,
  sym_where = 108,
  sym_data_name = 109,
  sym_data = 110,
  sym_data_signature = 111,
  sym_record = 112,
  sym_record_declarations_block = 113,
  sym__record_directive = 114,
  sym_record_constructor = 115,
  sym_record_constructor_instance = 116,
  sym_record_induction = 117,
  sym_record_eta = 118,
  sym_record_signature = 119,
  sym_infix = 120,
  sym_generalize = 121,
  sym_mutual = 122,
  sym_abstract = 123,
  sym_private = 124,
  sym_instance = 125,
  sym_macro = 126,
  sym_postulate = 127,
  sym_primitive = 128,
  sym__type_signature_block = 129,
  sym_type_signature = 130,
  sym_open = 131,
  sym_import = 132,
  sym_module_name = 133,
  aux_sym__import_directives = 134,
  sym_import_directive = 135,
  sym__comma_import_names = 136,
  sym_renaming = 137,
  sym__import_name = 138,
  sym_module_macro = 139,
  sym_module_application = 140,
  sym_module = 141,
  sym_catchall_pragma = 142,
  sym_syntax = 143,
  sym_hole_names = 144,
  sym_hole_name = 145,
  sym__simple_top_hole = 146,
  sym__simple_hole = 147,
  sym_pattern = 148,
  sym_unquote_decl = 149,
  sym__qid = 150,
  sym_bid = 151,
  aux_sym__ids = 152,
  sym__field_name = 153,
  aux_sym__field_names = 154,
  sym__maybe_dotted_id = 155,
  aux_sym__maybe_dotted_ids = 156,
  aux_sym__arg_ids = 157,
  sym__arg_id = 158,
  sym__binding_ids_and_absurds = 159,
  sym_attribute = 160,
  sym_attributes = 161,
  sym_expr = 162,
  sym_stmt = 163,
  sym__with_exprs = 164,
  sym__with_exprs_stmt = 165,
  sym__expr_or_attr = 166,
  sym__application = 167,
  sym__application_stmt = 168,
  sym__expr2_without_let = 169,
  sym__expr2 = 170,
  sym__expr2_stmt = 171,
  sym_atom = 172,
  aux_sym__atoms = 173,
  sym__atom_curly = 174,
  sym__atom_no_curly = 175,
  sym_forall = 176,
  sym_let = 177,
  sym_let_in_do = 178,
  sym__let_body = 179,
  sym_lambda = 180,
  sym__lambda_bindings = 181,
  sym_lambda_extended_or_absurd = 182,
  sym__lambda_clauses = 183,
  sym__lambda_clause_maybe_absurd = 184,
  sym_lambda_clause_absurd = 185,
  sym_lambda_clause = 186,
  sym_do = 187,
  sym__do_stmt = 188,
  sym_do_where = 189,
  sym_record_assignments = 190,
  sym_field_assignments = 191,
  sym__record_assignments = 192,
  sym__field_assignments = 193,
  sym__record_assignment = 194,
  sym_field_assignment = 195,
  sym_module_assignment = 196,
  aux_sym__typed_bindings = 197,
  sym_typed_binding = 198,
  aux_sym__typed_untyped_bindings = 199,
  sym__typed_untyped_binding = 200,
  sym_untyped_binding = 201,
  sym_integer = 202,
  sym_literal = 203,
  sym_SetN = 204,
  aux_sym_source_file_repeat1 = 205,
  aux_sym__signature_block_repeat1 = 206,
  aux_sym__modal_arg_ids_repeat1 = 207,
  aux_sym_record_declarations_block_repeat1 = 208,
  aux_sym_record_constructor_instance_repeat1 = 209,
  aux_sym_infix_repeat1 = 210,
  aux_sym__type_signature_block_repeat1 = 211,
  aux_sym_import_directive_repeat1 = 212,
  aux_sym__comma_import_names_repeat1 = 213,
  aux_sym_module_macro_repeat1 = 214,
  aux_sym_syntax_repeat1 = 215,
  aux_sym_hole_names_repeat1 = 216,
  aux_sym__with_exprs_repeat1 = 217,
  aux_sym__lambda_bindings_repeat1 = 218,
  aux_sym__lambda_clauses_repeat1 = 219,
  aux_sym_do_repeat1 = 220,
  aux_sym__record_assignments_repeat1 = 221,
  aux_sym__field_assignments_repeat1 = 222,
  anon_alias_sym_bid = 223,
  anon_alias_sym_data_name = 224,
  alias_sym_field_name = 225,
  alias_sym_function_name = 226,
  alias_sym_record_name = 227,
};

static const char * const ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [sym_id] = "id",
  [anon_sym_forall] = "forall",
  [anon_sym_u2200] = "\u2200",
  [anon_sym_DASH_GT] = "->",
  [anon_sym_u2192] = "\u2192",
  [anon_sym_BSLASH] = "\\",
  [anon_sym_u03bb] = "\u03bb",
  [anon_sym_DOT_DOT_DOT] = "...",
  [anon_sym_u2026] = "\u2026",
  [anon_sym_field] = "field",
  [anon_sym_overlap] = "overlap",
  [anon_sym_COLON] = ":",
  [anon_sym_instance] = "instance",
  [anon_sym_EQ] = "=",
  [anon_sym_with] = "with",
  [anon_sym_rewrite] = "rewrite",
  [anon_sym_module] = "module",
  [anon_sym_where] = "where",
  [anon_sym_data] = "data",
  [anon_sym_codata] = "codata",
  [anon_sym_record] = "record",
  [anon_sym_constructor] = "constructor",
  [anon_sym_inductive] = "inductive",
  [anon_sym_coinductive] = "coinductive",
  [anon_sym_eta_DASHequality] = "eta-equality",
  [anon_sym_no_DASHeta_DASHequality] = "no-eta-equality",
  [anon_sym_infix] = "infix",
  [anon_sym_infixl] = "infixl",
  [anon_sym_infixr] = "infixr",
  [anon_sym_variable] = "variable",
  [anon_sym_mutual] = "mutual",
  [anon_sym_abstract] = "abstract",
  [anon_sym_private] = "private",
  [anon_sym_macro] = "macro",
  [anon_sym_postulate] = "postulate",
  [anon_sym_primitive] = "primitive",
  [anon_sym_open] = "open",
  [anon_sym_import] = "import",
  [anon_sym_public] = "public",
  [anon_sym_using] = "using",
  [anon_sym_LPAREN] = "(",
  [anon_sym_RPAREN] = ")",
  [anon_sym_hiding] = "hiding",
  [anon_sym_renaming] = "renaming",
  [anon_sym_SEMI] = ";",
  [anon_sym_to] = "to",
  [anon_sym_LBRACE_LBRACE] = "{{",
  [anon_sym_RBRACE_RBRACE] = "}}",
  [anon_sym_u2983] = "\u2983",
  [anon_sym_u2984] = "\u2984",
  [anon_sym__] = "_",
  [sym_pragma] = "pragma",
  [anon_sym_LBRACE_DASH_POUND] = "{-#",
  [anon_sym_CATCHALL] = "CATCHALL",
  [anon_sym_POUND_DASH_RBRACE] = "#-}",
  [anon_sym_syntax] = "syntax",
  [anon_sym_LBRACE] = "{",
  [anon_sym_RBRACE] = "}",
  [anon_sym_pattern] = "pattern",
  [anon_sym_unquoteDecl] = "unquoteDecl",
  [anon_sym_unquoteDef] = "unquoteDef",
  [aux_sym__qid_token1] = "qid",
  [anon_sym_DOT] = ".",
  [anon_sym_DOT_DOT] = "..",
  [anon_sym_DASH] = "-",
  [anon_sym_AT] = "@",
  [anon_sym_PIPE] = "|",
  [anon_sym_quoteGoal] = "quoteGoal",
  [anon_sym_in] = "in",
  [anon_sym_tactic] = "tactic",
  [anon_sym_Prop] = "Prop",
  [anon_sym_quote] = "quote",
  [anon_sym_quoteTerm] = "quoteTerm",
  [anon_sym_quoteContext] = "quoteContext",
  [anon_sym_unquote] = "unquote",
  [anon_sym_LPAREN_PIPE] = "(|",
  [anon_sym_PIPE_RPAREN] = "|)",
  [anon_sym_u2987] = "\u2987",
  [anon_sym_u2988] = "\u2988",
  [anon_sym_let] = "let",
  [anon_sym_do] = "do",
  [aux_sym_integer_token1] = "integer_token1",
  [aux_sym_string_token1] = "string_token1",
  [sym_comment] = "comment",
  [anon_sym_Set] = "Set",
  [sym_PropN] = "PropN",
  [sym__newline] = "_newline",
  [sym__indent] = "_indent",
  [sym__dedent] = "_dedent",
  [sym_source_file] = "source_file",
  [sym__FORALL] = "_FORALL",
  [sym__ARROW] = "_ARROW",
  [sym__LAMBDA] = "_LAMBDA",
  [sym__ELLIPSIS] = "_ELLIPSIS",
  [sym__declaration_block] = "_declaration_block",
  [sym__declaration] = "_declaration",
  [sym_fields] = "fields",
  [sym__signature_block] = "_signature_block",
  [sym_signature] = "signature",
  [sym__modal_arg_ids] = "_modal_arg_ids",
  [sym_function] = "function",
  [sym_lhs_decl] = "lhs",
  [sym_lhs_defn] = "lhs",
  [sym_rhs_decl] = "rhs",
  [sym_rhs_defn] = "rhs",
  [sym_with_expressions] = "with_expressions",
  [sym_rewrite_equations] = "rewrite_equations",
  [sym_where] = "where",
  [sym_data_name] = "data_name",
  [sym_data] = "data",
  [sym_data_signature] = "data_signature",
  [sym_record] = "record",
  [sym_record_declarations_block] = "record_declarations_block",
  [sym__record_directive] = "_record_directive",
  [sym_record_constructor] = "record_constructor",
  [sym_record_constructor_instance] = "record_constructor_instance",
  [sym_record_induction] = "record_induction",
  [sym_record_eta] = "record_eta",
  [sym_record_signature] = "record_signature",
  [sym_infix] = "infix",
  [sym_generalize] = "generalize",
  [sym_mutual] = "mutual",
  [sym_abstract] = "abstract",
  [sym_private] = "private",
  [sym_instance] = "instance",
  [sym_macro] = "macro",
  [sym_postulate] = "postulate",
  [sym_primitive] = "primitive",
  [sym__type_signature_block] = "_type_signature_block",
  [sym_type_signature] = "type_signature",
  [sym_open] = "open",
  [sym_import] = "import",
  [sym_module_name] = "module_name",
  [aux_sym__import_directives] = "_import_directives",
  [sym_import_directive] = "import_directive",
  [sym__comma_import_names] = "_comma_import_names",
  [sym_renaming] = "renaming",
  [sym__import_name] = "_import_name",
  [sym_module_macro] = "module_macro",
  [sym_module_application] = "module_application",
  [sym_module] = "module",
  [sym_catchall_pragma] = "catchall_pragma",
  [sym_syntax] = "syntax",
  [sym_hole_names] = "hole_names",
  [sym_hole_name] = "hole_name",
  [sym__simple_top_hole] = "_simple_top_hole",
  [sym__simple_hole] = "_simple_hole",
  [sym_pattern] = "pattern",
  [sym_unquote_decl] = "unquote_decl",
  [sym__qid] = "_qid",
  [sym_bid] = "bid",
  [aux_sym__ids] = "_ids",
  [sym__field_name] = "_field_name",
  [aux_sym__field_names] = "_field_names",
  [sym__maybe_dotted_id] = "_maybe_dotted_id",
  [aux_sym__maybe_dotted_ids] = "_maybe_dotted_ids",
  [aux_sym__arg_ids] = "_arg_ids",
  [sym__arg_id] = "_arg_id",
  [sym__binding_ids_and_absurds] = "_binding_ids_and_absurds",
  [sym_attribute] = "attribute",
  [sym_attributes] = "attributes",
  [sym_expr] = "expr",
  [sym_stmt] = "stmt",
  [sym__with_exprs] = "_with_exprs",
  [sym__with_exprs_stmt] = "_with_exprs_stmt",
  [sym__expr_or_attr] = "_expr_or_attr",
  [sym__application] = "_application",
  [sym__application_stmt] = "_application_stmt",
  [sym__expr2_without_let] = "_expr2_without_let",
  [sym__expr2] = "_expr2",
  [sym__expr2_stmt] = "_expr2_stmt",
  [sym_atom] = "atom",
  [aux_sym__atoms] = "_atoms",
  [sym__atom_curly] = "_atom_curly",
  [sym__atom_no_curly] = "_atom_no_curly",
  [sym_forall] = "forall",
  [sym_let] = "let",
  [sym_let_in_do] = "let",
  [sym__let_body] = "_let_body",
  [sym_lambda] = "lambda",
  [sym__lambda_bindings] = "_lambda_bindings",
  [sym_lambda_extended_or_absurd] = "lambda",
  [sym__lambda_clauses] = "_lambda_clauses",
  [sym__lambda_clause_maybe_absurd] = "_lambda_clause_maybe_absurd",
  [sym_lambda_clause_absurd] = "lambda_clause_absurd",
  [sym_lambda_clause] = "lambda_clause",
  [sym_do] = "do",
  [sym__do_stmt] = "_do_stmt",
  [sym_do_where] = "do_where",
  [sym_record_assignments] = "record_assignments",
  [sym_field_assignments] = "record_assignments",
  [sym__record_assignments] = "_record_assignments",
  [sym__field_assignments] = "_field_assignments",
  [sym__record_assignment] = "_record_assignment",
  [sym_field_assignment] = "field_assignment",
  [sym_module_assignment] = "module_assignment",
  [aux_sym__typed_bindings] = "_typed_bindings",
  [sym_typed_binding] = "typed_binding",
  [aux_sym__typed_untyped_bindings] = "_typed_untyped_bindings",
  [sym__typed_untyped_binding] = "_typed_untyped_binding",
  [sym_untyped_binding] = "untyped_binding",
  [sym_integer] = "integer",
  [sym_literal] = "literal",
  [sym_SetN] = "SetN",
  [aux_sym_source_file_repeat1] = "source_file_repeat1",
  [aux_sym__signature_block_repeat1] = "_signature_block_repeat1",
  [aux_sym__modal_arg_ids_repeat1] = "_modal_arg_ids_repeat1",
  [aux_sym_record_declarations_block_repeat1] = "record_declarations_block_repeat1",
  [aux_sym_record_constructor_instance_repeat1] = "record_constructor_instance_repeat1",
  [aux_sym_infix_repeat1] = "infix_repeat1",
  [aux_sym__type_signature_block_repeat1] = "_type_signature_block_repeat1",
  [aux_sym_import_directive_repeat1] = "import_directive_repeat1",
  [aux_sym__comma_import_names_repeat1] = "_comma_import_names_repeat1",
  [aux_sym_module_macro_repeat1] = "module_macro_repeat1",
  [aux_sym_syntax_repeat1] = "syntax_repeat1",
  [aux_sym_hole_names_repeat1] = "hole_names_repeat1",
  [aux_sym__with_exprs_repeat1] = "_with_exprs_repeat1",
  [aux_sym__lambda_bindings_repeat1] = "_lambda_bindings_repeat1",
  [aux_sym__lambda_clauses_repeat1] = "_lambda_clauses_repeat1",
  [aux_sym_do_repeat1] = "do_repeat1",
  [aux_sym__record_assignments_repeat1] = "_record_assignments_repeat1",
  [aux_sym__field_assignments_repeat1] = "_field_assignments_repeat1",
  [anon_alias_sym_bid] = "bid",
  [anon_alias_sym_data_name] = "data_name",
  [alias_sym_field_name] = "field_name",
  [alias_sym_function_name] = "function_name",
  [alias_sym_record_name] = "record_name",
};

static const TSSymbol ts_symbol_map[] = {
  [ts_builtin_sym_end] = ts_builtin_sym_end,
  [sym_id] = sym_id,
  [anon_sym_forall] = anon_sym_forall,
  [anon_sym_u2200] = anon_sym_u2200,
  [anon_sym_DASH_GT] = anon_sym_DASH_GT,
  [anon_sym_u2192] = anon_sym_u2192,
  [anon_sym_BSLASH] = anon_sym_BSLASH,
  [anon_sym_u03bb] = anon_sym_u03bb,
  [anon_sym_DOT_DOT_DOT] = anon_sym_DOT_DOT_DOT,
  [anon_sym_u2026] = anon_sym_u2026,
  [anon_sym_field] = anon_sym_field,
  [anon_sym_overlap] = anon_sym_overlap,
  [anon_sym_COLON] = anon_sym_COLON,
  [anon_sym_instance] = anon_sym_instance,
  [anon_sym_EQ] = anon_sym_EQ,
  [anon_sym_with] = anon_sym_with,
  [anon_sym_rewrite] = anon_sym_rewrite,
  [anon_sym_module] = anon_sym_module,
  [anon_sym_where] = anon_sym_where,
  [anon_sym_data] = anon_sym_data,
  [anon_sym_codata] = anon_sym_codata,
  [anon_sym_record] = anon_sym_record,
  [anon_sym_constructor] = anon_sym_constructor,
  [anon_sym_inductive] = anon_sym_inductive,
  [anon_sym_coinductive] = anon_sym_coinductive,
  [anon_sym_eta_DASHequality] = anon_sym_eta_DASHequality,
  [anon_sym_no_DASHeta_DASHequality] = anon_sym_no_DASHeta_DASHequality,
  [anon_sym_infix] = anon_sym_infix,
  [anon_sym_infixl] = anon_sym_infixl,
  [anon_sym_infixr] = anon_sym_infixr,
  [anon_sym_variable] = anon_sym_variable,
  [anon_sym_mutual] = anon_sym_mutual,
  [anon_sym_abstract] = anon_sym_abstract,
  [anon_sym_private] = anon_sym_private,
  [anon_sym_macro] = anon_sym_macro,
  [anon_sym_postulate] = anon_sym_postulate,
  [anon_sym_primitive] = anon_sym_primitive,
  [anon_sym_open] = anon_sym_open,
  [anon_sym_import] = anon_sym_import,
  [anon_sym_public] = anon_sym_public,
  [anon_sym_using] = anon_sym_using,
  [anon_sym_LPAREN] = anon_sym_LPAREN,
  [anon_sym_RPAREN] = anon_sym_RPAREN,
  [anon_sym_hiding] = anon_sym_hiding,
  [anon_sym_renaming] = anon_sym_renaming,
  [anon_sym_SEMI] = anon_sym_SEMI,
  [anon_sym_to] = anon_sym_to,
  [anon_sym_LBRACE_LBRACE] = anon_sym_LBRACE_LBRACE,
  [anon_sym_RBRACE_RBRACE] = anon_sym_RBRACE_RBRACE,
  [anon_sym_u2983] = anon_sym_u2983,
  [anon_sym_u2984] = anon_sym_u2984,
  [anon_sym__] = anon_sym__,
  [sym_pragma] = sym_pragma,
  [anon_sym_LBRACE_DASH_POUND] = anon_sym_LBRACE_DASH_POUND,
  [anon_sym_CATCHALL] = anon_sym_CATCHALL,
  [anon_sym_POUND_DASH_RBRACE] = anon_sym_POUND_DASH_RBRACE,
  [anon_sym_syntax] = anon_sym_syntax,
  [anon_sym_LBRACE] = anon_sym_LBRACE,
  [anon_sym_RBRACE] = anon_sym_RBRACE,
  [anon_sym_pattern] = anon_sym_pattern,
  [anon_sym_unquoteDecl] = anon_sym_unquoteDecl,
  [anon_sym_unquoteDef] = anon_sym_unquoteDef,
  [aux_sym__qid_token1] = aux_sym__qid_token1,
  [anon_sym_DOT] = anon_sym_DOT,
  [anon_sym_DOT_DOT] = anon_sym_DOT_DOT,
  [anon_sym_DASH] = anon_sym_DASH,
  [anon_sym_AT] = anon_sym_AT,
  [anon_sym_PIPE] = anon_sym_PIPE,
  [anon_sym_quoteGoal] = anon_sym_quoteGoal,
  [anon_sym_in] = anon_sym_in,
  [anon_sym_tactic] = anon_sym_tactic,
  [anon_sym_Prop] = anon_sym_Prop,
  [anon_sym_quote] = anon_sym_quote,
  [anon_sym_quoteTerm] = anon_sym_quoteTerm,
  [anon_sym_quoteContext] = anon_sym_quoteContext,
  [anon_sym_unquote] = anon_sym_unquote,
  [anon_sym_LPAREN_PIPE] = anon_sym_LPAREN_PIPE,
  [anon_sym_PIPE_RPAREN] = anon_sym_PIPE_RPAREN,
  [anon_sym_u2987] = anon_sym_u2987,
  [anon_sym_u2988] = anon_sym_u2988,
  [anon_sym_let] = anon_sym_let,
  [anon_sym_do] = anon_sym_do,
  [aux_sym_integer_token1] = aux_sym_integer_token1,
  [aux_sym_string_token1] = aux_sym_string_token1,
  [sym_comment] = sym_comment,
  [anon_sym_Set] = anon_sym_Set,
  [sym_PropN] = sym_PropN,
  [sym__newline] = sym__newline,
  [sym__indent] = sym__indent,
  [sym__dedent] = sym__dedent,
  [sym_source_file] = sym_source_file,
  [sym__FORALL] = sym__FORALL,
  [sym__ARROW] = sym__ARROW,
  [sym__LAMBDA] = sym__LAMBDA,
  [sym__ELLIPSIS] = sym__ELLIPSIS,
  [sym__declaration_block] = sym__declaration_block,
  [sym__declaration] = sym__declaration,
  [sym_fields] = sym_fields,
  [sym__signature_block] = sym__signature_block,
  [sym_signature] = sym_signature,
  [sym__modal_arg_ids] = sym__modal_arg_ids,
  [sym_function] = sym_function,
  [sym_lhs_decl] = sym_lhs_decl,
  [sym_lhs_defn] = sym_lhs_decl,
  [sym_rhs_decl] = sym_rhs_decl,
  [sym_rhs_defn] = sym_rhs_decl,
  [sym_with_expressions] = sym_with_expressions,
  [sym_rewrite_equations] = sym_rewrite_equations,
  [sym_where] = sym_where,
  [sym_data_name] = sym_data_name,
  [sym_data] = sym_data,
  [sym_data_signature] = sym_data_signature,
  [sym_record] = sym_record,
  [sym_record_declarations_block] = sym_record_declarations_block,
  [sym__record_directive] = sym__record_directive,
  [sym_record_constructor] = sym_record_constructor,
  [sym_record_constructor_instance] = sym_record_constructor_instance,
  [sym_record_induction] = sym_record_induction,
  [sym_record_eta] = sym_record_eta,
  [sym_record_signature] = sym_record_signature,
  [sym_infix] = sym_infix,
  [sym_generalize] = sym_generalize,
  [sym_mutual] = sym_mutual,
  [sym_abstract] = sym_abstract,
  [sym_private] = sym_private,
  [sym_instance] = sym_instance,
  [sym_macro] = sym_macro,
  [sym_postulate] = sym_postulate,
  [sym_primitive] = sym_primitive,
  [sym__type_signature_block] = sym__type_signature_block,
  [sym_type_signature] = sym_type_signature,
  [sym_open] = sym_open,
  [sym_import] = sym_import,
  [sym_module_name] = sym_module_name,
  [aux_sym__import_directives] = aux_sym__import_directives,
  [sym_import_directive] = sym_import_directive,
  [sym__comma_import_names] = sym__comma_import_names,
  [sym_renaming] = sym_renaming,
  [sym__import_name] = sym__import_name,
  [sym_module_macro] = sym_module_macro,
  [sym_module_application] = sym_module_application,
  [sym_module] = sym_module,
  [sym_catchall_pragma] = sym_catchall_pragma,
  [sym_syntax] = sym_syntax,
  [sym_hole_names] = sym_hole_names,
  [sym_hole_name] = sym_hole_name,
  [sym__simple_top_hole] = sym__simple_top_hole,
  [sym__simple_hole] = sym__simple_hole,
  [sym_pattern] = sym_pattern,
  [sym_unquote_decl] = sym_unquote_decl,
  [sym__qid] = sym__qid,
  [sym_bid] = sym_bid,
  [aux_sym__ids] = aux_sym__ids,
  [sym__field_name] = sym__field_name,
  [aux_sym__field_names] = aux_sym__field_names,
  [sym__maybe_dotted_id] = sym__maybe_dotted_id,
  [aux_sym__maybe_dotted_ids] = aux_sym__maybe_dotted_ids,
  [aux_sym__arg_ids] = aux_sym__arg_ids,
  [sym__arg_id] = sym__arg_id,
  [sym__binding_ids_and_absurds] = sym__binding_ids_and_absurds,
  [sym_attribute] = sym_attribute,
  [sym_attributes] = sym_attributes,
  [sym_expr] = sym_expr,
  [sym_stmt] = sym_stmt,
  [sym__with_exprs] = sym__with_exprs,
  [sym__with_exprs_stmt] = sym__with_exprs_stmt,
  [sym__expr_or_attr] = sym__expr_or_attr,
  [sym__application] = sym__application,
  [sym__application_stmt] = sym__application_stmt,
  [sym__expr2_without_let] = sym__expr2_without_let,
  [sym__expr2] = sym__expr2,
  [sym__expr2_stmt] = sym__expr2_stmt,
  [sym_atom] = sym_atom,
  [aux_sym__atoms] = aux_sym__atoms,
  [sym__atom_curly] = sym__atom_curly,
  [sym__atom_no_curly] = sym__atom_no_curly,
  [sym_forall] = sym_forall,
  [sym_let] = sym_let,
  [sym_let_in_do] = sym_let,
  [sym__let_body] = sym__let_body,
  [sym_lambda] = sym_lambda,
  [sym__lambda_bindings] = sym__lambda_bindings,
  [sym_lambda_extended_or_absurd] = sym_lambda,
  [sym__lambda_clauses] = sym__lambda_clauses,
  [sym__lambda_clause_maybe_absurd] = sym__lambda_clause_maybe_absurd,
  [sym_lambda_clause_absurd] = sym_lambda_clause_absurd,
  [sym_lambda_clause] = sym_lambda_clause,
  [sym_do] = sym_do,
  [sym__do_stmt] = sym__do_stmt,
  [sym_do_where] = sym_do_where,
  [sym_record_assignments] = sym_record_assignments,
  [sym_field_assignments] = sym_record_assignments,
  [sym__record_assignments] = sym__record_assignments,
  [sym__field_assignments] = sym__field_assignments,
  [sym__record_assignment] = sym__record_assignment,
  [sym_field_assignment] = sym_field_assignment,
  [sym_module_assignment] = sym_module_assignment,
  [aux_sym__typed_bindings] = aux_sym__typed_bindings,
  [sym_typed_binding] = sym_typed_binding,
  [aux_sym__typed_untyped_bindings] = aux_sym__typed_untyped_bindings,
  [sym__typed_untyped_binding] = sym__typed_untyped_binding,
  [sym_untyped_binding] = sym_untyped_binding,
  [sym_integer] = sym_integer,
  [sym_literal] = sym_literal,
  [sym_SetN] = sym_SetN,
  [aux_sym_source_file_repeat1] = aux_sym_source_file_repeat1,
  [aux_sym__signature_block_repeat1] = aux_sym__signature_block_repeat1,
  [aux_sym__modal_arg_ids_repeat1] = aux_sym__modal_arg_ids_repeat1,
  [aux_sym_record_declarations_block_repeat1] = aux_sym_record_declarations_block_repeat1,
  [aux_sym_record_constructor_instance_repeat1] = aux_sym_record_constructor_instance_repeat1,
  [aux_sym_infix_repeat1] = aux_sym_infix_repeat1,
  [aux_sym__type_signature_block_repeat1] = aux_sym__type_signature_block_repeat1,
  [aux_sym_import_directive_repeat1] = aux_sym_import_directive_repeat1,
  [aux_sym__comma_import_names_repeat1] = aux_sym__comma_import_names_repeat1,
  [aux_sym_module_macro_repeat1] = aux_sym_module_macro_repeat1,
  [aux_sym_syntax_repeat1] = aux_sym_syntax_repeat1,
  [aux_sym_hole_names_repeat1] = aux_sym_hole_names_repeat1,
  [aux_sym__with_exprs_repeat1] = aux_sym__with_exprs_repeat1,
  [aux_sym__lambda_bindings_repeat1] = aux_sym__lambda_bindings_repeat1,
  [aux_sym__lambda_clauses_repeat1] = aux_sym__lambda_clauses_repeat1,
  [aux_sym_do_repeat1] = aux_sym_do_repeat1,
  [aux_sym__record_assignments_repeat1] = aux_sym__record_assignments_repeat1,
  [aux_sym__field_assignments_repeat1] = aux_sym__field_assignments_repeat1,
  [anon_alias_sym_bid] = anon_alias_sym_bid,
  [anon_alias_sym_data_name] = anon_alias_sym_data_name,
  [alias_sym_field_name] = alias_sym_field_name,
  [alias_sym_function_name] = alias_sym_function_name,
  [alias_sym_record_name] = alias_sym_record_name,
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [sym_id] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_forall] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u2200] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u2192] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u03bb] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_DOT_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u2026] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_field] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_overlap] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_instance] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_with] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_rewrite] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_module] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_where] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_data] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_codata] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_record] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_constructor] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_inductive] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_coinductive] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_eta_DASHequality] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_no_DASHeta_DASHequality] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_infix] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_infixl] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_infixr] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_variable] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_mutual] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_abstract] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_private] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_macro] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_postulate] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_primitive] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_open] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_import] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_public] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_using] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_hiding] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_renaming] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SEMI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_to] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u2983] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u2984] = {
    .visible = true,
    .named = false,
  },
  [anon_sym__] = {
    .visible = true,
    .named = false,
  },
  [sym_pragma] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_LBRACE_DASH_POUND] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CATCHALL] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_POUND_DASH_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_syntax] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_pattern] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_unquoteDecl] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_unquoteDef] = {
    .visible = true,
    .named = false,
  },
  [aux_sym__qid_token1] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_quoteGoal] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_in] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_tactic] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_Prop] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_quote] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_quoteTerm] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_quoteContext] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_unquote] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u2987] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u2988] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_let] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_do] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_integer_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_token1] = {
    .visible = false,
    .named = false,
  },
  [sym_comment] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_Set] = {
    .visible = true,
    .named = false,
  },
  [sym_PropN] = {
    .visible = true,
    .named = true,
  },
  [sym__newline] = {
    .visible = false,
    .named = true,
  },
  [sym__indent] = {
    .visible = false,
    .named = true,
  },
  [sym__dedent] = {
    .visible = false,
    .named = true,
  },
  [sym_source_file] = {
    .visible = true,
    .named = true,
  },
  [sym__FORALL] = {
    .visible = false,
    .named = true,
  },
  [sym__ARROW] = {
    .visible = false,
    .named = true,
  },
  [sym__LAMBDA] = {
    .visible = false,
    .named = true,
  },
  [sym__ELLIPSIS] = {
    .visible = false,
    .named = true,
  },
  [sym__declaration_block] = {
    .visible = false,
    .named = true,
  },
  [sym__declaration] = {
    .visible = false,
    .named = true,
  },
  [sym_fields] = {
    .visible = true,
    .named = true,
  },
  [sym__signature_block] = {
    .visible = false,
    .named = true,
  },
  [sym_signature] = {
    .visible = true,
    .named = true,
  },
  [sym__modal_arg_ids] = {
    .visible = false,
    .named = true,
  },
  [sym_function] = {
    .visible = true,
    .named = true,
  },
  [sym_lhs_decl] = {
    .visible = true,
    .named = true,
  },
  [sym_lhs_defn] = {
    .visible = true,
    .named = true,
  },
  [sym_rhs_decl] = {
    .visible = true,
    .named = true,
  },
  [sym_rhs_defn] = {
    .visible = true,
    .named = true,
  },
  [sym_with_expressions] = {
    .visible = true,
    .named = true,
  },
  [sym_rewrite_equations] = {
    .visible = true,
    .named = true,
  },
  [sym_where] = {
    .visible = true,
    .named = true,
  },
  [sym_data_name] = {
    .visible = true,
    .named = true,
  },
  [sym_data] = {
    .visible = true,
    .named = true,
  },
  [sym_data_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_record] = {
    .visible = true,
    .named = true,
  },
  [sym_record_declarations_block] = {
    .visible = true,
    .named = true,
  },
  [sym__record_directive] = {
    .visible = false,
    .named = true,
  },
  [sym_record_constructor] = {
    .visible = true,
    .named = true,
  },
  [sym_record_constructor_instance] = {
    .visible = true,
    .named = true,
  },
  [sym_record_induction] = {
    .visible = true,
    .named = true,
  },
  [sym_record_eta] = {
    .visible = true,
    .named = true,
  },
  [sym_record_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_infix] = {
    .visible = true,
    .named = true,
  },
  [sym_generalize] = {
    .visible = true,
    .named = true,
  },
  [sym_mutual] = {
    .visible = true,
    .named = true,
  },
  [sym_abstract] = {
    .visible = true,
    .named = true,
  },
  [sym_private] = {
    .visible = true,
    .named = true,
  },
  [sym_instance] = {
    .visible = true,
    .named = true,
  },
  [sym_macro] = {
    .visible = true,
    .named = true,
  },
  [sym_postulate] = {
    .visible = true,
    .named = true,
  },
  [sym_primitive] = {
    .visible = true,
    .named = true,
  },
  [sym__type_signature_block] = {
    .visible = false,
    .named = true,
  },
  [sym_type_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_open] = {
    .visible = true,
    .named = true,
  },
  [sym_import] = {
    .visible = true,
    .named = true,
  },
  [sym_module_name] = {
    .visible = true,
    .named = true,
  },
  [aux_sym__import_directives] = {
    .visible = false,
    .named = false,
  },
  [sym_import_directive] = {
    .visible = true,
    .named = true,
  },
  [sym__comma_import_names] = {
    .visible = false,
    .named = true,
  },
  [sym_renaming] = {
    .visible = true,
    .named = true,
  },
  [sym__import_name] = {
    .visible = false,
    .named = true,
  },
  [sym_module_macro] = {
    .visible = true,
    .named = true,
  },
  [sym_module_application] = {
    .visible = true,
    .named = true,
  },
  [sym_module] = {
    .visible = true,
    .named = true,
  },
  [sym_catchall_pragma] = {
    .visible = true,
    .named = true,
  },
  [sym_syntax] = {
    .visible = true,
    .named = true,
  },
  [sym_hole_names] = {
    .visible = true,
    .named = true,
  },
  [sym_hole_name] = {
    .visible = true,
    .named = true,
  },
  [sym__simple_top_hole] = {
    .visible = false,
    .named = true,
  },
  [sym__simple_hole] = {
    .visible = false,
    .named = true,
  },
  [sym_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_unquote_decl] = {
    .visible = true,
    .named = true,
  },
  [sym__qid] = {
    .visible = false,
    .named = true,
  },
  [sym_bid] = {
    .visible = true,
    .named = true,
  },
  [aux_sym__ids] = {
    .visible = false,
    .named = false,
  },
  [sym__field_name] = {
    .visible = false,
    .named = true,
  },
  [aux_sym__field_names] = {
    .visible = false,
    .named = false,
  },
  [sym__maybe_dotted_id] = {
    .visible = false,
    .named = true,
  },
  [aux_sym__maybe_dotted_ids] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__arg_ids] = {
    .visible = false,
    .named = false,
  },
  [sym__arg_id] = {
    .visible = false,
    .named = true,
  },
  [sym__binding_ids_and_absurds] = {
    .visible = false,
    .named = true,
  },
  [sym_attribute] = {
    .visible = true,
    .named = true,
  },
  [sym_attributes] = {
    .visible = true,
    .named = true,
  },
  [sym_expr] = {
    .visible = true,
    .named = true,
  },
  [sym_stmt] = {
    .visible = true,
    .named = true,
  },
  [sym__with_exprs] = {
    .visible = false,
    .named = true,
  },
  [sym__with_exprs_stmt] = {
    .visible = false,
    .named = true,
  },
  [sym__expr_or_attr] = {
    .visible = false,
    .named = true,
  },
  [sym__application] = {
    .visible = false,
    .named = true,
  },
  [sym__application_stmt] = {
    .visible = false,
    .named = true,
  },
  [sym__expr2_without_let] = {
    .visible = false,
    .named = true,
  },
  [sym__expr2] = {
    .visible = false,
    .named = true,
  },
  [sym__expr2_stmt] = {
    .visible = false,
    .named = true,
  },
  [sym_atom] = {
    .visible = true,
    .named = true,
  },
  [aux_sym__atoms] = {
    .visible = false,
    .named = false,
  },
  [sym__atom_curly] = {
    .visible = false,
    .named = true,
  },
  [sym__atom_no_curly] = {
    .visible = false,
    .named = true,
  },
  [sym_forall] = {
    .visible = true,
    .named = true,
  },
  [sym_let] = {
    .visible = true,
    .named = true,
  },
  [sym_let_in_do] = {
    .visible = true,
    .named = true,
  },
  [sym__let_body] = {
    .visible = false,
    .named = true,
  },
  [sym_lambda] = {
    .visible = true,
    .named = true,
  },
  [sym__lambda_bindings] = {
    .visible = false,
    .named = true,
  },
  [sym_lambda_extended_or_absurd] = {
    .visible = true,
    .named = true,
  },
  [sym__lambda_clauses] = {
    .visible = false,
    .named = true,
  },
  [sym__lambda_clause_maybe_absurd] = {
    .visible = false,
    .named = true,
  },
  [sym_lambda_clause_absurd] = {
    .visible = true,
    .named = true,
  },
  [sym_lambda_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_do] = {
    .visible = true,
    .named = true,
  },
  [sym__do_stmt] = {
    .visible = false,
    .named = true,
  },
  [sym_do_where] = {
    .visible = true,
    .named = true,
  },
  [sym_record_assignments] = {
    .visible = true,
    .named = true,
  },
  [sym_field_assignments] = {
    .visible = true,
    .named = true,
  },
  [sym__record_assignments] = {
    .visible = false,
    .named = true,
  },
  [sym__field_assignments] = {
    .visible = false,
    .named = true,
  },
  [sym__record_assignment] = {
    .visible = false,
    .named = true,
  },
  [sym_field_assignment] = {
    .visible = true,
    .named = true,
  },
  [sym_module_assignment] = {
    .visible = true,
    .named = true,
  },
  [aux_sym__typed_bindings] = {
    .visible = false,
    .named = false,
  },
  [sym_typed_binding] = {
    .visible = true,
    .named = true,
  },
  [aux_sym__typed_untyped_bindings] = {
    .visible = false,
    .named = false,
  },
  [sym__typed_untyped_binding] = {
    .visible = false,
    .named = true,
  },
  [sym_untyped_binding] = {
    .visible = true,
    .named = true,
  },
  [sym_integer] = {
    .visible = true,
    .named = true,
  },
  [sym_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_SetN] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_source_file_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__signature_block_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__modal_arg_ids_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_record_declarations_block_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_record_constructor_instance_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_infix_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__type_signature_block_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_import_directive_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__comma_import_names_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_module_macro_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_syntax_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_hole_names_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__with_exprs_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__lambda_bindings_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__lambda_clauses_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_do_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__record_assignments_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__field_assignments_repeat1] = {
    .visible = false,
    .named = false,
  },
  [anon_alias_sym_bid] = {
    .visible = true,
    .named = false,
  },
  [anon_alias_sym_data_name] = {
    .visible = true,
    .named = false,
  },
  [alias_sym_field_name] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_function_name] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_record_name] = {
    .visible = true,
    .named = true,
  },
};

static const TSSymbol ts_alias_sequences[PRODUCTION_ID_COUNT][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
  [1] = {
    [0] = aux_sym__qid_token1,
  },
  [2] = {
    [0] = alias_sym_function_name,
  },
  [3] = {
    [0] = anon_alias_sym_data_name,
  },
  [4] = {
    [0] = anon_alias_sym_bid,
  },
  [5] = {
    [0] = alias_sym_field_name,
  },
  [6] = {
    [1] = sym_module_name,
  },
  [7] = {
    [1] = alias_sym_record_name,
  },
  [8] = {
    [2] = sym_module_name,
  },
};

static const uint16_t ts_non_terminal_alias_map[] = {
  sym__qid, 2,
    sym__qid,
    sym_module_name,
  sym__with_exprs, 2,
    sym__with_exprs,
    alias_sym_function_name,
  sym__atom_no_curly, 2,
    sym__atom_no_curly,
    alias_sym_record_name,
  0,
};

static const TSStateId ts_primary_state_ids[STATE_COUNT] = {
  [0] = 0,
  [1] = 1,
  [2] = 2,
  [3] = 3,
  [4] = 4,
  [5] = 5,
  [6] = 5,
  [7] = 5,
  [8] = 5,
  [9] = 5,
  [10] = 5,
  [11] = 5,
  [12] = 5,
  [13] = 5,
  [14] = 5,
  [15] = 5,
  [16] = 5,
  [17] = 5,
  [18] = 5,
  [19] = 5,
  [20] = 5,
  [21] = 5,
  [22] = 5,
  [23] = 5,
  [24] = 5,
  [25] = 5,
  [26] = 5,
  [27] = 5,
  [28] = 5,
  [29] = 5,
  [30] = 5,
  [31] = 5,
  [32] = 5,
  [33] = 5,
  [34] = 5,
  [35] = 5,
  [36] = 5,
  [37] = 5,
  [38] = 5,
  [39] = 5,
  [40] = 5,
  [41] = 5,
  [42] = 5,
  [43] = 5,
  [44] = 5,
  [45] = 5,
  [46] = 5,
  [47] = 5,
  [48] = 5,
  [49] = 5,
  [50] = 5,
  [51] = 5,
  [52] = 5,
  [53] = 5,
  [54] = 5,
  [55] = 5,
  [56] = 5,
  [57] = 5,
  [58] = 5,
  [59] = 5,
  [60] = 5,
  [61] = 5,
  [62] = 62,
  [63] = 62,
  [64] = 62,
  [65] = 65,
  [66] = 62,
  [67] = 62,
  [68] = 62,
  [69] = 62,
  [70] = 62,
  [71] = 62,
  [72] = 62,
  [73] = 62,
  [74] = 62,
  [75] = 62,
  [76] = 76,
  [77] = 77,
  [78] = 62,
  [79] = 79,
  [80] = 62,
  [81] = 62,
  [82] = 62,
  [83] = 62,
  [84] = 62,
  [85] = 62,
  [86] = 62,
  [87] = 87,
  [88] = 62,
  [89] = 62,
  [90] = 62,
  [91] = 62,
  [92] = 92,
  [93] = 62,
  [94] = 62,
  [95] = 92,
  [96] = 96,
  [97] = 62,
  [98] = 62,
  [99] = 62,
  [100] = 62,
  [101] = 62,
  [102] = 62,
  [103] = 62,
  [104] = 62,
  [105] = 62,
  [106] = 62,
  [107] = 62,
  [108] = 62,
  [109] = 62,
  [110] = 62,
  [111] = 62,
  [112] = 62,
  [113] = 62,
  [114] = 62,
  [115] = 62,
  [116] = 116,
  [117] = 117,
  [118] = 116,
  [119] = 119,
  [120] = 116,
  [121] = 116,
  [122] = 119,
  [123] = 117,
  [124] = 117,
  [125] = 116,
  [126] = 117,
  [127] = 119,
  [128] = 119,
  [129] = 119,
  [130] = 116,
  [131] = 116,
  [132] = 119,
  [133] = 117,
  [134] = 119,
  [135] = 117,
  [136] = 117,
  [137] = 117,
  [138] = 117,
  [139] = 117,
  [140] = 116,
  [141] = 119,
  [142] = 116,
  [143] = 117,
  [144] = 119,
  [145] = 117,
  [146] = 117,
  [147] = 116,
  [148] = 117,
  [149] = 117,
  [150] = 117,
  [151] = 119,
  [152] = 117,
  [153] = 117,
  [154] = 119,
  [155] = 116,
  [156] = 116,
  [157] = 119,
  [158] = 158,
  [159] = 119,
  [160] = 117,
  [161] = 117,
  [162] = 92,
  [163] = 117,
  [164] = 117,
  [165] = 117,
  [166] = 117,
  [167] = 116,
  [168] = 119,
  [169] = 116,
  [170] = 116,
  [171] = 119,
  [172] = 116,
  [173] = 117,
  [174] = 119,
  [175] = 117,
  [176] = 119,
  [177] = 117,
  [178] = 116,
  [179] = 116,
  [180] = 119,
  [181] = 119,
  [182] = 119,
  [183] = 116,
  [184] = 116,
  [185] = 119,
  [186] = 117,
  [187] = 119,
  [188] = 116,
  [189] = 116,
  [190] = 119,
  [191] = 117,
  [192] = 119,
  [193] = 119,
  [194] = 194,
  [195] = 116,
  [196] = 116,
  [197] = 119,
  [198] = 117,
  [199] = 116,
  [200] = 116,
  [201] = 117,
  [202] = 119,
  [203] = 203,
  [204] = 117,
  [205] = 119,
  [206] = 116,
  [207] = 119,
  [208] = 117,
  [209] = 117,
  [210] = 116,
  [211] = 117,
  [212] = 119,
  [213] = 117,
  [214] = 119,
  [215] = 116,
  [216] = 116,
  [217] = 117,
  [218] = 116,
  [219] = 119,
  [220] = 116,
  [221] = 116,
  [222] = 119,
  [223] = 116,
  [224] = 117,
  [225] = 117,
  [226] = 119,
  [227] = 117,
  [228] = 116,
  [229] = 119,
  [230] = 117,
  [231] = 116,
  [232] = 119,
  [233] = 117,
  [234] = 117,
  [235] = 117,
  [236] = 116,
  [237] = 119,
  [238] = 238,
  [239] = 119,
  [240] = 116,
  [241] = 241,
  [242] = 119,
  [243] = 119,
  [244] = 116,
  [245] = 119,
  [246] = 116,
  [247] = 116,
  [248] = 116,
  [249] = 117,
  [250] = 119,
  [251] = 117,
  [252] = 119,
  [253] = 116,
  [254] = 119,
  [255] = 116,
  [256] = 119,
  [257] = 116,
  [258] = 116,
  [259] = 119,
  [260] = 260,
  [261] = 260,
  [262] = 260,
  [263] = 260,
  [264] = 260,
  [265] = 260,
  [266] = 266,
  [267] = 267,
  [268] = 260,
  [269] = 260,
  [270] = 260,
  [271] = 260,
  [272] = 260,
  [273] = 260,
  [274] = 260,
  [275] = 260,
  [276] = 260,
  [277] = 260,
  [278] = 260,
  [279] = 260,
  [280] = 260,
  [281] = 260,
  [282] = 260,
  [283] = 260,
  [284] = 260,
  [285] = 260,
  [286] = 260,
  [287] = 260,
  [288] = 266,
  [289] = 260,
  [290] = 260,
  [291] = 260,
  [292] = 260,
  [293] = 260,
  [294] = 260,
  [295] = 260,
  [296] = 260,
  [297] = 260,
  [298] = 260,
  [299] = 266,
  [300] = 260,
  [301] = 260,
  [302] = 260,
  [303] = 260,
  [304] = 260,
  [305] = 260,
  [306] = 260,
  [307] = 260,
  [308] = 260,
  [309] = 260,
  [310] = 260,
  [311] = 260,
  [312] = 260,
  [313] = 260,
  [314] = 260,
  [315] = 260,
  [316] = 316,
  [317] = 316,
  [318] = 316,
  [319] = 319,
  [320] = 320,
  [321] = 320,
  [322] = 322,
  [323] = 323,
  [324] = 324,
  [325] = 322,
  [326] = 324,
  [327] = 327,
  [328] = 327,
  [329] = 329,
  [330] = 319,
  [331] = 323,
  [332] = 323,
  [333] = 319,
  [334] = 329,
  [335] = 320,
  [336] = 322,
  [337] = 327,
  [338] = 324,
  [339] = 322,
  [340] = 324,
  [341] = 327,
  [342] = 320,
  [343] = 327,
  [344] = 324,
  [345] = 322,
  [346] = 320,
  [347] = 323,
  [348] = 319,
  [349] = 329,
  [350] = 320,
  [351] = 323,
  [352] = 329,
  [353] = 327,
  [354] = 319,
  [355] = 324,
  [356] = 322,
  [357] = 323,
  [358] = 320,
  [359] = 323,
  [360] = 319,
  [361] = 329,
  [362] = 323,
  [363] = 319,
  [364] = 329,
  [365] = 323,
  [366] = 319,
  [367] = 329,
  [368] = 327,
  [369] = 324,
  [370] = 322,
  [371] = 320,
  [372] = 320,
  [373] = 320,
  [374] = 322,
  [375] = 319,
  [376] = 324,
  [377] = 327,
  [378] = 320,
  [379] = 322,
  [380] = 322,
  [381] = 324,
  [382] = 327,
  [383] = 324,
  [384] = 327,
  [385] = 323,
  [386] = 319,
  [387] = 329,
  [388] = 329,
  [389] = 329,
  [390] = 320,
  [391] = 320,
  [392] = 322,
  [393] = 329,
  [394] = 319,
  [395] = 324,
  [396] = 327,
  [397] = 323,
  [398] = 327,
  [399] = 323,
  [400] = 319,
  [401] = 329,
  [402] = 322,
  [403] = 324,
  [404] = 324,
  [405] = 327,
  [406] = 322,
  [407] = 320,
  [408] = 322,
  [409] = 323,
  [410] = 319,
  [411] = 324,
  [412] = 327,
  [413] = 320,
  [414] = 320,
  [415] = 322,
  [416] = 323,
  [417] = 319,
  [418] = 327,
  [419] = 324,
  [420] = 322,
  [421] = 323,
  [422] = 320,
  [423] = 319,
  [424] = 329,
  [425] = 329,
  [426] = 323,
  [427] = 329,
  [428] = 319,
  [429] = 329,
  [430] = 324,
  [431] = 320,
  [432] = 327,
  [433] = 322,
  [434] = 320,
  [435] = 322,
  [436] = 324,
  [437] = 324,
  [438] = 324,
  [439] = 322,
  [440] = 329,
  [441] = 319,
  [442] = 320,
  [443] = 323,
  [444] = 327,
  [445] = 327,
  [446] = 329,
  [447] = 329,
  [448] = 319,
  [449] = 323,
  [450] = 320,
  [451] = 322,
  [452] = 324,
  [453] = 327,
  [454] = 327,
  [455] = 323,
  [456] = 319,
  [457] = 329,
  [458] = 323,
  [459] = 319,
  [460] = 323,
  [461] = 329,
  [462] = 324,
  [463] = 320,
  [464] = 322,
  [465] = 319,
  [466] = 327,
  [467] = 324,
  [468] = 324,
  [469] = 322,
  [470] = 320,
  [471] = 327,
  [472] = 322,
  [473] = 329,
  [474] = 319,
  [475] = 323,
  [476] = 329,
  [477] = 320,
  [478] = 323,
  [479] = 319,
  [480] = 319,
  [481] = 329,
  [482] = 323,
  [483] = 319,
  [484] = 329,
  [485] = 323,
  [486] = 319,
  [487] = 320,
  [488] = 329,
  [489] = 322,
  [490] = 320,
  [491] = 324,
  [492] = 322,
  [493] = 327,
  [494] = 323,
  [495] = 327,
  [496] = 320,
  [497] = 322,
  [498] = 320,
  [499] = 324,
  [500] = 327,
  [501] = 323,
  [502] = 319,
  [503] = 329,
  [504] = 323,
  [505] = 322,
  [506] = 324,
  [507] = 320,
  [508] = 322,
  [509] = 324,
  [510] = 327,
  [511] = 322,
  [512] = 320,
  [513] = 513,
  [514] = 319,
  [515] = 324,
  [516] = 327,
  [517] = 323,
  [518] = 327,
  [519] = 319,
  [520] = 324,
  [521] = 322,
  [522] = 329,
  [523] = 320,
  [524] = 320,
  [525] = 322,
  [526] = 324,
  [527] = 329,
  [528] = 327,
  [529] = 319,
  [530] = 323,
  [531] = 329,
  [532] = 320,
  [533] = 324,
  [534] = 323,
  [535] = 323,
  [536] = 319,
  [537] = 319,
  [538] = 329,
  [539] = 329,
  [540] = 327,
  [541] = 322,
  [542] = 324,
  [543] = 327,
  [544] = 320,
  [545] = 322,
  [546] = 324,
  [547] = 327,
  [548] = 327,
  [549] = 324,
  [550] = 322,
  [551] = 320,
  [552] = 327,
  [553] = 323,
  [554] = 320,
  [555] = 324,
  [556] = 319,
  [557] = 322,
  [558] = 322,
  [559] = 329,
  [560] = 324,
  [561] = 327,
  [562] = 323,
  [563] = 319,
  [564] = 320,
  [565] = 323,
  [566] = 327,
  [567] = 320,
  [568] = 322,
  [569] = 324,
  [570] = 327,
  [571] = 329,
  [572] = 323,
  [573] = 319,
  [574] = 329,
  [575] = 320,
  [576] = 322,
  [577] = 329,
  [578] = 324,
  [579] = 319,
  [580] = 323,
  [581] = 327,
  [582] = 320,
  [583] = 322,
  [584] = 329,
  [585] = 323,
  [586] = 319,
  [587] = 324,
  [588] = 319,
  [589] = 329,
  [590] = 323,
  [591] = 323,
  [592] = 319,
  [593] = 329,
  [594] = 327,
  [595] = 320,
  [596] = 322,
  [597] = 324,
  [598] = 327,
  [599] = 319,
  [600] = 329,
  [601] = 319,
  [602] = 327,
  [603] = 324,
  [604] = 323,
  [605] = 323,
  [606] = 320,
  [607] = 319,
  [608] = 322,
  [609] = 324,
  [610] = 329,
  [611] = 327,
  [612] = 322,
  [613] = 329,
  [614] = 614,
  [615] = 615,
  [616] = 616,
  [617] = 617,
  [618] = 614,
  [619] = 614,
  [620] = 614,
  [621] = 617,
  [622] = 614,
  [623] = 615,
  [624] = 616,
  [625] = 616,
  [626] = 626,
  [627] = 615,
  [628] = 616,
  [629] = 615,
  [630] = 616,
  [631] = 614,
  [632] = 615,
  [633] = 616,
  [634] = 617,
  [635] = 614,
  [636] = 614,
  [637] = 616,
  [638] = 617,
  [639] = 616,
  [640] = 615,
  [641] = 615,
  [642] = 615,
  [643] = 615,
  [644] = 615,
  [645] = 616,
  [646] = 617,
  [647] = 615,
  [648] = 617,
  [649] = 626,
  [650] = 614,
  [651] = 616,
  [652] = 614,
  [653] = 614,
  [654] = 617,
  [655] = 614,
  [656] = 616,
  [657] = 617,
  [658] = 617,
  [659] = 615,
  [660] = 616,
  [661] = 616,
  [662] = 615,
  [663] = 615,
  [664] = 616,
  [665] = 617,
  [666] = 614,
  [667] = 617,
  [668] = 614,
  [669] = 617,
  [670] = 616,
  [671] = 615,
  [672] = 626,
  [673] = 616,
  [674] = 614,
  [675] = 616,
  [676] = 617,
  [677] = 615,
  [678] = 615,
  [679] = 616,
  [680] = 626,
  [681] = 617,
  [682] = 614,
  [683] = 616,
  [684] = 614,
  [685] = 617,
  [686] = 616,
  [687] = 616,
  [688] = 614,
  [689] = 626,
  [690] = 617,
  [691] = 615,
  [692] = 614,
  [693] = 617,
  [694] = 614,
  [695] = 614,
  [696] = 615,
  [697] = 626,
  [698] = 616,
  [699] = 617,
  [700] = 617,
  [701] = 614,
  [702] = 614,
  [703] = 614,
  [704] = 617,
  [705] = 616,
  [706] = 616,
  [707] = 615,
  [708] = 615,
  [709] = 615,
  [710] = 615,
  [711] = 615,
  [712] = 616,
  [713] = 617,
  [714] = 615,
  [715] = 617,
  [716] = 617,
  [717] = 616,
  [718] = 626,
  [719] = 614,
  [720] = 615,
  [721] = 614,
  [722] = 615,
  [723] = 626,
  [724] = 617,
  [725] = 617,
  [726] = 615,
  [727] = 616,
  [728] = 614,
  [729] = 614,
  [730] = 615,
  [731] = 617,
  [732] = 616,
  [733] = 614,
  [734] = 615,
  [735] = 617,
  [736] = 626,
  [737] = 616,
  [738] = 616,
  [739] = 616,
  [740] = 615,
  [741] = 614,
  [742] = 615,
  [743] = 616,
  [744] = 617,
  [745] = 617,
  [746] = 614,
  [747] = 614,
  [748] = 617,
  [749] = 616,
  [750] = 616,
  [751] = 615,
  [752] = 614,
  [753] = 617,
  [754] = 616,
  [755] = 615,
  [756] = 615,
  [757] = 616,
  [758] = 617,
  [759] = 617,
  [760] = 617,
  [761] = 614,
  [762] = 614,
  [763] = 615,
  [764] = 614,
  [765] = 614,
  [766] = 616,
  [767] = 617,
  [768] = 616,
  [769] = 615,
  [770] = 614,
  [771] = 617,
  [772] = 616,
  [773] = 615,
  [774] = 615,
  [775] = 626,
  [776] = 615,
  [777] = 616,
  [778] = 617,
  [779] = 615,
  [780] = 616,
  [781] = 614,
  [782] = 614,
  [783] = 617,
  [784] = 617,
  [785] = 616,
  [786] = 615,
  [787] = 617,
  [788] = 616,
  [789] = 614,
  [790] = 615,
  [791] = 614,
  [792] = 614,
  [793] = 617,
  [794] = 616,
  [795] = 615,
  [796] = 615,
  [797] = 616,
  [798] = 615,
  [799] = 617,
  [800] = 614,
  [801] = 616,
  [802] = 614,
  [803] = 614,
  [804] = 614,
  [805] = 617,
  [806] = 616,
  [807] = 617,
  [808] = 616,
  [809] = 615,
  [810] = 614,
  [811] = 615,
  [812] = 617,
  [813] = 616,
  [814] = 615,
  [815] = 615,
  [816] = 616,
  [817] = 617,
  [818] = 616,
  [819] = 617,
  [820] = 617,
  [821] = 614,
  [822] = 614,
  [823] = 617,
  [824] = 614,
  [825] = 616,
  [826] = 615,
  [827] = 617,
  [828] = 614,
  [829] = 626,
  [830] = 616,
  [831] = 615,
  [832] = 614,
  [833] = 617,
  [834] = 615,
  [835] = 616,
  [836] = 615,
  [837] = 615,
  [838] = 626,
  [839] = 615,
  [840] = 616,
  [841] = 614,
  [842] = 616,
  [843] = 617,
  [844] = 614,
  [845] = 616,
  [846] = 615,
  [847] = 615,
  [848] = 614,
  [849] = 617,
  [850] = 850,
  [851] = 616,
  [852] = 852,
  [853] = 615,
  [854] = 617,
  [855] = 615,
  [856] = 626,
  [857] = 614,
  [858] = 616,
  [859] = 617,
  [860] = 617,
  [861] = 614,
  [862] = 614,
  [863] = 616,
  [864] = 614,
  [865] = 614,
  [866] = 617,
  [867] = 617,
  [868] = 616,
  [869] = 616,
  [870] = 615,
  [871] = 615,
  [872] = 614,
  [873] = 615,
  [874] = 617,
  [875] = 616,
  [876] = 615,
  [877] = 614,
  [878] = 617,
  [879] = 614,
  [880] = 617,
  [881] = 616,
  [882] = 615,
  [883] = 626,
  [884] = 616,
  [885] = 614,
  [886] = 626,
  [887] = 617,
  [888] = 617,
  [889] = 616,
  [890] = 617,
  [891] = 615,
  [892] = 616,
  [893] = 615,
  [894] = 614,
  [895] = 614,
  [896] = 614,
  [897] = 617,
  [898] = 616,
  [899] = 614,
  [900] = 615,
  [901] = 616,
  [902] = 617,
  [903] = 617,
  [904] = 616,
  [905] = 616,
  [906] = 614,
  [907] = 615,
  [908] = 614,
  [909] = 617,
  [910] = 614,
  [911] = 614,
  [912] = 617,
  [913] = 617,
  [914] = 617,
  [915] = 615,
  [916] = 617,
  [917] = 616,
  [918] = 626,
  [919] = 616,
  [920] = 615,
  [921] = 614,
  [922] = 617,
  [923] = 616,
  [924] = 614,
  [925] = 615,
  [926] = 616,
  [927] = 616,
  [928] = 615,
  [929] = 617,
  [930] = 614,
  [931] = 617,
  [932] = 616,
  [933] = 616,
  [934] = 615,
  [935] = 615,
  [936] = 615,
  [937] = 616,
  [938] = 617,
  [939] = 614,
  [940] = 614,
  [941] = 614,
  [942] = 617,
  [943] = 614,
  [944] = 617,
  [945] = 616,
  [946] = 626,
  [947] = 626,
  [948] = 615,
  [949] = 615,
  [950] = 626,
  [951] = 614,
  [952] = 616,
  [953] = 617,
  [954] = 626,
  [955] = 616,
  [956] = 617,
  [957] = 615,
  [958] = 614,
  [959] = 616,
  [960] = 617,
  [961] = 615,
  [962] = 616,
  [963] = 615,
  [964] = 614,
  [965] = 615,
  [966] = 617,
  [967] = 614,
  [968] = 615,
  [969] = 614,
  [970] = 617,
  [971] = 616,
  [972] = 616,
  [973] = 617,
  [974] = 614,
  [975] = 615,
  [976] = 615,
  [977] = 616,
  [978] = 614,
  [979] = 617,
  [980] = 617,
  [981] = 614,
  [982] = 616,
  [983] = 615,
  [984] = 614,
  [985] = 626,
  [986] = 614,
  [987] = 617,
  [988] = 617,
  [989] = 616,
  [990] = 615,
  [991] = 617,
  [992] = 616,
  [993] = 615,
  [994] = 616,
  [995] = 615,
  [996] = 614,
  [997] = 617,
  [998] = 626,
  [999] = 616,
  [1000] = 617,
  [1001] = 616,
  [1002] = 615,
  [1003] = 614,
  [1004] = 615,
  [1005] = 617,
  [1006] = 626,
  [1007] = 614,
  [1008] = 614,
  [1009] = 617,
  [1010] = 617,
  [1011] = 614,
  [1012] = 616,
  [1013] = 614,
  [1014] = 615,
  [1015] = 614,
  [1016] = 616,
  [1017] = 615,
  [1018] = 617,
  [1019] = 614,
  [1020] = 614,
  [1021] = 614,
  [1022] = 617,
  [1023] = 617,
  [1024] = 616,
  [1025] = 617,
  [1026] = 616,
  [1027] = 615,
  [1028] = 614,
  [1029] = 615,
  [1030] = 616,
  [1031] = 614,
  [1032] = 615,
  [1033] = 616,
  [1034] = 626,
  [1035] = 617,
  [1036] = 617,
  [1037] = 614,
  [1038] = 626,
  [1039] = 616,
  [1040] = 615,
  [1041] = 615,
  [1042] = 614,
  [1043] = 617,
  [1044] = 616,
  [1045] = 615,
  [1046] = 616,
  [1047] = 617,
  [1048] = 614,
  [1049] = 626,
  [1050] = 615,
  [1051] = 615,
  [1052] = 614,
  [1053] = 617,
  [1054] = 616,
  [1055] = 615,
  [1056] = 616,
  [1057] = 614,
  [1058] = 617,
  [1059] = 626,
  [1060] = 617,
  [1061] = 616,
  [1062] = 615,
  [1063] = 617,
  [1064] = 614,
  [1065] = 617,
  [1066] = 852,
  [1067] = 850,
  [1068] = 616,
  [1069] = 614,
  [1070] = 615,
  [1071] = 614,
  [1072] = 617,
  [1073] = 616,
  [1074] = 626,
  [1075] = 615,
  [1076] = 626,
  [1077] = 614,
  [1078] = 617,
  [1079] = 616,
  [1080] = 615,
  [1081] = 614,
  [1082] = 617,
  [1083] = 614,
  [1084] = 617,
  [1085] = 615,
  [1086] = 616,
  [1087] = 615,
  [1088] = 617,
  [1089] = 614,
  [1090] = 616,
  [1091] = 615,
  [1092] = 615,
  [1093] = 616,
  [1094] = 626,
  [1095] = 616,
  [1096] = 615,
  [1097] = 614,
  [1098] = 614,
  [1099] = 617,
  [1100] = 616,
  [1101] = 617,
  [1102] = 616,
  [1103] = 615,
  [1104] = 615,
  [1105] = 617,
  [1106] = 615,
  [1107] = 616,
  [1108] = 614,
  [1109] = 617,
  [1110] = 614,
  [1111] = 616,
  [1112] = 616,
  [1113] = 615,
  [1114] = 614,
  [1115] = 617,
  [1116] = 617,
  [1117] = 616,
  [1118] = 615,
  [1119] = 615,
  [1120] = 616,
  [1121] = 614,
  [1122] = 617,
  [1123] = 626,
  [1124] = 616,
  [1125] = 615,
  [1126] = 614,
  [1127] = 614,
  [1128] = 615,
  [1129] = 617,
  [1130] = 616,
  [1131] = 615,
  [1132] = 616,
  [1133] = 617,
  [1134] = 614,
  [1135] = 615,
  [1136] = 614,
  [1137] = 617,
  [1138] = 616,
  [1139] = 615,
  [1140] = 616,
  [1141] = 615,
  [1142] = 617,
  [1143] = 614,
  [1144] = 617,
  [1145] = 626,
  [1146] = 616,
  [1147] = 617,
  [1148] = 616,
  [1149] = 626,
  [1150] = 615,
  [1151] = 614,
  [1152] = 617,
  [1153] = 614,
  [1154] = 626,
  [1155] = 617,
  [1156] = 616,
  [1157] = 615,
  [1158] = 614,
  [1159] = 626,
  [1160] = 617,
  [1161] = 616,
  [1162] = 615,
  [1163] = 614,
  [1164] = 617,
  [1165] = 614,
  [1166] = 616,
  [1167] = 615,
  [1168] = 615,
  [1169] = 617,
  [1170] = 614,
  [1171] = 616,
  [1172] = 616,
  [1173] = 615,
  [1174] = 617,
  [1175] = 616,
  [1176] = 614,
  [1177] = 617,
  [1178] = 616,
  [1179] = 615,
  [1180] = 615,
  [1181] = 614,
  [1182] = 614,
  [1183] = 617,
  [1184] = 614,
  [1185] = 617,
  [1186] = 617,
  [1187] = 616,
  [1188] = 615,
  [1189] = 614,
  [1190] = 616,
  [1191] = 615,
  [1192] = 616,
  [1193] = 617,
  [1194] = 615,
  [1195] = 616,
  [1196] = 614,
  [1197] = 614,
  [1198] = 615,
  [1199] = 617,
  [1200] = 614,
  [1201] = 617,
  [1202] = 616,
  [1203] = 615,
  [1204] = 617,
  [1205] = 614,
  [1206] = 615,
  [1207] = 616,
  [1208] = 615,
  [1209] = 614,
  [1210] = 617,
  [1211] = 626,
  [1212] = 616,
  [1213] = 617,
  [1214] = 615,
  [1215] = 614,
  [1216] = 615,
  [1217] = 617,
  [1218] = 616,
  [1219] = 615,
  [1220] = 614,
  [1221] = 617,
  [1222] = 616,
  [1223] = 616,
  [1224] = 615,
  [1225] = 626,
  [1226] = 614,
  [1227] = 617,
  [1228] = 617,
  [1229] = 616,
  [1230] = 614,
  [1231] = 616,
  [1232] = 615,
  [1233] = 626,
  [1234] = 614,
  [1235] = 617,
  [1236] = 616,
  [1237] = 614,
  [1238] = 616,
  [1239] = 615,
  [1240] = 614,
  [1241] = 615,
  [1242] = 626,
  [1243] = 616,
  [1244] = 615,
  [1245] = 617,
  [1246] = 614,
  [1247] = 615,
  [1248] = 617,
  [1249] = 617,
  [1250] = 616,
  [1251] = 615,
  [1252] = 616,
  [1253] = 615,
  [1254] = 615,
  [1255] = 614,
  [1256] = 617,
  [1257] = 616,
  [1258] = 615,
  [1259] = 614,
  [1260] = 617,
  [1261] = 616,
  [1262] = 615,
  [1263] = 614,
  [1264] = 617,
  [1265] = 615,
  [1266] = 616,
  [1267] = 615,
  [1268] = 615,
  [1269] = 614,
  [1270] = 617,
  [1271] = 616,
  [1272] = 615,
  [1273] = 616,
  [1274] = 614,
  [1275] = 626,
  [1276] = 615,
  [1277] = 614,
  [1278] = 614,
  [1279] = 617,
  [1280] = 616,
  [1281] = 615,
  [1282] = 614,
  [1283] = 617,
  [1284] = 615,
  [1285] = 616,
  [1286] = 617,
  [1287] = 614,
  [1288] = 616,
  [1289] = 617,
  [1290] = 615,
  [1291] = 614,
  [1292] = 617,
  [1293] = 616,
  [1294] = 616,
  [1295] = 615,
  [1296] = 614,
  [1297] = 617,
  [1298] = 615,
  [1299] = 614,
  [1300] = 616,
  [1301] = 615,
  [1302] = 614,
  [1303] = 617,
  [1304] = 617,
  [1305] = 616,
  [1306] = 615,
  [1307] = 614,
  [1308] = 616,
  [1309] = 615,
  [1310] = 617,
  [1311] = 616,
  [1312] = 616,
  [1313] = 615,
  [1314] = 614,
  [1315] = 615,
  [1316] = 617,
  [1317] = 616,
  [1318] = 615,
  [1319] = 615,
  [1320] = 616,
  [1321] = 615,
  [1322] = 614,
  [1323] = 616,
  [1324] = 626,
  [1325] = 617,
  [1326] = 616,
  [1327] = 615,
  [1328] = 614,
  [1329] = 617,
  [1330] = 615,
  [1331] = 616,
  [1332] = 617,
  [1333] = 614,
  [1334] = 617,
  [1335] = 617,
  [1336] = 615,
  [1337] = 616,
  [1338] = 617,
  [1339] = 614,
  [1340] = 617,
  [1341] = 616,
  [1342] = 615,
  [1343] = 614,
  [1344] = 617,
  [1345] = 616,
  [1346] = 614,
  [1347] = 615,
  [1348] = 614,
  [1349] = 617,
  [1350] = 616,
  [1351] = 615,
  [1352] = 614,
  [1353] = 617,
  [1354] = 617,
  [1355] = 616,
  [1356] = 615,
  [1357] = 614,
  [1358] = 617,
  [1359] = 616,
  [1360] = 615,
  [1361] = 616,
  [1362] = 615,
  [1363] = 614,
  [1364] = 614,
  [1365] = 617,
  [1366] = 616,
  [1367] = 616,
  [1368] = 614,
  [1369] = 615,
  [1370] = 614,
  [1371] = 614,
  [1372] = 617,
  [1373] = 615,
  [1374] = 616,
  [1375] = 626,
  [1376] = 617,
  [1377] = 614,
  [1378] = 614,
  [1379] = 616,
  [1380] = 617,
  [1381] = 616,
  [1382] = 615,
  [1383] = 616,
  [1384] = 615,
  [1385] = 614,
  [1386] = 617,
  [1387] = 614,
  [1388] = 617,
  [1389] = 616,
  [1390] = 615,
  [1391] = 614,
  [1392] = 617,
  [1393] = 617,
  [1394] = 617,
  [1395] = 614,
  [1396] = 1396,
  [1397] = 1397,
  [1398] = 1398,
  [1399] = 1399,
  [1400] = 1400,
  [1401] = 1401,
  [1402] = 1402,
  [1403] = 1402,
  [1404] = 1404,
  [1405] = 1405,
  [1406] = 1401,
  [1407] = 1407,
  [1408] = 1399,
  [1409] = 1398,
  [1410] = 1410,
  [1411] = 1411,
  [1412] = 1410,
  [1413] = 1413,
  [1414] = 1397,
  [1415] = 1415,
  [1416] = 1410,
  [1417] = 1401,
  [1418] = 1415,
  [1419] = 1419,
  [1420] = 1420,
  [1421] = 1421,
  [1422] = 1422,
  [1423] = 1397,
  [1424] = 1415,
  [1425] = 1410,
  [1426] = 1422,
  [1427] = 1419,
  [1428] = 1421,
  [1429] = 1402,
  [1430] = 1399,
  [1431] = 1407,
  [1432] = 1398,
  [1433] = 1415,
  [1434] = 1410,
  [1435] = 1415,
  [1436] = 1397,
  [1437] = 1422,
  [1438] = 1421,
  [1439] = 1420,
  [1440] = 1421,
  [1441] = 1422,
  [1442] = 1422,
  [1443] = 1415,
  [1444] = 1410,
  [1445] = 1421,
  [1446] = 1398,
  [1447] = 1420,
  [1448] = 1420,
  [1449] = 1399,
  [1450] = 1402,
  [1451] = 1398,
  [1452] = 1422,
  [1453] = 1399,
  [1454] = 1420,
  [1455] = 1401,
  [1456] = 1407,
  [1457] = 1405,
  [1458] = 1402,
  [1459] = 1459,
  [1460] = 1460,
  [1461] = 1461,
  [1462] = 1396,
  [1463] = 1397,
  [1464] = 1400,
  [1465] = 1407,
  [1466] = 1401,
  [1467] = 1460,
  [1468] = 1421,
  [1469] = 1404,
  [1470] = 1461,
  [1471] = 1461,
  [1472] = 1396,
  [1473] = 1405,
  [1474] = 1460,
  [1475] = 1459,
  [1476] = 1404,
  [1477] = 1407,
  [1478] = 1401,
  [1479] = 1459,
  [1480] = 1397,
  [1481] = 1413,
  [1482] = 1413,
  [1483] = 1460,
  [1484] = 1419,
  [1485] = 1407,
  [1486] = 1405,
  [1487] = 1419,
  [1488] = 1404,
  [1489] = 1400,
  [1490] = 1407,
  [1491] = 1396,
  [1492] = 1420,
  [1493] = 1407,
  [1494] = 1421,
  [1495] = 1413,
  [1496] = 1420,
  [1497] = 1421,
  [1498] = 1422,
  [1499] = 1415,
  [1500] = 1401,
  [1501] = 1401,
  [1502] = 1410,
  [1503] = 1397,
  [1504] = 1402,
  [1505] = 1399,
  [1506] = 1405,
  [1507] = 1398,
  [1508] = 1410,
  [1509] = 1415,
  [1510] = 1422,
  [1511] = 1398,
  [1512] = 1399,
  [1513] = 1397,
  [1514] = 1461,
  [1515] = 1402,
  [1516] = 1460,
  [1517] = 1404,
  [1518] = 1459,
  [1519] = 1422,
  [1520] = 1415,
  [1521] = 1410,
  [1522] = 1400,
  [1523] = 1396,
  [1524] = 1421,
  [1525] = 1397,
  [1526] = 1401,
  [1527] = 1407,
  [1528] = 1398,
  [1529] = 1420,
  [1530] = 1399,
  [1531] = 1420,
  [1532] = 1402,
  [1533] = 1461,
  [1534] = 1460,
  [1535] = 1420,
  [1536] = 1407,
  [1537] = 1459,
  [1538] = 1459,
  [1539] = 1460,
  [1540] = 1461,
  [1541] = 1402,
  [1542] = 1396,
  [1543] = 1400,
  [1544] = 1421,
  [1545] = 1461,
  [1546] = 1422,
  [1547] = 1415,
  [1548] = 1410,
  [1549] = 1419,
  [1550] = 1397,
  [1551] = 1398,
  [1552] = 1399,
  [1553] = 1402,
  [1554] = 1407,
  [1555] = 1401,
  [1556] = 1402,
  [1557] = 1413,
  [1558] = 1404,
  [1559] = 1420,
  [1560] = 1405,
  [1561] = 1421,
  [1562] = 1399,
  [1563] = 1398,
  [1564] = 1404,
  [1565] = 1420,
  [1566] = 1410,
  [1567] = 1415,
  [1568] = 1397,
  [1569] = 1422,
  [1570] = 1421,
  [1571] = 1420,
  [1572] = 1400,
  [1573] = 1421,
  [1574] = 1422,
  [1575] = 1396,
  [1576] = 1422,
  [1577] = 1399,
  [1578] = 1413,
  [1579] = 1401,
  [1580] = 1399,
  [1581] = 1415,
  [1582] = 1407,
  [1583] = 1398,
  [1584] = 1415,
  [1585] = 1585,
  [1586] = 1461,
  [1587] = 1410,
  [1588] = 1405,
  [1589] = 1460,
  [1590] = 1459,
  [1591] = 1410,
  [1592] = 1398,
  [1593] = 1411,
  [1594] = 1460,
  [1595] = 1399,
  [1596] = 1402,
  [1597] = 1397,
  [1598] = 1461,
  [1599] = 1419,
  [1600] = 1415,
  [1601] = 1396,
  [1602] = 1422,
  [1603] = 1404,
  [1604] = 1397,
  [1605] = 1401,
  [1606] = 1407,
  [1607] = 1421,
  [1608] = 1396,
  [1609] = 1420,
  [1610] = 1413,
  [1611] = 1413,
  [1612] = 1397,
  [1613] = 1407,
  [1614] = 1400,
  [1615] = 1397,
  [1616] = 1407,
  [1617] = 1617,
  [1618] = 1401,
  [1619] = 1619,
  [1620] = 1419,
  [1621] = 1419,
  [1622] = 1405,
  [1623] = 1413,
  [1624] = 1420,
  [1625] = 1421,
  [1626] = 1422,
  [1627] = 1627,
  [1628] = 1628,
  [1629] = 1410,
  [1630] = 1420,
  [1631] = 1631,
  [1632] = 1398,
  [1633] = 1415,
  [1634] = 1634,
  [1635] = 1405,
  [1636] = 1410,
  [1637] = 1404,
  [1638] = 1638,
  [1639] = 1397,
  [1640] = 1398,
  [1641] = 1400,
  [1642] = 1459,
  [1643] = 1405,
  [1644] = 1419,
  [1645] = 1396,
  [1646] = 1459,
  [1647] = 1401,
  [1648] = 1421,
  [1649] = 1402,
  [1650] = 1422,
  [1651] = 1415,
  [1652] = 1410,
  [1653] = 1459,
  [1654] = 1405,
  [1655] = 1399,
  [1656] = 1399,
  [1657] = 1401,
  [1658] = 1407,
  [1659] = 1404,
  [1660] = 1404,
  [1661] = 1396,
  [1662] = 1460,
  [1663] = 1411,
  [1664] = 1402,
  [1665] = 1461,
  [1666] = 1460,
  [1667] = 1459,
  [1668] = 1401,
  [1669] = 1461,
  [1670] = 1460,
  [1671] = 1459,
  [1672] = 1397,
  [1673] = 1461,
  [1674] = 1397,
  [1675] = 1407,
  [1676] = 1401,
  [1677] = 1396,
  [1678] = 1400,
  [1679] = 1404,
  [1680] = 1405,
  [1681] = 1413,
  [1682] = 1402,
  [1683] = 1399,
  [1684] = 1419,
  [1685] = 1407,
  [1686] = 1404,
  [1687] = 1398,
  [1688] = 1410,
  [1689] = 1405,
  [1690] = 1415,
  [1691] = 1422,
  [1692] = 1400,
  [1693] = 1397,
  [1694] = 1398,
  [1695] = 1396,
  [1696] = 1402,
  [1697] = 1461,
  [1698] = 1399,
  [1699] = 1402,
  [1700] = 1421,
  [1701] = 1397,
  [1702] = 1401,
  [1703] = 1398,
  [1704] = 1460,
  [1705] = 1410,
  [1706] = 1459,
  [1707] = 1407,
  [1708] = 1708,
  [1709] = 1709,
  [1710] = 1415,
  [1711] = 1460,
  [1712] = 1420,
  [1713] = 1420,
  [1714] = 1461,
  [1715] = 1405,
  [1716] = 1422,
  [1717] = 1421,
  [1718] = 1420,
  [1719] = 1421,
  [1720] = 1422,
  [1721] = 1404,
  [1722] = 1420,
  [1723] = 1397,
  [1724] = 1396,
  [1725] = 1397,
  [1726] = 1415,
  [1727] = 1410,
  [1728] = 1398,
  [1729] = 1399,
  [1730] = 1420,
  [1731] = 1461,
  [1732] = 1459,
  [1733] = 1460,
  [1734] = 1459,
  [1735] = 1460,
  [1736] = 1461,
  [1737] = 1404,
  [1738] = 1396,
  [1739] = 1420,
  [1740] = 1402,
  [1741] = 1401,
  [1742] = 1400,
  [1743] = 1407,
  [1744] = 1396,
  [1745] = 1397,
  [1746] = 1404,
  [1747] = 1407,
  [1748] = 1405,
  [1749] = 1407,
  [1750] = 1401,
  [1751] = 1404,
  [1752] = 1421,
  [1753] = 1753,
  [1754] = 1754,
  [1755] = 1401,
  [1756] = 1756,
  [1757] = 1419,
  [1758] = 1407,
  [1759] = 1402,
  [1760] = 1421,
  [1761] = 1422,
  [1762] = 1401,
  [1763] = 1415,
  [1764] = 1410,
  [1765] = 1413,
  [1766] = 1398,
  [1767] = 1399,
  [1768] = 1402,
  [1769] = 1413,
  [1770] = 1401,
  [1771] = 1422,
  [1772] = 1415,
  [1773] = 1402,
  [1774] = 1419,
  [1775] = 1775,
  [1776] = 1399,
  [1777] = 1407,
  [1778] = 1778,
  [1779] = 1404,
  [1780] = 1398,
  [1781] = 1407,
  [1782] = 1396,
  [1783] = 1461,
  [1784] = 1402,
  [1785] = 1399,
  [1786] = 1398,
  [1787] = 1397,
  [1788] = 1410,
  [1789] = 1415,
  [1790] = 1422,
  [1791] = 1401,
  [1792] = 1397,
  [1793] = 1405,
  [1794] = 1460,
  [1795] = 1399,
  [1796] = 1407,
  [1797] = 1398,
  [1798] = 1404,
  [1799] = 1405,
  [1800] = 1410,
  [1801] = 1396,
  [1802] = 1410,
  [1803] = 1415,
  [1804] = 1422,
  [1805] = 1413,
  [1806] = 1411,
  [1807] = 1459,
  [1808] = 1460,
  [1809] = 1459,
  [1810] = 1421,
  [1811] = 1420,
  [1812] = 1461,
  [1813] = 1460,
  [1814] = 1459,
  [1815] = 1461,
  [1816] = 1405,
  [1817] = 1421,
  [1818] = 1420,
  [1819] = 1404,
  [1820] = 1400,
  [1821] = 1396,
  [1822] = 1396,
  [1823] = 1401,
  [1824] = 1404,
  [1825] = 1397,
  [1826] = 1405,
  [1827] = 1420,
  [1828] = 1461,
  [1829] = 1415,
  [1830] = 1460,
  [1831] = 1459,
  [1832] = 1421,
  [1833] = 1422,
  [1834] = 1420,
  [1835] = 1419,
  [1836] = 1421,
  [1837] = 1401,
  [1838] = 1422,
  [1839] = 1415,
  [1840] = 1422,
  [1841] = 1415,
  [1842] = 1410,
  [1843] = 1398,
  [1844] = 1410,
  [1845] = 1405,
  [1846] = 1405,
  [1847] = 1398,
  [1848] = 1459,
  [1849] = 1421,
  [1850] = 1399,
  [1851] = 1407,
  [1852] = 1852,
  [1853] = 1407,
  [1854] = 1401,
  [1855] = 1422,
  [1856] = 1420,
  [1857] = 1415,
  [1858] = 1419,
  [1859] = 1397,
  [1860] = 1421,
  [1861] = 1410,
  [1862] = 1422,
  [1863] = 1415,
  [1864] = 1398,
  [1865] = 1399,
  [1866] = 1420,
  [1867] = 1410,
  [1868] = 1402,
  [1869] = 1421,
  [1870] = 1413,
  [1871] = 1398,
  [1872] = 1422,
  [1873] = 1415,
  [1874] = 1399,
  [1875] = 1402,
  [1876] = 1405,
  [1877] = 1410,
  [1878] = 1401,
  [1879] = 1398,
  [1880] = 1399,
  [1881] = 1404,
  [1882] = 1882,
  [1883] = 1396,
  [1884] = 1402,
  [1885] = 1397,
  [1886] = 1407,
  [1887] = 1407,
  [1888] = 1401,
  [1889] = 1407,
  [1890] = 1461,
  [1891] = 1460,
  [1892] = 1459,
  [1893] = 1405,
  [1894] = 1402,
  [1895] = 1407,
  [1896] = 1401,
  [1897] = 1401,
  [1898] = 1401,
  [1899] = 1407,
  [1900] = 1397,
  [1901] = 1421,
  [1902] = 1401,
  [1903] = 1402,
  [1904] = 1904,
  [1905] = 1397,
  [1906] = 1407,
  [1907] = 1907,
  [1908] = 1399,
  [1909] = 1401,
  [1910] = 1419,
  [1911] = 1398,
  [1912] = 1407,
  [1913] = 1401,
  [1914] = 1407,
  [1915] = 1420,
  [1916] = 1410,
  [1917] = 1413,
  [1918] = 1404,
  [1919] = 1401,
  [1920] = 1420,
  [1921] = 1421,
  [1922] = 1422,
  [1923] = 1415,
  [1924] = 1407,
  [1925] = 1410,
  [1926] = 1398,
  [1927] = 1415,
  [1928] = 1422,
  [1929] = 1401,
  [1930] = 1399,
  [1931] = 1459,
  [1932] = 1405,
  [1933] = 1460,
  [1934] = 1421,
  [1935] = 1420,
  [1936] = 1404,
  [1937] = 1461,
  [1938] = 1400,
  [1939] = 1396,
  [1940] = 1407,
  [1941] = 1396,
  [1942] = 1401,
  [1943] = 1402,
  [1944] = 1404,
  [1945] = 1402,
  [1946] = 1407,
  [1947] = 1413,
  [1948] = 1461,
  [1949] = 1400,
  [1950] = 1396,
  [1951] = 1399,
  [1952] = 1401,
  [1953] = 1407,
  [1954] = 1460,
  [1955] = 1405,
  [1956] = 1398,
  [1957] = 1405,
  [1958] = 1407,
  [1959] = 1410,
  [1960] = 1415,
  [1961] = 1422,
  [1962] = 1421,
  [1963] = 1404,
  [1964] = 1420,
  [1965] = 1401,
  [1966] = 1396,
  [1967] = 1459,
  [1968] = 1401,
  [1969] = 1402,
  [1970] = 1399,
  [1971] = 1407,
  [1972] = 1398,
  [1973] = 1410,
  [1974] = 1415,
  [1975] = 1422,
  [1976] = 1461,
  [1977] = 1401,
  [1978] = 1460,
  [1979] = 1461,
  [1980] = 1407,
  [1981] = 1460,
  [1982] = 1459,
  [1983] = 1407,
  [1984] = 1401,
  [1985] = 1985,
  [1986] = 1459,
  [1987] = 1397,
  [1988] = 1421,
  [1989] = 1407,
  [1990] = 1401,
  [1991] = 1407,
  [1992] = 1407,
  [1993] = 1401,
  [1994] = 1397,
  [1995] = 1407,
  [1996] = 1401,
  [1997] = 1407,
  [1998] = 1401,
  [1999] = 1407,
  [2000] = 1420,
  [2001] = 1401,
  [2002] = 1397,
  [2003] = 1397,
  [2004] = 1407,
  [2005] = 1401,
  [2006] = 1407,
  [2007] = 1400,
  [2008] = 1401,
  [2009] = 1401,
  [2010] = 1397,
  [2011] = 1407,
  [2012] = 1420,
  [2013] = 1421,
  [2014] = 1397,
  [2015] = 1422,
  [2016] = 1401,
  [2017] = 1415,
  [2018] = 1410,
  [2019] = 1407,
  [2020] = 1396,
  [2021] = 1400,
  [2022] = 1398,
  [2023] = 1399,
  [2024] = 1401,
  [2025] = 1399,
  [2026] = 1402,
  [2027] = 1459,
  [2028] = 1460,
  [2029] = 1461,
  [2030] = 1401,
  [2031] = 1405,
  [2032] = 1407,
  [2033] = 1398,
  [2034] = 1399,
  [2035] = 1420,
  [2036] = 1401,
  [2037] = 1407,
  [2038] = 1396,
  [2039] = 1420,
  [2040] = 1421,
  [2041] = 1422,
  [2042] = 1397,
  [2043] = 1401,
  [2044] = 1415,
  [2045] = 1410,
  [2046] = 1398,
  [2047] = 1399,
  [2048] = 1402,
  [2049] = 1402,
  [2050] = 1407,
  [2051] = 1404,
  [2052] = 1405,
  [2053] = 1401,
  [2054] = 1407,
  [2055] = 1401,
  [2056] = 1407,
  [2057] = 1404,
  [2058] = 1405,
  [2059] = 1396,
  [2060] = 1401,
  [2061] = 1407,
  [2062] = 1421,
  [2063] = 1401,
  [2064] = 1461,
  [2065] = 1460,
  [2066] = 1459,
  [2067] = 1401,
  [2068] = 1402,
  [2069] = 1401,
  [2070] = 1407,
  [2071] = 1459,
  [2072] = 1402,
  [2073] = 1407,
  [2074] = 1399,
  [2075] = 1398,
  [2076] = 1397,
  [2077] = 1422,
  [2078] = 1460,
  [2079] = 1461,
  [2080] = 1410,
  [2081] = 1407,
  [2082] = 1415,
  [2083] = 1410,
  [2084] = 1399,
  [2085] = 1398,
  [2086] = 1398,
  [2087] = 1410,
  [2088] = 1415,
  [2089] = 1407,
  [2090] = 1396,
  [2091] = 1401,
  [2092] = 1407,
  [2093] = 1401,
  [2094] = 1401,
  [2095] = 1407,
  [2096] = 1401,
  [2097] = 1402,
  [2098] = 1401,
  [2099] = 1415,
  [2100] = 1410,
  [2101] = 1407,
  [2102] = 1401,
  [2103] = 1407,
  [2104] = 1407,
  [2105] = 1401,
  [2106] = 1398,
  [2107] = 1401,
  [2108] = 1407,
  [2109] = 1422,
  [2110] = 1421,
  [2111] = 1401,
  [2112] = 1407,
  [2113] = 1420,
  [2114] = 1399,
  [2115] = 1419,
  [2116] = 1397,
  [2117] = 1399,
  [2118] = 1402,
  [2119] = 1405,
  [2120] = 1413,
  [2121] = 1398,
  [2122] = 1405,
  [2123] = 1401,
  [2124] = 1410,
  [2125] = 1404,
  [2126] = 1407,
  [2127] = 1415,
  [2128] = 1396,
  [2129] = 1422,
  [2130] = 1421,
  [2131] = 1397,
  [2132] = 1404,
  [2133] = 1404,
  [2134] = 1399,
  [2135] = 1419,
  [2136] = 1407,
  [2137] = 1402,
  [2138] = 1401,
  [2139] = 1459,
  [2140] = 1422,
  [2141] = 1420,
  [2142] = 1460,
  [2143] = 1413,
  [2144] = 1401,
  [2145] = 1420,
  [2146] = 1421,
  [2147] = 1422,
  [2148] = 1415,
  [2149] = 1410,
  [2150] = 1398,
  [2151] = 1461,
  [2152] = 1461,
  [2153] = 1407,
  [2154] = 1405,
  [2155] = 1460,
  [2156] = 1459,
  [2157] = 1399,
  [2158] = 1396,
  [2159] = 1407,
  [2160] = 1401,
  [2161] = 1407,
  [2162] = 1402,
  [2163] = 1400,
  [2164] = 1404,
  [2165] = 1396,
  [2166] = 1397,
  [2167] = 1401,
  [2168] = 1407,
  [2169] = 1461,
  [2170] = 1460,
  [2171] = 1459,
  [2172] = 1401,
  [2173] = 1407,
  [2174] = 1401,
  [2175] = 1407,
  [2176] = 1401,
  [2177] = 1404,
  [2178] = 1399,
  [2179] = 1397,
  [2180] = 1407,
  [2181] = 1405,
  [2182] = 2182,
  [2183] = 1401,
  [2184] = 1407,
  [2185] = 1400,
  [2186] = 1407,
  [2187] = 1407,
  [2188] = 1396,
  [2189] = 1401,
  [2190] = 1401,
  [2191] = 1407,
  [2192] = 1401,
  [2193] = 1407,
  [2194] = 1401,
  [2195] = 1421,
  [2196] = 1407,
  [2197] = 1420,
  [2198] = 1420,
  [2199] = 1461,
  [2200] = 1419,
  [2201] = 1407,
  [2202] = 1401,
  [2203] = 1460,
  [2204] = 1459,
  [2205] = 1407,
  [2206] = 1405,
  [2207] = 1401,
  [2208] = 1401,
  [2209] = 1407,
  [2210] = 1407,
  [2211] = 1401,
  [2212] = 1407,
  [2213] = 1421,
  [2214] = 1401,
  [2215] = 1407,
  [2216] = 1401,
  [2217] = 1407,
  [2218] = 1401,
  [2219] = 1401,
  [2220] = 1422,
  [2221] = 1415,
  [2222] = 1410,
  [2223] = 1398,
  [2224] = 1407,
  [2225] = 1401,
  [2226] = 1399,
  [2227] = 1402,
  [2228] = 1407,
  [2229] = 1397,
  [2230] = 1420,
  [2231] = 1421,
  [2232] = 1422,
  [2233] = 1401,
  [2234] = 1415,
  [2235] = 1407,
  [2236] = 1401,
  [2237] = 1402,
  [2238] = 1410,
  [2239] = 1398,
  [2240] = 1407,
  [2241] = 1420,
  [2242] = 1399,
  [2243] = 1421,
  [2244] = 1397,
  [2245] = 1407,
  [2246] = 1419,
  [2247] = 1405,
  [2248] = 1422,
  [2249] = 1415,
  [2250] = 1410,
  [2251] = 1402,
  [2252] = 1404,
  [2253] = 1398,
  [2254] = 1401,
  [2255] = 1407,
  [2256] = 1396,
  [2257] = 1402,
  [2258] = 1401,
  [2259] = 1413,
  [2260] = 1399,
  [2261] = 1407,
  [2262] = 1401,
  [2263] = 1413,
  [2264] = 1397,
  [2265] = 1399,
  [2266] = 1407,
  [2267] = 1407,
  [2268] = 1401,
  [2269] = 1398,
  [2270] = 1402,
  [2271] = 1410,
  [2272] = 1401,
  [2273] = 1401,
  [2274] = 1407,
  [2275] = 1397,
  [2276] = 1402,
  [2277] = 1398,
  [2278] = 1405,
  [2279] = 1399,
  [2280] = 1461,
  [2281] = 1460,
  [2282] = 1459,
  [2283] = 1419,
  [2284] = 1407,
  [2285] = 1401,
  [2286] = 1407,
  [2287] = 1401,
  [2288] = 1401,
  [2289] = 1401,
  [2290] = 1407,
  [2291] = 1407,
  [2292] = 1459,
  [2293] = 1460,
  [2294] = 1398,
  [2295] = 1419,
  [2296] = 1397,
  [2297] = 1461,
  [2298] = 1410,
  [2299] = 1415,
  [2300] = 1410,
  [2301] = 1422,
  [2302] = 1421,
  [2303] = 1415,
  [2304] = 1422,
  [2305] = 1401,
  [2306] = 1421,
  [2307] = 1420,
  [2308] = 1404,
  [2309] = 1396,
  [2310] = 1400,
  [2311] = 1396,
  [2312] = 1407,
  [2313] = 1420,
  [2314] = 1421,
  [2315] = 1422,
  [2316] = 1401,
  [2317] = 1407,
  [2318] = 1401,
  [2319] = 1401,
  [2320] = 1402,
  [2321] = 1399,
  [2322] = 1407,
  [2323] = 1415,
  [2324] = 1407,
  [2325] = 1410,
  [2326] = 1461,
  [2327] = 1460,
  [2328] = 1459,
  [2329] = 1401,
  [2330] = 1407,
  [2331] = 1461,
  [2332] = 1398,
  [2333] = 1398,
  [2334] = 1401,
  [2335] = 1407,
  [2336] = 1407,
  [2337] = 1401,
  [2338] = 1401,
  [2339] = 1407,
  [2340] = 1399,
  [2341] = 1401,
  [2342] = 1407,
  [2343] = 1397,
  [2344] = 1404,
  [2345] = 1401,
  [2346] = 1407,
  [2347] = 1413,
  [2348] = 1407,
  [2349] = 1402,
  [2350] = 1399,
  [2351] = 1402,
  [2352] = 1420,
  [2353] = 1401,
  [2354] = 1405,
  [2355] = 1401,
  [2356] = 1398,
  [2357] = 1405,
  [2358] = 1407,
  [2359] = 1410,
  [2360] = 1415,
  [2361] = 1401,
  [2362] = 1422,
  [2363] = 1421,
  [2364] = 1420,
  [2365] = 1407,
  [2366] = 1401,
  [2367] = 1404,
  [2368] = 1407,
  [2369] = 1407,
  [2370] = 1415,
  [2371] = 1396,
  [2372] = 1401,
  [2373] = 1401,
  [2374] = 1401,
  [2375] = 1420,
  [2376] = 1461,
  [2377] = 1407,
  [2378] = 1460,
  [2379] = 1422,
  [2380] = 1459,
  [2381] = 1401,
  [2382] = 1407,
  [2383] = 1401,
  [2384] = 1407,
  [2385] = 1401,
  [2386] = 1421,
  [2387] = 1401,
  [2388] = 1422,
  [2389] = 1415,
  [2390] = 1407,
  [2391] = 1397,
  [2392] = 1460,
  [2393] = 1882,
  [2394] = 1410,
  [2395] = 1398,
  [2396] = 1399,
  [2397] = 1402,
  [2398] = 1459,
  [2399] = 1401,
  [2400] = 1407,
  [2401] = 1401,
  [2402] = 1410,
  [2403] = 1407,
  [2404] = 1401,
  [2405] = 1407,
  [2406] = 1405,
  [2407] = 1401,
  [2408] = 1407,
  [2409] = 1407,
  [2410] = 1401,
  [2411] = 1401,
  [2412] = 1407,
  [2413] = 1401,
  [2414] = 1420,
  [2415] = 1407,
  [2416] = 1407,
  [2417] = 1421,
  [2418] = 1422,
  [2419] = 1415,
  [2420] = 1410,
  [2421] = 1419,
  [2422] = 1398,
  [2423] = 1399,
  [2424] = 1775,
  [2425] = 1401,
  [2426] = 1756,
  [2427] = 1402,
  [2428] = 1420,
  [2429] = 1401,
  [2430] = 1753,
  [2431] = 1421,
  [2432] = 1407,
  [2433] = 1422,
  [2434] = 1413,
  [2435] = 1407,
  [2436] = 1401,
  [2437] = 1397,
  [2438] = 1405,
  [2439] = 1401,
  [2440] = 1404,
  [2441] = 1407,
  [2442] = 1415,
  [2443] = 1401,
  [2444] = 1402,
  [2445] = 1459,
  [2446] = 1460,
  [2447] = 1405,
  [2448] = 1461,
  [2449] = 1401,
  [2450] = 1407,
  [2451] = 1404,
  [2452] = 1404,
  [2453] = 1400,
  [2454] = 1396,
  [2455] = 1396,
  [2456] = 1401,
  [2457] = 1407,
  [2458] = 1396,
  [2459] = 1407,
  [2460] = 1400,
  [2461] = 1461,
  [2462] = 1396,
  [2463] = 1460,
  [2464] = 1410,
  [2465] = 1398,
  [2466] = 1399,
  [2467] = 1459,
  [2468] = 1402,
  [2469] = 1461,
  [2470] = 1461,
  [2471] = 1401,
  [2472] = 1460,
  [2473] = 1401,
  [2474] = 1460,
  [2475] = 1709,
  [2476] = 1708,
  [2477] = 1407,
  [2478] = 1401,
  [2479] = 1459,
  [2480] = 1407,
  [2481] = 1401,
  [2482] = 1401,
  [2483] = 1401,
  [2484] = 1407,
  [2485] = 1397,
  [2486] = 1459,
  [2487] = 1404,
  [2488] = 1404,
  [2489] = 1401,
  [2490] = 1407,
  [2491] = 1407,
  [2492] = 1415,
  [2493] = 1401,
  [2494] = 1422,
  [2495] = 1401,
  [2496] = 1407,
  [2497] = 1401,
  [2498] = 1407,
  [2499] = 1634,
  [2500] = 1631,
  [2501] = 1421,
  [2502] = 1407,
  [2503] = 1421,
  [2504] = 1401,
  [2505] = 1407,
  [2506] = 1401,
  [2507] = 1627,
  [2508] = 1405,
  [2509] = 1402,
  [2510] = 1420,
  [2511] = 1399,
  [2512] = 1398,
  [2513] = 1410,
  [2514] = 1407,
  [2515] = 1415,
  [2516] = 1422,
  [2517] = 1397,
  [2518] = 1421,
  [2519] = 1420,
  [2520] = 1407,
  [2521] = 1401,
  [2522] = 1420,
  [2523] = 1421,
  [2524] = 1422,
  [2525] = 1415,
  [2526] = 1405,
  [2527] = 1410,
  [2528] = 1398,
  [2529] = 1399,
  [2530] = 1404,
  [2531] = 1407,
  [2532] = 1396,
  [2533] = 1402,
  [2534] = 1619,
  [2535] = 1401,
  [2536] = 1420,
  [2537] = 1421,
  [2538] = 1461,
  [2539] = 1460,
  [2540] = 1459,
  [2541] = 1401,
  [2542] = 1407,
  [2543] = 1401,
  [2544] = 1407,
  [2545] = 1401,
  [2546] = 1407,
  [2547] = 1407,
  [2548] = 1401,
  [2549] = 1638,
  [2550] = 1617,
  [2551] = 1397,
  [2552] = 1407,
  [2553] = 1400,
  [2554] = 1422,
  [2555] = 1420,
  [2556] = 1401,
  [2557] = 1407,
  [2558] = 1396,
  [2559] = 1401,
  [2560] = 1397,
  [2561] = 1407,
  [2562] = 1415,
  [2563] = 1401,
  [2564] = 1410,
  [2565] = 1585,
  [2566] = 1420,
  [2567] = 1398,
  [2568] = 1407,
  [2569] = 1397,
  [2570] = 1401,
  [2571] = 1421,
  [2572] = 1422,
  [2573] = 1401,
  [2574] = 1407,
  [2575] = 1401,
  [2576] = 1407,
  [2577] = 1407,
  [2578] = 1401,
  [2579] = 1401,
  [2580] = 1399,
  [2581] = 1401,
  [2582] = 1402,
  [2583] = 1407,
  [2584] = 1401,
  [2585] = 1407,
  [2586] = 1459,
  [2587] = 1419,
  [2588] = 1407,
  [2589] = 1415,
  [2590] = 1401,
  [2591] = 1407,
  [2592] = 1460,
  [2593] = 1401,
  [2594] = 1407,
  [2595] = 1397,
  [2596] = 1413,
  [2597] = 1405,
  [2598] = 1461,
  [2599] = 1407,
  [2600] = 1401,
  [2601] = 1404,
  [2602] = 1407,
  [2603] = 1396,
  [2604] = 1407,
  [2605] = 1396,
  [2606] = 1404,
  [2607] = 1407,
  [2608] = 1401,
  [2609] = 1401,
  [2610] = 1407,
  [2611] = 1461,
  [2612] = 1460,
  [2613] = 1459,
  [2614] = 1407,
  [2615] = 1401,
  [2616] = 1459,
  [2617] = 1460,
  [2618] = 1405,
  [2619] = 1401,
  [2620] = 1420,
  [2621] = 1397,
  [2622] = 1421,
  [2623] = 1407,
  [2624] = 1410,
  [2625] = 1398,
  [2626] = 1422,
  [2627] = 1415,
  [2628] = 1410,
  [2629] = 1398,
  [2630] = 1405,
  [2631] = 1399,
  [2632] = 1461,
  [2633] = 1399,
  [2634] = 1401,
  [2635] = 1407,
  [2636] = 1401,
  [2637] = 1402,
  [2638] = 1407,
  [2639] = 1407,
  [2640] = 1401,
  [2641] = 1402,
  [2642] = 1401,
  [2643] = 1407,
  [2644] = 1404,
  [2645] = 1401,
  [2646] = 1407,
  [2647] = 1401,
  [2648] = 1407,
  [2649] = 1401,
  [2650] = 1407,
  [2651] = 1400,
  [2652] = 1396,
  [2653] = 1401,
  [2654] = 1407,
  [2655] = 1401,
  [2656] = 1407,
  [2657] = 1459,
  [2658] = 1461,
  [2659] = 1460,
  [2660] = 2660,
  [2661] = 2661,
  [2662] = 2661,
  [2663] = 2660,
  [2664] = 2660,
  [2665] = 2661,
  [2666] = 2666,
  [2667] = 2660,
  [2668] = 2666,
  [2669] = 2666,
  [2670] = 2666,
  [2671] = 2671,
  [2672] = 2660,
  [2673] = 2661,
  [2674] = 2660,
  [2675] = 2661,
  [2676] = 2660,
  [2677] = 2660,
  [2678] = 2661,
  [2679] = 2666,
  [2680] = 2660,
  [2681] = 2661,
  [2682] = 2666,
  [2683] = 2661,
  [2684] = 2660,
  [2685] = 2661,
  [2686] = 2661,
  [2687] = 2666,
  [2688] = 2666,
  [2689] = 2661,
  [2690] = 2661,
  [2691] = 2661,
  [2692] = 2660,
  [2693] = 2660,
  [2694] = 2666,
  [2695] = 2660,
  [2696] = 2660,
  [2697] = 2666,
  [2698] = 2666,
  [2699] = 2666,
  [2700] = 2661,
  [2701] = 2660,
  [2702] = 2661,
  [2703] = 2666,
  [2704] = 2666,
  [2705] = 2660,
  [2706] = 2661,
  [2707] = 2666,
  [2708] = 2666,
  [2709] = 2666,
  [2710] = 2660,
  [2711] = 2661,
  [2712] = 2666,
  [2713] = 2661,
  [2714] = 2660,
  [2715] = 2666,
  [2716] = 2660,
  [2717] = 2660,
  [2718] = 2661,
  [2719] = 2661,
  [2720] = 2666,
  [2721] = 2661,
  [2722] = 2660,
  [2723] = 2660,
  [2724] = 2660,
  [2725] = 2660,
  [2726] = 2666,
  [2727] = 2666,
  [2728] = 2660,
  [2729] = 2661,
  [2730] = 2660,
  [2731] = 2661,
  [2732] = 2666,
  [2733] = 2666,
  [2734] = 2666,
  [2735] = 2661,
  [2736] = 2661,
  [2737] = 2661,
  [2738] = 2660,
  [2739] = 2666,
  [2740] = 2666,
  [2741] = 2661,
  [2742] = 2661,
  [2743] = 2660,
  [2744] = 2660,
  [2745] = 2666,
  [2746] = 2661,
  [2747] = 2666,
  [2748] = 2661,
  [2749] = 2660,
  [2750] = 2660,
  [2751] = 2661,
  [2752] = 2666,
  [2753] = 2660,
  [2754] = 2660,
  [2755] = 2661,
  [2756] = 2666,
  [2757] = 2666,
  [2758] = 2666,
  [2759] = 2666,
  [2760] = 2661,
  [2761] = 2661,
  [2762] = 2661,
  [2763] = 2661,
  [2764] = 2661,
  [2765] = 2666,
  [2766] = 2666,
  [2767] = 2661,
  [2768] = 2666,
  [2769] = 2666,
  [2770] = 2661,
  [2771] = 2666,
  [2772] = 2660,
  [2773] = 2660,
  [2774] = 2661,
  [2775] = 2660,
  [2776] = 2661,
  [2777] = 2666,
  [2778] = 2666,
  [2779] = 2661,
  [2780] = 2660,
  [2781] = 2666,
  [2782] = 2660,
  [2783] = 2660,
  [2784] = 2660,
  [2785] = 2660,
  [2786] = 2660,
  [2787] = 2660,
  [2788] = 2666,
  [2789] = 2660,
  [2790] = 2660,
  [2791] = 2666,
  [2792] = 2660,
  [2793] = 2660,
  [2794] = 2660,
  [2795] = 2660,
  [2796] = 2661,
  [2797] = 2660,
  [2798] = 2660,
  [2799] = 2666,
  [2800] = 2660,
  [2801] = 2666,
  [2802] = 2661,
  [2803] = 2661,
  [2804] = 2660,
  [2805] = 2661,
  [2806] = 2666,
  [2807] = 2661,
  [2808] = 2666,
  [2809] = 2660,
  [2810] = 2666,
  [2811] = 2660,
  [2812] = 2660,
  [2813] = 2661,
  [2814] = 2660,
  [2815] = 2661,
  [2816] = 2666,
  [2817] = 2661,
  [2818] = 2661,
  [2819] = 2660,
  [2820] = 2661,
  [2821] = 2661,
  [2822] = 2666,
  [2823] = 2666,
  [2824] = 2666,
  [2825] = 2660,
  [2826] = 2826,
  [2827] = 2826,
  [2828] = 2826,
  [2829] = 2826,
  [2830] = 2826,
  [2831] = 2826,
  [2832] = 2832,
  [2833] = 2832,
  [2834] = 2834,
  [2835] = 2835,
  [2836] = 2836,
  [2837] = 2832,
  [2838] = 2836,
  [2839] = 2839,
  [2840] = 2839,
  [2841] = 2834,
  [2842] = 2832,
  [2843] = 2835,
  [2844] = 2834,
  [2845] = 2835,
  [2846] = 2832,
  [2847] = 2839,
  [2848] = 2832,
  [2849] = 2839,
  [2850] = 2835,
  [2851] = 2836,
  [2852] = 2834,
  [2853] = 2834,
  [2854] = 2839,
  [2855] = 2836,
  [2856] = 2834,
  [2857] = 2832,
  [2858] = 2835,
  [2859] = 2835,
  [2860] = 2839,
  [2861] = 2835,
  [2862] = 2835,
  [2863] = 2832,
  [2864] = 2832,
  [2865] = 2832,
  [2866] = 2839,
  [2867] = 2839,
  [2868] = 2839,
  [2869] = 2836,
  [2870] = 2834,
  [2871] = 2836,
  [2872] = 2836,
  [2873] = 2836,
  [2874] = 2834,
  [2875] = 2839,
  [2876] = 2834,
  [2877] = 2832,
  [2878] = 2836,
  [2879] = 2835,
  [2880] = 2834,
  [2881] = 2836,
  [2882] = 2834,
  [2883] = 2834,
  [2884] = 2834,
  [2885] = 2839,
  [2886] = 2832,
  [2887] = 2832,
  [2888] = 2835,
  [2889] = 2889,
  [2890] = 2836,
  [2891] = 2839,
  [2892] = 2835,
  [2893] = 2832,
  [2894] = 2836,
  [2895] = 2832,
  [2896] = 2839,
  [2897] = 2835,
  [2898] = 2836,
  [2899] = 2832,
  [2900] = 2839,
  [2901] = 2839,
  [2902] = 2835,
  [2903] = 2832,
  [2904] = 2839,
  [2905] = 2834,
  [2906] = 2836,
  [2907] = 2836,
  [2908] = 2832,
  [2909] = 2832,
  [2910] = 2835,
  [2911] = 2832,
  [2912] = 2835,
  [2913] = 2832,
  [2914] = 2834,
  [2915] = 2834,
  [2916] = 2836,
  [2917] = 2836,
  [2918] = 2836,
  [2919] = 2834,
  [2920] = 2835,
  [2921] = 2834,
  [2922] = 2832,
  [2923] = 2839,
  [2924] = 2839,
  [2925] = 2836,
  [2926] = 2834,
  [2927] = 2835,
  [2928] = 2836,
  [2929] = 2839,
  [2930] = 2835,
  [2931] = 2839,
  [2932] = 2839,
  [2933] = 2832,
  [2934] = 2836,
  [2935] = 2834,
  [2936] = 2835,
  [2937] = 2832,
  [2938] = 2836,
  [2939] = 2834,
  [2940] = 2835,
  [2941] = 2832,
  [2942] = 2832,
  [2943] = 2839,
  [2944] = 2834,
  [2945] = 2839,
  [2946] = 2836,
  [2947] = 2834,
  [2948] = 2836,
  [2949] = 2839,
  [2950] = 2835,
  [2951] = 2834,
  [2952] = 2836,
  [2953] = 2835,
  [2954] = 2832,
  [2955] = 2836,
  [2956] = 2834,
  [2957] = 2839,
  [2958] = 2836,
  [2959] = 2834,
  [2960] = 2834,
  [2961] = 2836,
  [2962] = 2834,
  [2963] = 2835,
  [2964] = 2839,
  [2965] = 2835,
  [2966] = 2834,
  [2967] = 2836,
  [2968] = 2836,
  [2969] = 2839,
  [2970] = 2970,
  [2971] = 2835,
  [2972] = 2834,
  [2973] = 2835,
  [2974] = 2839,
  [2975] = 2839,
  [2976] = 2832,
  [2977] = 2835,
  [2978] = 2832,
  [2979] = 2832,
  [2980] = 2839,
  [2981] = 2835,
  [2982] = 2834,
  [2983] = 2835,
  [2984] = 2839,
  [2985] = 2839,
  [2986] = 2832,
  [2987] = 2835,
  [2988] = 2832,
  [2989] = 2836,
  [2990] = 2835,
  [2991] = 2832,
  [2992] = 2832,
  [2993] = 2835,
  [2994] = 2839,
  [2995] = 2835,
  [2996] = 2839,
  [2997] = 2834,
  [2998] = 2836,
  [2999] = 2839,
  [3000] = 2832,
  [3001] = 2834,
  [3002] = 2836,
  [3003] = 2835,
  [3004] = 2834,
  [3005] = 2836,
  [3006] = 2836,
  [3007] = 2834,
  [3008] = 2839,
  [3009] = 2834,
  [3010] = 2832,
  [3011] = 2835,
  [3012] = 2836,
  [3013] = 2834,
  [3014] = 2835,
  [3015] = 2839,
  [3016] = 2832,
  [3017] = 2839,
  [3018] = 2832,
  [3019] = 2835,
  [3020] = 2835,
  [3021] = 2839,
  [3022] = 2835,
  [3023] = 2834,
  [3024] = 2834,
  [3025] = 2836,
  [3026] = 2834,
  [3027] = 2832,
  [3028] = 2836,
  [3029] = 2839,
  [3030] = 2836,
  [3031] = 2839,
  [3032] = 2836,
  [3033] = 2834,
  [3034] = 2839,
  [3035] = 2832,
  [3036] = 2835,
  [3037] = 2836,
  [3038] = 2834,
  [3039] = 2832,
  [3040] = 2835,
  [3041] = 2832,
  [3042] = 2836,
  [3043] = 2839,
  [3044] = 2834,
  [3045] = 2836,
  [3046] = 2836,
  [3047] = 2839,
  [3048] = 2834,
  [3049] = 2835,
  [3050] = 2835,
  [3051] = 2834,
  [3052] = 2832,
  [3053] = 2835,
  [3054] = 2839,
  [3055] = 2832,
  [3056] = 2835,
  [3057] = 2832,
  [3058] = 2836,
  [3059] = 2834,
  [3060] = 2836,
  [3061] = 2839,
  [3062] = 2832,
  [3063] = 2834,
  [3064] = 2836,
  [3065] = 2834,
  [3066] = 2836,
  [3067] = 2835,
  [3068] = 2834,
  [3069] = 2832,
  [3070] = 2839,
  [3071] = 2836,
  [3072] = 2839,
  [3073] = 2836,
  [3074] = 2836,
  [3075] = 2834,
  [3076] = 2834,
  [3077] = 2839,
  [3078] = 2835,
  [3079] = 2832,
  [3080] = 2834,
  [3081] = 2836,
  [3082] = 2832,
  [3083] = 2835,
  [3084] = 2839,
  [3085] = 2832,
  [3086] = 2839,
  [3087] = 2832,
  [3088] = 2835,
  [3089] = 2835,
  [3090] = 2839,
  [3091] = 2832,
  [3092] = 2835,
  [3093] = 2835,
  [3094] = 2832,
  [3095] = 2836,
  [3096] = 2834,
  [3097] = 2839,
  [3098] = 2835,
  [3099] = 3099,
  [3100] = 3100,
  [3101] = 3101,
  [3102] = 3101,
  [3103] = 3099,
  [3104] = 3104,
  [3105] = 3105,
  [3106] = 3105,
  [3107] = 3101,
  [3108] = 3105,
  [3109] = 3101,
  [3110] = 3099,
  [3111] = 3105,
  [3112] = 3099,
  [3113] = 3099,
  [3114] = 3105,
  [3115] = 3115,
  [3116] = 3101,
  [3117] = 3105,
  [3118] = 3099,
  [3119] = 3119,
  [3120] = 3101,
  [3121] = 3121,
  [3122] = 3122,
  [3123] = 3123,
  [3124] = 3124,
  [3125] = 3125,
  [3126] = 3126,
  [3127] = 3127,
  [3128] = 3128,
  [3129] = 3125,
  [3130] = 3130,
  [3131] = 3128,
  [3132] = 3130,
  [3133] = 3133,
  [3134] = 3130,
  [3135] = 3130,
  [3136] = 3133,
  [3137] = 3137,
  [3138] = 3133,
  [3139] = 3128,
  [3140] = 3123,
  [3141] = 3128,
  [3142] = 3137,
  [3143] = 3123,
  [3144] = 3133,
  [3145] = 3137,
  [3146] = 3128,
  [3147] = 3137,
  [3148] = 3133,
  [3149] = 3128,
  [3150] = 3123,
  [3151] = 3133,
  [3152] = 3128,
  [3153] = 3123,
  [3154] = 3137,
  [3155] = 3137,
  [3156] = 3133,
  [3157] = 3123,
  [3158] = 3133,
  [3159] = 3128,
  [3160] = 3123,
  [3161] = 3128,
  [3162] = 3133,
  [3163] = 3133,
  [3164] = 3130,
  [3165] = 3133,
  [3166] = 3123,
  [3167] = 3137,
  [3168] = 3133,
  [3169] = 3137,
  [3170] = 3123,
  [3171] = 3128,
  [3172] = 3130,
  [3173] = 3137,
  [3174] = 3133,
  [3175] = 3123,
  [3176] = 3130,
  [3177] = 3137,
  [3178] = 3133,
  [3179] = 3123,
  [3180] = 3128,
  [3181] = 3123,
  [3182] = 3128,
  [3183] = 3123,
  [3184] = 3128,
  [3185] = 3128,
  [3186] = 3128,
  [3187] = 3137,
  [3188] = 3137,
  [3189] = 3128,
  [3190] = 3130,
  [3191] = 3137,
  [3192] = 3137,
  [3193] = 3133,
  [3194] = 3128,
  [3195] = 3130,
  [3196] = 3137,
  [3197] = 3133,
  [3198] = 3123,
  [3199] = 3130,
  [3200] = 3130,
  [3201] = 3133,
  [3202] = 3133,
  [3203] = 3130,
  [3204] = 3128,
  [3205] = 3130,
  [3206] = 3137,
  [3207] = 3123,
  [3208] = 3137,
  [3209] = 3137,
  [3210] = 3133,
  [3211] = 3133,
  [3212] = 3128,
  [3213] = 3130,
  [3214] = 3133,
  [3215] = 3123,
  [3216] = 3133,
  [3217] = 3128,
  [3218] = 3133,
  [3219] = 3123,
  [3220] = 3128,
  [3221] = 3133,
  [3222] = 3130,
  [3223] = 3137,
  [3224] = 3123,
  [3225] = 3123,
  [3226] = 3130,
  [3227] = 3130,
  [3228] = 3137,
  [3229] = 3130,
  [3230] = 3128,
  [3231] = 3123,
  [3232] = 3137,
  [3233] = 3130,
  [3234] = 3123,
  [3235] = 3123,
  [3236] = 3137,
  [3237] = 3128,
  [3238] = 3123,
  [3239] = 3128,
  [3240] = 3128,
  [3241] = 3128,
  [3242] = 3123,
  [3243] = 3133,
  [3244] = 3137,
  [3245] = 3128,
  [3246] = 3133,
  [3247] = 3130,
  [3248] = 3128,
  [3249] = 3128,
  [3250] = 3123,
  [3251] = 3128,
  [3252] = 3128,
  [3253] = 3123,
  [3254] = 3123,
  [3255] = 3137,
  [3256] = 3128,
  [3257] = 3128,
  [3258] = 3123,
  [3259] = 3133,
  [3260] = 3137,
  [3261] = 3123,
  [3262] = 3133,
  [3263] = 3137,
  [3264] = 3128,
  [3265] = 3128,
  [3266] = 3133,
  [3267] = 3123,
  [3268] = 3137,
  [3269] = 3128,
  [3270] = 3123,
  [3271] = 3133,
  [3272] = 3137,
  [3273] = 3137,
  [3274] = 3133,
  [3275] = 3130,
  [3276] = 3133,
  [3277] = 3123,
  [3278] = 3133,
  [3279] = 3133,
  [3280] = 3123,
  [3281] = 3130,
  [3282] = 3123,
  [3283] = 3128,
  [3284] = 3128,
  [3285] = 3133,
  [3286] = 3137,
  [3287] = 3133,
  [3288] = 3133,
  [3289] = 3137,
  [3290] = 3137,
  [3291] = 3130,
  [3292] = 3128,
  [3293] = 3137,
  [3294] = 3123,
  [3295] = 3133,
  [3296] = 3137,
  [3297] = 3137,
  [3298] = 3137,
  [3299] = 3130,
  [3300] = 3133,
  [3301] = 3133,
  [3302] = 3130,
  [3303] = 3123,
  [3304] = 3128,
  [3305] = 3137,
  [3306] = 3133,
  [3307] = 3130,
  [3308] = 3130,
  [3309] = 3130,
  [3310] = 3137,
  [3311] = 3133,
  [3312] = 3128,
  [3313] = 3133,
  [3314] = 3123,
  [3315] = 3123,
  [3316] = 3133,
  [3317] = 3123,
  [3318] = 3128,
  [3319] = 3130,
  [3320] = 3123,
  [3321] = 3137,
  [3322] = 3128,
  [3323] = 3123,
  [3324] = 3123,
  [3325] = 3137,
  [3326] = 3133,
  [3327] = 3130,
  [3328] = 3123,
  [3329] = 3137,
  [3330] = 3137,
  [3331] = 3133,
  [3332] = 3137,
  [3333] = 3123,
  [3334] = 3128,
  [3335] = 3123,
  [3336] = 3128,
  [3337] = 3133,
  [3338] = 3128,
  [3339] = 3133,
  [3340] = 3137,
  [3341] = 3128,
  [3342] = 3137,
  [3343] = 3133,
  [3344] = 3133,
  [3345] = 3137,
  [3346] = 3123,
  [3347] = 3123,
  [3348] = 3348,
  [3349] = 3349,
  [3350] = 3350,
  [3351] = 3351,
  [3352] = 3352,
  [3353] = 3351,
  [3354] = 3349,
  [3355] = 3350,
  [3356] = 3349,
  [3357] = 3351,
  [3358] = 3352,
  [3359] = 3359,
  [3360] = 3348,
  [3361] = 3359,
  [3362] = 3350,
  [3363] = 3359,
  [3364] = 3364,
  [3365] = 3348,
  [3366] = 3359,
  [3367] = 3352,
  [3368] = 3352,
  [3369] = 3359,
  [3370] = 3352,
  [3371] = 3359,
  [3372] = 3349,
  [3373] = 3348,
  [3374] = 3364,
  [3375] = 3351,
  [3376] = 3359,
  [3377] = 3351,
  [3378] = 3351,
  [3379] = 3348,
  [3380] = 3349,
  [3381] = 3349,
  [3382] = 3359,
  [3383] = 3350,
  [3384] = 3348,
  [3385] = 3349,
  [3386] = 3351,
  [3387] = 3364,
  [3388] = 3348,
  [3389] = 3350,
  [3390] = 3351,
  [3391] = 3359,
  [3392] = 3359,
  [3393] = 3364,
  [3394] = 3351,
  [3395] = 3348,
  [3396] = 3348,
  [3397] = 3350,
  [3398] = 3350,
  [3399] = 3352,
  [3400] = 3350,
  [3401] = 3352,
  [3402] = 3350,
  [3403] = 3352,
  [3404] = 3364,
  [3405] = 3352,
  [3406] = 3352,
  [3407] = 3350,
  [3408] = 3348,
  [3409] = 3350,
  [3410] = 3351,
  [3411] = 3350,
  [3412] = 3351,
  [3413] = 3348,
  [3414] = 3352,
  [3415] = 3350,
  [3416] = 3364,
  [3417] = 3348,
  [3418] = 3350,
  [3419] = 3352,
  [3420] = 3352,
  [3421] = 3352,
  [3422] = 3348,
  [3423] = 3351,
  [3424] = 3350,
  [3425] = 3359,
  [3426] = 3351,
  [3427] = 3364,
  [3428] = 3428,
  [3429] = 3364,
  [3430] = 3359,
  [3431] = 3348,
  [3432] = 3359,
  [3433] = 3349,
  [3434] = 3351,
  [3435] = 3349,
  [3436] = 3351,
  [3437] = 3352,
  [3438] = 3350,
  [3439] = 3351,
  [3440] = 3352,
  [3441] = 3352,
  [3442] = 3350,
  [3443] = 3348,
  [3444] = 3351,
  [3445] = 3350,
  [3446] = 3364,
  [3447] = 3349,
  [3448] = 3352,
  [3449] = 3359,
  [3450] = 3351,
  [3451] = 3349,
  [3452] = 3350,
  [3453] = 3348,
  [3454] = 3348,
  [3455] = 3359,
  [3456] = 3359,
  [3457] = 3351,
  [3458] = 3351,
  [3459] = 3352,
  [3460] = 3348,
  [3461] = 3348,
  [3462] = 3350,
  [3463] = 3349,
  [3464] = 3352,
  [3465] = 3350,
  [3466] = 3352,
  [3467] = 3350,
  [3468] = 3348,
  [3469] = 3359,
  [3470] = 3348,
  [3471] = 3364,
  [3472] = 3352,
  [3473] = 3351,
  [3474] = 3428,
  [3475] = 3350,
  [3476] = 3349,
  [3477] = 3364,
  [3478] = 3359,
  [3479] = 3348,
  [3480] = 3351,
  [3481] = 3359,
  [3482] = 3364,
  [3483] = 3351,
  [3484] = 3359,
  [3485] = 3364,
  [3486] = 3359,
  [3487] = 3359,
  [3488] = 3349,
  [3489] = 3352,
  [3490] = 3359,
  [3491] = 3350,
  [3492] = 3348,
  [3493] = 3350,
  [3494] = 3494,
  [3495] = 3495,
  [3496] = 3496,
  [3497] = 3351,
  [3498] = 3364,
  [3499] = 3348,
  [3500] = 3352,
  [3501] = 3350,
  [3502] = 3359,
  [3503] = 3359,
  [3504] = 3504,
  [3505] = 3505,
  [3506] = 3506,
  [3507] = 3364,
  [3508] = 3359,
  [3509] = 3351,
  [3510] = 3352,
  [3511] = 3348,
  [3512] = 3359,
  [3513] = 3359,
  [3514] = 3359,
  [3515] = 3359,
  [3516] = 3352,
  [3517] = 3359,
  [3518] = 3351,
  [3519] = 3350,
  [3520] = 3359,
  [3521] = 3348,
  [3522] = 3348,
  [3523] = 3351,
  [3524] = 3348,
  [3525] = 3351,
  [3526] = 3350,
  [3527] = 3350,
  [3528] = 3349,
  [3529] = 3348,
  [3530] = 3350,
  [3531] = 3351,
  [3532] = 3350,
  [3533] = 3352,
  [3534] = 3352,
  [3535] = 3348,
  [3536] = 3350,
  [3537] = 3348,
  [3538] = 3351,
  [3539] = 3351,
  [3540] = 3352,
  [3541] = 3348,
  [3542] = 3349,
  [3543] = 3359,
  [3544] = 3544,
  [3545] = 3351,
  [3546] = 3364,
  [3547] = 3348,
  [3548] = 3350,
  [3549] = 3549,
  [3550] = 3428,
  [3551] = 3349,
  [3552] = 3352,
  [3553] = 3364,
  [3554] = 3364,
  [3555] = 3351,
  [3556] = 3352,
  [3557] = 3351,
  [3558] = 3348,
  [3559] = 3352,
  [3560] = 3349,
  [3561] = 3364,
  [3562] = 3351,
  [3563] = 3349,
  [3564] = 3352,
  [3565] = 3350,
  [3566] = 3351,
  [3567] = 3364,
  [3568] = 3348,
  [3569] = 3351,
  [3570] = 3350,
  [3571] = 3351,
  [3572] = 3348,
  [3573] = 3349,
  [3574] = 3350,
  [3575] = 3359,
  [3576] = 3349,
  [3577] = 3348,
  [3578] = 3359,
  [3579] = 3350,
  [3580] = 3348,
  [3581] = 3351,
  [3582] = 3352,
  [3583] = 3350,
  [3584] = 3348,
  [3585] = 3352,
  [3586] = 3352,
  [3587] = 3359,
  [3588] = 3364,
  [3589] = 3359,
  [3590] = 3350,
  [3591] = 3591,
  [3592] = 3364,
  [3593] = 3359,
  [3594] = 3349,
  [3595] = 3352,
  [3596] = 3364,
  [3597] = 3352,
  [3598] = 3349,
  [3599] = 3359,
  [3600] = 3351,
  [3601] = 3348,
  [3602] = 3350,
  [3603] = 3349,
  [3604] = 3350,
  [3605] = 3348,
  [3606] = 3351,
  [3607] = 3352,
  [3608] = 3352,
  [3609] = 3350,
  [3610] = 3364,
  [3611] = 3364,
  [3612] = 3352,
  [3613] = 3359,
  [3614] = 3351,
  [3615] = 3351,
  [3616] = 3359,
  [3617] = 3428,
  [3618] = 3351,
  [3619] = 3348,
  [3620] = 3350,
  [3621] = 3359,
  [3622] = 3352,
  [3623] = 3348,
  [3624] = 3351,
  [3625] = 3348,
  [3626] = 3350,
  [3627] = 3352,
  [3628] = 3348,
  [3629] = 3544,
  [3630] = 3350,
  [3631] = 3352,
  [3632] = 3352,
  [3633] = 3359,
  [3634] = 3352,
  [3635] = 3348,
  [3636] = 3359,
  [3637] = 3364,
  [3638] = 3352,
  [3639] = 3549,
  [3640] = 3352,
  [3641] = 3350,
  [3642] = 3350,
  [3643] = 3352,
  [3644] = 3348,
  [3645] = 3350,
  [3646] = 3350,
  [3647] = 3348,
  [3648] = 3359,
  [3649] = 3348,
  [3650] = 3351,
  [3651] = 3351,
  [3652] = 3359,
  [3653] = 3364,
  [3654] = 3348,
  [3655] = 3351,
  [3656] = 3349,
  [3657] = 3351,
  [3658] = 3359,
  [3659] = 3348,
  [3660] = 3359,
  [3661] = 3359,
  [3662] = 3359,
  [3663] = 3352,
  [3664] = 3350,
  [3665] = 3349,
  [3666] = 3352,
  [3667] = 3359,
  [3668] = 3359,
  [3669] = 3364,
  [3670] = 3359,
  [3671] = 3350,
  [3672] = 3359,
  [3673] = 3352,
  [3674] = 3350,
  [3675] = 3348,
  [3676] = 3351,
  [3677] = 3348,
  [3678] = 3351,
  [3679] = 3351,
  [3680] = 3364,
  [3681] = 3351,
  [3682] = 3349,
  [3683] = 3350,
  [3684] = 3349,
  [3685] = 3349,
  [3686] = 3351,
  [3687] = 3352,
  [3688] = 3364,
  [3689] = 3351,
  [3690] = 3349,
  [3691] = 3359,
  [3692] = 3351,
  [3693] = 3359,
  [3694] = 3348,
  [3695] = 3350,
  [3696] = 3352,
  [3697] = 3352,
  [3698] = 3348,
  [3699] = 3348,
  [3700] = 3352,
  [3701] = 3364,
  [3702] = 3350,
  [3703] = 3359,
  [3704] = 3350,
  [3705] = 3705,
  [3706] = 3705,
  [3707] = 3705,
  [3708] = 3705,
  [3709] = 3705,
  [3710] = 3705,
  [3711] = 3705,
  [3712] = 3705,
  [3713] = 3705,
  [3714] = 3705,
  [3715] = 3705,
  [3716] = 3705,
  [3717] = 3705,
  [3718] = 3705,
  [3719] = 3705,
  [3720] = 3705,
  [3721] = 3705,
  [3722] = 3705,
  [3723] = 3549,
  [3724] = 3705,
  [3725] = 3705,
  [3726] = 3705,
  [3727] = 3705,
  [3728] = 3705,
  [3729] = 3705,
  [3730] = 3705,
  [3731] = 3705,
  [3732] = 3705,
  [3733] = 3705,
  [3734] = 3705,
  [3735] = 3705,
  [3736] = 3705,
  [3737] = 3705,
  [3738] = 3705,
  [3739] = 3705,
  [3740] = 3705,
  [3741] = 3705,
  [3742] = 3705,
  [3743] = 3705,
  [3744] = 3705,
  [3745] = 3705,
  [3746] = 3705,
  [3747] = 3705,
  [3748] = 3705,
  [3749] = 3705,
  [3750] = 3705,
  [3751] = 3705,
  [3752] = 3705,
  [3753] = 3705,
  [3754] = 3705,
  [3755] = 3755,
  [3756] = 3705,
  [3757] = 3705,
  [3758] = 3705,
  [3759] = 3705,
  [3760] = 3705,
  [3761] = 3705,
  [3762] = 3705,
  [3763] = 3705,
  [3764] = 3764,
  [3765] = 3765,
  [3766] = 3765,
  [3767] = 3764,
  [3768] = 3764,
  [3769] = 3764,
  [3770] = 3765,
  [3771] = 3764,
  [3772] = 3764,
  [3773] = 3764,
  [3774] = 3765,
  [3775] = 3764,
  [3776] = 3764,
  [3777] = 3765,
  [3778] = 3765,
  [3779] = 3765,
  [3780] = 3764,
  [3781] = 3764,
  [3782] = 3764,
  [3783] = 3764,
  [3784] = 3765,
  [3785] = 3764,
  [3786] = 3764,
  [3787] = 3755,
  [3788] = 3765,
  [3789] = 3765,
  [3790] = 3765,
  [3791] = 3765,
  [3792] = 3765,
  [3793] = 3764,
  [3794] = 3765,
  [3795] = 3764,
  [3796] = 3764,
  [3797] = 3764,
  [3798] = 3765,
  [3799] = 3765,
  [3800] = 3764,
  [3801] = 3764,
  [3802] = 3764,
  [3803] = 3764,
  [3804] = 3764,
  [3805] = 3765,
  [3806] = 3765,
  [3807] = 3764,
  [3808] = 3765,
  [3809] = 3765,
  [3810] = 3764,
  [3811] = 3764,
  [3812] = 3765,
  [3813] = 3764,
  [3814] = 3764,
  [3815] = 3765,
  [3816] = 3765,
  [3817] = 3764,
  [3818] = 3764,
  [3819] = 3765,
  [3820] = 3755,
  [3821] = 3765,
  [3822] = 3765,
  [3823] = 3764,
  [3824] = 3765,
  [3825] = 3764,
  [3826] = 3764,
  [3827] = 3765,
  [3828] = 3764,
  [3829] = 3764,
  [3830] = 3764,
  [3831] = 3765,
  [3832] = 3765,
  [3833] = 3765,
  [3834] = 3764,
  [3835] = 3765,
  [3836] = 3765,
  [3837] = 3764,
  [3838] = 3764,
  [3839] = 3765,
  [3840] = 3765,
  [3841] = 3765,
  [3842] = 3764,
  [3843] = 3765,
  [3844] = 3764,
  [3845] = 3765,
  [3846] = 3764,
  [3847] = 3764,
  [3848] = 3764,
  [3849] = 3764,
  [3850] = 3764,
  [3851] = 3755,
  [3852] = 3765,
  [3853] = 3755,
  [3854] = 3764,
  [3855] = 3764,
  [3856] = 3765,
  [3857] = 3764,
  [3858] = 3765,
  [3859] = 3764,
  [3860] = 3765,
  [3861] = 3765,
  [3862] = 3765,
  [3863] = 3765,
  [3864] = 3764,
  [3865] = 3765,
  [3866] = 3765,
  [3867] = 3765,
  [3868] = 3765,
  [3869] = 3765,
  [3870] = 3765,
  [3871] = 3764,
  [3872] = 3765,
  [3873] = 3873,
  [3874] = 3764,
  [3875] = 3764,
  [3876] = 3764,
  [3877] = 3765,
  [3878] = 3764,
  [3879] = 3765,
  [3880] = 3765,
  [3881] = 3765,
  [3882] = 3765,
  [3883] = 3755,
  [3884] = 3755,
  [3885] = 3755,
  [3886] = 3755,
  [3887] = 3887,
  [3888] = 3887,
  [3889] = 3755,
  [3890] = 3755,
  [3891] = 3887,
  [3892] = 3887,
  [3893] = 3755,
  [3894] = 3755,
  [3895] = 3755,
  [3896] = 3755,
  [3897] = 3755,
  [3898] = 3755,
  [3899] = 3755,
  [3900] = 3755,
  [3901] = 3755,
  [3902] = 3755,
  [3903] = 3755,
  [3904] = 3755,
  [3905] = 3755,
  [3906] = 3755,
  [3907] = 3755,
  [3908] = 3755,
  [3909] = 3755,
  [3910] = 3755,
  [3911] = 3755,
  [3912] = 3755,
  [3913] = 3755,
  [3914] = 3755,
  [3915] = 3755,
  [3916] = 3755,
  [3917] = 3755,
  [3918] = 3755,
  [3919] = 3755,
  [3920] = 3755,
  [3921] = 3755,
  [3922] = 3755,
  [3923] = 3755,
  [3924] = 3755,
  [3925] = 3755,
  [3926] = 3755,
  [3927] = 3755,
  [3928] = 3755,
  [3929] = 3755,
  [3930] = 3755,
  [3931] = 3755,
  [3932] = 3755,
  [3933] = 3755,
  [3934] = 3755,
  [3935] = 3755,
  [3936] = 3755,
  [3937] = 3755,
  [3938] = 3755,
  [3939] = 3755,
  [3940] = 3755,
  [3941] = 3755,
  [3942] = 3755,
  [3943] = 3755,
  [3944] = 3755,
  [3945] = 3755,
  [3946] = 3755,
  [3947] = 3755,
  [3948] = 3755,
  [3949] = 3755,
  [3950] = 3755,
  [3951] = 3755,
  [3952] = 3755,
  [3953] = 3755,
  [3954] = 3755,
  [3955] = 3755,
  [3956] = 3755,
  [3957] = 3755,
  [3958] = 3755,
  [3959] = 3755,
  [3960] = 3755,
  [3961] = 3755,
  [3962] = 3755,
  [3963] = 3755,
  [3964] = 3755,
  [3965] = 3755,
  [3966] = 3755,
  [3967] = 3755,
  [3968] = 3755,
  [3969] = 3755,
  [3970] = 3755,
  [3971] = 3755,
  [3972] = 3755,
  [3973] = 3755,
  [3974] = 3755,
  [3975] = 3755,
  [3976] = 3755,
  [3977] = 3755,
  [3978] = 3755,
  [3979] = 3755,
  [3980] = 3755,
  [3981] = 3755,
  [3982] = 3982,
  [3983] = 3755,
  [3984] = 3755,
  [3985] = 3755,
  [3986] = 3755,
  [3987] = 3755,
  [3988] = 3755,
  [3989] = 3755,
  [3990] = 3755,
  [3991] = 3755,
  [3992] = 3755,
  [3993] = 3982,
  [3994] = 3994,
  [3995] = 3755,
  [3996] = 3755,
  [3997] = 3755,
  [3998] = 3755,
  [3999] = 3755,
  [4000] = 3755,
  [4001] = 3755,
  [4002] = 3755,
  [4003] = 4003,
  [4004] = 3982,
  [4005] = 3755,
  [4006] = 3755,
  [4007] = 3755,
  [4008] = 3755,
  [4009] = 4009,
  [4010] = 3994,
  [4011] = 3982,
  [4012] = 4012,
  [4013] = 3755,
  [4014] = 4014,
  [4015] = 4015,
  [4016] = 4016,
  [4017] = 4003,
  [4018] = 4003,
  [4019] = 4019,
  [4020] = 4020,
  [4021] = 3982,
  [4022] = 3755,
  [4023] = 3755,
  [4024] = 4024,
  [4025] = 4025,
  [4026] = 4026,
  [4027] = 3994,
  [4028] = 3994,
  [4029] = 3982,
  [4030] = 3994,
  [4031] = 3755,
  [4032] = 4032,
  [4033] = 4033,
  [4034] = 4034,
  [4035] = 4003,
  [4036] = 4036,
  [4037] = 4037,
  [4038] = 4038,
  [4039] = 3982,
  [4040] = 3994,
  [4041] = 4026,
  [4042] = 3755,
  [4043] = 4036,
  [4044] = 4032,
  [4045] = 4024,
  [4046] = 4003,
  [4047] = 4014,
  [4048] = 3755,
  [4049] = 4012,
  [4050] = 4050,
  [4051] = 3755,
  [4052] = 4012,
  [4053] = 4032,
  [4054] = 4014,
  [4055] = 4036,
  [4056] = 4014,
  [4057] = 4057,
  [4058] = 4014,
  [4059] = 3755,
  [4060] = 3982,
  [4061] = 4009,
  [4062] = 4034,
  [4063] = 4037,
  [4064] = 4064,
  [4065] = 4003,
  [4066] = 4015,
  [4067] = 4067,
  [4068] = 4025,
  [4069] = 4034,
  [4070] = 4012,
  [4071] = 3994,
  [4072] = 4003,
  [4073] = 4032,
  [4074] = 4026,
  [4075] = 3994,
  [4076] = 4036,
  [4077] = 4003,
  [4078] = 4037,
  [4079] = 4009,
  [4080] = 4034,
  [4081] = 4009,
  [4082] = 4020,
  [4083] = 4037,
  [4084] = 3982,
  [4085] = 4015,
  [4086] = 4024,
  [4087] = 3994,
  [4088] = 3982,
  [4089] = 4033,
  [4090] = 4026,
  [4091] = 4025,
  [4092] = 4024,
  [4093] = 3982,
  [4094] = 4026,
  [4095] = 4020,
  [4096] = 3994,
  [4097] = 4015,
  [4098] = 4019,
  [4099] = 4016,
  [4100] = 4015,
  [4101] = 3994,
  [4102] = 4019,
  [4103] = 4012,
  [4104] = 4016,
  [4105] = 4033,
  [4106] = 4019,
  [4107] = 4033,
  [4108] = 4032,
  [4109] = 4036,
  [4110] = 4009,
  [4111] = 4020,
  [4112] = 4034,
  [4113] = 4037,
  [4114] = 4016,
  [4115] = 4025,
  [4116] = 4024,
  [4117] = 4020,
  [4118] = 4019,
  [4119] = 4016,
  [4120] = 3994,
  [4121] = 3982,
  [4122] = 4025,
  [4123] = 4033,
  [4124] = 3755,
  [4125] = 4020,
  [4126] = 4034,
  [4127] = 4037,
  [4128] = 4016,
  [4129] = 4025,
  [4130] = 4024,
  [4131] = 4020,
  [4132] = 4019,
  [4133] = 4016,
  [4134] = 4019,
  [4135] = 4020,
  [4136] = 4024,
  [4137] = 4025,
  [4138] = 4033,
  [4139] = 4037,
  [4140] = 3994,
  [4141] = 4026,
  [4142] = 4015,
  [4143] = 4026,
  [4144] = 4034,
  [4145] = 4009,
  [4146] = 4015,
  [4147] = 3994,
  [4148] = 3994,
  [4149] = 3982,
  [4150] = 4036,
  [4151] = 4032,
  [4152] = 4033,
  [4153] = 4012,
  [4154] = 4014,
  [4155] = 4036,
  [4156] = 4003,
  [4157] = 4003,
  [4158] = 4032,
  [4159] = 3994,
  [4160] = 4015,
  [4161] = 3994,
  [4162] = 4012,
  [4163] = 4016,
  [4164] = 4003,
  [4165] = 4019,
  [4166] = 4020,
  [4167] = 4024,
  [4168] = 4025,
  [4169] = 4026,
  [4170] = 3982,
  [4171] = 4037,
  [4172] = 4034,
  [4173] = 4033,
  [4174] = 4033,
  [4175] = 4009,
  [4176] = 4036,
  [4177] = 4012,
  [4178] = 4032,
  [4179] = 3755,
  [4180] = 4032,
  [4181] = 4014,
  [4182] = 4036,
  [4183] = 4009,
  [4184] = 4032,
  [4185] = 4009,
  [4186] = 4003,
  [4187] = 3982,
  [4188] = 4034,
  [4189] = 4014,
  [4190] = 4037,
  [4191] = 4024,
  [4192] = 4012,
  [4193] = 4025,
  [4194] = 4024,
  [4195] = 4009,
  [4196] = 4019,
  [4197] = 4016,
  [4198] = 4016,
  [4199] = 4019,
  [4200] = 4020,
  [4201] = 4024,
  [4202] = 3994,
  [4203] = 4025,
  [4204] = 4026,
  [4205] = 4015,
  [4206] = 4012,
  [4207] = 4037,
  [4208] = 3755,
  [4209] = 4034,
  [4210] = 4009,
  [4211] = 3982,
  [4212] = 4036,
  [4213] = 4015,
  [4214] = 4032,
  [4215] = 3994,
  [4216] = 4014,
  [4217] = 4026,
  [4218] = 4012,
  [4219] = 4026,
  [4220] = 4015,
  [4221] = 4025,
  [4222] = 4036,
  [4223] = 3994,
  [4224] = 4033,
  [4225] = 4015,
  [4226] = 4014,
  [4227] = 4014,
  [4228] = 4050,
  [4229] = 4016,
  [4230] = 4019,
  [4231] = 4026,
  [4232] = 4020,
  [4233] = 4034,
  [4234] = 4024,
  [4235] = 4037,
  [4236] = 4034,
  [4237] = 4016,
  [4238] = 4033,
  [4239] = 4019,
  [4240] = 4037,
  [4241] = 4033,
  [4242] = 3755,
  [4243] = 4014,
  [4244] = 4020,
  [4245] = 4067,
  [4246] = 4025,
  [4247] = 4050,
  [4248] = 4009,
  [4249] = 3994,
  [4250] = 4036,
  [4251] = 3755,
  [4252] = 4067,
  [4253] = 4032,
  [4254] = 4012,
  [4255] = 4014,
  [4256] = 4033,
  [4257] = 4033,
  [4258] = 4258,
  [4259] = 4033,
  [4260] = 4014,
  [4261] = 4014,
  [4262] = 4262,
  [4263] = 4012,
  [4264] = 4032,
  [4265] = 4036,
  [4266] = 4009,
  [4267] = 4015,
  [4268] = 4036,
  [4269] = 4037,
  [4270] = 4020,
  [4271] = 4014,
  [4272] = 4025,
  [4273] = 4012,
  [4274] = 3994,
  [4275] = 3994,
  [4276] = 4024,
  [4277] = 3755,
  [4278] = 4014,
  [4279] = 4020,
  [4280] = 4019,
  [4281] = 4033,
  [4282] = 4012,
  [4283] = 3994,
  [4284] = 4032,
  [4285] = 4012,
  [4286] = 4009,
  [4287] = 4034,
  [4288] = 4037,
  [4289] = 4016,
  [4290] = 4025,
  [4291] = 4015,
  [4292] = 4024,
  [4293] = 4032,
  [4294] = 4020,
  [4295] = 4036,
  [4296] = 4019,
  [4297] = 3755,
  [4298] = 4016,
  [4299] = 4009,
  [4300] = 4034,
  [4301] = 4037,
  [4302] = 4025,
  [4303] = 4024,
  [4304] = 4020,
  [4305] = 4019,
  [4306] = 4016,
  [4307] = 4012,
  [4308] = 3755,
  [4309] = 4026,
  [4310] = 3982,
  [4311] = 4032,
  [4312] = 4032,
  [4313] = 4036,
  [4314] = 4009,
  [4315] = 3755,
  [4316] = 4034,
  [4317] = 4037,
  [4318] = 4015,
  [4319] = 4025,
  [4320] = 4024,
  [4321] = 4020,
  [4322] = 4019,
  [4323] = 4016,
  [4324] = 4009,
  [4325] = 3994,
  [4326] = 4024,
  [4327] = 4012,
  [4328] = 4036,
  [4329] = 4034,
  [4330] = 4037,
  [4331] = 4016,
  [4332] = 4019,
  [4333] = 4025,
  [4334] = 4024,
  [4335] = 4026,
  [4336] = 4025,
  [4337] = 4037,
  [4338] = 4034,
  [4339] = 4009,
  [4340] = 4036,
  [4341] = 4032,
  [4342] = 4032,
  [4343] = 4036,
  [4344] = 3982,
  [4345] = 4009,
  [4346] = 4034,
  [4347] = 4037,
  [4348] = 4015,
  [4349] = 4012,
  [4350] = 4033,
  [4351] = 4020,
  [4352] = 4025,
  [4353] = 4019,
  [4354] = 4024,
  [4355] = 3982,
  [4356] = 4003,
  [4357] = 4026,
  [4358] = 3994,
  [4359] = 4020,
  [4360] = 4003,
  [4361] = 4026,
  [4362] = 4026,
  [4363] = 3994,
  [4364] = 4015,
  [4365] = 4014,
  [4366] = 4014,
  [4367] = 4016,
  [4368] = 4019,
  [4369] = 4015,
  [4370] = 4020,
  [4371] = 4014,
  [4372] = 4024,
  [4373] = 4033,
  [4374] = 4025,
  [4375] = 3994,
  [4376] = 4037,
  [4377] = 4034,
  [4378] = 4009,
  [4379] = 4019,
  [4380] = 3982,
  [4381] = 4036,
  [4382] = 4032,
  [4383] = 4016,
  [4384] = 4016,
  [4385] = 4012,
  [4386] = 4003,
  [4387] = 4016,
  [4388] = 3994,
  [4389] = 4019,
  [4390] = 4026,
  [4391] = 4020,
  [4392] = 4024,
  [4393] = 4025,
  [4394] = 4037,
  [4395] = 3982,
  [4396] = 4034,
  [4397] = 3982,
  [4398] = 4009,
  [4399] = 4036,
  [4400] = 4032,
  [4401] = 4026,
  [4402] = 4034,
  [4403] = 4012,
  [4404] = 4026,
  [4405] = 4015,
  [4406] = 3994,
  [4407] = 4033,
  [4408] = 4014,
  [4409] = 3994,
  [4410] = 4003,
  [4411] = 3982,
  [4412] = 4033,
  [4413] = 4033,
  [4414] = 4026,
  [4415] = 4015,
  [4416] = 3994,
  [4417] = 4015,
  [4418] = 4009,
  [4419] = 4033,
  [4420] = 3755,
  [4421] = 4014,
  [4422] = 3982,
  [4423] = 4003,
  [4424] = 3982,
  [4425] = 4033,
  [4426] = 3982,
  [4427] = 4024,
  [4428] = 4015,
  [4429] = 4003,
  [4430] = 4033,
  [4431] = 3994,
  [4432] = 3994,
  [4433] = 4003,
  [4434] = 4015,
  [4435] = 4014,
  [4436] = 4026,
  [4437] = 4026,
  [4438] = 3755,
  [4439] = 3994,
  [4440] = 4016,
  [4441] = 4019,
  [4442] = 4016,
  [4443] = 4019,
  [4444] = 4020,
  [4445] = 4024,
  [4446] = 4025,
  [4447] = 4015,
  [4448] = 4037,
  [4449] = 4034,
  [4450] = 4020,
  [4451] = 4009,
  [4452] = 4036,
  [4453] = 4032,
  [4454] = 4026,
  [4455] = 4012,
  [4456] = 4025,
  [4457] = 4037,
  [4458] = 4034,
  [4459] = 4012,
  [4460] = 4003,
  [4461] = 4036,
  [4462] = 4033,
  [4463] = 4012,
  [4464] = 4032,
  [4465] = 3982,
  [4466] = 4003,
  [4467] = 4032,
  [4468] = 4009,
  [4469] = 4032,
  [4470] = 3994,
  [4471] = 4036,
  [4472] = 3982,
  [4473] = 4012,
  [4474] = 3994,
  [4475] = 4016,
  [4476] = 4019,
  [4477] = 4020,
  [4478] = 4009,
  [4479] = 4024,
  [4480] = 4025,
  [4481] = 4015,
  [4482] = 4037,
  [4483] = 4003,
  [4484] = 4034,
  [4485] = 3994,
  [4486] = 4034,
  [4487] = 4037,
  [4488] = 4014,
  [4489] = 4009,
  [4490] = 4025,
  [4491] = 4024,
  [4492] = 4036,
  [4493] = 4032,
  [4494] = 4026,
  [4495] = 4020,
  [4496] = 4012,
  [4497] = 4019,
  [4498] = 3755,
  [4499] = 3994,
  [4500] = 4036,
  [4501] = 4009,
  [4502] = 4034,
  [4503] = 4037,
  [4504] = 4025,
  [4505] = 4024,
  [4506] = 4014,
  [4507] = 4016,
  [4508] = 4020,
  [4509] = 4019,
  [4510] = 4016,
  [4511] = 4016,
  [4512] = 4019,
  [4513] = 4020,
  [4514] = 4024,
  [4515] = 4025,
  [4516] = 4037,
  [4517] = 4034,
  [4518] = 4014,
  [4519] = 3755,
  [4520] = 3982,
  [4521] = 4036,
  [4522] = 4032,
  [4523] = 4012,
  [4524] = 4026,
  [4525] = 3982,
  [4526] = 4015,
  [4527] = 4012,
  [4528] = 3982,
  [4529] = 4014,
  [4530] = 3994,
  [4531] = 4012,
  [4532] = 4014,
  [4533] = 4032,
  [4534] = 4036,
  [4535] = 4009,
  [4536] = 4032,
  [4537] = 4034,
  [4538] = 4036,
  [4539] = 4037,
  [4540] = 4025,
  [4541] = 4024,
  [4542] = 4020,
  [4543] = 4019,
  [4544] = 4016,
  [4545] = 4009,
  [4546] = 4034,
  [4547] = 4037,
  [4548] = 4025,
  [4549] = 4024,
  [4550] = 4020,
  [4551] = 4019,
  [4552] = 4016,
  [4553] = 4026,
  [4554] = 3755,
  [4555] = 3982,
  [4556] = 4015,
  [4557] = 4003,
  [4558] = 4026,
  [4559] = 4015,
  [4560] = 3994,
  [4561] = 4033,
  [4562] = 3994,
  [4563] = 3994,
  [4564] = 4032,
  [4565] = 4033,
  [4566] = 3982,
  [4567] = 4026,
  [4568] = 3755,
  [4569] = 4015,
  [4570] = 3755,
  [4571] = 4016,
  [4572] = 4262,
  [4573] = 4258,
  [4574] = 4003,
  [4575] = 4019,
  [4576] = 4020,
  [4577] = 4024,
  [4578] = 4025,
  [4579] = 4015,
  [4580] = 4037,
  [4581] = 4034,
  [4582] = 4009,
  [4583] = 4036,
  [4584] = 4012,
  [4585] = 4032,
  [4586] = 4036,
  [4587] = 4014,
  [4588] = 4009,
  [4589] = 4034,
  [4590] = 4033,
  [4591] = 4033,
  [4592] = 4037,
  [4593] = 4025,
  [4594] = 4024,
  [4595] = 4020,
  [4596] = 3982,
  [4597] = 4019,
  [4598] = 4016,
  [4599] = 4032,
  [4600] = 4014,
  [4601] = 4033,
  [4602] = 4026,
  [4603] = 4014,
  [4604] = 4026,
  [4605] = 4015,
  [4606] = 4033,
  [4607] = 3994,
  [4608] = 4012,
  [4609] = 4015,
  [4610] = 4026,
  [4611] = 4014,
  [4612] = 3994,
  [4613] = 4012,
  [4614] = 4016,
  [4615] = 4019,
  [4616] = 4020,
  [4617] = 4024,
  [4618] = 4025,
  [4619] = 4037,
  [4620] = 3994,
  [4621] = 4034,
  [4622] = 4033,
  [4623] = 4009,
  [4624] = 4036,
  [4625] = 4003,
  [4626] = 4025,
  [4627] = 4015,
  [4628] = 4026,
  [4629] = 4033,
  [4630] = 3994,
  [4631] = 4016,
  [4632] = 4019,
  [4633] = 4015,
  [4634] = 4026,
  [4635] = 4020,
  [4636] = 4024,
  [4637] = 4025,
  [4638] = 4037,
  [4639] = 4034,
  [4640] = 4009,
  [4641] = 4036,
  [4642] = 4032,
  [4643] = 4012,
  [4644] = 3755,
  [4645] = 3994,
  [4646] = 3755,
  [4647] = 4033,
  [4648] = 3755,
  [4649] = 4012,
  [4650] = 4032,
  [4651] = 4026,
  [4652] = 4036,
  [4653] = 4015,
  [4654] = 4009,
  [4655] = 4034,
  [4656] = 4037,
  [4657] = 4025,
  [4658] = 4024,
  [4659] = 4020,
  [4660] = 4019,
  [4661] = 4016,
  [4662] = 4032,
  [4663] = 3994,
  [4664] = 4014,
  [4665] = 4016,
  [4666] = 4019,
  [4667] = 4033,
  [4668] = 4020,
  [4669] = 4024,
  [4670] = 4025,
  [4671] = 4037,
  [4672] = 4034,
  [4673] = 4009,
  [4674] = 4036,
  [4675] = 4032,
  [4676] = 3755,
  [4677] = 4003,
  [4678] = 3994,
  [4679] = 4012,
  [4680] = 3755,
  [4681] = 4033,
  [4682] = 4012,
  [4683] = 3994,
  [4684] = 4014,
  [4685] = 4032,
  [4686] = 4036,
  [4687] = 4009,
  [4688] = 3755,
  [4689] = 4034,
  [4690] = 4016,
  [4691] = 4019,
  [4692] = 4037,
  [4693] = 4025,
  [4694] = 4024,
  [4695] = 4020,
  [4696] = 4020,
  [4697] = 4019,
  [4698] = 4016,
  [4699] = 4026,
  [4700] = 3994,
  [4701] = 3994,
  [4702] = 4024,
  [4703] = 4025,
  [4704] = 4015,
  [4705] = 3982,
  [4706] = 4015,
  [4707] = 4026,
  [4708] = 4026,
  [4709] = 3994,
  [4710] = 4037,
  [4711] = 4034,
  [4712] = 4014,
  [4713] = 4003,
  [4714] = 4015,
  [4715] = 4009,
  [4716] = 4036,
  [4717] = 4015,
  [4718] = 4014,
  [4719] = 4026,
  [4720] = 4033,
  [4721] = 4016,
  [4722] = 4019,
  [4723] = 4020,
  [4724] = 4024,
  [4725] = 4025,
  [4726] = 4037,
  [4727] = 4016,
  [4728] = 4012,
  [4729] = 4034,
  [4730] = 4009,
  [4731] = 4036,
  [4732] = 4032,
  [4733] = 4032,
  [4734] = 3994,
  [4735] = 4012,
  [4736] = 3982,
  [4737] = 4009,
  [4738] = 4003,
  [4739] = 4019,
  [4740] = 3755,
  [4741] = 4024,
  [4742] = 4012,
  [4743] = 3994,
  [4744] = 4020,
  [4745] = 3755,
  [4746] = 4036,
  [4747] = 4034,
  [4748] = 4024,
  [4749] = 4037,
  [4750] = 4025,
  [4751] = 4020,
  [4752] = 4019,
  [4753] = 4016,
  [4754] = 3994,
  [4755] = 4025,
  [4756] = 3982,
  [4757] = 4026,
  [4758] = 4037,
  [4759] = 4003,
  [4760] = 4015,
  [4761] = 4034,
  [4762] = 4009,
  [4763] = 4036,
  [4764] = 4003,
  [4765] = 4032,
  [4766] = 4012,
  [4767] = 4033,
  [4768] = 3994,
  [4769] = 4014,
  [4770] = 4033,
  [4771] = 4026,
  [4772] = 3982,
  [4773] = 4014,
  [4774] = 4033,
  [4775] = 4014,
  [4776] = 4003,
  [4777] = 3982,
  [4778] = 4003,
  [4779] = 3982,
  [4780] = 4014,
  [4781] = 4003,
  [4782] = 4003,
  [4783] = 4003,
  [4784] = 4012,
  [4785] = 4012,
  [4786] = 4014,
  [4787] = 4032,
  [4788] = 4036,
  [4789] = 3994,
  [4790] = 4009,
  [4791] = 3994,
  [4792] = 4034,
  [4793] = 4037,
  [4794] = 4025,
  [4795] = 4024,
  [4796] = 4003,
  [4797] = 4020,
  [4798] = 4003,
  [4799] = 4032,
  [4800] = 4019,
  [4801] = 4036,
  [4802] = 4016,
  [4803] = 4009,
  [4804] = 4034,
  [4805] = 4037,
  [4806] = 4025,
  [4807] = 4024,
  [4808] = 4020,
  [4809] = 4019,
  [4810] = 4016,
  [4811] = 4015,
  [4812] = 4032,
  [4813] = 3755,
  [4814] = 4026,
  [4815] = 3994,
  [4816] = 4015,
  [4817] = 3994,
  [4818] = 3755,
  [4819] = 4016,
  [4820] = 4019,
  [4821] = 4020,
  [4822] = 3994,
  [4823] = 3994,
  [4824] = 4026,
  [4825] = 3982,
  [4826] = 4015,
  [4827] = 4024,
  [4828] = 4025,
  [4829] = 3994,
  [4830] = 4037,
  [4831] = 4032,
  [4832] = 4009,
  [4833] = 4034,
  [4834] = 4009,
  [4835] = 3994,
  [4836] = 3994,
  [4837] = 4024,
  [4838] = 4036,
  [4839] = 4014,
  [4840] = 4012,
  [4841] = 4003,
  [4842] = 4033,
  [4843] = 4036,
  [4844] = 4036,
  [4845] = 3982,
  [4846] = 4016,
  [4847] = 4034,
  [4848] = 4009,
  [4849] = 4014,
  [4850] = 4037,
  [4851] = 4025,
  [4852] = 4034,
  [4853] = 4020,
  [4854] = 4019,
  [4855] = 4016,
  [4856] = 4033,
  [4857] = 4037,
  [4858] = 4012,
  [4859] = 4025,
  [4860] = 4032,
  [4861] = 4024,
  [4862] = 4009,
  [4863] = 4020,
  [4864] = 4019,
  [4865] = 3982,
  [4866] = 4016,
  [4867] = 4024,
  [4868] = 4012,
  [4869] = 4026,
  [4870] = 4012,
  [4871] = 4026,
  [4872] = 4015,
  [4873] = 4003,
  [4874] = 4036,
  [4875] = 3994,
  [4876] = 4003,
  [4877] = 4034,
  [4878] = 3982,
  [4879] = 3982,
  [4880] = 4037,
  [4881] = 4032,
  [4882] = 4036,
  [4883] = 4009,
  [4884] = 4015,
  [4885] = 4020,
  [4886] = 4019,
  [4887] = 4034,
  [4888] = 4037,
  [4889] = 4016,
  [4890] = 4033,
  [4891] = 3994,
  [4892] = 4015,
  [4893] = 3982,
  [4894] = 4026,
  [4895] = 4014,
  [4896] = 4012,
  [4897] = 4025,
  [4898] = 4032,
  [4899] = 4026,
  [4900] = 3982,
  [4901] = 4015,
  [4902] = 4033,
  [4903] = 4033,
  [4904] = 4003,
  [4905] = 4024,
  [4906] = 4020,
  [4907] = 4033,
  [4908] = 4014,
  [4909] = 4003,
  [4910] = 4033,
  [4911] = 3994,
  [4912] = 3755,
  [4913] = 4019,
  [4914] = 4014,
  [4915] = 3994,
  [4916] = 4014,
  [4917] = 3982,
  [4918] = 4033,
  [4919] = 4919,
  [4920] = 4012,
  [4921] = 4012,
  [4922] = 3994,
  [4923] = 4026,
  [4924] = 4014,
  [4925] = 4026,
  [4926] = 4016,
  [4927] = 4019,
  [4928] = 4020,
  [4929] = 4024,
  [4930] = 4025,
  [4931] = 4037,
  [4932] = 3755,
  [4933] = 4034,
  [4934] = 4032,
  [4935] = 4009,
  [4936] = 4036,
  [4937] = 4032,
  [4938] = 4036,
  [4939] = 4012,
  [4940] = 4009,
  [4941] = 4034,
  [4942] = 4919,
  [4943] = 3982,
  [4944] = 4037,
  [4945] = 4014,
  [4946] = 4016,
  [4947] = 4019,
  [4948] = 4020,
  [4949] = 4024,
  [4950] = 4025,
  [4951] = 4015,
  [4952] = 4037,
  [4953] = 4015,
  [4954] = 4034,
  [4955] = 4025,
  [4956] = 4919,
  [4957] = 4009,
  [4958] = 4919,
  [4959] = 4036,
  [4960] = 4032,
  [4961] = 4032,
  [4962] = 4919,
  [4963] = 4024,
  [4964] = 4003,
  [4965] = 4020,
  [4966] = 4012,
  [4967] = 4019,
  [4968] = 3994,
  [4969] = 4919,
  [4970] = 4016,
  [4971] = 3755,
  [4972] = 4014,
  [4973] = 4036,
  [4974] = 4009,
  [4975] = 3755,
  [4976] = 4034,
  [4977] = 4037,
  [4978] = 3982,
  [4979] = 4025,
  [4980] = 4012,
  [4981] = 4024,
  [4982] = 4026,
  [4983] = 4015,
  [4984] = 4020,
  [4985] = 4019,
  [4986] = 3994,
  [4987] = 4016,
  [4988] = 4919,
  [4989] = 4014,
  [4990] = 4036,
  [4991] = 4026,
  [4992] = 4003,
  [4993] = 3994,
  [4994] = 4919,
  [4995] = 4919,
  [4996] = 3755,
  [4997] = 4014,
  [4998] = 4015,
  [4999] = 4919,
  [5000] = 4012,
  [5001] = 4033,
  [5002] = 3994,
  [5003] = 4919,
  [5004] = 4033,
  [5005] = 4033,
  [5006] = 3994,
  [5007] = 4014,
  [5008] = 4014,
  [5009] = 4919,
  [5010] = 4015,
  [5011] = 4033,
  [5012] = 4014,
  [5013] = 4032,
  [5014] = 4036,
  [5015] = 4009,
  [5016] = 4003,
  [5017] = 4034,
  [5018] = 4014,
  [5019] = 4919,
  [5020] = 4026,
  [5021] = 4016,
  [5022] = 4037,
  [5023] = 4025,
  [5024] = 4024,
  [5025] = 4020,
  [5026] = 4019,
  [5027] = 4016,
  [5028] = 3994,
  [5029] = 4019,
  [5030] = 4020,
  [5031] = 4024,
  [5032] = 4037,
  [5033] = 4919,
  [5034] = 4919,
  [5035] = 4034,
  [5036] = 4009,
  [5037] = 4036,
  [5038] = 4032,
  [5039] = 4014,
  [5040] = 4016,
  [5041] = 4016,
  [5042] = 4019,
  [5043] = 4020,
  [5044] = 3755,
  [5045] = 4025,
  [5046] = 4037,
  [5047] = 4033,
  [5048] = 4919,
  [5049] = 4034,
  [5050] = 4003,
  [5051] = 4026,
  [5052] = 4036,
  [5053] = 4012,
  [5054] = 4015,
  [5055] = 3994,
  [5056] = 4012,
  [5057] = 3755,
  [5058] = 4033,
  [5059] = 4919,
  [5060] = 4024,
  [5061] = 4015,
  [5062] = 3755,
  [5063] = 4026,
  [5064] = 3982,
  [5065] = 4033,
  [5066] = 4919,
  [5067] = 4009,
  [5068] = 4015,
  [5069] = 4032,
  [5070] = 4033,
  [5071] = 4015,
  [5072] = 4919,
  [5073] = 4026,
  [5074] = 3994,
  [5075] = 3994,
  [5076] = 4026,
  [5077] = 4015,
  [5078] = 4033,
  [5079] = 4012,
  [5080] = 4026,
  [5081] = 4032,
  [5082] = 4025,
  [5083] = 4009,
  [5084] = 4034,
  [5085] = 4026,
  [5086] = 4037,
  [5087] = 4033,
  [5088] = 4025,
  [5089] = 4919,
  [5090] = 4015,
  [5091] = 4019,
  [5092] = 4020,
  [5093] = 4025,
  [5094] = 4037,
  [5095] = 4024,
  [5096] = 4034,
  [5097] = 4020,
  [5098] = 4036,
  [5099] = 4014,
  [5100] = 4019,
  [5101] = 4016,
  [5102] = 4012,
  [5103] = 3994,
  [5104] = 4024,
  [5105] = 4016,
  [5106] = 4033,
  [5107] = 4009,
  [5108] = 4032,
  [5109] = 4019,
  [5110] = 4919,
  [5111] = 4020,
  [5112] = 3982,
  [5113] = 4016,
  [5114] = 4019,
  [5115] = 4024,
  [5116] = 4033,
  [5117] = 4014,
  [5118] = 4020,
  [5119] = 4025,
  [5120] = 4037,
  [5121] = 4919,
  [5122] = 4024,
  [5123] = 4025,
  [5124] = 4037,
  [5125] = 4034,
  [5126] = 4009,
  [5127] = 4003,
  [5128] = 4014,
  [5129] = 4036,
  [5130] = 3994,
  [5131] = 3982,
  [5132] = 4032,
  [5133] = 4034,
  [5134] = 4012,
  [5135] = 4016,
  [5136] = 4009,
  [5137] = 4919,
  [5138] = 4036,
  [5139] = 4032,
  [5140] = 3755,
  [5141] = 4026,
  [5142] = 4014,
  [5143] = 3755,
  [5144] = 3994,
  [5145] = 4919,
  [5146] = 4015,
  [5147] = 4014,
  [5148] = 4026,
  [5149] = 4015,
  [5150] = 4016,
  [5151] = 4019,
  [5152] = 4026,
  [5153] = 4016,
  [5154] = 4019,
  [5155] = 4020,
  [5156] = 4025,
  [5157] = 3982,
  [5158] = 4037,
  [5159] = 4020,
  [5160] = 4034,
  [5161] = 4003,
  [5162] = 4919,
  [5163] = 4036,
  [5164] = 4919,
  [5165] = 4024,
  [5166] = 4919,
  [5167] = 4919,
  [5168] = 4012,
  [5169] = 4025,
  [5170] = 4033,
  [5171] = 4037,
  [5172] = 4024,
  [5173] = 4034,
  [5174] = 4009,
  [5175] = 4036,
  [5176] = 4032,
  [5177] = 4003,
  [5178] = 4009,
  [5179] = 3982,
  [5180] = 4032,
  [5181] = 3994,
  [5182] = 4026,
  [5183] = 4012,
  [5184] = 4015,
  [5185] = 4012,
  [5186] = 4015,
  [5187] = 4033,
  [5188] = 3755,
  [5189] = 4016,
  [5190] = 3982,
  [5191] = 4003,
  [5192] = 4033,
  [5193] = 3994,
  [5194] = 4033,
  [5195] = 4919,
  [5196] = 4019,
  [5197] = 4033,
  [5198] = 4036,
  [5199] = 4919,
  [5200] = 3982,
  [5201] = 4012,
  [5202] = 4014,
  [5203] = 4032,
  [5204] = 4014,
  [5205] = 3755,
  [5206] = 4036,
  [5207] = 4009,
  [5208] = 4034,
  [5209] = 4037,
  [5210] = 3982,
  [5211] = 4020,
  [5212] = 4025,
  [5213] = 4024,
  [5214] = 4919,
  [5215] = 4024,
  [5216] = 3994,
  [5217] = 5217,
  [5218] = 4020,
  [5219] = 4019,
  [5220] = 4015,
  [5221] = 4033,
  [5222] = 3994,
  [5223] = 4919,
  [5224] = 4003,
  [5225] = 3994,
  [5226] = 4014,
  [5227] = 4003,
  [5228] = 4026,
  [5229] = 4025,
  [5230] = 4016,
  [5231] = 4019,
  [5232] = 4020,
  [5233] = 4025,
  [5234] = 4015,
  [5235] = 4012,
  [5236] = 4037,
  [5237] = 4014,
  [5238] = 4034,
  [5239] = 4003,
  [5240] = 4036,
  [5241] = 4919,
  [5242] = 4012,
  [5243] = 4026,
  [5244] = 4919,
  [5245] = 4032,
  [5246] = 4012,
  [5247] = 4014,
  [5248] = 4036,
  [5249] = 4024,
  [5250] = 4009,
  [5251] = 3994,
  [5252] = 4003,
  [5253] = 4009,
  [5254] = 4032,
  [5255] = 4032,
  [5256] = 4034,
  [5257] = 5257,
  [5258] = 4037,
  [5259] = 4025,
  [5260] = 4020,
  [5261] = 4019,
  [5262] = 4036,
  [5263] = 4016,
  [5264] = 4919,
  [5265] = 4025,
  [5266] = 4009,
  [5267] = 4919,
  [5268] = 3994,
  [5269] = 4015,
  [5270] = 4034,
  [5271] = 4037,
  [5272] = 4919,
  [5273] = 4026,
  [5274] = 4037,
  [5275] = 4919,
  [5276] = 4025,
  [5277] = 4024,
  [5278] = 4020,
  [5279] = 4019,
  [5280] = 4016,
  [5281] = 4034,
  [5282] = 4015,
  [5283] = 4919,
  [5284] = 4003,
  [5285] = 4033,
  [5286] = 4003,
  [5287] = 4012,
  [5288] = 4009,
  [5289] = 3994,
  [5290] = 4014,
  [5291] = 4032,
  [5292] = 4919,
  [5293] = 4036,
  [5294] = 4009,
  [5295] = 4015,
  [5296] = 4034,
  [5297] = 4037,
  [5298] = 4025,
  [5299] = 4024,
  [5300] = 4020,
  [5301] = 3755,
  [5302] = 4026,
  [5303] = 4919,
  [5304] = 4019,
  [5305] = 4015,
  [5306] = 4026,
  [5307] = 4026,
  [5308] = 3755,
  [5309] = 4016,
  [5310] = 4019,
  [5311] = 4020,
  [5312] = 4024,
  [5313] = 4025,
  [5314] = 4037,
  [5315] = 4034,
  [5316] = 4009,
  [5317] = 4036,
  [5318] = 4032,
  [5319] = 4012,
  [5320] = 4016,
  [5321] = 4019,
  [5322] = 4020,
  [5323] = 4024,
  [5324] = 4016,
  [5325] = 4037,
  [5326] = 4919,
  [5327] = 4034,
  [5328] = 4009,
  [5329] = 4036,
  [5330] = 4032,
  [5331] = 3994,
  [5332] = 4919,
  [5333] = 4012,
  [5334] = 4024,
  [5335] = 4033,
  [5336] = 4032,
  [5337] = 4036,
  [5338] = 4009,
  [5339] = 4034,
  [5340] = 4037,
  [5341] = 4025,
  [5342] = 4024,
  [5343] = 4020,
  [5344] = 4019,
  [5345] = 4016,
  [5346] = 4919,
  [5347] = 4012,
  [5348] = 4015,
  [5349] = 3994,
  [5350] = 4026,
  [5351] = 3755,
  [5352] = 4014,
  [5353] = 4919,
  [5354] = 4032,
  [5355] = 4033,
  [5356] = 4919,
  [5357] = 4025,
  [5358] = 4014,
  [5359] = 4033,
  [5360] = 4036,
  [5361] = 4034,
  [5362] = 4019,
  [5363] = 4016,
  [5364] = 4012,
  [5365] = 4009,
  [5366] = 4033,
  [5367] = 4037,
  [5368] = 4014,
  [5369] = 4032,
  [5370] = 4026,
  [5371] = 4036,
  [5372] = 4015,
  [5373] = 4009,
  [5374] = 4026,
  [5375] = 4012,
  [5376] = 4025,
  [5377] = 4015,
  [5378] = 4024,
  [5379] = 4033,
  [5380] = 4034,
  [5381] = 4037,
  [5382] = 4025,
  [5383] = 4024,
  [5384] = 4020,
  [5385] = 4019,
  [5386] = 4016,
  [5387] = 4032,
  [5388] = 4015,
  [5389] = 4026,
  [5390] = 4016,
  [5391] = 4019,
  [5392] = 4020,
  [5393] = 4024,
  [5394] = 4025,
  [5395] = 4015,
  [5396] = 3755,
  [5397] = 4037,
  [5398] = 4034,
  [5399] = 4009,
  [5400] = 4036,
  [5401] = 4032,
  [5402] = 4026,
  [5403] = 3994,
  [5404] = 4014,
  [5405] = 4012,
  [5406] = 4015,
  [5407] = 4014,
  [5408] = 4026,
  [5409] = 3994,
  [5410] = 4016,
  [5411] = 4019,
  [5412] = 4020,
  [5413] = 4024,
  [5414] = 4025,
  [5415] = 4033,
  [5416] = 4037,
  [5417] = 4034,
  [5418] = 4033,
  [5419] = 4009,
  [5420] = 3994,
  [5421] = 4036,
  [5422] = 4032,
  [5423] = 4012,
  [5424] = 4016,
  [5425] = 4019,
  [5426] = 5426,
  [5427] = 4020,
  [5428] = 5428,
  [5429] = 3755,
  [5430] = 4014,
  [5431] = 4032,
  [5432] = 3994,
  [5433] = 4014,
  [5434] = 4009,
  [5435] = 4024,
  [5436] = 4012,
  [5437] = 4024,
  [5438] = 4033,
  [5439] = 4025,
  [5440] = 4026,
  [5441] = 4037,
  [5442] = 4014,
  [5443] = 4036,
  [5444] = 4033,
  [5445] = 4015,
  [5446] = 4026,
  [5447] = 4034,
  [5448] = 4034,
  [5449] = 4009,
  [5450] = 4036,
  [5451] = 4032,
  [5452] = 4037,
  [5453] = 4012,
  [5454] = 4012,
  [5455] = 4016,
  [5456] = 4019,
  [5457] = 4020,
  [5458] = 4024,
  [5459] = 4025,
  [5460] = 4015,
  [5461] = 4037,
  [5462] = 4034,
  [5463] = 4020,
  [5464] = 4009,
  [5465] = 4036,
  [5466] = 4032,
  [5467] = 4019,
  [5468] = 4016,
  [5469] = 4014,
  [5470] = 4032,
  [5471] = 3994,
  [5472] = 4012,
  [5473] = 4036,
  [5474] = 4009,
  [5475] = 4034,
  [5476] = 4037,
  [5477] = 4025,
  [5478] = 4024,
  [5479] = 4020,
  [5480] = 4032,
  [5481] = 4019,
  [5482] = 4009,
  [5483] = 4016,
  [5484] = 3994,
  [5485] = 4014,
  [5486] = 3994,
  [5487] = 4026,
  [5488] = 4015,
  [5489] = 4024,
  [5490] = 4012,
  [5491] = 4009,
  [5492] = 4032,
  [5493] = 4036,
  [5494] = 4009,
  [5495] = 4034,
  [5496] = 3982,
  [5497] = 4037,
  [5498] = 4025,
  [5499] = 4024,
  [5500] = 4020,
  [5501] = 4019,
  [5502] = 4016,
  [5503] = 4012,
  [5504] = 4033,
  [5505] = 4026,
  [5506] = 4036,
  [5507] = 4034,
  [5508] = 4037,
  [5509] = 3994,
  [5510] = 4014,
  [5511] = 4033,
  [5512] = 4014,
  [5513] = 4015,
  [5514] = 4026,
  [5515] = 4015,
  [5516] = 4016,
  [5517] = 4019,
  [5518] = 4025,
  [5519] = 4020,
  [5520] = 4024,
  [5521] = 4025,
  [5522] = 4020,
  [5523] = 4033,
  [5524] = 4019,
  [5525] = 4037,
  [5526] = 4016,
  [5527] = 4026,
  [5528] = 4025,
  [5529] = 4034,
  [5530] = 4015,
  [5531] = 4009,
  [5532] = 4033,
  [5533] = 4015,
  [5534] = 4036,
  [5535] = 4033,
  [5536] = 4014,
  [5537] = 4032,
  [5538] = 4012,
  [5539] = 3755,
  [5540] = 4026,
  [5541] = 4033,
  [5542] = 4014,
  [5543] = 4033,
  [5544] = 4015,
  [5545] = 4026,
  [5546] = 3994,
  [5547] = 3994,
  [5548] = 4014,
  [5549] = 4014,
  [5550] = 4012,
  [5551] = 3755,
  [5552] = 4016,
  [5553] = 4032,
  [5554] = 4036,
  [5555] = 4009,
  [5556] = 4019,
  [5557] = 4020,
  [5558] = 4034,
  [5559] = 4037,
  [5560] = 4024,
  [5561] = 4025,
  [5562] = 4024,
  [5563] = 4025,
  [5564] = 4020,
  [5565] = 4019,
  [5566] = 4032,
  [5567] = 4016,
  [5568] = 4016,
  [5569] = 4019,
  [5570] = 4020,
  [5571] = 4024,
  [5572] = 4025,
  [5573] = 4037,
  [5574] = 4037,
  [5575] = 4034,
  [5576] = 4009,
  [5577] = 3994,
  [5578] = 4036,
  [5579] = 4032,
  [5580] = 4034,
  [5581] = 4009,
  [5582] = 4012,
  [5583] = 4036,
  [5584] = 4032,
  [5585] = 3755,
  [5586] = 4024,
  [5587] = 4012,
  [5588] = 4014,
  [5589] = 4026,
  [5590] = 4012,
  [5591] = 3755,
  [5592] = 4036,
  [5593] = 4034,
  [5594] = 4037,
  [5595] = 4025,
  [5596] = 4014,
  [5597] = 4020,
  [5598] = 4019,
  [5599] = 4016,
  [5600] = 4015,
  [5601] = 4014,
  [5602] = 4033,
  [5603] = 4033,
  [5604] = 3994,
  [5605] = 4033,
  [5606] = 4015,
  [5607] = 4015,
  [5608] = 4026,
  [5609] = 3755,
  [5610] = 4026,
  [5611] = 3755,
  [5612] = 4026,
  [5613] = 4016,
  [5614] = 4019,
  [5615] = 4020,
  [5616] = 4024,
  [5617] = 4015,
  [5618] = 4025,
  [5619] = 4037,
  [5620] = 4034,
  [5621] = 4009,
  [5622] = 4015,
  [5623] = 4036,
  [5624] = 4032,
  [5625] = 4014,
  [5626] = 4026,
  [5627] = 4012,
  [5628] = 3994,
  [5629] = 4016,
  [5630] = 3755,
  [5631] = 4019,
  [5632] = 4020,
  [5633] = 4033,
  [5634] = 4024,
  [5635] = 4012,
  [5636] = 4025,
  [5637] = 4015,
  [5638] = 4037,
  [5639] = 4032,
  [5640] = 4036,
  [5641] = 4033,
  [5642] = 3994,
  [5643] = 4014,
  [5644] = 4009,
  [5645] = 4034,
  [5646] = 4034,
  [5647] = 4037,
  [5648] = 4016,
  [5649] = 4009,
  [5650] = 4019,
  [5651] = 4020,
  [5652] = 4024,
  [5653] = 4025,
  [5654] = 4025,
  [5655] = 4037,
  [5656] = 4024,
  [5657] = 4034,
  [5658] = 4020,
  [5659] = 4009,
  [5660] = 4036,
  [5661] = 4032,
  [5662] = 4019,
  [5663] = 4016,
  [5664] = 4012,
  [5665] = 4036,
  [5666] = 4032,
  [5667] = 4026,
  [5668] = 4012,
  [5669] = 4009,
  [5670] = 4015,
  [5671] = 4033,
  [5672] = 4016,
  [5673] = 4019,
  [5674] = 4020,
  [5675] = 4024,
  [5676] = 4025,
  [5677] = 4037,
  [5678] = 4034,
  [5679] = 4036,
  [5680] = 4032,
  [5681] = 4012,
  [5682] = 3994,
  [5683] = 4020,
  [5684] = 4026,
  [5685] = 3994,
  [5686] = 4033,
  [5687] = 4015,
  [5688] = 4026,
  [5689] = 4016,
  [5690] = 4019,
  [5691] = 4020,
  [5692] = 4025,
  [5693] = 4037,
  [5694] = 3755,
  [5695] = 4034,
  [5696] = 4036,
  [5697] = 4012,
  [5698] = 4012,
  [5699] = 4032,
  [5700] = 4036,
  [5701] = 4009,
  [5702] = 4034,
  [5703] = 4037,
  [5704] = 4024,
  [5705] = 4020,
  [5706] = 4019,
  [5707] = 4016,
  [5708] = 4024,
  [5709] = 4015,
  [5710] = 4033,
  [5711] = 4026,
  [5712] = 4009,
  [5713] = 4032,
  [5714] = 4026,
  [5715] = 4033,
  [5716] = 3994,
  [5717] = 4015,
  [5718] = 4014,
  [5719] = 4014,
  [5720] = 4016,
  [5721] = 4019,
  [5722] = 4020,
  [5723] = 4024,
  [5724] = 4025,
  [5725] = 4003,
  [5726] = 4037,
  [5727] = 4012,
  [5728] = 4034,
  [5729] = 3994,
  [5730] = 3755,
  [5731] = 4009,
  [5732] = 4036,
  [5733] = 4032,
  [5734] = 4014,
  [5735] = 4025,
  [5736] = 4012,
  [5737] = 4032,
  [5738] = 4009,
  [5739] = 4034,
  [5740] = 4037,
  [5741] = 4025,
  [5742] = 4024,
  [5743] = 4020,
  [5744] = 4019,
  [5745] = 3994,
  [5746] = 4016,
  [5747] = 4033,
  [5748] = 4015,
  [5749] = 4014,
  [5750] = 3994,
  [5751] = 4014,
  [5752] = 4012,
  [5753] = 4026,
  [5754] = 4016,
  [5755] = 4019,
  [5756] = 4020,
  [5757] = 4024,
  [5758] = 4025,
  [5759] = 4014,
  [5760] = 4037,
  [5761] = 4034,
  [5762] = 4032,
  [5763] = 4009,
  [5764] = 4036,
  [5765] = 4032,
  [5766] = 4036,
  [5767] = 4012,
  [5768] = 4009,
  [5769] = 4034,
  [5770] = 4037,
  [5771] = 4015,
  [5772] = 4033,
  [5773] = 4025,
  [5774] = 4024,
  [5775] = 4020,
  [5776] = 4019,
  [5777] = 4016,
  [5778] = 4012,
  [5779] = 4032,
  [5780] = 4036,
  [5781] = 4009,
  [5782] = 4034,
  [5783] = 4037,
  [5784] = 4025,
  [5785] = 4024,
  [5786] = 4020,
  [5787] = 4019,
  [5788] = 4016,
  [5789] = 4036,
  [5790] = 4015,
  [5791] = 4026,
  [5792] = 5792,
  [5793] = 4026,
  [5794] = 4015,
  [5795] = 4012,
  [5796] = 4026,
  [5797] = 4032,
  [5798] = 4036,
  [5799] = 4009,
  [5800] = 4034,
  [5801] = 4037,
  [5802] = 4015,
  [5803] = 4025,
  [5804] = 4012,
  [5805] = 4032,
  [5806] = 4033,
  [5807] = 4036,
  [5808] = 4009,
  [5809] = 4024,
  [5810] = 4034,
  [5811] = 4037,
  [5812] = 4014,
  [5813] = 4020,
  [5814] = 4019,
  [5815] = 3994,
  [5816] = 4016,
  [5817] = 4012,
  [5818] = 5818,
  [5819] = 4032,
  [5820] = 4036,
  [5821] = 4009,
  [5822] = 4034,
  [5823] = 4037,
  [5824] = 4025,
  [5825] = 4025,
  [5826] = 4024,
  [5827] = 4020,
  [5828] = 4019,
  [5829] = 4016,
  [5830] = 5830,
  [5831] = 4014,
  [5832] = 4033,
  [5833] = 4020,
  [5834] = 3994,
  [5835] = 4019,
  [5836] = 5836,
  [5837] = 3994,
  [5838] = 4012,
  [5839] = 4033,
  [5840] = 4016,
  [5841] = 4019,
  [5842] = 5217,
  [5843] = 4020,
  [5844] = 4033,
  [5845] = 4024,
  [5846] = 4026,
  [5847] = 4025,
  [5848] = 4037,
  [5849] = 4016,
  [5850] = 4015,
  [5851] = 4015,
  [5852] = 4034,
  [5853] = 4012,
  [5854] = 4032,
  [5855] = 4009,
  [5856] = 4036,
  [5857] = 4009,
  [5858] = 4026,
  [5859] = 4034,
  [5860] = 4037,
  [5861] = 4025,
  [5862] = 4024,
  [5863] = 4015,
  [5864] = 3994,
  [5865] = 4026,
  [5866] = 4020,
  [5867] = 4014,
  [5868] = 4036,
  [5869] = 4015,
  [5870] = 4032,
  [5871] = 4019,
  [5872] = 4014,
  [5873] = 4033,
  [5874] = 4026,
  [5875] = 5217,
  [5876] = 4033,
  [5877] = 4016,
  [5878] = 4026,
  [5879] = 4015,
  [5880] = 4016,
  [5881] = 4026,
  [5882] = 4019,
  [5883] = 4016,
  [5884] = 4033,
  [5885] = 3994,
  [5886] = 4016,
  [5887] = 4019,
  [5888] = 4020,
  [5889] = 4019,
  [5890] = 4024,
  [5891] = 4025,
  [5892] = 4037,
  [5893] = 4034,
  [5894] = 4020,
  [5895] = 4009,
  [5896] = 4024,
  [5897] = 4036,
  [5898] = 4032,
  [5899] = 4012,
  [5900] = 4025,
  [5901] = 4037,
  [5902] = 4026,
  [5903] = 4034,
  [5904] = 4009,
  [5905] = 4015,
  [5906] = 4036,
  [5907] = 3994,
  [5908] = 4026,
  [5909] = 4032,
  [5910] = 4015,
  [5911] = 4020,
  [5912] = 3994,
  [5913] = 4033,
  [5914] = 4012,
  [5915] = 4033,
  [5916] = 4014,
  [5917] = 4033,
  [5918] = 4024,
  [5919] = 4025,
  [5920] = 4037,
  [5921] = 4034,
  [5922] = 4009,
  [5923] = 4036,
  [5924] = 4032,
  [5925] = 4012,
  [5926] = 4012,
  [5927] = 4014,
  [5928] = 4032,
  [5929] = 4036,
  [5930] = 4009,
  [5931] = 4034,
  [5932] = 4037,
  [5933] = 3982,
  [5934] = 4025,
  [5935] = 4024,
  [5936] = 4020,
  [5937] = 4033,
  [5938] = 3994,
  [5939] = 4019,
  [5940] = 4016,
  [5941] = 4032,
  [5942] = 4014,
  [5943] = 4009,
  [5944] = 4014,
  [5945] = 4033,
  [5946] = 3994,
  [5947] = 3994,
  [5948] = 4014,
  [5949] = 4014,
  [5950] = 4014,
  [5951] = 4024,
  [5952] = 4032,
  [5953] = 4036,
  [5954] = 4009,
  [5955] = 4034,
  [5956] = 4014,
  [5957] = 4033,
  [5958] = 4037,
  [5959] = 4025,
  [5960] = 4024,
  [5961] = 4026,
  [5962] = 4020,
  [5963] = 4019,
  [5964] = 4016,
  [5965] = 4012,
  [5966] = 4015,
  [5967] = 4014,
  [5968] = 4033,
  [5969] = 4015,
  [5970] = 3994,
  [5971] = 4026,
  [5972] = 4036,
  [5973] = 4026,
  [5974] = 4024,
  [5975] = 4015,
  [5976] = 4012,
  [5977] = 4034,
  [5978] = 4033,
  [5979] = 4037,
  [5980] = 3994,
  [5981] = 4012,
  [5982] = 4032,
  [5983] = 4036,
  [5984] = 4009,
  [5985] = 4034,
  [5986] = 4037,
  [5987] = 4025,
  [5988] = 4024,
  [5989] = 4020,
  [5990] = 4019,
  [5991] = 4016,
  [5992] = 4015,
  [5993] = 4033,
  [5994] = 4026,
  [5995] = 3994,
  [5996] = 3755,
  [5997] = 4016,
  [5998] = 4019,
  [5999] = 4020,
  [6000] = 4016,
  [6001] = 6001,
  [6002] = 4015,
  [6003] = 4036,
  [6004] = 4015,
  [6005] = 4020,
  [6006] = 4025,
  [6007] = 4012,
  [6008] = 4024,
  [6009] = 4009,
  [6010] = 4032,
  [6011] = 6001,
  [6012] = 6001,
  [6013] = 4037,
  [6014] = 4033,
  [6015] = 4026,
  [6016] = 4026,
  [6017] = 6001,
  [6018] = 4033,
  [6019] = 4019,
  [6020] = 4016,
  [6021] = 3994,
  [6022] = 4014,
  [6023] = 3994,
  [6024] = 4026,
  [6025] = 6001,
  [6026] = 4032,
  [6027] = 4009,
  [6028] = 6001,
  [6029] = 6001,
  [6030] = 4015,
  [6031] = 6001,
  [6032] = 4032,
  [6033] = 4036,
  [6034] = 4009,
  [6035] = 4034,
  [6036] = 4016,
  [6037] = 4019,
  [6038] = 4020,
  [6039] = 4024,
  [6040] = 4025,
  [6041] = 4037,
  [6042] = 4037,
  [6043] = 4034,
  [6044] = 4025,
  [6045] = 4009,
  [6046] = 4036,
  [6047] = 4032,
  [6048] = 4024,
  [6049] = 4020,
  [6050] = 4012,
  [6051] = 4019,
  [6052] = 4016,
  [6053] = 4012,
  [6054] = 6001,
  [6055] = 4024,
  [6056] = 4026,
  [6057] = 4033,
  [6058] = 4015,
  [6059] = 4012,
  [6060] = 4012,
  [6061] = 6001,
  [6062] = 6001,
  [6063] = 4036,
  [6064] = 4016,
  [6065] = 4019,
  [6066] = 4033,
  [6067] = 4015,
  [6068] = 4026,
  [6069] = 4020,
  [6070] = 4033,
  [6071] = 6001,
  [6072] = 4014,
  [6073] = 4034,
  [6074] = 4024,
  [6075] = 4014,
  [6076] = 4025,
  [6077] = 6001,
  [6078] = 6001,
  [6079] = 4037,
  [6080] = 4034,
  [6081] = 4014,
  [6082] = 6001,
  [6083] = 4037,
  [6084] = 5217,
  [6085] = 4009,
  [6086] = 4036,
  [6087] = 4032,
  [6088] = 4025,
  [6089] = 4012,
  [6090] = 6001,
  [6091] = 4033,
  [6092] = 4020,
  [6093] = 4019,
  [6094] = 4016,
  [6095] = 4014,
  [6096] = 4032,
  [6097] = 6001,
  [6098] = 4009,
  [6099] = 4024,
  [6100] = 4012,
  [6101] = 4026,
  [6102] = 6001,
  [6103] = 4036,
  [6104] = 4034,
  [6105] = 4037,
  [6106] = 4015,
  [6107] = 4015,
  [6108] = 4025,
  [6109] = 4026,
  [6110] = 4033,
  [6111] = 4015,
  [6112] = 6001,
  [6113] = 6001,
  [6114] = 6001,
  [6115] = 4026,
  [6116] = 4019,
  [6117] = 4020,
  [6118] = 4024,
  [6119] = 3994,
  [6120] = 4014,
  [6121] = 5217,
  [6122] = 4025,
  [6123] = 6001,
  [6124] = 4032,
  [6125] = 4037,
  [6126] = 4034,
  [6127] = 4036,
  [6128] = 4009,
  [6129] = 4036,
  [6130] = 4032,
  [6131] = 3755,
  [6132] = 4020,
  [6133] = 4009,
  [6134] = 4034,
  [6135] = 4037,
  [6136] = 6001,
  [6137] = 4014,
  [6138] = 4025,
  [6139] = 4019,
  [6140] = 4024,
  [6141] = 4020,
  [6142] = 6001,
  [6143] = 4016,
  [6144] = 4019,
  [6145] = 4019,
  [6146] = 4016,
  [6147] = 4033,
  [6148] = 4020,
  [6149] = 4024,
  [6150] = 4025,
  [6151] = 4015,
  [6152] = 4037,
  [6153] = 4034,
  [6154] = 4009,
  [6155] = 4034,
  [6156] = 4036,
  [6157] = 4032,
  [6158] = 4033,
  [6159] = 4026,
  [6160] = 4026,
  [6161] = 4012,
  [6162] = 4012,
  [6163] = 6001,
  [6164] = 4033,
  [6165] = 6001,
  [6166] = 4032,
  [6167] = 4015,
  [6168] = 6001,
  [6169] = 4012,
  [6170] = 4009,
  [6171] = 4016,
  [6172] = 4019,
  [6173] = 4020,
  [6174] = 6174,
  [6175] = 4024,
  [6176] = 4025,
  [6177] = 6177,
  [6178] = 6001,
  [6179] = 4037,
  [6180] = 4034,
  [6181] = 6181,
  [6182] = 6181,
  [6183] = 6001,
  [6184] = 4009,
  [6185] = 4036,
  [6186] = 6001,
  [6187] = 4016,
  [6188] = 4012,
  [6189] = 6001,
  [6190] = 4033,
  [6191] = 4016,
  [6192] = 4019,
  [6193] = 4020,
  [6194] = 6001,
  [6195] = 4024,
  [6196] = 4025,
  [6197] = 6001,
  [6198] = 4014,
  [6199] = 4037,
  [6200] = 6181,
  [6201] = 6181,
  [6202] = 4034,
  [6203] = 4014,
  [6204] = 6001,
  [6205] = 6001,
  [6206] = 6181,
  [6207] = 6001,
  [6208] = 6181,
  [6209] = 6181,
  [6210] = 6181,
  [6211] = 4036,
  [6212] = 6181,
  [6213] = 4032,
  [6214] = 4012,
  [6215] = 6001,
  [6216] = 6181,
  [6217] = 4012,
  [6218] = 6181,
  [6219] = 6181,
  [6220] = 6001,
  [6221] = 6181,
  [6222] = 6181,
  [6223] = 6181,
  [6224] = 6224,
  [6225] = 4033,
  [6226] = 4032,
  [6227] = 4036,
  [6228] = 4009,
  [6229] = 4026,
  [6230] = 4014,
  [6231] = 4034,
  [6232] = 4037,
  [6233] = 6181,
  [6234] = 4033,
  [6235] = 4025,
  [6236] = 4024,
  [6237] = 6181,
  [6238] = 4020,
  [6239] = 4019,
  [6240] = 4016,
  [6241] = 6001,
  [6242] = 6001,
  [6243] = 6001,
  [6244] = 4032,
  [6245] = 4009,
  [6246] = 6001,
  [6247] = 4026,
  [6248] = 6181,
  [6249] = 6181,
  [6250] = 6001,
  [6251] = 4015,
  [6252] = 4015,
  [6253] = 4024,
  [6254] = 6181,
  [6255] = 4033,
  [6256] = 6181,
  [6257] = 4015,
  [6258] = 6181,
  [6259] = 6001,
  [6260] = 6181,
  [6261] = 6181,
  [6262] = 6001,
  [6263] = 6181,
  [6264] = 6181,
  [6265] = 6181,
  [6266] = 3994,
  [6267] = 4026,
  [6268] = 6001,
  [6269] = 6001,
  [6270] = 6181,
  [6271] = 6181,
  [6272] = 6001,
  [6273] = 6181,
  [6274] = 6181,
  [6275] = 6181,
  [6276] = 6181,
  [6277] = 4014,
  [6278] = 6181,
  [6279] = 6181,
  [6280] = 6181,
  [6281] = 4014,
  [6282] = 4033,
  [6283] = 4016,
  [6284] = 4019,
  [6285] = 4020,
  [6286] = 6001,
  [6287] = 4025,
  [6288] = 4037,
  [6289] = 6181,
  [6290] = 4034,
  [6291] = 6181,
  [6292] = 4036,
  [6293] = 5836,
  [6294] = 6181,
  [6295] = 6001,
  [6296] = 6181,
  [6297] = 6001,
  [6298] = 6181,
  [6299] = 6181,
  [6300] = 6181,
  [6301] = 6181,
  [6302] = 6181,
  [6303] = 6001,
  [6304] = 6001,
  [6305] = 6001,
  [6306] = 6001,
  [6307] = 6001,
  [6308] = 6181,
  [6309] = 5830,
  [6310] = 6001,
  [6311] = 6311,
  [6312] = 6312,
  [6313] = 6311,
  [6314] = 6314,
  [6315] = 6312,
  [6316] = 6312,
  [6317] = 6314,
  [6318] = 6312,
  [6319] = 6312,
  [6320] = 6311,
  [6321] = 4033,
  [6322] = 6311,
  [6323] = 6311,
  [6324] = 6312,
  [6325] = 6314,
  [6326] = 6311,
  [6327] = 6312,
  [6328] = 6311,
  [6329] = 6311,
  [6330] = 6311,
  [6331] = 6312,
  [6332] = 6312,
  [6333] = 4015,
  [6334] = 6314,
  [6335] = 6311,
  [6336] = 6312,
  [6337] = 6312,
  [6338] = 6312,
  [6339] = 6312,
  [6340] = 6311,
  [6341] = 6314,
  [6342] = 6311,
  [6343] = 6311,
  [6344] = 6311,
  [6345] = 6311,
  [6346] = 6311,
  [6347] = 6311,
  [6348] = 6312,
  [6349] = 6312,
  [6350] = 6314,
  [6351] = 6312,
  [6352] = 6311,
  [6353] = 6312,
  [6354] = 6311,
  [6355] = 4015,
  [6356] = 6311,
  [6357] = 4026,
  [6358] = 6311,
  [6359] = 6312,
  [6360] = 6314,
  [6361] = 6312,
  [6362] = 6314,
  [6363] = 6312,
  [6364] = 6312,
  [6365] = 6311,
  [6366] = 6314,
  [6367] = 6312,
  [6368] = 6311,
  [6369] = 6312,
  [6370] = 6311,
  [6371] = 6312,
  [6372] = 6312,
  [6373] = 6312,
  [6374] = 6312,
  [6375] = 6311,
  [6376] = 6311,
  [6377] = 6311,
  [6378] = 6311,
  [6379] = 6311,
  [6380] = 6311,
  [6381] = 6312,
  [6382] = 6314,
  [6383] = 6311,
  [6384] = 6312,
  [6385] = 6314,
  [6386] = 4014,
  [6387] = 6312,
  [6388] = 4016,
  [6389] = 4019,
  [6390] = 4020,
  [6391] = 4024,
  [6392] = 4025,
  [6393] = 6312,
  [6394] = 6314,
  [6395] = 6314,
  [6396] = 4037,
  [6397] = 4034,
  [6398] = 6311,
  [6399] = 4009,
  [6400] = 6314,
  [6401] = 4036,
  [6402] = 4032,
  [6403] = 6312,
  [6404] = 6311,
  [6405] = 6312,
  [6406] = 6311,
  [6407] = 4012,
  [6408] = 6312,
  [6409] = 6311,
  [6410] = 6314,
  [6411] = 6312,
  [6412] = 6312,
  [6413] = 6312,
  [6414] = 6314,
  [6415] = 6312,
  [6416] = 6312,
  [6417] = 6311,
  [6418] = 6311,
  [6419] = 6311,
  [6420] = 6312,
  [6421] = 6312,
  [6422] = 6312,
  [6423] = 6311,
  [6424] = 4033,
  [6425] = 6311,
  [6426] = 4015,
  [6427] = 4014,
  [6428] = 6311,
  [6429] = 6311,
  [6430] = 6314,
  [6431] = 6314,
  [6432] = 6312,
  [6433] = 6312,
  [6434] = 6312,
  [6435] = 6311,
  [6436] = 6311,
  [6437] = 6312,
  [6438] = 6312,
  [6439] = 6311,
  [6440] = 6311,
  [6441] = 6311,
  [6442] = 6314,
  [6443] = 6311,
  [6444] = 6312,
  [6445] = 6312,
  [6446] = 6311,
  [6447] = 6312,
  [6448] = 6311,
  [6449] = 6312,
  [6450] = 6312,
  [6451] = 6314,
  [6452] = 6311,
  [6453] = 6312,
  [6454] = 6312,
  [6455] = 6312,
  [6456] = 6314,
  [6457] = 6311,
  [6458] = 6311,
  [6459] = 6311,
  [6460] = 6312,
  [6461] = 6311,
  [6462] = 6314,
  [6463] = 6314,
  [6464] = 6312,
  [6465] = 6311,
  [6466] = 6311,
  [6467] = 6311,
  [6468] = 6312,
  [6469] = 6311,
  [6470] = 6312,
  [6471] = 6311,
  [6472] = 6312,
  [6473] = 6311,
  [6474] = 6311,
  [6475] = 6311,
  [6476] = 6311,
  [6477] = 6311,
  [6478] = 6311,
  [6479] = 6312,
  [6480] = 3994,
  [6481] = 6311,
  [6482] = 4033,
  [6483] = 6312,
  [6484] = 6311,
  [6485] = 6312,
  [6486] = 6311,
  [6487] = 6311,
  [6488] = 6311,
  [6489] = 6311,
  [6490] = 6312,
  [6491] = 6311,
  [6492] = 6311,
  [6493] = 6312,
  [6494] = 3994,
  [6495] = 3994,
  [6496] = 6312,
  [6497] = 6314,
  [6498] = 6311,
  [6499] = 6312,
  [6500] = 6311,
  [6501] = 6312,
  [6502] = 4015,
  [6503] = 6311,
  [6504] = 6311,
  [6505] = 6311,
  [6506] = 6314,
  [6507] = 6311,
  [6508] = 6312,
  [6509] = 4026,
  [6510] = 6311,
  [6511] = 6312,
  [6512] = 6311,
  [6513] = 6312,
  [6514] = 6311,
  [6515] = 6311,
  [6516] = 6311,
  [6517] = 4015,
  [6518] = 6311,
  [6519] = 4026,
  [6520] = 6312,
  [6521] = 6312,
  [6522] = 6311,
  [6523] = 6311,
  [6524] = 6314,
  [6525] = 6311,
  [6526] = 6311,
  [6527] = 4026,
  [6528] = 6314,
  [6529] = 6312,
  [6530] = 6311,
  [6531] = 6311,
  [6532] = 6532,
  [6533] = 6312,
  [6534] = 6311,
  [6535] = 6311,
  [6536] = 4016,
  [6537] = 4016,
  [6538] = 4019,
  [6539] = 4020,
  [6540] = 4024,
  [6541] = 4025,
  [6542] = 4037,
  [6543] = 4034,
  [6544] = 6311,
  [6545] = 4009,
  [6546] = 4036,
  [6547] = 4032,
  [6548] = 4019,
  [6549] = 4012,
  [6550] = 6311,
  [6551] = 4020,
  [6552] = 4025,
  [6553] = 6312,
  [6554] = 6312,
  [6555] = 4037,
  [6556] = 6311,
  [6557] = 4034,
  [6558] = 6312,
  [6559] = 6311,
  [6560] = 6311,
  [6561] = 6312,
  [6562] = 4036,
  [6563] = 6311,
  [6564] = 6312,
  [6565] = 4012,
  [6566] = 6311,
  [6567] = 4024,
  [6568] = 6312,
  [6569] = 6312,
  [6570] = 6312,
  [6571] = 6312,
  [6572] = 6311,
  [6573] = 6312,
  [6574] = 4009,
  [6575] = 4032,
  [6576] = 6311,
  [6577] = 6312,
  [6578] = 6312,
  [6579] = 6311,
  [6580] = 6311,
  [6581] = 6311,
  [6582] = 6312,
  [6583] = 6312,
  [6584] = 6311,
  [6585] = 6312,
  [6586] = 6314,
  [6587] = 6312,
  [6588] = 6311,
  [6589] = 6312,
  [6590] = 6311,
  [6591] = 6311,
  [6592] = 6311,
  [6593] = 6311,
  [6594] = 6312,
  [6595] = 6311,
  [6596] = 6311,
  [6597] = 6314,
  [6598] = 6311,
  [6599] = 6311,
  [6600] = 6312,
  [6601] = 6312,
  [6602] = 6312,
  [6603] = 6311,
  [6604] = 6312,
  [6605] = 6311,
  [6606] = 6312,
  [6607] = 6312,
  [6608] = 6311,
  [6609] = 6312,
  [6610] = 6311,
  [6611] = 6311,
  [6612] = 6312,
  [6613] = 6312,
  [6614] = 6312,
  [6615] = 6311,
  [6616] = 6311,
  [6617] = 6314,
  [6618] = 6312,
  [6619] = 6312,
  [6620] = 6312,
  [6621] = 6311,
  [6622] = 3994,
  [6623] = 6312,
  [6624] = 6312,
  [6625] = 6312,
  [6626] = 6312,
  [6627] = 6311,
  [6628] = 6312,
  [6629] = 6312,
  [6630] = 6312,
  [6631] = 6312,
  [6632] = 6314,
  [6633] = 6312,
  [6634] = 6311,
  [6635] = 6311,
  [6636] = 6311,
  [6637] = 6314,
  [6638] = 6312,
  [6639] = 6312,
  [6640] = 6311,
  [6641] = 6314,
  [6642] = 6311,
  [6643] = 6311,
  [6644] = 6311,
  [6645] = 6311,
  [6646] = 6314,
  [6647] = 6311,
  [6648] = 6312,
  [6649] = 6312,
  [6650] = 6312,
  [6651] = 6312,
  [6652] = 6311,
  [6653] = 6311,
  [6654] = 6312,
  [6655] = 6311,
  [6656] = 6311,
  [6657] = 6312,
  [6658] = 6311,
  [6659] = 6312,
  [6660] = 6312,
  [6661] = 6312,
  [6662] = 6312,
  [6663] = 6312,
  [6664] = 6312,
  [6665] = 6311,
  [6666] = 6312,
  [6667] = 4033,
  [6668] = 6311,
  [6669] = 6311,
  [6670] = 6670,
  [6671] = 6312,
  [6672] = 6311,
  [6673] = 6311,
  [6674] = 6312,
  [6675] = 6312,
  [6676] = 6311,
  [6677] = 6312,
  [6678] = 6312,
  [6679] = 6311,
  [6680] = 6311,
  [6681] = 6312,
  [6682] = 6312,
  [6683] = 6312,
  [6684] = 6311,
  [6685] = 6312,
  [6686] = 6312,
  [6687] = 6314,
  [6688] = 6311,
  [6689] = 6311,
  [6690] = 6311,
  [6691] = 6312,
  [6692] = 6312,
  [6693] = 6314,
  [6694] = 6314,
  [6695] = 6311,
  [6696] = 6312,
  [6697] = 6311,
  [6698] = 6312,
  [6699] = 6311,
  [6700] = 6312,
  [6701] = 6311,
  [6702] = 6312,
  [6703] = 6311,
  [6704] = 6311,
  [6705] = 6314,
  [6706] = 6312,
  [6707] = 6312,
  [6708] = 6311,
  [6709] = 6311,
  [6710] = 4026,
  [6711] = 6312,
  [6712] = 6312,
  [6713] = 6312,
  [6714] = 4012,
  [6715] = 4032,
  [6716] = 4036,
  [6717] = 6312,
  [6718] = 4009,
  [6719] = 6312,
  [6720] = 6312,
  [6721] = 6311,
  [6722] = 6312,
  [6723] = 6311,
  [6724] = 6312,
  [6725] = 6314,
  [6726] = 6311,
  [6727] = 6312,
  [6728] = 6311,
  [6729] = 6311,
  [6730] = 6311,
  [6731] = 6311,
  [6732] = 6312,
  [6733] = 6312,
  [6734] = 4034,
  [6735] = 6312,
  [6736] = 4037,
  [6737] = 6311,
  [6738] = 6311,
  [6739] = 6311,
  [6740] = 6312,
  [6741] = 6312,
  [6742] = 6311,
  [6743] = 6312,
  [6744] = 6311,
  [6745] = 4025,
  [6746] = 4024,
  [6747] = 6312,
  [6748] = 6311,
  [6749] = 4020,
  [6750] = 6312,
  [6751] = 6312,
  [6752] = 4019,
  [6753] = 6311,
  [6754] = 6312,
  [6755] = 6312,
  [6756] = 4016,
  [6757] = 6312,
  [6758] = 6312,
  [6759] = 6312,
  [6760] = 6311,
  [6761] = 6311,
  [6762] = 6312,
  [6763] = 6311,
  [6764] = 6314,
  [6765] = 6312,
  [6766] = 4033,
  [6767] = 6312,
  [6768] = 6312,
  [6769] = 6312,
  [6770] = 6311,
  [6771] = 6312,
  [6772] = 6312,
  [6773] = 6312,
  [6774] = 6311,
  [6775] = 6311,
  [6776] = 6311,
  [6777] = 6312,
  [6778] = 6312,
  [6779] = 6312,
  [6780] = 6311,
  [6781] = 6311,
  [6782] = 6311,
  [6783] = 6312,
  [6784] = 6312,
  [6785] = 6314,
  [6786] = 6311,
  [6787] = 6311,
  [6788] = 3755,
  [6789] = 6312,
  [6790] = 6314,
  [6791] = 4032,
  [6792] = 4009,
  [6793] = 4009,
  [6794] = 4036,
  [6795] = 4032,
  [6796] = 4012,
  [6797] = 4033,
  [6798] = 4033,
  [6799] = 4025,
  [6800] = 4015,
  [6801] = 4026,
  [6802] = 3994,
  [6803] = 4024,
  [6804] = 4020,
  [6805] = 4032,
  [6806] = 4009,
  [6807] = 4024,
  [6808] = 4019,
  [6809] = 4012,
  [6810] = 4036,
  [6811] = 4016,
  [6812] = 4034,
  [6813] = 4037,
  [6814] = 4025,
  [6815] = 4020,
  [6816] = 4019,
  [6817] = 4016,
  [6818] = 4026,
  [6819] = 4033,
  [6820] = 4015,
  [6821] = 4025,
  [6822] = 4033,
  [6823] = 4034,
  [6824] = 4024,
  [6825] = 4037,
  [6826] = 4012,
  [6827] = 4015,
  [6828] = 4036,
  [6829] = 4034,
  [6830] = 4037,
  [6831] = 4025,
  [6832] = 4020,
  [6833] = 4026,
  [6834] = 4019,
  [6835] = 4016,
  [6836] = 4026,
  [6837] = 3994,
  [6838] = 3994,
  [6839] = 4026,
  [6840] = 4016,
  [6841] = 4019,
  [6842] = 4015,
  [6843] = 4020,
  [6844] = 4024,
  [6845] = 4037,
  [6846] = 4034,
  [6847] = 4009,
  [6848] = 3994,
  [6849] = 4036,
  [6850] = 4032,
  [6851] = 4012,
  [6852] = 3994,
  [6853] = 4015,
  [6854] = 4033,
  [6855] = 6670,
  [6856] = 6856,
  [6857] = 6856,
  [6858] = 6856,
  [6859] = 4037,
  [6860] = 6856,
  [6861] = 6856,
  [6862] = 4025,
  [6863] = 6856,
  [6864] = 6856,
  [6865] = 4012,
  [6866] = 4016,
  [6867] = 6856,
  [6868] = 6856,
  [6869] = 6856,
  [6870] = 6856,
  [6871] = 6856,
  [6872] = 6856,
  [6873] = 6856,
  [6874] = 6856,
  [6875] = 6856,
  [6876] = 6856,
  [6877] = 6856,
  [6878] = 4034,
  [6879] = 6856,
  [6880] = 6856,
  [6881] = 6856,
  [6882] = 6856,
  [6883] = 6856,
  [6884] = 6856,
  [6885] = 6856,
  [6886] = 6856,
  [6887] = 4033,
  [6888] = 6856,
  [6889] = 6856,
  [6890] = 6856,
  [6891] = 6856,
  [6892] = 6856,
  [6893] = 6856,
  [6894] = 6856,
  [6895] = 4033,
  [6896] = 6856,
  [6897] = 6856,
  [6898] = 6856,
  [6899] = 6899,
  [6900] = 6856,
  [6901] = 4009,
  [6902] = 4036,
  [6903] = 4033,
  [6904] = 4032,
  [6905] = 4032,
  [6906] = 6856,
  [6907] = 4037,
  [6908] = 6856,
  [6909] = 4024,
  [6910] = 6856,
  [6911] = 6856,
  [6912] = 6856,
  [6913] = 6856,
  [6914] = 6856,
  [6915] = 6856,
  [6916] = 6856,
  [6917] = 4015,
  [6918] = 6856,
  [6919] = 6856,
  [6920] = 4026,
  [6921] = 6856,
  [6922] = 4036,
  [6923] = 6856,
  [6924] = 6856,
  [6925] = 4019,
  [6926] = 4020,
  [6927] = 6856,
  [6928] = 6856,
  [6929] = 6856,
  [6930] = 4025,
  [6931] = 4037,
  [6932] = 6856,
  [6933] = 4012,
  [6934] = 6856,
  [6935] = 6856,
  [6936] = 4034,
  [6937] = 4020,
  [6938] = 6856,
  [6939] = 4032,
  [6940] = 6856,
  [6941] = 6856,
  [6942] = 4036,
  [6943] = 4009,
  [6944] = 3994,
  [6945] = 4012,
  [6946] = 6856,
  [6947] = 6856,
  [6948] = 6856,
  [6949] = 6856,
  [6950] = 6856,
  [6951] = 4024,
  [6952] = 6856,
  [6953] = 6856,
  [6954] = 4009,
  [6955] = 4032,
  [6956] = 6856,
  [6957] = 6856,
  [6958] = 6856,
  [6959] = 6856,
  [6960] = 6856,
  [6961] = 6856,
  [6962] = 6856,
  [6963] = 6856,
  [6964] = 6856,
  [6965] = 6856,
  [6966] = 6856,
  [6967] = 6856,
  [6968] = 6856,
  [6969] = 6856,
  [6970] = 6856,
  [6971] = 6856,
  [6972] = 6856,
  [6973] = 6856,
  [6974] = 6856,
  [6975] = 6856,
  [6976] = 6856,
  [6977] = 6856,
  [6978] = 6856,
  [6979] = 6856,
  [6980] = 4034,
  [6981] = 6856,
  [6982] = 6856,
  [6983] = 6856,
  [6984] = 6984,
  [6985] = 6856,
  [6986] = 6856,
  [6987] = 6856,
  [6988] = 6856,
  [6989] = 6856,
  [6990] = 6856,
  [6991] = 6856,
  [6992] = 6856,
  [6993] = 6856,
  [6994] = 6856,
  [6995] = 6856,
  [6996] = 4025,
  [6997] = 4024,
  [6998] = 4019,
  [6999] = 6856,
  [7000] = 6856,
  [7001] = 6856,
  [7002] = 6856,
  [7003] = 6856,
  [7004] = 6856,
  [7005] = 6856,
  [7006] = 6856,
  [7007] = 6856,
  [7008] = 6856,
  [7009] = 4020,
  [7010] = 4019,
  [7011] = 6856,
  [7012] = 6856,
  [7013] = 6856,
  [7014] = 6856,
  [7015] = 6856,
  [7016] = 6856,
  [7017] = 6856,
  [7018] = 6856,
  [7019] = 6856,
  [7020] = 6856,
  [7021] = 6856,
  [7022] = 6856,
  [7023] = 6856,
  [7024] = 6856,
  [7025] = 6856,
  [7026] = 6856,
  [7027] = 6856,
  [7028] = 6856,
  [7029] = 6856,
  [7030] = 6856,
  [7031] = 6856,
  [7032] = 6856,
  [7033] = 4016,
  [7034] = 6856,
  [7035] = 6856,
  [7036] = 6856,
  [7037] = 6856,
  [7038] = 6856,
  [7039] = 6856,
  [7040] = 6856,
  [7041] = 4033,
  [7042] = 6856,
  [7043] = 6856,
  [7044] = 6856,
  [7045] = 6856,
  [7046] = 6856,
  [7047] = 6856,
  [7048] = 3994,
  [7049] = 6856,
  [7050] = 6856,
  [7051] = 4019,
  [7052] = 3994,
  [7053] = 6856,
  [7054] = 4026,
  [7055] = 6856,
  [7056] = 6856,
  [7057] = 6856,
  [7058] = 6856,
  [7059] = 6856,
  [7060] = 6856,
  [7061] = 6856,
  [7062] = 6856,
  [7063] = 6856,
  [7064] = 6856,
  [7065] = 6856,
  [7066] = 4012,
  [7067] = 6856,
  [7068] = 6856,
  [7069] = 4032,
  [7070] = 4036,
  [7071] = 4009,
  [7072] = 4034,
  [7073] = 4037,
  [7074] = 6856,
  [7075] = 6856,
  [7076] = 6856,
  [7077] = 4025,
  [7078] = 4024,
  [7079] = 4020,
  [7080] = 4019,
  [7081] = 4026,
  [7082] = 4016,
  [7083] = 4015,
  [7084] = 6856,
  [7085] = 4015,
  [7086] = 6856,
  [7087] = 6856,
  [7088] = 6856,
  [7089] = 6856,
  [7090] = 6856,
  [7091] = 6856,
  [7092] = 6856,
  [7093] = 6856,
  [7094] = 4012,
  [7095] = 6856,
  [7096] = 6856,
  [7097] = 3994,
  [7098] = 6856,
  [7099] = 4036,
  [7100] = 4009,
  [7101] = 4034,
  [7102] = 4037,
  [7103] = 6856,
  [7104] = 4026,
  [7105] = 4025,
  [7106] = 4016,
  [7107] = 4024,
  [7108] = 4020,
  [7109] = 6856,
  [7110] = 6856,
  [7111] = 4015,
  [7112] = 6984,
  [7113] = 4016,
  [7114] = 4033,
  [7115] = 3994,
  [7116] = 4015,
  [7117] = 4026,
  [7118] = 3994,
  [7119] = 4016,
  [7120] = 4015,
  [7121] = 4033,
  [7122] = 4019,
  [7123] = 4020,
  [7124] = 4024,
  [7125] = 4025,
  [7126] = 4037,
  [7127] = 4034,
  [7128] = 4009,
  [7129] = 4032,
  [7130] = 4012,
  [7131] = 4036,
  [7132] = 3994,
  [7133] = 3994,
  [7134] = 4033,
  [7135] = 4015,
  [7136] = 4015,
  [7137] = 4026,
  [7138] = 7138,
  [7139] = 4033,
  [7140] = 4026,
  [7141] = 4026,
  [7142] = 3994,
  [7143] = 3994,
  [7144] = 4012,
  [7145] = 4016,
  [7146] = 4016,
  [7147] = 4020,
  [7148] = 4019,
  [7149] = 4020,
  [7150] = 4019,
  [7151] = 4020,
  [7152] = 4024,
  [7153] = 4019,
  [7154] = 4025,
  [7155] = 4016,
  [7156] = 4037,
  [7157] = 4034,
  [7158] = 4009,
  [7159] = 4036,
  [7160] = 3994,
  [7161] = 4012,
  [7162] = 4032,
  [7163] = 4032,
  [7164] = 4024,
  [7165] = 4036,
  [7166] = 4025,
  [7167] = 4009,
  [7168] = 4032,
  [7169] = 4037,
  [7170] = 4034,
  [7171] = 4034,
  [7172] = 4009,
  [7173] = 4012,
  [7174] = 4037,
  [7175] = 4025,
  [7176] = 4024,
  [7177] = 4036,
  [7178] = 4036,
  [7179] = 4037,
  [7180] = 4019,
  [7181] = 4026,
  [7182] = 4026,
  [7183] = 4033,
  [7184] = 4016,
  [7185] = 4016,
  [7186] = 4020,
  [7187] = 4020,
  [7188] = 4019,
  [7189] = 4020,
  [7190] = 4024,
  [7191] = 4025,
  [7192] = 4024,
  [7193] = 4025,
  [7194] = 4037,
  [7195] = 4034,
  [7196] = 4015,
  [7197] = 4009,
  [7198] = 4037,
  [7199] = 4034,
  [7200] = 4036,
  [7201] = 4032,
  [7202] = 4012,
  [7203] = 4033,
  [7204] = 4009,
  [7205] = 4015,
  [7206] = 4012,
  [7207] = 3994,
  [7208] = 4015,
  [7209] = 4012,
  [7210] = 3994,
  [7211] = 4026,
  [7212] = 4032,
  [7213] = 4032,
  [7214] = 4036,
  [7215] = 4009,
  [7216] = 4034,
  [7217] = 4037,
  [7218] = 4025,
  [7219] = 4024,
  [7220] = 4019,
  [7221] = 4016,
  [7222] = 4033,
  [7223] = 3994,
  [7224] = 4015,
  [7225] = 4026,
  [7226] = 4032,
  [7227] = 7138,
  [7228] = 4026,
  [7229] = 4015,
  [7230] = 3994,
  [7231] = 4016,
  [7232] = 4015,
  [7233] = 4019,
  [7234] = 4020,
  [7235] = 3994,
  [7236] = 4024,
  [7237] = 4033,
  [7238] = 4025,
  [7239] = 4034,
  [7240] = 4009,
  [7241] = 4036,
  [7242] = 4016,
  [7243] = 4019,
  [7244] = 3994,
  [7245] = 4020,
  [7246] = 4026,
  [7247] = 4024,
  [7248] = 4025,
  [7249] = 4012,
  [7250] = 3994,
  [7251] = 4037,
  [7252] = 4034,
  [7253] = 4009,
  [7254] = 4036,
  [7255] = 4032,
  [7256] = 4012,
  [7257] = 4033,
  [7258] = 7258,
  [7259] = 3994,
  [7260] = 4033,
  [7261] = 7261,
  [7262] = 7258,
  [7263] = 3994,
  [7264] = 4037,
  [7265] = 4033,
  [7266] = 4012,
  [7267] = 4012,
  [7268] = 4032,
  [7269] = 4036,
  [7270] = 4009,
  [7271] = 4015,
  [7272] = 4026,
  [7273] = 4034,
  [7274] = 3994,
  [7275] = 4036,
  [7276] = 4032,
  [7277] = 4024,
  [7278] = 4025,
  [7279] = 4016,
  [7280] = 4037,
  [7281] = 4019,
  [7282] = 4020,
  [7283] = 4016,
  [7284] = 4019,
  [7285] = 4034,
  [7286] = 4024,
  [7287] = 4025,
  [7288] = 3994,
  [7289] = 4020,
  [7290] = 4009,
  [7291] = 4012,
  [7292] = 4019,
  [7293] = 4015,
  [7294] = 4019,
  [7295] = 4020,
  [7296] = 3994,
  [7297] = 4024,
  [7298] = 4025,
  [7299] = 4037,
  [7300] = 4033,
  [7301] = 4034,
  [7302] = 4012,
  [7303] = 4009,
  [7304] = 4036,
  [7305] = 4032,
  [7306] = 4012,
  [7307] = 4037,
  [7308] = 3994,
  [7309] = 4012,
  [7310] = 4016,
  [7311] = 3994,
  [7312] = 4032,
  [7313] = 4036,
  [7314] = 4009,
  [7315] = 3994,
  [7316] = 4025,
  [7317] = 4034,
  [7318] = 3994,
  [7319] = 4012,
  [7320] = 4032,
  [7321] = 4036,
  [7322] = 4009,
  [7323] = 4037,
  [7324] = 4034,
  [7325] = 4037,
  [7326] = 4025,
  [7327] = 3994,
  [7328] = 4024,
  [7329] = 4020,
  [7330] = 4019,
  [7331] = 4032,
  [7332] = 3994,
  [7333] = 4012,
  [7334] = 4033,
  [7335] = 4016,
  [7336] = 4025,
  [7337] = 4024,
  [7338] = 4026,
  [7339] = 4020,
  [7340] = 4019,
  [7341] = 4016,
  [7342] = 4033,
  [7343] = 3994,
  [7344] = 4019,
  [7345] = 4016,
  [7346] = 3994,
  [7347] = 4033,
  [7348] = 7258,
  [7349] = 4026,
  [7350] = 7261,
  [7351] = 3994,
  [7352] = 4015,
  [7353] = 4012,
  [7354] = 4032,
  [7355] = 4036,
  [7356] = 4009,
  [7357] = 4020,
  [7358] = 4033,
  [7359] = 4034,
  [7360] = 4037,
  [7361] = 4015,
  [7362] = 4025,
  [7363] = 4024,
  [7364] = 3994,
  [7365] = 4020,
  [7366] = 4026,
  [7367] = 4019,
  [7368] = 4016,
  [7369] = 4016,
  [7370] = 4026,
  [7371] = 4019,
  [7372] = 4020,
  [7373] = 4037,
  [7374] = 4025,
  [7375] = 4025,
  [7376] = 4034,
  [7377] = 4037,
  [7378] = 4024,
  [7379] = 4034,
  [7380] = 4016,
  [7381] = 4015,
  [7382] = 4036,
  [7383] = 4020,
  [7384] = 4019,
  [7385] = 4015,
  [7386] = 4016,
  [7387] = 4026,
  [7388] = 4024,
  [7389] = 4032,
  [7390] = 4036,
  [7391] = 4015,
  [7392] = 4015,
  [7393] = 4033,
  [7394] = 4026,
  [7395] = 4026,
  [7396] = 4019,
  [7397] = 4026,
  [7398] = 4015,
  [7399] = 4009,
  [7400] = 4032,
  [7401] = 3994,
  [7402] = 4026,
  [7403] = 3994,
  [7404] = 4015,
  [7405] = 4012,
  [7406] = 4032,
  [7407] = 4036,
  [7408] = 4009,
  [7409] = 4036,
  [7410] = 4034,
  [7411] = 4033,
  [7412] = 4033,
  [7413] = 4033,
  [7414] = 4020,
  [7415] = 4037,
  [7416] = 4015,
  [7417] = 4025,
  [7418] = 4024,
  [7419] = 4009,
  [7420] = 7261,
  [7421] = 4026,
  [7422] = 4024,
  [7423] = 4020,
  [7424] = 4009,
  [7425] = 4016,
  [7426] = 4034,
  [7427] = 4025,
  [7428] = 4024,
  [7429] = 4019,
  [7430] = 4037,
  [7431] = 4024,
  [7432] = 4025,
  [7433] = 4033,
  [7434] = 4034,
  [7435] = 4015,
  [7436] = 4009,
  [7437] = 4037,
  [7438] = 4034,
  [7439] = 4009,
  [7440] = 4036,
  [7441] = 4036,
  [7442] = 4032,
  [7443] = 4026,
  [7444] = 4020,
  [7445] = 4012,
  [7446] = 4032,
  [7447] = 4033,
  [7448] = 4012,
  [7449] = 4016,
  [7450] = 7258,
  [7451] = 4019,
  [7452] = 4020,
  [7453] = 4024,
  [7454] = 4025,
  [7455] = 4037,
  [7456] = 4034,
  [7457] = 4009,
  [7458] = 4036,
  [7459] = 4032,
  [7460] = 3994,
  [7461] = 4012,
  [7462] = 4016,
  [7463] = 4025,
  [7464] = 3994,
  [7465] = 3994,
  [7466] = 4009,
  [7467] = 4009,
  [7468] = 4032,
  [7469] = 4012,
  [7470] = 4037,
  [7471] = 4033,
  [7472] = 4026,
  [7473] = 4036,
  [7474] = 4034,
  [7475] = 4032,
  [7476] = 4024,
  [7477] = 4015,
  [7478] = 4033,
  [7479] = 4034,
  [7480] = 4020,
  [7481] = 4019,
  [7482] = 4016,
  [7483] = 4016,
  [7484] = 4037,
  [7485] = 4025,
  [7486] = 4019,
  [7487] = 4015,
  [7488] = 4012,
  [7489] = 4032,
  [7490] = 4020,
  [7491] = 4026,
  [7492] = 3994,
  [7493] = 4034,
  [7494] = 4036,
  [7495] = 4024,
  [7496] = 4024,
  [7497] = 4012,
  [7498] = 4024,
  [7499] = 4012,
  [7500] = 4033,
  [7501] = 4012,
  [7502] = 4032,
  [7503] = 4020,
  [7504] = 4032,
  [7505] = 4009,
  [7506] = 4036,
  [7507] = 4020,
  [7508] = 4009,
  [7509] = 4019,
  [7510] = 4009,
  [7511] = 4034,
  [7512] = 4034,
  [7513] = 4037,
  [7514] = 4016,
  [7515] = 4019,
  [7516] = 4025,
  [7517] = 4037,
  [7518] = 4026,
  [7519] = 4020,
  [7520] = 4025,
  [7521] = 4024,
  [7522] = 4020,
  [7523] = 4033,
  [7524] = 4037,
  [7525] = 4016,
  [7526] = 4025,
  [7527] = 4009,
  [7528] = 4036,
  [7529] = 4025,
  [7530] = 4033,
  [7531] = 4020,
  [7532] = 4019,
  [7533] = 4015,
  [7534] = 4016,
  [7535] = 4032,
  [7536] = 4012,
  [7537] = 4009,
  [7538] = 4034,
  [7539] = 4019,
  [7540] = 4033,
  [7541] = 4016,
  [7542] = 3994,
  [7543] = 4037,
  [7544] = 4033,
  [7545] = 4026,
  [7546] = 4009,
  [7547] = 4024,
  [7548] = 4036,
  [7549] = 4037,
  [7550] = 4034,
  [7551] = 4015,
  [7552] = 4012,
  [7553] = 4020,
  [7554] = 4019,
  [7555] = 4032,
  [7556] = 4025,
  [7557] = 4036,
  [7558] = 4016,
  [7559] = 4009,
  [7560] = 4034,
  [7561] = 4037,
  [7562] = 4025,
  [7563] = 4024,
  [7564] = 4033,
  [7565] = 4020,
  [7566] = 4033,
  [7567] = 4019,
  [7568] = 4016,
  [7569] = 4026,
  [7570] = 4009,
  [7571] = 4012,
  [7572] = 4015,
  [7573] = 4012,
  [7574] = 4033,
  [7575] = 4032,
  [7576] = 4036,
  [7577] = 4032,
  [7578] = 4009,
  [7579] = 4034,
  [7580] = 4036,
  [7581] = 4033,
  [7582] = 4032,
  [7583] = 4036,
  [7584] = 4009,
  [7585] = 4025,
  [7586] = 4024,
  [7587] = 4024,
  [7588] = 4020,
  [7589] = 4019,
  [7590] = 4012,
  [7591] = 4037,
  [7592] = 4026,
  [7593] = 4034,
  [7594] = 4032,
  [7595] = 4037,
  [7596] = 4036,
  [7597] = 4015,
  [7598] = 4036,
  [7599] = 4025,
  [7600] = 4012,
  [7601] = 3994,
  [7602] = 4034,
  [7603] = 4032,
  [7604] = 4036,
  [7605] = 4024,
  [7606] = 4012,
  [7607] = 4037,
  [7608] = 4025,
  [7609] = 4020,
  [7610] = 4019,
  [7611] = 4026,
  [7612] = 4016,
  [7613] = 4015,
  [7614] = 4020,
  [7615] = 4026,
  [7616] = 4015,
  [7617] = 4019,
  [7618] = 4016,
  [7619] = 4009,
  [7620] = 4034,
  [7621] = 4026,
  [7622] = 4037,
  [7623] = 4025,
  [7624] = 4024,
  [7625] = 4019,
  [7626] = 4026,
  [7627] = 4016,
  [7628] = 4026,
  [7629] = 4026,
  [7630] = 4015,
  [7631] = 4012,
  [7632] = 4024,
  [7633] = 4015,
  [7634] = 4015,
  [7635] = 4015,
  [7636] = 4033,
  [7637] = 4026,
  [7638] = 4015,
  [7639] = 3994,
  [7640] = 3994,
  [7641] = 4032,
  [7642] = 4033,
  [7643] = 3994,
  [7644] = 4015,
  [7645] = 4036,
  [7646] = 3994,
  [7647] = 4009,
  [7648] = 4034,
  [7649] = 4026,
  [7650] = 4037,
  [7651] = 4016,
  [7652] = 4032,
  [7653] = 4025,
  [7654] = 4016,
  [7655] = 4024,
  [7656] = 4020,
  [7657] = 4019,
  [7658] = 4019,
  [7659] = 4016,
  [7660] = 4020,
  [7661] = 4024,
  [7662] = 4033,
  [7663] = 3994,
  [7664] = 4025,
  [7665] = 4037,
  [7666] = 4034,
  [7667] = 4012,
  [7668] = 4036,
  [7669] = 4025,
  [7670] = 4009,
  [7671] = 4033,
  [7672] = 4034,
  [7673] = 4019,
  [7674] = 4026,
  [7675] = 4034,
  [7676] = 4024,
  [7677] = 4026,
  [7678] = 4015,
  [7679] = 4037,
  [7680] = 4015,
  [7681] = 4012,
  [7682] = 4025,
  [7683] = 4024,
  [7684] = 4009,
  [7685] = 4009,
  [7686] = 4032,
  [7687] = 4020,
  [7688] = 4026,
  [7689] = 4019,
  [7690] = 4032,
  [7691] = 4033,
  [7692] = 4034,
  [7693] = 4036,
  [7694] = 4015,
  [7695] = 4020,
  [7696] = 4036,
  [7697] = 4036,
  [7698] = 4032,
  [7699] = 4012,
  [7700] = 4032,
  [7701] = 4012,
  [7702] = 4016,
  [7703] = 4036,
  [7704] = 4036,
  [7705] = 4032,
  [7706] = 4009,
  [7707] = 4034,
  [7708] = 4015,
  [7709] = 4012,
  [7710] = 4037,
  [7711] = 4025,
  [7712] = 4032,
  [7713] = 4034,
  [7714] = 4037,
  [7715] = 4016,
  [7716] = 4019,
  [7717] = 4020,
  [7718] = 4024,
  [7719] = 4012,
  [7720] = 4036,
  [7721] = 4025,
  [7722] = 4026,
  [7723] = 4009,
  [7724] = 4012,
  [7725] = 5830,
  [7726] = 4034,
  [7727] = 4024,
  [7728] = 4009,
  [7729] = 4036,
  [7730] = 4020,
  [7731] = 4032,
  [7732] = 4020,
  [7733] = 4019,
  [7734] = 4015,
  [7735] = 4012,
  [7736] = 4036,
  [7737] = 4012,
  [7738] = 4026,
  [7739] = 4034,
  [7740] = 4037,
  [7741] = 4016,
  [7742] = 4009,
  [7743] = 4019,
  [7744] = 4024,
  [7745] = 4025,
  [7746] = 5836,
  [7747] = 4016,
  [7748] = 4025,
  [7749] = 4034,
  [7750] = 4025,
  [7751] = 4037,
  [7752] = 4033,
  [7753] = 4015,
  [7754] = 4020,
  [7755] = 4024,
  [7756] = 4032,
  [7757] = 4019,
  [7758] = 4033,
  [7759] = 4016,
  [7760] = 4037,
  [7761] = 4024,
  [7762] = 4033,
  [7763] = 4033,
  [7764] = 4012,
  [7765] = 4009,
  [7766] = 4026,
  [7767] = 4033,
  [7768] = 4033,
  [7769] = 4025,
  [7770] = 4032,
  [7771] = 4033,
  [7772] = 4033,
  [7773] = 4026,
  [7774] = 4036,
  [7775] = 4016,
  [7776] = 4026,
  [7777] = 4016,
  [7778] = 4015,
  [7779] = 4037,
  [7780] = 4024,
  [7781] = 4016,
  [7782] = 3994,
  [7783] = 4020,
  [7784] = 4032,
  [7785] = 4037,
  [7786] = 4015,
  [7787] = 4024,
  [7788] = 4020,
  [7789] = 4019,
  [7790] = 4019,
  [7791] = 4020,
  [7792] = 4019,
  [7793] = 4016,
  [7794] = 4024,
  [7795] = 4025,
  [7796] = 4015,
  [7797] = 4026,
  [7798] = 4012,
  [7799] = 4020,
  [7800] = 4037,
  [7801] = 4026,
  [7802] = 4009,
  [7803] = 4034,
  [7804] = 4036,
  [7805] = 4034,
  [7806] = 4009,
  [7807] = 4016,
  [7808] = 4037,
  [7809] = 4015,
  [7810] = 4019,
  [7811] = 4025,
  [7812] = 4032,
  [7813] = 4009,
  [7814] = 4024,
  [7815] = 4012,
  [7816] = 4036,
  [7817] = 4034,
  [7818] = 4037,
  [7819] = 4025,
  [7820] = 4020,
  [7821] = 4019,
  [7822] = 4016,
  [7823] = 4033,
  [7824] = 3994,
  [7825] = 4026,
  [7826] = 4015,
  [7827] = 4026,
  [7828] = 4020,
  [7829] = 4033,
  [7830] = 4012,
  [7831] = 4015,
  [7832] = 4026,
  [7833] = 4016,
  [7834] = 4019,
  [7835] = 4032,
  [7836] = 4025,
  [7837] = 4037,
  [7838] = 6670,
  [7839] = 4033,
  [7840] = 4034,
  [7841] = 4036,
  [7842] = 4015,
  [7843] = 4024,
  [7844] = 4009,
  [7845] = 7845,
  [7846] = 7846,
  [7847] = 7847,
  [7848] = 7848,
  [7849] = 7849,
  [7850] = 7850,
  [7851] = 7851,
  [7852] = 7852,
  [7853] = 7853,
  [7854] = 7854,
  [7855] = 7855,
  [7856] = 7856,
  [7857] = 7857,
  [7858] = 7849,
  [7859] = 7848,
  [7860] = 7855,
  [7861] = 7851,
  [7862] = 7854,
  [7863] = 7851,
  [7864] = 7850,
  [7865] = 7845,
  [7866] = 7851,
  [7867] = 7845,
  [7868] = 7852,
  [7869] = 7857,
  [7870] = 7852,
  [7871] = 7845,
  [7872] = 7849,
  [7873] = 7849,
  [7874] = 7846,
  [7875] = 7850,
  [7876] = 7854,
  [7877] = 7877,
  [7878] = 7856,
  [7879] = 7855,
  [7880] = 7857,
  [7881] = 7852,
  [7882] = 7857,
  [7883] = 7846,
  [7884] = 7850,
  [7885] = 7855,
  [7886] = 7848,
  [7887] = 7846,
  [7888] = 7856,
  [7889] = 7848,
  [7890] = 7854,
  [7891] = 7856,
  [7892] = 7846,
  [7893] = 7856,
  [7894] = 7855,
  [7895] = 7846,
  [7896] = 7849,
  [7897] = 7854,
  [7898] = 7857,
  [7899] = 7857,
  [7900] = 7845,
  [7901] = 7850,
  [7902] = 7857,
  [7903] = 7852,
  [7904] = 7845,
  [7905] = 7850,
  [7906] = 7854,
  [7907] = 7855,
  [7908] = 7851,
  [7909] = 7849,
  [7910] = 7856,
  [7911] = 7846,
  [7912] = 7852,
  [7913] = 7848,
  [7914] = 7848,
  [7915] = 7851,
  [7916] = 7855,
  [7917] = 7854,
  [7918] = 7851,
  [7919] = 7855,
  [7920] = 7856,
  [7921] = 7849,
  [7922] = 7854,
  [7923] = 7856,
  [7924] = 7850,
  [7925] = 7845,
  [7926] = 7852,
  [7927] = 7851,
  [7928] = 7857,
  [7929] = 7852,
  [7930] = 7846,
  [7931] = 7845,
  [7932] = 7850,
  [7933] = 7849,
  [7934] = 7848,
  [7935] = 7848,
  [7936] = 7936,
  [7937] = 7937,
  [7938] = 7937,
  [7939] = 7851,
  [7940] = 7850,
  [7941] = 7849,
  [7942] = 7857,
  [7943] = 7846,
  [7944] = 7937,
  [7945] = 7937,
  [7946] = 7848,
  [7947] = 7846,
  [7948] = 7855,
  [7949] = 7936,
  [7950] = 7857,
  [7951] = 7850,
  [7952] = 7845,
  [7953] = 7852,
  [7954] = 7937,
  [7955] = 7856,
  [7956] = 7937,
  [7957] = 7937,
  [7958] = 7937,
  [7959] = 7937,
  [7960] = 7937,
  [7961] = 7849,
  [7962] = 7848,
  [7963] = 7937,
  [7964] = 7937,
  [7965] = 7848,
  [7966] = 7937,
  [7967] = 7849,
  [7968] = 7937,
  [7969] = 7969,
  [7970] = 7851,
  [7971] = 7851,
  [7972] = 7937,
  [7973] = 7937,
  [7974] = 7937,
  [7975] = 7937,
  [7976] = 7937,
  [7977] = 7937,
  [7978] = 7937,
  [7979] = 7852,
  [7980] = 7937,
  [7981] = 7937,
  [7982] = 7937,
  [7983] = 7845,
  [7984] = 7856,
  [7985] = 7937,
  [7986] = 7845,
  [7987] = 7851,
  [7988] = 7855,
  [7989] = 7854,
  [7990] = 7937,
  [7991] = 7854,
  [7992] = 7937,
  [7993] = 7852,
  [7994] = 7937,
  [7995] = 7937,
  [7996] = 7855,
  [7997] = 7937,
  [7998] = 7937,
  [7999] = 7937,
  [8000] = 7849,
  [8001] = 7846,
  [8002] = 7937,
  [8003] = 7852,
  [8004] = 7846,
  [8005] = 7857,
  [8006] = 7937,
  [8007] = 7937,
  [8008] = 7937,
  [8009] = 7969,
  [8010] = 7856,
  [8011] = 7857,
  [8012] = 7845,
  [8013] = 7850,
  [8014] = 7850,
  [8015] = 7856,
  [8016] = 7937,
  [8017] = 7937,
  [8018] = 7937,
  [8019] = 7854,
  [8020] = 7937,
  [8021] = 7855,
  [8022] = 7848,
  [8023] = 7937,
  [8024] = 7937,
  [8025] = 7937,
  [8026] = 7937,
  [8027] = 7854,
  [8028] = 7937,
  [8029] = 7937,
  [8030] = 7856,
  [8031] = 8031,
  [8032] = 8031,
  [8033] = 8031,
  [8034] = 7855,
  [8035] = 8031,
  [8036] = 7851,
  [8037] = 7846,
  [8038] = 8031,
  [8039] = 8031,
  [8040] = 8031,
  [8041] = 8031,
  [8042] = 7852,
  [8043] = 8043,
  [8044] = 8031,
  [8045] = 7857,
  [8046] = 7856,
  [8047] = 8031,
  [8048] = 7854,
  [8049] = 7849,
  [8050] = 7848,
  [8051] = 8031,
  [8052] = 7852,
  [8053] = 8031,
  [8054] = 8031,
  [8055] = 7845,
  [8056] = 7851,
  [8057] = 7850,
  [8058] = 8031,
  [8059] = 7854,
  [8060] = 7855,
  [8061] = 8031,
  [8062] = 8031,
  [8063] = 8043,
  [8064] = 8031,
  [8065] = 7850,
  [8066] = 8031,
  [8067] = 8031,
  [8068] = 7854,
  [8069] = 7845,
  [8070] = 8043,
  [8071] = 7854,
  [8072] = 8031,
  [8073] = 7855,
  [8074] = 8074,
  [8075] = 8031,
  [8076] = 8031,
  [8077] = 8031,
  [8078] = 7852,
  [8079] = 8031,
  [8080] = 7849,
  [8081] = 8031,
  [8082] = 8082,
  [8083] = 7848,
  [8084] = 7846,
  [8085] = 8031,
  [8086] = 8031,
  [8087] = 8087,
  [8088] = 8088,
  [8089] = 8031,
  [8090] = 7857,
  [8091] = 8031,
  [8092] = 8031,
  [8093] = 8031,
  [8094] = 8031,
  [8095] = 8031,
  [8096] = 8031,
  [8097] = 7851,
  [8098] = 8098,
  [8099] = 8031,
  [8100] = 7851,
  [8101] = 7855,
  [8102] = 7850,
  [8103] = 7845,
  [8104] = 8031,
  [8105] = 8105,
  [8106] = 7852,
  [8107] = 7857,
  [8108] = 7856,
  [8109] = 7846,
  [8110] = 7848,
  [8111] = 8031,
  [8112] = 8105,
  [8113] = 7849,
  [8114] = 8031,
  [8115] = 8115,
  [8116] = 7850,
  [8117] = 8031,
  [8118] = 7848,
  [8119] = 8031,
  [8120] = 7856,
  [8121] = 7857,
  [8122] = 7846,
  [8123] = 8031,
  [8124] = 8031,
  [8125] = 8031,
  [8126] = 8031,
  [8127] = 8031,
  [8128] = 7855,
  [8129] = 8115,
  [8130] = 7854,
  [8131] = 7849,
  [8132] = 8031,
  [8133] = 8031,
  [8134] = 7852,
  [8135] = 7851,
  [8136] = 7845,
  [8137] = 7846,
  [8138] = 8031,
  [8139] = 8031,
  [8140] = 8031,
  [8141] = 7857,
  [8142] = 8031,
  [8143] = 8031,
  [8144] = 7850,
  [8145] = 7856,
  [8146] = 8031,
  [8147] = 7848,
  [8148] = 8031,
  [8149] = 7845,
  [8150] = 7849,
  [8151] = 8074,
  [8152] = 8031,
  [8153] = 8031,
  [8154] = 8087,
  [8155] = 8088,
  [8156] = 8031,
  [8157] = 7857,
  [8158] = 7845,
  [8159] = 7850,
  [8160] = 7851,
  [8161] = 7849,
  [8162] = 7852,
  [8163] = 8163,
  [8164] = 8043,
  [8165] = 7846,
  [8166] = 7857,
  [8167] = 7856,
  [8168] = 7848,
  [8169] = 7848,
  [8170] = 7854,
  [8171] = 7855,
  [8172] = 7854,
  [8173] = 7854,
  [8174] = 7855,
  [8175] = 8175,
  [8176] = 7854,
  [8177] = 7856,
  [8178] = 7855,
  [8179] = 7851,
  [8180] = 7850,
  [8181] = 7845,
  [8182] = 7857,
  [8183] = 7852,
  [8184] = 7846,
  [8185] = 7849,
  [8186] = 7856,
  [8187] = 7857,
  [8188] = 7846,
  [8189] = 7846,
  [8190] = 7851,
  [8191] = 7857,
  [8192] = 8163,
  [8193] = 8175,
  [8194] = 7856,
  [8195] = 7849,
  [8196] = 7848,
  [8197] = 7848,
  [8198] = 7852,
  [8199] = 7856,
  [8200] = 8043,
  [8201] = 7845,
  [8202] = 7850,
  [8203] = 7846,
  [8204] = 7851,
  [8205] = 7851,
  [8206] = 8206,
  [8207] = 7855,
  [8208] = 7854,
  [8209] = 7848,
  [8210] = 7855,
  [8211] = 7850,
  [8212] = 7845,
  [8213] = 7852,
  [8214] = 7849,
  [8215] = 7854,
  [8216] = 7851,
  [8217] = 7846,
  [8218] = 7857,
  [8219] = 7856,
  [8220] = 7848,
  [8221] = 7856,
  [8222] = 8222,
  [8223] = 7848,
  [8224] = 7849,
  [8225] = 7857,
  [8226] = 7848,
  [8227] = 7850,
  [8228] = 7852,
  [8229] = 7845,
  [8230] = 7852,
  [8231] = 7849,
  [8232] = 7849,
  [8233] = 7854,
  [8234] = 7852,
  [8235] = 7845,
  [8236] = 7846,
  [8237] = 7850,
  [8238] = 7855,
  [8239] = 7851,
  [8240] = 7845,
  [8241] = 7850,
  [8242] = 7851,
  [8243] = 7855,
  [8244] = 7846,
  [8245] = 7854,
  [8246] = 7849,
  [8247] = 7852,
  [8248] = 7845,
  [8249] = 7850,
  [8250] = 7857,
  [8251] = 7856,
  [8252] = 7851,
  [8253] = 7850,
  [8254] = 7855,
  [8255] = 7845,
  [8256] = 7855,
  [8257] = 8257,
  [8258] = 7852,
  [8259] = 7854,
  [8260] = 7849,
  [8261] = 7848,
  [8262] = 7846,
  [8263] = 7857,
  [8264] = 7856,
  [8265] = 8265,
  [8266] = 7851,
  [8267] = 8265,
  [8268] = 8268,
  [8269] = 8265,
  [8270] = 8265,
  [8271] = 7851,
  [8272] = 7851,
  [8273] = 8265,
  [8274] = 8265,
  [8275] = 8268,
  [8276] = 7850,
  [8277] = 7851,
  [8278] = 7850,
  [8279] = 7845,
  [8280] = 8265,
  [8281] = 7845,
  [8282] = 7852,
  [8283] = 7852,
  [8284] = 8265,
  [8285] = 7849,
  [8286] = 7849,
  [8287] = 8265,
  [8288] = 8268,
  [8289] = 7856,
  [8290] = 7850,
  [8291] = 7845,
  [8292] = 8265,
  [8293] = 7846,
  [8294] = 7852,
  [8295] = 7857,
  [8296] = 7849,
  [8297] = 7855,
  [8298] = 7848,
  [8299] = 8265,
  [8300] = 7851,
  [8301] = 7846,
  [8302] = 8268,
  [8303] = 7846,
  [8304] = 8265,
  [8305] = 7857,
  [8306] = 7857,
  [8307] = 8265,
  [8308] = 7856,
  [8309] = 8265,
  [8310] = 7848,
  [8311] = 7851,
  [8312] = 8265,
  [8313] = 7850,
  [8314] = 7845,
  [8315] = 8268,
  [8316] = 7852,
  [8317] = 7856,
  [8318] = 7849,
  [8319] = 7848,
  [8320] = 8265,
  [8321] = 8268,
  [8322] = 7846,
  [8323] = 7857,
  [8324] = 7850,
  [8325] = 7856,
  [8326] = 7845,
  [8327] = 8265,
  [8328] = 7848,
  [8329] = 7852,
  [8330] = 8265,
  [8331] = 7854,
  [8332] = 7849,
  [8333] = 8265,
  [8334] = 8268,
  [8335] = 7846,
  [8336] = 7854,
  [8337] = 7855,
  [8338] = 7857,
  [8339] = 8265,
  [8340] = 8265,
  [8341] = 8265,
  [8342] = 7856,
  [8343] = 8268,
  [8344] = 7848,
  [8345] = 8268,
  [8346] = 8265,
  [8347] = 7855,
  [8348] = 8265,
  [8349] = 7854,
  [8350] = 7855,
  [8351] = 7851,
  [8352] = 8265,
  [8353] = 7851,
  [8354] = 7854,
  [8355] = 8268,
  [8356] = 8265,
  [8357] = 7854,
  [8358] = 7854,
  [8359] = 8265,
  [8360] = 8265,
  [8361] = 7855,
  [8362] = 7855,
  [8363] = 8268,
  [8364] = 7850,
  [8365] = 7845,
  [8366] = 7852,
  [8367] = 7849,
  [8368] = 8268,
  [8369] = 8268,
  [8370] = 8265,
  [8371] = 8265,
  [8372] = 8268,
  [8373] = 7846,
  [8374] = 7850,
  [8375] = 7845,
  [8376] = 8376,
  [8377] = 7852,
  [8378] = 8265,
  [8379] = 8268,
  [8380] = 7855,
  [8381] = 8265,
  [8382] = 7854,
  [8383] = 7849,
  [8384] = 8268,
  [8385] = 8265,
  [8386] = 7846,
  [8387] = 7857,
  [8388] = 8268,
  [8389] = 8265,
  [8390] = 7851,
  [8391] = 7857,
  [8392] = 7855,
  [8393] = 8268,
  [8394] = 7854,
  [8395] = 7856,
  [8396] = 8268,
  [8397] = 7856,
  [8398] = 8268,
  [8399] = 7848,
  [8400] = 7848,
  [8401] = 7855,
  [8402] = 8268,
  [8403] = 7854,
  [8404] = 7851,
  [8405] = 7854,
  [8406] = 7850,
  [8407] = 8265,
  [8408] = 7845,
  [8409] = 8268,
  [8410] = 8265,
  [8411] = 7852,
  [8412] = 8268,
  [8413] = 7849,
  [8414] = 8268,
  [8415] = 7848,
  [8416] = 7856,
  [8417] = 8265,
  [8418] = 8268,
  [8419] = 7857,
  [8420] = 7846,
  [8421] = 8265,
  [8422] = 7850,
  [8423] = 8268,
  [8424] = 7848,
  [8425] = 7856,
  [8426] = 7849,
  [8427] = 7857,
  [8428] = 8268,
  [8429] = 7852,
  [8430] = 8265,
  [8431] = 8268,
  [8432] = 7846,
  [8433] = 7845,
  [8434] = 7850,
  [8435] = 8268,
  [8436] = 7848,
  [8437] = 7856,
  [8438] = 7849,
  [8439] = 7857,
  [8440] = 7845,
  [8441] = 7846,
  [8442] = 8268,
  [8443] = 8265,
  [8444] = 7845,
  [8445] = 8445,
  [8446] = 8268,
  [8447] = 7850,
  [8448] = 7846,
  [8449] = 8265,
  [8450] = 7848,
  [8451] = 8268,
  [8452] = 7852,
  [8453] = 7856,
  [8454] = 8265,
  [8455] = 8268,
  [8456] = 8268,
  [8457] = 7849,
  [8458] = 7857,
  [8459] = 7852,
  [8460] = 8268,
  [8461] = 7857,
  [8462] = 8265,
  [8463] = 8268,
  [8464] = 7846,
  [8465] = 8265,
  [8466] = 7845,
  [8467] = 7850,
  [8468] = 7851,
  [8469] = 7849,
  [8470] = 8268,
  [8471] = 7852,
  [8472] = 7845,
  [8473] = 7850,
  [8474] = 8265,
  [8475] = 7851,
  [8476] = 8268,
  [8477] = 7851,
  [8478] = 7855,
  [8479] = 7854,
  [8480] = 7854,
  [8481] = 8265,
  [8482] = 7852,
  [8483] = 8268,
  [8484] = 7849,
  [8485] = 8265,
  [8486] = 7856,
  [8487] = 7848,
  [8488] = 7855,
  [8489] = 8268,
  [8490] = 8268,
  [8491] = 8265,
  [8492] = 8265,
  [8493] = 7846,
  [8494] = 8265,
  [8495] = 8268,
  [8496] = 7857,
  [8497] = 8268,
  [8498] = 7855,
  [8499] = 7854,
  [8500] = 7848,
  [8501] = 7855,
  [8502] = 7856,
  [8503] = 7854,
  [8504] = 8268,
  [8505] = 7857,
  [8506] = 8265,
  [8507] = 7846,
  [8508] = 8265,
  [8509] = 7849,
  [8510] = 7852,
  [8511] = 8268,
  [8512] = 7845,
  [8513] = 7850,
  [8514] = 7851,
  [8515] = 7848,
  [8516] = 7856,
  [8517] = 8265,
  [8518] = 8268,
  [8519] = 7855,
  [8520] = 7846,
  [8521] = 7851,
  [8522] = 7857,
  [8523] = 7856,
  [8524] = 7848,
  [8525] = 7849,
  [8526] = 7850,
  [8527] = 7845,
  [8528] = 7852,
  [8529] = 7852,
  [8530] = 7849,
  [8531] = 7845,
  [8532] = 7854,
  [8533] = 7850,
  [8534] = 7855,
  [8535] = 7846,
  [8536] = 7857,
  [8537] = 7856,
  [8538] = 7848,
  [8539] = 7855,
  [8540] = 7854,
  [8541] = 7855,
  [8542] = 7854,
  [8543] = 7857,
  [8544] = 7851,
  [8545] = 7851,
  [8546] = 7850,
  [8547] = 7845,
  [8548] = 7852,
  [8549] = 7849,
  [8550] = 7846,
  [8551] = 7855,
  [8552] = 7854,
  [8553] = 7856,
  [8554] = 7855,
  [8555] = 7854,
  [8556] = 7848,
  [8557] = 7848,
  [8558] = 7856,
  [8559] = 7855,
  [8560] = 7857,
  [8561] = 7854,
  [8562] = 7846,
  [8563] = 7851,
  [8564] = 7849,
  [8565] = 7852,
  [8566] = 7845,
  [8567] = 7850,
  [8568] = 7848,
  [8569] = 7856,
  [8570] = 7857,
  [8571] = 7846,
  [8572] = 7851,
  [8573] = 7848,
  [8574] = 7855,
  [8575] = 7855,
  [8576] = 7856,
  [8577] = 7854,
  [8578] = 7849,
  [8579] = 7857,
  [8580] = 7848,
  [8581] = 7856,
  [8582] = 7857,
  [8583] = 7846,
  [8584] = 7852,
  [8585] = 7846,
  [8586] = 7845,
  [8587] = 7849,
  [8588] = 7850,
  [8589] = 7851,
  [8590] = 7854,
  [8591] = 7849,
  [8592] = 7845,
  [8593] = 7850,
  [8594] = 7848,
  [8595] = 7852,
  [8596] = 7856,
  [8597] = 7845,
  [8598] = 7850,
  [8599] = 7857,
  [8600] = 8600,
  [8601] = 7846,
  [8602] = 7855,
  [8603] = 7854,
  [8604] = 7848,
  [8605] = 7851,
  [8606] = 7856,
  [8607] = 7857,
  [8608] = 7849,
  [8609] = 7846,
  [8610] = 7849,
  [8611] = 7852,
  [8612] = 7845,
  [8613] = 7852,
  [8614] = 7850,
  [8615] = 7845,
  [8616] = 7850,
  [8617] = 7851,
  [8618] = 7848,
  [8619] = 7856,
  [8620] = 7857,
  [8621] = 7846,
  [8622] = 7849,
  [8623] = 7852,
  [8624] = 7845,
  [8625] = 7851,
  [8626] = 7850,
  [8627] = 7855,
  [8628] = 7852,
  [8629] = 7854,
  [8630] = 7851,
  [8631] = 8631,
  [8632] = 8632,
  [8633] = 8631,
  [8634] = 8631,
  [8635] = 8631,
  [8636] = 8631,
  [8637] = 8600,
  [8638] = 8631,
  [8639] = 8631,
  [8640] = 8631,
  [8641] = 8631,
  [8642] = 8631,
  [8643] = 8631,
  [8644] = 8631,
  [8645] = 8631,
  [8646] = 8631,
  [8647] = 8631,
  [8648] = 8631,
  [8649] = 8631,
  [8650] = 8631,
  [8651] = 8631,
  [8652] = 8631,
  [8653] = 8600,
  [8654] = 8631,
  [8655] = 8631,
  [8656] = 8631,
  [8657] = 8631,
  [8658] = 8658,
  [8659] = 8631,
  [8660] = 8631,
  [8661] = 8661,
  [8662] = 8631,
  [8663] = 8663,
  [8664] = 3994,
  [8665] = 8631,
  [8666] = 8631,
  [8667] = 8631,
  [8668] = 8600,
  [8669] = 8631,
  [8670] = 8631,
  [8671] = 8671,
  [8672] = 8631,
  [8673] = 8631,
  [8674] = 8631,
  [8675] = 8631,
  [8676] = 8631,
  [8677] = 8663,
  [8678] = 8631,
  [8679] = 8631,
  [8680] = 8631,
  [8681] = 8661,
  [8682] = 8631,
  [8683] = 8683,
  [8684] = 8631,
  [8685] = 8631,
  [8686] = 8631,
  [8687] = 8631,
  [8688] = 8631,
  [8689] = 8689,
  [8690] = 8689,
  [8691] = 8689,
  [8692] = 8689,
  [8693] = 8689,
  [8694] = 8689,
  [8695] = 8689,
  [8696] = 8689,
  [8697] = 8689,
  [8698] = 8689,
  [8699] = 8689,
  [8700] = 8689,
  [8701] = 8701,
  [8702] = 8689,
  [8703] = 8689,
  [8704] = 8689,
  [8705] = 8689,
  [8706] = 8689,
  [8707] = 8689,
  [8708] = 8689,
  [8709] = 8689,
  [8710] = 8689,
  [8711] = 7857,
  [8712] = 8689,
  [8713] = 8689,
  [8714] = 8689,
  [8715] = 8689,
  [8716] = 8689,
  [8717] = 8689,
  [8718] = 8689,
  [8719] = 8719,
  [8720] = 8689,
  [8721] = 8689,
  [8722] = 8689,
  [8723] = 8689,
  [8724] = 8689,
  [8725] = 8689,
  [8726] = 8689,
  [8727] = 8689,
  [8728] = 8689,
  [8729] = 8689,
  [8730] = 8689,
  [8731] = 8689,
  [8732] = 8689,
  [8733] = 8689,
  [8734] = 8689,
  [8735] = 8689,
  [8736] = 8689,
  [8737] = 8689,
  [8738] = 8689,
  [8739] = 8689,
  [8740] = 8689,
  [8741] = 8689,
  [8742] = 8689,
  [8743] = 8689,
  [8744] = 8689,
  [8745] = 8689,
  [8746] = 8689,
  [8747] = 8689,
  [8748] = 7851,
  [8749] = 8689,
  [8750] = 7848,
  [8751] = 8689,
  [8752] = 8689,
  [8753] = 8600,
  [8754] = 8689,
  [8755] = 8689,
  [8756] = 8689,
  [8757] = 8689,
  [8758] = 8689,
  [8759] = 8689,
  [8760] = 8689,
  [8761] = 8689,
  [8762] = 8689,
  [8763] = 4009,
  [8764] = 8689,
  [8765] = 8689,
  [8766] = 8689,
  [8767] = 8689,
  [8768] = 7856,
  [8769] = 7846,
  [8770] = 8689,
  [8771] = 8689,
  [8772] = 8689,
  [8773] = 8689,
  [8774] = 8689,
  [8775] = 8689,
  [8776] = 8689,
  [8777] = 8689,
  [8778] = 8689,
  [8779] = 8689,
  [8780] = 8689,
  [8781] = 8689,
  [8782] = 8689,
  [8783] = 8689,
  [8784] = 8689,
  [8785] = 8689,
  [8786] = 8689,
  [8787] = 8689,
  [8788] = 8689,
  [8789] = 8689,
  [8790] = 8689,
  [8791] = 8689,
  [8792] = 8689,
  [8793] = 8689,
  [8794] = 8689,
  [8795] = 8689,
  [8796] = 8689,
  [8797] = 8689,
  [8798] = 8689,
  [8799] = 8689,
  [8800] = 8689,
  [8801] = 8689,
  [8802] = 8689,
  [8803] = 8689,
  [8804] = 8600,
  [8805] = 4024,
  [8806] = 8689,
  [8807] = 8689,
  [8808] = 8689,
  [8809] = 4032,
  [8810] = 8689,
  [8811] = 8689,
  [8812] = 8689,
  [8813] = 8689,
  [8814] = 8689,
  [8815] = 8689,
  [8816] = 8689,
  [8817] = 8689,
  [8818] = 8689,
  [8819] = 8600,
  [8820] = 8689,
  [8821] = 8821,
  [8822] = 8689,
  [8823] = 8689,
  [8824] = 8689,
  [8825] = 8689,
  [8826] = 8689,
  [8827] = 7850,
  [8828] = 7845,
  [8829] = 8689,
  [8830] = 8689,
  [8831] = 8689,
  [8832] = 4012,
  [8833] = 8689,
  [8834] = 4033,
  [8835] = 4026,
  [8836] = 7856,
  [8837] = 8689,
  [8838] = 4036,
  [8839] = 8689,
  [8840] = 7852,
  [8841] = 4034,
  [8842] = 8689,
  [8843] = 8689,
  [8844] = 7849,
  [8845] = 8689,
  [8846] = 8689,
  [8847] = 8689,
  [8848] = 8848,
  [8849] = 4037,
  [8850] = 8689,
  [8851] = 7850,
  [8852] = 8689,
  [8853] = 8689,
  [8854] = 7845,
  [8855] = 4015,
  [8856] = 4025,
  [8857] = 7846,
  [8858] = 7852,
  [8859] = 7857,
  [8860] = 8689,
  [8861] = 8689,
  [8862] = 7849,
  [8863] = 8689,
  [8864] = 8689,
  [8865] = 8689,
  [8866] = 4020,
  [8867] = 4019,
  [8868] = 8689,
  [8869] = 7856,
  [8870] = 8689,
  [8871] = 7848,
  [8872] = 8689,
  [8873] = 7849,
  [8874] = 8689,
  [8875] = 8689,
  [8876] = 8689,
  [8877] = 8689,
  [8878] = 8689,
  [8879] = 7846,
  [8880] = 7857,
  [8881] = 8689,
  [8882] = 8689,
  [8883] = 8689,
  [8884] = 8689,
  [8885] = 7848,
  [8886] = 8689,
  [8887] = 7851,
  [8888] = 8689,
  [8889] = 8689,
  [8890] = 4016,
  [8891] = 8689,
  [8892] = 8689,
  [8893] = 7852,
  [8894] = 8689,
  [8895] = 8689,
  [8896] = 8689,
  [8897] = 8689,
  [8898] = 8689,
  [8899] = 8689,
  [8900] = 8689,
  [8901] = 7845,
  [8902] = 8689,
  [8903] = 8689,
  [8904] = 8689,
  [8905] = 8689,
  [8906] = 8689,
  [8907] = 7850,
  [8908] = 4033,
  [8909] = 8689,
  [8910] = 8689,
  [8911] = 8689,
  [8912] = 8689,
  [8913] = 8689,
  [8914] = 7851,
  [8915] = 8689,
  [8916] = 8689,
  [8917] = 8600,
  [8918] = 8689,
  [8919] = 8689,
  [8920] = 8689,
  [8921] = 8689,
  [8922] = 8689,
  [8923] = 5836,
  [8924] = 8924,
  [8925] = 7856,
  [8926] = 8926,
  [8927] = 7851,
  [8928] = 8600,
  [8929] = 8929,
  [8930] = 8930,
  [8931] = 7851,
  [8932] = 7846,
  [8933] = 7857,
  [8934] = 8934,
  [8935] = 7856,
  [8936] = 8936,
  [8937] = 8937,
  [8938] = 8938,
  [8939] = 8939,
  [8940] = 7857,
  [8941] = 8941,
  [8942] = 7849,
  [8943] = 8943,
  [8944] = 8938,
  [8945] = 8945,
  [8946] = 8946,
  [8947] = 8947,
  [8948] = 8948,
  [8949] = 8949,
  [8950] = 7852,
  [8951] = 8951,
  [8952] = 8951,
  [8953] = 8848,
  [8954] = 7846,
  [8955] = 8955,
  [8956] = 7845,
  [8957] = 8957,
  [8958] = 7850,
  [8959] = 8941,
  [8960] = 7848,
  [8961] = 8961,
  [8962] = 7855,
  [8963] = 8963,
  [8964] = 8955,
  [8965] = 7854,
  [8966] = 8963,
  [8967] = 8600,
  [8968] = 8929,
  [8969] = 7849,
  [8970] = 8957,
  [8971] = 8963,
  [8972] = 7852,
  [8973] = 8946,
  [8974] = 8948,
  [8975] = 7845,
  [8976] = 8943,
  [8977] = 7850,
  [8978] = 8939,
  [8979] = 8979,
  [8980] = 7848,
  [8981] = 8924,
  [8982] = 8961,
  [8983] = 8983,
  [8984] = 8600,
  [8985] = 4033,
  [8986] = 8986,
  [8987] = 8987,
  [8988] = 8988,
  [8989] = 8963,
  [8990] = 8930,
  [8991] = 8934,
  [8992] = 8949,
  [8993] = 8986,
  [8994] = 8947,
  [8995] = 8995,
  [8996] = 8995,
  [8997] = 8997,
  [8998] = 8600,
  [8999] = 8987,
  [9000] = 8988,
  [9001] = 8997,
  [9002] = 8937,
  [9003] = 8945,
  [9004] = 9004,
  [9005] = 9005,
  [9006] = 9006,
  [9007] = 9007,
  [9008] = 7846,
  [9009] = 7851,
  [9010] = 8926,
  [9011] = 9011,
  [9012] = 7852,
  [9013] = 9013,
  [9014] = 9014,
  [9015] = 9015,
  [9016] = 8600,
  [9017] = 8926,
  [9018] = 9018,
  [9019] = 9019,
  [9020] = 9020,
  [9021] = 7856,
  [9022] = 7850,
  [9023] = 7845,
  [9024] = 9024,
  [9025] = 9025,
  [9026] = 7850,
  [9027] = 9027,
  [9028] = 9027,
  [9029] = 7845,
  [9030] = 9027,
  [9031] = 9027,
  [9032] = 8600,
  [9033] = 8983,
  [9034] = 7852,
  [9035] = 8600,
  [9036] = 8926,
  [9037] = 9037,
  [9038] = 9038,
  [9039] = 7848,
  [9040] = 9040,
  [9041] = 7849,
  [9042] = 7857,
  [9043] = 7849,
  [9044] = 8600,
  [9045] = 9045,
  [9046] = 9045,
  [9047] = 9045,
  [9048] = 9045,
  [9049] = 4033,
  [9050] = 9045,
  [9051] = 9045,
  [9052] = 9052,
  [9053] = 9045,
  [9054] = 4026,
  [9055] = 9045,
  [9056] = 9045,
  [9057] = 9045,
  [9058] = 8926,
  [9059] = 9059,
  [9060] = 9045,
  [9061] = 9045,
  [9062] = 4015,
  [9063] = 9045,
  [9064] = 9045,
  [9065] = 9045,
  [9066] = 9045,
  [9067] = 9038,
  [9068] = 9045,
  [9069] = 9045,
  [9070] = 9045,
  [9071] = 8600,
  [9072] = 8600,
  [9073] = 9045,
  [9074] = 9074,
  [9075] = 9045,
  [9076] = 8926,
  [9077] = 9045,
  [9078] = 9045,
  [9079] = 9045,
  [9080] = 9045,
  [9081] = 9045,
  [9082] = 9045,
  [9083] = 9045,
  [9084] = 9084,
  [9085] = 9045,
  [9086] = 9045,
  [9087] = 9087,
  [9088] = 9088,
  [9089] = 9045,
  [9090] = 9045,
  [9091] = 9007,
  [9092] = 9092,
  [9093] = 9093,
  [9094] = 9045,
  [9095] = 9045,
  [9096] = 9096,
  [9097] = 9045,
  [9098] = 9045,
  [9099] = 8600,
  [9100] = 8600,
  [9101] = 9045,
  [9102] = 9045,
  [9103] = 9103,
  [9104] = 9045,
  [9105] = 8926,
  [9106] = 9045,
  [9107] = 9045,
  [9108] = 8600,
  [9109] = 9045,
  [9110] = 9040,
  [9111] = 9045,
  [9112] = 8600,
  [9113] = 9045,
  [9114] = 9114,
  [9115] = 9103,
  [9116] = 9116,
  [9117] = 9117,
  [9118] = 8600,
  [9119] = 9045,
  [9120] = 9045,
  [9121] = 9121,
  [9122] = 9045,
  [9123] = 9103,
  [9124] = 9088,
  [9125] = 8926,
  [9126] = 9045,
  [9127] = 9045,
  [9128] = 9045,
  [9129] = 9129,
  [9130] = 9130,
  [9131] = 9045,
  [9132] = 9045,
  [9133] = 9045,
  [9134] = 9045,
  [9135] = 9135,
  [9136] = 9045,
  [9137] = 9137,
  [9138] = 8600,
  [9139] = 6670,
  [9140] = 9045,
  [9141] = 9141,
  [9142] = 9142,
  [9143] = 8600,
  [9144] = 8600,
  [9145] = 9114,
  [9146] = 8600,
  [9147] = 8600,
  [9148] = 9148,
  [9149] = 9149,
  [9150] = 9087,
  [9151] = 8600,
  [9152] = 9059,
  [9153] = 8600,
  [9154] = 8600,
  [9155] = 9155,
  [9156] = 8600,
  [9157] = 8926,
  [9158] = 9158,
  [9159] = 9159,
  [9160] = 8600,
  [9161] = 8600,
  [9162] = 8926,
  [9163] = 8600,
  [9164] = 9164,
  [9165] = 8926,
  [9166] = 9121,
  [9167] = 8926,
  [9168] = 9135,
  [9169] = 9169,
  [9170] = 8600,
  [9171] = 9171,
  [9172] = 9172,
  [9173] = 9173,
  [9174] = 9084,
  [9175] = 9093,
  [9176] = 8663,
  [9177] = 8661,
  [9178] = 8600,
  [9179] = 9179,
  [9180] = 9180,
  [9181] = 8600,
  [9182] = 9137,
  [9183] = 9183,
  [9184] = 9184,
  [9185] = 9185,
  [9186] = 9185,
  [9187] = 9185,
  [9188] = 9185,
  [9189] = 9185,
  [9190] = 9185,
  [9191] = 9185,
  [9192] = 9185,
  [9193] = 9185,
  [9194] = 9185,
  [9195] = 9185,
  [9196] = 9185,
  [9197] = 9185,
  [9198] = 9185,
  [9199] = 9185,
  [9200] = 9185,
  [9201] = 9185,
  [9202] = 9185,
  [9203] = 9185,
  [9204] = 9185,
  [9205] = 9185,
  [9206] = 9185,
  [9207] = 8600,
  [9208] = 9185,
  [9209] = 9185,
  [9210] = 9185,
  [9211] = 9185,
  [9212] = 9185,
  [9213] = 9185,
  [9214] = 9214,
  [9215] = 9185,
  [9216] = 9185,
  [9217] = 9185,
  [9218] = 9185,
  [9219] = 9185,
  [9220] = 9185,
  [9221] = 9185,
  [9222] = 9185,
  [9223] = 9185,
  [9224] = 9185,
  [9225] = 9185,
  [9226] = 9185,
  [9227] = 9185,
  [9228] = 8926,
  [9229] = 8600,
  [9230] = 9185,
  [9231] = 9185,
  [9232] = 8600,
  [9233] = 9185,
  [9234] = 9185,
  [9235] = 9185,
  [9236] = 9185,
  [9237] = 9185,
  [9238] = 9185,
  [9239] = 9185,
  [9240] = 9185,
  [9241] = 9185,
  [9242] = 9180,
  [9243] = 9185,
  [9244] = 9185,
  [9245] = 9185,
  [9246] = 9185,
  [9247] = 9185,
  [9248] = 9185,
  [9249] = 9185,
  [9250] = 9185,
  [9251] = 8600,
  [9252] = 9185,
  [9253] = 9185,
  [9254] = 9185,
  [9255] = 9185,
  [9256] = 9185,
  [9257] = 9185,
  [9258] = 9185,
  [9259] = 9185,
  [9260] = 9185,
  [9261] = 9185,
  [9262] = 9185,
  [9263] = 8600,
  [9264] = 9185,
  [9265] = 9185,
  [9266] = 9185,
  [9267] = 8926,
  [9268] = 9185,
  [9269] = 9185,
  [9270] = 9185,
  [9271] = 9185,
  [9272] = 9185,
  [9273] = 9185,
  [9274] = 9185,
  [9275] = 9185,
  [9276] = 9185,
  [9277] = 9185,
  [9278] = 9278,
  [9279] = 9185,
  [9280] = 9185,
  [9281] = 9185,
  [9282] = 9185,
  [9283] = 9283,
  [9284] = 9185,
  [9285] = 9185,
  [9286] = 9286,
  [9287] = 9185,
  [9288] = 9185,
  [9289] = 9185,
  [9290] = 9185,
  [9291] = 9185,
  [9292] = 9185,
  [9293] = 9293,
  [9294] = 9185,
  [9295] = 9185,
  [9296] = 9185,
  [9297] = 9185,
  [9298] = 9185,
  [9299] = 9299,
  [9300] = 9185,
  [9301] = 9185,
  [9302] = 9185,
  [9303] = 9185,
  [9304] = 9185,
  [9305] = 9185,
  [9306] = 9185,
  [9307] = 9185,
  [9308] = 9185,
  [9309] = 9185,
  [9310] = 9185,
  [9311] = 9311,
  [9312] = 9312,
  [9313] = 9185,
  [9314] = 9185,
  [9315] = 9315,
  [9316] = 9185,
  [9317] = 9317,
  [9318] = 9185,
  [9319] = 9185,
  [9320] = 9185,
  [9321] = 9185,
  [9322] = 9185,
  [9323] = 9323,
  [9324] = 9185,
  [9325] = 9185,
  [9326] = 9185,
  [9327] = 9185,
  [9328] = 9185,
  [9329] = 9185,
  [9330] = 8600,
  [9331] = 9185,
  [9332] = 9185,
  [9333] = 9185,
  [9334] = 9185,
  [9335] = 9185,
  [9336] = 9185,
  [9337] = 9185,
  [9338] = 9185,
  [9339] = 9339,
  [9340] = 9340,
  [9341] = 9185,
  [9342] = 9185,
  [9343] = 9185,
  [9344] = 9185,
  [9345] = 9323,
  [9346] = 9185,
  [9347] = 9185,
  [9348] = 9185,
  [9349] = 9185,
  [9350] = 9185,
  [9351] = 8926,
  [9352] = 9185,
  [9353] = 9185,
  [9354] = 9185,
  [9355] = 9185,
  [9356] = 8600,
  [9357] = 9185,
  [9358] = 9185,
  [9359] = 9185,
  [9360] = 9185,
  [9361] = 9185,
  [9362] = 9185,
  [9363] = 9185,
  [9364] = 9185,
  [9365] = 9185,
  [9366] = 9185,
  [9367] = 9185,
  [9368] = 9185,
  [9369] = 9185,
  [9370] = 9185,
  [9371] = 9185,
  [9372] = 8926,
  [9373] = 9185,
  [9374] = 9185,
  [9375] = 9185,
  [9376] = 9185,
  [9377] = 9185,
  [9378] = 9185,
  [9379] = 9185,
  [9380] = 8600,
  [9381] = 9185,
  [9382] = 9185,
  [9383] = 9185,
  [9384] = 9185,
  [9385] = 9385,
  [9386] = 9185,
  [9387] = 9185,
  [9388] = 9388,
  [9389] = 9185,
  [9390] = 9185,
  [9391] = 9385,
  [9392] = 9388,
  [9393] = 9185,
  [9394] = 9185,
  [9395] = 9185,
  [9396] = 9293,
  [9397] = 9214,
  [9398] = 9183,
  [9399] = 4033,
  [9400] = 9185,
  [9401] = 9185,
  [9402] = 9185,
  [9403] = 9185,
  [9404] = 8926,
  [9405] = 8948,
  [9406] = 8926,
  [9407] = 9407,
  [9408] = 9408,
  [9409] = 9409,
  [9410] = 9410,
  [9411] = 9408,
  [9412] = 9409,
  [9413] = 9129,
  [9414] = 9414,
  [9415] = 8951,
  [9416] = 9416,
  [9417] = 9417,
  [9418] = 8926,
  [9419] = 9419,
  [9420] = 9420,
  [9421] = 9421,
  [9422] = 9422,
  [9423] = 8926,
  [9424] = 9424,
  [9425] = 9410,
  [9426] = 8926,
  [9427] = 9427,
  [9428] = 9428,
  [9429] = 9429,
  [9430] = 7851,
  [9431] = 8963,
  [9432] = 9432,
  [9433] = 9433,
  [9434] = 9434,
  [9435] = 9435,
  [9436] = 9436,
  [9437] = 9407,
  [9438] = 9438,
  [9439] = 9439,
  [9440] = 8926,
  [9441] = 9441,
  [9442] = 9410,
  [9443] = 9443,
  [9444] = 9444,
  [9445] = 8926,
  [9446] = 9446,
  [9447] = 9447,
  [9448] = 9448,
  [9449] = 9447,
  [9450] = 9450,
  [9451] = 9451,
  [9452] = 9410,
  [9453] = 9453,
  [9454] = 8997,
  [9455] = 9455,
  [9456] = 8995,
  [9457] = 9116,
  [9458] = 8930,
  [9459] = 8988,
  [9460] = 8987,
  [9461] = 8986,
  [9462] = 9129,
  [9463] = 9416,
  [9464] = 9447,
  [9465] = 8941,
  [9466] = 8939,
  [9467] = 8943,
  [9468] = 9468,
  [9469] = 8946,
  [9470] = 8955,
  [9471] = 8957,
  [9472] = 8929,
  [9473] = 8963,
  [9474] = 8924,
  [9475] = 8961,
  [9476] = 8949,
  [9477] = 9477,
  [9478] = 8947,
  [9479] = 8945,
  [9480] = 8938,
  [9481] = 8937,
  [9482] = 9482,
  [9483] = 9116,
  [9484] = 9484,
  [9485] = 9129,
  [9486] = 8926,
  [9487] = 9447,
  [9488] = 9488,
  [9489] = 9116,
  [9490] = 9490,
  [9491] = 9490,
  [9492] = 9490,
  [9493] = 9493,
  [9494] = 9493,
  [9495] = 9495,
  [9496] = 9495,
  [9497] = 9493,
  [9498] = 9490,
  [9499] = 9495,
  [9500] = 9493,
  [9501] = 9493,
  [9502] = 9493,
  [9503] = 9493,
  [9504] = 9504,
  [9505] = 9505,
  [9506] = 9506,
  [9507] = 9495,
  [9508] = 9490,
  [9509] = 9495,
  [9510] = 9490,
  [9511] = 9493,
  [9512] = 9495,
  [9513] = 9493,
  [9514] = 9495,
  [9515] = 9493,
  [9516] = 9493,
  [9517] = 9490,
  [9518] = 8926,
  [9519] = 9490,
  [9520] = 9495,
  [9521] = 8926,
  [9522] = 9495,
  [9523] = 9493,
  [9524] = 9495,
  [9525] = 9495,
  [9526] = 9490,
  [9527] = 8926,
  [9528] = 9490,
  [9529] = 9493,
  [9530] = 8926,
  [9531] = 9490,
  [9532] = 9493,
  [9533] = 9495,
  [9534] = 9493,
  [9535] = 9490,
  [9536] = 9495,
  [9537] = 9537,
  [9538] = 9493,
  [9539] = 9495,
  [9540] = 8926,
  [9541] = 9495,
  [9542] = 9490,
  [9543] = 9490,
  [9544] = 9490,
  [9545] = 9495,
  [9546] = 9546,
  [9547] = 9493,
  [9548] = 8926,
  [9549] = 9495,
  [9550] = 9493,
  [9551] = 9490,
  [9552] = 9495,
  [9553] = 9553,
  [9554] = 9490,
  [9555] = 9555,
  [9556] = 9495,
  [9557] = 9493,
  [9558] = 9558,
  [9559] = 8926,
  [9560] = 9493,
  [9561] = 9493,
  [9562] = 9490,
  [9563] = 9495,
  [9564] = 9564,
  [9565] = 9493,
  [9566] = 9490,
  [9567] = 9490,
  [9568] = 9495,
  [9569] = 9564,
  [9570] = 9570,
  [9571] = 9571,
  [9572] = 9572,
  [9573] = 9493,
  [9574] = 9490,
  [9575] = 9490,
  [9576] = 9495,
  [9577] = 9490,
  [9578] = 9578,
  [9579] = 9493,
  [9580] = 9490,
  [9581] = 9581,
  [9582] = 9495,
  [9583] = 9583,
  [9584] = 9493,
  [9585] = 9585,
  [9586] = 9495,
  [9587] = 9583,
  [9588] = 9490,
  [9589] = 9589,
  [9590] = 9589,
  [9591] = 9493,
  [9592] = 9495,
  [9593] = 9495,
  [9594] = 9493,
  [9595] = 9493,
  [9596] = 8926,
  [9597] = 9493,
  [9598] = 9493,
  [9599] = 8926,
  [9600] = 9490,
  [9601] = 9601,
  [9602] = 9495,
  [9603] = 9490,
  [9604] = 9490,
  [9605] = 9605,
  [9606] = 9495,
  [9607] = 8926,
  [9608] = 9493,
  [9609] = 9490,
  [9610] = 9495,
  [9611] = 9495,
  [9612] = 9490,
  [9613] = 9490,
  [9614] = 9495,
  [9615] = 9495,
  [9616] = 9616,
  [9617] = 9617,
  [9618] = 9493,
  [9619] = 9619,
  [9620] = 9558,
  [9621] = 9621,
  [9622] = 9490,
  [9623] = 9623,
  [9624] = 9537,
  [9625] = 9490,
  [9626] = 8926,
  [9627] = 9495,
  [9628] = 9495,
  [9629] = 9493,
  [9630] = 9450,
  [9631] = 9631,
  [9632] = 9495,
  [9633] = 9493,
  [9634] = 9634,
  [9635] = 9635,
  [9636] = 9495,
  [9637] = 9490,
  [9638] = 9493,
  [9639] = 9490,
  [9640] = 9493,
  [9641] = 9641,
  [9642] = 9493,
  [9643] = 9490,
  [9644] = 9490,
  [9645] = 9645,
  [9646] = 9495,
  [9647] = 9647,
  [9648] = 9648,
  [9649] = 9555,
  [9650] = 9451,
  [9651] = 9651,
  [9652] = 9652,
  [9653] = 9493,
  [9654] = 9495,
  [9655] = 8926,
  [9656] = 9495,
  [9657] = 9493,
  [9658] = 9495,
  [9659] = 9490,
  [9660] = 9495,
  [9661] = 9490,
  [9662] = 9662,
  [9663] = 9493,
  [9664] = 9490,
  [9665] = 9495,
  [9666] = 9666,
  [9667] = 9578,
  [9668] = 9668,
  [9669] = 9493,
  [9670] = 9670,
  [9671] = 9490,
  [9672] = 9493,
  [9673] = 9673,
  [9674] = 9495,
  [9675] = 9495,
  [9676] = 9495,
  [9677] = 9493,
  [9678] = 9444,
  [9679] = 9495,
  [9680] = 9680,
  [9681] = 9490,
  [9682] = 9493,
  [9683] = 9490,
  [9684] = 9490,
  [9685] = 8926,
  [9686] = 7851,
  [9687] = 8926,
  [9688] = 9493,
  [9689] = 9490,
  [9690] = 9490,
  [9691] = 9493,
  [9692] = 9495,
  [9693] = 7851,
  [9694] = 9493,
  [9695] = 9695,
  [9696] = 9696,
  [9697] = 9697,
  [9698] = 9698,
  [9699] = 9699,
  [9700] = 9695,
  [9701] = 9701,
  [9702] = 9702,
  [9703] = 9703,
  [9704] = 9696,
  [9705] = 9697,
  [9706] = 9698,
  [9707] = 9702,
  [9708] = 9695,
  [9709] = 9699,
  [9710] = 9699,
  [9711] = 9695,
  [9712] = 9702,
  [9713] = 9701,
  [9714] = 9703,
  [9715] = 9698,
  [9716] = 9716,
  [9717] = 9696,
  [9718] = 9697,
  [9719] = 9698,
  [9720] = 9703,
  [9721] = 9703,
  [9722] = 9701,
  [9723] = 9699,
  [9724] = 9703,
  [9725] = 9695,
  [9726] = 9697,
  [9727] = 9696,
  [9728] = 9702,
  [9729] = 9701,
  [9730] = 9703,
  [9731] = 9702,
  [9732] = 9695,
  [9733] = 9733,
  [9734] = 9701,
  [9735] = 9699,
  [9736] = 9703,
  [9737] = 9696,
  [9738] = 9697,
  [9739] = 9698,
  [9740] = 9698,
  [9741] = 9697,
  [9742] = 9696,
  [9743] = 9697,
  [9744] = 9699,
  [9745] = 9695,
  [9746] = 9701,
  [9747] = 9702,
  [9748] = 9703,
  [9749] = 9701,
  [9750] = 9701,
  [9751] = 9703,
  [9752] = 9702,
  [9753] = 9696,
  [9754] = 9695,
  [9755] = 9697,
  [9756] = 9699,
  [9757] = 9698,
  [9758] = 9701,
  [9759] = 9703,
  [9760] = 9703,
  [9761] = 9701,
  [9762] = 9698,
  [9763] = 9763,
  [9764] = 9699,
  [9765] = 9696,
  [9766] = 9695,
  [9767] = 9702,
  [9768] = 9701,
  [9769] = 9697,
  [9770] = 9703,
  [9771] = 9697,
  [9772] = 9701,
  [9773] = 9696,
  [9774] = 9697,
  [9775] = 9698,
  [9776] = 9703,
  [9777] = 9696,
  [9778] = 9703,
  [9779] = 9699,
  [9780] = 9695,
  [9781] = 9701,
  [9782] = 9702,
  [9783] = 9701,
  [9784] = 9702,
  [9785] = 9701,
  [9786] = 9698,
  [9787] = 9703,
  [9788] = 9702,
  [9789] = 9695,
  [9790] = 9699,
  [9791] = 9695,
  [9792] = 9701,
  [9793] = 9703,
  [9794] = 9699,
  [9795] = 9696,
  [9796] = 9697,
  [9797] = 9698,
  [9798] = 9698,
  [9799] = 9697,
  [9800] = 9696,
  [9801] = 9703,
  [9802] = 9699,
  [9803] = 9695,
  [9804] = 9702,
  [9805] = 9698,
  [9806] = 9701,
  [9807] = 9699,
  [9808] = 9695,
  [9809] = 9702,
  [9810] = 9703,
  [9811] = 9701,
  [9812] = 9812,
  [9813] = 9701,
  [9814] = 9703,
  [9815] = 9703,
  [9816] = 9697,
  [9817] = 9696,
  [9818] = 9702,
  [9819] = 9701,
  [9820] = 9695,
  [9821] = 9703,
  [9822] = 9696,
  [9823] = 9697,
  [9824] = 9698,
  [9825] = 9699,
  [9826] = 9701,
  [9827] = 9699,
  [9828] = 9695,
  [9829] = 9698,
  [9830] = 9697,
  [9831] = 9696,
  [9832] = 9702,
  [9833] = 9701,
  [9834] = 9703,
  [9835] = 9701,
  [9836] = 9702,
  [9837] = 9703,
  [9838] = 9695,
  [9839] = 9701,
  [9840] = 9696,
  [9841] = 9699,
  [9842] = 9697,
  [9843] = 9698,
  [9844] = 9698,
  [9845] = 9703,
  [9846] = 9701,
  [9847] = 9696,
  [9848] = 9699,
  [9849] = 9849,
  [9850] = 9698,
  [9851] = 9703,
  [9852] = 9695,
  [9853] = 9701,
  [9854] = 9701,
  [9855] = 9696,
  [9856] = 9703,
  [9857] = 9857,
  [9858] = 9701,
  [9859] = 9701,
  [9860] = 9702,
  [9861] = 8926,
  [9862] = 9703,
  [9863] = 9703,
  [9864] = 9702,
  [9865] = 9703,
  [9866] = 9703,
  [9867] = 9695,
  [9868] = 9699,
  [9869] = 9701,
  [9870] = 9701,
  [9871] = 9702,
  [9872] = 9695,
  [9873] = 9699,
  [9874] = 9703,
  [9875] = 9696,
  [9876] = 9697,
  [9877] = 9698,
  [9878] = 9698,
  [9879] = 9697,
  [9880] = 9697,
  [9881] = 9696,
  [9882] = 9698,
  [9883] = 9696,
  [9884] = 9703,
  [9885] = 9699,
  [9886] = 9701,
  [9887] = 9695,
  [9888] = 9702,
  [9889] = 9701,
  [9890] = 9890,
  [9891] = 9703,
  [9892] = 9892,
  [9893] = 9702,
  [9894] = 9695,
  [9895] = 9701,
  [9896] = 9699,
  [9897] = 9703,
  [9898] = 9696,
  [9899] = 9698,
  [9900] = 9696,
  [9901] = 9697,
  [9902] = 9697,
  [9903] = 9698,
  [9904] = 9697,
  [9905] = 9696,
  [9906] = 9703,
  [9907] = 9701,
  [9908] = 9699,
  [9909] = 9702,
  [9910] = 9695,
  [9911] = 9699,
  [9912] = 9695,
  [9913] = 9702,
  [9914] = 9701,
  [9915] = 9702,
  [9916] = 9695,
  [9917] = 9698,
  [9918] = 9699,
  [9919] = 9698,
  [9920] = 9697,
  [9921] = 9698,
  [9922] = 9697,
  [9923] = 9696,
  [9924] = 9701,
  [9925] = 9703,
  [9926] = 9701,
  [9927] = 9927,
  [9928] = 9703,
  [9929] = 9702,
  [9930] = 9696,
  [9931] = 9696,
  [9932] = 9699,
  [9933] = 9697,
  [9934] = 9701,
  [9935] = 9695,
  [9936] = 9703,
  [9937] = 9937,
  [9938] = 9698,
  [9939] = 9702,
  [9940] = 9695,
  [9941] = 9699,
  [9942] = 9699,
  [9943] = 9695,
  [9944] = 9698,
  [9945] = 9702,
  [9946] = 9697,
  [9947] = 9696,
  [9948] = 9702,
  [9949] = 9703,
  [9950] = 9695,
  [9951] = 9699,
  [9952] = 9701,
  [9953] = 9702,
  [9954] = 9701,
  [9955] = 9703,
  [9956] = 9695,
  [9957] = 9698,
  [9958] = 9697,
  [9959] = 9696,
  [9960] = 9701,
  [9961] = 9703,
  [9962] = 9696,
  [9963] = 9701,
  [9964] = 9699,
  [9965] = 9697,
  [9966] = 9698,
  [9967] = 9698,
  [9968] = 9697,
  [9969] = 9703,
  [9970] = 9696,
  [9971] = 9703,
  [9972] = 9701,
  [9973] = 9699,
  [9974] = 9695,
  [9975] = 9702,
  [9976] = 9976,
  [9977] = 9977,
  [9978] = 9978,
  [9979] = 9701,
  [9980] = 9703,
  [9981] = 9702,
  [9982] = 9695,
  [9983] = 9699,
  [9984] = 9703,
  [9985] = 9701,
  [9986] = 9701,
  [9987] = 9987,
  [9988] = 9988,
  [9989] = 9698,
  [9990] = 8926,
  [9991] = 9703,
  [9992] = 9697,
  [9993] = 9695,
  [9994] = 9696,
  [9995] = 9702,
  [9996] = 9701,
  [9997] = 9696,
  [9998] = 9697,
  [9999] = 9703,
  [10000] = 9698,
  [10001] = 9699,
  [10002] = 9698,
  [10003] = 9699,
  [10004] = 9695,
  [10005] = 9702,
  [10006] = 9697,
  [10007] = 9696,
  [10008] = 9703,
  [10009] = 9701,
  [10010] = 9701,
  [10011] = 9702,
  [10012] = 9703,
  [10013] = 9695,
  [10014] = 9699,
  [10015] = 9701,
  [10016] = 9697,
  [10017] = 9703,
  [10018] = 9696,
  [10019] = 9702,
  [10020] = 9695,
  [10021] = 9699,
  [10022] = 9697,
  [10023] = 9698,
  [10024] = 9698,
  [10025] = 9697,
  [10026] = 9696,
  [10027] = 9698,
  [10028] = 9697,
  [10029] = 9696,
  [10030] = 10030,
  [10031] = 9703,
  [10032] = 9701,
  [10033] = 9696,
  [10034] = 9701,
  [10035] = 9697,
  [10036] = 9699,
  [10037] = 9702,
  [10038] = 9703,
  [10039] = 9695,
  [10040] = 9699,
  [10041] = 10041,
  [10042] = 9699,
  [10043] = 9695,
  [10044] = 9701,
  [10045] = 9702,
  [10046] = 9698,
  [10047] = 9703,
  [10048] = 9701,
  [10049] = 9703,
  [10050] = 8926,
  [10051] = 9927,
  [10052] = 10052,
  [10053] = 9698,
  [10054] = 9697,
  [10055] = 9696,
  [10056] = 9697,
  [10057] = 9698,
  [10058] = 9702,
  [10059] = 9695,
  [10060] = 9699,
  [10061] = 9696,
  [10062] = 10062,
  [10063] = 9699,
  [10064] = 9695,
  [10065] = 8926,
  [10066] = 10066,
  [10067] = 9702,
  [10068] = 9702,
  [10069] = 9698,
  [10070] = 9695,
  [10071] = 9697,
  [10072] = 9696,
  [10073] = 9927,
  [10074] = 9699,
  [10075] = 9695,
  [10076] = 10076,
  [10077] = 9702,
  [10078] = 10078,
  [10079] = 9698,
  [10080] = 9697,
  [10081] = 9696,
  [10082] = 10078,
  [10083] = 4033,
  [10084] = 8926,
  [10085] = 9703,
  [10086] = 10086,
  [10087] = 7261,
  [10088] = 9701,
  [10089] = 9696,
  [10090] = 9697,
  [10091] = 9698,
  [10092] = 10092,
  [10093] = 10093,
  [10094] = 9696,
  [10095] = 9699,
  [10096] = 9702,
  [10097] = 9695,
  [10098] = 9699,
  [10099] = 9695,
  [10100] = 10100,
  [10101] = 10101,
  [10102] = 9702,
  [10103] = 10103,
  [10104] = 10104,
  [10105] = 10105,
  [10106] = 10106,
  [10107] = 9698,
  [10108] = 10108,
  [10109] = 9698,
  [10110] = 9697,
  [10111] = 9696,
  [10112] = 9703,
  [10113] = 9699,
  [10114] = 9702,
  [10115] = 10115,
  [10116] = 9699,
  [10117] = 9695,
  [10118] = 10118,
  [10119] = 9702,
  [10120] = 10120,
  [10121] = 9696,
  [10122] = 9697,
  [10123] = 10123,
  [10124] = 10124,
  [10125] = 10125,
  [10126] = 10126,
  [10127] = 10127,
  [10128] = 10128,
  [10129] = 10129,
  [10130] = 10130,
  [10131] = 9699,
  [10132] = 9695,
  [10133] = 9702,
  [10134] = 10134,
  [10135] = 9702,
  [10136] = 9695,
  [10137] = 9699,
  [10138] = 8926,
  [10139] = 10139,
  [10140] = 10140,
  [10141] = 10141,
  [10142] = 10142,
  [10143] = 10143,
  [10144] = 10144,
  [10145] = 10145,
  [10146] = 10146,
  [10147] = 9698,
  [10148] = 9697,
  [10149] = 9696,
  [10150] = 9695,
  [10151] = 10151,
  [10152] = 10152,
  [10153] = 10153,
  [10154] = 9696,
  [10155] = 10155,
  [10156] = 9697,
  [10157] = 10157,
  [10158] = 9698,
  [10159] = 10159,
  [10160] = 10160,
  [10161] = 9699,
  [10162] = 9695,
  [10163] = 9696,
  [10164] = 9697,
  [10165] = 9702,
  [10166] = 9698,
  [10167] = 10167,
  [10168] = 10100,
  [10169] = 9699,
  [10170] = 10170,
  [10171] = 10171,
  [10172] = 10172,
  [10173] = 9702,
  [10174] = 9695,
  [10175] = 9699,
  [10176] = 10176,
  [10177] = 9699,
  [10178] = 10178,
  [10179] = 9696,
  [10180] = 10180,
  [10181] = 9697,
  [10182] = 9698,
  [10183] = 10183,
  [10184] = 9695,
  [10185] = 9698,
  [10186] = 9697,
  [10187] = 9696,
  [10188] = 9702,
  [10189] = 7258,
  [10190] = 9698,
  [10191] = 8926,
  [10192] = 9695,
  [10193] = 9702,
  [10194] = 9116,
  [10195] = 9697,
  [10196] = 8926,
  [10197] = 9696,
  [10198] = 9697,
  [10199] = 9698,
  [10200] = 9698,
  [10201] = 9432,
  [10202] = 9697,
  [10203] = 4033,
  [10204] = 9702,
  [10205] = 9699,
  [10206] = 9849,
  [10207] = 9696,
  [10208] = 9697,
  [10209] = 9695,
  [10210] = 9699,
  [10211] = 9702,
  [10212] = 9702,
  [10213] = 9695,
  [10214] = 9699,
  [10215] = 9695,
  [10216] = 9699,
  [10217] = 9699,
  [10218] = 10218,
  [10219] = 9698,
  [10220] = 10101,
  [10221] = 9697,
  [10222] = 9698,
  [10223] = 9697,
  [10224] = 9696,
  [10225] = 9696,
  [10226] = 3994,
  [10227] = 9702,
  [10228] = 9702,
  [10229] = 9696,
  [10230] = 9698,
  [10231] = 9695,
  [10232] = 10232,
  [10233] = 10233,
  [10234] = 10234,
  [10235] = 10235,
  [10236] = 10236,
  [10237] = 10237,
  [10238] = 10238,
  [10239] = 10239,
  [10240] = 10240,
  [10241] = 10241,
  [10242] = 10242,
  [10243] = 10243,
  [10244] = 10232,
  [10245] = 10245,
  [10246] = 10246,
  [10247] = 10247,
  [10248] = 10248,
  [10249] = 10233,
  [10250] = 10250,
  [10251] = 10251,
  [10252] = 10252,
  [10253] = 10253,
  [10254] = 10254,
  [10255] = 10234,
  [10256] = 10235,
  [10257] = 10236,
  [10258] = 10238,
  [10259] = 10253,
  [10260] = 10252,
  [10261] = 10238,
  [10262] = 10239,
  [10263] = 10240,
  [10264] = 10264,
  [10265] = 10241,
  [10266] = 10242,
  [10267] = 10243,
  [10268] = 10232,
  [10269] = 10245,
  [10270] = 10246,
  [10271] = 10251,
  [10272] = 10250,
  [10273] = 10233,
  [10274] = 10264,
  [10275] = 10248,
  [10276] = 10246,
  [10277] = 10247,
  [10278] = 10248,
  [10279] = 10233,
  [10280] = 10250,
  [10281] = 10251,
  [10282] = 10252,
  [10283] = 10245,
  [10284] = 10237,
  [10285] = 10253,
  [10286] = 10254,
  [10287] = 10232,
  [10288] = 10243,
  [10289] = 10242,
  [10290] = 10241,
  [10291] = 10234,
  [10292] = 10240,
  [10293] = 10235,
  [10294] = 10236,
  [10295] = 10239,
  [10296] = 10242,
  [10297] = 10236,
  [10298] = 10235,
  [10299] = 10238,
  [10300] = 10239,
  [10301] = 10240,
  [10302] = 10234,
  [10303] = 10241,
  [10304] = 10242,
  [10305] = 10243,
  [10306] = 10254,
  [10307] = 10253,
  [10308] = 10252,
  [10309] = 10232,
  [10310] = 10245,
  [10311] = 10246,
  [10312] = 10251,
  [10313] = 10250,
  [10314] = 10233,
  [10315] = 10247,
  [10316] = 10248,
  [10317] = 10233,
  [10318] = 10250,
  [10319] = 10251,
  [10320] = 10252,
  [10321] = 10253,
  [10322] = 10254,
  [10323] = 10248,
  [10324] = 10247,
  [10325] = 10246,
  [10326] = 10234,
  [10327] = 10245,
  [10328] = 10235,
  [10329] = 10236,
  [10330] = 10232,
  [10331] = 10243,
  [10332] = 10242,
  [10333] = 10241,
  [10334] = 10238,
  [10335] = 10237,
  [10336] = 10240,
  [10337] = 10264,
  [10338] = 10239,
  [10339] = 10239,
  [10340] = 10240,
  [10341] = 10238,
  [10342] = 10241,
  [10343] = 10242,
  [10344] = 10243,
  [10345] = 10232,
  [10346] = 10236,
  [10347] = 10237,
  [10348] = 10245,
  [10349] = 10246,
  [10350] = 10235,
  [10351] = 10234,
  [10352] = 10264,
  [10353] = 10247,
  [10354] = 10248,
  [10355] = 10233,
  [10356] = 10250,
  [10357] = 10251,
  [10358] = 10252,
  [10359] = 10253,
  [10360] = 10254,
  [10361] = 10254,
  [10362] = 10253,
  [10363] = 10252,
  [10364] = 10234,
  [10365] = 10251,
  [10366] = 10235,
  [10367] = 10236,
  [10368] = 10247,
  [10369] = 10233,
  [10370] = 10248,
  [10371] = 10247,
  [10372] = 10250,
  [10373] = 10246,
  [10374] = 10245,
  [10375] = 10238,
  [10376] = 10232,
  [10377] = 10239,
  [10378] = 10240,
  [10379] = 10243,
  [10380] = 10241,
  [10381] = 10242,
  [10382] = 10243,
  [10383] = 10232,
  [10384] = 10245,
  [10385] = 10246,
  [10386] = 10238,
  [10387] = 10234,
  [10388] = 10247,
  [10389] = 10248,
  [10390] = 10241,
  [10391] = 10240,
  [10392] = 10264,
  [10393] = 10233,
  [10394] = 10239,
  [10395] = 10250,
  [10396] = 10251,
  [10397] = 10252,
  [10398] = 10253,
  [10399] = 10254,
  [10400] = 10238,
  [10401] = 10236,
  [10402] = 10237,
  [10403] = 10235,
  [10404] = 10234,
  [10405] = 10254,
  [10406] = 10234,
  [10407] = 10253,
  [10408] = 10235,
  [10409] = 10236,
  [10410] = 10252,
  [10411] = 10251,
  [10412] = 10250,
  [10413] = 10233,
  [10414] = 10238,
  [10415] = 10239,
  [10416] = 10240,
  [10417] = 10248,
  [10418] = 10241,
  [10419] = 10242,
  [10420] = 10243,
  [10421] = 10232,
  [10422] = 10245,
  [10423] = 10246,
  [10424] = 10247,
  [10425] = 10246,
  [10426] = 10245,
  [10427] = 10237,
  [10428] = 10232,
  [10429] = 10247,
  [10430] = 10248,
  [10431] = 10243,
  [10432] = 10233,
  [10433] = 10250,
  [10434] = 10251,
  [10435] = 10252,
  [10436] = 10253,
  [10437] = 10254,
  [10438] = 10242,
  [10439] = 10241,
  [10440] = 10240,
  [10441] = 10234,
  [10442] = 10239,
  [10443] = 10235,
  [10444] = 10236,
  [10445] = 10238,
  [10446] = 10264,
  [10447] = 10264,
  [10448] = 10236,
  [10449] = 10235,
  [10450] = 10237,
  [10451] = 10254,
  [10452] = 10253,
  [10453] = 10251,
  [10454] = 10239,
  [10455] = 10240,
  [10456] = 10252,
  [10457] = 10237,
  [10458] = 10251,
  [10459] = 10241,
  [10460] = 10250,
  [10461] = 10242,
  [10462] = 10243,
  [10463] = 10232,
  [10464] = 10245,
  [10465] = 10246,
  [10466] = 10233,
  [10467] = 10248,
  [10468] = 10247,
  [10469] = 10248,
  [10470] = 10233,
  [10471] = 10250,
  [10472] = 10251,
  [10473] = 10252,
  [10474] = 10253,
  [10475] = 10254,
  [10476] = 10247,
  [10477] = 10246,
  [10478] = 10232,
  [10479] = 10243,
  [10480] = 10242,
  [10481] = 10241,
  [10482] = 10234,
  [10483] = 10240,
  [10484] = 10235,
  [10485] = 10236,
  [10486] = 10239,
  [10487] = 10238,
  [10488] = 10236,
  [10489] = 10235,
  [10490] = 10234,
  [10491] = 10238,
  [10492] = 10239,
  [10493] = 10240,
  [10494] = 10254,
  [10495] = 10241,
  [10496] = 10242,
  [10497] = 10243,
  [10498] = 10253,
  [10499] = 10252,
  [10500] = 10264,
  [10501] = 10232,
  [10502] = 10251,
  [10503] = 10245,
  [10504] = 10246,
  [10505] = 10250,
  [10506] = 10233,
  [10507] = 10247,
  [10508] = 10248,
  [10509] = 10248,
  [10510] = 10237,
  [10511] = 10233,
  [10512] = 10250,
  [10513] = 10247,
  [10514] = 10242,
  [10515] = 10252,
  [10516] = 10253,
  [10517] = 10254,
  [10518] = 10242,
  [10519] = 10246,
  [10520] = 10245,
  [10521] = 10234,
  [10522] = 10232,
  [10523] = 10235,
  [10524] = 10236,
  [10525] = 10245,
  [10526] = 10242,
  [10527] = 10241,
  [10528] = 10240,
  [10529] = 10238,
  [10530] = 10239,
  [10531] = 10240,
  [10532] = 10239,
  [10533] = 10238,
  [10534] = 10264,
  [10535] = 10236,
  [10536] = 10241,
  [10537] = 10245,
  [10538] = 10243,
  [10539] = 10235,
  [10540] = 10232,
  [10541] = 10245,
  [10542] = 10246,
  [10543] = 10234,
  [10544] = 10254,
  [10545] = 10247,
  [10546] = 10248,
  [10547] = 10233,
  [10548] = 10250,
  [10549] = 10251,
  [10550] = 10252,
  [10551] = 10253,
  [10552] = 10252,
  [10553] = 10264,
  [10554] = 10253,
  [10555] = 10251,
  [10556] = 10254,
  [10557] = 10250,
  [10558] = 10233,
  [10559] = 10248,
  [10560] = 10234,
  [10561] = 10247,
  [10562] = 10246,
  [10563] = 10237,
  [10564] = 10235,
  [10565] = 10236,
  [10566] = 10245,
  [10567] = 10232,
  [10568] = 10243,
  [10569] = 10242,
  [10570] = 10241,
  [10571] = 10238,
  [10572] = 10239,
  [10573] = 10240,
  [10574] = 10240,
  [10575] = 10241,
  [10576] = 10242,
  [10577] = 10243,
  [10578] = 10232,
  [10579] = 10245,
  [10580] = 10246,
  [10581] = 10239,
  [10582] = 10238,
  [10583] = 10247,
  [10584] = 10248,
  [10585] = 10236,
  [10586] = 10235,
  [10587] = 10234,
  [10588] = 10233,
  [10589] = 10250,
  [10590] = 10251,
  [10591] = 10252,
  [10592] = 10254,
  [10593] = 10253,
  [10594] = 10254,
  [10595] = 10253,
  [10596] = 10243,
  [10597] = 10251,
  [10598] = 10234,
  [10599] = 10250,
  [10600] = 10235,
  [10601] = 10236,
  [10602] = 10233,
  [10603] = 10248,
  [10604] = 10247,
  [10605] = 10246,
  [10606] = 10264,
  [10607] = 10245,
  [10608] = 10232,
  [10609] = 10243,
  [10610] = 10238,
  [10611] = 10239,
  [10612] = 10240,
  [10613] = 10241,
  [10614] = 10242,
  [10615] = 10250,
  [10616] = 10237,
  [10617] = 10243,
  [10618] = 10232,
  [10619] = 10241,
  [10620] = 10240,
  [10621] = 10246,
  [10622] = 10239,
  [10623] = 10238,
  [10624] = 10247,
  [10625] = 10248,
  [10626] = 10233,
  [10627] = 10250,
  [10628] = 10251,
  [10629] = 10252,
  [10630] = 10253,
  [10631] = 10254,
  [10632] = 10236,
  [10633] = 10235,
  [10634] = 10234,
  [10635] = 10234,
  [10636] = 10254,
  [10637] = 10235,
  [10638] = 10253,
  [10639] = 10252,
  [10640] = 10251,
  [10641] = 10236,
  [10642] = 10246,
  [10643] = 10236,
  [10644] = 10233,
  [10645] = 10248,
  [10646] = 10247,
  [10647] = 10238,
  [10648] = 10239,
  [10649] = 10240,
  [10650] = 10246,
  [10651] = 10241,
  [10652] = 10242,
  [10653] = 10243,
  [10654] = 10232,
  [10655] = 10245,
  [10656] = 10246,
  [10657] = 10245,
  [10658] = 10232,
  [10659] = 10264,
  [10660] = 10243,
  [10661] = 10661,
  [10662] = 10662,
  [10663] = 10247,
  [10664] = 10248,
  [10665] = 10233,
  [10666] = 10250,
  [10667] = 10251,
  [10668] = 10242,
  [10669] = 10237,
  [10670] = 10252,
  [10671] = 10253,
  [10672] = 10672,
  [10673] = 10254,
  [10674] = 10241,
  [10675] = 10675,
  [10676] = 10676,
  [10677] = 10234,
  [10678] = 10240,
  [10679] = 10235,
  [10680] = 10236,
  [10681] = 10239,
  [10682] = 10237,
  [10683] = 10238,
  [10684] = 10236,
  [10685] = 10238,
  [10686] = 10239,
  [10687] = 10240,
  [10688] = 10235,
  [10689] = 10241,
  [10690] = 10242,
  [10691] = 10252,
  [10692] = 10254,
  [10693] = 10253,
  [10694] = 10243,
  [10695] = 10232,
  [10696] = 10245,
  [10697] = 10241,
  [10698] = 10252,
  [10699] = 10264,
  [10700] = 10251,
  [10701] = 10247,
  [10702] = 10248,
  [10703] = 10233,
  [10704] = 10250,
  [10705] = 10251,
  [10706] = 10252,
  [10707] = 10253,
  [10708] = 10254,
  [10709] = 10250,
  [10710] = 10233,
  [10711] = 10248,
  [10712] = 10264,
  [10713] = 10247,
  [10714] = 10246,
  [10715] = 10245,
  [10716] = 10234,
  [10717] = 10232,
  [10718] = 10235,
  [10719] = 10236,
  [10720] = 10246,
  [10721] = 10246,
  [10722] = 10237,
  [10723] = 10246,
  [10724] = 10236,
  [10725] = 10240,
  [10726] = 10241,
  [10727] = 10238,
  [10728] = 10239,
  [10729] = 10240,
  [10730] = 10242,
  [10731] = 10241,
  [10732] = 10242,
  [10733] = 10243,
  [10734] = 10232,
  [10735] = 10245,
  [10736] = 10246,
  [10737] = 10243,
  [10738] = 10232,
  [10739] = 10247,
  [10740] = 10248,
  [10741] = 10233,
  [10742] = 10250,
  [10743] = 10251,
  [10744] = 10245,
  [10745] = 10246,
  [10746] = 10243,
  [10747] = 10252,
  [10748] = 10253,
  [10749] = 10254,
  [10750] = 10242,
  [10751] = 10241,
  [10752] = 10236,
  [10753] = 10240,
  [10754] = 10234,
  [10755] = 10241,
  [10756] = 10235,
  [10757] = 10236,
  [10758] = 10242,
  [10759] = 10243,
  [10760] = 10232,
  [10761] = 10245,
  [10762] = 10238,
  [10763] = 10246,
  [10764] = 10240,
  [10765] = 10264,
  [10766] = 10239,
  [10767] = 10239,
  [10768] = 10240,
  [10769] = 10238,
  [10770] = 10246,
  [10771] = 10242,
  [10772] = 10243,
  [10773] = 10232,
  [10774] = 10236,
  [10775] = 10237,
  [10776] = 10245,
  [10777] = 10246,
  [10778] = 10240,
  [10779] = 10241,
  [10780] = 10242,
  [10781] = 10247,
  [10782] = 10248,
  [10783] = 10233,
  [10784] = 10250,
  [10785] = 10251,
  [10786] = 10252,
  [10787] = 10253,
  [10788] = 10254,
  [10789] = 10243,
  [10790] = 10232,
  [10791] = 10245,
  [10792] = 10234,
  [10793] = 10246,
  [10794] = 10235,
  [10795] = 10236,
  [10796] = 10245,
  [10797] = 10235,
  [10798] = 10234,
  [10799] = 10236,
  [10800] = 10240,
  [10801] = 10241,
  [10802] = 10242,
  [10803] = 10238,
  [10804] = 10243,
  [10805] = 10239,
  [10806] = 10240,
  [10807] = 10232,
  [10808] = 10241,
  [10809] = 10242,
  [10810] = 10243,
  [10811] = 10232,
  [10812] = 10245,
  [10813] = 10246,
  [10814] = 10245,
  [10815] = 10246,
  [10816] = 10254,
  [10817] = 10264,
  [10818] = 10247,
  [10819] = 10253,
  [10820] = 10248,
  [10821] = 10233,
  [10822] = 10250,
  [10823] = 10251,
  [10824] = 10252,
  [10825] = 10253,
  [10826] = 10236,
  [10827] = 10237,
  [10828] = 10254,
  [10829] = 10240,
  [10830] = 10241,
  [10831] = 10242,
  [10832] = 10243,
  [10833] = 10234,
  [10834] = 10232,
  [10835] = 10235,
  [10836] = 10236,
  [10837] = 10245,
  [10838] = 10246,
  [10839] = 10234,
  [10840] = 10251,
  [10841] = 10238,
  [10842] = 10239,
  [10843] = 10240,
  [10844] = 10250,
  [10845] = 10241,
  [10846] = 10242,
  [10847] = 10243,
  [10848] = 10232,
  [10849] = 10233,
  [10850] = 10245,
  [10851] = 10253,
  [10852] = 10248,
  [10853] = 10236,
  [10854] = 10247,
  [10855] = 10248,
  [10856] = 10233,
  [10857] = 10250,
  [10858] = 10251,
  [10859] = 10252,
  [10860] = 10253,
  [10861] = 10254,
  [10862] = 10240,
  [10863] = 10241,
  [10864] = 10242,
  [10865] = 10264,
  [10866] = 10243,
  [10867] = 10232,
  [10868] = 10234,
  [10869] = 10245,
  [10870] = 10235,
  [10871] = 10236,
  [10872] = 10246,
  [10873] = 10247,
  [10874] = 10246,
  [10875] = 10237,
  [10876] = 10252,
  [10877] = 10236,
  [10878] = 10240,
  [10879] = 10238,
  [10880] = 10239,
  [10881] = 10240,
  [10882] = 10241,
  [10883] = 10241,
  [10884] = 10242,
  [10885] = 10243,
  [10886] = 10232,
  [10887] = 10245,
  [10888] = 10246,
  [10889] = 10242,
  [10890] = 10243,
  [10891] = 10247,
  [10892] = 10248,
  [10893] = 10233,
  [10894] = 10250,
  [10895] = 10251,
  [10896] = 10252,
  [10897] = 10232,
  [10898] = 10246,
  [10899] = 10254,
  [10900] = 10243,
  [10901] = 10246,
  [10902] = 10232,
  [10903] = 10234,
  [10904] = 10243,
  [10905] = 10235,
  [10906] = 10236,
  [10907] = 10242,
  [10908] = 10241,
  [10909] = 10236,
  [10910] = 10240,
  [10911] = 10238,
  [10912] = 10241,
  [10913] = 10264,
  [10914] = 10239,
  [10915] = 10242,
  [10916] = 10240,
  [10917] = 10243,
  [10918] = 10241,
  [10919] = 10242,
  [10920] = 10243,
  [10921] = 10232,
  [10922] = 10232,
  [10923] = 10237,
  [10924] = 10245,
  [10925] = 10245,
  [10926] = 10245,
  [10927] = 10246,
  [10928] = 10240,
  [10929] = 10247,
  [10930] = 10248,
  [10931] = 10233,
  [10932] = 10250,
  [10933] = 10251,
  [10934] = 10252,
  [10935] = 10253,
  [10936] = 10254,
  [10937] = 10239,
  [10938] = 10238,
  [10939] = 10236,
  [10940] = 10234,
  [10941] = 10240,
  [10942] = 10235,
  [10943] = 10236,
  [10944] = 10241,
  [10945] = 10242,
  [10946] = 10243,
  [10947] = 10232,
  [10948] = 10245,
  [10949] = 10238,
  [10950] = 10239,
  [10951] = 10240,
  [10952] = 10246,
  [10953] = 10241,
  [10954] = 10242,
  [10955] = 10243,
  [10956] = 10232,
  [10957] = 10245,
  [10958] = 10246,
  [10959] = 10236,
  [10960] = 10235,
  [10961] = 10264,
  [10962] = 10234,
  [10963] = 10236,
  [10964] = 10247,
  [10965] = 10248,
  [10966] = 10233,
  [10967] = 10250,
  [10968] = 10251,
  [10969] = 10252,
  [10970] = 10240,
  [10971] = 10237,
  [10972] = 10253,
  [10973] = 10254,
  [10974] = 10241,
  [10975] = 10242,
  [10976] = 10243,
  [10977] = 10232,
  [10978] = 10234,
  [10979] = 10245,
  [10980] = 10235,
  [10981] = 10236,
  [10982] = 10246,
  [10983] = 10254,
  [10984] = 10253,
  [10985] = 10236,
  [10986] = 10238,
  [10987] = 10239,
  [10988] = 10240,
  [10989] = 10240,
  [10990] = 10241,
  [10991] = 10242,
  [10992] = 10243,
  [10993] = 10241,
  [10994] = 10232,
  [10995] = 10240,
  [10996] = 10246,
  [10997] = 10242,
  [10998] = 10243,
  [10999] = 10247,
  [11000] = 10248,
  [11001] = 10233,
  [11002] = 10250,
  [11003] = 10251,
  [11004] = 10252,
  [11005] = 10253,
  [11006] = 10254,
  [11007] = 10232,
  [11008] = 10245,
  [11009] = 10264,
  [11010] = 10246,
  [11011] = 10252,
  [11012] = 10251,
  [11013] = 10234,
  [11014] = 10250,
  [11015] = 10235,
  [11016] = 10236,
  [11017] = 10233,
  [11018] = 10248,
  [11019] = 10237,
  [11020] = 10236,
  [11021] = 10240,
  [11022] = 10241,
  [11023] = 10242,
  [11024] = 10238,
  [11025] = 10239,
  [11026] = 10241,
  [11027] = 10240,
  [11028] = 10241,
  [11029] = 10242,
  [11030] = 10243,
  [11031] = 10232,
  [11032] = 10245,
  [11033] = 10246,
  [11034] = 10232,
  [11035] = 10245,
  [11036] = 10247,
  [11037] = 10248,
  [11038] = 10233,
  [11039] = 10250,
  [11040] = 10251,
  [11041] = 10246,
  [11042] = 10252,
  [11043] = 10253,
  [11044] = 10254,
  [11045] = 10247,
  [11046] = 10246,
  [11047] = 10245,
  [11048] = 10234,
  [11049] = 10236,
  [11050] = 10235,
  [11051] = 10236,
  [11052] = 10240,
  [11053] = 10264,
  [11054] = 10241,
  [11055] = 10242,
  [11056] = 10243,
  [11057] = 10232,
  [11058] = 10245,
  [11059] = 10238,
  [11060] = 10246,
  [11061] = 10237,
  [11062] = 10239,
  [11063] = 10240,
  [11064] = 10232,
  [11065] = 10243,
  [11066] = 10238,
  [11067] = 10242,
  [11068] = 10243,
  [11069] = 10232,
  [11070] = 10245,
  [11071] = 10246,
  [11072] = 10242,
  [11073] = 10241,
  [11074] = 10247,
  [11075] = 10248,
  [11076] = 10233,
  [11077] = 10250,
  [11078] = 10251,
  [11079] = 10252,
  [11080] = 10253,
  [11081] = 10254,
  [11082] = 10236,
  [11083] = 10240,
  [11084] = 10241,
  [11085] = 10242,
  [11086] = 10234,
  [11087] = 10243,
  [11088] = 10264,
  [11089] = 10232,
  [11090] = 10245,
  [11091] = 10235,
  [11092] = 10236,
  [11093] = 10246,
  [11094] = 10240,
  [11095] = 10239,
  [11096] = 10237,
  [11097] = 10238,
  [11098] = 10236,
  [11099] = 10240,
  [11100] = 10238,
  [11101] = 10239,
  [11102] = 10240,
  [11103] = 10241,
  [11104] = 10241,
  [11105] = 10242,
  [11106] = 10243,
  [11107] = 10232,
  [11108] = 10245,
  [11109] = 10246,
  [11110] = 10242,
  [11111] = 10243,
  [11112] = 10247,
  [11113] = 10248,
  [11114] = 10233,
  [11115] = 10250,
  [11116] = 10251,
  [11117] = 10252,
  [11118] = 10232,
  [11119] = 10253,
  [11120] = 10254,
  [11121] = 10245,
  [11122] = 10246,
  [11123] = 10264,
  [11124] = 10236,
  [11125] = 10235,
  [11126] = 10245,
  [11127] = 10234,
  [11128] = 10236,
  [11129] = 10235,
  [11130] = 10240,
  [11131] = 10237,
  [11132] = 10236,
  [11133] = 10241,
  [11134] = 10242,
  [11135] = 10243,
  [11136] = 10232,
  [11137] = 10245,
  [11138] = 10250,
  [11139] = 10239,
  [11140] = 10240,
  [11141] = 10246,
  [11142] = 10241,
  [11143] = 10242,
  [11144] = 10243,
  [11145] = 10232,
  [11146] = 10245,
  [11147] = 10246,
  [11148] = 10254,
  [11149] = 10253,
  [11150] = 10247,
  [11151] = 10248,
  [11152] = 10233,
  [11153] = 10236,
  [11154] = 10238,
  [11155] = 10251,
  [11156] = 10252,
  [11157] = 10238,
  [11158] = 10264,
  [11159] = 10253,
  [11160] = 10254,
  [11161] = 10241,
  [11162] = 10242,
  [11163] = 10243,
  [11164] = 10237,
  [11165] = 10234,
  [11166] = 10232,
  [11167] = 10235,
  [11168] = 10236,
  [11169] = 10245,
  [11170] = 10246,
  [11171] = 10252,
  [11172] = 10251,
  [11173] = 10238,
  [11174] = 10239,
  [11175] = 10240,
  [11176] = 10250,
  [11177] = 10241,
  [11178] = 10242,
  [11179] = 10243,
  [11180] = 10232,
  [11181] = 10245,
  [11182] = 10246,
  [11183] = 10233,
  [11184] = 10248,
  [11185] = 10247,
  [11186] = 10248,
  [11187] = 10236,
  [11188] = 10264,
  [11189] = 10233,
  [11190] = 10237,
  [11191] = 10250,
  [11192] = 10251,
  [11193] = 10252,
  [11194] = 10253,
  [11195] = 10254,
  [11196] = 10240,
  [11197] = 10241,
  [11198] = 10242,
  [11199] = 10234,
  [11200] = 10243,
  [11201] = 10235,
  [11202] = 10236,
  [11203] = 10232,
  [11204] = 10245,
  [11205] = 10246,
  [11206] = 10247,
  [11207] = 10246,
  [11208] = 10239,
  [11209] = 10245,
  [11210] = 10264,
  [11211] = 10240,
  [11212] = 10237,
  [11213] = 10236,
  [11214] = 10241,
  [11215] = 10242,
  [11216] = 10243,
  [11217] = 10232,
  [11218] = 10245,
  [11219] = 10246,
  [11220] = 10240,
  [11221] = 10241,
  [11222] = 10247,
  [11223] = 10248,
  [11224] = 10233,
  [11225] = 10250,
  [11226] = 10251,
  [11227] = 10252,
  [11228] = 10253,
  [11229] = 10254,
  [11230] = 10242,
  [11231] = 10243,
  [11232] = 10264,
  [11233] = 10232,
  [11234] = 10237,
  [11235] = 10245,
  [11236] = 10234,
  [11237] = 10246,
  [11238] = 10235,
  [11239] = 10236,
  [11240] = 10232,
  [11241] = 10243,
  [11242] = 10242,
  [11243] = 10241,
  [11244] = 10238,
  [11245] = 10239,
  [11246] = 10240,
  [11247] = 10236,
  [11248] = 10241,
  [11249] = 10242,
  [11250] = 10243,
  [11251] = 10232,
  [11252] = 10245,
  [11253] = 10240,
  [11254] = 10264,
  [11255] = 10246,
  [11256] = 10237,
  [11257] = 10241,
  [11258] = 10242,
  [11259] = 10247,
  [11260] = 10248,
  [11261] = 10233,
  [11262] = 10250,
  [11263] = 10251,
  [11264] = 10252,
  [11265] = 10253,
  [11266] = 10254,
  [11267] = 10243,
  [11268] = 10232,
  [11269] = 10245,
  [11270] = 10234,
  [11271] = 10246,
  [11272] = 10235,
  [11273] = 10236,
  [11274] = 10239,
  [11275] = 10240,
  [11276] = 10264,
  [11277] = 10239,
  [11278] = 10237,
  [11279] = 10240,
  [11280] = 10236,
  [11281] = 10238,
  [11282] = 10235,
  [11283] = 10240,
  [11284] = 10246,
  [11285] = 10241,
  [11286] = 10242,
  [11287] = 10243,
  [11288] = 10232,
  [11289] = 10245,
  [11290] = 10246,
  [11291] = 10241,
  [11292] = 10242,
  [11293] = 10247,
  [11294] = 10248,
  [11295] = 10233,
  [11296] = 10250,
  [11297] = 10243,
  [11298] = 10264,
  [11299] = 10251,
  [11300] = 10237,
  [11301] = 10252,
  [11302] = 10253,
  [11303] = 10254,
  [11304] = 10232,
  [11305] = 10245,
  [11306] = 10246,
  [11307] = 10234,
  [11308] = 10236,
  [11309] = 10235,
  [11310] = 10236,
  [11311] = 10235,
  [11312] = 10234,
  [11313] = 10236,
  [11314] = 10240,
  [11315] = 10238,
  [11316] = 10239,
  [11317] = 10240,
  [11318] = 10241,
  [11319] = 10242,
  [11320] = 10264,
  [11321] = 10241,
  [11322] = 10237,
  [11323] = 10242,
  [11324] = 10243,
  [11325] = 10232,
  [11326] = 10245,
  [11327] = 10246,
  [11328] = 10243,
  [11329] = 10232,
  [11330] = 10247,
  [11331] = 10248,
  [11332] = 10233,
  [11333] = 10250,
  [11334] = 10251,
  [11335] = 10252,
  [11336] = 10253,
  [11337] = 10254,
  [11338] = 10245,
  [11339] = 10246,
  [11340] = 10254,
  [11341] = 10253,
  [11342] = 10264,
  [11343] = 10234,
  [11344] = 10237,
  [11345] = 10236,
  [11346] = 10254,
  [11347] = 10236,
  [11348] = 10240,
  [11349] = 10241,
  [11350] = 10242,
  [11351] = 10243,
  [11352] = 10238,
  [11353] = 10239,
  [11354] = 10240,
  [11355] = 10232,
  [11356] = 10241,
  [11357] = 10242,
  [11358] = 10243,
  [11359] = 10232,
  [11360] = 10245,
  [11361] = 10246,
  [11362] = 10245,
  [11363] = 10246,
  [11364] = 10264,
  [11365] = 10252,
  [11366] = 10237,
  [11367] = 10247,
  [11368] = 10248,
  [11369] = 10233,
  [11370] = 10250,
  [11371] = 10251,
  [11372] = 10252,
  [11373] = 10253,
  [11374] = 10254,
  [11375] = 10251,
  [11376] = 10234,
  [11377] = 10233,
  [11378] = 10234,
  [11379] = 10248,
  [11380] = 10235,
  [11381] = 10236,
  [11382] = 10236,
  [11383] = 10240,
  [11384] = 10241,
  [11385] = 10242,
  [11386] = 10264,
  [11387] = 10243,
  [11388] = 10237,
  [11389] = 10238,
  [11390] = 10239,
  [11391] = 10240,
  [11392] = 10232,
  [11393] = 10241,
  [11394] = 10242,
  [11395] = 10243,
  [11396] = 10232,
  [11397] = 10245,
  [11398] = 10246,
  [11399] = 10245,
  [11400] = 10246,
  [11401] = 10247,
  [11402] = 10248,
  [11403] = 10233,
  [11404] = 10250,
  [11405] = 10251,
  [11406] = 10252,
  [11407] = 10250,
  [11408] = 10264,
  [11409] = 10253,
  [11410] = 10237,
  [11411] = 10232,
  [11412] = 10245,
  [11413] = 10250,
  [11414] = 10236,
  [11415] = 10234,
  [11416] = 10240,
  [11417] = 10235,
  [11418] = 10236,
  [11419] = 10241,
  [11420] = 10242,
  [11421] = 10243,
  [11422] = 10232,
  [11423] = 10238,
  [11424] = 10239,
  [11425] = 10240,
  [11426] = 10245,
  [11427] = 10241,
  [11428] = 10242,
  [11429] = 10246,
  [11430] = 10264,
  [11431] = 10243,
  [11432] = 10237,
  [11433] = 10232,
  [11434] = 10245,
  [11435] = 10246,
  [11436] = 10232,
  [11437] = 10243,
  [11438] = 10247,
  [11439] = 10248,
  [11440] = 10233,
  [11441] = 10250,
  [11442] = 10251,
  [11443] = 10252,
  [11444] = 10253,
  [11445] = 10254,
  [11446] = 10242,
  [11447] = 10241,
  [11448] = 10236,
  [11449] = 10234,
  [11450] = 10240,
  [11451] = 10241,
  [11452] = 10264,
  [11453] = 10235,
  [11454] = 10237,
  [11455] = 10236,
  [11456] = 10242,
  [11457] = 10243,
  [11458] = 10232,
  [11459] = 10245,
  [11460] = 10238,
  [11461] = 10246,
  [11462] = 10239,
  [11463] = 10240,
  [11464] = 10240,
  [11465] = 10241,
  [11466] = 10242,
  [11467] = 10243,
  [11468] = 10232,
  [11469] = 10245,
  [11470] = 10246,
  [11471] = 10239,
  [11472] = 10238,
  [11473] = 10236,
  [11474] = 10264,
  [11475] = 10240,
  [11476] = 10237,
  [11477] = 10241,
  [11478] = 10247,
  [11479] = 10248,
  [11480] = 10233,
  [11481] = 10242,
  [11482] = 10251,
  [11483] = 10252,
  [11484] = 10253,
  [11485] = 10254,
  [11486] = 10243,
  [11487] = 10232,
  [11488] = 10245,
  [11489] = 10234,
  [11490] = 10246,
  [11491] = 10235,
  [11492] = 10236,
  [11493] = 10236,
  [11494] = 10235,
  [11495] = 10234,
  [11496] = 10264,
  [11497] = 11497,
  [11498] = 10237,
  [11499] = 10236,
  [11500] = 10240,
  [11501] = 10241,
  [11502] = 10238,
  [11503] = 10242,
  [11504] = 10239,
  [11505] = 10240,
  [11506] = 10243,
  [11507] = 10232,
  [11508] = 10241,
  [11509] = 10242,
  [11510] = 10243,
  [11511] = 10232,
  [11512] = 10245,
  [11513] = 10246,
  [11514] = 10245,
  [11515] = 11515,
  [11516] = 10246,
  [11517] = 10254,
  [11518] = 10264,
  [11519] = 10253,
  [11520] = 10237,
  [11521] = 10236,
  [11522] = 11522,
  [11523] = 10247,
  [11524] = 10248,
  [11525] = 10254,
  [11526] = 10250,
  [11527] = 10240,
  [11528] = 10251,
  [11529] = 10252,
  [11530] = 10253,
  [11531] = 10254,
  [11532] = 10241,
  [11533] = 11533,
  [11534] = 10242,
  [11535] = 11535,
  [11536] = 10243,
  [11537] = 10245,
  [11538] = 10240,
  [11539] = 10246,
  [11540] = 10264,
  [11541] = 10234,
  [11542] = 10237,
  [11543] = 10252,
  [11544] = 10251,
  [11545] = 10250,
  [11546] = 10235,
  [11547] = 10233,
  [11548] = 10248,
  [11549] = 10236,
  [11550] = 10236,
  [11551] = 10240,
  [11552] = 10241,
  [11553] = 10242,
  [11554] = 11497,
  [11555] = 10243,
  [11556] = 10242,
  [11557] = 10245,
  [11558] = 10238,
  [11559] = 10246,
  [11560] = 10239,
  [11561] = 10247,
  [11562] = 10264,
  [11563] = 10240,
  [11564] = 10237,
  [11565] = 10246,
  [11566] = 10245,
  [11567] = 10236,
  [11568] = 10240,
  [11569] = 10241,
  [11570] = 10242,
  [11571] = 10241,
  [11572] = 10242,
  [11573] = 10243,
  [11574] = 10232,
  [11575] = 10245,
  [11576] = 10246,
  [11577] = 10243,
  [11578] = 10232,
  [11579] = 11515,
  [11580] = 10245,
  [11581] = 10246,
  [11582] = 10232,
  [11583] = 10243,
  [11584] = 10264,
  [11585] = 10242,
  [11586] = 10237,
  [11587] = 10241,
  [11588] = 10236,
  [11589] = 10240,
  [11590] = 10241,
  [11591] = 10242,
  [11592] = 10243,
  [11593] = 10232,
  [11594] = 10245,
  [11595] = 10246,
  [11596] = 10240,
  [11597] = 10239,
  [11598] = 10238,
  [11599] = 10247,
  [11600] = 10236,
  [11601] = 10240,
  [11602] = 10241,
  [11603] = 10242,
  [11604] = 10243,
  [11605] = 10264,
  [11606] = 10232,
  [11607] = 10237,
  [11608] = 10245,
  [11609] = 10246,
  [11610] = 10236,
  [11611] = 10235,
  [11612] = 10234,
  [11613] = 10236,
  [11614] = 10240,
  [11615] = 10241,
  [11616] = 10242,
  [11617] = 10243,
  [11618] = 10232,
  [11619] = 10245,
  [11620] = 10246,
  [11621] = 10254,
  [11622] = 10253,
  [11623] = 10236,
  [11624] = 10240,
  [11625] = 10237,
  [11626] = 10241,
  [11627] = 10242,
  [11628] = 10243,
  [11629] = 10232,
  [11630] = 10245,
  [11631] = 10246,
  [11632] = 10252,
  [11633] = 10251,
  [11634] = 10250,
  [11635] = 10233,
  [11636] = 10248,
  [11637] = 10236,
  [11638] = 10240,
  [11639] = 10241,
  [11640] = 10242,
  [11641] = 10243,
  [11642] = 10237,
  [11643] = 10232,
  [11644] = 10245,
  [11645] = 10246,
  [11646] = 10247,
  [11647] = 10246,
  [11648] = 10245,
  [11649] = 10232,
  [11650] = 10236,
  [11651] = 10240,
  [11652] = 10241,
  [11653] = 10242,
  [11654] = 10243,
  [11655] = 10232,
  [11656] = 10245,
  [11657] = 10246,
  [11658] = 10243,
  [11659] = 10237,
  [11660] = 10242,
  [11661] = 10241,
  [11662] = 10242,
  [11663] = 10236,
  [11664] = 10240,
  [11665] = 10241,
  [11666] = 10245,
  [11667] = 10243,
  [11668] = 10232,
  [11669] = 10245,
  [11670] = 10246,
  [11671] = 10239,
  [11672] = 10238,
  [11673] = 10236,
  [11674] = 10240,
  [11675] = 10241,
  [11676] = 10237,
  [11677] = 10242,
  [11678] = 10243,
  [11679] = 10232,
  [11680] = 10245,
  [11681] = 10246,
  [11682] = 10236,
  [11683] = 10235,
  [11684] = 10234,
  [11685] = 10236,
  [11686] = 10240,
  [11687] = 4032,
  [11688] = 10241,
  [11689] = 10242,
  [11690] = 10243,
  [11691] = 10232,
  [11692] = 10245,
  [11693] = 10237,
  [11694] = 10246,
  [11695] = 10254,
  [11696] = 10253,
  [11697] = 10252,
  [11698] = 10236,
  [11699] = 10240,
  [11700] = 10241,
  [11701] = 10242,
  [11702] = 4024,
  [11703] = 10243,
  [11704] = 4009,
  [11705] = 10232,
  [11706] = 10245,
  [11707] = 10246,
  [11708] = 10251,
  [11709] = 10233,
  [11710] = 10237,
  [11711] = 10248,
  [11712] = 10247,
  [11713] = 10236,
  [11714] = 10240,
  [11715] = 10241,
  [11716] = 10242,
  [11717] = 10243,
  [11718] = 10232,
  [11719] = 10245,
  [11720] = 10246,
  [11721] = 10250,
  [11722] = 10246,
  [11723] = 10245,
  [11724] = 10232,
  [11725] = 10243,
  [11726] = 10236,
  [11727] = 10237,
  [11728] = 10240,
  [11729] = 10241,
  [11730] = 10242,
  [11731] = 10243,
  [11732] = 10232,
  [11733] = 10245,
  [11734] = 10246,
  [11735] = 10242,
  [11736] = 10241,
  [11737] = 10240,
  [11738] = 10239,
  [11739] = 10238,
  [11740] = 10236,
  [11741] = 10240,
  [11742] = 10241,
  [11743] = 10242,
  [11744] = 10237,
  [11745] = 10243,
  [11746] = 10232,
  [11747] = 10245,
  [11748] = 10246,
  [11749] = 10236,
  [11750] = 10236,
  [11751] = 10240,
  [11752] = 10241,
  [11753] = 10242,
  [11754] = 10243,
  [11755] = 10232,
  [11756] = 10245,
  [11757] = 10246,
  [11758] = 10235,
  [11759] = 10234,
  [11760] = 10236,
  [11761] = 10237,
  [11762] = 10240,
  [11763] = 10241,
  [11764] = 10242,
  [11765] = 10243,
  [11766] = 10232,
  [11767] = 10246,
  [11768] = 10246,
  [11769] = 10254,
  [11770] = 10253,
  [11771] = 10252,
  [11772] = 10251,
  [11773] = 10250,
  [11774] = 10236,
  [11775] = 10240,
  [11776] = 10241,
  [11777] = 10242,
  [11778] = 10237,
  [11779] = 10243,
  [11780] = 10232,
  [11781] = 10245,
  [11782] = 10246,
  [11783] = 10233,
  [11784] = 10248,
  [11785] = 10247,
  [11786] = 10246,
  [11787] = 10236,
  [11788] = 10240,
  [11789] = 10241,
  [11790] = 10242,
  [11791] = 10243,
  [11792] = 10232,
  [11793] = 10245,
  [11794] = 10236,
  [11795] = 10237,
  [11796] = 10245,
  [11797] = 10232,
  [11798] = 10243,
  [11799] = 10242,
  [11800] = 10241,
  [11801] = 10236,
  [11802] = 10240,
  [11803] = 10241,
  [11804] = 10242,
  [11805] = 10243,
  [11806] = 10232,
  [11807] = 10245,
  [11808] = 10246,
  [11809] = 10240,
  [11810] = 10239,
  [11811] = 10238,
  [11812] = 10237,
  [11813] = 10236,
  [11814] = 10240,
  [11815] = 10241,
  [11816] = 10242,
  [11817] = 10243,
  [11818] = 10232,
  [11819] = 10245,
  [11820] = 10246,
  [11821] = 10236,
  [11822] = 10235,
  [11823] = 10234,
  [11824] = 10236,
  [11825] = 10237,
  [11826] = 10240,
  [11827] = 10241,
  [11828] = 10242,
  [11829] = 10237,
  [11830] = 10243,
  [11831] = 10232,
  [11832] = 10245,
  [11833] = 10237,
  [11834] = 10246,
  [11835] = 10254,
  [11836] = 10253,
  [11837] = 10237,
  [11838] = 10236,
  [11839] = 10240,
  [11840] = 10241,
  [11841] = 10237,
  [11842] = 10242,
  [11843] = 10243,
  [11844] = 10232,
  [11845] = 10237,
  [11846] = 10245,
  [11847] = 10246,
  [11848] = 10252,
  [11849] = 10237,
  [11850] = 10251,
  [11851] = 10250,
  [11852] = 10233,
  [11853] = 10237,
  [11854] = 10248,
  [11855] = 10236,
  [11856] = 10240,
  [11857] = 10237,
  [11858] = 4015,
  [11859] = 10241,
  [11860] = 10242,
  [11861] = 10237,
  [11862] = 10243,
  [11863] = 4026,
  [11864] = 10232,
  [11865] = 10237,
  [11866] = 10245,
  [11867] = 10246,
  [11868] = 10247,
  [11869] = 10237,
  [11870] = 4016,
  [11871] = 10246,
  [11872] = 10245,
  [11873] = 10237,
  [11874] = 4019,
  [11875] = 4020,
  [11876] = 10232,
  [11877] = 10237,
  [11878] = 10236,
  [11879] = 4025,
  [11880] = 4037,
  [11881] = 10237,
  [11882] = 10240,
  [11883] = 10241,
  [11884] = 10242,
  [11885] = 10237,
  [11886] = 4034,
  [11887] = 4036,
  [11888] = 10243,
  [11889] = 10237,
  [11890] = 4012,
  [11891] = 10232,
  [11892] = 10245,
  [11893] = 10237,
  [11894] = 10246,
  [11895] = 10243,
  [11896] = 10242,
  [11897] = 10237,
  [11898] = 10241,
  [11899] = 10240,
  [11900] = 10239,
  [11901] = 10237,
  [11902] = 10245,
  [11903] = 10240,
  [11904] = 10241,
  [11905] = 10237,
  [11906] = 10242,
  [11907] = 10243,
  [11908] = 10232,
  [11909] = 10237,
  [11910] = 10245,
  [11911] = 10246,
  [11912] = 10238,
  [11913] = 10237,
  [11914] = 10236,
  [11915] = 10240,
  [11916] = 10241,
  [11917] = 10237,
  [11918] = 10242,
  [11919] = 10243,
  [11920] = 10232,
  [11921] = 10237,
  [11922] = 10246,
  [11923] = 10246,
  [11924] = 10236,
  [11925] = 10237,
  [11926] = 10235,
  [11927] = 10234,
  [11928] = 10236,
  [11929] = 10237,
  [11930] = 10240,
  [11931] = 10241,
  [11932] = 10242,
  [11933] = 10237,
  [11934] = 10243,
  [11935] = 10232,
  [11936] = 10245,
  [11937] = 10237,
  [11938] = 10246,
  [11939] = 10254,
  [11940] = 10253,
  [11941] = 10237,
  [11942] = 10252,
  [11943] = 10251,
  [11944] = 10236,
  [11945] = 10237,
  [11946] = 10240,
  [11947] = 10241,
  [11948] = 10242,
  [11949] = 10237,
  [11950] = 10243,
  [11951] = 10232,
  [11952] = 10245,
  [11953] = 10237,
  [11954] = 10246,
  [11955] = 10250,
  [11956] = 10233,
  [11957] = 10237,
  [11958] = 10247,
  [11959] = 10236,
  [11960] = 10240,
  [11961] = 10237,
  [11962] = 10241,
  [11963] = 10242,
  [11964] = 10243,
  [11965] = 10237,
  [11966] = 10232,
  [11967] = 10245,
  [11968] = 10246,
  [11969] = 10237,
  [11970] = 10246,
  [11971] = 10245,
  [11972] = 10232,
  [11973] = 10237,
  [11974] = 10243,
  [11975] = 10242,
  [11976] = 10236,
  [11977] = 10237,
  [11978] = 10240,
  [11979] = 10241,
  [11980] = 10242,
  [11981] = 10237,
  [11982] = 10243,
  [11983] = 10232,
  [11984] = 10245,
  [11985] = 10237,
  [11986] = 10246,
  [11987] = 10241,
  [11988] = 10240,
  [11989] = 10237,
  [11990] = 10239,
  [11991] = 10236,
  [11992] = 10236,
  [11993] = 10237,
  [11994] = 10240,
  [11995] = 10241,
  [11996] = 10242,
  [11997] = 10237,
  [11998] = 10243,
  [11999] = 10232,
  [12000] = 10245,
  [12001] = 10237,
  [12002] = 10246,
  [12003] = 10235,
  [12004] = 10254,
  [12005] = 10237,
  [12006] = 10253,
  [12007] = 10252,
  [12008] = 10251,
  [12009] = 10237,
  [12010] = 10236,
  [12011] = 10240,
  [12012] = 10241,
  [12013] = 10237,
  [12014] = 10242,
  [12015] = 10243,
  [12016] = 10232,
  [12017] = 10237,
  [12018] = 10245,
  [12019] = 10246,
  [12020] = 10250,
  [12021] = 10237,
  [12022] = 10233,
  [12023] = 10248,
  [12024] = 10248,
  [12025] = 10237,
  [12026] = 10236,
  [12027] = 10240,
  [12028] = 10241,
  [12029] = 10237,
  [12030] = 10242,
  [12031] = 10243,
  [12032] = 10232,
  [12033] = 10237,
  [12034] = 10172,
  [12035] = 10245,
  [12036] = 10243,
  [12037] = 10237,
  [12038] = 10246,
  [12039] = 10245,
  [12040] = 10232,
  [12041] = 10237,
  [12042] = 10243,
  [12043] = 10242,
  [12044] = 10236,
  [12045] = 10237,
  [12046] = 10240,
  [12047] = 10241,
  [12048] = 10242,
  [12049] = 10237,
  [12050] = 10241,
  [12051] = 10232,
  [12052] = 10245,
  [12053] = 10237,
  [12054] = 10246,
  [12055] = 10241,
  [12056] = 10240,
  [12057] = 10237,
  [12058] = 10236,
  [12059] = 10236,
  [12060] = 10240,
  [12061] = 10237,
  [12062] = 10241,
  [12063] = 10242,
  [12064] = 10233,
  [12065] = 10237,
  [12066] = 10243,
  [12067] = 10232,
  [12068] = 10245,
  [12069] = 10237,
  [12070] = 10246,
  [12071] = 10246,
  [12072] = 10245,
  [12073] = 10237,
  [12074] = 10232,
  [12075] = 10243,
  [12076] = 10242,
  [12077] = 10237,
  [12078] = 10236,
  [12079] = 10240,
  [12080] = 10241,
  [12081] = 10237,
  [12082] = 9987,
  [12083] = 10242,
  [12084] = 10243,
  [12085] = 10237,
  [12086] = 10232,
  [12087] = 10245,
  [12088] = 10246,
  [12089] = 10237,
  [12090] = 10241,
  [12091] = 10240,
  [12092] = 10236,
  [12093] = 10237,
  [12094] = 10247,
  [12095] = 10236,
  [12096] = 10240,
  [12097] = 10237,
  [12098] = 10241,
  [12099] = 10242,
  [12100] = 10243,
  [12101] = 10237,
  [12102] = 10232,
  [12103] = 10245,
  [12104] = 10246,
  [12105] = 10237,
  [12106] = 10246,
  [12107] = 10245,
  [12108] = 10232,
  [12109] = 10237,
  [12110] = 10243,
  [12111] = 10242,
  [12112] = 10236,
  [12113] = 10237,
  [12114] = 10240,
  [12115] = 10241,
  [12116] = 10242,
  [12117] = 10237,
  [12118] = 10243,
  [12119] = 10232,
  [12120] = 10245,
  [12121] = 10237,
  [12122] = 10246,
  [12123] = 10241,
  [12124] = 10240,
  [12125] = 10237,
  [12126] = 10236,
  [12127] = 10236,
  [12128] = 10240,
  [12129] = 10237,
  [12130] = 12130,
  [12131] = 10241,
  [12132] = 10242,
  [12133] = 10237,
  [12134] = 10243,
  [12135] = 10232,
  [12136] = 10245,
  [12137] = 10237,
  [12138] = 12138,
  [12139] = 10246,
  [12140] = 10246,
  [12141] = 10237,
  [12142] = 10245,
  [12143] = 10232,
  [12144] = 10243,
  [12145] = 10237,
  [12146] = 12146,
  [12147] = 10242,
  [12148] = 10236,
  [12149] = 10237,
  [12150] = 10240,
  [12151] = 12151,
  [12152] = 10241,
  [12153] = 10237,
  [12154] = 10242,
  [12155] = 12155,
  [12156] = 10243,
  [12157] = 10237,
  [12158] = 10232,
  [12159] = 10245,
  [12160] = 10246,
  [12161] = 10237,
  [12162] = 10241,
  [12163] = 10240,
  [12164] = 10236,
  [12165] = 10237,
  [12166] = 10236,
  [12167] = 10240,
  [12168] = 12168,
  [12169] = 10237,
  [12170] = 12170,
  [12171] = 11522,
  [12172] = 12172,
  [12173] = 10237,
  [12174] = 12174,
  [12175] = 10247,
  [12176] = 10248,
  [12177] = 10237,
  [12178] = 12178,
  [12179] = 10236,
  [12180] = 10250,
  [12181] = 10237,
  [12182] = 10242,
  [12183] = 10243,
  [12184] = 12184,
  [12185] = 10237,
  [12186] = 12186,
  [12187] = 10232,
  [12188] = 10245,
  [12189] = 10237,
  [12190] = 10246,
  [12191] = 10246,
  [12192] = 10245,
  [12193] = 10237,
  [12194] = 10232,
  [12195] = 10243,
  [12196] = 10242,
  [12197] = 10237,
  [12198] = 10236,
  [12199] = 12199,
  [12200] = 10240,
  [12201] = 10237,
  [12202] = 10241,
  [12203] = 10242,
  [12204] = 10243,
  [12205] = 10237,
  [12206] = 10232,
  [12207] = 12207,
  [12208] = 10245,
  [12209] = 10237,
  [12210] = 12210,
  [12211] = 10246,
  [12212] = 10241,
  [12213] = 10237,
  [12214] = 10240,
  [12215] = 12215,
  [12216] = 10236,
  [12217] = 10237,
  [12218] = 10236,
  [12219] = 10240,
  [12220] = 10241,
  [12221] = 10237,
  [12222] = 10242,
  [12223] = 10243,
  [12224] = 10232,
  [12225] = 10237,
  [12226] = 10245,
  [12227] = 10246,
  [12228] = 10246,
  [12229] = 10237,
  [12230] = 10245,
  [12231] = 10232,
  [12232] = 10251,
  [12233] = 10237,
  [12234] = 10252,
  [12235] = 10253,
  [12236] = 10243,
  [12237] = 10237,
  [12238] = 10254,
  [12239] = 10242,
  [12240] = 10236,
  [12241] = 10237,
  [12242] = 12242,
  [12243] = 12243,
  [12244] = 10240,
  [12245] = 10237,
  [12246] = 11533,
  [12247] = 10241,
  [12248] = 12248,
  [12249] = 10237,
  [12250] = 10242,
  [12251] = 10243,
  [12252] = 12252,
  [12253] = 10237,
  [12254] = 10232,
  [12255] = 10245,
  [12256] = 10246,
  [12257] = 10237,
  [12258] = 12258,
  [12259] = 12259,
  [12260] = 12260,
  [12261] = 10237,
  [12262] = 12262,
  [12263] = 12263,
  [12264] = 10241,
  [12265] = 10237,
  [12266] = 10240,
  [12267] = 10236,
  [12268] = 12268,
  [12269] = 10237,
  [12270] = 10236,
  [12271] = 10240,
  [12272] = 11535,
  [12273] = 10237,
  [12274] = 12274,
  [12275] = 10241,
  [12276] = 10242,
  [12277] = 10237,
  [12278] = 10243,
  [12279] = 10232,
  [12280] = 10245,
  [12281] = 10237,
  [12282] = 10246,
  [12283] = 12283,
  [12284] = 10246,
  [12285] = 10237,
  [12286] = 10245,
  [12287] = 10232,
  [12288] = 10242,
  [12289] = 10237,
  [12290] = 10236,
  [12291] = 10240,
  [12292] = 10241,
  [12293] = 10237,
  [12294] = 10242,
  [12295] = 10243,
  [12296] = 10232,
  [12297] = 10237,
  [12298] = 10245,
  [12299] = 10246,
  [12300] = 10241,
  [12301] = 10237,
  [12302] = 12302,
  [12303] = 10240,
  [12304] = 10236,
  [12305] = 10237,
  [12306] = 10246,
  [12307] = 10240,
  [12308] = 10241,
  [12309] = 10237,
  [12310] = 10234,
  [12311] = 10242,
  [12312] = 10243,
  [12313] = 10237,
  [12314] = 10232,
  [12315] = 10245,
  [12316] = 12316,
  [12317] = 10237,
  [12318] = 10246,
  [12319] = 10246,
  [12320] = 10245,
  [12321] = 10237,
  [12322] = 10232,
  [12323] = 10243,
  [12324] = 10242,
  [12325] = 10237,
  [12326] = 10236,
  [12327] = 10240,
  [12328] = 10241,
  [12329] = 10237,
  [12330] = 10242,
  [12331] = 10243,
  [12332] = 12332,
  [12333] = 10232,
  [12334] = 12334,
  [12335] = 12335,
  [12336] = 12336,
  [12337] = 10245,
  [12338] = 10246,
  [12339] = 10241,
  [12340] = 12340,
  [12341] = 10240,
  [12342] = 10236,
  [12343] = 12343,
  [12344] = 10243,
  [12345] = 10236,
  [12346] = 10240,
  [12347] = 12347,
  [12348] = 10241,
  [12349] = 10242,
  [12350] = 10243,
  [12351] = 12351,
  [12352] = 10232,
  [12353] = 10245,
  [12354] = 10246,
  [12355] = 10246,
  [12356] = 10245,
  [12357] = 12357,
  [12358] = 12358,
  [12359] = 12359,
  [12360] = 10232,
  [12361] = 12347,
  [12362] = 10243,
  [12363] = 10235,
  [12364] = 10242,
  [12365] = 10236,
  [12366] = 10240,
  [12367] = 10241,
  [12368] = 10242,
  [12369] = 10243,
  [12370] = 10232,
  [12371] = 10245,
  [12372] = 10241,
  [12373] = 10241,
  [12374] = 10240,
  [12375] = 10236,
  [12376] = 10236,
  [12377] = 10240,
  [12378] = 10241,
  [12379] = 10242,
  [12380] = 10243,
  [12381] = 10232,
  [12382] = 10236,
  [12383] = 10245,
  [12384] = 10246,
  [12385] = 10246,
  [12386] = 10264,
  [12387] = 10245,
  [12388] = 10232,
  [12389] = 12334,
  [12390] = 10243,
  [12391] = 12336,
  [12392] = 10242,
  [12393] = 10236,
  [12394] = 12394,
  [12395] = 10240,
  [12396] = 10241,
  [12397] = 12347,
  [12398] = 10242,
  [12399] = 12334,
  [12400] = 10243,
  [12401] = 10232,
  [12402] = 10245,
  [12403] = 10246,
  [12404] = 10241,
  [12405] = 10240,
  [12406] = 12347,
  [12407] = 10236,
  [12408] = 12334,
  [12409] = 10236,
  [12410] = 10240,
  [12411] = 10241,
  [12412] = 10242,
  [12413] = 10243,
  [12414] = 10232,
  [12415] = 12347,
  [12416] = 10245,
  [12417] = 12334,
  [12418] = 10246,
  [12419] = 10246,
  [12420] = 10245,
  [12421] = 10232,
  [12422] = 10243,
  [12423] = 10236,
  [12424] = 12347,
  [12425] = 10240,
  [12426] = 12334,
  [12427] = 10241,
  [12428] = 10242,
  [12429] = 10243,
  [12430] = 10232,
  [12431] = 10245,
  [12432] = 10246,
  [12433] = 12347,
  [12434] = 10240,
  [12435] = 12334,
  [12436] = 10240,
  [12437] = 10236,
  [12438] = 10236,
  [12439] = 10240,
  [12440] = 12440,
  [12441] = 10241,
  [12442] = 12347,
  [12443] = 10242,
  [12444] = 12334,
  [12445] = 12445,
  [12446] = 10243,
  [12447] = 10232,
  [12448] = 10245,
  [12449] = 10246,
  [12450] = 10246,
  [12451] = 12347,
  [12452] = 10245,
  [12453] = 12334,
  [12454] = 10232,
  [12455] = 10243,
  [12456] = 10242,
  [12457] = 10236,
  [12458] = 10240,
  [12459] = 10241,
  [12460] = 12347,
  [12461] = 10242,
  [12462] = 12334,
  [12463] = 12463,
  [12464] = 10243,
  [12465] = 10232,
  [12466] = 10245,
  [12467] = 11497,
  [12468] = 10246,
  [12469] = 12347,
  [12470] = 10241,
  [12471] = 12334,
  [12472] = 10240,
  [12473] = 10236,
  [12474] = 10236,
  [12475] = 10240,
  [12476] = 10241,
  [12477] = 10242,
  [12478] = 12347,
  [12479] = 10243,
  [12480] = 12334,
  [12481] = 10232,
  [12482] = 10245,
  [12483] = 12483,
  [12484] = 10246,
  [12485] = 10246,
  [12486] = 10245,
  [12487] = 12347,
  [12488] = 10232,
  [12489] = 12334,
  [12490] = 10243,
  [12491] = 10242,
  [12492] = 10675,
  [12493] = 10236,
  [12494] = 10238,
  [12495] = 10240,
  [12496] = 12347,
  [12497] = 10241,
  [12498] = 12334,
  [12499] = 10242,
  [12500] = 10243,
  [12501] = 12501,
  [12502] = 10232,
  [12503] = 10245,
  [12504] = 10246,
  [12505] = 12347,
  [12506] = 10241,
  [12507] = 12334,
  [12508] = 12508,
  [12509] = 10240,
  [12510] = 10236,
  [12511] = 10236,
  [12512] = 10246,
  [12513] = 10241,
  [12514] = 12347,
  [12515] = 10242,
  [12516] = 12334,
  [12517] = 10243,
  [12518] = 10232,
  [12519] = 10245,
  [12520] = 10661,
  [12521] = 10246,
  [12522] = 10246,
  [12523] = 12347,
  [12524] = 10245,
  [12525] = 12334,
  [12526] = 10232,
  [12527] = 10243,
  [12528] = 10662,
  [12529] = 10242,
  [12530] = 10236,
  [12531] = 10240,
  [12532] = 12347,
  [12533] = 10241,
  [12534] = 12334,
  [12535] = 10242,
  [12536] = 10243,
  [12537] = 10232,
  [12538] = 10245,
  [12539] = 12539,
  [12540] = 10246,
  [12541] = 12347,
  [12542] = 10241,
  [12543] = 12334,
  [12544] = 12544,
  [12545] = 10240,
  [12546] = 10236,
  [12547] = 12547,
  [12548] = 10672,
  [12549] = 10236,
  [12550] = 12347,
  [12551] = 10240,
  [12552] = 12334,
  [12553] = 10241,
  [12554] = 10242,
  [12555] = 10239,
  [12556] = 10243,
  [12557] = 10232,
  [12558] = 10245,
  [12559] = 12347,
  [12560] = 10246,
  [12561] = 12334,
  [12562] = 10246,
  [12563] = 10245,
  [12564] = 10676,
  [12565] = 10232,
  [12566] = 10243,
  [12567] = 10242,
  [12568] = 12347,
  [12569] = 10236,
  [12570] = 12334,
  [12571] = 10240,
  [12572] = 10241,
  [12573] = 12573,
  [12574] = 10242,
  [12575] = 10243,
  [12576] = 10232,
  [12577] = 12347,
  [12578] = 10245,
  [12579] = 12334,
  [12580] = 12580,
  [12581] = 10246,
  [12582] = 10241,
  [12583] = 10240,
  [12584] = 10240,
  [12585] = 10236,
  [12586] = 12347,
  [12587] = 10242,
  [12588] = 12334,
  [12589] = 10236,
  [12590] = 10237,
  [12591] = 10240,
  [12592] = 12347,
  [12593] = 10241,
  [12594] = 12334,
  [12595] = 10242,
  [12596] = 10243,
  [12597] = 10232,
  [12598] = 12347,
  [12599] = 10245,
  [12600] = 12334,
  [12601] = 10246,
  [12602] = 10246,
  [12603] = 10245,
  [12604] = 12347,
  [12605] = 10232,
  [12606] = 12334,
  [12607] = 10243,
  [12608] = 10242,
  [12609] = 10236,
  [12610] = 12347,
  [12611] = 10240,
  [12612] = 12334,
  [12613] = 10241,
  [12614] = 10242,
  [12615] = 10243,
  [12616] = 12347,
  [12617] = 10232,
  [12618] = 12334,
  [12619] = 10245,
  [12620] = 10246,
  [12621] = 10241,
  [12622] = 12347,
  [12623] = 10240,
  [12624] = 12334,
  [12625] = 10236,
  [12626] = 12626,
  [12627] = 10236,
  [12628] = 12347,
  [12629] = 10240,
  [12630] = 12334,
  [12631] = 10241,
  [12632] = 12632,
  [12633] = 10242,
  [12634] = 12347,
  [12635] = 10243,
  [12636] = 12334,
  [12637] = 10232,
  [12638] = 10245,
  [12639] = 10246,
  [12640] = 12347,
  [12641] = 10246,
  [12642] = 12334,
  [12643] = 10245,
  [12644] = 10232,
  [12645] = 10243,
  [12646] = 12347,
  [12647] = 10242,
  [12648] = 12334,
  [12649] = 10236,
  [12650] = 10240,
  [12651] = 10241,
  [12652] = 12347,
  [12653] = 10242,
  [12654] = 12334,
  [12655] = 10243,
  [12656] = 10232,
  [12657] = 10245,
  [12658] = 12347,
  [12659] = 10246,
  [12660] = 12334,
  [12661] = 10241,
  [12662] = 10240,
  [12663] = 10236,
  [12664] = 12347,
  [12665] = 10236,
  [12666] = 12334,
  [12667] = 10240,
  [12668] = 10241,
  [12669] = 10242,
  [12670] = 12347,
  [12671] = 10243,
  [12672] = 12334,
  [12673] = 10232,
  [12674] = 10245,
  [12675] = 10246,
  [12676] = 12347,
  [12677] = 10243,
  [12678] = 12334,
  [12679] = 10245,
  [12680] = 10232,
  [12681] = 10243,
  [12682] = 12347,
  [12683] = 10242,
  [12684] = 12334,
  [12685] = 10236,
  [12686] = 10240,
  [12687] = 10241,
  [12688] = 12347,
  [12689] = 10242,
  [12690] = 12334,
  [12691] = 10241,
  [12692] = 10232,
  [12693] = 10245,
  [12694] = 12347,
  [12695] = 10246,
  [12696] = 12334,
  [12697] = 10241,
  [12698] = 10240,
  [12699] = 10236,
  [12700] = 12347,
  [12701] = 10236,
  [12702] = 12334,
  [12703] = 10240,
  [12704] = 10241,
  [12705] = 10242,
  [12706] = 12347,
  [12707] = 10243,
  [12708] = 12334,
  [12709] = 10232,
  [12710] = 10245,
  [12711] = 10246,
  [12712] = 12347,
  [12713] = 10246,
  [12714] = 12334,
  [12715] = 10245,
  [12716] = 10232,
  [12717] = 12347,
  [12718] = 10243,
  [12719] = 10242,
  [12720] = 12347,
  [12721] = 10236,
  [12722] = 10240,
  [12723] = 12347,
  [12724] = 10241,
  [12725] = 10242,
  [12726] = 12347,
  [12727] = 10243,
  [12728] = 10232,
  [12729] = 12347,
  [12730] = 10245,
  [12731] = 10246,
  [12732] = 12347,
  [12733] = 10241,
  [12734] = 10240,
  [12735] = 12347,
  [12736] = 10236,
  [12737] = 10236,
  [12738] = 12347,
  [12739] = 10240,
  [12740] = 10241,
  [12741] = 12347,
  [12742] = 10242,
  [12743] = 10243,
  [12744] = 12347,
  [12745] = 10232,
  [12746] = 10245,
  [12747] = 12347,
  [12748] = 10246,
  [12749] = 12347,
  [12750] = 12750,
  [12751] = 10246,
  [12752] = 10245,
  [12753] = 10232,
  [12754] = 10243,
  [12755] = 10236,
  [12756] = 10240,
  [12757] = 10241,
  [12758] = 10242,
  [12759] = 10243,
  [12760] = 10232,
  [12761] = 10245,
  [12762] = 10241,
  [12763] = 10242,
  [12764] = 10264,
  [12765] = 10246,
  [12766] = 10243,
  [12767] = 10236,
  [12768] = 10232,
  [12769] = 10245,
  [12770] = 10240,
  [12771] = 10241,
  [12772] = 10246,
  [12773] = 10242,
  [12774] = 10243,
  [12775] = 10232,
  [12776] = 10245,
  [12777] = 10246,
  [12778] = 10236,
  [12779] = 10240,
  [12780] = 10241,
  [12781] = 10242,
  [12782] = 10243,
  [12783] = 10232,
  [12784] = 10245,
  [12785] = 10246,
  [12786] = 10236,
  [12787] = 10240,
  [12788] = 10241,
  [12789] = 10242,
  [12790] = 10243,
  [12791] = 10232,
  [12792] = 10245,
  [12793] = 10246,
  [12794] = 11515,
  [12795] = 10236,
  [12796] = 12796,
  [12797] = 12336,
  [12798] = 12334,
  [12799] = 10240,
  [12800] = 10241,
  [12801] = 10242,
  [12802] = 12332,
  [12803] = 12750,
  [12804] = 10243,
  [12805] = 10232,
  [12806] = 10245,
  [12807] = 10246,
  [12808] = 10236,
  [12809] = 10240,
  [12810] = 10241,
  [12811] = 10242,
  [12812] = 10243,
  [12813] = 10232,
  [12814] = 10245,
  [12815] = 10246,
  [12816] = 10236,
  [12817] = 10240,
};

static inline bool sym_id_character_set_1(int32_t c) {
  return (c < '.'
    ? (c < ' '
      ? (c < '\t'
        ? c == 0
        : c <= '\r')
      : (c <= ' ' || (c < '('
        ? c == '"'
        : c <= ')')))
    : (c <= '.' || (c < '{'
      ? (c < '@'
        ? c == ';'
        : c <= '@')
      : (c <= '{' || c == '}'))));
}

static inline bool sym_id_character_set_2(int32_t c) {
  return (c < '('
    ? (c < ' '
      ? (c < '\t'
        ? c == 0
        : c <= '\r')
      : (c <= ' ' || c == '"'))
    : (c <= ')' || (c < '{'
      ? (c < '@'
        ? c == ';'
        : c <= '@')
      : (c <= '{' || c == '}'))));
}

static inline bool sym_id_character_set_3(int32_t c) {
  return (c < '('
    ? (c < ' '
      ? (c < '\t'
        ? c == 0
        : c <= '\r')
      : (c <= ' ' || c == '"'))
    : (c <= '(' || (c < '{'
      ? (c < '@'
        ? c == ';'
        : c <= '@')
      : (c <= '{' || c == '}'))));
}

static inline bool sym_id_character_set_4(int32_t c) {
  return (c < '.'
    ? (c < ' '
      ? (c < '\t'
        ? c == 0
        : c <= '\r')
      : (c <= ' ' || (c < '('
        ? c == '"'
        : c <= '(')))
    : (c <= '.' || (c < '{'
      ? (c < '@'
        ? c == ';'
        : c <= '@')
      : (c <= '{' || c == '}'))));
}

static inline bool sym_id_character_set_5(int32_t c) {
  return (c < '('
    ? (c < ' '
      ? (c < '\t'
        ? c == 0
        : c <= '\r')
      : (c <= ' ' || c == '"'))
    : (c <= ')' || (c < '@'
      ? (c < ';'
        ? c == '.'
        : c <= ';')
      : (c <= '@' || c == '{'))));
}

static inline bool aux_sym__qid_token1_character_set_1(int32_t c) {
  return (c < '.'
    ? (c < ' '
      ? (c < '\t'
        ? c == 0
        : c <= '\r')
      : (c <= ' ' || (c < '\''
        ? c == '"'
        : c <= ')')))
    : (c <= '.' || (c < '{'
      ? (c < '@'
        ? c == ';'
        : c <= '@')
      : (c <= '{' || c == '}'))));
}

static inline bool sym_comment_character_set_1(int32_t c) {
  return (c < '('
    ? (c < ' '
      ? (c < 11
        ? c == '\t'
        : c <= '\r')
      : (c <= ' ' || c == '"'))
    : (c <= ')' || (c < '{'
      ? (c < '@'
        ? c == ';'
        : c <= '@')
      : (c <= '{' || c == '}'))));
}

static inline bool sym_comment_character_set_2(int32_t c) {
  return (c < '.'
    ? (c < ' '
      ? (c < 11
        ? c == '\t'
        : c <= '\r')
      : (c <= ' ' || (c < '('
        ? c == '"'
        : c <= ')')))
    : (c <= '.' || (c < '{'
      ? (c < '@'
        ? c == ';'
        : c <= '@')
      : (c <= '{' || c == '}'))));
}

static inline bool sym_comment_character_set_3(int32_t c) {
  return (c < '.'
    ? (c < ' '
      ? (c < 11
        ? c == '\t'
        : c <= '\r')
      : (c <= ' ' || (c < '\''
        ? c == '"'
        : c <= ')')))
    : (c <= '.' || (c < '{'
      ? (c < '@'
        ? c == ';'
        : c <= '@')
      : (c <= '{' || c == '}'))));
}

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  switch (state) {
    case 0:
      if (eof) ADVANCE(453);
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '#') ADVANCE(530);
      if (lookahead == '(') ADVANCE(497);
      if (lookahead == ')') ADVANCE(498);
      if (lookahead == '-') ADVANCE(662);
      if (lookahead == '.') ADVANCE(657);
      if (lookahead == '0') ADVANCE(649);
      if (lookahead == ':') ADVANCE(471);
      if (lookahead == ';') ADVANCE(506);
      if (lookahead == '=') ADVANCE(474);
      if (lookahead == '@') ADVANCE(665);
      if (lookahead == 'C') ADVANCE(591);
      if (lookahead == '\\') ADVANCE(300);
      if (lookahead == '_') ADVANCE(517);
      if (lookahead == 'c') ADVANCE(632);
      if (lookahead == 'h') ADVANCE(616);
      if (lookahead == 'i') ADVANCE(625);
      if (lookahead == 'm') ADVANCE(633);
      if (lookahead == 'p') ADVANCE(645);
      if (lookahead == 'r') ADVANCE(604);
      if (lookahead == 't') ADVANCE(631);
      if (lookahead == 'u') ADVANCE(639);
      if (lookahead == 'w') ADVANCE(614);
      if (lookahead == '{') ADVANCE(524);
      if (lookahead == '|') ADVANCE(667);
      if (lookahead == '}') ADVANCE(527);
      if (lookahead == 955) ADVANCE(465);
      if (lookahead == 8230) ADVANCE(468);
      if (lookahead == 8594) ADVANCE(461);
      if (lookahead == 8704) ADVANCE(455);
      if (lookahead == 10627) ADVANCE(513);
      if (lookahead == 10628) ADVANCE(516);
      if (lookahead == 10631) ADVANCE(675);
      if (lookahead == 10632) ADVANCE(678);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(0)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(651);
      if (lookahead != 0 &&
          lookahead != '\'') ADVANCE(654);
      END_STATE();
    case 1:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '#') ADVANCE(530);
      if (lookahead == '(') ADVANCE(497);
      if (lookahead == ')') ADVANCE(498);
      if (lookahead == '-') ADVANCE(662);
      if (lookahead == '.') ADVANCE(657);
      if (lookahead == '0') ADVANCE(649);
      if (lookahead == ':') ADVANCE(471);
      if (lookahead == ';') ADVANCE(506);
      if (lookahead == '=') ADVANCE(474);
      if (lookahead == '@') ADVANCE(665);
      if (lookahead == 'C') ADVANCE(591);
      if (lookahead == '\\') ADVANCE(300);
      if (lookahead == '_') ADVANCE(517);
      if (lookahead == 'c') ADVANCE(632);
      if (lookahead == 'h') ADVANCE(616);
      if (lookahead == 'i') ADVANCE(625);
      if (lookahead == 'm') ADVANCE(633);
      if (lookahead == 'p') ADVANCE(645);
      if (lookahead == 'r') ADVANCE(604);
      if (lookahead == 't') ADVANCE(631);
      if (lookahead == 'u') ADVANCE(639);
      if (lookahead == 'w') ADVANCE(614);
      if (lookahead == '{') ADVANCE(524);
      if (lookahead == '|') ADVANCE(667);
      if (lookahead == '}') ADVANCE(527);
      if (lookahead == 955) ADVANCE(465);
      if (lookahead == 8230) ADVANCE(468);
      if (lookahead == 8594) ADVANCE(461);
      if (lookahead == 8704) ADVANCE(455);
      if (lookahead == 10627) ADVANCE(513);
      if (lookahead == 10628) ADVANCE(516);
      if (lookahead == 10631) ADVANCE(675);
      if (lookahead == 10632) ADVANCE(678);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(1)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(651);
      if (lookahead != 0 &&
          lookahead != '\'') ADVANCE(654);
      END_STATE();
    case 2:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '(') ADVANCE(497);
      if (lookahead == ')') ADVANCE(498);
      if (lookahead == '-') ADVANCE(534);
      if (lookahead == '.') ADVANCE(657);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == ';') ADVANCE(654);
      if (lookahead == '@') ADVANCE(665);
      if (lookahead == '\\') ADVANCE(462);
      if (lookahead == '_') ADVANCE(518);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == '}') ADVANCE(527);
      if (lookahead == 955) ADVANCE(464);
      if (lookahead == 8230) ADVANCE(467);
      if (lookahead == 8704) ADVANCE(454);
      if (lookahead == 10627) ADVANCE(512);
      if (lookahead == 10631) ADVANCE(674);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(2)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (lookahead != 0 &&
          lookahead != '\'') ADVANCE(589);
      END_STATE();
    case 3:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '(') ADVANCE(497);
      if (lookahead == ')') ADVANCE(498);
      if (lookahead == '-') ADVANCE(534);
      if (lookahead == '.') ADVANCE(658);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == ':') ADVANCE(470);
      if (lookahead == ';') ADVANCE(506);
      if (lookahead == '=') ADVANCE(473);
      if (lookahead == '@') ADVANCE(665);
      if (lookahead == '\\') ADVANCE(462);
      if (lookahead == '_') ADVANCE(518);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == '|') ADVANCE(668);
      if (lookahead == '}') ADVANCE(444);
      if (lookahead == 955) ADVANCE(464);
      if (lookahead == 8230) ADVANCE(467);
      if (lookahead == 8704) ADVANCE(454);
      if (lookahead == 10627) ADVANCE(512);
      if (lookahead == 10631) ADVANCE(674);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(3)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (lookahead != 0 &&
          lookahead != '\'') ADVANCE(589);
      END_STATE();
    case 4:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '(') ADVANCE(497);
      if (lookahead == ')') ADVANCE(498);
      if (lookahead == '-') ADVANCE(534);
      if (lookahead == '.') ADVANCE(658);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == ':') ADVANCE(470);
      if (lookahead == ';') ADVANCE(506);
      if (lookahead == '=') ADVANCE(473);
      if (lookahead == '@') ADVANCE(665);
      if (lookahead == '\\') ADVANCE(311);
      if (lookahead == '_') ADVANCE(518);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == '|') ADVANCE(668);
      if (lookahead == '}') ADVANCE(444);
      if (lookahead == 8230) ADVANCE(467);
      if (lookahead == 10627) ADVANCE(512);
      if (lookahead == 10631) ADVANCE(674);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(4)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (lookahead != 0 &&
          lookahead != '\'') ADVANCE(589);
      END_STATE();
    case 5:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '(') ADVANCE(497);
      if (lookahead == ')') ADVANCE(498);
      if (lookahead == '-') ADVANCE(534);
      if (lookahead == '.') ADVANCE(658);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == ':') ADVANCE(470);
      if (lookahead == ';') ADVANCE(506);
      if (lookahead == '@') ADVANCE(665);
      if (lookahead == '\\') ADVANCE(462);
      if (lookahead == '_') ADVANCE(518);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == '|') ADVANCE(668);
      if (lookahead == '}') ADVANCE(527);
      if (lookahead == 955) ADVANCE(464);
      if (lookahead == 8230) ADVANCE(467);
      if (lookahead == 8704) ADVANCE(454);
      if (lookahead == 10627) ADVANCE(512);
      if (lookahead == 10631) ADVANCE(674);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(5)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (lookahead != 0 &&
          lookahead != '\'') ADVANCE(589);
      END_STATE();
    case 6:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '(') ADVANCE(497);
      if (lookahead == ')') ADVANCE(498);
      if (lookahead == '-') ADVANCE(534);
      if (lookahead == '.') ADVANCE(658);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == ':') ADVANCE(470);
      if (lookahead == ';') ADVANCE(506);
      if (lookahead == '@') ADVANCE(665);
      if (lookahead == '\\') ADVANCE(317);
      if (lookahead == '_') ADVANCE(518);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == '|') ADVANCE(668);
      if (lookahead == '}') ADVANCE(527);
      if (lookahead == 8230) ADVANCE(467);
      if (lookahead == 10627) ADVANCE(512);
      if (lookahead == 10631) ADVANCE(674);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(6)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (lookahead != 0 &&
          lookahead != '\'') ADVANCE(589);
      END_STATE();
    case 7:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '(') ADVANCE(497);
      if (lookahead == ')') ADVANCE(498);
      if (lookahead == '-') ADVANCE(534);
      if (lookahead == '.') ADVANCE(658);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == ':') ADVANCE(470);
      if (lookahead == ';') ADVANCE(654);
      if (lookahead == '=') ADVANCE(473);
      if (lookahead == '@') ADVANCE(665);
      if (lookahead == '\\') ADVANCE(462);
      if (lookahead == '_') ADVANCE(518);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == '|') ADVANCE(668);
      if (lookahead == '}') ADVANCE(444);
      if (lookahead == 955) ADVANCE(464);
      if (lookahead == 8230) ADVANCE(467);
      if (lookahead == 8704) ADVANCE(454);
      if (lookahead == 10627) ADVANCE(512);
      if (lookahead == 10631) ADVANCE(674);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(7)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (lookahead != 0 &&
          lookahead != '\'') ADVANCE(589);
      END_STATE();
    case 8:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '(') ADVANCE(497);
      if (lookahead == ')') ADVANCE(498);
      if (lookahead == '-') ADVANCE(534);
      if (lookahead == '.') ADVANCE(658);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == ':') ADVANCE(470);
      if (lookahead == ';') ADVANCE(654);
      if (lookahead == '=') ADVANCE(473);
      if (lookahead == '@') ADVANCE(665);
      if (lookahead == '\\') ADVANCE(462);
      if (lookahead == '_') ADVANCE(518);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == '}') ADVANCE(444);
      if (lookahead == 955) ADVANCE(464);
      if (lookahead == 8230) ADVANCE(467);
      if (lookahead == 8704) ADVANCE(454);
      if (lookahead == 10627) ADVANCE(512);
      if (lookahead == 10631) ADVANCE(674);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(8)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (lookahead != 0 &&
          lookahead != '\'') ADVANCE(589);
      END_STATE();
    case 9:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '(') ADVANCE(497);
      if (lookahead == ')') ADVANCE(498);
      if (lookahead == '-') ADVANCE(534);
      if (lookahead == '.') ADVANCE(658);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == ':') ADVANCE(470);
      if (lookahead == ';') ADVANCE(654);
      if (lookahead == '=') ADVANCE(473);
      if (lookahead == '@') ADVANCE(665);
      if (lookahead == '\\') ADVANCE(399);
      if (lookahead == '_') ADVANCE(518);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == '|') ADVANCE(668);
      if (lookahead == '}') ADVANCE(444);
      if (lookahead == 8230) ADVANCE(467);
      if (lookahead == 10627) ADVANCE(512);
      if (lookahead == 10631) ADVANCE(674);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(9)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (lookahead != 0 &&
          lookahead != '\'') ADVANCE(589);
      END_STATE();
    case 10:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '(') ADVANCE(497);
      if (lookahead == ')') ADVANCE(498);
      if (lookahead == '-') ADVANCE(534);
      if (lookahead == '.') ADVANCE(658);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == ':') ADVANCE(470);
      if (lookahead == ';') ADVANCE(654);
      if (lookahead == '@') ADVANCE(665);
      if (lookahead == '\\') ADVANCE(462);
      if (lookahead == '_') ADVANCE(518);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == '|') ADVANCE(668);
      if (lookahead == '}') ADVANCE(444);
      if (lookahead == 955) ADVANCE(464);
      if (lookahead == 8230) ADVANCE(467);
      if (lookahead == 8704) ADVANCE(454);
      if (lookahead == 10627) ADVANCE(512);
      if (lookahead == 10631) ADVANCE(674);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(10)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (lookahead != 0 &&
          lookahead != '\'') ADVANCE(589);
      END_STATE();
    case 11:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '(') ADVANCE(497);
      if (lookahead == ')') ADVANCE(498);
      if (lookahead == '-') ADVANCE(534);
      if (lookahead == '.') ADVANCE(658);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == ':') ADVANCE(470);
      if (lookahead == ';') ADVANCE(654);
      if (lookahead == '@') ADVANCE(665);
      if (lookahead == '\\') ADVANCE(462);
      if (lookahead == '_') ADVANCE(518);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == '}') ADVANCE(444);
      if (lookahead == 955) ADVANCE(464);
      if (lookahead == 8230) ADVANCE(467);
      if (lookahead == 8704) ADVANCE(454);
      if (lookahead == 10627) ADVANCE(512);
      if (lookahead == 10631) ADVANCE(674);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(11)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (lookahead != 0 &&
          lookahead != '\'') ADVANCE(589);
      END_STATE();
    case 12:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '(') ADVANCE(497);
      if (lookahead == ')') ADVANCE(498);
      if (lookahead == '-') ADVANCE(534);
      if (lookahead == '.') ADVANCE(658);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == ':') ADVANCE(470);
      if (lookahead == ';') ADVANCE(654);
      if (lookahead == '@') ADVANCE(665);
      if (lookahead == '\\') ADVANCE(405);
      if (lookahead == '_') ADVANCE(518);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == '|') ADVANCE(668);
      if (lookahead == '}') ADVANCE(444);
      if (lookahead == 8230) ADVANCE(467);
      if (lookahead == 10627) ADVANCE(512);
      if (lookahead == 10631) ADVANCE(674);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(12)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (lookahead != 0 &&
          lookahead != '\'') ADVANCE(589);
      END_STATE();
    case 13:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '(') ADVANCE(497);
      if (lookahead == ')') ADVANCE(498);
      if (lookahead == '-') ADVANCE(534);
      if (lookahead == '.') ADVANCE(658);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == ';') ADVANCE(506);
      if (lookahead == '=') ADVANCE(473);
      if (lookahead == '@') ADVANCE(665);
      if (lookahead == '\\') ADVANCE(462);
      if (lookahead == '_') ADVANCE(518);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == '|') ADVANCE(668);
      if (lookahead == '}') ADVANCE(527);
      if (lookahead == 955) ADVANCE(464);
      if (lookahead == 8230) ADVANCE(467);
      if (lookahead == 8704) ADVANCE(454);
      if (lookahead == 10627) ADVANCE(512);
      if (lookahead == 10631) ADVANCE(674);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(13)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (lookahead != 0 &&
          lookahead != '\'') ADVANCE(589);
      END_STATE();
    case 14:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '(') ADVANCE(497);
      if (lookahead == ')') ADVANCE(498);
      if (lookahead == '-') ADVANCE(534);
      if (lookahead == '.') ADVANCE(658);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == ';') ADVANCE(506);
      if (lookahead == '=') ADVANCE(473);
      if (lookahead == '@') ADVANCE(665);
      if (lookahead == '\\') ADVANCE(315);
      if (lookahead == '_') ADVANCE(518);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == '|') ADVANCE(668);
      if (lookahead == '}') ADVANCE(444);
      if (lookahead == 8230) ADVANCE(467);
      if (lookahead == 10627) ADVANCE(512);
      if (lookahead == 10631) ADVANCE(674);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(14)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (lookahead != 0 &&
          lookahead != '\'') ADVANCE(589);
      END_STATE();
    case 15:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '(') ADVANCE(497);
      if (lookahead == ')') ADVANCE(498);
      if (lookahead == '-') ADVANCE(534);
      if (lookahead == '.') ADVANCE(658);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == ';') ADVANCE(654);
      if (lookahead == '=') ADVANCE(473);
      if (lookahead == '@') ADVANCE(665);
      if (lookahead == '\\') ADVANCE(462);
      if (lookahead == '_') ADVANCE(518);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == '|') ADVANCE(668);
      if (lookahead == '}') ADVANCE(444);
      if (lookahead == 955) ADVANCE(464);
      if (lookahead == 8230) ADVANCE(467);
      if (lookahead == 8704) ADVANCE(454);
      if (lookahead == 10627) ADVANCE(512);
      if (lookahead == 10631) ADVANCE(674);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(15)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (lookahead != 0 &&
          lookahead != '\'') ADVANCE(589);
      END_STATE();
    case 16:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '(') ADVANCE(497);
      if (lookahead == ')') ADVANCE(498);
      if (lookahead == '-') ADVANCE(534);
      if (lookahead == '.') ADVANCE(658);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == ';') ADVANCE(654);
      if (lookahead == '=') ADVANCE(473);
      if (lookahead == '@') ADVANCE(665);
      if (lookahead == '\\') ADVANCE(403);
      if (lookahead == '_') ADVANCE(518);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == '|') ADVANCE(668);
      if (lookahead == '}') ADVANCE(444);
      if (lookahead == 8230) ADVANCE(467);
      if (lookahead == 10627) ADVANCE(512);
      if (lookahead == 10631) ADVANCE(674);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(16)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (lookahead != 0 &&
          lookahead != '\'') ADVANCE(589);
      END_STATE();
    case 17:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '(') ADVANCE(497);
      if (lookahead == ')') ADVANCE(498);
      if (lookahead == '-') ADVANCE(534);
      if (lookahead == '.') ADVANCE(658);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == ';') ADVANCE(654);
      if (lookahead == '@') ADVANCE(665);
      if (lookahead == '\\') ADVANCE(308);
      if (lookahead == '_') ADVANCE(518);
      if (lookahead == 'h') ADVANCE(554);
      if (lookahead == 'p') ADVANCE(584);
      if (lookahead == 'r') ADVANCE(546);
      if (lookahead == 'u') ADVANCE(577);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == 8230) ADVANCE(467);
      if (lookahead == 10627) ADVANCE(512);
      if (lookahead == 10631) ADVANCE(674);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(17)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (lookahead != 0 &&
          lookahead != '\'' &&
          lookahead != '}') ADVANCE(589);
      END_STATE();
    case 18:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '(') ADVANCE(497);
      if (lookahead == ')') ADVANCE(498);
      if (lookahead == '-') ADVANCE(664);
      if (lookahead == '.') ADVANCE(658);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == ';') ADVANCE(654);
      if (lookahead == '@') ADVANCE(665);
      if (lookahead == '\\') ADVANCE(462);
      if (lookahead == '_') ADVANCE(518);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == '}') ADVANCE(527);
      if (lookahead == 955) ADVANCE(464);
      if (lookahead == 8230) ADVANCE(467);
      if (lookahead == 8704) ADVANCE(454);
      if (lookahead == 10627) ADVANCE(512);
      if (lookahead == 10631) ADVANCE(674);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(18)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (lookahead != 0 &&
          lookahead != '\'') ADVANCE(589);
      END_STATE();
    case 19:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '(') ADVANCE(497);
      if (lookahead == ')') ADVANCE(498);
      if (lookahead == '-') ADVANCE(533);
      if (lookahead == '.') ADVANCE(658);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == ':') ADVANCE(470);
      if (lookahead == ';') ADVANCE(506);
      if (lookahead == '=') ADVANCE(473);
      if (lookahead == '@') ADVANCE(665);
      if (lookahead == '\\') ADVANCE(462);
      if (lookahead == '_') ADVANCE(518);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == '|') ADVANCE(668);
      if (lookahead == '}') ADVANCE(444);
      if (lookahead == 955) ADVANCE(464);
      if (lookahead == 8230) ADVANCE(467);
      if (lookahead == 8594) ADVANCE(460);
      if (lookahead == 8704) ADVANCE(454);
      if (lookahead == 10627) ADVANCE(512);
      if (lookahead == 10631) ADVANCE(674);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(19)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (lookahead != 0 &&
          lookahead != '\'') ADVANCE(589);
      END_STATE();
    case 20:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '(') ADVANCE(497);
      if (lookahead == ')') ADVANCE(498);
      if (lookahead == '-') ADVANCE(533);
      if (lookahead == '.') ADVANCE(658);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == ':') ADVANCE(470);
      if (lookahead == ';') ADVANCE(506);
      if (lookahead == '=') ADVANCE(473);
      if (lookahead == '@') ADVANCE(665);
      if (lookahead == '\\') ADVANCE(462);
      if (lookahead == '_') ADVANCE(518);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == '}') ADVANCE(527);
      if (lookahead == 955) ADVANCE(464);
      if (lookahead == 8230) ADVANCE(467);
      if (lookahead == 8594) ADVANCE(460);
      if (lookahead == 8704) ADVANCE(454);
      if (lookahead == 10627) ADVANCE(512);
      if (lookahead == 10631) ADVANCE(674);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(20)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (lookahead != 0 &&
          lookahead != '\'') ADVANCE(589);
      END_STATE();
    case 21:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '(') ADVANCE(497);
      if (lookahead == ')') ADVANCE(498);
      if (lookahead == '-') ADVANCE(533);
      if (lookahead == '.') ADVANCE(658);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == ':') ADVANCE(470);
      if (lookahead == ';') ADVANCE(506);
      if (lookahead == '=') ADVANCE(473);
      if (lookahead == '@') ADVANCE(665);
      if (lookahead == '\\') ADVANCE(462);
      if (lookahead == '_') ADVANCE(518);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == '}') ADVANCE(444);
      if (lookahead == 955) ADVANCE(464);
      if (lookahead == 8230) ADVANCE(467);
      if (lookahead == 8594) ADVANCE(460);
      if (lookahead == 8704) ADVANCE(454);
      if (lookahead == 10627) ADVANCE(512);
      if (lookahead == 10631) ADVANCE(674);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(21)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (lookahead != 0 &&
          lookahead != '\'') ADVANCE(589);
      END_STATE();
    case 22:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '(') ADVANCE(497);
      if (lookahead == ')') ADVANCE(498);
      if (lookahead == '-') ADVANCE(533);
      if (lookahead == '.') ADVANCE(658);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == ':') ADVANCE(470);
      if (lookahead == ';') ADVANCE(506);
      if (lookahead == '@') ADVANCE(665);
      if (lookahead == '\\') ADVANCE(462);
      if (lookahead == '_') ADVANCE(518);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == '}') ADVANCE(527);
      if (lookahead == 955) ADVANCE(464);
      if (lookahead == 8230) ADVANCE(467);
      if (lookahead == 8594) ADVANCE(460);
      if (lookahead == 8704) ADVANCE(454);
      if (lookahead == 10627) ADVANCE(512);
      if (lookahead == 10631) ADVANCE(674);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(22)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (lookahead != 0 &&
          lookahead != '\'') ADVANCE(589);
      END_STATE();
    case 23:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '(') ADVANCE(497);
      if (lookahead == ')') ADVANCE(498);
      if (lookahead == '-') ADVANCE(533);
      if (lookahead == '.') ADVANCE(658);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == ':') ADVANCE(470);
      if (lookahead == ';') ADVANCE(654);
      if (lookahead == '=') ADVANCE(473);
      if (lookahead == '@') ADVANCE(665);
      if (lookahead == '\\') ADVANCE(462);
      if (lookahead == '_') ADVANCE(518);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == '|') ADVANCE(668);
      if (lookahead == '}') ADVANCE(444);
      if (lookahead == 955) ADVANCE(464);
      if (lookahead == 8230) ADVANCE(467);
      if (lookahead == 8594) ADVANCE(460);
      if (lookahead == 8704) ADVANCE(454);
      if (lookahead == 10627) ADVANCE(512);
      if (lookahead == 10631) ADVANCE(674);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(23)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (lookahead != 0 &&
          lookahead != '\'') ADVANCE(589);
      END_STATE();
    case 24:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '(') ADVANCE(497);
      if (lookahead == ')') ADVANCE(498);
      if (lookahead == '-') ADVANCE(533);
      if (lookahead == '.') ADVANCE(658);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == ';') ADVANCE(506);
      if (lookahead == '=') ADVANCE(473);
      if (lookahead == '@') ADVANCE(665);
      if (lookahead == '\\') ADVANCE(462);
      if (lookahead == '_') ADVANCE(518);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == '|') ADVANCE(668);
      if (lookahead == '}') ADVANCE(527);
      if (lookahead == 955) ADVANCE(464);
      if (lookahead == 8230) ADVANCE(467);
      if (lookahead == 8594) ADVANCE(460);
      if (lookahead == 8704) ADVANCE(454);
      if (lookahead == 10627) ADVANCE(512);
      if (lookahead == 10631) ADVANCE(674);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(24)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (lookahead != 0 &&
          lookahead != '\'') ADVANCE(589);
      END_STATE();
    case 25:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '(') ADVANCE(497);
      if (lookahead == ')') ADVANCE(498);
      if (lookahead == '-') ADVANCE(533);
      if (lookahead == '.') ADVANCE(658);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == ';') ADVANCE(506);
      if (lookahead == '=') ADVANCE(473);
      if (lookahead == '@') ADVANCE(665);
      if (lookahead == '\\') ADVANCE(462);
      if (lookahead == '_') ADVANCE(518);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == '}') ADVANCE(444);
      if (lookahead == 955) ADVANCE(464);
      if (lookahead == 8230) ADVANCE(467);
      if (lookahead == 8594) ADVANCE(460);
      if (lookahead == 8704) ADVANCE(454);
      if (lookahead == 10627) ADVANCE(512);
      if (lookahead == 10631) ADVANCE(674);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(25)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (lookahead != 0 &&
          lookahead != '\'') ADVANCE(589);
      END_STATE();
    case 26:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '(') ADVANCE(497);
      if (lookahead == ')') ADVANCE(498);
      if (lookahead == '-') ADVANCE(533);
      if (lookahead == '.') ADVANCE(658);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == ';') ADVANCE(654);
      if (lookahead == '=') ADVANCE(473);
      if (lookahead == '@') ADVANCE(665);
      if (lookahead == '\\') ADVANCE(462);
      if (lookahead == '_') ADVANCE(518);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == '|') ADVANCE(668);
      if (lookahead == '}') ADVANCE(444);
      if (lookahead == 955) ADVANCE(464);
      if (lookahead == 8230) ADVANCE(467);
      if (lookahead == 8594) ADVANCE(460);
      if (lookahead == 8704) ADVANCE(454);
      if (lookahead == 10627) ADVANCE(512);
      if (lookahead == 10631) ADVANCE(674);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(26)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (lookahead != 0 &&
          lookahead != '\'') ADVANCE(589);
      END_STATE();
    case 27:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '(') ADVANCE(497);
      if (lookahead == '-') ADVANCE(534);
      if (lookahead == '.') ADVANCE(657);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == ':') ADVANCE(470);
      if (lookahead == ';') ADVANCE(654);
      if (lookahead == '\\') ADVANCE(326);
      if (lookahead == '_') ADVANCE(518);
      if (lookahead == 'w') ADVANCE(553);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == 8230) ADVANCE(467);
      if (lookahead == 10627) ADVANCE(512);
      if (lookahead == 10631) ADVANCE(674);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(27)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (lookahead != 0 &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != '@' &&
          lookahead != '}') ADVANCE(589);
      END_STATE();
    case 28:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '(') ADVANCE(497);
      if (lookahead == '-') ADVANCE(534);
      if (lookahead == '.') ADVANCE(657);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == ';') ADVANCE(654);
      if (lookahead == '@') ADVANCE(665);
      if (lookahead == '\\') ADVANCE(462);
      if (lookahead == '_') ADVANCE(518);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == '}') ADVANCE(444);
      if (lookahead == 955) ADVANCE(464);
      if (lookahead == 8230) ADVANCE(467);
      if (lookahead == 8704) ADVANCE(454);
      if (lookahead == 10627) ADVANCE(512);
      if (lookahead == 10631) ADVANCE(674);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(28)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (lookahead != 0 &&
          (lookahead < '\'' || ')' < lookahead)) ADVANCE(589);
      END_STATE();
    case 29:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '(') ADVANCE(497);
      if (lookahead == '-') ADVANCE(534);
      if (lookahead == '.') ADVANCE(657);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == ';') ADVANCE(654);
      if (lookahead == '@') ADVANCE(665);
      if (lookahead == '\\') ADVANCE(462);
      if (lookahead == '_') ADVANCE(518);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == 955) ADVANCE(464);
      if (lookahead == 8230) ADVANCE(467);
      if (lookahead == 8704) ADVANCE(454);
      if (lookahead == 10627) ADVANCE(512);
      if (lookahead == 10628) ADVANCE(515);
      if (lookahead == 10631) ADVANCE(674);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(29)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (lookahead != 0 &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != '}') ADVANCE(589);
      END_STATE();
    case 30:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '(') ADVANCE(497);
      if (lookahead == '-') ADVANCE(534);
      if (lookahead == '.') ADVANCE(658);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == ':') ADVANCE(470);
      if (lookahead == ';') ADVANCE(506);
      if (lookahead == '=') ADVANCE(473);
      if (lookahead == '@') ADVANCE(665);
      if (lookahead == '\\') ADVANCE(462);
      if (lookahead == '_') ADVANCE(518);
      if (lookahead == 'i') ADVANCE(564);
      if (lookahead == 'm') ADVANCE(569);
      if (lookahead == 'r') ADVANCE(543);
      if (lookahead == 'w') ADVANCE(552);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == '|') ADVANCE(668);
      if (lookahead == 955) ADVANCE(464);
      if (lookahead == 8230) ADVANCE(467);
      if (lookahead == 8704) ADVANCE(454);
      if (lookahead == 10627) ADVANCE(512);
      if (lookahead == 10631) ADVANCE(674);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(30)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (lookahead != 0 &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != '}') ADVANCE(589);
      END_STATE();
    case 31:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '(') ADVANCE(497);
      if (lookahead == '-') ADVANCE(534);
      if (lookahead == '.') ADVANCE(658);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == ':') ADVANCE(470);
      if (lookahead == ';') ADVANCE(506);
      if (lookahead == '=') ADVANCE(473);
      if (lookahead == '@') ADVANCE(665);
      if (lookahead == '\\') ADVANCE(462);
      if (lookahead == '_') ADVANCE(518);
      if (lookahead == 'i') ADVANCE(564);
      if (lookahead == 'm') ADVANCE(569);
      if (lookahead == 'w') ADVANCE(552);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == '|') ADVANCE(668);
      if (lookahead == 955) ADVANCE(464);
      if (lookahead == 8230) ADVANCE(467);
      if (lookahead == 8704) ADVANCE(454);
      if (lookahead == 10627) ADVANCE(512);
      if (lookahead == 10631) ADVANCE(674);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(31)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (lookahead != 0 &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != '}') ADVANCE(589);
      END_STATE();
    case 32:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '(') ADVANCE(497);
      if (lookahead == '-') ADVANCE(534);
      if (lookahead == '.') ADVANCE(658);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == ':') ADVANCE(470);
      if (lookahead == ';') ADVANCE(506);
      if (lookahead == '=') ADVANCE(473);
      if (lookahead == '@') ADVANCE(665);
      if (lookahead == '\\') ADVANCE(462);
      if (lookahead == '_') ADVANCE(518);
      if (lookahead == 'i') ADVANCE(564);
      if (lookahead == 'm') ADVANCE(569);
      if (lookahead == 'w') ADVANCE(553);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == '|') ADVANCE(668);
      if (lookahead == 955) ADVANCE(464);
      if (lookahead == 8230) ADVANCE(467);
      if (lookahead == 8704) ADVANCE(454);
      if (lookahead == 10627) ADVANCE(512);
      if (lookahead == 10631) ADVANCE(674);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(32)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (lookahead != 0 &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != '}') ADVANCE(589);
      END_STATE();
    case 33:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '(') ADVANCE(497);
      if (lookahead == '-') ADVANCE(534);
      if (lookahead == '.') ADVANCE(658);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == ':') ADVANCE(470);
      if (lookahead == ';') ADVANCE(506);
      if (lookahead == '=') ADVANCE(473);
      if (lookahead == '@') ADVANCE(665);
      if (lookahead == '\\') ADVANCE(462);
      if (lookahead == '_') ADVANCE(518);
      if (lookahead == 'm') ADVANCE(569);
      if (lookahead == 'r') ADVANCE(543);
      if (lookahead == 'w') ADVANCE(552);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == '|') ADVANCE(668);
      if (lookahead == 955) ADVANCE(464);
      if (lookahead == 8230) ADVANCE(467);
      if (lookahead == 8704) ADVANCE(454);
      if (lookahead == 10627) ADVANCE(512);
      if (lookahead == 10631) ADVANCE(674);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(33)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (lookahead != 0 &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != '}') ADVANCE(589);
      END_STATE();
    case 34:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '(') ADVANCE(497);
      if (lookahead == '-') ADVANCE(534);
      if (lookahead == '.') ADVANCE(658);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == ':') ADVANCE(470);
      if (lookahead == ';') ADVANCE(506);
      if (lookahead == '=') ADVANCE(473);
      if (lookahead == '@') ADVANCE(665);
      if (lookahead == '\\') ADVANCE(462);
      if (lookahead == '_') ADVANCE(518);
      if (lookahead == 'm') ADVANCE(569);
      if (lookahead == 'w') ADVANCE(552);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == '|') ADVANCE(668);
      if (lookahead == 955) ADVANCE(464);
      if (lookahead == 8230) ADVANCE(467);
      if (lookahead == 8704) ADVANCE(454);
      if (lookahead == 10627) ADVANCE(512);
      if (lookahead == 10631) ADVANCE(674);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(34)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (lookahead != 0 &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != '}') ADVANCE(589);
      END_STATE();
    case 35:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '(') ADVANCE(497);
      if (lookahead == '-') ADVANCE(534);
      if (lookahead == '.') ADVANCE(658);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == ':') ADVANCE(470);
      if (lookahead == ';') ADVANCE(506);
      if (lookahead == '=') ADVANCE(473);
      if (lookahead == '@') ADVANCE(665);
      if (lookahead == '\\') ADVANCE(462);
      if (lookahead == '_') ADVANCE(518);
      if (lookahead == 'm') ADVANCE(569);
      if (lookahead == 'w') ADVANCE(553);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == '|') ADVANCE(668);
      if (lookahead == 955) ADVANCE(464);
      if (lookahead == 8230) ADVANCE(467);
      if (lookahead == 8704) ADVANCE(454);
      if (lookahead == 10627) ADVANCE(512);
      if (lookahead == 10631) ADVANCE(674);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(35)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (lookahead != 0 &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != '}') ADVANCE(589);
      END_STATE();
    case 36:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '(') ADVANCE(497);
      if (lookahead == '-') ADVANCE(534);
      if (lookahead == '.') ADVANCE(658);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == ':') ADVANCE(470);
      if (lookahead == ';') ADVANCE(506);
      if (lookahead == '=') ADVANCE(473);
      if (lookahead == '@') ADVANCE(665);
      if (lookahead == '\\') ADVANCE(462);
      if (lookahead == '_') ADVANCE(518);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == '|') ADVANCE(668);
      if (lookahead == '}') ADVANCE(527);
      if (lookahead == 955) ADVANCE(464);
      if (lookahead == 8230) ADVANCE(467);
      if (lookahead == 8704) ADVANCE(454);
      if (lookahead == 10627) ADVANCE(512);
      if (lookahead == 10631) ADVANCE(674);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(36)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (lookahead != 0 &&
          (lookahead < '\'' || ')' < lookahead)) ADVANCE(589);
      END_STATE();
    case 37:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '(') ADVANCE(497);
      if (lookahead == '-') ADVANCE(534);
      if (lookahead == '.') ADVANCE(658);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == ':') ADVANCE(470);
      if (lookahead == ';') ADVANCE(506);
      if (lookahead == '=') ADVANCE(473);
      if (lookahead == '@') ADVANCE(665);
      if (lookahead == '\\') ADVANCE(462);
      if (lookahead == '_') ADVANCE(518);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == '|') ADVANCE(668);
      if (lookahead == 955) ADVANCE(464);
      if (lookahead == 8230) ADVANCE(467);
      if (lookahead == 8704) ADVANCE(454);
      if (lookahead == 10627) ADVANCE(512);
      if (lookahead == 10628) ADVANCE(515);
      if (lookahead == 10631) ADVANCE(674);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(37)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (lookahead != 0 &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != '}') ADVANCE(589);
      END_STATE();
    case 38:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '(') ADVANCE(497);
      if (lookahead == '-') ADVANCE(534);
      if (lookahead == '.') ADVANCE(658);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == ':') ADVANCE(470);
      if (lookahead == ';') ADVANCE(506);
      if (lookahead == '=') ADVANCE(473);
      if (lookahead == '@') ADVANCE(665);
      if (lookahead == '\\') ADVANCE(301);
      if (lookahead == '_') ADVANCE(518);
      if (lookahead == 'i') ADVANCE(564);
      if (lookahead == 'm') ADVANCE(569);
      if (lookahead == 'r') ADVANCE(543);
      if (lookahead == 'w') ADVANCE(552);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == '|') ADVANCE(668);
      if (lookahead == 8230) ADVANCE(467);
      if (lookahead == 10627) ADVANCE(512);
      if (lookahead == 10631) ADVANCE(674);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(38)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (lookahead != 0 &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != '}') ADVANCE(589);
      END_STATE();
    case 39:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '(') ADVANCE(497);
      if (lookahead == '-') ADVANCE(534);
      if (lookahead == '.') ADVANCE(658);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == ':') ADVANCE(470);
      if (lookahead == ';') ADVANCE(506);
      if (lookahead == '=') ADVANCE(473);
      if (lookahead == '@') ADVANCE(665);
      if (lookahead == '\\') ADVANCE(302);
      if (lookahead == '_') ADVANCE(518);
      if (lookahead == 'i') ADVANCE(564);
      if (lookahead == 'm') ADVANCE(569);
      if (lookahead == 'w') ADVANCE(552);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == '|') ADVANCE(668);
      if (lookahead == 8230) ADVANCE(467);
      if (lookahead == 10627) ADVANCE(512);
      if (lookahead == 10631) ADVANCE(674);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(39)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (lookahead != 0 &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != '}') ADVANCE(589);
      END_STATE();
    case 40:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '(') ADVANCE(497);
      if (lookahead == '-') ADVANCE(534);
      if (lookahead == '.') ADVANCE(658);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == ':') ADVANCE(470);
      if (lookahead == ';') ADVANCE(506);
      if (lookahead == '=') ADVANCE(473);
      if (lookahead == '@') ADVANCE(665);
      if (lookahead == '\\') ADVANCE(303);
      if (lookahead == '_') ADVANCE(518);
      if (lookahead == 'm') ADVANCE(569);
      if (lookahead == 'r') ADVANCE(543);
      if (lookahead == 'w') ADVANCE(552);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == '|') ADVANCE(668);
      if (lookahead == 8230) ADVANCE(467);
      if (lookahead == 10627) ADVANCE(512);
      if (lookahead == 10631) ADVANCE(674);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(40)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (lookahead != 0 &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != '}') ADVANCE(589);
      END_STATE();
    case 41:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '(') ADVANCE(497);
      if (lookahead == '-') ADVANCE(534);
      if (lookahead == '.') ADVANCE(658);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == ':') ADVANCE(470);
      if (lookahead == ';') ADVANCE(506);
      if (lookahead == '=') ADVANCE(473);
      if (lookahead == '@') ADVANCE(665);
      if (lookahead == '\\') ADVANCE(306);
      if (lookahead == '_') ADVANCE(518);
      if (lookahead == 'm') ADVANCE(569);
      if (lookahead == 'w') ADVANCE(552);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == '|') ADVANCE(668);
      if (lookahead == 8230) ADVANCE(467);
      if (lookahead == 10627) ADVANCE(512);
      if (lookahead == 10631) ADVANCE(674);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(41)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (lookahead != 0 &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != '}') ADVANCE(589);
      END_STATE();
    case 42:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '(') ADVANCE(497);
      if (lookahead == '-') ADVANCE(534);
      if (lookahead == '.') ADVANCE(658);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == ':') ADVANCE(470);
      if (lookahead == ';') ADVANCE(506);
      if (lookahead == '=') ADVANCE(473);
      if (lookahead == '@') ADVANCE(665);
      if (lookahead == '\\') ADVANCE(419);
      if (lookahead == '_') ADVANCE(518);
      if (lookahead == 'i') ADVANCE(564);
      if (lookahead == 'm') ADVANCE(569);
      if (lookahead == 'w') ADVANCE(553);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == '|') ADVANCE(668);
      if (lookahead == 8230) ADVANCE(467);
      if (lookahead == 10627) ADVANCE(512);
      if (lookahead == 10631) ADVANCE(674);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(42)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (lookahead != 0 &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != '}') ADVANCE(589);
      END_STATE();
    case 43:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '(') ADVANCE(497);
      if (lookahead == '-') ADVANCE(534);
      if (lookahead == '.') ADVANCE(658);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == ':') ADVANCE(470);
      if (lookahead == ';') ADVANCE(506);
      if (lookahead == '=') ADVANCE(473);
      if (lookahead == '@') ADVANCE(665);
      if (lookahead == '\\') ADVANCE(420);
      if (lookahead == '_') ADVANCE(518);
      if (lookahead == 'm') ADVANCE(569);
      if (lookahead == 'w') ADVANCE(553);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == '|') ADVANCE(668);
      if (lookahead == 8230) ADVANCE(467);
      if (lookahead == 10627) ADVANCE(512);
      if (lookahead == 10631) ADVANCE(674);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(43)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (lookahead != 0 &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != '}') ADVANCE(589);
      END_STATE();
    case 44:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '(') ADVANCE(497);
      if (lookahead == '-') ADVANCE(534);
      if (lookahead == '.') ADVANCE(658);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == ':') ADVANCE(470);
      if (lookahead == ';') ADVANCE(506);
      if (lookahead == '=') ADVANCE(473);
      if (lookahead == '@') ADVANCE(665);
      if (lookahead == '\\') ADVANCE(312);
      if (lookahead == '_') ADVANCE(518);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == '|') ADVANCE(668);
      if (lookahead == 8230) ADVANCE(467);
      if (lookahead == 10627) ADVANCE(512);
      if (lookahead == 10628) ADVANCE(515);
      if (lookahead == 10631) ADVANCE(674);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(44)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (lookahead != 0 &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != '}') ADVANCE(589);
      END_STATE();
    case 45:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '(') ADVANCE(497);
      if (lookahead == '-') ADVANCE(534);
      if (lookahead == '.') ADVANCE(658);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == ':') ADVANCE(470);
      if (lookahead == ';') ADVANCE(506);
      if (lookahead == '=') ADVANCE(473);
      if (lookahead == '@') ADVANCE(665);
      if (lookahead == '\\') ADVANCE(316);
      if (lookahead == '_') ADVANCE(518);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == '|') ADVANCE(668);
      if (lookahead == '}') ADVANCE(527);
      if (lookahead == 8230) ADVANCE(467);
      if (lookahead == 10627) ADVANCE(512);
      if (lookahead == 10631) ADVANCE(674);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(45)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (lookahead != 0 &&
          (lookahead < '\'' || ')' < lookahead)) ADVANCE(589);
      END_STATE();
    case 46:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '(') ADVANCE(497);
      if (lookahead == '-') ADVANCE(534);
      if (lookahead == '.') ADVANCE(658);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == ':') ADVANCE(470);
      if (lookahead == ';') ADVANCE(506);
      if (lookahead == '@') ADVANCE(665);
      if (lookahead == '\\') ADVANCE(462);
      if (lookahead == '_') ADVANCE(518);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == '|') ADVANCE(668);
      if (lookahead == '}') ADVANCE(444);
      if (lookahead == 955) ADVANCE(464);
      if (lookahead == 8230) ADVANCE(467);
      if (lookahead == 8704) ADVANCE(454);
      if (lookahead == 10627) ADVANCE(512);
      if (lookahead == 10631) ADVANCE(674);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(46)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (lookahead != 0 &&
          (lookahead < '\'' || ')' < lookahead)) ADVANCE(589);
      END_STATE();
    case 47:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '(') ADVANCE(497);
      if (lookahead == '-') ADVANCE(534);
      if (lookahead == '.') ADVANCE(658);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == ':') ADVANCE(470);
      if (lookahead == ';') ADVANCE(506);
      if (lookahead == '@') ADVANCE(665);
      if (lookahead == '\\') ADVANCE(462);
      if (lookahead == '_') ADVANCE(518);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == '|') ADVANCE(668);
      if (lookahead == 955) ADVANCE(464);
      if (lookahead == 8230) ADVANCE(467);
      if (lookahead == 8704) ADVANCE(454);
      if (lookahead == 10627) ADVANCE(512);
      if (lookahead == 10628) ADVANCE(515);
      if (lookahead == 10631) ADVANCE(674);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(47)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (lookahead != 0 &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != '}') ADVANCE(589);
      END_STATE();
    case 48:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '(') ADVANCE(497);
      if (lookahead == '-') ADVANCE(534);
      if (lookahead == '.') ADVANCE(658);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == ':') ADVANCE(470);
      if (lookahead == ';') ADVANCE(506);
      if (lookahead == '@') ADVANCE(665);
      if (lookahead == '\\') ADVANCE(318);
      if (lookahead == '_') ADVANCE(518);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == '|') ADVANCE(668);
      if (lookahead == '}') ADVANCE(444);
      if (lookahead == 8230) ADVANCE(467);
      if (lookahead == 10627) ADVANCE(512);
      if (lookahead == 10631) ADVANCE(674);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(48)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (lookahead != 0 &&
          (lookahead < '\'' || ')' < lookahead)) ADVANCE(589);
      END_STATE();
    case 49:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '(') ADVANCE(497);
      if (lookahead == '-') ADVANCE(534);
      if (lookahead == '.') ADVANCE(658);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == ':') ADVANCE(470);
      if (lookahead == ';') ADVANCE(506);
      if (lookahead == '@') ADVANCE(665);
      if (lookahead == '\\') ADVANCE(323);
      if (lookahead == '_') ADVANCE(518);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == '|') ADVANCE(668);
      if (lookahead == 8230) ADVANCE(467);
      if (lookahead == 10627) ADVANCE(512);
      if (lookahead == 10628) ADVANCE(515);
      if (lookahead == 10631) ADVANCE(674);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(49)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (lookahead != 0 &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != '}') ADVANCE(589);
      END_STATE();
    case 50:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '(') ADVANCE(497);
      if (lookahead == '-') ADVANCE(534);
      if (lookahead == '.') ADVANCE(658);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == ':') ADVANCE(470);
      if (lookahead == ';') ADVANCE(654);
      if (lookahead == '=') ADVANCE(473);
      if (lookahead == '@') ADVANCE(665);
      if (lookahead == '\\') ADVANCE(462);
      if (lookahead == '_') ADVANCE(518);
      if (lookahead == 'i') ADVANCE(564);
      if (lookahead == 'm') ADVANCE(569);
      if (lookahead == 'r') ADVANCE(543);
      if (lookahead == 'w') ADVANCE(552);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == '|') ADVANCE(668);
      if (lookahead == 955) ADVANCE(464);
      if (lookahead == 8230) ADVANCE(467);
      if (lookahead == 8704) ADVANCE(454);
      if (lookahead == 10627) ADVANCE(512);
      if (lookahead == 10631) ADVANCE(674);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(50)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (lookahead != 0 &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != '}') ADVANCE(589);
      END_STATE();
    case 51:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '(') ADVANCE(497);
      if (lookahead == '-') ADVANCE(534);
      if (lookahead == '.') ADVANCE(658);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == ':') ADVANCE(470);
      if (lookahead == ';') ADVANCE(654);
      if (lookahead == '=') ADVANCE(473);
      if (lookahead == '@') ADVANCE(665);
      if (lookahead == '\\') ADVANCE(462);
      if (lookahead == '_') ADVANCE(518);
      if (lookahead == 'i') ADVANCE(564);
      if (lookahead == 'm') ADVANCE(569);
      if (lookahead == 'w') ADVANCE(552);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == '|') ADVANCE(668);
      if (lookahead == 955) ADVANCE(464);
      if (lookahead == 8230) ADVANCE(467);
      if (lookahead == 8704) ADVANCE(454);
      if (lookahead == 10627) ADVANCE(512);
      if (lookahead == 10631) ADVANCE(674);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(51)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (lookahead != 0 &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != '}') ADVANCE(589);
      END_STATE();
    case 52:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '(') ADVANCE(497);
      if (lookahead == '-') ADVANCE(534);
      if (lookahead == '.') ADVANCE(658);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == ':') ADVANCE(470);
      if (lookahead == ';') ADVANCE(654);
      if (lookahead == '=') ADVANCE(473);
      if (lookahead == '@') ADVANCE(665);
      if (lookahead == '\\') ADVANCE(462);
      if (lookahead == '_') ADVANCE(518);
      if (lookahead == 'i') ADVANCE(564);
      if (lookahead == 'm') ADVANCE(569);
      if (lookahead == 'w') ADVANCE(553);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == '|') ADVANCE(668);
      if (lookahead == 955) ADVANCE(464);
      if (lookahead == 8230) ADVANCE(467);
      if (lookahead == 8704) ADVANCE(454);
      if (lookahead == 10627) ADVANCE(512);
      if (lookahead == 10631) ADVANCE(674);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(52)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (lookahead != 0 &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != '}') ADVANCE(589);
      END_STATE();
    case 53:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '(') ADVANCE(497);
      if (lookahead == '-') ADVANCE(534);
      if (lookahead == '.') ADVANCE(658);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == ':') ADVANCE(470);
      if (lookahead == ';') ADVANCE(654);
      if (lookahead == '=') ADVANCE(473);
      if (lookahead == '@') ADVANCE(665);
      if (lookahead == '\\') ADVANCE(462);
      if (lookahead == '_') ADVANCE(518);
      if (lookahead == 'm') ADVANCE(569);
      if (lookahead == 'r') ADVANCE(543);
      if (lookahead == 'w') ADVANCE(552);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == '|') ADVANCE(668);
      if (lookahead == 955) ADVANCE(464);
      if (lookahead == 8230) ADVANCE(467);
      if (lookahead == 8704) ADVANCE(454);
      if (lookahead == 10627) ADVANCE(512);
      if (lookahead == 10631) ADVANCE(674);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(53)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (lookahead != 0 &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != '}') ADVANCE(589);
      END_STATE();
    case 54:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '(') ADVANCE(497);
      if (lookahead == '-') ADVANCE(534);
      if (lookahead == '.') ADVANCE(658);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == ':') ADVANCE(470);
      if (lookahead == ';') ADVANCE(654);
      if (lookahead == '=') ADVANCE(473);
      if (lookahead == '@') ADVANCE(665);
      if (lookahead == '\\') ADVANCE(462);
      if (lookahead == '_') ADVANCE(518);
      if (lookahead == 'm') ADVANCE(569);
      if (lookahead == 'w') ADVANCE(552);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == '|') ADVANCE(668);
      if (lookahead == 955) ADVANCE(464);
      if (lookahead == 8230) ADVANCE(467);
      if (lookahead == 8704) ADVANCE(454);
      if (lookahead == 10627) ADVANCE(512);
      if (lookahead == 10631) ADVANCE(674);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(54)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (lookahead != 0 &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != '}') ADVANCE(589);
      END_STATE();
    case 55:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '(') ADVANCE(497);
      if (lookahead == '-') ADVANCE(534);
      if (lookahead == '.') ADVANCE(658);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == ':') ADVANCE(470);
      if (lookahead == ';') ADVANCE(654);
      if (lookahead == '=') ADVANCE(473);
      if (lookahead == '@') ADVANCE(665);
      if (lookahead == '\\') ADVANCE(462);
      if (lookahead == '_') ADVANCE(518);
      if (lookahead == 'm') ADVANCE(569);
      if (lookahead == 'w') ADVANCE(553);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == '|') ADVANCE(668);
      if (lookahead == 955) ADVANCE(464);
      if (lookahead == 8230) ADVANCE(467);
      if (lookahead == 8704) ADVANCE(454);
      if (lookahead == 10627) ADVANCE(512);
      if (lookahead == 10631) ADVANCE(674);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(55)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (lookahead != 0 &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != '}') ADVANCE(589);
      END_STATE();
    case 56:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '(') ADVANCE(497);
      if (lookahead == '-') ADVANCE(534);
      if (lookahead == '.') ADVANCE(658);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == ':') ADVANCE(470);
      if (lookahead == ';') ADVANCE(654);
      if (lookahead == '=') ADVANCE(473);
      if (lookahead == '@') ADVANCE(665);
      if (lookahead == '\\') ADVANCE(462);
      if (lookahead == '_') ADVANCE(518);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == '|') ADVANCE(668);
      if (lookahead == '}') ADVANCE(527);
      if (lookahead == 955) ADVANCE(464);
      if (lookahead == 8230) ADVANCE(467);
      if (lookahead == 8704) ADVANCE(454);
      if (lookahead == 10627) ADVANCE(512);
      if (lookahead == 10631) ADVANCE(674);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(56)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (lookahead != 0 &&
          (lookahead < '\'' || ')' < lookahead)) ADVANCE(589);
      END_STATE();
    case 57:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '(') ADVANCE(497);
      if (lookahead == '-') ADVANCE(534);
      if (lookahead == '.') ADVANCE(658);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == ':') ADVANCE(470);
      if (lookahead == ';') ADVANCE(654);
      if (lookahead == '=') ADVANCE(473);
      if (lookahead == '@') ADVANCE(665);
      if (lookahead == '\\') ADVANCE(462);
      if (lookahead == '_') ADVANCE(518);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == '|') ADVANCE(668);
      if (lookahead == 955) ADVANCE(464);
      if (lookahead == 8230) ADVANCE(467);
      if (lookahead == 8704) ADVANCE(454);
      if (lookahead == 10627) ADVANCE(512);
      if (lookahead == 10628) ADVANCE(515);
      if (lookahead == 10631) ADVANCE(674);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(57)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (lookahead != 0 &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != '}') ADVANCE(589);
      END_STATE();
    case 58:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '(') ADVANCE(497);
      if (lookahead == '-') ADVANCE(534);
      if (lookahead == '.') ADVANCE(658);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == ':') ADVANCE(470);
      if (lookahead == ';') ADVANCE(654);
      if (lookahead == '=') ADVANCE(473);
      if (lookahead == '@') ADVANCE(665);
      if (lookahead == '\\') ADVANCE(462);
      if (lookahead == '_') ADVANCE(518);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == '}') ADVANCE(527);
      if (lookahead == 955) ADVANCE(464);
      if (lookahead == 8230) ADVANCE(467);
      if (lookahead == 8704) ADVANCE(454);
      if (lookahead == 10627) ADVANCE(512);
      if (lookahead == 10631) ADVANCE(674);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(58)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (lookahead != 0 &&
          (lookahead < '\'' || ')' < lookahead)) ADVANCE(589);
      END_STATE();
    case 59:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '(') ADVANCE(497);
      if (lookahead == '-') ADVANCE(534);
      if (lookahead == '.') ADVANCE(658);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == ':') ADVANCE(470);
      if (lookahead == ';') ADVANCE(654);
      if (lookahead == '=') ADVANCE(473);
      if (lookahead == '@') ADVANCE(665);
      if (lookahead == '\\') ADVANCE(462);
      if (lookahead == '_') ADVANCE(518);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == 955) ADVANCE(464);
      if (lookahead == 8230) ADVANCE(467);
      if (lookahead == 8704) ADVANCE(454);
      if (lookahead == 10627) ADVANCE(512);
      if (lookahead == 10628) ADVANCE(515);
      if (lookahead == 10631) ADVANCE(674);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(59)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (lookahead != 0 &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != '}') ADVANCE(589);
      END_STATE();
    case 60:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '(') ADVANCE(497);
      if (lookahead == '-') ADVANCE(534);
      if (lookahead == '.') ADVANCE(658);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == ':') ADVANCE(470);
      if (lookahead == ';') ADVANCE(654);
      if (lookahead == '=') ADVANCE(473);
      if (lookahead == '@') ADVANCE(665);
      if (lookahead == '\\') ADVANCE(392);
      if (lookahead == '_') ADVANCE(518);
      if (lookahead == 'i') ADVANCE(564);
      if (lookahead == 'm') ADVANCE(569);
      if (lookahead == 'r') ADVANCE(543);
      if (lookahead == 'w') ADVANCE(552);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == '|') ADVANCE(668);
      if (lookahead == 8230) ADVANCE(467);
      if (lookahead == 10627) ADVANCE(512);
      if (lookahead == 10631) ADVANCE(674);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(60)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (lookahead != 0 &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != '}') ADVANCE(589);
      END_STATE();
    case 61:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '(') ADVANCE(497);
      if (lookahead == '-') ADVANCE(534);
      if (lookahead == '.') ADVANCE(658);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == ':') ADVANCE(470);
      if (lookahead == ';') ADVANCE(654);
      if (lookahead == '=') ADVANCE(473);
      if (lookahead == '@') ADVANCE(665);
      if (lookahead == '\\') ADVANCE(393);
      if (lookahead == '_') ADVANCE(518);
      if (lookahead == 'i') ADVANCE(564);
      if (lookahead == 'm') ADVANCE(569);
      if (lookahead == 'w') ADVANCE(552);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == '|') ADVANCE(668);
      if (lookahead == 8230) ADVANCE(467);
      if (lookahead == 10627) ADVANCE(512);
      if (lookahead == 10631) ADVANCE(674);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(61)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (lookahead != 0 &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != '}') ADVANCE(589);
      END_STATE();
    case 62:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '(') ADVANCE(497);
      if (lookahead == '-') ADVANCE(534);
      if (lookahead == '.') ADVANCE(658);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == ':') ADVANCE(470);
      if (lookahead == ';') ADVANCE(654);
      if (lookahead == '=') ADVANCE(473);
      if (lookahead == '@') ADVANCE(665);
      if (lookahead == '\\') ADVANCE(394);
      if (lookahead == '_') ADVANCE(518);
      if (lookahead == 'm') ADVANCE(569);
      if (lookahead == 'r') ADVANCE(543);
      if (lookahead == 'w') ADVANCE(552);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == '|') ADVANCE(668);
      if (lookahead == 8230) ADVANCE(467);
      if (lookahead == 10627) ADVANCE(512);
      if (lookahead == 10631) ADVANCE(674);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(62)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (lookahead != 0 &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != '}') ADVANCE(589);
      END_STATE();
    case 63:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '(') ADVANCE(497);
      if (lookahead == '-') ADVANCE(534);
      if (lookahead == '.') ADVANCE(658);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == ':') ADVANCE(470);
      if (lookahead == ';') ADVANCE(654);
      if (lookahead == '=') ADVANCE(473);
      if (lookahead == '@') ADVANCE(665);
      if (lookahead == '\\') ADVANCE(395);
      if (lookahead == '_') ADVANCE(518);
      if (lookahead == 'm') ADVANCE(569);
      if (lookahead == 'w') ADVANCE(552);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == '|') ADVANCE(668);
      if (lookahead == 8230) ADVANCE(467);
      if (lookahead == 10627) ADVANCE(512);
      if (lookahead == 10631) ADVANCE(674);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(63)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (lookahead != 0 &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != '}') ADVANCE(589);
      END_STATE();
    case 64:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '(') ADVANCE(497);
      if (lookahead == '-') ADVANCE(534);
      if (lookahead == '.') ADVANCE(658);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == ':') ADVANCE(470);
      if (lookahead == ';') ADVANCE(654);
      if (lookahead == '=') ADVANCE(473);
      if (lookahead == '@') ADVANCE(665);
      if (lookahead == '\\') ADVANCE(422);
      if (lookahead == '_') ADVANCE(518);
      if (lookahead == 'i') ADVANCE(564);
      if (lookahead == 'm') ADVANCE(569);
      if (lookahead == 'w') ADVANCE(553);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == '|') ADVANCE(668);
      if (lookahead == 8230) ADVANCE(467);
      if (lookahead == 10627) ADVANCE(512);
      if (lookahead == 10631) ADVANCE(674);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(64)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (lookahead != 0 &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != '}') ADVANCE(589);
      END_STATE();
    case 65:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '(') ADVANCE(497);
      if (lookahead == '-') ADVANCE(534);
      if (lookahead == '.') ADVANCE(658);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == ':') ADVANCE(470);
      if (lookahead == ';') ADVANCE(654);
      if (lookahead == '=') ADVANCE(473);
      if (lookahead == '@') ADVANCE(665);
      if (lookahead == '\\') ADVANCE(423);
      if (lookahead == '_') ADVANCE(518);
      if (lookahead == 'm') ADVANCE(569);
      if (lookahead == 'w') ADVANCE(553);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == '|') ADVANCE(668);
      if (lookahead == 8230) ADVANCE(467);
      if (lookahead == 10627) ADVANCE(512);
      if (lookahead == 10631) ADVANCE(674);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(65)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (lookahead != 0 &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != '}') ADVANCE(589);
      END_STATE();
    case 66:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '(') ADVANCE(497);
      if (lookahead == '-') ADVANCE(534);
      if (lookahead == '.') ADVANCE(658);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == ':') ADVANCE(470);
      if (lookahead == ';') ADVANCE(654);
      if (lookahead == '=') ADVANCE(473);
      if (lookahead == '@') ADVANCE(665);
      if (lookahead == '\\') ADVANCE(404);
      if (lookahead == '_') ADVANCE(518);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == '|') ADVANCE(668);
      if (lookahead == '}') ADVANCE(527);
      if (lookahead == 8230) ADVANCE(467);
      if (lookahead == 10627) ADVANCE(512);
      if (lookahead == 10631) ADVANCE(674);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(66)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (lookahead != 0 &&
          (lookahead < '\'' || ')' < lookahead)) ADVANCE(589);
      END_STATE();
    case 67:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '(') ADVANCE(497);
      if (lookahead == '-') ADVANCE(534);
      if (lookahead == '.') ADVANCE(658);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == ':') ADVANCE(470);
      if (lookahead == ';') ADVANCE(654);
      if (lookahead == '=') ADVANCE(473);
      if (lookahead == '@') ADVANCE(665);
      if (lookahead == '\\') ADVANCE(400);
      if (lookahead == '_') ADVANCE(518);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == '|') ADVANCE(668);
      if (lookahead == 8230) ADVANCE(467);
      if (lookahead == 10627) ADVANCE(512);
      if (lookahead == 10628) ADVANCE(515);
      if (lookahead == 10631) ADVANCE(674);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(67)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (lookahead != 0 &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != '}') ADVANCE(589);
      END_STATE();
    case 68:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '(') ADVANCE(497);
      if (lookahead == '-') ADVANCE(534);
      if (lookahead == '.') ADVANCE(658);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == ':') ADVANCE(470);
      if (lookahead == ';') ADVANCE(654);
      if (lookahead == '@') ADVANCE(665);
      if (lookahead == '\\') ADVANCE(462);
      if (lookahead == '_') ADVANCE(518);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == '|') ADVANCE(668);
      if (lookahead == '}') ADVANCE(527);
      if (lookahead == 955) ADVANCE(464);
      if (lookahead == 8230) ADVANCE(467);
      if (lookahead == 8704) ADVANCE(454);
      if (lookahead == 10627) ADVANCE(512);
      if (lookahead == 10631) ADVANCE(674);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(68)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (lookahead != 0 &&
          (lookahead < '\'' || ')' < lookahead)) ADVANCE(589);
      END_STATE();
    case 69:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '(') ADVANCE(497);
      if (lookahead == '-') ADVANCE(534);
      if (lookahead == '.') ADVANCE(658);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == ':') ADVANCE(470);
      if (lookahead == ';') ADVANCE(654);
      if (lookahead == '@') ADVANCE(665);
      if (lookahead == '\\') ADVANCE(462);
      if (lookahead == '_') ADVANCE(518);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == '|') ADVANCE(668);
      if (lookahead == 955) ADVANCE(464);
      if (lookahead == 8230) ADVANCE(467);
      if (lookahead == 8704) ADVANCE(454);
      if (lookahead == 10627) ADVANCE(512);
      if (lookahead == 10628) ADVANCE(515);
      if (lookahead == 10631) ADVANCE(674);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(69)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (lookahead != 0 &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != '}') ADVANCE(589);
      END_STATE();
    case 70:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '(') ADVANCE(497);
      if (lookahead == '-') ADVANCE(534);
      if (lookahead == '.') ADVANCE(658);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == ':') ADVANCE(470);
      if (lookahead == ';') ADVANCE(654);
      if (lookahead == '@') ADVANCE(665);
      if (lookahead == '\\') ADVANCE(462);
      if (lookahead == '_') ADVANCE(518);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == '}') ADVANCE(527);
      if (lookahead == 955) ADVANCE(464);
      if (lookahead == 8230) ADVANCE(467);
      if (lookahead == 8704) ADVANCE(454);
      if (lookahead == 10627) ADVANCE(512);
      if (lookahead == 10631) ADVANCE(674);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(70)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (lookahead != 0 &&
          (lookahead < '\'' || ')' < lookahead)) ADVANCE(589);
      END_STATE();
    case 71:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '(') ADVANCE(497);
      if (lookahead == '-') ADVANCE(534);
      if (lookahead == '.') ADVANCE(658);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == ':') ADVANCE(470);
      if (lookahead == ';') ADVANCE(654);
      if (lookahead == '@') ADVANCE(665);
      if (lookahead == '\\') ADVANCE(462);
      if (lookahead == '_') ADVANCE(518);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == 955) ADVANCE(464);
      if (lookahead == 8230) ADVANCE(467);
      if (lookahead == 8704) ADVANCE(454);
      if (lookahead == 10627) ADVANCE(512);
      if (lookahead == 10628) ADVANCE(515);
      if (lookahead == 10631) ADVANCE(674);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(71)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (lookahead != 0 &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != '}') ADVANCE(589);
      END_STATE();
    case 72:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '(') ADVANCE(497);
      if (lookahead == '-') ADVANCE(534);
      if (lookahead == '.') ADVANCE(658);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == ':') ADVANCE(470);
      if (lookahead == ';') ADVANCE(654);
      if (lookahead == '@') ADVANCE(665);
      if (lookahead == '\\') ADVANCE(406);
      if (lookahead == '_') ADVANCE(518);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == '|') ADVANCE(668);
      if (lookahead == '}') ADVANCE(527);
      if (lookahead == 8230) ADVANCE(467);
      if (lookahead == 10627) ADVANCE(512);
      if (lookahead == 10631) ADVANCE(674);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(72)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (lookahead != 0 &&
          (lookahead < '\'' || ')' < lookahead)) ADVANCE(589);
      END_STATE();
    case 73:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '(') ADVANCE(497);
      if (lookahead == '-') ADVANCE(534);
      if (lookahead == '.') ADVANCE(658);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == ':') ADVANCE(470);
      if (lookahead == ';') ADVANCE(654);
      if (lookahead == '@') ADVANCE(665);
      if (lookahead == '\\') ADVANCE(411);
      if (lookahead == '_') ADVANCE(518);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == '|') ADVANCE(668);
      if (lookahead == 8230) ADVANCE(467);
      if (lookahead == 10627) ADVANCE(512);
      if (lookahead == 10628) ADVANCE(515);
      if (lookahead == 10631) ADVANCE(674);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(73)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (lookahead != 0 &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != '}') ADVANCE(589);
      END_STATE();
    case 74:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '(') ADVANCE(497);
      if (lookahead == '-') ADVANCE(534);
      if (lookahead == '.') ADVANCE(658);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == ';') ADVANCE(506);
      if (lookahead == '=') ADVANCE(473);
      if (lookahead == '@') ADVANCE(665);
      if (lookahead == '\\') ADVANCE(462);
      if (lookahead == '_') ADVANCE(518);
      if (lookahead == 'i') ADVANCE(564);
      if (lookahead == 'm') ADVANCE(569);
      if (lookahead == 'w') ADVANCE(553);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == '|') ADVANCE(668);
      if (lookahead == 955) ADVANCE(464);
      if (lookahead == 8230) ADVANCE(467);
      if (lookahead == 8704) ADVANCE(454);
      if (lookahead == 10627) ADVANCE(512);
      if (lookahead == 10631) ADVANCE(674);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(74)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (lookahead != 0 &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != '}') ADVANCE(589);
      END_STATE();
    case 75:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '(') ADVANCE(497);
      if (lookahead == '-') ADVANCE(534);
      if (lookahead == '.') ADVANCE(658);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == ';') ADVANCE(506);
      if (lookahead == '=') ADVANCE(473);
      if (lookahead == '@') ADVANCE(665);
      if (lookahead == '\\') ADVANCE(462);
      if (lookahead == '_') ADVANCE(518);
      if (lookahead == 'i') ADVANCE(564);
      if (lookahead == 'w') ADVANCE(553);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == '|') ADVANCE(668);
      if (lookahead == 955) ADVANCE(464);
      if (lookahead == 8230) ADVANCE(467);
      if (lookahead == 8704) ADVANCE(454);
      if (lookahead == 10627) ADVANCE(512);
      if (lookahead == 10631) ADVANCE(674);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(75)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (lookahead != 0 &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != '}') ADVANCE(589);
      END_STATE();
    case 76:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '(') ADVANCE(497);
      if (lookahead == '-') ADVANCE(534);
      if (lookahead == '.') ADVANCE(658);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == ';') ADVANCE(506);
      if (lookahead == '=') ADVANCE(473);
      if (lookahead == '@') ADVANCE(665);
      if (lookahead == '\\') ADVANCE(462);
      if (lookahead == '_') ADVANCE(518);
      if (lookahead == 'i') ADVANCE(564);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == '|') ADVANCE(668);
      if (lookahead == 955) ADVANCE(464);
      if (lookahead == 8230) ADVANCE(467);
      if (lookahead == 8704) ADVANCE(454);
      if (lookahead == 10627) ADVANCE(512);
      if (lookahead == 10631) ADVANCE(674);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(76)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (lookahead != 0 &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != '}') ADVANCE(589);
      END_STATE();
    case 77:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '(') ADVANCE(497);
      if (lookahead == '-') ADVANCE(534);
      if (lookahead == '.') ADVANCE(658);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == ';') ADVANCE(506);
      if (lookahead == '=') ADVANCE(473);
      if (lookahead == '@') ADVANCE(665);
      if (lookahead == '\\') ADVANCE(462);
      if (lookahead == '_') ADVANCE(518);
      if (lookahead == 'm') ADVANCE(569);
      if (lookahead == 'w') ADVANCE(553);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == '|') ADVANCE(668);
      if (lookahead == 955) ADVANCE(464);
      if (lookahead == 8230) ADVANCE(467);
      if (lookahead == 8704) ADVANCE(454);
      if (lookahead == 10627) ADVANCE(512);
      if (lookahead == 10631) ADVANCE(674);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(77)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (lookahead != 0 &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != '}') ADVANCE(589);
      END_STATE();
    case 78:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '(') ADVANCE(497);
      if (lookahead == '-') ADVANCE(534);
      if (lookahead == '.') ADVANCE(658);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == ';') ADVANCE(506);
      if (lookahead == '=') ADVANCE(473);
      if (lookahead == '@') ADVANCE(665);
      if (lookahead == '\\') ADVANCE(462);
      if (lookahead == '_') ADVANCE(518);
      if (lookahead == 'w') ADVANCE(553);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == '|') ADVANCE(668);
      if (lookahead == 955) ADVANCE(464);
      if (lookahead == 8230) ADVANCE(467);
      if (lookahead == 8704) ADVANCE(454);
      if (lookahead == 10627) ADVANCE(512);
      if (lookahead == 10631) ADVANCE(674);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(78)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (lookahead != 0 &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != '}') ADVANCE(589);
      END_STATE();
    case 79:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '(') ADVANCE(497);
      if (lookahead == '-') ADVANCE(534);
      if (lookahead == '.') ADVANCE(658);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == ';') ADVANCE(506);
      if (lookahead == '=') ADVANCE(473);
      if (lookahead == '@') ADVANCE(665);
      if (lookahead == '\\') ADVANCE(462);
      if (lookahead == '_') ADVANCE(518);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == '|') ADVANCE(668);
      if (lookahead == '}') ADVANCE(444);
      if (lookahead == 955) ADVANCE(464);
      if (lookahead == 8230) ADVANCE(467);
      if (lookahead == 8704) ADVANCE(454);
      if (lookahead == 10627) ADVANCE(512);
      if (lookahead == 10631) ADVANCE(674);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(79)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (lookahead != 0 &&
          (lookahead < '\'' || ')' < lookahead)) ADVANCE(589);
      END_STATE();
    case 80:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '(') ADVANCE(497);
      if (lookahead == '-') ADVANCE(534);
      if (lookahead == '.') ADVANCE(658);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == ';') ADVANCE(506);
      if (lookahead == '=') ADVANCE(473);
      if (lookahead == '@') ADVANCE(665);
      if (lookahead == '\\') ADVANCE(462);
      if (lookahead == '_') ADVANCE(518);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == '|') ADVANCE(668);
      if (lookahead == 955) ADVANCE(464);
      if (lookahead == 8230) ADVANCE(467);
      if (lookahead == 8704) ADVANCE(454);
      if (lookahead == 10627) ADVANCE(512);
      if (lookahead == 10628) ADVANCE(515);
      if (lookahead == 10631) ADVANCE(674);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(80)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (lookahead != 0 &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != '}') ADVANCE(589);
      END_STATE();
    case 81:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '(') ADVANCE(497);
      if (lookahead == '-') ADVANCE(534);
      if (lookahead == '.') ADVANCE(658);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == ';') ADVANCE(506);
      if (lookahead == '=') ADVANCE(473);
      if (lookahead == '@') ADVANCE(665);
      if (lookahead == '\\') ADVANCE(462);
      if (lookahead == '_') ADVANCE(518);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == '|') ADVANCE(668);
      if (lookahead == 955) ADVANCE(464);
      if (lookahead == 8230) ADVANCE(467);
      if (lookahead == 8704) ADVANCE(454);
      if (lookahead == 10627) ADVANCE(512);
      if (lookahead == 10631) ADVANCE(674);
      if (lookahead == 10632) ADVANCE(677);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(81)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (lookahead != 0 &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != '}') ADVANCE(589);
      END_STATE();
    case 82:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '(') ADVANCE(497);
      if (lookahead == '-') ADVANCE(534);
      if (lookahead == '.') ADVANCE(658);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == ';') ADVANCE(506);
      if (lookahead == '=') ADVANCE(473);
      if (lookahead == '@') ADVANCE(665);
      if (lookahead == '\\') ADVANCE(462);
      if (lookahead == '_') ADVANCE(518);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == '|') ADVANCE(666);
      if (lookahead == 955) ADVANCE(464);
      if (lookahead == 8230) ADVANCE(467);
      if (lookahead == 8704) ADVANCE(454);
      if (lookahead == 10627) ADVANCE(512);
      if (lookahead == 10631) ADVANCE(674);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(82)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (lookahead != 0 &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != '}') ADVANCE(589);
      END_STATE();
    case 83:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '(') ADVANCE(497);
      if (lookahead == '-') ADVANCE(534);
      if (lookahead == '.') ADVANCE(658);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == ';') ADVANCE(506);
      if (lookahead == '=') ADVANCE(473);
      if (lookahead == '@') ADVANCE(665);
      if (lookahead == '\\') ADVANCE(307);
      if (lookahead == '_') ADVANCE(518);
      if (lookahead == 'i') ADVANCE(564);
      if (lookahead == 'm') ADVANCE(569);
      if (lookahead == 'w') ADVANCE(553);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == '|') ADVANCE(668);
      if (lookahead == 8230) ADVANCE(467);
      if (lookahead == 10627) ADVANCE(512);
      if (lookahead == 10631) ADVANCE(674);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(83)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (lookahead != 0 &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != '}') ADVANCE(589);
      END_STATE();
    case 84:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '(') ADVANCE(497);
      if (lookahead == '-') ADVANCE(534);
      if (lookahead == '.') ADVANCE(658);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == ';') ADVANCE(506);
      if (lookahead == '=') ADVANCE(473);
      if (lookahead == '@') ADVANCE(665);
      if (lookahead == '\\') ADVANCE(309);
      if (lookahead == '_') ADVANCE(518);
      if (lookahead == 'i') ADVANCE(564);
      if (lookahead == 'w') ADVANCE(553);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == '|') ADVANCE(668);
      if (lookahead == 8230) ADVANCE(467);
      if (lookahead == 10627) ADVANCE(512);
      if (lookahead == 10631) ADVANCE(674);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(84)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (lookahead != 0 &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != '}') ADVANCE(589);
      END_STATE();
    case 85:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '(') ADVANCE(497);
      if (lookahead == '-') ADVANCE(534);
      if (lookahead == '.') ADVANCE(658);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == ';') ADVANCE(506);
      if (lookahead == '=') ADVANCE(473);
      if (lookahead == '@') ADVANCE(665);
      if (lookahead == '\\') ADVANCE(310);
      if (lookahead == '_') ADVANCE(518);
      if (lookahead == 'm') ADVANCE(569);
      if (lookahead == 'w') ADVANCE(553);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == '|') ADVANCE(668);
      if (lookahead == 8230) ADVANCE(467);
      if (lookahead == 10627) ADVANCE(512);
      if (lookahead == 10631) ADVANCE(674);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(85)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (lookahead != 0 &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != '}') ADVANCE(589);
      END_STATE();
    case 86:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '(') ADVANCE(497);
      if (lookahead == '-') ADVANCE(534);
      if (lookahead == '.') ADVANCE(658);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == ';') ADVANCE(506);
      if (lookahead == '=') ADVANCE(473);
      if (lookahead == '@') ADVANCE(665);
      if (lookahead == '\\') ADVANCE(313);
      if (lookahead == '_') ADVANCE(518);
      if (lookahead == 'w') ADVANCE(553);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == '|') ADVANCE(668);
      if (lookahead == 8230) ADVANCE(467);
      if (lookahead == 10627) ADVANCE(512);
      if (lookahead == 10631) ADVANCE(674);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(86)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (lookahead != 0 &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != '}') ADVANCE(589);
      END_STATE();
    case 87:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '(') ADVANCE(497);
      if (lookahead == '-') ADVANCE(534);
      if (lookahead == '.') ADVANCE(658);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == ';') ADVANCE(506);
      if (lookahead == '=') ADVANCE(473);
      if (lookahead == '@') ADVANCE(665);
      if (lookahead == '\\') ADVANCE(314);
      if (lookahead == '_') ADVANCE(518);
      if (lookahead == 'i') ADVANCE(564);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == '|') ADVANCE(668);
      if (lookahead == 8230) ADVANCE(467);
      if (lookahead == 10627) ADVANCE(512);
      if (lookahead == 10631) ADVANCE(674);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(87)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (lookahead != 0 &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != '}') ADVANCE(589);
      END_STATE();
    case 88:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '(') ADVANCE(497);
      if (lookahead == '-') ADVANCE(534);
      if (lookahead == '.') ADVANCE(658);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == ';') ADVANCE(506);
      if (lookahead == '=') ADVANCE(473);
      if (lookahead == '@') ADVANCE(665);
      if (lookahead == '\\') ADVANCE(319);
      if (lookahead == '_') ADVANCE(518);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == '|') ADVANCE(668);
      if (lookahead == '}') ADVANCE(527);
      if (lookahead == 8230) ADVANCE(467);
      if (lookahead == 10627) ADVANCE(512);
      if (lookahead == 10631) ADVANCE(674);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(88)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (lookahead != 0 &&
          (lookahead < '\'' || ')' < lookahead)) ADVANCE(589);
      END_STATE();
    case 89:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '(') ADVANCE(497);
      if (lookahead == '-') ADVANCE(534);
      if (lookahead == '.') ADVANCE(658);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == ';') ADVANCE(506);
      if (lookahead == '=') ADVANCE(473);
      if (lookahead == '@') ADVANCE(665);
      if (lookahead == '\\') ADVANCE(320);
      if (lookahead == '_') ADVANCE(518);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == '|') ADVANCE(668);
      if (lookahead == 8230) ADVANCE(467);
      if (lookahead == 10627) ADVANCE(512);
      if (lookahead == 10628) ADVANCE(515);
      if (lookahead == 10631) ADVANCE(674);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(89)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (lookahead != 0 &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != '}') ADVANCE(589);
      END_STATE();
    case 90:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '(') ADVANCE(497);
      if (lookahead == '-') ADVANCE(534);
      if (lookahead == '.') ADVANCE(658);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == ';') ADVANCE(506);
      if (lookahead == '=') ADVANCE(473);
      if (lookahead == '@') ADVANCE(665);
      if (lookahead == '\\') ADVANCE(321);
      if (lookahead == '_') ADVANCE(518);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == '|') ADVANCE(666);
      if (lookahead == 8230) ADVANCE(467);
      if (lookahead == 10627) ADVANCE(512);
      if (lookahead == 10631) ADVANCE(674);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(90)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (lookahead != 0 &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != '}') ADVANCE(589);
      END_STATE();
    case 91:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '(') ADVANCE(497);
      if (lookahead == '-') ADVANCE(534);
      if (lookahead == '.') ADVANCE(658);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == ';') ADVANCE(506);
      if (lookahead == '=') ADVANCE(473);
      if (lookahead == '@') ADVANCE(665);
      if (lookahead == '\\') ADVANCE(322);
      if (lookahead == '_') ADVANCE(518);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == '|') ADVANCE(668);
      if (lookahead == 8230) ADVANCE(467);
      if (lookahead == 10627) ADVANCE(512);
      if (lookahead == 10631) ADVANCE(674);
      if (lookahead == 10632) ADVANCE(677);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(91)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (lookahead != 0 &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != '}') ADVANCE(589);
      END_STATE();
    case 92:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '(') ADVANCE(497);
      if (lookahead == '-') ADVANCE(534);
      if (lookahead == '.') ADVANCE(658);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == ';') ADVANCE(506);
      if (lookahead == '=') ADVANCE(473);
      if (lookahead == '\\') ADVANCE(329);
      if (lookahead == '_') ADVANCE(518);
      if (lookahead == 'h') ADVANCE(554);
      if (lookahead == 'p') ADVANCE(584);
      if (lookahead == 'r') ADVANCE(546);
      if (lookahead == 'u') ADVANCE(577);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == '}') ADVANCE(527);
      if (lookahead == 8230) ADVANCE(467);
      if (lookahead == 10627) ADVANCE(512);
      if (lookahead == 10631) ADVANCE(674);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(92)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (lookahead != 0 &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != '@') ADVANCE(589);
      END_STATE();
    case 93:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '(') ADVANCE(497);
      if (lookahead == '-') ADVANCE(534);
      if (lookahead == '.') ADVANCE(658);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == ';') ADVANCE(506);
      if (lookahead == '@') ADVANCE(665);
      if (lookahead == '\\') ADVANCE(462);
      if (lookahead == '_') ADVANCE(518);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == '|') ADVANCE(668);
      if (lookahead == '}') ADVANCE(527);
      if (lookahead == 955) ADVANCE(464);
      if (lookahead == 8230) ADVANCE(467);
      if (lookahead == 8704) ADVANCE(454);
      if (lookahead == 10627) ADVANCE(512);
      if (lookahead == 10631) ADVANCE(674);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(93)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (lookahead != 0 &&
          (lookahead < '\'' || ')' < lookahead)) ADVANCE(589);
      END_STATE();
    case 94:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '(') ADVANCE(497);
      if (lookahead == '-') ADVANCE(534);
      if (lookahead == '.') ADVANCE(658);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == ';') ADVANCE(506);
      if (lookahead == '@') ADVANCE(665);
      if (lookahead == '\\') ADVANCE(305);
      if (lookahead == '_') ADVANCE(518);
      if (lookahead == 'h') ADVANCE(554);
      if (lookahead == 'p') ADVANCE(584);
      if (lookahead == 'r') ADVANCE(546);
      if (lookahead == 'u') ADVANCE(577);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == '}') ADVANCE(527);
      if (lookahead == 8230) ADVANCE(467);
      if (lookahead == 10627) ADVANCE(512);
      if (lookahead == 10631) ADVANCE(674);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(94)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (lookahead != 0 &&
          (lookahead < '\'' || ')' < lookahead)) ADVANCE(589);
      END_STATE();
    case 95:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '(') ADVANCE(497);
      if (lookahead == '-') ADVANCE(534);
      if (lookahead == '.') ADVANCE(658);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == ';') ADVANCE(506);
      if (lookahead == '@') ADVANCE(665);
      if (lookahead == '\\') ADVANCE(325);
      if (lookahead == '_') ADVANCE(518);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == '|') ADVANCE(668);
      if (lookahead == '}') ADVANCE(527);
      if (lookahead == 8230) ADVANCE(467);
      if (lookahead == 10627) ADVANCE(512);
      if (lookahead == 10631) ADVANCE(674);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(95)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (lookahead != 0 &&
          (lookahead < '\'' || ')' < lookahead)) ADVANCE(589);
      END_STATE();
    case 96:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '(') ADVANCE(497);
      if (lookahead == '-') ADVANCE(534);
      if (lookahead == '.') ADVANCE(658);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == ';') ADVANCE(654);
      if (lookahead == '=') ADVANCE(473);
      if (lookahead == '@') ADVANCE(665);
      if (lookahead == '\\') ADVANCE(462);
      if (lookahead == '_') ADVANCE(518);
      if (lookahead == 'i') ADVANCE(564);
      if (lookahead == 'm') ADVANCE(569);
      if (lookahead == 'w') ADVANCE(553);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == '|') ADVANCE(668);
      if (lookahead == 955) ADVANCE(464);
      if (lookahead == 8230) ADVANCE(467);
      if (lookahead == 8704) ADVANCE(454);
      if (lookahead == 10627) ADVANCE(512);
      if (lookahead == 10631) ADVANCE(674);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(96)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (lookahead != 0 &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != '}') ADVANCE(589);
      END_STATE();
    case 97:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '(') ADVANCE(497);
      if (lookahead == '-') ADVANCE(534);
      if (lookahead == '.') ADVANCE(658);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == ';') ADVANCE(654);
      if (lookahead == '=') ADVANCE(473);
      if (lookahead == '@') ADVANCE(665);
      if (lookahead == '\\') ADVANCE(462);
      if (lookahead == '_') ADVANCE(518);
      if (lookahead == 'i') ADVANCE(564);
      if (lookahead == 'w') ADVANCE(553);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == '|') ADVANCE(668);
      if (lookahead == 955) ADVANCE(464);
      if (lookahead == 8230) ADVANCE(467);
      if (lookahead == 8704) ADVANCE(454);
      if (lookahead == 10627) ADVANCE(512);
      if (lookahead == 10631) ADVANCE(674);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(97)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (lookahead != 0 &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != '}') ADVANCE(589);
      END_STATE();
    case 98:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '(') ADVANCE(497);
      if (lookahead == '-') ADVANCE(534);
      if (lookahead == '.') ADVANCE(658);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == ';') ADVANCE(654);
      if (lookahead == '=') ADVANCE(473);
      if (lookahead == '@') ADVANCE(665);
      if (lookahead == '\\') ADVANCE(462);
      if (lookahead == '_') ADVANCE(518);
      if (lookahead == 'i') ADVANCE(564);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == '|') ADVANCE(668);
      if (lookahead == 955) ADVANCE(464);
      if (lookahead == 8230) ADVANCE(467);
      if (lookahead == 8704) ADVANCE(454);
      if (lookahead == 10627) ADVANCE(512);
      if (lookahead == 10631) ADVANCE(674);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(98)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (lookahead != 0 &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != '}') ADVANCE(589);
      END_STATE();
    case 99:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '(') ADVANCE(497);
      if (lookahead == '-') ADVANCE(534);
      if (lookahead == '.') ADVANCE(658);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == ';') ADVANCE(654);
      if (lookahead == '=') ADVANCE(473);
      if (lookahead == '@') ADVANCE(665);
      if (lookahead == '\\') ADVANCE(462);
      if (lookahead == '_') ADVANCE(518);
      if (lookahead == 'm') ADVANCE(569);
      if (lookahead == 'w') ADVANCE(553);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == '|') ADVANCE(668);
      if (lookahead == 955) ADVANCE(464);
      if (lookahead == 8230) ADVANCE(467);
      if (lookahead == 8704) ADVANCE(454);
      if (lookahead == 10627) ADVANCE(512);
      if (lookahead == 10631) ADVANCE(674);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(99)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (lookahead != 0 &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != '}') ADVANCE(589);
      END_STATE();
    case 100:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '(') ADVANCE(497);
      if (lookahead == '-') ADVANCE(534);
      if (lookahead == '.') ADVANCE(658);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == ';') ADVANCE(654);
      if (lookahead == '=') ADVANCE(473);
      if (lookahead == '@') ADVANCE(665);
      if (lookahead == '\\') ADVANCE(462);
      if (lookahead == '_') ADVANCE(518);
      if (lookahead == 'w') ADVANCE(553);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == '|') ADVANCE(668);
      if (lookahead == 955) ADVANCE(464);
      if (lookahead == 8230) ADVANCE(467);
      if (lookahead == 8704) ADVANCE(454);
      if (lookahead == 10627) ADVANCE(512);
      if (lookahead == 10631) ADVANCE(674);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(100)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (lookahead != 0 &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != '}') ADVANCE(589);
      END_STATE();
    case 101:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '(') ADVANCE(497);
      if (lookahead == '-') ADVANCE(534);
      if (lookahead == '.') ADVANCE(658);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == ';') ADVANCE(654);
      if (lookahead == '=') ADVANCE(473);
      if (lookahead == '@') ADVANCE(665);
      if (lookahead == '\\') ADVANCE(462);
      if (lookahead == '_') ADVANCE(518);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == '|') ADVANCE(668);
      if (lookahead == '}') ADVANCE(527);
      if (lookahead == 955) ADVANCE(464);
      if (lookahead == 8230) ADVANCE(467);
      if (lookahead == 8704) ADVANCE(454);
      if (lookahead == 10627) ADVANCE(512);
      if (lookahead == 10631) ADVANCE(674);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(101)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (lookahead != 0 &&
          (lookahead < '\'' || ')' < lookahead)) ADVANCE(589);
      END_STATE();
    case 102:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '(') ADVANCE(497);
      if (lookahead == '-') ADVANCE(534);
      if (lookahead == '.') ADVANCE(658);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == ';') ADVANCE(654);
      if (lookahead == '=') ADVANCE(473);
      if (lookahead == '@') ADVANCE(665);
      if (lookahead == '\\') ADVANCE(462);
      if (lookahead == '_') ADVANCE(518);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == '|') ADVANCE(668);
      if (lookahead == 955) ADVANCE(464);
      if (lookahead == 8230) ADVANCE(467);
      if (lookahead == 8704) ADVANCE(454);
      if (lookahead == 10627) ADVANCE(512);
      if (lookahead == 10628) ADVANCE(515);
      if (lookahead == 10631) ADVANCE(674);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(102)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (lookahead != 0 &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != '}') ADVANCE(589);
      END_STATE();
    case 103:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '(') ADVANCE(497);
      if (lookahead == '-') ADVANCE(534);
      if (lookahead == '.') ADVANCE(658);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == ';') ADVANCE(654);
      if (lookahead == '=') ADVANCE(473);
      if (lookahead == '@') ADVANCE(665);
      if (lookahead == '\\') ADVANCE(462);
      if (lookahead == '_') ADVANCE(518);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == '|') ADVANCE(668);
      if (lookahead == 955) ADVANCE(464);
      if (lookahead == 8230) ADVANCE(467);
      if (lookahead == 8704) ADVANCE(454);
      if (lookahead == 10627) ADVANCE(512);
      if (lookahead == 10631) ADVANCE(674);
      if (lookahead == 10632) ADVANCE(677);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(103)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (lookahead != 0 &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != '}') ADVANCE(589);
      END_STATE();
    case 104:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '(') ADVANCE(497);
      if (lookahead == '-') ADVANCE(534);
      if (lookahead == '.') ADVANCE(658);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == ';') ADVANCE(654);
      if (lookahead == '=') ADVANCE(473);
      if (lookahead == '@') ADVANCE(665);
      if (lookahead == '\\') ADVANCE(462);
      if (lookahead == '_') ADVANCE(518);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == '|') ADVANCE(666);
      if (lookahead == 955) ADVANCE(464);
      if (lookahead == 8230) ADVANCE(467);
      if (lookahead == 8704) ADVANCE(454);
      if (lookahead == 10627) ADVANCE(512);
      if (lookahead == 10631) ADVANCE(674);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(104)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (lookahead != 0 &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != '}') ADVANCE(589);
      END_STATE();
    case 105:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '(') ADVANCE(497);
      if (lookahead == '-') ADVANCE(534);
      if (lookahead == '.') ADVANCE(658);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == ';') ADVANCE(654);
      if (lookahead == '=') ADVANCE(473);
      if (lookahead == '@') ADVANCE(665);
      if (lookahead == '\\') ADVANCE(396);
      if (lookahead == '_') ADVANCE(518);
      if (lookahead == 'i') ADVANCE(564);
      if (lookahead == 'm') ADVANCE(569);
      if (lookahead == 'w') ADVANCE(553);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == '|') ADVANCE(668);
      if (lookahead == 8230) ADVANCE(467);
      if (lookahead == 10627) ADVANCE(512);
      if (lookahead == 10631) ADVANCE(674);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(105)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (lookahead != 0 &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != '}') ADVANCE(589);
      END_STATE();
    case 106:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '(') ADVANCE(497);
      if (lookahead == '-') ADVANCE(534);
      if (lookahead == '.') ADVANCE(658);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == ';') ADVANCE(654);
      if (lookahead == '=') ADVANCE(473);
      if (lookahead == '@') ADVANCE(665);
      if (lookahead == '\\') ADVANCE(397);
      if (lookahead == '_') ADVANCE(518);
      if (lookahead == 'i') ADVANCE(564);
      if (lookahead == 'w') ADVANCE(553);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == '|') ADVANCE(668);
      if (lookahead == 8230) ADVANCE(467);
      if (lookahead == 10627) ADVANCE(512);
      if (lookahead == 10631) ADVANCE(674);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(106)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (lookahead != 0 &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != '}') ADVANCE(589);
      END_STATE();
    case 107:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '(') ADVANCE(497);
      if (lookahead == '-') ADVANCE(534);
      if (lookahead == '.') ADVANCE(658);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == ';') ADVANCE(654);
      if (lookahead == '=') ADVANCE(473);
      if (lookahead == '@') ADVANCE(665);
      if (lookahead == '\\') ADVANCE(398);
      if (lookahead == '_') ADVANCE(518);
      if (lookahead == 'm') ADVANCE(569);
      if (lookahead == 'w') ADVANCE(553);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == '|') ADVANCE(668);
      if (lookahead == 8230) ADVANCE(467);
      if (lookahead == 10627) ADVANCE(512);
      if (lookahead == 10631) ADVANCE(674);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(107)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (lookahead != 0 &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != '}') ADVANCE(589);
      END_STATE();
    case 108:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '(') ADVANCE(497);
      if (lookahead == '-') ADVANCE(534);
      if (lookahead == '.') ADVANCE(658);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == ';') ADVANCE(654);
      if (lookahead == '=') ADVANCE(473);
      if (lookahead == '@') ADVANCE(665);
      if (lookahead == '\\') ADVANCE(401);
      if (lookahead == '_') ADVANCE(518);
      if (lookahead == 'w') ADVANCE(553);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == '|') ADVANCE(668);
      if (lookahead == 8230) ADVANCE(467);
      if (lookahead == 10627) ADVANCE(512);
      if (lookahead == 10631) ADVANCE(674);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(108)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (lookahead != 0 &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != '}') ADVANCE(589);
      END_STATE();
    case 109:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '(') ADVANCE(497);
      if (lookahead == '-') ADVANCE(534);
      if (lookahead == '.') ADVANCE(658);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == ';') ADVANCE(654);
      if (lookahead == '=') ADVANCE(473);
      if (lookahead == '@') ADVANCE(665);
      if (lookahead == '\\') ADVANCE(402);
      if (lookahead == '_') ADVANCE(518);
      if (lookahead == 'i') ADVANCE(564);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == '|') ADVANCE(668);
      if (lookahead == 8230) ADVANCE(467);
      if (lookahead == 10627) ADVANCE(512);
      if (lookahead == 10631) ADVANCE(674);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(109)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (lookahead != 0 &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != '}') ADVANCE(589);
      END_STATE();
    case 110:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '(') ADVANCE(497);
      if (lookahead == '-') ADVANCE(534);
      if (lookahead == '.') ADVANCE(658);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == ';') ADVANCE(654);
      if (lookahead == '=') ADVANCE(473);
      if (lookahead == '@') ADVANCE(665);
      if (lookahead == '\\') ADVANCE(407);
      if (lookahead == '_') ADVANCE(518);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == '|') ADVANCE(668);
      if (lookahead == '}') ADVANCE(527);
      if (lookahead == 8230) ADVANCE(467);
      if (lookahead == 10627) ADVANCE(512);
      if (lookahead == 10631) ADVANCE(674);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(110)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (lookahead != 0 &&
          (lookahead < '\'' || ')' < lookahead)) ADVANCE(589);
      END_STATE();
    case 111:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '(') ADVANCE(497);
      if (lookahead == '-') ADVANCE(534);
      if (lookahead == '.') ADVANCE(658);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == ';') ADVANCE(654);
      if (lookahead == '=') ADVANCE(473);
      if (lookahead == '@') ADVANCE(665);
      if (lookahead == '\\') ADVANCE(410);
      if (lookahead == '_') ADVANCE(518);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == '|') ADVANCE(668);
      if (lookahead == 8230) ADVANCE(467);
      if (lookahead == 10627) ADVANCE(512);
      if (lookahead == 10631) ADVANCE(674);
      if (lookahead == 10632) ADVANCE(677);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(111)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (lookahead != 0 &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != '}') ADVANCE(589);
      END_STATE();
    case 112:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '(') ADVANCE(497);
      if (lookahead == '-') ADVANCE(534);
      if (lookahead == '.') ADVANCE(658);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == ';') ADVANCE(654);
      if (lookahead == '=') ADVANCE(473);
      if (lookahead == '@') ADVANCE(665);
      if (lookahead == '\\') ADVANCE(409);
      if (lookahead == '_') ADVANCE(518);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == '|') ADVANCE(666);
      if (lookahead == 8230) ADVANCE(467);
      if (lookahead == 10627) ADVANCE(512);
      if (lookahead == 10631) ADVANCE(674);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(112)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (lookahead != 0 &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != '}') ADVANCE(589);
      END_STATE();
    case 113:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '(') ADVANCE(497);
      if (lookahead == '-') ADVANCE(534);
      if (lookahead == '.') ADVANCE(658);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == ';') ADVANCE(654);
      if (lookahead == '=') ADVANCE(473);
      if (lookahead == '@') ADVANCE(665);
      if (lookahead == '\\') ADVANCE(408);
      if (lookahead == '_') ADVANCE(518);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == '|') ADVANCE(668);
      if (lookahead == 8230) ADVANCE(467);
      if (lookahead == 10627) ADVANCE(512);
      if (lookahead == 10628) ADVANCE(515);
      if (lookahead == 10631) ADVANCE(674);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(113)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (lookahead != 0 &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != '}') ADVANCE(589);
      END_STATE();
    case 114:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '(') ADVANCE(497);
      if (lookahead == '-') ADVANCE(534);
      if (lookahead == '.') ADVANCE(658);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == ';') ADVANCE(654);
      if (lookahead == '@') ADVANCE(665);
      if (lookahead == '\\') ADVANCE(462);
      if (lookahead == '_') ADVANCE(518);
      if (lookahead == 'c') ADVANCE(570);
      if (lookahead == 'm') ADVANCE(569);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == 955) ADVANCE(464);
      if (lookahead == 8230) ADVANCE(467);
      if (lookahead == 8704) ADVANCE(454);
      if (lookahead == 10627) ADVANCE(512);
      if (lookahead == 10631) ADVANCE(674);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(114)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (lookahead != 0 &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != '}') ADVANCE(589);
      END_STATE();
    case 115:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '(') ADVANCE(497);
      if (lookahead == '-') ADVANCE(534);
      if (lookahead == '.') ADVANCE(658);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == ';') ADVANCE(654);
      if (lookahead == '@') ADVANCE(665);
      if (lookahead == '\\') ADVANCE(462);
      if (lookahead == '_') ADVANCE(518);
      if (lookahead == 'i') ADVANCE(564);
      if (lookahead == 'm') ADVANCE(569);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == 955) ADVANCE(464);
      if (lookahead == 8230) ADVANCE(467);
      if (lookahead == 8704) ADVANCE(454);
      if (lookahead == 10627) ADVANCE(512);
      if (lookahead == 10631) ADVANCE(674);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(115)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (lookahead != 0 &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != '}') ADVANCE(589);
      END_STATE();
    case 116:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '(') ADVANCE(497);
      if (lookahead == '-') ADVANCE(534);
      if (lookahead == '.') ADVANCE(658);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == ';') ADVANCE(654);
      if (lookahead == '@') ADVANCE(665);
      if (lookahead == '\\') ADVANCE(462);
      if (lookahead == '_') ADVANCE(518);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == '|') ADVANCE(668);
      if (lookahead == 955) ADVANCE(464);
      if (lookahead == 8230) ADVANCE(467);
      if (lookahead == 8704) ADVANCE(454);
      if (lookahead == 10627) ADVANCE(512);
      if (lookahead == 10631) ADVANCE(674);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(116)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (lookahead != 0 &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != '}') ADVANCE(589);
      END_STATE();
    case 117:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '(') ADVANCE(497);
      if (lookahead == '-') ADVANCE(534);
      if (lookahead == '.') ADVANCE(658);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == ';') ADVANCE(654);
      if (lookahead == '@') ADVANCE(665);
      if (lookahead == '\\') ADVANCE(462);
      if (lookahead == '_') ADVANCE(518);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == 955) ADVANCE(464);
      if (lookahead == 8230) ADVANCE(467);
      if (lookahead == 8704) ADVANCE(454);
      if (lookahead == 10627) ADVANCE(512);
      if (lookahead == 10631) ADVANCE(674);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(117)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (lookahead != 0 &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != '}') ADVANCE(589);
      END_STATE();
    case 118:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '(') ADVANCE(497);
      if (lookahead == '-') ADVANCE(534);
      if (lookahead == '.') ADVANCE(658);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == ';') ADVANCE(654);
      if (lookahead == '@') ADVANCE(665);
      if (lookahead == '\\') ADVANCE(304);
      if (lookahead == '_') ADVANCE(518);
      if (lookahead == 'h') ADVANCE(554);
      if (lookahead == 'i') ADVANCE(564);
      if (lookahead == 'p') ADVANCE(584);
      if (lookahead == 'r') ADVANCE(546);
      if (lookahead == 'u') ADVANCE(577);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == 8230) ADVANCE(467);
      if (lookahead == 10627) ADVANCE(512);
      if (lookahead == 10631) ADVANCE(674);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(118)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (lookahead != 0 &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != '}') ADVANCE(589);
      END_STATE();
    case 119:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '(') ADVANCE(497);
      if (lookahead == '-') ADVANCE(534);
      if (lookahead == '.') ADVANCE(658);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == ';') ADVANCE(654);
      if (lookahead == '@') ADVANCE(665);
      if (lookahead == '\\') ADVANCE(327);
      if (lookahead == '_') ADVANCE(518);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == '|') ADVANCE(668);
      if (lookahead == 8230) ADVANCE(467);
      if (lookahead == 10627) ADVANCE(512);
      if (lookahead == 10631) ADVANCE(674);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(119)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (lookahead != 0 &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != '}') ADVANCE(589);
      END_STATE();
    case 120:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '(') ADVANCE(497);
      if (lookahead == '-') ADVANCE(534);
      if (lookahead == '.') ADVANCE(658);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == ';') ADVANCE(654);
      if (lookahead == '@') ADVANCE(665);
      if (lookahead == '\\') ADVANCE(328);
      if (lookahead == '_') ADVANCE(518);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == 8230) ADVANCE(467);
      if (lookahead == 10627) ADVANCE(512);
      if (lookahead == 10631) ADVANCE(674);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(120)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (lookahead != 0 &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != '}') ADVANCE(589);
      END_STATE();
    case 121:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '(') ADVANCE(497);
      if (lookahead == '-') ADVANCE(663);
      if (lookahead == '.') ADVANCE(658);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == ';') ADVANCE(654);
      if (lookahead == '@') ADVANCE(665);
      if (lookahead == '\\') ADVANCE(462);
      if (lookahead == '_') ADVANCE(518);
      if (lookahead == '{') ADVANCE(524);
      if (lookahead == '}') ADVANCE(527);
      if (lookahead == 955) ADVANCE(464);
      if (lookahead == 8230) ADVANCE(467);
      if (lookahead == 8594) ADVANCE(460);
      if (lookahead == 8704) ADVANCE(454);
      if (lookahead == 10627) ADVANCE(512);
      if (lookahead == 10631) ADVANCE(674);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(121)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (lookahead != 0 &&
          (lookahead < '\'' || ')' < lookahead)) ADVANCE(589);
      END_STATE();
    case 122:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '(') ADVANCE(497);
      if (lookahead == '-') ADVANCE(664);
      if (lookahead == '.') ADVANCE(657);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == ';') ADVANCE(654);
      if (lookahead == '@') ADVANCE(665);
      if (lookahead == '\\') ADVANCE(462);
      if (lookahead == '_') ADVANCE(518);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == '}') ADVANCE(527);
      if (lookahead == 955) ADVANCE(464);
      if (lookahead == 8230) ADVANCE(467);
      if (lookahead == 8704) ADVANCE(454);
      if (lookahead == 10627) ADVANCE(512);
      if (lookahead == 10631) ADVANCE(674);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(122)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (lookahead != 0 &&
          (lookahead < '\'' || ')' < lookahead)) ADVANCE(589);
      END_STATE();
    case 123:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '(') ADVANCE(497);
      if (lookahead == '-') ADVANCE(664);
      if (lookahead == '.') ADVANCE(657);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == ';') ADVANCE(654);
      if (lookahead == '@') ADVANCE(665);
      if (lookahead == '\\') ADVANCE(462);
      if (lookahead == '_') ADVANCE(518);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == '}') ADVANCE(444);
      if (lookahead == 955) ADVANCE(464);
      if (lookahead == 8230) ADVANCE(467);
      if (lookahead == 8704) ADVANCE(454);
      if (lookahead == 10627) ADVANCE(512);
      if (lookahead == 10631) ADVANCE(674);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(123)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (lookahead != 0 &&
          (lookahead < '\'' || ')' < lookahead)) ADVANCE(589);
      END_STATE();
    case 124:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '(') ADVANCE(497);
      if (lookahead == '-') ADVANCE(664);
      if (lookahead == '.') ADVANCE(657);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == ';') ADVANCE(654);
      if (lookahead == '@') ADVANCE(665);
      if (lookahead == '\\') ADVANCE(462);
      if (lookahead == '_') ADVANCE(518);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == 955) ADVANCE(464);
      if (lookahead == 8230) ADVANCE(467);
      if (lookahead == 8704) ADVANCE(454);
      if (lookahead == 10627) ADVANCE(512);
      if (lookahead == 10628) ADVANCE(515);
      if (lookahead == 10631) ADVANCE(674);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(124)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (lookahead != 0 &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != '}') ADVANCE(589);
      END_STATE();
    case 125:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '(') ADVANCE(497);
      if (lookahead == '-') ADVANCE(664);
      if (lookahead == '.') ADVANCE(658);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == ';') ADVANCE(654);
      if (lookahead == '@') ADVANCE(665);
      if (lookahead == '\\') ADVANCE(462);
      if (lookahead == '_') ADVANCE(518);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == '}') ADVANCE(444);
      if (lookahead == 955) ADVANCE(464);
      if (lookahead == 8230) ADVANCE(467);
      if (lookahead == 8704) ADVANCE(454);
      if (lookahead == 10627) ADVANCE(512);
      if (lookahead == 10631) ADVANCE(674);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(125)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (lookahead != 0 &&
          (lookahead < '\'' || ')' < lookahead)) ADVANCE(589);
      END_STATE();
    case 126:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '(') ADVANCE(497);
      if (lookahead == '-') ADVANCE(664);
      if (lookahead == '.') ADVANCE(658);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == ';') ADVANCE(654);
      if (lookahead == '@') ADVANCE(665);
      if (lookahead == '\\') ADVANCE(462);
      if (lookahead == '_') ADVANCE(518);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == 955) ADVANCE(464);
      if (lookahead == 8230) ADVANCE(467);
      if (lookahead == 8704) ADVANCE(454);
      if (lookahead == 10627) ADVANCE(512);
      if (lookahead == 10628) ADVANCE(515);
      if (lookahead == 10631) ADVANCE(674);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(126)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (lookahead != 0 &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != '}') ADVANCE(589);
      END_STATE();
    case 127:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '(') ADVANCE(497);
      if (lookahead == '-') ADVANCE(533);
      if (lookahead == '.') ADVANCE(658);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == ':') ADVANCE(470);
      if (lookahead == ';') ADVANCE(506);
      if (lookahead == '=') ADVANCE(473);
      if (lookahead == '@') ADVANCE(665);
      if (lookahead == '\\') ADVANCE(462);
      if (lookahead == '_') ADVANCE(518);
      if (lookahead == 'i') ADVANCE(564);
      if (lookahead == 'm') ADVANCE(569);
      if (lookahead == 'r') ADVANCE(543);
      if (lookahead == 'w') ADVANCE(552);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == '|') ADVANCE(668);
      if (lookahead == 955) ADVANCE(464);
      if (lookahead == 8230) ADVANCE(467);
      if (lookahead == 8594) ADVANCE(460);
      if (lookahead == 8704) ADVANCE(454);
      if (lookahead == 10627) ADVANCE(512);
      if (lookahead == 10631) ADVANCE(674);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(127)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (lookahead != 0 &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != '}') ADVANCE(589);
      END_STATE();
    case 128:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '(') ADVANCE(497);
      if (lookahead == '-') ADVANCE(533);
      if (lookahead == '.') ADVANCE(658);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == ':') ADVANCE(470);
      if (lookahead == ';') ADVANCE(506);
      if (lookahead == '=') ADVANCE(473);
      if (lookahead == '@') ADVANCE(665);
      if (lookahead == '\\') ADVANCE(462);
      if (lookahead == '_') ADVANCE(518);
      if (lookahead == 'i') ADVANCE(564);
      if (lookahead == 'm') ADVANCE(569);
      if (lookahead == 'r') ADVANCE(543);
      if (lookahead == 'w') ADVANCE(552);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == 955) ADVANCE(464);
      if (lookahead == 8230) ADVANCE(467);
      if (lookahead == 8594) ADVANCE(460);
      if (lookahead == 8704) ADVANCE(454);
      if (lookahead == 10627) ADVANCE(512);
      if (lookahead == 10631) ADVANCE(674);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(128)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (lookahead != 0 &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != '}') ADVANCE(589);
      END_STATE();
    case 129:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '(') ADVANCE(497);
      if (lookahead == '-') ADVANCE(533);
      if (lookahead == '.') ADVANCE(658);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == ':') ADVANCE(470);
      if (lookahead == ';') ADVANCE(506);
      if (lookahead == '=') ADVANCE(473);
      if (lookahead == '@') ADVANCE(665);
      if (lookahead == '\\') ADVANCE(462);
      if (lookahead == '_') ADVANCE(518);
      if (lookahead == 'i') ADVANCE(564);
      if (lookahead == 'm') ADVANCE(569);
      if (lookahead == 'w') ADVANCE(552);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == '|') ADVANCE(668);
      if (lookahead == 955) ADVANCE(464);
      if (lookahead == 8230) ADVANCE(467);
      if (lookahead == 8594) ADVANCE(460);
      if (lookahead == 8704) ADVANCE(454);
      if (lookahead == 10627) ADVANCE(512);
      if (lookahead == 10631) ADVANCE(674);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(129)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (lookahead != 0 &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != '}') ADVANCE(589);
      END_STATE();
    case 130:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '(') ADVANCE(497);
      if (lookahead == '-') ADVANCE(533);
      if (lookahead == '.') ADVANCE(658);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == ':') ADVANCE(470);
      if (lookahead == ';') ADVANCE(506);
      if (lookahead == '=') ADVANCE(473);
      if (lookahead == '@') ADVANCE(665);
      if (lookahead == '\\') ADVANCE(462);
      if (lookahead == '_') ADVANCE(518);
      if (lookahead == 'i') ADVANCE(564);
      if (lookahead == 'm') ADVANCE(569);
      if (lookahead == 'w') ADVANCE(552);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == 955) ADVANCE(464);
      if (lookahead == 8230) ADVANCE(467);
      if (lookahead == 8594) ADVANCE(460);
      if (lookahead == 8704) ADVANCE(454);
      if (lookahead == 10627) ADVANCE(512);
      if (lookahead == 10631) ADVANCE(674);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(130)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (lookahead != 0 &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != '}') ADVANCE(589);
      END_STATE();
    case 131:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '(') ADVANCE(497);
      if (lookahead == '-') ADVANCE(533);
      if (lookahead == '.') ADVANCE(658);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == ':') ADVANCE(470);
      if (lookahead == ';') ADVANCE(506);
      if (lookahead == '=') ADVANCE(473);
      if (lookahead == '@') ADVANCE(665);
      if (lookahead == '\\') ADVANCE(462);
      if (lookahead == '_') ADVANCE(518);
      if (lookahead == 'i') ADVANCE(564);
      if (lookahead == 'm') ADVANCE(569);
      if (lookahead == 'w') ADVANCE(553);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == '|') ADVANCE(668);
      if (lookahead == 955) ADVANCE(464);
      if (lookahead == 8230) ADVANCE(467);
      if (lookahead == 8594) ADVANCE(460);
      if (lookahead == 8704) ADVANCE(454);
      if (lookahead == 10627) ADVANCE(512);
      if (lookahead == 10631) ADVANCE(674);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(131)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (lookahead != 0 &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != '}') ADVANCE(589);
      END_STATE();
    case 132:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '(') ADVANCE(497);
      if (lookahead == '-') ADVANCE(533);
      if (lookahead == '.') ADVANCE(658);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == ':') ADVANCE(470);
      if (lookahead == ';') ADVANCE(506);
      if (lookahead == '=') ADVANCE(473);
      if (lookahead == '@') ADVANCE(665);
      if (lookahead == '\\') ADVANCE(462);
      if (lookahead == '_') ADVANCE(518);
      if (lookahead == 'i') ADVANCE(564);
      if (lookahead == 'm') ADVANCE(569);
      if (lookahead == 'w') ADVANCE(553);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == 955) ADVANCE(464);
      if (lookahead == 8230) ADVANCE(467);
      if (lookahead == 8594) ADVANCE(460);
      if (lookahead == 8704) ADVANCE(454);
      if (lookahead == 10627) ADVANCE(512);
      if (lookahead == 10631) ADVANCE(674);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(132)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (lookahead != 0 &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != '}') ADVANCE(589);
      END_STATE();
    case 133:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '(') ADVANCE(497);
      if (lookahead == '-') ADVANCE(533);
      if (lookahead == '.') ADVANCE(658);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == ':') ADVANCE(470);
      if (lookahead == ';') ADVANCE(506);
      if (lookahead == '=') ADVANCE(473);
      if (lookahead == '@') ADVANCE(665);
      if (lookahead == '\\') ADVANCE(462);
      if (lookahead == '_') ADVANCE(518);
      if (lookahead == 'm') ADVANCE(569);
      if (lookahead == 'r') ADVANCE(543);
      if (lookahead == 'w') ADVANCE(552);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == '|') ADVANCE(668);
      if (lookahead == 955) ADVANCE(464);
      if (lookahead == 8230) ADVANCE(467);
      if (lookahead == 8594) ADVANCE(460);
      if (lookahead == 8704) ADVANCE(454);
      if (lookahead == 10627) ADVANCE(512);
      if (lookahead == 10631) ADVANCE(674);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(133)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (lookahead != 0 &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != '}') ADVANCE(589);
      END_STATE();
    case 134:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '(') ADVANCE(497);
      if (lookahead == '-') ADVANCE(533);
      if (lookahead == '.') ADVANCE(658);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == ':') ADVANCE(470);
      if (lookahead == ';') ADVANCE(506);
      if (lookahead == '=') ADVANCE(473);
      if (lookahead == '@') ADVANCE(665);
      if (lookahead == '\\') ADVANCE(462);
      if (lookahead == '_') ADVANCE(518);
      if (lookahead == 'm') ADVANCE(569);
      if (lookahead == 'r') ADVANCE(543);
      if (lookahead == 'w') ADVANCE(552);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == 955) ADVANCE(464);
      if (lookahead == 8230) ADVANCE(467);
      if (lookahead == 8594) ADVANCE(460);
      if (lookahead == 8704) ADVANCE(454);
      if (lookahead == 10627) ADVANCE(512);
      if (lookahead == 10631) ADVANCE(674);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(134)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (lookahead != 0 &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != '}') ADVANCE(589);
      END_STATE();
    case 135:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '(') ADVANCE(497);
      if (lookahead == '-') ADVANCE(533);
      if (lookahead == '.') ADVANCE(658);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == ':') ADVANCE(470);
      if (lookahead == ';') ADVANCE(506);
      if (lookahead == '=') ADVANCE(473);
      if (lookahead == '@') ADVANCE(665);
      if (lookahead == '\\') ADVANCE(462);
      if (lookahead == '_') ADVANCE(518);
      if (lookahead == 'm') ADVANCE(569);
      if (lookahead == 'w') ADVANCE(552);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == '|') ADVANCE(668);
      if (lookahead == 955) ADVANCE(464);
      if (lookahead == 8230) ADVANCE(467);
      if (lookahead == 8594) ADVANCE(460);
      if (lookahead == 8704) ADVANCE(454);
      if (lookahead == 10627) ADVANCE(512);
      if (lookahead == 10631) ADVANCE(674);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(135)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (lookahead != 0 &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != '}') ADVANCE(589);
      END_STATE();
    case 136:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '(') ADVANCE(497);
      if (lookahead == '-') ADVANCE(533);
      if (lookahead == '.') ADVANCE(658);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == ':') ADVANCE(470);
      if (lookahead == ';') ADVANCE(506);
      if (lookahead == '=') ADVANCE(473);
      if (lookahead == '@') ADVANCE(665);
      if (lookahead == '\\') ADVANCE(462);
      if (lookahead == '_') ADVANCE(518);
      if (lookahead == 'm') ADVANCE(569);
      if (lookahead == 'w') ADVANCE(552);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == 955) ADVANCE(464);
      if (lookahead == 8230) ADVANCE(467);
      if (lookahead == 8594) ADVANCE(460);
      if (lookahead == 8704) ADVANCE(454);
      if (lookahead == 10627) ADVANCE(512);
      if (lookahead == 10631) ADVANCE(674);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(136)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (lookahead != 0 &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != '}') ADVANCE(589);
      END_STATE();
    case 137:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '(') ADVANCE(497);
      if (lookahead == '-') ADVANCE(533);
      if (lookahead == '.') ADVANCE(658);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == ':') ADVANCE(470);
      if (lookahead == ';') ADVANCE(506);
      if (lookahead == '=') ADVANCE(473);
      if (lookahead == '@') ADVANCE(665);
      if (lookahead == '\\') ADVANCE(462);
      if (lookahead == '_') ADVANCE(518);
      if (lookahead == 'm') ADVANCE(569);
      if (lookahead == 'w') ADVANCE(553);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == '|') ADVANCE(668);
      if (lookahead == 955) ADVANCE(464);
      if (lookahead == 8230) ADVANCE(467);
      if (lookahead == 8594) ADVANCE(460);
      if (lookahead == 8704) ADVANCE(454);
      if (lookahead == 10627) ADVANCE(512);
      if (lookahead == 10631) ADVANCE(674);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(137)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (lookahead != 0 &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != '}') ADVANCE(589);
      END_STATE();
    case 138:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '(') ADVANCE(497);
      if (lookahead == '-') ADVANCE(533);
      if (lookahead == '.') ADVANCE(658);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == ':') ADVANCE(470);
      if (lookahead == ';') ADVANCE(506);
      if (lookahead == '=') ADVANCE(473);
      if (lookahead == '@') ADVANCE(665);
      if (lookahead == '\\') ADVANCE(462);
      if (lookahead == '_') ADVANCE(518);
      if (lookahead == 'm') ADVANCE(569);
      if (lookahead == 'w') ADVANCE(553);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == 955) ADVANCE(464);
      if (lookahead == 8230) ADVANCE(467);
      if (lookahead == 8594) ADVANCE(460);
      if (lookahead == 8704) ADVANCE(454);
      if (lookahead == 10627) ADVANCE(512);
      if (lookahead == 10631) ADVANCE(674);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(138)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (lookahead != 0 &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != '}') ADVANCE(589);
      END_STATE();
    case 139:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '(') ADVANCE(497);
      if (lookahead == '-') ADVANCE(533);
      if (lookahead == '.') ADVANCE(658);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == ':') ADVANCE(470);
      if (lookahead == ';') ADVANCE(506);
      if (lookahead == '=') ADVANCE(473);
      if (lookahead == '@') ADVANCE(665);
      if (lookahead == '\\') ADVANCE(462);
      if (lookahead == '_') ADVANCE(518);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == '|') ADVANCE(668);
      if (lookahead == '}') ADVANCE(527);
      if (lookahead == 955) ADVANCE(464);
      if (lookahead == 8230) ADVANCE(467);
      if (lookahead == 8594) ADVANCE(460);
      if (lookahead == 8704) ADVANCE(454);
      if (lookahead == 10627) ADVANCE(512);
      if (lookahead == 10631) ADVANCE(674);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(139)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (lookahead != 0 &&
          (lookahead < '\'' || ')' < lookahead)) ADVANCE(589);
      END_STATE();
    case 140:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '(') ADVANCE(497);
      if (lookahead == '-') ADVANCE(533);
      if (lookahead == '.') ADVANCE(658);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == ':') ADVANCE(470);
      if (lookahead == ';') ADVANCE(506);
      if (lookahead == '=') ADVANCE(473);
      if (lookahead == '@') ADVANCE(665);
      if (lookahead == '\\') ADVANCE(462);
      if (lookahead == '_') ADVANCE(518);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == '|') ADVANCE(668);
      if (lookahead == 955) ADVANCE(464);
      if (lookahead == 8230) ADVANCE(467);
      if (lookahead == 8594) ADVANCE(460);
      if (lookahead == 8704) ADVANCE(454);
      if (lookahead == 10627) ADVANCE(512);
      if (lookahead == 10628) ADVANCE(515);
      if (lookahead == 10631) ADVANCE(674);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(140)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (lookahead != 0 &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != '}') ADVANCE(589);
      END_STATE();
    case 141:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '(') ADVANCE(497);
      if (lookahead == '-') ADVANCE(533);
      if (lookahead == '.') ADVANCE(658);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == ':') ADVANCE(470);
      if (lookahead == ';') ADVANCE(506);
      if (lookahead == '=') ADVANCE(473);
      if (lookahead == '@') ADVANCE(665);
      if (lookahead == '\\') ADVANCE(462);
      if (lookahead == '_') ADVANCE(518);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == 955) ADVANCE(464);
      if (lookahead == 8230) ADVANCE(467);
      if (lookahead == 8594) ADVANCE(460);
      if (lookahead == 8704) ADVANCE(454);
      if (lookahead == 10627) ADVANCE(512);
      if (lookahead == 10628) ADVANCE(515);
      if (lookahead == 10631) ADVANCE(674);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(141)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (lookahead != 0 &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != '}') ADVANCE(589);
      END_STATE();
    case 142:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '(') ADVANCE(497);
      if (lookahead == '-') ADVANCE(533);
      if (lookahead == '.') ADVANCE(658);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == ':') ADVANCE(470);
      if (lookahead == ';') ADVANCE(506);
      if (lookahead == '@') ADVANCE(665);
      if (lookahead == '\\') ADVANCE(462);
      if (lookahead == '_') ADVANCE(518);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == '}') ADVANCE(444);
      if (lookahead == 955) ADVANCE(464);
      if (lookahead == 8230) ADVANCE(467);
      if (lookahead == 8594) ADVANCE(460);
      if (lookahead == 8704) ADVANCE(454);
      if (lookahead == 10627) ADVANCE(512);
      if (lookahead == 10631) ADVANCE(674);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(142)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (lookahead != 0 &&
          (lookahead < '\'' || ')' < lookahead)) ADVANCE(589);
      END_STATE();
    case 143:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '(') ADVANCE(497);
      if (lookahead == '-') ADVANCE(533);
      if (lookahead == '.') ADVANCE(658);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == ':') ADVANCE(470);
      if (lookahead == ';') ADVANCE(506);
      if (lookahead == '@') ADVANCE(665);
      if (lookahead == '\\') ADVANCE(462);
      if (lookahead == '_') ADVANCE(518);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == 955) ADVANCE(464);
      if (lookahead == 8230) ADVANCE(467);
      if (lookahead == 8594) ADVANCE(460);
      if (lookahead == 8704) ADVANCE(454);
      if (lookahead == 10627) ADVANCE(512);
      if (lookahead == 10628) ADVANCE(515);
      if (lookahead == 10631) ADVANCE(674);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(143)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (lookahead != 0 &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != '}') ADVANCE(589);
      END_STATE();
    case 144:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '(') ADVANCE(497);
      if (lookahead == '-') ADVANCE(533);
      if (lookahead == '.') ADVANCE(658);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == ':') ADVANCE(470);
      if (lookahead == ';') ADVANCE(654);
      if (lookahead == '=') ADVANCE(473);
      if (lookahead == '@') ADVANCE(665);
      if (lookahead == '\\') ADVANCE(462);
      if (lookahead == '_') ADVANCE(518);
      if (lookahead == 'i') ADVANCE(564);
      if (lookahead == 'm') ADVANCE(569);
      if (lookahead == 'r') ADVANCE(543);
      if (lookahead == 'w') ADVANCE(552);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == '|') ADVANCE(668);
      if (lookahead == 955) ADVANCE(464);
      if (lookahead == 8230) ADVANCE(467);
      if (lookahead == 8594) ADVANCE(460);
      if (lookahead == 8704) ADVANCE(454);
      if (lookahead == 10627) ADVANCE(512);
      if (lookahead == 10631) ADVANCE(674);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(144)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (lookahead != 0 &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != '}') ADVANCE(589);
      END_STATE();
    case 145:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '(') ADVANCE(497);
      if (lookahead == '-') ADVANCE(533);
      if (lookahead == '.') ADVANCE(658);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == ':') ADVANCE(470);
      if (lookahead == ';') ADVANCE(654);
      if (lookahead == '=') ADVANCE(473);
      if (lookahead == '@') ADVANCE(665);
      if (lookahead == '\\') ADVANCE(462);
      if (lookahead == '_') ADVANCE(518);
      if (lookahead == 'i') ADVANCE(564);
      if (lookahead == 'm') ADVANCE(569);
      if (lookahead == 'w') ADVANCE(552);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == '|') ADVANCE(668);
      if (lookahead == 955) ADVANCE(464);
      if (lookahead == 8230) ADVANCE(467);
      if (lookahead == 8594) ADVANCE(460);
      if (lookahead == 8704) ADVANCE(454);
      if (lookahead == 10627) ADVANCE(512);
      if (lookahead == 10631) ADVANCE(674);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(145)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (lookahead != 0 &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != '}') ADVANCE(589);
      END_STATE();
    case 146:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '(') ADVANCE(497);
      if (lookahead == '-') ADVANCE(533);
      if (lookahead == '.') ADVANCE(658);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == ':') ADVANCE(470);
      if (lookahead == ';') ADVANCE(654);
      if (lookahead == '=') ADVANCE(473);
      if (lookahead == '@') ADVANCE(665);
      if (lookahead == '\\') ADVANCE(462);
      if (lookahead == '_') ADVANCE(518);
      if (lookahead == 'i') ADVANCE(564);
      if (lookahead == 'm') ADVANCE(569);
      if (lookahead == 'w') ADVANCE(553);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == '|') ADVANCE(668);
      if (lookahead == 955) ADVANCE(464);
      if (lookahead == 8230) ADVANCE(467);
      if (lookahead == 8594) ADVANCE(460);
      if (lookahead == 8704) ADVANCE(454);
      if (lookahead == 10627) ADVANCE(512);
      if (lookahead == 10631) ADVANCE(674);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(146)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (lookahead != 0 &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != '}') ADVANCE(589);
      END_STATE();
    case 147:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '(') ADVANCE(497);
      if (lookahead == '-') ADVANCE(533);
      if (lookahead == '.') ADVANCE(658);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == ':') ADVANCE(470);
      if (lookahead == ';') ADVANCE(654);
      if (lookahead == '=') ADVANCE(473);
      if (lookahead == '@') ADVANCE(665);
      if (lookahead == '\\') ADVANCE(462);
      if (lookahead == '_') ADVANCE(518);
      if (lookahead == 'm') ADVANCE(569);
      if (lookahead == 'r') ADVANCE(543);
      if (lookahead == 'w') ADVANCE(552);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == '|') ADVANCE(668);
      if (lookahead == 955) ADVANCE(464);
      if (lookahead == 8230) ADVANCE(467);
      if (lookahead == 8594) ADVANCE(460);
      if (lookahead == 8704) ADVANCE(454);
      if (lookahead == 10627) ADVANCE(512);
      if (lookahead == 10631) ADVANCE(674);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(147)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (lookahead != 0 &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != '}') ADVANCE(589);
      END_STATE();
    case 148:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '(') ADVANCE(497);
      if (lookahead == '-') ADVANCE(533);
      if (lookahead == '.') ADVANCE(658);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == ':') ADVANCE(470);
      if (lookahead == ';') ADVANCE(654);
      if (lookahead == '=') ADVANCE(473);
      if (lookahead == '@') ADVANCE(665);
      if (lookahead == '\\') ADVANCE(462);
      if (lookahead == '_') ADVANCE(518);
      if (lookahead == 'm') ADVANCE(569);
      if (lookahead == 'w') ADVANCE(552);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == '|') ADVANCE(668);
      if (lookahead == 955) ADVANCE(464);
      if (lookahead == 8230) ADVANCE(467);
      if (lookahead == 8594) ADVANCE(460);
      if (lookahead == 8704) ADVANCE(454);
      if (lookahead == 10627) ADVANCE(512);
      if (lookahead == 10631) ADVANCE(674);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(148)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (lookahead != 0 &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != '}') ADVANCE(589);
      END_STATE();
    case 149:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '(') ADVANCE(497);
      if (lookahead == '-') ADVANCE(533);
      if (lookahead == '.') ADVANCE(658);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == ':') ADVANCE(470);
      if (lookahead == ';') ADVANCE(654);
      if (lookahead == '=') ADVANCE(473);
      if (lookahead == '@') ADVANCE(665);
      if (lookahead == '\\') ADVANCE(462);
      if (lookahead == '_') ADVANCE(518);
      if (lookahead == 'm') ADVANCE(569);
      if (lookahead == 'w') ADVANCE(553);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == '|') ADVANCE(668);
      if (lookahead == 955) ADVANCE(464);
      if (lookahead == 8230) ADVANCE(467);
      if (lookahead == 8594) ADVANCE(460);
      if (lookahead == 8704) ADVANCE(454);
      if (lookahead == 10627) ADVANCE(512);
      if (lookahead == 10631) ADVANCE(674);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(149)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (lookahead != 0 &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != '}') ADVANCE(589);
      END_STATE();
    case 150:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '(') ADVANCE(497);
      if (lookahead == '-') ADVANCE(533);
      if (lookahead == '.') ADVANCE(658);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == ':') ADVANCE(470);
      if (lookahead == ';') ADVANCE(654);
      if (lookahead == '=') ADVANCE(473);
      if (lookahead == '@') ADVANCE(665);
      if (lookahead == '\\') ADVANCE(462);
      if (lookahead == '_') ADVANCE(518);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == '|') ADVANCE(668);
      if (lookahead == '}') ADVANCE(527);
      if (lookahead == 955) ADVANCE(464);
      if (lookahead == 8230) ADVANCE(467);
      if (lookahead == 8594) ADVANCE(460);
      if (lookahead == 8704) ADVANCE(454);
      if (lookahead == 10627) ADVANCE(512);
      if (lookahead == 10631) ADVANCE(674);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(150)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (lookahead != 0 &&
          (lookahead < '\'' || ')' < lookahead)) ADVANCE(589);
      END_STATE();
    case 151:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '(') ADVANCE(497);
      if (lookahead == '-') ADVANCE(533);
      if (lookahead == '.') ADVANCE(658);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == ':') ADVANCE(470);
      if (lookahead == ';') ADVANCE(654);
      if (lookahead == '=') ADVANCE(473);
      if (lookahead == '@') ADVANCE(665);
      if (lookahead == '\\') ADVANCE(462);
      if (lookahead == '_') ADVANCE(518);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == '|') ADVANCE(668);
      if (lookahead == 955) ADVANCE(464);
      if (lookahead == 8230) ADVANCE(467);
      if (lookahead == 8594) ADVANCE(460);
      if (lookahead == 8704) ADVANCE(454);
      if (lookahead == 10627) ADVANCE(512);
      if (lookahead == 10628) ADVANCE(515);
      if (lookahead == 10631) ADVANCE(674);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(151)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (lookahead != 0 &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != '}') ADVANCE(589);
      END_STATE();
    case 152:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '(') ADVANCE(497);
      if (lookahead == '-') ADVANCE(533);
      if (lookahead == '.') ADVANCE(658);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == ':') ADVANCE(470);
      if (lookahead == ';') ADVANCE(654);
      if (lookahead == '=') ADVANCE(473);
      if (lookahead == '@') ADVANCE(665);
      if (lookahead == '\\') ADVANCE(462);
      if (lookahead == '_') ADVANCE(518);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == 955) ADVANCE(464);
      if (lookahead == 8230) ADVANCE(467);
      if (lookahead == 8594) ADVANCE(460);
      if (lookahead == 8704) ADVANCE(454);
      if (lookahead == 10627) ADVANCE(512);
      if (lookahead == 10631) ADVANCE(674);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(152)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (lookahead != 0 &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != '}') ADVANCE(589);
      END_STATE();
    case 153:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '(') ADVANCE(497);
      if (lookahead == '-') ADVANCE(533);
      if (lookahead == '.') ADVANCE(658);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == ':') ADVANCE(470);
      if (lookahead == ';') ADVANCE(654);
      if (lookahead == '@') ADVANCE(665);
      if (lookahead == '\\') ADVANCE(462);
      if (lookahead == '_') ADVANCE(518);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == 955) ADVANCE(464);
      if (lookahead == 8230) ADVANCE(467);
      if (lookahead == 8594) ADVANCE(460);
      if (lookahead == 8704) ADVANCE(454);
      if (lookahead == 10627) ADVANCE(512);
      if (lookahead == 10631) ADVANCE(674);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(153)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (lookahead != 0 &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != '}') ADVANCE(589);
      END_STATE();
    case 154:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '(') ADVANCE(497);
      if (lookahead == '-') ADVANCE(533);
      if (lookahead == '.') ADVANCE(658);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == ';') ADVANCE(506);
      if (lookahead == '=') ADVANCE(473);
      if (lookahead == '@') ADVANCE(665);
      if (lookahead == '\\') ADVANCE(462);
      if (lookahead == '_') ADVANCE(518);
      if (lookahead == 'i') ADVANCE(564);
      if (lookahead == 'm') ADVANCE(569);
      if (lookahead == 'w') ADVANCE(553);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == '|') ADVANCE(668);
      if (lookahead == 955) ADVANCE(464);
      if (lookahead == 8230) ADVANCE(467);
      if (lookahead == 8594) ADVANCE(460);
      if (lookahead == 8704) ADVANCE(454);
      if (lookahead == 10627) ADVANCE(512);
      if (lookahead == 10631) ADVANCE(674);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(154)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (lookahead != 0 &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != '}') ADVANCE(589);
      END_STATE();
    case 155:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '(') ADVANCE(497);
      if (lookahead == '-') ADVANCE(533);
      if (lookahead == '.') ADVANCE(658);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == ';') ADVANCE(506);
      if (lookahead == '=') ADVANCE(473);
      if (lookahead == '@') ADVANCE(665);
      if (lookahead == '\\') ADVANCE(462);
      if (lookahead == '_') ADVANCE(518);
      if (lookahead == 'i') ADVANCE(564);
      if (lookahead == 'm') ADVANCE(569);
      if (lookahead == 'w') ADVANCE(553);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == 955) ADVANCE(464);
      if (lookahead == 8230) ADVANCE(467);
      if (lookahead == 8594) ADVANCE(460);
      if (lookahead == 8704) ADVANCE(454);
      if (lookahead == 10627) ADVANCE(512);
      if (lookahead == 10631) ADVANCE(674);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(155)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (lookahead != 0 &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != '}') ADVANCE(589);
      END_STATE();
    case 156:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '(') ADVANCE(497);
      if (lookahead == '-') ADVANCE(533);
      if (lookahead == '.') ADVANCE(658);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == ';') ADVANCE(506);
      if (lookahead == '=') ADVANCE(473);
      if (lookahead == '@') ADVANCE(665);
      if (lookahead == '\\') ADVANCE(462);
      if (lookahead == '_') ADVANCE(518);
      if (lookahead == 'i') ADVANCE(564);
      if (lookahead == 'w') ADVANCE(553);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == '|') ADVANCE(668);
      if (lookahead == 955) ADVANCE(464);
      if (lookahead == 8230) ADVANCE(467);
      if (lookahead == 8594) ADVANCE(460);
      if (lookahead == 8704) ADVANCE(454);
      if (lookahead == 10627) ADVANCE(512);
      if (lookahead == 10631) ADVANCE(674);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(156)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (lookahead != 0 &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != '}') ADVANCE(589);
      END_STATE();
    case 157:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '(') ADVANCE(497);
      if (lookahead == '-') ADVANCE(533);
      if (lookahead == '.') ADVANCE(658);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == ';') ADVANCE(506);
      if (lookahead == '=') ADVANCE(473);
      if (lookahead == '@') ADVANCE(665);
      if (lookahead == '\\') ADVANCE(462);
      if (lookahead == '_') ADVANCE(518);
      if (lookahead == 'i') ADVANCE(564);
      if (lookahead == 'w') ADVANCE(553);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == 955) ADVANCE(464);
      if (lookahead == 8230) ADVANCE(467);
      if (lookahead == 8594) ADVANCE(460);
      if (lookahead == 8704) ADVANCE(454);
      if (lookahead == 10627) ADVANCE(512);
      if (lookahead == 10631) ADVANCE(674);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(157)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (lookahead != 0 &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != '}') ADVANCE(589);
      END_STATE();
    case 158:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '(') ADVANCE(497);
      if (lookahead == '-') ADVANCE(533);
      if (lookahead == '.') ADVANCE(658);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == ';') ADVANCE(506);
      if (lookahead == '=') ADVANCE(473);
      if (lookahead == '@') ADVANCE(665);
      if (lookahead == '\\') ADVANCE(462);
      if (lookahead == '_') ADVANCE(518);
      if (lookahead == 'i') ADVANCE(564);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == '|') ADVANCE(668);
      if (lookahead == 955) ADVANCE(464);
      if (lookahead == 8230) ADVANCE(467);
      if (lookahead == 8594) ADVANCE(460);
      if (lookahead == 8704) ADVANCE(454);
      if (lookahead == 10627) ADVANCE(512);
      if (lookahead == 10631) ADVANCE(674);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(158)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (lookahead != 0 &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != '}') ADVANCE(589);
      END_STATE();
    case 159:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '(') ADVANCE(497);
      if (lookahead == '-') ADVANCE(533);
      if (lookahead == '.') ADVANCE(658);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == ';') ADVANCE(506);
      if (lookahead == '=') ADVANCE(473);
      if (lookahead == '@') ADVANCE(665);
      if (lookahead == '\\') ADVANCE(462);
      if (lookahead == '_') ADVANCE(518);
      if (lookahead == 'i') ADVANCE(564);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == 955) ADVANCE(464);
      if (lookahead == 8230) ADVANCE(467);
      if (lookahead == 8594) ADVANCE(460);
      if (lookahead == 8704) ADVANCE(454);
      if (lookahead == 10627) ADVANCE(512);
      if (lookahead == 10631) ADVANCE(674);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(159)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (lookahead != 0 &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != '}') ADVANCE(589);
      END_STATE();
    case 160:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '(') ADVANCE(497);
      if (lookahead == '-') ADVANCE(533);
      if (lookahead == '.') ADVANCE(658);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == ';') ADVANCE(506);
      if (lookahead == '=') ADVANCE(473);
      if (lookahead == '@') ADVANCE(665);
      if (lookahead == '\\') ADVANCE(462);
      if (lookahead == '_') ADVANCE(518);
      if (lookahead == 'm') ADVANCE(569);
      if (lookahead == 'w') ADVANCE(553);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == '|') ADVANCE(668);
      if (lookahead == 955) ADVANCE(464);
      if (lookahead == 8230) ADVANCE(467);
      if (lookahead == 8594) ADVANCE(460);
      if (lookahead == 8704) ADVANCE(454);
      if (lookahead == 10627) ADVANCE(512);
      if (lookahead == 10631) ADVANCE(674);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(160)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (lookahead != 0 &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != '}') ADVANCE(589);
      END_STATE();
    case 161:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '(') ADVANCE(497);
      if (lookahead == '-') ADVANCE(533);
      if (lookahead == '.') ADVANCE(658);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == ';') ADVANCE(506);
      if (lookahead == '=') ADVANCE(473);
      if (lookahead == '@') ADVANCE(665);
      if (lookahead == '\\') ADVANCE(462);
      if (lookahead == '_') ADVANCE(518);
      if (lookahead == 'm') ADVANCE(569);
      if (lookahead == 'w') ADVANCE(553);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == 955) ADVANCE(464);
      if (lookahead == 8230) ADVANCE(467);
      if (lookahead == 8594) ADVANCE(460);
      if (lookahead == 8704) ADVANCE(454);
      if (lookahead == 10627) ADVANCE(512);
      if (lookahead == 10631) ADVANCE(674);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(161)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (lookahead != 0 &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != '}') ADVANCE(589);
      END_STATE();
    case 162:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '(') ADVANCE(497);
      if (lookahead == '-') ADVANCE(533);
      if (lookahead == '.') ADVANCE(658);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == ';') ADVANCE(506);
      if (lookahead == '=') ADVANCE(473);
      if (lookahead == '@') ADVANCE(665);
      if (lookahead == '\\') ADVANCE(462);
      if (lookahead == '_') ADVANCE(518);
      if (lookahead == 'w') ADVANCE(553);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == '|') ADVANCE(668);
      if (lookahead == 955) ADVANCE(464);
      if (lookahead == 8230) ADVANCE(467);
      if (lookahead == 8594) ADVANCE(460);
      if (lookahead == 8704) ADVANCE(454);
      if (lookahead == 10627) ADVANCE(512);
      if (lookahead == 10631) ADVANCE(674);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(162)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (lookahead != 0 &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != '}') ADVANCE(589);
      END_STATE();
    case 163:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '(') ADVANCE(497);
      if (lookahead == '-') ADVANCE(533);
      if (lookahead == '.') ADVANCE(658);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == ';') ADVANCE(506);
      if (lookahead == '=') ADVANCE(473);
      if (lookahead == '@') ADVANCE(665);
      if (lookahead == '\\') ADVANCE(462);
      if (lookahead == '_') ADVANCE(518);
      if (lookahead == 'w') ADVANCE(553);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == 955) ADVANCE(464);
      if (lookahead == 8230) ADVANCE(467);
      if (lookahead == 8594) ADVANCE(460);
      if (lookahead == 8704) ADVANCE(454);
      if (lookahead == 10627) ADVANCE(512);
      if (lookahead == 10631) ADVANCE(674);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(163)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (lookahead != 0 &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != '}') ADVANCE(589);
      END_STATE();
    case 164:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '(') ADVANCE(497);
      if (lookahead == '-') ADVANCE(533);
      if (lookahead == '.') ADVANCE(658);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == ';') ADVANCE(506);
      if (lookahead == '=') ADVANCE(473);
      if (lookahead == '@') ADVANCE(665);
      if (lookahead == '\\') ADVANCE(462);
      if (lookahead == '_') ADVANCE(518);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == '|') ADVANCE(668);
      if (lookahead == '}') ADVANCE(444);
      if (lookahead == 955) ADVANCE(464);
      if (lookahead == 8230) ADVANCE(467);
      if (lookahead == 8594) ADVANCE(460);
      if (lookahead == 8704) ADVANCE(454);
      if (lookahead == 10627) ADVANCE(512);
      if (lookahead == 10631) ADVANCE(674);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(164)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (lookahead != 0 &&
          (lookahead < '\'' || ')' < lookahead)) ADVANCE(589);
      END_STATE();
    case 165:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '(') ADVANCE(497);
      if (lookahead == '-') ADVANCE(533);
      if (lookahead == '.') ADVANCE(658);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == ';') ADVANCE(506);
      if (lookahead == '=') ADVANCE(473);
      if (lookahead == '@') ADVANCE(665);
      if (lookahead == '\\') ADVANCE(462);
      if (lookahead == '_') ADVANCE(518);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == '|') ADVANCE(668);
      if (lookahead == 955) ADVANCE(464);
      if (lookahead == 8230) ADVANCE(467);
      if (lookahead == 8594) ADVANCE(460);
      if (lookahead == 8704) ADVANCE(454);
      if (lookahead == 10627) ADVANCE(512);
      if (lookahead == 10628) ADVANCE(515);
      if (lookahead == 10631) ADVANCE(674);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(165)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (lookahead != 0 &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != '}') ADVANCE(589);
      END_STATE();
    case 166:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '(') ADVANCE(497);
      if (lookahead == '-') ADVANCE(533);
      if (lookahead == '.') ADVANCE(658);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == ';') ADVANCE(506);
      if (lookahead == '=') ADVANCE(473);
      if (lookahead == '@') ADVANCE(665);
      if (lookahead == '\\') ADVANCE(462);
      if (lookahead == '_') ADVANCE(518);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == '|') ADVANCE(668);
      if (lookahead == 955) ADVANCE(464);
      if (lookahead == 8230) ADVANCE(467);
      if (lookahead == 8594) ADVANCE(460);
      if (lookahead == 8704) ADVANCE(454);
      if (lookahead == 10627) ADVANCE(512);
      if (lookahead == 10631) ADVANCE(674);
      if (lookahead == 10632) ADVANCE(677);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(166)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (lookahead != 0 &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != '}') ADVANCE(589);
      END_STATE();
    case 167:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '(') ADVANCE(497);
      if (lookahead == '-') ADVANCE(533);
      if (lookahead == '.') ADVANCE(658);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == ';') ADVANCE(506);
      if (lookahead == '=') ADVANCE(473);
      if (lookahead == '@') ADVANCE(665);
      if (lookahead == '\\') ADVANCE(462);
      if (lookahead == '_') ADVANCE(518);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == '|') ADVANCE(666);
      if (lookahead == 955) ADVANCE(464);
      if (lookahead == 8230) ADVANCE(467);
      if (lookahead == 8594) ADVANCE(460);
      if (lookahead == 8704) ADVANCE(454);
      if (lookahead == 10627) ADVANCE(512);
      if (lookahead == 10631) ADVANCE(674);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(167)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (lookahead != 0 &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != '}') ADVANCE(589);
      END_STATE();
    case 168:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '(') ADVANCE(497);
      if (lookahead == '-') ADVANCE(533);
      if (lookahead == '.') ADVANCE(658);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == ';') ADVANCE(506);
      if (lookahead == '=') ADVANCE(473);
      if (lookahead == '@') ADVANCE(665);
      if (lookahead == '\\') ADVANCE(462);
      if (lookahead == '_') ADVANCE(518);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == '|') ADVANCE(528);
      if (lookahead == 955) ADVANCE(464);
      if (lookahead == 8230) ADVANCE(467);
      if (lookahead == 8594) ADVANCE(460);
      if (lookahead == 8704) ADVANCE(454);
      if (lookahead == 10627) ADVANCE(512);
      if (lookahead == 10631) ADVANCE(674);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(168)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (lookahead != 0 &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != '}') ADVANCE(589);
      END_STATE();
    case 169:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '(') ADVANCE(497);
      if (lookahead == '-') ADVANCE(533);
      if (lookahead == '.') ADVANCE(658);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == ';') ADVANCE(506);
      if (lookahead == '=') ADVANCE(473);
      if (lookahead == '@') ADVANCE(665);
      if (lookahead == '\\') ADVANCE(462);
      if (lookahead == '_') ADVANCE(518);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == '}') ADVANCE(527);
      if (lookahead == 955) ADVANCE(464);
      if (lookahead == 8230) ADVANCE(467);
      if (lookahead == 8594) ADVANCE(460);
      if (lookahead == 8704) ADVANCE(454);
      if (lookahead == 10627) ADVANCE(512);
      if (lookahead == 10631) ADVANCE(674);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(169)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (lookahead != 0 &&
          (lookahead < '\'' || ')' < lookahead)) ADVANCE(589);
      END_STATE();
    case 170:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '(') ADVANCE(497);
      if (lookahead == '-') ADVANCE(533);
      if (lookahead == '.') ADVANCE(658);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == ';') ADVANCE(506);
      if (lookahead == '=') ADVANCE(473);
      if (lookahead == '@') ADVANCE(665);
      if (lookahead == '\\') ADVANCE(462);
      if (lookahead == '_') ADVANCE(518);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == 955) ADVANCE(464);
      if (lookahead == 8230) ADVANCE(467);
      if (lookahead == 8594) ADVANCE(460);
      if (lookahead == 8704) ADVANCE(454);
      if (lookahead == 10627) ADVANCE(512);
      if (lookahead == 10628) ADVANCE(515);
      if (lookahead == 10631) ADVANCE(674);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(170)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (lookahead != 0 &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != '}') ADVANCE(589);
      END_STATE();
    case 171:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '(') ADVANCE(497);
      if (lookahead == '-') ADVANCE(533);
      if (lookahead == '.') ADVANCE(658);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == ';') ADVANCE(506);
      if (lookahead == '=') ADVANCE(473);
      if (lookahead == '@') ADVANCE(665);
      if (lookahead == '\\') ADVANCE(462);
      if (lookahead == '_') ADVANCE(518);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == 955) ADVANCE(464);
      if (lookahead == 8230) ADVANCE(467);
      if (lookahead == 8594) ADVANCE(460);
      if (lookahead == 8704) ADVANCE(454);
      if (lookahead == 10627) ADVANCE(512);
      if (lookahead == 10631) ADVANCE(674);
      if (lookahead == 10632) ADVANCE(677);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(171)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (lookahead != 0 &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != '}') ADVANCE(589);
      END_STATE();
    case 172:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '(') ADVANCE(497);
      if (lookahead == '-') ADVANCE(533);
      if (lookahead == '.') ADVANCE(658);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == ';') ADVANCE(506);
      if (lookahead == '@') ADVANCE(665);
      if (lookahead == '\\') ADVANCE(462);
      if (lookahead == '_') ADVANCE(518);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == '}') ADVANCE(527);
      if (lookahead == 955) ADVANCE(464);
      if (lookahead == 8230) ADVANCE(467);
      if (lookahead == 8594) ADVANCE(460);
      if (lookahead == 8704) ADVANCE(454);
      if (lookahead == 10627) ADVANCE(512);
      if (lookahead == 10631) ADVANCE(674);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(172)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (lookahead != 0 &&
          (lookahead < '\'' || ')' < lookahead)) ADVANCE(589);
      END_STATE();
    case 173:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '(') ADVANCE(497);
      if (lookahead == '-') ADVANCE(533);
      if (lookahead == '.') ADVANCE(658);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == ';') ADVANCE(654);
      if (lookahead == '=') ADVANCE(473);
      if (lookahead == '@') ADVANCE(665);
      if (lookahead == '\\') ADVANCE(462);
      if (lookahead == '_') ADVANCE(518);
      if (lookahead == 'i') ADVANCE(564);
      if (lookahead == 'm') ADVANCE(569);
      if (lookahead == 'w') ADVANCE(553);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == '|') ADVANCE(668);
      if (lookahead == 955) ADVANCE(464);
      if (lookahead == 8230) ADVANCE(467);
      if (lookahead == 8594) ADVANCE(460);
      if (lookahead == 8704) ADVANCE(454);
      if (lookahead == 10627) ADVANCE(512);
      if (lookahead == 10631) ADVANCE(674);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(173)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (lookahead != 0 &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != '}') ADVANCE(589);
      END_STATE();
    case 174:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '(') ADVANCE(497);
      if (lookahead == '-') ADVANCE(533);
      if (lookahead == '.') ADVANCE(658);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == ';') ADVANCE(654);
      if (lookahead == '=') ADVANCE(473);
      if (lookahead == '@') ADVANCE(665);
      if (lookahead == '\\') ADVANCE(462);
      if (lookahead == '_') ADVANCE(518);
      if (lookahead == 'i') ADVANCE(564);
      if (lookahead == 'w') ADVANCE(553);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == '|') ADVANCE(668);
      if (lookahead == 955) ADVANCE(464);
      if (lookahead == 8230) ADVANCE(467);
      if (lookahead == 8594) ADVANCE(460);
      if (lookahead == 8704) ADVANCE(454);
      if (lookahead == 10627) ADVANCE(512);
      if (lookahead == 10631) ADVANCE(674);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(174)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (lookahead != 0 &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != '}') ADVANCE(589);
      END_STATE();
    case 175:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '(') ADVANCE(497);
      if (lookahead == '-') ADVANCE(533);
      if (lookahead == '.') ADVANCE(658);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == ';') ADVANCE(654);
      if (lookahead == '=') ADVANCE(473);
      if (lookahead == '@') ADVANCE(665);
      if (lookahead == '\\') ADVANCE(462);
      if (lookahead == '_') ADVANCE(518);
      if (lookahead == 'i') ADVANCE(564);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == '|') ADVANCE(668);
      if (lookahead == 955) ADVANCE(464);
      if (lookahead == 8230) ADVANCE(467);
      if (lookahead == 8594) ADVANCE(460);
      if (lookahead == 8704) ADVANCE(454);
      if (lookahead == 10627) ADVANCE(512);
      if (lookahead == 10631) ADVANCE(674);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(175)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (lookahead != 0 &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != '}') ADVANCE(589);
      END_STATE();
    case 176:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '(') ADVANCE(497);
      if (lookahead == '-') ADVANCE(533);
      if (lookahead == '.') ADVANCE(658);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == ';') ADVANCE(654);
      if (lookahead == '=') ADVANCE(473);
      if (lookahead == '@') ADVANCE(665);
      if (lookahead == '\\') ADVANCE(462);
      if (lookahead == '_') ADVANCE(518);
      if (lookahead == 'm') ADVANCE(569);
      if (lookahead == 'w') ADVANCE(553);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == '|') ADVANCE(668);
      if (lookahead == 955) ADVANCE(464);
      if (lookahead == 8230) ADVANCE(467);
      if (lookahead == 8594) ADVANCE(460);
      if (lookahead == 8704) ADVANCE(454);
      if (lookahead == 10627) ADVANCE(512);
      if (lookahead == 10631) ADVANCE(674);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(176)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (lookahead != 0 &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != '}') ADVANCE(589);
      END_STATE();
    case 177:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '(') ADVANCE(497);
      if (lookahead == '-') ADVANCE(533);
      if (lookahead == '.') ADVANCE(658);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == ';') ADVANCE(654);
      if (lookahead == '=') ADVANCE(473);
      if (lookahead == '@') ADVANCE(665);
      if (lookahead == '\\') ADVANCE(462);
      if (lookahead == '_') ADVANCE(518);
      if (lookahead == 'w') ADVANCE(553);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == '|') ADVANCE(668);
      if (lookahead == 955) ADVANCE(464);
      if (lookahead == 8230) ADVANCE(467);
      if (lookahead == 8594) ADVANCE(460);
      if (lookahead == 8704) ADVANCE(454);
      if (lookahead == 10627) ADVANCE(512);
      if (lookahead == 10631) ADVANCE(674);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(177)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (lookahead != 0 &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != '}') ADVANCE(589);
      END_STATE();
    case 178:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '(') ADVANCE(497);
      if (lookahead == '-') ADVANCE(533);
      if (lookahead == '.') ADVANCE(658);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == ';') ADVANCE(654);
      if (lookahead == '=') ADVANCE(473);
      if (lookahead == '@') ADVANCE(665);
      if (lookahead == '\\') ADVANCE(462);
      if (lookahead == '_') ADVANCE(518);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == '|') ADVANCE(668);
      if (lookahead == '}') ADVANCE(527);
      if (lookahead == 955) ADVANCE(464);
      if (lookahead == 8230) ADVANCE(467);
      if (lookahead == 8594) ADVANCE(460);
      if (lookahead == 8704) ADVANCE(454);
      if (lookahead == 10627) ADVANCE(512);
      if (lookahead == 10631) ADVANCE(674);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(178)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (lookahead != 0 &&
          (lookahead < '\'' || ')' < lookahead)) ADVANCE(589);
      END_STATE();
    case 179:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '(') ADVANCE(497);
      if (lookahead == '-') ADVANCE(533);
      if (lookahead == '.') ADVANCE(658);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == ';') ADVANCE(654);
      if (lookahead == '=') ADVANCE(473);
      if (lookahead == '@') ADVANCE(665);
      if (lookahead == '\\') ADVANCE(462);
      if (lookahead == '_') ADVANCE(518);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == '|') ADVANCE(668);
      if (lookahead == 955) ADVANCE(464);
      if (lookahead == 8230) ADVANCE(467);
      if (lookahead == 8594) ADVANCE(460);
      if (lookahead == 8704) ADVANCE(454);
      if (lookahead == 10627) ADVANCE(512);
      if (lookahead == 10628) ADVANCE(515);
      if (lookahead == 10631) ADVANCE(674);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(179)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (lookahead != 0 &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != '}') ADVANCE(589);
      END_STATE();
    case 180:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '(') ADVANCE(497);
      if (lookahead == '-') ADVANCE(533);
      if (lookahead == '.') ADVANCE(658);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == ';') ADVANCE(654);
      if (lookahead == '=') ADVANCE(473);
      if (lookahead == '@') ADVANCE(665);
      if (lookahead == '\\') ADVANCE(462);
      if (lookahead == '_') ADVANCE(518);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == '|') ADVANCE(668);
      if (lookahead == 955) ADVANCE(464);
      if (lookahead == 8230) ADVANCE(467);
      if (lookahead == 8594) ADVANCE(460);
      if (lookahead == 8704) ADVANCE(454);
      if (lookahead == 10627) ADVANCE(512);
      if (lookahead == 10631) ADVANCE(674);
      if (lookahead == 10632) ADVANCE(677);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(180)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (lookahead != 0 &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != '}') ADVANCE(589);
      END_STATE();
    case 181:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '(') ADVANCE(497);
      if (lookahead == '-') ADVANCE(533);
      if (lookahead == '.') ADVANCE(658);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == ';') ADVANCE(654);
      if (lookahead == '=') ADVANCE(473);
      if (lookahead == '@') ADVANCE(665);
      if (lookahead == '\\') ADVANCE(462);
      if (lookahead == '_') ADVANCE(518);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == '|') ADVANCE(666);
      if (lookahead == 955) ADVANCE(464);
      if (lookahead == 8230) ADVANCE(467);
      if (lookahead == 8594) ADVANCE(460);
      if (lookahead == 8704) ADVANCE(454);
      if (lookahead == 10627) ADVANCE(512);
      if (lookahead == 10631) ADVANCE(674);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(181)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (lookahead != 0 &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != '}') ADVANCE(589);
      END_STATE();
    case 182:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '(') ADVANCE(497);
      if (lookahead == '-') ADVANCE(533);
      if (lookahead == '.') ADVANCE(658);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == ';') ADVANCE(654);
      if (lookahead == '@') ADVANCE(665);
      if (lookahead == '\\') ADVANCE(462);
      if (lookahead == '_') ADVANCE(518);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == '|') ADVANCE(668);
      if (lookahead == 955) ADVANCE(464);
      if (lookahead == 8230) ADVANCE(467);
      if (lookahead == 8594) ADVANCE(460);
      if (lookahead == 8704) ADVANCE(454);
      if (lookahead == 10627) ADVANCE(512);
      if (lookahead == 10631) ADVANCE(674);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(182)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (lookahead != 0 &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != '}') ADVANCE(589);
      END_STATE();
    case 183:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '(') ADVANCE(497);
      if (lookahead == '-') ADVANCE(533);
      if (lookahead == '.') ADVANCE(658);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == ';') ADVANCE(654);
      if (lookahead == '@') ADVANCE(665);
      if (lookahead == '\\') ADVANCE(462);
      if (lookahead == '_') ADVANCE(518);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == 955) ADVANCE(464);
      if (lookahead == 8230) ADVANCE(467);
      if (lookahead == 8594) ADVANCE(460);
      if (lookahead == 8704) ADVANCE(454);
      if (lookahead == 10627) ADVANCE(512);
      if (lookahead == 10631) ADVANCE(674);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(183)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (lookahead != 0 &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != '}') ADVANCE(589);
      END_STATE();
    case 184:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '(') ADVANCE(497);
      if (lookahead == '-') ADVANCE(533);
      if (lookahead == '.') ADVANCE(658);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == ';') ADVANCE(654);
      if (lookahead == '@') ADVANCE(665);
      if (lookahead == '\\') ADVANCE(324);
      if (lookahead == '_') ADVANCE(518);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == 8230) ADVANCE(467);
      if (lookahead == 8594) ADVANCE(460);
      if (lookahead == 10627) ADVANCE(512);
      if (lookahead == 10631) ADVANCE(674);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(184)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (lookahead != 0 &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != '}') ADVANCE(589);
      END_STATE();
    case 185:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '(') ADVANCE(497);
      if (lookahead == '-') ADVANCE(533);
      if (lookahead == '.') ADVANCE(658);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == ';') ADVANCE(654);
      if (lookahead == '\\') ADVANCE(462);
      if (lookahead == '_') ADVANCE(518);
      if (lookahead == '{') ADVANCE(524);
      if (lookahead == 955) ADVANCE(464);
      if (lookahead == 8230) ADVANCE(467);
      if (lookahead == 8594) ADVANCE(460);
      if (lookahead == 8704) ADVANCE(454);
      if (lookahead == 10627) ADVANCE(512);
      if (lookahead == 10631) ADVANCE(674);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(185)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (lookahead != 0 &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != '@' &&
          lookahead != '}') ADVANCE(589);
      END_STATE();
    case 186:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '(') ADVANCE(496);
      if (lookahead == '-') ADVANCE(534);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == ';') ADVANCE(654);
      if (lookahead == '\\') ADVANCE(382);
      if (lookahead == '_') ADVANCE(518);
      if (lookahead == '{') ADVANCE(260);
      if (lookahead == '}') ADVANCE(527);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(186)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (lookahead != 0 &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != '.' &&
          lookahead != '@') ADVANCE(589);
      END_STATE();
    case 187:
      if (lookahead == '"') ADVANCE(682);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(187);
      END_STATE();
    case 188:
      if (lookahead == '#') ADVANCE(520);
      if (lookahead == '-') ADVANCE(249);
      if (lookahead != 0) ADVANCE(250);
      END_STATE();
    case 189:
      if (lookahead == '#') ADVANCE(190);
      if (lookahead == '-') ADVANCE(249);
      if (lookahead != 0) ADVANCE(250);
      END_STATE();
    case 190:
      if (lookahead == '#') ADVANCE(261);
      if (lookahead != 0) ADVANCE(190);
      END_STATE();
    case 191:
      if (lookahead == '(') ADVANCE(496);
      if (lookahead == ')') ADVANCE(498);
      if (lookahead == '-') ADVANCE(531);
      if (lookahead == '.') ADVANCE(659);
      if (lookahead == ':') ADVANCE(471);
      if (lookahead == ';') ADVANCE(506);
      if (lookahead == '=') ADVANCE(474);
      if (lookahead == '\\') ADVANCE(347);
      if (lookahead == '_') ADVANCE(517);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == '}') ADVANCE(444);
      if (lookahead == 8594) ADVANCE(461);
      if (lookahead == 10627) ADVANCE(513);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(191)
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '\'' &&
          lookahead != '@') ADVANCE(654);
      END_STATE();
    case 192:
      if (lookahead == '(') ADVANCE(496);
      if (lookahead == ')') ADVANCE(498);
      if (lookahead == '-') ADVANCE(531);
      if (lookahead == '.') ADVANCE(659);
      if (lookahead == ':') ADVANCE(471);
      if (lookahead == ';') ADVANCE(506);
      if (lookahead == '\\') ADVANCE(357);
      if (lookahead == '_') ADVANCE(517);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == '}') ADVANCE(527);
      if (lookahead == 8594) ADVANCE(461);
      if (lookahead == 10627) ADVANCE(513);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(192)
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '\'' &&
          lookahead != '@') ADVANCE(654);
      END_STATE();
    case 193:
      if (lookahead == '(') ADVANCE(496);
      if (lookahead == ')') ADVANCE(498);
      if (lookahead == '-') ADVANCE(531);
      if (lookahead == '.') ADVANCE(659);
      if (lookahead == ':') ADVANCE(471);
      if (lookahead == '=') ADVANCE(474);
      if (lookahead == '\\') ADVANCE(349);
      if (lookahead == '_') ADVANCE(517);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == '}') ADVANCE(444);
      if (lookahead == 8594) ADVANCE(461);
      if (lookahead == 10627) ADVANCE(513);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(193)
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '\'' &&
          lookahead != '@') ADVANCE(654);
      END_STATE();
    case 194:
      if (lookahead == '(') ADVANCE(496);
      if (lookahead == ')') ADVANCE(498);
      if (lookahead == '-') ADVANCE(531);
      if (lookahead == '.') ADVANCE(659);
      if (lookahead == ':') ADVANCE(471);
      if (lookahead == '\\') ADVANCE(359);
      if (lookahead == '_') ADVANCE(517);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == '}') ADVANCE(444);
      if (lookahead == 8594) ADVANCE(461);
      if (lookahead == 10627) ADVANCE(513);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(194)
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '\'' &&
          lookahead != '@') ADVANCE(654);
      END_STATE();
    case 195:
      if (lookahead == '(') ADVANCE(496);
      if (lookahead == ')') ADVANCE(498);
      if (lookahead == '-') ADVANCE(531);
      if (lookahead == '.') ADVANCE(659);
      if (lookahead == ';') ADVANCE(506);
      if (lookahead == '=') ADVANCE(474);
      if (lookahead == '\\') ADVANCE(354);
      if (lookahead == '_') ADVANCE(517);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == '}') ADVANCE(444);
      if (lookahead == 8594) ADVANCE(461);
      if (lookahead == 10627) ADVANCE(513);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(195)
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '\'' &&
          lookahead != '@') ADVANCE(654);
      END_STATE();
    case 196:
      if (lookahead == '(') ADVANCE(496);
      if (lookahead == ')') ADVANCE(498);
      if (lookahead == '-') ADVANCE(531);
      if (lookahead == '.') ADVANCE(659);
      if (lookahead == '=') ADVANCE(474);
      if (lookahead == '\\') ADVANCE(365);
      if (lookahead == '_') ADVANCE(517);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == '}') ADVANCE(444);
      if (lookahead == 8594) ADVANCE(461);
      if (lookahead == 10627) ADVANCE(513);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(196)
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '\'' &&
          lookahead != '@') ADVANCE(654);
      END_STATE();
    case 197:
      if (lookahead == '(') ADVANCE(496);
      if (lookahead == '-') ADVANCE(531);
      if (lookahead == '.') ADVANCE(659);
      if (lookahead == ':') ADVANCE(471);
      if (lookahead == ';') ADVANCE(506);
      if (lookahead == '=') ADVANCE(474);
      if (lookahead == '\\') ADVANCE(330);
      if (lookahead == '_') ADVANCE(517);
      if (lookahead == 'i') ADVANCE(625);
      if (lookahead == 'm') ADVANCE(633);
      if (lookahead == 'r') ADVANCE(608);
      if (lookahead == 'w') ADVANCE(614);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == 8594) ADVANCE(461);
      if (lookahead == 10627) ADVANCE(513);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(197)
      if (lookahead != 0 &&
          lookahead != '"' &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != '@' &&
          lookahead != '}') ADVANCE(654);
      END_STATE();
    case 198:
      if (lookahead == '(') ADVANCE(496);
      if (lookahead == '-') ADVANCE(531);
      if (lookahead == '.') ADVANCE(659);
      if (lookahead == ':') ADVANCE(471);
      if (lookahead == ';') ADVANCE(506);
      if (lookahead == '=') ADVANCE(474);
      if (lookahead == '\\') ADVANCE(332);
      if (lookahead == '_') ADVANCE(517);
      if (lookahead == 'i') ADVANCE(625);
      if (lookahead == 'm') ADVANCE(633);
      if (lookahead == 'w') ADVANCE(614);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == 8594) ADVANCE(461);
      if (lookahead == 10627) ADVANCE(513);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(198)
      if (lookahead != 0 &&
          lookahead != '"' &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != '@' &&
          lookahead != '}') ADVANCE(654);
      END_STATE();
    case 199:
      if (lookahead == '(') ADVANCE(496);
      if (lookahead == '-') ADVANCE(531);
      if (lookahead == '.') ADVANCE(659);
      if (lookahead == ':') ADVANCE(471);
      if (lookahead == ';') ADVANCE(506);
      if (lookahead == '=') ADVANCE(474);
      if (lookahead == '\\') ADVANCE(334);
      if (lookahead == '_') ADVANCE(517);
      if (lookahead == 'm') ADVANCE(633);
      if (lookahead == 'r') ADVANCE(608);
      if (lookahead == 'w') ADVANCE(614);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == 8594) ADVANCE(461);
      if (lookahead == 10627) ADVANCE(513);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(199)
      if (lookahead != 0 &&
          lookahead != '"' &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != '@' &&
          lookahead != '}') ADVANCE(654);
      END_STATE();
    case 200:
      if (lookahead == '(') ADVANCE(496);
      if (lookahead == '-') ADVANCE(531);
      if (lookahead == '.') ADVANCE(659);
      if (lookahead == ':') ADVANCE(471);
      if (lookahead == ';') ADVANCE(506);
      if (lookahead == '=') ADVANCE(474);
      if (lookahead == '\\') ADVANCE(412);
      if (lookahead == '_') ADVANCE(517);
      if (lookahead == 'i') ADVANCE(625);
      if (lookahead == 'm') ADVANCE(633);
      if (lookahead == 'w') ADVANCE(615);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == 8594) ADVANCE(461);
      if (lookahead == 10627) ADVANCE(513);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(200)
      if (lookahead != 0 &&
          lookahead != '"' &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != '@' &&
          lookahead != '}') ADVANCE(654);
      END_STATE();
    case 201:
      if (lookahead == '(') ADVANCE(496);
      if (lookahead == '-') ADVANCE(531);
      if (lookahead == '.') ADVANCE(659);
      if (lookahead == ':') ADVANCE(471);
      if (lookahead == ';') ADVANCE(506);
      if (lookahead == '=') ADVANCE(474);
      if (lookahead == '\\') ADVANCE(336);
      if (lookahead == '_') ADVANCE(517);
      if (lookahead == 'm') ADVANCE(633);
      if (lookahead == 'w') ADVANCE(614);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == 8594) ADVANCE(461);
      if (lookahead == 10627) ADVANCE(513);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(201)
      if (lookahead != 0 &&
          lookahead != '"' &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != '@' &&
          lookahead != '}') ADVANCE(654);
      END_STATE();
    case 202:
      if (lookahead == '(') ADVANCE(496);
      if (lookahead == '-') ADVANCE(531);
      if (lookahead == '.') ADVANCE(659);
      if (lookahead == ':') ADVANCE(471);
      if (lookahead == ';') ADVANCE(506);
      if (lookahead == '=') ADVANCE(474);
      if (lookahead == '\\') ADVANCE(413);
      if (lookahead == '_') ADVANCE(517);
      if (lookahead == 'm') ADVANCE(633);
      if (lookahead == 'w') ADVANCE(615);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == 8594) ADVANCE(461);
      if (lookahead == 10627) ADVANCE(513);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(202)
      if (lookahead != 0 &&
          lookahead != '"' &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != '@' &&
          lookahead != '}') ADVANCE(654);
      END_STATE();
    case 203:
      if (lookahead == '(') ADVANCE(496);
      if (lookahead == '-') ADVANCE(531);
      if (lookahead == '.') ADVANCE(659);
      if (lookahead == ':') ADVANCE(471);
      if (lookahead == ';') ADVANCE(506);
      if (lookahead == '=') ADVANCE(474);
      if (lookahead == '\\') ADVANCE(350);
      if (lookahead == '_') ADVANCE(517);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == 8594) ADVANCE(461);
      if (lookahead == 10627) ADVANCE(513);
      if (lookahead == 10628) ADVANCE(516);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(203)
      if (lookahead != 0 &&
          lookahead != '"' &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != '@' &&
          lookahead != '}') ADVANCE(654);
      END_STATE();
    case 204:
      if (lookahead == '(') ADVANCE(496);
      if (lookahead == '-') ADVANCE(531);
      if (lookahead == '.') ADVANCE(659);
      if (lookahead == ':') ADVANCE(471);
      if (lookahead == ';') ADVANCE(506);
      if (lookahead == '=') ADVANCE(474);
      if (lookahead == '\\') ADVANCE(356);
      if (lookahead == '_') ADVANCE(517);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == '}') ADVANCE(527);
      if (lookahead == 8594) ADVANCE(461);
      if (lookahead == 10627) ADVANCE(513);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(204)
      if (lookahead != 0 &&
          lookahead != '"' &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != '@') ADVANCE(654);
      END_STATE();
    case 205:
      if (lookahead == '(') ADVANCE(496);
      if (lookahead == '-') ADVANCE(531);
      if (lookahead == '.') ADVANCE(659);
      if (lookahead == ':') ADVANCE(471);
      if (lookahead == ';') ADVANCE(506);
      if (lookahead == '\\') ADVANCE(364);
      if (lookahead == '_') ADVANCE(517);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == 8594) ADVANCE(461);
      if (lookahead == 10627) ADVANCE(513);
      if (lookahead == 10628) ADVANCE(516);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(205)
      if (lookahead != 0 &&
          lookahead != '"' &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != '@' &&
          lookahead != '}') ADVANCE(654);
      END_STATE();
    case 206:
      if (lookahead == '(') ADVANCE(496);
      if (lookahead == '-') ADVANCE(531);
      if (lookahead == '.') ADVANCE(659);
      if (lookahead == ':') ADVANCE(471);
      if (lookahead == ';') ADVANCE(506);
      if (lookahead == '\\') ADVANCE(369);
      if (lookahead == '_') ADVANCE(517);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == '}') ADVANCE(444);
      if (lookahead == 8594) ADVANCE(461);
      if (lookahead == 10627) ADVANCE(513);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(206)
      if (lookahead != 0 &&
          lookahead != '"' &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != '@') ADVANCE(654);
      END_STATE();
    case 207:
      if (lookahead == '(') ADVANCE(496);
      if (lookahead == '-') ADVANCE(531);
      if (lookahead == '.') ADVANCE(659);
      if (lookahead == ':') ADVANCE(471);
      if (lookahead == '=') ADVANCE(474);
      if (lookahead == '\\') ADVANCE(333);
      if (lookahead == '_') ADVANCE(517);
      if (lookahead == 'i') ADVANCE(625);
      if (lookahead == 'm') ADVANCE(633);
      if (lookahead == 'r') ADVANCE(608);
      if (lookahead == 'w') ADVANCE(614);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == 8594) ADVANCE(461);
      if (lookahead == 10627) ADVANCE(513);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(207)
      if (lookahead != 0 &&
          lookahead != '"' &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != '@' &&
          lookahead != '}') ADVANCE(654);
      END_STATE();
    case 208:
      if (lookahead == '(') ADVANCE(496);
      if (lookahead == '-') ADVANCE(531);
      if (lookahead == '.') ADVANCE(659);
      if (lookahead == ':') ADVANCE(471);
      if (lookahead == '=') ADVANCE(474);
      if (lookahead == '\\') ADVANCE(335);
      if (lookahead == '_') ADVANCE(517);
      if (lookahead == 'm') ADVANCE(633);
      if (lookahead == 'r') ADVANCE(608);
      if (lookahead == 'w') ADVANCE(614);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == 8594) ADVANCE(461);
      if (lookahead == 10627) ADVANCE(513);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(208)
      if (lookahead != 0 &&
          lookahead != '"' &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != '@' &&
          lookahead != '}') ADVANCE(654);
      END_STATE();
    case 209:
      if (lookahead == '(') ADVANCE(496);
      if (lookahead == '-') ADVANCE(531);
      if (lookahead == '.') ADVANCE(659);
      if (lookahead == ':') ADVANCE(471);
      if (lookahead == '=') ADVANCE(474);
      if (lookahead == '\\') ADVANCE(337);
      if (lookahead == '_') ADVANCE(517);
      if (lookahead == 'i') ADVANCE(625);
      if (lookahead == 'm') ADVANCE(633);
      if (lookahead == 'w') ADVANCE(614);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == 8594) ADVANCE(461);
      if (lookahead == 10627) ADVANCE(513);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(209)
      if (lookahead != 0 &&
          lookahead != '"' &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != '@' &&
          lookahead != '}') ADVANCE(654);
      END_STATE();
    case 210:
      if (lookahead == '(') ADVANCE(496);
      if (lookahead == '-') ADVANCE(531);
      if (lookahead == '.') ADVANCE(659);
      if (lookahead == ':') ADVANCE(471);
      if (lookahead == '=') ADVANCE(474);
      if (lookahead == '\\') ADVANCE(341);
      if (lookahead == '_') ADVANCE(517);
      if (lookahead == 'm') ADVANCE(633);
      if (lookahead == 'w') ADVANCE(614);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == 8594) ADVANCE(461);
      if (lookahead == 10627) ADVANCE(513);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(210)
      if (lookahead != 0 &&
          lookahead != '"' &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != '@' &&
          lookahead != '}') ADVANCE(654);
      END_STATE();
    case 211:
      if (lookahead == '(') ADVANCE(496);
      if (lookahead == '-') ADVANCE(531);
      if (lookahead == '.') ADVANCE(659);
      if (lookahead == ':') ADVANCE(471);
      if (lookahead == '=') ADVANCE(474);
      if (lookahead == '\\') ADVANCE(414);
      if (lookahead == '_') ADVANCE(517);
      if (lookahead == 'i') ADVANCE(625);
      if (lookahead == 'm') ADVANCE(633);
      if (lookahead == 'w') ADVANCE(615);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == 8594) ADVANCE(461);
      if (lookahead == 10627) ADVANCE(513);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(211)
      if (lookahead != 0 &&
          lookahead != '"' &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != '@' &&
          lookahead != '}') ADVANCE(654);
      END_STATE();
    case 212:
      if (lookahead == '(') ADVANCE(496);
      if (lookahead == '-') ADVANCE(531);
      if (lookahead == '.') ADVANCE(659);
      if (lookahead == ':') ADVANCE(471);
      if (lookahead == '=') ADVANCE(474);
      if (lookahead == '\\') ADVANCE(415);
      if (lookahead == '_') ADVANCE(517);
      if (lookahead == 'm') ADVANCE(633);
      if (lookahead == 'w') ADVANCE(615);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == 8594) ADVANCE(461);
      if (lookahead == 10627) ADVANCE(513);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(212)
      if (lookahead != 0 &&
          lookahead != '"' &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != '@' &&
          lookahead != '}') ADVANCE(654);
      END_STATE();
    case 213:
      if (lookahead == '(') ADVANCE(496);
      if (lookahead == '-') ADVANCE(531);
      if (lookahead == '.') ADVANCE(659);
      if (lookahead == ':') ADVANCE(471);
      if (lookahead == '=') ADVANCE(474);
      if (lookahead == '\\') ADVANCE(362);
      if (lookahead == '_') ADVANCE(517);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == '}') ADVANCE(527);
      if (lookahead == 8594) ADVANCE(461);
      if (lookahead == 10627) ADVANCE(513);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(213)
      if (lookahead != 0 &&
          lookahead != '"' &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != '@') ADVANCE(654);
      END_STATE();
    case 214:
      if (lookahead == '(') ADVANCE(496);
      if (lookahead == '-') ADVANCE(531);
      if (lookahead == '.') ADVANCE(659);
      if (lookahead == ':') ADVANCE(471);
      if (lookahead == '=') ADVANCE(474);
      if (lookahead == '\\') ADVANCE(363);
      if (lookahead == '_') ADVANCE(517);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == 8594) ADVANCE(461);
      if (lookahead == 10627) ADVANCE(513);
      if (lookahead == 10628) ADVANCE(516);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(214)
      if (lookahead != 0 &&
          lookahead != '"' &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != '@' &&
          lookahead != '}') ADVANCE(654);
      END_STATE();
    case 215:
      if (lookahead == '(') ADVANCE(496);
      if (lookahead == '-') ADVANCE(531);
      if (lookahead == '.') ADVANCE(659);
      if (lookahead == ':') ADVANCE(471);
      if (lookahead == '\\') ADVANCE(375);
      if (lookahead == '_') ADVANCE(517);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == '}') ADVANCE(527);
      if (lookahead == 8594) ADVANCE(461);
      if (lookahead == 10627) ADVANCE(513);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(215)
      if (lookahead != 0 &&
          lookahead != '"' &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != '@') ADVANCE(654);
      END_STATE();
    case 216:
      if (lookahead == '(') ADVANCE(496);
      if (lookahead == '-') ADVANCE(531);
      if (lookahead == '.') ADVANCE(659);
      if (lookahead == ':') ADVANCE(471);
      if (lookahead == '\\') ADVANCE(380);
      if (lookahead == '_') ADVANCE(517);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == 8594) ADVANCE(461);
      if (lookahead == 10627) ADVANCE(513);
      if (lookahead == 10628) ADVANCE(516);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(216)
      if (lookahead != 0 &&
          lookahead != '"' &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != '@' &&
          lookahead != '}') ADVANCE(654);
      END_STATE();
    case 217:
      if (lookahead == '(') ADVANCE(496);
      if (lookahead == '-') ADVANCE(531);
      if (lookahead == '.') ADVANCE(659);
      if (lookahead == ';') ADVANCE(506);
      if (lookahead == '=') ADVANCE(474);
      if (lookahead == '\\') ADVANCE(340);
      if (lookahead == '_') ADVANCE(517);
      if (lookahead == 'i') ADVANCE(625);
      if (lookahead == 'm') ADVANCE(633);
      if (lookahead == 'w') ADVANCE(615);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == 8594) ADVANCE(461);
      if (lookahead == 10627) ADVANCE(513);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(217)
      if (lookahead != 0 &&
          lookahead != '"' &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != '@' &&
          lookahead != '}') ADVANCE(654);
      END_STATE();
    case 218:
      if (lookahead == '(') ADVANCE(496);
      if (lookahead == '-') ADVANCE(531);
      if (lookahead == '.') ADVANCE(659);
      if (lookahead == ';') ADVANCE(506);
      if (lookahead == '=') ADVANCE(474);
      if (lookahead == '\\') ADVANCE(343);
      if (lookahead == '_') ADVANCE(517);
      if (lookahead == 'i') ADVANCE(625);
      if (lookahead == 'w') ADVANCE(615);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == 8594) ADVANCE(461);
      if (lookahead == 10627) ADVANCE(513);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(218)
      if (lookahead != 0 &&
          lookahead != '"' &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != '@' &&
          lookahead != '}') ADVANCE(654);
      END_STATE();
    case 219:
      if (lookahead == '(') ADVANCE(496);
      if (lookahead == '-') ADVANCE(531);
      if (lookahead == '.') ADVANCE(659);
      if (lookahead == ';') ADVANCE(506);
      if (lookahead == '=') ADVANCE(474);
      if (lookahead == '\\') ADVANCE(344);
      if (lookahead == '_') ADVANCE(517);
      if (lookahead == 'm') ADVANCE(633);
      if (lookahead == 'w') ADVANCE(615);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == 8594) ADVANCE(461);
      if (lookahead == 10627) ADVANCE(513);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(219)
      if (lookahead != 0 &&
          lookahead != '"' &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != '@' &&
          lookahead != '}') ADVANCE(654);
      END_STATE();
    case 220:
      if (lookahead == '(') ADVANCE(496);
      if (lookahead == '-') ADVANCE(531);
      if (lookahead == '.') ADVANCE(659);
      if (lookahead == ';') ADVANCE(506);
      if (lookahead == '=') ADVANCE(474);
      if (lookahead == '\\') ADVANCE(351);
      if (lookahead == '_') ADVANCE(517);
      if (lookahead == 'w') ADVANCE(615);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == 8594) ADVANCE(461);
      if (lookahead == 10627) ADVANCE(513);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(220)
      if (lookahead != 0 &&
          lookahead != '"' &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != '@' &&
          lookahead != '}') ADVANCE(654);
      END_STATE();
    case 221:
      if (lookahead == '(') ADVANCE(496);
      if (lookahead == '-') ADVANCE(531);
      if (lookahead == '.') ADVANCE(659);
      if (lookahead == ';') ADVANCE(506);
      if (lookahead == '=') ADVANCE(474);
      if (lookahead == '\\') ADVANCE(353);
      if (lookahead == '_') ADVANCE(517);
      if (lookahead == 'i') ADVANCE(625);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == 8594) ADVANCE(461);
      if (lookahead == 10627) ADVANCE(513);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(221)
      if (lookahead != 0 &&
          lookahead != '"' &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != '@' &&
          lookahead != '}') ADVANCE(654);
      END_STATE();
    case 222:
      if (lookahead == '(') ADVANCE(496);
      if (lookahead == '-') ADVANCE(531);
      if (lookahead == '.') ADVANCE(659);
      if (lookahead == ';') ADVANCE(506);
      if (lookahead == '=') ADVANCE(474);
      if (lookahead == '\\') ADVANCE(358);
      if (lookahead == '_') ADVANCE(517);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == 8594) ADVANCE(461);
      if (lookahead == 10627) ADVANCE(513);
      if (lookahead == 10628) ADVANCE(516);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(222)
      if (lookahead != 0 &&
          lookahead != '"' &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != '@' &&
          lookahead != '}') ADVANCE(654);
      END_STATE();
    case 223:
      if (lookahead == '(') ADVANCE(496);
      if (lookahead == '-') ADVANCE(531);
      if (lookahead == '.') ADVANCE(659);
      if (lookahead == ';') ADVANCE(506);
      if (lookahead == '=') ADVANCE(474);
      if (lookahead == '\\') ADVANCE(360);
      if (lookahead == '_') ADVANCE(517);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == '}') ADVANCE(527);
      if (lookahead == 8594) ADVANCE(461);
      if (lookahead == 10627) ADVANCE(513);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(223)
      if (lookahead != 0 &&
          lookahead != '"' &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != '@') ADVANCE(654);
      END_STATE();
    case 224:
      if (lookahead == '(') ADVANCE(496);
      if (lookahead == '-') ADVANCE(531);
      if (lookahead == '.') ADVANCE(659);
      if (lookahead == ';') ADVANCE(506);
      if (lookahead == '=') ADVANCE(474);
      if (lookahead == '\\') ADVANCE(366);
      if (lookahead == '_') ADVANCE(517);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == '|') ADVANCE(529);
      if (lookahead == 8594) ADVANCE(461);
      if (lookahead == 10627) ADVANCE(513);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(224)
      if (lookahead != 0 &&
          lookahead != '"' &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != '@' &&
          lookahead != '}') ADVANCE(654);
      END_STATE();
    case 225:
      if (lookahead == '(') ADVANCE(496);
      if (lookahead == '-') ADVANCE(531);
      if (lookahead == '.') ADVANCE(659);
      if (lookahead == ';') ADVANCE(506);
      if (lookahead == '=') ADVANCE(474);
      if (lookahead == '\\') ADVANCE(367);
      if (lookahead == '_') ADVANCE(517);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == 8594) ADVANCE(461);
      if (lookahead == 10627) ADVANCE(513);
      if (lookahead == 10632) ADVANCE(678);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(225)
      if (lookahead != 0 &&
          lookahead != '"' &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != '@' &&
          lookahead != '}') ADVANCE(654);
      END_STATE();
    case 226:
      if (lookahead == '(') ADVANCE(496);
      if (lookahead == '-') ADVANCE(531);
      if (lookahead == '.') ADVANCE(659);
      if (lookahead == ';') ADVANCE(506);
      if (lookahead == '\\') ADVANCE(370);
      if (lookahead == '_') ADVANCE(517);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == '}') ADVANCE(527);
      if (lookahead == 8594) ADVANCE(461);
      if (lookahead == 10627) ADVANCE(513);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(226)
      if (lookahead != 0 &&
          lookahead != '"' &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != '@') ADVANCE(654);
      END_STATE();
    case 227:
      if (lookahead == '(') ADVANCE(496);
      if (lookahead == '-') ADVANCE(531);
      if (lookahead == '.') ADVANCE(659);
      if (lookahead == '=') ADVANCE(474);
      if (lookahead == '\\') ADVANCE(345);
      if (lookahead == '_') ADVANCE(517);
      if (lookahead == 'i') ADVANCE(625);
      if (lookahead == 'm') ADVANCE(633);
      if (lookahead == 'w') ADVANCE(615);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == 8594) ADVANCE(461);
      if (lookahead == 10627) ADVANCE(513);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(227)
      if (lookahead != 0 &&
          lookahead != '"' &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != '@' &&
          lookahead != '}') ADVANCE(654);
      END_STATE();
    case 228:
      if (lookahead == '(') ADVANCE(496);
      if (lookahead == '-') ADVANCE(531);
      if (lookahead == '.') ADVANCE(659);
      if (lookahead == '=') ADVANCE(474);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == '_') ADVANCE(517);
      if (lookahead == 'i') ADVANCE(625);
      if (lookahead == 'w') ADVANCE(615);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == 8594) ADVANCE(461);
      if (lookahead == 10627) ADVANCE(513);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(228)
      if (lookahead != 0 &&
          lookahead != '"' &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != '@' &&
          lookahead != '}') ADVANCE(654);
      END_STATE();
    case 229:
      if (lookahead == '(') ADVANCE(496);
      if (lookahead == '-') ADVANCE(531);
      if (lookahead == '.') ADVANCE(659);
      if (lookahead == '=') ADVANCE(474);
      if (lookahead == '\\') ADVANCE(355);
      if (lookahead == '_') ADVANCE(517);
      if (lookahead == 'm') ADVANCE(633);
      if (lookahead == 'w') ADVANCE(615);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == 8594) ADVANCE(461);
      if (lookahead == 10627) ADVANCE(513);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(229)
      if (lookahead != 0 &&
          lookahead != '"' &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != '@' &&
          lookahead != '}') ADVANCE(654);
      END_STATE();
    case 230:
      if (lookahead == '(') ADVANCE(496);
      if (lookahead == '-') ADVANCE(531);
      if (lookahead == '.') ADVANCE(659);
      if (lookahead == '=') ADVANCE(474);
      if (lookahead == '\\') ADVANCE(361);
      if (lookahead == '_') ADVANCE(517);
      if (lookahead == 'w') ADVANCE(615);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == 8594) ADVANCE(461);
      if (lookahead == 10627) ADVANCE(513);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(230)
      if (lookahead != 0 &&
          lookahead != '"' &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != '@' &&
          lookahead != '}') ADVANCE(654);
      END_STATE();
    case 231:
      if (lookahead == '(') ADVANCE(496);
      if (lookahead == '-') ADVANCE(531);
      if (lookahead == '.') ADVANCE(659);
      if (lookahead == '=') ADVANCE(474);
      if (lookahead == '\\') ADVANCE(368);
      if (lookahead == '_') ADVANCE(517);
      if (lookahead == 'i') ADVANCE(625);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == 8594) ADVANCE(461);
      if (lookahead == 10627) ADVANCE(513);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(231)
      if (lookahead != 0 &&
          lookahead != '"' &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != '@' &&
          lookahead != '}') ADVANCE(654);
      END_STATE();
    case 232:
      if (lookahead == '(') ADVANCE(496);
      if (lookahead == '-') ADVANCE(531);
      if (lookahead == '.') ADVANCE(659);
      if (lookahead == '=') ADVANCE(474);
      if (lookahead == '\\') ADVANCE(371);
      if (lookahead == '_') ADVANCE(517);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == 8594) ADVANCE(461);
      if (lookahead == 10627) ADVANCE(513);
      if (lookahead == 10628) ADVANCE(516);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(232)
      if (lookahead != 0 &&
          lookahead != '"' &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != '@' &&
          lookahead != '}') ADVANCE(654);
      END_STATE();
    case 233:
      if (lookahead == '(') ADVANCE(496);
      if (lookahead == '-') ADVANCE(531);
      if (lookahead == '.') ADVANCE(659);
      if (lookahead == '=') ADVANCE(474);
      if (lookahead == '\\') ADVANCE(372);
      if (lookahead == '_') ADVANCE(517);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == '|') ADVANCE(529);
      if (lookahead == 8594) ADVANCE(461);
      if (lookahead == 10627) ADVANCE(513);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(233)
      if (lookahead != 0 &&
          lookahead != '"' &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != '@' &&
          lookahead != '}') ADVANCE(654);
      END_STATE();
    case 234:
      if (lookahead == '(') ADVANCE(496);
      if (lookahead == '-') ADVANCE(531);
      if (lookahead == '.') ADVANCE(659);
      if (lookahead == '=') ADVANCE(474);
      if (lookahead == '\\') ADVANCE(373);
      if (lookahead == '_') ADVANCE(517);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == 8594) ADVANCE(461);
      if (lookahead == 10627) ADVANCE(513);
      if (lookahead == 10632) ADVANCE(678);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(234)
      if (lookahead != 0 &&
          lookahead != '"' &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != '@' &&
          lookahead != '}') ADVANCE(654);
      END_STATE();
    case 235:
      if (lookahead == '(') ADVANCE(496);
      if (lookahead == '-') ADVANCE(531);
      if (lookahead == '.') ADVANCE(659);
      if (lookahead == '=') ADVANCE(474);
      if (lookahead == '\\') ADVANCE(374);
      if (lookahead == '_') ADVANCE(517);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == '}') ADVANCE(527);
      if (lookahead == 8594) ADVANCE(461);
      if (lookahead == 10627) ADVANCE(513);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(235)
      if (lookahead != 0 &&
          lookahead != '"' &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != '@') ADVANCE(654);
      END_STATE();
    case 236:
      if (lookahead == '(') ADVANCE(496);
      if (lookahead == '-') ADVANCE(531);
      if (lookahead == '.') ADVANCE(659);
      if (lookahead == '\\') ADVANCE(339);
      if (lookahead == '_') ADVANCE(517);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == 8594) ADVANCE(461);
      if (lookahead == 10627) ADVANCE(513);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(236)
      if (lookahead != 0 &&
          lookahead != '"' &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != '@' &&
          lookahead != '}') ADVANCE(654);
      END_STATE();
    case 237:
      if (lookahead == '(') ADVANCE(496);
      if (lookahead == '-') ADVANCE(532);
      if (lookahead == '.') ADVANCE(659);
      if (lookahead == ':') ADVANCE(471);
      if (lookahead == '@') ADVANCE(665);
      if (lookahead == '\\') ADVANCE(338);
      if (lookahead == '_') ADVANCE(517);
      if (lookahead == 'w') ADVANCE(615);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == 10627) ADVANCE(513);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(237)
      if (lookahead != 0 &&
          lookahead != '"' &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != '}') ADVANCE(654);
      END_STATE();
    case 238:
      if (lookahead == '(') ADVANCE(496);
      if (lookahead == '-') ADVANCE(532);
      if (lookahead == '.') ADVANCE(659);
      if (lookahead == '=') ADVANCE(474);
      if (lookahead == '\\') ADVANCE(346);
      if (lookahead == '_') ADVANCE(517);
      if (lookahead == 'w') ADVANCE(615);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == 10627) ADVANCE(513);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(238)
      if (lookahead != 0 &&
          lookahead != '"' &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != '@' &&
          lookahead != '}') ADVANCE(654);
      END_STATE();
    case 239:
      if (lookahead == '(') ADVANCE(496);
      if (lookahead == '-') ADVANCE(532);
      if (lookahead == '.') ADVANCE(659);
      if (lookahead == '=') ADVANCE(474);
      if (lookahead == '\\') ADVANCE(348);
      if (lookahead == '_') ADVANCE(517);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == 10627) ADVANCE(513);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(239)
      if (lookahead != 0 &&
          lookahead != '"' &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != '@' &&
          lookahead != '}') ADVANCE(654);
      END_STATE();
    case 240:
      if (lookahead == '(') ADVANCE(496);
      if (lookahead == '-') ADVANCE(532);
      if (lookahead == '.') ADVANCE(659);
      if (lookahead == '@') ADVANCE(665);
      if (lookahead == '\\') ADVANCE(331);
      if (lookahead == '_') ADVANCE(517);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == 10627) ADVANCE(513);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(240)
      if (lookahead != 0 &&
          lookahead != '"' &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != '}') ADVANCE(654);
      END_STATE();
    case 241:
      if (lookahead == '(') ADVANCE(496);
      if (lookahead == '-') ADVANCE(532);
      if (lookahead == '.') ADVANCE(659);
      if (lookahead == '\\') ADVANCE(342);
      if (lookahead == '_') ADVANCE(517);
      if (lookahead == 'w') ADVANCE(615);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == 10627) ADVANCE(513);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(241)
      if (lookahead != 0 &&
          lookahead != '"' &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != '@' &&
          lookahead != '}') ADVANCE(654);
      END_STATE();
    case 242:
      if (lookahead == ')') ADVANCE(498);
      if (lookahead == '-') ADVANCE(248);
      if (lookahead == ':') ADVANCE(469);
      if (lookahead == ';') ADVANCE(505);
      if (lookahead == '=') ADVANCE(472);
      if (lookahead == '@') ADVANCE(665);
      if (lookahead == '\\') SKIP(383)
      if (lookahead == 'h') ADVANCE(291);
      if (lookahead == 'p') ADVANCE(438);
      if (lookahead == 'r') ADVANCE(284);
      if (lookahead == 'u') ADVANCE(432);
      if (lookahead == 'w') ADVANCE(289);
      if (lookahead == '{') ADVANCE(525);
      if (lookahead == '|') ADVANCE(245);
      if (lookahead == '}') ADVANCE(527);
      if (lookahead == 8594) ADVANCE(459);
      if (lookahead == 10628) ADVANCE(514);
      if (lookahead == 10632) ADVANCE(676);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(242)
      END_STATE();
    case 243:
      if (lookahead == ')') ADVANCE(498);
      if (lookahead == '-') ADVANCE(532);
      if (lookahead == '\\') ADVANCE(388);
      if (lookahead == '_') ADVANCE(447);
      if (lookahead == 'm') ADVANCE(633);
      if (lookahead == '{') ADVANCE(260);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(243)
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '\'' &&
          lookahead != '(' &&
          lookahead != '.' &&
          lookahead != '@' &&
          lookahead != '}') ADVANCE(654);
      END_STATE();
    case 244:
      if (lookahead == ')') ADVANCE(498);
      if (lookahead == '-') ADVANCE(246);
      if (lookahead == ':') ADVANCE(469);
      if (lookahead == '\\') SKIP(389)
      if (lookahead == '{') ADVANCE(525);
      if (lookahead == '}') ADVANCE(444);
      if (lookahead == 10628) ADVANCE(514);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(244)
      END_STATE();
    case 245:
      if (lookahead == ')') ADVANCE(673);
      END_STATE();
    case 246:
      if (lookahead == '-') ADVANCE(688);
      END_STATE();
    case 247:
      if (lookahead == '-') ADVANCE(688);
      if (lookahead == '0') ADVANCE(679);
      if (lookahead == '>') ADVANCE(456);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(680);
      END_STATE();
    case 248:
      if (lookahead == '-') ADVANCE(688);
      if (lookahead == '>') ADVANCE(456);
      END_STATE();
    case 249:
      if (lookahead == '-') ADVANCE(442);
      if (lookahead == '}') ADVANCE(684);
      if (lookahead != 0) ADVANCE(250);
      END_STATE();
    case 250:
      if (lookahead == '-') ADVANCE(442);
      if (lookahead != 0) ADVANCE(250);
      END_STATE();
    case 251:
      if (lookahead == '-') ADVANCE(535);
      if (lookahead == ';') ADVANCE(654);
      if (lookahead == '\\') ADVANCE(384);
      if (lookahead == '_') ADVANCE(448);
      if (lookahead == 'm') ADVANCE(569);
      if (lookahead == '{') ADVANCE(260);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(251)
      if (lookahead != 0 &&
          lookahead != '"' &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != '.' &&
          lookahead != '@' &&
          lookahead != '}') ADVANCE(589);
      END_STATE();
    case 252:
      if (lookahead == '-') ADVANCE(532);
      if (lookahead == '.') ADVANCE(659);
      if (lookahead == ':') ADVANCE(471);
      if (lookahead == '\\') ADVANCE(381);
      if (lookahead == '_') ADVANCE(447);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == 10627) ADVANCE(513);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(252)
      if (lookahead != 0 &&
          lookahead != '"' &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != '@' &&
          lookahead != '}') ADVANCE(654);
      END_STATE();
    case 253:
      if (lookahead == '-') ADVANCE(532);
      if (lookahead == '.') ADVANCE(659);
      if (lookahead == '\\') ADVANCE(385);
      if (lookahead == '_') ADVANCE(517);
      if (lookahead == '{') ADVANCE(260);
      if (lookahead == '}') ADVANCE(444);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(253)
      if (lookahead != 0 &&
          lookahead != '"' &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != '@') ADVANCE(654);
      END_STATE();
    case 254:
      if (lookahead == '-') ADVANCE(532);
      if (lookahead == '.') ADVANCE(659);
      if (lookahead == '\\') ADVANCE(386);
      if (lookahead == '_') ADVANCE(447);
      if (lookahead == '{') ADVANCE(260);
      if (lookahead == 10628) ADVANCE(516);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(254)
      if (lookahead != 0 &&
          lookahead != '"' &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != '@' &&
          lookahead != '}') ADVANCE(654);
      END_STATE();
    case 255:
      if (lookahead == '-') ADVANCE(532);
      if (lookahead == '.') ADVANCE(659);
      if (lookahead == '\\') ADVANCE(418);
      if (lookahead == '_') ADVANCE(447);
      if (lookahead == '{') ADVANCE(260);
      if (lookahead == '}') ADVANCE(527);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(255)
      if (lookahead != 0 &&
          lookahead != '"' &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != '@') ADVANCE(654);
      END_STATE();
    case 256:
      if (lookahead == '-') ADVANCE(532);
      if (lookahead == ':') ADVANCE(471);
      if (lookahead == '\\') ADVANCE(390);
      if (lookahead == '_') ADVANCE(447);
      if (lookahead == '{') ADVANCE(260);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(256)
      if (lookahead != 0 &&
          lookahead != '"' &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != '.' &&
          lookahead != '@' &&
          lookahead != '}') ADVANCE(654);
      END_STATE();
    case 257:
      if (lookahead == '-') ADVANCE(532);
      if (lookahead == '=') ADVANCE(474);
      if (lookahead == '\\') ADVANCE(391);
      if (lookahead == '_') ADVANCE(447);
      if (lookahead == '{') ADVANCE(260);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(257)
      if (lookahead != 0 &&
          lookahead != '"' &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != '.' &&
          lookahead != '@' &&
          lookahead != '}') ADVANCE(654);
      END_STATE();
    case 258:
      if (lookahead == '-') ADVANCE(532);
      if (lookahead == '\\') ADVANCE(462);
      if (lookahead == '_') ADVANCE(447);
      if (lookahead == '{') ADVANCE(260);
      if (lookahead == 955) ADVANCE(465);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(258)
      if (lookahead != 0 &&
          lookahead != '"' &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != '.' &&
          lookahead != '@' &&
          lookahead != '}') ADVANCE(654);
      END_STATE();
    case 259:
      if (lookahead == '-') ADVANCE(532);
      if (lookahead == '\\') ADVANCE(387);
      if (lookahead == '_') ADVANCE(517);
      if (lookahead == 'i') ADVANCE(625);
      if (lookahead == '{') ADVANCE(260);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(259)
      if (lookahead != 0 &&
          lookahead != '"' &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != '.' &&
          lookahead != '@' &&
          lookahead != '}') ADVANCE(654);
      END_STATE();
    case 260:
      if (lookahead == '-') ADVANCE(189);
      END_STATE();
    case 261:
      if (lookahead == '-') ADVANCE(443);
      if (lookahead != 0) ADVANCE(190);
      END_STATE();
    case 262:
      if (lookahead == '-') ADVANCE(441);
      END_STATE();
    case 263:
      if (lookahead == '-') ADVANCE(246);
      if (lookahead == '\\') ADVANCE(462);
      if (lookahead == '{') ADVANCE(260);
      if (lookahead == 955) ADVANCE(463);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(263)
      END_STATE();
    case 264:
      if (lookahead == '.') ADVANCE(466);
      END_STATE();
    case 265:
      if (lookahead == 'A') ADVANCE(271);
      END_STATE();
    case 266:
      if (lookahead == 'A') ADVANCE(270);
      END_STATE();
    case 267:
      if (lookahead == 'C') ADVANCE(268);
      END_STATE();
    case 268:
      if (lookahead == 'H') ADVANCE(266);
      END_STATE();
    case 269:
      if (lookahead == 'L') ADVANCE(521);
      END_STATE();
    case 270:
      if (lookahead == 'L') ADVANCE(269);
      END_STATE();
    case 271:
      if (lookahead == 'T') ADVANCE(267);
      END_STATE();
    case 272:
      if (lookahead == '\\') ADVANCE(446);
      if (lookahead == '_') ADVANCE(449);
      if (!aux_sym__qid_token1_character_set_1(lookahead)) ADVANCE(655);
      END_STATE();
    case 273:
      if (lookahead == 'a') ADVANCE(299);
      END_STATE();
    case 274:
      if (lookahead == 'b') ADVANCE(297);
      END_STATE();
    case 275:
      if (lookahead == 'c') ADVANCE(490);
      END_STATE();
    case 276:
      if (lookahead == 'c') ADVANCE(436);
      END_STATE();
    case 277:
      if (lookahead == 'd') ADVANCE(439);
      END_STATE();
    case 278:
      if (lookahead == 'd') ADVANCE(295);
      END_STATE();
    case 279:
      if (lookahead == 'e') ADVANCE(378);
      END_STATE();
    case 280:
      if (lookahead == 'e') ADVANCE(484);
      END_STATE();
    case 281:
      if (lookahead == 'e') ADVANCE(481);
      END_STATE();
    case 282:
      if (lookahead == 'e') ADVANCE(478);
      END_STATE();
    case 283:
      if (lookahead == 'e') ADVANCE(430);
      END_STATE();
    case 284:
      if (lookahead == 'e') ADVANCE(377);
      END_STATE();
    case 285:
      if (lookahead == 'g') ADVANCE(493);
      END_STATE();
    case 286:
      if (lookahead == 'g') ADVANCE(499);
      END_STATE();
    case 287:
      if (lookahead == 'g') ADVANCE(502);
      END_STATE();
    case 288:
      if (lookahead == 'h') ADVANCE(475);
      END_STATE();
    case 289:
      if (lookahead == 'h') ADVANCE(283);
      END_STATE();
    case 290:
      if (lookahead == 'h') ADVANCE(283);
      if (lookahead == 'i') ADVANCE(434);
      END_STATE();
    case 291:
      if (lookahead == 'i') ADVANCE(278);
      END_STATE();
    case 292:
      if (lookahead == 'i') ADVANCE(275);
      END_STATE();
    case 293:
      if (lookahead == 'i') ADVANCE(379);
      END_STATE();
    case 294:
      if (lookahead == 'i') ADVANCE(437);
      END_STATE();
    case 295:
      if (lookahead == 'i') ADVANCE(417);
      END_STATE();
    case 296:
      if (lookahead == 'i') ADVANCE(421);
      END_STATE();
    case 297:
      if (lookahead == 'l') ADVANCE(292);
      END_STATE();
    case 298:
      if (lookahead == 'l') ADVANCE(281);
      END_STATE();
    case 299:
      if (lookahead == 'm') ADVANCE(296);
      END_STATE();
    case 300:
      if (lookahead == 'n') SKIP(1)
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          (lookahead < 'A' || 'Z' < lookahead) &&
          (lookahead < 'a' || 'z' < lookahead)) ADVANCE(654);
      END_STATE();
    case 301:
      if (lookahead == 'n') SKIP(38)
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          (lookahead < 'A' || 'Z' < lookahead) &&
          (lookahead < 'a' || 'z' < lookahead)) ADVANCE(589);
      END_STATE();
    case 302:
      if (lookahead == 'n') SKIP(39)
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          (lookahead < 'A' || 'Z' < lookahead) &&
          (lookahead < 'a' || 'z' < lookahead)) ADVANCE(589);
      END_STATE();
    case 303:
      if (lookahead == 'n') SKIP(40)
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          (lookahead < 'A' || 'Z' < lookahead) &&
          (lookahead < 'a' || 'z' < lookahead)) ADVANCE(589);
      END_STATE();
    case 304:
      if (lookahead == 'n') SKIP(118)
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          (lookahead < 'A' || 'Z' < lookahead) &&
          (lookahead < 'a' || 'z' < lookahead)) ADVANCE(589);
      END_STATE();
    case 305:
      if (lookahead == 'n') SKIP(94)
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          (lookahead < 'A' || 'Z' < lookahead) &&
          (lookahead < 'a' || 'z' < lookahead)) ADVANCE(589);
      END_STATE();
    case 306:
      if (lookahead == 'n') SKIP(41)
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          (lookahead < 'A' || 'Z' < lookahead) &&
          (lookahead < 'a' || 'z' < lookahead)) ADVANCE(589);
      END_STATE();
    case 307:
      if (lookahead == 'n') SKIP(83)
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          (lookahead < 'A' || 'Z' < lookahead) &&
          (lookahead < 'a' || 'z' < lookahead)) ADVANCE(589);
      END_STATE();
    case 308:
      if (lookahead == 'n') SKIP(17)
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          (lookahead < 'A' || 'Z' < lookahead) &&
          (lookahead < 'a' || 'z' < lookahead)) ADVANCE(589);
      END_STATE();
    case 309:
      if (lookahead == 'n') SKIP(84)
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          (lookahead < 'A' || 'Z' < lookahead) &&
          (lookahead < 'a' || 'z' < lookahead)) ADVANCE(589);
      END_STATE();
    case 310:
      if (lookahead == 'n') SKIP(85)
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          (lookahead < 'A' || 'Z' < lookahead) &&
          (lookahead < 'a' || 'z' < lookahead)) ADVANCE(589);
      END_STATE();
    case 311:
      if (lookahead == 'n') SKIP(4)
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          (lookahead < 'A' || 'Z' < lookahead) &&
          (lookahead < 'a' || 'z' < lookahead)) ADVANCE(589);
      END_STATE();
    case 312:
      if (lookahead == 'n') SKIP(44)
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          (lookahead < 'A' || 'Z' < lookahead) &&
          (lookahead < 'a' || 'z' < lookahead)) ADVANCE(589);
      END_STATE();
    case 313:
      if (lookahead == 'n') SKIP(86)
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          (lookahead < 'A' || 'Z' < lookahead) &&
          (lookahead < 'a' || 'z' < lookahead)) ADVANCE(589);
      END_STATE();
    case 314:
      if (lookahead == 'n') SKIP(87)
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          (lookahead < 'A' || 'Z' < lookahead) &&
          (lookahead < 'a' || 'z' < lookahead)) ADVANCE(589);
      END_STATE();
    case 315:
      if (lookahead == 'n') SKIP(14)
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          (lookahead < 'A' || 'Z' < lookahead) &&
          (lookahead < 'a' || 'z' < lookahead)) ADVANCE(589);
      END_STATE();
    case 316:
      if (lookahead == 'n') SKIP(45)
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          (lookahead < 'A' || 'Z' < lookahead) &&
          (lookahead < 'a' || 'z' < lookahead)) ADVANCE(589);
      END_STATE();
    case 317:
      if (lookahead == 'n') SKIP(6)
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          (lookahead < 'A' || 'Z' < lookahead) &&
          (lookahead < 'a' || 'z' < lookahead)) ADVANCE(589);
      END_STATE();
    case 318:
      if (lookahead == 'n') SKIP(48)
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          (lookahead < 'A' || 'Z' < lookahead) &&
          (lookahead < 'a' || 'z' < lookahead)) ADVANCE(589);
      END_STATE();
    case 319:
      if (lookahead == 'n') SKIP(88)
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          (lookahead < 'A' || 'Z' < lookahead) &&
          (lookahead < 'a' || 'z' < lookahead)) ADVANCE(589);
      END_STATE();
    case 320:
      if (lookahead == 'n') SKIP(89)
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          (lookahead < 'A' || 'Z' < lookahead) &&
          (lookahead < 'a' || 'z' < lookahead)) ADVANCE(589);
      END_STATE();
    case 321:
      if (lookahead == 'n') SKIP(90)
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          (lookahead < 'A' || 'Z' < lookahead) &&
          (lookahead < 'a' || 'z' < lookahead)) ADVANCE(589);
      END_STATE();
    case 322:
      if (lookahead == 'n') SKIP(91)
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          (lookahead < 'A' || 'Z' < lookahead) &&
          (lookahead < 'a' || 'z' < lookahead)) ADVANCE(589);
      END_STATE();
    case 323:
      if (lookahead == 'n') SKIP(49)
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          (lookahead < 'A' || 'Z' < lookahead) &&
          (lookahead < 'a' || 'z' < lookahead)) ADVANCE(589);
      END_STATE();
    case 324:
      if (lookahead == 'n') SKIP(184)
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          (lookahead < 'A' || 'Z' < lookahead) &&
          (lookahead < 'a' || 'z' < lookahead)) ADVANCE(589);
      END_STATE();
    case 325:
      if (lookahead == 'n') SKIP(95)
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          (lookahead < 'A' || 'Z' < lookahead) &&
          (lookahead < 'a' || 'z' < lookahead)) ADVANCE(589);
      END_STATE();
    case 326:
      if (lookahead == 'n') SKIP(27)
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          (lookahead < 'A' || 'Z' < lookahead) &&
          (lookahead < 'a' || 'z' < lookahead)) ADVANCE(589);
      END_STATE();
    case 327:
      if (lookahead == 'n') SKIP(119)
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          (lookahead < 'A' || 'Z' < lookahead) &&
          (lookahead < 'a' || 'z' < lookahead)) ADVANCE(589);
      END_STATE();
    case 328:
      if (lookahead == 'n') SKIP(120)
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          (lookahead < 'A' || 'Z' < lookahead) &&
          (lookahead < 'a' || 'z' < lookahead)) ADVANCE(589);
      END_STATE();
    case 329:
      if (lookahead == 'n') SKIP(92)
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          (lookahead < 'A' || 'Z' < lookahead) &&
          (lookahead < 'a' || 'z' < lookahead)) ADVANCE(589);
      END_STATE();
    case 330:
      if (lookahead == 'n') SKIP(197)
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          (lookahead < 'A' || 'Z' < lookahead) &&
          (lookahead < 'a' || 'z' < lookahead)) ADVANCE(654);
      END_STATE();
    case 331:
      if (lookahead == 'n') SKIP(240)
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          (lookahead < 'A' || 'Z' < lookahead) &&
          (lookahead < 'a' || 'z' < lookahead)) ADVANCE(654);
      END_STATE();
    case 332:
      if (lookahead == 'n') SKIP(198)
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          (lookahead < 'A' || 'Z' < lookahead) &&
          (lookahead < 'a' || 'z' < lookahead)) ADVANCE(654);
      END_STATE();
    case 333:
      if (lookahead == 'n') SKIP(207)
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          (lookahead < 'A' || 'Z' < lookahead) &&
          (lookahead < 'a' || 'z' < lookahead)) ADVANCE(654);
      END_STATE();
    case 334:
      if (lookahead == 'n') SKIP(199)
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          (lookahead < 'A' || 'Z' < lookahead) &&
          (lookahead < 'a' || 'z' < lookahead)) ADVANCE(654);
      END_STATE();
    case 335:
      if (lookahead == 'n') SKIP(208)
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          (lookahead < 'A' || 'Z' < lookahead) &&
          (lookahead < 'a' || 'z' < lookahead)) ADVANCE(654);
      END_STATE();
    case 336:
      if (lookahead == 'n') SKIP(201)
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          (lookahead < 'A' || 'Z' < lookahead) &&
          (lookahead < 'a' || 'z' < lookahead)) ADVANCE(654);
      END_STATE();
    case 337:
      if (lookahead == 'n') SKIP(209)
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          (lookahead < 'A' || 'Z' < lookahead) &&
          (lookahead < 'a' || 'z' < lookahead)) ADVANCE(654);
      END_STATE();
    case 338:
      if (lookahead == 'n') SKIP(237)
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          (lookahead < 'A' || 'Z' < lookahead) &&
          (lookahead < 'a' || 'z' < lookahead)) ADVANCE(654);
      END_STATE();
    case 339:
      if (lookahead == 'n') SKIP(236)
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          (lookahead < 'A' || 'Z' < lookahead) &&
          (lookahead < 'a' || 'z' < lookahead)) ADVANCE(654);
      END_STATE();
    case 340:
      if (lookahead == 'n') SKIP(217)
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          (lookahead < 'A' || 'Z' < lookahead) &&
          (lookahead < 'a' || 'z' < lookahead)) ADVANCE(654);
      END_STATE();
    case 341:
      if (lookahead == 'n') SKIP(210)
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          (lookahead < 'A' || 'Z' < lookahead) &&
          (lookahead < 'a' || 'z' < lookahead)) ADVANCE(654);
      END_STATE();
    case 342:
      if (lookahead == 'n') SKIP(241)
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          (lookahead < 'A' || 'Z' < lookahead) &&
          (lookahead < 'a' || 'z' < lookahead)) ADVANCE(654);
      END_STATE();
    case 343:
      if (lookahead == 'n') SKIP(218)
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          (lookahead < 'A' || 'Z' < lookahead) &&
          (lookahead < 'a' || 'z' < lookahead)) ADVANCE(654);
      END_STATE();
    case 344:
      if (lookahead == 'n') SKIP(219)
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          (lookahead < 'A' || 'Z' < lookahead) &&
          (lookahead < 'a' || 'z' < lookahead)) ADVANCE(654);
      END_STATE();
    case 345:
      if (lookahead == 'n') SKIP(227)
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          (lookahead < 'A' || 'Z' < lookahead) &&
          (lookahead < 'a' || 'z' < lookahead)) ADVANCE(654);
      END_STATE();
    case 346:
      if (lookahead == 'n') SKIP(238)
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          (lookahead < 'A' || 'Z' < lookahead) &&
          (lookahead < 'a' || 'z' < lookahead)) ADVANCE(654);
      END_STATE();
    case 347:
      if (lookahead == 'n') SKIP(191)
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          (lookahead < 'A' || 'Z' < lookahead) &&
          (lookahead < 'a' || 'z' < lookahead)) ADVANCE(654);
      END_STATE();
    case 348:
      if (lookahead == 'n') SKIP(239)
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          (lookahead < 'A' || 'Z' < lookahead) &&
          (lookahead < 'a' || 'z' < lookahead)) ADVANCE(654);
      END_STATE();
    case 349:
      if (lookahead == 'n') SKIP(193)
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          (lookahead < 'A' || 'Z' < lookahead) &&
          (lookahead < 'a' || 'z' < lookahead)) ADVANCE(654);
      END_STATE();
    case 350:
      if (lookahead == 'n') SKIP(203)
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          (lookahead < 'A' || 'Z' < lookahead) &&
          (lookahead < 'a' || 'z' < lookahead)) ADVANCE(654);
      END_STATE();
    case 351:
      if (lookahead == 'n') SKIP(220)
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          (lookahead < 'A' || 'Z' < lookahead) &&
          (lookahead < 'a' || 'z' < lookahead)) ADVANCE(654);
      END_STATE();
    case 352:
      if (lookahead == 'n') SKIP(228)
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          (lookahead < 'A' || 'Z' < lookahead) &&
          (lookahead < 'a' || 'z' < lookahead)) ADVANCE(654);
      END_STATE();
    case 353:
      if (lookahead == 'n') SKIP(221)
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          (lookahead < 'A' || 'Z' < lookahead) &&
          (lookahead < 'a' || 'z' < lookahead)) ADVANCE(654);
      END_STATE();
    case 354:
      if (lookahead == 'n') SKIP(195)
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          (lookahead < 'A' || 'Z' < lookahead) &&
          (lookahead < 'a' || 'z' < lookahead)) ADVANCE(654);
      END_STATE();
    case 355:
      if (lookahead == 'n') SKIP(229)
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          (lookahead < 'A' || 'Z' < lookahead) &&
          (lookahead < 'a' || 'z' < lookahead)) ADVANCE(654);
      END_STATE();
    case 356:
      if (lookahead == 'n') SKIP(204)
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          (lookahead < 'A' || 'Z' < lookahead) &&
          (lookahead < 'a' || 'z' < lookahead)) ADVANCE(654);
      END_STATE();
    case 357:
      if (lookahead == 'n') SKIP(192)
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          (lookahead < 'A' || 'Z' < lookahead) &&
          (lookahead < 'a' || 'z' < lookahead)) ADVANCE(654);
      END_STATE();
    case 358:
      if (lookahead == 'n') SKIP(222)
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          (lookahead < 'A' || 'Z' < lookahead) &&
          (lookahead < 'a' || 'z' < lookahead)) ADVANCE(654);
      END_STATE();
    case 359:
      if (lookahead == 'n') SKIP(194)
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          (lookahead < 'A' || 'Z' < lookahead) &&
          (lookahead < 'a' || 'z' < lookahead)) ADVANCE(654);
      END_STATE();
    case 360:
      if (lookahead == 'n') SKIP(223)
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          (lookahead < 'A' || 'Z' < lookahead) &&
          (lookahead < 'a' || 'z' < lookahead)) ADVANCE(654);
      END_STATE();
    case 361:
      if (lookahead == 'n') SKIP(230)
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          (lookahead < 'A' || 'Z' < lookahead) &&
          (lookahead < 'a' || 'z' < lookahead)) ADVANCE(654);
      END_STATE();
    case 362:
      if (lookahead == 'n') SKIP(213)
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          (lookahead < 'A' || 'Z' < lookahead) &&
          (lookahead < 'a' || 'z' < lookahead)) ADVANCE(654);
      END_STATE();
    case 363:
      if (lookahead == 'n') SKIP(214)
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          (lookahead < 'A' || 'Z' < lookahead) &&
          (lookahead < 'a' || 'z' < lookahead)) ADVANCE(654);
      END_STATE();
    case 364:
      if (lookahead == 'n') SKIP(205)
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          (lookahead < 'A' || 'Z' < lookahead) &&
          (lookahead < 'a' || 'z' < lookahead)) ADVANCE(654);
      END_STATE();
    case 365:
      if (lookahead == 'n') SKIP(196)
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          (lookahead < 'A' || 'Z' < lookahead) &&
          (lookahead < 'a' || 'z' < lookahead)) ADVANCE(654);
      END_STATE();
    case 366:
      if (lookahead == 'n') SKIP(224)
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          (lookahead < 'A' || 'Z' < lookahead) &&
          (lookahead < 'a' || 'z' < lookahead)) ADVANCE(654);
      END_STATE();
    case 367:
      if (lookahead == 'n') SKIP(225)
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          (lookahead < 'A' || 'Z' < lookahead) &&
          (lookahead < 'a' || 'z' < lookahead)) ADVANCE(654);
      END_STATE();
    case 368:
      if (lookahead == 'n') SKIP(231)
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          (lookahead < 'A' || 'Z' < lookahead) &&
          (lookahead < 'a' || 'z' < lookahead)) ADVANCE(654);
      END_STATE();
    case 369:
      if (lookahead == 'n') SKIP(206)
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          (lookahead < 'A' || 'Z' < lookahead) &&
          (lookahead < 'a' || 'z' < lookahead)) ADVANCE(654);
      END_STATE();
    case 370:
      if (lookahead == 'n') SKIP(226)
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          (lookahead < 'A' || 'Z' < lookahead) &&
          (lookahead < 'a' || 'z' < lookahead)) ADVANCE(654);
      END_STATE();
    case 371:
      if (lookahead == 'n') SKIP(232)
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          (lookahead < 'A' || 'Z' < lookahead) &&
          (lookahead < 'a' || 'z' < lookahead)) ADVANCE(654);
      END_STATE();
    case 372:
      if (lookahead == 'n') SKIP(233)
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          (lookahead < 'A' || 'Z' < lookahead) &&
          (lookahead < 'a' || 'z' < lookahead)) ADVANCE(654);
      END_STATE();
    case 373:
      if (lookahead == 'n') SKIP(234)
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          (lookahead < 'A' || 'Z' < lookahead) &&
          (lookahead < 'a' || 'z' < lookahead)) ADVANCE(654);
      END_STATE();
    case 374:
      if (lookahead == 'n') SKIP(235)
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          (lookahead < 'A' || 'Z' < lookahead) &&
          (lookahead < 'a' || 'z' < lookahead)) ADVANCE(654);
      END_STATE();
    case 375:
      if (lookahead == 'n') SKIP(215)
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          (lookahead < 'A' || 'Z' < lookahead) &&
          (lookahead < 'a' || 'z' < lookahead)) ADVANCE(654);
      END_STATE();
    case 376:
      if (lookahead == 'n') ADVANCE(669);
      END_STATE();
    case 377:
      if (lookahead == 'n') ADVANCE(273);
      END_STATE();
    case 378:
      if (lookahead == 'n') ADVANCE(273);
      if (lookahead == 'w') ADVANCE(431);
      END_STATE();
    case 379:
      if (lookahead == 'n') ADVANCE(285);
      END_STATE();
    case 380:
      if (lookahead == 'n') SKIP(216)
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          (lookahead < 'A' || 'Z' < lookahead) &&
          (lookahead < 'a' || 'z' < lookahead)) ADVANCE(654);
      END_STATE();
    case 381:
      if (lookahead == 'n') SKIP(252)
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          (lookahead < 'A' || 'Z' < lookahead) &&
          (lookahead < 'a' || 'z' < lookahead)) ADVANCE(654);
      END_STATE();
    case 382:
      if (lookahead == 'n') SKIP(186)
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          (lookahead < 'A' || 'Z' < lookahead) &&
          (lookahead < 'a' || 'z' < lookahead)) ADVANCE(589);
      END_STATE();
    case 383:
      if (lookahead == 'n') SKIP(242)
      END_STATE();
    case 384:
      if (lookahead == 'n') SKIP(251)
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          (lookahead < 'A' || 'Z' < lookahead) &&
          (lookahead < 'a' || 'z' < lookahead)) ADVANCE(589);
      END_STATE();
    case 385:
      if (lookahead == 'n') SKIP(253)
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          (lookahead < 'A' || 'Z' < lookahead) &&
          (lookahead < 'a' || 'z' < lookahead)) ADVANCE(654);
      END_STATE();
    case 386:
      if (lookahead == 'n') SKIP(254)
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          (lookahead < 'A' || 'Z' < lookahead) &&
          (lookahead < 'a' || 'z' < lookahead)) ADVANCE(654);
      END_STATE();
    case 387:
      if (lookahead == 'n') SKIP(259)
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          (lookahead < 'A' || 'Z' < lookahead) &&
          (lookahead < 'a' || 'z' < lookahead)) ADVANCE(654);
      END_STATE();
    case 388:
      if (lookahead == 'n') SKIP(243)
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          (lookahead < 'A' || 'Z' < lookahead) &&
          (lookahead < 'a' || 'z' < lookahead)) ADVANCE(654);
      END_STATE();
    case 389:
      if (lookahead == 'n') SKIP(244)
      END_STATE();
    case 390:
      if (lookahead == 'n') SKIP(256)
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          (lookahead < 'A' || 'Z' < lookahead) &&
          (lookahead < 'a' || 'z' < lookahead)) ADVANCE(654);
      END_STATE();
    case 391:
      if (lookahead == 'n') SKIP(257)
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          (lookahead < 'A' || 'Z' < lookahead) &&
          (lookahead < 'a' || 'z' < lookahead)) ADVANCE(654);
      END_STATE();
    case 392:
      if (lookahead == 'n') SKIP(60)
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          (lookahead < 'A' || 'Z' < lookahead) &&
          (lookahead < 'a' || 'z' < lookahead)) ADVANCE(589);
      END_STATE();
    case 393:
      if (lookahead == 'n') SKIP(61)
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          (lookahead < 'A' || 'Z' < lookahead) &&
          (lookahead < 'a' || 'z' < lookahead)) ADVANCE(589);
      END_STATE();
    case 394:
      if (lookahead == 'n') SKIP(62)
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          (lookahead < 'A' || 'Z' < lookahead) &&
          (lookahead < 'a' || 'z' < lookahead)) ADVANCE(589);
      END_STATE();
    case 395:
      if (lookahead == 'n') SKIP(63)
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          (lookahead < 'A' || 'Z' < lookahead) &&
          (lookahead < 'a' || 'z' < lookahead)) ADVANCE(589);
      END_STATE();
    case 396:
      if (lookahead == 'n') SKIP(105)
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          (lookahead < 'A' || 'Z' < lookahead) &&
          (lookahead < 'a' || 'z' < lookahead)) ADVANCE(589);
      END_STATE();
    case 397:
      if (lookahead == 'n') SKIP(106)
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          (lookahead < 'A' || 'Z' < lookahead) &&
          (lookahead < 'a' || 'z' < lookahead)) ADVANCE(589);
      END_STATE();
    case 398:
      if (lookahead == 'n') SKIP(107)
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          (lookahead < 'A' || 'Z' < lookahead) &&
          (lookahead < 'a' || 'z' < lookahead)) ADVANCE(589);
      END_STATE();
    case 399:
      if (lookahead == 'n') SKIP(9)
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          (lookahead < 'A' || 'Z' < lookahead) &&
          (lookahead < 'a' || 'z' < lookahead)) ADVANCE(589);
      END_STATE();
    case 400:
      if (lookahead == 'n') SKIP(67)
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          (lookahead < 'A' || 'Z' < lookahead) &&
          (lookahead < 'a' || 'z' < lookahead)) ADVANCE(589);
      END_STATE();
    case 401:
      if (lookahead == 'n') SKIP(108)
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          (lookahead < 'A' || 'Z' < lookahead) &&
          (lookahead < 'a' || 'z' < lookahead)) ADVANCE(589);
      END_STATE();
    case 402:
      if (lookahead == 'n') SKIP(109)
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          (lookahead < 'A' || 'Z' < lookahead) &&
          (lookahead < 'a' || 'z' < lookahead)) ADVANCE(589);
      END_STATE();
    case 403:
      if (lookahead == 'n') SKIP(16)
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          (lookahead < 'A' || 'Z' < lookahead) &&
          (lookahead < 'a' || 'z' < lookahead)) ADVANCE(589);
      END_STATE();
    case 404:
      if (lookahead == 'n') SKIP(66)
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          (lookahead < 'A' || 'Z' < lookahead) &&
          (lookahead < 'a' || 'z' < lookahead)) ADVANCE(589);
      END_STATE();
    case 405:
      if (lookahead == 'n') SKIP(12)
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          (lookahead < 'A' || 'Z' < lookahead) &&
          (lookahead < 'a' || 'z' < lookahead)) ADVANCE(589);
      END_STATE();
    case 406:
      if (lookahead == 'n') SKIP(72)
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          (lookahead < 'A' || 'Z' < lookahead) &&
          (lookahead < 'a' || 'z' < lookahead)) ADVANCE(589);
      END_STATE();
    case 407:
      if (lookahead == 'n') SKIP(110)
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          (lookahead < 'A' || 'Z' < lookahead) &&
          (lookahead < 'a' || 'z' < lookahead)) ADVANCE(589);
      END_STATE();
    case 408:
      if (lookahead == 'n') SKIP(113)
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          (lookahead < 'A' || 'Z' < lookahead) &&
          (lookahead < 'a' || 'z' < lookahead)) ADVANCE(589);
      END_STATE();
    case 409:
      if (lookahead == 'n') SKIP(112)
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          (lookahead < 'A' || 'Z' < lookahead) &&
          (lookahead < 'a' || 'z' < lookahead)) ADVANCE(589);
      END_STATE();
    case 410:
      if (lookahead == 'n') SKIP(111)
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          (lookahead < 'A' || 'Z' < lookahead) &&
          (lookahead < 'a' || 'z' < lookahead)) ADVANCE(589);
      END_STATE();
    case 411:
      if (lookahead == 'n') SKIP(73)
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          (lookahead < 'A' || 'Z' < lookahead) &&
          (lookahead < 'a' || 'z' < lookahead)) ADVANCE(589);
      END_STATE();
    case 412:
      if (lookahead == 'n') SKIP(200)
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          (lookahead < 'A' || 'Z' < lookahead) &&
          (lookahead < 'a' || 'z' < lookahead)) ADVANCE(654);
      END_STATE();
    case 413:
      if (lookahead == 'n') SKIP(202)
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          (lookahead < 'A' || 'Z' < lookahead) &&
          (lookahead < 'a' || 'z' < lookahead)) ADVANCE(654);
      END_STATE();
    case 414:
      if (lookahead == 'n') SKIP(211)
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          (lookahead < 'A' || 'Z' < lookahead) &&
          (lookahead < 'a' || 'z' < lookahead)) ADVANCE(654);
      END_STATE();
    case 415:
      if (lookahead == 'n') SKIP(212)
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          (lookahead < 'A' || 'Z' < lookahead) &&
          (lookahead < 'a' || 'z' < lookahead)) ADVANCE(654);
      END_STATE();
    case 416:
      if (lookahead == 'n') ADVANCE(433);
      END_STATE();
    case 417:
      if (lookahead == 'n') ADVANCE(286);
      END_STATE();
    case 418:
      if (lookahead == 'n') SKIP(255)
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          (lookahead < 'A' || 'Z' < lookahead) &&
          (lookahead < 'a' || 'z' < lookahead)) ADVANCE(654);
      END_STATE();
    case 419:
      if (lookahead == 'n') SKIP(42)
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          (lookahead < 'A' || 'Z' < lookahead) &&
          (lookahead < 'a' || 'z' < lookahead)) ADVANCE(589);
      END_STATE();
    case 420:
      if (lookahead == 'n') SKIP(43)
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          (lookahead < 'A' || 'Z' < lookahead) &&
          (lookahead < 'a' || 'z' < lookahead)) ADVANCE(589);
      END_STATE();
    case 421:
      if (lookahead == 'n') ADVANCE(287);
      END_STATE();
    case 422:
      if (lookahead == 'n') SKIP(64)
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          (lookahead < 'A' || 'Z' < lookahead) &&
          (lookahead < 'a' || 'z' < lookahead)) ADVANCE(589);
      END_STATE();
    case 423:
      if (lookahead == 'n') SKIP(65)
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          (lookahead < 'A' || 'Z' < lookahead) &&
          (lookahead < 'a' || 'z' < lookahead)) ADVANCE(589);
      END_STATE();
    case 424:
      if (lookahead == 'o') ADVANCE(507);
      END_STATE();
    case 425:
      if (lookahead == 'o') ADVANCE(416);
      END_STATE();
    case 426:
      if (lookahead == 'o') ADVANCE(277);
      END_STATE();
    case 427:
      if (lookahead == 'o') ADVANCE(428);
      END_STATE();
    case 428:
      if (lookahead == 'r') ADVANCE(487);
      END_STATE();
    case 429:
      if (lookahead == 'r') ADVANCE(440);
      END_STATE();
    case 430:
      if (lookahead == 'r') ADVANCE(280);
      END_STATE();
    case 431:
      if (lookahead == 'r') ADVANCE(294);
      END_STATE();
    case 432:
      if (lookahead == 's') ADVANCE(293);
      END_STATE();
    case 433:
      if (lookahead == 's') ADVANCE(435);
      END_STATE();
    case 434:
      if (lookahead == 't') ADVANCE(288);
      END_STATE();
    case 435:
      if (lookahead == 't') ADVANCE(429);
      END_STATE();
    case 436:
      if (lookahead == 't') ADVANCE(427);
      END_STATE();
    case 437:
      if (lookahead == 't') ADVANCE(282);
      END_STATE();
    case 438:
      if (lookahead == 'u') ADVANCE(274);
      END_STATE();
    case 439:
      if (lookahead == 'u') ADVANCE(298);
      END_STATE();
    case 440:
      if (lookahead == 'u') ADVANCE(276);
      END_STATE();
    case 441:
      if (lookahead == '}') ADVANCE(523);
      END_STATE();
    case 442:
      if (lookahead == '}') ADVANCE(683);
      if (lookahead != 0) ADVANCE(250);
      END_STATE();
    case 443:
      if (lookahead == '}') ADVANCE(519);
      if (lookahead != 0) ADVANCE(190);
      END_STATE();
    case 444:
      if (lookahead == '}') ADVANCE(510);
      END_STATE();
    case 445:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(681);
      END_STATE();
    case 446:
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          (lookahead < 'A' || 'Z' < lookahead) &&
          (lookahead < 'a' || 'z' < lookahead)) ADVANCE(655);
      END_STATE();
    case 447:
      if (!sym_id_character_set_1(lookahead)) ADVANCE(654);
      END_STATE();
    case 448:
      if (!sym_id_character_set_1(lookahead)) ADVANCE(589);
      END_STATE();
    case 449:
      if (!sym_id_character_set_1(lookahead)) ADVANCE(655);
      END_STATE();
    case 450:
      if (eof) ADVANCE(453);
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '(') ADVANCE(497);
      if (lookahead == '-') ADVANCE(534);
      if (lookahead == '.') ADVANCE(658);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == ';') ADVANCE(654);
      if (lookahead == '@') ADVANCE(665);
      if (lookahead == '\\') ADVANCE(462);
      if (lookahead == '_') ADVANCE(518);
      if (lookahead == 'm') ADVANCE(569);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == 955) ADVANCE(464);
      if (lookahead == 8230) ADVANCE(467);
      if (lookahead == 8704) ADVANCE(454);
      if (lookahead == 10627) ADVANCE(512);
      if (lookahead == 10631) ADVANCE(674);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(450)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (lookahead != 0 &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != '}') ADVANCE(589);
      END_STATE();
    case 451:
      if (eof) ADVANCE(453);
      if (lookahead == '#') ADVANCE(262);
      if (lookahead == '(') ADVANCE(496);
      if (lookahead == ')') ADVANCE(498);
      if (lookahead == '-') ADVANCE(247);
      if (lookahead == '.') ADVANCE(659);
      if (lookahead == '0') ADVANCE(679);
      if (lookahead == ':') ADVANCE(469);
      if (lookahead == ';') ADVANCE(505);
      if (lookahead == '=') ADVANCE(472);
      if (lookahead == 'C') ADVANCE(265);
      if (lookahead == '\\') SKIP(452)
      if (lookahead == 'c') ADVANCE(425);
      if (lookahead == 'h') ADVANCE(291);
      if (lookahead == 'i') ADVANCE(376);
      if (lookahead == 'm') ADVANCE(426);
      if (lookahead == 'p') ADVANCE(438);
      if (lookahead == 'r') ADVANCE(279);
      if (lookahead == 't') ADVANCE(424);
      if (lookahead == 'u') ADVANCE(432);
      if (lookahead == 'w') ADVANCE(290);
      if (lookahead == '{') ADVANCE(526);
      if (lookahead == '|') ADVANCE(245);
      if (lookahead == '}') ADVANCE(444);
      if (lookahead == 8594) ADVANCE(459);
      if (lookahead == 10627) ADVANCE(511);
      if (lookahead == 10628) ADVANCE(514);
      if (lookahead == 10632) ADVANCE(676);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(451)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(680);
      END_STATE();
    case 452:
      if (eof) ADVANCE(453);
      if (lookahead == 'n') SKIP(451)
      END_STATE();
    case 453:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 454:
      ACCEPT_TOKEN(anon_sym_u2200);
      if (lookahead == '.') ADVANCE(272);
      if (!sym_id_character_set_2(lookahead)) ADVANCE(589);
      END_STATE();
    case 455:
      ACCEPT_TOKEN(anon_sym_u2200);
      if (!sym_id_character_set_1(lookahead)) ADVANCE(654);
      END_STATE();
    case 456:
      ACCEPT_TOKEN(anon_sym_DASH_GT);
      END_STATE();
    case 457:
      ACCEPT_TOKEN(anon_sym_DASH_GT);
      if (lookahead == '.') ADVANCE(272);
      if (!sym_id_character_set_2(lookahead)) ADVANCE(589);
      END_STATE();
    case 458:
      ACCEPT_TOKEN(anon_sym_DASH_GT);
      if (!sym_id_character_set_1(lookahead)) ADVANCE(654);
      END_STATE();
    case 459:
      ACCEPT_TOKEN(anon_sym_u2192);
      END_STATE();
    case 460:
      ACCEPT_TOKEN(anon_sym_u2192);
      if (lookahead == '.') ADVANCE(272);
      if (!sym_id_character_set_2(lookahead)) ADVANCE(589);
      END_STATE();
    case 461:
      ACCEPT_TOKEN(anon_sym_u2192);
      if (!sym_id_character_set_1(lookahead)) ADVANCE(654);
      END_STATE();
    case 462:
      ACCEPT_TOKEN(anon_sym_BSLASH);
      END_STATE();
    case 463:
      ACCEPT_TOKEN(anon_sym_u03bb);
      END_STATE();
    case 464:
      ACCEPT_TOKEN(anon_sym_u03bb);
      if (lookahead == '.') ADVANCE(272);
      if (!sym_id_character_set_2(lookahead)) ADVANCE(589);
      END_STATE();
    case 465:
      ACCEPT_TOKEN(anon_sym_u03bb);
      if (!sym_id_character_set_1(lookahead)) ADVANCE(654);
      END_STATE();
    case 466:
      ACCEPT_TOKEN(anon_sym_DOT_DOT_DOT);
      END_STATE();
    case 467:
      ACCEPT_TOKEN(anon_sym_u2026);
      if (lookahead == '.') ADVANCE(272);
      if (!sym_id_character_set_2(lookahead)) ADVANCE(589);
      END_STATE();
    case 468:
      ACCEPT_TOKEN(anon_sym_u2026);
      if (!sym_id_character_set_1(lookahead)) ADVANCE(654);
      END_STATE();
    case 469:
      ACCEPT_TOKEN(anon_sym_COLON);
      END_STATE();
    case 470:
      ACCEPT_TOKEN(anon_sym_COLON);
      if (lookahead == '.') ADVANCE(272);
      if (!sym_id_character_set_2(lookahead)) ADVANCE(589);
      END_STATE();
    case 471:
      ACCEPT_TOKEN(anon_sym_COLON);
      if (!sym_id_character_set_1(lookahead)) ADVANCE(654);
      END_STATE();
    case 472:
      ACCEPT_TOKEN(anon_sym_EQ);
      END_STATE();
    case 473:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '.') ADVANCE(272);
      if (!sym_id_character_set_2(lookahead)) ADVANCE(589);
      END_STATE();
    case 474:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (!sym_id_character_set_1(lookahead)) ADVANCE(654);
      END_STATE();
    case 475:
      ACCEPT_TOKEN(anon_sym_with);
      END_STATE();
    case 476:
      ACCEPT_TOKEN(anon_sym_with);
      if (lookahead == '.') ADVANCE(272);
      if (!sym_id_character_set_2(lookahead)) ADVANCE(589);
      END_STATE();
    case 477:
      ACCEPT_TOKEN(anon_sym_with);
      if (!sym_id_character_set_1(lookahead)) ADVANCE(654);
      END_STATE();
    case 478:
      ACCEPT_TOKEN(anon_sym_rewrite);
      END_STATE();
    case 479:
      ACCEPT_TOKEN(anon_sym_rewrite);
      if (lookahead == '.') ADVANCE(272);
      if (!sym_id_character_set_2(lookahead)) ADVANCE(589);
      END_STATE();
    case 480:
      ACCEPT_TOKEN(anon_sym_rewrite);
      if (!sym_id_character_set_1(lookahead)) ADVANCE(654);
      END_STATE();
    case 481:
      ACCEPT_TOKEN(anon_sym_module);
      END_STATE();
    case 482:
      ACCEPT_TOKEN(anon_sym_module);
      if (lookahead == '.') ADVANCE(272);
      if (!sym_id_character_set_2(lookahead)) ADVANCE(589);
      END_STATE();
    case 483:
      ACCEPT_TOKEN(anon_sym_module);
      if (!sym_id_character_set_1(lookahead)) ADVANCE(654);
      END_STATE();
    case 484:
      ACCEPT_TOKEN(anon_sym_where);
      END_STATE();
    case 485:
      ACCEPT_TOKEN(anon_sym_where);
      if (lookahead == '.') ADVANCE(272);
      if (!sym_id_character_set_2(lookahead)) ADVANCE(589);
      END_STATE();
    case 486:
      ACCEPT_TOKEN(anon_sym_where);
      if (!sym_id_character_set_1(lookahead)) ADVANCE(654);
      END_STATE();
    case 487:
      ACCEPT_TOKEN(anon_sym_constructor);
      END_STATE();
    case 488:
      ACCEPT_TOKEN(anon_sym_constructor);
      if (lookahead == '.') ADVANCE(272);
      if (!sym_id_character_set_2(lookahead)) ADVANCE(589);
      END_STATE();
    case 489:
      ACCEPT_TOKEN(anon_sym_constructor);
      if (!sym_id_character_set_1(lookahead)) ADVANCE(654);
      END_STATE();
    case 490:
      ACCEPT_TOKEN(anon_sym_public);
      END_STATE();
    case 491:
      ACCEPT_TOKEN(anon_sym_public);
      if (lookahead == '.') ADVANCE(272);
      if (!sym_id_character_set_2(lookahead)) ADVANCE(589);
      END_STATE();
    case 492:
      ACCEPT_TOKEN(anon_sym_public);
      if (!sym_id_character_set_1(lookahead)) ADVANCE(654);
      END_STATE();
    case 493:
      ACCEPT_TOKEN(anon_sym_using);
      END_STATE();
    case 494:
      ACCEPT_TOKEN(anon_sym_using);
      if (lookahead == '.') ADVANCE(272);
      if (!sym_id_character_set_2(lookahead)) ADVANCE(589);
      END_STATE();
    case 495:
      ACCEPT_TOKEN(anon_sym_using);
      if (!sym_id_character_set_1(lookahead)) ADVANCE(654);
      END_STATE();
    case 496:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 497:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      if (lookahead == '|') ADVANCE(672);
      END_STATE();
    case 498:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 499:
      ACCEPT_TOKEN(anon_sym_hiding);
      END_STATE();
    case 500:
      ACCEPT_TOKEN(anon_sym_hiding);
      if (lookahead == '.') ADVANCE(272);
      if (!sym_id_character_set_2(lookahead)) ADVANCE(589);
      END_STATE();
    case 501:
      ACCEPT_TOKEN(anon_sym_hiding);
      if (!sym_id_character_set_1(lookahead)) ADVANCE(654);
      END_STATE();
    case 502:
      ACCEPT_TOKEN(anon_sym_renaming);
      END_STATE();
    case 503:
      ACCEPT_TOKEN(anon_sym_renaming);
      if (lookahead == '.') ADVANCE(272);
      if (!sym_id_character_set_2(lookahead)) ADVANCE(589);
      END_STATE();
    case 504:
      ACCEPT_TOKEN(anon_sym_renaming);
      if (!sym_id_character_set_1(lookahead)) ADVANCE(654);
      END_STATE();
    case 505:
      ACCEPT_TOKEN(anon_sym_SEMI);
      END_STATE();
    case 506:
      ACCEPT_TOKEN(anon_sym_SEMI);
      if (!sym_id_character_set_1(lookahead)) ADVANCE(654);
      END_STATE();
    case 507:
      ACCEPT_TOKEN(anon_sym_to);
      END_STATE();
    case 508:
      ACCEPT_TOKEN(anon_sym_to);
      if (!sym_id_character_set_1(lookahead)) ADVANCE(654);
      END_STATE();
    case 509:
      ACCEPT_TOKEN(anon_sym_LBRACE_LBRACE);
      END_STATE();
    case 510:
      ACCEPT_TOKEN(anon_sym_RBRACE_RBRACE);
      END_STATE();
    case 511:
      ACCEPT_TOKEN(anon_sym_u2983);
      END_STATE();
    case 512:
      ACCEPT_TOKEN(anon_sym_u2983);
      if (lookahead == '.') ADVANCE(272);
      if (!sym_id_character_set_2(lookahead)) ADVANCE(589);
      END_STATE();
    case 513:
      ACCEPT_TOKEN(anon_sym_u2983);
      if (!sym_id_character_set_1(lookahead)) ADVANCE(654);
      END_STATE();
    case 514:
      ACCEPT_TOKEN(anon_sym_u2984);
      END_STATE();
    case 515:
      ACCEPT_TOKEN(anon_sym_u2984);
      if (lookahead == '.') ADVANCE(272);
      if (!sym_id_character_set_2(lookahead)) ADVANCE(589);
      END_STATE();
    case 516:
      ACCEPT_TOKEN(anon_sym_u2984);
      if (!sym_id_character_set_1(lookahead)) ADVANCE(654);
      END_STATE();
    case 517:
      ACCEPT_TOKEN(anon_sym__);
      if (!sym_id_character_set_1(lookahead)) ADVANCE(654);
      END_STATE();
    case 518:
      ACCEPT_TOKEN(anon_sym__);
      if (!sym_id_character_set_1(lookahead)) ADVANCE(589);
      END_STATE();
    case 519:
      ACCEPT_TOKEN(sym_pragma);
      END_STATE();
    case 520:
      ACCEPT_TOKEN(anon_sym_LBRACE_DASH_POUND);
      if (lookahead == '#') ADVANCE(261);
      if (lookahead != 0) ADVANCE(190);
      END_STATE();
    case 521:
      ACCEPT_TOKEN(anon_sym_CATCHALL);
      END_STATE();
    case 522:
      ACCEPT_TOKEN(anon_sym_CATCHALL);
      if (!sym_id_character_set_1(lookahead)) ADVANCE(654);
      END_STATE();
    case 523:
      ACCEPT_TOKEN(anon_sym_POUND_DASH_RBRACE);
      END_STATE();
    case 524:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      if (lookahead == '-') ADVANCE(188);
      if (lookahead == '{') ADVANCE(509);
      END_STATE();
    case 525:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      if (lookahead == '-') ADVANCE(189);
      END_STATE();
    case 526:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      if (lookahead == '-') ADVANCE(189);
      if (lookahead == '{') ADVANCE(509);
      END_STATE();
    case 527:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 528:
      ACCEPT_TOKEN(sym_id);
      if (lookahead == ')') ADVANCE(673);
      if (lookahead == '.') ADVANCE(272);
      if (!sym_id_character_set_3(lookahead)) ADVANCE(589);
      END_STATE();
    case 529:
      ACCEPT_TOKEN(sym_id);
      if (lookahead == ')') ADVANCE(673);
      if (!sym_id_character_set_4(lookahead)) ADVANCE(654);
      END_STATE();
    case 530:
      ACCEPT_TOKEN(sym_id);
      if (lookahead == '-') ADVANCE(650);
      if (!sym_id_character_set_1(lookahead)) ADVANCE(654);
      END_STATE();
    case 531:
      ACCEPT_TOKEN(sym_id);
      if (lookahead == '-') ADVANCE(652);
      if (lookahead == '>') ADVANCE(458);
      if (!sym_id_character_set_1(lookahead)) ADVANCE(654);
      END_STATE();
    case 532:
      ACCEPT_TOKEN(sym_id);
      if (lookahead == '-') ADVANCE(652);
      if (!sym_id_character_set_1(lookahead)) ADVANCE(654);
      END_STATE();
    case 533:
      ACCEPT_TOKEN(sym_id);
      if (lookahead == '-') ADVANCE(590);
      if (lookahead == '.') ADVANCE(272);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == '>') ADVANCE(457);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (!sym_id_character_set_2(lookahead)) ADVANCE(589);
      END_STATE();
    case 534:
      ACCEPT_TOKEN(sym_id);
      if (lookahead == '-') ADVANCE(590);
      if (lookahead == '.') ADVANCE(272);
      if (lookahead == '0') ADVANCE(586);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (!sym_id_character_set_2(lookahead)) ADVANCE(589);
      END_STATE();
    case 535:
      ACCEPT_TOKEN(sym_id);
      if (lookahead == '-') ADVANCE(590);
      if (lookahead == '.') ADVANCE(272);
      if (!sym_id_character_set_2(lookahead)) ADVANCE(589);
      END_STATE();
    case 536:
      ACCEPT_TOKEN(sym_id);
      if (lookahead == '.') ADVANCE(272);
      if (lookahead == 'a') ADVANCE(562);
      if (!sym_id_character_set_2(lookahead)) ADVANCE(589);
      END_STATE();
    case 537:
      ACCEPT_TOKEN(sym_id);
      if (lookahead == '.') ADVANCE(272);
      if (lookahead == 'b') ADVANCE(561);
      if (!sym_id_character_set_2(lookahead)) ADVANCE(589);
      END_STATE();
    case 538:
      ACCEPT_TOKEN(sym_id);
      if (lookahead == '.') ADVANCE(272);
      if (lookahead == 'c') ADVANCE(491);
      if (!sym_id_character_set_2(lookahead)) ADVANCE(589);
      END_STATE();
    case 539:
      ACCEPT_TOKEN(sym_id);
      if (lookahead == '.') ADVANCE(272);
      if (lookahead == 'c') ADVANCE(580);
      if (!sym_id_character_set_2(lookahead)) ADVANCE(589);
      END_STATE();
    case 540:
      ACCEPT_TOKEN(sym_id);
      if (lookahead == '.') ADVANCE(272);
      if (lookahead == 'd') ADVANCE(582);
      if (!sym_id_character_set_2(lookahead)) ADVANCE(589);
      END_STATE();
    case 541:
      ACCEPT_TOKEN(sym_id);
      if (lookahead == '.') ADVANCE(272);
      if (lookahead == 'd') ADVANCE(558);
      if (!sym_id_character_set_2(lookahead)) ADVANCE(589);
      END_STATE();
    case 542:
      ACCEPT_TOKEN(sym_id);
      if (lookahead == '.') ADVANCE(272);
      if (lookahead == 'e') ADVANCE(482);
      if (!sym_id_character_set_2(lookahead)) ADVANCE(589);
      END_STATE();
    case 543:
      ACCEPT_TOKEN(sym_id);
      if (lookahead == '.') ADVANCE(272);
      if (lookahead == 'e') ADVANCE(585);
      if (!sym_id_character_set_2(lookahead)) ADVANCE(589);
      END_STATE();
    case 544:
      ACCEPT_TOKEN(sym_id);
      if (lookahead == '.') ADVANCE(272);
      if (lookahead == 'e') ADVANCE(485);
      if (!sym_id_character_set_2(lookahead)) ADVANCE(589);
      END_STATE();
    case 545:
      ACCEPT_TOKEN(sym_id);
      if (lookahead == '.') ADVANCE(272);
      if (lookahead == 'e') ADVANCE(479);
      if (!sym_id_character_set_2(lookahead)) ADVANCE(589);
      END_STATE();
    case 546:
      ACCEPT_TOKEN(sym_id);
      if (lookahead == '.') ADVANCE(272);
      if (lookahead == 'e') ADVANCE(565);
      if (!sym_id_character_set_2(lookahead)) ADVANCE(589);
      END_STATE();
    case 547:
      ACCEPT_TOKEN(sym_id);
      if (lookahead == '.') ADVANCE(272);
      if (lookahead == 'e') ADVANCE(575);
      if (!sym_id_character_set_2(lookahead)) ADVANCE(589);
      END_STATE();
    case 548:
      ACCEPT_TOKEN(sym_id);
      if (lookahead == '.') ADVANCE(272);
      if (lookahead == 'g') ADVANCE(494);
      if (!sym_id_character_set_2(lookahead)) ADVANCE(589);
      END_STATE();
    case 549:
      ACCEPT_TOKEN(sym_id);
      if (lookahead == '.') ADVANCE(272);
      if (lookahead == 'g') ADVANCE(500);
      if (!sym_id_character_set_2(lookahead)) ADVANCE(589);
      END_STATE();
    case 550:
      ACCEPT_TOKEN(sym_id);
      if (lookahead == '.') ADVANCE(272);
      if (lookahead == 'g') ADVANCE(503);
      if (!sym_id_character_set_2(lookahead)) ADVANCE(589);
      END_STATE();
    case 551:
      ACCEPT_TOKEN(sym_id);
      if (lookahead == '.') ADVANCE(272);
      if (lookahead == 'h') ADVANCE(476);
      if (!sym_id_character_set_2(lookahead)) ADVANCE(589);
      END_STATE();
    case 552:
      ACCEPT_TOKEN(sym_id);
      if (lookahead == '.') ADVANCE(272);
      if (lookahead == 'h') ADVANCE(547);
      if (lookahead == 'i') ADVANCE(579);
      if (!sym_id_character_set_2(lookahead)) ADVANCE(589);
      END_STATE();
    case 553:
      ACCEPT_TOKEN(sym_id);
      if (lookahead == '.') ADVANCE(272);
      if (lookahead == 'h') ADVANCE(547);
      if (!sym_id_character_set_2(lookahead)) ADVANCE(589);
      END_STATE();
    case 554:
      ACCEPT_TOKEN(sym_id);
      if (lookahead == '.') ADVANCE(272);
      if (lookahead == 'i') ADVANCE(541);
      if (!sym_id_character_set_2(lookahead)) ADVANCE(589);
      END_STATE();
    case 555:
      ACCEPT_TOKEN(sym_id);
      if (lookahead == '.') ADVANCE(272);
      if (lookahead == 'i') ADVANCE(538);
      if (!sym_id_character_set_2(lookahead)) ADVANCE(589);
      END_STATE();
    case 556:
      ACCEPT_TOKEN(sym_id);
      if (lookahead == '.') ADVANCE(272);
      if (lookahead == 'i') ADVANCE(566);
      if (!sym_id_character_set_2(lookahead)) ADVANCE(589);
      END_STATE();
    case 557:
      ACCEPT_TOKEN(sym_id);
      if (lookahead == '.') ADVANCE(272);
      if (lookahead == 'i') ADVANCE(581);
      if (!sym_id_character_set_2(lookahead)) ADVANCE(589);
      END_STATE();
    case 558:
      ACCEPT_TOKEN(sym_id);
      if (lookahead == '.') ADVANCE(272);
      if (lookahead == 'i') ADVANCE(567);
      if (!sym_id_character_set_2(lookahead)) ADVANCE(589);
      END_STATE();
    case 559:
      ACCEPT_TOKEN(sym_id);
      if (lookahead == '.') ADVANCE(272);
      if (lookahead == 'i') ADVANCE(568);
      if (!sym_id_character_set_2(lookahead)) ADVANCE(589);
      END_STATE();
    case 560:
      ACCEPT_TOKEN(sym_id);
      if (lookahead == '.') ADVANCE(272);
      if (lookahead == 'l') ADVANCE(542);
      if (!sym_id_character_set_2(lookahead)) ADVANCE(589);
      END_STATE();
    case 561:
      ACCEPT_TOKEN(sym_id);
      if (lookahead == '.') ADVANCE(272);
      if (lookahead == 'l') ADVANCE(555);
      if (!sym_id_character_set_2(lookahead)) ADVANCE(589);
      END_STATE();
    case 562:
      ACCEPT_TOKEN(sym_id);
      if (lookahead == '.') ADVANCE(272);
      if (lookahead == 'm') ADVANCE(559);
      if (!sym_id_character_set_2(lookahead)) ADVANCE(589);
      END_STATE();
    case 563:
      ACCEPT_TOKEN(sym_id);
      if (lookahead == '.') ADVANCE(272);
      if (lookahead == 'n') ADVANCE(576);
      if (!sym_id_character_set_2(lookahead)) ADVANCE(589);
      END_STATE();
    case 564:
      ACCEPT_TOKEN(sym_id);
      if (lookahead == '.') ADVANCE(272);
      if (lookahead == 'n') ADVANCE(670);
      if (!sym_id_character_set_2(lookahead)) ADVANCE(589);
      END_STATE();
    case 565:
      ACCEPT_TOKEN(sym_id);
      if (lookahead == '.') ADVANCE(272);
      if (lookahead == 'n') ADVANCE(536);
      if (!sym_id_character_set_2(lookahead)) ADVANCE(589);
      END_STATE();
    case 566:
      ACCEPT_TOKEN(sym_id);
      if (lookahead == '.') ADVANCE(272);
      if (lookahead == 'n') ADVANCE(548);
      if (!sym_id_character_set_2(lookahead)) ADVANCE(589);
      END_STATE();
    case 567:
      ACCEPT_TOKEN(sym_id);
      if (lookahead == '.') ADVANCE(272);
      if (lookahead == 'n') ADVANCE(549);
      if (!sym_id_character_set_2(lookahead)) ADVANCE(589);
      END_STATE();
    case 568:
      ACCEPT_TOKEN(sym_id);
      if (lookahead == '.') ADVANCE(272);
      if (lookahead == 'n') ADVANCE(550);
      if (!sym_id_character_set_2(lookahead)) ADVANCE(589);
      END_STATE();
    case 569:
      ACCEPT_TOKEN(sym_id);
      if (lookahead == '.') ADVANCE(272);
      if (lookahead == 'o') ADVANCE(540);
      if (!sym_id_character_set_2(lookahead)) ADVANCE(589);
      END_STATE();
    case 570:
      ACCEPT_TOKEN(sym_id);
      if (lookahead == '.') ADVANCE(272);
      if (lookahead == 'o') ADVANCE(563);
      if (!sym_id_character_set_2(lookahead)) ADVANCE(589);
      END_STATE();
    case 571:
      ACCEPT_TOKEN(sym_id);
      if (lookahead == '.') ADVANCE(272);
      if (lookahead == 'o') ADVANCE(572);
      if (!sym_id_character_set_2(lookahead)) ADVANCE(589);
      END_STATE();
    case 572:
      ACCEPT_TOKEN(sym_id);
      if (lookahead == '.') ADVANCE(272);
      if (lookahead == 'r') ADVANCE(488);
      if (!sym_id_character_set_2(lookahead)) ADVANCE(589);
      END_STATE();
    case 573:
      ACCEPT_TOKEN(sym_id);
      if (lookahead == '.') ADVANCE(272);
      if (lookahead == 'r') ADVANCE(557);
      if (!sym_id_character_set_2(lookahead)) ADVANCE(589);
      END_STATE();
    case 574:
      ACCEPT_TOKEN(sym_id);
      if (lookahead == '.') ADVANCE(272);
      if (lookahead == 'r') ADVANCE(583);
      if (!sym_id_character_set_2(lookahead)) ADVANCE(589);
      END_STATE();
    case 575:
      ACCEPT_TOKEN(sym_id);
      if (lookahead == '.') ADVANCE(272);
      if (lookahead == 'r') ADVANCE(544);
      if (!sym_id_character_set_2(lookahead)) ADVANCE(589);
      END_STATE();
    case 576:
      ACCEPT_TOKEN(sym_id);
      if (lookahead == '.') ADVANCE(272);
      if (lookahead == 's') ADVANCE(578);
      if (!sym_id_character_set_2(lookahead)) ADVANCE(589);
      END_STATE();
    case 577:
      ACCEPT_TOKEN(sym_id);
      if (lookahead == '.') ADVANCE(272);
      if (lookahead == 's') ADVANCE(556);
      if (!sym_id_character_set_2(lookahead)) ADVANCE(589);
      END_STATE();
    case 578:
      ACCEPT_TOKEN(sym_id);
      if (lookahead == '.') ADVANCE(272);
      if (lookahead == 't') ADVANCE(574);
      if (!sym_id_character_set_2(lookahead)) ADVANCE(589);
      END_STATE();
    case 579:
      ACCEPT_TOKEN(sym_id);
      if (lookahead == '.') ADVANCE(272);
      if (lookahead == 't') ADVANCE(551);
      if (!sym_id_character_set_2(lookahead)) ADVANCE(589);
      END_STATE();
    case 580:
      ACCEPT_TOKEN(sym_id);
      if (lookahead == '.') ADVANCE(272);
      if (lookahead == 't') ADVANCE(571);
      if (!sym_id_character_set_2(lookahead)) ADVANCE(589);
      END_STATE();
    case 581:
      ACCEPT_TOKEN(sym_id);
      if (lookahead == '.') ADVANCE(272);
      if (lookahead == 't') ADVANCE(545);
      if (!sym_id_character_set_2(lookahead)) ADVANCE(589);
      END_STATE();
    case 582:
      ACCEPT_TOKEN(sym_id);
      if (lookahead == '.') ADVANCE(272);
      if (lookahead == 'u') ADVANCE(560);
      if (!sym_id_character_set_2(lookahead)) ADVANCE(589);
      END_STATE();
    case 583:
      ACCEPT_TOKEN(sym_id);
      if (lookahead == '.') ADVANCE(272);
      if (lookahead == 'u') ADVANCE(539);
      if (!sym_id_character_set_2(lookahead)) ADVANCE(589);
      END_STATE();
    case 584:
      ACCEPT_TOKEN(sym_id);
      if (lookahead == '.') ADVANCE(272);
      if (lookahead == 'u') ADVANCE(537);
      if (!sym_id_character_set_2(lookahead)) ADVANCE(589);
      END_STATE();
    case 585:
      ACCEPT_TOKEN(sym_id);
      if (lookahead == '.') ADVANCE(272);
      if (lookahead == 'w') ADVANCE(573);
      if (!sym_id_character_set_2(lookahead)) ADVANCE(589);
      END_STATE();
    case 586:
      ACCEPT_TOKEN(sym_id);
      if (lookahead == '.') ADVANCE(272);
      if (lookahead == 'x') ADVANCE(588);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (!sym_id_character_set_2(lookahead)) ADVANCE(589);
      END_STATE();
    case 587:
      ACCEPT_TOKEN(sym_id);
      if (lookahead == '.') ADVANCE(272);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (!sym_id_character_set_2(lookahead)) ADVANCE(589);
      END_STATE();
    case 588:
      ACCEPT_TOKEN(sym_id);
      if (lookahead == '.') ADVANCE(272);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(588);
      if (!sym_id_character_set_2(lookahead)) ADVANCE(589);
      END_STATE();
    case 589:
      ACCEPT_TOKEN(sym_id);
      if (lookahead == '.') ADVANCE(272);
      if (!sym_id_character_set_2(lookahead)) ADVANCE(589);
      END_STATE();
    case 590:
      ACCEPT_TOKEN(sym_id);
      if (lookahead == '.') ADVANCE(685);
      if (sym_comment_character_set_1(lookahead)) ADVANCE(688);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(590);
      END_STATE();
    case 591:
      ACCEPT_TOKEN(sym_id);
      if (lookahead == 'A') ADVANCE(597);
      if (!sym_id_character_set_1(lookahead)) ADVANCE(654);
      END_STATE();
    case 592:
      ACCEPT_TOKEN(sym_id);
      if (lookahead == 'A') ADVANCE(596);
      if (!sym_id_character_set_1(lookahead)) ADVANCE(654);
      END_STATE();
    case 593:
      ACCEPT_TOKEN(sym_id);
      if (lookahead == 'C') ADVANCE(594);
      if (!sym_id_character_set_1(lookahead)) ADVANCE(654);
      END_STATE();
    case 594:
      ACCEPT_TOKEN(sym_id);
      if (lookahead == 'H') ADVANCE(592);
      if (!sym_id_character_set_1(lookahead)) ADVANCE(654);
      END_STATE();
    case 595:
      ACCEPT_TOKEN(sym_id);
      if (lookahead == 'L') ADVANCE(522);
      if (!sym_id_character_set_1(lookahead)) ADVANCE(654);
      END_STATE();
    case 596:
      ACCEPT_TOKEN(sym_id);
      if (lookahead == 'L') ADVANCE(595);
      if (!sym_id_character_set_1(lookahead)) ADVANCE(654);
      END_STATE();
    case 597:
      ACCEPT_TOKEN(sym_id);
      if (lookahead == 'T') ADVANCE(593);
      if (!sym_id_character_set_1(lookahead)) ADVANCE(654);
      END_STATE();
    case 598:
      ACCEPT_TOKEN(sym_id);
      if (lookahead == 'a') ADVANCE(624);
      if (!sym_id_character_set_1(lookahead)) ADVANCE(654);
      END_STATE();
    case 599:
      ACCEPT_TOKEN(sym_id);
      if (lookahead == 'b') ADVANCE(622);
      if (!sym_id_character_set_1(lookahead)) ADVANCE(654);
      END_STATE();
    case 600:
      ACCEPT_TOKEN(sym_id);
      if (lookahead == 'c') ADVANCE(492);
      if (!sym_id_character_set_1(lookahead)) ADVANCE(654);
      END_STATE();
    case 601:
      ACCEPT_TOKEN(sym_id);
      if (lookahead == 'c') ADVANCE(643);
      if (!sym_id_character_set_1(lookahead)) ADVANCE(654);
      END_STATE();
    case 602:
      ACCEPT_TOKEN(sym_id);
      if (lookahead == 'd') ADVANCE(646);
      if (!sym_id_character_set_1(lookahead)) ADVANCE(654);
      END_STATE();
    case 603:
      ACCEPT_TOKEN(sym_id);
      if (lookahead == 'd') ADVANCE(620);
      if (!sym_id_character_set_1(lookahead)) ADVANCE(654);
      END_STATE();
    case 604:
      ACCEPT_TOKEN(sym_id);
      if (lookahead == 'e') ADVANCE(626);
      if (!sym_id_character_set_1(lookahead)) ADVANCE(654);
      END_STATE();
    case 605:
      ACCEPT_TOKEN(sym_id);
      if (lookahead == 'e') ADVANCE(486);
      if (!sym_id_character_set_1(lookahead)) ADVANCE(654);
      END_STATE();
    case 606:
      ACCEPT_TOKEN(sym_id);
      if (lookahead == 'e') ADVANCE(483);
      if (!sym_id_character_set_1(lookahead)) ADVANCE(654);
      END_STATE();
    case 607:
      ACCEPT_TOKEN(sym_id);
      if (lookahead == 'e') ADVANCE(480);
      if (!sym_id_character_set_1(lookahead)) ADVANCE(654);
      END_STATE();
    case 608:
      ACCEPT_TOKEN(sym_id);
      if (lookahead == 'e') ADVANCE(648);
      if (!sym_id_character_set_1(lookahead)) ADVANCE(654);
      END_STATE();
    case 609:
      ACCEPT_TOKEN(sym_id);
      if (lookahead == 'e') ADVANCE(637);
      if (!sym_id_character_set_1(lookahead)) ADVANCE(654);
      END_STATE();
    case 610:
      ACCEPT_TOKEN(sym_id);
      if (lookahead == 'g') ADVANCE(495);
      if (!sym_id_character_set_1(lookahead)) ADVANCE(654);
      END_STATE();
    case 611:
      ACCEPT_TOKEN(sym_id);
      if (lookahead == 'g') ADVANCE(501);
      if (!sym_id_character_set_1(lookahead)) ADVANCE(654);
      END_STATE();
    case 612:
      ACCEPT_TOKEN(sym_id);
      if (lookahead == 'g') ADVANCE(504);
      if (!sym_id_character_set_1(lookahead)) ADVANCE(654);
      END_STATE();
    case 613:
      ACCEPT_TOKEN(sym_id);
      if (lookahead == 'h') ADVANCE(477);
      if (!sym_id_character_set_1(lookahead)) ADVANCE(654);
      END_STATE();
    case 614:
      ACCEPT_TOKEN(sym_id);
      if (lookahead == 'h') ADVANCE(609);
      if (lookahead == 'i') ADVANCE(641);
      if (!sym_id_character_set_1(lookahead)) ADVANCE(654);
      END_STATE();
    case 615:
      ACCEPT_TOKEN(sym_id);
      if (lookahead == 'h') ADVANCE(609);
      if (!sym_id_character_set_1(lookahead)) ADVANCE(654);
      END_STATE();
    case 616:
      ACCEPT_TOKEN(sym_id);
      if (lookahead == 'i') ADVANCE(603);
      if (!sym_id_character_set_1(lookahead)) ADVANCE(654);
      END_STATE();
    case 617:
      ACCEPT_TOKEN(sym_id);
      if (lookahead == 'i') ADVANCE(600);
      if (!sym_id_character_set_1(lookahead)) ADVANCE(654);
      END_STATE();
    case 618:
      ACCEPT_TOKEN(sym_id);
      if (lookahead == 'i') ADVANCE(627);
      if (!sym_id_character_set_1(lookahead)) ADVANCE(654);
      END_STATE();
    case 619:
      ACCEPT_TOKEN(sym_id);
      if (lookahead == 'i') ADVANCE(644);
      if (!sym_id_character_set_1(lookahead)) ADVANCE(654);
      END_STATE();
    case 620:
      ACCEPT_TOKEN(sym_id);
      if (lookahead == 'i') ADVANCE(629);
      if (!sym_id_character_set_1(lookahead)) ADVANCE(654);
      END_STATE();
    case 621:
      ACCEPT_TOKEN(sym_id);
      if (lookahead == 'i') ADVANCE(630);
      if (!sym_id_character_set_1(lookahead)) ADVANCE(654);
      END_STATE();
    case 622:
      ACCEPT_TOKEN(sym_id);
      if (lookahead == 'l') ADVANCE(617);
      if (!sym_id_character_set_1(lookahead)) ADVANCE(654);
      END_STATE();
    case 623:
      ACCEPT_TOKEN(sym_id);
      if (lookahead == 'l') ADVANCE(606);
      if (!sym_id_character_set_1(lookahead)) ADVANCE(654);
      END_STATE();
    case 624:
      ACCEPT_TOKEN(sym_id);
      if (lookahead == 'm') ADVANCE(621);
      if (!sym_id_character_set_1(lookahead)) ADVANCE(654);
      END_STATE();
    case 625:
      ACCEPT_TOKEN(sym_id);
      if (lookahead == 'n') ADVANCE(671);
      if (!sym_id_character_set_1(lookahead)) ADVANCE(654);
      END_STATE();
    case 626:
      ACCEPT_TOKEN(sym_id);
      if (lookahead == 'n') ADVANCE(598);
      if (lookahead == 'w') ADVANCE(638);
      if (!sym_id_character_set_1(lookahead)) ADVANCE(654);
      END_STATE();
    case 627:
      ACCEPT_TOKEN(sym_id);
      if (lookahead == 'n') ADVANCE(610);
      if (!sym_id_character_set_1(lookahead)) ADVANCE(654);
      END_STATE();
    case 628:
      ACCEPT_TOKEN(sym_id);
      if (lookahead == 'n') ADVANCE(640);
      if (!sym_id_character_set_1(lookahead)) ADVANCE(654);
      END_STATE();
    case 629:
      ACCEPT_TOKEN(sym_id);
      if (lookahead == 'n') ADVANCE(611);
      if (!sym_id_character_set_1(lookahead)) ADVANCE(654);
      END_STATE();
    case 630:
      ACCEPT_TOKEN(sym_id);
      if (lookahead == 'n') ADVANCE(612);
      if (!sym_id_character_set_1(lookahead)) ADVANCE(654);
      END_STATE();
    case 631:
      ACCEPT_TOKEN(sym_id);
      if (lookahead == 'o') ADVANCE(508);
      if (!sym_id_character_set_1(lookahead)) ADVANCE(654);
      END_STATE();
    case 632:
      ACCEPT_TOKEN(sym_id);
      if (lookahead == 'o') ADVANCE(628);
      if (!sym_id_character_set_1(lookahead)) ADVANCE(654);
      END_STATE();
    case 633:
      ACCEPT_TOKEN(sym_id);
      if (lookahead == 'o') ADVANCE(602);
      if (!sym_id_character_set_1(lookahead)) ADVANCE(654);
      END_STATE();
    case 634:
      ACCEPT_TOKEN(sym_id);
      if (lookahead == 'o') ADVANCE(635);
      if (!sym_id_character_set_1(lookahead)) ADVANCE(654);
      END_STATE();
    case 635:
      ACCEPT_TOKEN(sym_id);
      if (lookahead == 'r') ADVANCE(489);
      if (!sym_id_character_set_1(lookahead)) ADVANCE(654);
      END_STATE();
    case 636:
      ACCEPT_TOKEN(sym_id);
      if (lookahead == 'r') ADVANCE(647);
      if (!sym_id_character_set_1(lookahead)) ADVANCE(654);
      END_STATE();
    case 637:
      ACCEPT_TOKEN(sym_id);
      if (lookahead == 'r') ADVANCE(605);
      if (!sym_id_character_set_1(lookahead)) ADVANCE(654);
      END_STATE();
    case 638:
      ACCEPT_TOKEN(sym_id);
      if (lookahead == 'r') ADVANCE(619);
      if (!sym_id_character_set_1(lookahead)) ADVANCE(654);
      END_STATE();
    case 639:
      ACCEPT_TOKEN(sym_id);
      if (lookahead == 's') ADVANCE(618);
      if (!sym_id_character_set_1(lookahead)) ADVANCE(654);
      END_STATE();
    case 640:
      ACCEPT_TOKEN(sym_id);
      if (lookahead == 's') ADVANCE(642);
      if (!sym_id_character_set_1(lookahead)) ADVANCE(654);
      END_STATE();
    case 641:
      ACCEPT_TOKEN(sym_id);
      if (lookahead == 't') ADVANCE(613);
      if (!sym_id_character_set_1(lookahead)) ADVANCE(654);
      END_STATE();
    case 642:
      ACCEPT_TOKEN(sym_id);
      if (lookahead == 't') ADVANCE(636);
      if (!sym_id_character_set_1(lookahead)) ADVANCE(654);
      END_STATE();
    case 643:
      ACCEPT_TOKEN(sym_id);
      if (lookahead == 't') ADVANCE(634);
      if (!sym_id_character_set_1(lookahead)) ADVANCE(654);
      END_STATE();
    case 644:
      ACCEPT_TOKEN(sym_id);
      if (lookahead == 't') ADVANCE(607);
      if (!sym_id_character_set_1(lookahead)) ADVANCE(654);
      END_STATE();
    case 645:
      ACCEPT_TOKEN(sym_id);
      if (lookahead == 'u') ADVANCE(599);
      if (!sym_id_character_set_1(lookahead)) ADVANCE(654);
      END_STATE();
    case 646:
      ACCEPT_TOKEN(sym_id);
      if (lookahead == 'u') ADVANCE(623);
      if (!sym_id_character_set_1(lookahead)) ADVANCE(654);
      END_STATE();
    case 647:
      ACCEPT_TOKEN(sym_id);
      if (lookahead == 'u') ADVANCE(601);
      if (!sym_id_character_set_1(lookahead)) ADVANCE(654);
      END_STATE();
    case 648:
      ACCEPT_TOKEN(sym_id);
      if (lookahead == 'w') ADVANCE(638);
      if (!sym_id_character_set_1(lookahead)) ADVANCE(654);
      END_STATE();
    case 649:
      ACCEPT_TOKEN(sym_id);
      if (lookahead == 'x') ADVANCE(653);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(651);
      if (!sym_id_character_set_1(lookahead)) ADVANCE(654);
      END_STATE();
    case 650:
      ACCEPT_TOKEN(sym_id);
      if (lookahead == '}') ADVANCE(523);
      if (!sym_id_character_set_5(lookahead)) ADVANCE(654);
      END_STATE();
    case 651:
      ACCEPT_TOKEN(sym_id);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(651);
      if (!sym_id_character_set_1(lookahead)) ADVANCE(654);
      END_STATE();
    case 652:
      ACCEPT_TOKEN(sym_id);
      if (sym_comment_character_set_2(lookahead)) ADVANCE(688);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(652);
      END_STATE();
    case 653:
      ACCEPT_TOKEN(sym_id);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(653);
      if (!sym_id_character_set_1(lookahead)) ADVANCE(654);
      END_STATE();
    case 654:
      ACCEPT_TOKEN(sym_id);
      if (!sym_id_character_set_1(lookahead)) ADVANCE(654);
      END_STATE();
    case 655:
      ACCEPT_TOKEN(aux_sym__qid_token1);
      if (lookahead == '.') ADVANCE(272);
      if (!sym_id_character_set_2(lookahead)) ADVANCE(655);
      END_STATE();
    case 656:
      ACCEPT_TOKEN(aux_sym__qid_token1);
      if (lookahead == '.') ADVANCE(685);
      if (sym_comment_character_set_1(lookahead)) ADVANCE(688);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(656);
      END_STATE();
    case 657:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.') ADVANCE(661);
      END_STATE();
    case 658:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.') ADVANCE(264);
      END_STATE();
    case 659:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.') ADVANCE(660);
      END_STATE();
    case 660:
      ACCEPT_TOKEN(anon_sym_DOT_DOT);
      END_STATE();
    case 661:
      ACCEPT_TOKEN(anon_sym_DOT_DOT);
      if (lookahead == '.') ADVANCE(466);
      END_STATE();
    case 662:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(652);
      if (lookahead == '0') ADVANCE(649);
      if (lookahead == '>') ADVANCE(458);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(651);
      if (!sym_id_character_set_1(lookahead)) ADVANCE(654);
      END_STATE();
    case 663:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(590);
      if (lookahead == '.') ADVANCE(272);
      if (lookahead == '0') ADVANCE(586);
      if (lookahead == '>') ADVANCE(457);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (!sym_id_character_set_2(lookahead)) ADVANCE(589);
      END_STATE();
    case 664:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(590);
      if (lookahead == '.') ADVANCE(272);
      if (lookahead == '0') ADVANCE(586);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(587);
      if (!sym_id_character_set_2(lookahead)) ADVANCE(589);
      END_STATE();
    case 665:
      ACCEPT_TOKEN(anon_sym_AT);
      END_STATE();
    case 666:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == ')') ADVANCE(673);
      if (lookahead == '.') ADVANCE(272);
      if (!sym_id_character_set_3(lookahead)) ADVANCE(589);
      END_STATE();
    case 667:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == ')') ADVANCE(673);
      if (!sym_id_character_set_4(lookahead)) ADVANCE(654);
      END_STATE();
    case 668:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '.') ADVANCE(272);
      if (!sym_id_character_set_2(lookahead)) ADVANCE(589);
      END_STATE();
    case 669:
      ACCEPT_TOKEN(anon_sym_in);
      END_STATE();
    case 670:
      ACCEPT_TOKEN(anon_sym_in);
      if (lookahead == '.') ADVANCE(272);
      if (!sym_id_character_set_2(lookahead)) ADVANCE(589);
      END_STATE();
    case 671:
      ACCEPT_TOKEN(anon_sym_in);
      if (!sym_id_character_set_1(lookahead)) ADVANCE(654);
      END_STATE();
    case 672:
      ACCEPT_TOKEN(anon_sym_LPAREN_PIPE);
      END_STATE();
    case 673:
      ACCEPT_TOKEN(anon_sym_PIPE_RPAREN);
      END_STATE();
    case 674:
      ACCEPT_TOKEN(anon_sym_u2987);
      if (lookahead == '.') ADVANCE(272);
      if (!sym_id_character_set_2(lookahead)) ADVANCE(589);
      END_STATE();
    case 675:
      ACCEPT_TOKEN(anon_sym_u2987);
      if (!sym_id_character_set_1(lookahead)) ADVANCE(654);
      END_STATE();
    case 676:
      ACCEPT_TOKEN(anon_sym_u2988);
      END_STATE();
    case 677:
      ACCEPT_TOKEN(anon_sym_u2988);
      if (lookahead == '.') ADVANCE(272);
      if (!sym_id_character_set_2(lookahead)) ADVANCE(589);
      END_STATE();
    case 678:
      ACCEPT_TOKEN(anon_sym_u2988);
      if (!sym_id_character_set_1(lookahead)) ADVANCE(654);
      END_STATE();
    case 679:
      ACCEPT_TOKEN(aux_sym_integer_token1);
      if (lookahead == 'x') ADVANCE(445);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(680);
      END_STATE();
    case 680:
      ACCEPT_TOKEN(aux_sym_integer_token1);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(680);
      END_STATE();
    case 681:
      ACCEPT_TOKEN(aux_sym_integer_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(681);
      END_STATE();
    case 682:
      ACCEPT_TOKEN(aux_sym_string_token1);
      if (lookahead == '"') ADVANCE(682);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(187);
      END_STATE();
    case 683:
      ACCEPT_TOKEN(sym_comment);
      END_STATE();
    case 684:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '-') ADVANCE(442);
      if (lookahead != 0) ADVANCE(250);
      END_STATE();
    case 685:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '\\') ADVANCE(687);
      if (lookahead == '_') ADVANCE(686);
      if (sym_comment_character_set_3(lookahead)) ADVANCE(688);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(656);
      END_STATE();
    case 686:
      ACCEPT_TOKEN(sym_comment);
      if (sym_comment_character_set_2(lookahead)) ADVANCE(688);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(656);
      END_STATE();
    case 687:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '\t' ||
          (11 <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(688);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(656);
      END_STATE();
    case 688:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(688);
      END_STATE();
    default:
      return false;
  }
}

static bool ts_lex_keywords(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  switch (state) {
    case 0:
      if (lookahead == 'P') ADVANCE(1);
      if (lookahead == 'S') ADVANCE(2);
      if (lookahead == '\\') SKIP(3)
      if (lookahead == 'a') ADVANCE(4);
      if (lookahead == 'c') ADVANCE(5);
      if (lookahead == 'd') ADVANCE(6);
      if (lookahead == 'e') ADVANCE(7);
      if (lookahead == 'f') ADVANCE(8);
      if (lookahead == 'i') ADVANCE(9);
      if (lookahead == 'l') ADVANCE(10);
      if (lookahead == 'm') ADVANCE(11);
      if (lookahead == 'n') ADVANCE(12);
      if (lookahead == 'o') ADVANCE(13);
      if (lookahead == 'p') ADVANCE(14);
      if (lookahead == 'q') ADVANCE(15);
      if (lookahead == 'r') ADVANCE(16);
      if (lookahead == 's') ADVANCE(17);
      if (lookahead == 't') ADVANCE(18);
      if (lookahead == 'u') ADVANCE(19);
      if (lookahead == 'v') ADVANCE(20);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(0)
      END_STATE();
    case 1:
      if (lookahead == 'r') ADVANCE(21);
      END_STATE();
    case 2:
      if (lookahead == 'e') ADVANCE(22);
      END_STATE();
    case 3:
      if (lookahead == 'n') SKIP(0)
      END_STATE();
    case 4:
      if (lookahead == 'b') ADVANCE(23);
      END_STATE();
    case 5:
      if (lookahead == 'o') ADVANCE(24);
      END_STATE();
    case 6:
      if (lookahead == 'a') ADVANCE(25);
      if (lookahead == 'o') ADVANCE(26);
      END_STATE();
    case 7:
      if (lookahead == 't') ADVANCE(27);
      END_STATE();
    case 8:
      if (lookahead == 'i') ADVANCE(28);
      if (lookahead == 'o') ADVANCE(29);
      END_STATE();
    case 9:
      if (lookahead == 'm') ADVANCE(30);
      if (lookahead == 'n') ADVANCE(31);
      END_STATE();
    case 10:
      if (lookahead == 'e') ADVANCE(32);
      END_STATE();
    case 11:
      if (lookahead == 'a') ADVANCE(33);
      if (lookahead == 'u') ADVANCE(34);
      END_STATE();
    case 12:
      if (lookahead == 'o') ADVANCE(35);
      END_STATE();
    case 13:
      if (lookahead == 'p') ADVANCE(36);
      if (lookahead == 'v') ADVANCE(37);
      END_STATE();
    case 14:
      if (lookahead == 'a') ADVANCE(38);
      if (lookahead == 'o') ADVANCE(39);
      if (lookahead == 'r') ADVANCE(40);
      END_STATE();
    case 15:
      if (lookahead == 'u') ADVANCE(41);
      END_STATE();
    case 16:
      if (lookahead == 'e') ADVANCE(42);
      END_STATE();
    case 17:
      if (lookahead == 'y') ADVANCE(43);
      END_STATE();
    case 18:
      if (lookahead == 'a') ADVANCE(44);
      END_STATE();
    case 19:
      if (lookahead == 'n') ADVANCE(45);
      END_STATE();
    case 20:
      if (lookahead == 'a') ADVANCE(46);
      END_STATE();
    case 21:
      if (lookahead == 'o') ADVANCE(47);
      END_STATE();
    case 22:
      if (lookahead == 't') ADVANCE(48);
      END_STATE();
    case 23:
      if (lookahead == 's') ADVANCE(49);
      END_STATE();
    case 24:
      if (lookahead == 'd') ADVANCE(50);
      if (lookahead == 'i') ADVANCE(51);
      END_STATE();
    case 25:
      if (lookahead == 't') ADVANCE(52);
      END_STATE();
    case 26:
      ACCEPT_TOKEN(anon_sym_do);
      END_STATE();
    case 27:
      if (lookahead == 'a') ADVANCE(53);
      END_STATE();
    case 28:
      if (lookahead == 'e') ADVANCE(54);
      END_STATE();
    case 29:
      if (lookahead == 'r') ADVANCE(55);
      END_STATE();
    case 30:
      if (lookahead == 'p') ADVANCE(56);
      END_STATE();
    case 31:
      if (lookahead == 'd') ADVANCE(57);
      if (lookahead == 'f') ADVANCE(58);
      if (lookahead == 's') ADVANCE(59);
      END_STATE();
    case 32:
      if (lookahead == 't') ADVANCE(60);
      END_STATE();
    case 33:
      if (lookahead == 'c') ADVANCE(61);
      END_STATE();
    case 34:
      if (lookahead == 't') ADVANCE(62);
      END_STATE();
    case 35:
      if (lookahead == '-') ADVANCE(63);
      END_STATE();
    case 36:
      if (lookahead == 'e') ADVANCE(64);
      END_STATE();
    case 37:
      if (lookahead == 'e') ADVANCE(65);
      END_STATE();
    case 38:
      if (lookahead == 't') ADVANCE(66);
      END_STATE();
    case 39:
      if (lookahead == 's') ADVANCE(67);
      END_STATE();
    case 40:
      if (lookahead == 'i') ADVANCE(68);
      if (lookahead == 'o') ADVANCE(69);
      END_STATE();
    case 41:
      if (lookahead == 'o') ADVANCE(70);
      END_STATE();
    case 42:
      if (lookahead == 'c') ADVANCE(71);
      END_STATE();
    case 43:
      if (lookahead == 'n') ADVANCE(72);
      END_STATE();
    case 44:
      if (lookahead == 'c') ADVANCE(73);
      END_STATE();
    case 45:
      if (lookahead == 'q') ADVANCE(74);
      END_STATE();
    case 46:
      if (lookahead == 'r') ADVANCE(75);
      END_STATE();
    case 47:
      if (lookahead == 'p') ADVANCE(76);
      END_STATE();
    case 48:
      ACCEPT_TOKEN(anon_sym_Set);
      END_STATE();
    case 49:
      if (lookahead == 't') ADVANCE(77);
      END_STATE();
    case 50:
      if (lookahead == 'a') ADVANCE(78);
      END_STATE();
    case 51:
      if (lookahead == 'n') ADVANCE(79);
      END_STATE();
    case 52:
      if (lookahead == 'a') ADVANCE(80);
      END_STATE();
    case 53:
      if (lookahead == '-') ADVANCE(81);
      END_STATE();
    case 54:
      if (lookahead == 'l') ADVANCE(82);
      END_STATE();
    case 55:
      if (lookahead == 'a') ADVANCE(83);
      END_STATE();
    case 56:
      if (lookahead == 'o') ADVANCE(84);
      END_STATE();
    case 57:
      if (lookahead == 'u') ADVANCE(85);
      END_STATE();
    case 58:
      if (lookahead == 'i') ADVANCE(86);
      END_STATE();
    case 59:
      if (lookahead == 't') ADVANCE(87);
      END_STATE();
    case 60:
      ACCEPT_TOKEN(anon_sym_let);
      END_STATE();
    case 61:
      if (lookahead == 'r') ADVANCE(88);
      END_STATE();
    case 62:
      if (lookahead == 'u') ADVANCE(89);
      END_STATE();
    case 63:
      if (lookahead == 'e') ADVANCE(90);
      END_STATE();
    case 64:
      if (lookahead == 'n') ADVANCE(91);
      END_STATE();
    case 65:
      if (lookahead == 'r') ADVANCE(92);
      END_STATE();
    case 66:
      if (lookahead == 't') ADVANCE(93);
      END_STATE();
    case 67:
      if (lookahead == 't') ADVANCE(94);
      END_STATE();
    case 68:
      if (lookahead == 'm') ADVANCE(95);
      if (lookahead == 'v') ADVANCE(96);
      END_STATE();
    case 69:
      if (lookahead == 'p') ADVANCE(97);
      END_STATE();
    case 70:
      if (lookahead == 't') ADVANCE(98);
      END_STATE();
    case 71:
      if (lookahead == 'o') ADVANCE(99);
      END_STATE();
    case 72:
      if (lookahead == 't') ADVANCE(100);
      END_STATE();
    case 73:
      if (lookahead == 't') ADVANCE(101);
      END_STATE();
    case 74:
      if (lookahead == 'u') ADVANCE(102);
      END_STATE();
    case 75:
      if (lookahead == 'i') ADVANCE(103);
      END_STATE();
    case 76:
      ACCEPT_TOKEN(anon_sym_Prop);
      END_STATE();
    case 77:
      if (lookahead == 'r') ADVANCE(104);
      END_STATE();
    case 78:
      if (lookahead == 't') ADVANCE(105);
      END_STATE();
    case 79:
      if (lookahead == 'd') ADVANCE(106);
      END_STATE();
    case 80:
      ACCEPT_TOKEN(anon_sym_data);
      END_STATE();
    case 81:
      if (lookahead == 'e') ADVANCE(107);
      END_STATE();
    case 82:
      if (lookahead == 'd') ADVANCE(108);
      END_STATE();
    case 83:
      if (lookahead == 'l') ADVANCE(109);
      END_STATE();
    case 84:
      if (lookahead == 'r') ADVANCE(110);
      END_STATE();
    case 85:
      if (lookahead == 'c') ADVANCE(111);
      END_STATE();
    case 86:
      if (lookahead == 'x') ADVANCE(112);
      END_STATE();
    case 87:
      if (lookahead == 'a') ADVANCE(113);
      END_STATE();
    case 88:
      if (lookahead == 'o') ADVANCE(114);
      END_STATE();
    case 89:
      if (lookahead == 'a') ADVANCE(115);
      END_STATE();
    case 90:
      if (lookahead == 't') ADVANCE(116);
      END_STATE();
    case 91:
      ACCEPT_TOKEN(anon_sym_open);
      END_STATE();
    case 92:
      if (lookahead == 'l') ADVANCE(117);
      END_STATE();
    case 93:
      if (lookahead == 'e') ADVANCE(118);
      END_STATE();
    case 94:
      if (lookahead == 'u') ADVANCE(119);
      END_STATE();
    case 95:
      if (lookahead == 'i') ADVANCE(120);
      END_STATE();
    case 96:
      if (lookahead == 'a') ADVANCE(121);
      END_STATE();
    case 97:
      if (lookahead == 'N') ADVANCE(122);
      END_STATE();
    case 98:
      if (lookahead == 'e') ADVANCE(123);
      END_STATE();
    case 99:
      if (lookahead == 'r') ADVANCE(124);
      END_STATE();
    case 100:
      if (lookahead == 'a') ADVANCE(125);
      END_STATE();
    case 101:
      if (lookahead == 'i') ADVANCE(126);
      END_STATE();
    case 102:
      if (lookahead == 'o') ADVANCE(127);
      END_STATE();
    case 103:
      if (lookahead == 'a') ADVANCE(128);
      END_STATE();
    case 104:
      if (lookahead == 'a') ADVANCE(129);
      END_STATE();
    case 105:
      if (lookahead == 'a') ADVANCE(130);
      END_STATE();
    case 106:
      if (lookahead == 'u') ADVANCE(131);
      END_STATE();
    case 107:
      if (lookahead == 'q') ADVANCE(132);
      END_STATE();
    case 108:
      ACCEPT_TOKEN(anon_sym_field);
      END_STATE();
    case 109:
      if (lookahead == 'l') ADVANCE(133);
      END_STATE();
    case 110:
      if (lookahead == 't') ADVANCE(134);
      END_STATE();
    case 111:
      if (lookahead == 't') ADVANCE(135);
      END_STATE();
    case 112:
      ACCEPT_TOKEN(anon_sym_infix);
      if (lookahead == 'l') ADVANCE(136);
      if (lookahead == 'r') ADVANCE(137);
      END_STATE();
    case 113:
      if (lookahead == 'n') ADVANCE(138);
      END_STATE();
    case 114:
      ACCEPT_TOKEN(anon_sym_macro);
      END_STATE();
    case 115:
      if (lookahead == 'l') ADVANCE(139);
      END_STATE();
    case 116:
      if (lookahead == 'a') ADVANCE(140);
      END_STATE();
    case 117:
      if (lookahead == 'a') ADVANCE(141);
      END_STATE();
    case 118:
      if (lookahead == 'r') ADVANCE(142);
      END_STATE();
    case 119:
      if (lookahead == 'l') ADVANCE(143);
      END_STATE();
    case 120:
      if (lookahead == 't') ADVANCE(144);
      END_STATE();
    case 121:
      if (lookahead == 't') ADVANCE(145);
      END_STATE();
    case 122:
      ACCEPT_TOKEN(sym_PropN);
      END_STATE();
    case 123:
      ACCEPT_TOKEN(anon_sym_quote);
      if (lookahead == 'C') ADVANCE(146);
      if (lookahead == 'G') ADVANCE(147);
      if (lookahead == 'T') ADVANCE(148);
      END_STATE();
    case 124:
      if (lookahead == 'd') ADVANCE(149);
      END_STATE();
    case 125:
      if (lookahead == 'x') ADVANCE(150);
      END_STATE();
    case 126:
      if (lookahead == 'c') ADVANCE(151);
      END_STATE();
    case 127:
      if (lookahead == 't') ADVANCE(152);
      END_STATE();
    case 128:
      if (lookahead == 'b') ADVANCE(153);
      END_STATE();
    case 129:
      if (lookahead == 'c') ADVANCE(154);
      END_STATE();
    case 130:
      ACCEPT_TOKEN(anon_sym_codata);
      END_STATE();
    case 131:
      if (lookahead == 'c') ADVANCE(155);
      END_STATE();
    case 132:
      if (lookahead == 'u') ADVANCE(156);
      END_STATE();
    case 133:
      ACCEPT_TOKEN(anon_sym_forall);
      END_STATE();
    case 134:
      ACCEPT_TOKEN(anon_sym_import);
      END_STATE();
    case 135:
      if (lookahead == 'i') ADVANCE(157);
      END_STATE();
    case 136:
      ACCEPT_TOKEN(anon_sym_infixl);
      END_STATE();
    case 137:
      ACCEPT_TOKEN(anon_sym_infixr);
      END_STATE();
    case 138:
      if (lookahead == 'c') ADVANCE(158);
      END_STATE();
    case 139:
      ACCEPT_TOKEN(anon_sym_mutual);
      END_STATE();
    case 140:
      if (lookahead == '-') ADVANCE(159);
      END_STATE();
    case 141:
      if (lookahead == 'p') ADVANCE(160);
      END_STATE();
    case 142:
      if (lookahead == 'n') ADVANCE(161);
      END_STATE();
    case 143:
      if (lookahead == 'a') ADVANCE(162);
      END_STATE();
    case 144:
      if (lookahead == 'i') ADVANCE(163);
      END_STATE();
    case 145:
      if (lookahead == 'e') ADVANCE(164);
      END_STATE();
    case 146:
      if (lookahead == 'o') ADVANCE(165);
      END_STATE();
    case 147:
      if (lookahead == 'o') ADVANCE(166);
      END_STATE();
    case 148:
      if (lookahead == 'e') ADVANCE(167);
      END_STATE();
    case 149:
      ACCEPT_TOKEN(anon_sym_record);
      END_STATE();
    case 150:
      ACCEPT_TOKEN(anon_sym_syntax);
      END_STATE();
    case 151:
      ACCEPT_TOKEN(anon_sym_tactic);
      END_STATE();
    case 152:
      if (lookahead == 'e') ADVANCE(168);
      END_STATE();
    case 153:
      if (lookahead == 'l') ADVANCE(169);
      END_STATE();
    case 154:
      if (lookahead == 't') ADVANCE(170);
      END_STATE();
    case 155:
      if (lookahead == 't') ADVANCE(171);
      END_STATE();
    case 156:
      if (lookahead == 'a') ADVANCE(172);
      END_STATE();
    case 157:
      if (lookahead == 'v') ADVANCE(173);
      END_STATE();
    case 158:
      if (lookahead == 'e') ADVANCE(174);
      END_STATE();
    case 159:
      if (lookahead == 'e') ADVANCE(175);
      END_STATE();
    case 160:
      ACCEPT_TOKEN(anon_sym_overlap);
      END_STATE();
    case 161:
      ACCEPT_TOKEN(anon_sym_pattern);
      END_STATE();
    case 162:
      if (lookahead == 't') ADVANCE(176);
      END_STATE();
    case 163:
      if (lookahead == 'v') ADVANCE(177);
      END_STATE();
    case 164:
      ACCEPT_TOKEN(anon_sym_private);
      END_STATE();
    case 165:
      if (lookahead == 'n') ADVANCE(178);
      END_STATE();
    case 166:
      if (lookahead == 'a') ADVANCE(179);
      END_STATE();
    case 167:
      if (lookahead == 'r') ADVANCE(180);
      END_STATE();
    case 168:
      ACCEPT_TOKEN(anon_sym_unquote);
      if (lookahead == 'D') ADVANCE(181);
      END_STATE();
    case 169:
      if (lookahead == 'e') ADVANCE(182);
      END_STATE();
    case 170:
      ACCEPT_TOKEN(anon_sym_abstract);
      END_STATE();
    case 171:
      if (lookahead == 'i') ADVANCE(183);
      END_STATE();
    case 172:
      if (lookahead == 'l') ADVANCE(184);
      END_STATE();
    case 173:
      if (lookahead == 'e') ADVANCE(185);
      END_STATE();
    case 174:
      ACCEPT_TOKEN(anon_sym_instance);
      END_STATE();
    case 175:
      if (lookahead == 'q') ADVANCE(186);
      END_STATE();
    case 176:
      if (lookahead == 'e') ADVANCE(187);
      END_STATE();
    case 177:
      if (lookahead == 'e') ADVANCE(188);
      END_STATE();
    case 178:
      if (lookahead == 't') ADVANCE(189);
      END_STATE();
    case 179:
      if (lookahead == 'l') ADVANCE(190);
      END_STATE();
    case 180:
      if (lookahead == 'm') ADVANCE(191);
      END_STATE();
    case 181:
      if (lookahead == 'e') ADVANCE(192);
      END_STATE();
    case 182:
      ACCEPT_TOKEN(anon_sym_variable);
      END_STATE();
    case 183:
      if (lookahead == 'v') ADVANCE(193);
      END_STATE();
    case 184:
      if (lookahead == 'i') ADVANCE(194);
      END_STATE();
    case 185:
      ACCEPT_TOKEN(anon_sym_inductive);
      END_STATE();
    case 186:
      if (lookahead == 'u') ADVANCE(195);
      END_STATE();
    case 187:
      ACCEPT_TOKEN(anon_sym_postulate);
      END_STATE();
    case 188:
      ACCEPT_TOKEN(anon_sym_primitive);
      END_STATE();
    case 189:
      if (lookahead == 'e') ADVANCE(196);
      END_STATE();
    case 190:
      ACCEPT_TOKEN(anon_sym_quoteGoal);
      END_STATE();
    case 191:
      ACCEPT_TOKEN(anon_sym_quoteTerm);
      END_STATE();
    case 192:
      if (lookahead == 'c') ADVANCE(197);
      if (lookahead == 'f') ADVANCE(198);
      END_STATE();
    case 193:
      if (lookahead == 'e') ADVANCE(199);
      END_STATE();
    case 194:
      if (lookahead == 't') ADVANCE(200);
      END_STATE();
    case 195:
      if (lookahead == 'a') ADVANCE(201);
      END_STATE();
    case 196:
      if (lookahead == 'x') ADVANCE(202);
      END_STATE();
    case 197:
      if (lookahead == 'l') ADVANCE(203);
      END_STATE();
    case 198:
      ACCEPT_TOKEN(anon_sym_unquoteDef);
      END_STATE();
    case 199:
      ACCEPT_TOKEN(anon_sym_coinductive);
      END_STATE();
    case 200:
      if (lookahead == 'y') ADVANCE(204);
      END_STATE();
    case 201:
      if (lookahead == 'l') ADVANCE(205);
      END_STATE();
    case 202:
      if (lookahead == 't') ADVANCE(206);
      END_STATE();
    case 203:
      ACCEPT_TOKEN(anon_sym_unquoteDecl);
      END_STATE();
    case 204:
      ACCEPT_TOKEN(anon_sym_eta_DASHequality);
      END_STATE();
    case 205:
      if (lookahead == 'i') ADVANCE(207);
      END_STATE();
    case 206:
      ACCEPT_TOKEN(anon_sym_quoteContext);
      END_STATE();
    case 207:
      if (lookahead == 't') ADVANCE(208);
      END_STATE();
    case 208:
      if (lookahead == 'y') ADVANCE(209);
      END_STATE();
    case 209:
      ACCEPT_TOKEN(anon_sym_no_DASHeta_DASHequality);
      END_STATE();
    default:
      return false;
  }
}

static const TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0, .external_lex_state = 1},
  [1] = {.lex_state = 450},
  [2] = {.lex_state = 114, .external_lex_state = 2},
  [3] = {.lex_state = 114, .external_lex_state = 2},
  [4] = {.lex_state = 114},
  [5] = {.lex_state = 450, .external_lex_state = 3},
  [6] = {.lex_state = 450, .external_lex_state = 3},
  [7] = {.lex_state = 450, .external_lex_state = 3},
  [8] = {.lex_state = 450, .external_lex_state = 3},
  [9] = {.lex_state = 450, .external_lex_state = 3},
  [10] = {.lex_state = 450, .external_lex_state = 3},
  [11] = {.lex_state = 450, .external_lex_state = 3},
  [12] = {.lex_state = 450, .external_lex_state = 3},
  [13] = {.lex_state = 450, .external_lex_state = 3},
  [14] = {.lex_state = 450, .external_lex_state = 3},
  [15] = {.lex_state = 450, .external_lex_state = 3},
  [16] = {.lex_state = 450, .external_lex_state = 3},
  [17] = {.lex_state = 450, .external_lex_state = 3},
  [18] = {.lex_state = 450, .external_lex_state = 3},
  [19] = {.lex_state = 450, .external_lex_state = 3},
  [20] = {.lex_state = 450, .external_lex_state = 3},
  [21] = {.lex_state = 450, .external_lex_state = 3},
  [22] = {.lex_state = 450, .external_lex_state = 3},
  [23] = {.lex_state = 450, .external_lex_state = 3},
  [24] = {.lex_state = 450, .external_lex_state = 3},
  [25] = {.lex_state = 450, .external_lex_state = 3},
  [26] = {.lex_state = 450, .external_lex_state = 3},
  [27] = {.lex_state = 450, .external_lex_state = 3},
  [28] = {.lex_state = 450, .external_lex_state = 3},
  [29] = {.lex_state = 450, .external_lex_state = 3},
  [30] = {.lex_state = 450, .external_lex_state = 3},
  [31] = {.lex_state = 450, .external_lex_state = 3},
  [32] = {.lex_state = 450, .external_lex_state = 3},
  [33] = {.lex_state = 450, .external_lex_state = 3},
  [34] = {.lex_state = 450, .external_lex_state = 3},
  [35] = {.lex_state = 450, .external_lex_state = 3},
  [36] = {.lex_state = 450, .external_lex_state = 3},
  [37] = {.lex_state = 450, .external_lex_state = 3},
  [38] = {.lex_state = 450, .external_lex_state = 3},
  [39] = {.lex_state = 450, .external_lex_state = 3},
  [40] = {.lex_state = 450, .external_lex_state = 3},
  [41] = {.lex_state = 450, .external_lex_state = 3},
  [42] = {.lex_state = 450, .external_lex_state = 3},
  [43] = {.lex_state = 450, .external_lex_state = 3},
  [44] = {.lex_state = 450, .external_lex_state = 3},
  [45] = {.lex_state = 450, .external_lex_state = 3},
  [46] = {.lex_state = 450, .external_lex_state = 3},
  [47] = {.lex_state = 450, .external_lex_state = 3},
  [48] = {.lex_state = 450, .external_lex_state = 3},
  [49] = {.lex_state = 450, .external_lex_state = 3},
  [50] = {.lex_state = 450, .external_lex_state = 3},
  [51] = {.lex_state = 450, .external_lex_state = 3},
  [52] = {.lex_state = 450, .external_lex_state = 3},
  [53] = {.lex_state = 450, .external_lex_state = 3},
  [54] = {.lex_state = 450, .external_lex_state = 3},
  [55] = {.lex_state = 450, .external_lex_state = 3},
  [56] = {.lex_state = 450, .external_lex_state = 3},
  [57] = {.lex_state = 450, .external_lex_state = 3},
  [58] = {.lex_state = 450, .external_lex_state = 3},
  [59] = {.lex_state = 450, .external_lex_state = 3},
  [60] = {.lex_state = 450, .external_lex_state = 3},
  [61] = {.lex_state = 450, .external_lex_state = 3},
  [62] = {.lex_state = 450, .external_lex_state = 3},
  [63] = {.lex_state = 450, .external_lex_state = 3},
  [64] = {.lex_state = 450, .external_lex_state = 3},
  [65] = {.lex_state = 450, .external_lex_state = 2},
  [66] = {.lex_state = 450, .external_lex_state = 3},
  [67] = {.lex_state = 450, .external_lex_state = 3},
  [68] = {.lex_state = 450, .external_lex_state = 3},
  [69] = {.lex_state = 450, .external_lex_state = 3},
  [70] = {.lex_state = 450, .external_lex_state = 3},
  [71] = {.lex_state = 450, .external_lex_state = 3},
  [72] = {.lex_state = 450, .external_lex_state = 3},
  [73] = {.lex_state = 450, .external_lex_state = 3},
  [74] = {.lex_state = 450, .external_lex_state = 3},
  [75] = {.lex_state = 450, .external_lex_state = 3},
  [76] = {.lex_state = 450, .external_lex_state = 2},
  [77] = {.lex_state = 450},
  [78] = {.lex_state = 450, .external_lex_state = 3},
  [79] = {.lex_state = 450, .external_lex_state = 2},
  [80] = {.lex_state = 450, .external_lex_state = 3},
  [81] = {.lex_state = 450, .external_lex_state = 3},
  [82] = {.lex_state = 450, .external_lex_state = 3},
  [83] = {.lex_state = 450, .external_lex_state = 3},
  [84] = {.lex_state = 450, .external_lex_state = 3},
  [85] = {.lex_state = 450, .external_lex_state = 3},
  [86] = {.lex_state = 450, .external_lex_state = 3},
  [87] = {.lex_state = 450, .external_lex_state = 2},
  [88] = {.lex_state = 450, .external_lex_state = 3},
  [89] = {.lex_state = 450, .external_lex_state = 3},
  [90] = {.lex_state = 450, .external_lex_state = 3},
  [91] = {.lex_state = 450, .external_lex_state = 3},
  [92] = {.lex_state = 450, .external_lex_state = 2},
  [93] = {.lex_state = 450, .external_lex_state = 3},
  [94] = {.lex_state = 450, .external_lex_state = 3},
  [95] = {.lex_state = 450},
  [96] = {.lex_state = 450, .external_lex_state = 3},
  [97] = {.lex_state = 450, .external_lex_state = 3},
  [98] = {.lex_state = 450, .external_lex_state = 3},
  [99] = {.lex_state = 450, .external_lex_state = 3},
  [100] = {.lex_state = 450, .external_lex_state = 3},
  [101] = {.lex_state = 450, .external_lex_state = 3},
  [102] = {.lex_state = 450, .external_lex_state = 3},
  [103] = {.lex_state = 450, .external_lex_state = 3},
  [104] = {.lex_state = 450, .external_lex_state = 3},
  [105] = {.lex_state = 450, .external_lex_state = 3},
  [106] = {.lex_state = 450, .external_lex_state = 3},
  [107] = {.lex_state = 450, .external_lex_state = 3},
  [108] = {.lex_state = 450, .external_lex_state = 3},
  [109] = {.lex_state = 450, .external_lex_state = 3},
  [110] = {.lex_state = 450, .external_lex_state = 3},
  [111] = {.lex_state = 450, .external_lex_state = 3},
  [112] = {.lex_state = 450, .external_lex_state = 3},
  [113] = {.lex_state = 450, .external_lex_state = 3},
  [114] = {.lex_state = 450, .external_lex_state = 3},
  [115] = {.lex_state = 450, .external_lex_state = 3},
  [116] = {.lex_state = 450},
  [117] = {.lex_state = 450},
  [118] = {.lex_state = 450},
  [119] = {.lex_state = 450},
  [120] = {.lex_state = 450},
  [121] = {.lex_state = 450},
  [122] = {.lex_state = 450},
  [123] = {.lex_state = 450},
  [124] = {.lex_state = 450},
  [125] = {.lex_state = 450},
  [126] = {.lex_state = 450},
  [127] = {.lex_state = 450},
  [128] = {.lex_state = 450},
  [129] = {.lex_state = 450},
  [130] = {.lex_state = 450},
  [131] = {.lex_state = 450},
  [132] = {.lex_state = 450},
  [133] = {.lex_state = 450},
  [134] = {.lex_state = 450},
  [135] = {.lex_state = 450},
  [136] = {.lex_state = 450},
  [137] = {.lex_state = 450},
  [138] = {.lex_state = 450},
  [139] = {.lex_state = 450},
  [140] = {.lex_state = 450},
  [141] = {.lex_state = 450},
  [142] = {.lex_state = 450},
  [143] = {.lex_state = 450},
  [144] = {.lex_state = 450},
  [145] = {.lex_state = 450},
  [146] = {.lex_state = 450},
  [147] = {.lex_state = 450},
  [148] = {.lex_state = 450},
  [149] = {.lex_state = 450},
  [150] = {.lex_state = 450},
  [151] = {.lex_state = 450},
  [152] = {.lex_state = 450},
  [153] = {.lex_state = 450},
  [154] = {.lex_state = 450},
  [155] = {.lex_state = 450},
  [156] = {.lex_state = 450},
  [157] = {.lex_state = 450},
  [158] = {.lex_state = 450},
  [159] = {.lex_state = 450},
  [160] = {.lex_state = 450},
  [161] = {.lex_state = 450},
  [162] = {.lex_state = 450},
  [163] = {.lex_state = 450},
  [164] = {.lex_state = 450},
  [165] = {.lex_state = 450},
  [166] = {.lex_state = 450},
  [167] = {.lex_state = 450},
  [168] = {.lex_state = 450},
  [169] = {.lex_state = 450},
  [170] = {.lex_state = 450},
  [171] = {.lex_state = 450},
  [172] = {.lex_state = 450},
  [173] = {.lex_state = 450},
  [174] = {.lex_state = 450},
  [175] = {.lex_state = 450},
  [176] = {.lex_state = 450},
  [177] = {.lex_state = 450},
  [178] = {.lex_state = 450},
  [179] = {.lex_state = 450},
  [180] = {.lex_state = 450},
  [181] = {.lex_state = 450},
  [182] = {.lex_state = 450},
  [183] = {.lex_state = 450},
  [184] = {.lex_state = 450},
  [185] = {.lex_state = 450},
  [186] = {.lex_state = 450},
  [187] = {.lex_state = 450},
  [188] = {.lex_state = 450},
  [189] = {.lex_state = 450},
  [190] = {.lex_state = 450},
  [191] = {.lex_state = 450},
  [192] = {.lex_state = 450},
  [193] = {.lex_state = 450},
  [194] = {.lex_state = 450},
  [195] = {.lex_state = 450},
  [196] = {.lex_state = 450},
  [197] = {.lex_state = 450},
  [198] = {.lex_state = 450},
  [199] = {.lex_state = 450},
  [200] = {.lex_state = 450},
  [201] = {.lex_state = 450},
  [202] = {.lex_state = 450},
  [203] = {.lex_state = 450},
  [204] = {.lex_state = 450},
  [205] = {.lex_state = 450},
  [206] = {.lex_state = 450},
  [207] = {.lex_state = 450},
  [208] = {.lex_state = 450},
  [209] = {.lex_state = 450},
  [210] = {.lex_state = 450},
  [211] = {.lex_state = 450},
  [212] = {.lex_state = 450},
  [213] = {.lex_state = 450},
  [214] = {.lex_state = 450},
  [215] = {.lex_state = 450},
  [216] = {.lex_state = 450},
  [217] = {.lex_state = 450},
  [218] = {.lex_state = 450},
  [219] = {.lex_state = 450},
  [220] = {.lex_state = 450},
  [221] = {.lex_state = 450},
  [222] = {.lex_state = 450},
  [223] = {.lex_state = 450},
  [224] = {.lex_state = 450},
  [225] = {.lex_state = 450},
  [226] = {.lex_state = 450},
  [227] = {.lex_state = 450},
  [228] = {.lex_state = 450},
  [229] = {.lex_state = 450},
  [230] = {.lex_state = 450},
  [231] = {.lex_state = 450},
  [232] = {.lex_state = 450},
  [233] = {.lex_state = 450},
  [234] = {.lex_state = 450},
  [235] = {.lex_state = 450},
  [236] = {.lex_state = 450},
  [237] = {.lex_state = 450},
  [238] = {.lex_state = 450},
  [239] = {.lex_state = 450},
  [240] = {.lex_state = 450},
  [241] = {.lex_state = 450},
  [242] = {.lex_state = 450},
  [243] = {.lex_state = 450},
  [244] = {.lex_state = 450},
  [245] = {.lex_state = 450},
  [246] = {.lex_state = 450},
  [247] = {.lex_state = 450},
  [248] = {.lex_state = 450},
  [249] = {.lex_state = 450},
  [250] = {.lex_state = 450},
  [251] = {.lex_state = 450},
  [252] = {.lex_state = 450},
  [253] = {.lex_state = 450},
  [254] = {.lex_state = 450},
  [255] = {.lex_state = 450},
  [256] = {.lex_state = 450},
  [257] = {.lex_state = 450},
  [258] = {.lex_state = 450},
  [259] = {.lex_state = 450},
  [260] = {.lex_state = 121},
  [261] = {.lex_state = 121},
  [262] = {.lex_state = 121},
  [263] = {.lex_state = 121},
  [264] = {.lex_state = 121},
  [265] = {.lex_state = 121},
  [266] = {.lex_state = 2, .external_lex_state = 2},
  [267] = {.lex_state = 2, .external_lex_state = 2},
  [268] = {.lex_state = 121},
  [269] = {.lex_state = 121},
  [270] = {.lex_state = 121},
  [271] = {.lex_state = 121},
  [272] = {.lex_state = 121},
  [273] = {.lex_state = 121},
  [274] = {.lex_state = 121},
  [275] = {.lex_state = 121},
  [276] = {.lex_state = 121},
  [277] = {.lex_state = 121},
  [278] = {.lex_state = 121},
  [279] = {.lex_state = 121},
  [280] = {.lex_state = 121},
  [281] = {.lex_state = 121},
  [282] = {.lex_state = 121},
  [283] = {.lex_state = 121},
  [284] = {.lex_state = 121},
  [285] = {.lex_state = 121},
  [286] = {.lex_state = 121},
  [287] = {.lex_state = 121},
  [288] = {.lex_state = 2, .external_lex_state = 2},
  [289] = {.lex_state = 121},
  [290] = {.lex_state = 121},
  [291] = {.lex_state = 121},
  [292] = {.lex_state = 121},
  [293] = {.lex_state = 121},
  [294] = {.lex_state = 121},
  [295] = {.lex_state = 121},
  [296] = {.lex_state = 121},
  [297] = {.lex_state = 121},
  [298] = {.lex_state = 121},
  [299] = {.lex_state = 2, .external_lex_state = 2},
  [300] = {.lex_state = 121},
  [301] = {.lex_state = 121},
  [302] = {.lex_state = 121},
  [303] = {.lex_state = 121},
  [304] = {.lex_state = 121},
  [305] = {.lex_state = 121},
  [306] = {.lex_state = 121},
  [307] = {.lex_state = 121},
  [308] = {.lex_state = 121},
  [309] = {.lex_state = 121},
  [310] = {.lex_state = 121},
  [311] = {.lex_state = 121},
  [312] = {.lex_state = 121},
  [313] = {.lex_state = 121},
  [314] = {.lex_state = 121},
  [315] = {.lex_state = 121},
  [316] = {.lex_state = 2},
  [317] = {.lex_state = 2},
  [318] = {.lex_state = 2},
  [319] = {.lex_state = 124},
  [320] = {.lex_state = 122},
  [321] = {.lex_state = 122},
  [322] = {.lex_state = 124},
  [323] = {.lex_state = 122},
  [324] = {.lex_state = 123},
  [325] = {.lex_state = 124},
  [326] = {.lex_state = 123},
  [327] = {.lex_state = 2},
  [328] = {.lex_state = 2},
  [329] = {.lex_state = 123},
  [330] = {.lex_state = 124},
  [331] = {.lex_state = 122},
  [332] = {.lex_state = 122},
  [333] = {.lex_state = 124},
  [334] = {.lex_state = 123},
  [335] = {.lex_state = 122},
  [336] = {.lex_state = 124},
  [337] = {.lex_state = 2},
  [338] = {.lex_state = 123},
  [339] = {.lex_state = 124},
  [340] = {.lex_state = 123},
  [341] = {.lex_state = 2},
  [342] = {.lex_state = 122},
  [343] = {.lex_state = 2},
  [344] = {.lex_state = 123},
  [345] = {.lex_state = 124},
  [346] = {.lex_state = 122},
  [347] = {.lex_state = 122},
  [348] = {.lex_state = 124},
  [349] = {.lex_state = 123},
  [350] = {.lex_state = 122},
  [351] = {.lex_state = 122},
  [352] = {.lex_state = 123},
  [353] = {.lex_state = 2},
  [354] = {.lex_state = 124},
  [355] = {.lex_state = 123},
  [356] = {.lex_state = 124},
  [357] = {.lex_state = 122},
  [358] = {.lex_state = 122},
  [359] = {.lex_state = 122},
  [360] = {.lex_state = 124},
  [361] = {.lex_state = 123},
  [362] = {.lex_state = 122},
  [363] = {.lex_state = 124},
  [364] = {.lex_state = 123},
  [365] = {.lex_state = 122},
  [366] = {.lex_state = 124},
  [367] = {.lex_state = 123},
  [368] = {.lex_state = 2},
  [369] = {.lex_state = 123},
  [370] = {.lex_state = 124},
  [371] = {.lex_state = 122},
  [372] = {.lex_state = 122},
  [373] = {.lex_state = 122},
  [374] = {.lex_state = 124},
  [375] = {.lex_state = 124},
  [376] = {.lex_state = 123},
  [377] = {.lex_state = 2},
  [378] = {.lex_state = 122},
  [379] = {.lex_state = 124},
  [380] = {.lex_state = 124},
  [381] = {.lex_state = 123},
  [382] = {.lex_state = 2},
  [383] = {.lex_state = 123},
  [384] = {.lex_state = 2},
  [385] = {.lex_state = 122},
  [386] = {.lex_state = 124},
  [387] = {.lex_state = 123},
  [388] = {.lex_state = 123},
  [389] = {.lex_state = 123},
  [390] = {.lex_state = 122},
  [391] = {.lex_state = 122},
  [392] = {.lex_state = 124},
  [393] = {.lex_state = 123},
  [394] = {.lex_state = 124},
  [395] = {.lex_state = 123},
  [396] = {.lex_state = 2},
  [397] = {.lex_state = 122},
  [398] = {.lex_state = 2},
  [399] = {.lex_state = 122},
  [400] = {.lex_state = 124},
  [401] = {.lex_state = 123},
  [402] = {.lex_state = 124},
  [403] = {.lex_state = 123},
  [404] = {.lex_state = 123},
  [405] = {.lex_state = 2},
  [406] = {.lex_state = 124},
  [407] = {.lex_state = 122},
  [408] = {.lex_state = 124},
  [409] = {.lex_state = 122},
  [410] = {.lex_state = 124},
  [411] = {.lex_state = 123},
  [412] = {.lex_state = 2},
  [413] = {.lex_state = 122},
  [414] = {.lex_state = 122},
  [415] = {.lex_state = 124},
  [416] = {.lex_state = 122},
  [417] = {.lex_state = 124},
  [418] = {.lex_state = 2},
  [419] = {.lex_state = 123},
  [420] = {.lex_state = 124},
  [421] = {.lex_state = 122},
  [422] = {.lex_state = 122},
  [423] = {.lex_state = 124},
  [424] = {.lex_state = 123},
  [425] = {.lex_state = 123},
  [426] = {.lex_state = 122},
  [427] = {.lex_state = 123},
  [428] = {.lex_state = 124},
  [429] = {.lex_state = 123},
  [430] = {.lex_state = 123},
  [431] = {.lex_state = 122},
  [432] = {.lex_state = 2},
  [433] = {.lex_state = 124},
  [434] = {.lex_state = 122},
  [435] = {.lex_state = 124},
  [436] = {.lex_state = 123},
  [437] = {.lex_state = 123},
  [438] = {.lex_state = 123},
  [439] = {.lex_state = 124},
  [440] = {.lex_state = 123},
  [441] = {.lex_state = 124},
  [442] = {.lex_state = 122},
  [443] = {.lex_state = 122},
  [444] = {.lex_state = 2},
  [445] = {.lex_state = 2},
  [446] = {.lex_state = 123},
  [447] = {.lex_state = 123},
  [448] = {.lex_state = 124},
  [449] = {.lex_state = 122},
  [450] = {.lex_state = 122},
  [451] = {.lex_state = 124},
  [452] = {.lex_state = 123},
  [453] = {.lex_state = 2},
  [454] = {.lex_state = 2},
  [455] = {.lex_state = 122},
  [456] = {.lex_state = 124},
  [457] = {.lex_state = 123},
  [458] = {.lex_state = 122},
  [459] = {.lex_state = 124},
  [460] = {.lex_state = 122},
  [461] = {.lex_state = 123},
  [462] = {.lex_state = 123},
  [463] = {.lex_state = 122},
  [464] = {.lex_state = 124},
  [465] = {.lex_state = 124},
  [466] = {.lex_state = 2},
  [467] = {.lex_state = 123},
  [468] = {.lex_state = 123},
  [469] = {.lex_state = 124},
  [470] = {.lex_state = 122},
  [471] = {.lex_state = 2},
  [472] = {.lex_state = 124},
  [473] = {.lex_state = 123},
  [474] = {.lex_state = 124},
  [475] = {.lex_state = 122},
  [476] = {.lex_state = 123},
  [477] = {.lex_state = 122},
  [478] = {.lex_state = 122},
  [479] = {.lex_state = 124},
  [480] = {.lex_state = 124},
  [481] = {.lex_state = 123},
  [482] = {.lex_state = 122},
  [483] = {.lex_state = 124},
  [484] = {.lex_state = 123},
  [485] = {.lex_state = 122},
  [486] = {.lex_state = 124},
  [487] = {.lex_state = 122},
  [488] = {.lex_state = 123},
  [489] = {.lex_state = 124},
  [490] = {.lex_state = 122},
  [491] = {.lex_state = 123},
  [492] = {.lex_state = 124},
  [493] = {.lex_state = 2},
  [494] = {.lex_state = 122},
  [495] = {.lex_state = 2},
  [496] = {.lex_state = 122},
  [497] = {.lex_state = 124},
  [498] = {.lex_state = 122},
  [499] = {.lex_state = 123},
  [500] = {.lex_state = 2},
  [501] = {.lex_state = 122},
  [502] = {.lex_state = 124},
  [503] = {.lex_state = 123},
  [504] = {.lex_state = 122},
  [505] = {.lex_state = 124},
  [506] = {.lex_state = 123},
  [507] = {.lex_state = 122},
  [508] = {.lex_state = 124},
  [509] = {.lex_state = 123},
  [510] = {.lex_state = 2},
  [511] = {.lex_state = 124},
  [512] = {.lex_state = 122},
  [513] = {.lex_state = 114, .external_lex_state = 2},
  [514] = {.lex_state = 124},
  [515] = {.lex_state = 123},
  [516] = {.lex_state = 2},
  [517] = {.lex_state = 122},
  [518] = {.lex_state = 2},
  [519] = {.lex_state = 124},
  [520] = {.lex_state = 123},
  [521] = {.lex_state = 124},
  [522] = {.lex_state = 123},
  [523] = {.lex_state = 122},
  [524] = {.lex_state = 122},
  [525] = {.lex_state = 124},
  [526] = {.lex_state = 123},
  [527] = {.lex_state = 123},
  [528] = {.lex_state = 2},
  [529] = {.lex_state = 124},
  [530] = {.lex_state = 122},
  [531] = {.lex_state = 123},
  [532] = {.lex_state = 122},
  [533] = {.lex_state = 123},
  [534] = {.lex_state = 122},
  [535] = {.lex_state = 122},
  [536] = {.lex_state = 124},
  [537] = {.lex_state = 124},
  [538] = {.lex_state = 123},
  [539] = {.lex_state = 123},
  [540] = {.lex_state = 2},
  [541] = {.lex_state = 124},
  [542] = {.lex_state = 123},
  [543] = {.lex_state = 2},
  [544] = {.lex_state = 122},
  [545] = {.lex_state = 124},
  [546] = {.lex_state = 123},
  [547] = {.lex_state = 2},
  [548] = {.lex_state = 2},
  [549] = {.lex_state = 123},
  [550] = {.lex_state = 124},
  [551] = {.lex_state = 122},
  [552] = {.lex_state = 2},
  [553] = {.lex_state = 122},
  [554] = {.lex_state = 122},
  [555] = {.lex_state = 123},
  [556] = {.lex_state = 124},
  [557] = {.lex_state = 124},
  [558] = {.lex_state = 124},
  [559] = {.lex_state = 123},
  [560] = {.lex_state = 123},
  [561] = {.lex_state = 2},
  [562] = {.lex_state = 122},
  [563] = {.lex_state = 124},
  [564] = {.lex_state = 122},
  [565] = {.lex_state = 122},
  [566] = {.lex_state = 2},
  [567] = {.lex_state = 122},
  [568] = {.lex_state = 124},
  [569] = {.lex_state = 123},
  [570] = {.lex_state = 2},
  [571] = {.lex_state = 123},
  [572] = {.lex_state = 122},
  [573] = {.lex_state = 124},
  [574] = {.lex_state = 123},
  [575] = {.lex_state = 122},
  [576] = {.lex_state = 124},
  [577] = {.lex_state = 123},
  [578] = {.lex_state = 123},
  [579] = {.lex_state = 124},
  [580] = {.lex_state = 122},
  [581] = {.lex_state = 2},
  [582] = {.lex_state = 122},
  [583] = {.lex_state = 124},
  [584] = {.lex_state = 123},
  [585] = {.lex_state = 122},
  [586] = {.lex_state = 124},
  [587] = {.lex_state = 123},
  [588] = {.lex_state = 124},
  [589] = {.lex_state = 123},
  [590] = {.lex_state = 122},
  [591] = {.lex_state = 122},
  [592] = {.lex_state = 124},
  [593] = {.lex_state = 123},
  [594] = {.lex_state = 2},
  [595] = {.lex_state = 122},
  [596] = {.lex_state = 124},
  [597] = {.lex_state = 123},
  [598] = {.lex_state = 2},
  [599] = {.lex_state = 124},
  [600] = {.lex_state = 123},
  [601] = {.lex_state = 124},
  [602] = {.lex_state = 2},
  [603] = {.lex_state = 123},
  [604] = {.lex_state = 122},
  [605] = {.lex_state = 122},
  [606] = {.lex_state = 122},
  [607] = {.lex_state = 124},
  [608] = {.lex_state = 124},
  [609] = {.lex_state = 123},
  [610] = {.lex_state = 123},
  [611] = {.lex_state = 2},
  [612] = {.lex_state = 124},
  [613] = {.lex_state = 123},
  [614] = {.lex_state = 2},
  [615] = {.lex_state = 2},
  [616] = {.lex_state = 29},
  [617] = {.lex_state = 28},
  [618] = {.lex_state = 2},
  [619] = {.lex_state = 2},
  [620] = {.lex_state = 2},
  [621] = {.lex_state = 28},
  [622] = {.lex_state = 2},
  [623] = {.lex_state = 2},
  [624] = {.lex_state = 29},
  [625] = {.lex_state = 29},
  [626] = {.lex_state = 2},
  [627] = {.lex_state = 2},
  [628] = {.lex_state = 29},
  [629] = {.lex_state = 2},
  [630] = {.lex_state = 29},
  [631] = {.lex_state = 2},
  [632] = {.lex_state = 2},
  [633] = {.lex_state = 29},
  [634] = {.lex_state = 28},
  [635] = {.lex_state = 2},
  [636] = {.lex_state = 2},
  [637] = {.lex_state = 29},
  [638] = {.lex_state = 28},
  [639] = {.lex_state = 29},
  [640] = {.lex_state = 2},
  [641] = {.lex_state = 2},
  [642] = {.lex_state = 2},
  [643] = {.lex_state = 2},
  [644] = {.lex_state = 2},
  [645] = {.lex_state = 29},
  [646] = {.lex_state = 28},
  [647] = {.lex_state = 2},
  [648] = {.lex_state = 28},
  [649] = {.lex_state = 2},
  [650] = {.lex_state = 2},
  [651] = {.lex_state = 29},
  [652] = {.lex_state = 2},
  [653] = {.lex_state = 2},
  [654] = {.lex_state = 28},
  [655] = {.lex_state = 2},
  [656] = {.lex_state = 29},
  [657] = {.lex_state = 28},
  [658] = {.lex_state = 28},
  [659] = {.lex_state = 2},
  [660] = {.lex_state = 29},
  [661] = {.lex_state = 29},
  [662] = {.lex_state = 2},
  [663] = {.lex_state = 2},
  [664] = {.lex_state = 29},
  [665] = {.lex_state = 28},
  [666] = {.lex_state = 2},
  [667] = {.lex_state = 28},
  [668] = {.lex_state = 2},
  [669] = {.lex_state = 28},
  [670] = {.lex_state = 29},
  [671] = {.lex_state = 2},
  [672] = {.lex_state = 2},
  [673] = {.lex_state = 29},
  [674] = {.lex_state = 2},
  [675] = {.lex_state = 29},
  [676] = {.lex_state = 28},
  [677] = {.lex_state = 2},
  [678] = {.lex_state = 2},
  [679] = {.lex_state = 29},
  [680] = {.lex_state = 2},
  [681] = {.lex_state = 28},
  [682] = {.lex_state = 2},
  [683] = {.lex_state = 29},
  [684] = {.lex_state = 2},
  [685] = {.lex_state = 28},
  [686] = {.lex_state = 29},
  [687] = {.lex_state = 29},
  [688] = {.lex_state = 2},
  [689] = {.lex_state = 2},
  [690] = {.lex_state = 28},
  [691] = {.lex_state = 2},
  [692] = {.lex_state = 2},
  [693] = {.lex_state = 28},
  [694] = {.lex_state = 2},
  [695] = {.lex_state = 2},
  [696] = {.lex_state = 2},
  [697] = {.lex_state = 2},
  [698] = {.lex_state = 29},
  [699] = {.lex_state = 28},
  [700] = {.lex_state = 28},
  [701] = {.lex_state = 2},
  [702] = {.lex_state = 2},
  [703] = {.lex_state = 2},
  [704] = {.lex_state = 28},
  [705] = {.lex_state = 29},
  [706] = {.lex_state = 29},
  [707] = {.lex_state = 2},
  [708] = {.lex_state = 2},
  [709] = {.lex_state = 2},
  [710] = {.lex_state = 2},
  [711] = {.lex_state = 2},
  [712] = {.lex_state = 29},
  [713] = {.lex_state = 28},
  [714] = {.lex_state = 2},
  [715] = {.lex_state = 28},
  [716] = {.lex_state = 28},
  [717] = {.lex_state = 29},
  [718] = {.lex_state = 2},
  [719] = {.lex_state = 2},
  [720] = {.lex_state = 2},
  [721] = {.lex_state = 2},
  [722] = {.lex_state = 2},
  [723] = {.lex_state = 2},
  [724] = {.lex_state = 28},
  [725] = {.lex_state = 28},
  [726] = {.lex_state = 2},
  [727] = {.lex_state = 29},
  [728] = {.lex_state = 2},
  [729] = {.lex_state = 2},
  [730] = {.lex_state = 2},
  [731] = {.lex_state = 28},
  [732] = {.lex_state = 29},
  [733] = {.lex_state = 2},
  [734] = {.lex_state = 2},
  [735] = {.lex_state = 28},
  [736] = {.lex_state = 2},
  [737] = {.lex_state = 29},
  [738] = {.lex_state = 29},
  [739] = {.lex_state = 29},
  [740] = {.lex_state = 2},
  [741] = {.lex_state = 2},
  [742] = {.lex_state = 2},
  [743] = {.lex_state = 29},
  [744] = {.lex_state = 28},
  [745] = {.lex_state = 28},
  [746] = {.lex_state = 2},
  [747] = {.lex_state = 2},
  [748] = {.lex_state = 28},
  [749] = {.lex_state = 29},
  [750] = {.lex_state = 29},
  [751] = {.lex_state = 2},
  [752] = {.lex_state = 2},
  [753] = {.lex_state = 28},
  [754] = {.lex_state = 29},
  [755] = {.lex_state = 2},
  [756] = {.lex_state = 2},
  [757] = {.lex_state = 29},
  [758] = {.lex_state = 28},
  [759] = {.lex_state = 28},
  [760] = {.lex_state = 28},
  [761] = {.lex_state = 2},
  [762] = {.lex_state = 2},
  [763] = {.lex_state = 2},
  [764] = {.lex_state = 2},
  [765] = {.lex_state = 2},
  [766] = {.lex_state = 29},
  [767] = {.lex_state = 28},
  [768] = {.lex_state = 29},
  [769] = {.lex_state = 2},
  [770] = {.lex_state = 2},
  [771] = {.lex_state = 28},
  [772] = {.lex_state = 29},
  [773] = {.lex_state = 2},
  [774] = {.lex_state = 2},
  [775] = {.lex_state = 2},
  [776] = {.lex_state = 2},
  [777] = {.lex_state = 29},
  [778] = {.lex_state = 28},
  [779] = {.lex_state = 2},
  [780] = {.lex_state = 29},
  [781] = {.lex_state = 2},
  [782] = {.lex_state = 2},
  [783] = {.lex_state = 28},
  [784] = {.lex_state = 28},
  [785] = {.lex_state = 29},
  [786] = {.lex_state = 2},
  [787] = {.lex_state = 28},
  [788] = {.lex_state = 29},
  [789] = {.lex_state = 2},
  [790] = {.lex_state = 2},
  [791] = {.lex_state = 2},
  [792] = {.lex_state = 2},
  [793] = {.lex_state = 28},
  [794] = {.lex_state = 29},
  [795] = {.lex_state = 2},
  [796] = {.lex_state = 2},
  [797] = {.lex_state = 29},
  [798] = {.lex_state = 2},
  [799] = {.lex_state = 28},
  [800] = {.lex_state = 2},
  [801] = {.lex_state = 29},
  [802] = {.lex_state = 2},
  [803] = {.lex_state = 2},
  [804] = {.lex_state = 2},
  [805] = {.lex_state = 28},
  [806] = {.lex_state = 29},
  [807] = {.lex_state = 28},
  [808] = {.lex_state = 29},
  [809] = {.lex_state = 2},
  [810] = {.lex_state = 2},
  [811] = {.lex_state = 2},
  [812] = {.lex_state = 28},
  [813] = {.lex_state = 29},
  [814] = {.lex_state = 2},
  [815] = {.lex_state = 2},
  [816] = {.lex_state = 29},
  [817] = {.lex_state = 28},
  [818] = {.lex_state = 29},
  [819] = {.lex_state = 28},
  [820] = {.lex_state = 28},
  [821] = {.lex_state = 2},
  [822] = {.lex_state = 2},
  [823] = {.lex_state = 28},
  [824] = {.lex_state = 2},
  [825] = {.lex_state = 29},
  [826] = {.lex_state = 2},
  [827] = {.lex_state = 28},
  [828] = {.lex_state = 2},
  [829] = {.lex_state = 2},
  [830] = {.lex_state = 29},
  [831] = {.lex_state = 2},
  [832] = {.lex_state = 2},
  [833] = {.lex_state = 28},
  [834] = {.lex_state = 2},
  [835] = {.lex_state = 29},
  [836] = {.lex_state = 2},
  [837] = {.lex_state = 2},
  [838] = {.lex_state = 2},
  [839] = {.lex_state = 2},
  [840] = {.lex_state = 29},
  [841] = {.lex_state = 2},
  [842] = {.lex_state = 29},
  [843] = {.lex_state = 28},
  [844] = {.lex_state = 2},
  [845] = {.lex_state = 29},
  [846] = {.lex_state = 2},
  [847] = {.lex_state = 2},
  [848] = {.lex_state = 2},
  [849] = {.lex_state = 28},
  [850] = {.lex_state = 28},
  [851] = {.lex_state = 29},
  [852] = {.lex_state = 29},
  [853] = {.lex_state = 2},
  [854] = {.lex_state = 28},
  [855] = {.lex_state = 2},
  [856] = {.lex_state = 2},
  [857] = {.lex_state = 2},
  [858] = {.lex_state = 29},
  [859] = {.lex_state = 28},
  [860] = {.lex_state = 28},
  [861] = {.lex_state = 2},
  [862] = {.lex_state = 2},
  [863] = {.lex_state = 29},
  [864] = {.lex_state = 2},
  [865] = {.lex_state = 2},
  [866] = {.lex_state = 28},
  [867] = {.lex_state = 28},
  [868] = {.lex_state = 29},
  [869] = {.lex_state = 29},
  [870] = {.lex_state = 2},
  [871] = {.lex_state = 2},
  [872] = {.lex_state = 2},
  [873] = {.lex_state = 2},
  [874] = {.lex_state = 28},
  [875] = {.lex_state = 29},
  [876] = {.lex_state = 2},
  [877] = {.lex_state = 2},
  [878] = {.lex_state = 28},
  [879] = {.lex_state = 2},
  [880] = {.lex_state = 28},
  [881] = {.lex_state = 29},
  [882] = {.lex_state = 2},
  [883] = {.lex_state = 2},
  [884] = {.lex_state = 29},
  [885] = {.lex_state = 2},
  [886] = {.lex_state = 2},
  [887] = {.lex_state = 28},
  [888] = {.lex_state = 28},
  [889] = {.lex_state = 29},
  [890] = {.lex_state = 28},
  [891] = {.lex_state = 2},
  [892] = {.lex_state = 29},
  [893] = {.lex_state = 2},
  [894] = {.lex_state = 2},
  [895] = {.lex_state = 2},
  [896] = {.lex_state = 2},
  [897] = {.lex_state = 28},
  [898] = {.lex_state = 29},
  [899] = {.lex_state = 2},
  [900] = {.lex_state = 2},
  [901] = {.lex_state = 29},
  [902] = {.lex_state = 28},
  [903] = {.lex_state = 28},
  [904] = {.lex_state = 29},
  [905] = {.lex_state = 29},
  [906] = {.lex_state = 2},
  [907] = {.lex_state = 2},
  [908] = {.lex_state = 2},
  [909] = {.lex_state = 28},
  [910] = {.lex_state = 2},
  [911] = {.lex_state = 2},
  [912] = {.lex_state = 28},
  [913] = {.lex_state = 28},
  [914] = {.lex_state = 28},
  [915] = {.lex_state = 2},
  [916] = {.lex_state = 28},
  [917] = {.lex_state = 29},
  [918] = {.lex_state = 2},
  [919] = {.lex_state = 29},
  [920] = {.lex_state = 2},
  [921] = {.lex_state = 2},
  [922] = {.lex_state = 28},
  [923] = {.lex_state = 29},
  [924] = {.lex_state = 2},
  [925] = {.lex_state = 2},
  [926] = {.lex_state = 29},
  [927] = {.lex_state = 29},
  [928] = {.lex_state = 2},
  [929] = {.lex_state = 28},
  [930] = {.lex_state = 2},
  [931] = {.lex_state = 28},
  [932] = {.lex_state = 29},
  [933] = {.lex_state = 29},
  [934] = {.lex_state = 2},
  [935] = {.lex_state = 2},
  [936] = {.lex_state = 2},
  [937] = {.lex_state = 29},
  [938] = {.lex_state = 28},
  [939] = {.lex_state = 2},
  [940] = {.lex_state = 2},
  [941] = {.lex_state = 2},
  [942] = {.lex_state = 28},
  [943] = {.lex_state = 2},
  [944] = {.lex_state = 28},
  [945] = {.lex_state = 29},
  [946] = {.lex_state = 2},
  [947] = {.lex_state = 2},
  [948] = {.lex_state = 2},
  [949] = {.lex_state = 2},
  [950] = {.lex_state = 2},
  [951] = {.lex_state = 2},
  [952] = {.lex_state = 29},
  [953] = {.lex_state = 28},
  [954] = {.lex_state = 2},
  [955] = {.lex_state = 29},
  [956] = {.lex_state = 28},
  [957] = {.lex_state = 2},
  [958] = {.lex_state = 2},
  [959] = {.lex_state = 29},
  [960] = {.lex_state = 28},
  [961] = {.lex_state = 2},
  [962] = {.lex_state = 29},
  [963] = {.lex_state = 2},
  [964] = {.lex_state = 2},
  [965] = {.lex_state = 2},
  [966] = {.lex_state = 28},
  [967] = {.lex_state = 2},
  [968] = {.lex_state = 2},
  [969] = {.lex_state = 2},
  [970] = {.lex_state = 28},
  [971] = {.lex_state = 29},
  [972] = {.lex_state = 29},
  [973] = {.lex_state = 28},
  [974] = {.lex_state = 2},
  [975] = {.lex_state = 2},
  [976] = {.lex_state = 2},
  [977] = {.lex_state = 29},
  [978] = {.lex_state = 2},
  [979] = {.lex_state = 28},
  [980] = {.lex_state = 28},
  [981] = {.lex_state = 2},
  [982] = {.lex_state = 29},
  [983] = {.lex_state = 2},
  [984] = {.lex_state = 2},
  [985] = {.lex_state = 2},
  [986] = {.lex_state = 2},
  [987] = {.lex_state = 28},
  [988] = {.lex_state = 28},
  [989] = {.lex_state = 29},
  [990] = {.lex_state = 2},
  [991] = {.lex_state = 28},
  [992] = {.lex_state = 29},
  [993] = {.lex_state = 2},
  [994] = {.lex_state = 29},
  [995] = {.lex_state = 2},
  [996] = {.lex_state = 2},
  [997] = {.lex_state = 28},
  [998] = {.lex_state = 2},
  [999] = {.lex_state = 29},
  [1000] = {.lex_state = 28},
  [1001] = {.lex_state = 29},
  [1002] = {.lex_state = 2},
  [1003] = {.lex_state = 2},
  [1004] = {.lex_state = 2},
  [1005] = {.lex_state = 28},
  [1006] = {.lex_state = 2},
  [1007] = {.lex_state = 2},
  [1008] = {.lex_state = 2},
  [1009] = {.lex_state = 28},
  [1010] = {.lex_state = 28},
  [1011] = {.lex_state = 2},
  [1012] = {.lex_state = 29},
  [1013] = {.lex_state = 2},
  [1014] = {.lex_state = 2},
  [1015] = {.lex_state = 2},
  [1016] = {.lex_state = 29},
  [1017] = {.lex_state = 2},
  [1018] = {.lex_state = 28},
  [1019] = {.lex_state = 2},
  [1020] = {.lex_state = 2},
  [1021] = {.lex_state = 2},
  [1022] = {.lex_state = 28},
  [1023] = {.lex_state = 28},
  [1024] = {.lex_state = 29},
  [1025] = {.lex_state = 28},
  [1026] = {.lex_state = 29},
  [1027] = {.lex_state = 2},
  [1028] = {.lex_state = 2},
  [1029] = {.lex_state = 2},
  [1030] = {.lex_state = 29},
  [1031] = {.lex_state = 2},
  [1032] = {.lex_state = 2},
  [1033] = {.lex_state = 29},
  [1034] = {.lex_state = 2},
  [1035] = {.lex_state = 28},
  [1036] = {.lex_state = 28},
  [1037] = {.lex_state = 2},
  [1038] = {.lex_state = 2},
  [1039] = {.lex_state = 29},
  [1040] = {.lex_state = 2},
  [1041] = {.lex_state = 2},
  [1042] = {.lex_state = 2},
  [1043] = {.lex_state = 28},
  [1044] = {.lex_state = 29},
  [1045] = {.lex_state = 2},
  [1046] = {.lex_state = 29},
  [1047] = {.lex_state = 28},
  [1048] = {.lex_state = 2},
  [1049] = {.lex_state = 2},
  [1050] = {.lex_state = 2},
  [1051] = {.lex_state = 2},
  [1052] = {.lex_state = 2},
  [1053] = {.lex_state = 28},
  [1054] = {.lex_state = 29},
  [1055] = {.lex_state = 2},
  [1056] = {.lex_state = 29},
  [1057] = {.lex_state = 2},
  [1058] = {.lex_state = 28},
  [1059] = {.lex_state = 2},
  [1060] = {.lex_state = 28},
  [1061] = {.lex_state = 29},
  [1062] = {.lex_state = 2},
  [1063] = {.lex_state = 28},
  [1064] = {.lex_state = 2},
  [1065] = {.lex_state = 28},
  [1066] = {.lex_state = 29},
  [1067] = {.lex_state = 28},
  [1068] = {.lex_state = 29},
  [1069] = {.lex_state = 2},
  [1070] = {.lex_state = 2},
  [1071] = {.lex_state = 2},
  [1072] = {.lex_state = 28},
  [1073] = {.lex_state = 29},
  [1074] = {.lex_state = 2},
  [1075] = {.lex_state = 2},
  [1076] = {.lex_state = 2},
  [1077] = {.lex_state = 2},
  [1078] = {.lex_state = 28},
  [1079] = {.lex_state = 29},
  [1080] = {.lex_state = 2},
  [1081] = {.lex_state = 2},
  [1082] = {.lex_state = 28},
  [1083] = {.lex_state = 2},
  [1084] = {.lex_state = 28},
  [1085] = {.lex_state = 2},
  [1086] = {.lex_state = 29},
  [1087] = {.lex_state = 2},
  [1088] = {.lex_state = 28},
  [1089] = {.lex_state = 2},
  [1090] = {.lex_state = 29},
  [1091] = {.lex_state = 2},
  [1092] = {.lex_state = 2},
  [1093] = {.lex_state = 29},
  [1094] = {.lex_state = 2},
  [1095] = {.lex_state = 29},
  [1096] = {.lex_state = 2},
  [1097] = {.lex_state = 2},
  [1098] = {.lex_state = 2},
  [1099] = {.lex_state = 28},
  [1100] = {.lex_state = 29},
  [1101] = {.lex_state = 28},
  [1102] = {.lex_state = 29},
  [1103] = {.lex_state = 2},
  [1104] = {.lex_state = 2},
  [1105] = {.lex_state = 28},
  [1106] = {.lex_state = 2},
  [1107] = {.lex_state = 29},
  [1108] = {.lex_state = 2},
  [1109] = {.lex_state = 28},
  [1110] = {.lex_state = 2},
  [1111] = {.lex_state = 29},
  [1112] = {.lex_state = 29},
  [1113] = {.lex_state = 2},
  [1114] = {.lex_state = 2},
  [1115] = {.lex_state = 28},
  [1116] = {.lex_state = 28},
  [1117] = {.lex_state = 29},
  [1118] = {.lex_state = 2},
  [1119] = {.lex_state = 2},
  [1120] = {.lex_state = 29},
  [1121] = {.lex_state = 2},
  [1122] = {.lex_state = 28},
  [1123] = {.lex_state = 2},
  [1124] = {.lex_state = 29},
  [1125] = {.lex_state = 2},
  [1126] = {.lex_state = 2},
  [1127] = {.lex_state = 2},
  [1128] = {.lex_state = 2},
  [1129] = {.lex_state = 28},
  [1130] = {.lex_state = 29},
  [1131] = {.lex_state = 2},
  [1132] = {.lex_state = 29},
  [1133] = {.lex_state = 28},
  [1134] = {.lex_state = 2},
  [1135] = {.lex_state = 2},
  [1136] = {.lex_state = 2},
  [1137] = {.lex_state = 28},
  [1138] = {.lex_state = 29},
  [1139] = {.lex_state = 2},
  [1140] = {.lex_state = 29},
  [1141] = {.lex_state = 2},
  [1142] = {.lex_state = 28},
  [1143] = {.lex_state = 2},
  [1144] = {.lex_state = 28},
  [1145] = {.lex_state = 2},
  [1146] = {.lex_state = 29},
  [1147] = {.lex_state = 28},
  [1148] = {.lex_state = 29},
  [1149] = {.lex_state = 2},
  [1150] = {.lex_state = 2},
  [1151] = {.lex_state = 2},
  [1152] = {.lex_state = 28},
  [1153] = {.lex_state = 2},
  [1154] = {.lex_state = 2},
  [1155] = {.lex_state = 28},
  [1156] = {.lex_state = 29},
  [1157] = {.lex_state = 2},
  [1158] = {.lex_state = 2},
  [1159] = {.lex_state = 2},
  [1160] = {.lex_state = 28},
  [1161] = {.lex_state = 29},
  [1162] = {.lex_state = 2},
  [1163] = {.lex_state = 2},
  [1164] = {.lex_state = 28},
  [1165] = {.lex_state = 2},
  [1166] = {.lex_state = 29},
  [1167] = {.lex_state = 2},
  [1168] = {.lex_state = 2},
  [1169] = {.lex_state = 28},
  [1170] = {.lex_state = 2},
  [1171] = {.lex_state = 29},
  [1172] = {.lex_state = 29},
  [1173] = {.lex_state = 2},
  [1174] = {.lex_state = 28},
  [1175] = {.lex_state = 29},
  [1176] = {.lex_state = 2},
  [1177] = {.lex_state = 28},
  [1178] = {.lex_state = 29},
  [1179] = {.lex_state = 2},
  [1180] = {.lex_state = 2},
  [1181] = {.lex_state = 2},
  [1182] = {.lex_state = 2},
  [1183] = {.lex_state = 28},
  [1184] = {.lex_state = 2},
  [1185] = {.lex_state = 28},
  [1186] = {.lex_state = 28},
  [1187] = {.lex_state = 29},
  [1188] = {.lex_state = 2},
  [1189] = {.lex_state = 2},
  [1190] = {.lex_state = 29},
  [1191] = {.lex_state = 2},
  [1192] = {.lex_state = 29},
  [1193] = {.lex_state = 28},
  [1194] = {.lex_state = 2},
  [1195] = {.lex_state = 29},
  [1196] = {.lex_state = 2},
  [1197] = {.lex_state = 2},
  [1198] = {.lex_state = 2},
  [1199] = {.lex_state = 28},
  [1200] = {.lex_state = 2},
  [1201] = {.lex_state = 28},
  [1202] = {.lex_state = 29},
  [1203] = {.lex_state = 2},
  [1204] = {.lex_state = 28},
  [1205] = {.lex_state = 2},
  [1206] = {.lex_state = 2},
  [1207] = {.lex_state = 29},
  [1208] = {.lex_state = 2},
  [1209] = {.lex_state = 2},
  [1210] = {.lex_state = 28},
  [1211] = {.lex_state = 2},
  [1212] = {.lex_state = 29},
  [1213] = {.lex_state = 28},
  [1214] = {.lex_state = 2},
  [1215] = {.lex_state = 2},
  [1216] = {.lex_state = 2},
  [1217] = {.lex_state = 28},
  [1218] = {.lex_state = 29},
  [1219] = {.lex_state = 2},
  [1220] = {.lex_state = 2},
  [1221] = {.lex_state = 28},
  [1222] = {.lex_state = 29},
  [1223] = {.lex_state = 29},
  [1224] = {.lex_state = 2},
  [1225] = {.lex_state = 2},
  [1226] = {.lex_state = 2},
  [1227] = {.lex_state = 28},
  [1228] = {.lex_state = 28},
  [1229] = {.lex_state = 29},
  [1230] = {.lex_state = 2},
  [1231] = {.lex_state = 29},
  [1232] = {.lex_state = 2},
  [1233] = {.lex_state = 2},
  [1234] = {.lex_state = 2},
  [1235] = {.lex_state = 28},
  [1236] = {.lex_state = 29},
  [1237] = {.lex_state = 2},
  [1238] = {.lex_state = 29},
  [1239] = {.lex_state = 2},
  [1240] = {.lex_state = 2},
  [1241] = {.lex_state = 2},
  [1242] = {.lex_state = 2},
  [1243] = {.lex_state = 29},
  [1244] = {.lex_state = 2},
  [1245] = {.lex_state = 28},
  [1246] = {.lex_state = 2},
  [1247] = {.lex_state = 2},
  [1248] = {.lex_state = 28},
  [1249] = {.lex_state = 28},
  [1250] = {.lex_state = 29},
  [1251] = {.lex_state = 2},
  [1252] = {.lex_state = 29},
  [1253] = {.lex_state = 2},
  [1254] = {.lex_state = 2},
  [1255] = {.lex_state = 2},
  [1256] = {.lex_state = 28},
  [1257] = {.lex_state = 29},
  [1258] = {.lex_state = 2},
  [1259] = {.lex_state = 2},
  [1260] = {.lex_state = 28},
  [1261] = {.lex_state = 29},
  [1262] = {.lex_state = 2},
  [1263] = {.lex_state = 2},
  [1264] = {.lex_state = 28},
  [1265] = {.lex_state = 2},
  [1266] = {.lex_state = 29},
  [1267] = {.lex_state = 2},
  [1268] = {.lex_state = 2},
  [1269] = {.lex_state = 2},
  [1270] = {.lex_state = 28},
  [1271] = {.lex_state = 29},
  [1272] = {.lex_state = 2},
  [1273] = {.lex_state = 29},
  [1274] = {.lex_state = 2},
  [1275] = {.lex_state = 2},
  [1276] = {.lex_state = 2},
  [1277] = {.lex_state = 2},
  [1278] = {.lex_state = 2},
  [1279] = {.lex_state = 28},
  [1280] = {.lex_state = 29},
  [1281] = {.lex_state = 2},
  [1282] = {.lex_state = 2},
  [1283] = {.lex_state = 28},
  [1284] = {.lex_state = 2},
  [1285] = {.lex_state = 29},
  [1286] = {.lex_state = 28},
  [1287] = {.lex_state = 2},
  [1288] = {.lex_state = 29},
  [1289] = {.lex_state = 28},
  [1290] = {.lex_state = 2},
  [1291] = {.lex_state = 2},
  [1292] = {.lex_state = 28},
  [1293] = {.lex_state = 29},
  [1294] = {.lex_state = 29},
  [1295] = {.lex_state = 2},
  [1296] = {.lex_state = 2},
  [1297] = {.lex_state = 28},
  [1298] = {.lex_state = 2},
  [1299] = {.lex_state = 2},
  [1300] = {.lex_state = 29},
  [1301] = {.lex_state = 2},
  [1302] = {.lex_state = 2},
  [1303] = {.lex_state = 28},
  [1304] = {.lex_state = 28},
  [1305] = {.lex_state = 29},
  [1306] = {.lex_state = 2},
  [1307] = {.lex_state = 2},
  [1308] = {.lex_state = 29},
  [1309] = {.lex_state = 2},
  [1310] = {.lex_state = 28},
  [1311] = {.lex_state = 29},
  [1312] = {.lex_state = 29},
  [1313] = {.lex_state = 2},
  [1314] = {.lex_state = 2},
  [1315] = {.lex_state = 2},
  [1316] = {.lex_state = 28},
  [1317] = {.lex_state = 29},
  [1318] = {.lex_state = 2},
  [1319] = {.lex_state = 2},
  [1320] = {.lex_state = 29},
  [1321] = {.lex_state = 2},
  [1322] = {.lex_state = 2},
  [1323] = {.lex_state = 29},
  [1324] = {.lex_state = 2},
  [1325] = {.lex_state = 28},
  [1326] = {.lex_state = 29},
  [1327] = {.lex_state = 2},
  [1328] = {.lex_state = 2},
  [1329] = {.lex_state = 28},
  [1330] = {.lex_state = 2},
  [1331] = {.lex_state = 29},
  [1332] = {.lex_state = 28},
  [1333] = {.lex_state = 2},
  [1334] = {.lex_state = 28},
  [1335] = {.lex_state = 28},
  [1336] = {.lex_state = 2},
  [1337] = {.lex_state = 29},
  [1338] = {.lex_state = 28},
  [1339] = {.lex_state = 2},
  [1340] = {.lex_state = 28},
  [1341] = {.lex_state = 29},
  [1342] = {.lex_state = 2},
  [1343] = {.lex_state = 2},
  [1344] = {.lex_state = 28},
  [1345] = {.lex_state = 29},
  [1346] = {.lex_state = 2},
  [1347] = {.lex_state = 2},
  [1348] = {.lex_state = 2},
  [1349] = {.lex_state = 28},
  [1350] = {.lex_state = 29},
  [1351] = {.lex_state = 2},
  [1352] = {.lex_state = 2},
  [1353] = {.lex_state = 28},
  [1354] = {.lex_state = 28},
  [1355] = {.lex_state = 29},
  [1356] = {.lex_state = 2},
  [1357] = {.lex_state = 2},
  [1358] = {.lex_state = 28},
  [1359] = {.lex_state = 29},
  [1360] = {.lex_state = 2},
  [1361] = {.lex_state = 29},
  [1362] = {.lex_state = 2},
  [1363] = {.lex_state = 2},
  [1364] = {.lex_state = 2},
  [1365] = {.lex_state = 28},
  [1366] = {.lex_state = 29},
  [1367] = {.lex_state = 29},
  [1368] = {.lex_state = 2},
  [1369] = {.lex_state = 2},
  [1370] = {.lex_state = 2},
  [1371] = {.lex_state = 2},
  [1372] = {.lex_state = 28},
  [1373] = {.lex_state = 2},
  [1374] = {.lex_state = 29},
  [1375] = {.lex_state = 2},
  [1376] = {.lex_state = 28},
  [1377] = {.lex_state = 2},
  [1378] = {.lex_state = 2},
  [1379] = {.lex_state = 29},
  [1380] = {.lex_state = 28},
  [1381] = {.lex_state = 29},
  [1382] = {.lex_state = 2},
  [1383] = {.lex_state = 29},
  [1384] = {.lex_state = 2},
  [1385] = {.lex_state = 2},
  [1386] = {.lex_state = 28},
  [1387] = {.lex_state = 2},
  [1388] = {.lex_state = 28},
  [1389] = {.lex_state = 29},
  [1390] = {.lex_state = 2},
  [1391] = {.lex_state = 2},
  [1392] = {.lex_state = 28},
  [1393] = {.lex_state = 28},
  [1394] = {.lex_state = 28},
  [1395] = {.lex_state = 2},
  [1396] = {.lex_state = 2},
  [1397] = {.lex_state = 185},
  [1398] = {.lex_state = 2},
  [1399] = {.lex_state = 2},
  [1400] = {.lex_state = 2},
  [1401] = {.lex_state = 2},
  [1402] = {.lex_state = 2},
  [1403] = {.lex_state = 2},
  [1404] = {.lex_state = 2},
  [1405] = {.lex_state = 2},
  [1406] = {.lex_state = 2},
  [1407] = {.lex_state = 2},
  [1408] = {.lex_state = 2},
  [1409] = {.lex_state = 2},
  [1410] = {.lex_state = 2},
  [1411] = {.lex_state = 2},
  [1412] = {.lex_state = 2},
  [1413] = {.lex_state = 2},
  [1414] = {.lex_state = 185},
  [1415] = {.lex_state = 2},
  [1416] = {.lex_state = 2},
  [1417] = {.lex_state = 2},
  [1418] = {.lex_state = 2},
  [1419] = {.lex_state = 2},
  [1420] = {.lex_state = 2},
  [1421] = {.lex_state = 2},
  [1422] = {.lex_state = 2},
  [1423] = {.lex_state = 185},
  [1424] = {.lex_state = 2},
  [1425] = {.lex_state = 2},
  [1426] = {.lex_state = 2},
  [1427] = {.lex_state = 2},
  [1428] = {.lex_state = 2},
  [1429] = {.lex_state = 2},
  [1430] = {.lex_state = 2},
  [1431] = {.lex_state = 2},
  [1432] = {.lex_state = 2},
  [1433] = {.lex_state = 2},
  [1434] = {.lex_state = 2},
  [1435] = {.lex_state = 2},
  [1436] = {.lex_state = 185},
  [1437] = {.lex_state = 2},
  [1438] = {.lex_state = 2},
  [1439] = {.lex_state = 2},
  [1440] = {.lex_state = 2},
  [1441] = {.lex_state = 2},
  [1442] = {.lex_state = 2},
  [1443] = {.lex_state = 2},
  [1444] = {.lex_state = 2},
  [1445] = {.lex_state = 2},
  [1446] = {.lex_state = 2},
  [1447] = {.lex_state = 2},
  [1448] = {.lex_state = 2},
  [1449] = {.lex_state = 2},
  [1450] = {.lex_state = 2},
  [1451] = {.lex_state = 2},
  [1452] = {.lex_state = 2},
  [1453] = {.lex_state = 2},
  [1454] = {.lex_state = 2},
  [1455] = {.lex_state = 2},
  [1456] = {.lex_state = 2},
  [1457] = {.lex_state = 2},
  [1458] = {.lex_state = 2},
  [1459] = {.lex_state = 2},
  [1460] = {.lex_state = 2},
  [1461] = {.lex_state = 2},
  [1462] = {.lex_state = 2},
  [1463] = {.lex_state = 185},
  [1464] = {.lex_state = 2},
  [1465] = {.lex_state = 2},
  [1466] = {.lex_state = 2},
  [1467] = {.lex_state = 2},
  [1468] = {.lex_state = 2},
  [1469] = {.lex_state = 2},
  [1470] = {.lex_state = 2},
  [1471] = {.lex_state = 2},
  [1472] = {.lex_state = 2},
  [1473] = {.lex_state = 2},
  [1474] = {.lex_state = 2},
  [1475] = {.lex_state = 2},
  [1476] = {.lex_state = 2},
  [1477] = {.lex_state = 2},
  [1478] = {.lex_state = 2},
  [1479] = {.lex_state = 2},
  [1480] = {.lex_state = 185},
  [1481] = {.lex_state = 2},
  [1482] = {.lex_state = 2},
  [1483] = {.lex_state = 2},
  [1484] = {.lex_state = 2},
  [1485] = {.lex_state = 2},
  [1486] = {.lex_state = 2},
  [1487] = {.lex_state = 2},
  [1488] = {.lex_state = 2},
  [1489] = {.lex_state = 2},
  [1490] = {.lex_state = 2},
  [1491] = {.lex_state = 2},
  [1492] = {.lex_state = 2},
  [1493] = {.lex_state = 2},
  [1494] = {.lex_state = 2},
  [1495] = {.lex_state = 2},
  [1496] = {.lex_state = 2},
  [1497] = {.lex_state = 2},
  [1498] = {.lex_state = 2},
  [1499] = {.lex_state = 2},
  [1500] = {.lex_state = 2},
  [1501] = {.lex_state = 2},
  [1502] = {.lex_state = 2},
  [1503] = {.lex_state = 185},
  [1504] = {.lex_state = 2},
  [1505] = {.lex_state = 2},
  [1506] = {.lex_state = 2},
  [1507] = {.lex_state = 2},
  [1508] = {.lex_state = 2},
  [1509] = {.lex_state = 2},
  [1510] = {.lex_state = 2},
  [1511] = {.lex_state = 2},
  [1512] = {.lex_state = 2},
  [1513] = {.lex_state = 185},
  [1514] = {.lex_state = 2},
  [1515] = {.lex_state = 2},
  [1516] = {.lex_state = 2},
  [1517] = {.lex_state = 2},
  [1518] = {.lex_state = 2},
  [1519] = {.lex_state = 2},
  [1520] = {.lex_state = 2},
  [1521] = {.lex_state = 2},
  [1522] = {.lex_state = 2},
  [1523] = {.lex_state = 2},
  [1524] = {.lex_state = 2},
  [1525] = {.lex_state = 185},
  [1526] = {.lex_state = 2},
  [1527] = {.lex_state = 2},
  [1528] = {.lex_state = 2},
  [1529] = {.lex_state = 2},
  [1530] = {.lex_state = 2},
  [1531] = {.lex_state = 2},
  [1532] = {.lex_state = 2},
  [1533] = {.lex_state = 2},
  [1534] = {.lex_state = 2},
  [1535] = {.lex_state = 2},
  [1536] = {.lex_state = 2},
  [1537] = {.lex_state = 2},
  [1538] = {.lex_state = 2},
  [1539] = {.lex_state = 2},
  [1540] = {.lex_state = 2},
  [1541] = {.lex_state = 2},
  [1542] = {.lex_state = 2},
  [1543] = {.lex_state = 2},
  [1544] = {.lex_state = 2},
  [1545] = {.lex_state = 2},
  [1546] = {.lex_state = 2},
  [1547] = {.lex_state = 2},
  [1548] = {.lex_state = 2},
  [1549] = {.lex_state = 2},
  [1550] = {.lex_state = 185},
  [1551] = {.lex_state = 2},
  [1552] = {.lex_state = 2},
  [1553] = {.lex_state = 2},
  [1554] = {.lex_state = 2},
  [1555] = {.lex_state = 2},
  [1556] = {.lex_state = 2},
  [1557] = {.lex_state = 2},
  [1558] = {.lex_state = 2},
  [1559] = {.lex_state = 2},
  [1560] = {.lex_state = 2},
  [1561] = {.lex_state = 2},
  [1562] = {.lex_state = 2},
  [1563] = {.lex_state = 2},
  [1564] = {.lex_state = 2},
  [1565] = {.lex_state = 2},
  [1566] = {.lex_state = 2},
  [1567] = {.lex_state = 2},
  [1568] = {.lex_state = 185},
  [1569] = {.lex_state = 2},
  [1570] = {.lex_state = 2},
  [1571] = {.lex_state = 2},
  [1572] = {.lex_state = 2},
  [1573] = {.lex_state = 2},
  [1574] = {.lex_state = 2},
  [1575] = {.lex_state = 2},
  [1576] = {.lex_state = 2},
  [1577] = {.lex_state = 2},
  [1578] = {.lex_state = 2},
  [1579] = {.lex_state = 2},
  [1580] = {.lex_state = 2},
  [1581] = {.lex_state = 2},
  [1582] = {.lex_state = 2},
  [1583] = {.lex_state = 2},
  [1584] = {.lex_state = 2},
  [1585] = {.lex_state = 2},
  [1586] = {.lex_state = 2},
  [1587] = {.lex_state = 2},
  [1588] = {.lex_state = 2},
  [1589] = {.lex_state = 2},
  [1590] = {.lex_state = 2},
  [1591] = {.lex_state = 2},
  [1592] = {.lex_state = 2},
  [1593] = {.lex_state = 2},
  [1594] = {.lex_state = 2},
  [1595] = {.lex_state = 2},
  [1596] = {.lex_state = 2},
  [1597] = {.lex_state = 185},
  [1598] = {.lex_state = 2},
  [1599] = {.lex_state = 2},
  [1600] = {.lex_state = 2},
  [1601] = {.lex_state = 2},
  [1602] = {.lex_state = 2},
  [1603] = {.lex_state = 2},
  [1604] = {.lex_state = 185},
  [1605] = {.lex_state = 2},
  [1606] = {.lex_state = 2},
  [1607] = {.lex_state = 2},
  [1608] = {.lex_state = 2},
  [1609] = {.lex_state = 2},
  [1610] = {.lex_state = 2},
  [1611] = {.lex_state = 2},
  [1612] = {.lex_state = 185},
  [1613] = {.lex_state = 2},
  [1614] = {.lex_state = 2},
  [1615] = {.lex_state = 185},
  [1616] = {.lex_state = 2},
  [1617] = {.lex_state = 2},
  [1618] = {.lex_state = 2},
  [1619] = {.lex_state = 2},
  [1620] = {.lex_state = 2},
  [1621] = {.lex_state = 2},
  [1622] = {.lex_state = 2},
  [1623] = {.lex_state = 2},
  [1624] = {.lex_state = 2},
  [1625] = {.lex_state = 2},
  [1626] = {.lex_state = 2},
  [1627] = {.lex_state = 2},
  [1628] = {.lex_state = 2},
  [1629] = {.lex_state = 2},
  [1630] = {.lex_state = 2},
  [1631] = {.lex_state = 2},
  [1632] = {.lex_state = 2},
  [1633] = {.lex_state = 2},
  [1634] = {.lex_state = 18},
  [1635] = {.lex_state = 2},
  [1636] = {.lex_state = 2},
  [1637] = {.lex_state = 2},
  [1638] = {.lex_state = 2},
  [1639] = {.lex_state = 185},
  [1640] = {.lex_state = 2},
  [1641] = {.lex_state = 2},
  [1642] = {.lex_state = 2},
  [1643] = {.lex_state = 2},
  [1644] = {.lex_state = 2},
  [1645] = {.lex_state = 2},
  [1646] = {.lex_state = 2},
  [1647] = {.lex_state = 2},
  [1648] = {.lex_state = 2},
  [1649] = {.lex_state = 2},
  [1650] = {.lex_state = 2},
  [1651] = {.lex_state = 2},
  [1652] = {.lex_state = 2},
  [1653] = {.lex_state = 2},
  [1654] = {.lex_state = 2},
  [1655] = {.lex_state = 2},
  [1656] = {.lex_state = 2},
  [1657] = {.lex_state = 2},
  [1658] = {.lex_state = 2},
  [1659] = {.lex_state = 2},
  [1660] = {.lex_state = 2},
  [1661] = {.lex_state = 2},
  [1662] = {.lex_state = 2},
  [1663] = {.lex_state = 2},
  [1664] = {.lex_state = 2},
  [1665] = {.lex_state = 2},
  [1666] = {.lex_state = 2},
  [1667] = {.lex_state = 2},
  [1668] = {.lex_state = 2},
  [1669] = {.lex_state = 2},
  [1670] = {.lex_state = 2},
  [1671] = {.lex_state = 2},
  [1672] = {.lex_state = 185},
  [1673] = {.lex_state = 2},
  [1674] = {.lex_state = 185},
  [1675] = {.lex_state = 2},
  [1676] = {.lex_state = 2},
  [1677] = {.lex_state = 2},
  [1678] = {.lex_state = 2},
  [1679] = {.lex_state = 2},
  [1680] = {.lex_state = 2},
  [1681] = {.lex_state = 2},
  [1682] = {.lex_state = 2},
  [1683] = {.lex_state = 2},
  [1684] = {.lex_state = 2},
  [1685] = {.lex_state = 2},
  [1686] = {.lex_state = 2},
  [1687] = {.lex_state = 2},
  [1688] = {.lex_state = 2},
  [1689] = {.lex_state = 2},
  [1690] = {.lex_state = 2},
  [1691] = {.lex_state = 2},
  [1692] = {.lex_state = 2},
  [1693] = {.lex_state = 185},
  [1694] = {.lex_state = 2},
  [1695] = {.lex_state = 2},
  [1696] = {.lex_state = 2},
  [1697] = {.lex_state = 2},
  [1698] = {.lex_state = 2},
  [1699] = {.lex_state = 2},
  [1700] = {.lex_state = 2},
  [1701] = {.lex_state = 185},
  [1702] = {.lex_state = 2},
  [1703] = {.lex_state = 2},
  [1704] = {.lex_state = 2},
  [1705] = {.lex_state = 2},
  [1706] = {.lex_state = 2},
  [1707] = {.lex_state = 2},
  [1708] = {.lex_state = 2},
  [1709] = {.lex_state = 2},
  [1710] = {.lex_state = 2},
  [1711] = {.lex_state = 2},
  [1712] = {.lex_state = 2},
  [1713] = {.lex_state = 2},
  [1714] = {.lex_state = 2},
  [1715] = {.lex_state = 2},
  [1716] = {.lex_state = 2},
  [1717] = {.lex_state = 2},
  [1718] = {.lex_state = 2},
  [1719] = {.lex_state = 2},
  [1720] = {.lex_state = 2},
  [1721] = {.lex_state = 2},
  [1722] = {.lex_state = 2},
  [1723] = {.lex_state = 185},
  [1724] = {.lex_state = 2},
  [1725] = {.lex_state = 185},
  [1726] = {.lex_state = 2},
  [1727] = {.lex_state = 2},
  [1728] = {.lex_state = 2},
  [1729] = {.lex_state = 2},
  [1730] = {.lex_state = 2},
  [1731] = {.lex_state = 2},
  [1732] = {.lex_state = 2},
  [1733] = {.lex_state = 2},
  [1734] = {.lex_state = 2},
  [1735] = {.lex_state = 2},
  [1736] = {.lex_state = 2},
  [1737] = {.lex_state = 2},
  [1738] = {.lex_state = 2},
  [1739] = {.lex_state = 2},
  [1740] = {.lex_state = 2},
  [1741] = {.lex_state = 2},
  [1742] = {.lex_state = 2},
  [1743] = {.lex_state = 2},
  [1744] = {.lex_state = 2},
  [1745] = {.lex_state = 185},
  [1746] = {.lex_state = 2},
  [1747] = {.lex_state = 2},
  [1748] = {.lex_state = 2},
  [1749] = {.lex_state = 2},
  [1750] = {.lex_state = 2},
  [1751] = {.lex_state = 2},
  [1752] = {.lex_state = 2},
  [1753] = {.lex_state = 2},
  [1754] = {.lex_state = 2},
  [1755] = {.lex_state = 2},
  [1756] = {.lex_state = 2},
  [1757] = {.lex_state = 2},
  [1758] = {.lex_state = 2},
  [1759] = {.lex_state = 2},
  [1760] = {.lex_state = 2},
  [1761] = {.lex_state = 2},
  [1762] = {.lex_state = 2},
  [1763] = {.lex_state = 2},
  [1764] = {.lex_state = 2},
  [1765] = {.lex_state = 2},
  [1766] = {.lex_state = 2},
  [1767] = {.lex_state = 2},
  [1768] = {.lex_state = 2},
  [1769] = {.lex_state = 2},
  [1770] = {.lex_state = 2},
  [1771] = {.lex_state = 2},
  [1772] = {.lex_state = 2},
  [1773] = {.lex_state = 2},
  [1774] = {.lex_state = 2},
  [1775] = {.lex_state = 2},
  [1776] = {.lex_state = 2},
  [1777] = {.lex_state = 2},
  [1778] = {.lex_state = 2},
  [1779] = {.lex_state = 2},
  [1780] = {.lex_state = 2},
  [1781] = {.lex_state = 2},
  [1782] = {.lex_state = 2},
  [1783] = {.lex_state = 2},
  [1784] = {.lex_state = 2},
  [1785] = {.lex_state = 2},
  [1786] = {.lex_state = 2},
  [1787] = {.lex_state = 185},
  [1788] = {.lex_state = 2},
  [1789] = {.lex_state = 2},
  [1790] = {.lex_state = 2},
  [1791] = {.lex_state = 2},
  [1792] = {.lex_state = 185},
  [1793] = {.lex_state = 2},
  [1794] = {.lex_state = 2},
  [1795] = {.lex_state = 2},
  [1796] = {.lex_state = 2},
  [1797] = {.lex_state = 2},
  [1798] = {.lex_state = 2},
  [1799] = {.lex_state = 2},
  [1800] = {.lex_state = 2},
  [1801] = {.lex_state = 2},
  [1802] = {.lex_state = 2},
  [1803] = {.lex_state = 2},
  [1804] = {.lex_state = 2},
  [1805] = {.lex_state = 2},
  [1806] = {.lex_state = 2},
  [1807] = {.lex_state = 2},
  [1808] = {.lex_state = 2},
  [1809] = {.lex_state = 2},
  [1810] = {.lex_state = 2},
  [1811] = {.lex_state = 2},
  [1812] = {.lex_state = 2},
  [1813] = {.lex_state = 2},
  [1814] = {.lex_state = 2},
  [1815] = {.lex_state = 2},
  [1816] = {.lex_state = 2},
  [1817] = {.lex_state = 2},
  [1818] = {.lex_state = 2},
  [1819] = {.lex_state = 2},
  [1820] = {.lex_state = 2},
  [1821] = {.lex_state = 2},
  [1822] = {.lex_state = 2},
  [1823] = {.lex_state = 2},
  [1824] = {.lex_state = 2},
  [1825] = {.lex_state = 185},
  [1826] = {.lex_state = 2},
  [1827] = {.lex_state = 2},
  [1828] = {.lex_state = 2},
  [1829] = {.lex_state = 2},
  [1830] = {.lex_state = 2},
  [1831] = {.lex_state = 2},
  [1832] = {.lex_state = 2},
  [1833] = {.lex_state = 2},
  [1834] = {.lex_state = 2},
  [1835] = {.lex_state = 2},
  [1836] = {.lex_state = 2},
  [1837] = {.lex_state = 2},
  [1838] = {.lex_state = 2},
  [1839] = {.lex_state = 2},
  [1840] = {.lex_state = 2},
  [1841] = {.lex_state = 2},
  [1842] = {.lex_state = 2},
  [1843] = {.lex_state = 2},
  [1844] = {.lex_state = 2},
  [1845] = {.lex_state = 2},
  [1846] = {.lex_state = 2},
  [1847] = {.lex_state = 2},
  [1848] = {.lex_state = 2},
  [1849] = {.lex_state = 2},
  [1850] = {.lex_state = 2},
  [1851] = {.lex_state = 2},
  [1852] = {.lex_state = 2},
  [1853] = {.lex_state = 2},
  [1854] = {.lex_state = 2},
  [1855] = {.lex_state = 2},
  [1856] = {.lex_state = 2},
  [1857] = {.lex_state = 2},
  [1858] = {.lex_state = 2},
  [1859] = {.lex_state = 185},
  [1860] = {.lex_state = 2},
  [1861] = {.lex_state = 2},
  [1862] = {.lex_state = 2},
  [1863] = {.lex_state = 2},
  [1864] = {.lex_state = 2},
  [1865] = {.lex_state = 2},
  [1866] = {.lex_state = 2},
  [1867] = {.lex_state = 2},
  [1868] = {.lex_state = 2},
  [1869] = {.lex_state = 2},
  [1870] = {.lex_state = 2},
  [1871] = {.lex_state = 2},
  [1872] = {.lex_state = 2},
  [1873] = {.lex_state = 2},
  [1874] = {.lex_state = 2},
  [1875] = {.lex_state = 2},
  [1876] = {.lex_state = 2},
  [1877] = {.lex_state = 2},
  [1878] = {.lex_state = 2},
  [1879] = {.lex_state = 2},
  [1880] = {.lex_state = 2},
  [1881] = {.lex_state = 2},
  [1882] = {.lex_state = 2},
  [1883] = {.lex_state = 2},
  [1884] = {.lex_state = 2},
  [1885] = {.lex_state = 185},
  [1886] = {.lex_state = 2},
  [1887] = {.lex_state = 2},
  [1888] = {.lex_state = 2},
  [1889] = {.lex_state = 2},
  [1890] = {.lex_state = 2},
  [1891] = {.lex_state = 2},
  [1892] = {.lex_state = 2},
  [1893] = {.lex_state = 2},
  [1894] = {.lex_state = 2},
  [1895] = {.lex_state = 2},
  [1896] = {.lex_state = 2},
  [1897] = {.lex_state = 2},
  [1898] = {.lex_state = 2},
  [1899] = {.lex_state = 2},
  [1900] = {.lex_state = 185},
  [1901] = {.lex_state = 2},
  [1902] = {.lex_state = 2},
  [1903] = {.lex_state = 2},
  [1904] = {.lex_state = 185},
  [1905] = {.lex_state = 185},
  [1906] = {.lex_state = 2},
  [1907] = {.lex_state = 2},
  [1908] = {.lex_state = 2},
  [1909] = {.lex_state = 2},
  [1910] = {.lex_state = 2},
  [1911] = {.lex_state = 2},
  [1912] = {.lex_state = 2},
  [1913] = {.lex_state = 2},
  [1914] = {.lex_state = 2},
  [1915] = {.lex_state = 2},
  [1916] = {.lex_state = 2},
  [1917] = {.lex_state = 2},
  [1918] = {.lex_state = 2},
  [1919] = {.lex_state = 2},
  [1920] = {.lex_state = 2},
  [1921] = {.lex_state = 2},
  [1922] = {.lex_state = 2},
  [1923] = {.lex_state = 2},
  [1924] = {.lex_state = 2},
  [1925] = {.lex_state = 2},
  [1926] = {.lex_state = 2},
  [1927] = {.lex_state = 2},
  [1928] = {.lex_state = 2},
  [1929] = {.lex_state = 2},
  [1930] = {.lex_state = 2},
  [1931] = {.lex_state = 2},
  [1932] = {.lex_state = 2},
  [1933] = {.lex_state = 2},
  [1934] = {.lex_state = 2},
  [1935] = {.lex_state = 2},
  [1936] = {.lex_state = 2},
  [1937] = {.lex_state = 2},
  [1938] = {.lex_state = 2},
  [1939] = {.lex_state = 2},
  [1940] = {.lex_state = 2},
  [1941] = {.lex_state = 2},
  [1942] = {.lex_state = 2},
  [1943] = {.lex_state = 2},
  [1944] = {.lex_state = 2},
  [1945] = {.lex_state = 2},
  [1946] = {.lex_state = 2},
  [1947] = {.lex_state = 2},
  [1948] = {.lex_state = 2},
  [1949] = {.lex_state = 2},
  [1950] = {.lex_state = 2},
  [1951] = {.lex_state = 2},
  [1952] = {.lex_state = 2},
  [1953] = {.lex_state = 2},
  [1954] = {.lex_state = 2},
  [1955] = {.lex_state = 2},
  [1956] = {.lex_state = 2},
  [1957] = {.lex_state = 2},
  [1958] = {.lex_state = 2},
  [1959] = {.lex_state = 2},
  [1960] = {.lex_state = 2},
  [1961] = {.lex_state = 2},
  [1962] = {.lex_state = 2},
  [1963] = {.lex_state = 2},
  [1964] = {.lex_state = 2},
  [1965] = {.lex_state = 2},
  [1966] = {.lex_state = 2},
  [1967] = {.lex_state = 2},
  [1968] = {.lex_state = 2},
  [1969] = {.lex_state = 2},
  [1970] = {.lex_state = 2},
  [1971] = {.lex_state = 2},
  [1972] = {.lex_state = 2},
  [1973] = {.lex_state = 2},
  [1974] = {.lex_state = 2},
  [1975] = {.lex_state = 2},
  [1976] = {.lex_state = 2},
  [1977] = {.lex_state = 2},
  [1978] = {.lex_state = 2},
  [1979] = {.lex_state = 2},
  [1980] = {.lex_state = 2},
  [1981] = {.lex_state = 2},
  [1982] = {.lex_state = 2},
  [1983] = {.lex_state = 2},
  [1984] = {.lex_state = 2},
  [1985] = {.lex_state = 2},
  [1986] = {.lex_state = 2},
  [1987] = {.lex_state = 185},
  [1988] = {.lex_state = 2},
  [1989] = {.lex_state = 2},
  [1990] = {.lex_state = 2},
  [1991] = {.lex_state = 2},
  [1992] = {.lex_state = 2},
  [1993] = {.lex_state = 2},
  [1994] = {.lex_state = 185},
  [1995] = {.lex_state = 2},
  [1996] = {.lex_state = 2},
  [1997] = {.lex_state = 2},
  [1998] = {.lex_state = 2},
  [1999] = {.lex_state = 2},
  [2000] = {.lex_state = 2},
  [2001] = {.lex_state = 2},
  [2002] = {.lex_state = 185},
  [2003] = {.lex_state = 185},
  [2004] = {.lex_state = 2},
  [2005] = {.lex_state = 2},
  [2006] = {.lex_state = 2},
  [2007] = {.lex_state = 2},
  [2008] = {.lex_state = 2},
  [2009] = {.lex_state = 2},
  [2010] = {.lex_state = 185},
  [2011] = {.lex_state = 2},
  [2012] = {.lex_state = 2},
  [2013] = {.lex_state = 2},
  [2014] = {.lex_state = 185},
  [2015] = {.lex_state = 2},
  [2016] = {.lex_state = 2},
  [2017] = {.lex_state = 2},
  [2018] = {.lex_state = 2},
  [2019] = {.lex_state = 2},
  [2020] = {.lex_state = 2},
  [2021] = {.lex_state = 2},
  [2022] = {.lex_state = 2},
  [2023] = {.lex_state = 2},
  [2024] = {.lex_state = 2},
  [2025] = {.lex_state = 2},
  [2026] = {.lex_state = 2},
  [2027] = {.lex_state = 2},
  [2028] = {.lex_state = 2},
  [2029] = {.lex_state = 2},
  [2030] = {.lex_state = 2},
  [2031] = {.lex_state = 2},
  [2032] = {.lex_state = 2},
  [2033] = {.lex_state = 2},
  [2034] = {.lex_state = 2},
  [2035] = {.lex_state = 2},
  [2036] = {.lex_state = 2},
  [2037] = {.lex_state = 2},
  [2038] = {.lex_state = 2},
  [2039] = {.lex_state = 2},
  [2040] = {.lex_state = 2},
  [2041] = {.lex_state = 2},
  [2042] = {.lex_state = 185},
  [2043] = {.lex_state = 2},
  [2044] = {.lex_state = 2},
  [2045] = {.lex_state = 2},
  [2046] = {.lex_state = 2},
  [2047] = {.lex_state = 2},
  [2048] = {.lex_state = 2},
  [2049] = {.lex_state = 2},
  [2050] = {.lex_state = 2},
  [2051] = {.lex_state = 2},
  [2052] = {.lex_state = 2},
  [2053] = {.lex_state = 2},
  [2054] = {.lex_state = 2},
  [2055] = {.lex_state = 2},
  [2056] = {.lex_state = 2},
  [2057] = {.lex_state = 2},
  [2058] = {.lex_state = 2},
  [2059] = {.lex_state = 2},
  [2060] = {.lex_state = 2},
  [2061] = {.lex_state = 2},
  [2062] = {.lex_state = 2},
  [2063] = {.lex_state = 2},
  [2064] = {.lex_state = 2},
  [2065] = {.lex_state = 2},
  [2066] = {.lex_state = 2},
  [2067] = {.lex_state = 2},
  [2068] = {.lex_state = 2},
  [2069] = {.lex_state = 2},
  [2070] = {.lex_state = 2},
  [2071] = {.lex_state = 2},
  [2072] = {.lex_state = 2},
  [2073] = {.lex_state = 2},
  [2074] = {.lex_state = 2},
  [2075] = {.lex_state = 2},
  [2076] = {.lex_state = 185},
  [2077] = {.lex_state = 2},
  [2078] = {.lex_state = 2},
  [2079] = {.lex_state = 2},
  [2080] = {.lex_state = 2},
  [2081] = {.lex_state = 2},
  [2082] = {.lex_state = 2},
  [2083] = {.lex_state = 2},
  [2084] = {.lex_state = 2},
  [2085] = {.lex_state = 2},
  [2086] = {.lex_state = 2},
  [2087] = {.lex_state = 2},
  [2088] = {.lex_state = 2},
  [2089] = {.lex_state = 2},
  [2090] = {.lex_state = 2},
  [2091] = {.lex_state = 2},
  [2092] = {.lex_state = 2},
  [2093] = {.lex_state = 2},
  [2094] = {.lex_state = 2},
  [2095] = {.lex_state = 2},
  [2096] = {.lex_state = 2},
  [2097] = {.lex_state = 2},
  [2098] = {.lex_state = 2},
  [2099] = {.lex_state = 2},
  [2100] = {.lex_state = 2},
  [2101] = {.lex_state = 2},
  [2102] = {.lex_state = 2},
  [2103] = {.lex_state = 2},
  [2104] = {.lex_state = 2},
  [2105] = {.lex_state = 2},
  [2106] = {.lex_state = 2},
  [2107] = {.lex_state = 2},
  [2108] = {.lex_state = 2},
  [2109] = {.lex_state = 2},
  [2110] = {.lex_state = 2},
  [2111] = {.lex_state = 2},
  [2112] = {.lex_state = 2},
  [2113] = {.lex_state = 2},
  [2114] = {.lex_state = 2},
  [2115] = {.lex_state = 2},
  [2116] = {.lex_state = 185},
  [2117] = {.lex_state = 2},
  [2118] = {.lex_state = 2},
  [2119] = {.lex_state = 2},
  [2120] = {.lex_state = 2},
  [2121] = {.lex_state = 2},
  [2122] = {.lex_state = 2},
  [2123] = {.lex_state = 2},
  [2124] = {.lex_state = 2},
  [2125] = {.lex_state = 2},
  [2126] = {.lex_state = 2},
  [2127] = {.lex_state = 2},
  [2128] = {.lex_state = 2},
  [2129] = {.lex_state = 2},
  [2130] = {.lex_state = 2},
  [2131] = {.lex_state = 185},
  [2132] = {.lex_state = 2},
  [2133] = {.lex_state = 2},
  [2134] = {.lex_state = 2},
  [2135] = {.lex_state = 2},
  [2136] = {.lex_state = 2},
  [2137] = {.lex_state = 2},
  [2138] = {.lex_state = 2},
  [2139] = {.lex_state = 2},
  [2140] = {.lex_state = 2},
  [2141] = {.lex_state = 2},
  [2142] = {.lex_state = 2},
  [2143] = {.lex_state = 2},
  [2144] = {.lex_state = 2},
  [2145] = {.lex_state = 2},
  [2146] = {.lex_state = 2},
  [2147] = {.lex_state = 2},
  [2148] = {.lex_state = 2},
  [2149] = {.lex_state = 2},
  [2150] = {.lex_state = 2},
  [2151] = {.lex_state = 2},
  [2152] = {.lex_state = 2},
  [2153] = {.lex_state = 2},
  [2154] = {.lex_state = 2},
  [2155] = {.lex_state = 2},
  [2156] = {.lex_state = 2},
  [2157] = {.lex_state = 2},
  [2158] = {.lex_state = 2},
  [2159] = {.lex_state = 2},
  [2160] = {.lex_state = 2},
  [2161] = {.lex_state = 2},
  [2162] = {.lex_state = 2},
  [2163] = {.lex_state = 2},
  [2164] = {.lex_state = 2},
  [2165] = {.lex_state = 2},
  [2166] = {.lex_state = 185},
  [2167] = {.lex_state = 2},
  [2168] = {.lex_state = 2},
  [2169] = {.lex_state = 2},
  [2170] = {.lex_state = 2},
  [2171] = {.lex_state = 2},
  [2172] = {.lex_state = 2},
  [2173] = {.lex_state = 2},
  [2174] = {.lex_state = 2},
  [2175] = {.lex_state = 2},
  [2176] = {.lex_state = 2},
  [2177] = {.lex_state = 2},
  [2178] = {.lex_state = 2},
  [2179] = {.lex_state = 185},
  [2180] = {.lex_state = 2},
  [2181] = {.lex_state = 2},
  [2182] = {.lex_state = 2},
  [2183] = {.lex_state = 2},
  [2184] = {.lex_state = 2},
  [2185] = {.lex_state = 2},
  [2186] = {.lex_state = 2},
  [2187] = {.lex_state = 2},
  [2188] = {.lex_state = 2},
  [2189] = {.lex_state = 2},
  [2190] = {.lex_state = 2},
  [2191] = {.lex_state = 2},
  [2192] = {.lex_state = 2},
  [2193] = {.lex_state = 2},
  [2194] = {.lex_state = 2},
  [2195] = {.lex_state = 2},
  [2196] = {.lex_state = 2},
  [2197] = {.lex_state = 2},
  [2198] = {.lex_state = 2},
  [2199] = {.lex_state = 2},
  [2200] = {.lex_state = 2},
  [2201] = {.lex_state = 2},
  [2202] = {.lex_state = 2},
  [2203] = {.lex_state = 2},
  [2204] = {.lex_state = 2},
  [2205] = {.lex_state = 2},
  [2206] = {.lex_state = 2},
  [2207] = {.lex_state = 2},
  [2208] = {.lex_state = 2},
  [2209] = {.lex_state = 2},
  [2210] = {.lex_state = 2},
  [2211] = {.lex_state = 2},
  [2212] = {.lex_state = 2},
  [2213] = {.lex_state = 2},
  [2214] = {.lex_state = 2},
  [2215] = {.lex_state = 2},
  [2216] = {.lex_state = 2},
  [2217] = {.lex_state = 2},
  [2218] = {.lex_state = 2},
  [2219] = {.lex_state = 2},
  [2220] = {.lex_state = 2},
  [2221] = {.lex_state = 2},
  [2222] = {.lex_state = 2},
  [2223] = {.lex_state = 2},
  [2224] = {.lex_state = 2},
  [2225] = {.lex_state = 2},
  [2226] = {.lex_state = 2},
  [2227] = {.lex_state = 2},
  [2228] = {.lex_state = 2},
  [2229] = {.lex_state = 185},
  [2230] = {.lex_state = 2},
  [2231] = {.lex_state = 2},
  [2232] = {.lex_state = 2},
  [2233] = {.lex_state = 2},
  [2234] = {.lex_state = 2},
  [2235] = {.lex_state = 2},
  [2236] = {.lex_state = 2},
  [2237] = {.lex_state = 2},
  [2238] = {.lex_state = 2},
  [2239] = {.lex_state = 2},
  [2240] = {.lex_state = 2},
  [2241] = {.lex_state = 2},
  [2242] = {.lex_state = 2},
  [2243] = {.lex_state = 2},
  [2244] = {.lex_state = 185},
  [2245] = {.lex_state = 2},
  [2246] = {.lex_state = 2},
  [2247] = {.lex_state = 2},
  [2248] = {.lex_state = 2},
  [2249] = {.lex_state = 2},
  [2250] = {.lex_state = 2},
  [2251] = {.lex_state = 2},
  [2252] = {.lex_state = 2},
  [2253] = {.lex_state = 2},
  [2254] = {.lex_state = 2},
  [2255] = {.lex_state = 2},
  [2256] = {.lex_state = 2},
  [2257] = {.lex_state = 2},
  [2258] = {.lex_state = 2},
  [2259] = {.lex_state = 2},
  [2260] = {.lex_state = 2},
  [2261] = {.lex_state = 2},
  [2262] = {.lex_state = 2},
  [2263] = {.lex_state = 2},
  [2264] = {.lex_state = 185},
  [2265] = {.lex_state = 2},
  [2266] = {.lex_state = 2},
  [2267] = {.lex_state = 2},
  [2268] = {.lex_state = 2},
  [2269] = {.lex_state = 2},
  [2270] = {.lex_state = 2},
  [2271] = {.lex_state = 2},
  [2272] = {.lex_state = 2},
  [2273] = {.lex_state = 2},
  [2274] = {.lex_state = 2},
  [2275] = {.lex_state = 185},
  [2276] = {.lex_state = 2},
  [2277] = {.lex_state = 2},
  [2278] = {.lex_state = 2},
  [2279] = {.lex_state = 2},
  [2280] = {.lex_state = 2},
  [2281] = {.lex_state = 2},
  [2282] = {.lex_state = 2},
  [2283] = {.lex_state = 2},
  [2284] = {.lex_state = 2},
  [2285] = {.lex_state = 2},
  [2286] = {.lex_state = 2},
  [2287] = {.lex_state = 2},
  [2288] = {.lex_state = 2},
  [2289] = {.lex_state = 2},
  [2290] = {.lex_state = 2},
  [2291] = {.lex_state = 2},
  [2292] = {.lex_state = 2},
  [2293] = {.lex_state = 2},
  [2294] = {.lex_state = 2},
  [2295] = {.lex_state = 2},
  [2296] = {.lex_state = 185},
  [2297] = {.lex_state = 2},
  [2298] = {.lex_state = 2},
  [2299] = {.lex_state = 2},
  [2300] = {.lex_state = 2},
  [2301] = {.lex_state = 2},
  [2302] = {.lex_state = 2},
  [2303] = {.lex_state = 2},
  [2304] = {.lex_state = 2},
  [2305] = {.lex_state = 2},
  [2306] = {.lex_state = 2},
  [2307] = {.lex_state = 2},
  [2308] = {.lex_state = 2},
  [2309] = {.lex_state = 2},
  [2310] = {.lex_state = 2},
  [2311] = {.lex_state = 2},
  [2312] = {.lex_state = 2},
  [2313] = {.lex_state = 2},
  [2314] = {.lex_state = 2},
  [2315] = {.lex_state = 2},
  [2316] = {.lex_state = 2},
  [2317] = {.lex_state = 2},
  [2318] = {.lex_state = 2},
  [2319] = {.lex_state = 2},
  [2320] = {.lex_state = 2},
  [2321] = {.lex_state = 2},
  [2322] = {.lex_state = 2},
  [2323] = {.lex_state = 2},
  [2324] = {.lex_state = 2},
  [2325] = {.lex_state = 2},
  [2326] = {.lex_state = 2},
  [2327] = {.lex_state = 2},
  [2328] = {.lex_state = 2},
  [2329] = {.lex_state = 2},
  [2330] = {.lex_state = 2},
  [2331] = {.lex_state = 2},
  [2332] = {.lex_state = 2},
  [2333] = {.lex_state = 2},
  [2334] = {.lex_state = 2},
  [2335] = {.lex_state = 2},
  [2336] = {.lex_state = 2},
  [2337] = {.lex_state = 2},
  [2338] = {.lex_state = 2},
  [2339] = {.lex_state = 2},
  [2340] = {.lex_state = 2},
  [2341] = {.lex_state = 2},
  [2342] = {.lex_state = 2},
  [2343] = {.lex_state = 185},
  [2344] = {.lex_state = 2},
  [2345] = {.lex_state = 2},
  [2346] = {.lex_state = 2},
  [2347] = {.lex_state = 2},
  [2348] = {.lex_state = 2},
  [2349] = {.lex_state = 2},
  [2350] = {.lex_state = 2},
  [2351] = {.lex_state = 2},
  [2352] = {.lex_state = 2},
  [2353] = {.lex_state = 2},
  [2354] = {.lex_state = 2},
  [2355] = {.lex_state = 2},
  [2356] = {.lex_state = 2},
  [2357] = {.lex_state = 2},
  [2358] = {.lex_state = 2},
  [2359] = {.lex_state = 2},
  [2360] = {.lex_state = 2},
  [2361] = {.lex_state = 2},
  [2362] = {.lex_state = 2},
  [2363] = {.lex_state = 2},
  [2364] = {.lex_state = 2},
  [2365] = {.lex_state = 2},
  [2366] = {.lex_state = 2},
  [2367] = {.lex_state = 2},
  [2368] = {.lex_state = 2},
  [2369] = {.lex_state = 2},
  [2370] = {.lex_state = 2},
  [2371] = {.lex_state = 2},
  [2372] = {.lex_state = 2},
  [2373] = {.lex_state = 2},
  [2374] = {.lex_state = 2},
  [2375] = {.lex_state = 2},
  [2376] = {.lex_state = 2},
  [2377] = {.lex_state = 2},
  [2378] = {.lex_state = 2},
  [2379] = {.lex_state = 2},
  [2380] = {.lex_state = 2},
  [2381] = {.lex_state = 2},
  [2382] = {.lex_state = 2},
  [2383] = {.lex_state = 2},
  [2384] = {.lex_state = 2},
  [2385] = {.lex_state = 2},
  [2386] = {.lex_state = 2},
  [2387] = {.lex_state = 2},
  [2388] = {.lex_state = 2},
  [2389] = {.lex_state = 2},
  [2390] = {.lex_state = 2},
  [2391] = {.lex_state = 185},
  [2392] = {.lex_state = 2},
  [2393] = {.lex_state = 2},
  [2394] = {.lex_state = 2},
  [2395] = {.lex_state = 2},
  [2396] = {.lex_state = 2},
  [2397] = {.lex_state = 2},
  [2398] = {.lex_state = 2},
  [2399] = {.lex_state = 2},
  [2400] = {.lex_state = 2},
  [2401] = {.lex_state = 2},
  [2402] = {.lex_state = 2},
  [2403] = {.lex_state = 2},
  [2404] = {.lex_state = 2},
  [2405] = {.lex_state = 2},
  [2406] = {.lex_state = 2},
  [2407] = {.lex_state = 2},
  [2408] = {.lex_state = 2},
  [2409] = {.lex_state = 2},
  [2410] = {.lex_state = 2},
  [2411] = {.lex_state = 2},
  [2412] = {.lex_state = 2},
  [2413] = {.lex_state = 2},
  [2414] = {.lex_state = 2},
  [2415] = {.lex_state = 2},
  [2416] = {.lex_state = 2},
  [2417] = {.lex_state = 2},
  [2418] = {.lex_state = 2},
  [2419] = {.lex_state = 2},
  [2420] = {.lex_state = 2},
  [2421] = {.lex_state = 2},
  [2422] = {.lex_state = 2},
  [2423] = {.lex_state = 2},
  [2424] = {.lex_state = 2},
  [2425] = {.lex_state = 2},
  [2426] = {.lex_state = 2},
  [2427] = {.lex_state = 2},
  [2428] = {.lex_state = 2},
  [2429] = {.lex_state = 2},
  [2430] = {.lex_state = 2},
  [2431] = {.lex_state = 2},
  [2432] = {.lex_state = 2},
  [2433] = {.lex_state = 2},
  [2434] = {.lex_state = 2},
  [2435] = {.lex_state = 2},
  [2436] = {.lex_state = 2},
  [2437] = {.lex_state = 185},
  [2438] = {.lex_state = 2},
  [2439] = {.lex_state = 2},
  [2440] = {.lex_state = 2},
  [2441] = {.lex_state = 2},
  [2442] = {.lex_state = 2},
  [2443] = {.lex_state = 2},
  [2444] = {.lex_state = 2},
  [2445] = {.lex_state = 2},
  [2446] = {.lex_state = 2},
  [2447] = {.lex_state = 2},
  [2448] = {.lex_state = 2},
  [2449] = {.lex_state = 2},
  [2450] = {.lex_state = 2},
  [2451] = {.lex_state = 2},
  [2452] = {.lex_state = 2},
  [2453] = {.lex_state = 2},
  [2454] = {.lex_state = 2},
  [2455] = {.lex_state = 2},
  [2456] = {.lex_state = 2},
  [2457] = {.lex_state = 2},
  [2458] = {.lex_state = 2},
  [2459] = {.lex_state = 2},
  [2460] = {.lex_state = 2},
  [2461] = {.lex_state = 2},
  [2462] = {.lex_state = 2},
  [2463] = {.lex_state = 2},
  [2464] = {.lex_state = 2},
  [2465] = {.lex_state = 2},
  [2466] = {.lex_state = 2},
  [2467] = {.lex_state = 2},
  [2468] = {.lex_state = 2},
  [2469] = {.lex_state = 2},
  [2470] = {.lex_state = 2},
  [2471] = {.lex_state = 2},
  [2472] = {.lex_state = 2},
  [2473] = {.lex_state = 2},
  [2474] = {.lex_state = 2},
  [2475] = {.lex_state = 2},
  [2476] = {.lex_state = 2},
  [2477] = {.lex_state = 2},
  [2478] = {.lex_state = 2},
  [2479] = {.lex_state = 2},
  [2480] = {.lex_state = 2},
  [2481] = {.lex_state = 2},
  [2482] = {.lex_state = 2},
  [2483] = {.lex_state = 2},
  [2484] = {.lex_state = 2},
  [2485] = {.lex_state = 185},
  [2486] = {.lex_state = 2},
  [2487] = {.lex_state = 2},
  [2488] = {.lex_state = 2},
  [2489] = {.lex_state = 2},
  [2490] = {.lex_state = 2},
  [2491] = {.lex_state = 2},
  [2492] = {.lex_state = 2},
  [2493] = {.lex_state = 2},
  [2494] = {.lex_state = 2},
  [2495] = {.lex_state = 2},
  [2496] = {.lex_state = 2},
  [2497] = {.lex_state = 2},
  [2498] = {.lex_state = 2},
  [2499] = {.lex_state = 18},
  [2500] = {.lex_state = 2},
  [2501] = {.lex_state = 2},
  [2502] = {.lex_state = 2},
  [2503] = {.lex_state = 2},
  [2504] = {.lex_state = 2},
  [2505] = {.lex_state = 2},
  [2506] = {.lex_state = 2},
  [2507] = {.lex_state = 2},
  [2508] = {.lex_state = 2},
  [2509] = {.lex_state = 2},
  [2510] = {.lex_state = 2},
  [2511] = {.lex_state = 2},
  [2512] = {.lex_state = 2},
  [2513] = {.lex_state = 2},
  [2514] = {.lex_state = 2},
  [2515] = {.lex_state = 2},
  [2516] = {.lex_state = 2},
  [2517] = {.lex_state = 185},
  [2518] = {.lex_state = 2},
  [2519] = {.lex_state = 2},
  [2520] = {.lex_state = 2},
  [2521] = {.lex_state = 2},
  [2522] = {.lex_state = 2},
  [2523] = {.lex_state = 2},
  [2524] = {.lex_state = 2},
  [2525] = {.lex_state = 2},
  [2526] = {.lex_state = 2},
  [2527] = {.lex_state = 2},
  [2528] = {.lex_state = 2},
  [2529] = {.lex_state = 2},
  [2530] = {.lex_state = 2},
  [2531] = {.lex_state = 2},
  [2532] = {.lex_state = 2},
  [2533] = {.lex_state = 2},
  [2534] = {.lex_state = 2},
  [2535] = {.lex_state = 2},
  [2536] = {.lex_state = 2},
  [2537] = {.lex_state = 2},
  [2538] = {.lex_state = 2},
  [2539] = {.lex_state = 2},
  [2540] = {.lex_state = 2},
  [2541] = {.lex_state = 2},
  [2542] = {.lex_state = 2},
  [2543] = {.lex_state = 2},
  [2544] = {.lex_state = 2},
  [2545] = {.lex_state = 2},
  [2546] = {.lex_state = 2},
  [2547] = {.lex_state = 2},
  [2548] = {.lex_state = 2},
  [2549] = {.lex_state = 2},
  [2550] = {.lex_state = 2},
  [2551] = {.lex_state = 185},
  [2552] = {.lex_state = 2},
  [2553] = {.lex_state = 2},
  [2554] = {.lex_state = 2},
  [2555] = {.lex_state = 2},
  [2556] = {.lex_state = 2},
  [2557] = {.lex_state = 2},
  [2558] = {.lex_state = 2},
  [2559] = {.lex_state = 2},
  [2560] = {.lex_state = 185},
  [2561] = {.lex_state = 2},
  [2562] = {.lex_state = 2},
  [2563] = {.lex_state = 2},
  [2564] = {.lex_state = 2},
  [2565] = {.lex_state = 2},
  [2566] = {.lex_state = 2},
  [2567] = {.lex_state = 2},
  [2568] = {.lex_state = 2},
  [2569] = {.lex_state = 185},
  [2570] = {.lex_state = 2},
  [2571] = {.lex_state = 2},
  [2572] = {.lex_state = 2},
  [2573] = {.lex_state = 2},
  [2574] = {.lex_state = 2},
  [2575] = {.lex_state = 2},
  [2576] = {.lex_state = 2},
  [2577] = {.lex_state = 2},
  [2578] = {.lex_state = 2},
  [2579] = {.lex_state = 2},
  [2580] = {.lex_state = 2},
  [2581] = {.lex_state = 2},
  [2582] = {.lex_state = 2},
  [2583] = {.lex_state = 2},
  [2584] = {.lex_state = 2},
  [2585] = {.lex_state = 2},
  [2586] = {.lex_state = 2},
  [2587] = {.lex_state = 2},
  [2588] = {.lex_state = 2},
  [2589] = {.lex_state = 2},
  [2590] = {.lex_state = 2},
  [2591] = {.lex_state = 2},
  [2592] = {.lex_state = 2},
  [2593] = {.lex_state = 2},
  [2594] = {.lex_state = 2},
  [2595] = {.lex_state = 185},
  [2596] = {.lex_state = 2},
  [2597] = {.lex_state = 2},
  [2598] = {.lex_state = 2},
  [2599] = {.lex_state = 2},
  [2600] = {.lex_state = 2},
  [2601] = {.lex_state = 2},
  [2602] = {.lex_state = 2},
  [2603] = {.lex_state = 2},
  [2604] = {.lex_state = 2},
  [2605] = {.lex_state = 2},
  [2606] = {.lex_state = 2},
  [2607] = {.lex_state = 2},
  [2608] = {.lex_state = 2},
  [2609] = {.lex_state = 2},
  [2610] = {.lex_state = 2},
  [2611] = {.lex_state = 2},
  [2612] = {.lex_state = 2},
  [2613] = {.lex_state = 2},
  [2614] = {.lex_state = 2},
  [2615] = {.lex_state = 2},
  [2616] = {.lex_state = 2},
  [2617] = {.lex_state = 2},
  [2618] = {.lex_state = 2},
  [2619] = {.lex_state = 2},
  [2620] = {.lex_state = 2},
  [2621] = {.lex_state = 185},
  [2622] = {.lex_state = 2},
  [2623] = {.lex_state = 2},
  [2624] = {.lex_state = 2},
  [2625] = {.lex_state = 2},
  [2626] = {.lex_state = 2},
  [2627] = {.lex_state = 2},
  [2628] = {.lex_state = 2},
  [2629] = {.lex_state = 2},
  [2630] = {.lex_state = 2},
  [2631] = {.lex_state = 2},
  [2632] = {.lex_state = 2},
  [2633] = {.lex_state = 2},
  [2634] = {.lex_state = 2},
  [2635] = {.lex_state = 2},
  [2636] = {.lex_state = 2},
  [2637] = {.lex_state = 2},
  [2638] = {.lex_state = 2},
  [2639] = {.lex_state = 2},
  [2640] = {.lex_state = 2},
  [2641] = {.lex_state = 2},
  [2642] = {.lex_state = 2},
  [2643] = {.lex_state = 2},
  [2644] = {.lex_state = 2},
  [2645] = {.lex_state = 2},
  [2646] = {.lex_state = 2},
  [2647] = {.lex_state = 2},
  [2648] = {.lex_state = 2},
  [2649] = {.lex_state = 2},
  [2650] = {.lex_state = 2},
  [2651] = {.lex_state = 2},
  [2652] = {.lex_state = 2},
  [2653] = {.lex_state = 2},
  [2654] = {.lex_state = 2},
  [2655] = {.lex_state = 2},
  [2656] = {.lex_state = 2},
  [2657] = {.lex_state = 2},
  [2658] = {.lex_state = 2},
  [2659] = {.lex_state = 2},
  [2660] = {.lex_state = 185},
  [2661] = {.lex_state = 18},
  [2662] = {.lex_state = 18},
  [2663] = {.lex_state = 185},
  [2664] = {.lex_state = 185},
  [2665] = {.lex_state = 18},
  [2666] = {.lex_state = 18},
  [2667] = {.lex_state = 185},
  [2668] = {.lex_state = 18},
  [2669] = {.lex_state = 18},
  [2670] = {.lex_state = 18},
  [2671] = {.lex_state = 185},
  [2672] = {.lex_state = 185},
  [2673] = {.lex_state = 18},
  [2674] = {.lex_state = 185},
  [2675] = {.lex_state = 18},
  [2676] = {.lex_state = 185},
  [2677] = {.lex_state = 185},
  [2678] = {.lex_state = 18},
  [2679] = {.lex_state = 18},
  [2680] = {.lex_state = 185},
  [2681] = {.lex_state = 18},
  [2682] = {.lex_state = 18},
  [2683] = {.lex_state = 18},
  [2684] = {.lex_state = 185},
  [2685] = {.lex_state = 18},
  [2686] = {.lex_state = 18},
  [2687] = {.lex_state = 18},
  [2688] = {.lex_state = 18},
  [2689] = {.lex_state = 18},
  [2690] = {.lex_state = 18},
  [2691] = {.lex_state = 18},
  [2692] = {.lex_state = 185},
  [2693] = {.lex_state = 185},
  [2694] = {.lex_state = 18},
  [2695] = {.lex_state = 185},
  [2696] = {.lex_state = 185},
  [2697] = {.lex_state = 18},
  [2698] = {.lex_state = 18},
  [2699] = {.lex_state = 18},
  [2700] = {.lex_state = 18},
  [2701] = {.lex_state = 185},
  [2702] = {.lex_state = 18},
  [2703] = {.lex_state = 18},
  [2704] = {.lex_state = 18},
  [2705] = {.lex_state = 185},
  [2706] = {.lex_state = 18},
  [2707] = {.lex_state = 18},
  [2708] = {.lex_state = 18},
  [2709] = {.lex_state = 18},
  [2710] = {.lex_state = 185},
  [2711] = {.lex_state = 18},
  [2712] = {.lex_state = 18},
  [2713] = {.lex_state = 18},
  [2714] = {.lex_state = 185},
  [2715] = {.lex_state = 18},
  [2716] = {.lex_state = 185},
  [2717] = {.lex_state = 185},
  [2718] = {.lex_state = 18},
  [2719] = {.lex_state = 18},
  [2720] = {.lex_state = 18},
  [2721] = {.lex_state = 18},
  [2722] = {.lex_state = 185},
  [2723] = {.lex_state = 185},
  [2724] = {.lex_state = 185},
  [2725] = {.lex_state = 185},
  [2726] = {.lex_state = 18},
  [2727] = {.lex_state = 18},
  [2728] = {.lex_state = 185},
  [2729] = {.lex_state = 18},
  [2730] = {.lex_state = 185},
  [2731] = {.lex_state = 18},
  [2732] = {.lex_state = 18},
  [2733] = {.lex_state = 18},
  [2734] = {.lex_state = 18},
  [2735] = {.lex_state = 18},
  [2736] = {.lex_state = 18},
  [2737] = {.lex_state = 18},
  [2738] = {.lex_state = 185},
  [2739] = {.lex_state = 18},
  [2740] = {.lex_state = 18},
  [2741] = {.lex_state = 18},
  [2742] = {.lex_state = 18},
  [2743] = {.lex_state = 185},
  [2744] = {.lex_state = 185},
  [2745] = {.lex_state = 18},
  [2746] = {.lex_state = 18},
  [2747] = {.lex_state = 18},
  [2748] = {.lex_state = 18},
  [2749] = {.lex_state = 185},
  [2750] = {.lex_state = 185},
  [2751] = {.lex_state = 18},
  [2752] = {.lex_state = 18},
  [2753] = {.lex_state = 185},
  [2754] = {.lex_state = 185},
  [2755] = {.lex_state = 18},
  [2756] = {.lex_state = 18},
  [2757] = {.lex_state = 18},
  [2758] = {.lex_state = 18},
  [2759] = {.lex_state = 18},
  [2760] = {.lex_state = 18},
  [2761] = {.lex_state = 18},
  [2762] = {.lex_state = 18},
  [2763] = {.lex_state = 18},
  [2764] = {.lex_state = 18},
  [2765] = {.lex_state = 18},
  [2766] = {.lex_state = 18},
  [2767] = {.lex_state = 18},
  [2768] = {.lex_state = 18},
  [2769] = {.lex_state = 18},
  [2770] = {.lex_state = 18},
  [2771] = {.lex_state = 18},
  [2772] = {.lex_state = 185},
  [2773] = {.lex_state = 185},
  [2774] = {.lex_state = 18},
  [2775] = {.lex_state = 185},
  [2776] = {.lex_state = 18},
  [2777] = {.lex_state = 18},
  [2778] = {.lex_state = 18},
  [2779] = {.lex_state = 18},
  [2780] = {.lex_state = 185},
  [2781] = {.lex_state = 18},
  [2782] = {.lex_state = 185},
  [2783] = {.lex_state = 185},
  [2784] = {.lex_state = 185},
  [2785] = {.lex_state = 185},
  [2786] = {.lex_state = 185},
  [2787] = {.lex_state = 185},
  [2788] = {.lex_state = 18},
  [2789] = {.lex_state = 185},
  [2790] = {.lex_state = 185},
  [2791] = {.lex_state = 18},
  [2792] = {.lex_state = 185},
  [2793] = {.lex_state = 185},
  [2794] = {.lex_state = 185},
  [2795] = {.lex_state = 185},
  [2796] = {.lex_state = 18},
  [2797] = {.lex_state = 185},
  [2798] = {.lex_state = 185},
  [2799] = {.lex_state = 18},
  [2800] = {.lex_state = 185},
  [2801] = {.lex_state = 18},
  [2802] = {.lex_state = 18},
  [2803] = {.lex_state = 18},
  [2804] = {.lex_state = 185},
  [2805] = {.lex_state = 18},
  [2806] = {.lex_state = 18},
  [2807] = {.lex_state = 18},
  [2808] = {.lex_state = 18},
  [2809] = {.lex_state = 185},
  [2810] = {.lex_state = 18},
  [2811] = {.lex_state = 185},
  [2812] = {.lex_state = 185},
  [2813] = {.lex_state = 18},
  [2814] = {.lex_state = 185},
  [2815] = {.lex_state = 18},
  [2816] = {.lex_state = 18},
  [2817] = {.lex_state = 18},
  [2818] = {.lex_state = 18},
  [2819] = {.lex_state = 185},
  [2820] = {.lex_state = 18},
  [2821] = {.lex_state = 18},
  [2822] = {.lex_state = 18},
  [2823] = {.lex_state = 18},
  [2824] = {.lex_state = 18},
  [2825] = {.lex_state = 185},
  [2826] = {.lex_state = 18},
  [2827] = {.lex_state = 18},
  [2828] = {.lex_state = 18},
  [2829] = {.lex_state = 18},
  [2830] = {.lex_state = 18},
  [2831] = {.lex_state = 18},
  [2832] = {.lex_state = 126},
  [2833] = {.lex_state = 126},
  [2834] = {.lex_state = 125},
  [2835] = {.lex_state = 18},
  [2836] = {.lex_state = 126},
  [2837] = {.lex_state = 126},
  [2838] = {.lex_state = 126},
  [2839] = {.lex_state = 125},
  [2840] = {.lex_state = 125},
  [2841] = {.lex_state = 125},
  [2842] = {.lex_state = 126},
  [2843] = {.lex_state = 18},
  [2844] = {.lex_state = 125},
  [2845] = {.lex_state = 18},
  [2846] = {.lex_state = 126},
  [2847] = {.lex_state = 125},
  [2848] = {.lex_state = 126},
  [2849] = {.lex_state = 125},
  [2850] = {.lex_state = 18},
  [2851] = {.lex_state = 126},
  [2852] = {.lex_state = 125},
  [2853] = {.lex_state = 125},
  [2854] = {.lex_state = 125},
  [2855] = {.lex_state = 126},
  [2856] = {.lex_state = 125},
  [2857] = {.lex_state = 126},
  [2858] = {.lex_state = 18},
  [2859] = {.lex_state = 18},
  [2860] = {.lex_state = 125},
  [2861] = {.lex_state = 18},
  [2862] = {.lex_state = 18},
  [2863] = {.lex_state = 126},
  [2864] = {.lex_state = 126},
  [2865] = {.lex_state = 126},
  [2866] = {.lex_state = 125},
  [2867] = {.lex_state = 125},
  [2868] = {.lex_state = 125},
  [2869] = {.lex_state = 126},
  [2870] = {.lex_state = 125},
  [2871] = {.lex_state = 126},
  [2872] = {.lex_state = 126},
  [2873] = {.lex_state = 126},
  [2874] = {.lex_state = 125},
  [2875] = {.lex_state = 125},
  [2876] = {.lex_state = 125},
  [2877] = {.lex_state = 126},
  [2878] = {.lex_state = 126},
  [2879] = {.lex_state = 18},
  [2880] = {.lex_state = 125},
  [2881] = {.lex_state = 126},
  [2882] = {.lex_state = 125},
  [2883] = {.lex_state = 125},
  [2884] = {.lex_state = 125},
  [2885] = {.lex_state = 125},
  [2886] = {.lex_state = 126},
  [2887] = {.lex_state = 126},
  [2888] = {.lex_state = 18},
  [2889] = {.lex_state = 18},
  [2890] = {.lex_state = 126},
  [2891] = {.lex_state = 125},
  [2892] = {.lex_state = 18},
  [2893] = {.lex_state = 126},
  [2894] = {.lex_state = 126},
  [2895] = {.lex_state = 126},
  [2896] = {.lex_state = 125},
  [2897] = {.lex_state = 18},
  [2898] = {.lex_state = 126},
  [2899] = {.lex_state = 126},
  [2900] = {.lex_state = 125},
  [2901] = {.lex_state = 125},
  [2902] = {.lex_state = 18},
  [2903] = {.lex_state = 126},
  [2904] = {.lex_state = 125},
  [2905] = {.lex_state = 125},
  [2906] = {.lex_state = 126},
  [2907] = {.lex_state = 126},
  [2908] = {.lex_state = 126},
  [2909] = {.lex_state = 126},
  [2910] = {.lex_state = 18},
  [2911] = {.lex_state = 126},
  [2912] = {.lex_state = 18},
  [2913] = {.lex_state = 126},
  [2914] = {.lex_state = 125},
  [2915] = {.lex_state = 125},
  [2916] = {.lex_state = 126},
  [2917] = {.lex_state = 126},
  [2918] = {.lex_state = 126},
  [2919] = {.lex_state = 125},
  [2920] = {.lex_state = 18},
  [2921] = {.lex_state = 125},
  [2922] = {.lex_state = 126},
  [2923] = {.lex_state = 125},
  [2924] = {.lex_state = 125},
  [2925] = {.lex_state = 126},
  [2926] = {.lex_state = 125},
  [2927] = {.lex_state = 18},
  [2928] = {.lex_state = 126},
  [2929] = {.lex_state = 125},
  [2930] = {.lex_state = 18},
  [2931] = {.lex_state = 125},
  [2932] = {.lex_state = 125},
  [2933] = {.lex_state = 126},
  [2934] = {.lex_state = 126},
  [2935] = {.lex_state = 125},
  [2936] = {.lex_state = 18},
  [2937] = {.lex_state = 126},
  [2938] = {.lex_state = 126},
  [2939] = {.lex_state = 125},
  [2940] = {.lex_state = 18},
  [2941] = {.lex_state = 126},
  [2942] = {.lex_state = 126},
  [2943] = {.lex_state = 125},
  [2944] = {.lex_state = 125},
  [2945] = {.lex_state = 125},
  [2946] = {.lex_state = 126},
  [2947] = {.lex_state = 125},
  [2948] = {.lex_state = 126},
  [2949] = {.lex_state = 125},
  [2950] = {.lex_state = 18},
  [2951] = {.lex_state = 125},
  [2952] = {.lex_state = 126},
  [2953] = {.lex_state = 18},
  [2954] = {.lex_state = 126},
  [2955] = {.lex_state = 126},
  [2956] = {.lex_state = 125},
  [2957] = {.lex_state = 125},
  [2958] = {.lex_state = 126},
  [2959] = {.lex_state = 125},
  [2960] = {.lex_state = 125},
  [2961] = {.lex_state = 126},
  [2962] = {.lex_state = 125},
  [2963] = {.lex_state = 18},
  [2964] = {.lex_state = 125},
  [2965] = {.lex_state = 18},
  [2966] = {.lex_state = 125},
  [2967] = {.lex_state = 126},
  [2968] = {.lex_state = 126},
  [2969] = {.lex_state = 125},
  [2970] = {.lex_state = 114, .external_lex_state = 2},
  [2971] = {.lex_state = 18},
  [2972] = {.lex_state = 125},
  [2973] = {.lex_state = 18},
  [2974] = {.lex_state = 125},
  [2975] = {.lex_state = 125},
  [2976] = {.lex_state = 126},
  [2977] = {.lex_state = 18},
  [2978] = {.lex_state = 126},
  [2979] = {.lex_state = 126},
  [2980] = {.lex_state = 125},
  [2981] = {.lex_state = 18},
  [2982] = {.lex_state = 125},
  [2983] = {.lex_state = 18},
  [2984] = {.lex_state = 125},
  [2985] = {.lex_state = 125},
  [2986] = {.lex_state = 126},
  [2987] = {.lex_state = 18},
  [2988] = {.lex_state = 126},
  [2989] = {.lex_state = 126},
  [2990] = {.lex_state = 18},
  [2991] = {.lex_state = 126},
  [2992] = {.lex_state = 126},
  [2993] = {.lex_state = 18},
  [2994] = {.lex_state = 125},
  [2995] = {.lex_state = 18},
  [2996] = {.lex_state = 125},
  [2997] = {.lex_state = 125},
  [2998] = {.lex_state = 126},
  [2999] = {.lex_state = 125},
  [3000] = {.lex_state = 126},
  [3001] = {.lex_state = 125},
  [3002] = {.lex_state = 126},
  [3003] = {.lex_state = 18},
  [3004] = {.lex_state = 125},
  [3005] = {.lex_state = 126},
  [3006] = {.lex_state = 126},
  [3007] = {.lex_state = 125},
  [3008] = {.lex_state = 125},
  [3009] = {.lex_state = 125},
  [3010] = {.lex_state = 126},
  [3011] = {.lex_state = 18},
  [3012] = {.lex_state = 126},
  [3013] = {.lex_state = 125},
  [3014] = {.lex_state = 18},
  [3015] = {.lex_state = 125},
  [3016] = {.lex_state = 126},
  [3017] = {.lex_state = 125},
  [3018] = {.lex_state = 126},
  [3019] = {.lex_state = 18},
  [3020] = {.lex_state = 18},
  [3021] = {.lex_state = 125},
  [3022] = {.lex_state = 18},
  [3023] = {.lex_state = 125},
  [3024] = {.lex_state = 125},
  [3025] = {.lex_state = 126},
  [3026] = {.lex_state = 125},
  [3027] = {.lex_state = 126},
  [3028] = {.lex_state = 126},
  [3029] = {.lex_state = 125},
  [3030] = {.lex_state = 126},
  [3031] = {.lex_state = 125},
  [3032] = {.lex_state = 126},
  [3033] = {.lex_state = 125},
  [3034] = {.lex_state = 125},
  [3035] = {.lex_state = 126},
  [3036] = {.lex_state = 18},
  [3037] = {.lex_state = 126},
  [3038] = {.lex_state = 125},
  [3039] = {.lex_state = 126},
  [3040] = {.lex_state = 18},
  [3041] = {.lex_state = 126},
  [3042] = {.lex_state = 126},
  [3043] = {.lex_state = 125},
  [3044] = {.lex_state = 125},
  [3045] = {.lex_state = 126},
  [3046] = {.lex_state = 126},
  [3047] = {.lex_state = 125},
  [3048] = {.lex_state = 125},
  [3049] = {.lex_state = 18},
  [3050] = {.lex_state = 18},
  [3051] = {.lex_state = 125},
  [3052] = {.lex_state = 126},
  [3053] = {.lex_state = 18},
  [3054] = {.lex_state = 125},
  [3055] = {.lex_state = 126},
  [3056] = {.lex_state = 18},
  [3057] = {.lex_state = 126},
  [3058] = {.lex_state = 126},
  [3059] = {.lex_state = 125},
  [3060] = {.lex_state = 126},
  [3061] = {.lex_state = 125},
  [3062] = {.lex_state = 126},
  [3063] = {.lex_state = 125},
  [3064] = {.lex_state = 126},
  [3065] = {.lex_state = 125},
  [3066] = {.lex_state = 126},
  [3067] = {.lex_state = 18},
  [3068] = {.lex_state = 125},
  [3069] = {.lex_state = 126},
  [3070] = {.lex_state = 125},
  [3071] = {.lex_state = 126},
  [3072] = {.lex_state = 125},
  [3073] = {.lex_state = 126},
  [3074] = {.lex_state = 126},
  [3075] = {.lex_state = 125},
  [3076] = {.lex_state = 125},
  [3077] = {.lex_state = 125},
  [3078] = {.lex_state = 18},
  [3079] = {.lex_state = 126},
  [3080] = {.lex_state = 125},
  [3081] = {.lex_state = 126},
  [3082] = {.lex_state = 126},
  [3083] = {.lex_state = 18},
  [3084] = {.lex_state = 125},
  [3085] = {.lex_state = 126},
  [3086] = {.lex_state = 125},
  [3087] = {.lex_state = 126},
  [3088] = {.lex_state = 18},
  [3089] = {.lex_state = 18},
  [3090] = {.lex_state = 125},
  [3091] = {.lex_state = 126},
  [3092] = {.lex_state = 18},
  [3093] = {.lex_state = 18},
  [3094] = {.lex_state = 126},
  [3095] = {.lex_state = 126},
  [3096] = {.lex_state = 125},
  [3097] = {.lex_state = 125},
  [3098] = {.lex_state = 18},
  [3099] = {.lex_state = 18},
  [3100] = {.lex_state = 18},
  [3101] = {.lex_state = 18},
  [3102] = {.lex_state = 18},
  [3103] = {.lex_state = 18},
  [3104] = {.lex_state = 117},
  [3105] = {.lex_state = 18},
  [3106] = {.lex_state = 18},
  [3107] = {.lex_state = 18},
  [3108] = {.lex_state = 18},
  [3109] = {.lex_state = 18},
  [3110] = {.lex_state = 18},
  [3111] = {.lex_state = 18},
  [3112] = {.lex_state = 18},
  [3113] = {.lex_state = 18},
  [3114] = {.lex_state = 18},
  [3115] = {.lex_state = 18},
  [3116] = {.lex_state = 18},
  [3117] = {.lex_state = 18},
  [3118] = {.lex_state = 18},
  [3119] = {.lex_state = 18},
  [3120] = {.lex_state = 18},
  [3121] = {.lex_state = 182},
  [3122] = {.lex_state = 115, .external_lex_state = 2},
  [3123] = {.lex_state = 115, .external_lex_state = 2},
  [3124] = {.lex_state = 117},
  [3125] = {.lex_state = 117},
  [3126] = {.lex_state = 115, .external_lex_state = 2},
  [3127] = {.lex_state = 115, .external_lex_state = 2},
  [3128] = {.lex_state = 115, .external_lex_state = 2},
  [3129] = {.lex_state = 117},
  [3130] = {.lex_state = 183},
  [3131] = {.lex_state = 115},
  [3132] = {.lex_state = 183},
  [3133] = {.lex_state = 182},
  [3134] = {.lex_state = 183},
  [3135] = {.lex_state = 183},
  [3136] = {.lex_state = 182},
  [3137] = {.lex_state = 115},
  [3138] = {.lex_state = 182},
  [3139] = {.lex_state = 115},
  [3140] = {.lex_state = 115},
  [3141] = {.lex_state = 115},
  [3142] = {.lex_state = 115},
  [3143] = {.lex_state = 115},
  [3144] = {.lex_state = 182},
  [3145] = {.lex_state = 115},
  [3146] = {.lex_state = 115},
  [3147] = {.lex_state = 115},
  [3148] = {.lex_state = 182},
  [3149] = {.lex_state = 115},
  [3150] = {.lex_state = 115},
  [3151] = {.lex_state = 182},
  [3152] = {.lex_state = 115},
  [3153] = {.lex_state = 115},
  [3154] = {.lex_state = 115},
  [3155] = {.lex_state = 115},
  [3156] = {.lex_state = 182},
  [3157] = {.lex_state = 115},
  [3158] = {.lex_state = 182},
  [3159] = {.lex_state = 115},
  [3160] = {.lex_state = 115},
  [3161] = {.lex_state = 115},
  [3162] = {.lex_state = 182},
  [3163] = {.lex_state = 182},
  [3164] = {.lex_state = 183},
  [3165] = {.lex_state = 182},
  [3166] = {.lex_state = 115},
  [3167] = {.lex_state = 115},
  [3168] = {.lex_state = 182},
  [3169] = {.lex_state = 115},
  [3170] = {.lex_state = 115},
  [3171] = {.lex_state = 115},
  [3172] = {.lex_state = 183},
  [3173] = {.lex_state = 115},
  [3174] = {.lex_state = 182},
  [3175] = {.lex_state = 115},
  [3176] = {.lex_state = 183},
  [3177] = {.lex_state = 115},
  [3178] = {.lex_state = 182},
  [3179] = {.lex_state = 115},
  [3180] = {.lex_state = 115},
  [3181] = {.lex_state = 115},
  [3182] = {.lex_state = 115},
  [3183] = {.lex_state = 115},
  [3184] = {.lex_state = 115},
  [3185] = {.lex_state = 115},
  [3186] = {.lex_state = 115},
  [3187] = {.lex_state = 115},
  [3188] = {.lex_state = 115},
  [3189] = {.lex_state = 115},
  [3190] = {.lex_state = 183},
  [3191] = {.lex_state = 115},
  [3192] = {.lex_state = 115},
  [3193] = {.lex_state = 182},
  [3194] = {.lex_state = 115},
  [3195] = {.lex_state = 183},
  [3196] = {.lex_state = 115},
  [3197] = {.lex_state = 182},
  [3198] = {.lex_state = 115},
  [3199] = {.lex_state = 183},
  [3200] = {.lex_state = 183},
  [3201] = {.lex_state = 182},
  [3202] = {.lex_state = 182},
  [3203] = {.lex_state = 183},
  [3204] = {.lex_state = 115},
  [3205] = {.lex_state = 183},
  [3206] = {.lex_state = 115},
  [3207] = {.lex_state = 115},
  [3208] = {.lex_state = 115},
  [3209] = {.lex_state = 115},
  [3210] = {.lex_state = 182},
  [3211] = {.lex_state = 182},
  [3212] = {.lex_state = 115},
  [3213] = {.lex_state = 183},
  [3214] = {.lex_state = 182},
  [3215] = {.lex_state = 115},
  [3216] = {.lex_state = 182},
  [3217] = {.lex_state = 115},
  [3218] = {.lex_state = 182},
  [3219] = {.lex_state = 115},
  [3220] = {.lex_state = 115},
  [3221] = {.lex_state = 182},
  [3222] = {.lex_state = 183},
  [3223] = {.lex_state = 115},
  [3224] = {.lex_state = 115},
  [3225] = {.lex_state = 115},
  [3226] = {.lex_state = 183},
  [3227] = {.lex_state = 183},
  [3228] = {.lex_state = 115},
  [3229] = {.lex_state = 183},
  [3230] = {.lex_state = 115},
  [3231] = {.lex_state = 115},
  [3232] = {.lex_state = 115},
  [3233] = {.lex_state = 183},
  [3234] = {.lex_state = 115},
  [3235] = {.lex_state = 115},
  [3236] = {.lex_state = 115},
  [3237] = {.lex_state = 115},
  [3238] = {.lex_state = 115},
  [3239] = {.lex_state = 115},
  [3240] = {.lex_state = 115},
  [3241] = {.lex_state = 115},
  [3242] = {.lex_state = 115},
  [3243] = {.lex_state = 182},
  [3244] = {.lex_state = 115},
  [3245] = {.lex_state = 115},
  [3246] = {.lex_state = 182},
  [3247] = {.lex_state = 183},
  [3248] = {.lex_state = 115},
  [3249] = {.lex_state = 115},
  [3250] = {.lex_state = 115},
  [3251] = {.lex_state = 115},
  [3252] = {.lex_state = 115},
  [3253] = {.lex_state = 115},
  [3254] = {.lex_state = 115},
  [3255] = {.lex_state = 115},
  [3256] = {.lex_state = 115},
  [3257] = {.lex_state = 115},
  [3258] = {.lex_state = 115},
  [3259] = {.lex_state = 182},
  [3260] = {.lex_state = 115},
  [3261] = {.lex_state = 115},
  [3262] = {.lex_state = 182},
  [3263] = {.lex_state = 115},
  [3264] = {.lex_state = 115},
  [3265] = {.lex_state = 115},
  [3266] = {.lex_state = 182},
  [3267] = {.lex_state = 115},
  [3268] = {.lex_state = 115},
  [3269] = {.lex_state = 115},
  [3270] = {.lex_state = 115},
  [3271] = {.lex_state = 182},
  [3272] = {.lex_state = 115},
  [3273] = {.lex_state = 115},
  [3274] = {.lex_state = 182},
  [3275] = {.lex_state = 183},
  [3276] = {.lex_state = 182},
  [3277] = {.lex_state = 115},
  [3278] = {.lex_state = 182},
  [3279] = {.lex_state = 182},
  [3280] = {.lex_state = 115},
  [3281] = {.lex_state = 183},
  [3282] = {.lex_state = 115},
  [3283] = {.lex_state = 115},
  [3284] = {.lex_state = 115},
  [3285] = {.lex_state = 182},
  [3286] = {.lex_state = 115},
  [3287] = {.lex_state = 182},
  [3288] = {.lex_state = 182},
  [3289] = {.lex_state = 115},
  [3290] = {.lex_state = 115},
  [3291] = {.lex_state = 183},
  [3292] = {.lex_state = 115},
  [3293] = {.lex_state = 115},
  [3294] = {.lex_state = 115},
  [3295] = {.lex_state = 182},
  [3296] = {.lex_state = 115},
  [3297] = {.lex_state = 115},
  [3298] = {.lex_state = 115},
  [3299] = {.lex_state = 183},
  [3300] = {.lex_state = 182},
  [3301] = {.lex_state = 182},
  [3302] = {.lex_state = 183},
  [3303] = {.lex_state = 115},
  [3304] = {.lex_state = 115},
  [3305] = {.lex_state = 115},
  [3306] = {.lex_state = 182},
  [3307] = {.lex_state = 183},
  [3308] = {.lex_state = 183},
  [3309] = {.lex_state = 183},
  [3310] = {.lex_state = 115},
  [3311] = {.lex_state = 182},
  [3312] = {.lex_state = 115},
  [3313] = {.lex_state = 182},
  [3314] = {.lex_state = 115},
  [3315] = {.lex_state = 115},
  [3316] = {.lex_state = 182},
  [3317] = {.lex_state = 115},
  [3318] = {.lex_state = 115},
  [3319] = {.lex_state = 183},
  [3320] = {.lex_state = 115},
  [3321] = {.lex_state = 115},
  [3322] = {.lex_state = 115},
  [3323] = {.lex_state = 115},
  [3324] = {.lex_state = 115},
  [3325] = {.lex_state = 115},
  [3326] = {.lex_state = 182},
  [3327] = {.lex_state = 183},
  [3328] = {.lex_state = 115},
  [3329] = {.lex_state = 115},
  [3330] = {.lex_state = 115},
  [3331] = {.lex_state = 182},
  [3332] = {.lex_state = 115},
  [3333] = {.lex_state = 115},
  [3334] = {.lex_state = 115},
  [3335] = {.lex_state = 115},
  [3336] = {.lex_state = 115},
  [3337] = {.lex_state = 182},
  [3338] = {.lex_state = 115},
  [3339] = {.lex_state = 182},
  [3340] = {.lex_state = 115},
  [3341] = {.lex_state = 115},
  [3342] = {.lex_state = 115},
  [3343] = {.lex_state = 182},
  [3344] = {.lex_state = 182},
  [3345] = {.lex_state = 115},
  [3346] = {.lex_state = 115},
  [3347] = {.lex_state = 115},
  [3348] = {.lex_state = 18},
  [3349] = {.lex_state = 183},
  [3350] = {.lex_state = 18},
  [3351] = {.lex_state = 18},
  [3352] = {.lex_state = 18},
  [3353] = {.lex_state = 18},
  [3354] = {.lex_state = 183},
  [3355] = {.lex_state = 18},
  [3356] = {.lex_state = 183},
  [3357] = {.lex_state = 18},
  [3358] = {.lex_state = 18},
  [3359] = {.lex_state = 117},
  [3360] = {.lex_state = 18},
  [3361] = {.lex_state = 117},
  [3362] = {.lex_state = 18},
  [3363] = {.lex_state = 117},
  [3364] = {.lex_state = 183},
  [3365] = {.lex_state = 18},
  [3366] = {.lex_state = 117},
  [3367] = {.lex_state = 18},
  [3368] = {.lex_state = 18},
  [3369] = {.lex_state = 117},
  [3370] = {.lex_state = 18},
  [3371] = {.lex_state = 117},
  [3372] = {.lex_state = 183},
  [3373] = {.lex_state = 18},
  [3374] = {.lex_state = 183},
  [3375] = {.lex_state = 18},
  [3376] = {.lex_state = 117},
  [3377] = {.lex_state = 18},
  [3378] = {.lex_state = 18},
  [3379] = {.lex_state = 18},
  [3380] = {.lex_state = 183},
  [3381] = {.lex_state = 183},
  [3382] = {.lex_state = 117},
  [3383] = {.lex_state = 18},
  [3384] = {.lex_state = 18},
  [3385] = {.lex_state = 183},
  [3386] = {.lex_state = 18},
  [3387] = {.lex_state = 183},
  [3388] = {.lex_state = 18},
  [3389] = {.lex_state = 18},
  [3390] = {.lex_state = 18},
  [3391] = {.lex_state = 117},
  [3392] = {.lex_state = 117},
  [3393] = {.lex_state = 183},
  [3394] = {.lex_state = 18},
  [3395] = {.lex_state = 18},
  [3396] = {.lex_state = 18},
  [3397] = {.lex_state = 18},
  [3398] = {.lex_state = 18},
  [3399] = {.lex_state = 18},
  [3400] = {.lex_state = 18},
  [3401] = {.lex_state = 18},
  [3402] = {.lex_state = 18},
  [3403] = {.lex_state = 18},
  [3404] = {.lex_state = 183},
  [3405] = {.lex_state = 18},
  [3406] = {.lex_state = 18},
  [3407] = {.lex_state = 18},
  [3408] = {.lex_state = 18},
  [3409] = {.lex_state = 18},
  [3410] = {.lex_state = 18},
  [3411] = {.lex_state = 18},
  [3412] = {.lex_state = 18},
  [3413] = {.lex_state = 18},
  [3414] = {.lex_state = 18},
  [3415] = {.lex_state = 18},
  [3416] = {.lex_state = 183},
  [3417] = {.lex_state = 18},
  [3418] = {.lex_state = 18},
  [3419] = {.lex_state = 18},
  [3420] = {.lex_state = 18},
  [3421] = {.lex_state = 18},
  [3422] = {.lex_state = 18},
  [3423] = {.lex_state = 18},
  [3424] = {.lex_state = 18},
  [3425] = {.lex_state = 117},
  [3426] = {.lex_state = 18},
  [3427] = {.lex_state = 183},
  [3428] = {.lex_state = 183},
  [3429] = {.lex_state = 183},
  [3430] = {.lex_state = 117},
  [3431] = {.lex_state = 18},
  [3432] = {.lex_state = 117},
  [3433] = {.lex_state = 183},
  [3434] = {.lex_state = 18},
  [3435] = {.lex_state = 183},
  [3436] = {.lex_state = 18},
  [3437] = {.lex_state = 18},
  [3438] = {.lex_state = 18},
  [3439] = {.lex_state = 18},
  [3440] = {.lex_state = 18},
  [3441] = {.lex_state = 18},
  [3442] = {.lex_state = 18},
  [3443] = {.lex_state = 18},
  [3444] = {.lex_state = 18},
  [3445] = {.lex_state = 18},
  [3446] = {.lex_state = 183},
  [3447] = {.lex_state = 183},
  [3448] = {.lex_state = 18},
  [3449] = {.lex_state = 117},
  [3450] = {.lex_state = 18},
  [3451] = {.lex_state = 183},
  [3452] = {.lex_state = 18},
  [3453] = {.lex_state = 18},
  [3454] = {.lex_state = 18},
  [3455] = {.lex_state = 117},
  [3456] = {.lex_state = 117},
  [3457] = {.lex_state = 18},
  [3458] = {.lex_state = 18},
  [3459] = {.lex_state = 18},
  [3460] = {.lex_state = 18},
  [3461] = {.lex_state = 18},
  [3462] = {.lex_state = 18},
  [3463] = {.lex_state = 183},
  [3464] = {.lex_state = 18},
  [3465] = {.lex_state = 18},
  [3466] = {.lex_state = 18},
  [3467] = {.lex_state = 18},
  [3468] = {.lex_state = 18},
  [3469] = {.lex_state = 117},
  [3470] = {.lex_state = 18},
  [3471] = {.lex_state = 183},
  [3472] = {.lex_state = 18},
  [3473] = {.lex_state = 18},
  [3474] = {.lex_state = 183},
  [3475] = {.lex_state = 18},
  [3476] = {.lex_state = 183},
  [3477] = {.lex_state = 183},
  [3478] = {.lex_state = 117},
  [3479] = {.lex_state = 18},
  [3480] = {.lex_state = 18},
  [3481] = {.lex_state = 117},
  [3482] = {.lex_state = 183},
  [3483] = {.lex_state = 18},
  [3484] = {.lex_state = 117},
  [3485] = {.lex_state = 183},
  [3486] = {.lex_state = 117},
  [3487] = {.lex_state = 117},
  [3488] = {.lex_state = 183},
  [3489] = {.lex_state = 18},
  [3490] = {.lex_state = 117},
  [3491] = {.lex_state = 18},
  [3492] = {.lex_state = 18},
  [3493] = {.lex_state = 18},
  [3494] = {.lex_state = 18},
  [3495] = {.lex_state = 18},
  [3496] = {.lex_state = 18},
  [3497] = {.lex_state = 18},
  [3498] = {.lex_state = 183},
  [3499] = {.lex_state = 18},
  [3500] = {.lex_state = 18},
  [3501] = {.lex_state = 18},
  [3502] = {.lex_state = 117},
  [3503] = {.lex_state = 117},
  [3504] = {.lex_state = 18},
  [3505] = {.lex_state = 18},
  [3506] = {.lex_state = 18},
  [3507] = {.lex_state = 183},
  [3508] = {.lex_state = 117},
  [3509] = {.lex_state = 18},
  [3510] = {.lex_state = 18},
  [3511] = {.lex_state = 18},
  [3512] = {.lex_state = 117},
  [3513] = {.lex_state = 117},
  [3514] = {.lex_state = 117},
  [3515] = {.lex_state = 117},
  [3516] = {.lex_state = 18},
  [3517] = {.lex_state = 117},
  [3518] = {.lex_state = 18},
  [3519] = {.lex_state = 18},
  [3520] = {.lex_state = 117},
  [3521] = {.lex_state = 18},
  [3522] = {.lex_state = 18},
  [3523] = {.lex_state = 18},
  [3524] = {.lex_state = 18},
  [3525] = {.lex_state = 18},
  [3526] = {.lex_state = 18},
  [3527] = {.lex_state = 18},
  [3528] = {.lex_state = 183},
  [3529] = {.lex_state = 18},
  [3530] = {.lex_state = 18},
  [3531] = {.lex_state = 18},
  [3532] = {.lex_state = 18},
  [3533] = {.lex_state = 18},
  [3534] = {.lex_state = 18},
  [3535] = {.lex_state = 18},
  [3536] = {.lex_state = 18},
  [3537] = {.lex_state = 18},
  [3538] = {.lex_state = 18},
  [3539] = {.lex_state = 18},
  [3540] = {.lex_state = 18},
  [3541] = {.lex_state = 18},
  [3542] = {.lex_state = 183},
  [3543] = {.lex_state = 117},
  [3544] = {.lex_state = 117},
  [3545] = {.lex_state = 18},
  [3546] = {.lex_state = 183},
  [3547] = {.lex_state = 18},
  [3548] = {.lex_state = 18},
  [3549] = {.lex_state = 450},
  [3550] = {.lex_state = 183},
  [3551] = {.lex_state = 183},
  [3552] = {.lex_state = 18},
  [3553] = {.lex_state = 183},
  [3554] = {.lex_state = 183},
  [3555] = {.lex_state = 18},
  [3556] = {.lex_state = 18},
  [3557] = {.lex_state = 18},
  [3558] = {.lex_state = 18},
  [3559] = {.lex_state = 18},
  [3560] = {.lex_state = 183},
  [3561] = {.lex_state = 183},
  [3562] = {.lex_state = 18},
  [3563] = {.lex_state = 183},
  [3564] = {.lex_state = 18},
  [3565] = {.lex_state = 18},
  [3566] = {.lex_state = 18},
  [3567] = {.lex_state = 183},
  [3568] = {.lex_state = 18},
  [3569] = {.lex_state = 18},
  [3570] = {.lex_state = 18},
  [3571] = {.lex_state = 18},
  [3572] = {.lex_state = 18},
  [3573] = {.lex_state = 183},
  [3574] = {.lex_state = 18},
  [3575] = {.lex_state = 117},
  [3576] = {.lex_state = 183},
  [3577] = {.lex_state = 18},
  [3578] = {.lex_state = 117},
  [3579] = {.lex_state = 18},
  [3580] = {.lex_state = 18},
  [3581] = {.lex_state = 18},
  [3582] = {.lex_state = 18},
  [3583] = {.lex_state = 18},
  [3584] = {.lex_state = 18},
  [3585] = {.lex_state = 18},
  [3586] = {.lex_state = 18},
  [3587] = {.lex_state = 117},
  [3588] = {.lex_state = 183},
  [3589] = {.lex_state = 117},
  [3590] = {.lex_state = 18},
  [3591] = {.lex_state = 116},
  [3592] = {.lex_state = 183},
  [3593] = {.lex_state = 117},
  [3594] = {.lex_state = 183},
  [3595] = {.lex_state = 18},
  [3596] = {.lex_state = 183},
  [3597] = {.lex_state = 18},
  [3598] = {.lex_state = 183},
  [3599] = {.lex_state = 117},
  [3600] = {.lex_state = 18},
  [3601] = {.lex_state = 18},
  [3602] = {.lex_state = 18},
  [3603] = {.lex_state = 183},
  [3604] = {.lex_state = 18},
  [3605] = {.lex_state = 18},
  [3606] = {.lex_state = 18},
  [3607] = {.lex_state = 18},
  [3608] = {.lex_state = 18},
  [3609] = {.lex_state = 18},
  [3610] = {.lex_state = 183},
  [3611] = {.lex_state = 183},
  [3612] = {.lex_state = 18},
  [3613] = {.lex_state = 117},
  [3614] = {.lex_state = 18},
  [3615] = {.lex_state = 18},
  [3616] = {.lex_state = 117},
  [3617] = {.lex_state = 183},
  [3618] = {.lex_state = 18},
  [3619] = {.lex_state = 18},
  [3620] = {.lex_state = 18},
  [3621] = {.lex_state = 117},
  [3622] = {.lex_state = 18},
  [3623] = {.lex_state = 18},
  [3624] = {.lex_state = 18},
  [3625] = {.lex_state = 18},
  [3626] = {.lex_state = 18},
  [3627] = {.lex_state = 18},
  [3628] = {.lex_state = 18},
  [3629] = {.lex_state = 117},
  [3630] = {.lex_state = 18},
  [3631] = {.lex_state = 18},
  [3632] = {.lex_state = 18},
  [3633] = {.lex_state = 117},
  [3634] = {.lex_state = 18},
  [3635] = {.lex_state = 18},
  [3636] = {.lex_state = 117},
  [3637] = {.lex_state = 183},
  [3638] = {.lex_state = 18},
  [3639] = {.lex_state = 450, .external_lex_state = 2},
  [3640] = {.lex_state = 18},
  [3641] = {.lex_state = 18},
  [3642] = {.lex_state = 18},
  [3643] = {.lex_state = 18},
  [3644] = {.lex_state = 18},
  [3645] = {.lex_state = 18},
  [3646] = {.lex_state = 18},
  [3647] = {.lex_state = 18},
  [3648] = {.lex_state = 117},
  [3649] = {.lex_state = 18},
  [3650] = {.lex_state = 18},
  [3651] = {.lex_state = 18},
  [3652] = {.lex_state = 117},
  [3653] = {.lex_state = 183},
  [3654] = {.lex_state = 18},
  [3655] = {.lex_state = 18},
  [3656] = {.lex_state = 183},
  [3657] = {.lex_state = 18},
  [3658] = {.lex_state = 117},
  [3659] = {.lex_state = 18},
  [3660] = {.lex_state = 117},
  [3661] = {.lex_state = 117},
  [3662] = {.lex_state = 117},
  [3663] = {.lex_state = 18},
  [3664] = {.lex_state = 18},
  [3665] = {.lex_state = 183},
  [3666] = {.lex_state = 18},
  [3667] = {.lex_state = 117},
  [3668] = {.lex_state = 117},
  [3669] = {.lex_state = 183},
  [3670] = {.lex_state = 117},
  [3671] = {.lex_state = 18},
  [3672] = {.lex_state = 117},
  [3673] = {.lex_state = 18},
  [3674] = {.lex_state = 18},
  [3675] = {.lex_state = 18},
  [3676] = {.lex_state = 18},
  [3677] = {.lex_state = 18},
  [3678] = {.lex_state = 18},
  [3679] = {.lex_state = 18},
  [3680] = {.lex_state = 183},
  [3681] = {.lex_state = 18},
  [3682] = {.lex_state = 183},
  [3683] = {.lex_state = 18},
  [3684] = {.lex_state = 183},
  [3685] = {.lex_state = 183},
  [3686] = {.lex_state = 18},
  [3687] = {.lex_state = 18},
  [3688] = {.lex_state = 183},
  [3689] = {.lex_state = 18},
  [3690] = {.lex_state = 183},
  [3691] = {.lex_state = 117},
  [3692] = {.lex_state = 18},
  [3693] = {.lex_state = 117},
  [3694] = {.lex_state = 18},
  [3695] = {.lex_state = 18},
  [3696] = {.lex_state = 18},
  [3697] = {.lex_state = 18},
  [3698] = {.lex_state = 18},
  [3699] = {.lex_state = 18},
  [3700] = {.lex_state = 18},
  [3701] = {.lex_state = 183},
  [3702] = {.lex_state = 18},
  [3703] = {.lex_state = 117},
  [3704] = {.lex_state = 18},
  [3705] = {.lex_state = 117},
  [3706] = {.lex_state = 117},
  [3707] = {.lex_state = 117},
  [3708] = {.lex_state = 117},
  [3709] = {.lex_state = 117},
  [3710] = {.lex_state = 117},
  [3711] = {.lex_state = 117},
  [3712] = {.lex_state = 117},
  [3713] = {.lex_state = 117},
  [3714] = {.lex_state = 117},
  [3715] = {.lex_state = 117},
  [3716] = {.lex_state = 117},
  [3717] = {.lex_state = 117},
  [3718] = {.lex_state = 117},
  [3719] = {.lex_state = 117},
  [3720] = {.lex_state = 117},
  [3721] = {.lex_state = 117},
  [3722] = {.lex_state = 117},
  [3723] = {.lex_state = 450},
  [3724] = {.lex_state = 117},
  [3725] = {.lex_state = 117},
  [3726] = {.lex_state = 117},
  [3727] = {.lex_state = 117},
  [3728] = {.lex_state = 117},
  [3729] = {.lex_state = 117},
  [3730] = {.lex_state = 117},
  [3731] = {.lex_state = 117},
  [3732] = {.lex_state = 117},
  [3733] = {.lex_state = 117},
  [3734] = {.lex_state = 117},
  [3735] = {.lex_state = 117},
  [3736] = {.lex_state = 117},
  [3737] = {.lex_state = 117},
  [3738] = {.lex_state = 117},
  [3739] = {.lex_state = 117},
  [3740] = {.lex_state = 117},
  [3741] = {.lex_state = 117},
  [3742] = {.lex_state = 117},
  [3743] = {.lex_state = 117},
  [3744] = {.lex_state = 117},
  [3745] = {.lex_state = 117},
  [3746] = {.lex_state = 117},
  [3747] = {.lex_state = 117},
  [3748] = {.lex_state = 117},
  [3749] = {.lex_state = 117},
  [3750] = {.lex_state = 117},
  [3751] = {.lex_state = 117},
  [3752] = {.lex_state = 117},
  [3753] = {.lex_state = 117},
  [3754] = {.lex_state = 117},
  [3755] = {.lex_state = 127, .external_lex_state = 4},
  [3756] = {.lex_state = 117},
  [3757] = {.lex_state = 117},
  [3758] = {.lex_state = 117},
  [3759] = {.lex_state = 117},
  [3760] = {.lex_state = 117},
  [3761] = {.lex_state = 117},
  [3762] = {.lex_state = 117},
  [3763] = {.lex_state = 117},
  [3764] = {.lex_state = 116},
  [3765] = {.lex_state = 117},
  [3766] = {.lex_state = 117},
  [3767] = {.lex_state = 116},
  [3768] = {.lex_state = 116},
  [3769] = {.lex_state = 116},
  [3770] = {.lex_state = 117},
  [3771] = {.lex_state = 116},
  [3772] = {.lex_state = 116},
  [3773] = {.lex_state = 116},
  [3774] = {.lex_state = 117},
  [3775] = {.lex_state = 116},
  [3776] = {.lex_state = 116},
  [3777] = {.lex_state = 117},
  [3778] = {.lex_state = 117},
  [3779] = {.lex_state = 117},
  [3780] = {.lex_state = 116},
  [3781] = {.lex_state = 116},
  [3782] = {.lex_state = 116},
  [3783] = {.lex_state = 116},
  [3784] = {.lex_state = 117},
  [3785] = {.lex_state = 116},
  [3786] = {.lex_state = 116},
  [3787] = {.lex_state = 133, .external_lex_state = 4},
  [3788] = {.lex_state = 117},
  [3789] = {.lex_state = 117},
  [3790] = {.lex_state = 117},
  [3791] = {.lex_state = 117},
  [3792] = {.lex_state = 117},
  [3793] = {.lex_state = 116},
  [3794] = {.lex_state = 117},
  [3795] = {.lex_state = 116},
  [3796] = {.lex_state = 116},
  [3797] = {.lex_state = 116},
  [3798] = {.lex_state = 117},
  [3799] = {.lex_state = 117},
  [3800] = {.lex_state = 116},
  [3801] = {.lex_state = 116},
  [3802] = {.lex_state = 116},
  [3803] = {.lex_state = 116},
  [3804] = {.lex_state = 116},
  [3805] = {.lex_state = 117},
  [3806] = {.lex_state = 117},
  [3807] = {.lex_state = 116},
  [3808] = {.lex_state = 117},
  [3809] = {.lex_state = 117},
  [3810] = {.lex_state = 116},
  [3811] = {.lex_state = 116},
  [3812] = {.lex_state = 117},
  [3813] = {.lex_state = 116},
  [3814] = {.lex_state = 116},
  [3815] = {.lex_state = 117},
  [3816] = {.lex_state = 117},
  [3817] = {.lex_state = 116},
  [3818] = {.lex_state = 116},
  [3819] = {.lex_state = 117},
  [3820] = {.lex_state = 129, .external_lex_state = 4},
  [3821] = {.lex_state = 117},
  [3822] = {.lex_state = 117},
  [3823] = {.lex_state = 116},
  [3824] = {.lex_state = 117},
  [3825] = {.lex_state = 116},
  [3826] = {.lex_state = 116},
  [3827] = {.lex_state = 117},
  [3828] = {.lex_state = 116},
  [3829] = {.lex_state = 116},
  [3830] = {.lex_state = 116},
  [3831] = {.lex_state = 117},
  [3832] = {.lex_state = 117},
  [3833] = {.lex_state = 117},
  [3834] = {.lex_state = 116},
  [3835] = {.lex_state = 117},
  [3836] = {.lex_state = 117},
  [3837] = {.lex_state = 116},
  [3838] = {.lex_state = 116},
  [3839] = {.lex_state = 117},
  [3840] = {.lex_state = 117},
  [3841] = {.lex_state = 117},
  [3842] = {.lex_state = 116},
  [3843] = {.lex_state = 117},
  [3844] = {.lex_state = 116},
  [3845] = {.lex_state = 117},
  [3846] = {.lex_state = 116},
  [3847] = {.lex_state = 116},
  [3848] = {.lex_state = 116},
  [3849] = {.lex_state = 116},
  [3850] = {.lex_state = 116},
  [3851] = {.lex_state = 144, .external_lex_state = 4},
  [3852] = {.lex_state = 117},
  [3853] = {.lex_state = 128, .external_lex_state = 4},
  [3854] = {.lex_state = 116},
  [3855] = {.lex_state = 116},
  [3856] = {.lex_state = 117},
  [3857] = {.lex_state = 116},
  [3858] = {.lex_state = 117},
  [3859] = {.lex_state = 116},
  [3860] = {.lex_state = 117},
  [3861] = {.lex_state = 117},
  [3862] = {.lex_state = 117},
  [3863] = {.lex_state = 117},
  [3864] = {.lex_state = 116},
  [3865] = {.lex_state = 117},
  [3866] = {.lex_state = 117},
  [3867] = {.lex_state = 117},
  [3868] = {.lex_state = 117},
  [3869] = {.lex_state = 117},
  [3870] = {.lex_state = 117},
  [3871] = {.lex_state = 116},
  [3872] = {.lex_state = 117},
  [3873] = {.lex_state = 117},
  [3874] = {.lex_state = 116},
  [3875] = {.lex_state = 116},
  [3876] = {.lex_state = 116},
  [3877] = {.lex_state = 117},
  [3878] = {.lex_state = 116},
  [3879] = {.lex_state = 117},
  [3880] = {.lex_state = 117},
  [3881] = {.lex_state = 117},
  [3882] = {.lex_state = 117},
  [3883] = {.lex_state = 147, .external_lex_state = 4},
  [3884] = {.lex_state = 135, .external_lex_state = 4},
  [3885] = {.lex_state = 131, .external_lex_state = 4},
  [3886] = {.lex_state = 30, .external_lex_state = 4},
  [3887] = {.lex_state = 117},
  [3888] = {.lex_state = 117},
  [3889] = {.lex_state = 134, .external_lex_state = 4},
  [3890] = {.lex_state = 145, .external_lex_state = 4},
  [3891] = {.lex_state = 117},
  [3892] = {.lex_state = 117},
  [3893] = {.lex_state = 130, .external_lex_state = 4},
  [3894] = {.lex_state = 50, .external_lex_state = 4},
  [3895] = {.lex_state = 132, .external_lex_state = 4},
  [3896] = {.lex_state = 33, .external_lex_state = 4},
  [3897] = {.lex_state = 31, .external_lex_state = 4},
  [3898] = {.lex_state = 146, .external_lex_state = 4},
  [3899] = {.lex_state = 148, .external_lex_state = 4},
  [3900] = {.lex_state = 154, .external_lex_state = 4},
  [3901] = {.lex_state = 137, .external_lex_state = 4},
  [3902] = {.lex_state = 136, .external_lex_state = 4},
  [3903] = {.lex_state = 155, .external_lex_state = 4},
  [3904] = {.lex_state = 34, .external_lex_state = 4},
  [3905] = {.lex_state = 149, .external_lex_state = 4},
  [3906] = {.lex_state = 19},
  [3907] = {.lex_state = 156, .external_lex_state = 4},
  [3908] = {.lex_state = 138, .external_lex_state = 4},
  [3909] = {.lex_state = 32, .external_lex_state = 4},
  [3910] = {.lex_state = 160, .external_lex_state = 4},
  [3911] = {.lex_state = 51, .external_lex_state = 4},
  [3912] = {.lex_state = 53, .external_lex_state = 4},
  [3913] = {.lex_state = 173, .external_lex_state = 4},
  [3914] = {.lex_state = 174, .external_lex_state = 4},
  [3915] = {.lex_state = 54, .external_lex_state = 4},
  [3916] = {.lex_state = 35, .external_lex_state = 4},
  [3917] = {.lex_state = 157, .external_lex_state = 4},
  [3918] = {.lex_state = 158, .external_lex_state = 4},
  [3919] = {.lex_state = 140},
  [3920] = {.lex_state = 176, .external_lex_state = 4},
  [3921] = {.lex_state = 52, .external_lex_state = 4},
  [3922] = {.lex_state = 139},
  [3923] = {.lex_state = 24},
  [3924] = {.lex_state = 161, .external_lex_state = 4},
  [3925] = {.lex_state = 74, .external_lex_state = 4},
  [3926] = {.lex_state = 23},
  [3927] = {.lex_state = 162, .external_lex_state = 4},
  [3928] = {.lex_state = 163, .external_lex_state = 4},
  [3929] = {.lex_state = 177, .external_lex_state = 4},
  [3930] = {.lex_state = 165},
  [3931] = {.lex_state = 26},
  [3932] = {.lex_state = 20},
  [3933] = {.lex_state = 75, .external_lex_state = 4},
  [3934] = {.lex_state = 77, .external_lex_state = 4},
  [3935] = {.lex_state = 162},
  [3936] = {.lex_state = 21},
  [3937] = {.lex_state = 25},
  [3938] = {.lex_state = 55, .external_lex_state = 4},
  [3939] = {.lex_state = 22},
  [3940] = {.lex_state = 159, .external_lex_state = 4},
  [3941] = {.lex_state = 150},
  [3942] = {.lex_state = 151},
  [3943] = {.lex_state = 164},
  [3944] = {.lex_state = 96, .external_lex_state = 4},
  [3945] = {.lex_state = 167},
  [3946] = {.lex_state = 166},
  [3947] = {.lex_state = 20},
  [3948] = {.lex_state = 141},
  [3949] = {.lex_state = 24, .external_lex_state = 4},
  [3950] = {.lex_state = 175, .external_lex_state = 4},
  [3951] = {.lex_state = 3},
  [3952] = {.lex_state = 178},
  [3953] = {.lex_state = 171},
  [3954] = {.lex_state = 7},
  [3955] = {.lex_state = 97, .external_lex_state = 4},
  [3956] = {.lex_state = 142},
  [3957] = {.lex_state = 143},
  [3958] = {.lex_state = 25, .external_lex_state = 4},
  [3959] = {.lex_state = 179},
  [3960] = {.lex_state = 13},
  [3961] = {.lex_state = 163},
  [3962] = {.lex_state = 170},
  [3963] = {.lex_state = 76, .external_lex_state = 4},
  [3964] = {.lex_state = 99, .external_lex_state = 4},
  [3965] = {.lex_state = 181},
  [3966] = {.lex_state = 180},
  [3967] = {.lex_state = 168},
  [3968] = {.lex_state = 5},
  [3969] = {.lex_state = 36},
  [3970] = {.lex_state = 26, .external_lex_state = 4},
  [3971] = {.lex_state = 177},
  [3972] = {.lex_state = 37},
  [3973] = {.lex_state = 78, .external_lex_state = 4},
  [3974] = {.lex_state = 169},
  [3975] = {.lex_state = 100, .external_lex_state = 4},
  [3976] = {.lex_state = 46},
  [3977] = {.lex_state = 81},
  [3978] = {.lex_state = 47},
  [3979] = {.lex_state = 10},
  [3980] = {.lex_state = 57},
  [3981] = {.lex_state = 80},
  [3982] = {.lex_state = 182},
  [3983] = {.lex_state = 82},
  [3984] = {.lex_state = 56},
  [3985] = {.lex_state = 15},
  [3986] = {.lex_state = 78},
  [3987] = {.lex_state = 172, .external_lex_state = 4},
  [3988] = {.lex_state = 13, .external_lex_state = 4},
  [3989] = {.lex_state = 79},
  [3990] = {.lex_state = 98, .external_lex_state = 4},
  [3991] = {.lex_state = 172},
  [3992] = {.lex_state = 153},
  [3993] = {.lex_state = 38, .external_lex_state = 4},
  [3994] = {.lex_state = 127, .external_lex_state = 4},
  [3995] = {.lex_state = 102},
  [3996] = {.lex_state = 101},
  [3997] = {.lex_state = 68},
  [3998] = {.lex_state = 93, .external_lex_state = 4},
  [3999] = {.lex_state = 103},
  [4000] = {.lex_state = 69},
  [4001] = {.lex_state = 11},
  [4002] = {.lex_state = 93},
  [4003] = {.lex_state = 38, .external_lex_state = 4},
  [4004] = {.lex_state = 183},
  [4005] = {.lex_state = 15, .external_lex_state = 4},
  [4006] = {.lex_state = 104},
  [4007] = {.lex_state = 100},
  [4008] = {.lex_state = 182},
  [4009] = {.lex_state = 127, .external_lex_state = 4},
  [4010] = {.lex_state = 129, .external_lex_state = 4},
  [4011] = {.lex_state = 39, .external_lex_state = 4},
  [4012] = {.lex_state = 127, .external_lex_state = 4},
  [4013] = {.lex_state = 38, .external_lex_state = 4},
  [4014] = {.lex_state = 127, .external_lex_state = 4},
  [4015] = {.lex_state = 127, .external_lex_state = 4},
  [4016] = {.lex_state = 127, .external_lex_state = 4},
  [4017] = {.lex_state = 39, .external_lex_state = 4},
  [4018] = {.lex_state = 40, .external_lex_state = 4},
  [4019] = {.lex_state = 127, .external_lex_state = 4},
  [4020] = {.lex_state = 127, .external_lex_state = 4},
  [4021] = {.lex_state = 60, .external_lex_state = 4},
  [4022] = {.lex_state = 71},
  [4023] = {.lex_state = 183},
  [4024] = {.lex_state = 127, .external_lex_state = 4},
  [4025] = {.lex_state = 127, .external_lex_state = 4},
  [4026] = {.lex_state = 127, .external_lex_state = 4},
  [4027] = {.lex_state = 144, .external_lex_state = 4},
  [4028] = {.lex_state = 133, .external_lex_state = 4},
  [4029] = {.lex_state = 40, .external_lex_state = 4},
  [4030] = {.lex_state = 128, .external_lex_state = 4},
  [4031] = {.lex_state = 70},
  [4032] = {.lex_state = 127, .external_lex_state = 4},
  [4033] = {.lex_state = 127, .external_lex_state = 4},
  [4034] = {.lex_state = 127, .external_lex_state = 4},
  [4035] = {.lex_state = 60, .external_lex_state = 4},
  [4036] = {.lex_state = 127, .external_lex_state = 4},
  [4037] = {.lex_state = 127, .external_lex_state = 4},
  [4038] = {.lex_state = 117},
  [4039] = {.lex_state = 116},
  [4040] = {.lex_state = 134, .external_lex_state = 4},
  [4041] = {.lex_state = 133, .external_lex_state = 4},
  [4042] = {.lex_state = 39, .external_lex_state = 4},
  [4043] = {.lex_state = 144, .external_lex_state = 4},
  [4044] = {.lex_state = 144, .external_lex_state = 4},
  [4045] = {.lex_state = 128, .external_lex_state = 4},
  [4046] = {.lex_state = 61, .external_lex_state = 4},
  [4047] = {.lex_state = 129, .external_lex_state = 4},
  [4048] = {.lex_state = 60, .external_lex_state = 4},
  [4049] = {.lex_state = 133, .external_lex_state = 4},
  [4050] = {.lex_state = 118, .external_lex_state = 4},
  [4051] = {.lex_state = 40, .external_lex_state = 4},
  [4052] = {.lex_state = 144, .external_lex_state = 4},
  [4053] = {.lex_state = 133, .external_lex_state = 4},
  [4054] = {.lex_state = 144, .external_lex_state = 4},
  [4055] = {.lex_state = 133, .external_lex_state = 4},
  [4056] = {.lex_state = 133, .external_lex_state = 4},
  [4057] = {.lex_state = 94},
  [4058] = {.lex_state = 128, .external_lex_state = 4},
  [4059] = {.lex_state = 116},
  [4060] = {.lex_state = 61, .external_lex_state = 4},
  [4061] = {.lex_state = 133, .external_lex_state = 4},
  [4062] = {.lex_state = 133, .external_lex_state = 4},
  [4063] = {.lex_state = 133, .external_lex_state = 4},
  [4064] = {.lex_state = 94},
  [4065] = {.lex_state = 41, .external_lex_state = 4},
  [4066] = {.lex_state = 129, .external_lex_state = 4},
  [4067] = {.lex_state = 118, .external_lex_state = 4},
  [4068] = {.lex_state = 133, .external_lex_state = 4},
  [4069] = {.lex_state = 144, .external_lex_state = 4},
  [4070] = {.lex_state = 128, .external_lex_state = 4},
  [4071] = {.lex_state = 130, .external_lex_state = 4},
  [4072] = {.lex_state = 62, .external_lex_state = 4},
  [4073] = {.lex_state = 128, .external_lex_state = 4},
  [4074] = {.lex_state = 129, .external_lex_state = 4},
  [4075] = {.lex_state = 145, .external_lex_state = 4},
  [4076] = {.lex_state = 128, .external_lex_state = 4},
  [4077] = {.lex_state = 42, .external_lex_state = 4},
  [4078] = {.lex_state = 144, .external_lex_state = 4},
  [4079] = {.lex_state = 128, .external_lex_state = 4},
  [4080] = {.lex_state = 128, .external_lex_state = 4},
  [4081] = {.lex_state = 144, .external_lex_state = 4},
  [4082] = {.lex_state = 133, .external_lex_state = 4},
  [4083] = {.lex_state = 128, .external_lex_state = 4},
  [4084] = {.lex_state = 41, .external_lex_state = 4},
  [4085] = {.lex_state = 128, .external_lex_state = 4},
  [4086] = {.lex_state = 133, .external_lex_state = 4},
  [4087] = {.lex_state = 30, .external_lex_state = 4},
  [4088] = {.lex_state = 42, .external_lex_state = 4},
  [4089] = {.lex_state = 133, .external_lex_state = 4},
  [4090] = {.lex_state = 144, .external_lex_state = 4},
  [4091] = {.lex_state = 144, .external_lex_state = 4},
  [4092] = {.lex_state = 144, .external_lex_state = 4},
  [4093] = {.lex_state = 117},
  [4094] = {.lex_state = 128, .external_lex_state = 4},
  [4095] = {.lex_state = 144, .external_lex_state = 4},
  [4096] = {.lex_state = 131, .external_lex_state = 4},
  [4097] = {.lex_state = 144, .external_lex_state = 4},
  [4098] = {.lex_state = 144, .external_lex_state = 4},
  [4099] = {.lex_state = 128, .external_lex_state = 4},
  [4100] = {.lex_state = 133, .external_lex_state = 4},
  [4101] = {.lex_state = 147, .external_lex_state = 4},
  [4102] = {.lex_state = 133, .external_lex_state = 4},
  [4103] = {.lex_state = 129, .external_lex_state = 4},
  [4104] = {.lex_state = 133, .external_lex_state = 4},
  [4105] = {.lex_state = 128, .external_lex_state = 4},
  [4106] = {.lex_state = 128, .external_lex_state = 4},
  [4107] = {.lex_state = 144, .external_lex_state = 4},
  [4108] = {.lex_state = 129, .external_lex_state = 4},
  [4109] = {.lex_state = 129, .external_lex_state = 4},
  [4110] = {.lex_state = 129, .external_lex_state = 4},
  [4111] = {.lex_state = 128, .external_lex_state = 4},
  [4112] = {.lex_state = 129, .external_lex_state = 4},
  [4113] = {.lex_state = 129, .external_lex_state = 4},
  [4114] = {.lex_state = 144, .external_lex_state = 4},
  [4115] = {.lex_state = 129, .external_lex_state = 4},
  [4116] = {.lex_state = 129, .external_lex_state = 4},
  [4117] = {.lex_state = 129, .external_lex_state = 4},
  [4118] = {.lex_state = 129, .external_lex_state = 4},
  [4119] = {.lex_state = 129, .external_lex_state = 4},
  [4120] = {.lex_state = 135, .external_lex_state = 4},
  [4121] = {.lex_state = 62, .external_lex_state = 4},
  [4122] = {.lex_state = 128, .external_lex_state = 4},
  [4123] = {.lex_state = 129, .external_lex_state = 4},
  [4124] = {.lex_state = 41, .external_lex_state = 4},
  [4125] = {.lex_state = 135, .external_lex_state = 4},
  [4126] = {.lex_state = 145, .external_lex_state = 4},
  [4127] = {.lex_state = 145, .external_lex_state = 4},
  [4128] = {.lex_state = 147, .external_lex_state = 4},
  [4129] = {.lex_state = 145, .external_lex_state = 4},
  [4130] = {.lex_state = 145, .external_lex_state = 4},
  [4131] = {.lex_state = 145, .external_lex_state = 4},
  [4132] = {.lex_state = 145, .external_lex_state = 4},
  [4133] = {.lex_state = 145, .external_lex_state = 4},
  [4134] = {.lex_state = 147, .external_lex_state = 4},
  [4135] = {.lex_state = 147, .external_lex_state = 4},
  [4136] = {.lex_state = 147, .external_lex_state = 4},
  [4137] = {.lex_state = 147, .external_lex_state = 4},
  [4138] = {.lex_state = 147, .external_lex_state = 4},
  [4139] = {.lex_state = 147, .external_lex_state = 4},
  [4140] = {.lex_state = 154, .external_lex_state = 4},
  [4141] = {.lex_state = 131, .external_lex_state = 4},
  [4142] = {.lex_state = 131, .external_lex_state = 4},
  [4143] = {.lex_state = 145, .external_lex_state = 4},
  [4144] = {.lex_state = 147, .external_lex_state = 4},
  [4145] = {.lex_state = 147, .external_lex_state = 4},
  [4146] = {.lex_state = 145, .external_lex_state = 4},
  [4147] = {.lex_state = 136, .external_lex_state = 4},
  [4148] = {.lex_state = 146, .external_lex_state = 4},
  [4149] = {.lex_state = 83, .external_lex_state = 4},
  [4150] = {.lex_state = 147, .external_lex_state = 4},
  [4151] = {.lex_state = 147, .external_lex_state = 4},
  [4152] = {.lex_state = 30, .external_lex_state = 4},
  [4153] = {.lex_state = 147, .external_lex_state = 4},
  [4154] = {.lex_state = 134, .external_lex_state = 4},
  [4155] = {.lex_state = 145, .external_lex_state = 4},
  [4156] = {.lex_state = 63, .external_lex_state = 4},
  [4157] = {.lex_state = 83, .external_lex_state = 4},
  [4158] = {.lex_state = 145, .external_lex_state = 4},
  [4159] = {.lex_state = 132, .external_lex_state = 4},
  [4160] = {.lex_state = 130, .external_lex_state = 4},
  [4161] = {.lex_state = 31, .external_lex_state = 4},
  [4162] = {.lex_state = 145, .external_lex_state = 4},
  [4163] = {.lex_state = 131, .external_lex_state = 4},
  [4164] = {.lex_state = 43, .external_lex_state = 4},
  [4165] = {.lex_state = 131, .external_lex_state = 4},
  [4166] = {.lex_state = 131, .external_lex_state = 4},
  [4167] = {.lex_state = 131, .external_lex_state = 4},
  [4168] = {.lex_state = 131, .external_lex_state = 4},
  [4169] = {.lex_state = 130, .external_lex_state = 4},
  [4170] = {.lex_state = 64, .external_lex_state = 4},
  [4171] = {.lex_state = 131, .external_lex_state = 4},
  [4172] = {.lex_state = 131, .external_lex_state = 4},
  [4173] = {.lex_state = 130, .external_lex_state = 4},
  [4174] = {.lex_state = 134, .external_lex_state = 4},
  [4175] = {.lex_state = 131, .external_lex_state = 4},
  [4176] = {.lex_state = 131, .external_lex_state = 4},
  [4177] = {.lex_state = 135, .external_lex_state = 4},
  [4178] = {.lex_state = 135, .external_lex_state = 4},
  [4179] = {.lex_state = 117},
  [4180] = {.lex_state = 131, .external_lex_state = 4},
  [4181] = {.lex_state = 131, .external_lex_state = 4},
  [4182] = {.lex_state = 135, .external_lex_state = 4},
  [4183] = {.lex_state = 135, .external_lex_state = 4},
  [4184] = {.lex_state = 134, .external_lex_state = 4},
  [4185] = {.lex_state = 134, .external_lex_state = 4},
  [4186] = {.lex_state = 64, .external_lex_state = 4},
  [4187] = {.lex_state = 63, .external_lex_state = 4},
  [4188] = {.lex_state = 135, .external_lex_state = 4},
  [4189] = {.lex_state = 145, .external_lex_state = 4},
  [4190] = {.lex_state = 135, .external_lex_state = 4},
  [4191] = {.lex_state = 134, .external_lex_state = 4},
  [4192] = {.lex_state = 131, .external_lex_state = 4},
  [4193] = {.lex_state = 135, .external_lex_state = 4},
  [4194] = {.lex_state = 135, .external_lex_state = 4},
  [4195] = {.lex_state = 145, .external_lex_state = 4},
  [4196] = {.lex_state = 135, .external_lex_state = 4},
  [4197] = {.lex_state = 135, .external_lex_state = 4},
  [4198] = {.lex_state = 130, .external_lex_state = 4},
  [4199] = {.lex_state = 130, .external_lex_state = 4},
  [4200] = {.lex_state = 130, .external_lex_state = 4},
  [4201] = {.lex_state = 130, .external_lex_state = 4},
  [4202] = {.lex_state = 50, .external_lex_state = 4},
  [4203] = {.lex_state = 130, .external_lex_state = 4},
  [4204] = {.lex_state = 147, .external_lex_state = 4},
  [4205] = {.lex_state = 30, .external_lex_state = 4},
  [4206] = {.lex_state = 134, .external_lex_state = 4},
  [4207] = {.lex_state = 130, .external_lex_state = 4},
  [4208] = {.lex_state = 42, .external_lex_state = 4},
  [4209] = {.lex_state = 130, .external_lex_state = 4},
  [4210] = {.lex_state = 130, .external_lex_state = 4},
  [4211] = {.lex_state = 43, .external_lex_state = 4},
  [4212] = {.lex_state = 130, .external_lex_state = 4},
  [4213] = {.lex_state = 147, .external_lex_state = 4},
  [4214] = {.lex_state = 130, .external_lex_state = 4},
  [4215] = {.lex_state = 137, .external_lex_state = 4},
  [4216] = {.lex_state = 147, .external_lex_state = 4},
  [4217] = {.lex_state = 30, .external_lex_state = 4},
  [4218] = {.lex_state = 130, .external_lex_state = 4},
  [4219] = {.lex_state = 135, .external_lex_state = 4},
  [4220] = {.lex_state = 135, .external_lex_state = 4},
  [4221] = {.lex_state = 30, .external_lex_state = 4},
  [4222] = {.lex_state = 134, .external_lex_state = 4},
  [4223] = {.lex_state = 148, .external_lex_state = 4},
  [4224] = {.lex_state = 131, .external_lex_state = 4},
  [4225] = {.lex_state = 134, .external_lex_state = 4},
  [4226] = {.lex_state = 30, .external_lex_state = 4},
  [4227] = {.lex_state = 135, .external_lex_state = 4},
  [4228] = {.lex_state = 17, .external_lex_state = 4},
  [4229] = {.lex_state = 30, .external_lex_state = 4},
  [4230] = {.lex_state = 30, .external_lex_state = 4},
  [4231] = {.lex_state = 134, .external_lex_state = 4},
  [4232] = {.lex_state = 30, .external_lex_state = 4},
  [4233] = {.lex_state = 134, .external_lex_state = 4},
  [4234] = {.lex_state = 30, .external_lex_state = 4},
  [4235] = {.lex_state = 30, .external_lex_state = 4},
  [4236] = {.lex_state = 30, .external_lex_state = 4},
  [4237] = {.lex_state = 134, .external_lex_state = 4},
  [4238] = {.lex_state = 135, .external_lex_state = 4},
  [4239] = {.lex_state = 134, .external_lex_state = 4},
  [4240] = {.lex_state = 134, .external_lex_state = 4},
  [4241] = {.lex_state = 145, .external_lex_state = 4},
  [4242] = {.lex_state = 62, .external_lex_state = 4},
  [4243] = {.lex_state = 130, .external_lex_state = 4},
  [4244] = {.lex_state = 134, .external_lex_state = 4},
  [4245] = {.lex_state = 17},
  [4246] = {.lex_state = 134, .external_lex_state = 4},
  [4247] = {.lex_state = 17},
  [4248] = {.lex_state = 30, .external_lex_state = 4},
  [4249] = {.lex_state = 33, .external_lex_state = 4},
  [4250] = {.lex_state = 30, .external_lex_state = 4},
  [4251] = {.lex_state = 61, .external_lex_state = 4},
  [4252] = {.lex_state = 17, .external_lex_state = 4},
  [4253] = {.lex_state = 30, .external_lex_state = 4},
  [4254] = {.lex_state = 30, .external_lex_state = 4},
  [4255] = {.lex_state = 132, .external_lex_state = 4},
  [4256] = {.lex_state = 31, .external_lex_state = 4},
  [4257] = {.lex_state = 148, .external_lex_state = 4},
  [4258] = {.lex_state = 118, .external_lex_state = 4},
  [4259] = {.lex_state = 137, .external_lex_state = 4},
  [4260] = {.lex_state = 148, .external_lex_state = 4},
  [4261] = {.lex_state = 137, .external_lex_state = 4},
  [4262] = {.lex_state = 118, .external_lex_state = 4},
  [4263] = {.lex_state = 154, .external_lex_state = 4},
  [4264] = {.lex_state = 154, .external_lex_state = 4},
  [4265] = {.lex_state = 154, .external_lex_state = 4},
  [4266] = {.lex_state = 154, .external_lex_state = 4},
  [4267] = {.lex_state = 146, .external_lex_state = 4},
  [4268] = {.lex_state = 132, .external_lex_state = 4},
  [4269] = {.lex_state = 154, .external_lex_state = 4},
  [4270] = {.lex_state = 33, .external_lex_state = 4},
  [4271] = {.lex_state = 50, .external_lex_state = 4},
  [4272] = {.lex_state = 154, .external_lex_state = 4},
  [4273] = {.lex_state = 146, .external_lex_state = 4},
  [4274] = {.lex_state = 34, .external_lex_state = 4},
  [4275] = {.lex_state = 51, .external_lex_state = 4},
  [4276] = {.lex_state = 154, .external_lex_state = 4},
  [4277] = {.lex_state = 83, .external_lex_state = 4},
  [4278] = {.lex_state = 33, .external_lex_state = 4},
  [4279] = {.lex_state = 154, .external_lex_state = 4},
  [4280] = {.lex_state = 154, .external_lex_state = 4},
  [4281] = {.lex_state = 146, .external_lex_state = 4},
  [4282] = {.lex_state = 132, .external_lex_state = 4},
  [4283] = {.lex_state = 149, .external_lex_state = 4},
  [4284] = {.lex_state = 132, .external_lex_state = 4},
  [4285] = {.lex_state = 136, .external_lex_state = 4},
  [4286] = {.lex_state = 132, .external_lex_state = 4},
  [4287] = {.lex_state = 132, .external_lex_state = 4},
  [4288] = {.lex_state = 132, .external_lex_state = 4},
  [4289] = {.lex_state = 154, .external_lex_state = 4},
  [4290] = {.lex_state = 132, .external_lex_state = 4},
  [4291] = {.lex_state = 33, .external_lex_state = 4},
  [4292] = {.lex_state = 132, .external_lex_state = 4},
  [4293] = {.lex_state = 136, .external_lex_state = 4},
  [4294] = {.lex_state = 132, .external_lex_state = 4},
  [4295] = {.lex_state = 136, .external_lex_state = 4},
  [4296] = {.lex_state = 132, .external_lex_state = 4},
  [4297] = {.lex_state = 63, .external_lex_state = 4},
  [4298] = {.lex_state = 132, .external_lex_state = 4},
  [4299] = {.lex_state = 136, .external_lex_state = 4},
  [4300] = {.lex_state = 136, .external_lex_state = 4},
  [4301] = {.lex_state = 136, .external_lex_state = 4},
  [4302] = {.lex_state = 136, .external_lex_state = 4},
  [4303] = {.lex_state = 136, .external_lex_state = 4},
  [4304] = {.lex_state = 136, .external_lex_state = 4},
  [4305] = {.lex_state = 136, .external_lex_state = 4},
  [4306] = {.lex_state = 136, .external_lex_state = 4},
  [4307] = {.lex_state = 31, .external_lex_state = 4},
  [4308] = {.lex_state = 64, .external_lex_state = 4},
  [4309] = {.lex_state = 33, .external_lex_state = 4},
  [4310] = {.lex_state = 84, .external_lex_state = 4},
  [4311] = {.lex_state = 50, .external_lex_state = 4},
  [4312] = {.lex_state = 31, .external_lex_state = 4},
  [4313] = {.lex_state = 31, .external_lex_state = 4},
  [4314] = {.lex_state = 31, .external_lex_state = 4},
  [4315] = {.lex_state = 43, .external_lex_state = 4},
  [4316] = {.lex_state = 31, .external_lex_state = 4},
  [4317] = {.lex_state = 31, .external_lex_state = 4},
  [4318] = {.lex_state = 148, .external_lex_state = 4},
  [4319] = {.lex_state = 31, .external_lex_state = 4},
  [4320] = {.lex_state = 31, .external_lex_state = 4},
  [4321] = {.lex_state = 31, .external_lex_state = 4},
  [4322] = {.lex_state = 31, .external_lex_state = 4},
  [4323] = {.lex_state = 31, .external_lex_state = 4},
  [4324] = {.lex_state = 50, .external_lex_state = 4},
  [4325] = {.lex_state = 156, .external_lex_state = 4},
  [4326] = {.lex_state = 50, .external_lex_state = 4},
  [4327] = {.lex_state = 50, .external_lex_state = 4},
  [4328] = {.lex_state = 50, .external_lex_state = 4},
  [4329] = {.lex_state = 50, .external_lex_state = 4},
  [4330] = {.lex_state = 50, .external_lex_state = 4},
  [4331] = {.lex_state = 33, .external_lex_state = 4},
  [4332] = {.lex_state = 33, .external_lex_state = 4},
  [4333] = {.lex_state = 50, .external_lex_state = 4},
  [4334] = {.lex_state = 33, .external_lex_state = 4},
  [4335] = {.lex_state = 148, .external_lex_state = 4},
  [4336] = {.lex_state = 33, .external_lex_state = 4},
  [4337] = {.lex_state = 33, .external_lex_state = 4},
  [4338] = {.lex_state = 33, .external_lex_state = 4},
  [4339] = {.lex_state = 33, .external_lex_state = 4},
  [4340] = {.lex_state = 33, .external_lex_state = 4},
  [4341] = {.lex_state = 33, .external_lex_state = 4},
  [4342] = {.lex_state = 146, .external_lex_state = 4},
  [4343] = {.lex_state = 146, .external_lex_state = 4},
  [4344] = {.lex_state = 85, .external_lex_state = 4},
  [4345] = {.lex_state = 146, .external_lex_state = 4},
  [4346] = {.lex_state = 146, .external_lex_state = 4},
  [4347] = {.lex_state = 146, .external_lex_state = 4},
  [4348] = {.lex_state = 137, .external_lex_state = 4},
  [4349] = {.lex_state = 33, .external_lex_state = 4},
  [4350] = {.lex_state = 154, .external_lex_state = 4},
  [4351] = {.lex_state = 50, .external_lex_state = 4},
  [4352] = {.lex_state = 146, .external_lex_state = 4},
  [4353] = {.lex_state = 50, .external_lex_state = 4},
  [4354] = {.lex_state = 146, .external_lex_state = 4},
  [4355] = {.lex_state = 65, .external_lex_state = 4},
  [4356] = {.lex_state = 105, .external_lex_state = 4},
  [4357] = {.lex_state = 137, .external_lex_state = 4},
  [4358] = {.lex_state = 160, .external_lex_state = 4},
  [4359] = {.lex_state = 146, .external_lex_state = 4},
  [4360] = {.lex_state = 84, .external_lex_state = 4},
  [4361] = {.lex_state = 31, .external_lex_state = 4},
  [4362] = {.lex_state = 132, .external_lex_state = 4},
  [4363] = {.lex_state = 53, .external_lex_state = 4},
  [4364] = {.lex_state = 132, .external_lex_state = 4},
  [4365] = {.lex_state = 136, .external_lex_state = 4},
  [4366] = {.lex_state = 154, .external_lex_state = 4},
  [4367] = {.lex_state = 148, .external_lex_state = 4},
  [4368] = {.lex_state = 148, .external_lex_state = 4},
  [4369] = {.lex_state = 31, .external_lex_state = 4},
  [4370] = {.lex_state = 148, .external_lex_state = 4},
  [4371] = {.lex_state = 146, .external_lex_state = 4},
  [4372] = {.lex_state = 148, .external_lex_state = 4},
  [4373] = {.lex_state = 136, .external_lex_state = 4},
  [4374] = {.lex_state = 148, .external_lex_state = 4},
  [4375] = {.lex_state = 32, .external_lex_state = 4},
  [4376] = {.lex_state = 148, .external_lex_state = 4},
  [4377] = {.lex_state = 148, .external_lex_state = 4},
  [4378] = {.lex_state = 148, .external_lex_state = 4},
  [4379] = {.lex_state = 146, .external_lex_state = 4},
  [4380] = {.lex_state = 105, .external_lex_state = 4},
  [4381] = {.lex_state = 148, .external_lex_state = 4},
  [4382] = {.lex_state = 148, .external_lex_state = 4},
  [4383] = {.lex_state = 50, .external_lex_state = 4},
  [4384] = {.lex_state = 146, .external_lex_state = 4},
  [4385] = {.lex_state = 148, .external_lex_state = 4},
  [4386] = {.lex_state = 85, .external_lex_state = 4},
  [4387] = {.lex_state = 137, .external_lex_state = 4},
  [4388] = {.lex_state = 173, .external_lex_state = 4},
  [4389] = {.lex_state = 137, .external_lex_state = 4},
  [4390] = {.lex_state = 50, .external_lex_state = 4},
  [4391] = {.lex_state = 137, .external_lex_state = 4},
  [4392] = {.lex_state = 137, .external_lex_state = 4},
  [4393] = {.lex_state = 137, .external_lex_state = 4},
  [4394] = {.lex_state = 137, .external_lex_state = 4},
  [4395] = {.lex_state = 4},
  [4396] = {.lex_state = 137, .external_lex_state = 4},
  [4397] = {.lex_state = 118, .external_lex_state = 4},
  [4398] = {.lex_state = 137, .external_lex_state = 4},
  [4399] = {.lex_state = 137, .external_lex_state = 4},
  [4400] = {.lex_state = 137, .external_lex_state = 4},
  [4401] = {.lex_state = 154, .external_lex_state = 4},
  [4402] = {.lex_state = 154, .external_lex_state = 4},
  [4403] = {.lex_state = 137, .external_lex_state = 4},
  [4404] = {.lex_state = 136, .external_lex_state = 4},
  [4405] = {.lex_state = 136, .external_lex_state = 4},
  [4406] = {.lex_state = 138, .external_lex_state = 4},
  [4407] = {.lex_state = 33, .external_lex_state = 4},
  [4408] = {.lex_state = 31, .external_lex_state = 4},
  [4409] = {.lex_state = 155, .external_lex_state = 4},
  [4410] = {.lex_state = 65, .external_lex_state = 4},
  [4411] = {.lex_state = 94},
  [4412] = {.lex_state = 132, .external_lex_state = 4},
  [4413] = {.lex_state = 50, .external_lex_state = 4},
  [4414] = {.lex_state = 146, .external_lex_state = 4},
  [4415] = {.lex_state = 50, .external_lex_state = 4},
  [4416] = {.lex_state = 19},
  [4417] = {.lex_state = 154, .external_lex_state = 4},
  [4418] = {.lex_state = 34, .external_lex_state = 4},
  [4419] = {.lex_state = 156, .external_lex_state = 4},
  [4420] = {.lex_state = 94},
  [4421] = {.lex_state = 51, .external_lex_state = 4},
  [4422] = {.lex_state = 44},
  [4423] = {.lex_state = 86, .external_lex_state = 4},
  [4424] = {.lex_state = 106, .external_lex_state = 4},
  [4425] = {.lex_state = 149, .external_lex_state = 4},
  [4426] = {.lex_state = 86, .external_lex_state = 4},
  [4427] = {.lex_state = 149, .external_lex_state = 4},
  [4428] = {.lex_state = 149, .external_lex_state = 4},
  [4429] = {.lex_state = 87, .external_lex_state = 4},
  [4430] = {.lex_state = 34, .external_lex_state = 4},
  [4431] = {.lex_state = 74, .external_lex_state = 4},
  [4432] = {.lex_state = 52, .external_lex_state = 4},
  [4433] = {.lex_state = 106, .external_lex_state = 4},
  [4434] = {.lex_state = 32, .external_lex_state = 4},
  [4435] = {.lex_state = 173, .external_lex_state = 4},
  [4436] = {.lex_state = 32, .external_lex_state = 4},
  [4437] = {.lex_state = 149, .external_lex_state = 4},
  [4438] = {.lex_state = 105, .external_lex_state = 4},
  [4439] = {.lex_state = 54, .external_lex_state = 4},
  [4440] = {.lex_state = 149, .external_lex_state = 4},
  [4441] = {.lex_state = 149, .external_lex_state = 4},
  [4442] = {.lex_state = 32, .external_lex_state = 4},
  [4443] = {.lex_state = 32, .external_lex_state = 4},
  [4444] = {.lex_state = 32, .external_lex_state = 4},
  [4445] = {.lex_state = 32, .external_lex_state = 4},
  [4446] = {.lex_state = 32, .external_lex_state = 4},
  [4447] = {.lex_state = 156, .external_lex_state = 4},
  [4448] = {.lex_state = 32, .external_lex_state = 4},
  [4449] = {.lex_state = 32, .external_lex_state = 4},
  [4450] = {.lex_state = 149, .external_lex_state = 4},
  [4451] = {.lex_state = 32, .external_lex_state = 4},
  [4452] = {.lex_state = 32, .external_lex_state = 4},
  [4453] = {.lex_state = 32, .external_lex_state = 4},
  [4454] = {.lex_state = 156, .external_lex_state = 4},
  [4455] = {.lex_state = 32, .external_lex_state = 4},
  [4456] = {.lex_state = 149, .external_lex_state = 4},
  [4457] = {.lex_state = 149, .external_lex_state = 4},
  [4458] = {.lex_state = 149, .external_lex_state = 4},
  [4459] = {.lex_state = 173, .external_lex_state = 4},
  [4460] = {.lex_state = 44},
  [4461] = {.lex_state = 149, .external_lex_state = 4},
  [4462] = {.lex_state = 32, .external_lex_state = 4},
  [4463] = {.lex_state = 149, .external_lex_state = 4},
  [4464] = {.lex_state = 138, .external_lex_state = 4},
  [4465] = {.lex_state = 14},
  [4466] = {.lex_state = 4},
  [4467] = {.lex_state = 173, .external_lex_state = 4},
  [4468] = {.lex_state = 149, .external_lex_state = 4},
  [4469] = {.lex_state = 149, .external_lex_state = 4},
  [4470] = {.lex_state = 176, .external_lex_state = 4},
  [4471] = {.lex_state = 173, .external_lex_state = 4},
  [4472] = {.lex_state = 17},
  [4473] = {.lex_state = 138, .external_lex_state = 4},
  [4474] = {.lex_state = 35, .external_lex_state = 4},
  [4475] = {.lex_state = 156, .external_lex_state = 4},
  [4476] = {.lex_state = 156, .external_lex_state = 4},
  [4477] = {.lex_state = 156, .external_lex_state = 4},
  [4478] = {.lex_state = 173, .external_lex_state = 4},
  [4479] = {.lex_state = 156, .external_lex_state = 4},
  [4480] = {.lex_state = 156, .external_lex_state = 4},
  [4481] = {.lex_state = 34, .external_lex_state = 4},
  [4482] = {.lex_state = 156, .external_lex_state = 4},
  [4483] = {.lex_state = 45},
  [4484] = {.lex_state = 173, .external_lex_state = 4},
  [4485] = {.lex_state = 174, .external_lex_state = 4},
  [4486] = {.lex_state = 156, .external_lex_state = 4},
  [4487] = {.lex_state = 173, .external_lex_state = 4},
  [4488] = {.lex_state = 34, .external_lex_state = 4},
  [4489] = {.lex_state = 156, .external_lex_state = 4},
  [4490] = {.lex_state = 173, .external_lex_state = 4},
  [4491] = {.lex_state = 173, .external_lex_state = 4},
  [4492] = {.lex_state = 156, .external_lex_state = 4},
  [4493] = {.lex_state = 156, .external_lex_state = 4},
  [4494] = {.lex_state = 34, .external_lex_state = 4},
  [4495] = {.lex_state = 173, .external_lex_state = 4},
  [4496] = {.lex_state = 156, .external_lex_state = 4},
  [4497] = {.lex_state = 173, .external_lex_state = 4},
  [4498] = {.lex_state = 84, .external_lex_state = 4},
  [4499] = {.lex_state = 161, .external_lex_state = 4},
  [4500] = {.lex_state = 138, .external_lex_state = 4},
  [4501] = {.lex_state = 138, .external_lex_state = 4},
  [4502] = {.lex_state = 138, .external_lex_state = 4},
  [4503] = {.lex_state = 138, .external_lex_state = 4},
  [4504] = {.lex_state = 138, .external_lex_state = 4},
  [4505] = {.lex_state = 138, .external_lex_state = 4},
  [4506] = {.lex_state = 160, .external_lex_state = 4},
  [4507] = {.lex_state = 173, .external_lex_state = 4},
  [4508] = {.lex_state = 138, .external_lex_state = 4},
  [4509] = {.lex_state = 138, .external_lex_state = 4},
  [4510] = {.lex_state = 138, .external_lex_state = 4},
  [4511] = {.lex_state = 34, .external_lex_state = 4},
  [4512] = {.lex_state = 34, .external_lex_state = 4},
  [4513] = {.lex_state = 34, .external_lex_state = 4},
  [4514] = {.lex_state = 34, .external_lex_state = 4},
  [4515] = {.lex_state = 34, .external_lex_state = 4},
  [4516] = {.lex_state = 34, .external_lex_state = 4},
  [4517] = {.lex_state = 34, .external_lex_state = 4},
  [4518] = {.lex_state = 156, .external_lex_state = 4},
  [4519] = {.lex_state = 65, .external_lex_state = 4},
  [4520] = {.lex_state = 87, .external_lex_state = 4},
  [4521] = {.lex_state = 34, .external_lex_state = 4},
  [4522] = {.lex_state = 34, .external_lex_state = 4},
  [4523] = {.lex_state = 34, .external_lex_state = 4},
  [4524] = {.lex_state = 138, .external_lex_state = 4},
  [4525] = {.lex_state = 107, .external_lex_state = 4},
  [4526] = {.lex_state = 138, .external_lex_state = 4},
  [4527] = {.lex_state = 51, .external_lex_state = 4},
  [4528] = {.lex_state = 6},
  [4529] = {.lex_state = 149, .external_lex_state = 4},
  [4530] = {.lex_state = 140},
  [4531] = {.lex_state = 19},
  [4532] = {.lex_state = 32, .external_lex_state = 4},
  [4533] = {.lex_state = 51, .external_lex_state = 4},
  [4534] = {.lex_state = 51, .external_lex_state = 4},
  [4535] = {.lex_state = 51, .external_lex_state = 4},
  [4536] = {.lex_state = 19},
  [4537] = {.lex_state = 51, .external_lex_state = 4},
  [4538] = {.lex_state = 19},
  [4539] = {.lex_state = 51, .external_lex_state = 4},
  [4540] = {.lex_state = 51, .external_lex_state = 4},
  [4541] = {.lex_state = 51, .external_lex_state = 4},
  [4542] = {.lex_state = 51, .external_lex_state = 4},
  [4543] = {.lex_state = 51, .external_lex_state = 4},
  [4544] = {.lex_state = 51, .external_lex_state = 4},
  [4545] = {.lex_state = 19},
  [4546] = {.lex_state = 19},
  [4547] = {.lex_state = 19},
  [4548] = {.lex_state = 19},
  [4549] = {.lex_state = 19},
  [4550] = {.lex_state = 19},
  [4551] = {.lex_state = 19},
  [4552] = {.lex_state = 19},
  [4553] = {.lex_state = 173, .external_lex_state = 4},
  [4554] = {.lex_state = 118, .external_lex_state = 4},
  [4555] = {.lex_state = 9},
  [4556] = {.lex_state = 173, .external_lex_state = 4},
  [4557] = {.lex_state = 107, .external_lex_state = 4},
  [4558] = {.lex_state = 19},
  [4559] = {.lex_state = 19},
  [4560] = {.lex_state = 23},
  [4561] = {.lex_state = 138, .external_lex_state = 4},
  [4562] = {.lex_state = 158, .external_lex_state = 4},
  [4563] = {.lex_state = 157, .external_lex_state = 4},
  [4564] = {.lex_state = 53, .external_lex_state = 4},
  [4565] = {.lex_state = 19},
  [4566] = {.lex_state = 17, .external_lex_state = 4},
  [4567] = {.lex_state = 51, .external_lex_state = 4},
  [4568] = {.lex_state = 4},
  [4569] = {.lex_state = 51, .external_lex_state = 4},
  [4570] = {.lex_state = 85, .external_lex_state = 4},
  [4571] = {.lex_state = 53, .external_lex_state = 4},
  [4572] = {.lex_state = 17, .external_lex_state = 4},
  [4573] = {.lex_state = 17, .external_lex_state = 4},
  [4574] = {.lex_state = 4},
  [4575] = {.lex_state = 53, .external_lex_state = 4},
  [4576] = {.lex_state = 53, .external_lex_state = 4},
  [4577] = {.lex_state = 53, .external_lex_state = 4},
  [4578] = {.lex_state = 53, .external_lex_state = 4},
  [4579] = {.lex_state = 53, .external_lex_state = 4},
  [4580] = {.lex_state = 53, .external_lex_state = 4},
  [4581] = {.lex_state = 53, .external_lex_state = 4},
  [4582] = {.lex_state = 53, .external_lex_state = 4},
  [4583] = {.lex_state = 53, .external_lex_state = 4},
  [4584] = {.lex_state = 155, .external_lex_state = 4},
  [4585] = {.lex_state = 155, .external_lex_state = 4},
  [4586] = {.lex_state = 155, .external_lex_state = 4},
  [4587] = {.lex_state = 155, .external_lex_state = 4},
  [4588] = {.lex_state = 155, .external_lex_state = 4},
  [4589] = {.lex_state = 155, .external_lex_state = 4},
  [4590] = {.lex_state = 160, .external_lex_state = 4},
  [4591] = {.lex_state = 173, .external_lex_state = 4},
  [4592] = {.lex_state = 155, .external_lex_state = 4},
  [4593] = {.lex_state = 155, .external_lex_state = 4},
  [4594] = {.lex_state = 155, .external_lex_state = 4},
  [4595] = {.lex_state = 155, .external_lex_state = 4},
  [4596] = {.lex_state = 45},
  [4597] = {.lex_state = 155, .external_lex_state = 4},
  [4598] = {.lex_state = 155, .external_lex_state = 4},
  [4599] = {.lex_state = 160, .external_lex_state = 4},
  [4600] = {.lex_state = 53, .external_lex_state = 4},
  [4601] = {.lex_state = 51, .external_lex_state = 4},
  [4602] = {.lex_state = 53, .external_lex_state = 4},
  [4603] = {.lex_state = 138, .external_lex_state = 4},
  [4604] = {.lex_state = 155, .external_lex_state = 4},
  [4605] = {.lex_state = 155, .external_lex_state = 4},
  [4606] = {.lex_state = 53, .external_lex_state = 4},
  [4607] = {.lex_state = 24},
  [4608] = {.lex_state = 53, .external_lex_state = 4},
  [4609] = {.lex_state = 160, .external_lex_state = 4},
  [4610] = {.lex_state = 160, .external_lex_state = 4},
  [4611] = {.lex_state = 19},
  [4612] = {.lex_state = 162, .external_lex_state = 4},
  [4613] = {.lex_state = 160, .external_lex_state = 4},
  [4614] = {.lex_state = 160, .external_lex_state = 4},
  [4615] = {.lex_state = 160, .external_lex_state = 4},
  [4616] = {.lex_state = 160, .external_lex_state = 4},
  [4617] = {.lex_state = 160, .external_lex_state = 4},
  [4618] = {.lex_state = 160, .external_lex_state = 4},
  [4619] = {.lex_state = 160, .external_lex_state = 4},
  [4620] = {.lex_state = 139},
  [4621] = {.lex_state = 160, .external_lex_state = 4},
  [4622] = {.lex_state = 155, .external_lex_state = 4},
  [4623] = {.lex_state = 160, .external_lex_state = 4},
  [4624] = {.lex_state = 160, .external_lex_state = 4},
  [4625] = {.lex_state = 48},
  [4626] = {.lex_state = 54, .external_lex_state = 4},
  [4627] = {.lex_state = 162, .external_lex_state = 4},
  [4628] = {.lex_state = 162, .external_lex_state = 4},
  [4629] = {.lex_state = 162, .external_lex_state = 4},
  [4630] = {.lex_state = 21},
  [4631] = {.lex_state = 162, .external_lex_state = 4},
  [4632] = {.lex_state = 162, .external_lex_state = 4},
  [4633] = {.lex_state = 21},
  [4634] = {.lex_state = 21},
  [4635] = {.lex_state = 162, .external_lex_state = 4},
  [4636] = {.lex_state = 162, .external_lex_state = 4},
  [4637] = {.lex_state = 162, .external_lex_state = 4},
  [4638] = {.lex_state = 162, .external_lex_state = 4},
  [4639] = {.lex_state = 162, .external_lex_state = 4},
  [4640] = {.lex_state = 162, .external_lex_state = 4},
  [4641] = {.lex_state = 162, .external_lex_state = 4},
  [4642] = {.lex_state = 162, .external_lex_state = 4},
  [4643] = {.lex_state = 162, .external_lex_state = 4},
  [4644] = {.lex_state = 86, .external_lex_state = 4},
  [4645] = {.lex_state = 159, .external_lex_state = 4},
  [4646] = {.lex_state = 45},
  [4647] = {.lex_state = 24},
  [4648] = {.lex_state = 106, .external_lex_state = 4},
  [4649] = {.lex_state = 157, .external_lex_state = 4},
  [4650] = {.lex_state = 157, .external_lex_state = 4},
  [4651] = {.lex_state = 139},
  [4652] = {.lex_state = 157, .external_lex_state = 4},
  [4653] = {.lex_state = 139},
  [4654] = {.lex_state = 157, .external_lex_state = 4},
  [4655] = {.lex_state = 157, .external_lex_state = 4},
  [4656] = {.lex_state = 157, .external_lex_state = 4},
  [4657] = {.lex_state = 157, .external_lex_state = 4},
  [4658] = {.lex_state = 157, .external_lex_state = 4},
  [4659] = {.lex_state = 157, .external_lex_state = 4},
  [4660] = {.lex_state = 157, .external_lex_state = 4},
  [4661] = {.lex_state = 157, .external_lex_state = 4},
  [4662] = {.lex_state = 139},
  [4663] = {.lex_state = 162},
  [4664] = {.lex_state = 139},
  [4665] = {.lex_state = 21},
  [4666] = {.lex_state = 21},
  [4667] = {.lex_state = 139},
  [4668] = {.lex_state = 21},
  [4669] = {.lex_state = 21},
  [4670] = {.lex_state = 21},
  [4671] = {.lex_state = 21},
  [4672] = {.lex_state = 21},
  [4673] = {.lex_state = 21},
  [4674] = {.lex_state = 21},
  [4675] = {.lex_state = 21},
  [4676] = {.lex_state = 107, .external_lex_state = 4},
  [4677] = {.lex_state = 9},
  [4678] = {.lex_state = 55, .external_lex_state = 4},
  [4679] = {.lex_state = 21},
  [4680] = {.lex_state = 44},
  [4681] = {.lex_state = 140},
  [4682] = {.lex_state = 158, .external_lex_state = 4},
  [4683] = {.lex_state = 3},
  [4684] = {.lex_state = 140},
  [4685] = {.lex_state = 158, .external_lex_state = 4},
  [4686] = {.lex_state = 158, .external_lex_state = 4},
  [4687] = {.lex_state = 158, .external_lex_state = 4},
  [4688] = {.lex_state = 6},
  [4689] = {.lex_state = 158, .external_lex_state = 4},
  [4690] = {.lex_state = 139},
  [4691] = {.lex_state = 139},
  [4692] = {.lex_state = 158, .external_lex_state = 4},
  [4693] = {.lex_state = 158, .external_lex_state = 4},
  [4694] = {.lex_state = 158, .external_lex_state = 4},
  [4695] = {.lex_state = 139},
  [4696] = {.lex_state = 158, .external_lex_state = 4},
  [4697] = {.lex_state = 158, .external_lex_state = 4},
  [4698] = {.lex_state = 158, .external_lex_state = 4},
  [4699] = {.lex_state = 157, .external_lex_state = 4},
  [4700] = {.lex_state = 24, .external_lex_state = 4},
  [4701] = {.lex_state = 26},
  [4702] = {.lex_state = 139},
  [4703] = {.lex_state = 139},
  [4704] = {.lex_state = 157, .external_lex_state = 4},
  [4705] = {.lex_state = 16},
  [4706] = {.lex_state = 24},
  [4707] = {.lex_state = 24},
  [4708] = {.lex_state = 158, .external_lex_state = 4},
  [4709] = {.lex_state = 22},
  [4710] = {.lex_state = 139},
  [4711] = {.lex_state = 139},
  [4712] = {.lex_state = 23},
  [4713] = {.lex_state = 9},
  [4714] = {.lex_state = 158, .external_lex_state = 4},
  [4715] = {.lex_state = 139},
  [4716] = {.lex_state = 139},
  [4717] = {.lex_state = 140},
  [4718] = {.lex_state = 161, .external_lex_state = 4},
  [4719] = {.lex_state = 140},
  [4720] = {.lex_state = 161, .external_lex_state = 4},
  [4721] = {.lex_state = 24},
  [4722] = {.lex_state = 24},
  [4723] = {.lex_state = 24},
  [4724] = {.lex_state = 24},
  [4725] = {.lex_state = 24},
  [4726] = {.lex_state = 24},
  [4727] = {.lex_state = 140},
  [4728] = {.lex_state = 139},
  [4729] = {.lex_state = 24},
  [4730] = {.lex_state = 24},
  [4731] = {.lex_state = 24},
  [4732] = {.lex_state = 24},
  [4733] = {.lex_state = 23},
  [4734] = {.lex_state = 141},
  [4735] = {.lex_state = 24},
  [4736] = {.lex_state = 88},
  [4737] = {.lex_state = 23},
  [4738] = {.lex_state = 108, .external_lex_state = 4},
  [4739] = {.lex_state = 140},
  [4740] = {.lex_state = 17},
  [4741] = {.lex_state = 23},
  [4742] = {.lex_state = 23},
  [4743] = {.lex_state = 164},
  [4744] = {.lex_state = 140},
  [4745] = {.lex_state = 17, .external_lex_state = 4},
  [4746] = {.lex_state = 23},
  [4747] = {.lex_state = 23},
  [4748] = {.lex_state = 140},
  [4749] = {.lex_state = 23},
  [4750] = {.lex_state = 23},
  [4751] = {.lex_state = 23},
  [4752] = {.lex_state = 23},
  [4753] = {.lex_state = 23},
  [4754] = {.lex_state = 151},
  [4755] = {.lex_state = 140},
  [4756] = {.lex_state = 66},
  [4757] = {.lex_state = 23},
  [4758] = {.lex_state = 140},
  [4759] = {.lex_state = 67},
  [4760] = {.lex_state = 23},
  [4761] = {.lex_state = 140},
  [4762] = {.lex_state = 140},
  [4763] = {.lex_state = 140},
  [4764] = {.lex_state = 6},
  [4765] = {.lex_state = 140},
  [4766] = {.lex_state = 140},
  [4767] = {.lex_state = 157, .external_lex_state = 4},
  [4768] = {.lex_state = 165},
  [4769] = {.lex_state = 162, .external_lex_state = 4},
  [4770] = {.lex_state = 23},
  [4771] = {.lex_state = 161, .external_lex_state = 4},
  [4772] = {.lex_state = 67},
  [4773] = {.lex_state = 52, .external_lex_state = 4},
  [4774] = {.lex_state = 158, .external_lex_state = 4},
  [4775] = {.lex_state = 176, .external_lex_state = 4},
  [4776] = {.lex_state = 14},
  [4777] = {.lex_state = 108, .external_lex_state = 4},
  [4778] = {.lex_state = 89},
  [4779] = {.lex_state = 12},
  [4780] = {.lex_state = 54, .external_lex_state = 4},
  [4781] = {.lex_state = 90},
  [4782] = {.lex_state = 91},
  [4783] = {.lex_state = 109, .external_lex_state = 4},
  [4784] = {.lex_state = 174, .external_lex_state = 4},
  [4785] = {.lex_state = 35, .external_lex_state = 4},
  [4786] = {.lex_state = 74, .external_lex_state = 4},
  [4787] = {.lex_state = 35, .external_lex_state = 4},
  [4788] = {.lex_state = 35, .external_lex_state = 4},
  [4789] = {.lex_state = 20},
  [4790] = {.lex_state = 35, .external_lex_state = 4},
  [4791] = {.lex_state = 177, .external_lex_state = 4},
  [4792] = {.lex_state = 35, .external_lex_state = 4},
  [4793] = {.lex_state = 35, .external_lex_state = 4},
  [4794] = {.lex_state = 35, .external_lex_state = 4},
  [4795] = {.lex_state = 35, .external_lex_state = 4},
  [4796] = {.lex_state = 6},
  [4797] = {.lex_state = 35, .external_lex_state = 4},
  [4798] = {.lex_state = 14},
  [4799] = {.lex_state = 174, .external_lex_state = 4},
  [4800] = {.lex_state = 35, .external_lex_state = 4},
  [4801] = {.lex_state = 174, .external_lex_state = 4},
  [4802] = {.lex_state = 35, .external_lex_state = 4},
  [4803] = {.lex_state = 174, .external_lex_state = 4},
  [4804] = {.lex_state = 174, .external_lex_state = 4},
  [4805] = {.lex_state = 174, .external_lex_state = 4},
  [4806] = {.lex_state = 174, .external_lex_state = 4},
  [4807] = {.lex_state = 174, .external_lex_state = 4},
  [4808] = {.lex_state = 174, .external_lex_state = 4},
  [4809] = {.lex_state = 174, .external_lex_state = 4},
  [4810] = {.lex_state = 174, .external_lex_state = 4},
  [4811] = {.lex_state = 161, .external_lex_state = 4},
  [4812] = {.lex_state = 161, .external_lex_state = 4},
  [4813] = {.lex_state = 14},
  [4814] = {.lex_state = 35, .external_lex_state = 4},
  [4815] = {.lex_state = 167},
  [4816] = {.lex_state = 35, .external_lex_state = 4},
  [4817] = {.lex_state = 77, .external_lex_state = 4},
  [4818] = {.lex_state = 87, .external_lex_state = 4},
  [4819] = {.lex_state = 161, .external_lex_state = 4},
  [4820] = {.lex_state = 161, .external_lex_state = 4},
  [4821] = {.lex_state = 161, .external_lex_state = 4},
  [4822] = {.lex_state = 150},
  [4823] = {.lex_state = 166},
  [4824] = {.lex_state = 174, .external_lex_state = 4},
  [4825] = {.lex_state = 86},
  [4826] = {.lex_state = 174, .external_lex_state = 4},
  [4827] = {.lex_state = 161, .external_lex_state = 4},
  [4828] = {.lex_state = 161, .external_lex_state = 4},
  [4829] = {.lex_state = 20},
  [4830] = {.lex_state = 161, .external_lex_state = 4},
  [4831] = {.lex_state = 176, .external_lex_state = 4},
  [4832] = {.lex_state = 176, .external_lex_state = 4},
  [4833] = {.lex_state = 161, .external_lex_state = 4},
  [4834] = {.lex_state = 161, .external_lex_state = 4},
  [4835] = {.lex_state = 175, .external_lex_state = 4},
  [4836] = {.lex_state = 75, .external_lex_state = 4},
  [4837] = {.lex_state = 176, .external_lex_state = 4},
  [4838] = {.lex_state = 161, .external_lex_state = 4},
  [4839] = {.lex_state = 35, .external_lex_state = 4},
  [4840] = {.lex_state = 74, .external_lex_state = 4},
  [4841] = {.lex_state = 88},
  [4842] = {.lex_state = 52, .external_lex_state = 4},
  [4843] = {.lex_state = 176, .external_lex_state = 4},
  [4844] = {.lex_state = 74, .external_lex_state = 4},
  [4845] = {.lex_state = 48},
  [4846] = {.lex_state = 52, .external_lex_state = 4},
  [4847] = {.lex_state = 176, .external_lex_state = 4},
  [4848] = {.lex_state = 74, .external_lex_state = 4},
  [4849] = {.lex_state = 174, .external_lex_state = 4},
  [4850] = {.lex_state = 176, .external_lex_state = 4},
  [4851] = {.lex_state = 176, .external_lex_state = 4},
  [4852] = {.lex_state = 74, .external_lex_state = 4},
  [4853] = {.lex_state = 176, .external_lex_state = 4},
  [4854] = {.lex_state = 176, .external_lex_state = 4},
  [4855] = {.lex_state = 176, .external_lex_state = 4},
  [4856] = {.lex_state = 74, .external_lex_state = 4},
  [4857] = {.lex_state = 74, .external_lex_state = 4},
  [4858] = {.lex_state = 161, .external_lex_state = 4},
  [4859] = {.lex_state = 74, .external_lex_state = 4},
  [4860] = {.lex_state = 54, .external_lex_state = 4},
  [4861] = {.lex_state = 74, .external_lex_state = 4},
  [4862] = {.lex_state = 54, .external_lex_state = 4},
  [4863] = {.lex_state = 74, .external_lex_state = 4},
  [4864] = {.lex_state = 74, .external_lex_state = 4},
  [4865] = {.lex_state = 89},
  [4866] = {.lex_state = 74, .external_lex_state = 4},
  [4867] = {.lex_state = 54, .external_lex_state = 4},
  [4868] = {.lex_state = 54, .external_lex_state = 4},
  [4869] = {.lex_state = 74, .external_lex_state = 4},
  [4870] = {.lex_state = 52, .external_lex_state = 4},
  [4871] = {.lex_state = 176, .external_lex_state = 4},
  [4872] = {.lex_state = 74, .external_lex_state = 4},
  [4873] = {.lex_state = 66},
  [4874] = {.lex_state = 54, .external_lex_state = 4},
  [4875] = {.lex_state = 20},
  [4876] = {.lex_state = 14, .external_lex_state = 4},
  [4877] = {.lex_state = 54, .external_lex_state = 4},
  [4878] = {.lex_state = 90},
  [4879] = {.lex_state = 49},
  [4880] = {.lex_state = 54, .external_lex_state = 4},
  [4881] = {.lex_state = 52, .external_lex_state = 4},
  [4882] = {.lex_state = 52, .external_lex_state = 4},
  [4883] = {.lex_state = 52, .external_lex_state = 4},
  [4884] = {.lex_state = 176, .external_lex_state = 4},
  [4885] = {.lex_state = 54, .external_lex_state = 4},
  [4886] = {.lex_state = 54, .external_lex_state = 4},
  [4887] = {.lex_state = 52, .external_lex_state = 4},
  [4888] = {.lex_state = 52, .external_lex_state = 4},
  [4889] = {.lex_state = 54, .external_lex_state = 4},
  [4890] = {.lex_state = 35, .external_lex_state = 4},
  [4891] = {.lex_state = 163, .external_lex_state = 4},
  [4892] = {.lex_state = 52, .external_lex_state = 4},
  [4893] = {.lex_state = 91},
  [4894] = {.lex_state = 52, .external_lex_state = 4},
  [4895] = {.lex_state = 158, .external_lex_state = 4},
  [4896] = {.lex_state = 176, .external_lex_state = 4},
  [4897] = {.lex_state = 52, .external_lex_state = 4},
  [4898] = {.lex_state = 74, .external_lex_state = 4},
  [4899] = {.lex_state = 54, .external_lex_state = 4},
  [4900] = {.lex_state = 109, .external_lex_state = 4},
  [4901] = {.lex_state = 54, .external_lex_state = 4},
  [4902] = {.lex_state = 20},
  [4903] = {.lex_state = 176, .external_lex_state = 4},
  [4904] = {.lex_state = 49},
  [4905] = {.lex_state = 52, .external_lex_state = 4},
  [4906] = {.lex_state = 52, .external_lex_state = 4},
  [4907] = {.lex_state = 54, .external_lex_state = 4},
  [4908] = {.lex_state = 157, .external_lex_state = 4},
  [4909] = {.lex_state = 86},
  [4910] = {.lex_state = 174, .external_lex_state = 4},
  [4911] = {.lex_state = 25},
  [4912] = {.lex_state = 9},
  [4913] = {.lex_state = 52, .external_lex_state = 4},
  [4914] = {.lex_state = 21},
  [4915] = {.lex_state = 96, .external_lex_state = 4},
  [4916] = {.lex_state = 24},
  [4917] = {.lex_state = 14, .external_lex_state = 4},
  [4918] = {.lex_state = 166},
  [4919] = {.lex_state = 184},
  [4920] = {.lex_state = 150},
  [4921] = {.lex_state = 163, .external_lex_state = 4},
  [4922] = {.lex_state = 170},
  [4923] = {.lex_state = 25},
  [4924] = {.lex_state = 55, .external_lex_state = 4},
  [4925] = {.lex_state = 96, .external_lex_state = 4},
  [4926] = {.lex_state = 25},
  [4927] = {.lex_state = 25},
  [4928] = {.lex_state = 25},
  [4929] = {.lex_state = 25},
  [4930] = {.lex_state = 25},
  [4931] = {.lex_state = 25},
  [4932] = {.lex_state = 67},
  [4933] = {.lex_state = 25},
  [4934] = {.lex_state = 163, .external_lex_state = 4},
  [4935] = {.lex_state = 25},
  [4936] = {.lex_state = 25},
  [4937] = {.lex_state = 25},
  [4938] = {.lex_state = 163, .external_lex_state = 4},
  [4939] = {.lex_state = 25},
  [4940] = {.lex_state = 163, .external_lex_state = 4},
  [4941] = {.lex_state = 163, .external_lex_state = 4},
  [4942] = {.lex_state = 184},
  [4943] = {.lex_state = 95},
  [4944] = {.lex_state = 163, .external_lex_state = 4},
  [4945] = {.lex_state = 141},
  [4946] = {.lex_state = 75, .external_lex_state = 4},
  [4947] = {.lex_state = 75, .external_lex_state = 4},
  [4948] = {.lex_state = 75, .external_lex_state = 4},
  [4949] = {.lex_state = 75, .external_lex_state = 4},
  [4950] = {.lex_state = 75, .external_lex_state = 4},
  [4951] = {.lex_state = 96, .external_lex_state = 4},
  [4952] = {.lex_state = 75, .external_lex_state = 4},
  [4953] = {.lex_state = 25},
  [4954] = {.lex_state = 75, .external_lex_state = 4},
  [4955] = {.lex_state = 163, .external_lex_state = 4},
  [4956] = {.lex_state = 184},
  [4957] = {.lex_state = 75, .external_lex_state = 4},
  [4958] = {.lex_state = 184},
  [4959] = {.lex_state = 75, .external_lex_state = 4},
  [4960] = {.lex_state = 75, .external_lex_state = 4},
  [4961] = {.lex_state = 150},
  [4962] = {.lex_state = 184},
  [4963] = {.lex_state = 163, .external_lex_state = 4},
  [4964] = {.lex_state = 95, .external_lex_state = 4},
  [4965] = {.lex_state = 163, .external_lex_state = 4},
  [4966] = {.lex_state = 75, .external_lex_state = 4},
  [4967] = {.lex_state = 163, .external_lex_state = 4},
  [4968] = {.lex_state = 177},
  [4969] = {.lex_state = 184},
  [4970] = {.lex_state = 163, .external_lex_state = 4},
  [4971] = {.lex_state = 66},
  [4972] = {.lex_state = 164},
  [4973] = {.lex_state = 150},
  [4974] = {.lex_state = 150},
  [4975] = {.lex_state = 109, .external_lex_state = 4},
  [4976] = {.lex_state = 150},
  [4977] = {.lex_state = 150},
  [4978] = {.lex_state = 95, .external_lex_state = 4},
  [4979] = {.lex_state = 150},
  [4980] = {.lex_state = 96, .external_lex_state = 4},
  [4981] = {.lex_state = 150},
  [4982] = {.lex_state = 163, .external_lex_state = 4},
  [4983] = {.lex_state = 163, .external_lex_state = 4},
  [4984] = {.lex_state = 150},
  [4985] = {.lex_state = 150},
  [4986] = {.lex_state = 76, .external_lex_state = 4},
  [4987] = {.lex_state = 150},
  [4988] = {.lex_state = 184},
  [4989] = {.lex_state = 165},
  [4990] = {.lex_state = 165},
  [4991] = {.lex_state = 75, .external_lex_state = 4},
  [4992] = {.lex_state = 110},
  [4993] = {.lex_state = 168},
  [4994] = {.lex_state = 184},
  [4995] = {.lex_state = 184},
  [4996] = {.lex_state = 91},
  [4997] = {.lex_state = 167},
  [4998] = {.lex_state = 75, .external_lex_state = 4},
  [4999] = {.lex_state = 184},
  [5000] = {.lex_state = 175, .external_lex_state = 4},
  [5001] = {.lex_state = 177, .external_lex_state = 4},
  [5002] = {.lex_state = 171},
  [5003] = {.lex_state = 184},
  [5004] = {.lex_state = 77, .external_lex_state = 4},
  [5005] = {.lex_state = 96, .external_lex_state = 4},
  [5006] = {.lex_state = 142},
  [5007] = {.lex_state = 3},
  [5008] = {.lex_state = 77, .external_lex_state = 4},
  [5009] = {.lex_state = 184},
  [5010] = {.lex_state = 22},
  [5011] = {.lex_state = 167},
  [5012] = {.lex_state = 166},
  [5013] = {.lex_state = 175, .external_lex_state = 4},
  [5014] = {.lex_state = 175, .external_lex_state = 4},
  [5015] = {.lex_state = 175, .external_lex_state = 4},
  [5016] = {.lex_state = 72},
  [5017] = {.lex_state = 175, .external_lex_state = 4},
  [5018] = {.lex_state = 175, .external_lex_state = 4},
  [5019] = {.lex_state = 184},
  [5020] = {.lex_state = 22},
  [5021] = {.lex_state = 96, .external_lex_state = 4},
  [5022] = {.lex_state = 175, .external_lex_state = 4},
  [5023] = {.lex_state = 175, .external_lex_state = 4},
  [5024] = {.lex_state = 175, .external_lex_state = 4},
  [5025] = {.lex_state = 175, .external_lex_state = 4},
  [5026] = {.lex_state = 175, .external_lex_state = 4},
  [5027] = {.lex_state = 175, .external_lex_state = 4},
  [5028] = {.lex_state = 143},
  [5029] = {.lex_state = 96, .external_lex_state = 4},
  [5030] = {.lex_state = 96, .external_lex_state = 4},
  [5031] = {.lex_state = 96, .external_lex_state = 4},
  [5032] = {.lex_state = 96, .external_lex_state = 4},
  [5033] = {.lex_state = 184},
  [5034] = {.lex_state = 184},
  [5035] = {.lex_state = 96, .external_lex_state = 4},
  [5036] = {.lex_state = 96, .external_lex_state = 4},
  [5037] = {.lex_state = 96, .external_lex_state = 4},
  [5038] = {.lex_state = 96, .external_lex_state = 4},
  [5039] = {.lex_state = 162},
  [5040] = {.lex_state = 177, .external_lex_state = 4},
  [5041] = {.lex_state = 22},
  [5042] = {.lex_state = 22},
  [5043] = {.lex_state = 22},
  [5044] = {.lex_state = 90},
  [5045] = {.lex_state = 22},
  [5046] = {.lex_state = 22},
  [5047] = {.lex_state = 25},
  [5048] = {.lex_state = 184},
  [5049] = {.lex_state = 22},
  [5050] = {.lex_state = 95},
  [5051] = {.lex_state = 150},
  [5052] = {.lex_state = 22},
  [5053] = {.lex_state = 166},
  [5054] = {.lex_state = 150},
  [5055] = {.lex_state = 178},
  [5056] = {.lex_state = 22},
  [5057] = {.lex_state = 88},
  [5058] = {.lex_state = 165},
  [5059] = {.lex_state = 184},
  [5060] = {.lex_state = 22},
  [5061] = {.lex_state = 166},
  [5062] = {.lex_state = 89},
  [5063] = {.lex_state = 166},
  [5064] = {.lex_state = 108},
  [5065] = {.lex_state = 164},
  [5066] = {.lex_state = 184},
  [5067] = {.lex_state = 22},
  [5068] = {.lex_state = 167},
  [5069] = {.lex_state = 22},
  [5070] = {.lex_state = 163, .external_lex_state = 4},
  [5071] = {.lex_state = 77, .external_lex_state = 4},
  [5072] = {.lex_state = 184},
  [5073] = {.lex_state = 77, .external_lex_state = 4},
  [5074] = {.lex_state = 13},
  [5075] = {.lex_state = 78, .external_lex_state = 4},
  [5076] = {.lex_state = 167},
  [5077] = {.lex_state = 177, .external_lex_state = 4},
  [5078] = {.lex_state = 141},
  [5079] = {.lex_state = 20},
  [5080] = {.lex_state = 175, .external_lex_state = 4},
  [5081] = {.lex_state = 20},
  [5082] = {.lex_state = 96, .external_lex_state = 4},
  [5083] = {.lex_state = 20},
  [5084] = {.lex_state = 20},
  [5085] = {.lex_state = 177, .external_lex_state = 4},
  [5086] = {.lex_state = 20},
  [5087] = {.lex_state = 21},
  [5088] = {.lex_state = 20},
  [5089] = {.lex_state = 184},
  [5090] = {.lex_state = 175, .external_lex_state = 4},
  [5091] = {.lex_state = 177, .external_lex_state = 4},
  [5092] = {.lex_state = 177, .external_lex_state = 4},
  [5093] = {.lex_state = 177, .external_lex_state = 4},
  [5094] = {.lex_state = 177, .external_lex_state = 4},
  [5095] = {.lex_state = 20},
  [5096] = {.lex_state = 177, .external_lex_state = 4},
  [5097] = {.lex_state = 20},
  [5098] = {.lex_state = 177, .external_lex_state = 4},
  [5099] = {.lex_state = 25},
  [5100] = {.lex_state = 20},
  [5101] = {.lex_state = 20},
  [5102] = {.lex_state = 177, .external_lex_state = 4},
  [5103] = {.lex_state = 25, .external_lex_state = 4},
  [5104] = {.lex_state = 177, .external_lex_state = 4},
  [5105] = {.lex_state = 77, .external_lex_state = 4},
  [5106] = {.lex_state = 75, .external_lex_state = 4},
  [5107] = {.lex_state = 177, .external_lex_state = 4},
  [5108] = {.lex_state = 177, .external_lex_state = 4},
  [5109] = {.lex_state = 77, .external_lex_state = 4},
  [5110] = {.lex_state = 184},
  [5111] = {.lex_state = 77, .external_lex_state = 4},
  [5112] = {.lex_state = 73},
  [5113] = {.lex_state = 166},
  [5114] = {.lex_state = 166},
  [5115] = {.lex_state = 77, .external_lex_state = 4},
  [5116] = {.lex_state = 151},
  [5117] = {.lex_state = 96, .external_lex_state = 4},
  [5118] = {.lex_state = 166},
  [5119] = {.lex_state = 77, .external_lex_state = 4},
  [5120] = {.lex_state = 77, .external_lex_state = 4},
  [5121] = {.lex_state = 184},
  [5122] = {.lex_state = 166},
  [5123] = {.lex_state = 166},
  [5124] = {.lex_state = 166},
  [5125] = {.lex_state = 77, .external_lex_state = 4},
  [5126] = {.lex_state = 77, .external_lex_state = 4},
  [5127] = {.lex_state = 108},
  [5128] = {.lex_state = 22},
  [5129] = {.lex_state = 77, .external_lex_state = 4},
  [5130] = {.lex_state = 26, .external_lex_state = 4},
  [5131] = {.lex_state = 16, .external_lex_state = 4},
  [5132] = {.lex_state = 77, .external_lex_state = 4},
  [5133] = {.lex_state = 166},
  [5134] = {.lex_state = 77, .external_lex_state = 4},
  [5135] = {.lex_state = 24, .external_lex_state = 4},
  [5136] = {.lex_state = 166},
  [5137] = {.lex_state = 184},
  [5138] = {.lex_state = 166},
  [5139] = {.lex_state = 166},
  [5140] = {.lex_state = 86},
  [5141] = {.lex_state = 164},
  [5142] = {.lex_state = 163, .external_lex_state = 4},
  [5143] = {.lex_state = 16},
  [5144] = {.lex_state = 7},
  [5145] = {.lex_state = 184},
  [5146] = {.lex_state = 165},
  [5147] = {.lex_state = 177, .external_lex_state = 4},
  [5148] = {.lex_state = 165},
  [5149] = {.lex_state = 151},
  [5150] = {.lex_state = 167},
  [5151] = {.lex_state = 167},
  [5152] = {.lex_state = 151},
  [5153] = {.lex_state = 151},
  [5154] = {.lex_state = 151},
  [5155] = {.lex_state = 151},
  [5156] = {.lex_state = 151},
  [5157] = {.lex_state = 110},
  [5158] = {.lex_state = 151},
  [5159] = {.lex_state = 167},
  [5160] = {.lex_state = 151},
  [5161] = {.lex_state = 73},
  [5162] = {.lex_state = 184},
  [5163] = {.lex_state = 151},
  [5164] = {.lex_state = 184},
  [5165] = {.lex_state = 167},
  [5166] = {.lex_state = 184},
  [5167] = {.lex_state = 184},
  [5168] = {.lex_state = 151},
  [5169] = {.lex_state = 167},
  [5170] = {.lex_state = 175, .external_lex_state = 4},
  [5171] = {.lex_state = 167},
  [5172] = {.lex_state = 151},
  [5173] = {.lex_state = 167},
  [5174] = {.lex_state = 167},
  [5175] = {.lex_state = 167},
  [5176] = {.lex_state = 167},
  [5177] = {.lex_state = 12},
  [5178] = {.lex_state = 151},
  [5179] = {.lex_state = 72},
  [5180] = {.lex_state = 151},
  [5181] = {.lex_state = 169},
  [5182] = {.lex_state = 20},
  [5183] = {.lex_state = 167},
  [5184] = {.lex_state = 164},
  [5185] = {.lex_state = 164},
  [5186] = {.lex_state = 20},
  [5187] = {.lex_state = 55, .external_lex_state = 4},
  [5188] = {.lex_state = 108, .external_lex_state = 4},
  [5189] = {.lex_state = 165},
  [5190] = {.lex_state = 111},
  [5191] = {.lex_state = 16, .external_lex_state = 4},
  [5192] = {.lex_state = 150},
  [5193] = {.lex_state = 163},
  [5194] = {.lex_state = 3},
  [5195] = {.lex_state = 184},
  [5196] = {.lex_state = 165},
  [5197] = {.lex_state = 162},
  [5198] = {.lex_state = 20},
  [5199] = {.lex_state = 184},
  [5200] = {.lex_state = 112},
  [5201] = {.lex_state = 24, .external_lex_state = 4},
  [5202] = {.lex_state = 150},
  [5203] = {.lex_state = 24, .external_lex_state = 4},
  [5204] = {.lex_state = 151},
  [5205] = {.lex_state = 12},
  [5206] = {.lex_state = 24, .external_lex_state = 4},
  [5207] = {.lex_state = 24, .external_lex_state = 4},
  [5208] = {.lex_state = 24, .external_lex_state = 4},
  [5209] = {.lex_state = 24, .external_lex_state = 4},
  [5210] = {.lex_state = 113},
  [5211] = {.lex_state = 165},
  [5212] = {.lex_state = 24, .external_lex_state = 4},
  [5213] = {.lex_state = 24, .external_lex_state = 4},
  [5214] = {.lex_state = 184},
  [5215] = {.lex_state = 165},
  [5216] = {.lex_state = 180},
  [5217] = {.lex_state = 20},
  [5218] = {.lex_state = 24, .external_lex_state = 4},
  [5219] = {.lex_state = 24, .external_lex_state = 4},
  [5220] = {.lex_state = 24, .external_lex_state = 4},
  [5221] = {.lex_state = 26},
  [5222] = {.lex_state = 181},
  [5223] = {.lex_state = 184},
  [5224] = {.lex_state = 111},
  [5225] = {.lex_state = 179},
  [5226] = {.lex_state = 75, .external_lex_state = 4},
  [5227] = {.lex_state = 112},
  [5228] = {.lex_state = 24, .external_lex_state = 4},
  [5229] = {.lex_state = 162},
  [5230] = {.lex_state = 26},
  [5231] = {.lex_state = 26},
  [5232] = {.lex_state = 26},
  [5233] = {.lex_state = 26},
  [5234] = {.lex_state = 26},
  [5235] = {.lex_state = 55, .external_lex_state = 4},
  [5236] = {.lex_state = 26},
  [5237] = {.lex_state = 20},
  [5238] = {.lex_state = 26},
  [5239] = {.lex_state = 113},
  [5240] = {.lex_state = 26},
  [5241] = {.lex_state = 184},
  [5242] = {.lex_state = 159, .external_lex_state = 4},
  [5243] = {.lex_state = 26},
  [5244] = {.lex_state = 184},
  [5245] = {.lex_state = 55, .external_lex_state = 4},
  [5246] = {.lex_state = 26},
  [5247] = {.lex_state = 26},
  [5248] = {.lex_state = 55, .external_lex_state = 4},
  [5249] = {.lex_state = 26},
  [5250] = {.lex_state = 55, .external_lex_state = 4},
  [5251] = {.lex_state = 37},
  [5252] = {.lex_state = 16},
  [5253] = {.lex_state = 26},
  [5254] = {.lex_state = 159, .external_lex_state = 4},
  [5255] = {.lex_state = 26},
  [5256] = {.lex_state = 55, .external_lex_state = 4},
  [5257] = {.lex_state = 184},
  [5258] = {.lex_state = 55, .external_lex_state = 4},
  [5259] = {.lex_state = 55, .external_lex_state = 4},
  [5260] = {.lex_state = 55, .external_lex_state = 4},
  [5261] = {.lex_state = 55, .external_lex_state = 4},
  [5262] = {.lex_state = 159, .external_lex_state = 4},
  [5263] = {.lex_state = 55, .external_lex_state = 4},
  [5264] = {.lex_state = 184},
  [5265] = {.lex_state = 165},
  [5266] = {.lex_state = 159, .external_lex_state = 4},
  [5267] = {.lex_state = 184},
  [5268] = {.lex_state = 99, .external_lex_state = 4},
  [5269] = {.lex_state = 141},
  [5270] = {.lex_state = 159, .external_lex_state = 4},
  [5271] = {.lex_state = 165},
  [5272] = {.lex_state = 184},
  [5273] = {.lex_state = 55, .external_lex_state = 4},
  [5274] = {.lex_state = 159, .external_lex_state = 4},
  [5275] = {.lex_state = 184},
  [5276] = {.lex_state = 159, .external_lex_state = 4},
  [5277] = {.lex_state = 159, .external_lex_state = 4},
  [5278] = {.lex_state = 159, .external_lex_state = 4},
  [5279] = {.lex_state = 159, .external_lex_state = 4},
  [5280] = {.lex_state = 159, .external_lex_state = 4},
  [5281] = {.lex_state = 165},
  [5282] = {.lex_state = 55, .external_lex_state = 4},
  [5283] = {.lex_state = 184},
  [5284] = {.lex_state = 16},
  [5285] = {.lex_state = 22},
  [5286] = {.lex_state = 12},
  [5287] = {.lex_state = 141},
  [5288] = {.lex_state = 165},
  [5289] = {.lex_state = 36},
  [5290] = {.lex_state = 24, .external_lex_state = 4},
  [5291] = {.lex_state = 141},
  [5292] = {.lex_state = 184},
  [5293] = {.lex_state = 141},
  [5294] = {.lex_state = 141},
  [5295] = {.lex_state = 3},
  [5296] = {.lex_state = 141},
  [5297] = {.lex_state = 141},
  [5298] = {.lex_state = 141},
  [5299] = {.lex_state = 141},
  [5300] = {.lex_state = 141},
  [5301] = {.lex_state = 49},
  [5302] = {.lex_state = 3},
  [5303] = {.lex_state = 184},
  [5304] = {.lex_state = 141},
  [5305] = {.lex_state = 162},
  [5306] = {.lex_state = 162},
  [5307] = {.lex_state = 159, .external_lex_state = 4},
  [5308] = {.lex_state = 48},
  [5309] = {.lex_state = 3},
  [5310] = {.lex_state = 3},
  [5311] = {.lex_state = 3},
  [5312] = {.lex_state = 3},
  [5313] = {.lex_state = 3},
  [5314] = {.lex_state = 3},
  [5315] = {.lex_state = 3},
  [5316] = {.lex_state = 3},
  [5317] = {.lex_state = 3},
  [5318] = {.lex_state = 3},
  [5319] = {.lex_state = 3},
  [5320] = {.lex_state = 162},
  [5321] = {.lex_state = 162},
  [5322] = {.lex_state = 162},
  [5323] = {.lex_state = 162},
  [5324] = {.lex_state = 141},
  [5325] = {.lex_state = 162},
  [5326] = {.lex_state = 184},
  [5327] = {.lex_state = 162},
  [5328] = {.lex_state = 162},
  [5329] = {.lex_state = 162},
  [5330] = {.lex_state = 162},
  [5331] = {.lex_state = 97, .external_lex_state = 4},
  [5332] = {.lex_state = 184},
  [5333] = {.lex_state = 162},
  [5334] = {.lex_state = 55, .external_lex_state = 4},
  [5335] = {.lex_state = 24, .external_lex_state = 4},
  [5336] = {.lex_state = 164},
  [5337] = {.lex_state = 164},
  [5338] = {.lex_state = 164},
  [5339] = {.lex_state = 164},
  [5340] = {.lex_state = 164},
  [5341] = {.lex_state = 164},
  [5342] = {.lex_state = 164},
  [5343] = {.lex_state = 164},
  [5344] = {.lex_state = 164},
  [5345] = {.lex_state = 164},
  [5346] = {.lex_state = 184},
  [5347] = {.lex_state = 165},
  [5348] = {.lex_state = 159, .external_lex_state = 4},
  [5349] = {.lex_state = 5},
  [5350] = {.lex_state = 141},
  [5351] = {.lex_state = 14, .external_lex_state = 4},
  [5352] = {.lex_state = 159, .external_lex_state = 4},
  [5353] = {.lex_state = 184},
  [5354] = {.lex_state = 165},
  [5355] = {.lex_state = 159, .external_lex_state = 4},
  [5356] = {.lex_state = 184},
  [5357] = {.lex_state = 78, .external_lex_state = 4},
  [5358] = {.lex_state = 99, .external_lex_state = 4},
  [5359] = {.lex_state = 143},
  [5360] = {.lex_state = 163},
  [5361] = {.lex_state = 163},
  [5362] = {.lex_state = 163},
  [5363] = {.lex_state = 163},
  [5364] = {.lex_state = 7},
  [5365] = {.lex_state = 163},
  [5366] = {.lex_state = 142},
  [5367] = {.lex_state = 163},
  [5368] = {.lex_state = 76, .external_lex_state = 4},
  [5369] = {.lex_state = 7},
  [5370] = {.lex_state = 163},
  [5371] = {.lex_state = 7},
  [5372] = {.lex_state = 163},
  [5373] = {.lex_state = 7},
  [5374] = {.lex_state = 7},
  [5375] = {.lex_state = 163},
  [5376] = {.lex_state = 163},
  [5377] = {.lex_state = 7},
  [5378] = {.lex_state = 163},
  [5379] = {.lex_state = 13},
  [5380] = {.lex_state = 7},
  [5381] = {.lex_state = 7},
  [5382] = {.lex_state = 7},
  [5383] = {.lex_state = 7},
  [5384] = {.lex_state = 7},
  [5385] = {.lex_state = 7},
  [5386] = {.lex_state = 7},
  [5387] = {.lex_state = 163},
  [5388] = {.lex_state = 13},
  [5389] = {.lex_state = 13},
  [5390] = {.lex_state = 13},
  [5391] = {.lex_state = 13},
  [5392] = {.lex_state = 13},
  [5393] = {.lex_state = 13},
  [5394] = {.lex_state = 13},
  [5395] = {.lex_state = 143},
  [5396] = {.lex_state = 95},
  [5397] = {.lex_state = 13},
  [5398] = {.lex_state = 13},
  [5399] = {.lex_state = 13},
  [5400] = {.lex_state = 13},
  [5401] = {.lex_state = 13},
  [5402] = {.lex_state = 143},
  [5403] = {.lex_state = 57},
  [5404] = {.lex_state = 178},
  [5405] = {.lex_state = 13},
  [5406] = {.lex_state = 142},
  [5407] = {.lex_state = 78, .external_lex_state = 4},
  [5408] = {.lex_state = 142},
  [5409] = {.lex_state = 172, .external_lex_state = 4},
  [5410] = {.lex_state = 143},
  [5411] = {.lex_state = 143},
  [5412] = {.lex_state = 143},
  [5413] = {.lex_state = 143},
  [5414] = {.lex_state = 143},
  [5415] = {.lex_state = 163},
  [5416] = {.lex_state = 143},
  [5417] = {.lex_state = 143},
  [5418] = {.lex_state = 7},
  [5419] = {.lex_state = 143},
  [5420] = {.lex_state = 79},
  [5421] = {.lex_state = 143},
  [5422] = {.lex_state = 143},
  [5423] = {.lex_state = 143},
  [5424] = {.lex_state = 142},
  [5425] = {.lex_state = 142},
  [5426] = {.lex_state = 26},
  [5427] = {.lex_state = 142},
  [5428] = {.lex_state = 179},
  [5429] = {.lex_state = 27},
  [5430] = {.lex_state = 179},
  [5431] = {.lex_state = 179},
  [5432] = {.lex_state = 80},
  [5433] = {.lex_state = 169},
  [5434] = {.lex_state = 179},
  [5435] = {.lex_state = 179},
  [5436] = {.lex_state = 179},
  [5437] = {.lex_state = 142},
  [5438] = {.lex_state = 36},
  [5439] = {.lex_state = 142},
  [5440] = {.lex_state = 179},
  [5441] = {.lex_state = 142},
  [5442] = {.lex_state = 181},
  [5443] = {.lex_state = 179},
  [5444] = {.lex_state = 169},
  [5445] = {.lex_state = 36},
  [5446] = {.lex_state = 36},
  [5447] = {.lex_state = 179},
  [5448] = {.lex_state = 142},
  [5449] = {.lex_state = 142},
  [5450] = {.lex_state = 142},
  [5451] = {.lex_state = 142},
  [5452] = {.lex_state = 179},
  [5453] = {.lex_state = 142},
  [5454] = {.lex_state = 97, .external_lex_state = 4},
  [5455] = {.lex_state = 36},
  [5456] = {.lex_state = 36},
  [5457] = {.lex_state = 36},
  [5458] = {.lex_state = 36},
  [5459] = {.lex_state = 36},
  [5460] = {.lex_state = 179},
  [5461] = {.lex_state = 36},
  [5462] = {.lex_state = 36},
  [5463] = {.lex_state = 179},
  [5464] = {.lex_state = 36},
  [5465] = {.lex_state = 36},
  [5466] = {.lex_state = 36},
  [5467] = {.lex_state = 179},
  [5468] = {.lex_state = 179},
  [5469] = {.lex_state = 180},
  [5470] = {.lex_state = 97, .external_lex_state = 4},
  [5471] = {.lex_state = 56},
  [5472] = {.lex_state = 36},
  [5473] = {.lex_state = 97, .external_lex_state = 4},
  [5474] = {.lex_state = 97, .external_lex_state = 4},
  [5475] = {.lex_state = 97, .external_lex_state = 4},
  [5476] = {.lex_state = 97, .external_lex_state = 4},
  [5477] = {.lex_state = 97, .external_lex_state = 4},
  [5478] = {.lex_state = 97, .external_lex_state = 4},
  [5479] = {.lex_state = 97, .external_lex_state = 4},
  [5480] = {.lex_state = 181},
  [5481] = {.lex_state = 97, .external_lex_state = 4},
  [5482] = {.lex_state = 181},
  [5483] = {.lex_state = 97, .external_lex_state = 4},
  [5484] = {.lex_state = 82},
  [5485] = {.lex_state = 37},
  [5486] = {.lex_state = 81},
  [5487] = {.lex_state = 97, .external_lex_state = 4},
  [5488] = {.lex_state = 97, .external_lex_state = 4},
  [5489] = {.lex_state = 181},
  [5490] = {.lex_state = 181},
  [5491] = {.lex_state = 169},
  [5492] = {.lex_state = 180},
  [5493] = {.lex_state = 181},
  [5494] = {.lex_state = 180},
  [5495] = {.lex_state = 181},
  [5496] = {.lex_state = 184},
  [5497] = {.lex_state = 181},
  [5498] = {.lex_state = 181},
  [5499] = {.lex_state = 180},
  [5500] = {.lex_state = 181},
  [5501] = {.lex_state = 181},
  [5502] = {.lex_state = 181},
  [5503] = {.lex_state = 180},
  [5504] = {.lex_state = 179},
  [5505] = {.lex_state = 181},
  [5506] = {.lex_state = 180},
  [5507] = {.lex_state = 180},
  [5508] = {.lex_state = 180},
  [5509] = {.lex_state = 98, .external_lex_state = 4},
  [5510] = {.lex_state = 36},
  [5511] = {.lex_state = 25, .external_lex_state = 4},
  [5512] = {.lex_state = 5},
  [5513] = {.lex_state = 25, .external_lex_state = 4},
  [5514] = {.lex_state = 25, .external_lex_state = 4},
  [5515] = {.lex_state = 181},
  [5516] = {.lex_state = 25, .external_lex_state = 4},
  [5517] = {.lex_state = 25, .external_lex_state = 4},
  [5518] = {.lex_state = 180},
  [5519] = {.lex_state = 25, .external_lex_state = 4},
  [5520] = {.lex_state = 25, .external_lex_state = 4},
  [5521] = {.lex_state = 25, .external_lex_state = 4},
  [5522] = {.lex_state = 180},
  [5523] = {.lex_state = 178},
  [5524] = {.lex_state = 180},
  [5525] = {.lex_state = 25, .external_lex_state = 4},
  [5526] = {.lex_state = 180},
  [5527] = {.lex_state = 180},
  [5528] = {.lex_state = 179},
  [5529] = {.lex_state = 25, .external_lex_state = 4},
  [5530] = {.lex_state = 180},
  [5531] = {.lex_state = 25, .external_lex_state = 4},
  [5532] = {.lex_state = 181},
  [5533] = {.lex_state = 169},
  [5534] = {.lex_state = 25, .external_lex_state = 4},
  [5535] = {.lex_state = 180},
  [5536] = {.lex_state = 26, .external_lex_state = 4},
  [5537] = {.lex_state = 25, .external_lex_state = 4},
  [5538] = {.lex_state = 25, .external_lex_state = 4},
  [5539] = {.lex_state = 108},
  [5540] = {.lex_state = 169},
  [5541] = {.lex_state = 99, .external_lex_state = 4},
  [5542] = {.lex_state = 97, .external_lex_state = 4},
  [5543] = {.lex_state = 97, .external_lex_state = 4},
  [5544] = {.lex_state = 99, .external_lex_state = 4},
  [5545] = {.lex_state = 99, .external_lex_state = 4},
  [5546] = {.lex_state = 172},
  [5547] = {.lex_state = 15},
  [5548] = {.lex_state = 7},
  [5549] = {.lex_state = 163},
  [5550] = {.lex_state = 5},
  [5551] = {.lex_state = 72},
  [5552] = {.lex_state = 99, .external_lex_state = 4},
  [5553] = {.lex_state = 5},
  [5554] = {.lex_state = 5},
  [5555] = {.lex_state = 5},
  [5556] = {.lex_state = 99, .external_lex_state = 4},
  [5557] = {.lex_state = 99, .external_lex_state = 4},
  [5558] = {.lex_state = 5},
  [5559] = {.lex_state = 5},
  [5560] = {.lex_state = 99, .external_lex_state = 4},
  [5561] = {.lex_state = 5},
  [5562] = {.lex_state = 5},
  [5563] = {.lex_state = 99, .external_lex_state = 4},
  [5564] = {.lex_state = 5},
  [5565] = {.lex_state = 5},
  [5566] = {.lex_state = 26, .external_lex_state = 4},
  [5567] = {.lex_state = 5},
  [5568] = {.lex_state = 169},
  [5569] = {.lex_state = 169},
  [5570] = {.lex_state = 169},
  [5571] = {.lex_state = 169},
  [5572] = {.lex_state = 169},
  [5573] = {.lex_state = 99, .external_lex_state = 4},
  [5574] = {.lex_state = 169},
  [5575] = {.lex_state = 169},
  [5576] = {.lex_state = 26, .external_lex_state = 4},
  [5577] = {.lex_state = 10},
  [5578] = {.lex_state = 169},
  [5579] = {.lex_state = 169},
  [5580] = {.lex_state = 99, .external_lex_state = 4},
  [5581] = {.lex_state = 99, .external_lex_state = 4},
  [5582] = {.lex_state = 169},
  [5583] = {.lex_state = 99, .external_lex_state = 4},
  [5584] = {.lex_state = 99, .external_lex_state = 4},
  [5585] = {.lex_state = 73},
  [5586] = {.lex_state = 26, .external_lex_state = 4},
  [5587] = {.lex_state = 99, .external_lex_state = 4},
  [5588] = {.lex_state = 13},
  [5589] = {.lex_state = 5},
  [5590] = {.lex_state = 26, .external_lex_state = 4},
  [5591] = {.lex_state = 113},
  [5592] = {.lex_state = 26, .external_lex_state = 4},
  [5593] = {.lex_state = 26, .external_lex_state = 4},
  [5594] = {.lex_state = 26, .external_lex_state = 4},
  [5595] = {.lex_state = 26, .external_lex_state = 4},
  [5596] = {.lex_state = 143},
  [5597] = {.lex_state = 26, .external_lex_state = 4},
  [5598] = {.lex_state = 26, .external_lex_state = 4},
  [5599] = {.lex_state = 26, .external_lex_state = 4},
  [5600] = {.lex_state = 5},
  [5601] = {.lex_state = 142},
  [5602] = {.lex_state = 171},
  [5603] = {.lex_state = 168},
  [5604] = {.lex_state = 100, .external_lex_state = 4},
  [5605] = {.lex_state = 170},
  [5606] = {.lex_state = 168},
  [5607] = {.lex_state = 171},
  [5608] = {.lex_state = 26, .external_lex_state = 4},
  [5609] = {.lex_state = 110},
  [5610] = {.lex_state = 171},
  [5611] = {.lex_state = 16, .external_lex_state = 4},
  [5612] = {.lex_state = 168},
  [5613] = {.lex_state = 171},
  [5614] = {.lex_state = 171},
  [5615] = {.lex_state = 171},
  [5616] = {.lex_state = 171},
  [5617] = {.lex_state = 178},
  [5618] = {.lex_state = 171},
  [5619] = {.lex_state = 171},
  [5620] = {.lex_state = 171},
  [5621] = {.lex_state = 171},
  [5622] = {.lex_state = 26, .external_lex_state = 4},
  [5623] = {.lex_state = 171},
  [5624] = {.lex_state = 171},
  [5625] = {.lex_state = 25, .external_lex_state = 4},
  [5626] = {.lex_state = 178},
  [5627] = {.lex_state = 171},
  [5628] = {.lex_state = 47},
  [5629] = {.lex_state = 168},
  [5630] = {.lex_state = 95, .external_lex_state = 4},
  [5631] = {.lex_state = 168},
  [5632] = {.lex_state = 168},
  [5633] = {.lex_state = 5},
  [5634] = {.lex_state = 168},
  [5635] = {.lex_state = 37},
  [5636] = {.lex_state = 168},
  [5637] = {.lex_state = 170},
  [5638] = {.lex_state = 168},
  [5639] = {.lex_state = 37},
  [5640] = {.lex_state = 37},
  [5641] = {.lex_state = 76, .external_lex_state = 4},
  [5642] = {.lex_state = 46},
  [5643] = {.lex_state = 177},
  [5644] = {.lex_state = 37},
  [5645] = {.lex_state = 168},
  [5646] = {.lex_state = 37},
  [5647] = {.lex_state = 37},
  [5648] = {.lex_state = 178},
  [5649] = {.lex_state = 168},
  [5650] = {.lex_state = 178},
  [5651] = {.lex_state = 178},
  [5652] = {.lex_state = 178},
  [5653] = {.lex_state = 178},
  [5654] = {.lex_state = 37},
  [5655] = {.lex_state = 178},
  [5656] = {.lex_state = 37},
  [5657] = {.lex_state = 178},
  [5658] = {.lex_state = 37},
  [5659] = {.lex_state = 178},
  [5660] = {.lex_state = 178},
  [5661] = {.lex_state = 178},
  [5662] = {.lex_state = 37},
  [5663] = {.lex_state = 37},
  [5664] = {.lex_state = 178},
  [5665] = {.lex_state = 168},
  [5666] = {.lex_state = 168},
  [5667] = {.lex_state = 170},
  [5668] = {.lex_state = 168},
  [5669] = {.lex_state = 170},
  [5670] = {.lex_state = 37},
  [5671] = {.lex_state = 177},
  [5672] = {.lex_state = 170},
  [5673] = {.lex_state = 170},
  [5674] = {.lex_state = 170},
  [5675] = {.lex_state = 170},
  [5676] = {.lex_state = 170},
  [5677] = {.lex_state = 170},
  [5678] = {.lex_state = 170},
  [5679] = {.lex_state = 170},
  [5680] = {.lex_state = 170},
  [5681] = {.lex_state = 170},
  [5682] = {.lex_state = 13, .external_lex_state = 4},
  [5683] = {.lex_state = 163},
  [5684] = {.lex_state = 37},
  [5685] = {.lex_state = 152},
  [5686] = {.lex_state = 37},
  [5687] = {.lex_state = 177},
  [5688] = {.lex_state = 177},
  [5689] = {.lex_state = 177},
  [5690] = {.lex_state = 177},
  [5691] = {.lex_state = 177},
  [5692] = {.lex_state = 177},
  [5693] = {.lex_state = 177},
  [5694] = {.lex_state = 112},
  [5695] = {.lex_state = 177},
  [5696] = {.lex_state = 177},
  [5697] = {.lex_state = 78, .external_lex_state = 4},
  [5698] = {.lex_state = 177},
  [5699] = {.lex_state = 78, .external_lex_state = 4},
  [5700] = {.lex_state = 78, .external_lex_state = 4},
  [5701] = {.lex_state = 78, .external_lex_state = 4},
  [5702] = {.lex_state = 78, .external_lex_state = 4},
  [5703] = {.lex_state = 78, .external_lex_state = 4},
  [5704] = {.lex_state = 78, .external_lex_state = 4},
  [5705] = {.lex_state = 78, .external_lex_state = 4},
  [5706] = {.lex_state = 78, .external_lex_state = 4},
  [5707] = {.lex_state = 78, .external_lex_state = 4},
  [5708] = {.lex_state = 177},
  [5709] = {.lex_state = 76, .external_lex_state = 4},
  [5710] = {.lex_state = 26, .external_lex_state = 4},
  [5711] = {.lex_state = 76, .external_lex_state = 4},
  [5712] = {.lex_state = 177},
  [5713] = {.lex_state = 177},
  [5714] = {.lex_state = 78, .external_lex_state = 4},
  [5715] = {.lex_state = 78, .external_lex_state = 4},
  [5716] = {.lex_state = 78},
  [5717] = {.lex_state = 78, .external_lex_state = 4},
  [5718] = {.lex_state = 171},
  [5719] = {.lex_state = 168},
  [5720] = {.lex_state = 76, .external_lex_state = 4},
  [5721] = {.lex_state = 76, .external_lex_state = 4},
  [5722] = {.lex_state = 76, .external_lex_state = 4},
  [5723] = {.lex_state = 76, .external_lex_state = 4},
  [5724] = {.lex_state = 76, .external_lex_state = 4},
  [5725] = {.lex_state = 95},
  [5726] = {.lex_state = 76, .external_lex_state = 4},
  [5727] = {.lex_state = 76, .external_lex_state = 4},
  [5728] = {.lex_state = 76, .external_lex_state = 4},
  [5729] = {.lex_state = 8},
  [5730] = {.lex_state = 111},
  [5731] = {.lex_state = 76, .external_lex_state = 4},
  [5732] = {.lex_state = 76, .external_lex_state = 4},
  [5733] = {.lex_state = 76, .external_lex_state = 4},
  [5734] = {.lex_state = 170},
  [5735] = {.lex_state = 15},
  [5736] = {.lex_state = 57},
  [5737] = {.lex_state = 57},
  [5738] = {.lex_state = 57},
  [5739] = {.lex_state = 57},
  [5740] = {.lex_state = 57},
  [5741] = {.lex_state = 57},
  [5742] = {.lex_state = 57},
  [5743] = {.lex_state = 57},
  [5744] = {.lex_state = 57},
  [5745] = {.lex_state = 59},
  [5746] = {.lex_state = 57},
  [5747] = {.lex_state = 172, .external_lex_state = 4},
  [5748] = {.lex_state = 78},
  [5749] = {.lex_state = 78},
  [5750] = {.lex_state = 93},
  [5751] = {.lex_state = 46},
  [5752] = {.lex_state = 79},
  [5753] = {.lex_state = 57},
  [5754] = {.lex_state = 78},
  [5755] = {.lex_state = 78},
  [5756] = {.lex_state = 78},
  [5757] = {.lex_state = 78},
  [5758] = {.lex_state = 78},
  [5759] = {.lex_state = 47},
  [5760] = {.lex_state = 78},
  [5761] = {.lex_state = 78},
  [5762] = {.lex_state = 79},
  [5763] = {.lex_state = 78},
  [5764] = {.lex_state = 78},
  [5765] = {.lex_state = 78},
  [5766] = {.lex_state = 79},
  [5767] = {.lex_state = 78},
  [5768] = {.lex_state = 79},
  [5769] = {.lex_state = 79},
  [5770] = {.lex_state = 79},
  [5771] = {.lex_state = 57},
  [5772] = {.lex_state = 8},
  [5773] = {.lex_state = 79},
  [5774] = {.lex_state = 79},
  [5775] = {.lex_state = 79},
  [5776] = {.lex_state = 79},
  [5777] = {.lex_state = 79},
  [5778] = {.lex_state = 80},
  [5779] = {.lex_state = 80},
  [5780] = {.lex_state = 80},
  [5781] = {.lex_state = 80},
  [5782] = {.lex_state = 80},
  [5783] = {.lex_state = 80},
  [5784] = {.lex_state = 80},
  [5785] = {.lex_state = 80},
  [5786] = {.lex_state = 80},
  [5787] = {.lex_state = 80},
  [5788] = {.lex_state = 80},
  [5789] = {.lex_state = 57},
  [5790] = {.lex_state = 172, .external_lex_state = 4},
  [5791] = {.lex_state = 172, .external_lex_state = 4},
  [5792] = {.lex_state = 119},
  [5793] = {.lex_state = 79},
  [5794] = {.lex_state = 79},
  [5795] = {.lex_state = 82},
  [5796] = {.lex_state = 80},
  [5797] = {.lex_state = 82},
  [5798] = {.lex_state = 82},
  [5799] = {.lex_state = 82},
  [5800] = {.lex_state = 82},
  [5801] = {.lex_state = 82},
  [5802] = {.lex_state = 80},
  [5803] = {.lex_state = 82},
  [5804] = {.lex_state = 46},
  [5805] = {.lex_state = 46},
  [5806] = {.lex_state = 13, .external_lex_state = 4},
  [5807] = {.lex_state = 46},
  [5808] = {.lex_state = 46},
  [5809] = {.lex_state = 82},
  [5810] = {.lex_state = 46},
  [5811] = {.lex_state = 46},
  [5812] = {.lex_state = 100, .external_lex_state = 4},
  [5813] = {.lex_state = 82},
  [5814] = {.lex_state = 82},
  [5815] = {.lex_state = 153},
  [5816] = {.lex_state = 82},
  [5817] = {.lex_state = 81},
  [5818] = {.lex_state = 58},
  [5819] = {.lex_state = 81},
  [5820] = {.lex_state = 81},
  [5821] = {.lex_state = 81},
  [5822] = {.lex_state = 81},
  [5823] = {.lex_state = 81},
  [5824] = {.lex_state = 81},
  [5825] = {.lex_state = 46},
  [5826] = {.lex_state = 81},
  [5827] = {.lex_state = 81},
  [5828] = {.lex_state = 81},
  [5829] = {.lex_state = 81},
  [5830] = {.lex_state = 18},
  [5831] = {.lex_state = 172},
  [5832] = {.lex_state = 56},
  [5833] = {.lex_state = 46},
  [5834] = {.lex_state = 68},
  [5835] = {.lex_state = 46},
  [5836] = {.lex_state = 18},
  [5837] = {.lex_state = 11},
  [5838] = {.lex_state = 172, .external_lex_state = 4},
  [5839] = {.lex_state = 98, .external_lex_state = 4},
  [5840] = {.lex_state = 172, .external_lex_state = 4},
  [5841] = {.lex_state = 172, .external_lex_state = 4},
  [5842] = {.lex_state = 8},
  [5843] = {.lex_state = 172, .external_lex_state = 4},
  [5844] = {.lex_state = 57},
  [5845] = {.lex_state = 172, .external_lex_state = 4},
  [5846] = {.lex_state = 82},
  [5847] = {.lex_state = 172, .external_lex_state = 4},
  [5848] = {.lex_state = 172, .external_lex_state = 4},
  [5849] = {.lex_state = 46},
  [5850] = {.lex_state = 82},
  [5851] = {.lex_state = 56},
  [5852] = {.lex_state = 172, .external_lex_state = 4},
  [5853] = {.lex_state = 47},
  [5854] = {.lex_state = 47},
  [5855] = {.lex_state = 172, .external_lex_state = 4},
  [5856] = {.lex_state = 47},
  [5857] = {.lex_state = 47},
  [5858] = {.lex_state = 81},
  [5859] = {.lex_state = 47},
  [5860] = {.lex_state = 47},
  [5861] = {.lex_state = 47},
  [5862] = {.lex_state = 47},
  [5863] = {.lex_state = 13, .external_lex_state = 4},
  [5864] = {.lex_state = 182},
  [5865] = {.lex_state = 13, .external_lex_state = 4},
  [5866] = {.lex_state = 47},
  [5867] = {.lex_state = 56},
  [5868] = {.lex_state = 172, .external_lex_state = 4},
  [5869] = {.lex_state = 81},
  [5870] = {.lex_state = 172, .external_lex_state = 4},
  [5871] = {.lex_state = 47},
  [5872] = {.lex_state = 13, .external_lex_state = 4},
  [5873] = {.lex_state = 79},
  [5874] = {.lex_state = 56},
  [5875] = {.lex_state = 152},
  [5876] = {.lex_state = 80},
  [5877] = {.lex_state = 56},
  [5878] = {.lex_state = 78},
  [5879] = {.lex_state = 98, .external_lex_state = 4},
  [5880] = {.lex_state = 47},
  [5881] = {.lex_state = 98, .external_lex_state = 4},
  [5882] = {.lex_state = 56},
  [5883] = {.lex_state = 98, .external_lex_state = 4},
  [5884] = {.lex_state = 78},
  [5885] = {.lex_state = 15, .external_lex_state = 4},
  [5886] = {.lex_state = 13, .external_lex_state = 4},
  [5887] = {.lex_state = 13, .external_lex_state = 4},
  [5888] = {.lex_state = 13, .external_lex_state = 4},
  [5889] = {.lex_state = 98, .external_lex_state = 4},
  [5890] = {.lex_state = 13, .external_lex_state = 4},
  [5891] = {.lex_state = 13, .external_lex_state = 4},
  [5892] = {.lex_state = 13, .external_lex_state = 4},
  [5893] = {.lex_state = 13, .external_lex_state = 4},
  [5894] = {.lex_state = 98, .external_lex_state = 4},
  [5895] = {.lex_state = 13, .external_lex_state = 4},
  [5896] = {.lex_state = 98, .external_lex_state = 4},
  [5897] = {.lex_state = 13, .external_lex_state = 4},
  [5898] = {.lex_state = 13, .external_lex_state = 4},
  [5899] = {.lex_state = 13, .external_lex_state = 4},
  [5900] = {.lex_state = 98, .external_lex_state = 4},
  [5901] = {.lex_state = 98, .external_lex_state = 4},
  [5902] = {.lex_state = 46},
  [5903] = {.lex_state = 98, .external_lex_state = 4},
  [5904] = {.lex_state = 98, .external_lex_state = 4},
  [5905] = {.lex_state = 46},
  [5906] = {.lex_state = 98, .external_lex_state = 4},
  [5907] = {.lex_state = 93, .external_lex_state = 4},
  [5908] = {.lex_state = 47},
  [5909] = {.lex_state = 98, .external_lex_state = 4},
  [5910] = {.lex_state = 47},
  [5911] = {.lex_state = 56},
  [5912] = {.lex_state = 103},
  [5913] = {.lex_state = 82},
  [5914] = {.lex_state = 98, .external_lex_state = 4},
  [5915] = {.lex_state = 81},
  [5916] = {.lex_state = 10},
  [5917] = {.lex_state = 15},
  [5918] = {.lex_state = 56},
  [5919] = {.lex_state = 56},
  [5920] = {.lex_state = 56},
  [5921] = {.lex_state = 56},
  [5922] = {.lex_state = 56},
  [5923] = {.lex_state = 56},
  [5924] = {.lex_state = 56},
  [5925] = {.lex_state = 56},
  [5926] = {.lex_state = 10},
  [5927] = {.lex_state = 15},
  [5928] = {.lex_state = 10},
  [5929] = {.lex_state = 10},
  [5930] = {.lex_state = 10},
  [5931] = {.lex_state = 10},
  [5932] = {.lex_state = 10},
  [5933] = {.lex_state = 119},
  [5934] = {.lex_state = 10},
  [5935] = {.lex_state = 10},
  [5936] = {.lex_state = 10},
  [5937] = {.lex_state = 152},
  [5938] = {.lex_state = 58},
  [5939] = {.lex_state = 10},
  [5940] = {.lex_state = 10},
  [5941] = {.lex_state = 15},
  [5942] = {.lex_state = 81},
  [5943] = {.lex_state = 15},
  [5944] = {.lex_state = 98, .external_lex_state = 4},
  [5945] = {.lex_state = 172},
  [5946] = {.lex_state = 104},
  [5947] = {.lex_state = 100},
  [5948] = {.lex_state = 82},
  [5949] = {.lex_state = 80},
  [5950] = {.lex_state = 79},
  [5951] = {.lex_state = 15},
  [5952] = {.lex_state = 100, .external_lex_state = 4},
  [5953] = {.lex_state = 100, .external_lex_state = 4},
  [5954] = {.lex_state = 100, .external_lex_state = 4},
  [5955] = {.lex_state = 100, .external_lex_state = 4},
  [5956] = {.lex_state = 57},
  [5957] = {.lex_state = 10},
  [5958] = {.lex_state = 100, .external_lex_state = 4},
  [5959] = {.lex_state = 100, .external_lex_state = 4},
  [5960] = {.lex_state = 100, .external_lex_state = 4},
  [5961] = {.lex_state = 10},
  [5962] = {.lex_state = 100, .external_lex_state = 4},
  [5963] = {.lex_state = 100, .external_lex_state = 4},
  [5964] = {.lex_state = 100, .external_lex_state = 4},
  [5965] = {.lex_state = 15},
  [5966] = {.lex_state = 10},
  [5967] = {.lex_state = 172, .external_lex_state = 4},
  [5968] = {.lex_state = 47},
  [5969] = {.lex_state = 172},
  [5970] = {.lex_state = 101},
  [5971] = {.lex_state = 172},
  [5972] = {.lex_state = 15},
  [5973] = {.lex_state = 100, .external_lex_state = 4},
  [5974] = {.lex_state = 46},
  [5975] = {.lex_state = 100, .external_lex_state = 4},
  [5976] = {.lex_state = 100, .external_lex_state = 4},
  [5977] = {.lex_state = 15},
  [5978] = {.lex_state = 100, .external_lex_state = 4},
  [5979] = {.lex_state = 15},
  [5980] = {.lex_state = 69},
  [5981] = {.lex_state = 172},
  [5982] = {.lex_state = 172},
  [5983] = {.lex_state = 172},
  [5984] = {.lex_state = 172},
  [5985] = {.lex_state = 172},
  [5986] = {.lex_state = 172},
  [5987] = {.lex_state = 172},
  [5988] = {.lex_state = 172},
  [5989] = {.lex_state = 172},
  [5990] = {.lex_state = 172},
  [5991] = {.lex_state = 172},
  [5992] = {.lex_state = 15},
  [5993] = {.lex_state = 46},
  [5994] = {.lex_state = 15},
  [5995] = {.lex_state = 102},
  [5996] = {.lex_state = 184},
  [5997] = {.lex_state = 15},
  [5998] = {.lex_state = 15},
  [5999] = {.lex_state = 15},
  [6000] = {.lex_state = 15, .external_lex_state = 4},
  [6001] = {.lex_state = 120},
  [6002] = {.lex_state = 101},
  [6003] = {.lex_state = 102},
  [6004] = {.lex_state = 69},
  [6005] = {.lex_state = 102},
  [6006] = {.lex_state = 102},
  [6007] = {.lex_state = 102},
  [6008] = {.lex_state = 102},
  [6009] = {.lex_state = 102},
  [6010] = {.lex_state = 102},
  [6011] = {.lex_state = 120},
  [6012] = {.lex_state = 120},
  [6013] = {.lex_state = 102},
  [6014] = {.lex_state = 93, .external_lex_state = 4},
  [6015] = {.lex_state = 101},
  [6016] = {.lex_state = 69},
  [6017] = {.lex_state = 120},
  [6018] = {.lex_state = 15, .external_lex_state = 4},
  [6019] = {.lex_state = 102},
  [6020] = {.lex_state = 102},
  [6021] = {.lex_state = 70},
  [6022] = {.lex_state = 11},
  [6023] = {.lex_state = 71},
  [6024] = {.lex_state = 102},
  [6025] = {.lex_state = 120},
  [6026] = {.lex_state = 104},
  [6027] = {.lex_state = 104},
  [6028] = {.lex_state = 120},
  [6029] = {.lex_state = 120},
  [6030] = {.lex_state = 102},
  [6031] = {.lex_state = 120},
  [6032] = {.lex_state = 100},
  [6033] = {.lex_state = 100},
  [6034] = {.lex_state = 100},
  [6035] = {.lex_state = 100},
  [6036] = {.lex_state = 69},
  [6037] = {.lex_state = 69},
  [6038] = {.lex_state = 69},
  [6039] = {.lex_state = 69},
  [6040] = {.lex_state = 69},
  [6041] = {.lex_state = 100},
  [6042] = {.lex_state = 69},
  [6043] = {.lex_state = 69},
  [6044] = {.lex_state = 100},
  [6045] = {.lex_state = 69},
  [6046] = {.lex_state = 69},
  [6047] = {.lex_state = 69},
  [6048] = {.lex_state = 100},
  [6049] = {.lex_state = 100},
  [6050] = {.lex_state = 69},
  [6051] = {.lex_state = 100},
  [6052] = {.lex_state = 100},
  [6053] = {.lex_state = 15, .external_lex_state = 4},
  [6054] = {.lex_state = 120},
  [6055] = {.lex_state = 104},
  [6056] = {.lex_state = 100},
  [6057] = {.lex_state = 182},
  [6058] = {.lex_state = 100},
  [6059] = {.lex_state = 100},
  [6060] = {.lex_state = 104},
  [6061] = {.lex_state = 120},
  [6062] = {.lex_state = 120},
  [6063] = {.lex_state = 104},
  [6064] = {.lex_state = 101},
  [6065] = {.lex_state = 101},
  [6066] = {.lex_state = 11},
  [6067] = {.lex_state = 15, .external_lex_state = 4},
  [6068] = {.lex_state = 15, .external_lex_state = 4},
  [6069] = {.lex_state = 101},
  [6070] = {.lex_state = 69},
  [6071] = {.lex_state = 120},
  [6072] = {.lex_state = 103},
  [6073] = {.lex_state = 104},
  [6074] = {.lex_state = 101},
  [6075] = {.lex_state = 104},
  [6076] = {.lex_state = 101},
  [6077] = {.lex_state = 120},
  [6078] = {.lex_state = 120},
  [6079] = {.lex_state = 101},
  [6080] = {.lex_state = 101},
  [6081] = {.lex_state = 102},
  [6082] = {.lex_state = 120},
  [6083] = {.lex_state = 104},
  [6084] = {.lex_state = 58},
  [6085] = {.lex_state = 101},
  [6086] = {.lex_state = 101},
  [6087] = {.lex_state = 101},
  [6088] = {.lex_state = 104},
  [6089] = {.lex_state = 101},
  [6090] = {.lex_state = 120},
  [6091] = {.lex_state = 100},
  [6092] = {.lex_state = 104},
  [6093] = {.lex_state = 104},
  [6094] = {.lex_state = 104},
  [6095] = {.lex_state = 69},
  [6096] = {.lex_state = 103},
  [6097] = {.lex_state = 120},
  [6098] = {.lex_state = 103},
  [6099] = {.lex_state = 103},
  [6100] = {.lex_state = 103},
  [6101] = {.lex_state = 104},
  [6102] = {.lex_state = 120},
  [6103] = {.lex_state = 103},
  [6104] = {.lex_state = 103},
  [6105] = {.lex_state = 103},
  [6106] = {.lex_state = 104},
  [6107] = {.lex_state = 93, .external_lex_state = 4},
  [6108] = {.lex_state = 103},
  [6109] = {.lex_state = 93, .external_lex_state = 4},
  [6110] = {.lex_state = 153},
  [6111] = {.lex_state = 182},
  [6112] = {.lex_state = 120},
  [6113] = {.lex_state = 120},
  [6114] = {.lex_state = 120},
  [6115] = {.lex_state = 182},
  [6116] = {.lex_state = 15, .external_lex_state = 4},
  [6117] = {.lex_state = 15, .external_lex_state = 4},
  [6118] = {.lex_state = 15, .external_lex_state = 4},
  [6119] = {.lex_state = 38, .external_lex_state = 4},
  [6120] = {.lex_state = 68},
  [6121] = {.lex_state = 59},
  [6122] = {.lex_state = 15, .external_lex_state = 4},
  [6123] = {.lex_state = 120},
  [6124] = {.lex_state = 68},
  [6125] = {.lex_state = 15, .external_lex_state = 4},
  [6126] = {.lex_state = 15, .external_lex_state = 4},
  [6127] = {.lex_state = 68},
  [6128] = {.lex_state = 15, .external_lex_state = 4},
  [6129] = {.lex_state = 15, .external_lex_state = 4},
  [6130] = {.lex_state = 15, .external_lex_state = 4},
  [6131] = {.lex_state = 119},
  [6132] = {.lex_state = 103},
  [6133] = {.lex_state = 68},
  [6134] = {.lex_state = 68},
  [6135] = {.lex_state = 68},
  [6136] = {.lex_state = 120},
  [6137] = {.lex_state = 100},
  [6138] = {.lex_state = 68},
  [6139] = {.lex_state = 103},
  [6140] = {.lex_state = 68},
  [6141] = {.lex_state = 68},
  [6142] = {.lex_state = 120},
  [6143] = {.lex_state = 182},
  [6144] = {.lex_state = 182},
  [6145] = {.lex_state = 68},
  [6146] = {.lex_state = 68},
  [6147] = {.lex_state = 101},
  [6148] = {.lex_state = 182},
  [6149] = {.lex_state = 182},
  [6150] = {.lex_state = 182},
  [6151] = {.lex_state = 153},
  [6152] = {.lex_state = 182},
  [6153] = {.lex_state = 182},
  [6154] = {.lex_state = 182},
  [6155] = {.lex_state = 102},
  [6156] = {.lex_state = 182},
  [6157] = {.lex_state = 182},
  [6158] = {.lex_state = 58},
  [6159] = {.lex_state = 153},
  [6160] = {.lex_state = 68},
  [6161] = {.lex_state = 68},
  [6162] = {.lex_state = 182},
  [6163] = {.lex_state = 120},
  [6164] = {.lex_state = 68},
  [6165] = {.lex_state = 120},
  [6166] = {.lex_state = 153},
  [6167] = {.lex_state = 68},
  [6168] = {.lex_state = 120},
  [6169] = {.lex_state = 11},
  [6170] = {.lex_state = 93, .external_lex_state = 4},
  [6171] = {.lex_state = 153},
  [6172] = {.lex_state = 153},
  [6173] = {.lex_state = 153},
  [6174] = {.lex_state = 185},
  [6175] = {.lex_state = 153},
  [6176] = {.lex_state = 153},
  [6177] = {.lex_state = 2, .external_lex_state = 2},
  [6178] = {.lex_state = 120},
  [6179] = {.lex_state = 153},
  [6180] = {.lex_state = 153},
  [6181] = {.lex_state = 120},
  [6182] = {.lex_state = 120},
  [6183] = {.lex_state = 120},
  [6184] = {.lex_state = 153},
  [6185] = {.lex_state = 153},
  [6186] = {.lex_state = 120},
  [6187] = {.lex_state = 103},
  [6188] = {.lex_state = 153},
  [6189] = {.lex_state = 120},
  [6190] = {.lex_state = 102},
  [6191] = {.lex_state = 93, .external_lex_state = 4},
  [6192] = {.lex_state = 93, .external_lex_state = 4},
  [6193] = {.lex_state = 93, .external_lex_state = 4},
  [6194] = {.lex_state = 120},
  [6195] = {.lex_state = 93, .external_lex_state = 4},
  [6196] = {.lex_state = 93, .external_lex_state = 4},
  [6197] = {.lex_state = 120},
  [6198] = {.lex_state = 101},
  [6199] = {.lex_state = 93, .external_lex_state = 4},
  [6200] = {.lex_state = 120},
  [6201] = {.lex_state = 120},
  [6202] = {.lex_state = 93, .external_lex_state = 4},
  [6203] = {.lex_state = 153},
  [6204] = {.lex_state = 120},
  [6205] = {.lex_state = 120},
  [6206] = {.lex_state = 120},
  [6207] = {.lex_state = 120},
  [6208] = {.lex_state = 120},
  [6209] = {.lex_state = 120},
  [6210] = {.lex_state = 120},
  [6211] = {.lex_state = 93, .external_lex_state = 4},
  [6212] = {.lex_state = 120},
  [6213] = {.lex_state = 93, .external_lex_state = 4},
  [6214] = {.lex_state = 93},
  [6215] = {.lex_state = 120},
  [6216] = {.lex_state = 120},
  [6217] = {.lex_state = 93, .external_lex_state = 4},
  [6218] = {.lex_state = 120},
  [6219] = {.lex_state = 120},
  [6220] = {.lex_state = 120},
  [6221] = {.lex_state = 120},
  [6222] = {.lex_state = 120},
  [6223] = {.lex_state = 120},
  [6224] = {.lex_state = 120},
  [6225] = {.lex_state = 93},
  [6226] = {.lex_state = 93},
  [6227] = {.lex_state = 93},
  [6228] = {.lex_state = 93},
  [6229] = {.lex_state = 103},
  [6230] = {.lex_state = 93},
  [6231] = {.lex_state = 93},
  [6232] = {.lex_state = 93},
  [6233] = {.lex_state = 120},
  [6234] = {.lex_state = 59},
  [6235] = {.lex_state = 93},
  [6236] = {.lex_state = 93},
  [6237] = {.lex_state = 120},
  [6238] = {.lex_state = 93},
  [6239] = {.lex_state = 93},
  [6240] = {.lex_state = 93},
  [6241] = {.lex_state = 120},
  [6242] = {.lex_state = 120},
  [6243] = {.lex_state = 120},
  [6244] = {.lex_state = 11},
  [6245] = {.lex_state = 11},
  [6246] = {.lex_state = 120},
  [6247] = {.lex_state = 93},
  [6248] = {.lex_state = 120},
  [6249] = {.lex_state = 120},
  [6250] = {.lex_state = 120},
  [6251] = {.lex_state = 93},
  [6252] = {.lex_state = 103},
  [6253] = {.lex_state = 11},
  [6254] = {.lex_state = 120},
  [6255] = {.lex_state = 103},
  [6256] = {.lex_state = 120},
  [6257] = {.lex_state = 11},
  [6258] = {.lex_state = 120},
  [6259] = {.lex_state = 120},
  [6260] = {.lex_state = 120},
  [6261] = {.lex_state = 120},
  [6262] = {.lex_state = 120},
  [6263] = {.lex_state = 120},
  [6264] = {.lex_state = 120},
  [6265] = {.lex_state = 120},
  [6266] = {.lex_state = 183},
  [6267] = {.lex_state = 11},
  [6268] = {.lex_state = 120},
  [6269] = {.lex_state = 120},
  [6270] = {.lex_state = 120},
  [6271] = {.lex_state = 120},
  [6272] = {.lex_state = 120},
  [6273] = {.lex_state = 120},
  [6274] = {.lex_state = 120},
  [6275] = {.lex_state = 120},
  [6276] = {.lex_state = 120},
  [6277] = {.lex_state = 93, .external_lex_state = 4},
  [6278] = {.lex_state = 120},
  [6279] = {.lex_state = 120},
  [6280] = {.lex_state = 120},
  [6281] = {.lex_state = 15, .external_lex_state = 4},
  [6282] = {.lex_state = 104},
  [6283] = {.lex_state = 11},
  [6284] = {.lex_state = 11},
  [6285] = {.lex_state = 11},
  [6286] = {.lex_state = 120},
  [6287] = {.lex_state = 11},
  [6288] = {.lex_state = 11},
  [6289] = {.lex_state = 120},
  [6290] = {.lex_state = 11},
  [6291] = {.lex_state = 120},
  [6292] = {.lex_state = 11},
  [6293] = {.lex_state = 117},
  [6294] = {.lex_state = 120},
  [6295] = {.lex_state = 120},
  [6296] = {.lex_state = 120},
  [6297] = {.lex_state = 120},
  [6298] = {.lex_state = 120},
  [6299] = {.lex_state = 120},
  [6300] = {.lex_state = 120},
  [6301] = {.lex_state = 120},
  [6302] = {.lex_state = 120},
  [6303] = {.lex_state = 120},
  [6304] = {.lex_state = 120},
  [6305] = {.lex_state = 120},
  [6306] = {.lex_state = 120},
  [6307] = {.lex_state = 120},
  [6308] = {.lex_state = 120},
  [6309] = {.lex_state = 117},
  [6310] = {.lex_state = 120},
  [6311] = {.lex_state = 120},
  [6312] = {.lex_state = 120},
  [6313] = {.lex_state = 120},
  [6314] = {.lex_state = 120},
  [6315] = {.lex_state = 120},
  [6316] = {.lex_state = 120},
  [6317] = {.lex_state = 120},
  [6318] = {.lex_state = 120},
  [6319] = {.lex_state = 120},
  [6320] = {.lex_state = 120},
  [6321] = {.lex_state = 183},
  [6322] = {.lex_state = 120},
  [6323] = {.lex_state = 120},
  [6324] = {.lex_state = 120},
  [6325] = {.lex_state = 120},
  [6326] = {.lex_state = 120},
  [6327] = {.lex_state = 120},
  [6328] = {.lex_state = 120},
  [6329] = {.lex_state = 120},
  [6330] = {.lex_state = 120},
  [6331] = {.lex_state = 120},
  [6332] = {.lex_state = 120},
  [6333] = {.lex_state = 18},
  [6334] = {.lex_state = 120},
  [6335] = {.lex_state = 120},
  [6336] = {.lex_state = 120},
  [6337] = {.lex_state = 120},
  [6338] = {.lex_state = 120},
  [6339] = {.lex_state = 120},
  [6340] = {.lex_state = 120},
  [6341] = {.lex_state = 120},
  [6342] = {.lex_state = 120},
  [6343] = {.lex_state = 120},
  [6344] = {.lex_state = 120},
  [6345] = {.lex_state = 120},
  [6346] = {.lex_state = 120},
  [6347] = {.lex_state = 120},
  [6348] = {.lex_state = 120},
  [6349] = {.lex_state = 120},
  [6350] = {.lex_state = 120},
  [6351] = {.lex_state = 120},
  [6352] = {.lex_state = 120},
  [6353] = {.lex_state = 120},
  [6354] = {.lex_state = 120},
  [6355] = {.lex_state = 183},
  [6356] = {.lex_state = 120},
  [6357] = {.lex_state = 183},
  [6358] = {.lex_state = 120},
  [6359] = {.lex_state = 120},
  [6360] = {.lex_state = 120},
  [6361] = {.lex_state = 120},
  [6362] = {.lex_state = 120},
  [6363] = {.lex_state = 120},
  [6364] = {.lex_state = 120},
  [6365] = {.lex_state = 120},
  [6366] = {.lex_state = 120},
  [6367] = {.lex_state = 120},
  [6368] = {.lex_state = 120},
  [6369] = {.lex_state = 120},
  [6370] = {.lex_state = 120},
  [6371] = {.lex_state = 120},
  [6372] = {.lex_state = 120},
  [6373] = {.lex_state = 120},
  [6374] = {.lex_state = 120},
  [6375] = {.lex_state = 120},
  [6376] = {.lex_state = 120},
  [6377] = {.lex_state = 120},
  [6378] = {.lex_state = 120},
  [6379] = {.lex_state = 120},
  [6380] = {.lex_state = 120},
  [6381] = {.lex_state = 120},
  [6382] = {.lex_state = 120},
  [6383] = {.lex_state = 120},
  [6384] = {.lex_state = 120},
  [6385] = {.lex_state = 120},
  [6386] = {.lex_state = 71},
  [6387] = {.lex_state = 120},
  [6388] = {.lex_state = 183},
  [6389] = {.lex_state = 183},
  [6390] = {.lex_state = 183},
  [6391] = {.lex_state = 183},
  [6392] = {.lex_state = 183},
  [6393] = {.lex_state = 120},
  [6394] = {.lex_state = 120},
  [6395] = {.lex_state = 120},
  [6396] = {.lex_state = 183},
  [6397] = {.lex_state = 183},
  [6398] = {.lex_state = 120},
  [6399] = {.lex_state = 183},
  [6400] = {.lex_state = 120},
  [6401] = {.lex_state = 183},
  [6402] = {.lex_state = 183},
  [6403] = {.lex_state = 120},
  [6404] = {.lex_state = 120},
  [6405] = {.lex_state = 120},
  [6406] = {.lex_state = 120},
  [6407] = {.lex_state = 183},
  [6408] = {.lex_state = 120},
  [6409] = {.lex_state = 120},
  [6410] = {.lex_state = 120},
  [6411] = {.lex_state = 120},
  [6412] = {.lex_state = 120},
  [6413] = {.lex_state = 120},
  [6414] = {.lex_state = 120},
  [6415] = {.lex_state = 120},
  [6416] = {.lex_state = 120},
  [6417] = {.lex_state = 120},
  [6418] = {.lex_state = 120},
  [6419] = {.lex_state = 120},
  [6420] = {.lex_state = 120},
  [6421] = {.lex_state = 120},
  [6422] = {.lex_state = 120},
  [6423] = {.lex_state = 120},
  [6424] = {.lex_state = 38, .external_lex_state = 4},
  [6425] = {.lex_state = 120},
  [6426] = {.lex_state = 70},
  [6427] = {.lex_state = 70},
  [6428] = {.lex_state = 120},
  [6429] = {.lex_state = 120},
  [6430] = {.lex_state = 120},
  [6431] = {.lex_state = 120},
  [6432] = {.lex_state = 120},
  [6433] = {.lex_state = 120},
  [6434] = {.lex_state = 120},
  [6435] = {.lex_state = 120},
  [6436] = {.lex_state = 120},
  [6437] = {.lex_state = 120},
  [6438] = {.lex_state = 120},
  [6439] = {.lex_state = 120},
  [6440] = {.lex_state = 120},
  [6441] = {.lex_state = 120},
  [6442] = {.lex_state = 120},
  [6443] = {.lex_state = 120},
  [6444] = {.lex_state = 120},
  [6445] = {.lex_state = 120},
  [6446] = {.lex_state = 120},
  [6447] = {.lex_state = 120},
  [6448] = {.lex_state = 120},
  [6449] = {.lex_state = 120},
  [6450] = {.lex_state = 120},
  [6451] = {.lex_state = 120},
  [6452] = {.lex_state = 120},
  [6453] = {.lex_state = 120},
  [6454] = {.lex_state = 120},
  [6455] = {.lex_state = 120},
  [6456] = {.lex_state = 120},
  [6457] = {.lex_state = 120},
  [6458] = {.lex_state = 120},
  [6459] = {.lex_state = 120},
  [6460] = {.lex_state = 120},
  [6461] = {.lex_state = 120},
  [6462] = {.lex_state = 120},
  [6463] = {.lex_state = 120},
  [6464] = {.lex_state = 120},
  [6465] = {.lex_state = 120},
  [6466] = {.lex_state = 120},
  [6467] = {.lex_state = 120},
  [6468] = {.lex_state = 120},
  [6469] = {.lex_state = 120},
  [6470] = {.lex_state = 120},
  [6471] = {.lex_state = 120},
  [6472] = {.lex_state = 120},
  [6473] = {.lex_state = 120},
  [6474] = {.lex_state = 120},
  [6475] = {.lex_state = 120},
  [6476] = {.lex_state = 120},
  [6477] = {.lex_state = 120},
  [6478] = {.lex_state = 120},
  [6479] = {.lex_state = 120},
  [6480] = {.lex_state = 40, .external_lex_state = 4},
  [6481] = {.lex_state = 120},
  [6482] = {.lex_state = 18},
  [6483] = {.lex_state = 120},
  [6484] = {.lex_state = 120},
  [6485] = {.lex_state = 120},
  [6486] = {.lex_state = 120},
  [6487] = {.lex_state = 120},
  [6488] = {.lex_state = 120},
  [6489] = {.lex_state = 120},
  [6490] = {.lex_state = 120},
  [6491] = {.lex_state = 120},
  [6492] = {.lex_state = 120},
  [6493] = {.lex_state = 120},
  [6494] = {.lex_state = 39, .external_lex_state = 4},
  [6495] = {.lex_state = 116},
  [6496] = {.lex_state = 120},
  [6497] = {.lex_state = 120},
  [6498] = {.lex_state = 120},
  [6499] = {.lex_state = 120},
  [6500] = {.lex_state = 120},
  [6501] = {.lex_state = 120},
  [6502] = {.lex_state = 38, .external_lex_state = 4},
  [6503] = {.lex_state = 120},
  [6504] = {.lex_state = 120},
  [6505] = {.lex_state = 120},
  [6506] = {.lex_state = 120},
  [6507] = {.lex_state = 120},
  [6508] = {.lex_state = 120},
  [6509] = {.lex_state = 38, .external_lex_state = 4},
  [6510] = {.lex_state = 120},
  [6511] = {.lex_state = 120},
  [6512] = {.lex_state = 120},
  [6513] = {.lex_state = 120},
  [6514] = {.lex_state = 120},
  [6515] = {.lex_state = 120},
  [6516] = {.lex_state = 120},
  [6517] = {.lex_state = 71},
  [6518] = {.lex_state = 120},
  [6519] = {.lex_state = 71},
  [6520] = {.lex_state = 120},
  [6521] = {.lex_state = 120},
  [6522] = {.lex_state = 120},
  [6523] = {.lex_state = 120},
  [6524] = {.lex_state = 120},
  [6525] = {.lex_state = 120},
  [6526] = {.lex_state = 120},
  [6527] = {.lex_state = 18},
  [6528] = {.lex_state = 120},
  [6529] = {.lex_state = 120},
  [6530] = {.lex_state = 120},
  [6531] = {.lex_state = 120},
  [6532] = {.lex_state = 183},
  [6533] = {.lex_state = 120},
  [6534] = {.lex_state = 120},
  [6535] = {.lex_state = 120},
  [6536] = {.lex_state = 71},
  [6537] = {.lex_state = 38, .external_lex_state = 4},
  [6538] = {.lex_state = 38, .external_lex_state = 4},
  [6539] = {.lex_state = 38, .external_lex_state = 4},
  [6540] = {.lex_state = 38, .external_lex_state = 4},
  [6541] = {.lex_state = 38, .external_lex_state = 4},
  [6542] = {.lex_state = 38, .external_lex_state = 4},
  [6543] = {.lex_state = 38, .external_lex_state = 4},
  [6544] = {.lex_state = 120},
  [6545] = {.lex_state = 38, .external_lex_state = 4},
  [6546] = {.lex_state = 38, .external_lex_state = 4},
  [6547] = {.lex_state = 38, .external_lex_state = 4},
  [6548] = {.lex_state = 71},
  [6549] = {.lex_state = 38, .external_lex_state = 4},
  [6550] = {.lex_state = 120},
  [6551] = {.lex_state = 71},
  [6552] = {.lex_state = 71},
  [6553] = {.lex_state = 120},
  [6554] = {.lex_state = 120},
  [6555] = {.lex_state = 71},
  [6556] = {.lex_state = 120},
  [6557] = {.lex_state = 71},
  [6558] = {.lex_state = 120},
  [6559] = {.lex_state = 120},
  [6560] = {.lex_state = 120},
  [6561] = {.lex_state = 120},
  [6562] = {.lex_state = 71},
  [6563] = {.lex_state = 120},
  [6564] = {.lex_state = 120},
  [6565] = {.lex_state = 71},
  [6566] = {.lex_state = 120},
  [6567] = {.lex_state = 71},
  [6568] = {.lex_state = 120},
  [6569] = {.lex_state = 120},
  [6570] = {.lex_state = 120},
  [6571] = {.lex_state = 120},
  [6572] = {.lex_state = 120},
  [6573] = {.lex_state = 120},
  [6574] = {.lex_state = 71},
  [6575] = {.lex_state = 71},
  [6576] = {.lex_state = 120},
  [6577] = {.lex_state = 120},
  [6578] = {.lex_state = 120},
  [6579] = {.lex_state = 120},
  [6580] = {.lex_state = 120},
  [6581] = {.lex_state = 120},
  [6582] = {.lex_state = 120},
  [6583] = {.lex_state = 120},
  [6584] = {.lex_state = 120},
  [6585] = {.lex_state = 120},
  [6586] = {.lex_state = 120},
  [6587] = {.lex_state = 120},
  [6588] = {.lex_state = 120},
  [6589] = {.lex_state = 120},
  [6590] = {.lex_state = 120},
  [6591] = {.lex_state = 120},
  [6592] = {.lex_state = 120},
  [6593] = {.lex_state = 120},
  [6594] = {.lex_state = 120},
  [6595] = {.lex_state = 120},
  [6596] = {.lex_state = 120},
  [6597] = {.lex_state = 120},
  [6598] = {.lex_state = 120},
  [6599] = {.lex_state = 120},
  [6600] = {.lex_state = 120},
  [6601] = {.lex_state = 120},
  [6602] = {.lex_state = 120},
  [6603] = {.lex_state = 120},
  [6604] = {.lex_state = 120},
  [6605] = {.lex_state = 120},
  [6606] = {.lex_state = 120},
  [6607] = {.lex_state = 120},
  [6608] = {.lex_state = 120},
  [6609] = {.lex_state = 120},
  [6610] = {.lex_state = 120},
  [6611] = {.lex_state = 120},
  [6612] = {.lex_state = 120},
  [6613] = {.lex_state = 120},
  [6614] = {.lex_state = 120},
  [6615] = {.lex_state = 120},
  [6616] = {.lex_state = 120},
  [6617] = {.lex_state = 120},
  [6618] = {.lex_state = 120},
  [6619] = {.lex_state = 120},
  [6620] = {.lex_state = 120},
  [6621] = {.lex_state = 120},
  [6622] = {.lex_state = 60, .external_lex_state = 4},
  [6623] = {.lex_state = 120},
  [6624] = {.lex_state = 120},
  [6625] = {.lex_state = 120},
  [6626] = {.lex_state = 120},
  [6627] = {.lex_state = 120},
  [6628] = {.lex_state = 120},
  [6629] = {.lex_state = 120},
  [6630] = {.lex_state = 120},
  [6631] = {.lex_state = 120},
  [6632] = {.lex_state = 120},
  [6633] = {.lex_state = 120},
  [6634] = {.lex_state = 120},
  [6635] = {.lex_state = 120},
  [6636] = {.lex_state = 120},
  [6637] = {.lex_state = 120},
  [6638] = {.lex_state = 120},
  [6639] = {.lex_state = 120},
  [6640] = {.lex_state = 120},
  [6641] = {.lex_state = 120},
  [6642] = {.lex_state = 120},
  [6643] = {.lex_state = 120},
  [6644] = {.lex_state = 120},
  [6645] = {.lex_state = 120},
  [6646] = {.lex_state = 120},
  [6647] = {.lex_state = 120},
  [6648] = {.lex_state = 120},
  [6649] = {.lex_state = 120},
  [6650] = {.lex_state = 120},
  [6651] = {.lex_state = 120},
  [6652] = {.lex_state = 120},
  [6653] = {.lex_state = 120},
  [6654] = {.lex_state = 120},
  [6655] = {.lex_state = 120},
  [6656] = {.lex_state = 120},
  [6657] = {.lex_state = 120},
  [6658] = {.lex_state = 120},
  [6659] = {.lex_state = 120},
  [6660] = {.lex_state = 120},
  [6661] = {.lex_state = 120},
  [6662] = {.lex_state = 120},
  [6663] = {.lex_state = 120},
  [6664] = {.lex_state = 120},
  [6665] = {.lex_state = 120},
  [6666] = {.lex_state = 120},
  [6667] = {.lex_state = 70},
  [6668] = {.lex_state = 120},
  [6669] = {.lex_state = 120},
  [6670] = {.lex_state = 18},
  [6671] = {.lex_state = 120},
  [6672] = {.lex_state = 120},
  [6673] = {.lex_state = 120},
  [6674] = {.lex_state = 120},
  [6675] = {.lex_state = 120},
  [6676] = {.lex_state = 120},
  [6677] = {.lex_state = 120},
  [6678] = {.lex_state = 120},
  [6679] = {.lex_state = 120},
  [6680] = {.lex_state = 120},
  [6681] = {.lex_state = 120},
  [6682] = {.lex_state = 120},
  [6683] = {.lex_state = 120},
  [6684] = {.lex_state = 120},
  [6685] = {.lex_state = 120},
  [6686] = {.lex_state = 120},
  [6687] = {.lex_state = 120},
  [6688] = {.lex_state = 120},
  [6689] = {.lex_state = 120},
  [6690] = {.lex_state = 120},
  [6691] = {.lex_state = 120},
  [6692] = {.lex_state = 120},
  [6693] = {.lex_state = 120},
  [6694] = {.lex_state = 120},
  [6695] = {.lex_state = 120},
  [6696] = {.lex_state = 120},
  [6697] = {.lex_state = 120},
  [6698] = {.lex_state = 120},
  [6699] = {.lex_state = 120},
  [6700] = {.lex_state = 120},
  [6701] = {.lex_state = 120},
  [6702] = {.lex_state = 120},
  [6703] = {.lex_state = 120},
  [6704] = {.lex_state = 120},
  [6705] = {.lex_state = 120},
  [6706] = {.lex_state = 120},
  [6707] = {.lex_state = 120},
  [6708] = {.lex_state = 120},
  [6709] = {.lex_state = 120},
  [6710] = {.lex_state = 70},
  [6711] = {.lex_state = 120},
  [6712] = {.lex_state = 120},
  [6713] = {.lex_state = 120},
  [6714] = {.lex_state = 70},
  [6715] = {.lex_state = 70},
  [6716] = {.lex_state = 70},
  [6717] = {.lex_state = 120},
  [6718] = {.lex_state = 70},
  [6719] = {.lex_state = 120},
  [6720] = {.lex_state = 120},
  [6721] = {.lex_state = 120},
  [6722] = {.lex_state = 120},
  [6723] = {.lex_state = 120},
  [6724] = {.lex_state = 120},
  [6725] = {.lex_state = 120},
  [6726] = {.lex_state = 120},
  [6727] = {.lex_state = 120},
  [6728] = {.lex_state = 120},
  [6729] = {.lex_state = 120},
  [6730] = {.lex_state = 120},
  [6731] = {.lex_state = 120},
  [6732] = {.lex_state = 120},
  [6733] = {.lex_state = 120},
  [6734] = {.lex_state = 70},
  [6735] = {.lex_state = 120},
  [6736] = {.lex_state = 70},
  [6737] = {.lex_state = 120},
  [6738] = {.lex_state = 120},
  [6739] = {.lex_state = 120},
  [6740] = {.lex_state = 120},
  [6741] = {.lex_state = 120},
  [6742] = {.lex_state = 120},
  [6743] = {.lex_state = 120},
  [6744] = {.lex_state = 120},
  [6745] = {.lex_state = 70},
  [6746] = {.lex_state = 70},
  [6747] = {.lex_state = 120},
  [6748] = {.lex_state = 120},
  [6749] = {.lex_state = 70},
  [6750] = {.lex_state = 120},
  [6751] = {.lex_state = 120},
  [6752] = {.lex_state = 70},
  [6753] = {.lex_state = 120},
  [6754] = {.lex_state = 120},
  [6755] = {.lex_state = 120},
  [6756] = {.lex_state = 70},
  [6757] = {.lex_state = 120},
  [6758] = {.lex_state = 120},
  [6759] = {.lex_state = 120},
  [6760] = {.lex_state = 120},
  [6761] = {.lex_state = 120},
  [6762] = {.lex_state = 120},
  [6763] = {.lex_state = 120},
  [6764] = {.lex_state = 120},
  [6765] = {.lex_state = 120},
  [6766] = {.lex_state = 71},
  [6767] = {.lex_state = 120},
  [6768] = {.lex_state = 120},
  [6769] = {.lex_state = 120},
  [6770] = {.lex_state = 120},
  [6771] = {.lex_state = 120},
  [6772] = {.lex_state = 120},
  [6773] = {.lex_state = 120},
  [6774] = {.lex_state = 120},
  [6775] = {.lex_state = 120},
  [6776] = {.lex_state = 120},
  [6777] = {.lex_state = 120},
  [6778] = {.lex_state = 120},
  [6779] = {.lex_state = 120},
  [6780] = {.lex_state = 120},
  [6781] = {.lex_state = 120},
  [6782] = {.lex_state = 120},
  [6783] = {.lex_state = 120},
  [6784] = {.lex_state = 120},
  [6785] = {.lex_state = 120},
  [6786] = {.lex_state = 120},
  [6787] = {.lex_state = 120},
  [6788] = {.lex_state = 120},
  [6789] = {.lex_state = 120},
  [6790] = {.lex_state = 120},
  [6791] = {.lex_state = 116},
  [6792] = {.lex_state = 116},
  [6793] = {.lex_state = 40, .external_lex_state = 4},
  [6794] = {.lex_state = 40, .external_lex_state = 4},
  [6795] = {.lex_state = 40, .external_lex_state = 4},
  [6796] = {.lex_state = 40, .external_lex_state = 4},
  [6797] = {.lex_state = 117},
  [6798] = {.lex_state = 40, .external_lex_state = 4},
  [6799] = {.lex_state = 40, .external_lex_state = 4},
  [6800] = {.lex_state = 117},
  [6801] = {.lex_state = 117},
  [6802] = {.lex_state = 62, .external_lex_state = 4},
  [6803] = {.lex_state = 40, .external_lex_state = 4},
  [6804] = {.lex_state = 40, .external_lex_state = 4},
  [6805] = {.lex_state = 60, .external_lex_state = 4},
  [6806] = {.lex_state = 60, .external_lex_state = 4},
  [6807] = {.lex_state = 60, .external_lex_state = 4},
  [6808] = {.lex_state = 40, .external_lex_state = 4},
  [6809] = {.lex_state = 60, .external_lex_state = 4},
  [6810] = {.lex_state = 60, .external_lex_state = 4},
  [6811] = {.lex_state = 40, .external_lex_state = 4},
  [6812] = {.lex_state = 60, .external_lex_state = 4},
  [6813] = {.lex_state = 60, .external_lex_state = 4},
  [6814] = {.lex_state = 60, .external_lex_state = 4},
  [6815] = {.lex_state = 60, .external_lex_state = 4},
  [6816] = {.lex_state = 60, .external_lex_state = 4},
  [6817] = {.lex_state = 60, .external_lex_state = 4},
  [6818] = {.lex_state = 60, .external_lex_state = 4},
  [6819] = {.lex_state = 39, .external_lex_state = 4},
  [6820] = {.lex_state = 60, .external_lex_state = 4},
  [6821] = {.lex_state = 39, .external_lex_state = 4},
  [6822] = {.lex_state = 60, .external_lex_state = 4},
  [6823] = {.lex_state = 40, .external_lex_state = 4},
  [6824] = {.lex_state = 116},
  [6825] = {.lex_state = 40, .external_lex_state = 4},
  [6826] = {.lex_state = 116},
  [6827] = {.lex_state = 40, .external_lex_state = 4},
  [6828] = {.lex_state = 116},
  [6829] = {.lex_state = 116},
  [6830] = {.lex_state = 116},
  [6831] = {.lex_state = 116},
  [6832] = {.lex_state = 116},
  [6833] = {.lex_state = 40, .external_lex_state = 4},
  [6834] = {.lex_state = 116},
  [6835] = {.lex_state = 116},
  [6836] = {.lex_state = 39, .external_lex_state = 4},
  [6837] = {.lex_state = 42, .external_lex_state = 4},
  [6838] = {.lex_state = 41, .external_lex_state = 4},
  [6839] = {.lex_state = 116},
  [6840] = {.lex_state = 39, .external_lex_state = 4},
  [6841] = {.lex_state = 39, .external_lex_state = 4},
  [6842] = {.lex_state = 116},
  [6843] = {.lex_state = 39, .external_lex_state = 4},
  [6844] = {.lex_state = 39, .external_lex_state = 4},
  [6845] = {.lex_state = 39, .external_lex_state = 4},
  [6846] = {.lex_state = 39, .external_lex_state = 4},
  [6847] = {.lex_state = 39, .external_lex_state = 4},
  [6848] = {.lex_state = 61, .external_lex_state = 4},
  [6849] = {.lex_state = 39, .external_lex_state = 4},
  [6850] = {.lex_state = 39, .external_lex_state = 4},
  [6851] = {.lex_state = 39, .external_lex_state = 4},
  [6852] = {.lex_state = 117},
  [6853] = {.lex_state = 39, .external_lex_state = 4},
  [6854] = {.lex_state = 116},
  [6855] = {.lex_state = 117},
  [6856] = {.lex_state = 120},
  [6857] = {.lex_state = 120},
  [6858] = {.lex_state = 120},
  [6859] = {.lex_state = 41, .external_lex_state = 4},
  [6860] = {.lex_state = 120},
  [6861] = {.lex_state = 120},
  [6862] = {.lex_state = 42, .external_lex_state = 4},
  [6863] = {.lex_state = 120},
  [6864] = {.lex_state = 120},
  [6865] = {.lex_state = 42, .external_lex_state = 4},
  [6866] = {.lex_state = 62, .external_lex_state = 4},
  [6867] = {.lex_state = 120},
  [6868] = {.lex_state = 120},
  [6869] = {.lex_state = 120},
  [6870] = {.lex_state = 120},
  [6871] = {.lex_state = 120},
  [6872] = {.lex_state = 120},
  [6873] = {.lex_state = 120},
  [6874] = {.lex_state = 120},
  [6875] = {.lex_state = 120},
  [6876] = {.lex_state = 120},
  [6877] = {.lex_state = 120},
  [6878] = {.lex_state = 42, .external_lex_state = 4},
  [6879] = {.lex_state = 120},
  [6880] = {.lex_state = 120},
  [6881] = {.lex_state = 120},
  [6882] = {.lex_state = 120},
  [6883] = {.lex_state = 120},
  [6884] = {.lex_state = 120},
  [6885] = {.lex_state = 120},
  [6886] = {.lex_state = 120},
  [6887] = {.lex_state = 62, .external_lex_state = 4},
  [6888] = {.lex_state = 120},
  [6889] = {.lex_state = 120},
  [6890] = {.lex_state = 120},
  [6891] = {.lex_state = 120},
  [6892] = {.lex_state = 120},
  [6893] = {.lex_state = 120},
  [6894] = {.lex_state = 120},
  [6895] = {.lex_state = 41, .external_lex_state = 4},
  [6896] = {.lex_state = 120},
  [6897] = {.lex_state = 120},
  [6898] = {.lex_state = 120},
  [6899] = {.lex_state = 117},
  [6900] = {.lex_state = 120},
  [6901] = {.lex_state = 42, .external_lex_state = 4},
  [6902] = {.lex_state = 42, .external_lex_state = 4},
  [6903] = {.lex_state = 61, .external_lex_state = 4},
  [6904] = {.lex_state = 117},
  [6905] = {.lex_state = 42, .external_lex_state = 4},
  [6906] = {.lex_state = 120},
  [6907] = {.lex_state = 42, .external_lex_state = 4},
  [6908] = {.lex_state = 120},
  [6909] = {.lex_state = 42, .external_lex_state = 4},
  [6910] = {.lex_state = 120},
  [6911] = {.lex_state = 120},
  [6912] = {.lex_state = 120},
  [6913] = {.lex_state = 120},
  [6914] = {.lex_state = 120},
  [6915] = {.lex_state = 120},
  [6916] = {.lex_state = 120},
  [6917] = {.lex_state = 62, .external_lex_state = 4},
  [6918] = {.lex_state = 120},
  [6919] = {.lex_state = 120},
  [6920] = {.lex_state = 62, .external_lex_state = 4},
  [6921] = {.lex_state = 120},
  [6922] = {.lex_state = 62, .external_lex_state = 4},
  [6923] = {.lex_state = 120},
  [6924] = {.lex_state = 120},
  [6925] = {.lex_state = 62, .external_lex_state = 4},
  [6926] = {.lex_state = 62, .external_lex_state = 4},
  [6927] = {.lex_state = 120},
  [6928] = {.lex_state = 120},
  [6929] = {.lex_state = 120},
  [6930] = {.lex_state = 62, .external_lex_state = 4},
  [6931] = {.lex_state = 62, .external_lex_state = 4},
  [6932] = {.lex_state = 120},
  [6933] = {.lex_state = 41, .external_lex_state = 4},
  [6934] = {.lex_state = 120},
  [6935] = {.lex_state = 120},
  [6936] = {.lex_state = 62, .external_lex_state = 4},
  [6937] = {.lex_state = 42, .external_lex_state = 4},
  [6938] = {.lex_state = 120},
  [6939] = {.lex_state = 41, .external_lex_state = 4},
  [6940] = {.lex_state = 120},
  [6941] = {.lex_state = 120},
  [6942] = {.lex_state = 41, .external_lex_state = 4},
  [6943] = {.lex_state = 41, .external_lex_state = 4},
  [6944] = {.lex_state = 63, .external_lex_state = 4},
  [6945] = {.lex_state = 62, .external_lex_state = 4},
  [6946] = {.lex_state = 120},
  [6947] = {.lex_state = 120},
  [6948] = {.lex_state = 120},
  [6949] = {.lex_state = 120},
  [6950] = {.lex_state = 120},
  [6951] = {.lex_state = 62, .external_lex_state = 4},
  [6952] = {.lex_state = 120},
  [6953] = {.lex_state = 120},
  [6954] = {.lex_state = 62, .external_lex_state = 4},
  [6955] = {.lex_state = 62, .external_lex_state = 4},
  [6956] = {.lex_state = 120},
  [6957] = {.lex_state = 120},
  [6958] = {.lex_state = 120},
  [6959] = {.lex_state = 120},
  [6960] = {.lex_state = 120},
  [6961] = {.lex_state = 120},
  [6962] = {.lex_state = 120},
  [6963] = {.lex_state = 120},
  [6964] = {.lex_state = 120},
  [6965] = {.lex_state = 120},
  [6966] = {.lex_state = 120},
  [6967] = {.lex_state = 120},
  [6968] = {.lex_state = 120},
  [6969] = {.lex_state = 120},
  [6970] = {.lex_state = 120},
  [6971] = {.lex_state = 120},
  [6972] = {.lex_state = 120},
  [6973] = {.lex_state = 120},
  [6974] = {.lex_state = 120},
  [6975] = {.lex_state = 120},
  [6976] = {.lex_state = 120},
  [6977] = {.lex_state = 120},
  [6978] = {.lex_state = 120},
  [6979] = {.lex_state = 120},
  [6980] = {.lex_state = 41, .external_lex_state = 4},
  [6981] = {.lex_state = 120},
  [6982] = {.lex_state = 120},
  [6983] = {.lex_state = 120},
  [6984] = {.lex_state = 120},
  [6985] = {.lex_state = 120},
  [6986] = {.lex_state = 120},
  [6987] = {.lex_state = 120},
  [6988] = {.lex_state = 120},
  [6989] = {.lex_state = 120},
  [6990] = {.lex_state = 120},
  [6991] = {.lex_state = 120},
  [6992] = {.lex_state = 120},
  [6993] = {.lex_state = 120},
  [6994] = {.lex_state = 120},
  [6995] = {.lex_state = 120},
  [6996] = {.lex_state = 41, .external_lex_state = 4},
  [6997] = {.lex_state = 41, .external_lex_state = 4},
  [6998] = {.lex_state = 42, .external_lex_state = 4},
  [6999] = {.lex_state = 120},
  [7000] = {.lex_state = 120},
  [7001] = {.lex_state = 120},
  [7002] = {.lex_state = 120},
  [7003] = {.lex_state = 120},
  [7004] = {.lex_state = 120},
  [7005] = {.lex_state = 120},
  [7006] = {.lex_state = 120},
  [7007] = {.lex_state = 120},
  [7008] = {.lex_state = 120},
  [7009] = {.lex_state = 41, .external_lex_state = 4},
  [7010] = {.lex_state = 41, .external_lex_state = 4},
  [7011] = {.lex_state = 120},
  [7012] = {.lex_state = 120},
  [7013] = {.lex_state = 120},
  [7014] = {.lex_state = 120},
  [7015] = {.lex_state = 120},
  [7016] = {.lex_state = 120},
  [7017] = {.lex_state = 120},
  [7018] = {.lex_state = 120},
  [7019] = {.lex_state = 120},
  [7020] = {.lex_state = 120},
  [7021] = {.lex_state = 120},
  [7022] = {.lex_state = 120},
  [7023] = {.lex_state = 120},
  [7024] = {.lex_state = 120},
  [7025] = {.lex_state = 120},
  [7026] = {.lex_state = 120},
  [7027] = {.lex_state = 120},
  [7028] = {.lex_state = 120},
  [7029] = {.lex_state = 120},
  [7030] = {.lex_state = 120},
  [7031] = {.lex_state = 120},
  [7032] = {.lex_state = 120},
  [7033] = {.lex_state = 41, .external_lex_state = 4},
  [7034] = {.lex_state = 120},
  [7035] = {.lex_state = 120},
  [7036] = {.lex_state = 120},
  [7037] = {.lex_state = 120},
  [7038] = {.lex_state = 120},
  [7039] = {.lex_state = 120},
  [7040] = {.lex_state = 120},
  [7041] = {.lex_state = 42, .external_lex_state = 4},
  [7042] = {.lex_state = 120},
  [7043] = {.lex_state = 120},
  [7044] = {.lex_state = 120},
  [7045] = {.lex_state = 120},
  [7046] = {.lex_state = 120},
  [7047] = {.lex_state = 120},
  [7048] = {.lex_state = 83, .external_lex_state = 4},
  [7049] = {.lex_state = 120},
  [7050] = {.lex_state = 120},
  [7051] = {.lex_state = 117},
  [7052] = {.lex_state = 43, .external_lex_state = 4},
  [7053] = {.lex_state = 120},
  [7054] = {.lex_state = 42, .external_lex_state = 4},
  [7055] = {.lex_state = 120},
  [7056] = {.lex_state = 120},
  [7057] = {.lex_state = 120},
  [7058] = {.lex_state = 120},
  [7059] = {.lex_state = 120},
  [7060] = {.lex_state = 120},
  [7061] = {.lex_state = 120},
  [7062] = {.lex_state = 120},
  [7063] = {.lex_state = 120},
  [7064] = {.lex_state = 120},
  [7065] = {.lex_state = 120},
  [7066] = {.lex_state = 61, .external_lex_state = 4},
  [7067] = {.lex_state = 120},
  [7068] = {.lex_state = 120},
  [7069] = {.lex_state = 61, .external_lex_state = 4},
  [7070] = {.lex_state = 61, .external_lex_state = 4},
  [7071] = {.lex_state = 61, .external_lex_state = 4},
  [7072] = {.lex_state = 61, .external_lex_state = 4},
  [7073] = {.lex_state = 61, .external_lex_state = 4},
  [7074] = {.lex_state = 120},
  [7075] = {.lex_state = 120},
  [7076] = {.lex_state = 120},
  [7077] = {.lex_state = 61, .external_lex_state = 4},
  [7078] = {.lex_state = 61, .external_lex_state = 4},
  [7079] = {.lex_state = 61, .external_lex_state = 4},
  [7080] = {.lex_state = 61, .external_lex_state = 4},
  [7081] = {.lex_state = 41, .external_lex_state = 4},
  [7082] = {.lex_state = 61, .external_lex_state = 4},
  [7083] = {.lex_state = 61, .external_lex_state = 4},
  [7084] = {.lex_state = 120},
  [7085] = {.lex_state = 41, .external_lex_state = 4},
  [7086] = {.lex_state = 120},
  [7087] = {.lex_state = 120},
  [7088] = {.lex_state = 120},
  [7089] = {.lex_state = 120},
  [7090] = {.lex_state = 120},
  [7091] = {.lex_state = 120},
  [7092] = {.lex_state = 120},
  [7093] = {.lex_state = 120},
  [7094] = {.lex_state = 117},
  [7095] = {.lex_state = 120},
  [7096] = {.lex_state = 120},
  [7097] = {.lex_state = 64, .external_lex_state = 4},
  [7098] = {.lex_state = 120},
  [7099] = {.lex_state = 117},
  [7100] = {.lex_state = 117},
  [7101] = {.lex_state = 117},
  [7102] = {.lex_state = 117},
  [7103] = {.lex_state = 120},
  [7104] = {.lex_state = 61, .external_lex_state = 4},
  [7105] = {.lex_state = 117},
  [7106] = {.lex_state = 42, .external_lex_state = 4},
  [7107] = {.lex_state = 117},
  [7108] = {.lex_state = 117},
  [7109] = {.lex_state = 120},
  [7110] = {.lex_state = 120},
  [7111] = {.lex_state = 42, .external_lex_state = 4},
  [7112] = {.lex_state = 120},
  [7113] = {.lex_state = 117},
  [7114] = {.lex_state = 43, .external_lex_state = 4},
  [7115] = {.lex_state = 94},
  [7116] = {.lex_state = 64, .external_lex_state = 4},
  [7117] = {.lex_state = 64, .external_lex_state = 4},
  [7118] = {.lex_state = 105, .external_lex_state = 4},
  [7119] = {.lex_state = 64, .external_lex_state = 4},
  [7120] = {.lex_state = 43, .external_lex_state = 4},
  [7121] = {.lex_state = 83, .external_lex_state = 4},
  [7122] = {.lex_state = 64, .external_lex_state = 4},
  [7123] = {.lex_state = 64, .external_lex_state = 4},
  [7124] = {.lex_state = 64, .external_lex_state = 4},
  [7125] = {.lex_state = 64, .external_lex_state = 4},
  [7126] = {.lex_state = 64, .external_lex_state = 4},
  [7127] = {.lex_state = 64, .external_lex_state = 4},
  [7128] = {.lex_state = 64, .external_lex_state = 4},
  [7129] = {.lex_state = 64, .external_lex_state = 4},
  [7130] = {.lex_state = 64, .external_lex_state = 4},
  [7131] = {.lex_state = 64, .external_lex_state = 4},
  [7132] = {.lex_state = 118, .external_lex_state = 4},
  [7133] = {.lex_state = 84, .external_lex_state = 4},
  [7134] = {.lex_state = 63, .external_lex_state = 4},
  [7135] = {.lex_state = 83, .external_lex_state = 4},
  [7136] = {.lex_state = 63, .external_lex_state = 4},
  [7137] = {.lex_state = 83, .external_lex_state = 4},
  [7138] = {.lex_state = 92},
  [7139] = {.lex_state = 64, .external_lex_state = 4},
  [7140] = {.lex_state = 63, .external_lex_state = 4},
  [7141] = {.lex_state = 43, .external_lex_state = 4},
  [7142] = {.lex_state = 85, .external_lex_state = 4},
  [7143] = {.lex_state = 65, .external_lex_state = 4},
  [7144] = {.lex_state = 63, .external_lex_state = 4},
  [7145] = {.lex_state = 63, .external_lex_state = 4},
  [7146] = {.lex_state = 43, .external_lex_state = 4},
  [7147] = {.lex_state = 83, .external_lex_state = 4},
  [7148] = {.lex_state = 43, .external_lex_state = 4},
  [7149] = {.lex_state = 43, .external_lex_state = 4},
  [7150] = {.lex_state = 63, .external_lex_state = 4},
  [7151] = {.lex_state = 63, .external_lex_state = 4},
  [7152] = {.lex_state = 63, .external_lex_state = 4},
  [7153] = {.lex_state = 83, .external_lex_state = 4},
  [7154] = {.lex_state = 63, .external_lex_state = 4},
  [7155] = {.lex_state = 83, .external_lex_state = 4},
  [7156] = {.lex_state = 63, .external_lex_state = 4},
  [7157] = {.lex_state = 63, .external_lex_state = 4},
  [7158] = {.lex_state = 63, .external_lex_state = 4},
  [7159] = {.lex_state = 63, .external_lex_state = 4},
  [7160] = {.lex_state = 4},
  [7161] = {.lex_state = 83, .external_lex_state = 4},
  [7162] = {.lex_state = 63, .external_lex_state = 4},
  [7163] = {.lex_state = 83, .external_lex_state = 4},
  [7164] = {.lex_state = 43, .external_lex_state = 4},
  [7165] = {.lex_state = 83, .external_lex_state = 4},
  [7166] = {.lex_state = 43, .external_lex_state = 4},
  [7167] = {.lex_state = 83, .external_lex_state = 4},
  [7168] = {.lex_state = 43, .external_lex_state = 4},
  [7169] = {.lex_state = 43, .external_lex_state = 4},
  [7170] = {.lex_state = 83, .external_lex_state = 4},
  [7171] = {.lex_state = 43, .external_lex_state = 4},
  [7172] = {.lex_state = 43, .external_lex_state = 4},
  [7173] = {.lex_state = 43, .external_lex_state = 4},
  [7174] = {.lex_state = 83, .external_lex_state = 4},
  [7175] = {.lex_state = 83, .external_lex_state = 4},
  [7176] = {.lex_state = 83, .external_lex_state = 4},
  [7177] = {.lex_state = 43, .external_lex_state = 4},
  [7178] = {.lex_state = 85, .external_lex_state = 4},
  [7179] = {.lex_state = 94},
  [7180] = {.lex_state = 85, .external_lex_state = 4},
  [7181] = {.lex_state = 85, .external_lex_state = 4},
  [7182] = {.lex_state = 4},
  [7183] = {.lex_state = 94},
  [7184] = {.lex_state = 4},
  [7185] = {.lex_state = 85, .external_lex_state = 4},
  [7186] = {.lex_state = 65, .external_lex_state = 4},
  [7187] = {.lex_state = 85, .external_lex_state = 4},
  [7188] = {.lex_state = 4},
  [7189] = {.lex_state = 4},
  [7190] = {.lex_state = 85, .external_lex_state = 4},
  [7191] = {.lex_state = 85, .external_lex_state = 4},
  [7192] = {.lex_state = 4},
  [7193] = {.lex_state = 4},
  [7194] = {.lex_state = 4},
  [7195] = {.lex_state = 4},
  [7196] = {.lex_state = 85, .external_lex_state = 4},
  [7197] = {.lex_state = 4},
  [7198] = {.lex_state = 85, .external_lex_state = 4},
  [7199] = {.lex_state = 85, .external_lex_state = 4},
  [7200] = {.lex_state = 4},
  [7201] = {.lex_state = 4},
  [7202] = {.lex_state = 4},
  [7203] = {.lex_state = 84, .external_lex_state = 4},
  [7204] = {.lex_state = 85, .external_lex_state = 4},
  [7205] = {.lex_state = 4},
  [7206] = {.lex_state = 85, .external_lex_state = 4},
  [7207] = {.lex_state = 17, .external_lex_state = 4},
  [7208] = {.lex_state = 118, .external_lex_state = 4},
  [7209] = {.lex_state = 65, .external_lex_state = 4},
  [7210] = {.lex_state = 6},
  [7211] = {.lex_state = 118, .external_lex_state = 4},
  [7212] = {.lex_state = 84, .external_lex_state = 4},
  [7213] = {.lex_state = 65, .external_lex_state = 4},
  [7214] = {.lex_state = 65, .external_lex_state = 4},
  [7215] = {.lex_state = 65, .external_lex_state = 4},
  [7216] = {.lex_state = 65, .external_lex_state = 4},
  [7217] = {.lex_state = 65, .external_lex_state = 4},
  [7218] = {.lex_state = 65, .external_lex_state = 4},
  [7219] = {.lex_state = 65, .external_lex_state = 4},
  [7220] = {.lex_state = 65, .external_lex_state = 4},
  [7221] = {.lex_state = 65, .external_lex_state = 4},
  [7222] = {.lex_state = 105, .external_lex_state = 4},
  [7223] = {.lex_state = 107, .external_lex_state = 4},
  [7224] = {.lex_state = 84, .external_lex_state = 4},
  [7225] = {.lex_state = 84, .external_lex_state = 4},
  [7226] = {.lex_state = 85, .external_lex_state = 4},
  [7227] = {.lex_state = 92},
  [7228] = {.lex_state = 65, .external_lex_state = 4},
  [7229] = {.lex_state = 65, .external_lex_state = 4},
  [7230] = {.lex_state = 86, .external_lex_state = 4},
  [7231] = {.lex_state = 84, .external_lex_state = 4},
  [7232] = {.lex_state = 94},
  [7233] = {.lex_state = 84, .external_lex_state = 4},
  [7234] = {.lex_state = 84, .external_lex_state = 4},
  [7235] = {.lex_state = 44},
  [7236] = {.lex_state = 84, .external_lex_state = 4},
  [7237] = {.lex_state = 4},
  [7238] = {.lex_state = 84, .external_lex_state = 4},
  [7239] = {.lex_state = 84, .external_lex_state = 4},
  [7240] = {.lex_state = 84, .external_lex_state = 4},
  [7241] = {.lex_state = 84, .external_lex_state = 4},
  [7242] = {.lex_state = 118, .external_lex_state = 4},
  [7243] = {.lex_state = 118, .external_lex_state = 4},
  [7244] = {.lex_state = 87, .external_lex_state = 4},
  [7245] = {.lex_state = 118, .external_lex_state = 4},
  [7246] = {.lex_state = 94},
  [7247] = {.lex_state = 118, .external_lex_state = 4},
  [7248] = {.lex_state = 118, .external_lex_state = 4},
  [7249] = {.lex_state = 84, .external_lex_state = 4},
  [7250] = {.lex_state = 45},
  [7251] = {.lex_state = 118, .external_lex_state = 4},
  [7252] = {.lex_state = 118, .external_lex_state = 4},
  [7253] = {.lex_state = 118, .external_lex_state = 4},
  [7254] = {.lex_state = 118, .external_lex_state = 4},
  [7255] = {.lex_state = 118, .external_lex_state = 4},
  [7256] = {.lex_state = 118, .external_lex_state = 4},
  [7257] = {.lex_state = 118, .external_lex_state = 4},
  [7258] = {.lex_state = 118, .external_lex_state = 4},
  [7259] = {.lex_state = 17},
  [7260] = {.lex_state = 65, .external_lex_state = 4},
  [7261] = {.lex_state = 118, .external_lex_state = 4},
  [7262] = {.lex_state = 94},
  [7263] = {.lex_state = 14},
  [7264] = {.lex_state = 84, .external_lex_state = 4},
  [7265] = {.lex_state = 85, .external_lex_state = 4},
  [7266] = {.lex_state = 94},
  [7267] = {.lex_state = 105, .external_lex_state = 4},
  [7268] = {.lex_state = 94},
  [7269] = {.lex_state = 94},
  [7270] = {.lex_state = 94},
  [7271] = {.lex_state = 105, .external_lex_state = 4},
  [7272] = {.lex_state = 105, .external_lex_state = 4},
  [7273] = {.lex_state = 94},
  [7274] = {.lex_state = 9},
  [7275] = {.lex_state = 105, .external_lex_state = 4},
  [7276] = {.lex_state = 105, .external_lex_state = 4},
  [7277] = {.lex_state = 105, .external_lex_state = 4},
  [7278] = {.lex_state = 105, .external_lex_state = 4},
  [7279] = {.lex_state = 94},
  [7280] = {.lex_state = 105, .external_lex_state = 4},
  [7281] = {.lex_state = 94},
  [7282] = {.lex_state = 94},
  [7283] = {.lex_state = 105, .external_lex_state = 4},
  [7284] = {.lex_state = 105, .external_lex_state = 4},
  [7285] = {.lex_state = 105, .external_lex_state = 4},
  [7286] = {.lex_state = 94},
  [7287] = {.lex_state = 94},
  [7288] = {.lex_state = 106, .external_lex_state = 4},
  [7289] = {.lex_state = 105, .external_lex_state = 4},
  [7290] = {.lex_state = 105, .external_lex_state = 4},
  [7291] = {.lex_state = 17, .external_lex_state = 4},
  [7292] = {.lex_state = 45},
  [7293] = {.lex_state = 106, .external_lex_state = 4},
  [7294] = {.lex_state = 9},
  [7295] = {.lex_state = 9},
  [7296] = {.lex_state = 12},
  [7297] = {.lex_state = 9},
  [7298] = {.lex_state = 9},
  [7299] = {.lex_state = 9},
  [7300] = {.lex_state = 9},
  [7301] = {.lex_state = 9},
  [7302] = {.lex_state = 87, .external_lex_state = 4},
  [7303] = {.lex_state = 9},
  [7304] = {.lex_state = 9},
  [7305] = {.lex_state = 9},
  [7306] = {.lex_state = 9},
  [7307] = {.lex_state = 87, .external_lex_state = 4},
  [7308] = {.lex_state = 14, .external_lex_state = 4},
  [7309] = {.lex_state = 6},
  [7310] = {.lex_state = 9},
  [7311] = {.lex_state = 109, .external_lex_state = 4},
  [7312] = {.lex_state = 6},
  [7313] = {.lex_state = 6},
  [7314] = {.lex_state = 6},
  [7315] = {.lex_state = 108, .external_lex_state = 4},
  [7316] = {.lex_state = 106, .external_lex_state = 4},
  [7317] = {.lex_state = 6},
  [7318] = {.lex_state = 91},
  [7319] = {.lex_state = 86, .external_lex_state = 4},
  [7320] = {.lex_state = 86, .external_lex_state = 4},
  [7321] = {.lex_state = 86, .external_lex_state = 4},
  [7322] = {.lex_state = 86, .external_lex_state = 4},
  [7323] = {.lex_state = 6},
  [7324] = {.lex_state = 86, .external_lex_state = 4},
  [7325] = {.lex_state = 86, .external_lex_state = 4},
  [7326] = {.lex_state = 86, .external_lex_state = 4},
  [7327] = {.lex_state = 86},
  [7328] = {.lex_state = 86, .external_lex_state = 4},
  [7329] = {.lex_state = 86, .external_lex_state = 4},
  [7330] = {.lex_state = 86, .external_lex_state = 4},
  [7331] = {.lex_state = 44},
  [7332] = {.lex_state = 49},
  [7333] = {.lex_state = 44},
  [7334] = {.lex_state = 14},
  [7335] = {.lex_state = 86, .external_lex_state = 4},
  [7336] = {.lex_state = 6},
  [7337] = {.lex_state = 6},
  [7338] = {.lex_state = 106, .external_lex_state = 4},
  [7339] = {.lex_state = 6},
  [7340] = {.lex_state = 6},
  [7341] = {.lex_state = 6},
  [7342] = {.lex_state = 86, .external_lex_state = 4},
  [7343] = {.lex_state = 48},
  [7344] = {.lex_state = 87, .external_lex_state = 4},
  [7345] = {.lex_state = 87, .external_lex_state = 4},
  [7346] = {.lex_state = 90},
  [7347] = {.lex_state = 44},
  [7348] = {.lex_state = 17, .external_lex_state = 4},
  [7349] = {.lex_state = 87, .external_lex_state = 4},
  [7350] = {.lex_state = 17, .external_lex_state = 4},
  [7351] = {.lex_state = 16},
  [7352] = {.lex_state = 87, .external_lex_state = 4},
  [7353] = {.lex_state = 107, .external_lex_state = 4},
  [7354] = {.lex_state = 107, .external_lex_state = 4},
  [7355] = {.lex_state = 107, .external_lex_state = 4},
  [7356] = {.lex_state = 107, .external_lex_state = 4},
  [7357] = {.lex_state = 14},
  [7358] = {.lex_state = 87, .external_lex_state = 4},
  [7359] = {.lex_state = 107, .external_lex_state = 4},
  [7360] = {.lex_state = 107, .external_lex_state = 4},
  [7361] = {.lex_state = 17, .external_lex_state = 4},
  [7362] = {.lex_state = 107, .external_lex_state = 4},
  [7363] = {.lex_state = 107, .external_lex_state = 4},
  [7364] = {.lex_state = 89},
  [7365] = {.lex_state = 107, .external_lex_state = 4},
  [7366] = {.lex_state = 17, .external_lex_state = 4},
  [7367] = {.lex_state = 107, .external_lex_state = 4},
  [7368] = {.lex_state = 107, .external_lex_state = 4},
  [7369] = {.lex_state = 17, .external_lex_state = 4},
  [7370] = {.lex_state = 6},
  [7371] = {.lex_state = 17, .external_lex_state = 4},
  [7372] = {.lex_state = 17, .external_lex_state = 4},
  [7373] = {.lex_state = 44},
  [7374] = {.lex_state = 17, .external_lex_state = 4},
  [7375] = {.lex_state = 44},
  [7376] = {.lex_state = 44},
  [7377] = {.lex_state = 17, .external_lex_state = 4},
  [7378] = {.lex_state = 44},
  [7379] = {.lex_state = 17, .external_lex_state = 4},
  [7380] = {.lex_state = 106, .external_lex_state = 4},
  [7381] = {.lex_state = 6},
  [7382] = {.lex_state = 17, .external_lex_state = 4},
  [7383] = {.lex_state = 44},
  [7384] = {.lex_state = 44},
  [7385] = {.lex_state = 9},
  [7386] = {.lex_state = 44},
  [7387] = {.lex_state = 44},
  [7388] = {.lex_state = 17, .external_lex_state = 4},
  [7389] = {.lex_state = 87, .external_lex_state = 4},
  [7390] = {.lex_state = 87, .external_lex_state = 4},
  [7391] = {.lex_state = 44},
  [7392] = {.lex_state = 14},
  [7393] = {.lex_state = 106, .external_lex_state = 4},
  [7394] = {.lex_state = 86, .external_lex_state = 4},
  [7395] = {.lex_state = 14},
  [7396] = {.lex_state = 106, .external_lex_state = 4},
  [7397] = {.lex_state = 9},
  [7398] = {.lex_state = 86, .external_lex_state = 4},
  [7399] = {.lex_state = 17, .external_lex_state = 4},
  [7400] = {.lex_state = 17, .external_lex_state = 4},
  [7401] = {.lex_state = 67},
  [7402] = {.lex_state = 107, .external_lex_state = 4},
  [7403] = {.lex_state = 66},
  [7404] = {.lex_state = 107, .external_lex_state = 4},
  [7405] = {.lex_state = 45},
  [7406] = {.lex_state = 45},
  [7407] = {.lex_state = 45},
  [7408] = {.lex_state = 45},
  [7409] = {.lex_state = 44},
  [7410] = {.lex_state = 45},
  [7411] = {.lex_state = 107, .external_lex_state = 4},
  [7412] = {.lex_state = 45},
  [7413] = {.lex_state = 17, .external_lex_state = 4},
  [7414] = {.lex_state = 106, .external_lex_state = 4},
  [7415] = {.lex_state = 45},
  [7416] = {.lex_state = 17},
  [7417] = {.lex_state = 45},
  [7418] = {.lex_state = 45},
  [7419] = {.lex_state = 87, .external_lex_state = 4},
  [7420] = {.lex_state = 17},
  [7421] = {.lex_state = 17},
  [7422] = {.lex_state = 106, .external_lex_state = 4},
  [7423] = {.lex_state = 45},
  [7424] = {.lex_state = 44},
  [7425] = {.lex_state = 14},
  [7426] = {.lex_state = 87, .external_lex_state = 4},
  [7427] = {.lex_state = 87, .external_lex_state = 4},
  [7428] = {.lex_state = 87, .external_lex_state = 4},
  [7429] = {.lex_state = 14},
  [7430] = {.lex_state = 106, .external_lex_state = 4},
  [7431] = {.lex_state = 14},
  [7432] = {.lex_state = 14},
  [7433] = {.lex_state = 17},
  [7434] = {.lex_state = 106, .external_lex_state = 4},
  [7435] = {.lex_state = 45},
  [7436] = {.lex_state = 106, .external_lex_state = 4},
  [7437] = {.lex_state = 14},
  [7438] = {.lex_state = 14},
  [7439] = {.lex_state = 14},
  [7440] = {.lex_state = 106, .external_lex_state = 4},
  [7441] = {.lex_state = 14},
  [7442] = {.lex_state = 14},
  [7443] = {.lex_state = 45},
  [7444] = {.lex_state = 87, .external_lex_state = 4},
  [7445] = {.lex_state = 14},
  [7446] = {.lex_state = 106, .external_lex_state = 4},
  [7447] = {.lex_state = 6},
  [7448] = {.lex_state = 106, .external_lex_state = 4},
  [7449] = {.lex_state = 17},
  [7450] = {.lex_state = 17},
  [7451] = {.lex_state = 17},
  [7452] = {.lex_state = 17},
  [7453] = {.lex_state = 17},
  [7454] = {.lex_state = 17},
  [7455] = {.lex_state = 17},
  [7456] = {.lex_state = 17},
  [7457] = {.lex_state = 17},
  [7458] = {.lex_state = 17},
  [7459] = {.lex_state = 17},
  [7460] = {.lex_state = 88},
  [7461] = {.lex_state = 17},
  [7462] = {.lex_state = 45},
  [7463] = {.lex_state = 86},
  [7464] = {.lex_state = 95},
  [7465] = {.lex_state = 108},
  [7466] = {.lex_state = 67},
  [7467] = {.lex_state = 48},
  [7468] = {.lex_state = 48},
  [7469] = {.lex_state = 67},
  [7470] = {.lex_state = 48},
  [7471] = {.lex_state = 66},
  [7472] = {.lex_state = 14, .external_lex_state = 4},
  [7473] = {.lex_state = 89},
  [7474] = {.lex_state = 67},
  [7475] = {.lex_state = 67},
  [7476] = {.lex_state = 48},
  [7477] = {.lex_state = 14, .external_lex_state = 4},
  [7478] = {.lex_state = 67},
  [7479] = {.lex_state = 14, .external_lex_state = 4},
  [7480] = {.lex_state = 48},
  [7481] = {.lex_state = 48},
  [7482] = {.lex_state = 14, .external_lex_state = 4},
  [7483] = {.lex_state = 48},
  [7484] = {.lex_state = 67},
  [7485] = {.lex_state = 67},
  [7486] = {.lex_state = 14, .external_lex_state = 4},
  [7487] = {.lex_state = 88},
  [7488] = {.lex_state = 49},
  [7489] = {.lex_state = 49},
  [7490] = {.lex_state = 14, .external_lex_state = 4},
  [7491] = {.lex_state = 88},
  [7492] = {.lex_state = 72},
  [7493] = {.lex_state = 48},
  [7494] = {.lex_state = 48},
  [7495] = {.lex_state = 89},
  [7496] = {.lex_state = 67},
  [7497] = {.lex_state = 48},
  [7498] = {.lex_state = 14, .external_lex_state = 4},
  [7499] = {.lex_state = 86},
  [7500] = {.lex_state = 88},
  [7501] = {.lex_state = 89},
  [7502] = {.lex_state = 89},
  [7503] = {.lex_state = 109, .external_lex_state = 4},
  [7504] = {.lex_state = 86},
  [7505] = {.lex_state = 108, .external_lex_state = 4},
  [7506] = {.lex_state = 86},
  [7507] = {.lex_state = 67},
  [7508] = {.lex_state = 49},
  [7509] = {.lex_state = 67},
  [7510] = {.lex_state = 89},
  [7511] = {.lex_state = 89},
  [7512] = {.lex_state = 49},
  [7513] = {.lex_state = 89},
  [7514] = {.lex_state = 88},
  [7515] = {.lex_state = 88},
  [7516] = {.lex_state = 89},
  [7517] = {.lex_state = 49},
  [7518] = {.lex_state = 12},
  [7519] = {.lex_state = 88},
  [7520] = {.lex_state = 49},
  [7521] = {.lex_state = 49},
  [7522] = {.lex_state = 49},
  [7523] = {.lex_state = 12},
  [7524] = {.lex_state = 14, .external_lex_state = 4},
  [7525] = {.lex_state = 67},
  [7526] = {.lex_state = 48},
  [7527] = {.lex_state = 14, .external_lex_state = 4},
  [7528] = {.lex_state = 14, .external_lex_state = 4},
  [7529] = {.lex_state = 88},
  [7530] = {.lex_state = 90},
  [7531] = {.lex_state = 89},
  [7532] = {.lex_state = 89},
  [7533] = {.lex_state = 67},
  [7534] = {.lex_state = 89},
  [7535] = {.lex_state = 14, .external_lex_state = 4},
  [7536] = {.lex_state = 14, .external_lex_state = 4},
  [7537] = {.lex_state = 86},
  [7538] = {.lex_state = 86},
  [7539] = {.lex_state = 49},
  [7540] = {.lex_state = 14, .external_lex_state = 4},
  [7541] = {.lex_state = 49},
  [7542] = {.lex_state = 95, .external_lex_state = 4},
  [7543] = {.lex_state = 86},
  [7544] = {.lex_state = 91},
  [7545] = {.lex_state = 48},
  [7546] = {.lex_state = 66},
  [7547] = {.lex_state = 86},
  [7548] = {.lex_state = 49},
  [7549] = {.lex_state = 88},
  [7550] = {.lex_state = 88},
  [7551] = {.lex_state = 48},
  [7552] = {.lex_state = 90},
  [7553] = {.lex_state = 86},
  [7554] = {.lex_state = 86},
  [7555] = {.lex_state = 90},
  [7556] = {.lex_state = 14, .external_lex_state = 4},
  [7557] = {.lex_state = 90},
  [7558] = {.lex_state = 86},
  [7559] = {.lex_state = 90},
  [7560] = {.lex_state = 90},
  [7561] = {.lex_state = 90},
  [7562] = {.lex_state = 90},
  [7563] = {.lex_state = 90},
  [7564] = {.lex_state = 108, .external_lex_state = 4},
  [7565] = {.lex_state = 90},
  [7566] = {.lex_state = 48},
  [7567] = {.lex_state = 90},
  [7568] = {.lex_state = 90},
  [7569] = {.lex_state = 89},
  [7570] = {.lex_state = 88},
  [7571] = {.lex_state = 108, .external_lex_state = 4},
  [7572] = {.lex_state = 89},
  [7573] = {.lex_state = 91},
  [7574] = {.lex_state = 49},
  [7575] = {.lex_state = 91},
  [7576] = {.lex_state = 91},
  [7577] = {.lex_state = 108, .external_lex_state = 4},
  [7578] = {.lex_state = 91},
  [7579] = {.lex_state = 91},
  [7580] = {.lex_state = 88},
  [7581] = {.lex_state = 86},
  [7582] = {.lex_state = 16},
  [7583] = {.lex_state = 108, .external_lex_state = 4},
  [7584] = {.lex_state = 16},
  [7585] = {.lex_state = 91},
  [7586] = {.lex_state = 91},
  [7587] = {.lex_state = 16},
  [7588] = {.lex_state = 91},
  [7589] = {.lex_state = 91},
  [7590] = {.lex_state = 16},
  [7591] = {.lex_state = 91},
  [7592] = {.lex_state = 90},
  [7593] = {.lex_state = 108, .external_lex_state = 4},
  [7594] = {.lex_state = 88},
  [7595] = {.lex_state = 108, .external_lex_state = 4},
  [7596] = {.lex_state = 67},
  [7597] = {.lex_state = 90},
  [7598] = {.lex_state = 16},
  [7599] = {.lex_state = 108, .external_lex_state = 4},
  [7600] = {.lex_state = 109, .external_lex_state = 4},
  [7601] = {.lex_state = 111},
  [7602] = {.lex_state = 16},
  [7603] = {.lex_state = 109, .external_lex_state = 4},
  [7604] = {.lex_state = 109, .external_lex_state = 4},
  [7605] = {.lex_state = 108, .external_lex_state = 4},
  [7606] = {.lex_state = 88},
  [7607] = {.lex_state = 16},
  [7608] = {.lex_state = 16},
  [7609] = {.lex_state = 16},
  [7610] = {.lex_state = 16},
  [7611] = {.lex_state = 49},
  [7612] = {.lex_state = 16},
  [7613] = {.lex_state = 49},
  [7614] = {.lex_state = 108, .external_lex_state = 4},
  [7615] = {.lex_state = 67},
  [7616] = {.lex_state = 66},
  [7617] = {.lex_state = 108, .external_lex_state = 4},
  [7618] = {.lex_state = 108, .external_lex_state = 4},
  [7619] = {.lex_state = 109, .external_lex_state = 4},
  [7620] = {.lex_state = 109, .external_lex_state = 4},
  [7621] = {.lex_state = 66},
  [7622] = {.lex_state = 109, .external_lex_state = 4},
  [7623] = {.lex_state = 109, .external_lex_state = 4},
  [7624] = {.lex_state = 109, .external_lex_state = 4},
  [7625] = {.lex_state = 109, .external_lex_state = 4},
  [7626] = {.lex_state = 16},
  [7627] = {.lex_state = 109, .external_lex_state = 4},
  [7628] = {.lex_state = 86},
  [7629] = {.lex_state = 91},
  [7630] = {.lex_state = 12},
  [7631] = {.lex_state = 12},
  [7632] = {.lex_state = 88},
  [7633] = {.lex_state = 86},
  [7634] = {.lex_state = 16},
  [7635] = {.lex_state = 91},
  [7636] = {.lex_state = 89},
  [7637] = {.lex_state = 109, .external_lex_state = 4},
  [7638] = {.lex_state = 109, .external_lex_state = 4},
  [7639] = {.lex_state = 113},
  [7640] = {.lex_state = 16, .external_lex_state = 4},
  [7641] = {.lex_state = 12},
  [7642] = {.lex_state = 109, .external_lex_state = 4},
  [7643] = {.lex_state = 73},
  [7644] = {.lex_state = 108, .external_lex_state = 4},
  [7645] = {.lex_state = 12},
  [7646] = {.lex_state = 110},
  [7647] = {.lex_state = 12},
  [7648] = {.lex_state = 12},
  [7649] = {.lex_state = 108, .external_lex_state = 4},
  [7650] = {.lex_state = 12},
  [7651] = {.lex_state = 91},
  [7652] = {.lex_state = 66},
  [7653] = {.lex_state = 12},
  [7654] = {.lex_state = 66},
  [7655] = {.lex_state = 12},
  [7656] = {.lex_state = 12},
  [7657] = {.lex_state = 12},
  [7658] = {.lex_state = 66},
  [7659] = {.lex_state = 12},
  [7660] = {.lex_state = 66},
  [7661] = {.lex_state = 66},
  [7662] = {.lex_state = 16},
  [7663] = {.lex_state = 112},
  [7664] = {.lex_state = 66},
  [7665] = {.lex_state = 66},
  [7666] = {.lex_state = 66},
  [7667] = {.lex_state = 66},
  [7668] = {.lex_state = 66},
  [7669] = {.lex_state = 113},
  [7670] = {.lex_state = 95},
  [7671] = {.lex_state = 95, .external_lex_state = 4},
  [7672] = {.lex_state = 73},
  [7673] = {.lex_state = 16, .external_lex_state = 4},
  [7674] = {.lex_state = 72},
  [7675] = {.lex_state = 16, .external_lex_state = 4},
  [7676] = {.lex_state = 112},
  [7677] = {.lex_state = 110},
  [7678] = {.lex_state = 113},
  [7679] = {.lex_state = 73},
  [7680] = {.lex_state = 72},
  [7681] = {.lex_state = 108},
  [7682] = {.lex_state = 73},
  [7683] = {.lex_state = 73},
  [7684] = {.lex_state = 16, .external_lex_state = 4},
  [7685] = {.lex_state = 112},
  [7686] = {.lex_state = 112},
  [7687] = {.lex_state = 73},
  [7688] = {.lex_state = 113},
  [7689] = {.lex_state = 73},
  [7690] = {.lex_state = 95},
  [7691] = {.lex_state = 73},
  [7692] = {.lex_state = 95, .external_lex_state = 4},
  [7693] = {.lex_state = 73},
  [7694] = {.lex_state = 110},
  [7695] = {.lex_state = 16, .external_lex_state = 4},
  [7696] = {.lex_state = 95},
  [7697] = {.lex_state = 16, .external_lex_state = 4},
  [7698] = {.lex_state = 108},
  [7699] = {.lex_state = 112},
  [7700] = {.lex_state = 73},
  [7701] = {.lex_state = 73},
  [7702] = {.lex_state = 73},
  [7703] = {.lex_state = 108},
  [7704] = {.lex_state = 112},
  [7705] = {.lex_state = 16, .external_lex_state = 4},
  [7706] = {.lex_state = 108},
  [7707] = {.lex_state = 112},
  [7708] = {.lex_state = 111},
  [7709] = {.lex_state = 72},
  [7710] = {.lex_state = 112},
  [7711] = {.lex_state = 112},
  [7712] = {.lex_state = 72},
  [7713] = {.lex_state = 108},
  [7714] = {.lex_state = 108},
  [7715] = {.lex_state = 113},
  [7716] = {.lex_state = 113},
  [7717] = {.lex_state = 113},
  [7718] = {.lex_state = 111},
  [7719] = {.lex_state = 16, .external_lex_state = 4},
  [7720] = {.lex_state = 72},
  [7721] = {.lex_state = 108},
  [7722] = {.lex_state = 108},
  [7723] = {.lex_state = 113},
  [7724] = {.lex_state = 95, .external_lex_state = 4},
  [7725] = {.lex_state = 120},
  [7726] = {.lex_state = 113},
  [7727] = {.lex_state = 108},
  [7728] = {.lex_state = 72},
  [7729] = {.lex_state = 113},
  [7730] = {.lex_state = 108},
  [7731] = {.lex_state = 95, .external_lex_state = 4},
  [7732] = {.lex_state = 112},
  [7733] = {.lex_state = 112},
  [7734] = {.lex_state = 108},
  [7735] = {.lex_state = 95},
  [7736] = {.lex_state = 95, .external_lex_state = 4},
  [7737] = {.lex_state = 113},
  [7738] = {.lex_state = 111},
  [7739] = {.lex_state = 72},
  [7740] = {.lex_state = 72},
  [7741] = {.lex_state = 112},
  [7742] = {.lex_state = 95, .external_lex_state = 4},
  [7743] = {.lex_state = 108},
  [7744] = {.lex_state = 113},
  [7745] = {.lex_state = 72},
  [7746] = {.lex_state = 120},
  [7747] = {.lex_state = 108},
  [7748] = {.lex_state = 16, .external_lex_state = 4},
  [7749] = {.lex_state = 95},
  [7750] = {.lex_state = 95, .external_lex_state = 4},
  [7751] = {.lex_state = 95},
  [7752] = {.lex_state = 112},
  [7753] = {.lex_state = 95, .external_lex_state = 4},
  [7754] = {.lex_state = 72},
  [7755] = {.lex_state = 16, .external_lex_state = 4},
  [7756] = {.lex_state = 113},
  [7757] = {.lex_state = 72},
  [7758] = {.lex_state = 111},
  [7759] = {.lex_state = 72},
  [7760] = {.lex_state = 113},
  [7761] = {.lex_state = 72},
  [7762] = {.lex_state = 72},
  [7763] = {.lex_state = 16, .external_lex_state = 4},
  [7764] = {.lex_state = 110},
  [7765] = {.lex_state = 111},
  [7766] = {.lex_state = 95, .external_lex_state = 4},
  [7767] = {.lex_state = 108},
  [7768] = {.lex_state = 113},
  [7769] = {.lex_state = 95},
  [7770] = {.lex_state = 110},
  [7771] = {.lex_state = 95},
  [7772] = {.lex_state = 110},
  [7773] = {.lex_state = 16, .external_lex_state = 4},
  [7774] = {.lex_state = 110},
  [7775] = {.lex_state = 16, .external_lex_state = 4},
  [7776] = {.lex_state = 73},
  [7777] = {.lex_state = 111},
  [7778] = {.lex_state = 73},
  [7779] = {.lex_state = 16, .external_lex_state = 4},
  [7780] = {.lex_state = 95},
  [7781] = {.lex_state = 110},
  [7782] = {.lex_state = 184},
  [7783] = {.lex_state = 95},
  [7784] = {.lex_state = 111},
  [7785] = {.lex_state = 95, .external_lex_state = 4},
  [7786] = {.lex_state = 16, .external_lex_state = 4},
  [7787] = {.lex_state = 95, .external_lex_state = 4},
  [7788] = {.lex_state = 95, .external_lex_state = 4},
  [7789] = {.lex_state = 95, .external_lex_state = 4},
  [7790] = {.lex_state = 110},
  [7791] = {.lex_state = 110},
  [7792] = {.lex_state = 111},
  [7793] = {.lex_state = 95, .external_lex_state = 4},
  [7794] = {.lex_state = 110},
  [7795] = {.lex_state = 110},
  [7796] = {.lex_state = 95},
  [7797] = {.lex_state = 95},
  [7798] = {.lex_state = 111},
  [7799] = {.lex_state = 111},
  [7800] = {.lex_state = 110},
  [7801] = {.lex_state = 112},
  [7802] = {.lex_state = 110},
  [7803] = {.lex_state = 110},
  [7804] = {.lex_state = 111},
  [7805] = {.lex_state = 111},
  [7806] = {.lex_state = 73},
  [7807] = {.lex_state = 95},
  [7808] = {.lex_state = 111},
  [7809] = {.lex_state = 112},
  [7810] = {.lex_state = 95},
  [7811] = {.lex_state = 111},
  [7812] = {.lex_state = 184},
  [7813] = {.lex_state = 184},
  [7814] = {.lex_state = 184},
  [7815] = {.lex_state = 184},
  [7816] = {.lex_state = 184},
  [7817] = {.lex_state = 184},
  [7818] = {.lex_state = 184},
  [7819] = {.lex_state = 184},
  [7820] = {.lex_state = 184},
  [7821] = {.lex_state = 184},
  [7822] = {.lex_state = 184},
  [7823] = {.lex_state = 184},
  [7824] = {.lex_state = 119},
  [7825] = {.lex_state = 184},
  [7826] = {.lex_state = 184},
  [7827] = {.lex_state = 120},
  [7828] = {.lex_state = 119},
  [7829] = {.lex_state = 120},
  [7830] = {.lex_state = 119},
  [7831] = {.lex_state = 119},
  [7832] = {.lex_state = 119},
  [7833] = {.lex_state = 119},
  [7834] = {.lex_state = 119},
  [7835] = {.lex_state = 119},
  [7836] = {.lex_state = 119},
  [7837] = {.lex_state = 119},
  [7838] = {.lex_state = 120},
  [7839] = {.lex_state = 119},
  [7840] = {.lex_state = 119},
  [7841] = {.lex_state = 119},
  [7842] = {.lex_state = 120},
  [7843] = {.lex_state = 119},
  [7844] = {.lex_state = 119},
  [7845] = {.lex_state = 197, .external_lex_state = 4},
  [7846] = {.lex_state = 197, .external_lex_state = 4},
  [7847] = {.lex_state = 240, .external_lex_state = 2},
  [7848] = {.lex_state = 197, .external_lex_state = 4},
  [7849] = {.lex_state = 197, .external_lex_state = 4},
  [7850] = {.lex_state = 197, .external_lex_state = 4},
  [7851] = {.lex_state = 197, .external_lex_state = 4},
  [7852] = {.lex_state = 197, .external_lex_state = 4},
  [7853] = {.lex_state = 240, .external_lex_state = 2},
  [7854] = {.lex_state = 197, .external_lex_state = 4},
  [7855] = {.lex_state = 197, .external_lex_state = 4},
  [7856] = {.lex_state = 197, .external_lex_state = 4},
  [7857] = {.lex_state = 197, .external_lex_state = 4},
  [7858] = {.lex_state = 198, .external_lex_state = 4},
  [7859] = {.lex_state = 207, .external_lex_state = 4},
  [7860] = {.lex_state = 199, .external_lex_state = 4},
  [7861] = {.lex_state = 199, .external_lex_state = 4},
  [7862] = {.lex_state = 199, .external_lex_state = 4},
  [7863] = {.lex_state = 207, .external_lex_state = 4},
  [7864] = {.lex_state = 199, .external_lex_state = 4},
  [7865] = {.lex_state = 199, .external_lex_state = 4},
  [7866] = {.lex_state = 198, .external_lex_state = 4},
  [7867] = {.lex_state = 207, .external_lex_state = 4},
  [7868] = {.lex_state = 198, .external_lex_state = 4},
  [7869] = {.lex_state = 198, .external_lex_state = 4},
  [7870] = {.lex_state = 199, .external_lex_state = 4},
  [7871] = {.lex_state = 198, .external_lex_state = 4},
  [7872] = {.lex_state = 199, .external_lex_state = 4},
  [7873] = {.lex_state = 207, .external_lex_state = 4},
  [7874] = {.lex_state = 198, .external_lex_state = 4},
  [7875] = {.lex_state = 207, .external_lex_state = 4},
  [7876] = {.lex_state = 207, .external_lex_state = 4},
  [7877] = {.lex_state = 240},
  [7878] = {.lex_state = 207, .external_lex_state = 4},
  [7879] = {.lex_state = 198, .external_lex_state = 4},
  [7880] = {.lex_state = 199, .external_lex_state = 4},
  [7881] = {.lex_state = 207, .external_lex_state = 4},
  [7882] = {.lex_state = 207, .external_lex_state = 4},
  [7883] = {.lex_state = 199, .external_lex_state = 4},
  [7884] = {.lex_state = 198, .external_lex_state = 4},
  [7885] = {.lex_state = 207, .external_lex_state = 4},
  [7886] = {.lex_state = 198, .external_lex_state = 4},
  [7887] = {.lex_state = 207, .external_lex_state = 4},
  [7888] = {.lex_state = 198, .external_lex_state = 4},
  [7889] = {.lex_state = 199, .external_lex_state = 4},
  [7890] = {.lex_state = 198, .external_lex_state = 4},
  [7891] = {.lex_state = 199, .external_lex_state = 4},
  [7892] = {.lex_state = 200, .external_lex_state = 4},
  [7893] = {.lex_state = 200, .external_lex_state = 4},
  [7894] = {.lex_state = 208, .external_lex_state = 4},
  [7895] = {.lex_state = 208, .external_lex_state = 4},
  [7896] = {.lex_state = 208, .external_lex_state = 4},
  [7897] = {.lex_state = 208, .external_lex_state = 4},
  [7898] = {.lex_state = 208, .external_lex_state = 4},
  [7899] = {.lex_state = 200, .external_lex_state = 4},
  [7900] = {.lex_state = 208, .external_lex_state = 4},
  [7901] = {.lex_state = 208, .external_lex_state = 4},
  [7902] = {.lex_state = 201, .external_lex_state = 4},
  [7903] = {.lex_state = 201, .external_lex_state = 4},
  [7904] = {.lex_state = 201, .external_lex_state = 4},
  [7905] = {.lex_state = 201, .external_lex_state = 4},
  [7906] = {.lex_state = 209, .external_lex_state = 4},
  [7907] = {.lex_state = 209, .external_lex_state = 4},
  [7908] = {.lex_state = 200, .external_lex_state = 4},
  [7909] = {.lex_state = 201, .external_lex_state = 4},
  [7910] = {.lex_state = 208, .external_lex_state = 4},
  [7911] = {.lex_state = 201, .external_lex_state = 4},
  [7912] = {.lex_state = 208, .external_lex_state = 4},
  [7913] = {.lex_state = 209, .external_lex_state = 4},
  [7914] = {.lex_state = 208, .external_lex_state = 4},
  [7915] = {.lex_state = 208, .external_lex_state = 4},
  [7916] = {.lex_state = 201, .external_lex_state = 4},
  [7917] = {.lex_state = 201, .external_lex_state = 4},
  [7918] = {.lex_state = 209, .external_lex_state = 4},
  [7919] = {.lex_state = 200, .external_lex_state = 4},
  [7920] = {.lex_state = 201, .external_lex_state = 4},
  [7921] = {.lex_state = 200, .external_lex_state = 4},
  [7922] = {.lex_state = 200, .external_lex_state = 4},
  [7923] = {.lex_state = 209, .external_lex_state = 4},
  [7924] = {.lex_state = 209, .external_lex_state = 4},
  [7925] = {.lex_state = 209, .external_lex_state = 4},
  [7926] = {.lex_state = 200, .external_lex_state = 4},
  [7927] = {.lex_state = 201, .external_lex_state = 4},
  [7928] = {.lex_state = 209, .external_lex_state = 4},
  [7929] = {.lex_state = 209, .external_lex_state = 4},
  [7930] = {.lex_state = 209, .external_lex_state = 4},
  [7931] = {.lex_state = 200, .external_lex_state = 4},
  [7932] = {.lex_state = 200, .external_lex_state = 4},
  [7933] = {.lex_state = 209, .external_lex_state = 4},
  [7934] = {.lex_state = 201, .external_lex_state = 4},
  [7935] = {.lex_state = 200, .external_lex_state = 4},
  [7936] = {.lex_state = 237},
  [7937] = {.lex_state = 236},
  [7938] = {.lex_state = 236},
  [7939] = {.lex_state = 217, .external_lex_state = 4},
  [7940] = {.lex_state = 210, .external_lex_state = 4},
  [7941] = {.lex_state = 217, .external_lex_state = 4},
  [7942] = {.lex_state = 202, .external_lex_state = 4},
  [7943] = {.lex_state = 202, .external_lex_state = 4},
  [7944] = {.lex_state = 236},
  [7945] = {.lex_state = 236},
  [7946] = {.lex_state = 202, .external_lex_state = 4},
  [7947] = {.lex_state = 217, .external_lex_state = 4},
  [7948] = {.lex_state = 202, .external_lex_state = 4},
  [7949] = {.lex_state = 237},
  [7950] = {.lex_state = 217, .external_lex_state = 4},
  [7951] = {.lex_state = 211, .external_lex_state = 4},
  [7952] = {.lex_state = 211, .external_lex_state = 4},
  [7953] = {.lex_state = 211, .external_lex_state = 4},
  [7954] = {.lex_state = 236},
  [7955] = {.lex_state = 217, .external_lex_state = 4},
  [7956] = {.lex_state = 236},
  [7957] = {.lex_state = 236},
  [7958] = {.lex_state = 236},
  [7959] = {.lex_state = 236},
  [7960] = {.lex_state = 236},
  [7961] = {.lex_state = 211, .external_lex_state = 4},
  [7962] = {.lex_state = 217, .external_lex_state = 4},
  [7963] = {.lex_state = 236},
  [7964] = {.lex_state = 236},
  [7965] = {.lex_state = 210, .external_lex_state = 4},
  [7966] = {.lex_state = 236},
  [7967] = {.lex_state = 210, .external_lex_state = 4},
  [7968] = {.lex_state = 236},
  [7969] = {.lex_state = 237},
  [7970] = {.lex_state = 211, .external_lex_state = 4},
  [7971] = {.lex_state = 210, .external_lex_state = 4},
  [7972] = {.lex_state = 236},
  [7973] = {.lex_state = 236},
  [7974] = {.lex_state = 236},
  [7975] = {.lex_state = 236},
  [7976] = {.lex_state = 236},
  [7977] = {.lex_state = 236},
  [7978] = {.lex_state = 236},
  [7979] = {.lex_state = 217, .external_lex_state = 4},
  [7980] = {.lex_state = 236},
  [7981] = {.lex_state = 236},
  [7982] = {.lex_state = 236},
  [7983] = {.lex_state = 210, .external_lex_state = 4},
  [7984] = {.lex_state = 210, .external_lex_state = 4},
  [7985] = {.lex_state = 236},
  [7986] = {.lex_state = 217, .external_lex_state = 4},
  [7987] = {.lex_state = 202, .external_lex_state = 4},
  [7988] = {.lex_state = 211, .external_lex_state = 4},
  [7989] = {.lex_state = 211, .external_lex_state = 4},
  [7990] = {.lex_state = 236},
  [7991] = {.lex_state = 217, .external_lex_state = 4},
  [7992] = {.lex_state = 236},
  [7993] = {.lex_state = 210, .external_lex_state = 4},
  [7994] = {.lex_state = 236},
  [7995] = {.lex_state = 236},
  [7996] = {.lex_state = 217, .external_lex_state = 4},
  [7997] = {.lex_state = 236},
  [7998] = {.lex_state = 236},
  [7999] = {.lex_state = 236},
  [8000] = {.lex_state = 202, .external_lex_state = 4},
  [8001] = {.lex_state = 210, .external_lex_state = 4},
  [8002] = {.lex_state = 236},
  [8003] = {.lex_state = 202, .external_lex_state = 4},
  [8004] = {.lex_state = 211, .external_lex_state = 4},
  [8005] = {.lex_state = 210, .external_lex_state = 4},
  [8006] = {.lex_state = 236},
  [8007] = {.lex_state = 236},
  [8008] = {.lex_state = 236},
  [8009] = {.lex_state = 237},
  [8010] = {.lex_state = 202, .external_lex_state = 4},
  [8011] = {.lex_state = 211, .external_lex_state = 4},
  [8012] = {.lex_state = 202, .external_lex_state = 4},
  [8013] = {.lex_state = 217, .external_lex_state = 4},
  [8014] = {.lex_state = 202, .external_lex_state = 4},
  [8015] = {.lex_state = 211, .external_lex_state = 4},
  [8016] = {.lex_state = 236},
  [8017] = {.lex_state = 236},
  [8018] = {.lex_state = 236},
  [8019] = {.lex_state = 202, .external_lex_state = 4},
  [8020] = {.lex_state = 236},
  [8021] = {.lex_state = 210, .external_lex_state = 4},
  [8022] = {.lex_state = 211, .external_lex_state = 4},
  [8023] = {.lex_state = 236},
  [8024] = {.lex_state = 236},
  [8025] = {.lex_state = 236},
  [8026] = {.lex_state = 236},
  [8027] = {.lex_state = 210, .external_lex_state = 4},
  [8028] = {.lex_state = 236},
  [8029] = {.lex_state = 236},
  [8030] = {.lex_state = 212, .external_lex_state = 4},
  [8031] = {.lex_state = 241},
  [8032] = {.lex_state = 241},
  [8033] = {.lex_state = 241},
  [8034] = {.lex_state = 218, .external_lex_state = 4},
  [8035] = {.lex_state = 241},
  [8036] = {.lex_state = 219, .external_lex_state = 4},
  [8037] = {.lex_state = 227, .external_lex_state = 4},
  [8038] = {.lex_state = 241},
  [8039] = {.lex_state = 241},
  [8040] = {.lex_state = 241},
  [8041] = {.lex_state = 241},
  [8042] = {.lex_state = 212, .external_lex_state = 4},
  [8043] = {.lex_state = 238},
  [8044] = {.lex_state = 241},
  [8045] = {.lex_state = 227, .external_lex_state = 4},
  [8046] = {.lex_state = 227, .external_lex_state = 4},
  [8047] = {.lex_state = 241},
  [8048] = {.lex_state = 218, .external_lex_state = 4},
  [8049] = {.lex_state = 227, .external_lex_state = 4},
  [8050] = {.lex_state = 227, .external_lex_state = 4},
  [8051] = {.lex_state = 241},
  [8052] = {.lex_state = 227, .external_lex_state = 4},
  [8053] = {.lex_state = 241},
  [8054] = {.lex_state = 241},
  [8055] = {.lex_state = 227, .external_lex_state = 4},
  [8056] = {.lex_state = 218, .external_lex_state = 4},
  [8057] = {.lex_state = 227, .external_lex_state = 4},
  [8058] = {.lex_state = 241},
  [8059] = {.lex_state = 191},
  [8060] = {.lex_state = 191},
  [8061] = {.lex_state = 241},
  [8062] = {.lex_state = 241},
  [8063] = {.lex_state = 236},
  [8064] = {.lex_state = 241},
  [8065] = {.lex_state = 218, .external_lex_state = 4},
  [8066] = {.lex_state = 241},
  [8067] = {.lex_state = 241},
  [8068] = {.lex_state = 219, .external_lex_state = 4},
  [8069] = {.lex_state = 218, .external_lex_state = 4},
  [8070] = {.lex_state = 237},
  [8071] = {.lex_state = 227, .external_lex_state = 4},
  [8072] = {.lex_state = 241},
  [8073] = {.lex_state = 227, .external_lex_state = 4},
  [8074] = {.lex_state = 239},
  [8075] = {.lex_state = 241},
  [8076] = {.lex_state = 241},
  [8077] = {.lex_state = 241},
  [8078] = {.lex_state = 218, .external_lex_state = 4},
  [8079] = {.lex_state = 241},
  [8080] = {.lex_state = 218, .external_lex_state = 4},
  [8081] = {.lex_state = 241},
  [8082] = {.lex_state = 237},
  [8083] = {.lex_state = 212, .external_lex_state = 4},
  [8084] = {.lex_state = 218, .external_lex_state = 4},
  [8085] = {.lex_state = 241},
  [8086] = {.lex_state = 241},
  [8087] = {.lex_state = 237},
  [8088] = {.lex_state = 238},
  [8089] = {.lex_state = 241},
  [8090] = {.lex_state = 218, .external_lex_state = 4},
  [8091] = {.lex_state = 241},
  [8092] = {.lex_state = 241},
  [8093] = {.lex_state = 241},
  [8094] = {.lex_state = 241},
  [8095] = {.lex_state = 241},
  [8096] = {.lex_state = 241},
  [8097] = {.lex_state = 212, .external_lex_state = 4},
  [8098] = {.lex_state = 237},
  [8099] = {.lex_state = 241},
  [8100] = {.lex_state = 227, .external_lex_state = 4},
  [8101] = {.lex_state = 219, .external_lex_state = 4},
  [8102] = {.lex_state = 219, .external_lex_state = 4},
  [8103] = {.lex_state = 219, .external_lex_state = 4},
  [8104] = {.lex_state = 241},
  [8105] = {.lex_state = 237},
  [8106] = {.lex_state = 219, .external_lex_state = 4},
  [8107] = {.lex_state = 212, .external_lex_state = 4},
  [8108] = {.lex_state = 218, .external_lex_state = 4},
  [8109] = {.lex_state = 212, .external_lex_state = 4},
  [8110] = {.lex_state = 218, .external_lex_state = 4},
  [8111] = {.lex_state = 241},
  [8112] = {.lex_state = 237},
  [8113] = {.lex_state = 219, .external_lex_state = 4},
  [8114] = {.lex_state = 241},
  [8115] = {.lex_state = 238},
  [8116] = {.lex_state = 191},
  [8117] = {.lex_state = 241},
  [8118] = {.lex_state = 191},
  [8119] = {.lex_state = 241},
  [8120] = {.lex_state = 191},
  [8121] = {.lex_state = 191},
  [8122] = {.lex_state = 191},
  [8123] = {.lex_state = 241},
  [8124] = {.lex_state = 241},
  [8125] = {.lex_state = 241},
  [8126] = {.lex_state = 241},
  [8127] = {.lex_state = 241},
  [8128] = {.lex_state = 212, .external_lex_state = 4},
  [8129] = {.lex_state = 238},
  [8130] = {.lex_state = 212, .external_lex_state = 4},
  [8131] = {.lex_state = 191},
  [8132] = {.lex_state = 241},
  [8133] = {.lex_state = 241},
  [8134] = {.lex_state = 191},
  [8135] = {.lex_state = 191},
  [8136] = {.lex_state = 191},
  [8137] = {.lex_state = 219, .external_lex_state = 4},
  [8138] = {.lex_state = 241},
  [8139] = {.lex_state = 241},
  [8140] = {.lex_state = 241},
  [8141] = {.lex_state = 219, .external_lex_state = 4},
  [8142] = {.lex_state = 241},
  [8143] = {.lex_state = 241},
  [8144] = {.lex_state = 212, .external_lex_state = 4},
  [8145] = {.lex_state = 219, .external_lex_state = 4},
  [8146] = {.lex_state = 241},
  [8147] = {.lex_state = 219, .external_lex_state = 4},
  [8148] = {.lex_state = 241},
  [8149] = {.lex_state = 212, .external_lex_state = 4},
  [8150] = {.lex_state = 212, .external_lex_state = 4},
  [8151] = {.lex_state = 239},
  [8152] = {.lex_state = 241},
  [8153] = {.lex_state = 241},
  [8154] = {.lex_state = 237},
  [8155] = {.lex_state = 238},
  [8156] = {.lex_state = 241},
  [8157] = {.lex_state = 193},
  [8158] = {.lex_state = 203},
  [8159] = {.lex_state = 203},
  [8160] = {.lex_state = 220, .external_lex_state = 4},
  [8161] = {.lex_state = 203},
  [8162] = {.lex_state = 203},
  [8163] = {.lex_state = 239},
  [8164] = {.lex_state = 241},
  [8165] = {.lex_state = 203},
  [8166] = {.lex_state = 203},
  [8167] = {.lex_state = 203},
  [8168] = {.lex_state = 203},
  [8169] = {.lex_state = 228, .external_lex_state = 4},
  [8170] = {.lex_state = 220, .external_lex_state = 4},
  [8171] = {.lex_state = 220, .external_lex_state = 4},
  [8172] = {.lex_state = 228, .external_lex_state = 4},
  [8173] = {.lex_state = 221, .external_lex_state = 4},
  [8174] = {.lex_state = 228, .external_lex_state = 4},
  [8175] = {.lex_state = 239},
  [8176] = {.lex_state = 203},
  [8177] = {.lex_state = 228, .external_lex_state = 4},
  [8178] = {.lex_state = 203},
  [8179] = {.lex_state = 195},
  [8180] = {.lex_state = 195},
  [8181] = {.lex_state = 195},
  [8182] = {.lex_state = 228, .external_lex_state = 4},
  [8183] = {.lex_state = 195},
  [8184] = {.lex_state = 228, .external_lex_state = 4},
  [8185] = {.lex_state = 195},
  [8186] = {.lex_state = 221, .external_lex_state = 4},
  [8187] = {.lex_state = 221, .external_lex_state = 4},
  [8188] = {.lex_state = 221, .external_lex_state = 4},
  [8189] = {.lex_state = 195},
  [8190] = {.lex_state = 203},
  [8191] = {.lex_state = 195},
  [8192] = {.lex_state = 239},
  [8193] = {.lex_state = 239},
  [8194] = {.lex_state = 195},
  [8195] = {.lex_state = 221, .external_lex_state = 4},
  [8196] = {.lex_state = 220, .external_lex_state = 4},
  [8197] = {.lex_state = 195},
  [8198] = {.lex_state = 221, .external_lex_state = 4},
  [8199] = {.lex_state = 220, .external_lex_state = 4},
  [8200] = {.lex_state = 239},
  [8201] = {.lex_state = 221, .external_lex_state = 4},
  [8202] = {.lex_state = 221, .external_lex_state = 4},
  [8203] = {.lex_state = 193},
  [8204] = {.lex_state = 229, .external_lex_state = 4},
  [8205] = {.lex_state = 221, .external_lex_state = 4},
  [8206] = {.lex_state = 241},
  [8207] = {.lex_state = 193},
  [8208] = {.lex_state = 193},
  [8209] = {.lex_state = 221, .external_lex_state = 4},
  [8210] = {.lex_state = 204},
  [8211] = {.lex_state = 229, .external_lex_state = 4},
  [8212] = {.lex_state = 229, .external_lex_state = 4},
  [8213] = {.lex_state = 229, .external_lex_state = 4},
  [8214] = {.lex_state = 229, .external_lex_state = 4},
  [8215] = {.lex_state = 204},
  [8216] = {.lex_state = 192},
  [8217] = {.lex_state = 229, .external_lex_state = 4},
  [8218] = {.lex_state = 229, .external_lex_state = 4},
  [8219] = {.lex_state = 229, .external_lex_state = 4},
  [8220] = {.lex_state = 193},
  [8221] = {.lex_state = 193},
  [8222] = {.lex_state = 240},
  [8223] = {.lex_state = 229, .external_lex_state = 4},
  [8224] = {.lex_state = 228, .external_lex_state = 4},
  [8225] = {.lex_state = 220, .external_lex_state = 4},
  [8226] = {.lex_state = 204},
  [8227] = {.lex_state = 192},
  [8228] = {.lex_state = 228, .external_lex_state = 4},
  [8229] = {.lex_state = 192},
  [8230] = {.lex_state = 192},
  [8231] = {.lex_state = 192},
  [8232] = {.lex_state = 193},
  [8233] = {.lex_state = 195},
  [8234] = {.lex_state = 193},
  [8235] = {.lex_state = 193},
  [8236] = {.lex_state = 220, .external_lex_state = 4},
  [8237] = {.lex_state = 193},
  [8238] = {.lex_state = 195},
  [8239] = {.lex_state = 193},
  [8240] = {.lex_state = 228, .external_lex_state = 4},
  [8241] = {.lex_state = 228, .external_lex_state = 4},
  [8242] = {.lex_state = 204},
  [8243] = {.lex_state = 192},
  [8244] = {.lex_state = 192},
  [8245] = {.lex_state = 192},
  [8246] = {.lex_state = 220, .external_lex_state = 4},
  [8247] = {.lex_state = 220, .external_lex_state = 4},
  [8248] = {.lex_state = 220, .external_lex_state = 4},
  [8249] = {.lex_state = 220, .external_lex_state = 4},
  [8250] = {.lex_state = 192},
  [8251] = {.lex_state = 192},
  [8252] = {.lex_state = 228, .external_lex_state = 4},
  [8253] = {.lex_state = 204},
  [8254] = {.lex_state = 229, .external_lex_state = 4},
  [8255] = {.lex_state = 204},
  [8256] = {.lex_state = 221, .external_lex_state = 4},
  [8257] = {.lex_state = 241},
  [8258] = {.lex_state = 204},
  [8259] = {.lex_state = 229, .external_lex_state = 4},
  [8260] = {.lex_state = 204},
  [8261] = {.lex_state = 192},
  [8262] = {.lex_state = 204},
  [8263] = {.lex_state = 204},
  [8264] = {.lex_state = 204},
  [8265] = {.lex_state = 240},
  [8266] = {.lex_state = 222},
  [8267] = {.lex_state = 240},
  [8268] = {.lex_state = 240},
  [8269] = {.lex_state = 240},
  [8270] = {.lex_state = 240},
  [8271] = {.lex_state = 194},
  [8272] = {.lex_state = 223},
  [8273] = {.lex_state = 240},
  [8274] = {.lex_state = 240},
  [8275] = {.lex_state = 240},
  [8276] = {.lex_state = 223},
  [8277] = {.lex_state = 230, .external_lex_state = 4},
  [8278] = {.lex_state = 194},
  [8279] = {.lex_state = 194},
  [8280] = {.lex_state = 240},
  [8281] = {.lex_state = 223},
  [8282] = {.lex_state = 194},
  [8283] = {.lex_state = 223},
  [8284] = {.lex_state = 240},
  [8285] = {.lex_state = 194},
  [8286] = {.lex_state = 223},
  [8287] = {.lex_state = 240},
  [8288] = {.lex_state = 240},
  [8289] = {.lex_state = 194},
  [8290] = {.lex_state = 230, .external_lex_state = 4},
  [8291] = {.lex_state = 230, .external_lex_state = 4},
  [8292] = {.lex_state = 240},
  [8293] = {.lex_state = 194},
  [8294] = {.lex_state = 230, .external_lex_state = 4},
  [8295] = {.lex_state = 194},
  [8296] = {.lex_state = 230, .external_lex_state = 4},
  [8297] = {.lex_state = 194},
  [8298] = {.lex_state = 194},
  [8299] = {.lex_state = 240},
  [8300] = {.lex_state = 213},
  [8301] = {.lex_state = 223},
  [8302] = {.lex_state = 240},
  [8303] = {.lex_state = 230, .external_lex_state = 4},
  [8304] = {.lex_state = 240},
  [8305] = {.lex_state = 230, .external_lex_state = 4},
  [8306] = {.lex_state = 223},
  [8307] = {.lex_state = 240},
  [8308] = {.lex_state = 230, .external_lex_state = 4},
  [8309] = {.lex_state = 240},
  [8310] = {.lex_state = 230, .external_lex_state = 4},
  [8311] = {.lex_state = 214},
  [8312] = {.lex_state = 240},
  [8313] = {.lex_state = 214},
  [8314] = {.lex_state = 214},
  [8315] = {.lex_state = 240},
  [8316] = {.lex_state = 214},
  [8317] = {.lex_state = 223},
  [8318] = {.lex_state = 214},
  [8319] = {.lex_state = 223},
  [8320] = {.lex_state = 240},
  [8321] = {.lex_state = 240},
  [8322] = {.lex_state = 214},
  [8323] = {.lex_state = 214},
  [8324] = {.lex_state = 213},
  [8325] = {.lex_state = 214},
  [8326] = {.lex_state = 213},
  [8327] = {.lex_state = 240},
  [8328] = {.lex_state = 214},
  [8329] = {.lex_state = 213},
  [8330] = {.lex_state = 240},
  [8331] = {.lex_state = 194},
  [8332] = {.lex_state = 213},
  [8333] = {.lex_state = 240},
  [8334] = {.lex_state = 240},
  [8335] = {.lex_state = 213},
  [8336] = {.lex_state = 230, .external_lex_state = 4},
  [8337] = {.lex_state = 230, .external_lex_state = 4},
  [8338] = {.lex_state = 213},
  [8339] = {.lex_state = 240},
  [8340] = {.lex_state = 240},
  [8341] = {.lex_state = 240},
  [8342] = {.lex_state = 213},
  [8343] = {.lex_state = 240},
  [8344] = {.lex_state = 213},
  [8345] = {.lex_state = 240},
  [8346] = {.lex_state = 240},
  [8347] = {.lex_state = 222},
  [8348] = {.lex_state = 240},
  [8349] = {.lex_state = 223},
  [8350] = {.lex_state = 223},
  [8351] = {.lex_state = 205},
  [8352] = {.lex_state = 240},
  [8353] = {.lex_state = 220},
  [8354] = {.lex_state = 213},
  [8355] = {.lex_state = 240},
  [8356] = {.lex_state = 240},
  [8357] = {.lex_state = 214},
  [8358] = {.lex_state = 222},
  [8359] = {.lex_state = 240},
  [8360] = {.lex_state = 240},
  [8361] = {.lex_state = 213},
  [8362] = {.lex_state = 214},
  [8363] = {.lex_state = 240},
  [8364] = {.lex_state = 220},
  [8365] = {.lex_state = 220},
  [8366] = {.lex_state = 220},
  [8367] = {.lex_state = 220},
  [8368] = {.lex_state = 240},
  [8369] = {.lex_state = 240},
  [8370] = {.lex_state = 240},
  [8371] = {.lex_state = 240},
  [8372] = {.lex_state = 240},
  [8373] = {.lex_state = 196},
  [8374] = {.lex_state = 196},
  [8375] = {.lex_state = 196},
  [8376] = {.lex_state = 240},
  [8377] = {.lex_state = 196},
  [8378] = {.lex_state = 240},
  [8379] = {.lex_state = 240},
  [8380] = {.lex_state = 224},
  [8381] = {.lex_state = 240},
  [8382] = {.lex_state = 224},
  [8383] = {.lex_state = 196},
  [8384] = {.lex_state = 240},
  [8385] = {.lex_state = 240},
  [8386] = {.lex_state = 220},
  [8387] = {.lex_state = 220},
  [8388] = {.lex_state = 240},
  [8389] = {.lex_state = 240},
  [8390] = {.lex_state = 196},
  [8391] = {.lex_state = 196},
  [8392] = {.lex_state = 225},
  [8393] = {.lex_state = 240},
  [8394] = {.lex_state = 225},
  [8395] = {.lex_state = 220},
  [8396] = {.lex_state = 240},
  [8397] = {.lex_state = 196},
  [8398] = {.lex_state = 240},
  [8399] = {.lex_state = 220},
  [8400] = {.lex_state = 196},
  [8401] = {.lex_state = 231, .external_lex_state = 4},
  [8402] = {.lex_state = 240},
  [8403] = {.lex_state = 220},
  [8404] = {.lex_state = 206},
  [8405] = {.lex_state = 231, .external_lex_state = 4},
  [8406] = {.lex_state = 205},
  [8407] = {.lex_state = 240},
  [8408] = {.lex_state = 205},
  [8409] = {.lex_state = 240},
  [8410] = {.lex_state = 240},
  [8411] = {.lex_state = 205},
  [8412] = {.lex_state = 240},
  [8413] = {.lex_state = 205},
  [8414] = {.lex_state = 240},
  [8415] = {.lex_state = 222},
  [8416] = {.lex_state = 222},
  [8417] = {.lex_state = 240},
  [8418] = {.lex_state = 240},
  [8419] = {.lex_state = 222},
  [8420] = {.lex_state = 222},
  [8421] = {.lex_state = 240},
  [8422] = {.lex_state = 206},
  [8423] = {.lex_state = 240},
  [8424] = {.lex_state = 224},
  [8425] = {.lex_state = 224},
  [8426] = {.lex_state = 222},
  [8427] = {.lex_state = 224},
  [8428] = {.lex_state = 240},
  [8429] = {.lex_state = 222},
  [8430] = {.lex_state = 240},
  [8431] = {.lex_state = 240},
  [8432] = {.lex_state = 224},
  [8433] = {.lex_state = 222},
  [8434] = {.lex_state = 222},
  [8435] = {.lex_state = 240},
  [8436] = {.lex_state = 225},
  [8437] = {.lex_state = 225},
  [8438] = {.lex_state = 224},
  [8439] = {.lex_state = 225},
  [8440] = {.lex_state = 206},
  [8441] = {.lex_state = 225},
  [8442] = {.lex_state = 240},
  [8443] = {.lex_state = 240},
  [8444] = {.lex_state = 224},
  [8445] = {.lex_state = 240},
  [8446] = {.lex_state = 240},
  [8447] = {.lex_state = 224},
  [8448] = {.lex_state = 205},
  [8449] = {.lex_state = 240},
  [8450] = {.lex_state = 231, .external_lex_state = 4},
  [8451] = {.lex_state = 240},
  [8452] = {.lex_state = 206},
  [8453] = {.lex_state = 231, .external_lex_state = 4},
  [8454] = {.lex_state = 240},
  [8455] = {.lex_state = 240},
  [8456] = {.lex_state = 240},
  [8457] = {.lex_state = 225},
  [8458] = {.lex_state = 231, .external_lex_state = 4},
  [8459] = {.lex_state = 225},
  [8460] = {.lex_state = 240},
  [8461] = {.lex_state = 205},
  [8462] = {.lex_state = 240},
  [8463] = {.lex_state = 240},
  [8464] = {.lex_state = 231, .external_lex_state = 4},
  [8465] = {.lex_state = 240},
  [8466] = {.lex_state = 225},
  [8467] = {.lex_state = 225},
  [8468] = {.lex_state = 224},
  [8469] = {.lex_state = 231, .external_lex_state = 4},
  [8470] = {.lex_state = 240},
  [8471] = {.lex_state = 231, .external_lex_state = 4},
  [8472] = {.lex_state = 231, .external_lex_state = 4},
  [8473] = {.lex_state = 231, .external_lex_state = 4},
  [8474] = {.lex_state = 240},
  [8475] = {.lex_state = 225},
  [8476] = {.lex_state = 240},
  [8477] = {.lex_state = 231, .external_lex_state = 4},
  [8478] = {.lex_state = 195, .external_lex_state = 4},
  [8479] = {.lex_state = 195, .external_lex_state = 4},
  [8480] = {.lex_state = 196},
  [8481] = {.lex_state = 240},
  [8482] = {.lex_state = 224},
  [8483] = {.lex_state = 240},
  [8484] = {.lex_state = 206},
  [8485] = {.lex_state = 240},
  [8486] = {.lex_state = 205},
  [8487] = {.lex_state = 205},
  [8488] = {.lex_state = 196},
  [8489] = {.lex_state = 240},
  [8490] = {.lex_state = 240},
  [8491] = {.lex_state = 240},
  [8492] = {.lex_state = 240},
  [8493] = {.lex_state = 206},
  [8494] = {.lex_state = 240},
  [8495] = {.lex_state = 240},
  [8496] = {.lex_state = 206},
  [8497] = {.lex_state = 240},
  [8498] = {.lex_state = 206},
  [8499] = {.lex_state = 206},
  [8500] = {.lex_state = 195, .external_lex_state = 4},
  [8501] = {.lex_state = 205},
  [8502] = {.lex_state = 195, .external_lex_state = 4},
  [8503] = {.lex_state = 205},
  [8504] = {.lex_state = 240},
  [8505] = {.lex_state = 195, .external_lex_state = 4},
  [8506] = {.lex_state = 240},
  [8507] = {.lex_state = 195, .external_lex_state = 4},
  [8508] = {.lex_state = 240},
  [8509] = {.lex_state = 195, .external_lex_state = 4},
  [8510] = {.lex_state = 195, .external_lex_state = 4},
  [8511] = {.lex_state = 240},
  [8512] = {.lex_state = 195, .external_lex_state = 4},
  [8513] = {.lex_state = 195, .external_lex_state = 4},
  [8514] = {.lex_state = 195, .external_lex_state = 4},
  [8515] = {.lex_state = 206},
  [8516] = {.lex_state = 206},
  [8517] = {.lex_state = 240},
  [8518] = {.lex_state = 240},
  [8519] = {.lex_state = 220},
  [8520] = {.lex_state = 226, .external_lex_state = 4},
  [8521] = {.lex_state = 226},
  [8522] = {.lex_state = 226, .external_lex_state = 4},
  [8523] = {.lex_state = 226, .external_lex_state = 4},
  [8524] = {.lex_state = 226, .external_lex_state = 4},
  [8525] = {.lex_state = 226, .external_lex_state = 4},
  [8526] = {.lex_state = 226},
  [8527] = {.lex_state = 226},
  [8528] = {.lex_state = 226, .external_lex_state = 4},
  [8529] = {.lex_state = 226},
  [8530] = {.lex_state = 226},
  [8531] = {.lex_state = 226, .external_lex_state = 4},
  [8532] = {.lex_state = 226, .external_lex_state = 4},
  [8533] = {.lex_state = 226, .external_lex_state = 4},
  [8534] = {.lex_state = 226, .external_lex_state = 4},
  [8535] = {.lex_state = 226},
  [8536] = {.lex_state = 226},
  [8537] = {.lex_state = 226},
  [8538] = {.lex_state = 226},
  [8539] = {.lex_state = 232},
  [8540] = {.lex_state = 226},
  [8541] = {.lex_state = 226},
  [8542] = {.lex_state = 232},
  [8543] = {.lex_state = 230},
  [8544] = {.lex_state = 230},
  [8545] = {.lex_state = 226, .external_lex_state = 4},
  [8546] = {.lex_state = 230},
  [8547] = {.lex_state = 230},
  [8548] = {.lex_state = 230},
  [8549] = {.lex_state = 230},
  [8550] = {.lex_state = 230},
  [8551] = {.lex_state = 233},
  [8552] = {.lex_state = 233},
  [8553] = {.lex_state = 230},
  [8554] = {.lex_state = 234},
  [8555] = {.lex_state = 234},
  [8556] = {.lex_state = 230},
  [8557] = {.lex_state = 232},
  [8558] = {.lex_state = 232},
  [8559] = {.lex_state = 235},
  [8560] = {.lex_state = 232},
  [8561] = {.lex_state = 235},
  [8562] = {.lex_state = 232},
  [8563] = {.lex_state = 232},
  [8564] = {.lex_state = 232},
  [8565] = {.lex_state = 232},
  [8566] = {.lex_state = 232},
  [8567] = {.lex_state = 232},
  [8568] = {.lex_state = 233},
  [8569] = {.lex_state = 233},
  [8570] = {.lex_state = 233},
  [8571] = {.lex_state = 233},
  [8572] = {.lex_state = 233},
  [8573] = {.lex_state = 234},
  [8574] = {.lex_state = 215},
  [8575] = {.lex_state = 196, .external_lex_state = 4},
  [8576] = {.lex_state = 234},
  [8577] = {.lex_state = 196, .external_lex_state = 4},
  [8578] = {.lex_state = 233},
  [8579] = {.lex_state = 234},
  [8580] = {.lex_state = 235},
  [8581] = {.lex_state = 235},
  [8582] = {.lex_state = 235},
  [8583] = {.lex_state = 235},
  [8584] = {.lex_state = 233},
  [8585] = {.lex_state = 234},
  [8586] = {.lex_state = 233},
  [8587] = {.lex_state = 235},
  [8588] = {.lex_state = 233},
  [8589] = {.lex_state = 234},
  [8590] = {.lex_state = 215},
  [8591] = {.lex_state = 234},
  [8592] = {.lex_state = 235},
  [8593] = {.lex_state = 235},
  [8594] = {.lex_state = 215},
  [8595] = {.lex_state = 234},
  [8596] = {.lex_state = 215},
  [8597] = {.lex_state = 234},
  [8598] = {.lex_state = 234},
  [8599] = {.lex_state = 215},
  [8600] = {.lex_state = 451, .external_lex_state = 4},
  [8601] = {.lex_state = 215},
  [8602] = {.lex_state = 216},
  [8603] = {.lex_state = 216},
  [8604] = {.lex_state = 196, .external_lex_state = 4},
  [8605] = {.lex_state = 235},
  [8606] = {.lex_state = 196, .external_lex_state = 4},
  [8607] = {.lex_state = 196, .external_lex_state = 4},
  [8608] = {.lex_state = 215},
  [8609] = {.lex_state = 196, .external_lex_state = 4},
  [8610] = {.lex_state = 196, .external_lex_state = 4},
  [8611] = {.lex_state = 196, .external_lex_state = 4},
  [8612] = {.lex_state = 196, .external_lex_state = 4},
  [8613] = {.lex_state = 215},
  [8614] = {.lex_state = 196, .external_lex_state = 4},
  [8615] = {.lex_state = 215},
  [8616] = {.lex_state = 215},
  [8617] = {.lex_state = 196, .external_lex_state = 4},
  [8618] = {.lex_state = 216},
  [8619] = {.lex_state = 216},
  [8620] = {.lex_state = 216},
  [8621] = {.lex_state = 216},
  [8622] = {.lex_state = 216},
  [8623] = {.lex_state = 216},
  [8624] = {.lex_state = 216},
  [8625] = {.lex_state = 215},
  [8626] = {.lex_state = 216},
  [8627] = {.lex_state = 230},
  [8628] = {.lex_state = 235},
  [8629] = {.lex_state = 230},
  [8630] = {.lex_state = 216},
  [8631] = {.lex_state = 451},
  [8632] = {.lex_state = 252},
  [8633] = {.lex_state = 451},
  [8634] = {.lex_state = 451},
  [8635] = {.lex_state = 451},
  [8636] = {.lex_state = 451},
  [8637] = {.lex_state = 451, .external_lex_state = 4},
  [8638] = {.lex_state = 451},
  [8639] = {.lex_state = 451},
  [8640] = {.lex_state = 451},
  [8641] = {.lex_state = 451},
  [8642] = {.lex_state = 451},
  [8643] = {.lex_state = 451},
  [8644] = {.lex_state = 451},
  [8645] = {.lex_state = 451},
  [8646] = {.lex_state = 451},
  [8647] = {.lex_state = 451},
  [8648] = {.lex_state = 451},
  [8649] = {.lex_state = 451},
  [8650] = {.lex_state = 451},
  [8651] = {.lex_state = 451},
  [8652] = {.lex_state = 451},
  [8653] = {.lex_state = 451, .external_lex_state = 4},
  [8654] = {.lex_state = 451},
  [8655] = {.lex_state = 451},
  [8656] = {.lex_state = 451},
  [8657] = {.lex_state = 451},
  [8658] = {.lex_state = 252},
  [8659] = {.lex_state = 451},
  [8660] = {.lex_state = 451},
  [8661] = {.lex_state = 451},
  [8662] = {.lex_state = 451},
  [8663] = {.lex_state = 451},
  [8664] = {.lex_state = 237},
  [8665] = {.lex_state = 451},
  [8666] = {.lex_state = 451},
  [8667] = {.lex_state = 451},
  [8668] = {.lex_state = 451, .external_lex_state = 4},
  [8669] = {.lex_state = 451},
  [8670] = {.lex_state = 451},
  [8671] = {.lex_state = 451},
  [8672] = {.lex_state = 451},
  [8673] = {.lex_state = 451},
  [8674] = {.lex_state = 451},
  [8675] = {.lex_state = 451},
  [8676] = {.lex_state = 451},
  [8677] = {.lex_state = 451, .external_lex_state = 4},
  [8678] = {.lex_state = 451},
  [8679] = {.lex_state = 451},
  [8680] = {.lex_state = 451},
  [8681] = {.lex_state = 451, .external_lex_state = 4},
  [8682] = {.lex_state = 451},
  [8683] = {.lex_state = 252},
  [8684] = {.lex_state = 451},
  [8685] = {.lex_state = 451},
  [8686] = {.lex_state = 451},
  [8687] = {.lex_state = 451},
  [8688] = {.lex_state = 451},
  [8689] = {.lex_state = 186},
  [8690] = {.lex_state = 186},
  [8691] = {.lex_state = 186},
  [8692] = {.lex_state = 186},
  [8693] = {.lex_state = 186},
  [8694] = {.lex_state = 186},
  [8695] = {.lex_state = 186},
  [8696] = {.lex_state = 186},
  [8697] = {.lex_state = 186},
  [8698] = {.lex_state = 186},
  [8699] = {.lex_state = 186},
  [8700] = {.lex_state = 186},
  [8701] = {.lex_state = 240, .external_lex_state = 2},
  [8702] = {.lex_state = 186},
  [8703] = {.lex_state = 186},
  [8704] = {.lex_state = 186},
  [8705] = {.lex_state = 186},
  [8706] = {.lex_state = 186},
  [8707] = {.lex_state = 186},
  [8708] = {.lex_state = 186},
  [8709] = {.lex_state = 186},
  [8710] = {.lex_state = 186},
  [8711] = {.lex_state = 236},
  [8712] = {.lex_state = 186},
  [8713] = {.lex_state = 186},
  [8714] = {.lex_state = 186},
  [8715] = {.lex_state = 186},
  [8716] = {.lex_state = 186},
  [8717] = {.lex_state = 186},
  [8718] = {.lex_state = 186},
  [8719] = {.lex_state = 237},
  [8720] = {.lex_state = 186},
  [8721] = {.lex_state = 186},
  [8722] = {.lex_state = 186},
  [8723] = {.lex_state = 186},
  [8724] = {.lex_state = 186},
  [8725] = {.lex_state = 186},
  [8726] = {.lex_state = 186},
  [8727] = {.lex_state = 186},
  [8728] = {.lex_state = 186},
  [8729] = {.lex_state = 186},
  [8730] = {.lex_state = 186},
  [8731] = {.lex_state = 186},
  [8732] = {.lex_state = 186},
  [8733] = {.lex_state = 186},
  [8734] = {.lex_state = 186},
  [8735] = {.lex_state = 186},
  [8736] = {.lex_state = 186},
  [8737] = {.lex_state = 186},
  [8738] = {.lex_state = 186},
  [8739] = {.lex_state = 186},
  [8740] = {.lex_state = 186},
  [8741] = {.lex_state = 186},
  [8742] = {.lex_state = 186},
  [8743] = {.lex_state = 186},
  [8744] = {.lex_state = 186},
  [8745] = {.lex_state = 186},
  [8746] = {.lex_state = 186},
  [8747] = {.lex_state = 186},
  [8748] = {.lex_state = 236},
  [8749] = {.lex_state = 186},
  [8750] = {.lex_state = 236},
  [8751] = {.lex_state = 186},
  [8752] = {.lex_state = 186},
  [8753] = {.lex_state = 451, .external_lex_state = 4},
  [8754] = {.lex_state = 186},
  [8755] = {.lex_state = 186},
  [8756] = {.lex_state = 186},
  [8757] = {.lex_state = 186},
  [8758] = {.lex_state = 186},
  [8759] = {.lex_state = 186},
  [8760] = {.lex_state = 186},
  [8761] = {.lex_state = 186},
  [8762] = {.lex_state = 186},
  [8763] = {.lex_state = 237},
  [8764] = {.lex_state = 186},
  [8765] = {.lex_state = 186},
  [8766] = {.lex_state = 186},
  [8767] = {.lex_state = 186},
  [8768] = {.lex_state = 236},
  [8769] = {.lex_state = 236},
  [8770] = {.lex_state = 186},
  [8771] = {.lex_state = 186},
  [8772] = {.lex_state = 186},
  [8773] = {.lex_state = 186},
  [8774] = {.lex_state = 186},
  [8775] = {.lex_state = 186},
  [8776] = {.lex_state = 186},
  [8777] = {.lex_state = 186},
  [8778] = {.lex_state = 186},
  [8779] = {.lex_state = 186},
  [8780] = {.lex_state = 186},
  [8781] = {.lex_state = 186},
  [8782] = {.lex_state = 186},
  [8783] = {.lex_state = 186},
  [8784] = {.lex_state = 186},
  [8785] = {.lex_state = 186},
  [8786] = {.lex_state = 186},
  [8787] = {.lex_state = 186},
  [8788] = {.lex_state = 186},
  [8789] = {.lex_state = 186},
  [8790] = {.lex_state = 186},
  [8791] = {.lex_state = 186},
  [8792] = {.lex_state = 186},
  [8793] = {.lex_state = 186},
  [8794] = {.lex_state = 186},
  [8795] = {.lex_state = 186},
  [8796] = {.lex_state = 186},
  [8797] = {.lex_state = 186},
  [8798] = {.lex_state = 186},
  [8799] = {.lex_state = 186},
  [8800] = {.lex_state = 186},
  [8801] = {.lex_state = 186},
  [8802] = {.lex_state = 186},
  [8803] = {.lex_state = 186},
  [8804] = {.lex_state = 451, .external_lex_state = 4},
  [8805] = {.lex_state = 237},
  [8806] = {.lex_state = 186},
  [8807] = {.lex_state = 186},
  [8808] = {.lex_state = 186},
  [8809] = {.lex_state = 237},
  [8810] = {.lex_state = 186},
  [8811] = {.lex_state = 186},
  [8812] = {.lex_state = 186},
  [8813] = {.lex_state = 186},
  [8814] = {.lex_state = 186},
  [8815] = {.lex_state = 186},
  [8816] = {.lex_state = 186},
  [8817] = {.lex_state = 186},
  [8818] = {.lex_state = 186},
  [8819] = {.lex_state = 451, .external_lex_state = 4},
  [8820] = {.lex_state = 186},
  [8821] = {.lex_state = 451},
  [8822] = {.lex_state = 186},
  [8823] = {.lex_state = 186},
  [8824] = {.lex_state = 186},
  [8825] = {.lex_state = 186},
  [8826] = {.lex_state = 186},
  [8827] = {.lex_state = 237},
  [8828] = {.lex_state = 237},
  [8829] = {.lex_state = 186},
  [8830] = {.lex_state = 186},
  [8831] = {.lex_state = 186},
  [8832] = {.lex_state = 237},
  [8833] = {.lex_state = 186},
  [8834] = {.lex_state = 238},
  [8835] = {.lex_state = 237},
  [8836] = {.lex_state = 238},
  [8837] = {.lex_state = 186},
  [8838] = {.lex_state = 237},
  [8839] = {.lex_state = 186},
  [8840] = {.lex_state = 237},
  [8841] = {.lex_state = 237},
  [8842] = {.lex_state = 186},
  [8843] = {.lex_state = 186},
  [8844] = {.lex_state = 237},
  [8845] = {.lex_state = 186},
  [8846] = {.lex_state = 186},
  [8847] = {.lex_state = 186},
  [8848] = {.lex_state = 451, .external_lex_state = 4},
  [8849] = {.lex_state = 237},
  [8850] = {.lex_state = 186},
  [8851] = {.lex_state = 238},
  [8852] = {.lex_state = 186},
  [8853] = {.lex_state = 186},
  [8854] = {.lex_state = 238},
  [8855] = {.lex_state = 237},
  [8856] = {.lex_state = 237},
  [8857] = {.lex_state = 237},
  [8858] = {.lex_state = 238},
  [8859] = {.lex_state = 237},
  [8860] = {.lex_state = 186},
  [8861] = {.lex_state = 186},
  [8862] = {.lex_state = 238},
  [8863] = {.lex_state = 186},
  [8864] = {.lex_state = 186},
  [8865] = {.lex_state = 186},
  [8866] = {.lex_state = 237},
  [8867] = {.lex_state = 237},
  [8868] = {.lex_state = 186},
  [8869] = {.lex_state = 237},
  [8870] = {.lex_state = 186},
  [8871] = {.lex_state = 237},
  [8872] = {.lex_state = 186},
  [8873] = {.lex_state = 236},
  [8874] = {.lex_state = 186},
  [8875] = {.lex_state = 186},
  [8876] = {.lex_state = 186},
  [8877] = {.lex_state = 186},
  [8878] = {.lex_state = 186},
  [8879] = {.lex_state = 238},
  [8880] = {.lex_state = 238},
  [8881] = {.lex_state = 186},
  [8882] = {.lex_state = 186},
  [8883] = {.lex_state = 186},
  [8884] = {.lex_state = 186},
  [8885] = {.lex_state = 238},
  [8886] = {.lex_state = 186},
  [8887] = {.lex_state = 238},
  [8888] = {.lex_state = 186},
  [8889] = {.lex_state = 186},
  [8890] = {.lex_state = 237},
  [8891] = {.lex_state = 186},
  [8892] = {.lex_state = 186},
  [8893] = {.lex_state = 236},
  [8894] = {.lex_state = 186},
  [8895] = {.lex_state = 186},
  [8896] = {.lex_state = 186},
  [8897] = {.lex_state = 186},
  [8898] = {.lex_state = 186},
  [8899] = {.lex_state = 186},
  [8900] = {.lex_state = 186},
  [8901] = {.lex_state = 236},
  [8902] = {.lex_state = 186},
  [8903] = {.lex_state = 186},
  [8904] = {.lex_state = 186},
  [8905] = {.lex_state = 186},
  [8906] = {.lex_state = 186},
  [8907] = {.lex_state = 236},
  [8908] = {.lex_state = 237},
  [8909] = {.lex_state = 186},
  [8910] = {.lex_state = 186},
  [8911] = {.lex_state = 186},
  [8912] = {.lex_state = 186},
  [8913] = {.lex_state = 186},
  [8914] = {.lex_state = 237},
  [8915] = {.lex_state = 186},
  [8916] = {.lex_state = 186},
  [8917] = {.lex_state = 451, .external_lex_state = 4},
  [8918] = {.lex_state = 186},
  [8919] = {.lex_state = 186},
  [8920] = {.lex_state = 186},
  [8921] = {.lex_state = 186},
  [8922] = {.lex_state = 186},
  [8923] = {.lex_state = 240},
  [8924] = {.lex_state = 451},
  [8925] = {.lex_state = 241},
  [8926] = {.lex_state = 451, .external_lex_state = 4},
  [8927] = {.lex_state = 239},
  [8928] = {.lex_state = 451, .external_lex_state = 4},
  [8929] = {.lex_state = 451, .external_lex_state = 4},
  [8930] = {.lex_state = 451, .external_lex_state = 4},
  [8931] = {.lex_state = 241},
  [8932] = {.lex_state = 239},
  [8933] = {.lex_state = 239},
  [8934] = {.lex_state = 240},
  [8935] = {.lex_state = 239},
  [8936] = {.lex_state = 239},
  [8937] = {.lex_state = 242},
  [8938] = {.lex_state = 451},
  [8939] = {.lex_state = 451, .external_lex_state = 4},
  [8940] = {.lex_state = 241},
  [8941] = {.lex_state = 451, .external_lex_state = 4},
  [8942] = {.lex_state = 239},
  [8943] = {.lex_state = 451, .external_lex_state = 4},
  [8944] = {.lex_state = 451, .external_lex_state = 4},
  [8945] = {.lex_state = 242},
  [8946] = {.lex_state = 451, .external_lex_state = 4},
  [8947] = {.lex_state = 451},
  [8948] = {.lex_state = 451, .external_lex_state = 4},
  [8949] = {.lex_state = 451, .external_lex_state = 4},
  [8950] = {.lex_state = 239},
  [8951] = {.lex_state = 451},
  [8952] = {.lex_state = 451, .external_lex_state = 4},
  [8953] = {.lex_state = 451, .external_lex_state = 4},
  [8954] = {.lex_state = 241},
  [8955] = {.lex_state = 451, .external_lex_state = 4},
  [8956] = {.lex_state = 239},
  [8957] = {.lex_state = 451, .external_lex_state = 4},
  [8958] = {.lex_state = 239},
  [8959] = {.lex_state = 451},
  [8960] = {.lex_state = 241},
  [8961] = {.lex_state = 451},
  [8962] = {.lex_state = 239},
  [8963] = {.lex_state = 451, .external_lex_state = 4},
  [8964] = {.lex_state = 451},
  [8965] = {.lex_state = 239},
  [8966] = {.lex_state = 242},
  [8967] = {.lex_state = 451, .external_lex_state = 4},
  [8968] = {.lex_state = 242},
  [8969] = {.lex_state = 241},
  [8970] = {.lex_state = 242},
  [8971] = {.lex_state = 451, .external_lex_state = 4},
  [8972] = {.lex_state = 241},
  [8973] = {.lex_state = 451},
  [8974] = {.lex_state = 451},
  [8975] = {.lex_state = 241},
  [8976] = {.lex_state = 451},
  [8977] = {.lex_state = 241},
  [8978] = {.lex_state = 451},
  [8979] = {.lex_state = 239},
  [8980] = {.lex_state = 239},
  [8981] = {.lex_state = 451, .external_lex_state = 4},
  [8982] = {.lex_state = 451, .external_lex_state = 4},
  [8983] = {.lex_state = 242},
  [8984] = {.lex_state = 451, .external_lex_state = 4},
  [8985] = {.lex_state = 239},
  [8986] = {.lex_state = 242},
  [8987] = {.lex_state = 451},
  [8988] = {.lex_state = 451},
  [8989] = {.lex_state = 242},
  [8990] = {.lex_state = 451},
  [8991] = {.lex_state = 240},
  [8992] = {.lex_state = 451},
  [8993] = {.lex_state = 451, .external_lex_state = 4},
  [8994] = {.lex_state = 451, .external_lex_state = 4},
  [8995] = {.lex_state = 451},
  [8996] = {.lex_state = 451, .external_lex_state = 4},
  [8997] = {.lex_state = 451},
  [8998] = {.lex_state = 451, .external_lex_state = 4},
  [8999] = {.lex_state = 451, .external_lex_state = 4},
  [9000] = {.lex_state = 451, .external_lex_state = 4},
  [9001] = {.lex_state = 451, .external_lex_state = 4},
  [9002] = {.lex_state = 451, .external_lex_state = 4},
  [9003] = {.lex_state = 451, .external_lex_state = 4},
  [9004] = {.lex_state = 451, .external_lex_state = 4},
  [9005] = {.lex_state = 242},
  [9006] = {.lex_state = 451, .external_lex_state = 4},
  [9007] = {.lex_state = 451, .external_lex_state = 4},
  [9008] = {.lex_state = 240},
  [9009] = {.lex_state = 240},
  [9010] = {.lex_state = 451, .external_lex_state = 4},
  [9011] = {.lex_state = 451, .external_lex_state = 4},
  [9012] = {.lex_state = 451},
  [9013] = {.lex_state = 451, .external_lex_state = 4},
  [9014] = {.lex_state = 451, .external_lex_state = 4},
  [9015] = {.lex_state = 451, .external_lex_state = 4},
  [9016] = {.lex_state = 451, .external_lex_state = 4},
  [9017] = {.lex_state = 451, .external_lex_state = 4},
  [9018] = {.lex_state = 186},
  [9019] = {.lex_state = 451, .external_lex_state = 4},
  [9020] = {.lex_state = 451, .external_lex_state = 4},
  [9021] = {.lex_state = 240},
  [9022] = {.lex_state = 240},
  [9023] = {.lex_state = 240},
  [9024] = {.lex_state = 451, .external_lex_state = 4},
  [9025] = {.lex_state = 242},
  [9026] = {.lex_state = 451},
  [9027] = {.lex_state = 186},
  [9028] = {.lex_state = 186},
  [9029] = {.lex_state = 451},
  [9030] = {.lex_state = 186},
  [9031] = {.lex_state = 186},
  [9032] = {.lex_state = 451, .external_lex_state = 4},
  [9033] = {.lex_state = 451, .external_lex_state = 4},
  [9034] = {.lex_state = 240},
  [9035] = {.lex_state = 451, .external_lex_state = 4},
  [9036] = {.lex_state = 451, .external_lex_state = 4},
  [9037] = {.lex_state = 186},
  [9038] = {.lex_state = 451, .external_lex_state = 4},
  [9039] = {.lex_state = 240},
  [9040] = {.lex_state = 451, .external_lex_state = 4},
  [9041] = {.lex_state = 240},
  [9042] = {.lex_state = 240},
  [9043] = {.lex_state = 451},
  [9044] = {.lex_state = 451, .external_lex_state = 4},
  [9045] = {.lex_state = 240},
  [9046] = {.lex_state = 240},
  [9047] = {.lex_state = 240},
  [9048] = {.lex_state = 240},
  [9049] = {.lex_state = 240},
  [9050] = {.lex_state = 240},
  [9051] = {.lex_state = 240},
  [9052] = {.lex_state = 252},
  [9053] = {.lex_state = 240},
  [9054] = {.lex_state = 240},
  [9055] = {.lex_state = 240},
  [9056] = {.lex_state = 240},
  [9057] = {.lex_state = 240},
  [9058] = {.lex_state = 451, .external_lex_state = 4},
  [9059] = {.lex_state = 451, .external_lex_state = 4},
  [9060] = {.lex_state = 240},
  [9061] = {.lex_state = 240},
  [9062] = {.lex_state = 240},
  [9063] = {.lex_state = 240},
  [9064] = {.lex_state = 240},
  [9065] = {.lex_state = 240},
  [9066] = {.lex_state = 240},
  [9067] = {.lex_state = 451, .external_lex_state = 4},
  [9068] = {.lex_state = 240},
  [9069] = {.lex_state = 240},
  [9070] = {.lex_state = 240},
  [9071] = {.lex_state = 451},
  [9072] = {.lex_state = 242},
  [9073] = {.lex_state = 240},
  [9074] = {.lex_state = 252},
  [9075] = {.lex_state = 240},
  [9076] = {.lex_state = 451, .external_lex_state = 4},
  [9077] = {.lex_state = 240},
  [9078] = {.lex_state = 240},
  [9079] = {.lex_state = 240},
  [9080] = {.lex_state = 240},
  [9081] = {.lex_state = 240},
  [9082] = {.lex_state = 240},
  [9083] = {.lex_state = 240},
  [9084] = {.lex_state = 451, .external_lex_state = 4},
  [9085] = {.lex_state = 240},
  [9086] = {.lex_state = 240},
  [9087] = {.lex_state = 242},
  [9088] = {.lex_state = 251},
  [9089] = {.lex_state = 240},
  [9090] = {.lex_state = 240},
  [9091] = {.lex_state = 451},
  [9092] = {.lex_state = 451, .external_lex_state = 4},
  [9093] = {.lex_state = 451, .external_lex_state = 4},
  [9094] = {.lex_state = 240},
  [9095] = {.lex_state = 240},
  [9096] = {.lex_state = 253},
  [9097] = {.lex_state = 240},
  [9098] = {.lex_state = 240},
  [9099] = {.lex_state = 451, .external_lex_state = 4},
  [9100] = {.lex_state = 451},
  [9101] = {.lex_state = 240},
  [9102] = {.lex_state = 240},
  [9103] = {.lex_state = 253},
  [9104] = {.lex_state = 240},
  [9105] = {.lex_state = 451, .external_lex_state = 4},
  [9106] = {.lex_state = 240},
  [9107] = {.lex_state = 240},
  [9108] = {.lex_state = 451, .external_lex_state = 4},
  [9109] = {.lex_state = 240},
  [9110] = {.lex_state = 451},
  [9111] = {.lex_state = 240},
  [9112] = {.lex_state = 451},
  [9113] = {.lex_state = 240},
  [9114] = {.lex_state = 451, .external_lex_state = 4},
  [9115] = {.lex_state = 254},
  [9116] = {.lex_state = 252},
  [9117] = {.lex_state = 255},
  [9118] = {.lex_state = 451, .external_lex_state = 4},
  [9119] = {.lex_state = 240},
  [9120] = {.lex_state = 240},
  [9121] = {.lex_state = 242},
  [9122] = {.lex_state = 240},
  [9123] = {.lex_state = 255},
  [9124] = {.lex_state = 251},
  [9125] = {.lex_state = 451, .external_lex_state = 4},
  [9126] = {.lex_state = 240},
  [9127] = {.lex_state = 240},
  [9128] = {.lex_state = 240},
  [9129] = {.lex_state = 252},
  [9130] = {.lex_state = 254},
  [9131] = {.lex_state = 240},
  [9132] = {.lex_state = 240},
  [9133] = {.lex_state = 240},
  [9134] = {.lex_state = 240},
  [9135] = {.lex_state = 242},
  [9136] = {.lex_state = 240},
  [9137] = {.lex_state = 242},
  [9138] = {.lex_state = 451, .external_lex_state = 4},
  [9139] = {.lex_state = 240},
  [9140] = {.lex_state = 240},
  [9141] = {.lex_state = 239},
  [9142] = {.lex_state = 239},
  [9143] = {.lex_state = 451},
  [9144] = {.lex_state = 451},
  [9145] = {.lex_state = 451, .external_lex_state = 4},
  [9146] = {.lex_state = 242},
  [9147] = {.lex_state = 451},
  [9148] = {.lex_state = 451, .external_lex_state = 4},
  [9149] = {.lex_state = 451, .external_lex_state = 4},
  [9150] = {.lex_state = 451, .external_lex_state = 4},
  [9151] = {.lex_state = 451},
  [9152] = {.lex_state = 451, .external_lex_state = 4},
  [9153] = {.lex_state = 451, .external_lex_state = 4},
  [9154] = {.lex_state = 451, .external_lex_state = 4},
  [9155] = {.lex_state = 253, .external_lex_state = 2},
  [9156] = {.lex_state = 451},
  [9157] = {.lex_state = 451, .external_lex_state = 4},
  [9158] = {.lex_state = 253},
  [9159] = {.lex_state = 253},
  [9160] = {.lex_state = 451, .external_lex_state = 4},
  [9161] = {.lex_state = 242},
  [9162] = {.lex_state = 451, .external_lex_state = 4},
  [9163] = {.lex_state = 451},
  [9164] = {.lex_state = 451, .external_lex_state = 4},
  [9165] = {.lex_state = 451, .external_lex_state = 4},
  [9166] = {.lex_state = 451, .external_lex_state = 4},
  [9167] = {.lex_state = 451, .external_lex_state = 4},
  [9168] = {.lex_state = 451, .external_lex_state = 4},
  [9169] = {.lex_state = 239},
  [9170] = {.lex_state = 451},
  [9171] = {.lex_state = 253, .external_lex_state = 2},
  [9172] = {.lex_state = 186},
  [9173] = {.lex_state = 451, .external_lex_state = 4},
  [9174] = {.lex_state = 451, .external_lex_state = 4},
  [9175] = {.lex_state = 451, .external_lex_state = 4},
  [9176] = {.lex_state = 242},
  [9177] = {.lex_state = 242},
  [9178] = {.lex_state = 451},
  [9179] = {.lex_state = 239},
  [9180] = {.lex_state = 259, .external_lex_state = 4},
  [9181] = {.lex_state = 451},
  [9182] = {.lex_state = 451, .external_lex_state = 4},
  [9183] = {.lex_state = 259, .external_lex_state = 4},
  [9184] = {.lex_state = 253},
  [9185] = {.lex_state = 255},
  [9186] = {.lex_state = 255},
  [9187] = {.lex_state = 255},
  [9188] = {.lex_state = 255},
  [9189] = {.lex_state = 255},
  [9190] = {.lex_state = 255},
  [9191] = {.lex_state = 255},
  [9192] = {.lex_state = 255},
  [9193] = {.lex_state = 255},
  [9194] = {.lex_state = 255},
  [9195] = {.lex_state = 255},
  [9196] = {.lex_state = 255},
  [9197] = {.lex_state = 255},
  [9198] = {.lex_state = 255},
  [9199] = {.lex_state = 255},
  [9200] = {.lex_state = 255},
  [9201] = {.lex_state = 255},
  [9202] = {.lex_state = 255},
  [9203] = {.lex_state = 255},
  [9204] = {.lex_state = 255},
  [9205] = {.lex_state = 255},
  [9206] = {.lex_state = 255},
  [9207] = {.lex_state = 451, .external_lex_state = 4},
  [9208] = {.lex_state = 255},
  [9209] = {.lex_state = 255},
  [9210] = {.lex_state = 255},
  [9211] = {.lex_state = 255},
  [9212] = {.lex_state = 255},
  [9213] = {.lex_state = 255},
  [9214] = {.lex_state = 186},
  [9215] = {.lex_state = 255},
  [9216] = {.lex_state = 255},
  [9217] = {.lex_state = 255},
  [9218] = {.lex_state = 255},
  [9219] = {.lex_state = 255},
  [9220] = {.lex_state = 255},
  [9221] = {.lex_state = 255},
  [9222] = {.lex_state = 255},
  [9223] = {.lex_state = 255},
  [9224] = {.lex_state = 255},
  [9225] = {.lex_state = 255},
  [9226] = {.lex_state = 255},
  [9227] = {.lex_state = 255},
  [9228] = {.lex_state = 451, .external_lex_state = 4},
  [9229] = {.lex_state = 451},
  [9230] = {.lex_state = 255},
  [9231] = {.lex_state = 255},
  [9232] = {.lex_state = 242},
  [9233] = {.lex_state = 255},
  [9234] = {.lex_state = 255},
  [9235] = {.lex_state = 255},
  [9236] = {.lex_state = 255},
  [9237] = {.lex_state = 255},
  [9238] = {.lex_state = 255},
  [9239] = {.lex_state = 255},
  [9240] = {.lex_state = 255},
  [9241] = {.lex_state = 255},
  [9242] = {.lex_state = 253, .external_lex_state = 4},
  [9243] = {.lex_state = 255},
  [9244] = {.lex_state = 255},
  [9245] = {.lex_state = 255},
  [9246] = {.lex_state = 255},
  [9247] = {.lex_state = 255},
  [9248] = {.lex_state = 255},
  [9249] = {.lex_state = 255},
  [9250] = {.lex_state = 255},
  [9251] = {.lex_state = 451},
  [9252] = {.lex_state = 255},
  [9253] = {.lex_state = 255},
  [9254] = {.lex_state = 255},
  [9255] = {.lex_state = 255},
  [9256] = {.lex_state = 255},
  [9257] = {.lex_state = 255},
  [9258] = {.lex_state = 255},
  [9259] = {.lex_state = 255},
  [9260] = {.lex_state = 255},
  [9261] = {.lex_state = 255},
  [9262] = {.lex_state = 255},
  [9263] = {.lex_state = 451},
  [9264] = {.lex_state = 255},
  [9265] = {.lex_state = 255},
  [9266] = {.lex_state = 255},
  [9267] = {.lex_state = 451, .external_lex_state = 4},
  [9268] = {.lex_state = 255},
  [9269] = {.lex_state = 255},
  [9270] = {.lex_state = 255},
  [9271] = {.lex_state = 255},
  [9272] = {.lex_state = 255},
  [9273] = {.lex_state = 255},
  [9274] = {.lex_state = 255},
  [9275] = {.lex_state = 255},
  [9276] = {.lex_state = 255},
  [9277] = {.lex_state = 255},
  [9278] = {.lex_state = 258},
  [9279] = {.lex_state = 255},
  [9280] = {.lex_state = 255},
  [9281] = {.lex_state = 255},
  [9282] = {.lex_state = 255},
  [9283] = {.lex_state = 258},
  [9284] = {.lex_state = 255},
  [9285] = {.lex_state = 255},
  [9286] = {.lex_state = 258},
  [9287] = {.lex_state = 255},
  [9288] = {.lex_state = 255},
  [9289] = {.lex_state = 255},
  [9290] = {.lex_state = 255},
  [9291] = {.lex_state = 255},
  [9292] = {.lex_state = 255},
  [9293] = {.lex_state = 186},
  [9294] = {.lex_state = 255},
  [9295] = {.lex_state = 255},
  [9296] = {.lex_state = 255},
  [9297] = {.lex_state = 255},
  [9298] = {.lex_state = 255},
  [9299] = {.lex_state = 451, .external_lex_state = 4},
  [9300] = {.lex_state = 255},
  [9301] = {.lex_state = 255},
  [9302] = {.lex_state = 255},
  [9303] = {.lex_state = 255},
  [9304] = {.lex_state = 255},
  [9305] = {.lex_state = 255},
  [9306] = {.lex_state = 255},
  [9307] = {.lex_state = 255},
  [9308] = {.lex_state = 255},
  [9309] = {.lex_state = 255},
  [9310] = {.lex_state = 255},
  [9311] = {.lex_state = 258},
  [9312] = {.lex_state = 258},
  [9313] = {.lex_state = 255},
  [9314] = {.lex_state = 255},
  [9315] = {.lex_state = 258},
  [9316] = {.lex_state = 255},
  [9317] = {.lex_state = 451, .external_lex_state = 4},
  [9318] = {.lex_state = 255},
  [9319] = {.lex_state = 255},
  [9320] = {.lex_state = 255},
  [9321] = {.lex_state = 255},
  [9322] = {.lex_state = 255},
  [9323] = {.lex_state = 186},
  [9324] = {.lex_state = 255},
  [9325] = {.lex_state = 255},
  [9326] = {.lex_state = 255},
  [9327] = {.lex_state = 255},
  [9328] = {.lex_state = 255},
  [9329] = {.lex_state = 255},
  [9330] = {.lex_state = 451},
  [9331] = {.lex_state = 255},
  [9332] = {.lex_state = 255},
  [9333] = {.lex_state = 255},
  [9334] = {.lex_state = 255},
  [9335] = {.lex_state = 255},
  [9336] = {.lex_state = 255},
  [9337] = {.lex_state = 255},
  [9338] = {.lex_state = 255},
  [9339] = {.lex_state = 253},
  [9340] = {.lex_state = 240},
  [9341] = {.lex_state = 255},
  [9342] = {.lex_state = 255},
  [9343] = {.lex_state = 255},
  [9344] = {.lex_state = 255},
  [9345] = {.lex_state = 186},
  [9346] = {.lex_state = 255},
  [9347] = {.lex_state = 255},
  [9348] = {.lex_state = 255},
  [9349] = {.lex_state = 255},
  [9350] = {.lex_state = 255},
  [9351] = {.lex_state = 451, .external_lex_state = 4},
  [9352] = {.lex_state = 255},
  [9353] = {.lex_state = 255},
  [9354] = {.lex_state = 255},
  [9355] = {.lex_state = 255},
  [9356] = {.lex_state = 451},
  [9357] = {.lex_state = 255},
  [9358] = {.lex_state = 255},
  [9359] = {.lex_state = 255},
  [9360] = {.lex_state = 255},
  [9361] = {.lex_state = 255},
  [9362] = {.lex_state = 255},
  [9363] = {.lex_state = 255},
  [9364] = {.lex_state = 255},
  [9365] = {.lex_state = 255},
  [9366] = {.lex_state = 255},
  [9367] = {.lex_state = 255},
  [9368] = {.lex_state = 255},
  [9369] = {.lex_state = 255},
  [9370] = {.lex_state = 255},
  [9371] = {.lex_state = 255},
  [9372] = {.lex_state = 451, .external_lex_state = 4},
  [9373] = {.lex_state = 255},
  [9374] = {.lex_state = 255},
  [9375] = {.lex_state = 255},
  [9376] = {.lex_state = 255},
  [9377] = {.lex_state = 255},
  [9378] = {.lex_state = 255},
  [9379] = {.lex_state = 255},
  [9380] = {.lex_state = 451},
  [9381] = {.lex_state = 255},
  [9382] = {.lex_state = 255},
  [9383] = {.lex_state = 255},
  [9384] = {.lex_state = 255},
  [9385] = {.lex_state = 243},
  [9386] = {.lex_state = 255},
  [9387] = {.lex_state = 255},
  [9388] = {.lex_state = 186},
  [9389] = {.lex_state = 255},
  [9390] = {.lex_state = 255},
  [9391] = {.lex_state = 243},
  [9392] = {.lex_state = 186},
  [9393] = {.lex_state = 255},
  [9394] = {.lex_state = 255},
  [9395] = {.lex_state = 255},
  [9396] = {.lex_state = 186},
  [9397] = {.lex_state = 186},
  [9398] = {.lex_state = 253, .external_lex_state = 4},
  [9399] = {.lex_state = 244},
  [9400] = {.lex_state = 255},
  [9401] = {.lex_state = 255},
  [9402] = {.lex_state = 255},
  [9403] = {.lex_state = 255},
  [9404] = {.lex_state = 451, .external_lex_state = 4},
  [9405] = {.lex_state = 242},
  [9406] = {.lex_state = 451},
  [9407] = {.lex_state = 253},
  [9408] = {.lex_state = 243},
  [9409] = {.lex_state = 186},
  [9410] = {.lex_state = 186},
  [9411] = {.lex_state = 243},
  [9412] = {.lex_state = 186},
  [9413] = {.lex_state = 253},
  [9414] = {.lex_state = 451},
  [9415] = {.lex_state = 242},
  [9416] = {.lex_state = 186},
  [9417] = {.lex_state = 256},
  [9418] = {.lex_state = 242},
  [9419] = {.lex_state = 451, .external_lex_state = 5},
  [9420] = {.lex_state = 451, .external_lex_state = 5},
  [9421] = {.lex_state = 253},
  [9422] = {.lex_state = 254},
  [9423] = {.lex_state = 451},
  [9424] = {.lex_state = 255},
  [9425] = {.lex_state = 186},
  [9426] = {.lex_state = 451, .external_lex_state = 4},
  [9427] = {.lex_state = 451, .external_lex_state = 5},
  [9428] = {.lex_state = 451, .external_lex_state = 5},
  [9429] = {.lex_state = 451, .external_lex_state = 4},
  [9430] = {.lex_state = 259, .external_lex_state = 4},
  [9431] = {.lex_state = 451},
  [9432] = {.lex_state = 451},
  [9433] = {.lex_state = 451, .external_lex_state = 5},
  [9434] = {.lex_state = 451, .external_lex_state = 4},
  [9435] = {.lex_state = 451, .external_lex_state = 5},
  [9436] = {.lex_state = 451, .external_lex_state = 5},
  [9437] = {.lex_state = 253},
  [9438] = {.lex_state = 451, .external_lex_state = 5},
  [9439] = {.lex_state = 451, .external_lex_state = 5},
  [9440] = {.lex_state = 451, .external_lex_state = 4},
  [9441] = {.lex_state = 451, .external_lex_state = 2},
  [9442] = {.lex_state = 186},
  [9443] = {.lex_state = 451, .external_lex_state = 2},
  [9444] = {.lex_state = 451},
  [9445] = {.lex_state = 451, .external_lex_state = 4},
  [9446] = {.lex_state = 451, .external_lex_state = 4},
  [9447] = {.lex_state = 256},
  [9448] = {.lex_state = 451, .external_lex_state = 4},
  [9449] = {.lex_state = 253},
  [9450] = {.lex_state = 259, .external_lex_state = 4},
  [9451] = {.lex_state = 259, .external_lex_state = 4},
  [9452] = {.lex_state = 186},
  [9453] = {.lex_state = 451, .external_lex_state = 5},
  [9454] = {.lex_state = 242},
  [9455] = {.lex_state = 451, .external_lex_state = 5},
  [9456] = {.lex_state = 242},
  [9457] = {.lex_state = 253},
  [9458] = {.lex_state = 242},
  [9459] = {.lex_state = 242},
  [9460] = {.lex_state = 242},
  [9461] = {.lex_state = 451},
  [9462] = {.lex_state = 254},
  [9463] = {.lex_state = 186},
  [9464] = {.lex_state = 254},
  [9465] = {.lex_state = 242},
  [9466] = {.lex_state = 242},
  [9467] = {.lex_state = 242},
  [9468] = {.lex_state = 451, .external_lex_state = 5},
  [9469] = {.lex_state = 242},
  [9470] = {.lex_state = 242},
  [9471] = {.lex_state = 451},
  [9472] = {.lex_state = 451},
  [9473] = {.lex_state = 451},
  [9474] = {.lex_state = 242},
  [9475] = {.lex_state = 242},
  [9476] = {.lex_state = 242},
  [9477] = {.lex_state = 451, .external_lex_state = 5},
  [9478] = {.lex_state = 242},
  [9479] = {.lex_state = 451},
  [9480] = {.lex_state = 242},
  [9481] = {.lex_state = 451},
  [9482] = {.lex_state = 451, .external_lex_state = 5},
  [9483] = {.lex_state = 254},
  [9484] = {.lex_state = 451, .external_lex_state = 5},
  [9485] = {.lex_state = 255},
  [9486] = {.lex_state = 451},
  [9487] = {.lex_state = 255},
  [9488] = {.lex_state = 451, .external_lex_state = 5},
  [9489] = {.lex_state = 255},
  [9490] = {.lex_state = 451, .external_lex_state = 4},
  [9491] = {.lex_state = 451, .external_lex_state = 4},
  [9492] = {.lex_state = 451, .external_lex_state = 4},
  [9493] = {.lex_state = 451, .external_lex_state = 4},
  [9494] = {.lex_state = 451, .external_lex_state = 4},
  [9495] = {.lex_state = 451, .external_lex_state = 4},
  [9496] = {.lex_state = 451, .external_lex_state = 4},
  [9497] = {.lex_state = 451, .external_lex_state = 4},
  [9498] = {.lex_state = 451, .external_lex_state = 4},
  [9499] = {.lex_state = 451, .external_lex_state = 4},
  [9500] = {.lex_state = 451, .external_lex_state = 4},
  [9501] = {.lex_state = 451, .external_lex_state = 4},
  [9502] = {.lex_state = 451, .external_lex_state = 4},
  [9503] = {.lex_state = 451, .external_lex_state = 4},
  [9504] = {.lex_state = 253},
  [9505] = {.lex_state = 253},
  [9506] = {.lex_state = 253},
  [9507] = {.lex_state = 451, .external_lex_state = 4},
  [9508] = {.lex_state = 451, .external_lex_state = 4},
  [9509] = {.lex_state = 451, .external_lex_state = 4},
  [9510] = {.lex_state = 451, .external_lex_state = 4},
  [9511] = {.lex_state = 451, .external_lex_state = 4},
  [9512] = {.lex_state = 451, .external_lex_state = 4},
  [9513] = {.lex_state = 451, .external_lex_state = 4},
  [9514] = {.lex_state = 451, .external_lex_state = 4},
  [9515] = {.lex_state = 451, .external_lex_state = 4},
  [9516] = {.lex_state = 451, .external_lex_state = 4},
  [9517] = {.lex_state = 451, .external_lex_state = 4},
  [9518] = {.lex_state = 451},
  [9519] = {.lex_state = 451, .external_lex_state = 4},
  [9520] = {.lex_state = 451, .external_lex_state = 4},
  [9521] = {.lex_state = 451},
  [9522] = {.lex_state = 451, .external_lex_state = 4},
  [9523] = {.lex_state = 451, .external_lex_state = 4},
  [9524] = {.lex_state = 451, .external_lex_state = 4},
  [9525] = {.lex_state = 451, .external_lex_state = 4},
  [9526] = {.lex_state = 451, .external_lex_state = 4},
  [9527] = {.lex_state = 242},
  [9528] = {.lex_state = 451, .external_lex_state = 4},
  [9529] = {.lex_state = 451, .external_lex_state = 4},
  [9530] = {.lex_state = 242},
  [9531] = {.lex_state = 451, .external_lex_state = 4},
  [9532] = {.lex_state = 451, .external_lex_state = 4},
  [9533] = {.lex_state = 451, .external_lex_state = 4},
  [9534] = {.lex_state = 451, .external_lex_state = 4},
  [9535] = {.lex_state = 451, .external_lex_state = 4},
  [9536] = {.lex_state = 451, .external_lex_state = 4},
  [9537] = {.lex_state = 451},
  [9538] = {.lex_state = 451, .external_lex_state = 4},
  [9539] = {.lex_state = 451, .external_lex_state = 4},
  [9540] = {.lex_state = 451, .external_lex_state = 4},
  [9541] = {.lex_state = 451, .external_lex_state = 4},
  [9542] = {.lex_state = 451, .external_lex_state = 4},
  [9543] = {.lex_state = 451, .external_lex_state = 4},
  [9544] = {.lex_state = 451, .external_lex_state = 4},
  [9545] = {.lex_state = 451, .external_lex_state = 4},
  [9546] = {.lex_state = 253},
  [9547] = {.lex_state = 451, .external_lex_state = 4},
  [9548] = {.lex_state = 451},
  [9549] = {.lex_state = 451, .external_lex_state = 4},
  [9550] = {.lex_state = 451, .external_lex_state = 4},
  [9551] = {.lex_state = 451, .external_lex_state = 4},
  [9552] = {.lex_state = 451, .external_lex_state = 4},
  [9553] = {.lex_state = 253},
  [9554] = {.lex_state = 451, .external_lex_state = 4},
  [9555] = {.lex_state = 451},
  [9556] = {.lex_state = 451, .external_lex_state = 4},
  [9557] = {.lex_state = 451, .external_lex_state = 4},
  [9558] = {.lex_state = 451},
  [9559] = {.lex_state = 451},
  [9560] = {.lex_state = 451, .external_lex_state = 4},
  [9561] = {.lex_state = 451, .external_lex_state = 4},
  [9562] = {.lex_state = 451, .external_lex_state = 4},
  [9563] = {.lex_state = 451, .external_lex_state = 4},
  [9564] = {.lex_state = 257},
  [9565] = {.lex_state = 451, .external_lex_state = 4},
  [9566] = {.lex_state = 451, .external_lex_state = 4},
  [9567] = {.lex_state = 451, .external_lex_state = 4},
  [9568] = {.lex_state = 451, .external_lex_state = 4},
  [9569] = {.lex_state = 257},
  [9570] = {.lex_state = 451},
  [9571] = {.lex_state = 451, .external_lex_state = 4},
  [9572] = {.lex_state = 242},
  [9573] = {.lex_state = 451, .external_lex_state = 4},
  [9574] = {.lex_state = 451, .external_lex_state = 4},
  [9575] = {.lex_state = 451, .external_lex_state = 4},
  [9576] = {.lex_state = 451, .external_lex_state = 4},
  [9577] = {.lex_state = 451, .external_lex_state = 4},
  [9578] = {.lex_state = 257},
  [9579] = {.lex_state = 451, .external_lex_state = 4},
  [9580] = {.lex_state = 451, .external_lex_state = 4},
  [9581] = {.lex_state = 451},
  [9582] = {.lex_state = 451, .external_lex_state = 4},
  [9583] = {.lex_state = 253},
  [9584] = {.lex_state = 451, .external_lex_state = 4},
  [9585] = {.lex_state = 253},
  [9586] = {.lex_state = 451, .external_lex_state = 4},
  [9587] = {.lex_state = 253},
  [9588] = {.lex_state = 451, .external_lex_state = 4},
  [9589] = {.lex_state = 186},
  [9590] = {.lex_state = 186},
  [9591] = {.lex_state = 451, .external_lex_state = 4},
  [9592] = {.lex_state = 451, .external_lex_state = 4},
  [9593] = {.lex_state = 451, .external_lex_state = 4},
  [9594] = {.lex_state = 451, .external_lex_state = 4},
  [9595] = {.lex_state = 451, .external_lex_state = 4},
  [9596] = {.lex_state = 451, .external_lex_state = 4},
  [9597] = {.lex_state = 451, .external_lex_state = 4},
  [9598] = {.lex_state = 451, .external_lex_state = 4},
  [9599] = {.lex_state = 451},
  [9600] = {.lex_state = 451, .external_lex_state = 4},
  [9601] = {.lex_state = 451, .external_lex_state = 4},
  [9602] = {.lex_state = 451, .external_lex_state = 4},
  [9603] = {.lex_state = 451, .external_lex_state = 4},
  [9604] = {.lex_state = 451, .external_lex_state = 4},
  [9605] = {.lex_state = 451, .external_lex_state = 4},
  [9606] = {.lex_state = 451, .external_lex_state = 4},
  [9607] = {.lex_state = 451},
  [9608] = {.lex_state = 451, .external_lex_state = 4},
  [9609] = {.lex_state = 451, .external_lex_state = 4},
  [9610] = {.lex_state = 451, .external_lex_state = 4},
  [9611] = {.lex_state = 451, .external_lex_state = 4},
  [9612] = {.lex_state = 451, .external_lex_state = 4},
  [9613] = {.lex_state = 451, .external_lex_state = 4},
  [9614] = {.lex_state = 451, .external_lex_state = 4},
  [9615] = {.lex_state = 451, .external_lex_state = 4},
  [9616] = {.lex_state = 451, .external_lex_state = 5},
  [9617] = {.lex_state = 253},
  [9618] = {.lex_state = 451, .external_lex_state = 4},
  [9619] = {.lex_state = 451},
  [9620] = {.lex_state = 451},
  [9621] = {.lex_state = 451},
  [9622] = {.lex_state = 451, .external_lex_state = 4},
  [9623] = {.lex_state = 451, .external_lex_state = 4},
  [9624] = {.lex_state = 451},
  [9625] = {.lex_state = 451, .external_lex_state = 4},
  [9626] = {.lex_state = 451, .external_lex_state = 4},
  [9627] = {.lex_state = 451, .external_lex_state = 4},
  [9628] = {.lex_state = 451, .external_lex_state = 4},
  [9629] = {.lex_state = 451, .external_lex_state = 4},
  [9630] = {.lex_state = 253, .external_lex_state = 4},
  [9631] = {.lex_state = 257},
  [9632] = {.lex_state = 451, .external_lex_state = 4},
  [9633] = {.lex_state = 451, .external_lex_state = 4},
  [9634] = {.lex_state = 451, .external_lex_state = 4},
  [9635] = {.lex_state = 451, .external_lex_state = 4},
  [9636] = {.lex_state = 451, .external_lex_state = 4},
  [9637] = {.lex_state = 451, .external_lex_state = 4},
  [9638] = {.lex_state = 451, .external_lex_state = 4},
  [9639] = {.lex_state = 451, .external_lex_state = 4},
  [9640] = {.lex_state = 451, .external_lex_state = 4},
  [9641] = {.lex_state = 451, .external_lex_state = 4},
  [9642] = {.lex_state = 451, .external_lex_state = 4},
  [9643] = {.lex_state = 451, .external_lex_state = 4},
  [9644] = {.lex_state = 451, .external_lex_state = 4},
  [9645] = {.lex_state = 243},
  [9646] = {.lex_state = 451, .external_lex_state = 4},
  [9647] = {.lex_state = 451},
  [9648] = {.lex_state = 243},
  [9649] = {.lex_state = 451},
  [9650] = {.lex_state = 253, .external_lex_state = 4},
  [9651] = {.lex_state = 451, .external_lex_state = 4},
  [9652] = {.lex_state = 451, .external_lex_state = 4},
  [9653] = {.lex_state = 451, .external_lex_state = 4},
  [9654] = {.lex_state = 451, .external_lex_state = 4},
  [9655] = {.lex_state = 451},
  [9656] = {.lex_state = 451, .external_lex_state = 4},
  [9657] = {.lex_state = 451, .external_lex_state = 4},
  [9658] = {.lex_state = 451, .external_lex_state = 4},
  [9659] = {.lex_state = 451, .external_lex_state = 4},
  [9660] = {.lex_state = 451, .external_lex_state = 4},
  [9661] = {.lex_state = 451, .external_lex_state = 4},
  [9662] = {.lex_state = 263},
  [9663] = {.lex_state = 451, .external_lex_state = 4},
  [9664] = {.lex_state = 451, .external_lex_state = 4},
  [9665] = {.lex_state = 451, .external_lex_state = 4},
  [9666] = {.lex_state = 451},
  [9667] = {.lex_state = 257},
  [9668] = {.lex_state = 451, .external_lex_state = 4},
  [9669] = {.lex_state = 451, .external_lex_state = 4},
  [9670] = {.lex_state = 451},
  [9671] = {.lex_state = 451, .external_lex_state = 4},
  [9672] = {.lex_state = 451, .external_lex_state = 4},
  [9673] = {.lex_state = 451, .external_lex_state = 4},
  [9674] = {.lex_state = 451, .external_lex_state = 4},
  [9675] = {.lex_state = 451, .external_lex_state = 4},
  [9676] = {.lex_state = 451, .external_lex_state = 4},
  [9677] = {.lex_state = 451, .external_lex_state = 4},
  [9678] = {.lex_state = 242},
  [9679] = {.lex_state = 451, .external_lex_state = 4},
  [9680] = {.lex_state = 451},
  [9681] = {.lex_state = 451, .external_lex_state = 4},
  [9682] = {.lex_state = 451, .external_lex_state = 4},
  [9683] = {.lex_state = 451, .external_lex_state = 4},
  [9684] = {.lex_state = 451, .external_lex_state = 4},
  [9685] = {.lex_state = 451},
  [9686] = {.lex_state = 253, .external_lex_state = 4},
  [9687] = {.lex_state = 451},
  [9688] = {.lex_state = 451, .external_lex_state = 4},
  [9689] = {.lex_state = 451, .external_lex_state = 4},
  [9690] = {.lex_state = 451, .external_lex_state = 4},
  [9691] = {.lex_state = 451, .external_lex_state = 4},
  [9692] = {.lex_state = 451, .external_lex_state = 4},
  [9693] = {.lex_state = 451},
  [9694] = {.lex_state = 451, .external_lex_state = 4},
  [9695] = {.lex_state = 451},
  [9696] = {.lex_state = 451},
  [9697] = {.lex_state = 451},
  [9698] = {.lex_state = 242},
  [9699] = {.lex_state = 451},
  [9700] = {.lex_state = 451},
  [9701] = {.lex_state = 451},
  [9702] = {.lex_state = 242},
  [9703] = {.lex_state = 451},
  [9704] = {.lex_state = 451},
  [9705] = {.lex_state = 451},
  [9706] = {.lex_state = 242},
  [9707] = {.lex_state = 242},
  [9708] = {.lex_state = 451},
  [9709] = {.lex_state = 451},
  [9710] = {.lex_state = 451},
  [9711] = {.lex_state = 451},
  [9712] = {.lex_state = 242},
  [9713] = {.lex_state = 451},
  [9714] = {.lex_state = 451},
  [9715] = {.lex_state = 242},
  [9716] = {.lex_state = 451, .external_lex_state = 4},
  [9717] = {.lex_state = 451},
  [9718] = {.lex_state = 451},
  [9719] = {.lex_state = 242},
  [9720] = {.lex_state = 451},
  [9721] = {.lex_state = 451},
  [9722] = {.lex_state = 451},
  [9723] = {.lex_state = 451},
  [9724] = {.lex_state = 451},
  [9725] = {.lex_state = 451},
  [9726] = {.lex_state = 451},
  [9727] = {.lex_state = 451},
  [9728] = {.lex_state = 242},
  [9729] = {.lex_state = 451},
  [9730] = {.lex_state = 451},
  [9731] = {.lex_state = 242},
  [9732] = {.lex_state = 451},
  [9733] = {.lex_state = 242},
  [9734] = {.lex_state = 451},
  [9735] = {.lex_state = 451},
  [9736] = {.lex_state = 451},
  [9737] = {.lex_state = 451},
  [9738] = {.lex_state = 451},
  [9739] = {.lex_state = 242},
  [9740] = {.lex_state = 242},
  [9741] = {.lex_state = 451},
  [9742] = {.lex_state = 451},
  [9743] = {.lex_state = 451},
  [9744] = {.lex_state = 451},
  [9745] = {.lex_state = 451},
  [9746] = {.lex_state = 451},
  [9747] = {.lex_state = 242},
  [9748] = {.lex_state = 451},
  [9749] = {.lex_state = 451},
  [9750] = {.lex_state = 451},
  [9751] = {.lex_state = 451},
  [9752] = {.lex_state = 242},
  [9753] = {.lex_state = 451},
  [9754] = {.lex_state = 451},
  [9755] = {.lex_state = 451},
  [9756] = {.lex_state = 451},
  [9757] = {.lex_state = 242},
  [9758] = {.lex_state = 451},
  [9759] = {.lex_state = 451},
  [9760] = {.lex_state = 451},
  [9761] = {.lex_state = 451},
  [9762] = {.lex_state = 242},
  [9763] = {.lex_state = 451, .external_lex_state = 4},
  [9764] = {.lex_state = 451},
  [9765] = {.lex_state = 451},
  [9766] = {.lex_state = 451},
  [9767] = {.lex_state = 242},
  [9768] = {.lex_state = 451},
  [9769] = {.lex_state = 451},
  [9770] = {.lex_state = 451},
  [9771] = {.lex_state = 451},
  [9772] = {.lex_state = 451},
  [9773] = {.lex_state = 451},
  [9774] = {.lex_state = 451},
  [9775] = {.lex_state = 242},
  [9776] = {.lex_state = 451},
  [9777] = {.lex_state = 451},
  [9778] = {.lex_state = 451},
  [9779] = {.lex_state = 451},
  [9780] = {.lex_state = 451},
  [9781] = {.lex_state = 451},
  [9782] = {.lex_state = 242},
  [9783] = {.lex_state = 451},
  [9784] = {.lex_state = 242},
  [9785] = {.lex_state = 451},
  [9786] = {.lex_state = 242},
  [9787] = {.lex_state = 451},
  [9788] = {.lex_state = 242},
  [9789] = {.lex_state = 451},
  [9790] = {.lex_state = 451},
  [9791] = {.lex_state = 451},
  [9792] = {.lex_state = 451},
  [9793] = {.lex_state = 451},
  [9794] = {.lex_state = 451},
  [9795] = {.lex_state = 451},
  [9796] = {.lex_state = 451},
  [9797] = {.lex_state = 242},
  [9798] = {.lex_state = 242},
  [9799] = {.lex_state = 451},
  [9800] = {.lex_state = 451},
  [9801] = {.lex_state = 451},
  [9802] = {.lex_state = 451},
  [9803] = {.lex_state = 451},
  [9804] = {.lex_state = 242},
  [9805] = {.lex_state = 242},
  [9806] = {.lex_state = 451},
  [9807] = {.lex_state = 451},
  [9808] = {.lex_state = 451},
  [9809] = {.lex_state = 242},
  [9810] = {.lex_state = 451},
  [9811] = {.lex_state = 451},
  [9812] = {.lex_state = 451, .external_lex_state = 4},
  [9813] = {.lex_state = 451},
  [9814] = {.lex_state = 451},
  [9815] = {.lex_state = 451},
  [9816] = {.lex_state = 451},
  [9817] = {.lex_state = 451},
  [9818] = {.lex_state = 242},
  [9819] = {.lex_state = 451},
  [9820] = {.lex_state = 451},
  [9821] = {.lex_state = 451},
  [9822] = {.lex_state = 451},
  [9823] = {.lex_state = 451},
  [9824] = {.lex_state = 242},
  [9825] = {.lex_state = 451},
  [9826] = {.lex_state = 451},
  [9827] = {.lex_state = 451},
  [9828] = {.lex_state = 451},
  [9829] = {.lex_state = 242},
  [9830] = {.lex_state = 451},
  [9831] = {.lex_state = 451},
  [9832] = {.lex_state = 242},
  [9833] = {.lex_state = 451},
  [9834] = {.lex_state = 451},
  [9835] = {.lex_state = 451},
  [9836] = {.lex_state = 242},
  [9837] = {.lex_state = 451},
  [9838] = {.lex_state = 451},
  [9839] = {.lex_state = 451},
  [9840] = {.lex_state = 451},
  [9841] = {.lex_state = 451},
  [9842] = {.lex_state = 451},
  [9843] = {.lex_state = 242},
  [9844] = {.lex_state = 242},
  [9845] = {.lex_state = 451},
  [9846] = {.lex_state = 451},
  [9847] = {.lex_state = 451},
  [9848] = {.lex_state = 451},
  [9849] = {.lex_state = 451},
  [9850] = {.lex_state = 242},
  [9851] = {.lex_state = 451},
  [9852] = {.lex_state = 451},
  [9853] = {.lex_state = 451},
  [9854] = {.lex_state = 451},
  [9855] = {.lex_state = 451},
  [9856] = {.lex_state = 451},
  [9857] = {.lex_state = 451, .external_lex_state = 3},
  [9858] = {.lex_state = 451},
  [9859] = {.lex_state = 451},
  [9860] = {.lex_state = 242},
  [9861] = {.lex_state = 451},
  [9862] = {.lex_state = 451},
  [9863] = {.lex_state = 451},
  [9864] = {.lex_state = 242},
  [9865] = {.lex_state = 451},
  [9866] = {.lex_state = 451},
  [9867] = {.lex_state = 451},
  [9868] = {.lex_state = 451},
  [9869] = {.lex_state = 451},
  [9870] = {.lex_state = 451},
  [9871] = {.lex_state = 242},
  [9872] = {.lex_state = 451},
  [9873] = {.lex_state = 451},
  [9874] = {.lex_state = 451},
  [9875] = {.lex_state = 451},
  [9876] = {.lex_state = 451},
  [9877] = {.lex_state = 242},
  [9878] = {.lex_state = 242},
  [9879] = {.lex_state = 451},
  [9880] = {.lex_state = 451},
  [9881] = {.lex_state = 451},
  [9882] = {.lex_state = 242},
  [9883] = {.lex_state = 451},
  [9884] = {.lex_state = 451},
  [9885] = {.lex_state = 451},
  [9886] = {.lex_state = 451},
  [9887] = {.lex_state = 451},
  [9888] = {.lex_state = 242},
  [9889] = {.lex_state = 451},
  [9890] = {.lex_state = 451, .external_lex_state = 4},
  [9891] = {.lex_state = 451},
  [9892] = {.lex_state = 451, .external_lex_state = 4},
  [9893] = {.lex_state = 242},
  [9894] = {.lex_state = 451},
  [9895] = {.lex_state = 451},
  [9896] = {.lex_state = 451},
  [9897] = {.lex_state = 451},
  [9898] = {.lex_state = 451},
  [9899] = {.lex_state = 242},
  [9900] = {.lex_state = 451},
  [9901] = {.lex_state = 451},
  [9902] = {.lex_state = 451},
  [9903] = {.lex_state = 242},
  [9904] = {.lex_state = 451},
  [9905] = {.lex_state = 451},
  [9906] = {.lex_state = 451},
  [9907] = {.lex_state = 451},
  [9908] = {.lex_state = 451},
  [9909] = {.lex_state = 242},
  [9910] = {.lex_state = 451},
  [9911] = {.lex_state = 451},
  [9912] = {.lex_state = 451},
  [9913] = {.lex_state = 242},
  [9914] = {.lex_state = 451},
  [9915] = {.lex_state = 242},
  [9916] = {.lex_state = 451},
  [9917] = {.lex_state = 242},
  [9918] = {.lex_state = 451},
  [9919] = {.lex_state = 242},
  [9920] = {.lex_state = 451},
  [9921] = {.lex_state = 242},
  [9922] = {.lex_state = 451},
  [9923] = {.lex_state = 451},
  [9924] = {.lex_state = 451},
  [9925] = {.lex_state = 451},
  [9926] = {.lex_state = 451},
  [9927] = {.lex_state = 253},
  [9928] = {.lex_state = 451},
  [9929] = {.lex_state = 242},
  [9930] = {.lex_state = 451},
  [9931] = {.lex_state = 451},
  [9932] = {.lex_state = 451},
  [9933] = {.lex_state = 451},
  [9934] = {.lex_state = 451},
  [9935] = {.lex_state = 451},
  [9936] = {.lex_state = 451},
  [9937] = {.lex_state = 451, .external_lex_state = 4},
  [9938] = {.lex_state = 242},
  [9939] = {.lex_state = 242},
  [9940] = {.lex_state = 451},
  [9941] = {.lex_state = 451},
  [9942] = {.lex_state = 451},
  [9943] = {.lex_state = 451},
  [9944] = {.lex_state = 242},
  [9945] = {.lex_state = 242},
  [9946] = {.lex_state = 451},
  [9947] = {.lex_state = 451},
  [9948] = {.lex_state = 242},
  [9949] = {.lex_state = 451},
  [9950] = {.lex_state = 451},
  [9951] = {.lex_state = 451},
  [9952] = {.lex_state = 451},
  [9953] = {.lex_state = 242},
  [9954] = {.lex_state = 451},
  [9955] = {.lex_state = 451},
  [9956] = {.lex_state = 451},
  [9957] = {.lex_state = 242},
  [9958] = {.lex_state = 451},
  [9959] = {.lex_state = 451},
  [9960] = {.lex_state = 451},
  [9961] = {.lex_state = 451},
  [9962] = {.lex_state = 451},
  [9963] = {.lex_state = 451},
  [9964] = {.lex_state = 451},
  [9965] = {.lex_state = 451},
  [9966] = {.lex_state = 242},
  [9967] = {.lex_state = 242},
  [9968] = {.lex_state = 451},
  [9969] = {.lex_state = 451},
  [9970] = {.lex_state = 451},
  [9971] = {.lex_state = 451},
  [9972] = {.lex_state = 451},
  [9973] = {.lex_state = 451},
  [9974] = {.lex_state = 451},
  [9975] = {.lex_state = 242},
  [9976] = {.lex_state = 253, .external_lex_state = 2},
  [9977] = {.lex_state = 451, .external_lex_state = 4},
  [9978] = {.lex_state = 451, .external_lex_state = 4},
  [9979] = {.lex_state = 451},
  [9980] = {.lex_state = 451},
  [9981] = {.lex_state = 242},
  [9982] = {.lex_state = 451},
  [9983] = {.lex_state = 451},
  [9984] = {.lex_state = 451},
  [9985] = {.lex_state = 451},
  [9986] = {.lex_state = 451},
  [9987] = {.lex_state = 451, .external_lex_state = 4},
  [9988] = {.lex_state = 451, .external_lex_state = 4},
  [9989] = {.lex_state = 242},
  [9990] = {.lex_state = 451},
  [9991] = {.lex_state = 451},
  [9992] = {.lex_state = 451},
  [9993] = {.lex_state = 451},
  [9994] = {.lex_state = 451},
  [9995] = {.lex_state = 242},
  [9996] = {.lex_state = 451},
  [9997] = {.lex_state = 451},
  [9998] = {.lex_state = 451},
  [9999] = {.lex_state = 451},
  [10000] = {.lex_state = 242},
  [10001] = {.lex_state = 451},
  [10002] = {.lex_state = 242},
  [10003] = {.lex_state = 451},
  [10004] = {.lex_state = 451},
  [10005] = {.lex_state = 242},
  [10006] = {.lex_state = 451},
  [10007] = {.lex_state = 451},
  [10008] = {.lex_state = 451},
  [10009] = {.lex_state = 451},
  [10010] = {.lex_state = 451},
  [10011] = {.lex_state = 242},
  [10012] = {.lex_state = 451},
  [10013] = {.lex_state = 451},
  [10014] = {.lex_state = 451},
  [10015] = {.lex_state = 451},
  [10016] = {.lex_state = 451},
  [10017] = {.lex_state = 451},
  [10018] = {.lex_state = 451},
  [10019] = {.lex_state = 242},
  [10020] = {.lex_state = 451},
  [10021] = {.lex_state = 451},
  [10022] = {.lex_state = 451},
  [10023] = {.lex_state = 242},
  [10024] = {.lex_state = 242},
  [10025] = {.lex_state = 451},
  [10026] = {.lex_state = 451},
  [10027] = {.lex_state = 242},
  [10028] = {.lex_state = 451},
  [10029] = {.lex_state = 451},
  [10030] = {.lex_state = 451, .external_lex_state = 4},
  [10031] = {.lex_state = 451},
  [10032] = {.lex_state = 451},
  [10033] = {.lex_state = 451},
  [10034] = {.lex_state = 451},
  [10035] = {.lex_state = 451},
  [10036] = {.lex_state = 451},
  [10037] = {.lex_state = 242},
  [10038] = {.lex_state = 451},
  [10039] = {.lex_state = 451},
  [10040] = {.lex_state = 451},
  [10041] = {.lex_state = 186},
  [10042] = {.lex_state = 451},
  [10043] = {.lex_state = 451},
  [10044] = {.lex_state = 451},
  [10045] = {.lex_state = 242},
  [10046] = {.lex_state = 242},
  [10047] = {.lex_state = 451},
  [10048] = {.lex_state = 451},
  [10049] = {.lex_state = 451},
  [10050] = {.lex_state = 451},
  [10051] = {.lex_state = 253},
  [10052] = {.lex_state = 242},
  [10053] = {.lex_state = 242},
  [10054] = {.lex_state = 451},
  [10055] = {.lex_state = 451},
  [10056] = {.lex_state = 451},
  [10057] = {.lex_state = 242},
  [10058] = {.lex_state = 242},
  [10059] = {.lex_state = 451},
  [10060] = {.lex_state = 451},
  [10061] = {.lex_state = 451},
  [10062] = {.lex_state = 242},
  [10063] = {.lex_state = 451},
  [10064] = {.lex_state = 451},
  [10065] = {.lex_state = 451},
  [10066] = {.lex_state = 451, .external_lex_state = 3},
  [10067] = {.lex_state = 242},
  [10068] = {.lex_state = 242},
  [10069] = {.lex_state = 242},
  [10070] = {.lex_state = 451},
  [10071] = {.lex_state = 451},
  [10072] = {.lex_state = 451},
  [10073] = {.lex_state = 253},
  [10074] = {.lex_state = 451},
  [10075] = {.lex_state = 451},
  [10076] = {.lex_state = 451, .external_lex_state = 4},
  [10077] = {.lex_state = 242},
  [10078] = {.lex_state = 253},
  [10079] = {.lex_state = 242},
  [10080] = {.lex_state = 451},
  [10081] = {.lex_state = 451},
  [10082] = {.lex_state = 253},
  [10083] = {.lex_state = 242},
  [10084] = {.lex_state = 451},
  [10085] = {.lex_state = 451},
  [10086] = {.lex_state = 451},
  [10087] = {.lex_state = 451, .external_lex_state = 4},
  [10088] = {.lex_state = 451},
  [10089] = {.lex_state = 451},
  [10090] = {.lex_state = 451},
  [10091] = {.lex_state = 242},
  [10092] = {.lex_state = 451},
  [10093] = {.lex_state = 242},
  [10094] = {.lex_state = 451},
  [10095] = {.lex_state = 451},
  [10096] = {.lex_state = 242},
  [10097] = {.lex_state = 451},
  [10098] = {.lex_state = 451},
  [10099] = {.lex_state = 451},
  [10100] = {.lex_state = 253},
  [10101] = {.lex_state = 253},
  [10102] = {.lex_state = 242},
  [10103] = {.lex_state = 451},
  [10104] = {.lex_state = 451, .external_lex_state = 4},
  [10105] = {.lex_state = 451, .external_lex_state = 4},
  [10106] = {.lex_state = 451, .external_lex_state = 4},
  [10107] = {.lex_state = 242},
  [10108] = {.lex_state = 451, .external_lex_state = 4},
  [10109] = {.lex_state = 242},
  [10110] = {.lex_state = 451},
  [10111] = {.lex_state = 451},
  [10112] = {.lex_state = 451},
  [10113] = {.lex_state = 451},
  [10114] = {.lex_state = 242},
  [10115] = {.lex_state = 451, .external_lex_state = 4},
  [10116] = {.lex_state = 451},
  [10117] = {.lex_state = 451},
  [10118] = {.lex_state = 451, .external_lex_state = 4},
  [10119] = {.lex_state = 242},
  [10120] = {.lex_state = 451, .external_lex_state = 4},
  [10121] = {.lex_state = 451},
  [10122] = {.lex_state = 451},
  [10123] = {.lex_state = 451, .external_lex_state = 4},
  [10124] = {.lex_state = 451, .external_lex_state = 4},
  [10125] = {.lex_state = 451, .external_lex_state = 4},
  [10126] = {.lex_state = 451, .external_lex_state = 4},
  [10127] = {.lex_state = 242},
  [10128] = {.lex_state = 451, .external_lex_state = 4},
  [10129] = {.lex_state = 451, .external_lex_state = 4},
  [10130] = {.lex_state = 242},
  [10131] = {.lex_state = 451},
  [10132] = {.lex_state = 451},
  [10133] = {.lex_state = 242},
  [10134] = {.lex_state = 451, .external_lex_state = 4},
  [10135] = {.lex_state = 242},
  [10136] = {.lex_state = 451},
  [10137] = {.lex_state = 451},
  [10138] = {.lex_state = 451},
  [10139] = {.lex_state = 451, .external_lex_state = 4},
  [10140] = {.lex_state = 451, .external_lex_state = 4},
  [10141] = {.lex_state = 451, .external_lex_state = 4},
  [10142] = {.lex_state = 451, .external_lex_state = 4},
  [10143] = {.lex_state = 451, .external_lex_state = 4},
  [10144] = {.lex_state = 451, .external_lex_state = 4},
  [10145] = {.lex_state = 253},
  [10146] = {.lex_state = 451, .external_lex_state = 4},
  [10147] = {.lex_state = 242},
  [10148] = {.lex_state = 451},
  [10149] = {.lex_state = 451},
  [10150] = {.lex_state = 451},
  [10151] = {.lex_state = 451, .external_lex_state = 4},
  [10152] = {.lex_state = 451},
  [10153] = {.lex_state = 451, .external_lex_state = 4},
  [10154] = {.lex_state = 451},
  [10155] = {.lex_state = 451, .external_lex_state = 4},
  [10156] = {.lex_state = 451},
  [10157] = {.lex_state = 451, .external_lex_state = 4},
  [10158] = {.lex_state = 242},
  [10159] = {.lex_state = 451, .external_lex_state = 4},
  [10160] = {.lex_state = 451, .external_lex_state = 4},
  [10161] = {.lex_state = 451},
  [10162] = {.lex_state = 451},
  [10163] = {.lex_state = 451},
  [10164] = {.lex_state = 451},
  [10165] = {.lex_state = 242},
  [10166] = {.lex_state = 242},
  [10167] = {.lex_state = 451, .external_lex_state = 4},
  [10168] = {.lex_state = 253},
  [10169] = {.lex_state = 451},
  [10170] = {.lex_state = 451},
  [10171] = {.lex_state = 451},
  [10172] = {.lex_state = 451},
  [10173] = {.lex_state = 242},
  [10174] = {.lex_state = 451},
  [10175] = {.lex_state = 451},
  [10176] = {.lex_state = 451, .external_lex_state = 4},
  [10177] = {.lex_state = 451},
  [10178] = {.lex_state = 451, .external_lex_state = 2},
  [10179] = {.lex_state = 451},
  [10180] = {.lex_state = 451},
  [10181] = {.lex_state = 451},
  [10182] = {.lex_state = 242},
  [10183] = {.lex_state = 451, .external_lex_state = 4},
  [10184] = {.lex_state = 451},
  [10185] = {.lex_state = 242},
  [10186] = {.lex_state = 451},
  [10187] = {.lex_state = 451},
  [10188] = {.lex_state = 242},
  [10189] = {.lex_state = 451, .external_lex_state = 4},
  [10190] = {.lex_state = 242},
  [10191] = {.lex_state = 451, .external_lex_state = 4},
  [10192] = {.lex_state = 451},
  [10193] = {.lex_state = 242},
  [10194] = {.lex_state = 256},
  [10195] = {.lex_state = 451},
  [10196] = {.lex_state = 242},
  [10197] = {.lex_state = 451},
  [10198] = {.lex_state = 451},
  [10199] = {.lex_state = 242},
  [10200] = {.lex_state = 242},
  [10201] = {.lex_state = 242},
  [10202] = {.lex_state = 451},
  [10203] = {.lex_state = 451, .external_lex_state = 4},
  [10204] = {.lex_state = 242},
  [10205] = {.lex_state = 451},
  [10206] = {.lex_state = 451},
  [10207] = {.lex_state = 451},
  [10208] = {.lex_state = 451},
  [10209] = {.lex_state = 451},
  [10210] = {.lex_state = 451},
  [10211] = {.lex_state = 242},
  [10212] = {.lex_state = 242},
  [10213] = {.lex_state = 451},
  [10214] = {.lex_state = 451},
  [10215] = {.lex_state = 451},
  [10216] = {.lex_state = 451},
  [10217] = {.lex_state = 451},
  [10218] = {.lex_state = 253},
  [10219] = {.lex_state = 242},
  [10220] = {.lex_state = 253},
  [10221] = {.lex_state = 451},
  [10222] = {.lex_state = 242},
  [10223] = {.lex_state = 451},
  [10224] = {.lex_state = 451},
  [10225] = {.lex_state = 451},
  [10226] = {.lex_state = 242},
  [10227] = {.lex_state = 242},
  [10228] = {.lex_state = 242},
  [10229] = {.lex_state = 451},
  [10230] = {.lex_state = 242},
  [10231] = {.lex_state = 451},
  [10232] = {.lex_state = 451},
  [10233] = {.lex_state = 451},
  [10234] = {.lex_state = 451},
  [10235] = {.lex_state = 451},
  [10236] = {.lex_state = 242},
  [10237] = {.lex_state = 242},
  [10238] = {.lex_state = 451},
  [10239] = {.lex_state = 451},
  [10240] = {.lex_state = 242},
  [10241] = {.lex_state = 451},
  [10242] = {.lex_state = 451},
  [10243] = {.lex_state = 242},
  [10244] = {.lex_state = 451},
  [10245] = {.lex_state = 451},
  [10246] = {.lex_state = 451},
  [10247] = {.lex_state = 242},
  [10248] = {.lex_state = 451},
  [10249] = {.lex_state = 451},
  [10250] = {.lex_state = 451},
  [10251] = {.lex_state = 242},
  [10252] = {.lex_state = 451},
  [10253] = {.lex_state = 451},
  [10254] = {.lex_state = 451},
  [10255] = {.lex_state = 451},
  [10256] = {.lex_state = 451},
  [10257] = {.lex_state = 242},
  [10258] = {.lex_state = 451},
  [10259] = {.lex_state = 451},
  [10260] = {.lex_state = 451},
  [10261] = {.lex_state = 451},
  [10262] = {.lex_state = 451},
  [10263] = {.lex_state = 242},
  [10264] = {.lex_state = 451},
  [10265] = {.lex_state = 451},
  [10266] = {.lex_state = 451},
  [10267] = {.lex_state = 242},
  [10268] = {.lex_state = 451},
  [10269] = {.lex_state = 451},
  [10270] = {.lex_state = 451},
  [10271] = {.lex_state = 242},
  [10272] = {.lex_state = 451},
  [10273] = {.lex_state = 451},
  [10274] = {.lex_state = 451},
  [10275] = {.lex_state = 451},
  [10276] = {.lex_state = 451},
  [10277] = {.lex_state = 242},
  [10278] = {.lex_state = 451},
  [10279] = {.lex_state = 451},
  [10280] = {.lex_state = 451},
  [10281] = {.lex_state = 242},
  [10282] = {.lex_state = 451},
  [10283] = {.lex_state = 451},
  [10284] = {.lex_state = 242},
  [10285] = {.lex_state = 451},
  [10286] = {.lex_state = 451},
  [10287] = {.lex_state = 451},
  [10288] = {.lex_state = 242},
  [10289] = {.lex_state = 451},
  [10290] = {.lex_state = 451},
  [10291] = {.lex_state = 451},
  [10292] = {.lex_state = 242},
  [10293] = {.lex_state = 451},
  [10294] = {.lex_state = 242},
  [10295] = {.lex_state = 451},
  [10296] = {.lex_state = 451},
  [10297] = {.lex_state = 242},
  [10298] = {.lex_state = 451},
  [10299] = {.lex_state = 451},
  [10300] = {.lex_state = 451},
  [10301] = {.lex_state = 242},
  [10302] = {.lex_state = 451},
  [10303] = {.lex_state = 451},
  [10304] = {.lex_state = 451},
  [10305] = {.lex_state = 242},
  [10306] = {.lex_state = 451},
  [10307] = {.lex_state = 451},
  [10308] = {.lex_state = 451},
  [10309] = {.lex_state = 451},
  [10310] = {.lex_state = 451},
  [10311] = {.lex_state = 451},
  [10312] = {.lex_state = 242},
  [10313] = {.lex_state = 451},
  [10314] = {.lex_state = 451},
  [10315] = {.lex_state = 242},
  [10316] = {.lex_state = 451},
  [10317] = {.lex_state = 451},
  [10318] = {.lex_state = 451},
  [10319] = {.lex_state = 242},
  [10320] = {.lex_state = 451},
  [10321] = {.lex_state = 451},
  [10322] = {.lex_state = 451},
  [10323] = {.lex_state = 451},
  [10324] = {.lex_state = 242},
  [10325] = {.lex_state = 451},
  [10326] = {.lex_state = 451},
  [10327] = {.lex_state = 451},
  [10328] = {.lex_state = 451},
  [10329] = {.lex_state = 242},
  [10330] = {.lex_state = 451},
  [10331] = {.lex_state = 242},
  [10332] = {.lex_state = 451},
  [10333] = {.lex_state = 451},
  [10334] = {.lex_state = 451},
  [10335] = {.lex_state = 242},
  [10336] = {.lex_state = 242},
  [10337] = {.lex_state = 451},
  [10338] = {.lex_state = 451},
  [10339] = {.lex_state = 451},
  [10340] = {.lex_state = 242},
  [10341] = {.lex_state = 451},
  [10342] = {.lex_state = 451},
  [10343] = {.lex_state = 451},
  [10344] = {.lex_state = 242},
  [10345] = {.lex_state = 451},
  [10346] = {.lex_state = 242},
  [10347] = {.lex_state = 242},
  [10348] = {.lex_state = 451},
  [10349] = {.lex_state = 451},
  [10350] = {.lex_state = 451},
  [10351] = {.lex_state = 451},
  [10352] = {.lex_state = 451},
  [10353] = {.lex_state = 242},
  [10354] = {.lex_state = 451},
  [10355] = {.lex_state = 451},
  [10356] = {.lex_state = 451},
  [10357] = {.lex_state = 242},
  [10358] = {.lex_state = 451},
  [10359] = {.lex_state = 451},
  [10360] = {.lex_state = 451},
  [10361] = {.lex_state = 451},
  [10362] = {.lex_state = 451},
  [10363] = {.lex_state = 451},
  [10364] = {.lex_state = 451},
  [10365] = {.lex_state = 242},
  [10366] = {.lex_state = 451},
  [10367] = {.lex_state = 242},
  [10368] = {.lex_state = 242},
  [10369] = {.lex_state = 451},
  [10370] = {.lex_state = 451},
  [10371] = {.lex_state = 242},
  [10372] = {.lex_state = 451},
  [10373] = {.lex_state = 451},
  [10374] = {.lex_state = 451},
  [10375] = {.lex_state = 451},
  [10376] = {.lex_state = 451},
  [10377] = {.lex_state = 451},
  [10378] = {.lex_state = 242},
  [10379] = {.lex_state = 242},
  [10380] = {.lex_state = 451},
  [10381] = {.lex_state = 451},
  [10382] = {.lex_state = 242},
  [10383] = {.lex_state = 451},
  [10384] = {.lex_state = 451},
  [10385] = {.lex_state = 451},
  [10386] = {.lex_state = 451},
  [10387] = {.lex_state = 451},
  [10388] = {.lex_state = 242},
  [10389] = {.lex_state = 451},
  [10390] = {.lex_state = 451},
  [10391] = {.lex_state = 242},
  [10392] = {.lex_state = 451},
  [10393] = {.lex_state = 451},
  [10394] = {.lex_state = 451},
  [10395] = {.lex_state = 451},
  [10396] = {.lex_state = 242},
  [10397] = {.lex_state = 451},
  [10398] = {.lex_state = 451},
  [10399] = {.lex_state = 451},
  [10400] = {.lex_state = 451},
  [10401] = {.lex_state = 242},
  [10402] = {.lex_state = 242},
  [10403] = {.lex_state = 451},
  [10404] = {.lex_state = 451},
  [10405] = {.lex_state = 451},
  [10406] = {.lex_state = 451},
  [10407] = {.lex_state = 451},
  [10408] = {.lex_state = 451},
  [10409] = {.lex_state = 242},
  [10410] = {.lex_state = 451},
  [10411] = {.lex_state = 242},
  [10412] = {.lex_state = 451},
  [10413] = {.lex_state = 451},
  [10414] = {.lex_state = 451},
  [10415] = {.lex_state = 451},
  [10416] = {.lex_state = 242},
  [10417] = {.lex_state = 451},
  [10418] = {.lex_state = 451},
  [10419] = {.lex_state = 451},
  [10420] = {.lex_state = 242},
  [10421] = {.lex_state = 451},
  [10422] = {.lex_state = 451},
  [10423] = {.lex_state = 451},
  [10424] = {.lex_state = 242},
  [10425] = {.lex_state = 451},
  [10426] = {.lex_state = 451},
  [10427] = {.lex_state = 242},
  [10428] = {.lex_state = 451},
  [10429] = {.lex_state = 242},
  [10430] = {.lex_state = 451},
  [10431] = {.lex_state = 242},
  [10432] = {.lex_state = 451},
  [10433] = {.lex_state = 451},
  [10434] = {.lex_state = 242},
  [10435] = {.lex_state = 451},
  [10436] = {.lex_state = 451},
  [10437] = {.lex_state = 451},
  [10438] = {.lex_state = 451},
  [10439] = {.lex_state = 451},
  [10440] = {.lex_state = 242},
  [10441] = {.lex_state = 451},
  [10442] = {.lex_state = 451},
  [10443] = {.lex_state = 451},
  [10444] = {.lex_state = 242},
  [10445] = {.lex_state = 451},
  [10446] = {.lex_state = 451},
  [10447] = {.lex_state = 451},
  [10448] = {.lex_state = 242},
  [10449] = {.lex_state = 451},
  [10450] = {.lex_state = 242},
  [10451] = {.lex_state = 451},
  [10452] = {.lex_state = 451},
  [10453] = {.lex_state = 242},
  [10454] = {.lex_state = 451},
  [10455] = {.lex_state = 242},
  [10456] = {.lex_state = 451},
  [10457] = {.lex_state = 242},
  [10458] = {.lex_state = 242},
  [10459] = {.lex_state = 451},
  [10460] = {.lex_state = 451},
  [10461] = {.lex_state = 451},
  [10462] = {.lex_state = 242},
  [10463] = {.lex_state = 451},
  [10464] = {.lex_state = 451},
  [10465] = {.lex_state = 451},
  [10466] = {.lex_state = 451},
  [10467] = {.lex_state = 451},
  [10468] = {.lex_state = 242},
  [10469] = {.lex_state = 451},
  [10470] = {.lex_state = 451},
  [10471] = {.lex_state = 451},
  [10472] = {.lex_state = 242},
  [10473] = {.lex_state = 451},
  [10474] = {.lex_state = 451},
  [10475] = {.lex_state = 451},
  [10476] = {.lex_state = 242},
  [10477] = {.lex_state = 451},
  [10478] = {.lex_state = 451},
  [10479] = {.lex_state = 242},
  [10480] = {.lex_state = 451},
  [10481] = {.lex_state = 451},
  [10482] = {.lex_state = 451},
  [10483] = {.lex_state = 242},
  [10484] = {.lex_state = 451},
  [10485] = {.lex_state = 242},
  [10486] = {.lex_state = 451},
  [10487] = {.lex_state = 451},
  [10488] = {.lex_state = 242},
  [10489] = {.lex_state = 451},
  [10490] = {.lex_state = 451},
  [10491] = {.lex_state = 451},
  [10492] = {.lex_state = 451},
  [10493] = {.lex_state = 242},
  [10494] = {.lex_state = 451},
  [10495] = {.lex_state = 451},
  [10496] = {.lex_state = 451},
  [10497] = {.lex_state = 242},
  [10498] = {.lex_state = 451},
  [10499] = {.lex_state = 451},
  [10500] = {.lex_state = 451},
  [10501] = {.lex_state = 451},
  [10502] = {.lex_state = 242},
  [10503] = {.lex_state = 451},
  [10504] = {.lex_state = 451},
  [10505] = {.lex_state = 451},
  [10506] = {.lex_state = 451},
  [10507] = {.lex_state = 242},
  [10508] = {.lex_state = 451},
  [10509] = {.lex_state = 451},
  [10510] = {.lex_state = 242},
  [10511] = {.lex_state = 451},
  [10512] = {.lex_state = 451},
  [10513] = {.lex_state = 242},
  [10514] = {.lex_state = 451},
  [10515] = {.lex_state = 451},
  [10516] = {.lex_state = 451},
  [10517] = {.lex_state = 451},
  [10518] = {.lex_state = 451},
  [10519] = {.lex_state = 451},
  [10520] = {.lex_state = 451},
  [10521] = {.lex_state = 451},
  [10522] = {.lex_state = 451},
  [10523] = {.lex_state = 451},
  [10524] = {.lex_state = 242},
  [10525] = {.lex_state = 451},
  [10526] = {.lex_state = 451},
  [10527] = {.lex_state = 451},
  [10528] = {.lex_state = 242},
  [10529] = {.lex_state = 451},
  [10530] = {.lex_state = 451},
  [10531] = {.lex_state = 242},
  [10532] = {.lex_state = 451},
  [10533] = {.lex_state = 451},
  [10534] = {.lex_state = 451},
  [10535] = {.lex_state = 242},
  [10536] = {.lex_state = 451},
  [10537] = {.lex_state = 451},
  [10538] = {.lex_state = 242},
  [10539] = {.lex_state = 451},
  [10540] = {.lex_state = 451},
  [10541] = {.lex_state = 451},
  [10542] = {.lex_state = 451},
  [10543] = {.lex_state = 451},
  [10544] = {.lex_state = 451},
  [10545] = {.lex_state = 242},
  [10546] = {.lex_state = 451},
  [10547] = {.lex_state = 451},
  [10548] = {.lex_state = 451},
  [10549] = {.lex_state = 242},
  [10550] = {.lex_state = 451},
  [10551] = {.lex_state = 451},
  [10552] = {.lex_state = 451},
  [10553] = {.lex_state = 451},
  [10554] = {.lex_state = 451},
  [10555] = {.lex_state = 242},
  [10556] = {.lex_state = 451},
  [10557] = {.lex_state = 451},
  [10558] = {.lex_state = 451},
  [10559] = {.lex_state = 451},
  [10560] = {.lex_state = 451},
  [10561] = {.lex_state = 242},
  [10562] = {.lex_state = 451},
  [10563] = {.lex_state = 242},
  [10564] = {.lex_state = 451},
  [10565] = {.lex_state = 242},
  [10566] = {.lex_state = 451},
  [10567] = {.lex_state = 451},
  [10568] = {.lex_state = 242},
  [10569] = {.lex_state = 451},
  [10570] = {.lex_state = 451},
  [10571] = {.lex_state = 451},
  [10572] = {.lex_state = 451},
  [10573] = {.lex_state = 242},
  [10574] = {.lex_state = 242},
  [10575] = {.lex_state = 451},
  [10576] = {.lex_state = 451},
  [10577] = {.lex_state = 242},
  [10578] = {.lex_state = 451},
  [10579] = {.lex_state = 451},
  [10580] = {.lex_state = 451},
  [10581] = {.lex_state = 451},
  [10582] = {.lex_state = 451},
  [10583] = {.lex_state = 242},
  [10584] = {.lex_state = 451},
  [10585] = {.lex_state = 242},
  [10586] = {.lex_state = 451},
  [10587] = {.lex_state = 451},
  [10588] = {.lex_state = 451},
  [10589] = {.lex_state = 451},
  [10590] = {.lex_state = 242},
  [10591] = {.lex_state = 451},
  [10592] = {.lex_state = 451},
  [10593] = {.lex_state = 451},
  [10594] = {.lex_state = 451},
  [10595] = {.lex_state = 451},
  [10596] = {.lex_state = 242},
  [10597] = {.lex_state = 242},
  [10598] = {.lex_state = 451},
  [10599] = {.lex_state = 451},
  [10600] = {.lex_state = 451},
  [10601] = {.lex_state = 242},
  [10602] = {.lex_state = 451},
  [10603] = {.lex_state = 451},
  [10604] = {.lex_state = 242},
  [10605] = {.lex_state = 451},
  [10606] = {.lex_state = 451},
  [10607] = {.lex_state = 451},
  [10608] = {.lex_state = 451},
  [10609] = {.lex_state = 242},
  [10610] = {.lex_state = 451},
  [10611] = {.lex_state = 451},
  [10612] = {.lex_state = 242},
  [10613] = {.lex_state = 451},
  [10614] = {.lex_state = 451},
  [10615] = {.lex_state = 451},
  [10616] = {.lex_state = 242},
  [10617] = {.lex_state = 242},
  [10618] = {.lex_state = 451},
  [10619] = {.lex_state = 451},
  [10620] = {.lex_state = 242},
  [10621] = {.lex_state = 451},
  [10622] = {.lex_state = 451},
  [10623] = {.lex_state = 451},
  [10624] = {.lex_state = 242},
  [10625] = {.lex_state = 451},
  [10626] = {.lex_state = 451},
  [10627] = {.lex_state = 451},
  [10628] = {.lex_state = 242},
  [10629] = {.lex_state = 451},
  [10630] = {.lex_state = 451},
  [10631] = {.lex_state = 451},
  [10632] = {.lex_state = 242},
  [10633] = {.lex_state = 451},
  [10634] = {.lex_state = 451},
  [10635] = {.lex_state = 451},
  [10636] = {.lex_state = 451},
  [10637] = {.lex_state = 451},
  [10638] = {.lex_state = 451},
  [10639] = {.lex_state = 451},
  [10640] = {.lex_state = 242},
  [10641] = {.lex_state = 242},
  [10642] = {.lex_state = 451},
  [10643] = {.lex_state = 242},
  [10644] = {.lex_state = 451},
  [10645] = {.lex_state = 451},
  [10646] = {.lex_state = 242},
  [10647] = {.lex_state = 451},
  [10648] = {.lex_state = 451},
  [10649] = {.lex_state = 242},
  [10650] = {.lex_state = 451},
  [10651] = {.lex_state = 451},
  [10652] = {.lex_state = 451},
  [10653] = {.lex_state = 242},
  [10654] = {.lex_state = 451},
  [10655] = {.lex_state = 451},
  [10656] = {.lex_state = 451},
  [10657] = {.lex_state = 451},
  [10658] = {.lex_state = 451},
  [10659] = {.lex_state = 451},
  [10660] = {.lex_state = 242},
  [10661] = {.lex_state = 451},
  [10662] = {.lex_state = 451},
  [10663] = {.lex_state = 242},
  [10664] = {.lex_state = 451},
  [10665] = {.lex_state = 451},
  [10666] = {.lex_state = 451},
  [10667] = {.lex_state = 242},
  [10668] = {.lex_state = 451},
  [10669] = {.lex_state = 242},
  [10670] = {.lex_state = 451},
  [10671] = {.lex_state = 451},
  [10672] = {.lex_state = 451},
  [10673] = {.lex_state = 451},
  [10674] = {.lex_state = 451},
  [10675] = {.lex_state = 451},
  [10676] = {.lex_state = 451},
  [10677] = {.lex_state = 451},
  [10678] = {.lex_state = 242},
  [10679] = {.lex_state = 451},
  [10680] = {.lex_state = 242},
  [10681] = {.lex_state = 451},
  [10682] = {.lex_state = 242},
  [10683] = {.lex_state = 451},
  [10684] = {.lex_state = 242},
  [10685] = {.lex_state = 451},
  [10686] = {.lex_state = 451},
  [10687] = {.lex_state = 242},
  [10688] = {.lex_state = 451},
  [10689] = {.lex_state = 451},
  [10690] = {.lex_state = 451},
  [10691] = {.lex_state = 451},
  [10692] = {.lex_state = 451},
  [10693] = {.lex_state = 451},
  [10694] = {.lex_state = 242},
  [10695] = {.lex_state = 451},
  [10696] = {.lex_state = 451},
  [10697] = {.lex_state = 451},
  [10698] = {.lex_state = 451},
  [10699] = {.lex_state = 451},
  [10700] = {.lex_state = 242},
  [10701] = {.lex_state = 242},
  [10702] = {.lex_state = 451},
  [10703] = {.lex_state = 451},
  [10704] = {.lex_state = 451},
  [10705] = {.lex_state = 242},
  [10706] = {.lex_state = 451},
  [10707] = {.lex_state = 451},
  [10708] = {.lex_state = 451},
  [10709] = {.lex_state = 451},
  [10710] = {.lex_state = 451},
  [10711] = {.lex_state = 451},
  [10712] = {.lex_state = 451},
  [10713] = {.lex_state = 242},
  [10714] = {.lex_state = 451},
  [10715] = {.lex_state = 451},
  [10716] = {.lex_state = 451},
  [10717] = {.lex_state = 451},
  [10718] = {.lex_state = 451},
  [10719] = {.lex_state = 242},
  [10720] = {.lex_state = 451},
  [10721] = {.lex_state = 451},
  [10722] = {.lex_state = 242},
  [10723] = {.lex_state = 451},
  [10724] = {.lex_state = 242},
  [10725] = {.lex_state = 242},
  [10726] = {.lex_state = 451},
  [10727] = {.lex_state = 451},
  [10728] = {.lex_state = 451},
  [10729] = {.lex_state = 242},
  [10730] = {.lex_state = 451},
  [10731] = {.lex_state = 451},
  [10732] = {.lex_state = 451},
  [10733] = {.lex_state = 242},
  [10734] = {.lex_state = 451},
  [10735] = {.lex_state = 451},
  [10736] = {.lex_state = 451},
  [10737] = {.lex_state = 242},
  [10738] = {.lex_state = 451},
  [10739] = {.lex_state = 242},
  [10740] = {.lex_state = 451},
  [10741] = {.lex_state = 451},
  [10742] = {.lex_state = 451},
  [10743] = {.lex_state = 242},
  [10744] = {.lex_state = 451},
  [10745] = {.lex_state = 451},
  [10746] = {.lex_state = 242},
  [10747] = {.lex_state = 451},
  [10748] = {.lex_state = 451},
  [10749] = {.lex_state = 451},
  [10750] = {.lex_state = 451},
  [10751] = {.lex_state = 451},
  [10752] = {.lex_state = 242},
  [10753] = {.lex_state = 242},
  [10754] = {.lex_state = 451},
  [10755] = {.lex_state = 451},
  [10756] = {.lex_state = 451},
  [10757] = {.lex_state = 242},
  [10758] = {.lex_state = 451},
  [10759] = {.lex_state = 242},
  [10760] = {.lex_state = 451},
  [10761] = {.lex_state = 451},
  [10762] = {.lex_state = 451},
  [10763] = {.lex_state = 451},
  [10764] = {.lex_state = 242},
  [10765] = {.lex_state = 451},
  [10766] = {.lex_state = 451},
  [10767] = {.lex_state = 451},
  [10768] = {.lex_state = 242},
  [10769] = {.lex_state = 451},
  [10770] = {.lex_state = 451},
  [10771] = {.lex_state = 451},
  [10772] = {.lex_state = 242},
  [10773] = {.lex_state = 451},
  [10774] = {.lex_state = 242},
  [10775] = {.lex_state = 242},
  [10776] = {.lex_state = 451},
  [10777] = {.lex_state = 451},
  [10778] = {.lex_state = 242},
  [10779] = {.lex_state = 451},
  [10780] = {.lex_state = 451},
  [10781] = {.lex_state = 242},
  [10782] = {.lex_state = 451},
  [10783] = {.lex_state = 451},
  [10784] = {.lex_state = 451},
  [10785] = {.lex_state = 242},
  [10786] = {.lex_state = 451},
  [10787] = {.lex_state = 451},
  [10788] = {.lex_state = 451},
  [10789] = {.lex_state = 242},
  [10790] = {.lex_state = 451},
  [10791] = {.lex_state = 451},
  [10792] = {.lex_state = 451},
  [10793] = {.lex_state = 451},
  [10794] = {.lex_state = 451},
  [10795] = {.lex_state = 242},
  [10796] = {.lex_state = 451},
  [10797] = {.lex_state = 451},
  [10798] = {.lex_state = 451},
  [10799] = {.lex_state = 242},
  [10800] = {.lex_state = 242},
  [10801] = {.lex_state = 451},
  [10802] = {.lex_state = 451},
  [10803] = {.lex_state = 451},
  [10804] = {.lex_state = 242},
  [10805] = {.lex_state = 451},
  [10806] = {.lex_state = 242},
  [10807] = {.lex_state = 451},
  [10808] = {.lex_state = 451},
  [10809] = {.lex_state = 451},
  [10810] = {.lex_state = 242},
  [10811] = {.lex_state = 451},
  [10812] = {.lex_state = 451},
  [10813] = {.lex_state = 451},
  [10814] = {.lex_state = 451},
  [10815] = {.lex_state = 451},
  [10816] = {.lex_state = 451},
  [10817] = {.lex_state = 451},
  [10818] = {.lex_state = 242},
  [10819] = {.lex_state = 451},
  [10820] = {.lex_state = 451},
  [10821] = {.lex_state = 451},
  [10822] = {.lex_state = 451},
  [10823] = {.lex_state = 242},
  [10824] = {.lex_state = 451},
  [10825] = {.lex_state = 451},
  [10826] = {.lex_state = 242},
  [10827] = {.lex_state = 242},
  [10828] = {.lex_state = 451},
  [10829] = {.lex_state = 242},
  [10830] = {.lex_state = 451},
  [10831] = {.lex_state = 451},
  [10832] = {.lex_state = 242},
  [10833] = {.lex_state = 451},
  [10834] = {.lex_state = 451},
  [10835] = {.lex_state = 451},
  [10836] = {.lex_state = 242},
  [10837] = {.lex_state = 451},
  [10838] = {.lex_state = 451},
  [10839] = {.lex_state = 451},
  [10840] = {.lex_state = 242},
  [10841] = {.lex_state = 451},
  [10842] = {.lex_state = 451},
  [10843] = {.lex_state = 242},
  [10844] = {.lex_state = 451},
  [10845] = {.lex_state = 451},
  [10846] = {.lex_state = 451},
  [10847] = {.lex_state = 242},
  [10848] = {.lex_state = 451},
  [10849] = {.lex_state = 451},
  [10850] = {.lex_state = 451},
  [10851] = {.lex_state = 451},
  [10852] = {.lex_state = 451},
  [10853] = {.lex_state = 242},
  [10854] = {.lex_state = 242},
  [10855] = {.lex_state = 451},
  [10856] = {.lex_state = 451},
  [10857] = {.lex_state = 451},
  [10858] = {.lex_state = 242},
  [10859] = {.lex_state = 451},
  [10860] = {.lex_state = 451},
  [10861] = {.lex_state = 451},
  [10862] = {.lex_state = 242},
  [10863] = {.lex_state = 451},
  [10864] = {.lex_state = 451},
  [10865] = {.lex_state = 451},
  [10866] = {.lex_state = 242},
  [10867] = {.lex_state = 451},
  [10868] = {.lex_state = 451},
  [10869] = {.lex_state = 451},
  [10870] = {.lex_state = 451},
  [10871] = {.lex_state = 242},
  [10872] = {.lex_state = 451},
  [10873] = {.lex_state = 242},
  [10874] = {.lex_state = 451},
  [10875] = {.lex_state = 242},
  [10876] = {.lex_state = 451},
  [10877] = {.lex_state = 242},
  [10878] = {.lex_state = 242},
  [10879] = {.lex_state = 451},
  [10880] = {.lex_state = 451},
  [10881] = {.lex_state = 242},
  [10882] = {.lex_state = 451},
  [10883] = {.lex_state = 451},
  [10884] = {.lex_state = 451},
  [10885] = {.lex_state = 242},
  [10886] = {.lex_state = 451},
  [10887] = {.lex_state = 451},
  [10888] = {.lex_state = 451},
  [10889] = {.lex_state = 451},
  [10890] = {.lex_state = 242},
  [10891] = {.lex_state = 242},
  [10892] = {.lex_state = 451},
  [10893] = {.lex_state = 451},
  [10894] = {.lex_state = 451},
  [10895] = {.lex_state = 242},
  [10896] = {.lex_state = 451},
  [10897] = {.lex_state = 451},
  [10898] = {.lex_state = 451},
  [10899] = {.lex_state = 451},
  [10900] = {.lex_state = 242},
  [10901] = {.lex_state = 451},
  [10902] = {.lex_state = 451},
  [10903] = {.lex_state = 451},
  [10904] = {.lex_state = 242},
  [10905] = {.lex_state = 451},
  [10906] = {.lex_state = 242},
  [10907] = {.lex_state = 451},
  [10908] = {.lex_state = 451},
  [10909] = {.lex_state = 242},
  [10910] = {.lex_state = 242},
  [10911] = {.lex_state = 451},
  [10912] = {.lex_state = 451},
  [10913] = {.lex_state = 451},
  [10914] = {.lex_state = 451},
  [10915] = {.lex_state = 451},
  [10916] = {.lex_state = 242},
  [10917] = {.lex_state = 242},
  [10918] = {.lex_state = 451},
  [10919] = {.lex_state = 451},
  [10920] = {.lex_state = 242},
  [10921] = {.lex_state = 451},
  [10922] = {.lex_state = 451},
  [10923] = {.lex_state = 242},
  [10924] = {.lex_state = 451},
  [10925] = {.lex_state = 451},
  [10926] = {.lex_state = 451},
  [10927] = {.lex_state = 451},
  [10928] = {.lex_state = 242},
  [10929] = {.lex_state = 242},
  [10930] = {.lex_state = 451},
  [10931] = {.lex_state = 451},
  [10932] = {.lex_state = 451},
  [10933] = {.lex_state = 242},
  [10934] = {.lex_state = 451},
  [10935] = {.lex_state = 451},
  [10936] = {.lex_state = 451},
  [10937] = {.lex_state = 451},
  [10938] = {.lex_state = 451},
  [10939] = {.lex_state = 242},
  [10940] = {.lex_state = 451},
  [10941] = {.lex_state = 242},
  [10942] = {.lex_state = 451},
  [10943] = {.lex_state = 242},
  [10944] = {.lex_state = 451},
  [10945] = {.lex_state = 451},
  [10946] = {.lex_state = 242},
  [10947] = {.lex_state = 451},
  [10948] = {.lex_state = 451},
  [10949] = {.lex_state = 451},
  [10950] = {.lex_state = 451},
  [10951] = {.lex_state = 242},
  [10952] = {.lex_state = 451},
  [10953] = {.lex_state = 451},
  [10954] = {.lex_state = 451},
  [10955] = {.lex_state = 242},
  [10956] = {.lex_state = 451},
  [10957] = {.lex_state = 451},
  [10958] = {.lex_state = 451},
  [10959] = {.lex_state = 242},
  [10960] = {.lex_state = 451},
  [10961] = {.lex_state = 451},
  [10962] = {.lex_state = 451},
  [10963] = {.lex_state = 242},
  [10964] = {.lex_state = 242},
  [10965] = {.lex_state = 451},
  [10966] = {.lex_state = 451},
  [10967] = {.lex_state = 451},
  [10968] = {.lex_state = 242},
  [10969] = {.lex_state = 451},
  [10970] = {.lex_state = 242},
  [10971] = {.lex_state = 242},
  [10972] = {.lex_state = 451},
  [10973] = {.lex_state = 451},
  [10974] = {.lex_state = 451},
  [10975] = {.lex_state = 451},
  [10976] = {.lex_state = 242},
  [10977] = {.lex_state = 451},
  [10978] = {.lex_state = 451},
  [10979] = {.lex_state = 451},
  [10980] = {.lex_state = 451},
  [10981] = {.lex_state = 242},
  [10982] = {.lex_state = 451},
  [10983] = {.lex_state = 451},
  [10984] = {.lex_state = 451},
  [10985] = {.lex_state = 242},
  [10986] = {.lex_state = 451},
  [10987] = {.lex_state = 451},
  [10988] = {.lex_state = 242},
  [10989] = {.lex_state = 242},
  [10990] = {.lex_state = 451},
  [10991] = {.lex_state = 451},
  [10992] = {.lex_state = 242},
  [10993] = {.lex_state = 451},
  [10994] = {.lex_state = 451},
  [10995] = {.lex_state = 242},
  [10996] = {.lex_state = 451},
  [10997] = {.lex_state = 451},
  [10998] = {.lex_state = 242},
  [10999] = {.lex_state = 242},
  [11000] = {.lex_state = 451},
  [11001] = {.lex_state = 451},
  [11002] = {.lex_state = 451},
  [11003] = {.lex_state = 242},
  [11004] = {.lex_state = 451},
  [11005] = {.lex_state = 451},
  [11006] = {.lex_state = 451},
  [11007] = {.lex_state = 451},
  [11008] = {.lex_state = 451},
  [11009] = {.lex_state = 451},
  [11010] = {.lex_state = 451},
  [11011] = {.lex_state = 451},
  [11012] = {.lex_state = 242},
  [11013] = {.lex_state = 451},
  [11014] = {.lex_state = 451},
  [11015] = {.lex_state = 451},
  [11016] = {.lex_state = 242},
  [11017] = {.lex_state = 451},
  [11018] = {.lex_state = 451},
  [11019] = {.lex_state = 242},
  [11020] = {.lex_state = 242},
  [11021] = {.lex_state = 242},
  [11022] = {.lex_state = 451},
  [11023] = {.lex_state = 451},
  [11024] = {.lex_state = 451},
  [11025] = {.lex_state = 451},
  [11026] = {.lex_state = 451},
  [11027] = {.lex_state = 242},
  [11028] = {.lex_state = 451},
  [11029] = {.lex_state = 451},
  [11030] = {.lex_state = 242},
  [11031] = {.lex_state = 451},
  [11032] = {.lex_state = 451},
  [11033] = {.lex_state = 451},
  [11034] = {.lex_state = 451},
  [11035] = {.lex_state = 451},
  [11036] = {.lex_state = 242},
  [11037] = {.lex_state = 451},
  [11038] = {.lex_state = 451},
  [11039] = {.lex_state = 451},
  [11040] = {.lex_state = 242},
  [11041] = {.lex_state = 451},
  [11042] = {.lex_state = 451},
  [11043] = {.lex_state = 451},
  [11044] = {.lex_state = 451},
  [11045] = {.lex_state = 242},
  [11046] = {.lex_state = 451},
  [11047] = {.lex_state = 451},
  [11048] = {.lex_state = 451},
  [11049] = {.lex_state = 242},
  [11050] = {.lex_state = 451},
  [11051] = {.lex_state = 242},
  [11052] = {.lex_state = 242},
  [11053] = {.lex_state = 451},
  [11054] = {.lex_state = 451},
  [11055] = {.lex_state = 451},
  [11056] = {.lex_state = 242},
  [11057] = {.lex_state = 451},
  [11058] = {.lex_state = 451},
  [11059] = {.lex_state = 451},
  [11060] = {.lex_state = 451},
  [11061] = {.lex_state = 242},
  [11062] = {.lex_state = 451},
  [11063] = {.lex_state = 242},
  [11064] = {.lex_state = 451},
  [11065] = {.lex_state = 242},
  [11066] = {.lex_state = 451},
  [11067] = {.lex_state = 451},
  [11068] = {.lex_state = 242},
  [11069] = {.lex_state = 451},
  [11070] = {.lex_state = 451},
  [11071] = {.lex_state = 451},
  [11072] = {.lex_state = 451},
  [11073] = {.lex_state = 451},
  [11074] = {.lex_state = 242},
  [11075] = {.lex_state = 451},
  [11076] = {.lex_state = 451},
  [11077] = {.lex_state = 451},
  [11078] = {.lex_state = 242},
  [11079] = {.lex_state = 451},
  [11080] = {.lex_state = 451},
  [11081] = {.lex_state = 451},
  [11082] = {.lex_state = 242},
  [11083] = {.lex_state = 242},
  [11084] = {.lex_state = 451},
  [11085] = {.lex_state = 451},
  [11086] = {.lex_state = 451},
  [11087] = {.lex_state = 242},
  [11088] = {.lex_state = 451},
  [11089] = {.lex_state = 451},
  [11090] = {.lex_state = 451},
  [11091] = {.lex_state = 451},
  [11092] = {.lex_state = 242},
  [11093] = {.lex_state = 451},
  [11094] = {.lex_state = 242},
  [11095] = {.lex_state = 451},
  [11096] = {.lex_state = 242},
  [11097] = {.lex_state = 451},
  [11098] = {.lex_state = 242},
  [11099] = {.lex_state = 242},
  [11100] = {.lex_state = 451},
  [11101] = {.lex_state = 451},
  [11102] = {.lex_state = 242},
  [11103] = {.lex_state = 451},
  [11104] = {.lex_state = 451},
  [11105] = {.lex_state = 451},
  [11106] = {.lex_state = 242},
  [11107] = {.lex_state = 451},
  [11108] = {.lex_state = 451},
  [11109] = {.lex_state = 451},
  [11110] = {.lex_state = 451},
  [11111] = {.lex_state = 242},
  [11112] = {.lex_state = 242},
  [11113] = {.lex_state = 451},
  [11114] = {.lex_state = 451},
  [11115] = {.lex_state = 451},
  [11116] = {.lex_state = 242},
  [11117] = {.lex_state = 451},
  [11118] = {.lex_state = 451},
  [11119] = {.lex_state = 451},
  [11120] = {.lex_state = 451},
  [11121] = {.lex_state = 451},
  [11122] = {.lex_state = 451},
  [11123] = {.lex_state = 451},
  [11124] = {.lex_state = 242},
  [11125] = {.lex_state = 451},
  [11126] = {.lex_state = 451},
  [11127] = {.lex_state = 451},
  [11128] = {.lex_state = 242},
  [11129] = {.lex_state = 451},
  [11130] = {.lex_state = 242},
  [11131] = {.lex_state = 242},
  [11132] = {.lex_state = 242},
  [11133] = {.lex_state = 451},
  [11134] = {.lex_state = 451},
  [11135] = {.lex_state = 242},
  [11136] = {.lex_state = 451},
  [11137] = {.lex_state = 451},
  [11138] = {.lex_state = 451},
  [11139] = {.lex_state = 451},
  [11140] = {.lex_state = 242},
  [11141] = {.lex_state = 451},
  [11142] = {.lex_state = 451},
  [11143] = {.lex_state = 451},
  [11144] = {.lex_state = 242},
  [11145] = {.lex_state = 451},
  [11146] = {.lex_state = 451},
  [11147] = {.lex_state = 451},
  [11148] = {.lex_state = 451},
  [11149] = {.lex_state = 451},
  [11150] = {.lex_state = 242},
  [11151] = {.lex_state = 451},
  [11152] = {.lex_state = 451},
  [11153] = {.lex_state = 242},
  [11154] = {.lex_state = 451},
  [11155] = {.lex_state = 242},
  [11156] = {.lex_state = 451},
  [11157] = {.lex_state = 451},
  [11158] = {.lex_state = 451},
  [11159] = {.lex_state = 451},
  [11160] = {.lex_state = 451},
  [11161] = {.lex_state = 451},
  [11162] = {.lex_state = 451},
  [11163] = {.lex_state = 242},
  [11164] = {.lex_state = 242},
  [11165] = {.lex_state = 451},
  [11166] = {.lex_state = 451},
  [11167] = {.lex_state = 451},
  [11168] = {.lex_state = 242},
  [11169] = {.lex_state = 451},
  [11170] = {.lex_state = 451},
  [11171] = {.lex_state = 451},
  [11172] = {.lex_state = 242},
  [11173] = {.lex_state = 451},
  [11174] = {.lex_state = 451},
  [11175] = {.lex_state = 242},
  [11176] = {.lex_state = 451},
  [11177] = {.lex_state = 451},
  [11178] = {.lex_state = 451},
  [11179] = {.lex_state = 242},
  [11180] = {.lex_state = 451},
  [11181] = {.lex_state = 451},
  [11182] = {.lex_state = 451},
  [11183] = {.lex_state = 451},
  [11184] = {.lex_state = 451},
  [11185] = {.lex_state = 242},
  [11186] = {.lex_state = 451},
  [11187] = {.lex_state = 242},
  [11188] = {.lex_state = 451},
  [11189] = {.lex_state = 451},
  [11190] = {.lex_state = 242},
  [11191] = {.lex_state = 451},
  [11192] = {.lex_state = 242},
  [11193] = {.lex_state = 451},
  [11194] = {.lex_state = 451},
  [11195] = {.lex_state = 451},
  [11196] = {.lex_state = 242},
  [11197] = {.lex_state = 451},
  [11198] = {.lex_state = 451},
  [11199] = {.lex_state = 451},
  [11200] = {.lex_state = 242},
  [11201] = {.lex_state = 451},
  [11202] = {.lex_state = 242},
  [11203] = {.lex_state = 451},
  [11204] = {.lex_state = 451},
  [11205] = {.lex_state = 451},
  [11206] = {.lex_state = 242},
  [11207] = {.lex_state = 451},
  [11208] = {.lex_state = 451},
  [11209] = {.lex_state = 451},
  [11210] = {.lex_state = 451},
  [11211] = {.lex_state = 242},
  [11212] = {.lex_state = 242},
  [11213] = {.lex_state = 242},
  [11214] = {.lex_state = 451},
  [11215] = {.lex_state = 451},
  [11216] = {.lex_state = 242},
  [11217] = {.lex_state = 451},
  [11218] = {.lex_state = 451},
  [11219] = {.lex_state = 451},
  [11220] = {.lex_state = 242},
  [11221] = {.lex_state = 451},
  [11222] = {.lex_state = 242},
  [11223] = {.lex_state = 451},
  [11224] = {.lex_state = 451},
  [11225] = {.lex_state = 451},
  [11226] = {.lex_state = 242},
  [11227] = {.lex_state = 451},
  [11228] = {.lex_state = 451},
  [11229] = {.lex_state = 451},
  [11230] = {.lex_state = 451},
  [11231] = {.lex_state = 242},
  [11232] = {.lex_state = 451},
  [11233] = {.lex_state = 451},
  [11234] = {.lex_state = 242},
  [11235] = {.lex_state = 451},
  [11236] = {.lex_state = 451},
  [11237] = {.lex_state = 451},
  [11238] = {.lex_state = 451},
  [11239] = {.lex_state = 242},
  [11240] = {.lex_state = 451},
  [11241] = {.lex_state = 242},
  [11242] = {.lex_state = 451},
  [11243] = {.lex_state = 451},
  [11244] = {.lex_state = 451},
  [11245] = {.lex_state = 451},
  [11246] = {.lex_state = 242},
  [11247] = {.lex_state = 242},
  [11248] = {.lex_state = 451},
  [11249] = {.lex_state = 451},
  [11250] = {.lex_state = 242},
  [11251] = {.lex_state = 451},
  [11252] = {.lex_state = 451},
  [11253] = {.lex_state = 242},
  [11254] = {.lex_state = 451},
  [11255] = {.lex_state = 451},
  [11256] = {.lex_state = 242},
  [11257] = {.lex_state = 451},
  [11258] = {.lex_state = 451},
  [11259] = {.lex_state = 242},
  [11260] = {.lex_state = 451},
  [11261] = {.lex_state = 451},
  [11262] = {.lex_state = 451},
  [11263] = {.lex_state = 242},
  [11264] = {.lex_state = 451},
  [11265] = {.lex_state = 451},
  [11266] = {.lex_state = 451},
  [11267] = {.lex_state = 242},
  [11268] = {.lex_state = 451},
  [11269] = {.lex_state = 451},
  [11270] = {.lex_state = 451},
  [11271] = {.lex_state = 451},
  [11272] = {.lex_state = 451},
  [11273] = {.lex_state = 242},
  [11274] = {.lex_state = 451},
  [11275] = {.lex_state = 242},
  [11276] = {.lex_state = 451},
  [11277] = {.lex_state = 451},
  [11278] = {.lex_state = 242},
  [11279] = {.lex_state = 242},
  [11280] = {.lex_state = 242},
  [11281] = {.lex_state = 451},
  [11282] = {.lex_state = 451},
  [11283] = {.lex_state = 242},
  [11284] = {.lex_state = 451},
  [11285] = {.lex_state = 451},
  [11286] = {.lex_state = 451},
  [11287] = {.lex_state = 242},
  [11288] = {.lex_state = 451},
  [11289] = {.lex_state = 451},
  [11290] = {.lex_state = 451},
  [11291] = {.lex_state = 451},
  [11292] = {.lex_state = 451},
  [11293] = {.lex_state = 242},
  [11294] = {.lex_state = 451},
  [11295] = {.lex_state = 451},
  [11296] = {.lex_state = 451},
  [11297] = {.lex_state = 242},
  [11298] = {.lex_state = 451},
  [11299] = {.lex_state = 242},
  [11300] = {.lex_state = 242},
  [11301] = {.lex_state = 451},
  [11302] = {.lex_state = 451},
  [11303] = {.lex_state = 451},
  [11304] = {.lex_state = 451},
  [11305] = {.lex_state = 451},
  [11306] = {.lex_state = 451},
  [11307] = {.lex_state = 451},
  [11308] = {.lex_state = 242},
  [11309] = {.lex_state = 451},
  [11310] = {.lex_state = 242},
  [11311] = {.lex_state = 451},
  [11312] = {.lex_state = 451},
  [11313] = {.lex_state = 242},
  [11314] = {.lex_state = 242},
  [11315] = {.lex_state = 451},
  [11316] = {.lex_state = 451},
  [11317] = {.lex_state = 242},
  [11318] = {.lex_state = 451},
  [11319] = {.lex_state = 451},
  [11320] = {.lex_state = 451},
  [11321] = {.lex_state = 451},
  [11322] = {.lex_state = 242},
  [11323] = {.lex_state = 451},
  [11324] = {.lex_state = 242},
  [11325] = {.lex_state = 451},
  [11326] = {.lex_state = 451},
  [11327] = {.lex_state = 451},
  [11328] = {.lex_state = 242},
  [11329] = {.lex_state = 451},
  [11330] = {.lex_state = 242},
  [11331] = {.lex_state = 451},
  [11332] = {.lex_state = 451},
  [11333] = {.lex_state = 451},
  [11334] = {.lex_state = 242},
  [11335] = {.lex_state = 451},
  [11336] = {.lex_state = 451},
  [11337] = {.lex_state = 451},
  [11338] = {.lex_state = 451},
  [11339] = {.lex_state = 451},
  [11340] = {.lex_state = 451},
  [11341] = {.lex_state = 451},
  [11342] = {.lex_state = 451},
  [11343] = {.lex_state = 451},
  [11344] = {.lex_state = 242},
  [11345] = {.lex_state = 242},
  [11346] = {.lex_state = 451},
  [11347] = {.lex_state = 242},
  [11348] = {.lex_state = 242},
  [11349] = {.lex_state = 451},
  [11350] = {.lex_state = 451},
  [11351] = {.lex_state = 242},
  [11352] = {.lex_state = 451},
  [11353] = {.lex_state = 451},
  [11354] = {.lex_state = 242},
  [11355] = {.lex_state = 451},
  [11356] = {.lex_state = 451},
  [11357] = {.lex_state = 451},
  [11358] = {.lex_state = 242},
  [11359] = {.lex_state = 451},
  [11360] = {.lex_state = 451},
  [11361] = {.lex_state = 451},
  [11362] = {.lex_state = 451},
  [11363] = {.lex_state = 451},
  [11364] = {.lex_state = 451},
  [11365] = {.lex_state = 451},
  [11366] = {.lex_state = 242},
  [11367] = {.lex_state = 242},
  [11368] = {.lex_state = 451},
  [11369] = {.lex_state = 451},
  [11370] = {.lex_state = 451},
  [11371] = {.lex_state = 242},
  [11372] = {.lex_state = 451},
  [11373] = {.lex_state = 451},
  [11374] = {.lex_state = 451},
  [11375] = {.lex_state = 242},
  [11376] = {.lex_state = 451},
  [11377] = {.lex_state = 451},
  [11378] = {.lex_state = 451},
  [11379] = {.lex_state = 451},
  [11380] = {.lex_state = 451},
  [11381] = {.lex_state = 242},
  [11382] = {.lex_state = 242},
  [11383] = {.lex_state = 242},
  [11384] = {.lex_state = 451},
  [11385] = {.lex_state = 451},
  [11386] = {.lex_state = 451},
  [11387] = {.lex_state = 242},
  [11388] = {.lex_state = 242},
  [11389] = {.lex_state = 451},
  [11390] = {.lex_state = 451},
  [11391] = {.lex_state = 242},
  [11392] = {.lex_state = 451},
  [11393] = {.lex_state = 451},
  [11394] = {.lex_state = 451},
  [11395] = {.lex_state = 242},
  [11396] = {.lex_state = 451},
  [11397] = {.lex_state = 451},
  [11398] = {.lex_state = 451},
  [11399] = {.lex_state = 451},
  [11400] = {.lex_state = 451},
  [11401] = {.lex_state = 242},
  [11402] = {.lex_state = 451},
  [11403] = {.lex_state = 451},
  [11404] = {.lex_state = 451},
  [11405] = {.lex_state = 242},
  [11406] = {.lex_state = 451},
  [11407] = {.lex_state = 451},
  [11408] = {.lex_state = 451},
  [11409] = {.lex_state = 451},
  [11410] = {.lex_state = 242},
  [11411] = {.lex_state = 451},
  [11412] = {.lex_state = 451},
  [11413] = {.lex_state = 451},
  [11414] = {.lex_state = 242},
  [11415] = {.lex_state = 451},
  [11416] = {.lex_state = 242},
  [11417] = {.lex_state = 451},
  [11418] = {.lex_state = 242},
  [11419] = {.lex_state = 451},
  [11420] = {.lex_state = 451},
  [11421] = {.lex_state = 242},
  [11422] = {.lex_state = 451},
  [11423] = {.lex_state = 451},
  [11424] = {.lex_state = 451},
  [11425] = {.lex_state = 242},
  [11426] = {.lex_state = 451},
  [11427] = {.lex_state = 451},
  [11428] = {.lex_state = 451},
  [11429] = {.lex_state = 451},
  [11430] = {.lex_state = 451},
  [11431] = {.lex_state = 242},
  [11432] = {.lex_state = 242},
  [11433] = {.lex_state = 451},
  [11434] = {.lex_state = 451},
  [11435] = {.lex_state = 451},
  [11436] = {.lex_state = 451},
  [11437] = {.lex_state = 242},
  [11438] = {.lex_state = 242},
  [11439] = {.lex_state = 451},
  [11440] = {.lex_state = 451},
  [11441] = {.lex_state = 451},
  [11442] = {.lex_state = 242},
  [11443] = {.lex_state = 451},
  [11444] = {.lex_state = 451},
  [11445] = {.lex_state = 451},
  [11446] = {.lex_state = 451},
  [11447] = {.lex_state = 451},
  [11448] = {.lex_state = 242},
  [11449] = {.lex_state = 451},
  [11450] = {.lex_state = 242},
  [11451] = {.lex_state = 451},
  [11452] = {.lex_state = 451},
  [11453] = {.lex_state = 451},
  [11454] = {.lex_state = 242},
  [11455] = {.lex_state = 242},
  [11456] = {.lex_state = 451},
  [11457] = {.lex_state = 242},
  [11458] = {.lex_state = 451},
  [11459] = {.lex_state = 451},
  [11460] = {.lex_state = 451},
  [11461] = {.lex_state = 451},
  [11462] = {.lex_state = 451},
  [11463] = {.lex_state = 242},
  [11464] = {.lex_state = 242},
  [11465] = {.lex_state = 451},
  [11466] = {.lex_state = 451},
  [11467] = {.lex_state = 242},
  [11468] = {.lex_state = 451},
  [11469] = {.lex_state = 451},
  [11470] = {.lex_state = 451},
  [11471] = {.lex_state = 451},
  [11472] = {.lex_state = 451},
  [11473] = {.lex_state = 242},
  [11474] = {.lex_state = 451},
  [11475] = {.lex_state = 242},
  [11476] = {.lex_state = 242},
  [11477] = {.lex_state = 451},
  [11478] = {.lex_state = 242},
  [11479] = {.lex_state = 451},
  [11480] = {.lex_state = 451},
  [11481] = {.lex_state = 451},
  [11482] = {.lex_state = 242},
  [11483] = {.lex_state = 451},
  [11484] = {.lex_state = 451},
  [11485] = {.lex_state = 451},
  [11486] = {.lex_state = 242},
  [11487] = {.lex_state = 451},
  [11488] = {.lex_state = 451},
  [11489] = {.lex_state = 451},
  [11490] = {.lex_state = 451},
  [11491] = {.lex_state = 451},
  [11492] = {.lex_state = 242},
  [11493] = {.lex_state = 242},
  [11494] = {.lex_state = 451},
  [11495] = {.lex_state = 451},
  [11496] = {.lex_state = 451},
  [11497] = {.lex_state = 242},
  [11498] = {.lex_state = 242},
  [11499] = {.lex_state = 242},
  [11500] = {.lex_state = 242},
  [11501] = {.lex_state = 451},
  [11502] = {.lex_state = 451},
  [11503] = {.lex_state = 451},
  [11504] = {.lex_state = 451},
  [11505] = {.lex_state = 242},
  [11506] = {.lex_state = 242},
  [11507] = {.lex_state = 451},
  [11508] = {.lex_state = 451},
  [11509] = {.lex_state = 451},
  [11510] = {.lex_state = 242},
  [11511] = {.lex_state = 451},
  [11512] = {.lex_state = 451},
  [11513] = {.lex_state = 451},
  [11514] = {.lex_state = 451},
  [11515] = {.lex_state = 451, .external_lex_state = 4},
  [11516] = {.lex_state = 451},
  [11517] = {.lex_state = 451},
  [11518] = {.lex_state = 451},
  [11519] = {.lex_state = 451},
  [11520] = {.lex_state = 242},
  [11521] = {.lex_state = 242},
  [11522] = {.lex_state = 253},
  [11523] = {.lex_state = 242},
  [11524] = {.lex_state = 451},
  [11525] = {.lex_state = 451},
  [11526] = {.lex_state = 451},
  [11527] = {.lex_state = 242},
  [11528] = {.lex_state = 242},
  [11529] = {.lex_state = 451},
  [11530] = {.lex_state = 451},
  [11531] = {.lex_state = 451},
  [11532] = {.lex_state = 451},
  [11533] = {.lex_state = 451},
  [11534] = {.lex_state = 451},
  [11535] = {.lex_state = 451},
  [11536] = {.lex_state = 242},
  [11537] = {.lex_state = 451},
  [11538] = {.lex_state = 242},
  [11539] = {.lex_state = 451},
  [11540] = {.lex_state = 451},
  [11541] = {.lex_state = 451},
  [11542] = {.lex_state = 242},
  [11543] = {.lex_state = 451},
  [11544] = {.lex_state = 242},
  [11545] = {.lex_state = 451},
  [11546] = {.lex_state = 451},
  [11547] = {.lex_state = 451},
  [11548] = {.lex_state = 451},
  [11549] = {.lex_state = 242},
  [11550] = {.lex_state = 242},
  [11551] = {.lex_state = 242},
  [11552] = {.lex_state = 451},
  [11553] = {.lex_state = 451},
  [11554] = {.lex_state = 242},
  [11555] = {.lex_state = 242},
  [11556] = {.lex_state = 451},
  [11557] = {.lex_state = 451},
  [11558] = {.lex_state = 451},
  [11559] = {.lex_state = 451},
  [11560] = {.lex_state = 451},
  [11561] = {.lex_state = 242},
  [11562] = {.lex_state = 451},
  [11563] = {.lex_state = 242},
  [11564] = {.lex_state = 242},
  [11565] = {.lex_state = 451},
  [11566] = {.lex_state = 451},
  [11567] = {.lex_state = 242},
  [11568] = {.lex_state = 242},
  [11569] = {.lex_state = 451},
  [11570] = {.lex_state = 451},
  [11571] = {.lex_state = 451},
  [11572] = {.lex_state = 451},
  [11573] = {.lex_state = 242},
  [11574] = {.lex_state = 451},
  [11575] = {.lex_state = 451},
  [11576] = {.lex_state = 451},
  [11577] = {.lex_state = 242},
  [11578] = {.lex_state = 451},
  [11579] = {.lex_state = 451, .external_lex_state = 4},
  [11580] = {.lex_state = 451},
  [11581] = {.lex_state = 451},
  [11582] = {.lex_state = 451},
  [11583] = {.lex_state = 242},
  [11584] = {.lex_state = 451},
  [11585] = {.lex_state = 451},
  [11586] = {.lex_state = 242},
  [11587] = {.lex_state = 451},
  [11588] = {.lex_state = 242},
  [11589] = {.lex_state = 242},
  [11590] = {.lex_state = 451},
  [11591] = {.lex_state = 451},
  [11592] = {.lex_state = 242},
  [11593] = {.lex_state = 451},
  [11594] = {.lex_state = 451},
  [11595] = {.lex_state = 451},
  [11596] = {.lex_state = 242},
  [11597] = {.lex_state = 451},
  [11598] = {.lex_state = 451},
  [11599] = {.lex_state = 242},
  [11600] = {.lex_state = 242},
  [11601] = {.lex_state = 242},
  [11602] = {.lex_state = 451},
  [11603] = {.lex_state = 451},
  [11604] = {.lex_state = 242},
  [11605] = {.lex_state = 451},
  [11606] = {.lex_state = 451},
  [11607] = {.lex_state = 242},
  [11608] = {.lex_state = 451},
  [11609] = {.lex_state = 451},
  [11610] = {.lex_state = 242},
  [11611] = {.lex_state = 451},
  [11612] = {.lex_state = 451},
  [11613] = {.lex_state = 242},
  [11614] = {.lex_state = 242},
  [11615] = {.lex_state = 451},
  [11616] = {.lex_state = 451},
  [11617] = {.lex_state = 242},
  [11618] = {.lex_state = 451},
  [11619] = {.lex_state = 451},
  [11620] = {.lex_state = 451},
  [11621] = {.lex_state = 451},
  [11622] = {.lex_state = 451},
  [11623] = {.lex_state = 242},
  [11624] = {.lex_state = 242},
  [11625] = {.lex_state = 242},
  [11626] = {.lex_state = 451},
  [11627] = {.lex_state = 451},
  [11628] = {.lex_state = 242},
  [11629] = {.lex_state = 451},
  [11630] = {.lex_state = 451},
  [11631] = {.lex_state = 451},
  [11632] = {.lex_state = 451},
  [11633] = {.lex_state = 242},
  [11634] = {.lex_state = 451},
  [11635] = {.lex_state = 451},
  [11636] = {.lex_state = 451},
  [11637] = {.lex_state = 242},
  [11638] = {.lex_state = 242},
  [11639] = {.lex_state = 451},
  [11640] = {.lex_state = 451},
  [11641] = {.lex_state = 242},
  [11642] = {.lex_state = 242},
  [11643] = {.lex_state = 451},
  [11644] = {.lex_state = 451},
  [11645] = {.lex_state = 451},
  [11646] = {.lex_state = 242},
  [11647] = {.lex_state = 451},
  [11648] = {.lex_state = 451},
  [11649] = {.lex_state = 451},
  [11650] = {.lex_state = 242},
  [11651] = {.lex_state = 242},
  [11652] = {.lex_state = 451},
  [11653] = {.lex_state = 451},
  [11654] = {.lex_state = 242},
  [11655] = {.lex_state = 451},
  [11656] = {.lex_state = 451},
  [11657] = {.lex_state = 451},
  [11658] = {.lex_state = 242},
  [11659] = {.lex_state = 242},
  [11660] = {.lex_state = 451},
  [11661] = {.lex_state = 451},
  [11662] = {.lex_state = 451},
  [11663] = {.lex_state = 242},
  [11664] = {.lex_state = 242},
  [11665] = {.lex_state = 451},
  [11666] = {.lex_state = 451},
  [11667] = {.lex_state = 242},
  [11668] = {.lex_state = 451},
  [11669] = {.lex_state = 451},
  [11670] = {.lex_state = 451},
  [11671] = {.lex_state = 451},
  [11672] = {.lex_state = 451},
  [11673] = {.lex_state = 242},
  [11674] = {.lex_state = 242},
  [11675] = {.lex_state = 451},
  [11676] = {.lex_state = 242},
  [11677] = {.lex_state = 451},
  [11678] = {.lex_state = 242},
  [11679] = {.lex_state = 451},
  [11680] = {.lex_state = 451},
  [11681] = {.lex_state = 451},
  [11682] = {.lex_state = 242},
  [11683] = {.lex_state = 451},
  [11684] = {.lex_state = 451},
  [11685] = {.lex_state = 242},
  [11686] = {.lex_state = 242},
  [11687] = {.lex_state = 242},
  [11688] = {.lex_state = 451},
  [11689] = {.lex_state = 451},
  [11690] = {.lex_state = 242},
  [11691] = {.lex_state = 451},
  [11692] = {.lex_state = 451},
  [11693] = {.lex_state = 242},
  [11694] = {.lex_state = 451},
  [11695] = {.lex_state = 451},
  [11696] = {.lex_state = 451},
  [11697] = {.lex_state = 451},
  [11698] = {.lex_state = 242},
  [11699] = {.lex_state = 242},
  [11700] = {.lex_state = 451},
  [11701] = {.lex_state = 451},
  [11702] = {.lex_state = 242},
  [11703] = {.lex_state = 242},
  [11704] = {.lex_state = 242},
  [11705] = {.lex_state = 451},
  [11706] = {.lex_state = 451},
  [11707] = {.lex_state = 451},
  [11708] = {.lex_state = 242},
  [11709] = {.lex_state = 451},
  [11710] = {.lex_state = 242},
  [11711] = {.lex_state = 451},
  [11712] = {.lex_state = 242},
  [11713] = {.lex_state = 242},
  [11714] = {.lex_state = 242},
  [11715] = {.lex_state = 451},
  [11716] = {.lex_state = 451},
  [11717] = {.lex_state = 242},
  [11718] = {.lex_state = 451},
  [11719] = {.lex_state = 451},
  [11720] = {.lex_state = 451},
  [11721] = {.lex_state = 451},
  [11722] = {.lex_state = 451},
  [11723] = {.lex_state = 451},
  [11724] = {.lex_state = 451},
  [11725] = {.lex_state = 242},
  [11726] = {.lex_state = 242},
  [11727] = {.lex_state = 242},
  [11728] = {.lex_state = 242},
  [11729] = {.lex_state = 451},
  [11730] = {.lex_state = 451},
  [11731] = {.lex_state = 242},
  [11732] = {.lex_state = 451},
  [11733] = {.lex_state = 451},
  [11734] = {.lex_state = 451},
  [11735] = {.lex_state = 451},
  [11736] = {.lex_state = 451},
  [11737] = {.lex_state = 242},
  [11738] = {.lex_state = 451},
  [11739] = {.lex_state = 451},
  [11740] = {.lex_state = 242},
  [11741] = {.lex_state = 242},
  [11742] = {.lex_state = 451},
  [11743] = {.lex_state = 451},
  [11744] = {.lex_state = 242},
  [11745] = {.lex_state = 242},
  [11746] = {.lex_state = 451},
  [11747] = {.lex_state = 451},
  [11748] = {.lex_state = 451},
  [11749] = {.lex_state = 242},
  [11750] = {.lex_state = 242},
  [11751] = {.lex_state = 242},
  [11752] = {.lex_state = 451},
  [11753] = {.lex_state = 451},
  [11754] = {.lex_state = 242},
  [11755] = {.lex_state = 451},
  [11756] = {.lex_state = 451},
  [11757] = {.lex_state = 451},
  [11758] = {.lex_state = 451},
  [11759] = {.lex_state = 451},
  [11760] = {.lex_state = 242},
  [11761] = {.lex_state = 242},
  [11762] = {.lex_state = 242},
  [11763] = {.lex_state = 451},
  [11764] = {.lex_state = 451},
  [11765] = {.lex_state = 242},
  [11766] = {.lex_state = 451},
  [11767] = {.lex_state = 451},
  [11768] = {.lex_state = 451},
  [11769] = {.lex_state = 451},
  [11770] = {.lex_state = 451},
  [11771] = {.lex_state = 451},
  [11772] = {.lex_state = 242},
  [11773] = {.lex_state = 451},
  [11774] = {.lex_state = 242},
  [11775] = {.lex_state = 242},
  [11776] = {.lex_state = 451},
  [11777] = {.lex_state = 451},
  [11778] = {.lex_state = 242},
  [11779] = {.lex_state = 242},
  [11780] = {.lex_state = 451},
  [11781] = {.lex_state = 451},
  [11782] = {.lex_state = 451},
  [11783] = {.lex_state = 451},
  [11784] = {.lex_state = 451},
  [11785] = {.lex_state = 242},
  [11786] = {.lex_state = 451},
  [11787] = {.lex_state = 242},
  [11788] = {.lex_state = 242},
  [11789] = {.lex_state = 451},
  [11790] = {.lex_state = 451},
  [11791] = {.lex_state = 242},
  [11792] = {.lex_state = 451},
  [11793] = {.lex_state = 451},
  [11794] = {.lex_state = 242},
  [11795] = {.lex_state = 242},
  [11796] = {.lex_state = 451},
  [11797] = {.lex_state = 451},
  [11798] = {.lex_state = 242},
  [11799] = {.lex_state = 451},
  [11800] = {.lex_state = 451},
  [11801] = {.lex_state = 242},
  [11802] = {.lex_state = 242},
  [11803] = {.lex_state = 451},
  [11804] = {.lex_state = 451},
  [11805] = {.lex_state = 242},
  [11806] = {.lex_state = 451},
  [11807] = {.lex_state = 451},
  [11808] = {.lex_state = 451},
  [11809] = {.lex_state = 242},
  [11810] = {.lex_state = 451},
  [11811] = {.lex_state = 451},
  [11812] = {.lex_state = 242},
  [11813] = {.lex_state = 242},
  [11814] = {.lex_state = 242},
  [11815] = {.lex_state = 451},
  [11816] = {.lex_state = 451},
  [11817] = {.lex_state = 242},
  [11818] = {.lex_state = 451},
  [11819] = {.lex_state = 451},
  [11820] = {.lex_state = 451},
  [11821] = {.lex_state = 242},
  [11822] = {.lex_state = 451},
  [11823] = {.lex_state = 451},
  [11824] = {.lex_state = 242},
  [11825] = {.lex_state = 242},
  [11826] = {.lex_state = 242},
  [11827] = {.lex_state = 451},
  [11828] = {.lex_state = 451},
  [11829] = {.lex_state = 242},
  [11830] = {.lex_state = 242},
  [11831] = {.lex_state = 451},
  [11832] = {.lex_state = 451},
  [11833] = {.lex_state = 242},
  [11834] = {.lex_state = 451},
  [11835] = {.lex_state = 451},
  [11836] = {.lex_state = 451},
  [11837] = {.lex_state = 242},
  [11838] = {.lex_state = 242},
  [11839] = {.lex_state = 242},
  [11840] = {.lex_state = 451},
  [11841] = {.lex_state = 242},
  [11842] = {.lex_state = 451},
  [11843] = {.lex_state = 242},
  [11844] = {.lex_state = 451},
  [11845] = {.lex_state = 242},
  [11846] = {.lex_state = 451},
  [11847] = {.lex_state = 451},
  [11848] = {.lex_state = 451},
  [11849] = {.lex_state = 242},
  [11850] = {.lex_state = 242},
  [11851] = {.lex_state = 451},
  [11852] = {.lex_state = 451},
  [11853] = {.lex_state = 242},
  [11854] = {.lex_state = 451},
  [11855] = {.lex_state = 242},
  [11856] = {.lex_state = 242},
  [11857] = {.lex_state = 242},
  [11858] = {.lex_state = 242},
  [11859] = {.lex_state = 451},
  [11860] = {.lex_state = 451},
  [11861] = {.lex_state = 242},
  [11862] = {.lex_state = 242},
  [11863] = {.lex_state = 242},
  [11864] = {.lex_state = 451},
  [11865] = {.lex_state = 242},
  [11866] = {.lex_state = 451},
  [11867] = {.lex_state = 451},
  [11868] = {.lex_state = 242},
  [11869] = {.lex_state = 242},
  [11870] = {.lex_state = 242},
  [11871] = {.lex_state = 451},
  [11872] = {.lex_state = 451},
  [11873] = {.lex_state = 242},
  [11874] = {.lex_state = 242},
  [11875] = {.lex_state = 242},
  [11876] = {.lex_state = 451},
  [11877] = {.lex_state = 242},
  [11878] = {.lex_state = 242},
  [11879] = {.lex_state = 242},
  [11880] = {.lex_state = 242},
  [11881] = {.lex_state = 242},
  [11882] = {.lex_state = 242},
  [11883] = {.lex_state = 451},
  [11884] = {.lex_state = 451},
  [11885] = {.lex_state = 242},
  [11886] = {.lex_state = 242},
  [11887] = {.lex_state = 242},
  [11888] = {.lex_state = 242},
  [11889] = {.lex_state = 242},
  [11890] = {.lex_state = 242},
  [11891] = {.lex_state = 451},
  [11892] = {.lex_state = 451},
  [11893] = {.lex_state = 242},
  [11894] = {.lex_state = 451},
  [11895] = {.lex_state = 242},
  [11896] = {.lex_state = 451},
  [11897] = {.lex_state = 242},
  [11898] = {.lex_state = 451},
  [11899] = {.lex_state = 242},
  [11900] = {.lex_state = 451},
  [11901] = {.lex_state = 242},
  [11902] = {.lex_state = 451},
  [11903] = {.lex_state = 242},
  [11904] = {.lex_state = 451},
  [11905] = {.lex_state = 242},
  [11906] = {.lex_state = 451},
  [11907] = {.lex_state = 242},
  [11908] = {.lex_state = 451},
  [11909] = {.lex_state = 242},
  [11910] = {.lex_state = 451},
  [11911] = {.lex_state = 451},
  [11912] = {.lex_state = 451},
  [11913] = {.lex_state = 242},
  [11914] = {.lex_state = 242},
  [11915] = {.lex_state = 242},
  [11916] = {.lex_state = 451},
  [11917] = {.lex_state = 242},
  [11918] = {.lex_state = 451},
  [11919] = {.lex_state = 242},
  [11920] = {.lex_state = 451},
  [11921] = {.lex_state = 242},
  [11922] = {.lex_state = 451},
  [11923] = {.lex_state = 451},
  [11924] = {.lex_state = 242},
  [11925] = {.lex_state = 242},
  [11926] = {.lex_state = 451},
  [11927] = {.lex_state = 451},
  [11928] = {.lex_state = 242},
  [11929] = {.lex_state = 242},
  [11930] = {.lex_state = 242},
  [11931] = {.lex_state = 451},
  [11932] = {.lex_state = 451},
  [11933] = {.lex_state = 242},
  [11934] = {.lex_state = 242},
  [11935] = {.lex_state = 451},
  [11936] = {.lex_state = 451},
  [11937] = {.lex_state = 242},
  [11938] = {.lex_state = 451},
  [11939] = {.lex_state = 451},
  [11940] = {.lex_state = 451},
  [11941] = {.lex_state = 242},
  [11942] = {.lex_state = 451},
  [11943] = {.lex_state = 242},
  [11944] = {.lex_state = 242},
  [11945] = {.lex_state = 242},
  [11946] = {.lex_state = 242},
  [11947] = {.lex_state = 451},
  [11948] = {.lex_state = 451},
  [11949] = {.lex_state = 242},
  [11950] = {.lex_state = 242},
  [11951] = {.lex_state = 451},
  [11952] = {.lex_state = 451},
  [11953] = {.lex_state = 242},
  [11954] = {.lex_state = 451},
  [11955] = {.lex_state = 451},
  [11956] = {.lex_state = 451},
  [11957] = {.lex_state = 242},
  [11958] = {.lex_state = 242},
  [11959] = {.lex_state = 242},
  [11960] = {.lex_state = 242},
  [11961] = {.lex_state = 242},
  [11962] = {.lex_state = 451},
  [11963] = {.lex_state = 451},
  [11964] = {.lex_state = 242},
  [11965] = {.lex_state = 242},
  [11966] = {.lex_state = 451},
  [11967] = {.lex_state = 451},
  [11968] = {.lex_state = 451},
  [11969] = {.lex_state = 242},
  [11970] = {.lex_state = 451},
  [11971] = {.lex_state = 451},
  [11972] = {.lex_state = 451},
  [11973] = {.lex_state = 242},
  [11974] = {.lex_state = 242},
  [11975] = {.lex_state = 451},
  [11976] = {.lex_state = 242},
  [11977] = {.lex_state = 242},
  [11978] = {.lex_state = 242},
  [11979] = {.lex_state = 451},
  [11980] = {.lex_state = 451},
  [11981] = {.lex_state = 242},
  [11982] = {.lex_state = 242},
  [11983] = {.lex_state = 451},
  [11984] = {.lex_state = 451},
  [11985] = {.lex_state = 242},
  [11986] = {.lex_state = 451},
  [11987] = {.lex_state = 451},
  [11988] = {.lex_state = 242},
  [11989] = {.lex_state = 242},
  [11990] = {.lex_state = 451},
  [11991] = {.lex_state = 242},
  [11992] = {.lex_state = 242},
  [11993] = {.lex_state = 242},
  [11994] = {.lex_state = 242},
  [11995] = {.lex_state = 451},
  [11996] = {.lex_state = 451},
  [11997] = {.lex_state = 242},
  [11998] = {.lex_state = 242},
  [11999] = {.lex_state = 451},
  [12000] = {.lex_state = 451},
  [12001] = {.lex_state = 242},
  [12002] = {.lex_state = 451},
  [12003] = {.lex_state = 451},
  [12004] = {.lex_state = 451},
  [12005] = {.lex_state = 242},
  [12006] = {.lex_state = 451},
  [12007] = {.lex_state = 451},
  [12008] = {.lex_state = 242},
  [12009] = {.lex_state = 242},
  [12010] = {.lex_state = 242},
  [12011] = {.lex_state = 242},
  [12012] = {.lex_state = 451},
  [12013] = {.lex_state = 242},
  [12014] = {.lex_state = 451},
  [12015] = {.lex_state = 242},
  [12016] = {.lex_state = 451},
  [12017] = {.lex_state = 242},
  [12018] = {.lex_state = 451},
  [12019] = {.lex_state = 451},
  [12020] = {.lex_state = 451},
  [12021] = {.lex_state = 242},
  [12022] = {.lex_state = 451},
  [12023] = {.lex_state = 451},
  [12024] = {.lex_state = 451},
  [12025] = {.lex_state = 242},
  [12026] = {.lex_state = 242},
  [12027] = {.lex_state = 242},
  [12028] = {.lex_state = 451},
  [12029] = {.lex_state = 242},
  [12030] = {.lex_state = 451},
  [12031] = {.lex_state = 242},
  [12032] = {.lex_state = 451},
  [12033] = {.lex_state = 242},
  [12034] = {.lex_state = 242},
  [12035] = {.lex_state = 451},
  [12036] = {.lex_state = 242},
  [12037] = {.lex_state = 242},
  [12038] = {.lex_state = 451},
  [12039] = {.lex_state = 451},
  [12040] = {.lex_state = 451},
  [12041] = {.lex_state = 242},
  [12042] = {.lex_state = 242},
  [12043] = {.lex_state = 451},
  [12044] = {.lex_state = 242},
  [12045] = {.lex_state = 242},
  [12046] = {.lex_state = 242},
  [12047] = {.lex_state = 451},
  [12048] = {.lex_state = 451},
  [12049] = {.lex_state = 242},
  [12050] = {.lex_state = 451},
  [12051] = {.lex_state = 451},
  [12052] = {.lex_state = 451},
  [12053] = {.lex_state = 242},
  [12054] = {.lex_state = 451},
  [12055] = {.lex_state = 451},
  [12056] = {.lex_state = 242},
  [12057] = {.lex_state = 242},
  [12058] = {.lex_state = 242},
  [12059] = {.lex_state = 242},
  [12060] = {.lex_state = 242},
  [12061] = {.lex_state = 242},
  [12062] = {.lex_state = 451},
  [12063] = {.lex_state = 451},
  [12064] = {.lex_state = 451},
  [12065] = {.lex_state = 242},
  [12066] = {.lex_state = 242},
  [12067] = {.lex_state = 451},
  [12068] = {.lex_state = 451},
  [12069] = {.lex_state = 242},
  [12070] = {.lex_state = 451},
  [12071] = {.lex_state = 451},
  [12072] = {.lex_state = 451},
  [12073] = {.lex_state = 242},
  [12074] = {.lex_state = 451},
  [12075] = {.lex_state = 242},
  [12076] = {.lex_state = 451},
  [12077] = {.lex_state = 242},
  [12078] = {.lex_state = 242},
  [12079] = {.lex_state = 242},
  [12080] = {.lex_state = 451},
  [12081] = {.lex_state = 242},
  [12082] = {.lex_state = 451},
  [12083] = {.lex_state = 451},
  [12084] = {.lex_state = 242},
  [12085] = {.lex_state = 242},
  [12086] = {.lex_state = 451},
  [12087] = {.lex_state = 451},
  [12088] = {.lex_state = 451},
  [12089] = {.lex_state = 242},
  [12090] = {.lex_state = 451},
  [12091] = {.lex_state = 242},
  [12092] = {.lex_state = 242},
  [12093] = {.lex_state = 242},
  [12094] = {.lex_state = 242},
  [12095] = {.lex_state = 242},
  [12096] = {.lex_state = 242},
  [12097] = {.lex_state = 242},
  [12098] = {.lex_state = 451},
  [12099] = {.lex_state = 451},
  [12100] = {.lex_state = 242},
  [12101] = {.lex_state = 242},
  [12102] = {.lex_state = 451},
  [12103] = {.lex_state = 451},
  [12104] = {.lex_state = 451},
  [12105] = {.lex_state = 242},
  [12106] = {.lex_state = 451},
  [12107] = {.lex_state = 451},
  [12108] = {.lex_state = 451},
  [12109] = {.lex_state = 242},
  [12110] = {.lex_state = 242},
  [12111] = {.lex_state = 451},
  [12112] = {.lex_state = 242},
  [12113] = {.lex_state = 242},
  [12114] = {.lex_state = 242},
  [12115] = {.lex_state = 451},
  [12116] = {.lex_state = 451},
  [12117] = {.lex_state = 242},
  [12118] = {.lex_state = 242},
  [12119] = {.lex_state = 451},
  [12120] = {.lex_state = 451},
  [12121] = {.lex_state = 242},
  [12122] = {.lex_state = 451},
  [12123] = {.lex_state = 451},
  [12124] = {.lex_state = 242},
  [12125] = {.lex_state = 242},
  [12126] = {.lex_state = 242},
  [12127] = {.lex_state = 242},
  [12128] = {.lex_state = 242},
  [12129] = {.lex_state = 242},
  [12130] = {.lex_state = 451, .external_lex_state = 4},
  [12131] = {.lex_state = 451},
  [12132] = {.lex_state = 451},
  [12133] = {.lex_state = 242},
  [12134] = {.lex_state = 242},
  [12135] = {.lex_state = 451},
  [12136] = {.lex_state = 451},
  [12137] = {.lex_state = 242},
  [12138] = {.lex_state = 451},
  [12139] = {.lex_state = 451},
  [12140] = {.lex_state = 451},
  [12141] = {.lex_state = 242},
  [12142] = {.lex_state = 451},
  [12143] = {.lex_state = 451},
  [12144] = {.lex_state = 242},
  [12145] = {.lex_state = 242},
  [12146] = {.lex_state = 253},
  [12147] = {.lex_state = 451},
  [12148] = {.lex_state = 242},
  [12149] = {.lex_state = 242},
  [12150] = {.lex_state = 242},
  [12151] = {.lex_state = 451, .external_lex_state = 3},
  [12152] = {.lex_state = 451},
  [12153] = {.lex_state = 242},
  [12154] = {.lex_state = 451},
  [12155] = {.lex_state = 451, .external_lex_state = 4},
  [12156] = {.lex_state = 242},
  [12157] = {.lex_state = 242},
  [12158] = {.lex_state = 451},
  [12159] = {.lex_state = 451},
  [12160] = {.lex_state = 451},
  [12161] = {.lex_state = 242},
  [12162] = {.lex_state = 451},
  [12163] = {.lex_state = 242},
  [12164] = {.lex_state = 242},
  [12165] = {.lex_state = 242},
  [12166] = {.lex_state = 242},
  [12167] = {.lex_state = 242},
  [12168] = {.lex_state = 242},
  [12169] = {.lex_state = 242},
  [12170] = {.lex_state = 451},
  [12171] = {.lex_state = 253},
  [12172] = {.lex_state = 451},
  [12173] = {.lex_state = 242},
  [12174] = {.lex_state = 253},
  [12175] = {.lex_state = 242},
  [12176] = {.lex_state = 451},
  [12177] = {.lex_state = 242},
  [12178] = {.lex_state = 451},
  [12179] = {.lex_state = 242},
  [12180] = {.lex_state = 451},
  [12181] = {.lex_state = 242},
  [12182] = {.lex_state = 451},
  [12183] = {.lex_state = 242},
  [12184] = {.lex_state = 253},
  [12185] = {.lex_state = 242},
  [12186] = {.lex_state = 451},
  [12187] = {.lex_state = 451},
  [12188] = {.lex_state = 451},
  [12189] = {.lex_state = 242},
  [12190] = {.lex_state = 451},
  [12191] = {.lex_state = 451},
  [12192] = {.lex_state = 451},
  [12193] = {.lex_state = 242},
  [12194] = {.lex_state = 451},
  [12195] = {.lex_state = 242},
  [12196] = {.lex_state = 451},
  [12197] = {.lex_state = 242},
  [12198] = {.lex_state = 242},
  [12199] = {.lex_state = 451, .external_lex_state = 4},
  [12200] = {.lex_state = 242},
  [12201] = {.lex_state = 242},
  [12202] = {.lex_state = 451},
  [12203] = {.lex_state = 451},
  [12204] = {.lex_state = 242},
  [12205] = {.lex_state = 242},
  [12206] = {.lex_state = 451},
  [12207] = {.lex_state = 451, .external_lex_state = 4},
  [12208] = {.lex_state = 451},
  [12209] = {.lex_state = 242},
  [12210] = {.lex_state = 451},
  [12211] = {.lex_state = 451},
  [12212] = {.lex_state = 451},
  [12213] = {.lex_state = 242},
  [12214] = {.lex_state = 242},
  [12215] = {.lex_state = 451, .external_lex_state = 4},
  [12216] = {.lex_state = 242},
  [12217] = {.lex_state = 242},
  [12218] = {.lex_state = 242},
  [12219] = {.lex_state = 242},
  [12220] = {.lex_state = 451},
  [12221] = {.lex_state = 242},
  [12222] = {.lex_state = 451},
  [12223] = {.lex_state = 242},
  [12224] = {.lex_state = 451},
  [12225] = {.lex_state = 242},
  [12226] = {.lex_state = 451},
  [12227] = {.lex_state = 451},
  [12228] = {.lex_state = 451},
  [12229] = {.lex_state = 242},
  [12230] = {.lex_state = 451},
  [12231] = {.lex_state = 451},
  [12232] = {.lex_state = 242},
  [12233] = {.lex_state = 242},
  [12234] = {.lex_state = 451},
  [12235] = {.lex_state = 451},
  [12236] = {.lex_state = 242},
  [12237] = {.lex_state = 242},
  [12238] = {.lex_state = 451},
  [12239] = {.lex_state = 451},
  [12240] = {.lex_state = 242},
  [12241] = {.lex_state = 242},
  [12242] = {.lex_state = 451},
  [12243] = {.lex_state = 253},
  [12244] = {.lex_state = 242},
  [12245] = {.lex_state = 242},
  [12246] = {.lex_state = 451},
  [12247] = {.lex_state = 451},
  [12248] = {.lex_state = 253},
  [12249] = {.lex_state = 242},
  [12250] = {.lex_state = 451},
  [12251] = {.lex_state = 242},
  [12252] = {.lex_state = 451, .external_lex_state = 4},
  [12253] = {.lex_state = 242},
  [12254] = {.lex_state = 451},
  [12255] = {.lex_state = 451},
  [12256] = {.lex_state = 451},
  [12257] = {.lex_state = 242},
  [12258] = {.lex_state = 253},
  [12259] = {.lex_state = 451, .external_lex_state = 4},
  [12260] = {.lex_state = 451, .external_lex_state = 4},
  [12261] = {.lex_state = 242},
  [12262] = {.lex_state = 451, .external_lex_state = 4},
  [12263] = {.lex_state = 253},
  [12264] = {.lex_state = 451},
  [12265] = {.lex_state = 242},
  [12266] = {.lex_state = 242},
  [12267] = {.lex_state = 242},
  [12268] = {.lex_state = 451},
  [12269] = {.lex_state = 242},
  [12270] = {.lex_state = 242},
  [12271] = {.lex_state = 242},
  [12272] = {.lex_state = 451},
  [12273] = {.lex_state = 242},
  [12274] = {.lex_state = 451},
  [12275] = {.lex_state = 451},
  [12276] = {.lex_state = 451},
  [12277] = {.lex_state = 242},
  [12278] = {.lex_state = 242},
  [12279] = {.lex_state = 451},
  [12280] = {.lex_state = 451},
  [12281] = {.lex_state = 242},
  [12282] = {.lex_state = 451},
  [12283] = {.lex_state = 451, .external_lex_state = 4},
  [12284] = {.lex_state = 451},
  [12285] = {.lex_state = 242},
  [12286] = {.lex_state = 451},
  [12287] = {.lex_state = 451},
  [12288] = {.lex_state = 451},
  [12289] = {.lex_state = 242},
  [12290] = {.lex_state = 242},
  [12291] = {.lex_state = 242},
  [12292] = {.lex_state = 451},
  [12293] = {.lex_state = 242},
  [12294] = {.lex_state = 451},
  [12295] = {.lex_state = 242},
  [12296] = {.lex_state = 451},
  [12297] = {.lex_state = 242},
  [12298] = {.lex_state = 451},
  [12299] = {.lex_state = 451},
  [12300] = {.lex_state = 451},
  [12301] = {.lex_state = 242},
  [12302] = {.lex_state = 451},
  [12303] = {.lex_state = 242},
  [12304] = {.lex_state = 242},
  [12305] = {.lex_state = 242},
  [12306] = {.lex_state = 451},
  [12307] = {.lex_state = 242},
  [12308] = {.lex_state = 451},
  [12309] = {.lex_state = 242},
  [12310] = {.lex_state = 451},
  [12311] = {.lex_state = 451},
  [12312] = {.lex_state = 242},
  [12313] = {.lex_state = 242},
  [12314] = {.lex_state = 451},
  [12315] = {.lex_state = 451},
  [12316] = {.lex_state = 451, .external_lex_state = 4},
  [12317] = {.lex_state = 242},
  [12318] = {.lex_state = 451},
  [12319] = {.lex_state = 451},
  [12320] = {.lex_state = 451},
  [12321] = {.lex_state = 242},
  [12322] = {.lex_state = 451},
  [12323] = {.lex_state = 242},
  [12324] = {.lex_state = 451},
  [12325] = {.lex_state = 242},
  [12326] = {.lex_state = 242},
  [12327] = {.lex_state = 242},
  [12328] = {.lex_state = 451},
  [12329] = {.lex_state = 242},
  [12330] = {.lex_state = 451},
  [12331] = {.lex_state = 242},
  [12332] = {.lex_state = 253},
  [12333] = {.lex_state = 451},
  [12334] = {.lex_state = 253},
  [12335] = {.lex_state = 242},
  [12336] = {.lex_state = 451, .external_lex_state = 3},
  [12337] = {.lex_state = 451},
  [12338] = {.lex_state = 451},
  [12339] = {.lex_state = 451},
  [12340] = {.lex_state = 451},
  [12341] = {.lex_state = 242},
  [12342] = {.lex_state = 242},
  [12343] = {.lex_state = 451},
  [12344] = {.lex_state = 242},
  [12345] = {.lex_state = 242},
  [12346] = {.lex_state = 242},
  [12347] = {.lex_state = 451},
  [12348] = {.lex_state = 451},
  [12349] = {.lex_state = 451},
  [12350] = {.lex_state = 242},
  [12351] = {.lex_state = 451},
  [12352] = {.lex_state = 451},
  [12353] = {.lex_state = 451},
  [12354] = {.lex_state = 451},
  [12355] = {.lex_state = 451},
  [12356] = {.lex_state = 451},
  [12357] = {.lex_state = 451},
  [12358] = {.lex_state = 451},
  [12359] = {.lex_state = 451},
  [12360] = {.lex_state = 451},
  [12361] = {.lex_state = 451},
  [12362] = {.lex_state = 242},
  [12363] = {.lex_state = 451},
  [12364] = {.lex_state = 451},
  [12365] = {.lex_state = 242},
  [12366] = {.lex_state = 242},
  [12367] = {.lex_state = 451},
  [12368] = {.lex_state = 451},
  [12369] = {.lex_state = 242},
  [12370] = {.lex_state = 451},
  [12371] = {.lex_state = 451},
  [12372] = {.lex_state = 451},
  [12373] = {.lex_state = 451},
  [12374] = {.lex_state = 242},
  [12375] = {.lex_state = 242},
  [12376] = {.lex_state = 242},
  [12377] = {.lex_state = 242},
  [12378] = {.lex_state = 451},
  [12379] = {.lex_state = 451},
  [12380] = {.lex_state = 242},
  [12381] = {.lex_state = 451},
  [12382] = {.lex_state = 242},
  [12383] = {.lex_state = 451},
  [12384] = {.lex_state = 451},
  [12385] = {.lex_state = 451},
  [12386] = {.lex_state = 451},
  [12387] = {.lex_state = 451},
  [12388] = {.lex_state = 451},
  [12389] = {.lex_state = 253},
  [12390] = {.lex_state = 242},
  [12391] = {.lex_state = 451, .external_lex_state = 3},
  [12392] = {.lex_state = 451},
  [12393] = {.lex_state = 242},
  [12394] = {.lex_state = 451},
  [12395] = {.lex_state = 242},
  [12396] = {.lex_state = 451},
  [12397] = {.lex_state = 451},
  [12398] = {.lex_state = 451},
  [12399] = {.lex_state = 253},
  [12400] = {.lex_state = 242},
  [12401] = {.lex_state = 451},
  [12402] = {.lex_state = 451},
  [12403] = {.lex_state = 451},
  [12404] = {.lex_state = 451},
  [12405] = {.lex_state = 242},
  [12406] = {.lex_state = 451},
  [12407] = {.lex_state = 242},
  [12408] = {.lex_state = 253},
  [12409] = {.lex_state = 242},
  [12410] = {.lex_state = 242},
  [12411] = {.lex_state = 451},
  [12412] = {.lex_state = 451},
  [12413] = {.lex_state = 242},
  [12414] = {.lex_state = 451},
  [12415] = {.lex_state = 451},
  [12416] = {.lex_state = 451},
  [12417] = {.lex_state = 253},
  [12418] = {.lex_state = 451},
  [12419] = {.lex_state = 451},
  [12420] = {.lex_state = 451},
  [12421] = {.lex_state = 451},
  [12422] = {.lex_state = 242},
  [12423] = {.lex_state = 242},
  [12424] = {.lex_state = 451},
  [12425] = {.lex_state = 242},
  [12426] = {.lex_state = 253},
  [12427] = {.lex_state = 451},
  [12428] = {.lex_state = 451},
  [12429] = {.lex_state = 242},
  [12430] = {.lex_state = 451},
  [12431] = {.lex_state = 451},
  [12432] = {.lex_state = 451},
  [12433] = {.lex_state = 451},
  [12434] = {.lex_state = 242},
  [12435] = {.lex_state = 253},
  [12436] = {.lex_state = 242},
  [12437] = {.lex_state = 242},
  [12438] = {.lex_state = 242},
  [12439] = {.lex_state = 242},
  [12440] = {.lex_state = 451, .external_lex_state = 4},
  [12441] = {.lex_state = 451},
  [12442] = {.lex_state = 451},
  [12443] = {.lex_state = 451},
  [12444] = {.lex_state = 253},
  [12445] = {.lex_state = 451},
  [12446] = {.lex_state = 242},
  [12447] = {.lex_state = 451},
  [12448] = {.lex_state = 451},
  [12449] = {.lex_state = 451},
  [12450] = {.lex_state = 451},
  [12451] = {.lex_state = 451},
  [12452] = {.lex_state = 451},
  [12453] = {.lex_state = 253},
  [12454] = {.lex_state = 451},
  [12455] = {.lex_state = 242},
  [12456] = {.lex_state = 451},
  [12457] = {.lex_state = 242},
  [12458] = {.lex_state = 242},
  [12459] = {.lex_state = 451},
  [12460] = {.lex_state = 451},
  [12461] = {.lex_state = 451},
  [12462] = {.lex_state = 253},
  [12463] = {.lex_state = 451},
  [12464] = {.lex_state = 242},
  [12465] = {.lex_state = 451},
  [12466] = {.lex_state = 451},
  [12467] = {.lex_state = 242},
  [12468] = {.lex_state = 451},
  [12469] = {.lex_state = 451},
  [12470] = {.lex_state = 451},
  [12471] = {.lex_state = 253},
  [12472] = {.lex_state = 242},
  [12473] = {.lex_state = 242},
  [12474] = {.lex_state = 242},
  [12475] = {.lex_state = 242},
  [12476] = {.lex_state = 451},
  [12477] = {.lex_state = 451},
  [12478] = {.lex_state = 451},
  [12479] = {.lex_state = 242},
  [12480] = {.lex_state = 253},
  [12481] = {.lex_state = 451},
  [12482] = {.lex_state = 451},
  [12483] = {.lex_state = 451},
  [12484] = {.lex_state = 451},
  [12485] = {.lex_state = 451},
  [12486] = {.lex_state = 451},
  [12487] = {.lex_state = 451},
  [12488] = {.lex_state = 451},
  [12489] = {.lex_state = 253},
  [12490] = {.lex_state = 242},
  [12491] = {.lex_state = 451},
  [12492] = {.lex_state = 451},
  [12493] = {.lex_state = 242},
  [12494] = {.lex_state = 451},
  [12495] = {.lex_state = 242},
  [12496] = {.lex_state = 451},
  [12497] = {.lex_state = 451},
  [12498] = {.lex_state = 253},
  [12499] = {.lex_state = 451},
  [12500] = {.lex_state = 242},
  [12501] = {.lex_state = 451, .external_lex_state = 4},
  [12502] = {.lex_state = 451},
  [12503] = {.lex_state = 451},
  [12504] = {.lex_state = 451},
  [12505] = {.lex_state = 451},
  [12506] = {.lex_state = 451},
  [12507] = {.lex_state = 253},
  [12508] = {.lex_state = 451},
  [12509] = {.lex_state = 242},
  [12510] = {.lex_state = 242},
  [12511] = {.lex_state = 242},
  [12512] = {.lex_state = 451},
  [12513] = {.lex_state = 451},
  [12514] = {.lex_state = 451},
  [12515] = {.lex_state = 451},
  [12516] = {.lex_state = 253},
  [12517] = {.lex_state = 242},
  [12518] = {.lex_state = 451},
  [12519] = {.lex_state = 451},
  [12520] = {.lex_state = 451},
  [12521] = {.lex_state = 451},
  [12522] = {.lex_state = 451},
  [12523] = {.lex_state = 451},
  [12524] = {.lex_state = 451},
  [12525] = {.lex_state = 253},
  [12526] = {.lex_state = 451},
  [12527] = {.lex_state = 242},
  [12528] = {.lex_state = 451},
  [12529] = {.lex_state = 451},
  [12530] = {.lex_state = 242},
  [12531] = {.lex_state = 242},
  [12532] = {.lex_state = 451},
  [12533] = {.lex_state = 451},
  [12534] = {.lex_state = 253},
  [12535] = {.lex_state = 451},
  [12536] = {.lex_state = 242},
  [12537] = {.lex_state = 451},
  [12538] = {.lex_state = 451},
  [12539] = {.lex_state = 451},
  [12540] = {.lex_state = 451},
  [12541] = {.lex_state = 451},
  [12542] = {.lex_state = 451},
  [12543] = {.lex_state = 253},
  [12544] = {.lex_state = 451},
  [12545] = {.lex_state = 242},
  [12546] = {.lex_state = 242},
  [12547] = {.lex_state = 451},
  [12548] = {.lex_state = 451},
  [12549] = {.lex_state = 242},
  [12550] = {.lex_state = 451},
  [12551] = {.lex_state = 242},
  [12552] = {.lex_state = 253},
  [12553] = {.lex_state = 451},
  [12554] = {.lex_state = 451},
  [12555] = {.lex_state = 451},
  [12556] = {.lex_state = 242},
  [12557] = {.lex_state = 451},
  [12558] = {.lex_state = 451},
  [12559] = {.lex_state = 451},
  [12560] = {.lex_state = 451},
  [12561] = {.lex_state = 253},
  [12562] = {.lex_state = 451},
  [12563] = {.lex_state = 451},
  [12564] = {.lex_state = 451},
  [12565] = {.lex_state = 451},
  [12566] = {.lex_state = 242},
  [12567] = {.lex_state = 451},
  [12568] = {.lex_state = 451},
  [12569] = {.lex_state = 242},
  [12570] = {.lex_state = 253},
  [12571] = {.lex_state = 242},
  [12572] = {.lex_state = 451},
  [12573] = {.lex_state = 451, .external_lex_state = 4},
  [12574] = {.lex_state = 451},
  [12575] = {.lex_state = 242},
  [12576] = {.lex_state = 451},
  [12577] = {.lex_state = 451},
  [12578] = {.lex_state = 451},
  [12579] = {.lex_state = 253},
  [12580] = {.lex_state = 451, .external_lex_state = 3},
  [12581] = {.lex_state = 451},
  [12582] = {.lex_state = 451},
  [12583] = {.lex_state = 242},
  [12584] = {.lex_state = 242},
  [12585] = {.lex_state = 242},
  [12586] = {.lex_state = 451},
  [12587] = {.lex_state = 451},
  [12588] = {.lex_state = 253},
  [12589] = {.lex_state = 242},
  [12590] = {.lex_state = 242},
  [12591] = {.lex_state = 242},
  [12592] = {.lex_state = 451},
  [12593] = {.lex_state = 451},
  [12594] = {.lex_state = 253},
  [12595] = {.lex_state = 451},
  [12596] = {.lex_state = 242},
  [12597] = {.lex_state = 451},
  [12598] = {.lex_state = 451},
  [12599] = {.lex_state = 451},
  [12600] = {.lex_state = 253},
  [12601] = {.lex_state = 451},
  [12602] = {.lex_state = 451},
  [12603] = {.lex_state = 451},
  [12604] = {.lex_state = 451},
  [12605] = {.lex_state = 451},
  [12606] = {.lex_state = 253},
  [12607] = {.lex_state = 242},
  [12608] = {.lex_state = 451},
  [12609] = {.lex_state = 242},
  [12610] = {.lex_state = 451},
  [12611] = {.lex_state = 242},
  [12612] = {.lex_state = 253},
  [12613] = {.lex_state = 451},
  [12614] = {.lex_state = 451},
  [12615] = {.lex_state = 242},
  [12616] = {.lex_state = 451},
  [12617] = {.lex_state = 451},
  [12618] = {.lex_state = 253},
  [12619] = {.lex_state = 451},
  [12620] = {.lex_state = 451},
  [12621] = {.lex_state = 451},
  [12622] = {.lex_state = 451},
  [12623] = {.lex_state = 242},
  [12624] = {.lex_state = 253},
  [12625] = {.lex_state = 242},
  [12626] = {.lex_state = 451},
  [12627] = {.lex_state = 242},
  [12628] = {.lex_state = 451},
  [12629] = {.lex_state = 242},
  [12630] = {.lex_state = 253},
  [12631] = {.lex_state = 451},
  [12632] = {.lex_state = 451, .external_lex_state = 4},
  [12633] = {.lex_state = 451},
  [12634] = {.lex_state = 451},
  [12635] = {.lex_state = 242},
  [12636] = {.lex_state = 253},
  [12637] = {.lex_state = 451},
  [12638] = {.lex_state = 451},
  [12639] = {.lex_state = 451},
  [12640] = {.lex_state = 451},
  [12641] = {.lex_state = 451},
  [12642] = {.lex_state = 253},
  [12643] = {.lex_state = 451},
  [12644] = {.lex_state = 451},
  [12645] = {.lex_state = 242},
  [12646] = {.lex_state = 451},
  [12647] = {.lex_state = 451},
  [12648] = {.lex_state = 253},
  [12649] = {.lex_state = 242},
  [12650] = {.lex_state = 242},
  [12651] = {.lex_state = 451},
  [12652] = {.lex_state = 451},
  [12653] = {.lex_state = 451},
  [12654] = {.lex_state = 253},
  [12655] = {.lex_state = 242},
  [12656] = {.lex_state = 451},
  [12657] = {.lex_state = 451},
  [12658] = {.lex_state = 451},
  [12659] = {.lex_state = 451},
  [12660] = {.lex_state = 253},
  [12661] = {.lex_state = 451},
  [12662] = {.lex_state = 242},
  [12663] = {.lex_state = 242},
  [12664] = {.lex_state = 451},
  [12665] = {.lex_state = 242},
  [12666] = {.lex_state = 253},
  [12667] = {.lex_state = 242},
  [12668] = {.lex_state = 451},
  [12669] = {.lex_state = 451},
  [12670] = {.lex_state = 451},
  [12671] = {.lex_state = 242},
  [12672] = {.lex_state = 253},
  [12673] = {.lex_state = 451},
  [12674] = {.lex_state = 451},
  [12675] = {.lex_state = 451},
  [12676] = {.lex_state = 451},
  [12677] = {.lex_state = 242},
  [12678] = {.lex_state = 253},
  [12679] = {.lex_state = 451},
  [12680] = {.lex_state = 451},
  [12681] = {.lex_state = 242},
  [12682] = {.lex_state = 451},
  [12683] = {.lex_state = 451},
  [12684] = {.lex_state = 253},
  [12685] = {.lex_state = 242},
  [12686] = {.lex_state = 242},
  [12687] = {.lex_state = 451},
  [12688] = {.lex_state = 451},
  [12689] = {.lex_state = 451},
  [12690] = {.lex_state = 253},
  [12691] = {.lex_state = 451},
  [12692] = {.lex_state = 451},
  [12693] = {.lex_state = 451},
  [12694] = {.lex_state = 451},
  [12695] = {.lex_state = 451},
  [12696] = {.lex_state = 253},
  [12697] = {.lex_state = 451},
  [12698] = {.lex_state = 242},
  [12699] = {.lex_state = 242},
  [12700] = {.lex_state = 451},
  [12701] = {.lex_state = 242},
  [12702] = {.lex_state = 253},
  [12703] = {.lex_state = 242},
  [12704] = {.lex_state = 451},
  [12705] = {.lex_state = 451},
  [12706] = {.lex_state = 451},
  [12707] = {.lex_state = 242},
  [12708] = {.lex_state = 253},
  [12709] = {.lex_state = 451},
  [12710] = {.lex_state = 451},
  [12711] = {.lex_state = 451},
  [12712] = {.lex_state = 451},
  [12713] = {.lex_state = 451},
  [12714] = {.lex_state = 253},
  [12715] = {.lex_state = 451},
  [12716] = {.lex_state = 451},
  [12717] = {.lex_state = 451},
  [12718] = {.lex_state = 242},
  [12719] = {.lex_state = 451},
  [12720] = {.lex_state = 451},
  [12721] = {.lex_state = 242},
  [12722] = {.lex_state = 242},
  [12723] = {.lex_state = 451},
  [12724] = {.lex_state = 451},
  [12725] = {.lex_state = 451},
  [12726] = {.lex_state = 451},
  [12727] = {.lex_state = 242},
  [12728] = {.lex_state = 451},
  [12729] = {.lex_state = 451},
  [12730] = {.lex_state = 451},
  [12731] = {.lex_state = 451},
  [12732] = {.lex_state = 451},
  [12733] = {.lex_state = 451},
  [12734] = {.lex_state = 242},
  [12735] = {.lex_state = 451},
  [12736] = {.lex_state = 242},
  [12737] = {.lex_state = 242},
  [12738] = {.lex_state = 451},
  [12739] = {.lex_state = 242},
  [12740] = {.lex_state = 451},
  [12741] = {.lex_state = 451},
  [12742] = {.lex_state = 451},
  [12743] = {.lex_state = 242},
  [12744] = {.lex_state = 451},
  [12745] = {.lex_state = 451},
  [12746] = {.lex_state = 451},
  [12747] = {.lex_state = 451},
  [12748] = {.lex_state = 451},
  [12749] = {.lex_state = 451},
  [12750] = {.lex_state = 253},
  [12751] = {.lex_state = 451},
  [12752] = {.lex_state = 451},
  [12753] = {.lex_state = 451},
  [12754] = {.lex_state = 242},
  [12755] = {.lex_state = 242},
  [12756] = {.lex_state = 242},
  [12757] = {.lex_state = 451},
  [12758] = {.lex_state = 451},
  [12759] = {.lex_state = 242},
  [12760] = {.lex_state = 451},
  [12761] = {.lex_state = 451},
  [12762] = {.lex_state = 451},
  [12763] = {.lex_state = 451},
  [12764] = {.lex_state = 451},
  [12765] = {.lex_state = 451},
  [12766] = {.lex_state = 242},
  [12767] = {.lex_state = 242},
  [12768] = {.lex_state = 451},
  [12769] = {.lex_state = 451},
  [12770] = {.lex_state = 242},
  [12771] = {.lex_state = 451},
  [12772] = {.lex_state = 451},
  [12773] = {.lex_state = 451},
  [12774] = {.lex_state = 242},
  [12775] = {.lex_state = 451},
  [12776] = {.lex_state = 451},
  [12777] = {.lex_state = 451},
  [12778] = {.lex_state = 242},
  [12779] = {.lex_state = 242},
  [12780] = {.lex_state = 451},
  [12781] = {.lex_state = 451},
  [12782] = {.lex_state = 242},
  [12783] = {.lex_state = 451},
  [12784] = {.lex_state = 451},
  [12785] = {.lex_state = 451},
  [12786] = {.lex_state = 242},
  [12787] = {.lex_state = 242},
  [12788] = {.lex_state = 451},
  [12789] = {.lex_state = 451},
  [12790] = {.lex_state = 242},
  [12791] = {.lex_state = 451},
  [12792] = {.lex_state = 451},
  [12793] = {.lex_state = 451},
  [12794] = {.lex_state = 451, .external_lex_state = 4},
  [12795] = {.lex_state = 242},
  [12796] = {.lex_state = 451},
  [12797] = {.lex_state = 451, .external_lex_state = 3},
  [12798] = {.lex_state = 253},
  [12799] = {.lex_state = 242},
  [12800] = {.lex_state = 451},
  [12801] = {.lex_state = 451},
  [12802] = {.lex_state = 253},
  [12803] = {.lex_state = 253},
  [12804] = {.lex_state = 242},
  [12805] = {.lex_state = 451},
  [12806] = {.lex_state = 451},
  [12807] = {.lex_state = 451},
  [12808] = {.lex_state = 242},
  [12809] = {.lex_state = 242},
  [12810] = {.lex_state = 451},
  [12811] = {.lex_state = 451},
  [12812] = {.lex_state = 242},
  [12813] = {.lex_state = 451},
  [12814] = {.lex_state = 451},
  [12815] = {.lex_state = 451},
  [12816] = {.lex_state = 242},
  [12817] = {.lex_state = 242},
};

static const uint16_t ts_parse_table[LARGE_STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [ts_builtin_sym_end] = ACTIONS(1),
    [sym_id] = ACTIONS(1),
    [anon_sym_forall] = ACTIONS(1),
    [anon_sym_u2200] = ACTIONS(1),
    [anon_sym_DASH_GT] = ACTIONS(1),
    [anon_sym_u2192] = ACTIONS(1),
    [anon_sym_u03bb] = ACTIONS(1),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1),
    [anon_sym_u2026] = ACTIONS(1),
    [anon_sym_field] = ACTIONS(1),
    [anon_sym_overlap] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(1),
    [anon_sym_instance] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(1),
    [anon_sym_with] = ACTIONS(1),
    [anon_sym_rewrite] = ACTIONS(1),
    [anon_sym_module] = ACTIONS(1),
    [anon_sym_where] = ACTIONS(1),
    [anon_sym_data] = ACTIONS(1),
    [anon_sym_codata] = ACTIONS(1),
    [anon_sym_record] = ACTIONS(1),
    [anon_sym_constructor] = ACTIONS(1),
    [anon_sym_inductive] = ACTIONS(1),
    [anon_sym_coinductive] = ACTIONS(1),
    [anon_sym_eta_DASHequality] = ACTIONS(1),
    [anon_sym_no_DASHeta_DASHequality] = ACTIONS(1),
    [anon_sym_infix] = ACTIONS(1),
    [anon_sym_infixl] = ACTIONS(1),
    [anon_sym_infixr] = ACTIONS(1),
    [anon_sym_variable] = ACTIONS(1),
    [anon_sym_mutual] = ACTIONS(1),
    [anon_sym_abstract] = ACTIONS(1),
    [anon_sym_private] = ACTIONS(1),
    [anon_sym_macro] = ACTIONS(1),
    [anon_sym_postulate] = ACTIONS(1),
    [anon_sym_primitive] = ACTIONS(1),
    [anon_sym_open] = ACTIONS(1),
    [anon_sym_import] = ACTIONS(1),
    [anon_sym_public] = ACTIONS(1),
    [anon_sym_using] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [anon_sym_hiding] = ACTIONS(1),
    [anon_sym_renaming] = ACTIONS(1),
    [anon_sym_SEMI] = ACTIONS(1),
    [anon_sym_to] = ACTIONS(1),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(1),
    [anon_sym_u2983] = ACTIONS(1),
    [anon_sym_u2984] = ACTIONS(1),
    [anon_sym__] = ACTIONS(1),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LBRACE_DASH_POUND] = ACTIONS(1),
    [anon_sym_CATCHALL] = ACTIONS(1),
    [anon_sym_POUND_DASH_RBRACE] = ACTIONS(1),
    [anon_sym_syntax] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_pattern] = ACTIONS(1),
    [anon_sym_unquoteDecl] = ACTIONS(1),
    [anon_sym_unquoteDef] = ACTIONS(1),
    [anon_sym_DOT] = ACTIONS(1),
    [anon_sym_DOT_DOT] = ACTIONS(1),
    [anon_sym_DASH] = ACTIONS(1),
    [anon_sym_AT] = ACTIONS(1),
    [anon_sym_PIPE] = ACTIONS(1),
    [anon_sym_quoteGoal] = ACTIONS(1),
    [anon_sym_in] = ACTIONS(1),
    [anon_sym_tactic] = ACTIONS(1),
    [anon_sym_Prop] = ACTIONS(1),
    [anon_sym_quote] = ACTIONS(1),
    [anon_sym_quoteTerm] = ACTIONS(1),
    [anon_sym_quoteContext] = ACTIONS(1),
    [anon_sym_unquote] = ACTIONS(1),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1),
    [anon_sym_PIPE_RPAREN] = ACTIONS(1),
    [anon_sym_u2987] = ACTIONS(1),
    [anon_sym_u2988] = ACTIONS(1),
    [anon_sym_let] = ACTIONS(1),
    [anon_sym_do] = ACTIONS(1),
    [aux_sym_integer_token1] = ACTIONS(1),
    [aux_sym_string_token1] = ACTIONS(1),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(1),
    [sym_PropN] = ACTIONS(1),
    [sym__newline] = ACTIONS(1),
    [sym__indent] = ACTIONS(1),
    [sym__dedent] = ACTIONS(1),
  },
  [1] = {
    [sym_source_file] = STATE(12796),
    [sym__FORALL] = STATE(8288),
    [sym__LAMBDA] = STATE(8114),
    [sym__ELLIPSIS] = STATE(4608),
    [sym__declaration] = STATE(12794),
    [sym_fields] = STATE(12794),
    [sym_function] = STATE(12794),
    [sym_lhs_decl] = STATE(9175),
    [sym_lhs_defn] = STATE(9174),
    [sym_data] = STATE(12794),
    [sym_data_signature] = STATE(12794),
    [sym_record] = STATE(12794),
    [sym_record_signature] = STATE(12794),
    [sym_infix] = STATE(12794),
    [sym_generalize] = STATE(12794),
    [sym_mutual] = STATE(12794),
    [sym_abstract] = STATE(12794),
    [sym_private] = STATE(12794),
    [sym_instance] = STATE(12794),
    [sym_macro] = STATE(12794),
    [sym_postulate] = STATE(12794),
    [sym_primitive] = STATE(12794),
    [sym_open] = STATE(12794),
    [sym_import] = STATE(12794),
    [sym_module_macro] = STATE(12794),
    [sym_module] = STATE(12794),
    [sym_syntax] = STATE(12794),
    [sym_pattern] = STATE(12794),
    [sym_unquote_decl] = STATE(12794),
    [sym__qid] = STATE(4608),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3129),
    [sym__with_exprs] = STATE(8953),
    [sym__expr_or_attr] = STATE(4608),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4600),
    [aux_sym__atoms] = STATE(3848),
    [sym__atom_curly] = STATE(4564),
    [sym__atom_no_curly] = STATE(4564),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4608),
    [sym_field_assignments] = STATE(4608),
    [sym_literal] = STATE(4608),
    [sym_SetN] = STATE(4608),
    [aux_sym_source_file_repeat1] = STATE(77),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3710),
    [ts_builtin_sym_end] = ACTIONS(7),
    [sym_id] = ACTIONS(9),
    [anon_sym_forall] = ACTIONS(11),
    [anon_sym_u2200] = ACTIONS(11),
    [anon_sym_BSLASH] = ACTIONS(13),
    [anon_sym_u03bb] = ACTIONS(15),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(17),
    [anon_sym_u2026] = ACTIONS(17),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(23),
    [anon_sym_data] = ACTIONS(25),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(29),
    [anon_sym_infix] = ACTIONS(31),
    [anon_sym_infixl] = ACTIONS(31),
    [anon_sym_infixr] = ACTIONS(31),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(47),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(51),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(53),
    [anon_sym_u2983] = ACTIONS(55),
    [anon_sym__] = ACTIONS(17),
    [sym_pragma] = ACTIONS(57),
    [anon_sym_syntax] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_pattern] = ACTIONS(63),
    [anon_sym_unquoteDecl] = ACTIONS(65),
    [anon_sym_unquoteDef] = ACTIONS(67),
    [aux_sym__qid_token1] = ACTIONS(69),
    [anon_sym_DOT] = ACTIONS(71),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(75),
    [anon_sym_tactic] = ACTIONS(77),
    [anon_sym_Prop] = ACTIONS(17),
    [anon_sym_quote] = ACTIONS(17),
    [anon_sym_quoteTerm] = ACTIONS(17),
    [anon_sym_quoteContext] = ACTIONS(17),
    [anon_sym_unquote] = ACTIONS(17),
    [anon_sym_LPAREN_PIPE] = ACTIONS(79),
    [anon_sym_u2987] = ACTIONS(81),
    [anon_sym_let] = ACTIONS(83),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(87),
    [aux_sym_string_token1] = ACTIONS(87),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(89),
    [sym_PropN] = ACTIONS(17),
  },
  [2] = {
    [sym__FORALL] = STATE(8288),
    [sym__LAMBDA] = STATE(8114),
    [sym__ELLIPSIS] = STATE(4608),
    [sym__declaration] = STATE(11579),
    [sym_fields] = STATE(11579),
    [sym_function] = STATE(11579),
    [sym_lhs_decl] = STATE(9175),
    [sym_lhs_defn] = STATE(9174),
    [sym_data] = STATE(11579),
    [sym_data_signature] = STATE(11579),
    [sym_record] = STATE(11579),
    [sym__record_directive] = STATE(12259),
    [sym_record_constructor] = STATE(12259),
    [sym_record_constructor_instance] = STATE(12259),
    [sym_record_induction] = STATE(12259),
    [sym_record_eta] = STATE(12259),
    [sym_record_signature] = STATE(11579),
    [sym_infix] = STATE(11579),
    [sym_generalize] = STATE(11579),
    [sym_mutual] = STATE(11579),
    [sym_abstract] = STATE(11579),
    [sym_private] = STATE(11579),
    [sym_instance] = STATE(11579),
    [sym_macro] = STATE(11579),
    [sym_postulate] = STATE(11579),
    [sym_primitive] = STATE(11579),
    [sym_open] = STATE(11579),
    [sym_import] = STATE(11579),
    [sym_module_macro] = STATE(11579),
    [sym_module] = STATE(11579),
    [sym_syntax] = STATE(11579),
    [sym_pattern] = STATE(11579),
    [sym_unquote_decl] = STATE(11579),
    [sym__qid] = STATE(4608),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3129),
    [sym__with_exprs] = STATE(8953),
    [sym__expr_or_attr] = STATE(4608),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4600),
    [aux_sym__atoms] = STATE(3848),
    [sym__atom_curly] = STATE(4564),
    [sym__atom_no_curly] = STATE(4564),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4608),
    [sym_field_assignments] = STATE(4608),
    [sym_literal] = STATE(4608),
    [sym_SetN] = STATE(4608),
    [aux_sym_source_file_repeat1] = STATE(87),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym_record_declarations_block_repeat1] = STATE(3),
    [aux_sym__with_exprs_repeat1] = STATE(3710),
    [sym_id] = ACTIONS(9),
    [anon_sym_forall] = ACTIONS(11),
    [anon_sym_u2200] = ACTIONS(11),
    [anon_sym_BSLASH] = ACTIONS(13),
    [anon_sym_u03bb] = ACTIONS(15),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(17),
    [anon_sym_u2026] = ACTIONS(17),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(91),
    [anon_sym_module] = ACTIONS(23),
    [anon_sym_data] = ACTIONS(25),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(29),
    [anon_sym_constructor] = ACTIONS(93),
    [anon_sym_inductive] = ACTIONS(95),
    [anon_sym_coinductive] = ACTIONS(95),
    [anon_sym_eta_DASHequality] = ACTIONS(97),
    [anon_sym_no_DASHeta_DASHequality] = ACTIONS(97),
    [anon_sym_infix] = ACTIONS(31),
    [anon_sym_infixl] = ACTIONS(31),
    [anon_sym_infixr] = ACTIONS(31),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(47),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(51),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(53),
    [anon_sym_u2983] = ACTIONS(55),
    [anon_sym__] = ACTIONS(17),
    [sym_pragma] = ACTIONS(99),
    [anon_sym_syntax] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_pattern] = ACTIONS(63),
    [anon_sym_unquoteDecl] = ACTIONS(65),
    [anon_sym_unquoteDef] = ACTIONS(67),
    [aux_sym__qid_token1] = ACTIONS(69),
    [anon_sym_DOT] = ACTIONS(71),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(75),
    [anon_sym_tactic] = ACTIONS(77),
    [anon_sym_Prop] = ACTIONS(17),
    [anon_sym_quote] = ACTIONS(17),
    [anon_sym_quoteTerm] = ACTIONS(17),
    [anon_sym_quoteContext] = ACTIONS(17),
    [anon_sym_unquote] = ACTIONS(17),
    [anon_sym_LPAREN_PIPE] = ACTIONS(79),
    [anon_sym_u2987] = ACTIONS(81),
    [anon_sym_let] = ACTIONS(83),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(87),
    [aux_sym_string_token1] = ACTIONS(87),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(89),
    [sym_PropN] = ACTIONS(17),
    [sym__dedent] = ACTIONS(101),
  },
  [3] = {
    [sym__FORALL] = STATE(8288),
    [sym__LAMBDA] = STATE(8114),
    [sym__ELLIPSIS] = STATE(4608),
    [sym__declaration] = STATE(11579),
    [sym_fields] = STATE(11579),
    [sym_function] = STATE(11579),
    [sym_lhs_decl] = STATE(9175),
    [sym_lhs_defn] = STATE(9174),
    [sym_data] = STATE(11579),
    [sym_data_signature] = STATE(11579),
    [sym_record] = STATE(11579),
    [sym__record_directive] = STATE(12259),
    [sym_record_constructor] = STATE(12259),
    [sym_record_constructor_instance] = STATE(12259),
    [sym_record_induction] = STATE(12259),
    [sym_record_eta] = STATE(12259),
    [sym_record_signature] = STATE(11579),
    [sym_infix] = STATE(11579),
    [sym_generalize] = STATE(11579),
    [sym_mutual] = STATE(11579),
    [sym_abstract] = STATE(11579),
    [sym_private] = STATE(11579),
    [sym_instance] = STATE(11579),
    [sym_macro] = STATE(11579),
    [sym_postulate] = STATE(11579),
    [sym_primitive] = STATE(11579),
    [sym_open] = STATE(11579),
    [sym_import] = STATE(11579),
    [sym_module_macro] = STATE(11579),
    [sym_module] = STATE(11579),
    [sym_syntax] = STATE(11579),
    [sym_pattern] = STATE(11579),
    [sym_unquote_decl] = STATE(11579),
    [sym__qid] = STATE(4608),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3129),
    [sym__with_exprs] = STATE(8953),
    [sym__expr_or_attr] = STATE(4608),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4600),
    [aux_sym__atoms] = STATE(3848),
    [sym__atom_curly] = STATE(4564),
    [sym__atom_no_curly] = STATE(4564),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4608),
    [sym_field_assignments] = STATE(4608),
    [sym_literal] = STATE(4608),
    [sym_SetN] = STATE(4608),
    [aux_sym_source_file_repeat1] = STATE(65),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym_record_declarations_block_repeat1] = STATE(513),
    [aux_sym__with_exprs_repeat1] = STATE(3710),
    [sym_id] = ACTIONS(9),
    [anon_sym_forall] = ACTIONS(11),
    [anon_sym_u2200] = ACTIONS(11),
    [anon_sym_BSLASH] = ACTIONS(13),
    [anon_sym_u03bb] = ACTIONS(15),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(17),
    [anon_sym_u2026] = ACTIONS(17),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(91),
    [anon_sym_module] = ACTIONS(23),
    [anon_sym_data] = ACTIONS(25),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(29),
    [anon_sym_constructor] = ACTIONS(93),
    [anon_sym_inductive] = ACTIONS(95),
    [anon_sym_coinductive] = ACTIONS(95),
    [anon_sym_eta_DASHequality] = ACTIONS(97),
    [anon_sym_no_DASHeta_DASHequality] = ACTIONS(97),
    [anon_sym_infix] = ACTIONS(31),
    [anon_sym_infixl] = ACTIONS(31),
    [anon_sym_infixr] = ACTIONS(31),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(47),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(51),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(53),
    [anon_sym_u2983] = ACTIONS(55),
    [anon_sym__] = ACTIONS(17),
    [sym_pragma] = ACTIONS(99),
    [anon_sym_syntax] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_pattern] = ACTIONS(63),
    [anon_sym_unquoteDecl] = ACTIONS(65),
    [anon_sym_unquoteDef] = ACTIONS(67),
    [aux_sym__qid_token1] = ACTIONS(69),
    [anon_sym_DOT] = ACTIONS(71),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(75),
    [anon_sym_tactic] = ACTIONS(77),
    [anon_sym_Prop] = ACTIONS(17),
    [anon_sym_quote] = ACTIONS(17),
    [anon_sym_quoteTerm] = ACTIONS(17),
    [anon_sym_quoteContext] = ACTIONS(17),
    [anon_sym_unquote] = ACTIONS(17),
    [anon_sym_LPAREN_PIPE] = ACTIONS(79),
    [anon_sym_u2987] = ACTIONS(81),
    [anon_sym_let] = ACTIONS(83),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(87),
    [aux_sym_string_token1] = ACTIONS(87),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(89),
    [sym_PropN] = ACTIONS(17),
    [sym__dedent] = ACTIONS(103),
  },
  [4] = {
    [sym__FORALL] = STATE(8288),
    [sym__LAMBDA] = STATE(8114),
    [sym__ELLIPSIS] = STATE(4608),
    [sym__declaration] = STATE(11579),
    [sym_fields] = STATE(11579),
    [sym_function] = STATE(11579),
    [sym_lhs_decl] = STATE(9175),
    [sym_lhs_defn] = STATE(9174),
    [sym_data] = STATE(11579),
    [sym_data_signature] = STATE(11579),
    [sym_record] = STATE(11579),
    [sym_record_constructor] = STATE(12155),
    [sym_record_signature] = STATE(11579),
    [sym_infix] = STATE(11579),
    [sym_generalize] = STATE(11579),
    [sym_mutual] = STATE(11579),
    [sym_abstract] = STATE(11579),
    [sym_private] = STATE(11579),
    [sym_instance] = STATE(11579),
    [sym_macro] = STATE(11579),
    [sym_postulate] = STATE(11579),
    [sym_primitive] = STATE(11579),
    [sym_open] = STATE(11579),
    [sym_import] = STATE(11579),
    [sym_module_macro] = STATE(11579),
    [sym_module] = STATE(11579),
    [sym_syntax] = STATE(11579),
    [sym_pattern] = STATE(11579),
    [sym_unquote_decl] = STATE(11579),
    [sym__qid] = STATE(4608),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3129),
    [sym__with_exprs] = STATE(8953),
    [sym__expr_or_attr] = STATE(4608),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4600),
    [aux_sym__atoms] = STATE(3848),
    [sym__atom_curly] = STATE(4564),
    [sym__atom_no_curly] = STATE(4564),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4608),
    [sym_field_assignments] = STATE(4608),
    [sym_literal] = STATE(4608),
    [sym_SetN] = STATE(4608),
    [aux_sym_source_file_repeat1] = STATE(76),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym_record_constructor_instance_repeat1] = STATE(9441),
    [aux_sym__with_exprs_repeat1] = STATE(3710),
    [sym_id] = ACTIONS(9),
    [anon_sym_forall] = ACTIONS(11),
    [anon_sym_u2200] = ACTIONS(11),
    [anon_sym_BSLASH] = ACTIONS(13),
    [anon_sym_u03bb] = ACTIONS(15),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(17),
    [anon_sym_u2026] = ACTIONS(17),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(23),
    [anon_sym_data] = ACTIONS(25),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(29),
    [anon_sym_constructor] = ACTIONS(93),
    [anon_sym_infix] = ACTIONS(31),
    [anon_sym_infixl] = ACTIONS(31),
    [anon_sym_infixr] = ACTIONS(31),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(47),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(51),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(53),
    [anon_sym_u2983] = ACTIONS(55),
    [anon_sym__] = ACTIONS(17),
    [sym_pragma] = ACTIONS(99),
    [anon_sym_syntax] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_pattern] = ACTIONS(63),
    [anon_sym_unquoteDecl] = ACTIONS(65),
    [anon_sym_unquoteDef] = ACTIONS(67),
    [aux_sym__qid_token1] = ACTIONS(69),
    [anon_sym_DOT] = ACTIONS(71),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(75),
    [anon_sym_tactic] = ACTIONS(77),
    [anon_sym_Prop] = ACTIONS(17),
    [anon_sym_quote] = ACTIONS(17),
    [anon_sym_quoteTerm] = ACTIONS(17),
    [anon_sym_quoteContext] = ACTIONS(17),
    [anon_sym_unquote] = ACTIONS(17),
    [anon_sym_LPAREN_PIPE] = ACTIONS(79),
    [anon_sym_u2987] = ACTIONS(81),
    [anon_sym_let] = ACTIONS(83),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(87),
    [aux_sym_string_token1] = ACTIONS(87),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(89),
    [sym_PropN] = ACTIONS(17),
  },
  [5] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration_block] = STATE(11380),
    [sym__declaration] = STATE(9671),
    [sym_fields] = STATE(9671),
    [sym_function] = STATE(9671),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9671),
    [sym_data_signature] = STATE(9671),
    [sym_record] = STATE(9671),
    [sym_record_signature] = STATE(9671),
    [sym_infix] = STATE(9671),
    [sym_generalize] = STATE(9671),
    [sym_mutual] = STATE(9671),
    [sym_abstract] = STATE(9671),
    [sym_private] = STATE(9671),
    [sym_instance] = STATE(9671),
    [sym_macro] = STATE(9671),
    [sym_postulate] = STATE(9671),
    [sym_primitive] = STATE(9671),
    [sym_open] = STATE(9671),
    [sym_import] = STATE(9671),
    [sym_module_macro] = STATE(9671),
    [sym_module] = STATE(9671),
    [sym_syntax] = STATE(9671),
    [sym_pattern] = STATE(9671),
    [sym_unquote_decl] = STATE(9671),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(118),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(131),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
    [sym__indent] = ACTIONS(161),
  },
  [6] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration_block] = STATE(10564),
    [sym__declaration] = STATE(9671),
    [sym_fields] = STATE(9671),
    [sym_function] = STATE(9671),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9671),
    [sym_data_signature] = STATE(9671),
    [sym_record] = STATE(9671),
    [sym_record_signature] = STATE(9671),
    [sym_infix] = STATE(9671),
    [sym_generalize] = STATE(9671),
    [sym_mutual] = STATE(9671),
    [sym_abstract] = STATE(9671),
    [sym_private] = STATE(9671),
    [sym_instance] = STATE(9671),
    [sym_macro] = STATE(9671),
    [sym_postulate] = STATE(9671),
    [sym_primitive] = STATE(9671),
    [sym_open] = STATE(9671),
    [sym_import] = STATE(9671),
    [sym_module_macro] = STATE(9671),
    [sym_module] = STATE(9671),
    [sym_syntax] = STATE(9671),
    [sym_pattern] = STATE(9671),
    [sym_unquote_decl] = STATE(9671),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(118),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(131),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
    [sym__indent] = ACTIONS(161),
  },
  [7] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration_block] = STATE(11546),
    [sym__declaration] = STATE(9671),
    [sym_fields] = STATE(9671),
    [sym_function] = STATE(9671),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9671),
    [sym_data_signature] = STATE(9671),
    [sym_record] = STATE(9671),
    [sym_record_signature] = STATE(9671),
    [sym_infix] = STATE(9671),
    [sym_generalize] = STATE(9671),
    [sym_mutual] = STATE(9671),
    [sym_abstract] = STATE(9671),
    [sym_private] = STATE(9671),
    [sym_instance] = STATE(9671),
    [sym_macro] = STATE(9671),
    [sym_postulate] = STATE(9671),
    [sym_primitive] = STATE(9671),
    [sym_open] = STATE(9671),
    [sym_import] = STATE(9671),
    [sym_module_macro] = STATE(9671),
    [sym_module] = STATE(9671),
    [sym_syntax] = STATE(9671),
    [sym_pattern] = STATE(9671),
    [sym_unquote_decl] = STATE(9671),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(118),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(131),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
    [sym__indent] = ACTIONS(161),
  },
  [8] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration_block] = STATE(11091),
    [sym__declaration] = STATE(9671),
    [sym_fields] = STATE(9671),
    [sym_function] = STATE(9671),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9671),
    [sym_data_signature] = STATE(9671),
    [sym_record] = STATE(9671),
    [sym_record_signature] = STATE(9671),
    [sym_infix] = STATE(9671),
    [sym_generalize] = STATE(9671),
    [sym_mutual] = STATE(9671),
    [sym_abstract] = STATE(9671),
    [sym_private] = STATE(9671),
    [sym_instance] = STATE(9671),
    [sym_macro] = STATE(9671),
    [sym_postulate] = STATE(9671),
    [sym_primitive] = STATE(9671),
    [sym_open] = STATE(9671),
    [sym_import] = STATE(9671),
    [sym_module_macro] = STATE(9671),
    [sym_module] = STATE(9671),
    [sym_syntax] = STATE(9671),
    [sym_pattern] = STATE(9671),
    [sym_unquote_decl] = STATE(9671),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(118),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(131),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
    [sym__indent] = ACTIONS(161),
  },
  [9] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration_block] = STATE(10633),
    [sym__declaration] = STATE(9671),
    [sym_fields] = STATE(9671),
    [sym_function] = STATE(9671),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9671),
    [sym_data_signature] = STATE(9671),
    [sym_record] = STATE(9671),
    [sym_record_signature] = STATE(9671),
    [sym_infix] = STATE(9671),
    [sym_generalize] = STATE(9671),
    [sym_mutual] = STATE(9671),
    [sym_abstract] = STATE(9671),
    [sym_private] = STATE(9671),
    [sym_instance] = STATE(9671),
    [sym_macro] = STATE(9671),
    [sym_postulate] = STATE(9671),
    [sym_primitive] = STATE(9671),
    [sym_open] = STATE(9671),
    [sym_import] = STATE(9671),
    [sym_module_macro] = STATE(9671),
    [sym_module] = STATE(9671),
    [sym_syntax] = STATE(9671),
    [sym_pattern] = STATE(9671),
    [sym_unquote_decl] = STATE(9671),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(118),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(131),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
    [sym__indent] = ACTIONS(161),
  },
  [10] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration_block] = STATE(11309),
    [sym__declaration] = STATE(9671),
    [sym_fields] = STATE(9671),
    [sym_function] = STATE(9671),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9671),
    [sym_data_signature] = STATE(9671),
    [sym_record] = STATE(9671),
    [sym_record_signature] = STATE(9671),
    [sym_infix] = STATE(9671),
    [sym_generalize] = STATE(9671),
    [sym_mutual] = STATE(9671),
    [sym_abstract] = STATE(9671),
    [sym_private] = STATE(9671),
    [sym_instance] = STATE(9671),
    [sym_macro] = STATE(9671),
    [sym_postulate] = STATE(9671),
    [sym_primitive] = STATE(9671),
    [sym_open] = STATE(9671),
    [sym_import] = STATE(9671),
    [sym_module_macro] = STATE(9671),
    [sym_module] = STATE(9671),
    [sym_syntax] = STATE(9671),
    [sym_pattern] = STATE(9671),
    [sym_unquote_decl] = STATE(9671),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(118),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(131),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
    [sym__indent] = ACTIONS(161),
  },
  [11] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration_block] = STATE(10539),
    [sym__declaration] = STATE(9671),
    [sym_fields] = STATE(9671),
    [sym_function] = STATE(9671),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9671),
    [sym_data_signature] = STATE(9671),
    [sym_record] = STATE(9671),
    [sym_record_signature] = STATE(9671),
    [sym_infix] = STATE(9671),
    [sym_generalize] = STATE(9671),
    [sym_mutual] = STATE(9671),
    [sym_abstract] = STATE(9671),
    [sym_private] = STATE(9671),
    [sym_instance] = STATE(9671),
    [sym_macro] = STATE(9671),
    [sym_postulate] = STATE(9671),
    [sym_primitive] = STATE(9671),
    [sym_open] = STATE(9671),
    [sym_import] = STATE(9671),
    [sym_module_macro] = STATE(9671),
    [sym_module] = STATE(9671),
    [sym_syntax] = STATE(9671),
    [sym_pattern] = STATE(9671),
    [sym_unquote_decl] = STATE(9671),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(118),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(131),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
    [sym__indent] = ACTIONS(161),
  },
  [12] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration_block] = STATE(10600),
    [sym__declaration] = STATE(9671),
    [sym_fields] = STATE(9671),
    [sym_function] = STATE(9671),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9671),
    [sym_data_signature] = STATE(9671),
    [sym_record] = STATE(9671),
    [sym_record_signature] = STATE(9671),
    [sym_infix] = STATE(9671),
    [sym_generalize] = STATE(9671),
    [sym_mutual] = STATE(9671),
    [sym_abstract] = STATE(9671),
    [sym_private] = STATE(9671),
    [sym_instance] = STATE(9671),
    [sym_macro] = STATE(9671),
    [sym_postulate] = STATE(9671),
    [sym_primitive] = STATE(9671),
    [sym_open] = STATE(9671),
    [sym_import] = STATE(9671),
    [sym_module_macro] = STATE(9671),
    [sym_module] = STATE(9671),
    [sym_syntax] = STATE(9671),
    [sym_pattern] = STATE(9671),
    [sym_unquote_decl] = STATE(9671),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(118),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(131),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
    [sym__indent] = ACTIONS(161),
  },
  [13] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration_block] = STATE(10449),
    [sym__declaration] = STATE(9671),
    [sym_fields] = STATE(9671),
    [sym_function] = STATE(9671),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9671),
    [sym_data_signature] = STATE(9671),
    [sym_record] = STATE(9671),
    [sym_record_signature] = STATE(9671),
    [sym_infix] = STATE(9671),
    [sym_generalize] = STATE(9671),
    [sym_mutual] = STATE(9671),
    [sym_abstract] = STATE(9671),
    [sym_private] = STATE(9671),
    [sym_instance] = STATE(9671),
    [sym_macro] = STATE(9671),
    [sym_postulate] = STATE(9671),
    [sym_primitive] = STATE(9671),
    [sym_open] = STATE(9671),
    [sym_import] = STATE(9671),
    [sym_module_macro] = STATE(9671),
    [sym_module] = STATE(9671),
    [sym_syntax] = STATE(9671),
    [sym_pattern] = STATE(9671),
    [sym_unquote_decl] = STATE(9671),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(118),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(131),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
    [sym__indent] = ACTIONS(161),
  },
  [14] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration_block] = STATE(10443),
    [sym__declaration] = STATE(9671),
    [sym_fields] = STATE(9671),
    [sym_function] = STATE(9671),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9671),
    [sym_data_signature] = STATE(9671),
    [sym_record] = STATE(9671),
    [sym_record_signature] = STATE(9671),
    [sym_infix] = STATE(9671),
    [sym_generalize] = STATE(9671),
    [sym_mutual] = STATE(9671),
    [sym_abstract] = STATE(9671),
    [sym_private] = STATE(9671),
    [sym_instance] = STATE(9671),
    [sym_macro] = STATE(9671),
    [sym_postulate] = STATE(9671),
    [sym_primitive] = STATE(9671),
    [sym_open] = STATE(9671),
    [sym_import] = STATE(9671),
    [sym_module_macro] = STATE(9671),
    [sym_module] = STATE(9671),
    [sym_syntax] = STATE(9671),
    [sym_pattern] = STATE(9671),
    [sym_unquote_decl] = STATE(9671),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(118),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(131),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
    [sym__indent] = ACTIONS(161),
  },
  [15] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration_block] = STATE(11683),
    [sym__declaration] = STATE(9671),
    [sym_fields] = STATE(9671),
    [sym_function] = STATE(9671),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9671),
    [sym_data_signature] = STATE(9671),
    [sym_record] = STATE(9671),
    [sym_record_signature] = STATE(9671),
    [sym_infix] = STATE(9671),
    [sym_generalize] = STATE(9671),
    [sym_mutual] = STATE(9671),
    [sym_abstract] = STATE(9671),
    [sym_private] = STATE(9671),
    [sym_instance] = STATE(9671),
    [sym_macro] = STATE(9671),
    [sym_postulate] = STATE(9671),
    [sym_primitive] = STATE(9671),
    [sym_open] = STATE(9671),
    [sym_import] = STATE(9671),
    [sym_module_macro] = STATE(9671),
    [sym_module] = STATE(9671),
    [sym_syntax] = STATE(9671),
    [sym_pattern] = STATE(9671),
    [sym_unquote_decl] = STATE(9671),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(118),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(131),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
    [sym__indent] = ACTIONS(161),
  },
  [16] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration_block] = STATE(11758),
    [sym__declaration] = STATE(9671),
    [sym_fields] = STATE(9671),
    [sym_function] = STATE(9671),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9671),
    [sym_data_signature] = STATE(9671),
    [sym_record] = STATE(9671),
    [sym_record_signature] = STATE(9671),
    [sym_infix] = STATE(9671),
    [sym_generalize] = STATE(9671),
    [sym_mutual] = STATE(9671),
    [sym_abstract] = STATE(9671),
    [sym_private] = STATE(9671),
    [sym_instance] = STATE(9671),
    [sym_macro] = STATE(9671),
    [sym_postulate] = STATE(9671),
    [sym_primitive] = STATE(9671),
    [sym_open] = STATE(9671),
    [sym_import] = STATE(9671),
    [sym_module_macro] = STATE(9671),
    [sym_module] = STATE(9671),
    [sym_syntax] = STATE(9671),
    [sym_pattern] = STATE(9671),
    [sym_unquote_decl] = STATE(9671),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(118),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(131),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
    [sym__indent] = ACTIONS(161),
  },
  [17] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration_block] = STATE(10328),
    [sym__declaration] = STATE(9671),
    [sym_fields] = STATE(9671),
    [sym_function] = STATE(9671),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9671),
    [sym_data_signature] = STATE(9671),
    [sym_record] = STATE(9671),
    [sym_record_signature] = STATE(9671),
    [sym_infix] = STATE(9671),
    [sym_generalize] = STATE(9671),
    [sym_mutual] = STATE(9671),
    [sym_abstract] = STATE(9671),
    [sym_private] = STATE(9671),
    [sym_instance] = STATE(9671),
    [sym_macro] = STATE(9671),
    [sym_postulate] = STATE(9671),
    [sym_primitive] = STATE(9671),
    [sym_open] = STATE(9671),
    [sym_import] = STATE(9671),
    [sym_module_macro] = STATE(9671),
    [sym_module] = STATE(9671),
    [sym_syntax] = STATE(9671),
    [sym_pattern] = STATE(9671),
    [sym_unquote_decl] = STATE(9671),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(118),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(131),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
    [sym__indent] = ACTIONS(161),
  },
  [18] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration_block] = STATE(10523),
    [sym__declaration] = STATE(9671),
    [sym_fields] = STATE(9671),
    [sym_function] = STATE(9671),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9671),
    [sym_data_signature] = STATE(9671),
    [sym_record] = STATE(9671),
    [sym_record_signature] = STATE(9671),
    [sym_infix] = STATE(9671),
    [sym_generalize] = STATE(9671),
    [sym_mutual] = STATE(9671),
    [sym_abstract] = STATE(9671),
    [sym_private] = STATE(9671),
    [sym_instance] = STATE(9671),
    [sym_macro] = STATE(9671),
    [sym_postulate] = STATE(9671),
    [sym_primitive] = STATE(9671),
    [sym_open] = STATE(9671),
    [sym_import] = STATE(9671),
    [sym_module_macro] = STATE(9671),
    [sym_module] = STATE(9671),
    [sym_syntax] = STATE(9671),
    [sym_pattern] = STATE(9671),
    [sym_unquote_decl] = STATE(9671),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(118),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(131),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
    [sym__indent] = ACTIONS(161),
  },
  [19] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration_block] = STATE(11611),
    [sym__declaration] = STATE(9671),
    [sym_fields] = STATE(9671),
    [sym_function] = STATE(9671),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9671),
    [sym_data_signature] = STATE(9671),
    [sym_record] = STATE(9671),
    [sym_record_signature] = STATE(9671),
    [sym_infix] = STATE(9671),
    [sym_generalize] = STATE(9671),
    [sym_mutual] = STATE(9671),
    [sym_abstract] = STATE(9671),
    [sym_private] = STATE(9671),
    [sym_instance] = STATE(9671),
    [sym_macro] = STATE(9671),
    [sym_postulate] = STATE(9671),
    [sym_primitive] = STATE(9671),
    [sym_open] = STATE(9671),
    [sym_import] = STATE(9671),
    [sym_module_macro] = STATE(9671),
    [sym_module] = STATE(9671),
    [sym_syntax] = STATE(9671),
    [sym_pattern] = STATE(9671),
    [sym_unquote_decl] = STATE(9671),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(118),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(131),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
    [sym__indent] = ACTIONS(161),
  },
  [20] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration_block] = STATE(10688),
    [sym__declaration] = STATE(9671),
    [sym_fields] = STATE(9671),
    [sym_function] = STATE(9671),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9671),
    [sym_data_signature] = STATE(9671),
    [sym_record] = STATE(9671),
    [sym_record_signature] = STATE(9671),
    [sym_infix] = STATE(9671),
    [sym_generalize] = STATE(9671),
    [sym_mutual] = STATE(9671),
    [sym_abstract] = STATE(9671),
    [sym_private] = STATE(9671),
    [sym_instance] = STATE(9671),
    [sym_macro] = STATE(9671),
    [sym_postulate] = STATE(9671),
    [sym_primitive] = STATE(9671),
    [sym_open] = STATE(9671),
    [sym_import] = STATE(9671),
    [sym_module_macro] = STATE(9671),
    [sym_module] = STATE(9671),
    [sym_syntax] = STATE(9671),
    [sym_pattern] = STATE(9671),
    [sym_unquote_decl] = STATE(9671),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(118),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(131),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
    [sym__indent] = ACTIONS(161),
  },
  [21] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration_block] = STATE(10293),
    [sym__declaration] = STATE(9671),
    [sym_fields] = STATE(9671),
    [sym_function] = STATE(9671),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9671),
    [sym_data_signature] = STATE(9671),
    [sym_record] = STATE(9671),
    [sym_record_signature] = STATE(9671),
    [sym_infix] = STATE(9671),
    [sym_generalize] = STATE(9671),
    [sym_mutual] = STATE(9671),
    [sym_abstract] = STATE(9671),
    [sym_private] = STATE(9671),
    [sym_instance] = STATE(9671),
    [sym_macro] = STATE(9671),
    [sym_postulate] = STATE(9671),
    [sym_primitive] = STATE(9671),
    [sym_open] = STATE(9671),
    [sym_import] = STATE(9671),
    [sym_module_macro] = STATE(9671),
    [sym_module] = STATE(9671),
    [sym_syntax] = STATE(9671),
    [sym_pattern] = STATE(9671),
    [sym_unquote_decl] = STATE(9671),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(118),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(131),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
    [sym__indent] = ACTIONS(161),
  },
  [22] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration_block] = STATE(10870),
    [sym__declaration] = STATE(9671),
    [sym_fields] = STATE(9671),
    [sym_function] = STATE(9671),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9671),
    [sym_data_signature] = STATE(9671),
    [sym_record] = STATE(9671),
    [sym_record_signature] = STATE(9671),
    [sym_infix] = STATE(9671),
    [sym_generalize] = STATE(9671),
    [sym_mutual] = STATE(9671),
    [sym_abstract] = STATE(9671),
    [sym_private] = STATE(9671),
    [sym_instance] = STATE(9671),
    [sym_macro] = STATE(9671),
    [sym_postulate] = STATE(9671),
    [sym_primitive] = STATE(9671),
    [sym_open] = STATE(9671),
    [sym_import] = STATE(9671),
    [sym_module_macro] = STATE(9671),
    [sym_module] = STATE(9671),
    [sym_syntax] = STATE(9671),
    [sym_pattern] = STATE(9671),
    [sym_unquote_decl] = STATE(9671),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(118),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(131),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
    [sym__indent] = ACTIONS(161),
  },
  [23] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration_block] = STATE(11494),
    [sym__declaration] = STATE(9671),
    [sym_fields] = STATE(9671),
    [sym_function] = STATE(9671),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9671),
    [sym_data_signature] = STATE(9671),
    [sym_record] = STATE(9671),
    [sym_record_signature] = STATE(9671),
    [sym_infix] = STATE(9671),
    [sym_generalize] = STATE(9671),
    [sym_mutual] = STATE(9671),
    [sym_abstract] = STATE(9671),
    [sym_private] = STATE(9671),
    [sym_instance] = STATE(9671),
    [sym_macro] = STATE(9671),
    [sym_postulate] = STATE(9671),
    [sym_primitive] = STATE(9671),
    [sym_open] = STATE(9671),
    [sym_import] = STATE(9671),
    [sym_module_macro] = STATE(9671),
    [sym_module] = STATE(9671),
    [sym_syntax] = STATE(9671),
    [sym_pattern] = STATE(9671),
    [sym_unquote_decl] = STATE(9671),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(118),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(131),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
    [sym__indent] = ACTIONS(161),
  },
  [24] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration_block] = STATE(10835),
    [sym__declaration] = STATE(9671),
    [sym_fields] = STATE(9671),
    [sym_function] = STATE(9671),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9671),
    [sym_data_signature] = STATE(9671),
    [sym_record] = STATE(9671),
    [sym_record_signature] = STATE(9671),
    [sym_infix] = STATE(9671),
    [sym_generalize] = STATE(9671),
    [sym_mutual] = STATE(9671),
    [sym_abstract] = STATE(9671),
    [sym_private] = STATE(9671),
    [sym_instance] = STATE(9671),
    [sym_macro] = STATE(9671),
    [sym_postulate] = STATE(9671),
    [sym_primitive] = STATE(9671),
    [sym_open] = STATE(9671),
    [sym_import] = STATE(9671),
    [sym_module_macro] = STATE(9671),
    [sym_module] = STATE(9671),
    [sym_syntax] = STATE(9671),
    [sym_pattern] = STATE(9671),
    [sym_unquote_decl] = STATE(9671),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(118),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(131),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
    [sym__indent] = ACTIONS(161),
  },
  [25] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration_block] = STATE(10256),
    [sym__declaration] = STATE(9671),
    [sym_fields] = STATE(9671),
    [sym_function] = STATE(9671),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9671),
    [sym_data_signature] = STATE(9671),
    [sym_record] = STATE(9671),
    [sym_record_signature] = STATE(9671),
    [sym_infix] = STATE(9671),
    [sym_generalize] = STATE(9671),
    [sym_mutual] = STATE(9671),
    [sym_abstract] = STATE(9671),
    [sym_private] = STATE(9671),
    [sym_instance] = STATE(9671),
    [sym_macro] = STATE(9671),
    [sym_postulate] = STATE(9671),
    [sym_primitive] = STATE(9671),
    [sym_open] = STATE(9671),
    [sym_import] = STATE(9671),
    [sym_module_macro] = STATE(9671),
    [sym_module] = STATE(9671),
    [sym_syntax] = STATE(9671),
    [sym_pattern] = STATE(9671),
    [sym_unquote_decl] = STATE(9671),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(118),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(131),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
    [sym__indent] = ACTIONS(161),
  },
  [26] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration_block] = STATE(10403),
    [sym__declaration] = STATE(9671),
    [sym_fields] = STATE(9671),
    [sym_function] = STATE(9671),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9671),
    [sym_data_signature] = STATE(9671),
    [sym_record] = STATE(9671),
    [sym_record_signature] = STATE(9671),
    [sym_infix] = STATE(9671),
    [sym_generalize] = STATE(9671),
    [sym_mutual] = STATE(9671),
    [sym_abstract] = STATE(9671),
    [sym_private] = STATE(9671),
    [sym_instance] = STATE(9671),
    [sym_macro] = STATE(9671),
    [sym_postulate] = STATE(9671),
    [sym_primitive] = STATE(9671),
    [sym_open] = STATE(9671),
    [sym_import] = STATE(9671),
    [sym_module_macro] = STATE(9671),
    [sym_module] = STATE(9671),
    [sym_syntax] = STATE(9671),
    [sym_pattern] = STATE(9671),
    [sym_unquote_decl] = STATE(9671),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(118),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(131),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
    [sym__indent] = ACTIONS(161),
  },
  [27] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration_block] = STATE(11272),
    [sym__declaration] = STATE(9671),
    [sym_fields] = STATE(9671),
    [sym_function] = STATE(9671),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9671),
    [sym_data_signature] = STATE(9671),
    [sym_record] = STATE(9671),
    [sym_record_signature] = STATE(9671),
    [sym_infix] = STATE(9671),
    [sym_generalize] = STATE(9671),
    [sym_mutual] = STATE(9671),
    [sym_abstract] = STATE(9671),
    [sym_private] = STATE(9671),
    [sym_instance] = STATE(9671),
    [sym_macro] = STATE(9671),
    [sym_postulate] = STATE(9671),
    [sym_primitive] = STATE(9671),
    [sym_open] = STATE(9671),
    [sym_import] = STATE(9671),
    [sym_module_macro] = STATE(9671),
    [sym_module] = STATE(9671),
    [sym_syntax] = STATE(9671),
    [sym_pattern] = STATE(9671),
    [sym_unquote_decl] = STATE(9671),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(118),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(131),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
    [sym__indent] = ACTIONS(161),
  },
  [28] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration_block] = STATE(11129),
    [sym__declaration] = STATE(9671),
    [sym_fields] = STATE(9671),
    [sym_function] = STATE(9671),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9671),
    [sym_data_signature] = STATE(9671),
    [sym_record] = STATE(9671),
    [sym_record_signature] = STATE(9671),
    [sym_infix] = STATE(9671),
    [sym_generalize] = STATE(9671),
    [sym_mutual] = STATE(9671),
    [sym_abstract] = STATE(9671),
    [sym_private] = STATE(9671),
    [sym_instance] = STATE(9671),
    [sym_macro] = STATE(9671),
    [sym_postulate] = STATE(9671),
    [sym_primitive] = STATE(9671),
    [sym_open] = STATE(9671),
    [sym_import] = STATE(9671),
    [sym_module_macro] = STATE(9671),
    [sym_module] = STATE(9671),
    [sym_syntax] = STATE(9671),
    [sym_pattern] = STATE(9671),
    [sym_unquote_decl] = STATE(9671),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(118),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(131),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
    [sym__indent] = ACTIONS(161),
  },
  [29] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration_block] = STATE(10586),
    [sym__declaration] = STATE(9671),
    [sym_fields] = STATE(9671),
    [sym_function] = STATE(9671),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9671),
    [sym_data_signature] = STATE(9671),
    [sym_record] = STATE(9671),
    [sym_record_signature] = STATE(9671),
    [sym_infix] = STATE(9671),
    [sym_generalize] = STATE(9671),
    [sym_mutual] = STATE(9671),
    [sym_abstract] = STATE(9671),
    [sym_private] = STATE(9671),
    [sym_instance] = STATE(9671),
    [sym_macro] = STATE(9671),
    [sym_postulate] = STATE(9671),
    [sym_primitive] = STATE(9671),
    [sym_open] = STATE(9671),
    [sym_import] = STATE(9671),
    [sym_module_macro] = STATE(9671),
    [sym_module] = STATE(9671),
    [sym_syntax] = STATE(9671),
    [sym_pattern] = STATE(9671),
    [sym_unquote_decl] = STATE(9671),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(118),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(131),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
    [sym__indent] = ACTIONS(161),
  },
  [30] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration_block] = STATE(12003),
    [sym__declaration] = STATE(9671),
    [sym_fields] = STATE(9671),
    [sym_function] = STATE(9671),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9671),
    [sym_data_signature] = STATE(9671),
    [sym_record] = STATE(9671),
    [sym_record_signature] = STATE(9671),
    [sym_infix] = STATE(9671),
    [sym_generalize] = STATE(9671),
    [sym_mutual] = STATE(9671),
    [sym_abstract] = STATE(9671),
    [sym_private] = STATE(9671),
    [sym_instance] = STATE(9671),
    [sym_macro] = STATE(9671),
    [sym_postulate] = STATE(9671),
    [sym_primitive] = STATE(9671),
    [sym_open] = STATE(9671),
    [sym_import] = STATE(9671),
    [sym_module_macro] = STATE(9671),
    [sym_module] = STATE(9671),
    [sym_syntax] = STATE(9671),
    [sym_pattern] = STATE(9671),
    [sym_unquote_decl] = STATE(9671),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(118),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(131),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
    [sym__indent] = ACTIONS(161),
  },
  [31] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration_block] = STATE(11822),
    [sym__declaration] = STATE(9671),
    [sym_fields] = STATE(9671),
    [sym_function] = STATE(9671),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9671),
    [sym_data_signature] = STATE(9671),
    [sym_record] = STATE(9671),
    [sym_record_signature] = STATE(9671),
    [sym_infix] = STATE(9671),
    [sym_generalize] = STATE(9671),
    [sym_mutual] = STATE(9671),
    [sym_abstract] = STATE(9671),
    [sym_private] = STATE(9671),
    [sym_instance] = STATE(9671),
    [sym_macro] = STATE(9671),
    [sym_postulate] = STATE(9671),
    [sym_primitive] = STATE(9671),
    [sym_open] = STATE(9671),
    [sym_import] = STATE(9671),
    [sym_module_macro] = STATE(9671),
    [sym_module] = STATE(9671),
    [sym_syntax] = STATE(9671),
    [sym_pattern] = STATE(9671),
    [sym_unquote_decl] = STATE(9671),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(118),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(131),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
    [sym__indent] = ACTIONS(161),
  },
  [32] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration_block] = STATE(10366),
    [sym__declaration] = STATE(9671),
    [sym_fields] = STATE(9671),
    [sym_function] = STATE(9671),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9671),
    [sym_data_signature] = STATE(9671),
    [sym_record] = STATE(9671),
    [sym_record_signature] = STATE(9671),
    [sym_infix] = STATE(9671),
    [sym_generalize] = STATE(9671),
    [sym_mutual] = STATE(9671),
    [sym_abstract] = STATE(9671),
    [sym_private] = STATE(9671),
    [sym_instance] = STATE(9671),
    [sym_macro] = STATE(9671),
    [sym_postulate] = STATE(9671),
    [sym_primitive] = STATE(9671),
    [sym_open] = STATE(9671),
    [sym_import] = STATE(9671),
    [sym_module_macro] = STATE(9671),
    [sym_module] = STATE(9671),
    [sym_syntax] = STATE(9671),
    [sym_pattern] = STATE(9671),
    [sym_unquote_decl] = STATE(9671),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(118),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(131),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
    [sym__indent] = ACTIONS(161),
  },
  [33] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration_block] = STATE(10905),
    [sym__declaration] = STATE(9671),
    [sym_fields] = STATE(9671),
    [sym_function] = STATE(9671),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9671),
    [sym_data_signature] = STATE(9671),
    [sym_record] = STATE(9671),
    [sym_record_signature] = STATE(9671),
    [sym_infix] = STATE(9671),
    [sym_generalize] = STATE(9671),
    [sym_mutual] = STATE(9671),
    [sym_abstract] = STATE(9671),
    [sym_private] = STATE(9671),
    [sym_instance] = STATE(9671),
    [sym_macro] = STATE(9671),
    [sym_postulate] = STATE(9671),
    [sym_primitive] = STATE(9671),
    [sym_open] = STATE(9671),
    [sym_import] = STATE(9671),
    [sym_module_macro] = STATE(9671),
    [sym_module] = STATE(9671),
    [sym_syntax] = STATE(9671),
    [sym_pattern] = STATE(9671),
    [sym_unquote_decl] = STATE(9671),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(118),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(131),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
    [sym__indent] = ACTIONS(161),
  },
  [34] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration_block] = STATE(10679),
    [sym__declaration] = STATE(9671),
    [sym_fields] = STATE(9671),
    [sym_function] = STATE(9671),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9671),
    [sym_data_signature] = STATE(9671),
    [sym_record] = STATE(9671),
    [sym_record_signature] = STATE(9671),
    [sym_infix] = STATE(9671),
    [sym_generalize] = STATE(9671),
    [sym_mutual] = STATE(9671),
    [sym_abstract] = STATE(9671),
    [sym_private] = STATE(9671),
    [sym_instance] = STATE(9671),
    [sym_macro] = STATE(9671),
    [sym_postulate] = STATE(9671),
    [sym_primitive] = STATE(9671),
    [sym_open] = STATE(9671),
    [sym_import] = STATE(9671),
    [sym_module_macro] = STATE(9671),
    [sym_module] = STATE(9671),
    [sym_syntax] = STATE(9671),
    [sym_pattern] = STATE(9671),
    [sym_unquote_decl] = STATE(9671),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(118),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(131),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
    [sym__indent] = ACTIONS(161),
  },
  [35] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration_block] = STATE(10484),
    [sym__declaration] = STATE(9671),
    [sym_fields] = STATE(9671),
    [sym_function] = STATE(9671),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9671),
    [sym_data_signature] = STATE(9671),
    [sym_record] = STATE(9671),
    [sym_record_signature] = STATE(9671),
    [sym_infix] = STATE(9671),
    [sym_generalize] = STATE(9671),
    [sym_mutual] = STATE(9671),
    [sym_abstract] = STATE(9671),
    [sym_private] = STATE(9671),
    [sym_instance] = STATE(9671),
    [sym_macro] = STATE(9671),
    [sym_postulate] = STATE(9671),
    [sym_primitive] = STATE(9671),
    [sym_open] = STATE(9671),
    [sym_import] = STATE(9671),
    [sym_module_macro] = STATE(9671),
    [sym_module] = STATE(9671),
    [sym_syntax] = STATE(9671),
    [sym_pattern] = STATE(9671),
    [sym_unquote_decl] = STATE(9671),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(118),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(131),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
    [sym__indent] = ACTIONS(161),
  },
  [36] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration_block] = STATE(10942),
    [sym__declaration] = STATE(9671),
    [sym_fields] = STATE(9671),
    [sym_function] = STATE(9671),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9671),
    [sym_data_signature] = STATE(9671),
    [sym_record] = STATE(9671),
    [sym_record_signature] = STATE(9671),
    [sym_infix] = STATE(9671),
    [sym_generalize] = STATE(9671),
    [sym_mutual] = STATE(9671),
    [sym_abstract] = STATE(9671),
    [sym_private] = STATE(9671),
    [sym_instance] = STATE(9671),
    [sym_macro] = STATE(9671),
    [sym_postulate] = STATE(9671),
    [sym_primitive] = STATE(9671),
    [sym_open] = STATE(9671),
    [sym_import] = STATE(9671),
    [sym_module_macro] = STATE(9671),
    [sym_module] = STATE(9671),
    [sym_syntax] = STATE(9671),
    [sym_pattern] = STATE(9671),
    [sym_unquote_decl] = STATE(9671),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(118),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(131),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
    [sym__indent] = ACTIONS(161),
  },
  [37] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration_block] = STATE(10489),
    [sym__declaration] = STATE(9671),
    [sym_fields] = STATE(9671),
    [sym_function] = STATE(9671),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9671),
    [sym_data_signature] = STATE(9671),
    [sym_record] = STATE(9671),
    [sym_record_signature] = STATE(9671),
    [sym_infix] = STATE(9671),
    [sym_generalize] = STATE(9671),
    [sym_mutual] = STATE(9671),
    [sym_abstract] = STATE(9671),
    [sym_private] = STATE(9671),
    [sym_instance] = STATE(9671),
    [sym_macro] = STATE(9671),
    [sym_postulate] = STATE(9671),
    [sym_primitive] = STATE(9671),
    [sym_open] = STATE(9671),
    [sym_import] = STATE(9671),
    [sym_module_macro] = STATE(9671),
    [sym_module] = STATE(9671),
    [sym_syntax] = STATE(9671),
    [sym_pattern] = STATE(9671),
    [sym_unquote_decl] = STATE(9671),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(118),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(131),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
    [sym__indent] = ACTIONS(161),
  },
  [38] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration_block] = STATE(10980),
    [sym__declaration] = STATE(9671),
    [sym_fields] = STATE(9671),
    [sym_function] = STATE(9671),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9671),
    [sym_data_signature] = STATE(9671),
    [sym_record] = STATE(9671),
    [sym_record_signature] = STATE(9671),
    [sym_infix] = STATE(9671),
    [sym_generalize] = STATE(9671),
    [sym_mutual] = STATE(9671),
    [sym_abstract] = STATE(9671),
    [sym_private] = STATE(9671),
    [sym_instance] = STATE(9671),
    [sym_macro] = STATE(9671),
    [sym_postulate] = STATE(9671),
    [sym_primitive] = STATE(9671),
    [sym_open] = STATE(9671),
    [sym_import] = STATE(9671),
    [sym_module_macro] = STATE(9671),
    [sym_module] = STATE(9671),
    [sym_syntax] = STATE(9671),
    [sym_pattern] = STATE(9671),
    [sym_unquote_decl] = STATE(9671),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(118),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(131),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
    [sym__indent] = ACTIONS(161),
  },
  [39] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration_block] = STATE(11050),
    [sym__declaration] = STATE(9671),
    [sym_fields] = STATE(9671),
    [sym_function] = STATE(9671),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9671),
    [sym_data_signature] = STATE(9671),
    [sym_record] = STATE(9671),
    [sym_record_signature] = STATE(9671),
    [sym_infix] = STATE(9671),
    [sym_generalize] = STATE(9671),
    [sym_mutual] = STATE(9671),
    [sym_abstract] = STATE(9671),
    [sym_private] = STATE(9671),
    [sym_instance] = STATE(9671),
    [sym_macro] = STATE(9671),
    [sym_postulate] = STATE(9671),
    [sym_primitive] = STATE(9671),
    [sym_open] = STATE(9671),
    [sym_import] = STATE(9671),
    [sym_module_macro] = STATE(9671),
    [sym_module] = STATE(9671),
    [sym_syntax] = STATE(9671),
    [sym_pattern] = STATE(9671),
    [sym_unquote_decl] = STATE(9671),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(118),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(131),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
    [sym__indent] = ACTIONS(161),
  },
  [40] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration_block] = STATE(11491),
    [sym__declaration] = STATE(9671),
    [sym_fields] = STATE(9671),
    [sym_function] = STATE(9671),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9671),
    [sym_data_signature] = STATE(9671),
    [sym_record] = STATE(9671),
    [sym_record_signature] = STATE(9671),
    [sym_infix] = STATE(9671),
    [sym_generalize] = STATE(9671),
    [sym_mutual] = STATE(9671),
    [sym_abstract] = STATE(9671),
    [sym_private] = STATE(9671),
    [sym_instance] = STATE(9671),
    [sym_macro] = STATE(9671),
    [sym_postulate] = STATE(9671),
    [sym_primitive] = STATE(9671),
    [sym_open] = STATE(9671),
    [sym_import] = STATE(9671),
    [sym_module_macro] = STATE(9671),
    [sym_module] = STATE(9671),
    [sym_syntax] = STATE(9671),
    [sym_pattern] = STATE(9671),
    [sym_unquote_decl] = STATE(9671),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(118),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(131),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
    [sym__indent] = ACTIONS(161),
  },
  [41] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration_block] = STATE(10797),
    [sym__declaration] = STATE(9671),
    [sym_fields] = STATE(9671),
    [sym_function] = STATE(9671),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9671),
    [sym_data_signature] = STATE(9671),
    [sym_record] = STATE(9671),
    [sym_record_signature] = STATE(9671),
    [sym_infix] = STATE(9671),
    [sym_generalize] = STATE(9671),
    [sym_mutual] = STATE(9671),
    [sym_abstract] = STATE(9671),
    [sym_private] = STATE(9671),
    [sym_instance] = STATE(9671),
    [sym_macro] = STATE(9671),
    [sym_postulate] = STATE(9671),
    [sym_primitive] = STATE(9671),
    [sym_open] = STATE(9671),
    [sym_import] = STATE(9671),
    [sym_module_macro] = STATE(9671),
    [sym_module] = STATE(9671),
    [sym_syntax] = STATE(9671),
    [sym_pattern] = STATE(9671),
    [sym_unquote_decl] = STATE(9671),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(118),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(131),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
    [sym__indent] = ACTIONS(161),
  },
  [42] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration_block] = STATE(10350),
    [sym__declaration] = STATE(9671),
    [sym_fields] = STATE(9671),
    [sym_function] = STATE(9671),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9671),
    [sym_data_signature] = STATE(9671),
    [sym_record] = STATE(9671),
    [sym_record_signature] = STATE(9671),
    [sym_infix] = STATE(9671),
    [sym_generalize] = STATE(9671),
    [sym_mutual] = STATE(9671),
    [sym_abstract] = STATE(9671),
    [sym_private] = STATE(9671),
    [sym_instance] = STATE(9671),
    [sym_macro] = STATE(9671),
    [sym_postulate] = STATE(9671),
    [sym_primitive] = STATE(9671),
    [sym_open] = STATE(9671),
    [sym_import] = STATE(9671),
    [sym_module_macro] = STATE(9671),
    [sym_module] = STATE(9671),
    [sym_syntax] = STATE(9671),
    [sym_pattern] = STATE(9671),
    [sym_unquote_decl] = STATE(9671),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(118),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(131),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
    [sym__indent] = ACTIONS(161),
  },
  [43] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration_block] = STATE(10637),
    [sym__declaration] = STATE(9671),
    [sym_fields] = STATE(9671),
    [sym_function] = STATE(9671),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9671),
    [sym_data_signature] = STATE(9671),
    [sym_record] = STATE(9671),
    [sym_record_signature] = STATE(9671),
    [sym_infix] = STATE(9671),
    [sym_generalize] = STATE(9671),
    [sym_mutual] = STATE(9671),
    [sym_abstract] = STATE(9671),
    [sym_private] = STATE(9671),
    [sym_instance] = STATE(9671),
    [sym_macro] = STATE(9671),
    [sym_postulate] = STATE(9671),
    [sym_primitive] = STATE(9671),
    [sym_open] = STATE(9671),
    [sym_import] = STATE(9671),
    [sym_module_macro] = STATE(9671),
    [sym_module] = STATE(9671),
    [sym_syntax] = STATE(9671),
    [sym_pattern] = STATE(9671),
    [sym_unquote_decl] = STATE(9671),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(118),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(131),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
    [sym__indent] = ACTIONS(161),
  },
  [44] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration_block] = STATE(10235),
    [sym__declaration] = STATE(9671),
    [sym_fields] = STATE(9671),
    [sym_function] = STATE(9671),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9671),
    [sym_data_signature] = STATE(9671),
    [sym_record] = STATE(9671),
    [sym_record_signature] = STATE(9671),
    [sym_infix] = STATE(9671),
    [sym_generalize] = STATE(9671),
    [sym_mutual] = STATE(9671),
    [sym_abstract] = STATE(9671),
    [sym_private] = STATE(9671),
    [sym_instance] = STATE(9671),
    [sym_macro] = STATE(9671),
    [sym_postulate] = STATE(9671),
    [sym_primitive] = STATE(9671),
    [sym_open] = STATE(9671),
    [sym_import] = STATE(9671),
    [sym_module_macro] = STATE(9671),
    [sym_module] = STATE(9671),
    [sym_syntax] = STATE(9671),
    [sym_pattern] = STATE(9671),
    [sym_unquote_decl] = STATE(9671),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(118),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(131),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
    [sym__indent] = ACTIONS(161),
  },
  [45] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration_block] = STATE(10408),
    [sym__declaration] = STATE(9671),
    [sym_fields] = STATE(9671),
    [sym_function] = STATE(9671),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9671),
    [sym_data_signature] = STATE(9671),
    [sym_record] = STATE(9671),
    [sym_record_signature] = STATE(9671),
    [sym_infix] = STATE(9671),
    [sym_generalize] = STATE(9671),
    [sym_mutual] = STATE(9671),
    [sym_abstract] = STATE(9671),
    [sym_private] = STATE(9671),
    [sym_instance] = STATE(9671),
    [sym_macro] = STATE(9671),
    [sym_postulate] = STATE(9671),
    [sym_primitive] = STATE(9671),
    [sym_open] = STATE(9671),
    [sym_import] = STATE(9671),
    [sym_module_macro] = STATE(9671),
    [sym_module] = STATE(9671),
    [sym_syntax] = STATE(9671),
    [sym_pattern] = STATE(9671),
    [sym_unquote_decl] = STATE(9671),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(118),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(131),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
    [sym__indent] = ACTIONS(161),
  },
  [46] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration_block] = STATE(11167),
    [sym__declaration] = STATE(9671),
    [sym_fields] = STATE(9671),
    [sym_function] = STATE(9671),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9671),
    [sym_data_signature] = STATE(9671),
    [sym_record] = STATE(9671),
    [sym_record_signature] = STATE(9671),
    [sym_infix] = STATE(9671),
    [sym_generalize] = STATE(9671),
    [sym_mutual] = STATE(9671),
    [sym_abstract] = STATE(9671),
    [sym_private] = STATE(9671),
    [sym_instance] = STATE(9671),
    [sym_macro] = STATE(9671),
    [sym_postulate] = STATE(9671),
    [sym_primitive] = STATE(9671),
    [sym_open] = STATE(9671),
    [sym_import] = STATE(9671),
    [sym_module_macro] = STATE(9671),
    [sym_module] = STATE(9671),
    [sym_syntax] = STATE(9671),
    [sym_pattern] = STATE(9671),
    [sym_unquote_decl] = STATE(9671),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(118),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(131),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
    [sym__indent] = ACTIONS(161),
  },
  [47] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration_block] = STATE(10794),
    [sym__declaration] = STATE(9671),
    [sym_fields] = STATE(9671),
    [sym_function] = STATE(9671),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9671),
    [sym_data_signature] = STATE(9671),
    [sym_record] = STATE(9671),
    [sym_record_signature] = STATE(9671),
    [sym_infix] = STATE(9671),
    [sym_generalize] = STATE(9671),
    [sym_mutual] = STATE(9671),
    [sym_abstract] = STATE(9671),
    [sym_private] = STATE(9671),
    [sym_instance] = STATE(9671),
    [sym_macro] = STATE(9671),
    [sym_postulate] = STATE(9671),
    [sym_primitive] = STATE(9671),
    [sym_open] = STATE(9671),
    [sym_import] = STATE(9671),
    [sym_module_macro] = STATE(9671),
    [sym_module] = STATE(9671),
    [sym_syntax] = STATE(9671),
    [sym_pattern] = STATE(9671),
    [sym_unquote_decl] = STATE(9671),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(118),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(131),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
    [sym__indent] = ACTIONS(161),
  },
  [48] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration_block] = STATE(11015),
    [sym__declaration] = STATE(9671),
    [sym_fields] = STATE(9671),
    [sym_function] = STATE(9671),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9671),
    [sym_data_signature] = STATE(9671),
    [sym_record] = STATE(9671),
    [sym_record_signature] = STATE(9671),
    [sym_infix] = STATE(9671),
    [sym_generalize] = STATE(9671),
    [sym_mutual] = STATE(9671),
    [sym_abstract] = STATE(9671),
    [sym_private] = STATE(9671),
    [sym_instance] = STATE(9671),
    [sym_macro] = STATE(9671),
    [sym_postulate] = STATE(9671),
    [sym_primitive] = STATE(9671),
    [sym_open] = STATE(9671),
    [sym_import] = STATE(9671),
    [sym_module_macro] = STATE(9671),
    [sym_module] = STATE(9671),
    [sym_syntax] = STATE(9671),
    [sym_pattern] = STATE(9671),
    [sym_unquote_decl] = STATE(9671),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(118),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(131),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
    [sym__indent] = ACTIONS(161),
  },
  [49] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration_block] = STATE(11238),
    [sym__declaration] = STATE(9671),
    [sym_fields] = STATE(9671),
    [sym_function] = STATE(9671),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9671),
    [sym_data_signature] = STATE(9671),
    [sym_record] = STATE(9671),
    [sym_record_signature] = STATE(9671),
    [sym_infix] = STATE(9671),
    [sym_generalize] = STATE(9671),
    [sym_mutual] = STATE(9671),
    [sym_abstract] = STATE(9671),
    [sym_private] = STATE(9671),
    [sym_instance] = STATE(9671),
    [sym_macro] = STATE(9671),
    [sym_postulate] = STATE(9671),
    [sym_primitive] = STATE(9671),
    [sym_open] = STATE(9671),
    [sym_import] = STATE(9671),
    [sym_module_macro] = STATE(9671),
    [sym_module] = STATE(9671),
    [sym_syntax] = STATE(9671),
    [sym_pattern] = STATE(9671),
    [sym_unquote_decl] = STATE(9671),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(118),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(131),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
    [sym__indent] = ACTIONS(161),
  },
  [50] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration_block] = STATE(11311),
    [sym__declaration] = STATE(9671),
    [sym_fields] = STATE(9671),
    [sym_function] = STATE(9671),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9671),
    [sym_data_signature] = STATE(9671),
    [sym_record] = STATE(9671),
    [sym_record_signature] = STATE(9671),
    [sym_infix] = STATE(9671),
    [sym_generalize] = STATE(9671),
    [sym_mutual] = STATE(9671),
    [sym_abstract] = STATE(9671),
    [sym_private] = STATE(9671),
    [sym_instance] = STATE(9671),
    [sym_macro] = STATE(9671),
    [sym_postulate] = STATE(9671),
    [sym_primitive] = STATE(9671),
    [sym_open] = STATE(9671),
    [sym_import] = STATE(9671),
    [sym_module_macro] = STATE(9671),
    [sym_module] = STATE(9671),
    [sym_syntax] = STATE(9671),
    [sym_pattern] = STATE(9671),
    [sym_unquote_decl] = STATE(9671),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(118),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(131),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
    [sym__indent] = ACTIONS(161),
  },
  [51] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration_block] = STATE(11417),
    [sym__declaration] = STATE(9671),
    [sym_fields] = STATE(9671),
    [sym_function] = STATE(9671),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9671),
    [sym_data_signature] = STATE(9671),
    [sym_record] = STATE(9671),
    [sym_record_signature] = STATE(9671),
    [sym_infix] = STATE(9671),
    [sym_generalize] = STATE(9671),
    [sym_mutual] = STATE(9671),
    [sym_abstract] = STATE(9671),
    [sym_private] = STATE(9671),
    [sym_instance] = STATE(9671),
    [sym_macro] = STATE(9671),
    [sym_postulate] = STATE(9671),
    [sym_primitive] = STATE(9671),
    [sym_open] = STATE(9671),
    [sym_import] = STATE(9671),
    [sym_module_macro] = STATE(9671),
    [sym_module] = STATE(9671),
    [sym_syntax] = STATE(9671),
    [sym_pattern] = STATE(9671),
    [sym_unquote_decl] = STATE(9671),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(118),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(131),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
    [sym__indent] = ACTIONS(161),
  },
  [52] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration_block] = STATE(10718),
    [sym__declaration] = STATE(9671),
    [sym_fields] = STATE(9671),
    [sym_function] = STATE(9671),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9671),
    [sym_data_signature] = STATE(9671),
    [sym_record] = STATE(9671),
    [sym_record_signature] = STATE(9671),
    [sym_infix] = STATE(9671),
    [sym_generalize] = STATE(9671),
    [sym_mutual] = STATE(9671),
    [sym_abstract] = STATE(9671),
    [sym_private] = STATE(9671),
    [sym_instance] = STATE(9671),
    [sym_macro] = STATE(9671),
    [sym_postulate] = STATE(9671),
    [sym_primitive] = STATE(9671),
    [sym_open] = STATE(9671),
    [sym_import] = STATE(9671),
    [sym_module_macro] = STATE(9671),
    [sym_module] = STATE(9671),
    [sym_syntax] = STATE(9671),
    [sym_pattern] = STATE(9671),
    [sym_unquote_decl] = STATE(9671),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(118),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(131),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
    [sym__indent] = ACTIONS(161),
  },
  [53] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration_block] = STATE(11201),
    [sym__declaration] = STATE(9671),
    [sym_fields] = STATE(9671),
    [sym_function] = STATE(9671),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9671),
    [sym_data_signature] = STATE(9671),
    [sym_record] = STATE(9671),
    [sym_record_signature] = STATE(9671),
    [sym_infix] = STATE(9671),
    [sym_generalize] = STATE(9671),
    [sym_mutual] = STATE(9671),
    [sym_abstract] = STATE(9671),
    [sym_private] = STATE(9671),
    [sym_instance] = STATE(9671),
    [sym_macro] = STATE(9671),
    [sym_postulate] = STATE(9671),
    [sym_primitive] = STATE(9671),
    [sym_open] = STATE(9671),
    [sym_import] = STATE(9671),
    [sym_module_macro] = STATE(9671),
    [sym_module] = STATE(9671),
    [sym_syntax] = STATE(9671),
    [sym_pattern] = STATE(9671),
    [sym_unquote_decl] = STATE(9671),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(118),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(131),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
    [sym__indent] = ACTIONS(161),
  },
  [54] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration_block] = STATE(10756),
    [sym__declaration] = STATE(9671),
    [sym_fields] = STATE(9671),
    [sym_function] = STATE(9671),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9671),
    [sym_data_signature] = STATE(9671),
    [sym_record] = STATE(9671),
    [sym_record_signature] = STATE(9671),
    [sym_infix] = STATE(9671),
    [sym_generalize] = STATE(9671),
    [sym_mutual] = STATE(9671),
    [sym_abstract] = STATE(9671),
    [sym_private] = STATE(9671),
    [sym_instance] = STATE(9671),
    [sym_macro] = STATE(9671),
    [sym_postulate] = STATE(9671),
    [sym_primitive] = STATE(9671),
    [sym_open] = STATE(9671),
    [sym_import] = STATE(9671),
    [sym_module_macro] = STATE(9671),
    [sym_module] = STATE(9671),
    [sym_syntax] = STATE(9671),
    [sym_pattern] = STATE(9671),
    [sym_unquote_decl] = STATE(9671),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(118),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(131),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
    [sym__indent] = ACTIONS(161),
  },
  [55] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration_block] = STATE(11926),
    [sym__declaration] = STATE(9671),
    [sym_fields] = STATE(9671),
    [sym_function] = STATE(9671),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9671),
    [sym_data_signature] = STATE(9671),
    [sym_record] = STATE(9671),
    [sym_record_signature] = STATE(9671),
    [sym_infix] = STATE(9671),
    [sym_generalize] = STATE(9671),
    [sym_mutual] = STATE(9671),
    [sym_abstract] = STATE(9671),
    [sym_private] = STATE(9671),
    [sym_instance] = STATE(9671),
    [sym_macro] = STATE(9671),
    [sym_postulate] = STATE(9671),
    [sym_primitive] = STATE(9671),
    [sym_open] = STATE(9671),
    [sym_import] = STATE(9671),
    [sym_module_macro] = STATE(9671),
    [sym_module] = STATE(9671),
    [sym_syntax] = STATE(9671),
    [sym_pattern] = STATE(9671),
    [sym_unquote_decl] = STATE(9671),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(118),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(131),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
    [sym__indent] = ACTIONS(161),
  },
  [56] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration_block] = STATE(12363),
    [sym__declaration] = STATE(9671),
    [sym_fields] = STATE(9671),
    [sym_function] = STATE(9671),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9671),
    [sym_data_signature] = STATE(9671),
    [sym_record] = STATE(9671),
    [sym_record_signature] = STATE(9671),
    [sym_infix] = STATE(9671),
    [sym_generalize] = STATE(9671),
    [sym_mutual] = STATE(9671),
    [sym_abstract] = STATE(9671),
    [sym_private] = STATE(9671),
    [sym_instance] = STATE(9671),
    [sym_macro] = STATE(9671),
    [sym_postulate] = STATE(9671),
    [sym_primitive] = STATE(9671),
    [sym_open] = STATE(9671),
    [sym_import] = STATE(9671),
    [sym_module_macro] = STATE(9671),
    [sym_module] = STATE(9671),
    [sym_syntax] = STATE(9671),
    [sym_pattern] = STATE(9671),
    [sym_unquote_decl] = STATE(9671),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(118),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(131),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
    [sym__indent] = ACTIONS(161),
  },
  [57] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration_block] = STATE(10960),
    [sym__declaration] = STATE(9671),
    [sym_fields] = STATE(9671),
    [sym_function] = STATE(9671),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9671),
    [sym_data_signature] = STATE(9671),
    [sym_record] = STATE(9671),
    [sym_record_signature] = STATE(9671),
    [sym_infix] = STATE(9671),
    [sym_generalize] = STATE(9671),
    [sym_mutual] = STATE(9671),
    [sym_abstract] = STATE(9671),
    [sym_private] = STATE(9671),
    [sym_instance] = STATE(9671),
    [sym_macro] = STATE(9671),
    [sym_postulate] = STATE(9671),
    [sym_primitive] = STATE(9671),
    [sym_open] = STATE(9671),
    [sym_import] = STATE(9671),
    [sym_module_macro] = STATE(9671),
    [sym_module] = STATE(9671),
    [sym_syntax] = STATE(9671),
    [sym_pattern] = STATE(9671),
    [sym_unquote_decl] = STATE(9671),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(118),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(131),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
    [sym__indent] = ACTIONS(161),
  },
  [58] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration_block] = STATE(10298),
    [sym__declaration] = STATE(9671),
    [sym_fields] = STATE(9671),
    [sym_function] = STATE(9671),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9671),
    [sym_data_signature] = STATE(9671),
    [sym_record] = STATE(9671),
    [sym_record_signature] = STATE(9671),
    [sym_infix] = STATE(9671),
    [sym_generalize] = STATE(9671),
    [sym_mutual] = STATE(9671),
    [sym_abstract] = STATE(9671),
    [sym_private] = STATE(9671),
    [sym_instance] = STATE(9671),
    [sym_macro] = STATE(9671),
    [sym_postulate] = STATE(9671),
    [sym_primitive] = STATE(9671),
    [sym_open] = STATE(9671),
    [sym_import] = STATE(9671),
    [sym_module_macro] = STATE(9671),
    [sym_module] = STATE(9671),
    [sym_syntax] = STATE(9671),
    [sym_pattern] = STATE(9671),
    [sym_unquote_decl] = STATE(9671),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(118),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(131),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
    [sym__indent] = ACTIONS(161),
  },
  [59] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration_block] = STATE(11282),
    [sym__declaration] = STATE(9671),
    [sym_fields] = STATE(9671),
    [sym_function] = STATE(9671),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9671),
    [sym_data_signature] = STATE(9671),
    [sym_record] = STATE(9671),
    [sym_record_signature] = STATE(9671),
    [sym_infix] = STATE(9671),
    [sym_generalize] = STATE(9671),
    [sym_mutual] = STATE(9671),
    [sym_abstract] = STATE(9671),
    [sym_private] = STATE(9671),
    [sym_instance] = STATE(9671),
    [sym_macro] = STATE(9671),
    [sym_postulate] = STATE(9671),
    [sym_primitive] = STATE(9671),
    [sym_open] = STATE(9671),
    [sym_import] = STATE(9671),
    [sym_module_macro] = STATE(9671),
    [sym_module] = STATE(9671),
    [sym_syntax] = STATE(9671),
    [sym_pattern] = STATE(9671),
    [sym_unquote_decl] = STATE(9671),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(118),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(131),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
    [sym__indent] = ACTIONS(161),
  },
  [60] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration_block] = STATE(11453),
    [sym__declaration] = STATE(9671),
    [sym_fields] = STATE(9671),
    [sym_function] = STATE(9671),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9671),
    [sym_data_signature] = STATE(9671),
    [sym_record] = STATE(9671),
    [sym_record_signature] = STATE(9671),
    [sym_infix] = STATE(9671),
    [sym_generalize] = STATE(9671),
    [sym_mutual] = STATE(9671),
    [sym_abstract] = STATE(9671),
    [sym_private] = STATE(9671),
    [sym_instance] = STATE(9671),
    [sym_macro] = STATE(9671),
    [sym_postulate] = STATE(9671),
    [sym_primitive] = STATE(9671),
    [sym_open] = STATE(9671),
    [sym_import] = STATE(9671),
    [sym_module_macro] = STATE(9671),
    [sym_module] = STATE(9671),
    [sym_syntax] = STATE(9671),
    [sym_pattern] = STATE(9671),
    [sym_unquote_decl] = STATE(9671),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(118),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(131),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
    [sym__indent] = ACTIONS(161),
  },
  [61] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration_block] = STATE(11125),
    [sym__declaration] = STATE(9671),
    [sym_fields] = STATE(9671),
    [sym_function] = STATE(9671),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9671),
    [sym_data_signature] = STATE(9671),
    [sym_record] = STATE(9671),
    [sym_record_signature] = STATE(9671),
    [sym_infix] = STATE(9671),
    [sym_generalize] = STATE(9671),
    [sym_mutual] = STATE(9671),
    [sym_abstract] = STATE(9671),
    [sym_private] = STATE(9671),
    [sym_instance] = STATE(9671),
    [sym_macro] = STATE(9671),
    [sym_postulate] = STATE(9671),
    [sym_primitive] = STATE(9671),
    [sym_open] = STATE(9671),
    [sym_import] = STATE(9671),
    [sym_module_macro] = STATE(9671),
    [sym_module] = STATE(9671),
    [sym_syntax] = STATE(9671),
    [sym_pattern] = STATE(9671),
    [sym_unquote_decl] = STATE(9671),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(118),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(131),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
    [sym__indent] = ACTIONS(161),
  },
  [62] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9637),
    [sym_fields] = STATE(9637),
    [sym_function] = STATE(9637),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9637),
    [sym_data_signature] = STATE(9637),
    [sym_record] = STATE(9637),
    [sym_record_signature] = STATE(9637),
    [sym_infix] = STATE(9637),
    [sym_generalize] = STATE(9637),
    [sym_mutual] = STATE(9637),
    [sym_abstract] = STATE(9637),
    [sym_private] = STATE(9637),
    [sym_instance] = STATE(9637),
    [sym_macro] = STATE(9637),
    [sym_postulate] = STATE(9637),
    [sym_primitive] = STATE(9637),
    [sym_open] = STATE(9637),
    [sym_import] = STATE(9637),
    [sym_module_macro] = STATE(9637),
    [sym_module] = STATE(9637),
    [sym_syntax] = STATE(9637),
    [sym_pattern] = STATE(9637),
    [sym_unquote_decl] = STATE(9637),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(218),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(163),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
    [sym__indent] = ACTIONS(165),
  },
  [63] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9689),
    [sym_fields] = STATE(9689),
    [sym_function] = STATE(9689),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9689),
    [sym_data_signature] = STATE(9689),
    [sym_record] = STATE(9689),
    [sym_record_signature] = STATE(9689),
    [sym_infix] = STATE(9689),
    [sym_generalize] = STATE(9689),
    [sym_mutual] = STATE(9689),
    [sym_abstract] = STATE(9689),
    [sym_private] = STATE(9689),
    [sym_instance] = STATE(9689),
    [sym_macro] = STATE(9689),
    [sym_postulate] = STATE(9689),
    [sym_primitive] = STATE(9689),
    [sym_open] = STATE(9689),
    [sym_import] = STATE(9689),
    [sym_module_macro] = STATE(9689),
    [sym_module] = STATE(9689),
    [sym_syntax] = STATE(9689),
    [sym_pattern] = STATE(9689),
    [sym_unquote_decl] = STATE(9689),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(167),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(167),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
    [sym__indent] = ACTIONS(169),
  },
  [64] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9643),
    [sym_fields] = STATE(9643),
    [sym_function] = STATE(9643),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9643),
    [sym_data_signature] = STATE(9643),
    [sym_record] = STATE(9643),
    [sym_record_signature] = STATE(9643),
    [sym_infix] = STATE(9643),
    [sym_generalize] = STATE(9643),
    [sym_mutual] = STATE(9643),
    [sym_abstract] = STATE(9643),
    [sym_private] = STATE(9643),
    [sym_instance] = STATE(9643),
    [sym_macro] = STATE(9643),
    [sym_postulate] = STATE(9643),
    [sym_primitive] = STATE(9643),
    [sym_open] = STATE(9643),
    [sym_import] = STATE(9643),
    [sym_module_macro] = STATE(9643),
    [sym_module] = STATE(9643),
    [sym_syntax] = STATE(9643),
    [sym_pattern] = STATE(9643),
    [sym_unquote_decl] = STATE(9643),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(178),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(171),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
    [sym__indent] = ACTIONS(173),
  },
  [65] = {
    [sym__FORALL] = STATE(8288),
    [sym__LAMBDA] = STATE(8114),
    [sym__ELLIPSIS] = STATE(4608),
    [sym__declaration] = STATE(11579),
    [sym_fields] = STATE(11579),
    [sym_function] = STATE(11579),
    [sym_lhs_decl] = STATE(9175),
    [sym_lhs_defn] = STATE(9174),
    [sym_data] = STATE(11579),
    [sym_data_signature] = STATE(11579),
    [sym_record] = STATE(11579),
    [sym_record_signature] = STATE(11579),
    [sym_infix] = STATE(11579),
    [sym_generalize] = STATE(11579),
    [sym_mutual] = STATE(11579),
    [sym_abstract] = STATE(11579),
    [sym_private] = STATE(11579),
    [sym_instance] = STATE(11579),
    [sym_macro] = STATE(11579),
    [sym_postulate] = STATE(11579),
    [sym_primitive] = STATE(11579),
    [sym_open] = STATE(11579),
    [sym_import] = STATE(11579),
    [sym_module_macro] = STATE(11579),
    [sym_module] = STATE(11579),
    [sym_syntax] = STATE(11579),
    [sym_pattern] = STATE(11579),
    [sym_unquote_decl] = STATE(11579),
    [sym__qid] = STATE(4608),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3129),
    [sym__with_exprs] = STATE(8953),
    [sym__expr_or_attr] = STATE(4608),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4600),
    [aux_sym__atoms] = STATE(3848),
    [sym__atom_curly] = STATE(4564),
    [sym__atom_no_curly] = STATE(4564),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4608),
    [sym_field_assignments] = STATE(4608),
    [sym_literal] = STATE(4608),
    [sym_SetN] = STATE(4608),
    [aux_sym_source_file_repeat1] = STATE(92),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3710),
    [sym_id] = ACTIONS(9),
    [anon_sym_forall] = ACTIONS(11),
    [anon_sym_u2200] = ACTIONS(11),
    [anon_sym_BSLASH] = ACTIONS(13),
    [anon_sym_u03bb] = ACTIONS(15),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(17),
    [anon_sym_u2026] = ACTIONS(17),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(23),
    [anon_sym_data] = ACTIONS(25),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(29),
    [anon_sym_infix] = ACTIONS(31),
    [anon_sym_infixl] = ACTIONS(31),
    [anon_sym_infixr] = ACTIONS(31),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(47),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(51),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(53),
    [anon_sym_u2983] = ACTIONS(55),
    [anon_sym__] = ACTIONS(17),
    [sym_pragma] = ACTIONS(99),
    [anon_sym_syntax] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_pattern] = ACTIONS(63),
    [anon_sym_unquoteDecl] = ACTIONS(65),
    [anon_sym_unquoteDef] = ACTIONS(67),
    [aux_sym__qid_token1] = ACTIONS(69),
    [anon_sym_DOT] = ACTIONS(71),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(75),
    [anon_sym_tactic] = ACTIONS(77),
    [anon_sym_Prop] = ACTIONS(17),
    [anon_sym_quote] = ACTIONS(17),
    [anon_sym_quoteTerm] = ACTIONS(17),
    [anon_sym_quoteContext] = ACTIONS(17),
    [anon_sym_unquote] = ACTIONS(17),
    [anon_sym_LPAREN_PIPE] = ACTIONS(79),
    [anon_sym_u2987] = ACTIONS(81),
    [anon_sym_let] = ACTIONS(83),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(87),
    [aux_sym_string_token1] = ACTIONS(87),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(89),
    [sym_PropN] = ACTIONS(17),
    [sym__dedent] = ACTIONS(175),
  },
  [66] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9492),
    [sym_fields] = STATE(9492),
    [sym_function] = STATE(9492),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9492),
    [sym_data_signature] = STATE(9492),
    [sym_record] = STATE(9492),
    [sym_record_signature] = STATE(9492),
    [sym_infix] = STATE(9492),
    [sym_generalize] = STATE(9492),
    [sym_mutual] = STATE(9492),
    [sym_abstract] = STATE(9492),
    [sym_private] = STATE(9492),
    [sym_instance] = STATE(9492),
    [sym_macro] = STATE(9492),
    [sym_postulate] = STATE(9492),
    [sym_primitive] = STATE(9492),
    [sym_open] = STATE(9492),
    [sym_import] = STATE(9492),
    [sym_module_macro] = STATE(9492),
    [sym_module] = STATE(9492),
    [sym_syntax] = STATE(9492),
    [sym_pattern] = STATE(9492),
    [sym_unquote_decl] = STATE(9492),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(255),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(177),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
    [sym__indent] = ACTIONS(179),
  },
  [67] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9491),
    [sym_fields] = STATE(9491),
    [sym_function] = STATE(9491),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9491),
    [sym_data_signature] = STATE(9491),
    [sym_record] = STATE(9491),
    [sym_record_signature] = STATE(9491),
    [sym_infix] = STATE(9491),
    [sym_generalize] = STATE(9491),
    [sym_mutual] = STATE(9491),
    [sym_abstract] = STATE(9491),
    [sym_private] = STATE(9491),
    [sym_instance] = STATE(9491),
    [sym_macro] = STATE(9491),
    [sym_postulate] = STATE(9491),
    [sym_primitive] = STATE(9491),
    [sym_open] = STATE(9491),
    [sym_import] = STATE(9491),
    [sym_module_macro] = STATE(9491),
    [sym_module] = STATE(9491),
    [sym_syntax] = STATE(9491),
    [sym_pattern] = STATE(9491),
    [sym_unquote_decl] = STATE(9491),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(257),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(181),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
    [sym__indent] = ACTIONS(183),
  },
  [68] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9671),
    [sym_fields] = STATE(9671),
    [sym_function] = STATE(9671),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9671),
    [sym_data_signature] = STATE(9671),
    [sym_record] = STATE(9671),
    [sym_record_signature] = STATE(9671),
    [sym_infix] = STATE(9671),
    [sym_generalize] = STATE(9671),
    [sym_mutual] = STATE(9671),
    [sym_abstract] = STATE(9671),
    [sym_private] = STATE(9671),
    [sym_instance] = STATE(9671),
    [sym_macro] = STATE(9671),
    [sym_postulate] = STATE(9671),
    [sym_primitive] = STATE(9671),
    [sym_open] = STATE(9671),
    [sym_import] = STATE(9671),
    [sym_module_macro] = STATE(9671),
    [sym_module] = STATE(9671),
    [sym_syntax] = STATE(9671),
    [sym_pattern] = STATE(9671),
    [sym_unquote_decl] = STATE(9671),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(118),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(131),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
    [sym__indent] = ACTIONS(185),
  },
  [69] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9661),
    [sym_fields] = STATE(9661),
    [sym_function] = STATE(9661),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9661),
    [sym_data_signature] = STATE(9661),
    [sym_record] = STATE(9661),
    [sym_record_signature] = STATE(9661),
    [sym_infix] = STATE(9661),
    [sym_generalize] = STATE(9661),
    [sym_mutual] = STATE(9661),
    [sym_abstract] = STATE(9661),
    [sym_private] = STATE(9661),
    [sym_instance] = STATE(9661),
    [sym_macro] = STATE(9661),
    [sym_postulate] = STATE(9661),
    [sym_primitive] = STATE(9661),
    [sym_open] = STATE(9661),
    [sym_import] = STATE(9661),
    [sym_module_macro] = STATE(9661),
    [sym_module] = STATE(9661),
    [sym_syntax] = STATE(9661),
    [sym_pattern] = STATE(9661),
    [sym_unquote_decl] = STATE(9661),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(184),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(187),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
    [sym__indent] = ACTIONS(189),
  },
  [70] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9528),
    [sym_fields] = STATE(9528),
    [sym_function] = STATE(9528),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9528),
    [sym_data_signature] = STATE(9528),
    [sym_record] = STATE(9528),
    [sym_record_signature] = STATE(9528),
    [sym_infix] = STATE(9528),
    [sym_generalize] = STATE(9528),
    [sym_mutual] = STATE(9528),
    [sym_abstract] = STATE(9528),
    [sym_private] = STATE(9528),
    [sym_instance] = STATE(9528),
    [sym_macro] = STATE(9528),
    [sym_postulate] = STATE(9528),
    [sym_primitive] = STATE(9528),
    [sym_open] = STATE(9528),
    [sym_import] = STATE(9528),
    [sym_module_macro] = STATE(9528),
    [sym_module] = STATE(9528),
    [sym_syntax] = STATE(9528),
    [sym_pattern] = STATE(9528),
    [sym_unquote_decl] = STATE(9528),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(172),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(191),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
    [sym__indent] = ACTIONS(193),
  },
  [71] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9622),
    [sym_fields] = STATE(9622),
    [sym_function] = STATE(9622),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9622),
    [sym_data_signature] = STATE(9622),
    [sym_record] = STATE(9622),
    [sym_record_signature] = STATE(9622),
    [sym_infix] = STATE(9622),
    [sym_generalize] = STATE(9622),
    [sym_mutual] = STATE(9622),
    [sym_abstract] = STATE(9622),
    [sym_private] = STATE(9622),
    [sym_instance] = STATE(9622),
    [sym_macro] = STATE(9622),
    [sym_postulate] = STATE(9622),
    [sym_primitive] = STATE(9622),
    [sym_open] = STATE(9622),
    [sym_import] = STATE(9622),
    [sym_module_macro] = STATE(9622),
    [sym_module] = STATE(9622),
    [sym_syntax] = STATE(9622),
    [sym_pattern] = STATE(9622),
    [sym_unquote_decl] = STATE(9622),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(170),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(195),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
    [sym__indent] = ACTIONS(197),
  },
  [72] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9542),
    [sym_fields] = STATE(9542),
    [sym_function] = STATE(9542),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9542),
    [sym_data_signature] = STATE(9542),
    [sym_record] = STATE(9542),
    [sym_record_signature] = STATE(9542),
    [sym_infix] = STATE(9542),
    [sym_generalize] = STATE(9542),
    [sym_mutual] = STATE(9542),
    [sym_abstract] = STATE(9542),
    [sym_private] = STATE(9542),
    [sym_instance] = STATE(9542),
    [sym_macro] = STATE(9542),
    [sym_postulate] = STATE(9542),
    [sym_primitive] = STATE(9542),
    [sym_open] = STATE(9542),
    [sym_import] = STATE(9542),
    [sym_module_macro] = STATE(9542),
    [sym_module] = STATE(9542),
    [sym_syntax] = STATE(9542),
    [sym_pattern] = STATE(9542),
    [sym_unquote_decl] = STATE(9542),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(188),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(199),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
    [sym__indent] = ACTIONS(201),
  },
  [73] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9612),
    [sym_fields] = STATE(9612),
    [sym_function] = STATE(9612),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9612),
    [sym_data_signature] = STATE(9612),
    [sym_record] = STATE(9612),
    [sym_record_signature] = STATE(9612),
    [sym_infix] = STATE(9612),
    [sym_generalize] = STATE(9612),
    [sym_mutual] = STATE(9612),
    [sym_abstract] = STATE(9612),
    [sym_private] = STATE(9612),
    [sym_instance] = STATE(9612),
    [sym_macro] = STATE(9612),
    [sym_postulate] = STATE(9612),
    [sym_primitive] = STATE(9612),
    [sym_open] = STATE(9612),
    [sym_import] = STATE(9612),
    [sym_module_macro] = STATE(9612),
    [sym_module] = STATE(9612),
    [sym_syntax] = STATE(9612),
    [sym_pattern] = STATE(9612),
    [sym_unquote_decl] = STATE(9612),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(195),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(203),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
    [sym__indent] = ACTIONS(205),
  },
  [74] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9684),
    [sym_fields] = STATE(9684),
    [sym_function] = STATE(9684),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9684),
    [sym_data_signature] = STATE(9684),
    [sym_record] = STATE(9684),
    [sym_record_signature] = STATE(9684),
    [sym_infix] = STATE(9684),
    [sym_generalize] = STATE(9684),
    [sym_mutual] = STATE(9684),
    [sym_abstract] = STATE(9684),
    [sym_private] = STATE(9684),
    [sym_instance] = STATE(9684),
    [sym_macro] = STATE(9684),
    [sym_postulate] = STATE(9684),
    [sym_primitive] = STATE(9684),
    [sym_open] = STATE(9684),
    [sym_import] = STATE(9684),
    [sym_module_macro] = STATE(9684),
    [sym_module] = STATE(9684),
    [sym_syntax] = STATE(9684),
    [sym_pattern] = STATE(9684),
    [sym_unquote_decl] = STATE(9684),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(189),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(207),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
    [sym__indent] = ACTIONS(209),
  },
  [75] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9683),
    [sym_fields] = STATE(9683),
    [sym_function] = STATE(9683),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9683),
    [sym_data_signature] = STATE(9683),
    [sym_record] = STATE(9683),
    [sym_record_signature] = STATE(9683),
    [sym_infix] = STATE(9683),
    [sym_generalize] = STATE(9683),
    [sym_mutual] = STATE(9683),
    [sym_abstract] = STATE(9683),
    [sym_private] = STATE(9683),
    [sym_instance] = STATE(9683),
    [sym_macro] = STATE(9683),
    [sym_postulate] = STATE(9683),
    [sym_primitive] = STATE(9683),
    [sym_open] = STATE(9683),
    [sym_import] = STATE(9683),
    [sym_module_macro] = STATE(9683),
    [sym_module] = STATE(9683),
    [sym_syntax] = STATE(9683),
    [sym_pattern] = STATE(9683),
    [sym_unquote_decl] = STATE(9683),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(196),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(211),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
    [sym__indent] = ACTIONS(213),
  },
  [76] = {
    [sym__FORALL] = STATE(8288),
    [sym__LAMBDA] = STATE(8114),
    [sym__ELLIPSIS] = STATE(4608),
    [sym__declaration] = STATE(11579),
    [sym_fields] = STATE(11579),
    [sym_function] = STATE(11579),
    [sym_lhs_decl] = STATE(9175),
    [sym_lhs_defn] = STATE(9174),
    [sym_data] = STATE(11579),
    [sym_data_signature] = STATE(11579),
    [sym_record] = STATE(11579),
    [sym_record_signature] = STATE(11579),
    [sym_infix] = STATE(11579),
    [sym_generalize] = STATE(11579),
    [sym_mutual] = STATE(11579),
    [sym_abstract] = STATE(11579),
    [sym_private] = STATE(11579),
    [sym_instance] = STATE(11579),
    [sym_macro] = STATE(11579),
    [sym_postulate] = STATE(11579),
    [sym_primitive] = STATE(11579),
    [sym_open] = STATE(11579),
    [sym_import] = STATE(11579),
    [sym_module_macro] = STATE(11579),
    [sym_module] = STATE(11579),
    [sym_syntax] = STATE(11579),
    [sym_pattern] = STATE(11579),
    [sym_unquote_decl] = STATE(11579),
    [sym__qid] = STATE(4608),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3129),
    [sym__with_exprs] = STATE(8953),
    [sym__expr_or_attr] = STATE(4608),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4600),
    [aux_sym__atoms] = STATE(3848),
    [sym__atom_curly] = STATE(4564),
    [sym__atom_no_curly] = STATE(4564),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4608),
    [sym_field_assignments] = STATE(4608),
    [sym_literal] = STATE(4608),
    [sym_SetN] = STATE(4608),
    [aux_sym_source_file_repeat1] = STATE(92),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3710),
    [sym_id] = ACTIONS(9),
    [anon_sym_forall] = ACTIONS(11),
    [anon_sym_u2200] = ACTIONS(11),
    [anon_sym_BSLASH] = ACTIONS(13),
    [anon_sym_u03bb] = ACTIONS(15),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(17),
    [anon_sym_u2026] = ACTIONS(17),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(23),
    [anon_sym_data] = ACTIONS(25),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(29),
    [anon_sym_infix] = ACTIONS(31),
    [anon_sym_infixl] = ACTIONS(31),
    [anon_sym_infixr] = ACTIONS(31),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(47),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(51),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(53),
    [anon_sym_u2983] = ACTIONS(55),
    [anon_sym__] = ACTIONS(17),
    [sym_pragma] = ACTIONS(99),
    [anon_sym_syntax] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_pattern] = ACTIONS(63),
    [anon_sym_unquoteDecl] = ACTIONS(65),
    [anon_sym_unquoteDef] = ACTIONS(67),
    [aux_sym__qid_token1] = ACTIONS(69),
    [anon_sym_DOT] = ACTIONS(71),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(75),
    [anon_sym_tactic] = ACTIONS(77),
    [anon_sym_Prop] = ACTIONS(17),
    [anon_sym_quote] = ACTIONS(17),
    [anon_sym_quoteTerm] = ACTIONS(17),
    [anon_sym_quoteContext] = ACTIONS(17),
    [anon_sym_unquote] = ACTIONS(17),
    [anon_sym_LPAREN_PIPE] = ACTIONS(79),
    [anon_sym_u2987] = ACTIONS(81),
    [anon_sym_let] = ACTIONS(83),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(87),
    [aux_sym_string_token1] = ACTIONS(87),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(89),
    [sym_PropN] = ACTIONS(17),
    [sym__dedent] = ACTIONS(215),
  },
  [77] = {
    [sym__FORALL] = STATE(8288),
    [sym__LAMBDA] = STATE(8114),
    [sym__ELLIPSIS] = STATE(4608),
    [sym__declaration] = STATE(12794),
    [sym_fields] = STATE(12794),
    [sym_function] = STATE(12794),
    [sym_lhs_decl] = STATE(9175),
    [sym_lhs_defn] = STATE(9174),
    [sym_data] = STATE(12794),
    [sym_data_signature] = STATE(12794),
    [sym_record] = STATE(12794),
    [sym_record_signature] = STATE(12794),
    [sym_infix] = STATE(12794),
    [sym_generalize] = STATE(12794),
    [sym_mutual] = STATE(12794),
    [sym_abstract] = STATE(12794),
    [sym_private] = STATE(12794),
    [sym_instance] = STATE(12794),
    [sym_macro] = STATE(12794),
    [sym_postulate] = STATE(12794),
    [sym_primitive] = STATE(12794),
    [sym_open] = STATE(12794),
    [sym_import] = STATE(12794),
    [sym_module_macro] = STATE(12794),
    [sym_module] = STATE(12794),
    [sym_syntax] = STATE(12794),
    [sym_pattern] = STATE(12794),
    [sym_unquote_decl] = STATE(12794),
    [sym__qid] = STATE(4608),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3129),
    [sym__with_exprs] = STATE(8953),
    [sym__expr_or_attr] = STATE(4608),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4600),
    [aux_sym__atoms] = STATE(3848),
    [sym__atom_curly] = STATE(4564),
    [sym__atom_no_curly] = STATE(4564),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4608),
    [sym_field_assignments] = STATE(4608),
    [sym_literal] = STATE(4608),
    [sym_SetN] = STATE(4608),
    [aux_sym_source_file_repeat1] = STATE(95),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3710),
    [ts_builtin_sym_end] = ACTIONS(217),
    [sym_id] = ACTIONS(9),
    [anon_sym_forall] = ACTIONS(11),
    [anon_sym_u2200] = ACTIONS(11),
    [anon_sym_BSLASH] = ACTIONS(13),
    [anon_sym_u03bb] = ACTIONS(15),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(17),
    [anon_sym_u2026] = ACTIONS(17),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(23),
    [anon_sym_data] = ACTIONS(25),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(29),
    [anon_sym_infix] = ACTIONS(31),
    [anon_sym_infixl] = ACTIONS(31),
    [anon_sym_infixr] = ACTIONS(31),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(47),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(51),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(53),
    [anon_sym_u2983] = ACTIONS(55),
    [anon_sym__] = ACTIONS(17),
    [sym_pragma] = ACTIONS(57),
    [anon_sym_syntax] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_pattern] = ACTIONS(63),
    [anon_sym_unquoteDecl] = ACTIONS(65),
    [anon_sym_unquoteDef] = ACTIONS(67),
    [aux_sym__qid_token1] = ACTIONS(69),
    [anon_sym_DOT] = ACTIONS(71),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(75),
    [anon_sym_tactic] = ACTIONS(77),
    [anon_sym_Prop] = ACTIONS(17),
    [anon_sym_quote] = ACTIONS(17),
    [anon_sym_quoteTerm] = ACTIONS(17),
    [anon_sym_quoteContext] = ACTIONS(17),
    [anon_sym_unquote] = ACTIONS(17),
    [anon_sym_LPAREN_PIPE] = ACTIONS(79),
    [anon_sym_u2987] = ACTIONS(81),
    [anon_sym_let] = ACTIONS(83),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(87),
    [aux_sym_string_token1] = ACTIONS(87),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(89),
    [sym_PropN] = ACTIONS(17),
  },
  [78] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9508),
    [sym_fields] = STATE(9508),
    [sym_function] = STATE(9508),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9508),
    [sym_data_signature] = STATE(9508),
    [sym_record] = STATE(9508),
    [sym_record_signature] = STATE(9508),
    [sym_infix] = STATE(9508),
    [sym_generalize] = STATE(9508),
    [sym_mutual] = STATE(9508),
    [sym_abstract] = STATE(9508),
    [sym_private] = STATE(9508),
    [sym_instance] = STATE(9508),
    [sym_macro] = STATE(9508),
    [sym_postulate] = STATE(9508),
    [sym_primitive] = STATE(9508),
    [sym_open] = STATE(9508),
    [sym_import] = STATE(9508),
    [sym_module_macro] = STATE(9508),
    [sym_module] = STATE(9508),
    [sym_syntax] = STATE(9508),
    [sym_pattern] = STATE(9508),
    [sym_unquote_decl] = STATE(9508),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(210),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(219),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
    [sym__indent] = ACTIONS(221),
  },
  [79] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9532),
    [sym_fields] = STATE(9532),
    [sym_function] = STATE(9532),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9532),
    [sym_data_signature] = STATE(9532),
    [sym_record] = STATE(9532),
    [sym_record_signature] = STATE(9532),
    [sym_infix] = STATE(9532),
    [sym_generalize] = STATE(9532),
    [sym_mutual] = STATE(9532),
    [sym_abstract] = STATE(9532),
    [sym_private] = STATE(9532),
    [sym_instance] = STATE(9532),
    [sym_macro] = STATE(9532),
    [sym_postulate] = STATE(9532),
    [sym_primitive] = STATE(9532),
    [sym_open] = STATE(9532),
    [sym_import] = STATE(9532),
    [sym_module_macro] = STATE(9532),
    [sym_module] = STATE(9532),
    [sym_syntax] = STATE(9532),
    [sym_pattern] = STATE(9532),
    [sym_unquote_decl] = STATE(9532),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(92),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(223),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
    [sym__dedent] = ACTIONS(225),
  },
  [80] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9681),
    [sym_fields] = STATE(9681),
    [sym_function] = STATE(9681),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9681),
    [sym_data_signature] = STATE(9681),
    [sym_record] = STATE(9681),
    [sym_record_signature] = STATE(9681),
    [sym_infix] = STATE(9681),
    [sym_generalize] = STATE(9681),
    [sym_mutual] = STATE(9681),
    [sym_abstract] = STATE(9681),
    [sym_private] = STATE(9681),
    [sym_instance] = STATE(9681),
    [sym_macro] = STATE(9681),
    [sym_postulate] = STATE(9681),
    [sym_primitive] = STATE(9681),
    [sym_open] = STATE(9681),
    [sym_import] = STATE(9681),
    [sym_module_macro] = STATE(9681),
    [sym_module] = STATE(9681),
    [sym_syntax] = STATE(9681),
    [sym_pattern] = STATE(9681),
    [sym_unquote_decl] = STATE(9681),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(147),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(227),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
    [sym__indent] = ACTIONS(229),
  },
  [81] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9575),
    [sym_fields] = STATE(9575),
    [sym_function] = STATE(9575),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9575),
    [sym_data_signature] = STATE(9575),
    [sym_record] = STATE(9575),
    [sym_record_signature] = STATE(9575),
    [sym_infix] = STATE(9575),
    [sym_generalize] = STATE(9575),
    [sym_mutual] = STATE(9575),
    [sym_abstract] = STATE(9575),
    [sym_private] = STATE(9575),
    [sym_instance] = STATE(9575),
    [sym_macro] = STATE(9575),
    [sym_postulate] = STATE(9575),
    [sym_primitive] = STATE(9575),
    [sym_open] = STATE(9575),
    [sym_import] = STATE(9575),
    [sym_module_macro] = STATE(9575),
    [sym_module] = STATE(9575),
    [sym_syntax] = STATE(9575),
    [sym_pattern] = STATE(9575),
    [sym_unquote_decl] = STATE(9575),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(215),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(231),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
    [sym__indent] = ACTIONS(233),
  },
  [82] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9603),
    [sym_fields] = STATE(9603),
    [sym_function] = STATE(9603),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9603),
    [sym_data_signature] = STATE(9603),
    [sym_record] = STATE(9603),
    [sym_record_signature] = STATE(9603),
    [sym_infix] = STATE(9603),
    [sym_generalize] = STATE(9603),
    [sym_mutual] = STATE(9603),
    [sym_abstract] = STATE(9603),
    [sym_private] = STATE(9603),
    [sym_instance] = STATE(9603),
    [sym_macro] = STATE(9603),
    [sym_postulate] = STATE(9603),
    [sym_primitive] = STATE(9603),
    [sym_open] = STATE(9603),
    [sym_import] = STATE(9603),
    [sym_module_macro] = STATE(9603),
    [sym_module] = STATE(9603),
    [sym_syntax] = STATE(9603),
    [sym_pattern] = STATE(9603),
    [sym_unquote_decl] = STATE(9603),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(156),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(235),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
    [sym__indent] = ACTIONS(237),
  },
  [83] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9609),
    [sym_fields] = STATE(9609),
    [sym_function] = STATE(9609),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9609),
    [sym_data_signature] = STATE(9609),
    [sym_record] = STATE(9609),
    [sym_record_signature] = STATE(9609),
    [sym_infix] = STATE(9609),
    [sym_generalize] = STATE(9609),
    [sym_mutual] = STATE(9609),
    [sym_abstract] = STATE(9609),
    [sym_private] = STATE(9609),
    [sym_instance] = STATE(9609),
    [sym_macro] = STATE(9609),
    [sym_postulate] = STATE(9609),
    [sym_primitive] = STATE(9609),
    [sym_open] = STATE(9609),
    [sym_import] = STATE(9609),
    [sym_module_macro] = STATE(9609),
    [sym_module] = STATE(9609),
    [sym_syntax] = STATE(9609),
    [sym_pattern] = STATE(9609),
    [sym_unquote_decl] = STATE(9609),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(206),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(239),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
    [sym__indent] = ACTIONS(241),
  },
  [84] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9535),
    [sym_fields] = STATE(9535),
    [sym_function] = STATE(9535),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9535),
    [sym_data_signature] = STATE(9535),
    [sym_record] = STATE(9535),
    [sym_record_signature] = STATE(9535),
    [sym_infix] = STATE(9535),
    [sym_generalize] = STATE(9535),
    [sym_mutual] = STATE(9535),
    [sym_abstract] = STATE(9535),
    [sym_private] = STATE(9535),
    [sym_instance] = STATE(9535),
    [sym_macro] = STATE(9535),
    [sym_postulate] = STATE(9535),
    [sym_primitive] = STATE(9535),
    [sym_open] = STATE(9535),
    [sym_import] = STATE(9535),
    [sym_module_macro] = STATE(9535),
    [sym_module] = STATE(9535),
    [sym_syntax] = STATE(9535),
    [sym_pattern] = STATE(9535),
    [sym_unquote_decl] = STATE(9535),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(169),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(243),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
    [sym__indent] = ACTIONS(245),
  },
  [85] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9562),
    [sym_fields] = STATE(9562),
    [sym_function] = STATE(9562),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9562),
    [sym_data_signature] = STATE(9562),
    [sym_record] = STATE(9562),
    [sym_record_signature] = STATE(9562),
    [sym_infix] = STATE(9562),
    [sym_generalize] = STATE(9562),
    [sym_mutual] = STATE(9562),
    [sym_abstract] = STATE(9562),
    [sym_private] = STATE(9562),
    [sym_instance] = STATE(9562),
    [sym_macro] = STATE(9562),
    [sym_postulate] = STATE(9562),
    [sym_primitive] = STATE(9562),
    [sym_open] = STATE(9562),
    [sym_import] = STATE(9562),
    [sym_module_macro] = STATE(9562),
    [sym_module] = STATE(9562),
    [sym_syntax] = STATE(9562),
    [sym_pattern] = STATE(9562),
    [sym_unquote_decl] = STATE(9562),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(130),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(247),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
    [sym__indent] = ACTIONS(249),
  },
  [86] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9588),
    [sym_fields] = STATE(9588),
    [sym_function] = STATE(9588),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9588),
    [sym_data_signature] = STATE(9588),
    [sym_record] = STATE(9588),
    [sym_record_signature] = STATE(9588),
    [sym_infix] = STATE(9588),
    [sym_generalize] = STATE(9588),
    [sym_mutual] = STATE(9588),
    [sym_abstract] = STATE(9588),
    [sym_private] = STATE(9588),
    [sym_instance] = STATE(9588),
    [sym_macro] = STATE(9588),
    [sym_postulate] = STATE(9588),
    [sym_primitive] = STATE(9588),
    [sym_open] = STATE(9588),
    [sym_import] = STATE(9588),
    [sym_module_macro] = STATE(9588),
    [sym_module] = STATE(9588),
    [sym_syntax] = STATE(9588),
    [sym_pattern] = STATE(9588),
    [sym_unquote_decl] = STATE(9588),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(216),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(251),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
    [sym__indent] = ACTIONS(253),
  },
  [87] = {
    [sym__FORALL] = STATE(8288),
    [sym__LAMBDA] = STATE(8114),
    [sym__ELLIPSIS] = STATE(4608),
    [sym__declaration] = STATE(11579),
    [sym_fields] = STATE(11579),
    [sym_function] = STATE(11579),
    [sym_lhs_decl] = STATE(9175),
    [sym_lhs_defn] = STATE(9174),
    [sym_data] = STATE(11579),
    [sym_data_signature] = STATE(11579),
    [sym_record] = STATE(11579),
    [sym_record_signature] = STATE(11579),
    [sym_infix] = STATE(11579),
    [sym_generalize] = STATE(11579),
    [sym_mutual] = STATE(11579),
    [sym_abstract] = STATE(11579),
    [sym_private] = STATE(11579),
    [sym_instance] = STATE(11579),
    [sym_macro] = STATE(11579),
    [sym_postulate] = STATE(11579),
    [sym_primitive] = STATE(11579),
    [sym_open] = STATE(11579),
    [sym_import] = STATE(11579),
    [sym_module_macro] = STATE(11579),
    [sym_module] = STATE(11579),
    [sym_syntax] = STATE(11579),
    [sym_pattern] = STATE(11579),
    [sym_unquote_decl] = STATE(11579),
    [sym__qid] = STATE(4608),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3129),
    [sym__with_exprs] = STATE(8953),
    [sym__expr_or_attr] = STATE(4608),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4600),
    [aux_sym__atoms] = STATE(3848),
    [sym__atom_curly] = STATE(4564),
    [sym__atom_no_curly] = STATE(4564),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4608),
    [sym_field_assignments] = STATE(4608),
    [sym_literal] = STATE(4608),
    [sym_SetN] = STATE(4608),
    [aux_sym_source_file_repeat1] = STATE(92),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3710),
    [sym_id] = ACTIONS(9),
    [anon_sym_forall] = ACTIONS(11),
    [anon_sym_u2200] = ACTIONS(11),
    [anon_sym_BSLASH] = ACTIONS(13),
    [anon_sym_u03bb] = ACTIONS(15),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(17),
    [anon_sym_u2026] = ACTIONS(17),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(23),
    [anon_sym_data] = ACTIONS(25),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(29),
    [anon_sym_infix] = ACTIONS(31),
    [anon_sym_infixl] = ACTIONS(31),
    [anon_sym_infixr] = ACTIONS(31),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(47),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(51),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(53),
    [anon_sym_u2983] = ACTIONS(55),
    [anon_sym__] = ACTIONS(17),
    [sym_pragma] = ACTIONS(99),
    [anon_sym_syntax] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_pattern] = ACTIONS(63),
    [anon_sym_unquoteDecl] = ACTIONS(65),
    [anon_sym_unquoteDef] = ACTIONS(67),
    [aux_sym__qid_token1] = ACTIONS(69),
    [anon_sym_DOT] = ACTIONS(71),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(75),
    [anon_sym_tactic] = ACTIONS(77),
    [anon_sym_Prop] = ACTIONS(17),
    [anon_sym_quote] = ACTIONS(17),
    [anon_sym_quoteTerm] = ACTIONS(17),
    [anon_sym_quoteContext] = ACTIONS(17),
    [anon_sym_unquote] = ACTIONS(17),
    [anon_sym_LPAREN_PIPE] = ACTIONS(79),
    [anon_sym_u2987] = ACTIONS(81),
    [anon_sym_let] = ACTIONS(83),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(87),
    [aux_sym_string_token1] = ACTIONS(87),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(89),
    [sym_PropN] = ACTIONS(17),
    [sym__dedent] = ACTIONS(103),
  },
  [88] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9639),
    [sym_fields] = STATE(9639),
    [sym_function] = STATE(9639),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9639),
    [sym_data_signature] = STATE(9639),
    [sym_record] = STATE(9639),
    [sym_record_signature] = STATE(9639),
    [sym_infix] = STATE(9639),
    [sym_generalize] = STATE(9639),
    [sym_mutual] = STATE(9639),
    [sym_abstract] = STATE(9639),
    [sym_private] = STATE(9639),
    [sym_instance] = STATE(9639),
    [sym_macro] = STATE(9639),
    [sym_postulate] = STATE(9639),
    [sym_primitive] = STATE(9639),
    [sym_open] = STATE(9639),
    [sym_import] = STATE(9639),
    [sym_module_macro] = STATE(9639),
    [sym_module] = STATE(9639),
    [sym_syntax] = STATE(9639),
    [sym_pattern] = STATE(9639),
    [sym_unquote_decl] = STATE(9639),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(199),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(255),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
    [sym__indent] = ACTIONS(257),
  },
  [89] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9659),
    [sym_fields] = STATE(9659),
    [sym_function] = STATE(9659),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9659),
    [sym_data_signature] = STATE(9659),
    [sym_record] = STATE(9659),
    [sym_record_signature] = STATE(9659),
    [sym_infix] = STATE(9659),
    [sym_generalize] = STATE(9659),
    [sym_mutual] = STATE(9659),
    [sym_abstract] = STATE(9659),
    [sym_private] = STATE(9659),
    [sym_instance] = STATE(9659),
    [sym_macro] = STATE(9659),
    [sym_postulate] = STATE(9659),
    [sym_primitive] = STATE(9659),
    [sym_open] = STATE(9659),
    [sym_import] = STATE(9659),
    [sym_module_macro] = STATE(9659),
    [sym_module] = STATE(9659),
    [sym_syntax] = STATE(9659),
    [sym_pattern] = STATE(9659),
    [sym_unquote_decl] = STATE(9659),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(200),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(259),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
    [sym__indent] = ACTIONS(261),
  },
  [90] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9526),
    [sym_fields] = STATE(9526),
    [sym_function] = STATE(9526),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9526),
    [sym_data_signature] = STATE(9526),
    [sym_record] = STATE(9526),
    [sym_record_signature] = STATE(9526),
    [sym_infix] = STATE(9526),
    [sym_generalize] = STATE(9526),
    [sym_mutual] = STATE(9526),
    [sym_abstract] = STATE(9526),
    [sym_private] = STATE(9526),
    [sym_instance] = STATE(9526),
    [sym_macro] = STATE(9526),
    [sym_postulate] = STATE(9526),
    [sym_primitive] = STATE(9526),
    [sym_open] = STATE(9526),
    [sym_import] = STATE(9526),
    [sym_module_macro] = STATE(9526),
    [sym_module] = STATE(9526),
    [sym_syntax] = STATE(9526),
    [sym_pattern] = STATE(9526),
    [sym_unquote_decl] = STATE(9526),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(223),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(263),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
    [sym__indent] = ACTIONS(265),
  },
  [91] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9625),
    [sym_fields] = STATE(9625),
    [sym_function] = STATE(9625),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9625),
    [sym_data_signature] = STATE(9625),
    [sym_record] = STATE(9625),
    [sym_record_signature] = STATE(9625),
    [sym_infix] = STATE(9625),
    [sym_generalize] = STATE(9625),
    [sym_mutual] = STATE(9625),
    [sym_abstract] = STATE(9625),
    [sym_private] = STATE(9625),
    [sym_instance] = STATE(9625),
    [sym_macro] = STATE(9625),
    [sym_postulate] = STATE(9625),
    [sym_primitive] = STATE(9625),
    [sym_open] = STATE(9625),
    [sym_import] = STATE(9625),
    [sym_module_macro] = STATE(9625),
    [sym_module] = STATE(9625),
    [sym_syntax] = STATE(9625),
    [sym_pattern] = STATE(9625),
    [sym_unquote_decl] = STATE(9625),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(221),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(267),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
    [sym__indent] = ACTIONS(269),
  },
  [92] = {
    [sym__FORALL] = STATE(8288),
    [sym__LAMBDA] = STATE(8114),
    [sym__ELLIPSIS] = STATE(4608),
    [sym__declaration] = STATE(11579),
    [sym_fields] = STATE(11579),
    [sym_function] = STATE(11579),
    [sym_lhs_decl] = STATE(9175),
    [sym_lhs_defn] = STATE(9174),
    [sym_data] = STATE(11579),
    [sym_data_signature] = STATE(11579),
    [sym_record] = STATE(11579),
    [sym_record_signature] = STATE(11579),
    [sym_infix] = STATE(11579),
    [sym_generalize] = STATE(11579),
    [sym_mutual] = STATE(11579),
    [sym_abstract] = STATE(11579),
    [sym_private] = STATE(11579),
    [sym_instance] = STATE(11579),
    [sym_macro] = STATE(11579),
    [sym_postulate] = STATE(11579),
    [sym_primitive] = STATE(11579),
    [sym_open] = STATE(11579),
    [sym_import] = STATE(11579),
    [sym_module_macro] = STATE(11579),
    [sym_module] = STATE(11579),
    [sym_syntax] = STATE(11579),
    [sym_pattern] = STATE(11579),
    [sym_unquote_decl] = STATE(11579),
    [sym__qid] = STATE(4608),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3129),
    [sym__with_exprs] = STATE(8953),
    [sym__expr_or_attr] = STATE(4608),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4600),
    [aux_sym__atoms] = STATE(3848),
    [sym__atom_curly] = STATE(4564),
    [sym__atom_no_curly] = STATE(4564),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4608),
    [sym_field_assignments] = STATE(4608),
    [sym_literal] = STATE(4608),
    [sym_SetN] = STATE(4608),
    [aux_sym_source_file_repeat1] = STATE(92),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3710),
    [sym_id] = ACTIONS(271),
    [anon_sym_forall] = ACTIONS(274),
    [anon_sym_u2200] = ACTIONS(274),
    [anon_sym_BSLASH] = ACTIONS(277),
    [anon_sym_u03bb] = ACTIONS(280),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(283),
    [anon_sym_u2026] = ACTIONS(283),
    [anon_sym_field] = ACTIONS(286),
    [anon_sym_instance] = ACTIONS(289),
    [anon_sym_module] = ACTIONS(292),
    [anon_sym_data] = ACTIONS(295),
    [anon_sym_codata] = ACTIONS(298),
    [anon_sym_record] = ACTIONS(301),
    [anon_sym_infix] = ACTIONS(304),
    [anon_sym_infixl] = ACTIONS(304),
    [anon_sym_infixr] = ACTIONS(304),
    [anon_sym_variable] = ACTIONS(307),
    [anon_sym_mutual] = ACTIONS(310),
    [anon_sym_abstract] = ACTIONS(313),
    [anon_sym_private] = ACTIONS(316),
    [anon_sym_macro] = ACTIONS(319),
    [anon_sym_postulate] = ACTIONS(322),
    [anon_sym_primitive] = ACTIONS(325),
    [anon_sym_open] = ACTIONS(328),
    [anon_sym_import] = ACTIONS(331),
    [anon_sym_LPAREN] = ACTIONS(334),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(337),
    [anon_sym_u2983] = ACTIONS(340),
    [anon_sym__] = ACTIONS(283),
    [sym_pragma] = ACTIONS(343),
    [anon_sym_syntax] = ACTIONS(346),
    [anon_sym_LBRACE] = ACTIONS(349),
    [anon_sym_pattern] = ACTIONS(352),
    [anon_sym_unquoteDecl] = ACTIONS(355),
    [anon_sym_unquoteDef] = ACTIONS(358),
    [aux_sym__qid_token1] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(364),
    [anon_sym_AT] = ACTIONS(367),
    [anon_sym_quoteGoal] = ACTIONS(370),
    [anon_sym_tactic] = ACTIONS(373),
    [anon_sym_Prop] = ACTIONS(283),
    [anon_sym_quote] = ACTIONS(283),
    [anon_sym_quoteTerm] = ACTIONS(283),
    [anon_sym_quoteContext] = ACTIONS(283),
    [anon_sym_unquote] = ACTIONS(283),
    [anon_sym_LPAREN_PIPE] = ACTIONS(376),
    [anon_sym_u2987] = ACTIONS(379),
    [anon_sym_let] = ACTIONS(382),
    [anon_sym_do] = ACTIONS(385),
    [aux_sym_integer_token1] = ACTIONS(388),
    [aux_sym_string_token1] = ACTIONS(388),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(391),
    [sym_PropN] = ACTIONS(283),
    [sym__dedent] = ACTIONS(394),
  },
  [93] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9644),
    [sym_fields] = STATE(9644),
    [sym_function] = STATE(9644),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9644),
    [sym_data_signature] = STATE(9644),
    [sym_record] = STATE(9644),
    [sym_record_signature] = STATE(9644),
    [sym_infix] = STATE(9644),
    [sym_generalize] = STATE(9644),
    [sym_mutual] = STATE(9644),
    [sym_abstract] = STATE(9644),
    [sym_private] = STATE(9644),
    [sym_instance] = STATE(9644),
    [sym_macro] = STATE(9644),
    [sym_postulate] = STATE(9644),
    [sym_primitive] = STATE(9644),
    [sym_open] = STATE(9644),
    [sym_import] = STATE(9644),
    [sym_module_macro] = STATE(9644),
    [sym_module] = STATE(9644),
    [sym_syntax] = STATE(9644),
    [sym_pattern] = STATE(9644),
    [sym_unquote_decl] = STATE(9644),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(140),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(396),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
    [sym__indent] = ACTIONS(398),
  },
  [94] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9567),
    [sym_fields] = STATE(9567),
    [sym_function] = STATE(9567),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9567),
    [sym_data_signature] = STATE(9567),
    [sym_record] = STATE(9567),
    [sym_record_signature] = STATE(9567),
    [sym_infix] = STATE(9567),
    [sym_generalize] = STATE(9567),
    [sym_mutual] = STATE(9567),
    [sym_abstract] = STATE(9567),
    [sym_private] = STATE(9567),
    [sym_instance] = STATE(9567),
    [sym_macro] = STATE(9567),
    [sym_postulate] = STATE(9567),
    [sym_primitive] = STATE(9567),
    [sym_open] = STATE(9567),
    [sym_import] = STATE(9567),
    [sym_module_macro] = STATE(9567),
    [sym_module] = STATE(9567),
    [sym_syntax] = STATE(9567),
    [sym_pattern] = STATE(9567),
    [sym_unquote_decl] = STATE(9567),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(120),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(400),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
    [sym__indent] = ACTIONS(402),
  },
  [95] = {
    [sym__FORALL] = STATE(8288),
    [sym__LAMBDA] = STATE(8114),
    [sym__ELLIPSIS] = STATE(4608),
    [sym__declaration] = STATE(12794),
    [sym_fields] = STATE(12794),
    [sym_function] = STATE(12794),
    [sym_lhs_decl] = STATE(9175),
    [sym_lhs_defn] = STATE(9174),
    [sym_data] = STATE(12794),
    [sym_data_signature] = STATE(12794),
    [sym_record] = STATE(12794),
    [sym_record_signature] = STATE(12794),
    [sym_infix] = STATE(12794),
    [sym_generalize] = STATE(12794),
    [sym_mutual] = STATE(12794),
    [sym_abstract] = STATE(12794),
    [sym_private] = STATE(12794),
    [sym_instance] = STATE(12794),
    [sym_macro] = STATE(12794),
    [sym_postulate] = STATE(12794),
    [sym_primitive] = STATE(12794),
    [sym_open] = STATE(12794),
    [sym_import] = STATE(12794),
    [sym_module_macro] = STATE(12794),
    [sym_module] = STATE(12794),
    [sym_syntax] = STATE(12794),
    [sym_pattern] = STATE(12794),
    [sym_unquote_decl] = STATE(12794),
    [sym__qid] = STATE(4608),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3129),
    [sym__with_exprs] = STATE(8953),
    [sym__expr_or_attr] = STATE(4608),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4600),
    [aux_sym__atoms] = STATE(3848),
    [sym__atom_curly] = STATE(4564),
    [sym__atom_no_curly] = STATE(4564),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4608),
    [sym_field_assignments] = STATE(4608),
    [sym_literal] = STATE(4608),
    [sym_SetN] = STATE(4608),
    [aux_sym_source_file_repeat1] = STATE(95),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3710),
    [ts_builtin_sym_end] = ACTIONS(394),
    [sym_id] = ACTIONS(271),
    [anon_sym_forall] = ACTIONS(274),
    [anon_sym_u2200] = ACTIONS(274),
    [anon_sym_BSLASH] = ACTIONS(277),
    [anon_sym_u03bb] = ACTIONS(280),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(283),
    [anon_sym_u2026] = ACTIONS(283),
    [anon_sym_field] = ACTIONS(286),
    [anon_sym_instance] = ACTIONS(289),
    [anon_sym_module] = ACTIONS(292),
    [anon_sym_data] = ACTIONS(295),
    [anon_sym_codata] = ACTIONS(298),
    [anon_sym_record] = ACTIONS(301),
    [anon_sym_infix] = ACTIONS(304),
    [anon_sym_infixl] = ACTIONS(304),
    [anon_sym_infixr] = ACTIONS(304),
    [anon_sym_variable] = ACTIONS(307),
    [anon_sym_mutual] = ACTIONS(310),
    [anon_sym_abstract] = ACTIONS(313),
    [anon_sym_private] = ACTIONS(316),
    [anon_sym_macro] = ACTIONS(319),
    [anon_sym_postulate] = ACTIONS(322),
    [anon_sym_primitive] = ACTIONS(325),
    [anon_sym_open] = ACTIONS(328),
    [anon_sym_import] = ACTIONS(331),
    [anon_sym_LPAREN] = ACTIONS(334),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(337),
    [anon_sym_u2983] = ACTIONS(340),
    [anon_sym__] = ACTIONS(283),
    [sym_pragma] = ACTIONS(404),
    [anon_sym_syntax] = ACTIONS(346),
    [anon_sym_LBRACE] = ACTIONS(349),
    [anon_sym_pattern] = ACTIONS(352),
    [anon_sym_unquoteDecl] = ACTIONS(355),
    [anon_sym_unquoteDef] = ACTIONS(358),
    [aux_sym__qid_token1] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(364),
    [anon_sym_AT] = ACTIONS(367),
    [anon_sym_quoteGoal] = ACTIONS(370),
    [anon_sym_tactic] = ACTIONS(373),
    [anon_sym_Prop] = ACTIONS(283),
    [anon_sym_quote] = ACTIONS(283),
    [anon_sym_quoteTerm] = ACTIONS(283),
    [anon_sym_quoteContext] = ACTIONS(283),
    [anon_sym_unquote] = ACTIONS(283),
    [anon_sym_LPAREN_PIPE] = ACTIONS(376),
    [anon_sym_u2987] = ACTIONS(379),
    [anon_sym_let] = ACTIONS(382),
    [anon_sym_do] = ACTIONS(385),
    [aux_sym_integer_token1] = ACTIONS(388),
    [aux_sym_string_token1] = ACTIONS(388),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(391),
    [sym_PropN] = ACTIONS(283),
  },
  [96] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9601),
    [sym_fields] = STATE(9601),
    [sym_function] = STATE(9601),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9601),
    [sym_data_signature] = STATE(9601),
    [sym_record] = STATE(9601),
    [sym_record_signature] = STATE(9601),
    [sym_infix] = STATE(9601),
    [sym_generalize] = STATE(9601),
    [sym_mutual] = STATE(9601),
    [sym_abstract] = STATE(9601),
    [sym_private] = STATE(9601),
    [sym_instance] = STATE(9601),
    [sym_macro] = STATE(9601),
    [sym_postulate] = STATE(9601),
    [sym_primitive] = STATE(9601),
    [sym_open] = STATE(9601),
    [sym_import] = STATE(9601),
    [sym_module_macro] = STATE(9601),
    [sym_module] = STATE(9601),
    [sym_syntax] = STATE(9601),
    [sym_pattern] = STATE(9601),
    [sym_unquote_decl] = STATE(9601),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(238),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(407),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
    [sym__indent] = ACTIONS(409),
  },
  [97] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9551),
    [sym_fields] = STATE(9551),
    [sym_function] = STATE(9551),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9551),
    [sym_data_signature] = STATE(9551),
    [sym_record] = STATE(9551),
    [sym_record_signature] = STATE(9551),
    [sym_infix] = STATE(9551),
    [sym_generalize] = STATE(9551),
    [sym_mutual] = STATE(9551),
    [sym_abstract] = STATE(9551),
    [sym_private] = STATE(9551),
    [sym_instance] = STATE(9551),
    [sym_macro] = STATE(9551),
    [sym_postulate] = STATE(9551),
    [sym_primitive] = STATE(9551),
    [sym_open] = STATE(9551),
    [sym_import] = STATE(9551),
    [sym_module_macro] = STATE(9551),
    [sym_module] = STATE(9551),
    [sym_syntax] = STATE(9551),
    [sym_pattern] = STATE(9551),
    [sym_unquote_decl] = STATE(9551),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(183),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(411),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
    [sym__indent] = ACTIONS(413),
  },
  [98] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9498),
    [sym_fields] = STATE(9498),
    [sym_function] = STATE(9498),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9498),
    [sym_data_signature] = STATE(9498),
    [sym_record] = STATE(9498),
    [sym_record_signature] = STATE(9498),
    [sym_infix] = STATE(9498),
    [sym_generalize] = STATE(9498),
    [sym_mutual] = STATE(9498),
    [sym_abstract] = STATE(9498),
    [sym_private] = STATE(9498),
    [sym_instance] = STATE(9498),
    [sym_macro] = STATE(9498),
    [sym_postulate] = STATE(9498),
    [sym_primitive] = STATE(9498),
    [sym_open] = STATE(9498),
    [sym_import] = STATE(9498),
    [sym_module_macro] = STATE(9498),
    [sym_module] = STATE(9498),
    [sym_syntax] = STATE(9498),
    [sym_pattern] = STATE(9498),
    [sym_unquote_decl] = STATE(9498),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(246),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(415),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
    [sym__indent] = ACTIONS(417),
  },
  [99] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9510),
    [sym_fields] = STATE(9510),
    [sym_function] = STATE(9510),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9510),
    [sym_data_signature] = STATE(9510),
    [sym_record] = STATE(9510),
    [sym_record_signature] = STATE(9510),
    [sym_infix] = STATE(9510),
    [sym_generalize] = STATE(9510),
    [sym_mutual] = STATE(9510),
    [sym_abstract] = STATE(9510),
    [sym_private] = STATE(9510),
    [sym_instance] = STATE(9510),
    [sym_macro] = STATE(9510),
    [sym_postulate] = STATE(9510),
    [sym_primitive] = STATE(9510),
    [sym_open] = STATE(9510),
    [sym_import] = STATE(9510),
    [sym_module_macro] = STATE(9510),
    [sym_module] = STATE(9510),
    [sym_syntax] = STATE(9510),
    [sym_pattern] = STATE(9510),
    [sym_unquote_decl] = STATE(9510),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(155),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(419),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
    [sym__indent] = ACTIONS(421),
  },
  [100] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9613),
    [sym_fields] = STATE(9613),
    [sym_function] = STATE(9613),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9613),
    [sym_data_signature] = STATE(9613),
    [sym_record] = STATE(9613),
    [sym_record_signature] = STATE(9613),
    [sym_infix] = STATE(9613),
    [sym_generalize] = STATE(9613),
    [sym_mutual] = STATE(9613),
    [sym_abstract] = STATE(9613),
    [sym_private] = STATE(9613),
    [sym_instance] = STATE(9613),
    [sym_macro] = STATE(9613),
    [sym_postulate] = STATE(9613),
    [sym_primitive] = STATE(9613),
    [sym_open] = STATE(9613),
    [sym_import] = STATE(9613),
    [sym_module_macro] = STATE(9613),
    [sym_module] = STATE(9613),
    [sym_syntax] = STATE(9613),
    [sym_pattern] = STATE(9613),
    [sym_unquote_decl] = STATE(9613),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(231),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(423),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
    [sym__indent] = ACTIONS(425),
  },
  [101] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9580),
    [sym_fields] = STATE(9580),
    [sym_function] = STATE(9580),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9580),
    [sym_data_signature] = STATE(9580),
    [sym_record] = STATE(9580),
    [sym_record_signature] = STATE(9580),
    [sym_infix] = STATE(9580),
    [sym_generalize] = STATE(9580),
    [sym_mutual] = STATE(9580),
    [sym_abstract] = STATE(9580),
    [sym_private] = STATE(9580),
    [sym_instance] = STATE(9580),
    [sym_macro] = STATE(9580),
    [sym_postulate] = STATE(9580),
    [sym_primitive] = STATE(9580),
    [sym_open] = STATE(9580),
    [sym_import] = STATE(9580),
    [sym_module_macro] = STATE(9580),
    [sym_module] = STATE(9580),
    [sym_syntax] = STATE(9580),
    [sym_pattern] = STATE(9580),
    [sym_unquote_decl] = STATE(9580),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(121),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(427),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
    [sym__indent] = ACTIONS(429),
  },
  [102] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9600),
    [sym_fields] = STATE(9600),
    [sym_function] = STATE(9600),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9600),
    [sym_data_signature] = STATE(9600),
    [sym_record] = STATE(9600),
    [sym_record_signature] = STATE(9600),
    [sym_infix] = STATE(9600),
    [sym_generalize] = STATE(9600),
    [sym_mutual] = STATE(9600),
    [sym_abstract] = STATE(9600),
    [sym_private] = STATE(9600),
    [sym_instance] = STATE(9600),
    [sym_macro] = STATE(9600),
    [sym_postulate] = STATE(9600),
    [sym_primitive] = STATE(9600),
    [sym_open] = STATE(9600),
    [sym_import] = STATE(9600),
    [sym_module_macro] = STATE(9600),
    [sym_module] = STATE(9600),
    [sym_syntax] = STATE(9600),
    [sym_pattern] = STATE(9600),
    [sym_unquote_decl] = STATE(9600),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(228),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(431),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
    [sym__indent] = ACTIONS(433),
  },
  [103] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9517),
    [sym_fields] = STATE(9517),
    [sym_function] = STATE(9517),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9517),
    [sym_data_signature] = STATE(9517),
    [sym_record] = STATE(9517),
    [sym_record_signature] = STATE(9517),
    [sym_infix] = STATE(9517),
    [sym_generalize] = STATE(9517),
    [sym_mutual] = STATE(9517),
    [sym_abstract] = STATE(9517),
    [sym_private] = STATE(9517),
    [sym_instance] = STATE(9517),
    [sym_macro] = STATE(9517),
    [sym_postulate] = STATE(9517),
    [sym_primitive] = STATE(9517),
    [sym_open] = STATE(9517),
    [sym_import] = STATE(9517),
    [sym_module_macro] = STATE(9517),
    [sym_module] = STATE(9517),
    [sym_syntax] = STATE(9517),
    [sym_pattern] = STATE(9517),
    [sym_unquote_decl] = STATE(9517),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(179),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(435),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
    [sym__indent] = ACTIONS(437),
  },
  [104] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9690),
    [sym_fields] = STATE(9690),
    [sym_function] = STATE(9690),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9690),
    [sym_data_signature] = STATE(9690),
    [sym_record] = STATE(9690),
    [sym_record_signature] = STATE(9690),
    [sym_infix] = STATE(9690),
    [sym_generalize] = STATE(9690),
    [sym_mutual] = STATE(9690),
    [sym_abstract] = STATE(9690),
    [sym_private] = STATE(9690),
    [sym_instance] = STATE(9690),
    [sym_macro] = STATE(9690),
    [sym_postulate] = STATE(9690),
    [sym_primitive] = STATE(9690),
    [sym_open] = STATE(9690),
    [sym_import] = STATE(9690),
    [sym_module_macro] = STATE(9690),
    [sym_module] = STATE(9690),
    [sym_syntax] = STATE(9690),
    [sym_pattern] = STATE(9690),
    [sym_unquote_decl] = STATE(9690),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(116),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(439),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
    [sym__indent] = ACTIONS(441),
  },
  [105] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9574),
    [sym_fields] = STATE(9574),
    [sym_function] = STATE(9574),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9574),
    [sym_data_signature] = STATE(9574),
    [sym_record] = STATE(9574),
    [sym_record_signature] = STATE(9574),
    [sym_infix] = STATE(9574),
    [sym_generalize] = STATE(9574),
    [sym_mutual] = STATE(9574),
    [sym_abstract] = STATE(9574),
    [sym_private] = STATE(9574),
    [sym_instance] = STATE(9574),
    [sym_macro] = STATE(9574),
    [sym_postulate] = STATE(9574),
    [sym_primitive] = STATE(9574),
    [sym_open] = STATE(9574),
    [sym_import] = STATE(9574),
    [sym_module_macro] = STATE(9574),
    [sym_module] = STATE(9574),
    [sym_syntax] = STATE(9574),
    [sym_pattern] = STATE(9574),
    [sym_unquote_decl] = STATE(9574),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(244),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(443),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
    [sym__indent] = ACTIONS(445),
  },
  [106] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9490),
    [sym_fields] = STATE(9490),
    [sym_function] = STATE(9490),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9490),
    [sym_data_signature] = STATE(9490),
    [sym_record] = STATE(9490),
    [sym_record_signature] = STATE(9490),
    [sym_infix] = STATE(9490),
    [sym_generalize] = STATE(9490),
    [sym_mutual] = STATE(9490),
    [sym_abstract] = STATE(9490),
    [sym_private] = STATE(9490),
    [sym_instance] = STATE(9490),
    [sym_macro] = STATE(9490),
    [sym_postulate] = STATE(9490),
    [sym_primitive] = STATE(9490),
    [sym_open] = STATE(9490),
    [sym_import] = STATE(9490),
    [sym_module_macro] = STATE(9490),
    [sym_module] = STATE(9490),
    [sym_syntax] = STATE(9490),
    [sym_pattern] = STATE(9490),
    [sym_unquote_decl] = STATE(9490),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(220),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(447),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
    [sym__indent] = ACTIONS(449),
  },
  [107] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9577),
    [sym_fields] = STATE(9577),
    [sym_function] = STATE(9577),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9577),
    [sym_data_signature] = STATE(9577),
    [sym_record] = STATE(9577),
    [sym_record_signature] = STATE(9577),
    [sym_infix] = STATE(9577),
    [sym_generalize] = STATE(9577),
    [sym_mutual] = STATE(9577),
    [sym_abstract] = STATE(9577),
    [sym_private] = STATE(9577),
    [sym_instance] = STATE(9577),
    [sym_macro] = STATE(9577),
    [sym_postulate] = STATE(9577),
    [sym_primitive] = STATE(9577),
    [sym_open] = STATE(9577),
    [sym_import] = STATE(9577),
    [sym_module_macro] = STATE(9577),
    [sym_module] = STATE(9577),
    [sym_syntax] = STATE(9577),
    [sym_pattern] = STATE(9577),
    [sym_unquote_decl] = STATE(9577),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(236),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(451),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
    [sym__indent] = ACTIONS(453),
  },
  [108] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9531),
    [sym_fields] = STATE(9531),
    [sym_function] = STATE(9531),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9531),
    [sym_data_signature] = STATE(9531),
    [sym_record] = STATE(9531),
    [sym_record_signature] = STATE(9531),
    [sym_infix] = STATE(9531),
    [sym_generalize] = STATE(9531),
    [sym_mutual] = STATE(9531),
    [sym_abstract] = STATE(9531),
    [sym_private] = STATE(9531),
    [sym_instance] = STATE(9531),
    [sym_macro] = STATE(9531),
    [sym_postulate] = STATE(9531),
    [sym_primitive] = STATE(9531),
    [sym_open] = STATE(9531),
    [sym_import] = STATE(9531),
    [sym_module_macro] = STATE(9531),
    [sym_module] = STATE(9531),
    [sym_syntax] = STATE(9531),
    [sym_pattern] = STATE(9531),
    [sym_unquote_decl] = STATE(9531),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(253),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(455),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
    [sym__indent] = ACTIONS(457),
  },
  [109] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9566),
    [sym_fields] = STATE(9566),
    [sym_function] = STATE(9566),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9566),
    [sym_data_signature] = STATE(9566),
    [sym_record] = STATE(9566),
    [sym_record_signature] = STATE(9566),
    [sym_infix] = STATE(9566),
    [sym_generalize] = STATE(9566),
    [sym_mutual] = STATE(9566),
    [sym_abstract] = STATE(9566),
    [sym_private] = STATE(9566),
    [sym_instance] = STATE(9566),
    [sym_macro] = STATE(9566),
    [sym_postulate] = STATE(9566),
    [sym_primitive] = STATE(9566),
    [sym_open] = STATE(9566),
    [sym_import] = STATE(9566),
    [sym_module_macro] = STATE(9566),
    [sym_module] = STATE(9566),
    [sym_syntax] = STATE(9566),
    [sym_pattern] = STATE(9566),
    [sym_unquote_decl] = STATE(9566),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(247),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(459),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
    [sym__indent] = ACTIONS(461),
  },
  [110] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9604),
    [sym_fields] = STATE(9604),
    [sym_function] = STATE(9604),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9604),
    [sym_data_signature] = STATE(9604),
    [sym_record] = STATE(9604),
    [sym_record_signature] = STATE(9604),
    [sym_infix] = STATE(9604),
    [sym_generalize] = STATE(9604),
    [sym_mutual] = STATE(9604),
    [sym_abstract] = STATE(9604),
    [sym_private] = STATE(9604),
    [sym_instance] = STATE(9604),
    [sym_macro] = STATE(9604),
    [sym_postulate] = STATE(9604),
    [sym_primitive] = STATE(9604),
    [sym_open] = STATE(9604),
    [sym_import] = STATE(9604),
    [sym_module_macro] = STATE(9604),
    [sym_module] = STATE(9604),
    [sym_syntax] = STATE(9604),
    [sym_pattern] = STATE(9604),
    [sym_unquote_decl] = STATE(9604),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(125),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(463),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
    [sym__indent] = ACTIONS(465),
  },
  [111] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9554),
    [sym_fields] = STATE(9554),
    [sym_function] = STATE(9554),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9554),
    [sym_data_signature] = STATE(9554),
    [sym_record] = STATE(9554),
    [sym_record_signature] = STATE(9554),
    [sym_infix] = STATE(9554),
    [sym_generalize] = STATE(9554),
    [sym_mutual] = STATE(9554),
    [sym_abstract] = STATE(9554),
    [sym_private] = STATE(9554),
    [sym_instance] = STATE(9554),
    [sym_macro] = STATE(9554),
    [sym_postulate] = STATE(9554),
    [sym_primitive] = STATE(9554),
    [sym_open] = STATE(9554),
    [sym_import] = STATE(9554),
    [sym_module_macro] = STATE(9554),
    [sym_module] = STATE(9554),
    [sym_syntax] = STATE(9554),
    [sym_pattern] = STATE(9554),
    [sym_unquote_decl] = STATE(9554),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(240),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(467),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
    [sym__indent] = ACTIONS(469),
  },
  [112] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9543),
    [sym_fields] = STATE(9543),
    [sym_function] = STATE(9543),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9543),
    [sym_data_signature] = STATE(9543),
    [sym_record] = STATE(9543),
    [sym_record_signature] = STATE(9543),
    [sym_infix] = STATE(9543),
    [sym_generalize] = STATE(9543),
    [sym_mutual] = STATE(9543),
    [sym_abstract] = STATE(9543),
    [sym_private] = STATE(9543),
    [sym_instance] = STATE(9543),
    [sym_macro] = STATE(9543),
    [sym_postulate] = STATE(9543),
    [sym_primitive] = STATE(9543),
    [sym_open] = STATE(9543),
    [sym_import] = STATE(9543),
    [sym_module_macro] = STATE(9543),
    [sym_module] = STATE(9543),
    [sym_syntax] = STATE(9543),
    [sym_pattern] = STATE(9543),
    [sym_unquote_decl] = STATE(9543),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(258),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(471),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
    [sym__indent] = ACTIONS(473),
  },
  [113] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9664),
    [sym_fields] = STATE(9664),
    [sym_function] = STATE(9664),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9664),
    [sym_data_signature] = STATE(9664),
    [sym_record] = STATE(9664),
    [sym_record_signature] = STATE(9664),
    [sym_infix] = STATE(9664),
    [sym_generalize] = STATE(9664),
    [sym_mutual] = STATE(9664),
    [sym_abstract] = STATE(9664),
    [sym_private] = STATE(9664),
    [sym_instance] = STATE(9664),
    [sym_macro] = STATE(9664),
    [sym_postulate] = STATE(9664),
    [sym_primitive] = STATE(9664),
    [sym_open] = STATE(9664),
    [sym_import] = STATE(9664),
    [sym_module_macro] = STATE(9664),
    [sym_module] = STATE(9664),
    [sym_syntax] = STATE(9664),
    [sym_pattern] = STATE(9664),
    [sym_unquote_decl] = STATE(9664),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(142),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(475),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
    [sym__indent] = ACTIONS(477),
  },
  [114] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9544),
    [sym_fields] = STATE(9544),
    [sym_function] = STATE(9544),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9544),
    [sym_data_signature] = STATE(9544),
    [sym_record] = STATE(9544),
    [sym_record_signature] = STATE(9544),
    [sym_infix] = STATE(9544),
    [sym_generalize] = STATE(9544),
    [sym_mutual] = STATE(9544),
    [sym_abstract] = STATE(9544),
    [sym_private] = STATE(9544),
    [sym_instance] = STATE(9544),
    [sym_macro] = STATE(9544),
    [sym_postulate] = STATE(9544),
    [sym_primitive] = STATE(9544),
    [sym_open] = STATE(9544),
    [sym_import] = STATE(9544),
    [sym_module_macro] = STATE(9544),
    [sym_module] = STATE(9544),
    [sym_syntax] = STATE(9544),
    [sym_pattern] = STATE(9544),
    [sym_unquote_decl] = STATE(9544),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(131),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(479),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
    [sym__indent] = ACTIONS(481),
  },
  [115] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9519),
    [sym_fields] = STATE(9519),
    [sym_function] = STATE(9519),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9519),
    [sym_data_signature] = STATE(9519),
    [sym_record] = STATE(9519),
    [sym_record_signature] = STATE(9519),
    [sym_infix] = STATE(9519),
    [sym_generalize] = STATE(9519),
    [sym_mutual] = STATE(9519),
    [sym_abstract] = STATE(9519),
    [sym_private] = STATE(9519),
    [sym_instance] = STATE(9519),
    [sym_macro] = STATE(9519),
    [sym_postulate] = STATE(9519),
    [sym_primitive] = STATE(9519),
    [sym_open] = STATE(9519),
    [sym_import] = STATE(9519),
    [sym_module_macro] = STATE(9519),
    [sym_module] = STATE(9519),
    [sym_syntax] = STATE(9519),
    [sym_pattern] = STATE(9519),
    [sym_unquote_decl] = STATE(9519),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(248),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(483),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
    [sym__indent] = ACTIONS(485),
  },
  [116] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9660),
    [sym_fields] = STATE(9660),
    [sym_function] = STATE(9660),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9660),
    [sym_data_signature] = STATE(9660),
    [sym_record] = STATE(9660),
    [sym_record_signature] = STATE(9660),
    [sym_infix] = STATE(9660),
    [sym_generalize] = STATE(9660),
    [sym_mutual] = STATE(9660),
    [sym_abstract] = STATE(9660),
    [sym_private] = STATE(9660),
    [sym_instance] = STATE(9660),
    [sym_macro] = STATE(9660),
    [sym_postulate] = STATE(9660),
    [sym_primitive] = STATE(9660),
    [sym_open] = STATE(9660),
    [sym_import] = STATE(9660),
    [sym_module_macro] = STATE(9660),
    [sym_module] = STATE(9660),
    [sym_syntax] = STATE(9660),
    [sym_pattern] = STATE(9660),
    [sym_unquote_decl] = STATE(9660),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(162),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(487),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
  },
  [117] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9669),
    [sym_fields] = STATE(9669),
    [sym_function] = STATE(9669),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9669),
    [sym_data_signature] = STATE(9669),
    [sym_record] = STATE(9669),
    [sym_record_signature] = STATE(9669),
    [sym_infix] = STATE(9669),
    [sym_generalize] = STATE(9669),
    [sym_mutual] = STATE(9669),
    [sym_abstract] = STATE(9669),
    [sym_private] = STATE(9669),
    [sym_instance] = STATE(9669),
    [sym_macro] = STATE(9669),
    [sym_postulate] = STATE(9669),
    [sym_primitive] = STATE(9669),
    [sym_open] = STATE(9669),
    [sym_import] = STATE(9669),
    [sym_module_macro] = STATE(9669),
    [sym_module] = STATE(9669),
    [sym_syntax] = STATE(9669),
    [sym_pattern] = STATE(9669),
    [sym_unquote_decl] = STATE(9669),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(162),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(489),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
  },
  [118] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9674),
    [sym_fields] = STATE(9674),
    [sym_function] = STATE(9674),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9674),
    [sym_data_signature] = STATE(9674),
    [sym_record] = STATE(9674),
    [sym_record_signature] = STATE(9674),
    [sym_infix] = STATE(9674),
    [sym_generalize] = STATE(9674),
    [sym_mutual] = STATE(9674),
    [sym_abstract] = STATE(9674),
    [sym_private] = STATE(9674),
    [sym_instance] = STATE(9674),
    [sym_macro] = STATE(9674),
    [sym_postulate] = STATE(9674),
    [sym_primitive] = STATE(9674),
    [sym_open] = STATE(9674),
    [sym_import] = STATE(9674),
    [sym_module_macro] = STATE(9674),
    [sym_module] = STATE(9674),
    [sym_syntax] = STATE(9674),
    [sym_pattern] = STATE(9674),
    [sym_unquote_decl] = STATE(9674),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(162),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(491),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
  },
  [119] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9568),
    [sym_fields] = STATE(9568),
    [sym_function] = STATE(9568),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9568),
    [sym_data_signature] = STATE(9568),
    [sym_record] = STATE(9568),
    [sym_record_signature] = STATE(9568),
    [sym_infix] = STATE(9568),
    [sym_generalize] = STATE(9568),
    [sym_mutual] = STATE(9568),
    [sym_abstract] = STATE(9568),
    [sym_private] = STATE(9568),
    [sym_instance] = STATE(9568),
    [sym_macro] = STATE(9568),
    [sym_postulate] = STATE(9568),
    [sym_primitive] = STATE(9568),
    [sym_open] = STATE(9568),
    [sym_import] = STATE(9568),
    [sym_module_macro] = STATE(9568),
    [sym_module] = STATE(9568),
    [sym_syntax] = STATE(9568),
    [sym_pattern] = STATE(9568),
    [sym_unquote_decl] = STATE(9568),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(160),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(493),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
  },
  [120] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9568),
    [sym_fields] = STATE(9568),
    [sym_function] = STATE(9568),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9568),
    [sym_data_signature] = STATE(9568),
    [sym_record] = STATE(9568),
    [sym_record_signature] = STATE(9568),
    [sym_infix] = STATE(9568),
    [sym_generalize] = STATE(9568),
    [sym_mutual] = STATE(9568),
    [sym_abstract] = STATE(9568),
    [sym_private] = STATE(9568),
    [sym_instance] = STATE(9568),
    [sym_macro] = STATE(9568),
    [sym_postulate] = STATE(9568),
    [sym_primitive] = STATE(9568),
    [sym_open] = STATE(9568),
    [sym_import] = STATE(9568),
    [sym_module_macro] = STATE(9568),
    [sym_module] = STATE(9568),
    [sym_syntax] = STATE(9568),
    [sym_pattern] = STATE(9568),
    [sym_unquote_decl] = STATE(9568),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(162),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(493),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
  },
  [121] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9576),
    [sym_fields] = STATE(9576),
    [sym_function] = STATE(9576),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9576),
    [sym_data_signature] = STATE(9576),
    [sym_record] = STATE(9576),
    [sym_record_signature] = STATE(9576),
    [sym_infix] = STATE(9576),
    [sym_generalize] = STATE(9576),
    [sym_mutual] = STATE(9576),
    [sym_abstract] = STATE(9576),
    [sym_private] = STATE(9576),
    [sym_instance] = STATE(9576),
    [sym_macro] = STATE(9576),
    [sym_postulate] = STATE(9576),
    [sym_primitive] = STATE(9576),
    [sym_open] = STATE(9576),
    [sym_import] = STATE(9576),
    [sym_module_macro] = STATE(9576),
    [sym_module] = STATE(9576),
    [sym_syntax] = STATE(9576),
    [sym_pattern] = STATE(9576),
    [sym_unquote_decl] = STATE(9576),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(162),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(495),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
  },
  [122] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9592),
    [sym_fields] = STATE(9592),
    [sym_function] = STATE(9592),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9592),
    [sym_data_signature] = STATE(9592),
    [sym_record] = STATE(9592),
    [sym_record_signature] = STATE(9592),
    [sym_infix] = STATE(9592),
    [sym_generalize] = STATE(9592),
    [sym_mutual] = STATE(9592),
    [sym_abstract] = STATE(9592),
    [sym_private] = STATE(9592),
    [sym_instance] = STATE(9592),
    [sym_macro] = STATE(9592),
    [sym_postulate] = STATE(9592),
    [sym_primitive] = STATE(9592),
    [sym_open] = STATE(9592),
    [sym_import] = STATE(9592),
    [sym_module_macro] = STATE(9592),
    [sym_module] = STATE(9592),
    [sym_syntax] = STATE(9592),
    [sym_pattern] = STATE(9592),
    [sym_unquote_decl] = STATE(9592),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(145),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(497),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
  },
  [123] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9500),
    [sym_fields] = STATE(9500),
    [sym_function] = STATE(9500),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9500),
    [sym_data_signature] = STATE(9500),
    [sym_record] = STATE(9500),
    [sym_record_signature] = STATE(9500),
    [sym_infix] = STATE(9500),
    [sym_generalize] = STATE(9500),
    [sym_mutual] = STATE(9500),
    [sym_abstract] = STATE(9500),
    [sym_private] = STATE(9500),
    [sym_instance] = STATE(9500),
    [sym_macro] = STATE(9500),
    [sym_postulate] = STATE(9500),
    [sym_primitive] = STATE(9500),
    [sym_open] = STATE(9500),
    [sym_import] = STATE(9500),
    [sym_module_macro] = STATE(9500),
    [sym_module] = STATE(9500),
    [sym_syntax] = STATE(9500),
    [sym_pattern] = STATE(9500),
    [sym_unquote_decl] = STATE(9500),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(162),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(499),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
  },
  [124] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9494),
    [sym_fields] = STATE(9494),
    [sym_function] = STATE(9494),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9494),
    [sym_data_signature] = STATE(9494),
    [sym_record] = STATE(9494),
    [sym_record_signature] = STATE(9494),
    [sym_infix] = STATE(9494),
    [sym_generalize] = STATE(9494),
    [sym_mutual] = STATE(9494),
    [sym_abstract] = STATE(9494),
    [sym_private] = STATE(9494),
    [sym_instance] = STATE(9494),
    [sym_macro] = STATE(9494),
    [sym_postulate] = STATE(9494),
    [sym_primitive] = STATE(9494),
    [sym_open] = STATE(9494),
    [sym_import] = STATE(9494),
    [sym_module_macro] = STATE(9494),
    [sym_module] = STATE(9494),
    [sym_syntax] = STATE(9494),
    [sym_pattern] = STATE(9494),
    [sym_unquote_decl] = STATE(9494),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(162),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(501),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
  },
  [125] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9592),
    [sym_fields] = STATE(9592),
    [sym_function] = STATE(9592),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9592),
    [sym_data_signature] = STATE(9592),
    [sym_record] = STATE(9592),
    [sym_record_signature] = STATE(9592),
    [sym_infix] = STATE(9592),
    [sym_generalize] = STATE(9592),
    [sym_mutual] = STATE(9592),
    [sym_abstract] = STATE(9592),
    [sym_private] = STATE(9592),
    [sym_instance] = STATE(9592),
    [sym_macro] = STATE(9592),
    [sym_postulate] = STATE(9592),
    [sym_primitive] = STATE(9592),
    [sym_open] = STATE(9592),
    [sym_import] = STATE(9592),
    [sym_module_macro] = STATE(9592),
    [sym_module] = STATE(9592),
    [sym_syntax] = STATE(9592),
    [sym_pattern] = STATE(9592),
    [sym_unquote_decl] = STATE(9592),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(162),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(497),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
  },
  [126] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9547),
    [sym_fields] = STATE(9547),
    [sym_function] = STATE(9547),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9547),
    [sym_data_signature] = STATE(9547),
    [sym_record] = STATE(9547),
    [sym_record_signature] = STATE(9547),
    [sym_infix] = STATE(9547),
    [sym_generalize] = STATE(9547),
    [sym_mutual] = STATE(9547),
    [sym_abstract] = STATE(9547),
    [sym_private] = STATE(9547),
    [sym_instance] = STATE(9547),
    [sym_macro] = STATE(9547),
    [sym_postulate] = STATE(9547),
    [sym_primitive] = STATE(9547),
    [sym_open] = STATE(9547),
    [sym_import] = STATE(9547),
    [sym_module_macro] = STATE(9547),
    [sym_module] = STATE(9547),
    [sym_syntax] = STATE(9547),
    [sym_pattern] = STATE(9547),
    [sym_unquote_decl] = STATE(9547),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(162),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(503),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
  },
  [127] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9576),
    [sym_fields] = STATE(9576),
    [sym_function] = STATE(9576),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9576),
    [sym_data_signature] = STATE(9576),
    [sym_record] = STATE(9576),
    [sym_record_signature] = STATE(9576),
    [sym_infix] = STATE(9576),
    [sym_generalize] = STATE(9576),
    [sym_mutual] = STATE(9576),
    [sym_abstract] = STATE(9576),
    [sym_private] = STATE(9576),
    [sym_instance] = STATE(9576),
    [sym_macro] = STATE(9576),
    [sym_postulate] = STATE(9576),
    [sym_primitive] = STATE(9576),
    [sym_open] = STATE(9576),
    [sym_import] = STATE(9576),
    [sym_module_macro] = STATE(9576),
    [sym_module] = STATE(9576),
    [sym_syntax] = STATE(9576),
    [sym_pattern] = STATE(9576),
    [sym_unquote_decl] = STATE(9576),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(211),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(495),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
  },
  [128] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9539),
    [sym_fields] = STATE(9539),
    [sym_function] = STATE(9539),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9539),
    [sym_data_signature] = STATE(9539),
    [sym_record] = STATE(9539),
    [sym_record_signature] = STATE(9539),
    [sym_infix] = STATE(9539),
    [sym_generalize] = STATE(9539),
    [sym_mutual] = STATE(9539),
    [sym_abstract] = STATE(9539),
    [sym_private] = STATE(9539),
    [sym_instance] = STATE(9539),
    [sym_macro] = STATE(9539),
    [sym_postulate] = STATE(9539),
    [sym_primitive] = STATE(9539),
    [sym_open] = STATE(9539),
    [sym_import] = STATE(9539),
    [sym_module_macro] = STATE(9539),
    [sym_module] = STATE(9539),
    [sym_syntax] = STATE(9539),
    [sym_pattern] = STATE(9539),
    [sym_unquote_decl] = STATE(9539),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(209),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(505),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
  },
  [129] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9658),
    [sym_fields] = STATE(9658),
    [sym_function] = STATE(9658),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9658),
    [sym_data_signature] = STATE(9658),
    [sym_record] = STATE(9658),
    [sym_record_signature] = STATE(9658),
    [sym_infix] = STATE(9658),
    [sym_generalize] = STATE(9658),
    [sym_mutual] = STATE(9658),
    [sym_abstract] = STATE(9658),
    [sym_private] = STATE(9658),
    [sym_instance] = STATE(9658),
    [sym_macro] = STATE(9658),
    [sym_postulate] = STATE(9658),
    [sym_primitive] = STATE(9658),
    [sym_open] = STATE(9658),
    [sym_import] = STATE(9658),
    [sym_module_macro] = STATE(9658),
    [sym_module] = STATE(9658),
    [sym_syntax] = STATE(9658),
    [sym_pattern] = STATE(9658),
    [sym_unquote_decl] = STATE(9658),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(161),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(507),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
  },
  [130] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9628),
    [sym_fields] = STATE(9628),
    [sym_function] = STATE(9628),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9628),
    [sym_data_signature] = STATE(9628),
    [sym_record] = STATE(9628),
    [sym_record_signature] = STATE(9628),
    [sym_infix] = STATE(9628),
    [sym_generalize] = STATE(9628),
    [sym_mutual] = STATE(9628),
    [sym_abstract] = STATE(9628),
    [sym_private] = STATE(9628),
    [sym_instance] = STATE(9628),
    [sym_macro] = STATE(9628),
    [sym_postulate] = STATE(9628),
    [sym_primitive] = STATE(9628),
    [sym_open] = STATE(9628),
    [sym_import] = STATE(9628),
    [sym_module_macro] = STATE(9628),
    [sym_module] = STATE(9628),
    [sym_syntax] = STATE(9628),
    [sym_pattern] = STATE(9628),
    [sym_unquote_decl] = STATE(9628),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(162),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(509),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
  },
  [131] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9539),
    [sym_fields] = STATE(9539),
    [sym_function] = STATE(9539),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9539),
    [sym_data_signature] = STATE(9539),
    [sym_record] = STATE(9539),
    [sym_record_signature] = STATE(9539),
    [sym_infix] = STATE(9539),
    [sym_generalize] = STATE(9539),
    [sym_mutual] = STATE(9539),
    [sym_abstract] = STATE(9539),
    [sym_private] = STATE(9539),
    [sym_instance] = STATE(9539),
    [sym_macro] = STATE(9539),
    [sym_postulate] = STATE(9539),
    [sym_primitive] = STATE(9539),
    [sym_open] = STATE(9539),
    [sym_import] = STATE(9539),
    [sym_module_macro] = STATE(9539),
    [sym_module] = STATE(9539),
    [sym_syntax] = STATE(9539),
    [sym_pattern] = STATE(9539),
    [sym_unquote_decl] = STATE(9539),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(162),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(505),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
  },
  [132] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9514),
    [sym_fields] = STATE(9514),
    [sym_function] = STATE(9514),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9514),
    [sym_data_signature] = STATE(9514),
    [sym_record] = STATE(9514),
    [sym_record_signature] = STATE(9514),
    [sym_infix] = STATE(9514),
    [sym_generalize] = STATE(9514),
    [sym_mutual] = STATE(9514),
    [sym_abstract] = STATE(9514),
    [sym_private] = STATE(9514),
    [sym_instance] = STATE(9514),
    [sym_macro] = STATE(9514),
    [sym_postulate] = STATE(9514),
    [sym_primitive] = STATE(9514),
    [sym_open] = STATE(9514),
    [sym_import] = STATE(9514),
    [sym_module_macro] = STATE(9514),
    [sym_module] = STATE(9514),
    [sym_syntax] = STATE(9514),
    [sym_pattern] = STATE(9514),
    [sym_unquote_decl] = STATE(9514),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(208),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(511),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
  },
  [133] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9513),
    [sym_fields] = STATE(9513),
    [sym_function] = STATE(9513),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9513),
    [sym_data_signature] = STATE(9513),
    [sym_record] = STATE(9513),
    [sym_record_signature] = STATE(9513),
    [sym_infix] = STATE(9513),
    [sym_generalize] = STATE(9513),
    [sym_mutual] = STATE(9513),
    [sym_abstract] = STATE(9513),
    [sym_private] = STATE(9513),
    [sym_instance] = STATE(9513),
    [sym_macro] = STATE(9513),
    [sym_postulate] = STATE(9513),
    [sym_primitive] = STATE(9513),
    [sym_open] = STATE(9513),
    [sym_import] = STATE(9513),
    [sym_module_macro] = STATE(9513),
    [sym_module] = STATE(9513),
    [sym_syntax] = STATE(9513),
    [sym_pattern] = STATE(9513),
    [sym_unquote_decl] = STATE(9513),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(162),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(513),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
  },
  [134] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9628),
    [sym_fields] = STATE(9628),
    [sym_function] = STATE(9628),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9628),
    [sym_data_signature] = STATE(9628),
    [sym_record] = STATE(9628),
    [sym_record_signature] = STATE(9628),
    [sym_infix] = STATE(9628),
    [sym_generalize] = STATE(9628),
    [sym_mutual] = STATE(9628),
    [sym_abstract] = STATE(9628),
    [sym_private] = STATE(9628),
    [sym_instance] = STATE(9628),
    [sym_macro] = STATE(9628),
    [sym_postulate] = STATE(9628),
    [sym_primitive] = STATE(9628),
    [sym_open] = STATE(9628),
    [sym_import] = STATE(9628),
    [sym_module_macro] = STATE(9628),
    [sym_module] = STATE(9628),
    [sym_syntax] = STATE(9628),
    [sym_pattern] = STATE(9628),
    [sym_unquote_decl] = STATE(9628),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(230),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(509),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
  },
  [135] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9523),
    [sym_fields] = STATE(9523),
    [sym_function] = STATE(9523),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9523),
    [sym_data_signature] = STATE(9523),
    [sym_record] = STATE(9523),
    [sym_record_signature] = STATE(9523),
    [sym_infix] = STATE(9523),
    [sym_generalize] = STATE(9523),
    [sym_mutual] = STATE(9523),
    [sym_abstract] = STATE(9523),
    [sym_private] = STATE(9523),
    [sym_instance] = STATE(9523),
    [sym_macro] = STATE(9523),
    [sym_postulate] = STATE(9523),
    [sym_primitive] = STATE(9523),
    [sym_open] = STATE(9523),
    [sym_import] = STATE(9523),
    [sym_module_macro] = STATE(9523),
    [sym_module] = STATE(9523),
    [sym_syntax] = STATE(9523),
    [sym_pattern] = STATE(9523),
    [sym_unquote_decl] = STATE(9523),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(162),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(515),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
  },
  [136] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9502),
    [sym_fields] = STATE(9502),
    [sym_function] = STATE(9502),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9502),
    [sym_data_signature] = STATE(9502),
    [sym_record] = STATE(9502),
    [sym_record_signature] = STATE(9502),
    [sym_infix] = STATE(9502),
    [sym_generalize] = STATE(9502),
    [sym_mutual] = STATE(9502),
    [sym_abstract] = STATE(9502),
    [sym_private] = STATE(9502),
    [sym_instance] = STATE(9502),
    [sym_macro] = STATE(9502),
    [sym_postulate] = STATE(9502),
    [sym_primitive] = STATE(9502),
    [sym_open] = STATE(9502),
    [sym_import] = STATE(9502),
    [sym_module_macro] = STATE(9502),
    [sym_module] = STATE(9502),
    [sym_syntax] = STATE(9502),
    [sym_pattern] = STATE(9502),
    [sym_unquote_decl] = STATE(9502),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(162),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(517),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
  },
  [137] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9653),
    [sym_fields] = STATE(9653),
    [sym_function] = STATE(9653),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9653),
    [sym_data_signature] = STATE(9653),
    [sym_record] = STATE(9653),
    [sym_record_signature] = STATE(9653),
    [sym_infix] = STATE(9653),
    [sym_generalize] = STATE(9653),
    [sym_mutual] = STATE(9653),
    [sym_abstract] = STATE(9653),
    [sym_private] = STATE(9653),
    [sym_instance] = STATE(9653),
    [sym_macro] = STATE(9653),
    [sym_postulate] = STATE(9653),
    [sym_primitive] = STATE(9653),
    [sym_open] = STATE(9653),
    [sym_import] = STATE(9653),
    [sym_module_macro] = STATE(9653),
    [sym_module] = STATE(9653),
    [sym_syntax] = STATE(9653),
    [sym_pattern] = STATE(9653),
    [sym_unquote_decl] = STATE(9653),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(162),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(519),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
  },
  [138] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9682),
    [sym_fields] = STATE(9682),
    [sym_function] = STATE(9682),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9682),
    [sym_data_signature] = STATE(9682),
    [sym_record] = STATE(9682),
    [sym_record_signature] = STATE(9682),
    [sym_infix] = STATE(9682),
    [sym_generalize] = STATE(9682),
    [sym_mutual] = STATE(9682),
    [sym_abstract] = STATE(9682),
    [sym_private] = STATE(9682),
    [sym_instance] = STATE(9682),
    [sym_macro] = STATE(9682),
    [sym_postulate] = STATE(9682),
    [sym_primitive] = STATE(9682),
    [sym_open] = STATE(9682),
    [sym_import] = STATE(9682),
    [sym_module_macro] = STATE(9682),
    [sym_module] = STATE(9682),
    [sym_syntax] = STATE(9682),
    [sym_pattern] = STATE(9682),
    [sym_unquote_decl] = STATE(9682),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(162),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(521),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
  },
  [139] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9594),
    [sym_fields] = STATE(9594),
    [sym_function] = STATE(9594),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9594),
    [sym_data_signature] = STATE(9594),
    [sym_record] = STATE(9594),
    [sym_record_signature] = STATE(9594),
    [sym_infix] = STATE(9594),
    [sym_generalize] = STATE(9594),
    [sym_mutual] = STATE(9594),
    [sym_abstract] = STATE(9594),
    [sym_private] = STATE(9594),
    [sym_instance] = STATE(9594),
    [sym_macro] = STATE(9594),
    [sym_postulate] = STATE(9594),
    [sym_primitive] = STATE(9594),
    [sym_open] = STATE(9594),
    [sym_import] = STATE(9594),
    [sym_module_macro] = STATE(9594),
    [sym_module] = STATE(9594),
    [sym_syntax] = STATE(9594),
    [sym_pattern] = STATE(9594),
    [sym_unquote_decl] = STATE(9594),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(162),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(523),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
  },
  [140] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9636),
    [sym_fields] = STATE(9636),
    [sym_function] = STATE(9636),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9636),
    [sym_data_signature] = STATE(9636),
    [sym_record] = STATE(9636),
    [sym_record_signature] = STATE(9636),
    [sym_infix] = STATE(9636),
    [sym_generalize] = STATE(9636),
    [sym_mutual] = STATE(9636),
    [sym_abstract] = STATE(9636),
    [sym_private] = STATE(9636),
    [sym_instance] = STATE(9636),
    [sym_macro] = STATE(9636),
    [sym_postulate] = STATE(9636),
    [sym_primitive] = STATE(9636),
    [sym_open] = STATE(9636),
    [sym_import] = STATE(9636),
    [sym_module_macro] = STATE(9636),
    [sym_module] = STATE(9636),
    [sym_syntax] = STATE(9636),
    [sym_pattern] = STATE(9636),
    [sym_unquote_decl] = STATE(9636),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(162),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(525),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
  },
  [141] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9507),
    [sym_fields] = STATE(9507),
    [sym_function] = STATE(9507),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9507),
    [sym_data_signature] = STATE(9507),
    [sym_record] = STATE(9507),
    [sym_record_signature] = STATE(9507),
    [sym_infix] = STATE(9507),
    [sym_generalize] = STATE(9507),
    [sym_mutual] = STATE(9507),
    [sym_abstract] = STATE(9507),
    [sym_private] = STATE(9507),
    [sym_instance] = STATE(9507),
    [sym_macro] = STATE(9507),
    [sym_postulate] = STATE(9507),
    [sym_primitive] = STATE(9507),
    [sym_open] = STATE(9507),
    [sym_import] = STATE(9507),
    [sym_module_macro] = STATE(9507),
    [sym_module] = STATE(9507),
    [sym_syntax] = STATE(9507),
    [sym_pattern] = STATE(9507),
    [sym_unquote_decl] = STATE(9507),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(173),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(527),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
  },
  [142] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9658),
    [sym_fields] = STATE(9658),
    [sym_function] = STATE(9658),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9658),
    [sym_data_signature] = STATE(9658),
    [sym_record] = STATE(9658),
    [sym_record_signature] = STATE(9658),
    [sym_infix] = STATE(9658),
    [sym_generalize] = STATE(9658),
    [sym_mutual] = STATE(9658),
    [sym_abstract] = STATE(9658),
    [sym_private] = STATE(9658),
    [sym_instance] = STATE(9658),
    [sym_macro] = STATE(9658),
    [sym_postulate] = STATE(9658),
    [sym_primitive] = STATE(9658),
    [sym_open] = STATE(9658),
    [sym_import] = STATE(9658),
    [sym_module_macro] = STATE(9658),
    [sym_module] = STATE(9658),
    [sym_syntax] = STATE(9658),
    [sym_pattern] = STATE(9658),
    [sym_unquote_decl] = STATE(9658),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(162),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(507),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
  },
  [143] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9529),
    [sym_fields] = STATE(9529),
    [sym_function] = STATE(9529),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9529),
    [sym_data_signature] = STATE(9529),
    [sym_record] = STATE(9529),
    [sym_record_signature] = STATE(9529),
    [sym_infix] = STATE(9529),
    [sym_generalize] = STATE(9529),
    [sym_mutual] = STATE(9529),
    [sym_abstract] = STATE(9529),
    [sym_private] = STATE(9529),
    [sym_instance] = STATE(9529),
    [sym_macro] = STATE(9529),
    [sym_postulate] = STATE(9529),
    [sym_primitive] = STATE(9529),
    [sym_open] = STATE(9529),
    [sym_import] = STATE(9529),
    [sym_module_macro] = STATE(9529),
    [sym_module] = STATE(9529),
    [sym_syntax] = STATE(9529),
    [sym_pattern] = STATE(9529),
    [sym_unquote_decl] = STATE(9529),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(162),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(529),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
  },
  [144] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9636),
    [sym_fields] = STATE(9636),
    [sym_function] = STATE(9636),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9636),
    [sym_data_signature] = STATE(9636),
    [sym_record] = STATE(9636),
    [sym_record_signature] = STATE(9636),
    [sym_infix] = STATE(9636),
    [sym_generalize] = STATE(9636),
    [sym_mutual] = STATE(9636),
    [sym_abstract] = STATE(9636),
    [sym_private] = STATE(9636),
    [sym_instance] = STATE(9636),
    [sym_macro] = STATE(9636),
    [sym_postulate] = STATE(9636),
    [sym_primitive] = STATE(9636),
    [sym_open] = STATE(9636),
    [sym_import] = STATE(9636),
    [sym_module_macro] = STATE(9636),
    [sym_module] = STATE(9636),
    [sym_syntax] = STATE(9636),
    [sym_pattern] = STATE(9636),
    [sym_unquote_decl] = STATE(9636),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(117),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(525),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
  },
  [145] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9538),
    [sym_fields] = STATE(9538),
    [sym_function] = STATE(9538),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9538),
    [sym_data_signature] = STATE(9538),
    [sym_record] = STATE(9538),
    [sym_record_signature] = STATE(9538),
    [sym_infix] = STATE(9538),
    [sym_generalize] = STATE(9538),
    [sym_mutual] = STATE(9538),
    [sym_abstract] = STATE(9538),
    [sym_private] = STATE(9538),
    [sym_instance] = STATE(9538),
    [sym_macro] = STATE(9538),
    [sym_postulate] = STATE(9538),
    [sym_primitive] = STATE(9538),
    [sym_open] = STATE(9538),
    [sym_import] = STATE(9538),
    [sym_module_macro] = STATE(9538),
    [sym_module] = STATE(9538),
    [sym_syntax] = STATE(9538),
    [sym_pattern] = STATE(9538),
    [sym_unquote_decl] = STATE(9538),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(162),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(531),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
  },
  [146] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9503),
    [sym_fields] = STATE(9503),
    [sym_function] = STATE(9503),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9503),
    [sym_data_signature] = STATE(9503),
    [sym_record] = STATE(9503),
    [sym_record_signature] = STATE(9503),
    [sym_infix] = STATE(9503),
    [sym_generalize] = STATE(9503),
    [sym_mutual] = STATE(9503),
    [sym_abstract] = STATE(9503),
    [sym_private] = STATE(9503),
    [sym_instance] = STATE(9503),
    [sym_macro] = STATE(9503),
    [sym_postulate] = STATE(9503),
    [sym_primitive] = STATE(9503),
    [sym_open] = STATE(9503),
    [sym_import] = STATE(9503),
    [sym_module_macro] = STATE(9503),
    [sym_module] = STATE(9503),
    [sym_syntax] = STATE(9503),
    [sym_pattern] = STATE(9503),
    [sym_unquote_decl] = STATE(9503),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(162),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(533),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
  },
  [147] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9679),
    [sym_fields] = STATE(9679),
    [sym_function] = STATE(9679),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9679),
    [sym_data_signature] = STATE(9679),
    [sym_record] = STATE(9679),
    [sym_record_signature] = STATE(9679),
    [sym_infix] = STATE(9679),
    [sym_generalize] = STATE(9679),
    [sym_mutual] = STATE(9679),
    [sym_abstract] = STATE(9679),
    [sym_private] = STATE(9679),
    [sym_instance] = STATE(9679),
    [sym_macro] = STATE(9679),
    [sym_postulate] = STATE(9679),
    [sym_primitive] = STATE(9679),
    [sym_open] = STATE(9679),
    [sym_import] = STATE(9679),
    [sym_module_macro] = STATE(9679),
    [sym_module] = STATE(9679),
    [sym_syntax] = STATE(9679),
    [sym_pattern] = STATE(9679),
    [sym_unquote_decl] = STATE(9679),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(162),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(535),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
  },
  [148] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9640),
    [sym_fields] = STATE(9640),
    [sym_function] = STATE(9640),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9640),
    [sym_data_signature] = STATE(9640),
    [sym_record] = STATE(9640),
    [sym_record_signature] = STATE(9640),
    [sym_infix] = STATE(9640),
    [sym_generalize] = STATE(9640),
    [sym_mutual] = STATE(9640),
    [sym_abstract] = STATE(9640),
    [sym_private] = STATE(9640),
    [sym_instance] = STATE(9640),
    [sym_macro] = STATE(9640),
    [sym_postulate] = STATE(9640),
    [sym_primitive] = STATE(9640),
    [sym_open] = STATE(9640),
    [sym_import] = STATE(9640),
    [sym_module_macro] = STATE(9640),
    [sym_module] = STATE(9640),
    [sym_syntax] = STATE(9640),
    [sym_pattern] = STATE(9640),
    [sym_unquote_decl] = STATE(9640),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(162),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(537),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
  },
  [149] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9550),
    [sym_fields] = STATE(9550),
    [sym_function] = STATE(9550),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9550),
    [sym_data_signature] = STATE(9550),
    [sym_record] = STATE(9550),
    [sym_record_signature] = STATE(9550),
    [sym_infix] = STATE(9550),
    [sym_generalize] = STATE(9550),
    [sym_mutual] = STATE(9550),
    [sym_abstract] = STATE(9550),
    [sym_private] = STATE(9550),
    [sym_instance] = STATE(9550),
    [sym_macro] = STATE(9550),
    [sym_postulate] = STATE(9550),
    [sym_primitive] = STATE(9550),
    [sym_open] = STATE(9550),
    [sym_import] = STATE(9550),
    [sym_module_macro] = STATE(9550),
    [sym_module] = STATE(9550),
    [sym_syntax] = STATE(9550),
    [sym_pattern] = STATE(9550),
    [sym_unquote_decl] = STATE(9550),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(162),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(539),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
  },
  [150] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9501),
    [sym_fields] = STATE(9501),
    [sym_function] = STATE(9501),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9501),
    [sym_data_signature] = STATE(9501),
    [sym_record] = STATE(9501),
    [sym_record_signature] = STATE(9501),
    [sym_infix] = STATE(9501),
    [sym_generalize] = STATE(9501),
    [sym_mutual] = STATE(9501),
    [sym_abstract] = STATE(9501),
    [sym_private] = STATE(9501),
    [sym_instance] = STATE(9501),
    [sym_macro] = STATE(9501),
    [sym_postulate] = STATE(9501),
    [sym_primitive] = STATE(9501),
    [sym_open] = STATE(9501),
    [sym_import] = STATE(9501),
    [sym_module_macro] = STATE(9501),
    [sym_module] = STATE(9501),
    [sym_syntax] = STATE(9501),
    [sym_pattern] = STATE(9501),
    [sym_unquote_decl] = STATE(9501),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(162),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(541),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
  },
  [151] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9679),
    [sym_fields] = STATE(9679),
    [sym_function] = STATE(9679),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9679),
    [sym_data_signature] = STATE(9679),
    [sym_record] = STATE(9679),
    [sym_record_signature] = STATE(9679),
    [sym_infix] = STATE(9679),
    [sym_generalize] = STATE(9679),
    [sym_mutual] = STATE(9679),
    [sym_abstract] = STATE(9679),
    [sym_private] = STATE(9679),
    [sym_instance] = STATE(9679),
    [sym_macro] = STATE(9679),
    [sym_postulate] = STATE(9679),
    [sym_primitive] = STATE(9679),
    [sym_open] = STATE(9679),
    [sym_import] = STATE(9679),
    [sym_module_macro] = STATE(9679),
    [sym_module] = STATE(9679),
    [sym_syntax] = STATE(9679),
    [sym_pattern] = STATE(9679),
    [sym_unquote_decl] = STATE(9679),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(213),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(535),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
  },
  [152] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9579),
    [sym_fields] = STATE(9579),
    [sym_function] = STATE(9579),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9579),
    [sym_data_signature] = STATE(9579),
    [sym_record] = STATE(9579),
    [sym_record_signature] = STATE(9579),
    [sym_infix] = STATE(9579),
    [sym_generalize] = STATE(9579),
    [sym_mutual] = STATE(9579),
    [sym_abstract] = STATE(9579),
    [sym_private] = STATE(9579),
    [sym_instance] = STATE(9579),
    [sym_macro] = STATE(9579),
    [sym_postulate] = STATE(9579),
    [sym_primitive] = STATE(9579),
    [sym_open] = STATE(9579),
    [sym_import] = STATE(9579),
    [sym_module_macro] = STATE(9579),
    [sym_module] = STATE(9579),
    [sym_syntax] = STATE(9579),
    [sym_pattern] = STATE(9579),
    [sym_unquote_decl] = STATE(9579),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(162),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(543),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
  },
  [153] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9672),
    [sym_fields] = STATE(9672),
    [sym_function] = STATE(9672),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9672),
    [sym_data_signature] = STATE(9672),
    [sym_record] = STATE(9672),
    [sym_record_signature] = STATE(9672),
    [sym_infix] = STATE(9672),
    [sym_generalize] = STATE(9672),
    [sym_mutual] = STATE(9672),
    [sym_abstract] = STATE(9672),
    [sym_private] = STATE(9672),
    [sym_instance] = STATE(9672),
    [sym_macro] = STATE(9672),
    [sym_postulate] = STATE(9672),
    [sym_primitive] = STATE(9672),
    [sym_open] = STATE(9672),
    [sym_import] = STATE(9672),
    [sym_module_macro] = STATE(9672),
    [sym_module] = STATE(9672),
    [sym_syntax] = STATE(9672),
    [sym_pattern] = STATE(9672),
    [sym_unquote_decl] = STATE(9672),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(162),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(545),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
  },
  [154] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9536),
    [sym_fields] = STATE(9536),
    [sym_function] = STATE(9536),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9536),
    [sym_data_signature] = STATE(9536),
    [sym_record] = STATE(9536),
    [sym_record_signature] = STATE(9536),
    [sym_infix] = STATE(9536),
    [sym_generalize] = STATE(9536),
    [sym_mutual] = STATE(9536),
    [sym_abstract] = STATE(9536),
    [sym_private] = STATE(9536),
    [sym_instance] = STATE(9536),
    [sym_macro] = STATE(9536),
    [sym_postulate] = STATE(9536),
    [sym_primitive] = STATE(9536),
    [sym_open] = STATE(9536),
    [sym_import] = STATE(9536),
    [sym_module_macro] = STATE(9536),
    [sym_module] = STATE(9536),
    [sym_syntax] = STATE(9536),
    [sym_pattern] = STATE(9536),
    [sym_unquote_decl] = STATE(9536),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(166),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(547),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
  },
  [155] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9507),
    [sym_fields] = STATE(9507),
    [sym_function] = STATE(9507),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9507),
    [sym_data_signature] = STATE(9507),
    [sym_record] = STATE(9507),
    [sym_record_signature] = STATE(9507),
    [sym_infix] = STATE(9507),
    [sym_generalize] = STATE(9507),
    [sym_mutual] = STATE(9507),
    [sym_abstract] = STATE(9507),
    [sym_private] = STATE(9507),
    [sym_instance] = STATE(9507),
    [sym_macro] = STATE(9507),
    [sym_postulate] = STATE(9507),
    [sym_primitive] = STATE(9507),
    [sym_open] = STATE(9507),
    [sym_import] = STATE(9507),
    [sym_module_macro] = STATE(9507),
    [sym_module] = STATE(9507),
    [sym_syntax] = STATE(9507),
    [sym_pattern] = STATE(9507),
    [sym_unquote_decl] = STATE(9507),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(162),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(527),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
  },
  [156] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9606),
    [sym_fields] = STATE(9606),
    [sym_function] = STATE(9606),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9606),
    [sym_data_signature] = STATE(9606),
    [sym_record] = STATE(9606),
    [sym_record_signature] = STATE(9606),
    [sym_infix] = STATE(9606),
    [sym_generalize] = STATE(9606),
    [sym_mutual] = STATE(9606),
    [sym_abstract] = STATE(9606),
    [sym_private] = STATE(9606),
    [sym_instance] = STATE(9606),
    [sym_macro] = STATE(9606),
    [sym_postulate] = STATE(9606),
    [sym_primitive] = STATE(9606),
    [sym_open] = STATE(9606),
    [sym_import] = STATE(9606),
    [sym_module_macro] = STATE(9606),
    [sym_module] = STATE(9606),
    [sym_syntax] = STATE(9606),
    [sym_pattern] = STATE(9606),
    [sym_unquote_decl] = STATE(9606),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(162),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(549),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
  },
  [157] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9593),
    [sym_fields] = STATE(9593),
    [sym_function] = STATE(9593),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9593),
    [sym_data_signature] = STATE(9593),
    [sym_record] = STATE(9593),
    [sym_record_signature] = STATE(9593),
    [sym_infix] = STATE(9593),
    [sym_generalize] = STATE(9593),
    [sym_mutual] = STATE(9593),
    [sym_abstract] = STATE(9593),
    [sym_private] = STATE(9593),
    [sym_instance] = STATE(9593),
    [sym_macro] = STATE(9593),
    [sym_postulate] = STATE(9593),
    [sym_primitive] = STATE(9593),
    [sym_open] = STATE(9593),
    [sym_import] = STATE(9593),
    [sym_module_macro] = STATE(9593),
    [sym_module] = STATE(9593),
    [sym_syntax] = STATE(9593),
    [sym_pattern] = STATE(9593),
    [sym_unquote_decl] = STATE(9593),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(217),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(551),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
  },
  [158] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9524),
    [sym_fields] = STATE(9524),
    [sym_function] = STATE(9524),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9524),
    [sym_data_signature] = STATE(9524),
    [sym_record] = STATE(9524),
    [sym_record_signature] = STATE(9524),
    [sym_infix] = STATE(9524),
    [sym_generalize] = STATE(9524),
    [sym_mutual] = STATE(9524),
    [sym_abstract] = STATE(9524),
    [sym_private] = STATE(9524),
    [sym_instance] = STATE(9524),
    [sym_macro] = STATE(9524),
    [sym_postulate] = STATE(9524),
    [sym_primitive] = STATE(9524),
    [sym_open] = STATE(9524),
    [sym_import] = STATE(9524),
    [sym_module_macro] = STATE(9524),
    [sym_module] = STATE(9524),
    [sym_syntax] = STATE(9524),
    [sym_pattern] = STATE(9524),
    [sym_unquote_decl] = STATE(9524),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(79),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(553),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
  },
  [159] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9606),
    [sym_fields] = STATE(9606),
    [sym_function] = STATE(9606),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9606),
    [sym_data_signature] = STATE(9606),
    [sym_record] = STATE(9606),
    [sym_record_signature] = STATE(9606),
    [sym_infix] = STATE(9606),
    [sym_generalize] = STATE(9606),
    [sym_mutual] = STATE(9606),
    [sym_abstract] = STATE(9606),
    [sym_private] = STATE(9606),
    [sym_instance] = STATE(9606),
    [sym_macro] = STATE(9606),
    [sym_postulate] = STATE(9606),
    [sym_primitive] = STATE(9606),
    [sym_open] = STATE(9606),
    [sym_import] = STATE(9606),
    [sym_module_macro] = STATE(9606),
    [sym_module] = STATE(9606),
    [sym_syntax] = STATE(9606),
    [sym_pattern] = STATE(9606),
    [sym_unquote_decl] = STATE(9606),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(123),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(549),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
  },
  [160] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9560),
    [sym_fields] = STATE(9560),
    [sym_function] = STATE(9560),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9560),
    [sym_data_signature] = STATE(9560),
    [sym_record] = STATE(9560),
    [sym_record_signature] = STATE(9560),
    [sym_infix] = STATE(9560),
    [sym_generalize] = STATE(9560),
    [sym_mutual] = STATE(9560),
    [sym_abstract] = STATE(9560),
    [sym_private] = STATE(9560),
    [sym_instance] = STATE(9560),
    [sym_macro] = STATE(9560),
    [sym_postulate] = STATE(9560),
    [sym_primitive] = STATE(9560),
    [sym_open] = STATE(9560),
    [sym_import] = STATE(9560),
    [sym_module_macro] = STATE(9560),
    [sym_module] = STATE(9560),
    [sym_syntax] = STATE(9560),
    [sym_pattern] = STATE(9560),
    [sym_unquote_decl] = STATE(9560),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(162),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(555),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
  },
  [161] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9565),
    [sym_fields] = STATE(9565),
    [sym_function] = STATE(9565),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9565),
    [sym_data_signature] = STATE(9565),
    [sym_record] = STATE(9565),
    [sym_record_signature] = STATE(9565),
    [sym_infix] = STATE(9565),
    [sym_generalize] = STATE(9565),
    [sym_mutual] = STATE(9565),
    [sym_abstract] = STATE(9565),
    [sym_private] = STATE(9565),
    [sym_instance] = STATE(9565),
    [sym_macro] = STATE(9565),
    [sym_postulate] = STATE(9565),
    [sym_primitive] = STATE(9565),
    [sym_open] = STATE(9565),
    [sym_import] = STATE(9565),
    [sym_module_macro] = STATE(9565),
    [sym_module] = STATE(9565),
    [sym_syntax] = STATE(9565),
    [sym_pattern] = STATE(9565),
    [sym_unquote_decl] = STATE(9565),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(162),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(557),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
  },
  [162] = {
    [sym__FORALL] = STATE(8288),
    [sym__LAMBDA] = STATE(8114),
    [sym__ELLIPSIS] = STATE(4608),
    [sym__declaration] = STATE(11515),
    [sym_fields] = STATE(11515),
    [sym_function] = STATE(11515),
    [sym_lhs_decl] = STATE(9175),
    [sym_lhs_defn] = STATE(9174),
    [sym_data] = STATE(11515),
    [sym_data_signature] = STATE(11515),
    [sym_record] = STATE(11515),
    [sym_record_signature] = STATE(11515),
    [sym_infix] = STATE(11515),
    [sym_generalize] = STATE(11515),
    [sym_mutual] = STATE(11515),
    [sym_abstract] = STATE(11515),
    [sym_private] = STATE(11515),
    [sym_instance] = STATE(11515),
    [sym_macro] = STATE(11515),
    [sym_postulate] = STATE(11515),
    [sym_primitive] = STATE(11515),
    [sym_open] = STATE(11515),
    [sym_import] = STATE(11515),
    [sym_module_macro] = STATE(11515),
    [sym_module] = STATE(11515),
    [sym_syntax] = STATE(11515),
    [sym_pattern] = STATE(11515),
    [sym_unquote_decl] = STATE(11515),
    [sym__qid] = STATE(4608),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3129),
    [sym__with_exprs] = STATE(8953),
    [sym__expr_or_attr] = STATE(4608),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4600),
    [aux_sym__atoms] = STATE(3848),
    [sym__atom_curly] = STATE(4564),
    [sym__atom_no_curly] = STATE(4564),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4608),
    [sym_field_assignments] = STATE(4608),
    [sym_literal] = STATE(4608),
    [sym_SetN] = STATE(4608),
    [aux_sym_source_file_repeat1] = STATE(162),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3710),
    [sym_id] = ACTIONS(271),
    [anon_sym_forall] = ACTIONS(274),
    [anon_sym_u2200] = ACTIONS(274),
    [anon_sym_BSLASH] = ACTIONS(277),
    [anon_sym_u03bb] = ACTIONS(280),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(283),
    [anon_sym_u2026] = ACTIONS(283),
    [anon_sym_field] = ACTIONS(286),
    [anon_sym_instance] = ACTIONS(289),
    [anon_sym_module] = ACTIONS(292),
    [anon_sym_data] = ACTIONS(295),
    [anon_sym_codata] = ACTIONS(298),
    [anon_sym_record] = ACTIONS(301),
    [anon_sym_infix] = ACTIONS(304),
    [anon_sym_infixl] = ACTIONS(304),
    [anon_sym_infixr] = ACTIONS(304),
    [anon_sym_variable] = ACTIONS(307),
    [anon_sym_mutual] = ACTIONS(310),
    [anon_sym_abstract] = ACTIONS(313),
    [anon_sym_private] = ACTIONS(316),
    [anon_sym_macro] = ACTIONS(319),
    [anon_sym_postulate] = ACTIONS(322),
    [anon_sym_primitive] = ACTIONS(325),
    [anon_sym_open] = ACTIONS(328),
    [anon_sym_import] = ACTIONS(331),
    [anon_sym_LPAREN] = ACTIONS(334),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(337),
    [anon_sym_u2983] = ACTIONS(340),
    [anon_sym__] = ACTIONS(283),
    [sym_pragma] = ACTIONS(559),
    [anon_sym_syntax] = ACTIONS(346),
    [anon_sym_LBRACE] = ACTIONS(349),
    [anon_sym_pattern] = ACTIONS(352),
    [anon_sym_unquoteDecl] = ACTIONS(355),
    [anon_sym_unquoteDef] = ACTIONS(358),
    [aux_sym__qid_token1] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(364),
    [anon_sym_AT] = ACTIONS(367),
    [anon_sym_quoteGoal] = ACTIONS(370),
    [anon_sym_tactic] = ACTIONS(373),
    [anon_sym_Prop] = ACTIONS(283),
    [anon_sym_quote] = ACTIONS(283),
    [anon_sym_quoteTerm] = ACTIONS(283),
    [anon_sym_quoteContext] = ACTIONS(283),
    [anon_sym_unquote] = ACTIONS(283),
    [anon_sym_LPAREN_PIPE] = ACTIONS(376),
    [anon_sym_u2987] = ACTIONS(379),
    [anon_sym_let] = ACTIONS(382),
    [anon_sym_do] = ACTIONS(385),
    [aux_sym_integer_token1] = ACTIONS(388),
    [aux_sym_string_token1] = ACTIONS(388),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(391),
    [sym_PropN] = ACTIONS(283),
  },
  [163] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9497),
    [sym_fields] = STATE(9497),
    [sym_function] = STATE(9497),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9497),
    [sym_data_signature] = STATE(9497),
    [sym_record] = STATE(9497),
    [sym_record_signature] = STATE(9497),
    [sym_infix] = STATE(9497),
    [sym_generalize] = STATE(9497),
    [sym_mutual] = STATE(9497),
    [sym_abstract] = STATE(9497),
    [sym_private] = STATE(9497),
    [sym_instance] = STATE(9497),
    [sym_macro] = STATE(9497),
    [sym_postulate] = STATE(9497),
    [sym_primitive] = STATE(9497),
    [sym_open] = STATE(9497),
    [sym_import] = STATE(9497),
    [sym_module_macro] = STATE(9497),
    [sym_module] = STATE(9497),
    [sym_syntax] = STATE(9497),
    [sym_pattern] = STATE(9497),
    [sym_unquote_decl] = STATE(9497),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(162),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(562),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
  },
  [164] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9595),
    [sym_fields] = STATE(9595),
    [sym_function] = STATE(9595),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9595),
    [sym_data_signature] = STATE(9595),
    [sym_record] = STATE(9595),
    [sym_record_signature] = STATE(9595),
    [sym_infix] = STATE(9595),
    [sym_generalize] = STATE(9595),
    [sym_mutual] = STATE(9595),
    [sym_abstract] = STATE(9595),
    [sym_private] = STATE(9595),
    [sym_instance] = STATE(9595),
    [sym_macro] = STATE(9595),
    [sym_postulate] = STATE(9595),
    [sym_primitive] = STATE(9595),
    [sym_open] = STATE(9595),
    [sym_import] = STATE(9595),
    [sym_module_macro] = STATE(9595),
    [sym_module] = STATE(9595),
    [sym_syntax] = STATE(9595),
    [sym_pattern] = STATE(9595),
    [sym_unquote_decl] = STATE(9595),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(162),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(564),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
  },
  [165] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9515),
    [sym_fields] = STATE(9515),
    [sym_function] = STATE(9515),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9515),
    [sym_data_signature] = STATE(9515),
    [sym_record] = STATE(9515),
    [sym_record_signature] = STATE(9515),
    [sym_infix] = STATE(9515),
    [sym_generalize] = STATE(9515),
    [sym_mutual] = STATE(9515),
    [sym_abstract] = STATE(9515),
    [sym_private] = STATE(9515),
    [sym_instance] = STATE(9515),
    [sym_macro] = STATE(9515),
    [sym_postulate] = STATE(9515),
    [sym_primitive] = STATE(9515),
    [sym_open] = STATE(9515),
    [sym_import] = STATE(9515),
    [sym_module_macro] = STATE(9515),
    [sym_module] = STATE(9515),
    [sym_syntax] = STATE(9515),
    [sym_pattern] = STATE(9515),
    [sym_unquote_decl] = STATE(9515),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(162),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(566),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
  },
  [166] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9642),
    [sym_fields] = STATE(9642),
    [sym_function] = STATE(9642),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9642),
    [sym_data_signature] = STATE(9642),
    [sym_record] = STATE(9642),
    [sym_record_signature] = STATE(9642),
    [sym_infix] = STATE(9642),
    [sym_generalize] = STATE(9642),
    [sym_mutual] = STATE(9642),
    [sym_abstract] = STATE(9642),
    [sym_private] = STATE(9642),
    [sym_instance] = STATE(9642),
    [sym_macro] = STATE(9642),
    [sym_postulate] = STATE(9642),
    [sym_primitive] = STATE(9642),
    [sym_open] = STATE(9642),
    [sym_import] = STATE(9642),
    [sym_module_macro] = STATE(9642),
    [sym_module] = STATE(9642),
    [sym_syntax] = STATE(9642),
    [sym_pattern] = STATE(9642),
    [sym_unquote_decl] = STATE(9642),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(162),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(568),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
  },
  [167] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9692),
    [sym_fields] = STATE(9692),
    [sym_function] = STATE(9692),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9692),
    [sym_data_signature] = STATE(9692),
    [sym_record] = STATE(9692),
    [sym_record_signature] = STATE(9692),
    [sym_infix] = STATE(9692),
    [sym_generalize] = STATE(9692),
    [sym_mutual] = STATE(9692),
    [sym_abstract] = STATE(9692),
    [sym_private] = STATE(9692),
    [sym_instance] = STATE(9692),
    [sym_macro] = STATE(9692),
    [sym_postulate] = STATE(9692),
    [sym_primitive] = STATE(9692),
    [sym_open] = STATE(9692),
    [sym_import] = STATE(9692),
    [sym_module_macro] = STATE(9692),
    [sym_module] = STATE(9692),
    [sym_syntax] = STATE(9692),
    [sym_pattern] = STATE(9692),
    [sym_unquote_decl] = STATE(9692),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(162),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(570),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
  },
  [168] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9610),
    [sym_fields] = STATE(9610),
    [sym_function] = STATE(9610),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9610),
    [sym_data_signature] = STATE(9610),
    [sym_record] = STATE(9610),
    [sym_record_signature] = STATE(9610),
    [sym_infix] = STATE(9610),
    [sym_generalize] = STATE(9610),
    [sym_mutual] = STATE(9610),
    [sym_abstract] = STATE(9610),
    [sym_private] = STATE(9610),
    [sym_instance] = STATE(9610),
    [sym_macro] = STATE(9610),
    [sym_postulate] = STATE(9610),
    [sym_primitive] = STATE(9610),
    [sym_open] = STATE(9610),
    [sym_import] = STATE(9610),
    [sym_module_macro] = STATE(9610),
    [sym_module] = STATE(9610),
    [sym_syntax] = STATE(9610),
    [sym_pattern] = STATE(9610),
    [sym_unquote_decl] = STATE(9610),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(137),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(572),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
  },
  [169] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9536),
    [sym_fields] = STATE(9536),
    [sym_function] = STATE(9536),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9536),
    [sym_data_signature] = STATE(9536),
    [sym_record] = STATE(9536),
    [sym_record_signature] = STATE(9536),
    [sym_infix] = STATE(9536),
    [sym_generalize] = STATE(9536),
    [sym_mutual] = STATE(9536),
    [sym_abstract] = STATE(9536),
    [sym_private] = STATE(9536),
    [sym_instance] = STATE(9536),
    [sym_macro] = STATE(9536),
    [sym_postulate] = STATE(9536),
    [sym_primitive] = STATE(9536),
    [sym_open] = STATE(9536),
    [sym_import] = STATE(9536),
    [sym_module_macro] = STATE(9536),
    [sym_module] = STATE(9536),
    [sym_syntax] = STATE(9536),
    [sym_pattern] = STATE(9536),
    [sym_unquote_decl] = STATE(9536),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(162),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(547),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
  },
  [170] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9615),
    [sym_fields] = STATE(9615),
    [sym_function] = STATE(9615),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9615),
    [sym_data_signature] = STATE(9615),
    [sym_record] = STATE(9615),
    [sym_record_signature] = STATE(9615),
    [sym_infix] = STATE(9615),
    [sym_generalize] = STATE(9615),
    [sym_mutual] = STATE(9615),
    [sym_abstract] = STATE(9615),
    [sym_private] = STATE(9615),
    [sym_instance] = STATE(9615),
    [sym_macro] = STATE(9615),
    [sym_postulate] = STATE(9615),
    [sym_primitive] = STATE(9615),
    [sym_open] = STATE(9615),
    [sym_import] = STATE(9615),
    [sym_module_macro] = STATE(9615),
    [sym_module] = STATE(9615),
    [sym_syntax] = STATE(9615),
    [sym_pattern] = STATE(9615),
    [sym_unquote_decl] = STATE(9615),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(162),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(574),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
  },
  [171] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9512),
    [sym_fields] = STATE(9512),
    [sym_function] = STATE(9512),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9512),
    [sym_data_signature] = STATE(9512),
    [sym_record] = STATE(9512),
    [sym_record_signature] = STATE(9512),
    [sym_infix] = STATE(9512),
    [sym_generalize] = STATE(9512),
    [sym_mutual] = STATE(9512),
    [sym_abstract] = STATE(9512),
    [sym_private] = STATE(9512),
    [sym_instance] = STATE(9512),
    [sym_macro] = STATE(9512),
    [sym_postulate] = STATE(9512),
    [sym_primitive] = STATE(9512),
    [sym_open] = STATE(9512),
    [sym_import] = STATE(9512),
    [sym_module_macro] = STATE(9512),
    [sym_module] = STATE(9512),
    [sym_syntax] = STATE(9512),
    [sym_pattern] = STATE(9512),
    [sym_unquote_decl] = STATE(9512),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(191),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(576),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
  },
  [172] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9533),
    [sym_fields] = STATE(9533),
    [sym_function] = STATE(9533),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9533),
    [sym_data_signature] = STATE(9533),
    [sym_record] = STATE(9533),
    [sym_record_signature] = STATE(9533),
    [sym_infix] = STATE(9533),
    [sym_generalize] = STATE(9533),
    [sym_mutual] = STATE(9533),
    [sym_abstract] = STATE(9533),
    [sym_private] = STATE(9533),
    [sym_instance] = STATE(9533),
    [sym_macro] = STATE(9533),
    [sym_postulate] = STATE(9533),
    [sym_primitive] = STATE(9533),
    [sym_open] = STATE(9533),
    [sym_import] = STATE(9533),
    [sym_module_macro] = STATE(9533),
    [sym_module] = STATE(9533),
    [sym_syntax] = STATE(9533),
    [sym_pattern] = STATE(9533),
    [sym_unquote_decl] = STATE(9533),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(162),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(578),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
  },
  [173] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9584),
    [sym_fields] = STATE(9584),
    [sym_function] = STATE(9584),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9584),
    [sym_data_signature] = STATE(9584),
    [sym_record] = STATE(9584),
    [sym_record_signature] = STATE(9584),
    [sym_infix] = STATE(9584),
    [sym_generalize] = STATE(9584),
    [sym_mutual] = STATE(9584),
    [sym_abstract] = STATE(9584),
    [sym_private] = STATE(9584),
    [sym_instance] = STATE(9584),
    [sym_macro] = STATE(9584),
    [sym_postulate] = STATE(9584),
    [sym_primitive] = STATE(9584),
    [sym_open] = STATE(9584),
    [sym_import] = STATE(9584),
    [sym_module_macro] = STATE(9584),
    [sym_module] = STATE(9584),
    [sym_syntax] = STATE(9584),
    [sym_pattern] = STATE(9584),
    [sym_unquote_decl] = STATE(9584),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(162),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(580),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
  },
  [174] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9615),
    [sym_fields] = STATE(9615),
    [sym_function] = STATE(9615),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9615),
    [sym_data_signature] = STATE(9615),
    [sym_record] = STATE(9615),
    [sym_record_signature] = STATE(9615),
    [sym_infix] = STATE(9615),
    [sym_generalize] = STATE(9615),
    [sym_mutual] = STATE(9615),
    [sym_abstract] = STATE(9615),
    [sym_private] = STATE(9615),
    [sym_instance] = STATE(9615),
    [sym_macro] = STATE(9615),
    [sym_postulate] = STATE(9615),
    [sym_primitive] = STATE(9615),
    [sym_open] = STATE(9615),
    [sym_import] = STATE(9615),
    [sym_module_macro] = STATE(9615),
    [sym_module] = STATE(9615),
    [sym_syntax] = STATE(9615),
    [sym_pattern] = STATE(9615),
    [sym_unquote_decl] = STATE(9615),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(136),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(574),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
  },
  [175] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9608),
    [sym_fields] = STATE(9608),
    [sym_function] = STATE(9608),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9608),
    [sym_data_signature] = STATE(9608),
    [sym_record] = STATE(9608),
    [sym_record_signature] = STATE(9608),
    [sym_infix] = STATE(9608),
    [sym_generalize] = STATE(9608),
    [sym_mutual] = STATE(9608),
    [sym_abstract] = STATE(9608),
    [sym_private] = STATE(9608),
    [sym_instance] = STATE(9608),
    [sym_macro] = STATE(9608),
    [sym_postulate] = STATE(9608),
    [sym_primitive] = STATE(9608),
    [sym_open] = STATE(9608),
    [sym_import] = STATE(9608),
    [sym_module_macro] = STATE(9608),
    [sym_module] = STATE(9608),
    [sym_syntax] = STATE(9608),
    [sym_pattern] = STATE(9608),
    [sym_unquote_decl] = STATE(9608),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(162),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(582),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
  },
  [176] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9533),
    [sym_fields] = STATE(9533),
    [sym_function] = STATE(9533),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9533),
    [sym_data_signature] = STATE(9533),
    [sym_record] = STATE(9533),
    [sym_record_signature] = STATE(9533),
    [sym_infix] = STATE(9533),
    [sym_generalize] = STATE(9533),
    [sym_mutual] = STATE(9533),
    [sym_abstract] = STATE(9533),
    [sym_private] = STATE(9533),
    [sym_instance] = STATE(9533),
    [sym_macro] = STATE(9533),
    [sym_postulate] = STATE(9533),
    [sym_primitive] = STATE(9533),
    [sym_open] = STATE(9533),
    [sym_import] = STATE(9533),
    [sym_module_macro] = STATE(9533),
    [sym_module] = STATE(9533),
    [sym_syntax] = STATE(9533),
    [sym_pattern] = STATE(9533),
    [sym_unquote_decl] = STATE(9533),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(150),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(578),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
  },
  [177] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9691),
    [sym_fields] = STATE(9691),
    [sym_function] = STATE(9691),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9691),
    [sym_data_signature] = STATE(9691),
    [sym_record] = STATE(9691),
    [sym_record_signature] = STATE(9691),
    [sym_infix] = STATE(9691),
    [sym_generalize] = STATE(9691),
    [sym_mutual] = STATE(9691),
    [sym_abstract] = STATE(9691),
    [sym_private] = STATE(9691),
    [sym_instance] = STATE(9691),
    [sym_macro] = STATE(9691),
    [sym_postulate] = STATE(9691),
    [sym_primitive] = STATE(9691),
    [sym_open] = STATE(9691),
    [sym_import] = STATE(9691),
    [sym_module_macro] = STATE(9691),
    [sym_module] = STATE(9691),
    [sym_syntax] = STATE(9691),
    [sym_pattern] = STATE(9691),
    [sym_unquote_decl] = STATE(9691),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(162),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(584),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
  },
  [178] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9632),
    [sym_fields] = STATE(9632),
    [sym_function] = STATE(9632),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9632),
    [sym_data_signature] = STATE(9632),
    [sym_record] = STATE(9632),
    [sym_record_signature] = STATE(9632),
    [sym_infix] = STATE(9632),
    [sym_generalize] = STATE(9632),
    [sym_mutual] = STATE(9632),
    [sym_abstract] = STATE(9632),
    [sym_private] = STATE(9632),
    [sym_instance] = STATE(9632),
    [sym_macro] = STATE(9632),
    [sym_postulate] = STATE(9632),
    [sym_primitive] = STATE(9632),
    [sym_open] = STATE(9632),
    [sym_import] = STATE(9632),
    [sym_module_macro] = STATE(9632),
    [sym_module] = STATE(9632),
    [sym_syntax] = STATE(9632),
    [sym_pattern] = STATE(9632),
    [sym_unquote_decl] = STATE(9632),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(162),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(586),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
  },
  [179] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9512),
    [sym_fields] = STATE(9512),
    [sym_function] = STATE(9512),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9512),
    [sym_data_signature] = STATE(9512),
    [sym_record] = STATE(9512),
    [sym_record_signature] = STATE(9512),
    [sym_infix] = STATE(9512),
    [sym_generalize] = STATE(9512),
    [sym_mutual] = STATE(9512),
    [sym_abstract] = STATE(9512),
    [sym_private] = STATE(9512),
    [sym_instance] = STATE(9512),
    [sym_macro] = STATE(9512),
    [sym_postulate] = STATE(9512),
    [sym_primitive] = STATE(9512),
    [sym_open] = STATE(9512),
    [sym_import] = STATE(9512),
    [sym_module_macro] = STATE(9512),
    [sym_module] = STATE(9512),
    [sym_syntax] = STATE(9512),
    [sym_pattern] = STATE(9512),
    [sym_unquote_decl] = STATE(9512),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(162),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(576),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
  },
  [180] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9632),
    [sym_fields] = STATE(9632),
    [sym_function] = STATE(9632),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9632),
    [sym_data_signature] = STATE(9632),
    [sym_record] = STATE(9632),
    [sym_record_signature] = STATE(9632),
    [sym_infix] = STATE(9632),
    [sym_generalize] = STATE(9632),
    [sym_mutual] = STATE(9632),
    [sym_abstract] = STATE(9632),
    [sym_private] = STATE(9632),
    [sym_instance] = STATE(9632),
    [sym_macro] = STATE(9632),
    [sym_postulate] = STATE(9632),
    [sym_primitive] = STATE(9632),
    [sym_open] = STATE(9632),
    [sym_import] = STATE(9632),
    [sym_module_macro] = STATE(9632),
    [sym_module] = STATE(9632),
    [sym_syntax] = STATE(9632),
    [sym_pattern] = STATE(9632),
    [sym_unquote_decl] = STATE(9632),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(124),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(586),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
  },
  [181] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9692),
    [sym_fields] = STATE(9692),
    [sym_function] = STATE(9692),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9692),
    [sym_data_signature] = STATE(9692),
    [sym_record] = STATE(9692),
    [sym_record_signature] = STATE(9692),
    [sym_infix] = STATE(9692),
    [sym_generalize] = STATE(9692),
    [sym_mutual] = STATE(9692),
    [sym_abstract] = STATE(9692),
    [sym_private] = STATE(9692),
    [sym_instance] = STATE(9692),
    [sym_macro] = STATE(9692),
    [sym_postulate] = STATE(9692),
    [sym_primitive] = STATE(9692),
    [sym_open] = STATE(9692),
    [sym_import] = STATE(9692),
    [sym_module_macro] = STATE(9692),
    [sym_module] = STATE(9692),
    [sym_syntax] = STATE(9692),
    [sym_pattern] = STATE(9692),
    [sym_unquote_decl] = STATE(9692),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(138),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(570),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
  },
  [182] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9549),
    [sym_fields] = STATE(9549),
    [sym_function] = STATE(9549),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9549),
    [sym_data_signature] = STATE(9549),
    [sym_record] = STATE(9549),
    [sym_record_signature] = STATE(9549),
    [sym_infix] = STATE(9549),
    [sym_generalize] = STATE(9549),
    [sym_mutual] = STATE(9549),
    [sym_abstract] = STATE(9549),
    [sym_private] = STATE(9549),
    [sym_instance] = STATE(9549),
    [sym_macro] = STATE(9549),
    [sym_postulate] = STATE(9549),
    [sym_primitive] = STATE(9549),
    [sym_open] = STATE(9549),
    [sym_import] = STATE(9549),
    [sym_module_macro] = STATE(9549),
    [sym_module] = STATE(9549),
    [sym_syntax] = STATE(9549),
    [sym_pattern] = STATE(9549),
    [sym_unquote_decl] = STATE(9549),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(204),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(588),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
  },
  [183] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9549),
    [sym_fields] = STATE(9549),
    [sym_function] = STATE(9549),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9549),
    [sym_data_signature] = STATE(9549),
    [sym_record] = STATE(9549),
    [sym_record_signature] = STATE(9549),
    [sym_infix] = STATE(9549),
    [sym_generalize] = STATE(9549),
    [sym_mutual] = STATE(9549),
    [sym_abstract] = STATE(9549),
    [sym_private] = STATE(9549),
    [sym_instance] = STATE(9549),
    [sym_macro] = STATE(9549),
    [sym_postulate] = STATE(9549),
    [sym_primitive] = STATE(9549),
    [sym_open] = STATE(9549),
    [sym_import] = STATE(9549),
    [sym_module_macro] = STATE(9549),
    [sym_module] = STATE(9549),
    [sym_syntax] = STATE(9549),
    [sym_pattern] = STATE(9549),
    [sym_unquote_decl] = STATE(9549),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(162),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(588),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
  },
  [184] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9654),
    [sym_fields] = STATE(9654),
    [sym_function] = STATE(9654),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9654),
    [sym_data_signature] = STATE(9654),
    [sym_record] = STATE(9654),
    [sym_record_signature] = STATE(9654),
    [sym_infix] = STATE(9654),
    [sym_generalize] = STATE(9654),
    [sym_mutual] = STATE(9654),
    [sym_abstract] = STATE(9654),
    [sym_private] = STATE(9654),
    [sym_instance] = STATE(9654),
    [sym_macro] = STATE(9654),
    [sym_postulate] = STATE(9654),
    [sym_primitive] = STATE(9654),
    [sym_open] = STATE(9654),
    [sym_import] = STATE(9654),
    [sym_module_macro] = STATE(9654),
    [sym_module] = STATE(9654),
    [sym_syntax] = STATE(9654),
    [sym_pattern] = STATE(9654),
    [sym_unquote_decl] = STATE(9654),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(162),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(590),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
  },
  [185] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9654),
    [sym_fields] = STATE(9654),
    [sym_function] = STATE(9654),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9654),
    [sym_data_signature] = STATE(9654),
    [sym_record] = STATE(9654),
    [sym_record_signature] = STATE(9654),
    [sym_infix] = STATE(9654),
    [sym_generalize] = STATE(9654),
    [sym_mutual] = STATE(9654),
    [sym_abstract] = STATE(9654),
    [sym_private] = STATE(9654),
    [sym_instance] = STATE(9654),
    [sym_macro] = STATE(9654),
    [sym_postulate] = STATE(9654),
    [sym_primitive] = STATE(9654),
    [sym_open] = STATE(9654),
    [sym_import] = STATE(9654),
    [sym_module_macro] = STATE(9654),
    [sym_module] = STATE(9654),
    [sym_syntax] = STATE(9654),
    [sym_pattern] = STATE(9654),
    [sym_unquote_decl] = STATE(9654),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(135),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(590),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
  },
  [186] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9534),
    [sym_fields] = STATE(9534),
    [sym_function] = STATE(9534),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9534),
    [sym_data_signature] = STATE(9534),
    [sym_record] = STATE(9534),
    [sym_record_signature] = STATE(9534),
    [sym_infix] = STATE(9534),
    [sym_generalize] = STATE(9534),
    [sym_mutual] = STATE(9534),
    [sym_abstract] = STATE(9534),
    [sym_private] = STATE(9534),
    [sym_instance] = STATE(9534),
    [sym_macro] = STATE(9534),
    [sym_postulate] = STATE(9534),
    [sym_primitive] = STATE(9534),
    [sym_open] = STATE(9534),
    [sym_import] = STATE(9534),
    [sym_module_macro] = STATE(9534),
    [sym_module] = STATE(9534),
    [sym_syntax] = STATE(9534),
    [sym_pattern] = STATE(9534),
    [sym_unquote_decl] = STATE(9534),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(162),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(592),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
  },
  [187] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9660),
    [sym_fields] = STATE(9660),
    [sym_function] = STATE(9660),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9660),
    [sym_data_signature] = STATE(9660),
    [sym_record] = STATE(9660),
    [sym_record_signature] = STATE(9660),
    [sym_infix] = STATE(9660),
    [sym_generalize] = STATE(9660),
    [sym_mutual] = STATE(9660),
    [sym_abstract] = STATE(9660),
    [sym_private] = STATE(9660),
    [sym_instance] = STATE(9660),
    [sym_macro] = STATE(9660),
    [sym_postulate] = STATE(9660),
    [sym_primitive] = STATE(9660),
    [sym_open] = STATE(9660),
    [sym_import] = STATE(9660),
    [sym_module_macro] = STATE(9660),
    [sym_module] = STATE(9660),
    [sym_syntax] = STATE(9660),
    [sym_pattern] = STATE(9660),
    [sym_unquote_decl] = STATE(9660),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(149),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(487),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
  },
  [188] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9541),
    [sym_fields] = STATE(9541),
    [sym_function] = STATE(9541),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9541),
    [sym_data_signature] = STATE(9541),
    [sym_record] = STATE(9541),
    [sym_record_signature] = STATE(9541),
    [sym_infix] = STATE(9541),
    [sym_generalize] = STATE(9541),
    [sym_mutual] = STATE(9541),
    [sym_abstract] = STATE(9541),
    [sym_private] = STATE(9541),
    [sym_instance] = STATE(9541),
    [sym_macro] = STATE(9541),
    [sym_postulate] = STATE(9541),
    [sym_primitive] = STATE(9541),
    [sym_open] = STATE(9541),
    [sym_import] = STATE(9541),
    [sym_module_macro] = STATE(9541),
    [sym_module] = STATE(9541),
    [sym_syntax] = STATE(9541),
    [sym_pattern] = STATE(9541),
    [sym_unquote_decl] = STATE(9541),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(162),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(594),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
  },
  [189] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9676),
    [sym_fields] = STATE(9676),
    [sym_function] = STATE(9676),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9676),
    [sym_data_signature] = STATE(9676),
    [sym_record] = STATE(9676),
    [sym_record_signature] = STATE(9676),
    [sym_infix] = STATE(9676),
    [sym_generalize] = STATE(9676),
    [sym_mutual] = STATE(9676),
    [sym_abstract] = STATE(9676),
    [sym_private] = STATE(9676),
    [sym_instance] = STATE(9676),
    [sym_macro] = STATE(9676),
    [sym_postulate] = STATE(9676),
    [sym_primitive] = STATE(9676),
    [sym_open] = STATE(9676),
    [sym_import] = STATE(9676),
    [sym_module_macro] = STATE(9676),
    [sym_module] = STATE(9676),
    [sym_syntax] = STATE(9676),
    [sym_pattern] = STATE(9676),
    [sym_unquote_decl] = STATE(9676),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(162),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(596),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
  },
  [190] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9676),
    [sym_fields] = STATE(9676),
    [sym_function] = STATE(9676),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9676),
    [sym_data_signature] = STATE(9676),
    [sym_record] = STATE(9676),
    [sym_record_signature] = STATE(9676),
    [sym_infix] = STATE(9676),
    [sym_generalize] = STATE(9676),
    [sym_mutual] = STATE(9676),
    [sym_abstract] = STATE(9676),
    [sym_private] = STATE(9676),
    [sym_instance] = STATE(9676),
    [sym_macro] = STATE(9676),
    [sym_postulate] = STATE(9676),
    [sym_primitive] = STATE(9676),
    [sym_open] = STATE(9676),
    [sym_import] = STATE(9676),
    [sym_module_macro] = STATE(9676),
    [sym_module] = STATE(9676),
    [sym_syntax] = STATE(9676),
    [sym_pattern] = STATE(9676),
    [sym_unquote_decl] = STATE(9676),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(126),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(596),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
  },
  [191] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9493),
    [sym_fields] = STATE(9493),
    [sym_function] = STATE(9493),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9493),
    [sym_data_signature] = STATE(9493),
    [sym_record] = STATE(9493),
    [sym_record_signature] = STATE(9493),
    [sym_infix] = STATE(9493),
    [sym_generalize] = STATE(9493),
    [sym_mutual] = STATE(9493),
    [sym_abstract] = STATE(9493),
    [sym_private] = STATE(9493),
    [sym_instance] = STATE(9493),
    [sym_macro] = STATE(9493),
    [sym_postulate] = STATE(9493),
    [sym_primitive] = STATE(9493),
    [sym_open] = STATE(9493),
    [sym_import] = STATE(9493),
    [sym_module_macro] = STATE(9493),
    [sym_module] = STATE(9493),
    [sym_syntax] = STATE(9493),
    [sym_pattern] = STATE(9493),
    [sym_unquote_decl] = STATE(9493),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(162),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(598),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
  },
  [192] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9674),
    [sym_fields] = STATE(9674),
    [sym_function] = STATE(9674),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9674),
    [sym_data_signature] = STATE(9674),
    [sym_record] = STATE(9674),
    [sym_record_signature] = STATE(9674),
    [sym_infix] = STATE(9674),
    [sym_generalize] = STATE(9674),
    [sym_mutual] = STATE(9674),
    [sym_abstract] = STATE(9674),
    [sym_private] = STATE(9674),
    [sym_instance] = STATE(9674),
    [sym_macro] = STATE(9674),
    [sym_postulate] = STATE(9674),
    [sym_primitive] = STATE(9674),
    [sym_open] = STATE(9674),
    [sym_import] = STATE(9674),
    [sym_module_macro] = STATE(9674),
    [sym_module] = STATE(9674),
    [sym_syntax] = STATE(9674),
    [sym_pattern] = STATE(9674),
    [sym_unquote_decl] = STATE(9674),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(163),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(491),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
  },
  [193] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9541),
    [sym_fields] = STATE(9541),
    [sym_function] = STATE(9541),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9541),
    [sym_data_signature] = STATE(9541),
    [sym_record] = STATE(9541),
    [sym_record_signature] = STATE(9541),
    [sym_infix] = STATE(9541),
    [sym_generalize] = STATE(9541),
    [sym_mutual] = STATE(9541),
    [sym_abstract] = STATE(9541),
    [sym_private] = STATE(9541),
    [sym_instance] = STATE(9541),
    [sym_macro] = STATE(9541),
    [sym_postulate] = STATE(9541),
    [sym_primitive] = STATE(9541),
    [sym_open] = STATE(9541),
    [sym_import] = STATE(9541),
    [sym_module_macro] = STATE(9541),
    [sym_module] = STATE(9541),
    [sym_syntax] = STATE(9541),
    [sym_pattern] = STATE(9541),
    [sym_unquote_decl] = STATE(9541),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(165),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(594),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
  },
  [194] = {
    [sym__FORALL] = STATE(8288),
    [sym__LAMBDA] = STATE(8114),
    [sym__ELLIPSIS] = STATE(4608),
    [sym__declaration] = STATE(11579),
    [sym_fields] = STATE(11579),
    [sym_function] = STATE(11579),
    [sym_lhs_decl] = STATE(9175),
    [sym_lhs_defn] = STATE(9174),
    [sym_data] = STATE(11579),
    [sym_data_signature] = STATE(11579),
    [sym_record] = STATE(11579),
    [sym_record_signature] = STATE(11579),
    [sym_infix] = STATE(11579),
    [sym_generalize] = STATE(11579),
    [sym_mutual] = STATE(11579),
    [sym_abstract] = STATE(11579),
    [sym_private] = STATE(11579),
    [sym_instance] = STATE(11579),
    [sym_macro] = STATE(11579),
    [sym_postulate] = STATE(11579),
    [sym_primitive] = STATE(11579),
    [sym_open] = STATE(11579),
    [sym_import] = STATE(11579),
    [sym_module_macro] = STATE(11579),
    [sym_module] = STATE(11579),
    [sym_syntax] = STATE(11579),
    [sym_pattern] = STATE(11579),
    [sym_unquote_decl] = STATE(11579),
    [sym__qid] = STATE(4608),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3129),
    [sym__with_exprs] = STATE(8953),
    [sym__expr_or_attr] = STATE(4608),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4600),
    [aux_sym__atoms] = STATE(3848),
    [sym__atom_curly] = STATE(4564),
    [sym__atom_no_curly] = STATE(4564),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4608),
    [sym_field_assignments] = STATE(4608),
    [sym_literal] = STATE(4608),
    [sym_SetN] = STATE(4608),
    [aux_sym_source_file_repeat1] = STATE(76),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3710),
    [sym_id] = ACTIONS(9),
    [anon_sym_forall] = ACTIONS(11),
    [anon_sym_u2200] = ACTIONS(11),
    [anon_sym_BSLASH] = ACTIONS(13),
    [anon_sym_u03bb] = ACTIONS(15),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(17),
    [anon_sym_u2026] = ACTIONS(17),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(23),
    [anon_sym_data] = ACTIONS(25),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(29),
    [anon_sym_infix] = ACTIONS(31),
    [anon_sym_infixl] = ACTIONS(31),
    [anon_sym_infixr] = ACTIONS(31),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(47),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(51),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(53),
    [anon_sym_u2983] = ACTIONS(55),
    [anon_sym__] = ACTIONS(17),
    [sym_pragma] = ACTIONS(99),
    [anon_sym_syntax] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_pattern] = ACTIONS(63),
    [anon_sym_unquoteDecl] = ACTIONS(65),
    [anon_sym_unquoteDef] = ACTIONS(67),
    [aux_sym__qid_token1] = ACTIONS(69),
    [anon_sym_DOT] = ACTIONS(71),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(75),
    [anon_sym_tactic] = ACTIONS(77),
    [anon_sym_Prop] = ACTIONS(17),
    [anon_sym_quote] = ACTIONS(17),
    [anon_sym_quoteTerm] = ACTIONS(17),
    [anon_sym_quoteContext] = ACTIONS(17),
    [anon_sym_unquote] = ACTIONS(17),
    [anon_sym_LPAREN_PIPE] = ACTIONS(79),
    [anon_sym_u2987] = ACTIONS(81),
    [anon_sym_let] = ACTIONS(83),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(87),
    [aux_sym_string_token1] = ACTIONS(87),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(89),
    [sym_PropN] = ACTIONS(17),
  },
  [195] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9610),
    [sym_fields] = STATE(9610),
    [sym_function] = STATE(9610),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9610),
    [sym_data_signature] = STATE(9610),
    [sym_record] = STATE(9610),
    [sym_record_signature] = STATE(9610),
    [sym_infix] = STATE(9610),
    [sym_generalize] = STATE(9610),
    [sym_mutual] = STATE(9610),
    [sym_abstract] = STATE(9610),
    [sym_private] = STATE(9610),
    [sym_instance] = STATE(9610),
    [sym_macro] = STATE(9610),
    [sym_postulate] = STATE(9610),
    [sym_primitive] = STATE(9610),
    [sym_open] = STATE(9610),
    [sym_import] = STATE(9610),
    [sym_module_macro] = STATE(9610),
    [sym_module] = STATE(9610),
    [sym_syntax] = STATE(9610),
    [sym_pattern] = STATE(9610),
    [sym_unquote_decl] = STATE(9610),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(162),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(572),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
  },
  [196] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9675),
    [sym_fields] = STATE(9675),
    [sym_function] = STATE(9675),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9675),
    [sym_data_signature] = STATE(9675),
    [sym_record] = STATE(9675),
    [sym_record_signature] = STATE(9675),
    [sym_infix] = STATE(9675),
    [sym_generalize] = STATE(9675),
    [sym_mutual] = STATE(9675),
    [sym_abstract] = STATE(9675),
    [sym_private] = STATE(9675),
    [sym_instance] = STATE(9675),
    [sym_macro] = STATE(9675),
    [sym_postulate] = STATE(9675),
    [sym_primitive] = STATE(9675),
    [sym_open] = STATE(9675),
    [sym_import] = STATE(9675),
    [sym_module_macro] = STATE(9675),
    [sym_module] = STATE(9675),
    [sym_syntax] = STATE(9675),
    [sym_pattern] = STATE(9675),
    [sym_unquote_decl] = STATE(9675),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(162),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(600),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
  },
  [197] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9675),
    [sym_fields] = STATE(9675),
    [sym_function] = STATE(9675),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9675),
    [sym_data_signature] = STATE(9675),
    [sym_record] = STATE(9675),
    [sym_record_signature] = STATE(9675),
    [sym_infix] = STATE(9675),
    [sym_generalize] = STATE(9675),
    [sym_mutual] = STATE(9675),
    [sym_abstract] = STATE(9675),
    [sym_private] = STATE(9675),
    [sym_instance] = STATE(9675),
    [sym_macro] = STATE(9675),
    [sym_postulate] = STATE(9675),
    [sym_primitive] = STATE(9675),
    [sym_open] = STATE(9675),
    [sym_import] = STATE(9675),
    [sym_module_macro] = STATE(9675),
    [sym_module] = STATE(9675),
    [sym_syntax] = STATE(9675),
    [sym_pattern] = STATE(9675),
    [sym_unquote_decl] = STATE(9675),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(139),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(600),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
  },
  [198] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9629),
    [sym_fields] = STATE(9629),
    [sym_function] = STATE(9629),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9629),
    [sym_data_signature] = STATE(9629),
    [sym_record] = STATE(9629),
    [sym_record_signature] = STATE(9629),
    [sym_infix] = STATE(9629),
    [sym_generalize] = STATE(9629),
    [sym_mutual] = STATE(9629),
    [sym_abstract] = STATE(9629),
    [sym_private] = STATE(9629),
    [sym_instance] = STATE(9629),
    [sym_macro] = STATE(9629),
    [sym_postulate] = STATE(9629),
    [sym_primitive] = STATE(9629),
    [sym_open] = STATE(9629),
    [sym_import] = STATE(9629),
    [sym_module_macro] = STATE(9629),
    [sym_module] = STATE(9629),
    [sym_syntax] = STATE(9629),
    [sym_pattern] = STATE(9629),
    [sym_unquote_decl] = STATE(9629),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(162),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(602),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
  },
  [199] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9656),
    [sym_fields] = STATE(9656),
    [sym_function] = STATE(9656),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9656),
    [sym_data_signature] = STATE(9656),
    [sym_record] = STATE(9656),
    [sym_record_signature] = STATE(9656),
    [sym_infix] = STATE(9656),
    [sym_generalize] = STATE(9656),
    [sym_mutual] = STATE(9656),
    [sym_abstract] = STATE(9656),
    [sym_private] = STATE(9656),
    [sym_instance] = STATE(9656),
    [sym_macro] = STATE(9656),
    [sym_postulate] = STATE(9656),
    [sym_primitive] = STATE(9656),
    [sym_open] = STATE(9656),
    [sym_import] = STATE(9656),
    [sym_module_macro] = STATE(9656),
    [sym_module] = STATE(9656),
    [sym_syntax] = STATE(9656),
    [sym_pattern] = STATE(9656),
    [sym_unquote_decl] = STATE(9656),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(162),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(604),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
  },
  [200] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9665),
    [sym_fields] = STATE(9665),
    [sym_function] = STATE(9665),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9665),
    [sym_data_signature] = STATE(9665),
    [sym_record] = STATE(9665),
    [sym_record_signature] = STATE(9665),
    [sym_infix] = STATE(9665),
    [sym_generalize] = STATE(9665),
    [sym_mutual] = STATE(9665),
    [sym_abstract] = STATE(9665),
    [sym_private] = STATE(9665),
    [sym_instance] = STATE(9665),
    [sym_macro] = STATE(9665),
    [sym_postulate] = STATE(9665),
    [sym_primitive] = STATE(9665),
    [sym_open] = STATE(9665),
    [sym_import] = STATE(9665),
    [sym_module_macro] = STATE(9665),
    [sym_module] = STATE(9665),
    [sym_syntax] = STATE(9665),
    [sym_pattern] = STATE(9665),
    [sym_unquote_decl] = STATE(9665),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(162),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(606),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
  },
  [201] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9694),
    [sym_fields] = STATE(9694),
    [sym_function] = STATE(9694),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9694),
    [sym_data_signature] = STATE(9694),
    [sym_record] = STATE(9694),
    [sym_record_signature] = STATE(9694),
    [sym_infix] = STATE(9694),
    [sym_generalize] = STATE(9694),
    [sym_mutual] = STATE(9694),
    [sym_abstract] = STATE(9694),
    [sym_private] = STATE(9694),
    [sym_instance] = STATE(9694),
    [sym_macro] = STATE(9694),
    [sym_postulate] = STATE(9694),
    [sym_primitive] = STATE(9694),
    [sym_open] = STATE(9694),
    [sym_import] = STATE(9694),
    [sym_module_macro] = STATE(9694),
    [sym_module] = STATE(9694),
    [sym_syntax] = STATE(9694),
    [sym_pattern] = STATE(9694),
    [sym_unquote_decl] = STATE(9694),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(162),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(608),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
  },
  [202] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9665),
    [sym_fields] = STATE(9665),
    [sym_function] = STATE(9665),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9665),
    [sym_data_signature] = STATE(9665),
    [sym_record] = STATE(9665),
    [sym_record_signature] = STATE(9665),
    [sym_infix] = STATE(9665),
    [sym_generalize] = STATE(9665),
    [sym_mutual] = STATE(9665),
    [sym_abstract] = STATE(9665),
    [sym_private] = STATE(9665),
    [sym_instance] = STATE(9665),
    [sym_macro] = STATE(9665),
    [sym_postulate] = STATE(9665),
    [sym_primitive] = STATE(9665),
    [sym_open] = STATE(9665),
    [sym_import] = STATE(9665),
    [sym_module_macro] = STATE(9665),
    [sym_module] = STATE(9665),
    [sym_syntax] = STATE(9665),
    [sym_pattern] = STATE(9665),
    [sym_unquote_decl] = STATE(9665),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(153),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(606),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
  },
  [203] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9652),
    [sym_fields] = STATE(9652),
    [sym_function] = STATE(9652),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9652),
    [sym_data_signature] = STATE(9652),
    [sym_record] = STATE(9652),
    [sym_record_signature] = STATE(9652),
    [sym_infix] = STATE(9652),
    [sym_generalize] = STATE(9652),
    [sym_mutual] = STATE(9652),
    [sym_abstract] = STATE(9652),
    [sym_private] = STATE(9652),
    [sym_instance] = STATE(9652),
    [sym_macro] = STATE(9652),
    [sym_postulate] = STATE(9652),
    [sym_primitive] = STATE(9652),
    [sym_open] = STATE(9652),
    [sym_import] = STATE(9652),
    [sym_module_macro] = STATE(9652),
    [sym_module] = STATE(9652),
    [sym_syntax] = STATE(9652),
    [sym_pattern] = STATE(9652),
    [sym_unquote_decl] = STATE(9652),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(162),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(610),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
  },
  [204] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9573),
    [sym_fields] = STATE(9573),
    [sym_function] = STATE(9573),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9573),
    [sym_data_signature] = STATE(9573),
    [sym_record] = STATE(9573),
    [sym_record_signature] = STATE(9573),
    [sym_infix] = STATE(9573),
    [sym_generalize] = STATE(9573),
    [sym_mutual] = STATE(9573),
    [sym_abstract] = STATE(9573),
    [sym_private] = STATE(9573),
    [sym_instance] = STATE(9573),
    [sym_macro] = STATE(9573),
    [sym_postulate] = STATE(9573),
    [sym_primitive] = STATE(9573),
    [sym_open] = STATE(9573),
    [sym_import] = STATE(9573),
    [sym_module_macro] = STATE(9573),
    [sym_module] = STATE(9573),
    [sym_syntax] = STATE(9573),
    [sym_pattern] = STATE(9573),
    [sym_unquote_decl] = STATE(9573),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(162),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(612),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
  },
  [205] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9509),
    [sym_fields] = STATE(9509),
    [sym_function] = STATE(9509),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9509),
    [sym_data_signature] = STATE(9509),
    [sym_record] = STATE(9509),
    [sym_record_signature] = STATE(9509),
    [sym_infix] = STATE(9509),
    [sym_generalize] = STATE(9509),
    [sym_mutual] = STATE(9509),
    [sym_abstract] = STATE(9509),
    [sym_private] = STATE(9509),
    [sym_instance] = STATE(9509),
    [sym_macro] = STATE(9509),
    [sym_postulate] = STATE(9509),
    [sym_primitive] = STATE(9509),
    [sym_open] = STATE(9509),
    [sym_import] = STATE(9509),
    [sym_module_macro] = STATE(9509),
    [sym_module] = STATE(9509),
    [sym_syntax] = STATE(9509),
    [sym_pattern] = STATE(9509),
    [sym_unquote_decl] = STATE(9509),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(152),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(614),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
  },
  [206] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9611),
    [sym_fields] = STATE(9611),
    [sym_function] = STATE(9611),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9611),
    [sym_data_signature] = STATE(9611),
    [sym_record] = STATE(9611),
    [sym_record_signature] = STATE(9611),
    [sym_infix] = STATE(9611),
    [sym_generalize] = STATE(9611),
    [sym_mutual] = STATE(9611),
    [sym_abstract] = STATE(9611),
    [sym_private] = STATE(9611),
    [sym_instance] = STATE(9611),
    [sym_macro] = STATE(9611),
    [sym_postulate] = STATE(9611),
    [sym_primitive] = STATE(9611),
    [sym_open] = STATE(9611),
    [sym_import] = STATE(9611),
    [sym_module_macro] = STATE(9611),
    [sym_module] = STATE(9611),
    [sym_syntax] = STATE(9611),
    [sym_pattern] = STATE(9611),
    [sym_unquote_decl] = STATE(9611),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(162),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(616),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
  },
  [207] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9611),
    [sym_fields] = STATE(9611),
    [sym_function] = STATE(9611),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9611),
    [sym_data_signature] = STATE(9611),
    [sym_record] = STATE(9611),
    [sym_record_signature] = STATE(9611),
    [sym_infix] = STATE(9611),
    [sym_generalize] = STATE(9611),
    [sym_mutual] = STATE(9611),
    [sym_abstract] = STATE(9611),
    [sym_private] = STATE(9611),
    [sym_instance] = STATE(9611),
    [sym_macro] = STATE(9611),
    [sym_postulate] = STATE(9611),
    [sym_primitive] = STATE(9611),
    [sym_open] = STATE(9611),
    [sym_import] = STATE(9611),
    [sym_module_macro] = STATE(9611),
    [sym_module] = STATE(9611),
    [sym_syntax] = STATE(9611),
    [sym_pattern] = STATE(9611),
    [sym_unquote_decl] = STATE(9611),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(164),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(616),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
  },
  [208] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9598),
    [sym_fields] = STATE(9598),
    [sym_function] = STATE(9598),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9598),
    [sym_data_signature] = STATE(9598),
    [sym_record] = STATE(9598),
    [sym_record_signature] = STATE(9598),
    [sym_infix] = STATE(9598),
    [sym_generalize] = STATE(9598),
    [sym_mutual] = STATE(9598),
    [sym_abstract] = STATE(9598),
    [sym_private] = STATE(9598),
    [sym_instance] = STATE(9598),
    [sym_macro] = STATE(9598),
    [sym_postulate] = STATE(9598),
    [sym_primitive] = STATE(9598),
    [sym_open] = STATE(9598),
    [sym_import] = STATE(9598),
    [sym_module_macro] = STATE(9598),
    [sym_module] = STATE(9598),
    [sym_syntax] = STATE(9598),
    [sym_pattern] = STATE(9598),
    [sym_unquote_decl] = STATE(9598),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(162),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(618),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
  },
  [209] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9516),
    [sym_fields] = STATE(9516),
    [sym_function] = STATE(9516),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9516),
    [sym_data_signature] = STATE(9516),
    [sym_record] = STATE(9516),
    [sym_record_signature] = STATE(9516),
    [sym_infix] = STATE(9516),
    [sym_generalize] = STATE(9516),
    [sym_mutual] = STATE(9516),
    [sym_abstract] = STATE(9516),
    [sym_private] = STATE(9516),
    [sym_instance] = STATE(9516),
    [sym_macro] = STATE(9516),
    [sym_postulate] = STATE(9516),
    [sym_primitive] = STATE(9516),
    [sym_open] = STATE(9516),
    [sym_import] = STATE(9516),
    [sym_module_macro] = STATE(9516),
    [sym_module] = STATE(9516),
    [sym_syntax] = STATE(9516),
    [sym_pattern] = STATE(9516),
    [sym_unquote_decl] = STATE(9516),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(162),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(620),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
  },
  [210] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9509),
    [sym_fields] = STATE(9509),
    [sym_function] = STATE(9509),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9509),
    [sym_data_signature] = STATE(9509),
    [sym_record] = STATE(9509),
    [sym_record_signature] = STATE(9509),
    [sym_infix] = STATE(9509),
    [sym_generalize] = STATE(9509),
    [sym_mutual] = STATE(9509),
    [sym_abstract] = STATE(9509),
    [sym_private] = STATE(9509),
    [sym_instance] = STATE(9509),
    [sym_macro] = STATE(9509),
    [sym_postulate] = STATE(9509),
    [sym_primitive] = STATE(9509),
    [sym_open] = STATE(9509),
    [sym_import] = STATE(9509),
    [sym_module_macro] = STATE(9509),
    [sym_module] = STATE(9509),
    [sym_syntax] = STATE(9509),
    [sym_pattern] = STATE(9509),
    [sym_unquote_decl] = STATE(9509),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(162),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(614),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
  },
  [211] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9511),
    [sym_fields] = STATE(9511),
    [sym_function] = STATE(9511),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9511),
    [sym_data_signature] = STATE(9511),
    [sym_record] = STATE(9511),
    [sym_record_signature] = STATE(9511),
    [sym_infix] = STATE(9511),
    [sym_generalize] = STATE(9511),
    [sym_mutual] = STATE(9511),
    [sym_abstract] = STATE(9511),
    [sym_private] = STATE(9511),
    [sym_instance] = STATE(9511),
    [sym_macro] = STATE(9511),
    [sym_postulate] = STATE(9511),
    [sym_primitive] = STATE(9511),
    [sym_open] = STATE(9511),
    [sym_import] = STATE(9511),
    [sym_module_macro] = STATE(9511),
    [sym_module] = STATE(9511),
    [sym_syntax] = STATE(9511),
    [sym_pattern] = STATE(9511),
    [sym_unquote_decl] = STATE(9511),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(162),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(622),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
  },
  [212] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9656),
    [sym_fields] = STATE(9656),
    [sym_function] = STATE(9656),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9656),
    [sym_data_signature] = STATE(9656),
    [sym_record] = STATE(9656),
    [sym_record_signature] = STATE(9656),
    [sym_infix] = STATE(9656),
    [sym_generalize] = STATE(9656),
    [sym_mutual] = STATE(9656),
    [sym_abstract] = STATE(9656),
    [sym_private] = STATE(9656),
    [sym_instance] = STATE(9656),
    [sym_macro] = STATE(9656),
    [sym_postulate] = STATE(9656),
    [sym_primitive] = STATE(9656),
    [sym_open] = STATE(9656),
    [sym_import] = STATE(9656),
    [sym_module_macro] = STATE(9656),
    [sym_module] = STATE(9656),
    [sym_syntax] = STATE(9656),
    [sym_pattern] = STATE(9656),
    [sym_unquote_decl] = STATE(9656),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(249),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(604),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
  },
  [213] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9688),
    [sym_fields] = STATE(9688),
    [sym_function] = STATE(9688),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9688),
    [sym_data_signature] = STATE(9688),
    [sym_record] = STATE(9688),
    [sym_record_signature] = STATE(9688),
    [sym_infix] = STATE(9688),
    [sym_generalize] = STATE(9688),
    [sym_mutual] = STATE(9688),
    [sym_abstract] = STATE(9688),
    [sym_private] = STATE(9688),
    [sym_instance] = STATE(9688),
    [sym_macro] = STATE(9688),
    [sym_postulate] = STATE(9688),
    [sym_primitive] = STATE(9688),
    [sym_open] = STATE(9688),
    [sym_import] = STATE(9688),
    [sym_module_macro] = STATE(9688),
    [sym_module] = STATE(9688),
    [sym_syntax] = STATE(9688),
    [sym_pattern] = STATE(9688),
    [sym_unquote_decl] = STATE(9688),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(162),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(624),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
  },
  [214] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9563),
    [sym_fields] = STATE(9563),
    [sym_function] = STATE(9563),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9563),
    [sym_data_signature] = STATE(9563),
    [sym_record] = STATE(9563),
    [sym_record_signature] = STATE(9563),
    [sym_infix] = STATE(9563),
    [sym_generalize] = STATE(9563),
    [sym_mutual] = STATE(9563),
    [sym_abstract] = STATE(9563),
    [sym_private] = STATE(9563),
    [sym_instance] = STATE(9563),
    [sym_macro] = STATE(9563),
    [sym_postulate] = STATE(9563),
    [sym_primitive] = STATE(9563),
    [sym_open] = STATE(9563),
    [sym_import] = STATE(9563),
    [sym_module_macro] = STATE(9563),
    [sym_module] = STATE(9563),
    [sym_syntax] = STATE(9563),
    [sym_pattern] = STATE(9563),
    [sym_unquote_decl] = STATE(9563),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(225),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(626),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
  },
  [215] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9563),
    [sym_fields] = STATE(9563),
    [sym_function] = STATE(9563),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9563),
    [sym_data_signature] = STATE(9563),
    [sym_record] = STATE(9563),
    [sym_record_signature] = STATE(9563),
    [sym_infix] = STATE(9563),
    [sym_generalize] = STATE(9563),
    [sym_mutual] = STATE(9563),
    [sym_abstract] = STATE(9563),
    [sym_private] = STATE(9563),
    [sym_instance] = STATE(9563),
    [sym_macro] = STATE(9563),
    [sym_postulate] = STATE(9563),
    [sym_primitive] = STATE(9563),
    [sym_open] = STATE(9563),
    [sym_import] = STATE(9563),
    [sym_module_macro] = STATE(9563),
    [sym_module] = STATE(9563),
    [sym_syntax] = STATE(9563),
    [sym_pattern] = STATE(9563),
    [sym_unquote_decl] = STATE(9563),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(162),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(626),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
  },
  [216] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9593),
    [sym_fields] = STATE(9593),
    [sym_function] = STATE(9593),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9593),
    [sym_data_signature] = STATE(9593),
    [sym_record] = STATE(9593),
    [sym_record_signature] = STATE(9593),
    [sym_infix] = STATE(9593),
    [sym_generalize] = STATE(9593),
    [sym_mutual] = STATE(9593),
    [sym_abstract] = STATE(9593),
    [sym_private] = STATE(9593),
    [sym_instance] = STATE(9593),
    [sym_macro] = STATE(9593),
    [sym_postulate] = STATE(9593),
    [sym_primitive] = STATE(9593),
    [sym_open] = STATE(9593),
    [sym_import] = STATE(9593),
    [sym_module_macro] = STATE(9593),
    [sym_module] = STATE(9593),
    [sym_syntax] = STATE(9593),
    [sym_pattern] = STATE(9593),
    [sym_unquote_decl] = STATE(9593),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(162),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(551),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
  },
  [217] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9591),
    [sym_fields] = STATE(9591),
    [sym_function] = STATE(9591),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9591),
    [sym_data_signature] = STATE(9591),
    [sym_record] = STATE(9591),
    [sym_record_signature] = STATE(9591),
    [sym_infix] = STATE(9591),
    [sym_generalize] = STATE(9591),
    [sym_mutual] = STATE(9591),
    [sym_abstract] = STATE(9591),
    [sym_private] = STATE(9591),
    [sym_instance] = STATE(9591),
    [sym_macro] = STATE(9591),
    [sym_postulate] = STATE(9591),
    [sym_primitive] = STATE(9591),
    [sym_open] = STATE(9591),
    [sym_import] = STATE(9591),
    [sym_module_macro] = STATE(9591),
    [sym_module] = STATE(9591),
    [sym_syntax] = STATE(9591),
    [sym_pattern] = STATE(9591),
    [sym_unquote_decl] = STATE(9591),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(162),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(628),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
  },
  [218] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9646),
    [sym_fields] = STATE(9646),
    [sym_function] = STATE(9646),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9646),
    [sym_data_signature] = STATE(9646),
    [sym_record] = STATE(9646),
    [sym_record_signature] = STATE(9646),
    [sym_infix] = STATE(9646),
    [sym_generalize] = STATE(9646),
    [sym_mutual] = STATE(9646),
    [sym_abstract] = STATE(9646),
    [sym_private] = STATE(9646),
    [sym_instance] = STATE(9646),
    [sym_macro] = STATE(9646),
    [sym_postulate] = STATE(9646),
    [sym_primitive] = STATE(9646),
    [sym_open] = STATE(9646),
    [sym_import] = STATE(9646),
    [sym_module_macro] = STATE(9646),
    [sym_module] = STATE(9646),
    [sym_syntax] = STATE(9646),
    [sym_pattern] = STATE(9646),
    [sym_unquote_decl] = STATE(9646),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(162),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(630),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
  },
  [219] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9646),
    [sym_fields] = STATE(9646),
    [sym_function] = STATE(9646),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9646),
    [sym_data_signature] = STATE(9646),
    [sym_record] = STATE(9646),
    [sym_record_signature] = STATE(9646),
    [sym_infix] = STATE(9646),
    [sym_generalize] = STATE(9646),
    [sym_mutual] = STATE(9646),
    [sym_abstract] = STATE(9646),
    [sym_private] = STATE(9646),
    [sym_instance] = STATE(9646),
    [sym_macro] = STATE(9646),
    [sym_postulate] = STATE(9646),
    [sym_primitive] = STATE(9646),
    [sym_open] = STATE(9646),
    [sym_import] = STATE(9646),
    [sym_module_macro] = STATE(9646),
    [sym_module] = STATE(9646),
    [sym_syntax] = STATE(9646),
    [sym_pattern] = STATE(9646),
    [sym_unquote_decl] = STATE(9646),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(177),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(630),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
  },
  [220] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9586),
    [sym_fields] = STATE(9586),
    [sym_function] = STATE(9586),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9586),
    [sym_data_signature] = STATE(9586),
    [sym_record] = STATE(9586),
    [sym_record_signature] = STATE(9586),
    [sym_infix] = STATE(9586),
    [sym_generalize] = STATE(9586),
    [sym_mutual] = STATE(9586),
    [sym_abstract] = STATE(9586),
    [sym_private] = STATE(9586),
    [sym_instance] = STATE(9586),
    [sym_macro] = STATE(9586),
    [sym_postulate] = STATE(9586),
    [sym_primitive] = STATE(9586),
    [sym_open] = STATE(9586),
    [sym_import] = STATE(9586),
    [sym_module_macro] = STATE(9586),
    [sym_module] = STATE(9586),
    [sym_syntax] = STATE(9586),
    [sym_pattern] = STATE(9586),
    [sym_unquote_decl] = STATE(9586),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(162),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(632),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
  },
  [221] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9627),
    [sym_fields] = STATE(9627),
    [sym_function] = STATE(9627),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9627),
    [sym_data_signature] = STATE(9627),
    [sym_record] = STATE(9627),
    [sym_record_signature] = STATE(9627),
    [sym_infix] = STATE(9627),
    [sym_generalize] = STATE(9627),
    [sym_mutual] = STATE(9627),
    [sym_abstract] = STATE(9627),
    [sym_private] = STATE(9627),
    [sym_instance] = STATE(9627),
    [sym_macro] = STATE(9627),
    [sym_postulate] = STATE(9627),
    [sym_primitive] = STATE(9627),
    [sym_open] = STATE(9627),
    [sym_import] = STATE(9627),
    [sym_module_macro] = STATE(9627),
    [sym_module] = STATE(9627),
    [sym_syntax] = STATE(9627),
    [sym_pattern] = STATE(9627),
    [sym_unquote_decl] = STATE(9627),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(162),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(634),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
  },
  [222] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9627),
    [sym_fields] = STATE(9627),
    [sym_function] = STATE(9627),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9627),
    [sym_data_signature] = STATE(9627),
    [sym_record] = STATE(9627),
    [sym_record_signature] = STATE(9627),
    [sym_infix] = STATE(9627),
    [sym_generalize] = STATE(9627),
    [sym_mutual] = STATE(9627),
    [sym_abstract] = STATE(9627),
    [sym_private] = STATE(9627),
    [sym_instance] = STATE(9627),
    [sym_macro] = STATE(9627),
    [sym_postulate] = STATE(9627),
    [sym_primitive] = STATE(9627),
    [sym_open] = STATE(9627),
    [sym_import] = STATE(9627),
    [sym_module_macro] = STATE(9627),
    [sym_module] = STATE(9627),
    [sym_syntax] = STATE(9627),
    [sym_pattern] = STATE(9627),
    [sym_unquote_decl] = STATE(9627),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(201),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(634),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
  },
  [223] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9520),
    [sym_fields] = STATE(9520),
    [sym_function] = STATE(9520),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9520),
    [sym_data_signature] = STATE(9520),
    [sym_record] = STATE(9520),
    [sym_record_signature] = STATE(9520),
    [sym_infix] = STATE(9520),
    [sym_generalize] = STATE(9520),
    [sym_mutual] = STATE(9520),
    [sym_abstract] = STATE(9520),
    [sym_private] = STATE(9520),
    [sym_instance] = STATE(9520),
    [sym_macro] = STATE(9520),
    [sym_postulate] = STATE(9520),
    [sym_primitive] = STATE(9520),
    [sym_open] = STATE(9520),
    [sym_import] = STATE(9520),
    [sym_module_macro] = STATE(9520),
    [sym_module] = STATE(9520),
    [sym_syntax] = STATE(9520),
    [sym_pattern] = STATE(9520),
    [sym_unquote_decl] = STATE(9520),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(162),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(636),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
  },
  [224] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9618),
    [sym_fields] = STATE(9618),
    [sym_function] = STATE(9618),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9618),
    [sym_data_signature] = STATE(9618),
    [sym_record] = STATE(9618),
    [sym_record_signature] = STATE(9618),
    [sym_infix] = STATE(9618),
    [sym_generalize] = STATE(9618),
    [sym_mutual] = STATE(9618),
    [sym_abstract] = STATE(9618),
    [sym_private] = STATE(9618),
    [sym_instance] = STATE(9618),
    [sym_macro] = STATE(9618),
    [sym_postulate] = STATE(9618),
    [sym_primitive] = STATE(9618),
    [sym_open] = STATE(9618),
    [sym_import] = STATE(9618),
    [sym_module_macro] = STATE(9618),
    [sym_module] = STATE(9618),
    [sym_syntax] = STATE(9618),
    [sym_pattern] = STATE(9618),
    [sym_unquote_decl] = STATE(9618),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(162),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(638),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
  },
  [225] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9638),
    [sym_fields] = STATE(9638),
    [sym_function] = STATE(9638),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9638),
    [sym_data_signature] = STATE(9638),
    [sym_record] = STATE(9638),
    [sym_record_signature] = STATE(9638),
    [sym_infix] = STATE(9638),
    [sym_generalize] = STATE(9638),
    [sym_mutual] = STATE(9638),
    [sym_abstract] = STATE(9638),
    [sym_private] = STATE(9638),
    [sym_instance] = STATE(9638),
    [sym_macro] = STATE(9638),
    [sym_postulate] = STATE(9638),
    [sym_primitive] = STATE(9638),
    [sym_open] = STATE(9638),
    [sym_import] = STATE(9638),
    [sym_module_macro] = STATE(9638),
    [sym_module] = STATE(9638),
    [sym_syntax] = STATE(9638),
    [sym_pattern] = STATE(9638),
    [sym_unquote_decl] = STATE(9638),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(162),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(640),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
  },
  [226] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9520),
    [sym_fields] = STATE(9520),
    [sym_function] = STATE(9520),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9520),
    [sym_data_signature] = STATE(9520),
    [sym_record] = STATE(9520),
    [sym_record_signature] = STATE(9520),
    [sym_infix] = STATE(9520),
    [sym_generalize] = STATE(9520),
    [sym_mutual] = STATE(9520),
    [sym_abstract] = STATE(9520),
    [sym_private] = STATE(9520),
    [sym_instance] = STATE(9520),
    [sym_macro] = STATE(9520),
    [sym_postulate] = STATE(9520),
    [sym_primitive] = STATE(9520),
    [sym_open] = STATE(9520),
    [sym_import] = STATE(9520),
    [sym_module_macro] = STATE(9520),
    [sym_module] = STATE(9520),
    [sym_syntax] = STATE(9520),
    [sym_pattern] = STATE(9520),
    [sym_unquote_decl] = STATE(9520),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(186),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(636),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
  },
  [227] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9677),
    [sym_fields] = STATE(9677),
    [sym_function] = STATE(9677),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9677),
    [sym_data_signature] = STATE(9677),
    [sym_record] = STATE(9677),
    [sym_record_signature] = STATE(9677),
    [sym_infix] = STATE(9677),
    [sym_generalize] = STATE(9677),
    [sym_mutual] = STATE(9677),
    [sym_abstract] = STATE(9677),
    [sym_private] = STATE(9677),
    [sym_instance] = STATE(9677),
    [sym_macro] = STATE(9677),
    [sym_postulate] = STATE(9677),
    [sym_primitive] = STATE(9677),
    [sym_open] = STATE(9677),
    [sym_import] = STATE(9677),
    [sym_module_macro] = STATE(9677),
    [sym_module] = STATE(9677),
    [sym_syntax] = STATE(9677),
    [sym_pattern] = STATE(9677),
    [sym_unquote_decl] = STATE(9677),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(162),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(642),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
  },
  [228] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9602),
    [sym_fields] = STATE(9602),
    [sym_function] = STATE(9602),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9602),
    [sym_data_signature] = STATE(9602),
    [sym_record] = STATE(9602),
    [sym_record_signature] = STATE(9602),
    [sym_infix] = STATE(9602),
    [sym_generalize] = STATE(9602),
    [sym_mutual] = STATE(9602),
    [sym_abstract] = STATE(9602),
    [sym_private] = STATE(9602),
    [sym_instance] = STATE(9602),
    [sym_macro] = STATE(9602),
    [sym_postulate] = STATE(9602),
    [sym_primitive] = STATE(9602),
    [sym_open] = STATE(9602),
    [sym_import] = STATE(9602),
    [sym_module_macro] = STATE(9602),
    [sym_module] = STATE(9602),
    [sym_syntax] = STATE(9602),
    [sym_pattern] = STATE(9602),
    [sym_unquote_decl] = STATE(9602),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(162),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(644),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
  },
  [229] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9602),
    [sym_fields] = STATE(9602),
    [sym_function] = STATE(9602),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9602),
    [sym_data_signature] = STATE(9602),
    [sym_record] = STATE(9602),
    [sym_record_signature] = STATE(9602),
    [sym_infix] = STATE(9602),
    [sym_generalize] = STATE(9602),
    [sym_mutual] = STATE(9602),
    [sym_abstract] = STATE(9602),
    [sym_private] = STATE(9602),
    [sym_instance] = STATE(9602),
    [sym_macro] = STATE(9602),
    [sym_postulate] = STATE(9602),
    [sym_primitive] = STATE(9602),
    [sym_open] = STATE(9602),
    [sym_import] = STATE(9602),
    [sym_module_macro] = STATE(9602),
    [sym_module] = STATE(9602),
    [sym_syntax] = STATE(9602),
    [sym_pattern] = STATE(9602),
    [sym_unquote_decl] = STATE(9602),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(227),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(644),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
  },
  [230] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9597),
    [sym_fields] = STATE(9597),
    [sym_function] = STATE(9597),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9597),
    [sym_data_signature] = STATE(9597),
    [sym_record] = STATE(9597),
    [sym_record_signature] = STATE(9597),
    [sym_infix] = STATE(9597),
    [sym_generalize] = STATE(9597),
    [sym_mutual] = STATE(9597),
    [sym_abstract] = STATE(9597),
    [sym_private] = STATE(9597),
    [sym_instance] = STATE(9597),
    [sym_macro] = STATE(9597),
    [sym_postulate] = STATE(9597),
    [sym_primitive] = STATE(9597),
    [sym_open] = STATE(9597),
    [sym_import] = STATE(9597),
    [sym_module_macro] = STATE(9597),
    [sym_module] = STATE(9597),
    [sym_syntax] = STATE(9597),
    [sym_pattern] = STATE(9597),
    [sym_unquote_decl] = STATE(9597),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(162),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(646),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
  },
  [231] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9614),
    [sym_fields] = STATE(9614),
    [sym_function] = STATE(9614),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9614),
    [sym_data_signature] = STATE(9614),
    [sym_record] = STATE(9614),
    [sym_record_signature] = STATE(9614),
    [sym_infix] = STATE(9614),
    [sym_generalize] = STATE(9614),
    [sym_mutual] = STATE(9614),
    [sym_abstract] = STATE(9614),
    [sym_private] = STATE(9614),
    [sym_instance] = STATE(9614),
    [sym_macro] = STATE(9614),
    [sym_postulate] = STATE(9614),
    [sym_primitive] = STATE(9614),
    [sym_open] = STATE(9614),
    [sym_import] = STATE(9614),
    [sym_module_macro] = STATE(9614),
    [sym_module] = STATE(9614),
    [sym_syntax] = STATE(9614),
    [sym_pattern] = STATE(9614),
    [sym_unquote_decl] = STATE(9614),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(162),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(648),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
  },
  [232] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9614),
    [sym_fields] = STATE(9614),
    [sym_function] = STATE(9614),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9614),
    [sym_data_signature] = STATE(9614),
    [sym_record] = STATE(9614),
    [sym_record_signature] = STATE(9614),
    [sym_infix] = STATE(9614),
    [sym_generalize] = STATE(9614),
    [sym_mutual] = STATE(9614),
    [sym_abstract] = STATE(9614),
    [sym_private] = STATE(9614),
    [sym_instance] = STATE(9614),
    [sym_macro] = STATE(9614),
    [sym_postulate] = STATE(9614),
    [sym_primitive] = STATE(9614),
    [sym_open] = STATE(9614),
    [sym_import] = STATE(9614),
    [sym_module_macro] = STATE(9614),
    [sym_module] = STATE(9614),
    [sym_syntax] = STATE(9614),
    [sym_pattern] = STATE(9614),
    [sym_unquote_decl] = STATE(9614),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(148),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(648),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
  },
  [233] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9557),
    [sym_fields] = STATE(9557),
    [sym_function] = STATE(9557),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9557),
    [sym_data_signature] = STATE(9557),
    [sym_record] = STATE(9557),
    [sym_record_signature] = STATE(9557),
    [sym_infix] = STATE(9557),
    [sym_generalize] = STATE(9557),
    [sym_mutual] = STATE(9557),
    [sym_abstract] = STATE(9557),
    [sym_private] = STATE(9557),
    [sym_instance] = STATE(9557),
    [sym_macro] = STATE(9557),
    [sym_postulate] = STATE(9557),
    [sym_primitive] = STATE(9557),
    [sym_open] = STATE(9557),
    [sym_import] = STATE(9557),
    [sym_module_macro] = STATE(9557),
    [sym_module] = STATE(9557),
    [sym_syntax] = STATE(9557),
    [sym_pattern] = STATE(9557),
    [sym_unquote_decl] = STATE(9557),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(162),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(650),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
  },
  [234] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9657),
    [sym_fields] = STATE(9657),
    [sym_function] = STATE(9657),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9657),
    [sym_data_signature] = STATE(9657),
    [sym_record] = STATE(9657),
    [sym_record_signature] = STATE(9657),
    [sym_infix] = STATE(9657),
    [sym_generalize] = STATE(9657),
    [sym_mutual] = STATE(9657),
    [sym_abstract] = STATE(9657),
    [sym_private] = STATE(9657),
    [sym_instance] = STATE(9657),
    [sym_macro] = STATE(9657),
    [sym_postulate] = STATE(9657),
    [sym_primitive] = STATE(9657),
    [sym_open] = STATE(9657),
    [sym_import] = STATE(9657),
    [sym_module_macro] = STATE(9657),
    [sym_module] = STATE(9657),
    [sym_syntax] = STATE(9657),
    [sym_pattern] = STATE(9657),
    [sym_unquote_decl] = STATE(9657),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(162),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(652),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
  },
  [235] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9633),
    [sym_fields] = STATE(9633),
    [sym_function] = STATE(9633),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9633),
    [sym_data_signature] = STATE(9633),
    [sym_record] = STATE(9633),
    [sym_record_signature] = STATE(9633),
    [sym_infix] = STATE(9633),
    [sym_generalize] = STATE(9633),
    [sym_mutual] = STATE(9633),
    [sym_abstract] = STATE(9633),
    [sym_private] = STATE(9633),
    [sym_instance] = STATE(9633),
    [sym_macro] = STATE(9633),
    [sym_postulate] = STATE(9633),
    [sym_primitive] = STATE(9633),
    [sym_open] = STATE(9633),
    [sym_import] = STATE(9633),
    [sym_module_macro] = STATE(9633),
    [sym_module] = STATE(9633),
    [sym_syntax] = STATE(9633),
    [sym_pattern] = STATE(9633),
    [sym_unquote_decl] = STATE(9633),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(162),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(654),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
  },
  [236] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9582),
    [sym_fields] = STATE(9582),
    [sym_function] = STATE(9582),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9582),
    [sym_data_signature] = STATE(9582),
    [sym_record] = STATE(9582),
    [sym_record_signature] = STATE(9582),
    [sym_infix] = STATE(9582),
    [sym_generalize] = STATE(9582),
    [sym_mutual] = STATE(9582),
    [sym_abstract] = STATE(9582),
    [sym_private] = STATE(9582),
    [sym_instance] = STATE(9582),
    [sym_macro] = STATE(9582),
    [sym_postulate] = STATE(9582),
    [sym_primitive] = STATE(9582),
    [sym_open] = STATE(9582),
    [sym_import] = STATE(9582),
    [sym_module_macro] = STATE(9582),
    [sym_module] = STATE(9582),
    [sym_syntax] = STATE(9582),
    [sym_pattern] = STATE(9582),
    [sym_unquote_decl] = STATE(9582),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(162),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(656),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
  },
  [237] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9582),
    [sym_fields] = STATE(9582),
    [sym_function] = STATE(9582),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9582),
    [sym_data_signature] = STATE(9582),
    [sym_record] = STATE(9582),
    [sym_record_signature] = STATE(9582),
    [sym_infix] = STATE(9582),
    [sym_generalize] = STATE(9582),
    [sym_mutual] = STATE(9582),
    [sym_abstract] = STATE(9582),
    [sym_private] = STATE(9582),
    [sym_instance] = STATE(9582),
    [sym_macro] = STATE(9582),
    [sym_postulate] = STATE(9582),
    [sym_primitive] = STATE(9582),
    [sym_open] = STATE(9582),
    [sym_import] = STATE(9582),
    [sym_module_macro] = STATE(9582),
    [sym_module] = STATE(9582),
    [sym_syntax] = STATE(9582),
    [sym_pattern] = STATE(9582),
    [sym_unquote_decl] = STATE(9582),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(234),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(656),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
  },
  [238] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9634),
    [sym_fields] = STATE(9634),
    [sym_function] = STATE(9634),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9634),
    [sym_data_signature] = STATE(9634),
    [sym_record] = STATE(9634),
    [sym_record_signature] = STATE(9634),
    [sym_infix] = STATE(9634),
    [sym_generalize] = STATE(9634),
    [sym_mutual] = STATE(9634),
    [sym_abstract] = STATE(9634),
    [sym_private] = STATE(9634),
    [sym_instance] = STATE(9634),
    [sym_macro] = STATE(9634),
    [sym_postulate] = STATE(9634),
    [sym_primitive] = STATE(9634),
    [sym_open] = STATE(9634),
    [sym_import] = STATE(9634),
    [sym_module_macro] = STATE(9634),
    [sym_module] = STATE(9634),
    [sym_syntax] = STATE(9634),
    [sym_pattern] = STATE(9634),
    [sym_unquote_decl] = STATE(9634),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(162),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(658),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
  },
  [239] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9586),
    [sym_fields] = STATE(9586),
    [sym_function] = STATE(9586),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9586),
    [sym_data_signature] = STATE(9586),
    [sym_record] = STATE(9586),
    [sym_record_signature] = STATE(9586),
    [sym_infix] = STATE(9586),
    [sym_generalize] = STATE(9586),
    [sym_mutual] = STATE(9586),
    [sym_abstract] = STATE(9586),
    [sym_private] = STATE(9586),
    [sym_instance] = STATE(9586),
    [sym_macro] = STATE(9586),
    [sym_postulate] = STATE(9586),
    [sym_primitive] = STATE(9586),
    [sym_open] = STATE(9586),
    [sym_import] = STATE(9586),
    [sym_module_macro] = STATE(9586),
    [sym_module] = STATE(9586),
    [sym_syntax] = STATE(9586),
    [sym_pattern] = STATE(9586),
    [sym_unquote_decl] = STATE(9586),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(224),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(632),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
  },
  [240] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9556),
    [sym_fields] = STATE(9556),
    [sym_function] = STATE(9556),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9556),
    [sym_data_signature] = STATE(9556),
    [sym_record] = STATE(9556),
    [sym_record_signature] = STATE(9556),
    [sym_infix] = STATE(9556),
    [sym_generalize] = STATE(9556),
    [sym_mutual] = STATE(9556),
    [sym_abstract] = STATE(9556),
    [sym_private] = STATE(9556),
    [sym_instance] = STATE(9556),
    [sym_macro] = STATE(9556),
    [sym_postulate] = STATE(9556),
    [sym_primitive] = STATE(9556),
    [sym_open] = STATE(9556),
    [sym_import] = STATE(9556),
    [sym_module_macro] = STATE(9556),
    [sym_module] = STATE(9556),
    [sym_syntax] = STATE(9556),
    [sym_pattern] = STATE(9556),
    [sym_unquote_decl] = STATE(9556),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(162),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(660),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
  },
  [241] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9634),
    [sym_fields] = STATE(9634),
    [sym_function] = STATE(9634),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9634),
    [sym_data_signature] = STATE(9634),
    [sym_record] = STATE(9634),
    [sym_record_signature] = STATE(9634),
    [sym_infix] = STATE(9634),
    [sym_generalize] = STATE(9634),
    [sym_mutual] = STATE(9634),
    [sym_abstract] = STATE(9634),
    [sym_private] = STATE(9634),
    [sym_instance] = STATE(9634),
    [sym_macro] = STATE(9634),
    [sym_postulate] = STATE(9634),
    [sym_primitive] = STATE(9634),
    [sym_open] = STATE(9634),
    [sym_import] = STATE(9634),
    [sym_module_macro] = STATE(9634),
    [sym_module] = STATE(9634),
    [sym_syntax] = STATE(9634),
    [sym_pattern] = STATE(9634),
    [sym_unquote_decl] = STATE(9634),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(203),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(658),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
  },
  [242] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9556),
    [sym_fields] = STATE(9556),
    [sym_function] = STATE(9556),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9556),
    [sym_data_signature] = STATE(9556),
    [sym_record] = STATE(9556),
    [sym_record_signature] = STATE(9556),
    [sym_infix] = STATE(9556),
    [sym_generalize] = STATE(9556),
    [sym_mutual] = STATE(9556),
    [sym_abstract] = STATE(9556),
    [sym_private] = STATE(9556),
    [sym_instance] = STATE(9556),
    [sym_macro] = STATE(9556),
    [sym_postulate] = STATE(9556),
    [sym_primitive] = STATE(9556),
    [sym_open] = STATE(9556),
    [sym_import] = STATE(9556),
    [sym_module_macro] = STATE(9556),
    [sym_module] = STATE(9556),
    [sym_syntax] = STATE(9556),
    [sym_pattern] = STATE(9556),
    [sym_unquote_decl] = STATE(9556),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(235),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(660),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
  },
  [243] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9499),
    [sym_fields] = STATE(9499),
    [sym_function] = STATE(9499),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9499),
    [sym_data_signature] = STATE(9499),
    [sym_record] = STATE(9499),
    [sym_record_signature] = STATE(9499),
    [sym_infix] = STATE(9499),
    [sym_generalize] = STATE(9499),
    [sym_mutual] = STATE(9499),
    [sym_abstract] = STATE(9499),
    [sym_private] = STATE(9499),
    [sym_instance] = STATE(9499),
    [sym_macro] = STATE(9499),
    [sym_postulate] = STATE(9499),
    [sym_primitive] = STATE(9499),
    [sym_open] = STATE(9499),
    [sym_import] = STATE(9499),
    [sym_module_macro] = STATE(9499),
    [sym_module] = STATE(9499),
    [sym_syntax] = STATE(9499),
    [sym_pattern] = STATE(9499),
    [sym_unquote_decl] = STATE(9499),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(251),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(662),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
  },
  [244] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9499),
    [sym_fields] = STATE(9499),
    [sym_function] = STATE(9499),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9499),
    [sym_data_signature] = STATE(9499),
    [sym_record] = STATE(9499),
    [sym_record_signature] = STATE(9499),
    [sym_infix] = STATE(9499),
    [sym_generalize] = STATE(9499),
    [sym_mutual] = STATE(9499),
    [sym_abstract] = STATE(9499),
    [sym_private] = STATE(9499),
    [sym_instance] = STATE(9499),
    [sym_macro] = STATE(9499),
    [sym_postulate] = STATE(9499),
    [sym_primitive] = STATE(9499),
    [sym_open] = STATE(9499),
    [sym_import] = STATE(9499),
    [sym_module_macro] = STATE(9499),
    [sym_module] = STATE(9499),
    [sym_syntax] = STATE(9499),
    [sym_pattern] = STATE(9499),
    [sym_unquote_decl] = STATE(9499),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(162),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(662),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
  },
  [245] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9552),
    [sym_fields] = STATE(9552),
    [sym_function] = STATE(9552),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9552),
    [sym_data_signature] = STATE(9552),
    [sym_record] = STATE(9552),
    [sym_record_signature] = STATE(9552),
    [sym_infix] = STATE(9552),
    [sym_generalize] = STATE(9552),
    [sym_mutual] = STATE(9552),
    [sym_abstract] = STATE(9552),
    [sym_private] = STATE(9552),
    [sym_instance] = STATE(9552),
    [sym_macro] = STATE(9552),
    [sym_postulate] = STATE(9552),
    [sym_primitive] = STATE(9552),
    [sym_open] = STATE(9552),
    [sym_import] = STATE(9552),
    [sym_module_macro] = STATE(9552),
    [sym_module] = STATE(9552),
    [sym_syntax] = STATE(9552),
    [sym_pattern] = STATE(9552),
    [sym_unquote_decl] = STATE(9552),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(133),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(664),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
  },
  [246] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9514),
    [sym_fields] = STATE(9514),
    [sym_function] = STATE(9514),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9514),
    [sym_data_signature] = STATE(9514),
    [sym_record] = STATE(9514),
    [sym_record_signature] = STATE(9514),
    [sym_infix] = STATE(9514),
    [sym_generalize] = STATE(9514),
    [sym_mutual] = STATE(9514),
    [sym_abstract] = STATE(9514),
    [sym_private] = STATE(9514),
    [sym_instance] = STATE(9514),
    [sym_macro] = STATE(9514),
    [sym_postulate] = STATE(9514),
    [sym_primitive] = STATE(9514),
    [sym_open] = STATE(9514),
    [sym_import] = STATE(9514),
    [sym_module_macro] = STATE(9514),
    [sym_module] = STATE(9514),
    [sym_syntax] = STATE(9514),
    [sym_pattern] = STATE(9514),
    [sym_unquote_decl] = STATE(9514),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(162),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(511),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
  },
  [247] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9552),
    [sym_fields] = STATE(9552),
    [sym_function] = STATE(9552),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9552),
    [sym_data_signature] = STATE(9552),
    [sym_record] = STATE(9552),
    [sym_record_signature] = STATE(9552),
    [sym_infix] = STATE(9552),
    [sym_generalize] = STATE(9552),
    [sym_mutual] = STATE(9552),
    [sym_abstract] = STATE(9552),
    [sym_private] = STATE(9552),
    [sym_instance] = STATE(9552),
    [sym_macro] = STATE(9552),
    [sym_postulate] = STATE(9552),
    [sym_primitive] = STATE(9552),
    [sym_open] = STATE(9552),
    [sym_import] = STATE(9552),
    [sym_module_macro] = STATE(9552),
    [sym_module] = STATE(9552),
    [sym_syntax] = STATE(9552),
    [sym_pattern] = STATE(9552),
    [sym_unquote_decl] = STATE(9552),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(162),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(664),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
  },
  [248] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9522),
    [sym_fields] = STATE(9522),
    [sym_function] = STATE(9522),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9522),
    [sym_data_signature] = STATE(9522),
    [sym_record] = STATE(9522),
    [sym_record_signature] = STATE(9522),
    [sym_infix] = STATE(9522),
    [sym_generalize] = STATE(9522),
    [sym_mutual] = STATE(9522),
    [sym_abstract] = STATE(9522),
    [sym_private] = STATE(9522),
    [sym_instance] = STATE(9522),
    [sym_macro] = STATE(9522),
    [sym_postulate] = STATE(9522),
    [sym_primitive] = STATE(9522),
    [sym_open] = STATE(9522),
    [sym_import] = STATE(9522),
    [sym_module_macro] = STATE(9522),
    [sym_module] = STATE(9522),
    [sym_syntax] = STATE(9522),
    [sym_pattern] = STATE(9522),
    [sym_unquote_decl] = STATE(9522),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(162),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(666),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
  },
  [249] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9663),
    [sym_fields] = STATE(9663),
    [sym_function] = STATE(9663),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9663),
    [sym_data_signature] = STATE(9663),
    [sym_record] = STATE(9663),
    [sym_record_signature] = STATE(9663),
    [sym_infix] = STATE(9663),
    [sym_generalize] = STATE(9663),
    [sym_mutual] = STATE(9663),
    [sym_abstract] = STATE(9663),
    [sym_private] = STATE(9663),
    [sym_instance] = STATE(9663),
    [sym_macro] = STATE(9663),
    [sym_postulate] = STATE(9663),
    [sym_primitive] = STATE(9663),
    [sym_open] = STATE(9663),
    [sym_import] = STATE(9663),
    [sym_module_macro] = STATE(9663),
    [sym_module] = STATE(9663),
    [sym_syntax] = STATE(9663),
    [sym_pattern] = STATE(9663),
    [sym_unquote_decl] = STATE(9663),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(162),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(668),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
  },
  [250] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9522),
    [sym_fields] = STATE(9522),
    [sym_function] = STATE(9522),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9522),
    [sym_data_signature] = STATE(9522),
    [sym_record] = STATE(9522),
    [sym_record_signature] = STATE(9522),
    [sym_infix] = STATE(9522),
    [sym_generalize] = STATE(9522),
    [sym_mutual] = STATE(9522),
    [sym_abstract] = STATE(9522),
    [sym_private] = STATE(9522),
    [sym_instance] = STATE(9522),
    [sym_macro] = STATE(9522),
    [sym_postulate] = STATE(9522),
    [sym_primitive] = STATE(9522),
    [sym_open] = STATE(9522),
    [sym_import] = STATE(9522),
    [sym_module_macro] = STATE(9522),
    [sym_module] = STATE(9522),
    [sym_syntax] = STATE(9522),
    [sym_pattern] = STATE(9522),
    [sym_unquote_decl] = STATE(9522),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(143),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(666),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
  },
  [251] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9561),
    [sym_fields] = STATE(9561),
    [sym_function] = STATE(9561),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9561),
    [sym_data_signature] = STATE(9561),
    [sym_record] = STATE(9561),
    [sym_record_signature] = STATE(9561),
    [sym_infix] = STATE(9561),
    [sym_generalize] = STATE(9561),
    [sym_mutual] = STATE(9561),
    [sym_abstract] = STATE(9561),
    [sym_private] = STATE(9561),
    [sym_instance] = STATE(9561),
    [sym_macro] = STATE(9561),
    [sym_postulate] = STATE(9561),
    [sym_primitive] = STATE(9561),
    [sym_open] = STATE(9561),
    [sym_import] = STATE(9561),
    [sym_module_macro] = STATE(9561),
    [sym_module] = STATE(9561),
    [sym_syntax] = STATE(9561),
    [sym_pattern] = STATE(9561),
    [sym_unquote_decl] = STATE(9561),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(162),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(670),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
  },
  [252] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9525),
    [sym_fields] = STATE(9525),
    [sym_function] = STATE(9525),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9525),
    [sym_data_signature] = STATE(9525),
    [sym_record] = STATE(9525),
    [sym_record_signature] = STATE(9525),
    [sym_infix] = STATE(9525),
    [sym_generalize] = STATE(9525),
    [sym_mutual] = STATE(9525),
    [sym_abstract] = STATE(9525),
    [sym_private] = STATE(9525),
    [sym_instance] = STATE(9525),
    [sym_macro] = STATE(9525),
    [sym_postulate] = STATE(9525),
    [sym_primitive] = STATE(9525),
    [sym_open] = STATE(9525),
    [sym_import] = STATE(9525),
    [sym_module_macro] = STATE(9525),
    [sym_module] = STATE(9525),
    [sym_syntax] = STATE(9525),
    [sym_pattern] = STATE(9525),
    [sym_unquote_decl] = STATE(9525),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(198),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(672),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
  },
  [253] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9525),
    [sym_fields] = STATE(9525),
    [sym_function] = STATE(9525),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9525),
    [sym_data_signature] = STATE(9525),
    [sym_record] = STATE(9525),
    [sym_record_signature] = STATE(9525),
    [sym_infix] = STATE(9525),
    [sym_generalize] = STATE(9525),
    [sym_mutual] = STATE(9525),
    [sym_abstract] = STATE(9525),
    [sym_private] = STATE(9525),
    [sym_instance] = STATE(9525),
    [sym_macro] = STATE(9525),
    [sym_postulate] = STATE(9525),
    [sym_primitive] = STATE(9525),
    [sym_open] = STATE(9525),
    [sym_import] = STATE(9525),
    [sym_module_macro] = STATE(9525),
    [sym_module] = STATE(9525),
    [sym_syntax] = STATE(9525),
    [sym_pattern] = STATE(9525),
    [sym_unquote_decl] = STATE(9525),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(162),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(672),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
  },
  [254] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9545),
    [sym_fields] = STATE(9545),
    [sym_function] = STATE(9545),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9545),
    [sym_data_signature] = STATE(9545),
    [sym_record] = STATE(9545),
    [sym_record_signature] = STATE(9545),
    [sym_infix] = STATE(9545),
    [sym_generalize] = STATE(9545),
    [sym_mutual] = STATE(9545),
    [sym_abstract] = STATE(9545),
    [sym_private] = STATE(9545),
    [sym_instance] = STATE(9545),
    [sym_macro] = STATE(9545),
    [sym_postulate] = STATE(9545),
    [sym_primitive] = STATE(9545),
    [sym_open] = STATE(9545),
    [sym_import] = STATE(9545),
    [sym_module_macro] = STATE(9545),
    [sym_module] = STATE(9545),
    [sym_syntax] = STATE(9545),
    [sym_pattern] = STATE(9545),
    [sym_unquote_decl] = STATE(9545),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(233),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(674),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
  },
  [255] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9496),
    [sym_fields] = STATE(9496),
    [sym_function] = STATE(9496),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9496),
    [sym_data_signature] = STATE(9496),
    [sym_record] = STATE(9496),
    [sym_record_signature] = STATE(9496),
    [sym_infix] = STATE(9496),
    [sym_generalize] = STATE(9496),
    [sym_mutual] = STATE(9496),
    [sym_abstract] = STATE(9496),
    [sym_private] = STATE(9496),
    [sym_instance] = STATE(9496),
    [sym_macro] = STATE(9496),
    [sym_postulate] = STATE(9496),
    [sym_primitive] = STATE(9496),
    [sym_open] = STATE(9496),
    [sym_import] = STATE(9496),
    [sym_module_macro] = STATE(9496),
    [sym_module] = STATE(9496),
    [sym_syntax] = STATE(9496),
    [sym_pattern] = STATE(9496),
    [sym_unquote_decl] = STATE(9496),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(162),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(676),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
  },
  [256] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9496),
    [sym_fields] = STATE(9496),
    [sym_function] = STATE(9496),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9496),
    [sym_data_signature] = STATE(9496),
    [sym_record] = STATE(9496),
    [sym_record_signature] = STATE(9496),
    [sym_infix] = STATE(9496),
    [sym_generalize] = STATE(9496),
    [sym_mutual] = STATE(9496),
    [sym_abstract] = STATE(9496),
    [sym_private] = STATE(9496),
    [sym_instance] = STATE(9496),
    [sym_macro] = STATE(9496),
    [sym_postulate] = STATE(9496),
    [sym_primitive] = STATE(9496),
    [sym_open] = STATE(9496),
    [sym_import] = STATE(9496),
    [sym_module_macro] = STATE(9496),
    [sym_module] = STATE(9496),
    [sym_syntax] = STATE(9496),
    [sym_pattern] = STATE(9496),
    [sym_unquote_decl] = STATE(9496),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(175),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(676),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
  },
  [257] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9495),
    [sym_fields] = STATE(9495),
    [sym_function] = STATE(9495),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9495),
    [sym_data_signature] = STATE(9495),
    [sym_record] = STATE(9495),
    [sym_record_signature] = STATE(9495),
    [sym_infix] = STATE(9495),
    [sym_generalize] = STATE(9495),
    [sym_mutual] = STATE(9495),
    [sym_abstract] = STATE(9495),
    [sym_private] = STATE(9495),
    [sym_instance] = STATE(9495),
    [sym_macro] = STATE(9495),
    [sym_postulate] = STATE(9495),
    [sym_primitive] = STATE(9495),
    [sym_open] = STATE(9495),
    [sym_import] = STATE(9495),
    [sym_module_macro] = STATE(9495),
    [sym_module] = STATE(9495),
    [sym_syntax] = STATE(9495),
    [sym_pattern] = STATE(9495),
    [sym_unquote_decl] = STATE(9495),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(162),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(678),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
  },
  [258] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9545),
    [sym_fields] = STATE(9545),
    [sym_function] = STATE(9545),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9545),
    [sym_data_signature] = STATE(9545),
    [sym_record] = STATE(9545),
    [sym_record_signature] = STATE(9545),
    [sym_infix] = STATE(9545),
    [sym_generalize] = STATE(9545),
    [sym_mutual] = STATE(9545),
    [sym_abstract] = STATE(9545),
    [sym_private] = STATE(9545),
    [sym_instance] = STATE(9545),
    [sym_macro] = STATE(9545),
    [sym_postulate] = STATE(9545),
    [sym_primitive] = STATE(9545),
    [sym_open] = STATE(9545),
    [sym_import] = STATE(9545),
    [sym_module_macro] = STATE(9545),
    [sym_module] = STATE(9545),
    [sym_syntax] = STATE(9545),
    [sym_pattern] = STATE(9545),
    [sym_unquote_decl] = STATE(9545),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(162),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(674),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
  },
  [259] = {
    [sym__FORALL] = STATE(8343),
    [sym__LAMBDA] = STATE(8146),
    [sym__ELLIPSIS] = STATE(4327),
    [sym__declaration] = STATE(9495),
    [sym_fields] = STATE(9495),
    [sym_function] = STATE(9495),
    [sym_lhs_decl] = STATE(9093),
    [sym_lhs_defn] = STATE(9084),
    [sym_data] = STATE(9495),
    [sym_data_signature] = STATE(9495),
    [sym_record] = STATE(9495),
    [sym_record_signature] = STATE(9495),
    [sym_infix] = STATE(9495),
    [sym_generalize] = STATE(9495),
    [sym_mutual] = STATE(9495),
    [sym_abstract] = STATE(9495),
    [sym_private] = STATE(9495),
    [sym_instance] = STATE(9495),
    [sym_macro] = STATE(9495),
    [sym_postulate] = STATE(9495),
    [sym_primitive] = STATE(9495),
    [sym_open] = STATE(9495),
    [sym_import] = STATE(9495),
    [sym_module_macro] = STATE(9495),
    [sym_module] = STATE(9495),
    [sym_syntax] = STATE(9495),
    [sym_pattern] = STATE(9495),
    [sym_unquote_decl] = STATE(9495),
    [sym__qid] = STATE(4327),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3125),
    [sym__with_exprs] = STATE(8848),
    [sym__expr_or_attr] = STATE(4327),
    [sym__application] = STATE(8955),
    [sym__expr2_without_let] = STATE(8955),
    [sym__expr2] = STATE(8955),
    [sym_atom] = STATE(4271),
    [aux_sym__atoms] = STATE(3854),
    [sym__atom_curly] = STATE(4311),
    [sym__atom_no_curly] = STATE(4311),
    [sym_forall] = STATE(8955),
    [sym_let] = STATE(8955),
    [sym_lambda] = STATE(8955),
    [sym_lambda_extended_or_absurd] = STATE(8955),
    [sym_do] = STATE(8955),
    [sym_record_assignments] = STATE(4327),
    [sym_field_assignments] = STATE(4327),
    [sym_literal] = STATE(4327),
    [sym_SetN] = STATE(4327),
    [aux_sym_source_file_repeat1] = STATE(146),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3734),
    [sym_id] = ACTIONS(105),
    [anon_sym_forall] = ACTIONS(107),
    [anon_sym_u2200] = ACTIONS(107),
    [anon_sym_BSLASH] = ACTIONS(109),
    [anon_sym_u03bb] = ACTIONS(111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_u2026] = ACTIONS(113),
    [anon_sym_field] = ACTIONS(19),
    [anon_sym_instance] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(115),
    [anon_sym_data] = ACTIONS(117),
    [anon_sym_codata] = ACTIONS(27),
    [anon_sym_record] = ACTIONS(119),
    [anon_sym_infix] = ACTIONS(121),
    [anon_sym_infixl] = ACTIONS(121),
    [anon_sym_infixr] = ACTIONS(121),
    [anon_sym_variable] = ACTIONS(33),
    [anon_sym_mutual] = ACTIONS(35),
    [anon_sym_abstract] = ACTIONS(37),
    [anon_sym_private] = ACTIONS(39),
    [anon_sym_macro] = ACTIONS(41),
    [anon_sym_postulate] = ACTIONS(43),
    [anon_sym_primitive] = ACTIONS(45),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(127),
    [anon_sym_u2983] = ACTIONS(129),
    [anon_sym__] = ACTIONS(113),
    [sym_pragma] = ACTIONS(678),
    [anon_sym_syntax] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_pattern] = ACTIONS(137),
    [anon_sym_unquoteDecl] = ACTIONS(139),
    [anon_sym_unquoteDef] = ACTIONS(141),
    [aux_sym__qid_token1] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(147),
    [anon_sym_tactic] = ACTIONS(149),
    [anon_sym_Prop] = ACTIONS(113),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_quoteTerm] = ACTIONS(113),
    [anon_sym_quoteContext] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(151),
    [anon_sym_u2987] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(157),
    [aux_sym_string_token1] = ACTIONS(157),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(159),
    [sym_PropN] = ACTIONS(113),
  },
  [260] = {
    [sym__FORALL] = STATE(8495),
    [sym__ARROW] = STATE(2460),
    [sym__LAMBDA] = STATE(8064),
    [sym__ELLIPSIS] = STATE(5056),
    [sym_catchall_pragma] = STATE(3229),
    [sym__qid] = STATE(5217),
    [sym__binding_ids_and_absurds] = STATE(10219),
    [sym_attribute] = STATE(5830),
    [sym_attributes] = STATE(3406),
    [sym__expr_or_attr] = STATE(5056),
    [sym__application] = STATE(9572),
    [sym__expr2_without_let] = STATE(9572),
    [sym__expr2] = STATE(9572),
    [sym_atom] = STATE(5128),
    [aux_sym__atoms] = STATE(3561),
    [sym__atom_curly] = STATE(5069),
    [sym__atom_no_curly] = STATE(5069),
    [sym_forall] = STATE(9572),
    [sym_let] = STATE(9572),
    [sym_lambda] = STATE(9572),
    [sym_lambda_extended_or_absurd] = STATE(9572),
    [sym__lambda_clauses] = STATE(12467),
    [sym__lambda_clause_maybe_absurd] = STATE(8986),
    [sym_lambda_clause_absurd] = STATE(8986),
    [sym_lambda_clause] = STATE(8986),
    [sym_do] = STATE(9572),
    [sym_record_assignments] = STATE(5056),
    [sym_field_assignments] = STATE(5056),
    [sym_literal] = STATE(5056),
    [sym_SetN] = STATE(5056),
    [aux_sym__modal_arg_ids_repeat1] = STATE(5830),
    [aux_sym__lambda_clauses_repeat1] = STATE(2812),
    [sym_id] = ACTIONS(680),
    [anon_sym_forall] = ACTIONS(682),
    [anon_sym_u2200] = ACTIONS(682),
    [anon_sym_DASH_GT] = ACTIONS(684),
    [anon_sym_u2192] = ACTIONS(684),
    [anon_sym_BSLASH] = ACTIONS(686),
    [anon_sym_u03bb] = ACTIONS(688),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(690),
    [anon_sym_u2026] = ACTIONS(690),
    [anon_sym_record] = ACTIONS(692),
    [anon_sym_LPAREN] = ACTIONS(694),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(696),
    [anon_sym_u2983] = ACTIONS(698),
    [anon_sym__] = ACTIONS(690),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE_DASH_POUND] = ACTIONS(700),
    [anon_sym_LBRACE] = ACTIONS(702),
    [anon_sym_RBRACE] = ACTIONS(704),
    [aux_sym__qid_token1] = ACTIONS(706),
    [anon_sym_DOT] = ACTIONS(708),
    [anon_sym_DASH] = ACTIONS(710),
    [anon_sym_AT] = ACTIONS(712),
    [anon_sym_quoteGoal] = ACTIONS(714),
    [anon_sym_tactic] = ACTIONS(716),
    [anon_sym_Prop] = ACTIONS(690),
    [anon_sym_quote] = ACTIONS(690),
    [anon_sym_quoteTerm] = ACTIONS(690),
    [anon_sym_quoteContext] = ACTIONS(690),
    [anon_sym_unquote] = ACTIONS(690),
    [anon_sym_LPAREN_PIPE] = ACTIONS(718),
    [anon_sym_u2987] = ACTIONS(720),
    [anon_sym_let] = ACTIONS(722),
    [anon_sym_do] = ACTIONS(724),
    [aux_sym_integer_token1] = ACTIONS(726),
    [aux_sym_string_token1] = ACTIONS(726),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(728),
    [sym_PropN] = ACTIONS(690),
  },
  [261] = {
    [sym__FORALL] = STATE(8495),
    [sym__ARROW] = STATE(2460),
    [sym__LAMBDA] = STATE(8064),
    [sym__ELLIPSIS] = STATE(5056),
    [sym_catchall_pragma] = STATE(3229),
    [sym__qid] = STATE(5217),
    [sym__binding_ids_and_absurds] = STATE(10069),
    [sym_attribute] = STATE(5830),
    [sym_attributes] = STATE(3421),
    [sym__expr_or_attr] = STATE(5056),
    [sym__application] = STATE(9572),
    [sym__expr2_without_let] = STATE(9572),
    [sym__expr2] = STATE(9572),
    [sym_atom] = STATE(5128),
    [aux_sym__atoms] = STATE(3561),
    [sym__atom_curly] = STATE(5069),
    [sym__atom_no_curly] = STATE(5069),
    [sym_forall] = STATE(9572),
    [sym_let] = STATE(9572),
    [sym_lambda] = STATE(9572),
    [sym_lambda_extended_or_absurd] = STATE(9572),
    [sym__lambda_clauses] = STATE(11497),
    [sym__lambda_clause_maybe_absurd] = STATE(8986),
    [sym_lambda_clause_absurd] = STATE(8986),
    [sym_lambda_clause] = STATE(8986),
    [sym_do] = STATE(9572),
    [sym_record_assignments] = STATE(5056),
    [sym_field_assignments] = STATE(5056),
    [sym_literal] = STATE(5056),
    [sym_SetN] = STATE(5056),
    [aux_sym__modal_arg_ids_repeat1] = STATE(5830),
    [aux_sym__lambda_clauses_repeat1] = STATE(2812),
    [sym_id] = ACTIONS(680),
    [anon_sym_forall] = ACTIONS(682),
    [anon_sym_u2200] = ACTIONS(682),
    [anon_sym_DASH_GT] = ACTIONS(684),
    [anon_sym_u2192] = ACTIONS(684),
    [anon_sym_BSLASH] = ACTIONS(686),
    [anon_sym_u03bb] = ACTIONS(688),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(690),
    [anon_sym_u2026] = ACTIONS(690),
    [anon_sym_record] = ACTIONS(692),
    [anon_sym_LPAREN] = ACTIONS(694),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(696),
    [anon_sym_u2983] = ACTIONS(698),
    [anon_sym__] = ACTIONS(690),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE_DASH_POUND] = ACTIONS(700),
    [anon_sym_LBRACE] = ACTIONS(702),
    [anon_sym_RBRACE] = ACTIONS(730),
    [aux_sym__qid_token1] = ACTIONS(706),
    [anon_sym_DOT] = ACTIONS(708),
    [anon_sym_DASH] = ACTIONS(710),
    [anon_sym_AT] = ACTIONS(712),
    [anon_sym_quoteGoal] = ACTIONS(714),
    [anon_sym_tactic] = ACTIONS(716),
    [anon_sym_Prop] = ACTIONS(690),
    [anon_sym_quote] = ACTIONS(690),
    [anon_sym_quoteTerm] = ACTIONS(690),
    [anon_sym_quoteContext] = ACTIONS(690),
    [anon_sym_unquote] = ACTIONS(690),
    [anon_sym_LPAREN_PIPE] = ACTIONS(718),
    [anon_sym_u2987] = ACTIONS(720),
    [anon_sym_let] = ACTIONS(722),
    [anon_sym_do] = ACTIONS(724),
    [aux_sym_integer_token1] = ACTIONS(726),
    [aux_sym_string_token1] = ACTIONS(726),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(728),
    [sym_PropN] = ACTIONS(690),
  },
  [262] = {
    [sym__FORALL] = STATE(8495),
    [sym__ARROW] = STATE(2460),
    [sym__LAMBDA] = STATE(8064),
    [sym__ELLIPSIS] = STATE(5056),
    [sym_catchall_pragma] = STATE(3229),
    [sym__qid] = STATE(5217),
    [sym__binding_ids_and_absurds] = STATE(10185),
    [sym_attribute] = STATE(5830),
    [sym_attributes] = STATE(3489),
    [sym__expr_or_attr] = STATE(5056),
    [sym__application] = STATE(9572),
    [sym__expr2_without_let] = STATE(9572),
    [sym__expr2] = STATE(9572),
    [sym_atom] = STATE(5128),
    [aux_sym__atoms] = STATE(3561),
    [sym__atom_curly] = STATE(5069),
    [sym__atom_no_curly] = STATE(5069),
    [sym_forall] = STATE(9572),
    [sym_let] = STATE(9572),
    [sym_lambda] = STATE(9572),
    [sym_lambda_extended_or_absurd] = STATE(9572),
    [sym__lambda_clauses] = STATE(11554),
    [sym__lambda_clause_maybe_absurd] = STATE(8986),
    [sym_lambda_clause_absurd] = STATE(8986),
    [sym_lambda_clause] = STATE(8986),
    [sym_do] = STATE(9572),
    [sym_record_assignments] = STATE(5056),
    [sym_field_assignments] = STATE(5056),
    [sym_literal] = STATE(5056),
    [sym_SetN] = STATE(5056),
    [aux_sym__modal_arg_ids_repeat1] = STATE(5830),
    [aux_sym__lambda_clauses_repeat1] = STATE(2812),
    [sym_id] = ACTIONS(680),
    [anon_sym_forall] = ACTIONS(682),
    [anon_sym_u2200] = ACTIONS(682),
    [anon_sym_DASH_GT] = ACTIONS(684),
    [anon_sym_u2192] = ACTIONS(684),
    [anon_sym_BSLASH] = ACTIONS(686),
    [anon_sym_u03bb] = ACTIONS(688),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(690),
    [anon_sym_u2026] = ACTIONS(690),
    [anon_sym_record] = ACTIONS(692),
    [anon_sym_LPAREN] = ACTIONS(694),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(696),
    [anon_sym_u2983] = ACTIONS(698),
    [anon_sym__] = ACTIONS(690),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE_DASH_POUND] = ACTIONS(700),
    [anon_sym_LBRACE] = ACTIONS(702),
    [anon_sym_RBRACE] = ACTIONS(732),
    [aux_sym__qid_token1] = ACTIONS(706),
    [anon_sym_DOT] = ACTIONS(708),
    [anon_sym_DASH] = ACTIONS(710),
    [anon_sym_AT] = ACTIONS(712),
    [anon_sym_quoteGoal] = ACTIONS(714),
    [anon_sym_tactic] = ACTIONS(716),
    [anon_sym_Prop] = ACTIONS(690),
    [anon_sym_quote] = ACTIONS(690),
    [anon_sym_quoteTerm] = ACTIONS(690),
    [anon_sym_quoteContext] = ACTIONS(690),
    [anon_sym_unquote] = ACTIONS(690),
    [anon_sym_LPAREN_PIPE] = ACTIONS(718),
    [anon_sym_u2987] = ACTIONS(720),
    [anon_sym_let] = ACTIONS(722),
    [anon_sym_do] = ACTIONS(724),
    [aux_sym_integer_token1] = ACTIONS(726),
    [aux_sym_string_token1] = ACTIONS(726),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(728),
    [sym_PropN] = ACTIONS(690),
  },
  [263] = {
    [sym__FORALL] = STATE(8495),
    [sym__ARROW] = STATE(2460),
    [sym__LAMBDA] = STATE(8064),
    [sym__ELLIPSIS] = STATE(5056),
    [sym_catchall_pragma] = STATE(3229),
    [sym__qid] = STATE(5217),
    [sym__binding_ids_and_absurds] = STATE(10200),
    [sym_attribute] = STATE(5830),
    [sym_attributes] = STATE(3516),
    [sym__expr_or_attr] = STATE(5056),
    [sym__application] = STATE(9572),
    [sym__expr2_without_let] = STATE(9572),
    [sym__expr2] = STATE(9572),
    [sym_atom] = STATE(5128),
    [aux_sym__atoms] = STATE(3561),
    [sym__atom_curly] = STATE(5069),
    [sym__atom_no_curly] = STATE(5069),
    [sym_forall] = STATE(9572),
    [sym_let] = STATE(9572),
    [sym_lambda] = STATE(9572),
    [sym_lambda_extended_or_absurd] = STATE(9572),
    [sym__lambda_clauses] = STATE(12467),
    [sym__lambda_clause_maybe_absurd] = STATE(8986),
    [sym_lambda_clause_absurd] = STATE(8986),
    [sym_lambda_clause] = STATE(8986),
    [sym_do] = STATE(9572),
    [sym_record_assignments] = STATE(5056),
    [sym_field_assignments] = STATE(5056),
    [sym_literal] = STATE(5056),
    [sym_SetN] = STATE(5056),
    [aux_sym__modal_arg_ids_repeat1] = STATE(5830),
    [aux_sym__lambda_clauses_repeat1] = STATE(2812),
    [sym_id] = ACTIONS(680),
    [anon_sym_forall] = ACTIONS(682),
    [anon_sym_u2200] = ACTIONS(682),
    [anon_sym_DASH_GT] = ACTIONS(684),
    [anon_sym_u2192] = ACTIONS(684),
    [anon_sym_BSLASH] = ACTIONS(686),
    [anon_sym_u03bb] = ACTIONS(688),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(690),
    [anon_sym_u2026] = ACTIONS(690),
    [anon_sym_record] = ACTIONS(692),
    [anon_sym_LPAREN] = ACTIONS(694),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(696),
    [anon_sym_u2983] = ACTIONS(698),
    [anon_sym__] = ACTIONS(690),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE_DASH_POUND] = ACTIONS(700),
    [anon_sym_LBRACE] = ACTIONS(702),
    [anon_sym_RBRACE] = ACTIONS(704),
    [aux_sym__qid_token1] = ACTIONS(706),
    [anon_sym_DOT] = ACTIONS(708),
    [anon_sym_DASH] = ACTIONS(710),
    [anon_sym_AT] = ACTIONS(712),
    [anon_sym_quoteGoal] = ACTIONS(714),
    [anon_sym_tactic] = ACTIONS(716),
    [anon_sym_Prop] = ACTIONS(690),
    [anon_sym_quote] = ACTIONS(690),
    [anon_sym_quoteTerm] = ACTIONS(690),
    [anon_sym_quoteContext] = ACTIONS(690),
    [anon_sym_unquote] = ACTIONS(690),
    [anon_sym_LPAREN_PIPE] = ACTIONS(718),
    [anon_sym_u2987] = ACTIONS(720),
    [anon_sym_let] = ACTIONS(722),
    [anon_sym_do] = ACTIONS(724),
    [aux_sym_integer_token1] = ACTIONS(726),
    [aux_sym_string_token1] = ACTIONS(726),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(728),
    [sym_PropN] = ACTIONS(690),
  },
  [264] = {
    [sym__FORALL] = STATE(8495),
    [sym__ARROW] = STATE(2460),
    [sym__LAMBDA] = STATE(8064),
    [sym__ELLIPSIS] = STATE(5056),
    [sym_catchall_pragma] = STATE(3229),
    [sym__qid] = STATE(5217),
    [sym__binding_ids_and_absurds] = STATE(10222),
    [sym_attribute] = STATE(5830),
    [sym_attributes] = STATE(3510),
    [sym__expr_or_attr] = STATE(5056),
    [sym__application] = STATE(9572),
    [sym__expr2_without_let] = STATE(9572),
    [sym__expr2] = STATE(9572),
    [sym_atom] = STATE(5128),
    [aux_sym__atoms] = STATE(3561),
    [sym__atom_curly] = STATE(5069),
    [sym__atom_no_curly] = STATE(5069),
    [sym_forall] = STATE(9572),
    [sym_let] = STATE(9572),
    [sym_lambda] = STATE(9572),
    [sym_lambda_extended_or_absurd] = STATE(9572),
    [sym__lambda_clauses] = STATE(12467),
    [sym__lambda_clause_maybe_absurd] = STATE(8986),
    [sym_lambda_clause_absurd] = STATE(8986),
    [sym_lambda_clause] = STATE(8986),
    [sym_do] = STATE(9572),
    [sym_record_assignments] = STATE(5056),
    [sym_field_assignments] = STATE(5056),
    [sym_literal] = STATE(5056),
    [sym_SetN] = STATE(5056),
    [aux_sym__modal_arg_ids_repeat1] = STATE(5830),
    [aux_sym__lambda_clauses_repeat1] = STATE(2812),
    [sym_id] = ACTIONS(680),
    [anon_sym_forall] = ACTIONS(682),
    [anon_sym_u2200] = ACTIONS(682),
    [anon_sym_DASH_GT] = ACTIONS(684),
    [anon_sym_u2192] = ACTIONS(684),
    [anon_sym_BSLASH] = ACTIONS(686),
    [anon_sym_u03bb] = ACTIONS(688),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(690),
    [anon_sym_u2026] = ACTIONS(690),
    [anon_sym_record] = ACTIONS(692),
    [anon_sym_LPAREN] = ACTIONS(694),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(696),
    [anon_sym_u2983] = ACTIONS(698),
    [anon_sym__] = ACTIONS(690),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE_DASH_POUND] = ACTIONS(700),
    [anon_sym_LBRACE] = ACTIONS(702),
    [anon_sym_RBRACE] = ACTIONS(704),
    [aux_sym__qid_token1] = ACTIONS(706),
    [anon_sym_DOT] = ACTIONS(708),
    [anon_sym_DASH] = ACTIONS(710),
    [anon_sym_AT] = ACTIONS(712),
    [anon_sym_quoteGoal] = ACTIONS(714),
    [anon_sym_tactic] = ACTIONS(716),
    [anon_sym_Prop] = ACTIONS(690),
    [anon_sym_quote] = ACTIONS(690),
    [anon_sym_quoteTerm] = ACTIONS(690),
    [anon_sym_quoteContext] = ACTIONS(690),
    [anon_sym_unquote] = ACTIONS(690),
    [anon_sym_LPAREN_PIPE] = ACTIONS(718),
    [anon_sym_u2987] = ACTIONS(720),
    [anon_sym_let] = ACTIONS(722),
    [anon_sym_do] = ACTIONS(724),
    [aux_sym_integer_token1] = ACTIONS(726),
    [aux_sym_string_token1] = ACTIONS(726),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(728),
    [sym_PropN] = ACTIONS(690),
  },
  [265] = {
    [sym__FORALL] = STATE(8495),
    [sym__ARROW] = STATE(2460),
    [sym__LAMBDA] = STATE(8064),
    [sym__ELLIPSIS] = STATE(5056),
    [sym_catchall_pragma] = STATE(3229),
    [sym__qid] = STATE(5217),
    [sym__binding_ids_and_absurds] = STATE(9989),
    [sym_attribute] = STATE(5830),
    [sym_attributes] = STATE(3687),
    [sym__expr_or_attr] = STATE(5056),
    [sym__application] = STATE(9572),
    [sym__expr2_without_let] = STATE(9572),
    [sym__expr2] = STATE(9572),
    [sym_atom] = STATE(5128),
    [aux_sym__atoms] = STATE(3561),
    [sym__atom_curly] = STATE(5069),
    [sym__atom_no_curly] = STATE(5069),
    [sym_forall] = STATE(9572),
    [sym_let] = STATE(9572),
    [sym_lambda] = STATE(9572),
    [sym_lambda_extended_or_absurd] = STATE(9572),
    [sym__lambda_clauses] = STATE(12467),
    [sym__lambda_clause_maybe_absurd] = STATE(8986),
    [sym_lambda_clause_absurd] = STATE(8986),
    [sym_lambda_clause] = STATE(8986),
    [sym_do] = STATE(9572),
    [sym_record_assignments] = STATE(5056),
    [sym_field_assignments] = STATE(5056),
    [sym_literal] = STATE(5056),
    [sym_SetN] = STATE(5056),
    [aux_sym__modal_arg_ids_repeat1] = STATE(5830),
    [aux_sym__lambda_clauses_repeat1] = STATE(2812),
    [sym_id] = ACTIONS(680),
    [anon_sym_forall] = ACTIONS(682),
    [anon_sym_u2200] = ACTIONS(682),
    [anon_sym_DASH_GT] = ACTIONS(684),
    [anon_sym_u2192] = ACTIONS(684),
    [anon_sym_BSLASH] = ACTIONS(686),
    [anon_sym_u03bb] = ACTIONS(688),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(690),
    [anon_sym_u2026] = ACTIONS(690),
    [anon_sym_record] = ACTIONS(692),
    [anon_sym_LPAREN] = ACTIONS(694),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(696),
    [anon_sym_u2983] = ACTIONS(698),
    [anon_sym__] = ACTIONS(690),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE_DASH_POUND] = ACTIONS(700),
    [anon_sym_LBRACE] = ACTIONS(702),
    [anon_sym_RBRACE] = ACTIONS(704),
    [aux_sym__qid_token1] = ACTIONS(706),
    [anon_sym_DOT] = ACTIONS(708),
    [anon_sym_DASH] = ACTIONS(710),
    [anon_sym_AT] = ACTIONS(712),
    [anon_sym_quoteGoal] = ACTIONS(714),
    [anon_sym_tactic] = ACTIONS(716),
    [anon_sym_Prop] = ACTIONS(690),
    [anon_sym_quote] = ACTIONS(690),
    [anon_sym_quoteTerm] = ACTIONS(690),
    [anon_sym_quoteContext] = ACTIONS(690),
    [anon_sym_unquote] = ACTIONS(690),
    [anon_sym_LPAREN_PIPE] = ACTIONS(718),
    [anon_sym_u2987] = ACTIONS(720),
    [anon_sym_let] = ACTIONS(722),
    [anon_sym_do] = ACTIONS(724),
    [aux_sym_integer_token1] = ACTIONS(726),
    [aux_sym_string_token1] = ACTIONS(726),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(728),
    [sym_PropN] = ACTIONS(690),
  },
  [266] = {
    [sym__FORALL] = STATE(8456),
    [sym__LAMBDA] = STATE(8156),
    [sym__ELLIPSIS] = STATE(5102),
    [sym__qid] = STATE(5102),
    [sym_attribute] = STATE(7725),
    [sym_attributes] = STATE(6224),
    [sym_stmt] = STATE(9623),
    [sym__with_exprs] = STATE(12508),
    [sym__with_exprs_stmt] = STATE(9812),
    [sym__expr_or_attr] = STATE(5102),
    [sym__application] = STATE(8964),
    [sym__application_stmt] = STATE(9812),
    [sym__expr2_without_let] = STATE(9605),
    [sym__expr2] = STATE(8964),
    [sym__expr2_stmt] = STATE(9812),
    [sym_atom] = STATE(5147),
    [aux_sym__atoms] = STATE(3121),
    [sym__atom_curly] = STATE(5108),
    [sym__atom_no_curly] = STATE(5108),
    [sym_forall] = STATE(9605),
    [sym_let] = STATE(8964),
    [sym_let_in_do] = STATE(9812),
    [sym_lambda] = STATE(9605),
    [sym_lambda_extended_or_absurd] = STATE(9605),
    [sym_do] = STATE(9605),
    [sym__do_stmt] = STATE(12501),
    [sym_record_assignments] = STATE(5102),
    [sym_field_assignments] = STATE(5102),
    [aux_sym__typed_bindings] = STATE(8671),
    [sym_typed_binding] = STATE(8671),
    [sym_literal] = STATE(5102),
    [sym_SetN] = STATE(5102),
    [aux_sym__modal_arg_ids_repeat1] = STATE(7725),
    [aux_sym__with_exprs_repeat1] = STATE(3124),
    [aux_sym_do_repeat1] = STATE(267),
    [sym_id] = ACTIONS(734),
    [anon_sym_forall] = ACTIONS(736),
    [anon_sym_u2200] = ACTIONS(736),
    [anon_sym_BSLASH] = ACTIONS(738),
    [anon_sym_u03bb] = ACTIONS(740),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(742),
    [anon_sym_u2026] = ACTIONS(742),
    [anon_sym_record] = ACTIONS(744),
    [anon_sym_LPAREN] = ACTIONS(746),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(748),
    [anon_sym_u2983] = ACTIONS(750),
    [anon_sym__] = ACTIONS(742),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(752),
    [aux_sym__qid_token1] = ACTIONS(754),
    [anon_sym_DOT] = ACTIONS(756),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_AT] = ACTIONS(760),
    [anon_sym_quoteGoal] = ACTIONS(762),
    [anon_sym_tactic] = ACTIONS(764),
    [anon_sym_Prop] = ACTIONS(742),
    [anon_sym_quote] = ACTIONS(742),
    [anon_sym_quoteTerm] = ACTIONS(742),
    [anon_sym_quoteContext] = ACTIONS(742),
    [anon_sym_unquote] = ACTIONS(742),
    [anon_sym_LPAREN_PIPE] = ACTIONS(766),
    [anon_sym_u2987] = ACTIONS(768),
    [anon_sym_let] = ACTIONS(770),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(772),
    [aux_sym_string_token1] = ACTIONS(772),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(774),
    [sym_PropN] = ACTIONS(742),
    [sym__dedent] = ACTIONS(776),
  },
  [267] = {
    [sym__FORALL] = STATE(8456),
    [sym__LAMBDA] = STATE(8156),
    [sym__ELLIPSIS] = STATE(5102),
    [sym__qid] = STATE(5102),
    [sym_attribute] = STATE(7725),
    [sym_attributes] = STATE(6224),
    [sym_stmt] = STATE(9623),
    [sym__with_exprs] = STATE(12508),
    [sym__with_exprs_stmt] = STATE(9812),
    [sym__expr_or_attr] = STATE(5102),
    [sym__application] = STATE(8964),
    [sym__application_stmt] = STATE(9812),
    [sym__expr2_without_let] = STATE(9605),
    [sym__expr2] = STATE(8964),
    [sym__expr2_stmt] = STATE(9812),
    [sym_atom] = STATE(5147),
    [aux_sym__atoms] = STATE(3121),
    [sym__atom_curly] = STATE(5108),
    [sym__atom_no_curly] = STATE(5108),
    [sym_forall] = STATE(9605),
    [sym_let] = STATE(8964),
    [sym_let_in_do] = STATE(9812),
    [sym_lambda] = STATE(9605),
    [sym_lambda_extended_or_absurd] = STATE(9605),
    [sym_do] = STATE(9605),
    [sym__do_stmt] = STATE(12501),
    [sym_record_assignments] = STATE(5102),
    [sym_field_assignments] = STATE(5102),
    [aux_sym__typed_bindings] = STATE(8671),
    [sym_typed_binding] = STATE(8671),
    [sym_literal] = STATE(5102),
    [sym_SetN] = STATE(5102),
    [aux_sym__modal_arg_ids_repeat1] = STATE(7725),
    [aux_sym__with_exprs_repeat1] = STATE(3124),
    [aux_sym_do_repeat1] = STATE(267),
    [sym_id] = ACTIONS(778),
    [anon_sym_forall] = ACTIONS(781),
    [anon_sym_u2200] = ACTIONS(781),
    [anon_sym_BSLASH] = ACTIONS(784),
    [anon_sym_u03bb] = ACTIONS(787),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(790),
    [anon_sym_u2026] = ACTIONS(790),
    [anon_sym_record] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(796),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(799),
    [anon_sym_u2983] = ACTIONS(802),
    [anon_sym__] = ACTIONS(790),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(805),
    [aux_sym__qid_token1] = ACTIONS(808),
    [anon_sym_DOT] = ACTIONS(811),
    [anon_sym_DOT_DOT] = ACTIONS(814),
    [anon_sym_AT] = ACTIONS(817),
    [anon_sym_quoteGoal] = ACTIONS(820),
    [anon_sym_tactic] = ACTIONS(823),
    [anon_sym_Prop] = ACTIONS(790),
    [anon_sym_quote] = ACTIONS(790),
    [anon_sym_quoteTerm] = ACTIONS(790),
    [anon_sym_quoteContext] = ACTIONS(790),
    [anon_sym_unquote] = ACTIONS(790),
    [anon_sym_LPAREN_PIPE] = ACTIONS(826),
    [anon_sym_u2987] = ACTIONS(829),
    [anon_sym_let] = ACTIONS(832),
    [anon_sym_do] = ACTIONS(835),
    [aux_sym_integer_token1] = ACTIONS(838),
    [aux_sym_string_token1] = ACTIONS(838),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(841),
    [sym_PropN] = ACTIONS(790),
    [sym__dedent] = ACTIONS(844),
  },
  [268] = {
    [sym__FORALL] = STATE(8495),
    [sym__ARROW] = STATE(2460),
    [sym__LAMBDA] = STATE(8064),
    [sym__ELLIPSIS] = STATE(5056),
    [sym_catchall_pragma] = STATE(3229),
    [sym__qid] = STATE(5217),
    [sym__binding_ids_and_absurds] = STATE(10166),
    [sym_attribute] = STATE(5830),
    [sym_attributes] = STATE(3632),
    [sym__expr_or_attr] = STATE(5056),
    [sym__application] = STATE(9572),
    [sym__expr2_without_let] = STATE(9572),
    [sym__expr2] = STATE(9572),
    [sym_atom] = STATE(5128),
    [aux_sym__atoms] = STATE(3561),
    [sym__atom_curly] = STATE(5069),
    [sym__atom_no_curly] = STATE(5069),
    [sym_forall] = STATE(9572),
    [sym_let] = STATE(9572),
    [sym_lambda] = STATE(9572),
    [sym_lambda_extended_or_absurd] = STATE(9572),
    [sym__lambda_clauses] = STATE(12467),
    [sym__lambda_clause_maybe_absurd] = STATE(8986),
    [sym_lambda_clause_absurd] = STATE(8986),
    [sym_lambda_clause] = STATE(8986),
    [sym_do] = STATE(9572),
    [sym_record_assignments] = STATE(5056),
    [sym_field_assignments] = STATE(5056),
    [sym_literal] = STATE(5056),
    [sym_SetN] = STATE(5056),
    [aux_sym__modal_arg_ids_repeat1] = STATE(5830),
    [aux_sym__lambda_clauses_repeat1] = STATE(2812),
    [sym_id] = ACTIONS(680),
    [anon_sym_forall] = ACTIONS(682),
    [anon_sym_u2200] = ACTIONS(682),
    [anon_sym_DASH_GT] = ACTIONS(684),
    [anon_sym_u2192] = ACTIONS(684),
    [anon_sym_BSLASH] = ACTIONS(686),
    [anon_sym_u03bb] = ACTIONS(688),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(690),
    [anon_sym_u2026] = ACTIONS(690),
    [anon_sym_record] = ACTIONS(692),
    [anon_sym_LPAREN] = ACTIONS(694),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(696),
    [anon_sym_u2983] = ACTIONS(698),
    [anon_sym__] = ACTIONS(690),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE_DASH_POUND] = ACTIONS(700),
    [anon_sym_LBRACE] = ACTIONS(702),
    [anon_sym_RBRACE] = ACTIONS(704),
    [aux_sym__qid_token1] = ACTIONS(706),
    [anon_sym_DOT] = ACTIONS(708),
    [anon_sym_DASH] = ACTIONS(710),
    [anon_sym_AT] = ACTIONS(712),
    [anon_sym_quoteGoal] = ACTIONS(714),
    [anon_sym_tactic] = ACTIONS(716),
    [anon_sym_Prop] = ACTIONS(690),
    [anon_sym_quote] = ACTIONS(690),
    [anon_sym_quoteTerm] = ACTIONS(690),
    [anon_sym_quoteContext] = ACTIONS(690),
    [anon_sym_unquote] = ACTIONS(690),
    [anon_sym_LPAREN_PIPE] = ACTIONS(718),
    [anon_sym_u2987] = ACTIONS(720),
    [anon_sym_let] = ACTIONS(722),
    [anon_sym_do] = ACTIONS(724),
    [aux_sym_integer_token1] = ACTIONS(726),
    [aux_sym_string_token1] = ACTIONS(726),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(728),
    [sym_PropN] = ACTIONS(690),
  },
  [269] = {
    [sym__FORALL] = STATE(8495),
    [sym__ARROW] = STATE(2460),
    [sym__LAMBDA] = STATE(8064),
    [sym__ELLIPSIS] = STATE(5056),
    [sym_catchall_pragma] = STATE(3229),
    [sym__qid] = STATE(5217),
    [sym__binding_ids_and_absurds] = STATE(10109),
    [sym_attribute] = STATE(5830),
    [sym_attributes] = STATE(3368),
    [sym__expr_or_attr] = STATE(5056),
    [sym__application] = STATE(9572),
    [sym__expr2_without_let] = STATE(9572),
    [sym__expr2] = STATE(9572),
    [sym_atom] = STATE(5128),
    [aux_sym__atoms] = STATE(3561),
    [sym__atom_curly] = STATE(5069),
    [sym__atom_no_curly] = STATE(5069),
    [sym_forall] = STATE(9572),
    [sym_let] = STATE(9572),
    [sym_lambda] = STATE(9572),
    [sym_lambda_extended_or_absurd] = STATE(9572),
    [sym__lambda_clauses] = STATE(11554),
    [sym__lambda_clause_maybe_absurd] = STATE(8986),
    [sym_lambda_clause_absurd] = STATE(8986),
    [sym_lambda_clause] = STATE(8986),
    [sym_do] = STATE(9572),
    [sym_record_assignments] = STATE(5056),
    [sym_field_assignments] = STATE(5056),
    [sym_literal] = STATE(5056),
    [sym_SetN] = STATE(5056),
    [aux_sym__modal_arg_ids_repeat1] = STATE(5830),
    [aux_sym__lambda_clauses_repeat1] = STATE(2812),
    [sym_id] = ACTIONS(680),
    [anon_sym_forall] = ACTIONS(682),
    [anon_sym_u2200] = ACTIONS(682),
    [anon_sym_DASH_GT] = ACTIONS(684),
    [anon_sym_u2192] = ACTIONS(684),
    [anon_sym_BSLASH] = ACTIONS(686),
    [anon_sym_u03bb] = ACTIONS(688),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(690),
    [anon_sym_u2026] = ACTIONS(690),
    [anon_sym_record] = ACTIONS(692),
    [anon_sym_LPAREN] = ACTIONS(694),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(696),
    [anon_sym_u2983] = ACTIONS(698),
    [anon_sym__] = ACTIONS(690),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE_DASH_POUND] = ACTIONS(700),
    [anon_sym_LBRACE] = ACTIONS(702),
    [anon_sym_RBRACE] = ACTIONS(732),
    [aux_sym__qid_token1] = ACTIONS(706),
    [anon_sym_DOT] = ACTIONS(708),
    [anon_sym_DASH] = ACTIONS(710),
    [anon_sym_AT] = ACTIONS(712),
    [anon_sym_quoteGoal] = ACTIONS(714),
    [anon_sym_tactic] = ACTIONS(716),
    [anon_sym_Prop] = ACTIONS(690),
    [anon_sym_quote] = ACTIONS(690),
    [anon_sym_quoteTerm] = ACTIONS(690),
    [anon_sym_quoteContext] = ACTIONS(690),
    [anon_sym_unquote] = ACTIONS(690),
    [anon_sym_LPAREN_PIPE] = ACTIONS(718),
    [anon_sym_u2987] = ACTIONS(720),
    [anon_sym_let] = ACTIONS(722),
    [anon_sym_do] = ACTIONS(724),
    [aux_sym_integer_token1] = ACTIONS(726),
    [aux_sym_string_token1] = ACTIONS(726),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(728),
    [sym_PropN] = ACTIONS(690),
  },
  [270] = {
    [sym__FORALL] = STATE(8495),
    [sym__ARROW] = STATE(2460),
    [sym__LAMBDA] = STATE(8064),
    [sym__ELLIPSIS] = STATE(5056),
    [sym_catchall_pragma] = STATE(3229),
    [sym__qid] = STATE(5217),
    [sym__binding_ids_and_absurds] = STATE(9957),
    [sym_attribute] = STATE(5830),
    [sym_attributes] = STATE(3472),
    [sym__expr_or_attr] = STATE(5056),
    [sym__application] = STATE(9572),
    [sym__expr2_without_let] = STATE(9572),
    [sym__expr2] = STATE(9572),
    [sym_atom] = STATE(5128),
    [aux_sym__atoms] = STATE(3561),
    [sym__atom_curly] = STATE(5069),
    [sym__atom_no_curly] = STATE(5069),
    [sym_forall] = STATE(9572),
    [sym_let] = STATE(9572),
    [sym_lambda] = STATE(9572),
    [sym_lambda_extended_or_absurd] = STATE(9572),
    [sym__lambda_clauses] = STATE(12467),
    [sym__lambda_clause_maybe_absurd] = STATE(8986),
    [sym_lambda_clause_absurd] = STATE(8986),
    [sym_lambda_clause] = STATE(8986),
    [sym_do] = STATE(9572),
    [sym_record_assignments] = STATE(5056),
    [sym_field_assignments] = STATE(5056),
    [sym_literal] = STATE(5056),
    [sym_SetN] = STATE(5056),
    [aux_sym__modal_arg_ids_repeat1] = STATE(5830),
    [aux_sym__lambda_clauses_repeat1] = STATE(2812),
    [sym_id] = ACTIONS(680),
    [anon_sym_forall] = ACTIONS(682),
    [anon_sym_u2200] = ACTIONS(682),
    [anon_sym_DASH_GT] = ACTIONS(684),
    [anon_sym_u2192] = ACTIONS(684),
    [anon_sym_BSLASH] = ACTIONS(686),
    [anon_sym_u03bb] = ACTIONS(688),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(690),
    [anon_sym_u2026] = ACTIONS(690),
    [anon_sym_record] = ACTIONS(692),
    [anon_sym_LPAREN] = ACTIONS(694),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(696),
    [anon_sym_u2983] = ACTIONS(698),
    [anon_sym__] = ACTIONS(690),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE_DASH_POUND] = ACTIONS(700),
    [anon_sym_LBRACE] = ACTIONS(702),
    [anon_sym_RBRACE] = ACTIONS(704),
    [aux_sym__qid_token1] = ACTIONS(706),
    [anon_sym_DOT] = ACTIONS(708),
    [anon_sym_DASH] = ACTIONS(710),
    [anon_sym_AT] = ACTIONS(712),
    [anon_sym_quoteGoal] = ACTIONS(714),
    [anon_sym_tactic] = ACTIONS(716),
    [anon_sym_Prop] = ACTIONS(690),
    [anon_sym_quote] = ACTIONS(690),
    [anon_sym_quoteTerm] = ACTIONS(690),
    [anon_sym_quoteContext] = ACTIONS(690),
    [anon_sym_unquote] = ACTIONS(690),
    [anon_sym_LPAREN_PIPE] = ACTIONS(718),
    [anon_sym_u2987] = ACTIONS(720),
    [anon_sym_let] = ACTIONS(722),
    [anon_sym_do] = ACTIONS(724),
    [aux_sym_integer_token1] = ACTIONS(726),
    [aux_sym_string_token1] = ACTIONS(726),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(728),
    [sym_PropN] = ACTIONS(690),
  },
  [271] = {
    [sym__FORALL] = STATE(8495),
    [sym__ARROW] = STATE(2460),
    [sym__LAMBDA] = STATE(8064),
    [sym__ELLIPSIS] = STATE(5056),
    [sym_catchall_pragma] = STATE(3229),
    [sym__qid] = STATE(5217),
    [sym__binding_ids_and_absurds] = STATE(10107),
    [sym_attribute] = STATE(5830),
    [sym_attributes] = STATE(3627),
    [sym__expr_or_attr] = STATE(5056),
    [sym__application] = STATE(9572),
    [sym__expr2_without_let] = STATE(9572),
    [sym__expr2] = STATE(9572),
    [sym_atom] = STATE(5128),
    [aux_sym__atoms] = STATE(3561),
    [sym__atom_curly] = STATE(5069),
    [sym__atom_no_curly] = STATE(5069),
    [sym_forall] = STATE(9572),
    [sym_let] = STATE(9572),
    [sym_lambda] = STATE(9572),
    [sym_lambda_extended_or_absurd] = STATE(9572),
    [sym__lambda_clauses] = STATE(12467),
    [sym__lambda_clause_maybe_absurd] = STATE(8986),
    [sym_lambda_clause_absurd] = STATE(8986),
    [sym_lambda_clause] = STATE(8986),
    [sym_do] = STATE(9572),
    [sym_record_assignments] = STATE(5056),
    [sym_field_assignments] = STATE(5056),
    [sym_literal] = STATE(5056),
    [sym_SetN] = STATE(5056),
    [aux_sym__modal_arg_ids_repeat1] = STATE(5830),
    [aux_sym__lambda_clauses_repeat1] = STATE(2812),
    [sym_id] = ACTIONS(680),
    [anon_sym_forall] = ACTIONS(682),
    [anon_sym_u2200] = ACTIONS(682),
    [anon_sym_DASH_GT] = ACTIONS(684),
    [anon_sym_u2192] = ACTIONS(684),
    [anon_sym_BSLASH] = ACTIONS(686),
    [anon_sym_u03bb] = ACTIONS(688),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(690),
    [anon_sym_u2026] = ACTIONS(690),
    [anon_sym_record] = ACTIONS(692),
    [anon_sym_LPAREN] = ACTIONS(694),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(696),
    [anon_sym_u2983] = ACTIONS(698),
    [anon_sym__] = ACTIONS(690),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE_DASH_POUND] = ACTIONS(700),
    [anon_sym_LBRACE] = ACTIONS(702),
    [anon_sym_RBRACE] = ACTIONS(704),
    [aux_sym__qid_token1] = ACTIONS(706),
    [anon_sym_DOT] = ACTIONS(708),
    [anon_sym_DASH] = ACTIONS(710),
    [anon_sym_AT] = ACTIONS(712),
    [anon_sym_quoteGoal] = ACTIONS(714),
    [anon_sym_tactic] = ACTIONS(716),
    [anon_sym_Prop] = ACTIONS(690),
    [anon_sym_quote] = ACTIONS(690),
    [anon_sym_quoteTerm] = ACTIONS(690),
    [anon_sym_quoteContext] = ACTIONS(690),
    [anon_sym_unquote] = ACTIONS(690),
    [anon_sym_LPAREN_PIPE] = ACTIONS(718),
    [anon_sym_u2987] = ACTIONS(720),
    [anon_sym_let] = ACTIONS(722),
    [anon_sym_do] = ACTIONS(724),
    [aux_sym_integer_token1] = ACTIONS(726),
    [aux_sym_string_token1] = ACTIONS(726),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(728),
    [sym_PropN] = ACTIONS(690),
  },
  [272] = {
    [sym__FORALL] = STATE(8495),
    [sym__ARROW] = STATE(2460),
    [sym__LAMBDA] = STATE(8064),
    [sym__ELLIPSIS] = STATE(5056),
    [sym_catchall_pragma] = STATE(3229),
    [sym__qid] = STATE(5217),
    [sym__binding_ids_and_absurds] = STATE(10091),
    [sym_attribute] = STATE(5830),
    [sym_attributes] = STATE(3582),
    [sym__expr_or_attr] = STATE(5056),
    [sym__application] = STATE(9572),
    [sym__expr2_without_let] = STATE(9572),
    [sym__expr2] = STATE(9572),
    [sym_atom] = STATE(5128),
    [aux_sym__atoms] = STATE(3561),
    [sym__atom_curly] = STATE(5069),
    [sym__atom_no_curly] = STATE(5069),
    [sym_forall] = STATE(9572),
    [sym_let] = STATE(9572),
    [sym_lambda] = STATE(9572),
    [sym_lambda_extended_or_absurd] = STATE(9572),
    [sym__lambda_clauses] = STATE(11554),
    [sym__lambda_clause_maybe_absurd] = STATE(8986),
    [sym_lambda_clause_absurd] = STATE(8986),
    [sym_lambda_clause] = STATE(8986),
    [sym_do] = STATE(9572),
    [sym_record_assignments] = STATE(5056),
    [sym_field_assignments] = STATE(5056),
    [sym_literal] = STATE(5056),
    [sym_SetN] = STATE(5056),
    [aux_sym__modal_arg_ids_repeat1] = STATE(5830),
    [aux_sym__lambda_clauses_repeat1] = STATE(2812),
    [sym_id] = ACTIONS(680),
    [anon_sym_forall] = ACTIONS(682),
    [anon_sym_u2200] = ACTIONS(682),
    [anon_sym_DASH_GT] = ACTIONS(684),
    [anon_sym_u2192] = ACTIONS(684),
    [anon_sym_BSLASH] = ACTIONS(686),
    [anon_sym_u03bb] = ACTIONS(688),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(690),
    [anon_sym_u2026] = ACTIONS(690),
    [anon_sym_record] = ACTIONS(692),
    [anon_sym_LPAREN] = ACTIONS(694),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(696),
    [anon_sym_u2983] = ACTIONS(698),
    [anon_sym__] = ACTIONS(690),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE_DASH_POUND] = ACTIONS(700),
    [anon_sym_LBRACE] = ACTIONS(702),
    [anon_sym_RBRACE] = ACTIONS(732),
    [aux_sym__qid_token1] = ACTIONS(706),
    [anon_sym_DOT] = ACTIONS(708),
    [anon_sym_DASH] = ACTIONS(710),
    [anon_sym_AT] = ACTIONS(712),
    [anon_sym_quoteGoal] = ACTIONS(714),
    [anon_sym_tactic] = ACTIONS(716),
    [anon_sym_Prop] = ACTIONS(690),
    [anon_sym_quote] = ACTIONS(690),
    [anon_sym_quoteTerm] = ACTIONS(690),
    [anon_sym_quoteContext] = ACTIONS(690),
    [anon_sym_unquote] = ACTIONS(690),
    [anon_sym_LPAREN_PIPE] = ACTIONS(718),
    [anon_sym_u2987] = ACTIONS(720),
    [anon_sym_let] = ACTIONS(722),
    [anon_sym_do] = ACTIONS(724),
    [aux_sym_integer_token1] = ACTIONS(726),
    [aux_sym_string_token1] = ACTIONS(726),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(728),
    [sym_PropN] = ACTIONS(690),
  },
  [273] = {
    [sym__FORALL] = STATE(8495),
    [sym__ARROW] = STATE(2460),
    [sym__LAMBDA] = STATE(8064),
    [sym__ELLIPSIS] = STATE(5056),
    [sym_catchall_pragma] = STATE(3229),
    [sym__qid] = STATE(5217),
    [sym__binding_ids_and_absurds] = STATE(10027),
    [sym_attribute] = STATE(5830),
    [sym_attributes] = STATE(3540),
    [sym__expr_or_attr] = STATE(5056),
    [sym__application] = STATE(9572),
    [sym__expr2_without_let] = STATE(9572),
    [sym__expr2] = STATE(9572),
    [sym_atom] = STATE(5128),
    [aux_sym__atoms] = STATE(3561),
    [sym__atom_curly] = STATE(5069),
    [sym__atom_no_curly] = STATE(5069),
    [sym_forall] = STATE(9572),
    [sym_let] = STATE(9572),
    [sym_lambda] = STATE(9572),
    [sym_lambda_extended_or_absurd] = STATE(9572),
    [sym__lambda_clauses] = STATE(12467),
    [sym__lambda_clause_maybe_absurd] = STATE(8986),
    [sym_lambda_clause_absurd] = STATE(8986),
    [sym_lambda_clause] = STATE(8986),
    [sym_do] = STATE(9572),
    [sym_record_assignments] = STATE(5056),
    [sym_field_assignments] = STATE(5056),
    [sym_literal] = STATE(5056),
    [sym_SetN] = STATE(5056),
    [aux_sym__modal_arg_ids_repeat1] = STATE(5830),
    [aux_sym__lambda_clauses_repeat1] = STATE(2812),
    [sym_id] = ACTIONS(680),
    [anon_sym_forall] = ACTIONS(682),
    [anon_sym_u2200] = ACTIONS(682),
    [anon_sym_DASH_GT] = ACTIONS(684),
    [anon_sym_u2192] = ACTIONS(684),
    [anon_sym_BSLASH] = ACTIONS(686),
    [anon_sym_u03bb] = ACTIONS(688),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(690),
    [anon_sym_u2026] = ACTIONS(690),
    [anon_sym_record] = ACTIONS(692),
    [anon_sym_LPAREN] = ACTIONS(694),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(696),
    [anon_sym_u2983] = ACTIONS(698),
    [anon_sym__] = ACTIONS(690),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE_DASH_POUND] = ACTIONS(700),
    [anon_sym_LBRACE] = ACTIONS(702),
    [anon_sym_RBRACE] = ACTIONS(704),
    [aux_sym__qid_token1] = ACTIONS(706),
    [anon_sym_DOT] = ACTIONS(708),
    [anon_sym_DASH] = ACTIONS(710),
    [anon_sym_AT] = ACTIONS(712),
    [anon_sym_quoteGoal] = ACTIONS(714),
    [anon_sym_tactic] = ACTIONS(716),
    [anon_sym_Prop] = ACTIONS(690),
    [anon_sym_quote] = ACTIONS(690),
    [anon_sym_quoteTerm] = ACTIONS(690),
    [anon_sym_quoteContext] = ACTIONS(690),
    [anon_sym_unquote] = ACTIONS(690),
    [anon_sym_LPAREN_PIPE] = ACTIONS(718),
    [anon_sym_u2987] = ACTIONS(720),
    [anon_sym_let] = ACTIONS(722),
    [anon_sym_do] = ACTIONS(724),
    [aux_sym_integer_token1] = ACTIONS(726),
    [aux_sym_string_token1] = ACTIONS(726),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(728),
    [sym_PropN] = ACTIONS(690),
  },
  [274] = {
    [sym__FORALL] = STATE(8495),
    [sym__ARROW] = STATE(2460),
    [sym__LAMBDA] = STATE(8064),
    [sym__ELLIPSIS] = STATE(5056),
    [sym_catchall_pragma] = STATE(3229),
    [sym__qid] = STATE(5217),
    [sym__binding_ids_and_absurds] = STATE(10046),
    [sym_attribute] = STATE(5830),
    [sym_attributes] = STATE(3586),
    [sym__expr_or_attr] = STATE(5056),
    [sym__application] = STATE(9572),
    [sym__expr2_without_let] = STATE(9572),
    [sym__expr2] = STATE(9572),
    [sym_atom] = STATE(5128),
    [aux_sym__atoms] = STATE(3561),
    [sym__atom_curly] = STATE(5069),
    [sym__atom_no_curly] = STATE(5069),
    [sym_forall] = STATE(9572),
    [sym_let] = STATE(9572),
    [sym_lambda] = STATE(9572),
    [sym_lambda_extended_or_absurd] = STATE(9572),
    [sym__lambda_clauses] = STATE(11554),
    [sym__lambda_clause_maybe_absurd] = STATE(8986),
    [sym_lambda_clause_absurd] = STATE(8986),
    [sym_lambda_clause] = STATE(8986),
    [sym_do] = STATE(9572),
    [sym_record_assignments] = STATE(5056),
    [sym_field_assignments] = STATE(5056),
    [sym_literal] = STATE(5056),
    [sym_SetN] = STATE(5056),
    [aux_sym__modal_arg_ids_repeat1] = STATE(5830),
    [aux_sym__lambda_clauses_repeat1] = STATE(2812),
    [sym_id] = ACTIONS(680),
    [anon_sym_forall] = ACTIONS(682),
    [anon_sym_u2200] = ACTIONS(682),
    [anon_sym_DASH_GT] = ACTIONS(684),
    [anon_sym_u2192] = ACTIONS(684),
    [anon_sym_BSLASH] = ACTIONS(686),
    [anon_sym_u03bb] = ACTIONS(688),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(690),
    [anon_sym_u2026] = ACTIONS(690),
    [anon_sym_record] = ACTIONS(692),
    [anon_sym_LPAREN] = ACTIONS(694),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(696),
    [anon_sym_u2983] = ACTIONS(698),
    [anon_sym__] = ACTIONS(690),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE_DASH_POUND] = ACTIONS(700),
    [anon_sym_LBRACE] = ACTIONS(702),
    [anon_sym_RBRACE] = ACTIONS(732),
    [aux_sym__qid_token1] = ACTIONS(706),
    [anon_sym_DOT] = ACTIONS(708),
    [anon_sym_DASH] = ACTIONS(710),
    [anon_sym_AT] = ACTIONS(712),
    [anon_sym_quoteGoal] = ACTIONS(714),
    [anon_sym_tactic] = ACTIONS(716),
    [anon_sym_Prop] = ACTIONS(690),
    [anon_sym_quote] = ACTIONS(690),
    [anon_sym_quoteTerm] = ACTIONS(690),
    [anon_sym_quoteContext] = ACTIONS(690),
    [anon_sym_unquote] = ACTIONS(690),
    [anon_sym_LPAREN_PIPE] = ACTIONS(718),
    [anon_sym_u2987] = ACTIONS(720),
    [anon_sym_let] = ACTIONS(722),
    [anon_sym_do] = ACTIONS(724),
    [aux_sym_integer_token1] = ACTIONS(726),
    [aux_sym_string_token1] = ACTIONS(726),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(728),
    [sym_PropN] = ACTIONS(690),
  },
  [275] = {
    [sym__FORALL] = STATE(8495),
    [sym__ARROW] = STATE(2460),
    [sym__LAMBDA] = STATE(8064),
    [sym__ELLIPSIS] = STATE(5056),
    [sym_catchall_pragma] = STATE(3229),
    [sym__qid] = STATE(5217),
    [sym__binding_ids_and_absurds] = STATE(9903),
    [sym_attribute] = STATE(5830),
    [sym_attributes] = STATE(3631),
    [sym__expr_or_attr] = STATE(5056),
    [sym__application] = STATE(9572),
    [sym__expr2_without_let] = STATE(9572),
    [sym__expr2] = STATE(9572),
    [sym_atom] = STATE(5128),
    [aux_sym__atoms] = STATE(3561),
    [sym__atom_curly] = STATE(5069),
    [sym__atom_no_curly] = STATE(5069),
    [sym_forall] = STATE(9572),
    [sym_let] = STATE(9572),
    [sym_lambda] = STATE(9572),
    [sym_lambda_extended_or_absurd] = STATE(9572),
    [sym__lambda_clauses] = STATE(12467),
    [sym__lambda_clause_maybe_absurd] = STATE(8986),
    [sym_lambda_clause_absurd] = STATE(8986),
    [sym_lambda_clause] = STATE(8986),
    [sym_do] = STATE(9572),
    [sym_record_assignments] = STATE(5056),
    [sym_field_assignments] = STATE(5056),
    [sym_literal] = STATE(5056),
    [sym_SetN] = STATE(5056),
    [aux_sym__modal_arg_ids_repeat1] = STATE(5830),
    [aux_sym__lambda_clauses_repeat1] = STATE(2812),
    [sym_id] = ACTIONS(680),
    [anon_sym_forall] = ACTIONS(682),
    [anon_sym_u2200] = ACTIONS(682),
    [anon_sym_DASH_GT] = ACTIONS(684),
    [anon_sym_u2192] = ACTIONS(684),
    [anon_sym_BSLASH] = ACTIONS(686),
    [anon_sym_u03bb] = ACTIONS(688),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(690),
    [anon_sym_u2026] = ACTIONS(690),
    [anon_sym_record] = ACTIONS(692),
    [anon_sym_LPAREN] = ACTIONS(694),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(696),
    [anon_sym_u2983] = ACTIONS(698),
    [anon_sym__] = ACTIONS(690),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE_DASH_POUND] = ACTIONS(700),
    [anon_sym_LBRACE] = ACTIONS(702),
    [anon_sym_RBRACE] = ACTIONS(704),
    [aux_sym__qid_token1] = ACTIONS(706),
    [anon_sym_DOT] = ACTIONS(708),
    [anon_sym_DASH] = ACTIONS(710),
    [anon_sym_AT] = ACTIONS(712),
    [anon_sym_quoteGoal] = ACTIONS(714),
    [anon_sym_tactic] = ACTIONS(716),
    [anon_sym_Prop] = ACTIONS(690),
    [anon_sym_quote] = ACTIONS(690),
    [anon_sym_quoteTerm] = ACTIONS(690),
    [anon_sym_quoteContext] = ACTIONS(690),
    [anon_sym_unquote] = ACTIONS(690),
    [anon_sym_LPAREN_PIPE] = ACTIONS(718),
    [anon_sym_u2987] = ACTIONS(720),
    [anon_sym_let] = ACTIONS(722),
    [anon_sym_do] = ACTIONS(724),
    [aux_sym_integer_token1] = ACTIONS(726),
    [aux_sym_string_token1] = ACTIONS(726),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(728),
    [sym_PropN] = ACTIONS(690),
  },
  [276] = {
    [sym__FORALL] = STATE(8495),
    [sym__ARROW] = STATE(2460),
    [sym__LAMBDA] = STATE(8064),
    [sym__ELLIPSIS] = STATE(5056),
    [sym_catchall_pragma] = STATE(3229),
    [sym__qid] = STATE(5217),
    [sym__binding_ids_and_absurds] = STATE(10000),
    [sym_attribute] = STATE(5830),
    [sym_attributes] = STATE(3437),
    [sym__expr_or_attr] = STATE(5056),
    [sym__application] = STATE(9572),
    [sym__expr2_without_let] = STATE(9572),
    [sym__expr2] = STATE(9572),
    [sym_atom] = STATE(5128),
    [aux_sym__atoms] = STATE(3561),
    [sym__atom_curly] = STATE(5069),
    [sym__atom_no_curly] = STATE(5069),
    [sym_forall] = STATE(9572),
    [sym_let] = STATE(9572),
    [sym_lambda] = STATE(9572),
    [sym_lambda_extended_or_absurd] = STATE(9572),
    [sym__lambda_clauses] = STATE(11554),
    [sym__lambda_clause_maybe_absurd] = STATE(8986),
    [sym_lambda_clause_absurd] = STATE(8986),
    [sym_lambda_clause] = STATE(8986),
    [sym_do] = STATE(9572),
    [sym_record_assignments] = STATE(5056),
    [sym_field_assignments] = STATE(5056),
    [sym_literal] = STATE(5056),
    [sym_SetN] = STATE(5056),
    [aux_sym__modal_arg_ids_repeat1] = STATE(5830),
    [aux_sym__lambda_clauses_repeat1] = STATE(2812),
    [sym_id] = ACTIONS(680),
    [anon_sym_forall] = ACTIONS(682),
    [anon_sym_u2200] = ACTIONS(682),
    [anon_sym_DASH_GT] = ACTIONS(684),
    [anon_sym_u2192] = ACTIONS(684),
    [anon_sym_BSLASH] = ACTIONS(686),
    [anon_sym_u03bb] = ACTIONS(688),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(690),
    [anon_sym_u2026] = ACTIONS(690),
    [anon_sym_record] = ACTIONS(692),
    [anon_sym_LPAREN] = ACTIONS(694),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(696),
    [anon_sym_u2983] = ACTIONS(698),
    [anon_sym__] = ACTIONS(690),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE_DASH_POUND] = ACTIONS(700),
    [anon_sym_LBRACE] = ACTIONS(702),
    [anon_sym_RBRACE] = ACTIONS(732),
    [aux_sym__qid_token1] = ACTIONS(706),
    [anon_sym_DOT] = ACTIONS(708),
    [anon_sym_DASH] = ACTIONS(710),
    [anon_sym_AT] = ACTIONS(712),
    [anon_sym_quoteGoal] = ACTIONS(714),
    [anon_sym_tactic] = ACTIONS(716),
    [anon_sym_Prop] = ACTIONS(690),
    [anon_sym_quote] = ACTIONS(690),
    [anon_sym_quoteTerm] = ACTIONS(690),
    [anon_sym_quoteContext] = ACTIONS(690),
    [anon_sym_unquote] = ACTIONS(690),
    [anon_sym_LPAREN_PIPE] = ACTIONS(718),
    [anon_sym_u2987] = ACTIONS(720),
    [anon_sym_let] = ACTIONS(722),
    [anon_sym_do] = ACTIONS(724),
    [aux_sym_integer_token1] = ACTIONS(726),
    [aux_sym_string_token1] = ACTIONS(726),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(728),
    [sym_PropN] = ACTIONS(690),
  },
  [277] = {
    [sym__FORALL] = STATE(8495),
    [sym__ARROW] = STATE(2460),
    [sym__LAMBDA] = STATE(8064),
    [sym__ELLIPSIS] = STATE(5056),
    [sym_catchall_pragma] = STATE(3229),
    [sym__qid] = STATE(5217),
    [sym__binding_ids_and_absurds] = STATE(10199),
    [sym_attribute] = STATE(5830),
    [sym_attributes] = STATE(3608),
    [sym__expr_or_attr] = STATE(5056),
    [sym__application] = STATE(9572),
    [sym__expr2_without_let] = STATE(9572),
    [sym__expr2] = STATE(9572),
    [sym_atom] = STATE(5128),
    [aux_sym__atoms] = STATE(3561),
    [sym__atom_curly] = STATE(5069),
    [sym__atom_no_curly] = STATE(5069),
    [sym_forall] = STATE(9572),
    [sym_let] = STATE(9572),
    [sym_lambda] = STATE(9572),
    [sym_lambda_extended_or_absurd] = STATE(9572),
    [sym__lambda_clauses] = STATE(12467),
    [sym__lambda_clause_maybe_absurd] = STATE(8986),
    [sym_lambda_clause_absurd] = STATE(8986),
    [sym_lambda_clause] = STATE(8986),
    [sym_do] = STATE(9572),
    [sym_record_assignments] = STATE(5056),
    [sym_field_assignments] = STATE(5056),
    [sym_literal] = STATE(5056),
    [sym_SetN] = STATE(5056),
    [aux_sym__modal_arg_ids_repeat1] = STATE(5830),
    [aux_sym__lambda_clauses_repeat1] = STATE(2812),
    [sym_id] = ACTIONS(680),
    [anon_sym_forall] = ACTIONS(682),
    [anon_sym_u2200] = ACTIONS(682),
    [anon_sym_DASH_GT] = ACTIONS(684),
    [anon_sym_u2192] = ACTIONS(684),
    [anon_sym_BSLASH] = ACTIONS(686),
    [anon_sym_u03bb] = ACTIONS(688),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(690),
    [anon_sym_u2026] = ACTIONS(690),
    [anon_sym_record] = ACTIONS(692),
    [anon_sym_LPAREN] = ACTIONS(694),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(696),
    [anon_sym_u2983] = ACTIONS(698),
    [anon_sym__] = ACTIONS(690),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE_DASH_POUND] = ACTIONS(700),
    [anon_sym_LBRACE] = ACTIONS(702),
    [anon_sym_RBRACE] = ACTIONS(704),
    [aux_sym__qid_token1] = ACTIONS(706),
    [anon_sym_DOT] = ACTIONS(708),
    [anon_sym_DASH] = ACTIONS(710),
    [anon_sym_AT] = ACTIONS(712),
    [anon_sym_quoteGoal] = ACTIONS(714),
    [anon_sym_tactic] = ACTIONS(716),
    [anon_sym_Prop] = ACTIONS(690),
    [anon_sym_quote] = ACTIONS(690),
    [anon_sym_quoteTerm] = ACTIONS(690),
    [anon_sym_quoteContext] = ACTIONS(690),
    [anon_sym_unquote] = ACTIONS(690),
    [anon_sym_LPAREN_PIPE] = ACTIONS(718),
    [anon_sym_u2987] = ACTIONS(720),
    [anon_sym_let] = ACTIONS(722),
    [anon_sym_do] = ACTIONS(724),
    [aux_sym_integer_token1] = ACTIONS(726),
    [aux_sym_string_token1] = ACTIONS(726),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(728),
    [sym_PropN] = ACTIONS(690),
  },
  [278] = {
    [sym__FORALL] = STATE(8495),
    [sym__ARROW] = STATE(2460),
    [sym__LAMBDA] = STATE(8064),
    [sym__ELLIPSIS] = STATE(5056),
    [sym_catchall_pragma] = STATE(3229),
    [sym__qid] = STATE(5217),
    [sym__binding_ids_and_absurds] = STATE(10182),
    [sym_attribute] = STATE(5830),
    [sym_attributes] = STATE(3595),
    [sym__expr_or_attr] = STATE(5056),
    [sym__application] = STATE(9572),
    [sym__expr2_without_let] = STATE(9572),
    [sym__expr2] = STATE(9572),
    [sym_atom] = STATE(5128),
    [aux_sym__atoms] = STATE(3561),
    [sym__atom_curly] = STATE(5069),
    [sym__atom_no_curly] = STATE(5069),
    [sym_forall] = STATE(9572),
    [sym_let] = STATE(9572),
    [sym_lambda] = STATE(9572),
    [sym_lambda_extended_or_absurd] = STATE(9572),
    [sym__lambda_clauses] = STATE(12467),
    [sym__lambda_clause_maybe_absurd] = STATE(8986),
    [sym_lambda_clause_absurd] = STATE(8986),
    [sym_lambda_clause] = STATE(8986),
    [sym_do] = STATE(9572),
    [sym_record_assignments] = STATE(5056),
    [sym_field_assignments] = STATE(5056),
    [sym_literal] = STATE(5056),
    [sym_SetN] = STATE(5056),
    [aux_sym__modal_arg_ids_repeat1] = STATE(5830),
    [aux_sym__lambda_clauses_repeat1] = STATE(2812),
    [sym_id] = ACTIONS(680),
    [anon_sym_forall] = ACTIONS(682),
    [anon_sym_u2200] = ACTIONS(682),
    [anon_sym_DASH_GT] = ACTIONS(684),
    [anon_sym_u2192] = ACTIONS(684),
    [anon_sym_BSLASH] = ACTIONS(686),
    [anon_sym_u03bb] = ACTIONS(688),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(690),
    [anon_sym_u2026] = ACTIONS(690),
    [anon_sym_record] = ACTIONS(692),
    [anon_sym_LPAREN] = ACTIONS(694),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(696),
    [anon_sym_u2983] = ACTIONS(698),
    [anon_sym__] = ACTIONS(690),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE_DASH_POUND] = ACTIONS(700),
    [anon_sym_LBRACE] = ACTIONS(702),
    [anon_sym_RBRACE] = ACTIONS(704),
    [aux_sym__qid_token1] = ACTIONS(706),
    [anon_sym_DOT] = ACTIONS(708),
    [anon_sym_DASH] = ACTIONS(710),
    [anon_sym_AT] = ACTIONS(712),
    [anon_sym_quoteGoal] = ACTIONS(714),
    [anon_sym_tactic] = ACTIONS(716),
    [anon_sym_Prop] = ACTIONS(690),
    [anon_sym_quote] = ACTIONS(690),
    [anon_sym_quoteTerm] = ACTIONS(690),
    [anon_sym_quoteContext] = ACTIONS(690),
    [anon_sym_unquote] = ACTIONS(690),
    [anon_sym_LPAREN_PIPE] = ACTIONS(718),
    [anon_sym_u2987] = ACTIONS(720),
    [anon_sym_let] = ACTIONS(722),
    [anon_sym_do] = ACTIONS(724),
    [aux_sym_integer_token1] = ACTIONS(726),
    [aux_sym_string_token1] = ACTIONS(726),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(728),
    [sym_PropN] = ACTIONS(690),
  },
  [279] = {
    [sym__FORALL] = STATE(8495),
    [sym__ARROW] = STATE(2460),
    [sym__LAMBDA] = STATE(8064),
    [sym__ELLIPSIS] = STATE(5056),
    [sym_catchall_pragma] = STATE(3229),
    [sym__qid] = STATE(5217),
    [sym__binding_ids_and_absurds] = STATE(10230),
    [sym_attribute] = STATE(5830),
    [sym_attributes] = STATE(3405),
    [sym__expr_or_attr] = STATE(5056),
    [sym__application] = STATE(9572),
    [sym__expr2_without_let] = STATE(9572),
    [sym__expr2] = STATE(9572),
    [sym_atom] = STATE(5128),
    [aux_sym__atoms] = STATE(3561),
    [sym__atom_curly] = STATE(5069),
    [sym__atom_no_curly] = STATE(5069),
    [sym_forall] = STATE(9572),
    [sym_let] = STATE(9572),
    [sym_lambda] = STATE(9572),
    [sym_lambda_extended_or_absurd] = STATE(9572),
    [sym__lambda_clauses] = STATE(12467),
    [sym__lambda_clause_maybe_absurd] = STATE(8986),
    [sym_lambda_clause_absurd] = STATE(8986),
    [sym_lambda_clause] = STATE(8986),
    [sym_do] = STATE(9572),
    [sym_record_assignments] = STATE(5056),
    [sym_field_assignments] = STATE(5056),
    [sym_literal] = STATE(5056),
    [sym_SetN] = STATE(5056),
    [aux_sym__modal_arg_ids_repeat1] = STATE(5830),
    [aux_sym__lambda_clauses_repeat1] = STATE(2812),
    [sym_id] = ACTIONS(680),
    [anon_sym_forall] = ACTIONS(682),
    [anon_sym_u2200] = ACTIONS(682),
    [anon_sym_DASH_GT] = ACTIONS(684),
    [anon_sym_u2192] = ACTIONS(684),
    [anon_sym_BSLASH] = ACTIONS(686),
    [anon_sym_u03bb] = ACTIONS(688),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(690),
    [anon_sym_u2026] = ACTIONS(690),
    [anon_sym_record] = ACTIONS(692),
    [anon_sym_LPAREN] = ACTIONS(694),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(696),
    [anon_sym_u2983] = ACTIONS(698),
    [anon_sym__] = ACTIONS(690),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE_DASH_POUND] = ACTIONS(700),
    [anon_sym_LBRACE] = ACTIONS(702),
    [anon_sym_RBRACE] = ACTIONS(704),
    [aux_sym__qid_token1] = ACTIONS(706),
    [anon_sym_DOT] = ACTIONS(708),
    [anon_sym_DASH] = ACTIONS(710),
    [anon_sym_AT] = ACTIONS(712),
    [anon_sym_quoteGoal] = ACTIONS(714),
    [anon_sym_tactic] = ACTIONS(716),
    [anon_sym_Prop] = ACTIONS(690),
    [anon_sym_quote] = ACTIONS(690),
    [anon_sym_quoteTerm] = ACTIONS(690),
    [anon_sym_quoteContext] = ACTIONS(690),
    [anon_sym_unquote] = ACTIONS(690),
    [anon_sym_LPAREN_PIPE] = ACTIONS(718),
    [anon_sym_u2987] = ACTIONS(720),
    [anon_sym_let] = ACTIONS(722),
    [anon_sym_do] = ACTIONS(724),
    [aux_sym_integer_token1] = ACTIONS(726),
    [aux_sym_string_token1] = ACTIONS(726),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(728),
    [sym_PropN] = ACTIONS(690),
  },
  [280] = {
    [sym__FORALL] = STATE(8495),
    [sym__ARROW] = STATE(2460),
    [sym__LAMBDA] = STATE(8064),
    [sym__ELLIPSIS] = STATE(5056),
    [sym_catchall_pragma] = STATE(3229),
    [sym__qid] = STATE(5217),
    [sym__binding_ids_and_absurds] = STATE(9966),
    [sym_attribute] = STATE(5830),
    [sym_attributes] = STATE(3663),
    [sym__expr_or_attr] = STATE(5056),
    [sym__application] = STATE(9572),
    [sym__expr2_without_let] = STATE(9572),
    [sym__expr2] = STATE(9572),
    [sym_atom] = STATE(5128),
    [aux_sym__atoms] = STATE(3561),
    [sym__atom_curly] = STATE(5069),
    [sym__atom_no_curly] = STATE(5069),
    [sym_forall] = STATE(9572),
    [sym_let] = STATE(9572),
    [sym_lambda] = STATE(9572),
    [sym_lambda_extended_or_absurd] = STATE(9572),
    [sym__lambda_clauses] = STATE(11554),
    [sym__lambda_clause_maybe_absurd] = STATE(8986),
    [sym_lambda_clause_absurd] = STATE(8986),
    [sym_lambda_clause] = STATE(8986),
    [sym_do] = STATE(9572),
    [sym_record_assignments] = STATE(5056),
    [sym_field_assignments] = STATE(5056),
    [sym_literal] = STATE(5056),
    [sym_SetN] = STATE(5056),
    [aux_sym__modal_arg_ids_repeat1] = STATE(5830),
    [aux_sym__lambda_clauses_repeat1] = STATE(2812),
    [sym_id] = ACTIONS(680),
    [anon_sym_forall] = ACTIONS(682),
    [anon_sym_u2200] = ACTIONS(682),
    [anon_sym_DASH_GT] = ACTIONS(684),
    [anon_sym_u2192] = ACTIONS(684),
    [anon_sym_BSLASH] = ACTIONS(686),
    [anon_sym_u03bb] = ACTIONS(688),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(690),
    [anon_sym_u2026] = ACTIONS(690),
    [anon_sym_record] = ACTIONS(692),
    [anon_sym_LPAREN] = ACTIONS(694),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(696),
    [anon_sym_u2983] = ACTIONS(698),
    [anon_sym__] = ACTIONS(690),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE_DASH_POUND] = ACTIONS(700),
    [anon_sym_LBRACE] = ACTIONS(702),
    [anon_sym_RBRACE] = ACTIONS(732),
    [aux_sym__qid_token1] = ACTIONS(706),
    [anon_sym_DOT] = ACTIONS(708),
    [anon_sym_DASH] = ACTIONS(710),
    [anon_sym_AT] = ACTIONS(712),
    [anon_sym_quoteGoal] = ACTIONS(714),
    [anon_sym_tactic] = ACTIONS(716),
    [anon_sym_Prop] = ACTIONS(690),
    [anon_sym_quote] = ACTIONS(690),
    [anon_sym_quoteTerm] = ACTIONS(690),
    [anon_sym_quoteContext] = ACTIONS(690),
    [anon_sym_unquote] = ACTIONS(690),
    [anon_sym_LPAREN_PIPE] = ACTIONS(718),
    [anon_sym_u2987] = ACTIONS(720),
    [anon_sym_let] = ACTIONS(722),
    [anon_sym_do] = ACTIONS(724),
    [aux_sym_integer_token1] = ACTIONS(726),
    [aux_sym_string_token1] = ACTIONS(726),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(728),
    [sym_PropN] = ACTIONS(690),
  },
  [281] = {
    [sym__FORALL] = STATE(8495),
    [sym__ARROW] = STATE(2460),
    [sym__LAMBDA] = STATE(8064),
    [sym__ELLIPSIS] = STATE(5056),
    [sym_catchall_pragma] = STATE(3229),
    [sym__qid] = STATE(5217),
    [sym__binding_ids_and_absurds] = STATE(10158),
    [sym_attribute] = STATE(5830),
    [sym_attributes] = STATE(3666),
    [sym__expr_or_attr] = STATE(5056),
    [sym__application] = STATE(9572),
    [sym__expr2_without_let] = STATE(9572),
    [sym__expr2] = STATE(9572),
    [sym_atom] = STATE(5128),
    [aux_sym__atoms] = STATE(3561),
    [sym__atom_curly] = STATE(5069),
    [sym__atom_no_curly] = STATE(5069),
    [sym_forall] = STATE(9572),
    [sym_let] = STATE(9572),
    [sym_lambda] = STATE(9572),
    [sym_lambda_extended_or_absurd] = STATE(9572),
    [sym__lambda_clauses] = STATE(12467),
    [sym__lambda_clause_maybe_absurd] = STATE(8986),
    [sym_lambda_clause_absurd] = STATE(8986),
    [sym_lambda_clause] = STATE(8986),
    [sym_do] = STATE(9572),
    [sym_record_assignments] = STATE(5056),
    [sym_field_assignments] = STATE(5056),
    [sym_literal] = STATE(5056),
    [sym_SetN] = STATE(5056),
    [aux_sym__modal_arg_ids_repeat1] = STATE(5830),
    [aux_sym__lambda_clauses_repeat1] = STATE(2812),
    [sym_id] = ACTIONS(680),
    [anon_sym_forall] = ACTIONS(682),
    [anon_sym_u2200] = ACTIONS(682),
    [anon_sym_DASH_GT] = ACTIONS(684),
    [anon_sym_u2192] = ACTIONS(684),
    [anon_sym_BSLASH] = ACTIONS(686),
    [anon_sym_u03bb] = ACTIONS(688),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(690),
    [anon_sym_u2026] = ACTIONS(690),
    [anon_sym_record] = ACTIONS(692),
    [anon_sym_LPAREN] = ACTIONS(694),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(696),
    [anon_sym_u2983] = ACTIONS(698),
    [anon_sym__] = ACTIONS(690),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE_DASH_POUND] = ACTIONS(700),
    [anon_sym_LBRACE] = ACTIONS(702),
    [anon_sym_RBRACE] = ACTIONS(704),
    [aux_sym__qid_token1] = ACTIONS(706),
    [anon_sym_DOT] = ACTIONS(708),
    [anon_sym_DASH] = ACTIONS(710),
    [anon_sym_AT] = ACTIONS(712),
    [anon_sym_quoteGoal] = ACTIONS(714),
    [anon_sym_tactic] = ACTIONS(716),
    [anon_sym_Prop] = ACTIONS(690),
    [anon_sym_quote] = ACTIONS(690),
    [anon_sym_quoteTerm] = ACTIONS(690),
    [anon_sym_quoteContext] = ACTIONS(690),
    [anon_sym_unquote] = ACTIONS(690),
    [anon_sym_LPAREN_PIPE] = ACTIONS(718),
    [anon_sym_u2987] = ACTIONS(720),
    [anon_sym_let] = ACTIONS(722),
    [anon_sym_do] = ACTIONS(724),
    [aux_sym_integer_token1] = ACTIONS(726),
    [aux_sym_string_token1] = ACTIONS(726),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(728),
    [sym_PropN] = ACTIONS(690),
  },
  [282] = {
    [sym__FORALL] = STATE(8495),
    [sym__ARROW] = STATE(2460),
    [sym__LAMBDA] = STATE(8064),
    [sym__ELLIPSIS] = STATE(5056),
    [sym_catchall_pragma] = STATE(3229),
    [sym__qid] = STATE(5217),
    [sym__binding_ids_and_absurds] = STATE(9938),
    [sym_attribute] = STATE(5830),
    [sym_attributes] = STATE(3420),
    [sym__expr_or_attr] = STATE(5056),
    [sym__application] = STATE(9572),
    [sym__expr2_without_let] = STATE(9572),
    [sym__expr2] = STATE(9572),
    [sym_atom] = STATE(5128),
    [aux_sym__atoms] = STATE(3561),
    [sym__atom_curly] = STATE(5069),
    [sym__atom_no_curly] = STATE(5069),
    [sym_forall] = STATE(9572),
    [sym_let] = STATE(9572),
    [sym_lambda] = STATE(9572),
    [sym_lambda_extended_or_absurd] = STATE(9572),
    [sym__lambda_clauses] = STATE(11554),
    [sym__lambda_clause_maybe_absurd] = STATE(8986),
    [sym_lambda_clause_absurd] = STATE(8986),
    [sym_lambda_clause] = STATE(8986),
    [sym_do] = STATE(9572),
    [sym_record_assignments] = STATE(5056),
    [sym_field_assignments] = STATE(5056),
    [sym_literal] = STATE(5056),
    [sym_SetN] = STATE(5056),
    [aux_sym__modal_arg_ids_repeat1] = STATE(5830),
    [aux_sym__lambda_clauses_repeat1] = STATE(2812),
    [sym_id] = ACTIONS(680),
    [anon_sym_forall] = ACTIONS(682),
    [anon_sym_u2200] = ACTIONS(682),
    [anon_sym_DASH_GT] = ACTIONS(684),
    [anon_sym_u2192] = ACTIONS(684),
    [anon_sym_BSLASH] = ACTIONS(686),
    [anon_sym_u03bb] = ACTIONS(688),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(690),
    [anon_sym_u2026] = ACTIONS(690),
    [anon_sym_record] = ACTIONS(692),
    [anon_sym_LPAREN] = ACTIONS(694),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(696),
    [anon_sym_u2983] = ACTIONS(698),
    [anon_sym__] = ACTIONS(690),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE_DASH_POUND] = ACTIONS(700),
    [anon_sym_LBRACE] = ACTIONS(702),
    [anon_sym_RBRACE] = ACTIONS(732),
    [aux_sym__qid_token1] = ACTIONS(706),
    [anon_sym_DOT] = ACTIONS(708),
    [anon_sym_DASH] = ACTIONS(710),
    [anon_sym_AT] = ACTIONS(712),
    [anon_sym_quoteGoal] = ACTIONS(714),
    [anon_sym_tactic] = ACTIONS(716),
    [anon_sym_Prop] = ACTIONS(690),
    [anon_sym_quote] = ACTIONS(690),
    [anon_sym_quoteTerm] = ACTIONS(690),
    [anon_sym_quoteContext] = ACTIONS(690),
    [anon_sym_unquote] = ACTIONS(690),
    [anon_sym_LPAREN_PIPE] = ACTIONS(718),
    [anon_sym_u2987] = ACTIONS(720),
    [anon_sym_let] = ACTIONS(722),
    [anon_sym_do] = ACTIONS(724),
    [aux_sym_integer_token1] = ACTIONS(726),
    [aux_sym_string_token1] = ACTIONS(726),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(728),
    [sym_PropN] = ACTIONS(690),
  },
  [283] = {
    [sym__FORALL] = STATE(8495),
    [sym__ARROW] = STATE(2460),
    [sym__LAMBDA] = STATE(8064),
    [sym__ELLIPSIS] = STATE(5056),
    [sym_catchall_pragma] = STATE(3229),
    [sym__qid] = STATE(5217),
    [sym__binding_ids_and_absurds] = STATE(9917),
    [sym_attribute] = STATE(5830),
    [sym_attributes] = STATE(3414),
    [sym__expr_or_attr] = STATE(5056),
    [sym__application] = STATE(9572),
    [sym__expr2_without_let] = STATE(9572),
    [sym__expr2] = STATE(9572),
    [sym_atom] = STATE(5128),
    [aux_sym__atoms] = STATE(3561),
    [sym__atom_curly] = STATE(5069),
    [sym__atom_no_curly] = STATE(5069),
    [sym_forall] = STATE(9572),
    [sym_let] = STATE(9572),
    [sym_lambda] = STATE(9572),
    [sym_lambda_extended_or_absurd] = STATE(9572),
    [sym__lambda_clauses] = STATE(12467),
    [sym__lambda_clause_maybe_absurd] = STATE(8986),
    [sym_lambda_clause_absurd] = STATE(8986),
    [sym_lambda_clause] = STATE(8986),
    [sym_do] = STATE(9572),
    [sym_record_assignments] = STATE(5056),
    [sym_field_assignments] = STATE(5056),
    [sym_literal] = STATE(5056),
    [sym_SetN] = STATE(5056),
    [aux_sym__modal_arg_ids_repeat1] = STATE(5830),
    [aux_sym__lambda_clauses_repeat1] = STATE(2812),
    [sym_id] = ACTIONS(680),
    [anon_sym_forall] = ACTIONS(682),
    [anon_sym_u2200] = ACTIONS(682),
    [anon_sym_DASH_GT] = ACTIONS(684),
    [anon_sym_u2192] = ACTIONS(684),
    [anon_sym_BSLASH] = ACTIONS(686),
    [anon_sym_u03bb] = ACTIONS(688),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(690),
    [anon_sym_u2026] = ACTIONS(690),
    [anon_sym_record] = ACTIONS(692),
    [anon_sym_LPAREN] = ACTIONS(694),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(696),
    [anon_sym_u2983] = ACTIONS(698),
    [anon_sym__] = ACTIONS(690),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE_DASH_POUND] = ACTIONS(700),
    [anon_sym_LBRACE] = ACTIONS(702),
    [anon_sym_RBRACE] = ACTIONS(704),
    [aux_sym__qid_token1] = ACTIONS(706),
    [anon_sym_DOT] = ACTIONS(708),
    [anon_sym_DASH] = ACTIONS(710),
    [anon_sym_AT] = ACTIONS(712),
    [anon_sym_quoteGoal] = ACTIONS(714),
    [anon_sym_tactic] = ACTIONS(716),
    [anon_sym_Prop] = ACTIONS(690),
    [anon_sym_quote] = ACTIONS(690),
    [anon_sym_quoteTerm] = ACTIONS(690),
    [anon_sym_quoteContext] = ACTIONS(690),
    [anon_sym_unquote] = ACTIONS(690),
    [anon_sym_LPAREN_PIPE] = ACTIONS(718),
    [anon_sym_u2987] = ACTIONS(720),
    [anon_sym_let] = ACTIONS(722),
    [anon_sym_do] = ACTIONS(724),
    [aux_sym_integer_token1] = ACTIONS(726),
    [aux_sym_string_token1] = ACTIONS(726),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(728),
    [sym_PropN] = ACTIONS(690),
  },
  [284] = {
    [sym__FORALL] = STATE(8495),
    [sym__ARROW] = STATE(2460),
    [sym__LAMBDA] = STATE(8064),
    [sym__ELLIPSIS] = STATE(5056),
    [sym_catchall_pragma] = STATE(3229),
    [sym__qid] = STATE(5217),
    [sym__binding_ids_and_absurds] = STATE(10190),
    [sym_attribute] = STATE(5830),
    [sym_attributes] = STATE(3612),
    [sym__expr_or_attr] = STATE(5056),
    [sym__application] = STATE(9572),
    [sym__expr2_without_let] = STATE(9572),
    [sym__expr2] = STATE(9572),
    [sym_atom] = STATE(5128),
    [aux_sym__atoms] = STATE(3561),
    [sym__atom_curly] = STATE(5069),
    [sym__atom_no_curly] = STATE(5069),
    [sym_forall] = STATE(9572),
    [sym_let] = STATE(9572),
    [sym_lambda] = STATE(9572),
    [sym_lambda_extended_or_absurd] = STATE(9572),
    [sym__lambda_clauses] = STATE(12467),
    [sym__lambda_clause_maybe_absurd] = STATE(8986),
    [sym_lambda_clause_absurd] = STATE(8986),
    [sym_lambda_clause] = STATE(8986),
    [sym_do] = STATE(9572),
    [sym_record_assignments] = STATE(5056),
    [sym_field_assignments] = STATE(5056),
    [sym_literal] = STATE(5056),
    [sym_SetN] = STATE(5056),
    [aux_sym__modal_arg_ids_repeat1] = STATE(5830),
    [aux_sym__lambda_clauses_repeat1] = STATE(2812),
    [sym_id] = ACTIONS(680),
    [anon_sym_forall] = ACTIONS(682),
    [anon_sym_u2200] = ACTIONS(682),
    [anon_sym_DASH_GT] = ACTIONS(684),
    [anon_sym_u2192] = ACTIONS(684),
    [anon_sym_BSLASH] = ACTIONS(686),
    [anon_sym_u03bb] = ACTIONS(688),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(690),
    [anon_sym_u2026] = ACTIONS(690),
    [anon_sym_record] = ACTIONS(692),
    [anon_sym_LPAREN] = ACTIONS(694),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(696),
    [anon_sym_u2983] = ACTIONS(698),
    [anon_sym__] = ACTIONS(690),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE_DASH_POUND] = ACTIONS(700),
    [anon_sym_LBRACE] = ACTIONS(702),
    [anon_sym_RBRACE] = ACTIONS(704),
    [aux_sym__qid_token1] = ACTIONS(706),
    [anon_sym_DOT] = ACTIONS(708),
    [anon_sym_DASH] = ACTIONS(710),
    [anon_sym_AT] = ACTIONS(712),
    [anon_sym_quoteGoal] = ACTIONS(714),
    [anon_sym_tactic] = ACTIONS(716),
    [anon_sym_Prop] = ACTIONS(690),
    [anon_sym_quote] = ACTIONS(690),
    [anon_sym_quoteTerm] = ACTIONS(690),
    [anon_sym_quoteContext] = ACTIONS(690),
    [anon_sym_unquote] = ACTIONS(690),
    [anon_sym_LPAREN_PIPE] = ACTIONS(718),
    [anon_sym_u2987] = ACTIONS(720),
    [anon_sym_let] = ACTIONS(722),
    [anon_sym_do] = ACTIONS(724),
    [aux_sym_integer_token1] = ACTIONS(726),
    [aux_sym_string_token1] = ACTIONS(726),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(728),
    [sym_PropN] = ACTIONS(690),
  },
  [285] = {
    [sym__FORALL] = STATE(8495),
    [sym__ARROW] = STATE(2460),
    [sym__LAMBDA] = STATE(8064),
    [sym__ELLIPSIS] = STATE(5056),
    [sym_catchall_pragma] = STATE(3229),
    [sym__qid] = STATE(5217),
    [sym__binding_ids_and_absurds] = STATE(9967),
    [sym_attribute] = STATE(5830),
    [sym_attributes] = STATE(3459),
    [sym__expr_or_attr] = STATE(5056),
    [sym__application] = STATE(9572),
    [sym__expr2_without_let] = STATE(9572),
    [sym__expr2] = STATE(9572),
    [sym_atom] = STATE(5128),
    [aux_sym__atoms] = STATE(3561),
    [sym__atom_curly] = STATE(5069),
    [sym__atom_no_curly] = STATE(5069),
    [sym_forall] = STATE(9572),
    [sym_let] = STATE(9572),
    [sym_lambda] = STATE(9572),
    [sym_lambda_extended_or_absurd] = STATE(9572),
    [sym__lambda_clauses] = STATE(11554),
    [sym__lambda_clause_maybe_absurd] = STATE(8986),
    [sym_lambda_clause_absurd] = STATE(8986),
    [sym_lambda_clause] = STATE(8986),
    [sym_do] = STATE(9572),
    [sym_record_assignments] = STATE(5056),
    [sym_field_assignments] = STATE(5056),
    [sym_literal] = STATE(5056),
    [sym_SetN] = STATE(5056),
    [aux_sym__modal_arg_ids_repeat1] = STATE(5830),
    [aux_sym__lambda_clauses_repeat1] = STATE(2812),
    [sym_id] = ACTIONS(680),
    [anon_sym_forall] = ACTIONS(682),
    [anon_sym_u2200] = ACTIONS(682),
    [anon_sym_DASH_GT] = ACTIONS(684),
    [anon_sym_u2192] = ACTIONS(684),
    [anon_sym_BSLASH] = ACTIONS(686),
    [anon_sym_u03bb] = ACTIONS(688),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(690),
    [anon_sym_u2026] = ACTIONS(690),
    [anon_sym_record] = ACTIONS(692),
    [anon_sym_LPAREN] = ACTIONS(694),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(696),
    [anon_sym_u2983] = ACTIONS(698),
    [anon_sym__] = ACTIONS(690),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE_DASH_POUND] = ACTIONS(700),
    [anon_sym_LBRACE] = ACTIONS(702),
    [anon_sym_RBRACE] = ACTIONS(732),
    [aux_sym__qid_token1] = ACTIONS(706),
    [anon_sym_DOT] = ACTIONS(708),
    [anon_sym_DASH] = ACTIONS(710),
    [anon_sym_AT] = ACTIONS(712),
    [anon_sym_quoteGoal] = ACTIONS(714),
    [anon_sym_tactic] = ACTIONS(716),
    [anon_sym_Prop] = ACTIONS(690),
    [anon_sym_quote] = ACTIONS(690),
    [anon_sym_quoteTerm] = ACTIONS(690),
    [anon_sym_quoteContext] = ACTIONS(690),
    [anon_sym_unquote] = ACTIONS(690),
    [anon_sym_LPAREN_PIPE] = ACTIONS(718),
    [anon_sym_u2987] = ACTIONS(720),
    [anon_sym_let] = ACTIONS(722),
    [anon_sym_do] = ACTIONS(724),
    [aux_sym_integer_token1] = ACTIONS(726),
    [aux_sym_string_token1] = ACTIONS(726),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(728),
    [sym_PropN] = ACTIONS(690),
  },
  [286] = {
    [sym__FORALL] = STATE(8495),
    [sym__ARROW] = STATE(2460),
    [sym__LAMBDA] = STATE(8064),
    [sym__ELLIPSIS] = STATE(5056),
    [sym_catchall_pragma] = STATE(3229),
    [sym__qid] = STATE(5217),
    [sym__binding_ids_and_absurds] = STATE(9740),
    [sym_attribute] = STATE(5830),
    [sym_attributes] = STATE(3534),
    [sym__expr_or_attr] = STATE(5056),
    [sym__application] = STATE(9572),
    [sym__expr2_without_let] = STATE(9572),
    [sym__expr2] = STATE(9572),
    [sym_atom] = STATE(5128),
    [aux_sym__atoms] = STATE(3561),
    [sym__atom_curly] = STATE(5069),
    [sym__atom_no_curly] = STATE(5069),
    [sym_forall] = STATE(9572),
    [sym_let] = STATE(9572),
    [sym_lambda] = STATE(9572),
    [sym_lambda_extended_or_absurd] = STATE(9572),
    [sym__lambda_clauses] = STATE(11554),
    [sym__lambda_clause_maybe_absurd] = STATE(8986),
    [sym_lambda_clause_absurd] = STATE(8986),
    [sym_lambda_clause] = STATE(8986),
    [sym_do] = STATE(9572),
    [sym_record_assignments] = STATE(5056),
    [sym_field_assignments] = STATE(5056),
    [sym_literal] = STATE(5056),
    [sym_SetN] = STATE(5056),
    [aux_sym__modal_arg_ids_repeat1] = STATE(5830),
    [aux_sym__lambda_clauses_repeat1] = STATE(2812),
    [sym_id] = ACTIONS(680),
    [anon_sym_forall] = ACTIONS(682),
    [anon_sym_u2200] = ACTIONS(682),
    [anon_sym_DASH_GT] = ACTIONS(684),
    [anon_sym_u2192] = ACTIONS(684),
    [anon_sym_BSLASH] = ACTIONS(686),
    [anon_sym_u03bb] = ACTIONS(688),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(690),
    [anon_sym_u2026] = ACTIONS(690),
    [anon_sym_record] = ACTIONS(692),
    [anon_sym_LPAREN] = ACTIONS(694),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(696),
    [anon_sym_u2983] = ACTIONS(698),
    [anon_sym__] = ACTIONS(690),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE_DASH_POUND] = ACTIONS(700),
    [anon_sym_LBRACE] = ACTIONS(702),
    [anon_sym_RBRACE] = ACTIONS(732),
    [aux_sym__qid_token1] = ACTIONS(706),
    [anon_sym_DOT] = ACTIONS(708),
    [anon_sym_DASH] = ACTIONS(710),
    [anon_sym_AT] = ACTIONS(712),
    [anon_sym_quoteGoal] = ACTIONS(714),
    [anon_sym_tactic] = ACTIONS(716),
    [anon_sym_Prop] = ACTIONS(690),
    [anon_sym_quote] = ACTIONS(690),
    [anon_sym_quoteTerm] = ACTIONS(690),
    [anon_sym_quoteContext] = ACTIONS(690),
    [anon_sym_unquote] = ACTIONS(690),
    [anon_sym_LPAREN_PIPE] = ACTIONS(718),
    [anon_sym_u2987] = ACTIONS(720),
    [anon_sym_let] = ACTIONS(722),
    [anon_sym_do] = ACTIONS(724),
    [aux_sym_integer_token1] = ACTIONS(726),
    [aux_sym_string_token1] = ACTIONS(726),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(728),
    [sym_PropN] = ACTIONS(690),
  },
  [287] = {
    [sym__FORALL] = STATE(8495),
    [sym__ARROW] = STATE(2460),
    [sym__LAMBDA] = STATE(8064),
    [sym__ELLIPSIS] = STATE(5056),
    [sym_catchall_pragma] = STATE(3229),
    [sym__qid] = STATE(5217),
    [sym__binding_ids_and_absurds] = STATE(9829),
    [sym_attribute] = STATE(5830),
    [sym_attributes] = STATE(3585),
    [sym__expr_or_attr] = STATE(5056),
    [sym__application] = STATE(9572),
    [sym__expr2_without_let] = STATE(9572),
    [sym__expr2] = STATE(9572),
    [sym_atom] = STATE(5128),
    [aux_sym__atoms] = STATE(3561),
    [sym__atom_curly] = STATE(5069),
    [sym__atom_no_curly] = STATE(5069),
    [sym_forall] = STATE(9572),
    [sym_let] = STATE(9572),
    [sym_lambda] = STATE(9572),
    [sym_lambda_extended_or_absurd] = STATE(9572),
    [sym__lambda_clauses] = STATE(12467),
    [sym__lambda_clause_maybe_absurd] = STATE(8986),
    [sym_lambda_clause_absurd] = STATE(8986),
    [sym_lambda_clause] = STATE(8986),
    [sym_do] = STATE(9572),
    [sym_record_assignments] = STATE(5056),
    [sym_field_assignments] = STATE(5056),
    [sym_literal] = STATE(5056),
    [sym_SetN] = STATE(5056),
    [aux_sym__modal_arg_ids_repeat1] = STATE(5830),
    [aux_sym__lambda_clauses_repeat1] = STATE(2812),
    [sym_id] = ACTIONS(680),
    [anon_sym_forall] = ACTIONS(682),
    [anon_sym_u2200] = ACTIONS(682),
    [anon_sym_DASH_GT] = ACTIONS(684),
    [anon_sym_u2192] = ACTIONS(684),
    [anon_sym_BSLASH] = ACTIONS(686),
    [anon_sym_u03bb] = ACTIONS(688),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(690),
    [anon_sym_u2026] = ACTIONS(690),
    [anon_sym_record] = ACTIONS(692),
    [anon_sym_LPAREN] = ACTIONS(694),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(696),
    [anon_sym_u2983] = ACTIONS(698),
    [anon_sym__] = ACTIONS(690),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE_DASH_POUND] = ACTIONS(700),
    [anon_sym_LBRACE] = ACTIONS(702),
    [anon_sym_RBRACE] = ACTIONS(704),
    [aux_sym__qid_token1] = ACTIONS(706),
    [anon_sym_DOT] = ACTIONS(708),
    [anon_sym_DASH] = ACTIONS(710),
    [anon_sym_AT] = ACTIONS(712),
    [anon_sym_quoteGoal] = ACTIONS(714),
    [anon_sym_tactic] = ACTIONS(716),
    [anon_sym_Prop] = ACTIONS(690),
    [anon_sym_quote] = ACTIONS(690),
    [anon_sym_quoteTerm] = ACTIONS(690),
    [anon_sym_quoteContext] = ACTIONS(690),
    [anon_sym_unquote] = ACTIONS(690),
    [anon_sym_LPAREN_PIPE] = ACTIONS(718),
    [anon_sym_u2987] = ACTIONS(720),
    [anon_sym_let] = ACTIONS(722),
    [anon_sym_do] = ACTIONS(724),
    [aux_sym_integer_token1] = ACTIONS(726),
    [aux_sym_string_token1] = ACTIONS(726),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(728),
    [sym_PropN] = ACTIONS(690),
  },
  [288] = {
    [sym__FORALL] = STATE(8456),
    [sym__LAMBDA] = STATE(8156),
    [sym__ELLIPSIS] = STATE(5102),
    [sym__qid] = STATE(5102),
    [sym_attribute] = STATE(7725),
    [sym_attributes] = STATE(6224),
    [sym_stmt] = STATE(9623),
    [sym__with_exprs] = STATE(12508),
    [sym__with_exprs_stmt] = STATE(9812),
    [sym__expr_or_attr] = STATE(5102),
    [sym__application] = STATE(8964),
    [sym__application_stmt] = STATE(9812),
    [sym__expr2_without_let] = STATE(9605),
    [sym__expr2] = STATE(8964),
    [sym__expr2_stmt] = STATE(9812),
    [sym_atom] = STATE(5147),
    [aux_sym__atoms] = STATE(3121),
    [sym__atom_curly] = STATE(5108),
    [sym__atom_no_curly] = STATE(5108),
    [sym_forall] = STATE(9605),
    [sym_let] = STATE(8964),
    [sym_let_in_do] = STATE(9812),
    [sym_lambda] = STATE(9605),
    [sym_lambda_extended_or_absurd] = STATE(9605),
    [sym_do] = STATE(9605),
    [sym__do_stmt] = STATE(12501),
    [sym_record_assignments] = STATE(5102),
    [sym_field_assignments] = STATE(5102),
    [aux_sym__typed_bindings] = STATE(8671),
    [sym_typed_binding] = STATE(8671),
    [sym_literal] = STATE(5102),
    [sym_SetN] = STATE(5102),
    [aux_sym__modal_arg_ids_repeat1] = STATE(7725),
    [aux_sym__with_exprs_repeat1] = STATE(3124),
    [aux_sym_do_repeat1] = STATE(267),
    [sym_id] = ACTIONS(734),
    [anon_sym_forall] = ACTIONS(736),
    [anon_sym_u2200] = ACTIONS(736),
    [anon_sym_BSLASH] = ACTIONS(738),
    [anon_sym_u03bb] = ACTIONS(740),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(742),
    [anon_sym_u2026] = ACTIONS(742),
    [anon_sym_record] = ACTIONS(744),
    [anon_sym_LPAREN] = ACTIONS(746),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(748),
    [anon_sym_u2983] = ACTIONS(750),
    [anon_sym__] = ACTIONS(742),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(752),
    [aux_sym__qid_token1] = ACTIONS(754),
    [anon_sym_DOT] = ACTIONS(756),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_AT] = ACTIONS(760),
    [anon_sym_quoteGoal] = ACTIONS(762),
    [anon_sym_tactic] = ACTIONS(764),
    [anon_sym_Prop] = ACTIONS(742),
    [anon_sym_quote] = ACTIONS(742),
    [anon_sym_quoteTerm] = ACTIONS(742),
    [anon_sym_quoteContext] = ACTIONS(742),
    [anon_sym_unquote] = ACTIONS(742),
    [anon_sym_LPAREN_PIPE] = ACTIONS(766),
    [anon_sym_u2987] = ACTIONS(768),
    [anon_sym_let] = ACTIONS(770),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(772),
    [aux_sym_string_token1] = ACTIONS(772),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(774),
    [sym_PropN] = ACTIONS(742),
    [sym__dedent] = ACTIONS(846),
  },
  [289] = {
    [sym__FORALL] = STATE(8495),
    [sym__ARROW] = STATE(2460),
    [sym__LAMBDA] = STATE(8064),
    [sym__ELLIPSIS] = STATE(5056),
    [sym_catchall_pragma] = STATE(3229),
    [sym__qid] = STATE(5217),
    [sym__binding_ids_and_absurds] = STATE(10057),
    [sym_attribute] = STATE(5830),
    [sym_attributes] = STATE(3358),
    [sym__expr_or_attr] = STATE(5056),
    [sym__application] = STATE(9572),
    [sym__expr2_without_let] = STATE(9572),
    [sym__expr2] = STATE(9572),
    [sym_atom] = STATE(5128),
    [aux_sym__atoms] = STATE(3561),
    [sym__atom_curly] = STATE(5069),
    [sym__atom_no_curly] = STATE(5069),
    [sym_forall] = STATE(9572),
    [sym_let] = STATE(9572),
    [sym_lambda] = STATE(9572),
    [sym_lambda_extended_or_absurd] = STATE(9572),
    [sym__lambda_clauses] = STATE(11554),
    [sym__lambda_clause_maybe_absurd] = STATE(8986),
    [sym_lambda_clause_absurd] = STATE(8986),
    [sym_lambda_clause] = STATE(8986),
    [sym_do] = STATE(9572),
    [sym_record_assignments] = STATE(5056),
    [sym_field_assignments] = STATE(5056),
    [sym_literal] = STATE(5056),
    [sym_SetN] = STATE(5056),
    [aux_sym__modal_arg_ids_repeat1] = STATE(5830),
    [aux_sym__lambda_clauses_repeat1] = STATE(2812),
    [sym_id] = ACTIONS(680),
    [anon_sym_forall] = ACTIONS(682),
    [anon_sym_u2200] = ACTIONS(682),
    [anon_sym_DASH_GT] = ACTIONS(684),
    [anon_sym_u2192] = ACTIONS(684),
    [anon_sym_BSLASH] = ACTIONS(686),
    [anon_sym_u03bb] = ACTIONS(688),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(690),
    [anon_sym_u2026] = ACTIONS(690),
    [anon_sym_record] = ACTIONS(692),
    [anon_sym_LPAREN] = ACTIONS(694),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(696),
    [anon_sym_u2983] = ACTIONS(698),
    [anon_sym__] = ACTIONS(690),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE_DASH_POUND] = ACTIONS(700),
    [anon_sym_LBRACE] = ACTIONS(702),
    [anon_sym_RBRACE] = ACTIONS(732),
    [aux_sym__qid_token1] = ACTIONS(706),
    [anon_sym_DOT] = ACTIONS(708),
    [anon_sym_DASH] = ACTIONS(710),
    [anon_sym_AT] = ACTIONS(712),
    [anon_sym_quoteGoal] = ACTIONS(714),
    [anon_sym_tactic] = ACTIONS(716),
    [anon_sym_Prop] = ACTIONS(690),
    [anon_sym_quote] = ACTIONS(690),
    [anon_sym_quoteTerm] = ACTIONS(690),
    [anon_sym_quoteContext] = ACTIONS(690),
    [anon_sym_unquote] = ACTIONS(690),
    [anon_sym_LPAREN_PIPE] = ACTIONS(718),
    [anon_sym_u2987] = ACTIONS(720),
    [anon_sym_let] = ACTIONS(722),
    [anon_sym_do] = ACTIONS(724),
    [aux_sym_integer_token1] = ACTIONS(726),
    [aux_sym_string_token1] = ACTIONS(726),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(728),
    [sym_PropN] = ACTIONS(690),
  },
  [290] = {
    [sym__FORALL] = STATE(8495),
    [sym__ARROW] = STATE(2460),
    [sym__LAMBDA] = STATE(8064),
    [sym__ELLIPSIS] = STATE(5056),
    [sym_catchall_pragma] = STATE(3229),
    [sym__qid] = STATE(5217),
    [sym__binding_ids_and_absurds] = STATE(10079),
    [sym_attribute] = STATE(5830),
    [sym_attributes] = STATE(3597),
    [sym__expr_or_attr] = STATE(5056),
    [sym__application] = STATE(9572),
    [sym__expr2_without_let] = STATE(9572),
    [sym__expr2] = STATE(9572),
    [sym_atom] = STATE(5128),
    [aux_sym__atoms] = STATE(3561),
    [sym__atom_curly] = STATE(5069),
    [sym__atom_no_curly] = STATE(5069),
    [sym_forall] = STATE(9572),
    [sym_let] = STATE(9572),
    [sym_lambda] = STATE(9572),
    [sym_lambda_extended_or_absurd] = STATE(9572),
    [sym__lambda_clauses] = STATE(12467),
    [sym__lambda_clause_maybe_absurd] = STATE(8986),
    [sym_lambda_clause_absurd] = STATE(8986),
    [sym_lambda_clause] = STATE(8986),
    [sym_do] = STATE(9572),
    [sym_record_assignments] = STATE(5056),
    [sym_field_assignments] = STATE(5056),
    [sym_literal] = STATE(5056),
    [sym_SetN] = STATE(5056),
    [aux_sym__modal_arg_ids_repeat1] = STATE(5830),
    [aux_sym__lambda_clauses_repeat1] = STATE(2812),
    [sym_id] = ACTIONS(680),
    [anon_sym_forall] = ACTIONS(682),
    [anon_sym_u2200] = ACTIONS(682),
    [anon_sym_DASH_GT] = ACTIONS(684),
    [anon_sym_u2192] = ACTIONS(684),
    [anon_sym_BSLASH] = ACTIONS(686),
    [anon_sym_u03bb] = ACTIONS(688),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(690),
    [anon_sym_u2026] = ACTIONS(690),
    [anon_sym_record] = ACTIONS(692),
    [anon_sym_LPAREN] = ACTIONS(694),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(696),
    [anon_sym_u2983] = ACTIONS(698),
    [anon_sym__] = ACTIONS(690),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE_DASH_POUND] = ACTIONS(700),
    [anon_sym_LBRACE] = ACTIONS(702),
    [anon_sym_RBRACE] = ACTIONS(704),
    [aux_sym__qid_token1] = ACTIONS(706),
    [anon_sym_DOT] = ACTIONS(708),
    [anon_sym_DASH] = ACTIONS(710),
    [anon_sym_AT] = ACTIONS(712),
    [anon_sym_quoteGoal] = ACTIONS(714),
    [anon_sym_tactic] = ACTIONS(716),
    [anon_sym_Prop] = ACTIONS(690),
    [anon_sym_quote] = ACTIONS(690),
    [anon_sym_quoteTerm] = ACTIONS(690),
    [anon_sym_quoteContext] = ACTIONS(690),
    [anon_sym_unquote] = ACTIONS(690),
    [anon_sym_LPAREN_PIPE] = ACTIONS(718),
    [anon_sym_u2987] = ACTIONS(720),
    [anon_sym_let] = ACTIONS(722),
    [anon_sym_do] = ACTIONS(724),
    [aux_sym_integer_token1] = ACTIONS(726),
    [aux_sym_string_token1] = ACTIONS(726),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(728),
    [sym_PropN] = ACTIONS(690),
  },
  [291] = {
    [sym__FORALL] = STATE(8495),
    [sym__ARROW] = STATE(2460),
    [sym__LAMBDA] = STATE(8064),
    [sym__ELLIPSIS] = STATE(5056),
    [sym_catchall_pragma] = STATE(3229),
    [sym__qid] = STATE(5217),
    [sym__binding_ids_and_absurds] = STATE(9719),
    [sym_attribute] = STATE(5830),
    [sym_attributes] = STATE(3643),
    [sym__expr_or_attr] = STATE(5056),
    [sym__application] = STATE(9572),
    [sym__expr2_without_let] = STATE(9572),
    [sym__expr2] = STATE(9572),
    [sym_atom] = STATE(5128),
    [aux_sym__atoms] = STATE(3561),
    [sym__atom_curly] = STATE(5069),
    [sym__atom_no_curly] = STATE(5069),
    [sym_forall] = STATE(9572),
    [sym_let] = STATE(9572),
    [sym_lambda] = STATE(9572),
    [sym_lambda_extended_or_absurd] = STATE(9572),
    [sym__lambda_clauses] = STATE(11554),
    [sym__lambda_clause_maybe_absurd] = STATE(8986),
    [sym_lambda_clause_absurd] = STATE(8986),
    [sym_lambda_clause] = STATE(8986),
    [sym_do] = STATE(9572),
    [sym_record_assignments] = STATE(5056),
    [sym_field_assignments] = STATE(5056),
    [sym_literal] = STATE(5056),
    [sym_SetN] = STATE(5056),
    [aux_sym__modal_arg_ids_repeat1] = STATE(5830),
    [aux_sym__lambda_clauses_repeat1] = STATE(2812),
    [sym_id] = ACTIONS(680),
    [anon_sym_forall] = ACTIONS(682),
    [anon_sym_u2200] = ACTIONS(682),
    [anon_sym_DASH_GT] = ACTIONS(684),
    [anon_sym_u2192] = ACTIONS(684),
    [anon_sym_BSLASH] = ACTIONS(686),
    [anon_sym_u03bb] = ACTIONS(688),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(690),
    [anon_sym_u2026] = ACTIONS(690),
    [anon_sym_record] = ACTIONS(692),
    [anon_sym_LPAREN] = ACTIONS(694),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(696),
    [anon_sym_u2983] = ACTIONS(698),
    [anon_sym__] = ACTIONS(690),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE_DASH_POUND] = ACTIONS(700),
    [anon_sym_LBRACE] = ACTIONS(702),
    [anon_sym_RBRACE] = ACTIONS(732),
    [aux_sym__qid_token1] = ACTIONS(706),
    [anon_sym_DOT] = ACTIONS(708),
    [anon_sym_DASH] = ACTIONS(710),
    [anon_sym_AT] = ACTIONS(712),
    [anon_sym_quoteGoal] = ACTIONS(714),
    [anon_sym_tactic] = ACTIONS(716),
    [anon_sym_Prop] = ACTIONS(690),
    [anon_sym_quote] = ACTIONS(690),
    [anon_sym_quoteTerm] = ACTIONS(690),
    [anon_sym_quoteContext] = ACTIONS(690),
    [anon_sym_unquote] = ACTIONS(690),
    [anon_sym_LPAREN_PIPE] = ACTIONS(718),
    [anon_sym_u2987] = ACTIONS(720),
    [anon_sym_let] = ACTIONS(722),
    [anon_sym_do] = ACTIONS(724),
    [aux_sym_integer_token1] = ACTIONS(726),
    [aux_sym_string_token1] = ACTIONS(726),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(728),
    [sym_PropN] = ACTIONS(690),
  },
  [292] = {
    [sym__FORALL] = STATE(8495),
    [sym__ARROW] = STATE(2460),
    [sym__LAMBDA] = STATE(8064),
    [sym__ELLIPSIS] = STATE(5056),
    [sym_catchall_pragma] = STATE(3229),
    [sym__qid] = STATE(5217),
    [sym__binding_ids_and_absurds] = STATE(9786),
    [sym_attribute] = STATE(5830),
    [sym_attributes] = STATE(3556),
    [sym__expr_or_attr] = STATE(5056),
    [sym__application] = STATE(9572),
    [sym__expr2_without_let] = STATE(9572),
    [sym__expr2] = STATE(9572),
    [sym_atom] = STATE(5128),
    [aux_sym__atoms] = STATE(3561),
    [sym__atom_curly] = STATE(5069),
    [sym__atom_no_curly] = STATE(5069),
    [sym_forall] = STATE(9572),
    [sym_let] = STATE(9572),
    [sym_lambda] = STATE(9572),
    [sym_lambda_extended_or_absurd] = STATE(9572),
    [sym__lambda_clauses] = STATE(12467),
    [sym__lambda_clause_maybe_absurd] = STATE(8986),
    [sym_lambda_clause_absurd] = STATE(8986),
    [sym_lambda_clause] = STATE(8986),
    [sym_do] = STATE(9572),
    [sym_record_assignments] = STATE(5056),
    [sym_field_assignments] = STATE(5056),
    [sym_literal] = STATE(5056),
    [sym_SetN] = STATE(5056),
    [aux_sym__modal_arg_ids_repeat1] = STATE(5830),
    [aux_sym__lambda_clauses_repeat1] = STATE(2812),
    [sym_id] = ACTIONS(680),
    [anon_sym_forall] = ACTIONS(682),
    [anon_sym_u2200] = ACTIONS(682),
    [anon_sym_DASH_GT] = ACTIONS(684),
    [anon_sym_u2192] = ACTIONS(684),
    [anon_sym_BSLASH] = ACTIONS(686),
    [anon_sym_u03bb] = ACTIONS(688),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(690),
    [anon_sym_u2026] = ACTIONS(690),
    [anon_sym_record] = ACTIONS(692),
    [anon_sym_LPAREN] = ACTIONS(694),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(696),
    [anon_sym_u2983] = ACTIONS(698),
    [anon_sym__] = ACTIONS(690),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE_DASH_POUND] = ACTIONS(700),
    [anon_sym_LBRACE] = ACTIONS(702),
    [anon_sym_RBRACE] = ACTIONS(704),
    [aux_sym__qid_token1] = ACTIONS(706),
    [anon_sym_DOT] = ACTIONS(708),
    [anon_sym_DASH] = ACTIONS(710),
    [anon_sym_AT] = ACTIONS(712),
    [anon_sym_quoteGoal] = ACTIONS(714),
    [anon_sym_tactic] = ACTIONS(716),
    [anon_sym_Prop] = ACTIONS(690),
    [anon_sym_quote] = ACTIONS(690),
    [anon_sym_quoteTerm] = ACTIONS(690),
    [anon_sym_quoteContext] = ACTIONS(690),
    [anon_sym_unquote] = ACTIONS(690),
    [anon_sym_LPAREN_PIPE] = ACTIONS(718),
    [anon_sym_u2987] = ACTIONS(720),
    [anon_sym_let] = ACTIONS(722),
    [anon_sym_do] = ACTIONS(724),
    [aux_sym_integer_token1] = ACTIONS(726),
    [aux_sym_string_token1] = ACTIONS(726),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(728),
    [sym_PropN] = ACTIONS(690),
  },
  [293] = {
    [sym__FORALL] = STATE(8495),
    [sym__ARROW] = STATE(2460),
    [sym__LAMBDA] = STATE(8064),
    [sym__ELLIPSIS] = STATE(5056),
    [sym_catchall_pragma] = STATE(3229),
    [sym__qid] = STATE(5217),
    [sym__binding_ids_and_absurds] = STATE(9882),
    [sym_attribute] = STATE(5830),
    [sym_attributes] = STATE(3638),
    [sym__expr_or_attr] = STATE(5056),
    [sym__application] = STATE(9572),
    [sym__expr2_without_let] = STATE(9572),
    [sym__expr2] = STATE(9572),
    [sym_atom] = STATE(5128),
    [aux_sym__atoms] = STATE(3561),
    [sym__atom_curly] = STATE(5069),
    [sym__atom_no_curly] = STATE(5069),
    [sym_forall] = STATE(9572),
    [sym_let] = STATE(9572),
    [sym_lambda] = STATE(9572),
    [sym_lambda_extended_or_absurd] = STATE(9572),
    [sym__lambda_clauses] = STATE(12467),
    [sym__lambda_clause_maybe_absurd] = STATE(8986),
    [sym_lambda_clause_absurd] = STATE(8986),
    [sym_lambda_clause] = STATE(8986),
    [sym_do] = STATE(9572),
    [sym_record_assignments] = STATE(5056),
    [sym_field_assignments] = STATE(5056),
    [sym_literal] = STATE(5056),
    [sym_SetN] = STATE(5056),
    [aux_sym__modal_arg_ids_repeat1] = STATE(5830),
    [aux_sym__lambda_clauses_repeat1] = STATE(2812),
    [sym_id] = ACTIONS(680),
    [anon_sym_forall] = ACTIONS(682),
    [anon_sym_u2200] = ACTIONS(682),
    [anon_sym_DASH_GT] = ACTIONS(684),
    [anon_sym_u2192] = ACTIONS(684),
    [anon_sym_BSLASH] = ACTIONS(686),
    [anon_sym_u03bb] = ACTIONS(688),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(690),
    [anon_sym_u2026] = ACTIONS(690),
    [anon_sym_record] = ACTIONS(692),
    [anon_sym_LPAREN] = ACTIONS(694),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(696),
    [anon_sym_u2983] = ACTIONS(698),
    [anon_sym__] = ACTIONS(690),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE_DASH_POUND] = ACTIONS(700),
    [anon_sym_LBRACE] = ACTIONS(702),
    [anon_sym_RBRACE] = ACTIONS(704),
    [aux_sym__qid_token1] = ACTIONS(706),
    [anon_sym_DOT] = ACTIONS(708),
    [anon_sym_DASH] = ACTIONS(710),
    [anon_sym_AT] = ACTIONS(712),
    [anon_sym_quoteGoal] = ACTIONS(714),
    [anon_sym_tactic] = ACTIONS(716),
    [anon_sym_Prop] = ACTIONS(690),
    [anon_sym_quote] = ACTIONS(690),
    [anon_sym_quoteTerm] = ACTIONS(690),
    [anon_sym_quoteContext] = ACTIONS(690),
    [anon_sym_unquote] = ACTIONS(690),
    [anon_sym_LPAREN_PIPE] = ACTIONS(718),
    [anon_sym_u2987] = ACTIONS(720),
    [anon_sym_let] = ACTIONS(722),
    [anon_sym_do] = ACTIONS(724),
    [aux_sym_integer_token1] = ACTIONS(726),
    [aux_sym_string_token1] = ACTIONS(726),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(728),
    [sym_PropN] = ACTIONS(690),
  },
  [294] = {
    [sym__FORALL] = STATE(8495),
    [sym__ARROW] = STATE(2460),
    [sym__LAMBDA] = STATE(8064),
    [sym__ELLIPSIS] = STATE(5056),
    [sym_catchall_pragma] = STATE(3229),
    [sym__qid] = STATE(5217),
    [sym__binding_ids_and_absurds] = STATE(10147),
    [sym_attribute] = STATE(5830),
    [sym_attributes] = STATE(3564),
    [sym__expr_or_attr] = STATE(5056),
    [sym__application] = STATE(9572),
    [sym__expr2_without_let] = STATE(9572),
    [sym__expr2] = STATE(9572),
    [sym_atom] = STATE(5128),
    [aux_sym__atoms] = STATE(3561),
    [sym__atom_curly] = STATE(5069),
    [sym__atom_no_curly] = STATE(5069),
    [sym_forall] = STATE(9572),
    [sym_let] = STATE(9572),
    [sym_lambda] = STATE(9572),
    [sym_lambda_extended_or_absurd] = STATE(9572),
    [sym__lambda_clauses] = STATE(11554),
    [sym__lambda_clause_maybe_absurd] = STATE(8986),
    [sym_lambda_clause_absurd] = STATE(8986),
    [sym_lambda_clause] = STATE(8986),
    [sym_do] = STATE(9572),
    [sym_record_assignments] = STATE(5056),
    [sym_field_assignments] = STATE(5056),
    [sym_literal] = STATE(5056),
    [sym_SetN] = STATE(5056),
    [aux_sym__modal_arg_ids_repeat1] = STATE(5830),
    [aux_sym__lambda_clauses_repeat1] = STATE(2812),
    [sym_id] = ACTIONS(680),
    [anon_sym_forall] = ACTIONS(682),
    [anon_sym_u2200] = ACTIONS(682),
    [anon_sym_DASH_GT] = ACTIONS(684),
    [anon_sym_u2192] = ACTIONS(684),
    [anon_sym_BSLASH] = ACTIONS(686),
    [anon_sym_u03bb] = ACTIONS(688),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(690),
    [anon_sym_u2026] = ACTIONS(690),
    [anon_sym_record] = ACTIONS(692),
    [anon_sym_LPAREN] = ACTIONS(694),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(696),
    [anon_sym_u2983] = ACTIONS(698),
    [anon_sym__] = ACTIONS(690),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE_DASH_POUND] = ACTIONS(700),
    [anon_sym_LBRACE] = ACTIONS(702),
    [anon_sym_RBRACE] = ACTIONS(732),
    [aux_sym__qid_token1] = ACTIONS(706),
    [anon_sym_DOT] = ACTIONS(708),
    [anon_sym_DASH] = ACTIONS(710),
    [anon_sym_AT] = ACTIONS(712),
    [anon_sym_quoteGoal] = ACTIONS(714),
    [anon_sym_tactic] = ACTIONS(716),
    [anon_sym_Prop] = ACTIONS(690),
    [anon_sym_quote] = ACTIONS(690),
    [anon_sym_quoteTerm] = ACTIONS(690),
    [anon_sym_quoteContext] = ACTIONS(690),
    [anon_sym_unquote] = ACTIONS(690),
    [anon_sym_LPAREN_PIPE] = ACTIONS(718),
    [anon_sym_u2987] = ACTIONS(720),
    [anon_sym_let] = ACTIONS(722),
    [anon_sym_do] = ACTIONS(724),
    [aux_sym_integer_token1] = ACTIONS(726),
    [aux_sym_string_token1] = ACTIONS(726),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(728),
    [sym_PropN] = ACTIONS(690),
  },
  [295] = {
    [sym__FORALL] = STATE(8495),
    [sym__ARROW] = STATE(2460),
    [sym__LAMBDA] = STATE(8064),
    [sym__ELLIPSIS] = STATE(5056),
    [sym_catchall_pragma] = STATE(3229),
    [sym__qid] = STATE(5217),
    [sym__binding_ids_and_absurds] = STATE(10185),
    [sym_attribute] = STATE(5830),
    [sym_attributes] = STATE(3489),
    [sym__expr_or_attr] = STATE(5056),
    [sym__application] = STATE(9572),
    [sym__expr2_without_let] = STATE(9572),
    [sym__expr2] = STATE(9572),
    [sym_atom] = STATE(5128),
    [aux_sym__atoms] = STATE(3561),
    [sym__atom_curly] = STATE(5069),
    [sym__atom_no_curly] = STATE(5069),
    [sym_forall] = STATE(9572),
    [sym_let] = STATE(9572),
    [sym_lambda] = STATE(9572),
    [sym_lambda_extended_or_absurd] = STATE(9572),
    [sym__lambda_clauses] = STATE(11497),
    [sym__lambda_clause_maybe_absurd] = STATE(8986),
    [sym_lambda_clause_absurd] = STATE(8986),
    [sym_lambda_clause] = STATE(8986),
    [sym_do] = STATE(9572),
    [sym_record_assignments] = STATE(5056),
    [sym_field_assignments] = STATE(5056),
    [sym_literal] = STATE(5056),
    [sym_SetN] = STATE(5056),
    [aux_sym__modal_arg_ids_repeat1] = STATE(5830),
    [aux_sym__lambda_clauses_repeat1] = STATE(2812),
    [sym_id] = ACTIONS(680),
    [anon_sym_forall] = ACTIONS(682),
    [anon_sym_u2200] = ACTIONS(682),
    [anon_sym_DASH_GT] = ACTIONS(684),
    [anon_sym_u2192] = ACTIONS(684),
    [anon_sym_BSLASH] = ACTIONS(686),
    [anon_sym_u03bb] = ACTIONS(688),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(690),
    [anon_sym_u2026] = ACTIONS(690),
    [anon_sym_record] = ACTIONS(692),
    [anon_sym_LPAREN] = ACTIONS(694),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(696),
    [anon_sym_u2983] = ACTIONS(698),
    [anon_sym__] = ACTIONS(690),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE_DASH_POUND] = ACTIONS(700),
    [anon_sym_LBRACE] = ACTIONS(702),
    [anon_sym_RBRACE] = ACTIONS(730),
    [aux_sym__qid_token1] = ACTIONS(706),
    [anon_sym_DOT] = ACTIONS(708),
    [anon_sym_DASH] = ACTIONS(710),
    [anon_sym_AT] = ACTIONS(712),
    [anon_sym_quoteGoal] = ACTIONS(714),
    [anon_sym_tactic] = ACTIONS(716),
    [anon_sym_Prop] = ACTIONS(690),
    [anon_sym_quote] = ACTIONS(690),
    [anon_sym_quoteTerm] = ACTIONS(690),
    [anon_sym_quoteContext] = ACTIONS(690),
    [anon_sym_unquote] = ACTIONS(690),
    [anon_sym_LPAREN_PIPE] = ACTIONS(718),
    [anon_sym_u2987] = ACTIONS(720),
    [anon_sym_let] = ACTIONS(722),
    [anon_sym_do] = ACTIONS(724),
    [aux_sym_integer_token1] = ACTIONS(726),
    [aux_sym_string_token1] = ACTIONS(726),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(728),
    [sym_PropN] = ACTIONS(690),
  },
  [296] = {
    [sym__FORALL] = STATE(8495),
    [sym__ARROW] = STATE(2460),
    [sym__LAMBDA] = STATE(8064),
    [sym__ELLIPSIS] = STATE(5056),
    [sym_catchall_pragma] = STATE(3229),
    [sym__qid] = STATE(5217),
    [sym__binding_ids_and_absurds] = STATE(9762),
    [sym_attribute] = STATE(5830),
    [sym_attributes] = STATE(3448),
    [sym__expr_or_attr] = STATE(5056),
    [sym__application] = STATE(9572),
    [sym__expr2_without_let] = STATE(9572),
    [sym__expr2] = STATE(9572),
    [sym_atom] = STATE(5128),
    [aux_sym__atoms] = STATE(3561),
    [sym__atom_curly] = STATE(5069),
    [sym__atom_no_curly] = STATE(5069),
    [sym_forall] = STATE(9572),
    [sym_let] = STATE(9572),
    [sym_lambda] = STATE(9572),
    [sym_lambda_extended_or_absurd] = STATE(9572),
    [sym__lambda_clauses] = STATE(11554),
    [sym__lambda_clause_maybe_absurd] = STATE(8986),
    [sym_lambda_clause_absurd] = STATE(8986),
    [sym_lambda_clause] = STATE(8986),
    [sym_do] = STATE(9572),
    [sym_record_assignments] = STATE(5056),
    [sym_field_assignments] = STATE(5056),
    [sym_literal] = STATE(5056),
    [sym_SetN] = STATE(5056),
    [aux_sym__modal_arg_ids_repeat1] = STATE(5830),
    [aux_sym__lambda_clauses_repeat1] = STATE(2812),
    [sym_id] = ACTIONS(680),
    [anon_sym_forall] = ACTIONS(682),
    [anon_sym_u2200] = ACTIONS(682),
    [anon_sym_DASH_GT] = ACTIONS(684),
    [anon_sym_u2192] = ACTIONS(684),
    [anon_sym_BSLASH] = ACTIONS(686),
    [anon_sym_u03bb] = ACTIONS(688),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(690),
    [anon_sym_u2026] = ACTIONS(690),
    [anon_sym_record] = ACTIONS(692),
    [anon_sym_LPAREN] = ACTIONS(694),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(696),
    [anon_sym_u2983] = ACTIONS(698),
    [anon_sym__] = ACTIONS(690),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE_DASH_POUND] = ACTIONS(700),
    [anon_sym_LBRACE] = ACTIONS(702),
    [anon_sym_RBRACE] = ACTIONS(732),
    [aux_sym__qid_token1] = ACTIONS(706),
    [anon_sym_DOT] = ACTIONS(708),
    [anon_sym_DASH] = ACTIONS(710),
    [anon_sym_AT] = ACTIONS(712),
    [anon_sym_quoteGoal] = ACTIONS(714),
    [anon_sym_tactic] = ACTIONS(716),
    [anon_sym_Prop] = ACTIONS(690),
    [anon_sym_quote] = ACTIONS(690),
    [anon_sym_quoteTerm] = ACTIONS(690),
    [anon_sym_quoteContext] = ACTIONS(690),
    [anon_sym_unquote] = ACTIONS(690),
    [anon_sym_LPAREN_PIPE] = ACTIONS(718),
    [anon_sym_u2987] = ACTIONS(720),
    [anon_sym_let] = ACTIONS(722),
    [anon_sym_do] = ACTIONS(724),
    [aux_sym_integer_token1] = ACTIONS(726),
    [aux_sym_string_token1] = ACTIONS(726),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(728),
    [sym_PropN] = ACTIONS(690),
  },
  [297] = {
    [sym__FORALL] = STATE(8495),
    [sym__ARROW] = STATE(2460),
    [sym__LAMBDA] = STATE(8064),
    [sym__ELLIPSIS] = STATE(5056),
    [sym_catchall_pragma] = STATE(3229),
    [sym__qid] = STATE(5217),
    [sym__binding_ids_and_absurds] = STATE(9919),
    [sym_attribute] = STATE(5830),
    [sym_attributes] = STATE(3607),
    [sym__expr_or_attr] = STATE(5056),
    [sym__application] = STATE(9572),
    [sym__expr2_without_let] = STATE(9572),
    [sym__expr2] = STATE(9572),
    [sym_atom] = STATE(5128),
    [aux_sym__atoms] = STATE(3561),
    [sym__atom_curly] = STATE(5069),
    [sym__atom_no_curly] = STATE(5069),
    [sym_forall] = STATE(9572),
    [sym_let] = STATE(9572),
    [sym_lambda] = STATE(9572),
    [sym_lambda_extended_or_absurd] = STATE(9572),
    [sym__lambda_clauses] = STATE(11497),
    [sym__lambda_clause_maybe_absurd] = STATE(8986),
    [sym_lambda_clause_absurd] = STATE(8986),
    [sym_lambda_clause] = STATE(8986),
    [sym_do] = STATE(9572),
    [sym_record_assignments] = STATE(5056),
    [sym_field_assignments] = STATE(5056),
    [sym_literal] = STATE(5056),
    [sym_SetN] = STATE(5056),
    [aux_sym__modal_arg_ids_repeat1] = STATE(5830),
    [aux_sym__lambda_clauses_repeat1] = STATE(2812),
    [sym_id] = ACTIONS(680),
    [anon_sym_forall] = ACTIONS(682),
    [anon_sym_u2200] = ACTIONS(682),
    [anon_sym_DASH_GT] = ACTIONS(684),
    [anon_sym_u2192] = ACTIONS(684),
    [anon_sym_BSLASH] = ACTIONS(686),
    [anon_sym_u03bb] = ACTIONS(688),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(690),
    [anon_sym_u2026] = ACTIONS(690),
    [anon_sym_record] = ACTIONS(692),
    [anon_sym_LPAREN] = ACTIONS(694),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(696),
    [anon_sym_u2983] = ACTIONS(698),
    [anon_sym__] = ACTIONS(690),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE_DASH_POUND] = ACTIONS(700),
    [anon_sym_LBRACE] = ACTIONS(702),
    [anon_sym_RBRACE] = ACTIONS(730),
    [aux_sym__qid_token1] = ACTIONS(706),
    [anon_sym_DOT] = ACTIONS(708),
    [anon_sym_DASH] = ACTIONS(710),
    [anon_sym_AT] = ACTIONS(712),
    [anon_sym_quoteGoal] = ACTIONS(714),
    [anon_sym_tactic] = ACTIONS(716),
    [anon_sym_Prop] = ACTIONS(690),
    [anon_sym_quote] = ACTIONS(690),
    [anon_sym_quoteTerm] = ACTIONS(690),
    [anon_sym_quoteContext] = ACTIONS(690),
    [anon_sym_unquote] = ACTIONS(690),
    [anon_sym_LPAREN_PIPE] = ACTIONS(718),
    [anon_sym_u2987] = ACTIONS(720),
    [anon_sym_let] = ACTIONS(722),
    [anon_sym_do] = ACTIONS(724),
    [aux_sym_integer_token1] = ACTIONS(726),
    [aux_sym_string_token1] = ACTIONS(726),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(728),
    [sym_PropN] = ACTIONS(690),
  },
  [298] = {
    [sym__FORALL] = STATE(8495),
    [sym__ARROW] = STATE(2460),
    [sym__LAMBDA] = STATE(8064),
    [sym__ELLIPSIS] = STATE(5056),
    [sym_catchall_pragma] = STATE(3229),
    [sym__qid] = STATE(5217),
    [sym__binding_ids_and_absurds] = STATE(9805),
    [sym_attribute] = STATE(5830),
    [sym_attributes] = STATE(3367),
    [sym__expr_or_attr] = STATE(5056),
    [sym__application] = STATE(9572),
    [sym__expr2_without_let] = STATE(9572),
    [sym__expr2] = STATE(9572),
    [sym_atom] = STATE(5128),
    [aux_sym__atoms] = STATE(3561),
    [sym__atom_curly] = STATE(5069),
    [sym__atom_no_curly] = STATE(5069),
    [sym_forall] = STATE(9572),
    [sym_let] = STATE(9572),
    [sym_lambda] = STATE(9572),
    [sym_lambda_extended_or_absurd] = STATE(9572),
    [sym__lambda_clauses] = STATE(11554),
    [sym__lambda_clause_maybe_absurd] = STATE(8986),
    [sym_lambda_clause_absurd] = STATE(8986),
    [sym_lambda_clause] = STATE(8986),
    [sym_do] = STATE(9572),
    [sym_record_assignments] = STATE(5056),
    [sym_field_assignments] = STATE(5056),
    [sym_literal] = STATE(5056),
    [sym_SetN] = STATE(5056),
    [aux_sym__modal_arg_ids_repeat1] = STATE(5830),
    [aux_sym__lambda_clauses_repeat1] = STATE(2812),
    [sym_id] = ACTIONS(680),
    [anon_sym_forall] = ACTIONS(682),
    [anon_sym_u2200] = ACTIONS(682),
    [anon_sym_DASH_GT] = ACTIONS(684),
    [anon_sym_u2192] = ACTIONS(684),
    [anon_sym_BSLASH] = ACTIONS(686),
    [anon_sym_u03bb] = ACTIONS(688),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(690),
    [anon_sym_u2026] = ACTIONS(690),
    [anon_sym_record] = ACTIONS(692),
    [anon_sym_LPAREN] = ACTIONS(694),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(696),
    [anon_sym_u2983] = ACTIONS(698),
    [anon_sym__] = ACTIONS(690),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE_DASH_POUND] = ACTIONS(700),
    [anon_sym_LBRACE] = ACTIONS(702),
    [anon_sym_RBRACE] = ACTIONS(732),
    [aux_sym__qid_token1] = ACTIONS(706),
    [anon_sym_DOT] = ACTIONS(708),
    [anon_sym_DASH] = ACTIONS(710),
    [anon_sym_AT] = ACTIONS(712),
    [anon_sym_quoteGoal] = ACTIONS(714),
    [anon_sym_tactic] = ACTIONS(716),
    [anon_sym_Prop] = ACTIONS(690),
    [anon_sym_quote] = ACTIONS(690),
    [anon_sym_quoteTerm] = ACTIONS(690),
    [anon_sym_quoteContext] = ACTIONS(690),
    [anon_sym_unquote] = ACTIONS(690),
    [anon_sym_LPAREN_PIPE] = ACTIONS(718),
    [anon_sym_u2987] = ACTIONS(720),
    [anon_sym_let] = ACTIONS(722),
    [anon_sym_do] = ACTIONS(724),
    [aux_sym_integer_token1] = ACTIONS(726),
    [aux_sym_string_token1] = ACTIONS(726),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(728),
    [sym_PropN] = ACTIONS(690),
  },
  [299] = {
    [sym__FORALL] = STATE(8456),
    [sym__LAMBDA] = STATE(8156),
    [sym__ELLIPSIS] = STATE(5102),
    [sym__qid] = STATE(5102),
    [sym_attribute] = STATE(7725),
    [sym_attributes] = STATE(6224),
    [sym_stmt] = STATE(9623),
    [sym__with_exprs] = STATE(12508),
    [sym__with_exprs_stmt] = STATE(9812),
    [sym__expr_or_attr] = STATE(5102),
    [sym__application] = STATE(8964),
    [sym__application_stmt] = STATE(9812),
    [sym__expr2_without_let] = STATE(9605),
    [sym__expr2] = STATE(8964),
    [sym__expr2_stmt] = STATE(9812),
    [sym_atom] = STATE(5147),
    [aux_sym__atoms] = STATE(3121),
    [sym__atom_curly] = STATE(5108),
    [sym__atom_no_curly] = STATE(5108),
    [sym_forall] = STATE(9605),
    [sym_let] = STATE(8964),
    [sym_let_in_do] = STATE(9812),
    [sym_lambda] = STATE(9605),
    [sym_lambda_extended_or_absurd] = STATE(9605),
    [sym_do] = STATE(9605),
    [sym__do_stmt] = STATE(12501),
    [sym_record_assignments] = STATE(5102),
    [sym_field_assignments] = STATE(5102),
    [aux_sym__typed_bindings] = STATE(8671),
    [sym_typed_binding] = STATE(8671),
    [sym_literal] = STATE(5102),
    [sym_SetN] = STATE(5102),
    [aux_sym__modal_arg_ids_repeat1] = STATE(7725),
    [aux_sym__with_exprs_repeat1] = STATE(3124),
    [aux_sym_do_repeat1] = STATE(267),
    [sym_id] = ACTIONS(734),
    [anon_sym_forall] = ACTIONS(736),
    [anon_sym_u2200] = ACTIONS(736),
    [anon_sym_BSLASH] = ACTIONS(738),
    [anon_sym_u03bb] = ACTIONS(740),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(742),
    [anon_sym_u2026] = ACTIONS(742),
    [anon_sym_record] = ACTIONS(744),
    [anon_sym_LPAREN] = ACTIONS(746),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(748),
    [anon_sym_u2983] = ACTIONS(750),
    [anon_sym__] = ACTIONS(742),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(752),
    [aux_sym__qid_token1] = ACTIONS(754),
    [anon_sym_DOT] = ACTIONS(756),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_AT] = ACTIONS(760),
    [anon_sym_quoteGoal] = ACTIONS(762),
    [anon_sym_tactic] = ACTIONS(764),
    [anon_sym_Prop] = ACTIONS(742),
    [anon_sym_quote] = ACTIONS(742),
    [anon_sym_quoteTerm] = ACTIONS(742),
    [anon_sym_quoteContext] = ACTIONS(742),
    [anon_sym_unquote] = ACTIONS(742),
    [anon_sym_LPAREN_PIPE] = ACTIONS(766),
    [anon_sym_u2987] = ACTIONS(768),
    [anon_sym_let] = ACTIONS(770),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(772),
    [aux_sym_string_token1] = ACTIONS(772),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(774),
    [sym_PropN] = ACTIONS(742),
    [sym__dedent] = ACTIONS(848),
  },
  [300] = {
    [sym__FORALL] = STATE(8495),
    [sym__ARROW] = STATE(2460),
    [sym__LAMBDA] = STATE(8064),
    [sym__ELLIPSIS] = STATE(5056),
    [sym_catchall_pragma] = STATE(3229),
    [sym__qid] = STATE(5217),
    [sym__binding_ids_and_absurds] = STATE(9878),
    [sym_attribute] = STATE(5830),
    [sym_attributes] = STATE(3559),
    [sym__expr_or_attr] = STATE(5056),
    [sym__application] = STATE(9572),
    [sym__expr2_without_let] = STATE(9572),
    [sym__expr2] = STATE(9572),
    [sym_atom] = STATE(5128),
    [aux_sym__atoms] = STATE(3561),
    [sym__atom_curly] = STATE(5069),
    [sym__atom_no_curly] = STATE(5069),
    [sym_forall] = STATE(9572),
    [sym_let] = STATE(9572),
    [sym_lambda] = STATE(9572),
    [sym_lambda_extended_or_absurd] = STATE(9572),
    [sym__lambda_clauses] = STATE(11554),
    [sym__lambda_clause_maybe_absurd] = STATE(8986),
    [sym_lambda_clause_absurd] = STATE(8986),
    [sym_lambda_clause] = STATE(8986),
    [sym_do] = STATE(9572),
    [sym_record_assignments] = STATE(5056),
    [sym_field_assignments] = STATE(5056),
    [sym_literal] = STATE(5056),
    [sym_SetN] = STATE(5056),
    [aux_sym__modal_arg_ids_repeat1] = STATE(5830),
    [aux_sym__lambda_clauses_repeat1] = STATE(2812),
    [sym_id] = ACTIONS(680),
    [anon_sym_forall] = ACTIONS(682),
    [anon_sym_u2200] = ACTIONS(682),
    [anon_sym_DASH_GT] = ACTIONS(684),
    [anon_sym_u2192] = ACTIONS(684),
    [anon_sym_BSLASH] = ACTIONS(686),
    [anon_sym_u03bb] = ACTIONS(688),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(690),
    [anon_sym_u2026] = ACTIONS(690),
    [anon_sym_record] = ACTIONS(692),
    [anon_sym_LPAREN] = ACTIONS(694),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(696),
    [anon_sym_u2983] = ACTIONS(698),
    [anon_sym__] = ACTIONS(690),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE_DASH_POUND] = ACTIONS(700),
    [anon_sym_LBRACE] = ACTIONS(702),
    [anon_sym_RBRACE] = ACTIONS(732),
    [aux_sym__qid_token1] = ACTIONS(706),
    [anon_sym_DOT] = ACTIONS(708),
    [anon_sym_DASH] = ACTIONS(710),
    [anon_sym_AT] = ACTIONS(712),
    [anon_sym_quoteGoal] = ACTIONS(714),
    [anon_sym_tactic] = ACTIONS(716),
    [anon_sym_Prop] = ACTIONS(690),
    [anon_sym_quote] = ACTIONS(690),
    [anon_sym_quoteTerm] = ACTIONS(690),
    [anon_sym_quoteContext] = ACTIONS(690),
    [anon_sym_unquote] = ACTIONS(690),
    [anon_sym_LPAREN_PIPE] = ACTIONS(718),
    [anon_sym_u2987] = ACTIONS(720),
    [anon_sym_let] = ACTIONS(722),
    [anon_sym_do] = ACTIONS(724),
    [aux_sym_integer_token1] = ACTIONS(726),
    [aux_sym_string_token1] = ACTIONS(726),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(728),
    [sym_PropN] = ACTIONS(690),
  },
  [301] = {
    [sym__FORALL] = STATE(8495),
    [sym__ARROW] = STATE(2460),
    [sym__LAMBDA] = STATE(8064),
    [sym__ELLIPSIS] = STATE(5056),
    [sym_catchall_pragma] = STATE(3229),
    [sym__qid] = STATE(5217),
    [sym__binding_ids_and_absurds] = STATE(9844),
    [sym_attribute] = STATE(5830),
    [sym_attributes] = STATE(3622),
    [sym__expr_or_attr] = STATE(5056),
    [sym__application] = STATE(9572),
    [sym__expr2_without_let] = STATE(9572),
    [sym__expr2] = STATE(9572),
    [sym_atom] = STATE(5128),
    [aux_sym__atoms] = STATE(3561),
    [sym__atom_curly] = STATE(5069),
    [sym__atom_no_curly] = STATE(5069),
    [sym_forall] = STATE(9572),
    [sym_let] = STATE(9572),
    [sym_lambda] = STATE(9572),
    [sym_lambda_extended_or_absurd] = STATE(9572),
    [sym__lambda_clauses] = STATE(12467),
    [sym__lambda_clause_maybe_absurd] = STATE(8986),
    [sym_lambda_clause_absurd] = STATE(8986),
    [sym_lambda_clause] = STATE(8986),
    [sym_do] = STATE(9572),
    [sym_record_assignments] = STATE(5056),
    [sym_field_assignments] = STATE(5056),
    [sym_literal] = STATE(5056),
    [sym_SetN] = STATE(5056),
    [aux_sym__modal_arg_ids_repeat1] = STATE(5830),
    [aux_sym__lambda_clauses_repeat1] = STATE(2812),
    [sym_id] = ACTIONS(680),
    [anon_sym_forall] = ACTIONS(682),
    [anon_sym_u2200] = ACTIONS(682),
    [anon_sym_DASH_GT] = ACTIONS(684),
    [anon_sym_u2192] = ACTIONS(684),
    [anon_sym_BSLASH] = ACTIONS(686),
    [anon_sym_u03bb] = ACTIONS(688),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(690),
    [anon_sym_u2026] = ACTIONS(690),
    [anon_sym_record] = ACTIONS(692),
    [anon_sym_LPAREN] = ACTIONS(694),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(696),
    [anon_sym_u2983] = ACTIONS(698),
    [anon_sym__] = ACTIONS(690),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE_DASH_POUND] = ACTIONS(700),
    [anon_sym_LBRACE] = ACTIONS(702),
    [anon_sym_RBRACE] = ACTIONS(704),
    [aux_sym__qid_token1] = ACTIONS(706),
    [anon_sym_DOT] = ACTIONS(708),
    [anon_sym_DASH] = ACTIONS(710),
    [anon_sym_AT] = ACTIONS(712),
    [anon_sym_quoteGoal] = ACTIONS(714),
    [anon_sym_tactic] = ACTIONS(716),
    [anon_sym_Prop] = ACTIONS(690),
    [anon_sym_quote] = ACTIONS(690),
    [anon_sym_quoteTerm] = ACTIONS(690),
    [anon_sym_quoteContext] = ACTIONS(690),
    [anon_sym_unquote] = ACTIONS(690),
    [anon_sym_LPAREN_PIPE] = ACTIONS(718),
    [anon_sym_u2987] = ACTIONS(720),
    [anon_sym_let] = ACTIONS(722),
    [anon_sym_do] = ACTIONS(724),
    [aux_sym_integer_token1] = ACTIONS(726),
    [aux_sym_string_token1] = ACTIONS(726),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(728),
    [sym_PropN] = ACTIONS(690),
  },
  [302] = {
    [sym__FORALL] = STATE(8495),
    [sym__ARROW] = STATE(2460),
    [sym__LAMBDA] = STATE(8064),
    [sym__ELLIPSIS] = STATE(5056),
    [sym_catchall_pragma] = STATE(3229),
    [sym__qid] = STATE(5217),
    [sym__binding_ids_and_absurds] = STATE(10024),
    [sym_attribute] = STATE(5830),
    [sym_attributes] = STATE(3673),
    [sym__expr_or_attr] = STATE(5056),
    [sym__application] = STATE(9572),
    [sym__expr2_without_let] = STATE(9572),
    [sym__expr2] = STATE(9572),
    [sym_atom] = STATE(5128),
    [aux_sym__atoms] = STATE(3561),
    [sym__atom_curly] = STATE(5069),
    [sym__atom_no_curly] = STATE(5069),
    [sym_forall] = STATE(9572),
    [sym_let] = STATE(9572),
    [sym_lambda] = STATE(9572),
    [sym_lambda_extended_or_absurd] = STATE(9572),
    [sym__lambda_clauses] = STATE(11497),
    [sym__lambda_clause_maybe_absurd] = STATE(8986),
    [sym_lambda_clause_absurd] = STATE(8986),
    [sym_lambda_clause] = STATE(8986),
    [sym_do] = STATE(9572),
    [sym_record_assignments] = STATE(5056),
    [sym_field_assignments] = STATE(5056),
    [sym_literal] = STATE(5056),
    [sym_SetN] = STATE(5056),
    [aux_sym__modal_arg_ids_repeat1] = STATE(5830),
    [aux_sym__lambda_clauses_repeat1] = STATE(2812),
    [sym_id] = ACTIONS(680),
    [anon_sym_forall] = ACTIONS(682),
    [anon_sym_u2200] = ACTIONS(682),
    [anon_sym_DASH_GT] = ACTIONS(684),
    [anon_sym_u2192] = ACTIONS(684),
    [anon_sym_BSLASH] = ACTIONS(686),
    [anon_sym_u03bb] = ACTIONS(688),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(690),
    [anon_sym_u2026] = ACTIONS(690),
    [anon_sym_record] = ACTIONS(692),
    [anon_sym_LPAREN] = ACTIONS(694),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(696),
    [anon_sym_u2983] = ACTIONS(698),
    [anon_sym__] = ACTIONS(690),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE_DASH_POUND] = ACTIONS(700),
    [anon_sym_LBRACE] = ACTIONS(702),
    [anon_sym_RBRACE] = ACTIONS(730),
    [aux_sym__qid_token1] = ACTIONS(706),
    [anon_sym_DOT] = ACTIONS(708),
    [anon_sym_DASH] = ACTIONS(710),
    [anon_sym_AT] = ACTIONS(712),
    [anon_sym_quoteGoal] = ACTIONS(714),
    [anon_sym_tactic] = ACTIONS(716),
    [anon_sym_Prop] = ACTIONS(690),
    [anon_sym_quote] = ACTIONS(690),
    [anon_sym_quoteTerm] = ACTIONS(690),
    [anon_sym_quoteContext] = ACTIONS(690),
    [anon_sym_unquote] = ACTIONS(690),
    [anon_sym_LPAREN_PIPE] = ACTIONS(718),
    [anon_sym_u2987] = ACTIONS(720),
    [anon_sym_let] = ACTIONS(722),
    [anon_sym_do] = ACTIONS(724),
    [aux_sym_integer_token1] = ACTIONS(726),
    [aux_sym_string_token1] = ACTIONS(726),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(728),
    [sym_PropN] = ACTIONS(690),
  },
  [303] = {
    [sym__FORALL] = STATE(8495),
    [sym__ARROW] = STATE(2460),
    [sym__LAMBDA] = STATE(8064),
    [sym__ELLIPSIS] = STATE(5056),
    [sym_catchall_pragma] = STATE(3229),
    [sym__qid] = STATE(5217),
    [sym__binding_ids_and_absurds] = STATE(9798),
    [sym_attribute] = STATE(5830),
    [sym_attributes] = STATE(3700),
    [sym__expr_or_attr] = STATE(5056),
    [sym__application] = STATE(9572),
    [sym__expr2_without_let] = STATE(9572),
    [sym__expr2] = STATE(9572),
    [sym_atom] = STATE(5128),
    [aux_sym__atoms] = STATE(3561),
    [sym__atom_curly] = STATE(5069),
    [sym__atom_no_curly] = STATE(5069),
    [sym_forall] = STATE(9572),
    [sym_let] = STATE(9572),
    [sym_lambda] = STATE(9572),
    [sym_lambda_extended_or_absurd] = STATE(9572),
    [sym__lambda_clauses] = STATE(11554),
    [sym__lambda_clause_maybe_absurd] = STATE(8986),
    [sym_lambda_clause_absurd] = STATE(8986),
    [sym_lambda_clause] = STATE(8986),
    [sym_do] = STATE(9572),
    [sym_record_assignments] = STATE(5056),
    [sym_field_assignments] = STATE(5056),
    [sym_literal] = STATE(5056),
    [sym_SetN] = STATE(5056),
    [aux_sym__modal_arg_ids_repeat1] = STATE(5830),
    [aux_sym__lambda_clauses_repeat1] = STATE(2812),
    [sym_id] = ACTIONS(680),
    [anon_sym_forall] = ACTIONS(682),
    [anon_sym_u2200] = ACTIONS(682),
    [anon_sym_DASH_GT] = ACTIONS(684),
    [anon_sym_u2192] = ACTIONS(684),
    [anon_sym_BSLASH] = ACTIONS(686),
    [anon_sym_u03bb] = ACTIONS(688),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(690),
    [anon_sym_u2026] = ACTIONS(690),
    [anon_sym_record] = ACTIONS(692),
    [anon_sym_LPAREN] = ACTIONS(694),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(696),
    [anon_sym_u2983] = ACTIONS(698),
    [anon_sym__] = ACTIONS(690),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE_DASH_POUND] = ACTIONS(700),
    [anon_sym_LBRACE] = ACTIONS(702),
    [anon_sym_RBRACE] = ACTIONS(732),
    [aux_sym__qid_token1] = ACTIONS(706),
    [anon_sym_DOT] = ACTIONS(708),
    [anon_sym_DASH] = ACTIONS(710),
    [anon_sym_AT] = ACTIONS(712),
    [anon_sym_quoteGoal] = ACTIONS(714),
    [anon_sym_tactic] = ACTIONS(716),
    [anon_sym_Prop] = ACTIONS(690),
    [anon_sym_quote] = ACTIONS(690),
    [anon_sym_quoteTerm] = ACTIONS(690),
    [anon_sym_quoteContext] = ACTIONS(690),
    [anon_sym_unquote] = ACTIONS(690),
    [anon_sym_LPAREN_PIPE] = ACTIONS(718),
    [anon_sym_u2987] = ACTIONS(720),
    [anon_sym_let] = ACTIONS(722),
    [anon_sym_do] = ACTIONS(724),
    [aux_sym_integer_token1] = ACTIONS(726),
    [aux_sym_string_token1] = ACTIONS(726),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(728),
    [sym_PropN] = ACTIONS(690),
  },
  [304] = {
    [sym__FORALL] = STATE(8495),
    [sym__ARROW] = STATE(2460),
    [sym__LAMBDA] = STATE(8064),
    [sym__ELLIPSIS] = STATE(5056),
    [sym_catchall_pragma] = STATE(3229),
    [sym__qid] = STATE(5217),
    [sym__binding_ids_and_absurds] = STATE(9775),
    [sym_attribute] = STATE(5830),
    [sym_attributes] = STATE(3370),
    [sym__expr_or_attr] = STATE(5056),
    [sym__application] = STATE(9572),
    [sym__expr2_without_let] = STATE(9572),
    [sym__expr2] = STATE(9572),
    [sym_atom] = STATE(5128),
    [aux_sym__atoms] = STATE(3561),
    [sym__atom_curly] = STATE(5069),
    [sym__atom_no_curly] = STATE(5069),
    [sym_forall] = STATE(9572),
    [sym_let] = STATE(9572),
    [sym_lambda] = STATE(9572),
    [sym_lambda_extended_or_absurd] = STATE(9572),
    [sym__lambda_clauses] = STATE(12467),
    [sym__lambda_clause_maybe_absurd] = STATE(8986),
    [sym_lambda_clause_absurd] = STATE(8986),
    [sym_lambda_clause] = STATE(8986),
    [sym_do] = STATE(9572),
    [sym_record_assignments] = STATE(5056),
    [sym_field_assignments] = STATE(5056),
    [sym_literal] = STATE(5056),
    [sym_SetN] = STATE(5056),
    [aux_sym__modal_arg_ids_repeat1] = STATE(5830),
    [aux_sym__lambda_clauses_repeat1] = STATE(2812),
    [sym_id] = ACTIONS(680),
    [anon_sym_forall] = ACTIONS(682),
    [anon_sym_u2200] = ACTIONS(682),
    [anon_sym_DASH_GT] = ACTIONS(684),
    [anon_sym_u2192] = ACTIONS(684),
    [anon_sym_BSLASH] = ACTIONS(686),
    [anon_sym_u03bb] = ACTIONS(688),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(690),
    [anon_sym_u2026] = ACTIONS(690),
    [anon_sym_record] = ACTIONS(692),
    [anon_sym_LPAREN] = ACTIONS(694),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(696),
    [anon_sym_u2983] = ACTIONS(698),
    [anon_sym__] = ACTIONS(690),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE_DASH_POUND] = ACTIONS(700),
    [anon_sym_LBRACE] = ACTIONS(702),
    [anon_sym_RBRACE] = ACTIONS(704),
    [aux_sym__qid_token1] = ACTIONS(706),
    [anon_sym_DOT] = ACTIONS(708),
    [anon_sym_DASH] = ACTIONS(710),
    [anon_sym_AT] = ACTIONS(712),
    [anon_sym_quoteGoal] = ACTIONS(714),
    [anon_sym_tactic] = ACTIONS(716),
    [anon_sym_Prop] = ACTIONS(690),
    [anon_sym_quote] = ACTIONS(690),
    [anon_sym_quoteTerm] = ACTIONS(690),
    [anon_sym_quoteContext] = ACTIONS(690),
    [anon_sym_unquote] = ACTIONS(690),
    [anon_sym_LPAREN_PIPE] = ACTIONS(718),
    [anon_sym_u2987] = ACTIONS(720),
    [anon_sym_let] = ACTIONS(722),
    [anon_sym_do] = ACTIONS(724),
    [aux_sym_integer_token1] = ACTIONS(726),
    [aux_sym_string_token1] = ACTIONS(726),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(728),
    [sym_PropN] = ACTIONS(690),
  },
  [305] = {
    [sym__FORALL] = STATE(8495),
    [sym__ARROW] = STATE(2460),
    [sym__LAMBDA] = STATE(8064),
    [sym__ELLIPSIS] = STATE(5056),
    [sym_catchall_pragma] = STATE(3229),
    [sym__qid] = STATE(5217),
    [sym__binding_ids_and_absurds] = STATE(9797),
    [sym_attribute] = STATE(5830),
    [sym_attributes] = STATE(3352),
    [sym__expr_or_attr] = STATE(5056),
    [sym__application] = STATE(9572),
    [sym__expr2_without_let] = STATE(9572),
    [sym__expr2] = STATE(9572),
    [sym_atom] = STATE(5128),
    [aux_sym__atoms] = STATE(3561),
    [sym__atom_curly] = STATE(5069),
    [sym__atom_no_curly] = STATE(5069),
    [sym_forall] = STATE(9572),
    [sym_let] = STATE(9572),
    [sym_lambda] = STATE(9572),
    [sym_lambda_extended_or_absurd] = STATE(9572),
    [sym__lambda_clauses] = STATE(11554),
    [sym__lambda_clause_maybe_absurd] = STATE(8986),
    [sym_lambda_clause_absurd] = STATE(8986),
    [sym_lambda_clause] = STATE(8986),
    [sym_do] = STATE(9572),
    [sym_record_assignments] = STATE(5056),
    [sym_field_assignments] = STATE(5056),
    [sym_literal] = STATE(5056),
    [sym_SetN] = STATE(5056),
    [aux_sym__modal_arg_ids_repeat1] = STATE(5830),
    [aux_sym__lambda_clauses_repeat1] = STATE(2812),
    [sym_id] = ACTIONS(680),
    [anon_sym_forall] = ACTIONS(682),
    [anon_sym_u2200] = ACTIONS(682),
    [anon_sym_DASH_GT] = ACTIONS(684),
    [anon_sym_u2192] = ACTIONS(684),
    [anon_sym_BSLASH] = ACTIONS(686),
    [anon_sym_u03bb] = ACTIONS(688),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(690),
    [anon_sym_u2026] = ACTIONS(690),
    [anon_sym_record] = ACTIONS(692),
    [anon_sym_LPAREN] = ACTIONS(694),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(696),
    [anon_sym_u2983] = ACTIONS(698),
    [anon_sym__] = ACTIONS(690),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE_DASH_POUND] = ACTIONS(700),
    [anon_sym_LBRACE] = ACTIONS(702),
    [anon_sym_RBRACE] = ACTIONS(732),
    [aux_sym__qid_token1] = ACTIONS(706),
    [anon_sym_DOT] = ACTIONS(708),
    [anon_sym_DASH] = ACTIONS(710),
    [anon_sym_AT] = ACTIONS(712),
    [anon_sym_quoteGoal] = ACTIONS(714),
    [anon_sym_tactic] = ACTIONS(716),
    [anon_sym_Prop] = ACTIONS(690),
    [anon_sym_quote] = ACTIONS(690),
    [anon_sym_quoteTerm] = ACTIONS(690),
    [anon_sym_quoteContext] = ACTIONS(690),
    [anon_sym_unquote] = ACTIONS(690),
    [anon_sym_LPAREN_PIPE] = ACTIONS(718),
    [anon_sym_u2987] = ACTIONS(720),
    [anon_sym_let] = ACTIONS(722),
    [anon_sym_do] = ACTIONS(724),
    [aux_sym_integer_token1] = ACTIONS(726),
    [aux_sym_string_token1] = ACTIONS(726),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(728),
    [sym_PropN] = ACTIONS(690),
  },
  [306] = {
    [sym__FORALL] = STATE(8495),
    [sym__ARROW] = STATE(2460),
    [sym__LAMBDA] = STATE(8064),
    [sym__ELLIPSIS] = STATE(5056),
    [sym_catchall_pragma] = STATE(3229),
    [sym__qid] = STATE(5217),
    [sym__binding_ids_and_absurds] = STATE(9797),
    [sym_attribute] = STATE(5830),
    [sym_attributes] = STATE(3352),
    [sym__expr_or_attr] = STATE(5056),
    [sym__application] = STATE(9572),
    [sym__expr2_without_let] = STATE(9572),
    [sym__expr2] = STATE(9572),
    [sym_atom] = STATE(5128),
    [aux_sym__atoms] = STATE(3561),
    [sym__atom_curly] = STATE(5069),
    [sym__atom_no_curly] = STATE(5069),
    [sym_forall] = STATE(9572),
    [sym_let] = STATE(9572),
    [sym_lambda] = STATE(9572),
    [sym_lambda_extended_or_absurd] = STATE(9572),
    [sym__lambda_clauses] = STATE(11497),
    [sym__lambda_clause_maybe_absurd] = STATE(8986),
    [sym_lambda_clause_absurd] = STATE(8986),
    [sym_lambda_clause] = STATE(8986),
    [sym_do] = STATE(9572),
    [sym_record_assignments] = STATE(5056),
    [sym_field_assignments] = STATE(5056),
    [sym_literal] = STATE(5056),
    [sym_SetN] = STATE(5056),
    [aux_sym__modal_arg_ids_repeat1] = STATE(5830),
    [aux_sym__lambda_clauses_repeat1] = STATE(2812),
    [sym_id] = ACTIONS(680),
    [anon_sym_forall] = ACTIONS(682),
    [anon_sym_u2200] = ACTIONS(682),
    [anon_sym_DASH_GT] = ACTIONS(684),
    [anon_sym_u2192] = ACTIONS(684),
    [anon_sym_BSLASH] = ACTIONS(686),
    [anon_sym_u03bb] = ACTIONS(688),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(690),
    [anon_sym_u2026] = ACTIONS(690),
    [anon_sym_record] = ACTIONS(692),
    [anon_sym_LPAREN] = ACTIONS(694),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(696),
    [anon_sym_u2983] = ACTIONS(698),
    [anon_sym__] = ACTIONS(690),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE_DASH_POUND] = ACTIONS(700),
    [anon_sym_LBRACE] = ACTIONS(702),
    [anon_sym_RBRACE] = ACTIONS(730),
    [aux_sym__qid_token1] = ACTIONS(706),
    [anon_sym_DOT] = ACTIONS(708),
    [anon_sym_DASH] = ACTIONS(710),
    [anon_sym_AT] = ACTIONS(712),
    [anon_sym_quoteGoal] = ACTIONS(714),
    [anon_sym_tactic] = ACTIONS(716),
    [anon_sym_Prop] = ACTIONS(690),
    [anon_sym_quote] = ACTIONS(690),
    [anon_sym_quoteTerm] = ACTIONS(690),
    [anon_sym_quoteContext] = ACTIONS(690),
    [anon_sym_unquote] = ACTIONS(690),
    [anon_sym_LPAREN_PIPE] = ACTIONS(718),
    [anon_sym_u2987] = ACTIONS(720),
    [anon_sym_let] = ACTIONS(722),
    [anon_sym_do] = ACTIONS(724),
    [aux_sym_integer_token1] = ACTIONS(726),
    [aux_sym_string_token1] = ACTIONS(726),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(728),
    [sym_PropN] = ACTIONS(690),
  },
  [307] = {
    [sym__FORALL] = STATE(8495),
    [sym__ARROW] = STATE(2460),
    [sym__LAMBDA] = STATE(8064),
    [sym__ELLIPSIS] = STATE(5056),
    [sym_catchall_pragma] = STATE(3229),
    [sym__qid] = STATE(5217),
    [sym__binding_ids_and_absurds] = STATE(9843),
    [sym_attribute] = STATE(5830),
    [sym_attributes] = STATE(3440),
    [sym__expr_or_attr] = STATE(5056),
    [sym__application] = STATE(9572),
    [sym__expr2_without_let] = STATE(9572),
    [sym__expr2] = STATE(9572),
    [sym_atom] = STATE(5128),
    [aux_sym__atoms] = STATE(3561),
    [sym__atom_curly] = STATE(5069),
    [sym__atom_no_curly] = STATE(5069),
    [sym_forall] = STATE(9572),
    [sym_let] = STATE(9572),
    [sym_lambda] = STATE(9572),
    [sym_lambda_extended_or_absurd] = STATE(9572),
    [sym__lambda_clauses] = STATE(11554),
    [sym__lambda_clause_maybe_absurd] = STATE(8986),
    [sym_lambda_clause_absurd] = STATE(8986),
    [sym_lambda_clause] = STATE(8986),
    [sym_do] = STATE(9572),
    [sym_record_assignments] = STATE(5056),
    [sym_field_assignments] = STATE(5056),
    [sym_literal] = STATE(5056),
    [sym_SetN] = STATE(5056),
    [aux_sym__modal_arg_ids_repeat1] = STATE(5830),
    [aux_sym__lambda_clauses_repeat1] = STATE(2812),
    [sym_id] = ACTIONS(680),
    [anon_sym_forall] = ACTIONS(682),
    [anon_sym_u2200] = ACTIONS(682),
    [anon_sym_DASH_GT] = ACTIONS(684),
    [anon_sym_u2192] = ACTIONS(684),
    [anon_sym_BSLASH] = ACTIONS(686),
    [anon_sym_u03bb] = ACTIONS(688),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(690),
    [anon_sym_u2026] = ACTIONS(690),
    [anon_sym_record] = ACTIONS(692),
    [anon_sym_LPAREN] = ACTIONS(694),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(696),
    [anon_sym_u2983] = ACTIONS(698),
    [anon_sym__] = ACTIONS(690),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE_DASH_POUND] = ACTIONS(700),
    [anon_sym_LBRACE] = ACTIONS(702),
    [anon_sym_RBRACE] = ACTIONS(732),
    [aux_sym__qid_token1] = ACTIONS(706),
    [anon_sym_DOT] = ACTIONS(708),
    [anon_sym_DASH] = ACTIONS(710),
    [anon_sym_AT] = ACTIONS(712),
    [anon_sym_quoteGoal] = ACTIONS(714),
    [anon_sym_tactic] = ACTIONS(716),
    [anon_sym_Prop] = ACTIONS(690),
    [anon_sym_quote] = ACTIONS(690),
    [anon_sym_quoteTerm] = ACTIONS(690),
    [anon_sym_quoteContext] = ACTIONS(690),
    [anon_sym_unquote] = ACTIONS(690),
    [anon_sym_LPAREN_PIPE] = ACTIONS(718),
    [anon_sym_u2987] = ACTIONS(720),
    [anon_sym_let] = ACTIONS(722),
    [anon_sym_do] = ACTIONS(724),
    [aux_sym_integer_token1] = ACTIONS(726),
    [aux_sym_string_token1] = ACTIONS(726),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(728),
    [sym_PropN] = ACTIONS(690),
  },
  [308] = {
    [sym__FORALL] = STATE(8495),
    [sym__ARROW] = STATE(2460),
    [sym__LAMBDA] = STATE(8064),
    [sym__ELLIPSIS] = STATE(5056),
    [sym_catchall_pragma] = STATE(3229),
    [sym__qid] = STATE(5217),
    [sym__binding_ids_and_absurds] = STATE(9706),
    [sym_attribute] = STATE(5830),
    [sym_attributes] = STATE(3696),
    [sym__expr_or_attr] = STATE(5056),
    [sym__application] = STATE(9572),
    [sym__expr2_without_let] = STATE(9572),
    [sym__expr2] = STATE(9572),
    [sym_atom] = STATE(5128),
    [aux_sym__atoms] = STATE(3561),
    [sym__atom_curly] = STATE(5069),
    [sym__atom_no_curly] = STATE(5069),
    [sym_forall] = STATE(9572),
    [sym_let] = STATE(9572),
    [sym_lambda] = STATE(9572),
    [sym_lambda_extended_or_absurd] = STATE(9572),
    [sym__lambda_clauses] = STATE(12467),
    [sym__lambda_clause_maybe_absurd] = STATE(8986),
    [sym_lambda_clause_absurd] = STATE(8986),
    [sym_lambda_clause] = STATE(8986),
    [sym_do] = STATE(9572),
    [sym_record_assignments] = STATE(5056),
    [sym_field_assignments] = STATE(5056),
    [sym_literal] = STATE(5056),
    [sym_SetN] = STATE(5056),
    [aux_sym__modal_arg_ids_repeat1] = STATE(5830),
    [aux_sym__lambda_clauses_repeat1] = STATE(2812),
    [sym_id] = ACTIONS(680),
    [anon_sym_forall] = ACTIONS(682),
    [anon_sym_u2200] = ACTIONS(682),
    [anon_sym_DASH_GT] = ACTIONS(684),
    [anon_sym_u2192] = ACTIONS(684),
    [anon_sym_BSLASH] = ACTIONS(686),
    [anon_sym_u03bb] = ACTIONS(688),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(690),
    [anon_sym_u2026] = ACTIONS(690),
    [anon_sym_record] = ACTIONS(692),
    [anon_sym_LPAREN] = ACTIONS(694),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(696),
    [anon_sym_u2983] = ACTIONS(698),
    [anon_sym__] = ACTIONS(690),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE_DASH_POUND] = ACTIONS(700),
    [anon_sym_LBRACE] = ACTIONS(702),
    [anon_sym_RBRACE] = ACTIONS(704),
    [aux_sym__qid_token1] = ACTIONS(706),
    [anon_sym_DOT] = ACTIONS(708),
    [anon_sym_DASH] = ACTIONS(710),
    [anon_sym_AT] = ACTIONS(712),
    [anon_sym_quoteGoal] = ACTIONS(714),
    [anon_sym_tactic] = ACTIONS(716),
    [anon_sym_Prop] = ACTIONS(690),
    [anon_sym_quote] = ACTIONS(690),
    [anon_sym_quoteTerm] = ACTIONS(690),
    [anon_sym_quoteContext] = ACTIONS(690),
    [anon_sym_unquote] = ACTIONS(690),
    [anon_sym_LPAREN_PIPE] = ACTIONS(718),
    [anon_sym_u2987] = ACTIONS(720),
    [anon_sym_let] = ACTIONS(722),
    [anon_sym_do] = ACTIONS(724),
    [aux_sym_integer_token1] = ACTIONS(726),
    [aux_sym_string_token1] = ACTIONS(726),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(728),
    [sym_PropN] = ACTIONS(690),
  },
  [309] = {
    [sym__FORALL] = STATE(8495),
    [sym__ARROW] = STATE(2460),
    [sym__LAMBDA] = STATE(8064),
    [sym__ELLIPSIS] = STATE(5056),
    [sym_catchall_pragma] = STATE(3229),
    [sym__qid] = STATE(5217),
    [sym__binding_ids_and_absurds] = STATE(9757),
    [sym_attribute] = STATE(5830),
    [sym_attributes] = STATE(3401),
    [sym__expr_or_attr] = STATE(5056),
    [sym__application] = STATE(9572),
    [sym__expr2_without_let] = STATE(9572),
    [sym__expr2] = STATE(9572),
    [sym_atom] = STATE(5128),
    [aux_sym__atoms] = STATE(3561),
    [sym__atom_curly] = STATE(5069),
    [sym__atom_no_curly] = STATE(5069),
    [sym_forall] = STATE(9572),
    [sym_let] = STATE(9572),
    [sym_lambda] = STATE(9572),
    [sym_lambda_extended_or_absurd] = STATE(9572),
    [sym__lambda_clauses] = STATE(11497),
    [sym__lambda_clause_maybe_absurd] = STATE(8986),
    [sym_lambda_clause_absurd] = STATE(8986),
    [sym_lambda_clause] = STATE(8986),
    [sym_do] = STATE(9572),
    [sym_record_assignments] = STATE(5056),
    [sym_field_assignments] = STATE(5056),
    [sym_literal] = STATE(5056),
    [sym_SetN] = STATE(5056),
    [aux_sym__modal_arg_ids_repeat1] = STATE(5830),
    [aux_sym__lambda_clauses_repeat1] = STATE(2812),
    [sym_id] = ACTIONS(680),
    [anon_sym_forall] = ACTIONS(682),
    [anon_sym_u2200] = ACTIONS(682),
    [anon_sym_DASH_GT] = ACTIONS(684),
    [anon_sym_u2192] = ACTIONS(684),
    [anon_sym_BSLASH] = ACTIONS(686),
    [anon_sym_u03bb] = ACTIONS(688),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(690),
    [anon_sym_u2026] = ACTIONS(690),
    [anon_sym_record] = ACTIONS(692),
    [anon_sym_LPAREN] = ACTIONS(694),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(696),
    [anon_sym_u2983] = ACTIONS(698),
    [anon_sym__] = ACTIONS(690),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE_DASH_POUND] = ACTIONS(700),
    [anon_sym_LBRACE] = ACTIONS(702),
    [anon_sym_RBRACE] = ACTIONS(730),
    [aux_sym__qid_token1] = ACTIONS(706),
    [anon_sym_DOT] = ACTIONS(708),
    [anon_sym_DASH] = ACTIONS(710),
    [anon_sym_AT] = ACTIONS(712),
    [anon_sym_quoteGoal] = ACTIONS(714),
    [anon_sym_tactic] = ACTIONS(716),
    [anon_sym_Prop] = ACTIONS(690),
    [anon_sym_quote] = ACTIONS(690),
    [anon_sym_quoteTerm] = ACTIONS(690),
    [anon_sym_quoteContext] = ACTIONS(690),
    [anon_sym_unquote] = ACTIONS(690),
    [anon_sym_LPAREN_PIPE] = ACTIONS(718),
    [anon_sym_u2987] = ACTIONS(720),
    [anon_sym_let] = ACTIONS(722),
    [anon_sym_do] = ACTIONS(724),
    [aux_sym_integer_token1] = ACTIONS(726),
    [aux_sym_string_token1] = ACTIONS(726),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(728),
    [sym_PropN] = ACTIONS(690),
  },
  [310] = {
    [sym__FORALL] = STATE(8495),
    [sym__ARROW] = STATE(2460),
    [sym__LAMBDA] = STATE(8064),
    [sym__ELLIPSIS] = STATE(5056),
    [sym_catchall_pragma] = STATE(3229),
    [sym__qid] = STATE(5217),
    [sym__binding_ids_and_absurds] = STATE(9877),
    [sym_attribute] = STATE(5830),
    [sym_attributes] = STATE(3634),
    [sym__expr_or_attr] = STATE(5056),
    [sym__application] = STATE(9572),
    [sym__expr2_without_let] = STATE(9572),
    [sym__expr2] = STATE(9572),
    [sym_atom] = STATE(5128),
    [aux_sym__atoms] = STATE(3561),
    [sym__atom_curly] = STATE(5069),
    [sym__atom_no_curly] = STATE(5069),
    [sym_forall] = STATE(9572),
    [sym_let] = STATE(9572),
    [sym_lambda] = STATE(9572),
    [sym_lambda_extended_or_absurd] = STATE(9572),
    [sym__lambda_clauses] = STATE(11554),
    [sym__lambda_clause_maybe_absurd] = STATE(8986),
    [sym_lambda_clause_absurd] = STATE(8986),
    [sym_lambda_clause] = STATE(8986),
    [sym_do] = STATE(9572),
    [sym_record_assignments] = STATE(5056),
    [sym_field_assignments] = STATE(5056),
    [sym_literal] = STATE(5056),
    [sym_SetN] = STATE(5056),
    [aux_sym__modal_arg_ids_repeat1] = STATE(5830),
    [aux_sym__lambda_clauses_repeat1] = STATE(2812),
    [sym_id] = ACTIONS(680),
    [anon_sym_forall] = ACTIONS(682),
    [anon_sym_u2200] = ACTIONS(682),
    [anon_sym_DASH_GT] = ACTIONS(684),
    [anon_sym_u2192] = ACTIONS(684),
    [anon_sym_BSLASH] = ACTIONS(686),
    [anon_sym_u03bb] = ACTIONS(688),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(690),
    [anon_sym_u2026] = ACTIONS(690),
    [anon_sym_record] = ACTIONS(692),
    [anon_sym_LPAREN] = ACTIONS(694),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(696),
    [anon_sym_u2983] = ACTIONS(698),
    [anon_sym__] = ACTIONS(690),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE_DASH_POUND] = ACTIONS(700),
    [anon_sym_LBRACE] = ACTIONS(702),
    [anon_sym_RBRACE] = ACTIONS(732),
    [aux_sym__qid_token1] = ACTIONS(706),
    [anon_sym_DOT] = ACTIONS(708),
    [anon_sym_DASH] = ACTIONS(710),
    [anon_sym_AT] = ACTIONS(712),
    [anon_sym_quoteGoal] = ACTIONS(714),
    [anon_sym_tactic] = ACTIONS(716),
    [anon_sym_Prop] = ACTIONS(690),
    [anon_sym_quote] = ACTIONS(690),
    [anon_sym_quoteTerm] = ACTIONS(690),
    [anon_sym_quoteContext] = ACTIONS(690),
    [anon_sym_unquote] = ACTIONS(690),
    [anon_sym_LPAREN_PIPE] = ACTIONS(718),
    [anon_sym_u2987] = ACTIONS(720),
    [anon_sym_let] = ACTIONS(722),
    [anon_sym_do] = ACTIONS(724),
    [aux_sym_integer_token1] = ACTIONS(726),
    [aux_sym_string_token1] = ACTIONS(726),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(728),
    [sym_PropN] = ACTIONS(690),
  },
  [311] = {
    [sym__FORALL] = STATE(8495),
    [sym__ARROW] = STATE(2460),
    [sym__LAMBDA] = STATE(8064),
    [sym__ELLIPSIS] = STATE(5056),
    [sym_catchall_pragma] = STATE(3229),
    [sym__qid] = STATE(5217),
    [sym__binding_ids_and_absurds] = STATE(9921),
    [sym_attribute] = STATE(5830),
    [sym_attributes] = STATE(3399),
    [sym__expr_or_attr] = STATE(5056),
    [sym__application] = STATE(9572),
    [sym__expr2_without_let] = STATE(9572),
    [sym__expr2] = STATE(9572),
    [sym_atom] = STATE(5128),
    [aux_sym__atoms] = STATE(3561),
    [sym__atom_curly] = STATE(5069),
    [sym__atom_no_curly] = STATE(5069),
    [sym_forall] = STATE(9572),
    [sym_let] = STATE(9572),
    [sym_lambda] = STATE(9572),
    [sym_lambda_extended_or_absurd] = STATE(9572),
    [sym__lambda_clauses] = STATE(12467),
    [sym__lambda_clause_maybe_absurd] = STATE(8986),
    [sym_lambda_clause_absurd] = STATE(8986),
    [sym_lambda_clause] = STATE(8986),
    [sym_do] = STATE(9572),
    [sym_record_assignments] = STATE(5056),
    [sym_field_assignments] = STATE(5056),
    [sym_literal] = STATE(5056),
    [sym_SetN] = STATE(5056),
    [aux_sym__modal_arg_ids_repeat1] = STATE(5830),
    [aux_sym__lambda_clauses_repeat1] = STATE(2812),
    [sym_id] = ACTIONS(680),
    [anon_sym_forall] = ACTIONS(682),
    [anon_sym_u2200] = ACTIONS(682),
    [anon_sym_DASH_GT] = ACTIONS(684),
    [anon_sym_u2192] = ACTIONS(684),
    [anon_sym_BSLASH] = ACTIONS(686),
    [anon_sym_u03bb] = ACTIONS(688),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(690),
    [anon_sym_u2026] = ACTIONS(690),
    [anon_sym_record] = ACTIONS(692),
    [anon_sym_LPAREN] = ACTIONS(694),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(696),
    [anon_sym_u2983] = ACTIONS(698),
    [anon_sym__] = ACTIONS(690),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE_DASH_POUND] = ACTIONS(700),
    [anon_sym_LBRACE] = ACTIONS(702),
    [anon_sym_RBRACE] = ACTIONS(704),
    [aux_sym__qid_token1] = ACTIONS(706),
    [anon_sym_DOT] = ACTIONS(708),
    [anon_sym_DASH] = ACTIONS(710),
    [anon_sym_AT] = ACTIONS(712),
    [anon_sym_quoteGoal] = ACTIONS(714),
    [anon_sym_tactic] = ACTIONS(716),
    [anon_sym_Prop] = ACTIONS(690),
    [anon_sym_quote] = ACTIONS(690),
    [anon_sym_quoteTerm] = ACTIONS(690),
    [anon_sym_quoteContext] = ACTIONS(690),
    [anon_sym_unquote] = ACTIONS(690),
    [anon_sym_LPAREN_PIPE] = ACTIONS(718),
    [anon_sym_u2987] = ACTIONS(720),
    [anon_sym_let] = ACTIONS(722),
    [anon_sym_do] = ACTIONS(724),
    [aux_sym_integer_token1] = ACTIONS(726),
    [aux_sym_string_token1] = ACTIONS(726),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(728),
    [sym_PropN] = ACTIONS(690),
  },
  [312] = {
    [sym__FORALL] = STATE(8495),
    [sym__ARROW] = STATE(2460),
    [sym__LAMBDA] = STATE(8064),
    [sym__ELLIPSIS] = STATE(5056),
    [sym_catchall_pragma] = STATE(3229),
    [sym__qid] = STATE(5217),
    [sym__binding_ids_and_absurds] = STATE(9698),
    [sym_attribute] = STATE(5830),
    [sym_attributes] = STATE(3533),
    [sym__expr_or_attr] = STATE(5056),
    [sym__application] = STATE(9572),
    [sym__expr2_without_let] = STATE(9572),
    [sym__expr2] = STATE(9572),
    [sym_atom] = STATE(5128),
    [aux_sym__atoms] = STATE(3561),
    [sym__atom_curly] = STATE(5069),
    [sym__atom_no_curly] = STATE(5069),
    [sym_forall] = STATE(9572),
    [sym_let] = STATE(9572),
    [sym_lambda] = STATE(9572),
    [sym_lambda_extended_or_absurd] = STATE(9572),
    [sym__lambda_clauses] = STATE(12467),
    [sym__lambda_clause_maybe_absurd] = STATE(8986),
    [sym_lambda_clause_absurd] = STATE(8986),
    [sym_lambda_clause] = STATE(8986),
    [sym_do] = STATE(9572),
    [sym_record_assignments] = STATE(5056),
    [sym_field_assignments] = STATE(5056),
    [sym_literal] = STATE(5056),
    [sym_SetN] = STATE(5056),
    [aux_sym__modal_arg_ids_repeat1] = STATE(5830),
    [aux_sym__lambda_clauses_repeat1] = STATE(2812),
    [sym_id] = ACTIONS(680),
    [anon_sym_forall] = ACTIONS(682),
    [anon_sym_u2200] = ACTIONS(682),
    [anon_sym_DASH_GT] = ACTIONS(684),
    [anon_sym_u2192] = ACTIONS(684),
    [anon_sym_BSLASH] = ACTIONS(686),
    [anon_sym_u03bb] = ACTIONS(688),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(690),
    [anon_sym_u2026] = ACTIONS(690),
    [anon_sym_record] = ACTIONS(692),
    [anon_sym_LPAREN] = ACTIONS(694),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(696),
    [anon_sym_u2983] = ACTIONS(698),
    [anon_sym__] = ACTIONS(690),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE_DASH_POUND] = ACTIONS(700),
    [anon_sym_LBRACE] = ACTIONS(702),
    [anon_sym_RBRACE] = ACTIONS(704),
    [aux_sym__qid_token1] = ACTIONS(706),
    [anon_sym_DOT] = ACTIONS(708),
    [anon_sym_DASH] = ACTIONS(710),
    [anon_sym_AT] = ACTIONS(712),
    [anon_sym_quoteGoal] = ACTIONS(714),
    [anon_sym_tactic] = ACTIONS(716),
    [anon_sym_Prop] = ACTIONS(690),
    [anon_sym_quote] = ACTIONS(690),
    [anon_sym_quoteTerm] = ACTIONS(690),
    [anon_sym_quoteContext] = ACTIONS(690),
    [anon_sym_unquote] = ACTIONS(690),
    [anon_sym_LPAREN_PIPE] = ACTIONS(718),
    [anon_sym_u2987] = ACTIONS(720),
    [anon_sym_let] = ACTIONS(722),
    [anon_sym_do] = ACTIONS(724),
    [aux_sym_integer_token1] = ACTIONS(726),
    [aux_sym_string_token1] = ACTIONS(726),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(728),
    [sym_PropN] = ACTIONS(690),
  },
  [313] = {
    [sym__FORALL] = STATE(8495),
    [sym__ARROW] = STATE(2460),
    [sym__LAMBDA] = STATE(8064),
    [sym__ELLIPSIS] = STATE(5056),
    [sym_catchall_pragma] = STATE(3229),
    [sym__qid] = STATE(5217),
    [sym__binding_ids_and_absurds] = STATE(9715),
    [sym_attribute] = STATE(5830),
    [sym_attributes] = STATE(3640),
    [sym__expr_or_attr] = STATE(5056),
    [sym__application] = STATE(9572),
    [sym__expr2_without_let] = STATE(9572),
    [sym__expr2] = STATE(9572),
    [sym_atom] = STATE(5128),
    [aux_sym__atoms] = STATE(3561),
    [sym__atom_curly] = STATE(5069),
    [sym__atom_no_curly] = STATE(5069),
    [sym_forall] = STATE(9572),
    [sym_let] = STATE(9572),
    [sym_lambda] = STATE(9572),
    [sym_lambda_extended_or_absurd] = STATE(9572),
    [sym__lambda_clauses] = STATE(12467),
    [sym__lambda_clause_maybe_absurd] = STATE(8986),
    [sym_lambda_clause_absurd] = STATE(8986),
    [sym_lambda_clause] = STATE(8986),
    [sym_do] = STATE(9572),
    [sym_record_assignments] = STATE(5056),
    [sym_field_assignments] = STATE(5056),
    [sym_literal] = STATE(5056),
    [sym_SetN] = STATE(5056),
    [aux_sym__modal_arg_ids_repeat1] = STATE(5830),
    [aux_sym__lambda_clauses_repeat1] = STATE(2812),
    [sym_id] = ACTIONS(680),
    [anon_sym_forall] = ACTIONS(682),
    [anon_sym_u2200] = ACTIONS(682),
    [anon_sym_DASH_GT] = ACTIONS(684),
    [anon_sym_u2192] = ACTIONS(684),
    [anon_sym_BSLASH] = ACTIONS(686),
    [anon_sym_u03bb] = ACTIONS(688),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(690),
    [anon_sym_u2026] = ACTIONS(690),
    [anon_sym_record] = ACTIONS(692),
    [anon_sym_LPAREN] = ACTIONS(694),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(696),
    [anon_sym_u2983] = ACTIONS(698),
    [anon_sym__] = ACTIONS(690),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE_DASH_POUND] = ACTIONS(700),
    [anon_sym_LBRACE] = ACTIONS(702),
    [anon_sym_RBRACE] = ACTIONS(704),
    [aux_sym__qid_token1] = ACTIONS(706),
    [anon_sym_DOT] = ACTIONS(708),
    [anon_sym_DASH] = ACTIONS(710),
    [anon_sym_AT] = ACTIONS(712),
    [anon_sym_quoteGoal] = ACTIONS(714),
    [anon_sym_tactic] = ACTIONS(716),
    [anon_sym_Prop] = ACTIONS(690),
    [anon_sym_quote] = ACTIONS(690),
    [anon_sym_quoteTerm] = ACTIONS(690),
    [anon_sym_quoteContext] = ACTIONS(690),
    [anon_sym_unquote] = ACTIONS(690),
    [anon_sym_LPAREN_PIPE] = ACTIONS(718),
    [anon_sym_u2987] = ACTIONS(720),
    [anon_sym_let] = ACTIONS(722),
    [anon_sym_do] = ACTIONS(724),
    [aux_sym_integer_token1] = ACTIONS(726),
    [aux_sym_string_token1] = ACTIONS(726),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(728),
    [sym_PropN] = ACTIONS(690),
  },
  [314] = {
    [sym__FORALL] = STATE(8495),
    [sym__ARROW] = STATE(2460),
    [sym__LAMBDA] = STATE(8064),
    [sym__ELLIPSIS] = STATE(5056),
    [sym_catchall_pragma] = STATE(3229),
    [sym__qid] = STATE(5217),
    [sym__binding_ids_and_absurds] = STATE(9944),
    [sym_attribute] = STATE(5830),
    [sym_attributes] = STATE(3466),
    [sym__expr_or_attr] = STATE(5056),
    [sym__application] = STATE(9572),
    [sym__expr2_without_let] = STATE(9572),
    [sym__expr2] = STATE(9572),
    [sym_atom] = STATE(5128),
    [aux_sym__atoms] = STATE(3561),
    [sym__atom_curly] = STATE(5069),
    [sym__atom_no_curly] = STATE(5069),
    [sym_forall] = STATE(9572),
    [sym_let] = STATE(9572),
    [sym_lambda] = STATE(9572),
    [sym_lambda_extended_or_absurd] = STATE(9572),
    [sym__lambda_clauses] = STATE(11554),
    [sym__lambda_clause_maybe_absurd] = STATE(8986),
    [sym_lambda_clause_absurd] = STATE(8986),
    [sym_lambda_clause] = STATE(8986),
    [sym_do] = STATE(9572),
    [sym_record_assignments] = STATE(5056),
    [sym_field_assignments] = STATE(5056),
    [sym_literal] = STATE(5056),
    [sym_SetN] = STATE(5056),
    [aux_sym__modal_arg_ids_repeat1] = STATE(5830),
    [aux_sym__lambda_clauses_repeat1] = STATE(2812),
    [sym_id] = ACTIONS(680),
    [anon_sym_forall] = ACTIONS(682),
    [anon_sym_u2200] = ACTIONS(682),
    [anon_sym_DASH_GT] = ACTIONS(684),
    [anon_sym_u2192] = ACTIONS(684),
    [anon_sym_BSLASH] = ACTIONS(686),
    [anon_sym_u03bb] = ACTIONS(688),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(690),
    [anon_sym_u2026] = ACTIONS(690),
    [anon_sym_record] = ACTIONS(692),
    [anon_sym_LPAREN] = ACTIONS(694),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(696),
    [anon_sym_u2983] = ACTIONS(698),
    [anon_sym__] = ACTIONS(690),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE_DASH_POUND] = ACTIONS(700),
    [anon_sym_LBRACE] = ACTIONS(702),
    [anon_sym_RBRACE] = ACTIONS(732),
    [aux_sym__qid_token1] = ACTIONS(706),
    [anon_sym_DOT] = ACTIONS(708),
    [anon_sym_DASH] = ACTIONS(710),
    [anon_sym_AT] = ACTIONS(712),
    [anon_sym_quoteGoal] = ACTIONS(714),
    [anon_sym_tactic] = ACTIONS(716),
    [anon_sym_Prop] = ACTIONS(690),
    [anon_sym_quote] = ACTIONS(690),
    [anon_sym_quoteTerm] = ACTIONS(690),
    [anon_sym_quoteContext] = ACTIONS(690),
    [anon_sym_unquote] = ACTIONS(690),
    [anon_sym_LPAREN_PIPE] = ACTIONS(718),
    [anon_sym_u2987] = ACTIONS(720),
    [anon_sym_let] = ACTIONS(722),
    [anon_sym_do] = ACTIONS(724),
    [aux_sym_integer_token1] = ACTIONS(726),
    [aux_sym_string_token1] = ACTIONS(726),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(728),
    [sym_PropN] = ACTIONS(690),
  },
  [315] = {
    [sym__FORALL] = STATE(8495),
    [sym__ARROW] = STATE(2460),
    [sym__LAMBDA] = STATE(8064),
    [sym__ELLIPSIS] = STATE(5056),
    [sym_catchall_pragma] = STATE(3229),
    [sym__qid] = STATE(5217),
    [sym__binding_ids_and_absurds] = STATE(9739),
    [sym_attribute] = STATE(5830),
    [sym_attributes] = STATE(3419),
    [sym__expr_or_attr] = STATE(5056),
    [sym__application] = STATE(9572),
    [sym__expr2_without_let] = STATE(9572),
    [sym__expr2] = STATE(9572),
    [sym_atom] = STATE(5128),
    [aux_sym__atoms] = STATE(3561),
    [sym__atom_curly] = STATE(5069),
    [sym__atom_no_curly] = STATE(5069),
    [sym_forall] = STATE(9572),
    [sym_let] = STATE(9572),
    [sym_lambda] = STATE(9572),
    [sym_lambda_extended_or_absurd] = STATE(9572),
    [sym__lambda_clauses] = STATE(11497),
    [sym__lambda_clause_maybe_absurd] = STATE(8986),
    [sym_lambda_clause_absurd] = STATE(8986),
    [sym_lambda_clause] = STATE(8986),
    [sym_do] = STATE(9572),
    [sym_record_assignments] = STATE(5056),
    [sym_field_assignments] = STATE(5056),
    [sym_literal] = STATE(5056),
    [sym_SetN] = STATE(5056),
    [aux_sym__modal_arg_ids_repeat1] = STATE(5830),
    [aux_sym__lambda_clauses_repeat1] = STATE(2812),
    [sym_id] = ACTIONS(680),
    [anon_sym_forall] = ACTIONS(682),
    [anon_sym_u2200] = ACTIONS(682),
    [anon_sym_DASH_GT] = ACTIONS(684),
    [anon_sym_u2192] = ACTIONS(684),
    [anon_sym_BSLASH] = ACTIONS(686),
    [anon_sym_u03bb] = ACTIONS(688),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(690),
    [anon_sym_u2026] = ACTIONS(690),
    [anon_sym_record] = ACTIONS(692),
    [anon_sym_LPAREN] = ACTIONS(694),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(696),
    [anon_sym_u2983] = ACTIONS(698),
    [anon_sym__] = ACTIONS(690),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE_DASH_POUND] = ACTIONS(700),
    [anon_sym_LBRACE] = ACTIONS(702),
    [anon_sym_RBRACE] = ACTIONS(730),
    [aux_sym__qid_token1] = ACTIONS(706),
    [anon_sym_DOT] = ACTIONS(708),
    [anon_sym_DASH] = ACTIONS(710),
    [anon_sym_AT] = ACTIONS(712),
    [anon_sym_quoteGoal] = ACTIONS(714),
    [anon_sym_tactic] = ACTIONS(716),
    [anon_sym_Prop] = ACTIONS(690),
    [anon_sym_quote] = ACTIONS(690),
    [anon_sym_quoteTerm] = ACTIONS(690),
    [anon_sym_quoteContext] = ACTIONS(690),
    [anon_sym_unquote] = ACTIONS(690),
    [anon_sym_LPAREN_PIPE] = ACTIONS(718),
    [anon_sym_u2987] = ACTIONS(720),
    [anon_sym_let] = ACTIONS(722),
    [anon_sym_do] = ACTIONS(724),
    [aux_sym_integer_token1] = ACTIONS(726),
    [aux_sym_string_token1] = ACTIONS(726),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(728),
    [sym_PropN] = ACTIONS(690),
  },
  [316] = {
    [sym__FORALL] = STATE(8456),
    [sym__LAMBDA] = STATE(8156),
    [sym__ELLIPSIS] = STATE(5102),
    [sym__qid] = STATE(5102),
    [sym_attribute] = STATE(7725),
    [sym_attributes] = STATE(6224),
    [sym_stmt] = STATE(9623),
    [sym__with_exprs] = STATE(12508),
    [sym__with_exprs_stmt] = STATE(9812),
    [sym__expr_or_attr] = STATE(5102),
    [sym__application] = STATE(8964),
    [sym__application_stmt] = STATE(9812),
    [sym__expr2_without_let] = STATE(9605),
    [sym__expr2] = STATE(8964),
    [sym__expr2_stmt] = STATE(9812),
    [sym_atom] = STATE(5147),
    [aux_sym__atoms] = STATE(3121),
    [sym__atom_curly] = STATE(5108),
    [sym__atom_no_curly] = STATE(5108),
    [sym_forall] = STATE(9605),
    [sym_let] = STATE(8964),
    [sym_let_in_do] = STATE(9812),
    [sym_lambda] = STATE(9605),
    [sym_lambda_extended_or_absurd] = STATE(9605),
    [sym_do] = STATE(9605),
    [sym__do_stmt] = STATE(12501),
    [sym_record_assignments] = STATE(5102),
    [sym_field_assignments] = STATE(5102),
    [aux_sym__typed_bindings] = STATE(8671),
    [sym_typed_binding] = STATE(8671),
    [sym_literal] = STATE(5102),
    [sym_SetN] = STATE(5102),
    [aux_sym__modal_arg_ids_repeat1] = STATE(7725),
    [aux_sym__with_exprs_repeat1] = STATE(3124),
    [aux_sym_do_repeat1] = STATE(299),
    [sym_id] = ACTIONS(734),
    [anon_sym_forall] = ACTIONS(736),
    [anon_sym_u2200] = ACTIONS(736),
    [anon_sym_BSLASH] = ACTIONS(738),
    [anon_sym_u03bb] = ACTIONS(740),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(742),
    [anon_sym_u2026] = ACTIONS(742),
    [anon_sym_record] = ACTIONS(744),
    [anon_sym_LPAREN] = ACTIONS(746),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(748),
    [anon_sym_u2983] = ACTIONS(750),
    [anon_sym__] = ACTIONS(742),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(752),
    [aux_sym__qid_token1] = ACTIONS(754),
    [anon_sym_DOT] = ACTIONS(756),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_AT] = ACTIONS(760),
    [anon_sym_quoteGoal] = ACTIONS(762),
    [anon_sym_tactic] = ACTIONS(764),
    [anon_sym_Prop] = ACTIONS(742),
    [anon_sym_quote] = ACTIONS(742),
    [anon_sym_quoteTerm] = ACTIONS(742),
    [anon_sym_quoteContext] = ACTIONS(742),
    [anon_sym_unquote] = ACTIONS(742),
    [anon_sym_LPAREN_PIPE] = ACTIONS(766),
    [anon_sym_u2987] = ACTIONS(768),
    [anon_sym_let] = ACTIONS(770),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(772),
    [aux_sym_string_token1] = ACTIONS(772),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(774),
    [sym_PropN] = ACTIONS(742),
  },
  [317] = {
    [sym__FORALL] = STATE(8456),
    [sym__LAMBDA] = STATE(8156),
    [sym__ELLIPSIS] = STATE(5102),
    [sym__qid] = STATE(5102),
    [sym_attribute] = STATE(7725),
    [sym_attributes] = STATE(6224),
    [sym_stmt] = STATE(9623),
    [sym__with_exprs] = STATE(12508),
    [sym__with_exprs_stmt] = STATE(9812),
    [sym__expr_or_attr] = STATE(5102),
    [sym__application] = STATE(8964),
    [sym__application_stmt] = STATE(9812),
    [sym__expr2_without_let] = STATE(9605),
    [sym__expr2] = STATE(8964),
    [sym__expr2_stmt] = STATE(9812),
    [sym_atom] = STATE(5147),
    [aux_sym__atoms] = STATE(3121),
    [sym__atom_curly] = STATE(5108),
    [sym__atom_no_curly] = STATE(5108),
    [sym_forall] = STATE(9605),
    [sym_let] = STATE(8964),
    [sym_let_in_do] = STATE(9812),
    [sym_lambda] = STATE(9605),
    [sym_lambda_extended_or_absurd] = STATE(9605),
    [sym_do] = STATE(9605),
    [sym__do_stmt] = STATE(12501),
    [sym_record_assignments] = STATE(5102),
    [sym_field_assignments] = STATE(5102),
    [aux_sym__typed_bindings] = STATE(8671),
    [sym_typed_binding] = STATE(8671),
    [sym_literal] = STATE(5102),
    [sym_SetN] = STATE(5102),
    [aux_sym__modal_arg_ids_repeat1] = STATE(7725),
    [aux_sym__with_exprs_repeat1] = STATE(3124),
    [aux_sym_do_repeat1] = STATE(266),
    [sym_id] = ACTIONS(734),
    [anon_sym_forall] = ACTIONS(736),
    [anon_sym_u2200] = ACTIONS(736),
    [anon_sym_BSLASH] = ACTIONS(738),
    [anon_sym_u03bb] = ACTIONS(740),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(742),
    [anon_sym_u2026] = ACTIONS(742),
    [anon_sym_record] = ACTIONS(744),
    [anon_sym_LPAREN] = ACTIONS(746),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(748),
    [anon_sym_u2983] = ACTIONS(750),
    [anon_sym__] = ACTIONS(742),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(752),
    [aux_sym__qid_token1] = ACTIONS(754),
    [anon_sym_DOT] = ACTIONS(756),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_AT] = ACTIONS(760),
    [anon_sym_quoteGoal] = ACTIONS(762),
    [anon_sym_tactic] = ACTIONS(764),
    [anon_sym_Prop] = ACTIONS(742),
    [anon_sym_quote] = ACTIONS(742),
    [anon_sym_quoteTerm] = ACTIONS(742),
    [anon_sym_quoteContext] = ACTIONS(742),
    [anon_sym_unquote] = ACTIONS(742),
    [anon_sym_LPAREN_PIPE] = ACTIONS(766),
    [anon_sym_u2987] = ACTIONS(768),
    [anon_sym_let] = ACTIONS(770),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(772),
    [aux_sym_string_token1] = ACTIONS(772),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(774),
    [sym_PropN] = ACTIONS(742),
  },
  [318] = {
    [sym__FORALL] = STATE(8456),
    [sym__LAMBDA] = STATE(8156),
    [sym__ELLIPSIS] = STATE(5102),
    [sym__qid] = STATE(5102),
    [sym_attribute] = STATE(7725),
    [sym_attributes] = STATE(6224),
    [sym_stmt] = STATE(9623),
    [sym__with_exprs] = STATE(12508),
    [sym__with_exprs_stmt] = STATE(9812),
    [sym__expr_or_attr] = STATE(5102),
    [sym__application] = STATE(8964),
    [sym__application_stmt] = STATE(9812),
    [sym__expr2_without_let] = STATE(9605),
    [sym__expr2] = STATE(8964),
    [sym__expr2_stmt] = STATE(9812),
    [sym_atom] = STATE(5147),
    [aux_sym__atoms] = STATE(3121),
    [sym__atom_curly] = STATE(5108),
    [sym__atom_no_curly] = STATE(5108),
    [sym_forall] = STATE(9605),
    [sym_let] = STATE(8964),
    [sym_let_in_do] = STATE(9812),
    [sym_lambda] = STATE(9605),
    [sym_lambda_extended_or_absurd] = STATE(9605),
    [sym_do] = STATE(9605),
    [sym__do_stmt] = STATE(12501),
    [sym_record_assignments] = STATE(5102),
    [sym_field_assignments] = STATE(5102),
    [aux_sym__typed_bindings] = STATE(8671),
    [sym_typed_binding] = STATE(8671),
    [sym_literal] = STATE(5102),
    [sym_SetN] = STATE(5102),
    [aux_sym__modal_arg_ids_repeat1] = STATE(7725),
    [aux_sym__with_exprs_repeat1] = STATE(3124),
    [aux_sym_do_repeat1] = STATE(288),
    [sym_id] = ACTIONS(734),
    [anon_sym_forall] = ACTIONS(736),
    [anon_sym_u2200] = ACTIONS(736),
    [anon_sym_BSLASH] = ACTIONS(738),
    [anon_sym_u03bb] = ACTIONS(740),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(742),
    [anon_sym_u2026] = ACTIONS(742),
    [anon_sym_record] = ACTIONS(744),
    [anon_sym_LPAREN] = ACTIONS(746),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(748),
    [anon_sym_u2983] = ACTIONS(750),
    [anon_sym__] = ACTIONS(742),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(752),
    [aux_sym__qid_token1] = ACTIONS(754),
    [anon_sym_DOT] = ACTIONS(756),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_AT] = ACTIONS(760),
    [anon_sym_quoteGoal] = ACTIONS(762),
    [anon_sym_tactic] = ACTIONS(764),
    [anon_sym_Prop] = ACTIONS(742),
    [anon_sym_quote] = ACTIONS(742),
    [anon_sym_quoteTerm] = ACTIONS(742),
    [anon_sym_quoteContext] = ACTIONS(742),
    [anon_sym_unquote] = ACTIONS(742),
    [anon_sym_LPAREN_PIPE] = ACTIONS(766),
    [anon_sym_u2987] = ACTIONS(768),
    [anon_sym_let] = ACTIONS(770),
    [anon_sym_do] = ACTIONS(85),
    [aux_sym_integer_token1] = ACTIONS(772),
    [aux_sym_string_token1] = ACTIONS(772),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(774),
    [sym_PropN] = ACTIONS(742),
  },
  [319] = {
    [sym__FORALL] = STATE(8369),
    [sym__LAMBDA] = STATE(8152),
    [sym__ELLIPSIS] = STATE(5168),
    [sym__qid] = STATE(5168),
    [sym__binding_ids_and_absurds] = STATE(12358),
    [sym_attribute] = STATE(7725),
    [sym_attributes] = STATE(6182),
    [sym_expr] = STATE(12557),
    [sym__with_exprs] = STATE(9861),
    [sym__expr_or_attr] = STATE(5168),
    [sym__application] = STATE(9444),
    [sym__expr2_without_let] = STATE(9444),
    [sym__expr2] = STATE(9444),
    [sym_atom] = STATE(5204),
    [aux_sym__atoms] = STATE(3133),
    [sym__atom_curly] = STATE(5180),
    [sym__atom_no_curly] = STATE(5180),
    [sym_forall] = STATE(9444),
    [sym_let] = STATE(9444),
    [sym_lambda] = STATE(9444),
    [sym_lambda_extended_or_absurd] = STATE(9444),
    [sym_do] = STATE(9444),
    [sym_record_assignments] = STATE(5168),
    [sym_field_assignments] = STATE(5168),
    [aux_sym__typed_bindings] = STATE(8654),
    [sym_typed_binding] = STATE(8654),
    [sym_literal] = STATE(5168),
    [sym_SetN] = STATE(5168),
    [aux_sym__modal_arg_ids_repeat1] = STATE(7725),
    [aux_sym__with_exprs_repeat1] = STATE(3754),
    [sym_id] = ACTIONS(850),
    [anon_sym_forall] = ACTIONS(852),
    [anon_sym_u2200] = ACTIONS(852),
    [anon_sym_BSLASH] = ACTIONS(854),
    [anon_sym_u03bb] = ACTIONS(856),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(858),
    [anon_sym_u2026] = ACTIONS(858),
    [anon_sym_record] = ACTIONS(860),
    [anon_sym_LPAREN] = ACTIONS(862),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(864),
    [anon_sym_u2983] = ACTIONS(866),
    [anon_sym_u2984] = ACTIONS(868),
    [anon_sym__] = ACTIONS(858),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(870),
    [aux_sym__qid_token1] = ACTIONS(872),
    [anon_sym_DOT] = ACTIONS(874),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(760),
    [anon_sym_quoteGoal] = ACTIONS(878),
    [anon_sym_tactic] = ACTIONS(880),
    [anon_sym_Prop] = ACTIONS(858),
    [anon_sym_quote] = ACTIONS(858),
    [anon_sym_quoteTerm] = ACTIONS(858),
    [anon_sym_quoteContext] = ACTIONS(858),
    [anon_sym_unquote] = ACTIONS(858),
    [anon_sym_LPAREN_PIPE] = ACTIONS(882),
    [anon_sym_u2987] = ACTIONS(884),
    [anon_sym_let] = ACTIONS(886),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(890),
    [aux_sym_string_token1] = ACTIONS(890),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(892),
    [sym_PropN] = ACTIONS(858),
  },
  [320] = {
    [sym__FORALL] = STATE(8396),
    [sym__LAMBDA] = STATE(8031),
    [sym__ELLIPSIS] = STATE(4920),
    [sym__qid] = STATE(4920),
    [sym__binding_ids_and_absurds] = STATE(12539),
    [sym_attribute] = STATE(5830),
    [sym_attributes] = STATE(3504),
    [sym_expr] = STATE(11779),
    [sym__with_exprs] = STATE(10196),
    [sym__expr_or_attr] = STATE(4920),
    [sym__application] = STATE(9678),
    [sym__expr2_without_let] = STATE(9678),
    [sym__expr2] = STATE(9678),
    [sym_atom] = STATE(5202),
    [aux_sym__atoms] = STATE(3165),
    [sym__atom_curly] = STATE(4961),
    [sym__atom_no_curly] = STATE(4961),
    [sym_forall] = STATE(9678),
    [sym_let] = STATE(9678),
    [sym_lambda] = STATE(9678),
    [sym_lambda_extended_or_absurd] = STATE(9678),
    [sym_do] = STATE(9678),
    [sym_record_assignments] = STATE(4920),
    [sym_field_assignments] = STATE(4920),
    [aux_sym__typed_bindings] = STATE(8648),
    [sym_typed_binding] = STATE(8648),
    [sym_literal] = STATE(4920),
    [sym_SetN] = STATE(4920),
    [aux_sym__modal_arg_ids_repeat1] = STATE(5830),
    [aux_sym__with_exprs_repeat1] = STATE(3726),
    [sym_id] = ACTIONS(894),
    [anon_sym_forall] = ACTIONS(896),
    [anon_sym_u2200] = ACTIONS(896),
    [anon_sym_BSLASH] = ACTIONS(898),
    [anon_sym_u03bb] = ACTIONS(900),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(902),
    [anon_sym_u2026] = ACTIONS(902),
    [anon_sym_record] = ACTIONS(904),
    [anon_sym_LPAREN] = ACTIONS(906),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(908),
    [anon_sym_u2983] = ACTIONS(910),
    [anon_sym__] = ACTIONS(902),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(912),
    [anon_sym_RBRACE] = ACTIONS(914),
    [aux_sym__qid_token1] = ACTIONS(916),
    [anon_sym_DOT] = ACTIONS(918),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(712),
    [anon_sym_quoteGoal] = ACTIONS(920),
    [anon_sym_tactic] = ACTIONS(922),
    [anon_sym_Prop] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(902),
    [anon_sym_quoteTerm] = ACTIONS(902),
    [anon_sym_quoteContext] = ACTIONS(902),
    [anon_sym_unquote] = ACTIONS(902),
    [anon_sym_LPAREN_PIPE] = ACTIONS(924),
    [anon_sym_u2987] = ACTIONS(926),
    [anon_sym_let] = ACTIONS(928),
    [anon_sym_do] = ACTIONS(724),
    [aux_sym_integer_token1] = ACTIONS(930),
    [aux_sym_string_token1] = ACTIONS(930),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(932),
    [sym_PropN] = ACTIONS(902),
  },
  [321] = {
    [sym__FORALL] = STATE(8396),
    [sym__LAMBDA] = STATE(8031),
    [sym__ELLIPSIS] = STATE(4920),
    [sym__qid] = STATE(4920),
    [sym__binding_ids_and_absurds] = STATE(12539),
    [sym_attribute] = STATE(5830),
    [sym_attributes] = STATE(3504),
    [sym_expr] = STATE(10382),
    [sym__with_exprs] = STATE(10196),
    [sym__expr_or_attr] = STATE(4920),
    [sym__application] = STATE(9678),
    [sym__expr2_without_let] = STATE(9678),
    [sym__expr2] = STATE(9678),
    [sym_atom] = STATE(5202),
    [aux_sym__atoms] = STATE(3165),
    [sym__atom_curly] = STATE(4961),
    [sym__atom_no_curly] = STATE(4961),
    [sym_forall] = STATE(9678),
    [sym_let] = STATE(9678),
    [sym_lambda] = STATE(9678),
    [sym_lambda_extended_or_absurd] = STATE(9678),
    [sym_do] = STATE(9678),
    [sym_record_assignments] = STATE(4920),
    [sym_field_assignments] = STATE(4920),
    [aux_sym__typed_bindings] = STATE(8648),
    [sym_typed_binding] = STATE(8648),
    [sym_literal] = STATE(4920),
    [sym_SetN] = STATE(4920),
    [aux_sym__modal_arg_ids_repeat1] = STATE(5830),
    [aux_sym__with_exprs_repeat1] = STATE(3726),
    [sym_id] = ACTIONS(894),
    [anon_sym_forall] = ACTIONS(896),
    [anon_sym_u2200] = ACTIONS(896),
    [anon_sym_BSLASH] = ACTIONS(898),
    [anon_sym_u03bb] = ACTIONS(900),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(902),
    [anon_sym_u2026] = ACTIONS(902),
    [anon_sym_record] = ACTIONS(904),
    [anon_sym_LPAREN] = ACTIONS(906),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(908),
    [anon_sym_u2983] = ACTIONS(910),
    [anon_sym__] = ACTIONS(902),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(912),
    [anon_sym_RBRACE] = ACTIONS(934),
    [aux_sym__qid_token1] = ACTIONS(916),
    [anon_sym_DOT] = ACTIONS(918),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(712),
    [anon_sym_quoteGoal] = ACTIONS(920),
    [anon_sym_tactic] = ACTIONS(922),
    [anon_sym_Prop] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(902),
    [anon_sym_quoteTerm] = ACTIONS(902),
    [anon_sym_quoteContext] = ACTIONS(902),
    [anon_sym_unquote] = ACTIONS(902),
    [anon_sym_LPAREN_PIPE] = ACTIONS(924),
    [anon_sym_u2987] = ACTIONS(926),
    [anon_sym_let] = ACTIONS(928),
    [anon_sym_do] = ACTIONS(724),
    [aux_sym_integer_token1] = ACTIONS(930),
    [aux_sym_string_token1] = ACTIONS(930),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(932),
    [sym_PropN] = ACTIONS(902),
  },
  [322] = {
    [sym__FORALL] = STATE(8369),
    [sym__LAMBDA] = STATE(8152),
    [sym__ELLIPSIS] = STATE(5168),
    [sym__qid] = STATE(5168),
    [sym__binding_ids_and_absurds] = STATE(12544),
    [sym_attribute] = STATE(5830),
    [sym_attributes] = STATE(3505),
    [sym_expr] = STATE(11145),
    [sym__with_exprs] = STATE(9861),
    [sym__expr_or_attr] = STATE(5168),
    [sym__application] = STATE(9444),
    [sym__expr2_without_let] = STATE(9444),
    [sym__expr2] = STATE(9444),
    [sym_atom] = STATE(5204),
    [aux_sym__atoms] = STATE(3133),
    [sym__atom_curly] = STATE(5180),
    [sym__atom_no_curly] = STATE(5180),
    [sym_forall] = STATE(9444),
    [sym_let] = STATE(9444),
    [sym_lambda] = STATE(9444),
    [sym_lambda_extended_or_absurd] = STATE(9444),
    [sym_do] = STATE(9444),
    [sym_record_assignments] = STATE(5168),
    [sym_field_assignments] = STATE(5168),
    [aux_sym__typed_bindings] = STATE(8654),
    [sym_typed_binding] = STATE(8654),
    [sym_literal] = STATE(5168),
    [sym_SetN] = STATE(5168),
    [aux_sym__modal_arg_ids_repeat1] = STATE(5830),
    [aux_sym__with_exprs_repeat1] = STATE(3754),
    [sym_id] = ACTIONS(850),
    [anon_sym_forall] = ACTIONS(852),
    [anon_sym_u2200] = ACTIONS(852),
    [anon_sym_BSLASH] = ACTIONS(854),
    [anon_sym_u03bb] = ACTIONS(856),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(858),
    [anon_sym_u2026] = ACTIONS(858),
    [anon_sym_record] = ACTIONS(860),
    [anon_sym_LPAREN] = ACTIONS(862),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(864),
    [anon_sym_u2983] = ACTIONS(866),
    [anon_sym_u2984] = ACTIONS(936),
    [anon_sym__] = ACTIONS(858),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(870),
    [aux_sym__qid_token1] = ACTIONS(872),
    [anon_sym_DOT] = ACTIONS(874),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(712),
    [anon_sym_quoteGoal] = ACTIONS(878),
    [anon_sym_tactic] = ACTIONS(880),
    [anon_sym_Prop] = ACTIONS(858),
    [anon_sym_quote] = ACTIONS(858),
    [anon_sym_quoteTerm] = ACTIONS(858),
    [anon_sym_quoteContext] = ACTIONS(858),
    [anon_sym_unquote] = ACTIONS(858),
    [anon_sym_LPAREN_PIPE] = ACTIONS(882),
    [anon_sym_u2987] = ACTIONS(884),
    [anon_sym_let] = ACTIONS(886),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(890),
    [aux_sym_string_token1] = ACTIONS(890),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(892),
    [sym_PropN] = ACTIONS(858),
  },
  [323] = {
    [sym__FORALL] = STATE(8396),
    [sym__LAMBDA] = STATE(8031),
    [sym__ELLIPSIS] = STATE(4920),
    [sym__qid] = STATE(4920),
    [sym__binding_ids_and_absurds] = STATE(12357),
    [sym_attribute] = STATE(7725),
    [sym_attributes] = STATE(6200),
    [sym_expr] = STATE(12615),
    [sym__with_exprs] = STATE(10196),
    [sym__expr_or_attr] = STATE(4920),
    [sym__application] = STATE(9678),
    [sym__expr2_without_let] = STATE(9678),
    [sym__expr2] = STATE(9678),
    [sym_atom] = STATE(5202),
    [aux_sym__atoms] = STATE(3165),
    [sym__atom_curly] = STATE(4961),
    [sym__atom_no_curly] = STATE(4961),
    [sym_forall] = STATE(9678),
    [sym_let] = STATE(9678),
    [sym_lambda] = STATE(9678),
    [sym_lambda_extended_or_absurd] = STATE(9678),
    [sym_do] = STATE(9678),
    [sym_record_assignments] = STATE(4920),
    [sym_field_assignments] = STATE(4920),
    [aux_sym__typed_bindings] = STATE(8648),
    [sym_typed_binding] = STATE(8648),
    [sym_literal] = STATE(4920),
    [sym_SetN] = STATE(4920),
    [aux_sym__modal_arg_ids_repeat1] = STATE(7725),
    [aux_sym__with_exprs_repeat1] = STATE(3726),
    [sym_id] = ACTIONS(894),
    [anon_sym_forall] = ACTIONS(896),
    [anon_sym_u2200] = ACTIONS(896),
    [anon_sym_BSLASH] = ACTIONS(898),
    [anon_sym_u03bb] = ACTIONS(900),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(902),
    [anon_sym_u2026] = ACTIONS(902),
    [anon_sym_record] = ACTIONS(904),
    [anon_sym_LPAREN] = ACTIONS(906),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(908),
    [anon_sym_u2983] = ACTIONS(910),
    [anon_sym__] = ACTIONS(902),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(912),
    [anon_sym_RBRACE] = ACTIONS(938),
    [aux_sym__qid_token1] = ACTIONS(916),
    [anon_sym_DOT] = ACTIONS(918),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(760),
    [anon_sym_quoteGoal] = ACTIONS(920),
    [anon_sym_tactic] = ACTIONS(922),
    [anon_sym_Prop] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(902),
    [anon_sym_quoteTerm] = ACTIONS(902),
    [anon_sym_quoteContext] = ACTIONS(902),
    [anon_sym_unquote] = ACTIONS(902),
    [anon_sym_LPAREN_PIPE] = ACTIONS(924),
    [anon_sym_u2987] = ACTIONS(926),
    [anon_sym_let] = ACTIONS(928),
    [anon_sym_do] = ACTIONS(724),
    [aux_sym_integer_token1] = ACTIONS(930),
    [aux_sym_string_token1] = ACTIONS(930),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(932),
    [sym_PropN] = ACTIONS(902),
  },
  [324] = {
    [sym__FORALL] = STATE(8355),
    [sym__LAMBDA] = STATE(8054),
    [sym__ELLIPSIS] = STATE(4742),
    [sym__qid] = STATE(4742),
    [sym__binding_ids_and_absurds] = STATE(12547),
    [sym_attribute] = STATE(5830),
    [sym_attributes] = STATE(3506),
    [sym_expr] = STATE(11146),
    [sym__with_exprs] = STATE(10050),
    [sym__expr_or_attr] = STATE(4742),
    [sym__application] = STATE(9444),
    [sym__expr2_without_let] = STATE(9444),
    [sym__expr2] = STATE(9444),
    [sym_atom] = STATE(4712),
    [aux_sym__atoms] = STATE(3276),
    [sym__atom_curly] = STATE(4733),
    [sym__atom_no_curly] = STATE(4733),
    [sym_forall] = STATE(9444),
    [sym_let] = STATE(9444),
    [sym_lambda] = STATE(9444),
    [sym_lambda_extended_or_absurd] = STATE(9444),
    [sym_do] = STATE(9444),
    [sym_record_assignments] = STATE(4742),
    [sym_field_assignments] = STATE(4742),
    [aux_sym__typed_bindings] = STATE(8646),
    [sym_typed_binding] = STATE(8646),
    [sym_literal] = STATE(4742),
    [sym_SetN] = STATE(4742),
    [aux_sym__modal_arg_ids_repeat1] = STATE(5830),
    [aux_sym__with_exprs_repeat1] = STATE(3745),
    [sym_id] = ACTIONS(940),
    [anon_sym_forall] = ACTIONS(942),
    [anon_sym_u2200] = ACTIONS(942),
    [anon_sym_BSLASH] = ACTIONS(944),
    [anon_sym_u03bb] = ACTIONS(946),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(948),
    [anon_sym_u2026] = ACTIONS(948),
    [anon_sym_record] = ACTIONS(950),
    [anon_sym_LPAREN] = ACTIONS(952),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(954),
    [anon_sym_RBRACE_RBRACE] = ACTIONS(936),
    [anon_sym_u2983] = ACTIONS(956),
    [anon_sym__] = ACTIONS(948),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(958),
    [aux_sym__qid_token1] = ACTIONS(960),
    [anon_sym_DOT] = ACTIONS(962),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(712),
    [anon_sym_quoteGoal] = ACTIONS(964),
    [anon_sym_tactic] = ACTIONS(966),
    [anon_sym_Prop] = ACTIONS(948),
    [anon_sym_quote] = ACTIONS(948),
    [anon_sym_quoteTerm] = ACTIONS(948),
    [anon_sym_quoteContext] = ACTIONS(948),
    [anon_sym_unquote] = ACTIONS(948),
    [anon_sym_LPAREN_PIPE] = ACTIONS(968),
    [anon_sym_u2987] = ACTIONS(970),
    [anon_sym_let] = ACTIONS(972),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(974),
    [aux_sym_string_token1] = ACTIONS(974),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(976),
    [sym_PropN] = ACTIONS(948),
  },
  [325] = {
    [sym__FORALL] = STATE(8369),
    [sym__LAMBDA] = STATE(8152),
    [sym__ELLIPSIS] = STATE(5168),
    [sym__qid] = STATE(5168),
    [sym__binding_ids_and_absurds] = STATE(12544),
    [sym_attribute] = STATE(5830),
    [sym_attributes] = STATE(3505),
    [sym_expr] = STATE(10345),
    [sym__with_exprs] = STATE(9861),
    [sym__expr_or_attr] = STATE(5168),
    [sym__application] = STATE(9444),
    [sym__expr2_without_let] = STATE(9444),
    [sym__expr2] = STATE(9444),
    [sym_atom] = STATE(5204),
    [aux_sym__atoms] = STATE(3133),
    [sym__atom_curly] = STATE(5180),
    [sym__atom_no_curly] = STATE(5180),
    [sym_forall] = STATE(9444),
    [sym_let] = STATE(9444),
    [sym_lambda] = STATE(9444),
    [sym_lambda_extended_or_absurd] = STATE(9444),
    [sym_do] = STATE(9444),
    [sym_record_assignments] = STATE(5168),
    [sym_field_assignments] = STATE(5168),
    [aux_sym__typed_bindings] = STATE(8654),
    [sym_typed_binding] = STATE(8654),
    [sym_literal] = STATE(5168),
    [sym_SetN] = STATE(5168),
    [aux_sym__modal_arg_ids_repeat1] = STATE(5830),
    [aux_sym__with_exprs_repeat1] = STATE(3754),
    [sym_id] = ACTIONS(850),
    [anon_sym_forall] = ACTIONS(852),
    [anon_sym_u2200] = ACTIONS(852),
    [anon_sym_BSLASH] = ACTIONS(854),
    [anon_sym_u03bb] = ACTIONS(856),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(858),
    [anon_sym_u2026] = ACTIONS(858),
    [anon_sym_record] = ACTIONS(860),
    [anon_sym_LPAREN] = ACTIONS(862),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(864),
    [anon_sym_u2983] = ACTIONS(866),
    [anon_sym_u2984] = ACTIONS(978),
    [anon_sym__] = ACTIONS(858),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(870),
    [aux_sym__qid_token1] = ACTIONS(872),
    [anon_sym_DOT] = ACTIONS(874),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(712),
    [anon_sym_quoteGoal] = ACTIONS(878),
    [anon_sym_tactic] = ACTIONS(880),
    [anon_sym_Prop] = ACTIONS(858),
    [anon_sym_quote] = ACTIONS(858),
    [anon_sym_quoteTerm] = ACTIONS(858),
    [anon_sym_quoteContext] = ACTIONS(858),
    [anon_sym_unquote] = ACTIONS(858),
    [anon_sym_LPAREN_PIPE] = ACTIONS(882),
    [anon_sym_u2987] = ACTIONS(884),
    [anon_sym_let] = ACTIONS(886),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(890),
    [aux_sym_string_token1] = ACTIONS(890),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(892),
    [sym_PropN] = ACTIONS(858),
  },
  [326] = {
    [sym__FORALL] = STATE(8355),
    [sym__LAMBDA] = STATE(8054),
    [sym__ELLIPSIS] = STATE(4742),
    [sym__qid] = STATE(4742),
    [sym__binding_ids_and_absurds] = STATE(12547),
    [sym_attribute] = STATE(5830),
    [sym_attributes] = STATE(3506),
    [sym_expr] = STATE(10348),
    [sym__with_exprs] = STATE(10050),
    [sym__expr_or_attr] = STATE(4742),
    [sym__application] = STATE(9444),
    [sym__expr2_without_let] = STATE(9444),
    [sym__expr2] = STATE(9444),
    [sym_atom] = STATE(4712),
    [aux_sym__atoms] = STATE(3276),
    [sym__atom_curly] = STATE(4733),
    [sym__atom_no_curly] = STATE(4733),
    [sym_forall] = STATE(9444),
    [sym_let] = STATE(9444),
    [sym_lambda] = STATE(9444),
    [sym_lambda_extended_or_absurd] = STATE(9444),
    [sym_do] = STATE(9444),
    [sym_record_assignments] = STATE(4742),
    [sym_field_assignments] = STATE(4742),
    [aux_sym__typed_bindings] = STATE(8646),
    [sym_typed_binding] = STATE(8646),
    [sym_literal] = STATE(4742),
    [sym_SetN] = STATE(4742),
    [aux_sym__modal_arg_ids_repeat1] = STATE(5830),
    [aux_sym__with_exprs_repeat1] = STATE(3745),
    [sym_id] = ACTIONS(940),
    [anon_sym_forall] = ACTIONS(942),
    [anon_sym_u2200] = ACTIONS(942),
    [anon_sym_BSLASH] = ACTIONS(944),
    [anon_sym_u03bb] = ACTIONS(946),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(948),
    [anon_sym_u2026] = ACTIONS(948),
    [anon_sym_record] = ACTIONS(950),
    [anon_sym_LPAREN] = ACTIONS(952),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(954),
    [anon_sym_RBRACE_RBRACE] = ACTIONS(978),
    [anon_sym_u2983] = ACTIONS(956),
    [anon_sym__] = ACTIONS(948),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(958),
    [aux_sym__qid_token1] = ACTIONS(960),
    [anon_sym_DOT] = ACTIONS(962),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(712),
    [anon_sym_quoteGoal] = ACTIONS(964),
    [anon_sym_tactic] = ACTIONS(966),
    [anon_sym_Prop] = ACTIONS(948),
    [anon_sym_quote] = ACTIONS(948),
    [anon_sym_quoteTerm] = ACTIONS(948),
    [anon_sym_quoteContext] = ACTIONS(948),
    [anon_sym_unquote] = ACTIONS(948),
    [anon_sym_LPAREN_PIPE] = ACTIONS(968),
    [anon_sym_u2987] = ACTIONS(970),
    [anon_sym_let] = ACTIONS(972),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(974),
    [aux_sym_string_token1] = ACTIONS(974),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(976),
    [sym_PropN] = ACTIONS(948),
  },
  [327] = {
    [sym__FORALL] = STATE(8345),
    [sym__LAMBDA] = STATE(8095),
    [sym__ELLIPSIS] = STATE(4742),
    [sym_open] = STATE(12555),
    [sym__qid] = STATE(4742),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3873),
    [sym_expr] = STATE(10270),
    [sym__with_exprs] = STATE(10084),
    [sym__expr_or_attr] = STATE(4742),
    [sym__application] = STATE(9680),
    [sym__expr2_without_let] = STATE(9680),
    [sym__expr2] = STATE(9680),
    [sym_atom] = STATE(4712),
    [aux_sym__atoms] = STATE(3211),
    [sym__atom_curly] = STATE(4733),
    [sym__atom_no_curly] = STATE(4733),
    [sym_forall] = STATE(9680),
    [sym_let] = STATE(9680),
    [sym_lambda] = STATE(9680),
    [sym_lambda_extended_or_absurd] = STATE(9680),
    [sym_do] = STATE(9680),
    [sym_record_assignments] = STATE(4742),
    [sym_field_assignments] = STATE(4742),
    [aux_sym__typed_bindings] = STATE(8642),
    [sym_typed_binding] = STATE(8642),
    [sym_literal] = STATE(4742),
    [sym_SetN] = STATE(4742),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3728),
    [sym_id] = ACTIONS(940),
    [anon_sym_forall] = ACTIONS(980),
    [anon_sym_u2200] = ACTIONS(980),
    [anon_sym_BSLASH] = ACTIONS(982),
    [anon_sym_u03bb] = ACTIONS(984),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(948),
    [anon_sym_u2026] = ACTIONS(948),
    [anon_sym_record] = ACTIONS(950),
    [anon_sym_open] = ACTIONS(986),
    [anon_sym_LPAREN] = ACTIONS(952),
    [anon_sym_RPAREN] = ACTIONS(978),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(954),
    [anon_sym_u2983] = ACTIONS(956),
    [anon_sym__] = ACTIONS(948),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(958),
    [aux_sym__qid_token1] = ACTIONS(960),
    [anon_sym_DOT] = ACTIONS(962),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(988),
    [anon_sym_tactic] = ACTIONS(990),
    [anon_sym_Prop] = ACTIONS(948),
    [anon_sym_quote] = ACTIONS(948),
    [anon_sym_quoteTerm] = ACTIONS(948),
    [anon_sym_quoteContext] = ACTIONS(948),
    [anon_sym_unquote] = ACTIONS(948),
    [anon_sym_LPAREN_PIPE] = ACTIONS(968),
    [anon_sym_u2987] = ACTIONS(970),
    [anon_sym_let] = ACTIONS(992),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(974),
    [aux_sym_string_token1] = ACTIONS(974),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(976),
    [sym_PropN] = ACTIONS(948),
  },
  [328] = {
    [sym__FORALL] = STATE(8345),
    [sym__LAMBDA] = STATE(8095),
    [sym__ELLIPSIS] = STATE(4742),
    [sym_open] = STATE(12555),
    [sym__qid] = STATE(4742),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3873),
    [sym_expr] = STATE(11109),
    [sym__with_exprs] = STATE(10084),
    [sym__expr_or_attr] = STATE(4742),
    [sym__application] = STATE(9680),
    [sym__expr2_without_let] = STATE(9680),
    [sym__expr2] = STATE(9680),
    [sym_atom] = STATE(4712),
    [aux_sym__atoms] = STATE(3211),
    [sym__atom_curly] = STATE(4733),
    [sym__atom_no_curly] = STATE(4733),
    [sym_forall] = STATE(9680),
    [sym_let] = STATE(9680),
    [sym_lambda] = STATE(9680),
    [sym_lambda_extended_or_absurd] = STATE(9680),
    [sym_do] = STATE(9680),
    [sym_record_assignments] = STATE(4742),
    [sym_field_assignments] = STATE(4742),
    [aux_sym__typed_bindings] = STATE(8642),
    [sym_typed_binding] = STATE(8642),
    [sym_literal] = STATE(4742),
    [sym_SetN] = STATE(4742),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3728),
    [sym_id] = ACTIONS(940),
    [anon_sym_forall] = ACTIONS(980),
    [anon_sym_u2200] = ACTIONS(980),
    [anon_sym_BSLASH] = ACTIONS(982),
    [anon_sym_u03bb] = ACTIONS(984),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(948),
    [anon_sym_u2026] = ACTIONS(948),
    [anon_sym_record] = ACTIONS(950),
    [anon_sym_open] = ACTIONS(986),
    [anon_sym_LPAREN] = ACTIONS(952),
    [anon_sym_RPAREN] = ACTIONS(936),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(954),
    [anon_sym_u2983] = ACTIONS(956),
    [anon_sym__] = ACTIONS(948),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(958),
    [aux_sym__qid_token1] = ACTIONS(960),
    [anon_sym_DOT] = ACTIONS(962),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(988),
    [anon_sym_tactic] = ACTIONS(990),
    [anon_sym_Prop] = ACTIONS(948),
    [anon_sym_quote] = ACTIONS(948),
    [anon_sym_quoteTerm] = ACTIONS(948),
    [anon_sym_quoteContext] = ACTIONS(948),
    [anon_sym_unquote] = ACTIONS(948),
    [anon_sym_LPAREN_PIPE] = ACTIONS(968),
    [anon_sym_u2987] = ACTIONS(970),
    [anon_sym_let] = ACTIONS(992),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(974),
    [aux_sym_string_token1] = ACTIONS(974),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(976),
    [sym_PropN] = ACTIONS(948),
  },
  [329] = {
    [sym__FORALL] = STATE(8355),
    [sym__LAMBDA] = STATE(8054),
    [sym__ELLIPSIS] = STATE(4742),
    [sym__qid] = STATE(4742),
    [sym__binding_ids_and_absurds] = STATE(12359),
    [sym_attribute] = STATE(7725),
    [sym_attributes] = STATE(6302),
    [sym_expr] = STATE(11146),
    [sym__with_exprs] = STATE(10050),
    [sym__expr_or_attr] = STATE(4742),
    [sym__application] = STATE(9444),
    [sym__expr2_without_let] = STATE(9444),
    [sym__expr2] = STATE(9444),
    [sym_atom] = STATE(4712),
    [aux_sym__atoms] = STATE(3276),
    [sym__atom_curly] = STATE(4733),
    [sym__atom_no_curly] = STATE(4733),
    [sym_forall] = STATE(9444),
    [sym_let] = STATE(9444),
    [sym_lambda] = STATE(9444),
    [sym_lambda_extended_or_absurd] = STATE(9444),
    [sym_do] = STATE(9444),
    [sym_record_assignments] = STATE(4742),
    [sym_field_assignments] = STATE(4742),
    [aux_sym__typed_bindings] = STATE(8646),
    [sym_typed_binding] = STATE(8646),
    [sym_literal] = STATE(4742),
    [sym_SetN] = STATE(4742),
    [aux_sym__modal_arg_ids_repeat1] = STATE(7725),
    [aux_sym__with_exprs_repeat1] = STATE(3745),
    [sym_id] = ACTIONS(940),
    [anon_sym_forall] = ACTIONS(942),
    [anon_sym_u2200] = ACTIONS(942),
    [anon_sym_BSLASH] = ACTIONS(944),
    [anon_sym_u03bb] = ACTIONS(946),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(948),
    [anon_sym_u2026] = ACTIONS(948),
    [anon_sym_record] = ACTIONS(950),
    [anon_sym_LPAREN] = ACTIONS(952),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(954),
    [anon_sym_RBRACE_RBRACE] = ACTIONS(936),
    [anon_sym_u2983] = ACTIONS(956),
    [anon_sym__] = ACTIONS(948),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(958),
    [aux_sym__qid_token1] = ACTIONS(960),
    [anon_sym_DOT] = ACTIONS(962),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(760),
    [anon_sym_quoteGoal] = ACTIONS(964),
    [anon_sym_tactic] = ACTIONS(966),
    [anon_sym_Prop] = ACTIONS(948),
    [anon_sym_quote] = ACTIONS(948),
    [anon_sym_quoteTerm] = ACTIONS(948),
    [anon_sym_quoteContext] = ACTIONS(948),
    [anon_sym_unquote] = ACTIONS(948),
    [anon_sym_LPAREN_PIPE] = ACTIONS(968),
    [anon_sym_u2987] = ACTIONS(970),
    [anon_sym_let] = ACTIONS(972),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(974),
    [aux_sym_string_token1] = ACTIONS(974),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(976),
    [sym_PropN] = ACTIONS(948),
  },
  [330] = {
    [sym__FORALL] = STATE(8369),
    [sym__LAMBDA] = STATE(8152),
    [sym__ELLIPSIS] = STATE(5168),
    [sym__qid] = STATE(5168),
    [sym__binding_ids_and_absurds] = STATE(12358),
    [sym_attribute] = STATE(7725),
    [sym_attributes] = STATE(6182),
    [sym_expr] = STATE(11145),
    [sym__with_exprs] = STATE(9861),
    [sym__expr_or_attr] = STATE(5168),
    [sym__application] = STATE(9444),
    [sym__expr2_without_let] = STATE(9444),
    [sym__expr2] = STATE(9444),
    [sym_atom] = STATE(5204),
    [aux_sym__atoms] = STATE(3133),
    [sym__atom_curly] = STATE(5180),
    [sym__atom_no_curly] = STATE(5180),
    [sym_forall] = STATE(9444),
    [sym_let] = STATE(9444),
    [sym_lambda] = STATE(9444),
    [sym_lambda_extended_or_absurd] = STATE(9444),
    [sym_do] = STATE(9444),
    [sym_record_assignments] = STATE(5168),
    [sym_field_assignments] = STATE(5168),
    [aux_sym__typed_bindings] = STATE(8654),
    [sym_typed_binding] = STATE(8654),
    [sym_literal] = STATE(5168),
    [sym_SetN] = STATE(5168),
    [aux_sym__modal_arg_ids_repeat1] = STATE(7725),
    [aux_sym__with_exprs_repeat1] = STATE(3754),
    [sym_id] = ACTIONS(850),
    [anon_sym_forall] = ACTIONS(852),
    [anon_sym_u2200] = ACTIONS(852),
    [anon_sym_BSLASH] = ACTIONS(854),
    [anon_sym_u03bb] = ACTIONS(856),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(858),
    [anon_sym_u2026] = ACTIONS(858),
    [anon_sym_record] = ACTIONS(860),
    [anon_sym_LPAREN] = ACTIONS(862),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(864),
    [anon_sym_u2983] = ACTIONS(866),
    [anon_sym_u2984] = ACTIONS(936),
    [anon_sym__] = ACTIONS(858),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(870),
    [aux_sym__qid_token1] = ACTIONS(872),
    [anon_sym_DOT] = ACTIONS(874),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(760),
    [anon_sym_quoteGoal] = ACTIONS(878),
    [anon_sym_tactic] = ACTIONS(880),
    [anon_sym_Prop] = ACTIONS(858),
    [anon_sym_quote] = ACTIONS(858),
    [anon_sym_quoteTerm] = ACTIONS(858),
    [anon_sym_quoteContext] = ACTIONS(858),
    [anon_sym_unquote] = ACTIONS(858),
    [anon_sym_LPAREN_PIPE] = ACTIONS(882),
    [anon_sym_u2987] = ACTIONS(884),
    [anon_sym_let] = ACTIONS(886),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(890),
    [aux_sym_string_token1] = ACTIONS(890),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(892),
    [sym_PropN] = ACTIONS(858),
  },
  [331] = {
    [sym__FORALL] = STATE(8396),
    [sym__LAMBDA] = STATE(8031),
    [sym__ELLIPSIS] = STATE(4920),
    [sym__qid] = STATE(4920),
    [sym__binding_ids_and_absurds] = STATE(12357),
    [sym_attribute] = STATE(7725),
    [sym_attributes] = STATE(6200),
    [sym_expr] = STATE(11179),
    [sym__with_exprs] = STATE(10196),
    [sym__expr_or_attr] = STATE(4920),
    [sym__application] = STATE(9678),
    [sym__expr2_without_let] = STATE(9678),
    [sym__expr2] = STATE(9678),
    [sym_atom] = STATE(5202),
    [aux_sym__atoms] = STATE(3165),
    [sym__atom_curly] = STATE(4961),
    [sym__atom_no_curly] = STATE(4961),
    [sym_forall] = STATE(9678),
    [sym_let] = STATE(9678),
    [sym_lambda] = STATE(9678),
    [sym_lambda_extended_or_absurd] = STATE(9678),
    [sym_do] = STATE(9678),
    [sym_record_assignments] = STATE(4920),
    [sym_field_assignments] = STATE(4920),
    [aux_sym__typed_bindings] = STATE(8648),
    [sym_typed_binding] = STATE(8648),
    [sym_literal] = STATE(4920),
    [sym_SetN] = STATE(4920),
    [aux_sym__modal_arg_ids_repeat1] = STATE(7725),
    [aux_sym__with_exprs_repeat1] = STATE(3726),
    [sym_id] = ACTIONS(894),
    [anon_sym_forall] = ACTIONS(896),
    [anon_sym_u2200] = ACTIONS(896),
    [anon_sym_BSLASH] = ACTIONS(898),
    [anon_sym_u03bb] = ACTIONS(900),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(902),
    [anon_sym_u2026] = ACTIONS(902),
    [anon_sym_record] = ACTIONS(904),
    [anon_sym_LPAREN] = ACTIONS(906),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(908),
    [anon_sym_u2983] = ACTIONS(910),
    [anon_sym__] = ACTIONS(902),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(912),
    [anon_sym_RBRACE] = ACTIONS(994),
    [aux_sym__qid_token1] = ACTIONS(916),
    [anon_sym_DOT] = ACTIONS(918),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(760),
    [anon_sym_quoteGoal] = ACTIONS(920),
    [anon_sym_tactic] = ACTIONS(922),
    [anon_sym_Prop] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(902),
    [anon_sym_quoteTerm] = ACTIONS(902),
    [anon_sym_quoteContext] = ACTIONS(902),
    [anon_sym_unquote] = ACTIONS(902),
    [anon_sym_LPAREN_PIPE] = ACTIONS(924),
    [anon_sym_u2987] = ACTIONS(926),
    [anon_sym_let] = ACTIONS(928),
    [anon_sym_do] = ACTIONS(724),
    [aux_sym_integer_token1] = ACTIONS(930),
    [aux_sym_string_token1] = ACTIONS(930),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(932),
    [sym_PropN] = ACTIONS(902),
  },
  [332] = {
    [sym__FORALL] = STATE(8396),
    [sym__LAMBDA] = STATE(8031),
    [sym__ELLIPSIS] = STATE(4920),
    [sym__qid] = STATE(4920),
    [sym__binding_ids_and_absurds] = STATE(12357),
    [sym_attribute] = STATE(7725),
    [sym_attributes] = STATE(6200),
    [sym_expr] = STATE(11216),
    [sym__with_exprs] = STATE(10196),
    [sym__expr_or_attr] = STATE(4920),
    [sym__application] = STATE(9678),
    [sym__expr2_without_let] = STATE(9678),
    [sym__expr2] = STATE(9678),
    [sym_atom] = STATE(5202),
    [aux_sym__atoms] = STATE(3165),
    [sym__atom_curly] = STATE(4961),
    [sym__atom_no_curly] = STATE(4961),
    [sym_forall] = STATE(9678),
    [sym_let] = STATE(9678),
    [sym_lambda] = STATE(9678),
    [sym_lambda_extended_or_absurd] = STATE(9678),
    [sym_do] = STATE(9678),
    [sym_record_assignments] = STATE(4920),
    [sym_field_assignments] = STATE(4920),
    [aux_sym__typed_bindings] = STATE(8648),
    [sym_typed_binding] = STATE(8648),
    [sym_literal] = STATE(4920),
    [sym_SetN] = STATE(4920),
    [aux_sym__modal_arg_ids_repeat1] = STATE(7725),
    [aux_sym__with_exprs_repeat1] = STATE(3726),
    [sym_id] = ACTIONS(894),
    [anon_sym_forall] = ACTIONS(896),
    [anon_sym_u2200] = ACTIONS(896),
    [anon_sym_BSLASH] = ACTIONS(898),
    [anon_sym_u03bb] = ACTIONS(900),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(902),
    [anon_sym_u2026] = ACTIONS(902),
    [anon_sym_record] = ACTIONS(904),
    [anon_sym_LPAREN] = ACTIONS(906),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(908),
    [anon_sym_u2983] = ACTIONS(910),
    [anon_sym__] = ACTIONS(902),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(912),
    [anon_sym_RBRACE] = ACTIONS(996),
    [aux_sym__qid_token1] = ACTIONS(916),
    [anon_sym_DOT] = ACTIONS(918),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(760),
    [anon_sym_quoteGoal] = ACTIONS(920),
    [anon_sym_tactic] = ACTIONS(922),
    [anon_sym_Prop] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(902),
    [anon_sym_quoteTerm] = ACTIONS(902),
    [anon_sym_quoteContext] = ACTIONS(902),
    [anon_sym_unquote] = ACTIONS(902),
    [anon_sym_LPAREN_PIPE] = ACTIONS(924),
    [anon_sym_u2987] = ACTIONS(926),
    [anon_sym_let] = ACTIONS(928),
    [anon_sym_do] = ACTIONS(724),
    [aux_sym_integer_token1] = ACTIONS(930),
    [aux_sym_string_token1] = ACTIONS(930),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(932),
    [sym_PropN] = ACTIONS(902),
  },
  [333] = {
    [sym__FORALL] = STATE(8369),
    [sym__LAMBDA] = STATE(8152),
    [sym__ELLIPSIS] = STATE(5168),
    [sym__qid] = STATE(5168),
    [sym__binding_ids_and_absurds] = STATE(12358),
    [sym_attribute] = STATE(7725),
    [sym_attributes] = STATE(6182),
    [sym_expr] = STATE(11180),
    [sym__with_exprs] = STATE(9861),
    [sym__expr_or_attr] = STATE(5168),
    [sym__application] = STATE(9444),
    [sym__expr2_without_let] = STATE(9444),
    [sym__expr2] = STATE(9444),
    [sym_atom] = STATE(5204),
    [aux_sym__atoms] = STATE(3133),
    [sym__atom_curly] = STATE(5180),
    [sym__atom_no_curly] = STATE(5180),
    [sym_forall] = STATE(9444),
    [sym_let] = STATE(9444),
    [sym_lambda] = STATE(9444),
    [sym_lambda_extended_or_absurd] = STATE(9444),
    [sym_do] = STATE(9444),
    [sym_record_assignments] = STATE(5168),
    [sym_field_assignments] = STATE(5168),
    [aux_sym__typed_bindings] = STATE(8654),
    [sym_typed_binding] = STATE(8654),
    [sym_literal] = STATE(5168),
    [sym_SetN] = STATE(5168),
    [aux_sym__modal_arg_ids_repeat1] = STATE(7725),
    [aux_sym__with_exprs_repeat1] = STATE(3754),
    [sym_id] = ACTIONS(850),
    [anon_sym_forall] = ACTIONS(852),
    [anon_sym_u2200] = ACTIONS(852),
    [anon_sym_BSLASH] = ACTIONS(854),
    [anon_sym_u03bb] = ACTIONS(856),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(858),
    [anon_sym_u2026] = ACTIONS(858),
    [anon_sym_record] = ACTIONS(860),
    [anon_sym_LPAREN] = ACTIONS(862),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(864),
    [anon_sym_u2983] = ACTIONS(866),
    [anon_sym_u2984] = ACTIONS(998),
    [anon_sym__] = ACTIONS(858),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(870),
    [aux_sym__qid_token1] = ACTIONS(872),
    [anon_sym_DOT] = ACTIONS(874),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(760),
    [anon_sym_quoteGoal] = ACTIONS(878),
    [anon_sym_tactic] = ACTIONS(880),
    [anon_sym_Prop] = ACTIONS(858),
    [anon_sym_quote] = ACTIONS(858),
    [anon_sym_quoteTerm] = ACTIONS(858),
    [anon_sym_quoteContext] = ACTIONS(858),
    [anon_sym_unquote] = ACTIONS(858),
    [anon_sym_LPAREN_PIPE] = ACTIONS(882),
    [anon_sym_u2987] = ACTIONS(884),
    [anon_sym_let] = ACTIONS(886),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(890),
    [aux_sym_string_token1] = ACTIONS(890),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(892),
    [sym_PropN] = ACTIONS(858),
  },
  [334] = {
    [sym__FORALL] = STATE(8355),
    [sym__LAMBDA] = STATE(8054),
    [sym__ELLIPSIS] = STATE(4742),
    [sym__qid] = STATE(4742),
    [sym__binding_ids_and_absurds] = STATE(12359),
    [sym_attribute] = STATE(7725),
    [sym_attributes] = STATE(6302),
    [sym_expr] = STATE(11181),
    [sym__with_exprs] = STATE(10050),
    [sym__expr_or_attr] = STATE(4742),
    [sym__application] = STATE(9444),
    [sym__expr2_without_let] = STATE(9444),
    [sym__expr2] = STATE(9444),
    [sym_atom] = STATE(4712),
    [aux_sym__atoms] = STATE(3276),
    [sym__atom_curly] = STATE(4733),
    [sym__atom_no_curly] = STATE(4733),
    [sym_forall] = STATE(9444),
    [sym_let] = STATE(9444),
    [sym_lambda] = STATE(9444),
    [sym_lambda_extended_or_absurd] = STATE(9444),
    [sym_do] = STATE(9444),
    [sym_record_assignments] = STATE(4742),
    [sym_field_assignments] = STATE(4742),
    [aux_sym__typed_bindings] = STATE(8646),
    [sym_typed_binding] = STATE(8646),
    [sym_literal] = STATE(4742),
    [sym_SetN] = STATE(4742),
    [aux_sym__modal_arg_ids_repeat1] = STATE(7725),
    [aux_sym__with_exprs_repeat1] = STATE(3745),
    [sym_id] = ACTIONS(940),
    [anon_sym_forall] = ACTIONS(942),
    [anon_sym_u2200] = ACTIONS(942),
    [anon_sym_BSLASH] = ACTIONS(944),
    [anon_sym_u03bb] = ACTIONS(946),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(948),
    [anon_sym_u2026] = ACTIONS(948),
    [anon_sym_record] = ACTIONS(950),
    [anon_sym_LPAREN] = ACTIONS(952),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(954),
    [anon_sym_RBRACE_RBRACE] = ACTIONS(998),
    [anon_sym_u2983] = ACTIONS(956),
    [anon_sym__] = ACTIONS(948),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(958),
    [aux_sym__qid_token1] = ACTIONS(960),
    [anon_sym_DOT] = ACTIONS(962),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(760),
    [anon_sym_quoteGoal] = ACTIONS(964),
    [anon_sym_tactic] = ACTIONS(966),
    [anon_sym_Prop] = ACTIONS(948),
    [anon_sym_quote] = ACTIONS(948),
    [anon_sym_quoteTerm] = ACTIONS(948),
    [anon_sym_quoteContext] = ACTIONS(948),
    [anon_sym_unquote] = ACTIONS(948),
    [anon_sym_LPAREN_PIPE] = ACTIONS(968),
    [anon_sym_u2987] = ACTIONS(970),
    [anon_sym_let] = ACTIONS(972),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(974),
    [aux_sym_string_token1] = ACTIONS(974),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(976),
    [sym_PropN] = ACTIONS(948),
  },
  [335] = {
    [sym__FORALL] = STATE(8396),
    [sym__LAMBDA] = STATE(8031),
    [sym__ELLIPSIS] = STATE(4920),
    [sym__qid] = STATE(4920),
    [sym__binding_ids_and_absurds] = STATE(12539),
    [sym_attribute] = STATE(5830),
    [sym_attributes] = STATE(3504),
    [sym_expr] = STATE(11216),
    [sym__with_exprs] = STATE(10196),
    [sym__expr_or_attr] = STATE(4920),
    [sym__application] = STATE(9678),
    [sym__expr2_without_let] = STATE(9678),
    [sym__expr2] = STATE(9678),
    [sym_atom] = STATE(5202),
    [aux_sym__atoms] = STATE(3165),
    [sym__atom_curly] = STATE(4961),
    [sym__atom_no_curly] = STATE(4961),
    [sym_forall] = STATE(9678),
    [sym_let] = STATE(9678),
    [sym_lambda] = STATE(9678),
    [sym_lambda_extended_or_absurd] = STATE(9678),
    [sym_do] = STATE(9678),
    [sym_record_assignments] = STATE(4920),
    [sym_field_assignments] = STATE(4920),
    [aux_sym__typed_bindings] = STATE(8648),
    [sym_typed_binding] = STATE(8648),
    [sym_literal] = STATE(4920),
    [sym_SetN] = STATE(4920),
    [aux_sym__modal_arg_ids_repeat1] = STATE(5830),
    [aux_sym__with_exprs_repeat1] = STATE(3726),
    [sym_id] = ACTIONS(894),
    [anon_sym_forall] = ACTIONS(896),
    [anon_sym_u2200] = ACTIONS(896),
    [anon_sym_BSLASH] = ACTIONS(898),
    [anon_sym_u03bb] = ACTIONS(900),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(902),
    [anon_sym_u2026] = ACTIONS(902),
    [anon_sym_record] = ACTIONS(904),
    [anon_sym_LPAREN] = ACTIONS(906),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(908),
    [anon_sym_u2983] = ACTIONS(910),
    [anon_sym__] = ACTIONS(902),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(912),
    [anon_sym_RBRACE] = ACTIONS(996),
    [aux_sym__qid_token1] = ACTIONS(916),
    [anon_sym_DOT] = ACTIONS(918),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(712),
    [anon_sym_quoteGoal] = ACTIONS(920),
    [anon_sym_tactic] = ACTIONS(922),
    [anon_sym_Prop] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(902),
    [anon_sym_quoteTerm] = ACTIONS(902),
    [anon_sym_quoteContext] = ACTIONS(902),
    [anon_sym_unquote] = ACTIONS(902),
    [anon_sym_LPAREN_PIPE] = ACTIONS(924),
    [anon_sym_u2987] = ACTIONS(926),
    [anon_sym_let] = ACTIONS(928),
    [anon_sym_do] = ACTIONS(724),
    [aux_sym_integer_token1] = ACTIONS(930),
    [aux_sym_string_token1] = ACTIONS(930),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(932),
    [sym_PropN] = ACTIONS(902),
  },
  [336] = {
    [sym__FORALL] = STATE(8369),
    [sym__LAMBDA] = STATE(8152),
    [sym__ELLIPSIS] = STATE(5168),
    [sym__qid] = STATE(5168),
    [sym__binding_ids_and_absurds] = STATE(12544),
    [sym_attribute] = STATE(5830),
    [sym_attributes] = STATE(3505),
    [sym_expr] = STATE(11180),
    [sym__with_exprs] = STATE(9861),
    [sym__expr_or_attr] = STATE(5168),
    [sym__application] = STATE(9444),
    [sym__expr2_without_let] = STATE(9444),
    [sym__expr2] = STATE(9444),
    [sym_atom] = STATE(5204),
    [aux_sym__atoms] = STATE(3133),
    [sym__atom_curly] = STATE(5180),
    [sym__atom_no_curly] = STATE(5180),
    [sym_forall] = STATE(9444),
    [sym_let] = STATE(9444),
    [sym_lambda] = STATE(9444),
    [sym_lambda_extended_or_absurd] = STATE(9444),
    [sym_do] = STATE(9444),
    [sym_record_assignments] = STATE(5168),
    [sym_field_assignments] = STATE(5168),
    [aux_sym__typed_bindings] = STATE(8654),
    [sym_typed_binding] = STATE(8654),
    [sym_literal] = STATE(5168),
    [sym_SetN] = STATE(5168),
    [aux_sym__modal_arg_ids_repeat1] = STATE(5830),
    [aux_sym__with_exprs_repeat1] = STATE(3754),
    [sym_id] = ACTIONS(850),
    [anon_sym_forall] = ACTIONS(852),
    [anon_sym_u2200] = ACTIONS(852),
    [anon_sym_BSLASH] = ACTIONS(854),
    [anon_sym_u03bb] = ACTIONS(856),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(858),
    [anon_sym_u2026] = ACTIONS(858),
    [anon_sym_record] = ACTIONS(860),
    [anon_sym_LPAREN] = ACTIONS(862),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(864),
    [anon_sym_u2983] = ACTIONS(866),
    [anon_sym_u2984] = ACTIONS(998),
    [anon_sym__] = ACTIONS(858),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(870),
    [aux_sym__qid_token1] = ACTIONS(872),
    [anon_sym_DOT] = ACTIONS(874),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(712),
    [anon_sym_quoteGoal] = ACTIONS(878),
    [anon_sym_tactic] = ACTIONS(880),
    [anon_sym_Prop] = ACTIONS(858),
    [anon_sym_quote] = ACTIONS(858),
    [anon_sym_quoteTerm] = ACTIONS(858),
    [anon_sym_quoteContext] = ACTIONS(858),
    [anon_sym_unquote] = ACTIONS(858),
    [anon_sym_LPAREN_PIPE] = ACTIONS(882),
    [anon_sym_u2987] = ACTIONS(884),
    [anon_sym_let] = ACTIONS(886),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(890),
    [aux_sym_string_token1] = ACTIONS(890),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(892),
    [sym_PropN] = ACTIONS(858),
  },
  [337] = {
    [sym__FORALL] = STATE(8345),
    [sym__LAMBDA] = STATE(8095),
    [sym__ELLIPSIS] = STATE(4742),
    [sym_open] = STATE(12555),
    [sym__qid] = STATE(4742),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3873),
    [sym_expr] = STATE(12484),
    [sym__with_exprs] = STATE(10084),
    [sym__expr_or_attr] = STATE(4742),
    [sym__application] = STATE(9680),
    [sym__expr2_without_let] = STATE(9680),
    [sym__expr2] = STATE(9680),
    [sym_atom] = STATE(4712),
    [aux_sym__atoms] = STATE(3211),
    [sym__atom_curly] = STATE(4733),
    [sym__atom_no_curly] = STATE(4733),
    [sym_forall] = STATE(9680),
    [sym_let] = STATE(9680),
    [sym_lambda] = STATE(9680),
    [sym_lambda_extended_or_absurd] = STATE(9680),
    [sym_do] = STATE(9680),
    [sym_record_assignments] = STATE(4742),
    [sym_field_assignments] = STATE(4742),
    [aux_sym__typed_bindings] = STATE(8642),
    [sym_typed_binding] = STATE(8642),
    [sym_literal] = STATE(4742),
    [sym_SetN] = STATE(4742),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3728),
    [sym_id] = ACTIONS(940),
    [anon_sym_forall] = ACTIONS(980),
    [anon_sym_u2200] = ACTIONS(980),
    [anon_sym_BSLASH] = ACTIONS(982),
    [anon_sym_u03bb] = ACTIONS(984),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(948),
    [anon_sym_u2026] = ACTIONS(948),
    [anon_sym_record] = ACTIONS(950),
    [anon_sym_open] = ACTIONS(986),
    [anon_sym_LPAREN] = ACTIONS(952),
    [anon_sym_RPAREN] = ACTIONS(868),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(954),
    [anon_sym_u2983] = ACTIONS(956),
    [anon_sym__] = ACTIONS(948),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(958),
    [aux_sym__qid_token1] = ACTIONS(960),
    [anon_sym_DOT] = ACTIONS(962),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(988),
    [anon_sym_tactic] = ACTIONS(990),
    [anon_sym_Prop] = ACTIONS(948),
    [anon_sym_quote] = ACTIONS(948),
    [anon_sym_quoteTerm] = ACTIONS(948),
    [anon_sym_quoteContext] = ACTIONS(948),
    [anon_sym_unquote] = ACTIONS(948),
    [anon_sym_LPAREN_PIPE] = ACTIONS(968),
    [anon_sym_u2987] = ACTIONS(970),
    [anon_sym_let] = ACTIONS(992),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(974),
    [aux_sym_string_token1] = ACTIONS(974),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(976),
    [sym_PropN] = ACTIONS(948),
  },
  [338] = {
    [sym__FORALL] = STATE(8355),
    [sym__LAMBDA] = STATE(8054),
    [sym__ELLIPSIS] = STATE(4742),
    [sym__qid] = STATE(4742),
    [sym__binding_ids_and_absurds] = STATE(12547),
    [sym_attribute] = STATE(5830),
    [sym_attributes] = STATE(3506),
    [sym_expr] = STATE(12558),
    [sym__with_exprs] = STATE(10050),
    [sym__expr_or_attr] = STATE(4742),
    [sym__application] = STATE(9444),
    [sym__expr2_without_let] = STATE(9444),
    [sym__expr2] = STATE(9444),
    [sym_atom] = STATE(4712),
    [aux_sym__atoms] = STATE(3276),
    [sym__atom_curly] = STATE(4733),
    [sym__atom_no_curly] = STATE(4733),
    [sym_forall] = STATE(9444),
    [sym_let] = STATE(9444),
    [sym_lambda] = STATE(9444),
    [sym_lambda_extended_or_absurd] = STATE(9444),
    [sym_do] = STATE(9444),
    [sym_record_assignments] = STATE(4742),
    [sym_field_assignments] = STATE(4742),
    [aux_sym__typed_bindings] = STATE(8646),
    [sym_typed_binding] = STATE(8646),
    [sym_literal] = STATE(4742),
    [sym_SetN] = STATE(4742),
    [aux_sym__modal_arg_ids_repeat1] = STATE(5830),
    [aux_sym__with_exprs_repeat1] = STATE(3745),
    [sym_id] = ACTIONS(940),
    [anon_sym_forall] = ACTIONS(942),
    [anon_sym_u2200] = ACTIONS(942),
    [anon_sym_BSLASH] = ACTIONS(944),
    [anon_sym_u03bb] = ACTIONS(946),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(948),
    [anon_sym_u2026] = ACTIONS(948),
    [anon_sym_record] = ACTIONS(950),
    [anon_sym_LPAREN] = ACTIONS(952),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(954),
    [anon_sym_RBRACE_RBRACE] = ACTIONS(868),
    [anon_sym_u2983] = ACTIONS(956),
    [anon_sym__] = ACTIONS(948),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(958),
    [aux_sym__qid_token1] = ACTIONS(960),
    [anon_sym_DOT] = ACTIONS(962),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(712),
    [anon_sym_quoteGoal] = ACTIONS(964),
    [anon_sym_tactic] = ACTIONS(966),
    [anon_sym_Prop] = ACTIONS(948),
    [anon_sym_quote] = ACTIONS(948),
    [anon_sym_quoteTerm] = ACTIONS(948),
    [anon_sym_quoteContext] = ACTIONS(948),
    [anon_sym_unquote] = ACTIONS(948),
    [anon_sym_LPAREN_PIPE] = ACTIONS(968),
    [anon_sym_u2987] = ACTIONS(970),
    [anon_sym_let] = ACTIONS(972),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(974),
    [aux_sym_string_token1] = ACTIONS(974),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(976),
    [sym_PropN] = ACTIONS(948),
  },
  [339] = {
    [sym__FORALL] = STATE(8369),
    [sym__LAMBDA] = STATE(8152),
    [sym__ELLIPSIS] = STATE(5168),
    [sym__qid] = STATE(5168),
    [sym__binding_ids_and_absurds] = STATE(12544),
    [sym_attribute] = STATE(5830),
    [sym_attributes] = STATE(3505),
    [sym_expr] = STATE(12557),
    [sym__with_exprs] = STATE(9861),
    [sym__expr_or_attr] = STATE(5168),
    [sym__application] = STATE(9444),
    [sym__expr2_without_let] = STATE(9444),
    [sym__expr2] = STATE(9444),
    [sym_atom] = STATE(5204),
    [aux_sym__atoms] = STATE(3133),
    [sym__atom_curly] = STATE(5180),
    [sym__atom_no_curly] = STATE(5180),
    [sym_forall] = STATE(9444),
    [sym_let] = STATE(9444),
    [sym_lambda] = STATE(9444),
    [sym_lambda_extended_or_absurd] = STATE(9444),
    [sym_do] = STATE(9444),
    [sym_record_assignments] = STATE(5168),
    [sym_field_assignments] = STATE(5168),
    [aux_sym__typed_bindings] = STATE(8654),
    [sym_typed_binding] = STATE(8654),
    [sym_literal] = STATE(5168),
    [sym_SetN] = STATE(5168),
    [aux_sym__modal_arg_ids_repeat1] = STATE(5830),
    [aux_sym__with_exprs_repeat1] = STATE(3754),
    [sym_id] = ACTIONS(850),
    [anon_sym_forall] = ACTIONS(852),
    [anon_sym_u2200] = ACTIONS(852),
    [anon_sym_BSLASH] = ACTIONS(854),
    [anon_sym_u03bb] = ACTIONS(856),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(858),
    [anon_sym_u2026] = ACTIONS(858),
    [anon_sym_record] = ACTIONS(860),
    [anon_sym_LPAREN] = ACTIONS(862),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(864),
    [anon_sym_u2983] = ACTIONS(866),
    [anon_sym_u2984] = ACTIONS(868),
    [anon_sym__] = ACTIONS(858),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(870),
    [aux_sym__qid_token1] = ACTIONS(872),
    [anon_sym_DOT] = ACTIONS(874),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(712),
    [anon_sym_quoteGoal] = ACTIONS(878),
    [anon_sym_tactic] = ACTIONS(880),
    [anon_sym_Prop] = ACTIONS(858),
    [anon_sym_quote] = ACTIONS(858),
    [anon_sym_quoteTerm] = ACTIONS(858),
    [anon_sym_quoteContext] = ACTIONS(858),
    [anon_sym_unquote] = ACTIONS(858),
    [anon_sym_LPAREN_PIPE] = ACTIONS(882),
    [anon_sym_u2987] = ACTIONS(884),
    [anon_sym_let] = ACTIONS(886),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(890),
    [aux_sym_string_token1] = ACTIONS(890),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(892),
    [sym_PropN] = ACTIONS(858),
  },
  [340] = {
    [sym__FORALL] = STATE(8355),
    [sym__LAMBDA] = STATE(8054),
    [sym__ELLIPSIS] = STATE(4742),
    [sym__qid] = STATE(4742),
    [sym__binding_ids_and_absurds] = STATE(12547),
    [sym_attribute] = STATE(5830),
    [sym_attributes] = STATE(3506),
    [sym_expr] = STATE(11181),
    [sym__with_exprs] = STATE(10050),
    [sym__expr_or_attr] = STATE(4742),
    [sym__application] = STATE(9444),
    [sym__expr2_without_let] = STATE(9444),
    [sym__expr2] = STATE(9444),
    [sym_atom] = STATE(4712),
    [aux_sym__atoms] = STATE(3276),
    [sym__atom_curly] = STATE(4733),
    [sym__atom_no_curly] = STATE(4733),
    [sym_forall] = STATE(9444),
    [sym_let] = STATE(9444),
    [sym_lambda] = STATE(9444),
    [sym_lambda_extended_or_absurd] = STATE(9444),
    [sym_do] = STATE(9444),
    [sym_record_assignments] = STATE(4742),
    [sym_field_assignments] = STATE(4742),
    [aux_sym__typed_bindings] = STATE(8646),
    [sym_typed_binding] = STATE(8646),
    [sym_literal] = STATE(4742),
    [sym_SetN] = STATE(4742),
    [aux_sym__modal_arg_ids_repeat1] = STATE(5830),
    [aux_sym__with_exprs_repeat1] = STATE(3745),
    [sym_id] = ACTIONS(940),
    [anon_sym_forall] = ACTIONS(942),
    [anon_sym_u2200] = ACTIONS(942),
    [anon_sym_BSLASH] = ACTIONS(944),
    [anon_sym_u03bb] = ACTIONS(946),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(948),
    [anon_sym_u2026] = ACTIONS(948),
    [anon_sym_record] = ACTIONS(950),
    [anon_sym_LPAREN] = ACTIONS(952),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(954),
    [anon_sym_RBRACE_RBRACE] = ACTIONS(998),
    [anon_sym_u2983] = ACTIONS(956),
    [anon_sym__] = ACTIONS(948),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(958),
    [aux_sym__qid_token1] = ACTIONS(960),
    [anon_sym_DOT] = ACTIONS(962),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(712),
    [anon_sym_quoteGoal] = ACTIONS(964),
    [anon_sym_tactic] = ACTIONS(966),
    [anon_sym_Prop] = ACTIONS(948),
    [anon_sym_quote] = ACTIONS(948),
    [anon_sym_quoteTerm] = ACTIONS(948),
    [anon_sym_quoteContext] = ACTIONS(948),
    [anon_sym_unquote] = ACTIONS(948),
    [anon_sym_LPAREN_PIPE] = ACTIONS(968),
    [anon_sym_u2987] = ACTIONS(970),
    [anon_sym_let] = ACTIONS(972),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(974),
    [aux_sym_string_token1] = ACTIONS(974),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(976),
    [sym_PropN] = ACTIONS(948),
  },
  [341] = {
    [sym__FORALL] = STATE(8345),
    [sym__LAMBDA] = STATE(8095),
    [sym__ELLIPSIS] = STATE(4742),
    [sym_open] = STATE(12555),
    [sym__qid] = STATE(4742),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3873),
    [sym_expr] = STATE(11147),
    [sym__with_exprs] = STATE(10084),
    [sym__expr_or_attr] = STATE(4742),
    [sym__application] = STATE(9680),
    [sym__expr2_without_let] = STATE(9680),
    [sym__expr2] = STATE(9680),
    [sym_atom] = STATE(4712),
    [aux_sym__atoms] = STATE(3211),
    [sym__atom_curly] = STATE(4733),
    [sym__atom_no_curly] = STATE(4733),
    [sym_forall] = STATE(9680),
    [sym_let] = STATE(9680),
    [sym_lambda] = STATE(9680),
    [sym_lambda_extended_or_absurd] = STATE(9680),
    [sym_do] = STATE(9680),
    [sym_record_assignments] = STATE(4742),
    [sym_field_assignments] = STATE(4742),
    [aux_sym__typed_bindings] = STATE(8642),
    [sym_typed_binding] = STATE(8642),
    [sym_literal] = STATE(4742),
    [sym_SetN] = STATE(4742),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3728),
    [sym_id] = ACTIONS(940),
    [anon_sym_forall] = ACTIONS(980),
    [anon_sym_u2200] = ACTIONS(980),
    [anon_sym_BSLASH] = ACTIONS(982),
    [anon_sym_u03bb] = ACTIONS(984),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(948),
    [anon_sym_u2026] = ACTIONS(948),
    [anon_sym_record] = ACTIONS(950),
    [anon_sym_open] = ACTIONS(986),
    [anon_sym_LPAREN] = ACTIONS(952),
    [anon_sym_RPAREN] = ACTIONS(998),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(954),
    [anon_sym_u2983] = ACTIONS(956),
    [anon_sym__] = ACTIONS(948),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(958),
    [aux_sym__qid_token1] = ACTIONS(960),
    [anon_sym_DOT] = ACTIONS(962),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(988),
    [anon_sym_tactic] = ACTIONS(990),
    [anon_sym_Prop] = ACTIONS(948),
    [anon_sym_quote] = ACTIONS(948),
    [anon_sym_quoteTerm] = ACTIONS(948),
    [anon_sym_quoteContext] = ACTIONS(948),
    [anon_sym_unquote] = ACTIONS(948),
    [anon_sym_LPAREN_PIPE] = ACTIONS(968),
    [anon_sym_u2987] = ACTIONS(970),
    [anon_sym_let] = ACTIONS(992),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(974),
    [aux_sym_string_token1] = ACTIONS(974),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(976),
    [sym_PropN] = ACTIONS(948),
  },
  [342] = {
    [sym__FORALL] = STATE(8396),
    [sym__LAMBDA] = STATE(8031),
    [sym__ELLIPSIS] = STATE(4920),
    [sym__qid] = STATE(4920),
    [sym__binding_ids_and_absurds] = STATE(12539),
    [sym_attribute] = STATE(5830),
    [sym_attributes] = STATE(3504),
    [sym_expr] = STATE(12556),
    [sym__with_exprs] = STATE(10196),
    [sym__expr_or_attr] = STATE(4920),
    [sym__application] = STATE(9678),
    [sym__expr2_without_let] = STATE(9678),
    [sym__expr2] = STATE(9678),
    [sym_atom] = STATE(5202),
    [aux_sym__atoms] = STATE(3165),
    [sym__atom_curly] = STATE(4961),
    [sym__atom_no_curly] = STATE(4961),
    [sym_forall] = STATE(9678),
    [sym_let] = STATE(9678),
    [sym_lambda] = STATE(9678),
    [sym_lambda_extended_or_absurd] = STATE(9678),
    [sym_do] = STATE(9678),
    [sym_record_assignments] = STATE(4920),
    [sym_field_assignments] = STATE(4920),
    [aux_sym__typed_bindings] = STATE(8648),
    [sym_typed_binding] = STATE(8648),
    [sym_literal] = STATE(4920),
    [sym_SetN] = STATE(4920),
    [aux_sym__modal_arg_ids_repeat1] = STATE(5830),
    [aux_sym__with_exprs_repeat1] = STATE(3726),
    [sym_id] = ACTIONS(894),
    [anon_sym_forall] = ACTIONS(896),
    [anon_sym_u2200] = ACTIONS(896),
    [anon_sym_BSLASH] = ACTIONS(898),
    [anon_sym_u03bb] = ACTIONS(900),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(902),
    [anon_sym_u2026] = ACTIONS(902),
    [anon_sym_record] = ACTIONS(904),
    [anon_sym_LPAREN] = ACTIONS(906),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(908),
    [anon_sym_u2983] = ACTIONS(910),
    [anon_sym__] = ACTIONS(902),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(912),
    [anon_sym_RBRACE] = ACTIONS(1000),
    [aux_sym__qid_token1] = ACTIONS(916),
    [anon_sym_DOT] = ACTIONS(918),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(712),
    [anon_sym_quoteGoal] = ACTIONS(920),
    [anon_sym_tactic] = ACTIONS(922),
    [anon_sym_Prop] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(902),
    [anon_sym_quoteTerm] = ACTIONS(902),
    [anon_sym_quoteContext] = ACTIONS(902),
    [anon_sym_unquote] = ACTIONS(902),
    [anon_sym_LPAREN_PIPE] = ACTIONS(924),
    [anon_sym_u2987] = ACTIONS(926),
    [anon_sym_let] = ACTIONS(928),
    [anon_sym_do] = ACTIONS(724),
    [aux_sym_integer_token1] = ACTIONS(930),
    [aux_sym_string_token1] = ACTIONS(930),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(932),
    [sym_PropN] = ACTIONS(902),
  },
  [343] = {
    [sym__FORALL] = STATE(8345),
    [sym__LAMBDA] = STATE(8095),
    [sym__ELLIPSIS] = STATE(4742),
    [sym_open] = STATE(12555),
    [sym__qid] = STATE(4742),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3873),
    [sym_expr] = STATE(12675),
    [sym__with_exprs] = STATE(10084),
    [sym__expr_or_attr] = STATE(4742),
    [sym__application] = STATE(9680),
    [sym__expr2_without_let] = STATE(9680),
    [sym__expr2] = STATE(9680),
    [sym_atom] = STATE(4712),
    [aux_sym__atoms] = STATE(3211),
    [sym__atom_curly] = STATE(4733),
    [sym__atom_no_curly] = STATE(4733),
    [sym_forall] = STATE(9680),
    [sym_let] = STATE(9680),
    [sym_lambda] = STATE(9680),
    [sym_lambda_extended_or_absurd] = STATE(9680),
    [sym_do] = STATE(9680),
    [sym_record_assignments] = STATE(4742),
    [sym_field_assignments] = STATE(4742),
    [aux_sym__typed_bindings] = STATE(8642),
    [sym_typed_binding] = STATE(8642),
    [sym_literal] = STATE(4742),
    [sym_SetN] = STATE(4742),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3728),
    [sym_id] = ACTIONS(940),
    [anon_sym_forall] = ACTIONS(980),
    [anon_sym_u2200] = ACTIONS(980),
    [anon_sym_BSLASH] = ACTIONS(982),
    [anon_sym_u03bb] = ACTIONS(984),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(948),
    [anon_sym_u2026] = ACTIONS(948),
    [anon_sym_record] = ACTIONS(950),
    [anon_sym_open] = ACTIONS(986),
    [anon_sym_LPAREN] = ACTIONS(952),
    [anon_sym_RPAREN] = ACTIONS(1002),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(954),
    [anon_sym_u2983] = ACTIONS(956),
    [anon_sym__] = ACTIONS(948),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(958),
    [aux_sym__qid_token1] = ACTIONS(960),
    [anon_sym_DOT] = ACTIONS(962),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(988),
    [anon_sym_tactic] = ACTIONS(990),
    [anon_sym_Prop] = ACTIONS(948),
    [anon_sym_quote] = ACTIONS(948),
    [anon_sym_quoteTerm] = ACTIONS(948),
    [anon_sym_quoteContext] = ACTIONS(948),
    [anon_sym_unquote] = ACTIONS(948),
    [anon_sym_LPAREN_PIPE] = ACTIONS(968),
    [anon_sym_u2987] = ACTIONS(970),
    [anon_sym_let] = ACTIONS(992),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(974),
    [aux_sym_string_token1] = ACTIONS(974),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(976),
    [sym_PropN] = ACTIONS(948),
  },
  [344] = {
    [sym__FORALL] = STATE(8355),
    [sym__LAMBDA] = STATE(8054),
    [sym__ELLIPSIS] = STATE(4742),
    [sym__qid] = STATE(4742),
    [sym__binding_ids_and_absurds] = STATE(12547),
    [sym_attribute] = STATE(5830),
    [sym_attributes] = STATE(3506),
    [sym_expr] = STATE(12746),
    [sym__with_exprs] = STATE(10050),
    [sym__expr_or_attr] = STATE(4742),
    [sym__application] = STATE(9444),
    [sym__expr2_without_let] = STATE(9444),
    [sym__expr2] = STATE(9444),
    [sym_atom] = STATE(4712),
    [aux_sym__atoms] = STATE(3276),
    [sym__atom_curly] = STATE(4733),
    [sym__atom_no_curly] = STATE(4733),
    [sym_forall] = STATE(9444),
    [sym_let] = STATE(9444),
    [sym_lambda] = STATE(9444),
    [sym_lambda_extended_or_absurd] = STATE(9444),
    [sym_do] = STATE(9444),
    [sym_record_assignments] = STATE(4742),
    [sym_field_assignments] = STATE(4742),
    [aux_sym__typed_bindings] = STATE(8646),
    [sym_typed_binding] = STATE(8646),
    [sym_literal] = STATE(4742),
    [sym_SetN] = STATE(4742),
    [aux_sym__modal_arg_ids_repeat1] = STATE(5830),
    [aux_sym__with_exprs_repeat1] = STATE(3745),
    [sym_id] = ACTIONS(940),
    [anon_sym_forall] = ACTIONS(942),
    [anon_sym_u2200] = ACTIONS(942),
    [anon_sym_BSLASH] = ACTIONS(944),
    [anon_sym_u03bb] = ACTIONS(946),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(948),
    [anon_sym_u2026] = ACTIONS(948),
    [anon_sym_record] = ACTIONS(950),
    [anon_sym_LPAREN] = ACTIONS(952),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(954),
    [anon_sym_RBRACE_RBRACE] = ACTIONS(1002),
    [anon_sym_u2983] = ACTIONS(956),
    [anon_sym__] = ACTIONS(948),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(958),
    [aux_sym__qid_token1] = ACTIONS(960),
    [anon_sym_DOT] = ACTIONS(962),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(712),
    [anon_sym_quoteGoal] = ACTIONS(964),
    [anon_sym_tactic] = ACTIONS(966),
    [anon_sym_Prop] = ACTIONS(948),
    [anon_sym_quote] = ACTIONS(948),
    [anon_sym_quoteTerm] = ACTIONS(948),
    [anon_sym_quoteContext] = ACTIONS(948),
    [anon_sym_unquote] = ACTIONS(948),
    [anon_sym_LPAREN_PIPE] = ACTIONS(968),
    [anon_sym_u2987] = ACTIONS(970),
    [anon_sym_let] = ACTIONS(972),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(974),
    [aux_sym_string_token1] = ACTIONS(974),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(976),
    [sym_PropN] = ACTIONS(948),
  },
  [345] = {
    [sym__FORALL] = STATE(8369),
    [sym__LAMBDA] = STATE(8152),
    [sym__ELLIPSIS] = STATE(5168),
    [sym__qid] = STATE(5168),
    [sym__binding_ids_and_absurds] = STATE(12544),
    [sym_attribute] = STATE(5830),
    [sym_attributes] = STATE(3505),
    [sym_expr] = STATE(12745),
    [sym__with_exprs] = STATE(9861),
    [sym__expr_or_attr] = STATE(5168),
    [sym__application] = STATE(9444),
    [sym__expr2_without_let] = STATE(9444),
    [sym__expr2] = STATE(9444),
    [sym_atom] = STATE(5204),
    [aux_sym__atoms] = STATE(3133),
    [sym__atom_curly] = STATE(5180),
    [sym__atom_no_curly] = STATE(5180),
    [sym_forall] = STATE(9444),
    [sym_let] = STATE(9444),
    [sym_lambda] = STATE(9444),
    [sym_lambda_extended_or_absurd] = STATE(9444),
    [sym_do] = STATE(9444),
    [sym_record_assignments] = STATE(5168),
    [sym_field_assignments] = STATE(5168),
    [aux_sym__typed_bindings] = STATE(8654),
    [sym_typed_binding] = STATE(8654),
    [sym_literal] = STATE(5168),
    [sym_SetN] = STATE(5168),
    [aux_sym__modal_arg_ids_repeat1] = STATE(5830),
    [aux_sym__with_exprs_repeat1] = STATE(3754),
    [sym_id] = ACTIONS(850),
    [anon_sym_forall] = ACTIONS(852),
    [anon_sym_u2200] = ACTIONS(852),
    [anon_sym_BSLASH] = ACTIONS(854),
    [anon_sym_u03bb] = ACTIONS(856),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(858),
    [anon_sym_u2026] = ACTIONS(858),
    [anon_sym_record] = ACTIONS(860),
    [anon_sym_LPAREN] = ACTIONS(862),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(864),
    [anon_sym_u2983] = ACTIONS(866),
    [anon_sym_u2984] = ACTIONS(1002),
    [anon_sym__] = ACTIONS(858),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(870),
    [aux_sym__qid_token1] = ACTIONS(872),
    [anon_sym_DOT] = ACTIONS(874),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(712),
    [anon_sym_quoteGoal] = ACTIONS(878),
    [anon_sym_tactic] = ACTIONS(880),
    [anon_sym_Prop] = ACTIONS(858),
    [anon_sym_quote] = ACTIONS(858),
    [anon_sym_quoteTerm] = ACTIONS(858),
    [anon_sym_quoteContext] = ACTIONS(858),
    [anon_sym_unquote] = ACTIONS(858),
    [anon_sym_LPAREN_PIPE] = ACTIONS(882),
    [anon_sym_u2987] = ACTIONS(884),
    [anon_sym_let] = ACTIONS(886),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(890),
    [aux_sym_string_token1] = ACTIONS(890),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(892),
    [sym_PropN] = ACTIONS(858),
  },
  [346] = {
    [sym__FORALL] = STATE(8396),
    [sym__LAMBDA] = STATE(8031),
    [sym__ELLIPSIS] = STATE(4920),
    [sym__qid] = STATE(4920),
    [sym__binding_ids_and_absurds] = STATE(12539),
    [sym_attribute] = STATE(5830),
    [sym_attributes] = STATE(3504),
    [sym_expr] = STATE(12743),
    [sym__with_exprs] = STATE(10196),
    [sym__expr_or_attr] = STATE(4920),
    [sym__application] = STATE(9678),
    [sym__expr2_without_let] = STATE(9678),
    [sym__expr2] = STATE(9678),
    [sym_atom] = STATE(5202),
    [aux_sym__atoms] = STATE(3165),
    [sym__atom_curly] = STATE(4961),
    [sym__atom_no_curly] = STATE(4961),
    [sym_forall] = STATE(9678),
    [sym_let] = STATE(9678),
    [sym_lambda] = STATE(9678),
    [sym_lambda_extended_or_absurd] = STATE(9678),
    [sym_do] = STATE(9678),
    [sym_record_assignments] = STATE(4920),
    [sym_field_assignments] = STATE(4920),
    [aux_sym__typed_bindings] = STATE(8648),
    [sym_typed_binding] = STATE(8648),
    [sym_literal] = STATE(4920),
    [sym_SetN] = STATE(4920),
    [aux_sym__modal_arg_ids_repeat1] = STATE(5830),
    [aux_sym__with_exprs_repeat1] = STATE(3726),
    [sym_id] = ACTIONS(894),
    [anon_sym_forall] = ACTIONS(896),
    [anon_sym_u2200] = ACTIONS(896),
    [anon_sym_BSLASH] = ACTIONS(898),
    [anon_sym_u03bb] = ACTIONS(900),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(902),
    [anon_sym_u2026] = ACTIONS(902),
    [anon_sym_record] = ACTIONS(904),
    [anon_sym_LPAREN] = ACTIONS(906),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(908),
    [anon_sym_u2983] = ACTIONS(910),
    [anon_sym__] = ACTIONS(902),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(912),
    [anon_sym_RBRACE] = ACTIONS(1004),
    [aux_sym__qid_token1] = ACTIONS(916),
    [anon_sym_DOT] = ACTIONS(918),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(712),
    [anon_sym_quoteGoal] = ACTIONS(920),
    [anon_sym_tactic] = ACTIONS(922),
    [anon_sym_Prop] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(902),
    [anon_sym_quoteTerm] = ACTIONS(902),
    [anon_sym_quoteContext] = ACTIONS(902),
    [anon_sym_unquote] = ACTIONS(902),
    [anon_sym_LPAREN_PIPE] = ACTIONS(924),
    [anon_sym_u2987] = ACTIONS(926),
    [anon_sym_let] = ACTIONS(928),
    [anon_sym_do] = ACTIONS(724),
    [aux_sym_integer_token1] = ACTIONS(930),
    [aux_sym_string_token1] = ACTIONS(930),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(932),
    [sym_PropN] = ACTIONS(902),
  },
  [347] = {
    [sym__FORALL] = STATE(8396),
    [sym__LAMBDA] = STATE(8031),
    [sym__ELLIPSIS] = STATE(4920),
    [sym__qid] = STATE(4920),
    [sym__binding_ids_and_absurds] = STATE(12357),
    [sym_attribute] = STATE(7725),
    [sym_attributes] = STATE(6200),
    [sym_expr] = STATE(11358),
    [sym__with_exprs] = STATE(10196),
    [sym__expr_or_attr] = STATE(4920),
    [sym__application] = STATE(9678),
    [sym__expr2_without_let] = STATE(9678),
    [sym__expr2] = STATE(9678),
    [sym_atom] = STATE(5202),
    [aux_sym__atoms] = STATE(3165),
    [sym__atom_curly] = STATE(4961),
    [sym__atom_no_curly] = STATE(4961),
    [sym_forall] = STATE(9678),
    [sym_let] = STATE(9678),
    [sym_lambda] = STATE(9678),
    [sym_lambda_extended_or_absurd] = STATE(9678),
    [sym_do] = STATE(9678),
    [sym_record_assignments] = STATE(4920),
    [sym_field_assignments] = STATE(4920),
    [aux_sym__typed_bindings] = STATE(8648),
    [sym_typed_binding] = STATE(8648),
    [sym_literal] = STATE(4920),
    [sym_SetN] = STATE(4920),
    [aux_sym__modal_arg_ids_repeat1] = STATE(7725),
    [aux_sym__with_exprs_repeat1] = STATE(3726),
    [sym_id] = ACTIONS(894),
    [anon_sym_forall] = ACTIONS(896),
    [anon_sym_u2200] = ACTIONS(896),
    [anon_sym_BSLASH] = ACTIONS(898),
    [anon_sym_u03bb] = ACTIONS(900),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(902),
    [anon_sym_u2026] = ACTIONS(902),
    [anon_sym_record] = ACTIONS(904),
    [anon_sym_LPAREN] = ACTIONS(906),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(908),
    [anon_sym_u2983] = ACTIONS(910),
    [anon_sym__] = ACTIONS(902),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(912),
    [anon_sym_RBRACE] = ACTIONS(1006),
    [aux_sym__qid_token1] = ACTIONS(916),
    [anon_sym_DOT] = ACTIONS(918),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(760),
    [anon_sym_quoteGoal] = ACTIONS(920),
    [anon_sym_tactic] = ACTIONS(922),
    [anon_sym_Prop] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(902),
    [anon_sym_quoteTerm] = ACTIONS(902),
    [anon_sym_quoteContext] = ACTIONS(902),
    [anon_sym_unquote] = ACTIONS(902),
    [anon_sym_LPAREN_PIPE] = ACTIONS(924),
    [anon_sym_u2987] = ACTIONS(926),
    [anon_sym_let] = ACTIONS(928),
    [anon_sym_do] = ACTIONS(724),
    [aux_sym_integer_token1] = ACTIONS(930),
    [aux_sym_string_token1] = ACTIONS(930),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(932),
    [sym_PropN] = ACTIONS(902),
  },
  [348] = {
    [sym__FORALL] = STATE(8369),
    [sym__LAMBDA] = STATE(8152),
    [sym__ELLIPSIS] = STATE(5168),
    [sym__qid] = STATE(5168),
    [sym__binding_ids_and_absurds] = STATE(12358),
    [sym_attribute] = STATE(7725),
    [sym_attributes] = STATE(6182),
    [sym_expr] = STATE(11325),
    [sym__with_exprs] = STATE(9861),
    [sym__expr_or_attr] = STATE(5168),
    [sym__application] = STATE(9444),
    [sym__expr2_without_let] = STATE(9444),
    [sym__expr2] = STATE(9444),
    [sym_atom] = STATE(5204),
    [aux_sym__atoms] = STATE(3133),
    [sym__atom_curly] = STATE(5180),
    [sym__atom_no_curly] = STATE(5180),
    [sym_forall] = STATE(9444),
    [sym_let] = STATE(9444),
    [sym_lambda] = STATE(9444),
    [sym_lambda_extended_or_absurd] = STATE(9444),
    [sym_do] = STATE(9444),
    [sym_record_assignments] = STATE(5168),
    [sym_field_assignments] = STATE(5168),
    [aux_sym__typed_bindings] = STATE(8654),
    [sym_typed_binding] = STATE(8654),
    [sym_literal] = STATE(5168),
    [sym_SetN] = STATE(5168),
    [aux_sym__modal_arg_ids_repeat1] = STATE(7725),
    [aux_sym__with_exprs_repeat1] = STATE(3754),
    [sym_id] = ACTIONS(850),
    [anon_sym_forall] = ACTIONS(852),
    [anon_sym_u2200] = ACTIONS(852),
    [anon_sym_BSLASH] = ACTIONS(854),
    [anon_sym_u03bb] = ACTIONS(856),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(858),
    [anon_sym_u2026] = ACTIONS(858),
    [anon_sym_record] = ACTIONS(860),
    [anon_sym_LPAREN] = ACTIONS(862),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(864),
    [anon_sym_u2983] = ACTIONS(866),
    [anon_sym_u2984] = ACTIONS(1008),
    [anon_sym__] = ACTIONS(858),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(870),
    [aux_sym__qid_token1] = ACTIONS(872),
    [anon_sym_DOT] = ACTIONS(874),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(760),
    [anon_sym_quoteGoal] = ACTIONS(878),
    [anon_sym_tactic] = ACTIONS(880),
    [anon_sym_Prop] = ACTIONS(858),
    [anon_sym_quote] = ACTIONS(858),
    [anon_sym_quoteTerm] = ACTIONS(858),
    [anon_sym_quoteContext] = ACTIONS(858),
    [anon_sym_unquote] = ACTIONS(858),
    [anon_sym_LPAREN_PIPE] = ACTIONS(882),
    [anon_sym_u2987] = ACTIONS(884),
    [anon_sym_let] = ACTIONS(886),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(890),
    [aux_sym_string_token1] = ACTIONS(890),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(892),
    [sym_PropN] = ACTIONS(858),
  },
  [349] = {
    [sym__FORALL] = STATE(8355),
    [sym__LAMBDA] = STATE(8054),
    [sym__ELLIPSIS] = STATE(4742),
    [sym__qid] = STATE(4742),
    [sym__binding_ids_and_absurds] = STATE(12359),
    [sym_attribute] = STATE(7725),
    [sym_attributes] = STATE(6302),
    [sym_expr] = STATE(12558),
    [sym__with_exprs] = STATE(10050),
    [sym__expr_or_attr] = STATE(4742),
    [sym__application] = STATE(9444),
    [sym__expr2_without_let] = STATE(9444),
    [sym__expr2] = STATE(9444),
    [sym_atom] = STATE(4712),
    [aux_sym__atoms] = STATE(3276),
    [sym__atom_curly] = STATE(4733),
    [sym__atom_no_curly] = STATE(4733),
    [sym_forall] = STATE(9444),
    [sym_let] = STATE(9444),
    [sym_lambda] = STATE(9444),
    [sym_lambda_extended_or_absurd] = STATE(9444),
    [sym_do] = STATE(9444),
    [sym_record_assignments] = STATE(4742),
    [sym_field_assignments] = STATE(4742),
    [aux_sym__typed_bindings] = STATE(8646),
    [sym_typed_binding] = STATE(8646),
    [sym_literal] = STATE(4742),
    [sym_SetN] = STATE(4742),
    [aux_sym__modal_arg_ids_repeat1] = STATE(7725),
    [aux_sym__with_exprs_repeat1] = STATE(3745),
    [sym_id] = ACTIONS(940),
    [anon_sym_forall] = ACTIONS(942),
    [anon_sym_u2200] = ACTIONS(942),
    [anon_sym_BSLASH] = ACTIONS(944),
    [anon_sym_u03bb] = ACTIONS(946),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(948),
    [anon_sym_u2026] = ACTIONS(948),
    [anon_sym_record] = ACTIONS(950),
    [anon_sym_LPAREN] = ACTIONS(952),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(954),
    [anon_sym_RBRACE_RBRACE] = ACTIONS(868),
    [anon_sym_u2983] = ACTIONS(956),
    [anon_sym__] = ACTIONS(948),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(958),
    [aux_sym__qid_token1] = ACTIONS(960),
    [anon_sym_DOT] = ACTIONS(962),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(760),
    [anon_sym_quoteGoal] = ACTIONS(964),
    [anon_sym_tactic] = ACTIONS(966),
    [anon_sym_Prop] = ACTIONS(948),
    [anon_sym_quote] = ACTIONS(948),
    [anon_sym_quoteTerm] = ACTIONS(948),
    [anon_sym_quoteContext] = ACTIONS(948),
    [anon_sym_unquote] = ACTIONS(948),
    [anon_sym_LPAREN_PIPE] = ACTIONS(968),
    [anon_sym_u2987] = ACTIONS(970),
    [anon_sym_let] = ACTIONS(972),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(974),
    [aux_sym_string_token1] = ACTIONS(974),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(976),
    [sym_PropN] = ACTIONS(948),
  },
  [350] = {
    [sym__FORALL] = STATE(8396),
    [sym__LAMBDA] = STATE(8031),
    [sym__ELLIPSIS] = STATE(4920),
    [sym__qid] = STATE(4920),
    [sym__binding_ids_and_absurds] = STATE(12539),
    [sym_attribute] = STATE(5830),
    [sym_attributes] = STATE(3504),
    [sym_expr] = STATE(11179),
    [sym__with_exprs] = STATE(10196),
    [sym__expr_or_attr] = STATE(4920),
    [sym__application] = STATE(9678),
    [sym__expr2_without_let] = STATE(9678),
    [sym__expr2] = STATE(9678),
    [sym_atom] = STATE(5202),
    [aux_sym__atoms] = STATE(3165),
    [sym__atom_curly] = STATE(4961),
    [sym__atom_no_curly] = STATE(4961),
    [sym_forall] = STATE(9678),
    [sym_let] = STATE(9678),
    [sym_lambda] = STATE(9678),
    [sym_lambda_extended_or_absurd] = STATE(9678),
    [sym_do] = STATE(9678),
    [sym_record_assignments] = STATE(4920),
    [sym_field_assignments] = STATE(4920),
    [aux_sym__typed_bindings] = STATE(8648),
    [sym_typed_binding] = STATE(8648),
    [sym_literal] = STATE(4920),
    [sym_SetN] = STATE(4920),
    [aux_sym__modal_arg_ids_repeat1] = STATE(5830),
    [aux_sym__with_exprs_repeat1] = STATE(3726),
    [sym_id] = ACTIONS(894),
    [anon_sym_forall] = ACTIONS(896),
    [anon_sym_u2200] = ACTIONS(896),
    [anon_sym_BSLASH] = ACTIONS(898),
    [anon_sym_u03bb] = ACTIONS(900),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(902),
    [anon_sym_u2026] = ACTIONS(902),
    [anon_sym_record] = ACTIONS(904),
    [anon_sym_LPAREN] = ACTIONS(906),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(908),
    [anon_sym_u2983] = ACTIONS(910),
    [anon_sym__] = ACTIONS(902),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(912),
    [anon_sym_RBRACE] = ACTIONS(994),
    [aux_sym__qid_token1] = ACTIONS(916),
    [anon_sym_DOT] = ACTIONS(918),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(712),
    [anon_sym_quoteGoal] = ACTIONS(920),
    [anon_sym_tactic] = ACTIONS(922),
    [anon_sym_Prop] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(902),
    [anon_sym_quoteTerm] = ACTIONS(902),
    [anon_sym_quoteContext] = ACTIONS(902),
    [anon_sym_unquote] = ACTIONS(902),
    [anon_sym_LPAREN_PIPE] = ACTIONS(924),
    [anon_sym_u2987] = ACTIONS(926),
    [anon_sym_let] = ACTIONS(928),
    [anon_sym_do] = ACTIONS(724),
    [aux_sym_integer_token1] = ACTIONS(930),
    [aux_sym_string_token1] = ACTIONS(930),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(932),
    [sym_PropN] = ACTIONS(902),
  },
  [351] = {
    [sym__FORALL] = STATE(8396),
    [sym__LAMBDA] = STATE(8031),
    [sym__ELLIPSIS] = STATE(4920),
    [sym__qid] = STATE(4920),
    [sym__binding_ids_and_absurds] = STATE(12357),
    [sym_attribute] = STATE(7725),
    [sym_attributes] = STATE(6200),
    [sym_expr] = STATE(12556),
    [sym__with_exprs] = STATE(10196),
    [sym__expr_or_attr] = STATE(4920),
    [sym__application] = STATE(9678),
    [sym__expr2_without_let] = STATE(9678),
    [sym__expr2] = STATE(9678),
    [sym_atom] = STATE(5202),
    [aux_sym__atoms] = STATE(3165),
    [sym__atom_curly] = STATE(4961),
    [sym__atom_no_curly] = STATE(4961),
    [sym_forall] = STATE(9678),
    [sym_let] = STATE(9678),
    [sym_lambda] = STATE(9678),
    [sym_lambda_extended_or_absurd] = STATE(9678),
    [sym_do] = STATE(9678),
    [sym_record_assignments] = STATE(4920),
    [sym_field_assignments] = STATE(4920),
    [aux_sym__typed_bindings] = STATE(8648),
    [sym_typed_binding] = STATE(8648),
    [sym_literal] = STATE(4920),
    [sym_SetN] = STATE(4920),
    [aux_sym__modal_arg_ids_repeat1] = STATE(7725),
    [aux_sym__with_exprs_repeat1] = STATE(3726),
    [sym_id] = ACTIONS(894),
    [anon_sym_forall] = ACTIONS(896),
    [anon_sym_u2200] = ACTIONS(896),
    [anon_sym_BSLASH] = ACTIONS(898),
    [anon_sym_u03bb] = ACTIONS(900),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(902),
    [anon_sym_u2026] = ACTIONS(902),
    [anon_sym_record] = ACTIONS(904),
    [anon_sym_LPAREN] = ACTIONS(906),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(908),
    [anon_sym_u2983] = ACTIONS(910),
    [anon_sym__] = ACTIONS(902),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(912),
    [anon_sym_RBRACE] = ACTIONS(1000),
    [aux_sym__qid_token1] = ACTIONS(916),
    [anon_sym_DOT] = ACTIONS(918),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(760),
    [anon_sym_quoteGoal] = ACTIONS(920),
    [anon_sym_tactic] = ACTIONS(922),
    [anon_sym_Prop] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(902),
    [anon_sym_quoteTerm] = ACTIONS(902),
    [anon_sym_quoteContext] = ACTIONS(902),
    [anon_sym_unquote] = ACTIONS(902),
    [anon_sym_LPAREN_PIPE] = ACTIONS(924),
    [anon_sym_u2987] = ACTIONS(926),
    [anon_sym_let] = ACTIONS(928),
    [anon_sym_do] = ACTIONS(724),
    [aux_sym_integer_token1] = ACTIONS(930),
    [aux_sym_string_token1] = ACTIONS(930),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(932),
    [sym_PropN] = ACTIONS(902),
  },
  [352] = {
    [sym__FORALL] = STATE(8355),
    [sym__LAMBDA] = STATE(8054),
    [sym__ELLIPSIS] = STATE(4742),
    [sym__qid] = STATE(4742),
    [sym__binding_ids_and_absurds] = STATE(12359),
    [sym_attribute] = STATE(7725),
    [sym_attributes] = STATE(6302),
    [sym_expr] = STATE(11326),
    [sym__with_exprs] = STATE(10050),
    [sym__expr_or_attr] = STATE(4742),
    [sym__application] = STATE(9444),
    [sym__expr2_without_let] = STATE(9444),
    [sym__expr2] = STATE(9444),
    [sym_atom] = STATE(4712),
    [aux_sym__atoms] = STATE(3276),
    [sym__atom_curly] = STATE(4733),
    [sym__atom_no_curly] = STATE(4733),
    [sym_forall] = STATE(9444),
    [sym_let] = STATE(9444),
    [sym_lambda] = STATE(9444),
    [sym_lambda_extended_or_absurd] = STATE(9444),
    [sym_do] = STATE(9444),
    [sym_record_assignments] = STATE(4742),
    [sym_field_assignments] = STATE(4742),
    [aux_sym__typed_bindings] = STATE(8646),
    [sym_typed_binding] = STATE(8646),
    [sym_literal] = STATE(4742),
    [sym_SetN] = STATE(4742),
    [aux_sym__modal_arg_ids_repeat1] = STATE(7725),
    [aux_sym__with_exprs_repeat1] = STATE(3745),
    [sym_id] = ACTIONS(940),
    [anon_sym_forall] = ACTIONS(942),
    [anon_sym_u2200] = ACTIONS(942),
    [anon_sym_BSLASH] = ACTIONS(944),
    [anon_sym_u03bb] = ACTIONS(946),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(948),
    [anon_sym_u2026] = ACTIONS(948),
    [anon_sym_record] = ACTIONS(950),
    [anon_sym_LPAREN] = ACTIONS(952),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(954),
    [anon_sym_RBRACE_RBRACE] = ACTIONS(1008),
    [anon_sym_u2983] = ACTIONS(956),
    [anon_sym__] = ACTIONS(948),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(958),
    [aux_sym__qid_token1] = ACTIONS(960),
    [anon_sym_DOT] = ACTIONS(962),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(760),
    [anon_sym_quoteGoal] = ACTIONS(964),
    [anon_sym_tactic] = ACTIONS(966),
    [anon_sym_Prop] = ACTIONS(948),
    [anon_sym_quote] = ACTIONS(948),
    [anon_sym_quoteTerm] = ACTIONS(948),
    [anon_sym_quoteContext] = ACTIONS(948),
    [anon_sym_unquote] = ACTIONS(948),
    [anon_sym_LPAREN_PIPE] = ACTIONS(968),
    [anon_sym_u2987] = ACTIONS(970),
    [anon_sym_let] = ACTIONS(972),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(974),
    [aux_sym_string_token1] = ACTIONS(974),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(976),
    [sym_PropN] = ACTIONS(948),
  },
  [353] = {
    [sym__FORALL] = STATE(8345),
    [sym__LAMBDA] = STATE(8095),
    [sym__ELLIPSIS] = STATE(4742),
    [sym_open] = STATE(12555),
    [sym__qid] = STATE(4742),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3873),
    [sym_expr] = STATE(12485),
    [sym__with_exprs] = STATE(10084),
    [sym__expr_or_attr] = STATE(4742),
    [sym__application] = STATE(9680),
    [sym__expr2_without_let] = STATE(9680),
    [sym__expr2] = STATE(9680),
    [sym_atom] = STATE(4712),
    [aux_sym__atoms] = STATE(3211),
    [sym__atom_curly] = STATE(4733),
    [sym__atom_no_curly] = STATE(4733),
    [sym_forall] = STATE(9680),
    [sym_let] = STATE(9680),
    [sym_lambda] = STATE(9680),
    [sym_lambda_extended_or_absurd] = STATE(9680),
    [sym_do] = STATE(9680),
    [sym_record_assignments] = STATE(4742),
    [sym_field_assignments] = STATE(4742),
    [aux_sym__typed_bindings] = STATE(8642),
    [sym_typed_binding] = STATE(8642),
    [sym_literal] = STATE(4742),
    [sym_SetN] = STATE(4742),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3728),
    [sym_id] = ACTIONS(940),
    [anon_sym_forall] = ACTIONS(980),
    [anon_sym_u2200] = ACTIONS(980),
    [anon_sym_BSLASH] = ACTIONS(982),
    [anon_sym_u03bb] = ACTIONS(984),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(948),
    [anon_sym_u2026] = ACTIONS(948),
    [anon_sym_record] = ACTIONS(950),
    [anon_sym_open] = ACTIONS(986),
    [anon_sym_LPAREN] = ACTIONS(952),
    [anon_sym_RPAREN] = ACTIONS(1010),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(954),
    [anon_sym_u2983] = ACTIONS(956),
    [anon_sym__] = ACTIONS(948),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(958),
    [aux_sym__qid_token1] = ACTIONS(960),
    [anon_sym_DOT] = ACTIONS(962),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(988),
    [anon_sym_tactic] = ACTIONS(990),
    [anon_sym_Prop] = ACTIONS(948),
    [anon_sym_quote] = ACTIONS(948),
    [anon_sym_quoteTerm] = ACTIONS(948),
    [anon_sym_quoteContext] = ACTIONS(948),
    [anon_sym_unquote] = ACTIONS(948),
    [anon_sym_LPAREN_PIPE] = ACTIONS(968),
    [anon_sym_u2987] = ACTIONS(970),
    [anon_sym_let] = ACTIONS(992),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(974),
    [aux_sym_string_token1] = ACTIONS(974),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(976),
    [sym_PropN] = ACTIONS(948),
  },
  [354] = {
    [sym__FORALL] = STATE(8369),
    [sym__LAMBDA] = STATE(8152),
    [sym__ELLIPSIS] = STATE(5168),
    [sym__qid] = STATE(5168),
    [sym__binding_ids_and_absurds] = STATE(12358),
    [sym_attribute] = STATE(7725),
    [sym_attributes] = STATE(6182),
    [sym_expr] = STATE(12745),
    [sym__with_exprs] = STATE(9861),
    [sym__expr_or_attr] = STATE(5168),
    [sym__application] = STATE(9444),
    [sym__expr2_without_let] = STATE(9444),
    [sym__expr2] = STATE(9444),
    [sym_atom] = STATE(5204),
    [aux_sym__atoms] = STATE(3133),
    [sym__atom_curly] = STATE(5180),
    [sym__atom_no_curly] = STATE(5180),
    [sym_forall] = STATE(9444),
    [sym_let] = STATE(9444),
    [sym_lambda] = STATE(9444),
    [sym_lambda_extended_or_absurd] = STATE(9444),
    [sym_do] = STATE(9444),
    [sym_record_assignments] = STATE(5168),
    [sym_field_assignments] = STATE(5168),
    [aux_sym__typed_bindings] = STATE(8654),
    [sym_typed_binding] = STATE(8654),
    [sym_literal] = STATE(5168),
    [sym_SetN] = STATE(5168),
    [aux_sym__modal_arg_ids_repeat1] = STATE(7725),
    [aux_sym__with_exprs_repeat1] = STATE(3754),
    [sym_id] = ACTIONS(850),
    [anon_sym_forall] = ACTIONS(852),
    [anon_sym_u2200] = ACTIONS(852),
    [anon_sym_BSLASH] = ACTIONS(854),
    [anon_sym_u03bb] = ACTIONS(856),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(858),
    [anon_sym_u2026] = ACTIONS(858),
    [anon_sym_record] = ACTIONS(860),
    [anon_sym_LPAREN] = ACTIONS(862),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(864),
    [anon_sym_u2983] = ACTIONS(866),
    [anon_sym_u2984] = ACTIONS(1002),
    [anon_sym__] = ACTIONS(858),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(870),
    [aux_sym__qid_token1] = ACTIONS(872),
    [anon_sym_DOT] = ACTIONS(874),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(760),
    [anon_sym_quoteGoal] = ACTIONS(878),
    [anon_sym_tactic] = ACTIONS(880),
    [anon_sym_Prop] = ACTIONS(858),
    [anon_sym_quote] = ACTIONS(858),
    [anon_sym_quoteTerm] = ACTIONS(858),
    [anon_sym_quoteContext] = ACTIONS(858),
    [anon_sym_unquote] = ACTIONS(858),
    [anon_sym_LPAREN_PIPE] = ACTIONS(882),
    [anon_sym_u2987] = ACTIONS(884),
    [anon_sym_let] = ACTIONS(886),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(890),
    [aux_sym_string_token1] = ACTIONS(890),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(892),
    [sym_PropN] = ACTIONS(858),
  },
  [355] = {
    [sym__FORALL] = STATE(8355),
    [sym__LAMBDA] = STATE(8054),
    [sym__ELLIPSIS] = STATE(4742),
    [sym__qid] = STATE(4742),
    [sym__binding_ids_and_absurds] = STATE(12547),
    [sym_attribute] = STATE(5830),
    [sym_attributes] = STATE(3506),
    [sym_expr] = STATE(12356),
    [sym__with_exprs] = STATE(10050),
    [sym__expr_or_attr] = STATE(4742),
    [sym__application] = STATE(9444),
    [sym__expr2_without_let] = STATE(9444),
    [sym__expr2] = STATE(9444),
    [sym_atom] = STATE(4712),
    [aux_sym__atoms] = STATE(3276),
    [sym__atom_curly] = STATE(4733),
    [sym__atom_no_curly] = STATE(4733),
    [sym_forall] = STATE(9444),
    [sym_let] = STATE(9444),
    [sym_lambda] = STATE(9444),
    [sym_lambda_extended_or_absurd] = STATE(9444),
    [sym_do] = STATE(9444),
    [sym_record_assignments] = STATE(4742),
    [sym_field_assignments] = STATE(4742),
    [aux_sym__typed_bindings] = STATE(8646),
    [sym_typed_binding] = STATE(8646),
    [sym_literal] = STATE(4742),
    [sym_SetN] = STATE(4742),
    [aux_sym__modal_arg_ids_repeat1] = STATE(5830),
    [aux_sym__with_exprs_repeat1] = STATE(3745),
    [sym_id] = ACTIONS(940),
    [anon_sym_forall] = ACTIONS(942),
    [anon_sym_u2200] = ACTIONS(942),
    [anon_sym_BSLASH] = ACTIONS(944),
    [anon_sym_u03bb] = ACTIONS(946),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(948),
    [anon_sym_u2026] = ACTIONS(948),
    [anon_sym_record] = ACTIONS(950),
    [anon_sym_LPAREN] = ACTIONS(952),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(954),
    [anon_sym_RBRACE_RBRACE] = ACTIONS(1010),
    [anon_sym_u2983] = ACTIONS(956),
    [anon_sym__] = ACTIONS(948),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(958),
    [aux_sym__qid_token1] = ACTIONS(960),
    [anon_sym_DOT] = ACTIONS(962),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(712),
    [anon_sym_quoteGoal] = ACTIONS(964),
    [anon_sym_tactic] = ACTIONS(966),
    [anon_sym_Prop] = ACTIONS(948),
    [anon_sym_quote] = ACTIONS(948),
    [anon_sym_quoteTerm] = ACTIONS(948),
    [anon_sym_quoteContext] = ACTIONS(948),
    [anon_sym_unquote] = ACTIONS(948),
    [anon_sym_LPAREN_PIPE] = ACTIONS(968),
    [anon_sym_u2987] = ACTIONS(970),
    [anon_sym_let] = ACTIONS(972),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(974),
    [aux_sym_string_token1] = ACTIONS(974),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(976),
    [sym_PropN] = ACTIONS(948),
  },
  [356] = {
    [sym__FORALL] = STATE(8369),
    [sym__LAMBDA] = STATE(8152),
    [sym__ELLIPSIS] = STATE(5168),
    [sym__qid] = STATE(5168),
    [sym__binding_ids_and_absurds] = STATE(12544),
    [sym_attribute] = STATE(5830),
    [sym_attributes] = STATE(3505),
    [sym_expr] = STATE(12360),
    [sym__with_exprs] = STATE(9861),
    [sym__expr_or_attr] = STATE(5168),
    [sym__application] = STATE(9444),
    [sym__expr2_without_let] = STATE(9444),
    [sym__expr2] = STATE(9444),
    [sym_atom] = STATE(5204),
    [aux_sym__atoms] = STATE(3133),
    [sym__atom_curly] = STATE(5180),
    [sym__atom_no_curly] = STATE(5180),
    [sym_forall] = STATE(9444),
    [sym_let] = STATE(9444),
    [sym_lambda] = STATE(9444),
    [sym_lambda_extended_or_absurd] = STATE(9444),
    [sym_do] = STATE(9444),
    [sym_record_assignments] = STATE(5168),
    [sym_field_assignments] = STATE(5168),
    [aux_sym__typed_bindings] = STATE(8654),
    [sym_typed_binding] = STATE(8654),
    [sym_literal] = STATE(5168),
    [sym_SetN] = STATE(5168),
    [aux_sym__modal_arg_ids_repeat1] = STATE(5830),
    [aux_sym__with_exprs_repeat1] = STATE(3754),
    [sym_id] = ACTIONS(850),
    [anon_sym_forall] = ACTIONS(852),
    [anon_sym_u2200] = ACTIONS(852),
    [anon_sym_BSLASH] = ACTIONS(854),
    [anon_sym_u03bb] = ACTIONS(856),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(858),
    [anon_sym_u2026] = ACTIONS(858),
    [anon_sym_record] = ACTIONS(860),
    [anon_sym_LPAREN] = ACTIONS(862),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(864),
    [anon_sym_u2983] = ACTIONS(866),
    [anon_sym_u2984] = ACTIONS(1010),
    [anon_sym__] = ACTIONS(858),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(870),
    [aux_sym__qid_token1] = ACTIONS(872),
    [anon_sym_DOT] = ACTIONS(874),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(712),
    [anon_sym_quoteGoal] = ACTIONS(878),
    [anon_sym_tactic] = ACTIONS(880),
    [anon_sym_Prop] = ACTIONS(858),
    [anon_sym_quote] = ACTIONS(858),
    [anon_sym_quoteTerm] = ACTIONS(858),
    [anon_sym_quoteContext] = ACTIONS(858),
    [anon_sym_unquote] = ACTIONS(858),
    [anon_sym_LPAREN_PIPE] = ACTIONS(882),
    [anon_sym_u2987] = ACTIONS(884),
    [anon_sym_let] = ACTIONS(886),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(890),
    [aux_sym_string_token1] = ACTIONS(890),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(892),
    [sym_PropN] = ACTIONS(858),
  },
  [357] = {
    [sym__FORALL] = STATE(8396),
    [sym__LAMBDA] = STATE(8031),
    [sym__ELLIPSIS] = STATE(4920),
    [sym__qid] = STATE(4920),
    [sym__binding_ids_and_absurds] = STATE(12357),
    [sym_attribute] = STATE(7725),
    [sym_attributes] = STATE(6200),
    [sym_expr] = STATE(12042),
    [sym__with_exprs] = STATE(10196),
    [sym__expr_or_attr] = STATE(4920),
    [sym__application] = STATE(9678),
    [sym__expr2_without_let] = STATE(9678),
    [sym__expr2] = STATE(9678),
    [sym_atom] = STATE(5202),
    [aux_sym__atoms] = STATE(3165),
    [sym__atom_curly] = STATE(4961),
    [sym__atom_no_curly] = STATE(4961),
    [sym_forall] = STATE(9678),
    [sym_let] = STATE(9678),
    [sym_lambda] = STATE(9678),
    [sym_lambda_extended_or_absurd] = STATE(9678),
    [sym_do] = STATE(9678),
    [sym_record_assignments] = STATE(4920),
    [sym_field_assignments] = STATE(4920),
    [aux_sym__typed_bindings] = STATE(8648),
    [sym_typed_binding] = STATE(8648),
    [sym_literal] = STATE(4920),
    [sym_SetN] = STATE(4920),
    [aux_sym__modal_arg_ids_repeat1] = STATE(7725),
    [aux_sym__with_exprs_repeat1] = STATE(3726),
    [sym_id] = ACTIONS(894),
    [anon_sym_forall] = ACTIONS(896),
    [anon_sym_u2200] = ACTIONS(896),
    [anon_sym_BSLASH] = ACTIONS(898),
    [anon_sym_u03bb] = ACTIONS(900),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(902),
    [anon_sym_u2026] = ACTIONS(902),
    [anon_sym_record] = ACTIONS(904),
    [anon_sym_LPAREN] = ACTIONS(906),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(908),
    [anon_sym_u2983] = ACTIONS(910),
    [anon_sym__] = ACTIONS(902),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(912),
    [anon_sym_RBRACE] = ACTIONS(1012),
    [aux_sym__qid_token1] = ACTIONS(916),
    [anon_sym_DOT] = ACTIONS(918),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(760),
    [anon_sym_quoteGoal] = ACTIONS(920),
    [anon_sym_tactic] = ACTIONS(922),
    [anon_sym_Prop] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(902),
    [anon_sym_quoteTerm] = ACTIONS(902),
    [anon_sym_quoteContext] = ACTIONS(902),
    [anon_sym_unquote] = ACTIONS(902),
    [anon_sym_LPAREN_PIPE] = ACTIONS(924),
    [anon_sym_u2987] = ACTIONS(926),
    [anon_sym_let] = ACTIONS(928),
    [anon_sym_do] = ACTIONS(724),
    [aux_sym_integer_token1] = ACTIONS(930),
    [aux_sym_string_token1] = ACTIONS(930),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(932),
    [sym_PropN] = ACTIONS(902),
  },
  [358] = {
    [sym__FORALL] = STATE(8396),
    [sym__LAMBDA] = STATE(8031),
    [sym__ELLIPSIS] = STATE(4920),
    [sym__qid] = STATE(4920),
    [sym__binding_ids_and_absurds] = STATE(12539),
    [sym_attribute] = STATE(5830),
    [sym_attributes] = STATE(3504),
    [sym_expr] = STATE(12362),
    [sym__with_exprs] = STATE(10196),
    [sym__expr_or_attr] = STATE(4920),
    [sym__application] = STATE(9678),
    [sym__expr2_without_let] = STATE(9678),
    [sym__expr2] = STATE(9678),
    [sym_atom] = STATE(5202),
    [aux_sym__atoms] = STATE(3165),
    [sym__atom_curly] = STATE(4961),
    [sym__atom_no_curly] = STATE(4961),
    [sym_forall] = STATE(9678),
    [sym_let] = STATE(9678),
    [sym_lambda] = STATE(9678),
    [sym_lambda_extended_or_absurd] = STATE(9678),
    [sym_do] = STATE(9678),
    [sym_record_assignments] = STATE(4920),
    [sym_field_assignments] = STATE(4920),
    [aux_sym__typed_bindings] = STATE(8648),
    [sym_typed_binding] = STATE(8648),
    [sym_literal] = STATE(4920),
    [sym_SetN] = STATE(4920),
    [aux_sym__modal_arg_ids_repeat1] = STATE(5830),
    [aux_sym__with_exprs_repeat1] = STATE(3726),
    [sym_id] = ACTIONS(894),
    [anon_sym_forall] = ACTIONS(896),
    [anon_sym_u2200] = ACTIONS(896),
    [anon_sym_BSLASH] = ACTIONS(898),
    [anon_sym_u03bb] = ACTIONS(900),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(902),
    [anon_sym_u2026] = ACTIONS(902),
    [anon_sym_record] = ACTIONS(904),
    [anon_sym_LPAREN] = ACTIONS(906),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(908),
    [anon_sym_u2983] = ACTIONS(910),
    [anon_sym__] = ACTIONS(902),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(912),
    [anon_sym_RBRACE] = ACTIONS(1014),
    [aux_sym__qid_token1] = ACTIONS(916),
    [anon_sym_DOT] = ACTIONS(918),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(712),
    [anon_sym_quoteGoal] = ACTIONS(920),
    [anon_sym_tactic] = ACTIONS(922),
    [anon_sym_Prop] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(902),
    [anon_sym_quoteTerm] = ACTIONS(902),
    [anon_sym_quoteContext] = ACTIONS(902),
    [anon_sym_unquote] = ACTIONS(902),
    [anon_sym_LPAREN_PIPE] = ACTIONS(924),
    [anon_sym_u2987] = ACTIONS(926),
    [anon_sym_let] = ACTIONS(928),
    [anon_sym_do] = ACTIONS(724),
    [aux_sym_integer_token1] = ACTIONS(930),
    [aux_sym_string_token1] = ACTIONS(930),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(932),
    [sym_PropN] = ACTIONS(902),
  },
  [359] = {
    [sym__FORALL] = STATE(8396),
    [sym__LAMBDA] = STATE(8031),
    [sym__ELLIPSIS] = STATE(4920),
    [sym__qid] = STATE(4920),
    [sym__binding_ids_and_absurds] = STATE(12357),
    [sym_attribute] = STATE(7725),
    [sym_attributes] = STATE(6200),
    [sym_expr] = STATE(12743),
    [sym__with_exprs] = STATE(10196),
    [sym__expr_or_attr] = STATE(4920),
    [sym__application] = STATE(9678),
    [sym__expr2_without_let] = STATE(9678),
    [sym__expr2] = STATE(9678),
    [sym_atom] = STATE(5202),
    [aux_sym__atoms] = STATE(3165),
    [sym__atom_curly] = STATE(4961),
    [sym__atom_no_curly] = STATE(4961),
    [sym_forall] = STATE(9678),
    [sym_let] = STATE(9678),
    [sym_lambda] = STATE(9678),
    [sym_lambda_extended_or_absurd] = STATE(9678),
    [sym_do] = STATE(9678),
    [sym_record_assignments] = STATE(4920),
    [sym_field_assignments] = STATE(4920),
    [aux_sym__typed_bindings] = STATE(8648),
    [sym_typed_binding] = STATE(8648),
    [sym_literal] = STATE(4920),
    [sym_SetN] = STATE(4920),
    [aux_sym__modal_arg_ids_repeat1] = STATE(7725),
    [aux_sym__with_exprs_repeat1] = STATE(3726),
    [sym_id] = ACTIONS(894),
    [anon_sym_forall] = ACTIONS(896),
    [anon_sym_u2200] = ACTIONS(896),
    [anon_sym_BSLASH] = ACTIONS(898),
    [anon_sym_u03bb] = ACTIONS(900),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(902),
    [anon_sym_u2026] = ACTIONS(902),
    [anon_sym_record] = ACTIONS(904),
    [anon_sym_LPAREN] = ACTIONS(906),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(908),
    [anon_sym_u2983] = ACTIONS(910),
    [anon_sym__] = ACTIONS(902),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(912),
    [anon_sym_RBRACE] = ACTIONS(1004),
    [aux_sym__qid_token1] = ACTIONS(916),
    [anon_sym_DOT] = ACTIONS(918),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(760),
    [anon_sym_quoteGoal] = ACTIONS(920),
    [anon_sym_tactic] = ACTIONS(922),
    [anon_sym_Prop] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(902),
    [anon_sym_quoteTerm] = ACTIONS(902),
    [anon_sym_quoteContext] = ACTIONS(902),
    [anon_sym_unquote] = ACTIONS(902),
    [anon_sym_LPAREN_PIPE] = ACTIONS(924),
    [anon_sym_u2987] = ACTIONS(926),
    [anon_sym_let] = ACTIONS(928),
    [anon_sym_do] = ACTIONS(724),
    [aux_sym_integer_token1] = ACTIONS(930),
    [aux_sym_string_token1] = ACTIONS(930),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(932),
    [sym_PropN] = ACTIONS(902),
  },
  [360] = {
    [sym__FORALL] = STATE(8369),
    [sym__LAMBDA] = STATE(8152),
    [sym__ELLIPSIS] = STATE(5168),
    [sym__qid] = STATE(5168),
    [sym__binding_ids_and_absurds] = STATE(12358),
    [sym_attribute] = STATE(7725),
    [sym_attributes] = STATE(6182),
    [sym_expr] = STATE(12040),
    [sym__with_exprs] = STATE(9861),
    [sym__expr_or_attr] = STATE(5168),
    [sym__application] = STATE(9444),
    [sym__expr2_without_let] = STATE(9444),
    [sym__expr2] = STATE(9444),
    [sym_atom] = STATE(5204),
    [aux_sym__atoms] = STATE(3133),
    [sym__atom_curly] = STATE(5180),
    [sym__atom_no_curly] = STATE(5180),
    [sym_forall] = STATE(9444),
    [sym_let] = STATE(9444),
    [sym_lambda] = STATE(9444),
    [sym_lambda_extended_or_absurd] = STATE(9444),
    [sym_do] = STATE(9444),
    [sym_record_assignments] = STATE(5168),
    [sym_field_assignments] = STATE(5168),
    [aux_sym__typed_bindings] = STATE(8654),
    [sym_typed_binding] = STATE(8654),
    [sym_literal] = STATE(5168),
    [sym_SetN] = STATE(5168),
    [aux_sym__modal_arg_ids_repeat1] = STATE(7725),
    [aux_sym__with_exprs_repeat1] = STATE(3754),
    [sym_id] = ACTIONS(850),
    [anon_sym_forall] = ACTIONS(852),
    [anon_sym_u2200] = ACTIONS(852),
    [anon_sym_BSLASH] = ACTIONS(854),
    [anon_sym_u03bb] = ACTIONS(856),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(858),
    [anon_sym_u2026] = ACTIONS(858),
    [anon_sym_record] = ACTIONS(860),
    [anon_sym_LPAREN] = ACTIONS(862),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(864),
    [anon_sym_u2983] = ACTIONS(866),
    [anon_sym_u2984] = ACTIONS(1016),
    [anon_sym__] = ACTIONS(858),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(870),
    [aux_sym__qid_token1] = ACTIONS(872),
    [anon_sym_DOT] = ACTIONS(874),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(760),
    [anon_sym_quoteGoal] = ACTIONS(878),
    [anon_sym_tactic] = ACTIONS(880),
    [anon_sym_Prop] = ACTIONS(858),
    [anon_sym_quote] = ACTIONS(858),
    [anon_sym_quoteTerm] = ACTIONS(858),
    [anon_sym_quoteContext] = ACTIONS(858),
    [anon_sym_unquote] = ACTIONS(858),
    [anon_sym_LPAREN_PIPE] = ACTIONS(882),
    [anon_sym_u2987] = ACTIONS(884),
    [anon_sym_let] = ACTIONS(886),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(890),
    [aux_sym_string_token1] = ACTIONS(890),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(892),
    [sym_PropN] = ACTIONS(858),
  },
  [361] = {
    [sym__FORALL] = STATE(8355),
    [sym__LAMBDA] = STATE(8054),
    [sym__ELLIPSIS] = STATE(4742),
    [sym__qid] = STATE(4742),
    [sym__binding_ids_and_absurds] = STATE(12359),
    [sym_attribute] = STATE(7725),
    [sym_attributes] = STATE(6302),
    [sym_expr] = STATE(12039),
    [sym__with_exprs] = STATE(10050),
    [sym__expr_or_attr] = STATE(4742),
    [sym__application] = STATE(9444),
    [sym__expr2_without_let] = STATE(9444),
    [sym__expr2] = STATE(9444),
    [sym_atom] = STATE(4712),
    [aux_sym__atoms] = STATE(3276),
    [sym__atom_curly] = STATE(4733),
    [sym__atom_no_curly] = STATE(4733),
    [sym_forall] = STATE(9444),
    [sym_let] = STATE(9444),
    [sym_lambda] = STATE(9444),
    [sym_lambda_extended_or_absurd] = STATE(9444),
    [sym_do] = STATE(9444),
    [sym_record_assignments] = STATE(4742),
    [sym_field_assignments] = STATE(4742),
    [aux_sym__typed_bindings] = STATE(8646),
    [sym_typed_binding] = STATE(8646),
    [sym_literal] = STATE(4742),
    [sym_SetN] = STATE(4742),
    [aux_sym__modal_arg_ids_repeat1] = STATE(7725),
    [aux_sym__with_exprs_repeat1] = STATE(3745),
    [sym_id] = ACTIONS(940),
    [anon_sym_forall] = ACTIONS(942),
    [anon_sym_u2200] = ACTIONS(942),
    [anon_sym_BSLASH] = ACTIONS(944),
    [anon_sym_u03bb] = ACTIONS(946),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(948),
    [anon_sym_u2026] = ACTIONS(948),
    [anon_sym_record] = ACTIONS(950),
    [anon_sym_LPAREN] = ACTIONS(952),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(954),
    [anon_sym_RBRACE_RBRACE] = ACTIONS(1016),
    [anon_sym_u2983] = ACTIONS(956),
    [anon_sym__] = ACTIONS(948),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(958),
    [aux_sym__qid_token1] = ACTIONS(960),
    [anon_sym_DOT] = ACTIONS(962),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(760),
    [anon_sym_quoteGoal] = ACTIONS(964),
    [anon_sym_tactic] = ACTIONS(966),
    [anon_sym_Prop] = ACTIONS(948),
    [anon_sym_quote] = ACTIONS(948),
    [anon_sym_quoteTerm] = ACTIONS(948),
    [anon_sym_quoteContext] = ACTIONS(948),
    [anon_sym_unquote] = ACTIONS(948),
    [anon_sym_LPAREN_PIPE] = ACTIONS(968),
    [anon_sym_u2987] = ACTIONS(970),
    [anon_sym_let] = ACTIONS(972),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(974),
    [aux_sym_string_token1] = ACTIONS(974),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(976),
    [sym_PropN] = ACTIONS(948),
  },
  [362] = {
    [sym__FORALL] = STATE(8396),
    [sym__LAMBDA] = STATE(8031),
    [sym__ELLIPSIS] = STATE(4920),
    [sym__qid] = STATE(4920),
    [sym__binding_ids_and_absurds] = STATE(12357),
    [sym_attribute] = STATE(7725),
    [sym_attributes] = STATE(6200),
    [sym_expr] = STATE(12774),
    [sym__with_exprs] = STATE(10196),
    [sym__expr_or_attr] = STATE(4920),
    [sym__application] = STATE(9678),
    [sym__expr2_without_let] = STATE(9678),
    [sym__expr2] = STATE(9678),
    [sym_atom] = STATE(5202),
    [aux_sym__atoms] = STATE(3165),
    [sym__atom_curly] = STATE(4961),
    [sym__atom_no_curly] = STATE(4961),
    [sym_forall] = STATE(9678),
    [sym_let] = STATE(9678),
    [sym_lambda] = STATE(9678),
    [sym_lambda_extended_or_absurd] = STATE(9678),
    [sym_do] = STATE(9678),
    [sym_record_assignments] = STATE(4920),
    [sym_field_assignments] = STATE(4920),
    [aux_sym__typed_bindings] = STATE(8648),
    [sym_typed_binding] = STATE(8648),
    [sym_literal] = STATE(4920),
    [sym_SetN] = STATE(4920),
    [aux_sym__modal_arg_ids_repeat1] = STATE(7725),
    [aux_sym__with_exprs_repeat1] = STATE(3726),
    [sym_id] = ACTIONS(894),
    [anon_sym_forall] = ACTIONS(896),
    [anon_sym_u2200] = ACTIONS(896),
    [anon_sym_BSLASH] = ACTIONS(898),
    [anon_sym_u03bb] = ACTIONS(900),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(902),
    [anon_sym_u2026] = ACTIONS(902),
    [anon_sym_record] = ACTIONS(904),
    [anon_sym_LPAREN] = ACTIONS(906),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(908),
    [anon_sym_u2983] = ACTIONS(910),
    [anon_sym__] = ACTIONS(902),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(912),
    [anon_sym_RBRACE] = ACTIONS(1018),
    [aux_sym__qid_token1] = ACTIONS(916),
    [anon_sym_DOT] = ACTIONS(918),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(760),
    [anon_sym_quoteGoal] = ACTIONS(920),
    [anon_sym_tactic] = ACTIONS(922),
    [anon_sym_Prop] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(902),
    [anon_sym_quoteTerm] = ACTIONS(902),
    [anon_sym_quoteContext] = ACTIONS(902),
    [anon_sym_unquote] = ACTIONS(902),
    [anon_sym_LPAREN_PIPE] = ACTIONS(924),
    [anon_sym_u2987] = ACTIONS(926),
    [anon_sym_let] = ACTIONS(928),
    [anon_sym_do] = ACTIONS(724),
    [aux_sym_integer_token1] = ACTIONS(930),
    [aux_sym_string_token1] = ACTIONS(930),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(932),
    [sym_PropN] = ACTIONS(902),
  },
  [363] = {
    [sym__FORALL] = STATE(8369),
    [sym__LAMBDA] = STATE(8152),
    [sym__ELLIPSIS] = STATE(5168),
    [sym__qid] = STATE(5168),
    [sym__binding_ids_and_absurds] = STATE(12358),
    [sym_attribute] = STATE(7725),
    [sym_attributes] = STATE(6182),
    [sym_expr] = STATE(12775),
    [sym__with_exprs] = STATE(9861),
    [sym__expr_or_attr] = STATE(5168),
    [sym__application] = STATE(9444),
    [sym__expr2_without_let] = STATE(9444),
    [sym__expr2] = STATE(9444),
    [sym_atom] = STATE(5204),
    [aux_sym__atoms] = STATE(3133),
    [sym__atom_curly] = STATE(5180),
    [sym__atom_no_curly] = STATE(5180),
    [sym_forall] = STATE(9444),
    [sym_let] = STATE(9444),
    [sym_lambda] = STATE(9444),
    [sym_lambda_extended_or_absurd] = STATE(9444),
    [sym_do] = STATE(9444),
    [sym_record_assignments] = STATE(5168),
    [sym_field_assignments] = STATE(5168),
    [aux_sym__typed_bindings] = STATE(8654),
    [sym_typed_binding] = STATE(8654),
    [sym_literal] = STATE(5168),
    [sym_SetN] = STATE(5168),
    [aux_sym__modal_arg_ids_repeat1] = STATE(7725),
    [aux_sym__with_exprs_repeat1] = STATE(3754),
    [sym_id] = ACTIONS(850),
    [anon_sym_forall] = ACTIONS(852),
    [anon_sym_u2200] = ACTIONS(852),
    [anon_sym_BSLASH] = ACTIONS(854),
    [anon_sym_u03bb] = ACTIONS(856),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(858),
    [anon_sym_u2026] = ACTIONS(858),
    [anon_sym_record] = ACTIONS(860),
    [anon_sym_LPAREN] = ACTIONS(862),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(864),
    [anon_sym_u2983] = ACTIONS(866),
    [anon_sym_u2984] = ACTIONS(1020),
    [anon_sym__] = ACTIONS(858),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(870),
    [aux_sym__qid_token1] = ACTIONS(872),
    [anon_sym_DOT] = ACTIONS(874),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(760),
    [anon_sym_quoteGoal] = ACTIONS(878),
    [anon_sym_tactic] = ACTIONS(880),
    [anon_sym_Prop] = ACTIONS(858),
    [anon_sym_quote] = ACTIONS(858),
    [anon_sym_quoteTerm] = ACTIONS(858),
    [anon_sym_quoteContext] = ACTIONS(858),
    [anon_sym_unquote] = ACTIONS(858),
    [anon_sym_LPAREN_PIPE] = ACTIONS(882),
    [anon_sym_u2987] = ACTIONS(884),
    [anon_sym_let] = ACTIONS(886),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(890),
    [aux_sym_string_token1] = ACTIONS(890),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(892),
    [sym_PropN] = ACTIONS(858),
  },
  [364] = {
    [sym__FORALL] = STATE(8355),
    [sym__LAMBDA] = STATE(8054),
    [sym__ELLIPSIS] = STATE(4742),
    [sym__qid] = STATE(4742),
    [sym__binding_ids_and_absurds] = STATE(12359),
    [sym_attribute] = STATE(7725),
    [sym_attributes] = STATE(6302),
    [sym_expr] = STATE(12776),
    [sym__with_exprs] = STATE(10050),
    [sym__expr_or_attr] = STATE(4742),
    [sym__application] = STATE(9444),
    [sym__expr2_without_let] = STATE(9444),
    [sym__expr2] = STATE(9444),
    [sym_atom] = STATE(4712),
    [aux_sym__atoms] = STATE(3276),
    [sym__atom_curly] = STATE(4733),
    [sym__atom_no_curly] = STATE(4733),
    [sym_forall] = STATE(9444),
    [sym_let] = STATE(9444),
    [sym_lambda] = STATE(9444),
    [sym_lambda_extended_or_absurd] = STATE(9444),
    [sym_do] = STATE(9444),
    [sym_record_assignments] = STATE(4742),
    [sym_field_assignments] = STATE(4742),
    [aux_sym__typed_bindings] = STATE(8646),
    [sym_typed_binding] = STATE(8646),
    [sym_literal] = STATE(4742),
    [sym_SetN] = STATE(4742),
    [aux_sym__modal_arg_ids_repeat1] = STATE(7725),
    [aux_sym__with_exprs_repeat1] = STATE(3745),
    [sym_id] = ACTIONS(940),
    [anon_sym_forall] = ACTIONS(942),
    [anon_sym_u2200] = ACTIONS(942),
    [anon_sym_BSLASH] = ACTIONS(944),
    [anon_sym_u03bb] = ACTIONS(946),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(948),
    [anon_sym_u2026] = ACTIONS(948),
    [anon_sym_record] = ACTIONS(950),
    [anon_sym_LPAREN] = ACTIONS(952),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(954),
    [anon_sym_RBRACE_RBRACE] = ACTIONS(1020),
    [anon_sym_u2983] = ACTIONS(956),
    [anon_sym__] = ACTIONS(948),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(958),
    [aux_sym__qid_token1] = ACTIONS(960),
    [anon_sym_DOT] = ACTIONS(962),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(760),
    [anon_sym_quoteGoal] = ACTIONS(964),
    [anon_sym_tactic] = ACTIONS(966),
    [anon_sym_Prop] = ACTIONS(948),
    [anon_sym_quote] = ACTIONS(948),
    [anon_sym_quoteTerm] = ACTIONS(948),
    [anon_sym_quoteContext] = ACTIONS(948),
    [anon_sym_unquote] = ACTIONS(948),
    [anon_sym_LPAREN_PIPE] = ACTIONS(968),
    [anon_sym_u2987] = ACTIONS(970),
    [anon_sym_let] = ACTIONS(972),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(974),
    [aux_sym_string_token1] = ACTIONS(974),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(976),
    [sym_PropN] = ACTIONS(948),
  },
  [365] = {
    [sym__FORALL] = STATE(8396),
    [sym__LAMBDA] = STATE(8031),
    [sym__ELLIPSIS] = STATE(4920),
    [sym__qid] = STATE(4920),
    [sym__binding_ids_and_absurds] = STATE(12357),
    [sym_attribute] = STATE(7725),
    [sym_attributes] = STATE(6200),
    [sym_expr] = STATE(10946),
    [sym__with_exprs] = STATE(10196),
    [sym__expr_or_attr] = STATE(4920),
    [sym__application] = STATE(9678),
    [sym__expr2_without_let] = STATE(9678),
    [sym__expr2] = STATE(9678),
    [sym_atom] = STATE(5202),
    [aux_sym__atoms] = STATE(3165),
    [sym__atom_curly] = STATE(4961),
    [sym__atom_no_curly] = STATE(4961),
    [sym_forall] = STATE(9678),
    [sym_let] = STATE(9678),
    [sym_lambda] = STATE(9678),
    [sym_lambda_extended_or_absurd] = STATE(9678),
    [sym_do] = STATE(9678),
    [sym_record_assignments] = STATE(4920),
    [sym_field_assignments] = STATE(4920),
    [aux_sym__typed_bindings] = STATE(8648),
    [sym_typed_binding] = STATE(8648),
    [sym_literal] = STATE(4920),
    [sym_SetN] = STATE(4920),
    [aux_sym__modal_arg_ids_repeat1] = STATE(7725),
    [aux_sym__with_exprs_repeat1] = STATE(3726),
    [sym_id] = ACTIONS(894),
    [anon_sym_forall] = ACTIONS(896),
    [anon_sym_u2200] = ACTIONS(896),
    [anon_sym_BSLASH] = ACTIONS(898),
    [anon_sym_u03bb] = ACTIONS(900),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(902),
    [anon_sym_u2026] = ACTIONS(902),
    [anon_sym_record] = ACTIONS(904),
    [anon_sym_LPAREN] = ACTIONS(906),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(908),
    [anon_sym_u2983] = ACTIONS(910),
    [anon_sym__] = ACTIONS(902),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(912),
    [anon_sym_RBRACE] = ACTIONS(1022),
    [aux_sym__qid_token1] = ACTIONS(916),
    [anon_sym_DOT] = ACTIONS(918),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(760),
    [anon_sym_quoteGoal] = ACTIONS(920),
    [anon_sym_tactic] = ACTIONS(922),
    [anon_sym_Prop] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(902),
    [anon_sym_quoteTerm] = ACTIONS(902),
    [anon_sym_quoteContext] = ACTIONS(902),
    [anon_sym_unquote] = ACTIONS(902),
    [anon_sym_LPAREN_PIPE] = ACTIONS(924),
    [anon_sym_u2987] = ACTIONS(926),
    [anon_sym_let] = ACTIONS(928),
    [anon_sym_do] = ACTIONS(724),
    [aux_sym_integer_token1] = ACTIONS(930),
    [aux_sym_string_token1] = ACTIONS(930),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(932),
    [sym_PropN] = ACTIONS(902),
  },
  [366] = {
    [sym__FORALL] = STATE(8369),
    [sym__LAMBDA] = STATE(8152),
    [sym__ELLIPSIS] = STATE(5168),
    [sym__qid] = STATE(5168),
    [sym__binding_ids_and_absurds] = STATE(12358),
    [sym_attribute] = STATE(7725),
    [sym_attributes] = STATE(6182),
    [sym_expr] = STATE(10947),
    [sym__with_exprs] = STATE(9861),
    [sym__expr_or_attr] = STATE(5168),
    [sym__application] = STATE(9444),
    [sym__expr2_without_let] = STATE(9444),
    [sym__expr2] = STATE(9444),
    [sym_atom] = STATE(5204),
    [aux_sym__atoms] = STATE(3133),
    [sym__atom_curly] = STATE(5180),
    [sym__atom_no_curly] = STATE(5180),
    [sym_forall] = STATE(9444),
    [sym_let] = STATE(9444),
    [sym_lambda] = STATE(9444),
    [sym_lambda_extended_or_absurd] = STATE(9444),
    [sym_do] = STATE(9444),
    [sym_record_assignments] = STATE(5168),
    [sym_field_assignments] = STATE(5168),
    [aux_sym__typed_bindings] = STATE(8654),
    [sym_typed_binding] = STATE(8654),
    [sym_literal] = STATE(5168),
    [sym_SetN] = STATE(5168),
    [aux_sym__modal_arg_ids_repeat1] = STATE(7725),
    [aux_sym__with_exprs_repeat1] = STATE(3754),
    [sym_id] = ACTIONS(850),
    [anon_sym_forall] = ACTIONS(852),
    [anon_sym_u2200] = ACTIONS(852),
    [anon_sym_BSLASH] = ACTIONS(854),
    [anon_sym_u03bb] = ACTIONS(856),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(858),
    [anon_sym_u2026] = ACTIONS(858),
    [anon_sym_record] = ACTIONS(860),
    [anon_sym_LPAREN] = ACTIONS(862),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(864),
    [anon_sym_u2983] = ACTIONS(866),
    [anon_sym_u2984] = ACTIONS(1024),
    [anon_sym__] = ACTIONS(858),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(870),
    [aux_sym__qid_token1] = ACTIONS(872),
    [anon_sym_DOT] = ACTIONS(874),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(760),
    [anon_sym_quoteGoal] = ACTIONS(878),
    [anon_sym_tactic] = ACTIONS(880),
    [anon_sym_Prop] = ACTIONS(858),
    [anon_sym_quote] = ACTIONS(858),
    [anon_sym_quoteTerm] = ACTIONS(858),
    [anon_sym_quoteContext] = ACTIONS(858),
    [anon_sym_unquote] = ACTIONS(858),
    [anon_sym_LPAREN_PIPE] = ACTIONS(882),
    [anon_sym_u2987] = ACTIONS(884),
    [anon_sym_let] = ACTIONS(886),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(890),
    [aux_sym_string_token1] = ACTIONS(890),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(892),
    [sym_PropN] = ACTIONS(858),
  },
  [367] = {
    [sym__FORALL] = STATE(8355),
    [sym__LAMBDA] = STATE(8054),
    [sym__ELLIPSIS] = STATE(4742),
    [sym__qid] = STATE(4742),
    [sym__binding_ids_and_absurds] = STATE(12359),
    [sym_attribute] = STATE(7725),
    [sym_attributes] = STATE(6302),
    [sym_expr] = STATE(10948),
    [sym__with_exprs] = STATE(10050),
    [sym__expr_or_attr] = STATE(4742),
    [sym__application] = STATE(9444),
    [sym__expr2_without_let] = STATE(9444),
    [sym__expr2] = STATE(9444),
    [sym_atom] = STATE(4712),
    [aux_sym__atoms] = STATE(3276),
    [sym__atom_curly] = STATE(4733),
    [sym__atom_no_curly] = STATE(4733),
    [sym_forall] = STATE(9444),
    [sym_let] = STATE(9444),
    [sym_lambda] = STATE(9444),
    [sym_lambda_extended_or_absurd] = STATE(9444),
    [sym_do] = STATE(9444),
    [sym_record_assignments] = STATE(4742),
    [sym_field_assignments] = STATE(4742),
    [aux_sym__typed_bindings] = STATE(8646),
    [sym_typed_binding] = STATE(8646),
    [sym_literal] = STATE(4742),
    [sym_SetN] = STATE(4742),
    [aux_sym__modal_arg_ids_repeat1] = STATE(7725),
    [aux_sym__with_exprs_repeat1] = STATE(3745),
    [sym_id] = ACTIONS(940),
    [anon_sym_forall] = ACTIONS(942),
    [anon_sym_u2200] = ACTIONS(942),
    [anon_sym_BSLASH] = ACTIONS(944),
    [anon_sym_u03bb] = ACTIONS(946),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(948),
    [anon_sym_u2026] = ACTIONS(948),
    [anon_sym_record] = ACTIONS(950),
    [anon_sym_LPAREN] = ACTIONS(952),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(954),
    [anon_sym_RBRACE_RBRACE] = ACTIONS(1024),
    [anon_sym_u2983] = ACTIONS(956),
    [anon_sym__] = ACTIONS(948),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(958),
    [aux_sym__qid_token1] = ACTIONS(960),
    [anon_sym_DOT] = ACTIONS(962),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(760),
    [anon_sym_quoteGoal] = ACTIONS(964),
    [anon_sym_tactic] = ACTIONS(966),
    [anon_sym_Prop] = ACTIONS(948),
    [anon_sym_quote] = ACTIONS(948),
    [anon_sym_quoteTerm] = ACTIONS(948),
    [anon_sym_quoteContext] = ACTIONS(948),
    [anon_sym_unquote] = ACTIONS(948),
    [anon_sym_LPAREN_PIPE] = ACTIONS(968),
    [anon_sym_u2987] = ACTIONS(970),
    [anon_sym_let] = ACTIONS(972),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(974),
    [aux_sym_string_token1] = ACTIONS(974),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(976),
    [sym_PropN] = ACTIONS(948),
  },
  [368] = {
    [sym__FORALL] = STATE(8345),
    [sym__LAMBDA] = STATE(8095),
    [sym__ELLIPSIS] = STATE(4742),
    [sym_open] = STATE(12555),
    [sym__qid] = STATE(4742),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3873),
    [sym_expr] = STATE(12449),
    [sym__with_exprs] = STATE(10084),
    [sym__expr_or_attr] = STATE(4742),
    [sym__application] = STATE(9680),
    [sym__expr2_without_let] = STATE(9680),
    [sym__expr2] = STATE(9680),
    [sym_atom] = STATE(4712),
    [aux_sym__atoms] = STATE(3211),
    [sym__atom_curly] = STATE(4733),
    [sym__atom_no_curly] = STATE(4733),
    [sym_forall] = STATE(9680),
    [sym_let] = STATE(9680),
    [sym_lambda] = STATE(9680),
    [sym_lambda_extended_or_absurd] = STATE(9680),
    [sym_do] = STATE(9680),
    [sym_record_assignments] = STATE(4742),
    [sym_field_assignments] = STATE(4742),
    [aux_sym__typed_bindings] = STATE(8642),
    [sym_typed_binding] = STATE(8642),
    [sym_literal] = STATE(4742),
    [sym_SetN] = STATE(4742),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3728),
    [sym_id] = ACTIONS(940),
    [anon_sym_forall] = ACTIONS(980),
    [anon_sym_u2200] = ACTIONS(980),
    [anon_sym_BSLASH] = ACTIONS(982),
    [anon_sym_u03bb] = ACTIONS(984),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(948),
    [anon_sym_u2026] = ACTIONS(948),
    [anon_sym_record] = ACTIONS(950),
    [anon_sym_open] = ACTIONS(986),
    [anon_sym_LPAREN] = ACTIONS(952),
    [anon_sym_RPAREN] = ACTIONS(1026),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(954),
    [anon_sym_u2983] = ACTIONS(956),
    [anon_sym__] = ACTIONS(948),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(958),
    [aux_sym__qid_token1] = ACTIONS(960),
    [anon_sym_DOT] = ACTIONS(962),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(988),
    [anon_sym_tactic] = ACTIONS(990),
    [anon_sym_Prop] = ACTIONS(948),
    [anon_sym_quote] = ACTIONS(948),
    [anon_sym_quoteTerm] = ACTIONS(948),
    [anon_sym_quoteContext] = ACTIONS(948),
    [anon_sym_unquote] = ACTIONS(948),
    [anon_sym_LPAREN_PIPE] = ACTIONS(968),
    [anon_sym_u2987] = ACTIONS(970),
    [anon_sym_let] = ACTIONS(992),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(974),
    [aux_sym_string_token1] = ACTIONS(974),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(976),
    [sym_PropN] = ACTIONS(948),
  },
  [369] = {
    [sym__FORALL] = STATE(8355),
    [sym__LAMBDA] = STATE(8054),
    [sym__ELLIPSIS] = STATE(4742),
    [sym__qid] = STATE(4742),
    [sym__binding_ids_and_absurds] = STATE(12547),
    [sym_attribute] = STATE(5830),
    [sym_attributes] = STATE(3506),
    [sym_expr] = STATE(12519),
    [sym__with_exprs] = STATE(10050),
    [sym__expr_or_attr] = STATE(4742),
    [sym__application] = STATE(9444),
    [sym__expr2_without_let] = STATE(9444),
    [sym__expr2] = STATE(9444),
    [sym_atom] = STATE(4712),
    [aux_sym__atoms] = STATE(3276),
    [sym__atom_curly] = STATE(4733),
    [sym__atom_no_curly] = STATE(4733),
    [sym_forall] = STATE(9444),
    [sym_let] = STATE(9444),
    [sym_lambda] = STATE(9444),
    [sym_lambda_extended_or_absurd] = STATE(9444),
    [sym_do] = STATE(9444),
    [sym_record_assignments] = STATE(4742),
    [sym_field_assignments] = STATE(4742),
    [aux_sym__typed_bindings] = STATE(8646),
    [sym_typed_binding] = STATE(8646),
    [sym_literal] = STATE(4742),
    [sym_SetN] = STATE(4742),
    [aux_sym__modal_arg_ids_repeat1] = STATE(5830),
    [aux_sym__with_exprs_repeat1] = STATE(3745),
    [sym_id] = ACTIONS(940),
    [anon_sym_forall] = ACTIONS(942),
    [anon_sym_u2200] = ACTIONS(942),
    [anon_sym_BSLASH] = ACTIONS(944),
    [anon_sym_u03bb] = ACTIONS(946),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(948),
    [anon_sym_u2026] = ACTIONS(948),
    [anon_sym_record] = ACTIONS(950),
    [anon_sym_LPAREN] = ACTIONS(952),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(954),
    [anon_sym_RBRACE_RBRACE] = ACTIONS(1026),
    [anon_sym_u2983] = ACTIONS(956),
    [anon_sym__] = ACTIONS(948),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(958),
    [aux_sym__qid_token1] = ACTIONS(960),
    [anon_sym_DOT] = ACTIONS(962),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(712),
    [anon_sym_quoteGoal] = ACTIONS(964),
    [anon_sym_tactic] = ACTIONS(966),
    [anon_sym_Prop] = ACTIONS(948),
    [anon_sym_quote] = ACTIONS(948),
    [anon_sym_quoteTerm] = ACTIONS(948),
    [anon_sym_quoteContext] = ACTIONS(948),
    [anon_sym_unquote] = ACTIONS(948),
    [anon_sym_LPAREN_PIPE] = ACTIONS(968),
    [anon_sym_u2987] = ACTIONS(970),
    [anon_sym_let] = ACTIONS(972),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(974),
    [aux_sym_string_token1] = ACTIONS(974),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(976),
    [sym_PropN] = ACTIONS(948),
  },
  [370] = {
    [sym__FORALL] = STATE(8369),
    [sym__LAMBDA] = STATE(8152),
    [sym__ELLIPSIS] = STATE(5168),
    [sym__qid] = STATE(5168),
    [sym__binding_ids_and_absurds] = STATE(12544),
    [sym_attribute] = STATE(5830),
    [sym_attributes] = STATE(3505),
    [sym_expr] = STATE(12518),
    [sym__with_exprs] = STATE(9861),
    [sym__expr_or_attr] = STATE(5168),
    [sym__application] = STATE(9444),
    [sym__expr2_without_let] = STATE(9444),
    [sym__expr2] = STATE(9444),
    [sym_atom] = STATE(5204),
    [aux_sym__atoms] = STATE(3133),
    [sym__atom_curly] = STATE(5180),
    [sym__atom_no_curly] = STATE(5180),
    [sym_forall] = STATE(9444),
    [sym_let] = STATE(9444),
    [sym_lambda] = STATE(9444),
    [sym_lambda_extended_or_absurd] = STATE(9444),
    [sym_do] = STATE(9444),
    [sym_record_assignments] = STATE(5168),
    [sym_field_assignments] = STATE(5168),
    [aux_sym__typed_bindings] = STATE(8654),
    [sym_typed_binding] = STATE(8654),
    [sym_literal] = STATE(5168),
    [sym_SetN] = STATE(5168),
    [aux_sym__modal_arg_ids_repeat1] = STATE(5830),
    [aux_sym__with_exprs_repeat1] = STATE(3754),
    [sym_id] = ACTIONS(850),
    [anon_sym_forall] = ACTIONS(852),
    [anon_sym_u2200] = ACTIONS(852),
    [anon_sym_BSLASH] = ACTIONS(854),
    [anon_sym_u03bb] = ACTIONS(856),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(858),
    [anon_sym_u2026] = ACTIONS(858),
    [anon_sym_record] = ACTIONS(860),
    [anon_sym_LPAREN] = ACTIONS(862),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(864),
    [anon_sym_u2983] = ACTIONS(866),
    [anon_sym_u2984] = ACTIONS(1026),
    [anon_sym__] = ACTIONS(858),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(870),
    [aux_sym__qid_token1] = ACTIONS(872),
    [anon_sym_DOT] = ACTIONS(874),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(712),
    [anon_sym_quoteGoal] = ACTIONS(878),
    [anon_sym_tactic] = ACTIONS(880),
    [anon_sym_Prop] = ACTIONS(858),
    [anon_sym_quote] = ACTIONS(858),
    [anon_sym_quoteTerm] = ACTIONS(858),
    [anon_sym_quoteContext] = ACTIONS(858),
    [anon_sym_unquote] = ACTIONS(858),
    [anon_sym_LPAREN_PIPE] = ACTIONS(882),
    [anon_sym_u2987] = ACTIONS(884),
    [anon_sym_let] = ACTIONS(886),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(890),
    [aux_sym_string_token1] = ACTIONS(890),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(892),
    [sym_PropN] = ACTIONS(858),
  },
  [371] = {
    [sym__FORALL] = STATE(8396),
    [sym__LAMBDA] = STATE(8031),
    [sym__ELLIPSIS] = STATE(4920),
    [sym__qid] = STATE(4920),
    [sym__binding_ids_and_absurds] = STATE(12539),
    [sym_attribute] = STATE(5830),
    [sym_attributes] = STATE(3504),
    [sym_expr] = STATE(11358),
    [sym__with_exprs] = STATE(10196),
    [sym__expr_or_attr] = STATE(4920),
    [sym__application] = STATE(9678),
    [sym__expr2_without_let] = STATE(9678),
    [sym__expr2] = STATE(9678),
    [sym_atom] = STATE(5202),
    [aux_sym__atoms] = STATE(3165),
    [sym__atom_curly] = STATE(4961),
    [sym__atom_no_curly] = STATE(4961),
    [sym_forall] = STATE(9678),
    [sym_let] = STATE(9678),
    [sym_lambda] = STATE(9678),
    [sym_lambda_extended_or_absurd] = STATE(9678),
    [sym_do] = STATE(9678),
    [sym_record_assignments] = STATE(4920),
    [sym_field_assignments] = STATE(4920),
    [aux_sym__typed_bindings] = STATE(8648),
    [sym_typed_binding] = STATE(8648),
    [sym_literal] = STATE(4920),
    [sym_SetN] = STATE(4920),
    [aux_sym__modal_arg_ids_repeat1] = STATE(5830),
    [aux_sym__with_exprs_repeat1] = STATE(3726),
    [sym_id] = ACTIONS(894),
    [anon_sym_forall] = ACTIONS(896),
    [anon_sym_u2200] = ACTIONS(896),
    [anon_sym_BSLASH] = ACTIONS(898),
    [anon_sym_u03bb] = ACTIONS(900),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(902),
    [anon_sym_u2026] = ACTIONS(902),
    [anon_sym_record] = ACTIONS(904),
    [anon_sym_LPAREN] = ACTIONS(906),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(908),
    [anon_sym_u2983] = ACTIONS(910),
    [anon_sym__] = ACTIONS(902),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(912),
    [anon_sym_RBRACE] = ACTIONS(1006),
    [aux_sym__qid_token1] = ACTIONS(916),
    [anon_sym_DOT] = ACTIONS(918),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(712),
    [anon_sym_quoteGoal] = ACTIONS(920),
    [anon_sym_tactic] = ACTIONS(922),
    [anon_sym_Prop] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(902),
    [anon_sym_quoteTerm] = ACTIONS(902),
    [anon_sym_quoteContext] = ACTIONS(902),
    [anon_sym_unquote] = ACTIONS(902),
    [anon_sym_LPAREN_PIPE] = ACTIONS(924),
    [anon_sym_u2987] = ACTIONS(926),
    [anon_sym_let] = ACTIONS(928),
    [anon_sym_do] = ACTIONS(724),
    [aux_sym_integer_token1] = ACTIONS(930),
    [aux_sym_string_token1] = ACTIONS(930),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(932),
    [sym_PropN] = ACTIONS(902),
  },
  [372] = {
    [sym__FORALL] = STATE(8396),
    [sym__LAMBDA] = STATE(8031),
    [sym__ELLIPSIS] = STATE(4920),
    [sym__qid] = STATE(4920),
    [sym__binding_ids_and_absurds] = STATE(12539),
    [sym_attribute] = STATE(5830),
    [sym_attributes] = STATE(3504),
    [sym_expr] = STATE(10946),
    [sym__with_exprs] = STATE(10196),
    [sym__expr_or_attr] = STATE(4920),
    [sym__application] = STATE(9678),
    [sym__expr2_without_let] = STATE(9678),
    [sym__expr2] = STATE(9678),
    [sym_atom] = STATE(5202),
    [aux_sym__atoms] = STATE(3165),
    [sym__atom_curly] = STATE(4961),
    [sym__atom_no_curly] = STATE(4961),
    [sym_forall] = STATE(9678),
    [sym_let] = STATE(9678),
    [sym_lambda] = STATE(9678),
    [sym_lambda_extended_or_absurd] = STATE(9678),
    [sym_do] = STATE(9678),
    [sym_record_assignments] = STATE(4920),
    [sym_field_assignments] = STATE(4920),
    [aux_sym__typed_bindings] = STATE(8648),
    [sym_typed_binding] = STATE(8648),
    [sym_literal] = STATE(4920),
    [sym_SetN] = STATE(4920),
    [aux_sym__modal_arg_ids_repeat1] = STATE(5830),
    [aux_sym__with_exprs_repeat1] = STATE(3726),
    [sym_id] = ACTIONS(894),
    [anon_sym_forall] = ACTIONS(896),
    [anon_sym_u2200] = ACTIONS(896),
    [anon_sym_BSLASH] = ACTIONS(898),
    [anon_sym_u03bb] = ACTIONS(900),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(902),
    [anon_sym_u2026] = ACTIONS(902),
    [anon_sym_record] = ACTIONS(904),
    [anon_sym_LPAREN] = ACTIONS(906),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(908),
    [anon_sym_u2983] = ACTIONS(910),
    [anon_sym__] = ACTIONS(902),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(912),
    [anon_sym_RBRACE] = ACTIONS(1022),
    [aux_sym__qid_token1] = ACTIONS(916),
    [anon_sym_DOT] = ACTIONS(918),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(712),
    [anon_sym_quoteGoal] = ACTIONS(920),
    [anon_sym_tactic] = ACTIONS(922),
    [anon_sym_Prop] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(902),
    [anon_sym_quoteTerm] = ACTIONS(902),
    [anon_sym_quoteContext] = ACTIONS(902),
    [anon_sym_unquote] = ACTIONS(902),
    [anon_sym_LPAREN_PIPE] = ACTIONS(924),
    [anon_sym_u2987] = ACTIONS(926),
    [anon_sym_let] = ACTIONS(928),
    [anon_sym_do] = ACTIONS(724),
    [aux_sym_integer_token1] = ACTIONS(930),
    [aux_sym_string_token1] = ACTIONS(930),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(932),
    [sym_PropN] = ACTIONS(902),
  },
  [373] = {
    [sym__FORALL] = STATE(8396),
    [sym__LAMBDA] = STATE(8031),
    [sym__ELLIPSIS] = STATE(4920),
    [sym__qid] = STATE(4920),
    [sym__binding_ids_and_absurds] = STATE(12539),
    [sym_attribute] = STATE(5830),
    [sym_attributes] = STATE(3504),
    [sym_expr] = STATE(12517),
    [sym__with_exprs] = STATE(10196),
    [sym__expr_or_attr] = STATE(4920),
    [sym__application] = STATE(9678),
    [sym__expr2_without_let] = STATE(9678),
    [sym__expr2] = STATE(9678),
    [sym_atom] = STATE(5202),
    [aux_sym__atoms] = STATE(3165),
    [sym__atom_curly] = STATE(4961),
    [sym__atom_no_curly] = STATE(4961),
    [sym_forall] = STATE(9678),
    [sym_let] = STATE(9678),
    [sym_lambda] = STATE(9678),
    [sym_lambda_extended_or_absurd] = STATE(9678),
    [sym_do] = STATE(9678),
    [sym_record_assignments] = STATE(4920),
    [sym_field_assignments] = STATE(4920),
    [aux_sym__typed_bindings] = STATE(8648),
    [sym_typed_binding] = STATE(8648),
    [sym_literal] = STATE(4920),
    [sym_SetN] = STATE(4920),
    [aux_sym__modal_arg_ids_repeat1] = STATE(5830),
    [aux_sym__with_exprs_repeat1] = STATE(3726),
    [sym_id] = ACTIONS(894),
    [anon_sym_forall] = ACTIONS(896),
    [anon_sym_u2200] = ACTIONS(896),
    [anon_sym_BSLASH] = ACTIONS(898),
    [anon_sym_u03bb] = ACTIONS(900),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(902),
    [anon_sym_u2026] = ACTIONS(902),
    [anon_sym_record] = ACTIONS(904),
    [anon_sym_LPAREN] = ACTIONS(906),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(908),
    [anon_sym_u2983] = ACTIONS(910),
    [anon_sym__] = ACTIONS(902),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(912),
    [anon_sym_RBRACE] = ACTIONS(1028),
    [aux_sym__qid_token1] = ACTIONS(916),
    [anon_sym_DOT] = ACTIONS(918),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(712),
    [anon_sym_quoteGoal] = ACTIONS(920),
    [anon_sym_tactic] = ACTIONS(922),
    [anon_sym_Prop] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(902),
    [anon_sym_quoteTerm] = ACTIONS(902),
    [anon_sym_quoteContext] = ACTIONS(902),
    [anon_sym_unquote] = ACTIONS(902),
    [anon_sym_LPAREN_PIPE] = ACTIONS(924),
    [anon_sym_u2987] = ACTIONS(926),
    [anon_sym_let] = ACTIONS(928),
    [anon_sym_do] = ACTIONS(724),
    [aux_sym_integer_token1] = ACTIONS(930),
    [aux_sym_string_token1] = ACTIONS(930),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(932),
    [sym_PropN] = ACTIONS(902),
  },
  [374] = {
    [sym__FORALL] = STATE(8369),
    [sym__LAMBDA] = STATE(8152),
    [sym__ELLIPSIS] = STATE(5168),
    [sym__qid] = STATE(5168),
    [sym__binding_ids_and_absurds] = STATE(12544),
    [sym_attribute] = STATE(5830),
    [sym_attributes] = STATE(3505),
    [sym_expr] = STATE(10947),
    [sym__with_exprs] = STATE(9861),
    [sym__expr_or_attr] = STATE(5168),
    [sym__application] = STATE(9444),
    [sym__expr2_without_let] = STATE(9444),
    [sym__expr2] = STATE(9444),
    [sym_atom] = STATE(5204),
    [aux_sym__atoms] = STATE(3133),
    [sym__atom_curly] = STATE(5180),
    [sym__atom_no_curly] = STATE(5180),
    [sym_forall] = STATE(9444),
    [sym_let] = STATE(9444),
    [sym_lambda] = STATE(9444),
    [sym_lambda_extended_or_absurd] = STATE(9444),
    [sym_do] = STATE(9444),
    [sym_record_assignments] = STATE(5168),
    [sym_field_assignments] = STATE(5168),
    [aux_sym__typed_bindings] = STATE(8654),
    [sym_typed_binding] = STATE(8654),
    [sym_literal] = STATE(5168),
    [sym_SetN] = STATE(5168),
    [aux_sym__modal_arg_ids_repeat1] = STATE(5830),
    [aux_sym__with_exprs_repeat1] = STATE(3754),
    [sym_id] = ACTIONS(850),
    [anon_sym_forall] = ACTIONS(852),
    [anon_sym_u2200] = ACTIONS(852),
    [anon_sym_BSLASH] = ACTIONS(854),
    [anon_sym_u03bb] = ACTIONS(856),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(858),
    [anon_sym_u2026] = ACTIONS(858),
    [anon_sym_record] = ACTIONS(860),
    [anon_sym_LPAREN] = ACTIONS(862),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(864),
    [anon_sym_u2983] = ACTIONS(866),
    [anon_sym_u2984] = ACTIONS(1024),
    [anon_sym__] = ACTIONS(858),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(870),
    [aux_sym__qid_token1] = ACTIONS(872),
    [anon_sym_DOT] = ACTIONS(874),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(712),
    [anon_sym_quoteGoal] = ACTIONS(878),
    [anon_sym_tactic] = ACTIONS(880),
    [anon_sym_Prop] = ACTIONS(858),
    [anon_sym_quote] = ACTIONS(858),
    [anon_sym_quoteTerm] = ACTIONS(858),
    [anon_sym_quoteContext] = ACTIONS(858),
    [anon_sym_unquote] = ACTIONS(858),
    [anon_sym_LPAREN_PIPE] = ACTIONS(882),
    [anon_sym_u2987] = ACTIONS(884),
    [anon_sym_let] = ACTIONS(886),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(890),
    [aux_sym_string_token1] = ACTIONS(890),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(892),
    [sym_PropN] = ACTIONS(858),
  },
  [375] = {
    [sym__FORALL] = STATE(8369),
    [sym__LAMBDA] = STATE(8152),
    [sym__ELLIPSIS] = STATE(5168),
    [sym__qid] = STATE(5168),
    [sym__binding_ids_and_absurds] = STATE(12358),
    [sym_attribute] = STATE(7725),
    [sym_attributes] = STATE(6182),
    [sym_expr] = STATE(12617),
    [sym__with_exprs] = STATE(9861),
    [sym__expr_or_attr] = STATE(5168),
    [sym__application] = STATE(9444),
    [sym__expr2_without_let] = STATE(9444),
    [sym__expr2] = STATE(9444),
    [sym_atom] = STATE(5204),
    [aux_sym__atoms] = STATE(3133),
    [sym__atom_curly] = STATE(5180),
    [sym__atom_no_curly] = STATE(5180),
    [sym_forall] = STATE(9444),
    [sym_let] = STATE(9444),
    [sym_lambda] = STATE(9444),
    [sym_lambda_extended_or_absurd] = STATE(9444),
    [sym_do] = STATE(9444),
    [sym_record_assignments] = STATE(5168),
    [sym_field_assignments] = STATE(5168),
    [aux_sym__typed_bindings] = STATE(8654),
    [sym_typed_binding] = STATE(8654),
    [sym_literal] = STATE(5168),
    [sym_SetN] = STATE(5168),
    [aux_sym__modal_arg_ids_repeat1] = STATE(7725),
    [aux_sym__with_exprs_repeat1] = STATE(3754),
    [sym_id] = ACTIONS(850),
    [anon_sym_forall] = ACTIONS(852),
    [anon_sym_u2200] = ACTIONS(852),
    [anon_sym_BSLASH] = ACTIONS(854),
    [anon_sym_u03bb] = ACTIONS(856),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(858),
    [anon_sym_u2026] = ACTIONS(858),
    [anon_sym_record] = ACTIONS(860),
    [anon_sym_LPAREN] = ACTIONS(862),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(864),
    [anon_sym_u2983] = ACTIONS(866),
    [anon_sym_u2984] = ACTIONS(1030),
    [anon_sym__] = ACTIONS(858),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(870),
    [aux_sym__qid_token1] = ACTIONS(872),
    [anon_sym_DOT] = ACTIONS(874),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(760),
    [anon_sym_quoteGoal] = ACTIONS(878),
    [anon_sym_tactic] = ACTIONS(880),
    [anon_sym_Prop] = ACTIONS(858),
    [anon_sym_quote] = ACTIONS(858),
    [anon_sym_quoteTerm] = ACTIONS(858),
    [anon_sym_quoteContext] = ACTIONS(858),
    [anon_sym_unquote] = ACTIONS(858),
    [anon_sym_LPAREN_PIPE] = ACTIONS(882),
    [anon_sym_u2987] = ACTIONS(884),
    [anon_sym_let] = ACTIONS(886),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(890),
    [aux_sym_string_token1] = ACTIONS(890),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(892),
    [sym_PropN] = ACTIONS(858),
  },
  [376] = {
    [sym__FORALL] = STATE(8355),
    [sym__LAMBDA] = STATE(8054),
    [sym__ELLIPSIS] = STATE(4742),
    [sym__qid] = STATE(4742),
    [sym__binding_ids_and_absurds] = STATE(12547),
    [sym_attribute] = STATE(5830),
    [sym_attributes] = STATE(3506),
    [sym_expr] = STATE(10948),
    [sym__with_exprs] = STATE(10050),
    [sym__expr_or_attr] = STATE(4742),
    [sym__application] = STATE(9444),
    [sym__expr2_without_let] = STATE(9444),
    [sym__expr2] = STATE(9444),
    [sym_atom] = STATE(4712),
    [aux_sym__atoms] = STATE(3276),
    [sym__atom_curly] = STATE(4733),
    [sym__atom_no_curly] = STATE(4733),
    [sym_forall] = STATE(9444),
    [sym_let] = STATE(9444),
    [sym_lambda] = STATE(9444),
    [sym_lambda_extended_or_absurd] = STATE(9444),
    [sym_do] = STATE(9444),
    [sym_record_assignments] = STATE(4742),
    [sym_field_assignments] = STATE(4742),
    [aux_sym__typed_bindings] = STATE(8646),
    [sym_typed_binding] = STATE(8646),
    [sym_literal] = STATE(4742),
    [sym_SetN] = STATE(4742),
    [aux_sym__modal_arg_ids_repeat1] = STATE(5830),
    [aux_sym__with_exprs_repeat1] = STATE(3745),
    [sym_id] = ACTIONS(940),
    [anon_sym_forall] = ACTIONS(942),
    [anon_sym_u2200] = ACTIONS(942),
    [anon_sym_BSLASH] = ACTIONS(944),
    [anon_sym_u03bb] = ACTIONS(946),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(948),
    [anon_sym_u2026] = ACTIONS(948),
    [anon_sym_record] = ACTIONS(950),
    [anon_sym_LPAREN] = ACTIONS(952),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(954),
    [anon_sym_RBRACE_RBRACE] = ACTIONS(1024),
    [anon_sym_u2983] = ACTIONS(956),
    [anon_sym__] = ACTIONS(948),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(958),
    [aux_sym__qid_token1] = ACTIONS(960),
    [anon_sym_DOT] = ACTIONS(962),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(712),
    [anon_sym_quoteGoal] = ACTIONS(964),
    [anon_sym_tactic] = ACTIONS(966),
    [anon_sym_Prop] = ACTIONS(948),
    [anon_sym_quote] = ACTIONS(948),
    [anon_sym_quoteTerm] = ACTIONS(948),
    [anon_sym_quoteContext] = ACTIONS(948),
    [anon_sym_unquote] = ACTIONS(948),
    [anon_sym_LPAREN_PIPE] = ACTIONS(968),
    [anon_sym_u2987] = ACTIONS(970),
    [anon_sym_let] = ACTIONS(972),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(974),
    [aux_sym_string_token1] = ACTIONS(974),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(976),
    [sym_PropN] = ACTIONS(948),
  },
  [377] = {
    [sym__FORALL] = STATE(8345),
    [sym__LAMBDA] = STATE(8095),
    [sym__ELLIPSIS] = STATE(4742),
    [sym_open] = STATE(12555),
    [sym__qid] = STATE(4742),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3873),
    [sym_expr] = STATE(10872),
    [sym__with_exprs] = STATE(10084),
    [sym__expr_or_attr] = STATE(4742),
    [sym__application] = STATE(9680),
    [sym__expr2_without_let] = STATE(9680),
    [sym__expr2] = STATE(9680),
    [sym_atom] = STATE(4712),
    [aux_sym__atoms] = STATE(3211),
    [sym__atom_curly] = STATE(4733),
    [sym__atom_no_curly] = STATE(4733),
    [sym_forall] = STATE(9680),
    [sym_let] = STATE(9680),
    [sym_lambda] = STATE(9680),
    [sym_lambda_extended_or_absurd] = STATE(9680),
    [sym_do] = STATE(9680),
    [sym_record_assignments] = STATE(4742),
    [sym_field_assignments] = STATE(4742),
    [aux_sym__typed_bindings] = STATE(8642),
    [sym_typed_binding] = STATE(8642),
    [sym_literal] = STATE(4742),
    [sym_SetN] = STATE(4742),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3728),
    [sym_id] = ACTIONS(940),
    [anon_sym_forall] = ACTIONS(980),
    [anon_sym_u2200] = ACTIONS(980),
    [anon_sym_BSLASH] = ACTIONS(982),
    [anon_sym_u03bb] = ACTIONS(984),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(948),
    [anon_sym_u2026] = ACTIONS(948),
    [anon_sym_record] = ACTIONS(950),
    [anon_sym_open] = ACTIONS(986),
    [anon_sym_LPAREN] = ACTIONS(952),
    [anon_sym_RPAREN] = ACTIONS(1024),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(954),
    [anon_sym_u2983] = ACTIONS(956),
    [anon_sym__] = ACTIONS(948),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(958),
    [aux_sym__qid_token1] = ACTIONS(960),
    [anon_sym_DOT] = ACTIONS(962),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(988),
    [anon_sym_tactic] = ACTIONS(990),
    [anon_sym_Prop] = ACTIONS(948),
    [anon_sym_quote] = ACTIONS(948),
    [anon_sym_quoteTerm] = ACTIONS(948),
    [anon_sym_quoteContext] = ACTIONS(948),
    [anon_sym_unquote] = ACTIONS(948),
    [anon_sym_LPAREN_PIPE] = ACTIONS(968),
    [anon_sym_u2987] = ACTIONS(970),
    [anon_sym_let] = ACTIONS(992),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(974),
    [aux_sym_string_token1] = ACTIONS(974),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(976),
    [sym_PropN] = ACTIONS(948),
  },
  [378] = {
    [sym__FORALL] = STATE(8396),
    [sym__LAMBDA] = STATE(8031),
    [sym__ELLIPSIS] = STATE(4920),
    [sym__qid] = STATE(4920),
    [sym__binding_ids_and_absurds] = STATE(12539),
    [sym_attribute] = STATE(5830),
    [sym_attributes] = STATE(3504),
    [sym_expr] = STATE(12042),
    [sym__with_exprs] = STATE(10196),
    [sym__expr_or_attr] = STATE(4920),
    [sym__application] = STATE(9678),
    [sym__expr2_without_let] = STATE(9678),
    [sym__expr2] = STATE(9678),
    [sym_atom] = STATE(5202),
    [aux_sym__atoms] = STATE(3165),
    [sym__atom_curly] = STATE(4961),
    [sym__atom_no_curly] = STATE(4961),
    [sym_forall] = STATE(9678),
    [sym_let] = STATE(9678),
    [sym_lambda] = STATE(9678),
    [sym_lambda_extended_or_absurd] = STATE(9678),
    [sym_do] = STATE(9678),
    [sym_record_assignments] = STATE(4920),
    [sym_field_assignments] = STATE(4920),
    [aux_sym__typed_bindings] = STATE(8648),
    [sym_typed_binding] = STATE(8648),
    [sym_literal] = STATE(4920),
    [sym_SetN] = STATE(4920),
    [aux_sym__modal_arg_ids_repeat1] = STATE(5830),
    [aux_sym__with_exprs_repeat1] = STATE(3726),
    [sym_id] = ACTIONS(894),
    [anon_sym_forall] = ACTIONS(896),
    [anon_sym_u2200] = ACTIONS(896),
    [anon_sym_BSLASH] = ACTIONS(898),
    [anon_sym_u03bb] = ACTIONS(900),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(902),
    [anon_sym_u2026] = ACTIONS(902),
    [anon_sym_record] = ACTIONS(904),
    [anon_sym_LPAREN] = ACTIONS(906),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(908),
    [anon_sym_u2983] = ACTIONS(910),
    [anon_sym__] = ACTIONS(902),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(912),
    [anon_sym_RBRACE] = ACTIONS(1012),
    [aux_sym__qid_token1] = ACTIONS(916),
    [anon_sym_DOT] = ACTIONS(918),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(712),
    [anon_sym_quoteGoal] = ACTIONS(920),
    [anon_sym_tactic] = ACTIONS(922),
    [anon_sym_Prop] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(902),
    [anon_sym_quoteTerm] = ACTIONS(902),
    [anon_sym_quoteContext] = ACTIONS(902),
    [anon_sym_unquote] = ACTIONS(902),
    [anon_sym_LPAREN_PIPE] = ACTIONS(924),
    [anon_sym_u2987] = ACTIONS(926),
    [anon_sym_let] = ACTIONS(928),
    [anon_sym_do] = ACTIONS(724),
    [aux_sym_integer_token1] = ACTIONS(930),
    [aux_sym_string_token1] = ACTIONS(930),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(932),
    [sym_PropN] = ACTIONS(902),
  },
  [379] = {
    [sym__FORALL] = STATE(8369),
    [sym__LAMBDA] = STATE(8152),
    [sym__ELLIPSIS] = STATE(5168),
    [sym__qid] = STATE(5168),
    [sym__binding_ids_and_absurds] = STATE(12544),
    [sym_attribute] = STATE(5830),
    [sym_attributes] = STATE(3505),
    [sym_expr] = STATE(11325),
    [sym__with_exprs] = STATE(9861),
    [sym__expr_or_attr] = STATE(5168),
    [sym__application] = STATE(9444),
    [sym__expr2_without_let] = STATE(9444),
    [sym__expr2] = STATE(9444),
    [sym_atom] = STATE(5204),
    [aux_sym__atoms] = STATE(3133),
    [sym__atom_curly] = STATE(5180),
    [sym__atom_no_curly] = STATE(5180),
    [sym_forall] = STATE(9444),
    [sym_let] = STATE(9444),
    [sym_lambda] = STATE(9444),
    [sym_lambda_extended_or_absurd] = STATE(9444),
    [sym_do] = STATE(9444),
    [sym_record_assignments] = STATE(5168),
    [sym_field_assignments] = STATE(5168),
    [aux_sym__typed_bindings] = STATE(8654),
    [sym_typed_binding] = STATE(8654),
    [sym_literal] = STATE(5168),
    [sym_SetN] = STATE(5168),
    [aux_sym__modal_arg_ids_repeat1] = STATE(5830),
    [aux_sym__with_exprs_repeat1] = STATE(3754),
    [sym_id] = ACTIONS(850),
    [anon_sym_forall] = ACTIONS(852),
    [anon_sym_u2200] = ACTIONS(852),
    [anon_sym_BSLASH] = ACTIONS(854),
    [anon_sym_u03bb] = ACTIONS(856),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(858),
    [anon_sym_u2026] = ACTIONS(858),
    [anon_sym_record] = ACTIONS(860),
    [anon_sym_LPAREN] = ACTIONS(862),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(864),
    [anon_sym_u2983] = ACTIONS(866),
    [anon_sym_u2984] = ACTIONS(1008),
    [anon_sym__] = ACTIONS(858),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(870),
    [aux_sym__qid_token1] = ACTIONS(872),
    [anon_sym_DOT] = ACTIONS(874),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(712),
    [anon_sym_quoteGoal] = ACTIONS(878),
    [anon_sym_tactic] = ACTIONS(880),
    [anon_sym_Prop] = ACTIONS(858),
    [anon_sym_quote] = ACTIONS(858),
    [anon_sym_quoteTerm] = ACTIONS(858),
    [anon_sym_quoteContext] = ACTIONS(858),
    [anon_sym_unquote] = ACTIONS(858),
    [anon_sym_LPAREN_PIPE] = ACTIONS(882),
    [anon_sym_u2987] = ACTIONS(884),
    [anon_sym_let] = ACTIONS(886),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(890),
    [aux_sym_string_token1] = ACTIONS(890),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(892),
    [sym_PropN] = ACTIONS(858),
  },
  [380] = {
    [sym__FORALL] = STATE(8369),
    [sym__LAMBDA] = STATE(8152),
    [sym__ELLIPSIS] = STATE(5168),
    [sym__qid] = STATE(5168),
    [sym__binding_ids_and_absurds] = STATE(12544),
    [sym_attribute] = STATE(5830),
    [sym_attributes] = STATE(3505),
    [sym_expr] = STATE(12040),
    [sym__with_exprs] = STATE(9861),
    [sym__expr_or_attr] = STATE(5168),
    [sym__application] = STATE(9444),
    [sym__expr2_without_let] = STATE(9444),
    [sym__expr2] = STATE(9444),
    [sym_atom] = STATE(5204),
    [aux_sym__atoms] = STATE(3133),
    [sym__atom_curly] = STATE(5180),
    [sym__atom_no_curly] = STATE(5180),
    [sym_forall] = STATE(9444),
    [sym_let] = STATE(9444),
    [sym_lambda] = STATE(9444),
    [sym_lambda_extended_or_absurd] = STATE(9444),
    [sym_do] = STATE(9444),
    [sym_record_assignments] = STATE(5168),
    [sym_field_assignments] = STATE(5168),
    [aux_sym__typed_bindings] = STATE(8654),
    [sym_typed_binding] = STATE(8654),
    [sym_literal] = STATE(5168),
    [sym_SetN] = STATE(5168),
    [aux_sym__modal_arg_ids_repeat1] = STATE(5830),
    [aux_sym__with_exprs_repeat1] = STATE(3754),
    [sym_id] = ACTIONS(850),
    [anon_sym_forall] = ACTIONS(852),
    [anon_sym_u2200] = ACTIONS(852),
    [anon_sym_BSLASH] = ACTIONS(854),
    [anon_sym_u03bb] = ACTIONS(856),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(858),
    [anon_sym_u2026] = ACTIONS(858),
    [anon_sym_record] = ACTIONS(860),
    [anon_sym_LPAREN] = ACTIONS(862),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(864),
    [anon_sym_u2983] = ACTIONS(866),
    [anon_sym_u2984] = ACTIONS(1016),
    [anon_sym__] = ACTIONS(858),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(870),
    [aux_sym__qid_token1] = ACTIONS(872),
    [anon_sym_DOT] = ACTIONS(874),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(712),
    [anon_sym_quoteGoal] = ACTIONS(878),
    [anon_sym_tactic] = ACTIONS(880),
    [anon_sym_Prop] = ACTIONS(858),
    [anon_sym_quote] = ACTIONS(858),
    [anon_sym_quoteTerm] = ACTIONS(858),
    [anon_sym_quoteContext] = ACTIONS(858),
    [anon_sym_unquote] = ACTIONS(858),
    [anon_sym_LPAREN_PIPE] = ACTIONS(882),
    [anon_sym_u2987] = ACTIONS(884),
    [anon_sym_let] = ACTIONS(886),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(890),
    [aux_sym_string_token1] = ACTIONS(890),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(892),
    [sym_PropN] = ACTIONS(858),
  },
  [381] = {
    [sym__FORALL] = STATE(8355),
    [sym__LAMBDA] = STATE(8054),
    [sym__ELLIPSIS] = STATE(4742),
    [sym__qid] = STATE(4742),
    [sym__binding_ids_and_absurds] = STATE(12547),
    [sym_attribute] = STATE(5830),
    [sym_attributes] = STATE(3506),
    [sym_expr] = STATE(12039),
    [sym__with_exprs] = STATE(10050),
    [sym__expr_or_attr] = STATE(4742),
    [sym__application] = STATE(9444),
    [sym__expr2_without_let] = STATE(9444),
    [sym__expr2] = STATE(9444),
    [sym_atom] = STATE(4712),
    [aux_sym__atoms] = STATE(3276),
    [sym__atom_curly] = STATE(4733),
    [sym__atom_no_curly] = STATE(4733),
    [sym_forall] = STATE(9444),
    [sym_let] = STATE(9444),
    [sym_lambda] = STATE(9444),
    [sym_lambda_extended_or_absurd] = STATE(9444),
    [sym_do] = STATE(9444),
    [sym_record_assignments] = STATE(4742),
    [sym_field_assignments] = STATE(4742),
    [aux_sym__typed_bindings] = STATE(8646),
    [sym_typed_binding] = STATE(8646),
    [sym_literal] = STATE(4742),
    [sym_SetN] = STATE(4742),
    [aux_sym__modal_arg_ids_repeat1] = STATE(5830),
    [aux_sym__with_exprs_repeat1] = STATE(3745),
    [sym_id] = ACTIONS(940),
    [anon_sym_forall] = ACTIONS(942),
    [anon_sym_u2200] = ACTIONS(942),
    [anon_sym_BSLASH] = ACTIONS(944),
    [anon_sym_u03bb] = ACTIONS(946),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(948),
    [anon_sym_u2026] = ACTIONS(948),
    [anon_sym_record] = ACTIONS(950),
    [anon_sym_LPAREN] = ACTIONS(952),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(954),
    [anon_sym_RBRACE_RBRACE] = ACTIONS(1016),
    [anon_sym_u2983] = ACTIONS(956),
    [anon_sym__] = ACTIONS(948),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(958),
    [aux_sym__qid_token1] = ACTIONS(960),
    [anon_sym_DOT] = ACTIONS(962),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(712),
    [anon_sym_quoteGoal] = ACTIONS(964),
    [anon_sym_tactic] = ACTIONS(966),
    [anon_sym_Prop] = ACTIONS(948),
    [anon_sym_quote] = ACTIONS(948),
    [anon_sym_quoteTerm] = ACTIONS(948),
    [anon_sym_quoteContext] = ACTIONS(948),
    [anon_sym_unquote] = ACTIONS(948),
    [anon_sym_LPAREN_PIPE] = ACTIONS(968),
    [anon_sym_u2987] = ACTIONS(970),
    [anon_sym_let] = ACTIONS(972),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(974),
    [aux_sym_string_token1] = ACTIONS(974),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(976),
    [sym_PropN] = ACTIONS(948),
  },
  [382] = {
    [sym__FORALL] = STATE(8345),
    [sym__LAMBDA] = STATE(8095),
    [sym__ELLIPSIS] = STATE(4742),
    [sym_open] = STATE(12555),
    [sym__qid] = STATE(4742),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3873),
    [sym_expr] = STATE(12191),
    [sym__with_exprs] = STATE(10084),
    [sym__expr_or_attr] = STATE(4742),
    [sym__application] = STATE(9680),
    [sym__expr2_without_let] = STATE(9680),
    [sym__expr2] = STATE(9680),
    [sym_atom] = STATE(4712),
    [aux_sym__atoms] = STATE(3211),
    [sym__atom_curly] = STATE(4733),
    [sym__atom_no_curly] = STATE(4733),
    [sym_forall] = STATE(9680),
    [sym_let] = STATE(9680),
    [sym_lambda] = STATE(9680),
    [sym_lambda_extended_or_absurd] = STATE(9680),
    [sym_do] = STATE(9680),
    [sym_record_assignments] = STATE(4742),
    [sym_field_assignments] = STATE(4742),
    [aux_sym__typed_bindings] = STATE(8642),
    [sym_typed_binding] = STATE(8642),
    [sym_literal] = STATE(4742),
    [sym_SetN] = STATE(4742),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3728),
    [sym_id] = ACTIONS(940),
    [anon_sym_forall] = ACTIONS(980),
    [anon_sym_u2200] = ACTIONS(980),
    [anon_sym_BSLASH] = ACTIONS(982),
    [anon_sym_u03bb] = ACTIONS(984),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(948),
    [anon_sym_u2026] = ACTIONS(948),
    [anon_sym_record] = ACTIONS(950),
    [anon_sym_open] = ACTIONS(986),
    [anon_sym_LPAREN] = ACTIONS(952),
    [anon_sym_RPAREN] = ACTIONS(1016),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(954),
    [anon_sym_u2983] = ACTIONS(956),
    [anon_sym__] = ACTIONS(948),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(958),
    [aux_sym__qid_token1] = ACTIONS(960),
    [anon_sym_DOT] = ACTIONS(962),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(988),
    [anon_sym_tactic] = ACTIONS(990),
    [anon_sym_Prop] = ACTIONS(948),
    [anon_sym_quote] = ACTIONS(948),
    [anon_sym_quoteTerm] = ACTIONS(948),
    [anon_sym_quoteContext] = ACTIONS(948),
    [anon_sym_unquote] = ACTIONS(948),
    [anon_sym_LPAREN_PIPE] = ACTIONS(968),
    [anon_sym_u2987] = ACTIONS(970),
    [anon_sym_let] = ACTIONS(992),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(974),
    [aux_sym_string_token1] = ACTIONS(974),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(976),
    [sym_PropN] = ACTIONS(948),
  },
  [383] = {
    [sym__FORALL] = STATE(8355),
    [sym__LAMBDA] = STATE(8054),
    [sym__ELLIPSIS] = STATE(4742),
    [sym__qid] = STATE(4742),
    [sym__binding_ids_and_absurds] = STATE(12547),
    [sym_attribute] = STATE(5830),
    [sym_attributes] = STATE(3506),
    [sym_expr] = STATE(11326),
    [sym__with_exprs] = STATE(10050),
    [sym__expr_or_attr] = STATE(4742),
    [sym__application] = STATE(9444),
    [sym__expr2_without_let] = STATE(9444),
    [sym__expr2] = STATE(9444),
    [sym_atom] = STATE(4712),
    [aux_sym__atoms] = STATE(3276),
    [sym__atom_curly] = STATE(4733),
    [sym__atom_no_curly] = STATE(4733),
    [sym_forall] = STATE(9444),
    [sym_let] = STATE(9444),
    [sym_lambda] = STATE(9444),
    [sym_lambda_extended_or_absurd] = STATE(9444),
    [sym_do] = STATE(9444),
    [sym_record_assignments] = STATE(4742),
    [sym_field_assignments] = STATE(4742),
    [aux_sym__typed_bindings] = STATE(8646),
    [sym_typed_binding] = STATE(8646),
    [sym_literal] = STATE(4742),
    [sym_SetN] = STATE(4742),
    [aux_sym__modal_arg_ids_repeat1] = STATE(5830),
    [aux_sym__with_exprs_repeat1] = STATE(3745),
    [sym_id] = ACTIONS(940),
    [anon_sym_forall] = ACTIONS(942),
    [anon_sym_u2200] = ACTIONS(942),
    [anon_sym_BSLASH] = ACTIONS(944),
    [anon_sym_u03bb] = ACTIONS(946),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(948),
    [anon_sym_u2026] = ACTIONS(948),
    [anon_sym_record] = ACTIONS(950),
    [anon_sym_LPAREN] = ACTIONS(952),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(954),
    [anon_sym_RBRACE_RBRACE] = ACTIONS(1008),
    [anon_sym_u2983] = ACTIONS(956),
    [anon_sym__] = ACTIONS(948),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(958),
    [aux_sym__qid_token1] = ACTIONS(960),
    [anon_sym_DOT] = ACTIONS(962),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(712),
    [anon_sym_quoteGoal] = ACTIONS(964),
    [anon_sym_tactic] = ACTIONS(966),
    [anon_sym_Prop] = ACTIONS(948),
    [anon_sym_quote] = ACTIONS(948),
    [anon_sym_quoteTerm] = ACTIONS(948),
    [anon_sym_quoteContext] = ACTIONS(948),
    [anon_sym_unquote] = ACTIONS(948),
    [anon_sym_LPAREN_PIPE] = ACTIONS(968),
    [anon_sym_u2987] = ACTIONS(970),
    [anon_sym_let] = ACTIONS(972),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(974),
    [aux_sym_string_token1] = ACTIONS(974),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(976),
    [sym_PropN] = ACTIONS(948),
  },
  [384] = {
    [sym__FORALL] = STATE(8345),
    [sym__LAMBDA] = STATE(8095),
    [sym__ELLIPSIS] = STATE(4742),
    [sym_open] = STATE(12555),
    [sym__qid] = STATE(4742),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3873),
    [sym_expr] = STATE(11290),
    [sym__with_exprs] = STATE(10084),
    [sym__expr_or_attr] = STATE(4742),
    [sym__application] = STATE(9680),
    [sym__expr2_without_let] = STATE(9680),
    [sym__expr2] = STATE(9680),
    [sym_atom] = STATE(4712),
    [aux_sym__atoms] = STATE(3211),
    [sym__atom_curly] = STATE(4733),
    [sym__atom_no_curly] = STATE(4733),
    [sym_forall] = STATE(9680),
    [sym_let] = STATE(9680),
    [sym_lambda] = STATE(9680),
    [sym_lambda_extended_or_absurd] = STATE(9680),
    [sym_do] = STATE(9680),
    [sym_record_assignments] = STATE(4742),
    [sym_field_assignments] = STATE(4742),
    [aux_sym__typed_bindings] = STATE(8642),
    [sym_typed_binding] = STATE(8642),
    [sym_literal] = STATE(4742),
    [sym_SetN] = STATE(4742),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3728),
    [sym_id] = ACTIONS(940),
    [anon_sym_forall] = ACTIONS(980),
    [anon_sym_u2200] = ACTIONS(980),
    [anon_sym_BSLASH] = ACTIONS(982),
    [anon_sym_u03bb] = ACTIONS(984),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(948),
    [anon_sym_u2026] = ACTIONS(948),
    [anon_sym_record] = ACTIONS(950),
    [anon_sym_open] = ACTIONS(986),
    [anon_sym_LPAREN] = ACTIONS(952),
    [anon_sym_RPAREN] = ACTIONS(1008),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(954),
    [anon_sym_u2983] = ACTIONS(956),
    [anon_sym__] = ACTIONS(948),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(958),
    [aux_sym__qid_token1] = ACTIONS(960),
    [anon_sym_DOT] = ACTIONS(962),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(988),
    [anon_sym_tactic] = ACTIONS(990),
    [anon_sym_Prop] = ACTIONS(948),
    [anon_sym_quote] = ACTIONS(948),
    [anon_sym_quoteTerm] = ACTIONS(948),
    [anon_sym_quoteContext] = ACTIONS(948),
    [anon_sym_unquote] = ACTIONS(948),
    [anon_sym_LPAREN_PIPE] = ACTIONS(968),
    [anon_sym_u2987] = ACTIONS(970),
    [anon_sym_let] = ACTIONS(992),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(974),
    [aux_sym_string_token1] = ACTIONS(974),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(976),
    [sym_PropN] = ACTIONS(948),
  },
  [385] = {
    [sym__FORALL] = STATE(8396),
    [sym__LAMBDA] = STATE(8031),
    [sym__ELLIPSIS] = STATE(4920),
    [sym__qid] = STATE(4920),
    [sym__binding_ids_and_absurds] = STATE(12357),
    [sym_attribute] = STATE(7725),
    [sym_attributes] = STATE(6200),
    [sym_expr] = STATE(11163),
    [sym__with_exprs] = STATE(10196),
    [sym__expr_or_attr] = STATE(4920),
    [sym__application] = STATE(9678),
    [sym__expr2_without_let] = STATE(9678),
    [sym__expr2] = STATE(9678),
    [sym_atom] = STATE(5202),
    [aux_sym__atoms] = STATE(3165),
    [sym__atom_curly] = STATE(4961),
    [sym__atom_no_curly] = STATE(4961),
    [sym_forall] = STATE(9678),
    [sym_let] = STATE(9678),
    [sym_lambda] = STATE(9678),
    [sym_lambda_extended_or_absurd] = STATE(9678),
    [sym_do] = STATE(9678),
    [sym_record_assignments] = STATE(4920),
    [sym_field_assignments] = STATE(4920),
    [aux_sym__typed_bindings] = STATE(8648),
    [sym_typed_binding] = STATE(8648),
    [sym_literal] = STATE(4920),
    [sym_SetN] = STATE(4920),
    [aux_sym__modal_arg_ids_repeat1] = STATE(7725),
    [aux_sym__with_exprs_repeat1] = STATE(3726),
    [sym_id] = ACTIONS(894),
    [anon_sym_forall] = ACTIONS(896),
    [anon_sym_u2200] = ACTIONS(896),
    [anon_sym_BSLASH] = ACTIONS(898),
    [anon_sym_u03bb] = ACTIONS(900),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(902),
    [anon_sym_u2026] = ACTIONS(902),
    [anon_sym_record] = ACTIONS(904),
    [anon_sym_LPAREN] = ACTIONS(906),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(908),
    [anon_sym_u2983] = ACTIONS(910),
    [anon_sym__] = ACTIONS(902),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(912),
    [anon_sym_RBRACE] = ACTIONS(1032),
    [aux_sym__qid_token1] = ACTIONS(916),
    [anon_sym_DOT] = ACTIONS(918),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(760),
    [anon_sym_quoteGoal] = ACTIONS(920),
    [anon_sym_tactic] = ACTIONS(922),
    [anon_sym_Prop] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(902),
    [anon_sym_quoteTerm] = ACTIONS(902),
    [anon_sym_quoteContext] = ACTIONS(902),
    [anon_sym_unquote] = ACTIONS(902),
    [anon_sym_LPAREN_PIPE] = ACTIONS(924),
    [anon_sym_u2987] = ACTIONS(926),
    [anon_sym_let] = ACTIONS(928),
    [anon_sym_do] = ACTIONS(724),
    [aux_sym_integer_token1] = ACTIONS(930),
    [aux_sym_string_token1] = ACTIONS(930),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(932),
    [sym_PropN] = ACTIONS(902),
  },
  [386] = {
    [sym__FORALL] = STATE(8369),
    [sym__LAMBDA] = STATE(8152),
    [sym__ELLIPSIS] = STATE(5168),
    [sym__qid] = STATE(5168),
    [sym__binding_ids_and_absurds] = STATE(12358),
    [sym_attribute] = STATE(7725),
    [sym_attributes] = STATE(6182),
    [sym_expr] = STATE(11166),
    [sym__with_exprs] = STATE(9861),
    [sym__expr_or_attr] = STATE(5168),
    [sym__application] = STATE(9444),
    [sym__expr2_without_let] = STATE(9444),
    [sym__expr2] = STATE(9444),
    [sym_atom] = STATE(5204),
    [aux_sym__atoms] = STATE(3133),
    [sym__atom_curly] = STATE(5180),
    [sym__atom_no_curly] = STATE(5180),
    [sym_forall] = STATE(9444),
    [sym_let] = STATE(9444),
    [sym_lambda] = STATE(9444),
    [sym_lambda_extended_or_absurd] = STATE(9444),
    [sym_do] = STATE(9444),
    [sym_record_assignments] = STATE(5168),
    [sym_field_assignments] = STATE(5168),
    [aux_sym__typed_bindings] = STATE(8654),
    [sym_typed_binding] = STATE(8654),
    [sym_literal] = STATE(5168),
    [sym_SetN] = STATE(5168),
    [aux_sym__modal_arg_ids_repeat1] = STATE(7725),
    [aux_sym__with_exprs_repeat1] = STATE(3754),
    [sym_id] = ACTIONS(850),
    [anon_sym_forall] = ACTIONS(852),
    [anon_sym_u2200] = ACTIONS(852),
    [anon_sym_BSLASH] = ACTIONS(854),
    [anon_sym_u03bb] = ACTIONS(856),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(858),
    [anon_sym_u2026] = ACTIONS(858),
    [anon_sym_record] = ACTIONS(860),
    [anon_sym_LPAREN] = ACTIONS(862),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(864),
    [anon_sym_u2983] = ACTIONS(866),
    [anon_sym_u2984] = ACTIONS(1034),
    [anon_sym__] = ACTIONS(858),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(870),
    [aux_sym__qid_token1] = ACTIONS(872),
    [anon_sym_DOT] = ACTIONS(874),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(760),
    [anon_sym_quoteGoal] = ACTIONS(878),
    [anon_sym_tactic] = ACTIONS(880),
    [anon_sym_Prop] = ACTIONS(858),
    [anon_sym_quote] = ACTIONS(858),
    [anon_sym_quoteTerm] = ACTIONS(858),
    [anon_sym_quoteContext] = ACTIONS(858),
    [anon_sym_unquote] = ACTIONS(858),
    [anon_sym_LPAREN_PIPE] = ACTIONS(882),
    [anon_sym_u2987] = ACTIONS(884),
    [anon_sym_let] = ACTIONS(886),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(890),
    [aux_sym_string_token1] = ACTIONS(890),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(892),
    [sym_PropN] = ACTIONS(858),
  },
  [387] = {
    [sym__FORALL] = STATE(8355),
    [sym__LAMBDA] = STATE(8054),
    [sym__ELLIPSIS] = STATE(4742),
    [sym__qid] = STATE(4742),
    [sym__binding_ids_and_absurds] = STATE(12359),
    [sym_attribute] = STATE(7725),
    [sym_attributes] = STATE(6302),
    [sym_expr] = STATE(12619),
    [sym__with_exprs] = STATE(10050),
    [sym__expr_or_attr] = STATE(4742),
    [sym__application] = STATE(9444),
    [sym__expr2_without_let] = STATE(9444),
    [sym__expr2] = STATE(9444),
    [sym_atom] = STATE(4712),
    [aux_sym__atoms] = STATE(3276),
    [sym__atom_curly] = STATE(4733),
    [sym__atom_no_curly] = STATE(4733),
    [sym_forall] = STATE(9444),
    [sym_let] = STATE(9444),
    [sym_lambda] = STATE(9444),
    [sym_lambda_extended_or_absurd] = STATE(9444),
    [sym_do] = STATE(9444),
    [sym_record_assignments] = STATE(4742),
    [sym_field_assignments] = STATE(4742),
    [aux_sym__typed_bindings] = STATE(8646),
    [sym_typed_binding] = STATE(8646),
    [sym_literal] = STATE(4742),
    [sym_SetN] = STATE(4742),
    [aux_sym__modal_arg_ids_repeat1] = STATE(7725),
    [aux_sym__with_exprs_repeat1] = STATE(3745),
    [sym_id] = ACTIONS(940),
    [anon_sym_forall] = ACTIONS(942),
    [anon_sym_u2200] = ACTIONS(942),
    [anon_sym_BSLASH] = ACTIONS(944),
    [anon_sym_u03bb] = ACTIONS(946),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(948),
    [anon_sym_u2026] = ACTIONS(948),
    [anon_sym_record] = ACTIONS(950),
    [anon_sym_LPAREN] = ACTIONS(952),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(954),
    [anon_sym_RBRACE_RBRACE] = ACTIONS(1030),
    [anon_sym_u2983] = ACTIONS(956),
    [anon_sym__] = ACTIONS(948),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(958),
    [aux_sym__qid_token1] = ACTIONS(960),
    [anon_sym_DOT] = ACTIONS(962),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(760),
    [anon_sym_quoteGoal] = ACTIONS(964),
    [anon_sym_tactic] = ACTIONS(966),
    [anon_sym_Prop] = ACTIONS(948),
    [anon_sym_quote] = ACTIONS(948),
    [anon_sym_quoteTerm] = ACTIONS(948),
    [anon_sym_quoteContext] = ACTIONS(948),
    [anon_sym_unquote] = ACTIONS(948),
    [anon_sym_LPAREN_PIPE] = ACTIONS(968),
    [anon_sym_u2987] = ACTIONS(970),
    [anon_sym_let] = ACTIONS(972),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(974),
    [aux_sym_string_token1] = ACTIONS(974),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(976),
    [sym_PropN] = ACTIONS(948),
  },
  [388] = {
    [sym__FORALL] = STATE(8355),
    [sym__LAMBDA] = STATE(8054),
    [sym__ELLIPSIS] = STATE(4742),
    [sym__qid] = STATE(4742),
    [sym__binding_ids_and_absurds] = STATE(12359),
    [sym_attribute] = STATE(7725),
    [sym_attributes] = STATE(6302),
    [sym_expr] = STATE(11169),
    [sym__with_exprs] = STATE(10050),
    [sym__expr_or_attr] = STATE(4742),
    [sym__application] = STATE(9444),
    [sym__expr2_without_let] = STATE(9444),
    [sym__expr2] = STATE(9444),
    [sym_atom] = STATE(4712),
    [aux_sym__atoms] = STATE(3276),
    [sym__atom_curly] = STATE(4733),
    [sym__atom_no_curly] = STATE(4733),
    [sym_forall] = STATE(9444),
    [sym_let] = STATE(9444),
    [sym_lambda] = STATE(9444),
    [sym_lambda_extended_or_absurd] = STATE(9444),
    [sym_do] = STATE(9444),
    [sym_record_assignments] = STATE(4742),
    [sym_field_assignments] = STATE(4742),
    [aux_sym__typed_bindings] = STATE(8646),
    [sym_typed_binding] = STATE(8646),
    [sym_literal] = STATE(4742),
    [sym_SetN] = STATE(4742),
    [aux_sym__modal_arg_ids_repeat1] = STATE(7725),
    [aux_sym__with_exprs_repeat1] = STATE(3745),
    [sym_id] = ACTIONS(940),
    [anon_sym_forall] = ACTIONS(942),
    [anon_sym_u2200] = ACTIONS(942),
    [anon_sym_BSLASH] = ACTIONS(944),
    [anon_sym_u03bb] = ACTIONS(946),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(948),
    [anon_sym_u2026] = ACTIONS(948),
    [anon_sym_record] = ACTIONS(950),
    [anon_sym_LPAREN] = ACTIONS(952),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(954),
    [anon_sym_RBRACE_RBRACE] = ACTIONS(1034),
    [anon_sym_u2983] = ACTIONS(956),
    [anon_sym__] = ACTIONS(948),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(958),
    [aux_sym__qid_token1] = ACTIONS(960),
    [anon_sym_DOT] = ACTIONS(962),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(760),
    [anon_sym_quoteGoal] = ACTIONS(964),
    [anon_sym_tactic] = ACTIONS(966),
    [anon_sym_Prop] = ACTIONS(948),
    [anon_sym_quote] = ACTIONS(948),
    [anon_sym_quoteTerm] = ACTIONS(948),
    [anon_sym_quoteContext] = ACTIONS(948),
    [anon_sym_unquote] = ACTIONS(948),
    [anon_sym_LPAREN_PIPE] = ACTIONS(968),
    [anon_sym_u2987] = ACTIONS(970),
    [anon_sym_let] = ACTIONS(972),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(974),
    [aux_sym_string_token1] = ACTIONS(974),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(976),
    [sym_PropN] = ACTIONS(948),
  },
  [389] = {
    [sym__FORALL] = STATE(8355),
    [sym__LAMBDA] = STATE(8054),
    [sym__ELLIPSIS] = STATE(4742),
    [sym__qid] = STATE(4742),
    [sym__binding_ids_and_absurds] = STATE(12359),
    [sym_attribute] = STATE(7725),
    [sym_attributes] = STATE(6302),
    [sym_expr] = STATE(12746),
    [sym__with_exprs] = STATE(10050),
    [sym__expr_or_attr] = STATE(4742),
    [sym__application] = STATE(9444),
    [sym__expr2_without_let] = STATE(9444),
    [sym__expr2] = STATE(9444),
    [sym_atom] = STATE(4712),
    [aux_sym__atoms] = STATE(3276),
    [sym__atom_curly] = STATE(4733),
    [sym__atom_no_curly] = STATE(4733),
    [sym_forall] = STATE(9444),
    [sym_let] = STATE(9444),
    [sym_lambda] = STATE(9444),
    [sym_lambda_extended_or_absurd] = STATE(9444),
    [sym_do] = STATE(9444),
    [sym_record_assignments] = STATE(4742),
    [sym_field_assignments] = STATE(4742),
    [aux_sym__typed_bindings] = STATE(8646),
    [sym_typed_binding] = STATE(8646),
    [sym_literal] = STATE(4742),
    [sym_SetN] = STATE(4742),
    [aux_sym__modal_arg_ids_repeat1] = STATE(7725),
    [aux_sym__with_exprs_repeat1] = STATE(3745),
    [sym_id] = ACTIONS(940),
    [anon_sym_forall] = ACTIONS(942),
    [anon_sym_u2200] = ACTIONS(942),
    [anon_sym_BSLASH] = ACTIONS(944),
    [anon_sym_u03bb] = ACTIONS(946),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(948),
    [anon_sym_u2026] = ACTIONS(948),
    [anon_sym_record] = ACTIONS(950),
    [anon_sym_LPAREN] = ACTIONS(952),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(954),
    [anon_sym_RBRACE_RBRACE] = ACTIONS(1002),
    [anon_sym_u2983] = ACTIONS(956),
    [anon_sym__] = ACTIONS(948),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(958),
    [aux_sym__qid_token1] = ACTIONS(960),
    [anon_sym_DOT] = ACTIONS(962),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(760),
    [anon_sym_quoteGoal] = ACTIONS(964),
    [anon_sym_tactic] = ACTIONS(966),
    [anon_sym_Prop] = ACTIONS(948),
    [anon_sym_quote] = ACTIONS(948),
    [anon_sym_quoteTerm] = ACTIONS(948),
    [anon_sym_quoteContext] = ACTIONS(948),
    [anon_sym_unquote] = ACTIONS(948),
    [anon_sym_LPAREN_PIPE] = ACTIONS(968),
    [anon_sym_u2987] = ACTIONS(970),
    [anon_sym_let] = ACTIONS(972),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(974),
    [aux_sym_string_token1] = ACTIONS(974),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(976),
    [sym_PropN] = ACTIONS(948),
  },
  [390] = {
    [sym__FORALL] = STATE(8396),
    [sym__LAMBDA] = STATE(8031),
    [sym__ELLIPSIS] = STATE(4920),
    [sym__qid] = STATE(4920),
    [sym__binding_ids_and_absurds] = STATE(12539),
    [sym_attribute] = STATE(5830),
    [sym_attributes] = STATE(3504),
    [sym_expr] = STATE(11163),
    [sym__with_exprs] = STATE(10196),
    [sym__expr_or_attr] = STATE(4920),
    [sym__application] = STATE(9678),
    [sym__expr2_without_let] = STATE(9678),
    [sym__expr2] = STATE(9678),
    [sym_atom] = STATE(5202),
    [aux_sym__atoms] = STATE(3165),
    [sym__atom_curly] = STATE(4961),
    [sym__atom_no_curly] = STATE(4961),
    [sym_forall] = STATE(9678),
    [sym_let] = STATE(9678),
    [sym_lambda] = STATE(9678),
    [sym_lambda_extended_or_absurd] = STATE(9678),
    [sym_do] = STATE(9678),
    [sym_record_assignments] = STATE(4920),
    [sym_field_assignments] = STATE(4920),
    [aux_sym__typed_bindings] = STATE(8648),
    [sym_typed_binding] = STATE(8648),
    [sym_literal] = STATE(4920),
    [sym_SetN] = STATE(4920),
    [aux_sym__modal_arg_ids_repeat1] = STATE(5830),
    [aux_sym__with_exprs_repeat1] = STATE(3726),
    [sym_id] = ACTIONS(894),
    [anon_sym_forall] = ACTIONS(896),
    [anon_sym_u2200] = ACTIONS(896),
    [anon_sym_BSLASH] = ACTIONS(898),
    [anon_sym_u03bb] = ACTIONS(900),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(902),
    [anon_sym_u2026] = ACTIONS(902),
    [anon_sym_record] = ACTIONS(904),
    [anon_sym_LPAREN] = ACTIONS(906),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(908),
    [anon_sym_u2983] = ACTIONS(910),
    [anon_sym__] = ACTIONS(902),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(912),
    [anon_sym_RBRACE] = ACTIONS(1032),
    [aux_sym__qid_token1] = ACTIONS(916),
    [anon_sym_DOT] = ACTIONS(918),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(712),
    [anon_sym_quoteGoal] = ACTIONS(920),
    [anon_sym_tactic] = ACTIONS(922),
    [anon_sym_Prop] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(902),
    [anon_sym_quoteTerm] = ACTIONS(902),
    [anon_sym_quoteContext] = ACTIONS(902),
    [anon_sym_unquote] = ACTIONS(902),
    [anon_sym_LPAREN_PIPE] = ACTIONS(924),
    [anon_sym_u2987] = ACTIONS(926),
    [anon_sym_let] = ACTIONS(928),
    [anon_sym_do] = ACTIONS(724),
    [aux_sym_integer_token1] = ACTIONS(930),
    [aux_sym_string_token1] = ACTIONS(930),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(932),
    [sym_PropN] = ACTIONS(902),
  },
  [391] = {
    [sym__FORALL] = STATE(8396),
    [sym__LAMBDA] = STATE(8031),
    [sym__ELLIPSIS] = STATE(4920),
    [sym__qid] = STATE(4920),
    [sym__binding_ids_and_absurds] = STATE(12539),
    [sym_attribute] = STATE(5830),
    [sym_attributes] = STATE(3504),
    [sym_expr] = STATE(12615),
    [sym__with_exprs] = STATE(10196),
    [sym__expr_or_attr] = STATE(4920),
    [sym__application] = STATE(9678),
    [sym__expr2_without_let] = STATE(9678),
    [sym__expr2] = STATE(9678),
    [sym_atom] = STATE(5202),
    [aux_sym__atoms] = STATE(3165),
    [sym__atom_curly] = STATE(4961),
    [sym__atom_no_curly] = STATE(4961),
    [sym_forall] = STATE(9678),
    [sym_let] = STATE(9678),
    [sym_lambda] = STATE(9678),
    [sym_lambda_extended_or_absurd] = STATE(9678),
    [sym_do] = STATE(9678),
    [sym_record_assignments] = STATE(4920),
    [sym_field_assignments] = STATE(4920),
    [aux_sym__typed_bindings] = STATE(8648),
    [sym_typed_binding] = STATE(8648),
    [sym_literal] = STATE(4920),
    [sym_SetN] = STATE(4920),
    [aux_sym__modal_arg_ids_repeat1] = STATE(5830),
    [aux_sym__with_exprs_repeat1] = STATE(3726),
    [sym_id] = ACTIONS(894),
    [anon_sym_forall] = ACTIONS(896),
    [anon_sym_u2200] = ACTIONS(896),
    [anon_sym_BSLASH] = ACTIONS(898),
    [anon_sym_u03bb] = ACTIONS(900),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(902),
    [anon_sym_u2026] = ACTIONS(902),
    [anon_sym_record] = ACTIONS(904),
    [anon_sym_LPAREN] = ACTIONS(906),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(908),
    [anon_sym_u2983] = ACTIONS(910),
    [anon_sym__] = ACTIONS(902),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(912),
    [anon_sym_RBRACE] = ACTIONS(938),
    [aux_sym__qid_token1] = ACTIONS(916),
    [anon_sym_DOT] = ACTIONS(918),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(712),
    [anon_sym_quoteGoal] = ACTIONS(920),
    [anon_sym_tactic] = ACTIONS(922),
    [anon_sym_Prop] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(902),
    [anon_sym_quoteTerm] = ACTIONS(902),
    [anon_sym_quoteContext] = ACTIONS(902),
    [anon_sym_unquote] = ACTIONS(902),
    [anon_sym_LPAREN_PIPE] = ACTIONS(924),
    [anon_sym_u2987] = ACTIONS(926),
    [anon_sym_let] = ACTIONS(928),
    [anon_sym_do] = ACTIONS(724),
    [aux_sym_integer_token1] = ACTIONS(930),
    [aux_sym_string_token1] = ACTIONS(930),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(932),
    [sym_PropN] = ACTIONS(902),
  },
  [392] = {
    [sym__FORALL] = STATE(8369),
    [sym__LAMBDA] = STATE(8152),
    [sym__ELLIPSIS] = STATE(5168),
    [sym__qid] = STATE(5168),
    [sym__binding_ids_and_absurds] = STATE(12544),
    [sym_attribute] = STATE(5830),
    [sym_attributes] = STATE(3505),
    [sym_expr] = STATE(11166),
    [sym__with_exprs] = STATE(9861),
    [sym__expr_or_attr] = STATE(5168),
    [sym__application] = STATE(9444),
    [sym__expr2_without_let] = STATE(9444),
    [sym__expr2] = STATE(9444),
    [sym_atom] = STATE(5204),
    [aux_sym__atoms] = STATE(3133),
    [sym__atom_curly] = STATE(5180),
    [sym__atom_no_curly] = STATE(5180),
    [sym_forall] = STATE(9444),
    [sym_let] = STATE(9444),
    [sym_lambda] = STATE(9444),
    [sym_lambda_extended_or_absurd] = STATE(9444),
    [sym_do] = STATE(9444),
    [sym_record_assignments] = STATE(5168),
    [sym_field_assignments] = STATE(5168),
    [aux_sym__typed_bindings] = STATE(8654),
    [sym_typed_binding] = STATE(8654),
    [sym_literal] = STATE(5168),
    [sym_SetN] = STATE(5168),
    [aux_sym__modal_arg_ids_repeat1] = STATE(5830),
    [aux_sym__with_exprs_repeat1] = STATE(3754),
    [sym_id] = ACTIONS(850),
    [anon_sym_forall] = ACTIONS(852),
    [anon_sym_u2200] = ACTIONS(852),
    [anon_sym_BSLASH] = ACTIONS(854),
    [anon_sym_u03bb] = ACTIONS(856),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(858),
    [anon_sym_u2026] = ACTIONS(858),
    [anon_sym_record] = ACTIONS(860),
    [anon_sym_LPAREN] = ACTIONS(862),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(864),
    [anon_sym_u2983] = ACTIONS(866),
    [anon_sym_u2984] = ACTIONS(1034),
    [anon_sym__] = ACTIONS(858),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(870),
    [aux_sym__qid_token1] = ACTIONS(872),
    [anon_sym_DOT] = ACTIONS(874),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(712),
    [anon_sym_quoteGoal] = ACTIONS(878),
    [anon_sym_tactic] = ACTIONS(880),
    [anon_sym_Prop] = ACTIONS(858),
    [anon_sym_quote] = ACTIONS(858),
    [anon_sym_quoteTerm] = ACTIONS(858),
    [anon_sym_quoteContext] = ACTIONS(858),
    [anon_sym_unquote] = ACTIONS(858),
    [anon_sym_LPAREN_PIPE] = ACTIONS(882),
    [anon_sym_u2987] = ACTIONS(884),
    [anon_sym_let] = ACTIONS(886),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(890),
    [aux_sym_string_token1] = ACTIONS(890),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(892),
    [sym_PropN] = ACTIONS(858),
  },
  [393] = {
    [sym__FORALL] = STATE(8355),
    [sym__LAMBDA] = STATE(8054),
    [sym__ELLIPSIS] = STATE(4742),
    [sym__qid] = STATE(4742),
    [sym__binding_ids_and_absurds] = STATE(12359),
    [sym_attribute] = STATE(7725),
    [sym_attributes] = STATE(6302),
    [sym_expr] = STATE(12519),
    [sym__with_exprs] = STATE(10050),
    [sym__expr_or_attr] = STATE(4742),
    [sym__application] = STATE(9444),
    [sym__expr2_without_let] = STATE(9444),
    [sym__expr2] = STATE(9444),
    [sym_atom] = STATE(4712),
    [aux_sym__atoms] = STATE(3276),
    [sym__atom_curly] = STATE(4733),
    [sym__atom_no_curly] = STATE(4733),
    [sym_forall] = STATE(9444),
    [sym_let] = STATE(9444),
    [sym_lambda] = STATE(9444),
    [sym_lambda_extended_or_absurd] = STATE(9444),
    [sym_do] = STATE(9444),
    [sym_record_assignments] = STATE(4742),
    [sym_field_assignments] = STATE(4742),
    [aux_sym__typed_bindings] = STATE(8646),
    [sym_typed_binding] = STATE(8646),
    [sym_literal] = STATE(4742),
    [sym_SetN] = STATE(4742),
    [aux_sym__modal_arg_ids_repeat1] = STATE(7725),
    [aux_sym__with_exprs_repeat1] = STATE(3745),
    [sym_id] = ACTIONS(940),
    [anon_sym_forall] = ACTIONS(942),
    [anon_sym_u2200] = ACTIONS(942),
    [anon_sym_BSLASH] = ACTIONS(944),
    [anon_sym_u03bb] = ACTIONS(946),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(948),
    [anon_sym_u2026] = ACTIONS(948),
    [anon_sym_record] = ACTIONS(950),
    [anon_sym_LPAREN] = ACTIONS(952),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(954),
    [anon_sym_RBRACE_RBRACE] = ACTIONS(1026),
    [anon_sym_u2983] = ACTIONS(956),
    [anon_sym__] = ACTIONS(948),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(958),
    [aux_sym__qid_token1] = ACTIONS(960),
    [anon_sym_DOT] = ACTIONS(962),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(760),
    [anon_sym_quoteGoal] = ACTIONS(964),
    [anon_sym_tactic] = ACTIONS(966),
    [anon_sym_Prop] = ACTIONS(948),
    [anon_sym_quote] = ACTIONS(948),
    [anon_sym_quoteTerm] = ACTIONS(948),
    [anon_sym_quoteContext] = ACTIONS(948),
    [anon_sym_unquote] = ACTIONS(948),
    [anon_sym_LPAREN_PIPE] = ACTIONS(968),
    [anon_sym_u2987] = ACTIONS(970),
    [anon_sym_let] = ACTIONS(972),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(974),
    [aux_sym_string_token1] = ACTIONS(974),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(976),
    [sym_PropN] = ACTIONS(948),
  },
  [394] = {
    [sym__FORALL] = STATE(8369),
    [sym__LAMBDA] = STATE(8152),
    [sym__ELLIPSIS] = STATE(5168),
    [sym__qid] = STATE(5168),
    [sym__binding_ids_and_absurds] = STATE(12358),
    [sym_attribute] = STATE(7725),
    [sym_attributes] = STATE(6182),
    [sym_expr] = STATE(12518),
    [sym__with_exprs] = STATE(9861),
    [sym__expr_or_attr] = STATE(5168),
    [sym__application] = STATE(9444),
    [sym__expr2_without_let] = STATE(9444),
    [sym__expr2] = STATE(9444),
    [sym_atom] = STATE(5204),
    [aux_sym__atoms] = STATE(3133),
    [sym__atom_curly] = STATE(5180),
    [sym__atom_no_curly] = STATE(5180),
    [sym_forall] = STATE(9444),
    [sym_let] = STATE(9444),
    [sym_lambda] = STATE(9444),
    [sym_lambda_extended_or_absurd] = STATE(9444),
    [sym_do] = STATE(9444),
    [sym_record_assignments] = STATE(5168),
    [sym_field_assignments] = STATE(5168),
    [aux_sym__typed_bindings] = STATE(8654),
    [sym_typed_binding] = STATE(8654),
    [sym_literal] = STATE(5168),
    [sym_SetN] = STATE(5168),
    [aux_sym__modal_arg_ids_repeat1] = STATE(7725),
    [aux_sym__with_exprs_repeat1] = STATE(3754),
    [sym_id] = ACTIONS(850),
    [anon_sym_forall] = ACTIONS(852),
    [anon_sym_u2200] = ACTIONS(852),
    [anon_sym_BSLASH] = ACTIONS(854),
    [anon_sym_u03bb] = ACTIONS(856),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(858),
    [anon_sym_u2026] = ACTIONS(858),
    [anon_sym_record] = ACTIONS(860),
    [anon_sym_LPAREN] = ACTIONS(862),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(864),
    [anon_sym_u2983] = ACTIONS(866),
    [anon_sym_u2984] = ACTIONS(1026),
    [anon_sym__] = ACTIONS(858),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(870),
    [aux_sym__qid_token1] = ACTIONS(872),
    [anon_sym_DOT] = ACTIONS(874),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(760),
    [anon_sym_quoteGoal] = ACTIONS(878),
    [anon_sym_tactic] = ACTIONS(880),
    [anon_sym_Prop] = ACTIONS(858),
    [anon_sym_quote] = ACTIONS(858),
    [anon_sym_quoteTerm] = ACTIONS(858),
    [anon_sym_quoteContext] = ACTIONS(858),
    [anon_sym_unquote] = ACTIONS(858),
    [anon_sym_LPAREN_PIPE] = ACTIONS(882),
    [anon_sym_u2987] = ACTIONS(884),
    [anon_sym_let] = ACTIONS(886),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(890),
    [aux_sym_string_token1] = ACTIONS(890),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(892),
    [sym_PropN] = ACTIONS(858),
  },
  [395] = {
    [sym__FORALL] = STATE(8355),
    [sym__LAMBDA] = STATE(8054),
    [sym__ELLIPSIS] = STATE(4742),
    [sym__qid] = STATE(4742),
    [sym__binding_ids_and_absurds] = STATE(12547),
    [sym_attribute] = STATE(5830),
    [sym_attributes] = STATE(3506),
    [sym_expr] = STATE(11169),
    [sym__with_exprs] = STATE(10050),
    [sym__expr_or_attr] = STATE(4742),
    [sym__application] = STATE(9444),
    [sym__expr2_without_let] = STATE(9444),
    [sym__expr2] = STATE(9444),
    [sym_atom] = STATE(4712),
    [aux_sym__atoms] = STATE(3276),
    [sym__atom_curly] = STATE(4733),
    [sym__atom_no_curly] = STATE(4733),
    [sym_forall] = STATE(9444),
    [sym_let] = STATE(9444),
    [sym_lambda] = STATE(9444),
    [sym_lambda_extended_or_absurd] = STATE(9444),
    [sym_do] = STATE(9444),
    [sym_record_assignments] = STATE(4742),
    [sym_field_assignments] = STATE(4742),
    [aux_sym__typed_bindings] = STATE(8646),
    [sym_typed_binding] = STATE(8646),
    [sym_literal] = STATE(4742),
    [sym_SetN] = STATE(4742),
    [aux_sym__modal_arg_ids_repeat1] = STATE(5830),
    [aux_sym__with_exprs_repeat1] = STATE(3745),
    [sym_id] = ACTIONS(940),
    [anon_sym_forall] = ACTIONS(942),
    [anon_sym_u2200] = ACTIONS(942),
    [anon_sym_BSLASH] = ACTIONS(944),
    [anon_sym_u03bb] = ACTIONS(946),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(948),
    [anon_sym_u2026] = ACTIONS(948),
    [anon_sym_record] = ACTIONS(950),
    [anon_sym_LPAREN] = ACTIONS(952),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(954),
    [anon_sym_RBRACE_RBRACE] = ACTIONS(1034),
    [anon_sym_u2983] = ACTIONS(956),
    [anon_sym__] = ACTIONS(948),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(958),
    [aux_sym__qid_token1] = ACTIONS(960),
    [anon_sym_DOT] = ACTIONS(962),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(712),
    [anon_sym_quoteGoal] = ACTIONS(964),
    [anon_sym_tactic] = ACTIONS(966),
    [anon_sym_Prop] = ACTIONS(948),
    [anon_sym_quote] = ACTIONS(948),
    [anon_sym_quoteTerm] = ACTIONS(948),
    [anon_sym_quoteContext] = ACTIONS(948),
    [anon_sym_unquote] = ACTIONS(948),
    [anon_sym_LPAREN_PIPE] = ACTIONS(968),
    [anon_sym_u2987] = ACTIONS(970),
    [anon_sym_let] = ACTIONS(972),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(974),
    [aux_sym_string_token1] = ACTIONS(974),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(976),
    [sym_PropN] = ACTIONS(948),
  },
  [396] = {
    [sym__FORALL] = STATE(8345),
    [sym__LAMBDA] = STATE(8095),
    [sym__ELLIPSIS] = STATE(4742),
    [sym_open] = STATE(12555),
    [sym__qid] = STATE(4742),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3873),
    [sym_expr] = STATE(11093),
    [sym__with_exprs] = STATE(10084),
    [sym__expr_or_attr] = STATE(4742),
    [sym__application] = STATE(9680),
    [sym__expr2_without_let] = STATE(9680),
    [sym__expr2] = STATE(9680),
    [sym_atom] = STATE(4712),
    [aux_sym__atoms] = STATE(3211),
    [sym__atom_curly] = STATE(4733),
    [sym__atom_no_curly] = STATE(4733),
    [sym_forall] = STATE(9680),
    [sym_let] = STATE(9680),
    [sym_lambda] = STATE(9680),
    [sym_lambda_extended_or_absurd] = STATE(9680),
    [sym_do] = STATE(9680),
    [sym_record_assignments] = STATE(4742),
    [sym_field_assignments] = STATE(4742),
    [aux_sym__typed_bindings] = STATE(8642),
    [sym_typed_binding] = STATE(8642),
    [sym_literal] = STATE(4742),
    [sym_SetN] = STATE(4742),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3728),
    [sym_id] = ACTIONS(940),
    [anon_sym_forall] = ACTIONS(980),
    [anon_sym_u2200] = ACTIONS(980),
    [anon_sym_BSLASH] = ACTIONS(982),
    [anon_sym_u03bb] = ACTIONS(984),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(948),
    [anon_sym_u2026] = ACTIONS(948),
    [anon_sym_record] = ACTIONS(950),
    [anon_sym_open] = ACTIONS(986),
    [anon_sym_LPAREN] = ACTIONS(952),
    [anon_sym_RPAREN] = ACTIONS(1034),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(954),
    [anon_sym_u2983] = ACTIONS(956),
    [anon_sym__] = ACTIONS(948),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(958),
    [aux_sym__qid_token1] = ACTIONS(960),
    [anon_sym_DOT] = ACTIONS(962),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(988),
    [anon_sym_tactic] = ACTIONS(990),
    [anon_sym_Prop] = ACTIONS(948),
    [anon_sym_quote] = ACTIONS(948),
    [anon_sym_quoteTerm] = ACTIONS(948),
    [anon_sym_quoteContext] = ACTIONS(948),
    [anon_sym_unquote] = ACTIONS(948),
    [anon_sym_LPAREN_PIPE] = ACTIONS(968),
    [anon_sym_u2987] = ACTIONS(970),
    [anon_sym_let] = ACTIONS(992),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(974),
    [aux_sym_string_token1] = ACTIONS(974),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(976),
    [sym_PropN] = ACTIONS(948),
  },
  [397] = {
    [sym__FORALL] = STATE(8396),
    [sym__LAMBDA] = STATE(8031),
    [sym__ELLIPSIS] = STATE(4920),
    [sym__qid] = STATE(4920),
    [sym__binding_ids_and_absurds] = STATE(12357),
    [sym_attribute] = STATE(7725),
    [sym_attributes] = STATE(6200),
    [sym_expr] = STATE(12517),
    [sym__with_exprs] = STATE(10196),
    [sym__expr_or_attr] = STATE(4920),
    [sym__application] = STATE(9678),
    [sym__expr2_without_let] = STATE(9678),
    [sym__expr2] = STATE(9678),
    [sym_atom] = STATE(5202),
    [aux_sym__atoms] = STATE(3165),
    [sym__atom_curly] = STATE(4961),
    [sym__atom_no_curly] = STATE(4961),
    [sym_forall] = STATE(9678),
    [sym_let] = STATE(9678),
    [sym_lambda] = STATE(9678),
    [sym_lambda_extended_or_absurd] = STATE(9678),
    [sym_do] = STATE(9678),
    [sym_record_assignments] = STATE(4920),
    [sym_field_assignments] = STATE(4920),
    [aux_sym__typed_bindings] = STATE(8648),
    [sym_typed_binding] = STATE(8648),
    [sym_literal] = STATE(4920),
    [sym_SetN] = STATE(4920),
    [aux_sym__modal_arg_ids_repeat1] = STATE(7725),
    [aux_sym__with_exprs_repeat1] = STATE(3726),
    [sym_id] = ACTIONS(894),
    [anon_sym_forall] = ACTIONS(896),
    [anon_sym_u2200] = ACTIONS(896),
    [anon_sym_BSLASH] = ACTIONS(898),
    [anon_sym_u03bb] = ACTIONS(900),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(902),
    [anon_sym_u2026] = ACTIONS(902),
    [anon_sym_record] = ACTIONS(904),
    [anon_sym_LPAREN] = ACTIONS(906),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(908),
    [anon_sym_u2983] = ACTIONS(910),
    [anon_sym__] = ACTIONS(902),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(912),
    [anon_sym_RBRACE] = ACTIONS(1028),
    [aux_sym__qid_token1] = ACTIONS(916),
    [anon_sym_DOT] = ACTIONS(918),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(760),
    [anon_sym_quoteGoal] = ACTIONS(920),
    [anon_sym_tactic] = ACTIONS(922),
    [anon_sym_Prop] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(902),
    [anon_sym_quoteTerm] = ACTIONS(902),
    [anon_sym_quoteContext] = ACTIONS(902),
    [anon_sym_unquote] = ACTIONS(902),
    [anon_sym_LPAREN_PIPE] = ACTIONS(924),
    [anon_sym_u2987] = ACTIONS(926),
    [anon_sym_let] = ACTIONS(928),
    [anon_sym_do] = ACTIONS(724),
    [aux_sym_integer_token1] = ACTIONS(930),
    [aux_sym_string_token1] = ACTIONS(930),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(932),
    [sym_PropN] = ACTIONS(902),
  },
  [398] = {
    [sym__FORALL] = STATE(8345),
    [sym__LAMBDA] = STATE(8095),
    [sym__ELLIPSIS] = STATE(4742),
    [sym_open] = STATE(12555),
    [sym__qid] = STATE(4742),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3873),
    [sym_expr] = STATE(12601),
    [sym__with_exprs] = STATE(10084),
    [sym__expr_or_attr] = STATE(4742),
    [sym__application] = STATE(9680),
    [sym__expr2_without_let] = STATE(9680),
    [sym__expr2] = STATE(9680),
    [sym_atom] = STATE(4712),
    [aux_sym__atoms] = STATE(3211),
    [sym__atom_curly] = STATE(4733),
    [sym__atom_no_curly] = STATE(4733),
    [sym_forall] = STATE(9680),
    [sym_let] = STATE(9680),
    [sym_lambda] = STATE(9680),
    [sym_lambda_extended_or_absurd] = STATE(9680),
    [sym_do] = STATE(9680),
    [sym_record_assignments] = STATE(4742),
    [sym_field_assignments] = STATE(4742),
    [aux_sym__typed_bindings] = STATE(8642),
    [sym_typed_binding] = STATE(8642),
    [sym_literal] = STATE(4742),
    [sym_SetN] = STATE(4742),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3728),
    [sym_id] = ACTIONS(940),
    [anon_sym_forall] = ACTIONS(980),
    [anon_sym_u2200] = ACTIONS(980),
    [anon_sym_BSLASH] = ACTIONS(982),
    [anon_sym_u03bb] = ACTIONS(984),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(948),
    [anon_sym_u2026] = ACTIONS(948),
    [anon_sym_record] = ACTIONS(950),
    [anon_sym_open] = ACTIONS(986),
    [anon_sym_LPAREN] = ACTIONS(952),
    [anon_sym_RPAREN] = ACTIONS(1036),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(954),
    [anon_sym_u2983] = ACTIONS(956),
    [anon_sym__] = ACTIONS(948),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(958),
    [aux_sym__qid_token1] = ACTIONS(960),
    [anon_sym_DOT] = ACTIONS(962),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(988),
    [anon_sym_tactic] = ACTIONS(990),
    [anon_sym_Prop] = ACTIONS(948),
    [anon_sym_quote] = ACTIONS(948),
    [anon_sym_quoteTerm] = ACTIONS(948),
    [anon_sym_quoteContext] = ACTIONS(948),
    [anon_sym_unquote] = ACTIONS(948),
    [anon_sym_LPAREN_PIPE] = ACTIONS(968),
    [anon_sym_u2987] = ACTIONS(970),
    [anon_sym_let] = ACTIONS(992),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(974),
    [aux_sym_string_token1] = ACTIONS(974),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(976),
    [sym_PropN] = ACTIONS(948),
  },
  [399] = {
    [sym__FORALL] = STATE(8396),
    [sym__LAMBDA] = STATE(8031),
    [sym__ELLIPSIS] = STATE(4920),
    [sym__qid] = STATE(4920),
    [sym__binding_ids_and_absurds] = STATE(12357),
    [sym_attribute] = STATE(7725),
    [sym_attributes] = STATE(6200),
    [sym_expr] = STATE(11231),
    [sym__with_exprs] = STATE(10196),
    [sym__expr_or_attr] = STATE(4920),
    [sym__application] = STATE(9678),
    [sym__expr2_without_let] = STATE(9678),
    [sym__expr2] = STATE(9678),
    [sym_atom] = STATE(5202),
    [aux_sym__atoms] = STATE(3165),
    [sym__atom_curly] = STATE(4961),
    [sym__atom_no_curly] = STATE(4961),
    [sym_forall] = STATE(9678),
    [sym_let] = STATE(9678),
    [sym_lambda] = STATE(9678),
    [sym_lambda_extended_or_absurd] = STATE(9678),
    [sym_do] = STATE(9678),
    [sym_record_assignments] = STATE(4920),
    [sym_field_assignments] = STATE(4920),
    [aux_sym__typed_bindings] = STATE(8648),
    [sym_typed_binding] = STATE(8648),
    [sym_literal] = STATE(4920),
    [sym_SetN] = STATE(4920),
    [aux_sym__modal_arg_ids_repeat1] = STATE(7725),
    [aux_sym__with_exprs_repeat1] = STATE(3726),
    [sym_id] = ACTIONS(894),
    [anon_sym_forall] = ACTIONS(896),
    [anon_sym_u2200] = ACTIONS(896),
    [anon_sym_BSLASH] = ACTIONS(898),
    [anon_sym_u03bb] = ACTIONS(900),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(902),
    [anon_sym_u2026] = ACTIONS(902),
    [anon_sym_record] = ACTIONS(904),
    [anon_sym_LPAREN] = ACTIONS(906),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(908),
    [anon_sym_u2983] = ACTIONS(910),
    [anon_sym__] = ACTIONS(902),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(912),
    [anon_sym_RBRACE] = ACTIONS(1038),
    [aux_sym__qid_token1] = ACTIONS(916),
    [anon_sym_DOT] = ACTIONS(918),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(760),
    [anon_sym_quoteGoal] = ACTIONS(920),
    [anon_sym_tactic] = ACTIONS(922),
    [anon_sym_Prop] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(902),
    [anon_sym_quoteTerm] = ACTIONS(902),
    [anon_sym_quoteContext] = ACTIONS(902),
    [anon_sym_unquote] = ACTIONS(902),
    [anon_sym_LPAREN_PIPE] = ACTIONS(924),
    [anon_sym_u2987] = ACTIONS(926),
    [anon_sym_let] = ACTIONS(928),
    [anon_sym_do] = ACTIONS(724),
    [aux_sym_integer_token1] = ACTIONS(930),
    [aux_sym_string_token1] = ACTIONS(930),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(932),
    [sym_PropN] = ACTIONS(902),
  },
  [400] = {
    [sym__FORALL] = STATE(8369),
    [sym__LAMBDA] = STATE(8152),
    [sym__ELLIPSIS] = STATE(5168),
    [sym__qid] = STATE(5168),
    [sym__binding_ids_and_absurds] = STATE(12358),
    [sym_attribute] = STATE(7725),
    [sym_attributes] = STATE(6182),
    [sym_expr] = STATE(11233),
    [sym__with_exprs] = STATE(9861),
    [sym__expr_or_attr] = STATE(5168),
    [sym__application] = STATE(9444),
    [sym__expr2_without_let] = STATE(9444),
    [sym__expr2] = STATE(9444),
    [sym_atom] = STATE(5204),
    [aux_sym__atoms] = STATE(3133),
    [sym__atom_curly] = STATE(5180),
    [sym__atom_no_curly] = STATE(5180),
    [sym_forall] = STATE(9444),
    [sym_let] = STATE(9444),
    [sym_lambda] = STATE(9444),
    [sym_lambda_extended_or_absurd] = STATE(9444),
    [sym_do] = STATE(9444),
    [sym_record_assignments] = STATE(5168),
    [sym_field_assignments] = STATE(5168),
    [aux_sym__typed_bindings] = STATE(8654),
    [sym_typed_binding] = STATE(8654),
    [sym_literal] = STATE(5168),
    [sym_SetN] = STATE(5168),
    [aux_sym__modal_arg_ids_repeat1] = STATE(7725),
    [aux_sym__with_exprs_repeat1] = STATE(3754),
    [sym_id] = ACTIONS(850),
    [anon_sym_forall] = ACTIONS(852),
    [anon_sym_u2200] = ACTIONS(852),
    [anon_sym_BSLASH] = ACTIONS(854),
    [anon_sym_u03bb] = ACTIONS(856),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(858),
    [anon_sym_u2026] = ACTIONS(858),
    [anon_sym_record] = ACTIONS(860),
    [anon_sym_LPAREN] = ACTIONS(862),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(864),
    [anon_sym_u2983] = ACTIONS(866),
    [anon_sym_u2984] = ACTIONS(1040),
    [anon_sym__] = ACTIONS(858),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(870),
    [aux_sym__qid_token1] = ACTIONS(872),
    [anon_sym_DOT] = ACTIONS(874),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(760),
    [anon_sym_quoteGoal] = ACTIONS(878),
    [anon_sym_tactic] = ACTIONS(880),
    [anon_sym_Prop] = ACTIONS(858),
    [anon_sym_quote] = ACTIONS(858),
    [anon_sym_quoteTerm] = ACTIONS(858),
    [anon_sym_quoteContext] = ACTIONS(858),
    [anon_sym_unquote] = ACTIONS(858),
    [anon_sym_LPAREN_PIPE] = ACTIONS(882),
    [anon_sym_u2987] = ACTIONS(884),
    [anon_sym_let] = ACTIONS(886),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(890),
    [aux_sym_string_token1] = ACTIONS(890),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(892),
    [sym_PropN] = ACTIONS(858),
  },
  [401] = {
    [sym__FORALL] = STATE(8355),
    [sym__LAMBDA] = STATE(8054),
    [sym__ELLIPSIS] = STATE(4742),
    [sym__qid] = STATE(4742),
    [sym__binding_ids_and_absurds] = STATE(12359),
    [sym_attribute] = STATE(7725),
    [sym_attributes] = STATE(6302),
    [sym_expr] = STATE(11235),
    [sym__with_exprs] = STATE(10050),
    [sym__expr_or_attr] = STATE(4742),
    [sym__application] = STATE(9444),
    [sym__expr2_without_let] = STATE(9444),
    [sym__expr2] = STATE(9444),
    [sym_atom] = STATE(4712),
    [aux_sym__atoms] = STATE(3276),
    [sym__atom_curly] = STATE(4733),
    [sym__atom_no_curly] = STATE(4733),
    [sym_forall] = STATE(9444),
    [sym_let] = STATE(9444),
    [sym_lambda] = STATE(9444),
    [sym_lambda_extended_or_absurd] = STATE(9444),
    [sym_do] = STATE(9444),
    [sym_record_assignments] = STATE(4742),
    [sym_field_assignments] = STATE(4742),
    [aux_sym__typed_bindings] = STATE(8646),
    [sym_typed_binding] = STATE(8646),
    [sym_literal] = STATE(4742),
    [sym_SetN] = STATE(4742),
    [aux_sym__modal_arg_ids_repeat1] = STATE(7725),
    [aux_sym__with_exprs_repeat1] = STATE(3745),
    [sym_id] = ACTIONS(940),
    [anon_sym_forall] = ACTIONS(942),
    [anon_sym_u2200] = ACTIONS(942),
    [anon_sym_BSLASH] = ACTIONS(944),
    [anon_sym_u03bb] = ACTIONS(946),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(948),
    [anon_sym_u2026] = ACTIONS(948),
    [anon_sym_record] = ACTIONS(950),
    [anon_sym_LPAREN] = ACTIONS(952),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(954),
    [anon_sym_RBRACE_RBRACE] = ACTIONS(1040),
    [anon_sym_u2983] = ACTIONS(956),
    [anon_sym__] = ACTIONS(948),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(958),
    [aux_sym__qid_token1] = ACTIONS(960),
    [anon_sym_DOT] = ACTIONS(962),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(760),
    [anon_sym_quoteGoal] = ACTIONS(964),
    [anon_sym_tactic] = ACTIONS(966),
    [anon_sym_Prop] = ACTIONS(948),
    [anon_sym_quote] = ACTIONS(948),
    [anon_sym_quoteTerm] = ACTIONS(948),
    [anon_sym_quoteContext] = ACTIONS(948),
    [anon_sym_unquote] = ACTIONS(948),
    [anon_sym_LPAREN_PIPE] = ACTIONS(968),
    [anon_sym_u2987] = ACTIONS(970),
    [anon_sym_let] = ACTIONS(972),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(974),
    [aux_sym_string_token1] = ACTIONS(974),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(976),
    [sym_PropN] = ACTIONS(948),
  },
  [402] = {
    [sym__FORALL] = STATE(8369),
    [sym__LAMBDA] = STATE(8152),
    [sym__ELLIPSIS] = STATE(5168),
    [sym__qid] = STATE(5168),
    [sym__binding_ids_and_absurds] = STATE(12544),
    [sym_attribute] = STATE(5830),
    [sym_attributes] = STATE(3505),
    [sym_expr] = STATE(12617),
    [sym__with_exprs] = STATE(9861),
    [sym__expr_or_attr] = STATE(5168),
    [sym__application] = STATE(9444),
    [sym__expr2_without_let] = STATE(9444),
    [sym__expr2] = STATE(9444),
    [sym_atom] = STATE(5204),
    [aux_sym__atoms] = STATE(3133),
    [sym__atom_curly] = STATE(5180),
    [sym__atom_no_curly] = STATE(5180),
    [sym_forall] = STATE(9444),
    [sym_let] = STATE(9444),
    [sym_lambda] = STATE(9444),
    [sym_lambda_extended_or_absurd] = STATE(9444),
    [sym_do] = STATE(9444),
    [sym_record_assignments] = STATE(5168),
    [sym_field_assignments] = STATE(5168),
    [aux_sym__typed_bindings] = STATE(8654),
    [sym_typed_binding] = STATE(8654),
    [sym_literal] = STATE(5168),
    [sym_SetN] = STATE(5168),
    [aux_sym__modal_arg_ids_repeat1] = STATE(5830),
    [aux_sym__with_exprs_repeat1] = STATE(3754),
    [sym_id] = ACTIONS(850),
    [anon_sym_forall] = ACTIONS(852),
    [anon_sym_u2200] = ACTIONS(852),
    [anon_sym_BSLASH] = ACTIONS(854),
    [anon_sym_u03bb] = ACTIONS(856),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(858),
    [anon_sym_u2026] = ACTIONS(858),
    [anon_sym_record] = ACTIONS(860),
    [anon_sym_LPAREN] = ACTIONS(862),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(864),
    [anon_sym_u2983] = ACTIONS(866),
    [anon_sym_u2984] = ACTIONS(1030),
    [anon_sym__] = ACTIONS(858),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(870),
    [aux_sym__qid_token1] = ACTIONS(872),
    [anon_sym_DOT] = ACTIONS(874),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(712),
    [anon_sym_quoteGoal] = ACTIONS(878),
    [anon_sym_tactic] = ACTIONS(880),
    [anon_sym_Prop] = ACTIONS(858),
    [anon_sym_quote] = ACTIONS(858),
    [anon_sym_quoteTerm] = ACTIONS(858),
    [anon_sym_quoteContext] = ACTIONS(858),
    [anon_sym_unquote] = ACTIONS(858),
    [anon_sym_LPAREN_PIPE] = ACTIONS(882),
    [anon_sym_u2987] = ACTIONS(884),
    [anon_sym_let] = ACTIONS(886),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(890),
    [aux_sym_string_token1] = ACTIONS(890),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(892),
    [sym_PropN] = ACTIONS(858),
  },
  [403] = {
    [sym__FORALL] = STATE(8355),
    [sym__LAMBDA] = STATE(8054),
    [sym__ELLIPSIS] = STATE(4742),
    [sym__qid] = STATE(4742),
    [sym__binding_ids_and_absurds] = STATE(12547),
    [sym_attribute] = STATE(5830),
    [sym_attributes] = STATE(3506),
    [sym_expr] = STATE(12619),
    [sym__with_exprs] = STATE(10050),
    [sym__expr_or_attr] = STATE(4742),
    [sym__application] = STATE(9444),
    [sym__expr2_without_let] = STATE(9444),
    [sym__expr2] = STATE(9444),
    [sym_atom] = STATE(4712),
    [aux_sym__atoms] = STATE(3276),
    [sym__atom_curly] = STATE(4733),
    [sym__atom_no_curly] = STATE(4733),
    [sym_forall] = STATE(9444),
    [sym_let] = STATE(9444),
    [sym_lambda] = STATE(9444),
    [sym_lambda_extended_or_absurd] = STATE(9444),
    [sym_do] = STATE(9444),
    [sym_record_assignments] = STATE(4742),
    [sym_field_assignments] = STATE(4742),
    [aux_sym__typed_bindings] = STATE(8646),
    [sym_typed_binding] = STATE(8646),
    [sym_literal] = STATE(4742),
    [sym_SetN] = STATE(4742),
    [aux_sym__modal_arg_ids_repeat1] = STATE(5830),
    [aux_sym__with_exprs_repeat1] = STATE(3745),
    [sym_id] = ACTIONS(940),
    [anon_sym_forall] = ACTIONS(942),
    [anon_sym_u2200] = ACTIONS(942),
    [anon_sym_BSLASH] = ACTIONS(944),
    [anon_sym_u03bb] = ACTIONS(946),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(948),
    [anon_sym_u2026] = ACTIONS(948),
    [anon_sym_record] = ACTIONS(950),
    [anon_sym_LPAREN] = ACTIONS(952),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(954),
    [anon_sym_RBRACE_RBRACE] = ACTIONS(1030),
    [anon_sym_u2983] = ACTIONS(956),
    [anon_sym__] = ACTIONS(948),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(958),
    [aux_sym__qid_token1] = ACTIONS(960),
    [anon_sym_DOT] = ACTIONS(962),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(712),
    [anon_sym_quoteGoal] = ACTIONS(964),
    [anon_sym_tactic] = ACTIONS(966),
    [anon_sym_Prop] = ACTIONS(948),
    [anon_sym_quote] = ACTIONS(948),
    [anon_sym_quoteTerm] = ACTIONS(948),
    [anon_sym_quoteContext] = ACTIONS(948),
    [anon_sym_unquote] = ACTIONS(948),
    [anon_sym_LPAREN_PIPE] = ACTIONS(968),
    [anon_sym_u2987] = ACTIONS(970),
    [anon_sym_let] = ACTIONS(972),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(974),
    [aux_sym_string_token1] = ACTIONS(974),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(976),
    [sym_PropN] = ACTIONS(948),
  },
  [404] = {
    [sym__FORALL] = STATE(8355),
    [sym__LAMBDA] = STATE(8054),
    [sym__ELLIPSIS] = STATE(4742),
    [sym__qid] = STATE(4742),
    [sym__binding_ids_and_absurds] = STATE(12547),
    [sym_attribute] = STATE(5830),
    [sym_attributes] = STATE(3506),
    [sym_expr] = STATE(12674),
    [sym__with_exprs] = STATE(10050),
    [sym__expr_or_attr] = STATE(4742),
    [sym__application] = STATE(9444),
    [sym__expr2_without_let] = STATE(9444),
    [sym__expr2] = STATE(9444),
    [sym_atom] = STATE(4712),
    [aux_sym__atoms] = STATE(3276),
    [sym__atom_curly] = STATE(4733),
    [sym__atom_no_curly] = STATE(4733),
    [sym_forall] = STATE(9444),
    [sym_let] = STATE(9444),
    [sym_lambda] = STATE(9444),
    [sym_lambda_extended_or_absurd] = STATE(9444),
    [sym_do] = STATE(9444),
    [sym_record_assignments] = STATE(4742),
    [sym_field_assignments] = STATE(4742),
    [aux_sym__typed_bindings] = STATE(8646),
    [sym_typed_binding] = STATE(8646),
    [sym_literal] = STATE(4742),
    [sym_SetN] = STATE(4742),
    [aux_sym__modal_arg_ids_repeat1] = STATE(5830),
    [aux_sym__with_exprs_repeat1] = STATE(3745),
    [sym_id] = ACTIONS(940),
    [anon_sym_forall] = ACTIONS(942),
    [anon_sym_u2200] = ACTIONS(942),
    [anon_sym_BSLASH] = ACTIONS(944),
    [anon_sym_u03bb] = ACTIONS(946),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(948),
    [anon_sym_u2026] = ACTIONS(948),
    [anon_sym_record] = ACTIONS(950),
    [anon_sym_LPAREN] = ACTIONS(952),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(954),
    [anon_sym_RBRACE_RBRACE] = ACTIONS(1036),
    [anon_sym_u2983] = ACTIONS(956),
    [anon_sym__] = ACTIONS(948),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(958),
    [aux_sym__qid_token1] = ACTIONS(960),
    [anon_sym_DOT] = ACTIONS(962),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(712),
    [anon_sym_quoteGoal] = ACTIONS(964),
    [anon_sym_tactic] = ACTIONS(966),
    [anon_sym_Prop] = ACTIONS(948),
    [anon_sym_quote] = ACTIONS(948),
    [anon_sym_quoteTerm] = ACTIONS(948),
    [anon_sym_quoteContext] = ACTIONS(948),
    [anon_sym_unquote] = ACTIONS(948),
    [anon_sym_LPAREN_PIPE] = ACTIONS(968),
    [anon_sym_u2987] = ACTIONS(970),
    [anon_sym_let] = ACTIONS(972),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(974),
    [aux_sym_string_token1] = ACTIONS(974),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(976),
    [sym_PropN] = ACTIONS(948),
  },
  [405] = {
    [sym__FORALL] = STATE(8345),
    [sym__LAMBDA] = STATE(8095),
    [sym__ELLIPSIS] = STATE(4742),
    [sym_open] = STATE(12555),
    [sym__qid] = STATE(4742),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3873),
    [sym_expr] = STATE(12540),
    [sym__with_exprs] = STATE(10084),
    [sym__expr_or_attr] = STATE(4742),
    [sym__application] = STATE(9680),
    [sym__expr2_without_let] = STATE(9680),
    [sym__expr2] = STATE(9680),
    [sym_atom] = STATE(4712),
    [aux_sym__atoms] = STATE(3211),
    [sym__atom_curly] = STATE(4733),
    [sym__atom_no_curly] = STATE(4733),
    [sym_forall] = STATE(9680),
    [sym_let] = STATE(9680),
    [sym_lambda] = STATE(9680),
    [sym_lambda_extended_or_absurd] = STATE(9680),
    [sym_do] = STATE(9680),
    [sym_record_assignments] = STATE(4742),
    [sym_field_assignments] = STATE(4742),
    [aux_sym__typed_bindings] = STATE(8642),
    [sym_typed_binding] = STATE(8642),
    [sym_literal] = STATE(4742),
    [sym_SetN] = STATE(4742),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3728),
    [sym_id] = ACTIONS(940),
    [anon_sym_forall] = ACTIONS(980),
    [anon_sym_u2200] = ACTIONS(980),
    [anon_sym_BSLASH] = ACTIONS(982),
    [anon_sym_u03bb] = ACTIONS(984),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(948),
    [anon_sym_u2026] = ACTIONS(948),
    [anon_sym_record] = ACTIONS(950),
    [anon_sym_open] = ACTIONS(986),
    [anon_sym_LPAREN] = ACTIONS(952),
    [anon_sym_RPAREN] = ACTIONS(1030),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(954),
    [anon_sym_u2983] = ACTIONS(956),
    [anon_sym__] = ACTIONS(948),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(958),
    [aux_sym__qid_token1] = ACTIONS(960),
    [anon_sym_DOT] = ACTIONS(962),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(988),
    [anon_sym_tactic] = ACTIONS(990),
    [anon_sym_Prop] = ACTIONS(948),
    [anon_sym_quote] = ACTIONS(948),
    [anon_sym_quoteTerm] = ACTIONS(948),
    [anon_sym_quoteContext] = ACTIONS(948),
    [anon_sym_unquote] = ACTIONS(948),
    [anon_sym_LPAREN_PIPE] = ACTIONS(968),
    [anon_sym_u2987] = ACTIONS(970),
    [anon_sym_let] = ACTIONS(992),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(974),
    [aux_sym_string_token1] = ACTIONS(974),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(976),
    [sym_PropN] = ACTIONS(948),
  },
  [406] = {
    [sym__FORALL] = STATE(8369),
    [sym__LAMBDA] = STATE(8152),
    [sym__ELLIPSIS] = STATE(5168),
    [sym__qid] = STATE(5168),
    [sym__binding_ids_and_absurds] = STATE(12544),
    [sym_attribute] = STATE(5830),
    [sym_attributes] = STATE(3505),
    [sym_expr] = STATE(12673),
    [sym__with_exprs] = STATE(9861),
    [sym__expr_or_attr] = STATE(5168),
    [sym__application] = STATE(9444),
    [sym__expr2_without_let] = STATE(9444),
    [sym__expr2] = STATE(9444),
    [sym_atom] = STATE(5204),
    [aux_sym__atoms] = STATE(3133),
    [sym__atom_curly] = STATE(5180),
    [sym__atom_no_curly] = STATE(5180),
    [sym_forall] = STATE(9444),
    [sym_let] = STATE(9444),
    [sym_lambda] = STATE(9444),
    [sym_lambda_extended_or_absurd] = STATE(9444),
    [sym_do] = STATE(9444),
    [sym_record_assignments] = STATE(5168),
    [sym_field_assignments] = STATE(5168),
    [aux_sym__typed_bindings] = STATE(8654),
    [sym_typed_binding] = STATE(8654),
    [sym_literal] = STATE(5168),
    [sym_SetN] = STATE(5168),
    [aux_sym__modal_arg_ids_repeat1] = STATE(5830),
    [aux_sym__with_exprs_repeat1] = STATE(3754),
    [sym_id] = ACTIONS(850),
    [anon_sym_forall] = ACTIONS(852),
    [anon_sym_u2200] = ACTIONS(852),
    [anon_sym_BSLASH] = ACTIONS(854),
    [anon_sym_u03bb] = ACTIONS(856),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(858),
    [anon_sym_u2026] = ACTIONS(858),
    [anon_sym_record] = ACTIONS(860),
    [anon_sym_LPAREN] = ACTIONS(862),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(864),
    [anon_sym_u2983] = ACTIONS(866),
    [anon_sym_u2984] = ACTIONS(1036),
    [anon_sym__] = ACTIONS(858),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(870),
    [aux_sym__qid_token1] = ACTIONS(872),
    [anon_sym_DOT] = ACTIONS(874),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(712),
    [anon_sym_quoteGoal] = ACTIONS(878),
    [anon_sym_tactic] = ACTIONS(880),
    [anon_sym_Prop] = ACTIONS(858),
    [anon_sym_quote] = ACTIONS(858),
    [anon_sym_quoteTerm] = ACTIONS(858),
    [anon_sym_quoteContext] = ACTIONS(858),
    [anon_sym_unquote] = ACTIONS(858),
    [anon_sym_LPAREN_PIPE] = ACTIONS(882),
    [anon_sym_u2987] = ACTIONS(884),
    [anon_sym_let] = ACTIONS(886),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(890),
    [aux_sym_string_token1] = ACTIONS(890),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(892),
    [sym_PropN] = ACTIONS(858),
  },
  [407] = {
    [sym__FORALL] = STATE(8396),
    [sym__LAMBDA] = STATE(8031),
    [sym__ELLIPSIS] = STATE(4920),
    [sym__qid] = STATE(4920),
    [sym__binding_ids_and_absurds] = STATE(12539),
    [sym_attribute] = STATE(5830),
    [sym_attributes] = STATE(3504),
    [sym_expr] = STATE(11231),
    [sym__with_exprs] = STATE(10196),
    [sym__expr_or_attr] = STATE(4920),
    [sym__application] = STATE(9678),
    [sym__expr2_without_let] = STATE(9678),
    [sym__expr2] = STATE(9678),
    [sym_atom] = STATE(5202),
    [aux_sym__atoms] = STATE(3165),
    [sym__atom_curly] = STATE(4961),
    [sym__atom_no_curly] = STATE(4961),
    [sym_forall] = STATE(9678),
    [sym_let] = STATE(9678),
    [sym_lambda] = STATE(9678),
    [sym_lambda_extended_or_absurd] = STATE(9678),
    [sym_do] = STATE(9678),
    [sym_record_assignments] = STATE(4920),
    [sym_field_assignments] = STATE(4920),
    [aux_sym__typed_bindings] = STATE(8648),
    [sym_typed_binding] = STATE(8648),
    [sym_literal] = STATE(4920),
    [sym_SetN] = STATE(4920),
    [aux_sym__modal_arg_ids_repeat1] = STATE(5830),
    [aux_sym__with_exprs_repeat1] = STATE(3726),
    [sym_id] = ACTIONS(894),
    [anon_sym_forall] = ACTIONS(896),
    [anon_sym_u2200] = ACTIONS(896),
    [anon_sym_BSLASH] = ACTIONS(898),
    [anon_sym_u03bb] = ACTIONS(900),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(902),
    [anon_sym_u2026] = ACTIONS(902),
    [anon_sym_record] = ACTIONS(904),
    [anon_sym_LPAREN] = ACTIONS(906),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(908),
    [anon_sym_u2983] = ACTIONS(910),
    [anon_sym__] = ACTIONS(902),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(912),
    [anon_sym_RBRACE] = ACTIONS(1038),
    [aux_sym__qid_token1] = ACTIONS(916),
    [anon_sym_DOT] = ACTIONS(918),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(712),
    [anon_sym_quoteGoal] = ACTIONS(920),
    [anon_sym_tactic] = ACTIONS(922),
    [anon_sym_Prop] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(902),
    [anon_sym_quoteTerm] = ACTIONS(902),
    [anon_sym_quoteContext] = ACTIONS(902),
    [anon_sym_unquote] = ACTIONS(902),
    [anon_sym_LPAREN_PIPE] = ACTIONS(924),
    [anon_sym_u2987] = ACTIONS(926),
    [anon_sym_let] = ACTIONS(928),
    [anon_sym_do] = ACTIONS(724),
    [aux_sym_integer_token1] = ACTIONS(930),
    [aux_sym_string_token1] = ACTIONS(930),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(932),
    [sym_PropN] = ACTIONS(902),
  },
  [408] = {
    [sym__FORALL] = STATE(8369),
    [sym__LAMBDA] = STATE(8152),
    [sym__ELLIPSIS] = STATE(5168),
    [sym__qid] = STATE(5168),
    [sym__binding_ids_and_absurds] = STATE(12544),
    [sym_attribute] = STATE(5830),
    [sym_attributes] = STATE(3505),
    [sym_expr] = STATE(11233),
    [sym__with_exprs] = STATE(9861),
    [sym__expr_or_attr] = STATE(5168),
    [sym__application] = STATE(9444),
    [sym__expr2_without_let] = STATE(9444),
    [sym__expr2] = STATE(9444),
    [sym_atom] = STATE(5204),
    [aux_sym__atoms] = STATE(3133),
    [sym__atom_curly] = STATE(5180),
    [sym__atom_no_curly] = STATE(5180),
    [sym_forall] = STATE(9444),
    [sym_let] = STATE(9444),
    [sym_lambda] = STATE(9444),
    [sym_lambda_extended_or_absurd] = STATE(9444),
    [sym_do] = STATE(9444),
    [sym_record_assignments] = STATE(5168),
    [sym_field_assignments] = STATE(5168),
    [aux_sym__typed_bindings] = STATE(8654),
    [sym_typed_binding] = STATE(8654),
    [sym_literal] = STATE(5168),
    [sym_SetN] = STATE(5168),
    [aux_sym__modal_arg_ids_repeat1] = STATE(5830),
    [aux_sym__with_exprs_repeat1] = STATE(3754),
    [sym_id] = ACTIONS(850),
    [anon_sym_forall] = ACTIONS(852),
    [anon_sym_u2200] = ACTIONS(852),
    [anon_sym_BSLASH] = ACTIONS(854),
    [anon_sym_u03bb] = ACTIONS(856),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(858),
    [anon_sym_u2026] = ACTIONS(858),
    [anon_sym_record] = ACTIONS(860),
    [anon_sym_LPAREN] = ACTIONS(862),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(864),
    [anon_sym_u2983] = ACTIONS(866),
    [anon_sym_u2984] = ACTIONS(1040),
    [anon_sym__] = ACTIONS(858),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(870),
    [aux_sym__qid_token1] = ACTIONS(872),
    [anon_sym_DOT] = ACTIONS(874),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(712),
    [anon_sym_quoteGoal] = ACTIONS(878),
    [anon_sym_tactic] = ACTIONS(880),
    [anon_sym_Prop] = ACTIONS(858),
    [anon_sym_quote] = ACTIONS(858),
    [anon_sym_quoteTerm] = ACTIONS(858),
    [anon_sym_quoteContext] = ACTIONS(858),
    [anon_sym_unquote] = ACTIONS(858),
    [anon_sym_LPAREN_PIPE] = ACTIONS(882),
    [anon_sym_u2987] = ACTIONS(884),
    [anon_sym_let] = ACTIONS(886),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(890),
    [aux_sym_string_token1] = ACTIONS(890),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(892),
    [sym_PropN] = ACTIONS(858),
  },
  [409] = {
    [sym__FORALL] = STATE(8396),
    [sym__LAMBDA] = STATE(8031),
    [sym__ELLIPSIS] = STATE(4920),
    [sym__qid] = STATE(4920),
    [sym__binding_ids_and_absurds] = STATE(12357),
    [sym_attribute] = STATE(7725),
    [sym_attributes] = STATE(6200),
    [sym_expr] = STATE(11974),
    [sym__with_exprs] = STATE(10196),
    [sym__expr_or_attr] = STATE(4920),
    [sym__application] = STATE(9678),
    [sym__expr2_without_let] = STATE(9678),
    [sym__expr2] = STATE(9678),
    [sym_atom] = STATE(5202),
    [aux_sym__atoms] = STATE(3165),
    [sym__atom_curly] = STATE(4961),
    [sym__atom_no_curly] = STATE(4961),
    [sym_forall] = STATE(9678),
    [sym_let] = STATE(9678),
    [sym_lambda] = STATE(9678),
    [sym_lambda_extended_or_absurd] = STATE(9678),
    [sym_do] = STATE(9678),
    [sym_record_assignments] = STATE(4920),
    [sym_field_assignments] = STATE(4920),
    [aux_sym__typed_bindings] = STATE(8648),
    [sym_typed_binding] = STATE(8648),
    [sym_literal] = STATE(4920),
    [sym_SetN] = STATE(4920),
    [aux_sym__modal_arg_ids_repeat1] = STATE(7725),
    [aux_sym__with_exprs_repeat1] = STATE(3726),
    [sym_id] = ACTIONS(894),
    [anon_sym_forall] = ACTIONS(896),
    [anon_sym_u2200] = ACTIONS(896),
    [anon_sym_BSLASH] = ACTIONS(898),
    [anon_sym_u03bb] = ACTIONS(900),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(902),
    [anon_sym_u2026] = ACTIONS(902),
    [anon_sym_record] = ACTIONS(904),
    [anon_sym_LPAREN] = ACTIONS(906),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(908),
    [anon_sym_u2983] = ACTIONS(910),
    [anon_sym__] = ACTIONS(902),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(912),
    [anon_sym_RBRACE] = ACTIONS(1042),
    [aux_sym__qid_token1] = ACTIONS(916),
    [anon_sym_DOT] = ACTIONS(918),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(760),
    [anon_sym_quoteGoal] = ACTIONS(920),
    [anon_sym_tactic] = ACTIONS(922),
    [anon_sym_Prop] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(902),
    [anon_sym_quoteTerm] = ACTIONS(902),
    [anon_sym_quoteContext] = ACTIONS(902),
    [anon_sym_unquote] = ACTIONS(902),
    [anon_sym_LPAREN_PIPE] = ACTIONS(924),
    [anon_sym_u2987] = ACTIONS(926),
    [anon_sym_let] = ACTIONS(928),
    [anon_sym_do] = ACTIONS(724),
    [aux_sym_integer_token1] = ACTIONS(930),
    [aux_sym_string_token1] = ACTIONS(930),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(932),
    [sym_PropN] = ACTIONS(902),
  },
  [410] = {
    [sym__FORALL] = STATE(8369),
    [sym__LAMBDA] = STATE(8152),
    [sym__ELLIPSIS] = STATE(5168),
    [sym__qid] = STATE(5168),
    [sym__binding_ids_and_absurds] = STATE(12358),
    [sym_attribute] = STATE(7725),
    [sym_attributes] = STATE(6182),
    [sym_expr] = STATE(11972),
    [sym__with_exprs] = STATE(9861),
    [sym__expr_or_attr] = STATE(5168),
    [sym__application] = STATE(9444),
    [sym__expr2_without_let] = STATE(9444),
    [sym__expr2] = STATE(9444),
    [sym_atom] = STATE(5204),
    [aux_sym__atoms] = STATE(3133),
    [sym__atom_curly] = STATE(5180),
    [sym__atom_no_curly] = STATE(5180),
    [sym_forall] = STATE(9444),
    [sym_let] = STATE(9444),
    [sym_lambda] = STATE(9444),
    [sym_lambda_extended_or_absurd] = STATE(9444),
    [sym_do] = STATE(9444),
    [sym_record_assignments] = STATE(5168),
    [sym_field_assignments] = STATE(5168),
    [aux_sym__typed_bindings] = STATE(8654),
    [sym_typed_binding] = STATE(8654),
    [sym_literal] = STATE(5168),
    [sym_SetN] = STATE(5168),
    [aux_sym__modal_arg_ids_repeat1] = STATE(7725),
    [aux_sym__with_exprs_repeat1] = STATE(3754),
    [sym_id] = ACTIONS(850),
    [anon_sym_forall] = ACTIONS(852),
    [anon_sym_u2200] = ACTIONS(852),
    [anon_sym_BSLASH] = ACTIONS(854),
    [anon_sym_u03bb] = ACTIONS(856),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(858),
    [anon_sym_u2026] = ACTIONS(858),
    [anon_sym_record] = ACTIONS(860),
    [anon_sym_LPAREN] = ACTIONS(862),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(864),
    [anon_sym_u2983] = ACTIONS(866),
    [anon_sym_u2984] = ACTIONS(1044),
    [anon_sym__] = ACTIONS(858),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(870),
    [aux_sym__qid_token1] = ACTIONS(872),
    [anon_sym_DOT] = ACTIONS(874),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(760),
    [anon_sym_quoteGoal] = ACTIONS(878),
    [anon_sym_tactic] = ACTIONS(880),
    [anon_sym_Prop] = ACTIONS(858),
    [anon_sym_quote] = ACTIONS(858),
    [anon_sym_quoteTerm] = ACTIONS(858),
    [anon_sym_quoteContext] = ACTIONS(858),
    [anon_sym_unquote] = ACTIONS(858),
    [anon_sym_LPAREN_PIPE] = ACTIONS(882),
    [anon_sym_u2987] = ACTIONS(884),
    [anon_sym_let] = ACTIONS(886),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(890),
    [aux_sym_string_token1] = ACTIONS(890),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(892),
    [sym_PropN] = ACTIONS(858),
  },
  [411] = {
    [sym__FORALL] = STATE(8355),
    [sym__LAMBDA] = STATE(8054),
    [sym__ELLIPSIS] = STATE(4742),
    [sym__qid] = STATE(4742),
    [sym__binding_ids_and_absurds] = STATE(12547),
    [sym_attribute] = STATE(5830),
    [sym_attributes] = STATE(3506),
    [sym_expr] = STATE(11235),
    [sym__with_exprs] = STATE(10050),
    [sym__expr_or_attr] = STATE(4742),
    [sym__application] = STATE(9444),
    [sym__expr2_without_let] = STATE(9444),
    [sym__expr2] = STATE(9444),
    [sym_atom] = STATE(4712),
    [aux_sym__atoms] = STATE(3276),
    [sym__atom_curly] = STATE(4733),
    [sym__atom_no_curly] = STATE(4733),
    [sym_forall] = STATE(9444),
    [sym_let] = STATE(9444),
    [sym_lambda] = STATE(9444),
    [sym_lambda_extended_or_absurd] = STATE(9444),
    [sym_do] = STATE(9444),
    [sym_record_assignments] = STATE(4742),
    [sym_field_assignments] = STATE(4742),
    [aux_sym__typed_bindings] = STATE(8646),
    [sym_typed_binding] = STATE(8646),
    [sym_literal] = STATE(4742),
    [sym_SetN] = STATE(4742),
    [aux_sym__modal_arg_ids_repeat1] = STATE(5830),
    [aux_sym__with_exprs_repeat1] = STATE(3745),
    [sym_id] = ACTIONS(940),
    [anon_sym_forall] = ACTIONS(942),
    [anon_sym_u2200] = ACTIONS(942),
    [anon_sym_BSLASH] = ACTIONS(944),
    [anon_sym_u03bb] = ACTIONS(946),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(948),
    [anon_sym_u2026] = ACTIONS(948),
    [anon_sym_record] = ACTIONS(950),
    [anon_sym_LPAREN] = ACTIONS(952),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(954),
    [anon_sym_RBRACE_RBRACE] = ACTIONS(1040),
    [anon_sym_u2983] = ACTIONS(956),
    [anon_sym__] = ACTIONS(948),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(958),
    [aux_sym__qid_token1] = ACTIONS(960),
    [anon_sym_DOT] = ACTIONS(962),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(712),
    [anon_sym_quoteGoal] = ACTIONS(964),
    [anon_sym_tactic] = ACTIONS(966),
    [anon_sym_Prop] = ACTIONS(948),
    [anon_sym_quote] = ACTIONS(948),
    [anon_sym_quoteTerm] = ACTIONS(948),
    [anon_sym_quoteContext] = ACTIONS(948),
    [anon_sym_unquote] = ACTIONS(948),
    [anon_sym_LPAREN_PIPE] = ACTIONS(968),
    [anon_sym_u2987] = ACTIONS(970),
    [anon_sym_let] = ACTIONS(972),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(974),
    [aux_sym_string_token1] = ACTIONS(974),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(976),
    [sym_PropN] = ACTIONS(948),
  },
  [412] = {
    [sym__FORALL] = STATE(8345),
    [sym__LAMBDA] = STATE(8095),
    [sym__ELLIPSIS] = STATE(4742),
    [sym_open] = STATE(12555),
    [sym__qid] = STATE(4742),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3873),
    [sym_expr] = STATE(11141),
    [sym__with_exprs] = STATE(10084),
    [sym__expr_or_attr] = STATE(4742),
    [sym__application] = STATE(9680),
    [sym__expr2_without_let] = STATE(9680),
    [sym__expr2] = STATE(9680),
    [sym_atom] = STATE(4712),
    [aux_sym__atoms] = STATE(3211),
    [sym__atom_curly] = STATE(4733),
    [sym__atom_no_curly] = STATE(4733),
    [sym_forall] = STATE(9680),
    [sym_let] = STATE(9680),
    [sym_lambda] = STATE(9680),
    [sym_lambda_extended_or_absurd] = STATE(9680),
    [sym_do] = STATE(9680),
    [sym_record_assignments] = STATE(4742),
    [sym_field_assignments] = STATE(4742),
    [aux_sym__typed_bindings] = STATE(8642),
    [sym_typed_binding] = STATE(8642),
    [sym_literal] = STATE(4742),
    [sym_SetN] = STATE(4742),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3728),
    [sym_id] = ACTIONS(940),
    [anon_sym_forall] = ACTIONS(980),
    [anon_sym_u2200] = ACTIONS(980),
    [anon_sym_BSLASH] = ACTIONS(982),
    [anon_sym_u03bb] = ACTIONS(984),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(948),
    [anon_sym_u2026] = ACTIONS(948),
    [anon_sym_record] = ACTIONS(950),
    [anon_sym_open] = ACTIONS(986),
    [anon_sym_LPAREN] = ACTIONS(952),
    [anon_sym_RPAREN] = ACTIONS(1040),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(954),
    [anon_sym_u2983] = ACTIONS(956),
    [anon_sym__] = ACTIONS(948),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(958),
    [aux_sym__qid_token1] = ACTIONS(960),
    [anon_sym_DOT] = ACTIONS(962),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(988),
    [anon_sym_tactic] = ACTIONS(990),
    [anon_sym_Prop] = ACTIONS(948),
    [anon_sym_quote] = ACTIONS(948),
    [anon_sym_quoteTerm] = ACTIONS(948),
    [anon_sym_quoteContext] = ACTIONS(948),
    [anon_sym_unquote] = ACTIONS(948),
    [anon_sym_LPAREN_PIPE] = ACTIONS(968),
    [anon_sym_u2987] = ACTIONS(970),
    [anon_sym_let] = ACTIONS(992),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(974),
    [aux_sym_string_token1] = ACTIONS(974),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(976),
    [sym_PropN] = ACTIONS(948),
  },
  [413] = {
    [sym__FORALL] = STATE(8396),
    [sym__LAMBDA] = STATE(8031),
    [sym__ELLIPSIS] = STATE(4920),
    [sym__qid] = STATE(4920),
    [sym__binding_ids_and_absurds] = STATE(12539),
    [sym_attribute] = STATE(5830),
    [sym_attributes] = STATE(3504),
    [sym_expr] = STATE(12671),
    [sym__with_exprs] = STATE(10196),
    [sym__expr_or_attr] = STATE(4920),
    [sym__application] = STATE(9678),
    [sym__expr2_without_let] = STATE(9678),
    [sym__expr2] = STATE(9678),
    [sym_atom] = STATE(5202),
    [aux_sym__atoms] = STATE(3165),
    [sym__atom_curly] = STATE(4961),
    [sym__atom_no_curly] = STATE(4961),
    [sym_forall] = STATE(9678),
    [sym_let] = STATE(9678),
    [sym_lambda] = STATE(9678),
    [sym_lambda_extended_or_absurd] = STATE(9678),
    [sym_do] = STATE(9678),
    [sym_record_assignments] = STATE(4920),
    [sym_field_assignments] = STATE(4920),
    [aux_sym__typed_bindings] = STATE(8648),
    [sym_typed_binding] = STATE(8648),
    [sym_literal] = STATE(4920),
    [sym_SetN] = STATE(4920),
    [aux_sym__modal_arg_ids_repeat1] = STATE(5830),
    [aux_sym__with_exprs_repeat1] = STATE(3726),
    [sym_id] = ACTIONS(894),
    [anon_sym_forall] = ACTIONS(896),
    [anon_sym_u2200] = ACTIONS(896),
    [anon_sym_BSLASH] = ACTIONS(898),
    [anon_sym_u03bb] = ACTIONS(900),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(902),
    [anon_sym_u2026] = ACTIONS(902),
    [anon_sym_record] = ACTIONS(904),
    [anon_sym_LPAREN] = ACTIONS(906),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(908),
    [anon_sym_u2983] = ACTIONS(910),
    [anon_sym__] = ACTIONS(902),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(912),
    [anon_sym_RBRACE] = ACTIONS(1046),
    [aux_sym__qid_token1] = ACTIONS(916),
    [anon_sym_DOT] = ACTIONS(918),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(712),
    [anon_sym_quoteGoal] = ACTIONS(920),
    [anon_sym_tactic] = ACTIONS(922),
    [anon_sym_Prop] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(902),
    [anon_sym_quoteTerm] = ACTIONS(902),
    [anon_sym_quoteContext] = ACTIONS(902),
    [anon_sym_unquote] = ACTIONS(902),
    [anon_sym_LPAREN_PIPE] = ACTIONS(924),
    [anon_sym_u2987] = ACTIONS(926),
    [anon_sym_let] = ACTIONS(928),
    [anon_sym_do] = ACTIONS(724),
    [aux_sym_integer_token1] = ACTIONS(930),
    [aux_sym_string_token1] = ACTIONS(930),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(932),
    [sym_PropN] = ACTIONS(902),
  },
  [414] = {
    [sym__FORALL] = STATE(8396),
    [sym__LAMBDA] = STATE(8031),
    [sym__ELLIPSIS] = STATE(4920),
    [sym__qid] = STATE(4920),
    [sym__binding_ids_and_absurds] = STATE(12539),
    [sym_attribute] = STATE(5830),
    [sym_attributes] = STATE(3504),
    [sym_expr] = STATE(12774),
    [sym__with_exprs] = STATE(10196),
    [sym__expr_or_attr] = STATE(4920),
    [sym__application] = STATE(9678),
    [sym__expr2_without_let] = STATE(9678),
    [sym__expr2] = STATE(9678),
    [sym_atom] = STATE(5202),
    [aux_sym__atoms] = STATE(3165),
    [sym__atom_curly] = STATE(4961),
    [sym__atom_no_curly] = STATE(4961),
    [sym_forall] = STATE(9678),
    [sym_let] = STATE(9678),
    [sym_lambda] = STATE(9678),
    [sym_lambda_extended_or_absurd] = STATE(9678),
    [sym_do] = STATE(9678),
    [sym_record_assignments] = STATE(4920),
    [sym_field_assignments] = STATE(4920),
    [aux_sym__typed_bindings] = STATE(8648),
    [sym_typed_binding] = STATE(8648),
    [sym_literal] = STATE(4920),
    [sym_SetN] = STATE(4920),
    [aux_sym__modal_arg_ids_repeat1] = STATE(5830),
    [aux_sym__with_exprs_repeat1] = STATE(3726),
    [sym_id] = ACTIONS(894),
    [anon_sym_forall] = ACTIONS(896),
    [anon_sym_u2200] = ACTIONS(896),
    [anon_sym_BSLASH] = ACTIONS(898),
    [anon_sym_u03bb] = ACTIONS(900),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(902),
    [anon_sym_u2026] = ACTIONS(902),
    [anon_sym_record] = ACTIONS(904),
    [anon_sym_LPAREN] = ACTIONS(906),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(908),
    [anon_sym_u2983] = ACTIONS(910),
    [anon_sym__] = ACTIONS(902),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(912),
    [anon_sym_RBRACE] = ACTIONS(1018),
    [aux_sym__qid_token1] = ACTIONS(916),
    [anon_sym_DOT] = ACTIONS(918),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(712),
    [anon_sym_quoteGoal] = ACTIONS(920),
    [anon_sym_tactic] = ACTIONS(922),
    [anon_sym_Prop] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(902),
    [anon_sym_quoteTerm] = ACTIONS(902),
    [anon_sym_quoteContext] = ACTIONS(902),
    [anon_sym_unquote] = ACTIONS(902),
    [anon_sym_LPAREN_PIPE] = ACTIONS(924),
    [anon_sym_u2987] = ACTIONS(926),
    [anon_sym_let] = ACTIONS(928),
    [anon_sym_do] = ACTIONS(724),
    [aux_sym_integer_token1] = ACTIONS(930),
    [aux_sym_string_token1] = ACTIONS(930),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(932),
    [sym_PropN] = ACTIONS(902),
  },
  [415] = {
    [sym__FORALL] = STATE(8369),
    [sym__LAMBDA] = STATE(8152),
    [sym__ELLIPSIS] = STATE(5168),
    [sym__qid] = STATE(5168),
    [sym__binding_ids_and_absurds] = STATE(12544),
    [sym_attribute] = STATE(5830),
    [sym_attributes] = STATE(3505),
    [sym_expr] = STATE(12775),
    [sym__with_exprs] = STATE(9861),
    [sym__expr_or_attr] = STATE(5168),
    [sym__application] = STATE(9444),
    [sym__expr2_without_let] = STATE(9444),
    [sym__expr2] = STATE(9444),
    [sym_atom] = STATE(5204),
    [aux_sym__atoms] = STATE(3133),
    [sym__atom_curly] = STATE(5180),
    [sym__atom_no_curly] = STATE(5180),
    [sym_forall] = STATE(9444),
    [sym_let] = STATE(9444),
    [sym_lambda] = STATE(9444),
    [sym_lambda_extended_or_absurd] = STATE(9444),
    [sym_do] = STATE(9444),
    [sym_record_assignments] = STATE(5168),
    [sym_field_assignments] = STATE(5168),
    [aux_sym__typed_bindings] = STATE(8654),
    [sym_typed_binding] = STATE(8654),
    [sym_literal] = STATE(5168),
    [sym_SetN] = STATE(5168),
    [aux_sym__modal_arg_ids_repeat1] = STATE(5830),
    [aux_sym__with_exprs_repeat1] = STATE(3754),
    [sym_id] = ACTIONS(850),
    [anon_sym_forall] = ACTIONS(852),
    [anon_sym_u2200] = ACTIONS(852),
    [anon_sym_BSLASH] = ACTIONS(854),
    [anon_sym_u03bb] = ACTIONS(856),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(858),
    [anon_sym_u2026] = ACTIONS(858),
    [anon_sym_record] = ACTIONS(860),
    [anon_sym_LPAREN] = ACTIONS(862),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(864),
    [anon_sym_u2983] = ACTIONS(866),
    [anon_sym_u2984] = ACTIONS(1020),
    [anon_sym__] = ACTIONS(858),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(870),
    [aux_sym__qid_token1] = ACTIONS(872),
    [anon_sym_DOT] = ACTIONS(874),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(712),
    [anon_sym_quoteGoal] = ACTIONS(878),
    [anon_sym_tactic] = ACTIONS(880),
    [anon_sym_Prop] = ACTIONS(858),
    [anon_sym_quote] = ACTIONS(858),
    [anon_sym_quoteTerm] = ACTIONS(858),
    [anon_sym_quoteContext] = ACTIONS(858),
    [anon_sym_unquote] = ACTIONS(858),
    [anon_sym_LPAREN_PIPE] = ACTIONS(882),
    [anon_sym_u2987] = ACTIONS(884),
    [anon_sym_let] = ACTIONS(886),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(890),
    [aux_sym_string_token1] = ACTIONS(890),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(892),
    [sym_PropN] = ACTIONS(858),
  },
  [416] = {
    [sym__FORALL] = STATE(8396),
    [sym__LAMBDA] = STATE(8031),
    [sym__ELLIPSIS] = STATE(4920),
    [sym__qid] = STATE(4920),
    [sym__binding_ids_and_absurds] = STATE(12357),
    [sym_attribute] = STATE(7725),
    [sym_attributes] = STATE(6200),
    [sym_expr] = STATE(10617),
    [sym__with_exprs] = STATE(10196),
    [sym__expr_or_attr] = STATE(4920),
    [sym__application] = STATE(9678),
    [sym__expr2_without_let] = STATE(9678),
    [sym__expr2] = STATE(9678),
    [sym_atom] = STATE(5202),
    [aux_sym__atoms] = STATE(3165),
    [sym__atom_curly] = STATE(4961),
    [sym__atom_no_curly] = STATE(4961),
    [sym_forall] = STATE(9678),
    [sym_let] = STATE(9678),
    [sym_lambda] = STATE(9678),
    [sym_lambda_extended_or_absurd] = STATE(9678),
    [sym_do] = STATE(9678),
    [sym_record_assignments] = STATE(4920),
    [sym_field_assignments] = STATE(4920),
    [aux_sym__typed_bindings] = STATE(8648),
    [sym_typed_binding] = STATE(8648),
    [sym_literal] = STATE(4920),
    [sym_SetN] = STATE(4920),
    [aux_sym__modal_arg_ids_repeat1] = STATE(7725),
    [aux_sym__with_exprs_repeat1] = STATE(3726),
    [sym_id] = ACTIONS(894),
    [anon_sym_forall] = ACTIONS(896),
    [anon_sym_u2200] = ACTIONS(896),
    [anon_sym_BSLASH] = ACTIONS(898),
    [anon_sym_u03bb] = ACTIONS(900),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(902),
    [anon_sym_u2026] = ACTIONS(902),
    [anon_sym_record] = ACTIONS(904),
    [anon_sym_LPAREN] = ACTIONS(906),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(908),
    [anon_sym_u2983] = ACTIONS(910),
    [anon_sym__] = ACTIONS(902),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(912),
    [anon_sym_RBRACE] = ACTIONS(1048),
    [aux_sym__qid_token1] = ACTIONS(916),
    [anon_sym_DOT] = ACTIONS(918),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(760),
    [anon_sym_quoteGoal] = ACTIONS(920),
    [anon_sym_tactic] = ACTIONS(922),
    [anon_sym_Prop] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(902),
    [anon_sym_quoteTerm] = ACTIONS(902),
    [anon_sym_quoteContext] = ACTIONS(902),
    [anon_sym_unquote] = ACTIONS(902),
    [anon_sym_LPAREN_PIPE] = ACTIONS(924),
    [anon_sym_u2987] = ACTIONS(926),
    [anon_sym_let] = ACTIONS(928),
    [anon_sym_do] = ACTIONS(724),
    [aux_sym_integer_token1] = ACTIONS(930),
    [aux_sym_string_token1] = ACTIONS(930),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(932),
    [sym_PropN] = ACTIONS(902),
  },
  [417] = {
    [sym__FORALL] = STATE(8369),
    [sym__LAMBDA] = STATE(8152),
    [sym__ELLIPSIS] = STATE(5168),
    [sym__qid] = STATE(5168),
    [sym__binding_ids_and_absurds] = STATE(12358),
    [sym_attribute] = STATE(7725),
    [sym_attributes] = STATE(6182),
    [sym_expr] = STATE(10578),
    [sym__with_exprs] = STATE(9861),
    [sym__expr_or_attr] = STATE(5168),
    [sym__application] = STATE(9444),
    [sym__expr2_without_let] = STATE(9444),
    [sym__expr2] = STATE(9444),
    [sym_atom] = STATE(5204),
    [aux_sym__atoms] = STATE(3133),
    [sym__atom_curly] = STATE(5180),
    [sym__atom_no_curly] = STATE(5180),
    [sym_forall] = STATE(9444),
    [sym_let] = STATE(9444),
    [sym_lambda] = STATE(9444),
    [sym_lambda_extended_or_absurd] = STATE(9444),
    [sym_do] = STATE(9444),
    [sym_record_assignments] = STATE(5168),
    [sym_field_assignments] = STATE(5168),
    [aux_sym__typed_bindings] = STATE(8654),
    [sym_typed_binding] = STATE(8654),
    [sym_literal] = STATE(5168),
    [sym_SetN] = STATE(5168),
    [aux_sym__modal_arg_ids_repeat1] = STATE(7725),
    [aux_sym__with_exprs_repeat1] = STATE(3754),
    [sym_id] = ACTIONS(850),
    [anon_sym_forall] = ACTIONS(852),
    [anon_sym_u2200] = ACTIONS(852),
    [anon_sym_BSLASH] = ACTIONS(854),
    [anon_sym_u03bb] = ACTIONS(856),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(858),
    [anon_sym_u2026] = ACTIONS(858),
    [anon_sym_record] = ACTIONS(860),
    [anon_sym_LPAREN] = ACTIONS(862),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(864),
    [anon_sym_u2983] = ACTIONS(866),
    [anon_sym_u2984] = ACTIONS(1050),
    [anon_sym__] = ACTIONS(858),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(870),
    [aux_sym__qid_token1] = ACTIONS(872),
    [anon_sym_DOT] = ACTIONS(874),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(760),
    [anon_sym_quoteGoal] = ACTIONS(878),
    [anon_sym_tactic] = ACTIONS(880),
    [anon_sym_Prop] = ACTIONS(858),
    [anon_sym_quote] = ACTIONS(858),
    [anon_sym_quoteTerm] = ACTIONS(858),
    [anon_sym_quoteContext] = ACTIONS(858),
    [anon_sym_unquote] = ACTIONS(858),
    [anon_sym_LPAREN_PIPE] = ACTIONS(882),
    [anon_sym_u2987] = ACTIONS(884),
    [anon_sym_let] = ACTIONS(886),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(890),
    [aux_sym_string_token1] = ACTIONS(890),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(892),
    [sym_PropN] = ACTIONS(858),
  },
  [418] = {
    [sym__FORALL] = STATE(8345),
    [sym__LAMBDA] = STATE(8095),
    [sym__ELLIPSIS] = STATE(4742),
    [sym_open] = STATE(12555),
    [sym__qid] = STATE(4742),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3873),
    [sym_expr] = STATE(12070),
    [sym__with_exprs] = STATE(10084),
    [sym__expr_or_attr] = STATE(4742),
    [sym__application] = STATE(9680),
    [sym__expr2_without_let] = STATE(9680),
    [sym__expr2] = STATE(9680),
    [sym_atom] = STATE(4712),
    [aux_sym__atoms] = STATE(3211),
    [sym__atom_curly] = STATE(4733),
    [sym__atom_no_curly] = STATE(4733),
    [sym_forall] = STATE(9680),
    [sym_let] = STATE(9680),
    [sym_lambda] = STATE(9680),
    [sym_lambda_extended_or_absurd] = STATE(9680),
    [sym_do] = STATE(9680),
    [sym_record_assignments] = STATE(4742),
    [sym_field_assignments] = STATE(4742),
    [aux_sym__typed_bindings] = STATE(8642),
    [sym_typed_binding] = STATE(8642),
    [sym_literal] = STATE(4742),
    [sym_SetN] = STATE(4742),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3728),
    [sym_id] = ACTIONS(940),
    [anon_sym_forall] = ACTIONS(980),
    [anon_sym_u2200] = ACTIONS(980),
    [anon_sym_BSLASH] = ACTIONS(982),
    [anon_sym_u03bb] = ACTIONS(984),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(948),
    [anon_sym_u2026] = ACTIONS(948),
    [anon_sym_record] = ACTIONS(950),
    [anon_sym_open] = ACTIONS(986),
    [anon_sym_LPAREN] = ACTIONS(952),
    [anon_sym_RPAREN] = ACTIONS(1052),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(954),
    [anon_sym_u2983] = ACTIONS(956),
    [anon_sym__] = ACTIONS(948),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(958),
    [aux_sym__qid_token1] = ACTIONS(960),
    [anon_sym_DOT] = ACTIONS(962),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(988),
    [anon_sym_tactic] = ACTIONS(990),
    [anon_sym_Prop] = ACTIONS(948),
    [anon_sym_quote] = ACTIONS(948),
    [anon_sym_quoteTerm] = ACTIONS(948),
    [anon_sym_quoteContext] = ACTIONS(948),
    [anon_sym_unquote] = ACTIONS(948),
    [anon_sym_LPAREN_PIPE] = ACTIONS(968),
    [anon_sym_u2987] = ACTIONS(970),
    [anon_sym_let] = ACTIONS(992),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(974),
    [aux_sym_string_token1] = ACTIONS(974),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(976),
    [sym_PropN] = ACTIONS(948),
  },
  [419] = {
    [sym__FORALL] = STATE(8355),
    [sym__LAMBDA] = STATE(8054),
    [sym__ELLIPSIS] = STATE(4742),
    [sym__qid] = STATE(4742),
    [sym__binding_ids_and_absurds] = STATE(12547),
    [sym_attribute] = STATE(5830),
    [sym_attributes] = STATE(3506),
    [sym_expr] = STATE(12120),
    [sym__with_exprs] = STATE(10050),
    [sym__expr_or_attr] = STATE(4742),
    [sym__application] = STATE(9444),
    [sym__expr2_without_let] = STATE(9444),
    [sym__expr2] = STATE(9444),
    [sym_atom] = STATE(4712),
    [aux_sym__atoms] = STATE(3276),
    [sym__atom_curly] = STATE(4733),
    [sym__atom_no_curly] = STATE(4733),
    [sym_forall] = STATE(9444),
    [sym_let] = STATE(9444),
    [sym_lambda] = STATE(9444),
    [sym_lambda_extended_or_absurd] = STATE(9444),
    [sym_do] = STATE(9444),
    [sym_record_assignments] = STATE(4742),
    [sym_field_assignments] = STATE(4742),
    [aux_sym__typed_bindings] = STATE(8646),
    [sym_typed_binding] = STATE(8646),
    [sym_literal] = STATE(4742),
    [sym_SetN] = STATE(4742),
    [aux_sym__modal_arg_ids_repeat1] = STATE(5830),
    [aux_sym__with_exprs_repeat1] = STATE(3745),
    [sym_id] = ACTIONS(940),
    [anon_sym_forall] = ACTIONS(942),
    [anon_sym_u2200] = ACTIONS(942),
    [anon_sym_BSLASH] = ACTIONS(944),
    [anon_sym_u03bb] = ACTIONS(946),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(948),
    [anon_sym_u2026] = ACTIONS(948),
    [anon_sym_record] = ACTIONS(950),
    [anon_sym_LPAREN] = ACTIONS(952),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(954),
    [anon_sym_RBRACE_RBRACE] = ACTIONS(1052),
    [anon_sym_u2983] = ACTIONS(956),
    [anon_sym__] = ACTIONS(948),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(958),
    [aux_sym__qid_token1] = ACTIONS(960),
    [anon_sym_DOT] = ACTIONS(962),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(712),
    [anon_sym_quoteGoal] = ACTIONS(964),
    [anon_sym_tactic] = ACTIONS(966),
    [anon_sym_Prop] = ACTIONS(948),
    [anon_sym_quote] = ACTIONS(948),
    [anon_sym_quoteTerm] = ACTIONS(948),
    [anon_sym_quoteContext] = ACTIONS(948),
    [anon_sym_unquote] = ACTIONS(948),
    [anon_sym_LPAREN_PIPE] = ACTIONS(968),
    [anon_sym_u2987] = ACTIONS(970),
    [anon_sym_let] = ACTIONS(972),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(974),
    [aux_sym_string_token1] = ACTIONS(974),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(976),
    [sym_PropN] = ACTIONS(948),
  },
  [420] = {
    [sym__FORALL] = STATE(8369),
    [sym__LAMBDA] = STATE(8152),
    [sym__ELLIPSIS] = STATE(5168),
    [sym__qid] = STATE(5168),
    [sym__binding_ids_and_absurds] = STATE(12544),
    [sym_attribute] = STATE(5830),
    [sym_attributes] = STATE(3505),
    [sym_expr] = STATE(12119),
    [sym__with_exprs] = STATE(9861),
    [sym__expr_or_attr] = STATE(5168),
    [sym__application] = STATE(9444),
    [sym__expr2_without_let] = STATE(9444),
    [sym__expr2] = STATE(9444),
    [sym_atom] = STATE(5204),
    [aux_sym__atoms] = STATE(3133),
    [sym__atom_curly] = STATE(5180),
    [sym__atom_no_curly] = STATE(5180),
    [sym_forall] = STATE(9444),
    [sym_let] = STATE(9444),
    [sym_lambda] = STATE(9444),
    [sym_lambda_extended_or_absurd] = STATE(9444),
    [sym_do] = STATE(9444),
    [sym_record_assignments] = STATE(5168),
    [sym_field_assignments] = STATE(5168),
    [aux_sym__typed_bindings] = STATE(8654),
    [sym_typed_binding] = STATE(8654),
    [sym_literal] = STATE(5168),
    [sym_SetN] = STATE(5168),
    [aux_sym__modal_arg_ids_repeat1] = STATE(5830),
    [aux_sym__with_exprs_repeat1] = STATE(3754),
    [sym_id] = ACTIONS(850),
    [anon_sym_forall] = ACTIONS(852),
    [anon_sym_u2200] = ACTIONS(852),
    [anon_sym_BSLASH] = ACTIONS(854),
    [anon_sym_u03bb] = ACTIONS(856),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(858),
    [anon_sym_u2026] = ACTIONS(858),
    [anon_sym_record] = ACTIONS(860),
    [anon_sym_LPAREN] = ACTIONS(862),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(864),
    [anon_sym_u2983] = ACTIONS(866),
    [anon_sym_u2984] = ACTIONS(1052),
    [anon_sym__] = ACTIONS(858),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(870),
    [aux_sym__qid_token1] = ACTIONS(872),
    [anon_sym_DOT] = ACTIONS(874),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(712),
    [anon_sym_quoteGoal] = ACTIONS(878),
    [anon_sym_tactic] = ACTIONS(880),
    [anon_sym_Prop] = ACTIONS(858),
    [anon_sym_quote] = ACTIONS(858),
    [anon_sym_quoteTerm] = ACTIONS(858),
    [anon_sym_quoteContext] = ACTIONS(858),
    [anon_sym_unquote] = ACTIONS(858),
    [anon_sym_LPAREN_PIPE] = ACTIONS(882),
    [anon_sym_u2987] = ACTIONS(884),
    [anon_sym_let] = ACTIONS(886),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(890),
    [aux_sym_string_token1] = ACTIONS(890),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(892),
    [sym_PropN] = ACTIONS(858),
  },
  [421] = {
    [sym__FORALL] = STATE(8396),
    [sym__LAMBDA] = STATE(8031),
    [sym__ELLIPSIS] = STATE(4920),
    [sym__qid] = STATE(4920),
    [sym__binding_ids_and_absurds] = STATE(12357),
    [sym_attribute] = STATE(7725),
    [sym_attributes] = STATE(6200),
    [sym_expr] = STATE(11267),
    [sym__with_exprs] = STATE(10196),
    [sym__expr_or_attr] = STATE(4920),
    [sym__application] = STATE(9678),
    [sym__expr2_without_let] = STATE(9678),
    [sym__expr2] = STATE(9678),
    [sym_atom] = STATE(5202),
    [aux_sym__atoms] = STATE(3165),
    [sym__atom_curly] = STATE(4961),
    [sym__atom_no_curly] = STATE(4961),
    [sym_forall] = STATE(9678),
    [sym_let] = STATE(9678),
    [sym_lambda] = STATE(9678),
    [sym_lambda_extended_or_absurd] = STATE(9678),
    [sym_do] = STATE(9678),
    [sym_record_assignments] = STATE(4920),
    [sym_field_assignments] = STATE(4920),
    [aux_sym__typed_bindings] = STATE(8648),
    [sym_typed_binding] = STATE(8648),
    [sym_literal] = STATE(4920),
    [sym_SetN] = STATE(4920),
    [aux_sym__modal_arg_ids_repeat1] = STATE(7725),
    [aux_sym__with_exprs_repeat1] = STATE(3726),
    [sym_id] = ACTIONS(894),
    [anon_sym_forall] = ACTIONS(896),
    [anon_sym_u2200] = ACTIONS(896),
    [anon_sym_BSLASH] = ACTIONS(898),
    [anon_sym_u03bb] = ACTIONS(900),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(902),
    [anon_sym_u2026] = ACTIONS(902),
    [anon_sym_record] = ACTIONS(904),
    [anon_sym_LPAREN] = ACTIONS(906),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(908),
    [anon_sym_u2983] = ACTIONS(910),
    [anon_sym__] = ACTIONS(902),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(912),
    [anon_sym_RBRACE] = ACTIONS(1054),
    [aux_sym__qid_token1] = ACTIONS(916),
    [anon_sym_DOT] = ACTIONS(918),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(760),
    [anon_sym_quoteGoal] = ACTIONS(920),
    [anon_sym_tactic] = ACTIONS(922),
    [anon_sym_Prop] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(902),
    [anon_sym_quoteTerm] = ACTIONS(902),
    [anon_sym_quoteContext] = ACTIONS(902),
    [anon_sym_unquote] = ACTIONS(902),
    [anon_sym_LPAREN_PIPE] = ACTIONS(924),
    [anon_sym_u2987] = ACTIONS(926),
    [anon_sym_let] = ACTIONS(928),
    [anon_sym_do] = ACTIONS(724),
    [aux_sym_integer_token1] = ACTIONS(930),
    [aux_sym_string_token1] = ACTIONS(930),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(932),
    [sym_PropN] = ACTIONS(902),
  },
  [422] = {
    [sym__FORALL] = STATE(8396),
    [sym__LAMBDA] = STATE(8031),
    [sym__ELLIPSIS] = STATE(4920),
    [sym__qid] = STATE(4920),
    [sym__binding_ids_and_absurds] = STATE(12539),
    [sym_attribute] = STATE(5830),
    [sym_attributes] = STATE(3504),
    [sym_expr] = STATE(12118),
    [sym__with_exprs] = STATE(10196),
    [sym__expr_or_attr] = STATE(4920),
    [sym__application] = STATE(9678),
    [sym__expr2_without_let] = STATE(9678),
    [sym__expr2] = STATE(9678),
    [sym_atom] = STATE(5202),
    [aux_sym__atoms] = STATE(3165),
    [sym__atom_curly] = STATE(4961),
    [sym__atom_no_curly] = STATE(4961),
    [sym_forall] = STATE(9678),
    [sym_let] = STATE(9678),
    [sym_lambda] = STATE(9678),
    [sym_lambda_extended_or_absurd] = STATE(9678),
    [sym_do] = STATE(9678),
    [sym_record_assignments] = STATE(4920),
    [sym_field_assignments] = STATE(4920),
    [aux_sym__typed_bindings] = STATE(8648),
    [sym_typed_binding] = STATE(8648),
    [sym_literal] = STATE(4920),
    [sym_SetN] = STATE(4920),
    [aux_sym__modal_arg_ids_repeat1] = STATE(5830),
    [aux_sym__with_exprs_repeat1] = STATE(3726),
    [sym_id] = ACTIONS(894),
    [anon_sym_forall] = ACTIONS(896),
    [anon_sym_u2200] = ACTIONS(896),
    [anon_sym_BSLASH] = ACTIONS(898),
    [anon_sym_u03bb] = ACTIONS(900),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(902),
    [anon_sym_u2026] = ACTIONS(902),
    [anon_sym_record] = ACTIONS(904),
    [anon_sym_LPAREN] = ACTIONS(906),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(908),
    [anon_sym_u2983] = ACTIONS(910),
    [anon_sym__] = ACTIONS(902),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(912),
    [anon_sym_RBRACE] = ACTIONS(1056),
    [aux_sym__qid_token1] = ACTIONS(916),
    [anon_sym_DOT] = ACTIONS(918),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(712),
    [anon_sym_quoteGoal] = ACTIONS(920),
    [anon_sym_tactic] = ACTIONS(922),
    [anon_sym_Prop] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(902),
    [anon_sym_quoteTerm] = ACTIONS(902),
    [anon_sym_quoteContext] = ACTIONS(902),
    [anon_sym_unquote] = ACTIONS(902),
    [anon_sym_LPAREN_PIPE] = ACTIONS(924),
    [anon_sym_u2987] = ACTIONS(926),
    [anon_sym_let] = ACTIONS(928),
    [anon_sym_do] = ACTIONS(724),
    [aux_sym_integer_token1] = ACTIONS(930),
    [aux_sym_string_token1] = ACTIONS(930),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(932),
    [sym_PropN] = ACTIONS(902),
  },
  [423] = {
    [sym__FORALL] = STATE(8369),
    [sym__LAMBDA] = STATE(8152),
    [sym__ELLIPSIS] = STATE(5168),
    [sym__qid] = STATE(5168),
    [sym__binding_ids_and_absurds] = STATE(12358),
    [sym_attribute] = STATE(7725),
    [sym_attributes] = STATE(6182),
    [sym_expr] = STATE(11268),
    [sym__with_exprs] = STATE(9861),
    [sym__expr_or_attr] = STATE(5168),
    [sym__application] = STATE(9444),
    [sym__expr2_without_let] = STATE(9444),
    [sym__expr2] = STATE(9444),
    [sym_atom] = STATE(5204),
    [aux_sym__atoms] = STATE(3133),
    [sym__atom_curly] = STATE(5180),
    [sym__atom_no_curly] = STATE(5180),
    [sym_forall] = STATE(9444),
    [sym_let] = STATE(9444),
    [sym_lambda] = STATE(9444),
    [sym_lambda_extended_or_absurd] = STATE(9444),
    [sym_do] = STATE(9444),
    [sym_record_assignments] = STATE(5168),
    [sym_field_assignments] = STATE(5168),
    [aux_sym__typed_bindings] = STATE(8654),
    [sym_typed_binding] = STATE(8654),
    [sym_literal] = STATE(5168),
    [sym_SetN] = STATE(5168),
    [aux_sym__modal_arg_ids_repeat1] = STATE(7725),
    [aux_sym__with_exprs_repeat1] = STATE(3754),
    [sym_id] = ACTIONS(850),
    [anon_sym_forall] = ACTIONS(852),
    [anon_sym_u2200] = ACTIONS(852),
    [anon_sym_BSLASH] = ACTIONS(854),
    [anon_sym_u03bb] = ACTIONS(856),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(858),
    [anon_sym_u2026] = ACTIONS(858),
    [anon_sym_record] = ACTIONS(860),
    [anon_sym_LPAREN] = ACTIONS(862),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(864),
    [anon_sym_u2983] = ACTIONS(866),
    [anon_sym_u2984] = ACTIONS(1058),
    [anon_sym__] = ACTIONS(858),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(870),
    [aux_sym__qid_token1] = ACTIONS(872),
    [anon_sym_DOT] = ACTIONS(874),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(760),
    [anon_sym_quoteGoal] = ACTIONS(878),
    [anon_sym_tactic] = ACTIONS(880),
    [anon_sym_Prop] = ACTIONS(858),
    [anon_sym_quote] = ACTIONS(858),
    [anon_sym_quoteTerm] = ACTIONS(858),
    [anon_sym_quoteContext] = ACTIONS(858),
    [anon_sym_unquote] = ACTIONS(858),
    [anon_sym_LPAREN_PIPE] = ACTIONS(882),
    [anon_sym_u2987] = ACTIONS(884),
    [anon_sym_let] = ACTIONS(886),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(890),
    [aux_sym_string_token1] = ACTIONS(890),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(892),
    [sym_PropN] = ACTIONS(858),
  },
  [424] = {
    [sym__FORALL] = STATE(8355),
    [sym__LAMBDA] = STATE(8054),
    [sym__ELLIPSIS] = STATE(4742),
    [sym__qid] = STATE(4742),
    [sym__binding_ids_and_absurds] = STATE(12359),
    [sym_attribute] = STATE(7725),
    [sym_attributes] = STATE(6302),
    [sym_expr] = STATE(11269),
    [sym__with_exprs] = STATE(10050),
    [sym__expr_or_attr] = STATE(4742),
    [sym__application] = STATE(9444),
    [sym__expr2_without_let] = STATE(9444),
    [sym__expr2] = STATE(9444),
    [sym_atom] = STATE(4712),
    [aux_sym__atoms] = STATE(3276),
    [sym__atom_curly] = STATE(4733),
    [sym__atom_no_curly] = STATE(4733),
    [sym_forall] = STATE(9444),
    [sym_let] = STATE(9444),
    [sym_lambda] = STATE(9444),
    [sym_lambda_extended_or_absurd] = STATE(9444),
    [sym_do] = STATE(9444),
    [sym_record_assignments] = STATE(4742),
    [sym_field_assignments] = STATE(4742),
    [aux_sym__typed_bindings] = STATE(8646),
    [sym_typed_binding] = STATE(8646),
    [sym_literal] = STATE(4742),
    [sym_SetN] = STATE(4742),
    [aux_sym__modal_arg_ids_repeat1] = STATE(7725),
    [aux_sym__with_exprs_repeat1] = STATE(3745),
    [sym_id] = ACTIONS(940),
    [anon_sym_forall] = ACTIONS(942),
    [anon_sym_u2200] = ACTIONS(942),
    [anon_sym_BSLASH] = ACTIONS(944),
    [anon_sym_u03bb] = ACTIONS(946),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(948),
    [anon_sym_u2026] = ACTIONS(948),
    [anon_sym_record] = ACTIONS(950),
    [anon_sym_LPAREN] = ACTIONS(952),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(954),
    [anon_sym_RBRACE_RBRACE] = ACTIONS(1058),
    [anon_sym_u2983] = ACTIONS(956),
    [anon_sym__] = ACTIONS(948),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(958),
    [aux_sym__qid_token1] = ACTIONS(960),
    [anon_sym_DOT] = ACTIONS(962),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(760),
    [anon_sym_quoteGoal] = ACTIONS(964),
    [anon_sym_tactic] = ACTIONS(966),
    [anon_sym_Prop] = ACTIONS(948),
    [anon_sym_quote] = ACTIONS(948),
    [anon_sym_quoteTerm] = ACTIONS(948),
    [anon_sym_quoteContext] = ACTIONS(948),
    [anon_sym_unquote] = ACTIONS(948),
    [anon_sym_LPAREN_PIPE] = ACTIONS(968),
    [anon_sym_u2987] = ACTIONS(970),
    [anon_sym_let] = ACTIONS(972),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(974),
    [aux_sym_string_token1] = ACTIONS(974),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(976),
    [sym_PropN] = ACTIONS(948),
  },
  [425] = {
    [sym__FORALL] = STATE(8355),
    [sym__LAMBDA] = STATE(8054),
    [sym__ELLIPSIS] = STATE(4742),
    [sym__qid] = STATE(4742),
    [sym__binding_ids_and_absurds] = STATE(12359),
    [sym_attribute] = STATE(7725),
    [sym_attributes] = STATE(6302),
    [sym_expr] = STATE(11971),
    [sym__with_exprs] = STATE(10050),
    [sym__expr_or_attr] = STATE(4742),
    [sym__application] = STATE(9444),
    [sym__expr2_without_let] = STATE(9444),
    [sym__expr2] = STATE(9444),
    [sym_atom] = STATE(4712),
    [aux_sym__atoms] = STATE(3276),
    [sym__atom_curly] = STATE(4733),
    [sym__atom_no_curly] = STATE(4733),
    [sym_forall] = STATE(9444),
    [sym_let] = STATE(9444),
    [sym_lambda] = STATE(9444),
    [sym_lambda_extended_or_absurd] = STATE(9444),
    [sym_do] = STATE(9444),
    [sym_record_assignments] = STATE(4742),
    [sym_field_assignments] = STATE(4742),
    [aux_sym__typed_bindings] = STATE(8646),
    [sym_typed_binding] = STATE(8646),
    [sym_literal] = STATE(4742),
    [sym_SetN] = STATE(4742),
    [aux_sym__modal_arg_ids_repeat1] = STATE(7725),
    [aux_sym__with_exprs_repeat1] = STATE(3745),
    [sym_id] = ACTIONS(940),
    [anon_sym_forall] = ACTIONS(942),
    [anon_sym_u2200] = ACTIONS(942),
    [anon_sym_BSLASH] = ACTIONS(944),
    [anon_sym_u03bb] = ACTIONS(946),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(948),
    [anon_sym_u2026] = ACTIONS(948),
    [anon_sym_record] = ACTIONS(950),
    [anon_sym_LPAREN] = ACTIONS(952),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(954),
    [anon_sym_RBRACE_RBRACE] = ACTIONS(1044),
    [anon_sym_u2983] = ACTIONS(956),
    [anon_sym__] = ACTIONS(948),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(958),
    [aux_sym__qid_token1] = ACTIONS(960),
    [anon_sym_DOT] = ACTIONS(962),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(760),
    [anon_sym_quoteGoal] = ACTIONS(964),
    [anon_sym_tactic] = ACTIONS(966),
    [anon_sym_Prop] = ACTIONS(948),
    [anon_sym_quote] = ACTIONS(948),
    [anon_sym_quoteTerm] = ACTIONS(948),
    [anon_sym_quoteContext] = ACTIONS(948),
    [anon_sym_unquote] = ACTIONS(948),
    [anon_sym_LPAREN_PIPE] = ACTIONS(968),
    [anon_sym_u2987] = ACTIONS(970),
    [anon_sym_let] = ACTIONS(972),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(974),
    [aux_sym_string_token1] = ACTIONS(974),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(976),
    [sym_PropN] = ACTIONS(948),
  },
  [426] = {
    [sym__FORALL] = STATE(8396),
    [sym__LAMBDA] = STATE(8031),
    [sym__ELLIPSIS] = STATE(4920),
    [sym__qid] = STATE(4920),
    [sym__binding_ids_and_absurds] = STATE(12357),
    [sym_attribute] = STATE(7725),
    [sym_attributes] = STATE(6200),
    [sym_expr] = STATE(11395),
    [sym__with_exprs] = STATE(10196),
    [sym__expr_or_attr] = STATE(4920),
    [sym__application] = STATE(9678),
    [sym__expr2_without_let] = STATE(9678),
    [sym__expr2] = STATE(9678),
    [sym_atom] = STATE(5202),
    [aux_sym__atoms] = STATE(3165),
    [sym__atom_curly] = STATE(4961),
    [sym__atom_no_curly] = STATE(4961),
    [sym_forall] = STATE(9678),
    [sym_let] = STATE(9678),
    [sym_lambda] = STATE(9678),
    [sym_lambda_extended_or_absurd] = STATE(9678),
    [sym_do] = STATE(9678),
    [sym_record_assignments] = STATE(4920),
    [sym_field_assignments] = STATE(4920),
    [aux_sym__typed_bindings] = STATE(8648),
    [sym_typed_binding] = STATE(8648),
    [sym_literal] = STATE(4920),
    [sym_SetN] = STATE(4920),
    [aux_sym__modal_arg_ids_repeat1] = STATE(7725),
    [aux_sym__with_exprs_repeat1] = STATE(3726),
    [sym_id] = ACTIONS(894),
    [anon_sym_forall] = ACTIONS(896),
    [anon_sym_u2200] = ACTIONS(896),
    [anon_sym_BSLASH] = ACTIONS(898),
    [anon_sym_u03bb] = ACTIONS(900),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(902),
    [anon_sym_u2026] = ACTIONS(902),
    [anon_sym_record] = ACTIONS(904),
    [anon_sym_LPAREN] = ACTIONS(906),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(908),
    [anon_sym_u2983] = ACTIONS(910),
    [anon_sym__] = ACTIONS(902),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(912),
    [anon_sym_RBRACE] = ACTIONS(1060),
    [aux_sym__qid_token1] = ACTIONS(916),
    [anon_sym_DOT] = ACTIONS(918),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(760),
    [anon_sym_quoteGoal] = ACTIONS(920),
    [anon_sym_tactic] = ACTIONS(922),
    [anon_sym_Prop] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(902),
    [anon_sym_quoteTerm] = ACTIONS(902),
    [anon_sym_quoteContext] = ACTIONS(902),
    [anon_sym_unquote] = ACTIONS(902),
    [anon_sym_LPAREN_PIPE] = ACTIONS(924),
    [anon_sym_u2987] = ACTIONS(926),
    [anon_sym_let] = ACTIONS(928),
    [anon_sym_do] = ACTIONS(724),
    [aux_sym_integer_token1] = ACTIONS(930),
    [aux_sym_string_token1] = ACTIONS(930),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(932),
    [sym_PropN] = ACTIONS(902),
  },
  [427] = {
    [sym__FORALL] = STATE(8355),
    [sym__LAMBDA] = STATE(8054),
    [sym__ELLIPSIS] = STATE(4742),
    [sym__qid] = STATE(4742),
    [sym__binding_ids_and_absurds] = STATE(12359),
    [sym_attribute] = STATE(7725),
    [sym_attributes] = STATE(6302),
    [sym_expr] = STATE(10579),
    [sym__with_exprs] = STATE(10050),
    [sym__expr_or_attr] = STATE(4742),
    [sym__application] = STATE(9444),
    [sym__expr2_without_let] = STATE(9444),
    [sym__expr2] = STATE(9444),
    [sym_atom] = STATE(4712),
    [aux_sym__atoms] = STATE(3276),
    [sym__atom_curly] = STATE(4733),
    [sym__atom_no_curly] = STATE(4733),
    [sym_forall] = STATE(9444),
    [sym_let] = STATE(9444),
    [sym_lambda] = STATE(9444),
    [sym_lambda_extended_or_absurd] = STATE(9444),
    [sym_do] = STATE(9444),
    [sym_record_assignments] = STATE(4742),
    [sym_field_assignments] = STATE(4742),
    [aux_sym__typed_bindings] = STATE(8646),
    [sym_typed_binding] = STATE(8646),
    [sym_literal] = STATE(4742),
    [sym_SetN] = STATE(4742),
    [aux_sym__modal_arg_ids_repeat1] = STATE(7725),
    [aux_sym__with_exprs_repeat1] = STATE(3745),
    [sym_id] = ACTIONS(940),
    [anon_sym_forall] = ACTIONS(942),
    [anon_sym_u2200] = ACTIONS(942),
    [anon_sym_BSLASH] = ACTIONS(944),
    [anon_sym_u03bb] = ACTIONS(946),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(948),
    [anon_sym_u2026] = ACTIONS(948),
    [anon_sym_record] = ACTIONS(950),
    [anon_sym_LPAREN] = ACTIONS(952),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(954),
    [anon_sym_RBRACE_RBRACE] = ACTIONS(1050),
    [anon_sym_u2983] = ACTIONS(956),
    [anon_sym__] = ACTIONS(948),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(958),
    [aux_sym__qid_token1] = ACTIONS(960),
    [anon_sym_DOT] = ACTIONS(962),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(760),
    [anon_sym_quoteGoal] = ACTIONS(964),
    [anon_sym_tactic] = ACTIONS(966),
    [anon_sym_Prop] = ACTIONS(948),
    [anon_sym_quote] = ACTIONS(948),
    [anon_sym_quoteTerm] = ACTIONS(948),
    [anon_sym_quoteContext] = ACTIONS(948),
    [anon_sym_unquote] = ACTIONS(948),
    [anon_sym_LPAREN_PIPE] = ACTIONS(968),
    [anon_sym_u2987] = ACTIONS(970),
    [anon_sym_let] = ACTIONS(972),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(974),
    [aux_sym_string_token1] = ACTIONS(974),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(976),
    [sym_PropN] = ACTIONS(948),
  },
  [428] = {
    [sym__FORALL] = STATE(8369),
    [sym__LAMBDA] = STATE(8152),
    [sym__ELLIPSIS] = STATE(5168),
    [sym__qid] = STATE(5168),
    [sym__binding_ids_and_absurds] = STATE(12358),
    [sym_attribute] = STATE(7725),
    [sym_attributes] = STATE(6182),
    [sym_expr] = STATE(11359),
    [sym__with_exprs] = STATE(9861),
    [sym__expr_or_attr] = STATE(5168),
    [sym__application] = STATE(9444),
    [sym__expr2_without_let] = STATE(9444),
    [sym__expr2] = STATE(9444),
    [sym_atom] = STATE(5204),
    [aux_sym__atoms] = STATE(3133),
    [sym__atom_curly] = STATE(5180),
    [sym__atom_no_curly] = STATE(5180),
    [sym_forall] = STATE(9444),
    [sym_let] = STATE(9444),
    [sym_lambda] = STATE(9444),
    [sym_lambda_extended_or_absurd] = STATE(9444),
    [sym_do] = STATE(9444),
    [sym_record_assignments] = STATE(5168),
    [sym_field_assignments] = STATE(5168),
    [aux_sym__typed_bindings] = STATE(8654),
    [sym_typed_binding] = STATE(8654),
    [sym_literal] = STATE(5168),
    [sym_SetN] = STATE(5168),
    [aux_sym__modal_arg_ids_repeat1] = STATE(7725),
    [aux_sym__with_exprs_repeat1] = STATE(3754),
    [sym_id] = ACTIONS(850),
    [anon_sym_forall] = ACTIONS(852),
    [anon_sym_u2200] = ACTIONS(852),
    [anon_sym_BSLASH] = ACTIONS(854),
    [anon_sym_u03bb] = ACTIONS(856),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(858),
    [anon_sym_u2026] = ACTIONS(858),
    [anon_sym_record] = ACTIONS(860),
    [anon_sym_LPAREN] = ACTIONS(862),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(864),
    [anon_sym_u2983] = ACTIONS(866),
    [anon_sym_u2984] = ACTIONS(1062),
    [anon_sym__] = ACTIONS(858),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(870),
    [aux_sym__qid_token1] = ACTIONS(872),
    [anon_sym_DOT] = ACTIONS(874),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(760),
    [anon_sym_quoteGoal] = ACTIONS(878),
    [anon_sym_tactic] = ACTIONS(880),
    [anon_sym_Prop] = ACTIONS(858),
    [anon_sym_quote] = ACTIONS(858),
    [anon_sym_quoteTerm] = ACTIONS(858),
    [anon_sym_quoteContext] = ACTIONS(858),
    [anon_sym_unquote] = ACTIONS(858),
    [anon_sym_LPAREN_PIPE] = ACTIONS(882),
    [anon_sym_u2987] = ACTIONS(884),
    [anon_sym_let] = ACTIONS(886),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(890),
    [aux_sym_string_token1] = ACTIONS(890),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(892),
    [sym_PropN] = ACTIONS(858),
  },
  [429] = {
    [sym__FORALL] = STATE(8355),
    [sym__LAMBDA] = STATE(8054),
    [sym__ELLIPSIS] = STATE(4742),
    [sym__qid] = STATE(4742),
    [sym__binding_ids_and_absurds] = STATE(12359),
    [sym_attribute] = STATE(7725),
    [sym_attributes] = STATE(6302),
    [sym_expr] = STATE(11360),
    [sym__with_exprs] = STATE(10050),
    [sym__expr_or_attr] = STATE(4742),
    [sym__application] = STATE(9444),
    [sym__expr2_without_let] = STATE(9444),
    [sym__expr2] = STATE(9444),
    [sym_atom] = STATE(4712),
    [aux_sym__atoms] = STATE(3276),
    [sym__atom_curly] = STATE(4733),
    [sym__atom_no_curly] = STATE(4733),
    [sym_forall] = STATE(9444),
    [sym_let] = STATE(9444),
    [sym_lambda] = STATE(9444),
    [sym_lambda_extended_or_absurd] = STATE(9444),
    [sym_do] = STATE(9444),
    [sym_record_assignments] = STATE(4742),
    [sym_field_assignments] = STATE(4742),
    [aux_sym__typed_bindings] = STATE(8646),
    [sym_typed_binding] = STATE(8646),
    [sym_literal] = STATE(4742),
    [sym_SetN] = STATE(4742),
    [aux_sym__modal_arg_ids_repeat1] = STATE(7725),
    [aux_sym__with_exprs_repeat1] = STATE(3745),
    [sym_id] = ACTIONS(940),
    [anon_sym_forall] = ACTIONS(942),
    [anon_sym_u2200] = ACTIONS(942),
    [anon_sym_BSLASH] = ACTIONS(944),
    [anon_sym_u03bb] = ACTIONS(946),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(948),
    [anon_sym_u2026] = ACTIONS(948),
    [anon_sym_record] = ACTIONS(950),
    [anon_sym_LPAREN] = ACTIONS(952),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(954),
    [anon_sym_RBRACE_RBRACE] = ACTIONS(1062),
    [anon_sym_u2983] = ACTIONS(956),
    [anon_sym__] = ACTIONS(948),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(958),
    [aux_sym__qid_token1] = ACTIONS(960),
    [anon_sym_DOT] = ACTIONS(962),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(760),
    [anon_sym_quoteGoal] = ACTIONS(964),
    [anon_sym_tactic] = ACTIONS(966),
    [anon_sym_Prop] = ACTIONS(948),
    [anon_sym_quote] = ACTIONS(948),
    [anon_sym_quoteTerm] = ACTIONS(948),
    [anon_sym_quoteContext] = ACTIONS(948),
    [anon_sym_unquote] = ACTIONS(948),
    [anon_sym_LPAREN_PIPE] = ACTIONS(968),
    [anon_sym_u2987] = ACTIONS(970),
    [anon_sym_let] = ACTIONS(972),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(974),
    [aux_sym_string_token1] = ACTIONS(974),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(976),
    [sym_PropN] = ACTIONS(948),
  },
  [430] = {
    [sym__FORALL] = STATE(8355),
    [sym__LAMBDA] = STATE(8054),
    [sym__ELLIPSIS] = STATE(4742),
    [sym__qid] = STATE(4742),
    [sym__binding_ids_and_absurds] = STATE(12547),
    [sym_attribute] = STATE(5830),
    [sym_attributes] = STATE(3506),
    [sym_expr] = STATE(12776),
    [sym__with_exprs] = STATE(10050),
    [sym__expr_or_attr] = STATE(4742),
    [sym__application] = STATE(9444),
    [sym__expr2_without_let] = STATE(9444),
    [sym__expr2] = STATE(9444),
    [sym_atom] = STATE(4712),
    [aux_sym__atoms] = STATE(3276),
    [sym__atom_curly] = STATE(4733),
    [sym__atom_no_curly] = STATE(4733),
    [sym_forall] = STATE(9444),
    [sym_let] = STATE(9444),
    [sym_lambda] = STATE(9444),
    [sym_lambda_extended_or_absurd] = STATE(9444),
    [sym_do] = STATE(9444),
    [sym_record_assignments] = STATE(4742),
    [sym_field_assignments] = STATE(4742),
    [aux_sym__typed_bindings] = STATE(8646),
    [sym_typed_binding] = STATE(8646),
    [sym_literal] = STATE(4742),
    [sym_SetN] = STATE(4742),
    [aux_sym__modal_arg_ids_repeat1] = STATE(5830),
    [aux_sym__with_exprs_repeat1] = STATE(3745),
    [sym_id] = ACTIONS(940),
    [anon_sym_forall] = ACTIONS(942),
    [anon_sym_u2200] = ACTIONS(942),
    [anon_sym_BSLASH] = ACTIONS(944),
    [anon_sym_u03bb] = ACTIONS(946),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(948),
    [anon_sym_u2026] = ACTIONS(948),
    [anon_sym_record] = ACTIONS(950),
    [anon_sym_LPAREN] = ACTIONS(952),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(954),
    [anon_sym_RBRACE_RBRACE] = ACTIONS(1020),
    [anon_sym_u2983] = ACTIONS(956),
    [anon_sym__] = ACTIONS(948),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(958),
    [aux_sym__qid_token1] = ACTIONS(960),
    [anon_sym_DOT] = ACTIONS(962),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(712),
    [anon_sym_quoteGoal] = ACTIONS(964),
    [anon_sym_tactic] = ACTIONS(966),
    [anon_sym_Prop] = ACTIONS(948),
    [anon_sym_quote] = ACTIONS(948),
    [anon_sym_quoteTerm] = ACTIONS(948),
    [anon_sym_quoteContext] = ACTIONS(948),
    [anon_sym_unquote] = ACTIONS(948),
    [anon_sym_LPAREN_PIPE] = ACTIONS(968),
    [anon_sym_u2987] = ACTIONS(970),
    [anon_sym_let] = ACTIONS(972),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(974),
    [aux_sym_string_token1] = ACTIONS(974),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(976),
    [sym_PropN] = ACTIONS(948),
  },
  [431] = {
    [sym__FORALL] = STATE(8396),
    [sym__LAMBDA] = STATE(8031),
    [sym__ELLIPSIS] = STATE(4920),
    [sym__qid] = STATE(4920),
    [sym__binding_ids_and_absurds] = STATE(12539),
    [sym_attribute] = STATE(5830),
    [sym_attributes] = STATE(3504),
    [sym_expr] = STATE(11267),
    [sym__with_exprs] = STATE(10196),
    [sym__expr_or_attr] = STATE(4920),
    [sym__application] = STATE(9678),
    [sym__expr2_without_let] = STATE(9678),
    [sym__expr2] = STATE(9678),
    [sym_atom] = STATE(5202),
    [aux_sym__atoms] = STATE(3165),
    [sym__atom_curly] = STATE(4961),
    [sym__atom_no_curly] = STATE(4961),
    [sym_forall] = STATE(9678),
    [sym_let] = STATE(9678),
    [sym_lambda] = STATE(9678),
    [sym_lambda_extended_or_absurd] = STATE(9678),
    [sym_do] = STATE(9678),
    [sym_record_assignments] = STATE(4920),
    [sym_field_assignments] = STATE(4920),
    [aux_sym__typed_bindings] = STATE(8648),
    [sym_typed_binding] = STATE(8648),
    [sym_literal] = STATE(4920),
    [sym_SetN] = STATE(4920),
    [aux_sym__modal_arg_ids_repeat1] = STATE(5830),
    [aux_sym__with_exprs_repeat1] = STATE(3726),
    [sym_id] = ACTIONS(894),
    [anon_sym_forall] = ACTIONS(896),
    [anon_sym_u2200] = ACTIONS(896),
    [anon_sym_BSLASH] = ACTIONS(898),
    [anon_sym_u03bb] = ACTIONS(900),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(902),
    [anon_sym_u2026] = ACTIONS(902),
    [anon_sym_record] = ACTIONS(904),
    [anon_sym_LPAREN] = ACTIONS(906),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(908),
    [anon_sym_u2983] = ACTIONS(910),
    [anon_sym__] = ACTIONS(902),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(912),
    [anon_sym_RBRACE] = ACTIONS(1054),
    [aux_sym__qid_token1] = ACTIONS(916),
    [anon_sym_DOT] = ACTIONS(918),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(712),
    [anon_sym_quoteGoal] = ACTIONS(920),
    [anon_sym_tactic] = ACTIONS(922),
    [anon_sym_Prop] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(902),
    [anon_sym_quoteTerm] = ACTIONS(902),
    [anon_sym_quoteContext] = ACTIONS(902),
    [anon_sym_unquote] = ACTIONS(902),
    [anon_sym_LPAREN_PIPE] = ACTIONS(924),
    [anon_sym_u2987] = ACTIONS(926),
    [anon_sym_let] = ACTIONS(928),
    [anon_sym_do] = ACTIONS(724),
    [aux_sym_integer_token1] = ACTIONS(930),
    [aux_sym_string_token1] = ACTIONS(930),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(932),
    [sym_PropN] = ACTIONS(902),
  },
  [432] = {
    [sym__FORALL] = STATE(8345),
    [sym__LAMBDA] = STATE(8095),
    [sym__ELLIPSIS] = STATE(4742),
    [sym_open] = STATE(12555),
    [sym__qid] = STATE(4742),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3873),
    [sym_expr] = STATE(11071),
    [sym__with_exprs] = STATE(10084),
    [sym__expr_or_attr] = STATE(4742),
    [sym__application] = STATE(9680),
    [sym__expr2_without_let] = STATE(9680),
    [sym__expr2] = STATE(9680),
    [sym_atom] = STATE(4712),
    [aux_sym__atoms] = STATE(3211),
    [sym__atom_curly] = STATE(4733),
    [sym__atom_no_curly] = STATE(4733),
    [sym_forall] = STATE(9680),
    [sym_let] = STATE(9680),
    [sym_lambda] = STATE(9680),
    [sym_lambda_extended_or_absurd] = STATE(9680),
    [sym_do] = STATE(9680),
    [sym_record_assignments] = STATE(4742),
    [sym_field_assignments] = STATE(4742),
    [aux_sym__typed_bindings] = STATE(8642),
    [sym_typed_binding] = STATE(8642),
    [sym_literal] = STATE(4742),
    [sym_SetN] = STATE(4742),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3728),
    [sym_id] = ACTIONS(940),
    [anon_sym_forall] = ACTIONS(980),
    [anon_sym_u2200] = ACTIONS(980),
    [anon_sym_BSLASH] = ACTIONS(982),
    [anon_sym_u03bb] = ACTIONS(984),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(948),
    [anon_sym_u2026] = ACTIONS(948),
    [anon_sym_record] = ACTIONS(950),
    [anon_sym_open] = ACTIONS(986),
    [anon_sym_LPAREN] = ACTIONS(952),
    [anon_sym_RPAREN] = ACTIONS(1064),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(954),
    [anon_sym_u2983] = ACTIONS(956),
    [anon_sym__] = ACTIONS(948),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(958),
    [aux_sym__qid_token1] = ACTIONS(960),
    [anon_sym_DOT] = ACTIONS(962),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(988),
    [anon_sym_tactic] = ACTIONS(990),
    [anon_sym_Prop] = ACTIONS(948),
    [anon_sym_quote] = ACTIONS(948),
    [anon_sym_quoteTerm] = ACTIONS(948),
    [anon_sym_quoteContext] = ACTIONS(948),
    [anon_sym_unquote] = ACTIONS(948),
    [anon_sym_LPAREN_PIPE] = ACTIONS(968),
    [anon_sym_u2987] = ACTIONS(970),
    [anon_sym_let] = ACTIONS(992),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(974),
    [aux_sym_string_token1] = ACTIONS(974),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(976),
    [sym_PropN] = ACTIONS(948),
  },
  [433] = {
    [sym__FORALL] = STATE(8369),
    [sym__LAMBDA] = STATE(8152),
    [sym__ELLIPSIS] = STATE(5168),
    [sym__qid] = STATE(5168),
    [sym__binding_ids_and_absurds] = STATE(12544),
    [sym_attribute] = STATE(5830),
    [sym_attributes] = STATE(3505),
    [sym_expr] = STATE(11268),
    [sym__with_exprs] = STATE(9861),
    [sym__expr_or_attr] = STATE(5168),
    [sym__application] = STATE(9444),
    [sym__expr2_without_let] = STATE(9444),
    [sym__expr2] = STATE(9444),
    [sym_atom] = STATE(5204),
    [aux_sym__atoms] = STATE(3133),
    [sym__atom_curly] = STATE(5180),
    [sym__atom_no_curly] = STATE(5180),
    [sym_forall] = STATE(9444),
    [sym_let] = STATE(9444),
    [sym_lambda] = STATE(9444),
    [sym_lambda_extended_or_absurd] = STATE(9444),
    [sym_do] = STATE(9444),
    [sym_record_assignments] = STATE(5168),
    [sym_field_assignments] = STATE(5168),
    [aux_sym__typed_bindings] = STATE(8654),
    [sym_typed_binding] = STATE(8654),
    [sym_literal] = STATE(5168),
    [sym_SetN] = STATE(5168),
    [aux_sym__modal_arg_ids_repeat1] = STATE(5830),
    [aux_sym__with_exprs_repeat1] = STATE(3754),
    [sym_id] = ACTIONS(850),
    [anon_sym_forall] = ACTIONS(852),
    [anon_sym_u2200] = ACTIONS(852),
    [anon_sym_BSLASH] = ACTIONS(854),
    [anon_sym_u03bb] = ACTIONS(856),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(858),
    [anon_sym_u2026] = ACTIONS(858),
    [anon_sym_record] = ACTIONS(860),
    [anon_sym_LPAREN] = ACTIONS(862),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(864),
    [anon_sym_u2983] = ACTIONS(866),
    [anon_sym_u2984] = ACTIONS(1058),
    [anon_sym__] = ACTIONS(858),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(870),
    [aux_sym__qid_token1] = ACTIONS(872),
    [anon_sym_DOT] = ACTIONS(874),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(712),
    [anon_sym_quoteGoal] = ACTIONS(878),
    [anon_sym_tactic] = ACTIONS(880),
    [anon_sym_Prop] = ACTIONS(858),
    [anon_sym_quote] = ACTIONS(858),
    [anon_sym_quoteTerm] = ACTIONS(858),
    [anon_sym_quoteContext] = ACTIONS(858),
    [anon_sym_unquote] = ACTIONS(858),
    [anon_sym_LPAREN_PIPE] = ACTIONS(882),
    [anon_sym_u2987] = ACTIONS(884),
    [anon_sym_let] = ACTIONS(886),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(890),
    [aux_sym_string_token1] = ACTIONS(890),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(892),
    [sym_PropN] = ACTIONS(858),
  },
  [434] = {
    [sym__FORALL] = STATE(8396),
    [sym__LAMBDA] = STATE(8031),
    [sym__ELLIPSIS] = STATE(4920),
    [sym__qid] = STATE(4920),
    [sym__binding_ids_and_absurds] = STATE(12539),
    [sym_attribute] = STATE(5830),
    [sym_attributes] = STATE(3504),
    [sym_expr] = STATE(11974),
    [sym__with_exprs] = STATE(10196),
    [sym__expr_or_attr] = STATE(4920),
    [sym__application] = STATE(9678),
    [sym__expr2_without_let] = STATE(9678),
    [sym__expr2] = STATE(9678),
    [sym_atom] = STATE(5202),
    [aux_sym__atoms] = STATE(3165),
    [sym__atom_curly] = STATE(4961),
    [sym__atom_no_curly] = STATE(4961),
    [sym_forall] = STATE(9678),
    [sym_let] = STATE(9678),
    [sym_lambda] = STATE(9678),
    [sym_lambda_extended_or_absurd] = STATE(9678),
    [sym_do] = STATE(9678),
    [sym_record_assignments] = STATE(4920),
    [sym_field_assignments] = STATE(4920),
    [aux_sym__typed_bindings] = STATE(8648),
    [sym_typed_binding] = STATE(8648),
    [sym_literal] = STATE(4920),
    [sym_SetN] = STATE(4920),
    [aux_sym__modal_arg_ids_repeat1] = STATE(5830),
    [aux_sym__with_exprs_repeat1] = STATE(3726),
    [sym_id] = ACTIONS(894),
    [anon_sym_forall] = ACTIONS(896),
    [anon_sym_u2200] = ACTIONS(896),
    [anon_sym_BSLASH] = ACTIONS(898),
    [anon_sym_u03bb] = ACTIONS(900),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(902),
    [anon_sym_u2026] = ACTIONS(902),
    [anon_sym_record] = ACTIONS(904),
    [anon_sym_LPAREN] = ACTIONS(906),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(908),
    [anon_sym_u2983] = ACTIONS(910),
    [anon_sym__] = ACTIONS(902),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(912),
    [anon_sym_RBRACE] = ACTIONS(1042),
    [aux_sym__qid_token1] = ACTIONS(916),
    [anon_sym_DOT] = ACTIONS(918),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(712),
    [anon_sym_quoteGoal] = ACTIONS(920),
    [anon_sym_tactic] = ACTIONS(922),
    [anon_sym_Prop] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(902),
    [anon_sym_quoteTerm] = ACTIONS(902),
    [anon_sym_quoteContext] = ACTIONS(902),
    [anon_sym_unquote] = ACTIONS(902),
    [anon_sym_LPAREN_PIPE] = ACTIONS(924),
    [anon_sym_u2987] = ACTIONS(926),
    [anon_sym_let] = ACTIONS(928),
    [anon_sym_do] = ACTIONS(724),
    [aux_sym_integer_token1] = ACTIONS(930),
    [aux_sym_string_token1] = ACTIONS(930),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(932),
    [sym_PropN] = ACTIONS(902),
  },
  [435] = {
    [sym__FORALL] = STATE(8369),
    [sym__LAMBDA] = STATE(8152),
    [sym__ELLIPSIS] = STATE(5168),
    [sym__qid] = STATE(5168),
    [sym__binding_ids_and_absurds] = STATE(12544),
    [sym_attribute] = STATE(5830),
    [sym_attributes] = STATE(3505),
    [sym_expr] = STATE(11972),
    [sym__with_exprs] = STATE(9861),
    [sym__expr_or_attr] = STATE(5168),
    [sym__application] = STATE(9444),
    [sym__expr2_without_let] = STATE(9444),
    [sym__expr2] = STATE(9444),
    [sym_atom] = STATE(5204),
    [aux_sym__atoms] = STATE(3133),
    [sym__atom_curly] = STATE(5180),
    [sym__atom_no_curly] = STATE(5180),
    [sym_forall] = STATE(9444),
    [sym_let] = STATE(9444),
    [sym_lambda] = STATE(9444),
    [sym_lambda_extended_or_absurd] = STATE(9444),
    [sym_do] = STATE(9444),
    [sym_record_assignments] = STATE(5168),
    [sym_field_assignments] = STATE(5168),
    [aux_sym__typed_bindings] = STATE(8654),
    [sym_typed_binding] = STATE(8654),
    [sym_literal] = STATE(5168),
    [sym_SetN] = STATE(5168),
    [aux_sym__modal_arg_ids_repeat1] = STATE(5830),
    [aux_sym__with_exprs_repeat1] = STATE(3754),
    [sym_id] = ACTIONS(850),
    [anon_sym_forall] = ACTIONS(852),
    [anon_sym_u2200] = ACTIONS(852),
    [anon_sym_BSLASH] = ACTIONS(854),
    [anon_sym_u03bb] = ACTIONS(856),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(858),
    [anon_sym_u2026] = ACTIONS(858),
    [anon_sym_record] = ACTIONS(860),
    [anon_sym_LPAREN] = ACTIONS(862),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(864),
    [anon_sym_u2983] = ACTIONS(866),
    [anon_sym_u2984] = ACTIONS(1044),
    [anon_sym__] = ACTIONS(858),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(870),
    [aux_sym__qid_token1] = ACTIONS(872),
    [anon_sym_DOT] = ACTIONS(874),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(712),
    [anon_sym_quoteGoal] = ACTIONS(878),
    [anon_sym_tactic] = ACTIONS(880),
    [anon_sym_Prop] = ACTIONS(858),
    [anon_sym_quote] = ACTIONS(858),
    [anon_sym_quoteTerm] = ACTIONS(858),
    [anon_sym_quoteContext] = ACTIONS(858),
    [anon_sym_unquote] = ACTIONS(858),
    [anon_sym_LPAREN_PIPE] = ACTIONS(882),
    [anon_sym_u2987] = ACTIONS(884),
    [anon_sym_let] = ACTIONS(886),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(890),
    [aux_sym_string_token1] = ACTIONS(890),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(892),
    [sym_PropN] = ACTIONS(858),
  },
  [436] = {
    [sym__FORALL] = STATE(8355),
    [sym__LAMBDA] = STATE(8054),
    [sym__ELLIPSIS] = STATE(4742),
    [sym__qid] = STATE(4742),
    [sym__binding_ids_and_absurds] = STATE(12547),
    [sym_attribute] = STATE(5830),
    [sym_attributes] = STATE(3506),
    [sym_expr] = STATE(11269),
    [sym__with_exprs] = STATE(10050),
    [sym__expr_or_attr] = STATE(4742),
    [sym__application] = STATE(9444),
    [sym__expr2_without_let] = STATE(9444),
    [sym__expr2] = STATE(9444),
    [sym_atom] = STATE(4712),
    [aux_sym__atoms] = STATE(3276),
    [sym__atom_curly] = STATE(4733),
    [sym__atom_no_curly] = STATE(4733),
    [sym_forall] = STATE(9444),
    [sym_let] = STATE(9444),
    [sym_lambda] = STATE(9444),
    [sym_lambda_extended_or_absurd] = STATE(9444),
    [sym_do] = STATE(9444),
    [sym_record_assignments] = STATE(4742),
    [sym_field_assignments] = STATE(4742),
    [aux_sym__typed_bindings] = STATE(8646),
    [sym_typed_binding] = STATE(8646),
    [sym_literal] = STATE(4742),
    [sym_SetN] = STATE(4742),
    [aux_sym__modal_arg_ids_repeat1] = STATE(5830),
    [aux_sym__with_exprs_repeat1] = STATE(3745),
    [sym_id] = ACTIONS(940),
    [anon_sym_forall] = ACTIONS(942),
    [anon_sym_u2200] = ACTIONS(942),
    [anon_sym_BSLASH] = ACTIONS(944),
    [anon_sym_u03bb] = ACTIONS(946),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(948),
    [anon_sym_u2026] = ACTIONS(948),
    [anon_sym_record] = ACTIONS(950),
    [anon_sym_LPAREN] = ACTIONS(952),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(954),
    [anon_sym_RBRACE_RBRACE] = ACTIONS(1058),
    [anon_sym_u2983] = ACTIONS(956),
    [anon_sym__] = ACTIONS(948),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(958),
    [aux_sym__qid_token1] = ACTIONS(960),
    [anon_sym_DOT] = ACTIONS(962),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(712),
    [anon_sym_quoteGoal] = ACTIONS(964),
    [anon_sym_tactic] = ACTIONS(966),
    [anon_sym_Prop] = ACTIONS(948),
    [anon_sym_quote] = ACTIONS(948),
    [anon_sym_quoteTerm] = ACTIONS(948),
    [anon_sym_quoteContext] = ACTIONS(948),
    [anon_sym_unquote] = ACTIONS(948),
    [anon_sym_LPAREN_PIPE] = ACTIONS(968),
    [anon_sym_u2987] = ACTIONS(970),
    [anon_sym_let] = ACTIONS(972),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(974),
    [aux_sym_string_token1] = ACTIONS(974),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(976),
    [sym_PropN] = ACTIONS(948),
  },
  [437] = {
    [sym__FORALL] = STATE(8355),
    [sym__LAMBDA] = STATE(8054),
    [sym__ELLIPSIS] = STATE(4742),
    [sym__qid] = STATE(4742),
    [sym__binding_ids_and_absurds] = STATE(12547),
    [sym_attribute] = STATE(5830),
    [sym_attributes] = STATE(3506),
    [sym_expr] = STATE(11971),
    [sym__with_exprs] = STATE(10050),
    [sym__expr_or_attr] = STATE(4742),
    [sym__application] = STATE(9444),
    [sym__expr2_without_let] = STATE(9444),
    [sym__expr2] = STATE(9444),
    [sym_atom] = STATE(4712),
    [aux_sym__atoms] = STATE(3276),
    [sym__atom_curly] = STATE(4733),
    [sym__atom_no_curly] = STATE(4733),
    [sym_forall] = STATE(9444),
    [sym_let] = STATE(9444),
    [sym_lambda] = STATE(9444),
    [sym_lambda_extended_or_absurd] = STATE(9444),
    [sym_do] = STATE(9444),
    [sym_record_assignments] = STATE(4742),
    [sym_field_assignments] = STATE(4742),
    [aux_sym__typed_bindings] = STATE(8646),
    [sym_typed_binding] = STATE(8646),
    [sym_literal] = STATE(4742),
    [sym_SetN] = STATE(4742),
    [aux_sym__modal_arg_ids_repeat1] = STATE(5830),
    [aux_sym__with_exprs_repeat1] = STATE(3745),
    [sym_id] = ACTIONS(940),
    [anon_sym_forall] = ACTIONS(942),
    [anon_sym_u2200] = ACTIONS(942),
    [anon_sym_BSLASH] = ACTIONS(944),
    [anon_sym_u03bb] = ACTIONS(946),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(948),
    [anon_sym_u2026] = ACTIONS(948),
    [anon_sym_record] = ACTIONS(950),
    [anon_sym_LPAREN] = ACTIONS(952),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(954),
    [anon_sym_RBRACE_RBRACE] = ACTIONS(1044),
    [anon_sym_u2983] = ACTIONS(956),
    [anon_sym__] = ACTIONS(948),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(958),
    [aux_sym__qid_token1] = ACTIONS(960),
    [anon_sym_DOT] = ACTIONS(962),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(712),
    [anon_sym_quoteGoal] = ACTIONS(964),
    [anon_sym_tactic] = ACTIONS(966),
    [anon_sym_Prop] = ACTIONS(948),
    [anon_sym_quote] = ACTIONS(948),
    [anon_sym_quoteTerm] = ACTIONS(948),
    [anon_sym_quoteContext] = ACTIONS(948),
    [anon_sym_unquote] = ACTIONS(948),
    [anon_sym_LPAREN_PIPE] = ACTIONS(968),
    [anon_sym_u2987] = ACTIONS(970),
    [anon_sym_let] = ACTIONS(972),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(974),
    [aux_sym_string_token1] = ACTIONS(974),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(976),
    [sym_PropN] = ACTIONS(948),
  },
  [438] = {
    [sym__FORALL] = STATE(8355),
    [sym__LAMBDA] = STATE(8054),
    [sym__ELLIPSIS] = STATE(4742),
    [sym__qid] = STATE(4742),
    [sym__binding_ids_and_absurds] = STATE(12547),
    [sym_attribute] = STATE(5830),
    [sym_attributes] = STATE(3506),
    [sym_expr] = STATE(11108),
    [sym__with_exprs] = STATE(10050),
    [sym__expr_or_attr] = STATE(4742),
    [sym__application] = STATE(9444),
    [sym__expr2_without_let] = STATE(9444),
    [sym__expr2] = STATE(9444),
    [sym_atom] = STATE(4712),
    [aux_sym__atoms] = STATE(3276),
    [sym__atom_curly] = STATE(4733),
    [sym__atom_no_curly] = STATE(4733),
    [sym_forall] = STATE(9444),
    [sym_let] = STATE(9444),
    [sym_lambda] = STATE(9444),
    [sym_lambda_extended_or_absurd] = STATE(9444),
    [sym_do] = STATE(9444),
    [sym_record_assignments] = STATE(4742),
    [sym_field_assignments] = STATE(4742),
    [aux_sym__typed_bindings] = STATE(8646),
    [sym_typed_binding] = STATE(8646),
    [sym_literal] = STATE(4742),
    [sym_SetN] = STATE(4742),
    [aux_sym__modal_arg_ids_repeat1] = STATE(5830),
    [aux_sym__with_exprs_repeat1] = STATE(3745),
    [sym_id] = ACTIONS(940),
    [anon_sym_forall] = ACTIONS(942),
    [anon_sym_u2200] = ACTIONS(942),
    [anon_sym_BSLASH] = ACTIONS(944),
    [anon_sym_u03bb] = ACTIONS(946),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(948),
    [anon_sym_u2026] = ACTIONS(948),
    [anon_sym_record] = ACTIONS(950),
    [anon_sym_LPAREN] = ACTIONS(952),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(954),
    [anon_sym_RBRACE_RBRACE] = ACTIONS(1064),
    [anon_sym_u2983] = ACTIONS(956),
    [anon_sym__] = ACTIONS(948),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(958),
    [aux_sym__qid_token1] = ACTIONS(960),
    [anon_sym_DOT] = ACTIONS(962),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(712),
    [anon_sym_quoteGoal] = ACTIONS(964),
    [anon_sym_tactic] = ACTIONS(966),
    [anon_sym_Prop] = ACTIONS(948),
    [anon_sym_quote] = ACTIONS(948),
    [anon_sym_quoteTerm] = ACTIONS(948),
    [anon_sym_quoteContext] = ACTIONS(948),
    [anon_sym_unquote] = ACTIONS(948),
    [anon_sym_LPAREN_PIPE] = ACTIONS(968),
    [anon_sym_u2987] = ACTIONS(970),
    [anon_sym_let] = ACTIONS(972),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(974),
    [aux_sym_string_token1] = ACTIONS(974),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(976),
    [sym_PropN] = ACTIONS(948),
  },
  [439] = {
    [sym__FORALL] = STATE(8369),
    [sym__LAMBDA] = STATE(8152),
    [sym__ELLIPSIS] = STATE(5168),
    [sym__qid] = STATE(5168),
    [sym__binding_ids_and_absurds] = STATE(12544),
    [sym_attribute] = STATE(5830),
    [sym_attributes] = STATE(3505),
    [sym_expr] = STATE(11107),
    [sym__with_exprs] = STATE(9861),
    [sym__expr_or_attr] = STATE(5168),
    [sym__application] = STATE(9444),
    [sym__expr2_without_let] = STATE(9444),
    [sym__expr2] = STATE(9444),
    [sym_atom] = STATE(5204),
    [aux_sym__atoms] = STATE(3133),
    [sym__atom_curly] = STATE(5180),
    [sym__atom_no_curly] = STATE(5180),
    [sym_forall] = STATE(9444),
    [sym_let] = STATE(9444),
    [sym_lambda] = STATE(9444),
    [sym_lambda_extended_or_absurd] = STATE(9444),
    [sym_do] = STATE(9444),
    [sym_record_assignments] = STATE(5168),
    [sym_field_assignments] = STATE(5168),
    [aux_sym__typed_bindings] = STATE(8654),
    [sym_typed_binding] = STATE(8654),
    [sym_literal] = STATE(5168),
    [sym_SetN] = STATE(5168),
    [aux_sym__modal_arg_ids_repeat1] = STATE(5830),
    [aux_sym__with_exprs_repeat1] = STATE(3754),
    [sym_id] = ACTIONS(850),
    [anon_sym_forall] = ACTIONS(852),
    [anon_sym_u2200] = ACTIONS(852),
    [anon_sym_BSLASH] = ACTIONS(854),
    [anon_sym_u03bb] = ACTIONS(856),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(858),
    [anon_sym_u2026] = ACTIONS(858),
    [anon_sym_record] = ACTIONS(860),
    [anon_sym_LPAREN] = ACTIONS(862),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(864),
    [anon_sym_u2983] = ACTIONS(866),
    [anon_sym_u2984] = ACTIONS(1064),
    [anon_sym__] = ACTIONS(858),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(870),
    [aux_sym__qid_token1] = ACTIONS(872),
    [anon_sym_DOT] = ACTIONS(874),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(712),
    [anon_sym_quoteGoal] = ACTIONS(878),
    [anon_sym_tactic] = ACTIONS(880),
    [anon_sym_Prop] = ACTIONS(858),
    [anon_sym_quote] = ACTIONS(858),
    [anon_sym_quoteTerm] = ACTIONS(858),
    [anon_sym_quoteContext] = ACTIONS(858),
    [anon_sym_unquote] = ACTIONS(858),
    [anon_sym_LPAREN_PIPE] = ACTIONS(882),
    [anon_sym_u2987] = ACTIONS(884),
    [anon_sym_let] = ACTIONS(886),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(890),
    [aux_sym_string_token1] = ACTIONS(890),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(892),
    [sym_PropN] = ACTIONS(858),
  },
  [440] = {
    [sym__FORALL] = STATE(8355),
    [sym__LAMBDA] = STATE(8054),
    [sym__ELLIPSIS] = STATE(4742),
    [sym__qid] = STATE(4742),
    [sym__binding_ids_and_absurds] = STATE(12359),
    [sym_attribute] = STATE(7725),
    [sym_attributes] = STATE(6302),
    [sym_expr] = STATE(12120),
    [sym__with_exprs] = STATE(10050),
    [sym__expr_or_attr] = STATE(4742),
    [sym__application] = STATE(9444),
    [sym__expr2_without_let] = STATE(9444),
    [sym__expr2] = STATE(9444),
    [sym_atom] = STATE(4712),
    [aux_sym__atoms] = STATE(3276),
    [sym__atom_curly] = STATE(4733),
    [sym__atom_no_curly] = STATE(4733),
    [sym_forall] = STATE(9444),
    [sym_let] = STATE(9444),
    [sym_lambda] = STATE(9444),
    [sym_lambda_extended_or_absurd] = STATE(9444),
    [sym_do] = STATE(9444),
    [sym_record_assignments] = STATE(4742),
    [sym_field_assignments] = STATE(4742),
    [aux_sym__typed_bindings] = STATE(8646),
    [sym_typed_binding] = STATE(8646),
    [sym_literal] = STATE(4742),
    [sym_SetN] = STATE(4742),
    [aux_sym__modal_arg_ids_repeat1] = STATE(7725),
    [aux_sym__with_exprs_repeat1] = STATE(3745),
    [sym_id] = ACTIONS(940),
    [anon_sym_forall] = ACTIONS(942),
    [anon_sym_u2200] = ACTIONS(942),
    [anon_sym_BSLASH] = ACTIONS(944),
    [anon_sym_u03bb] = ACTIONS(946),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(948),
    [anon_sym_u2026] = ACTIONS(948),
    [anon_sym_record] = ACTIONS(950),
    [anon_sym_LPAREN] = ACTIONS(952),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(954),
    [anon_sym_RBRACE_RBRACE] = ACTIONS(1052),
    [anon_sym_u2983] = ACTIONS(956),
    [anon_sym__] = ACTIONS(948),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(958),
    [aux_sym__qid_token1] = ACTIONS(960),
    [anon_sym_DOT] = ACTIONS(962),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(760),
    [anon_sym_quoteGoal] = ACTIONS(964),
    [anon_sym_tactic] = ACTIONS(966),
    [anon_sym_Prop] = ACTIONS(948),
    [anon_sym_quote] = ACTIONS(948),
    [anon_sym_quoteTerm] = ACTIONS(948),
    [anon_sym_quoteContext] = ACTIONS(948),
    [anon_sym_unquote] = ACTIONS(948),
    [anon_sym_LPAREN_PIPE] = ACTIONS(968),
    [anon_sym_u2987] = ACTIONS(970),
    [anon_sym_let] = ACTIONS(972),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(974),
    [aux_sym_string_token1] = ACTIONS(974),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(976),
    [sym_PropN] = ACTIONS(948),
  },
  [441] = {
    [sym__FORALL] = STATE(8369),
    [sym__LAMBDA] = STATE(8152),
    [sym__ELLIPSIS] = STATE(5168),
    [sym__qid] = STATE(5168),
    [sym__binding_ids_and_absurds] = STATE(12358),
    [sym_attribute] = STATE(7725),
    [sym_attributes] = STATE(6182),
    [sym_expr] = STATE(12119),
    [sym__with_exprs] = STATE(9861),
    [sym__expr_or_attr] = STATE(5168),
    [sym__application] = STATE(9444),
    [sym__expr2_without_let] = STATE(9444),
    [sym__expr2] = STATE(9444),
    [sym_atom] = STATE(5204),
    [aux_sym__atoms] = STATE(3133),
    [sym__atom_curly] = STATE(5180),
    [sym__atom_no_curly] = STATE(5180),
    [sym_forall] = STATE(9444),
    [sym_let] = STATE(9444),
    [sym_lambda] = STATE(9444),
    [sym_lambda_extended_or_absurd] = STATE(9444),
    [sym_do] = STATE(9444),
    [sym_record_assignments] = STATE(5168),
    [sym_field_assignments] = STATE(5168),
    [aux_sym__typed_bindings] = STATE(8654),
    [sym_typed_binding] = STATE(8654),
    [sym_literal] = STATE(5168),
    [sym_SetN] = STATE(5168),
    [aux_sym__modal_arg_ids_repeat1] = STATE(7725),
    [aux_sym__with_exprs_repeat1] = STATE(3754),
    [sym_id] = ACTIONS(850),
    [anon_sym_forall] = ACTIONS(852),
    [anon_sym_u2200] = ACTIONS(852),
    [anon_sym_BSLASH] = ACTIONS(854),
    [anon_sym_u03bb] = ACTIONS(856),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(858),
    [anon_sym_u2026] = ACTIONS(858),
    [anon_sym_record] = ACTIONS(860),
    [anon_sym_LPAREN] = ACTIONS(862),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(864),
    [anon_sym_u2983] = ACTIONS(866),
    [anon_sym_u2984] = ACTIONS(1052),
    [anon_sym__] = ACTIONS(858),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(870),
    [aux_sym__qid_token1] = ACTIONS(872),
    [anon_sym_DOT] = ACTIONS(874),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(760),
    [anon_sym_quoteGoal] = ACTIONS(878),
    [anon_sym_tactic] = ACTIONS(880),
    [anon_sym_Prop] = ACTIONS(858),
    [anon_sym_quote] = ACTIONS(858),
    [anon_sym_quoteTerm] = ACTIONS(858),
    [anon_sym_quoteContext] = ACTIONS(858),
    [anon_sym_unquote] = ACTIONS(858),
    [anon_sym_LPAREN_PIPE] = ACTIONS(882),
    [anon_sym_u2987] = ACTIONS(884),
    [anon_sym_let] = ACTIONS(886),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(890),
    [aux_sym_string_token1] = ACTIONS(890),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(892),
    [sym_PropN] = ACTIONS(858),
  },
  [442] = {
    [sym__FORALL] = STATE(8396),
    [sym__LAMBDA] = STATE(8031),
    [sym__ELLIPSIS] = STATE(4920),
    [sym__qid] = STATE(4920),
    [sym__binding_ids_and_absurds] = STATE(12539),
    [sym_attribute] = STATE(5830),
    [sym_attributes] = STATE(3504),
    [sym_expr] = STATE(11144),
    [sym__with_exprs] = STATE(10196),
    [sym__expr_or_attr] = STATE(4920),
    [sym__application] = STATE(9678),
    [sym__expr2_without_let] = STATE(9678),
    [sym__expr2] = STATE(9678),
    [sym_atom] = STATE(5202),
    [aux_sym__atoms] = STATE(3165),
    [sym__atom_curly] = STATE(4961),
    [sym__atom_no_curly] = STATE(4961),
    [sym_forall] = STATE(9678),
    [sym_let] = STATE(9678),
    [sym_lambda] = STATE(9678),
    [sym_lambda_extended_or_absurd] = STATE(9678),
    [sym_do] = STATE(9678),
    [sym_record_assignments] = STATE(4920),
    [sym_field_assignments] = STATE(4920),
    [aux_sym__typed_bindings] = STATE(8648),
    [sym_typed_binding] = STATE(8648),
    [sym_literal] = STATE(4920),
    [sym_SetN] = STATE(4920),
    [aux_sym__modal_arg_ids_repeat1] = STATE(5830),
    [aux_sym__with_exprs_repeat1] = STATE(3726),
    [sym_id] = ACTIONS(894),
    [anon_sym_forall] = ACTIONS(896),
    [anon_sym_u2200] = ACTIONS(896),
    [anon_sym_BSLASH] = ACTIONS(898),
    [anon_sym_u03bb] = ACTIONS(900),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(902),
    [anon_sym_u2026] = ACTIONS(902),
    [anon_sym_record] = ACTIONS(904),
    [anon_sym_LPAREN] = ACTIONS(906),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(908),
    [anon_sym_u2983] = ACTIONS(910),
    [anon_sym__] = ACTIONS(902),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(912),
    [anon_sym_RBRACE] = ACTIONS(1066),
    [aux_sym__qid_token1] = ACTIONS(916),
    [anon_sym_DOT] = ACTIONS(918),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(712),
    [anon_sym_quoteGoal] = ACTIONS(920),
    [anon_sym_tactic] = ACTIONS(922),
    [anon_sym_Prop] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(902),
    [anon_sym_quoteTerm] = ACTIONS(902),
    [anon_sym_quoteContext] = ACTIONS(902),
    [anon_sym_unquote] = ACTIONS(902),
    [anon_sym_LPAREN_PIPE] = ACTIONS(924),
    [anon_sym_u2987] = ACTIONS(926),
    [anon_sym_let] = ACTIONS(928),
    [anon_sym_do] = ACTIONS(724),
    [aux_sym_integer_token1] = ACTIONS(930),
    [aux_sym_string_token1] = ACTIONS(930),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(932),
    [sym_PropN] = ACTIONS(902),
  },
  [443] = {
    [sym__FORALL] = STATE(8396),
    [sym__LAMBDA] = STATE(8031),
    [sym__ELLIPSIS] = STATE(4920),
    [sym__qid] = STATE(4920),
    [sym__binding_ids_and_absurds] = STATE(12357),
    [sym_attribute] = STATE(7725),
    [sym_attributes] = STATE(6200),
    [sym_expr] = STATE(12118),
    [sym__with_exprs] = STATE(10196),
    [sym__expr_or_attr] = STATE(4920),
    [sym__application] = STATE(9678),
    [sym__expr2_without_let] = STATE(9678),
    [sym__expr2] = STATE(9678),
    [sym_atom] = STATE(5202),
    [aux_sym__atoms] = STATE(3165),
    [sym__atom_curly] = STATE(4961),
    [sym__atom_no_curly] = STATE(4961),
    [sym_forall] = STATE(9678),
    [sym_let] = STATE(9678),
    [sym_lambda] = STATE(9678),
    [sym_lambda_extended_or_absurd] = STATE(9678),
    [sym_do] = STATE(9678),
    [sym_record_assignments] = STATE(4920),
    [sym_field_assignments] = STATE(4920),
    [aux_sym__typed_bindings] = STATE(8648),
    [sym_typed_binding] = STATE(8648),
    [sym_literal] = STATE(4920),
    [sym_SetN] = STATE(4920),
    [aux_sym__modal_arg_ids_repeat1] = STATE(7725),
    [aux_sym__with_exprs_repeat1] = STATE(3726),
    [sym_id] = ACTIONS(894),
    [anon_sym_forall] = ACTIONS(896),
    [anon_sym_u2200] = ACTIONS(896),
    [anon_sym_BSLASH] = ACTIONS(898),
    [anon_sym_u03bb] = ACTIONS(900),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(902),
    [anon_sym_u2026] = ACTIONS(902),
    [anon_sym_record] = ACTIONS(904),
    [anon_sym_LPAREN] = ACTIONS(906),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(908),
    [anon_sym_u2983] = ACTIONS(910),
    [anon_sym__] = ACTIONS(902),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(912),
    [anon_sym_RBRACE] = ACTIONS(1056),
    [aux_sym__qid_token1] = ACTIONS(916),
    [anon_sym_DOT] = ACTIONS(918),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(760),
    [anon_sym_quoteGoal] = ACTIONS(920),
    [anon_sym_tactic] = ACTIONS(922),
    [anon_sym_Prop] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(902),
    [anon_sym_quoteTerm] = ACTIONS(902),
    [anon_sym_quoteContext] = ACTIONS(902),
    [anon_sym_unquote] = ACTIONS(902),
    [anon_sym_LPAREN_PIPE] = ACTIONS(924),
    [anon_sym_u2987] = ACTIONS(926),
    [anon_sym_let] = ACTIONS(928),
    [anon_sym_do] = ACTIONS(724),
    [aux_sym_integer_token1] = ACTIONS(930),
    [aux_sym_string_token1] = ACTIONS(930),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(932),
    [sym_PropN] = ACTIONS(902),
  },
  [444] = {
    [sym__FORALL] = STATE(8345),
    [sym__LAMBDA] = STATE(8095),
    [sym__ELLIPSIS] = STATE(4742),
    [sym_open] = STATE(12555),
    [sym__qid] = STATE(4742),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3873),
    [sym_expr] = STATE(12140),
    [sym__with_exprs] = STATE(10084),
    [sym__expr_or_attr] = STATE(4742),
    [sym__application] = STATE(9680),
    [sym__expr2_without_let] = STATE(9680),
    [sym__expr2] = STATE(9680),
    [sym_atom] = STATE(4712),
    [aux_sym__atoms] = STATE(3211),
    [sym__atom_curly] = STATE(4733),
    [sym__atom_no_curly] = STATE(4733),
    [sym_forall] = STATE(9680),
    [sym_let] = STATE(9680),
    [sym_lambda] = STATE(9680),
    [sym_lambda_extended_or_absurd] = STATE(9680),
    [sym_do] = STATE(9680),
    [sym_record_assignments] = STATE(4742),
    [sym_field_assignments] = STATE(4742),
    [aux_sym__typed_bindings] = STATE(8642),
    [sym_typed_binding] = STATE(8642),
    [sym_literal] = STATE(4742),
    [sym_SetN] = STATE(4742),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3728),
    [sym_id] = ACTIONS(940),
    [anon_sym_forall] = ACTIONS(980),
    [anon_sym_u2200] = ACTIONS(980),
    [anon_sym_BSLASH] = ACTIONS(982),
    [anon_sym_u03bb] = ACTIONS(984),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(948),
    [anon_sym_u2026] = ACTIONS(948),
    [anon_sym_record] = ACTIONS(950),
    [anon_sym_open] = ACTIONS(986),
    [anon_sym_LPAREN] = ACTIONS(952),
    [anon_sym_RPAREN] = ACTIONS(1044),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(954),
    [anon_sym_u2983] = ACTIONS(956),
    [anon_sym__] = ACTIONS(948),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(958),
    [aux_sym__qid_token1] = ACTIONS(960),
    [anon_sym_DOT] = ACTIONS(962),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(988),
    [anon_sym_tactic] = ACTIONS(990),
    [anon_sym_Prop] = ACTIONS(948),
    [anon_sym_quote] = ACTIONS(948),
    [anon_sym_quoteTerm] = ACTIONS(948),
    [anon_sym_quoteContext] = ACTIONS(948),
    [anon_sym_unquote] = ACTIONS(948),
    [anon_sym_LPAREN_PIPE] = ACTIONS(968),
    [anon_sym_u2987] = ACTIONS(970),
    [anon_sym_let] = ACTIONS(992),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(974),
    [aux_sym_string_token1] = ACTIONS(974),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(976),
    [sym_PropN] = ACTIONS(948),
  },
  [445] = {
    [sym__FORALL] = STATE(8345),
    [sym__LAMBDA] = STATE(8095),
    [sym__ELLIPSIS] = STATE(4742),
    [sym_open] = STATE(12555),
    [sym__qid] = STATE(4742),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3873),
    [sym_expr] = STATE(11170),
    [sym__with_exprs] = STATE(10084),
    [sym__expr_or_attr] = STATE(4742),
    [sym__application] = STATE(9680),
    [sym__expr2_without_let] = STATE(9680),
    [sym__expr2] = STATE(9680),
    [sym_atom] = STATE(4712),
    [aux_sym__atoms] = STATE(3211),
    [sym__atom_curly] = STATE(4733),
    [sym__atom_no_curly] = STATE(4733),
    [sym_forall] = STATE(9680),
    [sym_let] = STATE(9680),
    [sym_lambda] = STATE(9680),
    [sym_lambda_extended_or_absurd] = STATE(9680),
    [sym_do] = STATE(9680),
    [sym_record_assignments] = STATE(4742),
    [sym_field_assignments] = STATE(4742),
    [aux_sym__typed_bindings] = STATE(8642),
    [sym_typed_binding] = STATE(8642),
    [sym_literal] = STATE(4742),
    [sym_SetN] = STATE(4742),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3728),
    [sym_id] = ACTIONS(940),
    [anon_sym_forall] = ACTIONS(980),
    [anon_sym_u2200] = ACTIONS(980),
    [anon_sym_BSLASH] = ACTIONS(982),
    [anon_sym_u03bb] = ACTIONS(984),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(948),
    [anon_sym_u2026] = ACTIONS(948),
    [anon_sym_record] = ACTIONS(950),
    [anon_sym_open] = ACTIONS(986),
    [anon_sym_LPAREN] = ACTIONS(952),
    [anon_sym_RPAREN] = ACTIONS(1058),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(954),
    [anon_sym_u2983] = ACTIONS(956),
    [anon_sym__] = ACTIONS(948),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(958),
    [aux_sym__qid_token1] = ACTIONS(960),
    [anon_sym_DOT] = ACTIONS(962),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(988),
    [anon_sym_tactic] = ACTIONS(990),
    [anon_sym_Prop] = ACTIONS(948),
    [anon_sym_quote] = ACTIONS(948),
    [anon_sym_quoteTerm] = ACTIONS(948),
    [anon_sym_quoteContext] = ACTIONS(948),
    [anon_sym_unquote] = ACTIONS(948),
    [anon_sym_LPAREN_PIPE] = ACTIONS(968),
    [anon_sym_u2987] = ACTIONS(970),
    [anon_sym_let] = ACTIONS(992),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(974),
    [aux_sym_string_token1] = ACTIONS(974),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(976),
    [sym_PropN] = ACTIONS(948),
  },
  [446] = {
    [sym__FORALL] = STATE(8355),
    [sym__LAMBDA] = STATE(8054),
    [sym__ELLIPSIS] = STATE(4742),
    [sym__qid] = STATE(4742),
    [sym__binding_ids_and_absurds] = STATE(12359),
    [sym_attribute] = STATE(7725),
    [sym_attributes] = STATE(6302),
    [sym_expr] = STATE(12356),
    [sym__with_exprs] = STATE(10050),
    [sym__expr_or_attr] = STATE(4742),
    [sym__application] = STATE(9444),
    [sym__expr2_without_let] = STATE(9444),
    [sym__expr2] = STATE(9444),
    [sym_atom] = STATE(4712),
    [aux_sym__atoms] = STATE(3276),
    [sym__atom_curly] = STATE(4733),
    [sym__atom_no_curly] = STATE(4733),
    [sym_forall] = STATE(9444),
    [sym_let] = STATE(9444),
    [sym_lambda] = STATE(9444),
    [sym_lambda_extended_or_absurd] = STATE(9444),
    [sym_do] = STATE(9444),
    [sym_record_assignments] = STATE(4742),
    [sym_field_assignments] = STATE(4742),
    [aux_sym__typed_bindings] = STATE(8646),
    [sym_typed_binding] = STATE(8646),
    [sym_literal] = STATE(4742),
    [sym_SetN] = STATE(4742),
    [aux_sym__modal_arg_ids_repeat1] = STATE(7725),
    [aux_sym__with_exprs_repeat1] = STATE(3745),
    [sym_id] = ACTIONS(940),
    [anon_sym_forall] = ACTIONS(942),
    [anon_sym_u2200] = ACTIONS(942),
    [anon_sym_BSLASH] = ACTIONS(944),
    [anon_sym_u03bb] = ACTIONS(946),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(948),
    [anon_sym_u2026] = ACTIONS(948),
    [anon_sym_record] = ACTIONS(950),
    [anon_sym_LPAREN] = ACTIONS(952),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(954),
    [anon_sym_RBRACE_RBRACE] = ACTIONS(1010),
    [anon_sym_u2983] = ACTIONS(956),
    [anon_sym__] = ACTIONS(948),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(958),
    [aux_sym__qid_token1] = ACTIONS(960),
    [anon_sym_DOT] = ACTIONS(962),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(760),
    [anon_sym_quoteGoal] = ACTIONS(964),
    [anon_sym_tactic] = ACTIONS(966),
    [anon_sym_Prop] = ACTIONS(948),
    [anon_sym_quote] = ACTIONS(948),
    [anon_sym_quoteTerm] = ACTIONS(948),
    [anon_sym_quoteContext] = ACTIONS(948),
    [anon_sym_unquote] = ACTIONS(948),
    [anon_sym_LPAREN_PIPE] = ACTIONS(968),
    [anon_sym_u2987] = ACTIONS(970),
    [anon_sym_let] = ACTIONS(972),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(974),
    [aux_sym_string_token1] = ACTIONS(974),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(976),
    [sym_PropN] = ACTIONS(948),
  },
  [447] = {
    [sym__FORALL] = STATE(8355),
    [sym__LAMBDA] = STATE(8054),
    [sym__ELLIPSIS] = STATE(4742),
    [sym__qid] = STATE(4742),
    [sym__binding_ids_and_absurds] = STATE(12359),
    [sym_attribute] = STATE(7725),
    [sym_attributes] = STATE(6302),
    [sym_expr] = STATE(12674),
    [sym__with_exprs] = STATE(10050),
    [sym__expr_or_attr] = STATE(4742),
    [sym__application] = STATE(9444),
    [sym__expr2_without_let] = STATE(9444),
    [sym__expr2] = STATE(9444),
    [sym_atom] = STATE(4712),
    [aux_sym__atoms] = STATE(3276),
    [sym__atom_curly] = STATE(4733),
    [sym__atom_no_curly] = STATE(4733),
    [sym_forall] = STATE(9444),
    [sym_let] = STATE(9444),
    [sym_lambda] = STATE(9444),
    [sym_lambda_extended_or_absurd] = STATE(9444),
    [sym_do] = STATE(9444),
    [sym_record_assignments] = STATE(4742),
    [sym_field_assignments] = STATE(4742),
    [aux_sym__typed_bindings] = STATE(8646),
    [sym_typed_binding] = STATE(8646),
    [sym_literal] = STATE(4742),
    [sym_SetN] = STATE(4742),
    [aux_sym__modal_arg_ids_repeat1] = STATE(7725),
    [aux_sym__with_exprs_repeat1] = STATE(3745),
    [sym_id] = ACTIONS(940),
    [anon_sym_forall] = ACTIONS(942),
    [anon_sym_u2200] = ACTIONS(942),
    [anon_sym_BSLASH] = ACTIONS(944),
    [anon_sym_u03bb] = ACTIONS(946),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(948),
    [anon_sym_u2026] = ACTIONS(948),
    [anon_sym_record] = ACTIONS(950),
    [anon_sym_LPAREN] = ACTIONS(952),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(954),
    [anon_sym_RBRACE_RBRACE] = ACTIONS(1036),
    [anon_sym_u2983] = ACTIONS(956),
    [anon_sym__] = ACTIONS(948),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(958),
    [aux_sym__qid_token1] = ACTIONS(960),
    [anon_sym_DOT] = ACTIONS(962),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(760),
    [anon_sym_quoteGoal] = ACTIONS(964),
    [anon_sym_tactic] = ACTIONS(966),
    [anon_sym_Prop] = ACTIONS(948),
    [anon_sym_quote] = ACTIONS(948),
    [anon_sym_quoteTerm] = ACTIONS(948),
    [anon_sym_quoteContext] = ACTIONS(948),
    [anon_sym_unquote] = ACTIONS(948),
    [anon_sym_LPAREN_PIPE] = ACTIONS(968),
    [anon_sym_u2987] = ACTIONS(970),
    [anon_sym_let] = ACTIONS(972),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(974),
    [aux_sym_string_token1] = ACTIONS(974),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(976),
    [sym_PropN] = ACTIONS(948),
  },
  [448] = {
    [sym__FORALL] = STATE(8369),
    [sym__LAMBDA] = STATE(8152),
    [sym__ELLIPSIS] = STATE(5168),
    [sym__qid] = STATE(5168),
    [sym__binding_ids_and_absurds] = STATE(12358),
    [sym_attribute] = STATE(7725),
    [sym_attributes] = STATE(6182),
    [sym_expr] = STATE(12360),
    [sym__with_exprs] = STATE(9861),
    [sym__expr_or_attr] = STATE(5168),
    [sym__application] = STATE(9444),
    [sym__expr2_without_let] = STATE(9444),
    [sym__expr2] = STATE(9444),
    [sym_atom] = STATE(5204),
    [aux_sym__atoms] = STATE(3133),
    [sym__atom_curly] = STATE(5180),
    [sym__atom_no_curly] = STATE(5180),
    [sym_forall] = STATE(9444),
    [sym_let] = STATE(9444),
    [sym_lambda] = STATE(9444),
    [sym_lambda_extended_or_absurd] = STATE(9444),
    [sym_do] = STATE(9444),
    [sym_record_assignments] = STATE(5168),
    [sym_field_assignments] = STATE(5168),
    [aux_sym__typed_bindings] = STATE(8654),
    [sym_typed_binding] = STATE(8654),
    [sym_literal] = STATE(5168),
    [sym_SetN] = STATE(5168),
    [aux_sym__modal_arg_ids_repeat1] = STATE(7725),
    [aux_sym__with_exprs_repeat1] = STATE(3754),
    [sym_id] = ACTIONS(850),
    [anon_sym_forall] = ACTIONS(852),
    [anon_sym_u2200] = ACTIONS(852),
    [anon_sym_BSLASH] = ACTIONS(854),
    [anon_sym_u03bb] = ACTIONS(856),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(858),
    [anon_sym_u2026] = ACTIONS(858),
    [anon_sym_record] = ACTIONS(860),
    [anon_sym_LPAREN] = ACTIONS(862),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(864),
    [anon_sym_u2983] = ACTIONS(866),
    [anon_sym_u2984] = ACTIONS(1010),
    [anon_sym__] = ACTIONS(858),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(870),
    [aux_sym__qid_token1] = ACTIONS(872),
    [anon_sym_DOT] = ACTIONS(874),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(760),
    [anon_sym_quoteGoal] = ACTIONS(878),
    [anon_sym_tactic] = ACTIONS(880),
    [anon_sym_Prop] = ACTIONS(858),
    [anon_sym_quote] = ACTIONS(858),
    [anon_sym_quoteTerm] = ACTIONS(858),
    [anon_sym_quoteContext] = ACTIONS(858),
    [anon_sym_unquote] = ACTIONS(858),
    [anon_sym_LPAREN_PIPE] = ACTIONS(882),
    [anon_sym_u2987] = ACTIONS(884),
    [anon_sym_let] = ACTIONS(886),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(890),
    [aux_sym_string_token1] = ACTIONS(890),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(892),
    [sym_PropN] = ACTIONS(858),
  },
  [449] = {
    [sym__FORALL] = STATE(8396),
    [sym__LAMBDA] = STATE(8031),
    [sym__ELLIPSIS] = STATE(4920),
    [sym__qid] = STATE(4920),
    [sym__binding_ids_and_absurds] = STATE(12357),
    [sym_attribute] = STATE(7725),
    [sym_attributes] = STATE(6200),
    [sym_expr] = STATE(12362),
    [sym__with_exprs] = STATE(10196),
    [sym__expr_or_attr] = STATE(4920),
    [sym__application] = STATE(9678),
    [sym__expr2_without_let] = STATE(9678),
    [sym__expr2] = STATE(9678),
    [sym_atom] = STATE(5202),
    [aux_sym__atoms] = STATE(3165),
    [sym__atom_curly] = STATE(4961),
    [sym__atom_no_curly] = STATE(4961),
    [sym_forall] = STATE(9678),
    [sym_let] = STATE(9678),
    [sym_lambda] = STATE(9678),
    [sym_lambda_extended_or_absurd] = STATE(9678),
    [sym_do] = STATE(9678),
    [sym_record_assignments] = STATE(4920),
    [sym_field_assignments] = STATE(4920),
    [aux_sym__typed_bindings] = STATE(8648),
    [sym_typed_binding] = STATE(8648),
    [sym_literal] = STATE(4920),
    [sym_SetN] = STATE(4920),
    [aux_sym__modal_arg_ids_repeat1] = STATE(7725),
    [aux_sym__with_exprs_repeat1] = STATE(3726),
    [sym_id] = ACTIONS(894),
    [anon_sym_forall] = ACTIONS(896),
    [anon_sym_u2200] = ACTIONS(896),
    [anon_sym_BSLASH] = ACTIONS(898),
    [anon_sym_u03bb] = ACTIONS(900),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(902),
    [anon_sym_u2026] = ACTIONS(902),
    [anon_sym_record] = ACTIONS(904),
    [anon_sym_LPAREN] = ACTIONS(906),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(908),
    [anon_sym_u2983] = ACTIONS(910),
    [anon_sym__] = ACTIONS(902),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(912),
    [anon_sym_RBRACE] = ACTIONS(1014),
    [aux_sym__qid_token1] = ACTIONS(916),
    [anon_sym_DOT] = ACTIONS(918),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(760),
    [anon_sym_quoteGoal] = ACTIONS(920),
    [anon_sym_tactic] = ACTIONS(922),
    [anon_sym_Prop] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(902),
    [anon_sym_quoteTerm] = ACTIONS(902),
    [anon_sym_quoteContext] = ACTIONS(902),
    [anon_sym_unquote] = ACTIONS(902),
    [anon_sym_LPAREN_PIPE] = ACTIONS(924),
    [anon_sym_u2987] = ACTIONS(926),
    [anon_sym_let] = ACTIONS(928),
    [anon_sym_do] = ACTIONS(724),
    [aux_sym_integer_token1] = ACTIONS(930),
    [aux_sym_string_token1] = ACTIONS(930),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(932),
    [sym_PropN] = ACTIONS(902),
  },
  [450] = {
    [sym__FORALL] = STATE(8396),
    [sym__LAMBDA] = STATE(8031),
    [sym__ELLIPSIS] = STATE(4920),
    [sym__qid] = STATE(4920),
    [sym__binding_ids_and_absurds] = STATE(12539),
    [sym_attribute] = STATE(5830),
    [sym_attributes] = STATE(3504),
    [sym_expr] = STATE(11395),
    [sym__with_exprs] = STATE(10196),
    [sym__expr_or_attr] = STATE(4920),
    [sym__application] = STATE(9678),
    [sym__expr2_without_let] = STATE(9678),
    [sym__expr2] = STATE(9678),
    [sym_atom] = STATE(5202),
    [aux_sym__atoms] = STATE(3165),
    [sym__atom_curly] = STATE(4961),
    [sym__atom_no_curly] = STATE(4961),
    [sym_forall] = STATE(9678),
    [sym_let] = STATE(9678),
    [sym_lambda] = STATE(9678),
    [sym_lambda_extended_or_absurd] = STATE(9678),
    [sym_do] = STATE(9678),
    [sym_record_assignments] = STATE(4920),
    [sym_field_assignments] = STATE(4920),
    [aux_sym__typed_bindings] = STATE(8648),
    [sym_typed_binding] = STATE(8648),
    [sym_literal] = STATE(4920),
    [sym_SetN] = STATE(4920),
    [aux_sym__modal_arg_ids_repeat1] = STATE(5830),
    [aux_sym__with_exprs_repeat1] = STATE(3726),
    [sym_id] = ACTIONS(894),
    [anon_sym_forall] = ACTIONS(896),
    [anon_sym_u2200] = ACTIONS(896),
    [anon_sym_BSLASH] = ACTIONS(898),
    [anon_sym_u03bb] = ACTIONS(900),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(902),
    [anon_sym_u2026] = ACTIONS(902),
    [anon_sym_record] = ACTIONS(904),
    [anon_sym_LPAREN] = ACTIONS(906),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(908),
    [anon_sym_u2983] = ACTIONS(910),
    [anon_sym__] = ACTIONS(902),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(912),
    [anon_sym_RBRACE] = ACTIONS(1060),
    [aux_sym__qid_token1] = ACTIONS(916),
    [anon_sym_DOT] = ACTIONS(918),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(712),
    [anon_sym_quoteGoal] = ACTIONS(920),
    [anon_sym_tactic] = ACTIONS(922),
    [anon_sym_Prop] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(902),
    [anon_sym_quoteTerm] = ACTIONS(902),
    [anon_sym_quoteContext] = ACTIONS(902),
    [anon_sym_unquote] = ACTIONS(902),
    [anon_sym_LPAREN_PIPE] = ACTIONS(924),
    [anon_sym_u2987] = ACTIONS(926),
    [anon_sym_let] = ACTIONS(928),
    [anon_sym_do] = ACTIONS(724),
    [aux_sym_integer_token1] = ACTIONS(930),
    [aux_sym_string_token1] = ACTIONS(930),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(932),
    [sym_PropN] = ACTIONS(902),
  },
  [451] = {
    [sym__FORALL] = STATE(8369),
    [sym__LAMBDA] = STATE(8152),
    [sym__ELLIPSIS] = STATE(5168),
    [sym__qid] = STATE(5168),
    [sym__binding_ids_and_absurds] = STATE(12544),
    [sym_attribute] = STATE(5830),
    [sym_attributes] = STATE(3505),
    [sym_expr] = STATE(11359),
    [sym__with_exprs] = STATE(9861),
    [sym__expr_or_attr] = STATE(5168),
    [sym__application] = STATE(9444),
    [sym__expr2_without_let] = STATE(9444),
    [sym__expr2] = STATE(9444),
    [sym_atom] = STATE(5204),
    [aux_sym__atoms] = STATE(3133),
    [sym__atom_curly] = STATE(5180),
    [sym__atom_no_curly] = STATE(5180),
    [sym_forall] = STATE(9444),
    [sym_let] = STATE(9444),
    [sym_lambda] = STATE(9444),
    [sym_lambda_extended_or_absurd] = STATE(9444),
    [sym_do] = STATE(9444),
    [sym_record_assignments] = STATE(5168),
    [sym_field_assignments] = STATE(5168),
    [aux_sym__typed_bindings] = STATE(8654),
    [sym_typed_binding] = STATE(8654),
    [sym_literal] = STATE(5168),
    [sym_SetN] = STATE(5168),
    [aux_sym__modal_arg_ids_repeat1] = STATE(5830),
    [aux_sym__with_exprs_repeat1] = STATE(3754),
    [sym_id] = ACTIONS(850),
    [anon_sym_forall] = ACTIONS(852),
    [anon_sym_u2200] = ACTIONS(852),
    [anon_sym_BSLASH] = ACTIONS(854),
    [anon_sym_u03bb] = ACTIONS(856),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(858),
    [anon_sym_u2026] = ACTIONS(858),
    [anon_sym_record] = ACTIONS(860),
    [anon_sym_LPAREN] = ACTIONS(862),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(864),
    [anon_sym_u2983] = ACTIONS(866),
    [anon_sym_u2984] = ACTIONS(1062),
    [anon_sym__] = ACTIONS(858),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(870),
    [aux_sym__qid_token1] = ACTIONS(872),
    [anon_sym_DOT] = ACTIONS(874),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(712),
    [anon_sym_quoteGoal] = ACTIONS(878),
    [anon_sym_tactic] = ACTIONS(880),
    [anon_sym_Prop] = ACTIONS(858),
    [anon_sym_quote] = ACTIONS(858),
    [anon_sym_quoteTerm] = ACTIONS(858),
    [anon_sym_quoteContext] = ACTIONS(858),
    [anon_sym_unquote] = ACTIONS(858),
    [anon_sym_LPAREN_PIPE] = ACTIONS(882),
    [anon_sym_u2987] = ACTIONS(884),
    [anon_sym_let] = ACTIONS(886),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(890),
    [aux_sym_string_token1] = ACTIONS(890),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(892),
    [sym_PropN] = ACTIONS(858),
  },
  [452] = {
    [sym__FORALL] = STATE(8355),
    [sym__LAMBDA] = STATE(8054),
    [sym__ELLIPSIS] = STATE(4742),
    [sym__qid] = STATE(4742),
    [sym__binding_ids_and_absurds] = STATE(12547),
    [sym_attribute] = STATE(5830),
    [sym_attributes] = STATE(3506),
    [sym_expr] = STATE(11360),
    [sym__with_exprs] = STATE(10050),
    [sym__expr_or_attr] = STATE(4742),
    [sym__application] = STATE(9444),
    [sym__expr2_without_let] = STATE(9444),
    [sym__expr2] = STATE(9444),
    [sym_atom] = STATE(4712),
    [aux_sym__atoms] = STATE(3276),
    [sym__atom_curly] = STATE(4733),
    [sym__atom_no_curly] = STATE(4733),
    [sym_forall] = STATE(9444),
    [sym_let] = STATE(9444),
    [sym_lambda] = STATE(9444),
    [sym_lambda_extended_or_absurd] = STATE(9444),
    [sym_do] = STATE(9444),
    [sym_record_assignments] = STATE(4742),
    [sym_field_assignments] = STATE(4742),
    [aux_sym__typed_bindings] = STATE(8646),
    [sym_typed_binding] = STATE(8646),
    [sym_literal] = STATE(4742),
    [sym_SetN] = STATE(4742),
    [aux_sym__modal_arg_ids_repeat1] = STATE(5830),
    [aux_sym__with_exprs_repeat1] = STATE(3745),
    [sym_id] = ACTIONS(940),
    [anon_sym_forall] = ACTIONS(942),
    [anon_sym_u2200] = ACTIONS(942),
    [anon_sym_BSLASH] = ACTIONS(944),
    [anon_sym_u03bb] = ACTIONS(946),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(948),
    [anon_sym_u2026] = ACTIONS(948),
    [anon_sym_record] = ACTIONS(950),
    [anon_sym_LPAREN] = ACTIONS(952),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(954),
    [anon_sym_RBRACE_RBRACE] = ACTIONS(1062),
    [anon_sym_u2983] = ACTIONS(956),
    [anon_sym__] = ACTIONS(948),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(958),
    [aux_sym__qid_token1] = ACTIONS(960),
    [anon_sym_DOT] = ACTIONS(962),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(712),
    [anon_sym_quoteGoal] = ACTIONS(964),
    [anon_sym_tactic] = ACTIONS(966),
    [anon_sym_Prop] = ACTIONS(948),
    [anon_sym_quote] = ACTIONS(948),
    [anon_sym_quoteTerm] = ACTIONS(948),
    [anon_sym_quoteContext] = ACTIONS(948),
    [anon_sym_unquote] = ACTIONS(948),
    [anon_sym_LPAREN_PIPE] = ACTIONS(968),
    [anon_sym_u2987] = ACTIONS(970),
    [anon_sym_let] = ACTIONS(972),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(974),
    [aux_sym_string_token1] = ACTIONS(974),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(976),
    [sym_PropN] = ACTIONS(948),
  },
  [453] = {
    [sym__FORALL] = STATE(8345),
    [sym__LAMBDA] = STATE(8095),
    [sym__ELLIPSIS] = STATE(4742),
    [sym_open] = STATE(12555),
    [sym__qid] = STATE(4742),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3873),
    [sym_expr] = STATE(11327),
    [sym__with_exprs] = STATE(10084),
    [sym__expr_or_attr] = STATE(4742),
    [sym__application] = STATE(9680),
    [sym__expr2_without_let] = STATE(9680),
    [sym__expr2] = STATE(9680),
    [sym_atom] = STATE(4712),
    [aux_sym__atoms] = STATE(3211),
    [sym__atom_curly] = STATE(4733),
    [sym__atom_no_curly] = STATE(4733),
    [sym_forall] = STATE(9680),
    [sym_let] = STATE(9680),
    [sym_lambda] = STATE(9680),
    [sym_lambda_extended_or_absurd] = STATE(9680),
    [sym_do] = STATE(9680),
    [sym_record_assignments] = STATE(4742),
    [sym_field_assignments] = STATE(4742),
    [aux_sym__typed_bindings] = STATE(8642),
    [sym_typed_binding] = STATE(8642),
    [sym_literal] = STATE(4742),
    [sym_SetN] = STATE(4742),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3728),
    [sym_id] = ACTIONS(940),
    [anon_sym_forall] = ACTIONS(980),
    [anon_sym_u2200] = ACTIONS(980),
    [anon_sym_BSLASH] = ACTIONS(982),
    [anon_sym_u03bb] = ACTIONS(984),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(948),
    [anon_sym_u2026] = ACTIONS(948),
    [anon_sym_record] = ACTIONS(950),
    [anon_sym_open] = ACTIONS(986),
    [anon_sym_LPAREN] = ACTIONS(952),
    [anon_sym_RPAREN] = ACTIONS(1062),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(954),
    [anon_sym_u2983] = ACTIONS(956),
    [anon_sym__] = ACTIONS(948),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(958),
    [aux_sym__qid_token1] = ACTIONS(960),
    [anon_sym_DOT] = ACTIONS(962),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(988),
    [anon_sym_tactic] = ACTIONS(990),
    [anon_sym_Prop] = ACTIONS(948),
    [anon_sym_quote] = ACTIONS(948),
    [anon_sym_quoteTerm] = ACTIONS(948),
    [anon_sym_quoteContext] = ACTIONS(948),
    [anon_sym_unquote] = ACTIONS(948),
    [anon_sym_LPAREN_PIPE] = ACTIONS(968),
    [anon_sym_u2987] = ACTIONS(970),
    [anon_sym_let] = ACTIONS(992),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(974),
    [aux_sym_string_token1] = ACTIONS(974),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(976),
    [sym_PropN] = ACTIONS(948),
  },
  [454] = {
    [sym__FORALL] = STATE(8345),
    [sym__LAMBDA] = STATE(8095),
    [sym__ELLIPSIS] = STATE(4742),
    [sym_open] = STATE(12555),
    [sym__qid] = STATE(4742),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3873),
    [sym_expr] = STATE(12711),
    [sym__with_exprs] = STATE(10084),
    [sym__expr_or_attr] = STATE(4742),
    [sym__application] = STATE(9680),
    [sym__expr2_without_let] = STATE(9680),
    [sym__expr2] = STATE(9680),
    [sym_atom] = STATE(4712),
    [aux_sym__atoms] = STATE(3211),
    [sym__atom_curly] = STATE(4733),
    [sym__atom_no_curly] = STATE(4733),
    [sym_forall] = STATE(9680),
    [sym_let] = STATE(9680),
    [sym_lambda] = STATE(9680),
    [sym_lambda_extended_or_absurd] = STATE(9680),
    [sym_do] = STATE(9680),
    [sym_record_assignments] = STATE(4742),
    [sym_field_assignments] = STATE(4742),
    [aux_sym__typed_bindings] = STATE(8642),
    [sym_typed_binding] = STATE(8642),
    [sym_literal] = STATE(4742),
    [sym_SetN] = STATE(4742),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3728),
    [sym_id] = ACTIONS(940),
    [anon_sym_forall] = ACTIONS(980),
    [anon_sym_u2200] = ACTIONS(980),
    [anon_sym_BSLASH] = ACTIONS(982),
    [anon_sym_u03bb] = ACTIONS(984),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(948),
    [anon_sym_u2026] = ACTIONS(948),
    [anon_sym_record] = ACTIONS(950),
    [anon_sym_open] = ACTIONS(986),
    [anon_sym_LPAREN] = ACTIONS(952),
    [anon_sym_RPAREN] = ACTIONS(1020),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(954),
    [anon_sym_u2983] = ACTIONS(956),
    [anon_sym__] = ACTIONS(948),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(958),
    [aux_sym__qid_token1] = ACTIONS(960),
    [anon_sym_DOT] = ACTIONS(962),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(988),
    [anon_sym_tactic] = ACTIONS(990),
    [anon_sym_Prop] = ACTIONS(948),
    [anon_sym_quote] = ACTIONS(948),
    [anon_sym_quoteTerm] = ACTIONS(948),
    [anon_sym_quoteContext] = ACTIONS(948),
    [anon_sym_unquote] = ACTIONS(948),
    [anon_sym_LPAREN_PIPE] = ACTIONS(968),
    [anon_sym_u2987] = ACTIONS(970),
    [anon_sym_let] = ACTIONS(992),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(974),
    [aux_sym_string_token1] = ACTIONS(974),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(976),
    [sym_PropN] = ACTIONS(948),
  },
  [455] = {
    [sym__FORALL] = STATE(8396),
    [sym__LAMBDA] = STATE(8031),
    [sym__ELLIPSIS] = STATE(4920),
    [sym__qid] = STATE(4920),
    [sym__binding_ids_and_absurds] = STATE(12357),
    [sym_attribute] = STATE(7725),
    [sym_attributes] = STATE(6200),
    [sym_expr] = STATE(11328),
    [sym__with_exprs] = STATE(10196),
    [sym__expr_or_attr] = STATE(4920),
    [sym__application] = STATE(9678),
    [sym__expr2_without_let] = STATE(9678),
    [sym__expr2] = STATE(9678),
    [sym_atom] = STATE(5202),
    [aux_sym__atoms] = STATE(3165),
    [sym__atom_curly] = STATE(4961),
    [sym__atom_no_curly] = STATE(4961),
    [sym_forall] = STATE(9678),
    [sym_let] = STATE(9678),
    [sym_lambda] = STATE(9678),
    [sym_lambda_extended_or_absurd] = STATE(9678),
    [sym_do] = STATE(9678),
    [sym_record_assignments] = STATE(4920),
    [sym_field_assignments] = STATE(4920),
    [aux_sym__typed_bindings] = STATE(8648),
    [sym_typed_binding] = STATE(8648),
    [sym_literal] = STATE(4920),
    [sym_SetN] = STATE(4920),
    [aux_sym__modal_arg_ids_repeat1] = STATE(7725),
    [aux_sym__with_exprs_repeat1] = STATE(3726),
    [sym_id] = ACTIONS(894),
    [anon_sym_forall] = ACTIONS(896),
    [anon_sym_u2200] = ACTIONS(896),
    [anon_sym_BSLASH] = ACTIONS(898),
    [anon_sym_u03bb] = ACTIONS(900),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(902),
    [anon_sym_u2026] = ACTIONS(902),
    [anon_sym_record] = ACTIONS(904),
    [anon_sym_LPAREN] = ACTIONS(906),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(908),
    [anon_sym_u2983] = ACTIONS(910),
    [anon_sym__] = ACTIONS(902),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(912),
    [anon_sym_RBRACE] = ACTIONS(1068),
    [aux_sym__qid_token1] = ACTIONS(916),
    [anon_sym_DOT] = ACTIONS(918),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(760),
    [anon_sym_quoteGoal] = ACTIONS(920),
    [anon_sym_tactic] = ACTIONS(922),
    [anon_sym_Prop] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(902),
    [anon_sym_quoteTerm] = ACTIONS(902),
    [anon_sym_quoteContext] = ACTIONS(902),
    [anon_sym_unquote] = ACTIONS(902),
    [anon_sym_LPAREN_PIPE] = ACTIONS(924),
    [anon_sym_u2987] = ACTIONS(926),
    [anon_sym_let] = ACTIONS(928),
    [anon_sym_do] = ACTIONS(724),
    [aux_sym_integer_token1] = ACTIONS(930),
    [aux_sym_string_token1] = ACTIONS(930),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(932),
    [sym_PropN] = ACTIONS(902),
  },
  [456] = {
    [sym__FORALL] = STATE(8369),
    [sym__LAMBDA] = STATE(8152),
    [sym__ELLIPSIS] = STATE(5168),
    [sym__qid] = STATE(5168),
    [sym__binding_ids_and_absurds] = STATE(12358),
    [sym_attribute] = STATE(7725),
    [sym_attributes] = STATE(6182),
    [sym_expr] = STATE(11329),
    [sym__with_exprs] = STATE(9861),
    [sym__expr_or_attr] = STATE(5168),
    [sym__application] = STATE(9444),
    [sym__expr2_without_let] = STATE(9444),
    [sym__expr2] = STATE(9444),
    [sym_atom] = STATE(5204),
    [aux_sym__atoms] = STATE(3133),
    [sym__atom_curly] = STATE(5180),
    [sym__atom_no_curly] = STATE(5180),
    [sym_forall] = STATE(9444),
    [sym_let] = STATE(9444),
    [sym_lambda] = STATE(9444),
    [sym_lambda_extended_or_absurd] = STATE(9444),
    [sym_do] = STATE(9444),
    [sym_record_assignments] = STATE(5168),
    [sym_field_assignments] = STATE(5168),
    [aux_sym__typed_bindings] = STATE(8654),
    [sym_typed_binding] = STATE(8654),
    [sym_literal] = STATE(5168),
    [sym_SetN] = STATE(5168),
    [aux_sym__modal_arg_ids_repeat1] = STATE(7725),
    [aux_sym__with_exprs_repeat1] = STATE(3754),
    [sym_id] = ACTIONS(850),
    [anon_sym_forall] = ACTIONS(852),
    [anon_sym_u2200] = ACTIONS(852),
    [anon_sym_BSLASH] = ACTIONS(854),
    [anon_sym_u03bb] = ACTIONS(856),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(858),
    [anon_sym_u2026] = ACTIONS(858),
    [anon_sym_record] = ACTIONS(860),
    [anon_sym_LPAREN] = ACTIONS(862),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(864),
    [anon_sym_u2983] = ACTIONS(866),
    [anon_sym_u2984] = ACTIONS(1070),
    [anon_sym__] = ACTIONS(858),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(870),
    [aux_sym__qid_token1] = ACTIONS(872),
    [anon_sym_DOT] = ACTIONS(874),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(760),
    [anon_sym_quoteGoal] = ACTIONS(878),
    [anon_sym_tactic] = ACTIONS(880),
    [anon_sym_Prop] = ACTIONS(858),
    [anon_sym_quote] = ACTIONS(858),
    [anon_sym_quoteTerm] = ACTIONS(858),
    [anon_sym_quoteContext] = ACTIONS(858),
    [anon_sym_unquote] = ACTIONS(858),
    [anon_sym_LPAREN_PIPE] = ACTIONS(882),
    [anon_sym_u2987] = ACTIONS(884),
    [anon_sym_let] = ACTIONS(886),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(890),
    [aux_sym_string_token1] = ACTIONS(890),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(892),
    [sym_PropN] = ACTIONS(858),
  },
  [457] = {
    [sym__FORALL] = STATE(8355),
    [sym__LAMBDA] = STATE(8054),
    [sym__ELLIPSIS] = STATE(4742),
    [sym__qid] = STATE(4742),
    [sym__binding_ids_and_absurds] = STATE(12359),
    [sym_attribute] = STATE(7725),
    [sym_attributes] = STATE(6302),
    [sym_expr] = STATE(11108),
    [sym__with_exprs] = STATE(10050),
    [sym__expr_or_attr] = STATE(4742),
    [sym__application] = STATE(9444),
    [sym__expr2_without_let] = STATE(9444),
    [sym__expr2] = STATE(9444),
    [sym_atom] = STATE(4712),
    [aux_sym__atoms] = STATE(3276),
    [sym__atom_curly] = STATE(4733),
    [sym__atom_no_curly] = STATE(4733),
    [sym_forall] = STATE(9444),
    [sym_let] = STATE(9444),
    [sym_lambda] = STATE(9444),
    [sym_lambda_extended_or_absurd] = STATE(9444),
    [sym_do] = STATE(9444),
    [sym_record_assignments] = STATE(4742),
    [sym_field_assignments] = STATE(4742),
    [aux_sym__typed_bindings] = STATE(8646),
    [sym_typed_binding] = STATE(8646),
    [sym_literal] = STATE(4742),
    [sym_SetN] = STATE(4742),
    [aux_sym__modal_arg_ids_repeat1] = STATE(7725),
    [aux_sym__with_exprs_repeat1] = STATE(3745),
    [sym_id] = ACTIONS(940),
    [anon_sym_forall] = ACTIONS(942),
    [anon_sym_u2200] = ACTIONS(942),
    [anon_sym_BSLASH] = ACTIONS(944),
    [anon_sym_u03bb] = ACTIONS(946),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(948),
    [anon_sym_u2026] = ACTIONS(948),
    [anon_sym_record] = ACTIONS(950),
    [anon_sym_LPAREN] = ACTIONS(952),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(954),
    [anon_sym_RBRACE_RBRACE] = ACTIONS(1064),
    [anon_sym_u2983] = ACTIONS(956),
    [anon_sym__] = ACTIONS(948),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(958),
    [aux_sym__qid_token1] = ACTIONS(960),
    [anon_sym_DOT] = ACTIONS(962),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(760),
    [anon_sym_quoteGoal] = ACTIONS(964),
    [anon_sym_tactic] = ACTIONS(966),
    [anon_sym_Prop] = ACTIONS(948),
    [anon_sym_quote] = ACTIONS(948),
    [anon_sym_quoteTerm] = ACTIONS(948),
    [anon_sym_quoteContext] = ACTIONS(948),
    [anon_sym_unquote] = ACTIONS(948),
    [anon_sym_LPAREN_PIPE] = ACTIONS(968),
    [anon_sym_u2987] = ACTIONS(970),
    [anon_sym_let] = ACTIONS(972),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(974),
    [aux_sym_string_token1] = ACTIONS(974),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(976),
    [sym_PropN] = ACTIONS(948),
  },
  [458] = {
    [sym__FORALL] = STATE(8396),
    [sym__LAMBDA] = STATE(8031),
    [sym__ELLIPSIS] = STATE(4920),
    [sym__qid] = STATE(4920),
    [sym__binding_ids_and_absurds] = STATE(12357),
    [sym_attribute] = STATE(7725),
    [sym_attributes] = STATE(6200),
    [sym_expr] = STATE(12635),
    [sym__with_exprs] = STATE(10196),
    [sym__expr_or_attr] = STATE(4920),
    [sym__application] = STATE(9678),
    [sym__expr2_without_let] = STATE(9678),
    [sym__expr2] = STATE(9678),
    [sym_atom] = STATE(5202),
    [aux_sym__atoms] = STATE(3165),
    [sym__atom_curly] = STATE(4961),
    [sym__atom_no_curly] = STATE(4961),
    [sym_forall] = STATE(9678),
    [sym_let] = STATE(9678),
    [sym_lambda] = STATE(9678),
    [sym_lambda_extended_or_absurd] = STATE(9678),
    [sym_do] = STATE(9678),
    [sym_record_assignments] = STATE(4920),
    [sym_field_assignments] = STATE(4920),
    [aux_sym__typed_bindings] = STATE(8648),
    [sym_typed_binding] = STATE(8648),
    [sym_literal] = STATE(4920),
    [sym_SetN] = STATE(4920),
    [aux_sym__modal_arg_ids_repeat1] = STATE(7725),
    [aux_sym__with_exprs_repeat1] = STATE(3726),
    [sym_id] = ACTIONS(894),
    [anon_sym_forall] = ACTIONS(896),
    [anon_sym_u2200] = ACTIONS(896),
    [anon_sym_BSLASH] = ACTIONS(898),
    [anon_sym_u03bb] = ACTIONS(900),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(902),
    [anon_sym_u2026] = ACTIONS(902),
    [anon_sym_record] = ACTIONS(904),
    [anon_sym_LPAREN] = ACTIONS(906),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(908),
    [anon_sym_u2983] = ACTIONS(910),
    [anon_sym__] = ACTIONS(902),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(912),
    [anon_sym_RBRACE] = ACTIONS(1072),
    [aux_sym__qid_token1] = ACTIONS(916),
    [anon_sym_DOT] = ACTIONS(918),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(760),
    [anon_sym_quoteGoal] = ACTIONS(920),
    [anon_sym_tactic] = ACTIONS(922),
    [anon_sym_Prop] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(902),
    [anon_sym_quoteTerm] = ACTIONS(902),
    [anon_sym_quoteContext] = ACTIONS(902),
    [anon_sym_unquote] = ACTIONS(902),
    [anon_sym_LPAREN_PIPE] = ACTIONS(924),
    [anon_sym_u2987] = ACTIONS(926),
    [anon_sym_let] = ACTIONS(928),
    [anon_sym_do] = ACTIONS(724),
    [aux_sym_integer_token1] = ACTIONS(930),
    [aux_sym_string_token1] = ACTIONS(930),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(932),
    [sym_PropN] = ACTIONS(902),
  },
  [459] = {
    [sym__FORALL] = STATE(8369),
    [sym__LAMBDA] = STATE(8152),
    [sym__ELLIPSIS] = STATE(5168),
    [sym__qid] = STATE(5168),
    [sym__binding_ids_and_absurds] = STATE(12358),
    [sym_attribute] = STATE(7725),
    [sym_attributes] = STATE(6182),
    [sym_expr] = STATE(11107),
    [sym__with_exprs] = STATE(9861),
    [sym__expr_or_attr] = STATE(5168),
    [sym__application] = STATE(9444),
    [sym__expr2_without_let] = STATE(9444),
    [sym__expr2] = STATE(9444),
    [sym_atom] = STATE(5204),
    [aux_sym__atoms] = STATE(3133),
    [sym__atom_curly] = STATE(5180),
    [sym__atom_no_curly] = STATE(5180),
    [sym_forall] = STATE(9444),
    [sym_let] = STATE(9444),
    [sym_lambda] = STATE(9444),
    [sym_lambda_extended_or_absurd] = STATE(9444),
    [sym_do] = STATE(9444),
    [sym_record_assignments] = STATE(5168),
    [sym_field_assignments] = STATE(5168),
    [aux_sym__typed_bindings] = STATE(8654),
    [sym_typed_binding] = STATE(8654),
    [sym_literal] = STATE(5168),
    [sym_SetN] = STATE(5168),
    [aux_sym__modal_arg_ids_repeat1] = STATE(7725),
    [aux_sym__with_exprs_repeat1] = STATE(3754),
    [sym_id] = ACTIONS(850),
    [anon_sym_forall] = ACTIONS(852),
    [anon_sym_u2200] = ACTIONS(852),
    [anon_sym_BSLASH] = ACTIONS(854),
    [anon_sym_u03bb] = ACTIONS(856),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(858),
    [anon_sym_u2026] = ACTIONS(858),
    [anon_sym_record] = ACTIONS(860),
    [anon_sym_LPAREN] = ACTIONS(862),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(864),
    [anon_sym_u2983] = ACTIONS(866),
    [anon_sym_u2984] = ACTIONS(1064),
    [anon_sym__] = ACTIONS(858),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(870),
    [aux_sym__qid_token1] = ACTIONS(872),
    [anon_sym_DOT] = ACTIONS(874),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(760),
    [anon_sym_quoteGoal] = ACTIONS(878),
    [anon_sym_tactic] = ACTIONS(880),
    [anon_sym_Prop] = ACTIONS(858),
    [anon_sym_quote] = ACTIONS(858),
    [anon_sym_quoteTerm] = ACTIONS(858),
    [anon_sym_quoteContext] = ACTIONS(858),
    [anon_sym_unquote] = ACTIONS(858),
    [anon_sym_LPAREN_PIPE] = ACTIONS(882),
    [anon_sym_u2987] = ACTIONS(884),
    [anon_sym_let] = ACTIONS(886),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(890),
    [aux_sym_string_token1] = ACTIONS(890),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(892),
    [sym_PropN] = ACTIONS(858),
  },
  [460] = {
    [sym__FORALL] = STATE(8396),
    [sym__LAMBDA] = STATE(8031),
    [sym__ELLIPSIS] = STATE(4920),
    [sym__qid] = STATE(4920),
    [sym__binding_ids_and_absurds] = STATE(12357),
    [sym_attribute] = STATE(7725),
    [sym_attributes] = STATE(6200),
    [sym_expr] = STATE(11144),
    [sym__with_exprs] = STATE(10196),
    [sym__expr_or_attr] = STATE(4920),
    [sym__application] = STATE(9678),
    [sym__expr2_without_let] = STATE(9678),
    [sym__expr2] = STATE(9678),
    [sym_atom] = STATE(5202),
    [aux_sym__atoms] = STATE(3165),
    [sym__atom_curly] = STATE(4961),
    [sym__atom_no_curly] = STATE(4961),
    [sym_forall] = STATE(9678),
    [sym_let] = STATE(9678),
    [sym_lambda] = STATE(9678),
    [sym_lambda_extended_or_absurd] = STATE(9678),
    [sym_do] = STATE(9678),
    [sym_record_assignments] = STATE(4920),
    [sym_field_assignments] = STATE(4920),
    [aux_sym__typed_bindings] = STATE(8648),
    [sym_typed_binding] = STATE(8648),
    [sym_literal] = STATE(4920),
    [sym_SetN] = STATE(4920),
    [aux_sym__modal_arg_ids_repeat1] = STATE(7725),
    [aux_sym__with_exprs_repeat1] = STATE(3726),
    [sym_id] = ACTIONS(894),
    [anon_sym_forall] = ACTIONS(896),
    [anon_sym_u2200] = ACTIONS(896),
    [anon_sym_BSLASH] = ACTIONS(898),
    [anon_sym_u03bb] = ACTIONS(900),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(902),
    [anon_sym_u2026] = ACTIONS(902),
    [anon_sym_record] = ACTIONS(904),
    [anon_sym_LPAREN] = ACTIONS(906),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(908),
    [anon_sym_u2983] = ACTIONS(910),
    [anon_sym__] = ACTIONS(902),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(912),
    [anon_sym_RBRACE] = ACTIONS(1066),
    [aux_sym__qid_token1] = ACTIONS(916),
    [anon_sym_DOT] = ACTIONS(918),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(760),
    [anon_sym_quoteGoal] = ACTIONS(920),
    [anon_sym_tactic] = ACTIONS(922),
    [anon_sym_Prop] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(902),
    [anon_sym_quoteTerm] = ACTIONS(902),
    [anon_sym_quoteContext] = ACTIONS(902),
    [anon_sym_unquote] = ACTIONS(902),
    [anon_sym_LPAREN_PIPE] = ACTIONS(924),
    [anon_sym_u2987] = ACTIONS(926),
    [anon_sym_let] = ACTIONS(928),
    [anon_sym_do] = ACTIONS(724),
    [aux_sym_integer_token1] = ACTIONS(930),
    [aux_sym_string_token1] = ACTIONS(930),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(932),
    [sym_PropN] = ACTIONS(902),
  },
  [461] = {
    [sym__FORALL] = STATE(8355),
    [sym__LAMBDA] = STATE(8054),
    [sym__ELLIPSIS] = STATE(4742),
    [sym__qid] = STATE(4742),
    [sym__binding_ids_and_absurds] = STATE(12359),
    [sym_attribute] = STATE(7725),
    [sym_attributes] = STATE(6302),
    [sym_expr] = STATE(11338),
    [sym__with_exprs] = STATE(10050),
    [sym__expr_or_attr] = STATE(4742),
    [sym__application] = STATE(9444),
    [sym__expr2_without_let] = STATE(9444),
    [sym__expr2] = STATE(9444),
    [sym_atom] = STATE(4712),
    [aux_sym__atoms] = STATE(3276),
    [sym__atom_curly] = STATE(4733),
    [sym__atom_no_curly] = STATE(4733),
    [sym_forall] = STATE(9444),
    [sym_let] = STATE(9444),
    [sym_lambda] = STATE(9444),
    [sym_lambda_extended_or_absurd] = STATE(9444),
    [sym_do] = STATE(9444),
    [sym_record_assignments] = STATE(4742),
    [sym_field_assignments] = STATE(4742),
    [aux_sym__typed_bindings] = STATE(8646),
    [sym_typed_binding] = STATE(8646),
    [sym_literal] = STATE(4742),
    [sym_SetN] = STATE(4742),
    [aux_sym__modal_arg_ids_repeat1] = STATE(7725),
    [aux_sym__with_exprs_repeat1] = STATE(3745),
    [sym_id] = ACTIONS(940),
    [anon_sym_forall] = ACTIONS(942),
    [anon_sym_u2200] = ACTIONS(942),
    [anon_sym_BSLASH] = ACTIONS(944),
    [anon_sym_u03bb] = ACTIONS(946),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(948),
    [anon_sym_u2026] = ACTIONS(948),
    [anon_sym_record] = ACTIONS(950),
    [anon_sym_LPAREN] = ACTIONS(952),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(954),
    [anon_sym_RBRACE_RBRACE] = ACTIONS(1070),
    [anon_sym_u2983] = ACTIONS(956),
    [anon_sym__] = ACTIONS(948),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(958),
    [aux_sym__qid_token1] = ACTIONS(960),
    [anon_sym_DOT] = ACTIONS(962),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(760),
    [anon_sym_quoteGoal] = ACTIONS(964),
    [anon_sym_tactic] = ACTIONS(966),
    [anon_sym_Prop] = ACTIONS(948),
    [anon_sym_quote] = ACTIONS(948),
    [anon_sym_quoteTerm] = ACTIONS(948),
    [anon_sym_quoteContext] = ACTIONS(948),
    [anon_sym_unquote] = ACTIONS(948),
    [anon_sym_LPAREN_PIPE] = ACTIONS(968),
    [anon_sym_u2987] = ACTIONS(970),
    [anon_sym_let] = ACTIONS(972),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(974),
    [aux_sym_string_token1] = ACTIONS(974),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(976),
    [sym_PropN] = ACTIONS(948),
  },
  [462] = {
    [sym__FORALL] = STATE(8355),
    [sym__LAMBDA] = STATE(8054),
    [sym__ELLIPSIS] = STATE(4742),
    [sym__qid] = STATE(4742),
    [sym__binding_ids_and_absurds] = STATE(12547),
    [sym_attribute] = STATE(5830),
    [sym_attributes] = STATE(3506),
    [sym_expr] = STATE(11512),
    [sym__with_exprs] = STATE(10050),
    [sym__expr_or_attr] = STATE(4742),
    [sym__application] = STATE(9444),
    [sym__expr2_without_let] = STATE(9444),
    [sym__expr2] = STATE(9444),
    [sym_atom] = STATE(4712),
    [aux_sym__atoms] = STATE(3276),
    [sym__atom_curly] = STATE(4733),
    [sym__atom_no_curly] = STATE(4733),
    [sym_forall] = STATE(9444),
    [sym_let] = STATE(9444),
    [sym_lambda] = STATE(9444),
    [sym_lambda_extended_or_absurd] = STATE(9444),
    [sym_do] = STATE(9444),
    [sym_record_assignments] = STATE(4742),
    [sym_field_assignments] = STATE(4742),
    [aux_sym__typed_bindings] = STATE(8646),
    [sym_typed_binding] = STATE(8646),
    [sym_literal] = STATE(4742),
    [sym_SetN] = STATE(4742),
    [aux_sym__modal_arg_ids_repeat1] = STATE(5830),
    [aux_sym__with_exprs_repeat1] = STATE(3745),
    [sym_id] = ACTIONS(940),
    [anon_sym_forall] = ACTIONS(942),
    [anon_sym_u2200] = ACTIONS(942),
    [anon_sym_BSLASH] = ACTIONS(944),
    [anon_sym_u03bb] = ACTIONS(946),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(948),
    [anon_sym_u2026] = ACTIONS(948),
    [anon_sym_record] = ACTIONS(950),
    [anon_sym_LPAREN] = ACTIONS(952),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(954),
    [anon_sym_RBRACE_RBRACE] = ACTIONS(1074),
    [anon_sym_u2983] = ACTIONS(956),
    [anon_sym__] = ACTIONS(948),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(958),
    [aux_sym__qid_token1] = ACTIONS(960),
    [anon_sym_DOT] = ACTIONS(962),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(712),
    [anon_sym_quoteGoal] = ACTIONS(964),
    [anon_sym_tactic] = ACTIONS(966),
    [anon_sym_Prop] = ACTIONS(948),
    [anon_sym_quote] = ACTIONS(948),
    [anon_sym_quoteTerm] = ACTIONS(948),
    [anon_sym_quoteContext] = ACTIONS(948),
    [anon_sym_unquote] = ACTIONS(948),
    [anon_sym_LPAREN_PIPE] = ACTIONS(968),
    [anon_sym_u2987] = ACTIONS(970),
    [anon_sym_let] = ACTIONS(972),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(974),
    [aux_sym_string_token1] = ACTIONS(974),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(976),
    [sym_PropN] = ACTIONS(948),
  },
  [463] = {
    [sym__FORALL] = STATE(8396),
    [sym__LAMBDA] = STATE(8031),
    [sym__ELLIPSIS] = STATE(4920),
    [sym__qid] = STATE(4920),
    [sym__binding_ids_and_absurds] = STATE(12539),
    [sym_attribute] = STATE(5830),
    [sym_attributes] = STATE(3504),
    [sym_expr] = STATE(11328),
    [sym__with_exprs] = STATE(10196),
    [sym__expr_or_attr] = STATE(4920),
    [sym__application] = STATE(9678),
    [sym__expr2_without_let] = STATE(9678),
    [sym__expr2] = STATE(9678),
    [sym_atom] = STATE(5202),
    [aux_sym__atoms] = STATE(3165),
    [sym__atom_curly] = STATE(4961),
    [sym__atom_no_curly] = STATE(4961),
    [sym_forall] = STATE(9678),
    [sym_let] = STATE(9678),
    [sym_lambda] = STATE(9678),
    [sym_lambda_extended_or_absurd] = STATE(9678),
    [sym_do] = STATE(9678),
    [sym_record_assignments] = STATE(4920),
    [sym_field_assignments] = STATE(4920),
    [aux_sym__typed_bindings] = STATE(8648),
    [sym_typed_binding] = STATE(8648),
    [sym_literal] = STATE(4920),
    [sym_SetN] = STATE(4920),
    [aux_sym__modal_arg_ids_repeat1] = STATE(5830),
    [aux_sym__with_exprs_repeat1] = STATE(3726),
    [sym_id] = ACTIONS(894),
    [anon_sym_forall] = ACTIONS(896),
    [anon_sym_u2200] = ACTIONS(896),
    [anon_sym_BSLASH] = ACTIONS(898),
    [anon_sym_u03bb] = ACTIONS(900),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(902),
    [anon_sym_u2026] = ACTIONS(902),
    [anon_sym_record] = ACTIONS(904),
    [anon_sym_LPAREN] = ACTIONS(906),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(908),
    [anon_sym_u2983] = ACTIONS(910),
    [anon_sym__] = ACTIONS(902),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(912),
    [anon_sym_RBRACE] = ACTIONS(1068),
    [aux_sym__qid_token1] = ACTIONS(916),
    [anon_sym_DOT] = ACTIONS(918),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(712),
    [anon_sym_quoteGoal] = ACTIONS(920),
    [anon_sym_tactic] = ACTIONS(922),
    [anon_sym_Prop] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(902),
    [anon_sym_quoteTerm] = ACTIONS(902),
    [anon_sym_quoteContext] = ACTIONS(902),
    [anon_sym_unquote] = ACTIONS(902),
    [anon_sym_LPAREN_PIPE] = ACTIONS(924),
    [anon_sym_u2987] = ACTIONS(926),
    [anon_sym_let] = ACTIONS(928),
    [anon_sym_do] = ACTIONS(724),
    [aux_sym_integer_token1] = ACTIONS(930),
    [aux_sym_string_token1] = ACTIONS(930),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(932),
    [sym_PropN] = ACTIONS(902),
  },
  [464] = {
    [sym__FORALL] = STATE(8369),
    [sym__LAMBDA] = STATE(8152),
    [sym__ELLIPSIS] = STATE(5168),
    [sym__qid] = STATE(5168),
    [sym__binding_ids_and_absurds] = STATE(12544),
    [sym_attribute] = STATE(5830),
    [sym_attributes] = STATE(3505),
    [sym_expr] = STATE(11329),
    [sym__with_exprs] = STATE(9861),
    [sym__expr_or_attr] = STATE(5168),
    [sym__application] = STATE(9444),
    [sym__expr2_without_let] = STATE(9444),
    [sym__expr2] = STATE(9444),
    [sym_atom] = STATE(5204),
    [aux_sym__atoms] = STATE(3133),
    [sym__atom_curly] = STATE(5180),
    [sym__atom_no_curly] = STATE(5180),
    [sym_forall] = STATE(9444),
    [sym_let] = STATE(9444),
    [sym_lambda] = STATE(9444),
    [sym_lambda_extended_or_absurd] = STATE(9444),
    [sym_do] = STATE(9444),
    [sym_record_assignments] = STATE(5168),
    [sym_field_assignments] = STATE(5168),
    [aux_sym__typed_bindings] = STATE(8654),
    [sym_typed_binding] = STATE(8654),
    [sym_literal] = STATE(5168),
    [sym_SetN] = STATE(5168),
    [aux_sym__modal_arg_ids_repeat1] = STATE(5830),
    [aux_sym__with_exprs_repeat1] = STATE(3754),
    [sym_id] = ACTIONS(850),
    [anon_sym_forall] = ACTIONS(852),
    [anon_sym_u2200] = ACTIONS(852),
    [anon_sym_BSLASH] = ACTIONS(854),
    [anon_sym_u03bb] = ACTIONS(856),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(858),
    [anon_sym_u2026] = ACTIONS(858),
    [anon_sym_record] = ACTIONS(860),
    [anon_sym_LPAREN] = ACTIONS(862),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(864),
    [anon_sym_u2983] = ACTIONS(866),
    [anon_sym_u2984] = ACTIONS(1070),
    [anon_sym__] = ACTIONS(858),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(870),
    [aux_sym__qid_token1] = ACTIONS(872),
    [anon_sym_DOT] = ACTIONS(874),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(712),
    [anon_sym_quoteGoal] = ACTIONS(878),
    [anon_sym_tactic] = ACTIONS(880),
    [anon_sym_Prop] = ACTIONS(858),
    [anon_sym_quote] = ACTIONS(858),
    [anon_sym_quoteTerm] = ACTIONS(858),
    [anon_sym_quoteContext] = ACTIONS(858),
    [anon_sym_unquote] = ACTIONS(858),
    [anon_sym_LPAREN_PIPE] = ACTIONS(882),
    [anon_sym_u2987] = ACTIONS(884),
    [anon_sym_let] = ACTIONS(886),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(890),
    [aux_sym_string_token1] = ACTIONS(890),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(892),
    [sym_PropN] = ACTIONS(858),
  },
  [465] = {
    [sym__FORALL] = STATE(8369),
    [sym__LAMBDA] = STATE(8152),
    [sym__ELLIPSIS] = STATE(5168),
    [sym__qid] = STATE(5168),
    [sym__binding_ids_and_absurds] = STATE(12358),
    [sym_attribute] = STATE(7725),
    [sym_attributes] = STATE(6182),
    [sym_expr] = STATE(12637),
    [sym__with_exprs] = STATE(9861),
    [sym__expr_or_attr] = STATE(5168),
    [sym__application] = STATE(9444),
    [sym__expr2_without_let] = STATE(9444),
    [sym__expr2] = STATE(9444),
    [sym_atom] = STATE(5204),
    [aux_sym__atoms] = STATE(3133),
    [sym__atom_curly] = STATE(5180),
    [sym__atom_no_curly] = STATE(5180),
    [sym_forall] = STATE(9444),
    [sym_let] = STATE(9444),
    [sym_lambda] = STATE(9444),
    [sym_lambda_extended_or_absurd] = STATE(9444),
    [sym_do] = STATE(9444),
    [sym_record_assignments] = STATE(5168),
    [sym_field_assignments] = STATE(5168),
    [aux_sym__typed_bindings] = STATE(8654),
    [sym_typed_binding] = STATE(8654),
    [sym_literal] = STATE(5168),
    [sym_SetN] = STATE(5168),
    [aux_sym__modal_arg_ids_repeat1] = STATE(7725),
    [aux_sym__with_exprs_repeat1] = STATE(3754),
    [sym_id] = ACTIONS(850),
    [anon_sym_forall] = ACTIONS(852),
    [anon_sym_u2200] = ACTIONS(852),
    [anon_sym_BSLASH] = ACTIONS(854),
    [anon_sym_u03bb] = ACTIONS(856),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(858),
    [anon_sym_u2026] = ACTIONS(858),
    [anon_sym_record] = ACTIONS(860),
    [anon_sym_LPAREN] = ACTIONS(862),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(864),
    [anon_sym_u2983] = ACTIONS(866),
    [anon_sym_u2984] = ACTIONS(1076),
    [anon_sym__] = ACTIONS(858),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(870),
    [aux_sym__qid_token1] = ACTIONS(872),
    [anon_sym_DOT] = ACTIONS(874),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(760),
    [anon_sym_quoteGoal] = ACTIONS(878),
    [anon_sym_tactic] = ACTIONS(880),
    [anon_sym_Prop] = ACTIONS(858),
    [anon_sym_quote] = ACTIONS(858),
    [anon_sym_quoteTerm] = ACTIONS(858),
    [anon_sym_quoteContext] = ACTIONS(858),
    [anon_sym_unquote] = ACTIONS(858),
    [anon_sym_LPAREN_PIPE] = ACTIONS(882),
    [anon_sym_u2987] = ACTIONS(884),
    [anon_sym_let] = ACTIONS(886),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(890),
    [aux_sym_string_token1] = ACTIONS(890),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(892),
    [sym_PropN] = ACTIONS(858),
  },
  [466] = {
    [sym__FORALL] = STATE(8345),
    [sym__LAMBDA] = STATE(8095),
    [sym__ELLIPSIS] = STATE(4742),
    [sym_open] = STATE(12555),
    [sym__qid] = STATE(4742),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3873),
    [sym_expr] = STATE(12019),
    [sym__with_exprs] = STATE(10084),
    [sym__expr_or_attr] = STATE(4742),
    [sym__application] = STATE(9680),
    [sym__expr2_without_let] = STATE(9680),
    [sym__expr2] = STATE(9680),
    [sym_atom] = STATE(4712),
    [aux_sym__atoms] = STATE(3211),
    [sym__atom_curly] = STATE(4733),
    [sym__atom_no_curly] = STATE(4733),
    [sym_forall] = STATE(9680),
    [sym_let] = STATE(9680),
    [sym_lambda] = STATE(9680),
    [sym_lambda_extended_or_absurd] = STATE(9680),
    [sym_do] = STATE(9680),
    [sym_record_assignments] = STATE(4742),
    [sym_field_assignments] = STATE(4742),
    [aux_sym__typed_bindings] = STATE(8642),
    [sym_typed_binding] = STATE(8642),
    [sym_literal] = STATE(4742),
    [sym_SetN] = STATE(4742),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3728),
    [sym_id] = ACTIONS(940),
    [anon_sym_forall] = ACTIONS(980),
    [anon_sym_u2200] = ACTIONS(980),
    [anon_sym_BSLASH] = ACTIONS(982),
    [anon_sym_u03bb] = ACTIONS(984),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(948),
    [anon_sym_u2026] = ACTIONS(948),
    [anon_sym_record] = ACTIONS(950),
    [anon_sym_open] = ACTIONS(986),
    [anon_sym_LPAREN] = ACTIONS(952),
    [anon_sym_RPAREN] = ACTIONS(1078),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(954),
    [anon_sym_u2983] = ACTIONS(956),
    [anon_sym__] = ACTIONS(948),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(958),
    [aux_sym__qid_token1] = ACTIONS(960),
    [anon_sym_DOT] = ACTIONS(962),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(988),
    [anon_sym_tactic] = ACTIONS(990),
    [anon_sym_Prop] = ACTIONS(948),
    [anon_sym_quote] = ACTIONS(948),
    [anon_sym_quoteTerm] = ACTIONS(948),
    [anon_sym_quoteContext] = ACTIONS(948),
    [anon_sym_unquote] = ACTIONS(948),
    [anon_sym_LPAREN_PIPE] = ACTIONS(968),
    [anon_sym_u2987] = ACTIONS(970),
    [anon_sym_let] = ACTIONS(992),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(974),
    [aux_sym_string_token1] = ACTIONS(974),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(976),
    [sym_PropN] = ACTIONS(948),
  },
  [467] = {
    [sym__FORALL] = STATE(8355),
    [sym__LAMBDA] = STATE(8054),
    [sym__ELLIPSIS] = STATE(4742),
    [sym__qid] = STATE(4742),
    [sym__binding_ids_and_absurds] = STATE(12547),
    [sym_attribute] = STATE(5830),
    [sym_attributes] = STATE(3506),
    [sym_expr] = STATE(12068),
    [sym__with_exprs] = STATE(10050),
    [sym__expr_or_attr] = STATE(4742),
    [sym__application] = STATE(9444),
    [sym__expr2_without_let] = STATE(9444),
    [sym__expr2] = STATE(9444),
    [sym_atom] = STATE(4712),
    [aux_sym__atoms] = STATE(3276),
    [sym__atom_curly] = STATE(4733),
    [sym__atom_no_curly] = STATE(4733),
    [sym_forall] = STATE(9444),
    [sym_let] = STATE(9444),
    [sym_lambda] = STATE(9444),
    [sym_lambda_extended_or_absurd] = STATE(9444),
    [sym_do] = STATE(9444),
    [sym_record_assignments] = STATE(4742),
    [sym_field_assignments] = STATE(4742),
    [aux_sym__typed_bindings] = STATE(8646),
    [sym_typed_binding] = STATE(8646),
    [sym_literal] = STATE(4742),
    [sym_SetN] = STATE(4742),
    [aux_sym__modal_arg_ids_repeat1] = STATE(5830),
    [aux_sym__with_exprs_repeat1] = STATE(3745),
    [sym_id] = ACTIONS(940),
    [anon_sym_forall] = ACTIONS(942),
    [anon_sym_u2200] = ACTIONS(942),
    [anon_sym_BSLASH] = ACTIONS(944),
    [anon_sym_u03bb] = ACTIONS(946),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(948),
    [anon_sym_u2026] = ACTIONS(948),
    [anon_sym_record] = ACTIONS(950),
    [anon_sym_LPAREN] = ACTIONS(952),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(954),
    [anon_sym_RBRACE_RBRACE] = ACTIONS(1078),
    [anon_sym_u2983] = ACTIONS(956),
    [anon_sym__] = ACTIONS(948),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(958),
    [aux_sym__qid_token1] = ACTIONS(960),
    [anon_sym_DOT] = ACTIONS(962),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(712),
    [anon_sym_quoteGoal] = ACTIONS(964),
    [anon_sym_tactic] = ACTIONS(966),
    [anon_sym_Prop] = ACTIONS(948),
    [anon_sym_quote] = ACTIONS(948),
    [anon_sym_quoteTerm] = ACTIONS(948),
    [anon_sym_quoteContext] = ACTIONS(948),
    [anon_sym_unquote] = ACTIONS(948),
    [anon_sym_LPAREN_PIPE] = ACTIONS(968),
    [anon_sym_u2987] = ACTIONS(970),
    [anon_sym_let] = ACTIONS(972),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(974),
    [aux_sym_string_token1] = ACTIONS(974),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(976),
    [sym_PropN] = ACTIONS(948),
  },
  [468] = {
    [sym__FORALL] = STATE(8355),
    [sym__LAMBDA] = STATE(8054),
    [sym__ELLIPSIS] = STATE(4742),
    [sym__qid] = STATE(4742),
    [sym__binding_ids_and_absurds] = STATE(12547),
    [sym_attribute] = STATE(5830),
    [sym_attributes] = STATE(3506),
    [sym_expr] = STATE(11338),
    [sym__with_exprs] = STATE(10050),
    [sym__expr_or_attr] = STATE(4742),
    [sym__application] = STATE(9444),
    [sym__expr2_without_let] = STATE(9444),
    [sym__expr2] = STATE(9444),
    [sym_atom] = STATE(4712),
    [aux_sym__atoms] = STATE(3276),
    [sym__atom_curly] = STATE(4733),
    [sym__atom_no_curly] = STATE(4733),
    [sym_forall] = STATE(9444),
    [sym_let] = STATE(9444),
    [sym_lambda] = STATE(9444),
    [sym_lambda_extended_or_absurd] = STATE(9444),
    [sym_do] = STATE(9444),
    [sym_record_assignments] = STATE(4742),
    [sym_field_assignments] = STATE(4742),
    [aux_sym__typed_bindings] = STATE(8646),
    [sym_typed_binding] = STATE(8646),
    [sym_literal] = STATE(4742),
    [sym_SetN] = STATE(4742),
    [aux_sym__modal_arg_ids_repeat1] = STATE(5830),
    [aux_sym__with_exprs_repeat1] = STATE(3745),
    [sym_id] = ACTIONS(940),
    [anon_sym_forall] = ACTIONS(942),
    [anon_sym_u2200] = ACTIONS(942),
    [anon_sym_BSLASH] = ACTIONS(944),
    [anon_sym_u03bb] = ACTIONS(946),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(948),
    [anon_sym_u2026] = ACTIONS(948),
    [anon_sym_record] = ACTIONS(950),
    [anon_sym_LPAREN] = ACTIONS(952),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(954),
    [anon_sym_RBRACE_RBRACE] = ACTIONS(1070),
    [anon_sym_u2983] = ACTIONS(956),
    [anon_sym__] = ACTIONS(948),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(958),
    [aux_sym__qid_token1] = ACTIONS(960),
    [anon_sym_DOT] = ACTIONS(962),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(712),
    [anon_sym_quoteGoal] = ACTIONS(964),
    [anon_sym_tactic] = ACTIONS(966),
    [anon_sym_Prop] = ACTIONS(948),
    [anon_sym_quote] = ACTIONS(948),
    [anon_sym_quoteTerm] = ACTIONS(948),
    [anon_sym_quoteContext] = ACTIONS(948),
    [anon_sym_unquote] = ACTIONS(948),
    [anon_sym_LPAREN_PIPE] = ACTIONS(968),
    [anon_sym_u2987] = ACTIONS(970),
    [anon_sym_let] = ACTIONS(972),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(974),
    [aux_sym_string_token1] = ACTIONS(974),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(976),
    [sym_PropN] = ACTIONS(948),
  },
  [469] = {
    [sym__FORALL] = STATE(8369),
    [sym__LAMBDA] = STATE(8152),
    [sym__ELLIPSIS] = STATE(5168),
    [sym__qid] = STATE(5168),
    [sym__binding_ids_and_absurds] = STATE(12544),
    [sym_attribute] = STATE(5830),
    [sym_attributes] = STATE(3505),
    [sym_expr] = STATE(12067),
    [sym__with_exprs] = STATE(9861),
    [sym__expr_or_attr] = STATE(5168),
    [sym__application] = STATE(9444),
    [sym__expr2_without_let] = STATE(9444),
    [sym__expr2] = STATE(9444),
    [sym_atom] = STATE(5204),
    [aux_sym__atoms] = STATE(3133),
    [sym__atom_curly] = STATE(5180),
    [sym__atom_no_curly] = STATE(5180),
    [sym_forall] = STATE(9444),
    [sym_let] = STATE(9444),
    [sym_lambda] = STATE(9444),
    [sym_lambda_extended_or_absurd] = STATE(9444),
    [sym_do] = STATE(9444),
    [sym_record_assignments] = STATE(5168),
    [sym_field_assignments] = STATE(5168),
    [aux_sym__typed_bindings] = STATE(8654),
    [sym_typed_binding] = STATE(8654),
    [sym_literal] = STATE(5168),
    [sym_SetN] = STATE(5168),
    [aux_sym__modal_arg_ids_repeat1] = STATE(5830),
    [aux_sym__with_exprs_repeat1] = STATE(3754),
    [sym_id] = ACTIONS(850),
    [anon_sym_forall] = ACTIONS(852),
    [anon_sym_u2200] = ACTIONS(852),
    [anon_sym_BSLASH] = ACTIONS(854),
    [anon_sym_u03bb] = ACTIONS(856),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(858),
    [anon_sym_u2026] = ACTIONS(858),
    [anon_sym_record] = ACTIONS(860),
    [anon_sym_LPAREN] = ACTIONS(862),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(864),
    [anon_sym_u2983] = ACTIONS(866),
    [anon_sym_u2984] = ACTIONS(1078),
    [anon_sym__] = ACTIONS(858),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(870),
    [aux_sym__qid_token1] = ACTIONS(872),
    [anon_sym_DOT] = ACTIONS(874),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(712),
    [anon_sym_quoteGoal] = ACTIONS(878),
    [anon_sym_tactic] = ACTIONS(880),
    [anon_sym_Prop] = ACTIONS(858),
    [anon_sym_quote] = ACTIONS(858),
    [anon_sym_quoteTerm] = ACTIONS(858),
    [anon_sym_quoteContext] = ACTIONS(858),
    [anon_sym_unquote] = ACTIONS(858),
    [anon_sym_LPAREN_PIPE] = ACTIONS(882),
    [anon_sym_u2987] = ACTIONS(884),
    [anon_sym_let] = ACTIONS(886),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(890),
    [aux_sym_string_token1] = ACTIONS(890),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(892),
    [sym_PropN] = ACTIONS(858),
  },
  [470] = {
    [sym__FORALL] = STATE(8396),
    [sym__LAMBDA] = STATE(8031),
    [sym__ELLIPSIS] = STATE(4920),
    [sym__qid] = STATE(4920),
    [sym__binding_ids_and_absurds] = STATE(12539),
    [sym_attribute] = STATE(5830),
    [sym_attributes] = STATE(3504),
    [sym_expr] = STATE(12066),
    [sym__with_exprs] = STATE(10196),
    [sym__expr_or_attr] = STATE(4920),
    [sym__application] = STATE(9678),
    [sym__expr2_without_let] = STATE(9678),
    [sym__expr2] = STATE(9678),
    [sym_atom] = STATE(5202),
    [aux_sym__atoms] = STATE(3165),
    [sym__atom_curly] = STATE(4961),
    [sym__atom_no_curly] = STATE(4961),
    [sym_forall] = STATE(9678),
    [sym_let] = STATE(9678),
    [sym_lambda] = STATE(9678),
    [sym_lambda_extended_or_absurd] = STATE(9678),
    [sym_do] = STATE(9678),
    [sym_record_assignments] = STATE(4920),
    [sym_field_assignments] = STATE(4920),
    [aux_sym__typed_bindings] = STATE(8648),
    [sym_typed_binding] = STATE(8648),
    [sym_literal] = STATE(4920),
    [sym_SetN] = STATE(4920),
    [aux_sym__modal_arg_ids_repeat1] = STATE(5830),
    [aux_sym__with_exprs_repeat1] = STATE(3726),
    [sym_id] = ACTIONS(894),
    [anon_sym_forall] = ACTIONS(896),
    [anon_sym_u2200] = ACTIONS(896),
    [anon_sym_BSLASH] = ACTIONS(898),
    [anon_sym_u03bb] = ACTIONS(900),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(902),
    [anon_sym_u2026] = ACTIONS(902),
    [anon_sym_record] = ACTIONS(904),
    [anon_sym_LPAREN] = ACTIONS(906),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(908),
    [anon_sym_u2983] = ACTIONS(910),
    [anon_sym__] = ACTIONS(902),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(912),
    [anon_sym_RBRACE] = ACTIONS(1080),
    [aux_sym__qid_token1] = ACTIONS(916),
    [anon_sym_DOT] = ACTIONS(918),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(712),
    [anon_sym_quoteGoal] = ACTIONS(920),
    [anon_sym_tactic] = ACTIONS(922),
    [anon_sym_Prop] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(902),
    [anon_sym_quoteTerm] = ACTIONS(902),
    [anon_sym_quoteContext] = ACTIONS(902),
    [anon_sym_unquote] = ACTIONS(902),
    [anon_sym_LPAREN_PIPE] = ACTIONS(924),
    [anon_sym_u2987] = ACTIONS(926),
    [anon_sym_let] = ACTIONS(928),
    [anon_sym_do] = ACTIONS(724),
    [aux_sym_integer_token1] = ACTIONS(930),
    [aux_sym_string_token1] = ACTIONS(930),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(932),
    [sym_PropN] = ACTIONS(902),
  },
  [471] = {
    [sym__FORALL] = STATE(8345),
    [sym__LAMBDA] = STATE(8095),
    [sym__ELLIPSIS] = STATE(4742),
    [sym_open] = STATE(12555),
    [sym__qid] = STATE(4742),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3873),
    [sym_expr] = STATE(11237),
    [sym__with_exprs] = STATE(10084),
    [sym__expr_or_attr] = STATE(4742),
    [sym__application] = STATE(9680),
    [sym__expr2_without_let] = STATE(9680),
    [sym__expr2] = STATE(9680),
    [sym_atom] = STATE(4712),
    [aux_sym__atoms] = STATE(3211),
    [sym__atom_curly] = STATE(4733),
    [sym__atom_no_curly] = STATE(4733),
    [sym_forall] = STATE(9680),
    [sym_let] = STATE(9680),
    [sym_lambda] = STATE(9680),
    [sym_lambda_extended_or_absurd] = STATE(9680),
    [sym_do] = STATE(9680),
    [sym_record_assignments] = STATE(4742),
    [sym_field_assignments] = STATE(4742),
    [aux_sym__typed_bindings] = STATE(8642),
    [sym_typed_binding] = STATE(8642),
    [sym_literal] = STATE(4742),
    [sym_SetN] = STATE(4742),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3728),
    [sym_id] = ACTIONS(940),
    [anon_sym_forall] = ACTIONS(980),
    [anon_sym_u2200] = ACTIONS(980),
    [anon_sym_BSLASH] = ACTIONS(982),
    [anon_sym_u03bb] = ACTIONS(984),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(948),
    [anon_sym_u2026] = ACTIONS(948),
    [anon_sym_record] = ACTIONS(950),
    [anon_sym_open] = ACTIONS(986),
    [anon_sym_LPAREN] = ACTIONS(952),
    [anon_sym_RPAREN] = ACTIONS(1070),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(954),
    [anon_sym_u2983] = ACTIONS(956),
    [anon_sym__] = ACTIONS(948),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(958),
    [aux_sym__qid_token1] = ACTIONS(960),
    [anon_sym_DOT] = ACTIONS(962),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(988),
    [anon_sym_tactic] = ACTIONS(990),
    [anon_sym_Prop] = ACTIONS(948),
    [anon_sym_quote] = ACTIONS(948),
    [anon_sym_quoteTerm] = ACTIONS(948),
    [anon_sym_quoteContext] = ACTIONS(948),
    [anon_sym_unquote] = ACTIONS(948),
    [anon_sym_LPAREN_PIPE] = ACTIONS(968),
    [anon_sym_u2987] = ACTIONS(970),
    [anon_sym_let] = ACTIONS(992),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(974),
    [aux_sym_string_token1] = ACTIONS(974),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(976),
    [sym_PropN] = ACTIONS(948),
  },
  [472] = {
    [sym__FORALL] = STATE(8369),
    [sym__LAMBDA] = STATE(8152),
    [sym__ELLIPSIS] = STATE(5168),
    [sym__qid] = STATE(5168),
    [sym__binding_ids_and_absurds] = STATE(12544),
    [sym_attribute] = STATE(5830),
    [sym_attributes] = STATE(3505),
    [sym_expr] = STATE(11511),
    [sym__with_exprs] = STATE(9861),
    [sym__expr_or_attr] = STATE(5168),
    [sym__application] = STATE(9444),
    [sym__expr2_without_let] = STATE(9444),
    [sym__expr2] = STATE(9444),
    [sym_atom] = STATE(5204),
    [aux_sym__atoms] = STATE(3133),
    [sym__atom_curly] = STATE(5180),
    [sym__atom_no_curly] = STATE(5180),
    [sym_forall] = STATE(9444),
    [sym_let] = STATE(9444),
    [sym_lambda] = STATE(9444),
    [sym_lambda_extended_or_absurd] = STATE(9444),
    [sym_do] = STATE(9444),
    [sym_record_assignments] = STATE(5168),
    [sym_field_assignments] = STATE(5168),
    [aux_sym__typed_bindings] = STATE(8654),
    [sym_typed_binding] = STATE(8654),
    [sym_literal] = STATE(5168),
    [sym_SetN] = STATE(5168),
    [aux_sym__modal_arg_ids_repeat1] = STATE(5830),
    [aux_sym__with_exprs_repeat1] = STATE(3754),
    [sym_id] = ACTIONS(850),
    [anon_sym_forall] = ACTIONS(852),
    [anon_sym_u2200] = ACTIONS(852),
    [anon_sym_BSLASH] = ACTIONS(854),
    [anon_sym_u03bb] = ACTIONS(856),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(858),
    [anon_sym_u2026] = ACTIONS(858),
    [anon_sym_record] = ACTIONS(860),
    [anon_sym_LPAREN] = ACTIONS(862),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(864),
    [anon_sym_u2983] = ACTIONS(866),
    [anon_sym_u2984] = ACTIONS(1074),
    [anon_sym__] = ACTIONS(858),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(870),
    [aux_sym__qid_token1] = ACTIONS(872),
    [anon_sym_DOT] = ACTIONS(874),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(712),
    [anon_sym_quoteGoal] = ACTIONS(878),
    [anon_sym_tactic] = ACTIONS(880),
    [anon_sym_Prop] = ACTIONS(858),
    [anon_sym_quote] = ACTIONS(858),
    [anon_sym_quoteTerm] = ACTIONS(858),
    [anon_sym_quoteContext] = ACTIONS(858),
    [anon_sym_unquote] = ACTIONS(858),
    [anon_sym_LPAREN_PIPE] = ACTIONS(882),
    [anon_sym_u2987] = ACTIONS(884),
    [anon_sym_let] = ACTIONS(886),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(890),
    [aux_sym_string_token1] = ACTIONS(890),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(892),
    [sym_PropN] = ACTIONS(858),
  },
  [473] = {
    [sym__FORALL] = STATE(8355),
    [sym__LAMBDA] = STATE(8054),
    [sym__ELLIPSIS] = STATE(4742),
    [sym__qid] = STATE(4742),
    [sym__binding_ids_and_absurds] = STATE(12359),
    [sym_attribute] = STATE(7725),
    [sym_attributes] = STATE(6302),
    [sym_expr] = STATE(12068),
    [sym__with_exprs] = STATE(10050),
    [sym__expr_or_attr] = STATE(4742),
    [sym__application] = STATE(9444),
    [sym__expr2_without_let] = STATE(9444),
    [sym__expr2] = STATE(9444),
    [sym_atom] = STATE(4712),
    [aux_sym__atoms] = STATE(3276),
    [sym__atom_curly] = STATE(4733),
    [sym__atom_no_curly] = STATE(4733),
    [sym_forall] = STATE(9444),
    [sym_let] = STATE(9444),
    [sym_lambda] = STATE(9444),
    [sym_lambda_extended_or_absurd] = STATE(9444),
    [sym_do] = STATE(9444),
    [sym_record_assignments] = STATE(4742),
    [sym_field_assignments] = STATE(4742),
    [aux_sym__typed_bindings] = STATE(8646),
    [sym_typed_binding] = STATE(8646),
    [sym_literal] = STATE(4742),
    [sym_SetN] = STATE(4742),
    [aux_sym__modal_arg_ids_repeat1] = STATE(7725),
    [aux_sym__with_exprs_repeat1] = STATE(3745),
    [sym_id] = ACTIONS(940),
    [anon_sym_forall] = ACTIONS(942),
    [anon_sym_u2200] = ACTIONS(942),
    [anon_sym_BSLASH] = ACTIONS(944),
    [anon_sym_u03bb] = ACTIONS(946),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(948),
    [anon_sym_u2026] = ACTIONS(948),
    [anon_sym_record] = ACTIONS(950),
    [anon_sym_LPAREN] = ACTIONS(952),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(954),
    [anon_sym_RBRACE_RBRACE] = ACTIONS(1078),
    [anon_sym_u2983] = ACTIONS(956),
    [anon_sym__] = ACTIONS(948),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(958),
    [aux_sym__qid_token1] = ACTIONS(960),
    [anon_sym_DOT] = ACTIONS(962),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(760),
    [anon_sym_quoteGoal] = ACTIONS(964),
    [anon_sym_tactic] = ACTIONS(966),
    [anon_sym_Prop] = ACTIONS(948),
    [anon_sym_quote] = ACTIONS(948),
    [anon_sym_quoteTerm] = ACTIONS(948),
    [anon_sym_quoteContext] = ACTIONS(948),
    [anon_sym_unquote] = ACTIONS(948),
    [anon_sym_LPAREN_PIPE] = ACTIONS(968),
    [anon_sym_u2987] = ACTIONS(970),
    [anon_sym_let] = ACTIONS(972),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(974),
    [aux_sym_string_token1] = ACTIONS(974),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(976),
    [sym_PropN] = ACTIONS(948),
  },
  [474] = {
    [sym__FORALL] = STATE(8369),
    [sym__LAMBDA] = STATE(8152),
    [sym__ELLIPSIS] = STATE(5168),
    [sym__qid] = STATE(5168),
    [sym__binding_ids_and_absurds] = STATE(12358),
    [sym_attribute] = STATE(7725),
    [sym_attributes] = STATE(6182),
    [sym_expr] = STATE(12067),
    [sym__with_exprs] = STATE(9861),
    [sym__expr_or_attr] = STATE(5168),
    [sym__application] = STATE(9444),
    [sym__expr2_without_let] = STATE(9444),
    [sym__expr2] = STATE(9444),
    [sym_atom] = STATE(5204),
    [aux_sym__atoms] = STATE(3133),
    [sym__atom_curly] = STATE(5180),
    [sym__atom_no_curly] = STATE(5180),
    [sym_forall] = STATE(9444),
    [sym_let] = STATE(9444),
    [sym_lambda] = STATE(9444),
    [sym_lambda_extended_or_absurd] = STATE(9444),
    [sym_do] = STATE(9444),
    [sym_record_assignments] = STATE(5168),
    [sym_field_assignments] = STATE(5168),
    [aux_sym__typed_bindings] = STATE(8654),
    [sym_typed_binding] = STATE(8654),
    [sym_literal] = STATE(5168),
    [sym_SetN] = STATE(5168),
    [aux_sym__modal_arg_ids_repeat1] = STATE(7725),
    [aux_sym__with_exprs_repeat1] = STATE(3754),
    [sym_id] = ACTIONS(850),
    [anon_sym_forall] = ACTIONS(852),
    [anon_sym_u2200] = ACTIONS(852),
    [anon_sym_BSLASH] = ACTIONS(854),
    [anon_sym_u03bb] = ACTIONS(856),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(858),
    [anon_sym_u2026] = ACTIONS(858),
    [anon_sym_record] = ACTIONS(860),
    [anon_sym_LPAREN] = ACTIONS(862),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(864),
    [anon_sym_u2983] = ACTIONS(866),
    [anon_sym_u2984] = ACTIONS(1078),
    [anon_sym__] = ACTIONS(858),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(870),
    [aux_sym__qid_token1] = ACTIONS(872),
    [anon_sym_DOT] = ACTIONS(874),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(760),
    [anon_sym_quoteGoal] = ACTIONS(878),
    [anon_sym_tactic] = ACTIONS(880),
    [anon_sym_Prop] = ACTIONS(858),
    [anon_sym_quote] = ACTIONS(858),
    [anon_sym_quoteTerm] = ACTIONS(858),
    [anon_sym_quoteContext] = ACTIONS(858),
    [anon_sym_unquote] = ACTIONS(858),
    [anon_sym_LPAREN_PIPE] = ACTIONS(882),
    [anon_sym_u2987] = ACTIONS(884),
    [anon_sym_let] = ACTIONS(886),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(890),
    [aux_sym_string_token1] = ACTIONS(890),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(892),
    [sym_PropN] = ACTIONS(858),
  },
  [475] = {
    [sym__FORALL] = STATE(8396),
    [sym__LAMBDA] = STATE(8031),
    [sym__ELLIPSIS] = STATE(4920),
    [sym__qid] = STATE(4920),
    [sym__binding_ids_and_absurds] = STATE(12357),
    [sym_attribute] = STATE(7725),
    [sym_attributes] = STATE(6200),
    [sym_expr] = STATE(12066),
    [sym__with_exprs] = STATE(10196),
    [sym__expr_or_attr] = STATE(4920),
    [sym__application] = STATE(9678),
    [sym__expr2_without_let] = STATE(9678),
    [sym__expr2] = STATE(9678),
    [sym_atom] = STATE(5202),
    [aux_sym__atoms] = STATE(3165),
    [sym__atom_curly] = STATE(4961),
    [sym__atom_no_curly] = STATE(4961),
    [sym_forall] = STATE(9678),
    [sym_let] = STATE(9678),
    [sym_lambda] = STATE(9678),
    [sym_lambda_extended_or_absurd] = STATE(9678),
    [sym_do] = STATE(9678),
    [sym_record_assignments] = STATE(4920),
    [sym_field_assignments] = STATE(4920),
    [aux_sym__typed_bindings] = STATE(8648),
    [sym_typed_binding] = STATE(8648),
    [sym_literal] = STATE(4920),
    [sym_SetN] = STATE(4920),
    [aux_sym__modal_arg_ids_repeat1] = STATE(7725),
    [aux_sym__with_exprs_repeat1] = STATE(3726),
    [sym_id] = ACTIONS(894),
    [anon_sym_forall] = ACTIONS(896),
    [anon_sym_u2200] = ACTIONS(896),
    [anon_sym_BSLASH] = ACTIONS(898),
    [anon_sym_u03bb] = ACTIONS(900),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(902),
    [anon_sym_u2026] = ACTIONS(902),
    [anon_sym_record] = ACTIONS(904),
    [anon_sym_LPAREN] = ACTIONS(906),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(908),
    [anon_sym_u2983] = ACTIONS(910),
    [anon_sym__] = ACTIONS(902),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(912),
    [anon_sym_RBRACE] = ACTIONS(1080),
    [aux_sym__qid_token1] = ACTIONS(916),
    [anon_sym_DOT] = ACTIONS(918),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(760),
    [anon_sym_quoteGoal] = ACTIONS(920),
    [anon_sym_tactic] = ACTIONS(922),
    [anon_sym_Prop] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(902),
    [anon_sym_quoteTerm] = ACTIONS(902),
    [anon_sym_quoteContext] = ACTIONS(902),
    [anon_sym_unquote] = ACTIONS(902),
    [anon_sym_LPAREN_PIPE] = ACTIONS(924),
    [anon_sym_u2987] = ACTIONS(926),
    [anon_sym_let] = ACTIONS(928),
    [anon_sym_do] = ACTIONS(724),
    [aux_sym_integer_token1] = ACTIONS(930),
    [aux_sym_string_token1] = ACTIONS(930),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(932),
    [sym_PropN] = ACTIONS(902),
  },
  [476] = {
    [sym__FORALL] = STATE(8355),
    [sym__LAMBDA] = STATE(8054),
    [sym__ELLIPSIS] = STATE(4742),
    [sym__qid] = STATE(4742),
    [sym__binding_ids_and_absurds] = STATE(12359),
    [sym_attribute] = STATE(7725),
    [sym_attributes] = STATE(6302),
    [sym_expr] = STATE(12638),
    [sym__with_exprs] = STATE(10050),
    [sym__expr_or_attr] = STATE(4742),
    [sym__application] = STATE(9444),
    [sym__expr2_without_let] = STATE(9444),
    [sym__expr2] = STATE(9444),
    [sym_atom] = STATE(4712),
    [aux_sym__atoms] = STATE(3276),
    [sym__atom_curly] = STATE(4733),
    [sym__atom_no_curly] = STATE(4733),
    [sym_forall] = STATE(9444),
    [sym_let] = STATE(9444),
    [sym_lambda] = STATE(9444),
    [sym_lambda_extended_or_absurd] = STATE(9444),
    [sym_do] = STATE(9444),
    [sym_record_assignments] = STATE(4742),
    [sym_field_assignments] = STATE(4742),
    [aux_sym__typed_bindings] = STATE(8646),
    [sym_typed_binding] = STATE(8646),
    [sym_literal] = STATE(4742),
    [sym_SetN] = STATE(4742),
    [aux_sym__modal_arg_ids_repeat1] = STATE(7725),
    [aux_sym__with_exprs_repeat1] = STATE(3745),
    [sym_id] = ACTIONS(940),
    [anon_sym_forall] = ACTIONS(942),
    [anon_sym_u2200] = ACTIONS(942),
    [anon_sym_BSLASH] = ACTIONS(944),
    [anon_sym_u03bb] = ACTIONS(946),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(948),
    [anon_sym_u2026] = ACTIONS(948),
    [anon_sym_record] = ACTIONS(950),
    [anon_sym_LPAREN] = ACTIONS(952),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(954),
    [anon_sym_RBRACE_RBRACE] = ACTIONS(1076),
    [anon_sym_u2983] = ACTIONS(956),
    [anon_sym__] = ACTIONS(948),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(958),
    [aux_sym__qid_token1] = ACTIONS(960),
    [anon_sym_DOT] = ACTIONS(962),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(760),
    [anon_sym_quoteGoal] = ACTIONS(964),
    [anon_sym_tactic] = ACTIONS(966),
    [anon_sym_Prop] = ACTIONS(948),
    [anon_sym_quote] = ACTIONS(948),
    [anon_sym_quoteTerm] = ACTIONS(948),
    [anon_sym_quoteContext] = ACTIONS(948),
    [anon_sym_unquote] = ACTIONS(948),
    [anon_sym_LPAREN_PIPE] = ACTIONS(968),
    [anon_sym_u2987] = ACTIONS(970),
    [anon_sym_let] = ACTIONS(972),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(974),
    [aux_sym_string_token1] = ACTIONS(974),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(976),
    [sym_PropN] = ACTIONS(948),
  },
  [477] = {
    [sym__FORALL] = STATE(8396),
    [sym__LAMBDA] = STATE(8031),
    [sym__ELLIPSIS] = STATE(4920),
    [sym__qid] = STATE(4920),
    [sym__binding_ids_and_absurds] = STATE(12539),
    [sym_attribute] = STATE(5830),
    [sym_attributes] = STATE(3504),
    [sym_expr] = STATE(11573),
    [sym__with_exprs] = STATE(10196),
    [sym__expr_or_attr] = STATE(4920),
    [sym__application] = STATE(9678),
    [sym__expr2_without_let] = STATE(9678),
    [sym__expr2] = STATE(9678),
    [sym_atom] = STATE(5202),
    [aux_sym__atoms] = STATE(3165),
    [sym__atom_curly] = STATE(4961),
    [sym__atom_no_curly] = STATE(4961),
    [sym_forall] = STATE(9678),
    [sym_let] = STATE(9678),
    [sym_lambda] = STATE(9678),
    [sym_lambda_extended_or_absurd] = STATE(9678),
    [sym_do] = STATE(9678),
    [sym_record_assignments] = STATE(4920),
    [sym_field_assignments] = STATE(4920),
    [aux_sym__typed_bindings] = STATE(8648),
    [sym_typed_binding] = STATE(8648),
    [sym_literal] = STATE(4920),
    [sym_SetN] = STATE(4920),
    [aux_sym__modal_arg_ids_repeat1] = STATE(5830),
    [aux_sym__with_exprs_repeat1] = STATE(3726),
    [sym_id] = ACTIONS(894),
    [anon_sym_forall] = ACTIONS(896),
    [anon_sym_u2200] = ACTIONS(896),
    [anon_sym_BSLASH] = ACTIONS(898),
    [anon_sym_u03bb] = ACTIONS(900),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(902),
    [anon_sym_u2026] = ACTIONS(902),
    [anon_sym_record] = ACTIONS(904),
    [anon_sym_LPAREN] = ACTIONS(906),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(908),
    [anon_sym_u2983] = ACTIONS(910),
    [anon_sym__] = ACTIONS(902),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(912),
    [anon_sym_RBRACE] = ACTIONS(1082),
    [aux_sym__qid_token1] = ACTIONS(916),
    [anon_sym_DOT] = ACTIONS(918),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(712),
    [anon_sym_quoteGoal] = ACTIONS(920),
    [anon_sym_tactic] = ACTIONS(922),
    [anon_sym_Prop] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(902),
    [anon_sym_quoteTerm] = ACTIONS(902),
    [anon_sym_quoteContext] = ACTIONS(902),
    [anon_sym_unquote] = ACTIONS(902),
    [anon_sym_LPAREN_PIPE] = ACTIONS(924),
    [anon_sym_u2987] = ACTIONS(926),
    [anon_sym_let] = ACTIONS(928),
    [anon_sym_do] = ACTIONS(724),
    [aux_sym_integer_token1] = ACTIONS(930),
    [aux_sym_string_token1] = ACTIONS(930),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(932),
    [sym_PropN] = ACTIONS(902),
  },
  [478] = {
    [sym__FORALL] = STATE(8396),
    [sym__LAMBDA] = STATE(8031),
    [sym__ELLIPSIS] = STATE(4920),
    [sym__qid] = STATE(4920),
    [sym__binding_ids_and_absurds] = STATE(12357),
    [sym_attribute] = STATE(7725),
    [sym_attributes] = STATE(6200),
    [sym_expr] = STATE(11798),
    [sym__with_exprs] = STATE(10196),
    [sym__expr_or_attr] = STATE(4920),
    [sym__application] = STATE(9678),
    [sym__expr2_without_let] = STATE(9678),
    [sym__expr2] = STATE(9678),
    [sym_atom] = STATE(5202),
    [aux_sym__atoms] = STATE(3165),
    [sym__atom_curly] = STATE(4961),
    [sym__atom_no_curly] = STATE(4961),
    [sym_forall] = STATE(9678),
    [sym_let] = STATE(9678),
    [sym_lambda] = STATE(9678),
    [sym_lambda_extended_or_absurd] = STATE(9678),
    [sym_do] = STATE(9678),
    [sym_record_assignments] = STATE(4920),
    [sym_field_assignments] = STATE(4920),
    [aux_sym__typed_bindings] = STATE(8648),
    [sym_typed_binding] = STATE(8648),
    [sym_literal] = STATE(4920),
    [sym_SetN] = STATE(4920),
    [aux_sym__modal_arg_ids_repeat1] = STATE(7725),
    [aux_sym__with_exprs_repeat1] = STATE(3726),
    [sym_id] = ACTIONS(894),
    [anon_sym_forall] = ACTIONS(896),
    [anon_sym_u2200] = ACTIONS(896),
    [anon_sym_BSLASH] = ACTIONS(898),
    [anon_sym_u03bb] = ACTIONS(900),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(902),
    [anon_sym_u2026] = ACTIONS(902),
    [anon_sym_record] = ACTIONS(904),
    [anon_sym_LPAREN] = ACTIONS(906),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(908),
    [anon_sym_u2983] = ACTIONS(910),
    [anon_sym__] = ACTIONS(902),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(912),
    [anon_sym_RBRACE] = ACTIONS(1084),
    [aux_sym__qid_token1] = ACTIONS(916),
    [anon_sym_DOT] = ACTIONS(918),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(760),
    [anon_sym_quoteGoal] = ACTIONS(920),
    [anon_sym_tactic] = ACTIONS(922),
    [anon_sym_Prop] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(902),
    [anon_sym_quoteTerm] = ACTIONS(902),
    [anon_sym_quoteContext] = ACTIONS(902),
    [anon_sym_unquote] = ACTIONS(902),
    [anon_sym_LPAREN_PIPE] = ACTIONS(924),
    [anon_sym_u2987] = ACTIONS(926),
    [anon_sym_let] = ACTIONS(928),
    [anon_sym_do] = ACTIONS(724),
    [aux_sym_integer_token1] = ACTIONS(930),
    [aux_sym_string_token1] = ACTIONS(930),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(932),
    [sym_PropN] = ACTIONS(902),
  },
  [479] = {
    [sym__FORALL] = STATE(8369),
    [sym__LAMBDA] = STATE(8152),
    [sym__ELLIPSIS] = STATE(5168),
    [sym__qid] = STATE(5168),
    [sym__binding_ids_and_absurds] = STATE(12358),
    [sym_attribute] = STATE(7725),
    [sym_attributes] = STATE(6182),
    [sym_expr] = STATE(11797),
    [sym__with_exprs] = STATE(9861),
    [sym__expr_or_attr] = STATE(5168),
    [sym__application] = STATE(9444),
    [sym__expr2_without_let] = STATE(9444),
    [sym__expr2] = STATE(9444),
    [sym_atom] = STATE(5204),
    [aux_sym__atoms] = STATE(3133),
    [sym__atom_curly] = STATE(5180),
    [sym__atom_no_curly] = STATE(5180),
    [sym_forall] = STATE(9444),
    [sym_let] = STATE(9444),
    [sym_lambda] = STATE(9444),
    [sym_lambda_extended_or_absurd] = STATE(9444),
    [sym_do] = STATE(9444),
    [sym_record_assignments] = STATE(5168),
    [sym_field_assignments] = STATE(5168),
    [aux_sym__typed_bindings] = STATE(8654),
    [sym_typed_binding] = STATE(8654),
    [sym_literal] = STATE(5168),
    [sym_SetN] = STATE(5168),
    [aux_sym__modal_arg_ids_repeat1] = STATE(7725),
    [aux_sym__with_exprs_repeat1] = STATE(3754),
    [sym_id] = ACTIONS(850),
    [anon_sym_forall] = ACTIONS(852),
    [anon_sym_u2200] = ACTIONS(852),
    [anon_sym_BSLASH] = ACTIONS(854),
    [anon_sym_u03bb] = ACTIONS(856),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(858),
    [anon_sym_u2026] = ACTIONS(858),
    [anon_sym_record] = ACTIONS(860),
    [anon_sym_LPAREN] = ACTIONS(862),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(864),
    [anon_sym_u2983] = ACTIONS(866),
    [anon_sym_u2984] = ACTIONS(1086),
    [anon_sym__] = ACTIONS(858),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(870),
    [aux_sym__qid_token1] = ACTIONS(872),
    [anon_sym_DOT] = ACTIONS(874),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(760),
    [anon_sym_quoteGoal] = ACTIONS(878),
    [anon_sym_tactic] = ACTIONS(880),
    [anon_sym_Prop] = ACTIONS(858),
    [anon_sym_quote] = ACTIONS(858),
    [anon_sym_quoteTerm] = ACTIONS(858),
    [anon_sym_quoteContext] = ACTIONS(858),
    [anon_sym_unquote] = ACTIONS(858),
    [anon_sym_LPAREN_PIPE] = ACTIONS(882),
    [anon_sym_u2987] = ACTIONS(884),
    [anon_sym_let] = ACTIONS(886),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(890),
    [aux_sym_string_token1] = ACTIONS(890),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(892),
    [sym_PropN] = ACTIONS(858),
  },
  [480] = {
    [sym__FORALL] = STATE(8369),
    [sym__LAMBDA] = STATE(8152),
    [sym__ELLIPSIS] = STATE(5168),
    [sym__qid] = STATE(5168),
    [sym__binding_ids_and_absurds] = STATE(12358),
    [sym_attribute] = STATE(7725),
    [sym_attributes] = STATE(6182),
    [sym_expr] = STATE(12673),
    [sym__with_exprs] = STATE(9861),
    [sym__expr_or_attr] = STATE(5168),
    [sym__application] = STATE(9444),
    [sym__expr2_without_let] = STATE(9444),
    [sym__expr2] = STATE(9444),
    [sym_atom] = STATE(5204),
    [aux_sym__atoms] = STATE(3133),
    [sym__atom_curly] = STATE(5180),
    [sym__atom_no_curly] = STATE(5180),
    [sym_forall] = STATE(9444),
    [sym_let] = STATE(9444),
    [sym_lambda] = STATE(9444),
    [sym_lambda_extended_or_absurd] = STATE(9444),
    [sym_do] = STATE(9444),
    [sym_record_assignments] = STATE(5168),
    [sym_field_assignments] = STATE(5168),
    [aux_sym__typed_bindings] = STATE(8654),
    [sym_typed_binding] = STATE(8654),
    [sym_literal] = STATE(5168),
    [sym_SetN] = STATE(5168),
    [aux_sym__modal_arg_ids_repeat1] = STATE(7725),
    [aux_sym__with_exprs_repeat1] = STATE(3754),
    [sym_id] = ACTIONS(850),
    [anon_sym_forall] = ACTIONS(852),
    [anon_sym_u2200] = ACTIONS(852),
    [anon_sym_BSLASH] = ACTIONS(854),
    [anon_sym_u03bb] = ACTIONS(856),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(858),
    [anon_sym_u2026] = ACTIONS(858),
    [anon_sym_record] = ACTIONS(860),
    [anon_sym_LPAREN] = ACTIONS(862),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(864),
    [anon_sym_u2983] = ACTIONS(866),
    [anon_sym_u2984] = ACTIONS(1036),
    [anon_sym__] = ACTIONS(858),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(870),
    [aux_sym__qid_token1] = ACTIONS(872),
    [anon_sym_DOT] = ACTIONS(874),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(760),
    [anon_sym_quoteGoal] = ACTIONS(878),
    [anon_sym_tactic] = ACTIONS(880),
    [anon_sym_Prop] = ACTIONS(858),
    [anon_sym_quote] = ACTIONS(858),
    [anon_sym_quoteTerm] = ACTIONS(858),
    [anon_sym_quoteContext] = ACTIONS(858),
    [anon_sym_unquote] = ACTIONS(858),
    [anon_sym_LPAREN_PIPE] = ACTIONS(882),
    [anon_sym_u2987] = ACTIONS(884),
    [anon_sym_let] = ACTIONS(886),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(890),
    [aux_sym_string_token1] = ACTIONS(890),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(892),
    [sym_PropN] = ACTIONS(858),
  },
  [481] = {
    [sym__FORALL] = STATE(8355),
    [sym__LAMBDA] = STATE(8054),
    [sym__ELLIPSIS] = STATE(4742),
    [sym__qid] = STATE(4742),
    [sym__binding_ids_and_absurds] = STATE(12359),
    [sym_attribute] = STATE(7725),
    [sym_attributes] = STATE(6302),
    [sym_expr] = STATE(11796),
    [sym__with_exprs] = STATE(10050),
    [sym__expr_or_attr] = STATE(4742),
    [sym__application] = STATE(9444),
    [sym__expr2_without_let] = STATE(9444),
    [sym__expr2] = STATE(9444),
    [sym_atom] = STATE(4712),
    [aux_sym__atoms] = STATE(3276),
    [sym__atom_curly] = STATE(4733),
    [sym__atom_no_curly] = STATE(4733),
    [sym_forall] = STATE(9444),
    [sym_let] = STATE(9444),
    [sym_lambda] = STATE(9444),
    [sym_lambda_extended_or_absurd] = STATE(9444),
    [sym_do] = STATE(9444),
    [sym_record_assignments] = STATE(4742),
    [sym_field_assignments] = STATE(4742),
    [aux_sym__typed_bindings] = STATE(8646),
    [sym_typed_binding] = STATE(8646),
    [sym_literal] = STATE(4742),
    [sym_SetN] = STATE(4742),
    [aux_sym__modal_arg_ids_repeat1] = STATE(7725),
    [aux_sym__with_exprs_repeat1] = STATE(3745),
    [sym_id] = ACTIONS(940),
    [anon_sym_forall] = ACTIONS(942),
    [anon_sym_u2200] = ACTIONS(942),
    [anon_sym_BSLASH] = ACTIONS(944),
    [anon_sym_u03bb] = ACTIONS(946),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(948),
    [anon_sym_u2026] = ACTIONS(948),
    [anon_sym_record] = ACTIONS(950),
    [anon_sym_LPAREN] = ACTIONS(952),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(954),
    [anon_sym_RBRACE_RBRACE] = ACTIONS(1086),
    [anon_sym_u2983] = ACTIONS(956),
    [anon_sym__] = ACTIONS(948),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(958),
    [aux_sym__qid_token1] = ACTIONS(960),
    [anon_sym_DOT] = ACTIONS(962),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(760),
    [anon_sym_quoteGoal] = ACTIONS(964),
    [anon_sym_tactic] = ACTIONS(966),
    [anon_sym_Prop] = ACTIONS(948),
    [anon_sym_quote] = ACTIONS(948),
    [anon_sym_quoteTerm] = ACTIONS(948),
    [anon_sym_quoteContext] = ACTIONS(948),
    [anon_sym_unquote] = ACTIONS(948),
    [anon_sym_LPAREN_PIPE] = ACTIONS(968),
    [anon_sym_u2987] = ACTIONS(970),
    [anon_sym_let] = ACTIONS(972),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(974),
    [aux_sym_string_token1] = ACTIONS(974),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(976),
    [sym_PropN] = ACTIONS(948),
  },
  [482] = {
    [sym__FORALL] = STATE(8396),
    [sym__LAMBDA] = STATE(8031),
    [sym__ELLIPSIS] = STATE(4920),
    [sym__qid] = STATE(4920),
    [sym__binding_ids_and_absurds] = STATE(12357),
    [sym_attribute] = STATE(7725),
    [sym_attributes] = STATE(6200),
    [sym_expr] = STATE(11387),
    [sym__with_exprs] = STATE(10196),
    [sym__expr_or_attr] = STATE(4920),
    [sym__application] = STATE(9678),
    [sym__expr2_without_let] = STATE(9678),
    [sym__expr2] = STATE(9678),
    [sym_atom] = STATE(5202),
    [aux_sym__atoms] = STATE(3165),
    [sym__atom_curly] = STATE(4961),
    [sym__atom_no_curly] = STATE(4961),
    [sym_forall] = STATE(9678),
    [sym_let] = STATE(9678),
    [sym_lambda] = STATE(9678),
    [sym_lambda_extended_or_absurd] = STATE(9678),
    [sym_do] = STATE(9678),
    [sym_record_assignments] = STATE(4920),
    [sym_field_assignments] = STATE(4920),
    [aux_sym__typed_bindings] = STATE(8648),
    [sym_typed_binding] = STATE(8648),
    [sym_literal] = STATE(4920),
    [sym_SetN] = STATE(4920),
    [aux_sym__modal_arg_ids_repeat1] = STATE(7725),
    [aux_sym__with_exprs_repeat1] = STATE(3726),
    [sym_id] = ACTIONS(894),
    [anon_sym_forall] = ACTIONS(896),
    [anon_sym_u2200] = ACTIONS(896),
    [anon_sym_BSLASH] = ACTIONS(898),
    [anon_sym_u03bb] = ACTIONS(900),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(902),
    [anon_sym_u2026] = ACTIONS(902),
    [anon_sym_record] = ACTIONS(904),
    [anon_sym_LPAREN] = ACTIONS(906),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(908),
    [anon_sym_u2983] = ACTIONS(910),
    [anon_sym__] = ACTIONS(902),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(912),
    [anon_sym_RBRACE] = ACTIONS(1088),
    [aux_sym__qid_token1] = ACTIONS(916),
    [anon_sym_DOT] = ACTIONS(918),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(760),
    [anon_sym_quoteGoal] = ACTIONS(920),
    [anon_sym_tactic] = ACTIONS(922),
    [anon_sym_Prop] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(902),
    [anon_sym_quoteTerm] = ACTIONS(902),
    [anon_sym_quoteContext] = ACTIONS(902),
    [anon_sym_unquote] = ACTIONS(902),
    [anon_sym_LPAREN_PIPE] = ACTIONS(924),
    [anon_sym_u2987] = ACTIONS(926),
    [anon_sym_let] = ACTIONS(928),
    [anon_sym_do] = ACTIONS(724),
    [aux_sym_integer_token1] = ACTIONS(930),
    [aux_sym_string_token1] = ACTIONS(930),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(932),
    [sym_PropN] = ACTIONS(902),
  },
  [483] = {
    [sym__FORALL] = STATE(8369),
    [sym__LAMBDA] = STATE(8152),
    [sym__ELLIPSIS] = STATE(5168),
    [sym__qid] = STATE(5168),
    [sym__binding_ids_and_absurds] = STATE(12358),
    [sym_attribute] = STATE(7725),
    [sym_attributes] = STATE(6182),
    [sym_expr] = STATE(11392),
    [sym__with_exprs] = STATE(9861),
    [sym__expr_or_attr] = STATE(5168),
    [sym__application] = STATE(9444),
    [sym__expr2_without_let] = STATE(9444),
    [sym__expr2] = STATE(9444),
    [sym_atom] = STATE(5204),
    [aux_sym__atoms] = STATE(3133),
    [sym__atom_curly] = STATE(5180),
    [sym__atom_no_curly] = STATE(5180),
    [sym_forall] = STATE(9444),
    [sym_let] = STATE(9444),
    [sym_lambda] = STATE(9444),
    [sym_lambda_extended_or_absurd] = STATE(9444),
    [sym_do] = STATE(9444),
    [sym_record_assignments] = STATE(5168),
    [sym_field_assignments] = STATE(5168),
    [aux_sym__typed_bindings] = STATE(8654),
    [sym_typed_binding] = STATE(8654),
    [sym_literal] = STATE(5168),
    [sym_SetN] = STATE(5168),
    [aux_sym__modal_arg_ids_repeat1] = STATE(7725),
    [aux_sym__with_exprs_repeat1] = STATE(3754),
    [sym_id] = ACTIONS(850),
    [anon_sym_forall] = ACTIONS(852),
    [anon_sym_u2200] = ACTIONS(852),
    [anon_sym_BSLASH] = ACTIONS(854),
    [anon_sym_u03bb] = ACTIONS(856),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(858),
    [anon_sym_u2026] = ACTIONS(858),
    [anon_sym_record] = ACTIONS(860),
    [anon_sym_LPAREN] = ACTIONS(862),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(864),
    [anon_sym_u2983] = ACTIONS(866),
    [anon_sym_u2984] = ACTIONS(1090),
    [anon_sym__] = ACTIONS(858),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(870),
    [aux_sym__qid_token1] = ACTIONS(872),
    [anon_sym_DOT] = ACTIONS(874),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(760),
    [anon_sym_quoteGoal] = ACTIONS(878),
    [anon_sym_tactic] = ACTIONS(880),
    [anon_sym_Prop] = ACTIONS(858),
    [anon_sym_quote] = ACTIONS(858),
    [anon_sym_quoteTerm] = ACTIONS(858),
    [anon_sym_quoteContext] = ACTIONS(858),
    [anon_sym_unquote] = ACTIONS(858),
    [anon_sym_LPAREN_PIPE] = ACTIONS(882),
    [anon_sym_u2987] = ACTIONS(884),
    [anon_sym_let] = ACTIONS(886),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(890),
    [aux_sym_string_token1] = ACTIONS(890),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(892),
    [sym_PropN] = ACTIONS(858),
  },
  [484] = {
    [sym__FORALL] = STATE(8355),
    [sym__LAMBDA] = STATE(8054),
    [sym__ELLIPSIS] = STATE(4742),
    [sym__qid] = STATE(4742),
    [sym__binding_ids_and_absurds] = STATE(12359),
    [sym_attribute] = STATE(7725),
    [sym_attributes] = STATE(6302),
    [sym_expr] = STATE(11399),
    [sym__with_exprs] = STATE(10050),
    [sym__expr_or_attr] = STATE(4742),
    [sym__application] = STATE(9444),
    [sym__expr2_without_let] = STATE(9444),
    [sym__expr2] = STATE(9444),
    [sym_atom] = STATE(4712),
    [aux_sym__atoms] = STATE(3276),
    [sym__atom_curly] = STATE(4733),
    [sym__atom_no_curly] = STATE(4733),
    [sym_forall] = STATE(9444),
    [sym_let] = STATE(9444),
    [sym_lambda] = STATE(9444),
    [sym_lambda_extended_or_absurd] = STATE(9444),
    [sym_do] = STATE(9444),
    [sym_record_assignments] = STATE(4742),
    [sym_field_assignments] = STATE(4742),
    [aux_sym__typed_bindings] = STATE(8646),
    [sym_typed_binding] = STATE(8646),
    [sym_literal] = STATE(4742),
    [sym_SetN] = STATE(4742),
    [aux_sym__modal_arg_ids_repeat1] = STATE(7725),
    [aux_sym__with_exprs_repeat1] = STATE(3745),
    [sym_id] = ACTIONS(940),
    [anon_sym_forall] = ACTIONS(942),
    [anon_sym_u2200] = ACTIONS(942),
    [anon_sym_BSLASH] = ACTIONS(944),
    [anon_sym_u03bb] = ACTIONS(946),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(948),
    [anon_sym_u2026] = ACTIONS(948),
    [anon_sym_record] = ACTIONS(950),
    [anon_sym_LPAREN] = ACTIONS(952),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(954),
    [anon_sym_RBRACE_RBRACE] = ACTIONS(1090),
    [anon_sym_u2983] = ACTIONS(956),
    [anon_sym__] = ACTIONS(948),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(958),
    [aux_sym__qid_token1] = ACTIONS(960),
    [anon_sym_DOT] = ACTIONS(962),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(760),
    [anon_sym_quoteGoal] = ACTIONS(964),
    [anon_sym_tactic] = ACTIONS(966),
    [anon_sym_Prop] = ACTIONS(948),
    [anon_sym_quote] = ACTIONS(948),
    [anon_sym_quoteTerm] = ACTIONS(948),
    [anon_sym_quoteContext] = ACTIONS(948),
    [anon_sym_unquote] = ACTIONS(948),
    [anon_sym_LPAREN_PIPE] = ACTIONS(968),
    [anon_sym_u2987] = ACTIONS(970),
    [anon_sym_let] = ACTIONS(972),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(974),
    [aux_sym_string_token1] = ACTIONS(974),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(976),
    [sym_PropN] = ACTIONS(948),
  },
  [485] = {
    [sym__FORALL] = STATE(8396),
    [sym__LAMBDA] = STATE(8031),
    [sym__ELLIPSIS] = STATE(4920),
    [sym__qid] = STATE(4920),
    [sym__binding_ids_and_absurds] = STATE(12357),
    [sym_attribute] = STATE(7725),
    [sym_attributes] = STATE(6200),
    [sym_expr] = STATE(11573),
    [sym__with_exprs] = STATE(10196),
    [sym__expr_or_attr] = STATE(4920),
    [sym__application] = STATE(9678),
    [sym__expr2_without_let] = STATE(9678),
    [sym__expr2] = STATE(9678),
    [sym_atom] = STATE(5202),
    [aux_sym__atoms] = STATE(3165),
    [sym__atom_curly] = STATE(4961),
    [sym__atom_no_curly] = STATE(4961),
    [sym_forall] = STATE(9678),
    [sym_let] = STATE(9678),
    [sym_lambda] = STATE(9678),
    [sym_lambda_extended_or_absurd] = STATE(9678),
    [sym_do] = STATE(9678),
    [sym_record_assignments] = STATE(4920),
    [sym_field_assignments] = STATE(4920),
    [aux_sym__typed_bindings] = STATE(8648),
    [sym_typed_binding] = STATE(8648),
    [sym_literal] = STATE(4920),
    [sym_SetN] = STATE(4920),
    [aux_sym__modal_arg_ids_repeat1] = STATE(7725),
    [aux_sym__with_exprs_repeat1] = STATE(3726),
    [sym_id] = ACTIONS(894),
    [anon_sym_forall] = ACTIONS(896),
    [anon_sym_u2200] = ACTIONS(896),
    [anon_sym_BSLASH] = ACTIONS(898),
    [anon_sym_u03bb] = ACTIONS(900),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(902),
    [anon_sym_u2026] = ACTIONS(902),
    [anon_sym_record] = ACTIONS(904),
    [anon_sym_LPAREN] = ACTIONS(906),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(908),
    [anon_sym_u2983] = ACTIONS(910),
    [anon_sym__] = ACTIONS(902),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(912),
    [anon_sym_RBRACE] = ACTIONS(1082),
    [aux_sym__qid_token1] = ACTIONS(916),
    [anon_sym_DOT] = ACTIONS(918),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(760),
    [anon_sym_quoteGoal] = ACTIONS(920),
    [anon_sym_tactic] = ACTIONS(922),
    [anon_sym_Prop] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(902),
    [anon_sym_quoteTerm] = ACTIONS(902),
    [anon_sym_quoteContext] = ACTIONS(902),
    [anon_sym_unquote] = ACTIONS(902),
    [anon_sym_LPAREN_PIPE] = ACTIONS(924),
    [anon_sym_u2987] = ACTIONS(926),
    [anon_sym_let] = ACTIONS(928),
    [anon_sym_do] = ACTIONS(724),
    [aux_sym_integer_token1] = ACTIONS(930),
    [aux_sym_string_token1] = ACTIONS(930),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(932),
    [sym_PropN] = ACTIONS(902),
  },
  [486] = {
    [sym__FORALL] = STATE(8369),
    [sym__LAMBDA] = STATE(8152),
    [sym__ELLIPSIS] = STATE(5168),
    [sym__qid] = STATE(5168),
    [sym__binding_ids_and_absurds] = STATE(12358),
    [sym_attribute] = STATE(7725),
    [sym_attributes] = STATE(6182),
    [sym_expr] = STATE(11511),
    [sym__with_exprs] = STATE(9861),
    [sym__expr_or_attr] = STATE(5168),
    [sym__application] = STATE(9444),
    [sym__expr2_without_let] = STATE(9444),
    [sym__expr2] = STATE(9444),
    [sym_atom] = STATE(5204),
    [aux_sym__atoms] = STATE(3133),
    [sym__atom_curly] = STATE(5180),
    [sym__atom_no_curly] = STATE(5180),
    [sym_forall] = STATE(9444),
    [sym_let] = STATE(9444),
    [sym_lambda] = STATE(9444),
    [sym_lambda_extended_or_absurd] = STATE(9444),
    [sym_do] = STATE(9444),
    [sym_record_assignments] = STATE(5168),
    [sym_field_assignments] = STATE(5168),
    [aux_sym__typed_bindings] = STATE(8654),
    [sym_typed_binding] = STATE(8654),
    [sym_literal] = STATE(5168),
    [sym_SetN] = STATE(5168),
    [aux_sym__modal_arg_ids_repeat1] = STATE(7725),
    [aux_sym__with_exprs_repeat1] = STATE(3754),
    [sym_id] = ACTIONS(850),
    [anon_sym_forall] = ACTIONS(852),
    [anon_sym_u2200] = ACTIONS(852),
    [anon_sym_BSLASH] = ACTIONS(854),
    [anon_sym_u03bb] = ACTIONS(856),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(858),
    [anon_sym_u2026] = ACTIONS(858),
    [anon_sym_record] = ACTIONS(860),
    [anon_sym_LPAREN] = ACTIONS(862),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(864),
    [anon_sym_u2983] = ACTIONS(866),
    [anon_sym_u2984] = ACTIONS(1074),
    [anon_sym__] = ACTIONS(858),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(870),
    [aux_sym__qid_token1] = ACTIONS(872),
    [anon_sym_DOT] = ACTIONS(874),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(760),
    [anon_sym_quoteGoal] = ACTIONS(878),
    [anon_sym_tactic] = ACTIONS(880),
    [anon_sym_Prop] = ACTIONS(858),
    [anon_sym_quote] = ACTIONS(858),
    [anon_sym_quoteTerm] = ACTIONS(858),
    [anon_sym_quoteContext] = ACTIONS(858),
    [anon_sym_unquote] = ACTIONS(858),
    [anon_sym_LPAREN_PIPE] = ACTIONS(882),
    [anon_sym_u2987] = ACTIONS(884),
    [anon_sym_let] = ACTIONS(886),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(890),
    [aux_sym_string_token1] = ACTIONS(890),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(892),
    [sym_PropN] = ACTIONS(858),
  },
  [487] = {
    [sym__FORALL] = STATE(8396),
    [sym__LAMBDA] = STATE(8031),
    [sym__ELLIPSIS] = STATE(4920),
    [sym__qid] = STATE(4920),
    [sym__binding_ids_and_absurds] = STATE(12539),
    [sym_attribute] = STATE(5830),
    [sym_attributes] = STATE(3504),
    [sym_expr] = STATE(11387),
    [sym__with_exprs] = STATE(10196),
    [sym__expr_or_attr] = STATE(4920),
    [sym__application] = STATE(9678),
    [sym__expr2_without_let] = STATE(9678),
    [sym__expr2] = STATE(9678),
    [sym_atom] = STATE(5202),
    [aux_sym__atoms] = STATE(3165),
    [sym__atom_curly] = STATE(4961),
    [sym__atom_no_curly] = STATE(4961),
    [sym_forall] = STATE(9678),
    [sym_let] = STATE(9678),
    [sym_lambda] = STATE(9678),
    [sym_lambda_extended_or_absurd] = STATE(9678),
    [sym_do] = STATE(9678),
    [sym_record_assignments] = STATE(4920),
    [sym_field_assignments] = STATE(4920),
    [aux_sym__typed_bindings] = STATE(8648),
    [sym_typed_binding] = STATE(8648),
    [sym_literal] = STATE(4920),
    [sym_SetN] = STATE(4920),
    [aux_sym__modal_arg_ids_repeat1] = STATE(5830),
    [aux_sym__with_exprs_repeat1] = STATE(3726),
    [sym_id] = ACTIONS(894),
    [anon_sym_forall] = ACTIONS(896),
    [anon_sym_u2200] = ACTIONS(896),
    [anon_sym_BSLASH] = ACTIONS(898),
    [anon_sym_u03bb] = ACTIONS(900),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(902),
    [anon_sym_u2026] = ACTIONS(902),
    [anon_sym_record] = ACTIONS(904),
    [anon_sym_LPAREN] = ACTIONS(906),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(908),
    [anon_sym_u2983] = ACTIONS(910),
    [anon_sym__] = ACTIONS(902),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(912),
    [anon_sym_RBRACE] = ACTIONS(1088),
    [aux_sym__qid_token1] = ACTIONS(916),
    [anon_sym_DOT] = ACTIONS(918),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(712),
    [anon_sym_quoteGoal] = ACTIONS(920),
    [anon_sym_tactic] = ACTIONS(922),
    [anon_sym_Prop] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(902),
    [anon_sym_quoteTerm] = ACTIONS(902),
    [anon_sym_quoteContext] = ACTIONS(902),
    [anon_sym_unquote] = ACTIONS(902),
    [anon_sym_LPAREN_PIPE] = ACTIONS(924),
    [anon_sym_u2987] = ACTIONS(926),
    [anon_sym_let] = ACTIONS(928),
    [anon_sym_do] = ACTIONS(724),
    [aux_sym_integer_token1] = ACTIONS(930),
    [aux_sym_string_token1] = ACTIONS(930),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(932),
    [sym_PropN] = ACTIONS(902),
  },
  [488] = {
    [sym__FORALL] = STATE(8355),
    [sym__LAMBDA] = STATE(8054),
    [sym__ELLIPSIS] = STATE(4742),
    [sym__qid] = STATE(4742),
    [sym__binding_ids_and_absurds] = STATE(12359),
    [sym_attribute] = STATE(7725),
    [sym_attributes] = STATE(6302),
    [sym_expr] = STATE(11512),
    [sym__with_exprs] = STATE(10050),
    [sym__expr_or_attr] = STATE(4742),
    [sym__application] = STATE(9444),
    [sym__expr2_without_let] = STATE(9444),
    [sym__expr2] = STATE(9444),
    [sym_atom] = STATE(4712),
    [aux_sym__atoms] = STATE(3276),
    [sym__atom_curly] = STATE(4733),
    [sym__atom_no_curly] = STATE(4733),
    [sym_forall] = STATE(9444),
    [sym_let] = STATE(9444),
    [sym_lambda] = STATE(9444),
    [sym_lambda_extended_or_absurd] = STATE(9444),
    [sym_do] = STATE(9444),
    [sym_record_assignments] = STATE(4742),
    [sym_field_assignments] = STATE(4742),
    [aux_sym__typed_bindings] = STATE(8646),
    [sym_typed_binding] = STATE(8646),
    [sym_literal] = STATE(4742),
    [sym_SetN] = STATE(4742),
    [aux_sym__modal_arg_ids_repeat1] = STATE(7725),
    [aux_sym__with_exprs_repeat1] = STATE(3745),
    [sym_id] = ACTIONS(940),
    [anon_sym_forall] = ACTIONS(942),
    [anon_sym_u2200] = ACTIONS(942),
    [anon_sym_BSLASH] = ACTIONS(944),
    [anon_sym_u03bb] = ACTIONS(946),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(948),
    [anon_sym_u2026] = ACTIONS(948),
    [anon_sym_record] = ACTIONS(950),
    [anon_sym_LPAREN] = ACTIONS(952),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(954),
    [anon_sym_RBRACE_RBRACE] = ACTIONS(1074),
    [anon_sym_u2983] = ACTIONS(956),
    [anon_sym__] = ACTIONS(948),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(958),
    [aux_sym__qid_token1] = ACTIONS(960),
    [anon_sym_DOT] = ACTIONS(962),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(760),
    [anon_sym_quoteGoal] = ACTIONS(964),
    [anon_sym_tactic] = ACTIONS(966),
    [anon_sym_Prop] = ACTIONS(948),
    [anon_sym_quote] = ACTIONS(948),
    [anon_sym_quoteTerm] = ACTIONS(948),
    [anon_sym_quoteContext] = ACTIONS(948),
    [anon_sym_unquote] = ACTIONS(948),
    [anon_sym_LPAREN_PIPE] = ACTIONS(968),
    [anon_sym_u2987] = ACTIONS(970),
    [anon_sym_let] = ACTIONS(972),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(974),
    [aux_sym_string_token1] = ACTIONS(974),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(976),
    [sym_PropN] = ACTIONS(948),
  },
  [489] = {
    [sym__FORALL] = STATE(8369),
    [sym__LAMBDA] = STATE(8152),
    [sym__ELLIPSIS] = STATE(5168),
    [sym__qid] = STATE(5168),
    [sym__binding_ids_and_absurds] = STATE(12544),
    [sym_attribute] = STATE(5830),
    [sym_attributes] = STATE(3505),
    [sym_expr] = STATE(11392),
    [sym__with_exprs] = STATE(9861),
    [sym__expr_or_attr] = STATE(5168),
    [sym__application] = STATE(9444),
    [sym__expr2_without_let] = STATE(9444),
    [sym__expr2] = STATE(9444),
    [sym_atom] = STATE(5204),
    [aux_sym__atoms] = STATE(3133),
    [sym__atom_curly] = STATE(5180),
    [sym__atom_no_curly] = STATE(5180),
    [sym_forall] = STATE(9444),
    [sym_let] = STATE(9444),
    [sym_lambda] = STATE(9444),
    [sym_lambda_extended_or_absurd] = STATE(9444),
    [sym_do] = STATE(9444),
    [sym_record_assignments] = STATE(5168),
    [sym_field_assignments] = STATE(5168),
    [aux_sym__typed_bindings] = STATE(8654),
    [sym_typed_binding] = STATE(8654),
    [sym_literal] = STATE(5168),
    [sym_SetN] = STATE(5168),
    [aux_sym__modal_arg_ids_repeat1] = STATE(5830),
    [aux_sym__with_exprs_repeat1] = STATE(3754),
    [sym_id] = ACTIONS(850),
    [anon_sym_forall] = ACTIONS(852),
    [anon_sym_u2200] = ACTIONS(852),
    [anon_sym_BSLASH] = ACTIONS(854),
    [anon_sym_u03bb] = ACTIONS(856),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(858),
    [anon_sym_u2026] = ACTIONS(858),
    [anon_sym_record] = ACTIONS(860),
    [anon_sym_LPAREN] = ACTIONS(862),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(864),
    [anon_sym_u2983] = ACTIONS(866),
    [anon_sym_u2984] = ACTIONS(1090),
    [anon_sym__] = ACTIONS(858),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(870),
    [aux_sym__qid_token1] = ACTIONS(872),
    [anon_sym_DOT] = ACTIONS(874),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(712),
    [anon_sym_quoteGoal] = ACTIONS(878),
    [anon_sym_tactic] = ACTIONS(880),
    [anon_sym_Prop] = ACTIONS(858),
    [anon_sym_quote] = ACTIONS(858),
    [anon_sym_quoteTerm] = ACTIONS(858),
    [anon_sym_quoteContext] = ACTIONS(858),
    [anon_sym_unquote] = ACTIONS(858),
    [anon_sym_LPAREN_PIPE] = ACTIONS(882),
    [anon_sym_u2987] = ACTIONS(884),
    [anon_sym_let] = ACTIONS(886),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(890),
    [aux_sym_string_token1] = ACTIONS(890),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(892),
    [sym_PropN] = ACTIONS(858),
  },
  [490] = {
    [sym__FORALL] = STATE(8396),
    [sym__LAMBDA] = STATE(8031),
    [sym__ELLIPSIS] = STATE(4920),
    [sym__qid] = STATE(4920),
    [sym__binding_ids_and_absurds] = STATE(12539),
    [sym_attribute] = STATE(5830),
    [sym_attributes] = STATE(3504),
    [sym_expr] = STATE(12635),
    [sym__with_exprs] = STATE(10196),
    [sym__expr_or_attr] = STATE(4920),
    [sym__application] = STATE(9678),
    [sym__expr2_without_let] = STATE(9678),
    [sym__expr2] = STATE(9678),
    [sym_atom] = STATE(5202),
    [aux_sym__atoms] = STATE(3165),
    [sym__atom_curly] = STATE(4961),
    [sym__atom_no_curly] = STATE(4961),
    [sym_forall] = STATE(9678),
    [sym_let] = STATE(9678),
    [sym_lambda] = STATE(9678),
    [sym_lambda_extended_or_absurd] = STATE(9678),
    [sym_do] = STATE(9678),
    [sym_record_assignments] = STATE(4920),
    [sym_field_assignments] = STATE(4920),
    [aux_sym__typed_bindings] = STATE(8648),
    [sym_typed_binding] = STATE(8648),
    [sym_literal] = STATE(4920),
    [sym_SetN] = STATE(4920),
    [aux_sym__modal_arg_ids_repeat1] = STATE(5830),
    [aux_sym__with_exprs_repeat1] = STATE(3726),
    [sym_id] = ACTIONS(894),
    [anon_sym_forall] = ACTIONS(896),
    [anon_sym_u2200] = ACTIONS(896),
    [anon_sym_BSLASH] = ACTIONS(898),
    [anon_sym_u03bb] = ACTIONS(900),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(902),
    [anon_sym_u2026] = ACTIONS(902),
    [anon_sym_record] = ACTIONS(904),
    [anon_sym_LPAREN] = ACTIONS(906),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(908),
    [anon_sym_u2983] = ACTIONS(910),
    [anon_sym__] = ACTIONS(902),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(912),
    [anon_sym_RBRACE] = ACTIONS(1072),
    [aux_sym__qid_token1] = ACTIONS(916),
    [anon_sym_DOT] = ACTIONS(918),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(712),
    [anon_sym_quoteGoal] = ACTIONS(920),
    [anon_sym_tactic] = ACTIONS(922),
    [anon_sym_Prop] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(902),
    [anon_sym_quoteTerm] = ACTIONS(902),
    [anon_sym_quoteContext] = ACTIONS(902),
    [anon_sym_unquote] = ACTIONS(902),
    [anon_sym_LPAREN_PIPE] = ACTIONS(924),
    [anon_sym_u2987] = ACTIONS(926),
    [anon_sym_let] = ACTIONS(928),
    [anon_sym_do] = ACTIONS(724),
    [aux_sym_integer_token1] = ACTIONS(930),
    [aux_sym_string_token1] = ACTIONS(930),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(932),
    [sym_PropN] = ACTIONS(902),
  },
  [491] = {
    [sym__FORALL] = STATE(8355),
    [sym__LAMBDA] = STATE(8054),
    [sym__ELLIPSIS] = STATE(4742),
    [sym__qid] = STATE(4742),
    [sym__binding_ids_and_absurds] = STATE(12547),
    [sym_attribute] = STATE(5830),
    [sym_attributes] = STATE(3506),
    [sym_expr] = STATE(11399),
    [sym__with_exprs] = STATE(10050),
    [sym__expr_or_attr] = STATE(4742),
    [sym__application] = STATE(9444),
    [sym__expr2_without_let] = STATE(9444),
    [sym__expr2] = STATE(9444),
    [sym_atom] = STATE(4712),
    [aux_sym__atoms] = STATE(3276),
    [sym__atom_curly] = STATE(4733),
    [sym__atom_no_curly] = STATE(4733),
    [sym_forall] = STATE(9444),
    [sym_let] = STATE(9444),
    [sym_lambda] = STATE(9444),
    [sym_lambda_extended_or_absurd] = STATE(9444),
    [sym_do] = STATE(9444),
    [sym_record_assignments] = STATE(4742),
    [sym_field_assignments] = STATE(4742),
    [aux_sym__typed_bindings] = STATE(8646),
    [sym_typed_binding] = STATE(8646),
    [sym_literal] = STATE(4742),
    [sym_SetN] = STATE(4742),
    [aux_sym__modal_arg_ids_repeat1] = STATE(5830),
    [aux_sym__with_exprs_repeat1] = STATE(3745),
    [sym_id] = ACTIONS(940),
    [anon_sym_forall] = ACTIONS(942),
    [anon_sym_u2200] = ACTIONS(942),
    [anon_sym_BSLASH] = ACTIONS(944),
    [anon_sym_u03bb] = ACTIONS(946),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(948),
    [anon_sym_u2026] = ACTIONS(948),
    [anon_sym_record] = ACTIONS(950),
    [anon_sym_LPAREN] = ACTIONS(952),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(954),
    [anon_sym_RBRACE_RBRACE] = ACTIONS(1090),
    [anon_sym_u2983] = ACTIONS(956),
    [anon_sym__] = ACTIONS(948),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(958),
    [aux_sym__qid_token1] = ACTIONS(960),
    [anon_sym_DOT] = ACTIONS(962),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(712),
    [anon_sym_quoteGoal] = ACTIONS(964),
    [anon_sym_tactic] = ACTIONS(966),
    [anon_sym_Prop] = ACTIONS(948),
    [anon_sym_quote] = ACTIONS(948),
    [anon_sym_quoteTerm] = ACTIONS(948),
    [anon_sym_quoteContext] = ACTIONS(948),
    [anon_sym_unquote] = ACTIONS(948),
    [anon_sym_LPAREN_PIPE] = ACTIONS(968),
    [anon_sym_u2987] = ACTIONS(970),
    [anon_sym_let] = ACTIONS(972),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(974),
    [aux_sym_string_token1] = ACTIONS(974),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(976),
    [sym_PropN] = ACTIONS(948),
  },
  [492] = {
    [sym__FORALL] = STATE(8369),
    [sym__LAMBDA] = STATE(8152),
    [sym__ELLIPSIS] = STATE(5168),
    [sym__qid] = STATE(5168),
    [sym__binding_ids_and_absurds] = STATE(12544),
    [sym_attribute] = STATE(5830),
    [sym_attributes] = STATE(3505),
    [sym_expr] = STATE(12637),
    [sym__with_exprs] = STATE(9861),
    [sym__expr_or_attr] = STATE(5168),
    [sym__application] = STATE(9444),
    [sym__expr2_without_let] = STATE(9444),
    [sym__expr2] = STATE(9444),
    [sym_atom] = STATE(5204),
    [aux_sym__atoms] = STATE(3133),
    [sym__atom_curly] = STATE(5180),
    [sym__atom_no_curly] = STATE(5180),
    [sym_forall] = STATE(9444),
    [sym_let] = STATE(9444),
    [sym_lambda] = STATE(9444),
    [sym_lambda_extended_or_absurd] = STATE(9444),
    [sym_do] = STATE(9444),
    [sym_record_assignments] = STATE(5168),
    [sym_field_assignments] = STATE(5168),
    [aux_sym__typed_bindings] = STATE(8654),
    [sym_typed_binding] = STATE(8654),
    [sym_literal] = STATE(5168),
    [sym_SetN] = STATE(5168),
    [aux_sym__modal_arg_ids_repeat1] = STATE(5830),
    [aux_sym__with_exprs_repeat1] = STATE(3754),
    [sym_id] = ACTIONS(850),
    [anon_sym_forall] = ACTIONS(852),
    [anon_sym_u2200] = ACTIONS(852),
    [anon_sym_BSLASH] = ACTIONS(854),
    [anon_sym_u03bb] = ACTIONS(856),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(858),
    [anon_sym_u2026] = ACTIONS(858),
    [anon_sym_record] = ACTIONS(860),
    [anon_sym_LPAREN] = ACTIONS(862),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(864),
    [anon_sym_u2983] = ACTIONS(866),
    [anon_sym_u2984] = ACTIONS(1076),
    [anon_sym__] = ACTIONS(858),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(870),
    [aux_sym__qid_token1] = ACTIONS(872),
    [anon_sym_DOT] = ACTIONS(874),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(712),
    [anon_sym_quoteGoal] = ACTIONS(878),
    [anon_sym_tactic] = ACTIONS(880),
    [anon_sym_Prop] = ACTIONS(858),
    [anon_sym_quote] = ACTIONS(858),
    [anon_sym_quoteTerm] = ACTIONS(858),
    [anon_sym_quoteContext] = ACTIONS(858),
    [anon_sym_unquote] = ACTIONS(858),
    [anon_sym_LPAREN_PIPE] = ACTIONS(882),
    [anon_sym_u2987] = ACTIONS(884),
    [anon_sym_let] = ACTIONS(886),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(890),
    [aux_sym_string_token1] = ACTIONS(890),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(892),
    [sym_PropN] = ACTIONS(858),
  },
  [493] = {
    [sym__FORALL] = STATE(8345),
    [sym__LAMBDA] = STATE(8095),
    [sym__ELLIPSIS] = STATE(4742),
    [sym_open] = STATE(12555),
    [sym__qid] = STATE(4742),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3873),
    [sym_expr] = STATE(10246),
    [sym__with_exprs] = STATE(10084),
    [sym__expr_or_attr] = STATE(4742),
    [sym__application] = STATE(9680),
    [sym__expr2_without_let] = STATE(9680),
    [sym__expr2] = STATE(9680),
    [sym_atom] = STATE(4712),
    [aux_sym__atoms] = STATE(3211),
    [sym__atom_curly] = STATE(4733),
    [sym__atom_no_curly] = STATE(4733),
    [sym_forall] = STATE(9680),
    [sym_let] = STATE(9680),
    [sym_lambda] = STATE(9680),
    [sym_lambda_extended_or_absurd] = STATE(9680),
    [sym_do] = STATE(9680),
    [sym_record_assignments] = STATE(4742),
    [sym_field_assignments] = STATE(4742),
    [aux_sym__typed_bindings] = STATE(8642),
    [sym_typed_binding] = STATE(8642),
    [sym_literal] = STATE(4742),
    [sym_SetN] = STATE(4742),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3728),
    [sym_id] = ACTIONS(940),
    [anon_sym_forall] = ACTIONS(980),
    [anon_sym_u2200] = ACTIONS(980),
    [anon_sym_BSLASH] = ACTIONS(982),
    [anon_sym_u03bb] = ACTIONS(984),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(948),
    [anon_sym_u2026] = ACTIONS(948),
    [anon_sym_record] = ACTIONS(950),
    [anon_sym_open] = ACTIONS(986),
    [anon_sym_LPAREN] = ACTIONS(952),
    [anon_sym_RPAREN] = ACTIONS(1092),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(954),
    [anon_sym_u2983] = ACTIONS(956),
    [anon_sym__] = ACTIONS(948),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(958),
    [aux_sym__qid_token1] = ACTIONS(960),
    [anon_sym_DOT] = ACTIONS(962),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(988),
    [anon_sym_tactic] = ACTIONS(990),
    [anon_sym_Prop] = ACTIONS(948),
    [anon_sym_quote] = ACTIONS(948),
    [anon_sym_quoteTerm] = ACTIONS(948),
    [anon_sym_quoteContext] = ACTIONS(948),
    [anon_sym_unquote] = ACTIONS(948),
    [anon_sym_LPAREN_PIPE] = ACTIONS(968),
    [anon_sym_u2987] = ACTIONS(970),
    [anon_sym_let] = ACTIONS(992),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(974),
    [aux_sym_string_token1] = ACTIONS(974),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(976),
    [sym_PropN] = ACTIONS(948),
  },
  [494] = {
    [sym__FORALL] = STATE(8396),
    [sym__LAMBDA] = STATE(8031),
    [sym__ELLIPSIS] = STATE(4920),
    [sym__qid] = STATE(4920),
    [sym__binding_ids_and_absurds] = STATE(12357),
    [sym_attribute] = STATE(7725),
    [sym_attributes] = STATE(6200),
    [sym_expr] = STATE(12671),
    [sym__with_exprs] = STATE(10196),
    [sym__expr_or_attr] = STATE(4920),
    [sym__application] = STATE(9678),
    [sym__expr2_without_let] = STATE(9678),
    [sym__expr2] = STATE(9678),
    [sym_atom] = STATE(5202),
    [aux_sym__atoms] = STATE(3165),
    [sym__atom_curly] = STATE(4961),
    [sym__atom_no_curly] = STATE(4961),
    [sym_forall] = STATE(9678),
    [sym_let] = STATE(9678),
    [sym_lambda] = STATE(9678),
    [sym_lambda_extended_or_absurd] = STATE(9678),
    [sym_do] = STATE(9678),
    [sym_record_assignments] = STATE(4920),
    [sym_field_assignments] = STATE(4920),
    [aux_sym__typed_bindings] = STATE(8648),
    [sym_typed_binding] = STATE(8648),
    [sym_literal] = STATE(4920),
    [sym_SetN] = STATE(4920),
    [aux_sym__modal_arg_ids_repeat1] = STATE(7725),
    [aux_sym__with_exprs_repeat1] = STATE(3726),
    [sym_id] = ACTIONS(894),
    [anon_sym_forall] = ACTIONS(896),
    [anon_sym_u2200] = ACTIONS(896),
    [anon_sym_BSLASH] = ACTIONS(898),
    [anon_sym_u03bb] = ACTIONS(900),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(902),
    [anon_sym_u2026] = ACTIONS(902),
    [anon_sym_record] = ACTIONS(904),
    [anon_sym_LPAREN] = ACTIONS(906),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(908),
    [anon_sym_u2983] = ACTIONS(910),
    [anon_sym__] = ACTIONS(902),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(912),
    [anon_sym_RBRACE] = ACTIONS(1046),
    [aux_sym__qid_token1] = ACTIONS(916),
    [anon_sym_DOT] = ACTIONS(918),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(760),
    [anon_sym_quoteGoal] = ACTIONS(920),
    [anon_sym_tactic] = ACTIONS(922),
    [anon_sym_Prop] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(902),
    [anon_sym_quoteTerm] = ACTIONS(902),
    [anon_sym_quoteContext] = ACTIONS(902),
    [anon_sym_unquote] = ACTIONS(902),
    [anon_sym_LPAREN_PIPE] = ACTIONS(924),
    [anon_sym_u2987] = ACTIONS(926),
    [anon_sym_let] = ACTIONS(928),
    [anon_sym_do] = ACTIONS(724),
    [aux_sym_integer_token1] = ACTIONS(930),
    [aux_sym_string_token1] = ACTIONS(930),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(932),
    [sym_PropN] = ACTIONS(902),
  },
  [495] = {
    [sym__FORALL] = STATE(8345),
    [sym__LAMBDA] = STATE(8095),
    [sym__ELLIPSIS] = STATE(4742),
    [sym_open] = STATE(12555),
    [sym__qid] = STATE(4742),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3873),
    [sym_expr] = STATE(11306),
    [sym__with_exprs] = STATE(10084),
    [sym__expr_or_attr] = STATE(4742),
    [sym__application] = STATE(9680),
    [sym__expr2_without_let] = STATE(9680),
    [sym__expr2] = STATE(9680),
    [sym_atom] = STATE(4712),
    [aux_sym__atoms] = STATE(3211),
    [sym__atom_curly] = STATE(4733),
    [sym__atom_no_curly] = STATE(4733),
    [sym_forall] = STATE(9680),
    [sym_let] = STATE(9680),
    [sym_lambda] = STATE(9680),
    [sym_lambda_extended_or_absurd] = STATE(9680),
    [sym_do] = STATE(9680),
    [sym_record_assignments] = STATE(4742),
    [sym_field_assignments] = STATE(4742),
    [aux_sym__typed_bindings] = STATE(8642),
    [sym_typed_binding] = STATE(8642),
    [sym_literal] = STATE(4742),
    [sym_SetN] = STATE(4742),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3728),
    [sym_id] = ACTIONS(940),
    [anon_sym_forall] = ACTIONS(980),
    [anon_sym_u2200] = ACTIONS(980),
    [anon_sym_BSLASH] = ACTIONS(982),
    [anon_sym_u03bb] = ACTIONS(984),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(948),
    [anon_sym_u2026] = ACTIONS(948),
    [anon_sym_record] = ACTIONS(950),
    [anon_sym_open] = ACTIONS(986),
    [anon_sym_LPAREN] = ACTIONS(952),
    [anon_sym_RPAREN] = ACTIONS(1090),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(954),
    [anon_sym_u2983] = ACTIONS(956),
    [anon_sym__] = ACTIONS(948),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(958),
    [aux_sym__qid_token1] = ACTIONS(960),
    [anon_sym_DOT] = ACTIONS(962),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(988),
    [anon_sym_tactic] = ACTIONS(990),
    [anon_sym_Prop] = ACTIONS(948),
    [anon_sym_quote] = ACTIONS(948),
    [anon_sym_quoteTerm] = ACTIONS(948),
    [anon_sym_quoteContext] = ACTIONS(948),
    [anon_sym_unquote] = ACTIONS(948),
    [anon_sym_LPAREN_PIPE] = ACTIONS(968),
    [anon_sym_u2987] = ACTIONS(970),
    [anon_sym_let] = ACTIONS(992),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(974),
    [aux_sym_string_token1] = ACTIONS(974),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(976),
    [sym_PropN] = ACTIONS(948),
  },
  [496] = {
    [sym__FORALL] = STATE(8396),
    [sym__LAMBDA] = STATE(8031),
    [sym__ELLIPSIS] = STATE(4920),
    [sym__qid] = STATE(4920),
    [sym__binding_ids_and_absurds] = STATE(12539),
    [sym_attribute] = STATE(5830),
    [sym_attributes] = STATE(3504),
    [sym_expr] = STATE(11798),
    [sym__with_exprs] = STATE(10196),
    [sym__expr_or_attr] = STATE(4920),
    [sym__application] = STATE(9678),
    [sym__expr2_without_let] = STATE(9678),
    [sym__expr2] = STATE(9678),
    [sym_atom] = STATE(5202),
    [aux_sym__atoms] = STATE(3165),
    [sym__atom_curly] = STATE(4961),
    [sym__atom_no_curly] = STATE(4961),
    [sym_forall] = STATE(9678),
    [sym_let] = STATE(9678),
    [sym_lambda] = STATE(9678),
    [sym_lambda_extended_or_absurd] = STATE(9678),
    [sym_do] = STATE(9678),
    [sym_record_assignments] = STATE(4920),
    [sym_field_assignments] = STATE(4920),
    [aux_sym__typed_bindings] = STATE(8648),
    [sym_typed_binding] = STATE(8648),
    [sym_literal] = STATE(4920),
    [sym_SetN] = STATE(4920),
    [aux_sym__modal_arg_ids_repeat1] = STATE(5830),
    [aux_sym__with_exprs_repeat1] = STATE(3726),
    [sym_id] = ACTIONS(894),
    [anon_sym_forall] = ACTIONS(896),
    [anon_sym_u2200] = ACTIONS(896),
    [anon_sym_BSLASH] = ACTIONS(898),
    [anon_sym_u03bb] = ACTIONS(900),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(902),
    [anon_sym_u2026] = ACTIONS(902),
    [anon_sym_record] = ACTIONS(904),
    [anon_sym_LPAREN] = ACTIONS(906),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(908),
    [anon_sym_u2983] = ACTIONS(910),
    [anon_sym__] = ACTIONS(902),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(912),
    [anon_sym_RBRACE] = ACTIONS(1084),
    [aux_sym__qid_token1] = ACTIONS(916),
    [anon_sym_DOT] = ACTIONS(918),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(712),
    [anon_sym_quoteGoal] = ACTIONS(920),
    [anon_sym_tactic] = ACTIONS(922),
    [anon_sym_Prop] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(902),
    [anon_sym_quoteTerm] = ACTIONS(902),
    [anon_sym_quoteContext] = ACTIONS(902),
    [anon_sym_unquote] = ACTIONS(902),
    [anon_sym_LPAREN_PIPE] = ACTIONS(924),
    [anon_sym_u2987] = ACTIONS(926),
    [anon_sym_let] = ACTIONS(928),
    [anon_sym_do] = ACTIONS(724),
    [aux_sym_integer_token1] = ACTIONS(930),
    [aux_sym_string_token1] = ACTIONS(930),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(932),
    [sym_PropN] = ACTIONS(902),
  },
  [497] = {
    [sym__FORALL] = STATE(8369),
    [sym__LAMBDA] = STATE(8152),
    [sym__ELLIPSIS] = STATE(5168),
    [sym__qid] = STATE(5168),
    [sym__binding_ids_and_absurds] = STATE(12544),
    [sym_attribute] = STATE(5830),
    [sym_attributes] = STATE(3505),
    [sym_expr] = STATE(11797),
    [sym__with_exprs] = STATE(9861),
    [sym__expr_or_attr] = STATE(5168),
    [sym__application] = STATE(9444),
    [sym__expr2_without_let] = STATE(9444),
    [sym__expr2] = STATE(9444),
    [sym_atom] = STATE(5204),
    [aux_sym__atoms] = STATE(3133),
    [sym__atom_curly] = STATE(5180),
    [sym__atom_no_curly] = STATE(5180),
    [sym_forall] = STATE(9444),
    [sym_let] = STATE(9444),
    [sym_lambda] = STATE(9444),
    [sym_lambda_extended_or_absurd] = STATE(9444),
    [sym_do] = STATE(9444),
    [sym_record_assignments] = STATE(5168),
    [sym_field_assignments] = STATE(5168),
    [aux_sym__typed_bindings] = STATE(8654),
    [sym_typed_binding] = STATE(8654),
    [sym_literal] = STATE(5168),
    [sym_SetN] = STATE(5168),
    [aux_sym__modal_arg_ids_repeat1] = STATE(5830),
    [aux_sym__with_exprs_repeat1] = STATE(3754),
    [sym_id] = ACTIONS(850),
    [anon_sym_forall] = ACTIONS(852),
    [anon_sym_u2200] = ACTIONS(852),
    [anon_sym_BSLASH] = ACTIONS(854),
    [anon_sym_u03bb] = ACTIONS(856),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(858),
    [anon_sym_u2026] = ACTIONS(858),
    [anon_sym_record] = ACTIONS(860),
    [anon_sym_LPAREN] = ACTIONS(862),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(864),
    [anon_sym_u2983] = ACTIONS(866),
    [anon_sym_u2984] = ACTIONS(1086),
    [anon_sym__] = ACTIONS(858),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(870),
    [aux_sym__qid_token1] = ACTIONS(872),
    [anon_sym_DOT] = ACTIONS(874),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(712),
    [anon_sym_quoteGoal] = ACTIONS(878),
    [anon_sym_tactic] = ACTIONS(880),
    [anon_sym_Prop] = ACTIONS(858),
    [anon_sym_quote] = ACTIONS(858),
    [anon_sym_quoteTerm] = ACTIONS(858),
    [anon_sym_quoteContext] = ACTIONS(858),
    [anon_sym_unquote] = ACTIONS(858),
    [anon_sym_LPAREN_PIPE] = ACTIONS(882),
    [anon_sym_u2987] = ACTIONS(884),
    [anon_sym_let] = ACTIONS(886),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(890),
    [aux_sym_string_token1] = ACTIONS(890),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(892),
    [sym_PropN] = ACTIONS(858),
  },
  [498] = {
    [sym__FORALL] = STATE(8396),
    [sym__LAMBDA] = STATE(8031),
    [sym__ELLIPSIS] = STATE(4920),
    [sym__qid] = STATE(4920),
    [sym__binding_ids_and_absurds] = STATE(12539),
    [sym_attribute] = STATE(5830),
    [sym_attributes] = STATE(3504),
    [sym_expr] = STATE(10617),
    [sym__with_exprs] = STATE(10196),
    [sym__expr_or_attr] = STATE(4920),
    [sym__application] = STATE(9678),
    [sym__expr2_without_let] = STATE(9678),
    [sym__expr2] = STATE(9678),
    [sym_atom] = STATE(5202),
    [aux_sym__atoms] = STATE(3165),
    [sym__atom_curly] = STATE(4961),
    [sym__atom_no_curly] = STATE(4961),
    [sym_forall] = STATE(9678),
    [sym_let] = STATE(9678),
    [sym_lambda] = STATE(9678),
    [sym_lambda_extended_or_absurd] = STATE(9678),
    [sym_do] = STATE(9678),
    [sym_record_assignments] = STATE(4920),
    [sym_field_assignments] = STATE(4920),
    [aux_sym__typed_bindings] = STATE(8648),
    [sym_typed_binding] = STATE(8648),
    [sym_literal] = STATE(4920),
    [sym_SetN] = STATE(4920),
    [aux_sym__modal_arg_ids_repeat1] = STATE(5830),
    [aux_sym__with_exprs_repeat1] = STATE(3726),
    [sym_id] = ACTIONS(894),
    [anon_sym_forall] = ACTIONS(896),
    [anon_sym_u2200] = ACTIONS(896),
    [anon_sym_BSLASH] = ACTIONS(898),
    [anon_sym_u03bb] = ACTIONS(900),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(902),
    [anon_sym_u2026] = ACTIONS(902),
    [anon_sym_record] = ACTIONS(904),
    [anon_sym_LPAREN] = ACTIONS(906),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(908),
    [anon_sym_u2983] = ACTIONS(910),
    [anon_sym__] = ACTIONS(902),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(912),
    [anon_sym_RBRACE] = ACTIONS(1048),
    [aux_sym__qid_token1] = ACTIONS(916),
    [anon_sym_DOT] = ACTIONS(918),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(712),
    [anon_sym_quoteGoal] = ACTIONS(920),
    [anon_sym_tactic] = ACTIONS(922),
    [anon_sym_Prop] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(902),
    [anon_sym_quoteTerm] = ACTIONS(902),
    [anon_sym_quoteContext] = ACTIONS(902),
    [anon_sym_unquote] = ACTIONS(902),
    [anon_sym_LPAREN_PIPE] = ACTIONS(924),
    [anon_sym_u2987] = ACTIONS(926),
    [anon_sym_let] = ACTIONS(928),
    [anon_sym_do] = ACTIONS(724),
    [aux_sym_integer_token1] = ACTIONS(930),
    [aux_sym_string_token1] = ACTIONS(930),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(932),
    [sym_PropN] = ACTIONS(902),
  },
  [499] = {
    [sym__FORALL] = STATE(8355),
    [sym__LAMBDA] = STATE(8054),
    [sym__ELLIPSIS] = STATE(4742),
    [sym__qid] = STATE(4742),
    [sym__binding_ids_and_absurds] = STATE(12547),
    [sym_attribute] = STATE(5830),
    [sym_attributes] = STATE(3506),
    [sym_expr] = STATE(11796),
    [sym__with_exprs] = STATE(10050),
    [sym__expr_or_attr] = STATE(4742),
    [sym__application] = STATE(9444),
    [sym__expr2_without_let] = STATE(9444),
    [sym__expr2] = STATE(9444),
    [sym_atom] = STATE(4712),
    [aux_sym__atoms] = STATE(3276),
    [sym__atom_curly] = STATE(4733),
    [sym__atom_no_curly] = STATE(4733),
    [sym_forall] = STATE(9444),
    [sym_let] = STATE(9444),
    [sym_lambda] = STATE(9444),
    [sym_lambda_extended_or_absurd] = STATE(9444),
    [sym_do] = STATE(9444),
    [sym_record_assignments] = STATE(4742),
    [sym_field_assignments] = STATE(4742),
    [aux_sym__typed_bindings] = STATE(8646),
    [sym_typed_binding] = STATE(8646),
    [sym_literal] = STATE(4742),
    [sym_SetN] = STATE(4742),
    [aux_sym__modal_arg_ids_repeat1] = STATE(5830),
    [aux_sym__with_exprs_repeat1] = STATE(3745),
    [sym_id] = ACTIONS(940),
    [anon_sym_forall] = ACTIONS(942),
    [anon_sym_u2200] = ACTIONS(942),
    [anon_sym_BSLASH] = ACTIONS(944),
    [anon_sym_u03bb] = ACTIONS(946),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(948),
    [anon_sym_u2026] = ACTIONS(948),
    [anon_sym_record] = ACTIONS(950),
    [anon_sym_LPAREN] = ACTIONS(952),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(954),
    [anon_sym_RBRACE_RBRACE] = ACTIONS(1086),
    [anon_sym_u2983] = ACTIONS(956),
    [anon_sym__] = ACTIONS(948),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(958),
    [aux_sym__qid_token1] = ACTIONS(960),
    [anon_sym_DOT] = ACTIONS(962),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(712),
    [anon_sym_quoteGoal] = ACTIONS(964),
    [anon_sym_tactic] = ACTIONS(966),
    [anon_sym_Prop] = ACTIONS(948),
    [anon_sym_quote] = ACTIONS(948),
    [anon_sym_quoteTerm] = ACTIONS(948),
    [anon_sym_quoteContext] = ACTIONS(948),
    [anon_sym_unquote] = ACTIONS(948),
    [anon_sym_LPAREN_PIPE] = ACTIONS(968),
    [anon_sym_u2987] = ACTIONS(970),
    [anon_sym_let] = ACTIONS(972),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(974),
    [aux_sym_string_token1] = ACTIONS(974),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(976),
    [sym_PropN] = ACTIONS(948),
  },
  [500] = {
    [sym__FORALL] = STATE(8345),
    [sym__LAMBDA] = STATE(8095),
    [sym__ELLIPSIS] = STATE(4742),
    [sym_open] = STATE(12555),
    [sym__qid] = STATE(4742),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3873),
    [sym_expr] = STATE(12071),
    [sym__with_exprs] = STATE(10084),
    [sym__expr_or_attr] = STATE(4742),
    [sym__application] = STATE(9680),
    [sym__expr2_without_let] = STATE(9680),
    [sym__expr2] = STATE(9680),
    [sym_atom] = STATE(4712),
    [aux_sym__atoms] = STATE(3211),
    [sym__atom_curly] = STATE(4733),
    [sym__atom_no_curly] = STATE(4733),
    [sym_forall] = STATE(9680),
    [sym_let] = STATE(9680),
    [sym_lambda] = STATE(9680),
    [sym_lambda_extended_or_absurd] = STATE(9680),
    [sym_do] = STATE(9680),
    [sym_record_assignments] = STATE(4742),
    [sym_field_assignments] = STATE(4742),
    [aux_sym__typed_bindings] = STATE(8642),
    [sym_typed_binding] = STATE(8642),
    [sym_literal] = STATE(4742),
    [sym_SetN] = STATE(4742),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3728),
    [sym_id] = ACTIONS(940),
    [anon_sym_forall] = ACTIONS(980),
    [anon_sym_u2200] = ACTIONS(980),
    [anon_sym_BSLASH] = ACTIONS(982),
    [anon_sym_u03bb] = ACTIONS(984),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(948),
    [anon_sym_u2026] = ACTIONS(948),
    [anon_sym_record] = ACTIONS(950),
    [anon_sym_open] = ACTIONS(986),
    [anon_sym_LPAREN] = ACTIONS(952),
    [anon_sym_RPAREN] = ACTIONS(1086),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(954),
    [anon_sym_u2983] = ACTIONS(956),
    [anon_sym__] = ACTIONS(948),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(958),
    [aux_sym__qid_token1] = ACTIONS(960),
    [anon_sym_DOT] = ACTIONS(962),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(988),
    [anon_sym_tactic] = ACTIONS(990),
    [anon_sym_Prop] = ACTIONS(948),
    [anon_sym_quote] = ACTIONS(948),
    [anon_sym_quoteTerm] = ACTIONS(948),
    [anon_sym_quoteContext] = ACTIONS(948),
    [anon_sym_unquote] = ACTIONS(948),
    [anon_sym_LPAREN_PIPE] = ACTIONS(968),
    [anon_sym_u2987] = ACTIONS(970),
    [anon_sym_let] = ACTIONS(992),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(974),
    [aux_sym_string_token1] = ACTIONS(974),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(976),
    [sym_PropN] = ACTIONS(948),
  },
  [501] = {
    [sym__FORALL] = STATE(8396),
    [sym__LAMBDA] = STATE(8031),
    [sym__ELLIPSIS] = STATE(4920),
    [sym__qid] = STATE(4920),
    [sym__binding_ids_and_absurds] = STATE(12357),
    [sym_attribute] = STATE(7725),
    [sym_attributes] = STATE(6200),
    [sym_expr] = STATE(11467),
    [sym__with_exprs] = STATE(10196),
    [sym__expr_or_attr] = STATE(4920),
    [sym__application] = STATE(9678),
    [sym__expr2_without_let] = STATE(9678),
    [sym__expr2] = STATE(9678),
    [sym_atom] = STATE(5202),
    [aux_sym__atoms] = STATE(3165),
    [sym__atom_curly] = STATE(4961),
    [sym__atom_no_curly] = STATE(4961),
    [sym_forall] = STATE(9678),
    [sym_let] = STATE(9678),
    [sym_lambda] = STATE(9678),
    [sym_lambda_extended_or_absurd] = STATE(9678),
    [sym_do] = STATE(9678),
    [sym_record_assignments] = STATE(4920),
    [sym_field_assignments] = STATE(4920),
    [aux_sym__typed_bindings] = STATE(8648),
    [sym_typed_binding] = STATE(8648),
    [sym_literal] = STATE(4920),
    [sym_SetN] = STATE(4920),
    [aux_sym__modal_arg_ids_repeat1] = STATE(7725),
    [aux_sym__with_exprs_repeat1] = STATE(3726),
    [sym_id] = ACTIONS(894),
    [anon_sym_forall] = ACTIONS(896),
    [anon_sym_u2200] = ACTIONS(896),
    [anon_sym_BSLASH] = ACTIONS(898),
    [anon_sym_u03bb] = ACTIONS(900),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(902),
    [anon_sym_u2026] = ACTIONS(902),
    [anon_sym_record] = ACTIONS(904),
    [anon_sym_LPAREN] = ACTIONS(906),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(908),
    [anon_sym_u2983] = ACTIONS(910),
    [anon_sym__] = ACTIONS(902),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(912),
    [anon_sym_RBRACE] = ACTIONS(1094),
    [aux_sym__qid_token1] = ACTIONS(916),
    [anon_sym_DOT] = ACTIONS(918),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(760),
    [anon_sym_quoteGoal] = ACTIONS(920),
    [anon_sym_tactic] = ACTIONS(922),
    [anon_sym_Prop] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(902),
    [anon_sym_quoteTerm] = ACTIONS(902),
    [anon_sym_quoteContext] = ACTIONS(902),
    [anon_sym_unquote] = ACTIONS(902),
    [anon_sym_LPAREN_PIPE] = ACTIONS(924),
    [anon_sym_u2987] = ACTIONS(926),
    [anon_sym_let] = ACTIONS(928),
    [anon_sym_do] = ACTIONS(724),
    [aux_sym_integer_token1] = ACTIONS(930),
    [aux_sym_string_token1] = ACTIONS(930),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(932),
    [sym_PropN] = ACTIONS(902),
  },
  [502] = {
    [sym__FORALL] = STATE(8369),
    [sym__LAMBDA] = STATE(8152),
    [sym__ELLIPSIS] = STATE(5168),
    [sym__qid] = STATE(5168),
    [sym__binding_ids_and_absurds] = STATE(12358),
    [sym_attribute] = STATE(7725),
    [sym_attributes] = STATE(6182),
    [sym_expr] = STATE(11433),
    [sym__with_exprs] = STATE(9861),
    [sym__expr_or_attr] = STATE(5168),
    [sym__application] = STATE(9444),
    [sym__expr2_without_let] = STATE(9444),
    [sym__expr2] = STATE(9444),
    [sym_atom] = STATE(5204),
    [aux_sym__atoms] = STATE(3133),
    [sym__atom_curly] = STATE(5180),
    [sym__atom_no_curly] = STATE(5180),
    [sym_forall] = STATE(9444),
    [sym_let] = STATE(9444),
    [sym_lambda] = STATE(9444),
    [sym_lambda_extended_or_absurd] = STATE(9444),
    [sym_do] = STATE(9444),
    [sym_record_assignments] = STATE(5168),
    [sym_field_assignments] = STATE(5168),
    [aux_sym__typed_bindings] = STATE(8654),
    [sym_typed_binding] = STATE(8654),
    [sym_literal] = STATE(5168),
    [sym_SetN] = STATE(5168),
    [aux_sym__modal_arg_ids_repeat1] = STATE(7725),
    [aux_sym__with_exprs_repeat1] = STATE(3754),
    [sym_id] = ACTIONS(850),
    [anon_sym_forall] = ACTIONS(852),
    [anon_sym_u2200] = ACTIONS(852),
    [anon_sym_BSLASH] = ACTIONS(854),
    [anon_sym_u03bb] = ACTIONS(856),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(858),
    [anon_sym_u2026] = ACTIONS(858),
    [anon_sym_record] = ACTIONS(860),
    [anon_sym_LPAREN] = ACTIONS(862),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(864),
    [anon_sym_u2983] = ACTIONS(866),
    [anon_sym_u2984] = ACTIONS(1096),
    [anon_sym__] = ACTIONS(858),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(870),
    [aux_sym__qid_token1] = ACTIONS(872),
    [anon_sym_DOT] = ACTIONS(874),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(760),
    [anon_sym_quoteGoal] = ACTIONS(878),
    [anon_sym_tactic] = ACTIONS(880),
    [anon_sym_Prop] = ACTIONS(858),
    [anon_sym_quote] = ACTIONS(858),
    [anon_sym_quoteTerm] = ACTIONS(858),
    [anon_sym_quoteContext] = ACTIONS(858),
    [anon_sym_unquote] = ACTIONS(858),
    [anon_sym_LPAREN_PIPE] = ACTIONS(882),
    [anon_sym_u2987] = ACTIONS(884),
    [anon_sym_let] = ACTIONS(886),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(890),
    [aux_sym_string_token1] = ACTIONS(890),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(892),
    [sym_PropN] = ACTIONS(858),
  },
  [503] = {
    [sym__FORALL] = STATE(8355),
    [sym__LAMBDA] = STATE(8054),
    [sym__ELLIPSIS] = STATE(4742),
    [sym__qid] = STATE(4742),
    [sym__binding_ids_and_absurds] = STATE(12359),
    [sym_attribute] = STATE(7725),
    [sym_attributes] = STATE(6302),
    [sym_expr] = STATE(11434),
    [sym__with_exprs] = STATE(10050),
    [sym__expr_or_attr] = STATE(4742),
    [sym__application] = STATE(9444),
    [sym__expr2_without_let] = STATE(9444),
    [sym__expr2] = STATE(9444),
    [sym_atom] = STATE(4712),
    [aux_sym__atoms] = STATE(3276),
    [sym__atom_curly] = STATE(4733),
    [sym__atom_no_curly] = STATE(4733),
    [sym_forall] = STATE(9444),
    [sym_let] = STATE(9444),
    [sym_lambda] = STATE(9444),
    [sym_lambda_extended_or_absurd] = STATE(9444),
    [sym_do] = STATE(9444),
    [sym_record_assignments] = STATE(4742),
    [sym_field_assignments] = STATE(4742),
    [aux_sym__typed_bindings] = STATE(8646),
    [sym_typed_binding] = STATE(8646),
    [sym_literal] = STATE(4742),
    [sym_SetN] = STATE(4742),
    [aux_sym__modal_arg_ids_repeat1] = STATE(7725),
    [aux_sym__with_exprs_repeat1] = STATE(3745),
    [sym_id] = ACTIONS(940),
    [anon_sym_forall] = ACTIONS(942),
    [anon_sym_u2200] = ACTIONS(942),
    [anon_sym_BSLASH] = ACTIONS(944),
    [anon_sym_u03bb] = ACTIONS(946),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(948),
    [anon_sym_u2026] = ACTIONS(948),
    [anon_sym_record] = ACTIONS(950),
    [anon_sym_LPAREN] = ACTIONS(952),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(954),
    [anon_sym_RBRACE_RBRACE] = ACTIONS(1096),
    [anon_sym_u2983] = ACTIONS(956),
    [anon_sym__] = ACTIONS(948),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(958),
    [aux_sym__qid_token1] = ACTIONS(960),
    [anon_sym_DOT] = ACTIONS(962),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(760),
    [anon_sym_quoteGoal] = ACTIONS(964),
    [anon_sym_tactic] = ACTIONS(966),
    [anon_sym_Prop] = ACTIONS(948),
    [anon_sym_quote] = ACTIONS(948),
    [anon_sym_quoteTerm] = ACTIONS(948),
    [anon_sym_quoteContext] = ACTIONS(948),
    [anon_sym_unquote] = ACTIONS(948),
    [anon_sym_LPAREN_PIPE] = ACTIONS(968),
    [anon_sym_u2987] = ACTIONS(970),
    [anon_sym_let] = ACTIONS(972),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(974),
    [aux_sym_string_token1] = ACTIONS(974),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(976),
    [sym_PropN] = ACTIONS(948),
  },
  [504] = {
    [sym__FORALL] = STATE(8396),
    [sym__LAMBDA] = STATE(8031),
    [sym__ELLIPSIS] = STATE(4920),
    [sym__qid] = STATE(4920),
    [sym__binding_ids_and_absurds] = STATE(12357),
    [sym_attribute] = STATE(7725),
    [sym_attributes] = STATE(6200),
    [sym_expr] = STATE(12422),
    [sym__with_exprs] = STATE(10196),
    [sym__expr_or_attr] = STATE(4920),
    [sym__application] = STATE(9678),
    [sym__expr2_without_let] = STATE(9678),
    [sym__expr2] = STATE(9678),
    [sym_atom] = STATE(5202),
    [aux_sym__atoms] = STATE(3165),
    [sym__atom_curly] = STATE(4961),
    [sym__atom_no_curly] = STATE(4961),
    [sym_forall] = STATE(9678),
    [sym_let] = STATE(9678),
    [sym_lambda] = STATE(9678),
    [sym_lambda_extended_or_absurd] = STATE(9678),
    [sym_do] = STATE(9678),
    [sym_record_assignments] = STATE(4920),
    [sym_field_assignments] = STATE(4920),
    [aux_sym__typed_bindings] = STATE(8648),
    [sym_typed_binding] = STATE(8648),
    [sym_literal] = STATE(4920),
    [sym_SetN] = STATE(4920),
    [aux_sym__modal_arg_ids_repeat1] = STATE(7725),
    [aux_sym__with_exprs_repeat1] = STATE(3726),
    [sym_id] = ACTIONS(894),
    [anon_sym_forall] = ACTIONS(896),
    [anon_sym_u2200] = ACTIONS(896),
    [anon_sym_BSLASH] = ACTIONS(898),
    [anon_sym_u03bb] = ACTIONS(900),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(902),
    [anon_sym_u2026] = ACTIONS(902),
    [anon_sym_record] = ACTIONS(904),
    [anon_sym_LPAREN] = ACTIONS(906),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(908),
    [anon_sym_u2983] = ACTIONS(910),
    [anon_sym__] = ACTIONS(902),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(912),
    [anon_sym_RBRACE] = ACTIONS(1098),
    [aux_sym__qid_token1] = ACTIONS(916),
    [anon_sym_DOT] = ACTIONS(918),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(760),
    [anon_sym_quoteGoal] = ACTIONS(920),
    [anon_sym_tactic] = ACTIONS(922),
    [anon_sym_Prop] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(902),
    [anon_sym_quoteTerm] = ACTIONS(902),
    [anon_sym_quoteContext] = ACTIONS(902),
    [anon_sym_unquote] = ACTIONS(902),
    [anon_sym_LPAREN_PIPE] = ACTIONS(924),
    [anon_sym_u2987] = ACTIONS(926),
    [anon_sym_let] = ACTIONS(928),
    [anon_sym_do] = ACTIONS(724),
    [aux_sym_integer_token1] = ACTIONS(930),
    [aux_sym_string_token1] = ACTIONS(930),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(932),
    [sym_PropN] = ACTIONS(902),
  },
  [505] = {
    [sym__FORALL] = STATE(8369),
    [sym__LAMBDA] = STATE(8152),
    [sym__ELLIPSIS] = STATE(5168),
    [sym__qid] = STATE(5168),
    [sym__binding_ids_and_absurds] = STATE(12544),
    [sym_attribute] = STATE(5830),
    [sym_attributes] = STATE(3505),
    [sym_expr] = STATE(10578),
    [sym__with_exprs] = STATE(9861),
    [sym__expr_or_attr] = STATE(5168),
    [sym__application] = STATE(9444),
    [sym__expr2_without_let] = STATE(9444),
    [sym__expr2] = STATE(9444),
    [sym_atom] = STATE(5204),
    [aux_sym__atoms] = STATE(3133),
    [sym__atom_curly] = STATE(5180),
    [sym__atom_no_curly] = STATE(5180),
    [sym_forall] = STATE(9444),
    [sym_let] = STATE(9444),
    [sym_lambda] = STATE(9444),
    [sym_lambda_extended_or_absurd] = STATE(9444),
    [sym_do] = STATE(9444),
    [sym_record_assignments] = STATE(5168),
    [sym_field_assignments] = STATE(5168),
    [aux_sym__typed_bindings] = STATE(8654),
    [sym_typed_binding] = STATE(8654),
    [sym_literal] = STATE(5168),
    [sym_SetN] = STATE(5168),
    [aux_sym__modal_arg_ids_repeat1] = STATE(5830),
    [aux_sym__with_exprs_repeat1] = STATE(3754),
    [sym_id] = ACTIONS(850),
    [anon_sym_forall] = ACTIONS(852),
    [anon_sym_u2200] = ACTIONS(852),
    [anon_sym_BSLASH] = ACTIONS(854),
    [anon_sym_u03bb] = ACTIONS(856),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(858),
    [anon_sym_u2026] = ACTIONS(858),
    [anon_sym_record] = ACTIONS(860),
    [anon_sym_LPAREN] = ACTIONS(862),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(864),
    [anon_sym_u2983] = ACTIONS(866),
    [anon_sym_u2984] = ACTIONS(1050),
    [anon_sym__] = ACTIONS(858),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(870),
    [aux_sym__qid_token1] = ACTIONS(872),
    [anon_sym_DOT] = ACTIONS(874),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(712),
    [anon_sym_quoteGoal] = ACTIONS(878),
    [anon_sym_tactic] = ACTIONS(880),
    [anon_sym_Prop] = ACTIONS(858),
    [anon_sym_quote] = ACTIONS(858),
    [anon_sym_quoteTerm] = ACTIONS(858),
    [anon_sym_quoteContext] = ACTIONS(858),
    [anon_sym_unquote] = ACTIONS(858),
    [anon_sym_LPAREN_PIPE] = ACTIONS(882),
    [anon_sym_u2987] = ACTIONS(884),
    [anon_sym_let] = ACTIONS(886),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(890),
    [aux_sym_string_token1] = ACTIONS(890),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(892),
    [sym_PropN] = ACTIONS(858),
  },
  [506] = {
    [sym__FORALL] = STATE(8355),
    [sym__LAMBDA] = STATE(8054),
    [sym__ELLIPSIS] = STATE(4742),
    [sym__qid] = STATE(4742),
    [sym__binding_ids_and_absurds] = STATE(12547),
    [sym_attribute] = STATE(5830),
    [sym_attributes] = STATE(3506),
    [sym_expr] = STATE(10310),
    [sym__with_exprs] = STATE(10050),
    [sym__expr_or_attr] = STATE(4742),
    [sym__application] = STATE(9444),
    [sym__expr2_without_let] = STATE(9444),
    [sym__expr2] = STATE(9444),
    [sym_atom] = STATE(4712),
    [aux_sym__atoms] = STATE(3276),
    [sym__atom_curly] = STATE(4733),
    [sym__atom_no_curly] = STATE(4733),
    [sym_forall] = STATE(9444),
    [sym_let] = STATE(9444),
    [sym_lambda] = STATE(9444),
    [sym_lambda_extended_or_absurd] = STATE(9444),
    [sym_do] = STATE(9444),
    [sym_record_assignments] = STATE(4742),
    [sym_field_assignments] = STATE(4742),
    [aux_sym__typed_bindings] = STATE(8646),
    [sym_typed_binding] = STATE(8646),
    [sym_literal] = STATE(4742),
    [sym_SetN] = STATE(4742),
    [aux_sym__modal_arg_ids_repeat1] = STATE(5830),
    [aux_sym__with_exprs_repeat1] = STATE(3745),
    [sym_id] = ACTIONS(940),
    [anon_sym_forall] = ACTIONS(942),
    [anon_sym_u2200] = ACTIONS(942),
    [anon_sym_BSLASH] = ACTIONS(944),
    [anon_sym_u03bb] = ACTIONS(946),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(948),
    [anon_sym_u2026] = ACTIONS(948),
    [anon_sym_record] = ACTIONS(950),
    [anon_sym_LPAREN] = ACTIONS(952),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(954),
    [anon_sym_RBRACE_RBRACE] = ACTIONS(1092),
    [anon_sym_u2983] = ACTIONS(956),
    [anon_sym__] = ACTIONS(948),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(958),
    [aux_sym__qid_token1] = ACTIONS(960),
    [anon_sym_DOT] = ACTIONS(962),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(712),
    [anon_sym_quoteGoal] = ACTIONS(964),
    [anon_sym_tactic] = ACTIONS(966),
    [anon_sym_Prop] = ACTIONS(948),
    [anon_sym_quote] = ACTIONS(948),
    [anon_sym_quoteTerm] = ACTIONS(948),
    [anon_sym_quoteContext] = ACTIONS(948),
    [anon_sym_unquote] = ACTIONS(948),
    [anon_sym_LPAREN_PIPE] = ACTIONS(968),
    [anon_sym_u2987] = ACTIONS(970),
    [anon_sym_let] = ACTIONS(972),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(974),
    [aux_sym_string_token1] = ACTIONS(974),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(976),
    [sym_PropN] = ACTIONS(948),
  },
  [507] = {
    [sym__FORALL] = STATE(8396),
    [sym__LAMBDA] = STATE(8031),
    [sym__ELLIPSIS] = STATE(4920),
    [sym__qid] = STATE(4920),
    [sym__binding_ids_and_absurds] = STATE(12539),
    [sym_attribute] = STATE(5830),
    [sym_attributes] = STATE(3504),
    [sym_expr] = STATE(11467),
    [sym__with_exprs] = STATE(10196),
    [sym__expr_or_attr] = STATE(4920),
    [sym__application] = STATE(9678),
    [sym__expr2_without_let] = STATE(9678),
    [sym__expr2] = STATE(9678),
    [sym_atom] = STATE(5202),
    [aux_sym__atoms] = STATE(3165),
    [sym__atom_curly] = STATE(4961),
    [sym__atom_no_curly] = STATE(4961),
    [sym_forall] = STATE(9678),
    [sym_let] = STATE(9678),
    [sym_lambda] = STATE(9678),
    [sym_lambda_extended_or_absurd] = STATE(9678),
    [sym_do] = STATE(9678),
    [sym_record_assignments] = STATE(4920),
    [sym_field_assignments] = STATE(4920),
    [aux_sym__typed_bindings] = STATE(8648),
    [sym_typed_binding] = STATE(8648),
    [sym_literal] = STATE(4920),
    [sym_SetN] = STATE(4920),
    [aux_sym__modal_arg_ids_repeat1] = STATE(5830),
    [aux_sym__with_exprs_repeat1] = STATE(3726),
    [sym_id] = ACTIONS(894),
    [anon_sym_forall] = ACTIONS(896),
    [anon_sym_u2200] = ACTIONS(896),
    [anon_sym_BSLASH] = ACTIONS(898),
    [anon_sym_u03bb] = ACTIONS(900),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(902),
    [anon_sym_u2026] = ACTIONS(902),
    [anon_sym_record] = ACTIONS(904),
    [anon_sym_LPAREN] = ACTIONS(906),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(908),
    [anon_sym_u2983] = ACTIONS(910),
    [anon_sym__] = ACTIONS(902),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(912),
    [anon_sym_RBRACE] = ACTIONS(1094),
    [aux_sym__qid_token1] = ACTIONS(916),
    [anon_sym_DOT] = ACTIONS(918),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(712),
    [anon_sym_quoteGoal] = ACTIONS(920),
    [anon_sym_tactic] = ACTIONS(922),
    [anon_sym_Prop] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(902),
    [anon_sym_quoteTerm] = ACTIONS(902),
    [anon_sym_quoteContext] = ACTIONS(902),
    [anon_sym_unquote] = ACTIONS(902),
    [anon_sym_LPAREN_PIPE] = ACTIONS(924),
    [anon_sym_u2987] = ACTIONS(926),
    [anon_sym_let] = ACTIONS(928),
    [anon_sym_do] = ACTIONS(724),
    [aux_sym_integer_token1] = ACTIONS(930),
    [aux_sym_string_token1] = ACTIONS(930),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(932),
    [sym_PropN] = ACTIONS(902),
  },
  [508] = {
    [sym__FORALL] = STATE(8369),
    [sym__LAMBDA] = STATE(8152),
    [sym__ELLIPSIS] = STATE(5168),
    [sym__qid] = STATE(5168),
    [sym__binding_ids_and_absurds] = STATE(12544),
    [sym_attribute] = STATE(5830),
    [sym_attributes] = STATE(3505),
    [sym_expr] = STATE(11433),
    [sym__with_exprs] = STATE(9861),
    [sym__expr_or_attr] = STATE(5168),
    [sym__application] = STATE(9444),
    [sym__expr2_without_let] = STATE(9444),
    [sym__expr2] = STATE(9444),
    [sym_atom] = STATE(5204),
    [aux_sym__atoms] = STATE(3133),
    [sym__atom_curly] = STATE(5180),
    [sym__atom_no_curly] = STATE(5180),
    [sym_forall] = STATE(9444),
    [sym_let] = STATE(9444),
    [sym_lambda] = STATE(9444),
    [sym_lambda_extended_or_absurd] = STATE(9444),
    [sym_do] = STATE(9444),
    [sym_record_assignments] = STATE(5168),
    [sym_field_assignments] = STATE(5168),
    [aux_sym__typed_bindings] = STATE(8654),
    [sym_typed_binding] = STATE(8654),
    [sym_literal] = STATE(5168),
    [sym_SetN] = STATE(5168),
    [aux_sym__modal_arg_ids_repeat1] = STATE(5830),
    [aux_sym__with_exprs_repeat1] = STATE(3754),
    [sym_id] = ACTIONS(850),
    [anon_sym_forall] = ACTIONS(852),
    [anon_sym_u2200] = ACTIONS(852),
    [anon_sym_BSLASH] = ACTIONS(854),
    [anon_sym_u03bb] = ACTIONS(856),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(858),
    [anon_sym_u2026] = ACTIONS(858),
    [anon_sym_record] = ACTIONS(860),
    [anon_sym_LPAREN] = ACTIONS(862),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(864),
    [anon_sym_u2983] = ACTIONS(866),
    [anon_sym_u2984] = ACTIONS(1096),
    [anon_sym__] = ACTIONS(858),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(870),
    [aux_sym__qid_token1] = ACTIONS(872),
    [anon_sym_DOT] = ACTIONS(874),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(712),
    [anon_sym_quoteGoal] = ACTIONS(878),
    [anon_sym_tactic] = ACTIONS(880),
    [anon_sym_Prop] = ACTIONS(858),
    [anon_sym_quote] = ACTIONS(858),
    [anon_sym_quoteTerm] = ACTIONS(858),
    [anon_sym_quoteContext] = ACTIONS(858),
    [anon_sym_unquote] = ACTIONS(858),
    [anon_sym_LPAREN_PIPE] = ACTIONS(882),
    [anon_sym_u2987] = ACTIONS(884),
    [anon_sym_let] = ACTIONS(886),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(890),
    [aux_sym_string_token1] = ACTIONS(890),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(892),
    [sym_PropN] = ACTIONS(858),
  },
  [509] = {
    [sym__FORALL] = STATE(8355),
    [sym__LAMBDA] = STATE(8054),
    [sym__ELLIPSIS] = STATE(4742),
    [sym__qid] = STATE(4742),
    [sym__binding_ids_and_absurds] = STATE(12547),
    [sym_attribute] = STATE(5830),
    [sym_attributes] = STATE(3506),
    [sym_expr] = STATE(11434),
    [sym__with_exprs] = STATE(10050),
    [sym__expr_or_attr] = STATE(4742),
    [sym__application] = STATE(9444),
    [sym__expr2_without_let] = STATE(9444),
    [sym__expr2] = STATE(9444),
    [sym_atom] = STATE(4712),
    [aux_sym__atoms] = STATE(3276),
    [sym__atom_curly] = STATE(4733),
    [sym__atom_no_curly] = STATE(4733),
    [sym_forall] = STATE(9444),
    [sym_let] = STATE(9444),
    [sym_lambda] = STATE(9444),
    [sym_lambda_extended_or_absurd] = STATE(9444),
    [sym_do] = STATE(9444),
    [sym_record_assignments] = STATE(4742),
    [sym_field_assignments] = STATE(4742),
    [aux_sym__typed_bindings] = STATE(8646),
    [sym_typed_binding] = STATE(8646),
    [sym_literal] = STATE(4742),
    [sym_SetN] = STATE(4742),
    [aux_sym__modal_arg_ids_repeat1] = STATE(5830),
    [aux_sym__with_exprs_repeat1] = STATE(3745),
    [sym_id] = ACTIONS(940),
    [anon_sym_forall] = ACTIONS(942),
    [anon_sym_u2200] = ACTIONS(942),
    [anon_sym_BSLASH] = ACTIONS(944),
    [anon_sym_u03bb] = ACTIONS(946),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(948),
    [anon_sym_u2026] = ACTIONS(948),
    [anon_sym_record] = ACTIONS(950),
    [anon_sym_LPAREN] = ACTIONS(952),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(954),
    [anon_sym_RBRACE_RBRACE] = ACTIONS(1096),
    [anon_sym_u2983] = ACTIONS(956),
    [anon_sym__] = ACTIONS(948),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(958),
    [aux_sym__qid_token1] = ACTIONS(960),
    [anon_sym_DOT] = ACTIONS(962),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(712),
    [anon_sym_quoteGoal] = ACTIONS(964),
    [anon_sym_tactic] = ACTIONS(966),
    [anon_sym_Prop] = ACTIONS(948),
    [anon_sym_quote] = ACTIONS(948),
    [anon_sym_quoteTerm] = ACTIONS(948),
    [anon_sym_quoteContext] = ACTIONS(948),
    [anon_sym_unquote] = ACTIONS(948),
    [anon_sym_LPAREN_PIPE] = ACTIONS(968),
    [anon_sym_u2987] = ACTIONS(970),
    [anon_sym_let] = ACTIONS(972),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(974),
    [aux_sym_string_token1] = ACTIONS(974),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(976),
    [sym_PropN] = ACTIONS(948),
  },
  [510] = {
    [sym__FORALL] = STATE(8345),
    [sym__LAMBDA] = STATE(8095),
    [sym__ELLIPSIS] = STATE(4742),
    [sym_open] = STATE(12555),
    [sym__qid] = STATE(4742),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3873),
    [sym_expr] = STATE(11435),
    [sym__with_exprs] = STATE(10084),
    [sym__expr_or_attr] = STATE(4742),
    [sym__application] = STATE(9680),
    [sym__expr2_without_let] = STATE(9680),
    [sym__expr2] = STATE(9680),
    [sym_atom] = STATE(4712),
    [aux_sym__atoms] = STATE(3211),
    [sym__atom_curly] = STATE(4733),
    [sym__atom_no_curly] = STATE(4733),
    [sym_forall] = STATE(9680),
    [sym_let] = STATE(9680),
    [sym_lambda] = STATE(9680),
    [sym_lambda_extended_or_absurd] = STATE(9680),
    [sym_do] = STATE(9680),
    [sym_record_assignments] = STATE(4742),
    [sym_field_assignments] = STATE(4742),
    [aux_sym__typed_bindings] = STATE(8642),
    [sym_typed_binding] = STATE(8642),
    [sym_literal] = STATE(4742),
    [sym_SetN] = STATE(4742),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3728),
    [sym_id] = ACTIONS(940),
    [anon_sym_forall] = ACTIONS(980),
    [anon_sym_u2200] = ACTIONS(980),
    [anon_sym_BSLASH] = ACTIONS(982),
    [anon_sym_u03bb] = ACTIONS(984),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(948),
    [anon_sym_u2026] = ACTIONS(948),
    [anon_sym_record] = ACTIONS(950),
    [anon_sym_open] = ACTIONS(986),
    [anon_sym_LPAREN] = ACTIONS(952),
    [anon_sym_RPAREN] = ACTIONS(1096),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(954),
    [anon_sym_u2983] = ACTIONS(956),
    [anon_sym__] = ACTIONS(948),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(958),
    [aux_sym__qid_token1] = ACTIONS(960),
    [anon_sym_DOT] = ACTIONS(962),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(988),
    [anon_sym_tactic] = ACTIONS(990),
    [anon_sym_Prop] = ACTIONS(948),
    [anon_sym_quote] = ACTIONS(948),
    [anon_sym_quoteTerm] = ACTIONS(948),
    [anon_sym_quoteContext] = ACTIONS(948),
    [anon_sym_unquote] = ACTIONS(948),
    [anon_sym_LPAREN_PIPE] = ACTIONS(968),
    [anon_sym_u2987] = ACTIONS(970),
    [anon_sym_let] = ACTIONS(992),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(974),
    [aux_sym_string_token1] = ACTIONS(974),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(976),
    [sym_PropN] = ACTIONS(948),
  },
  [511] = {
    [sym__FORALL] = STATE(8369),
    [sym__LAMBDA] = STATE(8152),
    [sym__ELLIPSIS] = STATE(5168),
    [sym__qid] = STATE(5168),
    [sym__binding_ids_and_absurds] = STATE(12544),
    [sym_attribute] = STATE(5830),
    [sym_attributes] = STATE(3505),
    [sym_expr] = STATE(10309),
    [sym__with_exprs] = STATE(9861),
    [sym__expr_or_attr] = STATE(5168),
    [sym__application] = STATE(9444),
    [sym__expr2_without_let] = STATE(9444),
    [sym__expr2] = STATE(9444),
    [sym_atom] = STATE(5204),
    [aux_sym__atoms] = STATE(3133),
    [sym__atom_curly] = STATE(5180),
    [sym__atom_no_curly] = STATE(5180),
    [sym_forall] = STATE(9444),
    [sym_let] = STATE(9444),
    [sym_lambda] = STATE(9444),
    [sym_lambda_extended_or_absurd] = STATE(9444),
    [sym_do] = STATE(9444),
    [sym_record_assignments] = STATE(5168),
    [sym_field_assignments] = STATE(5168),
    [aux_sym__typed_bindings] = STATE(8654),
    [sym_typed_binding] = STATE(8654),
    [sym_literal] = STATE(5168),
    [sym_SetN] = STATE(5168),
    [aux_sym__modal_arg_ids_repeat1] = STATE(5830),
    [aux_sym__with_exprs_repeat1] = STATE(3754),
    [sym_id] = ACTIONS(850),
    [anon_sym_forall] = ACTIONS(852),
    [anon_sym_u2200] = ACTIONS(852),
    [anon_sym_BSLASH] = ACTIONS(854),
    [anon_sym_u03bb] = ACTIONS(856),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(858),
    [anon_sym_u2026] = ACTIONS(858),
    [anon_sym_record] = ACTIONS(860),
    [anon_sym_LPAREN] = ACTIONS(862),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(864),
    [anon_sym_u2983] = ACTIONS(866),
    [anon_sym_u2984] = ACTIONS(1092),
    [anon_sym__] = ACTIONS(858),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(870),
    [aux_sym__qid_token1] = ACTIONS(872),
    [anon_sym_DOT] = ACTIONS(874),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(712),
    [anon_sym_quoteGoal] = ACTIONS(878),
    [anon_sym_tactic] = ACTIONS(880),
    [anon_sym_Prop] = ACTIONS(858),
    [anon_sym_quote] = ACTIONS(858),
    [anon_sym_quoteTerm] = ACTIONS(858),
    [anon_sym_quoteContext] = ACTIONS(858),
    [anon_sym_unquote] = ACTIONS(858),
    [anon_sym_LPAREN_PIPE] = ACTIONS(882),
    [anon_sym_u2987] = ACTIONS(884),
    [anon_sym_let] = ACTIONS(886),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(890),
    [aux_sym_string_token1] = ACTIONS(890),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(892),
    [sym_PropN] = ACTIONS(858),
  },
  [512] = {
    [sym__FORALL] = STATE(8396),
    [sym__LAMBDA] = STATE(8031),
    [sym__ELLIPSIS] = STATE(4920),
    [sym__qid] = STATE(4920),
    [sym__binding_ids_and_absurds] = STATE(12539),
    [sym_attribute] = STATE(5830),
    [sym_attributes] = STATE(3504),
    [sym_expr] = STATE(10344),
    [sym__with_exprs] = STATE(10196),
    [sym__expr_or_attr] = STATE(4920),
    [sym__application] = STATE(9678),
    [sym__expr2_without_let] = STATE(9678),
    [sym__expr2] = STATE(9678),
    [sym_atom] = STATE(5202),
    [aux_sym__atoms] = STATE(3165),
    [sym__atom_curly] = STATE(4961),
    [sym__atom_no_curly] = STATE(4961),
    [sym_forall] = STATE(9678),
    [sym_let] = STATE(9678),
    [sym_lambda] = STATE(9678),
    [sym_lambda_extended_or_absurd] = STATE(9678),
    [sym_do] = STATE(9678),
    [sym_record_assignments] = STATE(4920),
    [sym_field_assignments] = STATE(4920),
    [aux_sym__typed_bindings] = STATE(8648),
    [sym_typed_binding] = STATE(8648),
    [sym_literal] = STATE(4920),
    [sym_SetN] = STATE(4920),
    [aux_sym__modal_arg_ids_repeat1] = STATE(5830),
    [aux_sym__with_exprs_repeat1] = STATE(3726),
    [sym_id] = ACTIONS(894),
    [anon_sym_forall] = ACTIONS(896),
    [anon_sym_u2200] = ACTIONS(896),
    [anon_sym_BSLASH] = ACTIONS(898),
    [anon_sym_u03bb] = ACTIONS(900),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(902),
    [anon_sym_u2026] = ACTIONS(902),
    [anon_sym_record] = ACTIONS(904),
    [anon_sym_LPAREN] = ACTIONS(906),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(908),
    [anon_sym_u2983] = ACTIONS(910),
    [anon_sym__] = ACTIONS(902),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(912),
    [anon_sym_RBRACE] = ACTIONS(1100),
    [aux_sym__qid_token1] = ACTIONS(916),
    [anon_sym_DOT] = ACTIONS(918),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(712),
    [anon_sym_quoteGoal] = ACTIONS(920),
    [anon_sym_tactic] = ACTIONS(922),
    [anon_sym_Prop] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(902),
    [anon_sym_quoteTerm] = ACTIONS(902),
    [anon_sym_quoteContext] = ACTIONS(902),
    [anon_sym_unquote] = ACTIONS(902),
    [anon_sym_LPAREN_PIPE] = ACTIONS(924),
    [anon_sym_u2987] = ACTIONS(926),
    [anon_sym_let] = ACTIONS(928),
    [anon_sym_do] = ACTIONS(724),
    [aux_sym_integer_token1] = ACTIONS(930),
    [aux_sym_string_token1] = ACTIONS(930),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(932),
    [sym_PropN] = ACTIONS(902),
  },
  [513] = {
    [sym__record_directive] = STATE(12259),
    [sym_record_constructor] = STATE(12259),
    [sym_record_constructor_instance] = STATE(12259),
    [sym_record_induction] = STATE(12259),
    [sym_record_eta] = STATE(12259),
    [aux_sym_record_declarations_block_repeat1] = STATE(513),
    [sym_id] = ACTIONS(1102),
    [anon_sym_forall] = ACTIONS(1102),
    [anon_sym_u2200] = ACTIONS(1102),
    [anon_sym_BSLASH] = ACTIONS(1104),
    [anon_sym_u03bb] = ACTIONS(1102),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1102),
    [anon_sym_u2026] = ACTIONS(1102),
    [anon_sym_field] = ACTIONS(1102),
    [anon_sym_instance] = ACTIONS(1106),
    [anon_sym_module] = ACTIONS(1102),
    [anon_sym_data] = ACTIONS(1102),
    [anon_sym_codata] = ACTIONS(1102),
    [anon_sym_record] = ACTIONS(1102),
    [anon_sym_constructor] = ACTIONS(1109),
    [anon_sym_inductive] = ACTIONS(1112),
    [anon_sym_coinductive] = ACTIONS(1112),
    [anon_sym_eta_DASHequality] = ACTIONS(1115),
    [anon_sym_no_DASHeta_DASHequality] = ACTIONS(1115),
    [anon_sym_infix] = ACTIONS(1102),
    [anon_sym_infixl] = ACTIONS(1102),
    [anon_sym_infixr] = ACTIONS(1102),
    [anon_sym_variable] = ACTIONS(1102),
    [anon_sym_mutual] = ACTIONS(1102),
    [anon_sym_abstract] = ACTIONS(1102),
    [anon_sym_private] = ACTIONS(1102),
    [anon_sym_macro] = ACTIONS(1102),
    [anon_sym_postulate] = ACTIONS(1102),
    [anon_sym_primitive] = ACTIONS(1102),
    [anon_sym_open] = ACTIONS(1102),
    [anon_sym_import] = ACTIONS(1102),
    [anon_sym_LPAREN] = ACTIONS(1102),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(1102),
    [anon_sym_u2983] = ACTIONS(1102),
    [anon_sym__] = ACTIONS(1102),
    [sym_pragma] = ACTIONS(1102),
    [anon_sym_syntax] = ACTIONS(1102),
    [anon_sym_LBRACE] = ACTIONS(1102),
    [anon_sym_pattern] = ACTIONS(1102),
    [anon_sym_unquoteDecl] = ACTIONS(1102),
    [anon_sym_unquoteDef] = ACTIONS(1102),
    [aux_sym__qid_token1] = ACTIONS(1102),
    [anon_sym_DOT] = ACTIONS(1102),
    [anon_sym_AT] = ACTIONS(1102),
    [anon_sym_quoteGoal] = ACTIONS(1102),
    [anon_sym_tactic] = ACTIONS(1102),
    [anon_sym_Prop] = ACTIONS(1102),
    [anon_sym_quote] = ACTIONS(1102),
    [anon_sym_quoteTerm] = ACTIONS(1102),
    [anon_sym_quoteContext] = ACTIONS(1102),
    [anon_sym_unquote] = ACTIONS(1102),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1102),
    [anon_sym_u2987] = ACTIONS(1102),
    [anon_sym_let] = ACTIONS(1102),
    [anon_sym_do] = ACTIONS(1102),
    [aux_sym_integer_token1] = ACTIONS(1102),
    [aux_sym_string_token1] = ACTIONS(1102),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(1102),
    [sym_PropN] = ACTIONS(1102),
    [sym__dedent] = ACTIONS(1104),
  },
  [514] = {
    [sym__FORALL] = STATE(8369),
    [sym__LAMBDA] = STATE(8152),
    [sym__ELLIPSIS] = STATE(5168),
    [sym__qid] = STATE(5168),
    [sym__binding_ids_and_absurds] = STATE(12358),
    [sym_attribute] = STATE(7725),
    [sym_attributes] = STATE(6182),
    [sym_expr] = STATE(12421),
    [sym__with_exprs] = STATE(9861),
    [sym__expr_or_attr] = STATE(5168),
    [sym__application] = STATE(9444),
    [sym__expr2_without_let] = STATE(9444),
    [sym__expr2] = STATE(9444),
    [sym_atom] = STATE(5204),
    [aux_sym__atoms] = STATE(3133),
    [sym__atom_curly] = STATE(5180),
    [sym__atom_no_curly] = STATE(5180),
    [sym_forall] = STATE(9444),
    [sym_let] = STATE(9444),
    [sym_lambda] = STATE(9444),
    [sym_lambda_extended_or_absurd] = STATE(9444),
    [sym_do] = STATE(9444),
    [sym_record_assignments] = STATE(5168),
    [sym_field_assignments] = STATE(5168),
    [aux_sym__typed_bindings] = STATE(8654),
    [sym_typed_binding] = STATE(8654),
    [sym_literal] = STATE(5168),
    [sym_SetN] = STATE(5168),
    [aux_sym__modal_arg_ids_repeat1] = STATE(7725),
    [aux_sym__with_exprs_repeat1] = STATE(3754),
    [sym_id] = ACTIONS(850),
    [anon_sym_forall] = ACTIONS(852),
    [anon_sym_u2200] = ACTIONS(852),
    [anon_sym_BSLASH] = ACTIONS(854),
    [anon_sym_u03bb] = ACTIONS(856),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(858),
    [anon_sym_u2026] = ACTIONS(858),
    [anon_sym_record] = ACTIONS(860),
    [anon_sym_LPAREN] = ACTIONS(862),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(864),
    [anon_sym_u2983] = ACTIONS(866),
    [anon_sym_u2984] = ACTIONS(1118),
    [anon_sym__] = ACTIONS(858),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(870),
    [aux_sym__qid_token1] = ACTIONS(872),
    [anon_sym_DOT] = ACTIONS(874),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(760),
    [anon_sym_quoteGoal] = ACTIONS(878),
    [anon_sym_tactic] = ACTIONS(880),
    [anon_sym_Prop] = ACTIONS(858),
    [anon_sym_quote] = ACTIONS(858),
    [anon_sym_quoteTerm] = ACTIONS(858),
    [anon_sym_quoteContext] = ACTIONS(858),
    [anon_sym_unquote] = ACTIONS(858),
    [anon_sym_LPAREN_PIPE] = ACTIONS(882),
    [anon_sym_u2987] = ACTIONS(884),
    [anon_sym_let] = ACTIONS(886),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(890),
    [aux_sym_string_token1] = ACTIONS(890),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(892),
    [sym_PropN] = ACTIONS(858),
  },
  [515] = {
    [sym__FORALL] = STATE(8355),
    [sym__LAMBDA] = STATE(8054),
    [sym__ELLIPSIS] = STATE(4742),
    [sym__qid] = STATE(4742),
    [sym__binding_ids_and_absurds] = STATE(12547),
    [sym_attribute] = STATE(5830),
    [sym_attributes] = STATE(3506),
    [sym_expr] = STATE(10579),
    [sym__with_exprs] = STATE(10050),
    [sym__expr_or_attr] = STATE(4742),
    [sym__application] = STATE(9444),
    [sym__expr2_without_let] = STATE(9444),
    [sym__expr2] = STATE(9444),
    [sym_atom] = STATE(4712),
    [aux_sym__atoms] = STATE(3276),
    [sym__atom_curly] = STATE(4733),
    [sym__atom_no_curly] = STATE(4733),
    [sym_forall] = STATE(9444),
    [sym_let] = STATE(9444),
    [sym_lambda] = STATE(9444),
    [sym_lambda_extended_or_absurd] = STATE(9444),
    [sym_do] = STATE(9444),
    [sym_record_assignments] = STATE(4742),
    [sym_field_assignments] = STATE(4742),
    [aux_sym__typed_bindings] = STATE(8646),
    [sym_typed_binding] = STATE(8646),
    [sym_literal] = STATE(4742),
    [sym_SetN] = STATE(4742),
    [aux_sym__modal_arg_ids_repeat1] = STATE(5830),
    [aux_sym__with_exprs_repeat1] = STATE(3745),
    [sym_id] = ACTIONS(940),
    [anon_sym_forall] = ACTIONS(942),
    [anon_sym_u2200] = ACTIONS(942),
    [anon_sym_BSLASH] = ACTIONS(944),
    [anon_sym_u03bb] = ACTIONS(946),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(948),
    [anon_sym_u2026] = ACTIONS(948),
    [anon_sym_record] = ACTIONS(950),
    [anon_sym_LPAREN] = ACTIONS(952),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(954),
    [anon_sym_RBRACE_RBRACE] = ACTIONS(1050),
    [anon_sym_u2983] = ACTIONS(956),
    [anon_sym__] = ACTIONS(948),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(958),
    [aux_sym__qid_token1] = ACTIONS(960),
    [anon_sym_DOT] = ACTIONS(962),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(712),
    [anon_sym_quoteGoal] = ACTIONS(964),
    [anon_sym_tactic] = ACTIONS(966),
    [anon_sym_Prop] = ACTIONS(948),
    [anon_sym_quote] = ACTIONS(948),
    [anon_sym_quoteTerm] = ACTIONS(948),
    [anon_sym_quoteContext] = ACTIONS(948),
    [anon_sym_unquote] = ACTIONS(948),
    [anon_sym_LPAREN_PIPE] = ACTIONS(968),
    [anon_sym_u2987] = ACTIONS(970),
    [anon_sym_let] = ACTIONS(972),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(974),
    [aux_sym_string_token1] = ACTIONS(974),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(976),
    [sym_PropN] = ACTIONS(948),
  },
  [516] = {
    [sym__FORALL] = STATE(8345),
    [sym__LAMBDA] = STATE(8095),
    [sym__ELLIPSIS] = STATE(4742),
    [sym_open] = STATE(12555),
    [sym__qid] = STATE(4742),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3873),
    [sym_expr] = STATE(11513),
    [sym__with_exprs] = STATE(10084),
    [sym__expr_or_attr] = STATE(4742),
    [sym__application] = STATE(9680),
    [sym__expr2_without_let] = STATE(9680),
    [sym__expr2] = STATE(9680),
    [sym_atom] = STATE(4712),
    [aux_sym__atoms] = STATE(3211),
    [sym__atom_curly] = STATE(4733),
    [sym__atom_no_curly] = STATE(4733),
    [sym_forall] = STATE(9680),
    [sym_let] = STATE(9680),
    [sym_lambda] = STATE(9680),
    [sym_lambda_extended_or_absurd] = STATE(9680),
    [sym_do] = STATE(9680),
    [sym_record_assignments] = STATE(4742),
    [sym_field_assignments] = STATE(4742),
    [aux_sym__typed_bindings] = STATE(8642),
    [sym_typed_binding] = STATE(8642),
    [sym_literal] = STATE(4742),
    [sym_SetN] = STATE(4742),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3728),
    [sym_id] = ACTIONS(940),
    [anon_sym_forall] = ACTIONS(980),
    [anon_sym_u2200] = ACTIONS(980),
    [anon_sym_BSLASH] = ACTIONS(982),
    [anon_sym_u03bb] = ACTIONS(984),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(948),
    [anon_sym_u2026] = ACTIONS(948),
    [anon_sym_record] = ACTIONS(950),
    [anon_sym_open] = ACTIONS(986),
    [anon_sym_LPAREN] = ACTIONS(952),
    [anon_sym_RPAREN] = ACTIONS(1074),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(954),
    [anon_sym_u2983] = ACTIONS(956),
    [anon_sym__] = ACTIONS(948),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(958),
    [aux_sym__qid_token1] = ACTIONS(960),
    [anon_sym_DOT] = ACTIONS(962),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(988),
    [anon_sym_tactic] = ACTIONS(990),
    [anon_sym_Prop] = ACTIONS(948),
    [anon_sym_quote] = ACTIONS(948),
    [anon_sym_quoteTerm] = ACTIONS(948),
    [anon_sym_quoteContext] = ACTIONS(948),
    [anon_sym_unquote] = ACTIONS(948),
    [anon_sym_LPAREN_PIPE] = ACTIONS(968),
    [anon_sym_u2987] = ACTIONS(970),
    [anon_sym_let] = ACTIONS(992),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(974),
    [aux_sym_string_token1] = ACTIONS(974),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(976),
    [sym_PropN] = ACTIONS(948),
  },
  [517] = {
    [sym__FORALL] = STATE(8396),
    [sym__LAMBDA] = STATE(8031),
    [sym__ELLIPSIS] = STATE(4920),
    [sym__qid] = STATE(4920),
    [sym__binding_ids_and_absurds] = STATE(12357),
    [sym_attribute] = STATE(7725),
    [sym_attributes] = STATE(6200),
    [sym_expr] = STATE(11577),
    [sym__with_exprs] = STATE(10196),
    [sym__expr_or_attr] = STATE(4920),
    [sym__application] = STATE(9678),
    [sym__expr2_without_let] = STATE(9678),
    [sym__expr2] = STATE(9678),
    [sym_atom] = STATE(5202),
    [aux_sym__atoms] = STATE(3165),
    [sym__atom_curly] = STATE(4961),
    [sym__atom_no_curly] = STATE(4961),
    [sym_forall] = STATE(9678),
    [sym_let] = STATE(9678),
    [sym_lambda] = STATE(9678),
    [sym_lambda_extended_or_absurd] = STATE(9678),
    [sym_do] = STATE(9678),
    [sym_record_assignments] = STATE(4920),
    [sym_field_assignments] = STATE(4920),
    [aux_sym__typed_bindings] = STATE(8648),
    [sym_typed_binding] = STATE(8648),
    [sym_literal] = STATE(4920),
    [sym_SetN] = STATE(4920),
    [aux_sym__modal_arg_ids_repeat1] = STATE(7725),
    [aux_sym__with_exprs_repeat1] = STATE(3726),
    [sym_id] = ACTIONS(894),
    [anon_sym_forall] = ACTIONS(896),
    [anon_sym_u2200] = ACTIONS(896),
    [anon_sym_BSLASH] = ACTIONS(898),
    [anon_sym_u03bb] = ACTIONS(900),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(902),
    [anon_sym_u2026] = ACTIONS(902),
    [anon_sym_record] = ACTIONS(904),
    [anon_sym_LPAREN] = ACTIONS(906),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(908),
    [anon_sym_u2983] = ACTIONS(910),
    [anon_sym__] = ACTIONS(902),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(912),
    [anon_sym_RBRACE] = ACTIONS(1120),
    [aux_sym__qid_token1] = ACTIONS(916),
    [anon_sym_DOT] = ACTIONS(918),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(760),
    [anon_sym_quoteGoal] = ACTIONS(920),
    [anon_sym_tactic] = ACTIONS(922),
    [anon_sym_Prop] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(902),
    [anon_sym_quoteTerm] = ACTIONS(902),
    [anon_sym_quoteContext] = ACTIONS(902),
    [anon_sym_unquote] = ACTIONS(902),
    [anon_sym_LPAREN_PIPE] = ACTIONS(924),
    [anon_sym_u2987] = ACTIONS(926),
    [anon_sym_let] = ACTIONS(928),
    [anon_sym_do] = ACTIONS(724),
    [aux_sym_integer_token1] = ACTIONS(930),
    [aux_sym_string_token1] = ACTIONS(930),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(932),
    [sym_PropN] = ACTIONS(902),
  },
  [518] = {
    [sym__FORALL] = STATE(8345),
    [sym__LAMBDA] = STATE(8095),
    [sym__ELLIPSIS] = STATE(4742),
    [sym_open] = STATE(12555),
    [sym__qid] = STATE(4742),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3873),
    [sym_expr] = STATE(11968),
    [sym__with_exprs] = STATE(10084),
    [sym__expr_or_attr] = STATE(4742),
    [sym__application] = STATE(9680),
    [sym__expr2_without_let] = STATE(9680),
    [sym__expr2] = STATE(9680),
    [sym_atom] = STATE(4712),
    [aux_sym__atoms] = STATE(3211),
    [sym__atom_curly] = STATE(4733),
    [sym__atom_no_curly] = STATE(4733),
    [sym_forall] = STATE(9680),
    [sym_let] = STATE(9680),
    [sym_lambda] = STATE(9680),
    [sym_lambda_extended_or_absurd] = STATE(9680),
    [sym_do] = STATE(9680),
    [sym_record_assignments] = STATE(4742),
    [sym_field_assignments] = STATE(4742),
    [aux_sym__typed_bindings] = STATE(8642),
    [sym_typed_binding] = STATE(8642),
    [sym_literal] = STATE(4742),
    [sym_SetN] = STATE(4742),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3728),
    [sym_id] = ACTIONS(940),
    [anon_sym_forall] = ACTIONS(980),
    [anon_sym_u2200] = ACTIONS(980),
    [anon_sym_BSLASH] = ACTIONS(982),
    [anon_sym_u03bb] = ACTIONS(984),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(948),
    [anon_sym_u2026] = ACTIONS(948),
    [anon_sym_record] = ACTIONS(950),
    [anon_sym_open] = ACTIONS(986),
    [anon_sym_LPAREN] = ACTIONS(952),
    [anon_sym_RPAREN] = ACTIONS(1122),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(954),
    [anon_sym_u2983] = ACTIONS(956),
    [anon_sym__] = ACTIONS(948),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(958),
    [aux_sym__qid_token1] = ACTIONS(960),
    [anon_sym_DOT] = ACTIONS(962),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(988),
    [anon_sym_tactic] = ACTIONS(990),
    [anon_sym_Prop] = ACTIONS(948),
    [anon_sym_quote] = ACTIONS(948),
    [anon_sym_quoteTerm] = ACTIONS(948),
    [anon_sym_quoteContext] = ACTIONS(948),
    [anon_sym_unquote] = ACTIONS(948),
    [anon_sym_LPAREN_PIPE] = ACTIONS(968),
    [anon_sym_u2987] = ACTIONS(970),
    [anon_sym_let] = ACTIONS(992),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(974),
    [aux_sym_string_token1] = ACTIONS(974),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(976),
    [sym_PropN] = ACTIONS(948),
  },
  [519] = {
    [sym__FORALL] = STATE(8369),
    [sym__LAMBDA] = STATE(8152),
    [sym__ELLIPSIS] = STATE(5168),
    [sym__qid] = STATE(5168),
    [sym__binding_ids_and_absurds] = STATE(12358),
    [sym_attribute] = STATE(7725),
    [sym_attributes] = STATE(6182),
    [sym_expr] = STATE(11578),
    [sym__with_exprs] = STATE(9861),
    [sym__expr_or_attr] = STATE(5168),
    [sym__application] = STATE(9444),
    [sym__expr2_without_let] = STATE(9444),
    [sym__expr2] = STATE(9444),
    [sym_atom] = STATE(5204),
    [aux_sym__atoms] = STATE(3133),
    [sym__atom_curly] = STATE(5180),
    [sym__atom_no_curly] = STATE(5180),
    [sym_forall] = STATE(9444),
    [sym_let] = STATE(9444),
    [sym_lambda] = STATE(9444),
    [sym_lambda_extended_or_absurd] = STATE(9444),
    [sym_do] = STATE(9444),
    [sym_record_assignments] = STATE(5168),
    [sym_field_assignments] = STATE(5168),
    [aux_sym__typed_bindings] = STATE(8654),
    [sym_typed_binding] = STATE(8654),
    [sym_literal] = STATE(5168),
    [sym_SetN] = STATE(5168),
    [aux_sym__modal_arg_ids_repeat1] = STATE(7725),
    [aux_sym__with_exprs_repeat1] = STATE(3754),
    [sym_id] = ACTIONS(850),
    [anon_sym_forall] = ACTIONS(852),
    [anon_sym_u2200] = ACTIONS(852),
    [anon_sym_BSLASH] = ACTIONS(854),
    [anon_sym_u03bb] = ACTIONS(856),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(858),
    [anon_sym_u2026] = ACTIONS(858),
    [anon_sym_record] = ACTIONS(860),
    [anon_sym_LPAREN] = ACTIONS(862),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(864),
    [anon_sym_u2983] = ACTIONS(866),
    [anon_sym_u2984] = ACTIONS(1124),
    [anon_sym__] = ACTIONS(858),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(870),
    [aux_sym__qid_token1] = ACTIONS(872),
    [anon_sym_DOT] = ACTIONS(874),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(760),
    [anon_sym_quoteGoal] = ACTIONS(878),
    [anon_sym_tactic] = ACTIONS(880),
    [anon_sym_Prop] = ACTIONS(858),
    [anon_sym_quote] = ACTIONS(858),
    [anon_sym_quoteTerm] = ACTIONS(858),
    [anon_sym_quoteContext] = ACTIONS(858),
    [anon_sym_unquote] = ACTIONS(858),
    [anon_sym_LPAREN_PIPE] = ACTIONS(882),
    [anon_sym_u2987] = ACTIONS(884),
    [anon_sym_let] = ACTIONS(886),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(890),
    [aux_sym_string_token1] = ACTIONS(890),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(892),
    [sym_PropN] = ACTIONS(858),
  },
  [520] = {
    [sym__FORALL] = STATE(8355),
    [sym__LAMBDA] = STATE(8054),
    [sym__ELLIPSIS] = STATE(4742),
    [sym__qid] = STATE(4742),
    [sym__binding_ids_and_absurds] = STATE(12547),
    [sym_attribute] = STATE(5830),
    [sym_attributes] = STATE(3506),
    [sym_expr] = STATE(12018),
    [sym__with_exprs] = STATE(10050),
    [sym__expr_or_attr] = STATE(4742),
    [sym__application] = STATE(9444),
    [sym__expr2_without_let] = STATE(9444),
    [sym__expr2] = STATE(9444),
    [sym_atom] = STATE(4712),
    [aux_sym__atoms] = STATE(3276),
    [sym__atom_curly] = STATE(4733),
    [sym__atom_no_curly] = STATE(4733),
    [sym_forall] = STATE(9444),
    [sym_let] = STATE(9444),
    [sym_lambda] = STATE(9444),
    [sym_lambda_extended_or_absurd] = STATE(9444),
    [sym_do] = STATE(9444),
    [sym_record_assignments] = STATE(4742),
    [sym_field_assignments] = STATE(4742),
    [aux_sym__typed_bindings] = STATE(8646),
    [sym_typed_binding] = STATE(8646),
    [sym_literal] = STATE(4742),
    [sym_SetN] = STATE(4742),
    [aux_sym__modal_arg_ids_repeat1] = STATE(5830),
    [aux_sym__with_exprs_repeat1] = STATE(3745),
    [sym_id] = ACTIONS(940),
    [anon_sym_forall] = ACTIONS(942),
    [anon_sym_u2200] = ACTIONS(942),
    [anon_sym_BSLASH] = ACTIONS(944),
    [anon_sym_u03bb] = ACTIONS(946),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(948),
    [anon_sym_u2026] = ACTIONS(948),
    [anon_sym_record] = ACTIONS(950),
    [anon_sym_LPAREN] = ACTIONS(952),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(954),
    [anon_sym_RBRACE_RBRACE] = ACTIONS(1122),
    [anon_sym_u2983] = ACTIONS(956),
    [anon_sym__] = ACTIONS(948),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(958),
    [aux_sym__qid_token1] = ACTIONS(960),
    [anon_sym_DOT] = ACTIONS(962),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(712),
    [anon_sym_quoteGoal] = ACTIONS(964),
    [anon_sym_tactic] = ACTIONS(966),
    [anon_sym_Prop] = ACTIONS(948),
    [anon_sym_quote] = ACTIONS(948),
    [anon_sym_quoteTerm] = ACTIONS(948),
    [anon_sym_quoteContext] = ACTIONS(948),
    [anon_sym_unquote] = ACTIONS(948),
    [anon_sym_LPAREN_PIPE] = ACTIONS(968),
    [anon_sym_u2987] = ACTIONS(970),
    [anon_sym_let] = ACTIONS(972),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(974),
    [aux_sym_string_token1] = ACTIONS(974),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(976),
    [sym_PropN] = ACTIONS(948),
  },
  [521] = {
    [sym__FORALL] = STATE(8369),
    [sym__LAMBDA] = STATE(8152),
    [sym__ELLIPSIS] = STATE(5168),
    [sym__qid] = STATE(5168),
    [sym__binding_ids_and_absurds] = STATE(12544),
    [sym_attribute] = STATE(5830),
    [sym_attributes] = STATE(3505),
    [sym_expr] = STATE(12016),
    [sym__with_exprs] = STATE(9861),
    [sym__expr_or_attr] = STATE(5168),
    [sym__application] = STATE(9444),
    [sym__expr2_without_let] = STATE(9444),
    [sym__expr2] = STATE(9444),
    [sym_atom] = STATE(5204),
    [aux_sym__atoms] = STATE(3133),
    [sym__atom_curly] = STATE(5180),
    [sym__atom_no_curly] = STATE(5180),
    [sym_forall] = STATE(9444),
    [sym_let] = STATE(9444),
    [sym_lambda] = STATE(9444),
    [sym_lambda_extended_or_absurd] = STATE(9444),
    [sym_do] = STATE(9444),
    [sym_record_assignments] = STATE(5168),
    [sym_field_assignments] = STATE(5168),
    [aux_sym__typed_bindings] = STATE(8654),
    [sym_typed_binding] = STATE(8654),
    [sym_literal] = STATE(5168),
    [sym_SetN] = STATE(5168),
    [aux_sym__modal_arg_ids_repeat1] = STATE(5830),
    [aux_sym__with_exprs_repeat1] = STATE(3754),
    [sym_id] = ACTIONS(850),
    [anon_sym_forall] = ACTIONS(852),
    [anon_sym_u2200] = ACTIONS(852),
    [anon_sym_BSLASH] = ACTIONS(854),
    [anon_sym_u03bb] = ACTIONS(856),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(858),
    [anon_sym_u2026] = ACTIONS(858),
    [anon_sym_record] = ACTIONS(860),
    [anon_sym_LPAREN] = ACTIONS(862),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(864),
    [anon_sym_u2983] = ACTIONS(866),
    [anon_sym_u2984] = ACTIONS(1122),
    [anon_sym__] = ACTIONS(858),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(870),
    [aux_sym__qid_token1] = ACTIONS(872),
    [anon_sym_DOT] = ACTIONS(874),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(712),
    [anon_sym_quoteGoal] = ACTIONS(878),
    [anon_sym_tactic] = ACTIONS(880),
    [anon_sym_Prop] = ACTIONS(858),
    [anon_sym_quote] = ACTIONS(858),
    [anon_sym_quoteTerm] = ACTIONS(858),
    [anon_sym_quoteContext] = ACTIONS(858),
    [anon_sym_unquote] = ACTIONS(858),
    [anon_sym_LPAREN_PIPE] = ACTIONS(882),
    [anon_sym_u2987] = ACTIONS(884),
    [anon_sym_let] = ACTIONS(886),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(890),
    [aux_sym_string_token1] = ACTIONS(890),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(892),
    [sym_PropN] = ACTIONS(858),
  },
  [522] = {
    [sym__FORALL] = STATE(8355),
    [sym__LAMBDA] = STATE(8054),
    [sym__ELLIPSIS] = STATE(4742),
    [sym__qid] = STATE(4742),
    [sym__binding_ids_and_absurds] = STATE(12359),
    [sym_attribute] = STATE(7725),
    [sym_attributes] = STATE(6302),
    [sym_expr] = STATE(11580),
    [sym__with_exprs] = STATE(10050),
    [sym__expr_or_attr] = STATE(4742),
    [sym__application] = STATE(9444),
    [sym__expr2_without_let] = STATE(9444),
    [sym__expr2] = STATE(9444),
    [sym_atom] = STATE(4712),
    [aux_sym__atoms] = STATE(3276),
    [sym__atom_curly] = STATE(4733),
    [sym__atom_no_curly] = STATE(4733),
    [sym_forall] = STATE(9444),
    [sym_let] = STATE(9444),
    [sym_lambda] = STATE(9444),
    [sym_lambda_extended_or_absurd] = STATE(9444),
    [sym_do] = STATE(9444),
    [sym_record_assignments] = STATE(4742),
    [sym_field_assignments] = STATE(4742),
    [aux_sym__typed_bindings] = STATE(8646),
    [sym_typed_binding] = STATE(8646),
    [sym_literal] = STATE(4742),
    [sym_SetN] = STATE(4742),
    [aux_sym__modal_arg_ids_repeat1] = STATE(7725),
    [aux_sym__with_exprs_repeat1] = STATE(3745),
    [sym_id] = ACTIONS(940),
    [anon_sym_forall] = ACTIONS(942),
    [anon_sym_u2200] = ACTIONS(942),
    [anon_sym_BSLASH] = ACTIONS(944),
    [anon_sym_u03bb] = ACTIONS(946),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(948),
    [anon_sym_u2026] = ACTIONS(948),
    [anon_sym_record] = ACTIONS(950),
    [anon_sym_LPAREN] = ACTIONS(952),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(954),
    [anon_sym_RBRACE_RBRACE] = ACTIONS(1124),
    [anon_sym_u2983] = ACTIONS(956),
    [anon_sym__] = ACTIONS(948),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(958),
    [aux_sym__qid_token1] = ACTIONS(960),
    [anon_sym_DOT] = ACTIONS(962),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(760),
    [anon_sym_quoteGoal] = ACTIONS(964),
    [anon_sym_tactic] = ACTIONS(966),
    [anon_sym_Prop] = ACTIONS(948),
    [anon_sym_quote] = ACTIONS(948),
    [anon_sym_quoteTerm] = ACTIONS(948),
    [anon_sym_quoteContext] = ACTIONS(948),
    [anon_sym_unquote] = ACTIONS(948),
    [anon_sym_LPAREN_PIPE] = ACTIONS(968),
    [anon_sym_u2987] = ACTIONS(970),
    [anon_sym_let] = ACTIONS(972),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(974),
    [aux_sym_string_token1] = ACTIONS(974),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(976),
    [sym_PropN] = ACTIONS(948),
  },
  [523] = {
    [sym__FORALL] = STATE(8396),
    [sym__LAMBDA] = STATE(8031),
    [sym__ELLIPSIS] = STATE(4920),
    [sym__qid] = STATE(4920),
    [sym__binding_ids_and_absurds] = STATE(12539),
    [sym_attribute] = STATE(5830),
    [sym_attributes] = STATE(3504),
    [sym_expr] = STATE(12015),
    [sym__with_exprs] = STATE(10196),
    [sym__expr_or_attr] = STATE(4920),
    [sym__application] = STATE(9678),
    [sym__expr2_without_let] = STATE(9678),
    [sym__expr2] = STATE(9678),
    [sym_atom] = STATE(5202),
    [aux_sym__atoms] = STATE(3165),
    [sym__atom_curly] = STATE(4961),
    [sym__atom_no_curly] = STATE(4961),
    [sym_forall] = STATE(9678),
    [sym_let] = STATE(9678),
    [sym_lambda] = STATE(9678),
    [sym_lambda_extended_or_absurd] = STATE(9678),
    [sym_do] = STATE(9678),
    [sym_record_assignments] = STATE(4920),
    [sym_field_assignments] = STATE(4920),
    [aux_sym__typed_bindings] = STATE(8648),
    [sym_typed_binding] = STATE(8648),
    [sym_literal] = STATE(4920),
    [sym_SetN] = STATE(4920),
    [aux_sym__modal_arg_ids_repeat1] = STATE(5830),
    [aux_sym__with_exprs_repeat1] = STATE(3726),
    [sym_id] = ACTIONS(894),
    [anon_sym_forall] = ACTIONS(896),
    [anon_sym_u2200] = ACTIONS(896),
    [anon_sym_BSLASH] = ACTIONS(898),
    [anon_sym_u03bb] = ACTIONS(900),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(902),
    [anon_sym_u2026] = ACTIONS(902),
    [anon_sym_record] = ACTIONS(904),
    [anon_sym_LPAREN] = ACTIONS(906),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(908),
    [anon_sym_u2983] = ACTIONS(910),
    [anon_sym__] = ACTIONS(902),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(912),
    [anon_sym_RBRACE] = ACTIONS(1126),
    [aux_sym__qid_token1] = ACTIONS(916),
    [anon_sym_DOT] = ACTIONS(918),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(712),
    [anon_sym_quoteGoal] = ACTIONS(920),
    [anon_sym_tactic] = ACTIONS(922),
    [anon_sym_Prop] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(902),
    [anon_sym_quoteTerm] = ACTIONS(902),
    [anon_sym_quoteContext] = ACTIONS(902),
    [anon_sym_unquote] = ACTIONS(902),
    [anon_sym_LPAREN_PIPE] = ACTIONS(924),
    [anon_sym_u2987] = ACTIONS(926),
    [anon_sym_let] = ACTIONS(928),
    [anon_sym_do] = ACTIONS(724),
    [aux_sym_integer_token1] = ACTIONS(930),
    [aux_sym_string_token1] = ACTIONS(930),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(932),
    [sym_PropN] = ACTIONS(902),
  },
  [524] = {
    [sym__FORALL] = STATE(8396),
    [sym__LAMBDA] = STATE(8031),
    [sym__ELLIPSIS] = STATE(4920),
    [sym__qid] = STATE(4920),
    [sym__binding_ids_and_absurds] = STATE(12539),
    [sym_attribute] = STATE(5830),
    [sym_attributes] = STATE(3504),
    [sym_expr] = STATE(11577),
    [sym__with_exprs] = STATE(10196),
    [sym__expr_or_attr] = STATE(4920),
    [sym__application] = STATE(9678),
    [sym__expr2_without_let] = STATE(9678),
    [sym__expr2] = STATE(9678),
    [sym_atom] = STATE(5202),
    [aux_sym__atoms] = STATE(3165),
    [sym__atom_curly] = STATE(4961),
    [sym__atom_no_curly] = STATE(4961),
    [sym_forall] = STATE(9678),
    [sym_let] = STATE(9678),
    [sym_lambda] = STATE(9678),
    [sym_lambda_extended_or_absurd] = STATE(9678),
    [sym_do] = STATE(9678),
    [sym_record_assignments] = STATE(4920),
    [sym_field_assignments] = STATE(4920),
    [aux_sym__typed_bindings] = STATE(8648),
    [sym_typed_binding] = STATE(8648),
    [sym_literal] = STATE(4920),
    [sym_SetN] = STATE(4920),
    [aux_sym__modal_arg_ids_repeat1] = STATE(5830),
    [aux_sym__with_exprs_repeat1] = STATE(3726),
    [sym_id] = ACTIONS(894),
    [anon_sym_forall] = ACTIONS(896),
    [anon_sym_u2200] = ACTIONS(896),
    [anon_sym_BSLASH] = ACTIONS(898),
    [anon_sym_u03bb] = ACTIONS(900),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(902),
    [anon_sym_u2026] = ACTIONS(902),
    [anon_sym_record] = ACTIONS(904),
    [anon_sym_LPAREN] = ACTIONS(906),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(908),
    [anon_sym_u2983] = ACTIONS(910),
    [anon_sym__] = ACTIONS(902),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(912),
    [anon_sym_RBRACE] = ACTIONS(1120),
    [aux_sym__qid_token1] = ACTIONS(916),
    [anon_sym_DOT] = ACTIONS(918),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(712),
    [anon_sym_quoteGoal] = ACTIONS(920),
    [anon_sym_tactic] = ACTIONS(922),
    [anon_sym_Prop] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(902),
    [anon_sym_quoteTerm] = ACTIONS(902),
    [anon_sym_quoteContext] = ACTIONS(902),
    [anon_sym_unquote] = ACTIONS(902),
    [anon_sym_LPAREN_PIPE] = ACTIONS(924),
    [anon_sym_u2987] = ACTIONS(926),
    [anon_sym_let] = ACTIONS(928),
    [anon_sym_do] = ACTIONS(724),
    [aux_sym_integer_token1] = ACTIONS(930),
    [aux_sym_string_token1] = ACTIONS(930),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(932),
    [sym_PropN] = ACTIONS(902),
  },
  [525] = {
    [sym__FORALL] = STATE(8369),
    [sym__LAMBDA] = STATE(8152),
    [sym__ELLIPSIS] = STATE(5168),
    [sym__qid] = STATE(5168),
    [sym__binding_ids_and_absurds] = STATE(12544),
    [sym_attribute] = STATE(5830),
    [sym_attributes] = STATE(3505),
    [sym_expr] = STATE(11578),
    [sym__with_exprs] = STATE(9861),
    [sym__expr_or_attr] = STATE(5168),
    [sym__application] = STATE(9444),
    [sym__expr2_without_let] = STATE(9444),
    [sym__expr2] = STATE(9444),
    [sym_atom] = STATE(5204),
    [aux_sym__atoms] = STATE(3133),
    [sym__atom_curly] = STATE(5180),
    [sym__atom_no_curly] = STATE(5180),
    [sym_forall] = STATE(9444),
    [sym_let] = STATE(9444),
    [sym_lambda] = STATE(9444),
    [sym_lambda_extended_or_absurd] = STATE(9444),
    [sym_do] = STATE(9444),
    [sym_record_assignments] = STATE(5168),
    [sym_field_assignments] = STATE(5168),
    [aux_sym__typed_bindings] = STATE(8654),
    [sym_typed_binding] = STATE(8654),
    [sym_literal] = STATE(5168),
    [sym_SetN] = STATE(5168),
    [aux_sym__modal_arg_ids_repeat1] = STATE(5830),
    [aux_sym__with_exprs_repeat1] = STATE(3754),
    [sym_id] = ACTIONS(850),
    [anon_sym_forall] = ACTIONS(852),
    [anon_sym_u2200] = ACTIONS(852),
    [anon_sym_BSLASH] = ACTIONS(854),
    [anon_sym_u03bb] = ACTIONS(856),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(858),
    [anon_sym_u2026] = ACTIONS(858),
    [anon_sym_record] = ACTIONS(860),
    [anon_sym_LPAREN] = ACTIONS(862),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(864),
    [anon_sym_u2983] = ACTIONS(866),
    [anon_sym_u2984] = ACTIONS(1124),
    [anon_sym__] = ACTIONS(858),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(870),
    [aux_sym__qid_token1] = ACTIONS(872),
    [anon_sym_DOT] = ACTIONS(874),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(712),
    [anon_sym_quoteGoal] = ACTIONS(878),
    [anon_sym_tactic] = ACTIONS(880),
    [anon_sym_Prop] = ACTIONS(858),
    [anon_sym_quote] = ACTIONS(858),
    [anon_sym_quoteTerm] = ACTIONS(858),
    [anon_sym_quoteContext] = ACTIONS(858),
    [anon_sym_unquote] = ACTIONS(858),
    [anon_sym_LPAREN_PIPE] = ACTIONS(882),
    [anon_sym_u2987] = ACTIONS(884),
    [anon_sym_let] = ACTIONS(886),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(890),
    [aux_sym_string_token1] = ACTIONS(890),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(892),
    [sym_PropN] = ACTIONS(858),
  },
  [526] = {
    [sym__FORALL] = STATE(8355),
    [sym__LAMBDA] = STATE(8054),
    [sym__ELLIPSIS] = STATE(4742),
    [sym__qid] = STATE(4742),
    [sym__binding_ids_and_absurds] = STATE(12547),
    [sym_attribute] = STATE(5830),
    [sym_attributes] = STATE(3506),
    [sym_expr] = STATE(11580),
    [sym__with_exprs] = STATE(10050),
    [sym__expr_or_attr] = STATE(4742),
    [sym__application] = STATE(9444),
    [sym__expr2_without_let] = STATE(9444),
    [sym__expr2] = STATE(9444),
    [sym_atom] = STATE(4712),
    [aux_sym__atoms] = STATE(3276),
    [sym__atom_curly] = STATE(4733),
    [sym__atom_no_curly] = STATE(4733),
    [sym_forall] = STATE(9444),
    [sym_let] = STATE(9444),
    [sym_lambda] = STATE(9444),
    [sym_lambda_extended_or_absurd] = STATE(9444),
    [sym_do] = STATE(9444),
    [sym_record_assignments] = STATE(4742),
    [sym_field_assignments] = STATE(4742),
    [aux_sym__typed_bindings] = STATE(8646),
    [sym_typed_binding] = STATE(8646),
    [sym_literal] = STATE(4742),
    [sym_SetN] = STATE(4742),
    [aux_sym__modal_arg_ids_repeat1] = STATE(5830),
    [aux_sym__with_exprs_repeat1] = STATE(3745),
    [sym_id] = ACTIONS(940),
    [anon_sym_forall] = ACTIONS(942),
    [anon_sym_u2200] = ACTIONS(942),
    [anon_sym_BSLASH] = ACTIONS(944),
    [anon_sym_u03bb] = ACTIONS(946),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(948),
    [anon_sym_u2026] = ACTIONS(948),
    [anon_sym_record] = ACTIONS(950),
    [anon_sym_LPAREN] = ACTIONS(952),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(954),
    [anon_sym_RBRACE_RBRACE] = ACTIONS(1124),
    [anon_sym_u2983] = ACTIONS(956),
    [anon_sym__] = ACTIONS(948),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(958),
    [aux_sym__qid_token1] = ACTIONS(960),
    [anon_sym_DOT] = ACTIONS(962),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(712),
    [anon_sym_quoteGoal] = ACTIONS(964),
    [anon_sym_tactic] = ACTIONS(966),
    [anon_sym_Prop] = ACTIONS(948),
    [anon_sym_quote] = ACTIONS(948),
    [anon_sym_quoteTerm] = ACTIONS(948),
    [anon_sym_quoteContext] = ACTIONS(948),
    [anon_sym_unquote] = ACTIONS(948),
    [anon_sym_LPAREN_PIPE] = ACTIONS(968),
    [anon_sym_u2987] = ACTIONS(970),
    [anon_sym_let] = ACTIONS(972),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(974),
    [aux_sym_string_token1] = ACTIONS(974),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(976),
    [sym_PropN] = ACTIONS(948),
  },
  [527] = {
    [sym__FORALL] = STATE(8355),
    [sym__LAMBDA] = STATE(8054),
    [sym__ELLIPSIS] = STATE(4742),
    [sym__qid] = STATE(4742),
    [sym__binding_ids_and_absurds] = STATE(12359),
    [sym_attribute] = STATE(7725),
    [sym_attributes] = STATE(6302),
    [sym_expr] = STATE(12018),
    [sym__with_exprs] = STATE(10050),
    [sym__expr_or_attr] = STATE(4742),
    [sym__application] = STATE(9444),
    [sym__expr2_without_let] = STATE(9444),
    [sym__expr2] = STATE(9444),
    [sym_atom] = STATE(4712),
    [aux_sym__atoms] = STATE(3276),
    [sym__atom_curly] = STATE(4733),
    [sym__atom_no_curly] = STATE(4733),
    [sym_forall] = STATE(9444),
    [sym_let] = STATE(9444),
    [sym_lambda] = STATE(9444),
    [sym_lambda_extended_or_absurd] = STATE(9444),
    [sym_do] = STATE(9444),
    [sym_record_assignments] = STATE(4742),
    [sym_field_assignments] = STATE(4742),
    [aux_sym__typed_bindings] = STATE(8646),
    [sym_typed_binding] = STATE(8646),
    [sym_literal] = STATE(4742),
    [sym_SetN] = STATE(4742),
    [aux_sym__modal_arg_ids_repeat1] = STATE(7725),
    [aux_sym__with_exprs_repeat1] = STATE(3745),
    [sym_id] = ACTIONS(940),
    [anon_sym_forall] = ACTIONS(942),
    [anon_sym_u2200] = ACTIONS(942),
    [anon_sym_BSLASH] = ACTIONS(944),
    [anon_sym_u03bb] = ACTIONS(946),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(948),
    [anon_sym_u2026] = ACTIONS(948),
    [anon_sym_record] = ACTIONS(950),
    [anon_sym_LPAREN] = ACTIONS(952),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(954),
    [anon_sym_RBRACE_RBRACE] = ACTIONS(1122),
    [anon_sym_u2983] = ACTIONS(956),
    [anon_sym__] = ACTIONS(948),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(958),
    [aux_sym__qid_token1] = ACTIONS(960),
    [anon_sym_DOT] = ACTIONS(962),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(760),
    [anon_sym_quoteGoal] = ACTIONS(964),
    [anon_sym_tactic] = ACTIONS(966),
    [anon_sym_Prop] = ACTIONS(948),
    [anon_sym_quote] = ACTIONS(948),
    [anon_sym_quoteTerm] = ACTIONS(948),
    [anon_sym_quoteContext] = ACTIONS(948),
    [anon_sym_unquote] = ACTIONS(948),
    [anon_sym_LPAREN_PIPE] = ACTIONS(968),
    [anon_sym_u2987] = ACTIONS(970),
    [anon_sym_let] = ACTIONS(972),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(974),
    [aux_sym_string_token1] = ACTIONS(974),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(976),
    [sym_PropN] = ACTIONS(948),
  },
  [528] = {
    [sym__FORALL] = STATE(8345),
    [sym__LAMBDA] = STATE(8095),
    [sym__ELLIPSIS] = STATE(4742),
    [sym_open] = STATE(12555),
    [sym__qid] = STATE(4742),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3873),
    [sym_expr] = STATE(11516),
    [sym__with_exprs] = STATE(10084),
    [sym__expr_or_attr] = STATE(4742),
    [sym__application] = STATE(9680),
    [sym__expr2_without_let] = STATE(9680),
    [sym__expr2] = STATE(9680),
    [sym_atom] = STATE(4712),
    [aux_sym__atoms] = STATE(3211),
    [sym__atom_curly] = STATE(4733),
    [sym__atom_no_curly] = STATE(4733),
    [sym_forall] = STATE(9680),
    [sym_let] = STATE(9680),
    [sym_lambda] = STATE(9680),
    [sym_lambda_extended_or_absurd] = STATE(9680),
    [sym_do] = STATE(9680),
    [sym_record_assignments] = STATE(4742),
    [sym_field_assignments] = STATE(4742),
    [aux_sym__typed_bindings] = STATE(8642),
    [sym_typed_binding] = STATE(8642),
    [sym_literal] = STATE(4742),
    [sym_SetN] = STATE(4742),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3728),
    [sym_id] = ACTIONS(940),
    [anon_sym_forall] = ACTIONS(980),
    [anon_sym_u2200] = ACTIONS(980),
    [anon_sym_BSLASH] = ACTIONS(982),
    [anon_sym_u03bb] = ACTIONS(984),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(948),
    [anon_sym_u2026] = ACTIONS(948),
    [anon_sym_record] = ACTIONS(950),
    [anon_sym_open] = ACTIONS(986),
    [anon_sym_LPAREN] = ACTIONS(952),
    [anon_sym_RPAREN] = ACTIONS(1124),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(954),
    [anon_sym_u2983] = ACTIONS(956),
    [anon_sym__] = ACTIONS(948),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(958),
    [aux_sym__qid_token1] = ACTIONS(960),
    [anon_sym_DOT] = ACTIONS(962),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(988),
    [anon_sym_tactic] = ACTIONS(990),
    [anon_sym_Prop] = ACTIONS(948),
    [anon_sym_quote] = ACTIONS(948),
    [anon_sym_quoteTerm] = ACTIONS(948),
    [anon_sym_quoteContext] = ACTIONS(948),
    [anon_sym_unquote] = ACTIONS(948),
    [anon_sym_LPAREN_PIPE] = ACTIONS(968),
    [anon_sym_u2987] = ACTIONS(970),
    [anon_sym_let] = ACTIONS(992),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(974),
    [aux_sym_string_token1] = ACTIONS(974),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(976),
    [sym_PropN] = ACTIONS(948),
  },
  [529] = {
    [sym__FORALL] = STATE(8369),
    [sym__LAMBDA] = STATE(8152),
    [sym__ELLIPSIS] = STATE(5168),
    [sym__qid] = STATE(5168),
    [sym__binding_ids_and_absurds] = STATE(12358),
    [sym_attribute] = STATE(7725),
    [sym_attributes] = STATE(6182),
    [sym_expr] = STATE(12016),
    [sym__with_exprs] = STATE(9861),
    [sym__expr_or_attr] = STATE(5168),
    [sym__application] = STATE(9444),
    [sym__expr2_without_let] = STATE(9444),
    [sym__expr2] = STATE(9444),
    [sym_atom] = STATE(5204),
    [aux_sym__atoms] = STATE(3133),
    [sym__atom_curly] = STATE(5180),
    [sym__atom_no_curly] = STATE(5180),
    [sym_forall] = STATE(9444),
    [sym_let] = STATE(9444),
    [sym_lambda] = STATE(9444),
    [sym_lambda_extended_or_absurd] = STATE(9444),
    [sym_do] = STATE(9444),
    [sym_record_assignments] = STATE(5168),
    [sym_field_assignments] = STATE(5168),
    [aux_sym__typed_bindings] = STATE(8654),
    [sym_typed_binding] = STATE(8654),
    [sym_literal] = STATE(5168),
    [sym_SetN] = STATE(5168),
    [aux_sym__modal_arg_ids_repeat1] = STATE(7725),
    [aux_sym__with_exprs_repeat1] = STATE(3754),
    [sym_id] = ACTIONS(850),
    [anon_sym_forall] = ACTIONS(852),
    [anon_sym_u2200] = ACTIONS(852),
    [anon_sym_BSLASH] = ACTIONS(854),
    [anon_sym_u03bb] = ACTIONS(856),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(858),
    [anon_sym_u2026] = ACTIONS(858),
    [anon_sym_record] = ACTIONS(860),
    [anon_sym_LPAREN] = ACTIONS(862),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(864),
    [anon_sym_u2983] = ACTIONS(866),
    [anon_sym_u2984] = ACTIONS(1122),
    [anon_sym__] = ACTIONS(858),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(870),
    [aux_sym__qid_token1] = ACTIONS(872),
    [anon_sym_DOT] = ACTIONS(874),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(760),
    [anon_sym_quoteGoal] = ACTIONS(878),
    [anon_sym_tactic] = ACTIONS(880),
    [anon_sym_Prop] = ACTIONS(858),
    [anon_sym_quote] = ACTIONS(858),
    [anon_sym_quoteTerm] = ACTIONS(858),
    [anon_sym_quoteContext] = ACTIONS(858),
    [anon_sym_unquote] = ACTIONS(858),
    [anon_sym_LPAREN_PIPE] = ACTIONS(882),
    [anon_sym_u2987] = ACTIONS(884),
    [anon_sym_let] = ACTIONS(886),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(890),
    [aux_sym_string_token1] = ACTIONS(890),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(892),
    [sym_PropN] = ACTIONS(858),
  },
  [530] = {
    [sym__FORALL] = STATE(8396),
    [sym__LAMBDA] = STATE(8031),
    [sym__ELLIPSIS] = STATE(4920),
    [sym__qid] = STATE(4920),
    [sym__binding_ids_and_absurds] = STATE(12357),
    [sym_attribute] = STATE(7725),
    [sym_attributes] = STATE(6200),
    [sym_expr] = STATE(12015),
    [sym__with_exprs] = STATE(10196),
    [sym__expr_or_attr] = STATE(4920),
    [sym__application] = STATE(9678),
    [sym__expr2_without_let] = STATE(9678),
    [sym__expr2] = STATE(9678),
    [sym_atom] = STATE(5202),
    [aux_sym__atoms] = STATE(3165),
    [sym__atom_curly] = STATE(4961),
    [sym__atom_no_curly] = STATE(4961),
    [sym_forall] = STATE(9678),
    [sym_let] = STATE(9678),
    [sym_lambda] = STATE(9678),
    [sym_lambda_extended_or_absurd] = STATE(9678),
    [sym_do] = STATE(9678),
    [sym_record_assignments] = STATE(4920),
    [sym_field_assignments] = STATE(4920),
    [aux_sym__typed_bindings] = STATE(8648),
    [sym_typed_binding] = STATE(8648),
    [sym_literal] = STATE(4920),
    [sym_SetN] = STATE(4920),
    [aux_sym__modal_arg_ids_repeat1] = STATE(7725),
    [aux_sym__with_exprs_repeat1] = STATE(3726),
    [sym_id] = ACTIONS(894),
    [anon_sym_forall] = ACTIONS(896),
    [anon_sym_u2200] = ACTIONS(896),
    [anon_sym_BSLASH] = ACTIONS(898),
    [anon_sym_u03bb] = ACTIONS(900),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(902),
    [anon_sym_u2026] = ACTIONS(902),
    [anon_sym_record] = ACTIONS(904),
    [anon_sym_LPAREN] = ACTIONS(906),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(908),
    [anon_sym_u2983] = ACTIONS(910),
    [anon_sym__] = ACTIONS(902),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(912),
    [anon_sym_RBRACE] = ACTIONS(1126),
    [aux_sym__qid_token1] = ACTIONS(916),
    [anon_sym_DOT] = ACTIONS(918),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(760),
    [anon_sym_quoteGoal] = ACTIONS(920),
    [anon_sym_tactic] = ACTIONS(922),
    [anon_sym_Prop] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(902),
    [anon_sym_quoteTerm] = ACTIONS(902),
    [anon_sym_quoteContext] = ACTIONS(902),
    [anon_sym_unquote] = ACTIONS(902),
    [anon_sym_LPAREN_PIPE] = ACTIONS(924),
    [anon_sym_u2987] = ACTIONS(926),
    [anon_sym_let] = ACTIONS(928),
    [anon_sym_do] = ACTIONS(724),
    [aux_sym_integer_token1] = ACTIONS(930),
    [aux_sym_string_token1] = ACTIONS(930),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(932),
    [sym_PropN] = ACTIONS(902),
  },
  [531] = {
    [sym__FORALL] = STATE(8355),
    [sym__LAMBDA] = STATE(8054),
    [sym__ELLIPSIS] = STATE(4742),
    [sym__qid] = STATE(4742),
    [sym__binding_ids_and_absurds] = STATE(12359),
    [sym_attribute] = STATE(7725),
    [sym_attributes] = STATE(6302),
    [sym_expr] = STATE(12420),
    [sym__with_exprs] = STATE(10050),
    [sym__expr_or_attr] = STATE(4742),
    [sym__application] = STATE(9444),
    [sym__expr2_without_let] = STATE(9444),
    [sym__expr2] = STATE(9444),
    [sym_atom] = STATE(4712),
    [aux_sym__atoms] = STATE(3276),
    [sym__atom_curly] = STATE(4733),
    [sym__atom_no_curly] = STATE(4733),
    [sym_forall] = STATE(9444),
    [sym_let] = STATE(9444),
    [sym_lambda] = STATE(9444),
    [sym_lambda_extended_or_absurd] = STATE(9444),
    [sym_do] = STATE(9444),
    [sym_record_assignments] = STATE(4742),
    [sym_field_assignments] = STATE(4742),
    [aux_sym__typed_bindings] = STATE(8646),
    [sym_typed_binding] = STATE(8646),
    [sym_literal] = STATE(4742),
    [sym_SetN] = STATE(4742),
    [aux_sym__modal_arg_ids_repeat1] = STATE(7725),
    [aux_sym__with_exprs_repeat1] = STATE(3745),
    [sym_id] = ACTIONS(940),
    [anon_sym_forall] = ACTIONS(942),
    [anon_sym_u2200] = ACTIONS(942),
    [anon_sym_BSLASH] = ACTIONS(944),
    [anon_sym_u03bb] = ACTIONS(946),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(948),
    [anon_sym_u2026] = ACTIONS(948),
    [anon_sym_record] = ACTIONS(950),
    [anon_sym_LPAREN] = ACTIONS(952),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(954),
    [anon_sym_RBRACE_RBRACE] = ACTIONS(1118),
    [anon_sym_u2983] = ACTIONS(956),
    [anon_sym__] = ACTIONS(948),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(958),
    [aux_sym__qid_token1] = ACTIONS(960),
    [anon_sym_DOT] = ACTIONS(962),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(760),
    [anon_sym_quoteGoal] = ACTIONS(964),
    [anon_sym_tactic] = ACTIONS(966),
    [anon_sym_Prop] = ACTIONS(948),
    [anon_sym_quote] = ACTIONS(948),
    [anon_sym_quoteTerm] = ACTIONS(948),
    [anon_sym_quoteContext] = ACTIONS(948),
    [anon_sym_unquote] = ACTIONS(948),
    [anon_sym_LPAREN_PIPE] = ACTIONS(968),
    [anon_sym_u2987] = ACTIONS(970),
    [anon_sym_let] = ACTIONS(972),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(974),
    [aux_sym_string_token1] = ACTIONS(974),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(976),
    [sym_PropN] = ACTIONS(948),
  },
  [532] = {
    [sym__FORALL] = STATE(8396),
    [sym__LAMBDA] = STATE(8031),
    [sym__ELLIPSIS] = STATE(4920),
    [sym__qid] = STATE(4920),
    [sym__binding_ids_and_absurds] = STATE(12539),
    [sym_attribute] = STATE(5830),
    [sym_attributes] = STATE(3504),
    [sym_expr] = STATE(12422),
    [sym__with_exprs] = STATE(10196),
    [sym__expr_or_attr] = STATE(4920),
    [sym__application] = STATE(9678),
    [sym__expr2_without_let] = STATE(9678),
    [sym__expr2] = STATE(9678),
    [sym_atom] = STATE(5202),
    [aux_sym__atoms] = STATE(3165),
    [sym__atom_curly] = STATE(4961),
    [sym__atom_no_curly] = STATE(4961),
    [sym_forall] = STATE(9678),
    [sym_let] = STATE(9678),
    [sym_lambda] = STATE(9678),
    [sym_lambda_extended_or_absurd] = STATE(9678),
    [sym_do] = STATE(9678),
    [sym_record_assignments] = STATE(4920),
    [sym_field_assignments] = STATE(4920),
    [aux_sym__typed_bindings] = STATE(8648),
    [sym_typed_binding] = STATE(8648),
    [sym_literal] = STATE(4920),
    [sym_SetN] = STATE(4920),
    [aux_sym__modal_arg_ids_repeat1] = STATE(5830),
    [aux_sym__with_exprs_repeat1] = STATE(3726),
    [sym_id] = ACTIONS(894),
    [anon_sym_forall] = ACTIONS(896),
    [anon_sym_u2200] = ACTIONS(896),
    [anon_sym_BSLASH] = ACTIONS(898),
    [anon_sym_u03bb] = ACTIONS(900),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(902),
    [anon_sym_u2026] = ACTIONS(902),
    [anon_sym_record] = ACTIONS(904),
    [anon_sym_LPAREN] = ACTIONS(906),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(908),
    [anon_sym_u2983] = ACTIONS(910),
    [anon_sym__] = ACTIONS(902),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(912),
    [anon_sym_RBRACE] = ACTIONS(1098),
    [aux_sym__qid_token1] = ACTIONS(916),
    [anon_sym_DOT] = ACTIONS(918),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(712),
    [anon_sym_quoteGoal] = ACTIONS(920),
    [anon_sym_tactic] = ACTIONS(922),
    [anon_sym_Prop] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(902),
    [anon_sym_quoteTerm] = ACTIONS(902),
    [anon_sym_quoteContext] = ACTIONS(902),
    [anon_sym_unquote] = ACTIONS(902),
    [anon_sym_LPAREN_PIPE] = ACTIONS(924),
    [anon_sym_u2987] = ACTIONS(926),
    [anon_sym_let] = ACTIONS(928),
    [anon_sym_do] = ACTIONS(724),
    [aux_sym_integer_token1] = ACTIONS(930),
    [aux_sym_string_token1] = ACTIONS(930),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(932),
    [sym_PropN] = ACTIONS(902),
  },
  [533] = {
    [sym__FORALL] = STATE(8355),
    [sym__LAMBDA] = STATE(8054),
    [sym__ELLIPSIS] = STATE(4742),
    [sym__qid] = STATE(4742),
    [sym__binding_ids_and_absurds] = STATE(12547),
    [sym_attribute] = STATE(5830),
    [sym_attributes] = STATE(3506),
    [sym_expr] = STATE(12638),
    [sym__with_exprs] = STATE(10050),
    [sym__expr_or_attr] = STATE(4742),
    [sym__application] = STATE(9444),
    [sym__expr2_without_let] = STATE(9444),
    [sym__expr2] = STATE(9444),
    [sym_atom] = STATE(4712),
    [aux_sym__atoms] = STATE(3276),
    [sym__atom_curly] = STATE(4733),
    [sym__atom_no_curly] = STATE(4733),
    [sym_forall] = STATE(9444),
    [sym_let] = STATE(9444),
    [sym_lambda] = STATE(9444),
    [sym_lambda_extended_or_absurd] = STATE(9444),
    [sym_do] = STATE(9444),
    [sym_record_assignments] = STATE(4742),
    [sym_field_assignments] = STATE(4742),
    [aux_sym__typed_bindings] = STATE(8646),
    [sym_typed_binding] = STATE(8646),
    [sym_literal] = STATE(4742),
    [sym_SetN] = STATE(4742),
    [aux_sym__modal_arg_ids_repeat1] = STATE(5830),
    [aux_sym__with_exprs_repeat1] = STATE(3745),
    [sym_id] = ACTIONS(940),
    [anon_sym_forall] = ACTIONS(942),
    [anon_sym_u2200] = ACTIONS(942),
    [anon_sym_BSLASH] = ACTIONS(944),
    [anon_sym_u03bb] = ACTIONS(946),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(948),
    [anon_sym_u2026] = ACTIONS(948),
    [anon_sym_record] = ACTIONS(950),
    [anon_sym_LPAREN] = ACTIONS(952),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(954),
    [anon_sym_RBRACE_RBRACE] = ACTIONS(1076),
    [anon_sym_u2983] = ACTIONS(956),
    [anon_sym__] = ACTIONS(948),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(958),
    [aux_sym__qid_token1] = ACTIONS(960),
    [anon_sym_DOT] = ACTIONS(962),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(712),
    [anon_sym_quoteGoal] = ACTIONS(964),
    [anon_sym_tactic] = ACTIONS(966),
    [anon_sym_Prop] = ACTIONS(948),
    [anon_sym_quote] = ACTIONS(948),
    [anon_sym_quoteTerm] = ACTIONS(948),
    [anon_sym_quoteContext] = ACTIONS(948),
    [anon_sym_unquote] = ACTIONS(948),
    [anon_sym_LPAREN_PIPE] = ACTIONS(968),
    [anon_sym_u2987] = ACTIONS(970),
    [anon_sym_let] = ACTIONS(972),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(974),
    [aux_sym_string_token1] = ACTIONS(974),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(976),
    [sym_PropN] = ACTIONS(948),
  },
  [534] = {
    [sym__FORALL] = STATE(8396),
    [sym__LAMBDA] = STATE(8031),
    [sym__ELLIPSIS] = STATE(4920),
    [sym__qid] = STATE(4920),
    [sym__binding_ids_and_absurds] = STATE(12357),
    [sym_attribute] = STATE(7725),
    [sym_attributes] = STATE(6200),
    [sym_expr] = STATE(11604),
    [sym__with_exprs] = STATE(10196),
    [sym__expr_or_attr] = STATE(4920),
    [sym__application] = STATE(9678),
    [sym__expr2_without_let] = STATE(9678),
    [sym__expr2] = STATE(9678),
    [sym_atom] = STATE(5202),
    [aux_sym__atoms] = STATE(3165),
    [sym__atom_curly] = STATE(4961),
    [sym__atom_no_curly] = STATE(4961),
    [sym_forall] = STATE(9678),
    [sym_let] = STATE(9678),
    [sym_lambda] = STATE(9678),
    [sym_lambda_extended_or_absurd] = STATE(9678),
    [sym_do] = STATE(9678),
    [sym_record_assignments] = STATE(4920),
    [sym_field_assignments] = STATE(4920),
    [aux_sym__typed_bindings] = STATE(8648),
    [sym_typed_binding] = STATE(8648),
    [sym_literal] = STATE(4920),
    [sym_SetN] = STATE(4920),
    [aux_sym__modal_arg_ids_repeat1] = STATE(7725),
    [aux_sym__with_exprs_repeat1] = STATE(3726),
    [sym_id] = ACTIONS(894),
    [anon_sym_forall] = ACTIONS(896),
    [anon_sym_u2200] = ACTIONS(896),
    [anon_sym_BSLASH] = ACTIONS(898),
    [anon_sym_u03bb] = ACTIONS(900),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(902),
    [anon_sym_u2026] = ACTIONS(902),
    [anon_sym_record] = ACTIONS(904),
    [anon_sym_LPAREN] = ACTIONS(906),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(908),
    [anon_sym_u2983] = ACTIONS(910),
    [anon_sym__] = ACTIONS(902),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(912),
    [anon_sym_RBRACE] = ACTIONS(1128),
    [aux_sym__qid_token1] = ACTIONS(916),
    [anon_sym_DOT] = ACTIONS(918),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(760),
    [anon_sym_quoteGoal] = ACTIONS(920),
    [anon_sym_tactic] = ACTIONS(922),
    [anon_sym_Prop] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(902),
    [anon_sym_quoteTerm] = ACTIONS(902),
    [anon_sym_quoteContext] = ACTIONS(902),
    [anon_sym_unquote] = ACTIONS(902),
    [anon_sym_LPAREN_PIPE] = ACTIONS(924),
    [anon_sym_u2987] = ACTIONS(926),
    [anon_sym_let] = ACTIONS(928),
    [anon_sym_do] = ACTIONS(724),
    [aux_sym_integer_token1] = ACTIONS(930),
    [aux_sym_string_token1] = ACTIONS(930),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(932),
    [sym_PropN] = ACTIONS(902),
  },
  [535] = {
    [sym__FORALL] = STATE(8396),
    [sym__LAMBDA] = STATE(8031),
    [sym__ELLIPSIS] = STATE(4920),
    [sym__qid] = STATE(4920),
    [sym__binding_ids_and_absurds] = STATE(12357),
    [sym_attribute] = STATE(7725),
    [sym_attributes] = STATE(6200),
    [sym_expr] = STATE(11437),
    [sym__with_exprs] = STATE(10196),
    [sym__expr_or_attr] = STATE(4920),
    [sym__application] = STATE(9678),
    [sym__expr2_without_let] = STATE(9678),
    [sym__expr2] = STATE(9678),
    [sym_atom] = STATE(5202),
    [aux_sym__atoms] = STATE(3165),
    [sym__atom_curly] = STATE(4961),
    [sym__atom_no_curly] = STATE(4961),
    [sym_forall] = STATE(9678),
    [sym_let] = STATE(9678),
    [sym_lambda] = STATE(9678),
    [sym_lambda_extended_or_absurd] = STATE(9678),
    [sym_do] = STATE(9678),
    [sym_record_assignments] = STATE(4920),
    [sym_field_assignments] = STATE(4920),
    [aux_sym__typed_bindings] = STATE(8648),
    [sym_typed_binding] = STATE(8648),
    [sym_literal] = STATE(4920),
    [sym_SetN] = STATE(4920),
    [aux_sym__modal_arg_ids_repeat1] = STATE(7725),
    [aux_sym__with_exprs_repeat1] = STATE(3726),
    [sym_id] = ACTIONS(894),
    [anon_sym_forall] = ACTIONS(896),
    [anon_sym_u2200] = ACTIONS(896),
    [anon_sym_BSLASH] = ACTIONS(898),
    [anon_sym_u03bb] = ACTIONS(900),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(902),
    [anon_sym_u2026] = ACTIONS(902),
    [anon_sym_record] = ACTIONS(904),
    [anon_sym_LPAREN] = ACTIONS(906),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(908),
    [anon_sym_u2983] = ACTIONS(910),
    [anon_sym__] = ACTIONS(902),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(912),
    [anon_sym_RBRACE] = ACTIONS(1130),
    [aux_sym__qid_token1] = ACTIONS(916),
    [anon_sym_DOT] = ACTIONS(918),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(760),
    [anon_sym_quoteGoal] = ACTIONS(920),
    [anon_sym_tactic] = ACTIONS(922),
    [anon_sym_Prop] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(902),
    [anon_sym_quoteTerm] = ACTIONS(902),
    [anon_sym_quoteContext] = ACTIONS(902),
    [anon_sym_unquote] = ACTIONS(902),
    [anon_sym_LPAREN_PIPE] = ACTIONS(924),
    [anon_sym_u2987] = ACTIONS(926),
    [anon_sym_let] = ACTIONS(928),
    [anon_sym_do] = ACTIONS(724),
    [aux_sym_integer_token1] = ACTIONS(930),
    [aux_sym_string_token1] = ACTIONS(930),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(932),
    [sym_PropN] = ACTIONS(902),
  },
  [536] = {
    [sym__FORALL] = STATE(8369),
    [sym__LAMBDA] = STATE(8152),
    [sym__ELLIPSIS] = STATE(5168),
    [sym__qid] = STATE(5168),
    [sym__binding_ids_and_absurds] = STATE(12358),
    [sym_attribute] = STATE(7725),
    [sym_attributes] = STATE(6182),
    [sym_expr] = STATE(11436),
    [sym__with_exprs] = STATE(9861),
    [sym__expr_or_attr] = STATE(5168),
    [sym__application] = STATE(9444),
    [sym__expr2_without_let] = STATE(9444),
    [sym__expr2] = STATE(9444),
    [sym_atom] = STATE(5204),
    [aux_sym__atoms] = STATE(3133),
    [sym__atom_curly] = STATE(5180),
    [sym__atom_no_curly] = STATE(5180),
    [sym_forall] = STATE(9444),
    [sym_let] = STATE(9444),
    [sym_lambda] = STATE(9444),
    [sym_lambda_extended_or_absurd] = STATE(9444),
    [sym_do] = STATE(9444),
    [sym_record_assignments] = STATE(5168),
    [sym_field_assignments] = STATE(5168),
    [aux_sym__typed_bindings] = STATE(8654),
    [sym_typed_binding] = STATE(8654),
    [sym_literal] = STATE(5168),
    [sym_SetN] = STATE(5168),
    [aux_sym__modal_arg_ids_repeat1] = STATE(7725),
    [aux_sym__with_exprs_repeat1] = STATE(3754),
    [sym_id] = ACTIONS(850),
    [anon_sym_forall] = ACTIONS(852),
    [anon_sym_u2200] = ACTIONS(852),
    [anon_sym_BSLASH] = ACTIONS(854),
    [anon_sym_u03bb] = ACTIONS(856),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(858),
    [anon_sym_u2026] = ACTIONS(858),
    [anon_sym_record] = ACTIONS(860),
    [anon_sym_LPAREN] = ACTIONS(862),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(864),
    [anon_sym_u2983] = ACTIONS(866),
    [anon_sym_u2984] = ACTIONS(1132),
    [anon_sym__] = ACTIONS(858),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(870),
    [aux_sym__qid_token1] = ACTIONS(872),
    [anon_sym_DOT] = ACTIONS(874),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(760),
    [anon_sym_quoteGoal] = ACTIONS(878),
    [anon_sym_tactic] = ACTIONS(880),
    [anon_sym_Prop] = ACTIONS(858),
    [anon_sym_quote] = ACTIONS(858),
    [anon_sym_quoteTerm] = ACTIONS(858),
    [anon_sym_quoteContext] = ACTIONS(858),
    [anon_sym_unquote] = ACTIONS(858),
    [anon_sym_LPAREN_PIPE] = ACTIONS(882),
    [anon_sym_u2987] = ACTIONS(884),
    [anon_sym_let] = ACTIONS(886),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(890),
    [aux_sym_string_token1] = ACTIONS(890),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(892),
    [sym_PropN] = ACTIONS(858),
  },
  [537] = {
    [sym__FORALL] = STATE(8369),
    [sym__LAMBDA] = STATE(8152),
    [sym__ELLIPSIS] = STATE(5168),
    [sym__qid] = STATE(5168),
    [sym__binding_ids_and_absurds] = STATE(12358),
    [sym_attribute] = STATE(7725),
    [sym_attributes] = STATE(6182),
    [sym_expr] = STATE(11606),
    [sym__with_exprs] = STATE(9861),
    [sym__expr_or_attr] = STATE(5168),
    [sym__application] = STATE(9444),
    [sym__expr2_without_let] = STATE(9444),
    [sym__expr2] = STATE(9444),
    [sym_atom] = STATE(5204),
    [aux_sym__atoms] = STATE(3133),
    [sym__atom_curly] = STATE(5180),
    [sym__atom_no_curly] = STATE(5180),
    [sym_forall] = STATE(9444),
    [sym_let] = STATE(9444),
    [sym_lambda] = STATE(9444),
    [sym_lambda_extended_or_absurd] = STATE(9444),
    [sym_do] = STATE(9444),
    [sym_record_assignments] = STATE(5168),
    [sym_field_assignments] = STATE(5168),
    [aux_sym__typed_bindings] = STATE(8654),
    [sym_typed_binding] = STATE(8654),
    [sym_literal] = STATE(5168),
    [sym_SetN] = STATE(5168),
    [aux_sym__modal_arg_ids_repeat1] = STATE(7725),
    [aux_sym__with_exprs_repeat1] = STATE(3754),
    [sym_id] = ACTIONS(850),
    [anon_sym_forall] = ACTIONS(852),
    [anon_sym_u2200] = ACTIONS(852),
    [anon_sym_BSLASH] = ACTIONS(854),
    [anon_sym_u03bb] = ACTIONS(856),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(858),
    [anon_sym_u2026] = ACTIONS(858),
    [anon_sym_record] = ACTIONS(860),
    [anon_sym_LPAREN] = ACTIONS(862),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(864),
    [anon_sym_u2983] = ACTIONS(866),
    [anon_sym_u2984] = ACTIONS(1134),
    [anon_sym__] = ACTIONS(858),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(870),
    [aux_sym__qid_token1] = ACTIONS(872),
    [anon_sym_DOT] = ACTIONS(874),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(760),
    [anon_sym_quoteGoal] = ACTIONS(878),
    [anon_sym_tactic] = ACTIONS(880),
    [anon_sym_Prop] = ACTIONS(858),
    [anon_sym_quote] = ACTIONS(858),
    [anon_sym_quoteTerm] = ACTIONS(858),
    [anon_sym_quoteContext] = ACTIONS(858),
    [anon_sym_unquote] = ACTIONS(858),
    [anon_sym_LPAREN_PIPE] = ACTIONS(882),
    [anon_sym_u2987] = ACTIONS(884),
    [anon_sym_let] = ACTIONS(886),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(890),
    [aux_sym_string_token1] = ACTIONS(890),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(892),
    [sym_PropN] = ACTIONS(858),
  },
  [538] = {
    [sym__FORALL] = STATE(8355),
    [sym__LAMBDA] = STATE(8054),
    [sym__ELLIPSIS] = STATE(4742),
    [sym__qid] = STATE(4742),
    [sym__binding_ids_and_absurds] = STATE(12359),
    [sym_attribute] = STATE(7725),
    [sym_attributes] = STATE(6302),
    [sym_expr] = STATE(11412),
    [sym__with_exprs] = STATE(10050),
    [sym__expr_or_attr] = STATE(4742),
    [sym__application] = STATE(9444),
    [sym__expr2_without_let] = STATE(9444),
    [sym__expr2] = STATE(9444),
    [sym_atom] = STATE(4712),
    [aux_sym__atoms] = STATE(3276),
    [sym__atom_curly] = STATE(4733),
    [sym__atom_no_curly] = STATE(4733),
    [sym_forall] = STATE(9444),
    [sym_let] = STATE(9444),
    [sym_lambda] = STATE(9444),
    [sym_lambda_extended_or_absurd] = STATE(9444),
    [sym_do] = STATE(9444),
    [sym_record_assignments] = STATE(4742),
    [sym_field_assignments] = STATE(4742),
    [aux_sym__typed_bindings] = STATE(8646),
    [sym_typed_binding] = STATE(8646),
    [sym_literal] = STATE(4742),
    [sym_SetN] = STATE(4742),
    [aux_sym__modal_arg_ids_repeat1] = STATE(7725),
    [aux_sym__with_exprs_repeat1] = STATE(3745),
    [sym_id] = ACTIONS(940),
    [anon_sym_forall] = ACTIONS(942),
    [anon_sym_u2200] = ACTIONS(942),
    [anon_sym_BSLASH] = ACTIONS(944),
    [anon_sym_u03bb] = ACTIONS(946),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(948),
    [anon_sym_u2026] = ACTIONS(948),
    [anon_sym_record] = ACTIONS(950),
    [anon_sym_LPAREN] = ACTIONS(952),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(954),
    [anon_sym_RBRACE_RBRACE] = ACTIONS(1132),
    [anon_sym_u2983] = ACTIONS(956),
    [anon_sym__] = ACTIONS(948),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(958),
    [aux_sym__qid_token1] = ACTIONS(960),
    [anon_sym_DOT] = ACTIONS(962),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(760),
    [anon_sym_quoteGoal] = ACTIONS(964),
    [anon_sym_tactic] = ACTIONS(966),
    [anon_sym_Prop] = ACTIONS(948),
    [anon_sym_quote] = ACTIONS(948),
    [anon_sym_quoteTerm] = ACTIONS(948),
    [anon_sym_quoteContext] = ACTIONS(948),
    [anon_sym_unquote] = ACTIONS(948),
    [anon_sym_LPAREN_PIPE] = ACTIONS(968),
    [anon_sym_u2987] = ACTIONS(970),
    [anon_sym_let] = ACTIONS(972),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(974),
    [aux_sym_string_token1] = ACTIONS(974),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(976),
    [sym_PropN] = ACTIONS(948),
  },
  [539] = {
    [sym__FORALL] = STATE(8355),
    [sym__LAMBDA] = STATE(8054),
    [sym__ELLIPSIS] = STATE(4742),
    [sym__qid] = STATE(4742),
    [sym__binding_ids_and_absurds] = STATE(12359),
    [sym_attribute] = STATE(7725),
    [sym_attributes] = STATE(6302),
    [sym_expr] = STATE(11608),
    [sym__with_exprs] = STATE(10050),
    [sym__expr_or_attr] = STATE(4742),
    [sym__application] = STATE(9444),
    [sym__expr2_without_let] = STATE(9444),
    [sym__expr2] = STATE(9444),
    [sym_atom] = STATE(4712),
    [aux_sym__atoms] = STATE(3276),
    [sym__atom_curly] = STATE(4733),
    [sym__atom_no_curly] = STATE(4733),
    [sym_forall] = STATE(9444),
    [sym_let] = STATE(9444),
    [sym_lambda] = STATE(9444),
    [sym_lambda_extended_or_absurd] = STATE(9444),
    [sym_do] = STATE(9444),
    [sym_record_assignments] = STATE(4742),
    [sym_field_assignments] = STATE(4742),
    [aux_sym__typed_bindings] = STATE(8646),
    [sym_typed_binding] = STATE(8646),
    [sym_literal] = STATE(4742),
    [sym_SetN] = STATE(4742),
    [aux_sym__modal_arg_ids_repeat1] = STATE(7725),
    [aux_sym__with_exprs_repeat1] = STATE(3745),
    [sym_id] = ACTIONS(940),
    [anon_sym_forall] = ACTIONS(942),
    [anon_sym_u2200] = ACTIONS(942),
    [anon_sym_BSLASH] = ACTIONS(944),
    [anon_sym_u03bb] = ACTIONS(946),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(948),
    [anon_sym_u2026] = ACTIONS(948),
    [anon_sym_record] = ACTIONS(950),
    [anon_sym_LPAREN] = ACTIONS(952),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(954),
    [anon_sym_RBRACE_RBRACE] = ACTIONS(1134),
    [anon_sym_u2983] = ACTIONS(956),
    [anon_sym__] = ACTIONS(948),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(958),
    [aux_sym__qid_token1] = ACTIONS(960),
    [anon_sym_DOT] = ACTIONS(962),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(760),
    [anon_sym_quoteGoal] = ACTIONS(964),
    [anon_sym_tactic] = ACTIONS(966),
    [anon_sym_Prop] = ACTIONS(948),
    [anon_sym_quote] = ACTIONS(948),
    [anon_sym_quoteTerm] = ACTIONS(948),
    [anon_sym_quoteContext] = ACTIONS(948),
    [anon_sym_unquote] = ACTIONS(948),
    [anon_sym_LPAREN_PIPE] = ACTIONS(968),
    [anon_sym_u2987] = ACTIONS(970),
    [anon_sym_let] = ACTIONS(972),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(974),
    [aux_sym_string_token1] = ACTIONS(974),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(976),
    [sym_PropN] = ACTIONS(948),
  },
  [540] = {
    [sym__FORALL] = STATE(8345),
    [sym__LAMBDA] = STATE(8095),
    [sym__ELLIPSIS] = STATE(4742),
    [sym_open] = STATE(12555),
    [sym__qid] = STATE(4742),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3873),
    [sym_expr] = STATE(12560),
    [sym__with_exprs] = STATE(10084),
    [sym__expr_or_attr] = STATE(4742),
    [sym__application] = STATE(9680),
    [sym__expr2_without_let] = STATE(9680),
    [sym__expr2] = STATE(9680),
    [sym_atom] = STATE(4712),
    [aux_sym__atoms] = STATE(3211),
    [sym__atom_curly] = STATE(4733),
    [sym__atom_no_curly] = STATE(4733),
    [sym_forall] = STATE(9680),
    [sym_let] = STATE(9680),
    [sym_lambda] = STATE(9680),
    [sym_lambda_extended_or_absurd] = STATE(9680),
    [sym_do] = STATE(9680),
    [sym_record_assignments] = STATE(4742),
    [sym_field_assignments] = STATE(4742),
    [aux_sym__typed_bindings] = STATE(8642),
    [sym_typed_binding] = STATE(8642),
    [sym_literal] = STATE(4742),
    [sym_SetN] = STATE(4742),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3728),
    [sym_id] = ACTIONS(940),
    [anon_sym_forall] = ACTIONS(980),
    [anon_sym_u2200] = ACTIONS(980),
    [anon_sym_BSLASH] = ACTIONS(982),
    [anon_sym_u03bb] = ACTIONS(984),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(948),
    [anon_sym_u2026] = ACTIONS(948),
    [anon_sym_record] = ACTIONS(950),
    [anon_sym_open] = ACTIONS(986),
    [anon_sym_LPAREN] = ACTIONS(952),
    [anon_sym_RPAREN] = ACTIONS(1076),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(954),
    [anon_sym_u2983] = ACTIONS(956),
    [anon_sym__] = ACTIONS(948),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(958),
    [aux_sym__qid_token1] = ACTIONS(960),
    [anon_sym_DOT] = ACTIONS(962),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(988),
    [anon_sym_tactic] = ACTIONS(990),
    [anon_sym_Prop] = ACTIONS(948),
    [anon_sym_quote] = ACTIONS(948),
    [anon_sym_quoteTerm] = ACTIONS(948),
    [anon_sym_quoteContext] = ACTIONS(948),
    [anon_sym_unquote] = ACTIONS(948),
    [anon_sym_LPAREN_PIPE] = ACTIONS(968),
    [anon_sym_u2987] = ACTIONS(970),
    [anon_sym_let] = ACTIONS(992),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(974),
    [aux_sym_string_token1] = ACTIONS(974),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(976),
    [sym_PropN] = ACTIONS(948),
  },
  [541] = {
    [sym__FORALL] = STATE(8369),
    [sym__LAMBDA] = STATE(8152),
    [sym__ELLIPSIS] = STATE(5168),
    [sym__qid] = STATE(5168),
    [sym__binding_ids_and_absurds] = STATE(12544),
    [sym_attribute] = STATE(5830),
    [sym_attributes] = STATE(3505),
    [sym_expr] = STATE(12421),
    [sym__with_exprs] = STATE(9861),
    [sym__expr_or_attr] = STATE(5168),
    [sym__application] = STATE(9444),
    [sym__expr2_without_let] = STATE(9444),
    [sym__expr2] = STATE(9444),
    [sym_atom] = STATE(5204),
    [aux_sym__atoms] = STATE(3133),
    [sym__atom_curly] = STATE(5180),
    [sym__atom_no_curly] = STATE(5180),
    [sym_forall] = STATE(9444),
    [sym_let] = STATE(9444),
    [sym_lambda] = STATE(9444),
    [sym_lambda_extended_or_absurd] = STATE(9444),
    [sym_do] = STATE(9444),
    [sym_record_assignments] = STATE(5168),
    [sym_field_assignments] = STATE(5168),
    [aux_sym__typed_bindings] = STATE(8654),
    [sym_typed_binding] = STATE(8654),
    [sym_literal] = STATE(5168),
    [sym_SetN] = STATE(5168),
    [aux_sym__modal_arg_ids_repeat1] = STATE(5830),
    [aux_sym__with_exprs_repeat1] = STATE(3754),
    [sym_id] = ACTIONS(850),
    [anon_sym_forall] = ACTIONS(852),
    [anon_sym_u2200] = ACTIONS(852),
    [anon_sym_BSLASH] = ACTIONS(854),
    [anon_sym_u03bb] = ACTIONS(856),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(858),
    [anon_sym_u2026] = ACTIONS(858),
    [anon_sym_record] = ACTIONS(860),
    [anon_sym_LPAREN] = ACTIONS(862),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(864),
    [anon_sym_u2983] = ACTIONS(866),
    [anon_sym_u2984] = ACTIONS(1118),
    [anon_sym__] = ACTIONS(858),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(870),
    [aux_sym__qid_token1] = ACTIONS(872),
    [anon_sym_DOT] = ACTIONS(874),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(712),
    [anon_sym_quoteGoal] = ACTIONS(878),
    [anon_sym_tactic] = ACTIONS(880),
    [anon_sym_Prop] = ACTIONS(858),
    [anon_sym_quote] = ACTIONS(858),
    [anon_sym_quoteTerm] = ACTIONS(858),
    [anon_sym_quoteContext] = ACTIONS(858),
    [anon_sym_unquote] = ACTIONS(858),
    [anon_sym_LPAREN_PIPE] = ACTIONS(882),
    [anon_sym_u2987] = ACTIONS(884),
    [anon_sym_let] = ACTIONS(886),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(890),
    [aux_sym_string_token1] = ACTIONS(890),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(892),
    [sym_PropN] = ACTIONS(858),
  },
  [542] = {
    [sym__FORALL] = STATE(8355),
    [sym__LAMBDA] = STATE(8054),
    [sym__ELLIPSIS] = STATE(4742),
    [sym__qid] = STATE(4742),
    [sym__binding_ids_and_absurds] = STATE(12547),
    [sym_attribute] = STATE(5830),
    [sym_attributes] = STATE(3506),
    [sym_expr] = STATE(12420),
    [sym__with_exprs] = STATE(10050),
    [sym__expr_or_attr] = STATE(4742),
    [sym__application] = STATE(9444),
    [sym__expr2_without_let] = STATE(9444),
    [sym__expr2] = STATE(9444),
    [sym_atom] = STATE(4712),
    [aux_sym__atoms] = STATE(3276),
    [sym__atom_curly] = STATE(4733),
    [sym__atom_no_curly] = STATE(4733),
    [sym_forall] = STATE(9444),
    [sym_let] = STATE(9444),
    [sym_lambda] = STATE(9444),
    [sym_lambda_extended_or_absurd] = STATE(9444),
    [sym_do] = STATE(9444),
    [sym_record_assignments] = STATE(4742),
    [sym_field_assignments] = STATE(4742),
    [aux_sym__typed_bindings] = STATE(8646),
    [sym_typed_binding] = STATE(8646),
    [sym_literal] = STATE(4742),
    [sym_SetN] = STATE(4742),
    [aux_sym__modal_arg_ids_repeat1] = STATE(5830),
    [aux_sym__with_exprs_repeat1] = STATE(3745),
    [sym_id] = ACTIONS(940),
    [anon_sym_forall] = ACTIONS(942),
    [anon_sym_u2200] = ACTIONS(942),
    [anon_sym_BSLASH] = ACTIONS(944),
    [anon_sym_u03bb] = ACTIONS(946),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(948),
    [anon_sym_u2026] = ACTIONS(948),
    [anon_sym_record] = ACTIONS(950),
    [anon_sym_LPAREN] = ACTIONS(952),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(954),
    [anon_sym_RBRACE_RBRACE] = ACTIONS(1118),
    [anon_sym_u2983] = ACTIONS(956),
    [anon_sym__] = ACTIONS(948),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(958),
    [aux_sym__qid_token1] = ACTIONS(960),
    [anon_sym_DOT] = ACTIONS(962),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(712),
    [anon_sym_quoteGoal] = ACTIONS(964),
    [anon_sym_tactic] = ACTIONS(966),
    [anon_sym_Prop] = ACTIONS(948),
    [anon_sym_quote] = ACTIONS(948),
    [anon_sym_quoteTerm] = ACTIONS(948),
    [anon_sym_quoteContext] = ACTIONS(948),
    [anon_sym_unquote] = ACTIONS(948),
    [anon_sym_LPAREN_PIPE] = ACTIONS(968),
    [anon_sym_u2987] = ACTIONS(970),
    [anon_sym_let] = ACTIONS(972),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(974),
    [aux_sym_string_token1] = ACTIONS(974),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(976),
    [sym_PropN] = ACTIONS(948),
  },
  [543] = {
    [sym__FORALL] = STATE(8345),
    [sym__LAMBDA] = STATE(8095),
    [sym__ELLIPSIS] = STATE(4742),
    [sym_open] = STATE(12555),
    [sym__qid] = STATE(4742),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3873),
    [sym_expr] = STATE(10736),
    [sym__with_exprs] = STATE(10084),
    [sym__expr_or_attr] = STATE(4742),
    [sym__application] = STATE(9680),
    [sym__expr2_without_let] = STATE(9680),
    [sym__expr2] = STATE(9680),
    [sym_atom] = STATE(4712),
    [aux_sym__atoms] = STATE(3211),
    [sym__atom_curly] = STATE(4733),
    [sym__atom_no_curly] = STATE(4733),
    [sym_forall] = STATE(9680),
    [sym_let] = STATE(9680),
    [sym_lambda] = STATE(9680),
    [sym_lambda_extended_or_absurd] = STATE(9680),
    [sym_do] = STATE(9680),
    [sym_record_assignments] = STATE(4742),
    [sym_field_assignments] = STATE(4742),
    [aux_sym__typed_bindings] = STATE(8642),
    [sym_typed_binding] = STATE(8642),
    [sym_literal] = STATE(4742),
    [sym_SetN] = STATE(4742),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3728),
    [sym_id] = ACTIONS(940),
    [anon_sym_forall] = ACTIONS(980),
    [anon_sym_u2200] = ACTIONS(980),
    [anon_sym_BSLASH] = ACTIONS(982),
    [anon_sym_u03bb] = ACTIONS(984),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(948),
    [anon_sym_u2026] = ACTIONS(948),
    [anon_sym_record] = ACTIONS(950),
    [anon_sym_open] = ACTIONS(986),
    [anon_sym_LPAREN] = ACTIONS(952),
    [anon_sym_RPAREN] = ACTIONS(1136),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(954),
    [anon_sym_u2983] = ACTIONS(956),
    [anon_sym__] = ACTIONS(948),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(958),
    [aux_sym__qid_token1] = ACTIONS(960),
    [anon_sym_DOT] = ACTIONS(962),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(988),
    [anon_sym_tactic] = ACTIONS(990),
    [anon_sym_Prop] = ACTIONS(948),
    [anon_sym_quote] = ACTIONS(948),
    [anon_sym_quoteTerm] = ACTIONS(948),
    [anon_sym_quoteContext] = ACTIONS(948),
    [anon_sym_unquote] = ACTIONS(948),
    [anon_sym_LPAREN_PIPE] = ACTIONS(968),
    [anon_sym_u2987] = ACTIONS(970),
    [anon_sym_let] = ACTIONS(992),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(974),
    [aux_sym_string_token1] = ACTIONS(974),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(976),
    [sym_PropN] = ACTIONS(948),
  },
  [544] = {
    [sym__FORALL] = STATE(8396),
    [sym__LAMBDA] = STATE(8031),
    [sym__ELLIPSIS] = STATE(4920),
    [sym__qid] = STATE(4920),
    [sym__binding_ids_and_absurds] = STATE(12539),
    [sym_attribute] = STATE(5830),
    [sym_attributes] = STATE(3504),
    [sym_expr] = STATE(11604),
    [sym__with_exprs] = STATE(10196),
    [sym__expr_or_attr] = STATE(4920),
    [sym__application] = STATE(9678),
    [sym__expr2_without_let] = STATE(9678),
    [sym__expr2] = STATE(9678),
    [sym_atom] = STATE(5202),
    [aux_sym__atoms] = STATE(3165),
    [sym__atom_curly] = STATE(4961),
    [sym__atom_no_curly] = STATE(4961),
    [sym_forall] = STATE(9678),
    [sym_let] = STATE(9678),
    [sym_lambda] = STATE(9678),
    [sym_lambda_extended_or_absurd] = STATE(9678),
    [sym_do] = STATE(9678),
    [sym_record_assignments] = STATE(4920),
    [sym_field_assignments] = STATE(4920),
    [aux_sym__typed_bindings] = STATE(8648),
    [sym_typed_binding] = STATE(8648),
    [sym_literal] = STATE(4920),
    [sym_SetN] = STATE(4920),
    [aux_sym__modal_arg_ids_repeat1] = STATE(5830),
    [aux_sym__with_exprs_repeat1] = STATE(3726),
    [sym_id] = ACTIONS(894),
    [anon_sym_forall] = ACTIONS(896),
    [anon_sym_u2200] = ACTIONS(896),
    [anon_sym_BSLASH] = ACTIONS(898),
    [anon_sym_u03bb] = ACTIONS(900),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(902),
    [anon_sym_u2026] = ACTIONS(902),
    [anon_sym_record] = ACTIONS(904),
    [anon_sym_LPAREN] = ACTIONS(906),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(908),
    [anon_sym_u2983] = ACTIONS(910),
    [anon_sym__] = ACTIONS(902),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(912),
    [anon_sym_RBRACE] = ACTIONS(1128),
    [aux_sym__qid_token1] = ACTIONS(916),
    [anon_sym_DOT] = ACTIONS(918),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(712),
    [anon_sym_quoteGoal] = ACTIONS(920),
    [anon_sym_tactic] = ACTIONS(922),
    [anon_sym_Prop] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(902),
    [anon_sym_quoteTerm] = ACTIONS(902),
    [anon_sym_quoteContext] = ACTIONS(902),
    [anon_sym_unquote] = ACTIONS(902),
    [anon_sym_LPAREN_PIPE] = ACTIONS(924),
    [anon_sym_u2987] = ACTIONS(926),
    [anon_sym_let] = ACTIONS(928),
    [anon_sym_do] = ACTIONS(724),
    [aux_sym_integer_token1] = ACTIONS(930),
    [aux_sym_string_token1] = ACTIONS(930),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(932),
    [sym_PropN] = ACTIONS(902),
  },
  [545] = {
    [sym__FORALL] = STATE(8369),
    [sym__LAMBDA] = STATE(8152),
    [sym__ELLIPSIS] = STATE(5168),
    [sym__qid] = STATE(5168),
    [sym__binding_ids_and_absurds] = STATE(12544),
    [sym_attribute] = STATE(5830),
    [sym_attributes] = STATE(3505),
    [sym_expr] = STATE(11606),
    [sym__with_exprs] = STATE(9861),
    [sym__expr_or_attr] = STATE(5168),
    [sym__application] = STATE(9444),
    [sym__expr2_without_let] = STATE(9444),
    [sym__expr2] = STATE(9444),
    [sym_atom] = STATE(5204),
    [aux_sym__atoms] = STATE(3133),
    [sym__atom_curly] = STATE(5180),
    [sym__atom_no_curly] = STATE(5180),
    [sym_forall] = STATE(9444),
    [sym_let] = STATE(9444),
    [sym_lambda] = STATE(9444),
    [sym_lambda_extended_or_absurd] = STATE(9444),
    [sym_do] = STATE(9444),
    [sym_record_assignments] = STATE(5168),
    [sym_field_assignments] = STATE(5168),
    [aux_sym__typed_bindings] = STATE(8654),
    [sym_typed_binding] = STATE(8654),
    [sym_literal] = STATE(5168),
    [sym_SetN] = STATE(5168),
    [aux_sym__modal_arg_ids_repeat1] = STATE(5830),
    [aux_sym__with_exprs_repeat1] = STATE(3754),
    [sym_id] = ACTIONS(850),
    [anon_sym_forall] = ACTIONS(852),
    [anon_sym_u2200] = ACTIONS(852),
    [anon_sym_BSLASH] = ACTIONS(854),
    [anon_sym_u03bb] = ACTIONS(856),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(858),
    [anon_sym_u2026] = ACTIONS(858),
    [anon_sym_record] = ACTIONS(860),
    [anon_sym_LPAREN] = ACTIONS(862),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(864),
    [anon_sym_u2983] = ACTIONS(866),
    [anon_sym_u2984] = ACTIONS(1134),
    [anon_sym__] = ACTIONS(858),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(870),
    [aux_sym__qid_token1] = ACTIONS(872),
    [anon_sym_DOT] = ACTIONS(874),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(712),
    [anon_sym_quoteGoal] = ACTIONS(878),
    [anon_sym_tactic] = ACTIONS(880),
    [anon_sym_Prop] = ACTIONS(858),
    [anon_sym_quote] = ACTIONS(858),
    [anon_sym_quoteTerm] = ACTIONS(858),
    [anon_sym_quoteContext] = ACTIONS(858),
    [anon_sym_unquote] = ACTIONS(858),
    [anon_sym_LPAREN_PIPE] = ACTIONS(882),
    [anon_sym_u2987] = ACTIONS(884),
    [anon_sym_let] = ACTIONS(886),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(890),
    [aux_sym_string_token1] = ACTIONS(890),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(892),
    [sym_PropN] = ACTIONS(858),
  },
  [546] = {
    [sym__FORALL] = STATE(8355),
    [sym__LAMBDA] = STATE(8054),
    [sym__ELLIPSIS] = STATE(4742),
    [sym__qid] = STATE(4742),
    [sym__binding_ids_and_absurds] = STATE(12547),
    [sym_attribute] = STATE(5830),
    [sym_attributes] = STATE(3506),
    [sym_expr] = STATE(11608),
    [sym__with_exprs] = STATE(10050),
    [sym__expr_or_attr] = STATE(4742),
    [sym__application] = STATE(9444),
    [sym__expr2_without_let] = STATE(9444),
    [sym__expr2] = STATE(9444),
    [sym_atom] = STATE(4712),
    [aux_sym__atoms] = STATE(3276),
    [sym__atom_curly] = STATE(4733),
    [sym__atom_no_curly] = STATE(4733),
    [sym_forall] = STATE(9444),
    [sym_let] = STATE(9444),
    [sym_lambda] = STATE(9444),
    [sym_lambda_extended_or_absurd] = STATE(9444),
    [sym_do] = STATE(9444),
    [sym_record_assignments] = STATE(4742),
    [sym_field_assignments] = STATE(4742),
    [aux_sym__typed_bindings] = STATE(8646),
    [sym_typed_binding] = STATE(8646),
    [sym_literal] = STATE(4742),
    [sym_SetN] = STATE(4742),
    [aux_sym__modal_arg_ids_repeat1] = STATE(5830),
    [aux_sym__with_exprs_repeat1] = STATE(3745),
    [sym_id] = ACTIONS(940),
    [anon_sym_forall] = ACTIONS(942),
    [anon_sym_u2200] = ACTIONS(942),
    [anon_sym_BSLASH] = ACTIONS(944),
    [anon_sym_u03bb] = ACTIONS(946),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(948),
    [anon_sym_u2026] = ACTIONS(948),
    [anon_sym_record] = ACTIONS(950),
    [anon_sym_LPAREN] = ACTIONS(952),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(954),
    [anon_sym_RBRACE_RBRACE] = ACTIONS(1134),
    [anon_sym_u2983] = ACTIONS(956),
    [anon_sym__] = ACTIONS(948),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(958),
    [aux_sym__qid_token1] = ACTIONS(960),
    [anon_sym_DOT] = ACTIONS(962),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(712),
    [anon_sym_quoteGoal] = ACTIONS(964),
    [anon_sym_tactic] = ACTIONS(966),
    [anon_sym_Prop] = ACTIONS(948),
    [anon_sym_quote] = ACTIONS(948),
    [anon_sym_quoteTerm] = ACTIONS(948),
    [anon_sym_quoteContext] = ACTIONS(948),
    [anon_sym_unquote] = ACTIONS(948),
    [anon_sym_LPAREN_PIPE] = ACTIONS(968),
    [anon_sym_u2987] = ACTIONS(970),
    [anon_sym_let] = ACTIONS(972),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(974),
    [aux_sym_string_token1] = ACTIONS(974),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(976),
    [sym_PropN] = ACTIONS(948),
  },
  [547] = {
    [sym__FORALL] = STATE(8345),
    [sym__LAMBDA] = STATE(8095),
    [sym__ELLIPSIS] = STATE(4742),
    [sym_open] = STATE(12555),
    [sym__qid] = STATE(4742),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3873),
    [sym_expr] = STATE(12512),
    [sym__with_exprs] = STATE(10084),
    [sym__expr_or_attr] = STATE(4742),
    [sym__application] = STATE(9680),
    [sym__expr2_without_let] = STATE(9680),
    [sym__expr2] = STATE(9680),
    [sym_atom] = STATE(4712),
    [aux_sym__atoms] = STATE(3211),
    [sym__atom_curly] = STATE(4733),
    [sym__atom_no_curly] = STATE(4733),
    [sym_forall] = STATE(9680),
    [sym_let] = STATE(9680),
    [sym_lambda] = STATE(9680),
    [sym_lambda_extended_or_absurd] = STATE(9680),
    [sym_do] = STATE(9680),
    [sym_record_assignments] = STATE(4742),
    [sym_field_assignments] = STATE(4742),
    [aux_sym__typed_bindings] = STATE(8642),
    [sym_typed_binding] = STATE(8642),
    [sym_literal] = STATE(4742),
    [sym_SetN] = STATE(4742),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3728),
    [sym_id] = ACTIONS(940),
    [anon_sym_forall] = ACTIONS(980),
    [anon_sym_u2200] = ACTIONS(980),
    [anon_sym_BSLASH] = ACTIONS(982),
    [anon_sym_u03bb] = ACTIONS(984),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(948),
    [anon_sym_u2026] = ACTIONS(948),
    [anon_sym_record] = ACTIONS(950),
    [anon_sym_open] = ACTIONS(986),
    [anon_sym_LPAREN] = ACTIONS(952),
    [anon_sym_RPAREN] = ACTIONS(1118),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(954),
    [anon_sym_u2983] = ACTIONS(956),
    [anon_sym__] = ACTIONS(948),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(958),
    [aux_sym__qid_token1] = ACTIONS(960),
    [anon_sym_DOT] = ACTIONS(962),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(988),
    [anon_sym_tactic] = ACTIONS(990),
    [anon_sym_Prop] = ACTIONS(948),
    [anon_sym_quote] = ACTIONS(948),
    [anon_sym_quoteTerm] = ACTIONS(948),
    [anon_sym_quoteContext] = ACTIONS(948),
    [anon_sym_unquote] = ACTIONS(948),
    [anon_sym_LPAREN_PIPE] = ACTIONS(968),
    [anon_sym_u2987] = ACTIONS(970),
    [anon_sym_let] = ACTIONS(992),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(974),
    [aux_sym_string_token1] = ACTIONS(974),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(976),
    [sym_PropN] = ACTIONS(948),
  },
  [548] = {
    [sym__FORALL] = STATE(8345),
    [sym__LAMBDA] = STATE(8095),
    [sym__ELLIPSIS] = STATE(4742),
    [sym_open] = STATE(12555),
    [sym__qid] = STATE(4742),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3873),
    [sym_expr] = STATE(11559),
    [sym__with_exprs] = STATE(10084),
    [sym__expr_or_attr] = STATE(4742),
    [sym__application] = STATE(9680),
    [sym__expr2_without_let] = STATE(9680),
    [sym__expr2] = STATE(9680),
    [sym_atom] = STATE(4712),
    [aux_sym__atoms] = STATE(3211),
    [sym__atom_curly] = STATE(4733),
    [sym__atom_no_curly] = STATE(4733),
    [sym_forall] = STATE(9680),
    [sym_let] = STATE(9680),
    [sym_lambda] = STATE(9680),
    [sym_lambda_extended_or_absurd] = STATE(9680),
    [sym_do] = STATE(9680),
    [sym_record_assignments] = STATE(4742),
    [sym_field_assignments] = STATE(4742),
    [aux_sym__typed_bindings] = STATE(8642),
    [sym_typed_binding] = STATE(8642),
    [sym_literal] = STATE(4742),
    [sym_SetN] = STATE(4742),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3728),
    [sym_id] = ACTIONS(940),
    [anon_sym_forall] = ACTIONS(980),
    [anon_sym_u2200] = ACTIONS(980),
    [anon_sym_BSLASH] = ACTIONS(982),
    [anon_sym_u03bb] = ACTIONS(984),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(948),
    [anon_sym_u2026] = ACTIONS(948),
    [anon_sym_record] = ACTIONS(950),
    [anon_sym_open] = ACTIONS(986),
    [anon_sym_LPAREN] = ACTIONS(952),
    [anon_sym_RPAREN] = ACTIONS(1134),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(954),
    [anon_sym_u2983] = ACTIONS(956),
    [anon_sym__] = ACTIONS(948),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(958),
    [aux_sym__qid_token1] = ACTIONS(960),
    [anon_sym_DOT] = ACTIONS(962),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(988),
    [anon_sym_tactic] = ACTIONS(990),
    [anon_sym_Prop] = ACTIONS(948),
    [anon_sym_quote] = ACTIONS(948),
    [anon_sym_quoteTerm] = ACTIONS(948),
    [anon_sym_quoteContext] = ACTIONS(948),
    [anon_sym_unquote] = ACTIONS(948),
    [anon_sym_LPAREN_PIPE] = ACTIONS(968),
    [anon_sym_u2987] = ACTIONS(970),
    [anon_sym_let] = ACTIONS(992),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(974),
    [aux_sym_string_token1] = ACTIONS(974),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(976),
    [sym_PropN] = ACTIONS(948),
  },
  [549] = {
    [sym__FORALL] = STATE(8355),
    [sym__LAMBDA] = STATE(8054),
    [sym__ELLIPSIS] = STATE(4742),
    [sym__qid] = STATE(4742),
    [sym__binding_ids_and_absurds] = STATE(12547),
    [sym_attribute] = STATE(5830),
    [sym_attributes] = STATE(3506),
    [sym_expr] = STATE(10812),
    [sym__with_exprs] = STATE(10050),
    [sym__expr_or_attr] = STATE(4742),
    [sym__application] = STATE(9444),
    [sym__expr2_without_let] = STATE(9444),
    [sym__expr2] = STATE(9444),
    [sym_atom] = STATE(4712),
    [aux_sym__atoms] = STATE(3276),
    [sym__atom_curly] = STATE(4733),
    [sym__atom_no_curly] = STATE(4733),
    [sym_forall] = STATE(9444),
    [sym_let] = STATE(9444),
    [sym_lambda] = STATE(9444),
    [sym_lambda_extended_or_absurd] = STATE(9444),
    [sym_do] = STATE(9444),
    [sym_record_assignments] = STATE(4742),
    [sym_field_assignments] = STATE(4742),
    [aux_sym__typed_bindings] = STATE(8646),
    [sym_typed_binding] = STATE(8646),
    [sym_literal] = STATE(4742),
    [sym_SetN] = STATE(4742),
    [aux_sym__modal_arg_ids_repeat1] = STATE(5830),
    [aux_sym__with_exprs_repeat1] = STATE(3745),
    [sym_id] = ACTIONS(940),
    [anon_sym_forall] = ACTIONS(942),
    [anon_sym_u2200] = ACTIONS(942),
    [anon_sym_BSLASH] = ACTIONS(944),
    [anon_sym_u03bb] = ACTIONS(946),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(948),
    [anon_sym_u2026] = ACTIONS(948),
    [anon_sym_record] = ACTIONS(950),
    [anon_sym_LPAREN] = ACTIONS(952),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(954),
    [anon_sym_RBRACE_RBRACE] = ACTIONS(1136),
    [anon_sym_u2983] = ACTIONS(956),
    [anon_sym__] = ACTIONS(948),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(958),
    [aux_sym__qid_token1] = ACTIONS(960),
    [anon_sym_DOT] = ACTIONS(962),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(712),
    [anon_sym_quoteGoal] = ACTIONS(964),
    [anon_sym_tactic] = ACTIONS(966),
    [anon_sym_Prop] = ACTIONS(948),
    [anon_sym_quote] = ACTIONS(948),
    [anon_sym_quoteTerm] = ACTIONS(948),
    [anon_sym_quoteContext] = ACTIONS(948),
    [anon_sym_unquote] = ACTIONS(948),
    [anon_sym_LPAREN_PIPE] = ACTIONS(968),
    [anon_sym_u2987] = ACTIONS(970),
    [anon_sym_let] = ACTIONS(972),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(974),
    [aux_sym_string_token1] = ACTIONS(974),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(976),
    [sym_PropN] = ACTIONS(948),
  },
  [550] = {
    [sym__FORALL] = STATE(8369),
    [sym__LAMBDA] = STATE(8152),
    [sym__ELLIPSIS] = STATE(5168),
    [sym__qid] = STATE(5168),
    [sym__binding_ids_and_absurds] = STATE(12544),
    [sym_attribute] = STATE(5830),
    [sym_attributes] = STATE(3505),
    [sym_expr] = STATE(10811),
    [sym__with_exprs] = STATE(9861),
    [sym__expr_or_attr] = STATE(5168),
    [sym__application] = STATE(9444),
    [sym__expr2_without_let] = STATE(9444),
    [sym__expr2] = STATE(9444),
    [sym_atom] = STATE(5204),
    [aux_sym__atoms] = STATE(3133),
    [sym__atom_curly] = STATE(5180),
    [sym__atom_no_curly] = STATE(5180),
    [sym_forall] = STATE(9444),
    [sym_let] = STATE(9444),
    [sym_lambda] = STATE(9444),
    [sym_lambda_extended_or_absurd] = STATE(9444),
    [sym_do] = STATE(9444),
    [sym_record_assignments] = STATE(5168),
    [sym_field_assignments] = STATE(5168),
    [aux_sym__typed_bindings] = STATE(8654),
    [sym_typed_binding] = STATE(8654),
    [sym_literal] = STATE(5168),
    [sym_SetN] = STATE(5168),
    [aux_sym__modal_arg_ids_repeat1] = STATE(5830),
    [aux_sym__with_exprs_repeat1] = STATE(3754),
    [sym_id] = ACTIONS(850),
    [anon_sym_forall] = ACTIONS(852),
    [anon_sym_u2200] = ACTIONS(852),
    [anon_sym_BSLASH] = ACTIONS(854),
    [anon_sym_u03bb] = ACTIONS(856),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(858),
    [anon_sym_u2026] = ACTIONS(858),
    [anon_sym_record] = ACTIONS(860),
    [anon_sym_LPAREN] = ACTIONS(862),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(864),
    [anon_sym_u2983] = ACTIONS(866),
    [anon_sym_u2984] = ACTIONS(1136),
    [anon_sym__] = ACTIONS(858),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(870),
    [aux_sym__qid_token1] = ACTIONS(872),
    [anon_sym_DOT] = ACTIONS(874),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(712),
    [anon_sym_quoteGoal] = ACTIONS(878),
    [anon_sym_tactic] = ACTIONS(880),
    [anon_sym_Prop] = ACTIONS(858),
    [anon_sym_quote] = ACTIONS(858),
    [anon_sym_quoteTerm] = ACTIONS(858),
    [anon_sym_quoteContext] = ACTIONS(858),
    [anon_sym_unquote] = ACTIONS(858),
    [anon_sym_LPAREN_PIPE] = ACTIONS(882),
    [anon_sym_u2987] = ACTIONS(884),
    [anon_sym_let] = ACTIONS(886),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(890),
    [aux_sym_string_token1] = ACTIONS(890),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(892),
    [sym_PropN] = ACTIONS(858),
  },
  [551] = {
    [sym__FORALL] = STATE(8396),
    [sym__LAMBDA] = STATE(8031),
    [sym__ELLIPSIS] = STATE(4920),
    [sym__qid] = STATE(4920),
    [sym__binding_ids_and_absurds] = STATE(12539),
    [sym_attribute] = STATE(5830),
    [sym_attributes] = STATE(3504),
    [sym_expr] = STATE(10847),
    [sym__with_exprs] = STATE(10196),
    [sym__expr_or_attr] = STATE(4920),
    [sym__application] = STATE(9678),
    [sym__expr2_without_let] = STATE(9678),
    [sym__expr2] = STATE(9678),
    [sym_atom] = STATE(5202),
    [aux_sym__atoms] = STATE(3165),
    [sym__atom_curly] = STATE(4961),
    [sym__atom_no_curly] = STATE(4961),
    [sym_forall] = STATE(9678),
    [sym_let] = STATE(9678),
    [sym_lambda] = STATE(9678),
    [sym_lambda_extended_or_absurd] = STATE(9678),
    [sym_do] = STATE(9678),
    [sym_record_assignments] = STATE(4920),
    [sym_field_assignments] = STATE(4920),
    [aux_sym__typed_bindings] = STATE(8648),
    [sym_typed_binding] = STATE(8648),
    [sym_literal] = STATE(4920),
    [sym_SetN] = STATE(4920),
    [aux_sym__modal_arg_ids_repeat1] = STATE(5830),
    [aux_sym__with_exprs_repeat1] = STATE(3726),
    [sym_id] = ACTIONS(894),
    [anon_sym_forall] = ACTIONS(896),
    [anon_sym_u2200] = ACTIONS(896),
    [anon_sym_BSLASH] = ACTIONS(898),
    [anon_sym_u03bb] = ACTIONS(900),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(902),
    [anon_sym_u2026] = ACTIONS(902),
    [anon_sym_record] = ACTIONS(904),
    [anon_sym_LPAREN] = ACTIONS(906),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(908),
    [anon_sym_u2983] = ACTIONS(910),
    [anon_sym__] = ACTIONS(902),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(912),
    [anon_sym_RBRACE] = ACTIONS(1138),
    [aux_sym__qid_token1] = ACTIONS(916),
    [anon_sym_DOT] = ACTIONS(918),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(712),
    [anon_sym_quoteGoal] = ACTIONS(920),
    [anon_sym_tactic] = ACTIONS(922),
    [anon_sym_Prop] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(902),
    [anon_sym_quoteTerm] = ACTIONS(902),
    [anon_sym_quoteContext] = ACTIONS(902),
    [anon_sym_unquote] = ACTIONS(902),
    [anon_sym_LPAREN_PIPE] = ACTIONS(924),
    [anon_sym_u2987] = ACTIONS(926),
    [anon_sym_let] = ACTIONS(928),
    [anon_sym_do] = ACTIONS(724),
    [aux_sym_integer_token1] = ACTIONS(930),
    [aux_sym_string_token1] = ACTIONS(930),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(932),
    [sym_PropN] = ACTIONS(902),
  },
  [552] = {
    [sym__FORALL] = STATE(8345),
    [sym__LAMBDA] = STATE(8095),
    [sym__ELLIPSIS] = STATE(4742),
    [sym_open] = STATE(12555),
    [sym__qid] = STATE(4742),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3873),
    [sym_expr] = STATE(11911),
    [sym__with_exprs] = STATE(10084),
    [sym__expr_or_attr] = STATE(4742),
    [sym__application] = STATE(9680),
    [sym__expr2_without_let] = STATE(9680),
    [sym__expr2] = STATE(9680),
    [sym_atom] = STATE(4712),
    [aux_sym__atoms] = STATE(3211),
    [sym__atom_curly] = STATE(4733),
    [sym__atom_no_curly] = STATE(4733),
    [sym_forall] = STATE(9680),
    [sym_let] = STATE(9680),
    [sym_lambda] = STATE(9680),
    [sym_lambda_extended_or_absurd] = STATE(9680),
    [sym_do] = STATE(9680),
    [sym_record_assignments] = STATE(4742),
    [sym_field_assignments] = STATE(4742),
    [aux_sym__typed_bindings] = STATE(8642),
    [sym_typed_binding] = STATE(8642),
    [sym_literal] = STATE(4742),
    [sym_SetN] = STATE(4742),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3728),
    [sym_id] = ACTIONS(940),
    [anon_sym_forall] = ACTIONS(980),
    [anon_sym_u2200] = ACTIONS(980),
    [anon_sym_BSLASH] = ACTIONS(982),
    [anon_sym_u03bb] = ACTIONS(984),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(948),
    [anon_sym_u2026] = ACTIONS(948),
    [anon_sym_record] = ACTIONS(950),
    [anon_sym_open] = ACTIONS(986),
    [anon_sym_LPAREN] = ACTIONS(952),
    [anon_sym_RPAREN] = ACTIONS(1140),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(954),
    [anon_sym_u2983] = ACTIONS(956),
    [anon_sym__] = ACTIONS(948),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(958),
    [aux_sym__qid_token1] = ACTIONS(960),
    [anon_sym_DOT] = ACTIONS(962),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(988),
    [anon_sym_tactic] = ACTIONS(990),
    [anon_sym_Prop] = ACTIONS(948),
    [anon_sym_quote] = ACTIONS(948),
    [anon_sym_quoteTerm] = ACTIONS(948),
    [anon_sym_quoteContext] = ACTIONS(948),
    [anon_sym_unquote] = ACTIONS(948),
    [anon_sym_LPAREN_PIPE] = ACTIONS(968),
    [anon_sym_u2987] = ACTIONS(970),
    [anon_sym_let] = ACTIONS(992),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(974),
    [aux_sym_string_token1] = ACTIONS(974),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(976),
    [sym_PropN] = ACTIONS(948),
  },
  [553] = {
    [sym__FORALL] = STATE(8396),
    [sym__LAMBDA] = STATE(8031),
    [sym__ELLIPSIS] = STATE(4920),
    [sym__qid] = STATE(4920),
    [sym__binding_ids_and_absurds] = STATE(12357),
    [sym_attribute] = STATE(7725),
    [sym_attributes] = STATE(6200),
    [sym_expr] = STATE(11628),
    [sym__with_exprs] = STATE(10196),
    [sym__expr_or_attr] = STATE(4920),
    [sym__application] = STATE(9678),
    [sym__expr2_without_let] = STATE(9678),
    [sym__expr2] = STATE(9678),
    [sym_atom] = STATE(5202),
    [aux_sym__atoms] = STATE(3165),
    [sym__atom_curly] = STATE(4961),
    [sym__atom_no_curly] = STATE(4961),
    [sym_forall] = STATE(9678),
    [sym_let] = STATE(9678),
    [sym_lambda] = STATE(9678),
    [sym_lambda_extended_or_absurd] = STATE(9678),
    [sym_do] = STATE(9678),
    [sym_record_assignments] = STATE(4920),
    [sym_field_assignments] = STATE(4920),
    [aux_sym__typed_bindings] = STATE(8648),
    [sym_typed_binding] = STATE(8648),
    [sym_literal] = STATE(4920),
    [sym_SetN] = STATE(4920),
    [aux_sym__modal_arg_ids_repeat1] = STATE(7725),
    [aux_sym__with_exprs_repeat1] = STATE(3726),
    [sym_id] = ACTIONS(894),
    [anon_sym_forall] = ACTIONS(896),
    [anon_sym_u2200] = ACTIONS(896),
    [anon_sym_BSLASH] = ACTIONS(898),
    [anon_sym_u03bb] = ACTIONS(900),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(902),
    [anon_sym_u2026] = ACTIONS(902),
    [anon_sym_record] = ACTIONS(904),
    [anon_sym_LPAREN] = ACTIONS(906),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(908),
    [anon_sym_u2983] = ACTIONS(910),
    [anon_sym__] = ACTIONS(902),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(912),
    [anon_sym_RBRACE] = ACTIONS(1142),
    [aux_sym__qid_token1] = ACTIONS(916),
    [anon_sym_DOT] = ACTIONS(918),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(760),
    [anon_sym_quoteGoal] = ACTIONS(920),
    [anon_sym_tactic] = ACTIONS(922),
    [anon_sym_Prop] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(902),
    [anon_sym_quoteTerm] = ACTIONS(902),
    [anon_sym_quoteContext] = ACTIONS(902),
    [anon_sym_unquote] = ACTIONS(902),
    [anon_sym_LPAREN_PIPE] = ACTIONS(924),
    [anon_sym_u2987] = ACTIONS(926),
    [anon_sym_let] = ACTIONS(928),
    [anon_sym_do] = ACTIONS(724),
    [aux_sym_integer_token1] = ACTIONS(930),
    [aux_sym_string_token1] = ACTIONS(930),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(932),
    [sym_PropN] = ACTIONS(902),
  },
  [554] = {
    [sym__FORALL] = STATE(8396),
    [sym__LAMBDA] = STATE(8031),
    [sym__ELLIPSIS] = STATE(4920),
    [sym__qid] = STATE(4920),
    [sym__binding_ids_and_absurds] = STATE(12539),
    [sym_attribute] = STATE(5830),
    [sym_attributes] = STATE(3504),
    [sym_expr] = STATE(11437),
    [sym__with_exprs] = STATE(10196),
    [sym__expr_or_attr] = STATE(4920),
    [sym__application] = STATE(9678),
    [sym__expr2_without_let] = STATE(9678),
    [sym__expr2] = STATE(9678),
    [sym_atom] = STATE(5202),
    [aux_sym__atoms] = STATE(3165),
    [sym__atom_curly] = STATE(4961),
    [sym__atom_no_curly] = STATE(4961),
    [sym_forall] = STATE(9678),
    [sym_let] = STATE(9678),
    [sym_lambda] = STATE(9678),
    [sym_lambda_extended_or_absurd] = STATE(9678),
    [sym_do] = STATE(9678),
    [sym_record_assignments] = STATE(4920),
    [sym_field_assignments] = STATE(4920),
    [aux_sym__typed_bindings] = STATE(8648),
    [sym_typed_binding] = STATE(8648),
    [sym_literal] = STATE(4920),
    [sym_SetN] = STATE(4920),
    [aux_sym__modal_arg_ids_repeat1] = STATE(5830),
    [aux_sym__with_exprs_repeat1] = STATE(3726),
    [sym_id] = ACTIONS(894),
    [anon_sym_forall] = ACTIONS(896),
    [anon_sym_u2200] = ACTIONS(896),
    [anon_sym_BSLASH] = ACTIONS(898),
    [anon_sym_u03bb] = ACTIONS(900),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(902),
    [anon_sym_u2026] = ACTIONS(902),
    [anon_sym_record] = ACTIONS(904),
    [anon_sym_LPAREN] = ACTIONS(906),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(908),
    [anon_sym_u2983] = ACTIONS(910),
    [anon_sym__] = ACTIONS(902),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(912),
    [anon_sym_RBRACE] = ACTIONS(1130),
    [aux_sym__qid_token1] = ACTIONS(916),
    [anon_sym_DOT] = ACTIONS(918),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(712),
    [anon_sym_quoteGoal] = ACTIONS(920),
    [anon_sym_tactic] = ACTIONS(922),
    [anon_sym_Prop] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(902),
    [anon_sym_quoteTerm] = ACTIONS(902),
    [anon_sym_quoteContext] = ACTIONS(902),
    [anon_sym_unquote] = ACTIONS(902),
    [anon_sym_LPAREN_PIPE] = ACTIONS(924),
    [anon_sym_u2987] = ACTIONS(926),
    [anon_sym_let] = ACTIONS(928),
    [anon_sym_do] = ACTIONS(724),
    [aux_sym_integer_token1] = ACTIONS(930),
    [aux_sym_string_token1] = ACTIONS(930),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(932),
    [sym_PropN] = ACTIONS(902),
  },
  [555] = {
    [sym__FORALL] = STATE(8355),
    [sym__LAMBDA] = STATE(8054),
    [sym__ELLIPSIS] = STATE(4742),
    [sym__qid] = STATE(4742),
    [sym__binding_ids_and_absurds] = STATE(12547),
    [sym_attribute] = STATE(5830),
    [sym_attributes] = STATE(3506),
    [sym_expr] = STATE(11952),
    [sym__with_exprs] = STATE(10050),
    [sym__expr_or_attr] = STATE(4742),
    [sym__application] = STATE(9444),
    [sym__expr2_without_let] = STATE(9444),
    [sym__expr2] = STATE(9444),
    [sym_atom] = STATE(4712),
    [aux_sym__atoms] = STATE(3276),
    [sym__atom_curly] = STATE(4733),
    [sym__atom_no_curly] = STATE(4733),
    [sym_forall] = STATE(9444),
    [sym_let] = STATE(9444),
    [sym_lambda] = STATE(9444),
    [sym_lambda_extended_or_absurd] = STATE(9444),
    [sym_do] = STATE(9444),
    [sym_record_assignments] = STATE(4742),
    [sym_field_assignments] = STATE(4742),
    [aux_sym__typed_bindings] = STATE(8646),
    [sym_typed_binding] = STATE(8646),
    [sym_literal] = STATE(4742),
    [sym_SetN] = STATE(4742),
    [aux_sym__modal_arg_ids_repeat1] = STATE(5830),
    [aux_sym__with_exprs_repeat1] = STATE(3745),
    [sym_id] = ACTIONS(940),
    [anon_sym_forall] = ACTIONS(942),
    [anon_sym_u2200] = ACTIONS(942),
    [anon_sym_BSLASH] = ACTIONS(944),
    [anon_sym_u03bb] = ACTIONS(946),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(948),
    [anon_sym_u2026] = ACTIONS(948),
    [anon_sym_record] = ACTIONS(950),
    [anon_sym_LPAREN] = ACTIONS(952),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(954),
    [anon_sym_RBRACE_RBRACE] = ACTIONS(1140),
    [anon_sym_u2983] = ACTIONS(956),
    [anon_sym__] = ACTIONS(948),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(958),
    [aux_sym__qid_token1] = ACTIONS(960),
    [anon_sym_DOT] = ACTIONS(962),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(712),
    [anon_sym_quoteGoal] = ACTIONS(964),
    [anon_sym_tactic] = ACTIONS(966),
    [anon_sym_Prop] = ACTIONS(948),
    [anon_sym_quote] = ACTIONS(948),
    [anon_sym_quoteTerm] = ACTIONS(948),
    [anon_sym_quoteContext] = ACTIONS(948),
    [anon_sym_unquote] = ACTIONS(948),
    [anon_sym_LPAREN_PIPE] = ACTIONS(968),
    [anon_sym_u2987] = ACTIONS(970),
    [anon_sym_let] = ACTIONS(972),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(974),
    [aux_sym_string_token1] = ACTIONS(974),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(976),
    [sym_PropN] = ACTIONS(948),
  },
  [556] = {
    [sym__FORALL] = STATE(8369),
    [sym__LAMBDA] = STATE(8152),
    [sym__ELLIPSIS] = STATE(5168),
    [sym__qid] = STATE(5168),
    [sym__binding_ids_and_absurds] = STATE(12358),
    [sym_attribute] = STATE(7725),
    [sym_attributes] = STATE(6182),
    [sym_expr] = STATE(11629),
    [sym__with_exprs] = STATE(9861),
    [sym__expr_or_attr] = STATE(5168),
    [sym__application] = STATE(9444),
    [sym__expr2_without_let] = STATE(9444),
    [sym__expr2] = STATE(9444),
    [sym_atom] = STATE(5204),
    [aux_sym__atoms] = STATE(3133),
    [sym__atom_curly] = STATE(5180),
    [sym__atom_no_curly] = STATE(5180),
    [sym_forall] = STATE(9444),
    [sym_let] = STATE(9444),
    [sym_lambda] = STATE(9444),
    [sym_lambda_extended_or_absurd] = STATE(9444),
    [sym_do] = STATE(9444),
    [sym_record_assignments] = STATE(5168),
    [sym_field_assignments] = STATE(5168),
    [aux_sym__typed_bindings] = STATE(8654),
    [sym_typed_binding] = STATE(8654),
    [sym_literal] = STATE(5168),
    [sym_SetN] = STATE(5168),
    [aux_sym__modal_arg_ids_repeat1] = STATE(7725),
    [aux_sym__with_exprs_repeat1] = STATE(3754),
    [sym_id] = ACTIONS(850),
    [anon_sym_forall] = ACTIONS(852),
    [anon_sym_u2200] = ACTIONS(852),
    [anon_sym_BSLASH] = ACTIONS(854),
    [anon_sym_u03bb] = ACTIONS(856),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(858),
    [anon_sym_u2026] = ACTIONS(858),
    [anon_sym_record] = ACTIONS(860),
    [anon_sym_LPAREN] = ACTIONS(862),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(864),
    [anon_sym_u2983] = ACTIONS(866),
    [anon_sym_u2984] = ACTIONS(1144),
    [anon_sym__] = ACTIONS(858),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(870),
    [aux_sym__qid_token1] = ACTIONS(872),
    [anon_sym_DOT] = ACTIONS(874),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(760),
    [anon_sym_quoteGoal] = ACTIONS(878),
    [anon_sym_tactic] = ACTIONS(880),
    [anon_sym_Prop] = ACTIONS(858),
    [anon_sym_quote] = ACTIONS(858),
    [anon_sym_quoteTerm] = ACTIONS(858),
    [anon_sym_quoteContext] = ACTIONS(858),
    [anon_sym_unquote] = ACTIONS(858),
    [anon_sym_LPAREN_PIPE] = ACTIONS(882),
    [anon_sym_u2987] = ACTIONS(884),
    [anon_sym_let] = ACTIONS(886),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(890),
    [aux_sym_string_token1] = ACTIONS(890),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(892),
    [sym_PropN] = ACTIONS(858),
  },
  [557] = {
    [sym__FORALL] = STATE(8369),
    [sym__LAMBDA] = STATE(8152),
    [sym__ELLIPSIS] = STATE(5168),
    [sym__qid] = STATE(5168),
    [sym__binding_ids_and_absurds] = STATE(12544),
    [sym_attribute] = STATE(5830),
    [sym_attributes] = STATE(3505),
    [sym_expr] = STATE(11951),
    [sym__with_exprs] = STATE(9861),
    [sym__expr_or_attr] = STATE(5168),
    [sym__application] = STATE(9444),
    [sym__expr2_without_let] = STATE(9444),
    [sym__expr2] = STATE(9444),
    [sym_atom] = STATE(5204),
    [aux_sym__atoms] = STATE(3133),
    [sym__atom_curly] = STATE(5180),
    [sym__atom_no_curly] = STATE(5180),
    [sym_forall] = STATE(9444),
    [sym_let] = STATE(9444),
    [sym_lambda] = STATE(9444),
    [sym_lambda_extended_or_absurd] = STATE(9444),
    [sym_do] = STATE(9444),
    [sym_record_assignments] = STATE(5168),
    [sym_field_assignments] = STATE(5168),
    [aux_sym__typed_bindings] = STATE(8654),
    [sym_typed_binding] = STATE(8654),
    [sym_literal] = STATE(5168),
    [sym_SetN] = STATE(5168),
    [aux_sym__modal_arg_ids_repeat1] = STATE(5830),
    [aux_sym__with_exprs_repeat1] = STATE(3754),
    [sym_id] = ACTIONS(850),
    [anon_sym_forall] = ACTIONS(852),
    [anon_sym_u2200] = ACTIONS(852),
    [anon_sym_BSLASH] = ACTIONS(854),
    [anon_sym_u03bb] = ACTIONS(856),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(858),
    [anon_sym_u2026] = ACTIONS(858),
    [anon_sym_record] = ACTIONS(860),
    [anon_sym_LPAREN] = ACTIONS(862),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(864),
    [anon_sym_u2983] = ACTIONS(866),
    [anon_sym_u2984] = ACTIONS(1140),
    [anon_sym__] = ACTIONS(858),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(870),
    [aux_sym__qid_token1] = ACTIONS(872),
    [anon_sym_DOT] = ACTIONS(874),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(712),
    [anon_sym_quoteGoal] = ACTIONS(878),
    [anon_sym_tactic] = ACTIONS(880),
    [anon_sym_Prop] = ACTIONS(858),
    [anon_sym_quote] = ACTIONS(858),
    [anon_sym_quoteTerm] = ACTIONS(858),
    [anon_sym_quoteContext] = ACTIONS(858),
    [anon_sym_unquote] = ACTIONS(858),
    [anon_sym_LPAREN_PIPE] = ACTIONS(882),
    [anon_sym_u2987] = ACTIONS(884),
    [anon_sym_let] = ACTIONS(886),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(890),
    [aux_sym_string_token1] = ACTIONS(890),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(892),
    [sym_PropN] = ACTIONS(858),
  },
  [558] = {
    [sym__FORALL] = STATE(8369),
    [sym__LAMBDA] = STATE(8152),
    [sym__ELLIPSIS] = STATE(5168),
    [sym__qid] = STATE(5168),
    [sym__binding_ids_and_absurds] = STATE(12544),
    [sym_attribute] = STATE(5830),
    [sym_attributes] = STATE(3505),
    [sym_expr] = STATE(11436),
    [sym__with_exprs] = STATE(9861),
    [sym__expr_or_attr] = STATE(5168),
    [sym__application] = STATE(9444),
    [sym__expr2_without_let] = STATE(9444),
    [sym__expr2] = STATE(9444),
    [sym_atom] = STATE(5204),
    [aux_sym__atoms] = STATE(3133),
    [sym__atom_curly] = STATE(5180),
    [sym__atom_no_curly] = STATE(5180),
    [sym_forall] = STATE(9444),
    [sym_let] = STATE(9444),
    [sym_lambda] = STATE(9444),
    [sym_lambda_extended_or_absurd] = STATE(9444),
    [sym_do] = STATE(9444),
    [sym_record_assignments] = STATE(5168),
    [sym_field_assignments] = STATE(5168),
    [aux_sym__typed_bindings] = STATE(8654),
    [sym_typed_binding] = STATE(8654),
    [sym_literal] = STATE(5168),
    [sym_SetN] = STATE(5168),
    [aux_sym__modal_arg_ids_repeat1] = STATE(5830),
    [aux_sym__with_exprs_repeat1] = STATE(3754),
    [sym_id] = ACTIONS(850),
    [anon_sym_forall] = ACTIONS(852),
    [anon_sym_u2200] = ACTIONS(852),
    [anon_sym_BSLASH] = ACTIONS(854),
    [anon_sym_u03bb] = ACTIONS(856),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(858),
    [anon_sym_u2026] = ACTIONS(858),
    [anon_sym_record] = ACTIONS(860),
    [anon_sym_LPAREN] = ACTIONS(862),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(864),
    [anon_sym_u2983] = ACTIONS(866),
    [anon_sym_u2984] = ACTIONS(1132),
    [anon_sym__] = ACTIONS(858),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(870),
    [aux_sym__qid_token1] = ACTIONS(872),
    [anon_sym_DOT] = ACTIONS(874),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(712),
    [anon_sym_quoteGoal] = ACTIONS(878),
    [anon_sym_tactic] = ACTIONS(880),
    [anon_sym_Prop] = ACTIONS(858),
    [anon_sym_quote] = ACTIONS(858),
    [anon_sym_quoteTerm] = ACTIONS(858),
    [anon_sym_quoteContext] = ACTIONS(858),
    [anon_sym_unquote] = ACTIONS(858),
    [anon_sym_LPAREN_PIPE] = ACTIONS(882),
    [anon_sym_u2987] = ACTIONS(884),
    [anon_sym_let] = ACTIONS(886),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(890),
    [aux_sym_string_token1] = ACTIONS(890),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(892),
    [sym_PropN] = ACTIONS(858),
  },
  [559] = {
    [sym__FORALL] = STATE(8355),
    [sym__LAMBDA] = STATE(8054),
    [sym__ELLIPSIS] = STATE(4742),
    [sym__qid] = STATE(4742),
    [sym__binding_ids_and_absurds] = STATE(12359),
    [sym_attribute] = STATE(7725),
    [sym_attributes] = STATE(6302),
    [sym_expr] = STATE(11630),
    [sym__with_exprs] = STATE(10050),
    [sym__expr_or_attr] = STATE(4742),
    [sym__application] = STATE(9444),
    [sym__expr2_without_let] = STATE(9444),
    [sym__expr2] = STATE(9444),
    [sym_atom] = STATE(4712),
    [aux_sym__atoms] = STATE(3276),
    [sym__atom_curly] = STATE(4733),
    [sym__atom_no_curly] = STATE(4733),
    [sym_forall] = STATE(9444),
    [sym_let] = STATE(9444),
    [sym_lambda] = STATE(9444),
    [sym_lambda_extended_or_absurd] = STATE(9444),
    [sym_do] = STATE(9444),
    [sym_record_assignments] = STATE(4742),
    [sym_field_assignments] = STATE(4742),
    [aux_sym__typed_bindings] = STATE(8646),
    [sym_typed_binding] = STATE(8646),
    [sym_literal] = STATE(4742),
    [sym_SetN] = STATE(4742),
    [aux_sym__modal_arg_ids_repeat1] = STATE(7725),
    [aux_sym__with_exprs_repeat1] = STATE(3745),
    [sym_id] = ACTIONS(940),
    [anon_sym_forall] = ACTIONS(942),
    [anon_sym_u2200] = ACTIONS(942),
    [anon_sym_BSLASH] = ACTIONS(944),
    [anon_sym_u03bb] = ACTIONS(946),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(948),
    [anon_sym_u2026] = ACTIONS(948),
    [anon_sym_record] = ACTIONS(950),
    [anon_sym_LPAREN] = ACTIONS(952),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(954),
    [anon_sym_RBRACE_RBRACE] = ACTIONS(1144),
    [anon_sym_u2983] = ACTIONS(956),
    [anon_sym__] = ACTIONS(948),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(958),
    [aux_sym__qid_token1] = ACTIONS(960),
    [anon_sym_DOT] = ACTIONS(962),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(760),
    [anon_sym_quoteGoal] = ACTIONS(964),
    [anon_sym_tactic] = ACTIONS(966),
    [anon_sym_Prop] = ACTIONS(948),
    [anon_sym_quote] = ACTIONS(948),
    [anon_sym_quoteTerm] = ACTIONS(948),
    [anon_sym_quoteContext] = ACTIONS(948),
    [anon_sym_unquote] = ACTIONS(948),
    [anon_sym_LPAREN_PIPE] = ACTIONS(968),
    [anon_sym_u2987] = ACTIONS(970),
    [anon_sym_let] = ACTIONS(972),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(974),
    [aux_sym_string_token1] = ACTIONS(974),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(976),
    [sym_PropN] = ACTIONS(948),
  },
  [560] = {
    [sym__FORALL] = STATE(8355),
    [sym__LAMBDA] = STATE(8054),
    [sym__ELLIPSIS] = STATE(4742),
    [sym__qid] = STATE(4742),
    [sym__binding_ids_and_absurds] = STATE(12547),
    [sym_attribute] = STATE(5830),
    [sym_attributes] = STATE(3506),
    [sym_expr] = STATE(11412),
    [sym__with_exprs] = STATE(10050),
    [sym__expr_or_attr] = STATE(4742),
    [sym__application] = STATE(9444),
    [sym__expr2_without_let] = STATE(9444),
    [sym__expr2] = STATE(9444),
    [sym_atom] = STATE(4712),
    [aux_sym__atoms] = STATE(3276),
    [sym__atom_curly] = STATE(4733),
    [sym__atom_no_curly] = STATE(4733),
    [sym_forall] = STATE(9444),
    [sym_let] = STATE(9444),
    [sym_lambda] = STATE(9444),
    [sym_lambda_extended_or_absurd] = STATE(9444),
    [sym_do] = STATE(9444),
    [sym_record_assignments] = STATE(4742),
    [sym_field_assignments] = STATE(4742),
    [aux_sym__typed_bindings] = STATE(8646),
    [sym_typed_binding] = STATE(8646),
    [sym_literal] = STATE(4742),
    [sym_SetN] = STATE(4742),
    [aux_sym__modal_arg_ids_repeat1] = STATE(5830),
    [aux_sym__with_exprs_repeat1] = STATE(3745),
    [sym_id] = ACTIONS(940),
    [anon_sym_forall] = ACTIONS(942),
    [anon_sym_u2200] = ACTIONS(942),
    [anon_sym_BSLASH] = ACTIONS(944),
    [anon_sym_u03bb] = ACTIONS(946),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(948),
    [anon_sym_u2026] = ACTIONS(948),
    [anon_sym_record] = ACTIONS(950),
    [anon_sym_LPAREN] = ACTIONS(952),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(954),
    [anon_sym_RBRACE_RBRACE] = ACTIONS(1132),
    [anon_sym_u2983] = ACTIONS(956),
    [anon_sym__] = ACTIONS(948),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(958),
    [aux_sym__qid_token1] = ACTIONS(960),
    [anon_sym_DOT] = ACTIONS(962),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(712),
    [anon_sym_quoteGoal] = ACTIONS(964),
    [anon_sym_tactic] = ACTIONS(966),
    [anon_sym_Prop] = ACTIONS(948),
    [anon_sym_quote] = ACTIONS(948),
    [anon_sym_quoteTerm] = ACTIONS(948),
    [anon_sym_quoteContext] = ACTIONS(948),
    [anon_sym_unquote] = ACTIONS(948),
    [anon_sym_LPAREN_PIPE] = ACTIONS(968),
    [anon_sym_u2987] = ACTIONS(970),
    [anon_sym_let] = ACTIONS(972),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(974),
    [aux_sym_string_token1] = ACTIONS(974),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(976),
    [sym_PropN] = ACTIONS(948),
  },
  [561] = {
    [sym__FORALL] = STATE(8345),
    [sym__LAMBDA] = STATE(8095),
    [sym__ELLIPSIS] = STATE(4742),
    [sym_open] = STATE(12555),
    [sym__qid] = STATE(4742),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3873),
    [sym_expr] = STATE(11786),
    [sym__with_exprs] = STATE(10084),
    [sym__expr_or_attr] = STATE(4742),
    [sym__application] = STATE(9680),
    [sym__expr2_without_let] = STATE(9680),
    [sym__expr2] = STATE(9680),
    [sym_atom] = STATE(4712),
    [aux_sym__atoms] = STATE(3211),
    [sym__atom_curly] = STATE(4733),
    [sym__atom_no_curly] = STATE(4733),
    [sym_forall] = STATE(9680),
    [sym_let] = STATE(9680),
    [sym_lambda] = STATE(9680),
    [sym_lambda_extended_or_absurd] = STATE(9680),
    [sym_do] = STATE(9680),
    [sym_record_assignments] = STATE(4742),
    [sym_field_assignments] = STATE(4742),
    [aux_sym__typed_bindings] = STATE(8642),
    [sym_typed_binding] = STATE(8642),
    [sym_literal] = STATE(4742),
    [sym_SetN] = STATE(4742),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3728),
    [sym_id] = ACTIONS(940),
    [anon_sym_forall] = ACTIONS(980),
    [anon_sym_u2200] = ACTIONS(980),
    [anon_sym_BSLASH] = ACTIONS(982),
    [anon_sym_u03bb] = ACTIONS(984),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(948),
    [anon_sym_u2026] = ACTIONS(948),
    [anon_sym_record] = ACTIONS(950),
    [anon_sym_open] = ACTIONS(986),
    [anon_sym_LPAREN] = ACTIONS(952),
    [anon_sym_RPAREN] = ACTIONS(1132),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(954),
    [anon_sym_u2983] = ACTIONS(956),
    [anon_sym__] = ACTIONS(948),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(958),
    [aux_sym__qid_token1] = ACTIONS(960),
    [anon_sym_DOT] = ACTIONS(962),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(988),
    [anon_sym_tactic] = ACTIONS(990),
    [anon_sym_Prop] = ACTIONS(948),
    [anon_sym_quote] = ACTIONS(948),
    [anon_sym_quoteTerm] = ACTIONS(948),
    [anon_sym_quoteContext] = ACTIONS(948),
    [anon_sym_unquote] = ACTIONS(948),
    [anon_sym_LPAREN_PIPE] = ACTIONS(968),
    [anon_sym_u2987] = ACTIONS(970),
    [anon_sym_let] = ACTIONS(992),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(974),
    [aux_sym_string_token1] = ACTIONS(974),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(976),
    [sym_PropN] = ACTIONS(948),
  },
  [562] = {
    [sym__FORALL] = STATE(8396),
    [sym__LAMBDA] = STATE(8031),
    [sym__ELLIPSIS] = STATE(4920),
    [sym__qid] = STATE(4920),
    [sym__binding_ids_and_absurds] = STATE(12357),
    [sym_attribute] = STATE(7725),
    [sym_attributes] = STATE(6200),
    [sym_expr] = STATE(11510),
    [sym__with_exprs] = STATE(10196),
    [sym__expr_or_attr] = STATE(4920),
    [sym__application] = STATE(9678),
    [sym__expr2_without_let] = STATE(9678),
    [sym__expr2] = STATE(9678),
    [sym_atom] = STATE(5202),
    [aux_sym__atoms] = STATE(3165),
    [sym__atom_curly] = STATE(4961),
    [sym__atom_no_curly] = STATE(4961),
    [sym_forall] = STATE(9678),
    [sym_let] = STATE(9678),
    [sym_lambda] = STATE(9678),
    [sym_lambda_extended_or_absurd] = STATE(9678),
    [sym_do] = STATE(9678),
    [sym_record_assignments] = STATE(4920),
    [sym_field_assignments] = STATE(4920),
    [aux_sym__typed_bindings] = STATE(8648),
    [sym_typed_binding] = STATE(8648),
    [sym_literal] = STATE(4920),
    [sym_SetN] = STATE(4920),
    [aux_sym__modal_arg_ids_repeat1] = STATE(7725),
    [aux_sym__with_exprs_repeat1] = STATE(3726),
    [sym_id] = ACTIONS(894),
    [anon_sym_forall] = ACTIONS(896),
    [anon_sym_u2200] = ACTIONS(896),
    [anon_sym_BSLASH] = ACTIONS(898),
    [anon_sym_u03bb] = ACTIONS(900),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(902),
    [anon_sym_u2026] = ACTIONS(902),
    [anon_sym_record] = ACTIONS(904),
    [anon_sym_LPAREN] = ACTIONS(906),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(908),
    [anon_sym_u2983] = ACTIONS(910),
    [anon_sym__] = ACTIONS(902),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(912),
    [anon_sym_RBRACE] = ACTIONS(1146),
    [aux_sym__qid_token1] = ACTIONS(916),
    [anon_sym_DOT] = ACTIONS(918),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(760),
    [anon_sym_quoteGoal] = ACTIONS(920),
    [anon_sym_tactic] = ACTIONS(922),
    [anon_sym_Prop] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(902),
    [anon_sym_quoteTerm] = ACTIONS(902),
    [anon_sym_quoteContext] = ACTIONS(902),
    [anon_sym_unquote] = ACTIONS(902),
    [anon_sym_LPAREN_PIPE] = ACTIONS(924),
    [anon_sym_u2987] = ACTIONS(926),
    [anon_sym_let] = ACTIONS(928),
    [anon_sym_do] = ACTIONS(724),
    [aux_sym_integer_token1] = ACTIONS(930),
    [aux_sym_string_token1] = ACTIONS(930),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(932),
    [sym_PropN] = ACTIONS(902),
  },
  [563] = {
    [sym__FORALL] = STATE(8369),
    [sym__LAMBDA] = STATE(8152),
    [sym__ELLIPSIS] = STATE(5168),
    [sym__qid] = STATE(5168),
    [sym__binding_ids_and_absurds] = STATE(12358),
    [sym_attribute] = STATE(7725),
    [sym_attributes] = STATE(6182),
    [sym_expr] = STATE(11468),
    [sym__with_exprs] = STATE(9861),
    [sym__expr_or_attr] = STATE(5168),
    [sym__application] = STATE(9444),
    [sym__expr2_without_let] = STATE(9444),
    [sym__expr2] = STATE(9444),
    [sym_atom] = STATE(5204),
    [aux_sym__atoms] = STATE(3133),
    [sym__atom_curly] = STATE(5180),
    [sym__atom_no_curly] = STATE(5180),
    [sym_forall] = STATE(9444),
    [sym_let] = STATE(9444),
    [sym_lambda] = STATE(9444),
    [sym_lambda_extended_or_absurd] = STATE(9444),
    [sym_do] = STATE(9444),
    [sym_record_assignments] = STATE(5168),
    [sym_field_assignments] = STATE(5168),
    [aux_sym__typed_bindings] = STATE(8654),
    [sym_typed_binding] = STATE(8654),
    [sym_literal] = STATE(5168),
    [sym_SetN] = STATE(5168),
    [aux_sym__modal_arg_ids_repeat1] = STATE(7725),
    [aux_sym__with_exprs_repeat1] = STATE(3754),
    [sym_id] = ACTIONS(850),
    [anon_sym_forall] = ACTIONS(852),
    [anon_sym_u2200] = ACTIONS(852),
    [anon_sym_BSLASH] = ACTIONS(854),
    [anon_sym_u03bb] = ACTIONS(856),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(858),
    [anon_sym_u2026] = ACTIONS(858),
    [anon_sym_record] = ACTIONS(860),
    [anon_sym_LPAREN] = ACTIONS(862),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(864),
    [anon_sym_u2983] = ACTIONS(866),
    [anon_sym_u2984] = ACTIONS(1148),
    [anon_sym__] = ACTIONS(858),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(870),
    [aux_sym__qid_token1] = ACTIONS(872),
    [anon_sym_DOT] = ACTIONS(874),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(760),
    [anon_sym_quoteGoal] = ACTIONS(878),
    [anon_sym_tactic] = ACTIONS(880),
    [anon_sym_Prop] = ACTIONS(858),
    [anon_sym_quote] = ACTIONS(858),
    [anon_sym_quoteTerm] = ACTIONS(858),
    [anon_sym_quoteContext] = ACTIONS(858),
    [anon_sym_unquote] = ACTIONS(858),
    [anon_sym_LPAREN_PIPE] = ACTIONS(882),
    [anon_sym_u2987] = ACTIONS(884),
    [anon_sym_let] = ACTIONS(886),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(890),
    [aux_sym_string_token1] = ACTIONS(890),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(892),
    [sym_PropN] = ACTIONS(858),
  },
  [564] = {
    [sym__FORALL] = STATE(8396),
    [sym__LAMBDA] = STATE(8031),
    [sym__ELLIPSIS] = STATE(4920),
    [sym__qid] = STATE(4920),
    [sym__binding_ids_and_absurds] = STATE(12539),
    [sym_attribute] = STATE(5830),
    [sym_attributes] = STATE(3504),
    [sym_expr] = STATE(11950),
    [sym__with_exprs] = STATE(10196),
    [sym__expr_or_attr] = STATE(4920),
    [sym__application] = STATE(9678),
    [sym__expr2_without_let] = STATE(9678),
    [sym__expr2] = STATE(9678),
    [sym_atom] = STATE(5202),
    [aux_sym__atoms] = STATE(3165),
    [sym__atom_curly] = STATE(4961),
    [sym__atom_no_curly] = STATE(4961),
    [sym_forall] = STATE(9678),
    [sym_let] = STATE(9678),
    [sym_lambda] = STATE(9678),
    [sym_lambda_extended_or_absurd] = STATE(9678),
    [sym_do] = STATE(9678),
    [sym_record_assignments] = STATE(4920),
    [sym_field_assignments] = STATE(4920),
    [aux_sym__typed_bindings] = STATE(8648),
    [sym_typed_binding] = STATE(8648),
    [sym_literal] = STATE(4920),
    [sym_SetN] = STATE(4920),
    [aux_sym__modal_arg_ids_repeat1] = STATE(5830),
    [aux_sym__with_exprs_repeat1] = STATE(3726),
    [sym_id] = ACTIONS(894),
    [anon_sym_forall] = ACTIONS(896),
    [anon_sym_u2200] = ACTIONS(896),
    [anon_sym_BSLASH] = ACTIONS(898),
    [anon_sym_u03bb] = ACTIONS(900),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(902),
    [anon_sym_u2026] = ACTIONS(902),
    [anon_sym_record] = ACTIONS(904),
    [anon_sym_LPAREN] = ACTIONS(906),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(908),
    [anon_sym_u2983] = ACTIONS(910),
    [anon_sym__] = ACTIONS(902),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(912),
    [anon_sym_RBRACE] = ACTIONS(1150),
    [aux_sym__qid_token1] = ACTIONS(916),
    [anon_sym_DOT] = ACTIONS(918),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(712),
    [anon_sym_quoteGoal] = ACTIONS(920),
    [anon_sym_tactic] = ACTIONS(922),
    [anon_sym_Prop] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(902),
    [anon_sym_quoteTerm] = ACTIONS(902),
    [anon_sym_quoteContext] = ACTIONS(902),
    [anon_sym_unquote] = ACTIONS(902),
    [anon_sym_LPAREN_PIPE] = ACTIONS(924),
    [anon_sym_u2987] = ACTIONS(926),
    [anon_sym_let] = ACTIONS(928),
    [anon_sym_do] = ACTIONS(724),
    [aux_sym_integer_token1] = ACTIONS(930),
    [aux_sym_string_token1] = ACTIONS(930),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(932),
    [sym_PropN] = ACTIONS(902),
  },
  [565] = {
    [sym__FORALL] = STATE(8396),
    [sym__LAMBDA] = STATE(8031),
    [sym__ELLIPSIS] = STATE(4920),
    [sym__qid] = STATE(4920),
    [sym__binding_ids_and_absurds] = STATE(12357),
    [sym_attribute] = STATE(7725),
    [sym_attributes] = STATE(6200),
    [sym_expr] = STATE(10382),
    [sym__with_exprs] = STATE(10196),
    [sym__expr_or_attr] = STATE(4920),
    [sym__application] = STATE(9678),
    [sym__expr2_without_let] = STATE(9678),
    [sym__expr2] = STATE(9678),
    [sym_atom] = STATE(5202),
    [aux_sym__atoms] = STATE(3165),
    [sym__atom_curly] = STATE(4961),
    [sym__atom_no_curly] = STATE(4961),
    [sym_forall] = STATE(9678),
    [sym_let] = STATE(9678),
    [sym_lambda] = STATE(9678),
    [sym_lambda_extended_or_absurd] = STATE(9678),
    [sym_do] = STATE(9678),
    [sym_record_assignments] = STATE(4920),
    [sym_field_assignments] = STATE(4920),
    [aux_sym__typed_bindings] = STATE(8648),
    [sym_typed_binding] = STATE(8648),
    [sym_literal] = STATE(4920),
    [sym_SetN] = STATE(4920),
    [aux_sym__modal_arg_ids_repeat1] = STATE(7725),
    [aux_sym__with_exprs_repeat1] = STATE(3726),
    [sym_id] = ACTIONS(894),
    [anon_sym_forall] = ACTIONS(896),
    [anon_sym_u2200] = ACTIONS(896),
    [anon_sym_BSLASH] = ACTIONS(898),
    [anon_sym_u03bb] = ACTIONS(900),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(902),
    [anon_sym_u2026] = ACTIONS(902),
    [anon_sym_record] = ACTIONS(904),
    [anon_sym_LPAREN] = ACTIONS(906),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(908),
    [anon_sym_u2983] = ACTIONS(910),
    [anon_sym__] = ACTIONS(902),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(912),
    [anon_sym_RBRACE] = ACTIONS(934),
    [aux_sym__qid_token1] = ACTIONS(916),
    [anon_sym_DOT] = ACTIONS(918),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(760),
    [anon_sym_quoteGoal] = ACTIONS(920),
    [anon_sym_tactic] = ACTIONS(922),
    [anon_sym_Prop] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(902),
    [anon_sym_quoteTerm] = ACTIONS(902),
    [anon_sym_quoteContext] = ACTIONS(902),
    [anon_sym_unquote] = ACTIONS(902),
    [anon_sym_LPAREN_PIPE] = ACTIONS(924),
    [anon_sym_u2987] = ACTIONS(926),
    [anon_sym_let] = ACTIONS(928),
    [anon_sym_do] = ACTIONS(724),
    [aux_sym_integer_token1] = ACTIONS(930),
    [aux_sym_string_token1] = ACTIONS(930),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(932),
    [sym_PropN] = ACTIONS(902),
  },
  [566] = {
    [sym__FORALL] = STATE(8345),
    [sym__LAMBDA] = STATE(8095),
    [sym__ELLIPSIS] = STATE(4742),
    [sym_open] = STATE(12555),
    [sym__qid] = STATE(4742),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3873),
    [sym_expr] = STATE(10504),
    [sym__with_exprs] = STATE(10084),
    [sym__expr_or_attr] = STATE(4742),
    [sym__application] = STATE(9680),
    [sym__expr2_without_let] = STATE(9680),
    [sym__expr2] = STATE(9680),
    [sym_atom] = STATE(4712),
    [aux_sym__atoms] = STATE(3211),
    [sym__atom_curly] = STATE(4733),
    [sym__atom_no_curly] = STATE(4733),
    [sym_forall] = STATE(9680),
    [sym_let] = STATE(9680),
    [sym_lambda] = STATE(9680),
    [sym_lambda_extended_or_absurd] = STATE(9680),
    [sym_do] = STATE(9680),
    [sym_record_assignments] = STATE(4742),
    [sym_field_assignments] = STATE(4742),
    [aux_sym__typed_bindings] = STATE(8642),
    [sym_typed_binding] = STATE(8642),
    [sym_literal] = STATE(4742),
    [sym_SetN] = STATE(4742),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3728),
    [sym_id] = ACTIONS(940),
    [anon_sym_forall] = ACTIONS(980),
    [anon_sym_u2200] = ACTIONS(980),
    [anon_sym_BSLASH] = ACTIONS(982),
    [anon_sym_u03bb] = ACTIONS(984),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(948),
    [anon_sym_u2026] = ACTIONS(948),
    [anon_sym_record] = ACTIONS(950),
    [anon_sym_open] = ACTIONS(986),
    [anon_sym_LPAREN] = ACTIONS(952),
    [anon_sym_RPAREN] = ACTIONS(1050),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(954),
    [anon_sym_u2983] = ACTIONS(956),
    [anon_sym__] = ACTIONS(948),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(958),
    [aux_sym__qid_token1] = ACTIONS(960),
    [anon_sym_DOT] = ACTIONS(962),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(988),
    [anon_sym_tactic] = ACTIONS(990),
    [anon_sym_Prop] = ACTIONS(948),
    [anon_sym_quote] = ACTIONS(948),
    [anon_sym_quoteTerm] = ACTIONS(948),
    [anon_sym_quoteContext] = ACTIONS(948),
    [anon_sym_unquote] = ACTIONS(948),
    [anon_sym_LPAREN_PIPE] = ACTIONS(968),
    [anon_sym_u2987] = ACTIONS(970),
    [anon_sym_let] = ACTIONS(992),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(974),
    [aux_sym_string_token1] = ACTIONS(974),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(976),
    [sym_PropN] = ACTIONS(948),
  },
  [567] = {
    [sym__FORALL] = STATE(8396),
    [sym__LAMBDA] = STATE(8031),
    [sym__ELLIPSIS] = STATE(4920),
    [sym__qid] = STATE(4920),
    [sym__binding_ids_and_absurds] = STATE(12539),
    [sym_attribute] = STATE(5830),
    [sym_attributes] = STATE(3504),
    [sym_expr] = STATE(11628),
    [sym__with_exprs] = STATE(10196),
    [sym__expr_or_attr] = STATE(4920),
    [sym__application] = STATE(9678),
    [sym__expr2_without_let] = STATE(9678),
    [sym__expr2] = STATE(9678),
    [sym_atom] = STATE(5202),
    [aux_sym__atoms] = STATE(3165),
    [sym__atom_curly] = STATE(4961),
    [sym__atom_no_curly] = STATE(4961),
    [sym_forall] = STATE(9678),
    [sym_let] = STATE(9678),
    [sym_lambda] = STATE(9678),
    [sym_lambda_extended_or_absurd] = STATE(9678),
    [sym_do] = STATE(9678),
    [sym_record_assignments] = STATE(4920),
    [sym_field_assignments] = STATE(4920),
    [aux_sym__typed_bindings] = STATE(8648),
    [sym_typed_binding] = STATE(8648),
    [sym_literal] = STATE(4920),
    [sym_SetN] = STATE(4920),
    [aux_sym__modal_arg_ids_repeat1] = STATE(5830),
    [aux_sym__with_exprs_repeat1] = STATE(3726),
    [sym_id] = ACTIONS(894),
    [anon_sym_forall] = ACTIONS(896),
    [anon_sym_u2200] = ACTIONS(896),
    [anon_sym_BSLASH] = ACTIONS(898),
    [anon_sym_u03bb] = ACTIONS(900),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(902),
    [anon_sym_u2026] = ACTIONS(902),
    [anon_sym_record] = ACTIONS(904),
    [anon_sym_LPAREN] = ACTIONS(906),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(908),
    [anon_sym_u2983] = ACTIONS(910),
    [anon_sym__] = ACTIONS(902),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(912),
    [anon_sym_RBRACE] = ACTIONS(1142),
    [aux_sym__qid_token1] = ACTIONS(916),
    [anon_sym_DOT] = ACTIONS(918),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(712),
    [anon_sym_quoteGoal] = ACTIONS(920),
    [anon_sym_tactic] = ACTIONS(922),
    [anon_sym_Prop] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(902),
    [anon_sym_quoteTerm] = ACTIONS(902),
    [anon_sym_quoteContext] = ACTIONS(902),
    [anon_sym_unquote] = ACTIONS(902),
    [anon_sym_LPAREN_PIPE] = ACTIONS(924),
    [anon_sym_u2987] = ACTIONS(926),
    [anon_sym_let] = ACTIONS(928),
    [anon_sym_do] = ACTIONS(724),
    [aux_sym_integer_token1] = ACTIONS(930),
    [aux_sym_string_token1] = ACTIONS(930),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(932),
    [sym_PropN] = ACTIONS(902),
  },
  [568] = {
    [sym__FORALL] = STATE(8369),
    [sym__LAMBDA] = STATE(8152),
    [sym__ELLIPSIS] = STATE(5168),
    [sym__qid] = STATE(5168),
    [sym__binding_ids_and_absurds] = STATE(12544),
    [sym_attribute] = STATE(5830),
    [sym_attributes] = STATE(3505),
    [sym_expr] = STATE(11629),
    [sym__with_exprs] = STATE(9861),
    [sym__expr_or_attr] = STATE(5168),
    [sym__application] = STATE(9444),
    [sym__expr2_without_let] = STATE(9444),
    [sym__expr2] = STATE(9444),
    [sym_atom] = STATE(5204),
    [aux_sym__atoms] = STATE(3133),
    [sym__atom_curly] = STATE(5180),
    [sym__atom_no_curly] = STATE(5180),
    [sym_forall] = STATE(9444),
    [sym_let] = STATE(9444),
    [sym_lambda] = STATE(9444),
    [sym_lambda_extended_or_absurd] = STATE(9444),
    [sym_do] = STATE(9444),
    [sym_record_assignments] = STATE(5168),
    [sym_field_assignments] = STATE(5168),
    [aux_sym__typed_bindings] = STATE(8654),
    [sym_typed_binding] = STATE(8654),
    [sym_literal] = STATE(5168),
    [sym_SetN] = STATE(5168),
    [aux_sym__modal_arg_ids_repeat1] = STATE(5830),
    [aux_sym__with_exprs_repeat1] = STATE(3754),
    [sym_id] = ACTIONS(850),
    [anon_sym_forall] = ACTIONS(852),
    [anon_sym_u2200] = ACTIONS(852),
    [anon_sym_BSLASH] = ACTIONS(854),
    [anon_sym_u03bb] = ACTIONS(856),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(858),
    [anon_sym_u2026] = ACTIONS(858),
    [anon_sym_record] = ACTIONS(860),
    [anon_sym_LPAREN] = ACTIONS(862),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(864),
    [anon_sym_u2983] = ACTIONS(866),
    [anon_sym_u2984] = ACTIONS(1144),
    [anon_sym__] = ACTIONS(858),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(870),
    [aux_sym__qid_token1] = ACTIONS(872),
    [anon_sym_DOT] = ACTIONS(874),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(712),
    [anon_sym_quoteGoal] = ACTIONS(878),
    [anon_sym_tactic] = ACTIONS(880),
    [anon_sym_Prop] = ACTIONS(858),
    [anon_sym_quote] = ACTIONS(858),
    [anon_sym_quoteTerm] = ACTIONS(858),
    [anon_sym_quoteContext] = ACTIONS(858),
    [anon_sym_unquote] = ACTIONS(858),
    [anon_sym_LPAREN_PIPE] = ACTIONS(882),
    [anon_sym_u2987] = ACTIONS(884),
    [anon_sym_let] = ACTIONS(886),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(890),
    [aux_sym_string_token1] = ACTIONS(890),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(892),
    [sym_PropN] = ACTIONS(858),
  },
  [569] = {
    [sym__FORALL] = STATE(8355),
    [sym__LAMBDA] = STATE(8054),
    [sym__ELLIPSIS] = STATE(4742),
    [sym__qid] = STATE(4742),
    [sym__binding_ids_and_absurds] = STATE(12547),
    [sym_attribute] = STATE(5830),
    [sym_attributes] = STATE(3506),
    [sym_expr] = STATE(11630),
    [sym__with_exprs] = STATE(10050),
    [sym__expr_or_attr] = STATE(4742),
    [sym__application] = STATE(9444),
    [sym__expr2_without_let] = STATE(9444),
    [sym__expr2] = STATE(9444),
    [sym_atom] = STATE(4712),
    [aux_sym__atoms] = STATE(3276),
    [sym__atom_curly] = STATE(4733),
    [sym__atom_no_curly] = STATE(4733),
    [sym_forall] = STATE(9444),
    [sym_let] = STATE(9444),
    [sym_lambda] = STATE(9444),
    [sym_lambda_extended_or_absurd] = STATE(9444),
    [sym_do] = STATE(9444),
    [sym_record_assignments] = STATE(4742),
    [sym_field_assignments] = STATE(4742),
    [aux_sym__typed_bindings] = STATE(8646),
    [sym_typed_binding] = STATE(8646),
    [sym_literal] = STATE(4742),
    [sym_SetN] = STATE(4742),
    [aux_sym__modal_arg_ids_repeat1] = STATE(5830),
    [aux_sym__with_exprs_repeat1] = STATE(3745),
    [sym_id] = ACTIONS(940),
    [anon_sym_forall] = ACTIONS(942),
    [anon_sym_u2200] = ACTIONS(942),
    [anon_sym_BSLASH] = ACTIONS(944),
    [anon_sym_u03bb] = ACTIONS(946),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(948),
    [anon_sym_u2026] = ACTIONS(948),
    [anon_sym_record] = ACTIONS(950),
    [anon_sym_LPAREN] = ACTIONS(952),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(954),
    [anon_sym_RBRACE_RBRACE] = ACTIONS(1144),
    [anon_sym_u2983] = ACTIONS(956),
    [anon_sym__] = ACTIONS(948),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(958),
    [aux_sym__qid_token1] = ACTIONS(960),
    [anon_sym_DOT] = ACTIONS(962),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(712),
    [anon_sym_quoteGoal] = ACTIONS(964),
    [anon_sym_tactic] = ACTIONS(966),
    [anon_sym_Prop] = ACTIONS(948),
    [anon_sym_quote] = ACTIONS(948),
    [anon_sym_quoteTerm] = ACTIONS(948),
    [anon_sym_quoteContext] = ACTIONS(948),
    [anon_sym_unquote] = ACTIONS(948),
    [anon_sym_LPAREN_PIPE] = ACTIONS(968),
    [anon_sym_u2987] = ACTIONS(970),
    [anon_sym_let] = ACTIONS(972),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(974),
    [aux_sym_string_token1] = ACTIONS(974),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(976),
    [sym_PropN] = ACTIONS(948),
  },
  [570] = {
    [sym__FORALL] = STATE(8345),
    [sym__LAMBDA] = STATE(8095),
    [sym__ELLIPSIS] = STATE(4742),
    [sym_open] = STATE(12555),
    [sym__qid] = STATE(4742),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3873),
    [sym_expr] = STATE(11595),
    [sym__with_exprs] = STATE(10084),
    [sym__expr_or_attr] = STATE(4742),
    [sym__application] = STATE(9680),
    [sym__expr2_without_let] = STATE(9680),
    [sym__expr2] = STATE(9680),
    [sym_atom] = STATE(4712),
    [aux_sym__atoms] = STATE(3211),
    [sym__atom_curly] = STATE(4733),
    [sym__atom_no_curly] = STATE(4733),
    [sym_forall] = STATE(9680),
    [sym_let] = STATE(9680),
    [sym_lambda] = STATE(9680),
    [sym_lambda_extended_or_absurd] = STATE(9680),
    [sym_do] = STATE(9680),
    [sym_record_assignments] = STATE(4742),
    [sym_field_assignments] = STATE(4742),
    [aux_sym__typed_bindings] = STATE(8642),
    [sym_typed_binding] = STATE(8642),
    [sym_literal] = STATE(4742),
    [sym_SetN] = STATE(4742),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3728),
    [sym_id] = ACTIONS(940),
    [anon_sym_forall] = ACTIONS(980),
    [anon_sym_u2200] = ACTIONS(980),
    [anon_sym_BSLASH] = ACTIONS(982),
    [anon_sym_u03bb] = ACTIONS(984),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(948),
    [anon_sym_u2026] = ACTIONS(948),
    [anon_sym_record] = ACTIONS(950),
    [anon_sym_open] = ACTIONS(986),
    [anon_sym_LPAREN] = ACTIONS(952),
    [anon_sym_RPAREN] = ACTIONS(1144),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(954),
    [anon_sym_u2983] = ACTIONS(956),
    [anon_sym__] = ACTIONS(948),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(958),
    [aux_sym__qid_token1] = ACTIONS(960),
    [anon_sym_DOT] = ACTIONS(962),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(988),
    [anon_sym_tactic] = ACTIONS(990),
    [anon_sym_Prop] = ACTIONS(948),
    [anon_sym_quote] = ACTIONS(948),
    [anon_sym_quoteTerm] = ACTIONS(948),
    [anon_sym_quoteContext] = ACTIONS(948),
    [anon_sym_unquote] = ACTIONS(948),
    [anon_sym_LPAREN_PIPE] = ACTIONS(968),
    [anon_sym_u2987] = ACTIONS(970),
    [anon_sym_let] = ACTIONS(992),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(974),
    [aux_sym_string_token1] = ACTIONS(974),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(976),
    [sym_PropN] = ACTIONS(948),
  },
  [571] = {
    [sym__FORALL] = STATE(8355),
    [sym__LAMBDA] = STATE(8054),
    [sym__ELLIPSIS] = STATE(4742),
    [sym__qid] = STATE(4742),
    [sym__binding_ids_and_absurds] = STATE(12359),
    [sym_attribute] = STATE(7725),
    [sym_attributes] = STATE(6302),
    [sym_expr] = STATE(11469),
    [sym__with_exprs] = STATE(10050),
    [sym__expr_or_attr] = STATE(4742),
    [sym__application] = STATE(9444),
    [sym__expr2_without_let] = STATE(9444),
    [sym__expr2] = STATE(9444),
    [sym_atom] = STATE(4712),
    [aux_sym__atoms] = STATE(3276),
    [sym__atom_curly] = STATE(4733),
    [sym__atom_no_curly] = STATE(4733),
    [sym_forall] = STATE(9444),
    [sym_let] = STATE(9444),
    [sym_lambda] = STATE(9444),
    [sym_lambda_extended_or_absurd] = STATE(9444),
    [sym_do] = STATE(9444),
    [sym_record_assignments] = STATE(4742),
    [sym_field_assignments] = STATE(4742),
    [aux_sym__typed_bindings] = STATE(8646),
    [sym_typed_binding] = STATE(8646),
    [sym_literal] = STATE(4742),
    [sym_SetN] = STATE(4742),
    [aux_sym__modal_arg_ids_repeat1] = STATE(7725),
    [aux_sym__with_exprs_repeat1] = STATE(3745),
    [sym_id] = ACTIONS(940),
    [anon_sym_forall] = ACTIONS(942),
    [anon_sym_u2200] = ACTIONS(942),
    [anon_sym_BSLASH] = ACTIONS(944),
    [anon_sym_u03bb] = ACTIONS(946),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(948),
    [anon_sym_u2026] = ACTIONS(948),
    [anon_sym_record] = ACTIONS(950),
    [anon_sym_LPAREN] = ACTIONS(952),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(954),
    [anon_sym_RBRACE_RBRACE] = ACTIONS(1148),
    [anon_sym_u2983] = ACTIONS(956),
    [anon_sym__] = ACTIONS(948),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(958),
    [aux_sym__qid_token1] = ACTIONS(960),
    [anon_sym_DOT] = ACTIONS(962),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(760),
    [anon_sym_quoteGoal] = ACTIONS(964),
    [anon_sym_tactic] = ACTIONS(966),
    [anon_sym_Prop] = ACTIONS(948),
    [anon_sym_quote] = ACTIONS(948),
    [anon_sym_quoteTerm] = ACTIONS(948),
    [anon_sym_quoteContext] = ACTIONS(948),
    [anon_sym_unquote] = ACTIONS(948),
    [anon_sym_LPAREN_PIPE] = ACTIONS(968),
    [anon_sym_u2987] = ACTIONS(970),
    [anon_sym_let] = ACTIONS(972),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(974),
    [aux_sym_string_token1] = ACTIONS(974),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(976),
    [sym_PropN] = ACTIONS(948),
  },
  [572] = {
    [sym__FORALL] = STATE(8396),
    [sym__LAMBDA] = STATE(8031),
    [sym__ELLIPSIS] = STATE(4920),
    [sym__qid] = STATE(4920),
    [sym__binding_ids_and_absurds] = STATE(12357),
    [sym_attribute] = STATE(7725),
    [sym_attributes] = STATE(6200),
    [sym_expr] = STATE(11641),
    [sym__with_exprs] = STATE(10196),
    [sym__expr_or_attr] = STATE(4920),
    [sym__application] = STATE(9678),
    [sym__expr2_without_let] = STATE(9678),
    [sym__expr2] = STATE(9678),
    [sym_atom] = STATE(5202),
    [aux_sym__atoms] = STATE(3165),
    [sym__atom_curly] = STATE(4961),
    [sym__atom_no_curly] = STATE(4961),
    [sym_forall] = STATE(9678),
    [sym_let] = STATE(9678),
    [sym_lambda] = STATE(9678),
    [sym_lambda_extended_or_absurd] = STATE(9678),
    [sym_do] = STATE(9678),
    [sym_record_assignments] = STATE(4920),
    [sym_field_assignments] = STATE(4920),
    [aux_sym__typed_bindings] = STATE(8648),
    [sym_typed_binding] = STATE(8648),
    [sym_literal] = STATE(4920),
    [sym_SetN] = STATE(4920),
    [aux_sym__modal_arg_ids_repeat1] = STATE(7725),
    [aux_sym__with_exprs_repeat1] = STATE(3726),
    [sym_id] = ACTIONS(894),
    [anon_sym_forall] = ACTIONS(896),
    [anon_sym_u2200] = ACTIONS(896),
    [anon_sym_BSLASH] = ACTIONS(898),
    [anon_sym_u03bb] = ACTIONS(900),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(902),
    [anon_sym_u2026] = ACTIONS(902),
    [anon_sym_record] = ACTIONS(904),
    [anon_sym_LPAREN] = ACTIONS(906),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(908),
    [anon_sym_u2983] = ACTIONS(910),
    [anon_sym__] = ACTIONS(902),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(912),
    [anon_sym_RBRACE] = ACTIONS(1152),
    [aux_sym__qid_token1] = ACTIONS(916),
    [anon_sym_DOT] = ACTIONS(918),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(760),
    [anon_sym_quoteGoal] = ACTIONS(920),
    [anon_sym_tactic] = ACTIONS(922),
    [anon_sym_Prop] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(902),
    [anon_sym_quoteTerm] = ACTIONS(902),
    [anon_sym_quoteContext] = ACTIONS(902),
    [anon_sym_unquote] = ACTIONS(902),
    [anon_sym_LPAREN_PIPE] = ACTIONS(924),
    [anon_sym_u2987] = ACTIONS(926),
    [anon_sym_let] = ACTIONS(928),
    [anon_sym_do] = ACTIONS(724),
    [aux_sym_integer_token1] = ACTIONS(930),
    [aux_sym_string_token1] = ACTIONS(930),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(932),
    [sym_PropN] = ACTIONS(902),
  },
  [573] = {
    [sym__FORALL] = STATE(8369),
    [sym__LAMBDA] = STATE(8152),
    [sym__ELLIPSIS] = STATE(5168),
    [sym__qid] = STATE(5168),
    [sym__binding_ids_and_absurds] = STATE(12358),
    [sym_attribute] = STATE(7725),
    [sym_attributes] = STATE(6182),
    [sym_expr] = STATE(11643),
    [sym__with_exprs] = STATE(9861),
    [sym__expr_or_attr] = STATE(5168),
    [sym__application] = STATE(9444),
    [sym__expr2_without_let] = STATE(9444),
    [sym__expr2] = STATE(9444),
    [sym_atom] = STATE(5204),
    [aux_sym__atoms] = STATE(3133),
    [sym__atom_curly] = STATE(5180),
    [sym__atom_no_curly] = STATE(5180),
    [sym_forall] = STATE(9444),
    [sym_let] = STATE(9444),
    [sym_lambda] = STATE(9444),
    [sym_lambda_extended_or_absurd] = STATE(9444),
    [sym_do] = STATE(9444),
    [sym_record_assignments] = STATE(5168),
    [sym_field_assignments] = STATE(5168),
    [aux_sym__typed_bindings] = STATE(8654),
    [sym_typed_binding] = STATE(8654),
    [sym_literal] = STATE(5168),
    [sym_SetN] = STATE(5168),
    [aux_sym__modal_arg_ids_repeat1] = STATE(7725),
    [aux_sym__with_exprs_repeat1] = STATE(3754),
    [sym_id] = ACTIONS(850),
    [anon_sym_forall] = ACTIONS(852),
    [anon_sym_u2200] = ACTIONS(852),
    [anon_sym_BSLASH] = ACTIONS(854),
    [anon_sym_u03bb] = ACTIONS(856),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(858),
    [anon_sym_u2026] = ACTIONS(858),
    [anon_sym_record] = ACTIONS(860),
    [anon_sym_LPAREN] = ACTIONS(862),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(864),
    [anon_sym_u2983] = ACTIONS(866),
    [anon_sym_u2984] = ACTIONS(1154),
    [anon_sym__] = ACTIONS(858),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(870),
    [aux_sym__qid_token1] = ACTIONS(872),
    [anon_sym_DOT] = ACTIONS(874),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(760),
    [anon_sym_quoteGoal] = ACTIONS(878),
    [anon_sym_tactic] = ACTIONS(880),
    [anon_sym_Prop] = ACTIONS(858),
    [anon_sym_quote] = ACTIONS(858),
    [anon_sym_quoteTerm] = ACTIONS(858),
    [anon_sym_quoteContext] = ACTIONS(858),
    [anon_sym_unquote] = ACTIONS(858),
    [anon_sym_LPAREN_PIPE] = ACTIONS(882),
    [anon_sym_u2987] = ACTIONS(884),
    [anon_sym_let] = ACTIONS(886),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(890),
    [aux_sym_string_token1] = ACTIONS(890),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(892),
    [sym_PropN] = ACTIONS(858),
  },
  [574] = {
    [sym__FORALL] = STATE(8355),
    [sym__LAMBDA] = STATE(8054),
    [sym__ELLIPSIS] = STATE(4742),
    [sym__qid] = STATE(4742),
    [sym__binding_ids_and_absurds] = STATE(12359),
    [sym_attribute] = STATE(7725),
    [sym_attributes] = STATE(6302),
    [sym_expr] = STATE(11644),
    [sym__with_exprs] = STATE(10050),
    [sym__expr_or_attr] = STATE(4742),
    [sym__application] = STATE(9444),
    [sym__expr2_without_let] = STATE(9444),
    [sym__expr2] = STATE(9444),
    [sym_atom] = STATE(4712),
    [aux_sym__atoms] = STATE(3276),
    [sym__atom_curly] = STATE(4733),
    [sym__atom_no_curly] = STATE(4733),
    [sym_forall] = STATE(9444),
    [sym_let] = STATE(9444),
    [sym_lambda] = STATE(9444),
    [sym_lambda_extended_or_absurd] = STATE(9444),
    [sym_do] = STATE(9444),
    [sym_record_assignments] = STATE(4742),
    [sym_field_assignments] = STATE(4742),
    [aux_sym__typed_bindings] = STATE(8646),
    [sym_typed_binding] = STATE(8646),
    [sym_literal] = STATE(4742),
    [sym_SetN] = STATE(4742),
    [aux_sym__modal_arg_ids_repeat1] = STATE(7725),
    [aux_sym__with_exprs_repeat1] = STATE(3745),
    [sym_id] = ACTIONS(940),
    [anon_sym_forall] = ACTIONS(942),
    [anon_sym_u2200] = ACTIONS(942),
    [anon_sym_BSLASH] = ACTIONS(944),
    [anon_sym_u03bb] = ACTIONS(946),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(948),
    [anon_sym_u2026] = ACTIONS(948),
    [anon_sym_record] = ACTIONS(950),
    [anon_sym_LPAREN] = ACTIONS(952),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(954),
    [anon_sym_RBRACE_RBRACE] = ACTIONS(1154),
    [anon_sym_u2983] = ACTIONS(956),
    [anon_sym__] = ACTIONS(948),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(958),
    [aux_sym__qid_token1] = ACTIONS(960),
    [anon_sym_DOT] = ACTIONS(962),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(760),
    [anon_sym_quoteGoal] = ACTIONS(964),
    [anon_sym_tactic] = ACTIONS(966),
    [anon_sym_Prop] = ACTIONS(948),
    [anon_sym_quote] = ACTIONS(948),
    [anon_sym_quoteTerm] = ACTIONS(948),
    [anon_sym_quoteContext] = ACTIONS(948),
    [anon_sym_unquote] = ACTIONS(948),
    [anon_sym_LPAREN_PIPE] = ACTIONS(968),
    [anon_sym_u2987] = ACTIONS(970),
    [anon_sym_let] = ACTIONS(972),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(974),
    [aux_sym_string_token1] = ACTIONS(974),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(976),
    [sym_PropN] = ACTIONS(948),
  },
  [575] = {
    [sym__FORALL] = STATE(8396),
    [sym__LAMBDA] = STATE(8031),
    [sym__ELLIPSIS] = STATE(4920),
    [sym__qid] = STATE(4920),
    [sym__binding_ids_and_absurds] = STATE(12539),
    [sym_attribute] = STATE(5830),
    [sym_attributes] = STATE(3504),
    [sym_expr] = STATE(11641),
    [sym__with_exprs] = STATE(10196),
    [sym__expr_or_attr] = STATE(4920),
    [sym__application] = STATE(9678),
    [sym__expr2_without_let] = STATE(9678),
    [sym__expr2] = STATE(9678),
    [sym_atom] = STATE(5202),
    [aux_sym__atoms] = STATE(3165),
    [sym__atom_curly] = STATE(4961),
    [sym__atom_no_curly] = STATE(4961),
    [sym_forall] = STATE(9678),
    [sym_let] = STATE(9678),
    [sym_lambda] = STATE(9678),
    [sym_lambda_extended_or_absurd] = STATE(9678),
    [sym_do] = STATE(9678),
    [sym_record_assignments] = STATE(4920),
    [sym_field_assignments] = STATE(4920),
    [aux_sym__typed_bindings] = STATE(8648),
    [sym_typed_binding] = STATE(8648),
    [sym_literal] = STATE(4920),
    [sym_SetN] = STATE(4920),
    [aux_sym__modal_arg_ids_repeat1] = STATE(5830),
    [aux_sym__with_exprs_repeat1] = STATE(3726),
    [sym_id] = ACTIONS(894),
    [anon_sym_forall] = ACTIONS(896),
    [anon_sym_u2200] = ACTIONS(896),
    [anon_sym_BSLASH] = ACTIONS(898),
    [anon_sym_u03bb] = ACTIONS(900),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(902),
    [anon_sym_u2026] = ACTIONS(902),
    [anon_sym_record] = ACTIONS(904),
    [anon_sym_LPAREN] = ACTIONS(906),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(908),
    [anon_sym_u2983] = ACTIONS(910),
    [anon_sym__] = ACTIONS(902),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(912),
    [anon_sym_RBRACE] = ACTIONS(1152),
    [aux_sym__qid_token1] = ACTIONS(916),
    [anon_sym_DOT] = ACTIONS(918),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(712),
    [anon_sym_quoteGoal] = ACTIONS(920),
    [anon_sym_tactic] = ACTIONS(922),
    [anon_sym_Prop] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(902),
    [anon_sym_quoteTerm] = ACTIONS(902),
    [anon_sym_quoteContext] = ACTIONS(902),
    [anon_sym_unquote] = ACTIONS(902),
    [anon_sym_LPAREN_PIPE] = ACTIONS(924),
    [anon_sym_u2987] = ACTIONS(926),
    [anon_sym_let] = ACTIONS(928),
    [anon_sym_do] = ACTIONS(724),
    [aux_sym_integer_token1] = ACTIONS(930),
    [aux_sym_string_token1] = ACTIONS(930),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(932),
    [sym_PropN] = ACTIONS(902),
  },
  [576] = {
    [sym__FORALL] = STATE(8369),
    [sym__LAMBDA] = STATE(8152),
    [sym__ELLIPSIS] = STATE(5168),
    [sym__qid] = STATE(5168),
    [sym__binding_ids_and_absurds] = STATE(12544),
    [sym_attribute] = STATE(5830),
    [sym_attributes] = STATE(3505),
    [sym_expr] = STATE(11643),
    [sym__with_exprs] = STATE(9861),
    [sym__expr_or_attr] = STATE(5168),
    [sym__application] = STATE(9444),
    [sym__expr2_without_let] = STATE(9444),
    [sym__expr2] = STATE(9444),
    [sym_atom] = STATE(5204),
    [aux_sym__atoms] = STATE(3133),
    [sym__atom_curly] = STATE(5180),
    [sym__atom_no_curly] = STATE(5180),
    [sym_forall] = STATE(9444),
    [sym_let] = STATE(9444),
    [sym_lambda] = STATE(9444),
    [sym_lambda_extended_or_absurd] = STATE(9444),
    [sym_do] = STATE(9444),
    [sym_record_assignments] = STATE(5168),
    [sym_field_assignments] = STATE(5168),
    [aux_sym__typed_bindings] = STATE(8654),
    [sym_typed_binding] = STATE(8654),
    [sym_literal] = STATE(5168),
    [sym_SetN] = STATE(5168),
    [aux_sym__modal_arg_ids_repeat1] = STATE(5830),
    [aux_sym__with_exprs_repeat1] = STATE(3754),
    [sym_id] = ACTIONS(850),
    [anon_sym_forall] = ACTIONS(852),
    [anon_sym_u2200] = ACTIONS(852),
    [anon_sym_BSLASH] = ACTIONS(854),
    [anon_sym_u03bb] = ACTIONS(856),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(858),
    [anon_sym_u2026] = ACTIONS(858),
    [anon_sym_record] = ACTIONS(860),
    [anon_sym_LPAREN] = ACTIONS(862),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(864),
    [anon_sym_u2983] = ACTIONS(866),
    [anon_sym_u2984] = ACTIONS(1154),
    [anon_sym__] = ACTIONS(858),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(870),
    [aux_sym__qid_token1] = ACTIONS(872),
    [anon_sym_DOT] = ACTIONS(874),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(712),
    [anon_sym_quoteGoal] = ACTIONS(878),
    [anon_sym_tactic] = ACTIONS(880),
    [anon_sym_Prop] = ACTIONS(858),
    [anon_sym_quote] = ACTIONS(858),
    [anon_sym_quoteTerm] = ACTIONS(858),
    [anon_sym_quoteContext] = ACTIONS(858),
    [anon_sym_unquote] = ACTIONS(858),
    [anon_sym_LPAREN_PIPE] = ACTIONS(882),
    [anon_sym_u2987] = ACTIONS(884),
    [anon_sym_let] = ACTIONS(886),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(890),
    [aux_sym_string_token1] = ACTIONS(890),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(892),
    [sym_PropN] = ACTIONS(858),
  },
  [577] = {
    [sym__FORALL] = STATE(8355),
    [sym__LAMBDA] = STATE(8054),
    [sym__ELLIPSIS] = STATE(4742),
    [sym__qid] = STATE(4742),
    [sym__binding_ids_and_absurds] = STATE(12359),
    [sym_attribute] = STATE(7725),
    [sym_attributes] = STATE(6302),
    [sym_expr] = STATE(11952),
    [sym__with_exprs] = STATE(10050),
    [sym__expr_or_attr] = STATE(4742),
    [sym__application] = STATE(9444),
    [sym__expr2_without_let] = STATE(9444),
    [sym__expr2] = STATE(9444),
    [sym_atom] = STATE(4712),
    [aux_sym__atoms] = STATE(3276),
    [sym__atom_curly] = STATE(4733),
    [sym__atom_no_curly] = STATE(4733),
    [sym_forall] = STATE(9444),
    [sym_let] = STATE(9444),
    [sym_lambda] = STATE(9444),
    [sym_lambda_extended_or_absurd] = STATE(9444),
    [sym_do] = STATE(9444),
    [sym_record_assignments] = STATE(4742),
    [sym_field_assignments] = STATE(4742),
    [aux_sym__typed_bindings] = STATE(8646),
    [sym_typed_binding] = STATE(8646),
    [sym_literal] = STATE(4742),
    [sym_SetN] = STATE(4742),
    [aux_sym__modal_arg_ids_repeat1] = STATE(7725),
    [aux_sym__with_exprs_repeat1] = STATE(3745),
    [sym_id] = ACTIONS(940),
    [anon_sym_forall] = ACTIONS(942),
    [anon_sym_u2200] = ACTIONS(942),
    [anon_sym_BSLASH] = ACTIONS(944),
    [anon_sym_u03bb] = ACTIONS(946),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(948),
    [anon_sym_u2026] = ACTIONS(948),
    [anon_sym_record] = ACTIONS(950),
    [anon_sym_LPAREN] = ACTIONS(952),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(954),
    [anon_sym_RBRACE_RBRACE] = ACTIONS(1140),
    [anon_sym_u2983] = ACTIONS(956),
    [anon_sym__] = ACTIONS(948),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(958),
    [aux_sym__qid_token1] = ACTIONS(960),
    [anon_sym_DOT] = ACTIONS(962),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(760),
    [anon_sym_quoteGoal] = ACTIONS(964),
    [anon_sym_tactic] = ACTIONS(966),
    [anon_sym_Prop] = ACTIONS(948),
    [anon_sym_quote] = ACTIONS(948),
    [anon_sym_quoteTerm] = ACTIONS(948),
    [anon_sym_quoteContext] = ACTIONS(948),
    [anon_sym_unquote] = ACTIONS(948),
    [anon_sym_LPAREN_PIPE] = ACTIONS(968),
    [anon_sym_u2987] = ACTIONS(970),
    [anon_sym_let] = ACTIONS(972),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(974),
    [aux_sym_string_token1] = ACTIONS(974),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(976),
    [sym_PropN] = ACTIONS(948),
  },
  [578] = {
    [sym__FORALL] = STATE(8355),
    [sym__LAMBDA] = STATE(8054),
    [sym__ELLIPSIS] = STATE(4742),
    [sym__qid] = STATE(4742),
    [sym__binding_ids_and_absurds] = STATE(12547),
    [sym_attribute] = STATE(5830),
    [sym_attributes] = STATE(3506),
    [sym_expr] = STATE(11644),
    [sym__with_exprs] = STATE(10050),
    [sym__expr_or_attr] = STATE(4742),
    [sym__application] = STATE(9444),
    [sym__expr2_without_let] = STATE(9444),
    [sym__expr2] = STATE(9444),
    [sym_atom] = STATE(4712),
    [aux_sym__atoms] = STATE(3276),
    [sym__atom_curly] = STATE(4733),
    [sym__atom_no_curly] = STATE(4733),
    [sym_forall] = STATE(9444),
    [sym_let] = STATE(9444),
    [sym_lambda] = STATE(9444),
    [sym_lambda_extended_or_absurd] = STATE(9444),
    [sym_do] = STATE(9444),
    [sym_record_assignments] = STATE(4742),
    [sym_field_assignments] = STATE(4742),
    [aux_sym__typed_bindings] = STATE(8646),
    [sym_typed_binding] = STATE(8646),
    [sym_literal] = STATE(4742),
    [sym_SetN] = STATE(4742),
    [aux_sym__modal_arg_ids_repeat1] = STATE(5830),
    [aux_sym__with_exprs_repeat1] = STATE(3745),
    [sym_id] = ACTIONS(940),
    [anon_sym_forall] = ACTIONS(942),
    [anon_sym_u2200] = ACTIONS(942),
    [anon_sym_BSLASH] = ACTIONS(944),
    [anon_sym_u03bb] = ACTIONS(946),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(948),
    [anon_sym_u2026] = ACTIONS(948),
    [anon_sym_record] = ACTIONS(950),
    [anon_sym_LPAREN] = ACTIONS(952),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(954),
    [anon_sym_RBRACE_RBRACE] = ACTIONS(1154),
    [anon_sym_u2983] = ACTIONS(956),
    [anon_sym__] = ACTIONS(948),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(958),
    [aux_sym__qid_token1] = ACTIONS(960),
    [anon_sym_DOT] = ACTIONS(962),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(712),
    [anon_sym_quoteGoal] = ACTIONS(964),
    [anon_sym_tactic] = ACTIONS(966),
    [anon_sym_Prop] = ACTIONS(948),
    [anon_sym_quote] = ACTIONS(948),
    [anon_sym_quoteTerm] = ACTIONS(948),
    [anon_sym_quoteContext] = ACTIONS(948),
    [anon_sym_unquote] = ACTIONS(948),
    [anon_sym_LPAREN_PIPE] = ACTIONS(968),
    [anon_sym_u2987] = ACTIONS(970),
    [anon_sym_let] = ACTIONS(972),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(974),
    [aux_sym_string_token1] = ACTIONS(974),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(976),
    [sym_PropN] = ACTIONS(948),
  },
  [579] = {
    [sym__FORALL] = STATE(8369),
    [sym__LAMBDA] = STATE(8152),
    [sym__ELLIPSIS] = STATE(5168),
    [sym__qid] = STATE(5168),
    [sym__binding_ids_and_absurds] = STATE(12358),
    [sym_attribute] = STATE(7725),
    [sym_attributes] = STATE(6182),
    [sym_expr] = STATE(11951),
    [sym__with_exprs] = STATE(9861),
    [sym__expr_or_attr] = STATE(5168),
    [sym__application] = STATE(9444),
    [sym__expr2_without_let] = STATE(9444),
    [sym__expr2] = STATE(9444),
    [sym_atom] = STATE(5204),
    [aux_sym__atoms] = STATE(3133),
    [sym__atom_curly] = STATE(5180),
    [sym__atom_no_curly] = STATE(5180),
    [sym_forall] = STATE(9444),
    [sym_let] = STATE(9444),
    [sym_lambda] = STATE(9444),
    [sym_lambda_extended_or_absurd] = STATE(9444),
    [sym_do] = STATE(9444),
    [sym_record_assignments] = STATE(5168),
    [sym_field_assignments] = STATE(5168),
    [aux_sym__typed_bindings] = STATE(8654),
    [sym_typed_binding] = STATE(8654),
    [sym_literal] = STATE(5168),
    [sym_SetN] = STATE(5168),
    [aux_sym__modal_arg_ids_repeat1] = STATE(7725),
    [aux_sym__with_exprs_repeat1] = STATE(3754),
    [sym_id] = ACTIONS(850),
    [anon_sym_forall] = ACTIONS(852),
    [anon_sym_u2200] = ACTIONS(852),
    [anon_sym_BSLASH] = ACTIONS(854),
    [anon_sym_u03bb] = ACTIONS(856),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(858),
    [anon_sym_u2026] = ACTIONS(858),
    [anon_sym_record] = ACTIONS(860),
    [anon_sym_LPAREN] = ACTIONS(862),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(864),
    [anon_sym_u2983] = ACTIONS(866),
    [anon_sym_u2984] = ACTIONS(1140),
    [anon_sym__] = ACTIONS(858),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(870),
    [aux_sym__qid_token1] = ACTIONS(872),
    [anon_sym_DOT] = ACTIONS(874),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(760),
    [anon_sym_quoteGoal] = ACTIONS(878),
    [anon_sym_tactic] = ACTIONS(880),
    [anon_sym_Prop] = ACTIONS(858),
    [anon_sym_quote] = ACTIONS(858),
    [anon_sym_quoteTerm] = ACTIONS(858),
    [anon_sym_quoteContext] = ACTIONS(858),
    [anon_sym_unquote] = ACTIONS(858),
    [anon_sym_LPAREN_PIPE] = ACTIONS(882),
    [anon_sym_u2987] = ACTIONS(884),
    [anon_sym_let] = ACTIONS(886),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(890),
    [aux_sym_string_token1] = ACTIONS(890),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(892),
    [sym_PropN] = ACTIONS(858),
  },
  [580] = {
    [sym__FORALL] = STATE(8396),
    [sym__LAMBDA] = STATE(8031),
    [sym__ELLIPSIS] = STATE(4920),
    [sym__qid] = STATE(4920),
    [sym__binding_ids_and_absurds] = STATE(12357),
    [sym_attribute] = STATE(7725),
    [sym_attributes] = STATE(6200),
    [sym_expr] = STATE(11950),
    [sym__with_exprs] = STATE(10196),
    [sym__expr_or_attr] = STATE(4920),
    [sym__application] = STATE(9678),
    [sym__expr2_without_let] = STATE(9678),
    [sym__expr2] = STATE(9678),
    [sym_atom] = STATE(5202),
    [aux_sym__atoms] = STATE(3165),
    [sym__atom_curly] = STATE(4961),
    [sym__atom_no_curly] = STATE(4961),
    [sym_forall] = STATE(9678),
    [sym_let] = STATE(9678),
    [sym_lambda] = STATE(9678),
    [sym_lambda_extended_or_absurd] = STATE(9678),
    [sym_do] = STATE(9678),
    [sym_record_assignments] = STATE(4920),
    [sym_field_assignments] = STATE(4920),
    [aux_sym__typed_bindings] = STATE(8648),
    [sym_typed_binding] = STATE(8648),
    [sym_literal] = STATE(4920),
    [sym_SetN] = STATE(4920),
    [aux_sym__modal_arg_ids_repeat1] = STATE(7725),
    [aux_sym__with_exprs_repeat1] = STATE(3726),
    [sym_id] = ACTIONS(894),
    [anon_sym_forall] = ACTIONS(896),
    [anon_sym_u2200] = ACTIONS(896),
    [anon_sym_BSLASH] = ACTIONS(898),
    [anon_sym_u03bb] = ACTIONS(900),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(902),
    [anon_sym_u2026] = ACTIONS(902),
    [anon_sym_record] = ACTIONS(904),
    [anon_sym_LPAREN] = ACTIONS(906),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(908),
    [anon_sym_u2983] = ACTIONS(910),
    [anon_sym__] = ACTIONS(902),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(912),
    [anon_sym_RBRACE] = ACTIONS(1150),
    [aux_sym__qid_token1] = ACTIONS(916),
    [anon_sym_DOT] = ACTIONS(918),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(760),
    [anon_sym_quoteGoal] = ACTIONS(920),
    [anon_sym_tactic] = ACTIONS(922),
    [anon_sym_Prop] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(902),
    [anon_sym_quoteTerm] = ACTIONS(902),
    [anon_sym_quoteContext] = ACTIONS(902),
    [anon_sym_unquote] = ACTIONS(902),
    [anon_sym_LPAREN_PIPE] = ACTIONS(924),
    [anon_sym_u2987] = ACTIONS(926),
    [anon_sym_let] = ACTIONS(928),
    [anon_sym_do] = ACTIONS(724),
    [aux_sym_integer_token1] = ACTIONS(930),
    [aux_sym_string_token1] = ACTIONS(930),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(932),
    [sym_PropN] = ACTIONS(902),
  },
  [581] = {
    [sym__FORALL] = STATE(8345),
    [sym__LAMBDA] = STATE(8095),
    [sym__ELLIPSIS] = STATE(4742),
    [sym_open] = STATE(12555),
    [sym__qid] = STATE(4742),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3873),
    [sym_expr] = STATE(11609),
    [sym__with_exprs] = STATE(10084),
    [sym__expr_or_attr] = STATE(4742),
    [sym__application] = STATE(9680),
    [sym__expr2_without_let] = STATE(9680),
    [sym__expr2] = STATE(9680),
    [sym_atom] = STATE(4712),
    [aux_sym__atoms] = STATE(3211),
    [sym__atom_curly] = STATE(4733),
    [sym__atom_no_curly] = STATE(4733),
    [sym_forall] = STATE(9680),
    [sym_let] = STATE(9680),
    [sym_lambda] = STATE(9680),
    [sym_lambda_extended_or_absurd] = STATE(9680),
    [sym_do] = STATE(9680),
    [sym_record_assignments] = STATE(4742),
    [sym_field_assignments] = STATE(4742),
    [aux_sym__typed_bindings] = STATE(8642),
    [sym_typed_binding] = STATE(8642),
    [sym_literal] = STATE(4742),
    [sym_SetN] = STATE(4742),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3728),
    [sym_id] = ACTIONS(940),
    [anon_sym_forall] = ACTIONS(980),
    [anon_sym_u2200] = ACTIONS(980),
    [anon_sym_BSLASH] = ACTIONS(982),
    [anon_sym_u03bb] = ACTIONS(984),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(948),
    [anon_sym_u2026] = ACTIONS(948),
    [anon_sym_record] = ACTIONS(950),
    [anon_sym_open] = ACTIONS(986),
    [anon_sym_LPAREN] = ACTIONS(952),
    [anon_sym_RPAREN] = ACTIONS(1154),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(954),
    [anon_sym_u2983] = ACTIONS(956),
    [anon_sym__] = ACTIONS(948),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(958),
    [aux_sym__qid_token1] = ACTIONS(960),
    [anon_sym_DOT] = ACTIONS(962),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(988),
    [anon_sym_tactic] = ACTIONS(990),
    [anon_sym_Prop] = ACTIONS(948),
    [anon_sym_quote] = ACTIONS(948),
    [anon_sym_quoteTerm] = ACTIONS(948),
    [anon_sym_quoteContext] = ACTIONS(948),
    [anon_sym_unquote] = ACTIONS(948),
    [anon_sym_LPAREN_PIPE] = ACTIONS(968),
    [anon_sym_u2987] = ACTIONS(970),
    [anon_sym_let] = ACTIONS(992),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(974),
    [aux_sym_string_token1] = ACTIONS(974),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(976),
    [sym_PropN] = ACTIONS(948),
  },
  [582] = {
    [sym__FORALL] = STATE(8396),
    [sym__LAMBDA] = STATE(8031),
    [sym__ELLIPSIS] = STATE(4920),
    [sym__qid] = STATE(4920),
    [sym__binding_ids_and_absurds] = STATE(12539),
    [sym_attribute] = STATE(5830),
    [sym_attributes] = STATE(3504),
    [sym_expr] = STATE(11510),
    [sym__with_exprs] = STATE(10196),
    [sym__expr_or_attr] = STATE(4920),
    [sym__application] = STATE(9678),
    [sym__expr2_without_let] = STATE(9678),
    [sym__expr2] = STATE(9678),
    [sym_atom] = STATE(5202),
    [aux_sym__atoms] = STATE(3165),
    [sym__atom_curly] = STATE(4961),
    [sym__atom_no_curly] = STATE(4961),
    [sym_forall] = STATE(9678),
    [sym_let] = STATE(9678),
    [sym_lambda] = STATE(9678),
    [sym_lambda_extended_or_absurd] = STATE(9678),
    [sym_do] = STATE(9678),
    [sym_record_assignments] = STATE(4920),
    [sym_field_assignments] = STATE(4920),
    [aux_sym__typed_bindings] = STATE(8648),
    [sym_typed_binding] = STATE(8648),
    [sym_literal] = STATE(4920),
    [sym_SetN] = STATE(4920),
    [aux_sym__modal_arg_ids_repeat1] = STATE(5830),
    [aux_sym__with_exprs_repeat1] = STATE(3726),
    [sym_id] = ACTIONS(894),
    [anon_sym_forall] = ACTIONS(896),
    [anon_sym_u2200] = ACTIONS(896),
    [anon_sym_BSLASH] = ACTIONS(898),
    [anon_sym_u03bb] = ACTIONS(900),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(902),
    [anon_sym_u2026] = ACTIONS(902),
    [anon_sym_record] = ACTIONS(904),
    [anon_sym_LPAREN] = ACTIONS(906),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(908),
    [anon_sym_u2983] = ACTIONS(910),
    [anon_sym__] = ACTIONS(902),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(912),
    [anon_sym_RBRACE] = ACTIONS(1146),
    [aux_sym__qid_token1] = ACTIONS(916),
    [anon_sym_DOT] = ACTIONS(918),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(712),
    [anon_sym_quoteGoal] = ACTIONS(920),
    [anon_sym_tactic] = ACTIONS(922),
    [anon_sym_Prop] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(902),
    [anon_sym_quoteTerm] = ACTIONS(902),
    [anon_sym_quoteContext] = ACTIONS(902),
    [anon_sym_unquote] = ACTIONS(902),
    [anon_sym_LPAREN_PIPE] = ACTIONS(924),
    [anon_sym_u2987] = ACTIONS(926),
    [anon_sym_let] = ACTIONS(928),
    [anon_sym_do] = ACTIONS(724),
    [aux_sym_integer_token1] = ACTIONS(930),
    [aux_sym_string_token1] = ACTIONS(930),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(932),
    [sym_PropN] = ACTIONS(902),
  },
  [583] = {
    [sym__FORALL] = STATE(8369),
    [sym__LAMBDA] = STATE(8152),
    [sym__ELLIPSIS] = STATE(5168),
    [sym__qid] = STATE(5168),
    [sym__binding_ids_and_absurds] = STATE(12544),
    [sym_attribute] = STATE(5830),
    [sym_attributes] = STATE(3505),
    [sym_expr] = STATE(11468),
    [sym__with_exprs] = STATE(9861),
    [sym__expr_or_attr] = STATE(5168),
    [sym__application] = STATE(9444),
    [sym__expr2_without_let] = STATE(9444),
    [sym__expr2] = STATE(9444),
    [sym_atom] = STATE(5204),
    [aux_sym__atoms] = STATE(3133),
    [sym__atom_curly] = STATE(5180),
    [sym__atom_no_curly] = STATE(5180),
    [sym_forall] = STATE(9444),
    [sym_let] = STATE(9444),
    [sym_lambda] = STATE(9444),
    [sym_lambda_extended_or_absurd] = STATE(9444),
    [sym_do] = STATE(9444),
    [sym_record_assignments] = STATE(5168),
    [sym_field_assignments] = STATE(5168),
    [aux_sym__typed_bindings] = STATE(8654),
    [sym_typed_binding] = STATE(8654),
    [sym_literal] = STATE(5168),
    [sym_SetN] = STATE(5168),
    [aux_sym__modal_arg_ids_repeat1] = STATE(5830),
    [aux_sym__with_exprs_repeat1] = STATE(3754),
    [sym_id] = ACTIONS(850),
    [anon_sym_forall] = ACTIONS(852),
    [anon_sym_u2200] = ACTIONS(852),
    [anon_sym_BSLASH] = ACTIONS(854),
    [anon_sym_u03bb] = ACTIONS(856),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(858),
    [anon_sym_u2026] = ACTIONS(858),
    [anon_sym_record] = ACTIONS(860),
    [anon_sym_LPAREN] = ACTIONS(862),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(864),
    [anon_sym_u2983] = ACTIONS(866),
    [anon_sym_u2984] = ACTIONS(1148),
    [anon_sym__] = ACTIONS(858),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(870),
    [aux_sym__qid_token1] = ACTIONS(872),
    [anon_sym_DOT] = ACTIONS(874),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(712),
    [anon_sym_quoteGoal] = ACTIONS(878),
    [anon_sym_tactic] = ACTIONS(880),
    [anon_sym_Prop] = ACTIONS(858),
    [anon_sym_quote] = ACTIONS(858),
    [anon_sym_quoteTerm] = ACTIONS(858),
    [anon_sym_quoteContext] = ACTIONS(858),
    [anon_sym_unquote] = ACTIONS(858),
    [anon_sym_LPAREN_PIPE] = ACTIONS(882),
    [anon_sym_u2987] = ACTIONS(884),
    [anon_sym_let] = ACTIONS(886),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(890),
    [aux_sym_string_token1] = ACTIONS(890),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(892),
    [sym_PropN] = ACTIONS(858),
  },
  [584] = {
    [sym__FORALL] = STATE(8355),
    [sym__LAMBDA] = STATE(8054),
    [sym__ELLIPSIS] = STATE(4742),
    [sym__qid] = STATE(4742),
    [sym__binding_ids_and_absurds] = STATE(12359),
    [sym_attribute] = STATE(7725),
    [sym_attributes] = STATE(6302),
    [sym_expr] = STATE(10812),
    [sym__with_exprs] = STATE(10050),
    [sym__expr_or_attr] = STATE(4742),
    [sym__application] = STATE(9444),
    [sym__expr2_without_let] = STATE(9444),
    [sym__expr2] = STATE(9444),
    [sym_atom] = STATE(4712),
    [aux_sym__atoms] = STATE(3276),
    [sym__atom_curly] = STATE(4733),
    [sym__atom_no_curly] = STATE(4733),
    [sym_forall] = STATE(9444),
    [sym_let] = STATE(9444),
    [sym_lambda] = STATE(9444),
    [sym_lambda_extended_or_absurd] = STATE(9444),
    [sym_do] = STATE(9444),
    [sym_record_assignments] = STATE(4742),
    [sym_field_assignments] = STATE(4742),
    [aux_sym__typed_bindings] = STATE(8646),
    [sym_typed_binding] = STATE(8646),
    [sym_literal] = STATE(4742),
    [sym_SetN] = STATE(4742),
    [aux_sym__modal_arg_ids_repeat1] = STATE(7725),
    [aux_sym__with_exprs_repeat1] = STATE(3745),
    [sym_id] = ACTIONS(940),
    [anon_sym_forall] = ACTIONS(942),
    [anon_sym_u2200] = ACTIONS(942),
    [anon_sym_BSLASH] = ACTIONS(944),
    [anon_sym_u03bb] = ACTIONS(946),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(948),
    [anon_sym_u2026] = ACTIONS(948),
    [anon_sym_record] = ACTIONS(950),
    [anon_sym_LPAREN] = ACTIONS(952),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(954),
    [anon_sym_RBRACE_RBRACE] = ACTIONS(1136),
    [anon_sym_u2983] = ACTIONS(956),
    [anon_sym__] = ACTIONS(948),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(958),
    [aux_sym__qid_token1] = ACTIONS(960),
    [anon_sym_DOT] = ACTIONS(962),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(760),
    [anon_sym_quoteGoal] = ACTIONS(964),
    [anon_sym_tactic] = ACTIONS(966),
    [anon_sym_Prop] = ACTIONS(948),
    [anon_sym_quote] = ACTIONS(948),
    [anon_sym_quoteTerm] = ACTIONS(948),
    [anon_sym_quoteContext] = ACTIONS(948),
    [anon_sym_unquote] = ACTIONS(948),
    [anon_sym_LPAREN_PIPE] = ACTIONS(968),
    [anon_sym_u2987] = ACTIONS(970),
    [anon_sym_let] = ACTIONS(972),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(974),
    [aux_sym_string_token1] = ACTIONS(974),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(976),
    [sym_PropN] = ACTIONS(948),
  },
  [585] = {
    [sym__FORALL] = STATE(8396),
    [sym__LAMBDA] = STATE(8031),
    [sym__ELLIPSIS] = STATE(4920),
    [sym__qid] = STATE(4920),
    [sym__binding_ids_and_absurds] = STATE(12357),
    [sym_attribute] = STATE(7725),
    [sym_attributes] = STATE(6200),
    [sym_expr] = STATE(10288),
    [sym__with_exprs] = STATE(10196),
    [sym__expr_or_attr] = STATE(4920),
    [sym__application] = STATE(9678),
    [sym__expr2_without_let] = STATE(9678),
    [sym__expr2] = STATE(9678),
    [sym_atom] = STATE(5202),
    [aux_sym__atoms] = STATE(3165),
    [sym__atom_curly] = STATE(4961),
    [sym__atom_no_curly] = STATE(4961),
    [sym_forall] = STATE(9678),
    [sym_let] = STATE(9678),
    [sym_lambda] = STATE(9678),
    [sym_lambda_extended_or_absurd] = STATE(9678),
    [sym_do] = STATE(9678),
    [sym_record_assignments] = STATE(4920),
    [sym_field_assignments] = STATE(4920),
    [aux_sym__typed_bindings] = STATE(8648),
    [sym_typed_binding] = STATE(8648),
    [sym_literal] = STATE(4920),
    [sym_SetN] = STATE(4920),
    [aux_sym__modal_arg_ids_repeat1] = STATE(7725),
    [aux_sym__with_exprs_repeat1] = STATE(3726),
    [sym_id] = ACTIONS(894),
    [anon_sym_forall] = ACTIONS(896),
    [anon_sym_u2200] = ACTIONS(896),
    [anon_sym_BSLASH] = ACTIONS(898),
    [anon_sym_u03bb] = ACTIONS(900),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(902),
    [anon_sym_u2026] = ACTIONS(902),
    [anon_sym_record] = ACTIONS(904),
    [anon_sym_LPAREN] = ACTIONS(906),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(908),
    [anon_sym_u2983] = ACTIONS(910),
    [anon_sym__] = ACTIONS(902),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(912),
    [anon_sym_RBRACE] = ACTIONS(1156),
    [aux_sym__qid_token1] = ACTIONS(916),
    [anon_sym_DOT] = ACTIONS(918),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(760),
    [anon_sym_quoteGoal] = ACTIONS(920),
    [anon_sym_tactic] = ACTIONS(922),
    [anon_sym_Prop] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(902),
    [anon_sym_quoteTerm] = ACTIONS(902),
    [anon_sym_quoteContext] = ACTIONS(902),
    [anon_sym_unquote] = ACTIONS(902),
    [anon_sym_LPAREN_PIPE] = ACTIONS(924),
    [anon_sym_u2987] = ACTIONS(926),
    [anon_sym_let] = ACTIONS(928),
    [anon_sym_do] = ACTIONS(724),
    [aux_sym_integer_token1] = ACTIONS(930),
    [aux_sym_string_token1] = ACTIONS(930),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(932),
    [sym_PropN] = ACTIONS(902),
  },
  [586] = {
    [sym__FORALL] = STATE(8369),
    [sym__LAMBDA] = STATE(8152),
    [sym__ELLIPSIS] = STATE(5168),
    [sym__qid] = STATE(5168),
    [sym__binding_ids_and_absurds] = STATE(12358),
    [sym_attribute] = STATE(7725),
    [sym_attributes] = STATE(6182),
    [sym_expr] = STATE(10330),
    [sym__with_exprs] = STATE(9861),
    [sym__expr_or_attr] = STATE(5168),
    [sym__application] = STATE(9444),
    [sym__expr2_without_let] = STATE(9444),
    [sym__expr2] = STATE(9444),
    [sym_atom] = STATE(5204),
    [aux_sym__atoms] = STATE(3133),
    [sym__atom_curly] = STATE(5180),
    [sym__atom_no_curly] = STATE(5180),
    [sym_forall] = STATE(9444),
    [sym_let] = STATE(9444),
    [sym_lambda] = STATE(9444),
    [sym_lambda_extended_or_absurd] = STATE(9444),
    [sym_do] = STATE(9444),
    [sym_record_assignments] = STATE(5168),
    [sym_field_assignments] = STATE(5168),
    [aux_sym__typed_bindings] = STATE(8654),
    [sym_typed_binding] = STATE(8654),
    [sym_literal] = STATE(5168),
    [sym_SetN] = STATE(5168),
    [aux_sym__modal_arg_ids_repeat1] = STATE(7725),
    [aux_sym__with_exprs_repeat1] = STATE(3754),
    [sym_id] = ACTIONS(850),
    [anon_sym_forall] = ACTIONS(852),
    [anon_sym_u2200] = ACTIONS(852),
    [anon_sym_BSLASH] = ACTIONS(854),
    [anon_sym_u03bb] = ACTIONS(856),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(858),
    [anon_sym_u2026] = ACTIONS(858),
    [anon_sym_record] = ACTIONS(860),
    [anon_sym_LPAREN] = ACTIONS(862),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(864),
    [anon_sym_u2983] = ACTIONS(866),
    [anon_sym_u2984] = ACTIONS(1158),
    [anon_sym__] = ACTIONS(858),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(870),
    [aux_sym__qid_token1] = ACTIONS(872),
    [anon_sym_DOT] = ACTIONS(874),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(760),
    [anon_sym_quoteGoal] = ACTIONS(878),
    [anon_sym_tactic] = ACTIONS(880),
    [anon_sym_Prop] = ACTIONS(858),
    [anon_sym_quote] = ACTIONS(858),
    [anon_sym_quoteTerm] = ACTIONS(858),
    [anon_sym_quoteContext] = ACTIONS(858),
    [anon_sym_unquote] = ACTIONS(858),
    [anon_sym_LPAREN_PIPE] = ACTIONS(882),
    [anon_sym_u2987] = ACTIONS(884),
    [anon_sym_let] = ACTIONS(886),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(890),
    [aux_sym_string_token1] = ACTIONS(890),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(892),
    [sym_PropN] = ACTIONS(858),
  },
  [587] = {
    [sym__FORALL] = STATE(8355),
    [sym__LAMBDA] = STATE(8054),
    [sym__ELLIPSIS] = STATE(4742),
    [sym__qid] = STATE(4742),
    [sym__binding_ids_and_absurds] = STATE(12547),
    [sym_attribute] = STATE(5830),
    [sym_attributes] = STATE(3506),
    [sym_expr] = STATE(11469),
    [sym__with_exprs] = STATE(10050),
    [sym__expr_or_attr] = STATE(4742),
    [sym__application] = STATE(9444),
    [sym__expr2_without_let] = STATE(9444),
    [sym__expr2] = STATE(9444),
    [sym_atom] = STATE(4712),
    [aux_sym__atoms] = STATE(3276),
    [sym__atom_curly] = STATE(4733),
    [sym__atom_no_curly] = STATE(4733),
    [sym_forall] = STATE(9444),
    [sym_let] = STATE(9444),
    [sym_lambda] = STATE(9444),
    [sym_lambda_extended_or_absurd] = STATE(9444),
    [sym_do] = STATE(9444),
    [sym_record_assignments] = STATE(4742),
    [sym_field_assignments] = STATE(4742),
    [aux_sym__typed_bindings] = STATE(8646),
    [sym_typed_binding] = STATE(8646),
    [sym_literal] = STATE(4742),
    [sym_SetN] = STATE(4742),
    [aux_sym__modal_arg_ids_repeat1] = STATE(5830),
    [aux_sym__with_exprs_repeat1] = STATE(3745),
    [sym_id] = ACTIONS(940),
    [anon_sym_forall] = ACTIONS(942),
    [anon_sym_u2200] = ACTIONS(942),
    [anon_sym_BSLASH] = ACTIONS(944),
    [anon_sym_u03bb] = ACTIONS(946),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(948),
    [anon_sym_u2026] = ACTIONS(948),
    [anon_sym_record] = ACTIONS(950),
    [anon_sym_LPAREN] = ACTIONS(952),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(954),
    [anon_sym_RBRACE_RBRACE] = ACTIONS(1148),
    [anon_sym_u2983] = ACTIONS(956),
    [anon_sym__] = ACTIONS(948),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(958),
    [aux_sym__qid_token1] = ACTIONS(960),
    [anon_sym_DOT] = ACTIONS(962),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(712),
    [anon_sym_quoteGoal] = ACTIONS(964),
    [anon_sym_tactic] = ACTIONS(966),
    [anon_sym_Prop] = ACTIONS(948),
    [anon_sym_quote] = ACTIONS(948),
    [anon_sym_quoteTerm] = ACTIONS(948),
    [anon_sym_quoteContext] = ACTIONS(948),
    [anon_sym_unquote] = ACTIONS(948),
    [anon_sym_LPAREN_PIPE] = ACTIONS(968),
    [anon_sym_u2987] = ACTIONS(970),
    [anon_sym_let] = ACTIONS(972),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(974),
    [aux_sym_string_token1] = ACTIONS(974),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(976),
    [sym_PropN] = ACTIONS(948),
  },
  [588] = {
    [sym__FORALL] = STATE(8369),
    [sym__LAMBDA] = STATE(8152),
    [sym__ELLIPSIS] = STATE(5168),
    [sym__qid] = STATE(5168),
    [sym__binding_ids_and_absurds] = STATE(12358),
    [sym_attribute] = STATE(7725),
    [sym_attributes] = STATE(6182),
    [sym_expr] = STATE(10811),
    [sym__with_exprs] = STATE(9861),
    [sym__expr_or_attr] = STATE(5168),
    [sym__application] = STATE(9444),
    [sym__expr2_without_let] = STATE(9444),
    [sym__expr2] = STATE(9444),
    [sym_atom] = STATE(5204),
    [aux_sym__atoms] = STATE(3133),
    [sym__atom_curly] = STATE(5180),
    [sym__atom_no_curly] = STATE(5180),
    [sym_forall] = STATE(9444),
    [sym_let] = STATE(9444),
    [sym_lambda] = STATE(9444),
    [sym_lambda_extended_or_absurd] = STATE(9444),
    [sym_do] = STATE(9444),
    [sym_record_assignments] = STATE(5168),
    [sym_field_assignments] = STATE(5168),
    [aux_sym__typed_bindings] = STATE(8654),
    [sym_typed_binding] = STATE(8654),
    [sym_literal] = STATE(5168),
    [sym_SetN] = STATE(5168),
    [aux_sym__modal_arg_ids_repeat1] = STATE(7725),
    [aux_sym__with_exprs_repeat1] = STATE(3754),
    [sym_id] = ACTIONS(850),
    [anon_sym_forall] = ACTIONS(852),
    [anon_sym_u2200] = ACTIONS(852),
    [anon_sym_BSLASH] = ACTIONS(854),
    [anon_sym_u03bb] = ACTIONS(856),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(858),
    [anon_sym_u2026] = ACTIONS(858),
    [anon_sym_record] = ACTIONS(860),
    [anon_sym_LPAREN] = ACTIONS(862),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(864),
    [anon_sym_u2983] = ACTIONS(866),
    [anon_sym_u2984] = ACTIONS(1136),
    [anon_sym__] = ACTIONS(858),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(870),
    [aux_sym__qid_token1] = ACTIONS(872),
    [anon_sym_DOT] = ACTIONS(874),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(760),
    [anon_sym_quoteGoal] = ACTIONS(878),
    [anon_sym_tactic] = ACTIONS(880),
    [anon_sym_Prop] = ACTIONS(858),
    [anon_sym_quote] = ACTIONS(858),
    [anon_sym_quoteTerm] = ACTIONS(858),
    [anon_sym_quoteContext] = ACTIONS(858),
    [anon_sym_unquote] = ACTIONS(858),
    [anon_sym_LPAREN_PIPE] = ACTIONS(882),
    [anon_sym_u2987] = ACTIONS(884),
    [anon_sym_let] = ACTIONS(886),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(890),
    [aux_sym_string_token1] = ACTIONS(890),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(892),
    [sym_PropN] = ACTIONS(858),
  },
  [589] = {
    [sym__FORALL] = STATE(8355),
    [sym__LAMBDA] = STATE(8054),
    [sym__ELLIPSIS] = STATE(4742),
    [sym__qid] = STATE(4742),
    [sym__binding_ids_and_absurds] = STATE(12359),
    [sym_attribute] = STATE(7725),
    [sym_attributes] = STATE(6302),
    [sym_expr] = STATE(10327),
    [sym__with_exprs] = STATE(10050),
    [sym__expr_or_attr] = STATE(4742),
    [sym__application] = STATE(9444),
    [sym__expr2_without_let] = STATE(9444),
    [sym__expr2] = STATE(9444),
    [sym_atom] = STATE(4712),
    [aux_sym__atoms] = STATE(3276),
    [sym__atom_curly] = STATE(4733),
    [sym__atom_no_curly] = STATE(4733),
    [sym_forall] = STATE(9444),
    [sym_let] = STATE(9444),
    [sym_lambda] = STATE(9444),
    [sym_lambda_extended_or_absurd] = STATE(9444),
    [sym_do] = STATE(9444),
    [sym_record_assignments] = STATE(4742),
    [sym_field_assignments] = STATE(4742),
    [aux_sym__typed_bindings] = STATE(8646),
    [sym_typed_binding] = STATE(8646),
    [sym_literal] = STATE(4742),
    [sym_SetN] = STATE(4742),
    [aux_sym__modal_arg_ids_repeat1] = STATE(7725),
    [aux_sym__with_exprs_repeat1] = STATE(3745),
    [sym_id] = ACTIONS(940),
    [anon_sym_forall] = ACTIONS(942),
    [anon_sym_u2200] = ACTIONS(942),
    [anon_sym_BSLASH] = ACTIONS(944),
    [anon_sym_u03bb] = ACTIONS(946),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(948),
    [anon_sym_u2026] = ACTIONS(948),
    [anon_sym_record] = ACTIONS(950),
    [anon_sym_LPAREN] = ACTIONS(952),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(954),
    [anon_sym_RBRACE_RBRACE] = ACTIONS(1158),
    [anon_sym_u2983] = ACTIONS(956),
    [anon_sym__] = ACTIONS(948),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(958),
    [aux_sym__qid_token1] = ACTIONS(960),
    [anon_sym_DOT] = ACTIONS(962),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(760),
    [anon_sym_quoteGoal] = ACTIONS(964),
    [anon_sym_tactic] = ACTIONS(966),
    [anon_sym_Prop] = ACTIONS(948),
    [anon_sym_quote] = ACTIONS(948),
    [anon_sym_quoteTerm] = ACTIONS(948),
    [anon_sym_quoteContext] = ACTIONS(948),
    [anon_sym_unquote] = ACTIONS(948),
    [anon_sym_LPAREN_PIPE] = ACTIONS(968),
    [anon_sym_u2987] = ACTIONS(970),
    [anon_sym_let] = ACTIONS(972),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(974),
    [aux_sym_string_token1] = ACTIONS(974),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(976),
    [sym_PropN] = ACTIONS(948),
  },
  [590] = {
    [sym__FORALL] = STATE(8396),
    [sym__LAMBDA] = STATE(8031),
    [sym__ELLIPSIS] = STATE(4920),
    [sym__qid] = STATE(4920),
    [sym__binding_ids_and_absurds] = STATE(12357),
    [sym_attribute] = STATE(7725),
    [sym_attributes] = STATE(6200),
    [sym_expr] = STATE(10847),
    [sym__with_exprs] = STATE(10196),
    [sym__expr_or_attr] = STATE(4920),
    [sym__application] = STATE(9678),
    [sym__expr2_without_let] = STATE(9678),
    [sym__expr2] = STATE(9678),
    [sym_atom] = STATE(5202),
    [aux_sym__atoms] = STATE(3165),
    [sym__atom_curly] = STATE(4961),
    [sym__atom_no_curly] = STATE(4961),
    [sym_forall] = STATE(9678),
    [sym_let] = STATE(9678),
    [sym_lambda] = STATE(9678),
    [sym_lambda_extended_or_absurd] = STATE(9678),
    [sym_do] = STATE(9678),
    [sym_record_assignments] = STATE(4920),
    [sym_field_assignments] = STATE(4920),
    [aux_sym__typed_bindings] = STATE(8648),
    [sym_typed_binding] = STATE(8648),
    [sym_literal] = STATE(4920),
    [sym_SetN] = STATE(4920),
    [aux_sym__modal_arg_ids_repeat1] = STATE(7725),
    [aux_sym__with_exprs_repeat1] = STATE(3726),
    [sym_id] = ACTIONS(894),
    [anon_sym_forall] = ACTIONS(896),
    [anon_sym_u2200] = ACTIONS(896),
    [anon_sym_BSLASH] = ACTIONS(898),
    [anon_sym_u03bb] = ACTIONS(900),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(902),
    [anon_sym_u2026] = ACTIONS(902),
    [anon_sym_record] = ACTIONS(904),
    [anon_sym_LPAREN] = ACTIONS(906),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(908),
    [anon_sym_u2983] = ACTIONS(910),
    [anon_sym__] = ACTIONS(902),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(912),
    [anon_sym_RBRACE] = ACTIONS(1138),
    [aux_sym__qid_token1] = ACTIONS(916),
    [anon_sym_DOT] = ACTIONS(918),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(760),
    [anon_sym_quoteGoal] = ACTIONS(920),
    [anon_sym_tactic] = ACTIONS(922),
    [anon_sym_Prop] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(902),
    [anon_sym_quoteTerm] = ACTIONS(902),
    [anon_sym_quoteContext] = ACTIONS(902),
    [anon_sym_unquote] = ACTIONS(902),
    [anon_sym_LPAREN_PIPE] = ACTIONS(924),
    [anon_sym_u2987] = ACTIONS(926),
    [anon_sym_let] = ACTIONS(928),
    [anon_sym_do] = ACTIONS(724),
    [aux_sym_integer_token1] = ACTIONS(930),
    [aux_sym_string_token1] = ACTIONS(930),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(932),
    [sym_PropN] = ACTIONS(902),
  },
  [591] = {
    [sym__FORALL] = STATE(8396),
    [sym__LAMBDA] = STATE(8031),
    [sym__ELLIPSIS] = STATE(4920),
    [sym__qid] = STATE(4920),
    [sym__binding_ids_and_absurds] = STATE(12357),
    [sym_attribute] = STATE(7725),
    [sym_attributes] = STATE(6200),
    [sym_expr] = STATE(11667),
    [sym__with_exprs] = STATE(10196),
    [sym__expr_or_attr] = STATE(4920),
    [sym__application] = STATE(9678),
    [sym__expr2_without_let] = STATE(9678),
    [sym__expr2] = STATE(9678),
    [sym_atom] = STATE(5202),
    [aux_sym__atoms] = STATE(3165),
    [sym__atom_curly] = STATE(4961),
    [sym__atom_no_curly] = STATE(4961),
    [sym_forall] = STATE(9678),
    [sym_let] = STATE(9678),
    [sym_lambda] = STATE(9678),
    [sym_lambda_extended_or_absurd] = STATE(9678),
    [sym_do] = STATE(9678),
    [sym_record_assignments] = STATE(4920),
    [sym_field_assignments] = STATE(4920),
    [aux_sym__typed_bindings] = STATE(8648),
    [sym_typed_binding] = STATE(8648),
    [sym_literal] = STATE(4920),
    [sym_SetN] = STATE(4920),
    [aux_sym__modal_arg_ids_repeat1] = STATE(7725),
    [aux_sym__with_exprs_repeat1] = STATE(3726),
    [sym_id] = ACTIONS(894),
    [anon_sym_forall] = ACTIONS(896),
    [anon_sym_u2200] = ACTIONS(896),
    [anon_sym_BSLASH] = ACTIONS(898),
    [anon_sym_u03bb] = ACTIONS(900),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(902),
    [anon_sym_u2026] = ACTIONS(902),
    [anon_sym_record] = ACTIONS(904),
    [anon_sym_LPAREN] = ACTIONS(906),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(908),
    [anon_sym_u2983] = ACTIONS(910),
    [anon_sym__] = ACTIONS(902),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(912),
    [anon_sym_RBRACE] = ACTIONS(1160),
    [aux_sym__qid_token1] = ACTIONS(916),
    [anon_sym_DOT] = ACTIONS(918),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(760),
    [anon_sym_quoteGoal] = ACTIONS(920),
    [anon_sym_tactic] = ACTIONS(922),
    [anon_sym_Prop] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(902),
    [anon_sym_quoteTerm] = ACTIONS(902),
    [anon_sym_quoteContext] = ACTIONS(902),
    [anon_sym_unquote] = ACTIONS(902),
    [anon_sym_LPAREN_PIPE] = ACTIONS(924),
    [anon_sym_u2987] = ACTIONS(926),
    [anon_sym_let] = ACTIONS(928),
    [anon_sym_do] = ACTIONS(724),
    [aux_sym_integer_token1] = ACTIONS(930),
    [aux_sym_string_token1] = ACTIONS(930),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(932),
    [sym_PropN] = ACTIONS(902),
  },
  [592] = {
    [sym__FORALL] = STATE(8369),
    [sym__LAMBDA] = STATE(8152),
    [sym__ELLIPSIS] = STATE(5168),
    [sym__qid] = STATE(5168),
    [sym__binding_ids_and_absurds] = STATE(12358),
    [sym_attribute] = STATE(7725),
    [sym_attributes] = STATE(6182),
    [sym_expr] = STATE(11668),
    [sym__with_exprs] = STATE(9861),
    [sym__expr_or_attr] = STATE(5168),
    [sym__application] = STATE(9444),
    [sym__expr2_without_let] = STATE(9444),
    [sym__expr2] = STATE(9444),
    [sym_atom] = STATE(5204),
    [aux_sym__atoms] = STATE(3133),
    [sym__atom_curly] = STATE(5180),
    [sym__atom_no_curly] = STATE(5180),
    [sym_forall] = STATE(9444),
    [sym_let] = STATE(9444),
    [sym_lambda] = STATE(9444),
    [sym_lambda_extended_or_absurd] = STATE(9444),
    [sym_do] = STATE(9444),
    [sym_record_assignments] = STATE(5168),
    [sym_field_assignments] = STATE(5168),
    [aux_sym__typed_bindings] = STATE(8654),
    [sym_typed_binding] = STATE(8654),
    [sym_literal] = STATE(5168),
    [sym_SetN] = STATE(5168),
    [aux_sym__modal_arg_ids_repeat1] = STATE(7725),
    [aux_sym__with_exprs_repeat1] = STATE(3754),
    [sym_id] = ACTIONS(850),
    [anon_sym_forall] = ACTIONS(852),
    [anon_sym_u2200] = ACTIONS(852),
    [anon_sym_BSLASH] = ACTIONS(854),
    [anon_sym_u03bb] = ACTIONS(856),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(858),
    [anon_sym_u2026] = ACTIONS(858),
    [anon_sym_record] = ACTIONS(860),
    [anon_sym_LPAREN] = ACTIONS(862),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(864),
    [anon_sym_u2983] = ACTIONS(866),
    [anon_sym_u2984] = ACTIONS(1162),
    [anon_sym__] = ACTIONS(858),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(870),
    [aux_sym__qid_token1] = ACTIONS(872),
    [anon_sym_DOT] = ACTIONS(874),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(760),
    [anon_sym_quoteGoal] = ACTIONS(878),
    [anon_sym_tactic] = ACTIONS(880),
    [anon_sym_Prop] = ACTIONS(858),
    [anon_sym_quote] = ACTIONS(858),
    [anon_sym_quoteTerm] = ACTIONS(858),
    [anon_sym_quoteContext] = ACTIONS(858),
    [anon_sym_unquote] = ACTIONS(858),
    [anon_sym_LPAREN_PIPE] = ACTIONS(882),
    [anon_sym_u2987] = ACTIONS(884),
    [anon_sym_let] = ACTIONS(886),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(890),
    [aux_sym_string_token1] = ACTIONS(890),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(892),
    [sym_PropN] = ACTIONS(858),
  },
  [593] = {
    [sym__FORALL] = STATE(8355),
    [sym__LAMBDA] = STATE(8054),
    [sym__ELLIPSIS] = STATE(4742),
    [sym__qid] = STATE(4742),
    [sym__binding_ids_and_absurds] = STATE(12359),
    [sym_attribute] = STATE(7725),
    [sym_attributes] = STATE(6302),
    [sym_expr] = STATE(11669),
    [sym__with_exprs] = STATE(10050),
    [sym__expr_or_attr] = STATE(4742),
    [sym__application] = STATE(9444),
    [sym__expr2_without_let] = STATE(9444),
    [sym__expr2] = STATE(9444),
    [sym_atom] = STATE(4712),
    [aux_sym__atoms] = STATE(3276),
    [sym__atom_curly] = STATE(4733),
    [sym__atom_no_curly] = STATE(4733),
    [sym_forall] = STATE(9444),
    [sym_let] = STATE(9444),
    [sym_lambda] = STATE(9444),
    [sym_lambda_extended_or_absurd] = STATE(9444),
    [sym_do] = STATE(9444),
    [sym_record_assignments] = STATE(4742),
    [sym_field_assignments] = STATE(4742),
    [aux_sym__typed_bindings] = STATE(8646),
    [sym_typed_binding] = STATE(8646),
    [sym_literal] = STATE(4742),
    [sym_SetN] = STATE(4742),
    [aux_sym__modal_arg_ids_repeat1] = STATE(7725),
    [aux_sym__with_exprs_repeat1] = STATE(3745),
    [sym_id] = ACTIONS(940),
    [anon_sym_forall] = ACTIONS(942),
    [anon_sym_u2200] = ACTIONS(942),
    [anon_sym_BSLASH] = ACTIONS(944),
    [anon_sym_u03bb] = ACTIONS(946),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(948),
    [anon_sym_u2026] = ACTIONS(948),
    [anon_sym_record] = ACTIONS(950),
    [anon_sym_LPAREN] = ACTIONS(952),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(954),
    [anon_sym_RBRACE_RBRACE] = ACTIONS(1162),
    [anon_sym_u2983] = ACTIONS(956),
    [anon_sym__] = ACTIONS(948),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(958),
    [aux_sym__qid_token1] = ACTIONS(960),
    [anon_sym_DOT] = ACTIONS(962),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(760),
    [anon_sym_quoteGoal] = ACTIONS(964),
    [anon_sym_tactic] = ACTIONS(966),
    [anon_sym_Prop] = ACTIONS(948),
    [anon_sym_quote] = ACTIONS(948),
    [anon_sym_quoteTerm] = ACTIONS(948),
    [anon_sym_quoteContext] = ACTIONS(948),
    [anon_sym_unquote] = ACTIONS(948),
    [anon_sym_LPAREN_PIPE] = ACTIONS(968),
    [anon_sym_u2987] = ACTIONS(970),
    [anon_sym_let] = ACTIONS(972),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(974),
    [aux_sym_string_token1] = ACTIONS(974),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(976),
    [sym_PropN] = ACTIONS(948),
  },
  [594] = {
    [sym__FORALL] = STATE(8345),
    [sym__LAMBDA] = STATE(8095),
    [sym__ELLIPSIS] = STATE(4742),
    [sym_open] = STATE(12555),
    [sym__qid] = STATE(4742),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3873),
    [sym_expr] = STATE(11470),
    [sym__with_exprs] = STATE(10084),
    [sym__expr_or_attr] = STATE(4742),
    [sym__application] = STATE(9680),
    [sym__expr2_without_let] = STATE(9680),
    [sym__expr2] = STATE(9680),
    [sym_atom] = STATE(4712),
    [aux_sym__atoms] = STATE(3211),
    [sym__atom_curly] = STATE(4733),
    [sym__atom_no_curly] = STATE(4733),
    [sym_forall] = STATE(9680),
    [sym_let] = STATE(9680),
    [sym_lambda] = STATE(9680),
    [sym_lambda_extended_or_absurd] = STATE(9680),
    [sym_do] = STATE(9680),
    [sym_record_assignments] = STATE(4742),
    [sym_field_assignments] = STATE(4742),
    [aux_sym__typed_bindings] = STATE(8642),
    [sym_typed_binding] = STATE(8642),
    [sym_literal] = STATE(4742),
    [sym_SetN] = STATE(4742),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3728),
    [sym_id] = ACTIONS(940),
    [anon_sym_forall] = ACTIONS(980),
    [anon_sym_u2200] = ACTIONS(980),
    [anon_sym_BSLASH] = ACTIONS(982),
    [anon_sym_u03bb] = ACTIONS(984),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(948),
    [anon_sym_u2026] = ACTIONS(948),
    [anon_sym_record] = ACTIONS(950),
    [anon_sym_open] = ACTIONS(986),
    [anon_sym_LPAREN] = ACTIONS(952),
    [anon_sym_RPAREN] = ACTIONS(1148),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(954),
    [anon_sym_u2983] = ACTIONS(956),
    [anon_sym__] = ACTIONS(948),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(958),
    [aux_sym__qid_token1] = ACTIONS(960),
    [anon_sym_DOT] = ACTIONS(962),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(988),
    [anon_sym_tactic] = ACTIONS(990),
    [anon_sym_Prop] = ACTIONS(948),
    [anon_sym_quote] = ACTIONS(948),
    [anon_sym_quoteTerm] = ACTIONS(948),
    [anon_sym_quoteContext] = ACTIONS(948),
    [anon_sym_unquote] = ACTIONS(948),
    [anon_sym_LPAREN_PIPE] = ACTIONS(968),
    [anon_sym_u2987] = ACTIONS(970),
    [anon_sym_let] = ACTIONS(992),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(974),
    [aux_sym_string_token1] = ACTIONS(974),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(976),
    [sym_PropN] = ACTIONS(948),
  },
  [595] = {
    [sym__FORALL] = STATE(8396),
    [sym__LAMBDA] = STATE(8031),
    [sym__ELLIPSIS] = STATE(4920),
    [sym__qid] = STATE(4920),
    [sym__binding_ids_and_absurds] = STATE(12539),
    [sym_attribute] = STATE(5830),
    [sym_attributes] = STATE(3504),
    [sym_expr] = STATE(11667),
    [sym__with_exprs] = STATE(10196),
    [sym__expr_or_attr] = STATE(4920),
    [sym__application] = STATE(9678),
    [sym__expr2_without_let] = STATE(9678),
    [sym__expr2] = STATE(9678),
    [sym_atom] = STATE(5202),
    [aux_sym__atoms] = STATE(3165),
    [sym__atom_curly] = STATE(4961),
    [sym__atom_no_curly] = STATE(4961),
    [sym_forall] = STATE(9678),
    [sym_let] = STATE(9678),
    [sym_lambda] = STATE(9678),
    [sym_lambda_extended_or_absurd] = STATE(9678),
    [sym_do] = STATE(9678),
    [sym_record_assignments] = STATE(4920),
    [sym_field_assignments] = STATE(4920),
    [aux_sym__typed_bindings] = STATE(8648),
    [sym_typed_binding] = STATE(8648),
    [sym_literal] = STATE(4920),
    [sym_SetN] = STATE(4920),
    [aux_sym__modal_arg_ids_repeat1] = STATE(5830),
    [aux_sym__with_exprs_repeat1] = STATE(3726),
    [sym_id] = ACTIONS(894),
    [anon_sym_forall] = ACTIONS(896),
    [anon_sym_u2200] = ACTIONS(896),
    [anon_sym_BSLASH] = ACTIONS(898),
    [anon_sym_u03bb] = ACTIONS(900),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(902),
    [anon_sym_u2026] = ACTIONS(902),
    [anon_sym_record] = ACTIONS(904),
    [anon_sym_LPAREN] = ACTIONS(906),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(908),
    [anon_sym_u2983] = ACTIONS(910),
    [anon_sym__] = ACTIONS(902),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(912),
    [anon_sym_RBRACE] = ACTIONS(1160),
    [aux_sym__qid_token1] = ACTIONS(916),
    [anon_sym_DOT] = ACTIONS(918),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(712),
    [anon_sym_quoteGoal] = ACTIONS(920),
    [anon_sym_tactic] = ACTIONS(922),
    [anon_sym_Prop] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(902),
    [anon_sym_quoteTerm] = ACTIONS(902),
    [anon_sym_quoteContext] = ACTIONS(902),
    [anon_sym_unquote] = ACTIONS(902),
    [anon_sym_LPAREN_PIPE] = ACTIONS(924),
    [anon_sym_u2987] = ACTIONS(926),
    [anon_sym_let] = ACTIONS(928),
    [anon_sym_do] = ACTIONS(724),
    [aux_sym_integer_token1] = ACTIONS(930),
    [aux_sym_string_token1] = ACTIONS(930),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(932),
    [sym_PropN] = ACTIONS(902),
  },
  [596] = {
    [sym__FORALL] = STATE(8369),
    [sym__LAMBDA] = STATE(8152),
    [sym__ELLIPSIS] = STATE(5168),
    [sym__qid] = STATE(5168),
    [sym__binding_ids_and_absurds] = STATE(12544),
    [sym_attribute] = STATE(5830),
    [sym_attributes] = STATE(3505),
    [sym_expr] = STATE(11668),
    [sym__with_exprs] = STATE(9861),
    [sym__expr_or_attr] = STATE(5168),
    [sym__application] = STATE(9444),
    [sym__expr2_without_let] = STATE(9444),
    [sym__expr2] = STATE(9444),
    [sym_atom] = STATE(5204),
    [aux_sym__atoms] = STATE(3133),
    [sym__atom_curly] = STATE(5180),
    [sym__atom_no_curly] = STATE(5180),
    [sym_forall] = STATE(9444),
    [sym_let] = STATE(9444),
    [sym_lambda] = STATE(9444),
    [sym_lambda_extended_or_absurd] = STATE(9444),
    [sym_do] = STATE(9444),
    [sym_record_assignments] = STATE(5168),
    [sym_field_assignments] = STATE(5168),
    [aux_sym__typed_bindings] = STATE(8654),
    [sym_typed_binding] = STATE(8654),
    [sym_literal] = STATE(5168),
    [sym_SetN] = STATE(5168),
    [aux_sym__modal_arg_ids_repeat1] = STATE(5830),
    [aux_sym__with_exprs_repeat1] = STATE(3754),
    [sym_id] = ACTIONS(850),
    [anon_sym_forall] = ACTIONS(852),
    [anon_sym_u2200] = ACTIONS(852),
    [anon_sym_BSLASH] = ACTIONS(854),
    [anon_sym_u03bb] = ACTIONS(856),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(858),
    [anon_sym_u2026] = ACTIONS(858),
    [anon_sym_record] = ACTIONS(860),
    [anon_sym_LPAREN] = ACTIONS(862),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(864),
    [anon_sym_u2983] = ACTIONS(866),
    [anon_sym_u2984] = ACTIONS(1162),
    [anon_sym__] = ACTIONS(858),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(870),
    [aux_sym__qid_token1] = ACTIONS(872),
    [anon_sym_DOT] = ACTIONS(874),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(712),
    [anon_sym_quoteGoal] = ACTIONS(878),
    [anon_sym_tactic] = ACTIONS(880),
    [anon_sym_Prop] = ACTIONS(858),
    [anon_sym_quote] = ACTIONS(858),
    [anon_sym_quoteTerm] = ACTIONS(858),
    [anon_sym_quoteContext] = ACTIONS(858),
    [anon_sym_unquote] = ACTIONS(858),
    [anon_sym_LPAREN_PIPE] = ACTIONS(882),
    [anon_sym_u2987] = ACTIONS(884),
    [anon_sym_let] = ACTIONS(886),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(890),
    [aux_sym_string_token1] = ACTIONS(890),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(892),
    [sym_PropN] = ACTIONS(858),
  },
  [597] = {
    [sym__FORALL] = STATE(8355),
    [sym__LAMBDA] = STATE(8054),
    [sym__ELLIPSIS] = STATE(4742),
    [sym__qid] = STATE(4742),
    [sym__binding_ids_and_absurds] = STATE(12547),
    [sym_attribute] = STATE(5830),
    [sym_attributes] = STATE(3506),
    [sym_expr] = STATE(11669),
    [sym__with_exprs] = STATE(10050),
    [sym__expr_or_attr] = STATE(4742),
    [sym__application] = STATE(9444),
    [sym__expr2_without_let] = STATE(9444),
    [sym__expr2] = STATE(9444),
    [sym_atom] = STATE(4712),
    [aux_sym__atoms] = STATE(3276),
    [sym__atom_curly] = STATE(4733),
    [sym__atom_no_curly] = STATE(4733),
    [sym_forall] = STATE(9444),
    [sym_let] = STATE(9444),
    [sym_lambda] = STATE(9444),
    [sym_lambda_extended_or_absurd] = STATE(9444),
    [sym_do] = STATE(9444),
    [sym_record_assignments] = STATE(4742),
    [sym_field_assignments] = STATE(4742),
    [aux_sym__typed_bindings] = STATE(8646),
    [sym_typed_binding] = STATE(8646),
    [sym_literal] = STATE(4742),
    [sym_SetN] = STATE(4742),
    [aux_sym__modal_arg_ids_repeat1] = STATE(5830),
    [aux_sym__with_exprs_repeat1] = STATE(3745),
    [sym_id] = ACTIONS(940),
    [anon_sym_forall] = ACTIONS(942),
    [anon_sym_u2200] = ACTIONS(942),
    [anon_sym_BSLASH] = ACTIONS(944),
    [anon_sym_u03bb] = ACTIONS(946),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(948),
    [anon_sym_u2026] = ACTIONS(948),
    [anon_sym_record] = ACTIONS(950),
    [anon_sym_LPAREN] = ACTIONS(952),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(954),
    [anon_sym_RBRACE_RBRACE] = ACTIONS(1162),
    [anon_sym_u2983] = ACTIONS(956),
    [anon_sym__] = ACTIONS(948),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(958),
    [aux_sym__qid_token1] = ACTIONS(960),
    [anon_sym_DOT] = ACTIONS(962),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(712),
    [anon_sym_quoteGoal] = ACTIONS(964),
    [anon_sym_tactic] = ACTIONS(966),
    [anon_sym_Prop] = ACTIONS(948),
    [anon_sym_quote] = ACTIONS(948),
    [anon_sym_quoteTerm] = ACTIONS(948),
    [anon_sym_quoteContext] = ACTIONS(948),
    [anon_sym_unquote] = ACTIONS(948),
    [anon_sym_LPAREN_PIPE] = ACTIONS(968),
    [anon_sym_u2987] = ACTIONS(970),
    [anon_sym_let] = ACTIONS(972),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(974),
    [aux_sym_string_token1] = ACTIONS(974),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(976),
    [sym_PropN] = ACTIONS(948),
  },
  [598] = {
    [sym__FORALL] = STATE(8345),
    [sym__LAMBDA] = STATE(8095),
    [sym__ELLIPSIS] = STATE(4742),
    [sym_open] = STATE(12555),
    [sym__qid] = STATE(4742),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3873),
    [sym_expr] = STATE(11631),
    [sym__with_exprs] = STATE(10084),
    [sym__expr_or_attr] = STATE(4742),
    [sym__application] = STATE(9680),
    [sym__expr2_without_let] = STATE(9680),
    [sym__expr2] = STATE(9680),
    [sym_atom] = STATE(4712),
    [aux_sym__atoms] = STATE(3211),
    [sym__atom_curly] = STATE(4733),
    [sym__atom_no_curly] = STATE(4733),
    [sym_forall] = STATE(9680),
    [sym_let] = STATE(9680),
    [sym_lambda] = STATE(9680),
    [sym_lambda_extended_or_absurd] = STATE(9680),
    [sym_do] = STATE(9680),
    [sym_record_assignments] = STATE(4742),
    [sym_field_assignments] = STATE(4742),
    [aux_sym__typed_bindings] = STATE(8642),
    [sym_typed_binding] = STATE(8642),
    [sym_literal] = STATE(4742),
    [sym_SetN] = STATE(4742),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3728),
    [sym_id] = ACTIONS(940),
    [anon_sym_forall] = ACTIONS(980),
    [anon_sym_u2200] = ACTIONS(980),
    [anon_sym_BSLASH] = ACTIONS(982),
    [anon_sym_u03bb] = ACTIONS(984),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(948),
    [anon_sym_u2026] = ACTIONS(948),
    [anon_sym_record] = ACTIONS(950),
    [anon_sym_open] = ACTIONS(986),
    [anon_sym_LPAREN] = ACTIONS(952),
    [anon_sym_RPAREN] = ACTIONS(1162),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(954),
    [anon_sym_u2983] = ACTIONS(956),
    [anon_sym__] = ACTIONS(948),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(958),
    [aux_sym__qid_token1] = ACTIONS(960),
    [anon_sym_DOT] = ACTIONS(962),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(988),
    [anon_sym_tactic] = ACTIONS(990),
    [anon_sym_Prop] = ACTIONS(948),
    [anon_sym_quote] = ACTIONS(948),
    [anon_sym_quoteTerm] = ACTIONS(948),
    [anon_sym_quoteContext] = ACTIONS(948),
    [anon_sym_unquote] = ACTIONS(948),
    [anon_sym_LPAREN_PIPE] = ACTIONS(968),
    [anon_sym_u2987] = ACTIONS(970),
    [anon_sym_let] = ACTIONS(992),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(974),
    [aux_sym_string_token1] = ACTIONS(974),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(976),
    [sym_PropN] = ACTIONS(948),
  },
  [599] = {
    [sym__FORALL] = STATE(8369),
    [sym__LAMBDA] = STATE(8152),
    [sym__ELLIPSIS] = STATE(5168),
    [sym__qid] = STATE(5168),
    [sym__binding_ids_and_absurds] = STATE(12358),
    [sym_attribute] = STATE(7725),
    [sym_attributes] = STATE(6182),
    [sym_expr] = STATE(10345),
    [sym__with_exprs] = STATE(9861),
    [sym__expr_or_attr] = STATE(5168),
    [sym__application] = STATE(9444),
    [sym__expr2_without_let] = STATE(9444),
    [sym__expr2] = STATE(9444),
    [sym_atom] = STATE(5204),
    [aux_sym__atoms] = STATE(3133),
    [sym__atom_curly] = STATE(5180),
    [sym__atom_no_curly] = STATE(5180),
    [sym_forall] = STATE(9444),
    [sym_let] = STATE(9444),
    [sym_lambda] = STATE(9444),
    [sym_lambda_extended_or_absurd] = STATE(9444),
    [sym_do] = STATE(9444),
    [sym_record_assignments] = STATE(5168),
    [sym_field_assignments] = STATE(5168),
    [aux_sym__typed_bindings] = STATE(8654),
    [sym_typed_binding] = STATE(8654),
    [sym_literal] = STATE(5168),
    [sym_SetN] = STATE(5168),
    [aux_sym__modal_arg_ids_repeat1] = STATE(7725),
    [aux_sym__with_exprs_repeat1] = STATE(3754),
    [sym_id] = ACTIONS(850),
    [anon_sym_forall] = ACTIONS(852),
    [anon_sym_u2200] = ACTIONS(852),
    [anon_sym_BSLASH] = ACTIONS(854),
    [anon_sym_u03bb] = ACTIONS(856),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(858),
    [anon_sym_u2026] = ACTIONS(858),
    [anon_sym_record] = ACTIONS(860),
    [anon_sym_LPAREN] = ACTIONS(862),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(864),
    [anon_sym_u2983] = ACTIONS(866),
    [anon_sym_u2984] = ACTIONS(978),
    [anon_sym__] = ACTIONS(858),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(870),
    [aux_sym__qid_token1] = ACTIONS(872),
    [anon_sym_DOT] = ACTIONS(874),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(760),
    [anon_sym_quoteGoal] = ACTIONS(878),
    [anon_sym_tactic] = ACTIONS(880),
    [anon_sym_Prop] = ACTIONS(858),
    [anon_sym_quote] = ACTIONS(858),
    [anon_sym_quoteTerm] = ACTIONS(858),
    [anon_sym_quoteContext] = ACTIONS(858),
    [anon_sym_unquote] = ACTIONS(858),
    [anon_sym_LPAREN_PIPE] = ACTIONS(882),
    [anon_sym_u2987] = ACTIONS(884),
    [anon_sym_let] = ACTIONS(886),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(890),
    [aux_sym_string_token1] = ACTIONS(890),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(892),
    [sym_PropN] = ACTIONS(858),
  },
  [600] = {
    [sym__FORALL] = STATE(8355),
    [sym__LAMBDA] = STATE(8054),
    [sym__ELLIPSIS] = STATE(4742),
    [sym__qid] = STATE(4742),
    [sym__binding_ids_and_absurds] = STATE(12359),
    [sym_attribute] = STATE(7725),
    [sym_attributes] = STATE(6302),
    [sym_expr] = STATE(10310),
    [sym__with_exprs] = STATE(10050),
    [sym__expr_or_attr] = STATE(4742),
    [sym__application] = STATE(9444),
    [sym__expr2_without_let] = STATE(9444),
    [sym__expr2] = STATE(9444),
    [sym_atom] = STATE(4712),
    [aux_sym__atoms] = STATE(3276),
    [sym__atom_curly] = STATE(4733),
    [sym__atom_no_curly] = STATE(4733),
    [sym_forall] = STATE(9444),
    [sym_let] = STATE(9444),
    [sym_lambda] = STATE(9444),
    [sym_lambda_extended_or_absurd] = STATE(9444),
    [sym_do] = STATE(9444),
    [sym_record_assignments] = STATE(4742),
    [sym_field_assignments] = STATE(4742),
    [aux_sym__typed_bindings] = STATE(8646),
    [sym_typed_binding] = STATE(8646),
    [sym_literal] = STATE(4742),
    [sym_SetN] = STATE(4742),
    [aux_sym__modal_arg_ids_repeat1] = STATE(7725),
    [aux_sym__with_exprs_repeat1] = STATE(3745),
    [sym_id] = ACTIONS(940),
    [anon_sym_forall] = ACTIONS(942),
    [anon_sym_u2200] = ACTIONS(942),
    [anon_sym_BSLASH] = ACTIONS(944),
    [anon_sym_u03bb] = ACTIONS(946),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(948),
    [anon_sym_u2026] = ACTIONS(948),
    [anon_sym_record] = ACTIONS(950),
    [anon_sym_LPAREN] = ACTIONS(952),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(954),
    [anon_sym_RBRACE_RBRACE] = ACTIONS(1092),
    [anon_sym_u2983] = ACTIONS(956),
    [anon_sym__] = ACTIONS(948),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(958),
    [aux_sym__qid_token1] = ACTIONS(960),
    [anon_sym_DOT] = ACTIONS(962),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(760),
    [anon_sym_quoteGoal] = ACTIONS(964),
    [anon_sym_tactic] = ACTIONS(966),
    [anon_sym_Prop] = ACTIONS(948),
    [anon_sym_quote] = ACTIONS(948),
    [anon_sym_quoteTerm] = ACTIONS(948),
    [anon_sym_quoteContext] = ACTIONS(948),
    [anon_sym_unquote] = ACTIONS(948),
    [anon_sym_LPAREN_PIPE] = ACTIONS(968),
    [anon_sym_u2987] = ACTIONS(970),
    [anon_sym_let] = ACTIONS(972),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(974),
    [aux_sym_string_token1] = ACTIONS(974),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(976),
    [sym_PropN] = ACTIONS(948),
  },
  [601] = {
    [sym__FORALL] = STATE(8369),
    [sym__LAMBDA] = STATE(8152),
    [sym__ELLIPSIS] = STATE(5168),
    [sym__qid] = STATE(5168),
    [sym__binding_ids_and_absurds] = STATE(12358),
    [sym_attribute] = STATE(7725),
    [sym_attributes] = STATE(6182),
    [sym_expr] = STATE(10309),
    [sym__with_exprs] = STATE(9861),
    [sym__expr_or_attr] = STATE(5168),
    [sym__application] = STATE(9444),
    [sym__expr2_without_let] = STATE(9444),
    [sym__expr2] = STATE(9444),
    [sym_atom] = STATE(5204),
    [aux_sym__atoms] = STATE(3133),
    [sym__atom_curly] = STATE(5180),
    [sym__atom_no_curly] = STATE(5180),
    [sym_forall] = STATE(9444),
    [sym_let] = STATE(9444),
    [sym_lambda] = STATE(9444),
    [sym_lambda_extended_or_absurd] = STATE(9444),
    [sym_do] = STATE(9444),
    [sym_record_assignments] = STATE(5168),
    [sym_field_assignments] = STATE(5168),
    [aux_sym__typed_bindings] = STATE(8654),
    [sym_typed_binding] = STATE(8654),
    [sym_literal] = STATE(5168),
    [sym_SetN] = STATE(5168),
    [aux_sym__modal_arg_ids_repeat1] = STATE(7725),
    [aux_sym__with_exprs_repeat1] = STATE(3754),
    [sym_id] = ACTIONS(850),
    [anon_sym_forall] = ACTIONS(852),
    [anon_sym_u2200] = ACTIONS(852),
    [anon_sym_BSLASH] = ACTIONS(854),
    [anon_sym_u03bb] = ACTIONS(856),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(858),
    [anon_sym_u2026] = ACTIONS(858),
    [anon_sym_record] = ACTIONS(860),
    [anon_sym_LPAREN] = ACTIONS(862),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(864),
    [anon_sym_u2983] = ACTIONS(866),
    [anon_sym_u2984] = ACTIONS(1092),
    [anon_sym__] = ACTIONS(858),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(870),
    [aux_sym__qid_token1] = ACTIONS(872),
    [anon_sym_DOT] = ACTIONS(874),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(760),
    [anon_sym_quoteGoal] = ACTIONS(878),
    [anon_sym_tactic] = ACTIONS(880),
    [anon_sym_Prop] = ACTIONS(858),
    [anon_sym_quote] = ACTIONS(858),
    [anon_sym_quoteTerm] = ACTIONS(858),
    [anon_sym_quoteContext] = ACTIONS(858),
    [anon_sym_unquote] = ACTIONS(858),
    [anon_sym_LPAREN_PIPE] = ACTIONS(882),
    [anon_sym_u2987] = ACTIONS(884),
    [anon_sym_let] = ACTIONS(886),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(890),
    [aux_sym_string_token1] = ACTIONS(890),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(892),
    [sym_PropN] = ACTIONS(858),
  },
  [602] = {
    [sym__FORALL] = STATE(8345),
    [sym__LAMBDA] = STATE(8095),
    [sym__ELLIPSIS] = STATE(4742),
    [sym_open] = STATE(12555),
    [sym__qid] = STATE(4742),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3873),
    [sym_expr] = STATE(11748),
    [sym__with_exprs] = STATE(10084),
    [sym__expr_or_attr] = STATE(4742),
    [sym__application] = STATE(9680),
    [sym__expr2_without_let] = STATE(9680),
    [sym__expr2] = STATE(9680),
    [sym_atom] = STATE(4712),
    [aux_sym__atoms] = STATE(3211),
    [sym__atom_curly] = STATE(4733),
    [sym__atom_no_curly] = STATE(4733),
    [sym_forall] = STATE(9680),
    [sym_let] = STATE(9680),
    [sym_lambda] = STATE(9680),
    [sym_lambda_extended_or_absurd] = STATE(9680),
    [sym_do] = STATE(9680),
    [sym_record_assignments] = STATE(4742),
    [sym_field_assignments] = STATE(4742),
    [aux_sym__typed_bindings] = STATE(8642),
    [sym_typed_binding] = STATE(8642),
    [sym_literal] = STATE(4742),
    [sym_SetN] = STATE(4742),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3728),
    [sym_id] = ACTIONS(940),
    [anon_sym_forall] = ACTIONS(980),
    [anon_sym_u2200] = ACTIONS(980),
    [anon_sym_BSLASH] = ACTIONS(982),
    [anon_sym_u03bb] = ACTIONS(984),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(948),
    [anon_sym_u2026] = ACTIONS(948),
    [anon_sym_record] = ACTIONS(950),
    [anon_sym_open] = ACTIONS(986),
    [anon_sym_LPAREN] = ACTIONS(952),
    [anon_sym_RPAREN] = ACTIONS(1164),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(954),
    [anon_sym_u2983] = ACTIONS(956),
    [anon_sym__] = ACTIONS(948),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(958),
    [aux_sym__qid_token1] = ACTIONS(960),
    [anon_sym_DOT] = ACTIONS(962),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(988),
    [anon_sym_tactic] = ACTIONS(990),
    [anon_sym_Prop] = ACTIONS(948),
    [anon_sym_quote] = ACTIONS(948),
    [anon_sym_quoteTerm] = ACTIONS(948),
    [anon_sym_quoteContext] = ACTIONS(948),
    [anon_sym_unquote] = ACTIONS(948),
    [anon_sym_LPAREN_PIPE] = ACTIONS(968),
    [anon_sym_u2987] = ACTIONS(970),
    [anon_sym_let] = ACTIONS(992),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(974),
    [aux_sym_string_token1] = ACTIONS(974),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(976),
    [sym_PropN] = ACTIONS(948),
  },
  [603] = {
    [sym__FORALL] = STATE(8355),
    [sym__LAMBDA] = STATE(8054),
    [sym__ELLIPSIS] = STATE(4742),
    [sym__qid] = STATE(4742),
    [sym__binding_ids_and_absurds] = STATE(12547),
    [sym_attribute] = STATE(5830),
    [sym_attributes] = STATE(3506),
    [sym_expr] = STATE(11781),
    [sym__with_exprs] = STATE(10050),
    [sym__expr_or_attr] = STATE(4742),
    [sym__application] = STATE(9444),
    [sym__expr2_without_let] = STATE(9444),
    [sym__expr2] = STATE(9444),
    [sym_atom] = STATE(4712),
    [aux_sym__atoms] = STATE(3276),
    [sym__atom_curly] = STATE(4733),
    [sym__atom_no_curly] = STATE(4733),
    [sym_forall] = STATE(9444),
    [sym_let] = STATE(9444),
    [sym_lambda] = STATE(9444),
    [sym_lambda_extended_or_absurd] = STATE(9444),
    [sym_do] = STATE(9444),
    [sym_record_assignments] = STATE(4742),
    [sym_field_assignments] = STATE(4742),
    [aux_sym__typed_bindings] = STATE(8646),
    [sym_typed_binding] = STATE(8646),
    [sym_literal] = STATE(4742),
    [sym_SetN] = STATE(4742),
    [aux_sym__modal_arg_ids_repeat1] = STATE(5830),
    [aux_sym__with_exprs_repeat1] = STATE(3745),
    [sym_id] = ACTIONS(940),
    [anon_sym_forall] = ACTIONS(942),
    [anon_sym_u2200] = ACTIONS(942),
    [anon_sym_BSLASH] = ACTIONS(944),
    [anon_sym_u03bb] = ACTIONS(946),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(948),
    [anon_sym_u2026] = ACTIONS(948),
    [anon_sym_record] = ACTIONS(950),
    [anon_sym_LPAREN] = ACTIONS(952),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(954),
    [anon_sym_RBRACE_RBRACE] = ACTIONS(1164),
    [anon_sym_u2983] = ACTIONS(956),
    [anon_sym__] = ACTIONS(948),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(958),
    [aux_sym__qid_token1] = ACTIONS(960),
    [anon_sym_DOT] = ACTIONS(962),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(712),
    [anon_sym_quoteGoal] = ACTIONS(964),
    [anon_sym_tactic] = ACTIONS(966),
    [anon_sym_Prop] = ACTIONS(948),
    [anon_sym_quote] = ACTIONS(948),
    [anon_sym_quoteTerm] = ACTIONS(948),
    [anon_sym_quoteContext] = ACTIONS(948),
    [anon_sym_unquote] = ACTIONS(948),
    [anon_sym_LPAREN_PIPE] = ACTIONS(968),
    [anon_sym_u2987] = ACTIONS(970),
    [anon_sym_let] = ACTIONS(972),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(974),
    [aux_sym_string_token1] = ACTIONS(974),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(976),
    [sym_PropN] = ACTIONS(948),
  },
  [604] = {
    [sym__FORALL] = STATE(8396),
    [sym__LAMBDA] = STATE(8031),
    [sym__ELLIPSIS] = STATE(4920),
    [sym__qid] = STATE(4920),
    [sym__binding_ids_and_absurds] = STATE(12357),
    [sym_attribute] = STATE(7725),
    [sym_attributes] = STATE(6200),
    [sym_expr] = STATE(10344),
    [sym__with_exprs] = STATE(10196),
    [sym__expr_or_attr] = STATE(4920),
    [sym__application] = STATE(9678),
    [sym__expr2_without_let] = STATE(9678),
    [sym__expr2] = STATE(9678),
    [sym_atom] = STATE(5202),
    [aux_sym__atoms] = STATE(3165),
    [sym__atom_curly] = STATE(4961),
    [sym__atom_no_curly] = STATE(4961),
    [sym_forall] = STATE(9678),
    [sym_let] = STATE(9678),
    [sym_lambda] = STATE(9678),
    [sym_lambda_extended_or_absurd] = STATE(9678),
    [sym_do] = STATE(9678),
    [sym_record_assignments] = STATE(4920),
    [sym_field_assignments] = STATE(4920),
    [aux_sym__typed_bindings] = STATE(8648),
    [sym_typed_binding] = STATE(8648),
    [sym_literal] = STATE(4920),
    [sym_SetN] = STATE(4920),
    [aux_sym__modal_arg_ids_repeat1] = STATE(7725),
    [aux_sym__with_exprs_repeat1] = STATE(3726),
    [sym_id] = ACTIONS(894),
    [anon_sym_forall] = ACTIONS(896),
    [anon_sym_u2200] = ACTIONS(896),
    [anon_sym_BSLASH] = ACTIONS(898),
    [anon_sym_u03bb] = ACTIONS(900),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(902),
    [anon_sym_u2026] = ACTIONS(902),
    [anon_sym_record] = ACTIONS(904),
    [anon_sym_LPAREN] = ACTIONS(906),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(908),
    [anon_sym_u2983] = ACTIONS(910),
    [anon_sym__] = ACTIONS(902),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(912),
    [anon_sym_RBRACE] = ACTIONS(1100),
    [aux_sym__qid_token1] = ACTIONS(916),
    [anon_sym_DOT] = ACTIONS(918),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(760),
    [anon_sym_quoteGoal] = ACTIONS(920),
    [anon_sym_tactic] = ACTIONS(922),
    [anon_sym_Prop] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(902),
    [anon_sym_quoteTerm] = ACTIONS(902),
    [anon_sym_quoteContext] = ACTIONS(902),
    [anon_sym_unquote] = ACTIONS(902),
    [anon_sym_LPAREN_PIPE] = ACTIONS(924),
    [anon_sym_u2987] = ACTIONS(926),
    [anon_sym_let] = ACTIONS(928),
    [anon_sym_do] = ACTIONS(724),
    [aux_sym_integer_token1] = ACTIONS(930),
    [aux_sym_string_token1] = ACTIONS(930),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(932),
    [sym_PropN] = ACTIONS(902),
  },
  [605] = {
    [sym__FORALL] = STATE(8396),
    [sym__LAMBDA] = STATE(8031),
    [sym__ELLIPSIS] = STATE(4920),
    [sym__qid] = STATE(4920),
    [sym__binding_ids_and_absurds] = STATE(12357),
    [sym_attribute] = STATE(7725),
    [sym_attributes] = STATE(6200),
    [sym_expr] = STATE(11779),
    [sym__with_exprs] = STATE(10196),
    [sym__expr_or_attr] = STATE(4920),
    [sym__application] = STATE(9678),
    [sym__expr2_without_let] = STATE(9678),
    [sym__expr2] = STATE(9678),
    [sym_atom] = STATE(5202),
    [aux_sym__atoms] = STATE(3165),
    [sym__atom_curly] = STATE(4961),
    [sym__atom_no_curly] = STATE(4961),
    [sym_forall] = STATE(9678),
    [sym_let] = STATE(9678),
    [sym_lambda] = STATE(9678),
    [sym_lambda_extended_or_absurd] = STATE(9678),
    [sym_do] = STATE(9678),
    [sym_record_assignments] = STATE(4920),
    [sym_field_assignments] = STATE(4920),
    [aux_sym__typed_bindings] = STATE(8648),
    [sym_typed_binding] = STATE(8648),
    [sym_literal] = STATE(4920),
    [sym_SetN] = STATE(4920),
    [aux_sym__modal_arg_ids_repeat1] = STATE(7725),
    [aux_sym__with_exprs_repeat1] = STATE(3726),
    [sym_id] = ACTIONS(894),
    [anon_sym_forall] = ACTIONS(896),
    [anon_sym_u2200] = ACTIONS(896),
    [anon_sym_BSLASH] = ACTIONS(898),
    [anon_sym_u03bb] = ACTIONS(900),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(902),
    [anon_sym_u2026] = ACTIONS(902),
    [anon_sym_record] = ACTIONS(904),
    [anon_sym_LPAREN] = ACTIONS(906),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(908),
    [anon_sym_u2983] = ACTIONS(910),
    [anon_sym__] = ACTIONS(902),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(912),
    [anon_sym_RBRACE] = ACTIONS(914),
    [aux_sym__qid_token1] = ACTIONS(916),
    [anon_sym_DOT] = ACTIONS(918),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(760),
    [anon_sym_quoteGoal] = ACTIONS(920),
    [anon_sym_tactic] = ACTIONS(922),
    [anon_sym_Prop] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(902),
    [anon_sym_quoteTerm] = ACTIONS(902),
    [anon_sym_quoteContext] = ACTIONS(902),
    [anon_sym_unquote] = ACTIONS(902),
    [anon_sym_LPAREN_PIPE] = ACTIONS(924),
    [anon_sym_u2987] = ACTIONS(926),
    [anon_sym_let] = ACTIONS(928),
    [anon_sym_do] = ACTIONS(724),
    [aux_sym_integer_token1] = ACTIONS(930),
    [aux_sym_string_token1] = ACTIONS(930),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(932),
    [sym_PropN] = ACTIONS(902),
  },
  [606] = {
    [sym__FORALL] = STATE(8396),
    [sym__LAMBDA] = STATE(8031),
    [sym__ELLIPSIS] = STATE(4920),
    [sym__qid] = STATE(4920),
    [sym__binding_ids_and_absurds] = STATE(12539),
    [sym_attribute] = STATE(5830),
    [sym_attributes] = STATE(3504),
    [sym_expr] = STATE(10288),
    [sym__with_exprs] = STATE(10196),
    [sym__expr_or_attr] = STATE(4920),
    [sym__application] = STATE(9678),
    [sym__expr2_without_let] = STATE(9678),
    [sym__expr2] = STATE(9678),
    [sym_atom] = STATE(5202),
    [aux_sym__atoms] = STATE(3165),
    [sym__atom_curly] = STATE(4961),
    [sym__atom_no_curly] = STATE(4961),
    [sym_forall] = STATE(9678),
    [sym_let] = STATE(9678),
    [sym_lambda] = STATE(9678),
    [sym_lambda_extended_or_absurd] = STATE(9678),
    [sym_do] = STATE(9678),
    [sym_record_assignments] = STATE(4920),
    [sym_field_assignments] = STATE(4920),
    [aux_sym__typed_bindings] = STATE(8648),
    [sym_typed_binding] = STATE(8648),
    [sym_literal] = STATE(4920),
    [sym_SetN] = STATE(4920),
    [aux_sym__modal_arg_ids_repeat1] = STATE(5830),
    [aux_sym__with_exprs_repeat1] = STATE(3726),
    [sym_id] = ACTIONS(894),
    [anon_sym_forall] = ACTIONS(896),
    [anon_sym_u2200] = ACTIONS(896),
    [anon_sym_BSLASH] = ACTIONS(898),
    [anon_sym_u03bb] = ACTIONS(900),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(902),
    [anon_sym_u2026] = ACTIONS(902),
    [anon_sym_record] = ACTIONS(904),
    [anon_sym_LPAREN] = ACTIONS(906),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(908),
    [anon_sym_u2983] = ACTIONS(910),
    [anon_sym__] = ACTIONS(902),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(912),
    [anon_sym_RBRACE] = ACTIONS(1156),
    [aux_sym__qid_token1] = ACTIONS(916),
    [anon_sym_DOT] = ACTIONS(918),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(712),
    [anon_sym_quoteGoal] = ACTIONS(920),
    [anon_sym_tactic] = ACTIONS(922),
    [anon_sym_Prop] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(902),
    [anon_sym_quoteTerm] = ACTIONS(902),
    [anon_sym_quoteContext] = ACTIONS(902),
    [anon_sym_unquote] = ACTIONS(902),
    [anon_sym_LPAREN_PIPE] = ACTIONS(924),
    [anon_sym_u2987] = ACTIONS(926),
    [anon_sym_let] = ACTIONS(928),
    [anon_sym_do] = ACTIONS(724),
    [aux_sym_integer_token1] = ACTIONS(930),
    [aux_sym_string_token1] = ACTIONS(930),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(932),
    [sym_PropN] = ACTIONS(902),
  },
  [607] = {
    [sym__FORALL] = STATE(8369),
    [sym__LAMBDA] = STATE(8152),
    [sym__ELLIPSIS] = STATE(5168),
    [sym__qid] = STATE(5168),
    [sym__binding_ids_and_absurds] = STATE(12358),
    [sym_attribute] = STATE(7725),
    [sym_attributes] = STATE(6182),
    [sym_expr] = STATE(11780),
    [sym__with_exprs] = STATE(9861),
    [sym__expr_or_attr] = STATE(5168),
    [sym__application] = STATE(9444),
    [sym__expr2_without_let] = STATE(9444),
    [sym__expr2] = STATE(9444),
    [sym_atom] = STATE(5204),
    [aux_sym__atoms] = STATE(3133),
    [sym__atom_curly] = STATE(5180),
    [sym__atom_no_curly] = STATE(5180),
    [sym_forall] = STATE(9444),
    [sym_let] = STATE(9444),
    [sym_lambda] = STATE(9444),
    [sym_lambda_extended_or_absurd] = STATE(9444),
    [sym_do] = STATE(9444),
    [sym_record_assignments] = STATE(5168),
    [sym_field_assignments] = STATE(5168),
    [aux_sym__typed_bindings] = STATE(8654),
    [sym_typed_binding] = STATE(8654),
    [sym_literal] = STATE(5168),
    [sym_SetN] = STATE(5168),
    [aux_sym__modal_arg_ids_repeat1] = STATE(7725),
    [aux_sym__with_exprs_repeat1] = STATE(3754),
    [sym_id] = ACTIONS(850),
    [anon_sym_forall] = ACTIONS(852),
    [anon_sym_u2200] = ACTIONS(852),
    [anon_sym_BSLASH] = ACTIONS(854),
    [anon_sym_u03bb] = ACTIONS(856),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(858),
    [anon_sym_u2026] = ACTIONS(858),
    [anon_sym_record] = ACTIONS(860),
    [anon_sym_LPAREN] = ACTIONS(862),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(864),
    [anon_sym_u2983] = ACTIONS(866),
    [anon_sym_u2984] = ACTIONS(1164),
    [anon_sym__] = ACTIONS(858),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(870),
    [aux_sym__qid_token1] = ACTIONS(872),
    [anon_sym_DOT] = ACTIONS(874),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(760),
    [anon_sym_quoteGoal] = ACTIONS(878),
    [anon_sym_tactic] = ACTIONS(880),
    [anon_sym_Prop] = ACTIONS(858),
    [anon_sym_quote] = ACTIONS(858),
    [anon_sym_quoteTerm] = ACTIONS(858),
    [anon_sym_quoteContext] = ACTIONS(858),
    [anon_sym_unquote] = ACTIONS(858),
    [anon_sym_LPAREN_PIPE] = ACTIONS(882),
    [anon_sym_u2987] = ACTIONS(884),
    [anon_sym_let] = ACTIONS(886),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(890),
    [aux_sym_string_token1] = ACTIONS(890),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(892),
    [sym_PropN] = ACTIONS(858),
  },
  [608] = {
    [sym__FORALL] = STATE(8369),
    [sym__LAMBDA] = STATE(8152),
    [sym__ELLIPSIS] = STATE(5168),
    [sym__qid] = STATE(5168),
    [sym__binding_ids_and_absurds] = STATE(12544),
    [sym_attribute] = STATE(5830),
    [sym_attributes] = STATE(3505),
    [sym_expr] = STATE(10330),
    [sym__with_exprs] = STATE(9861),
    [sym__expr_or_attr] = STATE(5168),
    [sym__application] = STATE(9444),
    [sym__expr2_without_let] = STATE(9444),
    [sym__expr2] = STATE(9444),
    [sym_atom] = STATE(5204),
    [aux_sym__atoms] = STATE(3133),
    [sym__atom_curly] = STATE(5180),
    [sym__atom_no_curly] = STATE(5180),
    [sym_forall] = STATE(9444),
    [sym_let] = STATE(9444),
    [sym_lambda] = STATE(9444),
    [sym_lambda_extended_or_absurd] = STATE(9444),
    [sym_do] = STATE(9444),
    [sym_record_assignments] = STATE(5168),
    [sym_field_assignments] = STATE(5168),
    [aux_sym__typed_bindings] = STATE(8654),
    [sym_typed_binding] = STATE(8654),
    [sym_literal] = STATE(5168),
    [sym_SetN] = STATE(5168),
    [aux_sym__modal_arg_ids_repeat1] = STATE(5830),
    [aux_sym__with_exprs_repeat1] = STATE(3754),
    [sym_id] = ACTIONS(850),
    [anon_sym_forall] = ACTIONS(852),
    [anon_sym_u2200] = ACTIONS(852),
    [anon_sym_BSLASH] = ACTIONS(854),
    [anon_sym_u03bb] = ACTIONS(856),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(858),
    [anon_sym_u2026] = ACTIONS(858),
    [anon_sym_record] = ACTIONS(860),
    [anon_sym_LPAREN] = ACTIONS(862),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(864),
    [anon_sym_u2983] = ACTIONS(866),
    [anon_sym_u2984] = ACTIONS(1158),
    [anon_sym__] = ACTIONS(858),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(870),
    [aux_sym__qid_token1] = ACTIONS(872),
    [anon_sym_DOT] = ACTIONS(874),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(712),
    [anon_sym_quoteGoal] = ACTIONS(878),
    [anon_sym_tactic] = ACTIONS(880),
    [anon_sym_Prop] = ACTIONS(858),
    [anon_sym_quote] = ACTIONS(858),
    [anon_sym_quoteTerm] = ACTIONS(858),
    [anon_sym_quoteContext] = ACTIONS(858),
    [anon_sym_unquote] = ACTIONS(858),
    [anon_sym_LPAREN_PIPE] = ACTIONS(882),
    [anon_sym_u2987] = ACTIONS(884),
    [anon_sym_let] = ACTIONS(886),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(890),
    [aux_sym_string_token1] = ACTIONS(890),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(892),
    [sym_PropN] = ACTIONS(858),
  },
  [609] = {
    [sym__FORALL] = STATE(8355),
    [sym__LAMBDA] = STATE(8054),
    [sym__ELLIPSIS] = STATE(4742),
    [sym__qid] = STATE(4742),
    [sym__binding_ids_and_absurds] = STATE(12547),
    [sym_attribute] = STATE(5830),
    [sym_attributes] = STATE(3506),
    [sym_expr] = STATE(10327),
    [sym__with_exprs] = STATE(10050),
    [sym__expr_or_attr] = STATE(4742),
    [sym__application] = STATE(9444),
    [sym__expr2_without_let] = STATE(9444),
    [sym__expr2] = STATE(9444),
    [sym_atom] = STATE(4712),
    [aux_sym__atoms] = STATE(3276),
    [sym__atom_curly] = STATE(4733),
    [sym__atom_no_curly] = STATE(4733),
    [sym_forall] = STATE(9444),
    [sym_let] = STATE(9444),
    [sym_lambda] = STATE(9444),
    [sym_lambda_extended_or_absurd] = STATE(9444),
    [sym_do] = STATE(9444),
    [sym_record_assignments] = STATE(4742),
    [sym_field_assignments] = STATE(4742),
    [aux_sym__typed_bindings] = STATE(8646),
    [sym_typed_binding] = STATE(8646),
    [sym_literal] = STATE(4742),
    [sym_SetN] = STATE(4742),
    [aux_sym__modal_arg_ids_repeat1] = STATE(5830),
    [aux_sym__with_exprs_repeat1] = STATE(3745),
    [sym_id] = ACTIONS(940),
    [anon_sym_forall] = ACTIONS(942),
    [anon_sym_u2200] = ACTIONS(942),
    [anon_sym_BSLASH] = ACTIONS(944),
    [anon_sym_u03bb] = ACTIONS(946),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(948),
    [anon_sym_u2026] = ACTIONS(948),
    [anon_sym_record] = ACTIONS(950),
    [anon_sym_LPAREN] = ACTIONS(952),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(954),
    [anon_sym_RBRACE_RBRACE] = ACTIONS(1158),
    [anon_sym_u2983] = ACTIONS(956),
    [anon_sym__] = ACTIONS(948),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(958),
    [aux_sym__qid_token1] = ACTIONS(960),
    [anon_sym_DOT] = ACTIONS(962),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(712),
    [anon_sym_quoteGoal] = ACTIONS(964),
    [anon_sym_tactic] = ACTIONS(966),
    [anon_sym_Prop] = ACTIONS(948),
    [anon_sym_quote] = ACTIONS(948),
    [anon_sym_quoteTerm] = ACTIONS(948),
    [anon_sym_quoteContext] = ACTIONS(948),
    [anon_sym_unquote] = ACTIONS(948),
    [anon_sym_LPAREN_PIPE] = ACTIONS(968),
    [anon_sym_u2987] = ACTIONS(970),
    [anon_sym_let] = ACTIONS(972),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(974),
    [aux_sym_string_token1] = ACTIONS(974),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(976),
    [sym_PropN] = ACTIONS(948),
  },
  [610] = {
    [sym__FORALL] = STATE(8355),
    [sym__LAMBDA] = STATE(8054),
    [sym__ELLIPSIS] = STATE(4742),
    [sym__qid] = STATE(4742),
    [sym__binding_ids_and_absurds] = STATE(12359),
    [sym_attribute] = STATE(7725),
    [sym_attributes] = STATE(6302),
    [sym_expr] = STATE(11781),
    [sym__with_exprs] = STATE(10050),
    [sym__expr_or_attr] = STATE(4742),
    [sym__application] = STATE(9444),
    [sym__expr2_without_let] = STATE(9444),
    [sym__expr2] = STATE(9444),
    [sym_atom] = STATE(4712),
    [aux_sym__atoms] = STATE(3276),
    [sym__atom_curly] = STATE(4733),
    [sym__atom_no_curly] = STATE(4733),
    [sym_forall] = STATE(9444),
    [sym_let] = STATE(9444),
    [sym_lambda] = STATE(9444),
    [sym_lambda_extended_or_absurd] = STATE(9444),
    [sym_do] = STATE(9444),
    [sym_record_assignments] = STATE(4742),
    [sym_field_assignments] = STATE(4742),
    [aux_sym__typed_bindings] = STATE(8646),
    [sym_typed_binding] = STATE(8646),
    [sym_literal] = STATE(4742),
    [sym_SetN] = STATE(4742),
    [aux_sym__modal_arg_ids_repeat1] = STATE(7725),
    [aux_sym__with_exprs_repeat1] = STATE(3745),
    [sym_id] = ACTIONS(940),
    [anon_sym_forall] = ACTIONS(942),
    [anon_sym_u2200] = ACTIONS(942),
    [anon_sym_BSLASH] = ACTIONS(944),
    [anon_sym_u03bb] = ACTIONS(946),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(948),
    [anon_sym_u2026] = ACTIONS(948),
    [anon_sym_record] = ACTIONS(950),
    [anon_sym_LPAREN] = ACTIONS(952),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(954),
    [anon_sym_RBRACE_RBRACE] = ACTIONS(1164),
    [anon_sym_u2983] = ACTIONS(956),
    [anon_sym__] = ACTIONS(948),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(958),
    [aux_sym__qid_token1] = ACTIONS(960),
    [anon_sym_DOT] = ACTIONS(962),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(760),
    [anon_sym_quoteGoal] = ACTIONS(964),
    [anon_sym_tactic] = ACTIONS(966),
    [anon_sym_Prop] = ACTIONS(948),
    [anon_sym_quote] = ACTIONS(948),
    [anon_sym_quoteTerm] = ACTIONS(948),
    [anon_sym_quoteContext] = ACTIONS(948),
    [anon_sym_unquote] = ACTIONS(948),
    [anon_sym_LPAREN_PIPE] = ACTIONS(968),
    [anon_sym_u2987] = ACTIONS(970),
    [anon_sym_let] = ACTIONS(972),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(974),
    [aux_sym_string_token1] = ACTIONS(974),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(976),
    [sym_PropN] = ACTIONS(948),
  },
  [611] = {
    [sym__FORALL] = STATE(8345),
    [sym__LAMBDA] = STATE(8095),
    [sym__ELLIPSIS] = STATE(4742),
    [sym_open] = STATE(12555),
    [sym__qid] = STATE(4742),
    [sym_attribute] = STATE(6309),
    [sym_attributes] = STATE(3873),
    [sym_expr] = STATE(10477),
    [sym__with_exprs] = STATE(10084),
    [sym__expr_or_attr] = STATE(4742),
    [sym__application] = STATE(9680),
    [sym__expr2_without_let] = STATE(9680),
    [sym__expr2] = STATE(9680),
    [sym_atom] = STATE(4712),
    [aux_sym__atoms] = STATE(3211),
    [sym__atom_curly] = STATE(4733),
    [sym__atom_no_curly] = STATE(4733),
    [sym_forall] = STATE(9680),
    [sym_let] = STATE(9680),
    [sym_lambda] = STATE(9680),
    [sym_lambda_extended_or_absurd] = STATE(9680),
    [sym_do] = STATE(9680),
    [sym_record_assignments] = STATE(4742),
    [sym_field_assignments] = STATE(4742),
    [aux_sym__typed_bindings] = STATE(8642),
    [sym_typed_binding] = STATE(8642),
    [sym_literal] = STATE(4742),
    [sym_SetN] = STATE(4742),
    [aux_sym__modal_arg_ids_repeat1] = STATE(6309),
    [aux_sym__with_exprs_repeat1] = STATE(3728),
    [sym_id] = ACTIONS(940),
    [anon_sym_forall] = ACTIONS(980),
    [anon_sym_u2200] = ACTIONS(980),
    [anon_sym_BSLASH] = ACTIONS(982),
    [anon_sym_u03bb] = ACTIONS(984),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(948),
    [anon_sym_u2026] = ACTIONS(948),
    [anon_sym_record] = ACTIONS(950),
    [anon_sym_open] = ACTIONS(986),
    [anon_sym_LPAREN] = ACTIONS(952),
    [anon_sym_RPAREN] = ACTIONS(1158),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(954),
    [anon_sym_u2983] = ACTIONS(956),
    [anon_sym__] = ACTIONS(948),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(958),
    [aux_sym__qid_token1] = ACTIONS(960),
    [anon_sym_DOT] = ACTIONS(962),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_AT] = ACTIONS(73),
    [anon_sym_quoteGoal] = ACTIONS(988),
    [anon_sym_tactic] = ACTIONS(990),
    [anon_sym_Prop] = ACTIONS(948),
    [anon_sym_quote] = ACTIONS(948),
    [anon_sym_quoteTerm] = ACTIONS(948),
    [anon_sym_quoteContext] = ACTIONS(948),
    [anon_sym_unquote] = ACTIONS(948),
    [anon_sym_LPAREN_PIPE] = ACTIONS(968),
    [anon_sym_u2987] = ACTIONS(970),
    [anon_sym_let] = ACTIONS(992),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(974),
    [aux_sym_string_token1] = ACTIONS(974),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(976),
    [sym_PropN] = ACTIONS(948),
  },
  [612] = {
    [sym__FORALL] = STATE(8369),
    [sym__LAMBDA] = STATE(8152),
    [sym__ELLIPSIS] = STATE(5168),
    [sym__qid] = STATE(5168),
    [sym__binding_ids_and_absurds] = STATE(12544),
    [sym_attribute] = STATE(5830),
    [sym_attributes] = STATE(3505),
    [sym_expr] = STATE(11780),
    [sym__with_exprs] = STATE(9861),
    [sym__expr_or_attr] = STATE(5168),
    [sym__application] = STATE(9444),
    [sym__expr2_without_let] = STATE(9444),
    [sym__expr2] = STATE(9444),
    [sym_atom] = STATE(5204),
    [aux_sym__atoms] = STATE(3133),
    [sym__atom_curly] = STATE(5180),
    [sym__atom_no_curly] = STATE(5180),
    [sym_forall] = STATE(9444),
    [sym_let] = STATE(9444),
    [sym_lambda] = STATE(9444),
    [sym_lambda_extended_or_absurd] = STATE(9444),
    [sym_do] = STATE(9444),
    [sym_record_assignments] = STATE(5168),
    [sym_field_assignments] = STATE(5168),
    [aux_sym__typed_bindings] = STATE(8654),
    [sym_typed_binding] = STATE(8654),
    [sym_literal] = STATE(5168),
    [sym_SetN] = STATE(5168),
    [aux_sym__modal_arg_ids_repeat1] = STATE(5830),
    [aux_sym__with_exprs_repeat1] = STATE(3754),
    [sym_id] = ACTIONS(850),
    [anon_sym_forall] = ACTIONS(852),
    [anon_sym_u2200] = ACTIONS(852),
    [anon_sym_BSLASH] = ACTIONS(854),
    [anon_sym_u03bb] = ACTIONS(856),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(858),
    [anon_sym_u2026] = ACTIONS(858),
    [anon_sym_record] = ACTIONS(860),
    [anon_sym_LPAREN] = ACTIONS(862),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(864),
    [anon_sym_u2983] = ACTIONS(866),
    [anon_sym_u2984] = ACTIONS(1164),
    [anon_sym__] = ACTIONS(858),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(870),
    [aux_sym__qid_token1] = ACTIONS(872),
    [anon_sym_DOT] = ACTIONS(874),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(712),
    [anon_sym_quoteGoal] = ACTIONS(878),
    [anon_sym_tactic] = ACTIONS(880),
    [anon_sym_Prop] = ACTIONS(858),
    [anon_sym_quote] = ACTIONS(858),
    [anon_sym_quoteTerm] = ACTIONS(858),
    [anon_sym_quoteContext] = ACTIONS(858),
    [anon_sym_unquote] = ACTIONS(858),
    [anon_sym_LPAREN_PIPE] = ACTIONS(882),
    [anon_sym_u2987] = ACTIONS(884),
    [anon_sym_let] = ACTIONS(886),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(890),
    [aux_sym_string_token1] = ACTIONS(890),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(892),
    [sym_PropN] = ACTIONS(858),
  },
  [613] = {
    [sym__FORALL] = STATE(8355),
    [sym__LAMBDA] = STATE(8054),
    [sym__ELLIPSIS] = STATE(4742),
    [sym__qid] = STATE(4742),
    [sym__binding_ids_and_absurds] = STATE(12359),
    [sym_attribute] = STATE(7725),
    [sym_attributes] = STATE(6302),
    [sym_expr] = STATE(10348),
    [sym__with_exprs] = STATE(10050),
    [sym__expr_or_attr] = STATE(4742),
    [sym__application] = STATE(9444),
    [sym__expr2_without_let] = STATE(9444),
    [sym__expr2] = STATE(9444),
    [sym_atom] = STATE(4712),
    [aux_sym__atoms] = STATE(3276),
    [sym__atom_curly] = STATE(4733),
    [sym__atom_no_curly] = STATE(4733),
    [sym_forall] = STATE(9444),
    [sym_let] = STATE(9444),
    [sym_lambda] = STATE(9444),
    [sym_lambda_extended_or_absurd] = STATE(9444),
    [sym_do] = STATE(9444),
    [sym_record_assignments] = STATE(4742),
    [sym_field_assignments] = STATE(4742),
    [aux_sym__typed_bindings] = STATE(8646),
    [sym_typed_binding] = STATE(8646),
    [sym_literal] = STATE(4742),
    [sym_SetN] = STATE(4742),
    [aux_sym__modal_arg_ids_repeat1] = STATE(7725),
    [aux_sym__with_exprs_repeat1] = STATE(3745),
    [sym_id] = ACTIONS(940),
    [anon_sym_forall] = ACTIONS(942),
    [anon_sym_u2200] = ACTIONS(942),
    [anon_sym_BSLASH] = ACTIONS(944),
    [anon_sym_u03bb] = ACTIONS(946),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(948),
    [anon_sym_u2026] = ACTIONS(948),
    [anon_sym_record] = ACTIONS(950),
    [anon_sym_LPAREN] = ACTIONS(952),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(954),
    [anon_sym_RBRACE_RBRACE] = ACTIONS(978),
    [anon_sym_u2983] = ACTIONS(956),
    [anon_sym__] = ACTIONS(948),
    [sym_pragma] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(958),
    [aux_sym__qid_token1] = ACTIONS(960),
    [anon_sym_DOT] = ACTIONS(962),
    [anon_sym_DOT_DOT] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(760),
    [anon_sym_quoteGoal] = ACTIONS(964),
    [anon_sym_tactic] = ACTIONS(966),
    [anon_sym_Prop] = ACTIONS(948),
    [anon_sym_quote] = ACTIONS(948),
    [anon_sym_quoteTerm] = ACTIONS(948),
    [anon_sym_quoteContext] = ACTIONS(948),
    [anon_sym_unquote] = ACTIONS(948),
    [anon_sym_LPAREN_PIPE] = ACTIONS(968),
    [anon_sym_u2987] = ACTIONS(970),
    [anon_sym_let] = ACTIONS(972),
    [anon_sym_do] = ACTIONS(888),
    [aux_sym_integer_token1] = ACTIONS(974),
    [aux_sym_string_token1] = ACTIONS(974),
    [sym_comment] = ACTIONS(5),
    [anon_sym_Set] = ACTIONS(976),
    [sym_PropN] = ACTIONS(948),
  },
};

static const uint16_t ts_small_parse_table[] = {
  [0] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1180), 1,
      anon_sym_RPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(12160), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [139] = 37,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1014), 1,
      anon_sym_RBRACE,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(12362), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [278] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1262), 1,
      anon_sym_u2984,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(10921), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [417] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1262), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(10924), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [556] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1262), 1,
      anon_sym_RPAREN,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(10777), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [695] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1296), 1,
      anon_sym_RPAREN,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(12751), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [834] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1298), 1,
      anon_sym_RPAREN,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(12122), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [973] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    ACTIONS(1298), 1,
      anon_sym_RBRACE_RBRACE,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(12188), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [1112] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1300), 1,
      anon_sym_RPAREN,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(12418), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [1251] = 37,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1042), 1,
      anon_sym_RBRACE,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(11974), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [1390] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    ACTIONS(1298), 1,
      anon_sym_u2984,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(12187), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [1529] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1044), 1,
      anon_sym_u2984,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(11972), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [1668] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(940), 1,
      sym_id,
    ACTIONS(950), 1,
      anon_sym_record,
    ACTIONS(952), 1,
      anon_sym_LPAREN,
    ACTIONS(954), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(956), 1,
      anon_sym_u2983,
    ACTIONS(958), 1,
      anon_sym_LBRACE,
    ACTIONS(960), 1,
      aux_sym__qid_token1,
    ACTIONS(962), 1,
      anon_sym_DOT,
    ACTIONS(968), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(970), 1,
      anon_sym_u2987,
    ACTIONS(976), 1,
      anon_sym_Set,
    ACTIONS(982), 1,
      anon_sym_BSLASH,
    ACTIONS(984), 1,
      anon_sym_u03bb,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(990), 1,
      anon_sym_tactic,
    ACTIONS(1164), 1,
      anon_sym_RPAREN,
    ACTIONS(1302), 1,
      anon_sym_let,
    STATE(3211), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4712), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8095), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(11748), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(974), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(4733), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4742), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9581), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(948), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [1807] = 37,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    ACTIONS(1304), 1,
      anon_sym_RBRACE,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(12183), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [1946] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    ACTIONS(1306), 1,
      anon_sym_u2984,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(12644), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [2085] = 37,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    ACTIONS(1308), 1,
      anon_sym_RBRACE,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(10920), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [2224] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    ACTIONS(1296), 1,
      anon_sym_u2984,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(12605), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [2363] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1310), 1,
      anon_sym_RPAREN,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(12104), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [2502] = 37,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    ACTIONS(1312), 1,
      anon_sym_RBRACE,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(12607), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [2641] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    ACTIONS(1314), 1,
      anon_sym_u2984,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(12576), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [2780] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    ACTIONS(1310), 1,
      anon_sym_RBRACE_RBRACE,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(12159), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [2919] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1044), 1,
      anon_sym_RPAREN,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(12140), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [3058] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1316), 1,
      anon_sym_RPAREN,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(12695), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [3197] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    ACTIONS(1310), 1,
      anon_sym_u2984,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(12158), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [3336] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    ACTIONS(1316), 1,
      anon_sym_RBRACE_RBRACE,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(12761), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [3475] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    ACTIONS(1316), 1,
      anon_sym_u2984,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(12760), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [3614] = 37,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    ACTIONS(1318), 1,
      anon_sym_RBRACE,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(12759), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [3753] = 37,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    ACTIONS(1320), 1,
      anon_sym_RBRACE,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(12156), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [3892] = 37,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1100), 1,
      anon_sym_RBRACE,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(10344), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [4031] = 37,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    ACTIONS(1322), 1,
      anon_sym_RBRACE,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(12500), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [4170] = 37,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    ACTIONS(1324), 1,
      anon_sym_RBRACE,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(12204), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [4309] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1092), 1,
      anon_sym_u2984,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(10309), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [4448] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    ACTIONS(1300), 1,
      anon_sym_RBRACE_RBRACE,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(12482), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [4587] = 37,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    ACTIONS(1326), 1,
      anon_sym_RBRACE,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(10331), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [4726] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1092), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(10310), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [4865] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(940), 1,
      sym_id,
    ACTIONS(950), 1,
      anon_sym_record,
    ACTIONS(952), 1,
      anon_sym_LPAREN,
    ACTIONS(954), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(956), 1,
      anon_sym_u2983,
    ACTIONS(958), 1,
      anon_sym_LBRACE,
    ACTIONS(960), 1,
      aux_sym__qid_token1,
    ACTIONS(962), 1,
      anon_sym_DOT,
    ACTIONS(968), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(970), 1,
      anon_sym_u2987,
    ACTIONS(976), 1,
      anon_sym_Set,
    ACTIONS(982), 1,
      anon_sym_BSLASH,
    ACTIONS(984), 1,
      anon_sym_u03bb,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(990), 1,
      anon_sym_tactic,
    ACTIONS(1092), 1,
      anon_sym_RPAREN,
    ACTIONS(1302), 1,
      anon_sym_let,
    STATE(3211), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4712), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8095), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(10246), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(974), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(4733), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4742), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9581), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(948), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [5004] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1328), 1,
      anon_sym_RPAREN,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(10519), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [5143] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    ACTIONS(1330), 1,
      anon_sym_u2984,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(12206), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [5282] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1092), 1,
      anon_sym_RPAREN,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(10246), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [5421] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1332), 1,
      anon_sym_RPAREN,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(11576), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [5560] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    ACTIONS(1332), 1,
      anon_sym_RBRACE_RBRACE,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(11575), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [5699] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1334), 1,
      anon_sym_RPAREN,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(12088), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [5838] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    ACTIONS(1332), 1,
      anon_sym_u2984,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(11574), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [5977] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    ACTIONS(1328), 1,
      anon_sym_RBRACE_RBRACE,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(10374), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [6116] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    ACTIONS(1334), 1,
      anon_sym_RBRACE_RBRACE,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(12136), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [6255] = 37,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    ACTIONS(1336), 1,
      anon_sym_RBRACE,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(11431), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [6394] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    ACTIONS(1334), 1,
      anon_sym_u2984,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(12135), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [6533] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    ACTIONS(1328), 1,
      anon_sym_u2984,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(10376), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [6672] = 37,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    ACTIONS(1338), 1,
      anon_sym_RBRACE,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(10379), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [6811] = 37,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    ACTIONS(1340), 1,
      anon_sym_RBRACE,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(12134), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [6950] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    ACTIONS(1342), 1,
      anon_sym_u2984,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(10287), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [7089] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    ACTIONS(1330), 1,
      anon_sym_RBRACE_RBRACE,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(12208), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [7228] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1344), 1,
      anon_sym_RPAREN,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(12054), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [7367] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    ACTIONS(1342), 1,
      anon_sym_RBRACE_RBRACE,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(10283), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [7506] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1330), 1,
      anon_sym_RPAREN,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(12139), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [7645] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    ACTIONS(1344), 1,
      anon_sym_RBRACE_RBRACE,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(12103), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [7784] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    ACTIONS(1346), 1,
      anon_sym_u2984,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(12502), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [7923] = 37,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    ACTIONS(1348), 1,
      anon_sym_RBRACE,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(12223), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [8062] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(940), 1,
      sym_id,
    ACTIONS(950), 1,
      anon_sym_record,
    ACTIONS(952), 1,
      anon_sym_LPAREN,
    ACTIONS(954), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(956), 1,
      anon_sym_u2983,
    ACTIONS(958), 1,
      anon_sym_LBRACE,
    ACTIONS(960), 1,
      aux_sym__qid_token1,
    ACTIONS(962), 1,
      anon_sym_DOT,
    ACTIONS(968), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(970), 1,
      anon_sym_u2987,
    ACTIONS(976), 1,
      anon_sym_Set,
    ACTIONS(982), 1,
      anon_sym_BSLASH,
    ACTIONS(984), 1,
      anon_sym_u03bb,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(990), 1,
      anon_sym_tactic,
    ACTIONS(1162), 1,
      anon_sym_RPAREN,
    ACTIONS(1302), 1,
      anon_sym_let,
    STATE(3211), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4712), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8095), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(11631), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(974), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(4733), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4742), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9581), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(948), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [8201] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    ACTIONS(1344), 1,
      anon_sym_u2984,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(12102), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [8340] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1342), 1,
      anon_sym_RPAREN,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(10373), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [8479] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1180), 1,
      anon_sym_u2984,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(12224), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [8618] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1180), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(12226), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [8757] = 37,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    ACTIONS(1350), 1,
      anon_sym_RBRACE,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(12100), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [8896] = 37,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    ACTIONS(1352), 1,
      anon_sym_RBRACE,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(12566), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [9035] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    ACTIONS(1354), 1,
      anon_sym_u2984,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(12565), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [9174] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(940), 1,
      sym_id,
    ACTIONS(950), 1,
      anon_sym_record,
    ACTIONS(952), 1,
      anon_sym_LPAREN,
    ACTIONS(954), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(956), 1,
      anon_sym_u2983,
    ACTIONS(958), 1,
      anon_sym_LBRACE,
    ACTIONS(960), 1,
      aux_sym__qid_token1,
    ACTIONS(962), 1,
      anon_sym_DOT,
    ACTIONS(968), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(970), 1,
      anon_sym_u2987,
    ACTIONS(976), 1,
      anon_sym_Set,
    ACTIONS(982), 1,
      anon_sym_BSLASH,
    ACTIONS(984), 1,
      anon_sym_u03bb,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(990), 1,
      anon_sym_tactic,
    ACTIONS(1158), 1,
      anon_sym_RPAREN,
    ACTIONS(1302), 1,
      anon_sym_let,
    STATE(3211), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4712), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8095), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(10477), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(974), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(4733), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4742), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9581), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(948), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [9313] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    ACTIONS(1354), 1,
      anon_sym_RBRACE_RBRACE,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(12563), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [9452] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1354), 1,
      anon_sym_RPAREN,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(12713), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [9591] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    ACTIONS(1300), 1,
      anon_sym_u2984,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(12481), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [9730] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1356), 1,
      anon_sym_RPAREN,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(11922), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [9869] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    ACTIONS(1356), 1,
      anon_sym_RBRACE_RBRACE,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(12087), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [10008] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    ACTIONS(1356), 1,
      anon_sym_u2984,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(12086), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [10147] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    ACTIONS(1358), 1,
      anon_sym_u2984,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(12414), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [10286] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1306), 1,
      anon_sym_RPAREN,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(12815), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [10425] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(940), 1,
      sym_id,
    ACTIONS(950), 1,
      anon_sym_record,
    ACTIONS(952), 1,
      anon_sym_LPAREN,
    ACTIONS(954), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(956), 1,
      anon_sym_u2983,
    ACTIONS(958), 1,
      anon_sym_LBRACE,
    ACTIONS(960), 1,
      aux_sym__qid_token1,
    ACTIONS(962), 1,
      anon_sym_DOT,
    ACTIONS(968), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(970), 1,
      anon_sym_u2987,
    ACTIONS(976), 1,
      anon_sym_Set,
    ACTIONS(982), 1,
      anon_sym_BSLASH,
    ACTIONS(984), 1,
      anon_sym_u03bb,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(990), 1,
      anon_sym_tactic,
    ACTIONS(1136), 1,
      anon_sym_RPAREN,
    ACTIONS(1302), 1,
      anon_sym_let,
    STATE(3211), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4712), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8095), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(10736), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(974), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(4733), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4742), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9581), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(948), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [10564] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    ACTIONS(1306), 1,
      anon_sym_RBRACE_RBRACE,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(12643), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [10703] = 37,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    ACTIONS(1360), 1,
      anon_sym_RBRACE,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(12084), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [10842] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1362), 1,
      anon_sym_RPAREN,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(10542), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [10981] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    ACTIONS(1346), 1,
      anon_sym_RBRACE_RBRACE,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(12503), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [11120] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1364), 1,
      anon_sym_RPAREN,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(12002), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [11259] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1346), 1,
      anon_sym_RPAREN,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(12432), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [11398] = 37,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    ACTIONS(1366), 1,
      anon_sym_RBRACE,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(12536), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [11537] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(940), 1,
      sym_id,
    ACTIONS(950), 1,
      anon_sym_record,
    ACTIONS(952), 1,
      anon_sym_LPAREN,
    ACTIONS(954), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(956), 1,
      anon_sym_u2983,
    ACTIONS(958), 1,
      anon_sym_LBRACE,
    ACTIONS(960), 1,
      aux_sym__qid_token1,
    ACTIONS(962), 1,
      anon_sym_DOT,
    ACTIONS(968), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(970), 1,
      anon_sym_u2987,
    ACTIONS(976), 1,
      anon_sym_Set,
    ACTIONS(978), 1,
      anon_sym_RPAREN,
    ACTIONS(982), 1,
      anon_sym_BSLASH,
    ACTIONS(984), 1,
      anon_sym_u03bb,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(990), 1,
      anon_sym_tactic,
    ACTIONS(1302), 1,
      anon_sym_let,
    STATE(3211), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4712), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8095), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(10270), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(974), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(4733), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4742), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9581), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(948), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [11676] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    ACTIONS(1368), 1,
      anon_sym_u2984,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(12537), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [11815] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    ACTIONS(1368), 1,
      anon_sym_RBRACE_RBRACE,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(12538), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [11954] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    ACTIONS(1364), 1,
      anon_sym_RBRACE_RBRACE,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(12052), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [12093] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1368), 1,
      anon_sym_RPAREN,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(12468), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [12232] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1370), 1,
      anon_sym_RPAREN,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(12659), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [12371] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1372), 1,
      anon_sym_RPAREN,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(10562), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [12510] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    ACTIONS(1372), 1,
      anon_sym_RBRACE_RBRACE,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(10426), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [12649] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    ACTIONS(1372), 1,
      anon_sym_u2984,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(10428), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [12788] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    ACTIONS(1364), 1,
      anon_sym_u2984,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(12051), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [12927] = 37,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    ACTIONS(1374), 1,
      anon_sym_RBRACE,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(10431), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [13066] = 37,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    ACTIONS(1376), 1,
      anon_sym_RBRACE,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(12036), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [13205] = 37,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    ACTIONS(1378), 1,
      anon_sym_RBRACE,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(12527), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [13344] = 37,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    ACTIONS(1380), 1,
      anon_sym_RBRACE,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(12479), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [13483] = 37,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    ACTIONS(1382), 1,
      anon_sym_RBRACE,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(12782), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [13622] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    ACTIONS(1384), 1,
      anon_sym_u2984,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(12526), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [13761] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    ACTIONS(1386), 1,
      anon_sym_RBRACE_RBRACE,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(10887), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [13900] = 37,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    ACTIONS(1388), 1,
      anon_sym_RBRACE,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(12645), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [14039] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    ACTIONS(1384), 1,
      anon_sym_RBRACE_RBRACE,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(12524), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [14178] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    ACTIONS(1370), 1,
      anon_sym_RBRACE_RBRACE,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(12730), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [14317] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    ACTIONS(1370), 1,
      anon_sym_u2984,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(12728), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [14456] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(940), 1,
      sym_id,
    ACTIONS(950), 1,
      anon_sym_record,
    ACTIONS(952), 1,
      anon_sym_LPAREN,
    ACTIONS(954), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(956), 1,
      anon_sym_u2983,
    ACTIONS(958), 1,
      anon_sym_LBRACE,
    ACTIONS(960), 1,
      aux_sym__qid_token1,
    ACTIONS(962), 1,
      anon_sym_DOT,
    ACTIONS(968), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(970), 1,
      anon_sym_u2987,
    ACTIONS(976), 1,
      anon_sym_Set,
    ACTIONS(982), 1,
      anon_sym_BSLASH,
    ACTIONS(984), 1,
      anon_sym_u03bb,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(990), 1,
      anon_sym_tactic,
    ACTIONS(1154), 1,
      anon_sym_RPAREN,
    ACTIONS(1302), 1,
      anon_sym_let,
    STATE(3211), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4712), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8095), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(11609), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(974), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(4733), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4742), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9581), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(948), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [14595] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1384), 1,
      anon_sym_RPAREN,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(12562), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [14734] = 37,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    ACTIONS(1390), 1,
      anon_sym_RBRACE,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(12251), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [14873] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1392), 1,
      anon_sym_RPAREN,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(11986), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [15012] = 37,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    ACTIONS(1394), 1,
      anon_sym_RBRACE,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(12727), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [15151] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(940), 1,
      sym_id,
    ACTIONS(950), 1,
      anon_sym_record,
    ACTIONS(952), 1,
      anon_sym_LPAREN,
    ACTIONS(954), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(956), 1,
      anon_sym_u2983,
    ACTIONS(958), 1,
      anon_sym_LBRACE,
    ACTIONS(960), 1,
      aux_sym__qid_token1,
    ACTIONS(962), 1,
      anon_sym_DOT,
    ACTIONS(968), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(970), 1,
      anon_sym_u2987,
    ACTIONS(976), 1,
      anon_sym_Set,
    ACTIONS(982), 1,
      anon_sym_BSLASH,
    ACTIONS(984), 1,
      anon_sym_u03bb,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(990), 1,
      anon_sym_tactic,
    ACTIONS(1140), 1,
      anon_sym_RPAREN,
    ACTIONS(1302), 1,
      anon_sym_let,
    STATE(3211), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4712), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8095), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(11911), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(974), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(4733), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4742), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9581), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(948), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [15290] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    ACTIONS(1392), 1,
      anon_sym_RBRACE_RBRACE,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(12035), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [15429] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    ACTIONS(1362), 1,
      anon_sym_RBRACE_RBRACE,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(10537), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [15568] = 37,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    ACTIONS(1396), 1,
      anon_sym_RBRACE,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(12575), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [15707] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    ACTIONS(1392), 1,
      anon_sym_u2984,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(12032), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [15846] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1398), 1,
      anon_sym_RPAREN,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(10656), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [15985] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(998), 1,
      anon_sym_RPAREN,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(11147), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [16124] = 37,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    ACTIONS(1400), 1,
      anon_sym_RBRACE,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(12031), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [16263] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(998), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(11181), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [16402] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(998), 1,
      anon_sym_u2984,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(11180), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [16541] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1020), 1,
      anon_sym_RPAREN,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(12711), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [16680] = 37,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(996), 1,
      anon_sym_RBRACE,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(11216), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [16819] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1020), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(12776), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [16958] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(940), 1,
      sym_id,
    ACTIONS(950), 1,
      anon_sym_record,
    ACTIONS(952), 1,
      anon_sym_LPAREN,
    ACTIONS(954), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(956), 1,
      anon_sym_u2983,
    ACTIONS(958), 1,
      anon_sym_LBRACE,
    ACTIONS(960), 1,
      aux_sym__qid_token1,
    ACTIONS(962), 1,
      anon_sym_DOT,
    ACTIONS(968), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(970), 1,
      anon_sym_u2987,
    ACTIONS(976), 1,
      anon_sym_Set,
    ACTIONS(982), 1,
      anon_sym_BSLASH,
    ACTIONS(984), 1,
      anon_sym_u03bb,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(990), 1,
      anon_sym_tactic,
    ACTIONS(1148), 1,
      anon_sym_RPAREN,
    ACTIONS(1302), 1,
      anon_sym_let,
    STATE(3211), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4712), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8095), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(11470), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(974), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(4733), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4742), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9581), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(948), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [17097] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    ACTIONS(1402), 1,
      anon_sym_u2984,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(12254), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [17236] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1020), 1,
      anon_sym_u2984,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(12775), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [17375] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    ACTIONS(1404), 1,
      anon_sym_u2984,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(12783), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [17514] = 37,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1018), 1,
      anon_sym_RBRACE,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(12774), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [17653] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1386), 1,
      anon_sym_RPAREN,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(10813), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [17792] = 37,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(934), 1,
      anon_sym_RBRACE,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(10382), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [17931] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(978), 1,
      anon_sym_u2984,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(10345), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [18070] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(978), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(10348), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [18209] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    ACTIONS(1402), 1,
      anon_sym_RBRACE_RBRACE,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(12255), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [18348] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(978), 1,
      anon_sym_RPAREN,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(10270), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [18487] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1406), 1,
      anon_sym_RPAREN,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(11954), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [18626] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    ACTIONS(1406), 1,
      anon_sym_RBRACE_RBRACE,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(12000), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [18765] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    ACTIONS(1362), 1,
      anon_sym_u2984,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(10618), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [18904] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    ACTIONS(1406), 1,
      anon_sym_u2984,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(11999), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [19043] = 37,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    ACTIONS(1408), 1,
      anon_sym_RBRACE,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(11998), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [19182] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1002), 1,
      anon_sym_RPAREN,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(12675), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [19321] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1002), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(12746), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [19460] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1002), 1,
      anon_sym_u2984,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(12745), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [19599] = 37,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1004), 1,
      anon_sym_RBRACE,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(12743), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [19738] = 37,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    ACTIONS(1410), 1,
      anon_sym_RBRACE,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(12490), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [19877] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    ACTIONS(1412), 1,
      anon_sym_u2984,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(12488), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [20016] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    ACTIONS(1414), 1,
      anon_sym_RBRACE_RBRACE,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(10925), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [20155] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    ACTIONS(1412), 1,
      anon_sym_RBRACE_RBRACE,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(12486), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [20294] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    ACTIONS(1314), 1,
      anon_sym_RBRACE_RBRACE,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(12578), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [20433] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1414), 1,
      anon_sym_RPAREN,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(10898), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [20572] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1412), 1,
      anon_sym_RPAREN,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(12641), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [20711] = 37,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1098), 1,
      anon_sym_RBRACE,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(12422), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [20850] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1402), 1,
      anon_sym_RPAREN,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(12190), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [20989] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1416), 1,
      anon_sym_RPAREN,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(11938), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [21128] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    ACTIONS(1386), 1,
      anon_sym_u2984,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(10886), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [21267] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    ACTIONS(1416), 1,
      anon_sym_RBRACE_RBRACE,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(11984), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [21406] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    ACTIONS(1416), 1,
      anon_sym_u2984,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(11983), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [21545] = 37,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    ACTIONS(1418), 1,
      anon_sym_RBRACE,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(11982), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [21684] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1420), 1,
      anon_sym_RPAREN,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(11923), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [21823] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    ACTIONS(1420), 1,
      anon_sym_RBRACE_RBRACE,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(11967), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [21962] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    ACTIONS(1420), 1,
      anon_sym_u2984,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(11966), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [22101] = 37,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    ACTIONS(1422), 1,
      anon_sym_RBRACE,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(11964), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [22240] = 37,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1094), 1,
      anon_sym_RBRACE,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(11467), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [22379] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(940), 1,
      sym_id,
    ACTIONS(950), 1,
      anon_sym_record,
    ACTIONS(952), 1,
      anon_sym_LPAREN,
    ACTIONS(954), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(956), 1,
      anon_sym_u2983,
    ACTIONS(958), 1,
      anon_sym_LBRACE,
    ACTIONS(960), 1,
      aux_sym__qid_token1,
    ACTIONS(962), 1,
      anon_sym_DOT,
    ACTIONS(968), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(970), 1,
      anon_sym_u2987,
    ACTIONS(976), 1,
      anon_sym_Set,
    ACTIONS(982), 1,
      anon_sym_BSLASH,
    ACTIONS(984), 1,
      anon_sym_u03bb,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(990), 1,
      anon_sym_tactic,
    ACTIONS(1144), 1,
      anon_sym_RPAREN,
    ACTIONS(1302), 1,
      anon_sym_let,
    STATE(3211), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4712), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8095), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(11595), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(974), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(4733), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4742), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9581), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(948), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [22518] = 37,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    ACTIONS(1424), 1,
      anon_sym_RBRACE,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(12455), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [22657] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    ACTIONS(1426), 1,
      anon_sym_u2984,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(12454), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [22796] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    ACTIONS(1426), 1,
      anon_sym_RBRACE_RBRACE,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(12452), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [22935] = 37,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    ACTIONS(1428), 1,
      anon_sym_RBRACE,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(12278), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [23074] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    ACTIONS(1430), 1,
      anon_sym_u2984,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(12279), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [23213] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1426), 1,
      anon_sym_RPAREN,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(12602), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [23352] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1036), 1,
      anon_sym_RPAREN,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(12601), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [23491] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    ACTIONS(1430), 1,
      anon_sym_RBRACE_RBRACE,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(12280), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [23630] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    ACTIONS(1398), 1,
      anon_sym_RBRACE_RBRACE,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(10735), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [23769] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    ACTIONS(1398), 1,
      anon_sym_u2984,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(10734), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [23908] = 37,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    ACTIONS(1432), 1,
      anon_sym_RBRACE,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(10733), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [24047] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1036), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(12674), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [24186] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1036), 1,
      anon_sym_u2984,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(12673), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [24325] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1314), 1,
      anon_sym_RPAREN,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(12504), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [24464] = 37,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1046), 1,
      anon_sym_RBRACE,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(12671), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [24603] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1430), 1,
      anon_sym_RPAREN,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(12211), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [24742] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1434), 1,
      anon_sym_RPAREN,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(11894), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [24881] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    ACTIONS(1434), 1,
      anon_sym_RBRACE_RBRACE,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(11936), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [25020] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    ACTIONS(1434), 1,
      anon_sym_u2984,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(11935), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [25159] = 37,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    ACTIONS(1436), 1,
      anon_sym_RBRACE,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(11934), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [25298] = 37,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    ACTIONS(1438), 1,
      anon_sym_RBRACE,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(12390), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [25437] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    ACTIONS(1440), 1,
      anon_sym_u2984,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(12388), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [25576] = 37,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    ACTIONS(1442), 1,
      anon_sym_RBRACE,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(10243), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [25715] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    ACTIONS(1440), 1,
      anon_sym_RBRACE_RBRACE,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(12387), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [25854] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1440), 1,
      anon_sym_RPAREN,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(12522), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [25993] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    ACTIONS(1414), 1,
      anon_sym_u2984,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(10994), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [26132] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1444), 1,
      anon_sym_RPAREN,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(10605), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [26271] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1076), 1,
      anon_sym_RPAREN,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(12560), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [26410] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1446), 1,
      anon_sym_RPAREN,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(12807), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [26549] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    ACTIONS(1444), 1,
      anon_sym_RBRACE_RBRACE,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(10525), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [26688] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    ACTIONS(1444), 1,
      anon_sym_u2984,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(10478), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [26827] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1076), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(12638), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [26966] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1076), 1,
      anon_sym_u2984,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(12637), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [27105] = 37,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1072), 1,
      anon_sym_RBRACE,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(12635), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [27244] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1448), 1,
      anon_sym_RPAREN,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(11867), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [27383] = 37,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    ACTIONS(1450), 1,
      anon_sym_RBRACE,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(10479), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [27522] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    ACTIONS(1448), 1,
      anon_sym_RBRACE_RBRACE,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(11902), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [27661] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    ACTIONS(1448), 1,
      anon_sym_u2984,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(11920), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [27800] = 37,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    ACTIONS(1452), 1,
      anon_sym_RBRACE,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(11919), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [27939] = 37,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    ACTIONS(1454), 1,
      anon_sym_RBRACE,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(12323), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [28078] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    ACTIONS(1456), 1,
      anon_sym_u2984,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(10244), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [28217] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    ACTIONS(1456), 1,
      anon_sym_RBRACE_RBRACE,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(10245), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [28356] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    ACTIONS(1458), 1,
      anon_sym_u2984,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(12322), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [28495] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    ACTIONS(1458), 1,
      anon_sym_RBRACE_RBRACE,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(12320), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [28634] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    ACTIONS(1446), 1,
      anon_sym_RBRACE_RBRACE,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(12679), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [28773] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1456), 1,
      anon_sym_RPAREN,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(10325), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [28912] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1458), 1,
      anon_sym_RPAREN,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(12450), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [29051] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    ACTIONS(1404), 1,
      anon_sym_RBRACE_RBRACE,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(12784), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [29190] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1460), 1,
      anon_sym_RPAREN,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(11847), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [29329] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    ACTIONS(1446), 1,
      anon_sym_u2984,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(12680), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [29468] = 37,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    ACTIONS(1462), 1,
      anon_sym_RBRACE,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(10577), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [29607] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    ACTIONS(1460), 1,
      anon_sym_RBRACE_RBRACE,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(11910), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [29746] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1404), 1,
      anon_sym_RPAREN,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(12731), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [29885] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(940), 1,
      sym_id,
    ACTIONS(950), 1,
      anon_sym_record,
    ACTIONS(952), 1,
      anon_sym_LPAREN,
    ACTIONS(954), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(956), 1,
      anon_sym_u2983,
    ACTIONS(958), 1,
      anon_sym_LBRACE,
    ACTIONS(960), 1,
      aux_sym__qid_token1,
    ACTIONS(962), 1,
      anon_sym_DOT,
    ACTIONS(968), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(970), 1,
      anon_sym_u2987,
    ACTIONS(976), 1,
      anon_sym_Set,
    ACTIONS(982), 1,
      anon_sym_BSLASH,
    ACTIONS(984), 1,
      anon_sym_u03bb,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(990), 1,
      anon_sym_tactic,
    ACTIONS(1134), 1,
      anon_sym_RPAREN,
    ACTIONS(1302), 1,
      anon_sym_let,
    STATE(3211), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4712), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8095), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(11559), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(974), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(4733), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4742), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9581), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(948), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [30024] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    ACTIONS(1460), 1,
      anon_sym_u2984,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(11908), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [30163] = 37,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    ACTIONS(1464), 1,
      anon_sym_RBRACE,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(11907), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [30302] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1030), 1,
      anon_sym_RPAREN,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(12540), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [30441] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1030), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(12619), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [30580] = 37,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    ACTIONS(1466), 1,
      anon_sym_RBRACE,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(11030), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [30719] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1030), 1,
      anon_sym_u2984,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(12617), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [30858] = 37,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    ACTIONS(1468), 1,
      anon_sym_RBRACE,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(12681), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [30997] = 37,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(938), 1,
      anon_sym_RBRACE,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(12615), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [31136] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(940), 1,
      sym_id,
    ACTIONS(950), 1,
      anon_sym_record,
    ACTIONS(952), 1,
      anon_sym_LPAREN,
    ACTIONS(954), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(956), 1,
      anon_sym_u2983,
    ACTIONS(958), 1,
      anon_sym_LBRACE,
    ACTIONS(960), 1,
      aux_sym__qid_token1,
    ACTIONS(962), 1,
      anon_sym_DOT,
    ACTIONS(968), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(970), 1,
      anon_sym_u2987,
    ACTIONS(976), 1,
      anon_sym_Set,
    ACTIONS(982), 1,
      anon_sym_BSLASH,
    ACTIONS(984), 1,
      anon_sym_u03bb,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(990), 1,
      anon_sym_tactic,
    ACTIONS(1132), 1,
      anon_sym_RPAREN,
    ACTIONS(1302), 1,
      anon_sym_let,
    STATE(3211), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4712), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8095), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(11786), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(974), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(4733), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4742), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9581), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(948), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [31275] = 37,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    ACTIONS(1470), 1,
      anon_sym_RBRACE,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(12295), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [31414] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    ACTIONS(1472), 1,
      anon_sym_u2984,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(12296), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [31553] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1474), 1,
      anon_sym_RPAREN,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(11834), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [31692] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    ACTIONS(1476), 1,
      anon_sym_u2984,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(11031), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [31831] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    ACTIONS(1474), 1,
      anon_sym_RBRACE_RBRACE,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(11892), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [31970] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1478), 1,
      anon_sym_RPAREN,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(12581), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [32109] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    ACTIONS(1474), 1,
      anon_sym_u2984,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(11891), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [32248] = 37,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    ACTIONS(1480), 1,
      anon_sym_RBRACE,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(11888), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [32387] = 37,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    ACTIONS(1482), 1,
      anon_sym_RBRACE,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(10992), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [32526] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1484), 1,
      anon_sym_RPAREN,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(11820), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [32665] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    ACTIONS(1484), 1,
      anon_sym_RBRACE_RBRACE,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(11866), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [32804] = 39,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    ACTIONS(1488), 1,
      anon_sym_RBRACE_RBRACE,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(5426), 1,
      sym__ELLIPSIS,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(11723), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1486), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 6,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(1174), 7,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [32947] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    ACTIONS(1484), 1,
      anon_sym_u2984,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(11864), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [33086] = 39,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    ACTIONS(1488), 1,
      anon_sym_u2984,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5428), 1,
      sym__ELLIPSIS,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(11724), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1490), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 6,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(1252), 7,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [33229] = 37,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    ACTIONS(1492), 1,
      anon_sym_RBRACE,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(11862), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [33368] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    ACTIONS(1478), 1,
      anon_sym_RBRACE_RBRACE,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(12657), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [33507] = 37,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    ACTIONS(1494), 1,
      anon_sym_RBRACE,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(12344), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [33646] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(940), 1,
      sym_id,
    ACTIONS(950), 1,
      anon_sym_record,
    ACTIONS(952), 1,
      anon_sym_LPAREN,
    ACTIONS(954), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(956), 1,
      anon_sym_u2983,
    ACTIONS(958), 1,
      anon_sym_LBRACE,
    ACTIONS(960), 1,
      aux_sym__qid_token1,
    ACTIONS(962), 1,
      anon_sym_DOT,
    ACTIONS(968), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(970), 1,
      anon_sym_u2987,
    ACTIONS(976), 1,
      anon_sym_Set,
    ACTIONS(982), 1,
      anon_sym_BSLASH,
    ACTIONS(984), 1,
      anon_sym_u03bb,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(990), 1,
      anon_sym_tactic,
    ACTIONS(1118), 1,
      anon_sym_RPAREN,
    ACTIONS(1302), 1,
      anon_sym_let,
    STATE(3211), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4712), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8095), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(12512), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(974), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(4733), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4742), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9581), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(948), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [33785] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1496), 1,
      anon_sym_RPAREN,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(12403), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [33924] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    ACTIONS(1498), 1,
      anon_sym_u2984,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(12287), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [34063] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    ACTIONS(1476), 1,
      anon_sym_RBRACE_RBRACE,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(11032), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [34202] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    ACTIONS(1498), 1,
      anon_sym_RBRACE_RBRACE,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(12286), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [34341] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1498), 1,
      anon_sym_RPAREN,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(12419), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [34480] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1476), 1,
      anon_sym_RPAREN,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(10958), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [34619] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    ACTIONS(1478), 1,
      anon_sym_u2984,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(12656), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [34758] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1500), 1,
      anon_sym_RPAREN,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(10714), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [34897] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(868), 1,
      anon_sym_RPAREN,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(12484), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [35036] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    ACTIONS(1500), 1,
      anon_sym_RBRACE_RBRACE,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(10520), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [35175] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(868), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(12558), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [35314] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    ACTIONS(1500), 1,
      anon_sym_u2984,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(10522), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [35453] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(868), 1,
      anon_sym_u2984,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(12557), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [35592] = 37,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1000), 1,
      anon_sym_RBRACE,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(12556), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [35731] = 37,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    ACTIONS(1502), 1,
      anon_sym_RBRACE,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(10596), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [35870] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1026), 1,
      anon_sym_RPAREN,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(12449), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [36009] = 37,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    ACTIONS(1504), 1,
      anon_sym_RBRACE,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(12655), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [36148] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1026), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(12519), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [36287] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1026), 1,
      anon_sym_u2984,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(12518), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [36426] = 37,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1028), 1,
      anon_sym_RBRACE,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(12517), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [36565] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1506), 1,
      anon_sym_RPAREN,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(11808), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [36704] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    ACTIONS(1472), 1,
      anon_sym_RBRACE_RBRACE,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(12298), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [36843] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1472), 1,
      anon_sym_RPAREN,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(12227), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [36982] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    ACTIONS(1506), 1,
      anon_sym_RBRACE_RBRACE,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(11846), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [37121] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    ACTIONS(1506), 1,
      anon_sym_u2984,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(11844), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [37260] = 37,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    ACTIONS(1508), 1,
      anon_sym_RBRACE,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(11843), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [37399] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(940), 1,
      sym_id,
    ACTIONS(950), 1,
      anon_sym_record,
    ACTIONS(952), 1,
      anon_sym_LPAREN,
    ACTIONS(954), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(956), 1,
      anon_sym_u2983,
    ACTIONS(958), 1,
      anon_sym_LBRACE,
    ACTIONS(960), 1,
      aux_sym__qid_token1,
    ACTIONS(962), 1,
      anon_sym_DOT,
    ACTIONS(968), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(970), 1,
      anon_sym_u2987,
    ACTIONS(976), 1,
      anon_sym_Set,
    ACTIONS(982), 1,
      anon_sym_BSLASH,
    ACTIONS(984), 1,
      anon_sym_u03bb,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(990), 1,
      anon_sym_tactic,
    ACTIONS(1122), 1,
      anon_sym_RPAREN,
    ACTIONS(1302), 1,
      anon_sym_let,
    STATE(3211), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4712), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8095), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(11968), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(974), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(4733), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4742), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9581), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(948), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [37538] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1010), 1,
      anon_sym_u2984,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(12360), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [37677] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1510), 1,
      anon_sym_RPAREN,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(11767), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [37816] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(940), 1,
      sym_id,
    ACTIONS(950), 1,
      anon_sym_record,
    ACTIONS(952), 1,
      anon_sym_LPAREN,
    ACTIONS(954), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(956), 1,
      anon_sym_u2983,
    ACTIONS(958), 1,
      anon_sym_LBRACE,
    ACTIONS(960), 1,
      aux_sym__qid_token1,
    ACTIONS(962), 1,
      anon_sym_DOT,
    ACTIONS(968), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(970), 1,
      anon_sym_u2987,
    ACTIONS(976), 1,
      anon_sym_Set,
    ACTIONS(982), 1,
      anon_sym_BSLASH,
    ACTIONS(984), 1,
      anon_sym_u03bb,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(990), 1,
      anon_sym_tactic,
    ACTIONS(1124), 1,
      anon_sym_RPAREN,
    ACTIONS(1302), 1,
      anon_sym_let,
    STATE(3211), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4712), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8095), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(11516), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(974), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(4733), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4742), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9581), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(948), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [37955] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    ACTIONS(1510), 1,
      anon_sym_RBRACE_RBRACE,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(11832), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [38094] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    ACTIONS(1496), 1,
      anon_sym_RBRACE_RBRACE,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(12466), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [38233] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1118), 1,
      anon_sym_u2984,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(12421), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [38372] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1118), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(12420), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [38511] = 37,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    ACTIONS(1512), 1,
      anon_sym_RBRACE,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(10267), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [38650] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    ACTIONS(1510), 1,
      anon_sym_u2984,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(11831), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [38789] = 37,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    ACTIONS(1514), 1,
      anon_sym_RBRACE,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(11830), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [38928] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1118), 1,
      anon_sym_RPAREN,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(12512), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [39067] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1516), 1,
      anon_sym_RPAREN,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(12639), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [39206] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1518), 1,
      anon_sym_RPAREN,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(11361), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [39345] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    ACTIONS(1518), 1,
      anon_sym_RBRACE_RBRACE,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(11397), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [39484] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    ACTIONS(1518), 1,
      anon_sym_u2984,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(11396), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [39623] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1520), 1,
      anon_sym_RPAREN,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(11782), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [39762] = 37,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    ACTIONS(1522), 1,
      anon_sym_RBRACE,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(11324), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [39901] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    ACTIONS(1524), 1,
      anon_sym_u2984,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(10268), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [40040] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    ACTIONS(1524), 1,
      anon_sym_RBRACE_RBRACE,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(10269), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [40179] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    ACTIONS(1520), 1,
      anon_sym_RBRACE_RBRACE,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(11819), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [40318] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    ACTIONS(1520), 1,
      anon_sym_u2984,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(11818), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [40457] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    ACTIONS(1496), 1,
      anon_sym_u2984,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(12465), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [40596] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1158), 1,
      anon_sym_RPAREN,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(10477), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [40735] = 37,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    ACTIONS(1526), 1,
      anon_sym_RBRACE,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(11817), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [40874] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1528), 1,
      anon_sym_RPAREN,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(11768), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [41013] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    ACTIONS(1516), 1,
      anon_sym_RBRACE_RBRACE,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(12710), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [41152] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1524), 1,
      anon_sym_RPAREN,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(10276), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [41291] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1096), 1,
      anon_sym_RPAREN,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(11435), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [41430] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    ACTIONS(1528), 1,
      anon_sym_RBRACE_RBRACE,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(11807), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [41569] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1044), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(11971), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [41708] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1096), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(11434), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [41847] = 37,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    ACTIONS(1530), 1,
      anon_sym_RBRACE,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(12236), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [41986] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1158), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(10327), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [42125] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1096), 1,
      anon_sym_u2984,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(11433), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [42264] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(940), 1,
      sym_id,
    ACTIONS(950), 1,
      anon_sym_record,
    ACTIONS(952), 1,
      anon_sym_LPAREN,
    ACTIONS(954), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(956), 1,
      anon_sym_u2983,
    ACTIONS(958), 1,
      anon_sym_LBRACE,
    ACTIONS(960), 1,
      aux_sym__qid_token1,
    ACTIONS(962), 1,
      anon_sym_DOT,
    ACTIONS(968), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(970), 1,
      anon_sym_u2987,
    ACTIONS(976), 1,
      anon_sym_Set,
    ACTIONS(982), 1,
      anon_sym_BSLASH,
    ACTIONS(984), 1,
      anon_sym_u03bb,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(990), 1,
      anon_sym_tactic,
    ACTIONS(1096), 1,
      anon_sym_RPAREN,
    ACTIONS(1302), 1,
      anon_sym_let,
    STATE(3211), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4712), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8095), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(11435), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(974), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(4733), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4742), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9581), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(948), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [42403] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    ACTIONS(1532), 1,
      anon_sym_u2984,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(12231), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [42542] = 37,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    ACTIONS(1534), 1,
      anon_sym_RBRACE,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(10885), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [42681] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(936), 1,
      anon_sym_RPAREN,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(11109), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [42820] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    ACTIONS(1532), 1,
      anon_sym_RBRACE_RBRACE,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(12230), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [42959] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1158), 1,
      anon_sym_u2984,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(10330), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [43098] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1532), 1,
      anon_sym_RPAREN,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(12385), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [43237] = 37,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1156), 1,
      anon_sym_RBRACE,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(10288), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [43376] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    ACTIONS(1516), 1,
      anon_sym_u2984,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(12709), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [43515] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    ACTIONS(1528), 1,
      anon_sym_u2984,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(11806), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [43654] = 37,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    ACTIONS(1536), 1,
      anon_sym_RBRACE,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(11805), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [43793] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(936), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(11146), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [43932] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1538), 1,
      anon_sym_RPAREN,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(11757), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [44071] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    ACTIONS(1538), 1,
      anon_sym_RBRACE_RBRACE,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(11793), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [44210] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(936), 1,
      anon_sym_u2984,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(11145), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [44349] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    ACTIONS(1538), 1,
      anon_sym_u2984,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(11792), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [44488] = 37,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(994), 1,
      anon_sym_RBRACE,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(11179), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [44627] = 37,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    ACTIONS(1540), 1,
      anon_sym_RBRACE,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(12312), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [44766] = 37,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    ACTIONS(1542), 1,
      anon_sym_RBRACE,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(11791), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [44905] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    ACTIONS(1544), 1,
      anon_sym_u2984,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(12314), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [45044] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    ACTIONS(1544), 1,
      anon_sym_RBRACE_RBRACE,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(12315), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [45183] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1546), 1,
      anon_sym_RPAREN,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(10621), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [45322] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1016), 1,
      anon_sym_RPAREN,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(12191), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [45461] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1548), 1,
      anon_sym_RPAREN,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(11734), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [45600] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    ACTIONS(1548), 1,
      anon_sym_RBRACE_RBRACE,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(11666), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [45739] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1544), 1,
      anon_sym_RPAREN,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(12256), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [45878] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1016), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(12039), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [46017] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    ACTIONS(1548), 1,
      anon_sym_u2984,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(11766), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [46156] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(940), 1,
      sym_id,
    ACTIONS(950), 1,
      anon_sym_record,
    ACTIONS(952), 1,
      anon_sym_LPAREN,
    ACTIONS(954), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(956), 1,
      anon_sym_u2983,
    ACTIONS(958), 1,
      anon_sym_LBRACE,
    ACTIONS(960), 1,
      aux_sym__qid_token1,
    ACTIONS(962), 1,
      anon_sym_DOT,
    ACTIONS(968), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(970), 1,
      anon_sym_u2987,
    ACTIONS(976), 1,
      anon_sym_Set,
    ACTIONS(982), 1,
      anon_sym_BSLASH,
    ACTIONS(984), 1,
      anon_sym_u03bb,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(990), 1,
      anon_sym_tactic,
    ACTIONS(1074), 1,
      anon_sym_RPAREN,
    ACTIONS(1302), 1,
      anon_sym_let,
    STATE(3211), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4712), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8095), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(11513), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(974), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(4733), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4742), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9581), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(948), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [46295] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(940), 1,
      sym_id,
    ACTIONS(950), 1,
      anon_sym_record,
    ACTIONS(952), 1,
      anon_sym_LPAREN,
    ACTIONS(954), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(956), 1,
      anon_sym_u2983,
    ACTIONS(958), 1,
      anon_sym_LBRACE,
    ACTIONS(960), 1,
      aux_sym__qid_token1,
    ACTIONS(962), 1,
      anon_sym_DOT,
    ACTIONS(968), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(970), 1,
      anon_sym_u2987,
    ACTIONS(976), 1,
      anon_sym_Set,
    ACTIONS(982), 1,
      anon_sym_BSLASH,
    ACTIONS(984), 1,
      anon_sym_u03bb,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(990), 1,
      anon_sym_tactic,
    ACTIONS(1090), 1,
      anon_sym_RPAREN,
    ACTIONS(1302), 1,
      anon_sym_let,
    STATE(3211), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4712), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8095), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(11306), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(974), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(4733), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4742), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9581), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(948), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [46434] = 37,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    ACTIONS(1550), 1,
      anon_sym_RBRACE,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(11765), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [46573] = 37,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    ACTIONS(1552), 1,
      anon_sym_RBRACE,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(12331), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [46712] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(940), 1,
      sym_id,
    ACTIONS(950), 1,
      anon_sym_record,
    ACTIONS(952), 1,
      anon_sym_LPAREN,
    ACTIONS(954), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(956), 1,
      anon_sym_u2983,
    ACTIONS(958), 1,
      anon_sym_LBRACE,
    ACTIONS(960), 1,
      aux_sym__qid_token1,
    ACTIONS(962), 1,
      anon_sym_DOT,
    ACTIONS(968), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(970), 1,
      anon_sym_u2987,
    ACTIONS(976), 1,
      anon_sym_Set,
    ACTIONS(982), 1,
      anon_sym_BSLASH,
    ACTIONS(984), 1,
      anon_sym_u03bb,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(990), 1,
      anon_sym_tactic,
    ACTIONS(1076), 1,
      anon_sym_RPAREN,
    ACTIONS(1302), 1,
      anon_sym_let,
    STATE(3211), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4712), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8095), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(12560), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(974), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(4733), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4742), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9581), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(948), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [46851] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1554), 1,
      anon_sym_RPAREN,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(11720), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [46990] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    ACTIONS(1556), 1,
      anon_sym_u2984,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(12333), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [47129] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    ACTIONS(1554), 1,
      anon_sym_RBRACE_RBRACE,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(11756), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [47268] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(940), 1,
      sym_id,
    ACTIONS(950), 1,
      anon_sym_record,
    ACTIONS(952), 1,
      anon_sym_LPAREN,
    ACTIONS(954), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(956), 1,
      anon_sym_u2983,
    ACTIONS(958), 1,
      anon_sym_LBRACE,
    ACTIONS(960), 1,
      aux_sym__qid_token1,
    ACTIONS(962), 1,
      anon_sym_DOT,
    ACTIONS(968), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(970), 1,
      anon_sym_u2987,
    ACTIONS(976), 1,
      anon_sym_Set,
    ACTIONS(982), 1,
      anon_sym_BSLASH,
    ACTIONS(984), 1,
      anon_sym_u03bb,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(990), 1,
      anon_sym_tactic,
    ACTIONS(1086), 1,
      anon_sym_RPAREN,
    ACTIONS(1302), 1,
      anon_sym_let,
    STATE(3211), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4712), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8095), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(12071), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(974), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(4733), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4742), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9581), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(948), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [47407] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    ACTIONS(1554), 1,
      anon_sym_u2984,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(11755), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [47546] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    ACTIONS(1546), 1,
      anon_sym_RBRACE_RBRACE,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(10696), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [47685] = 37,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    ACTIONS(1558), 1,
      anon_sym_RBRACE,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(11754), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [47824] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1560), 1,
      anon_sym_RPAREN,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(11707), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [47963] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    ACTIONS(1546), 1,
      anon_sym_u2984,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(10695), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [48102] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    ACTIONS(1560), 1,
      anon_sym_RBRACE_RBRACE,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(11747), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [48241] = 37,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    ACTIONS(1562), 1,
      anon_sym_RBRACE,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(12707), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [48380] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    ACTIONS(1560), 1,
      anon_sym_u2984,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(11746), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [48519] = 37,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1006), 1,
      anon_sym_RBRACE,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(11358), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [48658] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1564), 1,
      anon_sym_RPAREN,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(12620), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [48797] = 37,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    ACTIONS(1566), 1,
      anon_sym_RBRACE,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(11745), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [48936] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    ACTIONS(1556), 1,
      anon_sym_RBRACE_RBRACE,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(12337), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [49075] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1556), 1,
      anon_sym_RPAREN,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(12282), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [49214] = 37,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    ACTIONS(1568), 1,
      anon_sym_RBRACE,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(10955), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [49353] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1570), 1,
      anon_sym_RPAREN,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(11694), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [49492] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    ACTIONS(1570), 1,
      anon_sym_RBRACE_RBRACE,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(11733), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [49631] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    ACTIONS(1570), 1,
      anon_sym_u2984,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(11732), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [49770] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1148), 1,
      anon_sym_u2984,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(11468), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [49909] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1148), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(11469), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [50048] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1572), 1,
      anon_sym_RPAREN,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(11255), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [50187] = 37,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    ACTIONS(1574), 1,
      anon_sym_RBRACE,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(11731), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [50326] = 37,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    ACTIONS(1576), 1,
      anon_sym_RBRACE,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(12195), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [50465] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    ACTIONS(1578), 1,
      anon_sym_u2984,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(12194), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [50604] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1580), 1,
      anon_sym_RPAREN,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(10874), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [50743] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    ACTIONS(1578), 1,
      anon_sym_RBRACE_RBRACE,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(12192), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [50882] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    ACTIONS(1580), 1,
      anon_sym_RBRACE_RBRACE,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(10566), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [51021] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1578), 1,
      anon_sym_RPAREN,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(12355), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [51160] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    ACTIONS(1580), 1,
      anon_sym_u2984,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(10567), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [51299] = 37,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    ACTIONS(1582), 1,
      anon_sym_RBRACE,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(10568), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [51438] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1584), 1,
      anon_sym_RPAREN,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(12793), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [51577] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(940), 1,
      sym_id,
    ACTIONS(950), 1,
      anon_sym_record,
    ACTIONS(952), 1,
      anon_sym_LPAREN,
    ACTIONS(954), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(956), 1,
      anon_sym_u2983,
    ACTIONS(958), 1,
      anon_sym_LBRACE,
    ACTIONS(960), 1,
      aux_sym__qid_token1,
    ACTIONS(962), 1,
      anon_sym_DOT,
    ACTIONS(968), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(970), 1,
      anon_sym_u2987,
    ACTIONS(976), 1,
      anon_sym_Set,
    ACTIONS(982), 1,
      anon_sym_BSLASH,
    ACTIONS(984), 1,
      anon_sym_u03bb,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(990), 1,
      anon_sym_tactic,
    ACTIONS(1078), 1,
      anon_sym_RPAREN,
    ACTIONS(1302), 1,
      anon_sym_let,
    STATE(3211), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4712), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8095), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(12019), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(974), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(4733), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4742), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9581), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(948), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [51716] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1586), 1,
      anon_sym_RPAREN,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(11681), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [51855] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    ACTIONS(1586), 1,
      anon_sym_RBRACE_RBRACE,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(11719), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [51994] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    ACTIONS(1584), 1,
      anon_sym_RBRACE_RBRACE,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(12715), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [52133] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    ACTIONS(1586), 1,
      anon_sym_u2984,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(11718), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [52272] = 37,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    ACTIONS(1588), 1,
      anon_sym_RBRACE,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(10305), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [52411] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    ACTIONS(1572), 1,
      anon_sym_RBRACE_RBRACE,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(11289), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [52550] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    ACTIONS(1572), 1,
      anon_sym_u2984,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(11288), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [52689] = 37,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    ACTIONS(1590), 1,
      anon_sym_RBRACE,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(11717), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [52828] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    ACTIONS(1584), 1,
      anon_sym_u2984,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(12716), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [52967] = 37,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    ACTIONS(1592), 1,
      anon_sym_RBRACE,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(11287), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [53106] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1594), 1,
      anon_sym_RPAREN,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(11670), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [53245] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    ACTIONS(1594), 1,
      anon_sym_RBRACE_RBRACE,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(11706), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [53384] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(940), 1,
      sym_id,
    ACTIONS(950), 1,
      anon_sym_record,
    ACTIONS(952), 1,
      anon_sym_LPAREN,
    ACTIONS(954), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(956), 1,
      anon_sym_u2983,
    ACTIONS(958), 1,
      anon_sym_LBRACE,
    ACTIONS(960), 1,
      aux_sym__qid_token1,
    ACTIONS(962), 1,
      anon_sym_DOT,
    ACTIONS(968), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(970), 1,
      anon_sym_u2987,
    ACTIONS(976), 1,
      anon_sym_Set,
    ACTIONS(982), 1,
      anon_sym_BSLASH,
    ACTIONS(984), 1,
      anon_sym_u03bb,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(990), 1,
      anon_sym_tactic,
    ACTIONS(1070), 1,
      anon_sym_RPAREN,
    ACTIONS(1302), 1,
      anon_sym_let,
    STATE(3211), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4712), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8095), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(11237), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(974), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(4733), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4742), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9581), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(948), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [53523] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    ACTIONS(1596), 1,
      anon_sym_u2984,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(10383), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [53662] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    ACTIONS(1596), 1,
      anon_sym_RBRACE_RBRACE,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(10384), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [53801] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    ACTIONS(1594), 1,
      anon_sym_u2984,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(11705), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [53940] = 37,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    ACTIONS(1598), 1,
      anon_sym_RBRACE,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(12718), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [54079] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1596), 1,
      anon_sym_RPAREN,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(10311), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [54218] = 37,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    ACTIONS(1600), 1,
      anon_sym_RBRACE,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(11703), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [54357] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    ACTIONS(1296), 1,
      anon_sym_RBRACE_RBRACE,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(12603), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [54496] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(940), 1,
      sym_id,
    ACTIONS(950), 1,
      anon_sym_record,
    ACTIONS(952), 1,
      anon_sym_LPAREN,
    ACTIONS(954), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(956), 1,
      anon_sym_u2983,
    ACTIONS(958), 1,
      anon_sym_LBRACE,
    ACTIONS(960), 1,
      aux_sym__qid_token1,
    ACTIONS(962), 1,
      anon_sym_DOT,
    ACTIONS(968), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(970), 1,
      anon_sym_u2987,
    ACTIONS(976), 1,
      anon_sym_Set,
    ACTIONS(982), 1,
      anon_sym_BSLASH,
    ACTIONS(984), 1,
      anon_sym_u03bb,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(990), 1,
      anon_sym_tactic,
    ACTIONS(1064), 1,
      anon_sym_RPAREN,
    ACTIONS(1302), 1,
      anon_sym_let,
    STATE(3211), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4712), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8095), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(11071), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(974), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(4733), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4742), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9581), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(948), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [54635] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1602), 1,
      anon_sym_RPAREN,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(10770), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [54774] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1604), 1,
      anon_sym_RPAREN,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(11657), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [54913] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    ACTIONS(1604), 1,
      anon_sym_RBRACE_RBRACE,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(11692), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [55052] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    ACTIONS(1602), 1,
      anon_sym_RBRACE_RBRACE,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(10850), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [55191] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1148), 1,
      anon_sym_RPAREN,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(11470), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [55330] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    ACTIONS(1604), 1,
      anon_sym_u2984,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(11691), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [55469] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1606), 1,
      anon_sym_RPAREN,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(12521), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [55608] = 37,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    ACTIONS(1608), 1,
      anon_sym_RBRACE,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(11690), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [55747] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1610), 1,
      anon_sym_RPAREN,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(10465), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [55886] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    ACTIONS(1602), 1,
      anon_sym_u2984,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(10848), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [56025] = 37,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    ACTIONS(1612), 1,
      anon_sym_RBRACE,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(10810), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [56164] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1010), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(12356), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [56303] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1614), 1,
      anon_sym_RPAREN,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(12748), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [56442] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1064), 1,
      anon_sym_RPAREN,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(11071), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [56581] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1616), 1,
      anon_sym_RPAREN,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(11645), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [56720] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    ACTIONS(1564), 1,
      anon_sym_RBRACE_RBRACE,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(12693), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [56859] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    ACTIONS(1616), 1,
      anon_sym_RBRACE_RBRACE,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(11680), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [56998] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    ACTIONS(1616), 1,
      anon_sym_u2984,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(11679), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [57137] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1064), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(11108), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [57276] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1064), 1,
      anon_sym_u2984,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(11107), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [57415] = 37,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    ACTIONS(1618), 1,
      anon_sym_RBRACE,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(11678), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [57554] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1620), 1,
      anon_sym_RPAREN,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(11620), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [57693] = 37,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1066), 1,
      anon_sym_RBRACE,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(11144), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [57832] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1016), 1,
      anon_sym_u2984,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(12040), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [57971] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1010), 1,
      anon_sym_RPAREN,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(12485), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [58110] = 37,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    ACTIONS(1622), 1,
      anon_sym_RBRACE,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(12350), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [58249] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    ACTIONS(1624), 1,
      anon_sym_u2984,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(12352), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [58388] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(940), 1,
      sym_id,
    ACTIONS(950), 1,
      anon_sym_record,
    ACTIONS(952), 1,
      anon_sym_LPAREN,
    ACTIONS(954), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(956), 1,
      anon_sym_u2983,
    ACTIONS(958), 1,
      anon_sym_LBRACE,
    ACTIONS(960), 1,
      aux_sym__qid_token1,
    ACTIONS(962), 1,
      anon_sym_DOT,
    ACTIONS(968), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(970), 1,
      anon_sym_u2987,
    ACTIONS(976), 1,
      anon_sym_Set,
    ACTIONS(982), 1,
      anon_sym_BSLASH,
    ACTIONS(984), 1,
      anon_sym_u03bb,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(990), 1,
      anon_sym_tactic,
    ACTIONS(1052), 1,
      anon_sym_RPAREN,
    ACTIONS(1302), 1,
      anon_sym_let,
    STATE(3211), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4712), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8095), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(12070), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(974), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(4733), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4742), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9581), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(948), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [58527] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    ACTIONS(1620), 1,
      anon_sym_RBRACE_RBRACE,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(11656), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [58666] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    ACTIONS(1624), 1,
      anon_sym_RBRACE_RBRACE,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(12353), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [58805] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1624), 1,
      anon_sym_RPAREN,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(12299), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [58944] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(940), 1,
      sym_id,
    ACTIONS(950), 1,
      anon_sym_record,
    ACTIONS(952), 1,
      anon_sym_LPAREN,
    ACTIONS(954), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(956), 1,
      anon_sym_u2983,
    ACTIONS(958), 1,
      anon_sym_LBRACE,
    ACTIONS(960), 1,
      aux_sym__qid_token1,
    ACTIONS(962), 1,
      anon_sym_DOT,
    ACTIONS(968), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(970), 1,
      anon_sym_u2987,
    ACTIONS(976), 1,
      anon_sym_Set,
    ACTIONS(982), 1,
      anon_sym_BSLASH,
    ACTIONS(984), 1,
      anon_sym_u03bb,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(990), 1,
      anon_sym_tactic,
    ACTIONS(1062), 1,
      anon_sym_RPAREN,
    ACTIONS(1302), 1,
      anon_sym_let,
    STATE(3211), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4712), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8095), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(11327), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(974), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(4733), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4742), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9581), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(948), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [59083] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    ACTIONS(1620), 1,
      anon_sym_u2984,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(11655), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [59222] = 37,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    ACTIONS(1626), 1,
      anon_sym_RBRACE,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(11654), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [59361] = 37,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1012), 1,
      anon_sym_RBRACE,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(12042), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [59500] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1628), 1,
      anon_sym_RPAREN,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(11581), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [59639] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    ACTIONS(1628), 1,
      anon_sym_RBRACE_RBRACE,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(11619), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [59778] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    ACTIONS(1628), 1,
      anon_sym_u2984,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(11618), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [59917] = 37,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    ACTIONS(1630), 1,
      anon_sym_RBRACE,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(12144), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [60056] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    ACTIONS(1632), 1,
      anon_sym_u2984,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(12143), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [60195] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    ACTIONS(1632), 1,
      anon_sym_RBRACE_RBRACE,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(12142), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [60334] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1632), 1,
      anon_sym_RPAREN,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(12319), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [60473] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(940), 1,
      sym_id,
    ACTIONS(950), 1,
      anon_sym_record,
    ACTIONS(952), 1,
      anon_sym_LPAREN,
    ACTIONS(954), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(956), 1,
      anon_sym_u2983,
    ACTIONS(958), 1,
      anon_sym_LBRACE,
    ACTIONS(960), 1,
      aux_sym__qid_token1,
    ACTIONS(962), 1,
      anon_sym_DOT,
    ACTIONS(968), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(970), 1,
      anon_sym_u2987,
    ACTIONS(976), 1,
      anon_sym_Set,
    ACTIONS(982), 1,
      anon_sym_BSLASH,
    ACTIONS(984), 1,
      anon_sym_u03bb,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(990), 1,
      anon_sym_tactic,
    ACTIONS(1010), 1,
      anon_sym_RPAREN,
    ACTIONS(1302), 1,
      anon_sym_let,
    STATE(3211), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4712), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8095), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(12485), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(974), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(4733), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4742), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9581), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(948), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [60612] = 37,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    ACTIONS(1634), 1,
      anon_sym_RBRACE,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(11068), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [60751] = 37,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    ACTIONS(1636), 1,
      anon_sym_RBRACE,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(11617), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [60890] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1638), 1,
      anon_sym_RPAREN,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(11539), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [61029] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    ACTIONS(1638), 1,
      anon_sym_RBRACE_RBRACE,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(11594), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [61168] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    ACTIONS(1638), 1,
      anon_sym_u2984,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(11593), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [61307] = 37,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    ACTIONS(1640), 1,
      anon_sym_RBRACE,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(11592), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [61446] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1074), 1,
      anon_sym_u2984,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(11511), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [61585] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1052), 1,
      anon_sym_RPAREN,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(12070), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [61724] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    ACTIONS(1610), 1,
      anon_sym_RBRACE_RBRACE,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(10541), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [61863] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(940), 1,
      sym_id,
    ACTIONS(950), 1,
      anon_sym_record,
    ACTIONS(952), 1,
      anon_sym_LPAREN,
    ACTIONS(954), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(956), 1,
      anon_sym_u2983,
    ACTIONS(958), 1,
      anon_sym_LBRACE,
    ACTIONS(960), 1,
      aux_sym__qid_token1,
    ACTIONS(962), 1,
      anon_sym_DOT,
    ACTIONS(968), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(970), 1,
      anon_sym_u2987,
    ACTIONS(976), 1,
      anon_sym_Set,
    ACTIONS(982), 1,
      anon_sym_BSLASH,
    ACTIONS(984), 1,
      anon_sym_u03bb,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(990), 1,
      anon_sym_tactic,
    ACTIONS(1050), 1,
      anon_sym_RPAREN,
    ACTIONS(1302), 1,
      anon_sym_let,
    STATE(3211), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4712), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8095), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(10504), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(974), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(4733), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4742), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9581), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(948), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [62002] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1052), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(12120), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [62141] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1052), 1,
      anon_sym_u2984,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(12119), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [62280] = 37,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1056), 1,
      anon_sym_RBRACE,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(12118), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [62419] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1074), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(11512), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [62558] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1642), 1,
      anon_sym_RPAREN,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(11490), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [62697] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    ACTIONS(1642), 1,
      anon_sym_RBRACE_RBRACE,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(11557), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [62836] = 39,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    ACTIONS(1644), 1,
      anon_sym_u2984,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5428), 1,
      sym__ELLIPSIS,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(11217), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1490), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 6,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(1252), 7,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [62979] = 39,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    ACTIONS(1644), 1,
      anon_sym_RBRACE_RBRACE,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(5426), 1,
      sym__ELLIPSIS,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(11218), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1486), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 6,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(1174), 7,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [63122] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    ACTIONS(1642), 1,
      anon_sym_u2984,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(10232), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [63261] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1646), 1,
      anon_sym_RPAREN,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(12785), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [63400] = 37,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    ACTIONS(1648), 1,
      anon_sym_RBRACE,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(11555), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [63539] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1078), 1,
      anon_sym_RPAREN,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(12019), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [63678] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1078), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(12068), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [63817] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1078), 1,
      anon_sym_u2984,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(12067), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [63956] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(940), 1,
      sym_id,
    ACTIONS(950), 1,
      anon_sym_record,
    ACTIONS(952), 1,
      anon_sym_LPAREN,
    ACTIONS(954), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(956), 1,
      anon_sym_u2983,
    ACTIONS(958), 1,
      anon_sym_LBRACE,
    ACTIONS(960), 1,
      aux_sym__qid_token1,
    ACTIONS(962), 1,
      anon_sym_DOT,
    ACTIONS(968), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(970), 1,
      anon_sym_u2987,
    ACTIONS(976), 1,
      anon_sym_Set,
    ACTIONS(982), 1,
      anon_sym_BSLASH,
    ACTIONS(984), 1,
      anon_sym_u03bb,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(990), 1,
      anon_sym_tactic,
    ACTIONS(1058), 1,
      anon_sym_RPAREN,
    ACTIONS(1302), 1,
      anon_sym_let,
    STATE(3211), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4712), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8095), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(11170), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(974), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(4733), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4742), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9581), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(948), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [64095] = 37,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1080), 1,
      anon_sym_RBRACE,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(12066), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [64234] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(940), 1,
      sym_id,
    ACTIONS(950), 1,
      anon_sym_record,
    ACTIONS(952), 1,
      anon_sym_LPAREN,
    ACTIONS(954), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(956), 1,
      anon_sym_u2983,
    ACTIONS(958), 1,
      anon_sym_LBRACE,
    ACTIONS(960), 1,
      aux_sym__qid_token1,
    ACTIONS(962), 1,
      anon_sym_DOT,
    ACTIONS(968), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(970), 1,
      anon_sym_u2987,
    ACTIONS(976), 1,
      anon_sym_Set,
    ACTIONS(982), 1,
      anon_sym_BSLASH,
    ACTIONS(984), 1,
      anon_sym_u03bb,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(990), 1,
      anon_sym_tactic,
    ACTIONS(1044), 1,
      anon_sym_RPAREN,
    ACTIONS(1302), 1,
      anon_sym_let,
    STATE(3211), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4712), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8095), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(12140), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(974), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(4733), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4742), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9581), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(948), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [64373] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1650), 1,
      anon_sym_RPAREN,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(11461), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [64512] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    ACTIONS(1650), 1,
      anon_sym_RBRACE_RBRACE,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(11537), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [64651] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    ACTIONS(1650), 1,
      anon_sym_u2984,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(11411), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [64790] = 37,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    ACTIONS(1652), 1,
      anon_sym_RBRACE,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(11536), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [64929] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1074), 1,
      anon_sym_RPAREN,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(11513), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [65068] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    ACTIONS(1646), 1,
      anon_sym_RBRACE_RBRACE,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(12752), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [65207] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1122), 1,
      anon_sym_RPAREN,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(11968), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [65346] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1122), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(12018), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [65485] = 37,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1048), 1,
      anon_sym_RBRACE,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(10617), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [65624] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1050), 1,
      anon_sym_u2984,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(10578), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [65763] = 37,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    ACTIONS(1654), 1,
      anon_sym_RBRACE,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(12790), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [65902] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1050), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(10579), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [66041] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1050), 1,
      anon_sym_RPAREN,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(10504), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [66180] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    ACTIONS(1646), 1,
      anon_sym_u2984,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(12753), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [66319] = 37,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    ACTIONS(1656), 1,
      anon_sym_RBRACE,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(12754), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [66458] = 37,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    ACTIONS(1658), 1,
      anon_sym_RBRACE,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(10420), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [66597] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    ACTIONS(1660), 1,
      anon_sym_u2984,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(10421), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [66736] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(940), 1,
      sym_id,
    ACTIONS(950), 1,
      anon_sym_record,
    ACTIONS(952), 1,
      anon_sym_LPAREN,
    ACTIONS(954), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(956), 1,
      anon_sym_u2983,
    ACTIONS(958), 1,
      anon_sym_LBRACE,
    ACTIONS(960), 1,
      aux_sym__qid_token1,
    ACTIONS(962), 1,
      anon_sym_DOT,
    ACTIONS(968), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(970), 1,
      anon_sym_u2987,
    ACTIONS(976), 1,
      anon_sym_Set,
    ACTIONS(982), 1,
      anon_sym_BSLASH,
    ACTIONS(984), 1,
      anon_sym_u03bb,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(990), 1,
      anon_sym_tactic,
    ACTIONS(1036), 1,
      anon_sym_RPAREN,
    ACTIONS(1302), 1,
      anon_sym_let,
    STATE(3211), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4712), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8095), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(12601), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(974), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(4733), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4742), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9581), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(948), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [66875] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1122), 1,
      anon_sym_u2984,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(12016), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [67014] = 37,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1126), 1,
      anon_sym_RBRACE,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(12015), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [67153] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1662), 1,
      anon_sym_RPAREN,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(11046), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [67292] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1664), 1,
      anon_sym_RPAREN,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(11429), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [67431] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    ACTIONS(1664), 1,
      anon_sym_RBRACE_RBRACE,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(11514), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [67570] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    ACTIONS(1664), 1,
      anon_sym_u2984,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(11507), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [67709] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    ACTIONS(1662), 1,
      anon_sym_RBRACE_RBRACE,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(10607), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [67848] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    ACTIONS(1662), 1,
      anon_sym_u2984,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(10608), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [67987] = 37,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    ACTIONS(1666), 1,
      anon_sym_RBRACE,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(11506), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [68126] = 37,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    ACTIONS(1668), 1,
      anon_sym_RBRACE,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(10609), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [68265] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    ACTIONS(1660), 1,
      anon_sym_RBRACE_RBRACE,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(10422), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [68404] = 37,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    ACTIONS(1670), 1,
      anon_sym_RBRACE,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(12369), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [68543] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    ACTIONS(1672), 1,
      anon_sym_u2984,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(12370), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [68682] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1140), 1,
      anon_sym_RPAREN,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(11911), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [68821] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1140), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(11952), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [68960] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1660), 1,
      anon_sym_RPAREN,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(10349), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [69099] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1140), 1,
      anon_sym_u2984,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(11951), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [69238] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    ACTIONS(1610), 1,
      anon_sym_u2984,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(10540), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [69377] = 37,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1150), 1,
      anon_sym_RBRACE,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(11950), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [69516] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1674), 1,
      anon_sym_RPAREN,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(11400), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [69655] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    ACTIONS(1674), 1,
      anon_sym_RBRACE_RBRACE,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(11488), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [69794] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    ACTIONS(1672), 1,
      anon_sym_RBRACE_RBRACE,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(12371), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [69933] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    ACTIONS(1674), 1,
      anon_sym_u2984,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(11487), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [70072] = 37,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    ACTIONS(1676), 1,
      anon_sym_RBRACE,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(10538), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [70211] = 37,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    ACTIONS(1678), 1,
      anon_sym_RBRACE,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(11486), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [70350] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    ACTIONS(1564), 1,
      anon_sym_u2984,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(12692), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [70489] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1680), 1,
      anon_sym_RPAREN,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(11363), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [70628] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    ACTIONS(1680), 1,
      anon_sym_RBRACE_RBRACE,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(11459), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [70767] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(940), 1,
      sym_id,
    ACTIONS(950), 1,
      anon_sym_record,
    ACTIONS(952), 1,
      anon_sym_LPAREN,
    ACTIONS(954), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(956), 1,
      anon_sym_u2983,
    ACTIONS(958), 1,
      anon_sym_LBRACE,
    ACTIONS(960), 1,
      aux_sym__qid_token1,
    ACTIONS(962), 1,
      anon_sym_DOT,
    ACTIONS(968), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(970), 1,
      anon_sym_u2987,
    ACTIONS(976), 1,
      anon_sym_Set,
    ACTIONS(982), 1,
      anon_sym_BSLASH,
    ACTIONS(984), 1,
      anon_sym_u03bb,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(990), 1,
      anon_sym_tactic,
    ACTIONS(1040), 1,
      anon_sym_RPAREN,
    ACTIONS(1302), 1,
      anon_sym_let,
    STATE(3211), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4712), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8095), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(11141), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(974), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(4733), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4742), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9581), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(948), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [70906] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    ACTIONS(1680), 1,
      anon_sym_u2984,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(11458), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [71045] = 37,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    ACTIONS(1682), 1,
      anon_sym_RBRACE,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(11457), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [71184] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1672), 1,
      anon_sym_RPAREN,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(12318), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [71323] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1684), 1,
      anon_sym_RPAREN,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(11339), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [71462] = 37,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    ACTIONS(1686), 1,
      anon_sym_RBRACE,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(12380), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [71601] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    ACTIONS(1684), 1,
      anon_sym_RBRACE_RBRACE,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(11426), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [71740] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    ACTIONS(1684), 1,
      anon_sym_u2984,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(11422), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [71879] = 37,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    ACTIONS(1688), 1,
      anon_sym_RBRACE,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(11421), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [72018] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    ACTIONS(1614), 1,
      anon_sym_u2984,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(12791), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [72157] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    ACTIONS(1614), 1,
      anon_sym_RBRACE_RBRACE,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(12792), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [72296] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1690), 1,
      anon_sym_RPAREN,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(11271), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [72435] = 37,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    ACTIONS(1692), 1,
      anon_sym_RBRACE,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(12677), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [72574] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1694), 1,
      anon_sym_RPAREN,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(11207), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [72713] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    ACTIONS(1694), 1,
      anon_sym_RBRACE_RBRACE,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(10657), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [72852] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    ACTIONS(1694), 1,
      anon_sym_u2984,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(10658), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [72991] = 37,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    ACTIONS(1696), 1,
      anon_sym_RBRACE,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(12110), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [73130] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    ACTIONS(1698), 1,
      anon_sym_u2984,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(12108), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [73269] = 37,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    ACTIONS(1700), 1,
      anon_sym_RBRACE,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(10660), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [73408] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    ACTIONS(1698), 1,
      anon_sym_RBRACE_RBRACE,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(12107), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [73547] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1698), 1,
      anon_sym_RPAREN,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(12284), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [73686] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    ACTIONS(1690), 1,
      anon_sym_RBRACE_RBRACE,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(11362), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [73825] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(868), 1,
      anon_sym_RPAREN,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(940), 1,
      sym_id,
    ACTIONS(950), 1,
      anon_sym_record,
    ACTIONS(952), 1,
      anon_sym_LPAREN,
    ACTIONS(954), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(956), 1,
      anon_sym_u2983,
    ACTIONS(958), 1,
      anon_sym_LBRACE,
    ACTIONS(960), 1,
      aux_sym__qid_token1,
    ACTIONS(962), 1,
      anon_sym_DOT,
    ACTIONS(968), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(970), 1,
      anon_sym_u2987,
    ACTIONS(976), 1,
      anon_sym_Set,
    ACTIONS(982), 1,
      anon_sym_BSLASH,
    ACTIONS(984), 1,
      anon_sym_u03bb,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(990), 1,
      anon_sym_tactic,
    ACTIONS(1302), 1,
      anon_sym_let,
    STATE(3211), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4712), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8095), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(12484), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(974), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(4733), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4742), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9581), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(948), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [73964] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    ACTIONS(1702), 1,
      anon_sym_u2984,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(12381), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [74103] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    ACTIONS(1702), 1,
      anon_sym_RBRACE_RBRACE,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(12383), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [74242] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    ACTIONS(1690), 1,
      anon_sym_u2984,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(11355), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [74381] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(940), 1,
      sym_id,
    ACTIONS(950), 1,
      anon_sym_record,
    ACTIONS(952), 1,
      anon_sym_LPAREN,
    ACTIONS(954), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(956), 1,
      anon_sym_u2983,
    ACTIONS(958), 1,
      anon_sym_LBRACE,
    ACTIONS(960), 1,
      aux_sym__qid_token1,
    ACTIONS(962), 1,
      anon_sym_DOT,
    ACTIONS(968), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(970), 1,
      anon_sym_u2987,
    ACTIONS(976), 1,
      anon_sym_Set,
    ACTIONS(982), 1,
      anon_sym_BSLASH,
    ACTIONS(984), 1,
      anon_sym_u03bb,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(990), 1,
      anon_sym_tactic,
    ACTIONS(1026), 1,
      anon_sym_RPAREN,
    ACTIONS(1302), 1,
      anon_sym_let,
    STATE(3211), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4712), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8095), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(12449), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(974), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(4733), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4742), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9581), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(948), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [74520] = 37,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    ACTIONS(1704), 1,
      anon_sym_RBRACE,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(11351), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [74659] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1706), 1,
      anon_sym_RPAREN,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(10642), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [74798] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    ACTIONS(1606), 1,
      anon_sym_RBRACE_RBRACE,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(12599), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [74937] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1708), 1,
      anon_sym_RPAREN,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(11205), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [75076] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(940), 1,
      sym_id,
    ACTIONS(950), 1,
      anon_sym_record,
    ACTIONS(952), 1,
      anon_sym_LPAREN,
    ACTIONS(954), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(956), 1,
      anon_sym_u2983,
    ACTIONS(958), 1,
      anon_sym_LBRACE,
    ACTIONS(960), 1,
      aux_sym__qid_token1,
    ACTIONS(962), 1,
      anon_sym_DOT,
    ACTIONS(968), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(970), 1,
      anon_sym_u2987,
    ACTIONS(976), 1,
      anon_sym_Set,
    ACTIONS(982), 1,
      anon_sym_BSLASH,
    ACTIONS(984), 1,
      anon_sym_u03bb,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(990), 1,
      anon_sym_tactic,
    ACTIONS(1034), 1,
      anon_sym_RPAREN,
    ACTIONS(1302), 1,
      anon_sym_let,
    STATE(3211), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4712), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8095), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(11093), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(974), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(4733), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4742), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9581), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(948), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [75215] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    ACTIONS(1708), 1,
      anon_sym_RBRACE_RBRACE,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(11305), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [75354] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    ACTIONS(1708), 1,
      anon_sym_u2984,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(11304), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [75493] = 37,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    ACTIONS(1710), 1,
      anon_sym_RBRACE,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(11297), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [75632] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1712), 1,
      anon_sym_RPAREN,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(11122), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [75771] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(940), 1,
      sym_id,
    ACTIONS(950), 1,
      anon_sym_record,
    ACTIONS(952), 1,
      anon_sym_LPAREN,
    ACTIONS(954), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(956), 1,
      anon_sym_u2983,
    ACTIONS(958), 1,
      anon_sym_LBRACE,
    ACTIONS(960), 1,
      aux_sym__qid_token1,
    ACTIONS(962), 1,
      anon_sym_DOT,
    ACTIONS(968), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(970), 1,
      anon_sym_u2987,
    ACTIONS(976), 1,
      anon_sym_Set,
    ACTIONS(982), 1,
      anon_sym_BSLASH,
    ACTIONS(984), 1,
      anon_sym_u03bb,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(990), 1,
      anon_sym_tactic,
    ACTIONS(1030), 1,
      anon_sym_RPAREN,
    ACTIONS(1302), 1,
      anon_sym_let,
    STATE(3211), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4712), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8095), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(12540), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(974), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(4733), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4742), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9581), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(948), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [75910] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    ACTIONS(1712), 1,
      anon_sym_RBRACE_RBRACE,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(11204), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [76049] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    ACTIONS(1712), 1,
      anon_sym_u2984,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(11203), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [76188] = 37,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    ACTIONS(1714), 1,
      anon_sym_RBRACE,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(11200), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [76327] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1702), 1,
      anon_sym_RPAREN,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(11398), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [76466] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    ACTIONS(1706), 1,
      anon_sym_RBRACE_RBRACE,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(10776), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [76605] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1164), 1,
      anon_sym_RPAREN,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(11748), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [76744] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    ACTIONS(1606), 1,
      anon_sym_u2984,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(12597), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [76883] = 37,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    ACTIONS(1716), 1,
      anon_sym_RBRACE,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(12596), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [77022] = 37,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    ACTIONS(1718), 1,
      anon_sym_RBRACE,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(10653), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [77161] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1164), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(11781), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [77300] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1720), 1,
      anon_sym_RPAREN,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(11219), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [77439] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1164), 1,
      anon_sym_u2984,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(11780), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [77578] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    ACTIONS(1722), 1,
      anon_sym_u2984,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(10654), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [77717] = 37,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(914), 1,
      anon_sym_RBRACE,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(11779), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [77856] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    ACTIONS(1720), 1,
      anon_sym_RBRACE_RBRACE,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(11252), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [77995] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    ACTIONS(1720), 1,
      anon_sym_u2984,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(11251), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [78134] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1724), 1,
      anon_sym_RPAREN,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(11060), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [78273] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    ACTIONS(1724), 1,
      anon_sym_RBRACE_RBRACE,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(11137), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [78412] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    ACTIONS(1724), 1,
      anon_sym_u2984,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(11136), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [78551] = 37,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    ACTIONS(1726), 1,
      anon_sym_RBRACE,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(11135), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [78690] = 37,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    ACTIONS(1728), 1,
      anon_sym_RBRACE,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(11250), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [78829] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1132), 1,
      anon_sym_RPAREN,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(11786), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [78968] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1730), 1,
      anon_sym_RPAREN,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(11284), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [79107] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    ACTIONS(1722), 1,
      anon_sym_RBRACE_RBRACE,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(10655), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [79246] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1732), 1,
      anon_sym_RPAREN,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(11041), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [79385] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    ACTIONS(1730), 1,
      anon_sym_RBRACE_RBRACE,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(10715), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [79524] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    ACTIONS(1732), 1,
      anon_sym_RBRACE_RBRACE,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(11121), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [79663] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    ACTIONS(1732), 1,
      anon_sym_u2984,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(11118), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [79802] = 37,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    ACTIONS(1734), 1,
      anon_sym_RBRACE,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(11111), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [79941] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1162), 1,
      anon_sym_RPAREN,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(11631), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [80080] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    ACTIONS(1730), 1,
      anon_sym_u2984,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(10717), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [80219] = 37,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    ACTIONS(1736), 1,
      anon_sym_RBRACE,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(12075), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [80358] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    ACTIONS(1738), 1,
      anon_sym_u2984,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(12074), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [80497] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    ACTIONS(1738), 1,
      anon_sym_RBRACE_RBRACE,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(12072), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [80636] = 37,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    ACTIONS(1740), 1,
      anon_sym_RBRACE,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(10746), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [80775] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    ACTIONS(1706), 1,
      anon_sym_u2984,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(10773), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [80914] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1738), 1,
      anon_sym_RPAREN,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(12228), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [81053] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1742), 1,
      anon_sym_RPAREN,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(12777), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [81192] = 37,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1060), 1,
      anon_sym_RBRACE,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(11395), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [81331] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    ACTIONS(1742), 1,
      anon_sym_RBRACE_RBRACE,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(12814), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [81470] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1744), 1,
      anon_sym_RPAREN,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(12384), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [81609] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1162), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(11669), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [81748] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    ACTIONS(1742), 1,
      anon_sym_u2984,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(12813), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [81887] = 37,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    ACTIONS(1746), 1,
      anon_sym_RBRACE,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(12812), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [82026] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1132), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(11412), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [82165] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1722), 1,
      anon_sym_RPAREN,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(10580), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [82304] = 37,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    ACTIONS(1748), 1,
      anon_sym_RBRACE,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(12464), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [82443] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1162), 1,
      anon_sym_u2984,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(11668), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [82582] = 37,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1160), 1,
      anon_sym_RBRACE,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(11667), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [82721] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1750), 1,
      anon_sym_RPAREN,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(11010), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [82860] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    ACTIONS(1750), 1,
      anon_sym_RBRACE_RBRACE,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(11090), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [82999] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(940), 1,
      sym_id,
    ACTIONS(950), 1,
      anon_sym_record,
    ACTIONS(952), 1,
      anon_sym_LPAREN,
    ACTIONS(954), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(956), 1,
      anon_sym_u2983,
    ACTIONS(958), 1,
      anon_sym_LBRACE,
    ACTIONS(960), 1,
      aux_sym__qid_token1,
    ACTIONS(962), 1,
      anon_sym_DOT,
    ACTIONS(968), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(970), 1,
      anon_sym_u2987,
    ACTIONS(976), 1,
      anon_sym_Set,
    ACTIONS(982), 1,
      anon_sym_BSLASH,
    ACTIONS(984), 1,
      anon_sym_u03bb,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(990), 1,
      anon_sym_tactic,
    ACTIONS(1024), 1,
      anon_sym_RPAREN,
    ACTIONS(1302), 1,
      anon_sym_let,
    STATE(3211), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4712), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8095), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(10872), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(974), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(4733), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4742), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9581), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(948), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [83138] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    ACTIONS(1750), 1,
      anon_sym_u2984,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(11089), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [83277] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    ACTIONS(1744), 1,
      anon_sym_RBRACE_RBRACE,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(12448), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [83416] = 37,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    ACTIONS(1752), 1,
      anon_sym_RBRACE,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(11087), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [83555] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1154), 1,
      anon_sym_RPAREN,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(11609), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [83694] = 37,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    ACTIONS(1754), 1,
      anon_sym_RBRACE,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(10462), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [83833] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1154), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(11644), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [83972] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1154), 1,
      anon_sym_u2984,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(11643), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [84111] = 37,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1152), 1,
      anon_sym_RBRACE,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(11641), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [84250] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1756), 1,
      anon_sym_RPAREN,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(10982), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [84389] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    ACTIONS(1756), 1,
      anon_sym_RBRACE_RBRACE,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(11058), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [84528] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    ACTIONS(1758), 1,
      anon_sym_u2984,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(10463), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [84667] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    ACTIONS(1756), 1,
      anon_sym_u2984,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(11057), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [84806] = 37,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    ACTIONS(1760), 1,
      anon_sym_RBRACE,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(11056), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [84945] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(940), 1,
      sym_id,
    ACTIONS(950), 1,
      anon_sym_record,
    ACTIONS(952), 1,
      anon_sym_LPAREN,
    ACTIONS(954), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(956), 1,
      anon_sym_u2983,
    ACTIONS(958), 1,
      anon_sym_LBRACE,
    ACTIONS(960), 1,
      aux_sym__qid_token1,
    ACTIONS(962), 1,
      anon_sym_DOT,
    ACTIONS(968), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(970), 1,
      anon_sym_u2987,
    ACTIONS(976), 1,
      anon_sym_Set,
    ACTIONS(982), 1,
      anon_sym_BSLASH,
    ACTIONS(984), 1,
      anon_sym_u03bb,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(990), 1,
      anon_sym_tactic,
    ACTIONS(1020), 1,
      anon_sym_RPAREN,
    ACTIONS(1302), 1,
      anon_sym_let,
    STATE(3211), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4712), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8095), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(12711), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(974), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(4733), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4742), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9581), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(948), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [85084] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1144), 1,
      anon_sym_RPAREN,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(11595), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [85223] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1144), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(11630), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [85362] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    ACTIONS(1758), 1,
      anon_sym_RBRACE_RBRACE,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(10464), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [85501] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1144), 1,
      anon_sym_u2984,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(11629), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [85640] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1758), 1,
      anon_sym_RPAREN,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(10385), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [85779] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1132), 1,
      anon_sym_u2984,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(11436), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [85918] = 37,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1142), 1,
      anon_sym_RBRACE,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(11628), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [86057] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(940), 1,
      sym_id,
    ACTIONS(950), 1,
      anon_sym_record,
    ACTIONS(952), 1,
      anon_sym_LPAREN,
    ACTIONS(954), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(956), 1,
      anon_sym_u2983,
    ACTIONS(958), 1,
      anon_sym_LBRACE,
    ACTIONS(960), 1,
      aux_sym__qid_token1,
    ACTIONS(962), 1,
      anon_sym_DOT,
    ACTIONS(968), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(970), 1,
      anon_sym_u2987,
    ACTIONS(976), 1,
      anon_sym_Set,
    ACTIONS(982), 1,
      anon_sym_BSLASH,
    ACTIONS(984), 1,
      anon_sym_u03bb,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(990), 1,
      anon_sym_tactic,
    ACTIONS(1008), 1,
      anon_sym_RPAREN,
    ACTIONS(1302), 1,
      anon_sym_let,
    STATE(3211), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4712), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8095), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(11290), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(974), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(4733), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4742), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9581), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(948), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [86196] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1134), 1,
      anon_sym_RPAREN,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(11559), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [86335] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1134), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(11608), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [86474] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    ACTIONS(1744), 1,
      anon_sym_u2984,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(12447), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [86613] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1762), 1,
      anon_sym_RPAREN,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(11565), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [86752] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1134), 1,
      anon_sym_u2984,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(11606), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [86891] = 37,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1128), 1,
      anon_sym_RBRACE,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(11604), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [87030] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1764), 1,
      anon_sym_RPAREN,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(10952), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [87169] = 37,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    ACTIONS(1766), 1,
      anon_sym_RBRACE,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(11895), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [87308] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(940), 1,
      sym_id,
    ACTIONS(950), 1,
      anon_sym_record,
    ACTIONS(952), 1,
      anon_sym_LPAREN,
    ACTIONS(954), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(956), 1,
      anon_sym_u2983,
    ACTIONS(958), 1,
      anon_sym_LBRACE,
    ACTIONS(960), 1,
      aux_sym__qid_token1,
    ACTIONS(962), 1,
      anon_sym_DOT,
    ACTIONS(968), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(970), 1,
      anon_sym_u2987,
    ACTIONS(976), 1,
      anon_sym_Set,
    ACTIONS(982), 1,
      anon_sym_BSLASH,
    ACTIONS(984), 1,
      anon_sym_u03bb,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(990), 1,
      anon_sym_tactic,
    ACTIONS(1016), 1,
      anon_sym_RPAREN,
    ACTIONS(1302), 1,
      anon_sym_let,
    STATE(3211), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4712), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8095), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(12191), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(974), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(4733), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4742), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9581), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(948), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [87447] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    ACTIONS(1768), 1,
      anon_sym_u2984,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(11876), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [87586] = 37,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1130), 1,
      anon_sym_RBRACE,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(11437), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [87725] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    ACTIONS(1768), 1,
      anon_sym_RBRACE_RBRACE,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(11872), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [87864] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1768), 1,
      anon_sym_RPAREN,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(12106), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [88003] = 37,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    ACTIONS(1770), 1,
      anon_sym_RBRACE,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(12446), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [88142] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    ACTIONS(1764), 1,
      anon_sym_RBRACE_RBRACE,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(11035), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [88281] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    ACTIONS(1762), 1,
      anon_sym_RBRACE_RBRACE,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(11126), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [88420] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    ACTIONS(1762), 1,
      anon_sym_u2984,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(10902), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [88559] = 37,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    ACTIONS(1772), 1,
      anon_sym_RBRACE,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(10904), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [88698] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    ACTIONS(1764), 1,
      anon_sym_u2984,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(11034), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [88837] = 37,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1084), 1,
      anon_sym_RBRACE,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(11798), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [88976] = 37,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    ACTIONS(1774), 1,
      anon_sym_RBRACE,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(10900), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [89115] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1124), 1,
      anon_sym_RPAREN,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(11516), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [89254] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1124), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(11580), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [89393] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1124), 1,
      anon_sym_u2984,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(11578), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [89532] = 37,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1120), 1,
      anon_sym_RBRACE,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(11577), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [89671] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1776), 1,
      anon_sym_RPAREN,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(10927), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [89810] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    ACTIONS(1776), 1,
      anon_sym_RBRACE_RBRACE,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(11008), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [89949] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    ACTIONS(1776), 1,
      anon_sym_u2984,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(11007), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [90088] = 37,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    ACTIONS(1778), 1,
      anon_sym_RBRACE,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(10998), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [90227] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1780), 1,
      anon_sym_RPAREN,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(10901), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [90366] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    ACTIONS(1780), 1,
      anon_sym_RBRACE_RBRACE,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(10979), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [90505] = 37,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    ACTIONS(1782), 1,
      anon_sym_RBRACE,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(10772), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [90644] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    ACTIONS(1780), 1,
      anon_sym_u2984,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(10977), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [90783] = 37,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    ACTIONS(1784), 1,
      anon_sym_RBRACE,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(10976), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [90922] = 37,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    ACTIONS(1786), 1,
      anon_sym_RBRACE,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(12413), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [91061] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1090), 1,
      anon_sym_RPAREN,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(11306), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [91200] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1090), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(11399), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [91339] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1090), 1,
      anon_sym_u2984,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(11392), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [91478] = 37,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1088), 1,
      anon_sym_RBRACE,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(11387), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [91617] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1086), 1,
      anon_sym_u2984,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(11797), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [91756] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1086), 1,
      anon_sym_RPAREN,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(12071), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [91895] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(940), 1,
      sym_id,
    ACTIONS(950), 1,
      anon_sym_record,
    ACTIONS(952), 1,
      anon_sym_LPAREN,
    ACTIONS(954), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(956), 1,
      anon_sym_u2983,
    ACTIONS(958), 1,
      anon_sym_LBRACE,
    ACTIONS(960), 1,
      aux_sym__qid_token1,
    ACTIONS(962), 1,
      anon_sym_DOT,
    ACTIONS(968), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(970), 1,
      anon_sym_u2987,
    ACTIONS(976), 1,
      anon_sym_Set,
    ACTIONS(982), 1,
      anon_sym_BSLASH,
    ACTIONS(984), 1,
      anon_sym_u03bb,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(990), 1,
      anon_sym_tactic,
    ACTIONS(1002), 1,
      anon_sym_RPAREN,
    ACTIONS(1302), 1,
      anon_sym_let,
    STATE(3211), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4712), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8095), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(12675), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(974), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(4733), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4742), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9581), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(948), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [92034] = 37,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    ACTIONS(1788), 1,
      anon_sym_RBRACE,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(12400), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [92173] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1790), 1,
      anon_sym_RPAREN,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(10838), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [92312] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1792), 1,
      anon_sym_RPAREN,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(11647), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [92451] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    ACTIONS(1790), 1,
      anon_sym_RBRACE_RBRACE,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(10926), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [92590] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    ACTIONS(1790), 1,
      anon_sym_u2984,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(10922), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [92729] = 37,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    ACTIONS(1794), 1,
      anon_sym_RBRACE,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(10917), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [92868] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1070), 1,
      anon_sym_RPAREN,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(11237), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [93007] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    ACTIONS(1792), 1,
      anon_sym_RBRACE_RBRACE,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(11047), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [93146] = 37,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    ACTIONS(1796), 1,
      anon_sym_RBRACE,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(11725), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [93285] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    ACTIONS(1488), 1,
      anon_sym_u2984,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(11724), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [93424] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    ACTIONS(1488), 1,
      anon_sym_RBRACE_RBRACE,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(11723), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [93563] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1488), 1,
      anon_sym_RPAREN,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(12038), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [93702] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    ACTIONS(1792), 1,
      anon_sym_u2984,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(11064), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [93841] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1070), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(11338), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [93980] = 37,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    ACTIONS(1798), 1,
      anon_sym_RBRACE,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(11065), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [94119] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1800), 1,
      anon_sym_RPAREN,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(12306), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [94258] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    ACTIONS(1800), 1,
      anon_sym_RBRACE_RBRACE,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(12431), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [94397] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    ACTIONS(1802), 1,
      anon_sym_u2984,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(12401), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [94536] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1070), 1,
      anon_sym_u2984,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(11329), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [94675] = 37,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1068), 1,
      anon_sym_RBRACE,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(11328), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [94814] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1804), 1,
      anon_sym_RPAREN,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(10815), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [94953] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    ACTIONS(1804), 1,
      anon_sym_RBRACE_RBRACE,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(10796), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [95092] = 37,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    ACTIONS(1806), 1,
      anon_sym_RBRACE,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(12766), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [95231] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1644), 1,
      anon_sym_RPAREN,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(11182), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [95370] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    ACTIONS(1804), 1,
      anon_sym_u2984,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(10897), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [95509] = 37,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    ACTIONS(1808), 1,
      anon_sym_RBRACE,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(10890), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [95648] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1058), 1,
      anon_sym_RPAREN,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(11170), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [95787] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1058), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(11269), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [95926] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    ACTIONS(1644), 1,
      anon_sym_RBRACE_RBRACE,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(11218), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [96065] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1058), 1,
      anon_sym_u2984,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(11268), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [96204] = 37,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1054), 1,
      anon_sym_RBRACE,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(11267), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [96343] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1810), 1,
      anon_sym_RPAREN,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(10793), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [96482] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    ACTIONS(1644), 1,
      anon_sym_u2984,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(11217), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [96621] = 37,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    ACTIONS(1812), 1,
      anon_sym_RBRACE,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(11106), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [96760] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    ACTIONS(1810), 1,
      anon_sym_RBRACE_RBRACE,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(10869), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [96899] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    ACTIONS(1800), 1,
      anon_sym_u2984,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(12430), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [97038] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    ACTIONS(1810), 1,
      anon_sym_u2984,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(10867), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [97177] = 37,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    ACTIONS(1814), 1,
      anon_sym_RBRACE,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(10866), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [97316] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1040), 1,
      anon_sym_RPAREN,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(11141), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [97455] = 37,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    ACTIONS(1816), 1,
      anon_sym_RBRACE,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(12429), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [97594] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1040), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(11235), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [97733] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1040), 1,
      anon_sym_u2984,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(11233), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [97872] = 37,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    ACTIONS(1818), 1,
      anon_sym_RBRACE,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(12804), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [98011] = 37,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1038), 1,
      anon_sym_RBRACE,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(11231), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [98150] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    ACTIONS(1820), 1,
      anon_sym_u2984,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(12805), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [98289] = 37,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    ACTIONS(1822), 1,
      anon_sym_RBRACE,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(10694), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [98428] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1034), 1,
      anon_sym_RPAREN,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(11093), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [98567] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1008), 1,
      anon_sym_u2984,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(11325), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [98706] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(940), 1,
      sym_id,
    ACTIONS(950), 1,
      anon_sym_record,
    ACTIONS(952), 1,
      anon_sym_LPAREN,
    ACTIONS(954), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(956), 1,
      anon_sym_u2983,
    ACTIONS(958), 1,
      anon_sym_LBRACE,
    ACTIONS(960), 1,
      aux_sym__qid_token1,
    ACTIONS(962), 1,
      anon_sym_DOT,
    ACTIONS(968), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(970), 1,
      anon_sym_u2987,
    ACTIONS(976), 1,
      anon_sym_Set,
    ACTIONS(982), 1,
      anon_sym_BSLASH,
    ACTIONS(984), 1,
      anon_sym_u03bb,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(990), 1,
      anon_sym_tactic,
    ACTIONS(998), 1,
      anon_sym_RPAREN,
    ACTIONS(1302), 1,
      anon_sym_let,
    STATE(3211), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4712), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8095), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(11147), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(974), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(4733), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4742), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9581), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(948), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [98845] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1034), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(11169), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [98984] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1034), 1,
      anon_sym_u2984,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(11166), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [99123] = 37,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1032), 1,
      anon_sym_RBRACE,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(11163), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [99262] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1824), 1,
      anon_sym_RPAREN,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(10763), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [99401] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    ACTIONS(1820), 1,
      anon_sym_RBRACE_RBRACE,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(12806), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [99540] = 37,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    ACTIONS(1826), 1,
      anon_sym_RBRACE,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(11658), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [99679] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    ACTIONS(1828), 1,
      anon_sym_u2984,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(11649), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [99818] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    ACTIONS(1828), 1,
      anon_sym_RBRACE_RBRACE,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(11648), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [99957] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1828), 1,
      anon_sym_RPAREN,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(11970), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [100096] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    ACTIONS(1824), 1,
      anon_sym_RBRACE_RBRACE,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(10837), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [100235] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    ACTIONS(1802), 1,
      anon_sym_RBRACE_RBRACE,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(12402), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [100374] = 37,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    ACTIONS(1830), 1,
      anon_sym_RBRACE,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(10497), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [100513] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    ACTIONS(1832), 1,
      anon_sym_u2984,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(12768), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [100652] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    ACTIONS(1832), 1,
      anon_sym_RBRACE_RBRACE,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(12769), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [100791] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1136), 1,
      anon_sym_RPAREN,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(10736), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [100930] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1136), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(10812), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [101069] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    ACTIONS(1824), 1,
      anon_sym_u2984,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(10834), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [101208] = 37,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    ACTIONS(1834), 1,
      anon_sym_RBRACE,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(10832), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [101347] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1836), 1,
      anon_sym_RPAREN,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(10745), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [101486] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    ACTIONS(1836), 1,
      anon_sym_RBRACE_RBRACE,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(10814), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [101625] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    ACTIONS(1836), 1,
      anon_sym_u2984,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(10807), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [101764] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1832), 1,
      anon_sym_RPAREN,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(12772), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [101903] = 37,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    ACTIONS(1838), 1,
      anon_sym_RBRACE,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(10804), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [102042] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1840), 1,
      anon_sym_RPAREN,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(10723), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [102181] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    ACTIONS(1840), 1,
      anon_sym_RBRACE_RBRACE,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(10791), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [102320] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    ACTIONS(1840), 1,
      anon_sym_u2984,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(10790), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [102459] = 37,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    ACTIONS(1842), 1,
      anon_sym_RBRACE,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(10789), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [102598] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1844), 1,
      anon_sym_RPAREN,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(10721), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [102737] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    ACTIONS(1844), 1,
      anon_sym_RBRACE_RBRACE,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(10761), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [102876] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1008), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(11326), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [103015] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    ACTIONS(1844), 1,
      anon_sym_u2984,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(10760), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [103154] = 37,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    ACTIONS(1846), 1,
      anon_sym_RBRACE,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(10759), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [103293] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1024), 1,
      anon_sym_RPAREN,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(10872), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [103432] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1024), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(10948), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [103571] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1024), 1,
      anon_sym_u2984,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(10947), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [103710] = 37,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1022), 1,
      anon_sym_RBRACE,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(10946), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [103849] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1136), 1,
      anon_sym_u2984,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(10811), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [103988] = 37,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1138), 1,
      anon_sym_RBRACE,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(10847), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [104127] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1848), 1,
      anon_sym_RPAREN,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(10720), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [104266] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1820), 1,
      anon_sym_RPAREN,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(12765), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [104405] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    ACTIONS(1848), 1,
      anon_sym_RBRACE_RBRACE,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(10744), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [104544] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1062), 1,
      anon_sym_u2984,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(11359), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [104683] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    ACTIONS(1848), 1,
      anon_sym_u2984,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(10738), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [104822] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1008), 1,
      anon_sym_RPAREN,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(11290), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [104961] = 37,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    ACTIONS(1850), 1,
      anon_sym_RBRACE,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(10737), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [105100] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1852), 1,
      anon_sym_RPAREN,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(10888), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [105239] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1358), 1,
      anon_sym_RPAREN,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(12354), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [105378] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    ACTIONS(1852), 1,
      anon_sym_RBRACE_RBRACE,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(10957), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [105517] = 37,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    ACTIONS(1854), 1,
      anon_sym_RBRACE,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(11583), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [105656] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    ACTIONS(1856), 1,
      anon_sym_u2984,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(11582), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [105795] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(936), 1,
      anon_sym_RPAREN,
    ACTIONS(940), 1,
      sym_id,
    ACTIONS(950), 1,
      anon_sym_record,
    ACTIONS(952), 1,
      anon_sym_LPAREN,
    ACTIONS(954), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(956), 1,
      anon_sym_u2983,
    ACTIONS(958), 1,
      anon_sym_LBRACE,
    ACTIONS(960), 1,
      aux_sym__qid_token1,
    ACTIONS(962), 1,
      anon_sym_DOT,
    ACTIONS(968), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(970), 1,
      anon_sym_u2987,
    ACTIONS(976), 1,
      anon_sym_Set,
    ACTIONS(982), 1,
      anon_sym_BSLASH,
    ACTIONS(984), 1,
      anon_sym_u03bb,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(990), 1,
      anon_sym_tactic,
    ACTIONS(1302), 1,
      anon_sym_let,
    STATE(3211), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4712), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8095), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(11109), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(974), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(4733), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4742), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9581), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(948), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [105934] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    ACTIONS(1856), 1,
      anon_sym_RBRACE_RBRACE,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(11566), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [106073] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1858), 1,
      anon_sym_RPAREN,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(10996), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [106212] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1856), 1,
      anon_sym_RPAREN,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(11871), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [106351] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    ACTIONS(1852), 1,
      anon_sym_u2984,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(10956), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [106490] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    ACTIONS(1858), 1,
      anon_sym_RBRACE_RBRACE,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(11070), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [106629] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    ACTIONS(1858), 1,
      anon_sym_u2984,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(11069), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [106768] = 37,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1082), 1,
      anon_sym_RBRACE,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(11573), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [106907] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    ACTIONS(1860), 1,
      anon_sym_u2984,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(10501), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [107046] = 37,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1146), 1,
      anon_sym_RBRACE,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(11510), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [107185] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1802), 1,
      anon_sym_RPAREN,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(12338), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [107324] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    ACTIONS(1860), 1,
      anon_sym_RBRACE_RBRACE,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(10503), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [107463] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1862), 1,
      anon_sym_RPAREN,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(11722), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [107602] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    ACTIONS(1862), 1,
      anon_sym_RBRACE_RBRACE,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(11209), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [107741] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    ACTIONS(1862), 1,
      anon_sym_u2984,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(11240), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [107880] = 37,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    ACTIONS(1864), 1,
      anon_sym_RBRACE,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(11241), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [108019] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1860), 1,
      anon_sym_RPAREN,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(10423), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [108158] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    ACTIONS(1358), 1,
      anon_sym_RBRACE_RBRACE,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(12416), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [108297] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1086), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(11796), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [108436] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1062), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(11360), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [108575] = 37,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1062), 1,
      anon_sym_RPAREN,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(11327), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [108714] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1866), 1,
      sym_id,
    ACTIONS(1870), 1,
      anon_sym_BSLASH,
    ACTIONS(1872), 1,
      anon_sym_u03bb,
    ACTIONS(1876), 1,
      anon_sym_record,
    ACTIONS(1878), 1,
      anon_sym_LPAREN,
    ACTIONS(1880), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1882), 1,
      anon_sym_u2983,
    ACTIONS(1884), 1,
      anon_sym_LBRACE,
    ACTIONS(1886), 1,
      aux_sym__qid_token1,
    ACTIONS(1888), 1,
      anon_sym_DOT,
    ACTIONS(1890), 1,
      anon_sym_quoteGoal,
    ACTIONS(1892), 1,
      anon_sym_tactic,
    ACTIONS(1894), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1896), 1,
      anon_sym_u2987,
    ACTIONS(1898), 1,
      anon_sym_let,
    ACTIONS(1902), 1,
      anon_sym_Set,
    STATE(3337), 1,
      aux_sym__atoms,
    STATE(3738), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4366), 1,
      sym_atom,
    STATE(6298), 1,
      sym_attributes,
    STATE(8032), 1,
      sym__LAMBDA,
    STATE(8379), 1,
      sym__FORALL,
    STATE(8952), 1,
      sym_expr,
    STATE(9157), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1868), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1900), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4264), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8633), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4263), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1874), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [108850] = 35,
    ACTIONS(700), 1,
      anon_sym_LBRACE_DASH_POUND,
    ACTIONS(706), 1,
      aux_sym__qid_token1,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1904), 1,
      sym_id,
    ACTIONS(1910), 1,
      anon_sym_BSLASH,
    ACTIONS(1912), 1,
      anon_sym_u03bb,
    ACTIONS(1916), 1,
      anon_sym_record,
    ACTIONS(1918), 1,
      anon_sym_LPAREN,
    ACTIONS(1920), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1922), 1,
      anon_sym_u2983,
    ACTIONS(1924), 1,
      anon_sym_LBRACE,
    ACTIONS(1926), 1,
      anon_sym_DOT,
    ACTIONS(1928), 1,
      anon_sym_quoteGoal,
    ACTIONS(1930), 1,
      anon_sym_tactic,
    ACTIONS(1932), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1934), 1,
      anon_sym_u2987,
    ACTIONS(1936), 1,
      anon_sym_let,
    ACTIONS(1940), 1,
      anon_sym_Set,
    STATE(2553), 1,
      sym__ARROW,
    STATE(2728), 1,
      aux_sym__lambda_clauses_repeat1,
    STATE(3176), 1,
      sym_catchall_pragma,
    STATE(3669), 1,
      aux_sym__atoms,
    STATE(4914), 1,
      sym_atom,
    STATE(8153), 1,
      sym__LAMBDA,
    STATE(8431), 1,
      sym__FORALL,
    STATE(8987), 1,
      sym__lambda_clauses,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1906), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1908), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(1938), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4675), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(8986), 3,
      sym__lambda_clause_maybe_absurd,
      sym_lambda_clause_absurd,
      sym_lambda_clause,
    STATE(4679), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8988), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1914), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [108984] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(10355), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [109120] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(10354), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [109256] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1866), 1,
      sym_id,
    ACTIONS(1870), 1,
      anon_sym_BSLASH,
    ACTIONS(1872), 1,
      anon_sym_u03bb,
    ACTIONS(1876), 1,
      anon_sym_record,
    ACTIONS(1878), 1,
      anon_sym_LPAREN,
    ACTIONS(1880), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1882), 1,
      anon_sym_u2983,
    ACTIONS(1884), 1,
      anon_sym_LBRACE,
    ACTIONS(1886), 1,
      aux_sym__qid_token1,
    ACTIONS(1888), 1,
      anon_sym_DOT,
    ACTIONS(1890), 1,
      anon_sym_quoteGoal,
    ACTIONS(1892), 1,
      anon_sym_tactic,
    ACTIONS(1894), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1896), 1,
      anon_sym_u2987,
    ACTIONS(1898), 1,
      anon_sym_let,
    ACTIONS(1902), 1,
      anon_sym_Set,
    STATE(3337), 1,
      aux_sym__atoms,
    STATE(3738), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4366), 1,
      sym_atom,
    STATE(6298), 1,
      sym_attributes,
    STATE(8032), 1,
      sym__LAMBDA,
    STATE(8379), 1,
      sym__FORALL,
    STATE(8957), 1,
      sym_expr,
    STATE(9157), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1868), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1900), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4264), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8633), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4263), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1874), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [109392] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(9990), 1,
      sym__with_exprs,
    STATE(11735), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [109528] = 36,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(11712), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [109664] = 36,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(10353), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [109800] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1980), 1,
      sym_id,
    ACTIONS(1984), 1,
      anon_sym_BSLASH,
    ACTIONS(1986), 1,
      anon_sym_u03bb,
    ACTIONS(1990), 1,
      anon_sym_record,
    ACTIONS(1992), 1,
      anon_sym_LPAREN,
    ACTIONS(1994), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1996), 1,
      anon_sym_u2983,
    ACTIONS(1998), 1,
      anon_sym_LBRACE,
    ACTIONS(2000), 1,
      aux_sym__qid_token1,
    ACTIONS(2002), 1,
      anon_sym_DOT,
    ACTIONS(2004), 1,
      anon_sym_quoteGoal,
    ACTIONS(2006), 1,
      anon_sym_tactic,
    ACTIONS(2008), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2010), 1,
      anon_sym_u2987,
    ACTIONS(2012), 1,
      anon_sym_let,
    ACTIONS(2016), 1,
      anon_sym_Set,
    STATE(3156), 1,
      aux_sym__atoms,
    STATE(3740), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4972), 1,
      sym_atom,
    STATE(6248), 1,
      sym_attributes,
    STATE(8039), 1,
      sym__LAMBDA,
    STATE(8483), 1,
      sym__FORALL,
    STATE(8961), 1,
      sym_expr,
    STATE(9685), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1982), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2014), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5336), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8659), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5185), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1988), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [109936] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2018), 1,
      sym_id,
    ACTIONS(2022), 1,
      anon_sym_BSLASH,
    ACTIONS(2024), 1,
      anon_sym_u03bb,
    ACTIONS(2028), 1,
      anon_sym_record,
    ACTIONS(2030), 1,
      anon_sym_LPAREN,
    ACTIONS(2032), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2034), 1,
      anon_sym_u2983,
    ACTIONS(2036), 1,
      anon_sym_LBRACE,
    ACTIONS(2038), 1,
      aux_sym__qid_token1,
    ACTIONS(2040), 1,
      anon_sym_DOT,
    ACTIONS(2042), 1,
      anon_sym_quoteGoal,
    ACTIONS(2044), 1,
      anon_sym_tactic,
    ACTIONS(2046), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2048), 1,
      anon_sym_u2987,
    ACTIONS(2050), 1,
      anon_sym_let,
    ACTIONS(2054), 1,
      anon_sym_Set,
    STATE(3271), 1,
      aux_sym__atoms,
    STATE(3748), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4997), 1,
      sym_atom,
    STATE(6254), 1,
      sym_attributes,
    STATE(8033), 1,
      sym__LAMBDA,
    STATE(8463), 1,
      sym__FORALL,
    STATE(8992), 1,
      sym_expr,
    STATE(9607), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2020), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2052), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5176), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8669), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5183), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2026), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [110072] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(9990), 1,
      sym__with_exprs,
    STATE(10343), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [110208] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(10065), 1,
      sym__with_exprs,
    STATE(10953), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [110344] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(11711), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [110480] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(11709), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [110616] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(10627), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [110752] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(11033), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [110888] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(11721), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [111024] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1866), 1,
      sym_id,
    ACTIONS(1870), 1,
      anon_sym_BSLASH,
    ACTIONS(1872), 1,
      anon_sym_u03bb,
    ACTIONS(1876), 1,
      anon_sym_record,
    ACTIONS(1878), 1,
      anon_sym_LPAREN,
    ACTIONS(1880), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1882), 1,
      anon_sym_u2983,
    ACTIONS(1884), 1,
      anon_sym_LBRACE,
    ACTIONS(1886), 1,
      aux_sym__qid_token1,
    ACTIONS(1888), 1,
      anon_sym_DOT,
    ACTIONS(1890), 1,
      anon_sym_quoteGoal,
    ACTIONS(1892), 1,
      anon_sym_tactic,
    ACTIONS(1894), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1896), 1,
      anon_sym_u2987,
    ACTIONS(1898), 1,
      anon_sym_let,
    ACTIONS(1902), 1,
      anon_sym_Set,
    STATE(3337), 1,
      aux_sym__atoms,
    STATE(3738), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4366), 1,
      sym_atom,
    STATE(6298), 1,
      sym_attributes,
    STATE(8032), 1,
      sym__LAMBDA,
    STATE(8379), 1,
      sym__FORALL,
    STATE(9003), 1,
      sym_expr,
    STATE(9157), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1868), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1900), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4264), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8633), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4263), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1874), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [111160] = 34,
    ACTIONS(700), 1,
      anon_sym_LBRACE_DASH_POUND,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2094), 1,
      sym_id,
    ACTIONS(2100), 1,
      anon_sym_BSLASH,
    ACTIONS(2102), 1,
      anon_sym_u03bb,
    ACTIONS(2106), 1,
      anon_sym_record,
    ACTIONS(2108), 1,
      anon_sym_LPAREN,
    ACTIONS(2110), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2112), 1,
      anon_sym_u2983,
    ACTIONS(2114), 1,
      anon_sym_LBRACE,
    ACTIONS(2116), 1,
      aux_sym__qid_token1,
    ACTIONS(2118), 1,
      anon_sym_DOT,
    ACTIONS(2120), 1,
      anon_sym_quoteGoal,
    ACTIONS(2122), 1,
      anon_sym_tactic,
    ACTIONS(2124), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2126), 1,
      anon_sym_u2987,
    ACTIONS(2128), 1,
      anon_sym_let,
    ACTIONS(2132), 1,
      anon_sym_Set,
    STATE(1489), 1,
      sym__ARROW,
    STATE(2789), 1,
      aux_sym__lambda_clauses_repeat1,
    STATE(3291), 1,
      sym_catchall_pragma,
    STATE(3471), 1,
      aux_sym__atoms,
    STATE(5601), 1,
      sym_atom,
    STATE(8075), 1,
      sym__LAMBDA,
    STATE(8428), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2096), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2098), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(2130), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5451), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(8987), 4,
      sym__lambda_clauses,
      sym__lambda_clause_maybe_absurd,
      sym_lambda_clause_absurd,
      sym_lambda_clause,
    STATE(5453), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8988), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2104), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [111292] = 36,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(11708), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [111428] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(10356), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [111564] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(9990), 1,
      sym__with_exprs,
    STATE(10954), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [111700] = 36,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(10357), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [111836] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1866), 1,
      sym_id,
    ACTIONS(1870), 1,
      anon_sym_BSLASH,
    ACTIONS(1872), 1,
      anon_sym_u03bb,
    ACTIONS(1876), 1,
      anon_sym_record,
    ACTIONS(1878), 1,
      anon_sym_LPAREN,
    ACTIONS(1880), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1882), 1,
      anon_sym_u2983,
    ACTIONS(1884), 1,
      anon_sym_LBRACE,
    ACTIONS(1886), 1,
      aux_sym__qid_token1,
    ACTIONS(1888), 1,
      anon_sym_DOT,
    ACTIONS(1890), 1,
      anon_sym_quoteGoal,
    ACTIONS(1892), 1,
      anon_sym_tactic,
    ACTIONS(1894), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1896), 1,
      anon_sym_u2987,
    ACTIONS(1898), 1,
      anon_sym_let,
    ACTIONS(1902), 1,
      anon_sym_Set,
    STATE(3337), 1,
      aux_sym__atoms,
    STATE(3738), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4366), 1,
      sym_atom,
    STATE(6298), 1,
      sym_attributes,
    STATE(8032), 1,
      sym__LAMBDA,
    STATE(8379), 1,
      sym__FORALL,
    STATE(9002), 1,
      sym_expr,
    STATE(9157), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1868), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1900), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4264), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8633), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4263), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1874), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [111972] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(10594), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [112108] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(10593), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [112244] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(10591), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [112380] = 35,
    ACTIONS(700), 1,
      anon_sym_LBRACE_DASH_POUND,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2134), 1,
      sym_id,
    ACTIONS(2140), 1,
      anon_sym_BSLASH,
    ACTIONS(2142), 1,
      anon_sym_u03bb,
    ACTIONS(2146), 1,
      anon_sym_record,
    ACTIONS(2148), 1,
      anon_sym_LPAREN,
    ACTIONS(2150), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2152), 1,
      anon_sym_u2983,
    ACTIONS(2154), 1,
      anon_sym_LBRACE,
    ACTIONS(2156), 1,
      aux_sym__qid_token1,
    ACTIONS(2158), 1,
      anon_sym_DOT,
    ACTIONS(2160), 1,
      anon_sym_quoteGoal,
    ACTIONS(2162), 1,
      anon_sym_tactic,
    ACTIONS(2164), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2166), 1,
      anon_sym_u2987,
    ACTIONS(2168), 1,
      anon_sym_let,
    ACTIONS(2172), 1,
      anon_sym_Set,
    STATE(1614), 1,
      sym__ARROW,
    STATE(2716), 1,
      aux_sym__lambda_clauses_repeat1,
    STATE(3213), 1,
      sym_catchall_pragma,
    STATE(3482), 1,
      aux_sym__atoms,
    STATE(5718), 1,
      sym_atom,
    STATE(8040), 1,
      sym__LAMBDA,
    STATE(8460), 1,
      sym__FORALL,
    STATE(8987), 1,
      sym__lambda_clauses,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2136), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2138), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(2170), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5624), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(8986), 3,
      sym__lambda_clause_maybe_absurd,
      sym_lambda_clause_absurd,
      sym_lambda_clause,
    STATE(5627), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8988), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2144), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [112514] = 36,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(10590), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [112650] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(10589), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [112786] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(10358), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [112922] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2120), 1,
      anon_sym_quoteGoal,
    ACTIONS(2128), 1,
      anon_sym_let,
    ACTIONS(2174), 1,
      sym_id,
    ACTIONS(2176), 1,
      anon_sym_BSLASH,
    ACTIONS(2178), 1,
      anon_sym_u03bb,
    ACTIONS(2182), 1,
      anon_sym_record,
    ACTIONS(2184), 1,
      anon_sym_LPAREN,
    ACTIONS(2186), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2188), 1,
      anon_sym_u2983,
    ACTIONS(2190), 1,
      anon_sym_LBRACE,
    ACTIONS(2192), 1,
      aux_sym__qid_token1,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_tactic,
    ACTIONS(2198), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2200), 1,
      anon_sym_u2987,
    ACTIONS(2204), 1,
      anon_sym_Set,
    STATE(3331), 1,
      aux_sym__atoms,
    STATE(3762), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4611), 1,
      sym_atom,
    STATE(6270), 1,
      sym_attributes,
    STATE(8044), 1,
      sym__LAMBDA,
    STATE(8428), 1,
      sym__FORALL,
    STATE(9423), 1,
      sym__with_exprs,
    STATE(9481), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2096), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4536), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8635), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4531), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2180), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [113058] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(10359), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [113194] = 36,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(10964), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [113330] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(10965), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [113466] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(10065), 1,
      sym__with_exprs,
    STATE(10342), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [113602] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(10966), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [113738] = 36,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(10628), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [113874] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(10967), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [114010] = 36,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(10968), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [114146] = 35,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(700), 1,
      anon_sym_LBRACE_DASH_POUND,
    ACTIONS(2206), 1,
      sym_id,
    ACTIONS(2212), 1,
      anon_sym_BSLASH,
    ACTIONS(2214), 1,
      anon_sym_u03bb,
    ACTIONS(2218), 1,
      anon_sym_record,
    ACTIONS(2220), 1,
      anon_sym_LPAREN,
    ACTIONS(2222), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2224), 1,
      anon_sym_u2983,
    ACTIONS(2226), 1,
      anon_sym_LBRACE,
    ACTIONS(2228), 1,
      aux_sym__qid_token1,
    ACTIONS(2230), 1,
      anon_sym_DOT,
    ACTIONS(2232), 1,
      anon_sym_quoteGoal,
    ACTIONS(2234), 1,
      anon_sym_tactic,
    ACTIONS(2236), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2238), 1,
      anon_sym_u2987,
    ACTIONS(2240), 1,
      anon_sym_let,
    ACTIONS(2244), 1,
      anon_sym_Set,
    STATE(2163), 1,
      sym__ARROW,
    STATE(2794), 1,
      aux_sym__lambda_clauses_repeat1,
    STATE(3205), 1,
      sym_catchall_pragma,
    STATE(3701), 1,
      aux_sym__atoms,
    STATE(4718), 1,
      sym_atom,
    STATE(8035), 1,
      sym__LAMBDA,
    STATE(8402), 1,
      sym__FORALL,
    STATE(8999), 1,
      sym__lambda_clauses,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2210), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(2242), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4812), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(8993), 3,
      sym__lambda_clause_maybe_absurd,
      sym_lambda_clause_absurd,
      sym_lambda_clause,
    STATE(4858), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9000), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2216), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [114280] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(10969), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [114416] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(10972), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [114552] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(11531), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [114688] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(11530), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [114824] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(11529), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [114960] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(11697), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [115096] = 36,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(11528), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [115232] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(11526), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [115368] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(11696), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [115504] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(10233), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [115640] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(11695), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [115776] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(10973), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [115912] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(11524), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [116048] = 36,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(11523), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [116184] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(10588), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [116320] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(10629), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [116456] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(10584), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [116592] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(10360), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [116728] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(9990), 1,
      sym__with_exprs,
    STATE(12763), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [116864] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(10065), 1,
      sym__with_exprs,
    STATE(12762), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [117000] = 36,
    ACTIONS(13), 1,
      anon_sym_BSLASH,
    ACTIONS(15), 1,
      anon_sym_u03bb,
    ACTIONS(75), 1,
      anon_sym_quoteGoal,
    ACTIONS(77), 1,
      anon_sym_tactic,
    ACTIONS(83), 1,
      anon_sym_let,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(2246), 1,
      sym_id,
    ACTIONS(2250), 1,
      anon_sym_record,
    ACTIONS(2252), 1,
      anon_sym_LPAREN,
    ACTIONS(2254), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2256), 1,
      anon_sym_u2983,
    ACTIONS(2258), 1,
      anon_sym_LBRACE,
    ACTIONS(2260), 1,
      aux_sym__qid_token1,
    ACTIONS(2262), 1,
      anon_sym_DOT,
    ACTIONS(2264), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2266), 1,
      anon_sym_u2987,
    ACTIONS(2270), 1,
      anon_sym_Set,
    STATE(3285), 1,
      aux_sym__atoms,
    STATE(3710), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4216), 1,
      sym_atom,
    STATE(6218), 1,
      sym_attributes,
    STATE(8114), 1,
      sym__LAMBDA,
    STATE(8288), 1,
      sym__FORALL,
    STATE(8949), 1,
      sym_expr,
    STATE(9125), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(11), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2268), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4151), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8647), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4153), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2248), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [117136] = 36,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(10583), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [117272] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2140), 1,
      anon_sym_BSLASH,
    ACTIONS(2142), 1,
      anon_sym_u03bb,
    ACTIONS(2160), 1,
      anon_sym_quoteGoal,
    ACTIONS(2162), 1,
      anon_sym_tactic,
    ACTIONS(2168), 1,
      anon_sym_let,
    ACTIONS(2272), 1,
      sym_id,
    ACTIONS(2276), 1,
      anon_sym_record,
    ACTIONS(2278), 1,
      anon_sym_LPAREN,
    ACTIONS(2280), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2282), 1,
      anon_sym_u2983,
    ACTIONS(2284), 1,
      anon_sym_LBRACE,
    ACTIONS(2286), 1,
      aux_sym__qid_token1,
    ACTIONS(2288), 1,
      anon_sym_DOT,
    ACTIONS(2290), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2292), 1,
      anon_sym_u2987,
    ACTIONS(2296), 1,
      anon_sym_Set,
    STATE(3301), 1,
      aux_sym__atoms,
    STATE(3750), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5012), 1,
      sym_atom,
    STATE(6256), 1,
      sym_attributes,
    STATE(8040), 1,
      sym__LAMBDA,
    STATE(8460), 1,
      sym__FORALL,
    STATE(8959), 1,
      sym_expr,
    STATE(9559), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2136), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2294), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5139), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8631), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5053), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2274), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [117408] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2298), 1,
      sym_id,
    ACTIONS(2302), 1,
      anon_sym_BSLASH,
    ACTIONS(2304), 1,
      anon_sym_u03bb,
    ACTIONS(2308), 1,
      anon_sym_record,
    ACTIONS(2310), 1,
      anon_sym_LPAREN,
    ACTIONS(2312), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2314), 1,
      anon_sym_u2983,
    ACTIONS(2316), 1,
      anon_sym_LBRACE,
    ACTIONS(2318), 1,
      aux_sym__qid_token1,
    ACTIONS(2320), 1,
      anon_sym_DOT,
    ACTIONS(2322), 1,
      anon_sym_quoteGoal,
    ACTIONS(2324), 1,
      anon_sym_tactic,
    ACTIONS(2326), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2328), 1,
      anon_sym_u2987,
    ACTIONS(2330), 1,
      anon_sym_let,
    ACTIONS(2334), 1,
      anon_sym_Set,
    STATE(3178), 1,
      aux_sym__atoms,
    STATE(3707), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4989), 1,
      sym_atom,
    STATE(6249), 1,
      sym_attributes,
    STATE(8138), 1,
      sym__LAMBDA,
    STATE(8476), 1,
      sym__FORALL,
    STATE(8978), 1,
      sym_expr,
    STATE(9655), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2300), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2332), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5354), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8660), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5347), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2306), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [117544] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2298), 1,
      sym_id,
    ACTIONS(2302), 1,
      anon_sym_BSLASH,
    ACTIONS(2304), 1,
      anon_sym_u03bb,
    ACTIONS(2308), 1,
      anon_sym_record,
    ACTIONS(2310), 1,
      anon_sym_LPAREN,
    ACTIONS(2312), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2314), 1,
      anon_sym_u2983,
    ACTIONS(2316), 1,
      anon_sym_LBRACE,
    ACTIONS(2318), 1,
      aux_sym__qid_token1,
    ACTIONS(2320), 1,
      anon_sym_DOT,
    ACTIONS(2322), 1,
      anon_sym_quoteGoal,
    ACTIONS(2324), 1,
      anon_sym_tactic,
    ACTIONS(2326), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2328), 1,
      anon_sym_u2987,
    ACTIONS(2330), 1,
      anon_sym_let,
    ACTIONS(2334), 1,
      anon_sym_Set,
    STATE(3178), 1,
      aux_sym__atoms,
    STATE(3707), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4989), 1,
      sym_atom,
    STATE(6249), 1,
      sym_attributes,
    STATE(8138), 1,
      sym__LAMBDA,
    STATE(8476), 1,
      sym__FORALL,
    STATE(8974), 1,
      sym_expr,
    STATE(9655), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2300), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2332), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5354), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8660), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5347), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2306), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [117680] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2298), 1,
      sym_id,
    ACTIONS(2302), 1,
      anon_sym_BSLASH,
    ACTIONS(2304), 1,
      anon_sym_u03bb,
    ACTIONS(2308), 1,
      anon_sym_record,
    ACTIONS(2310), 1,
      anon_sym_LPAREN,
    ACTIONS(2312), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2314), 1,
      anon_sym_u2983,
    ACTIONS(2316), 1,
      anon_sym_LBRACE,
    ACTIONS(2318), 1,
      aux_sym__qid_token1,
    ACTIONS(2320), 1,
      anon_sym_DOT,
    ACTIONS(2322), 1,
      anon_sym_quoteGoal,
    ACTIONS(2324), 1,
      anon_sym_tactic,
    ACTIONS(2326), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2328), 1,
      anon_sym_u2987,
    ACTIONS(2330), 1,
      anon_sym_let,
    ACTIONS(2334), 1,
      anon_sym_Set,
    STATE(3178), 1,
      aux_sym__atoms,
    STATE(3707), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4989), 1,
      sym_atom,
    STATE(6249), 1,
      sym_attributes,
    STATE(8138), 1,
      sym__LAMBDA,
    STATE(8476), 1,
      sym__FORALL,
    STATE(8951), 1,
      sym_expr,
    STATE(9655), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2300), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2332), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5354), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8660), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5347), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2306), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [117816] = 34,
    ACTIONS(692), 1,
      anon_sym_record,
    ACTIONS(694), 1,
      anon_sym_LPAREN,
    ACTIONS(696), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(698), 1,
      anon_sym_u2983,
    ACTIONS(700), 1,
      anon_sym_LBRACE_DASH_POUND,
    ACTIONS(702), 1,
      anon_sym_LBRACE,
    ACTIONS(708), 1,
      anon_sym_DOT,
    ACTIONS(718), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(720), 1,
      anon_sym_u2987,
    ACTIONS(728), 1,
      anon_sym_Set,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1928), 1,
      anon_sym_quoteGoal,
    ACTIONS(1936), 1,
      anon_sym_let,
    ACTIONS(2336), 1,
      sym_id,
    ACTIONS(2338), 1,
      anon_sym_BSLASH,
    ACTIONS(2340), 1,
      anon_sym_u03bb,
    ACTIONS(2342), 1,
      aux_sym__qid_token1,
    ACTIONS(2344), 1,
      anon_sym_tactic,
    STATE(2553), 1,
      sym__ARROW,
    STATE(2723), 1,
      aux_sym__lambda_clauses_repeat1,
    STATE(3309), 1,
      sym_catchall_pragma,
    STATE(3416), 1,
      aux_sym__atoms,
    STATE(5128), 1,
      sym_atom,
    STATE(8079), 1,
      sym__LAMBDA,
    STATE(8431), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(726), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1906), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1908), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(5069), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(8987), 4,
      sym__lambda_clauses,
      sym__lambda_clause_maybe_absurd,
      sym_lambda_clause_absurd,
      sym_lambda_clause,
    STATE(5056), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8988), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(690), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [117948] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(2346), 1,
      sym_id,
    ACTIONS(2350), 1,
      anon_sym_BSLASH,
    ACTIONS(2352), 1,
      anon_sym_u03bb,
    ACTIONS(2356), 1,
      anon_sym_record,
    ACTIONS(2358), 1,
      anon_sym_LPAREN,
    ACTIONS(2360), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2362), 1,
      anon_sym_u2983,
    ACTIONS(2364), 1,
      anon_sym_LBRACE,
    ACTIONS(2366), 1,
      aux_sym__qid_token1,
    ACTIONS(2368), 1,
      anon_sym_DOT,
    ACTIONS(2370), 1,
      anon_sym_quoteGoal,
    ACTIONS(2372), 1,
      anon_sym_tactic,
    ACTIONS(2374), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2376), 1,
      anon_sym_u2987,
    ACTIONS(2378), 1,
      anon_sym_let,
    ACTIONS(2382), 1,
      anon_sym_Set,
    STATE(3287), 1,
      aux_sym__atoms,
    STATE(3711), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4181), 1,
      sym_atom,
    STATE(6299), 1,
      sym_attributes,
    STATE(8119), 1,
      sym__LAMBDA,
    STATE(8372), 1,
      sym__FORALL,
    STATE(8957), 1,
      sym_expr,
    STATE(9076), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2348), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2380), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4180), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8640), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4192), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2354), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [118084] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(10065), 1,
      sym__with_exprs,
    STATE(11736), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [118220] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(9990), 1,
      sym__with_exprs,
    STATE(10576), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [118356] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(8978), 1,
      sym_expr,
    STATE(10050), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [118492] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(10630), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [118628] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2298), 1,
      sym_id,
    ACTIONS(2302), 1,
      anon_sym_BSLASH,
    ACTIONS(2304), 1,
      anon_sym_u03bb,
    ACTIONS(2308), 1,
      anon_sym_record,
    ACTIONS(2310), 1,
      anon_sym_LPAREN,
    ACTIONS(2312), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2314), 1,
      anon_sym_u2983,
    ACTIONS(2316), 1,
      anon_sym_LBRACE,
    ACTIONS(2318), 1,
      aux_sym__qid_token1,
    ACTIONS(2320), 1,
      anon_sym_DOT,
    ACTIONS(2322), 1,
      anon_sym_quoteGoal,
    ACTIONS(2324), 1,
      anon_sym_tactic,
    ACTIONS(2326), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2328), 1,
      anon_sym_u2987,
    ACTIONS(2330), 1,
      anon_sym_let,
    ACTIONS(2334), 1,
      anon_sym_Set,
    STATE(3178), 1,
      aux_sym__atoms,
    STATE(3707), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4989), 1,
      sym_atom,
    STATE(6249), 1,
      sym_attributes,
    STATE(8138), 1,
      sym__LAMBDA,
    STATE(8476), 1,
      sym__FORALL,
    STATE(8961), 1,
      sym_expr,
    STATE(9655), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2300), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2332), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5354), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8660), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5347), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2306), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [118764] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1980), 1,
      sym_id,
    ACTIONS(1984), 1,
      anon_sym_BSLASH,
    ACTIONS(1986), 1,
      anon_sym_u03bb,
    ACTIONS(1990), 1,
      anon_sym_record,
    ACTIONS(1992), 1,
      anon_sym_LPAREN,
    ACTIONS(1994), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1996), 1,
      anon_sym_u2983,
    ACTIONS(1998), 1,
      anon_sym_LBRACE,
    ACTIONS(2000), 1,
      aux_sym__qid_token1,
    ACTIONS(2002), 1,
      anon_sym_DOT,
    ACTIONS(2004), 1,
      anon_sym_quoteGoal,
    ACTIONS(2006), 1,
      anon_sym_tactic,
    ACTIONS(2008), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2010), 1,
      anon_sym_u2987,
    ACTIONS(2012), 1,
      anon_sym_let,
    ACTIONS(2016), 1,
      anon_sym_Set,
    STATE(3156), 1,
      aux_sym__atoms,
    STATE(3740), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4972), 1,
      sym_atom,
    STATE(6248), 1,
      sym_attributes,
    STATE(8039), 1,
      sym__LAMBDA,
    STATE(8483), 1,
      sym__FORALL,
    STATE(8974), 1,
      sym_expr,
    STATE(9685), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1982), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2014), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5336), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8659), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5185), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1988), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [118900] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(8974), 1,
      sym_expr,
    STATE(10050), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [119036] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(8951), 1,
      sym_expr,
    STATE(10050), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [119172] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2140), 1,
      anon_sym_BSLASH,
    ACTIONS(2142), 1,
      anon_sym_u03bb,
    ACTIONS(2160), 1,
      anon_sym_quoteGoal,
    ACTIONS(2162), 1,
      anon_sym_tactic,
    ACTIONS(2168), 1,
      anon_sym_let,
    ACTIONS(2272), 1,
      sym_id,
    ACTIONS(2276), 1,
      anon_sym_record,
    ACTIONS(2278), 1,
      anon_sym_LPAREN,
    ACTIONS(2280), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2282), 1,
      anon_sym_u2983,
    ACTIONS(2284), 1,
      anon_sym_LBRACE,
    ACTIONS(2286), 1,
      aux_sym__qid_token1,
    ACTIONS(2288), 1,
      anon_sym_DOT,
    ACTIONS(2290), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2292), 1,
      anon_sym_u2987,
    ACTIONS(2296), 1,
      anon_sym_Set,
    STATE(3301), 1,
      aux_sym__atoms,
    STATE(3750), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5012), 1,
      sym_atom,
    STATE(6256), 1,
      sym_attributes,
    STATE(8040), 1,
      sym__LAMBDA,
    STATE(8460), 1,
      sym__FORALL,
    STATE(8992), 1,
      sym_expr,
    STATE(9559), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2136), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2294), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5139), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8631), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5053), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2274), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [119308] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1980), 1,
      sym_id,
    ACTIONS(1984), 1,
      anon_sym_BSLASH,
    ACTIONS(1986), 1,
      anon_sym_u03bb,
    ACTIONS(1990), 1,
      anon_sym_record,
    ACTIONS(1992), 1,
      anon_sym_LPAREN,
    ACTIONS(1994), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1996), 1,
      anon_sym_u2983,
    ACTIONS(1998), 1,
      anon_sym_LBRACE,
    ACTIONS(2000), 1,
      aux_sym__qid_token1,
    ACTIONS(2002), 1,
      anon_sym_DOT,
    ACTIONS(2004), 1,
      anon_sym_quoteGoal,
    ACTIONS(2006), 1,
      anon_sym_tactic,
    ACTIONS(2008), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2010), 1,
      anon_sym_u2987,
    ACTIONS(2012), 1,
      anon_sym_let,
    ACTIONS(2016), 1,
      anon_sym_Set,
    STATE(3156), 1,
      aux_sym__atoms,
    STATE(3740), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4972), 1,
      sym_atom,
    STATE(6248), 1,
      sym_attributes,
    STATE(8039), 1,
      sym__LAMBDA,
    STATE(8483), 1,
      sym__FORALL,
    STATE(8978), 1,
      sym_expr,
    STATE(9685), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1982), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2014), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5336), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8659), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5185), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1988), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [119444] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2018), 1,
      sym_id,
    ACTIONS(2022), 1,
      anon_sym_BSLASH,
    ACTIONS(2024), 1,
      anon_sym_u03bb,
    ACTIONS(2028), 1,
      anon_sym_record,
    ACTIONS(2030), 1,
      anon_sym_LPAREN,
    ACTIONS(2032), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2034), 1,
      anon_sym_u2983,
    ACTIONS(2036), 1,
      anon_sym_LBRACE,
    ACTIONS(2038), 1,
      aux_sym__qid_token1,
    ACTIONS(2040), 1,
      anon_sym_DOT,
    ACTIONS(2042), 1,
      anon_sym_quoteGoal,
    ACTIONS(2044), 1,
      anon_sym_tactic,
    ACTIONS(2046), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2048), 1,
      anon_sym_u2987,
    ACTIONS(2050), 1,
      anon_sym_let,
    ACTIONS(2054), 1,
      anon_sym_Set,
    STATE(3271), 1,
      aux_sym__atoms,
    STATE(3748), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4997), 1,
      sym_atom,
    STATE(6254), 1,
      sym_attributes,
    STATE(8033), 1,
      sym__LAMBDA,
    STATE(8463), 1,
      sym__FORALL,
    STATE(8959), 1,
      sym_expr,
    STATE(9607), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2020), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2052), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5176), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8669), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5183), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2026), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [119580] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(8961), 1,
      sym_expr,
    STATE(10050), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [119716] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(10065), 1,
      sym__with_exprs,
    STATE(11571), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [119852] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(9990), 1,
      sym__with_exprs,
    STATE(11572), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [119988] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(2384), 1,
      sym_id,
    ACTIONS(2388), 1,
      anon_sym_BSLASH,
    ACTIONS(2390), 1,
      anon_sym_u03bb,
    ACTIONS(2394), 1,
      anon_sym_record,
    ACTIONS(2396), 1,
      anon_sym_LPAREN,
    ACTIONS(2398), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2400), 1,
      anon_sym_u2983,
    ACTIONS(2402), 1,
      anon_sym_LBRACE,
    ACTIONS(2404), 1,
      aux_sym__qid_token1,
    ACTIONS(2406), 1,
      anon_sym_DOT,
    ACTIONS(2408), 1,
      anon_sym_quoteGoal,
    ACTIONS(2410), 1,
      anon_sym_tactic,
    ACTIONS(2412), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2414), 1,
      anon_sym_u2987,
    ACTIONS(2416), 1,
      anon_sym_let,
    ACTIONS(2420), 1,
      anon_sym_Set,
    STATE(3210), 1,
      aux_sym__atoms,
    STATE(3752), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4775), 1,
      sym_atom,
    STATE(6209), 1,
      sym_attributes,
    STATE(8139), 1,
      sym__LAMBDA,
    STATE(8518), 1,
      sym__FORALL,
    STATE(8941), 1,
      sym_expr,
    STATE(9440), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2386), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2418), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4831), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8636), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4896), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2392), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [120124] = 34,
    ACTIONS(700), 1,
      anon_sym_LBRACE_DASH_POUND,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2422), 1,
      sym_id,
    ACTIONS(2428), 1,
      anon_sym_BSLASH,
    ACTIONS(2430), 1,
      anon_sym_u03bb,
    ACTIONS(2434), 1,
      anon_sym_record,
    ACTIONS(2436), 1,
      anon_sym_LPAREN,
    ACTIONS(2438), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2440), 1,
      anon_sym_u2983,
    ACTIONS(2442), 1,
      anon_sym_LBRACE,
    ACTIONS(2444), 1,
      aux_sym__qid_token1,
    ACTIONS(2446), 1,
      anon_sym_DOT,
    ACTIONS(2448), 1,
      anon_sym_quoteGoal,
    ACTIONS(2450), 1,
      anon_sym_tactic,
    ACTIONS(2452), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2454), 1,
      anon_sym_u2987,
    ACTIONS(2456), 1,
      anon_sym_let,
    ACTIONS(2460), 1,
      anon_sym_Set,
    STATE(2007), 1,
      sym__ARROW,
    STATE(2809), 1,
      aux_sym__lambda_clauses_repeat1,
    STATE(3222), 1,
      sym_catchall_pragma,
    STATE(3588), 1,
      aux_sym__atoms,
    STATE(5596), 1,
      sym_atom,
    STATE(8125), 1,
      sym__LAMBDA,
    STATE(8423), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2424), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2426), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(2458), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5422), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(8987), 4,
      sym__lambda_clauses,
      sym__lambda_clause_maybe_absurd,
      sym_lambda_clause_absurd,
      sym_lambda_clause,
    STATE(5423), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8988), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2432), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [120256] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2120), 1,
      anon_sym_quoteGoal,
    ACTIONS(2128), 1,
      anon_sym_let,
    ACTIONS(2174), 1,
      sym_id,
    ACTIONS(2176), 1,
      anon_sym_BSLASH,
    ACTIONS(2178), 1,
      anon_sym_u03bb,
    ACTIONS(2182), 1,
      anon_sym_record,
    ACTIONS(2184), 1,
      anon_sym_LPAREN,
    ACTIONS(2186), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2188), 1,
      anon_sym_u2983,
    ACTIONS(2190), 1,
      anon_sym_LBRACE,
    ACTIONS(2192), 1,
      aux_sym__qid_token1,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_tactic,
    ACTIONS(2198), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2200), 1,
      anon_sym_u2987,
    ACTIONS(2204), 1,
      anon_sym_Set,
    STATE(3331), 1,
      aux_sym__atoms,
    STATE(3762), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4611), 1,
      sym_atom,
    STATE(6270), 1,
      sym_attributes,
    STATE(8044), 1,
      sym__LAMBDA,
    STATE(8428), 1,
      sym__FORALL,
    STATE(9423), 1,
      sym__with_exprs,
    STATE(9479), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2096), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4536), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8635), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4531), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2180), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [120392] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(2346), 1,
      sym_id,
    ACTIONS(2350), 1,
      anon_sym_BSLASH,
    ACTIONS(2352), 1,
      anon_sym_u03bb,
    ACTIONS(2356), 1,
      anon_sym_record,
    ACTIONS(2358), 1,
      anon_sym_LPAREN,
    ACTIONS(2360), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2362), 1,
      anon_sym_u2983,
    ACTIONS(2364), 1,
      anon_sym_LBRACE,
    ACTIONS(2366), 1,
      aux_sym__qid_token1,
    ACTIONS(2368), 1,
      anon_sym_DOT,
    ACTIONS(2370), 1,
      anon_sym_quoteGoal,
    ACTIONS(2372), 1,
      anon_sym_tactic,
    ACTIONS(2374), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2376), 1,
      anon_sym_u2987,
    ACTIONS(2378), 1,
      anon_sym_let,
    ACTIONS(2382), 1,
      anon_sym_Set,
    STATE(3287), 1,
      aux_sym__atoms,
    STATE(3711), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4181), 1,
      sym_atom,
    STATE(6299), 1,
      sym_attributes,
    STATE(8119), 1,
      sym__LAMBDA,
    STATE(8372), 1,
      sym__FORALL,
    STATE(9003), 1,
      sym_expr,
    STATE(9076), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2348), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2380), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4180), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8640), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4192), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2354), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [120528] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(109), 1,
      anon_sym_BSLASH,
    ACTIONS(111), 1,
      anon_sym_u03bb,
    ACTIONS(147), 1,
      anon_sym_quoteGoal,
    ACTIONS(149), 1,
      anon_sym_tactic,
    ACTIONS(155), 1,
      anon_sym_let,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(2462), 1,
      sym_id,
    ACTIONS(2466), 1,
      anon_sym_record,
    ACTIONS(2468), 1,
      anon_sym_LPAREN,
    ACTIONS(2470), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2472), 1,
      anon_sym_u2983,
    ACTIONS(2474), 1,
      anon_sym_LBRACE,
    ACTIONS(2476), 1,
      aux_sym__qid_token1,
    ACTIONS(2478), 1,
      anon_sym_DOT,
    ACTIONS(2480), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2482), 1,
      anon_sym_u2987,
    ACTIONS(2486), 1,
      anon_sym_Set,
    STATE(3259), 1,
      aux_sym__atoms,
    STATE(3734), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4054), 1,
      sym_atom,
    STATE(6260), 1,
      sym_attributes,
    STATE(8146), 1,
      sym__LAMBDA,
    STATE(8343), 1,
      sym__FORALL,
    STATE(8939), 1,
      sym_expr,
    STATE(9017), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(107), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2484), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4044), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8667), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4052), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2464), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [120664] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2018), 1,
      sym_id,
    ACTIONS(2022), 1,
      anon_sym_BSLASH,
    ACTIONS(2024), 1,
      anon_sym_u03bb,
    ACTIONS(2028), 1,
      anon_sym_record,
    ACTIONS(2030), 1,
      anon_sym_LPAREN,
    ACTIONS(2032), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2034), 1,
      anon_sym_u2983,
    ACTIONS(2036), 1,
      anon_sym_LBRACE,
    ACTIONS(2038), 1,
      aux_sym__qid_token1,
    ACTIONS(2040), 1,
      anon_sym_DOT,
    ACTIONS(2042), 1,
      anon_sym_quoteGoal,
    ACTIONS(2044), 1,
      anon_sym_tactic,
    ACTIONS(2046), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2048), 1,
      anon_sym_u2987,
    ACTIONS(2050), 1,
      anon_sym_let,
    ACTIONS(2054), 1,
      anon_sym_Set,
    STATE(3271), 1,
      aux_sym__atoms,
    STATE(3748), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4997), 1,
      sym_atom,
    STATE(6254), 1,
      sym_attributes,
    STATE(8033), 1,
      sym__LAMBDA,
    STATE(8463), 1,
      sym__FORALL,
    STATE(8937), 1,
      sym_expr,
    STATE(9607), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2020), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2052), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5176), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8669), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5183), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2026), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [120800] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(10065), 1,
      sym__with_exprs,
    STATE(10575), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [120936] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2488), 1,
      sym_id,
    ACTIONS(2492), 1,
      anon_sym_BSLASH,
    ACTIONS(2494), 1,
      anon_sym_u03bb,
    ACTIONS(2498), 1,
      anon_sym_record,
    ACTIONS(2500), 1,
      anon_sym_LPAREN,
    ACTIONS(2502), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2504), 1,
      anon_sym_u2983,
    ACTIONS(2506), 1,
      anon_sym_LBRACE,
    ACTIONS(2508), 1,
      aux_sym__qid_token1,
    ACTIONS(2510), 1,
      anon_sym_DOT,
    ACTIONS(2512), 1,
      anon_sym_quoteGoal,
    ACTIONS(2514), 1,
      anon_sym_tactic,
    ACTIONS(2516), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2518), 1,
      anon_sym_u2987,
    ACTIONS(2520), 1,
      anon_sym_let,
    ACTIONS(2524), 1,
      anon_sym_Set,
    STATE(3193), 1,
      aux_sym__atoms,
    STATE(3709), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5643), 1,
      sym_atom,
    STATE(6216), 1,
      sym_attributes,
    STATE(8096), 1,
      sym__LAMBDA,
    STATE(8497), 1,
      sym__FORALL,
    STATE(8992), 1,
      sym_expr,
    STATE(10138), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2490), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2522), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5713), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8645), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5698), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2496), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [121072] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(2346), 1,
      sym_id,
    ACTIONS(2350), 1,
      anon_sym_BSLASH,
    ACTIONS(2352), 1,
      anon_sym_u03bb,
    ACTIONS(2356), 1,
      anon_sym_record,
    ACTIONS(2358), 1,
      anon_sym_LPAREN,
    ACTIONS(2360), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2362), 1,
      anon_sym_u2983,
    ACTIONS(2364), 1,
      anon_sym_LBRACE,
    ACTIONS(2366), 1,
      aux_sym__qid_token1,
    ACTIONS(2368), 1,
      anon_sym_DOT,
    ACTIONS(2370), 1,
      anon_sym_quoteGoal,
    ACTIONS(2372), 1,
      anon_sym_tactic,
    ACTIONS(2374), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2376), 1,
      anon_sym_u2987,
    ACTIONS(2378), 1,
      anon_sym_let,
    ACTIONS(2382), 1,
      anon_sym_Set,
    STATE(3287), 1,
      aux_sym__atoms,
    STATE(3711), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4181), 1,
      sym_atom,
    STATE(6299), 1,
      sym_attributes,
    STATE(8119), 1,
      sym__LAMBDA,
    STATE(8372), 1,
      sym__FORALL,
    STATE(9002), 1,
      sym_expr,
    STATE(9076), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2348), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2380), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4180), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8640), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4192), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2354), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [121208] = 36,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(894), 1,
      sym_id,
    ACTIONS(898), 1,
      anon_sym_BSLASH,
    ACTIONS(900), 1,
      anon_sym_u03bb,
    ACTIONS(904), 1,
      anon_sym_record,
    ACTIONS(906), 1,
      anon_sym_LPAREN,
    ACTIONS(908), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(910), 1,
      anon_sym_u2983,
    ACTIONS(912), 1,
      anon_sym_LBRACE,
    ACTIONS(916), 1,
      aux_sym__qid_token1,
    ACTIONS(918), 1,
      anon_sym_DOT,
    ACTIONS(920), 1,
      anon_sym_quoteGoal,
    ACTIONS(922), 1,
      anon_sym_tactic,
    ACTIONS(924), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(926), 1,
      anon_sym_u2987,
    ACTIONS(928), 1,
      anon_sym_let,
    ACTIONS(932), 1,
      anon_sym_Set,
    STATE(3138), 1,
      aux_sym__atoms,
    STATE(3718), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5202), 1,
      sym_atom,
    STATE(6274), 1,
      sym_attributes,
    STATE(8031), 1,
      sym__LAMBDA,
    STATE(8396), 1,
      sym__FORALL,
    STATE(9475), 1,
      sym_expr,
    STATE(9527), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(930), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4961), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8678), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4920), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(902), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [121344] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2120), 1,
      anon_sym_quoteGoal,
    ACTIONS(2128), 1,
      anon_sym_let,
    ACTIONS(2174), 1,
      sym_id,
    ACTIONS(2176), 1,
      anon_sym_BSLASH,
    ACTIONS(2178), 1,
      anon_sym_u03bb,
    ACTIONS(2182), 1,
      anon_sym_record,
    ACTIONS(2184), 1,
      anon_sym_LPAREN,
    ACTIONS(2186), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2188), 1,
      anon_sym_u2983,
    ACTIONS(2190), 1,
      anon_sym_LBRACE,
    ACTIONS(2192), 1,
      aux_sym__qid_token1,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_tactic,
    ACTIONS(2198), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2200), 1,
      anon_sym_u2987,
    ACTIONS(2204), 1,
      anon_sym_Set,
    STATE(3331), 1,
      aux_sym__atoms,
    STATE(3762), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4611), 1,
      sym_atom,
    STATE(6270), 1,
      sym_attributes,
    STATE(8044), 1,
      sym__LAMBDA,
    STATE(8428), 1,
      sym__FORALL,
    STATE(9423), 1,
      sym__with_exprs,
    STATE(9471), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2096), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4536), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8635), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4531), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2180), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [121480] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(10065), 1,
      sym__with_exprs,
    STATE(10990), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [121616] = 36,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(894), 1,
      sym_id,
    ACTIONS(898), 1,
      anon_sym_BSLASH,
    ACTIONS(900), 1,
      anon_sym_u03bb,
    ACTIONS(904), 1,
      anon_sym_record,
    ACTIONS(906), 1,
      anon_sym_LPAREN,
    ACTIONS(908), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(910), 1,
      anon_sym_u2983,
    ACTIONS(912), 1,
      anon_sym_LBRACE,
    ACTIONS(916), 1,
      aux_sym__qid_token1,
    ACTIONS(918), 1,
      anon_sym_DOT,
    ACTIONS(920), 1,
      anon_sym_quoteGoal,
    ACTIONS(922), 1,
      anon_sym_tactic,
    ACTIONS(924), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(926), 1,
      anon_sym_u2987,
    ACTIONS(928), 1,
      anon_sym_let,
    ACTIONS(932), 1,
      anon_sym_Set,
    STATE(3138), 1,
      aux_sym__atoms,
    STATE(3718), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5202), 1,
      sym_atom,
    STATE(6274), 1,
      sym_attributes,
    STATE(8031), 1,
      sym__LAMBDA,
    STATE(8396), 1,
      sym__FORALL,
    STATE(9415), 1,
      sym_expr,
    STATE(9527), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(930), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4961), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8678), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4920), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(902), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [121752] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(10556), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [121888] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(10065), 1,
      sym__with_exprs,
    STATE(11661), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [122024] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(10554), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [122160] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2018), 1,
      sym_id,
    ACTIONS(2022), 1,
      anon_sym_BSLASH,
    ACTIONS(2024), 1,
      anon_sym_u03bb,
    ACTIONS(2028), 1,
      anon_sym_record,
    ACTIONS(2030), 1,
      anon_sym_LPAREN,
    ACTIONS(2032), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2034), 1,
      anon_sym_u2983,
    ACTIONS(2036), 1,
      anon_sym_LBRACE,
    ACTIONS(2038), 1,
      aux_sym__qid_token1,
    ACTIONS(2040), 1,
      anon_sym_DOT,
    ACTIONS(2042), 1,
      anon_sym_quoteGoal,
    ACTIONS(2044), 1,
      anon_sym_tactic,
    ACTIONS(2046), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2048), 1,
      anon_sym_u2987,
    ACTIONS(2050), 1,
      anon_sym_let,
    ACTIONS(2054), 1,
      anon_sym_Set,
    STATE(3271), 1,
      aux_sym__atoms,
    STATE(3748), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4997), 1,
      sym_atom,
    STATE(6254), 1,
      sym_attributes,
    STATE(8033), 1,
      sym__LAMBDA,
    STATE(8463), 1,
      sym__FORALL,
    STATE(8945), 1,
      sym_expr,
    STATE(9607), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2020), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2052), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5176), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8669), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5183), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2026), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [122296] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(10322), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [122432] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(10321), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [122568] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(10320), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [122704] = 36,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(10319), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [122840] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(9990), 1,
      sym__with_exprs,
    STATE(11660), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [122976] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(9990), 1,
      sym__with_exprs,
    STATE(10991), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [123112] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(10318), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [123248] = 35,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(700), 1,
      anon_sym_LBRACE_DASH_POUND,
    ACTIONS(2526), 1,
      sym_id,
    ACTIONS(2532), 1,
      anon_sym_BSLASH,
    ACTIONS(2534), 1,
      anon_sym_u03bb,
    ACTIONS(2538), 1,
      anon_sym_record,
    ACTIONS(2540), 1,
      anon_sym_LPAREN,
    ACTIONS(2542), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2544), 1,
      anon_sym_u2983,
    ACTIONS(2546), 1,
      anon_sym_LBRACE,
    ACTIONS(2548), 1,
      aux_sym__qid_token1,
    ACTIONS(2550), 1,
      anon_sym_DOT,
    ACTIONS(2552), 1,
      anon_sym_quoteGoal,
    ACTIONS(2554), 1,
      anon_sym_tactic,
    ACTIONS(2556), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2558), 1,
      anon_sym_u2987,
    ACTIONS(2560), 1,
      anon_sym_let,
    ACTIONS(2564), 1,
      anon_sym_Set,
    STATE(1938), 1,
      sym__ARROW,
    STATE(2784), 1,
      aux_sym__lambda_clauses_repeat1,
    STATE(3281), 1,
      sym_catchall_pragma,
    STATE(3610), 1,
      aux_sym__atoms,
    STATE(4603), 1,
      sym_atom,
    STATE(8066), 1,
      sym__LAMBDA,
    STATE(8398), 1,
      sym__FORALL,
    STATE(8999), 1,
      sym__lambda_clauses,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2528), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2530), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(2562), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4464), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(8993), 3,
      sym__lambda_clause_maybe_absurd,
      sym_lambda_clause_absurd,
      sym_lambda_clause,
    STATE(4473), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9000), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2536), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [123382] = 36,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(11646), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [123518] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(11636), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [123654] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(2566), 1,
      sym_id,
    ACTIONS(2570), 1,
      anon_sym_BSLASH,
    ACTIONS(2572), 1,
      anon_sym_u03bb,
    ACTIONS(2576), 1,
      anon_sym_record,
    ACTIONS(2578), 1,
      anon_sym_LPAREN,
    ACTIONS(2580), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2582), 1,
      anon_sym_u2983,
    ACTIONS(2584), 1,
      anon_sym_LBRACE,
    ACTIONS(2586), 1,
      aux_sym__qid_token1,
    ACTIONS(2588), 1,
      anon_sym_DOT,
    ACTIONS(2590), 1,
      anon_sym_quoteGoal,
    ACTIONS(2592), 1,
      anon_sym_tactic,
    ACTIONS(2594), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2596), 1,
      anon_sym_u2987,
    ACTIONS(2598), 1,
      anon_sym_let,
    ACTIONS(2602), 1,
      anon_sym_Set,
    STATE(3214), 1,
      aux_sym__atoms,
    STATE(3714), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5536), 1,
      sym_atom,
    STATE(6208), 1,
      sym_attributes,
    STATE(8111), 1,
      sym__LAMBDA,
    STATE(8412), 1,
      sym__FORALL,
    STATE(8949), 1,
      sym_expr,
    STATE(10191), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2568), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2600), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5566), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8634), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5590), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2574), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [123790] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(11635), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [123926] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(11634), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [124062] = 36,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(11633), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [124198] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(11632), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [124334] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(10317), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [124470] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(10316), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [124606] = 34,
    ACTIONS(686), 1,
      anon_sym_BSLASH,
    ACTIONS(688), 1,
      anon_sym_u03bb,
    ACTIONS(692), 1,
      anon_sym_record,
    ACTIONS(694), 1,
      anon_sym_LPAREN,
    ACTIONS(696), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(698), 1,
      anon_sym_u2983,
    ACTIONS(700), 1,
      anon_sym_LBRACE_DASH_POUND,
    ACTIONS(702), 1,
      anon_sym_LBRACE,
    ACTIONS(708), 1,
      anon_sym_DOT,
    ACTIONS(714), 1,
      anon_sym_quoteGoal,
    ACTIONS(716), 1,
      anon_sym_tactic,
    ACTIONS(718), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(720), 1,
      anon_sym_u2987,
    ACTIONS(722), 1,
      anon_sym_let,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(728), 1,
      anon_sym_Set,
    ACTIONS(2336), 1,
      sym_id,
    ACTIONS(2342), 1,
      aux_sym__qid_token1,
    STATE(2651), 1,
      sym__ARROW,
    STATE(2772), 1,
      aux_sym__lambda_clauses_repeat1,
    STATE(3132), 1,
      sym_catchall_pragma,
    STATE(3688), 1,
      aux_sym__atoms,
    STATE(5128), 1,
      sym_atom,
    STATE(8064), 1,
      sym__LAMBDA,
    STATE(8495), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(682), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(726), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(2604), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(5069), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(9460), 4,
      sym__lambda_clauses,
      sym__lambda_clause_maybe_absurd,
      sym_lambda_clause_absurd,
      sym_lambda_clause,
    STATE(5056), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9459), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(690), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [124738] = 36,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(894), 1,
      sym_id,
    ACTIONS(898), 1,
      anon_sym_BSLASH,
    ACTIONS(900), 1,
      anon_sym_u03bb,
    ACTIONS(904), 1,
      anon_sym_record,
    ACTIONS(906), 1,
      anon_sym_LPAREN,
    ACTIONS(908), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(910), 1,
      anon_sym_u2983,
    ACTIONS(912), 1,
      anon_sym_LBRACE,
    ACTIONS(916), 1,
      aux_sym__qid_token1,
    ACTIONS(918), 1,
      anon_sym_DOT,
    ACTIONS(920), 1,
      anon_sym_quoteGoal,
    ACTIONS(922), 1,
      anon_sym_tactic,
    ACTIONS(924), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(926), 1,
      anon_sym_u2987,
    ACTIONS(928), 1,
      anon_sym_let,
    ACTIONS(932), 1,
      anon_sym_Set,
    STATE(3138), 1,
      aux_sym__atoms,
    STATE(3718), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5202), 1,
      sym_atom,
    STATE(6274), 1,
      sym_attributes,
    STATE(8031), 1,
      sym__LAMBDA,
    STATE(8396), 1,
      sym__FORALL,
    STATE(9405), 1,
      sym_expr,
    STATE(9527), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(930), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4961), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8678), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4920), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(902), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [124874] = 36,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(10315), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [125010] = 36,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(894), 1,
      sym_id,
    ACTIONS(898), 1,
      anon_sym_BSLASH,
    ACTIONS(900), 1,
      anon_sym_u03bb,
    ACTIONS(904), 1,
      anon_sym_record,
    ACTIONS(906), 1,
      anon_sym_LPAREN,
    ACTIONS(908), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(910), 1,
      anon_sym_u2983,
    ACTIONS(912), 1,
      anon_sym_LBRACE,
    ACTIONS(916), 1,
      aux_sym__qid_token1,
    ACTIONS(918), 1,
      anon_sym_DOT,
    ACTIONS(920), 1,
      anon_sym_quoteGoal,
    ACTIONS(922), 1,
      anon_sym_tactic,
    ACTIONS(924), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(926), 1,
      anon_sym_u2987,
    ACTIONS(928), 1,
      anon_sym_let,
    ACTIONS(932), 1,
      anon_sym_Set,
    STATE(3138), 1,
      aux_sym__atoms,
    STATE(3718), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5202), 1,
      sym_atom,
    STATE(6274), 1,
      sym_attributes,
    STATE(8031), 1,
      sym__LAMBDA,
    STATE(8396), 1,
      sym__FORALL,
    STATE(9466), 1,
      sym_expr,
    STATE(9527), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(930), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4961), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8678), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4920), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(902), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [125146] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(8961), 1,
      sym_expr,
    STATE(10065), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [125282] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2488), 1,
      sym_id,
    ACTIONS(2492), 1,
      anon_sym_BSLASH,
    ACTIONS(2494), 1,
      anon_sym_u03bb,
    ACTIONS(2498), 1,
      anon_sym_record,
    ACTIONS(2500), 1,
      anon_sym_LPAREN,
    ACTIONS(2502), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2504), 1,
      anon_sym_u2983,
    ACTIONS(2506), 1,
      anon_sym_LBRACE,
    ACTIONS(2508), 1,
      aux_sym__qid_token1,
    ACTIONS(2510), 1,
      anon_sym_DOT,
    ACTIONS(2512), 1,
      anon_sym_quoteGoal,
    ACTIONS(2514), 1,
      anon_sym_tactic,
    ACTIONS(2516), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2518), 1,
      anon_sym_u2987,
    ACTIONS(2520), 1,
      anon_sym_let,
    ACTIONS(2524), 1,
      anon_sym_Set,
    STATE(3193), 1,
      aux_sym__atoms,
    STATE(3709), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5643), 1,
      sym_atom,
    STATE(6216), 1,
      sym_attributes,
    STATE(8096), 1,
      sym__LAMBDA,
    STATE(8497), 1,
      sym__FORALL,
    STATE(8959), 1,
      sym_expr,
    STATE(10138), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2490), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2522), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5713), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8645), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5698), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2496), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [125418] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(10550), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [125554] = 36,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(10549), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [125690] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(10548), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [125826] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2018), 1,
      sym_id,
    ACTIONS(2022), 1,
      anon_sym_BSLASH,
    ACTIONS(2024), 1,
      anon_sym_u03bb,
    ACTIONS(2028), 1,
      anon_sym_record,
    ACTIONS(2030), 1,
      anon_sym_LPAREN,
    ACTIONS(2032), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2034), 1,
      anon_sym_u2983,
    ACTIONS(2036), 1,
      anon_sym_LBRACE,
    ACTIONS(2038), 1,
      aux_sym__qid_token1,
    ACTIONS(2040), 1,
      anon_sym_DOT,
    ACTIONS(2042), 1,
      anon_sym_quoteGoal,
    ACTIONS(2044), 1,
      anon_sym_tactic,
    ACTIONS(2046), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2048), 1,
      anon_sym_u2987,
    ACTIONS(2050), 1,
      anon_sym_let,
    ACTIONS(2054), 1,
      anon_sym_Set,
    STATE(3271), 1,
      aux_sym__atoms,
    STATE(3748), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4997), 1,
      sym_atom,
    STATE(6254), 1,
      sym_attributes,
    STATE(8033), 1,
      sym__LAMBDA,
    STATE(8463), 1,
      sym__FORALL,
    STATE(8970), 1,
      sym_expr,
    STATE(9607), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2020), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2052), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5176), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8669), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5183), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2026), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [125962] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(8951), 1,
      sym_expr,
    STATE(10065), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [126098] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(11622), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [126234] = 35,
    ACTIONS(700), 1,
      anon_sym_LBRACE_DASH_POUND,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1916), 1,
      anon_sym_record,
    ACTIONS(1918), 1,
      anon_sym_LPAREN,
    ACTIONS(1920), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1922), 1,
      anon_sym_u2983,
    ACTIONS(1924), 1,
      anon_sym_LBRACE,
    ACTIONS(1932), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1934), 1,
      anon_sym_u2987,
    ACTIONS(2120), 1,
      anon_sym_quoteGoal,
    ACTIONS(2128), 1,
      anon_sym_let,
    ACTIONS(2176), 1,
      anon_sym_BSLASH,
    ACTIONS(2178), 1,
      anon_sym_u03bb,
    ACTIONS(2196), 1,
      anon_sym_tactic,
    ACTIONS(2606), 1,
      sym_id,
    ACTIONS(2608), 1,
      aux_sym__qid_token1,
    ACTIONS(2610), 1,
      anon_sym_DOT,
    ACTIONS(2612), 1,
      anon_sym_Set,
    STATE(1489), 1,
      sym__ARROW,
    STATE(2785), 1,
      aux_sym__lambda_clauses_repeat1,
    STATE(3135), 1,
      sym_catchall_pragma,
    STATE(3507), 1,
      aux_sym__atoms,
    STATE(4914), 1,
      sym_atom,
    STATE(8044), 1,
      sym__LAMBDA,
    STATE(8428), 1,
      sym__FORALL,
    STATE(8987), 1,
      sym__lambda_clauses,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1938), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(2096), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2098), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(4675), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(9461), 3,
      sym__lambda_clause_maybe_absurd,
      sym_lambda_clause_absurd,
      sym_lambda_clause,
    STATE(4679), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8988), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1914), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [126368] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(9990), 1,
      sym__with_exprs,
    STATE(10304), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [126504] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(10065), 1,
      sym__with_exprs,
    STATE(10303), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [126640] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(10547), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [126776] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(10631), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [126912] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(10546), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [127048] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(11621), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [127184] = 36,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(10545), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [127320] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(8974), 1,
      sym_expr,
    STATE(10065), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [127456] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(8978), 1,
      sym_expr,
    STATE(10065), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [127592] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(10936), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [127728] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(10065), 1,
      sym__with_exprs,
    STATE(10536), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [127864] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(2566), 1,
      sym_id,
    ACTIONS(2570), 1,
      anon_sym_BSLASH,
    ACTIONS(2572), 1,
      anon_sym_u03bb,
    ACTIONS(2576), 1,
      anon_sym_record,
    ACTIONS(2578), 1,
      anon_sym_LPAREN,
    ACTIONS(2580), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2582), 1,
      anon_sym_u2983,
    ACTIONS(2584), 1,
      anon_sym_LBRACE,
    ACTIONS(2586), 1,
      aux_sym__qid_token1,
    ACTIONS(2588), 1,
      anon_sym_DOT,
    ACTIONS(2590), 1,
      anon_sym_quoteGoal,
    ACTIONS(2592), 1,
      anon_sym_tactic,
    ACTIONS(2594), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2596), 1,
      anon_sym_u2987,
    ACTIONS(2598), 1,
      anon_sym_let,
    ACTIONS(2602), 1,
      anon_sym_Set,
    STATE(3214), 1,
      aux_sym__atoms,
    STATE(3714), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5536), 1,
      sym_atom,
    STATE(6208), 1,
      sym_attributes,
    STATE(8111), 1,
      sym__LAMBDA,
    STATE(8412), 1,
      sym__FORALL,
    STATE(8941), 1,
      sym_expr,
    STATE(10191), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2568), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2600), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5566), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8634), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5590), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2574), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [128000] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(2614), 1,
      sym_id,
    ACTIONS(2618), 1,
      anon_sym_BSLASH,
    ACTIONS(2620), 1,
      anon_sym_u03bb,
    ACTIONS(2624), 1,
      anon_sym_record,
    ACTIONS(2626), 1,
      anon_sym_LPAREN,
    ACTIONS(2628), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2630), 1,
      anon_sym_u2983,
    ACTIONS(2632), 1,
      anon_sym_LBRACE,
    ACTIONS(2634), 1,
      aux_sym__qid_token1,
    ACTIONS(2636), 1,
      anon_sym_DOT,
    ACTIONS(2638), 1,
      anon_sym_quoteGoal,
    ACTIONS(2640), 1,
      anon_sym_tactic,
    ACTIONS(2642), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2644), 1,
      anon_sym_u2987,
    ACTIONS(2646), 1,
      anon_sym_let,
    ACTIONS(2650), 1,
      anon_sym_Set,
    STATE(3343), 1,
      aux_sym__atoms,
    STATE(3758), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4849), 1,
      sym_atom,
    STATE(6258), 1,
      sym_attributes,
    STATE(8093), 1,
      sym__LAMBDA,
    STATE(8414), 1,
      sym__FORALL,
    STATE(8941), 1,
      sym_expr,
    STATE(9445), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2616), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2648), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4799), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8666), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4784), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2622), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [128136] = 36,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(2652), 1,
      sym_id,
    ACTIONS(2656), 1,
      anon_sym_BSLASH,
    ACTIONS(2658), 1,
      anon_sym_u03bb,
    ACTIONS(2662), 1,
      anon_sym_record,
    ACTIONS(2664), 1,
      anon_sym_LPAREN,
    ACTIONS(2666), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2668), 1,
      anon_sym_u2983,
    ACTIONS(2670), 1,
      anon_sym_LBRACE,
    ACTIONS(2672), 1,
      aux_sym__qid_token1,
    ACTIONS(2674), 1,
      anon_sym_DOT,
    ACTIONS(2676), 1,
      anon_sym_quoteGoal,
    ACTIONS(2678), 1,
      anon_sym_tactic,
    ACTIONS(2680), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2682), 1,
      anon_sym_u2987,
    ACTIONS(2684), 1,
      anon_sym_let,
    ACTIONS(2688), 1,
      anon_sym_Set,
    STATE(3243), 1,
      aux_sym__atoms,
    STATE(3732), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4916), 1,
      sym_atom,
    STATE(6233), 1,
      sym_attributes,
    STATE(8132), 1,
      sym__LAMBDA,
    STATE(8470), 1,
      sym__FORALL,
    STATE(9466), 1,
      sym_expr,
    STATE(9530), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2654), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2686), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4732), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8656), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4735), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2660), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [128272] = 36,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(2652), 1,
      sym_id,
    ACTIONS(2656), 1,
      anon_sym_BSLASH,
    ACTIONS(2658), 1,
      anon_sym_u03bb,
    ACTIONS(2662), 1,
      anon_sym_record,
    ACTIONS(2664), 1,
      anon_sym_LPAREN,
    ACTIONS(2666), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2668), 1,
      anon_sym_u2983,
    ACTIONS(2670), 1,
      anon_sym_LBRACE,
    ACTIONS(2672), 1,
      aux_sym__qid_token1,
    ACTIONS(2674), 1,
      anon_sym_DOT,
    ACTIONS(2676), 1,
      anon_sym_quoteGoal,
    ACTIONS(2678), 1,
      anon_sym_tactic,
    ACTIONS(2680), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2682), 1,
      anon_sym_u2987,
    ACTIONS(2684), 1,
      anon_sym_let,
    ACTIONS(2688), 1,
      anon_sym_Set,
    STATE(3243), 1,
      aux_sym__atoms,
    STATE(3732), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4916), 1,
      sym_atom,
    STATE(6233), 1,
      sym_attributes,
    STATE(8132), 1,
      sym__LAMBDA,
    STATE(8470), 1,
      sym__FORALL,
    STATE(9405), 1,
      sym_expr,
    STATE(9530), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2654), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2686), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4732), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8656), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4735), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2660), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [128408] = 36,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(10999), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [128544] = 36,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(2652), 1,
      sym_id,
    ACTIONS(2656), 1,
      anon_sym_BSLASH,
    ACTIONS(2658), 1,
      anon_sym_u03bb,
    ACTIONS(2662), 1,
      anon_sym_record,
    ACTIONS(2664), 1,
      anon_sym_LPAREN,
    ACTIONS(2666), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2668), 1,
      anon_sym_u2983,
    ACTIONS(2670), 1,
      anon_sym_LBRACE,
    ACTIONS(2672), 1,
      aux_sym__qid_token1,
    ACTIONS(2674), 1,
      anon_sym_DOT,
    ACTIONS(2676), 1,
      anon_sym_quoteGoal,
    ACTIONS(2678), 1,
      anon_sym_tactic,
    ACTIONS(2680), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2682), 1,
      anon_sym_u2987,
    ACTIONS(2684), 1,
      anon_sym_let,
    ACTIONS(2688), 1,
      anon_sym_Set,
    STATE(3243), 1,
      aux_sym__atoms,
    STATE(3732), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4916), 1,
      sym_atom,
    STATE(6233), 1,
      sym_attributes,
    STATE(8132), 1,
      sym__LAMBDA,
    STATE(8470), 1,
      sym__FORALL,
    STATE(9415), 1,
      sym_expr,
    STATE(9530), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2654), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2686), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4732), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8656), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4735), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2660), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [128680] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(2690), 1,
      sym_id,
    ACTIONS(2694), 1,
      anon_sym_BSLASH,
    ACTIONS(2696), 1,
      anon_sym_u03bb,
    ACTIONS(2700), 1,
      anon_sym_record,
    ACTIONS(2702), 1,
      anon_sym_LPAREN,
    ACTIONS(2704), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2706), 1,
      anon_sym_u2983,
    ACTIONS(2708), 1,
      anon_sym_LBRACE,
    ACTIONS(2710), 1,
      aux_sym__qid_token1,
    ACTIONS(2712), 1,
      anon_sym_DOT,
    ACTIONS(2714), 1,
      anon_sym_quoteGoal,
    ACTIONS(2716), 1,
      anon_sym_tactic,
    ACTIONS(2718), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2720), 1,
      anon_sym_u2987,
    ACTIONS(2722), 1,
      anon_sym_let,
    ACTIONS(2726), 1,
      anon_sym_Set,
    STATE(3168), 1,
      aux_sym__atoms,
    STATE(3725), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4047), 1,
      sym_atom,
    STATE(6301), 1,
      sym_attributes,
    STATE(8133), 1,
      sym__LAMBDA,
    STATE(8368), 1,
      sym__FORALL,
    STATE(8957), 1,
      sym_expr,
    STATE(9036), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2692), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2724), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4108), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8650), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4103), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2698), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [128816] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(10935), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [128952] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(109), 1,
      anon_sym_BSLASH,
    ACTIONS(111), 1,
      anon_sym_u03bb,
    ACTIONS(147), 1,
      anon_sym_quoteGoal,
    ACTIONS(149), 1,
      anon_sym_tactic,
    ACTIONS(155), 1,
      anon_sym_let,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(2462), 1,
      sym_id,
    ACTIONS(2466), 1,
      anon_sym_record,
    ACTIONS(2468), 1,
      anon_sym_LPAREN,
    ACTIONS(2470), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2472), 1,
      anon_sym_u2983,
    ACTIONS(2474), 1,
      anon_sym_LBRACE,
    ACTIONS(2476), 1,
      aux_sym__qid_token1,
    ACTIONS(2478), 1,
      anon_sym_DOT,
    ACTIONS(2480), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2482), 1,
      anon_sym_u2987,
    ACTIONS(2486), 1,
      anon_sym_Set,
    STATE(3259), 1,
      aux_sym__atoms,
    STATE(3734), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4054), 1,
      sym_atom,
    STATE(6260), 1,
      sym_attributes,
    STATE(8146), 1,
      sym__LAMBDA,
    STATE(8343), 1,
      sym__FORALL,
    STATE(8948), 1,
      sym_expr,
    STATE(9017), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(107), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2484), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4044), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8667), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4052), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2464), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [129088] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(10934), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [129224] = 36,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(10933), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [129360] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(10932), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [129496] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(2728), 1,
      sym_id,
    ACTIONS(2732), 1,
      anon_sym_BSLASH,
    ACTIONS(2734), 1,
      anon_sym_u03bb,
    ACTIONS(2738), 1,
      anon_sym_record,
    ACTIONS(2740), 1,
      anon_sym_LPAREN,
    ACTIONS(2742), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2744), 1,
      anon_sym_u2983,
    ACTIONS(2746), 1,
      anon_sym_LBRACE,
    ACTIONS(2748), 1,
      aux_sym__qid_token1,
    ACTIONS(2750), 1,
      anon_sym_DOT,
    ACTIONS(2752), 1,
      anon_sym_quoteGoal,
    ACTIONS(2754), 1,
      anon_sym_tactic,
    ACTIONS(2756), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2758), 1,
      anon_sym_u2987,
    ACTIONS(2760), 1,
      anon_sym_let,
    ACTIONS(2764), 1,
      anon_sym_Set,
    STATE(3288), 1,
      aux_sym__atoms,
    STATE(3749), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4895), 1,
      sym_atom,
    STATE(6296), 1,
      sym_attributes,
    STATE(8061), 1,
      sym__LAMBDA,
    STATE(8384), 1,
      sym__FORALL,
    STATE(9002), 1,
      sym_expr,
    STATE(9404), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2730), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2762), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4685), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8665), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4682), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2736), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [129632] = 35,
    ACTIONS(700), 1,
      anon_sym_LBRACE_DASH_POUND,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2022), 1,
      anon_sym_BSLASH,
    ACTIONS(2024), 1,
      anon_sym_u03bb,
    ACTIONS(2042), 1,
      anon_sym_quoteGoal,
    ACTIONS(2044), 1,
      anon_sym_tactic,
    ACTIONS(2050), 1,
      anon_sym_let,
    ACTIONS(2766), 1,
      sym_id,
    ACTIONS(2772), 1,
      anon_sym_record,
    ACTIONS(2774), 1,
      anon_sym_LPAREN,
    ACTIONS(2776), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2778), 1,
      anon_sym_u2983,
    ACTIONS(2780), 1,
      anon_sym_LBRACE,
    ACTIONS(2782), 1,
      aux_sym__qid_token1,
    ACTIONS(2784), 1,
      anon_sym_DOT,
    ACTIONS(2786), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2788), 1,
      anon_sym_u2987,
    ACTIONS(2792), 1,
      anon_sym_Set,
    STATE(1522), 1,
      sym__ARROW,
    STATE(2811), 1,
      aux_sym__lambda_clauses_repeat1,
    STATE(3130), 1,
      sym_catchall_pragma,
    STATE(3637), 1,
      aux_sym__atoms,
    STATE(5719), 1,
      sym_atom,
    STATE(8033), 1,
      sym__LAMBDA,
    STATE(8463), 1,
      sym__FORALL,
    STATE(8987), 1,
      sym__lambda_clauses,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2020), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2768), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(2790), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5666), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(8986), 3,
      sym__lambda_clause_maybe_absurd,
      sym_lambda_clause_absurd,
      sym_lambda_clause,
    STATE(5668), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8988), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2770), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [129766] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(10931), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [129902] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(10930), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [130038] = 36,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(10929), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [130174] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(10065), 1,
      sym__with_exprs,
    STATE(11587), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [130310] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(9990), 1,
      sym__with_exprs,
    STATE(11585), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [130446] = 36,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(11561), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [130582] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(2728), 1,
      sym_id,
    ACTIONS(2732), 1,
      anon_sym_BSLASH,
    ACTIONS(2734), 1,
      anon_sym_u03bb,
    ACTIONS(2738), 1,
      anon_sym_record,
    ACTIONS(2740), 1,
      anon_sym_LPAREN,
    ACTIONS(2742), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2744), 1,
      anon_sym_u2983,
    ACTIONS(2746), 1,
      anon_sym_LBRACE,
    ACTIONS(2748), 1,
      aux_sym__qid_token1,
    ACTIONS(2750), 1,
      anon_sym_DOT,
    ACTIONS(2752), 1,
      anon_sym_quoteGoal,
    ACTIONS(2754), 1,
      anon_sym_tactic,
    ACTIONS(2756), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2758), 1,
      anon_sym_u2987,
    ACTIONS(2760), 1,
      anon_sym_let,
    ACTIONS(2764), 1,
      anon_sym_Set,
    STATE(3288), 1,
      aux_sym__atoms,
    STATE(3749), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4895), 1,
      sym_atom,
    STATE(6296), 1,
      sym_attributes,
    STATE(8061), 1,
      sym__LAMBDA,
    STATE(8384), 1,
      sym__FORALL,
    STATE(9003), 1,
      sym_expr,
    STATE(9404), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2730), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2762), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4685), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8665), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4682), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2736), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [130718] = 36,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(2652), 1,
      sym_id,
    ACTIONS(2656), 1,
      anon_sym_BSLASH,
    ACTIONS(2658), 1,
      anon_sym_u03bb,
    ACTIONS(2662), 1,
      anon_sym_record,
    ACTIONS(2664), 1,
      anon_sym_LPAREN,
    ACTIONS(2666), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2668), 1,
      anon_sym_u2983,
    ACTIONS(2670), 1,
      anon_sym_LBRACE,
    ACTIONS(2672), 1,
      aux_sym__qid_token1,
    ACTIONS(2674), 1,
      anon_sym_DOT,
    ACTIONS(2676), 1,
      anon_sym_quoteGoal,
    ACTIONS(2678), 1,
      anon_sym_tactic,
    ACTIONS(2680), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2682), 1,
      anon_sym_u2987,
    ACTIONS(2684), 1,
      anon_sym_let,
    ACTIONS(2688), 1,
      anon_sym_Set,
    STATE(3243), 1,
      aux_sym__atoms,
    STATE(3732), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4916), 1,
      sym_atom,
    STATE(6233), 1,
      sym_attributes,
    STATE(8132), 1,
      sym__LAMBDA,
    STATE(8470), 1,
      sym__FORALL,
    STATE(9475), 1,
      sym_expr,
    STATE(9530), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2654), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2686), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4732), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8656), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4735), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2660), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [130854] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(10286), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [130990] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2298), 1,
      sym_id,
    ACTIONS(2302), 1,
      anon_sym_BSLASH,
    ACTIONS(2304), 1,
      anon_sym_u03bb,
    ACTIONS(2308), 1,
      anon_sym_record,
    ACTIONS(2310), 1,
      anon_sym_LPAREN,
    ACTIONS(2312), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2314), 1,
      anon_sym_u2983,
    ACTIONS(2316), 1,
      anon_sym_LBRACE,
    ACTIONS(2318), 1,
      aux_sym__qid_token1,
    ACTIONS(2320), 1,
      anon_sym_DOT,
    ACTIONS(2322), 1,
      anon_sym_quoteGoal,
    ACTIONS(2324), 1,
      anon_sym_tactic,
    ACTIONS(2326), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2328), 1,
      anon_sym_u2987,
    ACTIONS(2330), 1,
      anon_sym_let,
    ACTIONS(2334), 1,
      anon_sym_Set,
    STATE(3178), 1,
      aux_sym__atoms,
    STATE(3707), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4989), 1,
      sym_atom,
    STATE(6249), 1,
      sym_attributes,
    STATE(8138), 1,
      sym__LAMBDA,
    STATE(8476), 1,
      sym__FORALL,
    STATE(8992), 1,
      sym_expr,
    STATE(9655), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2300), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2332), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5354), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8660), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5347), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2306), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [131126] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(10285), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [131262] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(11548), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [131398] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(11547), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [131534] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2652), 1,
      sym_id,
    ACTIONS(2662), 1,
      anon_sym_record,
    ACTIONS(2664), 1,
      anon_sym_LPAREN,
    ACTIONS(2666), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2668), 1,
      anon_sym_u2983,
    ACTIONS(2670), 1,
      anon_sym_LBRACE,
    ACTIONS(2672), 1,
      aux_sym__qid_token1,
    ACTIONS(2674), 1,
      anon_sym_DOT,
    ACTIONS(2680), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2682), 1,
      anon_sym_u2987,
    ACTIONS(2688), 1,
      anon_sym_Set,
    ACTIONS(2796), 1,
      anon_sym_BSLASH,
    ACTIONS(2798), 1,
      anon_sym_u03bb,
    ACTIONS(2800), 1,
      anon_sym_quoteGoal,
    ACTIONS(2802), 1,
      anon_sym_tactic,
    ACTIONS(2804), 1,
      anon_sym_let,
    STATE(3197), 1,
      aux_sym__atoms,
    STATE(3721), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4916), 1,
      sym_atom,
    STATE(6237), 1,
      sym_attributes,
    STATE(8041), 1,
      sym__LAMBDA,
    STATE(8490), 1,
      sym__FORALL,
    STATE(8961), 1,
      sym_expr,
    STATE(9687), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2686), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(2794), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(4732), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8657), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4735), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2660), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [131670] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(11769), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [131806] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(11545), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [131942] = 36,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(11544), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [132078] = 34,
    ACTIONS(700), 1,
      anon_sym_LBRACE_DASH_POUND,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2800), 1,
      anon_sym_quoteGoal,
    ACTIONS(2804), 1,
      anon_sym_let,
    ACTIONS(2806), 1,
      sym_id,
    ACTIONS(2810), 1,
      anon_sym_BSLASH,
    ACTIONS(2812), 1,
      anon_sym_u03bb,
    ACTIONS(2816), 1,
      anon_sym_record,
    ACTIONS(2818), 1,
      anon_sym_LPAREN,
    ACTIONS(2820), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2822), 1,
      anon_sym_u2983,
    ACTIONS(2824), 1,
      anon_sym_LBRACE,
    ACTIONS(2826), 1,
      aux_sym__qid_token1,
    ACTIONS(2828), 1,
      anon_sym_DOT,
    ACTIONS(2830), 1,
      anon_sym_tactic,
    ACTIONS(2832), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2834), 1,
      anon_sym_u2987,
    ACTIONS(2838), 1,
      anon_sym_Set,
    STATE(2185), 1,
      sym__ARROW,
    STATE(2792), 1,
      aux_sym__lambda_clauses_repeat1,
    STATE(3164), 1,
      sym_catchall_pragma,
    STATE(3364), 1,
      aux_sym__atoms,
    STATE(5831), 1,
      sym_atom,
    STATE(8081), 1,
      sym__LAMBDA,
    STATE(8490), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2794), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2808), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(2836), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5982), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(8987), 4,
      sym__lambda_clauses,
      sym__lambda_clause_maybe_absurd,
      sym_lambda_clause_absurd,
      sym_lambda_clause,
    STATE(5981), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8988), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2814), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [132210] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(11543), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [132346] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(11519), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [132482] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(11517), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [132618] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(2728), 1,
      sym_id,
    ACTIONS(2732), 1,
      anon_sym_BSLASH,
    ACTIONS(2734), 1,
      anon_sym_u03bb,
    ACTIONS(2738), 1,
      anon_sym_record,
    ACTIONS(2740), 1,
      anon_sym_LPAREN,
    ACTIONS(2742), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2744), 1,
      anon_sym_u2983,
    ACTIONS(2746), 1,
      anon_sym_LBRACE,
    ACTIONS(2748), 1,
      aux_sym__qid_token1,
    ACTIONS(2750), 1,
      anon_sym_DOT,
    ACTIONS(2752), 1,
      anon_sym_quoteGoal,
    ACTIONS(2754), 1,
      anon_sym_tactic,
    ACTIONS(2756), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2758), 1,
      anon_sym_u2987,
    ACTIONS(2760), 1,
      anon_sym_let,
    ACTIONS(2764), 1,
      anon_sym_Set,
    STATE(3288), 1,
      aux_sym__atoms,
    STATE(3749), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4895), 1,
      sym_atom,
    STATE(6296), 1,
      sym_attributes,
    STATE(8061), 1,
      sym__LAMBDA,
    STATE(8384), 1,
      sym__FORALL,
    STATE(8957), 1,
      sym_expr,
    STATE(9404), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2730), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2762), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4685), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8665), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4682), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2736), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [132754] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(11770), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [132890] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(11771), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [133026] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2652), 1,
      sym_id,
    ACTIONS(2662), 1,
      anon_sym_record,
    ACTIONS(2664), 1,
      anon_sym_LPAREN,
    ACTIONS(2666), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2668), 1,
      anon_sym_u2983,
    ACTIONS(2670), 1,
      anon_sym_LBRACE,
    ACTIONS(2672), 1,
      aux_sym__qid_token1,
    ACTIONS(2674), 1,
      anon_sym_DOT,
    ACTIONS(2680), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2682), 1,
      anon_sym_u2987,
    ACTIONS(2688), 1,
      anon_sym_Set,
    ACTIONS(2796), 1,
      anon_sym_BSLASH,
    ACTIONS(2798), 1,
      anon_sym_u03bb,
    ACTIONS(2800), 1,
      anon_sym_quoteGoal,
    ACTIONS(2802), 1,
      anon_sym_tactic,
    ACTIONS(2804), 1,
      anon_sym_let,
    STATE(3197), 1,
      aux_sym__atoms,
    STATE(3721), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4916), 1,
      sym_atom,
    STATE(6237), 1,
      sym_attributes,
    STATE(8041), 1,
      sym__LAMBDA,
    STATE(8490), 1,
      sym__FORALL,
    STATE(8951), 1,
      sym_expr,
    STATE(9687), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2686), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(2794), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(4732), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8657), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4735), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2660), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [133162] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(10282), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [133298] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(11000), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [133434] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2448), 1,
      anon_sym_quoteGoal,
    ACTIONS(2456), 1,
      anon_sym_let,
    ACTIONS(2840), 1,
      sym_id,
    ACTIONS(2842), 1,
      anon_sym_BSLASH,
    ACTIONS(2844), 1,
      anon_sym_u03bb,
    ACTIONS(2848), 1,
      anon_sym_record,
    ACTIONS(2850), 1,
      anon_sym_LPAREN,
    ACTIONS(2852), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2854), 1,
      anon_sym_u2983,
    ACTIONS(2856), 1,
      anon_sym_LBRACE,
    ACTIONS(2858), 1,
      aux_sym__qid_token1,
    ACTIONS(2860), 1,
      anon_sym_DOT,
    ACTIONS(2862), 1,
      anon_sym_tactic,
    ACTIONS(2864), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2866), 1,
      anon_sym_u2987,
    ACTIONS(2870), 1,
      anon_sym_Set,
    STATE(3174), 1,
      aux_sym__atoms,
    STATE(3747), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4684), 1,
      sym_atom,
    STATE(6273), 1,
      sym_attributes,
    STATE(8053), 1,
      sym__LAMBDA,
    STATE(8423), 1,
      sym__FORALL,
    STATE(8945), 1,
      sym_expr,
    STATE(9406), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2424), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2868), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4765), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8686), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4766), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2846), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [133570] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(9990), 1,
      sym__with_exprs,
    STATE(10919), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [133706] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(11784), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [133842] = 36,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(11772), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [133978] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(10065), 1,
      sym__with_exprs,
    STATE(10918), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [134114] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(11001), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [134250] = 36,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(10281), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [134386] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(2566), 1,
      sym_id,
    ACTIONS(2570), 1,
      anon_sym_BSLASH,
    ACTIONS(2572), 1,
      anon_sym_u03bb,
    ACTIONS(2576), 1,
      anon_sym_record,
    ACTIONS(2578), 1,
      anon_sym_LPAREN,
    ACTIONS(2580), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2582), 1,
      anon_sym_u2983,
    ACTIONS(2584), 1,
      anon_sym_LBRACE,
    ACTIONS(2586), 1,
      aux_sym__qid_token1,
    ACTIONS(2588), 1,
      anon_sym_DOT,
    ACTIONS(2590), 1,
      anon_sym_quoteGoal,
    ACTIONS(2592), 1,
      anon_sym_tactic,
    ACTIONS(2594), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2596), 1,
      anon_sym_u2987,
    ACTIONS(2598), 1,
      anon_sym_let,
    ACTIONS(2602), 1,
      anon_sym_Set,
    STATE(3214), 1,
      aux_sym__atoms,
    STATE(3714), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5536), 1,
      sym_atom,
    STATE(6208), 1,
      sym_attributes,
    STATE(8111), 1,
      sym__LAMBDA,
    STATE(8412), 1,
      sym__FORALL,
    STATE(9763), 1,
      sym_expr,
    STATE(10191), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2568), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2600), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5566), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8634), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5590), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2574), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [134522] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2652), 1,
      sym_id,
    ACTIONS(2662), 1,
      anon_sym_record,
    ACTIONS(2664), 1,
      anon_sym_LPAREN,
    ACTIONS(2666), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2668), 1,
      anon_sym_u2983,
    ACTIONS(2670), 1,
      anon_sym_LBRACE,
    ACTIONS(2672), 1,
      aux_sym__qid_token1,
    ACTIONS(2674), 1,
      anon_sym_DOT,
    ACTIONS(2680), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2682), 1,
      anon_sym_u2987,
    ACTIONS(2688), 1,
      anon_sym_Set,
    ACTIONS(2796), 1,
      anon_sym_BSLASH,
    ACTIONS(2798), 1,
      anon_sym_u03bb,
    ACTIONS(2800), 1,
      anon_sym_quoteGoal,
    ACTIONS(2802), 1,
      anon_sym_tactic,
    ACTIONS(2804), 1,
      anon_sym_let,
    STATE(3197), 1,
      aux_sym__atoms,
    STATE(3721), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4916), 1,
      sym_atom,
    STATE(6237), 1,
      sym_attributes,
    STATE(8041), 1,
      sym__LAMBDA,
    STATE(8490), 1,
      sym__FORALL,
    STATE(8974), 1,
      sym_expr,
    STATE(9687), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2686), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(2794), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(4732), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8657), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4735), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2660), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [134658] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(11002), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [134794] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(2614), 1,
      sym_id,
    ACTIONS(2618), 1,
      anon_sym_BSLASH,
    ACTIONS(2620), 1,
      anon_sym_u03bb,
    ACTIONS(2624), 1,
      anon_sym_record,
    ACTIONS(2626), 1,
      anon_sym_LPAREN,
    ACTIONS(2628), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2630), 1,
      anon_sym_u2983,
    ACTIONS(2632), 1,
      anon_sym_LBRACE,
    ACTIONS(2634), 1,
      aux_sym__qid_token1,
    ACTIONS(2636), 1,
      anon_sym_DOT,
    ACTIONS(2638), 1,
      anon_sym_quoteGoal,
    ACTIONS(2640), 1,
      anon_sym_tactic,
    ACTIONS(2642), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2644), 1,
      anon_sym_u2987,
    ACTIONS(2646), 1,
      anon_sym_let,
    ACTIONS(2650), 1,
      anon_sym_Set,
    STATE(3343), 1,
      aux_sym__atoms,
    STATE(3758), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4849), 1,
      sym_atom,
    STATE(6258), 1,
      sym_attributes,
    STATE(8093), 1,
      sym__LAMBDA,
    STATE(8414), 1,
      sym__FORALL,
    STATE(8949), 1,
      sym_expr,
    STATE(9445), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2616), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2648), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4799), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8666), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4784), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2622), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [134930] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2652), 1,
      sym_id,
    ACTIONS(2662), 1,
      anon_sym_record,
    ACTIONS(2664), 1,
      anon_sym_LPAREN,
    ACTIONS(2666), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2668), 1,
      anon_sym_u2983,
    ACTIONS(2670), 1,
      anon_sym_LBRACE,
    ACTIONS(2672), 1,
      aux_sym__qid_token1,
    ACTIONS(2674), 1,
      anon_sym_DOT,
    ACTIONS(2680), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2682), 1,
      anon_sym_u2987,
    ACTIONS(2688), 1,
      anon_sym_Set,
    ACTIONS(2796), 1,
      anon_sym_BSLASH,
    ACTIONS(2798), 1,
      anon_sym_u03bb,
    ACTIONS(2800), 1,
      anon_sym_quoteGoal,
    ACTIONS(2802), 1,
      anon_sym_tactic,
    ACTIONS(2804), 1,
      anon_sym_let,
    STATE(3197), 1,
      aux_sym__atoms,
    STATE(3721), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4916), 1,
      sym_atom,
    STATE(6237), 1,
      sym_attributes,
    STATE(8041), 1,
      sym__LAMBDA,
    STATE(8490), 1,
      sym__FORALL,
    STATE(8978), 1,
      sym_expr,
    STATE(9687), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2686), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(2794), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(4732), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8657), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4735), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2660), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [135066] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2298), 1,
      sym_id,
    ACTIONS(2302), 1,
      anon_sym_BSLASH,
    ACTIONS(2304), 1,
      anon_sym_u03bb,
    ACTIONS(2308), 1,
      anon_sym_record,
    ACTIONS(2310), 1,
      anon_sym_LPAREN,
    ACTIONS(2312), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2314), 1,
      anon_sym_u2983,
    ACTIONS(2316), 1,
      anon_sym_LBRACE,
    ACTIONS(2318), 1,
      aux_sym__qid_token1,
    ACTIONS(2320), 1,
      anon_sym_DOT,
    ACTIONS(2322), 1,
      anon_sym_quoteGoal,
    ACTIONS(2324), 1,
      anon_sym_tactic,
    ACTIONS(2326), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2328), 1,
      anon_sym_u2987,
    ACTIONS(2330), 1,
      anon_sym_let,
    ACTIONS(2334), 1,
      anon_sym_Set,
    STATE(3178), 1,
      aux_sym__atoms,
    STATE(3707), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4989), 1,
      sym_atom,
    STATE(6249), 1,
      sym_attributes,
    STATE(8138), 1,
      sym__LAMBDA,
    STATE(8476), 1,
      sym__FORALL,
    STATE(8959), 1,
      sym_expr,
    STATE(9655), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2300), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2332), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5354), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8660), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5347), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2306), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [135202] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(10280), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [135338] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(10279), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [135474] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(11398), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [135610] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(940), 1,
      sym_id,
    ACTIONS(944), 1,
      anon_sym_BSLASH,
    ACTIONS(946), 1,
      anon_sym_u03bb,
    ACTIONS(950), 1,
      anon_sym_record,
    ACTIONS(952), 1,
      anon_sym_LPAREN,
    ACTIONS(954), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(956), 1,
      anon_sym_u2983,
    ACTIONS(958), 1,
      anon_sym_LBRACE,
    ACTIONS(960), 1,
      aux_sym__qid_token1,
    ACTIONS(962), 1,
      anon_sym_DOT,
    ACTIONS(964), 1,
      anon_sym_quoteGoal,
    ACTIONS(966), 1,
      anon_sym_tactic,
    ACTIONS(968), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(970), 1,
      anon_sym_u2987,
    ACTIONS(972), 1,
      anon_sym_let,
    ACTIONS(976), 1,
      anon_sym_Set,
    STATE(3278), 1,
      aux_sym__atoms,
    STATE(3743), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4712), 1,
      sym_atom,
    STATE(6265), 1,
      sym_attributes,
    STATE(8054), 1,
      sym__LAMBDA,
    STATE(8355), 1,
      sym__FORALL,
    STATE(8978), 1,
      sym_expr,
    STATE(9518), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(942), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(974), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4733), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8674), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4742), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(948), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [135746] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(10278), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [135882] = 36,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(10277), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [136018] = 35,
    ACTIONS(700), 1,
      anon_sym_LBRACE_DASH_POUND,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2448), 1,
      anon_sym_quoteGoal,
    ACTIONS(2456), 1,
      anon_sym_let,
    ACTIONS(2842), 1,
      anon_sym_BSLASH,
    ACTIONS(2844), 1,
      anon_sym_u03bb,
    ACTIONS(2862), 1,
      anon_sym_tactic,
    ACTIONS(2872), 1,
      sym_id,
    ACTIONS(2876), 1,
      anon_sym_record,
    ACTIONS(2878), 1,
      anon_sym_LPAREN,
    ACTIONS(2880), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2882), 1,
      anon_sym_u2983,
    ACTIONS(2884), 1,
      anon_sym_LBRACE,
    ACTIONS(2886), 1,
      aux_sym__qid_token1,
    ACTIONS(2888), 1,
      anon_sym_DOT,
    ACTIONS(2890), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2892), 1,
      anon_sym_u2987,
    ACTIONS(2896), 1,
      anon_sym_Set,
    STATE(2007), 1,
      sym__ARROW,
    STATE(2672), 1,
      aux_sym__lambda_clauses_repeat1,
    STATE(3134), 1,
      sym_catchall_pragma,
    STATE(3374), 1,
      aux_sym__atoms,
    STATE(4945), 1,
      sym_atom,
    STATE(8053), 1,
      sym__LAMBDA,
    STATE(8423), 1,
      sym__FORALL,
    STATE(8987), 1,
      sym__lambda_clauses,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2424), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2426), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(2894), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5291), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(8986), 3,
      sym__lambda_clause_maybe_absurd,
      sym_lambda_clause_absurd,
      sym_lambda_clause,
    STATE(5287), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8988), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2874), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [136152] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(940), 1,
      sym_id,
    ACTIONS(944), 1,
      anon_sym_BSLASH,
    ACTIONS(946), 1,
      anon_sym_u03bb,
    ACTIONS(950), 1,
      anon_sym_record,
    ACTIONS(952), 1,
      anon_sym_LPAREN,
    ACTIONS(954), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(956), 1,
      anon_sym_u2983,
    ACTIONS(958), 1,
      anon_sym_LBRACE,
    ACTIONS(960), 1,
      aux_sym__qid_token1,
    ACTIONS(962), 1,
      anon_sym_DOT,
    ACTIONS(964), 1,
      anon_sym_quoteGoal,
    ACTIONS(966), 1,
      anon_sym_tactic,
    ACTIONS(968), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(970), 1,
      anon_sym_u2987,
    ACTIONS(972), 1,
      anon_sym_let,
    ACTIONS(976), 1,
      anon_sym_Set,
    STATE(3278), 1,
      aux_sym__atoms,
    STATE(3743), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4712), 1,
      sym_atom,
    STATE(6265), 1,
      sym_attributes,
    STATE(8054), 1,
      sym__LAMBDA,
    STATE(8355), 1,
      sym__FORALL,
    STATE(8974), 1,
      sym_expr,
    STATE(9518), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(942), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(974), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4733), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8674), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4742), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(948), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [136288] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2298), 1,
      sym_id,
    ACTIONS(2302), 1,
      anon_sym_BSLASH,
    ACTIONS(2304), 1,
      anon_sym_u03bb,
    ACTIONS(2308), 1,
      anon_sym_record,
    ACTIONS(2310), 1,
      anon_sym_LPAREN,
    ACTIONS(2312), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2314), 1,
      anon_sym_u2983,
    ACTIONS(2316), 1,
      anon_sym_LBRACE,
    ACTIONS(2318), 1,
      aux_sym__qid_token1,
    ACTIONS(2320), 1,
      anon_sym_DOT,
    ACTIONS(2322), 1,
      anon_sym_quoteGoal,
    ACTIONS(2324), 1,
      anon_sym_tactic,
    ACTIONS(2326), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2328), 1,
      anon_sym_u2987,
    ACTIONS(2330), 1,
      anon_sym_let,
    ACTIONS(2334), 1,
      anon_sym_Set,
    STATE(3178), 1,
      aux_sym__atoms,
    STATE(3707), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4989), 1,
      sym_atom,
    STATE(6249), 1,
      sym_attributes,
    STATE(8138), 1,
      sym__LAMBDA,
    STATE(8476), 1,
      sym__FORALL,
    STATE(8937), 1,
      sym_expr,
    STATE(9655), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2300), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2332), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5354), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8660), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5347), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2306), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [136424] = 36,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(11003), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [136560] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(940), 1,
      sym_id,
    ACTIONS(944), 1,
      anon_sym_BSLASH,
    ACTIONS(946), 1,
      anon_sym_u03bb,
    ACTIONS(950), 1,
      anon_sym_record,
    ACTIONS(952), 1,
      anon_sym_LPAREN,
    ACTIONS(954), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(956), 1,
      anon_sym_u2983,
    ACTIONS(958), 1,
      anon_sym_LBRACE,
    ACTIONS(960), 1,
      aux_sym__qid_token1,
    ACTIONS(962), 1,
      anon_sym_DOT,
    ACTIONS(964), 1,
      anon_sym_quoteGoal,
    ACTIONS(966), 1,
      anon_sym_tactic,
    ACTIONS(968), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(970), 1,
      anon_sym_u2987,
    ACTIONS(972), 1,
      anon_sym_let,
    ACTIONS(976), 1,
      anon_sym_Set,
    STATE(3278), 1,
      aux_sym__atoms,
    STATE(3743), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4712), 1,
      sym_atom,
    STATE(6265), 1,
      sym_attributes,
    STATE(8054), 1,
      sym__LAMBDA,
    STATE(8355), 1,
      sym__FORALL,
    STATE(8951), 1,
      sym_expr,
    STATE(9518), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(942), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(974), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4733), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8674), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4742), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(948), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [136696] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(11004), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [136832] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(940), 1,
      sym_id,
    ACTIONS(944), 1,
      anon_sym_BSLASH,
    ACTIONS(946), 1,
      anon_sym_u03bb,
    ACTIONS(950), 1,
      anon_sym_record,
    ACTIONS(952), 1,
      anon_sym_LPAREN,
    ACTIONS(954), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(956), 1,
      anon_sym_u2983,
    ACTIONS(958), 1,
      anon_sym_LBRACE,
    ACTIONS(960), 1,
      aux_sym__qid_token1,
    ACTIONS(962), 1,
      anon_sym_DOT,
    ACTIONS(964), 1,
      anon_sym_quoteGoal,
    ACTIONS(966), 1,
      anon_sym_tactic,
    ACTIONS(968), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(970), 1,
      anon_sym_u2987,
    ACTIONS(972), 1,
      anon_sym_let,
    ACTIONS(976), 1,
      anon_sym_Set,
    STATE(3278), 1,
      aux_sym__atoms,
    STATE(3743), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4712), 1,
      sym_atom,
    STATE(6265), 1,
      sym_attributes,
    STATE(8054), 1,
      sym__LAMBDA,
    STATE(8355), 1,
      sym__FORALL,
    STATE(8961), 1,
      sym_expr,
    STATE(9518), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(942), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(974), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4733), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8674), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4742), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(948), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [136968] = 34,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(700), 1,
      anon_sym_LBRACE_DASH_POUND,
    ACTIONS(2898), 1,
      sym_id,
    ACTIONS(2904), 1,
      anon_sym_BSLASH,
    ACTIONS(2906), 1,
      anon_sym_u03bb,
    ACTIONS(2910), 1,
      anon_sym_record,
    ACTIONS(2912), 1,
      anon_sym_LPAREN,
    ACTIONS(2914), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2916), 1,
      anon_sym_u2983,
    ACTIONS(2918), 1,
      anon_sym_LBRACE,
    ACTIONS(2920), 1,
      aux_sym__qid_token1,
    ACTIONS(2922), 1,
      anon_sym_DOT,
    ACTIONS(2924), 1,
      anon_sym_quoteGoal,
    ACTIONS(2926), 1,
      anon_sym_tactic,
    ACTIONS(2928), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2930), 1,
      anon_sym_u2987,
    ACTIONS(2932), 1,
      anon_sym_let,
    ACTIONS(2936), 1,
      anon_sym_Set,
    STATE(1742), 1,
      sym__ARROW,
    STATE(2722), 1,
      aux_sym__lambda_clauses_repeat1,
    STATE(3327), 1,
      sym_catchall_pragma,
    STATE(3387), 1,
      aux_sym__atoms,
    STATE(4154), 1,
      sym_atom,
    STATE(8094), 1,
      sym__LAMBDA,
    STATE(8489), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2900), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2902), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(2934), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4184), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(8999), 4,
      sym__lambda_clauses,
      sym__lambda_clause_maybe_absurd,
      sym_lambda_clause_absurd,
      sym_lambda_clause,
    STATE(4206), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9000), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2908), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [137100] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(9990), 1,
      sym__with_exprs,
    STATE(10266), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [137236] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(10065), 1,
      sym__with_exprs,
    STATE(10265), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [137372] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(11005), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [137508] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(109), 1,
      anon_sym_BSLASH,
    ACTIONS(111), 1,
      anon_sym_u03bb,
    ACTIONS(147), 1,
      anon_sym_quoteGoal,
    ACTIONS(149), 1,
      anon_sym_tactic,
    ACTIONS(155), 1,
      anon_sym_let,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(2462), 1,
      sym_id,
    ACTIONS(2466), 1,
      anon_sym_record,
    ACTIONS(2468), 1,
      anon_sym_LPAREN,
    ACTIONS(2470), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2472), 1,
      anon_sym_u2983,
    ACTIONS(2474), 1,
      anon_sym_LBRACE,
    ACTIONS(2476), 1,
      aux_sym__qid_token1,
    ACTIONS(2478), 1,
      anon_sym_DOT,
    ACTIONS(2480), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2482), 1,
      anon_sym_u2987,
    ACTIONS(2486), 1,
      anon_sym_Set,
    STATE(3259), 1,
      aux_sym__atoms,
    STATE(3734), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4054), 1,
      sym_atom,
    STATE(6260), 1,
      sym_attributes,
    STATE(8146), 1,
      sym__LAMBDA,
    STATE(8343), 1,
      sym__FORALL,
    STATE(8952), 1,
      sym_expr,
    STATE(9017), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(107), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2484), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4044), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8667), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4052), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2464), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [137644] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(11006), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [137780] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(2690), 1,
      sym_id,
    ACTIONS(2694), 1,
      anon_sym_BSLASH,
    ACTIONS(2696), 1,
      anon_sym_u03bb,
    ACTIONS(2700), 1,
      anon_sym_record,
    ACTIONS(2702), 1,
      anon_sym_LPAREN,
    ACTIONS(2704), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2706), 1,
      anon_sym_u2983,
    ACTIONS(2708), 1,
      anon_sym_LBRACE,
    ACTIONS(2710), 1,
      aux_sym__qid_token1,
    ACTIONS(2712), 1,
      anon_sym_DOT,
    ACTIONS(2714), 1,
      anon_sym_quoteGoal,
    ACTIONS(2716), 1,
      anon_sym_tactic,
    ACTIONS(2718), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2720), 1,
      anon_sym_u2987,
    ACTIONS(2722), 1,
      anon_sym_let,
    ACTIONS(2726), 1,
      anon_sym_Set,
    STATE(3168), 1,
      aux_sym__atoms,
    STATE(3725), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4047), 1,
      sym_atom,
    STATE(6301), 1,
      sym_attributes,
    STATE(8133), 1,
      sym__LAMBDA,
    STATE(8368), 1,
      sym__FORALL,
    STATE(9003), 1,
      sym_expr,
    STATE(9036), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2692), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2724), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4108), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8650), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4103), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2698), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [137916] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2298), 1,
      sym_id,
    ACTIONS(2302), 1,
      anon_sym_BSLASH,
    ACTIONS(2304), 1,
      anon_sym_u03bb,
    ACTIONS(2308), 1,
      anon_sym_record,
    ACTIONS(2310), 1,
      anon_sym_LPAREN,
    ACTIONS(2312), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2314), 1,
      anon_sym_u2983,
    ACTIONS(2316), 1,
      anon_sym_LBRACE,
    ACTIONS(2318), 1,
      aux_sym__qid_token1,
    ACTIONS(2320), 1,
      anon_sym_DOT,
    ACTIONS(2322), 1,
      anon_sym_quoteGoal,
    ACTIONS(2324), 1,
      anon_sym_tactic,
    ACTIONS(2326), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2328), 1,
      anon_sym_u2987,
    ACTIONS(2330), 1,
      anon_sym_let,
    ACTIONS(2334), 1,
      anon_sym_Set,
    STATE(3178), 1,
      aux_sym__atoms,
    STATE(3707), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4989), 1,
      sym_atom,
    STATE(6249), 1,
      sym_attributes,
    STATE(8138), 1,
      sym__LAMBDA,
    STATE(8476), 1,
      sym__FORALL,
    STATE(8945), 1,
      sym_expr,
    STATE(9655), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2300), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2332), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5354), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8660), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5347), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2306), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [138052] = 34,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(700), 1,
      anon_sym_LBRACE_DASH_POUND,
    ACTIONS(2938), 1,
      sym_id,
    ACTIONS(2944), 1,
      anon_sym_BSLASH,
    ACTIONS(2946), 1,
      anon_sym_u03bb,
    ACTIONS(2950), 1,
      anon_sym_record,
    ACTIONS(2952), 1,
      anon_sym_LPAREN,
    ACTIONS(2954), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2956), 1,
      anon_sym_u2983,
    ACTIONS(2958), 1,
      anon_sym_LBRACE,
    ACTIONS(2960), 1,
      aux_sym__qid_token1,
    ACTIONS(2962), 1,
      anon_sym_DOT,
    ACTIONS(2964), 1,
      anon_sym_quoteGoal,
    ACTIONS(2966), 1,
      anon_sym_tactic,
    ACTIONS(2968), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2970), 1,
      anon_sym_u2987,
    ACTIONS(2972), 1,
      anon_sym_let,
    ACTIONS(2976), 1,
      anon_sym_Set,
    STATE(2453), 1,
      sym__ARROW,
    STATE(2663), 1,
      aux_sym__lambda_clauses_repeat1,
    STATE(3199), 1,
      sym_catchall_pragma,
    STATE(3546), 1,
      aux_sym__atoms,
    STATE(5967), 1,
      sym_atom,
    STATE(8126), 1,
      sym__LAMBDA,
    STATE(8418), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2940), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2942), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(2974), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5870), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(8999), 4,
      sym__lambda_clauses,
      sym__lambda_clause_maybe_absurd,
      sym_lambda_clause_absurd,
      sym_lambda_clause,
    STATE(5838), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9000), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2948), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [138184] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(10065), 1,
      sym__with_exprs,
    STATE(10613), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [138320] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2140), 1,
      anon_sym_BSLASH,
    ACTIONS(2142), 1,
      anon_sym_u03bb,
    ACTIONS(2160), 1,
      anon_sym_quoteGoal,
    ACTIONS(2162), 1,
      anon_sym_tactic,
    ACTIONS(2168), 1,
      anon_sym_let,
    ACTIONS(2272), 1,
      sym_id,
    ACTIONS(2276), 1,
      anon_sym_record,
    ACTIONS(2278), 1,
      anon_sym_LPAREN,
    ACTIONS(2280), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2282), 1,
      anon_sym_u2983,
    ACTIONS(2284), 1,
      anon_sym_LBRACE,
    ACTIONS(2286), 1,
      aux_sym__qid_token1,
    ACTIONS(2288), 1,
      anon_sym_DOT,
    ACTIONS(2290), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2292), 1,
      anon_sym_u2987,
    ACTIONS(2296), 1,
      anon_sym_Set,
    STATE(3301), 1,
      aux_sym__atoms,
    STATE(3750), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5012), 1,
      sym_atom,
    STATE(6256), 1,
      sym_attributes,
    STATE(8040), 1,
      sym__LAMBDA,
    STATE(8460), 1,
      sym__FORALL,
    STATE(8970), 1,
      sym_expr,
    STATE(9559), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2136), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2294), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5139), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8631), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5053), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2274), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [138456] = 35,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(700), 1,
      anon_sym_LBRACE_DASH_POUND,
    ACTIONS(2898), 1,
      sym_id,
    ACTIONS(2904), 1,
      anon_sym_BSLASH,
    ACTIONS(2906), 1,
      anon_sym_u03bb,
    ACTIONS(2910), 1,
      anon_sym_record,
    ACTIONS(2912), 1,
      anon_sym_LPAREN,
    ACTIONS(2914), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2916), 1,
      anon_sym_u2983,
    ACTIONS(2918), 1,
      anon_sym_LBRACE,
    ACTIONS(2920), 1,
      aux_sym__qid_token1,
    ACTIONS(2922), 1,
      anon_sym_DOT,
    ACTIONS(2924), 1,
      anon_sym_quoteGoal,
    ACTIONS(2926), 1,
      anon_sym_tactic,
    ACTIONS(2928), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2930), 1,
      anon_sym_u2987,
    ACTIONS(2932), 1,
      anon_sym_let,
    ACTIONS(2936), 1,
      anon_sym_Set,
    STATE(1742), 1,
      sym__ARROW,
    STATE(2780), 1,
      aux_sym__lambda_clauses_repeat1,
    STATE(3327), 1,
      sym_catchall_pragma,
    STATE(3387), 1,
      aux_sym__atoms,
    STATE(4154), 1,
      sym_atom,
    STATE(8094), 1,
      sym__LAMBDA,
    STATE(8489), 1,
      sym__FORALL,
    STATE(8999), 1,
      sym__lambda_clauses,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2900), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2902), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(2934), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4184), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(8993), 3,
      sym__lambda_clause_maybe_absurd,
      sym_lambda_clause_absurd,
      sym_lambda_clause,
    STATE(4206), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9000), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2908), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [138590] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(10065), 1,
      sym__with_exprs,
    STATE(11447), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [138726] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(2384), 1,
      sym_id,
    ACTIONS(2388), 1,
      anon_sym_BSLASH,
    ACTIONS(2390), 1,
      anon_sym_u03bb,
    ACTIONS(2394), 1,
      anon_sym_record,
    ACTIONS(2396), 1,
      anon_sym_LPAREN,
    ACTIONS(2398), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2400), 1,
      anon_sym_u2983,
    ACTIONS(2402), 1,
      anon_sym_LBRACE,
    ACTIONS(2404), 1,
      aux_sym__qid_token1,
    ACTIONS(2406), 1,
      anon_sym_DOT,
    ACTIONS(2408), 1,
      anon_sym_quoteGoal,
    ACTIONS(2410), 1,
      anon_sym_tactic,
    ACTIONS(2412), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2414), 1,
      anon_sym_u2987,
    ACTIONS(2416), 1,
      anon_sym_let,
    ACTIONS(2420), 1,
      anon_sym_Set,
    STATE(3210), 1,
      aux_sym__atoms,
    STATE(3752), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4775), 1,
      sym_atom,
    STATE(6209), 1,
      sym_attributes,
    STATE(8139), 1,
      sym__LAMBDA,
    STATE(8518), 1,
      sym__FORALL,
    STATE(9440), 1,
      sym__with_exprs,
    STATE(9448), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2386), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2418), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4831), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8636), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4896), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2392), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [138862] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(9990), 1,
      sym__with_exprs,
    STATE(10514), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [138998] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(2978), 1,
      sym_id,
    ACTIONS(2982), 1,
      anon_sym_BSLASH,
    ACTIONS(2984), 1,
      anon_sym_u03bb,
    ACTIONS(2988), 1,
      anon_sym_record,
    ACTIONS(2990), 1,
      anon_sym_LPAREN,
    ACTIONS(2992), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2994), 1,
      anon_sym_u2983,
    ACTIONS(2996), 1,
      anon_sym_LBRACE,
    ACTIONS(2998), 1,
      aux_sym__qid_token1,
    ACTIONS(3000), 1,
      anon_sym_DOT,
    ACTIONS(3002), 1,
      anon_sym_quoteGoal,
    ACTIONS(3004), 1,
      anon_sym_tactic,
    ACTIONS(3006), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3008), 1,
      anon_sym_u2987,
    ACTIONS(3010), 1,
      anon_sym_let,
    ACTIONS(3014), 1,
      anon_sym_Set,
    STATE(3136), 1,
      aux_sym__atoms,
    STATE(3737), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4529), 1,
      sym_atom,
    STATE(6210), 1,
      sym_attributes,
    STATE(8117), 1,
      sym__LAMBDA,
    STATE(8511), 1,
      sym__FORALL,
    STATE(9149), 1,
      sym_expr,
    STATE(9228), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3012), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4469), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8638), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4463), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2986), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [139134] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(3016), 1,
      sym_id,
    ACTIONS(3020), 1,
      anon_sym_BSLASH,
    ACTIONS(3022), 1,
      anon_sym_u03bb,
    ACTIONS(3026), 1,
      anon_sym_record,
    ACTIONS(3028), 1,
      anon_sym_LPAREN,
    ACTIONS(3030), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3032), 1,
      anon_sym_u2983,
    ACTIONS(3034), 1,
      anon_sym_LBRACE,
    ACTIONS(3036), 1,
      aux_sym__qid_token1,
    ACTIONS(3038), 1,
      anon_sym_DOT,
    ACTIONS(3040), 1,
      anon_sym_quoteGoal,
    ACTIONS(3042), 1,
      anon_sym_tactic,
    ACTIONS(3044), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3046), 1,
      anon_sym_u2987,
    ACTIONS(3048), 1,
      anon_sym_let,
    ACTIONS(3052), 1,
      anon_sym_Set,
    STATE(3216), 1,
      aux_sym__atoms,
    STATE(3760), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5039), 1,
      sym_atom,
    STATE(6294), 1,
      sym_attributes,
    STATE(8127), 1,
      sym__LAMBDA,
    STATE(8388), 1,
      sym__FORALL,
    STATE(8937), 1,
      sym_expr,
    STATE(9599), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3018), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3050), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5330), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8672), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5333), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3024), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [139270] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(2690), 1,
      sym_id,
    ACTIONS(2694), 1,
      anon_sym_BSLASH,
    ACTIONS(2696), 1,
      anon_sym_u03bb,
    ACTIONS(2700), 1,
      anon_sym_record,
    ACTIONS(2702), 1,
      anon_sym_LPAREN,
    ACTIONS(2704), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2706), 1,
      anon_sym_u2983,
    ACTIONS(2708), 1,
      anon_sym_LBRACE,
    ACTIONS(2710), 1,
      aux_sym__qid_token1,
    ACTIONS(2712), 1,
      anon_sym_DOT,
    ACTIONS(2714), 1,
      anon_sym_quoteGoal,
    ACTIONS(2716), 1,
      anon_sym_tactic,
    ACTIONS(2718), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2720), 1,
      anon_sym_u2987,
    ACTIONS(2722), 1,
      anon_sym_let,
    ACTIONS(2726), 1,
      anon_sym_Set,
    STATE(3168), 1,
      aux_sym__atoms,
    STATE(3725), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4047), 1,
      sym_atom,
    STATE(6301), 1,
      sym_attributes,
    STATE(8133), 1,
      sym__LAMBDA,
    STATE(8368), 1,
      sym__FORALL,
    STATE(9002), 1,
      sym_expr,
    STATE(9036), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2692), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2724), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4108), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8650), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4103), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2698), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [139406] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(8992), 1,
      sym_expr,
    STATE(10065), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [139542] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(3016), 1,
      sym_id,
    ACTIONS(3020), 1,
      anon_sym_BSLASH,
    ACTIONS(3022), 1,
      anon_sym_u03bb,
    ACTIONS(3026), 1,
      anon_sym_record,
    ACTIONS(3028), 1,
      anon_sym_LPAREN,
    ACTIONS(3030), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3032), 1,
      anon_sym_u2983,
    ACTIONS(3034), 1,
      anon_sym_LBRACE,
    ACTIONS(3036), 1,
      aux_sym__qid_token1,
    ACTIONS(3038), 1,
      anon_sym_DOT,
    ACTIONS(3040), 1,
      anon_sym_quoteGoal,
    ACTIONS(3042), 1,
      anon_sym_tactic,
    ACTIONS(3044), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3046), 1,
      anon_sym_u2987,
    ACTIONS(3048), 1,
      anon_sym_let,
    ACTIONS(3052), 1,
      anon_sym_Set,
    STATE(3216), 1,
      aux_sym__atoms,
    STATE(3760), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5039), 1,
      sym_atom,
    STATE(6294), 1,
      sym_attributes,
    STATE(8127), 1,
      sym__LAMBDA,
    STATE(8388), 1,
      sym__FORALL,
    STATE(8945), 1,
      sym_expr,
    STATE(9599), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3018), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3050), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5330), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8672), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5333), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3024), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [139678] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(10899), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [139814] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(10851), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [139950] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(10896), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [140086] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(734), 1,
      sym_id,
    ACTIONS(738), 1,
      anon_sym_BSLASH,
    ACTIONS(740), 1,
      anon_sym_u03bb,
    ACTIONS(744), 1,
      anon_sym_record,
    ACTIONS(746), 1,
      anon_sym_LPAREN,
    ACTIONS(748), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(750), 1,
      anon_sym_u2983,
    ACTIONS(752), 1,
      anon_sym_LBRACE,
    ACTIONS(754), 1,
      aux_sym__qid_token1,
    ACTIONS(756), 1,
      anon_sym_DOT,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(762), 1,
      anon_sym_quoteGoal,
    ACTIONS(764), 1,
      anon_sym_tactic,
    ACTIONS(766), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(768), 1,
      anon_sym_u2987,
    ACTIONS(774), 1,
      anon_sym_Set,
    ACTIONS(3054), 1,
      anon_sym_let,
    STATE(3326), 1,
      aux_sym__atoms,
    STATE(3730), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5147), 1,
      sym_atom,
    STATE(6212), 1,
      sym_attributes,
    STATE(8156), 1,
      sym__LAMBDA,
    STATE(8456), 1,
      sym__FORALL,
    STATE(9571), 1,
      sym_expr,
    STATE(9596), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(736), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(772), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5108), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8641), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5102), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(742), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [140222] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2488), 1,
      sym_id,
    ACTIONS(2492), 1,
      anon_sym_BSLASH,
    ACTIONS(2494), 1,
      anon_sym_u03bb,
    ACTIONS(2498), 1,
      anon_sym_record,
    ACTIONS(2500), 1,
      anon_sym_LPAREN,
    ACTIONS(2502), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2504), 1,
      anon_sym_u2983,
    ACTIONS(2506), 1,
      anon_sym_LBRACE,
    ACTIONS(2508), 1,
      aux_sym__qid_token1,
    ACTIONS(2510), 1,
      anon_sym_DOT,
    ACTIONS(2512), 1,
      anon_sym_quoteGoal,
    ACTIONS(2514), 1,
      anon_sym_tactic,
    ACTIONS(2516), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2518), 1,
      anon_sym_u2987,
    ACTIONS(2520), 1,
      anon_sym_let,
    ACTIONS(2524), 1,
      anon_sym_Set,
    STATE(3193), 1,
      aux_sym__atoms,
    STATE(3709), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5643), 1,
      sym_atom,
    STATE(6216), 1,
      sym_attributes,
    STATE(8096), 1,
      sym__LAMBDA,
    STATE(8497), 1,
      sym__FORALL,
    STATE(10138), 1,
      sym__with_exprs,
    STATE(12394), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2490), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2522), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5713), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8645), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5698), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2496), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [140358] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(11773), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [140494] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(10254), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [140630] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(734), 1,
      sym_id,
    ACTIONS(738), 1,
      anon_sym_BSLASH,
    ACTIONS(740), 1,
      anon_sym_u03bb,
    ACTIONS(744), 1,
      anon_sym_record,
    ACTIONS(746), 1,
      anon_sym_LPAREN,
    ACTIONS(748), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(750), 1,
      anon_sym_u2983,
    ACTIONS(752), 1,
      anon_sym_LBRACE,
    ACTIONS(754), 1,
      aux_sym__qid_token1,
    ACTIONS(756), 1,
      anon_sym_DOT,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(762), 1,
      anon_sym_quoteGoal,
    ACTIONS(764), 1,
      anon_sym_tactic,
    ACTIONS(766), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(768), 1,
      anon_sym_u2987,
    ACTIONS(774), 1,
      anon_sym_Set,
    ACTIONS(3054), 1,
      anon_sym_let,
    STATE(3326), 1,
      aux_sym__atoms,
    STATE(3730), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5147), 1,
      sym_atom,
    STATE(6212), 1,
      sym_attributes,
    STATE(8156), 1,
      sym__LAMBDA,
    STATE(8456), 1,
      sym__FORALL,
    STATE(9434), 1,
      sym_expr,
    STATE(9596), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(736), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(772), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5108), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8641), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5102), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(742), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [140766] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(11783), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [140902] = 36,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(10895), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [141038] = 37,
    ACTIONS(710), 1,
      anon_sym_DASH,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(920), 1,
      anon_sym_quoteGoal,
    ACTIONS(928), 1,
      anon_sym_let,
    ACTIONS(3056), 1,
      sym_id,
    ACTIONS(3058), 1,
      anon_sym_BSLASH,
    ACTIONS(3060), 1,
      anon_sym_u03bb,
    ACTIONS(3064), 1,
      anon_sym_record,
    ACTIONS(3066), 1,
      anon_sym_LPAREN,
    ACTIONS(3068), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3070), 1,
      anon_sym_u2983,
    ACTIONS(3072), 1,
      anon_sym_LBRACE,
    ACTIONS(3074), 1,
      anon_sym_RBRACE,
    ACTIONS(3076), 1,
      aux_sym__qid_token1,
    ACTIONS(3078), 1,
      anon_sym_DOT,
    ACTIONS(3080), 1,
      anon_sym_tactic,
    ACTIONS(3082), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3084), 1,
      anon_sym_u2987,
    ACTIONS(3088), 1,
      anon_sym_Set,
    STATE(3697), 1,
      sym_attributes,
    STATE(3892), 1,
      aux_sym__atoms,
    STATE(6084), 1,
      sym__qid,
    STATE(6427), 1,
      sym_atom,
    STATE(8123), 1,
      sym__LAMBDA,
    STATE(8396), 1,
      sym__FORALL,
    STATE(9546), 1,
      aux_sym__field_assignments_repeat1,
    STATE(10062), 1,
      sym_field_assignment,
    STATE(12382), 1,
      sym__field_assignments,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3086), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6715), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6714), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3062), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10002), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [141176] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1980), 1,
      sym_id,
    ACTIONS(1984), 1,
      anon_sym_BSLASH,
    ACTIONS(1986), 1,
      anon_sym_u03bb,
    ACTIONS(1990), 1,
      anon_sym_record,
    ACTIONS(1992), 1,
      anon_sym_LPAREN,
    ACTIONS(1994), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1996), 1,
      anon_sym_u2983,
    ACTIONS(1998), 1,
      anon_sym_LBRACE,
    ACTIONS(2000), 1,
      aux_sym__qid_token1,
    ACTIONS(2002), 1,
      anon_sym_DOT,
    ACTIONS(2004), 1,
      anon_sym_quoteGoal,
    ACTIONS(2006), 1,
      anon_sym_tactic,
    ACTIONS(2008), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2010), 1,
      anon_sym_u2987,
    ACTIONS(2012), 1,
      anon_sym_let,
    ACTIONS(2016), 1,
      anon_sym_Set,
    STATE(3156), 1,
      aux_sym__atoms,
    STATE(3740), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4972), 1,
      sym_atom,
    STATE(6248), 1,
      sym_attributes,
    STATE(8039), 1,
      sym__LAMBDA,
    STATE(8483), 1,
      sym__FORALL,
    STATE(8992), 1,
      sym_expr,
    STATE(9685), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1982), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2014), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5336), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8659), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5185), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1988), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [141312] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(10894), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [141448] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(8961), 1,
      sym_expr,
    STATE(9990), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [141584] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(2384), 1,
      sym_id,
    ACTIONS(2388), 1,
      anon_sym_BSLASH,
    ACTIONS(2390), 1,
      anon_sym_u03bb,
    ACTIONS(2394), 1,
      anon_sym_record,
    ACTIONS(2396), 1,
      anon_sym_LPAREN,
    ACTIONS(2398), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2400), 1,
      anon_sym_u2983,
    ACTIONS(2402), 1,
      anon_sym_LBRACE,
    ACTIONS(2404), 1,
      aux_sym__qid_token1,
    ACTIONS(2406), 1,
      anon_sym_DOT,
    ACTIONS(2408), 1,
      anon_sym_quoteGoal,
    ACTIONS(2410), 1,
      anon_sym_tactic,
    ACTIONS(2412), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2414), 1,
      anon_sym_u2987,
    ACTIONS(2416), 1,
      anon_sym_let,
    ACTIONS(2420), 1,
      anon_sym_Set,
    STATE(3210), 1,
      aux_sym__atoms,
    STATE(3752), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4775), 1,
      sym_atom,
    STATE(6209), 1,
      sym_attributes,
    STATE(8139), 1,
      sym__LAMBDA,
    STATE(8518), 1,
      sym__FORALL,
    STATE(9440), 1,
      sym__with_exprs,
    STATE(9446), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2386), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2418), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4831), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8636), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4896), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2392), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [141720] = 35,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(700), 1,
      anon_sym_LBRACE_DASH_POUND,
    ACTIONS(3090), 1,
      sym_id,
    ACTIONS(3096), 1,
      anon_sym_BSLASH,
    ACTIONS(3098), 1,
      anon_sym_u03bb,
    ACTIONS(3102), 1,
      anon_sym_record,
    ACTIONS(3104), 1,
      anon_sym_LPAREN,
    ACTIONS(3106), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3108), 1,
      anon_sym_u2983,
    ACTIONS(3110), 1,
      anon_sym_LBRACE,
    ACTIONS(3112), 1,
      aux_sym__qid_token1,
    ACTIONS(3114), 1,
      anon_sym_DOT,
    ACTIONS(3116), 1,
      anon_sym_quoteGoal,
    ACTIONS(3118), 1,
      anon_sym_tactic,
    ACTIONS(3120), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3122), 1,
      anon_sym_u2987,
    ACTIONS(3124), 1,
      anon_sym_let,
    ACTIONS(3128), 1,
      anon_sym_Set,
    STATE(1820), 1,
      sym__ARROW,
    STATE(2743), 1,
      aux_sym__lambda_clauses_repeat1,
    STATE(3319), 1,
      sym_catchall_pragma,
    STATE(3477), 1,
      aux_sym__atoms,
    STATE(4365), 1,
      sym_atom,
    STATE(8099), 1,
      sym__LAMBDA,
    STATE(8393), 1,
      sym__FORALL,
    STATE(8999), 1,
      sym__lambda_clauses,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3092), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3094), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(3126), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4293), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(8993), 3,
      sym__lambda_clause_maybe_absurd,
      sym_lambda_clause_absurd,
      sym_lambda_clause,
    STATE(4285), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9000), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3100), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [141854] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(10893), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [141990] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2298), 1,
      sym_id,
    ACTIONS(2302), 1,
      anon_sym_BSLASH,
    ACTIONS(2304), 1,
      anon_sym_u03bb,
    ACTIONS(2308), 1,
      anon_sym_record,
    ACTIONS(2310), 1,
      anon_sym_LPAREN,
    ACTIONS(2312), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2314), 1,
      anon_sym_u2983,
    ACTIONS(2316), 1,
      anon_sym_LBRACE,
    ACTIONS(2318), 1,
      aux_sym__qid_token1,
    ACTIONS(2320), 1,
      anon_sym_DOT,
    ACTIONS(2322), 1,
      anon_sym_quoteGoal,
    ACTIONS(2324), 1,
      anon_sym_tactic,
    ACTIONS(2326), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2328), 1,
      anon_sym_u2987,
    ACTIONS(2330), 1,
      anon_sym_let,
    ACTIONS(2334), 1,
      anon_sym_Set,
    STATE(3178), 1,
      aux_sym__atoms,
    STATE(3707), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4989), 1,
      sym_atom,
    STATE(6249), 1,
      sym_attributes,
    STATE(8138), 1,
      sym__LAMBDA,
    STATE(8476), 1,
      sym__FORALL,
    STATE(8970), 1,
      sym_expr,
    STATE(9655), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2300), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2332), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5354), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8660), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5347), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2306), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [142126] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(940), 1,
      sym_id,
    ACTIONS(944), 1,
      anon_sym_BSLASH,
    ACTIONS(946), 1,
      anon_sym_u03bb,
    ACTIONS(950), 1,
      anon_sym_record,
    ACTIONS(952), 1,
      anon_sym_LPAREN,
    ACTIONS(954), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(956), 1,
      anon_sym_u2983,
    ACTIONS(958), 1,
      anon_sym_LBRACE,
    ACTIONS(960), 1,
      aux_sym__qid_token1,
    ACTIONS(962), 1,
      anon_sym_DOT,
    ACTIONS(964), 1,
      anon_sym_quoteGoal,
    ACTIONS(966), 1,
      anon_sym_tactic,
    ACTIONS(968), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(970), 1,
      anon_sym_u2987,
    ACTIONS(972), 1,
      anon_sym_let,
    ACTIONS(976), 1,
      anon_sym_Set,
    STATE(3278), 1,
      aux_sym__atoms,
    STATE(3743), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4712), 1,
      sym_atom,
    STATE(6265), 1,
      sym_attributes,
    STATE(8054), 1,
      sym__LAMBDA,
    STATE(8355), 1,
      sym__FORALL,
    STATE(8959), 1,
      sym_expr,
    STATE(9518), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(942), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(974), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4733), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8674), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4742), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(948), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [142262] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(940), 1,
      sym_id,
    ACTIONS(944), 1,
      anon_sym_BSLASH,
    ACTIONS(946), 1,
      anon_sym_u03bb,
    ACTIONS(950), 1,
      anon_sym_record,
    ACTIONS(952), 1,
      anon_sym_LPAREN,
    ACTIONS(954), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(956), 1,
      anon_sym_u2983,
    ACTIONS(958), 1,
      anon_sym_LBRACE,
    ACTIONS(960), 1,
      aux_sym__qid_token1,
    ACTIONS(962), 1,
      anon_sym_DOT,
    ACTIONS(964), 1,
      anon_sym_quoteGoal,
    ACTIONS(966), 1,
      anon_sym_tactic,
    ACTIONS(968), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(970), 1,
      anon_sym_u2987,
    ACTIONS(972), 1,
      anon_sym_let,
    ACTIONS(976), 1,
      anon_sym_Set,
    STATE(3278), 1,
      aux_sym__atoms,
    STATE(3743), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4712), 1,
      sym_atom,
    STATE(6265), 1,
      sym_attributes,
    STATE(8054), 1,
      sym__LAMBDA,
    STATE(8355), 1,
      sym__FORALL,
    STATE(8992), 1,
      sym_expr,
    STATE(9518), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(942), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(974), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4733), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8674), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4742), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(948), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [142398] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1910), 1,
      anon_sym_BSLASH,
    ACTIONS(1912), 1,
      anon_sym_u03bb,
    ACTIONS(1928), 1,
      anon_sym_quoteGoal,
    ACTIONS(1930), 1,
      anon_sym_tactic,
    ACTIONS(1936), 1,
      anon_sym_let,
    ACTIONS(2174), 1,
      sym_id,
    ACTIONS(2182), 1,
      anon_sym_record,
    ACTIONS(2184), 1,
      anon_sym_LPAREN,
    ACTIONS(2186), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2188), 1,
      anon_sym_u2983,
    ACTIONS(2190), 1,
      anon_sym_LBRACE,
    ACTIONS(2192), 1,
      aux_sym__qid_token1,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2198), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2200), 1,
      anon_sym_u2987,
    ACTIONS(2204), 1,
      anon_sym_Set,
    STATE(3339), 1,
      aux_sym__atoms,
    STATE(3717), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4611), 1,
      sym_atom,
    STATE(6264), 1,
      sym_attributes,
    STATE(8153), 1,
      sym__LAMBDA,
    STATE(8431), 1,
      sym__FORALL,
    STATE(8937), 1,
      sym_expr,
    STATE(9486), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1906), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4536), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8673), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4531), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2180), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [142534] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(8951), 1,
      sym_expr,
    STATE(9990), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [142670] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(8959), 1,
      sym_expr,
    STATE(10084), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [142806] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(9990), 1,
      sym__with_exprs,
    STATE(11446), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [142942] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(10253), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [143078] = 36,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(11599), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [143214] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(10252), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [143350] = 36,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(10251), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [143486] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(10250), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [143622] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(109), 1,
      anon_sym_BSLASH,
    ACTIONS(111), 1,
      anon_sym_u03bb,
    ACTIONS(147), 1,
      anon_sym_quoteGoal,
    ACTIONS(149), 1,
      anon_sym_tactic,
    ACTIONS(155), 1,
      anon_sym_let,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(2462), 1,
      sym_id,
    ACTIONS(2466), 1,
      anon_sym_record,
    ACTIONS(2468), 1,
      anon_sym_LPAREN,
    ACTIONS(2470), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2472), 1,
      anon_sym_u2983,
    ACTIONS(2474), 1,
      anon_sym_LBRACE,
    ACTIONS(2476), 1,
      aux_sym__qid_token1,
    ACTIONS(2478), 1,
      anon_sym_DOT,
    ACTIONS(2480), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2482), 1,
      anon_sym_u2987,
    ACTIONS(2486), 1,
      anon_sym_Set,
    STATE(3259), 1,
      aux_sym__atoms,
    STATE(3734), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4054), 1,
      sym_atom,
    STATE(6260), 1,
      sym_attributes,
    STATE(8146), 1,
      sym__LAMBDA,
    STATE(8343), 1,
      sym__FORALL,
    STATE(8941), 1,
      sym_expr,
    STATE(9017), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(107), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2484), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4044), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8667), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4052), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2464), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [143758] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(3130), 1,
      sym_id,
    ACTIONS(3134), 1,
      anon_sym_BSLASH,
    ACTIONS(3136), 1,
      anon_sym_u03bb,
    ACTIONS(3140), 1,
      anon_sym_record,
    ACTIONS(3142), 1,
      anon_sym_LPAREN,
    ACTIONS(3144), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3146), 1,
      anon_sym_u2983,
    ACTIONS(3148), 1,
      anon_sym_LBRACE,
    ACTIONS(3150), 1,
      aux_sym__qid_token1,
    ACTIONS(3152), 1,
      anon_sym_DOT,
    ACTIONS(3154), 1,
      anon_sym_quoteGoal,
    ACTIONS(3156), 1,
      anon_sym_tactic,
    ACTIONS(3158), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3160), 1,
      anon_sym_u2987,
    ACTIONS(3162), 1,
      anon_sym_let,
    ACTIONS(3166), 1,
      anon_sym_Set,
    STATE(3151), 1,
      aux_sym__atoms,
    STATE(3719), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4518), 1,
      sym_atom,
    STATE(6221), 1,
      sym_attributes,
    STATE(8076), 1,
      sym__LAMBDA,
    STATE(8363), 1,
      sym__FORALL,
    STATE(8949), 1,
      sym_expr,
    STATE(9351), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3132), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3164), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4493), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8662), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4496), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3138), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [143894] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(10892), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [144030] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(11379), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [144166] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(9990), 1,
      sym__with_exprs,
    STATE(11509), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [144302] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(10065), 1,
      sym__with_exprs,
    STATE(11508), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [144438] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(3130), 1,
      sym_id,
    ACTIONS(3134), 1,
      anon_sym_BSLASH,
    ACTIONS(3136), 1,
      anon_sym_u03bb,
    ACTIONS(3140), 1,
      anon_sym_record,
    ACTIONS(3142), 1,
      anon_sym_LPAREN,
    ACTIONS(3144), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3146), 1,
      anon_sym_u2983,
    ACTIONS(3148), 1,
      anon_sym_LBRACE,
    ACTIONS(3150), 1,
      aux_sym__qid_token1,
    ACTIONS(3152), 1,
      anon_sym_DOT,
    ACTIONS(3154), 1,
      anon_sym_quoteGoal,
    ACTIONS(3156), 1,
      anon_sym_tactic,
    ACTIONS(3158), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3160), 1,
      anon_sym_u2987,
    ACTIONS(3162), 1,
      anon_sym_let,
    ACTIONS(3166), 1,
      anon_sym_Set,
    STATE(3151), 1,
      aux_sym__atoms,
    STATE(3719), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4518), 1,
      sym_atom,
    STATE(6221), 1,
      sym_attributes,
    STATE(8076), 1,
      sym__LAMBDA,
    STATE(8363), 1,
      sym__FORALL,
    STATE(8982), 1,
      sym_expr,
    STATE(9351), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3132), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3164), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4493), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8662), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4496), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3138), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [144574] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2488), 1,
      sym_id,
    ACTIONS(2492), 1,
      anon_sym_BSLASH,
    ACTIONS(2494), 1,
      anon_sym_u03bb,
    ACTIONS(2498), 1,
      anon_sym_record,
    ACTIONS(2500), 1,
      anon_sym_LPAREN,
    ACTIONS(2502), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2504), 1,
      anon_sym_u2983,
    ACTIONS(2506), 1,
      anon_sym_LBRACE,
    ACTIONS(2508), 1,
      aux_sym__qid_token1,
    ACTIONS(2510), 1,
      anon_sym_DOT,
    ACTIONS(2512), 1,
      anon_sym_quoteGoal,
    ACTIONS(2514), 1,
      anon_sym_tactic,
    ACTIONS(2516), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2518), 1,
      anon_sym_u2987,
    ACTIONS(2520), 1,
      anon_sym_let,
    ACTIONS(2524), 1,
      anon_sym_Set,
    STATE(3193), 1,
      aux_sym__atoms,
    STATE(3709), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5643), 1,
      sym_atom,
    STATE(6216), 1,
      sym_attributes,
    STATE(8096), 1,
      sym__LAMBDA,
    STATE(8497), 1,
      sym__FORALL,
    STATE(8961), 1,
      sym_expr,
    STATE(10138), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2490), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2522), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5713), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8645), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5698), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2496), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [144710] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(3130), 1,
      sym_id,
    ACTIONS(3134), 1,
      anon_sym_BSLASH,
    ACTIONS(3136), 1,
      anon_sym_u03bb,
    ACTIONS(3140), 1,
      anon_sym_record,
    ACTIONS(3142), 1,
      anon_sym_LPAREN,
    ACTIONS(3144), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3146), 1,
      anon_sym_u2983,
    ACTIONS(3148), 1,
      anon_sym_LBRACE,
    ACTIONS(3150), 1,
      aux_sym__qid_token1,
    ACTIONS(3152), 1,
      anon_sym_DOT,
    ACTIONS(3154), 1,
      anon_sym_quoteGoal,
    ACTIONS(3156), 1,
      anon_sym_tactic,
    ACTIONS(3158), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3160), 1,
      anon_sym_u2987,
    ACTIONS(3162), 1,
      anon_sym_let,
    ACTIONS(3166), 1,
      anon_sym_Set,
    STATE(3151), 1,
      aux_sym__atoms,
    STATE(3719), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4518), 1,
      sym_atom,
    STATE(6221), 1,
      sym_attributes,
    STATE(8076), 1,
      sym__LAMBDA,
    STATE(8363), 1,
      sym__FORALL,
    STATE(8952), 1,
      sym_expr,
    STATE(9351), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3132), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3164), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4493), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8662), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4496), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3138), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [144846] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2018), 1,
      sym_id,
    ACTIONS(2022), 1,
      anon_sym_BSLASH,
    ACTIONS(2024), 1,
      anon_sym_u03bb,
    ACTIONS(2028), 1,
      anon_sym_record,
    ACTIONS(2030), 1,
      anon_sym_LPAREN,
    ACTIONS(2032), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2034), 1,
      anon_sym_u2983,
    ACTIONS(2036), 1,
      anon_sym_LBRACE,
    ACTIONS(2038), 1,
      aux_sym__qid_token1,
    ACTIONS(2040), 1,
      anon_sym_DOT,
    ACTIONS(2042), 1,
      anon_sym_quoteGoal,
    ACTIONS(2044), 1,
      anon_sym_tactic,
    ACTIONS(2046), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2048), 1,
      anon_sym_u2987,
    ACTIONS(2050), 1,
      anon_sym_let,
    ACTIONS(2054), 1,
      anon_sym_Set,
    STATE(3271), 1,
      aux_sym__atoms,
    STATE(3748), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4997), 1,
      sym_atom,
    STATE(6254), 1,
      sym_attributes,
    STATE(8033), 1,
      sym__LAMBDA,
    STATE(8463), 1,
      sym__FORALL,
    STATE(8978), 1,
      sym_expr,
    STATE(9607), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2020), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2052), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5176), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8669), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5183), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2026), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [144982] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(10425), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [145118] = 36,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(11785), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [145254] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(3130), 1,
      sym_id,
    ACTIONS(3134), 1,
      anon_sym_BSLASH,
    ACTIONS(3136), 1,
      anon_sym_u03bb,
    ACTIONS(3140), 1,
      anon_sym_record,
    ACTIONS(3142), 1,
      anon_sym_LPAREN,
    ACTIONS(3144), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3146), 1,
      anon_sym_u2983,
    ACTIONS(3148), 1,
      anon_sym_LBRACE,
    ACTIONS(3150), 1,
      aux_sym__qid_token1,
    ACTIONS(3152), 1,
      anon_sym_DOT,
    ACTIONS(3154), 1,
      anon_sym_quoteGoal,
    ACTIONS(3156), 1,
      anon_sym_tactic,
    ACTIONS(3158), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3160), 1,
      anon_sym_u2987,
    ACTIONS(3162), 1,
      anon_sym_let,
    ACTIONS(3166), 1,
      anon_sym_Set,
    STATE(3151), 1,
      aux_sym__atoms,
    STATE(3719), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4518), 1,
      sym_atom,
    STATE(6221), 1,
      sym_attributes,
    STATE(8076), 1,
      sym__LAMBDA,
    STATE(8363), 1,
      sym__FORALL,
    STATE(8948), 1,
      sym_expr,
    STATE(9351), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3132), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3164), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4493), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8662), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4496), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3138), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [145390] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(3130), 1,
      sym_id,
    ACTIONS(3134), 1,
      anon_sym_BSLASH,
    ACTIONS(3136), 1,
      anon_sym_u03bb,
    ACTIONS(3140), 1,
      anon_sym_record,
    ACTIONS(3142), 1,
      anon_sym_LPAREN,
    ACTIONS(3144), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3146), 1,
      anon_sym_u2983,
    ACTIONS(3148), 1,
      anon_sym_LBRACE,
    ACTIONS(3150), 1,
      aux_sym__qid_token1,
    ACTIONS(3152), 1,
      anon_sym_DOT,
    ACTIONS(3154), 1,
      anon_sym_quoteGoal,
    ACTIONS(3156), 1,
      anon_sym_tactic,
    ACTIONS(3158), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3160), 1,
      anon_sym_u2987,
    ACTIONS(3162), 1,
      anon_sym_let,
    ACTIONS(3166), 1,
      anon_sym_Set,
    STATE(3151), 1,
      aux_sym__atoms,
    STATE(3719), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4518), 1,
      sym_atom,
    STATE(6221), 1,
      sym_attributes,
    STATE(8076), 1,
      sym__LAMBDA,
    STATE(8363), 1,
      sym__FORALL,
    STATE(8939), 1,
      sym_expr,
    STATE(9351), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3132), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3164), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4493), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8662), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4496), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3138), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [145526] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(3130), 1,
      sym_id,
    ACTIONS(3134), 1,
      anon_sym_BSLASH,
    ACTIONS(3136), 1,
      anon_sym_u03bb,
    ACTIONS(3140), 1,
      anon_sym_record,
    ACTIONS(3142), 1,
      anon_sym_LPAREN,
    ACTIONS(3144), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3146), 1,
      anon_sym_u2983,
    ACTIONS(3148), 1,
      anon_sym_LBRACE,
    ACTIONS(3150), 1,
      aux_sym__qid_token1,
    ACTIONS(3152), 1,
      anon_sym_DOT,
    ACTIONS(3154), 1,
      anon_sym_quoteGoal,
    ACTIONS(3156), 1,
      anon_sym_tactic,
    ACTIONS(3158), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3160), 1,
      anon_sym_u2987,
    ACTIONS(3162), 1,
      anon_sym_let,
    ACTIONS(3166), 1,
      anon_sym_Set,
    STATE(3151), 1,
      aux_sym__atoms,
    STATE(3719), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4518), 1,
      sym_atom,
    STATE(6221), 1,
      sym_attributes,
    STATE(8076), 1,
      sym__LAMBDA,
    STATE(8363), 1,
      sym__FORALL,
    STATE(8941), 1,
      sym_expr,
    STATE(9351), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3132), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3164), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4493), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8662), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4496), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3138), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [145662] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(9990), 1,
      sym__with_exprs,
    STATE(11799), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [145798] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(8974), 1,
      sym_expr,
    STATE(9990), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [145934] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(8978), 1,
      sym_expr,
    STATE(9990), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [146070] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(8959), 1,
      sym_expr,
    STATE(10065), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [146206] = 34,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(700), 1,
      anon_sym_LBRACE_DASH_POUND,
    ACTIONS(2206), 1,
      sym_id,
    ACTIONS(2212), 1,
      anon_sym_BSLASH,
    ACTIONS(2214), 1,
      anon_sym_u03bb,
    ACTIONS(2218), 1,
      anon_sym_record,
    ACTIONS(2220), 1,
      anon_sym_LPAREN,
    ACTIONS(2222), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2224), 1,
      anon_sym_u2983,
    ACTIONS(2226), 1,
      anon_sym_LBRACE,
    ACTIONS(2228), 1,
      aux_sym__qid_token1,
    ACTIONS(2230), 1,
      anon_sym_DOT,
    ACTIONS(2232), 1,
      anon_sym_quoteGoal,
    ACTIONS(2234), 1,
      anon_sym_tactic,
    ACTIONS(2236), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2238), 1,
      anon_sym_u2987,
    ACTIONS(2240), 1,
      anon_sym_let,
    ACTIONS(2244), 1,
      anon_sym_Set,
    STATE(2163), 1,
      sym__ARROW,
    STATE(2749), 1,
      aux_sym__lambda_clauses_repeat1,
    STATE(3205), 1,
      sym_catchall_pragma,
    STATE(3701), 1,
      aux_sym__atoms,
    STATE(4718), 1,
      sym_atom,
    STATE(8035), 1,
      sym__LAMBDA,
    STATE(8402), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2210), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(2242), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4812), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(8999), 4,
      sym__lambda_clauses,
      sym__lambda_clause_maybe_absurd,
      sym_lambda_clause_absurd,
      sym_lambda_clause,
    STATE(4858), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9000), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2216), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [146338] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2018), 1,
      sym_id,
    ACTIONS(2022), 1,
      anon_sym_BSLASH,
    ACTIONS(2024), 1,
      anon_sym_u03bb,
    ACTIONS(2028), 1,
      anon_sym_record,
    ACTIONS(2030), 1,
      anon_sym_LPAREN,
    ACTIONS(2032), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2034), 1,
      anon_sym_u2983,
    ACTIONS(2036), 1,
      anon_sym_LBRACE,
    ACTIONS(2038), 1,
      aux_sym__qid_token1,
    ACTIONS(2040), 1,
      anon_sym_DOT,
    ACTIONS(2042), 1,
      anon_sym_quoteGoal,
    ACTIONS(2044), 1,
      anon_sym_tactic,
    ACTIONS(2046), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2048), 1,
      anon_sym_u2987,
    ACTIONS(2050), 1,
      anon_sym_let,
    ACTIONS(2054), 1,
      anon_sym_Set,
    STATE(3271), 1,
      aux_sym__atoms,
    STATE(3748), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4997), 1,
      sym_atom,
    STATE(6254), 1,
      sym_attributes,
    STATE(8033), 1,
      sym__LAMBDA,
    STATE(8463), 1,
      sym__FORALL,
    STATE(8974), 1,
      sym_expr,
    STATE(9607), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2020), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2052), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5176), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8669), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5183), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2026), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [146474] = 34,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(700), 1,
      anon_sym_LBRACE_DASH_POUND,
    ACTIONS(3168), 1,
      sym_id,
    ACTIONS(3174), 1,
      anon_sym_BSLASH,
    ACTIONS(3176), 1,
      anon_sym_u03bb,
    ACTIONS(3180), 1,
      anon_sym_record,
    ACTIONS(3182), 1,
      anon_sym_LPAREN,
    ACTIONS(3184), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3186), 1,
      anon_sym_u2983,
    ACTIONS(3188), 1,
      anon_sym_LBRACE,
    ACTIONS(3190), 1,
      aux_sym__qid_token1,
    ACTIONS(3192), 1,
      anon_sym_DOT,
    ACTIONS(3194), 1,
      anon_sym_quoteGoal,
    ACTIONS(3196), 1,
      anon_sym_tactic,
    ACTIONS(3198), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3200), 1,
      anon_sym_u2987,
    ACTIONS(3202), 1,
      anon_sym_let,
    ACTIONS(3206), 1,
      anon_sym_Set,
    STATE(2310), 1,
      sym__ARROW,
    STATE(2710), 1,
      aux_sym__lambda_clauses_repeat1,
    STATE(3226), 1,
      sym_catchall_pragma,
    STATE(3553), 1,
      aux_sym__atoms,
    STATE(5142), 1,
      sym_atom,
    STATE(8051), 1,
      sym__LAMBDA,
    STATE(8409), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3170), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3172), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(3204), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4934), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(8999), 4,
      sym__lambda_clauses,
      sym__lambda_clause_maybe_absurd,
      sym_lambda_clause_absurd,
      sym_lambda_clause,
    STATE(4921), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9000), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3178), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [146606] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(10065), 1,
      sym__with_exprs,
    STATE(11028), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [146742] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(9990), 1,
      sym__with_exprs,
    STATE(11029), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [146878] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2018), 1,
      sym_id,
    ACTIONS(2022), 1,
      anon_sym_BSLASH,
    ACTIONS(2024), 1,
      anon_sym_u03bb,
    ACTIONS(2028), 1,
      anon_sym_record,
    ACTIONS(2030), 1,
      anon_sym_LPAREN,
    ACTIONS(2032), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2034), 1,
      anon_sym_u2983,
    ACTIONS(2036), 1,
      anon_sym_LBRACE,
    ACTIONS(2038), 1,
      aux_sym__qid_token1,
    ACTIONS(2040), 1,
      anon_sym_DOT,
    ACTIONS(2042), 1,
      anon_sym_quoteGoal,
    ACTIONS(2044), 1,
      anon_sym_tactic,
    ACTIONS(2046), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2048), 1,
      anon_sym_u2987,
    ACTIONS(2050), 1,
      anon_sym_let,
    ACTIONS(2054), 1,
      anon_sym_Set,
    STATE(3271), 1,
      aux_sym__atoms,
    STATE(3748), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4997), 1,
      sym_atom,
    STATE(6254), 1,
      sym_attributes,
    STATE(8033), 1,
      sym__LAMBDA,
    STATE(8463), 1,
      sym__FORALL,
    STATE(8951), 1,
      sym_expr,
    STATE(9607), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2020), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2052), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5176), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8669), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5183), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2026), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [147014] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(3130), 1,
      sym_id,
    ACTIONS(3134), 1,
      anon_sym_BSLASH,
    ACTIONS(3136), 1,
      anon_sym_u03bb,
    ACTIONS(3140), 1,
      anon_sym_record,
    ACTIONS(3142), 1,
      anon_sym_LPAREN,
    ACTIONS(3144), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3146), 1,
      anon_sym_u2983,
    ACTIONS(3148), 1,
      anon_sym_LBRACE,
    ACTIONS(3150), 1,
      aux_sym__qid_token1,
    ACTIONS(3152), 1,
      anon_sym_DOT,
    ACTIONS(3154), 1,
      anon_sym_quoteGoal,
    ACTIONS(3156), 1,
      anon_sym_tactic,
    ACTIONS(3158), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3160), 1,
      anon_sym_u2987,
    ACTIONS(3162), 1,
      anon_sym_let,
    ACTIONS(3166), 1,
      anon_sym_Set,
    STATE(3151), 1,
      aux_sym__atoms,
    STATE(3719), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4518), 1,
      sym_atom,
    STATE(6221), 1,
      sym_attributes,
    STATE(8076), 1,
      sym__LAMBDA,
    STATE(8363), 1,
      sym__FORALL,
    STATE(8957), 1,
      sym_expr,
    STATE(9351), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3132), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3164), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4493), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8662), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4496), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3138), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [147150] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2018), 1,
      sym_id,
    ACTIONS(2022), 1,
      anon_sym_BSLASH,
    ACTIONS(2024), 1,
      anon_sym_u03bb,
    ACTIONS(2028), 1,
      anon_sym_record,
    ACTIONS(2030), 1,
      anon_sym_LPAREN,
    ACTIONS(2032), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2034), 1,
      anon_sym_u2983,
    ACTIONS(2036), 1,
      anon_sym_LBRACE,
    ACTIONS(2038), 1,
      aux_sym__qid_token1,
    ACTIONS(2040), 1,
      anon_sym_DOT,
    ACTIONS(2042), 1,
      anon_sym_quoteGoal,
    ACTIONS(2044), 1,
      anon_sym_tactic,
    ACTIONS(2046), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2048), 1,
      anon_sym_u2987,
    ACTIONS(2050), 1,
      anon_sym_let,
    ACTIONS(2054), 1,
      anon_sym_Set,
    STATE(3271), 1,
      aux_sym__atoms,
    STATE(3748), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4997), 1,
      sym_atom,
    STATE(6254), 1,
      sym_attributes,
    STATE(8033), 1,
      sym__LAMBDA,
    STATE(8463), 1,
      sym__FORALL,
    STATE(8961), 1,
      sym_expr,
    STATE(9607), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2020), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2052), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5176), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8669), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5183), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2026), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [147286] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(109), 1,
      anon_sym_BSLASH,
    ACTIONS(111), 1,
      anon_sym_u03bb,
    ACTIONS(147), 1,
      anon_sym_quoteGoal,
    ACTIONS(149), 1,
      anon_sym_tactic,
    ACTIONS(155), 1,
      anon_sym_let,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(2462), 1,
      sym_id,
    ACTIONS(2466), 1,
      anon_sym_record,
    ACTIONS(2468), 1,
      anon_sym_LPAREN,
    ACTIONS(2470), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2472), 1,
      anon_sym_u2983,
    ACTIONS(2474), 1,
      anon_sym_LBRACE,
    ACTIONS(2476), 1,
      aux_sym__qid_token1,
    ACTIONS(2478), 1,
      anon_sym_DOT,
    ACTIONS(2480), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2482), 1,
      anon_sym_u2987,
    ACTIONS(2486), 1,
      anon_sym_Set,
    STATE(3259), 1,
      aux_sym__atoms,
    STATE(3734), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4054), 1,
      sym_atom,
    STATE(6260), 1,
      sym_attributes,
    STATE(8146), 1,
      sym__LAMBDA,
    STATE(8343), 1,
      sym__FORALL,
    STATE(8949), 1,
      sym_expr,
    STATE(9017), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(107), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2484), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4044), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8667), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4052), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2464), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [147422] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(3130), 1,
      sym_id,
    ACTIONS(3134), 1,
      anon_sym_BSLASH,
    ACTIONS(3136), 1,
      anon_sym_u03bb,
    ACTIONS(3140), 1,
      anon_sym_record,
    ACTIONS(3142), 1,
      anon_sym_LPAREN,
    ACTIONS(3144), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3146), 1,
      anon_sym_u2983,
    ACTIONS(3148), 1,
      anon_sym_LBRACE,
    ACTIONS(3150), 1,
      aux_sym__qid_token1,
    ACTIONS(3152), 1,
      anon_sym_DOT,
    ACTIONS(3154), 1,
      anon_sym_quoteGoal,
    ACTIONS(3156), 1,
      anon_sym_tactic,
    ACTIONS(3158), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3160), 1,
      anon_sym_u2987,
    ACTIONS(3162), 1,
      anon_sym_let,
    ACTIONS(3166), 1,
      anon_sym_Set,
    STATE(3151), 1,
      aux_sym__atoms,
    STATE(3719), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4518), 1,
      sym_atom,
    STATE(6221), 1,
      sym_attributes,
    STATE(8076), 1,
      sym__LAMBDA,
    STATE(8363), 1,
      sym__FORALL,
    STATE(9003), 1,
      sym_expr,
    STATE(9351), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3132), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3164), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4493), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8662), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4496), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3138), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [147558] = 36,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(11036), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [147694] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(11037), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [147830] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(3130), 1,
      sym_id,
    ACTIONS(3134), 1,
      anon_sym_BSLASH,
    ACTIONS(3136), 1,
      anon_sym_u03bb,
    ACTIONS(3140), 1,
      anon_sym_record,
    ACTIONS(3142), 1,
      anon_sym_LPAREN,
    ACTIONS(3144), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3146), 1,
      anon_sym_u2983,
    ACTIONS(3148), 1,
      anon_sym_LBRACE,
    ACTIONS(3150), 1,
      aux_sym__qid_token1,
    ACTIONS(3152), 1,
      anon_sym_DOT,
    ACTIONS(3154), 1,
      anon_sym_quoteGoal,
    ACTIONS(3156), 1,
      anon_sym_tactic,
    ACTIONS(3158), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3160), 1,
      anon_sym_u2987,
    ACTIONS(3162), 1,
      anon_sym_let,
    ACTIONS(3166), 1,
      anon_sym_Set,
    STATE(3151), 1,
      aux_sym__atoms,
    STATE(3719), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4518), 1,
      sym_atom,
    STATE(6221), 1,
      sym_attributes,
    STATE(8076), 1,
      sym__LAMBDA,
    STATE(8363), 1,
      sym__FORALL,
    STATE(9002), 1,
      sym_expr,
    STATE(9351), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3132), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3164), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4493), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8662), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4496), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3138), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [147966] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(10065), 1,
      sym__with_exprs,
    STATE(11800), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [148102] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(109), 1,
      anon_sym_BSLASH,
    ACTIONS(111), 1,
      anon_sym_u03bb,
    ACTIONS(147), 1,
      anon_sym_quoteGoal,
    ACTIONS(149), 1,
      anon_sym_tactic,
    ACTIONS(155), 1,
      anon_sym_let,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(2462), 1,
      sym_id,
    ACTIONS(2466), 1,
      anon_sym_record,
    ACTIONS(2468), 1,
      anon_sym_LPAREN,
    ACTIONS(2470), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2472), 1,
      anon_sym_u2983,
    ACTIONS(2474), 1,
      anon_sym_LBRACE,
    ACTIONS(2476), 1,
      aux_sym__qid_token1,
    ACTIONS(2478), 1,
      anon_sym_DOT,
    ACTIONS(2480), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2482), 1,
      anon_sym_u2987,
    ACTIONS(2486), 1,
      anon_sym_Set,
    STATE(3259), 1,
      aux_sym__atoms,
    STATE(3734), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4054), 1,
      sym_atom,
    STATE(6260), 1,
      sym_attributes,
    STATE(8146), 1,
      sym__LAMBDA,
    STATE(8343), 1,
      sym__FORALL,
    STATE(8982), 1,
      sym_expr,
    STATE(9017), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(107), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2484), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4044), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8667), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4052), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2464), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [148238] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(11038), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [148374] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(11039), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [148510] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(2384), 1,
      sym_id,
    ACTIONS(2388), 1,
      anon_sym_BSLASH,
    ACTIONS(2390), 1,
      anon_sym_u03bb,
    ACTIONS(2394), 1,
      anon_sym_record,
    ACTIONS(2396), 1,
      anon_sym_LPAREN,
    ACTIONS(2398), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2400), 1,
      anon_sym_u2983,
    ACTIONS(2402), 1,
      anon_sym_LBRACE,
    ACTIONS(2404), 1,
      aux_sym__qid_token1,
    ACTIONS(2406), 1,
      anon_sym_DOT,
    ACTIONS(2408), 1,
      anon_sym_quoteGoal,
    ACTIONS(2410), 1,
      anon_sym_tactic,
    ACTIONS(2412), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2414), 1,
      anon_sym_u2987,
    ACTIONS(2416), 1,
      anon_sym_let,
    ACTIONS(2420), 1,
      anon_sym_Set,
    STATE(3210), 1,
      aux_sym__atoms,
    STATE(3752), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4775), 1,
      sym_atom,
    STATE(6209), 1,
      sym_attributes,
    STATE(8139), 1,
      sym__LAMBDA,
    STATE(8518), 1,
      sym__FORALL,
    STATE(8949), 1,
      sym_expr,
    STATE(9440), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2386), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2418), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4831), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8636), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4896), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2392), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [148646] = 36,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(11040), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [148782] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(11042), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [148918] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(3016), 1,
      sym_id,
    ACTIONS(3020), 1,
      anon_sym_BSLASH,
    ACTIONS(3022), 1,
      anon_sym_u03bb,
    ACTIONS(3026), 1,
      anon_sym_record,
    ACTIONS(3028), 1,
      anon_sym_LPAREN,
    ACTIONS(3030), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3032), 1,
      anon_sym_u2983,
    ACTIONS(3034), 1,
      anon_sym_LBRACE,
    ACTIONS(3036), 1,
      aux_sym__qid_token1,
    ACTIONS(3038), 1,
      anon_sym_DOT,
    ACTIONS(3040), 1,
      anon_sym_quoteGoal,
    ACTIONS(3042), 1,
      anon_sym_tactic,
    ACTIONS(3044), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3046), 1,
      anon_sym_u2987,
    ACTIONS(3048), 1,
      anon_sym_let,
    ACTIONS(3052), 1,
      anon_sym_Set,
    STATE(3216), 1,
      aux_sym__atoms,
    STATE(3760), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5039), 1,
      sym_atom,
    STATE(6294), 1,
      sym_attributes,
    STATE(8127), 1,
      sym__LAMBDA,
    STATE(8388), 1,
      sym__FORALL,
    STATE(8970), 1,
      sym_expr,
    STATE(9599), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3018), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3050), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5330), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8672), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5333), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3024), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [149054] = 34,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(700), 1,
      anon_sym_LBRACE_DASH_POUND,
    ACTIONS(2526), 1,
      sym_id,
    ACTIONS(2532), 1,
      anon_sym_BSLASH,
    ACTIONS(2534), 1,
      anon_sym_u03bb,
    ACTIONS(2538), 1,
      anon_sym_record,
    ACTIONS(2540), 1,
      anon_sym_LPAREN,
    ACTIONS(2542), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2544), 1,
      anon_sym_u2983,
    ACTIONS(2546), 1,
      anon_sym_LBRACE,
    ACTIONS(2548), 1,
      aux_sym__qid_token1,
    ACTIONS(2550), 1,
      anon_sym_DOT,
    ACTIONS(2552), 1,
      anon_sym_quoteGoal,
    ACTIONS(2554), 1,
      anon_sym_tactic,
    ACTIONS(2556), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2558), 1,
      anon_sym_u2987,
    ACTIONS(2560), 1,
      anon_sym_let,
    ACTIONS(2564), 1,
      anon_sym_Set,
    STATE(1938), 1,
      sym__ARROW,
    STATE(2701), 1,
      aux_sym__lambda_clauses_repeat1,
    STATE(3281), 1,
      sym_catchall_pragma,
    STATE(3610), 1,
      aux_sym__atoms,
    STATE(4603), 1,
      sym_atom,
    STATE(8066), 1,
      sym__LAMBDA,
    STATE(8398), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2528), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2530), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(2562), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4464), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(8999), 4,
      sym__lambda_clauses,
      sym__lambda_clause_maybe_absurd,
      sym_lambda_clause_absurd,
      sym_lambda_clause,
    STATE(4473), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9000), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2536), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [149186] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(10249), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [149322] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2488), 1,
      sym_id,
    ACTIONS(2492), 1,
      anon_sym_BSLASH,
    ACTIONS(2494), 1,
      anon_sym_u03bb,
    ACTIONS(2498), 1,
      anon_sym_record,
    ACTIONS(2500), 1,
      anon_sym_LPAREN,
    ACTIONS(2502), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2504), 1,
      anon_sym_u2983,
    ACTIONS(2506), 1,
      anon_sym_LBRACE,
    ACTIONS(2508), 1,
      aux_sym__qid_token1,
    ACTIONS(2510), 1,
      anon_sym_DOT,
    ACTIONS(2512), 1,
      anon_sym_quoteGoal,
    ACTIONS(2514), 1,
      anon_sym_tactic,
    ACTIONS(2516), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2518), 1,
      anon_sym_u2987,
    ACTIONS(2520), 1,
      anon_sym_let,
    ACTIONS(2524), 1,
      anon_sym_Set,
    STATE(3193), 1,
      aux_sym__atoms,
    STATE(3709), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5643), 1,
      sym_atom,
    STATE(6216), 1,
      sym_attributes,
    STATE(8096), 1,
      sym__LAMBDA,
    STATE(8497), 1,
      sym__FORALL,
    STATE(8951), 1,
      sym_expr,
    STATE(10138), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2490), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2522), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5713), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8645), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5698), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2496), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [149458] = 36,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(10891), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [149594] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2488), 1,
      sym_id,
    ACTIONS(2492), 1,
      anon_sym_BSLASH,
    ACTIONS(2494), 1,
      anon_sym_u03bb,
    ACTIONS(2498), 1,
      anon_sym_record,
    ACTIONS(2500), 1,
      anon_sym_LPAREN,
    ACTIONS(2502), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2504), 1,
      anon_sym_u2983,
    ACTIONS(2506), 1,
      anon_sym_LBRACE,
    ACTIONS(2508), 1,
      aux_sym__qid_token1,
    ACTIONS(2510), 1,
      anon_sym_DOT,
    ACTIONS(2512), 1,
      anon_sym_quoteGoal,
    ACTIONS(2514), 1,
      anon_sym_tactic,
    ACTIONS(2516), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2518), 1,
      anon_sym_u2987,
    ACTIONS(2520), 1,
      anon_sym_let,
    ACTIONS(2524), 1,
      anon_sym_Set,
    STATE(3193), 1,
      aux_sym__atoms,
    STATE(3709), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5643), 1,
      sym_atom,
    STATE(6216), 1,
      sym_attributes,
    STATE(8096), 1,
      sym__LAMBDA,
    STATE(8497), 1,
      sym__FORALL,
    STATE(8974), 1,
      sym_expr,
    STATE(10138), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2490), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2522), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5713), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8645), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5698), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2496), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [149730] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(10248), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [149866] = 36,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(10247), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [150002] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(11043), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [150138] = 35,
    ACTIONS(700), 1,
      anon_sym_LBRACE_DASH_POUND,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(2656), 1,
      anon_sym_BSLASH,
    ACTIONS(2658), 1,
      anon_sym_u03bb,
    ACTIONS(2676), 1,
      anon_sym_quoteGoal,
    ACTIONS(2678), 1,
      anon_sym_tactic,
    ACTIONS(2684), 1,
      anon_sym_let,
    ACTIONS(3208), 1,
      sym_id,
    ACTIONS(3212), 1,
      anon_sym_record,
    ACTIONS(3214), 1,
      anon_sym_LPAREN,
    ACTIONS(3216), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3218), 1,
      anon_sym_u2983,
    ACTIONS(3220), 1,
      anon_sym_LBRACE,
    ACTIONS(3222), 1,
      aux_sym__qid_token1,
    ACTIONS(3224), 1,
      anon_sym_DOT,
    ACTIONS(3226), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3228), 1,
      anon_sym_u2987,
    ACTIONS(3232), 1,
      anon_sym_Set,
    STATE(2460), 1,
      sym__ARROW,
    STATE(2754), 1,
      aux_sym__lambda_clauses_repeat1,
    STATE(3200), 1,
      sym_catchall_pragma,
    STATE(3498), 1,
      aux_sym__atoms,
    STATE(5433), 1,
      sym_atom,
    STATE(8132), 1,
      sym__LAMBDA,
    STATE(8470), 1,
      sym__FORALL,
    STATE(9460), 1,
      sym__lambda_clauses,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(684), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(2654), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3230), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5579), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(8986), 3,
      sym__lambda_clause_maybe_absurd,
      sym_lambda_clause_absurd,
      sym_lambda_clause,
    STATE(5582), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9459), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3210), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [150272] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(9990), 1,
      sym__with_exprs,
    STATE(10242), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [150408] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(11377), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [150544] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2488), 1,
      sym_id,
    ACTIONS(2492), 1,
      anon_sym_BSLASH,
    ACTIONS(2494), 1,
      anon_sym_u03bb,
    ACTIONS(2498), 1,
      anon_sym_record,
    ACTIONS(2500), 1,
      anon_sym_LPAREN,
    ACTIONS(2502), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2504), 1,
      anon_sym_u2983,
    ACTIONS(2506), 1,
      anon_sym_LBRACE,
    ACTIONS(2508), 1,
      aux_sym__qid_token1,
    ACTIONS(2510), 1,
      anon_sym_DOT,
    ACTIONS(2512), 1,
      anon_sym_quoteGoal,
    ACTIONS(2514), 1,
      anon_sym_tactic,
    ACTIONS(2516), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2518), 1,
      anon_sym_u2987,
    ACTIONS(2520), 1,
      anon_sym_let,
    ACTIONS(2524), 1,
      anon_sym_Set,
    STATE(3193), 1,
      aux_sym__atoms,
    STATE(3709), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5643), 1,
      sym_atom,
    STATE(6216), 1,
      sym_attributes,
    STATE(8096), 1,
      sym__LAMBDA,
    STATE(8497), 1,
      sym__FORALL,
    STATE(8978), 1,
      sym_expr,
    STATE(10138), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2490), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2522), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5713), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8645), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5698), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2496), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [150680] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(11407), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [150816] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1980), 1,
      sym_id,
    ACTIONS(1984), 1,
      anon_sym_BSLASH,
    ACTIONS(1986), 1,
      anon_sym_u03bb,
    ACTIONS(1990), 1,
      anon_sym_record,
    ACTIONS(1992), 1,
      anon_sym_LPAREN,
    ACTIONS(1994), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1996), 1,
      anon_sym_u2983,
    ACTIONS(1998), 1,
      anon_sym_LBRACE,
    ACTIONS(2000), 1,
      aux_sym__qid_token1,
    ACTIONS(2002), 1,
      anon_sym_DOT,
    ACTIONS(2004), 1,
      anon_sym_quoteGoal,
    ACTIONS(2006), 1,
      anon_sym_tactic,
    ACTIONS(2008), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2010), 1,
      anon_sym_u2987,
    ACTIONS(2012), 1,
      anon_sym_let,
    ACTIONS(2016), 1,
      anon_sym_Set,
    STATE(3156), 1,
      aux_sym__atoms,
    STATE(3740), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4972), 1,
      sym_atom,
    STATE(6248), 1,
      sym_attributes,
    STATE(8039), 1,
      sym__LAMBDA,
    STATE(8483), 1,
      sym__FORALL,
    STATE(8959), 1,
      sym_expr,
    STATE(9685), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1982), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2014), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5336), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8659), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5185), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1988), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [150952] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(10065), 1,
      sym__with_exprs,
    STATE(10241), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [151088] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(2566), 1,
      sym_id,
    ACTIONS(2570), 1,
      anon_sym_BSLASH,
    ACTIONS(2572), 1,
      anon_sym_u03bb,
    ACTIONS(2576), 1,
      anon_sym_record,
    ACTIONS(2578), 1,
      anon_sym_LPAREN,
    ACTIONS(2580), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2582), 1,
      anon_sym_u2983,
    ACTIONS(2584), 1,
      anon_sym_LBRACE,
    ACTIONS(2586), 1,
      aux_sym__qid_token1,
    ACTIONS(2588), 1,
      anon_sym_DOT,
    ACTIONS(2590), 1,
      anon_sym_quoteGoal,
    ACTIONS(2592), 1,
      anon_sym_tactic,
    ACTIONS(2594), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2596), 1,
      anon_sym_u2987,
    ACTIONS(2598), 1,
      anon_sym_let,
    ACTIONS(2602), 1,
      anon_sym_Set,
    STATE(3214), 1,
      aux_sym__atoms,
    STATE(3714), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5536), 1,
      sym_atom,
    STATE(6208), 1,
      sym_attributes,
    STATE(8111), 1,
      sym__LAMBDA,
    STATE(8412), 1,
      sym__FORALL,
    STATE(10104), 1,
      sym_expr,
    STATE(10191), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2568), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2600), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5566), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8634), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5590), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2574), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [151224] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(2566), 1,
      sym_id,
    ACTIONS(2570), 1,
      anon_sym_BSLASH,
    ACTIONS(2572), 1,
      anon_sym_u03bb,
    ACTIONS(2576), 1,
      anon_sym_record,
    ACTIONS(2578), 1,
      anon_sym_LPAREN,
    ACTIONS(2580), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2582), 1,
      anon_sym_u2983,
    ACTIONS(2584), 1,
      anon_sym_LBRACE,
    ACTIONS(2586), 1,
      aux_sym__qid_token1,
    ACTIONS(2588), 1,
      anon_sym_DOT,
    ACTIONS(2590), 1,
      anon_sym_quoteGoal,
    ACTIONS(2592), 1,
      anon_sym_tactic,
    ACTIONS(2594), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2596), 1,
      anon_sym_u2987,
    ACTIONS(2598), 1,
      anon_sym_let,
    ACTIONS(2602), 1,
      anon_sym_Set,
    STATE(3214), 1,
      aux_sym__atoms,
    STATE(3714), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5536), 1,
      sym_atom,
    STATE(6208), 1,
      sym_attributes,
    STATE(8111), 1,
      sym__LAMBDA,
    STATE(8412), 1,
      sym__FORALL,
    STATE(10105), 1,
      sym_expr,
    STATE(10191), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2568), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2600), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5566), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8634), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5590), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2574), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [151360] = 36,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(11375), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [151496] = 36,
    ACTIONS(13), 1,
      anon_sym_BSLASH,
    ACTIONS(15), 1,
      anon_sym_u03bb,
    ACTIONS(75), 1,
      anon_sym_quoteGoal,
    ACTIONS(77), 1,
      anon_sym_tactic,
    ACTIONS(83), 1,
      anon_sym_let,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(2246), 1,
      sym_id,
    ACTIONS(2250), 1,
      anon_sym_record,
    ACTIONS(2252), 1,
      anon_sym_LPAREN,
    ACTIONS(2254), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2256), 1,
      anon_sym_u2983,
    ACTIONS(2258), 1,
      anon_sym_LBRACE,
    ACTIONS(2260), 1,
      aux_sym__qid_token1,
    ACTIONS(2262), 1,
      anon_sym_DOT,
    ACTIONS(2264), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2266), 1,
      anon_sym_u2987,
    ACTIONS(2270), 1,
      anon_sym_Set,
    STATE(3285), 1,
      aux_sym__atoms,
    STATE(3710), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4216), 1,
      sym_atom,
    STATE(6218), 1,
      sym_attributes,
    STATE(8114), 1,
      sym__LAMBDA,
    STATE(8288), 1,
      sym__FORALL,
    STATE(8939), 1,
      sym_expr,
    STATE(9125), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(11), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2268), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4151), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8647), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4153), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2248), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [151632] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(11939), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [151768] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(11044), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [151904] = 36,
    ACTIONS(13), 1,
      anon_sym_BSLASH,
    ACTIONS(15), 1,
      anon_sym_u03bb,
    ACTIONS(75), 1,
      anon_sym_quoteGoal,
    ACTIONS(77), 1,
      anon_sym_tactic,
    ACTIONS(83), 1,
      anon_sym_let,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(2246), 1,
      sym_id,
    ACTIONS(2250), 1,
      anon_sym_record,
    ACTIONS(2252), 1,
      anon_sym_LPAREN,
    ACTIONS(2254), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2256), 1,
      anon_sym_u2983,
    ACTIONS(2258), 1,
      anon_sym_LBRACE,
    ACTIONS(2260), 1,
      aux_sym__qid_token1,
    ACTIONS(2262), 1,
      anon_sym_DOT,
    ACTIONS(2264), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2266), 1,
      anon_sym_u2987,
    ACTIONS(2270), 1,
      anon_sym_Set,
    STATE(3285), 1,
      aux_sym__atoms,
    STATE(3710), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4216), 1,
      sym_atom,
    STATE(6218), 1,
      sym_attributes,
    STATE(8114), 1,
      sym__LAMBDA,
    STATE(8288), 1,
      sym__FORALL,
    STATE(8948), 1,
      sym_expr,
    STATE(9125), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(11), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2268), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4151), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8647), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4153), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2248), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [152040] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(2690), 1,
      sym_id,
    ACTIONS(2694), 1,
      anon_sym_BSLASH,
    ACTIONS(2696), 1,
      anon_sym_u03bb,
    ACTIONS(2700), 1,
      anon_sym_record,
    ACTIONS(2702), 1,
      anon_sym_LPAREN,
    ACTIONS(2704), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2706), 1,
      anon_sym_u2983,
    ACTIONS(2708), 1,
      anon_sym_LBRACE,
    ACTIONS(2710), 1,
      aux_sym__qid_token1,
    ACTIONS(2712), 1,
      anon_sym_DOT,
    ACTIONS(2714), 1,
      anon_sym_quoteGoal,
    ACTIONS(2716), 1,
      anon_sym_tactic,
    ACTIONS(2718), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2720), 1,
      anon_sym_u2987,
    ACTIONS(2722), 1,
      anon_sym_let,
    ACTIONS(2726), 1,
      anon_sym_Set,
    STATE(3168), 1,
      aux_sym__atoms,
    STATE(3725), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4047), 1,
      sym_atom,
    STATE(6301), 1,
      sym_attributes,
    STATE(8133), 1,
      sym__LAMBDA,
    STATE(8368), 1,
      sym__FORALL,
    STATE(8949), 1,
      sym_expr,
    STATE(9036), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2692), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2724), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4108), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8650), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4103), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2698), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [152176] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(11365), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [152312] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(11341), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [152448] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(11485), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [152584] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(11484), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [152720] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(11483), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [152856] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(2690), 1,
      sym_id,
    ACTIONS(2694), 1,
      anon_sym_BSLASH,
    ACTIONS(2696), 1,
      anon_sym_u03bb,
    ACTIONS(2700), 1,
      anon_sym_record,
    ACTIONS(2702), 1,
      anon_sym_LPAREN,
    ACTIONS(2704), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2706), 1,
      anon_sym_u2983,
    ACTIONS(2708), 1,
      anon_sym_LBRACE,
    ACTIONS(2710), 1,
      aux_sym__qid_token1,
    ACTIONS(2712), 1,
      anon_sym_DOT,
    ACTIONS(2714), 1,
      anon_sym_quoteGoal,
    ACTIONS(2716), 1,
      anon_sym_tactic,
    ACTIONS(2718), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2720), 1,
      anon_sym_u2987,
    ACTIONS(2722), 1,
      anon_sym_let,
    ACTIONS(2726), 1,
      anon_sym_Set,
    STATE(3168), 1,
      aux_sym__atoms,
    STATE(3725), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4047), 1,
      sym_atom,
    STATE(6301), 1,
      sym_attributes,
    STATE(8133), 1,
      sym__LAMBDA,
    STATE(8368), 1,
      sym__FORALL,
    STATE(8982), 1,
      sym_expr,
    STATE(9036), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2692), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2724), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4108), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8650), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4103), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2698), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [152992] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(11340), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [153128] = 35,
    ACTIONS(686), 1,
      anon_sym_BSLASH,
    ACTIONS(688), 1,
      anon_sym_u03bb,
    ACTIONS(692), 1,
      anon_sym_record,
    ACTIONS(694), 1,
      anon_sym_LPAREN,
    ACTIONS(696), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(698), 1,
      anon_sym_u2983,
    ACTIONS(700), 1,
      anon_sym_LBRACE_DASH_POUND,
    ACTIONS(702), 1,
      anon_sym_LBRACE,
    ACTIONS(708), 1,
      anon_sym_DOT,
    ACTIONS(714), 1,
      anon_sym_quoteGoal,
    ACTIONS(716), 1,
      anon_sym_tactic,
    ACTIONS(718), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(720), 1,
      anon_sym_u2987,
    ACTIONS(722), 1,
      anon_sym_let,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(728), 1,
      anon_sym_Set,
    ACTIONS(2336), 1,
      sym_id,
    ACTIONS(2342), 1,
      aux_sym__qid_token1,
    STATE(2651), 1,
      sym__ARROW,
    STATE(2664), 1,
      aux_sym__lambda_clauses_repeat1,
    STATE(3132), 1,
      sym_catchall_pragma,
    STATE(3688), 1,
      aux_sym__atoms,
    STATE(5128), 1,
      sym_atom,
    STATE(8064), 1,
      sym__LAMBDA,
    STATE(8495), 1,
      sym__FORALL,
    STATE(9460), 1,
      sym__lambda_clauses,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(682), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(726), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(2604), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(5069), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(8986), 3,
      sym__lambda_clause_maybe_absurd,
      sym_lambda_clause_absurd,
      sym_lambda_clause,
    STATE(5056), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9459), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(690), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [153262] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(2690), 1,
      sym_id,
    ACTIONS(2694), 1,
      anon_sym_BSLASH,
    ACTIONS(2696), 1,
      anon_sym_u03bb,
    ACTIONS(2700), 1,
      anon_sym_record,
    ACTIONS(2702), 1,
      anon_sym_LPAREN,
    ACTIONS(2704), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2706), 1,
      anon_sym_u2983,
    ACTIONS(2708), 1,
      anon_sym_LBRACE,
    ACTIONS(2710), 1,
      aux_sym__qid_token1,
    ACTIONS(2712), 1,
      anon_sym_DOT,
    ACTIONS(2714), 1,
      anon_sym_quoteGoal,
    ACTIONS(2716), 1,
      anon_sym_tactic,
    ACTIONS(2718), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2720), 1,
      anon_sym_u2987,
    ACTIONS(2722), 1,
      anon_sym_let,
    ACTIONS(2726), 1,
      anon_sym_Set,
    STATE(3168), 1,
      aux_sym__atoms,
    STATE(3725), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4047), 1,
      sym_atom,
    STATE(6301), 1,
      sym_attributes,
    STATE(8133), 1,
      sym__LAMBDA,
    STATE(8368), 1,
      sym__FORALL,
    STATE(8952), 1,
      sym_expr,
    STATE(9036), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2692), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2724), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4108), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8650), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4103), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2698), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [153398] = 35,
    ACTIONS(700), 1,
      anon_sym_LBRACE_DASH_POUND,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(3020), 1,
      anon_sym_BSLASH,
    ACTIONS(3022), 1,
      anon_sym_u03bb,
    ACTIONS(3040), 1,
      anon_sym_quoteGoal,
    ACTIONS(3042), 1,
      anon_sym_tactic,
    ACTIONS(3048), 1,
      anon_sym_let,
    ACTIONS(3234), 1,
      sym_id,
    ACTIONS(3240), 1,
      anon_sym_record,
    ACTIONS(3242), 1,
      anon_sym_LPAREN,
    ACTIONS(3244), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3246), 1,
      anon_sym_u2983,
    ACTIONS(3248), 1,
      anon_sym_LBRACE,
    ACTIONS(3250), 1,
      aux_sym__qid_token1,
    ACTIONS(3252), 1,
      anon_sym_DOT,
    ACTIONS(3254), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3256), 1,
      anon_sym_u2987,
    ACTIONS(3260), 1,
      anon_sym_Set,
    STATE(1692), 1,
      sym__ARROW,
    STATE(2684), 1,
      aux_sym__lambda_clauses_repeat1,
    STATE(3302), 1,
      sym_catchall_pragma,
    STATE(3393), 1,
      aux_sym__atoms,
    STATE(5549), 1,
      sym_atom,
    STATE(8127), 1,
      sym__LAMBDA,
    STATE(8388), 1,
      sym__FORALL,
    STATE(8987), 1,
      sym__lambda_clauses,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3018), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3236), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(3258), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5387), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(8986), 3,
      sym__lambda_clause_maybe_absurd,
      sym_lambda_clause_absurd,
      sym_lambda_clause,
    STATE(5375), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8988), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3238), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [153532] = 36,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(11482), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [153668] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(11413), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [153804] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(11480), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [153940] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(11479), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [154076] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(10517), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [154212] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(2690), 1,
      sym_id,
    ACTIONS(2694), 1,
      anon_sym_BSLASH,
    ACTIONS(2696), 1,
      anon_sym_u03bb,
    ACTIONS(2700), 1,
      anon_sym_record,
    ACTIONS(2702), 1,
      anon_sym_LPAREN,
    ACTIONS(2704), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2706), 1,
      anon_sym_u2983,
    ACTIONS(2708), 1,
      anon_sym_LBRACE,
    ACTIONS(2710), 1,
      aux_sym__qid_token1,
    ACTIONS(2712), 1,
      anon_sym_DOT,
    ACTIONS(2714), 1,
      anon_sym_quoteGoal,
    ACTIONS(2716), 1,
      anon_sym_tactic,
    ACTIONS(2718), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2720), 1,
      anon_sym_u2987,
    ACTIONS(2722), 1,
      anon_sym_let,
    ACTIONS(2726), 1,
      anon_sym_Set,
    STATE(3168), 1,
      aux_sym__atoms,
    STATE(3725), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4047), 1,
      sym_atom,
    STATE(6301), 1,
      sym_attributes,
    STATE(8133), 1,
      sym__LAMBDA,
    STATE(8368), 1,
      sym__FORALL,
    STATE(8948), 1,
      sym_expr,
    STATE(9036), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2692), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2724), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4108), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8650), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4103), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2698), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [154348] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(3262), 1,
      sym_id,
    ACTIONS(3266), 1,
      anon_sym_BSLASH,
    ACTIONS(3268), 1,
      anon_sym_u03bb,
    ACTIONS(3272), 1,
      anon_sym_record,
    ACTIONS(3274), 1,
      anon_sym_LPAREN,
    ACTIONS(3276), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3278), 1,
      anon_sym_u2983,
    ACTIONS(3280), 1,
      anon_sym_LBRACE,
    ACTIONS(3282), 1,
      aux_sym__qid_token1,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3286), 1,
      anon_sym_quoteGoal,
    ACTIONS(3288), 1,
      anon_sym_tactic,
    ACTIONS(3290), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3292), 1,
      anon_sym_u2987,
    ACTIONS(3294), 1,
      anon_sym_let,
    ACTIONS(3298), 1,
      anon_sym_Set,
    STATE(3148), 1,
      aux_sym__atoms,
    STATE(3739), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4014), 1,
      sym_atom,
    STATE(6261), 1,
      sym_attributes,
    STATE(8143), 1,
      sym__LAMBDA,
    STATE(8451), 1,
      sym__FORALL,
    STATE(8926), 1,
      sym__with_exprs,
    STATE(8941), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3264), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3296), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4032), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8687), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4012), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3270), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [154484] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(2690), 1,
      sym_id,
    ACTIONS(2694), 1,
      anon_sym_BSLASH,
    ACTIONS(2696), 1,
      anon_sym_u03bb,
    ACTIONS(2700), 1,
      anon_sym_record,
    ACTIONS(2702), 1,
      anon_sym_LPAREN,
    ACTIONS(2704), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2706), 1,
      anon_sym_u2983,
    ACTIONS(2708), 1,
      anon_sym_LBRACE,
    ACTIONS(2710), 1,
      aux_sym__qid_token1,
    ACTIONS(2712), 1,
      anon_sym_DOT,
    ACTIONS(2714), 1,
      anon_sym_quoteGoal,
    ACTIONS(2716), 1,
      anon_sym_tactic,
    ACTIONS(2718), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2720), 1,
      anon_sym_u2987,
    ACTIONS(2722), 1,
      anon_sym_let,
    ACTIONS(2726), 1,
      anon_sym_Set,
    STATE(3168), 1,
      aux_sym__atoms,
    STATE(3725), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4047), 1,
      sym_atom,
    STATE(6301), 1,
      sym_attributes,
    STATE(8133), 1,
      sym__LAMBDA,
    STATE(8368), 1,
      sym__FORALL,
    STATE(8939), 1,
      sym_expr,
    STATE(9036), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2692), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2724), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4108), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8650), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4103), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2698), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [154620] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(2690), 1,
      sym_id,
    ACTIONS(2694), 1,
      anon_sym_BSLASH,
    ACTIONS(2696), 1,
      anon_sym_u03bb,
    ACTIONS(2700), 1,
      anon_sym_record,
    ACTIONS(2702), 1,
      anon_sym_LPAREN,
    ACTIONS(2704), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2706), 1,
      anon_sym_u2983,
    ACTIONS(2708), 1,
      anon_sym_LBRACE,
    ACTIONS(2710), 1,
      aux_sym__qid_token1,
    ACTIONS(2712), 1,
      anon_sym_DOT,
    ACTIONS(2714), 1,
      anon_sym_quoteGoal,
    ACTIONS(2716), 1,
      anon_sym_tactic,
    ACTIONS(2718), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2720), 1,
      anon_sym_u2987,
    ACTIONS(2722), 1,
      anon_sym_let,
    ACTIONS(2726), 1,
      anon_sym_Set,
    STATE(3168), 1,
      aux_sym__atoms,
    STATE(3725), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4047), 1,
      sym_atom,
    STATE(6301), 1,
      sym_attributes,
    STATE(8133), 1,
      sym__LAMBDA,
    STATE(8368), 1,
      sym__FORALL,
    STATE(8941), 1,
      sym_expr,
    STATE(9036), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2692), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2724), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4108), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8650), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4103), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2698), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [154756] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2140), 1,
      anon_sym_BSLASH,
    ACTIONS(2142), 1,
      anon_sym_u03bb,
    ACTIONS(2160), 1,
      anon_sym_quoteGoal,
    ACTIONS(2162), 1,
      anon_sym_tactic,
    ACTIONS(2168), 1,
      anon_sym_let,
    ACTIONS(2272), 1,
      sym_id,
    ACTIONS(2276), 1,
      anon_sym_record,
    ACTIONS(2278), 1,
      anon_sym_LPAREN,
    ACTIONS(2280), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2282), 1,
      anon_sym_u2983,
    ACTIONS(2284), 1,
      anon_sym_LBRACE,
    ACTIONS(2286), 1,
      aux_sym__qid_token1,
    ACTIONS(2288), 1,
      anon_sym_DOT,
    ACTIONS(2290), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2292), 1,
      anon_sym_u2987,
    ACTIONS(2296), 1,
      anon_sym_Set,
    STATE(3301), 1,
      aux_sym__atoms,
    STATE(3750), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5012), 1,
      sym_atom,
    STATE(6256), 1,
      sym_attributes,
    STATE(8040), 1,
      sym__LAMBDA,
    STATE(8460), 1,
      sym__FORALL,
    STATE(8978), 1,
      sym_expr,
    STATE(9559), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2136), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2294), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5139), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8631), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5053), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2274), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [154892] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2140), 1,
      anon_sym_BSLASH,
    ACTIONS(2142), 1,
      anon_sym_u03bb,
    ACTIONS(2160), 1,
      anon_sym_quoteGoal,
    ACTIONS(2162), 1,
      anon_sym_tactic,
    ACTIONS(2168), 1,
      anon_sym_let,
    ACTIONS(2272), 1,
      sym_id,
    ACTIONS(2276), 1,
      anon_sym_record,
    ACTIONS(2278), 1,
      anon_sym_LPAREN,
    ACTIONS(2280), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2282), 1,
      anon_sym_u2983,
    ACTIONS(2284), 1,
      anon_sym_LBRACE,
    ACTIONS(2286), 1,
      aux_sym__qid_token1,
    ACTIONS(2288), 1,
      anon_sym_DOT,
    ACTIONS(2290), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2292), 1,
      anon_sym_u2987,
    ACTIONS(2296), 1,
      anon_sym_Set,
    STATE(3301), 1,
      aux_sym__atoms,
    STATE(3750), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5012), 1,
      sym_atom,
    STATE(6256), 1,
      sym_attributes,
    STATE(8040), 1,
      sym__LAMBDA,
    STATE(8460), 1,
      sym__FORALL,
    STATE(8974), 1,
      sym_expr,
    STATE(9559), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2136), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2294), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5139), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8631), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5053), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2274), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [155028] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(2566), 1,
      sym_id,
    ACTIONS(2570), 1,
      anon_sym_BSLASH,
    ACTIONS(2572), 1,
      anon_sym_u03bb,
    ACTIONS(2576), 1,
      anon_sym_record,
    ACTIONS(2578), 1,
      anon_sym_LPAREN,
    ACTIONS(2580), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2582), 1,
      anon_sym_u2983,
    ACTIONS(2584), 1,
      anon_sym_LBRACE,
    ACTIONS(2586), 1,
      aux_sym__qid_token1,
    ACTIONS(2588), 1,
      anon_sym_DOT,
    ACTIONS(2590), 1,
      anon_sym_quoteGoal,
    ACTIONS(2592), 1,
      anon_sym_tactic,
    ACTIONS(2594), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2596), 1,
      anon_sym_u2987,
    ACTIONS(2598), 1,
      anon_sym_let,
    ACTIONS(2602), 1,
      anon_sym_Set,
    STATE(3214), 1,
      aux_sym__atoms,
    STATE(3714), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5536), 1,
      sym_atom,
    STATE(6208), 1,
      sym_attributes,
    STATE(8111), 1,
      sym__LAMBDA,
    STATE(8412), 1,
      sym__FORALL,
    STATE(8982), 1,
      sym_expr,
    STATE(10191), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2568), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2600), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5566), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8634), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5590), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2574), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [155164] = 36,
    ACTIONS(13), 1,
      anon_sym_BSLASH,
    ACTIONS(15), 1,
      anon_sym_u03bb,
    ACTIONS(75), 1,
      anon_sym_quoteGoal,
    ACTIONS(77), 1,
      anon_sym_tactic,
    ACTIONS(83), 1,
      anon_sym_let,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(2246), 1,
      sym_id,
    ACTIONS(2250), 1,
      anon_sym_record,
    ACTIONS(2252), 1,
      anon_sym_LPAREN,
    ACTIONS(2254), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2256), 1,
      anon_sym_u2983,
    ACTIONS(2258), 1,
      anon_sym_LBRACE,
    ACTIONS(2260), 1,
      aux_sym__qid_token1,
    ACTIONS(2262), 1,
      anon_sym_DOT,
    ACTIONS(2264), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2266), 1,
      anon_sym_u2987,
    ACTIONS(2270), 1,
      anon_sym_Set,
    STATE(3285), 1,
      aux_sym__atoms,
    STATE(3710), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4216), 1,
      sym_atom,
    STATE(6218), 1,
      sym_attributes,
    STATE(8114), 1,
      sym__LAMBDA,
    STATE(8288), 1,
      sym__FORALL,
    STATE(8952), 1,
      sym_expr,
    STATE(9125), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(11), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2268), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4151), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8647), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4153), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2248), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [155300] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(11835), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [155436] = 36,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(11478), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [155572] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(9990), 1,
      sym__with_exprs,
    STATE(10884), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [155708] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(2904), 1,
      anon_sym_BSLASH,
    ACTIONS(2906), 1,
      anon_sym_u03bb,
    ACTIONS(2924), 1,
      anon_sym_quoteGoal,
    ACTIONS(2926), 1,
      anon_sym_tactic,
    ACTIONS(2932), 1,
      anon_sym_let,
    ACTIONS(3300), 1,
      sym_id,
    ACTIONS(3304), 1,
      anon_sym_record,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3308), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3310), 1,
      anon_sym_u2983,
    ACTIONS(3312), 1,
      anon_sym_LBRACE,
    ACTIONS(3314), 1,
      aux_sym__qid_token1,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3318), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3320), 1,
      anon_sym_u2987,
    ACTIONS(3324), 1,
      anon_sym_Set,
    STATE(3316), 1,
      aux_sym__atoms,
    STATE(3756), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4056), 1,
      sym_atom,
    STATE(6223), 1,
      sym_attributes,
    STATE(8094), 1,
      sym__LAMBDA,
    STATE(8489), 1,
      sym__FORALL,
    STATE(8957), 1,
      sym_expr,
    STATE(9010), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2900), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3322), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4053), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8655), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4049), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3302), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [155844] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(10065), 1,
      sym__with_exprs,
    STATE(10883), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [155980] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2140), 1,
      anon_sym_BSLASH,
    ACTIONS(2142), 1,
      anon_sym_u03bb,
    ACTIONS(2160), 1,
      anon_sym_quoteGoal,
    ACTIONS(2162), 1,
      anon_sym_tactic,
    ACTIONS(2168), 1,
      anon_sym_let,
    ACTIONS(2272), 1,
      sym_id,
    ACTIONS(2276), 1,
      anon_sym_record,
    ACTIONS(2278), 1,
      anon_sym_LPAREN,
    ACTIONS(2280), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2282), 1,
      anon_sym_u2983,
    ACTIONS(2284), 1,
      anon_sym_LBRACE,
    ACTIONS(2286), 1,
      aux_sym__qid_token1,
    ACTIONS(2288), 1,
      anon_sym_DOT,
    ACTIONS(2290), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2292), 1,
      anon_sym_u2987,
    ACTIONS(2296), 1,
      anon_sym_Set,
    STATE(3301), 1,
      aux_sym__atoms,
    STATE(3750), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5012), 1,
      sym_atom,
    STATE(6256), 1,
      sym_attributes,
    STATE(8040), 1,
      sym__LAMBDA,
    STATE(8460), 1,
      sym__FORALL,
    STATE(8951), 1,
      sym_expr,
    STATE(9559), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2136), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2294), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5139), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8631), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5053), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2274), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [156116] = 35,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(700), 1,
      anon_sym_LBRACE_DASH_POUND,
    ACTIONS(3134), 1,
      anon_sym_BSLASH,
    ACTIONS(3136), 1,
      anon_sym_u03bb,
    ACTIONS(3154), 1,
      anon_sym_quoteGoal,
    ACTIONS(3156), 1,
      anon_sym_tactic,
    ACTIONS(3162), 1,
      anon_sym_let,
    ACTIONS(3326), 1,
      sym_id,
    ACTIONS(3332), 1,
      anon_sym_record,
    ACTIONS(3334), 1,
      anon_sym_LPAREN,
    ACTIONS(3336), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3338), 1,
      anon_sym_u2983,
    ACTIONS(3340), 1,
      anon_sym_LBRACE,
    ACTIONS(3342), 1,
      aux_sym__qid_token1,
    ACTIONS(3344), 1,
      anon_sym_DOT,
    ACTIONS(3346), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3348), 1,
      anon_sym_u2987,
    ACTIONS(3352), 1,
      anon_sym_Set,
    STATE(1678), 1,
      sym__ARROW,
    STATE(2793), 1,
      aux_sym__lambda_clauses_repeat1,
    STATE(3227), 1,
      sym_catchall_pragma,
    STATE(3427), 1,
      aux_sym__atoms,
    STATE(4908), 1,
      sym_atom,
    STATE(8076), 1,
      sym__LAMBDA,
    STATE(8363), 1,
      sym__FORALL,
    STATE(8999), 1,
      sym__lambda_clauses,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3132), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3328), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(3350), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4650), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(8993), 3,
      sym__lambda_clause_maybe_absurd,
      sym_lambda_clause_absurd,
      sym_lambda_clause,
    STATE(4649), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9000), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3330), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [156250] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2140), 1,
      anon_sym_BSLASH,
    ACTIONS(2142), 1,
      anon_sym_u03bb,
    ACTIONS(2160), 1,
      anon_sym_quoteGoal,
    ACTIONS(2162), 1,
      anon_sym_tactic,
    ACTIONS(2168), 1,
      anon_sym_let,
    ACTIONS(2272), 1,
      sym_id,
    ACTIONS(2276), 1,
      anon_sym_record,
    ACTIONS(2278), 1,
      anon_sym_LPAREN,
    ACTIONS(2280), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2282), 1,
      anon_sym_u2983,
    ACTIONS(2284), 1,
      anon_sym_LBRACE,
    ACTIONS(2286), 1,
      aux_sym__qid_token1,
    ACTIONS(2288), 1,
      anon_sym_DOT,
    ACTIONS(2290), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2292), 1,
      anon_sym_u2987,
    ACTIONS(2296), 1,
      anon_sym_Set,
    STATE(3301), 1,
      aux_sym__atoms,
    STATE(3750), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5012), 1,
      sym_atom,
    STATE(6256), 1,
      sym_attributes,
    STATE(8040), 1,
      sym__LAMBDA,
    STATE(8460), 1,
      sym__FORALL,
    STATE(8961), 1,
      sym_expr,
    STATE(9559), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2136), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2294), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5139), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8631), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5053), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2274), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [156386] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(10065), 1,
      sym__with_exprs,
    STATE(10380), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [156522] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(3262), 1,
      sym_id,
    ACTIONS(3266), 1,
      anon_sym_BSLASH,
    ACTIONS(3268), 1,
      anon_sym_u03bb,
    ACTIONS(3272), 1,
      anon_sym_record,
    ACTIONS(3274), 1,
      anon_sym_LPAREN,
    ACTIONS(3276), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3278), 1,
      anon_sym_u2983,
    ACTIONS(3280), 1,
      anon_sym_LBRACE,
    ACTIONS(3282), 1,
      aux_sym__qid_token1,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3286), 1,
      anon_sym_quoteGoal,
    ACTIONS(3288), 1,
      anon_sym_tactic,
    ACTIONS(3290), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3292), 1,
      anon_sym_u2987,
    ACTIONS(3294), 1,
      anon_sym_let,
    ACTIONS(3298), 1,
      anon_sym_Set,
    STATE(3148), 1,
      aux_sym__atoms,
    STATE(3739), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4014), 1,
      sym_atom,
    STATE(6261), 1,
      sym_attributes,
    STATE(8143), 1,
      sym__LAMBDA,
    STATE(8451), 1,
      sym__FORALL,
    STATE(8926), 1,
      sym__with_exprs,
    STATE(8949), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3264), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3296), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4032), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8687), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4012), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3270), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [156658] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(10065), 1,
      sym__with_exprs,
    STATE(11026), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [156794] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(9990), 1,
      sym__with_exprs,
    STATE(11067), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [156930] = 36,
    ACTIONS(13), 1,
      anon_sym_BSLASH,
    ACTIONS(15), 1,
      anon_sym_u03bb,
    ACTIONS(75), 1,
      anon_sym_quoteGoal,
    ACTIONS(77), 1,
      anon_sym_tactic,
    ACTIONS(83), 1,
      anon_sym_let,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(2246), 1,
      sym_id,
    ACTIONS(2250), 1,
      anon_sym_record,
    ACTIONS(2252), 1,
      anon_sym_LPAREN,
    ACTIONS(2254), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2256), 1,
      anon_sym_u2983,
    ACTIONS(2258), 1,
      anon_sym_LBRACE,
    ACTIONS(2260), 1,
      aux_sym__qid_token1,
    ACTIONS(2262), 1,
      anon_sym_DOT,
    ACTIONS(2264), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2266), 1,
      anon_sym_u2987,
    ACTIONS(2270), 1,
      anon_sym_Set,
    STATE(3285), 1,
      aux_sym__atoms,
    STATE(3710), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4216), 1,
      sym_atom,
    STATE(6218), 1,
      sym_attributes,
    STATE(8114), 1,
      sym__LAMBDA,
    STATE(8288), 1,
      sym__FORALL,
    STATE(8982), 1,
      sym_expr,
    STATE(9125), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(11), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2268), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4151), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8647), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4153), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2248), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [157066] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(10516), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [157202] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(734), 1,
      sym_id,
    ACTIONS(738), 1,
      anon_sym_BSLASH,
    ACTIONS(740), 1,
      anon_sym_u03bb,
    ACTIONS(744), 1,
      anon_sym_record,
    ACTIONS(746), 1,
      anon_sym_LPAREN,
    ACTIONS(748), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(750), 1,
      anon_sym_u2983,
    ACTIONS(752), 1,
      anon_sym_LBRACE,
    ACTIONS(754), 1,
      aux_sym__qid_token1,
    ACTIONS(756), 1,
      anon_sym_DOT,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(762), 1,
      anon_sym_quoteGoal,
    ACTIONS(764), 1,
      anon_sym_tactic,
    ACTIONS(766), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(768), 1,
      anon_sym_u2987,
    ACTIONS(774), 1,
      anon_sym_Set,
    ACTIONS(3054), 1,
      anon_sym_let,
    STATE(3326), 1,
      aux_sym__atoms,
    STATE(3730), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5147), 1,
      sym_atom,
    STATE(6212), 1,
      sym_attributes,
    STATE(8156), 1,
      sym__LAMBDA,
    STATE(8456), 1,
      sym__FORALL,
    STATE(9596), 1,
      sym__with_exprs,
    STATE(9641), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(736), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(772), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5108), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8641), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5102), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(742), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [157338] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2488), 1,
      sym_id,
    ACTIONS(2492), 1,
      anon_sym_BSLASH,
    ACTIONS(2494), 1,
      anon_sym_u03bb,
    ACTIONS(2498), 1,
      anon_sym_record,
    ACTIONS(2500), 1,
      anon_sym_LPAREN,
    ACTIONS(2502), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2504), 1,
      anon_sym_u2983,
    ACTIONS(2506), 1,
      anon_sym_LBRACE,
    ACTIONS(2508), 1,
      aux_sym__qid_token1,
    ACTIONS(2510), 1,
      anon_sym_DOT,
    ACTIONS(2512), 1,
      anon_sym_quoteGoal,
    ACTIONS(2514), 1,
      anon_sym_tactic,
    ACTIONS(2516), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2518), 1,
      anon_sym_u2987,
    ACTIONS(2520), 1,
      anon_sym_let,
    ACTIONS(2524), 1,
      anon_sym_Set,
    STATE(3193), 1,
      aux_sym__atoms,
    STATE(3709), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5643), 1,
      sym_atom,
    STATE(6216), 1,
      sym_attributes,
    STATE(8096), 1,
      sym__LAMBDA,
    STATE(8497), 1,
      sym__FORALL,
    STATE(10138), 1,
      sym__with_exprs,
    STATE(12274), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2490), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2522), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5713), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8645), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5698), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2496), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [157474] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(9990), 1,
      sym__with_exprs,
    STATE(10381), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [157610] = 36,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(2652), 1,
      sym_id,
    ACTIONS(2656), 1,
      anon_sym_BSLASH,
    ACTIONS(2658), 1,
      anon_sym_u03bb,
    ACTIONS(2662), 1,
      anon_sym_record,
    ACTIONS(2664), 1,
      anon_sym_LPAREN,
    ACTIONS(2666), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2668), 1,
      anon_sym_u2983,
    ACTIONS(2670), 1,
      anon_sym_LBRACE,
    ACTIONS(2672), 1,
      aux_sym__qid_token1,
    ACTIONS(2674), 1,
      anon_sym_DOT,
    ACTIONS(2676), 1,
      anon_sym_quoteGoal,
    ACTIONS(2678), 1,
      anon_sym_tactic,
    ACTIONS(2680), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2682), 1,
      anon_sym_u2987,
    ACTIONS(2684), 1,
      anon_sym_let,
    ACTIONS(2688), 1,
      anon_sym_Set,
    STATE(3243), 1,
      aux_sym__atoms,
    STATE(3732), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4916), 1,
      sym_atom,
    STATE(6233), 1,
      sym_attributes,
    STATE(8132), 1,
      sym__LAMBDA,
    STATE(8470), 1,
      sym__FORALL,
    STATE(9530), 1,
      sym__with_exprs,
    STATE(10127), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2654), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2686), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4732), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8656), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4735), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2660), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [157746] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(3096), 1,
      anon_sym_BSLASH,
    ACTIONS(3098), 1,
      anon_sym_u03bb,
    ACTIONS(3116), 1,
      anon_sym_quoteGoal,
    ACTIONS(3118), 1,
      anon_sym_tactic,
    ACTIONS(3124), 1,
      anon_sym_let,
    ACTIONS(3354), 1,
      sym_id,
    ACTIONS(3358), 1,
      anon_sym_record,
    ACTIONS(3360), 1,
      anon_sym_LPAREN,
    ACTIONS(3362), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3364), 1,
      anon_sym_u2983,
    ACTIONS(3366), 1,
      anon_sym_LBRACE,
    ACTIONS(3368), 1,
      aux_sym__qid_token1,
    ACTIONS(3370), 1,
      anon_sym_DOT,
    ACTIONS(3372), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3374), 1,
      anon_sym_u2987,
    ACTIONS(3378), 1,
      anon_sym_Set,
    STATE(3144), 1,
      aux_sym__atoms,
    STATE(3705), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4227), 1,
      sym_atom,
    STATE(6291), 1,
      sym_attributes,
    STATE(8099), 1,
      sym__LAMBDA,
    STATE(8393), 1,
      sym__FORALL,
    STATE(9002), 1,
      sym_expr,
    STATE(9105), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3092), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3376), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4178), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8679), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4177), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3356), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [157882] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(10065), 1,
      sym__with_exprs,
    STATE(11243), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [158018] = 36,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(10388), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [158154] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(11836), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [158290] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(11848), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [158426] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(9990), 1,
      sym__with_exprs,
    STATE(11242), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [158562] = 36,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(11850), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [158698] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(11851), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [158834] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1910), 1,
      anon_sym_BSLASH,
    ACTIONS(1912), 1,
      anon_sym_u03bb,
    ACTIONS(1928), 1,
      anon_sym_quoteGoal,
    ACTIONS(1930), 1,
      anon_sym_tactic,
    ACTIONS(1936), 1,
      anon_sym_let,
    ACTIONS(2174), 1,
      sym_id,
    ACTIONS(2182), 1,
      anon_sym_record,
    ACTIONS(2184), 1,
      anon_sym_LPAREN,
    ACTIONS(2186), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2188), 1,
      anon_sym_u2983,
    ACTIONS(2190), 1,
      anon_sym_LBRACE,
    ACTIONS(2192), 1,
      aux_sym__qid_token1,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2198), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2200), 1,
      anon_sym_u2987,
    ACTIONS(2204), 1,
      anon_sym_Set,
    STATE(3339), 1,
      aux_sym__atoms,
    STATE(3717), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4611), 1,
      sym_atom,
    STATE(6264), 1,
      sym_attributes,
    STATE(8153), 1,
      sym__LAMBDA,
    STATE(8431), 1,
      sym__FORALL,
    STATE(8945), 1,
      sym_expr,
    STATE(9486), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1906), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4536), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8673), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4531), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2180), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [158970] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(11852), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [159106] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(11854), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [159242] = 36,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(11868), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [159378] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2140), 1,
      anon_sym_BSLASH,
    ACTIONS(2142), 1,
      anon_sym_u03bb,
    ACTIONS(2160), 1,
      anon_sym_quoteGoal,
    ACTIONS(2162), 1,
      anon_sym_tactic,
    ACTIONS(2168), 1,
      anon_sym_let,
    ACTIONS(2272), 1,
      sym_id,
    ACTIONS(2276), 1,
      anon_sym_record,
    ACTIONS(2278), 1,
      anon_sym_LPAREN,
    ACTIONS(2280), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2282), 1,
      anon_sym_u2983,
    ACTIONS(2284), 1,
      anon_sym_LBRACE,
    ACTIONS(2286), 1,
      aux_sym__qid_token1,
    ACTIONS(2288), 1,
      anon_sym_DOT,
    ACTIONS(2290), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2292), 1,
      anon_sym_u2987,
    ACTIONS(2296), 1,
      anon_sym_Set,
    STATE(3301), 1,
      aux_sym__atoms,
    STATE(3750), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5012), 1,
      sym_atom,
    STATE(6256), 1,
      sym_attributes,
    STATE(8040), 1,
      sym__LAMBDA,
    STATE(8460), 1,
      sym__FORALL,
    STATE(8945), 1,
      sym_expr,
    STATE(9559), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2136), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2294), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5139), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8631), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5053), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2274), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [159514] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(9990), 1,
      sym__with_exprs,
    STATE(11896), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [159650] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(10515), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [159786] = 36,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(10453), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [159922] = 36,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(11206), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [160058] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2448), 1,
      anon_sym_quoteGoal,
    ACTIONS(2456), 1,
      anon_sym_let,
    ACTIONS(2840), 1,
      sym_id,
    ACTIONS(2842), 1,
      anon_sym_BSLASH,
    ACTIONS(2844), 1,
      anon_sym_u03bb,
    ACTIONS(2848), 1,
      anon_sym_record,
    ACTIONS(2850), 1,
      anon_sym_LPAREN,
    ACTIONS(2852), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2854), 1,
      anon_sym_u2983,
    ACTIONS(2856), 1,
      anon_sym_LBRACE,
    ACTIONS(2858), 1,
      aux_sym__qid_token1,
    ACTIONS(2860), 1,
      anon_sym_DOT,
    ACTIONS(2862), 1,
      anon_sym_tactic,
    ACTIONS(2864), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2866), 1,
      anon_sym_u2987,
    ACTIONS(2870), 1,
      anon_sym_Set,
    STATE(3174), 1,
      aux_sym__atoms,
    STATE(3747), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4684), 1,
      sym_atom,
    STATE(6273), 1,
      sym_attributes,
    STATE(8053), 1,
      sym__LAMBDA,
    STATE(8423), 1,
      sym__FORALL,
    STATE(8937), 1,
      sym_expr,
    STATE(9406), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2424), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2868), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4765), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8686), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4766), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2846), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [160194] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(734), 1,
      sym_id,
    ACTIONS(738), 1,
      anon_sym_BSLASH,
    ACTIONS(740), 1,
      anon_sym_u03bb,
    ACTIONS(744), 1,
      anon_sym_record,
    ACTIONS(746), 1,
      anon_sym_LPAREN,
    ACTIONS(748), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(750), 1,
      anon_sym_u2983,
    ACTIONS(752), 1,
      anon_sym_LBRACE,
    ACTIONS(754), 1,
      aux_sym__qid_token1,
    ACTIONS(756), 1,
      anon_sym_DOT,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(762), 1,
      anon_sym_quoteGoal,
    ACTIONS(764), 1,
      anon_sym_tactic,
    ACTIONS(766), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(768), 1,
      anon_sym_u2987,
    ACTIONS(774), 1,
      anon_sym_Set,
    ACTIONS(3054), 1,
      anon_sym_let,
    STATE(3326), 1,
      aux_sym__atoms,
    STATE(3730), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5147), 1,
      sym_atom,
    STATE(6212), 1,
      sym_attributes,
    STATE(8156), 1,
      sym__LAMBDA,
    STATE(8456), 1,
      sym__FORALL,
    STATE(9429), 1,
      sym_expr,
    STATE(9596), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(736), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(772), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5108), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8641), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5102), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(742), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [160330] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(11184), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [160466] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(10065), 1,
      sym__with_exprs,
    STATE(10651), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [160602] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(2566), 1,
      sym_id,
    ACTIONS(2570), 1,
      anon_sym_BSLASH,
    ACTIONS(2572), 1,
      anon_sym_u03bb,
    ACTIONS(2576), 1,
      anon_sym_record,
    ACTIONS(2578), 1,
      anon_sym_LPAREN,
    ACTIONS(2580), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2582), 1,
      anon_sym_u2983,
    ACTIONS(2584), 1,
      anon_sym_LBRACE,
    ACTIONS(2586), 1,
      aux_sym__qid_token1,
    ACTIONS(2588), 1,
      anon_sym_DOT,
    ACTIONS(2590), 1,
      anon_sym_quoteGoal,
    ACTIONS(2592), 1,
      anon_sym_tactic,
    ACTIONS(2594), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2596), 1,
      anon_sym_u2987,
    ACTIONS(2598), 1,
      anon_sym_let,
    ACTIONS(2602), 1,
      anon_sym_Set,
    STATE(3214), 1,
      aux_sym__atoms,
    STATE(3714), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5536), 1,
      sym_atom,
    STATE(6208), 1,
      sym_attributes,
    STATE(8111), 1,
      sym__LAMBDA,
    STATE(8412), 1,
      sym__FORALL,
    STATE(10191), 1,
      sym__with_exprs,
    STATE(12252), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2568), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2600), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5566), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8634), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5590), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2574), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [160738] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2120), 1,
      anon_sym_quoteGoal,
    ACTIONS(2128), 1,
      anon_sym_let,
    ACTIONS(2174), 1,
      sym_id,
    ACTIONS(2176), 1,
      anon_sym_BSLASH,
    ACTIONS(2178), 1,
      anon_sym_u03bb,
    ACTIONS(2182), 1,
      anon_sym_record,
    ACTIONS(2184), 1,
      anon_sym_LPAREN,
    ACTIONS(2186), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2188), 1,
      anon_sym_u2983,
    ACTIONS(2190), 1,
      anon_sym_LBRACE,
    ACTIONS(2192), 1,
      aux_sym__qid_token1,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_tactic,
    ACTIONS(2198), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2200), 1,
      anon_sym_u2987,
    ACTIONS(2204), 1,
      anon_sym_Set,
    STATE(3331), 1,
      aux_sym__atoms,
    STATE(3762), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4611), 1,
      sym_atom,
    STATE(6270), 1,
      sym_attributes,
    STATE(8044), 1,
      sym__LAMBDA,
    STATE(8428), 1,
      sym__FORALL,
    STATE(8961), 1,
      sym_expr,
    STATE(9423), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2096), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4536), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8635), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4531), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2180), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [160874] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(11183), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [161010] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(10065), 1,
      sym__with_exprs,
    STATE(11898), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [161146] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2120), 1,
      anon_sym_quoteGoal,
    ACTIONS(2128), 1,
      anon_sym_let,
    ACTIONS(2174), 1,
      sym_id,
    ACTIONS(2176), 1,
      anon_sym_BSLASH,
    ACTIONS(2178), 1,
      anon_sym_u03bb,
    ACTIONS(2182), 1,
      anon_sym_record,
    ACTIONS(2184), 1,
      anon_sym_LPAREN,
    ACTIONS(2186), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2188), 1,
      anon_sym_u2983,
    ACTIONS(2190), 1,
      anon_sym_LBRACE,
    ACTIONS(2192), 1,
      aux_sym__qid_token1,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_tactic,
    ACTIONS(2198), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2200), 1,
      anon_sym_u2987,
    ACTIONS(2204), 1,
      anon_sym_Set,
    STATE(3331), 1,
      aux_sym__atoms,
    STATE(3762), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4611), 1,
      sym_atom,
    STATE(6270), 1,
      sym_attributes,
    STATE(8044), 1,
      sym__LAMBDA,
    STATE(8428), 1,
      sym__FORALL,
    STATE(8951), 1,
      sym_expr,
    STATE(9423), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2096), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4536), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8635), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4531), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2180), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [161282] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2120), 1,
      anon_sym_quoteGoal,
    ACTIONS(2128), 1,
      anon_sym_let,
    ACTIONS(2174), 1,
      sym_id,
    ACTIONS(2176), 1,
      anon_sym_BSLASH,
    ACTIONS(2178), 1,
      anon_sym_u03bb,
    ACTIONS(2182), 1,
      anon_sym_record,
    ACTIONS(2184), 1,
      anon_sym_LPAREN,
    ACTIONS(2186), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2188), 1,
      anon_sym_u2983,
    ACTIONS(2190), 1,
      anon_sym_LBRACE,
    ACTIONS(2192), 1,
      aux_sym__qid_token1,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_tactic,
    ACTIONS(2198), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2200), 1,
      anon_sym_u2987,
    ACTIONS(2204), 1,
      anon_sym_Set,
    STATE(3331), 1,
      aux_sym__atoms,
    STATE(3762), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4611), 1,
      sym_atom,
    STATE(6270), 1,
      sym_attributes,
    STATE(8044), 1,
      sym__LAMBDA,
    STATE(8428), 1,
      sym__FORALL,
    STATE(8974), 1,
      sym_expr,
    STATE(9423), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2096), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4536), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8635), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4531), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2180), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [161418] = 36,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(11074), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [161554] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(11075), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [161690] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(11076), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [161826] = 34,
    ACTIONS(700), 1,
      anon_sym_LBRACE_DASH_POUND,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2796), 1,
      anon_sym_BSLASH,
    ACTIONS(2798), 1,
      anon_sym_u03bb,
    ACTIONS(2800), 1,
      anon_sym_quoteGoal,
    ACTIONS(2802), 1,
      anon_sym_tactic,
    ACTIONS(2804), 1,
      anon_sym_let,
    ACTIONS(3380), 1,
      sym_id,
    ACTIONS(3384), 1,
      anon_sym_record,
    ACTIONS(3386), 1,
      anon_sym_LPAREN,
    ACTIONS(3388), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3390), 1,
      anon_sym_u2983,
    ACTIONS(3392), 1,
      anon_sym_LBRACE,
    ACTIONS(3394), 1,
      aux_sym__qid_token1,
    ACTIONS(3396), 1,
      anon_sym_DOT,
    ACTIONS(3398), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3400), 1,
      anon_sym_u2987,
    ACTIONS(3404), 1,
      anon_sym_Set,
    STATE(2185), 1,
      sym__ARROW,
    STATE(2677), 1,
      aux_sym__lambda_clauses_repeat1,
    STATE(3299), 1,
      sym_catchall_pragma,
    STATE(3446), 1,
      aux_sym__atoms,
    STATE(5099), 1,
      sym_atom,
    STATE(8041), 1,
      sym__LAMBDA,
    STATE(8490), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2794), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2808), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(3402), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4937), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(8987), 4,
      sym__lambda_clauses,
      sym__lambda_clause_maybe_absurd,
      sym_lambda_clause_absurd,
      sym_lambda_clause,
    STATE(4939), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8988), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3382), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [161958] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(11077), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [162094] = 36,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(11078), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [162230] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(11079), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [162366] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(9990), 1,
      sym__with_exprs,
    STATE(11466), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [162502] = 34,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(700), 1,
      anon_sym_LBRACE_DASH_POUND,
    ACTIONS(3090), 1,
      sym_id,
    ACTIONS(3096), 1,
      anon_sym_BSLASH,
    ACTIONS(3098), 1,
      anon_sym_u03bb,
    ACTIONS(3102), 1,
      anon_sym_record,
    ACTIONS(3104), 1,
      anon_sym_LPAREN,
    ACTIONS(3106), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3108), 1,
      anon_sym_u2983,
    ACTIONS(3110), 1,
      anon_sym_LBRACE,
    ACTIONS(3112), 1,
      aux_sym__qid_token1,
    ACTIONS(3114), 1,
      anon_sym_DOT,
    ACTIONS(3116), 1,
      anon_sym_quoteGoal,
    ACTIONS(3118), 1,
      anon_sym_tactic,
    ACTIONS(3120), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3122), 1,
      anon_sym_u2987,
    ACTIONS(3124), 1,
      anon_sym_let,
    ACTIONS(3128), 1,
      anon_sym_Set,
    STATE(1820), 1,
      sym__ARROW,
    STATE(2667), 1,
      aux_sym__lambda_clauses_repeat1,
    STATE(3319), 1,
      sym_catchall_pragma,
    STATE(3477), 1,
      aux_sym__atoms,
    STATE(4365), 1,
      sym_atom,
    STATE(8099), 1,
      sym__LAMBDA,
    STATE(8393), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3092), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3094), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(3126), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4293), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(8999), 4,
      sym__lambda_clauses,
      sym__lambda_clause_maybe_absurd,
      sym_lambda_clause_absurd,
      sym_lambda_clause,
    STATE(4285), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9000), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3100), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [162634] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(3406), 1,
      sym_id,
    ACTIONS(3410), 1,
      anon_sym_BSLASH,
    ACTIONS(3412), 1,
      anon_sym_u03bb,
    ACTIONS(3416), 1,
      anon_sym_record,
    ACTIONS(3418), 1,
      anon_sym_LPAREN,
    ACTIONS(3420), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3422), 1,
      anon_sym_u2983,
    ACTIONS(3424), 1,
      anon_sym_LBRACE,
    ACTIONS(3426), 1,
      aux_sym__qid_token1,
    ACTIONS(3428), 1,
      anon_sym_DOT,
    ACTIONS(3430), 1,
      anon_sym_quoteGoal,
    ACTIONS(3432), 1,
      anon_sym_tactic,
    ACTIONS(3434), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3436), 1,
      anon_sym_u2987,
    ACTIONS(3438), 1,
      anon_sym_let,
    ACTIONS(3442), 1,
      anon_sym_Set,
    STATE(3266), 1,
      aux_sym__atoms,
    STATE(3727), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4189), 1,
      sym_atom,
    STATE(6300), 1,
      sym_attributes,
    STATE(8038), 1,
      sym__LAMBDA,
    STATE(8435), 1,
      sym__FORALL,
    STATE(8949), 1,
      sym_expr,
    STATE(9058), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3408), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3440), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4158), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8644), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4162), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3414), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [162770] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2120), 1,
      anon_sym_quoteGoal,
    ACTIONS(2128), 1,
      anon_sym_let,
    ACTIONS(2174), 1,
      sym_id,
    ACTIONS(2176), 1,
      anon_sym_BSLASH,
    ACTIONS(2178), 1,
      anon_sym_u03bb,
    ACTIONS(2182), 1,
      anon_sym_record,
    ACTIONS(2184), 1,
      anon_sym_LPAREN,
    ACTIONS(2186), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2188), 1,
      anon_sym_u2983,
    ACTIONS(2190), 1,
      anon_sym_LBRACE,
    ACTIONS(2192), 1,
      aux_sym__qid_token1,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_tactic,
    ACTIONS(2198), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2200), 1,
      anon_sym_u2987,
    ACTIONS(2204), 1,
      anon_sym_Set,
    STATE(3331), 1,
      aux_sym__atoms,
    STATE(3762), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4611), 1,
      sym_atom,
    STATE(6270), 1,
      sym_attributes,
    STATE(8044), 1,
      sym__LAMBDA,
    STATE(8428), 1,
      sym__FORALL,
    STATE(8978), 1,
      sym_expr,
    STATE(9423), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2096), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4536), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8635), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4531), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2180), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [162906] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(10389), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [163042] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(10065), 1,
      sym__with_exprs,
    STATE(11465), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [163178] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(10393), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [163314] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(2346), 1,
      sym_id,
    ACTIONS(2350), 1,
      anon_sym_BSLASH,
    ACTIONS(2352), 1,
      anon_sym_u03bb,
    ACTIONS(2356), 1,
      anon_sym_record,
    ACTIONS(2358), 1,
      anon_sym_LPAREN,
    ACTIONS(2360), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2362), 1,
      anon_sym_u2983,
    ACTIONS(2364), 1,
      anon_sym_LBRACE,
    ACTIONS(2366), 1,
      aux_sym__qid_token1,
    ACTIONS(2368), 1,
      anon_sym_DOT,
    ACTIONS(2370), 1,
      anon_sym_quoteGoal,
    ACTIONS(2372), 1,
      anon_sym_tactic,
    ACTIONS(2374), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2376), 1,
      anon_sym_u2987,
    ACTIONS(2378), 1,
      anon_sym_let,
    ACTIONS(2382), 1,
      anon_sym_Set,
    STATE(3287), 1,
      aux_sym__atoms,
    STATE(3711), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4181), 1,
      sym_atom,
    STATE(6299), 1,
      sym_attributes,
    STATE(8119), 1,
      sym__LAMBDA,
    STATE(8372), 1,
      sym__FORALL,
    STATE(8982), 1,
      sym_expr,
    STATE(9076), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2348), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2380), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4180), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8640), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4192), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2354), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [163450] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2120), 1,
      anon_sym_quoteGoal,
    ACTIONS(2128), 1,
      anon_sym_let,
    ACTIONS(2174), 1,
      sym_id,
    ACTIONS(2176), 1,
      anon_sym_BSLASH,
    ACTIONS(2178), 1,
      anon_sym_u03bb,
    ACTIONS(2182), 1,
      anon_sym_record,
    ACTIONS(2184), 1,
      anon_sym_LPAREN,
    ACTIONS(2186), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2188), 1,
      anon_sym_u2983,
    ACTIONS(2190), 1,
      anon_sym_LBRACE,
    ACTIONS(2192), 1,
      aux_sym__qid_token1,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_tactic,
    ACTIONS(2198), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2200), 1,
      anon_sym_u2987,
    ACTIONS(2204), 1,
      anon_sym_Set,
    STATE(3331), 1,
      aux_sym__atoms,
    STATE(3762), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4611), 1,
      sym_atom,
    STATE(6270), 1,
      sym_attributes,
    STATE(8044), 1,
      sym__LAMBDA,
    STATE(8428), 1,
      sym__FORALL,
    STATE(8992), 1,
      sym_expr,
    STATE(9423), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2096), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4536), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8635), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4531), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2180), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [163586] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(10395), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [163722] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(2346), 1,
      sym_id,
    ACTIONS(2350), 1,
      anon_sym_BSLASH,
    ACTIONS(2352), 1,
      anon_sym_u03bb,
    ACTIONS(2356), 1,
      anon_sym_record,
    ACTIONS(2358), 1,
      anon_sym_LPAREN,
    ACTIONS(2360), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2362), 1,
      anon_sym_u2983,
    ACTIONS(2364), 1,
      anon_sym_LBRACE,
    ACTIONS(2366), 1,
      aux_sym__qid_token1,
    ACTIONS(2368), 1,
      anon_sym_DOT,
    ACTIONS(2370), 1,
      anon_sym_quoteGoal,
    ACTIONS(2372), 1,
      anon_sym_tactic,
    ACTIONS(2374), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2376), 1,
      anon_sym_u2987,
    ACTIONS(2378), 1,
      anon_sym_let,
    ACTIONS(2382), 1,
      anon_sym_Set,
    STATE(3287), 1,
      aux_sym__atoms,
    STATE(3711), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4181), 1,
      sym_atom,
    STATE(6299), 1,
      sym_attributes,
    STATE(8119), 1,
      sym__LAMBDA,
    STATE(8372), 1,
      sym__FORALL,
    STATE(8952), 1,
      sym_expr,
    STATE(9076), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2348), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2380), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4180), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8640), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4192), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2354), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [163858] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(11176), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [163994] = 36,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(11172), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [164130] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(11171), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [164266] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(3096), 1,
      anon_sym_BSLASH,
    ACTIONS(3098), 1,
      anon_sym_u03bb,
    ACTIONS(3116), 1,
      anon_sym_quoteGoal,
    ACTIONS(3118), 1,
      anon_sym_tactic,
    ACTIONS(3124), 1,
      anon_sym_let,
    ACTIONS(3354), 1,
      sym_id,
    ACTIONS(3358), 1,
      anon_sym_record,
    ACTIONS(3360), 1,
      anon_sym_LPAREN,
    ACTIONS(3362), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3364), 1,
      anon_sym_u2983,
    ACTIONS(3366), 1,
      anon_sym_LBRACE,
    ACTIONS(3368), 1,
      aux_sym__qid_token1,
    ACTIONS(3370), 1,
      anon_sym_DOT,
    ACTIONS(3372), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3374), 1,
      anon_sym_u2987,
    ACTIONS(3378), 1,
      anon_sym_Set,
    STATE(3144), 1,
      aux_sym__atoms,
    STATE(3705), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4227), 1,
      sym_atom,
    STATE(6291), 1,
      sym_attributes,
    STATE(8099), 1,
      sym__LAMBDA,
    STATE(8393), 1,
      sym__FORALL,
    STATE(9003), 1,
      sym_expr,
    STATE(9105), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3092), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3376), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4178), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8679), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4177), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3356), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [164402] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(10650), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [164538] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(940), 1,
      sym_id,
    ACTIONS(950), 1,
      anon_sym_record,
    ACTIONS(952), 1,
      anon_sym_LPAREN,
    ACTIONS(954), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(956), 1,
      anon_sym_u2983,
    ACTIONS(958), 1,
      anon_sym_LBRACE,
    ACTIONS(960), 1,
      aux_sym__qid_token1,
    ACTIONS(962), 1,
      anon_sym_DOT,
    ACTIONS(968), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(970), 1,
      anon_sym_u2987,
    ACTIONS(976), 1,
      anon_sym_Set,
    ACTIONS(982), 1,
      anon_sym_BSLASH,
    ACTIONS(984), 1,
      anon_sym_u03bb,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(990), 1,
      anon_sym_tactic,
    ACTIONS(1302), 1,
      anon_sym_let,
    STATE(3221), 1,
      aux_sym__atoms,
    STATE(3708), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4712), 1,
      sym_atom,
    STATE(6263), 1,
      sym_attributes,
    STATE(8095), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(8959), 1,
      sym_expr,
    STATE(9521), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(974), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(4733), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8670), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4742), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(948), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [164674] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(3444), 1,
      sym_id,
    ACTIONS(3448), 1,
      anon_sym_BSLASH,
    ACTIONS(3450), 1,
      anon_sym_u03bb,
    ACTIONS(3454), 1,
      anon_sym_record,
    ACTIONS(3456), 1,
      anon_sym_LPAREN,
    ACTIONS(3458), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3460), 1,
      anon_sym_u2983,
    ACTIONS(3462), 1,
      anon_sym_LBRACE,
    ACTIONS(3464), 1,
      aux_sym__qid_token1,
    ACTIONS(3466), 1,
      anon_sym_DOT,
    ACTIONS(3468), 1,
      anon_sym_quoteGoal,
    ACTIONS(3470), 1,
      anon_sym_tactic,
    ACTIONS(3472), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3474), 1,
      anon_sym_u2987,
    ACTIONS(3476), 1,
      anon_sym_let,
    ACTIONS(3480), 1,
      anon_sym_Set,
    STATE(3313), 1,
      aux_sym__atoms,
    STATE(3742), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5018), 1,
      sym_atom,
    STATE(6219), 1,
      sym_attributes,
    STATE(8072), 1,
      sym__LAMBDA,
    STATE(8455), 1,
      sym__FORALL,
    STATE(8939), 1,
      sym_expr,
    STATE(9626), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3446), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3478), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5013), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8649), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5000), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3452), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [164810] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2120), 1,
      anon_sym_quoteGoal,
    ACTIONS(2128), 1,
      anon_sym_let,
    ACTIONS(2174), 1,
      sym_id,
    ACTIONS(2176), 1,
      anon_sym_BSLASH,
    ACTIONS(2178), 1,
      anon_sym_u03bb,
    ACTIONS(2182), 1,
      anon_sym_record,
    ACTIONS(2184), 1,
      anon_sym_LPAREN,
    ACTIONS(2186), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2188), 1,
      anon_sym_u2983,
    ACTIONS(2190), 1,
      anon_sym_LBRACE,
    ACTIONS(2192), 1,
      aux_sym__qid_token1,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_tactic,
    ACTIONS(2198), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2200), 1,
      anon_sym_u2987,
    ACTIONS(2204), 1,
      anon_sym_Set,
    STATE(3331), 1,
      aux_sym__atoms,
    STATE(3762), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4611), 1,
      sym_atom,
    STATE(6270), 1,
      sym_attributes,
    STATE(8044), 1,
      sym__LAMBDA,
    STATE(8428), 1,
      sym__FORALL,
    STATE(8959), 1,
      sym_expr,
    STATE(9423), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2096), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4536), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8635), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4531), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2180), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [164946] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(11149), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [165082] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(11148), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [165218] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(2346), 1,
      sym_id,
    ACTIONS(2350), 1,
      anon_sym_BSLASH,
    ACTIONS(2352), 1,
      anon_sym_u03bb,
    ACTIONS(2356), 1,
      anon_sym_record,
    ACTIONS(2358), 1,
      anon_sym_LPAREN,
    ACTIONS(2360), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2362), 1,
      anon_sym_u2983,
    ACTIONS(2364), 1,
      anon_sym_LBRACE,
    ACTIONS(2366), 1,
      aux_sym__qid_token1,
    ACTIONS(2368), 1,
      anon_sym_DOT,
    ACTIONS(2370), 1,
      anon_sym_quoteGoal,
    ACTIONS(2372), 1,
      anon_sym_tactic,
    ACTIONS(2374), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2376), 1,
      anon_sym_u2987,
    ACTIONS(2378), 1,
      anon_sym_let,
    ACTIONS(2382), 1,
      anon_sym_Set,
    STATE(3287), 1,
      aux_sym__atoms,
    STATE(3711), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4181), 1,
      sym_atom,
    STATE(6299), 1,
      sym_attributes,
    STATE(8119), 1,
      sym__LAMBDA,
    STATE(8372), 1,
      sym__FORALL,
    STATE(8948), 1,
      sym_expr,
    STATE(9076), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2348), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2380), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4180), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8640), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4192), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2354), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [165354] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(2346), 1,
      sym_id,
    ACTIONS(2350), 1,
      anon_sym_BSLASH,
    ACTIONS(2352), 1,
      anon_sym_u03bb,
    ACTIONS(2356), 1,
      anon_sym_record,
    ACTIONS(2358), 1,
      anon_sym_LPAREN,
    ACTIONS(2360), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2362), 1,
      anon_sym_u2983,
    ACTIONS(2364), 1,
      anon_sym_LBRACE,
    ACTIONS(2366), 1,
      aux_sym__qid_token1,
    ACTIONS(2368), 1,
      anon_sym_DOT,
    ACTIONS(2370), 1,
      anon_sym_quoteGoal,
    ACTIONS(2372), 1,
      anon_sym_tactic,
    ACTIONS(2374), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2376), 1,
      anon_sym_u2987,
    ACTIONS(2378), 1,
      anon_sym_let,
    ACTIONS(2382), 1,
      anon_sym_Set,
    STATE(3287), 1,
      aux_sym__atoms,
    STATE(3711), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4181), 1,
      sym_atom,
    STATE(6299), 1,
      sym_attributes,
    STATE(8119), 1,
      sym__LAMBDA,
    STATE(8372), 1,
      sym__FORALL,
    STATE(8939), 1,
      sym_expr,
    STATE(9076), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2348), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2380), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4180), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8640), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4192), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2354), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [165490] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(3406), 1,
      sym_id,
    ACTIONS(3410), 1,
      anon_sym_BSLASH,
    ACTIONS(3412), 1,
      anon_sym_u03bb,
    ACTIONS(3416), 1,
      anon_sym_record,
    ACTIONS(3418), 1,
      anon_sym_LPAREN,
    ACTIONS(3420), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3422), 1,
      anon_sym_u2983,
    ACTIONS(3424), 1,
      anon_sym_LBRACE,
    ACTIONS(3426), 1,
      aux_sym__qid_token1,
    ACTIONS(3428), 1,
      anon_sym_DOT,
    ACTIONS(3430), 1,
      anon_sym_quoteGoal,
    ACTIONS(3432), 1,
      anon_sym_tactic,
    ACTIONS(3434), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3436), 1,
      anon_sym_u2987,
    ACTIONS(3438), 1,
      anon_sym_let,
    ACTIONS(3442), 1,
      anon_sym_Set,
    STATE(3266), 1,
      aux_sym__atoms,
    STATE(3727), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4189), 1,
      sym_atom,
    STATE(6300), 1,
      sym_attributes,
    STATE(8038), 1,
      sym__LAMBDA,
    STATE(8435), 1,
      sym__FORALL,
    STATE(8941), 1,
      sym_expr,
    STATE(9058), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3408), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3440), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4158), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8644), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4162), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3414), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [165626] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(3444), 1,
      sym_id,
    ACTIONS(3448), 1,
      anon_sym_BSLASH,
    ACTIONS(3450), 1,
      anon_sym_u03bb,
    ACTIONS(3454), 1,
      anon_sym_record,
    ACTIONS(3456), 1,
      anon_sym_LPAREN,
    ACTIONS(3458), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3460), 1,
      anon_sym_u2983,
    ACTIONS(3462), 1,
      anon_sym_LBRACE,
    ACTIONS(3464), 1,
      aux_sym__qid_token1,
    ACTIONS(3466), 1,
      anon_sym_DOT,
    ACTIONS(3468), 1,
      anon_sym_quoteGoal,
    ACTIONS(3470), 1,
      anon_sym_tactic,
    ACTIONS(3472), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3474), 1,
      anon_sym_u2987,
    ACTIONS(3476), 1,
      anon_sym_let,
    ACTIONS(3480), 1,
      anon_sym_Set,
    STATE(3313), 1,
      aux_sym__atoms,
    STATE(3742), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5018), 1,
      sym_atom,
    STATE(6219), 1,
      sym_attributes,
    STATE(8072), 1,
      sym__LAMBDA,
    STATE(8455), 1,
      sym__FORALL,
    STATE(8948), 1,
      sym_expr,
    STATE(9626), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3446), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3478), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5013), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8649), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5000), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3452), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [165762] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2652), 1,
      sym_id,
    ACTIONS(2662), 1,
      anon_sym_record,
    ACTIONS(2664), 1,
      anon_sym_LPAREN,
    ACTIONS(2666), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2668), 1,
      anon_sym_u2983,
    ACTIONS(2670), 1,
      anon_sym_LBRACE,
    ACTIONS(2672), 1,
      aux_sym__qid_token1,
    ACTIONS(2674), 1,
      anon_sym_DOT,
    ACTIONS(2680), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2682), 1,
      anon_sym_u2987,
    ACTIONS(2688), 1,
      anon_sym_Set,
    ACTIONS(2796), 1,
      anon_sym_BSLASH,
    ACTIONS(2798), 1,
      anon_sym_u03bb,
    ACTIONS(2800), 1,
      anon_sym_quoteGoal,
    ACTIONS(2802), 1,
      anon_sym_tactic,
    ACTIONS(2804), 1,
      anon_sym_let,
    STATE(3197), 1,
      aux_sym__atoms,
    STATE(3721), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4916), 1,
      sym_atom,
    STATE(6237), 1,
      sym_attributes,
    STATE(8041), 1,
      sym__LAMBDA,
    STATE(8490), 1,
      sym__FORALL,
    STATE(8992), 1,
      sym_expr,
    STATE(9687), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2686), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(2794), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(4732), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8657), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4735), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2660), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [165898] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(11080), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [166034] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(11081), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [166170] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(3482), 1,
      sym_id,
    ACTIONS(3486), 1,
      anon_sym_BSLASH,
    ACTIONS(3488), 1,
      anon_sym_u03bb,
    ACTIONS(3492), 1,
      anon_sym_record,
    ACTIONS(3494), 1,
      anon_sym_LPAREN,
    ACTIONS(3496), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3498), 1,
      anon_sym_u2983,
    ACTIONS(3500), 1,
      anon_sym_LBRACE,
    ACTIONS(3502), 1,
      aux_sym__qid_token1,
    ACTIONS(3504), 1,
      anon_sym_DOT,
    ACTIONS(3506), 1,
      anon_sym_quoteGoal,
    ACTIONS(3508), 1,
      anon_sym_tactic,
    ACTIONS(3510), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3512), 1,
      anon_sym_u2987,
    ACTIONS(3514), 1,
      anon_sym_let,
    ACTIONS(3518), 1,
      anon_sym_Set,
    STATE(3202), 1,
      aux_sym__atoms,
    STATE(3736), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4260), 1,
      sym_atom,
    STATE(6289), 1,
      sym_attributes,
    STATE(8140), 1,
      sym__LAMBDA,
    STATE(8504), 1,
      sym__FORALL,
    STATE(8982), 1,
      sym_expr,
    STATE(9167), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3484), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3516), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4382), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8682), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4385), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3490), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [166306] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(3096), 1,
      anon_sym_BSLASH,
    ACTIONS(3098), 1,
      anon_sym_u03bb,
    ACTIONS(3116), 1,
      anon_sym_quoteGoal,
    ACTIONS(3118), 1,
      anon_sym_tactic,
    ACTIONS(3124), 1,
      anon_sym_let,
    ACTIONS(3354), 1,
      sym_id,
    ACTIONS(3358), 1,
      anon_sym_record,
    ACTIONS(3360), 1,
      anon_sym_LPAREN,
    ACTIONS(3362), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3364), 1,
      anon_sym_u2983,
    ACTIONS(3366), 1,
      anon_sym_LBRACE,
    ACTIONS(3368), 1,
      aux_sym__qid_token1,
    ACTIONS(3370), 1,
      anon_sym_DOT,
    ACTIONS(3372), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3374), 1,
      anon_sym_u2987,
    ACTIONS(3378), 1,
      anon_sym_Set,
    STATE(3144), 1,
      aux_sym__atoms,
    STATE(3705), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4227), 1,
      sym_atom,
    STATE(6291), 1,
      sym_attributes,
    STATE(8099), 1,
      sym__LAMBDA,
    STATE(8393), 1,
      sym__FORALL,
    STATE(8957), 1,
      sym_expr,
    STATE(9105), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3092), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3376), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4178), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8679), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4177), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3356), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [166442] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(3482), 1,
      sym_id,
    ACTIONS(3486), 1,
      anon_sym_BSLASH,
    ACTIONS(3488), 1,
      anon_sym_u03bb,
    ACTIONS(3492), 1,
      anon_sym_record,
    ACTIONS(3494), 1,
      anon_sym_LPAREN,
    ACTIONS(3496), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3498), 1,
      anon_sym_u2983,
    ACTIONS(3500), 1,
      anon_sym_LBRACE,
    ACTIONS(3502), 1,
      aux_sym__qid_token1,
    ACTIONS(3504), 1,
      anon_sym_DOT,
    ACTIONS(3506), 1,
      anon_sym_quoteGoal,
    ACTIONS(3508), 1,
      anon_sym_tactic,
    ACTIONS(3510), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3512), 1,
      anon_sym_u2987,
    ACTIONS(3514), 1,
      anon_sym_let,
    ACTIONS(3518), 1,
      anon_sym_Set,
    STATE(3202), 1,
      aux_sym__atoms,
    STATE(3736), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4260), 1,
      sym_atom,
    STATE(6289), 1,
      sym_attributes,
    STATE(8140), 1,
      sym__LAMBDA,
    STATE(8504), 1,
      sym__FORALL,
    STATE(8952), 1,
      sym_expr,
    STATE(9167), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3484), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3516), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4382), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8682), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4385), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3490), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [166578] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(3444), 1,
      sym_id,
    ACTIONS(3448), 1,
      anon_sym_BSLASH,
    ACTIONS(3450), 1,
      anon_sym_u03bb,
    ACTIONS(3454), 1,
      anon_sym_record,
    ACTIONS(3456), 1,
      anon_sym_LPAREN,
    ACTIONS(3458), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3460), 1,
      anon_sym_u2983,
    ACTIONS(3462), 1,
      anon_sym_LBRACE,
    ACTIONS(3464), 1,
      aux_sym__qid_token1,
    ACTIONS(3466), 1,
      anon_sym_DOT,
    ACTIONS(3468), 1,
      anon_sym_quoteGoal,
    ACTIONS(3470), 1,
      anon_sym_tactic,
    ACTIONS(3472), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3474), 1,
      anon_sym_u2987,
    ACTIONS(3476), 1,
      anon_sym_let,
    ACTIONS(3480), 1,
      anon_sym_Set,
    STATE(3313), 1,
      aux_sym__atoms,
    STATE(3742), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5018), 1,
      sym_atom,
    STATE(6219), 1,
      sym_attributes,
    STATE(8072), 1,
      sym__LAMBDA,
    STATE(8455), 1,
      sym__FORALL,
    STATE(8952), 1,
      sym_expr,
    STATE(9626), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3446), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3478), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5013), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8649), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5000), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3452), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [166714] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(9990), 1,
      sym__with_exprs,
    STATE(10652), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [166850] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(3444), 1,
      sym_id,
    ACTIONS(3448), 1,
      anon_sym_BSLASH,
    ACTIONS(3450), 1,
      anon_sym_u03bb,
    ACTIONS(3454), 1,
      anon_sym_record,
    ACTIONS(3456), 1,
      anon_sym_LPAREN,
    ACTIONS(3458), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3460), 1,
      anon_sym_u2983,
    ACTIONS(3462), 1,
      anon_sym_LBRACE,
    ACTIONS(3464), 1,
      aux_sym__qid_token1,
    ACTIONS(3466), 1,
      anon_sym_DOT,
    ACTIONS(3468), 1,
      anon_sym_quoteGoal,
    ACTIONS(3470), 1,
      anon_sym_tactic,
    ACTIONS(3472), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3474), 1,
      anon_sym_u2987,
    ACTIONS(3476), 1,
      anon_sym_let,
    ACTIONS(3480), 1,
      anon_sym_Set,
    STATE(3313), 1,
      aux_sym__atoms,
    STATE(3742), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5018), 1,
      sym_atom,
    STATE(6219), 1,
      sym_attributes,
    STATE(8072), 1,
      sym__LAMBDA,
    STATE(8455), 1,
      sym__FORALL,
    STATE(8982), 1,
      sym_expr,
    STATE(9626), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3446), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3478), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5013), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8649), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5000), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3452), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [166986] = 34,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(700), 1,
      anon_sym_LBRACE_DASH_POUND,
    ACTIONS(2964), 1,
      anon_sym_quoteGoal,
    ACTIONS(2972), 1,
      anon_sym_let,
    ACTIONS(3520), 1,
      sym_id,
    ACTIONS(3522), 1,
      anon_sym_BSLASH,
    ACTIONS(3524), 1,
      anon_sym_u03bb,
    ACTIONS(3528), 1,
      anon_sym_record,
    ACTIONS(3530), 1,
      anon_sym_LPAREN,
    ACTIONS(3532), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3534), 1,
      anon_sym_u2983,
    ACTIONS(3536), 1,
      anon_sym_LBRACE,
    ACTIONS(3538), 1,
      aux_sym__qid_token1,
    ACTIONS(3540), 1,
      anon_sym_DOT,
    ACTIONS(3542), 1,
      anon_sym_tactic,
    ACTIONS(3544), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3546), 1,
      anon_sym_u2987,
    ACTIONS(3550), 1,
      anon_sym_Set,
    STATE(2453), 1,
      sym__ARROW,
    STATE(2660), 1,
      aux_sym__lambda_clauses_repeat1,
    STATE(3308), 1,
      sym_catchall_pragma,
    STATE(3404), 1,
      aux_sym__atoms,
    STATE(5625), 1,
      sym_atom,
    STATE(8058), 1,
      sym__LAMBDA,
    STATE(8418), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2940), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2942), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(3548), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5537), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(8999), 4,
      sym__lambda_clauses,
      sym__lambda_clause_maybe_absurd,
      sym_lambda_clause_absurd,
      sym_lambda_clause,
    STATE(5538), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9000), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3526), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [167118] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(940), 1,
      sym_id,
    ACTIONS(950), 1,
      anon_sym_record,
    ACTIONS(952), 1,
      anon_sym_LPAREN,
    ACTIONS(954), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(956), 1,
      anon_sym_u2983,
    ACTIONS(958), 1,
      anon_sym_LBRACE,
    ACTIONS(960), 1,
      aux_sym__qid_token1,
    ACTIONS(962), 1,
      anon_sym_DOT,
    ACTIONS(968), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(970), 1,
      anon_sym_u2987,
    ACTIONS(976), 1,
      anon_sym_Set,
    ACTIONS(982), 1,
      anon_sym_BSLASH,
    ACTIONS(984), 1,
      anon_sym_u03bb,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(990), 1,
      anon_sym_tactic,
    ACTIONS(1302), 1,
      anon_sym_let,
    STATE(3221), 1,
      aux_sym__atoms,
    STATE(3708), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4712), 1,
      sym_atom,
    STATE(6263), 1,
      sym_attributes,
    STATE(8095), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(8992), 1,
      sym_expr,
    STATE(9521), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(974), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(4733), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8670), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4742), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(948), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [167254] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(10861), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [167390] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(3482), 1,
      sym_id,
    ACTIONS(3486), 1,
      anon_sym_BSLASH,
    ACTIONS(3488), 1,
      anon_sym_u03bb,
    ACTIONS(3492), 1,
      anon_sym_record,
    ACTIONS(3494), 1,
      anon_sym_LPAREN,
    ACTIONS(3496), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3498), 1,
      anon_sym_u2983,
    ACTIONS(3500), 1,
      anon_sym_LBRACE,
    ACTIONS(3502), 1,
      aux_sym__qid_token1,
    ACTIONS(3504), 1,
      anon_sym_DOT,
    ACTIONS(3506), 1,
      anon_sym_quoteGoal,
    ACTIONS(3508), 1,
      anon_sym_tactic,
    ACTIONS(3510), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3512), 1,
      anon_sym_u2987,
    ACTIONS(3514), 1,
      anon_sym_let,
    ACTIONS(3518), 1,
      anon_sym_Set,
    STATE(3202), 1,
      aux_sym__atoms,
    STATE(3736), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4260), 1,
      sym_atom,
    STATE(6289), 1,
      sym_attributes,
    STATE(8140), 1,
      sym__LAMBDA,
    STATE(8504), 1,
      sym__FORALL,
    STATE(8948), 1,
      sym_expr,
    STATE(9167), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3484), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3516), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4382), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8682), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4385), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3490), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [167526] = 36,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(10396), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [167662] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(3482), 1,
      sym_id,
    ACTIONS(3486), 1,
      anon_sym_BSLASH,
    ACTIONS(3488), 1,
      anon_sym_u03bb,
    ACTIONS(3492), 1,
      anon_sym_record,
    ACTIONS(3494), 1,
      anon_sym_LPAREN,
    ACTIONS(3496), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3498), 1,
      anon_sym_u2983,
    ACTIONS(3500), 1,
      anon_sym_LBRACE,
    ACTIONS(3502), 1,
      aux_sym__qid_token1,
    ACTIONS(3504), 1,
      anon_sym_DOT,
    ACTIONS(3506), 1,
      anon_sym_quoteGoal,
    ACTIONS(3508), 1,
      anon_sym_tactic,
    ACTIONS(3510), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3512), 1,
      anon_sym_u2987,
    ACTIONS(3514), 1,
      anon_sym_let,
    ACTIONS(3518), 1,
      anon_sym_Set,
    STATE(3202), 1,
      aux_sym__atoms,
    STATE(3736), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4260), 1,
      sym_atom,
    STATE(6289), 1,
      sym_attributes,
    STATE(8140), 1,
      sym__LAMBDA,
    STATE(8504), 1,
      sym__FORALL,
    STATE(8939), 1,
      sym_expr,
    STATE(9167), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3484), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3516), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4382), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8682), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4385), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3490), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [167798] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2652), 1,
      sym_id,
    ACTIONS(2662), 1,
      anon_sym_record,
    ACTIONS(2664), 1,
      anon_sym_LPAREN,
    ACTIONS(2666), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2668), 1,
      anon_sym_u2983,
    ACTIONS(2670), 1,
      anon_sym_LBRACE,
    ACTIONS(2672), 1,
      aux_sym__qid_token1,
    ACTIONS(2674), 1,
      anon_sym_DOT,
    ACTIONS(2680), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2682), 1,
      anon_sym_u2987,
    ACTIONS(2688), 1,
      anon_sym_Set,
    ACTIONS(2796), 1,
      anon_sym_BSLASH,
    ACTIONS(2798), 1,
      anon_sym_u03bb,
    ACTIONS(2800), 1,
      anon_sym_quoteGoal,
    ACTIONS(2802), 1,
      anon_sym_tactic,
    ACTIONS(2804), 1,
      anon_sym_let,
    STATE(3197), 1,
      aux_sym__atoms,
    STATE(3721), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4916), 1,
      sym_atom,
    STATE(6237), 1,
      sym_attributes,
    STATE(8041), 1,
      sym__LAMBDA,
    STATE(8490), 1,
      sym__FORALL,
    STATE(8959), 1,
      sym_expr,
    STATE(9687), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2686), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(2794), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(4732), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8657), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4735), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2660), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [167934] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(11940), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [168070] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(11942), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [168206] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(12238), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [168342] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2140), 1,
      anon_sym_BSLASH,
    ACTIONS(2142), 1,
      anon_sym_u03bb,
    ACTIONS(2160), 1,
      anon_sym_quoteGoal,
    ACTIONS(2162), 1,
      anon_sym_tactic,
    ACTIONS(2168), 1,
      anon_sym_let,
    ACTIONS(2272), 1,
      sym_id,
    ACTIONS(2276), 1,
      anon_sym_record,
    ACTIONS(2278), 1,
      anon_sym_LPAREN,
    ACTIONS(2280), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2282), 1,
      anon_sym_u2983,
    ACTIONS(2284), 1,
      anon_sym_LBRACE,
    ACTIONS(2286), 1,
      aux_sym__qid_token1,
    ACTIONS(2288), 1,
      anon_sym_DOT,
    ACTIONS(2290), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2292), 1,
      anon_sym_u2987,
    ACTIONS(2296), 1,
      anon_sym_Set,
    STATE(3301), 1,
      aux_sym__atoms,
    STATE(3750), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5012), 1,
      sym_atom,
    STATE(6256), 1,
      sym_attributes,
    STATE(8040), 1,
      sym__LAMBDA,
    STATE(8460), 1,
      sym__FORALL,
    STATE(8937), 1,
      sym_expr,
    STATE(9559), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2136), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2294), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5139), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8631), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5053), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2274), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [168478] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(12235), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [168614] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(9990), 1,
      sym__with_exprs,
    STATE(12043), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [168750] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(12234), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [168886] = 36,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(12232), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [169022] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(10397), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [169158] = 36,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(11943), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [169294] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(11955), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [169430] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(11956), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [169566] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(10512), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [169702] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(8992), 1,
      sym_expr,
    STATE(10084), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [169838] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(8992), 1,
      sym_expr,
    STATE(10050), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [169974] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(10511), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [170110] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(8959), 1,
      sym_expr,
    STATE(10050), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [170246] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(10860), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [170382] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(12024), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [170518] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(10065), 1,
      sym__with_exprs,
    STATE(10726), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [170654] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(2566), 1,
      sym_id,
    ACTIONS(2570), 1,
      anon_sym_BSLASH,
    ACTIONS(2572), 1,
      anon_sym_u03bb,
    ACTIONS(2576), 1,
      anon_sym_record,
    ACTIONS(2578), 1,
      anon_sym_LPAREN,
    ACTIONS(2580), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2582), 1,
      anon_sym_u2983,
    ACTIONS(2584), 1,
      anon_sym_LBRACE,
    ACTIONS(2586), 1,
      aux_sym__qid_token1,
    ACTIONS(2588), 1,
      anon_sym_DOT,
    ACTIONS(2590), 1,
      anon_sym_quoteGoal,
    ACTIONS(2592), 1,
      anon_sym_tactic,
    ACTIONS(2594), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2596), 1,
      anon_sym_u2987,
    ACTIONS(2598), 1,
      anon_sym_let,
    ACTIONS(2602), 1,
      anon_sym_Set,
    STATE(3214), 1,
      aux_sym__atoms,
    STATE(3714), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5536), 1,
      sym_atom,
    STATE(6208), 1,
      sym_attributes,
    STATE(8111), 1,
      sym__LAMBDA,
    STATE(8412), 1,
      sym__FORALL,
    STATE(10191), 1,
      sym__with_exprs,
    STATE(12283), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2568), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2600), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5566), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8634), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5590), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2574), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [170790] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(10065), 1,
      sym__with_exprs,
    STATE(11104), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [170926] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(9990), 1,
      sym__with_exprs,
    STATE(11105), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [171062] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(10859), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [171198] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(11525), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [171334] = 36,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(10858), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [171470] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1980), 1,
      sym_id,
    ACTIONS(1984), 1,
      anon_sym_BSLASH,
    ACTIONS(1986), 1,
      anon_sym_u03bb,
    ACTIONS(1990), 1,
      anon_sym_record,
    ACTIONS(1992), 1,
      anon_sym_LPAREN,
    ACTIONS(1994), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1996), 1,
      anon_sym_u2983,
    ACTIONS(1998), 1,
      anon_sym_LBRACE,
    ACTIONS(2000), 1,
      aux_sym__qid_token1,
    ACTIONS(2002), 1,
      anon_sym_DOT,
    ACTIONS(2004), 1,
      anon_sym_quoteGoal,
    ACTIONS(2006), 1,
      anon_sym_tactic,
    ACTIONS(2008), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2010), 1,
      anon_sym_u2987,
    ACTIONS(2012), 1,
      anon_sym_let,
    ACTIONS(2016), 1,
      anon_sym_Set,
    STATE(3156), 1,
      aux_sym__atoms,
    STATE(3740), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4972), 1,
      sym_atom,
    STATE(6248), 1,
      sym_attributes,
    STATE(8039), 1,
      sym__LAMBDA,
    STATE(8483), 1,
      sym__FORALL,
    STATE(9481), 1,
      sym_expr,
    STATE(9685), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1982), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2014), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5336), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8659), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5185), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1988), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [171606] = 35,
    ACTIONS(700), 1,
      anon_sym_LBRACE_DASH_POUND,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2422), 1,
      sym_id,
    ACTIONS(2428), 1,
      anon_sym_BSLASH,
    ACTIONS(2430), 1,
      anon_sym_u03bb,
    ACTIONS(2434), 1,
      anon_sym_record,
    ACTIONS(2436), 1,
      anon_sym_LPAREN,
    ACTIONS(2438), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2440), 1,
      anon_sym_u2983,
    ACTIONS(2442), 1,
      anon_sym_LBRACE,
    ACTIONS(2444), 1,
      aux_sym__qid_token1,
    ACTIONS(2446), 1,
      anon_sym_DOT,
    ACTIONS(2448), 1,
      anon_sym_quoteGoal,
    ACTIONS(2450), 1,
      anon_sym_tactic,
    ACTIONS(2452), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2454), 1,
      anon_sym_u2987,
    ACTIONS(2456), 1,
      anon_sym_let,
    ACTIONS(2460), 1,
      anon_sym_Set,
    STATE(2007), 1,
      sym__ARROW,
    STATE(2783), 1,
      aux_sym__lambda_clauses_repeat1,
    STATE(3222), 1,
      sym_catchall_pragma,
    STATE(3588), 1,
      aux_sym__atoms,
    STATE(5596), 1,
      sym_atom,
    STATE(8125), 1,
      sym__LAMBDA,
    STATE(8423), 1,
      sym__FORALL,
    STATE(8987), 1,
      sym__lambda_clauses,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2424), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2426), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(2458), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5422), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(8986), 3,
      sym__lambda_clause_maybe_absurd,
      sym_lambda_clause_absurd,
      sym_lambda_clause,
    STATE(5423), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8988), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2432), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [171740] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(10259), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [171876] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(10857), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [172012] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(10260), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [172148] = 36,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(10271), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [172284] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(10856), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [172420] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(10855), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [172556] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(11445), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [172692] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(10272), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [172828] = 36,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(10854), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [172964] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(11444), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [173100] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1980), 1,
      sym_id,
    ACTIONS(1984), 1,
      anon_sym_BSLASH,
    ACTIONS(1986), 1,
      anon_sym_u03bb,
    ACTIONS(1990), 1,
      anon_sym_record,
    ACTIONS(1992), 1,
      anon_sym_LPAREN,
    ACTIONS(1994), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1996), 1,
      anon_sym_u2983,
    ACTIONS(1998), 1,
      anon_sym_LBRACE,
    ACTIONS(2000), 1,
      aux_sym__qid_token1,
    ACTIONS(2002), 1,
      anon_sym_DOT,
    ACTIONS(2004), 1,
      anon_sym_quoteGoal,
    ACTIONS(2006), 1,
      anon_sym_tactic,
    ACTIONS(2008), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2010), 1,
      anon_sym_u2987,
    ACTIONS(2012), 1,
      anon_sym_let,
    ACTIONS(2016), 1,
      anon_sym_Set,
    STATE(3156), 1,
      aux_sym__atoms,
    STATE(3740), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4972), 1,
      sym_atom,
    STATE(6248), 1,
      sym_attributes,
    STATE(8039), 1,
      sym__LAMBDA,
    STATE(8483), 1,
      sym__FORALL,
    STATE(9479), 1,
      sym_expr,
    STATE(9685), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1982), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2014), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5336), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8659), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5185), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1988), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [173236] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(10273), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [173372] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(11443), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [173508] = 36,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(11442), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [173644] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(10275), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [173780] = 36,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(10368), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [173916] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(2346), 1,
      sym_id,
    ACTIONS(2350), 1,
      anon_sym_BSLASH,
    ACTIONS(2352), 1,
      anon_sym_u03bb,
    ACTIONS(2356), 1,
      anon_sym_record,
    ACTIONS(2358), 1,
      anon_sym_LPAREN,
    ACTIONS(2360), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2362), 1,
      anon_sym_u2983,
    ACTIONS(2364), 1,
      anon_sym_LBRACE,
    ACTIONS(2366), 1,
      aux_sym__qid_token1,
    ACTIONS(2368), 1,
      anon_sym_DOT,
    ACTIONS(2370), 1,
      anon_sym_quoteGoal,
    ACTIONS(2372), 1,
      anon_sym_tactic,
    ACTIONS(2374), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2376), 1,
      anon_sym_u2987,
    ACTIONS(2378), 1,
      anon_sym_let,
    ACTIONS(2382), 1,
      anon_sym_Set,
    STATE(3287), 1,
      aux_sym__atoms,
    STATE(3711), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4181), 1,
      sym_atom,
    STATE(6299), 1,
      sym_attributes,
    STATE(8119), 1,
      sym__LAMBDA,
    STATE(8372), 1,
      sym__FORALL,
    STATE(8949), 1,
      sym_expr,
    STATE(9076), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2348), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2380), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4180), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8640), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4192), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2354), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [174052] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(11441), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [174188] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(9990), 1,
      sym__with_exprs,
    STATE(10289), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [174324] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(11440), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [174460] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(11439), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [174596] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1866), 1,
      sym_id,
    ACTIONS(1870), 1,
      anon_sym_BSLASH,
    ACTIONS(1872), 1,
      anon_sym_u03bb,
    ACTIONS(1876), 1,
      anon_sym_record,
    ACTIONS(1878), 1,
      anon_sym_LPAREN,
    ACTIONS(1880), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1882), 1,
      anon_sym_u2983,
    ACTIONS(1884), 1,
      anon_sym_LBRACE,
    ACTIONS(1886), 1,
      aux_sym__qid_token1,
    ACTIONS(1888), 1,
      anon_sym_DOT,
    ACTIONS(1890), 1,
      anon_sym_quoteGoal,
    ACTIONS(1892), 1,
      anon_sym_tactic,
    ACTIONS(1894), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1896), 1,
      anon_sym_u2987,
    ACTIONS(1898), 1,
      anon_sym_let,
    ACTIONS(1902), 1,
      anon_sym_Set,
    STATE(3337), 1,
      aux_sym__atoms,
    STATE(3738), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4366), 1,
      sym_atom,
    STATE(6298), 1,
      sym_attributes,
    STATE(8032), 1,
      sym__LAMBDA,
    STATE(8379), 1,
      sym__FORALL,
    STATE(8982), 1,
      sym_expr,
    STATE(9157), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1868), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1900), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4264), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8633), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4263), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1874), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [174732] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(2566), 1,
      sym_id,
    ACTIONS(2570), 1,
      anon_sym_BSLASH,
    ACTIONS(2572), 1,
      anon_sym_u03bb,
    ACTIONS(2576), 1,
      anon_sym_record,
    ACTIONS(2578), 1,
      anon_sym_LPAREN,
    ACTIONS(2580), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2582), 1,
      anon_sym_u2983,
    ACTIONS(2584), 1,
      anon_sym_LBRACE,
    ACTIONS(2586), 1,
      aux_sym__qid_token1,
    ACTIONS(2588), 1,
      anon_sym_DOT,
    ACTIONS(2590), 1,
      anon_sym_quoteGoal,
    ACTIONS(2592), 1,
      anon_sym_tactic,
    ACTIONS(2594), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2596), 1,
      anon_sym_u2987,
    ACTIONS(2598), 1,
      anon_sym_let,
    ACTIONS(2602), 1,
      anon_sym_Set,
    STATE(3214), 1,
      aux_sym__atoms,
    STATE(3714), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5536), 1,
      sym_atom,
    STATE(6208), 1,
      sym_attributes,
    STATE(8111), 1,
      sym__LAMBDA,
    STATE(8412), 1,
      sym__FORALL,
    STATE(10141), 1,
      sym_expr,
    STATE(10191), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2568), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2600), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5566), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8634), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5590), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2574), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [174868] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1980), 1,
      sym_id,
    ACTIONS(1984), 1,
      anon_sym_BSLASH,
    ACTIONS(1986), 1,
      anon_sym_u03bb,
    ACTIONS(1990), 1,
      anon_sym_record,
    ACTIONS(1992), 1,
      anon_sym_LPAREN,
    ACTIONS(1994), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1996), 1,
      anon_sym_u2983,
    ACTIONS(1998), 1,
      anon_sym_LBRACE,
    ACTIONS(2000), 1,
      aux_sym__qid_token1,
    ACTIONS(2002), 1,
      anon_sym_DOT,
    ACTIONS(2004), 1,
      anon_sym_quoteGoal,
    ACTIONS(2006), 1,
      anon_sym_tactic,
    ACTIONS(2008), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2010), 1,
      anon_sym_u2987,
    ACTIONS(2012), 1,
      anon_sym_let,
    ACTIONS(2016), 1,
      anon_sym_Set,
    STATE(3156), 1,
      aux_sym__atoms,
    STATE(3740), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4972), 1,
      sym_atom,
    STATE(6248), 1,
      sym_attributes,
    STATE(8039), 1,
      sym__LAMBDA,
    STATE(8483), 1,
      sym__FORALL,
    STATE(8951), 1,
      sym_expr,
    STATE(9685), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1982), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2014), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5336), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8659), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5185), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1988), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [175004] = 36,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(11438), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [175140] = 34,
    ACTIONS(700), 1,
      anon_sym_LBRACE_DASH_POUND,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1984), 1,
      anon_sym_BSLASH,
    ACTIONS(1986), 1,
      anon_sym_u03bb,
    ACTIONS(2004), 1,
      anon_sym_quoteGoal,
    ACTIONS(2006), 1,
      anon_sym_tactic,
    ACTIONS(2012), 1,
      anon_sym_let,
    ACTIONS(3380), 1,
      sym_id,
    ACTIONS(3384), 1,
      anon_sym_record,
    ACTIONS(3386), 1,
      anon_sym_LPAREN,
    ACTIONS(3388), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3390), 1,
      anon_sym_u2983,
    ACTIONS(3392), 1,
      anon_sym_LBRACE,
    ACTIONS(3394), 1,
      aux_sym__qid_token1,
    ACTIONS(3396), 1,
      anon_sym_DOT,
    ACTIONS(3398), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3400), 1,
      anon_sym_u2987,
    ACTIONS(3404), 1,
      anon_sym_Set,
    STATE(1949), 1,
      sym__ARROW,
    STATE(2730), 1,
      aux_sym__lambda_clauses_repeat1,
    STATE(3203), 1,
      sym_catchall_pragma,
    STATE(3611), 1,
      aux_sym__atoms,
    STATE(5099), 1,
      sym_atom,
    STATE(8039), 1,
      sym__LAMBDA,
    STATE(8483), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1982), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3402), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(3552), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(4937), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(8987), 4,
      sym__lambda_clauses,
      sym__lambda_clause_maybe_absurd,
      sym_lambda_clause_absurd,
      sym_lambda_clause,
    STATE(4939), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8988), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3382), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [175272] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(10065), 1,
      sym__with_exprs,
    STATE(10755), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [175408] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(10065), 1,
      sym__with_exprs,
    STATE(10290), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [175544] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(9990), 1,
      sym__with_exprs,
    STATE(10758), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [175680] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(10065), 1,
      sym__with_exprs,
    STATE(10779), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [175816] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1866), 1,
      sym_id,
    ACTIONS(1870), 1,
      anon_sym_BSLASH,
    ACTIONS(1872), 1,
      anon_sym_u03bb,
    ACTIONS(1876), 1,
      anon_sym_record,
    ACTIONS(1878), 1,
      anon_sym_LPAREN,
    ACTIONS(1880), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1882), 1,
      anon_sym_u2983,
    ACTIONS(1884), 1,
      anon_sym_LBRACE,
    ACTIONS(1886), 1,
      aux_sym__qid_token1,
    ACTIONS(1888), 1,
      anon_sym_DOT,
    ACTIONS(1890), 1,
      anon_sym_quoteGoal,
    ACTIONS(1892), 1,
      anon_sym_tactic,
    ACTIONS(1894), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1896), 1,
      anon_sym_u2987,
    ACTIONS(1898), 1,
      anon_sym_let,
    ACTIONS(1902), 1,
      anon_sym_Set,
    STATE(3337), 1,
      aux_sym__atoms,
    STATE(3738), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4366), 1,
      sym_atom,
    STATE(6298), 1,
      sym_attributes,
    STATE(8032), 1,
      sym__LAMBDA,
    STATE(8379), 1,
      sym__FORALL,
    STATE(8948), 1,
      sym_expr,
    STATE(9157), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1868), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1900), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4264), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8633), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4263), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1874), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [175952] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1866), 1,
      sym_id,
    ACTIONS(1870), 1,
      anon_sym_BSLASH,
    ACTIONS(1872), 1,
      anon_sym_u03bb,
    ACTIONS(1876), 1,
      anon_sym_record,
    ACTIONS(1878), 1,
      anon_sym_LPAREN,
    ACTIONS(1880), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1882), 1,
      anon_sym_u2983,
    ACTIONS(1884), 1,
      anon_sym_LBRACE,
    ACTIONS(1886), 1,
      aux_sym__qid_token1,
    ACTIONS(1888), 1,
      anon_sym_DOT,
    ACTIONS(1890), 1,
      anon_sym_quoteGoal,
    ACTIONS(1892), 1,
      anon_sym_tactic,
    ACTIONS(1894), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1896), 1,
      anon_sym_u2987,
    ACTIONS(1898), 1,
      anon_sym_let,
    ACTIONS(1902), 1,
      anon_sym_Set,
    STATE(3337), 1,
      aux_sym__atoms,
    STATE(3738), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4366), 1,
      sym_atom,
    STATE(6298), 1,
      sym_attributes,
    STATE(8032), 1,
      sym__LAMBDA,
    STATE(8379), 1,
      sym__FORALL,
    STATE(8939), 1,
      sym_expr,
    STATE(9157), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1868), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1900), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4264), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8633), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4263), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1874), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [176088] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(2346), 1,
      sym_id,
    ACTIONS(2350), 1,
      anon_sym_BSLASH,
    ACTIONS(2352), 1,
      anon_sym_u03bb,
    ACTIONS(2356), 1,
      anon_sym_record,
    ACTIONS(2358), 1,
      anon_sym_LPAREN,
    ACTIONS(2360), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2362), 1,
      anon_sym_u2983,
    ACTIONS(2364), 1,
      anon_sym_LBRACE,
    ACTIONS(2366), 1,
      aux_sym__qid_token1,
    ACTIONS(2368), 1,
      anon_sym_DOT,
    ACTIONS(2370), 1,
      anon_sym_quoteGoal,
    ACTIONS(2372), 1,
      anon_sym_tactic,
    ACTIONS(2374), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2376), 1,
      anon_sym_u2987,
    ACTIONS(2378), 1,
      anon_sym_let,
    ACTIONS(2382), 1,
      anon_sym_Set,
    STATE(3287), 1,
      aux_sym__atoms,
    STATE(3711), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4181), 1,
      sym_atom,
    STATE(6299), 1,
      sym_attributes,
    STATE(8119), 1,
      sym__LAMBDA,
    STATE(8372), 1,
      sym__FORALL,
    STATE(8941), 1,
      sym_expr,
    STATE(9076), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2348), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2380), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4180), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8640), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4192), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2354), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [176224] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(8992), 1,
      sym_expr,
    STATE(9990), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [176360] = 36,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(11958), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [176496] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(10065), 1,
      sym__with_exprs,
    STATE(11073), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [176632] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(9990), 1,
      sym__with_exprs,
    STATE(11072), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [176768] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(9990), 1,
      sym__with_exprs,
    STATE(11975), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [176904] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(9990), 1,
      sym__with_exprs,
    STATE(10780), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [177040] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(10065), 1,
      sym__with_exprs,
    STATE(11987), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [177176] = 34,
    ACTIONS(700), 1,
      anon_sym_LBRACE_DASH_POUND,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(3020), 1,
      anon_sym_BSLASH,
    ACTIONS(3022), 1,
      anon_sym_u03bb,
    ACTIONS(3040), 1,
      anon_sym_quoteGoal,
    ACTIONS(3042), 1,
      anon_sym_tactic,
    ACTIONS(3048), 1,
      anon_sym_let,
    ACTIONS(3234), 1,
      sym_id,
    ACTIONS(3240), 1,
      anon_sym_record,
    ACTIONS(3242), 1,
      anon_sym_LPAREN,
    ACTIONS(3244), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3246), 1,
      anon_sym_u2983,
    ACTIONS(3248), 1,
      anon_sym_LBRACE,
    ACTIONS(3250), 1,
      aux_sym__qid_token1,
    ACTIONS(3252), 1,
      anon_sym_DOT,
    ACTIONS(3254), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3256), 1,
      anon_sym_u2987,
    ACTIONS(3260), 1,
      anon_sym_Set,
    STATE(1692), 1,
      sym__ARROW,
    STATE(2674), 1,
      aux_sym__lambda_clauses_repeat1,
    STATE(3302), 1,
      sym_catchall_pragma,
    STATE(3393), 1,
      aux_sym__atoms,
    STATE(5549), 1,
      sym_atom,
    STATE(8127), 1,
      sym__LAMBDA,
    STATE(8388), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3018), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3236), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(3258), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5387), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(8987), 4,
      sym__lambda_clauses,
      sym__lambda_clause_maybe_absurd,
      sym_lambda_clause_absurd,
      sym_lambda_clause,
    STATE(5375), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8988), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3238), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [177308] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(10398), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [177444] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(9990), 1,
      sym__with_exprs,
    STATE(10730), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [177580] = 36,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(11045), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [177716] = 35,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(700), 1,
      anon_sym_LBRACE_DASH_POUND,
    ACTIONS(2938), 1,
      sym_id,
    ACTIONS(2944), 1,
      anon_sym_BSLASH,
    ACTIONS(2946), 1,
      anon_sym_u03bb,
    ACTIONS(2950), 1,
      anon_sym_record,
    ACTIONS(2952), 1,
      anon_sym_LPAREN,
    ACTIONS(2954), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2956), 1,
      anon_sym_u2983,
    ACTIONS(2958), 1,
      anon_sym_LBRACE,
    ACTIONS(2960), 1,
      aux_sym__qid_token1,
    ACTIONS(2962), 1,
      anon_sym_DOT,
    ACTIONS(2964), 1,
      anon_sym_quoteGoal,
    ACTIONS(2966), 1,
      anon_sym_tactic,
    ACTIONS(2968), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2970), 1,
      anon_sym_u2987,
    ACTIONS(2972), 1,
      anon_sym_let,
    ACTIONS(2976), 1,
      anon_sym_Set,
    STATE(2453), 1,
      sym__ARROW,
    STATE(2693), 1,
      aux_sym__lambda_clauses_repeat1,
    STATE(3199), 1,
      sym_catchall_pragma,
    STATE(3546), 1,
      aux_sym__atoms,
    STATE(5967), 1,
      sym_atom,
    STATE(8126), 1,
      sym__LAMBDA,
    STATE(8418), 1,
      sym__FORALL,
    STATE(12215), 1,
      sym__lambda_clauses,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2940), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2942), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(2974), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5870), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(8993), 3,
      sym__lambda_clause_maybe_absurd,
      sym_lambda_clause_absurd,
      sym_lambda_clause,
    STATE(5838), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9000), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2948), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [177850] = 34,
    ACTIONS(700), 1,
      anon_sym_LBRACE_DASH_POUND,
    ACTIONS(706), 1,
      aux_sym__qid_token1,
    ACTIONS(714), 1,
      anon_sym_quoteGoal,
    ACTIONS(722), 1,
      anon_sym_let,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(3554), 1,
      sym_id,
    ACTIONS(3556), 1,
      anon_sym_BSLASH,
    ACTIONS(3558), 1,
      anon_sym_u03bb,
    ACTIONS(3562), 1,
      anon_sym_record,
    ACTIONS(3564), 1,
      anon_sym_LPAREN,
    ACTIONS(3566), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3568), 1,
      anon_sym_u2983,
    ACTIONS(3570), 1,
      anon_sym_LBRACE,
    ACTIONS(3572), 1,
      anon_sym_DOT,
    ACTIONS(3574), 1,
      anon_sym_tactic,
    ACTIONS(3576), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3578), 1,
      anon_sym_u2987,
    ACTIONS(3582), 1,
      anon_sym_Set,
    STATE(2651), 1,
      sym__ARROW,
    STATE(2795), 1,
      aux_sym__lambda_clauses_repeat1,
    STATE(3233), 1,
      sym_catchall_pragma,
    STATE(3567), 1,
      aux_sym__atoms,
    STATE(5237), 1,
      sym_atom,
    STATE(8092), 1,
      sym__LAMBDA,
    STATE(8495), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(682), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2604), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(3580), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5081), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(9460), 4,
      sym__lambda_clauses,
      sym__lambda_clause_maybe_absurd,
      sym_lambda_clause_absurd,
      sym_lambda_clause,
    STATE(5079), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9459), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3560), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [177982] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(10065), 1,
      sym__with_exprs,
    STATE(10801), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [178118] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(734), 1,
      sym_id,
    ACTIONS(738), 1,
      anon_sym_BSLASH,
    ACTIONS(740), 1,
      anon_sym_u03bb,
    ACTIONS(744), 1,
      anon_sym_record,
    ACTIONS(746), 1,
      anon_sym_LPAREN,
    ACTIONS(748), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(750), 1,
      anon_sym_u2983,
    ACTIONS(752), 1,
      anon_sym_LBRACE,
    ACTIONS(754), 1,
      aux_sym__qid_token1,
    ACTIONS(756), 1,
      anon_sym_DOT,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(762), 1,
      anon_sym_quoteGoal,
    ACTIONS(764), 1,
      anon_sym_tactic,
    ACTIONS(766), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(768), 1,
      anon_sym_u2987,
    ACTIONS(774), 1,
      anon_sym_Set,
    ACTIONS(3054), 1,
      anon_sym_let,
    STATE(3326), 1,
      aux_sym__atoms,
    STATE(3730), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5147), 1,
      sym_atom,
    STATE(6212), 1,
      sym_attributes,
    STATE(8156), 1,
      sym__LAMBDA,
    STATE(8456), 1,
      sym__FORALL,
    STATE(9596), 1,
      sym__with_exprs,
    STATE(10142), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(736), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(772), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5108), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8641), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5102), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(742), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [178254] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(11018), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [178390] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(9990), 1,
      sym__with_exprs,
    STATE(10802), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [178526] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(2532), 1,
      anon_sym_BSLASH,
    ACTIONS(2534), 1,
      anon_sym_u03bb,
    ACTIONS(2552), 1,
      anon_sym_quoteGoal,
    ACTIONS(2554), 1,
      anon_sym_tactic,
    ACTIONS(2560), 1,
      anon_sym_let,
    ACTIONS(3584), 1,
      sym_id,
    ACTIONS(3588), 1,
      anon_sym_record,
    ACTIONS(3590), 1,
      anon_sym_LPAREN,
    ACTIONS(3592), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3594), 1,
      anon_sym_u2983,
    ACTIONS(3596), 1,
      anon_sym_LBRACE,
    ACTIONS(3598), 1,
      aux_sym__qid_token1,
    ACTIONS(3600), 1,
      anon_sym_DOT,
    ACTIONS(3602), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3604), 1,
      anon_sym_u2987,
    ACTIONS(3608), 1,
      anon_sym_Set,
    STATE(3300), 1,
      aux_sym__atoms,
    STATE(3720), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4261), 1,
      sym_atom,
    STATE(6280), 1,
      sym_attributes,
    STATE(8066), 1,
      sym__LAMBDA,
    STATE(8398), 1,
      sym__FORALL,
    STATE(9002), 1,
      sym_expr,
    STATE(9162), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2528), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3606), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4400), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8676), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4403), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3586), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [178662] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(11017), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [178798] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(10065), 1,
      sym__with_exprs,
    STATE(10830), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [178934] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(9990), 1,
      sym__with_exprs,
    STATE(10846), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [179070] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(10065), 1,
      sym__with_exprs,
    STATE(10845), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [179206] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(10399), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [179342] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(11014), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [179478] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(2532), 1,
      anon_sym_BSLASH,
    ACTIONS(2534), 1,
      anon_sym_u03bb,
    ACTIONS(2552), 1,
      anon_sym_quoteGoal,
    ACTIONS(2554), 1,
      anon_sym_tactic,
    ACTIONS(2560), 1,
      anon_sym_let,
    ACTIONS(3584), 1,
      sym_id,
    ACTIONS(3588), 1,
      anon_sym_record,
    ACTIONS(3590), 1,
      anon_sym_LPAREN,
    ACTIONS(3592), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3594), 1,
      anon_sym_u2983,
    ACTIONS(3596), 1,
      anon_sym_LBRACE,
    ACTIONS(3598), 1,
      aux_sym__qid_token1,
    ACTIONS(3600), 1,
      anon_sym_DOT,
    ACTIONS(3602), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3604), 1,
      anon_sym_u2987,
    ACTIONS(3608), 1,
      anon_sym_Set,
    STATE(3300), 1,
      aux_sym__atoms,
    STATE(3720), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4261), 1,
      sym_atom,
    STATE(6280), 1,
      sym_attributes,
    STATE(8066), 1,
      sym__LAMBDA,
    STATE(8398), 1,
      sym__FORALL,
    STATE(9003), 1,
      sym_expr,
    STATE(9162), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2528), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3606), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4400), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8676), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4403), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3586), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [179614] = 36,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(9475), 1,
      sym_expr,
    STATE(10196), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [179750] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(9990), 1,
      sym__with_exprs,
    STATE(10831), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [179886] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(12004), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [180022] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(12006), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [180158] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(12007), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [180294] = 36,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(12008), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [180430] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(10065), 1,
      sym__with_exprs,
    STATE(10863), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [180566] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(12020), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [180702] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(12022), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [180838] = 36,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(11012), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [180974] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(11011), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [181110] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(9990), 1,
      sym__with_exprs,
    STATE(10864), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [181246] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(12023), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [181382] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1910), 1,
      anon_sym_BSLASH,
    ACTIONS(1912), 1,
      anon_sym_u03bb,
    ACTIONS(1928), 1,
      anon_sym_quoteGoal,
    ACTIONS(1930), 1,
      anon_sym_tactic,
    ACTIONS(1936), 1,
      anon_sym_let,
    ACTIONS(2174), 1,
      sym_id,
    ACTIONS(2182), 1,
      anon_sym_record,
    ACTIONS(2184), 1,
      anon_sym_LPAREN,
    ACTIONS(2186), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2188), 1,
      anon_sym_u2983,
    ACTIONS(2190), 1,
      anon_sym_LBRACE,
    ACTIONS(2192), 1,
      aux_sym__qid_token1,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2198), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2200), 1,
      anon_sym_u2987,
    ACTIONS(2204), 1,
      anon_sym_Set,
    STATE(3339), 1,
      aux_sym__atoms,
    STATE(3717), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4611), 1,
      sym_atom,
    STATE(6264), 1,
      sym_attributes,
    STATE(8153), 1,
      sym__LAMBDA,
    STATE(8431), 1,
      sym__FORALL,
    STATE(8959), 1,
      sym_expr,
    STATE(9486), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1906), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4536), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8673), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4531), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2180), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [181518] = 36,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(2652), 1,
      sym_id,
    ACTIONS(2656), 1,
      anon_sym_BSLASH,
    ACTIONS(2658), 1,
      anon_sym_u03bb,
    ACTIONS(2662), 1,
      anon_sym_record,
    ACTIONS(2664), 1,
      anon_sym_LPAREN,
    ACTIONS(2666), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2668), 1,
      anon_sym_u2983,
    ACTIONS(2670), 1,
      anon_sym_LBRACE,
    ACTIONS(2672), 1,
      aux_sym__qid_token1,
    ACTIONS(2674), 1,
      anon_sym_DOT,
    ACTIONS(2676), 1,
      anon_sym_quoteGoal,
    ACTIONS(2678), 1,
      anon_sym_tactic,
    ACTIONS(2680), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2682), 1,
      anon_sym_u2987,
    ACTIONS(2684), 1,
      anon_sym_let,
    ACTIONS(2688), 1,
      anon_sym_Set,
    STATE(3243), 1,
      aux_sym__atoms,
    STATE(3732), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4916), 1,
      sym_atom,
    STATE(6233), 1,
      sym_attributes,
    STATE(8132), 1,
      sym__LAMBDA,
    STATE(8470), 1,
      sym__FORALL,
    STATE(9476), 1,
      sym_expr,
    STATE(9530), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2654), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2686), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4732), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8656), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4735), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2660), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [181654] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(3262), 1,
      sym_id,
    ACTIONS(3266), 1,
      anon_sym_BSLASH,
    ACTIONS(3268), 1,
      anon_sym_u03bb,
    ACTIONS(3272), 1,
      anon_sym_record,
    ACTIONS(3274), 1,
      anon_sym_LPAREN,
    ACTIONS(3276), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3278), 1,
      anon_sym_u2983,
    ACTIONS(3280), 1,
      anon_sym_LBRACE,
    ACTIONS(3282), 1,
      aux_sym__qid_token1,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3286), 1,
      anon_sym_quoteGoal,
    ACTIONS(3288), 1,
      anon_sym_tactic,
    ACTIONS(3290), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3292), 1,
      anon_sym_u2987,
    ACTIONS(3294), 1,
      anon_sym_let,
    ACTIONS(3298), 1,
      anon_sym_Set,
    STATE(3148), 1,
      aux_sym__atoms,
    STATE(3739), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4014), 1,
      sym_atom,
    STATE(6261), 1,
      sym_attributes,
    STATE(8143), 1,
      sym__LAMBDA,
    STATE(8451), 1,
      sym__FORALL,
    STATE(8926), 1,
      sym__with_exprs,
    STATE(8939), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3264), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3296), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4032), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8687), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4012), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3270), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [181790] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(10984), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [181926] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(10983), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [182062] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(2978), 1,
      sym_id,
    ACTIONS(2982), 1,
      anon_sym_BSLASH,
    ACTIONS(2984), 1,
      anon_sym_u03bb,
    ACTIONS(2988), 1,
      anon_sym_record,
    ACTIONS(2990), 1,
      anon_sym_LPAREN,
    ACTIONS(2992), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2994), 1,
      anon_sym_u2983,
    ACTIONS(2996), 1,
      anon_sym_LBRACE,
    ACTIONS(2998), 1,
      aux_sym__qid_token1,
    ACTIONS(3000), 1,
      anon_sym_DOT,
    ACTIONS(3002), 1,
      anon_sym_quoteGoal,
    ACTIONS(3004), 1,
      anon_sym_tactic,
    ACTIONS(3006), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3008), 1,
      anon_sym_u2987,
    ACTIONS(3010), 1,
      anon_sym_let,
    ACTIONS(3014), 1,
      anon_sym_Set,
    STATE(3136), 1,
      aux_sym__atoms,
    STATE(3737), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4529), 1,
      sym_atom,
    STATE(6210), 1,
      sym_attributes,
    STATE(8117), 1,
      sym__LAMBDA,
    STATE(8511), 1,
      sym__FORALL,
    STATE(8982), 1,
      sym_expr,
    STATE(9228), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3012), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4469), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8638), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4463), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2986), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [182198] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(3262), 1,
      sym_id,
    ACTIONS(3266), 1,
      anon_sym_BSLASH,
    ACTIONS(3268), 1,
      anon_sym_u03bb,
    ACTIONS(3272), 1,
      anon_sym_record,
    ACTIONS(3274), 1,
      anon_sym_LPAREN,
    ACTIONS(3276), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3278), 1,
      anon_sym_u2983,
    ACTIONS(3280), 1,
      anon_sym_LBRACE,
    ACTIONS(3282), 1,
      aux_sym__qid_token1,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3286), 1,
      anon_sym_quoteGoal,
    ACTIONS(3288), 1,
      anon_sym_tactic,
    ACTIONS(3290), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3292), 1,
      anon_sym_u2987,
    ACTIONS(3294), 1,
      anon_sym_let,
    ACTIONS(3298), 1,
      anon_sym_Set,
    STATE(3148), 1,
      aux_sym__atoms,
    STATE(3739), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4014), 1,
      sym_atom,
    STATE(6261), 1,
      sym_attributes,
    STATE(8143), 1,
      sym__LAMBDA,
    STATE(8451), 1,
      sym__FORALL,
    STATE(8926), 1,
      sym__with_exprs,
    STATE(8948), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3264), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3296), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4032), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8687), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4012), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3270), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [182334] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(2532), 1,
      anon_sym_BSLASH,
    ACTIONS(2534), 1,
      anon_sym_u03bb,
    ACTIONS(2552), 1,
      anon_sym_quoteGoal,
    ACTIONS(2554), 1,
      anon_sym_tactic,
    ACTIONS(2560), 1,
      anon_sym_let,
    ACTIONS(3584), 1,
      sym_id,
    ACTIONS(3588), 1,
      anon_sym_record,
    ACTIONS(3590), 1,
      anon_sym_LPAREN,
    ACTIONS(3592), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3594), 1,
      anon_sym_u2983,
    ACTIONS(3596), 1,
      anon_sym_LBRACE,
    ACTIONS(3598), 1,
      aux_sym__qid_token1,
    ACTIONS(3600), 1,
      anon_sym_DOT,
    ACTIONS(3602), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3604), 1,
      anon_sym_u2987,
    ACTIONS(3608), 1,
      anon_sym_Set,
    STATE(3300), 1,
      aux_sym__atoms,
    STATE(3720), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4261), 1,
      sym_atom,
    STATE(6280), 1,
      sym_attributes,
    STATE(8066), 1,
      sym__LAMBDA,
    STATE(8398), 1,
      sym__FORALL,
    STATE(8957), 1,
      sym_expr,
    STATE(9162), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2528), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3606), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4400), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8676), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4403), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3586), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [182470] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(2978), 1,
      sym_id,
    ACTIONS(2982), 1,
      anon_sym_BSLASH,
    ACTIONS(2984), 1,
      anon_sym_u03bb,
    ACTIONS(2988), 1,
      anon_sym_record,
    ACTIONS(2990), 1,
      anon_sym_LPAREN,
    ACTIONS(2992), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2994), 1,
      anon_sym_u2983,
    ACTIONS(2996), 1,
      anon_sym_LBRACE,
    ACTIONS(2998), 1,
      aux_sym__qid_token1,
    ACTIONS(3000), 1,
      anon_sym_DOT,
    ACTIONS(3002), 1,
      anon_sym_quoteGoal,
    ACTIONS(3004), 1,
      anon_sym_tactic,
    ACTIONS(3006), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3008), 1,
      anon_sym_u2987,
    ACTIONS(3010), 1,
      anon_sym_let,
    ACTIONS(3014), 1,
      anon_sym_Set,
    STATE(3136), 1,
      aux_sym__atoms,
    STATE(3737), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4529), 1,
      sym_atom,
    STATE(6210), 1,
      sym_attributes,
    STATE(8117), 1,
      sym__LAMBDA,
    STATE(8511), 1,
      sym__FORALL,
    STATE(8952), 1,
      sym_expr,
    STATE(9228), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3012), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4469), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8638), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4463), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2986), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [182606] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(10065), 1,
      sym__with_exprs,
    STATE(10882), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [182742] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(3262), 1,
      sym_id,
    ACTIONS(3266), 1,
      anon_sym_BSLASH,
    ACTIONS(3268), 1,
      anon_sym_u03bb,
    ACTIONS(3272), 1,
      anon_sym_record,
    ACTIONS(3274), 1,
      anon_sym_LPAREN,
    ACTIONS(3276), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3278), 1,
      anon_sym_u2983,
    ACTIONS(3280), 1,
      anon_sym_LBRACE,
    ACTIONS(3282), 1,
      aux_sym__qid_token1,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3286), 1,
      anon_sym_quoteGoal,
    ACTIONS(3288), 1,
      anon_sym_tactic,
    ACTIONS(3290), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3292), 1,
      anon_sym_u2987,
    ACTIONS(3294), 1,
      anon_sym_let,
    ACTIONS(3298), 1,
      anon_sym_Set,
    STATE(3148), 1,
      aux_sym__atoms,
    STATE(3739), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4014), 1,
      sym_atom,
    STATE(6261), 1,
      sym_attributes,
    STATE(8143), 1,
      sym__LAMBDA,
    STATE(8451), 1,
      sym__FORALL,
    STATE(8926), 1,
      sym__with_exprs,
    STATE(8952), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3264), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3296), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4032), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8687), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4012), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3270), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [182878] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(9990), 1,
      sym__with_exprs,
    STATE(10889), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [183014] = 36,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(12094), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [183150] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(3262), 1,
      sym_id,
    ACTIONS(3266), 1,
      anon_sym_BSLASH,
    ACTIONS(3268), 1,
      anon_sym_u03bb,
    ACTIONS(3272), 1,
      anon_sym_record,
    ACTIONS(3274), 1,
      anon_sym_LPAREN,
    ACTIONS(3276), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3278), 1,
      anon_sym_u2983,
    ACTIONS(3280), 1,
      anon_sym_LBRACE,
    ACTIONS(3282), 1,
      aux_sym__qid_token1,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3286), 1,
      anon_sym_quoteGoal,
    ACTIONS(3288), 1,
      anon_sym_tactic,
    ACTIONS(3290), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3292), 1,
      anon_sym_u2987,
    ACTIONS(3294), 1,
      anon_sym_let,
    ACTIONS(3298), 1,
      anon_sym_Set,
    STATE(3148), 1,
      aux_sym__atoms,
    STATE(3739), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4014), 1,
      sym_atom,
    STATE(6261), 1,
      sym_attributes,
    STATE(8143), 1,
      sym__LAMBDA,
    STATE(8451), 1,
      sym__FORALL,
    STATE(8926), 1,
      sym__with_exprs,
    STATE(8982), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3264), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3296), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4032), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8687), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4012), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3270), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [183286] = 36,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(11112), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [183422] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(10065), 1,
      sym__with_exprs,
    STATE(10912), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [183558] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(2904), 1,
      anon_sym_BSLASH,
    ACTIONS(2906), 1,
      anon_sym_u03bb,
    ACTIONS(2924), 1,
      anon_sym_quoteGoal,
    ACTIONS(2926), 1,
      anon_sym_tactic,
    ACTIONS(2932), 1,
      anon_sym_let,
    ACTIONS(3300), 1,
      sym_id,
    ACTIONS(3304), 1,
      anon_sym_record,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3308), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3310), 1,
      anon_sym_u2983,
    ACTIONS(3312), 1,
      anon_sym_LBRACE,
    ACTIONS(3314), 1,
      aux_sym__qid_token1,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3318), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3320), 1,
      anon_sym_u2987,
    ACTIONS(3324), 1,
      anon_sym_Set,
    STATE(3316), 1,
      aux_sym__atoms,
    STATE(3756), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4056), 1,
      sym_atom,
    STATE(6223), 1,
      sym_attributes,
    STATE(8094), 1,
      sym__LAMBDA,
    STATE(8489), 1,
      sym__FORALL,
    STATE(9003), 1,
      sym_expr,
    STATE(9010), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2900), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3322), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4053), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8655), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4049), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3302), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [183694] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(2978), 1,
      sym_id,
    ACTIONS(2982), 1,
      anon_sym_BSLASH,
    ACTIONS(2984), 1,
      anon_sym_u03bb,
    ACTIONS(2988), 1,
      anon_sym_record,
    ACTIONS(2990), 1,
      anon_sym_LPAREN,
    ACTIONS(2992), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2994), 1,
      anon_sym_u2983,
    ACTIONS(2996), 1,
      anon_sym_LBRACE,
    ACTIONS(2998), 1,
      aux_sym__qid_token1,
    ACTIONS(3000), 1,
      anon_sym_DOT,
    ACTIONS(3002), 1,
      anon_sym_quoteGoal,
    ACTIONS(3004), 1,
      anon_sym_tactic,
    ACTIONS(3006), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3008), 1,
      anon_sym_u2987,
    ACTIONS(3010), 1,
      anon_sym_let,
    ACTIONS(3014), 1,
      anon_sym_Set,
    STATE(3136), 1,
      aux_sym__atoms,
    STATE(3737), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4529), 1,
      sym_atom,
    STATE(6210), 1,
      sym_attributes,
    STATE(8117), 1,
      sym__LAMBDA,
    STATE(8511), 1,
      sym__FORALL,
    STATE(8948), 1,
      sym_expr,
    STATE(9228), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3012), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4469), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8638), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4463), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2986), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [183830] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1980), 1,
      sym_id,
    ACTIONS(1984), 1,
      anon_sym_BSLASH,
    ACTIONS(1986), 1,
      anon_sym_u03bb,
    ACTIONS(1990), 1,
      anon_sym_record,
    ACTIONS(1992), 1,
      anon_sym_LPAREN,
    ACTIONS(1994), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1996), 1,
      anon_sym_u2983,
    ACTIONS(1998), 1,
      anon_sym_LBRACE,
    ACTIONS(2000), 1,
      aux_sym__qid_token1,
    ACTIONS(2002), 1,
      anon_sym_DOT,
    ACTIONS(2004), 1,
      anon_sym_quoteGoal,
    ACTIONS(2006), 1,
      anon_sym_tactic,
    ACTIONS(2008), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2010), 1,
      anon_sym_u2987,
    ACTIONS(2012), 1,
      anon_sym_let,
    ACTIONS(2016), 1,
      anon_sym_Set,
    STATE(3156), 1,
      aux_sym__atoms,
    STATE(3740), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4972), 1,
      sym_atom,
    STATE(6248), 1,
      sym_attributes,
    STATE(8039), 1,
      sym__LAMBDA,
    STATE(8483), 1,
      sym__FORALL,
    STATE(9471), 1,
      sym_expr,
    STATE(9685), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1982), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2014), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5336), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8659), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5185), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1988), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [183966] = 36,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(9415), 1,
      sym_expr,
    STATE(10196), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [184102] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(11113), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [184238] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(9990), 1,
      sym__with_exprs,
    STATE(11428), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [184374] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(10065), 1,
      sym__with_exprs,
    STATE(11427), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [184510] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(2978), 1,
      sym_id,
    ACTIONS(2982), 1,
      anon_sym_BSLASH,
    ACTIONS(2984), 1,
      anon_sym_u03bb,
    ACTIONS(2988), 1,
      anon_sym_record,
    ACTIONS(2990), 1,
      anon_sym_LPAREN,
    ACTIONS(2992), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2994), 1,
      anon_sym_u2983,
    ACTIONS(2996), 1,
      anon_sym_LBRACE,
    ACTIONS(2998), 1,
      aux_sym__qid_token1,
    ACTIONS(3000), 1,
      anon_sym_DOT,
    ACTIONS(3002), 1,
      anon_sym_quoteGoal,
    ACTIONS(3004), 1,
      anon_sym_tactic,
    ACTIONS(3006), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3008), 1,
      anon_sym_u2987,
    ACTIONS(3010), 1,
      anon_sym_let,
    ACTIONS(3014), 1,
      anon_sym_Set,
    STATE(3136), 1,
      aux_sym__atoms,
    STATE(3737), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4529), 1,
      sym_atom,
    STATE(6210), 1,
      sym_attributes,
    STATE(8117), 1,
      sym__LAMBDA,
    STATE(8511), 1,
      sym__FORALL,
    STATE(8939), 1,
      sym_expr,
    STATE(9228), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3012), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4469), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8638), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4463), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2986), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [184646] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1910), 1,
      anon_sym_BSLASH,
    ACTIONS(1912), 1,
      anon_sym_u03bb,
    ACTIONS(1928), 1,
      anon_sym_quoteGoal,
    ACTIONS(1930), 1,
      anon_sym_tactic,
    ACTIONS(1936), 1,
      anon_sym_let,
    ACTIONS(2174), 1,
      sym_id,
    ACTIONS(2182), 1,
      anon_sym_record,
    ACTIONS(2184), 1,
      anon_sym_LPAREN,
    ACTIONS(2186), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2188), 1,
      anon_sym_u2983,
    ACTIONS(2190), 1,
      anon_sym_LBRACE,
    ACTIONS(2192), 1,
      aux_sym__qid_token1,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2198), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2200), 1,
      anon_sym_u2987,
    ACTIONS(2204), 1,
      anon_sym_Set,
    STATE(3339), 1,
      aux_sym__atoms,
    STATE(3717), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4611), 1,
      sym_atom,
    STATE(6264), 1,
      sym_attributes,
    STATE(8153), 1,
      sym__LAMBDA,
    STATE(8431), 1,
      sym__FORALL,
    STATE(8992), 1,
      sym_expr,
    STATE(9486), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1906), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4536), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8673), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4531), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2180), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [184782] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(11114), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [184918] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1866), 1,
      sym_id,
    ACTIONS(1870), 1,
      anon_sym_BSLASH,
    ACTIONS(1872), 1,
      anon_sym_u03bb,
    ACTIONS(1876), 1,
      anon_sym_record,
    ACTIONS(1878), 1,
      anon_sym_LPAREN,
    ACTIONS(1880), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1882), 1,
      anon_sym_u2983,
    ACTIONS(1884), 1,
      anon_sym_LBRACE,
    ACTIONS(1886), 1,
      aux_sym__qid_token1,
    ACTIONS(1888), 1,
      anon_sym_DOT,
    ACTIONS(1890), 1,
      anon_sym_quoteGoal,
    ACTIONS(1892), 1,
      anon_sym_tactic,
    ACTIONS(1894), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1896), 1,
      anon_sym_u2987,
    ACTIONS(1898), 1,
      anon_sym_let,
    ACTIONS(1902), 1,
      anon_sym_Set,
    STATE(3337), 1,
      aux_sym__atoms,
    STATE(3738), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4366), 1,
      sym_atom,
    STATE(6298), 1,
      sym_attributes,
    STATE(8032), 1,
      sym__LAMBDA,
    STATE(8379), 1,
      sym__FORALL,
    STATE(8949), 1,
      sym_expr,
    STATE(9157), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1868), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1900), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4264), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8633), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4263), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1874), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [185054] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(10065), 1,
      sym__with_exprs,
    STATE(10908), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [185190] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(11115), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [185326] = 36,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(11116), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [185462] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(11117), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [185598] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(11119), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [185734] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(2728), 1,
      sym_id,
    ACTIONS(2732), 1,
      anon_sym_BSLASH,
    ACTIONS(2734), 1,
      anon_sym_u03bb,
    ACTIONS(2738), 1,
      anon_sym_record,
    ACTIONS(2740), 1,
      anon_sym_LPAREN,
    ACTIONS(2742), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2744), 1,
      anon_sym_u2983,
    ACTIONS(2746), 1,
      anon_sym_LBRACE,
    ACTIONS(2748), 1,
      aux_sym__qid_token1,
    ACTIONS(2750), 1,
      anon_sym_DOT,
    ACTIONS(2752), 1,
      anon_sym_quoteGoal,
    ACTIONS(2754), 1,
      anon_sym_tactic,
    ACTIONS(2756), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2758), 1,
      anon_sym_u2987,
    ACTIONS(2760), 1,
      anon_sym_let,
    ACTIONS(2764), 1,
      anon_sym_Set,
    STATE(3288), 1,
      aux_sym__atoms,
    STATE(3749), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4895), 1,
      sym_atom,
    STATE(6296), 1,
      sym_attributes,
    STATE(8061), 1,
      sym__LAMBDA,
    STATE(8384), 1,
      sym__FORALL,
    STATE(8982), 1,
      sym_expr,
    STATE(9404), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2730), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2762), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4685), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8665), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4682), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2736), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [185870] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(11120), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [186006] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(9990), 1,
      sym__with_exprs,
    STATE(10907), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [186142] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(2728), 1,
      sym_id,
    ACTIONS(2732), 1,
      anon_sym_BSLASH,
    ACTIONS(2734), 1,
      anon_sym_u03bb,
    ACTIONS(2738), 1,
      anon_sym_record,
    ACTIONS(2740), 1,
      anon_sym_LPAREN,
    ACTIONS(2742), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2744), 1,
      anon_sym_u2983,
    ACTIONS(2746), 1,
      anon_sym_LBRACE,
    ACTIONS(2748), 1,
      aux_sym__qid_token1,
    ACTIONS(2750), 1,
      anon_sym_DOT,
    ACTIONS(2752), 1,
      anon_sym_quoteGoal,
    ACTIONS(2754), 1,
      anon_sym_tactic,
    ACTIONS(2756), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2758), 1,
      anon_sym_u2987,
    ACTIONS(2760), 1,
      anon_sym_let,
    ACTIONS(2764), 1,
      anon_sym_Set,
    STATE(3288), 1,
      aux_sym__atoms,
    STATE(3749), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4895), 1,
      sym_atom,
    STATE(6296), 1,
      sym_attributes,
    STATE(8061), 1,
      sym__LAMBDA,
    STATE(8384), 1,
      sym__FORALL,
    STATE(8952), 1,
      sym_expr,
    STATE(9404), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2730), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2762), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4685), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8665), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4682), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2736), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [186278] = 36,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(2652), 1,
      sym_id,
    ACTIONS(2656), 1,
      anon_sym_BSLASH,
    ACTIONS(2658), 1,
      anon_sym_u03bb,
    ACTIONS(2662), 1,
      anon_sym_record,
    ACTIONS(2664), 1,
      anon_sym_LPAREN,
    ACTIONS(2666), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2668), 1,
      anon_sym_u2983,
    ACTIONS(2670), 1,
      anon_sym_LBRACE,
    ACTIONS(2672), 1,
      aux_sym__qid_token1,
    ACTIONS(2674), 1,
      anon_sym_DOT,
    ACTIONS(2676), 1,
      anon_sym_quoteGoal,
    ACTIONS(2678), 1,
      anon_sym_tactic,
    ACTIONS(2680), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2682), 1,
      anon_sym_u2987,
    ACTIONS(2684), 1,
      anon_sym_let,
    ACTIONS(2688), 1,
      anon_sym_Set,
    STATE(3243), 1,
      aux_sym__atoms,
    STATE(3732), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4916), 1,
      sym_atom,
    STATE(6233), 1,
      sym_attributes,
    STATE(8132), 1,
      sym__LAMBDA,
    STATE(8470), 1,
      sym__FORALL,
    STATE(9465), 1,
      sym_expr,
    STATE(9530), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2654), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2686), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4732), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8656), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4735), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2660), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [186414] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(9990), 1,
      sym__with_exprs,
    STATE(10915), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [186550] = 36,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(10873), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [186686] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(10852), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [186822] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(10065), 1,
      sym__with_exprs,
    STATE(10944), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [186958] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(10849), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [187094] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(10844), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [187230] = 36,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(10840), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [187366] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(10876), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [187502] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(2728), 1,
      sym_id,
    ACTIONS(2732), 1,
      anon_sym_BSLASH,
    ACTIONS(2734), 1,
      anon_sym_u03bb,
    ACTIONS(2738), 1,
      anon_sym_record,
    ACTIONS(2740), 1,
      anon_sym_LPAREN,
    ACTIONS(2742), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2744), 1,
      anon_sym_u2983,
    ACTIONS(2746), 1,
      anon_sym_LBRACE,
    ACTIONS(2748), 1,
      aux_sym__qid_token1,
    ACTIONS(2750), 1,
      anon_sym_DOT,
    ACTIONS(2752), 1,
      anon_sym_quoteGoal,
    ACTIONS(2754), 1,
      anon_sym_tactic,
    ACTIONS(2756), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2758), 1,
      anon_sym_u2987,
    ACTIONS(2760), 1,
      anon_sym_let,
    ACTIONS(2764), 1,
      anon_sym_Set,
    STATE(3288), 1,
      aux_sym__atoms,
    STATE(3749), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4895), 1,
      sym_atom,
    STATE(6296), 1,
      sym_attributes,
    STATE(8061), 1,
      sym__LAMBDA,
    STATE(8384), 1,
      sym__FORALL,
    STATE(8948), 1,
      sym_expr,
    STATE(9404), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2730), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2762), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4685), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8665), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4682), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2736), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [187638] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(9990), 1,
      sym__with_exprs,
    STATE(10945), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [187774] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(2728), 1,
      sym_id,
    ACTIONS(2732), 1,
      anon_sym_BSLASH,
    ACTIONS(2734), 1,
      anon_sym_u03bb,
    ACTIONS(2738), 1,
      anon_sym_record,
    ACTIONS(2740), 1,
      anon_sym_LPAREN,
    ACTIONS(2742), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2744), 1,
      anon_sym_u2983,
    ACTIONS(2746), 1,
      anon_sym_LBRACE,
    ACTIONS(2748), 1,
      aux_sym__qid_token1,
    ACTIONS(2750), 1,
      anon_sym_DOT,
    ACTIONS(2752), 1,
      anon_sym_quoteGoal,
    ACTIONS(2754), 1,
      anon_sym_tactic,
    ACTIONS(2756), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2758), 1,
      anon_sym_u2987,
    ACTIONS(2760), 1,
      anon_sym_let,
    ACTIONS(2764), 1,
      anon_sym_Set,
    STATE(3288), 1,
      aux_sym__atoms,
    STATE(3749), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4895), 1,
      sym_atom,
    STATE(6296), 1,
      sym_attributes,
    STATE(8061), 1,
      sym__LAMBDA,
    STATE(8384), 1,
      sym__FORALL,
    STATE(8939), 1,
      sym_expr,
    STATE(9404), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2730), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2762), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4685), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8665), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4682), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2736), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [187910] = 36,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(9405), 1,
      sym_expr,
    STATE(10196), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [188046] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(10065), 1,
      sym__with_exprs,
    STATE(10974), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [188182] = 36,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(9466), 1,
      sym_expr,
    STATE(10196), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [188318] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1866), 1,
      sym_id,
    ACTIONS(1870), 1,
      anon_sym_BSLASH,
    ACTIONS(1872), 1,
      anon_sym_u03bb,
    ACTIONS(1876), 1,
      anon_sym_record,
    ACTIONS(1878), 1,
      anon_sym_LPAREN,
    ACTIONS(1880), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1882), 1,
      anon_sym_u2983,
    ACTIONS(1884), 1,
      anon_sym_LBRACE,
    ACTIONS(1886), 1,
      aux_sym__qid_token1,
    ACTIONS(1888), 1,
      anon_sym_DOT,
    ACTIONS(1890), 1,
      anon_sym_quoteGoal,
    ACTIONS(1892), 1,
      anon_sym_tactic,
    ACTIONS(1894), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1896), 1,
      anon_sym_u2987,
    ACTIONS(1898), 1,
      anon_sym_let,
    ACTIONS(1902), 1,
      anon_sym_Set,
    STATE(3337), 1,
      aux_sym__atoms,
    STATE(3738), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4366), 1,
      sym_atom,
    STATE(6298), 1,
      sym_attributes,
    STATE(8032), 1,
      sym__LAMBDA,
    STATE(8379), 1,
      sym__FORALL,
    STATE(8941), 1,
      sym_expr,
    STATE(9157), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1868), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1900), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4264), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8633), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4263), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1874), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [188454] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(10065), 1,
      sym__with_exprs,
    STATE(12162), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [188590] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(9990), 1,
      sym__with_exprs,
    STATE(10975), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [188726] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(2566), 1,
      sym_id,
    ACTIONS(2570), 1,
      anon_sym_BSLASH,
    ACTIONS(2572), 1,
      anon_sym_u03bb,
    ACTIONS(2576), 1,
      anon_sym_record,
    ACTIONS(2578), 1,
      anon_sym_LPAREN,
    ACTIONS(2580), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2582), 1,
      anon_sym_u2983,
    ACTIONS(2584), 1,
      anon_sym_LBRACE,
    ACTIONS(2586), 1,
      aux_sym__qid_token1,
    ACTIONS(2588), 1,
      anon_sym_DOT,
    ACTIONS(2590), 1,
      anon_sym_quoteGoal,
    ACTIONS(2592), 1,
      anon_sym_tactic,
    ACTIONS(2594), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2596), 1,
      anon_sym_u2987,
    ACTIONS(2598), 1,
      anon_sym_let,
    ACTIONS(2602), 1,
      anon_sym_Set,
    STATE(3214), 1,
      aux_sym__atoms,
    STATE(3714), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5536), 1,
      sym_atom,
    STATE(6208), 1,
      sym_attributes,
    STATE(8111), 1,
      sym__LAMBDA,
    STATE(8412), 1,
      sym__FORALL,
    STATE(10191), 1,
      sym__with_exprs,
    STATE(12207), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2568), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2600), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5566), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8634), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5590), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2574), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [188862] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(8959), 1,
      sym_expr,
    STATE(9990), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [188998] = 34,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(700), 1,
      anon_sym_LBRACE_DASH_POUND,
    ACTIONS(2732), 1,
      anon_sym_BSLASH,
    ACTIONS(2734), 1,
      anon_sym_u03bb,
    ACTIONS(2752), 1,
      anon_sym_quoteGoal,
    ACTIONS(2754), 1,
      anon_sym_tactic,
    ACTIONS(2760), 1,
      anon_sym_let,
    ACTIONS(3610), 1,
      sym_id,
    ACTIONS(3616), 1,
      anon_sym_record,
    ACTIONS(3618), 1,
      anon_sym_LPAREN,
    ACTIONS(3620), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3622), 1,
      anon_sym_u2983,
    ACTIONS(3624), 1,
      anon_sym_LBRACE,
    ACTIONS(3626), 1,
      aux_sym__qid_token1,
    ACTIONS(3628), 1,
      anon_sym_DOT,
    ACTIONS(3630), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3632), 1,
      anon_sym_u2987,
    ACTIONS(3636), 1,
      anon_sym_Set,
    STATE(1572), 1,
      sym__ARROW,
    STATE(2725), 1,
      aux_sym__lambda_clauses_repeat1,
    STATE(3190), 1,
      sym_catchall_pragma,
    STATE(3429), 1,
      aux_sym__atoms,
    STATE(5352), 1,
      sym_atom,
    STATE(8061), 1,
      sym__LAMBDA,
    STATE(8384), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2730), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3612), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(3634), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5254), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(8999), 4,
      sym__lambda_clauses,
      sym__lambda_clause_maybe_absurd,
      sym_lambda_clause_absurd,
      sym_lambda_clause,
    STATE(5242), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9000), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3614), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [189130] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(10819), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [189266] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(10065), 1,
      sym__with_exprs,
    STATE(10993), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [189402] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(9990), 1,
      sym__with_exprs,
    STATE(10997), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [189538] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(10065), 1,
      sym__with_exprs,
    STATE(12055), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [189674] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(10065), 1,
      sym__with_exprs,
    STATE(11022), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [189810] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(9990), 1,
      sym__with_exprs,
    STATE(12076), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [189946] = 34,
    ACTIONS(700), 1,
      anon_sym_LBRACE_DASH_POUND,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2448), 1,
      anon_sym_quoteGoal,
    ACTIONS(2456), 1,
      anon_sym_let,
    ACTIONS(2842), 1,
      anon_sym_BSLASH,
    ACTIONS(2844), 1,
      anon_sym_u03bb,
    ACTIONS(2862), 1,
      anon_sym_tactic,
    ACTIONS(2872), 1,
      sym_id,
    ACTIONS(2876), 1,
      anon_sym_record,
    ACTIONS(2878), 1,
      anon_sym_LPAREN,
    ACTIONS(2880), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2882), 1,
      anon_sym_u2983,
    ACTIONS(2884), 1,
      anon_sym_LBRACE,
    ACTIONS(2886), 1,
      aux_sym__qid_token1,
    ACTIONS(2888), 1,
      anon_sym_DOT,
    ACTIONS(2890), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2892), 1,
      anon_sym_u2987,
    ACTIONS(2896), 1,
      anon_sym_Set,
    STATE(2007), 1,
      sym__ARROW,
    STATE(2750), 1,
      aux_sym__lambda_clauses_repeat1,
    STATE(3134), 1,
      sym_catchall_pragma,
    STATE(3374), 1,
      aux_sym__atoms,
    STATE(4945), 1,
      sym_atom,
    STATE(8053), 1,
      sym__LAMBDA,
    STATE(8423), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2424), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2426), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(2894), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5291), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(8987), 4,
      sym__lambda_clauses,
      sym__lambda_clause_maybe_absurd,
      sym_lambda_clause_absurd,
      sym_lambda_clause,
    STATE(5287), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8988), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2874), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [190078] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(10065), 1,
      sym__with_exprs,
    STATE(12090), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [190214] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(9990), 1,
      sym__with_exprs,
    STATE(12111), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [190350] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(10065), 1,
      sym__with_exprs,
    STATE(12123), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [190486] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(9990), 1,
      sym__with_exprs,
    STATE(11023), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [190622] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(10065), 1,
      sym__with_exprs,
    STATE(11054), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [190758] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(10816), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [190894] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(9990), 1,
      sym__with_exprs,
    STATE(11055), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [191030] = 35,
    ACTIONS(700), 1,
      anon_sym_LBRACE_DASH_POUND,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2094), 1,
      sym_id,
    ACTIONS(2100), 1,
      anon_sym_BSLASH,
    ACTIONS(2102), 1,
      anon_sym_u03bb,
    ACTIONS(2106), 1,
      anon_sym_record,
    ACTIONS(2108), 1,
      anon_sym_LPAREN,
    ACTIONS(2110), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2112), 1,
      anon_sym_u2983,
    ACTIONS(2114), 1,
      anon_sym_LBRACE,
    ACTIONS(2116), 1,
      aux_sym__qid_token1,
    ACTIONS(2118), 1,
      anon_sym_DOT,
    ACTIONS(2120), 1,
      anon_sym_quoteGoal,
    ACTIONS(2122), 1,
      anon_sym_tactic,
    ACTIONS(2124), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2126), 1,
      anon_sym_u2987,
    ACTIONS(2128), 1,
      anon_sym_let,
    ACTIONS(2132), 1,
      anon_sym_Set,
    STATE(1489), 1,
      sym__ARROW,
    STATE(2825), 1,
      aux_sym__lambda_clauses_repeat1,
    STATE(3291), 1,
      sym_catchall_pragma,
    STATE(3471), 1,
      aux_sym__atoms,
    STATE(5601), 1,
      sym_atom,
    STATE(8075), 1,
      sym__LAMBDA,
    STATE(8428), 1,
      sym__FORALL,
    STATE(8987), 1,
      sym__lambda_clauses,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2096), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2098), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(2130), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5451), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(9461), 3,
      sym__lambda_clause_maybe_absurd,
      sym_lambda_clause_absurd,
      sym_lambda_clause,
    STATE(5453), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8988), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2104), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [191164] = 34,
    ACTIONS(700), 1,
      anon_sym_LBRACE_DASH_POUND,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2302), 1,
      anon_sym_BSLASH,
    ACTIONS(2304), 1,
      anon_sym_u03bb,
    ACTIONS(2322), 1,
      anon_sym_quoteGoal,
    ACTIONS(2324), 1,
      anon_sym_tactic,
    ACTIONS(2330), 1,
      anon_sym_let,
    ACTIONS(3638), 1,
      sym_id,
    ACTIONS(3644), 1,
      anon_sym_record,
    ACTIONS(3646), 1,
      anon_sym_LPAREN,
    ACTIONS(3648), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3650), 1,
      anon_sym_u2983,
    ACTIONS(3652), 1,
      anon_sym_LBRACE,
    ACTIONS(3654), 1,
      aux_sym__qid_token1,
    ACTIONS(3656), 1,
      anon_sym_DOT,
    ACTIONS(3658), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3660), 1,
      anon_sym_u2987,
    ACTIONS(3664), 1,
      anon_sym_Set,
    STATE(1641), 1,
      sym__ARROW,
    STATE(2804), 1,
      aux_sym__lambda_clauses_repeat1,
    STATE(3275), 1,
      sym_catchall_pragma,
    STATE(3485), 1,
      aux_sym__atoms,
    STATE(5734), 1,
      sym_atom,
    STATE(8138), 1,
      sym__LAMBDA,
    STATE(8476), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2300), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3640), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(3662), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5680), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(8987), 4,
      sym__lambda_clauses,
      sym__lambda_clause_maybe_absurd,
      sym_lambda_clause_absurd,
      sym_lambda_clause,
    STATE(5681), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8988), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3642), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [191296] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(10065), 1,
      sym__with_exprs,
    STATE(11084), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [191432] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(9990), 1,
      sym__with_exprs,
    STATE(11085), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [191568] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(10065), 1,
      sym__with_exprs,
    STATE(11103), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [191704] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2448), 1,
      anon_sym_quoteGoal,
    ACTIONS(2456), 1,
      anon_sym_let,
    ACTIONS(2840), 1,
      sym_id,
    ACTIONS(2842), 1,
      anon_sym_BSLASH,
    ACTIONS(2844), 1,
      anon_sym_u03bb,
    ACTIONS(2848), 1,
      anon_sym_record,
    ACTIONS(2850), 1,
      anon_sym_LPAREN,
    ACTIONS(2852), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2854), 1,
      anon_sym_u2983,
    ACTIONS(2856), 1,
      anon_sym_LBRACE,
    ACTIONS(2858), 1,
      aux_sym__qid_token1,
    ACTIONS(2860), 1,
      anon_sym_DOT,
    ACTIONS(2862), 1,
      anon_sym_tactic,
    ACTIONS(2864), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2866), 1,
      anon_sym_u2987,
    ACTIONS(2870), 1,
      anon_sym_Set,
    STATE(3174), 1,
      aux_sym__atoms,
    STATE(3747), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4684), 1,
      sym_atom,
    STATE(6273), 1,
      sym_attributes,
    STATE(8053), 1,
      sym__LAMBDA,
    STATE(8423), 1,
      sym__FORALL,
    STATE(8970), 1,
      sym_expr,
    STATE(9406), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2424), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2868), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4765), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8686), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4766), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2846), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [191840] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(9990), 1,
      sym__with_exprs,
    STATE(11110), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [191976] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(9990), 1,
      sym__with_exprs,
    STATE(12147), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [192112] = 34,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(700), 1,
      anon_sym_LBRACE_DASH_POUND,
    ACTIONS(1870), 1,
      anon_sym_BSLASH,
    ACTIONS(1872), 1,
      anon_sym_u03bb,
    ACTIONS(1890), 1,
      anon_sym_quoteGoal,
    ACTIONS(1892), 1,
      anon_sym_tactic,
    ACTIONS(1898), 1,
      anon_sym_let,
    ACTIONS(3666), 1,
      sym_id,
    ACTIONS(3672), 1,
      anon_sym_record,
    ACTIONS(3674), 1,
      anon_sym_LPAREN,
    ACTIONS(3676), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3678), 1,
      anon_sym_u2983,
    ACTIONS(3680), 1,
      anon_sym_LBRACE,
    ACTIONS(3682), 1,
      aux_sym__qid_token1,
    ACTIONS(3684), 1,
      anon_sym_DOT,
    ACTIONS(3686), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3688), 1,
      anon_sym_u2987,
    ACTIONS(3692), 1,
      anon_sym_Set,
    STATE(1400), 1,
      sym__ARROW,
    STATE(2798), 1,
      aux_sym__lambda_clauses_repeat1,
    STATE(3172), 1,
      sym_catchall_pragma,
    STATE(3653), 1,
      aux_sym__atoms,
    STATE(4587), 1,
      sym_atom,
    STATE(8032), 1,
      sym__LAMBDA,
    STATE(8379), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1868), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3668), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(3690), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4585), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(8999), 4,
      sym__lambda_clauses,
      sym__lambda_clause_maybe_absurd,
      sym_lambda_clause_absurd,
      sym_lambda_clause,
    STATE(4584), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9000), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3670), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [192244] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(10065), 1,
      sym__with_exprs,
    STATE(11133), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [192380] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(10306), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [192516] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(10307), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [192652] = 35,
    ACTIONS(700), 1,
      anon_sym_LBRACE_DASH_POUND,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2302), 1,
      anon_sym_BSLASH,
    ACTIONS(2304), 1,
      anon_sym_u03bb,
    ACTIONS(2322), 1,
      anon_sym_quoteGoal,
    ACTIONS(2324), 1,
      anon_sym_tactic,
    ACTIONS(2330), 1,
      anon_sym_let,
    ACTIONS(3638), 1,
      sym_id,
    ACTIONS(3644), 1,
      anon_sym_record,
    ACTIONS(3646), 1,
      anon_sym_LPAREN,
    ACTIONS(3648), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3650), 1,
      anon_sym_u2983,
    ACTIONS(3652), 1,
      anon_sym_LBRACE,
    ACTIONS(3654), 1,
      aux_sym__qid_token1,
    ACTIONS(3656), 1,
      anon_sym_DOT,
    ACTIONS(3658), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3660), 1,
      anon_sym_u2987,
    ACTIONS(3664), 1,
      anon_sym_Set,
    STATE(1641), 1,
      sym__ARROW,
    STATE(2819), 1,
      aux_sym__lambda_clauses_repeat1,
    STATE(3275), 1,
      sym_catchall_pragma,
    STATE(3485), 1,
      aux_sym__atoms,
    STATE(5734), 1,
      sym_atom,
    STATE(8138), 1,
      sym__LAMBDA,
    STATE(8476), 1,
      sym__FORALL,
    STATE(8987), 1,
      sym__lambda_clauses,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2300), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3640), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(3662), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5680), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(8986), 3,
      sym__lambda_clause_maybe_absurd,
      sym_lambda_clause_absurd,
      sym_lambda_clause,
    STATE(5681), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8988), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3642), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [192786] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(10308), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [192922] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(9990), 1,
      sym__with_exprs,
    STATE(11134), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [193058] = 36,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(10312), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [193194] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(10313), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [193330] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(10065), 1,
      sym__with_exprs,
    STATE(11161), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [193466] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(2566), 1,
      sym_id,
    ACTIONS(2570), 1,
      anon_sym_BSLASH,
    ACTIONS(2572), 1,
      anon_sym_u03bb,
    ACTIONS(2576), 1,
      anon_sym_record,
    ACTIONS(2578), 1,
      anon_sym_LPAREN,
    ACTIONS(2580), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2582), 1,
      anon_sym_u2983,
    ACTIONS(2584), 1,
      anon_sym_LBRACE,
    ACTIONS(2586), 1,
      aux_sym__qid_token1,
    ACTIONS(2588), 1,
      anon_sym_DOT,
    ACTIONS(2590), 1,
      anon_sym_quoteGoal,
    ACTIONS(2592), 1,
      anon_sym_tactic,
    ACTIONS(2594), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2596), 1,
      anon_sym_u2987,
    ACTIONS(2598), 1,
      anon_sym_let,
    ACTIONS(2602), 1,
      anon_sym_Set,
    STATE(3214), 1,
      aux_sym__atoms,
    STATE(3714), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5536), 1,
      sym_atom,
    STATE(6208), 1,
      sym_attributes,
    STATE(8111), 1,
      sym__LAMBDA,
    STATE(8412), 1,
      sym__FORALL,
    STATE(8952), 1,
      sym_expr,
    STATE(10191), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2568), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2600), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5566), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8634), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5590), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2574), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [193602] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(3262), 1,
      sym_id,
    ACTIONS(3266), 1,
      anon_sym_BSLASH,
    ACTIONS(3268), 1,
      anon_sym_u03bb,
    ACTIONS(3272), 1,
      anon_sym_record,
    ACTIONS(3274), 1,
      anon_sym_LPAREN,
    ACTIONS(3276), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3278), 1,
      anon_sym_u2983,
    ACTIONS(3280), 1,
      anon_sym_LBRACE,
    ACTIONS(3282), 1,
      aux_sym__qid_token1,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3286), 1,
      anon_sym_quoteGoal,
    ACTIONS(3288), 1,
      anon_sym_tactic,
    ACTIONS(3290), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3292), 1,
      anon_sym_u2987,
    ACTIONS(3294), 1,
      anon_sym_let,
    ACTIONS(3298), 1,
      anon_sym_Set,
    STATE(3148), 1,
      aux_sym__atoms,
    STATE(3739), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4014), 1,
      sym_atom,
    STATE(6261), 1,
      sym_attributes,
    STATE(8143), 1,
      sym__LAMBDA,
    STATE(8451), 1,
      sym__FORALL,
    STATE(8926), 1,
      sym__with_exprs,
    STATE(8957), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3264), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3296), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4032), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8687), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4012), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3270), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [193738] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(10314), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [193874] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(10323), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [194010] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(9990), 1,
      sym__with_exprs,
    STATE(11162), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [194146] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(10508), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [194282] = 36,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(10324), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [194418] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(850), 1,
      sym_id,
    ACTIONS(854), 1,
      anon_sym_BSLASH,
    ACTIONS(856), 1,
      anon_sym_u03bb,
    ACTIONS(860), 1,
      anon_sym_record,
    ACTIONS(862), 1,
      anon_sym_LPAREN,
    ACTIONS(864), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(866), 1,
      anon_sym_u2983,
    ACTIONS(870), 1,
      anon_sym_LBRACE,
    ACTIONS(872), 1,
      aux_sym__qid_token1,
    ACTIONS(874), 1,
      anon_sym_DOT,
    ACTIONS(878), 1,
      anon_sym_quoteGoal,
    ACTIONS(880), 1,
      anon_sym_tactic,
    ACTIONS(882), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(884), 1,
      anon_sym_u2987,
    ACTIONS(886), 1,
      anon_sym_let,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(892), 1,
      anon_sym_Set,
    STATE(3274), 1,
      aux_sym__atoms,
    STATE(3763), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5204), 1,
      sym_atom,
    STATE(6271), 1,
      sym_attributes,
    STATE(8152), 1,
      sym__LAMBDA,
    STATE(8369), 1,
      sym__FORALL,
    STATE(8959), 1,
      sym_expr,
    STATE(9548), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(852), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(890), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5180), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8688), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5168), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(858), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [194554] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(3694), 1,
      sym_id,
    ACTIONS(3698), 1,
      anon_sym_BSLASH,
    ACTIONS(3700), 1,
      anon_sym_u03bb,
    ACTIONS(3704), 1,
      anon_sym_record,
    ACTIONS(3706), 1,
      anon_sym_LPAREN,
    ACTIONS(3708), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3710), 1,
      anon_sym_u2983,
    ACTIONS(3712), 1,
      anon_sym_LBRACE,
    ACTIONS(3714), 1,
      aux_sym__qid_token1,
    ACTIONS(3716), 1,
      anon_sym_DOT,
    ACTIONS(3718), 1,
      anon_sym_quoteGoal,
    ACTIONS(3720), 1,
      anon_sym_tactic,
    ACTIONS(3722), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3724), 1,
      anon_sym_u2987,
    ACTIONS(3726), 1,
      anon_sym_let,
    ACTIONS(3730), 1,
      anon_sym_Set,
    STATE(3295), 1,
      aux_sym__atoms,
    STATE(3761), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4435), 1,
      sym_atom,
    STATE(6181), 1,
      sym_attributes,
    STATE(8124), 1,
      sym__LAMBDA,
    STATE(8446), 1,
      sym__FORALL,
    STATE(8939), 1,
      sym_expr,
    STATE(9267), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3696), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3728), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4467), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8651), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4459), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3702), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [194690] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(3694), 1,
      sym_id,
    ACTIONS(3698), 1,
      anon_sym_BSLASH,
    ACTIONS(3700), 1,
      anon_sym_u03bb,
    ACTIONS(3704), 1,
      anon_sym_record,
    ACTIONS(3706), 1,
      anon_sym_LPAREN,
    ACTIONS(3708), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3710), 1,
      anon_sym_u2983,
    ACTIONS(3712), 1,
      anon_sym_LBRACE,
    ACTIONS(3714), 1,
      aux_sym__qid_token1,
    ACTIONS(3716), 1,
      anon_sym_DOT,
    ACTIONS(3718), 1,
      anon_sym_quoteGoal,
    ACTIONS(3720), 1,
      anon_sym_tactic,
    ACTIONS(3722), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3724), 1,
      anon_sym_u2987,
    ACTIONS(3726), 1,
      anon_sym_let,
    ACTIONS(3730), 1,
      anon_sym_Set,
    STATE(3295), 1,
      aux_sym__atoms,
    STATE(3761), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4435), 1,
      sym_atom,
    STATE(6181), 1,
      sym_attributes,
    STATE(8124), 1,
      sym__LAMBDA,
    STATE(8446), 1,
      sym__FORALL,
    STATE(8948), 1,
      sym_expr,
    STATE(9267), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3696), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3728), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4467), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8651), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4459), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3702), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [194826] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(9990), 1,
      sym__with_exprs,
    STATE(11198), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [194962] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(734), 1,
      sym_id,
    ACTIONS(738), 1,
      anon_sym_BSLASH,
    ACTIONS(740), 1,
      anon_sym_u03bb,
    ACTIONS(744), 1,
      anon_sym_record,
    ACTIONS(746), 1,
      anon_sym_LPAREN,
    ACTIONS(748), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(750), 1,
      anon_sym_u2983,
    ACTIONS(752), 1,
      anon_sym_LBRACE,
    ACTIONS(754), 1,
      aux_sym__qid_token1,
    ACTIONS(756), 1,
      anon_sym_DOT,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(762), 1,
      anon_sym_quoteGoal,
    ACTIONS(764), 1,
      anon_sym_tactic,
    ACTIONS(766), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(768), 1,
      anon_sym_u2987,
    ACTIONS(774), 1,
      anon_sym_Set,
    ACTIONS(3054), 1,
      anon_sym_let,
    STATE(3326), 1,
      aux_sym__atoms,
    STATE(3730), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5147), 1,
      sym_atom,
    STATE(6212), 1,
      sym_attributes,
    STATE(8156), 1,
      sym__LAMBDA,
    STATE(8456), 1,
      sym__FORALL,
    STATE(8949), 1,
      sym_expr,
    STATE(9596), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(736), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(772), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5108), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8641), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5102), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(742), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [195098] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(10065), 1,
      sym__with_exprs,
    STATE(11221), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [195234] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(10626), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [195370] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(10625), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [195506] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(10828), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [195642] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(9990), 1,
      sym__with_exprs,
    STATE(11230), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [195778] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(10065), 1,
      sym__with_exprs,
    STATE(11257), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [195914] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(3694), 1,
      sym_id,
    ACTIONS(3698), 1,
      anon_sym_BSLASH,
    ACTIONS(3700), 1,
      anon_sym_u03bb,
    ACTIONS(3704), 1,
      anon_sym_record,
    ACTIONS(3706), 1,
      anon_sym_LPAREN,
    ACTIONS(3708), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3710), 1,
      anon_sym_u2983,
    ACTIONS(3712), 1,
      anon_sym_LBRACE,
    ACTIONS(3714), 1,
      aux_sym__qid_token1,
    ACTIONS(3716), 1,
      anon_sym_DOT,
    ACTIONS(3718), 1,
      anon_sym_quoteGoal,
    ACTIONS(3720), 1,
      anon_sym_tactic,
    ACTIONS(3722), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3724), 1,
      anon_sym_u2987,
    ACTIONS(3726), 1,
      anon_sym_let,
    ACTIONS(3730), 1,
      anon_sym_Set,
    STATE(3295), 1,
      aux_sym__atoms,
    STATE(3761), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4435), 1,
      sym_atom,
    STATE(6181), 1,
      sym_attributes,
    STATE(8124), 1,
      sym__LAMBDA,
    STATE(8446), 1,
      sym__FORALL,
    STATE(8952), 1,
      sym_expr,
    STATE(9267), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3696), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3728), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4467), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8651), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4459), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3702), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [196050] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(11346), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [196186] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(11409), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [196322] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(11406), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [196458] = 35,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(700), 1,
      anon_sym_LBRACE_DASH_POUND,
    ACTIONS(3266), 1,
      anon_sym_BSLASH,
    ACTIONS(3268), 1,
      anon_sym_u03bb,
    ACTIONS(3286), 1,
      anon_sym_quoteGoal,
    ACTIONS(3288), 1,
      anon_sym_tactic,
    ACTIONS(3294), 1,
      anon_sym_let,
    ACTIONS(3732), 1,
      sym_id,
    ACTIONS(3738), 1,
      anon_sym_record,
    ACTIONS(3740), 1,
      anon_sym_LPAREN,
    ACTIONS(3742), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3744), 1,
      anon_sym_u2983,
    ACTIONS(3746), 1,
      anon_sym_LBRACE,
    ACTIONS(3748), 1,
      aux_sym__qid_token1,
    ACTIONS(3750), 1,
      anon_sym_DOT,
    ACTIONS(3752), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3754), 1,
      anon_sym_u2987,
    ACTIONS(3758), 1,
      anon_sym_Set,
    STATE(2021), 1,
      sym__ARROW,
    STATE(2782), 1,
      aux_sym__lambda_clauses_repeat1,
    STATE(3195), 1,
      sym_catchall_pragma,
    STATE(3592), 1,
      aux_sym__atoms,
    STATE(4058), 1,
      sym_atom,
    STATE(8143), 1,
      sym__LAMBDA,
    STATE(8451), 1,
      sym__FORALL,
    STATE(8999), 1,
      sym__lambda_clauses,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3264), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3734), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(3756), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4073), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(8993), 3,
      sym__lambda_clause_maybe_absurd,
      sym_lambda_clause_absurd,
      sym_lambda_clause,
    STATE(4070), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9000), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3736), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [196592] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(9990), 1,
      sym__with_exprs,
    STATE(10332), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [196728] = 36,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(11405), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [196864] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(11404), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [197000] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(11403), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [197136] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(11402), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [197272] = 36,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(10663), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [197408] = 36,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(11401), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [197544] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(10065), 1,
      sym__with_exprs,
    STATE(10418), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [197680] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(3694), 1,
      sym_id,
    ACTIONS(3698), 1,
      anon_sym_BSLASH,
    ACTIONS(3700), 1,
      anon_sym_u03bb,
    ACTIONS(3704), 1,
      anon_sym_record,
    ACTIONS(3706), 1,
      anon_sym_LPAREN,
    ACTIONS(3708), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3710), 1,
      anon_sym_u2983,
    ACTIONS(3712), 1,
      anon_sym_LBRACE,
    ACTIONS(3714), 1,
      aux_sym__qid_token1,
    ACTIONS(3716), 1,
      anon_sym_DOT,
    ACTIONS(3718), 1,
      anon_sym_quoteGoal,
    ACTIONS(3720), 1,
      anon_sym_tactic,
    ACTIONS(3722), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3724), 1,
      anon_sym_u2987,
    ACTIONS(3726), 1,
      anon_sym_let,
    ACTIONS(3730), 1,
      anon_sym_Set,
    STATE(3295), 1,
      aux_sym__atoms,
    STATE(3761), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4435), 1,
      sym_atom,
    STATE(6181), 1,
      sym_attributes,
    STATE(8124), 1,
      sym__LAMBDA,
    STATE(8446), 1,
      sym__FORALL,
    STATE(8982), 1,
      sym_expr,
    STATE(9267), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3696), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3728), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4467), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8651), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4459), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3702), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [197816] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(2728), 1,
      sym_id,
    ACTIONS(2732), 1,
      anon_sym_BSLASH,
    ACTIONS(2734), 1,
      anon_sym_u03bb,
    ACTIONS(2738), 1,
      anon_sym_record,
    ACTIONS(2740), 1,
      anon_sym_LPAREN,
    ACTIONS(2742), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2744), 1,
      anon_sym_u2983,
    ACTIONS(2746), 1,
      anon_sym_LBRACE,
    ACTIONS(2748), 1,
      aux_sym__qid_token1,
    ACTIONS(2750), 1,
      anon_sym_DOT,
    ACTIONS(2752), 1,
      anon_sym_quoteGoal,
    ACTIONS(2754), 1,
      anon_sym_tactic,
    ACTIONS(2756), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2758), 1,
      anon_sym_u2987,
    ACTIONS(2760), 1,
      anon_sym_let,
    ACTIONS(2764), 1,
      anon_sym_Set,
    STATE(3288), 1,
      aux_sym__atoms,
    STATE(3749), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4895), 1,
      sym_atom,
    STATE(6296), 1,
      sym_attributes,
    STATE(8061), 1,
      sym__LAMBDA,
    STATE(8384), 1,
      sym__FORALL,
    STATE(8949), 1,
      sym_expr,
    STATE(9404), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2730), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2762), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4685), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8665), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4682), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2736), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [197952] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(9990), 1,
      sym__with_exprs,
    STATE(12196), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [198088] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(10065), 1,
      sym__with_exprs,
    STATE(11142), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [198224] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(9990), 1,
      sym__with_exprs,
    STATE(11143), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [198360] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(10065), 1,
      sym__with_exprs,
    STATE(12212), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [198496] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(3016), 1,
      sym_id,
    ACTIONS(3020), 1,
      anon_sym_BSLASH,
    ACTIONS(3022), 1,
      anon_sym_u03bb,
    ACTIONS(3026), 1,
      anon_sym_record,
    ACTIONS(3028), 1,
      anon_sym_LPAREN,
    ACTIONS(3030), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3032), 1,
      anon_sym_u2983,
    ACTIONS(3034), 1,
      anon_sym_LBRACE,
    ACTIONS(3036), 1,
      aux_sym__qid_token1,
    ACTIONS(3038), 1,
      anon_sym_DOT,
    ACTIONS(3040), 1,
      anon_sym_quoteGoal,
    ACTIONS(3042), 1,
      anon_sym_tactic,
    ACTIONS(3044), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3046), 1,
      anon_sym_u2987,
    ACTIONS(3048), 1,
      anon_sym_let,
    ACTIONS(3052), 1,
      anon_sym_Set,
    STATE(3216), 1,
      aux_sym__atoms,
    STATE(3760), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5039), 1,
      sym_atom,
    STATE(6294), 1,
      sym_attributes,
    STATE(8127), 1,
      sym__LAMBDA,
    STATE(8388), 1,
      sym__FORALL,
    STATE(8961), 1,
      sym_expr,
    STATE(9599), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3018), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3050), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5330), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8672), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5333), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3024), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [198632] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(850), 1,
      sym_id,
    ACTIONS(854), 1,
      anon_sym_BSLASH,
    ACTIONS(856), 1,
      anon_sym_u03bb,
    ACTIONS(860), 1,
      anon_sym_record,
    ACTIONS(862), 1,
      anon_sym_LPAREN,
    ACTIONS(864), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(866), 1,
      anon_sym_u2983,
    ACTIONS(870), 1,
      anon_sym_LBRACE,
    ACTIONS(872), 1,
      aux_sym__qid_token1,
    ACTIONS(874), 1,
      anon_sym_DOT,
    ACTIONS(878), 1,
      anon_sym_quoteGoal,
    ACTIONS(880), 1,
      anon_sym_tactic,
    ACTIONS(882), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(884), 1,
      anon_sym_u2987,
    ACTIONS(886), 1,
      anon_sym_let,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(892), 1,
      anon_sym_Set,
    STATE(3274), 1,
      aux_sym__atoms,
    STATE(3763), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5204), 1,
      sym_atom,
    STATE(6271), 1,
      sym_attributes,
    STATE(8152), 1,
      sym__LAMBDA,
    STATE(8369), 1,
      sym__FORALL,
    STATE(8992), 1,
      sym_expr,
    STATE(9548), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(852), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(890), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5180), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8688), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5168), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(858), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [198768] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(3016), 1,
      sym_id,
    ACTIONS(3020), 1,
      anon_sym_BSLASH,
    ACTIONS(3022), 1,
      anon_sym_u03bb,
    ACTIONS(3026), 1,
      anon_sym_record,
    ACTIONS(3028), 1,
      anon_sym_LPAREN,
    ACTIONS(3030), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3032), 1,
      anon_sym_u2983,
    ACTIONS(3034), 1,
      anon_sym_LBRACE,
    ACTIONS(3036), 1,
      aux_sym__qid_token1,
    ACTIONS(3038), 1,
      anon_sym_DOT,
    ACTIONS(3040), 1,
      anon_sym_quoteGoal,
    ACTIONS(3042), 1,
      anon_sym_tactic,
    ACTIONS(3044), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3046), 1,
      anon_sym_u2987,
    ACTIONS(3048), 1,
      anon_sym_let,
    ACTIONS(3052), 1,
      anon_sym_Set,
    STATE(3216), 1,
      aux_sym__atoms,
    STATE(3760), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5039), 1,
      sym_atom,
    STATE(6294), 1,
      sym_attributes,
    STATE(8127), 1,
      sym__LAMBDA,
    STATE(8388), 1,
      sym__FORALL,
    STATE(8951), 1,
      sym_expr,
    STATE(9599), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3018), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3050), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5330), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8672), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5333), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3024), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [198904] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(9990), 1,
      sym__with_exprs,
    STATE(11258), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [199040] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(10065), 1,
      sym__with_exprs,
    STATE(11291), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [199176] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(10825), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [199312] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(9990), 1,
      sym__with_exprs,
    STATE(11292), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [199448] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(3016), 1,
      sym_id,
    ACTIONS(3020), 1,
      anon_sym_BSLASH,
    ACTIONS(3022), 1,
      anon_sym_u03bb,
    ACTIONS(3026), 1,
      anon_sym_record,
    ACTIONS(3028), 1,
      anon_sym_LPAREN,
    ACTIONS(3030), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3032), 1,
      anon_sym_u2983,
    ACTIONS(3034), 1,
      anon_sym_LBRACE,
    ACTIONS(3036), 1,
      aux_sym__qid_token1,
    ACTIONS(3038), 1,
      anon_sym_DOT,
    ACTIONS(3040), 1,
      anon_sym_quoteGoal,
    ACTIONS(3042), 1,
      anon_sym_tactic,
    ACTIONS(3044), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3046), 1,
      anon_sym_u2987,
    ACTIONS(3048), 1,
      anon_sym_let,
    ACTIONS(3052), 1,
      anon_sym_Set,
    STATE(3216), 1,
      aux_sym__atoms,
    STATE(3760), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5039), 1,
      sym_atom,
    STATE(6294), 1,
      sym_attributes,
    STATE(8127), 1,
      sym__LAMBDA,
    STATE(8388), 1,
      sym__FORALL,
    STATE(8974), 1,
      sym_expr,
    STATE(9599), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3018), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3050), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5330), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8672), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5333), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3024), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [199584] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(3016), 1,
      sym_id,
    ACTIONS(3020), 1,
      anon_sym_BSLASH,
    ACTIONS(3022), 1,
      anon_sym_u03bb,
    ACTIONS(3026), 1,
      anon_sym_record,
    ACTIONS(3028), 1,
      anon_sym_LPAREN,
    ACTIONS(3030), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3032), 1,
      anon_sym_u2983,
    ACTIONS(3034), 1,
      anon_sym_LBRACE,
    ACTIONS(3036), 1,
      aux_sym__qid_token1,
    ACTIONS(3038), 1,
      anon_sym_DOT,
    ACTIONS(3040), 1,
      anon_sym_quoteGoal,
    ACTIONS(3042), 1,
      anon_sym_tactic,
    ACTIONS(3044), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3046), 1,
      anon_sym_u2987,
    ACTIONS(3048), 1,
      anon_sym_let,
    ACTIONS(3052), 1,
      anon_sym_Set,
    STATE(3216), 1,
      aux_sym__atoms,
    STATE(3760), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5039), 1,
      sym_atom,
    STATE(6294), 1,
      sym_attributes,
    STATE(8127), 1,
      sym__LAMBDA,
    STATE(8388), 1,
      sym__FORALL,
    STATE(8978), 1,
      sym_expr,
    STATE(9599), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3018), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3050), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5330), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8672), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5333), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3024), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [199720] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(2728), 1,
      sym_id,
    ACTIONS(2732), 1,
      anon_sym_BSLASH,
    ACTIONS(2734), 1,
      anon_sym_u03bb,
    ACTIONS(2738), 1,
      anon_sym_record,
    ACTIONS(2740), 1,
      anon_sym_LPAREN,
    ACTIONS(2742), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2744), 1,
      anon_sym_u2983,
    ACTIONS(2746), 1,
      anon_sym_LBRACE,
    ACTIONS(2748), 1,
      aux_sym__qid_token1,
    ACTIONS(2750), 1,
      anon_sym_DOT,
    ACTIONS(2752), 1,
      anon_sym_quoteGoal,
    ACTIONS(2754), 1,
      anon_sym_tactic,
    ACTIONS(2756), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2758), 1,
      anon_sym_u2987,
    ACTIONS(2760), 1,
      anon_sym_let,
    ACTIONS(2764), 1,
      anon_sym_Set,
    STATE(3288), 1,
      aux_sym__atoms,
    STATE(3749), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4895), 1,
      sym_atom,
    STATE(6296), 1,
      sym_attributes,
    STATE(8061), 1,
      sym__LAMBDA,
    STATE(8384), 1,
      sym__FORALL,
    STATE(8941), 1,
      sym_expr,
    STATE(9404), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2730), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2762), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4685), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8665), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4682), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2736), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [199856] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(9990), 1,
      sym__with_exprs,
    STATE(10419), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [199992] = 36,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(10429), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [200128] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(9990), 1,
      sym__with_exprs,
    STATE(12239), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [200264] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(10065), 1,
      sym__with_exprs,
    STATE(10333), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [200400] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(2978), 1,
      sym_id,
    ACTIONS(2982), 1,
      anon_sym_BSLASH,
    ACTIONS(2984), 1,
      anon_sym_u03bb,
    ACTIONS(2988), 1,
      anon_sym_record,
    ACTIONS(2990), 1,
      anon_sym_LPAREN,
    ACTIONS(2992), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2994), 1,
      anon_sym_u2983,
    ACTIONS(2996), 1,
      anon_sym_LBRACE,
    ACTIONS(2998), 1,
      aux_sym__qid_token1,
    ACTIONS(3000), 1,
      anon_sym_DOT,
    ACTIONS(3002), 1,
      anon_sym_quoteGoal,
    ACTIONS(3004), 1,
      anon_sym_tactic,
    ACTIONS(3006), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3008), 1,
      anon_sym_u2987,
    ACTIONS(3010), 1,
      anon_sym_let,
    ACTIONS(3014), 1,
      anon_sym_Set,
    STATE(3136), 1,
      aux_sym__atoms,
    STATE(3737), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4529), 1,
      sym_atom,
    STATE(6210), 1,
      sym_attributes,
    STATE(8117), 1,
      sym__LAMBDA,
    STATE(8511), 1,
      sym__FORALL,
    STATE(8941), 1,
      sym_expr,
    STATE(9228), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3012), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4469), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8638), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4463), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2986), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [200536] = 36,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(11150), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [200672] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(10065), 1,
      sym__with_exprs,
    STATE(12264), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [200808] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(11151), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [200944] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(11152), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [201080] = 34,
    ACTIONS(700), 1,
      anon_sym_LBRACE_DASH_POUND,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1916), 1,
      anon_sym_record,
    ACTIONS(1918), 1,
      anon_sym_LPAREN,
    ACTIONS(1920), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1922), 1,
      anon_sym_u2983,
    ACTIONS(1924), 1,
      anon_sym_LBRACE,
    ACTIONS(1932), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1934), 1,
      anon_sym_u2987,
    ACTIONS(2120), 1,
      anon_sym_quoteGoal,
    ACTIONS(2128), 1,
      anon_sym_let,
    ACTIONS(2176), 1,
      anon_sym_BSLASH,
    ACTIONS(2178), 1,
      anon_sym_u03bb,
    ACTIONS(2196), 1,
      anon_sym_tactic,
    ACTIONS(2606), 1,
      sym_id,
    ACTIONS(2608), 1,
      aux_sym__qid_token1,
    ACTIONS(2610), 1,
      anon_sym_DOT,
    ACTIONS(2612), 1,
      anon_sym_Set,
    STATE(1489), 1,
      sym__ARROW,
    STATE(2724), 1,
      aux_sym__lambda_clauses_repeat1,
    STATE(3135), 1,
      sym_catchall_pragma,
    STATE(3507), 1,
      aux_sym__atoms,
    STATE(4914), 1,
      sym_atom,
    STATE(8044), 1,
      sym__LAMBDA,
    STATE(8428), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1938), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(2096), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2098), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(4675), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(8987), 4,
      sym__lambda_clauses,
      sym__lambda_clause_maybe_absurd,
      sym_lambda_clause_absurd,
      sym_lambda_clause,
    STATE(4679), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8988), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1914), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [201212] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(10824), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [201348] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(940), 1,
      sym_id,
    ACTIONS(950), 1,
      anon_sym_record,
    ACTIONS(952), 1,
      anon_sym_LPAREN,
    ACTIONS(954), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(956), 1,
      anon_sym_u2983,
    ACTIONS(958), 1,
      anon_sym_LBRACE,
    ACTIONS(960), 1,
      aux_sym__qid_token1,
    ACTIONS(962), 1,
      anon_sym_DOT,
    ACTIONS(968), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(970), 1,
      anon_sym_u2987,
    ACTIONS(976), 1,
      anon_sym_Set,
    ACTIONS(982), 1,
      anon_sym_BSLASH,
    ACTIONS(984), 1,
      anon_sym_u03bb,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(990), 1,
      anon_sym_tactic,
    ACTIONS(1302), 1,
      anon_sym_let,
    STATE(3221), 1,
      aux_sym__atoms,
    STATE(3708), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4712), 1,
      sym_atom,
    STATE(6263), 1,
      sym_attributes,
    STATE(8095), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(8978), 1,
      sym_expr,
    STATE(9521), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(974), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(4733), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8670), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4742), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(948), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [201484] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(940), 1,
      sym_id,
    ACTIONS(950), 1,
      anon_sym_record,
    ACTIONS(952), 1,
      anon_sym_LPAREN,
    ACTIONS(954), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(956), 1,
      anon_sym_u2983,
    ACTIONS(958), 1,
      anon_sym_LBRACE,
    ACTIONS(960), 1,
      aux_sym__qid_token1,
    ACTIONS(962), 1,
      anon_sym_DOT,
    ACTIONS(968), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(970), 1,
      anon_sym_u2987,
    ACTIONS(976), 1,
      anon_sym_Set,
    ACTIONS(982), 1,
      anon_sym_BSLASH,
    ACTIONS(984), 1,
      anon_sym_u03bb,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(990), 1,
      anon_sym_tactic,
    ACTIONS(1302), 1,
      anon_sym_let,
    STATE(3221), 1,
      aux_sym__atoms,
    STATE(3708), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4712), 1,
      sym_atom,
    STATE(6263), 1,
      sym_attributes,
    STATE(8095), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(8974), 1,
      sym_expr,
    STATE(9521), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(974), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(4733), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8670), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4742), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(948), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [201620] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(11138), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [201756] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(10065), 1,
      sym__with_exprs,
    STATE(11318), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [201892] = 36,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(10823), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [202028] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(10822), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [202164] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(10430), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [202300] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(10821), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [202436] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(10432), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [202572] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(10433), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [202708] = 36,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(10434), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [202844] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(10065), 1,
      sym__with_exprs,
    STATE(10751), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [202980] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(940), 1,
      sym_id,
    ACTIONS(950), 1,
      anon_sym_record,
    ACTIONS(952), 1,
      anon_sym_LPAREN,
    ACTIONS(954), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(956), 1,
      anon_sym_u2983,
    ACTIONS(958), 1,
      anon_sym_LBRACE,
    ACTIONS(960), 1,
      aux_sym__qid_token1,
    ACTIONS(962), 1,
      anon_sym_DOT,
    ACTIONS(968), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(970), 1,
      anon_sym_u2987,
    ACTIONS(976), 1,
      anon_sym_Set,
    ACTIONS(982), 1,
      anon_sym_BSLASH,
    ACTIONS(984), 1,
      anon_sym_u03bb,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(990), 1,
      anon_sym_tactic,
    ACTIONS(1302), 1,
      anon_sym_let,
    STATE(3221), 1,
      aux_sym__atoms,
    STATE(3708), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4712), 1,
      sym_atom,
    STATE(6263), 1,
      sym_attributes,
    STATE(8095), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(8951), 1,
      sym_expr,
    STATE(9521), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(974), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(4733), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8670), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4742), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(948), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [203116] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(9990), 1,
      sym__with_exprs,
    STATE(11319), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [203252] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(10065), 1,
      sym__with_exprs,
    STATE(11349), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [203388] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(9990), 1,
      sym__with_exprs,
    STATE(12288), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [203524] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(9990), 1,
      sym__with_exprs,
    STATE(10750), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [203660] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(10065), 1,
      sym__with_exprs,
    STATE(12300), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [203796] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(9990), 1,
      sym__with_exprs,
    STATE(12324), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [203932] = 36,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(10713), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [204068] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(9990), 1,
      sym__with_exprs,
    STATE(11350), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [204204] = 36,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(11155), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [204340] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(12180), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [204476] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(10065), 1,
      sym__with_exprs,
    STATE(12339), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [204612] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(9990), 1,
      sym__with_exprs,
    STATE(12364), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [204748] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(10065), 1,
      sym__with_exprs,
    STATE(11384), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [204884] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(10065), 1,
      sym__with_exprs,
    STATE(12373), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [205020] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(9990), 1,
      sym__with_exprs,
    STATE(11385), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [205156] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(12064), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [205292] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(9990), 1,
      sym__with_exprs,
    STATE(11394), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [205428] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(10065), 1,
      sym__with_exprs,
    STATE(11393), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [205564] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(11156), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [205700] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(11159), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [205836] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(9990), 1,
      sym__with_exprs,
    STATE(12392), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [205972] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(10065), 1,
      sym__with_exprs,
    STATE(12404), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [206108] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(11160), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [206244] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(10711), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [206380] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(2212), 1,
      anon_sym_BSLASH,
    ACTIONS(2214), 1,
      anon_sym_u03bb,
    ACTIONS(2232), 1,
      anon_sym_quoteGoal,
    ACTIONS(2234), 1,
      anon_sym_tactic,
    ACTIONS(2240), 1,
      anon_sym_let,
    ACTIONS(3760), 1,
      sym_id,
    ACTIONS(3764), 1,
      anon_sym_record,
    ACTIONS(3766), 1,
      anon_sym_LPAREN,
    ACTIONS(3768), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3770), 1,
      anon_sym_u2983,
    ACTIONS(3772), 1,
      anon_sym_LBRACE,
    ACTIONS(3774), 1,
      aux_sym__qid_token1,
    ACTIONS(3776), 1,
      anon_sym_DOT,
    ACTIONS(3778), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3780), 1,
      anon_sym_u2987,
    ACTIONS(3784), 1,
      anon_sym_Set,
    STATE(3306), 1,
      aux_sym__atoms,
    STATE(3733), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4506), 1,
      sym_atom,
    STATE(6279), 1,
      sym_attributes,
    STATE(8035), 1,
      sym__LAMBDA,
    STATE(8402), 1,
      sym__FORALL,
    STATE(9002), 1,
      sym_expr,
    STATE(9372), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3782), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4599), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8680), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4613), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3762), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [206516] = 34,
    ACTIONS(700), 1,
      anon_sym_LBRACE_DASH_POUND,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(2656), 1,
      anon_sym_BSLASH,
    ACTIONS(2658), 1,
      anon_sym_u03bb,
    ACTIONS(2676), 1,
      anon_sym_quoteGoal,
    ACTIONS(2678), 1,
      anon_sym_tactic,
    ACTIONS(2684), 1,
      anon_sym_let,
    ACTIONS(3208), 1,
      sym_id,
    ACTIONS(3212), 1,
      anon_sym_record,
    ACTIONS(3214), 1,
      anon_sym_LPAREN,
    ACTIONS(3216), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3218), 1,
      anon_sym_u2983,
    ACTIONS(3220), 1,
      anon_sym_LBRACE,
    ACTIONS(3222), 1,
      aux_sym__qid_token1,
    ACTIONS(3224), 1,
      anon_sym_DOT,
    ACTIONS(3226), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3228), 1,
      anon_sym_u2987,
    ACTIONS(3232), 1,
      anon_sym_Set,
    STATE(2460), 1,
      sym__ARROW,
    STATE(2786), 1,
      aux_sym__lambda_clauses_repeat1,
    STATE(3200), 1,
      sym_catchall_pragma,
    STATE(3498), 1,
      aux_sym__atoms,
    STATE(5433), 1,
      sym_atom,
    STATE(8132), 1,
      sym__LAMBDA,
    STATE(8470), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(684), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(2654), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3230), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5579), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(9460), 4,
      sym__lambda_clauses,
      sym__lambda_clause_maybe_absurd,
      sym_lambda_clause_absurd,
      sym_lambda_clause,
    STATE(5582), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9459), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3210), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [206648] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(10820), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [206784] = 36,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(10818), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [206920] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(3016), 1,
      sym_id,
    ACTIONS(3020), 1,
      anon_sym_BSLASH,
    ACTIONS(3022), 1,
      anon_sym_u03bb,
    ACTIONS(3026), 1,
      anon_sym_record,
    ACTIONS(3028), 1,
      anon_sym_LPAREN,
    ACTIONS(3030), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3032), 1,
      anon_sym_u2983,
    ACTIONS(3034), 1,
      anon_sym_LBRACE,
    ACTIONS(3036), 1,
      aux_sym__qid_token1,
    ACTIONS(3038), 1,
      anon_sym_DOT,
    ACTIONS(3040), 1,
      anon_sym_quoteGoal,
    ACTIONS(3042), 1,
      anon_sym_tactic,
    ACTIONS(3044), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3046), 1,
      anon_sym_u2987,
    ACTIONS(3048), 1,
      anon_sym_let,
    ACTIONS(3052), 1,
      anon_sym_Set,
    STATE(3216), 1,
      aux_sym__atoms,
    STATE(3760), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5039), 1,
      sym_atom,
    STATE(6294), 1,
      sym_attributes,
    STATE(8127), 1,
      sym__LAMBDA,
    STATE(8388), 1,
      sym__FORALL,
    STATE(8992), 1,
      sym_expr,
    STATE(9599), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3018), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3050), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5330), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8672), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5333), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3024), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [207056] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(2212), 1,
      anon_sym_BSLASH,
    ACTIONS(2214), 1,
      anon_sym_u03bb,
    ACTIONS(2232), 1,
      anon_sym_quoteGoal,
    ACTIONS(2234), 1,
      anon_sym_tactic,
    ACTIONS(2240), 1,
      anon_sym_let,
    ACTIONS(3760), 1,
      sym_id,
    ACTIONS(3764), 1,
      anon_sym_record,
    ACTIONS(3766), 1,
      anon_sym_LPAREN,
    ACTIONS(3768), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3770), 1,
      anon_sym_u2983,
    ACTIONS(3772), 1,
      anon_sym_LBRACE,
    ACTIONS(3774), 1,
      aux_sym__qid_token1,
    ACTIONS(3776), 1,
      anon_sym_DOT,
    ACTIONS(3778), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3780), 1,
      anon_sym_u2987,
    ACTIONS(3784), 1,
      anon_sym_Set,
    STATE(3306), 1,
      aux_sym__atoms,
    STATE(3733), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4506), 1,
      sym_atom,
    STATE(6279), 1,
      sym_attributes,
    STATE(8035), 1,
      sym__LAMBDA,
    STATE(8402), 1,
      sym__FORALL,
    STATE(9003), 1,
      sym_expr,
    STATE(9372), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3782), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4599), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8680), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4613), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3762), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [207192] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(10710), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [207328] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(2904), 1,
      anon_sym_BSLASH,
    ACTIONS(2906), 1,
      anon_sym_u03bb,
    ACTIONS(2924), 1,
      anon_sym_quoteGoal,
    ACTIONS(2926), 1,
      anon_sym_tactic,
    ACTIONS(2932), 1,
      anon_sym_let,
    ACTIONS(3300), 1,
      sym_id,
    ACTIONS(3304), 1,
      anon_sym_record,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3308), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3310), 1,
      anon_sym_u2983,
    ACTIONS(3312), 1,
      anon_sym_LBRACE,
    ACTIONS(3314), 1,
      aux_sym__qid_token1,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3318), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3320), 1,
      anon_sym_u2987,
    ACTIONS(3324), 1,
      anon_sym_Set,
    STATE(3316), 1,
      aux_sym__atoms,
    STATE(3756), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4056), 1,
      sym_atom,
    STATE(6223), 1,
      sym_attributes,
    STATE(8094), 1,
      sym__LAMBDA,
    STATE(8489), 1,
      sym__FORALL,
    STATE(8949), 1,
      sym_expr,
    STATE(9010), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2900), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3322), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4053), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8655), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4049), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3302), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [207464] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(9990), 1,
      sym__with_exprs,
    STATE(10809), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [207600] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(10709), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [207736] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(3096), 1,
      anon_sym_BSLASH,
    ACTIONS(3098), 1,
      anon_sym_u03bb,
    ACTIONS(3116), 1,
      anon_sym_quoteGoal,
    ACTIONS(3118), 1,
      anon_sym_tactic,
    ACTIONS(3124), 1,
      anon_sym_let,
    ACTIONS(3354), 1,
      sym_id,
    ACTIONS(3358), 1,
      anon_sym_record,
    ACTIONS(3360), 1,
      anon_sym_LPAREN,
    ACTIONS(3362), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3364), 1,
      anon_sym_u2983,
    ACTIONS(3366), 1,
      anon_sym_LBRACE,
    ACTIONS(3368), 1,
      aux_sym__qid_token1,
    ACTIONS(3370), 1,
      anon_sym_DOT,
    ACTIONS(3372), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3374), 1,
      anon_sym_u2987,
    ACTIONS(3378), 1,
      anon_sym_Set,
    STATE(3144), 1,
      aux_sym__atoms,
    STATE(3705), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4227), 1,
      sym_atom,
    STATE(6291), 1,
      sym_attributes,
    STATE(8099), 1,
      sym__LAMBDA,
    STATE(8393), 1,
      sym__FORALL,
    STATE(8982), 1,
      sym_expr,
    STATE(9105), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3092), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3376), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4178), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8679), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4177), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3356), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [207872] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(10065), 1,
      sym__with_exprs,
    STATE(10808), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [208008] = 36,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(10700), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [208144] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(3096), 1,
      anon_sym_BSLASH,
    ACTIONS(3098), 1,
      anon_sym_u03bb,
    ACTIONS(3116), 1,
      anon_sym_quoteGoal,
    ACTIONS(3118), 1,
      anon_sym_tactic,
    ACTIONS(3124), 1,
      anon_sym_let,
    ACTIONS(3354), 1,
      sym_id,
    ACTIONS(3358), 1,
      anon_sym_record,
    ACTIONS(3360), 1,
      anon_sym_LPAREN,
    ACTIONS(3362), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3364), 1,
      anon_sym_u2983,
    ACTIONS(3366), 1,
      anon_sym_LBRACE,
    ACTIONS(3368), 1,
      aux_sym__qid_token1,
    ACTIONS(3370), 1,
      anon_sym_DOT,
    ACTIONS(3372), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3374), 1,
      anon_sym_u2987,
    ACTIONS(3378), 1,
      anon_sym_Set,
    STATE(3144), 1,
      aux_sym__atoms,
    STATE(3705), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4227), 1,
      sym_atom,
    STATE(6291), 1,
      sym_attributes,
    STATE(8099), 1,
      sym__LAMBDA,
    STATE(8393), 1,
      sym__FORALL,
    STATE(8952), 1,
      sym_expr,
    STATE(9105), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3092), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3376), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4178), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8679), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4177), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3356), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [208280] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(10698), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [208416] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(10693), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [208552] = 34,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(700), 1,
      anon_sym_LBRACE_DASH_POUND,
    ACTIONS(2350), 1,
      anon_sym_BSLASH,
    ACTIONS(2352), 1,
      anon_sym_u03bb,
    ACTIONS(2370), 1,
      anon_sym_quoteGoal,
    ACTIONS(2372), 1,
      anon_sym_tactic,
    ACTIONS(2378), 1,
      anon_sym_let,
    ACTIONS(3786), 1,
      sym_id,
    ACTIONS(3792), 1,
      anon_sym_record,
    ACTIONS(3794), 1,
      anon_sym_LPAREN,
    ACTIONS(3796), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3798), 1,
      anon_sym_u2983,
    ACTIONS(3800), 1,
      anon_sym_LBRACE,
    ACTIONS(3802), 1,
      aux_sym__qid_token1,
    ACTIONS(3804), 1,
      anon_sym_DOT,
    ACTIONS(3806), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3808), 1,
      anon_sym_u2987,
    ACTIONS(3812), 1,
      anon_sym_Set,
    STATE(1464), 1,
      sym__ARROW,
    STATE(2705), 1,
      aux_sym__lambda_clauses_repeat1,
    STATE(3247), 1,
      sym_catchall_pragma,
    STATE(3680), 1,
      aux_sym__atoms,
    STATE(4255), 1,
      sym_atom,
    STATE(8119), 1,
      sym__LAMBDA,
    STATE(8372), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2348), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3788), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(3810), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4284), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(8999), 4,
      sym__lambda_clauses,
      sym__lambda_clause_maybe_absurd,
      sym_lambda_clause_absurd,
      sym_lambda_clause,
    STATE(4282), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9000), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3790), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [208684] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(2384), 1,
      sym_id,
    ACTIONS(2388), 1,
      anon_sym_BSLASH,
    ACTIONS(2390), 1,
      anon_sym_u03bb,
    ACTIONS(2394), 1,
      anon_sym_record,
    ACTIONS(2396), 1,
      anon_sym_LPAREN,
    ACTIONS(2398), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2400), 1,
      anon_sym_u2983,
    ACTIONS(2402), 1,
      anon_sym_LBRACE,
    ACTIONS(2404), 1,
      aux_sym__qid_token1,
    ACTIONS(2406), 1,
      anon_sym_DOT,
    ACTIONS(2408), 1,
      anon_sym_quoteGoal,
    ACTIONS(2410), 1,
      anon_sym_tactic,
    ACTIONS(2412), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2414), 1,
      anon_sym_u2987,
    ACTIONS(2416), 1,
      anon_sym_let,
    ACTIONS(2420), 1,
      anon_sym_Set,
    STATE(3210), 1,
      aux_sym__atoms,
    STATE(3752), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4775), 1,
      sym_atom,
    STATE(6209), 1,
      sym_attributes,
    STATE(8139), 1,
      sym__LAMBDA,
    STATE(8518), 1,
      sym__FORALL,
    STATE(8982), 1,
      sym_expr,
    STATE(9440), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2386), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2418), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4831), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8636), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4896), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2392), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [208820] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(940), 1,
      sym_id,
    ACTIONS(950), 1,
      anon_sym_record,
    ACTIONS(952), 1,
      anon_sym_LPAREN,
    ACTIONS(954), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(956), 1,
      anon_sym_u2983,
    ACTIONS(958), 1,
      anon_sym_LBRACE,
    ACTIONS(960), 1,
      aux_sym__qid_token1,
    ACTIONS(962), 1,
      anon_sym_DOT,
    ACTIONS(968), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(970), 1,
      anon_sym_u2987,
    ACTIONS(976), 1,
      anon_sym_Set,
    ACTIONS(982), 1,
      anon_sym_BSLASH,
    ACTIONS(984), 1,
      anon_sym_u03bb,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(990), 1,
      anon_sym_tactic,
    ACTIONS(1302), 1,
      anon_sym_let,
    STATE(3221), 1,
      aux_sym__atoms,
    STATE(3708), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4712), 1,
      sym_atom,
    STATE(6263), 1,
      sym_attributes,
    STATE(8095), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(8961), 1,
      sym_expr,
    STATE(9521), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(974), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(4733), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8670), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4742), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(948), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [208956] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(12176), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [209092] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2652), 1,
      sym_id,
    ACTIONS(2662), 1,
      anon_sym_record,
    ACTIONS(2664), 1,
      anon_sym_LPAREN,
    ACTIONS(2666), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2668), 1,
      anon_sym_u2983,
    ACTIONS(2670), 1,
      anon_sym_LBRACE,
    ACTIONS(2672), 1,
      aux_sym__qid_token1,
    ACTIONS(2674), 1,
      anon_sym_DOT,
    ACTIONS(2680), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2682), 1,
      anon_sym_u2987,
    ACTIONS(2688), 1,
      anon_sym_Set,
    ACTIONS(2796), 1,
      anon_sym_BSLASH,
    ACTIONS(2798), 1,
      anon_sym_u03bb,
    ACTIONS(2800), 1,
      anon_sym_quoteGoal,
    ACTIONS(2802), 1,
      anon_sym_tactic,
    ACTIONS(2804), 1,
      anon_sym_let,
    STATE(3197), 1,
      aux_sym__atoms,
    STATE(3721), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4916), 1,
      sym_atom,
    STATE(6237), 1,
      sym_attributes,
    STATE(8041), 1,
      sym__LAMBDA,
    STATE(8490), 1,
      sym__FORALL,
    STATE(8937), 1,
      sym_expr,
    STATE(9687), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2686), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(2794), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(4732), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8657), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4735), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2660), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [209228] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(10065), 1,
      sym__with_exprs,
    STATE(11419), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [209364] = 36,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(12175), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [209500] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(9990), 1,
      sym__with_exprs,
    STATE(11420), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [209636] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2448), 1,
      anon_sym_quoteGoal,
    ACTIONS(2456), 1,
      anon_sym_let,
    ACTIONS(2840), 1,
      sym_id,
    ACTIONS(2842), 1,
      anon_sym_BSLASH,
    ACTIONS(2844), 1,
      anon_sym_u03bb,
    ACTIONS(2848), 1,
      anon_sym_record,
    ACTIONS(2850), 1,
      anon_sym_LPAREN,
    ACTIONS(2852), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2854), 1,
      anon_sym_u2983,
    ACTIONS(2856), 1,
      anon_sym_LBRACE,
    ACTIONS(2858), 1,
      aux_sym__qid_token1,
    ACTIONS(2860), 1,
      anon_sym_DOT,
    ACTIONS(2862), 1,
      anon_sym_tactic,
    ACTIONS(2864), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2866), 1,
      anon_sym_u2987,
    ACTIONS(2870), 1,
      anon_sym_Set,
    STATE(3174), 1,
      aux_sym__atoms,
    STATE(3747), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4684), 1,
      sym_atom,
    STATE(6273), 1,
      sym_attributes,
    STATE(8053), 1,
      sym__LAMBDA,
    STATE(8423), 1,
      sym__FORALL,
    STATE(8959), 1,
      sym_expr,
    STATE(9406), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2424), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2868), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4765), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8686), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4766), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2846), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [209772] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(10435), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [209908] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(10361), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [210044] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(3814), 1,
      sym_id,
    ACTIONS(3818), 1,
      anon_sym_BSLASH,
    ACTIONS(3820), 1,
      anon_sym_u03bb,
    ACTIONS(3824), 1,
      anon_sym_record,
    ACTIONS(3826), 1,
      anon_sym_LPAREN,
    ACTIONS(3828), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3830), 1,
      anon_sym_u2983,
    ACTIONS(3832), 1,
      anon_sym_LBRACE,
    ACTIONS(3834), 1,
      aux_sym__qid_token1,
    ACTIONS(3836), 1,
      anon_sym_DOT,
    ACTIONS(3838), 1,
      anon_sym_quoteGoal,
    ACTIONS(3840), 1,
      anon_sym_tactic,
    ACTIONS(3842), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3844), 1,
      anon_sym_u2987,
    ACTIONS(3846), 1,
      anon_sym_let,
    ACTIONS(3850), 1,
      anon_sym_Set,
    STATE(3246), 1,
      aux_sym__atoms,
    STATE(3716), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4371), 1,
      sym_atom,
    STATE(6222), 1,
      sym_attributes,
    STATE(8085), 1,
      sym__LAMBDA,
    STATE(8442), 1,
      sym__FORALL,
    STATE(8939), 1,
      sym_expr,
    STATE(9165), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3816), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3848), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4342), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8652), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4273), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3822), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [210180] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2652), 1,
      sym_id,
    ACTIONS(2662), 1,
      anon_sym_record,
    ACTIONS(2664), 1,
      anon_sym_LPAREN,
    ACTIONS(2666), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2668), 1,
      anon_sym_u2983,
    ACTIONS(2670), 1,
      anon_sym_LBRACE,
    ACTIONS(2672), 1,
      aux_sym__qid_token1,
    ACTIONS(2674), 1,
      anon_sym_DOT,
    ACTIONS(2680), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2682), 1,
      anon_sym_u2987,
    ACTIONS(2688), 1,
      anon_sym_Set,
    ACTIONS(2796), 1,
      anon_sym_BSLASH,
    ACTIONS(2798), 1,
      anon_sym_u03bb,
    ACTIONS(2800), 1,
      anon_sym_quoteGoal,
    ACTIONS(2802), 1,
      anon_sym_tactic,
    ACTIONS(2804), 1,
      anon_sym_let,
    STATE(3197), 1,
      aux_sym__atoms,
    STATE(3721), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4916), 1,
      sym_atom,
    STATE(6237), 1,
      sym_attributes,
    STATE(8041), 1,
      sym__LAMBDA,
    STATE(8490), 1,
      sym__FORALL,
    STATE(8945), 1,
      sym_expr,
    STATE(9687), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2686), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(2794), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(4732), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8657), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4735), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2660), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [210316] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(9990), 1,
      sym__with_exprs,
    STATE(12587), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [210452] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(10692), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [210588] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(10362), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [210724] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(10363), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [210860] = 36,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(10365), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [210996] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(10372), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [211132] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(10369), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [211268] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(3096), 1,
      anon_sym_BSLASH,
    ACTIONS(3098), 1,
      anon_sym_u03bb,
    ACTIONS(3116), 1,
      anon_sym_quoteGoal,
    ACTIONS(3118), 1,
      anon_sym_tactic,
    ACTIONS(3124), 1,
      anon_sym_let,
    ACTIONS(3354), 1,
      sym_id,
    ACTIONS(3358), 1,
      anon_sym_record,
    ACTIONS(3360), 1,
      anon_sym_LPAREN,
    ACTIONS(3362), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3364), 1,
      anon_sym_u2983,
    ACTIONS(3366), 1,
      anon_sym_LBRACE,
    ACTIONS(3368), 1,
      aux_sym__qid_token1,
    ACTIONS(3370), 1,
      anon_sym_DOT,
    ACTIONS(3372), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3374), 1,
      anon_sym_u2987,
    ACTIONS(3378), 1,
      anon_sym_Set,
    STATE(3144), 1,
      aux_sym__atoms,
    STATE(3705), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4227), 1,
      sym_atom,
    STATE(6291), 1,
      sym_attributes,
    STATE(8099), 1,
      sym__LAMBDA,
    STATE(8393), 1,
      sym__FORALL,
    STATE(8948), 1,
      sym_expr,
    STATE(9105), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3092), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3376), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4178), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8679), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4177), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3356), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [211404] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(3814), 1,
      sym_id,
    ACTIONS(3818), 1,
      anon_sym_BSLASH,
    ACTIONS(3820), 1,
      anon_sym_u03bb,
    ACTIONS(3824), 1,
      anon_sym_record,
    ACTIONS(3826), 1,
      anon_sym_LPAREN,
    ACTIONS(3828), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3830), 1,
      anon_sym_u2983,
    ACTIONS(3832), 1,
      anon_sym_LBRACE,
    ACTIONS(3834), 1,
      aux_sym__qid_token1,
    ACTIONS(3836), 1,
      anon_sym_DOT,
    ACTIONS(3838), 1,
      anon_sym_quoteGoal,
    ACTIONS(3840), 1,
      anon_sym_tactic,
    ACTIONS(3842), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3844), 1,
      anon_sym_u2987,
    ACTIONS(3846), 1,
      anon_sym_let,
    ACTIONS(3850), 1,
      anon_sym_Set,
    STATE(3246), 1,
      aux_sym__atoms,
    STATE(3716), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4371), 1,
      sym_atom,
    STATE(6222), 1,
      sym_attributes,
    STATE(8085), 1,
      sym__LAMBDA,
    STATE(8442), 1,
      sym__FORALL,
    STATE(8948), 1,
      sym_expr,
    STATE(9165), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3816), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3848), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4342), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8652), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4273), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3822), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [211540] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(10065), 1,
      sym__with_exprs,
    STATE(11451), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [211676] = 36,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(9476), 1,
      sym_expr,
    STATE(10196), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [211812] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(3096), 1,
      anon_sym_BSLASH,
    ACTIONS(3098), 1,
      anon_sym_u03bb,
    ACTIONS(3116), 1,
      anon_sym_quoteGoal,
    ACTIONS(3118), 1,
      anon_sym_tactic,
    ACTIONS(3124), 1,
      anon_sym_let,
    ACTIONS(3354), 1,
      sym_id,
    ACTIONS(3358), 1,
      anon_sym_record,
    ACTIONS(3360), 1,
      anon_sym_LPAREN,
    ACTIONS(3362), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3364), 1,
      anon_sym_u2983,
    ACTIONS(3366), 1,
      anon_sym_LBRACE,
    ACTIONS(3368), 1,
      aux_sym__qid_token1,
    ACTIONS(3370), 1,
      anon_sym_DOT,
    ACTIONS(3372), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3374), 1,
      anon_sym_u2987,
    ACTIONS(3378), 1,
      anon_sym_Set,
    STATE(3144), 1,
      aux_sym__atoms,
    STATE(3705), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4227), 1,
      sym_atom,
    STATE(6291), 1,
      sym_attributes,
    STATE(8099), 1,
      sym__LAMBDA,
    STATE(8393), 1,
      sym__FORALL,
    STATE(8939), 1,
      sym_expr,
    STATE(9105), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3092), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3376), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4178), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8679), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4177), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3356), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [211948] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(3016), 1,
      sym_id,
    ACTIONS(3020), 1,
      anon_sym_BSLASH,
    ACTIONS(3022), 1,
      anon_sym_u03bb,
    ACTIONS(3026), 1,
      anon_sym_record,
    ACTIONS(3028), 1,
      anon_sym_LPAREN,
    ACTIONS(3030), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3032), 1,
      anon_sym_u2983,
    ACTIONS(3034), 1,
      anon_sym_LBRACE,
    ACTIONS(3036), 1,
      aux_sym__qid_token1,
    ACTIONS(3038), 1,
      anon_sym_DOT,
    ACTIONS(3040), 1,
      anon_sym_quoteGoal,
    ACTIONS(3042), 1,
      anon_sym_tactic,
    ACTIONS(3044), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3046), 1,
      anon_sym_u2987,
    ACTIONS(3048), 1,
      anon_sym_let,
    ACTIONS(3052), 1,
      anon_sym_Set,
    STATE(3216), 1,
      aux_sym__atoms,
    STATE(3760), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5039), 1,
      sym_atom,
    STATE(6294), 1,
      sym_attributes,
    STATE(8127), 1,
      sym__LAMBDA,
    STATE(8388), 1,
      sym__FORALL,
    STATE(8959), 1,
      sym_expr,
    STATE(9599), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3018), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3050), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5330), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8672), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5333), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3024), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [212084] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(10370), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [212220] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(3814), 1,
      sym_id,
    ACTIONS(3818), 1,
      anon_sym_BSLASH,
    ACTIONS(3820), 1,
      anon_sym_u03bb,
    ACTIONS(3824), 1,
      anon_sym_record,
    ACTIONS(3826), 1,
      anon_sym_LPAREN,
    ACTIONS(3828), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3830), 1,
      anon_sym_u2983,
    ACTIONS(3832), 1,
      anon_sym_LBRACE,
    ACTIONS(3834), 1,
      aux_sym__qid_token1,
    ACTIONS(3836), 1,
      anon_sym_DOT,
    ACTIONS(3838), 1,
      anon_sym_quoteGoal,
    ACTIONS(3840), 1,
      anon_sym_tactic,
    ACTIONS(3842), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3844), 1,
      anon_sym_u2987,
    ACTIONS(3846), 1,
      anon_sym_let,
    ACTIONS(3850), 1,
      anon_sym_Set,
    STATE(3246), 1,
      aux_sym__atoms,
    STATE(3716), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4371), 1,
      sym_atom,
    STATE(6222), 1,
      sym_attributes,
    STATE(8085), 1,
      sym__LAMBDA,
    STATE(8442), 1,
      sym__FORALL,
    STATE(8952), 1,
      sym_expr,
    STATE(9165), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3816), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3848), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4342), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8652), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4273), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3822), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [212356] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(10065), 1,
      sym__with_exprs,
    STATE(12372), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [212492] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(9990), 1,
      sym__with_exprs,
    STATE(12456), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [212628] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(10065), 1,
      sym__with_exprs,
    STATE(12470), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [212764] = 36,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(10371), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [212900] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(2212), 1,
      anon_sym_BSLASH,
    ACTIONS(2214), 1,
      anon_sym_u03bb,
    ACTIONS(2232), 1,
      anon_sym_quoteGoal,
    ACTIONS(2234), 1,
      anon_sym_tactic,
    ACTIONS(2240), 1,
      anon_sym_let,
    ACTIONS(3760), 1,
      sym_id,
    ACTIONS(3764), 1,
      anon_sym_record,
    ACTIONS(3766), 1,
      anon_sym_LPAREN,
    ACTIONS(3768), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3770), 1,
      anon_sym_u2983,
    ACTIONS(3772), 1,
      anon_sym_LBRACE,
    ACTIONS(3774), 1,
      aux_sym__qid_token1,
    ACTIONS(3776), 1,
      anon_sym_DOT,
    ACTIONS(3778), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3780), 1,
      anon_sym_u2987,
    ACTIONS(3784), 1,
      anon_sym_Set,
    STATE(3306), 1,
      aux_sym__atoms,
    STATE(3733), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4506), 1,
      sym_atom,
    STATE(6279), 1,
      sym_attributes,
    STATE(8035), 1,
      sym__LAMBDA,
    STATE(8402), 1,
      sym__FORALL,
    STATE(8957), 1,
      sym_expr,
    STATE(9372), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3782), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4599), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8680), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4613), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3762), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [213036] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(3814), 1,
      sym_id,
    ACTIONS(3818), 1,
      anon_sym_BSLASH,
    ACTIONS(3820), 1,
      anon_sym_u03bb,
    ACTIONS(3824), 1,
      anon_sym_record,
    ACTIONS(3826), 1,
      anon_sym_LPAREN,
    ACTIONS(3828), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3830), 1,
      anon_sym_u2983,
    ACTIONS(3832), 1,
      anon_sym_LBRACE,
    ACTIONS(3834), 1,
      aux_sym__qid_token1,
    ACTIONS(3836), 1,
      anon_sym_DOT,
    ACTIONS(3838), 1,
      anon_sym_quoteGoal,
    ACTIONS(3840), 1,
      anon_sym_tactic,
    ACTIONS(3842), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3844), 1,
      anon_sym_u2987,
    ACTIONS(3846), 1,
      anon_sym_let,
    ACTIONS(3850), 1,
      anon_sym_Set,
    STATE(3246), 1,
      aux_sym__atoms,
    STATE(3716), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4371), 1,
      sym_atom,
    STATE(6222), 1,
      sym_attributes,
    STATE(8085), 1,
      sym__LAMBDA,
    STATE(8442), 1,
      sym__FORALL,
    STATE(8982), 1,
      sym_expr,
    STATE(9165), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3816), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3848), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4342), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8652), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4273), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3822), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [213172] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(2384), 1,
      sym_id,
    ACTIONS(2388), 1,
      anon_sym_BSLASH,
    ACTIONS(2390), 1,
      anon_sym_u03bb,
    ACTIONS(2394), 1,
      anon_sym_record,
    ACTIONS(2396), 1,
      anon_sym_LPAREN,
    ACTIONS(2398), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2400), 1,
      anon_sym_u2983,
    ACTIONS(2402), 1,
      anon_sym_LBRACE,
    ACTIONS(2404), 1,
      aux_sym__qid_token1,
    ACTIONS(2406), 1,
      anon_sym_DOT,
    ACTIONS(2408), 1,
      anon_sym_quoteGoal,
    ACTIONS(2410), 1,
      anon_sym_tactic,
    ACTIONS(2412), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2414), 1,
      anon_sym_u2987,
    ACTIONS(2416), 1,
      anon_sym_let,
    ACTIONS(2420), 1,
      anon_sym_Set,
    STATE(3210), 1,
      aux_sym__atoms,
    STATE(3752), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4775), 1,
      sym_atom,
    STATE(6209), 1,
      sym_attributes,
    STATE(8139), 1,
      sym__LAMBDA,
    STATE(8518), 1,
      sym__FORALL,
    STATE(8952), 1,
      sym_expr,
    STATE(9440), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2386), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2418), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4831), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8636), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4896), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2392), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [213308] = 34,
    ACTIONS(700), 1,
      anon_sym_LBRACE_DASH_POUND,
    ACTIONS(706), 1,
      aux_sym__qid_token1,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1904), 1,
      sym_id,
    ACTIONS(1910), 1,
      anon_sym_BSLASH,
    ACTIONS(1912), 1,
      anon_sym_u03bb,
    ACTIONS(1916), 1,
      anon_sym_record,
    ACTIONS(1918), 1,
      anon_sym_LPAREN,
    ACTIONS(1920), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1922), 1,
      anon_sym_u2983,
    ACTIONS(1924), 1,
      anon_sym_LBRACE,
    ACTIONS(1926), 1,
      anon_sym_DOT,
    ACTIONS(1928), 1,
      anon_sym_quoteGoal,
    ACTIONS(1930), 1,
      anon_sym_tactic,
    ACTIONS(1932), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1934), 1,
      anon_sym_u2987,
    ACTIONS(1936), 1,
      anon_sym_let,
    ACTIONS(1940), 1,
      anon_sym_Set,
    STATE(2553), 1,
      sym__ARROW,
    STATE(2676), 1,
      aux_sym__lambda_clauses_repeat1,
    STATE(3176), 1,
      sym_catchall_pragma,
    STATE(3669), 1,
      aux_sym__atoms,
    STATE(4914), 1,
      sym_atom,
    STATE(8153), 1,
      sym__LAMBDA,
    STATE(8431), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1906), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1908), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(1938), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4675), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(8987), 4,
      sym__lambda_clauses,
      sym__lambda_clause_maybe_absurd,
      sym_lambda_clause_absurd,
      sym_lambda_clause,
    STATE(4679), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8988), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1914), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [213440] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(9990), 1,
      sym__with_exprs,
    STATE(10296), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [213576] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(10065), 1,
      sym__with_exprs,
    STATE(10390), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [213712] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(2384), 1,
      sym_id,
    ACTIONS(2388), 1,
      anon_sym_BSLASH,
    ACTIONS(2390), 1,
      anon_sym_u03bb,
    ACTIONS(2394), 1,
      anon_sym_record,
    ACTIONS(2396), 1,
      anon_sym_LPAREN,
    ACTIONS(2398), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2400), 1,
      anon_sym_u2983,
    ACTIONS(2402), 1,
      anon_sym_LBRACE,
    ACTIONS(2404), 1,
      aux_sym__qid_token1,
    ACTIONS(2406), 1,
      anon_sym_DOT,
    ACTIONS(2408), 1,
      anon_sym_quoteGoal,
    ACTIONS(2410), 1,
      anon_sym_tactic,
    ACTIONS(2412), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2414), 1,
      anon_sym_u2987,
    ACTIONS(2416), 1,
      anon_sym_let,
    ACTIONS(2420), 1,
      anon_sym_Set,
    STATE(3210), 1,
      aux_sym__atoms,
    STATE(3752), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4775), 1,
      sym_atom,
    STATE(6209), 1,
      sym_attributes,
    STATE(8139), 1,
      sym__LAMBDA,
    STATE(8518), 1,
      sym__FORALL,
    STATE(8948), 1,
      sym_expr,
    STATE(9440), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2386), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2418), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4831), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8636), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4896), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2392), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [213848] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(2384), 1,
      sym_id,
    ACTIONS(2388), 1,
      anon_sym_BSLASH,
    ACTIONS(2390), 1,
      anon_sym_u03bb,
    ACTIONS(2394), 1,
      anon_sym_record,
    ACTIONS(2396), 1,
      anon_sym_LPAREN,
    ACTIONS(2398), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2400), 1,
      anon_sym_u2983,
    ACTIONS(2402), 1,
      anon_sym_LBRACE,
    ACTIONS(2404), 1,
      aux_sym__qid_token1,
    ACTIONS(2406), 1,
      anon_sym_DOT,
    ACTIONS(2408), 1,
      anon_sym_quoteGoal,
    ACTIONS(2410), 1,
      anon_sym_tactic,
    ACTIONS(2412), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2414), 1,
      anon_sym_u2987,
    ACTIONS(2416), 1,
      anon_sym_let,
    ACTIONS(2420), 1,
      anon_sym_Set,
    STATE(3210), 1,
      aux_sym__atoms,
    STATE(3752), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4775), 1,
      sym_atom,
    STATE(6209), 1,
      sym_attributes,
    STATE(8139), 1,
      sym__LAMBDA,
    STATE(8518), 1,
      sym__FORALL,
    STATE(8939), 1,
      sym_expr,
    STATE(9440), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2386), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2418), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4831), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8636), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4896), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2392), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [213984] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(2904), 1,
      anon_sym_BSLASH,
    ACTIONS(2906), 1,
      anon_sym_u03bb,
    ACTIONS(2924), 1,
      anon_sym_quoteGoal,
    ACTIONS(2926), 1,
      anon_sym_tactic,
    ACTIONS(2932), 1,
      anon_sym_let,
    ACTIONS(3300), 1,
      sym_id,
    ACTIONS(3304), 1,
      anon_sym_record,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3308), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3310), 1,
      anon_sym_u2983,
    ACTIONS(3312), 1,
      anon_sym_LBRACE,
    ACTIONS(3314), 1,
      aux_sym__qid_token1,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3318), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3320), 1,
      anon_sym_u2987,
    ACTIONS(3324), 1,
      anon_sym_Set,
    STATE(3316), 1,
      aux_sym__atoms,
    STATE(3756), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4056), 1,
      sym_atom,
    STATE(6223), 1,
      sym_attributes,
    STATE(8094), 1,
      sym__LAMBDA,
    STATE(8489), 1,
      sym__FORALL,
    STATE(8941), 1,
      sym_expr,
    STATE(9010), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2900), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3322), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4053), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8655), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4049), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3302), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [214120] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(9990), 1,
      sym__with_exprs,
    STATE(11456), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [214256] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(10065), 1,
      sym__with_exprs,
    STATE(11477), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [214392] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(9990), 1,
      sym__with_exprs,
    STATE(11481), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [214528] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(10065), 1,
      sym__with_exprs,
    STATE(11501), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [214664] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(9990), 1,
      sym__with_exprs,
    STATE(11503), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [214800] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(8961), 1,
      sym_expr,
    STATE(9861), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [214936] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(10664), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [215072] = 35,
    ACTIONS(692), 1,
      anon_sym_record,
    ACTIONS(694), 1,
      anon_sym_LPAREN,
    ACTIONS(696), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(698), 1,
      anon_sym_u2983,
    ACTIONS(700), 1,
      anon_sym_LBRACE_DASH_POUND,
    ACTIONS(702), 1,
      anon_sym_LBRACE,
    ACTIONS(708), 1,
      anon_sym_DOT,
    ACTIONS(718), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(720), 1,
      anon_sym_u2987,
    ACTIONS(728), 1,
      anon_sym_Set,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1928), 1,
      anon_sym_quoteGoal,
    ACTIONS(1936), 1,
      anon_sym_let,
    ACTIONS(2336), 1,
      sym_id,
    ACTIONS(2338), 1,
      anon_sym_BSLASH,
    ACTIONS(2340), 1,
      anon_sym_u03bb,
    ACTIONS(2342), 1,
      aux_sym__qid_token1,
    ACTIONS(2344), 1,
      anon_sym_tactic,
    STATE(2553), 1,
      sym__ARROW,
    STATE(2744), 1,
      aux_sym__lambda_clauses_repeat1,
    STATE(3309), 1,
      sym_catchall_pragma,
    STATE(3416), 1,
      aux_sym__atoms,
    STATE(5128), 1,
      sym_atom,
    STATE(8079), 1,
      sym__LAMBDA,
    STATE(8431), 1,
      sym__FORALL,
    STATE(8987), 1,
      sym__lambda_clauses,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(726), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1906), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1908), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(5069), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(8986), 3,
      sym__lambda_clause_maybe_absurd,
      sym_lambda_clause_absurd,
      sym_lambda_clause,
    STATE(5056), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8988), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(690), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [215206] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(10065), 1,
      sym__with_exprs,
    STATE(11532), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [215342] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2448), 1,
      anon_sym_quoteGoal,
    ACTIONS(2456), 1,
      anon_sym_let,
    ACTIONS(2840), 1,
      sym_id,
    ACTIONS(2842), 1,
      anon_sym_BSLASH,
    ACTIONS(2844), 1,
      anon_sym_u03bb,
    ACTIONS(2848), 1,
      anon_sym_record,
    ACTIONS(2850), 1,
      anon_sym_LPAREN,
    ACTIONS(2852), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2854), 1,
      anon_sym_u2983,
    ACTIONS(2856), 1,
      anon_sym_LBRACE,
    ACTIONS(2858), 1,
      aux_sym__qid_token1,
    ACTIONS(2860), 1,
      anon_sym_DOT,
    ACTIONS(2862), 1,
      anon_sym_tactic,
    ACTIONS(2864), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2866), 1,
      anon_sym_u2987,
    ACTIONS(2870), 1,
      anon_sym_Set,
    STATE(3174), 1,
      aux_sym__atoms,
    STATE(3747), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4684), 1,
      sym_atom,
    STATE(6273), 1,
      sym_attributes,
    STATE(8053), 1,
      sym__LAMBDA,
    STATE(8423), 1,
      sym__FORALL,
    STATE(8992), 1,
      sym_expr,
    STATE(9406), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2424), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2868), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4765), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8686), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4766), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2846), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [215478] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(734), 1,
      sym_id,
    ACTIONS(738), 1,
      anon_sym_BSLASH,
    ACTIONS(740), 1,
      anon_sym_u03bb,
    ACTIONS(744), 1,
      anon_sym_record,
    ACTIONS(746), 1,
      anon_sym_LPAREN,
    ACTIONS(748), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(750), 1,
      anon_sym_u2983,
    ACTIONS(752), 1,
      anon_sym_LBRACE,
    ACTIONS(754), 1,
      aux_sym__qid_token1,
    ACTIONS(756), 1,
      anon_sym_DOT,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(762), 1,
      anon_sym_quoteGoal,
    ACTIONS(764), 1,
      anon_sym_tactic,
    ACTIONS(766), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(768), 1,
      anon_sym_u2987,
    ACTIONS(774), 1,
      anon_sym_Set,
    ACTIONS(3054), 1,
      anon_sym_let,
    STATE(3326), 1,
      aux_sym__atoms,
    STATE(3730), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5147), 1,
      sym_atom,
    STATE(6212), 1,
      sym_attributes,
    STATE(8156), 1,
      sym__LAMBDA,
    STATE(8456), 1,
      sym__FORALL,
    STATE(9596), 1,
      sym__with_exprs,
    STATE(10159), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(736), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(772), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5108), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8641), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5102), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(742), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [215614] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(9990), 1,
      sym__with_exprs,
    STATE(11534), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [215750] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(10065), 1,
      sym__with_exprs,
    STATE(11552), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [215886] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2652), 1,
      sym_id,
    ACTIONS(2662), 1,
      anon_sym_record,
    ACTIONS(2664), 1,
      anon_sym_LPAREN,
    ACTIONS(2666), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2668), 1,
      anon_sym_u2983,
    ACTIONS(2670), 1,
      anon_sym_LBRACE,
    ACTIONS(2672), 1,
      aux_sym__qid_token1,
    ACTIONS(2674), 1,
      anon_sym_DOT,
    ACTIONS(2680), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2682), 1,
      anon_sym_u2987,
    ACTIONS(2688), 1,
      anon_sym_Set,
    ACTIONS(2796), 1,
      anon_sym_BSLASH,
    ACTIONS(2798), 1,
      anon_sym_u03bb,
    ACTIONS(2800), 1,
      anon_sym_quoteGoal,
    ACTIONS(2802), 1,
      anon_sym_tactic,
    ACTIONS(2804), 1,
      anon_sym_let,
    STATE(3197), 1,
      aux_sym__atoms,
    STATE(3721), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4916), 1,
      sym_atom,
    STATE(6237), 1,
      sym_attributes,
    STATE(8041), 1,
      sym__LAMBDA,
    STATE(8490), 1,
      sym__FORALL,
    STATE(8970), 1,
      sym_expr,
    STATE(9687), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2686), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(2794), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(4732), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8657), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4735), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2660), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [216022] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(10065), 1,
      sym__with_exprs,
    STATE(11197), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [216158] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(10065), 1,
      sym__with_exprs,
    STATE(11177), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [216294] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(8951), 1,
      sym_expr,
    STATE(9861), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [216430] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(9990), 1,
      sym__with_exprs,
    STATE(11178), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [216566] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(9990), 1,
      sym__with_exprs,
    STATE(12491), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [216702] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(10065), 1,
      sym__with_exprs,
    STATE(12506), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [216838] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(9990), 1,
      sym__with_exprs,
    STATE(12529), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [216974] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(10065), 1,
      sym__with_exprs,
    STATE(12542), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [217110] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(9990), 1,
      sym__with_exprs,
    STATE(12567), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [217246] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(10436), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [217382] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(10065), 1,
      sym__with_exprs,
    STATE(12582), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [217518] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(10437), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [217654] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(11374), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [217790] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(8974), 1,
      sym_expr,
    STATE(9861), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [217926] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(2904), 1,
      anon_sym_BSLASH,
    ACTIONS(2906), 1,
      anon_sym_u03bb,
    ACTIONS(2924), 1,
      anon_sym_quoteGoal,
    ACTIONS(2926), 1,
      anon_sym_tactic,
    ACTIONS(2932), 1,
      anon_sym_let,
    ACTIONS(3300), 1,
      sym_id,
    ACTIONS(3304), 1,
      anon_sym_record,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3308), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3310), 1,
      anon_sym_u2983,
    ACTIONS(3312), 1,
      anon_sym_LBRACE,
    ACTIONS(3314), 1,
      aux_sym__qid_token1,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3318), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3320), 1,
      anon_sym_u2987,
    ACTIONS(3324), 1,
      anon_sym_Set,
    STATE(3316), 1,
      aux_sym__atoms,
    STATE(3756), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4056), 1,
      sym_atom,
    STATE(6223), 1,
      sym_attributes,
    STATE(8094), 1,
      sym__LAMBDA,
    STATE(8489), 1,
      sym__FORALL,
    STATE(9002), 1,
      sym_expr,
    STATE(9010), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2900), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3322), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4053), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8655), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4049), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3302), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [218062] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(10065), 1,
      sym__with_exprs,
    STATE(11569), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [218198] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(9990), 1,
      sym__with_exprs,
    STATE(12608), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [218334] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(8978), 1,
      sym_expr,
    STATE(9861), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [218470] = 36,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(9465), 1,
      sym_expr,
    STATE(10196), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [218606] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(10065), 1,
      sym__with_exprs,
    STATE(12621), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [218742] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(2978), 1,
      sym_id,
    ACTIONS(2982), 1,
      anon_sym_BSLASH,
    ACTIONS(2984), 1,
      anon_sym_u03bb,
    ACTIONS(2988), 1,
      anon_sym_record,
    ACTIONS(2990), 1,
      anon_sym_LPAREN,
    ACTIONS(2992), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2994), 1,
      anon_sym_u2983,
    ACTIONS(2996), 1,
      anon_sym_LBRACE,
    ACTIONS(2998), 1,
      aux_sym__qid_token1,
    ACTIONS(3000), 1,
      anon_sym_DOT,
    ACTIONS(3002), 1,
      anon_sym_quoteGoal,
    ACTIONS(3004), 1,
      anon_sym_tactic,
    ACTIONS(3006), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3008), 1,
      anon_sym_u2987,
    ACTIONS(3010), 1,
      anon_sym_let,
    ACTIONS(3014), 1,
      anon_sym_Set,
    STATE(3136), 1,
      aux_sym__atoms,
    STATE(3737), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4529), 1,
      sym_atom,
    STATE(6210), 1,
      sym_attributes,
    STATE(8117), 1,
      sym__LAMBDA,
    STATE(8511), 1,
      sym__FORALL,
    STATE(8949), 1,
      sym_expr,
    STATE(9228), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3012), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4469), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8638), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4463), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2986), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [218878] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(9990), 1,
      sym__with_exprs,
    STATE(12647), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [219014] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(9990), 1,
      sym__with_exprs,
    STATE(11570), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [219150] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(10065), 1,
      sym__with_exprs,
    STATE(11590), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [219286] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(10065), 1,
      sym__with_exprs,
    STATE(12661), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [219422] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(9990), 1,
      sym__with_exprs,
    STATE(12683), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [219558] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(10065), 1,
      sym__with_exprs,
    STATE(12697), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [219694] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(11373), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [219830] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(9990), 1,
      sym__with_exprs,
    STATE(11591), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [219966] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(10065), 1,
      sym__with_exprs,
    STATE(11602), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [220102] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(9990), 1,
      sym__with_exprs,
    STATE(11603), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [220238] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(10065), 1,
      sym__with_exprs,
    STATE(11615), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [220374] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(9990), 1,
      sym__with_exprs,
    STATE(11553), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [220510] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(9990), 1,
      sym__with_exprs,
    STATE(12719), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [220646] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(11372), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [220782] = 36,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(11371), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [220918] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(11370), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [221054] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(11369), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [221190] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(10065), 1,
      sym__with_exprs,
    STATE(11626), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [221326] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(9990), 1,
      sym__with_exprs,
    STATE(11627), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [221462] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(11368), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [221598] = 36,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(11367), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [221734] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(10065), 1,
      sym__with_exprs,
    STATE(11639), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [221870] = 35,
    ACTIONS(700), 1,
      anon_sym_LBRACE_DASH_POUND,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1984), 1,
      anon_sym_BSLASH,
    ACTIONS(1986), 1,
      anon_sym_u03bb,
    ACTIONS(2004), 1,
      anon_sym_quoteGoal,
    ACTIONS(2006), 1,
      anon_sym_tactic,
    ACTIONS(2012), 1,
      anon_sym_let,
    ACTIONS(3380), 1,
      sym_id,
    ACTIONS(3384), 1,
      anon_sym_record,
    ACTIONS(3386), 1,
      anon_sym_LPAREN,
    ACTIONS(3388), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3390), 1,
      anon_sym_u2983,
    ACTIONS(3392), 1,
      anon_sym_LBRACE,
    ACTIONS(3394), 1,
      aux_sym__qid_token1,
    ACTIONS(3396), 1,
      anon_sym_DOT,
    ACTIONS(3398), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3400), 1,
      anon_sym_u2987,
    ACTIONS(3404), 1,
      anon_sym_Set,
    STATE(1949), 1,
      sym__ARROW,
    STATE(2775), 1,
      aux_sym__lambda_clauses_repeat1,
    STATE(3203), 1,
      sym_catchall_pragma,
    STATE(3611), 1,
      aux_sym__atoms,
    STATE(5099), 1,
      sym_atom,
    STATE(8039), 1,
      sym__LAMBDA,
    STATE(8483), 1,
      sym__FORALL,
    STATE(8987), 1,
      sym__lambda_clauses,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1982), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3402), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(3552), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(4937), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(9461), 3,
      sym__lambda_clause_maybe_absurd,
      sym_lambda_clause_absurd,
      sym_lambda_clause,
    STATE(4939), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8988), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3382), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [222004] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(10405), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [222140] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(10407), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [222276] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(10410), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [222412] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(9990), 1,
      sym__with_exprs,
    STATE(11640), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [222548] = 36,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(10411), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [222684] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(10065), 1,
      sym__with_exprs,
    STATE(11652), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [222820] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(9990), 1,
      sym__with_exprs,
    STATE(11653), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [222956] = 36,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(10624), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [223092] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(10412), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [223228] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(10413), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [223364] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(10065), 1,
      sym__with_exprs,
    STATE(11665), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [223500] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(10788), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [223636] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(10417), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [223772] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(10787), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [223908] = 34,
    ACTIONS(700), 1,
      anon_sym_LBRACE_DASH_POUND,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2022), 1,
      anon_sym_BSLASH,
    ACTIONS(2024), 1,
      anon_sym_u03bb,
    ACTIONS(2042), 1,
      anon_sym_quoteGoal,
    ACTIONS(2044), 1,
      anon_sym_tactic,
    ACTIONS(2050), 1,
      anon_sym_let,
    ACTIONS(2766), 1,
      sym_id,
    ACTIONS(2772), 1,
      anon_sym_record,
    ACTIONS(2774), 1,
      anon_sym_LPAREN,
    ACTIONS(2776), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2778), 1,
      anon_sym_u2983,
    ACTIONS(2780), 1,
      anon_sym_LBRACE,
    ACTIONS(2782), 1,
      aux_sym__qid_token1,
    ACTIONS(2784), 1,
      anon_sym_DOT,
    ACTIONS(2786), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2788), 1,
      anon_sym_u2987,
    ACTIONS(2792), 1,
      anon_sym_Set,
    STATE(1522), 1,
      sym__ARROW,
    STATE(2692), 1,
      aux_sym__lambda_clauses_repeat1,
    STATE(3130), 1,
      sym_catchall_pragma,
    STATE(3637), 1,
      aux_sym__atoms,
    STATE(5719), 1,
      sym_atom,
    STATE(8033), 1,
      sym__LAMBDA,
    STATE(8463), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2020), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2768), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(2790), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5666), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(8987), 4,
      sym__lambda_clauses,
      sym__lambda_clause_maybe_absurd,
      sym_lambda_clause_absurd,
      sym_lambda_clause,
    STATE(5668), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8988), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2770), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [224040] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(10065), 1,
      sym__with_exprs,
    STATE(12733), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [224176] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(3174), 1,
      anon_sym_BSLASH,
    ACTIONS(3176), 1,
      anon_sym_u03bb,
    ACTIONS(3194), 1,
      anon_sym_quoteGoal,
    ACTIONS(3196), 1,
      anon_sym_tactic,
    ACTIONS(3202), 1,
      anon_sym_let,
    ACTIONS(3852), 1,
      sym_id,
    ACTIONS(3856), 1,
      anon_sym_record,
    ACTIONS(3858), 1,
      anon_sym_LPAREN,
    ACTIONS(3860), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3862), 1,
      anon_sym_u2983,
    ACTIONS(3864), 1,
      anon_sym_LBRACE,
    ACTIONS(3866), 1,
      aux_sym__qid_token1,
    ACTIONS(3868), 1,
      anon_sym_DOT,
    ACTIONS(3870), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3872), 1,
      anon_sym_u2987,
    ACTIONS(3876), 1,
      anon_sym_Set,
    STATE(3279), 1,
      aux_sym__atoms,
    STATE(3724), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4769), 1,
      sym_atom,
    STATE(6278), 1,
      sym_attributes,
    STATE(8051), 1,
      sym__LAMBDA,
    STATE(8409), 1,
      sym__FORALL,
    STATE(9002), 1,
      sym_expr,
    STATE(9426), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3170), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3874), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4642), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8675), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4643), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3854), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [224312] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(3096), 1,
      anon_sym_BSLASH,
    ACTIONS(3098), 1,
      anon_sym_u03bb,
    ACTIONS(3116), 1,
      anon_sym_quoteGoal,
    ACTIONS(3118), 1,
      anon_sym_tactic,
    ACTIONS(3124), 1,
      anon_sym_let,
    ACTIONS(3354), 1,
      sym_id,
    ACTIONS(3358), 1,
      anon_sym_record,
    ACTIONS(3360), 1,
      anon_sym_LPAREN,
    ACTIONS(3362), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3364), 1,
      anon_sym_u2983,
    ACTIONS(3366), 1,
      anon_sym_LBRACE,
    ACTIONS(3368), 1,
      aux_sym__qid_token1,
    ACTIONS(3370), 1,
      anon_sym_DOT,
    ACTIONS(3372), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3374), 1,
      anon_sym_u2987,
    ACTIONS(3378), 1,
      anon_sym_Set,
    STATE(3144), 1,
      aux_sym__atoms,
    STATE(3705), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4227), 1,
      sym_atom,
    STATE(6291), 1,
      sym_attributes,
    STATE(8099), 1,
      sym__LAMBDA,
    STATE(8393), 1,
      sym__FORALL,
    STATE(8949), 1,
      sym_expr,
    STATE(9105), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3092), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3376), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4178), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8679), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4177), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3356), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [224448] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(10786), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [224584] = 36,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(10785), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [224720] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(10784), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [224856] = 36,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(11185), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [224992] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(2532), 1,
      anon_sym_BSLASH,
    ACTIONS(2534), 1,
      anon_sym_u03bb,
    ACTIONS(2552), 1,
      anon_sym_quoteGoal,
    ACTIONS(2554), 1,
      anon_sym_tactic,
    ACTIONS(2560), 1,
      anon_sym_let,
    ACTIONS(3584), 1,
      sym_id,
    ACTIONS(3588), 1,
      anon_sym_record,
    ACTIONS(3590), 1,
      anon_sym_LPAREN,
    ACTIONS(3592), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3594), 1,
      anon_sym_u2983,
    ACTIONS(3596), 1,
      anon_sym_LBRACE,
    ACTIONS(3598), 1,
      aux_sym__qid_token1,
    ACTIONS(3600), 1,
      anon_sym_DOT,
    ACTIONS(3602), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3604), 1,
      anon_sym_u2987,
    ACTIONS(3608), 1,
      anon_sym_Set,
    STATE(3300), 1,
      aux_sym__atoms,
    STATE(3720), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4261), 1,
      sym_atom,
    STATE(6280), 1,
      sym_attributes,
    STATE(8066), 1,
      sym__LAMBDA,
    STATE(8398), 1,
      sym__FORALL,
    STATE(8982), 1,
      sym_expr,
    STATE(9162), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2528), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3606), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4400), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8676), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4403), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3586), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [225128] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(10783), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [225264] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(9990), 1,
      sym__with_exprs,
    STATE(11556), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [225400] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(10065), 1,
      sym__with_exprs,
    STATE(12691), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [225536] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(2532), 1,
      anon_sym_BSLASH,
    ACTIONS(2534), 1,
      anon_sym_u03bb,
    ACTIONS(2552), 1,
      anon_sym_quoteGoal,
    ACTIONS(2554), 1,
      anon_sym_tactic,
    ACTIONS(2560), 1,
      anon_sym_let,
    ACTIONS(3584), 1,
      sym_id,
    ACTIONS(3588), 1,
      anon_sym_record,
    ACTIONS(3590), 1,
      anon_sym_LPAREN,
    ACTIONS(3592), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3594), 1,
      anon_sym_u2983,
    ACTIONS(3596), 1,
      anon_sym_LBRACE,
    ACTIONS(3598), 1,
      aux_sym__qid_token1,
    ACTIONS(3600), 1,
      anon_sym_DOT,
    ACTIONS(3602), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3604), 1,
      anon_sym_u2987,
    ACTIONS(3608), 1,
      anon_sym_Set,
    STATE(3300), 1,
      aux_sym__atoms,
    STATE(3720), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4261), 1,
      sym_atom,
    STATE(6280), 1,
      sym_attributes,
    STATE(8066), 1,
      sym__LAMBDA,
    STATE(8398), 1,
      sym__FORALL,
    STATE(8952), 1,
      sym_expr,
    STATE(9162), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2528), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3606), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4400), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8676), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4403), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3586), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [225672] = 36,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(10424), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [225808] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(9990), 1,
      sym__with_exprs,
    STATE(10438), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [225944] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(3262), 1,
      sym_id,
    ACTIONS(3266), 1,
      anon_sym_BSLASH,
    ACTIONS(3268), 1,
      anon_sym_u03bb,
    ACTIONS(3272), 1,
      anon_sym_record,
    ACTIONS(3274), 1,
      anon_sym_LPAREN,
    ACTIONS(3276), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3278), 1,
      anon_sym_u2983,
    ACTIONS(3280), 1,
      anon_sym_LBRACE,
    ACTIONS(3282), 1,
      aux_sym__qid_token1,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3286), 1,
      anon_sym_quoteGoal,
    ACTIONS(3288), 1,
      anon_sym_tactic,
    ACTIONS(3290), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3292), 1,
      anon_sym_u2987,
    ACTIONS(3294), 1,
      anon_sym_let,
    ACTIONS(3298), 1,
      anon_sym_Set,
    STATE(3148), 1,
      aux_sym__atoms,
    STATE(3739), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4014), 1,
      sym_atom,
    STATE(6261), 1,
      sym_attributes,
    STATE(8143), 1,
      sym__LAMBDA,
    STATE(8451), 1,
      sym__FORALL,
    STATE(8926), 1,
      sym__with_exprs,
    STATE(9003), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3264), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3296), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4032), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8687), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4012), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3270), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [226080] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(11186), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [226216] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(10065), 1,
      sym__with_exprs,
    STATE(10439), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [226352] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(9990), 1,
      sym__with_exprs,
    STATE(12811), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [226488] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(3174), 1,
      anon_sym_BSLASH,
    ACTIONS(3176), 1,
      anon_sym_u03bb,
    ACTIONS(3194), 1,
      anon_sym_quoteGoal,
    ACTIONS(3196), 1,
      anon_sym_tactic,
    ACTIONS(3202), 1,
      anon_sym_let,
    ACTIONS(3852), 1,
      sym_id,
    ACTIONS(3856), 1,
      anon_sym_record,
    ACTIONS(3858), 1,
      anon_sym_LPAREN,
    ACTIONS(3860), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3862), 1,
      anon_sym_u2983,
    ACTIONS(3864), 1,
      anon_sym_LBRACE,
    ACTIONS(3866), 1,
      aux_sym__qid_token1,
    ACTIONS(3868), 1,
      anon_sym_DOT,
    ACTIONS(3870), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3872), 1,
      anon_sym_u2987,
    ACTIONS(3876), 1,
      anon_sym_Set,
    STATE(3279), 1,
      aux_sym__atoms,
    STATE(3724), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4769), 1,
      sym_atom,
    STATE(6278), 1,
      sym_attributes,
    STATE(8051), 1,
      sym__LAMBDA,
    STATE(8409), 1,
      sym__FORALL,
    STATE(9003), 1,
      sym_expr,
    STATE(9426), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3170), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3874), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4642), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8675), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4643), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3854), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [226624] = 34,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(700), 1,
      anon_sym_LBRACE_DASH_POUND,
    ACTIONS(3134), 1,
      anon_sym_BSLASH,
    ACTIONS(3136), 1,
      anon_sym_u03bb,
    ACTIONS(3154), 1,
      anon_sym_quoteGoal,
    ACTIONS(3156), 1,
      anon_sym_tactic,
    ACTIONS(3162), 1,
      anon_sym_let,
    ACTIONS(3326), 1,
      sym_id,
    ACTIONS(3332), 1,
      anon_sym_record,
    ACTIONS(3334), 1,
      anon_sym_LPAREN,
    ACTIONS(3336), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3338), 1,
      anon_sym_u2983,
    ACTIONS(3340), 1,
      anon_sym_LBRACE,
    ACTIONS(3342), 1,
      aux_sym__qid_token1,
    ACTIONS(3344), 1,
      anon_sym_DOT,
    ACTIONS(3346), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3348), 1,
      anon_sym_u2987,
    ACTIONS(3352), 1,
      anon_sym_Set,
    STATE(1678), 1,
      sym__ARROW,
    STATE(2790), 1,
      aux_sym__lambda_clauses_repeat1,
    STATE(3227), 1,
      sym_catchall_pragma,
    STATE(3427), 1,
      aux_sym__atoms,
    STATE(4908), 1,
      sym_atom,
    STATE(8076), 1,
      sym__LAMBDA,
    STATE(8363), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3132), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3328), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(3350), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4650), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(8999), 4,
      sym__lambda_clauses,
      sym__lambda_clause_maybe_absurd,
      sym_lambda_clause_absurd,
      sym_lambda_clause,
    STATE(4649), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9000), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3330), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [226756] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(10782), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [226892] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(10065), 1,
      sym__with_exprs,
    STATE(10674), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [227028] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(10065), 1,
      sym__with_exprs,
    STATE(12810), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [227164] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(9990), 1,
      sym__with_exprs,
    STATE(10614), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [227300] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(10665), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [227436] = 36,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(10781), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [227572] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(10666), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [227708] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(9990), 1,
      sym__with_exprs,
    STATE(10668), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [227844] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(9990), 1,
      sym__with_exprs,
    STATE(10771), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [227980] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(10065), 1,
      sym__with_exprs,
    STATE(10697), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [228116] = 34,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(700), 1,
      anon_sym_LBRACE_DASH_POUND,
    ACTIONS(2694), 1,
      anon_sym_BSLASH,
    ACTIONS(2696), 1,
      anon_sym_u03bb,
    ACTIONS(2714), 1,
      anon_sym_quoteGoal,
    ACTIONS(2716), 1,
      anon_sym_tactic,
    ACTIONS(2722), 1,
      anon_sym_let,
    ACTIONS(3878), 1,
      sym_id,
    ACTIONS(3884), 1,
      anon_sym_record,
    ACTIONS(3886), 1,
      anon_sym_LPAREN,
    ACTIONS(3888), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3890), 1,
      anon_sym_u2983,
    ACTIONS(3892), 1,
      anon_sym_LBRACE,
    ACTIONS(3894), 1,
      aux_sym__qid_token1,
    ACTIONS(3896), 1,
      anon_sym_DOT,
    ACTIONS(3898), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3900), 1,
      anon_sym_u2987,
    ACTIONS(3904), 1,
      anon_sym_Set,
    STATE(1543), 1,
      sym__ARROW,
    STATE(2696), 1,
      aux_sym__lambda_clauses_repeat1,
    STATE(3307), 1,
      sym_catchall_pragma,
    STATE(3554), 1,
      aux_sym__atoms,
    STATE(4243), 1,
      sym_atom,
    STATE(8133), 1,
      sym__LAMBDA,
    STATE(8368), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2692), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3880), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(3902), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4214), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(8999), 4,
      sym__lambda_clauses,
      sym__lambda_clause_maybe_absurd,
      sym_lambda_clause_absurd,
      sym_lambda_clause,
    STATE(4218), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9000), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3882), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [228248] = 36,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(10646), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [228384] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(11189), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [228520] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(3814), 1,
      sym_id,
    ACTIONS(3818), 1,
      anon_sym_BSLASH,
    ACTIONS(3820), 1,
      anon_sym_u03bb,
    ACTIONS(3824), 1,
      anon_sym_record,
    ACTIONS(3826), 1,
      anon_sym_LPAREN,
    ACTIONS(3828), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3830), 1,
      anon_sym_u2983,
    ACTIONS(3832), 1,
      anon_sym_LBRACE,
    ACTIONS(3834), 1,
      aux_sym__qid_token1,
    ACTIONS(3836), 1,
      anon_sym_DOT,
    ACTIONS(3838), 1,
      anon_sym_quoteGoal,
    ACTIONS(3840), 1,
      anon_sym_tactic,
    ACTIONS(3842), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3844), 1,
      anon_sym_u2987,
    ACTIONS(3846), 1,
      anon_sym_let,
    ACTIONS(3850), 1,
      anon_sym_Set,
    STATE(3246), 1,
      aux_sym__atoms,
    STATE(3716), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4371), 1,
      sym_atom,
    STATE(6222), 1,
      sym_attributes,
    STATE(8085), 1,
      sym__LAMBDA,
    STATE(8442), 1,
      sym__FORALL,
    STATE(8949), 1,
      sym_expr,
    STATE(9165), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3816), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3848), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4342), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8652), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4273), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3822), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [228656] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(10645), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [228792] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(2532), 1,
      anon_sym_BSLASH,
    ACTIONS(2534), 1,
      anon_sym_u03bb,
    ACTIONS(2552), 1,
      anon_sym_quoteGoal,
    ACTIONS(2554), 1,
      anon_sym_tactic,
    ACTIONS(2560), 1,
      anon_sym_let,
    ACTIONS(3584), 1,
      sym_id,
    ACTIONS(3588), 1,
      anon_sym_record,
    ACTIONS(3590), 1,
      anon_sym_LPAREN,
    ACTIONS(3592), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3594), 1,
      anon_sym_u2983,
    ACTIONS(3596), 1,
      anon_sym_LBRACE,
    ACTIONS(3598), 1,
      aux_sym__qid_token1,
    ACTIONS(3600), 1,
      anon_sym_DOT,
    ACTIONS(3602), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3604), 1,
      anon_sym_u2987,
    ACTIONS(3608), 1,
      anon_sym_Set,
    STATE(3300), 1,
      aux_sym__atoms,
    STATE(3720), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4261), 1,
      sym_atom,
    STATE(6280), 1,
      sym_attributes,
    STATE(8066), 1,
      sym__LAMBDA,
    STATE(8398), 1,
      sym__FORALL,
    STATE(8948), 1,
      sym_expr,
    STATE(9162), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2528), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3606), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4400), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8676), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4403), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3586), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [228928] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(2532), 1,
      anon_sym_BSLASH,
    ACTIONS(2534), 1,
      anon_sym_u03bb,
    ACTIONS(2552), 1,
      anon_sym_quoteGoal,
    ACTIONS(2554), 1,
      anon_sym_tactic,
    ACTIONS(2560), 1,
      anon_sym_let,
    ACTIONS(3584), 1,
      sym_id,
    ACTIONS(3588), 1,
      anon_sym_record,
    ACTIONS(3590), 1,
      anon_sym_LPAREN,
    ACTIONS(3592), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3594), 1,
      anon_sym_u2983,
    ACTIONS(3596), 1,
      anon_sym_LBRACE,
    ACTIONS(3598), 1,
      aux_sym__qid_token1,
    ACTIONS(3600), 1,
      anon_sym_DOT,
    ACTIONS(3602), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3604), 1,
      anon_sym_u2987,
    ACTIONS(3608), 1,
      anon_sym_Set,
    STATE(3300), 1,
      aux_sym__atoms,
    STATE(3720), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4261), 1,
      sym_atom,
    STATE(6280), 1,
      sym_attributes,
    STATE(8066), 1,
      sym__LAMBDA,
    STATE(8398), 1,
      sym__FORALL,
    STATE(8939), 1,
      sym_expr,
    STATE(9162), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2528), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3606), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4400), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8676), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4403), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3586), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [229064] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(3096), 1,
      anon_sym_BSLASH,
    ACTIONS(3098), 1,
      anon_sym_u03bb,
    ACTIONS(3116), 1,
      anon_sym_quoteGoal,
    ACTIONS(3118), 1,
      anon_sym_tactic,
    ACTIONS(3124), 1,
      anon_sym_let,
    ACTIONS(3354), 1,
      sym_id,
    ACTIONS(3358), 1,
      anon_sym_record,
    ACTIONS(3360), 1,
      anon_sym_LPAREN,
    ACTIONS(3362), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3364), 1,
      anon_sym_u2983,
    ACTIONS(3366), 1,
      anon_sym_LBRACE,
    ACTIONS(3368), 1,
      aux_sym__qid_token1,
    ACTIONS(3370), 1,
      anon_sym_DOT,
    ACTIONS(3372), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3374), 1,
      anon_sym_u2987,
    ACTIONS(3378), 1,
      anon_sym_Set,
    STATE(3144), 1,
      aux_sym__atoms,
    STATE(3705), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4227), 1,
      sym_atom,
    STATE(6291), 1,
      sym_attributes,
    STATE(8099), 1,
      sym__LAMBDA,
    STATE(8393), 1,
      sym__FORALL,
    STATE(8941), 1,
      sym_expr,
    STATE(9105), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3092), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3376), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4178), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8679), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4177), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3356), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [229200] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(3262), 1,
      sym_id,
    ACTIONS(3266), 1,
      anon_sym_BSLASH,
    ACTIONS(3268), 1,
      anon_sym_u03bb,
    ACTIONS(3272), 1,
      anon_sym_record,
    ACTIONS(3274), 1,
      anon_sym_LPAREN,
    ACTIONS(3276), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3278), 1,
      anon_sym_u2983,
    ACTIONS(3280), 1,
      anon_sym_LBRACE,
    ACTIONS(3282), 1,
      aux_sym__qid_token1,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3286), 1,
      anon_sym_quoteGoal,
    ACTIONS(3288), 1,
      anon_sym_tactic,
    ACTIONS(3290), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3292), 1,
      anon_sym_u2987,
    ACTIONS(3294), 1,
      anon_sym_let,
    ACTIONS(3298), 1,
      anon_sym_Set,
    STATE(3148), 1,
      aux_sym__atoms,
    STATE(3739), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4014), 1,
      sym_atom,
    STATE(6261), 1,
      sym_attributes,
    STATE(8143), 1,
      sym__LAMBDA,
    STATE(8451), 1,
      sym__FORALL,
    STATE(8926), 1,
      sym__with_exprs,
    STATE(9002), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3264), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3296), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4032), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8687), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4012), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3270), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [229336] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(10065), 1,
      sym__with_exprs,
    STATE(10459), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [229472] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(9990), 1,
      sym__with_exprs,
    STATE(11662), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [229608] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(10065), 1,
      sym__with_exprs,
    STATE(11675), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [229744] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(9990), 1,
      sym__with_exprs,
    STATE(11677), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [229880] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(9990), 1,
      sym__with_exprs,
    STATE(10461), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [230016] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(9990), 1,
      sym__with_exprs,
    STATE(12801), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [230152] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(10065), 1,
      sym__with_exprs,
    STATE(12800), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [230288] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(10065), 1,
      sym__with_exprs,
    STATE(11688), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [230424] = 36,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(894), 1,
      sym_id,
    ACTIONS(898), 1,
      anon_sym_BSLASH,
    ACTIONS(900), 1,
      anon_sym_u03bb,
    ACTIONS(904), 1,
      anon_sym_record,
    ACTIONS(906), 1,
      anon_sym_LPAREN,
    ACTIONS(908), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(910), 1,
      anon_sym_u2983,
    ACTIONS(912), 1,
      anon_sym_LBRACE,
    ACTIONS(916), 1,
      aux_sym__qid_token1,
    ACTIONS(918), 1,
      anon_sym_DOT,
    ACTIONS(920), 1,
      anon_sym_quoteGoal,
    ACTIONS(922), 1,
      anon_sym_tactic,
    ACTIONS(924), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(926), 1,
      anon_sym_u2987,
    ACTIONS(928), 1,
      anon_sym_let,
    ACTIONS(932), 1,
      anon_sym_Set,
    STATE(3138), 1,
      aux_sym__atoms,
    STATE(3718), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5202), 1,
      sym_atom,
    STATE(6274), 1,
      sym_attributes,
    STATE(8031), 1,
      sym__LAMBDA,
    STATE(8396), 1,
      sym__FORALL,
    STATE(9465), 1,
      sym_expr,
    STATE(9527), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(930), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4961), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8678), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4920), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(902), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [230560] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(3406), 1,
      sym_id,
    ACTIONS(3410), 1,
      anon_sym_BSLASH,
    ACTIONS(3412), 1,
      anon_sym_u03bb,
    ACTIONS(3416), 1,
      anon_sym_record,
    ACTIONS(3418), 1,
      anon_sym_LPAREN,
    ACTIONS(3420), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3422), 1,
      anon_sym_u2983,
    ACTIONS(3424), 1,
      anon_sym_LBRACE,
    ACTIONS(3426), 1,
      aux_sym__qid_token1,
    ACTIONS(3428), 1,
      anon_sym_DOT,
    ACTIONS(3430), 1,
      anon_sym_quoteGoal,
    ACTIONS(3432), 1,
      anon_sym_tactic,
    ACTIONS(3434), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3436), 1,
      anon_sym_u2987,
    ACTIONS(3438), 1,
      anon_sym_let,
    ACTIONS(3442), 1,
      anon_sym_Set,
    STATE(3266), 1,
      aux_sym__atoms,
    STATE(3727), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4189), 1,
      sym_atom,
    STATE(6300), 1,
      sym_attributes,
    STATE(8038), 1,
      sym__LAMBDA,
    STATE(8435), 1,
      sym__FORALL,
    STATE(8939), 1,
      sym_expr,
    STATE(9058), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3408), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3440), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4158), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8644), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4162), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3414), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [230696] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(10644), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [230832] = 36,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(2652), 1,
      sym_id,
    ACTIONS(2656), 1,
      anon_sym_BSLASH,
    ACTIONS(2658), 1,
      anon_sym_u03bb,
    ACTIONS(2662), 1,
      anon_sym_record,
    ACTIONS(2664), 1,
      anon_sym_LPAREN,
    ACTIONS(2666), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2668), 1,
      anon_sym_u2983,
    ACTIONS(2670), 1,
      anon_sym_LBRACE,
    ACTIONS(2672), 1,
      aux_sym__qid_token1,
    ACTIONS(2674), 1,
      anon_sym_DOT,
    ACTIONS(2676), 1,
      anon_sym_quoteGoal,
    ACTIONS(2678), 1,
      anon_sym_tactic,
    ACTIONS(2680), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2682), 1,
      anon_sym_u2987,
    ACTIONS(2684), 1,
      anon_sym_let,
    ACTIONS(2688), 1,
      anon_sym_Set,
    STATE(3243), 1,
      aux_sym__atoms,
    STATE(3732), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4916), 1,
      sym_atom,
    STATE(6233), 1,
      sym_attributes,
    STATE(8132), 1,
      sym__LAMBDA,
    STATE(8470), 1,
      sym__FORALL,
    STATE(8937), 1,
      sym_expr,
    STATE(9530), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2654), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2686), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4732), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8656), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4735), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2660), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [230968] = 34,
    ACTIONS(700), 1,
      anon_sym_LBRACE_DASH_POUND,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(2676), 1,
      anon_sym_quoteGoal,
    ACTIONS(2684), 1,
      anon_sym_let,
    ACTIONS(2806), 1,
      sym_id,
    ACTIONS(2816), 1,
      anon_sym_record,
    ACTIONS(2818), 1,
      anon_sym_LPAREN,
    ACTIONS(2820), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2822), 1,
      anon_sym_u2983,
    ACTIONS(2824), 1,
      anon_sym_LBRACE,
    ACTIONS(2826), 1,
      aux_sym__qid_token1,
    ACTIONS(2828), 1,
      anon_sym_DOT,
    ACTIONS(2832), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2834), 1,
      anon_sym_u2987,
    ACTIONS(2838), 1,
      anon_sym_Set,
    ACTIONS(3906), 1,
      anon_sym_BSLASH,
    ACTIONS(3908), 1,
      anon_sym_u03bb,
    ACTIONS(3910), 1,
      anon_sym_tactic,
    STATE(2460), 1,
      sym__ARROW,
    STATE(2680), 1,
      aux_sym__lambda_clauses_repeat1,
    STATE(3229), 1,
      sym_catchall_pragma,
    STATE(3596), 1,
      aux_sym__atoms,
    STATE(5831), 1,
      sym_atom,
    STATE(8086), 1,
      sym__LAMBDA,
    STATE(8470), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(684), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(2654), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2836), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5982), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(9460), 4,
      sym__lambda_clauses,
      sym__lambda_clause_maybe_absurd,
      sym_lambda_clause_absurd,
      sym_lambda_clause,
    STATE(5981), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9459), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2814), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [231100] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(3406), 1,
      sym_id,
    ACTIONS(3410), 1,
      anon_sym_BSLASH,
    ACTIONS(3412), 1,
      anon_sym_u03bb,
    ACTIONS(3416), 1,
      anon_sym_record,
    ACTIONS(3418), 1,
      anon_sym_LPAREN,
    ACTIONS(3420), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3422), 1,
      anon_sym_u2983,
    ACTIONS(3424), 1,
      anon_sym_LBRACE,
    ACTIONS(3426), 1,
      aux_sym__qid_token1,
    ACTIONS(3428), 1,
      anon_sym_DOT,
    ACTIONS(3430), 1,
      anon_sym_quoteGoal,
    ACTIONS(3432), 1,
      anon_sym_tactic,
    ACTIONS(3434), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3436), 1,
      anon_sym_u2987,
    ACTIONS(3438), 1,
      anon_sym_let,
    ACTIONS(3442), 1,
      anon_sym_Set,
    STATE(3266), 1,
      aux_sym__atoms,
    STATE(3727), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4189), 1,
      sym_atom,
    STATE(6300), 1,
      sym_attributes,
    STATE(8038), 1,
      sym__LAMBDA,
    STATE(8435), 1,
      sym__FORALL,
    STATE(8948), 1,
      sym_expr,
    STATE(9058), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3408), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3440), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4158), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8644), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4162), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3414), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [231236] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(11191), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [231372] = 36,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(11192), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [231508] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(10615), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [231644] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(11193), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [231780] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(11194), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [231916] = 36,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(10640), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [232052] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(10639), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [232188] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(9990), 1,
      sym__with_exprs,
    STATE(11357), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [232324] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(10638), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [232460] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(10636), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [232596] = 36,
    ACTIONS(714), 1,
      anon_sym_quoteGoal,
    ACTIONS(722), 1,
      anon_sym_let,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(3556), 1,
      anon_sym_BSLASH,
    ACTIONS(3558), 1,
      anon_sym_u03bb,
    ACTIONS(3574), 1,
      anon_sym_tactic,
    ACTIONS(3912), 1,
      sym_id,
    ACTIONS(3916), 1,
      anon_sym_record,
    ACTIONS(3918), 1,
      anon_sym_LPAREN,
    ACTIONS(3920), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3922), 1,
      anon_sym_u2983,
    ACTIONS(3924), 1,
      anon_sym_LBRACE,
    ACTIONS(3926), 1,
      aux_sym__qid_token1,
    ACTIONS(3928), 1,
      anon_sym_DOT,
    ACTIONS(3930), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3932), 1,
      anon_sym_u2987,
    ACTIONS(3936), 1,
      anon_sym_Set,
    STATE(3162), 1,
      aux_sym__atoms,
    STATE(3706), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4664), 1,
      sym_atom,
    STATE(6275), 1,
      sym_attributes,
    STATE(8092), 1,
      sym__LAMBDA,
    STATE(8495), 1,
      sym__FORALL,
    STATE(9418), 1,
      sym__with_exprs,
    STATE(9475), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(682), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3934), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4662), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8684), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4728), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3914), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [232732] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(3406), 1,
      sym_id,
    ACTIONS(3410), 1,
      anon_sym_BSLASH,
    ACTIONS(3412), 1,
      anon_sym_u03bb,
    ACTIONS(3416), 1,
      anon_sym_record,
    ACTIONS(3418), 1,
      anon_sym_LPAREN,
    ACTIONS(3420), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3422), 1,
      anon_sym_u2983,
    ACTIONS(3424), 1,
      anon_sym_LBRACE,
    ACTIONS(3426), 1,
      aux_sym__qid_token1,
    ACTIONS(3428), 1,
      anon_sym_DOT,
    ACTIONS(3430), 1,
      anon_sym_quoteGoal,
    ACTIONS(3432), 1,
      anon_sym_tactic,
    ACTIONS(3434), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3436), 1,
      anon_sym_u2987,
    ACTIONS(3438), 1,
      anon_sym_let,
    ACTIONS(3442), 1,
      anon_sym_Set,
    STATE(3266), 1,
      aux_sym__atoms,
    STATE(3727), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4189), 1,
      sym_atom,
    STATE(6300), 1,
      sym_attributes,
    STATE(8038), 1,
      sym__LAMBDA,
    STATE(8435), 1,
      sym__FORALL,
    STATE(8952), 1,
      sym_expr,
    STATE(9058), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3408), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3440), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4158), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8644), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4162), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3414), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [232868] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(3174), 1,
      anon_sym_BSLASH,
    ACTIONS(3176), 1,
      anon_sym_u03bb,
    ACTIONS(3194), 1,
      anon_sym_quoteGoal,
    ACTIONS(3196), 1,
      anon_sym_tactic,
    ACTIONS(3202), 1,
      anon_sym_let,
    ACTIONS(3852), 1,
      sym_id,
    ACTIONS(3856), 1,
      anon_sym_record,
    ACTIONS(3858), 1,
      anon_sym_LPAREN,
    ACTIONS(3860), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3862), 1,
      anon_sym_u2983,
    ACTIONS(3864), 1,
      anon_sym_LBRACE,
    ACTIONS(3866), 1,
      aux_sym__qid_token1,
    ACTIONS(3868), 1,
      anon_sym_DOT,
    ACTIONS(3870), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3872), 1,
      anon_sym_u2987,
    ACTIONS(3876), 1,
      anon_sym_Set,
    STATE(3279), 1,
      aux_sym__atoms,
    STATE(3724), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4769), 1,
      sym_atom,
    STATE(6278), 1,
      sym_attributes,
    STATE(8051), 1,
      sym__LAMBDA,
    STATE(8409), 1,
      sym__FORALL,
    STATE(8957), 1,
      sym_expr,
    STATE(9426), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3170), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3874), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4642), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8675), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4643), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3854), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [233004] = 36,
    ACTIONS(714), 1,
      anon_sym_quoteGoal,
    ACTIONS(722), 1,
      anon_sym_let,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(3556), 1,
      anon_sym_BSLASH,
    ACTIONS(3558), 1,
      anon_sym_u03bb,
    ACTIONS(3574), 1,
      anon_sym_tactic,
    ACTIONS(3912), 1,
      sym_id,
    ACTIONS(3916), 1,
      anon_sym_record,
    ACTIONS(3918), 1,
      anon_sym_LPAREN,
    ACTIONS(3920), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3922), 1,
      anon_sym_u2983,
    ACTIONS(3924), 1,
      anon_sym_LBRACE,
    ACTIONS(3926), 1,
      aux_sym__qid_token1,
    ACTIONS(3928), 1,
      anon_sym_DOT,
    ACTIONS(3930), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3932), 1,
      anon_sym_u2987,
    ACTIONS(3936), 1,
      anon_sym_Set,
    STATE(3162), 1,
      aux_sym__atoms,
    STATE(3706), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4664), 1,
      sym_atom,
    STATE(6275), 1,
      sym_attributes,
    STATE(8092), 1,
      sym__LAMBDA,
    STATE(8495), 1,
      sym__FORALL,
    STATE(9415), 1,
      sym_expr,
    STATE(9418), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(682), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3934), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4662), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8684), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4728), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3914), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [233140] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(10065), 1,
      sym__with_exprs,
    STATE(11356), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [233276] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(10451), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [233412] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(10452), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [233548] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(10456), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [233684] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(9990), 1,
      sym__with_exprs,
    STATE(12789), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [233820] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(10065), 1,
      sym__with_exprs,
    STATE(12788), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [233956] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(9990), 1,
      sym__with_exprs,
    STATE(11689), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [234092] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(9990), 1,
      sym__with_exprs,
    STATE(12781), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [234228] = 36,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(10468), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [234364] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(10469), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [234500] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(10065), 1,
      sym__with_exprs,
    STATE(11700), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [234636] = 36,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(10458), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [234772] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(10065), 1,
      sym__with_exprs,
    STATE(12780), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [234908] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(10460), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [235044] = 36,
    ACTIONS(714), 1,
      anon_sym_quoteGoal,
    ACTIONS(722), 1,
      anon_sym_let,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(3556), 1,
      anon_sym_BSLASH,
    ACTIONS(3558), 1,
      anon_sym_u03bb,
    ACTIONS(3574), 1,
      anon_sym_tactic,
    ACTIONS(3912), 1,
      sym_id,
    ACTIONS(3916), 1,
      anon_sym_record,
    ACTIONS(3918), 1,
      anon_sym_LPAREN,
    ACTIONS(3920), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3922), 1,
      anon_sym_u2983,
    ACTIONS(3924), 1,
      anon_sym_LBRACE,
    ACTIONS(3926), 1,
      aux_sym__qid_token1,
    ACTIONS(3928), 1,
      anon_sym_DOT,
    ACTIONS(3930), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3932), 1,
      anon_sym_u2987,
    ACTIONS(3936), 1,
      anon_sym_Set,
    STATE(3162), 1,
      aux_sym__atoms,
    STATE(3706), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4664), 1,
      sym_atom,
    STATE(6275), 1,
      sym_attributes,
    STATE(8092), 1,
      sym__LAMBDA,
    STATE(8495), 1,
      sym__FORALL,
    STATE(9405), 1,
      sym_expr,
    STATE(9418), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(682), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3934), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4662), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8684), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4728), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3914), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [235180] = 36,
    ACTIONS(714), 1,
      anon_sym_quoteGoal,
    ACTIONS(722), 1,
      anon_sym_let,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(3556), 1,
      anon_sym_BSLASH,
    ACTIONS(3558), 1,
      anon_sym_u03bb,
    ACTIONS(3574), 1,
      anon_sym_tactic,
    ACTIONS(3912), 1,
      sym_id,
    ACTIONS(3916), 1,
      anon_sym_record,
    ACTIONS(3918), 1,
      anon_sym_LPAREN,
    ACTIONS(3920), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3922), 1,
      anon_sym_u2983,
    ACTIONS(3924), 1,
      anon_sym_LBRACE,
    ACTIONS(3926), 1,
      aux_sym__qid_token1,
    ACTIONS(3928), 1,
      anon_sym_DOT,
    ACTIONS(3930), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3932), 1,
      anon_sym_u2987,
    ACTIONS(3936), 1,
      anon_sym_Set,
    STATE(3162), 1,
      aux_sym__atoms,
    STATE(3706), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4664), 1,
      sym_atom,
    STATE(6275), 1,
      sym_attributes,
    STATE(8092), 1,
      sym__LAMBDA,
    STATE(8495), 1,
      sym__FORALL,
    STATE(9418), 1,
      sym__with_exprs,
    STATE(9466), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(682), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3934), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4662), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8684), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4728), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3914), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [235316] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(3814), 1,
      sym_id,
    ACTIONS(3818), 1,
      anon_sym_BSLASH,
    ACTIONS(3820), 1,
      anon_sym_u03bb,
    ACTIONS(3824), 1,
      anon_sym_record,
    ACTIONS(3826), 1,
      anon_sym_LPAREN,
    ACTIONS(3828), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3830), 1,
      anon_sym_u2983,
    ACTIONS(3832), 1,
      anon_sym_LBRACE,
    ACTIONS(3834), 1,
      aux_sym__qid_token1,
    ACTIONS(3836), 1,
      anon_sym_DOT,
    ACTIONS(3838), 1,
      anon_sym_quoteGoal,
    ACTIONS(3840), 1,
      anon_sym_tactic,
    ACTIONS(3842), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3844), 1,
      anon_sym_u2987,
    ACTIONS(3846), 1,
      anon_sym_let,
    ACTIONS(3850), 1,
      anon_sym_Set,
    STATE(3246), 1,
      aux_sym__atoms,
    STATE(3716), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4371), 1,
      sym_atom,
    STATE(6222), 1,
      sym_attributes,
    STATE(8085), 1,
      sym__LAMBDA,
    STATE(8442), 1,
      sym__FORALL,
    STATE(8941), 1,
      sym_expr,
    STATE(9165), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3816), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3848), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4342), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8652), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4273), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3822), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [235452] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(9990), 1,
      sym__with_exprs,
    STATE(11701), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [235588] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(10065), 1,
      sym__with_exprs,
    STATE(11715), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [235724] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(2566), 1,
      sym_id,
    ACTIONS(2570), 1,
      anon_sym_BSLASH,
    ACTIONS(2572), 1,
      anon_sym_u03bb,
    ACTIONS(2576), 1,
      anon_sym_record,
    ACTIONS(2578), 1,
      anon_sym_LPAREN,
    ACTIONS(2580), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2582), 1,
      anon_sym_u2983,
    ACTIONS(2584), 1,
      anon_sym_LBRACE,
    ACTIONS(2586), 1,
      aux_sym__qid_token1,
    ACTIONS(2588), 1,
      anon_sym_DOT,
    ACTIONS(2590), 1,
      anon_sym_quoteGoal,
    ACTIONS(2592), 1,
      anon_sym_tactic,
    ACTIONS(2594), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2596), 1,
      anon_sym_u2987,
    ACTIONS(2598), 1,
      anon_sym_let,
    ACTIONS(2602), 1,
      anon_sym_Set,
    STATE(3214), 1,
      aux_sym__atoms,
    STATE(3714), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5536), 1,
      sym_atom,
    STATE(6208), 1,
      sym_attributes,
    STATE(8111), 1,
      sym__LAMBDA,
    STATE(8412), 1,
      sym__FORALL,
    STATE(8948), 1,
      sym_expr,
    STATE(10191), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2568), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2600), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5566), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8634), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5590), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2574), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [235860] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(10470), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [235996] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(10466), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [236132] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(9990), 1,
      sym__with_exprs,
    STATE(12773), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [236268] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(10065), 1,
      sym__with_exprs,
    STATE(12771), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [236404] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(10065), 1,
      sym__with_exprs,
    STATE(10619), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [236540] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(9990), 1,
      sym__with_exprs,
    STATE(10518), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [236676] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(9990), 1,
      sym__with_exprs,
    STATE(11716), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [236812] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(10065), 1,
      sym__with_exprs,
    STATE(11729), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [236948] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(10467), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [237084] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(9990), 1,
      sym__with_exprs,
    STATE(12758), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [237220] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(10065), 1,
      sym__with_exprs,
    STATE(12757), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [237356] = 35,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(700), 1,
      anon_sym_LBRACE_DASH_POUND,
    ACTIONS(3168), 1,
      sym_id,
    ACTIONS(3174), 1,
      anon_sym_BSLASH,
    ACTIONS(3176), 1,
      anon_sym_u03bb,
    ACTIONS(3180), 1,
      anon_sym_record,
    ACTIONS(3182), 1,
      anon_sym_LPAREN,
    ACTIONS(3184), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3186), 1,
      anon_sym_u2983,
    ACTIONS(3188), 1,
      anon_sym_LBRACE,
    ACTIONS(3190), 1,
      aux_sym__qid_token1,
    ACTIONS(3192), 1,
      anon_sym_DOT,
    ACTIONS(3194), 1,
      anon_sym_quoteGoal,
    ACTIONS(3196), 1,
      anon_sym_tactic,
    ACTIONS(3198), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3200), 1,
      anon_sym_u2987,
    ACTIONS(3202), 1,
      anon_sym_let,
    ACTIONS(3206), 1,
      anon_sym_Set,
    STATE(2310), 1,
      sym__ARROW,
    STATE(2717), 1,
      aux_sym__lambda_clauses_repeat1,
    STATE(3226), 1,
      sym_catchall_pragma,
    STATE(3553), 1,
      aux_sym__atoms,
    STATE(5142), 1,
      sym_atom,
    STATE(8051), 1,
      sym__LAMBDA,
    STATE(8409), 1,
      sym__FORALL,
    STATE(8999), 1,
      sym__lambda_clauses,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3170), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3172), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(3204), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4934), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(8993), 3,
      sym__lambda_clause_maybe_absurd,
      sym_lambda_clause_absurd,
      sym_lambda_clause,
    STATE(4921), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9000), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3178), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [237490] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(3406), 1,
      sym_id,
    ACTIONS(3410), 1,
      anon_sym_BSLASH,
    ACTIONS(3412), 1,
      anon_sym_u03bb,
    ACTIONS(3416), 1,
      anon_sym_record,
    ACTIONS(3418), 1,
      anon_sym_LPAREN,
    ACTIONS(3420), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3422), 1,
      anon_sym_u2983,
    ACTIONS(3424), 1,
      anon_sym_LBRACE,
    ACTIONS(3426), 1,
      aux_sym__qid_token1,
    ACTIONS(3428), 1,
      anon_sym_DOT,
    ACTIONS(3430), 1,
      anon_sym_quoteGoal,
    ACTIONS(3432), 1,
      anon_sym_tactic,
    ACTIONS(3434), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3436), 1,
      anon_sym_u2987,
    ACTIONS(3438), 1,
      anon_sym_let,
    ACTIONS(3442), 1,
      anon_sym_Set,
    STATE(3266), 1,
      aux_sym__atoms,
    STATE(3727), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4189), 1,
      sym_atom,
    STATE(6300), 1,
      sym_attributes,
    STATE(8038), 1,
      sym__LAMBDA,
    STATE(8435), 1,
      sym__FORALL,
    STATE(8982), 1,
      sym_expr,
    STATE(9058), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3408), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3440), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4158), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8644), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4162), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3414), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [237626] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(9990), 1,
      sym__with_exprs,
    STATE(12742), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [237762] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(10065), 1,
      sym__with_exprs,
    STATE(12740), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [237898] = 36,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(2652), 1,
      sym_id,
    ACTIONS(2656), 1,
      anon_sym_BSLASH,
    ACTIONS(2658), 1,
      anon_sym_u03bb,
    ACTIONS(2662), 1,
      anon_sym_record,
    ACTIONS(2664), 1,
      anon_sym_LPAREN,
    ACTIONS(2666), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2668), 1,
      anon_sym_u2983,
    ACTIONS(2670), 1,
      anon_sym_LBRACE,
    ACTIONS(2672), 1,
      aux_sym__qid_token1,
    ACTIONS(2674), 1,
      anon_sym_DOT,
    ACTIONS(2676), 1,
      anon_sym_quoteGoal,
    ACTIONS(2678), 1,
      anon_sym_tactic,
    ACTIONS(2680), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2682), 1,
      anon_sym_u2987,
    ACTIONS(2684), 1,
      anon_sym_let,
    ACTIONS(2688), 1,
      anon_sym_Set,
    STATE(3243), 1,
      aux_sym__atoms,
    STATE(3732), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4916), 1,
      sym_atom,
    STATE(6233), 1,
      sym_attributes,
    STATE(8132), 1,
      sym__LAMBDA,
    STATE(8470), 1,
      sym__FORALL,
    STATE(8945), 1,
      sym_expr,
    STATE(9530), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2654), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2686), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4732), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8656), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4735), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2660), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [238034] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(10065), 1,
      sym__with_exprs,
    STATE(12593), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [238170] = 36,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(10604), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [238306] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(10603), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [238442] = 36,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(10476), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [238578] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(11195), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [238714] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(9990), 1,
      sym__with_exprs,
    STATE(10480), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [238850] = 36,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(894), 1,
      sym_id,
    ACTIONS(898), 1,
      anon_sym_BSLASH,
    ACTIONS(900), 1,
      anon_sym_u03bb,
    ACTIONS(904), 1,
      anon_sym_record,
    ACTIONS(906), 1,
      anon_sym_LPAREN,
    ACTIONS(908), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(910), 1,
      anon_sym_u2983,
    ACTIONS(912), 1,
      anon_sym_LBRACE,
    ACTIONS(916), 1,
      aux_sym__qid_token1,
    ACTIONS(918), 1,
      anon_sym_DOT,
    ACTIONS(920), 1,
      anon_sym_quoteGoal,
    ACTIONS(922), 1,
      anon_sym_tactic,
    ACTIONS(924), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(926), 1,
      anon_sym_u2987,
    ACTIONS(928), 1,
      anon_sym_let,
    ACTIONS(932), 1,
      anon_sym_Set,
    STATE(3138), 1,
      aux_sym__atoms,
    STATE(3718), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5202), 1,
      sym_atom,
    STATE(6274), 1,
      sym_attributes,
    STATE(8031), 1,
      sym__LAMBDA,
    STATE(8396), 1,
      sym__FORALL,
    STATE(9476), 1,
      sym_expr,
    STATE(9527), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(930), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4961), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8678), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4920), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(902), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [238986] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(9990), 1,
      sym__with_exprs,
    STATE(11730), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [239122] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(10602), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [239258] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(3482), 1,
      sym_id,
    ACTIONS(3486), 1,
      anon_sym_BSLASH,
    ACTIONS(3488), 1,
      anon_sym_u03bb,
    ACTIONS(3492), 1,
      anon_sym_record,
    ACTIONS(3494), 1,
      anon_sym_LPAREN,
    ACTIONS(3496), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3498), 1,
      anon_sym_u2983,
    ACTIONS(3500), 1,
      anon_sym_LBRACE,
    ACTIONS(3502), 1,
      aux_sym__qid_token1,
    ACTIONS(3504), 1,
      anon_sym_DOT,
    ACTIONS(3506), 1,
      anon_sym_quoteGoal,
    ACTIONS(3508), 1,
      anon_sym_tactic,
    ACTIONS(3510), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3512), 1,
      anon_sym_u2987,
    ACTIONS(3514), 1,
      anon_sym_let,
    ACTIONS(3518), 1,
      anon_sym_Set,
    STATE(3202), 1,
      aux_sym__atoms,
    STATE(3736), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4260), 1,
      sym_atom,
    STATE(6289), 1,
      sym_attributes,
    STATE(8140), 1,
      sym__LAMBDA,
    STATE(8504), 1,
      sym__FORALL,
    STATE(8949), 1,
      sym_expr,
    STATE(9167), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3484), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3516), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4382), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8682), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4385), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3490), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [239394] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(10065), 1,
      sym__with_exprs,
    STATE(11742), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [239530] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(10599), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [239666] = 36,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(10597), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [239802] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(9990), 1,
      sym__with_exprs,
    STATE(11743), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [239938] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(10691), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [240074] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(10595), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [240210] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(10592), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [240346] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(10065), 1,
      sym__with_exprs,
    STATE(11752), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [240482] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(9990), 1,
      sym__with_exprs,
    STATE(11753), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [240618] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(2212), 1,
      anon_sym_BSLASH,
    ACTIONS(2214), 1,
      anon_sym_u03bb,
    ACTIONS(2232), 1,
      anon_sym_quoteGoal,
    ACTIONS(2234), 1,
      anon_sym_tactic,
    ACTIONS(2240), 1,
      anon_sym_let,
    ACTIONS(3760), 1,
      sym_id,
    ACTIONS(3764), 1,
      anon_sym_record,
    ACTIONS(3766), 1,
      anon_sym_LPAREN,
    ACTIONS(3768), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3770), 1,
      anon_sym_u2983,
    ACTIONS(3772), 1,
      anon_sym_LBRACE,
    ACTIONS(3774), 1,
      aux_sym__qid_token1,
    ACTIONS(3776), 1,
      anon_sym_DOT,
    ACTIONS(3778), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3780), 1,
      anon_sym_u2987,
    ACTIONS(3784), 1,
      anon_sym_Set,
    STATE(3306), 1,
      aux_sym__atoms,
    STATE(3733), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4506), 1,
      sym_atom,
    STATE(6279), 1,
      sym_attributes,
    STATE(8035), 1,
      sym__LAMBDA,
    STATE(8402), 1,
      sym__FORALL,
    STATE(8982), 1,
      sym_expr,
    STATE(9372), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3782), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4599), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8680), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4613), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3762), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [240754] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(10065), 1,
      sym__with_exprs,
    STATE(11763), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [240890] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(10065), 1,
      sym__with_exprs,
    STATE(10481), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [241026] = 36,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(10667), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [241162] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(2212), 1,
      anon_sym_BSLASH,
    ACTIONS(2214), 1,
      anon_sym_u03bb,
    ACTIONS(2232), 1,
      anon_sym_quoteGoal,
    ACTIONS(2234), 1,
      anon_sym_tactic,
    ACTIONS(2240), 1,
      anon_sym_let,
    ACTIONS(3760), 1,
      sym_id,
    ACTIONS(3764), 1,
      anon_sym_record,
    ACTIONS(3766), 1,
      anon_sym_LPAREN,
    ACTIONS(3768), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3770), 1,
      anon_sym_u2983,
    ACTIONS(3772), 1,
      anon_sym_LBRACE,
    ACTIONS(3774), 1,
      aux_sym__qid_token1,
    ACTIONS(3776), 1,
      anon_sym_DOT,
    ACTIONS(3778), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3780), 1,
      anon_sym_u2987,
    ACTIONS(3784), 1,
      anon_sym_Set,
    STATE(3306), 1,
      aux_sym__atoms,
    STATE(3733), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4506), 1,
      sym_atom,
    STATE(6279), 1,
      sym_attributes,
    STATE(8035), 1,
      sym__LAMBDA,
    STATE(8402), 1,
      sym__FORALL,
    STATE(8952), 1,
      sym_expr,
    STATE(9372), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3782), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4599), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8680), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4613), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3762), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [241298] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(9990), 1,
      sym__with_exprs,
    STATE(11764), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [241434] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(9990), 1,
      sym__with_exprs,
    STATE(11616), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [241570] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(9990), 1,
      sym__with_exprs,
    STATE(11777), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [241706] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(11337), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [241842] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(2212), 1,
      anon_sym_BSLASH,
    ACTIONS(2214), 1,
      anon_sym_u03bb,
    ACTIONS(2232), 1,
      anon_sym_quoteGoal,
    ACTIONS(2234), 1,
      anon_sym_tactic,
    ACTIONS(2240), 1,
      anon_sym_let,
    ACTIONS(3760), 1,
      sym_id,
    ACTIONS(3764), 1,
      anon_sym_record,
    ACTIONS(3766), 1,
      anon_sym_LPAREN,
    ACTIONS(3768), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3770), 1,
      anon_sym_u2983,
    ACTIONS(3772), 1,
      anon_sym_LBRACE,
    ACTIONS(3774), 1,
      aux_sym__qid_token1,
    ACTIONS(3776), 1,
      anon_sym_DOT,
    ACTIONS(3778), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3780), 1,
      anon_sym_u2987,
    ACTIONS(3784), 1,
      anon_sym_Set,
    STATE(3306), 1,
      aux_sym__atoms,
    STATE(3733), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4506), 1,
      sym_atom,
    STATE(6279), 1,
      sym_attributes,
    STATE(8035), 1,
      sym__LAMBDA,
    STATE(8402), 1,
      sym__FORALL,
    STATE(8948), 1,
      sym_expr,
    STATE(9372), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3782), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4599), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8680), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4613), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3762), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [241978] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(10065), 1,
      sym__with_exprs,
    STATE(11789), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [242114] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(2212), 1,
      anon_sym_BSLASH,
    ACTIONS(2214), 1,
      anon_sym_u03bb,
    ACTIONS(2232), 1,
      anon_sym_quoteGoal,
    ACTIONS(2234), 1,
      anon_sym_tactic,
    ACTIONS(2240), 1,
      anon_sym_let,
    ACTIONS(3760), 1,
      sym_id,
    ACTIONS(3764), 1,
      anon_sym_record,
    ACTIONS(3766), 1,
      anon_sym_LPAREN,
    ACTIONS(3768), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3770), 1,
      anon_sym_u2983,
    ACTIONS(3772), 1,
      anon_sym_LBRACE,
    ACTIONS(3774), 1,
      aux_sym__qid_token1,
    ACTIONS(3776), 1,
      anon_sym_DOT,
    ACTIONS(3778), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3780), 1,
      anon_sym_u2987,
    ACTIONS(3784), 1,
      anon_sym_Set,
    STATE(3306), 1,
      aux_sym__atoms,
    STATE(3733), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4506), 1,
      sym_atom,
    STATE(6279), 1,
      sym_attributes,
    STATE(8035), 1,
      sym__LAMBDA,
    STATE(8402), 1,
      sym__FORALL,
    STATE(8939), 1,
      sym_expr,
    STATE(9372), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3782), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4599), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8680), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4613), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3762), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [242250] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(10670), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [242386] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(3482), 1,
      sym_id,
    ACTIONS(3486), 1,
      anon_sym_BSLASH,
    ACTIONS(3488), 1,
      anon_sym_u03bb,
    ACTIONS(3492), 1,
      anon_sym_record,
    ACTIONS(3494), 1,
      anon_sym_LPAREN,
    ACTIONS(3496), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3498), 1,
      anon_sym_u2983,
    ACTIONS(3500), 1,
      anon_sym_LBRACE,
    ACTIONS(3502), 1,
      aux_sym__qid_token1,
    ACTIONS(3504), 1,
      anon_sym_DOT,
    ACTIONS(3506), 1,
      anon_sym_quoteGoal,
    ACTIONS(3508), 1,
      anon_sym_tactic,
    ACTIONS(3510), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3512), 1,
      anon_sym_u2987,
    ACTIONS(3514), 1,
      anon_sym_let,
    ACTIONS(3518), 1,
      anon_sym_Set,
    STATE(3202), 1,
      aux_sym__atoms,
    STATE(3736), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4260), 1,
      sym_atom,
    STATE(6289), 1,
      sym_attributes,
    STATE(8140), 1,
      sym__LAMBDA,
    STATE(8504), 1,
      sym__FORALL,
    STATE(8941), 1,
      sym_expr,
    STATE(9167), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3484), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3516), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4382), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8682), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4385), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3490), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [242522] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(9990), 1,
      sym__with_exprs,
    STATE(11790), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [242658] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(10065), 1,
      sym__with_exprs,
    STATE(11803), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [242794] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(9990), 1,
      sym__with_exprs,
    STATE(12725), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [242930] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(10065), 1,
      sym__with_exprs,
    STATE(12724), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [243066] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(9990), 1,
      sym__with_exprs,
    STATE(12705), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [243202] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(11336), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [243338] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(9990), 1,
      sym__with_exprs,
    STATE(11804), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [243474] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(11335), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [243610] = 36,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(11334), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [243746] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(10065), 1,
      sym__with_exprs,
    STATE(11815), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [243882] = 35,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(700), 1,
      anon_sym_LBRACE_DASH_POUND,
    ACTIONS(2694), 1,
      anon_sym_BSLASH,
    ACTIONS(2696), 1,
      anon_sym_u03bb,
    ACTIONS(2714), 1,
      anon_sym_quoteGoal,
    ACTIONS(2716), 1,
      anon_sym_tactic,
    ACTIONS(2722), 1,
      anon_sym_let,
    ACTIONS(3878), 1,
      sym_id,
    ACTIONS(3884), 1,
      anon_sym_record,
    ACTIONS(3886), 1,
      anon_sym_LPAREN,
    ACTIONS(3888), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3890), 1,
      anon_sym_u2983,
    ACTIONS(3892), 1,
      anon_sym_LBRACE,
    ACTIONS(3894), 1,
      aux_sym__qid_token1,
    ACTIONS(3896), 1,
      anon_sym_DOT,
    ACTIONS(3898), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3900), 1,
      anon_sym_u2987,
    ACTIONS(3904), 1,
      anon_sym_Set,
    STATE(1543), 1,
      sym__ARROW,
    STATE(2714), 1,
      aux_sym__lambda_clauses_repeat1,
    STATE(3307), 1,
      sym_catchall_pragma,
    STATE(3554), 1,
      aux_sym__atoms,
    STATE(4243), 1,
      sym_atom,
    STATE(8133), 1,
      sym__LAMBDA,
    STATE(8368), 1,
      sym__FORALL,
    STATE(8999), 1,
      sym__lambda_clauses,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2692), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3880), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(3902), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4214), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(8993), 3,
      sym__lambda_clause_maybe_absurd,
      sym_lambda_clause_absurd,
      sym_lambda_clause,
    STATE(4218), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9000), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3882), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [244016] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(2566), 1,
      sym_id,
    ACTIONS(2570), 1,
      anon_sym_BSLASH,
    ACTIONS(2572), 1,
      anon_sym_u03bb,
    ACTIONS(2576), 1,
      anon_sym_record,
    ACTIONS(2578), 1,
      anon_sym_LPAREN,
    ACTIONS(2580), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2582), 1,
      anon_sym_u2983,
    ACTIONS(2584), 1,
      anon_sym_LBRACE,
    ACTIONS(2586), 1,
      aux_sym__qid_token1,
    ACTIONS(2588), 1,
      anon_sym_DOT,
    ACTIONS(2590), 1,
      anon_sym_quoteGoal,
    ACTIONS(2592), 1,
      anon_sym_tactic,
    ACTIONS(2594), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2596), 1,
      anon_sym_u2987,
    ACTIONS(2598), 1,
      anon_sym_let,
    ACTIONS(2602), 1,
      anon_sym_Set,
    STATE(3214), 1,
      aux_sym__atoms,
    STATE(3714), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5536), 1,
      sym_atom,
    STATE(6208), 1,
      sym_attributes,
    STATE(8111), 1,
      sym__LAMBDA,
    STATE(8412), 1,
      sym__FORALL,
    STATE(8939), 1,
      sym_expr,
    STATE(10191), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2568), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2600), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5566), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8634), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5590), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2574), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [244152] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(3444), 1,
      sym_id,
    ACTIONS(3448), 1,
      anon_sym_BSLASH,
    ACTIONS(3450), 1,
      anon_sym_u03bb,
    ACTIONS(3454), 1,
      anon_sym_record,
    ACTIONS(3456), 1,
      anon_sym_LPAREN,
    ACTIONS(3458), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3460), 1,
      anon_sym_u2983,
    ACTIONS(3462), 1,
      anon_sym_LBRACE,
    ACTIONS(3464), 1,
      aux_sym__qid_token1,
    ACTIONS(3466), 1,
      anon_sym_DOT,
    ACTIONS(3468), 1,
      anon_sym_quoteGoal,
    ACTIONS(3470), 1,
      anon_sym_tactic,
    ACTIONS(3472), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3474), 1,
      anon_sym_u2987,
    ACTIONS(3476), 1,
      anon_sym_let,
    ACTIONS(3480), 1,
      anon_sym_Set,
    STATE(3313), 1,
      aux_sym__atoms,
    STATE(3742), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5018), 1,
      sym_atom,
    STATE(6219), 1,
      sym_attributes,
    STATE(8072), 1,
      sym__LAMBDA,
    STATE(8455), 1,
      sym__FORALL,
    STATE(9626), 1,
      sym__with_exprs,
    STATE(10141), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3446), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3478), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5013), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8649), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5000), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3452), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [244288] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(11333), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [244424] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(11332), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [244560] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(11331), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [244696] = 36,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(11330), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [244832] = 36,
    ACTIONS(13), 1,
      anon_sym_BSLASH,
    ACTIONS(15), 1,
      anon_sym_u03bb,
    ACTIONS(75), 1,
      anon_sym_quoteGoal,
    ACTIONS(77), 1,
      anon_sym_tactic,
    ACTIONS(83), 1,
      anon_sym_let,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(2246), 1,
      sym_id,
    ACTIONS(2250), 1,
      anon_sym_record,
    ACTIONS(2252), 1,
      anon_sym_LPAREN,
    ACTIONS(2254), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2256), 1,
      anon_sym_u2983,
    ACTIONS(2258), 1,
      anon_sym_LBRACE,
    ACTIONS(2260), 1,
      aux_sym__qid_token1,
    ACTIONS(2262), 1,
      anon_sym_DOT,
    ACTIONS(2264), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2266), 1,
      anon_sym_u2987,
    ACTIONS(2270), 1,
      anon_sym_Set,
    STATE(3285), 1,
      aux_sym__atoms,
    STATE(3710), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4216), 1,
      sym_atom,
    STATE(6218), 1,
      sym_attributes,
    STATE(8114), 1,
      sym__LAMBDA,
    STATE(8288), 1,
      sym__FORALL,
    STATE(8941), 1,
      sym_expr,
    STATE(9125), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(11), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2268), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4151), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8647), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4153), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2248), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [244968] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(9990), 1,
      sym__with_exprs,
    STATE(11816), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [245104] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(10065), 1,
      sym__with_exprs,
    STATE(11827), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [245240] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(9990), 1,
      sym__with_exprs,
    STATE(11828), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [245376] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(10471), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [245512] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(10065), 1,
      sym__with_exprs,
    STATE(12704), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [245648] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(9990), 1,
      sym__with_exprs,
    STATE(12689), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [245784] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(10065), 1,
      sym__with_exprs,
    STATE(12687), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [245920] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(8992), 1,
      sym_expr,
    STATE(9861), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [246056] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(9990), 1,
      sym__with_exprs,
    STATE(12669), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [246192] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(10065), 1,
      sym__with_exprs,
    STATE(11840), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [246328] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(10065), 1,
      sym__with_exprs,
    STATE(12668), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [246464] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(9990), 1,
      sym__with_exprs,
    STATE(12653), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [246600] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(9990), 1,
      sym__with_exprs,
    STATE(11842), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [246736] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(10065), 1,
      sym__with_exprs,
    STATE(12651), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [246872] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(9990), 1,
      sym__with_exprs,
    STATE(12633), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [247008] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(10749), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [247144] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(10065), 1,
      sym__with_exprs,
    STATE(11859), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [247280] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(10065), 1,
      sym__with_exprs,
    STATE(12631), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [247416] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(10748), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [247552] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(10747), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [247688] = 36,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(10743), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [247824] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(10742), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [247960] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(2964), 1,
      anon_sym_quoteGoal,
    ACTIONS(2972), 1,
      anon_sym_let,
    ACTIONS(3522), 1,
      anon_sym_BSLASH,
    ACTIONS(3524), 1,
      anon_sym_u03bb,
    ACTIONS(3542), 1,
      anon_sym_tactic,
    ACTIONS(3938), 1,
      sym_id,
    ACTIONS(3942), 1,
      anon_sym_record,
    ACTIONS(3944), 1,
      anon_sym_LPAREN,
    ACTIONS(3946), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3948), 1,
      anon_sym_u2983,
    ACTIONS(3950), 1,
      anon_sym_LBRACE,
    ACTIONS(3952), 1,
      aux_sym__qid_token1,
    ACTIONS(3954), 1,
      anon_sym_DOT,
    ACTIONS(3956), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3958), 1,
      anon_sym_u2987,
    ACTIONS(3962), 1,
      anon_sym_Set,
    STATE(3218), 1,
      aux_sym__atoms,
    STATE(3712), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5290), 1,
      sym_atom,
    STATE(6276), 1,
      sym_attributes,
    STATE(8058), 1,
      sym__LAMBDA,
    STATE(8418), 1,
      sym__FORALL,
    STATE(9002), 1,
      sym_expr,
    STATE(9540), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2940), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3960), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5203), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8685), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5201), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3940), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [248096] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(10741), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [248232] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(10740), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [248368] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(2614), 1,
      sym_id,
    ACTIONS(2618), 1,
      anon_sym_BSLASH,
    ACTIONS(2620), 1,
      anon_sym_u03bb,
    ACTIONS(2624), 1,
      anon_sym_record,
    ACTIONS(2626), 1,
      anon_sym_LPAREN,
    ACTIONS(2628), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2630), 1,
      anon_sym_u2983,
    ACTIONS(2632), 1,
      anon_sym_LBRACE,
    ACTIONS(2634), 1,
      aux_sym__qid_token1,
    ACTIONS(2636), 1,
      anon_sym_DOT,
    ACTIONS(2638), 1,
      anon_sym_quoteGoal,
    ACTIONS(2640), 1,
      anon_sym_tactic,
    ACTIONS(2642), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2644), 1,
      anon_sym_u2987,
    ACTIONS(2646), 1,
      anon_sym_let,
    ACTIONS(2650), 1,
      anon_sym_Set,
    STATE(3343), 1,
      aux_sym__atoms,
    STATE(3758), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4849), 1,
      sym_atom,
    STATE(6258), 1,
      sym_attributes,
    STATE(8093), 1,
      sym__LAMBDA,
    STATE(8414), 1,
      sym__FORALL,
    STATE(9429), 1,
      sym_expr,
    STATE(9445), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2616), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2648), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4799), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8666), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4784), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2622), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [248504] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(9990), 1,
      sym__with_exprs,
    STATE(11860), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [248640] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2652), 1,
      sym_id,
    ACTIONS(2662), 1,
      anon_sym_record,
    ACTIONS(2664), 1,
      anon_sym_LPAREN,
    ACTIONS(2666), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2668), 1,
      anon_sym_u2983,
    ACTIONS(2670), 1,
      anon_sym_LBRACE,
    ACTIONS(2672), 1,
      aux_sym__qid_token1,
    ACTIONS(2674), 1,
      anon_sym_DOT,
    ACTIONS(2680), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2682), 1,
      anon_sym_u2987,
    ACTIONS(2688), 1,
      anon_sym_Set,
    ACTIONS(2796), 1,
      anon_sym_BSLASH,
    ACTIONS(2798), 1,
      anon_sym_u03bb,
    ACTIONS(2800), 1,
      anon_sym_quoteGoal,
    ACTIONS(2802), 1,
      anon_sym_tactic,
    ACTIONS(2804), 1,
      anon_sym_let,
    STATE(3197), 1,
      aux_sym__atoms,
    STATE(3721), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4916), 1,
      sym_atom,
    STATE(6237), 1,
      sym_attributes,
    STATE(8041), 1,
      sym__LAMBDA,
    STATE(8490), 1,
      sym__FORALL,
    STATE(9687), 1,
      sym__with_exprs,
    STATE(10127), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2686), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(2794), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(4732), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8657), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4735), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2660), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [248776] = 36,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(10739), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [248912] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(10494), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [249048] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(9990), 1,
      sym__with_exprs,
    STATE(10732), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [249184] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(2614), 1,
      sym_id,
    ACTIONS(2618), 1,
      anon_sym_BSLASH,
    ACTIONS(2620), 1,
      anon_sym_u03bb,
    ACTIONS(2624), 1,
      anon_sym_record,
    ACTIONS(2626), 1,
      anon_sym_LPAREN,
    ACTIONS(2628), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2630), 1,
      anon_sym_u2983,
    ACTIONS(2632), 1,
      anon_sym_LBRACE,
    ACTIONS(2634), 1,
      aux_sym__qid_token1,
    ACTIONS(2636), 1,
      anon_sym_DOT,
    ACTIONS(2638), 1,
      anon_sym_quoteGoal,
    ACTIONS(2640), 1,
      anon_sym_tactic,
    ACTIONS(2642), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2644), 1,
      anon_sym_u2987,
    ACTIONS(2646), 1,
      anon_sym_let,
    ACTIONS(2650), 1,
      anon_sym_Set,
    STATE(3343), 1,
      aux_sym__atoms,
    STATE(3758), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4849), 1,
      sym_atom,
    STATE(6258), 1,
      sym_attributes,
    STATE(8093), 1,
      sym__LAMBDA,
    STATE(8414), 1,
      sym__FORALL,
    STATE(9445), 1,
      sym__with_exprs,
    STATE(9641), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2616), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2648), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4799), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8666), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4784), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2622), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [249320] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(10498), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [249456] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(10065), 1,
      sym__with_exprs,
    STATE(11214), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [249592] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(10499), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [249728] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(2964), 1,
      anon_sym_quoteGoal,
    ACTIONS(2972), 1,
      anon_sym_let,
    ACTIONS(3522), 1,
      anon_sym_BSLASH,
    ACTIONS(3524), 1,
      anon_sym_u03bb,
    ACTIONS(3542), 1,
      anon_sym_tactic,
    ACTIONS(3938), 1,
      sym_id,
    ACTIONS(3942), 1,
      anon_sym_record,
    ACTIONS(3944), 1,
      anon_sym_LPAREN,
    ACTIONS(3946), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3948), 1,
      anon_sym_u2983,
    ACTIONS(3950), 1,
      anon_sym_LBRACE,
    ACTIONS(3952), 1,
      aux_sym__qid_token1,
    ACTIONS(3954), 1,
      anon_sym_DOT,
    ACTIONS(3956), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3958), 1,
      anon_sym_u2987,
    ACTIONS(3962), 1,
      anon_sym_Set,
    STATE(3218), 1,
      aux_sym__atoms,
    STATE(3712), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5290), 1,
      sym_atom,
    STATE(6276), 1,
      sym_attributes,
    STATE(8058), 1,
      sym__LAMBDA,
    STATE(8418), 1,
      sym__FORALL,
    STATE(9003), 1,
      sym_expr,
    STATE(9540), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2940), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3960), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5203), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8685), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5201), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3940), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [249864] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(10065), 1,
      sym__with_exprs,
    STATE(10731), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [250000] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(9990), 1,
      sym__with_exprs,
    STATE(11215), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [250136] = 34,
    ACTIONS(700), 1,
      anon_sym_LBRACE_DASH_POUND,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2134), 1,
      sym_id,
    ACTIONS(2140), 1,
      anon_sym_BSLASH,
    ACTIONS(2142), 1,
      anon_sym_u03bb,
    ACTIONS(2146), 1,
      anon_sym_record,
    ACTIONS(2148), 1,
      anon_sym_LPAREN,
    ACTIONS(2150), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2152), 1,
      anon_sym_u2983,
    ACTIONS(2154), 1,
      anon_sym_LBRACE,
    ACTIONS(2156), 1,
      aux_sym__qid_token1,
    ACTIONS(2158), 1,
      anon_sym_DOT,
    ACTIONS(2160), 1,
      anon_sym_quoteGoal,
    ACTIONS(2162), 1,
      anon_sym_tactic,
    ACTIONS(2164), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2166), 1,
      anon_sym_u2987,
    ACTIONS(2168), 1,
      anon_sym_let,
    ACTIONS(2172), 1,
      anon_sym_Set,
    STATE(1614), 1,
      sym__ARROW,
    STATE(2695), 1,
      aux_sym__lambda_clauses_repeat1,
    STATE(3213), 1,
      sym_catchall_pragma,
    STATE(3482), 1,
      aux_sym__atoms,
    STATE(5718), 1,
      sym_atom,
    STATE(8040), 1,
      sym__LAMBDA,
    STATE(8460), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2136), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2138), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(2170), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5624), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(8987), 4,
      sym__lambda_clauses,
      sym__lambda_clause_maybe_absurd,
      sym_lambda_clause_absurd,
      sym_lambda_clause,
    STATE(5627), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8988), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2144), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [250268] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(3694), 1,
      sym_id,
    ACTIONS(3698), 1,
      anon_sym_BSLASH,
    ACTIONS(3700), 1,
      anon_sym_u03bb,
    ACTIONS(3704), 1,
      anon_sym_record,
    ACTIONS(3706), 1,
      anon_sym_LPAREN,
    ACTIONS(3708), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3710), 1,
      anon_sym_u2983,
    ACTIONS(3712), 1,
      anon_sym_LBRACE,
    ACTIONS(3714), 1,
      aux_sym__qid_token1,
    ACTIONS(3716), 1,
      anon_sym_DOT,
    ACTIONS(3718), 1,
      anon_sym_quoteGoal,
    ACTIONS(3720), 1,
      anon_sym_tactic,
    ACTIONS(3722), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3724), 1,
      anon_sym_u2987,
    ACTIONS(3726), 1,
      anon_sym_let,
    ACTIONS(3730), 1,
      anon_sym_Set,
    STATE(3295), 1,
      aux_sym__atoms,
    STATE(3761), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4435), 1,
      sym_atom,
    STATE(6181), 1,
      sym_attributes,
    STATE(8124), 1,
      sym__LAMBDA,
    STATE(8446), 1,
      sym__FORALL,
    STATE(8949), 1,
      sym_expr,
    STATE(9267), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3696), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3728), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4467), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8651), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4459), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3702), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [250404] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(9990), 1,
      sym__with_exprs,
    STATE(12614), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [250540] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(8961), 1,
      sym_expr,
    STATE(10084), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [250676] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(10065), 1,
      sym__with_exprs,
    STATE(11883), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [250812] = 36,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(10502), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [250948] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(9990), 1,
      sym__with_exprs,
    STATE(11884), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [251084] = 36,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(10507), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [251220] = 36,
    ACTIONS(714), 1,
      anon_sym_quoteGoal,
    ACTIONS(722), 1,
      anon_sym_let,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(3556), 1,
      anon_sym_BSLASH,
    ACTIONS(3558), 1,
      anon_sym_u03bb,
    ACTIONS(3574), 1,
      anon_sym_tactic,
    ACTIONS(3912), 1,
      sym_id,
    ACTIONS(3916), 1,
      anon_sym_record,
    ACTIONS(3918), 1,
      anon_sym_LPAREN,
    ACTIONS(3920), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3922), 1,
      anon_sym_u2983,
    ACTIONS(3924), 1,
      anon_sym_LBRACE,
    ACTIONS(3926), 1,
      aux_sym__qid_token1,
    ACTIONS(3928), 1,
      anon_sym_DOT,
    ACTIONS(3930), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3932), 1,
      anon_sym_u2987,
    ACTIONS(3936), 1,
      anon_sym_Set,
    STATE(3162), 1,
      aux_sym__atoms,
    STATE(3706), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4664), 1,
      sym_atom,
    STATE(6275), 1,
      sym_attributes,
    STATE(8092), 1,
      sym__LAMBDA,
    STATE(8495), 1,
      sym__FORALL,
    STATE(9418), 1,
      sym__with_exprs,
    STATE(9465), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(682), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3934), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4662), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8684), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4728), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3914), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [251356] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1910), 1,
      anon_sym_BSLASH,
    ACTIONS(1912), 1,
      anon_sym_u03bb,
    ACTIONS(1928), 1,
      anon_sym_quoteGoal,
    ACTIONS(1930), 1,
      anon_sym_tactic,
    ACTIONS(1936), 1,
      anon_sym_let,
    ACTIONS(2174), 1,
      sym_id,
    ACTIONS(2182), 1,
      anon_sym_record,
    ACTIONS(2184), 1,
      anon_sym_LPAREN,
    ACTIONS(2186), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2188), 1,
      anon_sym_u2983,
    ACTIONS(2190), 1,
      anon_sym_LBRACE,
    ACTIONS(2192), 1,
      aux_sym__qid_token1,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2198), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2200), 1,
      anon_sym_u2987,
    ACTIONS(2204), 1,
      anon_sym_Set,
    STATE(3339), 1,
      aux_sym__atoms,
    STATE(3717), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4611), 1,
      sym_atom,
    STATE(6264), 1,
      sym_attributes,
    STATE(8153), 1,
      sym__LAMBDA,
    STATE(8431), 1,
      sym__FORALL,
    STATE(8978), 1,
      sym_expr,
    STATE(9486), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1906), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4536), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8673), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4531), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2180), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [251492] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(2532), 1,
      anon_sym_BSLASH,
    ACTIONS(2534), 1,
      anon_sym_u03bb,
    ACTIONS(2552), 1,
      anon_sym_quoteGoal,
    ACTIONS(2554), 1,
      anon_sym_tactic,
    ACTIONS(2560), 1,
      anon_sym_let,
    ACTIONS(3584), 1,
      sym_id,
    ACTIONS(3588), 1,
      anon_sym_record,
    ACTIONS(3590), 1,
      anon_sym_LPAREN,
    ACTIONS(3592), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3594), 1,
      anon_sym_u2983,
    ACTIONS(3596), 1,
      anon_sym_LBRACE,
    ACTIONS(3598), 1,
      aux_sym__qid_token1,
    ACTIONS(3600), 1,
      anon_sym_DOT,
    ACTIONS(3602), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3604), 1,
      anon_sym_u2987,
    ACTIONS(3608), 1,
      anon_sym_Set,
    STATE(3300), 1,
      aux_sym__atoms,
    STATE(3720), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4261), 1,
      sym_atom,
    STATE(6280), 1,
      sym_attributes,
    STATE(8066), 1,
      sym__LAMBDA,
    STATE(8398), 1,
      sym__FORALL,
    STATE(8949), 1,
      sym_expr,
    STATE(9162), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2528), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3606), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4400), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8676), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4403), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3586), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [251628] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1910), 1,
      anon_sym_BSLASH,
    ACTIONS(1912), 1,
      anon_sym_u03bb,
    ACTIONS(1928), 1,
      anon_sym_quoteGoal,
    ACTIONS(1930), 1,
      anon_sym_tactic,
    ACTIONS(1936), 1,
      anon_sym_let,
    ACTIONS(2174), 1,
      sym_id,
    ACTIONS(2182), 1,
      anon_sym_record,
    ACTIONS(2184), 1,
      anon_sym_LPAREN,
    ACTIONS(2186), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2188), 1,
      anon_sym_u2983,
    ACTIONS(2190), 1,
      anon_sym_LBRACE,
    ACTIONS(2192), 1,
      aux_sym__qid_token1,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2198), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2200), 1,
      anon_sym_u2987,
    ACTIONS(2204), 1,
      anon_sym_Set,
    STATE(3339), 1,
      aux_sym__atoms,
    STATE(3717), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4611), 1,
      sym_atom,
    STATE(6264), 1,
      sym_attributes,
    STATE(8153), 1,
      sym__LAMBDA,
    STATE(8431), 1,
      sym__FORALL,
    STATE(8974), 1,
      sym_expr,
    STATE(9486), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1906), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4536), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8673), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4531), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2180), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [251764] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(9990), 1,
      sym__with_exprs,
    STATE(10496), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [251900] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(10065), 1,
      sym__with_exprs,
    STATE(10495), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [252036] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(2904), 1,
      anon_sym_BSLASH,
    ACTIONS(2906), 1,
      anon_sym_u03bb,
    ACTIONS(2924), 1,
      anon_sym_quoteGoal,
    ACTIONS(2926), 1,
      anon_sym_tactic,
    ACTIONS(2932), 1,
      anon_sym_let,
    ACTIONS(3300), 1,
      sym_id,
    ACTIONS(3304), 1,
      anon_sym_record,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3308), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3310), 1,
      anon_sym_u2983,
    ACTIONS(3312), 1,
      anon_sym_LBRACE,
    ACTIONS(3314), 1,
      aux_sym__qid_token1,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3318), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3320), 1,
      anon_sym_u2987,
    ACTIONS(3324), 1,
      anon_sym_Set,
    STATE(3316), 1,
      aux_sym__atoms,
    STATE(3756), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4056), 1,
      sym_atom,
    STATE(6223), 1,
      sym_attributes,
    STATE(8094), 1,
      sym__LAMBDA,
    STATE(8489), 1,
      sym__FORALL,
    STATE(8982), 1,
      sym_expr,
    STATE(9010), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2900), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3322), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4053), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8655), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4049), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3302), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [252172] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(3174), 1,
      anon_sym_BSLASH,
    ACTIONS(3176), 1,
      anon_sym_u03bb,
    ACTIONS(3194), 1,
      anon_sym_quoteGoal,
    ACTIONS(3196), 1,
      anon_sym_tactic,
    ACTIONS(3202), 1,
      anon_sym_let,
    ACTIONS(3852), 1,
      sym_id,
    ACTIONS(3856), 1,
      anon_sym_record,
    ACTIONS(3858), 1,
      anon_sym_LPAREN,
    ACTIONS(3860), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3862), 1,
      anon_sym_u2983,
    ACTIONS(3864), 1,
      anon_sym_LBRACE,
    ACTIONS(3866), 1,
      aux_sym__qid_token1,
    ACTIONS(3868), 1,
      anon_sym_DOT,
    ACTIONS(3870), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3872), 1,
      anon_sym_u2987,
    ACTIONS(3876), 1,
      anon_sym_Set,
    STATE(3279), 1,
      aux_sym__atoms,
    STATE(3724), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4769), 1,
      sym_atom,
    STATE(6278), 1,
      sym_attributes,
    STATE(8051), 1,
      sym__LAMBDA,
    STATE(8409), 1,
      sym__FORALL,
    STATE(8982), 1,
      sym_expr,
    STATE(9426), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3170), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3874), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4642), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8675), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4643), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3854), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [252308] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(2964), 1,
      anon_sym_quoteGoal,
    ACTIONS(2972), 1,
      anon_sym_let,
    ACTIONS(3522), 1,
      anon_sym_BSLASH,
    ACTIONS(3524), 1,
      anon_sym_u03bb,
    ACTIONS(3542), 1,
      anon_sym_tactic,
    ACTIONS(3938), 1,
      sym_id,
    ACTIONS(3942), 1,
      anon_sym_record,
    ACTIONS(3944), 1,
      anon_sym_LPAREN,
    ACTIONS(3946), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3948), 1,
      anon_sym_u2983,
    ACTIONS(3950), 1,
      anon_sym_LBRACE,
    ACTIONS(3952), 1,
      aux_sym__qid_token1,
    ACTIONS(3954), 1,
      anon_sym_DOT,
    ACTIONS(3956), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3958), 1,
      anon_sym_u2987,
    ACTIONS(3962), 1,
      anon_sym_Set,
    STATE(3218), 1,
      aux_sym__atoms,
    STATE(3712), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5290), 1,
      sym_atom,
    STATE(6276), 1,
      sym_attributes,
    STATE(8058), 1,
      sym__LAMBDA,
    STATE(8418), 1,
      sym__FORALL,
    STATE(8957), 1,
      sym_expr,
    STATE(9540), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2940), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3960), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5203), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8685), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5201), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3940), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [252444] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(3174), 1,
      anon_sym_BSLASH,
    ACTIONS(3176), 1,
      anon_sym_u03bb,
    ACTIONS(3194), 1,
      anon_sym_quoteGoal,
    ACTIONS(3196), 1,
      anon_sym_tactic,
    ACTIONS(3202), 1,
      anon_sym_let,
    ACTIONS(3852), 1,
      sym_id,
    ACTIONS(3856), 1,
      anon_sym_record,
    ACTIONS(3858), 1,
      anon_sym_LPAREN,
    ACTIONS(3860), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3862), 1,
      anon_sym_u2983,
    ACTIONS(3864), 1,
      anon_sym_LBRACE,
    ACTIONS(3866), 1,
      aux_sym__qid_token1,
    ACTIONS(3868), 1,
      anon_sym_DOT,
    ACTIONS(3870), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3872), 1,
      anon_sym_u2987,
    ACTIONS(3876), 1,
      anon_sym_Set,
    STATE(3279), 1,
      aux_sym__atoms,
    STATE(3724), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4769), 1,
      sym_atom,
    STATE(6278), 1,
      sym_attributes,
    STATE(8051), 1,
      sym__LAMBDA,
    STATE(8409), 1,
      sym__FORALL,
    STATE(8952), 1,
      sym_expr,
    STATE(9426), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3170), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3874), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4642), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8675), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4643), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3854), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [252580] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(2904), 1,
      anon_sym_BSLASH,
    ACTIONS(2906), 1,
      anon_sym_u03bb,
    ACTIONS(2924), 1,
      anon_sym_quoteGoal,
    ACTIONS(2926), 1,
      anon_sym_tactic,
    ACTIONS(2932), 1,
      anon_sym_let,
    ACTIONS(3300), 1,
      sym_id,
    ACTIONS(3304), 1,
      anon_sym_record,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3308), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3310), 1,
      anon_sym_u2983,
    ACTIONS(3312), 1,
      anon_sym_LBRACE,
    ACTIONS(3314), 1,
      aux_sym__qid_token1,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3318), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3320), 1,
      anon_sym_u2987,
    ACTIONS(3324), 1,
      anon_sym_Set,
    STATE(3316), 1,
      aux_sym__atoms,
    STATE(3756), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4056), 1,
      sym_atom,
    STATE(6223), 1,
      sym_attributes,
    STATE(8094), 1,
      sym__LAMBDA,
    STATE(8489), 1,
      sym__FORALL,
    STATE(8952), 1,
      sym_expr,
    STATE(9010), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2900), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3322), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4053), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8655), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4049), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3302), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [252716] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(9990), 1,
      sym__with_exprs,
    STATE(11323), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [252852] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(10065), 1,
      sym__with_exprs,
    STATE(11321), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [252988] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1910), 1,
      anon_sym_BSLASH,
    ACTIONS(1912), 1,
      anon_sym_u03bb,
    ACTIONS(1928), 1,
      anon_sym_quoteGoal,
    ACTIONS(1930), 1,
      anon_sym_tactic,
    ACTIONS(1936), 1,
      anon_sym_let,
    ACTIONS(2174), 1,
      sym_id,
    ACTIONS(2182), 1,
      anon_sym_record,
    ACTIONS(2184), 1,
      anon_sym_LPAREN,
    ACTIONS(2186), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2188), 1,
      anon_sym_u2983,
    ACTIONS(2190), 1,
      anon_sym_LBRACE,
    ACTIONS(2192), 1,
      aux_sym__qid_token1,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2198), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2200), 1,
      anon_sym_u2987,
    ACTIONS(2204), 1,
      anon_sym_Set,
    STATE(3339), 1,
      aux_sym__atoms,
    STATE(3717), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4611), 1,
      sym_atom,
    STATE(6264), 1,
      sym_attributes,
    STATE(8153), 1,
      sym__LAMBDA,
    STATE(8431), 1,
      sym__FORALL,
    STATE(8951), 1,
      sym_expr,
    STATE(9486), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1906), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4536), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8673), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4531), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2180), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [253124] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(10065), 1,
      sym__with_exprs,
    STATE(12613), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [253260] = 36,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(2652), 1,
      sym_id,
    ACTIONS(2656), 1,
      anon_sym_BSLASH,
    ACTIONS(2658), 1,
      anon_sym_u03bb,
    ACTIONS(2662), 1,
      anon_sym_record,
    ACTIONS(2664), 1,
      anon_sym_LPAREN,
    ACTIONS(2666), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2668), 1,
      anon_sym_u2983,
    ACTIONS(2670), 1,
      anon_sym_LBRACE,
    ACTIONS(2672), 1,
      aux_sym__qid_token1,
    ACTIONS(2674), 1,
      anon_sym_DOT,
    ACTIONS(2676), 1,
      anon_sym_quoteGoal,
    ACTIONS(2678), 1,
      anon_sym_tactic,
    ACTIONS(2680), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2682), 1,
      anon_sym_u2987,
    ACTIONS(2684), 1,
      anon_sym_let,
    ACTIONS(2688), 1,
      anon_sym_Set,
    STATE(3243), 1,
      aux_sym__atoms,
    STATE(3732), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4916), 1,
      sym_atom,
    STATE(6233), 1,
      sym_attributes,
    STATE(8132), 1,
      sym__LAMBDA,
    STATE(8470), 1,
      sym__FORALL,
    STATE(8970), 1,
      sym_expr,
    STATE(9530), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2654), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2686), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4732), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8656), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4735), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2660), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [253396] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(3174), 1,
      anon_sym_BSLASH,
    ACTIONS(3176), 1,
      anon_sym_u03bb,
    ACTIONS(3194), 1,
      anon_sym_quoteGoal,
    ACTIONS(3196), 1,
      anon_sym_tactic,
    ACTIONS(3202), 1,
      anon_sym_let,
    ACTIONS(3852), 1,
      sym_id,
    ACTIONS(3856), 1,
      anon_sym_record,
    ACTIONS(3858), 1,
      anon_sym_LPAREN,
    ACTIONS(3860), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3862), 1,
      anon_sym_u2983,
    ACTIONS(3864), 1,
      anon_sym_LBRACE,
    ACTIONS(3866), 1,
      aux_sym__qid_token1,
    ACTIONS(3868), 1,
      anon_sym_DOT,
    ACTIONS(3870), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3872), 1,
      anon_sym_u2987,
    ACTIONS(3876), 1,
      anon_sym_Set,
    STATE(3279), 1,
      aux_sym__atoms,
    STATE(3724), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4769), 1,
      sym_atom,
    STATE(6278), 1,
      sym_attributes,
    STATE(8051), 1,
      sym__LAMBDA,
    STATE(8409), 1,
      sym__FORALL,
    STATE(8948), 1,
      sym_expr,
    STATE(9426), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3170), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3874), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4642), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8675), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4643), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3854), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [253532] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(8951), 1,
      sym_expr,
    STATE(10084), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [253668] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(3174), 1,
      anon_sym_BSLASH,
    ACTIONS(3176), 1,
      anon_sym_u03bb,
    ACTIONS(3194), 1,
      anon_sym_quoteGoal,
    ACTIONS(3196), 1,
      anon_sym_tactic,
    ACTIONS(3202), 1,
      anon_sym_let,
    ACTIONS(3852), 1,
      sym_id,
    ACTIONS(3856), 1,
      anon_sym_record,
    ACTIONS(3858), 1,
      anon_sym_LPAREN,
    ACTIONS(3860), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3862), 1,
      anon_sym_u2983,
    ACTIONS(3864), 1,
      anon_sym_LBRACE,
    ACTIONS(3866), 1,
      aux_sym__qid_token1,
    ACTIONS(3868), 1,
      anon_sym_DOT,
    ACTIONS(3870), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3872), 1,
      anon_sym_u2987,
    ACTIONS(3876), 1,
      anon_sym_Set,
    STATE(3279), 1,
      aux_sym__atoms,
    STATE(3724), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4769), 1,
      sym_atom,
    STATE(6278), 1,
      sym_attributes,
    STATE(8051), 1,
      sym__LAMBDA,
    STATE(8409), 1,
      sym__FORALL,
    STATE(8939), 1,
      sym_expr,
    STATE(9426), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3170), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3874), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4642), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8675), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4643), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3854), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [253804] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(10505), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [253940] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(10506), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [254076] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(10509), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [254212] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(2532), 1,
      anon_sym_BSLASH,
    ACTIONS(2534), 1,
      anon_sym_u03bb,
    ACTIONS(2552), 1,
      anon_sym_quoteGoal,
    ACTIONS(2554), 1,
      anon_sym_tactic,
    ACTIONS(2560), 1,
      anon_sym_let,
    ACTIONS(3584), 1,
      sym_id,
    ACTIONS(3588), 1,
      anon_sym_record,
    ACTIONS(3590), 1,
      anon_sym_LPAREN,
    ACTIONS(3592), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3594), 1,
      anon_sym_u2983,
    ACTIONS(3596), 1,
      anon_sym_LBRACE,
    ACTIONS(3598), 1,
      aux_sym__qid_token1,
    ACTIONS(3600), 1,
      anon_sym_DOT,
    ACTIONS(3602), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3604), 1,
      anon_sym_u2987,
    ACTIONS(3608), 1,
      anon_sym_Set,
    STATE(3300), 1,
      aux_sym__atoms,
    STATE(3720), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4261), 1,
      sym_atom,
    STATE(6280), 1,
      sym_attributes,
    STATE(8066), 1,
      sym__LAMBDA,
    STATE(8398), 1,
      sym__FORALL,
    STATE(8941), 1,
      sym_expr,
    STATE(9162), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2528), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3606), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4400), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8676), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4403), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3586), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [254348] = 36,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(10513), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [254484] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(2904), 1,
      anon_sym_BSLASH,
    ACTIONS(2906), 1,
      anon_sym_u03bb,
    ACTIONS(2924), 1,
      anon_sym_quoteGoal,
    ACTIONS(2926), 1,
      anon_sym_tactic,
    ACTIONS(2932), 1,
      anon_sym_let,
    ACTIONS(3300), 1,
      sym_id,
    ACTIONS(3304), 1,
      anon_sym_record,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3308), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3310), 1,
      anon_sym_u2983,
    ACTIONS(3312), 1,
      anon_sym_LBRACE,
    ACTIONS(3314), 1,
      aux_sym__qid_token1,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3318), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3320), 1,
      anon_sym_u2987,
    ACTIONS(3324), 1,
      anon_sym_Set,
    STATE(3316), 1,
      aux_sym__atoms,
    STATE(3756), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4056), 1,
      sym_atom,
    STATE(6223), 1,
      sym_attributes,
    STATE(8094), 1,
      sym__LAMBDA,
    STATE(8489), 1,
      sym__FORALL,
    STATE(8948), 1,
      sym_expr,
    STATE(9010), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2900), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3322), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4053), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8655), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4049), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3302), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [254620] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(8974), 1,
      sym_expr,
    STATE(10084), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [254756] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(9990), 1,
      sym__with_exprs,
    STATE(12595), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [254892] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(2904), 1,
      anon_sym_BSLASH,
    ACTIONS(2906), 1,
      anon_sym_u03bb,
    ACTIONS(2924), 1,
      anon_sym_quoteGoal,
    ACTIONS(2926), 1,
      anon_sym_tactic,
    ACTIONS(2932), 1,
      anon_sym_let,
    ACTIONS(3300), 1,
      sym_id,
    ACTIONS(3304), 1,
      anon_sym_record,
    ACTIONS(3306), 1,
      anon_sym_LPAREN,
    ACTIONS(3308), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3310), 1,
      anon_sym_u2983,
    ACTIONS(3312), 1,
      anon_sym_LBRACE,
    ACTIONS(3314), 1,
      aux_sym__qid_token1,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    ACTIONS(3318), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3320), 1,
      anon_sym_u2987,
    ACTIONS(3324), 1,
      anon_sym_Set,
    STATE(3316), 1,
      aux_sym__atoms,
    STATE(3756), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4056), 1,
      sym_atom,
    STATE(6223), 1,
      sym_attributes,
    STATE(8094), 1,
      sym__LAMBDA,
    STATE(8489), 1,
      sym__FORALL,
    STATE(8939), 1,
      sym_expr,
    STATE(9010), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2900), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3322), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4053), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8655), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4049), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3302), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [255028] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(9990), 1,
      sym__with_exprs,
    STATE(10526), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [255164] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(8978), 1,
      sym_expr,
    STATE(10084), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [255300] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(3444), 1,
      sym_id,
    ACTIONS(3448), 1,
      anon_sym_BSLASH,
    ACTIONS(3450), 1,
      anon_sym_u03bb,
    ACTIONS(3454), 1,
      anon_sym_record,
    ACTIONS(3456), 1,
      anon_sym_LPAREN,
    ACTIONS(3458), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3460), 1,
      anon_sym_u2983,
    ACTIONS(3462), 1,
      anon_sym_LBRACE,
    ACTIONS(3464), 1,
      aux_sym__qid_token1,
    ACTIONS(3466), 1,
      anon_sym_DOT,
    ACTIONS(3468), 1,
      anon_sym_quoteGoal,
    ACTIONS(3470), 1,
      anon_sym_tactic,
    ACTIONS(3472), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3474), 1,
      anon_sym_u2987,
    ACTIONS(3476), 1,
      anon_sym_let,
    ACTIONS(3480), 1,
      anon_sym_Set,
    STATE(3313), 1,
      aux_sym__atoms,
    STATE(3742), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5018), 1,
      sym_atom,
    STATE(6219), 1,
      sym_attributes,
    STATE(8072), 1,
      sym__LAMBDA,
    STATE(8455), 1,
      sym__FORALL,
    STATE(9626), 1,
      sym__with_exprs,
    STATE(10105), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3446), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3478), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5013), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8649), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5000), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3452), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [255436] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(3444), 1,
      sym_id,
    ACTIONS(3448), 1,
      anon_sym_BSLASH,
    ACTIONS(3450), 1,
      anon_sym_u03bb,
    ACTIONS(3454), 1,
      anon_sym_record,
    ACTIONS(3456), 1,
      anon_sym_LPAREN,
    ACTIONS(3458), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3460), 1,
      anon_sym_u2983,
    ACTIONS(3462), 1,
      anon_sym_LBRACE,
    ACTIONS(3464), 1,
      aux_sym__qid_token1,
    ACTIONS(3466), 1,
      anon_sym_DOT,
    ACTIONS(3468), 1,
      anon_sym_quoteGoal,
    ACTIONS(3470), 1,
      anon_sym_tactic,
    ACTIONS(3472), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3474), 1,
      anon_sym_u2987,
    ACTIONS(3476), 1,
      anon_sym_let,
    ACTIONS(3480), 1,
      anon_sym_Set,
    STATE(3313), 1,
      aux_sym__atoms,
    STATE(3742), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5018), 1,
      sym_atom,
    STATE(6219), 1,
      sym_attributes,
    STATE(8072), 1,
      sym__LAMBDA,
    STATE(8455), 1,
      sym__FORALL,
    STATE(9626), 1,
      sym__with_exprs,
    STATE(10104), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3446), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3478), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5013), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8649), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5000), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3452), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [255572] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(10065), 1,
      sym__with_exprs,
    STATE(12553), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [255708] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(9990), 1,
      sym__with_exprs,
    STATE(12574), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [255844] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(8959), 1,
      sym_expr,
    STATE(9861), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [255980] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(10065), 1,
      sym__with_exprs,
    STATE(12572), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [256116] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(9990), 1,
      sym__with_exprs,
    STATE(12554), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [256252] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(9990), 1,
      sym__with_exprs,
    STATE(12311), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [256388] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(9990), 1,
      sym__with_exprs,
    STATE(12535), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [256524] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(10065), 1,
      sym__with_exprs,
    STATE(12533), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [256660] = 35,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(700), 1,
      anon_sym_LBRACE_DASH_POUND,
    ACTIONS(2350), 1,
      anon_sym_BSLASH,
    ACTIONS(2352), 1,
      anon_sym_u03bb,
    ACTIONS(2370), 1,
      anon_sym_quoteGoal,
    ACTIONS(2372), 1,
      anon_sym_tactic,
    ACTIONS(2378), 1,
      anon_sym_let,
    ACTIONS(3786), 1,
      sym_id,
    ACTIONS(3792), 1,
      anon_sym_record,
    ACTIONS(3794), 1,
      anon_sym_LPAREN,
    ACTIONS(3796), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3798), 1,
      anon_sym_u2983,
    ACTIONS(3800), 1,
      anon_sym_LBRACE,
    ACTIONS(3802), 1,
      aux_sym__qid_token1,
    ACTIONS(3804), 1,
      anon_sym_DOT,
    ACTIONS(3806), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3808), 1,
      anon_sym_u2987,
    ACTIONS(3812), 1,
      anon_sym_Set,
    STATE(1464), 1,
      sym__ARROW,
    STATE(2773), 1,
      aux_sym__lambda_clauses_repeat1,
    STATE(3247), 1,
      sym_catchall_pragma,
    STATE(3680), 1,
      aux_sym__atoms,
    STATE(4255), 1,
      sym_atom,
    STATE(8119), 1,
      sym__LAMBDA,
    STATE(8372), 1,
      sym__FORALL,
    STATE(8999), 1,
      sym__lambda_clauses,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2348), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3788), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(3810), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4284), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(8993), 3,
      sym__lambda_clause_maybe_absurd,
      sym_lambda_clause_absurd,
      sym_lambda_clause,
    STATE(4282), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9000), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3790), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [256794] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(3694), 1,
      sym_id,
    ACTIONS(3698), 1,
      anon_sym_BSLASH,
    ACTIONS(3700), 1,
      anon_sym_u03bb,
    ACTIONS(3704), 1,
      anon_sym_record,
    ACTIONS(3706), 1,
      anon_sym_LPAREN,
    ACTIONS(3708), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3710), 1,
      anon_sym_u2983,
    ACTIONS(3712), 1,
      anon_sym_LBRACE,
    ACTIONS(3714), 1,
      aux_sym__qid_token1,
    ACTIONS(3716), 1,
      anon_sym_DOT,
    ACTIONS(3718), 1,
      anon_sym_quoteGoal,
    ACTIONS(3720), 1,
      anon_sym_tactic,
    ACTIONS(3722), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3724), 1,
      anon_sym_u2987,
    ACTIONS(3726), 1,
      anon_sym_let,
    ACTIONS(3730), 1,
      anon_sym_Set,
    STATE(3295), 1,
      aux_sym__atoms,
    STATE(3761), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4435), 1,
      sym_atom,
    STATE(6181), 1,
      sym_attributes,
    STATE(8124), 1,
      sym__LAMBDA,
    STATE(8446), 1,
      sym__FORALL,
    STATE(8941), 1,
      sym_expr,
    STATE(9267), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3696), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3728), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4467), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8651), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4459), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3702), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [256930] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(850), 1,
      sym_id,
    ACTIONS(854), 1,
      anon_sym_BSLASH,
    ACTIONS(856), 1,
      anon_sym_u03bb,
    ACTIONS(860), 1,
      anon_sym_record,
    ACTIONS(862), 1,
      anon_sym_LPAREN,
    ACTIONS(864), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(866), 1,
      anon_sym_u2983,
    ACTIONS(870), 1,
      anon_sym_LBRACE,
    ACTIONS(872), 1,
      aux_sym__qid_token1,
    ACTIONS(874), 1,
      anon_sym_DOT,
    ACTIONS(878), 1,
      anon_sym_quoteGoal,
    ACTIONS(880), 1,
      anon_sym_tactic,
    ACTIONS(882), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(884), 1,
      anon_sym_u2987,
    ACTIONS(886), 1,
      anon_sym_let,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(892), 1,
      anon_sym_Set,
    STATE(3274), 1,
      aux_sym__atoms,
    STATE(3763), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5204), 1,
      sym_atom,
    STATE(6271), 1,
      sym_attributes,
    STATE(8152), 1,
      sym__LAMBDA,
    STATE(8369), 1,
      sym__FORALL,
    STATE(8961), 1,
      sym_expr,
    STATE(9548), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(852), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(890), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5180), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8688), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5168), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(858), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [257066] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1910), 1,
      anon_sym_BSLASH,
    ACTIONS(1912), 1,
      anon_sym_u03bb,
    ACTIONS(1928), 1,
      anon_sym_quoteGoal,
    ACTIONS(1930), 1,
      anon_sym_tactic,
    ACTIONS(1936), 1,
      anon_sym_let,
    ACTIONS(2174), 1,
      sym_id,
    ACTIONS(2182), 1,
      anon_sym_record,
    ACTIONS(2184), 1,
      anon_sym_LPAREN,
    ACTIONS(2186), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2188), 1,
      anon_sym_u2983,
    ACTIONS(2190), 1,
      anon_sym_LBRACE,
    ACTIONS(2192), 1,
      aux_sym__qid_token1,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2198), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2200), 1,
      anon_sym_u2987,
    ACTIONS(2204), 1,
      anon_sym_Set,
    STATE(3339), 1,
      aux_sym__atoms,
    STATE(3717), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4611), 1,
      sym_atom,
    STATE(6264), 1,
      sym_attributes,
    STATE(8153), 1,
      sym__LAMBDA,
    STATE(8431), 1,
      sym__FORALL,
    STATE(8961), 1,
      sym_expr,
    STATE(9486), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1906), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4536), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8673), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4531), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2180), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [257202] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(9990), 1,
      sym__with_exprs,
    STATE(12515), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [257338] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(10065), 1,
      sym__with_exprs,
    STATE(11904), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [257474] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(10065), 1,
      sym__with_exprs,
    STATE(12513), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [257610] = 36,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(10472), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [257746] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(9990), 1,
      sym__with_exprs,
    STATE(11906), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [257882] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(10473), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [258018] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(9990), 1,
      sym__with_exprs,
    STATE(12499), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [258154] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(10065), 1,
      sym__with_exprs,
    STATE(12497), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [258290] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(9990), 1,
      sym__with_exprs,
    STATE(12477), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [258426] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(10065), 1,
      sym__with_exprs,
    STATE(10527), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [258562] = 37,
    ACTIONS(710), 1,
      anon_sym_DASH,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(920), 1,
      anon_sym_quoteGoal,
    ACTIONS(928), 1,
      anon_sym_let,
    ACTIONS(3056), 1,
      sym_id,
    ACTIONS(3058), 1,
      anon_sym_BSLASH,
    ACTIONS(3060), 1,
      anon_sym_u03bb,
    ACTIONS(3064), 1,
      anon_sym_record,
    ACTIONS(3066), 1,
      anon_sym_LPAREN,
    ACTIONS(3068), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3070), 1,
      anon_sym_u2983,
    ACTIONS(3072), 1,
      anon_sym_LBRACE,
    ACTIONS(3076), 1,
      aux_sym__qid_token1,
    ACTIONS(3078), 1,
      anon_sym_DOT,
    ACTIONS(3080), 1,
      anon_sym_tactic,
    ACTIONS(3082), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3084), 1,
      anon_sym_u2987,
    ACTIONS(3088), 1,
      anon_sym_Set,
    ACTIONS(3964), 1,
      anon_sym_RBRACE,
    STATE(3697), 1,
      sym_attributes,
    STATE(3892), 1,
      aux_sym__atoms,
    STATE(6084), 1,
      sym__qid,
    STATE(6427), 1,
      sym_atom,
    STATE(8123), 1,
      sym__LAMBDA,
    STATE(8396), 1,
      sym__FORALL,
    STATE(9546), 1,
      aux_sym__field_assignments_repeat1,
    STATE(10062), 1,
      sym_field_assignment,
    STATE(11273), 1,
      sym__field_assignments,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3086), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6715), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6714), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3062), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10002), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [258700] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(2614), 1,
      sym_id,
    ACTIONS(2618), 1,
      anon_sym_BSLASH,
    ACTIONS(2620), 1,
      anon_sym_u03bb,
    ACTIONS(2624), 1,
      anon_sym_record,
    ACTIONS(2626), 1,
      anon_sym_LPAREN,
    ACTIONS(2628), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2630), 1,
      anon_sym_u2983,
    ACTIONS(2632), 1,
      anon_sym_LBRACE,
    ACTIONS(2634), 1,
      aux_sym__qid_token1,
    ACTIONS(2636), 1,
      anon_sym_DOT,
    ACTIONS(2638), 1,
      anon_sym_quoteGoal,
    ACTIONS(2640), 1,
      anon_sym_tactic,
    ACTIONS(2642), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2644), 1,
      anon_sym_u2987,
    ACTIONS(2646), 1,
      anon_sym_let,
    ACTIONS(2650), 1,
      anon_sym_Set,
    STATE(3343), 1,
      aux_sym__atoms,
    STATE(3758), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4849), 1,
      sym_atom,
    STATE(6258), 1,
      sym_attributes,
    STATE(8093), 1,
      sym__LAMBDA,
    STATE(8414), 1,
      sym__FORALL,
    STATE(9434), 1,
      sym_expr,
    STATE(9445), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2616), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2648), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4799), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8666), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4784), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2622), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [258836] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(10671), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [258972] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(10065), 1,
      sym__with_exprs,
    STATE(12476), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [259108] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(10474), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [259244] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(9990), 1,
      sym__with_exprs,
    STATE(12461), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [259380] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(10065), 1,
      sym__with_exprs,
    STATE(12459), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [259516] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(9990), 1,
      sym__with_exprs,
    STATE(12443), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [259652] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(2614), 1,
      sym_id,
    ACTIONS(2618), 1,
      anon_sym_BSLASH,
    ACTIONS(2620), 1,
      anon_sym_u03bb,
    ACTIONS(2624), 1,
      anon_sym_record,
    ACTIONS(2626), 1,
      anon_sym_LPAREN,
    ACTIONS(2628), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2630), 1,
      anon_sym_u2983,
    ACTIONS(2632), 1,
      anon_sym_LBRACE,
    ACTIONS(2634), 1,
      aux_sym__qid_token1,
    ACTIONS(2636), 1,
      anon_sym_DOT,
    ACTIONS(2638), 1,
      anon_sym_quoteGoal,
    ACTIONS(2640), 1,
      anon_sym_tactic,
    ACTIONS(2642), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2644), 1,
      anon_sym_u2987,
    ACTIONS(2646), 1,
      anon_sym_let,
    ACTIONS(2650), 1,
      anon_sym_Set,
    STATE(3343), 1,
      aux_sym__atoms,
    STATE(3758), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4849), 1,
      sym_atom,
    STATE(6258), 1,
      sym_attributes,
    STATE(8093), 1,
      sym__LAMBDA,
    STATE(8414), 1,
      sym__FORALL,
    STATE(9445), 1,
      sym__with_exprs,
    STATE(9571), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2616), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2648), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4799), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8666), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4784), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2622), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [259788] = 36,
    ACTIONS(714), 1,
      anon_sym_quoteGoal,
    ACTIONS(722), 1,
      anon_sym_let,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(3556), 1,
      anon_sym_BSLASH,
    ACTIONS(3558), 1,
      anon_sym_u03bb,
    ACTIONS(3574), 1,
      anon_sym_tactic,
    ACTIONS(3912), 1,
      sym_id,
    ACTIONS(3916), 1,
      anon_sym_record,
    ACTIONS(3918), 1,
      anon_sym_LPAREN,
    ACTIONS(3920), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3922), 1,
      anon_sym_u2983,
    ACTIONS(3924), 1,
      anon_sym_LBRACE,
    ACTIONS(3926), 1,
      aux_sym__qid_token1,
    ACTIONS(3928), 1,
      anon_sym_DOT,
    ACTIONS(3930), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3932), 1,
      anon_sym_u2987,
    ACTIONS(3936), 1,
      anon_sym_Set,
    STATE(3162), 1,
      aux_sym__atoms,
    STATE(3706), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4664), 1,
      sym_atom,
    STATE(6275), 1,
      sym_attributes,
    STATE(8092), 1,
      sym__LAMBDA,
    STATE(8495), 1,
      sym__FORALL,
    STATE(9418), 1,
      sym__with_exprs,
    STATE(9476), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(682), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3934), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4662), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8684), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4728), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3914), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [259924] = 36,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(11222), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [260060] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(10673), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [260196] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(11223), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [260332] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(11224), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [260468] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(11225), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [260604] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(10065), 1,
      sym__with_exprs,
    STATE(12441), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [260740] = 36,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(11226), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [260876] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(11227), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [261012] = 35,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(700), 1,
      anon_sym_LBRACE_DASH_POUND,
    ACTIONS(2964), 1,
      anon_sym_quoteGoal,
    ACTIONS(2972), 1,
      anon_sym_let,
    ACTIONS(3520), 1,
      sym_id,
    ACTIONS(3522), 1,
      anon_sym_BSLASH,
    ACTIONS(3524), 1,
      anon_sym_u03bb,
    ACTIONS(3528), 1,
      anon_sym_record,
    ACTIONS(3530), 1,
      anon_sym_LPAREN,
    ACTIONS(3532), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3534), 1,
      anon_sym_u2983,
    ACTIONS(3536), 1,
      anon_sym_LBRACE,
    ACTIONS(3538), 1,
      aux_sym__qid_token1,
    ACTIONS(3540), 1,
      anon_sym_DOT,
    ACTIONS(3542), 1,
      anon_sym_tactic,
    ACTIONS(3544), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3546), 1,
      anon_sym_u2987,
    ACTIONS(3550), 1,
      anon_sym_Set,
    STATE(2453), 1,
      sym__ARROW,
    STATE(2787), 1,
      aux_sym__lambda_clauses_repeat1,
    STATE(3308), 1,
      sym_catchall_pragma,
    STATE(3404), 1,
      aux_sym__atoms,
    STATE(5625), 1,
      sym_atom,
    STATE(8058), 1,
      sym__LAMBDA,
    STATE(8418), 1,
      sym__FORALL,
    STATE(8999), 1,
      sym__lambda_clauses,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2940), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2942), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(3548), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5537), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(8993), 3,
      sym__lambda_clause_maybe_absurd,
      sym_lambda_clause_absurd,
      sym_lambda_clause,
    STATE(5538), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9000), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3526), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [261146] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(11228), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [261282] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(11229), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [261418] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(10065), 1,
      sym__with_exprs,
    STATE(11916), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [261554] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(9990), 1,
      sym__with_exprs,
    STATE(11918), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [261690] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(11303), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [261826] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(11302), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [261962] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(11301), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [262098] = 36,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(11299), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [262234] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(2212), 1,
      anon_sym_BSLASH,
    ACTIONS(2214), 1,
      anon_sym_u03bb,
    ACTIONS(2232), 1,
      anon_sym_quoteGoal,
    ACTIONS(2234), 1,
      anon_sym_tactic,
    ACTIONS(2240), 1,
      anon_sym_let,
    ACTIONS(3760), 1,
      sym_id,
    ACTIONS(3764), 1,
      anon_sym_record,
    ACTIONS(3766), 1,
      anon_sym_LPAREN,
    ACTIONS(3768), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3770), 1,
      anon_sym_u2983,
    ACTIONS(3772), 1,
      anon_sym_LBRACE,
    ACTIONS(3774), 1,
      aux_sym__qid_token1,
    ACTIONS(3776), 1,
      anon_sym_DOT,
    ACTIONS(3778), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3780), 1,
      anon_sym_u2987,
    ACTIONS(3784), 1,
      anon_sym_Set,
    STATE(3306), 1,
      aux_sym__atoms,
    STATE(3733), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4506), 1,
      sym_atom,
    STATE(6279), 1,
      sym_attributes,
    STATE(8035), 1,
      sym__LAMBDA,
    STATE(8402), 1,
      sym__FORALL,
    STATE(8949), 1,
      sym_expr,
    STATE(9372), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3782), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4599), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8680), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4613), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3762), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [262370] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(11296), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [262506] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(11295), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [262642] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(11294), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [262778] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(2614), 1,
      sym_id,
    ACTIONS(2618), 1,
      anon_sym_BSLASH,
    ACTIONS(2620), 1,
      anon_sym_u03bb,
    ACTIONS(2624), 1,
      anon_sym_record,
    ACTIONS(2626), 1,
      anon_sym_LPAREN,
    ACTIONS(2628), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2630), 1,
      anon_sym_u2983,
    ACTIONS(2632), 1,
      anon_sym_LBRACE,
    ACTIONS(2634), 1,
      aux_sym__qid_token1,
    ACTIONS(2636), 1,
      anon_sym_DOT,
    ACTIONS(2638), 1,
      anon_sym_quoteGoal,
    ACTIONS(2640), 1,
      anon_sym_tactic,
    ACTIONS(2642), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2644), 1,
      anon_sym_u2987,
    ACTIONS(2646), 1,
      anon_sym_let,
    ACTIONS(2650), 1,
      anon_sym_Set,
    STATE(3343), 1,
      aux_sym__atoms,
    STATE(3758), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4849), 1,
      sym_atom,
    STATE(6258), 1,
      sym_attributes,
    STATE(8093), 1,
      sym__LAMBDA,
    STATE(8414), 1,
      sym__FORALL,
    STATE(8982), 1,
      sym_expr,
    STATE(9445), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2616), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2648), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4799), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8666), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4784), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2622), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [262914] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(10065), 1,
      sym__with_exprs,
    STATE(11931), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [263050] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(2614), 1,
      sym_id,
    ACTIONS(2618), 1,
      anon_sym_BSLASH,
    ACTIONS(2620), 1,
      anon_sym_u03bb,
    ACTIONS(2624), 1,
      anon_sym_record,
    ACTIONS(2626), 1,
      anon_sym_LPAREN,
    ACTIONS(2628), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2630), 1,
      anon_sym_u2983,
    ACTIONS(2632), 1,
      anon_sym_LBRACE,
    ACTIONS(2634), 1,
      aux_sym__qid_token1,
    ACTIONS(2636), 1,
      anon_sym_DOT,
    ACTIONS(2638), 1,
      anon_sym_quoteGoal,
    ACTIONS(2640), 1,
      anon_sym_tactic,
    ACTIONS(2642), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2644), 1,
      anon_sym_u2987,
    ACTIONS(2646), 1,
      anon_sym_let,
    ACTIONS(2650), 1,
      anon_sym_Set,
    STATE(3343), 1,
      aux_sym__atoms,
    STATE(3758), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4849), 1,
      sym_atom,
    STATE(6258), 1,
      sym_attributes,
    STATE(8093), 1,
      sym__LAMBDA,
    STATE(8414), 1,
      sym__FORALL,
    STATE(8952), 1,
      sym_expr,
    STATE(9445), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2616), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2648), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4799), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8666), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4784), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2622), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [263186] = 36,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(11293), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [263322] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(3814), 1,
      sym_id,
    ACTIONS(3818), 1,
      anon_sym_BSLASH,
    ACTIONS(3820), 1,
      anon_sym_u03bb,
    ACTIONS(3824), 1,
      anon_sym_record,
    ACTIONS(3826), 1,
      anon_sym_LPAREN,
    ACTIONS(3828), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3830), 1,
      anon_sym_u2983,
    ACTIONS(3832), 1,
      anon_sym_LBRACE,
    ACTIONS(3834), 1,
      aux_sym__qid_token1,
    ACTIONS(3836), 1,
      anon_sym_DOT,
    ACTIONS(3838), 1,
      anon_sym_quoteGoal,
    ACTIONS(3840), 1,
      anon_sym_tactic,
    ACTIONS(3842), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3844), 1,
      anon_sym_u2987,
    ACTIONS(3846), 1,
      anon_sym_let,
    ACTIONS(3850), 1,
      anon_sym_Set,
    STATE(3246), 1,
      aux_sym__atoms,
    STATE(3716), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4371), 1,
      sym_atom,
    STATE(6222), 1,
      sym_attributes,
    STATE(8085), 1,
      sym__LAMBDA,
    STATE(8442), 1,
      sym__FORALL,
    STATE(9149), 1,
      sym_expr,
    STATE(9165), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3816), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3848), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4342), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8652), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4273), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3822), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [263458] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(9990), 1,
      sym__with_exprs,
    STATE(11932), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [263594] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(10708), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [263730] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(10707), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [263866] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(2614), 1,
      sym_id,
    ACTIONS(2618), 1,
      anon_sym_BSLASH,
    ACTIONS(2620), 1,
      anon_sym_u03bb,
    ACTIONS(2624), 1,
      anon_sym_record,
    ACTIONS(2626), 1,
      anon_sym_LPAREN,
    ACTIONS(2628), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2630), 1,
      anon_sym_u2983,
    ACTIONS(2632), 1,
      anon_sym_LBRACE,
    ACTIONS(2634), 1,
      aux_sym__qid_token1,
    ACTIONS(2636), 1,
      anon_sym_DOT,
    ACTIONS(2638), 1,
      anon_sym_quoteGoal,
    ACTIONS(2640), 1,
      anon_sym_tactic,
    ACTIONS(2642), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2644), 1,
      anon_sym_u2987,
    ACTIONS(2646), 1,
      anon_sym_let,
    ACTIONS(2650), 1,
      anon_sym_Set,
    STATE(3343), 1,
      aux_sym__atoms,
    STATE(3758), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4849), 1,
      sym_atom,
    STATE(6258), 1,
      sym_attributes,
    STATE(8093), 1,
      sym__LAMBDA,
    STATE(8414), 1,
      sym__FORALL,
    STATE(8948), 1,
      sym_expr,
    STATE(9445), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2616), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2648), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4799), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8666), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4784), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2622), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [264002] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(2614), 1,
      sym_id,
    ACTIONS(2618), 1,
      anon_sym_BSLASH,
    ACTIONS(2620), 1,
      anon_sym_u03bb,
    ACTIONS(2624), 1,
      anon_sym_record,
    ACTIONS(2626), 1,
      anon_sym_LPAREN,
    ACTIONS(2628), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2630), 1,
      anon_sym_u2983,
    ACTIONS(2632), 1,
      anon_sym_LBRACE,
    ACTIONS(2634), 1,
      aux_sym__qid_token1,
    ACTIONS(2636), 1,
      anon_sym_DOT,
    ACTIONS(2638), 1,
      anon_sym_quoteGoal,
    ACTIONS(2640), 1,
      anon_sym_tactic,
    ACTIONS(2642), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2644), 1,
      anon_sym_u2987,
    ACTIONS(2646), 1,
      anon_sym_let,
    ACTIONS(2650), 1,
      anon_sym_Set,
    STATE(3343), 1,
      aux_sym__atoms,
    STATE(3758), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4849), 1,
      sym_atom,
    STATE(6258), 1,
      sym_attributes,
    STATE(8093), 1,
      sym__LAMBDA,
    STATE(8414), 1,
      sym__FORALL,
    STATE(8939), 1,
      sym_expr,
    STATE(9445), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2616), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2648), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4799), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8666), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4784), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2622), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [264138] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(2212), 1,
      anon_sym_BSLASH,
    ACTIONS(2214), 1,
      anon_sym_u03bb,
    ACTIONS(2232), 1,
      anon_sym_quoteGoal,
    ACTIONS(2234), 1,
      anon_sym_tactic,
    ACTIONS(2240), 1,
      anon_sym_let,
    ACTIONS(3760), 1,
      sym_id,
    ACTIONS(3764), 1,
      anon_sym_record,
    ACTIONS(3766), 1,
      anon_sym_LPAREN,
    ACTIONS(3768), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3770), 1,
      anon_sym_u2983,
    ACTIONS(3772), 1,
      anon_sym_LBRACE,
    ACTIONS(3774), 1,
      aux_sym__qid_token1,
    ACTIONS(3776), 1,
      anon_sym_DOT,
    ACTIONS(3778), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3780), 1,
      anon_sym_u2987,
    ACTIONS(3784), 1,
      anon_sym_Set,
    STATE(3306), 1,
      aux_sym__atoms,
    STATE(3733), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4506), 1,
      sym_atom,
    STATE(6279), 1,
      sym_attributes,
    STATE(8035), 1,
      sym__LAMBDA,
    STATE(8402), 1,
      sym__FORALL,
    STATE(8941), 1,
      sym_expr,
    STATE(9372), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3782), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4599), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8680), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4613), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3762), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [264274] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(9990), 1,
      sym__with_exprs,
    STATE(12428), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [264410] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(10065), 1,
      sym__with_exprs,
    STATE(12427), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [264546] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(9990), 1,
      sym__with_exprs,
    STATE(12412), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [264682] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(10065), 1,
      sym__with_exprs,
    STATE(12411), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [264818] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(9990), 1,
      sym__with_exprs,
    STATE(12398), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [264954] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(10065), 1,
      sym__with_exprs,
    STATE(12396), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [265090] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(10065), 1,
      sym__with_exprs,
    STATE(11947), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [265226] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(9990), 1,
      sym__with_exprs,
    STATE(11948), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [265362] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(3694), 1,
      sym_id,
    ACTIONS(3698), 1,
      anon_sym_BSLASH,
    ACTIONS(3700), 1,
      anon_sym_u03bb,
    ACTIONS(3704), 1,
      anon_sym_record,
    ACTIONS(3706), 1,
      anon_sym_LPAREN,
    ACTIONS(3708), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3710), 1,
      anon_sym_u2983,
    ACTIONS(3712), 1,
      anon_sym_LBRACE,
    ACTIONS(3714), 1,
      aux_sym__qid_token1,
    ACTIONS(3716), 1,
      anon_sym_DOT,
    ACTIONS(3718), 1,
      anon_sym_quoteGoal,
    ACTIONS(3720), 1,
      anon_sym_tactic,
    ACTIONS(3722), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3724), 1,
      anon_sym_u2987,
    ACTIONS(3726), 1,
      anon_sym_let,
    ACTIONS(3730), 1,
      anon_sym_Set,
    STATE(3295), 1,
      aux_sym__atoms,
    STATE(3761), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4435), 1,
      sym_atom,
    STATE(6181), 1,
      sym_attributes,
    STATE(8124), 1,
      sym__LAMBDA,
    STATE(8446), 1,
      sym__FORALL,
    STATE(9267), 1,
      sym__with_exprs,
    STATE(9446), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3696), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3728), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4467), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8651), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4459), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3702), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [265498] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(3694), 1,
      sym_id,
    ACTIONS(3698), 1,
      anon_sym_BSLASH,
    ACTIONS(3700), 1,
      anon_sym_u03bb,
    ACTIONS(3704), 1,
      anon_sym_record,
    ACTIONS(3706), 1,
      anon_sym_LPAREN,
    ACTIONS(3708), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3710), 1,
      anon_sym_u2983,
    ACTIONS(3712), 1,
      anon_sym_LBRACE,
    ACTIONS(3714), 1,
      aux_sym__qid_token1,
    ACTIONS(3716), 1,
      anon_sym_DOT,
    ACTIONS(3718), 1,
      anon_sym_quoteGoal,
    ACTIONS(3720), 1,
      anon_sym_tactic,
    ACTIONS(3722), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3724), 1,
      anon_sym_u2987,
    ACTIONS(3726), 1,
      anon_sym_let,
    ACTIONS(3730), 1,
      anon_sym_Set,
    STATE(3295), 1,
      aux_sym__atoms,
    STATE(3761), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4435), 1,
      sym_atom,
    STATE(6181), 1,
      sym_attributes,
    STATE(8124), 1,
      sym__LAMBDA,
    STATE(8446), 1,
      sym__FORALL,
    STATE(9267), 1,
      sym__with_exprs,
    STATE(9448), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3696), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3728), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4467), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8651), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4459), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3702), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [265634] = 35,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(700), 1,
      anon_sym_LBRACE_DASH_POUND,
    ACTIONS(1870), 1,
      anon_sym_BSLASH,
    ACTIONS(1872), 1,
      anon_sym_u03bb,
    ACTIONS(1890), 1,
      anon_sym_quoteGoal,
    ACTIONS(1892), 1,
      anon_sym_tactic,
    ACTIONS(1898), 1,
      anon_sym_let,
    ACTIONS(3666), 1,
      sym_id,
    ACTIONS(3672), 1,
      anon_sym_record,
    ACTIONS(3674), 1,
      anon_sym_LPAREN,
    ACTIONS(3676), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3678), 1,
      anon_sym_u2983,
    ACTIONS(3680), 1,
      anon_sym_LBRACE,
    ACTIONS(3682), 1,
      aux_sym__qid_token1,
    ACTIONS(3684), 1,
      anon_sym_DOT,
    ACTIONS(3686), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3688), 1,
      anon_sym_u2987,
    ACTIONS(3692), 1,
      anon_sym_Set,
    STATE(1400), 1,
      sym__ARROW,
    STATE(2814), 1,
      aux_sym__lambda_clauses_repeat1,
    STATE(3172), 1,
      sym_catchall_pragma,
    STATE(3653), 1,
      aux_sym__atoms,
    STATE(4587), 1,
      sym_atom,
    STATE(8032), 1,
      sym__LAMBDA,
    STATE(8379), 1,
      sym__FORALL,
    STATE(8999), 1,
      sym__lambda_clauses,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1868), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3668), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(3690), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4585), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(8993), 3,
      sym__lambda_clause_maybe_absurd,
      sym_lambda_clause_absurd,
      sym_lambda_clause,
    STATE(4584), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9000), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3670), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [265768] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(10065), 1,
      sym__with_exprs,
    STATE(11962), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [265904] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1910), 1,
      anon_sym_BSLASH,
    ACTIONS(1912), 1,
      anon_sym_u03bb,
    ACTIONS(1928), 1,
      anon_sym_quoteGoal,
    ACTIONS(1930), 1,
      anon_sym_tactic,
    ACTIONS(1936), 1,
      anon_sym_let,
    ACTIONS(2174), 1,
      sym_id,
    ACTIONS(2182), 1,
      anon_sym_record,
    ACTIONS(2184), 1,
      anon_sym_LPAREN,
    ACTIONS(2186), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2188), 1,
      anon_sym_u2983,
    ACTIONS(2190), 1,
      anon_sym_LBRACE,
    ACTIONS(2192), 1,
      aux_sym__qid_token1,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2198), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2200), 1,
      anon_sym_u2987,
    ACTIONS(2204), 1,
      anon_sym_Set,
    STATE(3339), 1,
      aux_sym__atoms,
    STATE(3717), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4611), 1,
      sym_atom,
    STATE(6264), 1,
      sym_attributes,
    STATE(8153), 1,
      sym__LAMBDA,
    STATE(8431), 1,
      sym__FORALL,
    STATE(8970), 1,
      sym_expr,
    STATE(9486), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1906), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4536), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8673), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4531), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2180), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [266040] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(10706), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [266176] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(10475), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [266312] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(9990), 1,
      sym__with_exprs,
    STATE(11963), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [266448] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(10065), 1,
      sym__with_exprs,
    STATE(11979), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [266584] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(850), 1,
      sym_id,
    ACTIONS(854), 1,
      anon_sym_BSLASH,
    ACTIONS(856), 1,
      anon_sym_u03bb,
    ACTIONS(860), 1,
      anon_sym_record,
    ACTIONS(862), 1,
      anon_sym_LPAREN,
    ACTIONS(864), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(866), 1,
      anon_sym_u2983,
    ACTIONS(870), 1,
      anon_sym_LBRACE,
    ACTIONS(872), 1,
      aux_sym__qid_token1,
    ACTIONS(874), 1,
      anon_sym_DOT,
    ACTIONS(878), 1,
      anon_sym_quoteGoal,
    ACTIONS(880), 1,
      anon_sym_tactic,
    ACTIONS(882), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(884), 1,
      anon_sym_u2987,
    ACTIONS(886), 1,
      anon_sym_let,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(892), 1,
      anon_sym_Set,
    STATE(3274), 1,
      aux_sym__atoms,
    STATE(3763), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5204), 1,
      sym_atom,
    STATE(6271), 1,
      sym_attributes,
    STATE(8152), 1,
      sym__LAMBDA,
    STATE(8369), 1,
      sym__FORALL,
    STATE(8951), 1,
      sym_expr,
    STATE(9548), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(852), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(890), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5180), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8688), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5168), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(858), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [266720] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(9990), 1,
      sym__with_exprs,
    STATE(11980), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [266856] = 35,
    ACTIONS(700), 1,
      anon_sym_LBRACE_DASH_POUND,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2796), 1,
      anon_sym_BSLASH,
    ACTIONS(2798), 1,
      anon_sym_u03bb,
    ACTIONS(2800), 1,
      anon_sym_quoteGoal,
    ACTIONS(2802), 1,
      anon_sym_tactic,
    ACTIONS(2804), 1,
      anon_sym_let,
    ACTIONS(3380), 1,
      sym_id,
    ACTIONS(3384), 1,
      anon_sym_record,
    ACTIONS(3386), 1,
      anon_sym_LPAREN,
    ACTIONS(3388), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3390), 1,
      anon_sym_u2983,
    ACTIONS(3392), 1,
      anon_sym_LBRACE,
    ACTIONS(3394), 1,
      aux_sym__qid_token1,
    ACTIONS(3396), 1,
      anon_sym_DOT,
    ACTIONS(3398), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3400), 1,
      anon_sym_u2987,
    ACTIONS(3404), 1,
      anon_sym_Set,
    STATE(2185), 1,
      sym__ARROW,
    STATE(2738), 1,
      aux_sym__lambda_clauses_repeat1,
    STATE(3299), 1,
      sym_catchall_pragma,
    STATE(3446), 1,
      aux_sym__atoms,
    STATE(5099), 1,
      sym_atom,
    STATE(8041), 1,
      sym__LAMBDA,
    STATE(8490), 1,
      sym__FORALL,
    STATE(8987), 1,
      sym__lambda_clauses,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2794), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2808), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(3402), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4937), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(8986), 3,
      sym__lambda_clause_maybe_absurd,
      sym_lambda_clause_absurd,
      sym_lambda_clause,
    STATE(4939), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8988), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3382), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [266990] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(10065), 1,
      sym__with_exprs,
    STATE(11776), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [267126] = 36,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(10705), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [267262] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(9990), 1,
      sym__with_exprs,
    STATE(11996), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [267398] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(10704), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [267534] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(3444), 1,
      sym_id,
    ACTIONS(3448), 1,
      anon_sym_BSLASH,
    ACTIONS(3450), 1,
      anon_sym_u03bb,
    ACTIONS(3454), 1,
      anon_sym_record,
    ACTIONS(3456), 1,
      anon_sym_LPAREN,
    ACTIONS(3458), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3460), 1,
      anon_sym_u2983,
    ACTIONS(3462), 1,
      anon_sym_LBRACE,
    ACTIONS(3464), 1,
      aux_sym__qid_token1,
    ACTIONS(3466), 1,
      anon_sym_DOT,
    ACTIONS(3468), 1,
      anon_sym_quoteGoal,
    ACTIONS(3470), 1,
      anon_sym_tactic,
    ACTIONS(3472), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3474), 1,
      anon_sym_u2987,
    ACTIONS(3476), 1,
      anon_sym_let,
    ACTIONS(3480), 1,
      anon_sym_Set,
    STATE(3313), 1,
      aux_sym__atoms,
    STATE(3742), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5018), 1,
      sym_atom,
    STATE(6219), 1,
      sym_attributes,
    STATE(8072), 1,
      sym__LAMBDA,
    STATE(8455), 1,
      sym__FORALL,
    STATE(9626), 1,
      sym__with_exprs,
    STATE(9763), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3446), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3478), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5013), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8649), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5000), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3452), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [267670] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(10544), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [267806] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(10703), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [267942] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(10065), 1,
      sym__with_exprs,
    STATE(12012), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [268078] = 35,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(700), 1,
      anon_sym_LBRACE_DASH_POUND,
    ACTIONS(2732), 1,
      anon_sym_BSLASH,
    ACTIONS(2734), 1,
      anon_sym_u03bb,
    ACTIONS(2752), 1,
      anon_sym_quoteGoal,
    ACTIONS(2754), 1,
      anon_sym_tactic,
    ACTIONS(2760), 1,
      anon_sym_let,
    ACTIONS(3610), 1,
      sym_id,
    ACTIONS(3616), 1,
      anon_sym_record,
    ACTIONS(3618), 1,
      anon_sym_LPAREN,
    ACTIONS(3620), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3622), 1,
      anon_sym_u2983,
    ACTIONS(3624), 1,
      anon_sym_LBRACE,
    ACTIONS(3626), 1,
      aux_sym__qid_token1,
    ACTIONS(3628), 1,
      anon_sym_DOT,
    ACTIONS(3630), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3632), 1,
      anon_sym_u2987,
    ACTIONS(3636), 1,
      anon_sym_Set,
    STATE(1572), 1,
      sym__ARROW,
    STATE(2753), 1,
      aux_sym__lambda_clauses_repeat1,
    STATE(3190), 1,
      sym_catchall_pragma,
    STATE(3429), 1,
      aux_sym__atoms,
    STATE(5352), 1,
      sym_atom,
    STATE(8061), 1,
      sym__LAMBDA,
    STATE(8384), 1,
      sym__FORALL,
    STATE(8999), 1,
      sym__lambda_clauses,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2730), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3612), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(3634), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5254), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(8993), 3,
      sym__lambda_clause_maybe_absurd,
      sym_lambda_clause_absurd,
      sym_lambda_clause,
    STATE(5242), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9000), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3614), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [268212] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(9990), 1,
      sym__with_exprs,
    STATE(12014), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [268348] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(10551), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [268484] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(10552), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [268620] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(9990), 1,
      sym__with_exprs,
    STATE(12379), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [268756] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(10065), 1,
      sym__with_exprs,
    STATE(12378), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [268892] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(9990), 1,
      sym__with_exprs,
    STATE(12368), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [269028] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(10065), 1,
      sym__with_exprs,
    STATE(12028), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [269164] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(10065), 1,
      sym__with_exprs,
    STATE(12367), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [269300] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(9990), 1,
      sym__with_exprs,
    STATE(12349), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [269436] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(9990), 1,
      sym__with_exprs,
    STATE(12030), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [269572] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(10702), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [269708] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(9990), 1,
      sym__with_exprs,
    STATE(11286), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [269844] = 36,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(10701), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [269980] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(10065), 1,
      sym__with_exprs,
    STATE(12047), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [270116] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(9990), 1,
      sym__with_exprs,
    STATE(12048), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [270252] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(10065), 1,
      sym__with_exprs,
    STATE(11285), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [270388] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(2964), 1,
      anon_sym_quoteGoal,
    ACTIONS(2972), 1,
      anon_sym_let,
    ACTIONS(3522), 1,
      anon_sym_BSLASH,
    ACTIONS(3524), 1,
      anon_sym_u03bb,
    ACTIONS(3542), 1,
      anon_sym_tactic,
    ACTIONS(3938), 1,
      sym_id,
    ACTIONS(3942), 1,
      anon_sym_record,
    ACTIONS(3944), 1,
      anon_sym_LPAREN,
    ACTIONS(3946), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3948), 1,
      anon_sym_u2983,
    ACTIONS(3950), 1,
      anon_sym_LBRACE,
    ACTIONS(3952), 1,
      aux_sym__qid_token1,
    ACTIONS(3954), 1,
      anon_sym_DOT,
    ACTIONS(3956), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3958), 1,
      anon_sym_u2987,
    ACTIONS(3962), 1,
      anon_sym_Set,
    STATE(3218), 1,
      aux_sym__atoms,
    STATE(3712), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5290), 1,
      sym_atom,
    STATE(6276), 1,
      sym_attributes,
    STATE(8058), 1,
      sym__LAMBDA,
    STATE(8418), 1,
      sym__FORALL,
    STATE(8941), 1,
      sym_expr,
    STATE(9540), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2940), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3960), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5203), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8685), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5201), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3940), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [270524] = 36,
    ACTIONS(714), 1,
      anon_sym_quoteGoal,
    ACTIONS(722), 1,
      anon_sym_let,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(3556), 1,
      anon_sym_BSLASH,
    ACTIONS(3558), 1,
      anon_sym_u03bb,
    ACTIONS(3574), 1,
      anon_sym_tactic,
    ACTIONS(3912), 1,
      sym_id,
    ACTIONS(3916), 1,
      anon_sym_record,
    ACTIONS(3918), 1,
      anon_sym_LPAREN,
    ACTIONS(3920), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3922), 1,
      anon_sym_u2983,
    ACTIONS(3924), 1,
      anon_sym_LBRACE,
    ACTIONS(3926), 1,
      aux_sym__qid_token1,
    ACTIONS(3928), 1,
      anon_sym_DOT,
    ACTIONS(3930), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3932), 1,
      anon_sym_u2987,
    ACTIONS(3936), 1,
      anon_sym_Set,
    STATE(3162), 1,
      aux_sym__atoms,
    STATE(3706), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4664), 1,
      sym_atom,
    STATE(6275), 1,
      sym_attributes,
    STATE(8092), 1,
      sym__LAMBDA,
    STATE(8495), 1,
      sym__FORALL,
    STATE(8937), 1,
      sym_expr,
    STATE(9418), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(682), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3934), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4662), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8684), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4728), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3914), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [270660] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(10065), 1,
      sym__with_exprs,
    STATE(12348), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [270796] = 36,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(10555), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [270932] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(9990), 1,
      sym__with_exprs,
    STATE(10690), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [271068] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(10065), 1,
      sym__with_exprs,
    STATE(10689), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [271204] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2448), 1,
      anon_sym_quoteGoal,
    ACTIONS(2456), 1,
      anon_sym_let,
    ACTIONS(2840), 1,
      sym_id,
    ACTIONS(2842), 1,
      anon_sym_BSLASH,
    ACTIONS(2844), 1,
      anon_sym_u03bb,
    ACTIONS(2848), 1,
      anon_sym_record,
    ACTIONS(2850), 1,
      anon_sym_LPAREN,
    ACTIONS(2852), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2854), 1,
      anon_sym_u2983,
    ACTIONS(2856), 1,
      anon_sym_LBRACE,
    ACTIONS(2858), 1,
      aux_sym__qid_token1,
    ACTIONS(2860), 1,
      anon_sym_DOT,
    ACTIONS(2862), 1,
      anon_sym_tactic,
    ACTIONS(2864), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2866), 1,
      anon_sym_u2987,
    ACTIONS(2870), 1,
      anon_sym_Set,
    STATE(3174), 1,
      aux_sym__atoms,
    STATE(3747), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4684), 1,
      sym_atom,
    STATE(6273), 1,
      sym_attributes,
    STATE(8053), 1,
      sym__LAMBDA,
    STATE(8423), 1,
      sym__FORALL,
    STATE(8978), 1,
      sym_expr,
    STATE(9406), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2424), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2868), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4765), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8686), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4766), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2846), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [271340] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(9990), 1,
      sym__with_exprs,
    STATE(12330), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [271476] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(10065), 1,
      sym__with_exprs,
    STATE(12328), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [271612] = 35,
    ACTIONS(700), 1,
      anon_sym_LBRACE_DASH_POUND,
    ACTIONS(706), 1,
      aux_sym__qid_token1,
    ACTIONS(714), 1,
      anon_sym_quoteGoal,
    ACTIONS(722), 1,
      anon_sym_let,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(3554), 1,
      sym_id,
    ACTIONS(3556), 1,
      anon_sym_BSLASH,
    ACTIONS(3558), 1,
      anon_sym_u03bb,
    ACTIONS(3562), 1,
      anon_sym_record,
    ACTIONS(3564), 1,
      anon_sym_LPAREN,
    ACTIONS(3566), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3568), 1,
      anon_sym_u2983,
    ACTIONS(3570), 1,
      anon_sym_LBRACE,
    ACTIONS(3572), 1,
      anon_sym_DOT,
    ACTIONS(3574), 1,
      anon_sym_tactic,
    ACTIONS(3576), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3578), 1,
      anon_sym_u2987,
    ACTIONS(3582), 1,
      anon_sym_Set,
    STATE(2651), 1,
      sym__ARROW,
    STATE(2800), 1,
      aux_sym__lambda_clauses_repeat1,
    STATE(3233), 1,
      sym_catchall_pragma,
    STATE(3567), 1,
      aux_sym__atoms,
    STATE(5237), 1,
      sym_atom,
    STATE(8092), 1,
      sym__LAMBDA,
    STATE(8495), 1,
      sym__FORALL,
    STATE(9460), 1,
      sym__lambda_clauses,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(682), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2604), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(3580), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5081), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(8986), 3,
      sym__lambda_clause_maybe_absurd,
      sym_lambda_clause_absurd,
      sym_lambda_clause,
    STATE(5079), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9459), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3560), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [271746] = 36,
    ACTIONS(714), 1,
      anon_sym_quoteGoal,
    ACTIONS(722), 1,
      anon_sym_let,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(3556), 1,
      anon_sym_BSLASH,
    ACTIONS(3558), 1,
      anon_sym_u03bb,
    ACTIONS(3574), 1,
      anon_sym_tactic,
    ACTIONS(3912), 1,
      sym_id,
    ACTIONS(3916), 1,
      anon_sym_record,
    ACTIONS(3918), 1,
      anon_sym_LPAREN,
    ACTIONS(3920), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3922), 1,
      anon_sym_u2983,
    ACTIONS(3924), 1,
      anon_sym_LBRACE,
    ACTIONS(3926), 1,
      aux_sym__qid_token1,
    ACTIONS(3928), 1,
      anon_sym_DOT,
    ACTIONS(3930), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3932), 1,
      anon_sym_u2987,
    ACTIONS(3936), 1,
      anon_sym_Set,
    STATE(3162), 1,
      aux_sym__atoms,
    STATE(3706), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4664), 1,
      sym_atom,
    STATE(6275), 1,
      sym_attributes,
    STATE(8092), 1,
      sym__LAMBDA,
    STATE(8495), 1,
      sym__FORALL,
    STATE(8945), 1,
      sym_expr,
    STATE(9418), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(682), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3934), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4662), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8684), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4728), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3914), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [271882] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(3174), 1,
      anon_sym_BSLASH,
    ACTIONS(3176), 1,
      anon_sym_u03bb,
    ACTIONS(3194), 1,
      anon_sym_quoteGoal,
    ACTIONS(3196), 1,
      anon_sym_tactic,
    ACTIONS(3202), 1,
      anon_sym_let,
    ACTIONS(3852), 1,
      sym_id,
    ACTIONS(3856), 1,
      anon_sym_record,
    ACTIONS(3858), 1,
      anon_sym_LPAREN,
    ACTIONS(3860), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3862), 1,
      anon_sym_u2983,
    ACTIONS(3864), 1,
      anon_sym_LBRACE,
    ACTIONS(3866), 1,
      aux_sym__qid_token1,
    ACTIONS(3868), 1,
      anon_sym_DOT,
    ACTIONS(3870), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3872), 1,
      anon_sym_u2987,
    ACTIONS(3876), 1,
      anon_sym_Set,
    STATE(3279), 1,
      aux_sym__atoms,
    STATE(3724), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4769), 1,
      sym_atom,
    STATE(6278), 1,
      sym_attributes,
    STATE(8051), 1,
      sym__LAMBDA,
    STATE(8409), 1,
      sym__FORALL,
    STATE(8949), 1,
      sym_expr,
    STATE(9426), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3170), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3874), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4642), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8675), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4643), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3854), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [272018] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2448), 1,
      anon_sym_quoteGoal,
    ACTIONS(2456), 1,
      anon_sym_let,
    ACTIONS(2840), 1,
      sym_id,
    ACTIONS(2842), 1,
      anon_sym_BSLASH,
    ACTIONS(2844), 1,
      anon_sym_u03bb,
    ACTIONS(2848), 1,
      anon_sym_record,
    ACTIONS(2850), 1,
      anon_sym_LPAREN,
    ACTIONS(2852), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2854), 1,
      anon_sym_u2983,
    ACTIONS(2856), 1,
      anon_sym_LBRACE,
    ACTIONS(2858), 1,
      aux_sym__qid_token1,
    ACTIONS(2860), 1,
      anon_sym_DOT,
    ACTIONS(2862), 1,
      anon_sym_tactic,
    ACTIONS(2864), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2866), 1,
      anon_sym_u2987,
    ACTIONS(2870), 1,
      anon_sym_Set,
    STATE(3174), 1,
      aux_sym__atoms,
    STATE(3747), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4684), 1,
      sym_atom,
    STATE(6273), 1,
      sym_attributes,
    STATE(8053), 1,
      sym__LAMBDA,
    STATE(8423), 1,
      sym__FORALL,
    STATE(8974), 1,
      sym_expr,
    STATE(9406), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2424), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2868), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4765), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8686), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4766), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2846), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [272154] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(10065), 1,
      sym__with_exprs,
    STATE(12062), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [272290] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(9990), 1,
      sym__with_exprs,
    STATE(12063), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [272426] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(2964), 1,
      anon_sym_quoteGoal,
    ACTIONS(2972), 1,
      anon_sym_let,
    ACTIONS(3522), 1,
      anon_sym_BSLASH,
    ACTIONS(3524), 1,
      anon_sym_u03bb,
    ACTIONS(3542), 1,
      anon_sym_tactic,
    ACTIONS(3938), 1,
      sym_id,
    ACTIONS(3942), 1,
      anon_sym_record,
    ACTIONS(3944), 1,
      anon_sym_LPAREN,
    ACTIONS(3946), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3948), 1,
      anon_sym_u2983,
    ACTIONS(3950), 1,
      anon_sym_LBRACE,
    ACTIONS(3952), 1,
      aux_sym__qid_token1,
    ACTIONS(3954), 1,
      anon_sym_DOT,
    ACTIONS(3956), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3958), 1,
      anon_sym_u2987,
    ACTIONS(3962), 1,
      anon_sym_Set,
    STATE(3218), 1,
      aux_sym__atoms,
    STATE(3712), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5290), 1,
      sym_atom,
    STATE(6276), 1,
      sym_attributes,
    STATE(8058), 1,
      sym__LAMBDA,
    STATE(8418), 1,
      sym__FORALL,
    STATE(8982), 1,
      sym_expr,
    STATE(9540), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2940), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3960), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5203), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8685), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5201), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3940), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [272562] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(10065), 1,
      sym__with_exprs,
    STATE(12080), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [272698] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(2964), 1,
      anon_sym_quoteGoal,
    ACTIONS(2972), 1,
      anon_sym_let,
    ACTIONS(3522), 1,
      anon_sym_BSLASH,
    ACTIONS(3524), 1,
      anon_sym_u03bb,
    ACTIONS(3542), 1,
      anon_sym_tactic,
    ACTIONS(3938), 1,
      sym_id,
    ACTIONS(3942), 1,
      anon_sym_record,
    ACTIONS(3944), 1,
      anon_sym_LPAREN,
    ACTIONS(3946), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3948), 1,
      anon_sym_u2983,
    ACTIONS(3950), 1,
      anon_sym_LBRACE,
    ACTIONS(3952), 1,
      aux_sym__qid_token1,
    ACTIONS(3954), 1,
      anon_sym_DOT,
    ACTIONS(3956), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3958), 1,
      anon_sym_u2987,
    ACTIONS(3962), 1,
      anon_sym_Set,
    STATE(3218), 1,
      aux_sym__atoms,
    STATE(3712), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5290), 1,
      sym_atom,
    STATE(6276), 1,
      sym_attributes,
    STATE(8058), 1,
      sym__LAMBDA,
    STATE(8418), 1,
      sym__FORALL,
    STATE(8952), 1,
      sym_expr,
    STATE(9540), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2940), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3960), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5203), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8685), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5201), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3940), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [272834] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(10065), 1,
      sym__with_exprs,
    STATE(12098), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [272970] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2448), 1,
      anon_sym_quoteGoal,
    ACTIONS(2456), 1,
      anon_sym_let,
    ACTIONS(2840), 1,
      sym_id,
    ACTIONS(2842), 1,
      anon_sym_BSLASH,
    ACTIONS(2844), 1,
      anon_sym_u03bb,
    ACTIONS(2848), 1,
      anon_sym_record,
    ACTIONS(2850), 1,
      anon_sym_LPAREN,
    ACTIONS(2852), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2854), 1,
      anon_sym_u2983,
    ACTIONS(2856), 1,
      anon_sym_LBRACE,
    ACTIONS(2858), 1,
      aux_sym__qid_token1,
    ACTIONS(2860), 1,
      anon_sym_DOT,
    ACTIONS(2862), 1,
      anon_sym_tactic,
    ACTIONS(2864), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2866), 1,
      anon_sym_u2987,
    ACTIONS(2870), 1,
      anon_sym_Set,
    STATE(3174), 1,
      aux_sym__atoms,
    STATE(3747), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4684), 1,
      sym_atom,
    STATE(6273), 1,
      sym_attributes,
    STATE(8053), 1,
      sym__LAMBDA,
    STATE(8423), 1,
      sym__FORALL,
    STATE(8951), 1,
      sym_expr,
    STATE(9406), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2424), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2868), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4765), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8686), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4766), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2846), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [273106] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2448), 1,
      anon_sym_quoteGoal,
    ACTIONS(2456), 1,
      anon_sym_let,
    ACTIONS(2840), 1,
      sym_id,
    ACTIONS(2842), 1,
      anon_sym_BSLASH,
    ACTIONS(2844), 1,
      anon_sym_u03bb,
    ACTIONS(2848), 1,
      anon_sym_record,
    ACTIONS(2850), 1,
      anon_sym_LPAREN,
    ACTIONS(2852), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2854), 1,
      anon_sym_u2983,
    ACTIONS(2856), 1,
      anon_sym_LBRACE,
    ACTIONS(2858), 1,
      aux_sym__qid_token1,
    ACTIONS(2860), 1,
      anon_sym_DOT,
    ACTIONS(2862), 1,
      anon_sym_tactic,
    ACTIONS(2864), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2866), 1,
      anon_sym_u2987,
    ACTIONS(2870), 1,
      anon_sym_Set,
    STATE(3174), 1,
      aux_sym__atoms,
    STATE(3747), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4684), 1,
      sym_atom,
    STATE(6273), 1,
      sym_attributes,
    STATE(8053), 1,
      sym__LAMBDA,
    STATE(8423), 1,
      sym__FORALL,
    STATE(8961), 1,
      sym_expr,
    STATE(9406), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2424), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2868), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4765), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8686), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4766), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2846), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [273242] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(10065), 1,
      sym__with_exprs,
    STATE(12308), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [273378] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(9990), 1,
      sym__with_exprs,
    STATE(12294), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [273514] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(9990), 1,
      sym__with_exprs,
    STATE(12083), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [273650] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(10065), 1,
      sym__with_exprs,
    STATE(11248), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [273786] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(2964), 1,
      anon_sym_quoteGoal,
    ACTIONS(2972), 1,
      anon_sym_let,
    ACTIONS(3522), 1,
      anon_sym_BSLASH,
    ACTIONS(3524), 1,
      anon_sym_u03bb,
    ACTIONS(3542), 1,
      anon_sym_tactic,
    ACTIONS(3938), 1,
      sym_id,
    ACTIONS(3942), 1,
      anon_sym_record,
    ACTIONS(3944), 1,
      anon_sym_LPAREN,
    ACTIONS(3946), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3948), 1,
      anon_sym_u2983,
    ACTIONS(3950), 1,
      anon_sym_LBRACE,
    ACTIONS(3952), 1,
      aux_sym__qid_token1,
    ACTIONS(3954), 1,
      anon_sym_DOT,
    ACTIONS(3956), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3958), 1,
      anon_sym_u2987,
    ACTIONS(3962), 1,
      anon_sym_Set,
    STATE(3218), 1,
      aux_sym__atoms,
    STATE(3712), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5290), 1,
      sym_atom,
    STATE(6276), 1,
      sym_attributes,
    STATE(8058), 1,
      sym__LAMBDA,
    STATE(8418), 1,
      sym__FORALL,
    STATE(8948), 1,
      sym_expr,
    STATE(9540), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2940), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3960), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5203), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8685), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5201), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3940), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [273922] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(2964), 1,
      anon_sym_quoteGoal,
    ACTIONS(2972), 1,
      anon_sym_let,
    ACTIONS(3522), 1,
      anon_sym_BSLASH,
    ACTIONS(3524), 1,
      anon_sym_u03bb,
    ACTIONS(3542), 1,
      anon_sym_tactic,
    ACTIONS(3938), 1,
      sym_id,
    ACTIONS(3942), 1,
      anon_sym_record,
    ACTIONS(3944), 1,
      anon_sym_LPAREN,
    ACTIONS(3946), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3948), 1,
      anon_sym_u2983,
    ACTIONS(3950), 1,
      anon_sym_LBRACE,
    ACTIONS(3952), 1,
      aux_sym__qid_token1,
    ACTIONS(3954), 1,
      anon_sym_DOT,
    ACTIONS(3956), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3958), 1,
      anon_sym_u2987,
    ACTIONS(3962), 1,
      anon_sym_Set,
    STATE(3218), 1,
      aux_sym__atoms,
    STATE(3712), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5290), 1,
      sym_atom,
    STATE(6276), 1,
      sym_attributes,
    STATE(8058), 1,
      sym__LAMBDA,
    STATE(8418), 1,
      sym__FORALL,
    STATE(8939), 1,
      sym_expr,
    STATE(9540), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2940), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3960), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5203), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8685), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5201), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3940), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [274058] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(3174), 1,
      anon_sym_BSLASH,
    ACTIONS(3176), 1,
      anon_sym_u03bb,
    ACTIONS(3194), 1,
      anon_sym_quoteGoal,
    ACTIONS(3196), 1,
      anon_sym_tactic,
    ACTIONS(3202), 1,
      anon_sym_let,
    ACTIONS(3852), 1,
      sym_id,
    ACTIONS(3856), 1,
      anon_sym_record,
    ACTIONS(3858), 1,
      anon_sym_LPAREN,
    ACTIONS(3860), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3862), 1,
      anon_sym_u2983,
    ACTIONS(3864), 1,
      anon_sym_LBRACE,
    ACTIONS(3866), 1,
      aux_sym__qid_token1,
    ACTIONS(3868), 1,
      anon_sym_DOT,
    ACTIONS(3870), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3872), 1,
      anon_sym_u2987,
    ACTIONS(3876), 1,
      anon_sym_Set,
    STATE(3279), 1,
      aux_sym__atoms,
    STATE(3724), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4769), 1,
      sym_atom,
    STATE(6278), 1,
      sym_attributes,
    STATE(8051), 1,
      sym__LAMBDA,
    STATE(8409), 1,
      sym__FORALL,
    STATE(8941), 1,
      sym_expr,
    STATE(9426), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3170), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3874), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4642), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8675), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4643), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3854), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [274194] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(10065), 1,
      sym__with_exprs,
    STATE(12292), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [274330] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(9990), 1,
      sym__with_exprs,
    STATE(12276), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [274466] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(734), 1,
      sym_id,
    ACTIONS(738), 1,
      anon_sym_BSLASH,
    ACTIONS(740), 1,
      anon_sym_u03bb,
    ACTIONS(744), 1,
      anon_sym_record,
    ACTIONS(746), 1,
      anon_sym_LPAREN,
    ACTIONS(748), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(750), 1,
      anon_sym_u2983,
    ACTIONS(752), 1,
      anon_sym_LBRACE,
    ACTIONS(754), 1,
      aux_sym__qid_token1,
    ACTIONS(756), 1,
      anon_sym_DOT,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(762), 1,
      anon_sym_quoteGoal,
    ACTIONS(764), 1,
      anon_sym_tactic,
    ACTIONS(766), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(768), 1,
      anon_sym_u2987,
    ACTIONS(774), 1,
      anon_sym_Set,
    ACTIONS(3054), 1,
      anon_sym_let,
    STATE(3326), 1,
      aux_sym__atoms,
    STATE(3730), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5147), 1,
      sym_atom,
    STATE(6212), 1,
      sym_attributes,
    STATE(8156), 1,
      sym__LAMBDA,
    STATE(8456), 1,
      sym__FORALL,
    STATE(8941), 1,
      sym_expr,
    STATE(9596), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(736), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(772), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5108), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8641), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5102), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(742), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [274602] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(850), 1,
      sym_id,
    ACTIONS(854), 1,
      anon_sym_BSLASH,
    ACTIONS(856), 1,
      anon_sym_u03bb,
    ACTIONS(860), 1,
      anon_sym_record,
    ACTIONS(862), 1,
      anon_sym_LPAREN,
    ACTIONS(864), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(866), 1,
      anon_sym_u2983,
    ACTIONS(870), 1,
      anon_sym_LBRACE,
    ACTIONS(872), 1,
      aux_sym__qid_token1,
    ACTIONS(874), 1,
      anon_sym_DOT,
    ACTIONS(878), 1,
      anon_sym_quoteGoal,
    ACTIONS(880), 1,
      anon_sym_tactic,
    ACTIONS(882), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(884), 1,
      anon_sym_u2987,
    ACTIONS(886), 1,
      anon_sym_let,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(892), 1,
      anon_sym_Set,
    STATE(3274), 1,
      aux_sym__atoms,
    STATE(3763), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5204), 1,
      sym_atom,
    STATE(6271), 1,
      sym_attributes,
    STATE(8152), 1,
      sym__LAMBDA,
    STATE(8369), 1,
      sym__FORALL,
    STATE(8978), 1,
      sym_expr,
    STATE(9548), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(852), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(890), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5180), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8688), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5168), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(858), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [274738] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(2964), 1,
      anon_sym_quoteGoal,
    ACTIONS(2972), 1,
      anon_sym_let,
    ACTIONS(3522), 1,
      anon_sym_BSLASH,
    ACTIONS(3524), 1,
      anon_sym_u03bb,
    ACTIONS(3542), 1,
      anon_sym_tactic,
    ACTIONS(3938), 1,
      sym_id,
    ACTIONS(3942), 1,
      anon_sym_record,
    ACTIONS(3944), 1,
      anon_sym_LPAREN,
    ACTIONS(3946), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3948), 1,
      anon_sym_u2983,
    ACTIONS(3950), 1,
      anon_sym_LBRACE,
    ACTIONS(3952), 1,
      aux_sym__qid_token1,
    ACTIONS(3954), 1,
      anon_sym_DOT,
    ACTIONS(3956), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3958), 1,
      anon_sym_u2987,
    ACTIONS(3962), 1,
      anon_sym_Set,
    STATE(3218), 1,
      aux_sym__atoms,
    STATE(3712), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5290), 1,
      sym_atom,
    STATE(6276), 1,
      sym_attributes,
    STATE(8058), 1,
      sym__LAMBDA,
    STATE(8418), 1,
      sym__FORALL,
    STATE(8949), 1,
      sym_expr,
    STATE(9540), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2940), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3960), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5203), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8685), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5201), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3940), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [274874] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(9990), 1,
      sym__with_exprs,
    STATE(11249), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [275010] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(11266), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [275146] = 34,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(700), 1,
      anon_sym_LBRACE_DASH_POUND,
    ACTIONS(3266), 1,
      anon_sym_BSLASH,
    ACTIONS(3268), 1,
      anon_sym_u03bb,
    ACTIONS(3286), 1,
      anon_sym_quoteGoal,
    ACTIONS(3288), 1,
      anon_sym_tactic,
    ACTIONS(3294), 1,
      anon_sym_let,
    ACTIONS(3732), 1,
      sym_id,
    ACTIONS(3738), 1,
      anon_sym_record,
    ACTIONS(3740), 1,
      anon_sym_LPAREN,
    ACTIONS(3742), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3744), 1,
      anon_sym_u2983,
    ACTIONS(3746), 1,
      anon_sym_LBRACE,
    ACTIONS(3748), 1,
      aux_sym__qid_token1,
    ACTIONS(3750), 1,
      anon_sym_DOT,
    ACTIONS(3752), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3754), 1,
      anon_sym_u2987,
    ACTIONS(3758), 1,
      anon_sym_Set,
    STATE(2021), 1,
      sym__ARROW,
    STATE(2797), 1,
      aux_sym__lambda_clauses_repeat1,
    STATE(3195), 1,
      sym_catchall_pragma,
    STATE(3592), 1,
      aux_sym__atoms,
    STATE(4058), 1,
      sym_atom,
    STATE(8143), 1,
      sym__LAMBDA,
    STATE(8451), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3264), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3734), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(3756), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4073), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(8999), 4,
      sym__lambda_clauses,
      sym__lambda_clause_maybe_absurd,
      sym_lambda_clause_absurd,
      sym_lambda_clause,
    STATE(4070), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9000), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3736), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [275278] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(11265), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [275414] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(10065), 1,
      sym__with_exprs,
    STATE(12275), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [275550] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(10557), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [275686] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(10558), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [275822] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(11264), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [275958] = 36,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(11263), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [276094] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    STATE(3201), 1,
      aux_sym__atoms,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6308), 1,
      sym_attributes,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(10084), 1,
      sym__with_exprs,
    STATE(11262), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8642), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [276230] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1178), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1184), 1,
      anon_sym_u2983,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    STATE(3262), 1,
      aux_sym__atoms,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5247), 1,
      sym_atom,
    STATE(6302), 1,
      sym_attributes,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(10050), 1,
      sym__with_exprs,
    STATE(11261), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8646), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [276366] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(3444), 1,
      sym_id,
    ACTIONS(3448), 1,
      anon_sym_BSLASH,
    ACTIONS(3450), 1,
      anon_sym_u03bb,
    ACTIONS(3454), 1,
      anon_sym_record,
    ACTIONS(3456), 1,
      anon_sym_LPAREN,
    ACTIONS(3458), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3460), 1,
      anon_sym_u2983,
    ACTIONS(3462), 1,
      anon_sym_LBRACE,
    ACTIONS(3464), 1,
      aux_sym__qid_token1,
    ACTIONS(3466), 1,
      anon_sym_DOT,
    ACTIONS(3468), 1,
      anon_sym_quoteGoal,
    ACTIONS(3470), 1,
      anon_sym_tactic,
    ACTIONS(3472), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3474), 1,
      anon_sym_u2987,
    ACTIONS(3476), 1,
      anon_sym_let,
    ACTIONS(3480), 1,
      anon_sym_Set,
    STATE(3313), 1,
      aux_sym__atoms,
    STATE(3742), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5018), 1,
      sym_atom,
    STATE(6219), 1,
      sym_attributes,
    STATE(8072), 1,
      sym__LAMBDA,
    STATE(8455), 1,
      sym__FORALL,
    STATE(8949), 1,
      sym_expr,
    STATE(9626), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3446), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3478), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5013), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8649), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5000), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3452), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [276502] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(11260), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [276638] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(850), 1,
      sym_id,
    ACTIONS(854), 1,
      anon_sym_BSLASH,
    ACTIONS(856), 1,
      anon_sym_u03bb,
    ACTIONS(860), 1,
      anon_sym_record,
    ACTIONS(862), 1,
      anon_sym_LPAREN,
    ACTIONS(864), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(866), 1,
      anon_sym_u2983,
    ACTIONS(870), 1,
      anon_sym_LBRACE,
    ACTIONS(872), 1,
      aux_sym__qid_token1,
    ACTIONS(874), 1,
      anon_sym_DOT,
    ACTIONS(878), 1,
      anon_sym_quoteGoal,
    ACTIONS(880), 1,
      anon_sym_tactic,
    ACTIONS(882), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(884), 1,
      anon_sym_u2987,
    ACTIONS(886), 1,
      anon_sym_let,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(892), 1,
      anon_sym_Set,
    STATE(3274), 1,
      aux_sym__atoms,
    STATE(3763), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5204), 1,
      sym_atom,
    STATE(6271), 1,
      sym_attributes,
    STATE(8152), 1,
      sym__LAMBDA,
    STATE(8369), 1,
      sym__FORALL,
    STATE(8974), 1,
      sym_expr,
    STATE(9548), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(852), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(890), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5180), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8688), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5168), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(858), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [276774] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1260), 1,
      anon_sym_u2983,
    ACTIONS(1264), 1,
      anon_sym_LBRACE,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1268), 1,
      anon_sym_DOT,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    STATE(3158), 1,
      aux_sym__atoms,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5430), 1,
      sym_atom,
    STATE(6182), 1,
      sym_attributes,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(9861), 1,
      sym__with_exprs,
    STATE(10559), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8654), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [276910] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(9990), 1,
      sym__with_exprs,
    STATE(12250), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [277046] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(10065), 1,
      sym__with_exprs,
    STATE(12247), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [277182] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(9990), 1,
      sym__with_exprs,
    STATE(12222), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [277318] = 36,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(11259), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [277454] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(10065), 1,
      sym__with_exprs,
    STATE(12220), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [277590] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(10065), 1,
      sym__with_exprs,
    STATE(11995), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [277726] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(9990), 1,
      sym__with_exprs,
    STATE(12099), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [277862] = 36,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1218), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1222), 1,
      anon_sym_u2983,
    ACTIONS(1224), 1,
      anon_sym_LBRACE,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    STATE(3344), 1,
      aux_sym__atoms,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5404), 1,
      sym_atom,
    STATE(6200), 1,
      sym_attributes,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(10196), 1,
      sym__with_exprs,
    STATE(10561), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8648), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [277998] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(9990), 1,
      sym__with_exprs,
    STATE(12203), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [278134] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(10065), 1,
      sym__with_exprs,
    STATE(12202), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [278270] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(734), 1,
      sym_id,
    ACTIONS(738), 1,
      anon_sym_BSLASH,
    ACTIONS(740), 1,
      anon_sym_u03bb,
    ACTIONS(744), 1,
      anon_sym_record,
    ACTIONS(746), 1,
      anon_sym_LPAREN,
    ACTIONS(748), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(750), 1,
      anon_sym_u2983,
    ACTIONS(752), 1,
      anon_sym_LBRACE,
    ACTIONS(754), 1,
      aux_sym__qid_token1,
    ACTIONS(756), 1,
      anon_sym_DOT,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(762), 1,
      anon_sym_quoteGoal,
    ACTIONS(764), 1,
      anon_sym_tactic,
    ACTIONS(766), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(768), 1,
      anon_sym_u2987,
    ACTIONS(774), 1,
      anon_sym_Set,
    ACTIONS(3054), 1,
      anon_sym_let,
    STATE(3326), 1,
      aux_sym__atoms,
    STATE(3730), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5147), 1,
      sym_atom,
    STATE(6212), 1,
      sym_attributes,
    STATE(8156), 1,
      sym__LAMBDA,
    STATE(8456), 1,
      sym__FORALL,
    STATE(8982), 1,
      sym_expr,
    STATE(9596), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(736), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(772), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5108), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8641), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5102), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(742), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [278406] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(9990), 1,
      sym__with_exprs,
    STATE(12182), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [278542] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(10065), 1,
      sym__with_exprs,
    STATE(12050), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [278678] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(9990), 1,
      sym__with_exprs,
    STATE(12154), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [278814] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(10065), 1,
      sym__with_exprs,
    STATE(12152), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [278950] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(9990), 1,
      sym__with_exprs,
    STATE(10569), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [279086] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(10065), 1,
      sym__with_exprs,
    STATE(10570), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [279222] = 36,
    ACTIONS(714), 1,
      anon_sym_quoteGoal,
    ACTIONS(722), 1,
      anon_sym_let,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(3556), 1,
      anon_sym_BSLASH,
    ACTIONS(3558), 1,
      anon_sym_u03bb,
    ACTIONS(3574), 1,
      anon_sym_tactic,
    ACTIONS(3912), 1,
      sym_id,
    ACTIONS(3916), 1,
      anon_sym_record,
    ACTIONS(3918), 1,
      anon_sym_LPAREN,
    ACTIONS(3920), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3922), 1,
      anon_sym_u2983,
    ACTIONS(3924), 1,
      anon_sym_LBRACE,
    ACTIONS(3926), 1,
      aux_sym__qid_token1,
    ACTIONS(3928), 1,
      anon_sym_DOT,
    ACTIONS(3930), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3932), 1,
      anon_sym_u2987,
    ACTIONS(3936), 1,
      anon_sym_Set,
    STATE(3162), 1,
      aux_sym__atoms,
    STATE(3706), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4664), 1,
      sym_atom,
    STATE(6275), 1,
      sym_attributes,
    STATE(8092), 1,
      sym__LAMBDA,
    STATE(8495), 1,
      sym__FORALL,
    STATE(8970), 1,
      sym_expr,
    STATE(9418), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(682), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3934), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4662), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8684), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(4728), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3914), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [279358] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(734), 1,
      sym_id,
    ACTIONS(738), 1,
      anon_sym_BSLASH,
    ACTIONS(740), 1,
      anon_sym_u03bb,
    ACTIONS(744), 1,
      anon_sym_record,
    ACTIONS(746), 1,
      anon_sym_LPAREN,
    ACTIONS(748), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(750), 1,
      anon_sym_u2983,
    ACTIONS(752), 1,
      anon_sym_LBRACE,
    ACTIONS(754), 1,
      aux_sym__qid_token1,
    ACTIONS(756), 1,
      anon_sym_DOT,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(762), 1,
      anon_sym_quoteGoal,
    ACTIONS(764), 1,
      anon_sym_tactic,
    ACTIONS(766), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(768), 1,
      anon_sym_u2987,
    ACTIONS(774), 1,
      anon_sym_Set,
    ACTIONS(3054), 1,
      anon_sym_let,
    STATE(3326), 1,
      aux_sym__atoms,
    STATE(3730), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5147), 1,
      sym_atom,
    STATE(6212), 1,
      sym_attributes,
    STATE(8156), 1,
      sym__LAMBDA,
    STATE(8456), 1,
      sym__FORALL,
    STATE(8952), 1,
      sym_expr,
    STATE(9596), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(736), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(772), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5108), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8641), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5102), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(742), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [279494] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(9990), 1,
      sym__with_exprs,
    STATE(12132), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [279630] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(10065), 1,
      sym__with_exprs,
    STATE(12131), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [279766] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1954), 1,
      anon_sym_LPAREN,
    ACTIONS(1956), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1958), 1,
      anon_sym_u2983,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1964), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    STATE(3163), 1,
      aux_sym__atoms,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5442), 1,
      sym_atom,
    STATE(6201), 1,
      sym_attributes,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(9990), 1,
      sym__with_exprs,
    STATE(12116), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8643), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [279902] = 36,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2068), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_u2983,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2078), 1,
      anon_sym_DOT,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    STATE(3311), 1,
      aux_sym__atoms,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5469), 1,
      sym_atom,
    STATE(6206), 1,
      sym_attributes,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(10065), 1,
      sym__with_exprs,
    STATE(12115), 1,
      sym_expr,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8639), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [280038] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(3444), 1,
      sym_id,
    ACTIONS(3448), 1,
      anon_sym_BSLASH,
    ACTIONS(3450), 1,
      anon_sym_u03bb,
    ACTIONS(3454), 1,
      anon_sym_record,
    ACTIONS(3456), 1,
      anon_sym_LPAREN,
    ACTIONS(3458), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3460), 1,
      anon_sym_u2983,
    ACTIONS(3462), 1,
      anon_sym_LBRACE,
    ACTIONS(3464), 1,
      aux_sym__qid_token1,
    ACTIONS(3466), 1,
      anon_sym_DOT,
    ACTIONS(3468), 1,
      anon_sym_quoteGoal,
    ACTIONS(3470), 1,
      anon_sym_tactic,
    ACTIONS(3472), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3474), 1,
      anon_sym_u2987,
    ACTIONS(3476), 1,
      anon_sym_let,
    ACTIONS(3480), 1,
      anon_sym_Set,
    STATE(3313), 1,
      aux_sym__atoms,
    STATE(3742), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5018), 1,
      sym_atom,
    STATE(6219), 1,
      sym_attributes,
    STATE(8072), 1,
      sym__LAMBDA,
    STATE(8455), 1,
      sym__FORALL,
    STATE(8941), 1,
      sym_expr,
    STATE(9626), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3446), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3478), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5013), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8649), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5000), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3452), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [280174] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(734), 1,
      sym_id,
    ACTIONS(738), 1,
      anon_sym_BSLASH,
    ACTIONS(740), 1,
      anon_sym_u03bb,
    ACTIONS(744), 1,
      anon_sym_record,
    ACTIONS(746), 1,
      anon_sym_LPAREN,
    ACTIONS(748), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(750), 1,
      anon_sym_u2983,
    ACTIONS(752), 1,
      anon_sym_LBRACE,
    ACTIONS(754), 1,
      aux_sym__qid_token1,
    ACTIONS(756), 1,
      anon_sym_DOT,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(762), 1,
      anon_sym_quoteGoal,
    ACTIONS(764), 1,
      anon_sym_tactic,
    ACTIONS(766), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(768), 1,
      anon_sym_u2987,
    ACTIONS(774), 1,
      anon_sym_Set,
    ACTIONS(3054), 1,
      anon_sym_let,
    STATE(3326), 1,
      aux_sym__atoms,
    STATE(3730), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5147), 1,
      sym_atom,
    STATE(6212), 1,
      sym_attributes,
    STATE(8156), 1,
      sym__LAMBDA,
    STATE(8456), 1,
      sym__FORALL,
    STATE(8948), 1,
      sym_expr,
    STATE(9596), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(736), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(772), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5108), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8641), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5102), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(742), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [280310] = 36,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(734), 1,
      sym_id,
    ACTIONS(738), 1,
      anon_sym_BSLASH,
    ACTIONS(740), 1,
      anon_sym_u03bb,
    ACTIONS(744), 1,
      anon_sym_record,
    ACTIONS(746), 1,
      anon_sym_LPAREN,
    ACTIONS(748), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(750), 1,
      anon_sym_u2983,
    ACTIONS(752), 1,
      anon_sym_LBRACE,
    ACTIONS(754), 1,
      aux_sym__qid_token1,
    ACTIONS(756), 1,
      anon_sym_DOT,
    ACTIONS(758), 1,
      anon_sym_DOT_DOT,
    ACTIONS(760), 1,
      anon_sym_AT,
    ACTIONS(762), 1,
      anon_sym_quoteGoal,
    ACTIONS(764), 1,
      anon_sym_tactic,
    ACTIONS(766), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(768), 1,
      anon_sym_u2987,
    ACTIONS(774), 1,
      anon_sym_Set,
    ACTIONS(3054), 1,
      anon_sym_let,
    STATE(3326), 1,
      aux_sym__atoms,
    STATE(3730), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5147), 1,
      sym_atom,
    STATE(6212), 1,
      sym_attributes,
    STATE(8156), 1,
      sym__LAMBDA,
    STATE(8456), 1,
      sym__FORALL,
    STATE(8939), 1,
      sym_expr,
    STATE(9596), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(736), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(772), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5108), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7725), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8641), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
    STATE(5102), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(742), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [280446] = 34,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(700), 1,
      anon_sym_LBRACE_DASH_POUND,
    ACTIONS(2964), 1,
      anon_sym_quoteGoal,
    ACTIONS(2972), 1,
      anon_sym_let,
    ACTIONS(3520), 1,
      sym_id,
    ACTIONS(3522), 1,
      anon_sym_BSLASH,
    ACTIONS(3524), 1,
      anon_sym_u03bb,
    ACTIONS(3528), 1,
      anon_sym_record,
    ACTIONS(3530), 1,
      anon_sym_LPAREN,
    ACTIONS(3532), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3534), 1,
      anon_sym_u2983,
    ACTIONS(3536), 1,
      anon_sym_LBRACE,
    ACTIONS(3538), 1,
      aux_sym__qid_token1,
    ACTIONS(3540), 1,
      anon_sym_DOT,
    ACTIONS(3542), 1,
      anon_sym_tactic,
    ACTIONS(3544), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3546), 1,
      anon_sym_u2987,
    ACTIONS(3550), 1,
      anon_sym_Set,
    STATE(2453), 1,
      sym__ARROW,
    STATE(2671), 1,
      aux_sym__lambda_clauses_repeat1,
    STATE(3308), 1,
      sym_catchall_pragma,
    STATE(3404), 1,
      aux_sym__atoms,
    STATE(5625), 1,
      sym_atom,
    STATE(8058), 1,
      sym__LAMBDA,
    STATE(8418), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2940), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2942), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(3548), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5537), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(8971), 3,
      sym__lambda_clause_maybe_absurd,
      sym_lambda_clause_absurd,
      sym_lambda_clause,
    STATE(5538), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9000), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3526), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [280577] = 37,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(986), 1,
      anon_sym_open,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3978), 1,
      anon_sym_RPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(3996), 1,
      anon_sym_let,
    ACTIONS(4000), 1,
      anon_sym_Set,
    STATE(3651), 1,
      sym_attributes,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(10938), 1,
      sym__binding_ids_and_absurds,
    STATE(11095), 1,
      sym_open,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9972), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [280714] = 37,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(986), 1,
      anon_sym_open,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3978), 1,
      anon_sym_RPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4002), 1,
      anon_sym_let,
    STATE(3351), 1,
      sym_attributes,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(11912), 1,
      sym__binding_ids_and_absurds,
    STATE(11990), 1,
      sym_open,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(10048), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [280851] = 34,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(700), 1,
      anon_sym_LBRACE_DASH_POUND,
    ACTIONS(2938), 1,
      sym_id,
    ACTIONS(2944), 1,
      anon_sym_BSLASH,
    ACTIONS(2946), 1,
      anon_sym_u03bb,
    ACTIONS(2950), 1,
      anon_sym_record,
    ACTIONS(2952), 1,
      anon_sym_LPAREN,
    ACTIONS(2954), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2956), 1,
      anon_sym_u2983,
    ACTIONS(2958), 1,
      anon_sym_LBRACE,
    ACTIONS(2960), 1,
      aux_sym__qid_token1,
    ACTIONS(2962), 1,
      anon_sym_DOT,
    ACTIONS(2964), 1,
      anon_sym_quoteGoal,
    ACTIONS(2966), 1,
      anon_sym_tactic,
    ACTIONS(2968), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2970), 1,
      anon_sym_u2987,
    ACTIONS(2972), 1,
      anon_sym_let,
    ACTIONS(2976), 1,
      anon_sym_Set,
    STATE(2453), 1,
      sym__ARROW,
    STATE(2671), 1,
      aux_sym__lambda_clauses_repeat1,
    STATE(3199), 1,
      sym_catchall_pragma,
    STATE(3546), 1,
      aux_sym__atoms,
    STATE(5967), 1,
      sym_atom,
    STATE(8126), 1,
      sym__LAMBDA,
    STATE(8418), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2940), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2942), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(2974), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5870), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(8971), 3,
      sym__lambda_clause_maybe_absurd,
      sym_lambda_clause_absurd,
      sym_lambda_clause,
    STATE(5838), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9000), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2948), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [280982] = 34,
    ACTIONS(686), 1,
      anon_sym_BSLASH,
    ACTIONS(688), 1,
      anon_sym_u03bb,
    ACTIONS(692), 1,
      anon_sym_record,
    ACTIONS(694), 1,
      anon_sym_LPAREN,
    ACTIONS(696), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(698), 1,
      anon_sym_u2983,
    ACTIONS(700), 1,
      anon_sym_LBRACE_DASH_POUND,
    ACTIONS(702), 1,
      anon_sym_LBRACE,
    ACTIONS(708), 1,
      anon_sym_DOT,
    ACTIONS(714), 1,
      anon_sym_quoteGoal,
    ACTIONS(716), 1,
      anon_sym_tactic,
    ACTIONS(718), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(720), 1,
      anon_sym_u2987,
    ACTIONS(722), 1,
      anon_sym_let,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(728), 1,
      anon_sym_Set,
    ACTIONS(2336), 1,
      sym_id,
    ACTIONS(2342), 1,
      aux_sym__qid_token1,
    STATE(2651), 1,
      sym__ARROW,
    STATE(2671), 1,
      aux_sym__lambda_clauses_repeat1,
    STATE(3132), 1,
      sym_catchall_pragma,
    STATE(3688), 1,
      aux_sym__atoms,
    STATE(5128), 1,
      sym_atom,
    STATE(8064), 1,
      sym__LAMBDA,
    STATE(8495), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(682), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(726), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(2604), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(5069), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(8966), 3,
      sym__lambda_clause_maybe_absurd,
      sym_lambda_clause_absurd,
      sym_lambda_clause,
    STATE(5056), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9459), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(690), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [281113] = 37,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(986), 1,
      anon_sym_open,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3978), 1,
      anon_sym_RPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4004), 1,
      anon_sym_let,
    STATE(3624), 1,
      sym_attributes,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(11598), 1,
      sym__binding_ids_and_absurds,
    STATE(11671), 1,
      sym_open,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(10009), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [281250] = 37,
    ACTIONS(704), 1,
      anon_sym_RPAREN,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(986), 1,
      anon_sym_open,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4006), 1,
      anon_sym_let,
    STATE(3353), 1,
      sym_attributes,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(10238), 1,
      sym__binding_ids_and_absurds,
    STATE(10295), 1,
      sym_open,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9854), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [281387] = 34,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(700), 1,
      anon_sym_LBRACE_DASH_POUND,
    ACTIONS(3090), 1,
      sym_id,
    ACTIONS(3096), 1,
      anon_sym_BSLASH,
    ACTIONS(3098), 1,
      anon_sym_u03bb,
    ACTIONS(3102), 1,
      anon_sym_record,
    ACTIONS(3104), 1,
      anon_sym_LPAREN,
    ACTIONS(3106), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3108), 1,
      anon_sym_u2983,
    ACTIONS(3110), 1,
      anon_sym_LBRACE,
    ACTIONS(3112), 1,
      aux_sym__qid_token1,
    ACTIONS(3114), 1,
      anon_sym_DOT,
    ACTIONS(3116), 1,
      anon_sym_quoteGoal,
    ACTIONS(3118), 1,
      anon_sym_tactic,
    ACTIONS(3120), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3122), 1,
      anon_sym_u2987,
    ACTIONS(3124), 1,
      anon_sym_let,
    ACTIONS(3128), 1,
      anon_sym_Set,
    STATE(1820), 1,
      sym__ARROW,
    STATE(2671), 1,
      aux_sym__lambda_clauses_repeat1,
    STATE(3319), 1,
      sym_catchall_pragma,
    STATE(3477), 1,
      aux_sym__atoms,
    STATE(4365), 1,
      sym_atom,
    STATE(8099), 1,
      sym__LAMBDA,
    STATE(8393), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3092), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3094), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(3126), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4293), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(8971), 3,
      sym__lambda_clause_maybe_absurd,
      sym_lambda_clause_absurd,
      sym_lambda_clause,
    STATE(4285), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9000), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3100), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [281518] = 37,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(732), 1,
      anon_sym_RPAREN,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(986), 1,
      anon_sym_open,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4008), 1,
      anon_sym_let,
    STATE(3538), 1,
      sym_attributes,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(10880), 1,
      sym_open,
    STATE(10911), 1,
      sym__binding_ids_and_absurds,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9729), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [281655] = 37,
    ACTIONS(704), 1,
      anon_sym_RPAREN,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(986), 1,
      anon_sym_open,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4010), 1,
      anon_sym_let,
    STATE(3457), 1,
      sym_attributes,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(10805), 1,
      sym_open,
    STATE(10841), 1,
      sym__binding_ids_and_absurds,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9701), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [281792] = 37,
    ACTIONS(704), 1,
      anon_sym_RPAREN,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(986), 1,
      anon_sym_open,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(3996), 1,
      anon_sym_let,
    ACTIONS(4000), 1,
      anon_sym_Set,
    STATE(3651), 1,
      sym_attributes,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(10938), 1,
      sym__binding_ids_and_absurds,
    STATE(11095), 1,
      sym_open,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9972), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [281929] = 34,
    ACTIONS(4012), 1,
      sym_id,
    ACTIONS(4021), 1,
      anon_sym_BSLASH,
    ACTIONS(4024), 1,
      anon_sym_u03bb,
    ACTIONS(4030), 1,
      anon_sym_record,
    ACTIONS(4033), 1,
      anon_sym_LPAREN,
    ACTIONS(4036), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4039), 1,
      anon_sym_u2983,
    ACTIONS(4042), 1,
      anon_sym_LBRACE_DASH_POUND,
    ACTIONS(4045), 1,
      anon_sym_LBRACE,
    ACTIONS(4048), 1,
      aux_sym__qid_token1,
    ACTIONS(4051), 1,
      anon_sym_DOT,
    ACTIONS(4054), 1,
      anon_sym_quoteGoal,
    ACTIONS(4057), 1,
      anon_sym_tactic,
    ACTIONS(4060), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4063), 1,
      anon_sym_u2987,
    ACTIONS(4066), 1,
      anon_sym_let,
    ACTIONS(4069), 1,
      anon_sym_do,
    ACTIONS(4075), 1,
      anon_sym_Set,
    STATE(2185), 1,
      sym__ARROW,
    STATE(2671), 1,
      aux_sym__lambda_clauses_repeat1,
    STATE(3164), 1,
      sym_catchall_pragma,
    STATE(3364), 1,
      aux_sym__atoms,
    STATE(5831), 1,
      sym_atom,
    STATE(8081), 1,
      sym__LAMBDA,
    STATE(8490), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(4015), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4018), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(4072), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5982), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(12210), 3,
      sym__lambda_clause_maybe_absurd,
      sym_lambda_clause_absurd,
      sym_lambda_clause,
    STATE(5981), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8988), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(4027), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [282060] = 34,
    ACTIONS(700), 1,
      anon_sym_LBRACE_DASH_POUND,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2448), 1,
      anon_sym_quoteGoal,
    ACTIONS(2456), 1,
      anon_sym_let,
    ACTIONS(2842), 1,
      anon_sym_BSLASH,
    ACTIONS(2844), 1,
      anon_sym_u03bb,
    ACTIONS(2862), 1,
      anon_sym_tactic,
    ACTIONS(2872), 1,
      sym_id,
    ACTIONS(2876), 1,
      anon_sym_record,
    ACTIONS(2878), 1,
      anon_sym_LPAREN,
    ACTIONS(2880), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2882), 1,
      anon_sym_u2983,
    ACTIONS(2884), 1,
      anon_sym_LBRACE,
    ACTIONS(2886), 1,
      aux_sym__qid_token1,
    ACTIONS(2888), 1,
      anon_sym_DOT,
    ACTIONS(2890), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2892), 1,
      anon_sym_u2987,
    ACTIONS(2896), 1,
      anon_sym_Set,
    STATE(2007), 1,
      sym__ARROW,
    STATE(2671), 1,
      aux_sym__lambda_clauses_repeat1,
    STATE(3134), 1,
      sym_catchall_pragma,
    STATE(3374), 1,
      aux_sym__atoms,
    STATE(4945), 1,
      sym_atom,
    STATE(8053), 1,
      sym__LAMBDA,
    STATE(8423), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2424), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2426), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(2894), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5291), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(8966), 3,
      sym__lambda_clause_maybe_absurd,
      sym_lambda_clause_absurd,
      sym_lambda_clause,
    STATE(5287), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8988), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2874), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [282191] = 37,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(986), 1,
      anon_sym_open,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3978), 1,
      anon_sym_RPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4006), 1,
      anon_sym_let,
    STATE(3353), 1,
      sym_attributes,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(10238), 1,
      sym__binding_ids_and_absurds,
    STATE(10295), 1,
      sym_open,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9854), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [282328] = 34,
    ACTIONS(700), 1,
      anon_sym_LBRACE_DASH_POUND,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(3020), 1,
      anon_sym_BSLASH,
    ACTIONS(3022), 1,
      anon_sym_u03bb,
    ACTIONS(3040), 1,
      anon_sym_quoteGoal,
    ACTIONS(3042), 1,
      anon_sym_tactic,
    ACTIONS(3048), 1,
      anon_sym_let,
    ACTIONS(3234), 1,
      sym_id,
    ACTIONS(3240), 1,
      anon_sym_record,
    ACTIONS(3242), 1,
      anon_sym_LPAREN,
    ACTIONS(3244), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3246), 1,
      anon_sym_u2983,
    ACTIONS(3248), 1,
      anon_sym_LBRACE,
    ACTIONS(3250), 1,
      aux_sym__qid_token1,
    ACTIONS(3252), 1,
      anon_sym_DOT,
    ACTIONS(3254), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3256), 1,
      anon_sym_u2987,
    ACTIONS(3260), 1,
      anon_sym_Set,
    STATE(1692), 1,
      sym__ARROW,
    STATE(2671), 1,
      aux_sym__lambda_clauses_repeat1,
    STATE(3302), 1,
      sym_catchall_pragma,
    STATE(3393), 1,
      aux_sym__atoms,
    STATE(5549), 1,
      sym_atom,
    STATE(8127), 1,
      sym__LAMBDA,
    STATE(8388), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3018), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3236), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(3258), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5387), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(8989), 3,
      sym__lambda_clause_maybe_absurd,
      sym_lambda_clause_absurd,
      sym_lambda_clause,
    STATE(5375), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8988), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3238), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [282459] = 37,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(986), 1,
      anon_sym_open,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3978), 1,
      anon_sym_RPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4010), 1,
      anon_sym_let,
    STATE(3457), 1,
      sym_attributes,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(10805), 1,
      sym_open,
    STATE(10841), 1,
      sym__binding_ids_and_absurds,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9701), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [282596] = 34,
    ACTIONS(700), 1,
      anon_sym_LBRACE_DASH_POUND,
    ACTIONS(706), 1,
      aux_sym__qid_token1,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1904), 1,
      sym_id,
    ACTIONS(1910), 1,
      anon_sym_BSLASH,
    ACTIONS(1912), 1,
      anon_sym_u03bb,
    ACTIONS(1916), 1,
      anon_sym_record,
    ACTIONS(1918), 1,
      anon_sym_LPAREN,
    ACTIONS(1920), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1922), 1,
      anon_sym_u2983,
    ACTIONS(1924), 1,
      anon_sym_LBRACE,
    ACTIONS(1926), 1,
      anon_sym_DOT,
    ACTIONS(1928), 1,
      anon_sym_quoteGoal,
    ACTIONS(1930), 1,
      anon_sym_tactic,
    ACTIONS(1932), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1934), 1,
      anon_sym_u2987,
    ACTIONS(1936), 1,
      anon_sym_let,
    ACTIONS(1940), 1,
      anon_sym_Set,
    STATE(2553), 1,
      sym__ARROW,
    STATE(2671), 1,
      aux_sym__lambda_clauses_repeat1,
    STATE(3176), 1,
      sym_catchall_pragma,
    STATE(3669), 1,
      aux_sym__atoms,
    STATE(4914), 1,
      sym_atom,
    STATE(8153), 1,
      sym__LAMBDA,
    STATE(8431), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1906), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1908), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(1938), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4675), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(8989), 3,
      sym__lambda_clause_maybe_absurd,
      sym_lambda_clause_absurd,
      sym_lambda_clause,
    STATE(4679), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8988), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1914), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [282727] = 34,
    ACTIONS(700), 1,
      anon_sym_LBRACE_DASH_POUND,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2796), 1,
      anon_sym_BSLASH,
    ACTIONS(2798), 1,
      anon_sym_u03bb,
    ACTIONS(2800), 1,
      anon_sym_quoteGoal,
    ACTIONS(2802), 1,
      anon_sym_tactic,
    ACTIONS(2804), 1,
      anon_sym_let,
    ACTIONS(3380), 1,
      sym_id,
    ACTIONS(3384), 1,
      anon_sym_record,
    ACTIONS(3386), 1,
      anon_sym_LPAREN,
    ACTIONS(3388), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3390), 1,
      anon_sym_u2983,
    ACTIONS(3392), 1,
      anon_sym_LBRACE,
    ACTIONS(3394), 1,
      aux_sym__qid_token1,
    ACTIONS(3396), 1,
      anon_sym_DOT,
    ACTIONS(3398), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3400), 1,
      anon_sym_u2987,
    ACTIONS(3404), 1,
      anon_sym_Set,
    STATE(2185), 1,
      sym__ARROW,
    STATE(2671), 1,
      aux_sym__lambda_clauses_repeat1,
    STATE(3299), 1,
      sym_catchall_pragma,
    STATE(3446), 1,
      aux_sym__atoms,
    STATE(5099), 1,
      sym_atom,
    STATE(8041), 1,
      sym__LAMBDA,
    STATE(8490), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2794), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2808), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(3402), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4937), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(8989), 3,
      sym__lambda_clause_maybe_absurd,
      sym_lambda_clause_absurd,
      sym_lambda_clause,
    STATE(4939), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8988), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3382), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [282858] = 37,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(986), 1,
      anon_sym_open,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4008), 1,
      anon_sym_let,
    ACTIONS(4078), 1,
      anon_sym_RPAREN,
    STATE(3538), 1,
      sym_attributes,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(10880), 1,
      sym_open,
    STATE(10911), 1,
      sym__binding_ids_and_absurds,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9729), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [282995] = 37,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(732), 1,
      anon_sym_RPAREN,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(986), 1,
      anon_sym_open,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4080), 1,
      anon_sym_let,
    STATE(3458), 1,
      sym_attributes,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(11154), 1,
      sym__binding_ids_and_absurds,
    STATE(11174), 1,
      sym_open,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9870), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [283132] = 34,
    ACTIONS(700), 1,
      anon_sym_LBRACE_DASH_POUND,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(2676), 1,
      anon_sym_quoteGoal,
    ACTIONS(2684), 1,
      anon_sym_let,
    ACTIONS(2806), 1,
      sym_id,
    ACTIONS(2816), 1,
      anon_sym_record,
    ACTIONS(2818), 1,
      anon_sym_LPAREN,
    ACTIONS(2820), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2822), 1,
      anon_sym_u2983,
    ACTIONS(2824), 1,
      anon_sym_LBRACE,
    ACTIONS(2826), 1,
      aux_sym__qid_token1,
    ACTIONS(2828), 1,
      anon_sym_DOT,
    ACTIONS(2832), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2834), 1,
      anon_sym_u2987,
    ACTIONS(2838), 1,
      anon_sym_Set,
    ACTIONS(3906), 1,
      anon_sym_BSLASH,
    ACTIONS(3908), 1,
      anon_sym_u03bb,
    ACTIONS(3910), 1,
      anon_sym_tactic,
    STATE(2460), 1,
      sym__ARROW,
    STATE(2671), 1,
      aux_sym__lambda_clauses_repeat1,
    STATE(3229), 1,
      sym_catchall_pragma,
    STATE(3596), 1,
      aux_sym__atoms,
    STATE(5831), 1,
      sym_atom,
    STATE(8086), 1,
      sym__LAMBDA,
    STATE(8470), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(684), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(2654), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2836), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5982), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(8989), 3,
      sym__lambda_clause_maybe_absurd,
      sym_lambda_clause_absurd,
      sym_lambda_clause,
    STATE(5981), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9459), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2814), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [283263] = 37,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(986), 1,
      anon_sym_open,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4078), 1,
      anon_sym_RPAREN,
    ACTIONS(4082), 1,
      anon_sym_let,
    STATE(3509), 1,
      sym_attributes,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(10492), 1,
      sym_open,
    STATE(10529), 1,
      sym__binding_ids_and_absurds,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9772), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [283400] = 37,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(732), 1,
      anon_sym_RPAREN,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(986), 1,
      anon_sym_open,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4084), 1,
      anon_sym_let,
    STATE(3377), 1,
      sym_attributes,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(10386), 1,
      sym__binding_ids_and_absurds,
    STATE(10415), 1,
      sym_open,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9792), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [283537] = 37,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(986), 1,
      anon_sym_open,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4078), 1,
      anon_sym_RPAREN,
    ACTIONS(4080), 1,
      anon_sym_let,
    STATE(3458), 1,
      sym_attributes,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(11154), 1,
      sym__binding_ids_and_absurds,
    STATE(11174), 1,
      sym_open,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9870), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [283674] = 34,
    ACTIONS(700), 1,
      anon_sym_LBRACE_DASH_POUND,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(3020), 1,
      anon_sym_BSLASH,
    ACTIONS(3022), 1,
      anon_sym_u03bb,
    ACTIONS(3040), 1,
      anon_sym_quoteGoal,
    ACTIONS(3042), 1,
      anon_sym_tactic,
    ACTIONS(3048), 1,
      anon_sym_let,
    ACTIONS(3234), 1,
      sym_id,
    ACTIONS(3240), 1,
      anon_sym_record,
    ACTIONS(3242), 1,
      anon_sym_LPAREN,
    ACTIONS(3244), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3246), 1,
      anon_sym_u2983,
    ACTIONS(3248), 1,
      anon_sym_LBRACE,
    ACTIONS(3250), 1,
      aux_sym__qid_token1,
    ACTIONS(3252), 1,
      anon_sym_DOT,
    ACTIONS(3254), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3256), 1,
      anon_sym_u2987,
    ACTIONS(3260), 1,
      anon_sym_Set,
    STATE(1692), 1,
      sym__ARROW,
    STATE(2671), 1,
      aux_sym__lambda_clauses_repeat1,
    STATE(3302), 1,
      sym_catchall_pragma,
    STATE(3393), 1,
      aux_sym__atoms,
    STATE(5549), 1,
      sym_atom,
    STATE(8127), 1,
      sym__LAMBDA,
    STATE(8388), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3018), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3236), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(3258), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5387), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(8966), 3,
      sym__lambda_clause_maybe_absurd,
      sym_lambda_clause_absurd,
      sym_lambda_clause,
    STATE(5375), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8988), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3238), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [283805] = 37,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(986), 1,
      anon_sym_open,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4078), 1,
      anon_sym_RPAREN,
    ACTIONS(4086), 1,
      anon_sym_let,
    STATE(3423), 1,
      sym_attributes,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(10766), 1,
      sym_open,
    STATE(10803), 1,
      sym__binding_ids_and_absurds,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9713), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [283942] = 37,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(986), 1,
      anon_sym_open,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3978), 1,
      anon_sym_RPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4088), 1,
      anon_sym_let,
    STATE(3531), 1,
      sym_attributes,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(11097), 1,
      sym__binding_ids_and_absurds,
    STATE(11277), 1,
      sym_open,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9979), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [284079] = 37,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(732), 1,
      anon_sym_RPAREN,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(986), 1,
      anon_sym_open,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4082), 1,
      anon_sym_let,
    STATE(3509), 1,
      sym_attributes,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(10492), 1,
      sym_open,
    STATE(10529), 1,
      sym__binding_ids_and_absurds,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9772), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [284216] = 37,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(730), 1,
      anon_sym_RPAREN,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(986), 1,
      anon_sym_open,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4090), 1,
      anon_sym_let,
    STATE(3615), 1,
      sym_attributes,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(10454), 1,
      sym_open,
    STATE(10491), 1,
      sym__binding_ids_and_absurds,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9783), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [284353] = 37,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(986), 1,
      anon_sym_open,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4090), 1,
      anon_sym_let,
    ACTIONS(4092), 1,
      anon_sym_RPAREN,
    STATE(3615), 1,
      sym_attributes,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(10454), 1,
      sym_open,
    STATE(10491), 1,
      sym__binding_ids_and_absurds,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9783), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [284490] = 37,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(986), 1,
      anon_sym_open,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3978), 1,
      anon_sym_RPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4094), 1,
      anon_sym_let,
    STATE(3566), 1,
      sym_attributes,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(10338), 1,
      sym_open,
    STATE(10375), 1,
      sym__binding_ids_and_absurds,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9813), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [284627] = 37,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(986), 1,
      anon_sym_open,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4086), 1,
      anon_sym_let,
    ACTIONS(4092), 1,
      anon_sym_RPAREN,
    STATE(3423), 1,
      sym_attributes,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(10766), 1,
      sym_open,
    STATE(10803), 1,
      sym__binding_ids_and_absurds,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9713), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [284764] = 34,
    ACTIONS(700), 1,
      anon_sym_LBRACE_DASH_POUND,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2022), 1,
      anon_sym_BSLASH,
    ACTIONS(2024), 1,
      anon_sym_u03bb,
    ACTIONS(2042), 1,
      anon_sym_quoteGoal,
    ACTIONS(2044), 1,
      anon_sym_tactic,
    ACTIONS(2050), 1,
      anon_sym_let,
    ACTIONS(2766), 1,
      sym_id,
    ACTIONS(2772), 1,
      anon_sym_record,
    ACTIONS(2774), 1,
      anon_sym_LPAREN,
    ACTIONS(2776), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2778), 1,
      anon_sym_u2983,
    ACTIONS(2780), 1,
      anon_sym_LBRACE,
    ACTIONS(2782), 1,
      aux_sym__qid_token1,
    ACTIONS(2784), 1,
      anon_sym_DOT,
    ACTIONS(2786), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2788), 1,
      anon_sym_u2987,
    ACTIONS(2792), 1,
      anon_sym_Set,
    STATE(1522), 1,
      sym__ARROW,
    STATE(2671), 1,
      aux_sym__lambda_clauses_repeat1,
    STATE(3130), 1,
      sym_catchall_pragma,
    STATE(3637), 1,
      aux_sym__atoms,
    STATE(5719), 1,
      sym_atom,
    STATE(8033), 1,
      sym__LAMBDA,
    STATE(8463), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2020), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2768), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(2790), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5666), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(8989), 3,
      sym__lambda_clause_maybe_absurd,
      sym_lambda_clause_absurd,
      sym_lambda_clause,
    STATE(5668), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8988), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2770), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [284895] = 34,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(700), 1,
      anon_sym_LBRACE_DASH_POUND,
    ACTIONS(2938), 1,
      sym_id,
    ACTIONS(2944), 1,
      anon_sym_BSLASH,
    ACTIONS(2946), 1,
      anon_sym_u03bb,
    ACTIONS(2950), 1,
      anon_sym_record,
    ACTIONS(2952), 1,
      anon_sym_LPAREN,
    ACTIONS(2954), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2956), 1,
      anon_sym_u2983,
    ACTIONS(2958), 1,
      anon_sym_LBRACE,
    ACTIONS(2960), 1,
      aux_sym__qid_token1,
    ACTIONS(2962), 1,
      anon_sym_DOT,
    ACTIONS(2964), 1,
      anon_sym_quoteGoal,
    ACTIONS(2966), 1,
      anon_sym_tactic,
    ACTIONS(2968), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2970), 1,
      anon_sym_u2987,
    ACTIONS(2972), 1,
      anon_sym_let,
    ACTIONS(2976), 1,
      anon_sym_Set,
    STATE(2453), 1,
      sym__ARROW,
    STATE(2671), 1,
      aux_sym__lambda_clauses_repeat1,
    STATE(3199), 1,
      sym_catchall_pragma,
    STATE(3546), 1,
      aux_sym__atoms,
    STATE(5967), 1,
      sym_atom,
    STATE(8126), 1,
      sym__LAMBDA,
    STATE(8418), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2940), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2942), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(2974), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5870), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(8963), 3,
      sym__lambda_clause_maybe_absurd,
      sym_lambda_clause_absurd,
      sym_lambda_clause,
    STATE(5838), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9000), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2948), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [285026] = 37,
    ACTIONS(704), 1,
      anon_sym_RPAREN,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(986), 1,
      anon_sym_open,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4004), 1,
      anon_sym_let,
    STATE(3624), 1,
      sym_attributes,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(11598), 1,
      sym__binding_ids_and_absurds,
    STATE(11671), 1,
      sym_open,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(10009), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [285163] = 34,
    ACTIONS(700), 1,
      anon_sym_LBRACE_DASH_POUND,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2134), 1,
      sym_id,
    ACTIONS(2140), 1,
      anon_sym_BSLASH,
    ACTIONS(2142), 1,
      anon_sym_u03bb,
    ACTIONS(2146), 1,
      anon_sym_record,
    ACTIONS(2148), 1,
      anon_sym_LPAREN,
    ACTIONS(2150), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2152), 1,
      anon_sym_u2983,
    ACTIONS(2154), 1,
      anon_sym_LBRACE,
    ACTIONS(2156), 1,
      aux_sym__qid_token1,
    ACTIONS(2158), 1,
      anon_sym_DOT,
    ACTIONS(2160), 1,
      anon_sym_quoteGoal,
    ACTIONS(2162), 1,
      anon_sym_tactic,
    ACTIONS(2164), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2166), 1,
      anon_sym_u2987,
    ACTIONS(2168), 1,
      anon_sym_let,
    ACTIONS(2172), 1,
      anon_sym_Set,
    STATE(1614), 1,
      sym__ARROW,
    STATE(2671), 1,
      aux_sym__lambda_clauses_repeat1,
    STATE(3213), 1,
      sym_catchall_pragma,
    STATE(3482), 1,
      aux_sym__atoms,
    STATE(5718), 1,
      sym_atom,
    STATE(8040), 1,
      sym__LAMBDA,
    STATE(8460), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2136), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2138), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(2170), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5624), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(8989), 3,
      sym__lambda_clause_maybe_absurd,
      sym_lambda_clause_absurd,
      sym_lambda_clause,
    STATE(5627), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8988), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2144), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [285294] = 34,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(700), 1,
      anon_sym_LBRACE_DASH_POUND,
    ACTIONS(2694), 1,
      anon_sym_BSLASH,
    ACTIONS(2696), 1,
      anon_sym_u03bb,
    ACTIONS(2714), 1,
      anon_sym_quoteGoal,
    ACTIONS(2716), 1,
      anon_sym_tactic,
    ACTIONS(2722), 1,
      anon_sym_let,
    ACTIONS(3878), 1,
      sym_id,
    ACTIONS(3884), 1,
      anon_sym_record,
    ACTIONS(3886), 1,
      anon_sym_LPAREN,
    ACTIONS(3888), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3890), 1,
      anon_sym_u2983,
    ACTIONS(3892), 1,
      anon_sym_LBRACE,
    ACTIONS(3894), 1,
      aux_sym__qid_token1,
    ACTIONS(3896), 1,
      anon_sym_DOT,
    ACTIONS(3898), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3900), 1,
      anon_sym_u2987,
    ACTIONS(3904), 1,
      anon_sym_Set,
    STATE(1543), 1,
      sym__ARROW,
    STATE(2671), 1,
      aux_sym__lambda_clauses_repeat1,
    STATE(3307), 1,
      sym_catchall_pragma,
    STATE(3554), 1,
      aux_sym__atoms,
    STATE(4243), 1,
      sym_atom,
    STATE(8133), 1,
      sym__LAMBDA,
    STATE(8368), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2692), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3880), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(3902), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4214), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(8971), 3,
      sym__lambda_clause_maybe_absurd,
      sym_lambda_clause_absurd,
      sym_lambda_clause,
    STATE(4218), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9000), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3882), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [285425] = 37,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(730), 1,
      anon_sym_RPAREN,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(986), 1,
      anon_sym_open,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4096), 1,
      anon_sym_let,
    STATE(3386), 1,
      sym_attributes,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(10445), 1,
      sym__binding_ids_and_absurds,
    STATE(10486), 1,
      sym_open,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9886), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [285562] = 37,
    ACTIONS(704), 1,
      anon_sym_RPAREN,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(986), 1,
      anon_sym_open,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4098), 1,
      anon_sym_let,
    STATE(3681), 1,
      sym_attributes,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(10300), 1,
      sym_open,
    STATE(10334), 1,
      sym__binding_ids_and_absurds,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9819), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [285699] = 37,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(732), 1,
      anon_sym_RPAREN,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(986), 1,
      anon_sym_open,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4086), 1,
      anon_sym_let,
    STATE(3423), 1,
      sym_attributes,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(10766), 1,
      sym_open,
    STATE(10803), 1,
      sym__binding_ids_and_absurds,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9713), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [285836] = 37,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(986), 1,
      anon_sym_open,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4078), 1,
      anon_sym_RPAREN,
    ACTIONS(4100), 1,
      anon_sym_let,
    STATE(3436), 1,
      sym_attributes,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(10683), 1,
      sym__binding_ids_and_absurds,
    STATE(10767), 1,
      sym_open,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9960), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [285973] = 34,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(700), 1,
      anon_sym_LBRACE_DASH_POUND,
    ACTIONS(2526), 1,
      sym_id,
    ACTIONS(2532), 1,
      anon_sym_BSLASH,
    ACTIONS(2534), 1,
      anon_sym_u03bb,
    ACTIONS(2538), 1,
      anon_sym_record,
    ACTIONS(2540), 1,
      anon_sym_LPAREN,
    ACTIONS(2542), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2544), 1,
      anon_sym_u2983,
    ACTIONS(2546), 1,
      anon_sym_LBRACE,
    ACTIONS(2548), 1,
      aux_sym__qid_token1,
    ACTIONS(2550), 1,
      anon_sym_DOT,
    ACTIONS(2552), 1,
      anon_sym_quoteGoal,
    ACTIONS(2554), 1,
      anon_sym_tactic,
    ACTIONS(2556), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2558), 1,
      anon_sym_u2987,
    ACTIONS(2560), 1,
      anon_sym_let,
    ACTIONS(2564), 1,
      anon_sym_Set,
    STATE(1938), 1,
      sym__ARROW,
    STATE(2671), 1,
      aux_sym__lambda_clauses_repeat1,
    STATE(3281), 1,
      sym_catchall_pragma,
    STATE(3610), 1,
      aux_sym__atoms,
    STATE(4603), 1,
      sym_atom,
    STATE(8066), 1,
      sym__LAMBDA,
    STATE(8398), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2528), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2530), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(2562), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4464), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(8971), 3,
      sym__lambda_clause_maybe_absurd,
      sym_lambda_clause_absurd,
      sym_lambda_clause,
    STATE(4473), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9000), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2536), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [286104] = 37,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(986), 1,
      anon_sym_open,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3978), 1,
      anon_sym_RPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4102), 1,
      anon_sym_let,
    STATE(3557), 1,
      sym_attributes,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(11139), 1,
      sym_open,
    STATE(11173), 1,
      sym__binding_ids_and_absurds,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9859), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [286241] = 37,
    ACTIONS(704), 1,
      anon_sym_RPAREN,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(986), 1,
      anon_sym_open,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4002), 1,
      anon_sym_let,
    STATE(3351), 1,
      sym_attributes,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(11912), 1,
      sym__binding_ids_and_absurds,
    STATE(11990), 1,
      sym_open,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(10048), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [286378] = 37,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(730), 1,
      anon_sym_RPAREN,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(986), 1,
      anon_sym_open,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4086), 1,
      anon_sym_let,
    STATE(3423), 1,
      sym_attributes,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(10766), 1,
      sym_open,
    STATE(10803), 1,
      sym__binding_ids_and_absurds,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9713), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [286515] = 34,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(700), 1,
      anon_sym_LBRACE_DASH_POUND,
    ACTIONS(2350), 1,
      anon_sym_BSLASH,
    ACTIONS(2352), 1,
      anon_sym_u03bb,
    ACTIONS(2370), 1,
      anon_sym_quoteGoal,
    ACTIONS(2372), 1,
      anon_sym_tactic,
    ACTIONS(2378), 1,
      anon_sym_let,
    ACTIONS(3786), 1,
      sym_id,
    ACTIONS(3792), 1,
      anon_sym_record,
    ACTIONS(3794), 1,
      anon_sym_LPAREN,
    ACTIONS(3796), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3798), 1,
      anon_sym_u2983,
    ACTIONS(3800), 1,
      anon_sym_LBRACE,
    ACTIONS(3802), 1,
      aux_sym__qid_token1,
    ACTIONS(3804), 1,
      anon_sym_DOT,
    ACTIONS(3806), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3808), 1,
      anon_sym_u2987,
    ACTIONS(3812), 1,
      anon_sym_Set,
    STATE(1464), 1,
      sym__ARROW,
    STATE(2671), 1,
      aux_sym__lambda_clauses_repeat1,
    STATE(3247), 1,
      sym_catchall_pragma,
    STATE(3680), 1,
      aux_sym__atoms,
    STATE(4255), 1,
      sym_atom,
    STATE(8119), 1,
      sym__LAMBDA,
    STATE(8372), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2348), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3788), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(3810), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4284), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(8971), 3,
      sym__lambda_clause_maybe_absurd,
      sym_lambda_clause_absurd,
      sym_lambda_clause,
    STATE(4282), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9000), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3790), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [286646] = 37,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(986), 1,
      anon_sym_open,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3978), 1,
      anon_sym_RPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4104), 1,
      anon_sym_let,
    STATE(3545), 1,
      sym_attributes,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(10239), 1,
      sym_open,
    STATE(10261), 1,
      sym__binding_ids_and_absurds,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9839), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [286783] = 37,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(732), 1,
      anon_sym_RPAREN,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(986), 1,
      anon_sym_open,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4106), 1,
      anon_sym_let,
    STATE(3569), 1,
      sym_attributes,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(11472), 1,
      sym__binding_ids_and_absurds,
    STATE(11597), 1,
      sym_open,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9996), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [286920] = 37,
    ACTIONS(704), 1,
      anon_sym_RPAREN,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(986), 1,
      anon_sym_open,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4094), 1,
      anon_sym_let,
    STATE(3566), 1,
      sym_attributes,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(10338), 1,
      sym_open,
    STATE(10375), 1,
      sym__binding_ids_and_absurds,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9813), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [287057] = 37,
    ACTIONS(704), 1,
      anon_sym_RPAREN,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(986), 1,
      anon_sym_open,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4108), 1,
      anon_sym_let,
    STATE(3525), 1,
      sym_attributes,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(10686), 1,
      sym_open,
    STATE(10727), 1,
      sym__binding_ids_and_absurds,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9734), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [287194] = 34,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(700), 1,
      anon_sym_LBRACE_DASH_POUND,
    ACTIONS(3168), 1,
      sym_id,
    ACTIONS(3174), 1,
      anon_sym_BSLASH,
    ACTIONS(3176), 1,
      anon_sym_u03bb,
    ACTIONS(3180), 1,
      anon_sym_record,
    ACTIONS(3182), 1,
      anon_sym_LPAREN,
    ACTIONS(3184), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3186), 1,
      anon_sym_u2983,
    ACTIONS(3188), 1,
      anon_sym_LBRACE,
    ACTIONS(3190), 1,
      aux_sym__qid_token1,
    ACTIONS(3192), 1,
      anon_sym_DOT,
    ACTIONS(3194), 1,
      anon_sym_quoteGoal,
    ACTIONS(3196), 1,
      anon_sym_tactic,
    ACTIONS(3198), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3200), 1,
      anon_sym_u2987,
    ACTIONS(3202), 1,
      anon_sym_let,
    ACTIONS(3206), 1,
      anon_sym_Set,
    STATE(2310), 1,
      sym__ARROW,
    STATE(2671), 1,
      aux_sym__lambda_clauses_repeat1,
    STATE(3226), 1,
      sym_catchall_pragma,
    STATE(3553), 1,
      aux_sym__atoms,
    STATE(5142), 1,
      sym_atom,
    STATE(8051), 1,
      sym__LAMBDA,
    STATE(8409), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3170), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3172), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(3204), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4934), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(8971), 3,
      sym__lambda_clause_maybe_absurd,
      sym_lambda_clause_absurd,
      sym_lambda_clause,
    STATE(4921), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9000), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3178), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [287325] = 37,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(986), 1,
      anon_sym_open,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4078), 1,
      anon_sym_RPAREN,
    ACTIONS(4106), 1,
      anon_sym_let,
    STATE(3569), 1,
      sym_attributes,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(11472), 1,
      sym__binding_ids_and_absurds,
    STATE(11597), 1,
      sym_open,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9996), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [287462] = 37,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(732), 1,
      anon_sym_RPAREN,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(986), 1,
      anon_sym_open,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4110), 1,
      anon_sym_let,
    STATE(3439), 1,
      sym_attributes,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(11316), 1,
      sym_open,
    STATE(11352), 1,
      sym__binding_ids_and_absurds,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9952), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [287599] = 37,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(986), 1,
      anon_sym_open,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4078), 1,
      anon_sym_RPAREN,
    ACTIONS(4112), 1,
      anon_sym_let,
    STATE(3678), 1,
      sym_attributes,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(10258), 1,
      sym__binding_ids_and_absurds,
    STATE(10339), 1,
      sym_open,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9858), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [287736] = 34,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(700), 1,
      anon_sym_LBRACE_DASH_POUND,
    ACTIONS(2694), 1,
      anon_sym_BSLASH,
    ACTIONS(2696), 1,
      anon_sym_u03bb,
    ACTIONS(2714), 1,
      anon_sym_quoteGoal,
    ACTIONS(2716), 1,
      anon_sym_tactic,
    ACTIONS(2722), 1,
      anon_sym_let,
    ACTIONS(3878), 1,
      sym_id,
    ACTIONS(3884), 1,
      anon_sym_record,
    ACTIONS(3886), 1,
      anon_sym_LPAREN,
    ACTIONS(3888), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3890), 1,
      anon_sym_u2983,
    ACTIONS(3892), 1,
      anon_sym_LBRACE,
    ACTIONS(3894), 1,
      aux_sym__qid_token1,
    ACTIONS(3896), 1,
      anon_sym_DOT,
    ACTIONS(3898), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3900), 1,
      anon_sym_u2987,
    ACTIONS(3904), 1,
      anon_sym_Set,
    STATE(1543), 1,
      sym__ARROW,
    STATE(2671), 1,
      aux_sym__lambda_clauses_repeat1,
    STATE(3307), 1,
      sym_catchall_pragma,
    STATE(3554), 1,
      aux_sym__atoms,
    STATE(4243), 1,
      sym_atom,
    STATE(8133), 1,
      sym__LAMBDA,
    STATE(8368), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2692), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3880), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(3902), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4214), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(8963), 3,
      sym__lambda_clause_maybe_absurd,
      sym_lambda_clause_absurd,
      sym_lambda_clause,
    STATE(4218), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9000), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3882), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [287867] = 37,
    ACTIONS(704), 1,
      anon_sym_RPAREN,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(986), 1,
      anon_sym_open,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4102), 1,
      anon_sym_let,
    STATE(3557), 1,
      sym_attributes,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(11139), 1,
      sym_open,
    STATE(11173), 1,
      sym__binding_ids_and_absurds,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9859), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [288004] = 34,
    ACTIONS(700), 1,
      anon_sym_LBRACE_DASH_POUND,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2134), 1,
      sym_id,
    ACTIONS(2140), 1,
      anon_sym_BSLASH,
    ACTIONS(2142), 1,
      anon_sym_u03bb,
    ACTIONS(2146), 1,
      anon_sym_record,
    ACTIONS(2148), 1,
      anon_sym_LPAREN,
    ACTIONS(2150), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2152), 1,
      anon_sym_u2983,
    ACTIONS(2154), 1,
      anon_sym_LBRACE,
    ACTIONS(2156), 1,
      aux_sym__qid_token1,
    ACTIONS(2158), 1,
      anon_sym_DOT,
    ACTIONS(2160), 1,
      anon_sym_quoteGoal,
    ACTIONS(2162), 1,
      anon_sym_tactic,
    ACTIONS(2164), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2166), 1,
      anon_sym_u2987,
    ACTIONS(2168), 1,
      anon_sym_let,
    ACTIONS(2172), 1,
      anon_sym_Set,
    STATE(1614), 1,
      sym__ARROW,
    STATE(2671), 1,
      aux_sym__lambda_clauses_repeat1,
    STATE(3213), 1,
      sym_catchall_pragma,
    STATE(3482), 1,
      aux_sym__atoms,
    STATE(5718), 1,
      sym_atom,
    STATE(8040), 1,
      sym__LAMBDA,
    STATE(8460), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2136), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2138), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(2170), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5624), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(8966), 3,
      sym__lambda_clause_maybe_absurd,
      sym_lambda_clause_absurd,
      sym_lambda_clause,
    STATE(5627), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8988), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2144), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [288135] = 34,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(700), 1,
      anon_sym_LBRACE_DASH_POUND,
    ACTIONS(3168), 1,
      sym_id,
    ACTIONS(3174), 1,
      anon_sym_BSLASH,
    ACTIONS(3176), 1,
      anon_sym_u03bb,
    ACTIONS(3180), 1,
      anon_sym_record,
    ACTIONS(3182), 1,
      anon_sym_LPAREN,
    ACTIONS(3184), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3186), 1,
      anon_sym_u2983,
    ACTIONS(3188), 1,
      anon_sym_LBRACE,
    ACTIONS(3190), 1,
      aux_sym__qid_token1,
    ACTIONS(3192), 1,
      anon_sym_DOT,
    ACTIONS(3194), 1,
      anon_sym_quoteGoal,
    ACTIONS(3196), 1,
      anon_sym_tactic,
    ACTIONS(3198), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3200), 1,
      anon_sym_u2987,
    ACTIONS(3202), 1,
      anon_sym_let,
    ACTIONS(3206), 1,
      anon_sym_Set,
    STATE(2310), 1,
      sym__ARROW,
    STATE(2671), 1,
      aux_sym__lambda_clauses_repeat1,
    STATE(3226), 1,
      sym_catchall_pragma,
    STATE(3553), 1,
      aux_sym__atoms,
    STATE(5142), 1,
      sym_atom,
    STATE(8051), 1,
      sym__LAMBDA,
    STATE(8409), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3170), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3172), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(3204), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4934), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(8963), 3,
      sym__lambda_clause_maybe_absurd,
      sym_lambda_clause_absurd,
      sym_lambda_clause,
    STATE(4921), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9000), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3178), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [288266] = 37,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(986), 1,
      anon_sym_open,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4078), 1,
      anon_sym_RPAREN,
    ACTIONS(4114), 1,
      anon_sym_let,
    STATE(3679), 1,
      sym_attributes,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(11208), 1,
      sym_open,
    STATE(11244), 1,
      sym__binding_ids_and_absurds,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9889), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [288403] = 37,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(986), 1,
      anon_sym_open,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4078), 1,
      anon_sym_RPAREN,
    ACTIONS(4084), 1,
      anon_sym_let,
    STATE(3377), 1,
      sym_attributes,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(10386), 1,
      sym__binding_ids_and_absurds,
    STATE(10415), 1,
      sym_open,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9792), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [288540] = 37,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(732), 1,
      anon_sym_RPAREN,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(986), 1,
      anon_sym_open,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4114), 1,
      anon_sym_let,
    STATE(3679), 1,
      sym_attributes,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(11208), 1,
      sym_open,
    STATE(11244), 1,
      sym__binding_ids_and_absurds,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9889), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [288677] = 37,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(986), 1,
      anon_sym_open,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3978), 1,
      anon_sym_RPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4116), 1,
      anon_sym_let,
    STATE(3426), 1,
      sym_attributes,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(10623), 1,
      sym__binding_ids_and_absurds,
    STATE(10681), 1,
      sym_open,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9954), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [288814] = 34,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(700), 1,
      anon_sym_LBRACE_DASH_POUND,
    ACTIONS(2898), 1,
      sym_id,
    ACTIONS(2904), 1,
      anon_sym_BSLASH,
    ACTIONS(2906), 1,
      anon_sym_u03bb,
    ACTIONS(2910), 1,
      anon_sym_record,
    ACTIONS(2912), 1,
      anon_sym_LPAREN,
    ACTIONS(2914), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2916), 1,
      anon_sym_u2983,
    ACTIONS(2918), 1,
      anon_sym_LBRACE,
    ACTIONS(2920), 1,
      aux_sym__qid_token1,
    ACTIONS(2922), 1,
      anon_sym_DOT,
    ACTIONS(2924), 1,
      anon_sym_quoteGoal,
    ACTIONS(2926), 1,
      anon_sym_tactic,
    ACTIONS(2928), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2930), 1,
      anon_sym_u2987,
    ACTIONS(2932), 1,
      anon_sym_let,
    ACTIONS(2936), 1,
      anon_sym_Set,
    STATE(1742), 1,
      sym__ARROW,
    STATE(2671), 1,
      aux_sym__lambda_clauses_repeat1,
    STATE(3327), 1,
      sym_catchall_pragma,
    STATE(3387), 1,
      aux_sym__atoms,
    STATE(4154), 1,
      sym_atom,
    STATE(8094), 1,
      sym__LAMBDA,
    STATE(8489), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2900), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2902), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(2934), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4184), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(8971), 3,
      sym__lambda_clause_maybe_absurd,
      sym_lambda_clause_absurd,
      sym_lambda_clause,
    STATE(4206), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9000), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2908), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [288945] = 34,
    ACTIONS(692), 1,
      anon_sym_record,
    ACTIONS(694), 1,
      anon_sym_LPAREN,
    ACTIONS(696), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(698), 1,
      anon_sym_u2983,
    ACTIONS(700), 1,
      anon_sym_LBRACE_DASH_POUND,
    ACTIONS(702), 1,
      anon_sym_LBRACE,
    ACTIONS(708), 1,
      anon_sym_DOT,
    ACTIONS(718), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(720), 1,
      anon_sym_u2987,
    ACTIONS(728), 1,
      anon_sym_Set,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1928), 1,
      anon_sym_quoteGoal,
    ACTIONS(1936), 1,
      anon_sym_let,
    ACTIONS(2336), 1,
      sym_id,
    ACTIONS(2338), 1,
      anon_sym_BSLASH,
    ACTIONS(2340), 1,
      anon_sym_u03bb,
    ACTIONS(2342), 1,
      aux_sym__qid_token1,
    ACTIONS(2344), 1,
      anon_sym_tactic,
    STATE(2553), 1,
      sym__ARROW,
    STATE(2671), 1,
      aux_sym__lambda_clauses_repeat1,
    STATE(3309), 1,
      sym_catchall_pragma,
    STATE(3416), 1,
      aux_sym__atoms,
    STATE(5128), 1,
      sym_atom,
    STATE(8079), 1,
      sym__LAMBDA,
    STATE(8431), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(726), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1906), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1908), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(5069), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(8989), 3,
      sym__lambda_clause_maybe_absurd,
      sym_lambda_clause_absurd,
      sym_lambda_clause,
    STATE(5056), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8988), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(690), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [289076] = 34,
    ACTIONS(700), 1,
      anon_sym_LBRACE_DASH_POUND,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1916), 1,
      anon_sym_record,
    ACTIONS(1918), 1,
      anon_sym_LPAREN,
    ACTIONS(1920), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1922), 1,
      anon_sym_u2983,
    ACTIONS(1924), 1,
      anon_sym_LBRACE,
    ACTIONS(1932), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1934), 1,
      anon_sym_u2987,
    ACTIONS(2120), 1,
      anon_sym_quoteGoal,
    ACTIONS(2128), 1,
      anon_sym_let,
    ACTIONS(2176), 1,
      anon_sym_BSLASH,
    ACTIONS(2178), 1,
      anon_sym_u03bb,
    ACTIONS(2196), 1,
      anon_sym_tactic,
    ACTIONS(2606), 1,
      sym_id,
    ACTIONS(2608), 1,
      aux_sym__qid_token1,
    ACTIONS(2610), 1,
      anon_sym_DOT,
    ACTIONS(2612), 1,
      anon_sym_Set,
    STATE(1489), 1,
      sym__ARROW,
    STATE(2671), 1,
      aux_sym__lambda_clauses_repeat1,
    STATE(3135), 1,
      sym_catchall_pragma,
    STATE(3507), 1,
      aux_sym__atoms,
    STATE(4914), 1,
      sym_atom,
    STATE(8044), 1,
      sym__LAMBDA,
    STATE(8428), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1938), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(2096), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2098), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(4675), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(9431), 3,
      sym__lambda_clause_maybe_absurd,
      sym_lambda_clause_absurd,
      sym_lambda_clause,
    STATE(4679), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8988), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1914), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [289207] = 34,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(700), 1,
      anon_sym_LBRACE_DASH_POUND,
    ACTIONS(2732), 1,
      anon_sym_BSLASH,
    ACTIONS(2734), 1,
      anon_sym_u03bb,
    ACTIONS(2752), 1,
      anon_sym_quoteGoal,
    ACTIONS(2754), 1,
      anon_sym_tactic,
    ACTIONS(2760), 1,
      anon_sym_let,
    ACTIONS(3610), 1,
      sym_id,
    ACTIONS(3616), 1,
      anon_sym_record,
    ACTIONS(3618), 1,
      anon_sym_LPAREN,
    ACTIONS(3620), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3622), 1,
      anon_sym_u2983,
    ACTIONS(3624), 1,
      anon_sym_LBRACE,
    ACTIONS(3626), 1,
      aux_sym__qid_token1,
    ACTIONS(3628), 1,
      anon_sym_DOT,
    ACTIONS(3630), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3632), 1,
      anon_sym_u2987,
    ACTIONS(3636), 1,
      anon_sym_Set,
    STATE(1572), 1,
      sym__ARROW,
    STATE(2671), 1,
      aux_sym__lambda_clauses_repeat1,
    STATE(3190), 1,
      sym_catchall_pragma,
    STATE(3429), 1,
      aux_sym__atoms,
    STATE(5352), 1,
      sym_atom,
    STATE(8061), 1,
      sym__LAMBDA,
    STATE(8384), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2730), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3612), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(3634), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5254), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(8971), 3,
      sym__lambda_clause_maybe_absurd,
      sym_lambda_clause_absurd,
      sym_lambda_clause,
    STATE(5242), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9000), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3614), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [289338] = 37,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(732), 1,
      anon_sym_RPAREN,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(986), 1,
      anon_sym_open,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4112), 1,
      anon_sym_let,
    STATE(3678), 1,
      sym_attributes,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(10258), 1,
      sym__binding_ids_and_absurds,
    STATE(10339), 1,
      sym_open,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9858), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [289475] = 37,
    ACTIONS(704), 1,
      anon_sym_RPAREN,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(986), 1,
      anon_sym_open,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4116), 1,
      anon_sym_let,
    STATE(3426), 1,
      sym_attributes,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(10623), 1,
      sym__binding_ids_and_absurds,
    STATE(10681), 1,
      sym_open,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9954), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [289612] = 34,
    ACTIONS(700), 1,
      anon_sym_LBRACE_DASH_POUND,
    ACTIONS(706), 1,
      aux_sym__qid_token1,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1904), 1,
      sym_id,
    ACTIONS(1910), 1,
      anon_sym_BSLASH,
    ACTIONS(1912), 1,
      anon_sym_u03bb,
    ACTIONS(1916), 1,
      anon_sym_record,
    ACTIONS(1918), 1,
      anon_sym_LPAREN,
    ACTIONS(1920), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1922), 1,
      anon_sym_u2983,
    ACTIONS(1924), 1,
      anon_sym_LBRACE,
    ACTIONS(1926), 1,
      anon_sym_DOT,
    ACTIONS(1928), 1,
      anon_sym_quoteGoal,
    ACTIONS(1930), 1,
      anon_sym_tactic,
    ACTIONS(1932), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1934), 1,
      anon_sym_u2987,
    ACTIONS(1936), 1,
      anon_sym_let,
    ACTIONS(1940), 1,
      anon_sym_Set,
    STATE(2553), 1,
      sym__ARROW,
    STATE(2671), 1,
      aux_sym__lambda_clauses_repeat1,
    STATE(3176), 1,
      sym_catchall_pragma,
    STATE(3669), 1,
      aux_sym__atoms,
    STATE(4914), 1,
      sym_atom,
    STATE(8153), 1,
      sym__LAMBDA,
    STATE(8431), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1906), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1908), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(1938), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4675), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(8966), 3,
      sym__lambda_clause_maybe_absurd,
      sym_lambda_clause_absurd,
      sym_lambda_clause,
    STATE(4679), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8988), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1914), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [289743] = 37,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(986), 1,
      anon_sym_open,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4078), 1,
      anon_sym_RPAREN,
    ACTIONS(4110), 1,
      anon_sym_let,
    STATE(3439), 1,
      sym_attributes,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(11316), 1,
      sym_open,
    STATE(11352), 1,
      sym__binding_ids_and_absurds,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9952), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [289880] = 34,
    ACTIONS(700), 1,
      anon_sym_LBRACE_DASH_POUND,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1984), 1,
      anon_sym_BSLASH,
    ACTIONS(1986), 1,
      anon_sym_u03bb,
    ACTIONS(2004), 1,
      anon_sym_quoteGoal,
    ACTIONS(2006), 1,
      anon_sym_tactic,
    ACTIONS(2012), 1,
      anon_sym_let,
    ACTIONS(3380), 1,
      sym_id,
    ACTIONS(3384), 1,
      anon_sym_record,
    ACTIONS(3386), 1,
      anon_sym_LPAREN,
    ACTIONS(3388), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3390), 1,
      anon_sym_u2983,
    ACTIONS(3392), 1,
      anon_sym_LBRACE,
    ACTIONS(3394), 1,
      aux_sym__qid_token1,
    ACTIONS(3396), 1,
      anon_sym_DOT,
    ACTIONS(3398), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3400), 1,
      anon_sym_u2987,
    ACTIONS(3404), 1,
      anon_sym_Set,
    STATE(1949), 1,
      sym__ARROW,
    STATE(2671), 1,
      aux_sym__lambda_clauses_repeat1,
    STATE(3203), 1,
      sym_catchall_pragma,
    STATE(3611), 1,
      aux_sym__atoms,
    STATE(5099), 1,
      sym_atom,
    STATE(8039), 1,
      sym__LAMBDA,
    STATE(8483), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1982), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3402), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(3552), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(4937), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(9431), 3,
      sym__lambda_clause_maybe_absurd,
      sym_lambda_clause_absurd,
      sym_lambda_clause,
    STATE(4939), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8988), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3382), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [290011] = 37,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(986), 1,
      anon_sym_open,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3978), 1,
      anon_sym_RPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4118), 1,
      anon_sym_let,
    STATE(3692), 1,
      sym_attributes,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(10950), 1,
      sym_open,
    STATE(10986), 1,
      sym__binding_ids_and_absurds,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9761), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [290148] = 37,
    ACTIONS(704), 1,
      anon_sym_RPAREN,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(986), 1,
      anon_sym_open,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4120), 1,
      anon_sym_let,
    STATE(3390), 1,
      sym_attributes,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(10487), 1,
      sym__binding_ids_and_absurds,
    STATE(10532), 1,
      sym_open,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9895), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [290285] = 37,
    ACTIONS(704), 1,
      anon_sym_RPAREN,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(986), 1,
      anon_sym_open,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4122), 1,
      anon_sym_let,
    STATE(3689), 1,
      sym_attributes,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(11672), 1,
      sym__binding_ids_and_absurds,
    STATE(11738), 1,
      sym_open,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(10015), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [290422] = 37,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(732), 1,
      anon_sym_RPAREN,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(986), 1,
      anon_sym_open,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4124), 1,
      anon_sym_let,
    STATE(3497), 1,
      sym_attributes,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(11353), 1,
      sym_open,
    STATE(11389), 1,
      sym__binding_ids_and_absurds,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9924), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [290559] = 37,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(986), 1,
      anon_sym_open,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4078), 1,
      anon_sym_RPAREN,
    ACTIONS(4126), 1,
      anon_sym_let,
    STATE(3357), 1,
      sym_attributes,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(10400), 1,
      sym__binding_ids_and_absurds,
    STATE(10442), 1,
      sym_open,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9869), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [290696] = 37,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(986), 1,
      anon_sym_open,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4092), 1,
      anon_sym_RPAREN,
    ACTIONS(4128), 1,
      anon_sym_let,
    STATE(3600), 1,
      sym_attributes,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(11274), 1,
      sym_open,
    STATE(11315), 1,
      sym__binding_ids_and_absurds,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9926), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [290833] = 37,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(986), 1,
      anon_sym_open,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3978), 1,
      anon_sym_RPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4108), 1,
      anon_sym_let,
    STATE(3525), 1,
      sym_attributes,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(10686), 1,
      sym_open,
    STATE(10727), 1,
      sym__binding_ids_and_absurds,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9734), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [290970] = 34,
    ACTIONS(700), 1,
      anon_sym_LBRACE_DASH_POUND,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2796), 1,
      anon_sym_BSLASH,
    ACTIONS(2798), 1,
      anon_sym_u03bb,
    ACTIONS(2800), 1,
      anon_sym_quoteGoal,
    ACTIONS(2802), 1,
      anon_sym_tactic,
    ACTIONS(2804), 1,
      anon_sym_let,
    ACTIONS(3380), 1,
      sym_id,
    ACTIONS(3384), 1,
      anon_sym_record,
    ACTIONS(3386), 1,
      anon_sym_LPAREN,
    ACTIONS(3388), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3390), 1,
      anon_sym_u2983,
    ACTIONS(3392), 1,
      anon_sym_LBRACE,
    ACTIONS(3394), 1,
      aux_sym__qid_token1,
    ACTIONS(3396), 1,
      anon_sym_DOT,
    ACTIONS(3398), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3400), 1,
      anon_sym_u2987,
    ACTIONS(3404), 1,
      anon_sym_Set,
    STATE(2185), 1,
      sym__ARROW,
    STATE(2671), 1,
      aux_sym__lambda_clauses_repeat1,
    STATE(3299), 1,
      sym_catchall_pragma,
    STATE(3446), 1,
      aux_sym__atoms,
    STATE(5099), 1,
      sym_atom,
    STATE(8041), 1,
      sym__LAMBDA,
    STATE(8490), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2794), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2808), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(3402), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4937), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(8966), 3,
      sym__lambda_clause_maybe_absurd,
      sym_lambda_clause_absurd,
      sym_lambda_clause,
    STATE(4939), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8988), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3382), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [291101] = 37,
    ACTIONS(704), 1,
      anon_sym_RPAREN,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(986), 1,
      anon_sym_open,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4118), 1,
      anon_sym_let,
    STATE(3692), 1,
      sym_attributes,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(10950), 1,
      sym_open,
    STATE(10986), 1,
      sym__binding_ids_and_absurds,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9761), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [291238] = 37,
    ACTIONS(704), 1,
      anon_sym_RPAREN,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(986), 1,
      anon_sym_open,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4104), 1,
      anon_sym_let,
    STATE(3545), 1,
      sym_attributes,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(10239), 1,
      sym_open,
    STATE(10261), 1,
      sym__binding_ids_and_absurds,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9839), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [291375] = 37,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(986), 1,
      anon_sym_open,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3978), 1,
      anon_sym_RPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4120), 1,
      anon_sym_let,
    STATE(3390), 1,
      sym_attributes,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(10487), 1,
      sym__binding_ids_and_absurds,
    STATE(10532), 1,
      sym_open,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9895), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [291512] = 37,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(986), 1,
      anon_sym_open,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4078), 1,
      anon_sym_RPAREN,
    ACTIONS(4130), 1,
      anon_sym_let,
    STATE(3655), 1,
      sym_attributes,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(10914), 1,
      sym_open,
    STATE(10949), 1,
      sym__binding_ids_and_absurds,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9749), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [291649] = 34,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(700), 1,
      anon_sym_LBRACE_DASH_POUND,
    ACTIONS(3090), 1,
      sym_id,
    ACTIONS(3096), 1,
      anon_sym_BSLASH,
    ACTIONS(3098), 1,
      anon_sym_u03bb,
    ACTIONS(3102), 1,
      anon_sym_record,
    ACTIONS(3104), 1,
      anon_sym_LPAREN,
    ACTIONS(3106), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3108), 1,
      anon_sym_u2983,
    ACTIONS(3110), 1,
      anon_sym_LBRACE,
    ACTIONS(3112), 1,
      aux_sym__qid_token1,
    ACTIONS(3114), 1,
      anon_sym_DOT,
    ACTIONS(3116), 1,
      anon_sym_quoteGoal,
    ACTIONS(3118), 1,
      anon_sym_tactic,
    ACTIONS(3120), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3122), 1,
      anon_sym_u2987,
    ACTIONS(3124), 1,
      anon_sym_let,
    ACTIONS(3128), 1,
      anon_sym_Set,
    STATE(1820), 1,
      sym__ARROW,
    STATE(2671), 1,
      aux_sym__lambda_clauses_repeat1,
    STATE(3319), 1,
      sym_catchall_pragma,
    STATE(3477), 1,
      aux_sym__atoms,
    STATE(4365), 1,
      sym_atom,
    STATE(8099), 1,
      sym__LAMBDA,
    STATE(8393), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3092), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3094), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(3126), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4293), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(8963), 3,
      sym__lambda_clause_maybe_absurd,
      sym_lambda_clause_absurd,
      sym_lambda_clause,
    STATE(4285), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9000), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3100), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [291780] = 34,
    ACTIONS(692), 1,
      anon_sym_record,
    ACTIONS(694), 1,
      anon_sym_LPAREN,
    ACTIONS(696), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(698), 1,
      anon_sym_u2983,
    ACTIONS(700), 1,
      anon_sym_LBRACE_DASH_POUND,
    ACTIONS(702), 1,
      anon_sym_LBRACE,
    ACTIONS(708), 1,
      anon_sym_DOT,
    ACTIONS(718), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(720), 1,
      anon_sym_u2987,
    ACTIONS(728), 1,
      anon_sym_Set,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1928), 1,
      anon_sym_quoteGoal,
    ACTIONS(1936), 1,
      anon_sym_let,
    ACTIONS(2336), 1,
      sym_id,
    ACTIONS(2338), 1,
      anon_sym_BSLASH,
    ACTIONS(2340), 1,
      anon_sym_u03bb,
    ACTIONS(2342), 1,
      aux_sym__qid_token1,
    ACTIONS(2344), 1,
      anon_sym_tactic,
    STATE(2553), 1,
      sym__ARROW,
    STATE(2671), 1,
      aux_sym__lambda_clauses_repeat1,
    STATE(3309), 1,
      sym_catchall_pragma,
    STATE(3416), 1,
      aux_sym__atoms,
    STATE(5128), 1,
      sym_atom,
    STATE(8079), 1,
      sym__LAMBDA,
    STATE(8431), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(726), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1906), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1908), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(5069), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(8966), 3,
      sym__lambda_clause_maybe_absurd,
      sym_lambda_clause_absurd,
      sym_lambda_clause,
    STATE(5056), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8988), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(690), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [291911] = 37,
    ACTIONS(704), 1,
      anon_sym_RPAREN,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(986), 1,
      anon_sym_open,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4132), 1,
      anon_sym_let,
    STATE(3523), 1,
      sym_attributes,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(10987), 1,
      sym_open,
    STATE(11024), 1,
      sym__binding_ids_and_absurds,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9781), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [292048] = 37,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(986), 1,
      anon_sym_open,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3978), 1,
      anon_sym_RPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4134), 1,
      anon_sym_let,
    STATE(3378), 1,
      sym_attributes,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(11157), 1,
      sym__binding_ids_and_absurds,
    STATE(11471), 1,
      sym_open,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9986), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [292185] = 37,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(732), 1,
      anon_sym_RPAREN,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(986), 1,
      anon_sym_open,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4130), 1,
      anon_sym_let,
    STATE(3655), 1,
      sym_attributes,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(10914), 1,
      sym_open,
    STATE(10949), 1,
      sym__binding_ids_and_absurds,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9749), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [292322] = 37,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(986), 1,
      anon_sym_open,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3978), 1,
      anon_sym_RPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4136), 1,
      anon_sym_let,
    STATE(3480), 1,
      sym_attributes,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(10582), 1,
      sym__binding_ids_and_absurds,
    STATE(10622), 1,
      sym_open,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9934), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [292459] = 34,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(700), 1,
      anon_sym_LBRACE_DASH_POUND,
    ACTIONS(2206), 1,
      sym_id,
    ACTIONS(2212), 1,
      anon_sym_BSLASH,
    ACTIONS(2214), 1,
      anon_sym_u03bb,
    ACTIONS(2218), 1,
      anon_sym_record,
    ACTIONS(2220), 1,
      anon_sym_LPAREN,
    ACTIONS(2222), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2224), 1,
      anon_sym_u2983,
    ACTIONS(2226), 1,
      anon_sym_LBRACE,
    ACTIONS(2228), 1,
      aux_sym__qid_token1,
    ACTIONS(2230), 1,
      anon_sym_DOT,
    ACTIONS(2232), 1,
      anon_sym_quoteGoal,
    ACTIONS(2234), 1,
      anon_sym_tactic,
    ACTIONS(2236), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2238), 1,
      anon_sym_u2987,
    ACTIONS(2240), 1,
      anon_sym_let,
    ACTIONS(2244), 1,
      anon_sym_Set,
    STATE(2163), 1,
      sym__ARROW,
    STATE(2671), 1,
      aux_sym__lambda_clauses_repeat1,
    STATE(3205), 1,
      sym_catchall_pragma,
    STATE(3701), 1,
      aux_sym__atoms,
    STATE(4718), 1,
      sym_atom,
    STATE(8035), 1,
      sym__LAMBDA,
    STATE(8402), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2210), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(2242), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4812), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(8971), 3,
      sym__lambda_clause_maybe_absurd,
      sym_lambda_clause_absurd,
      sym_lambda_clause,
    STATE(4858), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9000), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2216), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [292590] = 34,
    ACTIONS(700), 1,
      anon_sym_LBRACE_DASH_POUND,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2448), 1,
      anon_sym_quoteGoal,
    ACTIONS(2456), 1,
      anon_sym_let,
    ACTIONS(2842), 1,
      anon_sym_BSLASH,
    ACTIONS(2844), 1,
      anon_sym_u03bb,
    ACTIONS(2862), 1,
      anon_sym_tactic,
    ACTIONS(2872), 1,
      sym_id,
    ACTIONS(2876), 1,
      anon_sym_record,
    ACTIONS(2878), 1,
      anon_sym_LPAREN,
    ACTIONS(2880), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2882), 1,
      anon_sym_u2983,
    ACTIONS(2884), 1,
      anon_sym_LBRACE,
    ACTIONS(2886), 1,
      aux_sym__qid_token1,
    ACTIONS(2888), 1,
      anon_sym_DOT,
    ACTIONS(2890), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2892), 1,
      anon_sym_u2987,
    ACTIONS(2896), 1,
      anon_sym_Set,
    STATE(2007), 1,
      sym__ARROW,
    STATE(2671), 1,
      aux_sym__lambda_clauses_repeat1,
    STATE(3134), 1,
      sym_catchall_pragma,
    STATE(3374), 1,
      aux_sym__atoms,
    STATE(4945), 1,
      sym_atom,
    STATE(8053), 1,
      sym__LAMBDA,
    STATE(8423), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2424), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2426), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(2894), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5291), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(8989), 3,
      sym__lambda_clause_maybe_absurd,
      sym_lambda_clause_absurd,
      sym_lambda_clause,
    STATE(5287), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8988), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2874), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [292721] = 37,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(986), 1,
      anon_sym_open,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3978), 1,
      anon_sym_RPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4122), 1,
      anon_sym_let,
    STATE(3689), 1,
      sym_attributes,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(11672), 1,
      sym__binding_ids_and_absurds,
    STATE(11738), 1,
      sym_open,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(10015), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [292858] = 37,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(732), 1,
      anon_sym_RPAREN,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(986), 1,
      anon_sym_open,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4138), 1,
      anon_sym_let,
    STATE(3614), 1,
      sym_attributes,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(10377), 1,
      sym_open,
    STATE(10414), 1,
      sym__binding_ids_and_absurds,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9806), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [292995] = 34,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(700), 1,
      anon_sym_LBRACE_DASH_POUND,
    ACTIONS(2732), 1,
      anon_sym_BSLASH,
    ACTIONS(2734), 1,
      anon_sym_u03bb,
    ACTIONS(2752), 1,
      anon_sym_quoteGoal,
    ACTIONS(2754), 1,
      anon_sym_tactic,
    ACTIONS(2760), 1,
      anon_sym_let,
    ACTIONS(3610), 1,
      sym_id,
    ACTIONS(3616), 1,
      anon_sym_record,
    ACTIONS(3618), 1,
      anon_sym_LPAREN,
    ACTIONS(3620), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3622), 1,
      anon_sym_u2983,
    ACTIONS(3624), 1,
      anon_sym_LBRACE,
    ACTIONS(3626), 1,
      aux_sym__qid_token1,
    ACTIONS(3628), 1,
      anon_sym_DOT,
    ACTIONS(3630), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3632), 1,
      anon_sym_u2987,
    ACTIONS(3636), 1,
      anon_sym_Set,
    STATE(1572), 1,
      sym__ARROW,
    STATE(2671), 1,
      aux_sym__lambda_clauses_repeat1,
    STATE(3190), 1,
      sym_catchall_pragma,
    STATE(3429), 1,
      aux_sym__atoms,
    STATE(5352), 1,
      sym_atom,
    STATE(8061), 1,
      sym__LAMBDA,
    STATE(8384), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2730), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3612), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(3634), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5254), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(8963), 3,
      sym__lambda_clause_maybe_absurd,
      sym_lambda_clause_absurd,
      sym_lambda_clause,
    STATE(5242), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9000), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3614), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [293126] = 34,
    ACTIONS(700), 1,
      anon_sym_LBRACE_DASH_POUND,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(2656), 1,
      anon_sym_BSLASH,
    ACTIONS(2658), 1,
      anon_sym_u03bb,
    ACTIONS(2676), 1,
      anon_sym_quoteGoal,
    ACTIONS(2678), 1,
      anon_sym_tactic,
    ACTIONS(2684), 1,
      anon_sym_let,
    ACTIONS(3208), 1,
      sym_id,
    ACTIONS(3212), 1,
      anon_sym_record,
    ACTIONS(3214), 1,
      anon_sym_LPAREN,
    ACTIONS(3216), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3218), 1,
      anon_sym_u2983,
    ACTIONS(3220), 1,
      anon_sym_LBRACE,
    ACTIONS(3222), 1,
      aux_sym__qid_token1,
    ACTIONS(3224), 1,
      anon_sym_DOT,
    ACTIONS(3226), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3228), 1,
      anon_sym_u2987,
    ACTIONS(3232), 1,
      anon_sym_Set,
    STATE(2460), 1,
      sym__ARROW,
    STATE(2671), 1,
      aux_sym__lambda_clauses_repeat1,
    STATE(3200), 1,
      sym_catchall_pragma,
    STATE(3498), 1,
      aux_sym__atoms,
    STATE(5433), 1,
      sym_atom,
    STATE(8132), 1,
      sym__LAMBDA,
    STATE(8470), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(684), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(2654), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3230), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5579), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(8966), 3,
      sym__lambda_clause_maybe_absurd,
      sym_lambda_clause_absurd,
      sym_lambda_clause,
    STATE(5582), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9459), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3210), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [293257] = 37,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(986), 1,
      anon_sym_open,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4092), 1,
      anon_sym_RPAREN,
    ACTIONS(4140), 1,
      anon_sym_let,
    STATE(3394), 1,
      sym_attributes,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(10842), 1,
      sym_open,
    STATE(10879), 1,
      sym__binding_ids_and_absurds,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9722), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [293394] = 37,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(730), 1,
      anon_sym_RPAREN,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(986), 1,
      anon_sym_open,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4142), 1,
      anon_sym_let,
    STATE(3412), 1,
      sym_attributes,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(11025), 1,
      sym_open,
    STATE(11059), 1,
      sym__binding_ids_and_absurds,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9811), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [293531] = 37,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(730), 1,
      anon_sym_RPAREN,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(986), 1,
      anon_sym_open,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4140), 1,
      anon_sym_let,
    STATE(3394), 1,
      sym_attributes,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(10842), 1,
      sym_open,
    STATE(10879), 1,
      sym__binding_ids_and_absurds,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9722), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [293668] = 37,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(730), 1,
      anon_sym_RPAREN,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(986), 1,
      anon_sym_open,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4128), 1,
      anon_sym_let,
    STATE(3600), 1,
      sym_attributes,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(11274), 1,
      sym_open,
    STATE(11315), 1,
      sym__binding_ids_and_absurds,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9926), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [293805] = 37,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(732), 1,
      anon_sym_RPAREN,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(986), 1,
      anon_sym_open,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4144), 1,
      anon_sym_let,
    STATE(3657), 1,
      sym_attributes,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(11066), 1,
      sym__binding_ids_and_absurds,
    STATE(11101), 1,
      sym_open,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9846), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [293942] = 37,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(986), 1,
      anon_sym_open,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3978), 1,
      anon_sym_RPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4146), 1,
      anon_sym_let,
    STATE(3450), 1,
      sym_attributes,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(11811), 1,
      sym__binding_ids_and_absurds,
    STATE(11900), 1,
      sym_open,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(10044), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [294079] = 37,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(986), 1,
      anon_sym_open,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3978), 1,
      anon_sym_RPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4098), 1,
      anon_sym_let,
    STATE(3681), 1,
      sym_attributes,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(10300), 1,
      sym_open,
    STATE(10334), 1,
      sym__binding_ids_and_absurds,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9819), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [294216] = 37,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(986), 1,
      anon_sym_open,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4078), 1,
      anon_sym_RPAREN,
    ACTIONS(4148), 1,
      anon_sym_let,
    STATE(3676), 1,
      sym_attributes,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(10530), 1,
      sym_open,
    STATE(10571), 1,
      sym__binding_ids_and_absurds,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9768), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [294353] = 37,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(986), 1,
      anon_sym_open,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4078), 1,
      anon_sym_RPAREN,
    ACTIONS(4138), 1,
      anon_sym_let,
    STATE(3614), 1,
      sym_attributes,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(10377), 1,
      sym_open,
    STATE(10414), 1,
      sym__binding_ids_and_absurds,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9806), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [294490] = 37,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(986), 1,
      anon_sym_open,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4078), 1,
      anon_sym_RPAREN,
    ACTIONS(4144), 1,
      anon_sym_let,
    STATE(3657), 1,
      sym_attributes,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(11066), 1,
      sym__binding_ids_and_absurds,
    STATE(11101), 1,
      sym_open,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9846), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [294627] = 37,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(732), 1,
      anon_sym_RPAREN,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(986), 1,
      anon_sym_open,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4148), 1,
      anon_sym_let,
    STATE(3676), 1,
      sym_attributes,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(10530), 1,
      sym_open,
    STATE(10571), 1,
      sym__binding_ids_and_absurds,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9768), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [294764] = 37,
    ACTIONS(704), 1,
      anon_sym_RPAREN,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(986), 1,
      anon_sym_open,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4134), 1,
      anon_sym_let,
    STATE(3378), 1,
      sym_attributes,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(11157), 1,
      sym__binding_ids_and_absurds,
    STATE(11471), 1,
      sym_open,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9986), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [294901] = 37,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(986), 1,
      anon_sym_open,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3978), 1,
      anon_sym_RPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4150), 1,
      anon_sym_let,
    STATE(3562), 1,
      sym_attributes,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(10611), 1,
      sym_open,
    STATE(10647), 1,
      sym__binding_ids_and_absurds,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9750), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [295038] = 37,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(730), 1,
      anon_sym_RPAREN,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(986), 1,
      anon_sym_open,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4112), 1,
      anon_sym_let,
    STATE(3678), 1,
      sym_attributes,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(10258), 1,
      sym__binding_ids_and_absurds,
    STATE(10339), 1,
      sym_open,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9858), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [295175] = 37,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(732), 1,
      anon_sym_RPAREN,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(986), 1,
      anon_sym_open,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4126), 1,
      anon_sym_let,
    STATE(3357), 1,
      sym_attributes,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(10400), 1,
      sym__binding_ids_and_absurds,
    STATE(10442), 1,
      sym_open,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9869), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [295312] = 37,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(986), 1,
      anon_sym_open,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4092), 1,
      anon_sym_RPAREN,
    ACTIONS(4142), 1,
      anon_sym_let,
    STATE(3412), 1,
      sym_attributes,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(11025), 1,
      sym_open,
    STATE(11059), 1,
      sym__binding_ids_and_absurds,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9811), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [295449] = 37,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(732), 1,
      anon_sym_RPAREN,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(986), 1,
      anon_sym_open,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4100), 1,
      anon_sym_let,
    STATE(3436), 1,
      sym_attributes,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(10683), 1,
      sym__binding_ids_and_absurds,
    STATE(10767), 1,
      sym_open,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9960), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [295586] = 34,
    ACTIONS(686), 1,
      anon_sym_BSLASH,
    ACTIONS(688), 1,
      anon_sym_u03bb,
    ACTIONS(692), 1,
      anon_sym_record,
    ACTIONS(694), 1,
      anon_sym_LPAREN,
    ACTIONS(696), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(698), 1,
      anon_sym_u2983,
    ACTIONS(700), 1,
      anon_sym_LBRACE_DASH_POUND,
    ACTIONS(702), 1,
      anon_sym_LBRACE,
    ACTIONS(708), 1,
      anon_sym_DOT,
    ACTIONS(714), 1,
      anon_sym_quoteGoal,
    ACTIONS(716), 1,
      anon_sym_tactic,
    ACTIONS(718), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(720), 1,
      anon_sym_u2987,
    ACTIONS(722), 1,
      anon_sym_let,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(728), 1,
      anon_sym_Set,
    ACTIONS(2336), 1,
      sym_id,
    ACTIONS(2342), 1,
      aux_sym__qid_token1,
    STATE(2651), 1,
      sym__ARROW,
    STATE(2671), 1,
      aux_sym__lambda_clauses_repeat1,
    STATE(3132), 1,
      sym_catchall_pragma,
    STATE(3688), 1,
      aux_sym__atoms,
    STATE(5128), 1,
      sym_atom,
    STATE(8064), 1,
      sym__LAMBDA,
    STATE(8495), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(682), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(726), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(2604), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(5069), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(8989), 3,
      sym__lambda_clause_maybe_absurd,
      sym_lambda_clause_absurd,
      sym_lambda_clause,
    STATE(5056), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9459), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(690), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [295717] = 34,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(700), 1,
      anon_sym_LBRACE_DASH_POUND,
    ACTIONS(2350), 1,
      anon_sym_BSLASH,
    ACTIONS(2352), 1,
      anon_sym_u03bb,
    ACTIONS(2370), 1,
      anon_sym_quoteGoal,
    ACTIONS(2372), 1,
      anon_sym_tactic,
    ACTIONS(2378), 1,
      anon_sym_let,
    ACTIONS(3786), 1,
      sym_id,
    ACTIONS(3792), 1,
      anon_sym_record,
    ACTIONS(3794), 1,
      anon_sym_LPAREN,
    ACTIONS(3796), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3798), 1,
      anon_sym_u2983,
    ACTIONS(3800), 1,
      anon_sym_LBRACE,
    ACTIONS(3802), 1,
      aux_sym__qid_token1,
    ACTIONS(3804), 1,
      anon_sym_DOT,
    ACTIONS(3806), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3808), 1,
      anon_sym_u2987,
    ACTIONS(3812), 1,
      anon_sym_Set,
    STATE(1464), 1,
      sym__ARROW,
    STATE(2671), 1,
      aux_sym__lambda_clauses_repeat1,
    STATE(3247), 1,
      sym_catchall_pragma,
    STATE(3680), 1,
      aux_sym__atoms,
    STATE(4255), 1,
      sym_atom,
    STATE(8119), 1,
      sym__LAMBDA,
    STATE(8372), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2348), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3788), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(3810), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4284), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(8963), 3,
      sym__lambda_clause_maybe_absurd,
      sym_lambda_clause_absurd,
      sym_lambda_clause,
    STATE(4282), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9000), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3790), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [295848] = 37,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(986), 1,
      anon_sym_open,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3978), 1,
      anon_sym_RPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4152), 1,
      anon_sym_let,
    STATE(3518), 1,
      sym_attributes,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(11504), 1,
      sym_open,
    STATE(11558), 1,
      sym__binding_ids_and_absurds,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(10088), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [295985] = 34,
    ACTIONS(700), 1,
      anon_sym_LBRACE_DASH_POUND,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1984), 1,
      anon_sym_BSLASH,
    ACTIONS(1986), 1,
      anon_sym_u03bb,
    ACTIONS(2004), 1,
      anon_sym_quoteGoal,
    ACTIONS(2006), 1,
      anon_sym_tactic,
    ACTIONS(2012), 1,
      anon_sym_let,
    ACTIONS(3380), 1,
      sym_id,
    ACTIONS(3384), 1,
      anon_sym_record,
    ACTIONS(3386), 1,
      anon_sym_LPAREN,
    ACTIONS(3388), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3390), 1,
      anon_sym_u2983,
    ACTIONS(3392), 1,
      anon_sym_LBRACE,
    ACTIONS(3394), 1,
      aux_sym__qid_token1,
    ACTIONS(3396), 1,
      anon_sym_DOT,
    ACTIONS(3398), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3400), 1,
      anon_sym_u2987,
    ACTIONS(3404), 1,
      anon_sym_Set,
    STATE(1949), 1,
      sym__ARROW,
    STATE(2671), 1,
      aux_sym__lambda_clauses_repeat1,
    STATE(3203), 1,
      sym_catchall_pragma,
    STATE(3611), 1,
      aux_sym__atoms,
    STATE(5099), 1,
      sym_atom,
    STATE(8039), 1,
      sym__LAMBDA,
    STATE(8483), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1982), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3402), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(3552), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(4937), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(9473), 3,
      sym__lambda_clause_maybe_absurd,
      sym_lambda_clause_absurd,
      sym_lambda_clause,
    STATE(4939), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8988), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3382), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [296116] = 37,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(986), 1,
      anon_sym_open,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4092), 1,
      anon_sym_RPAREN,
    ACTIONS(4112), 1,
      anon_sym_let,
    STATE(3678), 1,
      sym_attributes,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(10258), 1,
      sym__binding_ids_and_absurds,
    STATE(10339), 1,
      sym_open,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9858), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [296253] = 37,
    ACTIONS(704), 1,
      anon_sym_RPAREN,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(986), 1,
      anon_sym_open,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4154), 1,
      anon_sym_let,
    STATE(3686), 1,
      sym_attributes,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(11739), 1,
      sym__binding_ids_and_absurds,
    STATE(11810), 1,
      sym_open,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(10034), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [296390] = 37,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(732), 1,
      anon_sym_RPAREN,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(986), 1,
      anon_sym_open,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4156), 1,
      anon_sym_let,
    STATE(3618), 1,
      sym_attributes,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(10572), 1,
      sym_open,
    STATE(10610), 1,
      sym__binding_ids_and_absurds,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9758), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [296527] = 37,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(986), 1,
      anon_sym_open,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4078), 1,
      anon_sym_RPAREN,
    ACTIONS(4158), 1,
      anon_sym_let,
    STATE(3555), 1,
      sym_attributes,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(11245), 1,
      sym_open,
    STATE(11281), 1,
      sym__binding_ids_and_absurds,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9907), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [296664] = 34,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(700), 1,
      anon_sym_LBRACE_DASH_POUND,
    ACTIONS(2898), 1,
      sym_id,
    ACTIONS(2904), 1,
      anon_sym_BSLASH,
    ACTIONS(2906), 1,
      anon_sym_u03bb,
    ACTIONS(2910), 1,
      anon_sym_record,
    ACTIONS(2912), 1,
      anon_sym_LPAREN,
    ACTIONS(2914), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2916), 1,
      anon_sym_u2983,
    ACTIONS(2918), 1,
      anon_sym_LBRACE,
    ACTIONS(2920), 1,
      aux_sym__qid_token1,
    ACTIONS(2922), 1,
      anon_sym_DOT,
    ACTIONS(2924), 1,
      anon_sym_quoteGoal,
    ACTIONS(2926), 1,
      anon_sym_tactic,
    ACTIONS(2928), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2930), 1,
      anon_sym_u2987,
    ACTIONS(2932), 1,
      anon_sym_let,
    ACTIONS(2936), 1,
      anon_sym_Set,
    STATE(1742), 1,
      sym__ARROW,
    STATE(2671), 1,
      aux_sym__lambda_clauses_repeat1,
    STATE(3327), 1,
      sym_catchall_pragma,
    STATE(3387), 1,
      aux_sym__atoms,
    STATE(4154), 1,
      sym_atom,
    STATE(8094), 1,
      sym__LAMBDA,
    STATE(8489), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2900), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2902), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(2934), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4184), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(8963), 3,
      sym__lambda_clause_maybe_absurd,
      sym_lambda_clause_absurd,
      sym_lambda_clause,
    STATE(4206), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9000), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2908), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [296795] = 37,
    ACTIONS(704), 1,
      anon_sym_RPAREN,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(986), 1,
      anon_sym_open,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4160), 1,
      anon_sym_let,
    STATE(3650), 1,
      sym_attributes,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(10533), 1,
      sym__binding_ids_and_absurds,
    STATE(10581), 1,
      sym_open,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9914), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [296932] = 34,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(700), 1,
      anon_sym_LBRACE_DASH_POUND,
    ACTIONS(3266), 1,
      anon_sym_BSLASH,
    ACTIONS(3268), 1,
      anon_sym_u03bb,
    ACTIONS(3286), 1,
      anon_sym_quoteGoal,
    ACTIONS(3288), 1,
      anon_sym_tactic,
    ACTIONS(3294), 1,
      anon_sym_let,
    ACTIONS(3732), 1,
      sym_id,
    ACTIONS(3738), 1,
      anon_sym_record,
    ACTIONS(3740), 1,
      anon_sym_LPAREN,
    ACTIONS(3742), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3744), 1,
      anon_sym_u2983,
    ACTIONS(3746), 1,
      anon_sym_LBRACE,
    ACTIONS(3748), 1,
      aux_sym__qid_token1,
    ACTIONS(3750), 1,
      anon_sym_DOT,
    ACTIONS(3752), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3754), 1,
      anon_sym_u2987,
    ACTIONS(3758), 1,
      anon_sym_Set,
    STATE(2021), 1,
      sym__ARROW,
    STATE(2671), 1,
      aux_sym__lambda_clauses_repeat1,
    STATE(3195), 1,
      sym_catchall_pragma,
    STATE(3592), 1,
      aux_sym__atoms,
    STATE(4058), 1,
      sym_atom,
    STATE(8143), 1,
      sym__LAMBDA,
    STATE(8451), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3264), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3734), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(3756), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4073), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(8963), 3,
      sym__lambda_clause_maybe_absurd,
      sym_lambda_clause_absurd,
      sym_lambda_clause,
    STATE(4070), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9000), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3736), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [297063] = 34,
    ACTIONS(700), 1,
      anon_sym_LBRACE_DASH_POUND,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2422), 1,
      sym_id,
    ACTIONS(2428), 1,
      anon_sym_BSLASH,
    ACTIONS(2430), 1,
      anon_sym_u03bb,
    ACTIONS(2434), 1,
      anon_sym_record,
    ACTIONS(2436), 1,
      anon_sym_LPAREN,
    ACTIONS(2438), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2440), 1,
      anon_sym_u2983,
    ACTIONS(2442), 1,
      anon_sym_LBRACE,
    ACTIONS(2444), 1,
      aux_sym__qid_token1,
    ACTIONS(2446), 1,
      anon_sym_DOT,
    ACTIONS(2448), 1,
      anon_sym_quoteGoal,
    ACTIONS(2450), 1,
      anon_sym_tactic,
    ACTIONS(2452), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2454), 1,
      anon_sym_u2987,
    ACTIONS(2456), 1,
      anon_sym_let,
    ACTIONS(2460), 1,
      anon_sym_Set,
    STATE(2007), 1,
      sym__ARROW,
    STATE(2671), 1,
      aux_sym__lambda_clauses_repeat1,
    STATE(3222), 1,
      sym_catchall_pragma,
    STATE(3588), 1,
      aux_sym__atoms,
    STATE(5596), 1,
      sym_atom,
    STATE(8125), 1,
      sym__LAMBDA,
    STATE(8423), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2424), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2426), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(2458), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5422), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(8966), 3,
      sym__lambda_clause_maybe_absurd,
      sym_lambda_clause_absurd,
      sym_lambda_clause,
    STATE(5423), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8988), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2432), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [297194] = 34,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(700), 1,
      anon_sym_LBRACE_DASH_POUND,
    ACTIONS(2526), 1,
      sym_id,
    ACTIONS(2532), 1,
      anon_sym_BSLASH,
    ACTIONS(2534), 1,
      anon_sym_u03bb,
    ACTIONS(2538), 1,
      anon_sym_record,
    ACTIONS(2540), 1,
      anon_sym_LPAREN,
    ACTIONS(2542), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2544), 1,
      anon_sym_u2983,
    ACTIONS(2546), 1,
      anon_sym_LBRACE,
    ACTIONS(2548), 1,
      aux_sym__qid_token1,
    ACTIONS(2550), 1,
      anon_sym_DOT,
    ACTIONS(2552), 1,
      anon_sym_quoteGoal,
    ACTIONS(2554), 1,
      anon_sym_tactic,
    ACTIONS(2556), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2558), 1,
      anon_sym_u2987,
    ACTIONS(2560), 1,
      anon_sym_let,
    ACTIONS(2564), 1,
      anon_sym_Set,
    STATE(1938), 1,
      sym__ARROW,
    STATE(2671), 1,
      aux_sym__lambda_clauses_repeat1,
    STATE(3281), 1,
      sym_catchall_pragma,
    STATE(3610), 1,
      aux_sym__atoms,
    STATE(4603), 1,
      sym_atom,
    STATE(8066), 1,
      sym__LAMBDA,
    STATE(8398), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2528), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2530), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(2562), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4464), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(8963), 3,
      sym__lambda_clause_maybe_absurd,
      sym_lambda_clause_absurd,
      sym_lambda_clause,
    STATE(4473), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9000), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2536), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [297325] = 34,
    ACTIONS(700), 1,
      anon_sym_LBRACE_DASH_POUND,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1916), 1,
      anon_sym_record,
    ACTIONS(1918), 1,
      anon_sym_LPAREN,
    ACTIONS(1920), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1922), 1,
      anon_sym_u2983,
    ACTIONS(1924), 1,
      anon_sym_LBRACE,
    ACTIONS(1932), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1934), 1,
      anon_sym_u2987,
    ACTIONS(2120), 1,
      anon_sym_quoteGoal,
    ACTIONS(2128), 1,
      anon_sym_let,
    ACTIONS(2176), 1,
      anon_sym_BSLASH,
    ACTIONS(2178), 1,
      anon_sym_u03bb,
    ACTIONS(2196), 1,
      anon_sym_tactic,
    ACTIONS(2606), 1,
      sym_id,
    ACTIONS(2608), 1,
      aux_sym__qid_token1,
    ACTIONS(2610), 1,
      anon_sym_DOT,
    ACTIONS(2612), 1,
      anon_sym_Set,
    STATE(1489), 1,
      sym__ARROW,
    STATE(2671), 1,
      aux_sym__lambda_clauses_repeat1,
    STATE(3135), 1,
      sym_catchall_pragma,
    STATE(3507), 1,
      aux_sym__atoms,
    STATE(4914), 1,
      sym_atom,
    STATE(8044), 1,
      sym__LAMBDA,
    STATE(8428), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1938), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(2096), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2098), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(4675), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(9473), 3,
      sym__lambda_clause_maybe_absurd,
      sym_lambda_clause_absurd,
      sym_lambda_clause,
    STATE(4679), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8988), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1914), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [297456] = 34,
    ACTIONS(700), 1,
      anon_sym_LBRACE_DASH_POUND,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(2656), 1,
      anon_sym_BSLASH,
    ACTIONS(2658), 1,
      anon_sym_u03bb,
    ACTIONS(2676), 1,
      anon_sym_quoteGoal,
    ACTIONS(2678), 1,
      anon_sym_tactic,
    ACTIONS(2684), 1,
      anon_sym_let,
    ACTIONS(3208), 1,
      sym_id,
    ACTIONS(3212), 1,
      anon_sym_record,
    ACTIONS(3214), 1,
      anon_sym_LPAREN,
    ACTIONS(3216), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3218), 1,
      anon_sym_u2983,
    ACTIONS(3220), 1,
      anon_sym_LBRACE,
    ACTIONS(3222), 1,
      aux_sym__qid_token1,
    ACTIONS(3224), 1,
      anon_sym_DOT,
    ACTIONS(3226), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3228), 1,
      anon_sym_u2987,
    ACTIONS(3232), 1,
      anon_sym_Set,
    STATE(2460), 1,
      sym__ARROW,
    STATE(2671), 1,
      aux_sym__lambda_clauses_repeat1,
    STATE(3200), 1,
      sym_catchall_pragma,
    STATE(3498), 1,
      aux_sym__atoms,
    STATE(5433), 1,
      sym_atom,
    STATE(8132), 1,
      sym__LAMBDA,
    STATE(8470), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(684), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(2654), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3230), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5579), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(8989), 3,
      sym__lambda_clause_maybe_absurd,
      sym_lambda_clause_absurd,
      sym_lambda_clause,
    STATE(5582), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9459), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3210), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [297587] = 34,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(700), 1,
      anon_sym_LBRACE_DASH_POUND,
    ACTIONS(2964), 1,
      anon_sym_quoteGoal,
    ACTIONS(2972), 1,
      anon_sym_let,
    ACTIONS(3520), 1,
      sym_id,
    ACTIONS(3522), 1,
      anon_sym_BSLASH,
    ACTIONS(3524), 1,
      anon_sym_u03bb,
    ACTIONS(3528), 1,
      anon_sym_record,
    ACTIONS(3530), 1,
      anon_sym_LPAREN,
    ACTIONS(3532), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3534), 1,
      anon_sym_u2983,
    ACTIONS(3536), 1,
      anon_sym_LBRACE,
    ACTIONS(3538), 1,
      aux_sym__qid_token1,
    ACTIONS(3540), 1,
      anon_sym_DOT,
    ACTIONS(3542), 1,
      anon_sym_tactic,
    ACTIONS(3544), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3546), 1,
      anon_sym_u2987,
    ACTIONS(3550), 1,
      anon_sym_Set,
    STATE(2453), 1,
      sym__ARROW,
    STATE(2671), 1,
      aux_sym__lambda_clauses_repeat1,
    STATE(3308), 1,
      sym_catchall_pragma,
    STATE(3404), 1,
      aux_sym__atoms,
    STATE(5625), 1,
      sym_atom,
    STATE(8058), 1,
      sym__LAMBDA,
    STATE(8418), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2940), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2942), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(3548), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5537), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(8963), 3,
      sym__lambda_clause_maybe_absurd,
      sym_lambda_clause_absurd,
      sym_lambda_clause,
    STATE(5538), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9000), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3526), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [297718] = 37,
    ACTIONS(704), 1,
      anon_sym_RPAREN,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(986), 1,
      anon_sym_open,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4150), 1,
      anon_sym_let,
    STATE(3562), 1,
      sym_attributes,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(10611), 1,
      sym_open,
    STATE(10647), 1,
      sym__binding_ids_and_absurds,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9750), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [297855] = 34,
    ACTIONS(700), 1,
      anon_sym_LBRACE_DASH_POUND,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2094), 1,
      sym_id,
    ACTIONS(2100), 1,
      anon_sym_BSLASH,
    ACTIONS(2102), 1,
      anon_sym_u03bb,
    ACTIONS(2106), 1,
      anon_sym_record,
    ACTIONS(2108), 1,
      anon_sym_LPAREN,
    ACTIONS(2110), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2112), 1,
      anon_sym_u2983,
    ACTIONS(2114), 1,
      anon_sym_LBRACE,
    ACTIONS(2116), 1,
      aux_sym__qid_token1,
    ACTIONS(2118), 1,
      anon_sym_DOT,
    ACTIONS(2120), 1,
      anon_sym_quoteGoal,
    ACTIONS(2122), 1,
      anon_sym_tactic,
    ACTIONS(2124), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2126), 1,
      anon_sym_u2987,
    ACTIONS(2128), 1,
      anon_sym_let,
    ACTIONS(2132), 1,
      anon_sym_Set,
    STATE(1489), 1,
      sym__ARROW,
    STATE(2671), 1,
      aux_sym__lambda_clauses_repeat1,
    STATE(3291), 1,
      sym_catchall_pragma,
    STATE(3471), 1,
      aux_sym__atoms,
    STATE(5601), 1,
      sym_atom,
    STATE(8075), 1,
      sym__LAMBDA,
    STATE(8428), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2096), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2098), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(2130), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5451), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(9431), 3,
      sym__lambda_clause_maybe_absurd,
      sym_lambda_clause_absurd,
      sym_lambda_clause,
    STATE(5453), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8988), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2104), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [297986] = 34,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(700), 1,
      anon_sym_LBRACE_DASH_POUND,
    ACTIONS(3134), 1,
      anon_sym_BSLASH,
    ACTIONS(3136), 1,
      anon_sym_u03bb,
    ACTIONS(3154), 1,
      anon_sym_quoteGoal,
    ACTIONS(3156), 1,
      anon_sym_tactic,
    ACTIONS(3162), 1,
      anon_sym_let,
    ACTIONS(3326), 1,
      sym_id,
    ACTIONS(3332), 1,
      anon_sym_record,
    ACTIONS(3334), 1,
      anon_sym_LPAREN,
    ACTIONS(3336), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3338), 1,
      anon_sym_u2983,
    ACTIONS(3340), 1,
      anon_sym_LBRACE,
    ACTIONS(3342), 1,
      aux_sym__qid_token1,
    ACTIONS(3344), 1,
      anon_sym_DOT,
    ACTIONS(3346), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3348), 1,
      anon_sym_u2987,
    ACTIONS(3352), 1,
      anon_sym_Set,
    STATE(1678), 1,
      sym__ARROW,
    STATE(2671), 1,
      aux_sym__lambda_clauses_repeat1,
    STATE(3227), 1,
      sym_catchall_pragma,
    STATE(3427), 1,
      aux_sym__atoms,
    STATE(4908), 1,
      sym_atom,
    STATE(8076), 1,
      sym__LAMBDA,
    STATE(8363), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3132), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3328), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(3350), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4650), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(8971), 3,
      sym__lambda_clause_maybe_absurd,
      sym_lambda_clause_absurd,
      sym_lambda_clause,
    STATE(4649), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9000), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3330), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [298117] = 37,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(732), 1,
      anon_sym_RPAREN,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(986), 1,
      anon_sym_open,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4158), 1,
      anon_sym_let,
    STATE(3555), 1,
      sym_attributes,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(11245), 1,
      sym_open,
    STATE(11281), 1,
      sym__binding_ids_and_absurds,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9907), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [298254] = 34,
    ACTIONS(700), 1,
      anon_sym_LBRACE_DASH_POUND,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2800), 1,
      anon_sym_quoteGoal,
    ACTIONS(2804), 1,
      anon_sym_let,
    ACTIONS(2806), 1,
      sym_id,
    ACTIONS(2810), 1,
      anon_sym_BSLASH,
    ACTIONS(2812), 1,
      anon_sym_u03bb,
    ACTIONS(2816), 1,
      anon_sym_record,
    ACTIONS(2818), 1,
      anon_sym_LPAREN,
    ACTIONS(2820), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2822), 1,
      anon_sym_u2983,
    ACTIONS(2824), 1,
      anon_sym_LBRACE,
    ACTIONS(2826), 1,
      aux_sym__qid_token1,
    ACTIONS(2828), 1,
      anon_sym_DOT,
    ACTIONS(2830), 1,
      anon_sym_tactic,
    ACTIONS(2832), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2834), 1,
      anon_sym_u2987,
    ACTIONS(2838), 1,
      anon_sym_Set,
    STATE(2185), 1,
      sym__ARROW,
    STATE(2671), 1,
      aux_sym__lambda_clauses_repeat1,
    STATE(3164), 1,
      sym_catchall_pragma,
    STATE(3364), 1,
      aux_sym__atoms,
    STATE(5831), 1,
      sym_atom,
    STATE(8081), 1,
      sym__LAMBDA,
    STATE(8490), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2794), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2808), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(2836), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5982), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(8989), 3,
      sym__lambda_clause_maybe_absurd,
      sym_lambda_clause_absurd,
      sym_lambda_clause,
    STATE(5981), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8988), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2814), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [298385] = 34,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(700), 1,
      anon_sym_LBRACE_DASH_POUND,
    ACTIONS(3134), 1,
      anon_sym_BSLASH,
    ACTIONS(3136), 1,
      anon_sym_u03bb,
    ACTIONS(3154), 1,
      anon_sym_quoteGoal,
    ACTIONS(3156), 1,
      anon_sym_tactic,
    ACTIONS(3162), 1,
      anon_sym_let,
    ACTIONS(3326), 1,
      sym_id,
    ACTIONS(3332), 1,
      anon_sym_record,
    ACTIONS(3334), 1,
      anon_sym_LPAREN,
    ACTIONS(3336), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3338), 1,
      anon_sym_u2983,
    ACTIONS(3340), 1,
      anon_sym_LBRACE,
    ACTIONS(3342), 1,
      aux_sym__qid_token1,
    ACTIONS(3344), 1,
      anon_sym_DOT,
    ACTIONS(3346), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3348), 1,
      anon_sym_u2987,
    ACTIONS(3352), 1,
      anon_sym_Set,
    STATE(1678), 1,
      sym__ARROW,
    STATE(2671), 1,
      aux_sym__lambda_clauses_repeat1,
    STATE(3227), 1,
      sym_catchall_pragma,
    STATE(3427), 1,
      aux_sym__atoms,
    STATE(4908), 1,
      sym_atom,
    STATE(8076), 1,
      sym__LAMBDA,
    STATE(8363), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3132), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3328), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(3350), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4650), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(8963), 3,
      sym__lambda_clause_maybe_absurd,
      sym_lambda_clause_absurd,
      sym_lambda_clause,
    STATE(4649), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9000), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3330), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [298516] = 34,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(700), 1,
      anon_sym_LBRACE_DASH_POUND,
    ACTIONS(2206), 1,
      sym_id,
    ACTIONS(2212), 1,
      anon_sym_BSLASH,
    ACTIONS(2214), 1,
      anon_sym_u03bb,
    ACTIONS(2218), 1,
      anon_sym_record,
    ACTIONS(2220), 1,
      anon_sym_LPAREN,
    ACTIONS(2222), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2224), 1,
      anon_sym_u2983,
    ACTIONS(2226), 1,
      anon_sym_LBRACE,
    ACTIONS(2228), 1,
      aux_sym__qid_token1,
    ACTIONS(2230), 1,
      anon_sym_DOT,
    ACTIONS(2232), 1,
      anon_sym_quoteGoal,
    ACTIONS(2234), 1,
      anon_sym_tactic,
    ACTIONS(2236), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2238), 1,
      anon_sym_u2987,
    ACTIONS(2240), 1,
      anon_sym_let,
    ACTIONS(2244), 1,
      anon_sym_Set,
    STATE(2163), 1,
      sym__ARROW,
    STATE(2671), 1,
      aux_sym__lambda_clauses_repeat1,
    STATE(3205), 1,
      sym_catchall_pragma,
    STATE(3701), 1,
      aux_sym__atoms,
    STATE(4718), 1,
      sym_atom,
    STATE(8035), 1,
      sym__LAMBDA,
    STATE(8402), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2210), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(2242), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4812), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(8963), 3,
      sym__lambda_clause_maybe_absurd,
      sym_lambda_clause_absurd,
      sym_lambda_clause,
    STATE(4858), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9000), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2216), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [298647] = 34,
    ACTIONS(700), 1,
      anon_sym_LBRACE_DASH_POUND,
    ACTIONS(706), 1,
      aux_sym__qid_token1,
    ACTIONS(714), 1,
      anon_sym_quoteGoal,
    ACTIONS(722), 1,
      anon_sym_let,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(3554), 1,
      sym_id,
    ACTIONS(3556), 1,
      anon_sym_BSLASH,
    ACTIONS(3558), 1,
      anon_sym_u03bb,
    ACTIONS(3562), 1,
      anon_sym_record,
    ACTIONS(3564), 1,
      anon_sym_LPAREN,
    ACTIONS(3566), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3568), 1,
      anon_sym_u2983,
    ACTIONS(3570), 1,
      anon_sym_LBRACE,
    ACTIONS(3572), 1,
      anon_sym_DOT,
    ACTIONS(3574), 1,
      anon_sym_tactic,
    ACTIONS(3576), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3578), 1,
      anon_sym_u2987,
    ACTIONS(3582), 1,
      anon_sym_Set,
    STATE(2651), 1,
      sym__ARROW,
    STATE(2671), 1,
      aux_sym__lambda_clauses_repeat1,
    STATE(3233), 1,
      sym_catchall_pragma,
    STATE(3567), 1,
      aux_sym__atoms,
    STATE(5237), 1,
      sym_atom,
    STATE(8092), 1,
      sym__LAMBDA,
    STATE(8495), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(682), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2604), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(3580), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5081), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(8989), 3,
      sym__lambda_clause_maybe_absurd,
      sym_lambda_clause_absurd,
      sym_lambda_clause,
    STATE(5079), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9459), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3560), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [298778] = 37,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(986), 1,
      anon_sym_open,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3978), 1,
      anon_sym_RPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4160), 1,
      anon_sym_let,
    STATE(3650), 1,
      sym_attributes,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(10533), 1,
      sym__binding_ids_and_absurds,
    STATE(10581), 1,
      sym_open,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9914), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [298915] = 34,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(700), 1,
      anon_sym_LBRACE_DASH_POUND,
    ACTIONS(3266), 1,
      anon_sym_BSLASH,
    ACTIONS(3268), 1,
      anon_sym_u03bb,
    ACTIONS(3286), 1,
      anon_sym_quoteGoal,
    ACTIONS(3288), 1,
      anon_sym_tactic,
    ACTIONS(3294), 1,
      anon_sym_let,
    ACTIONS(3732), 1,
      sym_id,
    ACTIONS(3738), 1,
      anon_sym_record,
    ACTIONS(3740), 1,
      anon_sym_LPAREN,
    ACTIONS(3742), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3744), 1,
      anon_sym_u2983,
    ACTIONS(3746), 1,
      anon_sym_LBRACE,
    ACTIONS(3748), 1,
      aux_sym__qid_token1,
    ACTIONS(3750), 1,
      anon_sym_DOT,
    ACTIONS(3752), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3754), 1,
      anon_sym_u2987,
    ACTIONS(3758), 1,
      anon_sym_Set,
    STATE(2021), 1,
      sym__ARROW,
    STATE(2671), 1,
      aux_sym__lambda_clauses_repeat1,
    STATE(3195), 1,
      sym_catchall_pragma,
    STATE(3592), 1,
      aux_sym__atoms,
    STATE(4058), 1,
      sym_atom,
    STATE(8143), 1,
      sym__LAMBDA,
    STATE(8451), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3264), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3734), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(3756), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4073), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(8971), 3,
      sym__lambda_clause_maybe_absurd,
      sym_lambda_clause_absurd,
      sym_lambda_clause,
    STATE(4070), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9000), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3736), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [299046] = 34,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(700), 1,
      anon_sym_LBRACE_DASH_POUND,
    ACTIONS(1870), 1,
      anon_sym_BSLASH,
    ACTIONS(1872), 1,
      anon_sym_u03bb,
    ACTIONS(1890), 1,
      anon_sym_quoteGoal,
    ACTIONS(1892), 1,
      anon_sym_tactic,
    ACTIONS(1898), 1,
      anon_sym_let,
    ACTIONS(3666), 1,
      sym_id,
    ACTIONS(3672), 1,
      anon_sym_record,
    ACTIONS(3674), 1,
      anon_sym_LPAREN,
    ACTIONS(3676), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3678), 1,
      anon_sym_u2983,
    ACTIONS(3680), 1,
      anon_sym_LBRACE,
    ACTIONS(3682), 1,
      aux_sym__qid_token1,
    ACTIONS(3684), 1,
      anon_sym_DOT,
    ACTIONS(3686), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3688), 1,
      anon_sym_u2987,
    ACTIONS(3692), 1,
      anon_sym_Set,
    STATE(1400), 1,
      sym__ARROW,
    STATE(2671), 1,
      aux_sym__lambda_clauses_repeat1,
    STATE(3172), 1,
      sym_catchall_pragma,
    STATE(3653), 1,
      aux_sym__atoms,
    STATE(4587), 1,
      sym_atom,
    STATE(8032), 1,
      sym__LAMBDA,
    STATE(8379), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1868), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3668), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(3690), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4585), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(8971), 3,
      sym__lambda_clause_maybe_absurd,
      sym_lambda_clause_absurd,
      sym_lambda_clause,
    STATE(4584), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9000), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3670), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [299177] = 37,
    ACTIONS(704), 1,
      anon_sym_RPAREN,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(986), 1,
      anon_sym_open,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4088), 1,
      anon_sym_let,
    STATE(3531), 1,
      sym_attributes,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(11097), 1,
      sym__binding_ids_and_absurds,
    STATE(11277), 1,
      sym_open,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9979), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [299314] = 34,
    ACTIONS(700), 1,
      anon_sym_LBRACE_DASH_POUND,
    ACTIONS(706), 1,
      aux_sym__qid_token1,
    ACTIONS(714), 1,
      anon_sym_quoteGoal,
    ACTIONS(722), 1,
      anon_sym_let,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(3554), 1,
      sym_id,
    ACTIONS(3556), 1,
      anon_sym_BSLASH,
    ACTIONS(3558), 1,
      anon_sym_u03bb,
    ACTIONS(3562), 1,
      anon_sym_record,
    ACTIONS(3564), 1,
      anon_sym_LPAREN,
    ACTIONS(3566), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3568), 1,
      anon_sym_u2983,
    ACTIONS(3570), 1,
      anon_sym_LBRACE,
    ACTIONS(3572), 1,
      anon_sym_DOT,
    ACTIONS(3574), 1,
      anon_sym_tactic,
    ACTIONS(3576), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3578), 1,
      anon_sym_u2987,
    ACTIONS(3582), 1,
      anon_sym_Set,
    STATE(2651), 1,
      sym__ARROW,
    STATE(2671), 1,
      aux_sym__lambda_clauses_repeat1,
    STATE(3233), 1,
      sym_catchall_pragma,
    STATE(3567), 1,
      aux_sym__atoms,
    STATE(5237), 1,
      sym_atom,
    STATE(8092), 1,
      sym__LAMBDA,
    STATE(8495), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(682), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2604), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(3580), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5081), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(8966), 3,
      sym__lambda_clause_maybe_absurd,
      sym_lambda_clause_absurd,
      sym_lambda_clause,
    STATE(5079), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9459), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3560), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [299445] = 37,
    ACTIONS(704), 1,
      anon_sym_RPAREN,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(986), 1,
      anon_sym_open,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4162), 1,
      anon_sym_let,
    STATE(3375), 1,
      sym_attributes,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(10648), 1,
      sym_open,
    STATE(10685), 1,
      sym__binding_ids_and_absurds,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9746), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [299582] = 37,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(986), 1,
      anon_sym_open,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4078), 1,
      anon_sym_RPAREN,
    ACTIONS(4156), 1,
      anon_sym_let,
    STATE(3618), 1,
      sym_attributes,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(10572), 1,
      sym_open,
    STATE(10610), 1,
      sym__binding_ids_and_absurds,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9758), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [299719] = 37,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(986), 1,
      anon_sym_open,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4078), 1,
      anon_sym_RPAREN,
    ACTIONS(4164), 1,
      anon_sym_let,
    STATE(3581), 1,
      sym_attributes,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(10769), 1,
      sym__binding_ids_and_absurds,
    STATE(10937), 1,
      sym_open,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9963), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [299856] = 34,
    ACTIONS(700), 1,
      anon_sym_LBRACE_DASH_POUND,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2302), 1,
      anon_sym_BSLASH,
    ACTIONS(2304), 1,
      anon_sym_u03bb,
    ACTIONS(2322), 1,
      anon_sym_quoteGoal,
    ACTIONS(2324), 1,
      anon_sym_tactic,
    ACTIONS(2330), 1,
      anon_sym_let,
    ACTIONS(3638), 1,
      sym_id,
    ACTIONS(3644), 1,
      anon_sym_record,
    ACTIONS(3646), 1,
      anon_sym_LPAREN,
    ACTIONS(3648), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3650), 1,
      anon_sym_u2983,
    ACTIONS(3652), 1,
      anon_sym_LBRACE,
    ACTIONS(3654), 1,
      aux_sym__qid_token1,
    ACTIONS(3656), 1,
      anon_sym_DOT,
    ACTIONS(3658), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3660), 1,
      anon_sym_u2987,
    ACTIONS(3664), 1,
      anon_sym_Set,
    STATE(1641), 1,
      sym__ARROW,
    STATE(2671), 1,
      aux_sym__lambda_clauses_repeat1,
    STATE(3275), 1,
      sym_catchall_pragma,
    STATE(3485), 1,
      aux_sym__atoms,
    STATE(5734), 1,
      sym_atom,
    STATE(8138), 1,
      sym__LAMBDA,
    STATE(8476), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2300), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3640), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(3662), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5680), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(8989), 3,
      sym__lambda_clause_maybe_absurd,
      sym_lambda_clause_absurd,
      sym_lambda_clause,
    STATE(5681), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8988), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3642), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [299987] = 37,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(986), 1,
      anon_sym_open,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3978), 1,
      anon_sym_RPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4132), 1,
      anon_sym_let,
    STATE(3523), 1,
      sym_attributes,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(10987), 1,
      sym_open,
    STATE(11024), 1,
      sym__binding_ids_and_absurds,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9781), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [300124] = 37,
    ACTIONS(704), 1,
      anon_sym_RPAREN,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(986), 1,
      anon_sym_open,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4152), 1,
      anon_sym_let,
    STATE(3518), 1,
      sym_attributes,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(11504), 1,
      sym_open,
    STATE(11558), 1,
      sym__binding_ids_and_absurds,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(10088), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [300261] = 37,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(986), 1,
      anon_sym_open,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3978), 1,
      anon_sym_RPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4166), 1,
      anon_sym_let,
    STATE(3606), 1,
      sym_attributes,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(10262), 1,
      sym_open,
    STATE(10299), 1,
      sym__binding_ids_and_absurds,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9835), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [300398] = 37,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(732), 1,
      anon_sym_RPAREN,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(986), 1,
      anon_sym_open,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4164), 1,
      anon_sym_let,
    STATE(3581), 1,
      sym_attributes,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(10769), 1,
      sym__binding_ids_and_absurds,
    STATE(10937), 1,
      sym_open,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9963), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [300535] = 34,
    ACTIONS(700), 1,
      anon_sym_LBRACE_DASH_POUND,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2422), 1,
      sym_id,
    ACTIONS(2428), 1,
      anon_sym_BSLASH,
    ACTIONS(2430), 1,
      anon_sym_u03bb,
    ACTIONS(2434), 1,
      anon_sym_record,
    ACTIONS(2436), 1,
      anon_sym_LPAREN,
    ACTIONS(2438), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2440), 1,
      anon_sym_u2983,
    ACTIONS(2442), 1,
      anon_sym_LBRACE,
    ACTIONS(2444), 1,
      aux_sym__qid_token1,
    ACTIONS(2446), 1,
      anon_sym_DOT,
    ACTIONS(2448), 1,
      anon_sym_quoteGoal,
    ACTIONS(2450), 1,
      anon_sym_tactic,
    ACTIONS(2452), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2454), 1,
      anon_sym_u2987,
    ACTIONS(2456), 1,
      anon_sym_let,
    ACTIONS(2460), 1,
      anon_sym_Set,
    STATE(2007), 1,
      sym__ARROW,
    STATE(2671), 1,
      aux_sym__lambda_clauses_repeat1,
    STATE(3222), 1,
      sym_catchall_pragma,
    STATE(3588), 1,
      aux_sym__atoms,
    STATE(5596), 1,
      sym_atom,
    STATE(8125), 1,
      sym__LAMBDA,
    STATE(8423), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2424), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2426), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(2458), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5422), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(8989), 3,
      sym__lambda_clause_maybe_absurd,
      sym_lambda_clause_absurd,
      sym_lambda_clause,
    STATE(5423), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8988), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2432), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [300666] = 37,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(732), 1,
      anon_sym_RPAREN,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(986), 1,
      anon_sym_open,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4168), 1,
      anon_sym_let,
    STATE(3571), 1,
      sym_attributes,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(10341), 1,
      sym__binding_ids_and_absurds,
    STATE(10394), 1,
      sym_open,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9853), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [300803] = 34,
    ACTIONS(700), 1,
      anon_sym_LBRACE_DASH_POUND,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2022), 1,
      anon_sym_BSLASH,
    ACTIONS(2024), 1,
      anon_sym_u03bb,
    ACTIONS(2042), 1,
      anon_sym_quoteGoal,
    ACTIONS(2044), 1,
      anon_sym_tactic,
    ACTIONS(2050), 1,
      anon_sym_let,
    ACTIONS(2766), 1,
      sym_id,
    ACTIONS(2772), 1,
      anon_sym_record,
    ACTIONS(2774), 1,
      anon_sym_LPAREN,
    ACTIONS(2776), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2778), 1,
      anon_sym_u2983,
    ACTIONS(2780), 1,
      anon_sym_LBRACE,
    ACTIONS(2782), 1,
      aux_sym__qid_token1,
    ACTIONS(2784), 1,
      anon_sym_DOT,
    ACTIONS(2786), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2788), 1,
      anon_sym_u2987,
    ACTIONS(2792), 1,
      anon_sym_Set,
    STATE(1522), 1,
      sym__ARROW,
    STATE(2671), 1,
      aux_sym__lambda_clauses_repeat1,
    STATE(3130), 1,
      sym_catchall_pragma,
    STATE(3637), 1,
      aux_sym__atoms,
    STATE(5719), 1,
      sym_atom,
    STATE(8033), 1,
      sym__LAMBDA,
    STATE(8463), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2020), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2768), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(2790), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5666), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(8966), 3,
      sym__lambda_clause_maybe_absurd,
      sym_lambda_clause_absurd,
      sym_lambda_clause,
    STATE(5668), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8988), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2770), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [300934] = 34,
    ACTIONS(700), 1,
      anon_sym_LBRACE_DASH_POUND,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(2676), 1,
      anon_sym_quoteGoal,
    ACTIONS(2684), 1,
      anon_sym_let,
    ACTIONS(2806), 1,
      sym_id,
    ACTIONS(2816), 1,
      anon_sym_record,
    ACTIONS(2818), 1,
      anon_sym_LPAREN,
    ACTIONS(2820), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2822), 1,
      anon_sym_u2983,
    ACTIONS(2824), 1,
      anon_sym_LBRACE,
    ACTIONS(2826), 1,
      aux_sym__qid_token1,
    ACTIONS(2828), 1,
      anon_sym_DOT,
    ACTIONS(2832), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2834), 1,
      anon_sym_u2987,
    ACTIONS(2838), 1,
      anon_sym_Set,
    ACTIONS(3906), 1,
      anon_sym_BSLASH,
    ACTIONS(3908), 1,
      anon_sym_u03bb,
    ACTIONS(3910), 1,
      anon_sym_tactic,
    STATE(2460), 1,
      sym__ARROW,
    STATE(2671), 1,
      aux_sym__lambda_clauses_repeat1,
    STATE(3229), 1,
      sym_catchall_pragma,
    STATE(3596), 1,
      aux_sym__atoms,
    STATE(5831), 1,
      sym_atom,
    STATE(8086), 1,
      sym__LAMBDA,
    STATE(8470), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(684), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(2654), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2836), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5982), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(8966), 3,
      sym__lambda_clause_maybe_absurd,
      sym_lambda_clause_absurd,
      sym_lambda_clause,
    STATE(5981), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9459), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2814), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [301065] = 37,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(986), 1,
      anon_sym_open,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4078), 1,
      anon_sym_RPAREN,
    ACTIONS(4168), 1,
      anon_sym_let,
    STATE(3571), 1,
      sym_attributes,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(10341), 1,
      sym__binding_ids_and_absurds,
    STATE(10394), 1,
      sym_open,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9853), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [301202] = 34,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(700), 1,
      anon_sym_LBRACE_DASH_POUND,
    ACTIONS(1870), 1,
      anon_sym_BSLASH,
    ACTIONS(1872), 1,
      anon_sym_u03bb,
    ACTIONS(1890), 1,
      anon_sym_quoteGoal,
    ACTIONS(1892), 1,
      anon_sym_tactic,
    ACTIONS(1898), 1,
      anon_sym_let,
    ACTIONS(3666), 1,
      sym_id,
    ACTIONS(3672), 1,
      anon_sym_record,
    ACTIONS(3674), 1,
      anon_sym_LPAREN,
    ACTIONS(3676), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3678), 1,
      anon_sym_u2983,
    ACTIONS(3680), 1,
      anon_sym_LBRACE,
    ACTIONS(3682), 1,
      aux_sym__qid_token1,
    ACTIONS(3684), 1,
      anon_sym_DOT,
    ACTIONS(3686), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3688), 1,
      anon_sym_u2987,
    ACTIONS(3692), 1,
      anon_sym_Set,
    STATE(1400), 1,
      sym__ARROW,
    STATE(2671), 1,
      aux_sym__lambda_clauses_repeat1,
    STATE(3172), 1,
      sym_catchall_pragma,
    STATE(3653), 1,
      aux_sym__atoms,
    STATE(4587), 1,
      sym_atom,
    STATE(8032), 1,
      sym__LAMBDA,
    STATE(8379), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1868), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3668), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(3690), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4585), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(8963), 3,
      sym__lambda_clause_maybe_absurd,
      sym_lambda_clause_absurd,
      sym_lambda_clause,
    STATE(4584), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9000), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3670), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [301333] = 37,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(986), 1,
      anon_sym_open,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4092), 1,
      anon_sym_RPAREN,
    ACTIONS(4096), 1,
      anon_sym_let,
    STATE(3386), 1,
      sym_attributes,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(10445), 1,
      sym__binding_ids_and_absurds,
    STATE(10486), 1,
      sym_open,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9886), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [301470] = 37,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(732), 1,
      anon_sym_RPAREN,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(986), 1,
      anon_sym_open,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4170), 1,
      anon_sym_let,
    STATE(3473), 1,
      sym_attributes,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(11062), 1,
      sym_open,
    STATE(11100), 1,
      sym__binding_ids_and_absurds,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9826), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [301607] = 37,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(986), 1,
      anon_sym_open,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3978), 1,
      anon_sym_RPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4162), 1,
      anon_sym_let,
    STATE(3375), 1,
      sym_attributes,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(10648), 1,
      sym_open,
    STATE(10685), 1,
      sym__binding_ids_and_absurds,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9746), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [301744] = 37,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(986), 1,
      anon_sym_open,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4078), 1,
      anon_sym_RPAREN,
    ACTIONS(4170), 1,
      anon_sym_let,
    STATE(3473), 1,
      sym_attributes,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(11062), 1,
      sym_open,
    STATE(11100), 1,
      sym__binding_ids_and_absurds,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9826), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [301881] = 34,
    ACTIONS(700), 1,
      anon_sym_LBRACE_DASH_POUND,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2302), 1,
      anon_sym_BSLASH,
    ACTIONS(2304), 1,
      anon_sym_u03bb,
    ACTIONS(2322), 1,
      anon_sym_quoteGoal,
    ACTIONS(2324), 1,
      anon_sym_tactic,
    ACTIONS(2330), 1,
      anon_sym_let,
    ACTIONS(3638), 1,
      sym_id,
    ACTIONS(3644), 1,
      anon_sym_record,
    ACTIONS(3646), 1,
      anon_sym_LPAREN,
    ACTIONS(3648), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3650), 1,
      anon_sym_u2983,
    ACTIONS(3652), 1,
      anon_sym_LBRACE,
    ACTIONS(3654), 1,
      aux_sym__qid_token1,
    ACTIONS(3656), 1,
      anon_sym_DOT,
    ACTIONS(3658), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3660), 1,
      anon_sym_u2987,
    ACTIONS(3664), 1,
      anon_sym_Set,
    STATE(1641), 1,
      sym__ARROW,
    STATE(2671), 1,
      aux_sym__lambda_clauses_repeat1,
    STATE(3275), 1,
      sym_catchall_pragma,
    STATE(3485), 1,
      aux_sym__atoms,
    STATE(5734), 1,
      sym_atom,
    STATE(8138), 1,
      sym__LAMBDA,
    STATE(8476), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2300), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3640), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(3662), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5680), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(8966), 3,
      sym__lambda_clause_maybe_absurd,
      sym_lambda_clause_absurd,
      sym_lambda_clause,
    STATE(5681), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8988), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3642), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [302012] = 37,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(986), 1,
      anon_sym_open,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3978), 1,
      anon_sym_RPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4154), 1,
      anon_sym_let,
    STATE(3686), 1,
      sym_attributes,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(11739), 1,
      sym__binding_ids_and_absurds,
    STATE(11810), 1,
      sym_open,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(10034), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [302149] = 37,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(986), 1,
      anon_sym_open,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4078), 1,
      anon_sym_RPAREN,
    ACTIONS(4124), 1,
      anon_sym_let,
    STATE(3497), 1,
      sym_attributes,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(11353), 1,
      sym_open,
    STATE(11389), 1,
      sym__binding_ids_and_absurds,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9924), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [302286] = 37,
    ACTIONS(704), 1,
      anon_sym_RPAREN,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(986), 1,
      anon_sym_open,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4166), 1,
      anon_sym_let,
    STATE(3606), 1,
      sym_attributes,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(10262), 1,
      sym_open,
    STATE(10299), 1,
      sym__binding_ids_and_absurds,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9835), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [302423] = 37,
    ACTIONS(704), 1,
      anon_sym_RPAREN,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(986), 1,
      anon_sym_open,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4136), 1,
      anon_sym_let,
    STATE(3480), 1,
      sym_attributes,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(10582), 1,
      sym__binding_ids_and_absurds,
    STATE(10622), 1,
      sym_open,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9934), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [302560] = 37,
    ACTIONS(704), 1,
      anon_sym_RPAREN,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(986), 1,
      anon_sym_open,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4146), 1,
      anon_sym_let,
    STATE(3450), 1,
      sym_attributes,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(11811), 1,
      sym__binding_ids_and_absurds,
    STATE(11900), 1,
      sym_open,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(10044), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [302697] = 34,
    ACTIONS(700), 1,
      anon_sym_LBRACE_DASH_POUND,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2094), 1,
      sym_id,
    ACTIONS(2100), 1,
      anon_sym_BSLASH,
    ACTIONS(2102), 1,
      anon_sym_u03bb,
    ACTIONS(2106), 1,
      anon_sym_record,
    ACTIONS(2108), 1,
      anon_sym_LPAREN,
    ACTIONS(2110), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2112), 1,
      anon_sym_u2983,
    ACTIONS(2114), 1,
      anon_sym_LBRACE,
    ACTIONS(2116), 1,
      aux_sym__qid_token1,
    ACTIONS(2118), 1,
      anon_sym_DOT,
    ACTIONS(2120), 1,
      anon_sym_quoteGoal,
    ACTIONS(2122), 1,
      anon_sym_tactic,
    ACTIONS(2124), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2126), 1,
      anon_sym_u2987,
    ACTIONS(2128), 1,
      anon_sym_let,
    ACTIONS(2132), 1,
      anon_sym_Set,
    STATE(1489), 1,
      sym__ARROW,
    STATE(2671), 1,
      aux_sym__lambda_clauses_repeat1,
    STATE(3291), 1,
      sym_catchall_pragma,
    STATE(3471), 1,
      aux_sym__atoms,
    STATE(5601), 1,
      sym_atom,
    STATE(8075), 1,
      sym__LAMBDA,
    STATE(8428), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2096), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2098), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(2130), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5451), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(9473), 3,
      sym__lambda_clause_maybe_absurd,
      sym_lambda_clause_absurd,
      sym_lambda_clause,
    STATE(5453), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8988), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2104), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [302828] = 36,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(986), 1,
      anon_sym_open,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4172), 1,
      anon_sym_let,
    STATE(3410), 1,
      sym_attributes,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(11560), 1,
      sym_open,
    STATE(12494), 1,
      sym__binding_ids_and_absurds,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9833), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [302962] = 36,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(986), 1,
      anon_sym_open,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4174), 1,
      anon_sym_let,
    STATE(3483), 1,
      sym_attributes,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(11390), 1,
      sym_open,
    STATE(11423), 1,
      sym__binding_ids_and_absurds,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9985), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [303096] = 36,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(986), 1,
      anon_sym_open,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4176), 1,
      anon_sym_let,
    STATE(3434), 1,
      sym_attributes,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(10728), 1,
      sym_open,
    STATE(10762), 1,
      sym__binding_ids_and_absurds,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9785), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [303230] = 36,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(986), 1,
      anon_sym_open,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4178), 1,
      anon_sym_let,
    STATE(3444), 1,
      sym_attributes,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(11462), 1,
      sym_open,
    STATE(11502), 1,
      sym__binding_ids_and_absurds,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(10032), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [303364] = 36,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(986), 1,
      anon_sym_open,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4180), 1,
      anon_sym_let,
    STATE(3539), 1,
      sym_attributes,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(11424), 1,
      sym_open,
    STATE(11460), 1,
      sym__binding_ids_and_absurds,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(10010), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [303498] = 36,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(986), 1,
      anon_sym_open,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4158), 1,
      anon_sym_let,
    STATE(3555), 1,
      sym_attributes,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(11245), 1,
      sym_open,
    STATE(11281), 1,
      sym__binding_ids_and_absurds,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9907), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [303632] = 34,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(878), 1,
      anon_sym_quoteGoal,
    ACTIONS(886), 1,
      anon_sym_let,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(4078), 1,
      anon_sym_u2984,
    ACTIONS(4182), 1,
      sym_id,
    ACTIONS(4184), 1,
      anon_sym_BSLASH,
    ACTIONS(4186), 1,
      anon_sym_u03bb,
    ACTIONS(4190), 1,
      anon_sym_record,
    ACTIONS(4192), 1,
      anon_sym_LPAREN,
    ACTIONS(4194), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4196), 1,
      anon_sym_u2983,
    ACTIONS(4198), 1,
      anon_sym_LBRACE,
    ACTIONS(4200), 1,
      aux_sym__qid_token1,
    ACTIONS(4202), 1,
      anon_sym_DOT,
    ACTIONS(4204), 1,
      anon_sym_tactic,
    ACTIONS(4206), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4208), 1,
      anon_sym_u2987,
    ACTIONS(4212), 1,
      anon_sym_Set,
    STATE(3467), 1,
      sym_attributes,
    STATE(3888), 1,
      aux_sym__atoms,
    STATE(6121), 1,
      sym__qid,
    STATE(6386), 1,
      sym_atom,
    STATE(8067), 1,
      sym__LAMBDA,
    STATE(8369), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(852), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4210), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6575), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6565), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(4188), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9879), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [303761] = 34,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(878), 1,
      anon_sym_quoteGoal,
    ACTIONS(886), 1,
      anon_sym_let,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(3978), 1,
      anon_sym_u2984,
    ACTIONS(4182), 1,
      sym_id,
    ACTIONS(4184), 1,
      anon_sym_BSLASH,
    ACTIONS(4186), 1,
      anon_sym_u03bb,
    ACTIONS(4190), 1,
      anon_sym_record,
    ACTIONS(4192), 1,
      anon_sym_LPAREN,
    ACTIONS(4194), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4196), 1,
      anon_sym_u2983,
    ACTIONS(4198), 1,
      anon_sym_LBRACE,
    ACTIONS(4200), 1,
      aux_sym__qid_token1,
    ACTIONS(4202), 1,
      anon_sym_DOT,
    ACTIONS(4204), 1,
      anon_sym_tactic,
    ACTIONS(4206), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4208), 1,
      anon_sym_u2987,
    ACTIONS(4212), 1,
      anon_sym_Set,
    STATE(3704), 1,
      sym_attributes,
    STATE(3888), 1,
      aux_sym__atoms,
    STATE(6121), 1,
      sym__qid,
    STATE(6386), 1,
      sym_atom,
    STATE(8067), 1,
      sym__LAMBDA,
    STATE(8369), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(852), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4210), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6575), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6565), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(4188), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10164), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [303890] = 34,
    ACTIONS(704), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(964), 1,
      anon_sym_quoteGoal,
    ACTIONS(972), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4214), 1,
      anon_sym_BSLASH,
    ACTIONS(4216), 1,
      anon_sym_u03bb,
    ACTIONS(4218), 1,
      anon_sym_tactic,
    STATE(3499), 1,
      sym_attributes,
    STATE(3891), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8047), 1,
      sym__LAMBDA,
    STATE(8355), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(942), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10225), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [304019] = 34,
    ACTIONS(710), 1,
      anon_sym_DASH,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(920), 1,
      anon_sym_quoteGoal,
    ACTIONS(928), 1,
      anon_sym_let,
    ACTIONS(3058), 1,
      anon_sym_BSLASH,
    ACTIONS(3060), 1,
      anon_sym_u03bb,
    ACTIONS(3064), 1,
      anon_sym_record,
    ACTIONS(3066), 1,
      anon_sym_LPAREN,
    ACTIONS(3068), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3070), 1,
      anon_sym_u2983,
    ACTIONS(3072), 1,
      anon_sym_LBRACE,
    ACTIONS(3076), 1,
      aux_sym__qid_token1,
    ACTIONS(3078), 1,
      anon_sym_DOT,
    ACTIONS(3080), 1,
      anon_sym_tactic,
    ACTIONS(3082), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3084), 1,
      anon_sym_u2987,
    ACTIONS(3088), 1,
      anon_sym_Set,
    ACTIONS(4078), 1,
      anon_sym_RBRACE,
    ACTIONS(4220), 1,
      sym_id,
    STATE(3420), 1,
      sym_attributes,
    STATE(3892), 1,
      aux_sym__atoms,
    STATE(6084), 1,
      sym__qid,
    STATE(6427), 1,
      sym_atom,
    STATE(8123), 1,
      sym__LAMBDA,
    STATE(8396), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3086), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6715), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6714), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3062), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9938), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [304148] = 34,
    ACTIONS(704), 1,
      anon_sym_u2984,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(878), 1,
      anon_sym_quoteGoal,
    ACTIONS(886), 1,
      anon_sym_let,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(4182), 1,
      sym_id,
    ACTIONS(4184), 1,
      anon_sym_BSLASH,
    ACTIONS(4186), 1,
      anon_sym_u03bb,
    ACTIONS(4190), 1,
      anon_sym_record,
    ACTIONS(4192), 1,
      anon_sym_LPAREN,
    ACTIONS(4194), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4196), 1,
      anon_sym_u2983,
    ACTIONS(4198), 1,
      anon_sym_LBRACE,
    ACTIONS(4200), 1,
      aux_sym__qid_token1,
    ACTIONS(4202), 1,
      anon_sym_DOT,
    ACTIONS(4204), 1,
      anon_sym_tactic,
    ACTIONS(4206), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4208), 1,
      anon_sym_u2987,
    ACTIONS(4212), 1,
      anon_sym_Set,
    STATE(3570), 1,
      sym_attributes,
    STATE(3888), 1,
      aux_sym__atoms,
    STATE(6121), 1,
      sym__qid,
    STATE(6386), 1,
      sym_atom,
    STATE(8067), 1,
      sym__LAMBDA,
    STATE(8369), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(852), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4210), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6575), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6565), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(4188), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10080), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [304277] = 34,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(878), 1,
      anon_sym_quoteGoal,
    ACTIONS(886), 1,
      anon_sym_let,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(3978), 1,
      anon_sym_u2984,
    ACTIONS(4182), 1,
      sym_id,
    ACTIONS(4184), 1,
      anon_sym_BSLASH,
    ACTIONS(4186), 1,
      anon_sym_u03bb,
    ACTIONS(4190), 1,
      anon_sym_record,
    ACTIONS(4192), 1,
      anon_sym_LPAREN,
    ACTIONS(4194), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4196), 1,
      anon_sym_u2983,
    ACTIONS(4198), 1,
      anon_sym_LBRACE,
    ACTIONS(4200), 1,
      aux_sym__qid_token1,
    ACTIONS(4202), 1,
      anon_sym_DOT,
    ACTIONS(4204), 1,
      anon_sym_tactic,
    ACTIONS(4206), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4208), 1,
      anon_sym_u2987,
    ACTIONS(4212), 1,
      anon_sym_Set,
    STATE(3475), 1,
      sym_attributes,
    STATE(3888), 1,
      aux_sym__atoms,
    STATE(6121), 1,
      sym__qid,
    STATE(6386), 1,
      sym_atom,
    STATE(8067), 1,
      sym__LAMBDA,
    STATE(8369), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(852), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4210), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6575), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6565), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(4188), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9958), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [304406] = 34,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(730), 1,
      anon_sym_u2984,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(878), 1,
      anon_sym_quoteGoal,
    ACTIONS(886), 1,
      anon_sym_let,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(4182), 1,
      sym_id,
    ACTIONS(4184), 1,
      anon_sym_BSLASH,
    ACTIONS(4186), 1,
      anon_sym_u03bb,
    ACTIONS(4190), 1,
      anon_sym_record,
    ACTIONS(4192), 1,
      anon_sym_LPAREN,
    ACTIONS(4194), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4196), 1,
      anon_sym_u2983,
    ACTIONS(4198), 1,
      anon_sym_LBRACE,
    ACTIONS(4200), 1,
      aux_sym__qid_token1,
    ACTIONS(4202), 1,
      anon_sym_DOT,
    ACTIONS(4204), 1,
      anon_sym_tactic,
    ACTIONS(4206), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4208), 1,
      anon_sym_u2987,
    ACTIONS(4212), 1,
      anon_sym_Set,
    STATE(3389), 1,
      sym_attributes,
    STATE(3888), 1,
      aux_sym__atoms,
    STATE(6121), 1,
      sym__qid,
    STATE(6386), 1,
      sym_atom,
    STATE(8067), 1,
      sym__LAMBDA,
    STATE(8369), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(852), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4210), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6575), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6565), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(4188), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10071), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [304535] = 34,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(964), 1,
      anon_sym_quoteGoal,
    ACTIONS(972), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3978), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4214), 1,
      anon_sym_BSLASH,
    ACTIONS(4216), 1,
      anon_sym_u03bb,
    ACTIONS(4218), 1,
      anon_sym_tactic,
    STATE(3479), 1,
      sym_attributes,
    STATE(3891), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8047), 1,
      sym__LAMBDA,
    STATE(8355), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(942), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9959), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [304664] = 34,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(964), 1,
      anon_sym_quoteGoal,
    ACTIONS(972), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4078), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(4214), 1,
      anon_sym_BSLASH,
    ACTIONS(4216), 1,
      anon_sym_u03bb,
    ACTIONS(4218), 1,
      anon_sym_tactic,
    STATE(3492), 1,
      sym_attributes,
    STATE(3891), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8047), 1,
      sym__LAMBDA,
    STATE(8355), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(942), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9970), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [304793] = 34,
    ACTIONS(704), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(964), 1,
      anon_sym_quoteGoal,
    ACTIONS(972), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4214), 1,
      anon_sym_BSLASH,
    ACTIONS(4216), 1,
      anon_sym_u03bb,
    ACTIONS(4218), 1,
      anon_sym_tactic,
    STATE(3511), 1,
      sym_attributes,
    STATE(3891), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8047), 1,
      sym__LAMBDA,
    STATE(8355), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(942), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10229), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [304922] = 34,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(878), 1,
      anon_sym_quoteGoal,
    ACTIONS(886), 1,
      anon_sym_let,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(4078), 1,
      anon_sym_u2984,
    ACTIONS(4182), 1,
      sym_id,
    ACTIONS(4184), 1,
      anon_sym_BSLASH,
    ACTIONS(4186), 1,
      anon_sym_u03bb,
    ACTIONS(4190), 1,
      anon_sym_record,
    ACTIONS(4192), 1,
      anon_sym_LPAREN,
    ACTIONS(4194), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4196), 1,
      anon_sym_u2983,
    ACTIONS(4198), 1,
      anon_sym_LBRACE,
    ACTIONS(4200), 1,
      aux_sym__qid_token1,
    ACTIONS(4202), 1,
      anon_sym_DOT,
    ACTIONS(4204), 1,
      anon_sym_tactic,
    ACTIONS(4206), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4208), 1,
      anon_sym_u2987,
    ACTIONS(4212), 1,
      anon_sym_Set,
    STATE(3491), 1,
      sym_attributes,
    STATE(3888), 1,
      aux_sym__atoms,
    STATE(6121), 1,
      sym__qid,
    STATE(6386), 1,
      sym_atom,
    STATE(8067), 1,
      sym__LAMBDA,
    STATE(8369), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(852), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4210), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6575), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6565), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(4188), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9968), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [305051] = 34,
    ACTIONS(710), 1,
      anon_sym_DASH,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(920), 1,
      anon_sym_quoteGoal,
    ACTIONS(928), 1,
      anon_sym_let,
    ACTIONS(3058), 1,
      anon_sym_BSLASH,
    ACTIONS(3060), 1,
      anon_sym_u03bb,
    ACTIONS(3064), 1,
      anon_sym_record,
    ACTIONS(3066), 1,
      anon_sym_LPAREN,
    ACTIONS(3068), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3070), 1,
      anon_sym_u2983,
    ACTIONS(3072), 1,
      anon_sym_LBRACE,
    ACTIONS(3076), 1,
      aux_sym__qid_token1,
    ACTIONS(3078), 1,
      anon_sym_DOT,
    ACTIONS(3080), 1,
      anon_sym_tactic,
    ACTIONS(3082), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3084), 1,
      anon_sym_u2987,
    ACTIONS(3088), 1,
      anon_sym_Set,
    ACTIONS(4078), 1,
      anon_sym_RBRACE,
    ACTIONS(4220), 1,
      sym_id,
    STATE(3459), 1,
      sym_attributes,
    STATE(3892), 1,
      aux_sym__atoms,
    STATE(6084), 1,
      sym__qid,
    STATE(6427), 1,
      sym_atom,
    STATE(8123), 1,
      sym__LAMBDA,
    STATE(8396), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3086), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6715), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6714), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3062), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9967), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [305180] = 34,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(730), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(964), 1,
      anon_sym_quoteGoal,
    ACTIONS(972), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4214), 1,
      anon_sym_BSLASH,
    ACTIONS(4216), 1,
      anon_sym_u03bb,
    ACTIONS(4218), 1,
      anon_sym_tactic,
    STATE(3388), 1,
      sym_attributes,
    STATE(3891), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8047), 1,
      sym__LAMBDA,
    STATE(8355), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(942), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10072), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [305309] = 34,
    ACTIONS(710), 1,
      anon_sym_DASH,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(920), 1,
      anon_sym_quoteGoal,
    ACTIONS(928), 1,
      anon_sym_let,
    ACTIONS(3058), 1,
      anon_sym_BSLASH,
    ACTIONS(3060), 1,
      anon_sym_u03bb,
    ACTIONS(3064), 1,
      anon_sym_record,
    ACTIONS(3066), 1,
      anon_sym_LPAREN,
    ACTIONS(3068), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3070), 1,
      anon_sym_u2983,
    ACTIONS(3072), 1,
      anon_sym_LBRACE,
    ACTIONS(3076), 1,
      aux_sym__qid_token1,
    ACTIONS(3078), 1,
      anon_sym_DOT,
    ACTIONS(3080), 1,
      anon_sym_tactic,
    ACTIONS(3082), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3084), 1,
      anon_sym_u2987,
    ACTIONS(3088), 1,
      anon_sym_Set,
    ACTIONS(4078), 1,
      anon_sym_RBRACE,
    ACTIONS(4220), 1,
      sym_id,
    STATE(3448), 1,
      sym_attributes,
    STATE(3892), 1,
      aux_sym__atoms,
    STATE(6084), 1,
      sym__qid,
    STATE(6427), 1,
      sym_atom,
    STATE(8123), 1,
      sym__LAMBDA,
    STATE(8396), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3086), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6715), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6714), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3062), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9762), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [305438] = 34,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(878), 1,
      anon_sym_quoteGoal,
    ACTIONS(886), 1,
      anon_sym_let,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(4078), 1,
      anon_sym_u2984,
    ACTIONS(4182), 1,
      sym_id,
    ACTIONS(4184), 1,
      anon_sym_BSLASH,
    ACTIONS(4186), 1,
      anon_sym_u03bb,
    ACTIONS(4190), 1,
      anon_sym_record,
    ACTIONS(4192), 1,
      anon_sym_LPAREN,
    ACTIONS(4194), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4196), 1,
      anon_sym_u2983,
    ACTIONS(4198), 1,
      anon_sym_LBRACE,
    ACTIONS(4200), 1,
      aux_sym__qid_token1,
    ACTIONS(4202), 1,
      anon_sym_DOT,
    ACTIONS(4204), 1,
      anon_sym_tactic,
    ACTIONS(4206), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4208), 1,
      anon_sym_u2987,
    ACTIONS(4212), 1,
      anon_sym_Set,
    STATE(3452), 1,
      sym_attributes,
    STATE(3888), 1,
      aux_sym__atoms,
    STATE(6121), 1,
      sym__qid,
    STATE(6386), 1,
      sym_atom,
    STATE(8067), 1,
      sym__LAMBDA,
    STATE(8369), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(852), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4210), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6575), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6565), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(4188), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9771), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [305567] = 34,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(964), 1,
      anon_sym_quoteGoal,
    ACTIONS(972), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3978), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4214), 1,
      anon_sym_BSLASH,
    ACTIONS(4216), 1,
      anon_sym_u03bb,
    ACTIONS(4218), 1,
      anon_sym_tactic,
    STATE(3521), 1,
      sym_attributes,
    STATE(3891), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8047), 1,
      sym__LAMBDA,
    STATE(8355), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(942), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9765), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [305696] = 34,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(878), 1,
      anon_sym_quoteGoal,
    ACTIONS(886), 1,
      anon_sym_let,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(3978), 1,
      anon_sym_u2984,
    ACTIONS(4182), 1,
      sym_id,
    ACTIONS(4184), 1,
      anon_sym_BSLASH,
    ACTIONS(4186), 1,
      anon_sym_u03bb,
    ACTIONS(4190), 1,
      anon_sym_record,
    ACTIONS(4192), 1,
      anon_sym_LPAREN,
    ACTIONS(4194), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4196), 1,
      anon_sym_u2983,
    ACTIONS(4198), 1,
      anon_sym_LBRACE,
    ACTIONS(4200), 1,
      aux_sym__qid_token1,
    ACTIONS(4202), 1,
      anon_sym_DOT,
    ACTIONS(4204), 1,
      anon_sym_tactic,
    ACTIONS(4206), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4208), 1,
      anon_sym_u2987,
    ACTIONS(4212), 1,
      anon_sym_Set,
    STATE(3402), 1,
      sym_attributes,
    STATE(3888), 1,
      aux_sym__atoms,
    STATE(6121), 1,
      sym__qid,
    STATE(6386), 1,
      sym_atom,
    STATE(8067), 1,
      sym__LAMBDA,
    STATE(8369), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(852), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4210), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6575), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6565), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(4188), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9769), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [305825] = 34,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(964), 1,
      anon_sym_quoteGoal,
    ACTIONS(972), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4078), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(4214), 1,
      anon_sym_BSLASH,
    ACTIONS(4216), 1,
      anon_sym_u03bb,
    ACTIONS(4218), 1,
      anon_sym_tactic,
    STATE(3470), 1,
      sym_attributes,
    STATE(3891), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8047), 1,
      sym__LAMBDA,
    STATE(8355), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(942), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9777), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [305954] = 34,
    ACTIONS(710), 1,
      anon_sym_DASH,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(920), 1,
      anon_sym_quoteGoal,
    ACTIONS(928), 1,
      anon_sym_let,
    ACTIONS(3058), 1,
      anon_sym_BSLASH,
    ACTIONS(3060), 1,
      anon_sym_u03bb,
    ACTIONS(3064), 1,
      anon_sym_record,
    ACTIONS(3066), 1,
      anon_sym_LPAREN,
    ACTIONS(3068), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3070), 1,
      anon_sym_u2983,
    ACTIONS(3072), 1,
      anon_sym_LBRACE,
    ACTIONS(3076), 1,
      aux_sym__qid_token1,
    ACTIONS(3078), 1,
      anon_sym_DOT,
    ACTIONS(3080), 1,
      anon_sym_tactic,
    ACTIONS(3082), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3084), 1,
      anon_sym_u2987,
    ACTIONS(3088), 1,
      anon_sym_Set,
    ACTIONS(3978), 1,
      anon_sym_RBRACE,
    ACTIONS(4220), 1,
      sym_id,
    STATE(3556), 1,
      sym_attributes,
    STATE(3892), 1,
      aux_sym__atoms,
    STATE(6084), 1,
      sym__qid,
    STATE(6427), 1,
      sym_atom,
    STATE(8123), 1,
      sym__LAMBDA,
    STATE(8396), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3086), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6715), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6714), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3062), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9786), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [306083] = 34,
    ACTIONS(704), 1,
      anon_sym_u2984,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(878), 1,
      anon_sym_quoteGoal,
    ACTIONS(886), 1,
      anon_sym_let,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(4182), 1,
      sym_id,
    ACTIONS(4184), 1,
      anon_sym_BSLASH,
    ACTIONS(4186), 1,
      anon_sym_u03bb,
    ACTIONS(4190), 1,
      anon_sym_record,
    ACTIONS(4192), 1,
      anon_sym_LPAREN,
    ACTIONS(4194), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4196), 1,
      anon_sym_u2983,
    ACTIONS(4198), 1,
      anon_sym_LBRACE,
    ACTIONS(4200), 1,
      aux_sym__qid_token1,
    ACTIONS(4202), 1,
      anon_sym_DOT,
    ACTIONS(4204), 1,
      anon_sym_tactic,
    ACTIONS(4206), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4208), 1,
      anon_sym_u2987,
    ACTIONS(4212), 1,
      anon_sym_Set,
    STATE(3475), 1,
      sym_attributes,
    STATE(3888), 1,
      aux_sym__atoms,
    STATE(6121), 1,
      sym__qid,
    STATE(6386), 1,
      sym_atom,
    STATE(8067), 1,
      sym__LAMBDA,
    STATE(8369), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(852), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4210), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6575), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6565), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(4188), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9958), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [306212] = 34,
    ACTIONS(704), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(964), 1,
      anon_sym_quoteGoal,
    ACTIONS(972), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4214), 1,
      anon_sym_BSLASH,
    ACTIONS(4216), 1,
      anon_sym_u03bb,
    ACTIONS(4218), 1,
      anon_sym_tactic,
    STATE(3479), 1,
      sym_attributes,
    STATE(3891), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8047), 1,
      sym__LAMBDA,
    STATE(8355), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(942), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9959), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [306341] = 34,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(732), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(964), 1,
      anon_sym_quoteGoal,
    ACTIONS(972), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4214), 1,
      anon_sym_BSLASH,
    ACTIONS(4216), 1,
      anon_sym_u03bb,
    ACTIONS(4218), 1,
      anon_sym_tactic,
    STATE(3537), 1,
      sym_attributes,
    STATE(3891), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8047), 1,
      sym__LAMBDA,
    STATE(8355), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(942), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9737), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [306470] = 34,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(964), 1,
      anon_sym_quoteGoal,
    ACTIONS(972), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3978), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4214), 1,
      anon_sym_BSLASH,
    ACTIONS(4216), 1,
      anon_sym_u03bb,
    ACTIONS(4218), 1,
      anon_sym_tactic,
    STATE(3625), 1,
      sym_attributes,
    STATE(3891), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8047), 1,
      sym__LAMBDA,
    STATE(8355), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(942), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10094), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [306599] = 34,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(732), 1,
      anon_sym_u2984,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(878), 1,
      anon_sym_quoteGoal,
    ACTIONS(886), 1,
      anon_sym_let,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(4182), 1,
      sym_id,
    ACTIONS(4184), 1,
      anon_sym_BSLASH,
    ACTIONS(4186), 1,
      anon_sym_u03bb,
    ACTIONS(4190), 1,
      anon_sym_record,
    ACTIONS(4192), 1,
      anon_sym_LPAREN,
    ACTIONS(4194), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4196), 1,
      anon_sym_u2983,
    ACTIONS(4198), 1,
      anon_sym_LBRACE,
    ACTIONS(4200), 1,
      aux_sym__qid_token1,
    ACTIONS(4202), 1,
      anon_sym_DOT,
    ACTIONS(4204), 1,
      anon_sym_tactic,
    ACTIONS(4206), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4208), 1,
      anon_sym_u2987,
    ACTIONS(4212), 1,
      anon_sym_Set,
    STATE(3452), 1,
      sym_attributes,
    STATE(3888), 1,
      aux_sym__atoms,
    STATE(6121), 1,
      sym__qid,
    STATE(6386), 1,
      sym_atom,
    STATE(8067), 1,
      sym__LAMBDA,
    STATE(8369), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(852), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4210), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6575), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6565), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(4188), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9771), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [306728] = 34,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(732), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(964), 1,
      anon_sym_quoteGoal,
    ACTIONS(972), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4214), 1,
      anon_sym_BSLASH,
    ACTIONS(4216), 1,
      anon_sym_u03bb,
    ACTIONS(4218), 1,
      anon_sym_tactic,
    STATE(3470), 1,
      sym_attributes,
    STATE(3891), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8047), 1,
      sym__LAMBDA,
    STATE(8355), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(942), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9777), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [306857] = 34,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(878), 1,
      anon_sym_quoteGoal,
    ACTIONS(886), 1,
      anon_sym_let,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(3978), 1,
      anon_sym_u2984,
    ACTIONS(4182), 1,
      sym_id,
    ACTIONS(4184), 1,
      anon_sym_BSLASH,
    ACTIONS(4186), 1,
      anon_sym_u03bb,
    ACTIONS(4190), 1,
      anon_sym_record,
    ACTIONS(4192), 1,
      anon_sym_LPAREN,
    ACTIONS(4194), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4196), 1,
      anon_sym_u2983,
    ACTIONS(4198), 1,
      anon_sym_LBRACE,
    ACTIONS(4200), 1,
      aux_sym__qid_token1,
    ACTIONS(4202), 1,
      anon_sym_DOT,
    ACTIONS(4204), 1,
      anon_sym_tactic,
    ACTIONS(4206), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4208), 1,
      anon_sym_u2987,
    ACTIONS(4212), 1,
      anon_sym_Set,
    STATE(3626), 1,
      sym_attributes,
    STATE(3888), 1,
      aux_sym__atoms,
    STATE(6121), 1,
      sym__qid,
    STATE(6386), 1,
      sym_atom,
    STATE(8067), 1,
      sym__LAMBDA,
    STATE(8369), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(852), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4210), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6575), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6565), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(4188), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10195), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [306986] = 34,
    ACTIONS(710), 1,
      anon_sym_DASH,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(920), 1,
      anon_sym_quoteGoal,
    ACTIONS(928), 1,
      anon_sym_let,
    ACTIONS(3058), 1,
      anon_sym_BSLASH,
    ACTIONS(3060), 1,
      anon_sym_u03bb,
    ACTIONS(3064), 1,
      anon_sym_record,
    ACTIONS(3066), 1,
      anon_sym_LPAREN,
    ACTIONS(3068), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3070), 1,
      anon_sym_u2983,
    ACTIONS(3072), 1,
      anon_sym_LBRACE,
    ACTIONS(3076), 1,
      aux_sym__qid_token1,
    ACTIONS(3078), 1,
      anon_sym_DOT,
    ACTIONS(3080), 1,
      anon_sym_tactic,
    ACTIONS(3082), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3084), 1,
      anon_sym_u2987,
    ACTIONS(3088), 1,
      anon_sym_Set,
    ACTIONS(3978), 1,
      anon_sym_RBRACE,
    ACTIONS(4220), 1,
      sym_id,
    STATE(3627), 1,
      sym_attributes,
    STATE(3892), 1,
      aux_sym__atoms,
    STATE(6084), 1,
      sym__qid,
    STATE(6427), 1,
      sym_atom,
    STATE(8123), 1,
      sym__LAMBDA,
    STATE(8396), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3086), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6715), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6714), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3062), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10107), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [307115] = 34,
    ACTIONS(710), 1,
      anon_sym_DASH,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(920), 1,
      anon_sym_quoteGoal,
    ACTIONS(928), 1,
      anon_sym_let,
    ACTIONS(3058), 1,
      anon_sym_BSLASH,
    ACTIONS(3060), 1,
      anon_sym_u03bb,
    ACTIONS(3064), 1,
      anon_sym_record,
    ACTIONS(3066), 1,
      anon_sym_LPAREN,
    ACTIONS(3068), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3070), 1,
      anon_sym_u2983,
    ACTIONS(3072), 1,
      anon_sym_LBRACE,
    ACTIONS(3076), 1,
      aux_sym__qid_token1,
    ACTIONS(3078), 1,
      anon_sym_DOT,
    ACTIONS(3080), 1,
      anon_sym_tactic,
    ACTIONS(3082), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3084), 1,
      anon_sym_u2987,
    ACTIONS(3088), 1,
      anon_sym_Set,
    ACTIONS(3978), 1,
      anon_sym_RBRACE,
    ACTIONS(4220), 1,
      sym_id,
    STATE(3608), 1,
      sym_attributes,
    STATE(3892), 1,
      aux_sym__atoms,
    STATE(6084), 1,
      sym__qid,
    STATE(6427), 1,
      sym_atom,
    STATE(8123), 1,
      sym__LAMBDA,
    STATE(8396), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3086), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6715), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6714), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3062), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10199), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [307244] = 34,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(964), 1,
      anon_sym_quoteGoal,
    ACTIONS(972), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3978), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4214), 1,
      anon_sym_BSLASH,
    ACTIONS(4216), 1,
      anon_sym_u03bb,
    ACTIONS(4218), 1,
      anon_sym_tactic,
    STATE(3396), 1,
      sym_attributes,
    STATE(3891), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8047), 1,
      sym__LAMBDA,
    STATE(8355), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(942), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10224), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [307373] = 34,
    ACTIONS(710), 1,
      anon_sym_DASH,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(920), 1,
      anon_sym_quoteGoal,
    ACTIONS(928), 1,
      anon_sym_let,
    ACTIONS(3058), 1,
      anon_sym_BSLASH,
    ACTIONS(3060), 1,
      anon_sym_u03bb,
    ACTIONS(3064), 1,
      anon_sym_record,
    ACTIONS(3066), 1,
      anon_sym_LPAREN,
    ACTIONS(3068), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3070), 1,
      anon_sym_u2983,
    ACTIONS(3072), 1,
      anon_sym_LBRACE,
    ACTIONS(3076), 1,
      aux_sym__qid_token1,
    ACTIONS(3078), 1,
      anon_sym_DOT,
    ACTIONS(3080), 1,
      anon_sym_tactic,
    ACTIONS(3082), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3084), 1,
      anon_sym_u2987,
    ACTIONS(3088), 1,
      anon_sym_Set,
    ACTIONS(4078), 1,
      anon_sym_RBRACE,
    ACTIONS(4220), 1,
      sym_id,
    STATE(3564), 1,
      sym_attributes,
    STATE(3892), 1,
      aux_sym__atoms,
    STATE(6084), 1,
      sym__qid,
    STATE(6427), 1,
      sym_atom,
    STATE(8123), 1,
      sym__LAMBDA,
    STATE(8396), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3086), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6715), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6714), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3062), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10147), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [307502] = 34,
    ACTIONS(710), 1,
      anon_sym_DASH,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(920), 1,
      anon_sym_quoteGoal,
    ACTIONS(928), 1,
      anon_sym_let,
    ACTIONS(3058), 1,
      anon_sym_BSLASH,
    ACTIONS(3060), 1,
      anon_sym_u03bb,
    ACTIONS(3064), 1,
      anon_sym_record,
    ACTIONS(3066), 1,
      anon_sym_LPAREN,
    ACTIONS(3068), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3070), 1,
      anon_sym_u2983,
    ACTIONS(3072), 1,
      anon_sym_LBRACE,
    ACTIONS(3076), 1,
      aux_sym__qid_token1,
    ACTIONS(3078), 1,
      anon_sym_DOT,
    ACTIONS(3080), 1,
      anon_sym_tactic,
    ACTIONS(3082), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3084), 1,
      anon_sym_u2987,
    ACTIONS(3088), 1,
      anon_sym_Set,
    ACTIONS(3978), 1,
      anon_sym_RBRACE,
    ACTIONS(4220), 1,
      sym_id,
    STATE(3638), 1,
      sym_attributes,
    STATE(3892), 1,
      aux_sym__atoms,
    STATE(6084), 1,
      sym__qid,
    STATE(6427), 1,
      sym_atom,
    STATE(8123), 1,
      sym__LAMBDA,
    STATE(8396), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3086), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6715), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6714), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3062), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9882), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [307631] = 34,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(878), 1,
      anon_sym_quoteGoal,
    ACTIONS(886), 1,
      anon_sym_let,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(3978), 1,
      anon_sym_u2984,
    ACTIONS(4182), 1,
      sym_id,
    ACTIONS(4184), 1,
      anon_sym_BSLASH,
    ACTIONS(4186), 1,
      anon_sym_u03bb,
    ACTIONS(4190), 1,
      anon_sym_record,
    ACTIONS(4192), 1,
      anon_sym_LPAREN,
    ACTIONS(4194), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4196), 1,
      anon_sym_u2983,
    ACTIONS(4198), 1,
      anon_sym_LBRACE,
    ACTIONS(4200), 1,
      aux_sym__qid_token1,
    ACTIONS(4202), 1,
      anon_sym_DOT,
    ACTIONS(4204), 1,
      anon_sym_tactic,
    ACTIONS(4206), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4208), 1,
      anon_sym_u2987,
    ACTIONS(4212), 1,
      anon_sym_Set,
    STATE(3609), 1,
      sym_attributes,
    STATE(3888), 1,
      aux_sym__atoms,
    STATE(6121), 1,
      sym__qid,
    STATE(6386), 1,
      sym_atom,
    STATE(8067), 1,
      sym__LAMBDA,
    STATE(8369), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(852), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4210), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6575), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6565), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(4188), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10198), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [307760] = 34,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(878), 1,
      anon_sym_quoteGoal,
    ACTIONS(886), 1,
      anon_sym_let,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(4078), 1,
      anon_sym_u2984,
    ACTIONS(4182), 1,
      sym_id,
    ACTIONS(4184), 1,
      anon_sym_BSLASH,
    ACTIONS(4186), 1,
      anon_sym_u03bb,
    ACTIONS(4190), 1,
      anon_sym_record,
    ACTIONS(4192), 1,
      anon_sym_LPAREN,
    ACTIONS(4194), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4196), 1,
      anon_sym_u2983,
    ACTIONS(4198), 1,
      anon_sym_LBRACE,
    ACTIONS(4200), 1,
      aux_sym__qid_token1,
    ACTIONS(4202), 1,
      anon_sym_DOT,
    ACTIONS(4204), 1,
      anon_sym_tactic,
    ACTIONS(4206), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4208), 1,
      anon_sym_u2987,
    ACTIONS(4212), 1,
      anon_sym_Set,
    STATE(3565), 1,
      sym_attributes,
    STATE(3888), 1,
      aux_sym__atoms,
    STATE(6121), 1,
      sym__qid,
    STATE(6386), 1,
      sym_atom,
    STATE(8067), 1,
      sym__LAMBDA,
    STATE(8369), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(852), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4210), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6575), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6565), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(4188), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10148), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [307889] = 34,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(878), 1,
      anon_sym_quoteGoal,
    ACTIONS(886), 1,
      anon_sym_let,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(3978), 1,
      anon_sym_u2984,
    ACTIONS(4182), 1,
      sym_id,
    ACTIONS(4184), 1,
      anon_sym_BSLASH,
    ACTIONS(4186), 1,
      anon_sym_u03bb,
    ACTIONS(4190), 1,
      anon_sym_record,
    ACTIONS(4192), 1,
      anon_sym_LPAREN,
    ACTIONS(4194), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4196), 1,
      anon_sym_u2983,
    ACTIONS(4198), 1,
      anon_sym_LBRACE,
    ACTIONS(4200), 1,
      aux_sym__qid_token1,
    ACTIONS(4202), 1,
      anon_sym_DOT,
    ACTIONS(4204), 1,
      anon_sym_tactic,
    ACTIONS(4206), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4208), 1,
      anon_sym_u2987,
    ACTIONS(4212), 1,
      anon_sym_Set,
    STATE(3350), 1,
      sym_attributes,
    STATE(3888), 1,
      aux_sym__atoms,
    STATE(6121), 1,
      sym__qid,
    STATE(6386), 1,
      sym_atom,
    STATE(8067), 1,
      sym__LAMBDA,
    STATE(8369), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(852), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4210), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6575), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6565), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(4188), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9876), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [308018] = 34,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(964), 1,
      anon_sym_quoteGoal,
    ACTIONS(972), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3978), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4214), 1,
      anon_sym_BSLASH,
    ACTIONS(4216), 1,
      anon_sym_u03bb,
    ACTIONS(4218), 1,
      anon_sym_tactic,
    STATE(3365), 1,
      sym_attributes,
    STATE(3891), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8047), 1,
      sym__LAMBDA,
    STATE(8355), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(942), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9875), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [308147] = 34,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(964), 1,
      anon_sym_quoteGoal,
    ACTIONS(972), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4078), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(4214), 1,
      anon_sym_BSLASH,
    ACTIONS(4216), 1,
      anon_sym_u03bb,
    ACTIONS(4218), 1,
      anon_sym_tactic,
    STATE(3568), 1,
      sym_attributes,
    STATE(3891), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8047), 1,
      sym__LAMBDA,
    STATE(8355), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(942), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10149), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [308276] = 34,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(964), 1,
      anon_sym_quoteGoal,
    ACTIONS(972), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3978), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4214), 1,
      anon_sym_BSLASH,
    ACTIONS(4216), 1,
      anon_sym_u03bb,
    ACTIONS(4218), 1,
      anon_sym_tactic,
    STATE(3623), 1,
      sym_attributes,
    STATE(3891), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8047), 1,
      sym__LAMBDA,
    STATE(8355), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(942), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10197), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [308405] = 34,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(732), 1,
      anon_sym_u2984,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(878), 1,
      anon_sym_quoteGoal,
    ACTIONS(886), 1,
      anon_sym_let,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(4182), 1,
      sym_id,
    ACTIONS(4184), 1,
      anon_sym_BSLASH,
    ACTIONS(4186), 1,
      anon_sym_u03bb,
    ACTIONS(4190), 1,
      anon_sym_record,
    ACTIONS(4192), 1,
      anon_sym_LPAREN,
    ACTIONS(4194), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4196), 1,
      anon_sym_u2983,
    ACTIONS(4198), 1,
      anon_sym_LBRACE,
    ACTIONS(4200), 1,
      aux_sym__qid_token1,
    ACTIONS(4202), 1,
      anon_sym_DOT,
    ACTIONS(4204), 1,
      anon_sym_tactic,
    ACTIONS(4206), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4208), 1,
      anon_sym_u2987,
    ACTIONS(4212), 1,
      anon_sym_Set,
    STATE(3536), 1,
      sym_attributes,
    STATE(3888), 1,
      aux_sym__atoms,
    STATE(6121), 1,
      sym__qid,
    STATE(6386), 1,
      sym_atom,
    STATE(8067), 1,
      sym__LAMBDA,
    STATE(8369), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(852), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4210), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6575), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6565), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(4188), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9738), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [308534] = 34,
    ACTIONS(704), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(964), 1,
      anon_sym_quoteGoal,
    ACTIONS(972), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4214), 1,
      anon_sym_BSLASH,
    ACTIONS(4216), 1,
      anon_sym_u03bb,
    ACTIONS(4218), 1,
      anon_sym_tactic,
    STATE(3605), 1,
      sym_attributes,
    STATE(3891), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8047), 1,
      sym__LAMBDA,
    STATE(8355), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(942), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10179), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [308663] = 34,
    ACTIONS(704), 1,
      anon_sym_u2984,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(878), 1,
      anon_sym_quoteGoal,
    ACTIONS(886), 1,
      anon_sym_let,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(4182), 1,
      sym_id,
    ACTIONS(4184), 1,
      anon_sym_BSLASH,
    ACTIONS(4186), 1,
      anon_sym_u03bb,
    ACTIONS(4190), 1,
      anon_sym_record,
    ACTIONS(4192), 1,
      anon_sym_LPAREN,
    ACTIONS(4194), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4196), 1,
      anon_sym_u2983,
    ACTIONS(4198), 1,
      anon_sym_LBRACE,
    ACTIONS(4200), 1,
      aux_sym__qid_token1,
    ACTIONS(4202), 1,
      anon_sym_DOT,
    ACTIONS(4204), 1,
      anon_sym_tactic,
    ACTIONS(4206), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4208), 1,
      anon_sym_u2987,
    ACTIONS(4212), 1,
      anon_sym_Set,
    STATE(3602), 1,
      sym_attributes,
    STATE(3888), 1,
      aux_sym__atoms,
    STATE(6121), 1,
      sym__qid,
    STATE(6386), 1,
      sym_atom,
    STATE(8067), 1,
      sym__LAMBDA,
    STATE(8369), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(852), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4210), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6575), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6565), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(4188), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10181), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [308792] = 34,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(732), 1,
      anon_sym_u2984,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(878), 1,
      anon_sym_quoteGoal,
    ACTIONS(886), 1,
      anon_sym_let,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(4182), 1,
      sym_id,
    ACTIONS(4184), 1,
      anon_sym_BSLASH,
    ACTIONS(4186), 1,
      anon_sym_u03bb,
    ACTIONS(4190), 1,
      anon_sym_record,
    ACTIONS(4192), 1,
      anon_sym_LPAREN,
    ACTIONS(4194), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4196), 1,
      anon_sym_u2983,
    ACTIONS(4198), 1,
      anon_sym_LBRACE,
    ACTIONS(4200), 1,
      aux_sym__qid_token1,
    ACTIONS(4202), 1,
      anon_sym_DOT,
    ACTIONS(4204), 1,
      anon_sym_tactic,
    ACTIONS(4206), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4208), 1,
      anon_sym_u2987,
    ACTIONS(4212), 1,
      anon_sym_Set,
    STATE(3565), 1,
      sym_attributes,
    STATE(3888), 1,
      aux_sym__atoms,
    STATE(6121), 1,
      sym__qid,
    STATE(6386), 1,
      sym_atom,
    STATE(8067), 1,
      sym__LAMBDA,
    STATE(8369), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(852), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4210), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6575), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6565), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(4188), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10148), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [308921] = 34,
    ACTIONS(704), 1,
      anon_sym_u2984,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(878), 1,
      anon_sym_quoteGoal,
    ACTIONS(886), 1,
      anon_sym_let,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(4182), 1,
      sym_id,
    ACTIONS(4184), 1,
      anon_sym_BSLASH,
    ACTIONS(4186), 1,
      anon_sym_u03bb,
    ACTIONS(4190), 1,
      anon_sym_record,
    ACTIONS(4192), 1,
      anon_sym_LPAREN,
    ACTIONS(4194), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4196), 1,
      anon_sym_u2983,
    ACTIONS(4198), 1,
      anon_sym_LBRACE,
    ACTIONS(4200), 1,
      aux_sym__qid_token1,
    ACTIONS(4202), 1,
      anon_sym_DOT,
    ACTIONS(4204), 1,
      anon_sym_tactic,
    ACTIONS(4206), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4208), 1,
      anon_sym_u2987,
    ACTIONS(4212), 1,
      anon_sym_Set,
    STATE(3424), 1,
      sym_attributes,
    STATE(3888), 1,
      aux_sym__atoms,
    STATE(6121), 1,
      sym__qid,
    STATE(6386), 1,
      sym_atom,
    STATE(8067), 1,
      sym__LAMBDA,
    STATE(8369), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(852), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4210), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6575), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6565), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(4188), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9774), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [309050] = 34,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(732), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(964), 1,
      anon_sym_quoteGoal,
    ACTIONS(972), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4214), 1,
      anon_sym_BSLASH,
    ACTIONS(4216), 1,
      anon_sym_u03bb,
    ACTIONS(4218), 1,
      anon_sym_tactic,
    STATE(3568), 1,
      sym_attributes,
    STATE(3891), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8047), 1,
      sym__LAMBDA,
    STATE(8355), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(942), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10149), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [309179] = 34,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(964), 1,
      anon_sym_quoteGoal,
    ACTIONS(972), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4092), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(4214), 1,
      anon_sym_BSLASH,
    ACTIONS(4216), 1,
      anon_sym_u03bb,
    ACTIONS(4218), 1,
      anon_sym_tactic,
    STATE(3388), 1,
      sym_attributes,
    STATE(3891), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8047), 1,
      sym__LAMBDA,
    STATE(8355), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(942), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10072), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [309308] = 34,
    ACTIONS(704), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(964), 1,
      anon_sym_quoteGoal,
    ACTIONS(972), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4214), 1,
      anon_sym_BSLASH,
    ACTIONS(4216), 1,
      anon_sym_u03bb,
    ACTIONS(4218), 1,
      anon_sym_tactic,
    STATE(3524), 1,
      sym_attributes,
    STATE(3891), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8047), 1,
      sym__LAMBDA,
    STATE(8355), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(942), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9696), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [309437] = 34,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(878), 1,
      anon_sym_quoteGoal,
    ACTIONS(886), 1,
      anon_sym_let,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(4092), 1,
      anon_sym_u2984,
    ACTIONS(4182), 1,
      sym_id,
    ACTIONS(4184), 1,
      anon_sym_BSLASH,
    ACTIONS(4186), 1,
      anon_sym_u03bb,
    ACTIONS(4190), 1,
      anon_sym_record,
    ACTIONS(4192), 1,
      anon_sym_LPAREN,
    ACTIONS(4194), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4196), 1,
      anon_sym_u2983,
    ACTIONS(4198), 1,
      anon_sym_LBRACE,
    ACTIONS(4200), 1,
      aux_sym__qid_token1,
    ACTIONS(4202), 1,
      anon_sym_DOT,
    ACTIONS(4204), 1,
      anon_sym_tactic,
    ACTIONS(4206), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4208), 1,
      anon_sym_u2987,
    ACTIONS(4212), 1,
      anon_sym_Set,
    STATE(3389), 1,
      sym_attributes,
    STATE(3888), 1,
      aux_sym__atoms,
    STATE(6121), 1,
      sym__qid,
    STATE(6386), 1,
      sym_atom,
    STATE(8067), 1,
      sym__LAMBDA,
    STATE(8369), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(852), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4210), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6575), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6565), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(4188), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10071), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [309566] = 34,
    ACTIONS(704), 1,
      anon_sym_u2984,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(878), 1,
      anon_sym_quoteGoal,
    ACTIONS(886), 1,
      anon_sym_let,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(4182), 1,
      sym_id,
    ACTIONS(4184), 1,
      anon_sym_BSLASH,
    ACTIONS(4186), 1,
      anon_sym_u03bb,
    ACTIONS(4190), 1,
      anon_sym_record,
    ACTIONS(4192), 1,
      anon_sym_LPAREN,
    ACTIONS(4194), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4196), 1,
      anon_sym_u2983,
    ACTIONS(4198), 1,
      anon_sym_LBRACE,
    ACTIONS(4200), 1,
      aux_sym__qid_token1,
    ACTIONS(4202), 1,
      anon_sym_DOT,
    ACTIONS(4204), 1,
      anon_sym_tactic,
    ACTIONS(4206), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4208), 1,
      anon_sym_u2987,
    ACTIONS(4212), 1,
      anon_sym_Set,
    STATE(3526), 1,
      sym_attributes,
    STATE(3888), 1,
      aux_sym__atoms,
    STATE(6121), 1,
      sym__qid,
    STATE(6386), 1,
      sym_atom,
    STATE(8067), 1,
      sym__LAMBDA,
    STATE(8369), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(852), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4210), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6575), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6565), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(4188), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9697), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [309695] = 34,
    ACTIONS(710), 1,
      anon_sym_DASH,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(920), 1,
      anon_sym_quoteGoal,
    ACTIONS(928), 1,
      anon_sym_let,
    ACTIONS(3058), 1,
      anon_sym_BSLASH,
    ACTIONS(3060), 1,
      anon_sym_u03bb,
    ACTIONS(3064), 1,
      anon_sym_record,
    ACTIONS(3066), 1,
      anon_sym_LPAREN,
    ACTIONS(3068), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3070), 1,
      anon_sym_u2983,
    ACTIONS(3072), 1,
      anon_sym_LBRACE,
    ACTIONS(3076), 1,
      aux_sym__qid_token1,
    ACTIONS(3078), 1,
      anon_sym_DOT,
    ACTIONS(3080), 1,
      anon_sym_tactic,
    ACTIONS(3082), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3084), 1,
      anon_sym_u2987,
    ACTIONS(3088), 1,
      anon_sym_Set,
    ACTIONS(4092), 1,
      anon_sym_RBRACE,
    ACTIONS(4220), 1,
      sym_id,
    STATE(3421), 1,
      sym_attributes,
    STATE(3892), 1,
      aux_sym__atoms,
    STATE(6084), 1,
      sym__qid,
    STATE(6427), 1,
      sym_atom,
    STATE(8123), 1,
      sym__LAMBDA,
    STATE(8396), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3086), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6715), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6714), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3062), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10069), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [309824] = 34,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(732), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(964), 1,
      anon_sym_quoteGoal,
    ACTIONS(972), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4214), 1,
      anon_sym_BSLASH,
    ACTIONS(4216), 1,
      anon_sym_u03bb,
    ACTIONS(4218), 1,
      anon_sym_tactic,
    STATE(3635), 1,
      sym_attributes,
    STATE(3891), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8047), 1,
      sym__LAMBDA,
    STATE(8355), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(942), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9817), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [309953] = 34,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(732), 1,
      anon_sym_u2984,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(878), 1,
      anon_sym_quoteGoal,
    ACTIONS(886), 1,
      anon_sym_let,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(4182), 1,
      sym_id,
    ACTIONS(4184), 1,
      anon_sym_BSLASH,
    ACTIONS(4186), 1,
      anon_sym_u03bb,
    ACTIONS(4190), 1,
      anon_sym_record,
    ACTIONS(4192), 1,
      anon_sym_LPAREN,
    ACTIONS(4194), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4196), 1,
      anon_sym_u2983,
    ACTIONS(4198), 1,
      anon_sym_LBRACE,
    ACTIONS(4200), 1,
      aux_sym__qid_token1,
    ACTIONS(4202), 1,
      anon_sym_DOT,
    ACTIONS(4204), 1,
      anon_sym_tactic,
    ACTIONS(4206), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4208), 1,
      anon_sym_u2987,
    ACTIONS(4212), 1,
      anon_sym_Set,
    STATE(3355), 1,
      sym_attributes,
    STATE(3888), 1,
      aux_sym__atoms,
    STATE(6121), 1,
      sym__qid,
    STATE(6386), 1,
      sym_atom,
    STATE(8067), 1,
      sym__LAMBDA,
    STATE(8369), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(852), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4210), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6575), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6565), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(4188), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9816), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [310082] = 34,
    ACTIONS(704), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(964), 1,
      anon_sym_quoteGoal,
    ACTIONS(972), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4214), 1,
      anon_sym_BSLASH,
    ACTIONS(4216), 1,
      anon_sym_u03bb,
    ACTIONS(4218), 1,
      anon_sym_tactic,
    STATE(3454), 1,
      sym_attributes,
    STATE(3891), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8047), 1,
      sym__LAMBDA,
    STATE(8355), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(942), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9773), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [310211] = 34,
    ACTIONS(704), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(964), 1,
      anon_sym_quoteGoal,
    ACTIONS(972), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4214), 1,
      anon_sym_BSLASH,
    ACTIONS(4216), 1,
      anon_sym_u03bb,
    ACTIONS(4218), 1,
      anon_sym_tactic,
    STATE(3558), 1,
      sym_attributes,
    STATE(3891), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8047), 1,
      sym__LAMBDA,
    STATE(8355), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(942), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9831), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [310340] = 34,
    ACTIONS(704), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(964), 1,
      anon_sym_quoteGoal,
    ACTIONS(972), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4214), 1,
      anon_sym_BSLASH,
    ACTIONS(4216), 1,
      anon_sym_u03bb,
    ACTIONS(4218), 1,
      anon_sym_tactic,
    STATE(3522), 1,
      sym_attributes,
    STATE(3891), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8047), 1,
      sym__LAMBDA,
    STATE(8355), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(942), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10081), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [310469] = 34,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(964), 1,
      anon_sym_quoteGoal,
    ACTIONS(972), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3978), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4214), 1,
      anon_sym_BSLASH,
    ACTIONS(4216), 1,
      anon_sym_u03bb,
    ACTIONS(4218), 1,
      anon_sym_tactic,
    STATE(3605), 1,
      sym_attributes,
    STATE(3891), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8047), 1,
      sym__LAMBDA,
    STATE(8355), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(942), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10179), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [310598] = 34,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(878), 1,
      anon_sym_quoteGoal,
    ACTIONS(886), 1,
      anon_sym_let,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(4078), 1,
      anon_sym_u2984,
    ACTIONS(4182), 1,
      sym_id,
    ACTIONS(4184), 1,
      anon_sym_BSLASH,
    ACTIONS(4186), 1,
      anon_sym_u03bb,
    ACTIONS(4190), 1,
      anon_sym_record,
    ACTIONS(4192), 1,
      anon_sym_LPAREN,
    ACTIONS(4194), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4196), 1,
      anon_sym_u2983,
    ACTIONS(4198), 1,
      anon_sym_LBRACE,
    ACTIONS(4200), 1,
      aux_sym__qid_token1,
    ACTIONS(4202), 1,
      anon_sym_DOT,
    ACTIONS(4204), 1,
      anon_sym_tactic,
    ACTIONS(4206), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4208), 1,
      anon_sym_u2987,
    ACTIONS(4212), 1,
      anon_sym_Set,
    STATE(3383), 1,
      sym_attributes,
    STATE(3888), 1,
      aux_sym__atoms,
    STATE(6121), 1,
      sym__qid,
    STATE(6386), 1,
      sym_atom,
    STATE(8067), 1,
      sym__LAMBDA,
    STATE(8369), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(852), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4210), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6575), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6565), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(4188), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9933), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [310727] = 34,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(878), 1,
      anon_sym_quoteGoal,
    ACTIONS(886), 1,
      anon_sym_let,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(3978), 1,
      anon_sym_u2984,
    ACTIONS(4182), 1,
      sym_id,
    ACTIONS(4184), 1,
      anon_sym_BSLASH,
    ACTIONS(4186), 1,
      anon_sym_u03bb,
    ACTIONS(4190), 1,
      anon_sym_record,
    ACTIONS(4192), 1,
      anon_sym_LPAREN,
    ACTIONS(4194), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4196), 1,
      anon_sym_u2983,
    ACTIONS(4198), 1,
      anon_sym_LBRACE,
    ACTIONS(4200), 1,
      aux_sym__qid_token1,
    ACTIONS(4202), 1,
      anon_sym_DOT,
    ACTIONS(4204), 1,
      anon_sym_tactic,
    ACTIONS(4206), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4208), 1,
      anon_sym_u2987,
    ACTIONS(4212), 1,
      anon_sym_Set,
    STATE(3602), 1,
      sym_attributes,
    STATE(3888), 1,
      aux_sym__atoms,
    STATE(6121), 1,
      sym__qid,
    STATE(6386), 1,
      sym_atom,
    STATE(8067), 1,
      sym__LAMBDA,
    STATE(8369), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(852), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4210), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6575), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6565), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(4188), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10181), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [310856] = 34,
    ACTIONS(710), 1,
      anon_sym_DASH,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(920), 1,
      anon_sym_quoteGoal,
    ACTIONS(928), 1,
      anon_sym_let,
    ACTIONS(3058), 1,
      anon_sym_BSLASH,
    ACTIONS(3060), 1,
      anon_sym_u03bb,
    ACTIONS(3064), 1,
      anon_sym_record,
    ACTIONS(3066), 1,
      anon_sym_LPAREN,
    ACTIONS(3068), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3070), 1,
      anon_sym_u2983,
    ACTIONS(3072), 1,
      anon_sym_LBRACE,
    ACTIONS(3076), 1,
      aux_sym__qid_token1,
    ACTIONS(3078), 1,
      anon_sym_DOT,
    ACTIONS(3080), 1,
      anon_sym_tactic,
    ACTIONS(3082), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3084), 1,
      anon_sym_u2987,
    ACTIONS(3088), 1,
      anon_sym_Set,
    ACTIONS(3978), 1,
      anon_sym_RBRACE,
    ACTIONS(4220), 1,
      sym_id,
    STATE(3595), 1,
      sym_attributes,
    STATE(3892), 1,
      aux_sym__atoms,
    STATE(6084), 1,
      sym__qid,
    STATE(6427), 1,
      sym_atom,
    STATE(8123), 1,
      sym__LAMBDA,
    STATE(8396), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3086), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6715), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6714), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3062), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10182), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [310985] = 34,
    ACTIONS(710), 1,
      anon_sym_DASH,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(732), 1,
      anon_sym_RBRACE,
    ACTIONS(920), 1,
      anon_sym_quoteGoal,
    ACTIONS(928), 1,
      anon_sym_let,
    ACTIONS(3058), 1,
      anon_sym_BSLASH,
    ACTIONS(3060), 1,
      anon_sym_u03bb,
    ACTIONS(3064), 1,
      anon_sym_record,
    ACTIONS(3066), 1,
      anon_sym_LPAREN,
    ACTIONS(3068), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3070), 1,
      anon_sym_u2983,
    ACTIONS(3072), 1,
      anon_sym_LBRACE,
    ACTIONS(3076), 1,
      aux_sym__qid_token1,
    ACTIONS(3078), 1,
      anon_sym_DOT,
    ACTIONS(3080), 1,
      anon_sym_tactic,
    ACTIONS(3082), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3084), 1,
      anon_sym_u2987,
    ACTIONS(3088), 1,
      anon_sym_Set,
    ACTIONS(4220), 1,
      sym_id,
    STATE(3500), 1,
      sym_attributes,
    STATE(3892), 1,
      aux_sym__atoms,
    STATE(6084), 1,
      sym__qid,
    STATE(6427), 1,
      sym_atom,
    STATE(8123), 1,
      sym__LAMBDA,
    STATE(8396), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3086), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6715), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6714), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3062), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9899), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [311114] = 34,
    ACTIONS(704), 1,
      anon_sym_u2984,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(878), 1,
      anon_sym_quoteGoal,
    ACTIONS(886), 1,
      anon_sym_let,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(4182), 1,
      sym_id,
    ACTIONS(4184), 1,
      anon_sym_BSLASH,
    ACTIONS(4186), 1,
      anon_sym_u03bb,
    ACTIONS(4190), 1,
      anon_sym_record,
    ACTIONS(4192), 1,
      anon_sym_LPAREN,
    ACTIONS(4194), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4196), 1,
      anon_sym_u2983,
    ACTIONS(4198), 1,
      anon_sym_LBRACE,
    ACTIONS(4200), 1,
      aux_sym__qid_token1,
    ACTIONS(4202), 1,
      anon_sym_DOT,
    ACTIONS(4204), 1,
      anon_sym_tactic,
    ACTIONS(4206), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4208), 1,
      anon_sym_u2987,
    ACTIONS(4212), 1,
      anon_sym_Set,
    STATE(3350), 1,
      sym_attributes,
    STATE(3888), 1,
      aux_sym__atoms,
    STATE(6121), 1,
      sym__qid,
    STATE(6386), 1,
      sym_atom,
    STATE(8067), 1,
      sym__LAMBDA,
    STATE(8369), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(852), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4210), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6575), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6565), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(4188), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9876), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [311243] = 34,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(964), 1,
      anon_sym_quoteGoal,
    ACTIONS(972), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3978), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4214), 1,
      anon_sym_BSLASH,
    ACTIONS(4216), 1,
      anon_sym_u03bb,
    ACTIONS(4218), 1,
      anon_sym_tactic,
    STATE(3524), 1,
      sym_attributes,
    STATE(3891), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8047), 1,
      sym__LAMBDA,
    STATE(8355), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(942), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9696), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [311372] = 34,
    ACTIONS(710), 1,
      anon_sym_DASH,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(920), 1,
      anon_sym_quoteGoal,
    ACTIONS(928), 1,
      anon_sym_let,
    ACTIONS(3058), 1,
      anon_sym_BSLASH,
    ACTIONS(3060), 1,
      anon_sym_u03bb,
    ACTIONS(3064), 1,
      anon_sym_record,
    ACTIONS(3066), 1,
      anon_sym_LPAREN,
    ACTIONS(3068), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3070), 1,
      anon_sym_u2983,
    ACTIONS(3072), 1,
      anon_sym_LBRACE,
    ACTIONS(3076), 1,
      aux_sym__qid_token1,
    ACTIONS(3078), 1,
      anon_sym_DOT,
    ACTIONS(3080), 1,
      anon_sym_tactic,
    ACTIONS(3082), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3084), 1,
      anon_sym_u2987,
    ACTIONS(3088), 1,
      anon_sym_Set,
    ACTIONS(3978), 1,
      anon_sym_RBRACE,
    ACTIONS(4220), 1,
      sym_id,
    STATE(3472), 1,
      sym_attributes,
    STATE(3892), 1,
      aux_sym__atoms,
    STATE(6084), 1,
      sym__qid,
    STATE(6427), 1,
      sym_atom,
    STATE(8123), 1,
      sym__LAMBDA,
    STATE(8396), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3086), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6715), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6714), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3062), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9957), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [311501] = 34,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(878), 1,
      anon_sym_quoteGoal,
    ACTIONS(886), 1,
      anon_sym_let,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(3978), 1,
      anon_sym_u2984,
    ACTIONS(4182), 1,
      sym_id,
    ACTIONS(4184), 1,
      anon_sym_BSLASH,
    ACTIONS(4186), 1,
      anon_sym_u03bb,
    ACTIONS(4190), 1,
      anon_sym_record,
    ACTIONS(4192), 1,
      anon_sym_LPAREN,
    ACTIONS(4194), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4196), 1,
      anon_sym_u2983,
    ACTIONS(4198), 1,
      anon_sym_LBRACE,
    ACTIONS(4200), 1,
      aux_sym__qid_token1,
    ACTIONS(4202), 1,
      anon_sym_DOT,
    ACTIONS(4204), 1,
      anon_sym_tactic,
    ACTIONS(4206), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4208), 1,
      anon_sym_u2987,
    ACTIONS(4212), 1,
      anon_sym_Set,
    STATE(3526), 1,
      sym_attributes,
    STATE(3888), 1,
      aux_sym__atoms,
    STATE(6121), 1,
      sym__qid,
    STATE(6386), 1,
      sym_atom,
    STATE(8067), 1,
      sym__LAMBDA,
    STATE(8369), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(852), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4210), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6575), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6565), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(4188), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9697), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [311630] = 34,
    ACTIONS(704), 1,
      anon_sym_u2984,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(878), 1,
      anon_sym_quoteGoal,
    ACTIONS(886), 1,
      anon_sym_let,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(4182), 1,
      sym_id,
    ACTIONS(4184), 1,
      anon_sym_BSLASH,
    ACTIONS(4186), 1,
      anon_sym_u03bb,
    ACTIONS(4190), 1,
      anon_sym_record,
    ACTIONS(4192), 1,
      anon_sym_LPAREN,
    ACTIONS(4194), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4196), 1,
      anon_sym_u2983,
    ACTIONS(4198), 1,
      anon_sym_LBRACE,
    ACTIONS(4200), 1,
      aux_sym__qid_token1,
    ACTIONS(4202), 1,
      anon_sym_DOT,
    ACTIONS(4204), 1,
      anon_sym_tactic,
    ACTIONS(4206), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4208), 1,
      anon_sym_u2987,
    ACTIONS(4212), 1,
      anon_sym_Set,
    STATE(3402), 1,
      sym_attributes,
    STATE(3888), 1,
      aux_sym__atoms,
    STATE(6121), 1,
      sym__qid,
    STATE(6386), 1,
      sym_atom,
    STATE(8067), 1,
      sym__LAMBDA,
    STATE(8369), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(852), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4210), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6575), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6565), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(4188), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9769), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [311759] = 34,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(878), 1,
      anon_sym_quoteGoal,
    ACTIONS(886), 1,
      anon_sym_let,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(4078), 1,
      anon_sym_u2984,
    ACTIONS(4182), 1,
      sym_id,
    ACTIONS(4184), 1,
      anon_sym_BSLASH,
    ACTIONS(4186), 1,
      anon_sym_u03bb,
    ACTIONS(4190), 1,
      anon_sym_record,
    ACTIONS(4192), 1,
      anon_sym_LPAREN,
    ACTIONS(4194), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4196), 1,
      anon_sym_u2983,
    ACTIONS(4198), 1,
      anon_sym_LBRACE,
    ACTIONS(4200), 1,
      aux_sym__qid_token1,
    ACTIONS(4202), 1,
      anon_sym_DOT,
    ACTIONS(4204), 1,
      anon_sym_tactic,
    ACTIONS(4206), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4208), 1,
      anon_sym_u2987,
    ACTIONS(4212), 1,
      anon_sym_Set,
    STATE(3664), 1,
      sym_attributes,
    STATE(3888), 1,
      aux_sym__atoms,
    STATE(6121), 1,
      sym__qid,
    STATE(6386), 1,
      sym_atom,
    STATE(8067), 1,
      sym__LAMBDA,
    STATE(8369), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(852), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4210), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6575), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6565), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(4188), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9965), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [311888] = 34,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(964), 1,
      anon_sym_quoteGoal,
    ACTIONS(972), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4078), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(4214), 1,
      anon_sym_BSLASH,
    ACTIONS(4216), 1,
      anon_sym_u03bb,
    ACTIONS(4218), 1,
      anon_sym_tactic,
    STATE(3628), 1,
      sym_attributes,
    STATE(3891), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8047), 1,
      sym__LAMBDA,
    STATE(8355), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(942), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9931), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [312017] = 34,
    ACTIONS(710), 1,
      anon_sym_DASH,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(920), 1,
      anon_sym_quoteGoal,
    ACTIONS(928), 1,
      anon_sym_let,
    ACTIONS(3058), 1,
      anon_sym_BSLASH,
    ACTIONS(3060), 1,
      anon_sym_u03bb,
    ACTIONS(3064), 1,
      anon_sym_record,
    ACTIONS(3066), 1,
      anon_sym_LPAREN,
    ACTIONS(3068), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3070), 1,
      anon_sym_u2983,
    ACTIONS(3072), 1,
      anon_sym_LBRACE,
    ACTIONS(3076), 1,
      aux_sym__qid_token1,
    ACTIONS(3078), 1,
      anon_sym_DOT,
    ACTIONS(3080), 1,
      anon_sym_tactic,
    ACTIONS(3082), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3084), 1,
      anon_sym_u2987,
    ACTIONS(3088), 1,
      anon_sym_Set,
    ACTIONS(3978), 1,
      anon_sym_RBRACE,
    ACTIONS(4220), 1,
      sym_id,
    STATE(3533), 1,
      sym_attributes,
    STATE(3892), 1,
      aux_sym__atoms,
    STATE(6084), 1,
      sym__qid,
    STATE(6427), 1,
      sym_atom,
    STATE(8123), 1,
      sym__LAMBDA,
    STATE(8396), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3086), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6715), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6714), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3062), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9698), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [312146] = 34,
    ACTIONS(704), 1,
      anon_sym_u2984,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(878), 1,
      anon_sym_quoteGoal,
    ACTIONS(886), 1,
      anon_sym_let,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(4182), 1,
      sym_id,
    ACTIONS(4184), 1,
      anon_sym_BSLASH,
    ACTIONS(4186), 1,
      anon_sym_u03bb,
    ACTIONS(4190), 1,
      anon_sym_record,
    ACTIONS(4192), 1,
      anon_sym_LPAREN,
    ACTIONS(4194), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4196), 1,
      anon_sym_u2983,
    ACTIONS(4198), 1,
      anon_sym_LBRACE,
    ACTIONS(4200), 1,
      aux_sym__qid_token1,
    ACTIONS(4202), 1,
      anon_sym_DOT,
    ACTIONS(4204), 1,
      anon_sym_tactic,
    ACTIONS(4206), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4208), 1,
      anon_sym_u2987,
    ACTIONS(4212), 1,
      anon_sym_Set,
    STATE(3583), 1,
      sym_attributes,
    STATE(3888), 1,
      aux_sym__atoms,
    STATE(6121), 1,
      sym__qid,
    STATE(6386), 1,
      sym_atom,
    STATE(8067), 1,
      sym__LAMBDA,
    STATE(8369), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(852), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4210), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6575), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6565), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(4188), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9830), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [312275] = 34,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(878), 1,
      anon_sym_quoteGoal,
    ACTIONS(886), 1,
      anon_sym_let,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(3978), 1,
      anon_sym_u2984,
    ACTIONS(4182), 1,
      sym_id,
    ACTIONS(4184), 1,
      anon_sym_BSLASH,
    ACTIONS(4186), 1,
      anon_sym_u03bb,
    ACTIONS(4190), 1,
      anon_sym_record,
    ACTIONS(4192), 1,
      anon_sym_LPAREN,
    ACTIONS(4194), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4196), 1,
      anon_sym_u2983,
    ACTIONS(4198), 1,
      anon_sym_LBRACE,
    ACTIONS(4200), 1,
      aux_sym__qid_token1,
    ACTIONS(4202), 1,
      anon_sym_DOT,
    ACTIONS(4204), 1,
      anon_sym_tactic,
    ACTIONS(4206), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4208), 1,
      anon_sym_u2987,
    ACTIONS(4212), 1,
      anon_sym_Set,
    STATE(3397), 1,
      sym_attributes,
    STATE(3888), 1,
      aux_sym__atoms,
    STATE(6121), 1,
      sym__qid,
    STATE(6386), 1,
      sym_atom,
    STATE(8067), 1,
      sym__LAMBDA,
    STATE(8369), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(852), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4210), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6575), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6565), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(4188), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10221), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [312404] = 34,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(964), 1,
      anon_sym_quoteGoal,
    ACTIONS(972), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3978), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4214), 1,
      anon_sym_BSLASH,
    ACTIONS(4216), 1,
      anon_sym_u03bb,
    ACTIONS(4218), 1,
      anon_sym_tactic,
    STATE(3499), 1,
      sym_attributes,
    STATE(3891), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8047), 1,
      sym__LAMBDA,
    STATE(8355), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(942), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10225), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [312533] = 34,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(964), 1,
      anon_sym_quoteGoal,
    ACTIONS(972), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4078), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(4214), 1,
      anon_sym_BSLASH,
    ACTIONS(4216), 1,
      anon_sym_u03bb,
    ACTIONS(4218), 1,
      anon_sym_tactic,
    STATE(3635), 1,
      sym_attributes,
    STATE(3891), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8047), 1,
      sym__LAMBDA,
    STATE(8355), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(942), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9817), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [312662] = 34,
    ACTIONS(710), 1,
      anon_sym_DASH,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(920), 1,
      anon_sym_quoteGoal,
    ACTIONS(928), 1,
      anon_sym_let,
    ACTIONS(3058), 1,
      anon_sym_BSLASH,
    ACTIONS(3060), 1,
      anon_sym_u03bb,
    ACTIONS(3064), 1,
      anon_sym_record,
    ACTIONS(3066), 1,
      anon_sym_LPAREN,
    ACTIONS(3068), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3070), 1,
      anon_sym_u2983,
    ACTIONS(3072), 1,
      anon_sym_LBRACE,
    ACTIONS(3076), 1,
      aux_sym__qid_token1,
    ACTIONS(3078), 1,
      anon_sym_DOT,
    ACTIONS(3080), 1,
      anon_sym_tactic,
    ACTIONS(3082), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3084), 1,
      anon_sym_u2987,
    ACTIONS(3088), 1,
      anon_sym_Set,
    ACTIONS(3978), 1,
      anon_sym_RBRACE,
    ACTIONS(4220), 1,
      sym_id,
    STATE(3687), 1,
      sym_attributes,
    STATE(3892), 1,
      aux_sym__atoms,
    STATE(6084), 1,
      sym__qid,
    STATE(6427), 1,
      sym_atom,
    STATE(8123), 1,
      sym__LAMBDA,
    STATE(8396), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3086), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6715), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6714), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3062), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9989), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [312791] = 34,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(878), 1,
      anon_sym_quoteGoal,
    ACTIONS(886), 1,
      anon_sym_let,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(3978), 1,
      anon_sym_u2984,
    ACTIONS(4182), 1,
      sym_id,
    ACTIONS(4184), 1,
      anon_sym_BSLASH,
    ACTIONS(4186), 1,
      anon_sym_u03bb,
    ACTIONS(4190), 1,
      anon_sym_record,
    ACTIONS(4192), 1,
      anon_sym_LPAREN,
    ACTIONS(4194), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4196), 1,
      anon_sym_u2983,
    ACTIONS(4198), 1,
      anon_sym_LBRACE,
    ACTIONS(4200), 1,
      aux_sym__qid_token1,
    ACTIONS(4202), 1,
      anon_sym_DOT,
    ACTIONS(4204), 1,
      anon_sym_tactic,
    ACTIONS(4206), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4208), 1,
      anon_sym_u2987,
    ACTIONS(4212), 1,
      anon_sym_Set,
    STATE(3683), 1,
      sym_attributes,
    STATE(3888), 1,
      aux_sym__atoms,
    STATE(6121), 1,
      sym__qid,
    STATE(6386), 1,
      sym_atom,
    STATE(8067), 1,
      sym__LAMBDA,
    STATE(8369), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(852), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4210), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6575), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6565), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(4188), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9992), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [312920] = 34,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(964), 1,
      anon_sym_quoteGoal,
    ACTIONS(972), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3978), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4214), 1,
      anon_sym_BSLASH,
    ACTIONS(4216), 1,
      anon_sym_u03bb,
    ACTIONS(4218), 1,
      anon_sym_tactic,
    STATE(3654), 1,
      sym_attributes,
    STATE(3891), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8047), 1,
      sym__LAMBDA,
    STATE(8355), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(942), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9994), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [313049] = 34,
    ACTIONS(704), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(964), 1,
      anon_sym_quoteGoal,
    ACTIONS(972), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4214), 1,
      anon_sym_BSLASH,
    ACTIONS(4216), 1,
      anon_sym_u03bb,
    ACTIONS(4218), 1,
      anon_sym_tactic,
    STATE(3521), 1,
      sym_attributes,
    STATE(3891), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8047), 1,
      sym__LAMBDA,
    STATE(8355), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(942), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9765), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [313178] = 34,
    ACTIONS(704), 1,
      anon_sym_u2984,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(878), 1,
      anon_sym_quoteGoal,
    ACTIONS(886), 1,
      anon_sym_let,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(4182), 1,
      sym_id,
    ACTIONS(4184), 1,
      anon_sym_BSLASH,
    ACTIONS(4186), 1,
      anon_sym_u03bb,
    ACTIONS(4190), 1,
      anon_sym_record,
    ACTIONS(4192), 1,
      anon_sym_LPAREN,
    ACTIONS(4194), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4196), 1,
      anon_sym_u2983,
    ACTIONS(4198), 1,
      anon_sym_LBRACE,
    ACTIONS(4200), 1,
      aux_sym__qid_token1,
    ACTIONS(4202), 1,
      anon_sym_DOT,
    ACTIONS(4204), 1,
      anon_sym_tactic,
    ACTIONS(4206), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4208), 1,
      anon_sym_u2987,
    ACTIONS(4212), 1,
      anon_sym_Set,
    STATE(3609), 1,
      sym_attributes,
    STATE(3888), 1,
      aux_sym__atoms,
    STATE(6121), 1,
      sym__qid,
    STATE(6386), 1,
      sym_atom,
    STATE(8067), 1,
      sym__LAMBDA,
    STATE(8369), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(852), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4210), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6575), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6565), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(4188), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10198), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [313307] = 34,
    ACTIONS(704), 1,
      anon_sym_u2984,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(878), 1,
      anon_sym_quoteGoal,
    ACTIONS(886), 1,
      anon_sym_let,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(4182), 1,
      sym_id,
    ACTIONS(4184), 1,
      anon_sym_BSLASH,
    ACTIONS(4186), 1,
      anon_sym_u03bb,
    ACTIONS(4190), 1,
      anon_sym_record,
    ACTIONS(4192), 1,
      anon_sym_LPAREN,
    ACTIONS(4194), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4196), 1,
      anon_sym_u2983,
    ACTIONS(4198), 1,
      anon_sym_LBRACE,
    ACTIONS(4200), 1,
      aux_sym__qid_token1,
    ACTIONS(4202), 1,
      anon_sym_DOT,
    ACTIONS(4204), 1,
      anon_sym_tactic,
    ACTIONS(4206), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4208), 1,
      anon_sym_u2987,
    ACTIONS(4212), 1,
      anon_sym_Set,
    STATE(3409), 1,
      sym_attributes,
    STATE(3888), 1,
      aux_sym__atoms,
    STATE(6121), 1,
      sym__qid,
    STATE(6386), 1,
      sym_atom,
    STATE(8067), 1,
      sym__LAMBDA,
    STATE(8369), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(852), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4210), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6575), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6565), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(4188), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10202), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [313436] = 34,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(878), 1,
      anon_sym_quoteGoal,
    ACTIONS(886), 1,
      anon_sym_let,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(3978), 1,
      anon_sym_u2984,
    ACTIONS(4182), 1,
      sym_id,
    ACTIONS(4184), 1,
      anon_sym_BSLASH,
    ACTIONS(4186), 1,
      anon_sym_u03bb,
    ACTIONS(4190), 1,
      anon_sym_record,
    ACTIONS(4192), 1,
      anon_sym_LPAREN,
    ACTIONS(4194), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4196), 1,
      anon_sym_u2983,
    ACTIONS(4198), 1,
      anon_sym_LBRACE,
    ACTIONS(4200), 1,
      aux_sym__qid_token1,
    ACTIONS(4202), 1,
      anon_sym_DOT,
    ACTIONS(4204), 1,
      anon_sym_tactic,
    ACTIONS(4206), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4208), 1,
      anon_sym_u2987,
    ACTIONS(4212), 1,
      anon_sym_Set,
    STATE(3530), 1,
      sym_attributes,
    STATE(3888), 1,
      aux_sym__atoms,
    STATE(6121), 1,
      sym__qid,
    STATE(6386), 1,
      sym_atom,
    STATE(8067), 1,
      sym__LAMBDA,
    STATE(8369), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(852), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4210), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6575), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6565), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(4188), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10223), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [313565] = 34,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(878), 1,
      anon_sym_quoteGoal,
    ACTIONS(886), 1,
      anon_sym_let,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(4078), 1,
      anon_sym_u2984,
    ACTIONS(4182), 1,
      sym_id,
    ACTIONS(4184), 1,
      anon_sym_BSLASH,
    ACTIONS(4186), 1,
      anon_sym_u03bb,
    ACTIONS(4190), 1,
      anon_sym_record,
    ACTIONS(4192), 1,
      anon_sym_LPAREN,
    ACTIONS(4194), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4196), 1,
      anon_sym_u2983,
    ACTIONS(4198), 1,
      anon_sym_LBRACE,
    ACTIONS(4200), 1,
      aux_sym__qid_token1,
    ACTIONS(4202), 1,
      anon_sym_DOT,
    ACTIONS(4204), 1,
      anon_sym_tactic,
    ACTIONS(4206), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4208), 1,
      anon_sym_u2987,
    ACTIONS(4212), 1,
      anon_sym_Set,
    STATE(3355), 1,
      sym_attributes,
    STATE(3888), 1,
      aux_sym__atoms,
    STATE(6121), 1,
      sym__qid,
    STATE(6386), 1,
      sym_atom,
    STATE(8067), 1,
      sym__LAMBDA,
    STATE(8369), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(852), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4210), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6575), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6565), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(4188), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9816), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [313694] = 34,
    ACTIONS(710), 1,
      anon_sym_DASH,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(920), 1,
      anon_sym_quoteGoal,
    ACTIONS(928), 1,
      anon_sym_let,
    ACTIONS(3058), 1,
      anon_sym_BSLASH,
    ACTIONS(3060), 1,
      anon_sym_u03bb,
    ACTIONS(3064), 1,
      anon_sym_record,
    ACTIONS(3066), 1,
      anon_sym_LPAREN,
    ACTIONS(3068), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3070), 1,
      anon_sym_u2983,
    ACTIONS(3072), 1,
      anon_sym_LBRACE,
    ACTIONS(3076), 1,
      aux_sym__qid_token1,
    ACTIONS(3078), 1,
      anon_sym_DOT,
    ACTIONS(3080), 1,
      anon_sym_tactic,
    ACTIONS(3082), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3084), 1,
      anon_sym_u2987,
    ACTIONS(3088), 1,
      anon_sym_Set,
    ACTIONS(4078), 1,
      anon_sym_RBRACE,
    ACTIONS(4220), 1,
      sym_id,
    STATE(3367), 1,
      sym_attributes,
    STATE(3892), 1,
      aux_sym__atoms,
    STATE(6084), 1,
      sym__qid,
    STATE(6427), 1,
      sym_atom,
    STATE(8123), 1,
      sym__LAMBDA,
    STATE(8396), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3086), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6715), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6714), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3062), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9805), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [313823] = 34,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(878), 1,
      anon_sym_quoteGoal,
    ACTIONS(886), 1,
      anon_sym_let,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(4078), 1,
      anon_sym_u2984,
    ACTIONS(4182), 1,
      sym_id,
    ACTIONS(4184), 1,
      anon_sym_BSLASH,
    ACTIONS(4186), 1,
      anon_sym_u03bb,
    ACTIONS(4190), 1,
      anon_sym_record,
    ACTIONS(4192), 1,
      anon_sym_LPAREN,
    ACTIONS(4194), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4196), 1,
      anon_sym_u2983,
    ACTIONS(4198), 1,
      anon_sym_LBRACE,
    ACTIONS(4200), 1,
      aux_sym__qid_token1,
    ACTIONS(4202), 1,
      anon_sym_DOT,
    ACTIONS(4204), 1,
      anon_sym_tactic,
    ACTIONS(4206), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4208), 1,
      anon_sym_u2987,
    ACTIONS(4212), 1,
      anon_sym_Set,
    STATE(3645), 1,
      sym_attributes,
    STATE(3888), 1,
      aux_sym__atoms,
    STATE(6121), 1,
      sym__qid,
    STATE(6386), 1,
      sym_atom,
    STATE(8067), 1,
      sym__LAMBDA,
    STATE(8369), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(852), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4210), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6575), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6565), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(4188), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9718), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [313952] = 34,
    ACTIONS(710), 1,
      anon_sym_DASH,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(920), 1,
      anon_sym_quoteGoal,
    ACTIONS(928), 1,
      anon_sym_let,
    ACTIONS(3058), 1,
      anon_sym_BSLASH,
    ACTIONS(3060), 1,
      anon_sym_u03bb,
    ACTIONS(3064), 1,
      anon_sym_record,
    ACTIONS(3066), 1,
      anon_sym_LPAREN,
    ACTIONS(3068), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3070), 1,
      anon_sym_u2983,
    ACTIONS(3072), 1,
      anon_sym_LBRACE,
    ACTIONS(3076), 1,
      aux_sym__qid_token1,
    ACTIONS(3078), 1,
      anon_sym_DOT,
    ACTIONS(3080), 1,
      anon_sym_tactic,
    ACTIONS(3082), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3084), 1,
      anon_sym_u2987,
    ACTIONS(3088), 1,
      anon_sym_Set,
    ACTIONS(4092), 1,
      anon_sym_RBRACE,
    ACTIONS(4220), 1,
      sym_id,
    STATE(3419), 1,
      sym_attributes,
    STATE(3892), 1,
      aux_sym__atoms,
    STATE(6084), 1,
      sym__qid,
    STATE(6427), 1,
      sym_atom,
    STATE(8123), 1,
      sym__LAMBDA,
    STATE(8396), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3086), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6715), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6714), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3062), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9739), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [314081] = 34,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(878), 1,
      anon_sym_quoteGoal,
    ACTIONS(886), 1,
      anon_sym_let,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(4092), 1,
      anon_sym_u2984,
    ACTIONS(4182), 1,
      sym_id,
    ACTIONS(4184), 1,
      anon_sym_BSLASH,
    ACTIONS(4186), 1,
      anon_sym_u03bb,
    ACTIONS(4190), 1,
      anon_sym_record,
    ACTIONS(4192), 1,
      anon_sym_LPAREN,
    ACTIONS(4194), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4196), 1,
      anon_sym_u2983,
    ACTIONS(4198), 1,
      anon_sym_LBRACE,
    ACTIONS(4200), 1,
      aux_sym__qid_token1,
    ACTIONS(4202), 1,
      anon_sym_DOT,
    ACTIONS(4204), 1,
      anon_sym_tactic,
    ACTIONS(4206), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4208), 1,
      anon_sym_u2987,
    ACTIONS(4212), 1,
      anon_sym_Set,
    STATE(3418), 1,
      sym_attributes,
    STATE(3888), 1,
      aux_sym__atoms,
    STATE(6121), 1,
      sym__qid,
    STATE(6386), 1,
      sym_atom,
    STATE(8067), 1,
      sym__LAMBDA,
    STATE(8369), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(852), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4210), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6575), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6565), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(4188), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9741), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [314210] = 34,
    ACTIONS(704), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(964), 1,
      anon_sym_quoteGoal,
    ACTIONS(972), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4214), 1,
      anon_sym_BSLASH,
    ACTIONS(4216), 1,
      anon_sym_u03bb,
    ACTIONS(4218), 1,
      anon_sym_tactic,
    STATE(3584), 1,
      sym_attributes,
    STATE(3891), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8047), 1,
      sym__LAMBDA,
    STATE(8355), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(942), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9898), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [314339] = 34,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(732), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(964), 1,
      anon_sym_quoteGoal,
    ACTIONS(972), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4214), 1,
      anon_sym_BSLASH,
    ACTIONS(4216), 1,
      anon_sym_u03bb,
    ACTIONS(4218), 1,
      anon_sym_tactic,
    STATE(3541), 1,
      sym_attributes,
    STATE(3891), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8047), 1,
      sym__LAMBDA,
    STATE(8355), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(942), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9905), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [314468] = 34,
    ACTIONS(704), 1,
      anon_sym_u2984,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(878), 1,
      anon_sym_quoteGoal,
    ACTIONS(886), 1,
      anon_sym_let,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(4182), 1,
      sym_id,
    ACTIONS(4184), 1,
      anon_sym_BSLASH,
    ACTIONS(4186), 1,
      anon_sym_u03bb,
    ACTIONS(4190), 1,
      anon_sym_record,
    ACTIONS(4192), 1,
      anon_sym_LPAREN,
    ACTIONS(4194), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4196), 1,
      anon_sym_u2983,
    ACTIONS(4198), 1,
      anon_sym_LBRACE,
    ACTIONS(4200), 1,
      aux_sym__qid_token1,
    ACTIONS(4202), 1,
      anon_sym_DOT,
    ACTIONS(4204), 1,
      anon_sym_tactic,
    ACTIONS(4206), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4208), 1,
      anon_sym_u2987,
    ACTIONS(4212), 1,
      anon_sym_Set,
    STATE(3590), 1,
      sym_attributes,
    STATE(3888), 1,
      aux_sym__atoms,
    STATE(6121), 1,
      sym__qid,
    STATE(6386), 1,
      sym_atom,
    STATE(8067), 1,
      sym__LAMBDA,
    STATE(8369), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(852), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4210), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6575), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6565), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(4188), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9902), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [314597] = 34,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(732), 1,
      anon_sym_u2984,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(878), 1,
      anon_sym_quoteGoal,
    ACTIONS(886), 1,
      anon_sym_let,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(4182), 1,
      sym_id,
    ACTIONS(4184), 1,
      anon_sym_BSLASH,
    ACTIONS(4186), 1,
      anon_sym_u03bb,
    ACTIONS(4190), 1,
      anon_sym_record,
    ACTIONS(4192), 1,
      anon_sym_LPAREN,
    ACTIONS(4194), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4196), 1,
      anon_sym_u2983,
    ACTIONS(4198), 1,
      anon_sym_LBRACE,
    ACTIONS(4200), 1,
      aux_sym__qid_token1,
    ACTIONS(4202), 1,
      anon_sym_DOT,
    ACTIONS(4204), 1,
      anon_sym_tactic,
    ACTIONS(4206), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4208), 1,
      anon_sym_u2987,
    ACTIONS(4212), 1,
      anon_sym_Set,
    STATE(3527), 1,
      sym_attributes,
    STATE(3888), 1,
      aux_sym__atoms,
    STATE(6121), 1,
      sym__qid,
    STATE(6386), 1,
      sym_atom,
    STATE(8067), 1,
      sym__LAMBDA,
    STATE(8369), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(852), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4210), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6575), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6565), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(4188), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9904), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [314726] = 34,
    ACTIONS(704), 1,
      anon_sym_u2984,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(878), 1,
      anon_sym_quoteGoal,
    ACTIONS(886), 1,
      anon_sym_let,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(4182), 1,
      sym_id,
    ACTIONS(4184), 1,
      anon_sym_BSLASH,
    ACTIONS(4186), 1,
      anon_sym_u03bb,
    ACTIONS(4190), 1,
      anon_sym_record,
    ACTIONS(4192), 1,
      anon_sym_LPAREN,
    ACTIONS(4194), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4196), 1,
      anon_sym_u2983,
    ACTIONS(4198), 1,
      anon_sym_LBRACE,
    ACTIONS(4200), 1,
      aux_sym__qid_token1,
    ACTIONS(4202), 1,
      anon_sym_DOT,
    ACTIONS(4204), 1,
      anon_sym_tactic,
    ACTIONS(4206), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4208), 1,
      anon_sym_u2987,
    ACTIONS(4212), 1,
      anon_sym_Set,
    STATE(3683), 1,
      sym_attributes,
    STATE(3888), 1,
      aux_sym__atoms,
    STATE(6121), 1,
      sym__qid,
    STATE(6386), 1,
      sym_atom,
    STATE(8067), 1,
      sym__LAMBDA,
    STATE(8369), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(852), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4210), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6575), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6565), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(4188), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9992), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [314855] = 34,
    ACTIONS(704), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(964), 1,
      anon_sym_quoteGoal,
    ACTIONS(972), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4214), 1,
      anon_sym_BSLASH,
    ACTIONS(4216), 1,
      anon_sym_u03bb,
    ACTIONS(4218), 1,
      anon_sym_tactic,
    STATE(3654), 1,
      sym_attributes,
    STATE(3891), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8047), 1,
      sym__LAMBDA,
    STATE(8355), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(942), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9994), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [314984] = 34,
    ACTIONS(710), 1,
      anon_sym_DASH,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(920), 1,
      anon_sym_quoteGoal,
    ACTIONS(928), 1,
      anon_sym_let,
    ACTIONS(3058), 1,
      anon_sym_BSLASH,
    ACTIONS(3060), 1,
      anon_sym_u03bb,
    ACTIONS(3064), 1,
      anon_sym_record,
    ACTIONS(3066), 1,
      anon_sym_LPAREN,
    ACTIONS(3068), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3070), 1,
      anon_sym_u2983,
    ACTIONS(3072), 1,
      anon_sym_LBRACE,
    ACTIONS(3076), 1,
      aux_sym__qid_token1,
    ACTIONS(3078), 1,
      anon_sym_DOT,
    ACTIONS(3080), 1,
      anon_sym_tactic,
    ACTIONS(3082), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3084), 1,
      anon_sym_u2987,
    ACTIONS(3088), 1,
      anon_sym_Set,
    ACTIONS(4092), 1,
      anon_sym_RBRACE,
    ACTIONS(4220), 1,
      sym_id,
    STATE(3489), 1,
      sym_attributes,
    STATE(3892), 1,
      aux_sym__atoms,
    STATE(6084), 1,
      sym__qid,
    STATE(6427), 1,
      sym_atom,
    STATE(8123), 1,
      sym__LAMBDA,
    STATE(8396), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3086), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6715), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6714), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3062), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10185), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [315113] = 34,
    ACTIONS(704), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(964), 1,
      anon_sym_quoteGoal,
    ACTIONS(972), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4214), 1,
      anon_sym_BSLASH,
    ACTIONS(4216), 1,
      anon_sym_u03bb,
    ACTIONS(4218), 1,
      anon_sym_tactic,
    STATE(3623), 1,
      sym_attributes,
    STATE(3891), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8047), 1,
      sym__LAMBDA,
    STATE(8355), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(942), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10197), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [315242] = 34,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(878), 1,
      anon_sym_quoteGoal,
    ACTIONS(886), 1,
      anon_sym_let,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(4092), 1,
      anon_sym_u2984,
    ACTIONS(4182), 1,
      sym_id,
    ACTIONS(4184), 1,
      anon_sym_BSLASH,
    ACTIONS(4186), 1,
      anon_sym_u03bb,
    ACTIONS(4190), 1,
      anon_sym_record,
    ACTIONS(4192), 1,
      anon_sym_LPAREN,
    ACTIONS(4194), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4196), 1,
      anon_sym_u2983,
    ACTIONS(4198), 1,
      anon_sym_LBRACE,
    ACTIONS(4200), 1,
      aux_sym__qid_token1,
    ACTIONS(4202), 1,
      anon_sym_DOT,
    ACTIONS(4204), 1,
      anon_sym_tactic,
    ACTIONS(4206), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4208), 1,
      anon_sym_u2987,
    ACTIONS(4212), 1,
      anon_sym_Set,
    STATE(3574), 1,
      sym_attributes,
    STATE(3888), 1,
      aux_sym__atoms,
    STATE(6121), 1,
      sym__qid,
    STATE(6386), 1,
      sym_atom,
    STATE(8067), 1,
      sym__LAMBDA,
    STATE(8369), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(852), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4210), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6575), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6565), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(4188), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10186), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [315371] = 34,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(964), 1,
      anon_sym_quoteGoal,
    ACTIONS(972), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4092), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(4214), 1,
      anon_sym_BSLASH,
    ACTIONS(4216), 1,
      anon_sym_u03bb,
    ACTIONS(4218), 1,
      anon_sym_tactic,
    STATE(3577), 1,
      sym_attributes,
    STATE(3891), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8047), 1,
      sym__LAMBDA,
    STATE(8355), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(942), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10187), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [315500] = 34,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(964), 1,
      anon_sym_quoteGoal,
    ACTIONS(972), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4092), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(4214), 1,
      anon_sym_BSLASH,
    ACTIONS(4216), 1,
      anon_sym_u03bb,
    ACTIONS(4218), 1,
      anon_sym_tactic,
    STATE(3413), 1,
      sym_attributes,
    STATE(3891), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8047), 1,
      sym__LAMBDA,
    STATE(8355), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(942), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9742), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [315629] = 34,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(732), 1,
      anon_sym_u2984,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(878), 1,
      anon_sym_quoteGoal,
    ACTIONS(886), 1,
      anon_sym_let,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(4182), 1,
      sym_id,
    ACTIONS(4184), 1,
      anon_sym_BSLASH,
    ACTIONS(4186), 1,
      anon_sym_u03bb,
    ACTIONS(4190), 1,
      anon_sym_record,
    ACTIONS(4192), 1,
      anon_sym_LPAREN,
    ACTIONS(4194), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4196), 1,
      anon_sym_u2983,
    ACTIONS(4198), 1,
      anon_sym_LBRACE,
    ACTIONS(4200), 1,
      aux_sym__qid_token1,
    ACTIONS(4202), 1,
      anon_sym_DOT,
    ACTIONS(4204), 1,
      anon_sym_tactic,
    ACTIONS(4206), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4208), 1,
      anon_sym_u2987,
    ACTIONS(4212), 1,
      anon_sym_Set,
    STATE(3383), 1,
      sym_attributes,
    STATE(3888), 1,
      aux_sym__atoms,
    STATE(6121), 1,
      sym__qid,
    STATE(6386), 1,
      sym_atom,
    STATE(8067), 1,
      sym__LAMBDA,
    STATE(8369), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(852), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4210), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6575), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6565), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(4188), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9933), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [315758] = 34,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(732), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(964), 1,
      anon_sym_quoteGoal,
    ACTIONS(972), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4214), 1,
      anon_sym_BSLASH,
    ACTIONS(4216), 1,
      anon_sym_u03bb,
    ACTIONS(4218), 1,
      anon_sym_tactic,
    STATE(3628), 1,
      sym_attributes,
    STATE(3891), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8047), 1,
      sym__LAMBDA,
    STATE(8355), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(942), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9931), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [315887] = 34,
    ACTIONS(710), 1,
      anon_sym_DASH,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(920), 1,
      anon_sym_quoteGoal,
    ACTIONS(928), 1,
      anon_sym_let,
    ACTIONS(3058), 1,
      anon_sym_BSLASH,
    ACTIONS(3060), 1,
      anon_sym_u03bb,
    ACTIONS(3064), 1,
      anon_sym_record,
    ACTIONS(3066), 1,
      anon_sym_LPAREN,
    ACTIONS(3068), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3070), 1,
      anon_sym_u2983,
    ACTIONS(3072), 1,
      anon_sym_LBRACE,
    ACTIONS(3076), 1,
      aux_sym__qid_token1,
    ACTIONS(3078), 1,
      anon_sym_DOT,
    ACTIONS(3080), 1,
      anon_sym_tactic,
    ACTIONS(3082), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3084), 1,
      anon_sym_u2987,
    ACTIONS(3088), 1,
      anon_sym_Set,
    ACTIONS(4078), 1,
      anon_sym_RBRACE,
    ACTIONS(4220), 1,
      sym_id,
    STATE(3559), 1,
      sym_attributes,
    STATE(3892), 1,
      aux_sym__atoms,
    STATE(6084), 1,
      sym__qid,
    STATE(6427), 1,
      sym_atom,
    STATE(8123), 1,
      sym__LAMBDA,
    STATE(8396), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3086), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6715), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6714), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3062), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9878), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [316016] = 34,
    ACTIONS(704), 1,
      anon_sym_u2984,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(878), 1,
      anon_sym_quoteGoal,
    ACTIONS(886), 1,
      anon_sym_let,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(4182), 1,
      sym_id,
    ACTIONS(4184), 1,
      anon_sym_BSLASH,
    ACTIONS(4186), 1,
      anon_sym_u03bb,
    ACTIONS(4190), 1,
      anon_sym_record,
    ACTIONS(4192), 1,
      anon_sym_LPAREN,
    ACTIONS(4194), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4196), 1,
      anon_sym_u2983,
    ACTIONS(4198), 1,
      anon_sym_LBRACE,
    ACTIONS(4200), 1,
      aux_sym__qid_token1,
    ACTIONS(4202), 1,
      anon_sym_DOT,
    ACTIONS(4204), 1,
      anon_sym_tactic,
    ACTIONS(4206), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4208), 1,
      anon_sym_u2987,
    ACTIONS(4212), 1,
      anon_sym_Set,
    STATE(3530), 1,
      sym_attributes,
    STATE(3888), 1,
      aux_sym__atoms,
    STATE(6121), 1,
      sym__qid,
    STATE(6386), 1,
      sym_atom,
    STATE(8067), 1,
      sym__LAMBDA,
    STATE(8369), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(852), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4210), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6575), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6565), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(4188), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10223), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [316145] = 34,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(964), 1,
      anon_sym_quoteGoal,
    ACTIONS(972), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4078), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(4214), 1,
      anon_sym_BSLASH,
    ACTIONS(4216), 1,
      anon_sym_u03bb,
    ACTIONS(4218), 1,
      anon_sym_tactic,
    STATE(3541), 1,
      sym_attributes,
    STATE(3891), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8047), 1,
      sym__LAMBDA,
    STATE(8355), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(942), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9905), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [316274] = 34,
    ACTIONS(710), 1,
      anon_sym_DASH,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(920), 1,
      anon_sym_quoteGoal,
    ACTIONS(928), 1,
      anon_sym_let,
    ACTIONS(3058), 1,
      anon_sym_BSLASH,
    ACTIONS(3060), 1,
      anon_sym_u03bb,
    ACTIONS(3064), 1,
      anon_sym_record,
    ACTIONS(3066), 1,
      anon_sym_LPAREN,
    ACTIONS(3068), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3070), 1,
      anon_sym_u2983,
    ACTIONS(3072), 1,
      anon_sym_LBRACE,
    ACTIONS(3076), 1,
      aux_sym__qid_token1,
    ACTIONS(3078), 1,
      anon_sym_DOT,
    ACTIONS(3080), 1,
      anon_sym_tactic,
    ACTIONS(3082), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3084), 1,
      anon_sym_u2987,
    ACTIONS(3088), 1,
      anon_sym_Set,
    ACTIONS(4078), 1,
      anon_sym_RBRACE,
    ACTIONS(4220), 1,
      sym_id,
    STATE(3582), 1,
      sym_attributes,
    STATE(3892), 1,
      aux_sym__atoms,
    STATE(6084), 1,
      sym__qid,
    STATE(6427), 1,
      sym_atom,
    STATE(8123), 1,
      sym__LAMBDA,
    STATE(8396), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3086), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6715), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6714), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3062), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10091), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [316403] = 34,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(964), 1,
      anon_sym_quoteGoal,
    ACTIONS(972), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4078), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(4214), 1,
      anon_sym_BSLASH,
    ACTIONS(4216), 1,
      anon_sym_u03bb,
    ACTIONS(4218), 1,
      anon_sym_tactic,
    STATE(3453), 1,
      sym_attributes,
    STATE(3891), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8047), 1,
      sym__LAMBDA,
    STATE(8355), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(942), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9881), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [316532] = 34,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(964), 1,
      anon_sym_quoteGoal,
    ACTIONS(972), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3978), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4214), 1,
      anon_sym_BSLASH,
    ACTIONS(4216), 1,
      anon_sym_u03bb,
    ACTIONS(4218), 1,
      anon_sym_tactic,
    STATE(3522), 1,
      sym_attributes,
    STATE(3891), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8047), 1,
      sym__LAMBDA,
    STATE(8355), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(942), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10081), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [316661] = 34,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(878), 1,
      anon_sym_quoteGoal,
    ACTIONS(886), 1,
      anon_sym_let,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(3978), 1,
      anon_sym_u2984,
    ACTIONS(4182), 1,
      sym_id,
    ACTIONS(4184), 1,
      anon_sym_BSLASH,
    ACTIONS(4186), 1,
      anon_sym_u03bb,
    ACTIONS(4190), 1,
      anon_sym_record,
    ACTIONS(4192), 1,
      anon_sym_LPAREN,
    ACTIONS(4194), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4196), 1,
      anon_sym_u2983,
    ACTIONS(4198), 1,
      anon_sym_LBRACE,
    ACTIONS(4200), 1,
      aux_sym__qid_token1,
    ACTIONS(4202), 1,
      anon_sym_DOT,
    ACTIONS(4204), 1,
      anon_sym_tactic,
    ACTIONS(4206), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4208), 1,
      anon_sym_u2987,
    ACTIONS(4212), 1,
      anon_sym_Set,
    STATE(3570), 1,
      sym_attributes,
    STATE(3888), 1,
      aux_sym__atoms,
    STATE(6121), 1,
      sym__qid,
    STATE(6386), 1,
      sym_atom,
    STATE(8067), 1,
      sym__LAMBDA,
    STATE(8369), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(852), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4210), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6575), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6565), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(4188), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10080), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [316790] = 34,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(730), 1,
      anon_sym_u2984,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(878), 1,
      anon_sym_quoteGoal,
    ACTIONS(886), 1,
      anon_sym_let,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(4182), 1,
      sym_id,
    ACTIONS(4184), 1,
      anon_sym_BSLASH,
    ACTIONS(4186), 1,
      anon_sym_u03bb,
    ACTIONS(4190), 1,
      anon_sym_record,
    ACTIONS(4192), 1,
      anon_sym_LPAREN,
    ACTIONS(4194), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4196), 1,
      anon_sym_u2983,
    ACTIONS(4198), 1,
      anon_sym_LBRACE,
    ACTIONS(4200), 1,
      aux_sym__qid_token1,
    ACTIONS(4202), 1,
      anon_sym_DOT,
    ACTIONS(4204), 1,
      anon_sym_tactic,
    ACTIONS(4206), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4208), 1,
      anon_sym_u2987,
    ACTIONS(4212), 1,
      anon_sym_Set,
    STATE(3574), 1,
      sym_attributes,
    STATE(3888), 1,
      aux_sym__atoms,
    STATE(6121), 1,
      sym__qid,
    STATE(6386), 1,
      sym_atom,
    STATE(8067), 1,
      sym__LAMBDA,
    STATE(8369), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(852), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4210), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6575), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6565), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(4188), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10186), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [316919] = 34,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(730), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(964), 1,
      anon_sym_quoteGoal,
    ACTIONS(972), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4214), 1,
      anon_sym_BSLASH,
    ACTIONS(4216), 1,
      anon_sym_u03bb,
    ACTIONS(4218), 1,
      anon_sym_tactic,
    STATE(3577), 1,
      sym_attributes,
    STATE(3891), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8047), 1,
      sym__LAMBDA,
    STATE(8355), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(942), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10187), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [317048] = 34,
    ACTIONS(710), 1,
      anon_sym_DASH,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(920), 1,
      anon_sym_quoteGoal,
    ACTIONS(928), 1,
      anon_sym_let,
    ACTIONS(3058), 1,
      anon_sym_BSLASH,
    ACTIONS(3060), 1,
      anon_sym_u03bb,
    ACTIONS(3064), 1,
      anon_sym_record,
    ACTIONS(3066), 1,
      anon_sym_LPAREN,
    ACTIONS(3068), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3070), 1,
      anon_sym_u2983,
    ACTIONS(3072), 1,
      anon_sym_LBRACE,
    ACTIONS(3076), 1,
      aux_sym__qid_token1,
    ACTIONS(3078), 1,
      anon_sym_DOT,
    ACTIONS(3080), 1,
      anon_sym_tactic,
    ACTIONS(3082), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3084), 1,
      anon_sym_u2987,
    ACTIONS(3088), 1,
      anon_sym_Set,
    ACTIONS(3978), 1,
      anon_sym_RBRACE,
    ACTIONS(4220), 1,
      sym_id,
    STATE(3597), 1,
      sym_attributes,
    STATE(3892), 1,
      aux_sym__atoms,
    STATE(6084), 1,
      sym__qid,
    STATE(6427), 1,
      sym_atom,
    STATE(8123), 1,
      sym__LAMBDA,
    STATE(8396), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3086), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6715), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6714), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3062), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10079), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [317177] = 34,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(878), 1,
      anon_sym_quoteGoal,
    ACTIONS(886), 1,
      anon_sym_let,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(4078), 1,
      anon_sym_u2984,
    ACTIONS(4182), 1,
      sym_id,
    ACTIONS(4184), 1,
      anon_sym_BSLASH,
    ACTIONS(4186), 1,
      anon_sym_u03bb,
    ACTIONS(4190), 1,
      anon_sym_record,
    ACTIONS(4192), 1,
      anon_sym_LPAREN,
    ACTIONS(4194), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4196), 1,
      anon_sym_u2983,
    ACTIONS(4198), 1,
      anon_sym_LBRACE,
    ACTIONS(4200), 1,
      aux_sym__qid_token1,
    ACTIONS(4202), 1,
      anon_sym_DOT,
    ACTIONS(4204), 1,
      anon_sym_tactic,
    ACTIONS(4206), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4208), 1,
      anon_sym_u2987,
    ACTIONS(4212), 1,
      anon_sym_Set,
    STATE(3527), 1,
      sym_attributes,
    STATE(3888), 1,
      aux_sym__atoms,
    STATE(6121), 1,
      sym__qid,
    STATE(6386), 1,
      sym_atom,
    STATE(8067), 1,
      sym__LAMBDA,
    STATE(8369), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(852), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4210), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6575), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6565), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(4188), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9904), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [317306] = 34,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(732), 1,
      anon_sym_u2984,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(878), 1,
      anon_sym_quoteGoal,
    ACTIONS(886), 1,
      anon_sym_let,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(4182), 1,
      sym_id,
    ACTIONS(4184), 1,
      anon_sym_BSLASH,
    ACTIONS(4186), 1,
      anon_sym_u03bb,
    ACTIONS(4190), 1,
      anon_sym_record,
    ACTIONS(4192), 1,
      anon_sym_LPAREN,
    ACTIONS(4194), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4196), 1,
      anon_sym_u2983,
    ACTIONS(4198), 1,
      anon_sym_LBRACE,
    ACTIONS(4200), 1,
      aux_sym__qid_token1,
    ACTIONS(4202), 1,
      anon_sym_DOT,
    ACTIONS(4204), 1,
      anon_sym_tactic,
    ACTIONS(4206), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4208), 1,
      anon_sym_u2987,
    ACTIONS(4212), 1,
      anon_sym_Set,
    STATE(3467), 1,
      sym_attributes,
    STATE(3888), 1,
      aux_sym__atoms,
    STATE(6121), 1,
      sym__qid,
    STATE(6386), 1,
      sym_atom,
    STATE(8067), 1,
      sym__LAMBDA,
    STATE(8369), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(852), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4210), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6575), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6565), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(4188), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9879), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [317435] = 34,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(732), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(964), 1,
      anon_sym_quoteGoal,
    ACTIONS(972), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4214), 1,
      anon_sym_BSLASH,
    ACTIONS(4216), 1,
      anon_sym_u03bb,
    ACTIONS(4218), 1,
      anon_sym_tactic,
    STATE(3453), 1,
      sym_attributes,
    STATE(3891), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8047), 1,
      sym__LAMBDA,
    STATE(8355), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(942), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9881), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [317564] = 34,
    ACTIONS(710), 1,
      anon_sym_DASH,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(920), 1,
      anon_sym_quoteGoal,
    ACTIONS(928), 1,
      anon_sym_let,
    ACTIONS(3058), 1,
      anon_sym_BSLASH,
    ACTIONS(3060), 1,
      anon_sym_u03bb,
    ACTIONS(3064), 1,
      anon_sym_record,
    ACTIONS(3066), 1,
      anon_sym_LPAREN,
    ACTIONS(3068), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3070), 1,
      anon_sym_u2983,
    ACTIONS(3072), 1,
      anon_sym_LBRACE,
    ACTIONS(3076), 1,
      aux_sym__qid_token1,
    ACTIONS(3078), 1,
      anon_sym_DOT,
    ACTIONS(3080), 1,
      anon_sym_tactic,
    ACTIONS(3082), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3084), 1,
      anon_sym_u2987,
    ACTIONS(3088), 1,
      anon_sym_Set,
    ACTIONS(4078), 1,
      anon_sym_RBRACE,
    ACTIONS(4220), 1,
      sym_id,
    STATE(3700), 1,
      sym_attributes,
    STATE(3892), 1,
      aux_sym__atoms,
    STATE(6084), 1,
      sym__qid,
    STATE(6427), 1,
      sym_atom,
    STATE(8123), 1,
      sym__LAMBDA,
    STATE(8396), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3086), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6715), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6714), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3062), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9798), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [317693] = 34,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(878), 1,
      anon_sym_quoteGoal,
    ACTIONS(886), 1,
      anon_sym_let,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(4078), 1,
      anon_sym_u2984,
    ACTIONS(4182), 1,
      sym_id,
    ACTIONS(4184), 1,
      anon_sym_BSLASH,
    ACTIONS(4186), 1,
      anon_sym_u03bb,
    ACTIONS(4190), 1,
      anon_sym_record,
    ACTIONS(4192), 1,
      anon_sym_LPAREN,
    ACTIONS(4194), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4196), 1,
      anon_sym_u2983,
    ACTIONS(4198), 1,
      anon_sym_LBRACE,
    ACTIONS(4200), 1,
      aux_sym__qid_token1,
    ACTIONS(4202), 1,
      anon_sym_DOT,
    ACTIONS(4204), 1,
      anon_sym_tactic,
    ACTIONS(4206), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4208), 1,
      anon_sym_u2987,
    ACTIONS(4212), 1,
      anon_sym_Set,
    STATE(3501), 1,
      sym_attributes,
    STATE(3888), 1,
      aux_sym__atoms,
    STATE(6121), 1,
      sym__qid,
    STATE(6386), 1,
      sym_atom,
    STATE(8067), 1,
      sym__LAMBDA,
    STATE(8369), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(852), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4210), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6575), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6565), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(4188), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10090), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [317822] = 34,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(878), 1,
      anon_sym_quoteGoal,
    ACTIONS(886), 1,
      anon_sym_let,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(4078), 1,
      anon_sym_u2984,
    ACTIONS(4182), 1,
      sym_id,
    ACTIONS(4184), 1,
      anon_sym_BSLASH,
    ACTIONS(4186), 1,
      anon_sym_u03bb,
    ACTIONS(4190), 1,
      anon_sym_record,
    ACTIONS(4192), 1,
      anon_sym_LPAREN,
    ACTIONS(4194), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4196), 1,
      anon_sym_u2983,
    ACTIONS(4198), 1,
      anon_sym_LBRACE,
    ACTIONS(4200), 1,
      aux_sym__qid_token1,
    ACTIONS(4202), 1,
      anon_sym_DOT,
    ACTIONS(4204), 1,
      anon_sym_tactic,
    ACTIONS(4206), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4208), 1,
      anon_sym_u2987,
    ACTIONS(4212), 1,
      anon_sym_Set,
    STATE(3702), 1,
      sym_attributes,
    STATE(3888), 1,
      aux_sym__atoms,
    STATE(6121), 1,
      sym__qid,
    STATE(6386), 1,
      sym_atom,
    STATE(8067), 1,
      sym__LAMBDA,
    STATE(8369), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(852), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4210), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6575), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6565), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(4188), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9799), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [317951] = 34,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(964), 1,
      anon_sym_quoteGoal,
    ACTIONS(972), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4078), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(4214), 1,
      anon_sym_BSLASH,
    ACTIONS(4216), 1,
      anon_sym_u03bb,
    ACTIONS(4218), 1,
      anon_sym_tactic,
    STATE(3468), 1,
      sym_attributes,
    STATE(3891), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8047), 1,
      sym__LAMBDA,
    STATE(8355), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(942), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10089), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [318080] = 34,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(732), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(964), 1,
      anon_sym_quoteGoal,
    ACTIONS(972), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4214), 1,
      anon_sym_BSLASH,
    ACTIONS(4216), 1,
      anon_sym_u03bb,
    ACTIONS(4218), 1,
      anon_sym_tactic,
    STATE(3360), 1,
      sym_attributes,
    STATE(3891), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8047), 1,
      sym__LAMBDA,
    STATE(8355), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(942), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10111), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [318209] = 34,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(964), 1,
      anon_sym_quoteGoal,
    ACTIONS(972), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4078), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(4214), 1,
      anon_sym_BSLASH,
    ACTIONS(4216), 1,
      anon_sym_u03bb,
    ACTIONS(4218), 1,
      anon_sym_tactic,
    STATE(3699), 1,
      sym_attributes,
    STATE(3891), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8047), 1,
      sym__LAMBDA,
    STATE(8355), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(942), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9800), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [318338] = 34,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(732), 1,
      anon_sym_u2984,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(878), 1,
      anon_sym_quoteGoal,
    ACTIONS(886), 1,
      anon_sym_let,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(4182), 1,
      sym_id,
    ACTIONS(4184), 1,
      anon_sym_BSLASH,
    ACTIONS(4186), 1,
      anon_sym_u03bb,
    ACTIONS(4190), 1,
      anon_sym_record,
    ACTIONS(4192), 1,
      anon_sym_LPAREN,
    ACTIONS(4194), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4196), 1,
      anon_sym_u2983,
    ACTIONS(4198), 1,
      anon_sym_LBRACE,
    ACTIONS(4200), 1,
      aux_sym__qid_token1,
    ACTIONS(4202), 1,
      anon_sym_DOT,
    ACTIONS(4204), 1,
      anon_sym_tactic,
    ACTIONS(4206), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4208), 1,
      anon_sym_u2987,
    ACTIONS(4212), 1,
      anon_sym_Set,
    STATE(3362), 1,
      sym_attributes,
    STATE(3888), 1,
      aux_sym__atoms,
    STATE(6121), 1,
      sym__qid,
    STATE(6386), 1,
      sym_atom,
    STATE(8067), 1,
      sym__LAMBDA,
    STATE(8369), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(852), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4210), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6575), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6565), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(4188), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10110), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [318467] = 34,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(732), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(964), 1,
      anon_sym_quoteGoal,
    ACTIONS(972), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4214), 1,
      anon_sym_BSLASH,
    ACTIONS(4216), 1,
      anon_sym_u03bb,
    ACTIONS(4218), 1,
      anon_sym_tactic,
    STATE(3675), 1,
      sym_attributes,
    STATE(3891), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8047), 1,
      sym__LAMBDA,
    STATE(8355), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(942), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9962), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [318596] = 34,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(732), 1,
      anon_sym_u2984,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(878), 1,
      anon_sym_quoteGoal,
    ACTIONS(886), 1,
      anon_sym_let,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(4182), 1,
      sym_id,
    ACTIONS(4184), 1,
      anon_sym_BSLASH,
    ACTIONS(4186), 1,
      anon_sym_u03bb,
    ACTIONS(4190), 1,
      anon_sym_record,
    ACTIONS(4192), 1,
      anon_sym_LPAREN,
    ACTIONS(4194), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4196), 1,
      anon_sym_u2983,
    ACTIONS(4198), 1,
      anon_sym_LBRACE,
    ACTIONS(4200), 1,
      aux_sym__qid_token1,
    ACTIONS(4202), 1,
      anon_sym_DOT,
    ACTIONS(4204), 1,
      anon_sym_tactic,
    ACTIONS(4206), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4208), 1,
      anon_sym_u2987,
    ACTIONS(4212), 1,
      anon_sym_Set,
    STATE(3664), 1,
      sym_attributes,
    STATE(3888), 1,
      aux_sym__atoms,
    STATE(6121), 1,
      sym__qid,
    STATE(6386), 1,
      sym_atom,
    STATE(8067), 1,
      sym__LAMBDA,
    STATE(8369), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(852), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4210), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6575), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6565), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(4188), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9965), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [318725] = 34,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(964), 1,
      anon_sym_quoteGoal,
    ACTIONS(972), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3978), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4214), 1,
      anon_sym_BSLASH,
    ACTIONS(4216), 1,
      anon_sym_u03bb,
    ACTIONS(4218), 1,
      anon_sym_tactic,
    STATE(3584), 1,
      sym_attributes,
    STATE(3891), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8047), 1,
      sym__LAMBDA,
    STATE(8355), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(942), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9898), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [318854] = 34,
    ACTIONS(710), 1,
      anon_sym_DASH,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(920), 1,
      anon_sym_quoteGoal,
    ACTIONS(928), 1,
      anon_sym_let,
    ACTIONS(3058), 1,
      anon_sym_BSLASH,
    ACTIONS(3060), 1,
      anon_sym_u03bb,
    ACTIONS(3064), 1,
      anon_sym_record,
    ACTIONS(3066), 1,
      anon_sym_LPAREN,
    ACTIONS(3068), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3070), 1,
      anon_sym_u2983,
    ACTIONS(3072), 1,
      anon_sym_LBRACE,
    ACTIONS(3076), 1,
      aux_sym__qid_token1,
    ACTIONS(3078), 1,
      anon_sym_DOT,
    ACTIONS(3080), 1,
      anon_sym_tactic,
    ACTIONS(3082), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3084), 1,
      anon_sym_u2987,
    ACTIONS(3088), 1,
      anon_sym_Set,
    ACTIONS(3978), 1,
      anon_sym_RBRACE,
    ACTIONS(4220), 1,
      sym_id,
    STATE(3666), 1,
      sym_attributes,
    STATE(3892), 1,
      aux_sym__atoms,
    STATE(6084), 1,
      sym__qid,
    STATE(6427), 1,
      sym_atom,
    STATE(8123), 1,
      sym__LAMBDA,
    STATE(8396), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3086), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6715), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6714), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3062), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10158), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [318983] = 34,
    ACTIONS(704), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(964), 1,
      anon_sym_quoteGoal,
    ACTIONS(972), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4214), 1,
      anon_sym_BSLASH,
    ACTIONS(4216), 1,
      anon_sym_u03bb,
    ACTIONS(4218), 1,
      anon_sym_tactic,
    STATE(3384), 1,
      sym_attributes,
    STATE(3891), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8047), 1,
      sym__LAMBDA,
    STATE(8355), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(942), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9900), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [319112] = 34,
    ACTIONS(704), 1,
      anon_sym_u2984,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(878), 1,
      anon_sym_quoteGoal,
    ACTIONS(886), 1,
      anon_sym_let,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(4182), 1,
      sym_id,
    ACTIONS(4184), 1,
      anon_sym_BSLASH,
    ACTIONS(4186), 1,
      anon_sym_u03bb,
    ACTIONS(4190), 1,
      anon_sym_record,
    ACTIONS(4192), 1,
      anon_sym_LPAREN,
    ACTIONS(4194), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4196), 1,
      anon_sym_u2983,
    ACTIONS(4198), 1,
      anon_sym_LBRACE,
    ACTIONS(4200), 1,
      aux_sym__qid_token1,
    ACTIONS(4202), 1,
      anon_sym_DOT,
    ACTIONS(4204), 1,
      anon_sym_tactic,
    ACTIONS(4206), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4208), 1,
      anon_sym_u2987,
    ACTIONS(4212), 1,
      anon_sym_Set,
    STATE(3398), 1,
      sym_attributes,
    STATE(3888), 1,
      aux_sym__atoms,
    STATE(6121), 1,
      sym__qid,
    STATE(6386), 1,
      sym_atom,
    STATE(8067), 1,
      sym__LAMBDA,
    STATE(8369), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(852), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4210), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6575), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6565), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(4188), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9901), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [319241] = 34,
    ACTIONS(710), 1,
      anon_sym_DASH,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(920), 1,
      anon_sym_quoteGoal,
    ACTIONS(928), 1,
      anon_sym_let,
    ACTIONS(3058), 1,
      anon_sym_BSLASH,
    ACTIONS(3060), 1,
      anon_sym_u03bb,
    ACTIONS(3064), 1,
      anon_sym_record,
    ACTIONS(3066), 1,
      anon_sym_LPAREN,
    ACTIONS(3068), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3070), 1,
      anon_sym_u2983,
    ACTIONS(3072), 1,
      anon_sym_LBRACE,
    ACTIONS(3076), 1,
      aux_sym__qid_token1,
    ACTIONS(3078), 1,
      anon_sym_DOT,
    ACTIONS(3080), 1,
      anon_sym_tactic,
    ACTIONS(3082), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3084), 1,
      anon_sym_u2987,
    ACTIONS(3088), 1,
      anon_sym_Set,
    ACTIONS(4078), 1,
      anon_sym_RBRACE,
    ACTIONS(4220), 1,
      sym_id,
    STATE(3500), 1,
      sym_attributes,
    STATE(3892), 1,
      aux_sym__atoms,
    STATE(6084), 1,
      sym__qid,
    STATE(6427), 1,
      sym_atom,
    STATE(8123), 1,
      sym__LAMBDA,
    STATE(8396), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3086), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6715), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6714), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3062), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9899), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [319370] = 34,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(878), 1,
      anon_sym_quoteGoal,
    ACTIONS(886), 1,
      anon_sym_let,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(3978), 1,
      anon_sym_u2984,
    ACTIONS(4182), 1,
      sym_id,
    ACTIONS(4184), 1,
      anon_sym_BSLASH,
    ACTIONS(4186), 1,
      anon_sym_u03bb,
    ACTIONS(4190), 1,
      anon_sym_record,
    ACTIONS(4192), 1,
      anon_sym_LPAREN,
    ACTIONS(4194), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4196), 1,
      anon_sym_u2983,
    ACTIONS(4198), 1,
      anon_sym_LBRACE,
    ACTIONS(4200), 1,
      aux_sym__qid_token1,
    ACTIONS(4202), 1,
      anon_sym_DOT,
    ACTIONS(4204), 1,
      anon_sym_tactic,
    ACTIONS(4206), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4208), 1,
      anon_sym_u2987,
    ACTIONS(4212), 1,
      anon_sym_Set,
    STATE(3674), 1,
      sym_attributes,
    STATE(3888), 1,
      aux_sym__atoms,
    STATE(6121), 1,
      sym__qid,
    STATE(6386), 1,
      sym_atom,
    STATE(8067), 1,
      sym__LAMBDA,
    STATE(8369), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(852), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4210), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6575), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6565), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(4188), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10156), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [319499] = 34,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(732), 1,
      anon_sym_u2984,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(878), 1,
      anon_sym_quoteGoal,
    ACTIONS(886), 1,
      anon_sym_let,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(4182), 1,
      sym_id,
    ACTIONS(4184), 1,
      anon_sym_BSLASH,
    ACTIONS(4186), 1,
      anon_sym_u03bb,
    ACTIONS(4190), 1,
      anon_sym_record,
    ACTIONS(4192), 1,
      anon_sym_LPAREN,
    ACTIONS(4194), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4196), 1,
      anon_sym_u2983,
    ACTIONS(4198), 1,
      anon_sym_LBRACE,
    ACTIONS(4200), 1,
      aux_sym__qid_token1,
    ACTIONS(4202), 1,
      anon_sym_DOT,
    ACTIONS(4204), 1,
      anon_sym_tactic,
    ACTIONS(4206), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4208), 1,
      anon_sym_u2987,
    ACTIONS(4212), 1,
      anon_sym_Set,
    STATE(3702), 1,
      sym_attributes,
    STATE(3888), 1,
      aux_sym__atoms,
    STATE(6121), 1,
      sym__qid,
    STATE(6386), 1,
      sym_atom,
    STATE(8067), 1,
      sym__LAMBDA,
    STATE(8369), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(852), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4210), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6575), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6565), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(4188), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9799), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [319628] = 34,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(732), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(964), 1,
      anon_sym_quoteGoal,
    ACTIONS(972), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4214), 1,
      anon_sym_BSLASH,
    ACTIONS(4216), 1,
      anon_sym_u03bb,
    ACTIONS(4218), 1,
      anon_sym_tactic,
    STATE(3699), 1,
      sym_attributes,
    STATE(3891), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8047), 1,
      sym__LAMBDA,
    STATE(8355), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(942), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9800), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [319757] = 34,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(964), 1,
      anon_sym_quoteGoal,
    ACTIONS(972), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3978), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4214), 1,
      anon_sym_BSLASH,
    ACTIONS(4216), 1,
      anon_sym_u03bb,
    ACTIONS(4218), 1,
      anon_sym_tactic,
    STATE(3677), 1,
      sym_attributes,
    STATE(3891), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8047), 1,
      sym__LAMBDA,
    STATE(8355), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(942), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10154), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [319886] = 34,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(730), 1,
      anon_sym_u2984,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(878), 1,
      anon_sym_quoteGoal,
    ACTIONS(886), 1,
      anon_sym_let,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(4182), 1,
      sym_id,
    ACTIONS(4184), 1,
      anon_sym_BSLASH,
    ACTIONS(4186), 1,
      anon_sym_u03bb,
    ACTIONS(4190), 1,
      anon_sym_record,
    ACTIONS(4192), 1,
      anon_sym_LPAREN,
    ACTIONS(4194), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4196), 1,
      anon_sym_u2983,
    ACTIONS(4198), 1,
      anon_sym_LBRACE,
    ACTIONS(4200), 1,
      aux_sym__qid_token1,
    ACTIONS(4202), 1,
      anon_sym_DOT,
    ACTIONS(4204), 1,
      anon_sym_tactic,
    ACTIONS(4206), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4208), 1,
      anon_sym_u2987,
    ACTIONS(4212), 1,
      anon_sym_Set,
    STATE(3418), 1,
      sym_attributes,
    STATE(3888), 1,
      aux_sym__atoms,
    STATE(6121), 1,
      sym__qid,
    STATE(6386), 1,
      sym_atom,
    STATE(8067), 1,
      sym__LAMBDA,
    STATE(8369), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(852), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4210), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6575), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6565), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(4188), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9741), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [320015] = 34,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(730), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(964), 1,
      anon_sym_quoteGoal,
    ACTIONS(972), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4214), 1,
      anon_sym_BSLASH,
    ACTIONS(4216), 1,
      anon_sym_u03bb,
    ACTIONS(4218), 1,
      anon_sym_tactic,
    STATE(3395), 1,
      sym_attributes,
    STATE(3891), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8047), 1,
      sym__LAMBDA,
    STATE(8355), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(942), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9753), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [320144] = 34,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(730), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(964), 1,
      anon_sym_quoteGoal,
    ACTIONS(972), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4214), 1,
      anon_sym_BSLASH,
    ACTIONS(4216), 1,
      anon_sym_u03bb,
    ACTIONS(4218), 1,
      anon_sym_tactic,
    STATE(3601), 1,
      sym_attributes,
    STATE(3891), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8047), 1,
      sym__LAMBDA,
    STATE(8355), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(942), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9847), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [320273] = 34,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(730), 1,
      anon_sym_u2984,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(878), 1,
      anon_sym_quoteGoal,
    ACTIONS(886), 1,
      anon_sym_let,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(4182), 1,
      sym_id,
    ACTIONS(4184), 1,
      anon_sym_BSLASH,
    ACTIONS(4186), 1,
      anon_sym_u03bb,
    ACTIONS(4190), 1,
      anon_sym_record,
    ACTIONS(4192), 1,
      anon_sym_LPAREN,
    ACTIONS(4194), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4196), 1,
      anon_sym_u2983,
    ACTIONS(4198), 1,
      anon_sym_LBRACE,
    ACTIONS(4200), 1,
      aux_sym__qid_token1,
    ACTIONS(4202), 1,
      anon_sym_DOT,
    ACTIONS(4204), 1,
      anon_sym_tactic,
    ACTIONS(4206), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4208), 1,
      anon_sym_u2987,
    ACTIONS(4212), 1,
      anon_sym_Set,
    STATE(3604), 1,
      sym_attributes,
    STATE(3888), 1,
      aux_sym__atoms,
    STATE(6121), 1,
      sym__qid,
    STATE(6386), 1,
      sym_atom,
    STATE(8067), 1,
      sym__LAMBDA,
    STATE(8369), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(852), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4210), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6575), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6565), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(4188), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9920), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [320402] = 34,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(730), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(964), 1,
      anon_sym_quoteGoal,
    ACTIONS(972), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4214), 1,
      anon_sym_BSLASH,
    ACTIONS(4216), 1,
      anon_sym_u03bb,
    ACTIONS(4218), 1,
      anon_sym_tactic,
    STATE(3413), 1,
      sym_attributes,
    STATE(3891), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8047), 1,
      sym__LAMBDA,
    STATE(8355), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(942), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9742), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [320531] = 34,
    ACTIONS(710), 1,
      anon_sym_DASH,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(920), 1,
      anon_sym_quoteGoal,
    ACTIONS(928), 1,
      anon_sym_let,
    ACTIONS(3058), 1,
      anon_sym_BSLASH,
    ACTIONS(3060), 1,
      anon_sym_u03bb,
    ACTIONS(3064), 1,
      anon_sym_record,
    ACTIONS(3066), 1,
      anon_sym_LPAREN,
    ACTIONS(3068), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3070), 1,
      anon_sym_u2983,
    ACTIONS(3072), 1,
      anon_sym_LBRACE,
    ACTIONS(3076), 1,
      aux_sym__qid_token1,
    ACTIONS(3078), 1,
      anon_sym_DOT,
    ACTIONS(3080), 1,
      anon_sym_tactic,
    ACTIONS(3082), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3084), 1,
      anon_sym_u2987,
    ACTIONS(3088), 1,
      anon_sym_Set,
    ACTIONS(3978), 1,
      anon_sym_RBRACE,
    ACTIONS(4220), 1,
      sym_id,
    STATE(3632), 1,
      sym_attributes,
    STATE(3892), 1,
      aux_sym__atoms,
    STATE(6084), 1,
      sym__qid,
    STATE(6427), 1,
      sym_atom,
    STATE(8123), 1,
      sym__LAMBDA,
    STATE(8396), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3086), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6715), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6714), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3062), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10166), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [320660] = 34,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(964), 1,
      anon_sym_quoteGoal,
    ACTIONS(972), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4078), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(4214), 1,
      anon_sym_BSLASH,
    ACTIONS(4216), 1,
      anon_sym_u03bb,
    ACTIONS(4218), 1,
      anon_sym_tactic,
    STATE(3675), 1,
      sym_attributes,
    STATE(3891), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8047), 1,
      sym__LAMBDA,
    STATE(8355), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(942), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9962), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [320789] = 34,
    ACTIONS(710), 1,
      anon_sym_DASH,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(920), 1,
      anon_sym_quoteGoal,
    ACTIONS(928), 1,
      anon_sym_let,
    ACTIONS(3058), 1,
      anon_sym_BSLASH,
    ACTIONS(3060), 1,
      anon_sym_u03bb,
    ACTIONS(3064), 1,
      anon_sym_record,
    ACTIONS(3066), 1,
      anon_sym_LPAREN,
    ACTIONS(3068), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3070), 1,
      anon_sym_u2983,
    ACTIONS(3072), 1,
      anon_sym_LBRACE,
    ACTIONS(3076), 1,
      aux_sym__qid_token1,
    ACTIONS(3078), 1,
      anon_sym_DOT,
    ACTIONS(3080), 1,
      anon_sym_tactic,
    ACTIONS(3082), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3084), 1,
      anon_sym_u2987,
    ACTIONS(3088), 1,
      anon_sym_Set,
    ACTIONS(3978), 1,
      anon_sym_RBRACE,
    ACTIONS(4220), 1,
      sym_id,
    STATE(3510), 1,
      sym_attributes,
    STATE(3892), 1,
      aux_sym__atoms,
    STATE(6084), 1,
      sym__qid,
    STATE(6427), 1,
      sym_atom,
    STATE(8123), 1,
      sym__LAMBDA,
    STATE(8396), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3086), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6715), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6714), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3062), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10222), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [320918] = 34,
    ACTIONS(704), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(964), 1,
      anon_sym_quoteGoal,
    ACTIONS(972), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4214), 1,
      anon_sym_BSLASH,
    ACTIONS(4216), 1,
      anon_sym_u03bb,
    ACTIONS(4218), 1,
      anon_sym_tactic,
    STATE(3365), 1,
      sym_attributes,
    STATE(3891), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8047), 1,
      sym__LAMBDA,
    STATE(8355), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(942), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9875), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [321047] = 34,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(730), 1,
      anon_sym_u2984,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(878), 1,
      anon_sym_quoteGoal,
    ACTIONS(886), 1,
      anon_sym_let,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(4182), 1,
      sym_id,
    ACTIONS(4184), 1,
      anon_sym_BSLASH,
    ACTIONS(4186), 1,
      anon_sym_u03bb,
    ACTIONS(4190), 1,
      anon_sym_record,
    ACTIONS(4192), 1,
      anon_sym_LPAREN,
    ACTIONS(4194), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4196), 1,
      anon_sym_u2983,
    ACTIONS(4198), 1,
      anon_sym_LBRACE,
    ACTIONS(4200), 1,
      aux_sym__qid_token1,
    ACTIONS(4202), 1,
      anon_sym_DOT,
    ACTIONS(4204), 1,
      anon_sym_tactic,
    ACTIONS(4206), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4208), 1,
      anon_sym_u2987,
    ACTIONS(4212), 1,
      anon_sym_Set,
    STATE(3400), 1,
      sym_attributes,
    STATE(3888), 1,
      aux_sym__atoms,
    STATE(6121), 1,
      sym__qid,
    STATE(6386), 1,
      sym_atom,
    STATE(8067), 1,
      sym__LAMBDA,
    STATE(8369), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(852), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4210), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6575), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6565), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(4188), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9755), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [321176] = 34,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(732), 1,
      anon_sym_u2984,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(878), 1,
      anon_sym_quoteGoal,
    ACTIONS(886), 1,
      anon_sym_let,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(4182), 1,
      sym_id,
    ACTIONS(4184), 1,
      anon_sym_BSLASH,
    ACTIONS(4186), 1,
      anon_sym_u03bb,
    ACTIONS(4190), 1,
      anon_sym_record,
    ACTIONS(4192), 1,
      anon_sym_LPAREN,
    ACTIONS(4194), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4196), 1,
      anon_sym_u2983,
    ACTIONS(4198), 1,
      anon_sym_LBRACE,
    ACTIONS(4200), 1,
      aux_sym__qid_token1,
    ACTIONS(4202), 1,
      anon_sym_DOT,
    ACTIONS(4204), 1,
      anon_sym_tactic,
    ACTIONS(4206), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4208), 1,
      anon_sym_u2987,
    ACTIONS(4212), 1,
      anon_sym_Set,
    STATE(3501), 1,
      sym_attributes,
    STATE(3888), 1,
      aux_sym__atoms,
    STATE(6121), 1,
      sym__qid,
    STATE(6386), 1,
      sym_atom,
    STATE(8067), 1,
      sym__LAMBDA,
    STATE(8369), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(852), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4210), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6575), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6565), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(4188), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10090), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [321305] = 34,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(964), 1,
      anon_sym_quoteGoal,
    ACTIONS(972), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3978), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4214), 1,
      anon_sym_BSLASH,
    ACTIONS(4216), 1,
      anon_sym_u03bb,
    ACTIONS(4218), 1,
      anon_sym_tactic,
    STATE(3698), 1,
      sym_attributes,
    STATE(3891), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8047), 1,
      sym__LAMBDA,
    STATE(8355), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(942), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10163), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [321434] = 3,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1104), 2,
      sym__dedent,
      anon_sym_BSLASH,
    ACTIONS(1102), 57,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_field,
      anon_sym_instance,
      anon_sym_module,
      anon_sym_data,
      anon_sym_codata,
      anon_sym_record,
      anon_sym_constructor,
      anon_sym_inductive,
      anon_sym_coinductive,
      anon_sym_eta_DASHequality,
      anon_sym_no_DASHeta_DASHequality,
      anon_sym_infix,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_variable,
      anon_sym_mutual,
      anon_sym_abstract,
      anon_sym_private,
      anon_sym_macro,
      anon_sym_postulate,
      anon_sym_primitive,
      anon_sym_open,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      sym_pragma,
      anon_sym_syntax,
      anon_sym_LBRACE,
      anon_sym_pattern,
      anon_sym_unquoteDecl,
      anon_sym_unquoteDef,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_AT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [321501] = 34,
    ACTIONS(710), 1,
      anon_sym_DASH,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(920), 1,
      anon_sym_quoteGoal,
    ACTIONS(928), 1,
      anon_sym_let,
    ACTIONS(3058), 1,
      anon_sym_BSLASH,
    ACTIONS(3060), 1,
      anon_sym_u03bb,
    ACTIONS(3064), 1,
      anon_sym_record,
    ACTIONS(3066), 1,
      anon_sym_LPAREN,
    ACTIONS(3068), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3070), 1,
      anon_sym_u2983,
    ACTIONS(3072), 1,
      anon_sym_LBRACE,
    ACTIONS(3076), 1,
      aux_sym__qid_token1,
    ACTIONS(3078), 1,
      anon_sym_DOT,
    ACTIONS(3080), 1,
      anon_sym_tactic,
    ACTIONS(3082), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3084), 1,
      anon_sym_u2987,
    ACTIONS(3088), 1,
      anon_sym_Set,
    ACTIONS(3978), 1,
      anon_sym_RBRACE,
    ACTIONS(4220), 1,
      sym_id,
    STATE(3640), 1,
      sym_attributes,
    STATE(3892), 1,
      aux_sym__atoms,
    STATE(6084), 1,
      sym__qid,
    STATE(6427), 1,
      sym_atom,
    STATE(8123), 1,
      sym__LAMBDA,
    STATE(8396), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3086), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6715), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6714), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3062), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9715), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [321630] = 34,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(732), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(964), 1,
      anon_sym_quoteGoal,
    ACTIONS(972), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4214), 1,
      anon_sym_BSLASH,
    ACTIONS(4216), 1,
      anon_sym_u03bb,
    ACTIONS(4218), 1,
      anon_sym_tactic,
    STATE(3468), 1,
      sym_attributes,
    STATE(3891), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8047), 1,
      sym__LAMBDA,
    STATE(8355), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(942), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10089), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [321759] = 34,
    ACTIONS(710), 1,
      anon_sym_DASH,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(920), 1,
      anon_sym_quoteGoal,
    ACTIONS(928), 1,
      anon_sym_let,
    ACTIONS(3058), 1,
      anon_sym_BSLASH,
    ACTIONS(3060), 1,
      anon_sym_u03bb,
    ACTIONS(3064), 1,
      anon_sym_record,
    ACTIONS(3066), 1,
      anon_sym_LPAREN,
    ACTIONS(3068), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3070), 1,
      anon_sym_u2983,
    ACTIONS(3072), 1,
      anon_sym_LBRACE,
    ACTIONS(3076), 1,
      aux_sym__qid_token1,
    ACTIONS(3078), 1,
      anon_sym_DOT,
    ACTIONS(3080), 1,
      anon_sym_tactic,
    ACTIONS(3082), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3084), 1,
      anon_sym_u2987,
    ACTIONS(3088), 1,
      anon_sym_Set,
    ACTIONS(3978), 1,
      anon_sym_RBRACE,
    ACTIONS(4220), 1,
      sym_id,
    STATE(3631), 1,
      sym_attributes,
    STATE(3892), 1,
      aux_sym__atoms,
    STATE(6084), 1,
      sym__qid,
    STATE(6427), 1,
      sym_atom,
    STATE(8123), 1,
      sym__LAMBDA,
    STATE(8396), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3086), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6715), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6714), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3062), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9903), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [321888] = 34,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(964), 1,
      anon_sym_quoteGoal,
    ACTIONS(972), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4092), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(4214), 1,
      anon_sym_BSLASH,
    ACTIONS(4216), 1,
      anon_sym_u03bb,
    ACTIONS(4218), 1,
      anon_sym_tactic,
    STATE(3395), 1,
      sym_attributes,
    STATE(3891), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8047), 1,
      sym__LAMBDA,
    STATE(8355), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(942), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9753), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [322017] = 34,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(964), 1,
      anon_sym_quoteGoal,
    ACTIONS(972), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3978), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4214), 1,
      anon_sym_BSLASH,
    ACTIONS(4216), 1,
      anon_sym_u03bb,
    ACTIONS(4218), 1,
      anon_sym_tactic,
    STATE(3511), 1,
      sym_attributes,
    STATE(3891), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8047), 1,
      sym__LAMBDA,
    STATE(8355), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(942), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10229), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [322146] = 34,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(878), 1,
      anon_sym_quoteGoal,
    ACTIONS(886), 1,
      anon_sym_let,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(4092), 1,
      anon_sym_u2984,
    ACTIONS(4182), 1,
      sym_id,
    ACTIONS(4184), 1,
      anon_sym_BSLASH,
    ACTIONS(4186), 1,
      anon_sym_u03bb,
    ACTIONS(4190), 1,
      anon_sym_record,
    ACTIONS(4192), 1,
      anon_sym_LPAREN,
    ACTIONS(4194), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4196), 1,
      anon_sym_u2983,
    ACTIONS(4198), 1,
      anon_sym_LBRACE,
    ACTIONS(4200), 1,
      aux_sym__qid_token1,
    ACTIONS(4202), 1,
      anon_sym_DOT,
    ACTIONS(4204), 1,
      anon_sym_tactic,
    ACTIONS(4206), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4208), 1,
      anon_sym_u2987,
    ACTIONS(4212), 1,
      anon_sym_Set,
    STATE(3400), 1,
      sym_attributes,
    STATE(3888), 1,
      aux_sym__atoms,
    STATE(6121), 1,
      sym__qid,
    STATE(6386), 1,
      sym_atom,
    STATE(8067), 1,
      sym__LAMBDA,
    STATE(8369), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(852), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4210), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6575), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6565), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(4188), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9755), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [322275] = 34,
    ACTIONS(710), 1,
      anon_sym_DASH,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(920), 1,
      anon_sym_quoteGoal,
    ACTIONS(928), 1,
      anon_sym_let,
    ACTIONS(3058), 1,
      anon_sym_BSLASH,
    ACTIONS(3060), 1,
      anon_sym_u03bb,
    ACTIONS(3064), 1,
      anon_sym_record,
    ACTIONS(3066), 1,
      anon_sym_LPAREN,
    ACTIONS(3068), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3070), 1,
      anon_sym_u2983,
    ACTIONS(3072), 1,
      anon_sym_LBRACE,
    ACTIONS(3076), 1,
      aux_sym__qid_token1,
    ACTIONS(3078), 1,
      anon_sym_DOT,
    ACTIONS(3080), 1,
      anon_sym_tactic,
    ACTIONS(3082), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3084), 1,
      anon_sym_u2987,
    ACTIONS(3088), 1,
      anon_sym_Set,
    ACTIONS(4092), 1,
      anon_sym_RBRACE,
    ACTIONS(4220), 1,
      sym_id,
    STATE(3401), 1,
      sym_attributes,
    STATE(3892), 1,
      aux_sym__atoms,
    STATE(6084), 1,
      sym__qid,
    STATE(6427), 1,
      sym_atom,
    STATE(8123), 1,
      sym__LAMBDA,
    STATE(8396), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3086), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6715), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6714), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3062), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9757), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [322404] = 34,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(878), 1,
      anon_sym_quoteGoal,
    ACTIONS(886), 1,
      anon_sym_let,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(3978), 1,
      anon_sym_u2984,
    ACTIONS(4182), 1,
      sym_id,
    ACTIONS(4184), 1,
      anon_sym_BSLASH,
    ACTIONS(4186), 1,
      anon_sym_u03bb,
    ACTIONS(4190), 1,
      anon_sym_record,
    ACTIONS(4192), 1,
      anon_sym_LPAREN,
    ACTIONS(4194), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4196), 1,
      anon_sym_u2983,
    ACTIONS(4198), 1,
      anon_sym_LBRACE,
    ACTIONS(4200), 1,
      aux_sym__qid_token1,
    ACTIONS(4202), 1,
      anon_sym_DOT,
    ACTIONS(4204), 1,
      anon_sym_tactic,
    ACTIONS(4206), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4208), 1,
      anon_sym_u2987,
    ACTIONS(4212), 1,
      anon_sym_Set,
    STATE(3409), 1,
      sym_attributes,
    STATE(3888), 1,
      aux_sym__atoms,
    STATE(6121), 1,
      sym__qid,
    STATE(6386), 1,
      sym_atom,
    STATE(8067), 1,
      sym__LAMBDA,
    STATE(8369), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(852), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4210), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6575), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6565), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(4188), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10202), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [322533] = 34,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(878), 1,
      anon_sym_quoteGoal,
    ACTIONS(886), 1,
      anon_sym_let,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(3978), 1,
      anon_sym_u2984,
    ACTIONS(4182), 1,
      sym_id,
    ACTIONS(4184), 1,
      anon_sym_BSLASH,
    ACTIONS(4186), 1,
      anon_sym_u03bb,
    ACTIONS(4190), 1,
      anon_sym_record,
    ACTIONS(4192), 1,
      anon_sym_LPAREN,
    ACTIONS(4194), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4196), 1,
      anon_sym_u2983,
    ACTIONS(4198), 1,
      anon_sym_LBRACE,
    ACTIONS(4200), 1,
      aux_sym__qid_token1,
    ACTIONS(4202), 1,
      anon_sym_DOT,
    ACTIONS(4204), 1,
      anon_sym_tactic,
    ACTIONS(4206), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4208), 1,
      anon_sym_u2987,
    ACTIONS(4212), 1,
      anon_sym_Set,
    STATE(3642), 1,
      sym_attributes,
    STATE(3888), 1,
      aux_sym__atoms,
    STATE(6121), 1,
      sym__qid,
    STATE(6386), 1,
      sym_atom,
    STATE(8067), 1,
      sym__LAMBDA,
    STATE(8369), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(852), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4210), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6575), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6565), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(4188), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9726), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [322662] = 34,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(964), 1,
      anon_sym_quoteGoal,
    ACTIONS(972), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3978), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4214), 1,
      anon_sym_BSLASH,
    ACTIONS(4216), 1,
      anon_sym_u03bb,
    ACTIONS(4218), 1,
      anon_sym_tactic,
    STATE(3649), 1,
      sym_attributes,
    STATE(3891), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8047), 1,
      sym__LAMBDA,
    STATE(8355), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(942), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9727), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [322791] = 34,
    ACTIONS(710), 1,
      anon_sym_DASH,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(920), 1,
      anon_sym_quoteGoal,
    ACTIONS(928), 1,
      anon_sym_let,
    ACTIONS(3058), 1,
      anon_sym_BSLASH,
    ACTIONS(3060), 1,
      anon_sym_u03bb,
    ACTIONS(3064), 1,
      anon_sym_record,
    ACTIONS(3066), 1,
      anon_sym_LPAREN,
    ACTIONS(3068), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3070), 1,
      anon_sym_u2983,
    ACTIONS(3072), 1,
      anon_sym_LBRACE,
    ACTIONS(3076), 1,
      aux_sym__qid_token1,
    ACTIONS(3078), 1,
      anon_sym_DOT,
    ACTIONS(3080), 1,
      anon_sym_tactic,
    ACTIONS(3082), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3084), 1,
      anon_sym_u2987,
    ACTIONS(3088), 1,
      anon_sym_Set,
    ACTIONS(3978), 1,
      anon_sym_RBRACE,
    ACTIONS(4220), 1,
      sym_id,
    STATE(3405), 1,
      sym_attributes,
    STATE(3892), 1,
      aux_sym__atoms,
    STATE(6084), 1,
      sym__qid,
    STATE(6427), 1,
      sym_atom,
    STATE(8123), 1,
      sym__LAMBDA,
    STATE(8396), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3086), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6715), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6714), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3062), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10230), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [322920] = 34,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(732), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(964), 1,
      anon_sym_quoteGoal,
    ACTIONS(972), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4214), 1,
      anon_sym_BSLASH,
    ACTIONS(4216), 1,
      anon_sym_u03bb,
    ACTIONS(4218), 1,
      anon_sym_tactic,
    STATE(3647), 1,
      sym_attributes,
    STATE(3891), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8047), 1,
      sym__LAMBDA,
    STATE(8355), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(942), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9717), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [323049] = 34,
    ACTIONS(710), 1,
      anon_sym_DASH,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(920), 1,
      anon_sym_quoteGoal,
    ACTIONS(928), 1,
      anon_sym_let,
    ACTIONS(3058), 1,
      anon_sym_BSLASH,
    ACTIONS(3060), 1,
      anon_sym_u03bb,
    ACTIONS(3064), 1,
      anon_sym_record,
    ACTIONS(3066), 1,
      anon_sym_LPAREN,
    ACTIONS(3068), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3070), 1,
      anon_sym_u2983,
    ACTIONS(3072), 1,
      anon_sym_LBRACE,
    ACTIONS(3076), 1,
      aux_sym__qid_token1,
    ACTIONS(3078), 1,
      anon_sym_DOT,
    ACTIONS(3080), 1,
      anon_sym_tactic,
    ACTIONS(3082), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3084), 1,
      anon_sym_u2987,
    ACTIONS(3088), 1,
      anon_sym_Set,
    ACTIONS(3978), 1,
      anon_sym_RBRACE,
    ACTIONS(4220), 1,
      sym_id,
    STATE(3540), 1,
      sym_attributes,
    STATE(3892), 1,
      aux_sym__atoms,
    STATE(6084), 1,
      sym__qid,
    STATE(6427), 1,
      sym_atom,
    STATE(8123), 1,
      sym__LAMBDA,
    STATE(8396), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3086), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6715), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6714), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3062), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10027), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [323178] = 34,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(964), 1,
      anon_sym_quoteGoal,
    ACTIONS(972), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3978), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4214), 1,
      anon_sym_BSLASH,
    ACTIONS(4216), 1,
      anon_sym_u03bb,
    ACTIONS(4218), 1,
      anon_sym_tactic,
    STATE(3454), 1,
      sym_attributes,
    STATE(3891), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8047), 1,
      sym__LAMBDA,
    STATE(8355), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(942), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9773), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [323307] = 34,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(964), 1,
      anon_sym_quoteGoal,
    ACTIONS(972), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3978), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4214), 1,
      anon_sym_BSLASH,
    ACTIONS(4216), 1,
      anon_sym_u03bb,
    ACTIONS(4218), 1,
      anon_sym_tactic,
    STATE(3384), 1,
      sym_attributes,
    STATE(3891), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8047), 1,
      sym__LAMBDA,
    STATE(8355), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(942), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9900), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [323436] = 34,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(878), 1,
      anon_sym_quoteGoal,
    ACTIONS(886), 1,
      anon_sym_let,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(3978), 1,
      anon_sym_u2984,
    ACTIONS(4182), 1,
      sym_id,
    ACTIONS(4184), 1,
      anon_sym_BSLASH,
    ACTIONS(4186), 1,
      anon_sym_u03bb,
    ACTIONS(4190), 1,
      anon_sym_record,
    ACTIONS(4192), 1,
      anon_sym_LPAREN,
    ACTIONS(4194), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4196), 1,
      anon_sym_u2983,
    ACTIONS(4198), 1,
      anon_sym_LBRACE,
    ACTIONS(4200), 1,
      aux_sym__qid_token1,
    ACTIONS(4202), 1,
      anon_sym_DOT,
    ACTIONS(4204), 1,
      anon_sym_tactic,
    ACTIONS(4206), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4208), 1,
      anon_sym_u2987,
    ACTIONS(4212), 1,
      anon_sym_Set,
    STATE(3532), 1,
      sym_attributes,
    STATE(3888), 1,
      aux_sym__atoms,
    STATE(6121), 1,
      sym__qid,
    STATE(6386), 1,
      sym_atom,
    STATE(8067), 1,
      sym__LAMBDA,
    STATE(8369), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(852), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4210), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6575), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6565), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(4188), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10028), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [323565] = 34,
    ACTIONS(710), 1,
      anon_sym_DASH,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(920), 1,
      anon_sym_quoteGoal,
    ACTIONS(928), 1,
      anon_sym_let,
    ACTIONS(3058), 1,
      anon_sym_BSLASH,
    ACTIONS(3060), 1,
      anon_sym_u03bb,
    ACTIONS(3064), 1,
      anon_sym_record,
    ACTIONS(3066), 1,
      anon_sym_LPAREN,
    ACTIONS(3068), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3070), 1,
      anon_sym_u2983,
    ACTIONS(3072), 1,
      anon_sym_LBRACE,
    ACTIONS(3076), 1,
      aux_sym__qid_token1,
    ACTIONS(3078), 1,
      anon_sym_DOT,
    ACTIONS(3080), 1,
      anon_sym_tactic,
    ACTIONS(3082), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3084), 1,
      anon_sym_u2987,
    ACTIONS(3088), 1,
      anon_sym_Set,
    ACTIONS(4078), 1,
      anon_sym_RBRACE,
    ACTIONS(4220), 1,
      sym_id,
    STATE(3663), 1,
      sym_attributes,
    STATE(3892), 1,
      aux_sym__atoms,
    STATE(6084), 1,
      sym__qid,
    STATE(6427), 1,
      sym_atom,
    STATE(8123), 1,
      sym__LAMBDA,
    STATE(8396), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3086), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6715), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6714), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3062), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9966), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [323694] = 34,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(878), 1,
      anon_sym_quoteGoal,
    ACTIONS(886), 1,
      anon_sym_let,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(3978), 1,
      anon_sym_u2984,
    ACTIONS(4182), 1,
      sym_id,
    ACTIONS(4184), 1,
      anon_sym_BSLASH,
    ACTIONS(4186), 1,
      anon_sym_u03bb,
    ACTIONS(4190), 1,
      anon_sym_record,
    ACTIONS(4192), 1,
      anon_sym_LPAREN,
    ACTIONS(4194), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4196), 1,
      anon_sym_u2983,
    ACTIONS(4198), 1,
      anon_sym_LBRACE,
    ACTIONS(4200), 1,
      aux_sym__qid_token1,
    ACTIONS(4202), 1,
      anon_sym_DOT,
    ACTIONS(4204), 1,
      anon_sym_tactic,
    ACTIONS(4206), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4208), 1,
      anon_sym_u2987,
    ACTIONS(4212), 1,
      anon_sym_Set,
    STATE(3424), 1,
      sym_attributes,
    STATE(3888), 1,
      aux_sym__atoms,
    STATE(6121), 1,
      sym__qid,
    STATE(6386), 1,
      sym_atom,
    STATE(8067), 1,
      sym__LAMBDA,
    STATE(8369), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(852), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4210), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6575), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6565), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(4188), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9774), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [323823] = 34,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(732), 1,
      anon_sym_u2984,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(878), 1,
      anon_sym_quoteGoal,
    ACTIONS(886), 1,
      anon_sym_let,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(4182), 1,
      sym_id,
    ACTIONS(4184), 1,
      anon_sym_BSLASH,
    ACTIONS(4186), 1,
      anon_sym_u03bb,
    ACTIONS(4190), 1,
      anon_sym_record,
    ACTIONS(4192), 1,
      anon_sym_LPAREN,
    ACTIONS(4194), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4196), 1,
      anon_sym_u2983,
    ACTIONS(4198), 1,
      anon_sym_LBRACE,
    ACTIONS(4200), 1,
      aux_sym__qid_token1,
    ACTIONS(4202), 1,
      anon_sym_DOT,
    ACTIONS(4204), 1,
      anon_sym_tactic,
    ACTIONS(4206), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4208), 1,
      anon_sym_u2987,
    ACTIONS(4212), 1,
      anon_sym_Set,
    STATE(3645), 1,
      sym_attributes,
    STATE(3888), 1,
      aux_sym__atoms,
    STATE(6121), 1,
      sym__qid,
    STATE(6386), 1,
      sym_atom,
    STATE(8067), 1,
      sym__LAMBDA,
    STATE(8369), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(852), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4210), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6575), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6565), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(4188), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9718), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [323952] = 34,
    ACTIONS(710), 1,
      anon_sym_DASH,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(920), 1,
      anon_sym_quoteGoal,
    ACTIONS(928), 1,
      anon_sym_let,
    ACTIONS(3058), 1,
      anon_sym_BSLASH,
    ACTIONS(3060), 1,
      anon_sym_u03bb,
    ACTIONS(3064), 1,
      anon_sym_record,
    ACTIONS(3066), 1,
      anon_sym_LPAREN,
    ACTIONS(3068), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3070), 1,
      anon_sym_u2983,
    ACTIONS(3072), 1,
      anon_sym_LBRACE,
    ACTIONS(3076), 1,
      aux_sym__qid_token1,
    ACTIONS(3078), 1,
      anon_sym_DOT,
    ACTIONS(3080), 1,
      anon_sym_tactic,
    ACTIONS(3082), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3084), 1,
      anon_sym_u2987,
    ACTIONS(3088), 1,
      anon_sym_Set,
    ACTIONS(3978), 1,
      anon_sym_RBRACE,
    ACTIONS(4220), 1,
      sym_id,
    STATE(3622), 1,
      sym_attributes,
    STATE(3892), 1,
      aux_sym__atoms,
    STATE(6084), 1,
      sym__qid,
    STATE(6427), 1,
      sym_atom,
    STATE(8123), 1,
      sym__LAMBDA,
    STATE(8396), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3086), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6715), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6714), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3062), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9844), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [324081] = 34,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(878), 1,
      anon_sym_quoteGoal,
    ACTIONS(886), 1,
      anon_sym_let,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(3978), 1,
      anon_sym_u2984,
    ACTIONS(4182), 1,
      sym_id,
    ACTIONS(4184), 1,
      anon_sym_BSLASH,
    ACTIONS(4186), 1,
      anon_sym_u03bb,
    ACTIONS(4190), 1,
      anon_sym_record,
    ACTIONS(4192), 1,
      anon_sym_LPAREN,
    ACTIONS(4194), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4196), 1,
      anon_sym_u2983,
    ACTIONS(4198), 1,
      anon_sym_LBRACE,
    ACTIONS(4200), 1,
      aux_sym__qid_token1,
    ACTIONS(4202), 1,
      anon_sym_DOT,
    ACTIONS(4204), 1,
      anon_sym_tactic,
    ACTIONS(4206), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4208), 1,
      anon_sym_u2987,
    ACTIONS(4212), 1,
      anon_sym_Set,
    STATE(3398), 1,
      sym_attributes,
    STATE(3888), 1,
      aux_sym__atoms,
    STATE(6121), 1,
      sym__qid,
    STATE(6386), 1,
      sym_atom,
    STATE(8067), 1,
      sym__LAMBDA,
    STATE(8369), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(852), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4210), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6575), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6565), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(4188), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9901), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [324210] = 34,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(878), 1,
      anon_sym_quoteGoal,
    ACTIONS(886), 1,
      anon_sym_let,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(3978), 1,
      anon_sym_u2984,
    ACTIONS(4182), 1,
      sym_id,
    ACTIONS(4184), 1,
      anon_sym_BSLASH,
    ACTIONS(4186), 1,
      anon_sym_u03bb,
    ACTIONS(4190), 1,
      anon_sym_record,
    ACTIONS(4192), 1,
      anon_sym_LPAREN,
    ACTIONS(4194), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4196), 1,
      anon_sym_u2983,
    ACTIONS(4198), 1,
      anon_sym_LBRACE,
    ACTIONS(4200), 1,
      aux_sym__qid_token1,
    ACTIONS(4202), 1,
      anon_sym_DOT,
    ACTIONS(4204), 1,
      anon_sym_tactic,
    ACTIONS(4206), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4208), 1,
      anon_sym_u2987,
    ACTIONS(4212), 1,
      anon_sym_Set,
    STATE(3620), 1,
      sym_attributes,
    STATE(3888), 1,
      aux_sym__atoms,
    STATE(6121), 1,
      sym__qid,
    STATE(6386), 1,
      sym_atom,
    STATE(8067), 1,
      sym__LAMBDA,
    STATE(8369), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(852), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4210), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6575), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6565), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(4188), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9842), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [324339] = 34,
    ACTIONS(710), 1,
      anon_sym_DASH,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(920), 1,
      anon_sym_quoteGoal,
    ACTIONS(928), 1,
      anon_sym_let,
    ACTIONS(3058), 1,
      anon_sym_BSLASH,
    ACTIONS(3060), 1,
      anon_sym_u03bb,
    ACTIONS(3064), 1,
      anon_sym_record,
    ACTIONS(3066), 1,
      anon_sym_LPAREN,
    ACTIONS(3068), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3070), 1,
      anon_sym_u2983,
    ACTIONS(3072), 1,
      anon_sym_LBRACE,
    ACTIONS(3076), 1,
      aux_sym__qid_token1,
    ACTIONS(3078), 1,
      anon_sym_DOT,
    ACTIONS(3080), 1,
      anon_sym_tactic,
    ACTIONS(3082), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3084), 1,
      anon_sym_u2987,
    ACTIONS(3088), 1,
      anon_sym_Set,
    ACTIONS(3978), 1,
      anon_sym_RBRACE,
    ACTIONS(4220), 1,
      sym_id,
    STATE(3370), 1,
      sym_attributes,
    STATE(3892), 1,
      aux_sym__atoms,
    STATE(6084), 1,
      sym__qid,
    STATE(6427), 1,
      sym_atom,
    STATE(8123), 1,
      sym__LAMBDA,
    STATE(8396), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3086), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6715), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6714), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3062), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9775), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [324468] = 34,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(964), 1,
      anon_sym_quoteGoal,
    ACTIONS(972), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3978), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4214), 1,
      anon_sym_BSLASH,
    ACTIONS(4216), 1,
      anon_sym_u03bb,
    ACTIONS(4218), 1,
      anon_sym_tactic,
    STATE(3529), 1,
      sym_attributes,
    STATE(3891), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8047), 1,
      sym__LAMBDA,
    STATE(8355), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(942), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10029), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [324597] = 34,
    ACTIONS(710), 1,
      anon_sym_DASH,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(920), 1,
      anon_sym_quoteGoal,
    ACTIONS(928), 1,
      anon_sym_let,
    ACTIONS(3058), 1,
      anon_sym_BSLASH,
    ACTIONS(3060), 1,
      anon_sym_u03bb,
    ACTIONS(3064), 1,
      anon_sym_record,
    ACTIONS(3066), 1,
      anon_sym_LPAREN,
    ACTIONS(3068), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3070), 1,
      anon_sym_u2983,
    ACTIONS(3072), 1,
      anon_sym_LBRACE,
    ACTIONS(3076), 1,
      aux_sym__qid_token1,
    ACTIONS(3078), 1,
      anon_sym_DOT,
    ACTIONS(3080), 1,
      anon_sym_tactic,
    ACTIONS(3082), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3084), 1,
      anon_sym_u2987,
    ACTIONS(3088), 1,
      anon_sym_Set,
    ACTIONS(4078), 1,
      anon_sym_RBRACE,
    ACTIONS(4220), 1,
      sym_id,
    STATE(3466), 1,
      sym_attributes,
    STATE(3892), 1,
      aux_sym__atoms,
    STATE(6084), 1,
      sym__qid,
    STATE(6427), 1,
      sym_atom,
    STATE(8123), 1,
      sym__LAMBDA,
    STATE(8396), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3086), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6715), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6714), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3062), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9944), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [324726] = 34,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(964), 1,
      anon_sym_quoteGoal,
    ACTIONS(972), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4078), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(4214), 1,
      anon_sym_BSLASH,
    ACTIONS(4216), 1,
      anon_sym_u03bb,
    ACTIONS(4218), 1,
      anon_sym_tactic,
    STATE(3647), 1,
      sym_attributes,
    STATE(3891), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8047), 1,
      sym__LAMBDA,
    STATE(8355), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(942), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9717), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [324855] = 34,
    ACTIONS(704), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(964), 1,
      anon_sym_quoteGoal,
    ACTIONS(972), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4214), 1,
      anon_sym_BSLASH,
    ACTIONS(4216), 1,
      anon_sym_u03bb,
    ACTIONS(4218), 1,
      anon_sym_tactic,
    STATE(3535), 1,
      sym_attributes,
    STATE(3891), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8047), 1,
      sym__LAMBDA,
    STATE(8355), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(942), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10207), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [324984] = 34,
    ACTIONS(704), 1,
      anon_sym_u2984,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(878), 1,
      anon_sym_quoteGoal,
    ACTIONS(886), 1,
      anon_sym_let,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(4182), 1,
      sym_id,
    ACTIONS(4184), 1,
      anon_sym_BSLASH,
    ACTIONS(4186), 1,
      anon_sym_u03bb,
    ACTIONS(4190), 1,
      anon_sym_record,
    ACTIONS(4192), 1,
      anon_sym_LPAREN,
    ACTIONS(4194), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4196), 1,
      anon_sym_u2983,
    ACTIONS(4198), 1,
      anon_sym_LBRACE,
    ACTIONS(4200), 1,
      aux_sym__qid_token1,
    ACTIONS(4202), 1,
      anon_sym_DOT,
    ACTIONS(4204), 1,
      anon_sym_tactic,
    ACTIONS(4206), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4208), 1,
      anon_sym_u2987,
    ACTIONS(4212), 1,
      anon_sym_Set,
    STATE(3519), 1,
      sym_attributes,
    STATE(3888), 1,
      aux_sym__atoms,
    STATE(6121), 1,
      sym__qid,
    STATE(6386), 1,
      sym_atom,
    STATE(8067), 1,
      sym__LAMBDA,
    STATE(8369), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(852), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4210), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6575), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6565), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(4188), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10208), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [325113] = 34,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(964), 1,
      anon_sym_quoteGoal,
    ACTIONS(972), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3978), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4214), 1,
      anon_sym_BSLASH,
    ACTIONS(4216), 1,
      anon_sym_u03bb,
    ACTIONS(4218), 1,
      anon_sym_tactic,
    STATE(3619), 1,
      sym_attributes,
    STATE(3891), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8047), 1,
      sym__LAMBDA,
    STATE(8355), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(942), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9840), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [325242] = 34,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(878), 1,
      anon_sym_quoteGoal,
    ACTIONS(886), 1,
      anon_sym_let,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(4078), 1,
      anon_sym_u2984,
    ACTIONS(4182), 1,
      sym_id,
    ACTIONS(4184), 1,
      anon_sym_BSLASH,
    ACTIONS(4186), 1,
      anon_sym_u03bb,
    ACTIONS(4190), 1,
      anon_sym_record,
    ACTIONS(4192), 1,
      anon_sym_LPAREN,
    ACTIONS(4194), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4196), 1,
      anon_sym_u2983,
    ACTIONS(4198), 1,
      anon_sym_LBRACE,
    ACTIONS(4200), 1,
      aux_sym__qid_token1,
    ACTIONS(4202), 1,
      anon_sym_DOT,
    ACTIONS(4204), 1,
      anon_sym_tactic,
    ACTIONS(4206), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4208), 1,
      anon_sym_u2987,
    ACTIONS(4212), 1,
      anon_sym_Set,
    STATE(3465), 1,
      sym_attributes,
    STATE(3888), 1,
      aux_sym__atoms,
    STATE(6121), 1,
      sym__qid,
    STATE(6386), 1,
      sym_atom,
    STATE(8067), 1,
      sym__LAMBDA,
    STATE(8369), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(852), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4210), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6575), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6565), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(4188), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9946), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [325371] = 34,
    ACTIONS(704), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(964), 1,
      anon_sym_quoteGoal,
    ACTIONS(972), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4214), 1,
      anon_sym_BSLASH,
    ACTIONS(4216), 1,
      anon_sym_u03bb,
    ACTIONS(4218), 1,
      anon_sym_tactic,
    STATE(3649), 1,
      sym_attributes,
    STATE(3891), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8047), 1,
      sym__LAMBDA,
    STATE(8355), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(942), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9727), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [325500] = 34,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(732), 1,
      anon_sym_u2984,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(878), 1,
      anon_sym_quoteGoal,
    ACTIONS(886), 1,
      anon_sym_let,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(4182), 1,
      sym_id,
    ACTIONS(4184), 1,
      anon_sym_BSLASH,
    ACTIONS(4186), 1,
      anon_sym_u03bb,
    ACTIONS(4190), 1,
      anon_sym_record,
    ACTIONS(4192), 1,
      anon_sym_LPAREN,
    ACTIONS(4194), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4196), 1,
      anon_sym_u2983,
    ACTIONS(4198), 1,
      anon_sym_LBRACE,
    ACTIONS(4200), 1,
      aux_sym__qid_token1,
    ACTIONS(4202), 1,
      anon_sym_DOT,
    ACTIONS(4204), 1,
      anon_sym_tactic,
    ACTIONS(4206), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4208), 1,
      anon_sym_u2987,
    ACTIONS(4212), 1,
      anon_sym_Set,
    STATE(3491), 1,
      sym_attributes,
    STATE(3888), 1,
      aux_sym__atoms,
    STATE(6121), 1,
      sym__qid,
    STATE(6386), 1,
      sym_atom,
    STATE(8067), 1,
      sym__LAMBDA,
    STATE(8369), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(852), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4210), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6575), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6565), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(4188), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9968), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [325629] = 34,
    ACTIONS(710), 1,
      anon_sym_DASH,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(920), 1,
      anon_sym_quoteGoal,
    ACTIONS(928), 1,
      anon_sym_let,
    ACTIONS(3058), 1,
      anon_sym_BSLASH,
    ACTIONS(3060), 1,
      anon_sym_u03bb,
    ACTIONS(3064), 1,
      anon_sym_record,
    ACTIONS(3066), 1,
      anon_sym_LPAREN,
    ACTIONS(3068), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3070), 1,
      anon_sym_u2983,
    ACTIONS(3072), 1,
      anon_sym_LBRACE,
    ACTIONS(3076), 1,
      aux_sym__qid_token1,
    ACTIONS(3078), 1,
      anon_sym_DOT,
    ACTIONS(3080), 1,
      anon_sym_tactic,
    ACTIONS(3082), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3084), 1,
      anon_sym_u2987,
    ACTIONS(3088), 1,
      anon_sym_Set,
    ACTIONS(3978), 1,
      anon_sym_RBRACE,
    ACTIONS(4220), 1,
      sym_id,
    STATE(3414), 1,
      sym_attributes,
    STATE(3892), 1,
      aux_sym__atoms,
    STATE(6084), 1,
      sym__qid,
    STATE(6427), 1,
      sym_atom,
    STATE(8123), 1,
      sym__LAMBDA,
    STATE(8396), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3086), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6715), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6714), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3062), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9917), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [325758] = 34,
    ACTIONS(704), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(964), 1,
      anon_sym_quoteGoal,
    ACTIONS(972), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4214), 1,
      anon_sym_BSLASH,
    ACTIONS(4216), 1,
      anon_sym_u03bb,
    ACTIONS(4218), 1,
      anon_sym_tactic,
    STATE(3694), 1,
      sym_attributes,
    STATE(3891), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8047), 1,
      sym__LAMBDA,
    STATE(8355), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(942), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9704), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [325887] = 34,
    ACTIONS(704), 1,
      anon_sym_u2984,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(878), 1,
      anon_sym_quoteGoal,
    ACTIONS(886), 1,
      anon_sym_let,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(4182), 1,
      sym_id,
    ACTIONS(4184), 1,
      anon_sym_BSLASH,
    ACTIONS(4186), 1,
      anon_sym_u03bb,
    ACTIONS(4190), 1,
      anon_sym_record,
    ACTIONS(4192), 1,
      anon_sym_LPAREN,
    ACTIONS(4194), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4196), 1,
      anon_sym_u2983,
    ACTIONS(4198), 1,
      anon_sym_LBRACE,
    ACTIONS(4200), 1,
      aux_sym__qid_token1,
    ACTIONS(4202), 1,
      anon_sym_DOT,
    ACTIONS(4204), 1,
      anon_sym_tactic,
    ACTIONS(4206), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4208), 1,
      anon_sym_u2987,
    ACTIONS(4212), 1,
      anon_sym_Set,
    STATE(3695), 1,
      sym_attributes,
    STATE(3888), 1,
      aux_sym__atoms,
    STATE(6121), 1,
      sym__qid,
    STATE(6386), 1,
      sym_atom,
    STATE(8067), 1,
      sym__LAMBDA,
    STATE(8369), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(852), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4210), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6575), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6565), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(4188), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9705), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [326016] = 34,
    ACTIONS(704), 1,
      anon_sym_u2984,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(878), 1,
      anon_sym_quoteGoal,
    ACTIONS(886), 1,
      anon_sym_let,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(4182), 1,
      sym_id,
    ACTIONS(4184), 1,
      anon_sym_BSLASH,
    ACTIONS(4186), 1,
      anon_sym_u03bb,
    ACTIONS(4190), 1,
      anon_sym_record,
    ACTIONS(4192), 1,
      anon_sym_LPAREN,
    ACTIONS(4194), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4196), 1,
      anon_sym_u2983,
    ACTIONS(4198), 1,
      anon_sym_LBRACE,
    ACTIONS(4200), 1,
      aux_sym__qid_token1,
    ACTIONS(4202), 1,
      anon_sym_DOT,
    ACTIONS(4204), 1,
      anon_sym_tactic,
    ACTIONS(4206), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4208), 1,
      anon_sym_u2987,
    ACTIONS(4212), 1,
      anon_sym_Set,
    STATE(3532), 1,
      sym_attributes,
    STATE(3888), 1,
      aux_sym__atoms,
    STATE(6121), 1,
      sym__qid,
    STATE(6386), 1,
      sym_atom,
    STATE(8067), 1,
      sym__LAMBDA,
    STATE(8369), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(852), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4210), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6575), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6565), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(4188), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10028), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [326145] = 34,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(732), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(964), 1,
      anon_sym_quoteGoal,
    ACTIONS(972), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4214), 1,
      anon_sym_BSLASH,
    ACTIONS(4216), 1,
      anon_sym_u03bb,
    ACTIONS(4218), 1,
      anon_sym_tactic,
    STATE(3492), 1,
      sym_attributes,
    STATE(3891), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8047), 1,
      sym__LAMBDA,
    STATE(8355), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(942), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9970), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [326274] = 34,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(964), 1,
      anon_sym_quoteGoal,
    ACTIONS(972), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4092), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(4214), 1,
      anon_sym_BSLASH,
    ACTIONS(4216), 1,
      anon_sym_u03bb,
    ACTIONS(4218), 1,
      anon_sym_tactic,
    STATE(3601), 1,
      sym_attributes,
    STATE(3891), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8047), 1,
      sym__LAMBDA,
    STATE(8355), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(942), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9847), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [326403] = 34,
    ACTIONS(704), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(964), 1,
      anon_sym_quoteGoal,
    ACTIONS(972), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4214), 1,
      anon_sym_BSLASH,
    ACTIONS(4216), 1,
      anon_sym_u03bb,
    ACTIONS(4218), 1,
      anon_sym_tactic,
    STATE(3529), 1,
      sym_attributes,
    STATE(3891), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8047), 1,
      sym__LAMBDA,
    STATE(8355), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(942), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10029), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [326532] = 34,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(878), 1,
      anon_sym_quoteGoal,
    ACTIONS(886), 1,
      anon_sym_let,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(4092), 1,
      anon_sym_u2984,
    ACTIONS(4182), 1,
      sym_id,
    ACTIONS(4184), 1,
      anon_sym_BSLASH,
    ACTIONS(4186), 1,
      anon_sym_u03bb,
    ACTIONS(4190), 1,
      anon_sym_record,
    ACTIONS(4192), 1,
      anon_sym_LPAREN,
    ACTIONS(4194), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4196), 1,
      anon_sym_u2983,
    ACTIONS(4198), 1,
      anon_sym_LBRACE,
    ACTIONS(4200), 1,
      aux_sym__qid_token1,
    ACTIONS(4202), 1,
      anon_sym_DOT,
    ACTIONS(4204), 1,
      anon_sym_tactic,
    ACTIONS(4206), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4208), 1,
      anon_sym_u2987,
    ACTIONS(4212), 1,
      anon_sym_Set,
    STATE(3604), 1,
      sym_attributes,
    STATE(3888), 1,
      aux_sym__atoms,
    STATE(6121), 1,
      sym__qid,
    STATE(6386), 1,
      sym_atom,
    STATE(8067), 1,
      sym__LAMBDA,
    STATE(8369), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(852), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4210), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6575), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6565), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(4188), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9920), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [326661] = 34,
    ACTIONS(710), 1,
      anon_sym_DASH,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(920), 1,
      anon_sym_quoteGoal,
    ACTIONS(928), 1,
      anon_sym_let,
    ACTIONS(3058), 1,
      anon_sym_BSLASH,
    ACTIONS(3060), 1,
      anon_sym_u03bb,
    ACTIONS(3064), 1,
      anon_sym_record,
    ACTIONS(3066), 1,
      anon_sym_LPAREN,
    ACTIONS(3068), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3070), 1,
      anon_sym_u2983,
    ACTIONS(3072), 1,
      anon_sym_LBRACE,
    ACTIONS(3076), 1,
      aux_sym__qid_token1,
    ACTIONS(3078), 1,
      anon_sym_DOT,
    ACTIONS(3080), 1,
      anon_sym_tactic,
    ACTIONS(3082), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3084), 1,
      anon_sym_u2987,
    ACTIONS(3088), 1,
      anon_sym_Set,
    ACTIONS(4092), 1,
      anon_sym_RBRACE,
    ACTIONS(4220), 1,
      sym_id,
    STATE(3607), 1,
      sym_attributes,
    STATE(3892), 1,
      aux_sym__atoms,
    STATE(6084), 1,
      sym__qid,
    STATE(6427), 1,
      sym_atom,
    STATE(8123), 1,
      sym__LAMBDA,
    STATE(8396), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3086), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6715), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6714), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3062), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9919), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [326790] = 34,
    ACTIONS(704), 1,
      anon_sym_u2984,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(878), 1,
      anon_sym_quoteGoal,
    ACTIONS(886), 1,
      anon_sym_let,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(4182), 1,
      sym_id,
    ACTIONS(4184), 1,
      anon_sym_BSLASH,
    ACTIONS(4186), 1,
      anon_sym_u03bb,
    ACTIONS(4190), 1,
      anon_sym_record,
    ACTIONS(4192), 1,
      anon_sym_LPAREN,
    ACTIONS(4194), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4196), 1,
      anon_sym_u2983,
    ACTIONS(4198), 1,
      anon_sym_LBRACE,
    ACTIONS(4200), 1,
      aux_sym__qid_token1,
    ACTIONS(4202), 1,
      anon_sym_DOT,
    ACTIONS(4204), 1,
      anon_sym_tactic,
    ACTIONS(4206), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4208), 1,
      anon_sym_u2987,
    ACTIONS(4212), 1,
      anon_sym_Set,
    STATE(3704), 1,
      sym_attributes,
    STATE(3888), 1,
      aux_sym__atoms,
    STATE(6121), 1,
      sym__qid,
    STATE(6386), 1,
      sym_atom,
    STATE(8067), 1,
      sym__LAMBDA,
    STATE(8369), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(852), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4210), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6575), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6565), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(4188), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10164), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [326919] = 34,
    ACTIONS(704), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(964), 1,
      anon_sym_quoteGoal,
    ACTIONS(972), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4214), 1,
      anon_sym_BSLASH,
    ACTIONS(4216), 1,
      anon_sym_u03bb,
    ACTIONS(4218), 1,
      anon_sym_tactic,
    STATE(3698), 1,
      sym_attributes,
    STATE(3891), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8047), 1,
      sym__LAMBDA,
    STATE(8355), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(942), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10163), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [327048] = 34,
    ACTIONS(710), 1,
      anon_sym_DASH,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(920), 1,
      anon_sym_quoteGoal,
    ACTIONS(928), 1,
      anon_sym_let,
    ACTIONS(3058), 1,
      anon_sym_BSLASH,
    ACTIONS(3060), 1,
      anon_sym_u03bb,
    ACTIONS(3064), 1,
      anon_sym_record,
    ACTIONS(3066), 1,
      anon_sym_LPAREN,
    ACTIONS(3068), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3070), 1,
      anon_sym_u2983,
    ACTIONS(3072), 1,
      anon_sym_LBRACE,
    ACTIONS(3076), 1,
      aux_sym__qid_token1,
    ACTIONS(3078), 1,
      anon_sym_DOT,
    ACTIONS(3080), 1,
      anon_sym_tactic,
    ACTIONS(3082), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3084), 1,
      anon_sym_u2987,
    ACTIONS(3088), 1,
      anon_sym_Set,
    ACTIONS(4078), 1,
      anon_sym_RBRACE,
    ACTIONS(4220), 1,
      sym_id,
    STATE(3643), 1,
      sym_attributes,
    STATE(3892), 1,
      aux_sym__atoms,
    STATE(6084), 1,
      sym__qid,
    STATE(6427), 1,
      sym_atom,
    STATE(8123), 1,
      sym__LAMBDA,
    STATE(8396), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3086), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6715), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6714), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3062), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9719), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [327177] = 34,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(964), 1,
      anon_sym_quoteGoal,
    ACTIONS(972), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4078), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(4214), 1,
      anon_sym_BSLASH,
    ACTIONS(4216), 1,
      anon_sym_u03bb,
    ACTIONS(4218), 1,
      anon_sym_tactic,
    STATE(3360), 1,
      sym_attributes,
    STATE(3891), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8047), 1,
      sym__LAMBDA,
    STATE(8355), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(942), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10111), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [327306] = 34,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(878), 1,
      anon_sym_quoteGoal,
    ACTIONS(886), 1,
      anon_sym_let,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(4078), 1,
      anon_sym_u2984,
    ACTIONS(4182), 1,
      sym_id,
    ACTIONS(4184), 1,
      anon_sym_BSLASH,
    ACTIONS(4186), 1,
      anon_sym_u03bb,
    ACTIONS(4190), 1,
      anon_sym_record,
    ACTIONS(4192), 1,
      anon_sym_LPAREN,
    ACTIONS(4194), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4196), 1,
      anon_sym_u2983,
    ACTIONS(4198), 1,
      anon_sym_LBRACE,
    ACTIONS(4200), 1,
      aux_sym__qid_token1,
    ACTIONS(4202), 1,
      anon_sym_DOT,
    ACTIONS(4204), 1,
      anon_sym_tactic,
    ACTIONS(4206), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4208), 1,
      anon_sym_u2987,
    ACTIONS(4212), 1,
      anon_sym_Set,
    STATE(3362), 1,
      sym_attributes,
    STATE(3888), 1,
      aux_sym__atoms,
    STATE(6121), 1,
      sym__qid,
    STATE(6386), 1,
      sym_atom,
    STATE(8067), 1,
      sym__LAMBDA,
    STATE(8369), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(852), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4210), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6575), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6565), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(4188), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10110), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [327435] = 34,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(964), 1,
      anon_sym_quoteGoal,
    ACTIONS(972), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3978), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4214), 1,
      anon_sym_BSLASH,
    ACTIONS(4216), 1,
      anon_sym_u03bb,
    ACTIONS(4218), 1,
      anon_sym_tactic,
    STATE(3694), 1,
      sym_attributes,
    STATE(3891), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8047), 1,
      sym__LAMBDA,
    STATE(8355), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(942), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9704), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [327564] = 34,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(878), 1,
      anon_sym_quoteGoal,
    ACTIONS(886), 1,
      anon_sym_let,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(3978), 1,
      anon_sym_u2984,
    ACTIONS(4182), 1,
      sym_id,
    ACTIONS(4184), 1,
      anon_sym_BSLASH,
    ACTIONS(4186), 1,
      anon_sym_u03bb,
    ACTIONS(4190), 1,
      anon_sym_record,
    ACTIONS(4192), 1,
      anon_sym_LPAREN,
    ACTIONS(4194), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4196), 1,
      anon_sym_u2983,
    ACTIONS(4198), 1,
      anon_sym_LBRACE,
    ACTIONS(4200), 1,
      aux_sym__qid_token1,
    ACTIONS(4202), 1,
      anon_sym_DOT,
    ACTIONS(4204), 1,
      anon_sym_tactic,
    ACTIONS(4206), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4208), 1,
      anon_sym_u2987,
    ACTIONS(4212), 1,
      anon_sym_Set,
    STATE(3695), 1,
      sym_attributes,
    STATE(3888), 1,
      aux_sym__atoms,
    STATE(6121), 1,
      sym__qid,
    STATE(6386), 1,
      sym_atom,
    STATE(8067), 1,
      sym__LAMBDA,
    STATE(8369), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(852), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4210), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6575), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6565), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(4188), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9705), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [327693] = 34,
    ACTIONS(710), 1,
      anon_sym_DASH,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(920), 1,
      anon_sym_quoteGoal,
    ACTIONS(928), 1,
      anon_sym_let,
    ACTIONS(3058), 1,
      anon_sym_BSLASH,
    ACTIONS(3060), 1,
      anon_sym_u03bb,
    ACTIONS(3064), 1,
      anon_sym_record,
    ACTIONS(3066), 1,
      anon_sym_LPAREN,
    ACTIONS(3068), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3070), 1,
      anon_sym_u2983,
    ACTIONS(3072), 1,
      anon_sym_LBRACE,
    ACTIONS(3076), 1,
      aux_sym__qid_token1,
    ACTIONS(3078), 1,
      anon_sym_DOT,
    ACTIONS(3080), 1,
      anon_sym_tactic,
    ACTIONS(3082), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3084), 1,
      anon_sym_u2987,
    ACTIONS(3088), 1,
      anon_sym_Set,
    ACTIONS(4078), 1,
      anon_sym_RBRACE,
    ACTIONS(4220), 1,
      sym_id,
    STATE(3368), 1,
      sym_attributes,
    STATE(3892), 1,
      aux_sym__atoms,
    STATE(6084), 1,
      sym__qid,
    STATE(6427), 1,
      sym_atom,
    STATE(8123), 1,
      sym__LAMBDA,
    STATE(8396), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3086), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6715), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6714), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3062), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10109), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [327822] = 34,
    ACTIONS(710), 1,
      anon_sym_DASH,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(920), 1,
      anon_sym_quoteGoal,
    ACTIONS(928), 1,
      anon_sym_let,
    ACTIONS(3058), 1,
      anon_sym_BSLASH,
    ACTIONS(3060), 1,
      anon_sym_u03bb,
    ACTIONS(3064), 1,
      anon_sym_record,
    ACTIONS(3066), 1,
      anon_sym_LPAREN,
    ACTIONS(3068), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3070), 1,
      anon_sym_u2983,
    ACTIONS(3072), 1,
      anon_sym_LBRACE,
    ACTIONS(3076), 1,
      aux_sym__qid_token1,
    ACTIONS(3078), 1,
      anon_sym_DOT,
    ACTIONS(3080), 1,
      anon_sym_tactic,
    ACTIONS(3082), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3084), 1,
      anon_sym_u2987,
    ACTIONS(3088), 1,
      anon_sym_Set,
    ACTIONS(3978), 1,
      anon_sym_RBRACE,
    ACTIONS(4220), 1,
      sym_id,
    STATE(3696), 1,
      sym_attributes,
    STATE(3892), 1,
      aux_sym__atoms,
    STATE(6084), 1,
      sym__qid,
    STATE(6427), 1,
      sym_atom,
    STATE(8123), 1,
      sym__LAMBDA,
    STATE(8396), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3086), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6715), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6714), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3062), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9706), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [327951] = 34,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(964), 1,
      anon_sym_quoteGoal,
    ACTIONS(972), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4078), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(4214), 1,
      anon_sym_BSLASH,
    ACTIONS(4216), 1,
      anon_sym_u03bb,
    ACTIONS(4218), 1,
      anon_sym_tactic,
    STATE(3461), 1,
      sym_attributes,
    STATE(3891), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8047), 1,
      sym__LAMBDA,
    STATE(8355), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(942), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9947), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [328080] = 34,
    ACTIONS(710), 1,
      anon_sym_DASH,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(920), 1,
      anon_sym_quoteGoal,
    ACTIONS(928), 1,
      anon_sym_let,
    ACTIONS(3058), 1,
      anon_sym_BSLASH,
    ACTIONS(3060), 1,
      anon_sym_u03bb,
    ACTIONS(3064), 1,
      anon_sym_record,
    ACTIONS(3066), 1,
      anon_sym_LPAREN,
    ACTIONS(3068), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3070), 1,
      anon_sym_u2983,
    ACTIONS(3072), 1,
      anon_sym_LBRACE,
    ACTIONS(3076), 1,
      aux_sym__qid_token1,
    ACTIONS(3078), 1,
      anon_sym_DOT,
    ACTIONS(3080), 1,
      anon_sym_tactic,
    ACTIONS(3082), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3084), 1,
      anon_sym_u2987,
    ACTIONS(3088), 1,
      anon_sym_Set,
    ACTIONS(4078), 1,
      anon_sym_RBRACE,
    ACTIONS(4220), 1,
      sym_id,
    STATE(3358), 1,
      sym_attributes,
    STATE(3892), 1,
      aux_sym__atoms,
    STATE(6084), 1,
      sym__qid,
    STATE(6427), 1,
      sym_atom,
    STATE(8123), 1,
      sym__LAMBDA,
    STATE(8396), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3086), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6715), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6714), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3062), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10057), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [328209] = 34,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(732), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(964), 1,
      anon_sym_quoteGoal,
    ACTIONS(972), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4214), 1,
      anon_sym_BSLASH,
    ACTIONS(4216), 1,
      anon_sym_u03bb,
    ACTIONS(4218), 1,
      anon_sym_tactic,
    STATE(3577), 1,
      sym_attributes,
    STATE(3891), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8047), 1,
      sym__LAMBDA,
    STATE(8355), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(942), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10187), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [328338] = 34,
    ACTIONS(704), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(964), 1,
      anon_sym_quoteGoal,
    ACTIONS(972), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4214), 1,
      anon_sym_BSLASH,
    ACTIONS(4216), 1,
      anon_sym_u03bb,
    ACTIONS(4218), 1,
      anon_sym_tactic,
    STATE(3422), 1,
      sym_attributes,
    STATE(3891), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8047), 1,
      sym__LAMBDA,
    STATE(8355), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(942), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9923), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [328467] = 34,
    ACTIONS(704), 1,
      anon_sym_u2984,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(878), 1,
      anon_sym_quoteGoal,
    ACTIONS(886), 1,
      anon_sym_let,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(4182), 1,
      sym_id,
    ACTIONS(4184), 1,
      anon_sym_BSLASH,
    ACTIONS(4186), 1,
      anon_sym_u03bb,
    ACTIONS(4190), 1,
      anon_sym_record,
    ACTIONS(4192), 1,
      anon_sym_LPAREN,
    ACTIONS(4194), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4196), 1,
      anon_sym_u2983,
    ACTIONS(4198), 1,
      anon_sym_LBRACE,
    ACTIONS(4200), 1,
      aux_sym__qid_token1,
    ACTIONS(4202), 1,
      anon_sym_DOT,
    ACTIONS(4204), 1,
      anon_sym_tactic,
    ACTIONS(4206), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4208), 1,
      anon_sym_u2987,
    ACTIONS(4212), 1,
      anon_sym_Set,
    STATE(3415), 1,
      sym_attributes,
    STATE(3888), 1,
      aux_sym__atoms,
    STATE(6121), 1,
      sym__qid,
    STATE(6386), 1,
      sym_atom,
    STATE(8067), 1,
      sym__LAMBDA,
    STATE(8369), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(852), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4210), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6575), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6565), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(4188), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9922), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [328596] = 34,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(732), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(964), 1,
      anon_sym_quoteGoal,
    ACTIONS(972), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4214), 1,
      anon_sym_BSLASH,
    ACTIONS(4216), 1,
      anon_sym_u03bb,
    ACTIONS(4218), 1,
      anon_sym_tactic,
    STATE(3659), 1,
      sym_attributes,
    STATE(3891), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8047), 1,
      sym__LAMBDA,
    STATE(8355), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(942), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9883), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [328725] = 34,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(878), 1,
      anon_sym_quoteGoal,
    ACTIONS(886), 1,
      anon_sym_let,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(4078), 1,
      anon_sym_u2984,
    ACTIONS(4182), 1,
      sym_id,
    ACTIONS(4184), 1,
      anon_sym_BSLASH,
    ACTIONS(4186), 1,
      anon_sym_u03bb,
    ACTIONS(4190), 1,
      anon_sym_record,
    ACTIONS(4192), 1,
      anon_sym_LPAREN,
    ACTIONS(4194), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4196), 1,
      anon_sym_u2983,
    ACTIONS(4198), 1,
      anon_sym_LBRACE,
    ACTIONS(4200), 1,
      aux_sym__qid_token1,
    ACTIONS(4202), 1,
      anon_sym_DOT,
    ACTIONS(4204), 1,
      anon_sym_tactic,
    ACTIONS(4206), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4208), 1,
      anon_sym_u2987,
    ACTIONS(4212), 1,
      anon_sym_Set,
    STATE(3630), 1,
      sym_attributes,
    STATE(3888), 1,
      aux_sym__atoms,
    STATE(6121), 1,
      sym__qid,
    STATE(6386), 1,
      sym_atom,
    STATE(8067), 1,
      sym__LAMBDA,
    STATE(8369), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(852), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4210), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6575), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6565), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(4188), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10056), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [328854] = 34,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(732), 1,
      anon_sym_u2984,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(878), 1,
      anon_sym_quoteGoal,
    ACTIONS(886), 1,
      anon_sym_let,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(4182), 1,
      sym_id,
    ACTIONS(4184), 1,
      anon_sym_BSLASH,
    ACTIONS(4186), 1,
      anon_sym_u03bb,
    ACTIONS(4190), 1,
      anon_sym_record,
    ACTIONS(4192), 1,
      anon_sym_LPAREN,
    ACTIONS(4194), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4196), 1,
      anon_sym_u2983,
    ACTIONS(4198), 1,
      anon_sym_LBRACE,
    ACTIONS(4200), 1,
      aux_sym__qid_token1,
    ACTIONS(4202), 1,
      anon_sym_DOT,
    ACTIONS(4204), 1,
      anon_sym_tactic,
    ACTIONS(4206), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4208), 1,
      anon_sym_u2987,
    ACTIONS(4212), 1,
      anon_sym_Set,
    STATE(3574), 1,
      sym_attributes,
    STATE(3888), 1,
      aux_sym__atoms,
    STATE(6121), 1,
      sym__qid,
    STATE(6386), 1,
      sym_atom,
    STATE(8067), 1,
      sym__LAMBDA,
    STATE(8369), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(852), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4210), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6575), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6565), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(4188), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10186), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [328983] = 34,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(964), 1,
      anon_sym_quoteGoal,
    ACTIONS(972), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4078), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(4214), 1,
      anon_sym_BSLASH,
    ACTIONS(4216), 1,
      anon_sym_u03bb,
    ACTIONS(4218), 1,
      anon_sym_tactic,
    STATE(3373), 1,
      sym_attributes,
    STATE(3891), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8047), 1,
      sym__LAMBDA,
    STATE(8355), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(942), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10055), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [329112] = 34,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(732), 1,
      anon_sym_u2984,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(878), 1,
      anon_sym_quoteGoal,
    ACTIONS(886), 1,
      anon_sym_let,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(4182), 1,
      sym_id,
    ACTIONS(4184), 1,
      anon_sym_BSLASH,
    ACTIONS(4186), 1,
      anon_sym_u03bb,
    ACTIONS(4190), 1,
      anon_sym_record,
    ACTIONS(4192), 1,
      anon_sym_LPAREN,
    ACTIONS(4194), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4196), 1,
      anon_sym_u2983,
    ACTIONS(4198), 1,
      anon_sym_LBRACE,
    ACTIONS(4200), 1,
      aux_sym__qid_token1,
    ACTIONS(4202), 1,
      anon_sym_DOT,
    ACTIONS(4204), 1,
      anon_sym_tactic,
    ACTIONS(4206), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4208), 1,
      anon_sym_u2987,
    ACTIONS(4212), 1,
      anon_sym_Set,
    STATE(3641), 1,
      sym_attributes,
    STATE(3888), 1,
      aux_sym__atoms,
    STATE(6121), 1,
      sym__qid,
    STATE(6386), 1,
      sym_atom,
    STATE(8067), 1,
      sym__LAMBDA,
    STATE(8369), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(852), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4210), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6575), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6565), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(4188), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9880), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [329241] = 34,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(964), 1,
      anon_sym_quoteGoal,
    ACTIONS(972), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3978), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4214), 1,
      anon_sym_BSLASH,
    ACTIONS(4216), 1,
      anon_sym_u03bb,
    ACTIONS(4218), 1,
      anon_sym_tactic,
    STATE(3422), 1,
      sym_attributes,
    STATE(3891), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8047), 1,
      sym__LAMBDA,
    STATE(8355), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(942), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9923), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [329370] = 34,
    ACTIONS(704), 1,
      anon_sym_u2984,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(878), 1,
      anon_sym_quoteGoal,
    ACTIONS(886), 1,
      anon_sym_let,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(4182), 1,
      sym_id,
    ACTIONS(4184), 1,
      anon_sym_BSLASH,
    ACTIONS(4186), 1,
      anon_sym_u03bb,
    ACTIONS(4190), 1,
      anon_sym_record,
    ACTIONS(4192), 1,
      anon_sym_LPAREN,
    ACTIONS(4194), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4196), 1,
      anon_sym_u2983,
    ACTIONS(4198), 1,
      anon_sym_LBRACE,
    ACTIONS(4200), 1,
      aux_sym__qid_token1,
    ACTIONS(4202), 1,
      anon_sym_DOT,
    ACTIONS(4204), 1,
      anon_sym_tactic,
    ACTIONS(4206), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4208), 1,
      anon_sym_u2987,
    ACTIONS(4212), 1,
      anon_sym_Set,
    STATE(3674), 1,
      sym_attributes,
    STATE(3888), 1,
      aux_sym__atoms,
    STATE(6121), 1,
      sym__qid,
    STATE(6386), 1,
      sym_atom,
    STATE(8067), 1,
      sym__LAMBDA,
    STATE(8369), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(852), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4210), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6575), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6565), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(4188), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10156), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [329499] = 34,
    ACTIONS(704), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(964), 1,
      anon_sym_quoteGoal,
    ACTIONS(972), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4214), 1,
      anon_sym_BSLASH,
    ACTIONS(4216), 1,
      anon_sym_u03bb,
    ACTIONS(4218), 1,
      anon_sym_tactic,
    STATE(3677), 1,
      sym_attributes,
    STATE(3891), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8047), 1,
      sym__LAMBDA,
    STATE(8355), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(942), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10154), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [329628] = 34,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(964), 1,
      anon_sym_quoteGoal,
    ACTIONS(972), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4078), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(4214), 1,
      anon_sym_BSLASH,
    ACTIONS(4216), 1,
      anon_sym_u03bb,
    ACTIONS(4218), 1,
      anon_sym_tactic,
    STATE(3659), 1,
      sym_attributes,
    STATE(3891), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8047), 1,
      sym__LAMBDA,
    STATE(8355), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(942), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9883), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [329757] = 34,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(878), 1,
      anon_sym_quoteGoal,
    ACTIONS(886), 1,
      anon_sym_let,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(3978), 1,
      anon_sym_u2984,
    ACTIONS(4182), 1,
      sym_id,
    ACTIONS(4184), 1,
      anon_sym_BSLASH,
    ACTIONS(4186), 1,
      anon_sym_u03bb,
    ACTIONS(4190), 1,
      anon_sym_record,
    ACTIONS(4192), 1,
      anon_sym_LPAREN,
    ACTIONS(4194), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4196), 1,
      anon_sym_u2983,
    ACTIONS(4198), 1,
      anon_sym_LBRACE,
    ACTIONS(4200), 1,
      aux_sym__qid_token1,
    ACTIONS(4202), 1,
      anon_sym_DOT,
    ACTIONS(4204), 1,
      anon_sym_tactic,
    ACTIONS(4206), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4208), 1,
      anon_sym_u2987,
    ACTIONS(4212), 1,
      anon_sym_Set,
    STATE(3415), 1,
      sym_attributes,
    STATE(3888), 1,
      aux_sym__atoms,
    STATE(6121), 1,
      sym__qid,
    STATE(6386), 1,
      sym_atom,
    STATE(8067), 1,
      sym__LAMBDA,
    STATE(8369), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(852), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4210), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6575), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6565), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(4188), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9922), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [329886] = 34,
    ACTIONS(710), 1,
      anon_sym_DASH,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(920), 1,
      anon_sym_quoteGoal,
    ACTIONS(928), 1,
      anon_sym_let,
    ACTIONS(3058), 1,
      anon_sym_BSLASH,
    ACTIONS(3060), 1,
      anon_sym_u03bb,
    ACTIONS(3064), 1,
      anon_sym_record,
    ACTIONS(3066), 1,
      anon_sym_LPAREN,
    ACTIONS(3068), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3070), 1,
      anon_sym_u2983,
    ACTIONS(3072), 1,
      anon_sym_LBRACE,
    ACTIONS(3076), 1,
      aux_sym__qid_token1,
    ACTIONS(3078), 1,
      anon_sym_DOT,
    ACTIONS(3080), 1,
      anon_sym_tactic,
    ACTIONS(3082), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3084), 1,
      anon_sym_u2987,
    ACTIONS(3088), 1,
      anon_sym_Set,
    ACTIONS(3978), 1,
      anon_sym_RBRACE,
    ACTIONS(4220), 1,
      sym_id,
    STATE(3399), 1,
      sym_attributes,
    STATE(3892), 1,
      aux_sym__atoms,
    STATE(6084), 1,
      sym__qid,
    STATE(6427), 1,
      sym_atom,
    STATE(8123), 1,
      sym__LAMBDA,
    STATE(8396), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3086), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6715), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6714), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3062), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9921), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [330015] = 34,
    ACTIONS(704), 1,
      anon_sym_u2984,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(878), 1,
      anon_sym_quoteGoal,
    ACTIONS(886), 1,
      anon_sym_let,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(4182), 1,
      sym_id,
    ACTIONS(4184), 1,
      anon_sym_BSLASH,
    ACTIONS(4186), 1,
      anon_sym_u03bb,
    ACTIONS(4190), 1,
      anon_sym_record,
    ACTIONS(4192), 1,
      anon_sym_LPAREN,
    ACTIONS(4194), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4196), 1,
      anon_sym_u2983,
    ACTIONS(4198), 1,
      anon_sym_LBRACE,
    ACTIONS(4200), 1,
      aux_sym__qid_token1,
    ACTIONS(4202), 1,
      anon_sym_DOT,
    ACTIONS(4204), 1,
      anon_sym_tactic,
    ACTIONS(4206), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4208), 1,
      anon_sym_u2987,
    ACTIONS(4212), 1,
      anon_sym_Set,
    STATE(3620), 1,
      sym_attributes,
    STATE(3888), 1,
      aux_sym__atoms,
    STATE(6121), 1,
      sym__qid,
    STATE(6386), 1,
      sym_atom,
    STATE(8067), 1,
      sym__LAMBDA,
    STATE(8369), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(852), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4210), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6575), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6565), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(4188), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9842), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [330144] = 34,
    ACTIONS(704), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(964), 1,
      anon_sym_quoteGoal,
    ACTIONS(972), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4214), 1,
      anon_sym_BSLASH,
    ACTIONS(4216), 1,
      anon_sym_u03bb,
    ACTIONS(4218), 1,
      anon_sym_tactic,
    STATE(3619), 1,
      sym_attributes,
    STATE(3891), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8047), 1,
      sym__LAMBDA,
    STATE(8355), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(942), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9840), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [330273] = 34,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(878), 1,
      anon_sym_quoteGoal,
    ACTIONS(886), 1,
      anon_sym_let,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(4078), 1,
      anon_sym_u2984,
    ACTIONS(4182), 1,
      sym_id,
    ACTIONS(4184), 1,
      anon_sym_BSLASH,
    ACTIONS(4186), 1,
      anon_sym_u03bb,
    ACTIONS(4190), 1,
      anon_sym_record,
    ACTIONS(4192), 1,
      anon_sym_LPAREN,
    ACTIONS(4194), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4196), 1,
      anon_sym_u2983,
    ACTIONS(4198), 1,
      anon_sym_LBRACE,
    ACTIONS(4200), 1,
      aux_sym__qid_token1,
    ACTIONS(4202), 1,
      anon_sym_DOT,
    ACTIONS(4204), 1,
      anon_sym_tactic,
    ACTIONS(4206), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4208), 1,
      anon_sym_u2987,
    ACTIONS(4212), 1,
      anon_sym_Set,
    STATE(3641), 1,
      sym_attributes,
    STATE(3888), 1,
      aux_sym__atoms,
    STATE(6121), 1,
      sym__qid,
    STATE(6386), 1,
      sym_atom,
    STATE(8067), 1,
      sym__LAMBDA,
    STATE(8369), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(852), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4210), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6575), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6565), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(4188), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9880), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [330402] = 34,
    ACTIONS(710), 1,
      anon_sym_DASH,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(920), 1,
      anon_sym_quoteGoal,
    ACTIONS(928), 1,
      anon_sym_let,
    ACTIONS(3058), 1,
      anon_sym_BSLASH,
    ACTIONS(3060), 1,
      anon_sym_u03bb,
    ACTIONS(3064), 1,
      anon_sym_record,
    ACTIONS(3066), 1,
      anon_sym_LPAREN,
    ACTIONS(3068), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3070), 1,
      anon_sym_u2983,
    ACTIONS(3072), 1,
      anon_sym_LBRACE,
    ACTIONS(3076), 1,
      aux_sym__qid_token1,
    ACTIONS(3078), 1,
      anon_sym_DOT,
    ACTIONS(3080), 1,
      anon_sym_tactic,
    ACTIONS(3082), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3084), 1,
      anon_sym_u2987,
    ACTIONS(3088), 1,
      anon_sym_Set,
    ACTIONS(4078), 1,
      anon_sym_RBRACE,
    ACTIONS(4220), 1,
      sym_id,
    STATE(3586), 1,
      sym_attributes,
    STATE(3892), 1,
      aux_sym__atoms,
    STATE(6084), 1,
      sym__qid,
    STATE(6427), 1,
      sym_atom,
    STATE(8123), 1,
      sym__LAMBDA,
    STATE(8396), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3086), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6715), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6714), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3062), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10046), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [330531] = 34,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(878), 1,
      anon_sym_quoteGoal,
    ACTIONS(886), 1,
      anon_sym_let,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(4078), 1,
      anon_sym_u2984,
    ACTIONS(4182), 1,
      sym_id,
    ACTIONS(4184), 1,
      anon_sym_BSLASH,
    ACTIONS(4186), 1,
      anon_sym_u03bb,
    ACTIONS(4190), 1,
      anon_sym_record,
    ACTIONS(4192), 1,
      anon_sym_LPAREN,
    ACTIONS(4194), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4196), 1,
      anon_sym_u2983,
    ACTIONS(4198), 1,
      anon_sym_LBRACE,
    ACTIONS(4200), 1,
      aux_sym__qid_token1,
    ACTIONS(4202), 1,
      anon_sym_DOT,
    ACTIONS(4204), 1,
      anon_sym_tactic,
    ACTIONS(4206), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4208), 1,
      anon_sym_u2987,
    ACTIONS(4212), 1,
      anon_sym_Set,
    STATE(3579), 1,
      sym_attributes,
    STATE(3888), 1,
      aux_sym__atoms,
    STATE(6121), 1,
      sym__qid,
    STATE(6386), 1,
      sym_atom,
    STATE(8067), 1,
      sym__LAMBDA,
    STATE(8369), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(852), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4210), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6575), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6565), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(4188), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10035), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [330660] = 34,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(732), 1,
      anon_sym_u2984,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(878), 1,
      anon_sym_quoteGoal,
    ACTIONS(886), 1,
      anon_sym_let,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(4182), 1,
      sym_id,
    ACTIONS(4184), 1,
      anon_sym_BSLASH,
    ACTIONS(4186), 1,
      anon_sym_u03bb,
    ACTIONS(4190), 1,
      anon_sym_record,
    ACTIONS(4192), 1,
      anon_sym_LPAREN,
    ACTIONS(4194), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4196), 1,
      anon_sym_u2983,
    ACTIONS(4198), 1,
      anon_sym_LBRACE,
    ACTIONS(4200), 1,
      aux_sym__qid_token1,
    ACTIONS(4202), 1,
      anon_sym_DOT,
    ACTIONS(4204), 1,
      anon_sym_tactic,
    ACTIONS(4206), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4208), 1,
      anon_sym_u2987,
    ACTIONS(4212), 1,
      anon_sym_Set,
    STATE(3465), 1,
      sym_attributes,
    STATE(3888), 1,
      aux_sym__atoms,
    STATE(6121), 1,
      sym__qid,
    STATE(6386), 1,
      sym_atom,
    STATE(8067), 1,
      sym__LAMBDA,
    STATE(8369), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(852), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4210), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6575), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6565), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(4188), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9946), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [330789] = 34,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(964), 1,
      anon_sym_quoteGoal,
    ACTIONS(972), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4078), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(4214), 1,
      anon_sym_BSLASH,
    ACTIONS(4216), 1,
      anon_sym_u03bb,
    ACTIONS(4218), 1,
      anon_sym_tactic,
    STATE(3572), 1,
      sym_attributes,
    STATE(3891), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8047), 1,
      sym__LAMBDA,
    STATE(8355), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(942), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10033), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [330918] = 34,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(732), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(964), 1,
      anon_sym_quoteGoal,
    ACTIONS(972), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4214), 1,
      anon_sym_BSLASH,
    ACTIONS(4216), 1,
      anon_sym_u03bb,
    ACTIONS(4218), 1,
      anon_sym_tactic,
    STATE(3461), 1,
      sym_attributes,
    STATE(3891), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8047), 1,
      sym__LAMBDA,
    STATE(8355), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(942), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9947), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [331047] = 34,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(732), 1,
      anon_sym_u2984,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(878), 1,
      anon_sym_quoteGoal,
    ACTIONS(886), 1,
      anon_sym_let,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(4182), 1,
      sym_id,
    ACTIONS(4184), 1,
      anon_sym_BSLASH,
    ACTIONS(4186), 1,
      anon_sym_u03bb,
    ACTIONS(4190), 1,
      anon_sym_record,
    ACTIONS(4192), 1,
      anon_sym_LPAREN,
    ACTIONS(4194), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4196), 1,
      anon_sym_u2983,
    ACTIONS(4198), 1,
      anon_sym_LBRACE,
    ACTIONS(4200), 1,
      aux_sym__qid_token1,
    ACTIONS(4202), 1,
      anon_sym_DOT,
    ACTIONS(4204), 1,
      anon_sym_tactic,
    ACTIONS(4206), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4208), 1,
      anon_sym_u2987,
    ACTIONS(4212), 1,
      anon_sym_Set,
    STATE(3579), 1,
      sym_attributes,
    STATE(3888), 1,
      aux_sym__atoms,
    STATE(6121), 1,
      sym__qid,
    STATE(6386), 1,
      sym_atom,
    STATE(8067), 1,
      sym__LAMBDA,
    STATE(8369), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(852), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4210), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6575), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6565), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(4188), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10035), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [331176] = 34,
    ACTIONS(704), 1,
      anon_sym_u2984,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(878), 1,
      anon_sym_quoteGoal,
    ACTIONS(886), 1,
      anon_sym_let,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(4182), 1,
      sym_id,
    ACTIONS(4184), 1,
      anon_sym_BSLASH,
    ACTIONS(4186), 1,
      anon_sym_u03bb,
    ACTIONS(4190), 1,
      anon_sym_record,
    ACTIONS(4192), 1,
      anon_sym_LPAREN,
    ACTIONS(4194), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4196), 1,
      anon_sym_u2983,
    ACTIONS(4198), 1,
      anon_sym_LBRACE,
    ACTIONS(4200), 1,
      aux_sym__qid_token1,
    ACTIONS(4202), 1,
      anon_sym_DOT,
    ACTIONS(4204), 1,
      anon_sym_tactic,
    ACTIONS(4206), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4208), 1,
      anon_sym_u2987,
    ACTIONS(4212), 1,
      anon_sym_Set,
    STATE(3642), 1,
      sym_attributes,
    STATE(3888), 1,
      aux_sym__atoms,
    STATE(6121), 1,
      sym__qid,
    STATE(6386), 1,
      sym_atom,
    STATE(8067), 1,
      sym__LAMBDA,
    STATE(8369), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(852), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4210), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6575), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6565), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(4188), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9726), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [331305] = 34,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(964), 1,
      anon_sym_quoteGoal,
    ACTIONS(972), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4078), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(4214), 1,
      anon_sym_BSLASH,
    ACTIONS(4216), 1,
      anon_sym_u03bb,
    ACTIONS(4218), 1,
      anon_sym_tactic,
    STATE(3577), 1,
      sym_attributes,
    STATE(3891), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8047), 1,
      sym__LAMBDA,
    STATE(8355), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(942), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10187), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [331434] = 34,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(732), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(964), 1,
      anon_sym_quoteGoal,
    ACTIONS(972), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4214), 1,
      anon_sym_BSLASH,
    ACTIONS(4216), 1,
      anon_sym_u03bb,
    ACTIONS(4218), 1,
      anon_sym_tactic,
    STATE(3572), 1,
      sym_attributes,
    STATE(3891), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8047), 1,
      sym__LAMBDA,
    STATE(8355), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(942), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10033), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [331563] = 34,
    ACTIONS(710), 1,
      anon_sym_DASH,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(920), 1,
      anon_sym_quoteGoal,
    ACTIONS(928), 1,
      anon_sym_let,
    ACTIONS(3058), 1,
      anon_sym_BSLASH,
    ACTIONS(3060), 1,
      anon_sym_u03bb,
    ACTIONS(3064), 1,
      anon_sym_record,
    ACTIONS(3066), 1,
      anon_sym_LPAREN,
    ACTIONS(3068), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3070), 1,
      anon_sym_u2983,
    ACTIONS(3072), 1,
      anon_sym_LBRACE,
    ACTIONS(3076), 1,
      aux_sym__qid_token1,
    ACTIONS(3078), 1,
      anon_sym_DOT,
    ACTIONS(3080), 1,
      anon_sym_tactic,
    ACTIONS(3082), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3084), 1,
      anon_sym_u2987,
    ACTIONS(3088), 1,
      anon_sym_Set,
    ACTIONS(3978), 1,
      anon_sym_RBRACE,
    ACTIONS(4220), 1,
      sym_id,
    STATE(3585), 1,
      sym_attributes,
    STATE(3892), 1,
      aux_sym__atoms,
    STATE(6084), 1,
      sym__qid,
    STATE(6427), 1,
      sym_atom,
    STATE(8123), 1,
      sym__LAMBDA,
    STATE(8396), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3086), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6715), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6714), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3062), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9829), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [331692] = 34,
    ACTIONS(710), 1,
      anon_sym_DASH,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(920), 1,
      anon_sym_quoteGoal,
    ACTIONS(928), 1,
      anon_sym_let,
    ACTIONS(3058), 1,
      anon_sym_BSLASH,
    ACTIONS(3060), 1,
      anon_sym_u03bb,
    ACTIONS(3064), 1,
      anon_sym_record,
    ACTIONS(3066), 1,
      anon_sym_LPAREN,
    ACTIONS(3068), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3070), 1,
      anon_sym_u2983,
    ACTIONS(3072), 1,
      anon_sym_LBRACE,
    ACTIONS(3076), 1,
      aux_sym__qid_token1,
    ACTIONS(3078), 1,
      anon_sym_DOT,
    ACTIONS(3080), 1,
      anon_sym_tactic,
    ACTIONS(3082), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3084), 1,
      anon_sym_u2987,
    ACTIONS(3088), 1,
      anon_sym_Set,
    ACTIONS(4078), 1,
      anon_sym_RBRACE,
    ACTIONS(4220), 1,
      sym_id,
    STATE(3634), 1,
      sym_attributes,
    STATE(3892), 1,
      aux_sym__atoms,
    STATE(6084), 1,
      sym__qid,
    STATE(6427), 1,
      sym_atom,
    STATE(8123), 1,
      sym__LAMBDA,
    STATE(8396), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3086), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6715), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6714), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3062), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9877), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [331821] = 34,
    ACTIONS(704), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(964), 1,
      anon_sym_quoteGoal,
    ACTIONS(972), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4214), 1,
      anon_sym_BSLASH,
    ACTIONS(4216), 1,
      anon_sym_u03bb,
    ACTIONS(4218), 1,
      anon_sym_tactic,
    STATE(3580), 1,
      sym_attributes,
    STATE(3891), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8047), 1,
      sym__LAMBDA,
    STATE(8355), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(942), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10121), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [331950] = 34,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(878), 1,
      anon_sym_quoteGoal,
    ACTIONS(886), 1,
      anon_sym_let,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(4078), 1,
      anon_sym_u2984,
    ACTIONS(4182), 1,
      sym_id,
    ACTIONS(4184), 1,
      anon_sym_BSLASH,
    ACTIONS(4186), 1,
      anon_sym_u03bb,
    ACTIONS(4190), 1,
      anon_sym_record,
    ACTIONS(4192), 1,
      anon_sym_LPAREN,
    ACTIONS(4194), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4196), 1,
      anon_sym_u2983,
    ACTIONS(4198), 1,
      anon_sym_LBRACE,
    ACTIONS(4200), 1,
      aux_sym__qid_token1,
    ACTIONS(4202), 1,
      anon_sym_DOT,
    ACTIONS(4204), 1,
      anon_sym_tactic,
    ACTIONS(4206), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4208), 1,
      anon_sym_u2987,
    ACTIONS(4212), 1,
      anon_sym_Set,
    STATE(3574), 1,
      sym_attributes,
    STATE(3888), 1,
      aux_sym__atoms,
    STATE(6121), 1,
      sym__qid,
    STATE(6386), 1,
      sym_atom,
    STATE(8067), 1,
      sym__LAMBDA,
    STATE(8369), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(852), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4210), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6575), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6565), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(4188), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10186), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [332079] = 34,
    ACTIONS(710), 1,
      anon_sym_DASH,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(920), 1,
      anon_sym_quoteGoal,
    ACTIONS(928), 1,
      anon_sym_let,
    ACTIONS(3058), 1,
      anon_sym_BSLASH,
    ACTIONS(3060), 1,
      anon_sym_u03bb,
    ACTIONS(3064), 1,
      anon_sym_record,
    ACTIONS(3066), 1,
      anon_sym_LPAREN,
    ACTIONS(3068), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3070), 1,
      anon_sym_u2983,
    ACTIONS(3072), 1,
      anon_sym_LBRACE,
    ACTIONS(3076), 1,
      aux_sym__qid_token1,
    ACTIONS(3078), 1,
      anon_sym_DOT,
    ACTIONS(3080), 1,
      anon_sym_tactic,
    ACTIONS(3082), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3084), 1,
      anon_sym_u2987,
    ACTIONS(3088), 1,
      anon_sym_Set,
    ACTIONS(4078), 1,
      anon_sym_RBRACE,
    ACTIONS(4220), 1,
      sym_id,
    STATE(3489), 1,
      sym_attributes,
    STATE(3892), 1,
      aux_sym__atoms,
    STATE(6084), 1,
      sym__qid,
    STATE(6427), 1,
      sym_atom,
    STATE(8123), 1,
      sym__LAMBDA,
    STATE(8396), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3086), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6715), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6714), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3062), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10185), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [332208] = 34,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(964), 1,
      anon_sym_quoteGoal,
    ACTIONS(972), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3978), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4214), 1,
      anon_sym_BSLASH,
    ACTIONS(4216), 1,
      anon_sym_u03bb,
    ACTIONS(4218), 1,
      anon_sym_tactic,
    STATE(3535), 1,
      sym_attributes,
    STATE(3891), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8047), 1,
      sym__LAMBDA,
    STATE(8355), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(942), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10207), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [332337] = 34,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(878), 1,
      anon_sym_quoteGoal,
    ACTIONS(886), 1,
      anon_sym_let,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(3978), 1,
      anon_sym_u2984,
    ACTIONS(4182), 1,
      sym_id,
    ACTIONS(4184), 1,
      anon_sym_BSLASH,
    ACTIONS(4186), 1,
      anon_sym_u03bb,
    ACTIONS(4190), 1,
      anon_sym_record,
    ACTIONS(4192), 1,
      anon_sym_LPAREN,
    ACTIONS(4194), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4196), 1,
      anon_sym_u2983,
    ACTIONS(4198), 1,
      anon_sym_LBRACE,
    ACTIONS(4200), 1,
      aux_sym__qid_token1,
    ACTIONS(4202), 1,
      anon_sym_DOT,
    ACTIONS(4204), 1,
      anon_sym_tactic,
    ACTIONS(4206), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4208), 1,
      anon_sym_u2987,
    ACTIONS(4212), 1,
      anon_sym_Set,
    STATE(3519), 1,
      sym_attributes,
    STATE(3888), 1,
      aux_sym__atoms,
    STATE(6121), 1,
      sym__qid,
    STATE(6386), 1,
      sym_atom,
    STATE(8067), 1,
      sym__LAMBDA,
    STATE(8369), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(852), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4210), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6575), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6565), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(4188), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10208), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [332466] = 34,
    ACTIONS(710), 1,
      anon_sym_DASH,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(920), 1,
      anon_sym_quoteGoal,
    ACTIONS(928), 1,
      anon_sym_let,
    ACTIONS(3058), 1,
      anon_sym_BSLASH,
    ACTIONS(3060), 1,
      anon_sym_u03bb,
    ACTIONS(3064), 1,
      anon_sym_record,
    ACTIONS(3066), 1,
      anon_sym_LPAREN,
    ACTIONS(3068), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3070), 1,
      anon_sym_u2983,
    ACTIONS(3072), 1,
      anon_sym_LBRACE,
    ACTIONS(3076), 1,
      aux_sym__qid_token1,
    ACTIONS(3078), 1,
      anon_sym_DOT,
    ACTIONS(3080), 1,
      anon_sym_tactic,
    ACTIONS(3082), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3084), 1,
      anon_sym_u2987,
    ACTIONS(3088), 1,
      anon_sym_Set,
    ACTIONS(3978), 1,
      anon_sym_RBRACE,
    ACTIONS(4220), 1,
      sym_id,
    STATE(3516), 1,
      sym_attributes,
    STATE(3892), 1,
      aux_sym__atoms,
    STATE(6084), 1,
      sym__qid,
    STATE(6427), 1,
      sym_atom,
    STATE(8123), 1,
      sym__LAMBDA,
    STATE(8396), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3086), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6715), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6714), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3062), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10200), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [332595] = 34,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(878), 1,
      anon_sym_quoteGoal,
    ACTIONS(886), 1,
      anon_sym_let,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(3978), 1,
      anon_sym_u2984,
    ACTIONS(4182), 1,
      sym_id,
    ACTIONS(4184), 1,
      anon_sym_BSLASH,
    ACTIONS(4186), 1,
      anon_sym_u03bb,
    ACTIONS(4190), 1,
      anon_sym_record,
    ACTIONS(4192), 1,
      anon_sym_LPAREN,
    ACTIONS(4194), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4196), 1,
      anon_sym_u2983,
    ACTIONS(4198), 1,
      anon_sym_LBRACE,
    ACTIONS(4200), 1,
      aux_sym__qid_token1,
    ACTIONS(4202), 1,
      anon_sym_DOT,
    ACTIONS(4204), 1,
      anon_sym_tactic,
    ACTIONS(4206), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4208), 1,
      anon_sym_u2987,
    ACTIONS(4212), 1,
      anon_sym_Set,
    STATE(3583), 1,
      sym_attributes,
    STATE(3888), 1,
      aux_sym__atoms,
    STATE(6121), 1,
      sym__qid,
    STATE(6386), 1,
      sym_atom,
    STATE(8067), 1,
      sym__LAMBDA,
    STATE(8369), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(852), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4210), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6575), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6565), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(4188), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9830), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [332724] = 34,
    ACTIONS(704), 1,
      anon_sym_u2984,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(878), 1,
      anon_sym_quoteGoal,
    ACTIONS(886), 1,
      anon_sym_let,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(4182), 1,
      sym_id,
    ACTIONS(4184), 1,
      anon_sym_BSLASH,
    ACTIONS(4186), 1,
      anon_sym_u03bb,
    ACTIONS(4190), 1,
      anon_sym_record,
    ACTIONS(4192), 1,
      anon_sym_LPAREN,
    ACTIONS(4194), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4196), 1,
      anon_sym_u2983,
    ACTIONS(4198), 1,
      anon_sym_LBRACE,
    ACTIONS(4200), 1,
      aux_sym__qid_token1,
    ACTIONS(4202), 1,
      anon_sym_DOT,
    ACTIONS(4204), 1,
      anon_sym_tactic,
    ACTIONS(4206), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4208), 1,
      anon_sym_u2987,
    ACTIONS(4212), 1,
      anon_sym_Set,
    STATE(3646), 1,
      sym_attributes,
    STATE(3888), 1,
      aux_sym__atoms,
    STATE(6121), 1,
      sym__qid,
    STATE(6386), 1,
      sym_atom,
    STATE(8067), 1,
      sym__LAMBDA,
    STATE(8369), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(852), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4210), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6575), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6565), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(4188), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10122), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [332853] = 34,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(730), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(964), 1,
      anon_sym_quoteGoal,
    ACTIONS(972), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4214), 1,
      anon_sym_BSLASH,
    ACTIONS(4216), 1,
      anon_sym_u03bb,
    ACTIONS(4218), 1,
      anon_sym_tactic,
    STATE(3417), 1,
      sym_attributes,
    STATE(3891), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8047), 1,
      sym__LAMBDA,
    STATE(8355), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(942), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9795), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [332982] = 34,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(730), 1,
      anon_sym_u2984,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(878), 1,
      anon_sym_quoteGoal,
    ACTIONS(886), 1,
      anon_sym_let,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(4182), 1,
      sym_id,
    ACTIONS(4184), 1,
      anon_sym_BSLASH,
    ACTIONS(4186), 1,
      anon_sym_u03bb,
    ACTIONS(4190), 1,
      anon_sym_record,
    ACTIONS(4192), 1,
      anon_sym_LPAREN,
    ACTIONS(4194), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4196), 1,
      anon_sym_u2983,
    ACTIONS(4198), 1,
      anon_sym_LBRACE,
    ACTIONS(4200), 1,
      aux_sym__qid_token1,
    ACTIONS(4202), 1,
      anon_sym_DOT,
    ACTIONS(4204), 1,
      anon_sym_tactic,
    ACTIONS(4206), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4208), 1,
      anon_sym_u2987,
    ACTIONS(4212), 1,
      anon_sym_Set,
    STATE(3411), 1,
      sym_attributes,
    STATE(3888), 1,
      aux_sym__atoms,
    STATE(6121), 1,
      sym__qid,
    STATE(6386), 1,
      sym_atom,
    STATE(8067), 1,
      sym__LAMBDA,
    STATE(8369), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(852), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4210), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6575), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6565), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(4188), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9796), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [333111] = 34,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(964), 1,
      anon_sym_quoteGoal,
    ACTIONS(972), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3978), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4214), 1,
      anon_sym_BSLASH,
    ACTIONS(4216), 1,
      anon_sym_u03bb,
    ACTIONS(4218), 1,
      anon_sym_tactic,
    STATE(3558), 1,
      sym_attributes,
    STATE(3891), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8047), 1,
      sym__LAMBDA,
    STATE(8355), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(942), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9831), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [333240] = 34,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(878), 1,
      anon_sym_quoteGoal,
    ACTIONS(886), 1,
      anon_sym_let,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(3978), 1,
      anon_sym_u2984,
    ACTIONS(4182), 1,
      sym_id,
    ACTIONS(4184), 1,
      anon_sym_BSLASH,
    ACTIONS(4186), 1,
      anon_sym_u03bb,
    ACTIONS(4190), 1,
      anon_sym_record,
    ACTIONS(4192), 1,
      anon_sym_LPAREN,
    ACTIONS(4194), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4196), 1,
      anon_sym_u2983,
    ACTIONS(4198), 1,
      anon_sym_LBRACE,
    ACTIONS(4200), 1,
      aux_sym__qid_token1,
    ACTIONS(4202), 1,
      anon_sym_DOT,
    ACTIONS(4204), 1,
      anon_sym_tactic,
    ACTIONS(4206), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4208), 1,
      anon_sym_u2987,
    ACTIONS(4212), 1,
      anon_sym_Set,
    STATE(3590), 1,
      sym_attributes,
    STATE(3888), 1,
      aux_sym__atoms,
    STATE(6121), 1,
      sym__qid,
    STATE(6386), 1,
      sym_atom,
    STATE(8067), 1,
      sym__LAMBDA,
    STATE(8369), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(852), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4210), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6575), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6565), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(4188), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9902), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [333369] = 34,
    ACTIONS(704), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(964), 1,
      anon_sym_quoteGoal,
    ACTIONS(972), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4214), 1,
      anon_sym_BSLASH,
    ACTIONS(4216), 1,
      anon_sym_u03bb,
    ACTIONS(4218), 1,
      anon_sym_tactic,
    STATE(3396), 1,
      sym_attributes,
    STATE(3891), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8047), 1,
      sym__LAMBDA,
    STATE(8355), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(942), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10224), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [333498] = 34,
    ACTIONS(704), 1,
      anon_sym_u2984,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(878), 1,
      anon_sym_quoteGoal,
    ACTIONS(886), 1,
      anon_sym_let,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(4182), 1,
      sym_id,
    ACTIONS(4184), 1,
      anon_sym_BSLASH,
    ACTIONS(4186), 1,
      anon_sym_u03bb,
    ACTIONS(4190), 1,
      anon_sym_record,
    ACTIONS(4192), 1,
      anon_sym_LPAREN,
    ACTIONS(4194), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4196), 1,
      anon_sym_u2983,
    ACTIONS(4198), 1,
      anon_sym_LBRACE,
    ACTIONS(4200), 1,
      aux_sym__qid_token1,
    ACTIONS(4202), 1,
      anon_sym_DOT,
    ACTIONS(4204), 1,
      anon_sym_tactic,
    ACTIONS(4206), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4208), 1,
      anon_sym_u2987,
    ACTIONS(4212), 1,
      anon_sym_Set,
    STATE(3397), 1,
      sym_attributes,
    STATE(3888), 1,
      aux_sym__atoms,
    STATE(6121), 1,
      sym__qid,
    STATE(6386), 1,
      sym_atom,
    STATE(8067), 1,
      sym__LAMBDA,
    STATE(8369), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(852), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4210), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6575), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6565), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(4188), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10221), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [333627] = 34,
    ACTIONS(704), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(964), 1,
      anon_sym_quoteGoal,
    ACTIONS(972), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4214), 1,
      anon_sym_BSLASH,
    ACTIONS(4216), 1,
      anon_sym_u03bb,
    ACTIONS(4218), 1,
      anon_sym_tactic,
    STATE(3625), 1,
      sym_attributes,
    STATE(3891), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8047), 1,
      sym__LAMBDA,
    STATE(8355), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(942), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10094), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [333756] = 34,
    ACTIONS(704), 1,
      anon_sym_u2984,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(878), 1,
      anon_sym_quoteGoal,
    ACTIONS(886), 1,
      anon_sym_let,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(4182), 1,
      sym_id,
    ACTIONS(4184), 1,
      anon_sym_BSLASH,
    ACTIONS(4186), 1,
      anon_sym_u03bb,
    ACTIONS(4190), 1,
      anon_sym_record,
    ACTIONS(4192), 1,
      anon_sym_LPAREN,
    ACTIONS(4194), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4196), 1,
      anon_sym_u2983,
    ACTIONS(4198), 1,
      anon_sym_LBRACE,
    ACTIONS(4200), 1,
      aux_sym__qid_token1,
    ACTIONS(4202), 1,
      anon_sym_DOT,
    ACTIONS(4204), 1,
      anon_sym_tactic,
    ACTIONS(4206), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4208), 1,
      anon_sym_u2987,
    ACTIONS(4212), 1,
      anon_sym_Set,
    STATE(3626), 1,
      sym_attributes,
    STATE(3888), 1,
      aux_sym__atoms,
    STATE(6121), 1,
      sym__qid,
    STATE(6386), 1,
      sym_atom,
    STATE(8067), 1,
      sym__LAMBDA,
    STATE(8369), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(852), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4210), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6575), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6565), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(4188), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10195), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [333885] = 34,
    ACTIONS(710), 1,
      anon_sym_DASH,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(920), 1,
      anon_sym_quoteGoal,
    ACTIONS(928), 1,
      anon_sym_let,
    ACTIONS(3058), 1,
      anon_sym_BSLASH,
    ACTIONS(3060), 1,
      anon_sym_u03bb,
    ACTIONS(3064), 1,
      anon_sym_record,
    ACTIONS(3066), 1,
      anon_sym_LPAREN,
    ACTIONS(3068), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3070), 1,
      anon_sym_u2983,
    ACTIONS(3072), 1,
      anon_sym_LBRACE,
    ACTIONS(3076), 1,
      aux_sym__qid_token1,
    ACTIONS(3078), 1,
      anon_sym_DOT,
    ACTIONS(3080), 1,
      anon_sym_tactic,
    ACTIONS(3082), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3084), 1,
      anon_sym_u2987,
    ACTIONS(3088), 1,
      anon_sym_Set,
    ACTIONS(4092), 1,
      anon_sym_RBRACE,
    ACTIONS(4220), 1,
      sym_id,
    STATE(3673), 1,
      sym_attributes,
    STATE(3892), 1,
      aux_sym__atoms,
    STATE(6084), 1,
      sym__qid,
    STATE(6427), 1,
      sym_atom,
    STATE(8123), 1,
      sym__LAMBDA,
    STATE(8396), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3086), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6715), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6714), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3062), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10024), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [334014] = 34,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(732), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(964), 1,
      anon_sym_quoteGoal,
    ACTIONS(972), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4214), 1,
      anon_sym_BSLASH,
    ACTIONS(4216), 1,
      anon_sym_u03bb,
    ACTIONS(4218), 1,
      anon_sym_tactic,
    STATE(3417), 1,
      sym_attributes,
    STATE(3891), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8047), 1,
      sym__LAMBDA,
    STATE(8355), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(942), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9795), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [334143] = 34,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(878), 1,
      anon_sym_quoteGoal,
    ACTIONS(886), 1,
      anon_sym_let,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(4092), 1,
      anon_sym_u2984,
    ACTIONS(4182), 1,
      sym_id,
    ACTIONS(4184), 1,
      anon_sym_BSLASH,
    ACTIONS(4186), 1,
      anon_sym_u03bb,
    ACTIONS(4190), 1,
      anon_sym_record,
    ACTIONS(4192), 1,
      anon_sym_LPAREN,
    ACTIONS(4194), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4196), 1,
      anon_sym_u2983,
    ACTIONS(4198), 1,
      anon_sym_LBRACE,
    ACTIONS(4200), 1,
      aux_sym__qid_token1,
    ACTIONS(4202), 1,
      anon_sym_DOT,
    ACTIONS(4204), 1,
      anon_sym_tactic,
    ACTIONS(4206), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4208), 1,
      anon_sym_u2987,
    ACTIONS(4212), 1,
      anon_sym_Set,
    STATE(3671), 1,
      sym_attributes,
    STATE(3888), 1,
      aux_sym__atoms,
    STATE(6121), 1,
      sym__qid,
    STATE(6386), 1,
      sym_atom,
    STATE(8067), 1,
      sym__LAMBDA,
    STATE(8369), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(852), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4210), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6575), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6565), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(4188), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10022), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [334272] = 34,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(964), 1,
      anon_sym_quoteGoal,
    ACTIONS(972), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4092), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(4214), 1,
      anon_sym_BSLASH,
    ACTIONS(4216), 1,
      anon_sym_u03bb,
    ACTIONS(4218), 1,
      anon_sym_tactic,
    STATE(3644), 1,
      sym_attributes,
    STATE(3891), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8047), 1,
      sym__LAMBDA,
    STATE(8355), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(942), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10018), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [334401] = 34,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(732), 1,
      anon_sym_u2984,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(878), 1,
      anon_sym_quoteGoal,
    ACTIONS(886), 1,
      anon_sym_let,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(4182), 1,
      sym_id,
    ACTIONS(4184), 1,
      anon_sym_BSLASH,
    ACTIONS(4186), 1,
      anon_sym_u03bb,
    ACTIONS(4190), 1,
      anon_sym_record,
    ACTIONS(4192), 1,
      anon_sym_LPAREN,
    ACTIONS(4194), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4196), 1,
      anon_sym_u2983,
    ACTIONS(4198), 1,
      anon_sym_LBRACE,
    ACTIONS(4200), 1,
      aux_sym__qid_token1,
    ACTIONS(4202), 1,
      anon_sym_DOT,
    ACTIONS(4204), 1,
      anon_sym_tactic,
    ACTIONS(4206), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4208), 1,
      anon_sym_u2987,
    ACTIONS(4212), 1,
      anon_sym_Set,
    STATE(3411), 1,
      sym_attributes,
    STATE(3888), 1,
      aux_sym__atoms,
    STATE(6121), 1,
      sym__qid,
    STATE(6386), 1,
      sym_atom,
    STATE(8067), 1,
      sym__LAMBDA,
    STATE(8369), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(852), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4210), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6575), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6565), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(4188), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9796), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [334530] = 34,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(964), 1,
      anon_sym_quoteGoal,
    ACTIONS(972), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4092), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(4214), 1,
      anon_sym_BSLASH,
    ACTIONS(4216), 1,
      anon_sym_u03bb,
    ACTIONS(4218), 1,
      anon_sym_tactic,
    STATE(3417), 1,
      sym_attributes,
    STATE(3891), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8047), 1,
      sym__LAMBDA,
    STATE(8355), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(942), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9795), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [334659] = 34,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(732), 1,
      anon_sym_u2984,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(878), 1,
      anon_sym_quoteGoal,
    ACTIONS(886), 1,
      anon_sym_let,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(4182), 1,
      sym_id,
    ACTIONS(4184), 1,
      anon_sym_BSLASH,
    ACTIONS(4186), 1,
      anon_sym_u03bb,
    ACTIONS(4190), 1,
      anon_sym_record,
    ACTIONS(4192), 1,
      anon_sym_LPAREN,
    ACTIONS(4194), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4196), 1,
      anon_sym_u2983,
    ACTIONS(4198), 1,
      anon_sym_LBRACE,
    ACTIONS(4200), 1,
      aux_sym__qid_token1,
    ACTIONS(4202), 1,
      anon_sym_DOT,
    ACTIONS(4204), 1,
      anon_sym_tactic,
    ACTIONS(4206), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4208), 1,
      anon_sym_u2987,
    ACTIONS(4212), 1,
      anon_sym_Set,
    STATE(3630), 1,
      sym_attributes,
    STATE(3888), 1,
      aux_sym__atoms,
    STATE(6121), 1,
      sym__qid,
    STATE(6386), 1,
      sym_atom,
    STATE(8067), 1,
      sym__LAMBDA,
    STATE(8369), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(852), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4210), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6575), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6565), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(4188), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10056), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [334788] = 34,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(730), 1,
      anon_sym_u2984,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(878), 1,
      anon_sym_quoteGoal,
    ACTIONS(886), 1,
      anon_sym_let,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(4182), 1,
      sym_id,
    ACTIONS(4184), 1,
      anon_sym_BSLASH,
    ACTIONS(4186), 1,
      anon_sym_u03bb,
    ACTIONS(4190), 1,
      anon_sym_record,
    ACTIONS(4192), 1,
      anon_sym_LPAREN,
    ACTIONS(4194), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4196), 1,
      anon_sym_u2983,
    ACTIONS(4198), 1,
      anon_sym_LBRACE,
    ACTIONS(4200), 1,
      aux_sym__qid_token1,
    ACTIONS(4202), 1,
      anon_sym_DOT,
    ACTIONS(4204), 1,
      anon_sym_tactic,
    ACTIONS(4206), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4208), 1,
      anon_sym_u2987,
    ACTIONS(4212), 1,
      anon_sym_Set,
    STATE(3671), 1,
      sym_attributes,
    STATE(3888), 1,
      aux_sym__atoms,
    STATE(6121), 1,
      sym__qid,
    STATE(6386), 1,
      sym_atom,
    STATE(8067), 1,
      sym__LAMBDA,
    STATE(8369), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(852), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4210), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6575), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6565), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(4188), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10022), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [334917] = 34,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(730), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(964), 1,
      anon_sym_quoteGoal,
    ACTIONS(972), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4214), 1,
      anon_sym_BSLASH,
    ACTIONS(4216), 1,
      anon_sym_u03bb,
    ACTIONS(4218), 1,
      anon_sym_tactic,
    STATE(3644), 1,
      sym_attributes,
    STATE(3891), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8047), 1,
      sym__LAMBDA,
    STATE(8355), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(942), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10018), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [335046] = 34,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(732), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(964), 1,
      anon_sym_quoteGoal,
    ACTIONS(972), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4214), 1,
      anon_sym_BSLASH,
    ACTIONS(4216), 1,
      anon_sym_u03bb,
    ACTIONS(4218), 1,
      anon_sym_tactic,
    STATE(3373), 1,
      sym_attributes,
    STATE(3891), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8047), 1,
      sym__LAMBDA,
    STATE(8355), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(942), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10055), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [335175] = 34,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(964), 1,
      anon_sym_quoteGoal,
    ACTIONS(972), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3978), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4214), 1,
      anon_sym_BSLASH,
    ACTIONS(4216), 1,
      anon_sym_u03bb,
    ACTIONS(4218), 1,
      anon_sym_tactic,
    STATE(3580), 1,
      sym_attributes,
    STATE(3891), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8047), 1,
      sym__LAMBDA,
    STATE(8355), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(942), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10121), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [335304] = 34,
    ACTIONS(710), 1,
      anon_sym_DASH,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(920), 1,
      anon_sym_quoteGoal,
    ACTIONS(928), 1,
      anon_sym_let,
    ACTIONS(3058), 1,
      anon_sym_BSLASH,
    ACTIONS(3060), 1,
      anon_sym_u03bb,
    ACTIONS(3064), 1,
      anon_sym_record,
    ACTIONS(3066), 1,
      anon_sym_LPAREN,
    ACTIONS(3068), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3070), 1,
      anon_sym_u2983,
    ACTIONS(3072), 1,
      anon_sym_LBRACE,
    ACTIONS(3076), 1,
      aux_sym__qid_token1,
    ACTIONS(3078), 1,
      anon_sym_DOT,
    ACTIONS(3080), 1,
      anon_sym_tactic,
    ACTIONS(3082), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3084), 1,
      anon_sym_u2987,
    ACTIONS(3088), 1,
      anon_sym_Set,
    ACTIONS(4078), 1,
      anon_sym_RBRACE,
    ACTIONS(4220), 1,
      sym_id,
    STATE(3440), 1,
      sym_attributes,
    STATE(3892), 1,
      aux_sym__atoms,
    STATE(6084), 1,
      sym__qid,
    STATE(6427), 1,
      sym_atom,
    STATE(8123), 1,
      sym__LAMBDA,
    STATE(8396), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3086), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6715), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6714), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3062), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9843), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [335433] = 34,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(878), 1,
      anon_sym_quoteGoal,
    ACTIONS(886), 1,
      anon_sym_let,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(3978), 1,
      anon_sym_u2984,
    ACTIONS(4182), 1,
      sym_id,
    ACTIONS(4184), 1,
      anon_sym_BSLASH,
    ACTIONS(4186), 1,
      anon_sym_u03bb,
    ACTIONS(4190), 1,
      anon_sym_record,
    ACTIONS(4192), 1,
      anon_sym_LPAREN,
    ACTIONS(4194), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4196), 1,
      anon_sym_u2983,
    ACTIONS(4198), 1,
      anon_sym_LBRACE,
    ACTIONS(4200), 1,
      aux_sym__qid_token1,
    ACTIONS(4202), 1,
      anon_sym_DOT,
    ACTIONS(4204), 1,
      anon_sym_tactic,
    ACTIONS(4206), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4208), 1,
      anon_sym_u2987,
    ACTIONS(4212), 1,
      anon_sym_Set,
    STATE(3646), 1,
      sym_attributes,
    STATE(3888), 1,
      aux_sym__atoms,
    STATE(6121), 1,
      sym__qid,
    STATE(6386), 1,
      sym_atom,
    STATE(8067), 1,
      sym__LAMBDA,
    STATE(8369), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(852), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4210), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6575), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6565), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(4188), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10122), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [335562] = 34,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(732), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(964), 1,
      anon_sym_quoteGoal,
    ACTIONS(972), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4214), 1,
      anon_sym_BSLASH,
    ACTIONS(4216), 1,
      anon_sym_u03bb,
    ACTIONS(4218), 1,
      anon_sym_tactic,
    STATE(3408), 1,
      sym_attributes,
    STATE(3891), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8047), 1,
      sym__LAMBDA,
    STATE(8355), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(942), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9997), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [335691] = 34,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(732), 1,
      anon_sym_u2984,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(878), 1,
      anon_sym_quoteGoal,
    ACTIONS(886), 1,
      anon_sym_let,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(4182), 1,
      sym_id,
    ACTIONS(4184), 1,
      anon_sym_BSLASH,
    ACTIONS(4186), 1,
      anon_sym_u03bb,
    ACTIONS(4190), 1,
      anon_sym_record,
    ACTIONS(4192), 1,
      anon_sym_LPAREN,
    ACTIONS(4194), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4196), 1,
      anon_sym_u2983,
    ACTIONS(4198), 1,
      anon_sym_LBRACE,
    ACTIONS(4200), 1,
      aux_sym__qid_token1,
    ACTIONS(4202), 1,
      anon_sym_DOT,
    ACTIONS(4204), 1,
      anon_sym_tactic,
    ACTIONS(4206), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4208), 1,
      anon_sym_u2987,
    ACTIONS(4212), 1,
      anon_sym_Set,
    STATE(3438), 1,
      sym_attributes,
    STATE(3888), 1,
      aux_sym__atoms,
    STATE(6121), 1,
      sym__qid,
    STATE(6386), 1,
      sym_atom,
    STATE(8067), 1,
      sym__LAMBDA,
    STATE(8369), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(852), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4210), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6575), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6565), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(4188), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9998), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [335820] = 34,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(878), 1,
      anon_sym_quoteGoal,
    ACTIONS(886), 1,
      anon_sym_let,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(4078), 1,
      anon_sym_u2984,
    ACTIONS(4182), 1,
      sym_id,
    ACTIONS(4184), 1,
      anon_sym_BSLASH,
    ACTIONS(4186), 1,
      anon_sym_u03bb,
    ACTIONS(4190), 1,
      anon_sym_record,
    ACTIONS(4192), 1,
      anon_sym_LPAREN,
    ACTIONS(4194), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4196), 1,
      anon_sym_u2983,
    ACTIONS(4198), 1,
      anon_sym_LBRACE,
    ACTIONS(4200), 1,
      aux_sym__qid_token1,
    ACTIONS(4202), 1,
      anon_sym_DOT,
    ACTIONS(4204), 1,
      anon_sym_tactic,
    ACTIONS(4206), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4208), 1,
      anon_sym_u2987,
    ACTIONS(4212), 1,
      anon_sym_Set,
    STATE(3445), 1,
      sym_attributes,
    STATE(3888), 1,
      aux_sym__atoms,
    STATE(6121), 1,
      sym__qid,
    STATE(6386), 1,
      sym_atom,
    STATE(8067), 1,
      sym__LAMBDA,
    STATE(8369), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(852), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4210), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6575), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6565), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(4188), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9743), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [335949] = 34,
    ACTIONS(710), 1,
      anon_sym_DASH,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(920), 1,
      anon_sym_quoteGoal,
    ACTIONS(928), 1,
      anon_sym_let,
    ACTIONS(3058), 1,
      anon_sym_BSLASH,
    ACTIONS(3060), 1,
      anon_sym_u03bb,
    ACTIONS(3064), 1,
      anon_sym_record,
    ACTIONS(3066), 1,
      anon_sym_LPAREN,
    ACTIONS(3068), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3070), 1,
      anon_sym_u2983,
    ACTIONS(3072), 1,
      anon_sym_LBRACE,
    ACTIONS(3076), 1,
      aux_sym__qid_token1,
    ACTIONS(3078), 1,
      anon_sym_DOT,
    ACTIONS(3080), 1,
      anon_sym_tactic,
    ACTIONS(3082), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3084), 1,
      anon_sym_u2987,
    ACTIONS(3088), 1,
      anon_sym_Set,
    ACTIONS(3978), 1,
      anon_sym_RBRACE,
    ACTIONS(4220), 1,
      sym_id,
    STATE(3612), 1,
      sym_attributes,
    STATE(3892), 1,
      aux_sym__atoms,
    STATE(6084), 1,
      sym__qid,
    STATE(6427), 1,
      sym_atom,
    STATE(8123), 1,
      sym__LAMBDA,
    STATE(8396), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3086), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6715), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6714), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3062), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10190), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [336078] = 34,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(964), 1,
      anon_sym_quoteGoal,
    ACTIONS(972), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4078), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(4214), 1,
      anon_sym_BSLASH,
    ACTIONS(4216), 1,
      anon_sym_u03bb,
    ACTIONS(4218), 1,
      anon_sym_tactic,
    STATE(3348), 1,
      sym_attributes,
    STATE(3891), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8047), 1,
      sym__LAMBDA,
    STATE(8355), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(942), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9855), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [336207] = 34,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(878), 1,
      anon_sym_quoteGoal,
    ACTIONS(886), 1,
      anon_sym_let,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(4092), 1,
      anon_sym_u2984,
    ACTIONS(4182), 1,
      sym_id,
    ACTIONS(4184), 1,
      anon_sym_BSLASH,
    ACTIONS(4186), 1,
      anon_sym_u03bb,
    ACTIONS(4190), 1,
      anon_sym_record,
    ACTIONS(4192), 1,
      anon_sym_LPAREN,
    ACTIONS(4194), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4196), 1,
      anon_sym_u2983,
    ACTIONS(4198), 1,
      anon_sym_LBRACE,
    ACTIONS(4200), 1,
      aux_sym__qid_token1,
    ACTIONS(4202), 1,
      anon_sym_DOT,
    ACTIONS(4204), 1,
      anon_sym_tactic,
    ACTIONS(4206), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4208), 1,
      anon_sym_u2987,
    ACTIONS(4212), 1,
      anon_sym_Set,
    STATE(3411), 1,
      sym_attributes,
    STATE(3888), 1,
      aux_sym__atoms,
    STATE(6121), 1,
      sym__qid,
    STATE(6386), 1,
      sym_atom,
    STATE(8067), 1,
      sym__LAMBDA,
    STATE(8369), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(852), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4210), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6575), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6565), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(4188), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9796), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [336336] = 34,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(964), 1,
      anon_sym_quoteGoal,
    ACTIONS(972), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4078), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(4214), 1,
      anon_sym_BSLASH,
    ACTIONS(4216), 1,
      anon_sym_u03bb,
    ACTIONS(4218), 1,
      anon_sym_tactic,
    STATE(3417), 1,
      sym_attributes,
    STATE(3891), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8047), 1,
      sym__LAMBDA,
    STATE(8355), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(942), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9795), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [336465] = 34,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(878), 1,
      anon_sym_quoteGoal,
    ACTIONS(886), 1,
      anon_sym_let,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(4078), 1,
      anon_sym_u2984,
    ACTIONS(4182), 1,
      sym_id,
    ACTIONS(4184), 1,
      anon_sym_BSLASH,
    ACTIONS(4186), 1,
      anon_sym_u03bb,
    ACTIONS(4190), 1,
      anon_sym_record,
    ACTIONS(4192), 1,
      anon_sym_LPAREN,
    ACTIONS(4194), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4196), 1,
      anon_sym_u2983,
    ACTIONS(4198), 1,
      anon_sym_LBRACE,
    ACTIONS(4200), 1,
      aux_sym__qid_token1,
    ACTIONS(4202), 1,
      anon_sym_DOT,
    ACTIONS(4204), 1,
      anon_sym_tactic,
    ACTIONS(4206), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4208), 1,
      anon_sym_u2987,
    ACTIONS(4212), 1,
      anon_sym_Set,
    STATE(3411), 1,
      sym_attributes,
    STATE(3888), 1,
      aux_sym__atoms,
    STATE(6121), 1,
      sym__qid,
    STATE(6386), 1,
      sym_atom,
    STATE(8067), 1,
      sym__LAMBDA,
    STATE(8369), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(852), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4210), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6575), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6565), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(4188), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9796), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [336594] = 34,
    ACTIONS(710), 1,
      anon_sym_DASH,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(920), 1,
      anon_sym_quoteGoal,
    ACTIONS(928), 1,
      anon_sym_let,
    ACTIONS(3058), 1,
      anon_sym_BSLASH,
    ACTIONS(3060), 1,
      anon_sym_u03bb,
    ACTIONS(3064), 1,
      anon_sym_record,
    ACTIONS(3066), 1,
      anon_sym_LPAREN,
    ACTIONS(3068), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3070), 1,
      anon_sym_u2983,
    ACTIONS(3072), 1,
      anon_sym_LBRACE,
    ACTIONS(3076), 1,
      aux_sym__qid_token1,
    ACTIONS(3078), 1,
      anon_sym_DOT,
    ACTIONS(3080), 1,
      anon_sym_tactic,
    ACTIONS(3082), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3084), 1,
      anon_sym_u2987,
    ACTIONS(3088), 1,
      anon_sym_Set,
    ACTIONS(4092), 1,
      anon_sym_RBRACE,
    ACTIONS(4220), 1,
      sym_id,
    STATE(3352), 1,
      sym_attributes,
    STATE(3892), 1,
      aux_sym__atoms,
    STATE(6084), 1,
      sym__qid,
    STATE(6427), 1,
      sym_atom,
    STATE(8123), 1,
      sym__LAMBDA,
    STATE(8396), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3086), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6715), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6714), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3062), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9797), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [336723] = 34,
    ACTIONS(710), 1,
      anon_sym_DASH,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(920), 1,
      anon_sym_quoteGoal,
    ACTIONS(928), 1,
      anon_sym_let,
    ACTIONS(3058), 1,
      anon_sym_BSLASH,
    ACTIONS(3060), 1,
      anon_sym_u03bb,
    ACTIONS(3064), 1,
      anon_sym_record,
    ACTIONS(3066), 1,
      anon_sym_LPAREN,
    ACTIONS(3068), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3070), 1,
      anon_sym_u2983,
    ACTIONS(3072), 1,
      anon_sym_LBRACE,
    ACTIONS(3076), 1,
      aux_sym__qid_token1,
    ACTIONS(3078), 1,
      anon_sym_DOT,
    ACTIONS(3080), 1,
      anon_sym_tactic,
    ACTIONS(3082), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3084), 1,
      anon_sym_u2987,
    ACTIONS(3088), 1,
      anon_sym_Set,
    ACTIONS(4078), 1,
      anon_sym_RBRACE,
    ACTIONS(4220), 1,
      sym_id,
    STATE(3352), 1,
      sym_attributes,
    STATE(3892), 1,
      aux_sym__atoms,
    STATE(6084), 1,
      sym__qid,
    STATE(6427), 1,
      sym_atom,
    STATE(8123), 1,
      sym__LAMBDA,
    STATE(8396), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3086), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6715), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6714), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3062), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9797), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [336852] = 34,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(964), 1,
      anon_sym_quoteGoal,
    ACTIONS(972), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4078), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(4214), 1,
      anon_sym_BSLASH,
    ACTIONS(4216), 1,
      anon_sym_u03bb,
    ACTIONS(4218), 1,
      anon_sym_tactic,
    STATE(3408), 1,
      sym_attributes,
    STATE(3891), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8047), 1,
      sym__LAMBDA,
    STATE(8355), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(942), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9997), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [336981] = 34,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(878), 1,
      anon_sym_quoteGoal,
    ACTIONS(886), 1,
      anon_sym_let,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(4078), 1,
      anon_sym_u2984,
    ACTIONS(4182), 1,
      sym_id,
    ACTIONS(4184), 1,
      anon_sym_BSLASH,
    ACTIONS(4186), 1,
      anon_sym_u03bb,
    ACTIONS(4190), 1,
      anon_sym_record,
    ACTIONS(4192), 1,
      anon_sym_LPAREN,
    ACTIONS(4194), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4196), 1,
      anon_sym_u2983,
    ACTIONS(4198), 1,
      anon_sym_LBRACE,
    ACTIONS(4200), 1,
      aux_sym__qid_token1,
    ACTIONS(4202), 1,
      anon_sym_DOT,
    ACTIONS(4204), 1,
      anon_sym_tactic,
    ACTIONS(4206), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4208), 1,
      anon_sym_u2987,
    ACTIONS(4212), 1,
      anon_sym_Set,
    STATE(3438), 1,
      sym_attributes,
    STATE(3888), 1,
      aux_sym__atoms,
    STATE(6121), 1,
      sym__qid,
    STATE(6386), 1,
      sym_atom,
    STATE(8067), 1,
      sym__LAMBDA,
    STATE(8369), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(852), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4210), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6575), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6565), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(4188), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9998), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [337110] = 34,
    ACTIONS(710), 1,
      anon_sym_DASH,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(920), 1,
      anon_sym_quoteGoal,
    ACTIONS(928), 1,
      anon_sym_let,
    ACTIONS(3058), 1,
      anon_sym_BSLASH,
    ACTIONS(3060), 1,
      anon_sym_u03bb,
    ACTIONS(3064), 1,
      anon_sym_record,
    ACTIONS(3066), 1,
      anon_sym_LPAREN,
    ACTIONS(3068), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3070), 1,
      anon_sym_u2983,
    ACTIONS(3072), 1,
      anon_sym_LBRACE,
    ACTIONS(3076), 1,
      aux_sym__qid_token1,
    ACTIONS(3078), 1,
      anon_sym_DOT,
    ACTIONS(3080), 1,
      anon_sym_tactic,
    ACTIONS(3082), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3084), 1,
      anon_sym_u2987,
    ACTIONS(3088), 1,
      anon_sym_Set,
    ACTIONS(4078), 1,
      anon_sym_RBRACE,
    ACTIONS(4220), 1,
      sym_id,
    STATE(3437), 1,
      sym_attributes,
    STATE(3892), 1,
      aux_sym__atoms,
    STATE(6084), 1,
      sym__qid,
    STATE(6427), 1,
      sym_atom,
    STATE(8123), 1,
      sym__LAMBDA,
    STATE(8396), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3086), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6715), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6714), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3062), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10000), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [337239] = 34,
    ACTIONS(710), 1,
      anon_sym_DASH,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(920), 1,
      anon_sym_quoteGoal,
    ACTIONS(928), 1,
      anon_sym_let,
    ACTIONS(3058), 1,
      anon_sym_BSLASH,
    ACTIONS(3060), 1,
      anon_sym_u03bb,
    ACTIONS(3064), 1,
      anon_sym_record,
    ACTIONS(3066), 1,
      anon_sym_LPAREN,
    ACTIONS(3068), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3070), 1,
      anon_sym_u2983,
    ACTIONS(3072), 1,
      anon_sym_LBRACE,
    ACTIONS(3076), 1,
      aux_sym__qid_token1,
    ACTIONS(3078), 1,
      anon_sym_DOT,
    ACTIONS(3080), 1,
      anon_sym_tactic,
    ACTIONS(3082), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3084), 1,
      anon_sym_u2987,
    ACTIONS(3088), 1,
      anon_sym_Set,
    ACTIONS(4078), 1,
      anon_sym_RBRACE,
    ACTIONS(4220), 1,
      sym_id,
    STATE(3534), 1,
      sym_attributes,
    STATE(3892), 1,
      aux_sym__atoms,
    STATE(6084), 1,
      sym__qid,
    STATE(6427), 1,
      sym_atom,
    STATE(8123), 1,
      sym__LAMBDA,
    STATE(8396), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3086), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6715), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6714), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3062), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9740), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [337368] = 34,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(878), 1,
      anon_sym_quoteGoal,
    ACTIONS(886), 1,
      anon_sym_let,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(4078), 1,
      anon_sym_u2984,
    ACTIONS(4182), 1,
      sym_id,
    ACTIONS(4184), 1,
      anon_sym_BSLASH,
    ACTIONS(4186), 1,
      anon_sym_u03bb,
    ACTIONS(4190), 1,
      anon_sym_record,
    ACTIONS(4192), 1,
      anon_sym_LPAREN,
    ACTIONS(4194), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4196), 1,
      anon_sym_u2983,
    ACTIONS(4198), 1,
      anon_sym_LBRACE,
    ACTIONS(4200), 1,
      aux_sym__qid_token1,
    ACTIONS(4202), 1,
      anon_sym_DOT,
    ACTIONS(4204), 1,
      anon_sym_tactic,
    ACTIONS(4206), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4208), 1,
      anon_sym_u2987,
    ACTIONS(4212), 1,
      anon_sym_Set,
    STATE(3536), 1,
      sym_attributes,
    STATE(3888), 1,
      aux_sym__atoms,
    STATE(6121), 1,
      sym__qid,
    STATE(6386), 1,
      sym_atom,
    STATE(8067), 1,
      sym__LAMBDA,
    STATE(8369), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(852), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4210), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6575), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6565), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(4188), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9738), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [337497] = 34,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(732), 1,
      anon_sym_u2984,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(878), 1,
      anon_sym_quoteGoal,
    ACTIONS(886), 1,
      anon_sym_let,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(4182), 1,
      sym_id,
    ACTIONS(4184), 1,
      anon_sym_BSLASH,
    ACTIONS(4186), 1,
      anon_sym_u03bb,
    ACTIONS(4190), 1,
      anon_sym_record,
    ACTIONS(4192), 1,
      anon_sym_LPAREN,
    ACTIONS(4194), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4196), 1,
      anon_sym_u2983,
    ACTIONS(4198), 1,
      anon_sym_LBRACE,
    ACTIONS(4200), 1,
      aux_sym__qid_token1,
    ACTIONS(4202), 1,
      anon_sym_DOT,
    ACTIONS(4204), 1,
      anon_sym_tactic,
    ACTIONS(4206), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4208), 1,
      anon_sym_u2987,
    ACTIONS(4212), 1,
      anon_sym_Set,
    STATE(3445), 1,
      sym_attributes,
    STATE(3888), 1,
      aux_sym__atoms,
    STATE(6121), 1,
      sym__qid,
    STATE(6386), 1,
      sym_atom,
    STATE(8067), 1,
      sym__LAMBDA,
    STATE(8369), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(852), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4210), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6575), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6565), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(4188), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9743), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [337626] = 34,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(732), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(964), 1,
      anon_sym_quoteGoal,
    ACTIONS(972), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4214), 1,
      anon_sym_BSLASH,
    ACTIONS(4216), 1,
      anon_sym_u03bb,
    ACTIONS(4218), 1,
      anon_sym_tactic,
    STATE(3348), 1,
      sym_attributes,
    STATE(3891), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8047), 1,
      sym__LAMBDA,
    STATE(8355), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(942), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9855), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [337755] = 34,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(964), 1,
      anon_sym_quoteGoal,
    ACTIONS(972), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4078), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(4214), 1,
      anon_sym_BSLASH,
    ACTIONS(4216), 1,
      anon_sym_u03bb,
    ACTIONS(4218), 1,
      anon_sym_tactic,
    STATE(3537), 1,
      sym_attributes,
    STATE(3891), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8047), 1,
      sym__LAMBDA,
    STATE(8355), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(942), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9737), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [337884] = 34,
    ACTIONS(710), 1,
      anon_sym_DASH,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(920), 1,
      anon_sym_quoteGoal,
    ACTIONS(928), 1,
      anon_sym_let,
    ACTIONS(3058), 1,
      anon_sym_BSLASH,
    ACTIONS(3060), 1,
      anon_sym_u03bb,
    ACTIONS(3064), 1,
      anon_sym_record,
    ACTIONS(3066), 1,
      anon_sym_LPAREN,
    ACTIONS(3068), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3070), 1,
      anon_sym_u2983,
    ACTIONS(3072), 1,
      anon_sym_LBRACE,
    ACTIONS(3076), 1,
      aux_sym__qid_token1,
    ACTIONS(3078), 1,
      anon_sym_DOT,
    ACTIONS(3080), 1,
      anon_sym_tactic,
    ACTIONS(3082), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3084), 1,
      anon_sym_u2987,
    ACTIONS(3088), 1,
      anon_sym_Set,
    ACTIONS(3978), 1,
      anon_sym_RBRACE,
    ACTIONS(4220), 1,
      sym_id,
    STATE(3406), 1,
      sym_attributes,
    STATE(3892), 1,
      aux_sym__atoms,
    STATE(6084), 1,
      sym__qid,
    STATE(6427), 1,
      sym_atom,
    STATE(8123), 1,
      sym__LAMBDA,
    STATE(8396), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3086), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6715), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6714), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3062), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10219), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [338013] = 33,
    ACTIONS(710), 1,
      anon_sym_DASH,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(920), 1,
      anon_sym_quoteGoal,
    ACTIONS(928), 1,
      anon_sym_let,
    ACTIONS(3058), 1,
      anon_sym_BSLASH,
    ACTIONS(3060), 1,
      anon_sym_u03bb,
    ACTIONS(3064), 1,
      anon_sym_record,
    ACTIONS(3066), 1,
      anon_sym_LPAREN,
    ACTIONS(3068), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3070), 1,
      anon_sym_u2983,
    ACTIONS(3072), 1,
      anon_sym_LBRACE,
    ACTIONS(3076), 1,
      aux_sym__qid_token1,
    ACTIONS(3078), 1,
      anon_sym_DOT,
    ACTIONS(3080), 1,
      anon_sym_tactic,
    ACTIONS(3082), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3084), 1,
      anon_sym_u2987,
    ACTIONS(3088), 1,
      anon_sym_Set,
    ACTIONS(4220), 1,
      sym_id,
    STATE(3403), 1,
      sym_attributes,
    STATE(3892), 1,
      aux_sym__atoms,
    STATE(6084), 1,
      sym__qid,
    STATE(6427), 1,
      sym_atom,
    STATE(8123), 1,
      sym__LAMBDA,
    STATE(8396), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3086), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6715), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6714), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3062), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9850), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [338139] = 33,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(1302), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    STATE(3494), 1,
      sym_attributes,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(12539), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [338265] = 33,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(964), 1,
      anon_sym_quoteGoal,
    ACTIONS(972), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4214), 1,
      anon_sym_BSLASH,
    ACTIONS(4216), 1,
      anon_sym_u03bb,
    ACTIONS(4218), 1,
      anon_sym_tactic,
    STATE(3443), 1,
      sym_attributes,
    STATE(3891), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8047), 1,
      sym__LAMBDA,
    STATE(8355), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(942), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10061), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [338391] = 33,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(964), 1,
      anon_sym_quoteGoal,
    ACTIONS(972), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4214), 1,
      anon_sym_BSLASH,
    ACTIONS(4216), 1,
      anon_sym_u03bb,
    ACTIONS(4218), 1,
      anon_sym_tactic,
    STATE(3541), 1,
      sym_attributes,
    STATE(3891), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8047), 1,
      sym__LAMBDA,
    STATE(8355), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(942), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9905), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [338517] = 33,
    ACTIONS(710), 1,
      anon_sym_DASH,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(920), 1,
      anon_sym_quoteGoal,
    ACTIONS(928), 1,
      anon_sym_let,
    ACTIONS(3058), 1,
      anon_sym_BSLASH,
    ACTIONS(3060), 1,
      anon_sym_u03bb,
    ACTIONS(3064), 1,
      anon_sym_record,
    ACTIONS(3066), 1,
      anon_sym_LPAREN,
    ACTIONS(3068), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3070), 1,
      anon_sym_u2983,
    ACTIONS(3072), 1,
      anon_sym_LBRACE,
    ACTIONS(3076), 1,
      aux_sym__qid_token1,
    ACTIONS(3078), 1,
      anon_sym_DOT,
    ACTIONS(3080), 1,
      anon_sym_tactic,
    ACTIONS(3082), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3084), 1,
      anon_sym_u2987,
    ACTIONS(3088), 1,
      anon_sym_Set,
    ACTIONS(4220), 1,
      sym_id,
    STATE(3464), 1,
      sym_attributes,
    STATE(3892), 1,
      aux_sym__atoms,
    STATE(6084), 1,
      sym__qid,
    STATE(6427), 1,
      sym_atom,
    STATE(8123), 1,
      sym__LAMBDA,
    STATE(8396), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3086), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6715), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6714), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3062), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9824), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [338643] = 33,
    ACTIONS(73), 1,
      anon_sym_AT,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(986), 1,
      anon_sym_open,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(992), 1,
      anon_sym_let,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4222), 1,
      sym_id,
    ACTIONS(4224), 1,
      aux_sym__qid_token1,
    STATE(3870), 1,
      sym_attributes,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(12555), 1,
      sym_open,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6309), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6169), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(12351), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [338769] = 33,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(878), 1,
      anon_sym_quoteGoal,
    ACTIONS(886), 1,
      anon_sym_let,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(4182), 1,
      sym_id,
    ACTIONS(4184), 1,
      anon_sym_BSLASH,
    ACTIONS(4186), 1,
      anon_sym_u03bb,
    ACTIONS(4190), 1,
      anon_sym_record,
    ACTIONS(4192), 1,
      anon_sym_LPAREN,
    ACTIONS(4194), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4196), 1,
      anon_sym_u2983,
    ACTIONS(4198), 1,
      anon_sym_LBRACE,
    ACTIONS(4200), 1,
      aux_sym__qid_token1,
    ACTIONS(4202), 1,
      anon_sym_DOT,
    ACTIONS(4204), 1,
      anon_sym_tactic,
    ACTIONS(4206), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4208), 1,
      anon_sym_u2987,
    ACTIONS(4212), 1,
      anon_sym_Set,
    STATE(3462), 1,
      sym_attributes,
    STATE(3888), 1,
      aux_sym__atoms,
    STATE(6121), 1,
      sym__qid,
    STATE(6386), 1,
      sym_atom,
    STATE(8067), 1,
      sym__LAMBDA,
    STATE(8369), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(852), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4210), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6575), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6565), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(4188), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9823), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [338895] = 33,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(878), 1,
      anon_sym_quoteGoal,
    ACTIONS(886), 1,
      anon_sym_let,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(4182), 1,
      sym_id,
    ACTIONS(4184), 1,
      anon_sym_BSLASH,
    ACTIONS(4186), 1,
      anon_sym_u03bb,
    ACTIONS(4190), 1,
      anon_sym_record,
    ACTIONS(4192), 1,
      anon_sym_LPAREN,
    ACTIONS(4194), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4196), 1,
      anon_sym_u2983,
    ACTIONS(4198), 1,
      anon_sym_LBRACE,
    ACTIONS(4200), 1,
      aux_sym__qid_token1,
    ACTIONS(4202), 1,
      anon_sym_DOT,
    ACTIONS(4204), 1,
      anon_sym_tactic,
    ACTIONS(4206), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4208), 1,
      anon_sym_u2987,
    ACTIONS(4212), 1,
      anon_sym_Set,
    STATE(3442), 1,
      sym_attributes,
    STATE(3888), 1,
      aux_sym__atoms,
    STATE(6121), 1,
      sym__qid,
    STATE(6386), 1,
      sym_atom,
    STATE(8067), 1,
      sym__LAMBDA,
    STATE(8369), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(852), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4210), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6575), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6565), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(4188), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10054), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [339021] = 33,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(964), 1,
      anon_sym_quoteGoal,
    ACTIONS(972), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4214), 1,
      anon_sym_BSLASH,
    ACTIONS(4216), 1,
      anon_sym_u03bb,
    ACTIONS(4218), 1,
      anon_sym_tactic,
    STATE(3547), 1,
      sym_attributes,
    STATE(3891), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8047), 1,
      sym__LAMBDA,
    STATE(8355), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(942), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10026), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [339147] = 33,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(878), 1,
      anon_sym_quoteGoal,
    ACTIONS(886), 1,
      anon_sym_let,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(4182), 1,
      sym_id,
    ACTIONS(4184), 1,
      anon_sym_BSLASH,
    ACTIONS(4186), 1,
      anon_sym_u03bb,
    ACTIONS(4190), 1,
      anon_sym_record,
    ACTIONS(4192), 1,
      anon_sym_LPAREN,
    ACTIONS(4194), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4196), 1,
      anon_sym_u2983,
    ACTIONS(4198), 1,
      anon_sym_LBRACE,
    ACTIONS(4200), 1,
      aux_sym__qid_token1,
    ACTIONS(4202), 1,
      anon_sym_DOT,
    ACTIONS(4204), 1,
      anon_sym_tactic,
    ACTIONS(4206), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4208), 1,
      anon_sym_u2987,
    ACTIONS(4212), 1,
      anon_sym_Set,
    STATE(3548), 1,
      sym_attributes,
    STATE(3888), 1,
      aux_sym__atoms,
    STATE(6121), 1,
      sym__qid,
    STATE(6386), 1,
      sym_atom,
    STATE(8067), 1,
      sym__LAMBDA,
    STATE(8369), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(852), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4210), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6575), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6565), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(4188), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10025), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [339273] = 33,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(964), 1,
      anon_sym_quoteGoal,
    ACTIONS(972), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4214), 1,
      anon_sym_BSLASH,
    ACTIONS(4216), 1,
      anon_sym_u03bb,
    ACTIONS(4218), 1,
      anon_sym_tactic,
    STATE(3431), 1,
      sym_attributes,
    STATE(3891), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8047), 1,
      sym__LAMBDA,
    STATE(8355), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(942), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10007), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [339399] = 33,
    ACTIONS(710), 1,
      anon_sym_DASH,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(920), 1,
      anon_sym_quoteGoal,
    ACTIONS(928), 1,
      anon_sym_let,
    ACTIONS(3058), 1,
      anon_sym_BSLASH,
    ACTIONS(3060), 1,
      anon_sym_u03bb,
    ACTIONS(3064), 1,
      anon_sym_record,
    ACTIONS(3066), 1,
      anon_sym_LPAREN,
    ACTIONS(3068), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3070), 1,
      anon_sym_u2983,
    ACTIONS(3072), 1,
      anon_sym_LBRACE,
    ACTIONS(3076), 1,
      aux_sym__qid_token1,
    ACTIONS(3078), 1,
      anon_sym_DOT,
    ACTIONS(3080), 1,
      anon_sym_tactic,
    ACTIONS(3082), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3084), 1,
      anon_sym_u2987,
    ACTIONS(3088), 1,
      anon_sym_Set,
    ACTIONS(4220), 1,
      sym_id,
    STATE(3697), 1,
      sym_attributes,
    STATE(3892), 1,
      aux_sym__atoms,
    STATE(6084), 1,
      sym__qid,
    STATE(6427), 1,
      sym_atom,
    STATE(8123), 1,
      sym__LAMBDA,
    STATE(8396), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3086), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6715), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6714), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3062), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10002), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [339525] = 33,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(878), 1,
      anon_sym_quoteGoal,
    ACTIONS(886), 1,
      anon_sym_let,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(4182), 1,
      sym_id,
    ACTIONS(4184), 1,
      anon_sym_BSLASH,
    ACTIONS(4186), 1,
      anon_sym_u03bb,
    ACTIONS(4190), 1,
      anon_sym_record,
    ACTIONS(4192), 1,
      anon_sym_LPAREN,
    ACTIONS(4194), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4196), 1,
      anon_sym_u2983,
    ACTIONS(4198), 1,
      anon_sym_LBRACE,
    ACTIONS(4200), 1,
      aux_sym__qid_token1,
    ACTIONS(4202), 1,
      anon_sym_DOT,
    ACTIONS(4204), 1,
      anon_sym_tactic,
    ACTIONS(4206), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4208), 1,
      anon_sym_u2987,
    ACTIONS(4212), 1,
      anon_sym_Set,
    STATE(3493), 1,
      sym_attributes,
    STATE(3888), 1,
      aux_sym__atoms,
    STATE(6121), 1,
      sym__qid,
    STATE(6386), 1,
      sym_atom,
    STATE(8067), 1,
      sym__LAMBDA,
    STATE(8369), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(852), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4210), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6575), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6565), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(4188), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10006), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [339651] = 33,
    ACTIONS(710), 1,
      anon_sym_DASH,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(920), 1,
      anon_sym_quoteGoal,
    ACTIONS(928), 1,
      anon_sym_let,
    ACTIONS(3058), 1,
      anon_sym_BSLASH,
    ACTIONS(3060), 1,
      anon_sym_u03bb,
    ACTIONS(3064), 1,
      anon_sym_record,
    ACTIONS(3066), 1,
      anon_sym_LPAREN,
    ACTIONS(3068), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3070), 1,
      anon_sym_u2983,
    ACTIONS(3072), 1,
      anon_sym_LBRACE,
    ACTIONS(3076), 1,
      aux_sym__qid_token1,
    ACTIONS(3078), 1,
      anon_sym_DOT,
    ACTIONS(3080), 1,
      anon_sym_tactic,
    ACTIONS(3082), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3084), 1,
      anon_sym_u2987,
    ACTIONS(3088), 1,
      anon_sym_Set,
    ACTIONS(4220), 1,
      sym_id,
    STATE(3441), 1,
      sym_attributes,
    STATE(3892), 1,
      aux_sym__atoms,
    STATE(6084), 1,
      sym__qid,
    STATE(6427), 1,
      sym_atom,
    STATE(8123), 1,
      sym__LAMBDA,
    STATE(8396), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3086), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6715), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6714), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3062), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10053), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [339777] = 33,
    ACTIONS(710), 1,
      anon_sym_DASH,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(920), 1,
      anon_sym_quoteGoal,
    ACTIONS(928), 1,
      anon_sym_let,
    ACTIONS(3058), 1,
      anon_sym_BSLASH,
    ACTIONS(3060), 1,
      anon_sym_u03bb,
    ACTIONS(3064), 1,
      anon_sym_record,
    ACTIONS(3066), 1,
      anon_sym_LPAREN,
    ACTIONS(3068), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3070), 1,
      anon_sym_u2983,
    ACTIONS(3072), 1,
      anon_sym_LBRACE,
    ACTIONS(3076), 1,
      aux_sym__qid_token1,
    ACTIONS(3078), 1,
      anon_sym_DOT,
    ACTIONS(3080), 1,
      anon_sym_tactic,
    ACTIONS(3082), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3084), 1,
      anon_sym_u2987,
    ACTIONS(3088), 1,
      anon_sym_Set,
    ACTIONS(4220), 1,
      sym_id,
    STATE(3552), 1,
      sym_attributes,
    STATE(3892), 1,
      aux_sym__atoms,
    STATE(6084), 1,
      sym__qid,
    STATE(6427), 1,
      sym_atom,
    STATE(8123), 1,
      sym__LAMBDA,
    STATE(8396), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3086), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6715), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6714), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3062), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10023), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [339903] = 33,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(878), 1,
      anon_sym_quoteGoal,
    ACTIONS(886), 1,
      anon_sym_let,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(4182), 1,
      sym_id,
    ACTIONS(4184), 1,
      anon_sym_BSLASH,
    ACTIONS(4186), 1,
      anon_sym_u03bb,
    ACTIONS(4190), 1,
      anon_sym_record,
    ACTIONS(4192), 1,
      anon_sym_LPAREN,
    ACTIONS(4194), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4196), 1,
      anon_sym_u2983,
    ACTIONS(4198), 1,
      anon_sym_LBRACE,
    ACTIONS(4200), 1,
      aux_sym__qid_token1,
    ACTIONS(4202), 1,
      anon_sym_DOT,
    ACTIONS(4204), 1,
      anon_sym_tactic,
    ACTIONS(4206), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4208), 1,
      anon_sym_u2987,
    ACTIONS(4212), 1,
      anon_sym_Set,
    STATE(3407), 1,
      sym_attributes,
    STATE(3888), 1,
      aux_sym__atoms,
    STATE(6121), 1,
      sym__qid,
    STATE(6386), 1,
      sym_atom,
    STATE(8067), 1,
      sym__LAMBDA,
    STATE(8369), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(852), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4210), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6575), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6565), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(4188), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10016), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [340029] = 33,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(1302), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    STATE(3496), 1,
      sym_attributes,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(12547), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [340155] = 33,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(964), 1,
      anon_sym_quoteGoal,
    ACTIONS(972), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4214), 1,
      anon_sym_BSLASH,
    ACTIONS(4216), 1,
      anon_sym_u03bb,
    ACTIONS(4218), 1,
      anon_sym_tactic,
    STATE(3379), 1,
      sym_attributes,
    STATE(3891), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8047), 1,
      sym__LAMBDA,
    STATE(8355), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(942), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9930), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [340281] = 33,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(878), 1,
      anon_sym_quoteGoal,
    ACTIONS(886), 1,
      anon_sym_let,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(4182), 1,
      sym_id,
    ACTIONS(4184), 1,
      anon_sym_BSLASH,
    ACTIONS(4186), 1,
      anon_sym_u03bb,
    ACTIONS(4190), 1,
      anon_sym_record,
    ACTIONS(4192), 1,
      anon_sym_LPAREN,
    ACTIONS(4194), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4196), 1,
      anon_sym_u2983,
    ACTIONS(4198), 1,
      anon_sym_LBRACE,
    ACTIONS(4200), 1,
      aux_sym__qid_token1,
    ACTIONS(4202), 1,
      anon_sym_DOT,
    ACTIONS(4204), 1,
      anon_sym_tactic,
    ACTIONS(4206), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4208), 1,
      anon_sym_u2987,
    ACTIONS(4212), 1,
      anon_sym_Set,
    STATE(3527), 1,
      sym_attributes,
    STATE(3888), 1,
      aux_sym__atoms,
    STATE(6121), 1,
      sym__qid,
    STATE(6386), 1,
      sym_atom,
    STATE(8067), 1,
      sym__LAMBDA,
    STATE(8369), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(852), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4210), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6575), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6565), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(4188), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9904), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [340407] = 33,
    ACTIONS(710), 1,
      anon_sym_DASH,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(920), 1,
      anon_sym_quoteGoal,
    ACTIONS(928), 1,
      anon_sym_let,
    ACTIONS(3058), 1,
      anon_sym_BSLASH,
    ACTIONS(3060), 1,
      anon_sym_u03bb,
    ACTIONS(3064), 1,
      anon_sym_record,
    ACTIONS(3066), 1,
      anon_sym_LPAREN,
    ACTIONS(3068), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3070), 1,
      anon_sym_u2983,
    ACTIONS(3072), 1,
      anon_sym_LBRACE,
    ACTIONS(3076), 1,
      aux_sym__qid_token1,
    ACTIONS(3078), 1,
      anon_sym_DOT,
    ACTIONS(3080), 1,
      anon_sym_tactic,
    ACTIONS(3082), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3084), 1,
      anon_sym_u2987,
    ACTIONS(3088), 1,
      anon_sym_Set,
    ACTIONS(4220), 1,
      sym_id,
    STATE(3500), 1,
      sym_attributes,
    STATE(3892), 1,
      aux_sym__atoms,
    STATE(6084), 1,
      sym__qid,
    STATE(6427), 1,
      sym_atom,
    STATE(8123), 1,
      sym__LAMBDA,
    STATE(8396), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3086), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6715), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6714), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3062), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9899), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [340533] = 33,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(1302), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    STATE(3495), 1,
      sym_attributes,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(12544), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [340659] = 33,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(964), 1,
      anon_sym_quoteGoal,
    ACTIONS(972), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4214), 1,
      anon_sym_BSLASH,
    ACTIONS(4216), 1,
      anon_sym_u03bb,
    ACTIONS(4218), 1,
      anon_sym_tactic,
    STATE(3460), 1,
      sym_attributes,
    STATE(3891), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8047), 1,
      sym__LAMBDA,
    STATE(8355), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(942), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5830), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9822), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [340785] = 33,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(734), 1,
      sym_id,
    ACTIONS(738), 1,
      anon_sym_BSLASH,
    ACTIONS(740), 1,
      anon_sym_u03bb,
    ACTIONS(744), 1,
      anon_sym_record,
    ACTIONS(754), 1,
      aux_sym__qid_token1,
    ACTIONS(762), 1,
      anon_sym_quoteGoal,
    ACTIONS(764), 1,
      anon_sym_tactic,
    ACTIONS(766), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(768), 1,
      anon_sym_u2987,
    ACTIONS(770), 1,
      anon_sym_let,
    ACTIONS(774), 1,
      anon_sym_Set,
    ACTIONS(4228), 1,
      anon_sym_LPAREN,
    ACTIONS(4230), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4232), 1,
      anon_sym_u2983,
    ACTIONS(4234), 1,
      anon_sym_LBRACE,
    ACTIONS(4236), 1,
      anon_sym_DOT,
    ACTIONS(4238), 1,
      anon_sym_PIPE,
    STATE(1907), 1,
      sym__ARROW,
    STATE(3982), 1,
      aux_sym__atoms,
    STATE(5147), 1,
      sym_atom,
    STATE(8156), 1,
      sym__LAMBDA,
    STATE(8456), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(736), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(772), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(4226), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(5108), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(8997), 2,
      sym__expr2,
      sym_let,
    STATE(10106), 2,
      sym__expr2_stmt,
      sym_let_in_do,
    STATE(9605), 5,
      sym__expr2_without_let,
      sym_forall,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    STATE(5102), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(742), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [340910] = 6,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(394), 1,
      anon_sym_BSLASH,
    ACTIONS(4242), 1,
      anon_sym_in,
    ACTIONS(4244), 1,
      sym__dedent,
    STATE(9668), 1,
      sym__let_body,
    ACTIONS(4240), 52,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_field,
      anon_sym_instance,
      anon_sym_module,
      anon_sym_data,
      anon_sym_codata,
      anon_sym_record,
      anon_sym_infix,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_variable,
      anon_sym_mutual,
      anon_sym_abstract,
      anon_sym_private,
      anon_sym_macro,
      anon_sym_postulate,
      anon_sym_primitive,
      anon_sym_open,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      sym_pragma,
      anon_sym_syntax,
      anon_sym_LBRACE,
      anon_sym_pattern,
      anon_sym_unquoteDecl,
      anon_sym_unquoteDef,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_AT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [340980] = 5,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(4246), 1,
      anon_sym_in,
    STATE(8938), 1,
      sym__let_body,
    ACTIONS(394), 2,
      sym__dedent,
      anon_sym_BSLASH,
    ACTIONS(4240), 52,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_field,
      anon_sym_instance,
      anon_sym_module,
      anon_sym_data,
      anon_sym_codata,
      anon_sym_record,
      anon_sym_infix,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_variable,
      anon_sym_mutual,
      anon_sym_abstract,
      anon_sym_private,
      anon_sym_macro,
      anon_sym_postulate,
      anon_sym_primitive,
      anon_sym_open,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      sym_pragma,
      anon_sym_syntax,
      anon_sym_LBRACE,
      anon_sym_pattern,
      anon_sym_unquoteDecl,
      anon_sym_unquoteDef,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_AT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [341048] = 31,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(738), 1,
      anon_sym_BSLASH,
    ACTIONS(740), 1,
      anon_sym_u03bb,
    ACTIONS(762), 1,
      anon_sym_quoteGoal,
    ACTIONS(764), 1,
      anon_sym_tactic,
    ACTIONS(770), 1,
      anon_sym_let,
    ACTIONS(4248), 1,
      sym_id,
    ACTIONS(4252), 1,
      anon_sym_record,
    ACTIONS(4254), 1,
      anon_sym_LPAREN,
    ACTIONS(4256), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4258), 1,
      anon_sym_u2983,
    ACTIONS(4260), 1,
      anon_sym_LBRACE,
    ACTIONS(4262), 1,
      aux_sym__qid_token1,
    ACTIONS(4264), 1,
      anon_sym_DOT,
    ACTIONS(4266), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4268), 1,
      anon_sym_u2987,
    ACTIONS(4272), 1,
      anon_sym_Set,
    STATE(3591), 1,
      aux_sym__atoms,
    STATE(4038), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5812), 1,
      sym_atom,
    STATE(8156), 1,
      sym__LAMBDA,
    STATE(8456), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(736), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4270), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5952), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(8995), 3,
      sym__application,
      sym__expr2,
      sym_let,
    STATE(10108), 3,
      sym__application_stmt,
      sym__expr2_stmt,
      sym_let_in_do,
    STATE(9605), 5,
      sym__expr2_without_let,
      sym_forall,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    STATE(5976), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(4250), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [341168] = 32,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(105), 1,
      sym_id,
    ACTIONS(109), 1,
      anon_sym_BSLASH,
    ACTIONS(111), 1,
      anon_sym_u03bb,
    ACTIONS(125), 1,
      anon_sym_LPAREN,
    ACTIONS(127), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(129), 1,
      anon_sym_u2983,
    ACTIONS(135), 1,
      anon_sym_LBRACE,
    ACTIONS(143), 1,
      aux_sym__qid_token1,
    ACTIONS(145), 1,
      anon_sym_DOT,
    ACTIONS(147), 1,
      anon_sym_quoteGoal,
    ACTIONS(149), 1,
      anon_sym_tactic,
    ACTIONS(151), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(153), 1,
      anon_sym_u2987,
    ACTIONS(155), 1,
      anon_sym_let,
    ACTIONS(159), 1,
      anon_sym_Set,
    ACTIONS(4274), 1,
      anon_sym_record,
    STATE(3734), 1,
      aux_sym__with_exprs_repeat1,
    STATE(3854), 1,
      aux_sym__atoms,
    STATE(4271), 1,
      sym_atom,
    STATE(8146), 1,
      sym__LAMBDA,
    STATE(8343), 1,
      sym__FORALL,
    STATE(8848), 1,
      sym__with_exprs,
    STATE(9059), 1,
      sym_lhs_defn,
    STATE(9114), 1,
      sym_lhs_decl,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(107), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(157), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4311), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4327), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(113), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [341290] = 6,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(394), 1,
      anon_sym_BSLASH,
    ACTIONS(4242), 1,
      anon_sym_in,
    ACTIONS(4276), 1,
      sym__dedent,
    STATE(9673), 1,
      sym__let_body,
    ACTIONS(4240), 52,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_field,
      anon_sym_instance,
      anon_sym_module,
      anon_sym_data,
      anon_sym_codata,
      anon_sym_record,
      anon_sym_infix,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_variable,
      anon_sym_mutual,
      anon_sym_abstract,
      anon_sym_private,
      anon_sym_macro,
      anon_sym_postulate,
      anon_sym_primitive,
      anon_sym_open,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      sym_pragma,
      anon_sym_syntax,
      anon_sym_LBRACE,
      anon_sym_pattern,
      anon_sym_unquoteDecl,
      anon_sym_unquoteDef,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_AT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [341360] = 6,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(394), 1,
      anon_sym_BSLASH,
    ACTIONS(4242), 1,
      anon_sym_in,
    ACTIONS(4278), 1,
      sym__dedent,
    STATE(9651), 1,
      sym__let_body,
    ACTIONS(4240), 52,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_field,
      anon_sym_instance,
      anon_sym_module,
      anon_sym_data,
      anon_sym_codata,
      anon_sym_record,
      anon_sym_infix,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_variable,
      anon_sym_mutual,
      anon_sym_abstract,
      anon_sym_private,
      anon_sym_macro,
      anon_sym_postulate,
      anon_sym_primitive,
      anon_sym_open,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      sym_pragma,
      anon_sym_syntax,
      anon_sym_LBRACE,
      anon_sym_pattern,
      anon_sym_unquoteDecl,
      anon_sym_unquoteDef,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_AT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [341430] = 5,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(4246), 1,
      anon_sym_in,
    STATE(8947), 1,
      sym__let_body,
    ACTIONS(394), 2,
      sym__dedent,
      anon_sym_BSLASH,
    ACTIONS(4240), 52,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_field,
      anon_sym_instance,
      anon_sym_module,
      anon_sym_data,
      anon_sym_codata,
      anon_sym_record,
      anon_sym_infix,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_variable,
      anon_sym_mutual,
      anon_sym_abstract,
      anon_sym_private,
      anon_sym_macro,
      anon_sym_postulate,
      anon_sym_primitive,
      anon_sym_open,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      sym_pragma,
      anon_sym_syntax,
      anon_sym_LBRACE,
      anon_sym_pattern,
      anon_sym_unquoteDecl,
      anon_sym_unquoteDef,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_AT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [341498] = 32,
    ACTIONS(9), 1,
      sym_id,
    ACTIONS(13), 1,
      anon_sym_BSLASH,
    ACTIONS(15), 1,
      anon_sym_u03bb,
    ACTIONS(51), 1,
      anon_sym_LPAREN,
    ACTIONS(53), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(55), 1,
      anon_sym_u2983,
    ACTIONS(61), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      aux_sym__qid_token1,
    ACTIONS(71), 1,
      anon_sym_DOT,
    ACTIONS(75), 1,
      anon_sym_quoteGoal,
    ACTIONS(77), 1,
      anon_sym_tactic,
    ACTIONS(79), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(81), 1,
      anon_sym_u2987,
    ACTIONS(83), 1,
      anon_sym_let,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(89), 1,
      anon_sym_Set,
    ACTIONS(4280), 1,
      anon_sym_record,
    STATE(3710), 1,
      aux_sym__with_exprs_repeat1,
    STATE(3848), 1,
      aux_sym__atoms,
    STATE(4600), 1,
      sym_atom,
    STATE(8114), 1,
      sym__LAMBDA,
    STATE(8288), 1,
      sym__FORALL,
    STATE(8953), 1,
      sym__with_exprs,
    STATE(9145), 1,
      sym_lhs_decl,
    STATE(9152), 1,
      sym_lhs_defn,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(11), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(87), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4564), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4608), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(17), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [341620] = 30,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2022), 1,
      anon_sym_BSLASH,
    ACTIONS(2024), 1,
      anon_sym_u03bb,
    ACTIONS(2042), 1,
      anon_sym_quoteGoal,
    ACTIONS(2044), 1,
      anon_sym_tactic,
    ACTIONS(2050), 1,
      anon_sym_let,
    ACTIONS(2766), 1,
      sym_id,
    ACTIONS(2772), 1,
      anon_sym_record,
    ACTIONS(2774), 1,
      anon_sym_LPAREN,
    ACTIONS(2776), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2778), 1,
      anon_sym_u2983,
    ACTIONS(2780), 1,
      anon_sym_LBRACE,
    ACTIONS(2782), 1,
      aux_sym__qid_token1,
    ACTIONS(2784), 1,
      anon_sym_DOT,
    ACTIONS(2786), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2788), 1,
      anon_sym_u2987,
    ACTIONS(2792), 1,
      anon_sym_Set,
    STATE(1495), 1,
      sym__ARROW,
    STATE(3665), 1,
      aux_sym__atoms,
    STATE(5719), 1,
      sym_atom,
    STATE(8033), 1,
      sym__LAMBDA,
    STATE(8463), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2020), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2790), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(4282), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(5666), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5668), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8968), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2770), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [341737] = 5,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(394), 1,
      anon_sym_BSLASH,
    ACTIONS(4284), 1,
      anon_sym_in,
    STATE(8947), 1,
      sym__let_body,
    ACTIONS(4240), 52,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_field,
      anon_sym_instance,
      anon_sym_module,
      anon_sym_data,
      anon_sym_codata,
      anon_sym_record,
      anon_sym_infix,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_variable,
      anon_sym_mutual,
      anon_sym_abstract,
      anon_sym_private,
      anon_sym_macro,
      anon_sym_postulate,
      anon_sym_primitive,
      anon_sym_open,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      sym_pragma,
      anon_sym_syntax,
      anon_sym_LBRACE,
      anon_sym_pattern,
      anon_sym_unquoteDecl,
      anon_sym_unquoteDef,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_AT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [341804] = 30,
    ACTIONS(686), 1,
      anon_sym_BSLASH,
    ACTIONS(688), 1,
      anon_sym_u03bb,
    ACTIONS(692), 1,
      anon_sym_record,
    ACTIONS(694), 1,
      anon_sym_LPAREN,
    ACTIONS(696), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(698), 1,
      anon_sym_u2983,
    ACTIONS(702), 1,
      anon_sym_LBRACE,
    ACTIONS(708), 1,
      anon_sym_DOT,
    ACTIONS(714), 1,
      anon_sym_quoteGoal,
    ACTIONS(716), 1,
      anon_sym_tactic,
    ACTIONS(718), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(720), 1,
      anon_sym_u2987,
    ACTIONS(722), 1,
      anon_sym_let,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(728), 1,
      anon_sym_Set,
    ACTIONS(2336), 1,
      sym_id,
    ACTIONS(2342), 1,
      aux_sym__qid_token1,
    STATE(2596), 1,
      sym__ARROW,
    STATE(3603), 1,
      aux_sym__atoms,
    STATE(5128), 1,
      sym_atom,
    STATE(8064), 1,
      sym__LAMBDA,
    STATE(8495), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(682), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(726), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(4286), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(5069), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5056), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8968), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(690), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [341921] = 31,
    ACTIONS(850), 1,
      sym_id,
    ACTIONS(854), 1,
      anon_sym_BSLASH,
    ACTIONS(856), 1,
      anon_sym_u03bb,
    ACTIONS(860), 1,
      anon_sym_record,
    ACTIONS(872), 1,
      aux_sym__qid_token1,
    ACTIONS(878), 1,
      anon_sym_quoteGoal,
    ACTIONS(880), 1,
      anon_sym_tactic,
    ACTIONS(882), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(884), 1,
      anon_sym_u2987,
    ACTIONS(886), 1,
      anon_sym_let,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(892), 1,
      anon_sym_Set,
    ACTIONS(4238), 1,
      anon_sym_PIPE,
    ACTIONS(4290), 1,
      anon_sym_LPAREN,
    ACTIONS(4292), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4294), 1,
      anon_sym_u2983,
    ACTIONS(4296), 1,
      anon_sym_LBRACE,
    ACTIONS(4298), 1,
      anon_sym_DOT,
    STATE(2479), 1,
      sym__ARROW,
    STATE(3982), 1,
      aux_sym__atoms,
    STATE(5204), 1,
      sym_atom,
    STATE(8152), 1,
      sym__LAMBDA,
    STATE(8369), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(852), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(890), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(4288), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(5180), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5168), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8997), 7,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(858), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [342040] = 30,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2448), 1,
      anon_sym_quoteGoal,
    ACTIONS(2456), 1,
      anon_sym_let,
    ACTIONS(2842), 1,
      anon_sym_BSLASH,
    ACTIONS(2844), 1,
      anon_sym_u03bb,
    ACTIONS(2862), 1,
      anon_sym_tactic,
    ACTIONS(2872), 1,
      sym_id,
    ACTIONS(2876), 1,
      anon_sym_record,
    ACTIONS(2878), 1,
      anon_sym_LPAREN,
    ACTIONS(2880), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2882), 1,
      anon_sym_u2983,
    ACTIONS(2884), 1,
      anon_sym_LBRACE,
    ACTIONS(2886), 1,
      aux_sym__qid_token1,
    ACTIONS(2888), 1,
      anon_sym_DOT,
    ACTIONS(2890), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2892), 1,
      anon_sym_u2987,
    ACTIONS(2896), 1,
      anon_sym_Set,
    STATE(1578), 1,
      sym__ARROW,
    STATE(3576), 1,
      aux_sym__atoms,
    STATE(4945), 1,
      sym_atom,
    STATE(8053), 1,
      sym__LAMBDA,
    STATE(8423), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2424), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2894), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(4300), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(5291), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5287), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8968), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2874), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [342157] = 30,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1916), 1,
      anon_sym_record,
    ACTIONS(1918), 1,
      anon_sym_LPAREN,
    ACTIONS(1920), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1922), 1,
      anon_sym_u2983,
    ACTIONS(1924), 1,
      anon_sym_LBRACE,
    ACTIONS(1932), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1934), 1,
      anon_sym_u2987,
    ACTIONS(2120), 1,
      anon_sym_quoteGoal,
    ACTIONS(2128), 1,
      anon_sym_let,
    ACTIONS(2176), 1,
      anon_sym_BSLASH,
    ACTIONS(2178), 1,
      anon_sym_u03bb,
    ACTIONS(2196), 1,
      anon_sym_tactic,
    ACTIONS(2606), 1,
      sym_id,
    ACTIONS(2608), 1,
      aux_sym__qid_token1,
    ACTIONS(2610), 1,
      anon_sym_DOT,
    ACTIONS(2612), 1,
      anon_sym_Set,
    STATE(1481), 1,
      sym__ARROW,
    STATE(3690), 1,
      aux_sym__atoms,
    STATE(4914), 1,
      sym_atom,
    STATE(8044), 1,
      sym__LAMBDA,
    STATE(8428), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1938), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(2096), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4302), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(4675), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4679), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9472), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1914), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [342274] = 31,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(2978), 1,
      sym_id,
    ACTIONS(2982), 1,
      anon_sym_BSLASH,
    ACTIONS(2984), 1,
      anon_sym_u03bb,
    ACTIONS(2988), 1,
      anon_sym_record,
    ACTIONS(2998), 1,
      aux_sym__qid_token1,
    ACTIONS(3002), 1,
      anon_sym_quoteGoal,
    ACTIONS(3004), 1,
      anon_sym_tactic,
    ACTIONS(3006), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3008), 1,
      anon_sym_u2987,
    ACTIONS(3010), 1,
      anon_sym_let,
    ACTIONS(3014), 1,
      anon_sym_Set,
    ACTIONS(4238), 1,
      anon_sym_PIPE,
    ACTIONS(4306), 1,
      anon_sym_LPAREN,
    ACTIONS(4308), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4310), 1,
      anon_sym_u2983,
    ACTIONS(4312), 1,
      anon_sym_LBRACE,
    ACTIONS(4314), 1,
      anon_sym_DOT,
    STATE(2071), 1,
      sym__ARROW,
    STATE(3982), 1,
      aux_sym__atoms,
    STATE(4529), 1,
      sym_atom,
    STATE(8117), 1,
      sym__LAMBDA,
    STATE(8511), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3012), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(4304), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(4469), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4463), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9001), 7,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2986), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [342393] = 5,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(394), 1,
      anon_sym_BSLASH,
    ACTIONS(4316), 1,
      anon_sym_in,
    STATE(8976), 1,
      sym__let_body,
    ACTIONS(4240), 52,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_field,
      anon_sym_instance,
      anon_sym_module,
      anon_sym_data,
      anon_sym_codata,
      anon_sym_record,
      anon_sym_infix,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_variable,
      anon_sym_mutual,
      anon_sym_abstract,
      anon_sym_private,
      anon_sym_macro,
      anon_sym_postulate,
      anon_sym_primitive,
      anon_sym_open,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      sym_pragma,
      anon_sym_syntax,
      anon_sym_LBRACE,
      anon_sym_pattern,
      anon_sym_unquoteDecl,
      anon_sym_unquoteDef,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_AT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [342460] = 31,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(894), 1,
      sym_id,
    ACTIONS(898), 1,
      anon_sym_BSLASH,
    ACTIONS(900), 1,
      anon_sym_u03bb,
    ACTIONS(904), 1,
      anon_sym_record,
    ACTIONS(916), 1,
      aux_sym__qid_token1,
    ACTIONS(920), 1,
      anon_sym_quoteGoal,
    ACTIONS(922), 1,
      anon_sym_tactic,
    ACTIONS(924), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(926), 1,
      anon_sym_u2987,
    ACTIONS(928), 1,
      anon_sym_let,
    ACTIONS(932), 1,
      anon_sym_Set,
    ACTIONS(4238), 1,
      anon_sym_PIPE,
    ACTIONS(4320), 1,
      anon_sym_LPAREN,
    ACTIONS(4322), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4324), 1,
      anon_sym_u2983,
    ACTIONS(4326), 1,
      anon_sym_LBRACE,
    ACTIONS(4328), 1,
      anon_sym_DOT,
    STATE(2292), 1,
      sym__ARROW,
    STATE(3982), 1,
      aux_sym__atoms,
    STATE(5202), 1,
      sym_atom,
    STATE(8031), 1,
      sym__LAMBDA,
    STATE(8396), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(930), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(4318), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(4961), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4920), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9454), 7,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(902), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [342579] = 5,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(394), 1,
      anon_sym_BSLASH,
    ACTIONS(4330), 1,
      anon_sym_in,
    STATE(8994), 1,
      sym__let_body,
    ACTIONS(4240), 52,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_field,
      anon_sym_instance,
      anon_sym_module,
      anon_sym_data,
      anon_sym_codata,
      anon_sym_record,
      anon_sym_infix,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_variable,
      anon_sym_mutual,
      anon_sym_abstract,
      anon_sym_private,
      anon_sym_macro,
      anon_sym_postulate,
      anon_sym_primitive,
      anon_sym_open,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      sym_pragma,
      anon_sym_syntax,
      anon_sym_LBRACE,
      anon_sym_pattern,
      anon_sym_unquoteDecl,
      anon_sym_unquoteDef,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_AT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [342646] = 5,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(394), 1,
      anon_sym_BSLASH,
    ACTIONS(4332), 1,
      anon_sym_in,
    STATE(8944), 1,
      sym__let_body,
    ACTIONS(4240), 52,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_field,
      anon_sym_instance,
      anon_sym_module,
      anon_sym_data,
      anon_sym_codata,
      anon_sym_record,
      anon_sym_infix,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_variable,
      anon_sym_mutual,
      anon_sym_abstract,
      anon_sym_private,
      anon_sym_macro,
      anon_sym_postulate,
      anon_sym_primitive,
      anon_sym_open,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      sym_pragma,
      anon_sym_syntax,
      anon_sym_LBRACE,
      anon_sym_pattern,
      anon_sym_unquoteDecl,
      anon_sym_unquoteDef,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_AT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [342713] = 5,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(394), 1,
      anon_sym_BSLASH,
    ACTIONS(4332), 1,
      anon_sym_in,
    STATE(8994), 1,
      sym__let_body,
    ACTIONS(4240), 52,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_field,
      anon_sym_instance,
      anon_sym_module,
      anon_sym_data,
      anon_sym_codata,
      anon_sym_record,
      anon_sym_infix,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_variable,
      anon_sym_mutual,
      anon_sym_abstract,
      anon_sym_private,
      anon_sym_macro,
      anon_sym_postulate,
      anon_sym_primitive,
      anon_sym_open,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      sym_pragma,
      anon_sym_syntax,
      anon_sym_LBRACE,
      anon_sym_pattern,
      anon_sym_unquoteDecl,
      anon_sym_unquoteDef,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_AT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [342780] = 5,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(394), 1,
      anon_sym_BSLASH,
    ACTIONS(4332), 1,
      anon_sym_in,
    STATE(8943), 1,
      sym__let_body,
    ACTIONS(4240), 52,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_field,
      anon_sym_instance,
      anon_sym_module,
      anon_sym_data,
      anon_sym_codata,
      anon_sym_record,
      anon_sym_infix,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_variable,
      anon_sym_mutual,
      anon_sym_abstract,
      anon_sym_private,
      anon_sym_macro,
      anon_sym_postulate,
      anon_sym_primitive,
      anon_sym_open,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      sym_pragma,
      anon_sym_syntax,
      anon_sym_LBRACE,
      anon_sym_pattern,
      anon_sym_unquoteDecl,
      anon_sym_unquoteDef,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_AT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [342847] = 5,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(394), 1,
      anon_sym_BSLASH,
    ACTIONS(4330), 1,
      anon_sym_in,
    STATE(8944), 1,
      sym__let_body,
    ACTIONS(4240), 52,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_field,
      anon_sym_instance,
      anon_sym_module,
      anon_sym_data,
      anon_sym_codata,
      anon_sym_record,
      anon_sym_infix,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_variable,
      anon_sym_mutual,
      anon_sym_abstract,
      anon_sym_private,
      anon_sym_macro,
      anon_sym_postulate,
      anon_sym_primitive,
      anon_sym_open,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      sym_pragma,
      anon_sym_syntax,
      anon_sym_LBRACE,
      anon_sym_pattern,
      anon_sym_unquoteDecl,
      anon_sym_unquoteDef,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_AT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [342914] = 31,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(3096), 1,
      anon_sym_BSLASH,
    ACTIONS(3098), 1,
      anon_sym_u03bb,
    ACTIONS(3116), 1,
      anon_sym_quoteGoal,
    ACTIONS(3118), 1,
      anon_sym_tactic,
    ACTIONS(3124), 1,
      anon_sym_let,
    ACTIONS(3354), 1,
      sym_id,
    ACTIONS(3358), 1,
      anon_sym_record,
    ACTIONS(3368), 1,
      aux_sym__qid_token1,
    ACTIONS(3372), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3374), 1,
      anon_sym_u2987,
    ACTIONS(3378), 1,
      anon_sym_Set,
    ACTIONS(4238), 1,
      anon_sym_PIPE,
    ACTIONS(4336), 1,
      anon_sym_LPAREN,
    ACTIONS(4338), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4340), 1,
      anon_sym_u2983,
    ACTIONS(4342), 1,
      anon_sym_LBRACE,
    ACTIONS(4344), 1,
      anon_sym_DOT,
    STATE(2282), 1,
      sym__ARROW,
    STATE(3982), 1,
      aux_sym__atoms,
    STATE(4227), 1,
      sym_atom,
    STATE(8099), 1,
      sym__LAMBDA,
    STATE(8393), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3092), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3376), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(4334), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(4178), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4177), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9001), 7,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3356), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [343033] = 5,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(394), 1,
      anon_sym_BSLASH,
    ACTIONS(4346), 1,
      anon_sym_in,
    STATE(8943), 1,
      sym__let_body,
    ACTIONS(4240), 52,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_field,
      anon_sym_instance,
      anon_sym_module,
      anon_sym_data,
      anon_sym_codata,
      anon_sym_record,
      anon_sym_infix,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_variable,
      anon_sym_mutual,
      anon_sym_abstract,
      anon_sym_private,
      anon_sym_macro,
      anon_sym_postulate,
      anon_sym_primitive,
      anon_sym_open,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      sym_pragma,
      anon_sym_syntax,
      anon_sym_LBRACE,
      anon_sym_pattern,
      anon_sym_unquoteDecl,
      anon_sym_unquoteDef,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_AT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [343100] = 5,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(394), 1,
      anon_sym_BSLASH,
    ACTIONS(4348), 1,
      anon_sym_in,
    STATE(8947), 1,
      sym__let_body,
    ACTIONS(4240), 52,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_field,
      anon_sym_instance,
      anon_sym_module,
      anon_sym_data,
      anon_sym_codata,
      anon_sym_record,
      anon_sym_infix,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_variable,
      anon_sym_mutual,
      anon_sym_abstract,
      anon_sym_private,
      anon_sym_macro,
      anon_sym_postulate,
      anon_sym_primitive,
      anon_sym_open,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      sym_pragma,
      anon_sym_syntax,
      anon_sym_LBRACE,
      anon_sym_pattern,
      anon_sym_unquoteDecl,
      anon_sym_unquoteDef,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_AT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [343167] = 5,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(394), 1,
      anon_sym_BSLASH,
    ACTIONS(4350), 1,
      anon_sym_in,
    STATE(8943), 1,
      sym__let_body,
    ACTIONS(4240), 52,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_field,
      anon_sym_instance,
      anon_sym_module,
      anon_sym_data,
      anon_sym_codata,
      anon_sym_record,
      anon_sym_infix,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_variable,
      anon_sym_mutual,
      anon_sym_abstract,
      anon_sym_private,
      anon_sym_macro,
      anon_sym_postulate,
      anon_sym_primitive,
      anon_sym_open,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      sym_pragma,
      anon_sym_syntax,
      anon_sym_LBRACE,
      anon_sym_pattern,
      anon_sym_unquoteDecl,
      anon_sym_unquoteDef,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_AT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [343234] = 31,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(3262), 1,
      sym_id,
    ACTIONS(3266), 1,
      anon_sym_BSLASH,
    ACTIONS(3268), 1,
      anon_sym_u03bb,
    ACTIONS(3272), 1,
      anon_sym_record,
    ACTIONS(3282), 1,
      aux_sym__qid_token1,
    ACTIONS(3286), 1,
      anon_sym_quoteGoal,
    ACTIONS(3288), 1,
      anon_sym_tactic,
    ACTIONS(3290), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3292), 1,
      anon_sym_u2987,
    ACTIONS(3294), 1,
      anon_sym_let,
    ACTIONS(3298), 1,
      anon_sym_Set,
    ACTIONS(4238), 1,
      anon_sym_PIPE,
    ACTIONS(4354), 1,
      anon_sym_LPAREN,
    ACTIONS(4356), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4358), 1,
      anon_sym_u2983,
    ACTIONS(4360), 1,
      anon_sym_LBRACE,
    ACTIONS(4362), 1,
      anon_sym_DOT,
    STATE(1732), 1,
      sym__ARROW,
    STATE(3982), 1,
      aux_sym__atoms,
    STATE(4014), 1,
      sym_atom,
    STATE(8143), 1,
      sym__LAMBDA,
    STATE(8451), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3264), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3296), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(4352), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(4032), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4012), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9001), 7,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3270), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [343353] = 5,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(394), 1,
      anon_sym_BSLASH,
    ACTIONS(4364), 1,
      anon_sym_in,
    STATE(8947), 1,
      sym__let_body,
    ACTIONS(4240), 52,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_field,
      anon_sym_instance,
      anon_sym_module,
      anon_sym_data,
      anon_sym_codata,
      anon_sym_record,
      anon_sym_infix,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_variable,
      anon_sym_mutual,
      anon_sym_abstract,
      anon_sym_private,
      anon_sym_macro,
      anon_sym_postulate,
      anon_sym_primitive,
      anon_sym_open,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      sym_pragma,
      anon_sym_syntax,
      anon_sym_LBRACE,
      anon_sym_pattern,
      anon_sym_unquoteDecl,
      anon_sym_unquoteDef,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_AT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [343420] = 5,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(394), 1,
      anon_sym_BSLASH,
    ACTIONS(4364), 1,
      anon_sym_in,
    STATE(8938), 1,
      sym__let_body,
    ACTIONS(4240), 52,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_field,
      anon_sym_instance,
      anon_sym_module,
      anon_sym_data,
      anon_sym_codata,
      anon_sym_record,
      anon_sym_infix,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_variable,
      anon_sym_mutual,
      anon_sym_abstract,
      anon_sym_private,
      anon_sym_macro,
      anon_sym_postulate,
      anon_sym_primitive,
      anon_sym_open,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      sym_pragma,
      anon_sym_syntax,
      anon_sym_LBRACE,
      anon_sym_pattern,
      anon_sym_unquoteDecl,
      anon_sym_unquoteDef,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_AT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [343487] = 31,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(3130), 1,
      sym_id,
    ACTIONS(3134), 1,
      anon_sym_BSLASH,
    ACTIONS(3136), 1,
      anon_sym_u03bb,
    ACTIONS(3140), 1,
      anon_sym_record,
    ACTIONS(3150), 1,
      aux_sym__qid_token1,
    ACTIONS(3154), 1,
      anon_sym_quoteGoal,
    ACTIONS(3156), 1,
      anon_sym_tactic,
    ACTIONS(3158), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3160), 1,
      anon_sym_u2987,
    ACTIONS(3162), 1,
      anon_sym_let,
    ACTIONS(3166), 1,
      anon_sym_Set,
    ACTIONS(4238), 1,
      anon_sym_PIPE,
    ACTIONS(4368), 1,
      anon_sym_LPAREN,
    ACTIONS(4370), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4372), 1,
      anon_sym_u2983,
    ACTIONS(4374), 1,
      anon_sym_LBRACE,
    ACTIONS(4376), 1,
      anon_sym_DOT,
    STATE(1667), 1,
      sym__ARROW,
    STATE(3982), 1,
      aux_sym__atoms,
    STATE(4518), 1,
      sym_atom,
    STATE(8076), 1,
      sym__LAMBDA,
    STATE(8363), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3132), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3164), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(4366), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(4493), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4496), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9001), 7,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3138), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [343606] = 5,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(394), 1,
      anon_sym_BSLASH,
    ACTIONS(4378), 1,
      anon_sym_in,
    STATE(8994), 1,
      sym__let_body,
    ACTIONS(4240), 52,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_field,
      anon_sym_instance,
      anon_sym_module,
      anon_sym_data,
      anon_sym_codata,
      anon_sym_record,
      anon_sym_infix,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_variable,
      anon_sym_mutual,
      anon_sym_abstract,
      anon_sym_private,
      anon_sym_macro,
      anon_sym_postulate,
      anon_sym_primitive,
      anon_sym_open,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      sym_pragma,
      anon_sym_syntax,
      anon_sym_LBRACE,
      anon_sym_pattern,
      anon_sym_unquoteDecl,
      anon_sym_unquoteDef,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_AT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [343673] = 5,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(394), 1,
      anon_sym_BSLASH,
    ACTIONS(4380), 1,
      anon_sym_in,
    STATE(9480), 1,
      sym__let_body,
    ACTIONS(4240), 52,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_field,
      anon_sym_instance,
      anon_sym_module,
      anon_sym_data,
      anon_sym_codata,
      anon_sym_record,
      anon_sym_infix,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_variable,
      anon_sym_mutual,
      anon_sym_abstract,
      anon_sym_private,
      anon_sym_macro,
      anon_sym_postulate,
      anon_sym_primitive,
      anon_sym_open,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      sym_pragma,
      anon_sym_syntax,
      anon_sym_LBRACE,
      anon_sym_pattern,
      anon_sym_unquoteDecl,
      anon_sym_unquoteDef,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_AT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [343740] = 5,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(394), 1,
      anon_sym_BSLASH,
    ACTIONS(4330), 1,
      anon_sym_in,
    STATE(8943), 1,
      sym__let_body,
    ACTIONS(4240), 52,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_field,
      anon_sym_instance,
      anon_sym_module,
      anon_sym_data,
      anon_sym_codata,
      anon_sym_record,
      anon_sym_infix,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_variable,
      anon_sym_mutual,
      anon_sym_abstract,
      anon_sym_private,
      anon_sym_macro,
      anon_sym_postulate,
      anon_sym_primitive,
      anon_sym_open,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      sym_pragma,
      anon_sym_syntax,
      anon_sym_LBRACE,
      anon_sym_pattern,
      anon_sym_unquoteDecl,
      anon_sym_unquoteDef,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_AT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [343807] = 5,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(394), 1,
      anon_sym_BSLASH,
    ACTIONS(4382), 1,
      anon_sym_in,
    STATE(8943), 1,
      sym__let_body,
    ACTIONS(4240), 52,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_field,
      anon_sym_instance,
      anon_sym_module,
      anon_sym_data,
      anon_sym_codata,
      anon_sym_record,
      anon_sym_infix,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_variable,
      anon_sym_mutual,
      anon_sym_abstract,
      anon_sym_private,
      anon_sym_macro,
      anon_sym_postulate,
      anon_sym_primitive,
      anon_sym_open,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      sym_pragma,
      anon_sym_syntax,
      anon_sym_LBRACE,
      anon_sym_pattern,
      anon_sym_unquoteDecl,
      anon_sym_unquoteDef,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_AT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [343874] = 31,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1980), 1,
      sym_id,
    ACTIONS(1984), 1,
      anon_sym_BSLASH,
    ACTIONS(1986), 1,
      anon_sym_u03bb,
    ACTIONS(1990), 1,
      anon_sym_record,
    ACTIONS(2000), 1,
      aux_sym__qid_token1,
    ACTIONS(2004), 1,
      anon_sym_quoteGoal,
    ACTIONS(2006), 1,
      anon_sym_tactic,
    ACTIONS(2008), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2010), 1,
      anon_sym_u2987,
    ACTIONS(2012), 1,
      anon_sym_let,
    ACTIONS(2016), 1,
      anon_sym_Set,
    ACTIONS(4238), 1,
      anon_sym_PIPE,
    ACTIONS(4386), 1,
      anon_sym_LPAREN,
    ACTIONS(4388), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4390), 1,
      anon_sym_u2983,
    ACTIONS(4392), 1,
      anon_sym_LBRACE,
    ACTIONS(4394), 1,
      anon_sym_DOT,
    STATE(1706), 1,
      sym__ARROW,
    STATE(3982), 1,
      aux_sym__atoms,
    STATE(4972), 1,
      sym_atom,
    STATE(8039), 1,
      sym__LAMBDA,
    STATE(8483), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1982), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2014), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(4384), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(5336), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5185), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8997), 7,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1988), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [343993] = 5,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(394), 1,
      anon_sym_BSLASH,
    ACTIONS(4378), 1,
      anon_sym_in,
    STATE(8944), 1,
      sym__let_body,
    ACTIONS(4240), 52,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_field,
      anon_sym_instance,
      anon_sym_module,
      anon_sym_data,
      anon_sym_codata,
      anon_sym_record,
      anon_sym_infix,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_variable,
      anon_sym_mutual,
      anon_sym_abstract,
      anon_sym_private,
      anon_sym_macro,
      anon_sym_postulate,
      anon_sym_primitive,
      anon_sym_open,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      sym_pragma,
      anon_sym_syntax,
      anon_sym_LBRACE,
      anon_sym_pattern,
      anon_sym_unquoteDecl,
      anon_sym_unquoteDef,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_AT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [344060] = 31,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(1282), 1,
      anon_sym_Set,
    ACTIONS(4238), 1,
      anon_sym_PIPE,
    ACTIONS(4396), 1,
      anon_sym_LPAREN,
    ACTIONS(4398), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4400), 1,
      anon_sym_u2983,
    ACTIONS(4402), 1,
      anon_sym_LBRACE,
    ACTIONS(4404), 1,
      anon_sym_DOT,
    STATE(2479), 1,
      sym__ARROW,
    STATE(3982), 1,
      aux_sym__atoms,
    STATE(5430), 1,
      sym_atom,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(4288), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8997), 7,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [344179] = 5,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(394), 1,
      anon_sym_BSLASH,
    ACTIONS(4406), 1,
      anon_sym_in,
    STATE(8994), 1,
      sym__let_body,
    ACTIONS(4240), 52,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_field,
      anon_sym_instance,
      anon_sym_module,
      anon_sym_data,
      anon_sym_codata,
      anon_sym_record,
      anon_sym_infix,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_variable,
      anon_sym_mutual,
      anon_sym_abstract,
      anon_sym_private,
      anon_sym_macro,
      anon_sym_postulate,
      anon_sym_primitive,
      anon_sym_open,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      sym_pragma,
      anon_sym_syntax,
      anon_sym_LBRACE,
      anon_sym_pattern,
      anon_sym_unquoteDecl,
      anon_sym_unquoteDef,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_AT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [344246] = 5,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(394), 1,
      anon_sym_BSLASH,
    ACTIONS(4408), 1,
      anon_sym_in,
    STATE(8938), 1,
      sym__let_body,
    ACTIONS(4240), 52,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_field,
      anon_sym_instance,
      anon_sym_module,
      anon_sym_data,
      anon_sym_codata,
      anon_sym_record,
      anon_sym_infix,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_variable,
      anon_sym_mutual,
      anon_sym_abstract,
      anon_sym_private,
      anon_sym_macro,
      anon_sym_postulate,
      anon_sym_primitive,
      anon_sym_open,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      sym_pragma,
      anon_sym_syntax,
      anon_sym_LBRACE,
      anon_sym_pattern,
      anon_sym_unquoteDecl,
      anon_sym_unquoteDef,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_AT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [344313] = 5,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(394), 1,
      anon_sym_BSLASH,
    ACTIONS(4408), 1,
      anon_sym_in,
    STATE(8947), 1,
      sym__let_body,
    ACTIONS(4240), 52,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_field,
      anon_sym_instance,
      anon_sym_module,
      anon_sym_data,
      anon_sym_codata,
      anon_sym_record,
      anon_sym_infix,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_variable,
      anon_sym_mutual,
      anon_sym_abstract,
      anon_sym_private,
      anon_sym_macro,
      anon_sym_postulate,
      anon_sym_primitive,
      anon_sym_open,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      sym_pragma,
      anon_sym_syntax,
      anon_sym_LBRACE,
      anon_sym_pattern,
      anon_sym_unquoteDecl,
      anon_sym_unquoteDef,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_AT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [344380] = 31,
    ACTIONS(714), 1,
      anon_sym_quoteGoal,
    ACTIONS(722), 1,
      anon_sym_let,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(3556), 1,
      anon_sym_BSLASH,
    ACTIONS(3558), 1,
      anon_sym_u03bb,
    ACTIONS(3574), 1,
      anon_sym_tactic,
    ACTIONS(3912), 1,
      sym_id,
    ACTIONS(3916), 1,
      anon_sym_record,
    ACTIONS(3926), 1,
      aux_sym__qid_token1,
    ACTIONS(3930), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3932), 1,
      anon_sym_u2987,
    ACTIONS(3936), 1,
      anon_sym_Set,
    ACTIONS(4238), 1,
      anon_sym_PIPE,
    ACTIONS(4412), 1,
      anon_sym_LPAREN,
    ACTIONS(4414), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4416), 1,
      anon_sym_u2983,
    ACTIONS(4418), 1,
      anon_sym_LBRACE,
    ACTIONS(4420), 1,
      anon_sym_DOT,
    STATE(2445), 1,
      sym__ARROW,
    STATE(3982), 1,
      aux_sym__atoms,
    STATE(4664), 1,
      sym_atom,
    STATE(8092), 1,
      sym__LAMBDA,
    STATE(8495), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(682), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3934), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(4410), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(4662), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4728), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9454), 7,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3914), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [344499] = 31,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(1978), 1,
      anon_sym_Set,
    ACTIONS(4238), 1,
      anon_sym_PIPE,
    ACTIONS(4424), 1,
      anon_sym_LPAREN,
    ACTIONS(4426), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4428), 1,
      anon_sym_u2983,
    ACTIONS(4430), 1,
      anon_sym_LBRACE,
    ACTIONS(4432), 1,
      anon_sym_DOT,
    STATE(1986), 1,
      sym__ARROW,
    STATE(3982), 1,
      aux_sym__atoms,
    STATE(5442), 1,
      sym_atom,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(4422), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8997), 7,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [344618] = 30,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2800), 1,
      anon_sym_quoteGoal,
    ACTIONS(2804), 1,
      anon_sym_let,
    ACTIONS(2806), 1,
      sym_id,
    ACTIONS(2810), 1,
      anon_sym_BSLASH,
    ACTIONS(2812), 1,
      anon_sym_u03bb,
    ACTIONS(2816), 1,
      anon_sym_record,
    ACTIONS(2818), 1,
      anon_sym_LPAREN,
    ACTIONS(2820), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2822), 1,
      anon_sym_u2983,
    ACTIONS(2824), 1,
      anon_sym_LBRACE,
    ACTIONS(2826), 1,
      aux_sym__qid_token1,
    ACTIONS(2828), 1,
      anon_sym_DOT,
    ACTIONS(2830), 1,
      anon_sym_tactic,
    ACTIONS(2832), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2834), 1,
      anon_sym_u2987,
    ACTIONS(2838), 1,
      anon_sym_Set,
    STATE(2143), 1,
      sym__ARROW,
    STATE(3451), 1,
      aux_sym__atoms,
    STATE(5831), 1,
      sym_atom,
    STATE(8081), 1,
      sym__LAMBDA,
    STATE(8490), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2794), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2836), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(4434), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(5982), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5981), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8968), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2814), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [344735] = 31,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(894), 1,
      sym_id,
    ACTIONS(898), 1,
      anon_sym_BSLASH,
    ACTIONS(900), 1,
      anon_sym_u03bb,
    ACTIONS(904), 1,
      anon_sym_record,
    ACTIONS(916), 1,
      aux_sym__qid_token1,
    ACTIONS(920), 1,
      anon_sym_quoteGoal,
    ACTIONS(922), 1,
      anon_sym_tactic,
    ACTIONS(924), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(926), 1,
      anon_sym_u2987,
    ACTIONS(928), 1,
      anon_sym_let,
    ACTIONS(932), 1,
      anon_sym_Set,
    ACTIONS(4238), 1,
      anon_sym_PIPE,
    ACTIONS(4320), 1,
      anon_sym_LPAREN,
    ACTIONS(4322), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4324), 1,
      anon_sym_u2983,
    ACTIONS(4326), 1,
      anon_sym_LBRACE,
    ACTIONS(4328), 1,
      anon_sym_DOT,
    STATE(2204), 1,
      sym__ARROW,
    STATE(3982), 1,
      aux_sym__atoms,
    STATE(5202), 1,
      sym_atom,
    STATE(8031), 1,
      sym__LAMBDA,
    STATE(8396), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(930), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(4436), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(4961), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4920), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9454), 7,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(902), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [344854] = 5,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(394), 1,
      anon_sym_BSLASH,
    ACTIONS(4438), 1,
      anon_sym_in,
    STATE(8944), 1,
      sym__let_body,
    ACTIONS(4240), 52,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_field,
      anon_sym_instance,
      anon_sym_module,
      anon_sym_data,
      anon_sym_codata,
      anon_sym_record,
      anon_sym_infix,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_variable,
      anon_sym_mutual,
      anon_sym_abstract,
      anon_sym_private,
      anon_sym_macro,
      anon_sym_postulate,
      anon_sym_primitive,
      anon_sym_open,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      sym_pragma,
      anon_sym_syntax,
      anon_sym_LBRACE,
      anon_sym_pattern,
      anon_sym_unquoteDecl,
      anon_sym_unquoteDef,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_AT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [344921] = 5,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(394), 1,
      anon_sym_BSLASH,
    ACTIONS(4440), 1,
      anon_sym_in,
    STATE(8976), 1,
      sym__let_body,
    ACTIONS(4240), 52,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_field,
      anon_sym_instance,
      anon_sym_module,
      anon_sym_data,
      anon_sym_codata,
      anon_sym_record,
      anon_sym_infix,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_variable,
      anon_sym_mutual,
      anon_sym_abstract,
      anon_sym_private,
      anon_sym_macro,
      anon_sym_postulate,
      anon_sym_primitive,
      anon_sym_open,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      sym_pragma,
      anon_sym_syntax,
      anon_sym_LBRACE,
      anon_sym_pattern,
      anon_sym_unquoteDecl,
      anon_sym_unquoteDef,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_AT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [344988] = 31,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(2690), 1,
      sym_id,
    ACTIONS(2694), 1,
      anon_sym_BSLASH,
    ACTIONS(2696), 1,
      anon_sym_u03bb,
    ACTIONS(2700), 1,
      anon_sym_record,
    ACTIONS(2710), 1,
      aux_sym__qid_token1,
    ACTIONS(2714), 1,
      anon_sym_quoteGoal,
    ACTIONS(2716), 1,
      anon_sym_tactic,
    ACTIONS(2718), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2720), 1,
      anon_sym_u2987,
    ACTIONS(2722), 1,
      anon_sym_let,
    ACTIONS(2726), 1,
      anon_sym_Set,
    ACTIONS(4238), 1,
      anon_sym_PIPE,
    ACTIONS(4444), 1,
      anon_sym_LPAREN,
    ACTIONS(4446), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4448), 1,
      anon_sym_u2983,
    ACTIONS(4450), 1,
      anon_sym_LBRACE,
    ACTIONS(4452), 1,
      anon_sym_DOT,
    STATE(1734), 1,
      sym__ARROW,
    STATE(3982), 1,
      aux_sym__atoms,
    STATE(4047), 1,
      sym_atom,
    STATE(8133), 1,
      sym__LAMBDA,
    STATE(8368), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2692), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2724), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(4442), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(4108), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4103), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9001), 7,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2698), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [345107] = 5,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(394), 1,
      anon_sym_BSLASH,
    ACTIONS(4454), 1,
      anon_sym_in,
    STATE(8943), 1,
      sym__let_body,
    ACTIONS(4240), 52,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_field,
      anon_sym_instance,
      anon_sym_module,
      anon_sym_data,
      anon_sym_codata,
      anon_sym_record,
      anon_sym_infix,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_variable,
      anon_sym_mutual,
      anon_sym_abstract,
      anon_sym_private,
      anon_sym_macro,
      anon_sym_postulate,
      anon_sym_primitive,
      anon_sym_open,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      sym_pragma,
      anon_sym_syntax,
      anon_sym_LBRACE,
      anon_sym_pattern,
      anon_sym_unquoteDecl,
      anon_sym_unquoteDef,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_AT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [345174] = 5,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(394), 1,
      anon_sym_BSLASH,
    ACTIONS(4456), 1,
      anon_sym_in,
    STATE(8938), 1,
      sym__let_body,
    ACTIONS(4240), 52,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_field,
      anon_sym_instance,
      anon_sym_module,
      anon_sym_data,
      anon_sym_codata,
      anon_sym_record,
      anon_sym_infix,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_variable,
      anon_sym_mutual,
      anon_sym_abstract,
      anon_sym_private,
      anon_sym_macro,
      anon_sym_postulate,
      anon_sym_primitive,
      anon_sym_open,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      sym_pragma,
      anon_sym_syntax,
      anon_sym_LBRACE,
      anon_sym_pattern,
      anon_sym_unquoteDecl,
      anon_sym_unquoteDef,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_AT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [345241] = 5,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(394), 1,
      anon_sym_BSLASH,
    ACTIONS(4380), 1,
      anon_sym_in,
    STATE(9478), 1,
      sym__let_body,
    ACTIONS(4240), 52,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_field,
      anon_sym_instance,
      anon_sym_module,
      anon_sym_data,
      anon_sym_codata,
      anon_sym_record,
      anon_sym_infix,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_variable,
      anon_sym_mutual,
      anon_sym_abstract,
      anon_sym_private,
      anon_sym_macro,
      anon_sym_postulate,
      anon_sym_primitive,
      anon_sym_open,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      sym_pragma,
      anon_sym_syntax,
      anon_sym_LBRACE,
      anon_sym_pattern,
      anon_sym_unquoteDecl,
      anon_sym_unquoteDef,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_AT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [345308] = 30,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(1870), 1,
      anon_sym_BSLASH,
    ACTIONS(1872), 1,
      anon_sym_u03bb,
    ACTIONS(1890), 1,
      anon_sym_quoteGoal,
    ACTIONS(1892), 1,
      anon_sym_tactic,
    ACTIONS(1898), 1,
      anon_sym_let,
    ACTIONS(3666), 1,
      sym_id,
    ACTIONS(3672), 1,
      anon_sym_record,
    ACTIONS(3674), 1,
      anon_sym_LPAREN,
    ACTIONS(3676), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3678), 1,
      anon_sym_u2983,
    ACTIONS(3680), 1,
      anon_sym_LBRACE,
    ACTIONS(3682), 1,
      aux_sym__qid_token1,
    ACTIONS(3684), 1,
      anon_sym_DOT,
    ACTIONS(3686), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3688), 1,
      anon_sym_u2987,
    ACTIONS(3692), 1,
      anon_sym_Set,
    STATE(1413), 1,
      sym__ARROW,
    STATE(3682), 1,
      aux_sym__atoms,
    STATE(4587), 1,
      sym_atom,
    STATE(8032), 1,
      sym__LAMBDA,
    STATE(8379), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1868), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3690), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(4458), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(4585), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4584), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8929), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3670), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [345425] = 5,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(394), 1,
      anon_sym_BSLASH,
    ACTIONS(4460), 1,
      anon_sym_in,
    STATE(8943), 1,
      sym__let_body,
    ACTIONS(4240), 52,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_field,
      anon_sym_instance,
      anon_sym_module,
      anon_sym_data,
      anon_sym_codata,
      anon_sym_record,
      anon_sym_infix,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_variable,
      anon_sym_mutual,
      anon_sym_abstract,
      anon_sym_private,
      anon_sym_macro,
      anon_sym_postulate,
      anon_sym_primitive,
      anon_sym_open,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      sym_pragma,
      anon_sym_syntax,
      anon_sym_LBRACE,
      anon_sym_pattern,
      anon_sym_unquoteDecl,
      anon_sym_unquoteDef,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_AT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [345492] = 31,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2448), 1,
      anon_sym_quoteGoal,
    ACTIONS(2456), 1,
      anon_sym_let,
    ACTIONS(2840), 1,
      sym_id,
    ACTIONS(2842), 1,
      anon_sym_BSLASH,
    ACTIONS(2844), 1,
      anon_sym_u03bb,
    ACTIONS(2848), 1,
      anon_sym_record,
    ACTIONS(2858), 1,
      aux_sym__qid_token1,
    ACTIONS(2862), 1,
      anon_sym_tactic,
    ACTIONS(2864), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2866), 1,
      anon_sym_u2987,
    ACTIONS(2870), 1,
      anon_sym_Set,
    ACTIONS(4238), 1,
      anon_sym_PIPE,
    ACTIONS(4464), 1,
      anon_sym_LPAREN,
    ACTIONS(4466), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4468), 1,
      anon_sym_u2983,
    ACTIONS(4470), 1,
      anon_sym_LBRACE,
    ACTIONS(4472), 1,
      anon_sym_DOT,
    STATE(2139), 1,
      sym__ARROW,
    STATE(3982), 1,
      aux_sym__atoms,
    STATE(4684), 1,
      sym_atom,
    STATE(8053), 1,
      sym__LAMBDA,
    STATE(8423), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2424), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2868), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(4462), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(4765), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4766), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8997), 7,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2846), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [345611] = 5,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(394), 1,
      anon_sym_BSLASH,
    ACTIONS(4474), 1,
      anon_sym_in,
    STATE(8944), 1,
      sym__let_body,
    ACTIONS(4240), 52,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_field,
      anon_sym_instance,
      anon_sym_module,
      anon_sym_data,
      anon_sym_codata,
      anon_sym_record,
      anon_sym_infix,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_variable,
      anon_sym_mutual,
      anon_sym_abstract,
      anon_sym_private,
      anon_sym_macro,
      anon_sym_postulate,
      anon_sym_primitive,
      anon_sym_open,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      sym_pragma,
      anon_sym_syntax,
      anon_sym_LBRACE,
      anon_sym_pattern,
      anon_sym_unquoteDecl,
      anon_sym_unquoteDef,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_AT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [345678] = 30,
    ACTIONS(706), 1,
      aux_sym__qid_token1,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1904), 1,
      sym_id,
    ACTIONS(1910), 1,
      anon_sym_BSLASH,
    ACTIONS(1912), 1,
      anon_sym_u03bb,
    ACTIONS(1916), 1,
      anon_sym_record,
    ACTIONS(1918), 1,
      anon_sym_LPAREN,
    ACTIONS(1920), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1922), 1,
      anon_sym_u2983,
    ACTIONS(1924), 1,
      anon_sym_LBRACE,
    ACTIONS(1926), 1,
      anon_sym_DOT,
    ACTIONS(1928), 1,
      anon_sym_quoteGoal,
    ACTIONS(1930), 1,
      anon_sym_tactic,
    ACTIONS(1932), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1934), 1,
      anon_sym_u2987,
    ACTIONS(1936), 1,
      anon_sym_let,
    ACTIONS(1940), 1,
      anon_sym_Set,
    STATE(1765), 1,
      sym__ARROW,
    STATE(3372), 1,
      aux_sym__atoms,
    STATE(4914), 1,
      sym_atom,
    STATE(8153), 1,
      sym__LAMBDA,
    STATE(8431), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1906), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1938), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(4476), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(4675), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4679), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8968), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1914), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [345795] = 5,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(394), 1,
      anon_sym_BSLASH,
    ACTIONS(4478), 1,
      anon_sym_in,
    STATE(8943), 1,
      sym__let_body,
    ACTIONS(4240), 52,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_field,
      anon_sym_instance,
      anon_sym_module,
      anon_sym_data,
      anon_sym_codata,
      anon_sym_record,
      anon_sym_infix,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_variable,
      anon_sym_mutual,
      anon_sym_abstract,
      anon_sym_private,
      anon_sym_macro,
      anon_sym_postulate,
      anon_sym_primitive,
      anon_sym_open,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      sym_pragma,
      anon_sym_syntax,
      anon_sym_LBRACE,
      anon_sym_pattern,
      anon_sym_unquoteDecl,
      anon_sym_unquoteDef,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_AT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [345862] = 31,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2298), 1,
      sym_id,
    ACTIONS(2302), 1,
      anon_sym_BSLASH,
    ACTIONS(2304), 1,
      anon_sym_u03bb,
    ACTIONS(2308), 1,
      anon_sym_record,
    ACTIONS(2318), 1,
      aux_sym__qid_token1,
    ACTIONS(2322), 1,
      anon_sym_quoteGoal,
    ACTIONS(2324), 1,
      anon_sym_tactic,
    ACTIONS(2326), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2328), 1,
      anon_sym_u2987,
    ACTIONS(2330), 1,
      anon_sym_let,
    ACTIONS(2334), 1,
      anon_sym_Set,
    ACTIONS(4238), 1,
      anon_sym_PIPE,
    ACTIONS(4482), 1,
      anon_sym_LPAREN,
    ACTIONS(4484), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4486), 1,
      anon_sym_u2983,
    ACTIONS(4488), 1,
      anon_sym_LBRACE,
    ACTIONS(4490), 1,
      anon_sym_DOT,
    STATE(1590), 1,
      sym__ARROW,
    STATE(3982), 1,
      aux_sym__atoms,
    STATE(4989), 1,
      sym_atom,
    STATE(8138), 1,
      sym__LAMBDA,
    STATE(8476), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2300), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2332), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(4480), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(5354), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5347), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8997), 7,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2306), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [345981] = 5,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(394), 1,
      anon_sym_BSLASH,
    ACTIONS(4492), 1,
      anon_sym_in,
    STATE(8944), 1,
      sym__let_body,
    ACTIONS(4240), 52,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_field,
      anon_sym_instance,
      anon_sym_module,
      anon_sym_data,
      anon_sym_codata,
      anon_sym_record,
      anon_sym_infix,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_variable,
      anon_sym_mutual,
      anon_sym_abstract,
      anon_sym_private,
      anon_sym_macro,
      anon_sym_postulate,
      anon_sym_primitive,
      anon_sym_open,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      sym_pragma,
      anon_sym_syntax,
      anon_sym_LBRACE,
      anon_sym_pattern,
      anon_sym_unquoteDecl,
      anon_sym_unquoteDef,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_AT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [346048] = 5,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(394), 1,
      anon_sym_BSLASH,
    ACTIONS(4492), 1,
      anon_sym_in,
    STATE(8994), 1,
      sym__let_body,
    ACTIONS(4240), 52,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_field,
      anon_sym_instance,
      anon_sym_module,
      anon_sym_data,
      anon_sym_codata,
      anon_sym_record,
      anon_sym_infix,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_variable,
      anon_sym_mutual,
      anon_sym_abstract,
      anon_sym_private,
      anon_sym_macro,
      anon_sym_postulate,
      anon_sym_primitive,
      anon_sym_open,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      sym_pragma,
      anon_sym_syntax,
      anon_sym_LBRACE,
      anon_sym_pattern,
      anon_sym_unquoteDecl,
      anon_sym_unquoteDef,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_AT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [346115] = 5,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(394), 1,
      anon_sym_BSLASH,
    ACTIONS(4494), 1,
      anon_sym_in,
    STATE(8938), 1,
      sym__let_body,
    ACTIONS(4240), 52,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_field,
      anon_sym_instance,
      anon_sym_module,
      anon_sym_data,
      anon_sym_codata,
      anon_sym_record,
      anon_sym_infix,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_variable,
      anon_sym_mutual,
      anon_sym_abstract,
      anon_sym_private,
      anon_sym_macro,
      anon_sym_postulate,
      anon_sym_primitive,
      anon_sym_open,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      sym_pragma,
      anon_sym_syntax,
      anon_sym_LBRACE,
      anon_sym_pattern,
      anon_sym_unquoteDecl,
      anon_sym_unquoteDef,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_AT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [346182] = 5,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(394), 1,
      anon_sym_BSLASH,
    ACTIONS(4494), 1,
      anon_sym_in,
    STATE(8947), 1,
      sym__let_body,
    ACTIONS(4240), 52,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_field,
      anon_sym_instance,
      anon_sym_module,
      anon_sym_data,
      anon_sym_codata,
      anon_sym_record,
      anon_sym_infix,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_variable,
      anon_sym_mutual,
      anon_sym_abstract,
      anon_sym_private,
      anon_sym_macro,
      anon_sym_postulate,
      anon_sym_primitive,
      anon_sym_open,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      sym_pragma,
      anon_sym_syntax,
      anon_sym_LBRACE,
      anon_sym_pattern,
      anon_sym_unquoteDecl,
      anon_sym_unquoteDef,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_AT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [346249] = 5,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(394), 1,
      anon_sym_BSLASH,
    ACTIONS(4496), 1,
      anon_sym_in,
    STATE(8944), 1,
      sym__let_body,
    ACTIONS(4240), 52,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_field,
      anon_sym_instance,
      anon_sym_module,
      anon_sym_data,
      anon_sym_codata,
      anon_sym_record,
      anon_sym_infix,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_variable,
      anon_sym_mutual,
      anon_sym_abstract,
      anon_sym_private,
      anon_sym_macro,
      anon_sym_postulate,
      anon_sym_primitive,
      anon_sym_open,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      sym_pragma,
      anon_sym_syntax,
      anon_sym_LBRACE,
      anon_sym_pattern,
      anon_sym_unquoteDecl,
      anon_sym_unquoteDef,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_AT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [346316] = 5,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(394), 1,
      anon_sym_BSLASH,
    ACTIONS(4496), 1,
      anon_sym_in,
    STATE(8994), 1,
      sym__let_body,
    ACTIONS(4240), 52,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_field,
      anon_sym_instance,
      anon_sym_module,
      anon_sym_data,
      anon_sym_codata,
      anon_sym_record,
      anon_sym_infix,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_variable,
      anon_sym_mutual,
      anon_sym_abstract,
      anon_sym_private,
      anon_sym_macro,
      anon_sym_postulate,
      anon_sym_primitive,
      anon_sym_open,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      sym_pragma,
      anon_sym_syntax,
      anon_sym_LBRACE,
      anon_sym_pattern,
      anon_sym_unquoteDecl,
      anon_sym_unquoteDef,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_AT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [346383] = 5,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(394), 1,
      anon_sym_BSLASH,
    ACTIONS(4474), 1,
      anon_sym_in,
    STATE(8994), 1,
      sym__let_body,
    ACTIONS(4240), 52,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_field,
      anon_sym_instance,
      anon_sym_module,
      anon_sym_data,
      anon_sym_codata,
      anon_sym_record,
      anon_sym_infix,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_variable,
      anon_sym_mutual,
      anon_sym_abstract,
      anon_sym_private,
      anon_sym_macro,
      anon_sym_postulate,
      anon_sym_primitive,
      anon_sym_open,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      sym_pragma,
      anon_sym_syntax,
      anon_sym_LBRACE,
      anon_sym_pattern,
      anon_sym_unquoteDecl,
      anon_sym_unquoteDef,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_AT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [346450] = 5,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(394), 1,
      anon_sym_BSLASH,
    ACTIONS(4438), 1,
      anon_sym_in,
    STATE(8994), 1,
      sym__let_body,
    ACTIONS(4240), 52,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_field,
      anon_sym_instance,
      anon_sym_module,
      anon_sym_data,
      anon_sym_codata,
      anon_sym_record,
      anon_sym_infix,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_variable,
      anon_sym_mutual,
      anon_sym_abstract,
      anon_sym_private,
      anon_sym_macro,
      anon_sym_postulate,
      anon_sym_primitive,
      anon_sym_open,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      sym_pragma,
      anon_sym_syntax,
      anon_sym_LBRACE,
      anon_sym_pattern,
      anon_sym_unquoteDecl,
      anon_sym_unquoteDef,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_AT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [346517] = 5,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(394), 1,
      anon_sym_BSLASH,
    ACTIONS(4246), 1,
      anon_sym_in,
    STATE(8976), 1,
      sym__let_body,
    ACTIONS(4240), 52,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_field,
      anon_sym_instance,
      anon_sym_module,
      anon_sym_data,
      anon_sym_codata,
      anon_sym_record,
      anon_sym_infix,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_variable,
      anon_sym_mutual,
      anon_sym_abstract,
      anon_sym_private,
      anon_sym_macro,
      anon_sym_postulate,
      anon_sym_primitive,
      anon_sym_open,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      sym_pragma,
      anon_sym_syntax,
      anon_sym_LBRACE,
      anon_sym_pattern,
      anon_sym_unquoteDecl,
      anon_sym_unquoteDef,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_AT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [346584] = 5,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(394), 1,
      anon_sym_BSLASH,
    ACTIONS(4498), 1,
      anon_sym_in,
    STATE(8976), 1,
      sym__let_body,
    ACTIONS(4240), 52,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_field,
      anon_sym_instance,
      anon_sym_module,
      anon_sym_data,
      anon_sym_codata,
      anon_sym_record,
      anon_sym_infix,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_variable,
      anon_sym_mutual,
      anon_sym_abstract,
      anon_sym_private,
      anon_sym_macro,
      anon_sym_postulate,
      anon_sym_primitive,
      anon_sym_open,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      sym_pragma,
      anon_sym_syntax,
      anon_sym_LBRACE,
      anon_sym_pattern,
      anon_sym_unquoteDecl,
      anon_sym_unquoteDef,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_AT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [346651] = 5,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(394), 1,
      anon_sym_BSLASH,
    ACTIONS(4456), 1,
      anon_sym_in,
    STATE(8947), 1,
      sym__let_body,
    ACTIONS(4240), 52,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_field,
      anon_sym_instance,
      anon_sym_module,
      anon_sym_data,
      anon_sym_codata,
      anon_sym_record,
      anon_sym_infix,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_variable,
      anon_sym_mutual,
      anon_sym_abstract,
      anon_sym_private,
      anon_sym_macro,
      anon_sym_postulate,
      anon_sym_primitive,
      anon_sym_open,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      sym_pragma,
      anon_sym_syntax,
      anon_sym_LBRACE,
      anon_sym_pattern,
      anon_sym_unquoteDecl,
      anon_sym_unquoteDef,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_AT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [346718] = 30,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(2732), 1,
      anon_sym_BSLASH,
    ACTIONS(2734), 1,
      anon_sym_u03bb,
    ACTIONS(2752), 1,
      anon_sym_quoteGoal,
    ACTIONS(2754), 1,
      anon_sym_tactic,
    ACTIONS(2760), 1,
      anon_sym_let,
    ACTIONS(3610), 1,
      sym_id,
    ACTIONS(3616), 1,
      anon_sym_record,
    ACTIONS(3618), 1,
      anon_sym_LPAREN,
    ACTIONS(3620), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3622), 1,
      anon_sym_u2983,
    ACTIONS(3624), 1,
      anon_sym_LBRACE,
    ACTIONS(3626), 1,
      aux_sym__qid_token1,
    ACTIONS(3628), 1,
      anon_sym_DOT,
    ACTIONS(3630), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3632), 1,
      anon_sym_u2987,
    ACTIONS(3636), 1,
      anon_sym_Set,
    STATE(1557), 1,
      sym__ARROW,
    STATE(3476), 1,
      aux_sym__atoms,
    STATE(5352), 1,
      sym_atom,
    STATE(8061), 1,
      sym__LAMBDA,
    STATE(8384), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2730), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3634), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(4500), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(5254), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5242), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8929), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3614), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [346835] = 5,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(394), 1,
      anon_sym_BSLASH,
    ACTIONS(4364), 1,
      anon_sym_in,
    STATE(8976), 1,
      sym__let_body,
    ACTIONS(4240), 52,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_field,
      anon_sym_instance,
      anon_sym_module,
      anon_sym_data,
      anon_sym_codata,
      anon_sym_record,
      anon_sym_infix,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_variable,
      anon_sym_mutual,
      anon_sym_abstract,
      anon_sym_private,
      anon_sym_macro,
      anon_sym_postulate,
      anon_sym_primitive,
      anon_sym_open,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      sym_pragma,
      anon_sym_syntax,
      anon_sym_LBRACE,
      anon_sym_pattern,
      anon_sym_unquoteDecl,
      anon_sym_unquoteDef,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_AT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [346902] = 5,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(394), 1,
      anon_sym_BSLASH,
    ACTIONS(4502), 1,
      anon_sym_in,
    STATE(8976), 1,
      sym__let_body,
    ACTIONS(4240), 52,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_field,
      anon_sym_instance,
      anon_sym_module,
      anon_sym_data,
      anon_sym_codata,
      anon_sym_record,
      anon_sym_infix,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_variable,
      anon_sym_mutual,
      anon_sym_abstract,
      anon_sym_private,
      anon_sym_macro,
      anon_sym_postulate,
      anon_sym_primitive,
      anon_sym_open,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      sym_pragma,
      anon_sym_syntax,
      anon_sym_LBRACE,
      anon_sym_pattern,
      anon_sym_unquoteDecl,
      anon_sym_unquoteDef,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_AT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [346969] = 31,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2488), 1,
      sym_id,
    ACTIONS(2492), 1,
      anon_sym_BSLASH,
    ACTIONS(2494), 1,
      anon_sym_u03bb,
    ACTIONS(2498), 1,
      anon_sym_record,
    ACTIONS(2508), 1,
      aux_sym__qid_token1,
    ACTIONS(2512), 1,
      anon_sym_quoteGoal,
    ACTIONS(2514), 1,
      anon_sym_tactic,
    ACTIONS(2516), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2518), 1,
      anon_sym_u2987,
    ACTIONS(2520), 1,
      anon_sym_let,
    ACTIONS(2524), 1,
      anon_sym_Set,
    ACTIONS(4238), 1,
      anon_sym_PIPE,
    ACTIONS(4506), 1,
      anon_sym_LPAREN,
    ACTIONS(4508), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4510), 1,
      anon_sym_u2983,
    ACTIONS(4512), 1,
      anon_sym_LBRACE,
    ACTIONS(4514), 1,
      anon_sym_DOT,
    STATE(1518), 1,
      sym__ARROW,
    STATE(3982), 1,
      aux_sym__atoms,
    STATE(5643), 1,
      sym_atom,
    STATE(8096), 1,
      sym__LAMBDA,
    STATE(8497), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2490), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2522), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(4504), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(5713), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5698), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8997), 7,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2496), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [347088] = 5,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(394), 1,
      anon_sym_BSLASH,
    ACTIONS(4516), 1,
      anon_sym_in,
    STATE(8947), 1,
      sym__let_body,
    ACTIONS(4240), 52,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_field,
      anon_sym_instance,
      anon_sym_module,
      anon_sym_data,
      anon_sym_codata,
      anon_sym_record,
      anon_sym_infix,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_variable,
      anon_sym_mutual,
      anon_sym_abstract,
      anon_sym_private,
      anon_sym_macro,
      anon_sym_postulate,
      anon_sym_primitive,
      anon_sym_open,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      sym_pragma,
      anon_sym_syntax,
      anon_sym_LBRACE,
      anon_sym_pattern,
      anon_sym_unquoteDecl,
      anon_sym_unquoteDef,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_AT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [347155] = 30,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(3266), 1,
      anon_sym_BSLASH,
    ACTIONS(3268), 1,
      anon_sym_u03bb,
    ACTIONS(3286), 1,
      anon_sym_quoteGoal,
    ACTIONS(3288), 1,
      anon_sym_tactic,
    ACTIONS(3294), 1,
      anon_sym_let,
    ACTIONS(3732), 1,
      sym_id,
    ACTIONS(3738), 1,
      anon_sym_record,
    ACTIONS(3740), 1,
      anon_sym_LPAREN,
    ACTIONS(3742), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3744), 1,
      anon_sym_u2983,
    ACTIONS(3746), 1,
      anon_sym_LBRACE,
    ACTIONS(3748), 1,
      aux_sym__qid_token1,
    ACTIONS(3750), 1,
      anon_sym_DOT,
    ACTIONS(3752), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3754), 1,
      anon_sym_u2987,
    ACTIONS(3758), 1,
      anon_sym_Set,
    STATE(2259), 1,
      sym__ARROW,
    STATE(3381), 1,
      aux_sym__atoms,
    STATE(4058), 1,
      sym_atom,
    STATE(8143), 1,
      sym__LAMBDA,
    STATE(8451), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3264), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3756), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(4518), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(4073), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4070), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8929), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3736), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [347272] = 5,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(394), 1,
      anon_sym_BSLASH,
    ACTIONS(4520), 1,
      anon_sym_in,
    STATE(8976), 1,
      sym__let_body,
    ACTIONS(4240), 52,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_field,
      anon_sym_instance,
      anon_sym_module,
      anon_sym_data,
      anon_sym_codata,
      anon_sym_record,
      anon_sym_infix,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_variable,
      anon_sym_mutual,
      anon_sym_abstract,
      anon_sym_private,
      anon_sym_macro,
      anon_sym_postulate,
      anon_sym_primitive,
      anon_sym_open,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      sym_pragma,
      anon_sym_syntax,
      anon_sym_LBRACE,
      anon_sym_pattern,
      anon_sym_unquoteDecl,
      anon_sym_unquoteDef,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_AT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [347339] = 31,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2652), 1,
      sym_id,
    ACTIONS(2662), 1,
      anon_sym_record,
    ACTIONS(2672), 1,
      aux_sym__qid_token1,
    ACTIONS(2680), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2682), 1,
      anon_sym_u2987,
    ACTIONS(2688), 1,
      anon_sym_Set,
    ACTIONS(2796), 1,
      anon_sym_BSLASH,
    ACTIONS(2798), 1,
      anon_sym_u03bb,
    ACTIONS(2800), 1,
      anon_sym_quoteGoal,
    ACTIONS(2802), 1,
      anon_sym_tactic,
    ACTIONS(2804), 1,
      anon_sym_let,
    ACTIONS(4238), 1,
      anon_sym_PIPE,
    ACTIONS(4524), 1,
      anon_sym_LPAREN,
    ACTIONS(4526), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4528), 1,
      anon_sym_u2983,
    ACTIONS(4530), 1,
      anon_sym_LBRACE,
    ACTIONS(4532), 1,
      anon_sym_DOT,
    STATE(1831), 1,
      sym__ARROW,
    STATE(3982), 1,
      aux_sym__atoms,
    STATE(4916), 1,
      sym_atom,
    STATE(8041), 1,
      sym__LAMBDA,
    STATE(8490), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2686), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(2794), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4522), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(4732), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4735), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8997), 7,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2660), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [347458] = 5,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(394), 1,
      anon_sym_BSLASH,
    ACTIONS(4516), 1,
      anon_sym_in,
    STATE(8938), 1,
      sym__let_body,
    ACTIONS(4240), 52,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_field,
      anon_sym_instance,
      anon_sym_module,
      anon_sym_data,
      anon_sym_codata,
      anon_sym_record,
      anon_sym_infix,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_variable,
      anon_sym_mutual,
      anon_sym_abstract,
      anon_sym_private,
      anon_sym_macro,
      anon_sym_postulate,
      anon_sym_primitive,
      anon_sym_open,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      sym_pragma,
      anon_sym_syntax,
      anon_sym_LBRACE,
      anon_sym_pattern,
      anon_sym_unquoteDecl,
      anon_sym_unquoteDef,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_AT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [347525] = 30,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(2938), 1,
      sym_id,
    ACTIONS(2944), 1,
      anon_sym_BSLASH,
    ACTIONS(2946), 1,
      anon_sym_u03bb,
    ACTIONS(2950), 1,
      anon_sym_record,
    ACTIONS(2952), 1,
      anon_sym_LPAREN,
    ACTIONS(2954), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2956), 1,
      anon_sym_u2983,
    ACTIONS(2958), 1,
      anon_sym_LBRACE,
    ACTIONS(2960), 1,
      aux_sym__qid_token1,
    ACTIONS(2962), 1,
      anon_sym_DOT,
    ACTIONS(2964), 1,
      anon_sym_quoteGoal,
    ACTIONS(2966), 1,
      anon_sym_tactic,
    ACTIONS(2968), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2970), 1,
      anon_sym_u2987,
    ACTIONS(2972), 1,
      anon_sym_let,
    ACTIONS(2976), 1,
      anon_sym_Set,
    STATE(2434), 1,
      sym__ARROW,
    STATE(3488), 1,
      aux_sym__atoms,
    STATE(5967), 1,
      sym_atom,
    STATE(8126), 1,
      sym__LAMBDA,
    STATE(8418), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2940), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2974), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(4534), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(5870), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5838), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8929), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2948), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [347642] = 30,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(2656), 1,
      anon_sym_BSLASH,
    ACTIONS(2658), 1,
      anon_sym_u03bb,
    ACTIONS(2676), 1,
      anon_sym_quoteGoal,
    ACTIONS(2678), 1,
      anon_sym_tactic,
    ACTIONS(2684), 1,
      anon_sym_let,
    ACTIONS(3208), 1,
      sym_id,
    ACTIONS(3212), 1,
      anon_sym_record,
    ACTIONS(3214), 1,
      anon_sym_LPAREN,
    ACTIONS(3216), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3218), 1,
      anon_sym_u2983,
    ACTIONS(3220), 1,
      anon_sym_LBRACE,
    ACTIONS(3222), 1,
      aux_sym__qid_token1,
    ACTIONS(3224), 1,
      anon_sym_DOT,
    ACTIONS(3226), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3228), 1,
      anon_sym_u2987,
    ACTIONS(3232), 1,
      anon_sym_Set,
    STATE(2347), 1,
      sym__ARROW,
    STATE(3560), 1,
      aux_sym__atoms,
    STATE(5433), 1,
      sym_atom,
    STATE(8132), 1,
      sym__LAMBDA,
    STATE(8470), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2654), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3230), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(4536), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(5579), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5582), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8968), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3210), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [347759] = 31,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(4238), 1,
      anon_sym_PIPE,
    ACTIONS(4540), 1,
      anon_sym_LPAREN,
    ACTIONS(4542), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4544), 1,
      anon_sym_u2983,
    ACTIONS(4546), 1,
      anon_sym_LBRACE,
    ACTIONS(4548), 1,
      anon_sym_DOT,
    STATE(1646), 1,
      sym__ARROW,
    STATE(3982), 1,
      aux_sym__atoms,
    STATE(5247), 1,
      sym_atom,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(4538), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8997), 7,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [347878] = 31,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(3482), 1,
      sym_id,
    ACTIONS(3486), 1,
      anon_sym_BSLASH,
    ACTIONS(3488), 1,
      anon_sym_u03bb,
    ACTIONS(3492), 1,
      anon_sym_record,
    ACTIONS(3502), 1,
      aux_sym__qid_token1,
    ACTIONS(3506), 1,
      anon_sym_quoteGoal,
    ACTIONS(3508), 1,
      anon_sym_tactic,
    ACTIONS(3510), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3512), 1,
      anon_sym_u2987,
    ACTIONS(3514), 1,
      anon_sym_let,
    ACTIONS(3518), 1,
      anon_sym_Set,
    ACTIONS(4238), 1,
      anon_sym_PIPE,
    ACTIONS(4552), 1,
      anon_sym_LPAREN,
    ACTIONS(4554), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4556), 1,
      anon_sym_u2983,
    ACTIONS(4558), 1,
      anon_sym_LBRACE,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    STATE(2380), 1,
      sym__ARROW,
    STATE(3982), 1,
      aux_sym__atoms,
    STATE(4260), 1,
      sym_atom,
    STATE(8140), 1,
      sym__LAMBDA,
    STATE(8504), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3484), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3516), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(4550), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(4382), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4385), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9001), 7,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3490), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [347997] = 30,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1984), 1,
      anon_sym_BSLASH,
    ACTIONS(1986), 1,
      anon_sym_u03bb,
    ACTIONS(2004), 1,
      anon_sym_quoteGoal,
    ACTIONS(2006), 1,
      anon_sym_tactic,
    ACTIONS(2012), 1,
      anon_sym_let,
    ACTIONS(3380), 1,
      sym_id,
    ACTIONS(3384), 1,
      anon_sym_record,
    ACTIONS(3386), 1,
      anon_sym_LPAREN,
    ACTIONS(3388), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3390), 1,
      anon_sym_u2983,
    ACTIONS(3392), 1,
      anon_sym_LBRACE,
    ACTIONS(3394), 1,
      aux_sym__qid_token1,
    ACTIONS(3396), 1,
      anon_sym_DOT,
    ACTIONS(3398), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3400), 1,
      anon_sym_u2987,
    ACTIONS(3404), 1,
      anon_sym_Set,
    STATE(1870), 1,
      sym__ARROW,
    STATE(3573), 1,
      aux_sym__atoms,
    STATE(5099), 1,
      sym_atom,
    STATE(8039), 1,
      sym__LAMBDA,
    STATE(8483), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1982), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3402), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(4562), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(4937), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4939), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9472), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3382), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [348114] = 5,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(394), 1,
      anon_sym_BSLASH,
    ACTIONS(4382), 1,
      anon_sym_in,
    STATE(8994), 1,
      sym__let_body,
    ACTIONS(4240), 52,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_field,
      anon_sym_instance,
      anon_sym_module,
      anon_sym_data,
      anon_sym_codata,
      anon_sym_record,
      anon_sym_infix,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_variable,
      anon_sym_mutual,
      anon_sym_abstract,
      anon_sym_private,
      anon_sym_macro,
      anon_sym_postulate,
      anon_sym_primitive,
      anon_sym_open,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      sym_pragma,
      anon_sym_syntax,
      anon_sym_LBRACE,
      anon_sym_pattern,
      anon_sym_unquoteDecl,
      anon_sym_unquoteDef,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_AT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [348181] = 30,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(2206), 1,
      sym_id,
    ACTIONS(2212), 1,
      anon_sym_BSLASH,
    ACTIONS(2214), 1,
      anon_sym_u03bb,
    ACTIONS(2218), 1,
      anon_sym_record,
    ACTIONS(2220), 1,
      anon_sym_LPAREN,
    ACTIONS(2222), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2224), 1,
      anon_sym_u2983,
    ACTIONS(2226), 1,
      anon_sym_LBRACE,
    ACTIONS(2228), 1,
      aux_sym__qid_token1,
    ACTIONS(2230), 1,
      anon_sym_DOT,
    ACTIONS(2232), 1,
      anon_sym_quoteGoal,
    ACTIONS(2234), 1,
      anon_sym_tactic,
    ACTIONS(2236), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2238), 1,
      anon_sym_u2987,
    ACTIONS(2240), 1,
      anon_sym_let,
    ACTIONS(2244), 1,
      anon_sym_Set,
    STATE(2120), 1,
      sym__ARROW,
    STATE(3685), 1,
      aux_sym__atoms,
    STATE(4718), 1,
      sym_atom,
    STATE(8035), 1,
      sym__LAMBDA,
    STATE(8402), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2242), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(4564), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(4812), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4858), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8929), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2216), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [348298] = 5,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(394), 1,
      anon_sym_BSLASH,
    ACTIONS(4380), 1,
      anon_sym_in,
    STATE(9467), 1,
      sym__let_body,
    ACTIONS(4240), 52,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_field,
      anon_sym_instance,
      anon_sym_module,
      anon_sym_data,
      anon_sym_codata,
      anon_sym_record,
      anon_sym_infix,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_variable,
      anon_sym_mutual,
      anon_sym_abstract,
      anon_sym_private,
      anon_sym_macro,
      anon_sym_postulate,
      anon_sym_primitive,
      anon_sym_open,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      sym_pragma,
      anon_sym_syntax,
      anon_sym_LBRACE,
      anon_sym_pattern,
      anon_sym_unquoteDecl,
      anon_sym_unquoteDef,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_AT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [348365] = 5,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(394), 1,
      anon_sym_BSLASH,
    ACTIONS(4382), 1,
      anon_sym_in,
    STATE(8944), 1,
      sym__let_body,
    ACTIONS(4240), 52,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_field,
      anon_sym_instance,
      anon_sym_module,
      anon_sym_data,
      anon_sym_codata,
      anon_sym_record,
      anon_sym_infix,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_variable,
      anon_sym_mutual,
      anon_sym_abstract,
      anon_sym_private,
      anon_sym_macro,
      anon_sym_postulate,
      anon_sym_primitive,
      anon_sym_open,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      sym_pragma,
      anon_sym_syntax,
      anon_sym_LBRACE,
      anon_sym_pattern,
      anon_sym_unquoteDecl,
      anon_sym_unquoteDef,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_AT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [348432] = 5,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(394), 1,
      anon_sym_BSLASH,
    ACTIONS(4242), 1,
      anon_sym_in,
    STATE(8943), 1,
      sym__let_body,
    ACTIONS(4240), 52,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_field,
      anon_sym_instance,
      anon_sym_module,
      anon_sym_data,
      anon_sym_codata,
      anon_sym_record,
      anon_sym_infix,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_variable,
      anon_sym_mutual,
      anon_sym_abstract,
      anon_sym_private,
      anon_sym_macro,
      anon_sym_postulate,
      anon_sym_primitive,
      anon_sym_open,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      sym_pragma,
      anon_sym_syntax,
      anon_sym_LBRACE,
      anon_sym_pattern,
      anon_sym_unquoteDecl,
      anon_sym_unquoteDef,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_AT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [348499] = 5,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(394), 1,
      anon_sym_BSLASH,
    ACTIONS(4566), 1,
      anon_sym_in,
    STATE(9467), 1,
      sym__let_body,
    ACTIONS(4240), 52,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_field,
      anon_sym_instance,
      anon_sym_module,
      anon_sym_data,
      anon_sym_codata,
      anon_sym_record,
      anon_sym_infix,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_variable,
      anon_sym_mutual,
      anon_sym_abstract,
      anon_sym_private,
      anon_sym_macro,
      anon_sym_postulate,
      anon_sym_primitive,
      anon_sym_open,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      sym_pragma,
      anon_sym_syntax,
      anon_sym_LBRACE,
      anon_sym_pattern,
      anon_sym_unquoteDecl,
      anon_sym_unquoteDef,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_AT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [348566] = 31,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(2384), 1,
      sym_id,
    ACTIONS(2388), 1,
      anon_sym_BSLASH,
    ACTIONS(2390), 1,
      anon_sym_u03bb,
    ACTIONS(2394), 1,
      anon_sym_record,
    ACTIONS(2404), 1,
      aux_sym__qid_token1,
    ACTIONS(2408), 1,
      anon_sym_quoteGoal,
    ACTIONS(2410), 1,
      anon_sym_tactic,
    ACTIONS(2412), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2414), 1,
      anon_sym_u2987,
    ACTIONS(2416), 1,
      anon_sym_let,
    ACTIONS(2420), 1,
      anon_sym_Set,
    ACTIONS(4238), 1,
      anon_sym_PIPE,
    ACTIONS(4570), 1,
      anon_sym_LPAREN,
    ACTIONS(4572), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4574), 1,
      anon_sym_u2983,
    ACTIONS(4576), 1,
      anon_sym_LBRACE,
    ACTIONS(4578), 1,
      anon_sym_DOT,
    STATE(1479), 1,
      sym__ARROW,
    STATE(3982), 1,
      aux_sym__atoms,
    STATE(4775), 1,
      sym_atom,
    STATE(8139), 1,
      sym__LAMBDA,
    STATE(8518), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2386), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2418), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(4568), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(4831), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4896), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9001), 7,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2392), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [348685] = 31,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(940), 1,
      sym_id,
    ACTIONS(950), 1,
      anon_sym_record,
    ACTIONS(960), 1,
      aux_sym__qid_token1,
    ACTIONS(968), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(970), 1,
      anon_sym_u2987,
    ACTIONS(976), 1,
      anon_sym_Set,
    ACTIONS(982), 1,
      anon_sym_BSLASH,
    ACTIONS(984), 1,
      anon_sym_u03bb,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(990), 1,
      anon_sym_tactic,
    ACTIONS(1302), 1,
      anon_sym_let,
    ACTIONS(4238), 1,
      anon_sym_PIPE,
    ACTIONS(4580), 1,
      anon_sym_LPAREN,
    ACTIONS(4582), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4584), 1,
      anon_sym_u2983,
    ACTIONS(4586), 1,
      anon_sym_LBRACE,
    ACTIONS(4588), 1,
      anon_sym_DOT,
    STATE(1646), 1,
      sym__ARROW,
    STATE(3982), 1,
      aux_sym__atoms,
    STATE(4712), 1,
      sym_atom,
    STATE(8095), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(974), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4538), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(4733), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4742), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8997), 7,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(948), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [348804] = 5,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(394), 1,
      anon_sym_BSLASH,
    ACTIONS(4498), 1,
      anon_sym_in,
    STATE(8947), 1,
      sym__let_body,
    ACTIONS(4240), 52,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_field,
      anon_sym_instance,
      anon_sym_module,
      anon_sym_data,
      anon_sym_codata,
      anon_sym_record,
      anon_sym_infix,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_variable,
      anon_sym_mutual,
      anon_sym_abstract,
      anon_sym_private,
      anon_sym_macro,
      anon_sym_postulate,
      anon_sym_primitive,
      anon_sym_open,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      sym_pragma,
      anon_sym_syntax,
      anon_sym_LBRACE,
      anon_sym_pattern,
      anon_sym_unquoteDecl,
      anon_sym_unquoteDef,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_AT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [348871] = 30,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2134), 1,
      sym_id,
    ACTIONS(2140), 1,
      anon_sym_BSLASH,
    ACTIONS(2142), 1,
      anon_sym_u03bb,
    ACTIONS(2146), 1,
      anon_sym_record,
    ACTIONS(2148), 1,
      anon_sym_LPAREN,
    ACTIONS(2150), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2152), 1,
      anon_sym_u2983,
    ACTIONS(2154), 1,
      anon_sym_LBRACE,
    ACTIONS(2156), 1,
      aux_sym__qid_token1,
    ACTIONS(2158), 1,
      anon_sym_DOT,
    ACTIONS(2160), 1,
      anon_sym_quoteGoal,
    ACTIONS(2162), 1,
      anon_sym_tactic,
    ACTIONS(2164), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2166), 1,
      anon_sym_u2987,
    ACTIONS(2168), 1,
      anon_sym_let,
    ACTIONS(2172), 1,
      anon_sym_Set,
    STATE(1769), 1,
      sym__ARROW,
    STATE(3356), 1,
      aux_sym__atoms,
    STATE(5718), 1,
      sym_atom,
    STATE(8040), 1,
      sym__LAMBDA,
    STATE(8460), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2136), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2170), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(4590), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(5624), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5627), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8968), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2144), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [348988] = 31,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(2566), 1,
      sym_id,
    ACTIONS(2570), 1,
      anon_sym_BSLASH,
    ACTIONS(2572), 1,
      anon_sym_u03bb,
    ACTIONS(2576), 1,
      anon_sym_record,
    ACTIONS(2586), 1,
      aux_sym__qid_token1,
    ACTIONS(2590), 1,
      anon_sym_quoteGoal,
    ACTIONS(2592), 1,
      anon_sym_tactic,
    ACTIONS(2594), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2596), 1,
      anon_sym_u2987,
    ACTIONS(2598), 1,
      anon_sym_let,
    ACTIONS(2602), 1,
      anon_sym_Set,
    ACTIONS(4238), 1,
      anon_sym_PIPE,
    ACTIONS(4594), 1,
      anon_sym_LPAREN,
    ACTIONS(4596), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4598), 1,
      anon_sym_u2983,
    ACTIONS(4600), 1,
      anon_sym_LBRACE,
    ACTIONS(4602), 1,
      anon_sym_DOT,
    STATE(1537), 1,
      sym__ARROW,
    STATE(3982), 1,
      aux_sym__atoms,
    STATE(5536), 1,
      sym_atom,
    STATE(8111), 1,
      sym__LAMBDA,
    STATE(8412), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2568), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2600), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(4592), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(5566), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5590), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9001), 7,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2574), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [349107] = 5,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(394), 1,
      anon_sym_BSLASH,
    ACTIONS(4498), 1,
      anon_sym_in,
    STATE(8938), 1,
      sym__let_body,
    ACTIONS(4240), 52,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_field,
      anon_sym_instance,
      anon_sym_module,
      anon_sym_data,
      anon_sym_codata,
      anon_sym_record,
      anon_sym_infix,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_variable,
      anon_sym_mutual,
      anon_sym_abstract,
      anon_sym_private,
      anon_sym_macro,
      anon_sym_postulate,
      anon_sym_primitive,
      anon_sym_open,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      sym_pragma,
      anon_sym_syntax,
      anon_sym_LBRACE,
      anon_sym_pattern,
      anon_sym_unquoteDecl,
      anon_sym_unquoteDef,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_AT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [349174] = 31,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(3016), 1,
      sym_id,
    ACTIONS(3020), 1,
      anon_sym_BSLASH,
    ACTIONS(3022), 1,
      anon_sym_u03bb,
    ACTIONS(3026), 1,
      anon_sym_record,
    ACTIONS(3036), 1,
      aux_sym__qid_token1,
    ACTIONS(3040), 1,
      anon_sym_quoteGoal,
    ACTIONS(3042), 1,
      anon_sym_tactic,
    ACTIONS(3044), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3046), 1,
      anon_sym_u2987,
    ACTIONS(3048), 1,
      anon_sym_let,
    ACTIONS(3052), 1,
      anon_sym_Set,
    ACTIONS(4238), 1,
      anon_sym_PIPE,
    ACTIONS(4606), 1,
      anon_sym_LPAREN,
    ACTIONS(4608), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4610), 1,
      anon_sym_u2983,
    ACTIONS(4612), 1,
      anon_sym_LBRACE,
    ACTIONS(4614), 1,
      anon_sym_DOT,
    STATE(2156), 1,
      sym__ARROW,
    STATE(3982), 1,
      aux_sym__atoms,
    STATE(5039), 1,
      sym_atom,
    STATE(8127), 1,
      sym__LAMBDA,
    STATE(8388), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3018), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3050), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(4604), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(5330), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5333), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8997), 7,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3024), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [349293] = 5,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(394), 1,
      anon_sym_BSLASH,
    ACTIONS(4616), 1,
      anon_sym_in,
    STATE(8994), 1,
      sym__let_body,
    ACTIONS(4240), 52,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_field,
      anon_sym_instance,
      anon_sym_module,
      anon_sym_data,
      anon_sym_codata,
      anon_sym_record,
      anon_sym_infix,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_variable,
      anon_sym_mutual,
      anon_sym_abstract,
      anon_sym_private,
      anon_sym_macro,
      anon_sym_postulate,
      anon_sym_primitive,
      anon_sym_open,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      sym_pragma,
      anon_sym_syntax,
      anon_sym_LBRACE,
      anon_sym_pattern,
      anon_sym_unquoteDecl,
      anon_sym_unquoteDef,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_AT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [349360] = 31,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(2964), 1,
      anon_sym_quoteGoal,
    ACTIONS(2972), 1,
      anon_sym_let,
    ACTIONS(3522), 1,
      anon_sym_BSLASH,
    ACTIONS(3524), 1,
      anon_sym_u03bb,
    ACTIONS(3542), 1,
      anon_sym_tactic,
    ACTIONS(3938), 1,
      sym_id,
    ACTIONS(3942), 1,
      anon_sym_record,
    ACTIONS(3952), 1,
      aux_sym__qid_token1,
    ACTIONS(3956), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3958), 1,
      anon_sym_u2987,
    ACTIONS(3962), 1,
      anon_sym_Set,
    ACTIONS(4238), 1,
      anon_sym_PIPE,
    ACTIONS(4620), 1,
      anon_sym_LPAREN,
    ACTIONS(4622), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4624), 1,
      anon_sym_u2983,
    ACTIONS(4626), 1,
      anon_sym_LBRACE,
    ACTIONS(4628), 1,
      anon_sym_DOT,
    STATE(2586), 1,
      sym__ARROW,
    STATE(3982), 1,
      aux_sym__atoms,
    STATE(5290), 1,
      sym_atom,
    STATE(8058), 1,
      sym__LAMBDA,
    STATE(8418), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2940), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3960), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(4618), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(5203), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5201), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9001), 7,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3940), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [349479] = 5,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(394), 1,
      anon_sym_BSLASH,
    ACTIONS(4630), 1,
      anon_sym_in,
    STATE(8944), 1,
      sym__let_body,
    ACTIONS(4240), 52,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_field,
      anon_sym_instance,
      anon_sym_module,
      anon_sym_data,
      anon_sym_codata,
      anon_sym_record,
      anon_sym_infix,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_variable,
      anon_sym_mutual,
      anon_sym_abstract,
      anon_sym_private,
      anon_sym_macro,
      anon_sym_postulate,
      anon_sym_primitive,
      anon_sym_open,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      sym_pragma,
      anon_sym_syntax,
      anon_sym_LBRACE,
      anon_sym_pattern,
      anon_sym_unquoteDecl,
      anon_sym_unquoteDef,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_AT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [349546] = 5,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(394), 1,
      anon_sym_BSLASH,
    ACTIONS(4630), 1,
      anon_sym_in,
    STATE(8994), 1,
      sym__let_body,
    ACTIONS(4240), 52,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_field,
      anon_sym_instance,
      anon_sym_module,
      anon_sym_data,
      anon_sym_codata,
      anon_sym_record,
      anon_sym_infix,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_variable,
      anon_sym_mutual,
      anon_sym_abstract,
      anon_sym_private,
      anon_sym_macro,
      anon_sym_postulate,
      anon_sym_primitive,
      anon_sym_open,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      sym_pragma,
      anon_sym_syntax,
      anon_sym_LBRACE,
      anon_sym_pattern,
      anon_sym_unquoteDecl,
      anon_sym_unquoteDef,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_AT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [349613] = 31,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(940), 1,
      sym_id,
    ACTIONS(950), 1,
      anon_sym_record,
    ACTIONS(960), 1,
      aux_sym__qid_token1,
    ACTIONS(968), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(970), 1,
      anon_sym_u2987,
    ACTIONS(976), 1,
      anon_sym_Set,
    ACTIONS(982), 1,
      anon_sym_BSLASH,
    ACTIONS(984), 1,
      anon_sym_u03bb,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(990), 1,
      anon_sym_tactic,
    ACTIONS(1302), 1,
      anon_sym_let,
    ACTIONS(4238), 1,
      anon_sym_PIPE,
    ACTIONS(4580), 1,
      anon_sym_LPAREN,
    ACTIONS(4582), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4584), 1,
      anon_sym_u2983,
    ACTIONS(4586), 1,
      anon_sym_LBRACE,
    ACTIONS(4588), 1,
      anon_sym_DOT,
    STATE(1807), 1,
      sym__ARROW,
    STATE(3982), 1,
      aux_sym__atoms,
    STATE(4712), 1,
      sym_atom,
    STATE(8095), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(974), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4632), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(4733), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4742), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8997), 7,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(948), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [349732] = 30,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2422), 1,
      sym_id,
    ACTIONS(2428), 1,
      anon_sym_BSLASH,
    ACTIONS(2430), 1,
      anon_sym_u03bb,
    ACTIONS(2434), 1,
      anon_sym_record,
    ACTIONS(2436), 1,
      anon_sym_LPAREN,
    ACTIONS(2438), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2440), 1,
      anon_sym_u2983,
    ACTIONS(2442), 1,
      anon_sym_LBRACE,
    ACTIONS(2444), 1,
      aux_sym__qid_token1,
    ACTIONS(2446), 1,
      anon_sym_DOT,
    ACTIONS(2448), 1,
      anon_sym_quoteGoal,
    ACTIONS(2450), 1,
      anon_sym_tactic,
    ACTIONS(2452), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2454), 1,
      anon_sym_u2987,
    ACTIONS(2456), 1,
      anon_sym_let,
    ACTIONS(2460), 1,
      anon_sym_Set,
    STATE(1578), 1,
      sym__ARROW,
    STATE(3528), 1,
      aux_sym__atoms,
    STATE(5596), 1,
      sym_atom,
    STATE(8125), 1,
      sym__LAMBDA,
    STATE(8423), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2424), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2458), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(4300), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(5422), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5423), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8968), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2432), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [349849] = 5,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(394), 1,
      anon_sym_BSLASH,
    ACTIONS(4634), 1,
      anon_sym_in,
    STATE(8976), 1,
      sym__let_body,
    ACTIONS(4240), 52,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_field,
      anon_sym_instance,
      anon_sym_module,
      anon_sym_data,
      anon_sym_codata,
      anon_sym_record,
      anon_sym_infix,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_variable,
      anon_sym_mutual,
      anon_sym_abstract,
      anon_sym_private,
      anon_sym_macro,
      anon_sym_postulate,
      anon_sym_primitive,
      anon_sym_open,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      sym_pragma,
      anon_sym_syntax,
      anon_sym_LBRACE,
      anon_sym_pattern,
      anon_sym_unquoteDecl,
      anon_sym_unquoteDef,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_AT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [349916] = 5,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(394), 1,
      anon_sym_BSLASH,
    ACTIONS(4502), 1,
      anon_sym_in,
    STATE(8938), 1,
      sym__let_body,
    ACTIONS(4240), 52,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_field,
      anon_sym_instance,
      anon_sym_module,
      anon_sym_data,
      anon_sym_codata,
      anon_sym_record,
      anon_sym_infix,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_variable,
      anon_sym_mutual,
      anon_sym_abstract,
      anon_sym_private,
      anon_sym_macro,
      anon_sym_postulate,
      anon_sym_primitive,
      anon_sym_open,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      sym_pragma,
      anon_sym_syntax,
      anon_sym_LBRACE,
      anon_sym_pattern,
      anon_sym_unquoteDecl,
      anon_sym_unquoteDef,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_AT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [349983] = 5,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(394), 1,
      anon_sym_BSLASH,
    ACTIONS(4616), 1,
      anon_sym_in,
    STATE(8944), 1,
      sym__let_body,
    ACTIONS(4240), 52,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_field,
      anon_sym_instance,
      anon_sym_module,
      anon_sym_data,
      anon_sym_codata,
      anon_sym_record,
      anon_sym_infix,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_variable,
      anon_sym_mutual,
      anon_sym_abstract,
      anon_sym_private,
      anon_sym_macro,
      anon_sym_postulate,
      anon_sym_primitive,
      anon_sym_open,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      sym_pragma,
      anon_sym_syntax,
      anon_sym_LBRACE,
      anon_sym_pattern,
      anon_sym_unquoteDecl,
      anon_sym_unquoteDef,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_AT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [350050] = 30,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(3168), 1,
      sym_id,
    ACTIONS(3174), 1,
      anon_sym_BSLASH,
    ACTIONS(3176), 1,
      anon_sym_u03bb,
    ACTIONS(3180), 1,
      anon_sym_record,
    ACTIONS(3182), 1,
      anon_sym_LPAREN,
    ACTIONS(3184), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3186), 1,
      anon_sym_u2983,
    ACTIONS(3188), 1,
      anon_sym_LBRACE,
    ACTIONS(3190), 1,
      aux_sym__qid_token1,
    ACTIONS(3192), 1,
      anon_sym_DOT,
    ACTIONS(3194), 1,
      anon_sym_quoteGoal,
    ACTIONS(3196), 1,
      anon_sym_tactic,
    ACTIONS(3198), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3200), 1,
      anon_sym_u2987,
    ACTIONS(3202), 1,
      anon_sym_let,
    ACTIONS(3206), 1,
      anon_sym_Set,
    STATE(2263), 1,
      sym__ARROW,
    STATE(3380), 1,
      aux_sym__atoms,
    STATE(5142), 1,
      sym_atom,
    STATE(8051), 1,
      sym__LAMBDA,
    STATE(8409), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3170), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3204), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(4636), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(4934), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4921), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8929), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3178), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [350167] = 30,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(3134), 1,
      anon_sym_BSLASH,
    ACTIONS(3136), 1,
      anon_sym_u03bb,
    ACTIONS(3154), 1,
      anon_sym_quoteGoal,
    ACTIONS(3156), 1,
      anon_sym_tactic,
    ACTIONS(3162), 1,
      anon_sym_let,
    ACTIONS(3326), 1,
      sym_id,
    ACTIONS(3332), 1,
      anon_sym_record,
    ACTIONS(3334), 1,
      anon_sym_LPAREN,
    ACTIONS(3336), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3338), 1,
      anon_sym_u2983,
    ACTIONS(3340), 1,
      anon_sym_LBRACE,
    ACTIONS(3342), 1,
      aux_sym__qid_token1,
    ACTIONS(3344), 1,
      anon_sym_DOT,
    ACTIONS(3346), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3348), 1,
      anon_sym_u2987,
    ACTIONS(3352), 1,
      anon_sym_Set,
    STATE(1681), 1,
      sym__ARROW,
    STATE(3447), 1,
      aux_sym__atoms,
    STATE(4908), 1,
      sym_atom,
    STATE(8076), 1,
      sym__LAMBDA,
    STATE(8363), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3132), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3350), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(4638), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(4650), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4649), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8929), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3330), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [350284] = 5,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(394), 1,
      anon_sym_BSLASH,
    ACTIONS(4630), 1,
      anon_sym_in,
    STATE(8943), 1,
      sym__let_body,
    ACTIONS(4240), 52,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_field,
      anon_sym_instance,
      anon_sym_module,
      anon_sym_data,
      anon_sym_codata,
      anon_sym_record,
      anon_sym_infix,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_variable,
      anon_sym_mutual,
      anon_sym_abstract,
      anon_sym_private,
      anon_sym_macro,
      anon_sym_postulate,
      anon_sym_primitive,
      anon_sym_open,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      sym_pragma,
      anon_sym_syntax,
      anon_sym_LBRACE,
      anon_sym_pattern,
      anon_sym_unquoteDecl,
      anon_sym_unquoteDef,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_AT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [350351] = 30,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(2676), 1,
      anon_sym_quoteGoal,
    ACTIONS(2684), 1,
      anon_sym_let,
    ACTIONS(2806), 1,
      sym_id,
    ACTIONS(2816), 1,
      anon_sym_record,
    ACTIONS(2818), 1,
      anon_sym_LPAREN,
    ACTIONS(2820), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2822), 1,
      anon_sym_u2983,
    ACTIONS(2824), 1,
      anon_sym_LBRACE,
    ACTIONS(2826), 1,
      aux_sym__qid_token1,
    ACTIONS(2828), 1,
      anon_sym_DOT,
    ACTIONS(2832), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2834), 1,
      anon_sym_u2987,
    ACTIONS(2838), 1,
      anon_sym_Set,
    ACTIONS(3906), 1,
      anon_sym_BSLASH,
    ACTIONS(3908), 1,
      anon_sym_u03bb,
    ACTIONS(3910), 1,
      anon_sym_tactic,
    STATE(2347), 1,
      sym__ARROW,
    STATE(3435), 1,
      aux_sym__atoms,
    STATE(5831), 1,
      sym_atom,
    STATE(8086), 1,
      sym__LAMBDA,
    STATE(8470), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2654), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2836), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(4536), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(5982), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5981), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8968), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2814), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [350468] = 5,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(394), 1,
      anon_sym_BSLASH,
    ACTIONS(4502), 1,
      anon_sym_in,
    STATE(8947), 1,
      sym__let_body,
    ACTIONS(4240), 52,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_field,
      anon_sym_instance,
      anon_sym_module,
      anon_sym_data,
      anon_sym_codata,
      anon_sym_record,
      anon_sym_infix,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_variable,
      anon_sym_mutual,
      anon_sym_abstract,
      anon_sym_private,
      anon_sym_macro,
      anon_sym_postulate,
      anon_sym_primitive,
      anon_sym_open,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      sym_pragma,
      anon_sym_syntax,
      anon_sym_LBRACE,
      anon_sym_pattern,
      anon_sym_unquoteDecl,
      anon_sym_unquoteDef,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_AT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [350535] = 5,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(394), 1,
      anon_sym_BSLASH,
    ACTIONS(4640), 1,
      anon_sym_in,
    STATE(8938), 1,
      sym__let_body,
    ACTIONS(4240), 52,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_field,
      anon_sym_instance,
      anon_sym_module,
      anon_sym_data,
      anon_sym_codata,
      anon_sym_record,
      anon_sym_infix,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_variable,
      anon_sym_mutual,
      anon_sym_abstract,
      anon_sym_private,
      anon_sym_macro,
      anon_sym_postulate,
      anon_sym_primitive,
      anon_sym_open,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      sym_pragma,
      anon_sym_syntax,
      anon_sym_LBRACE,
      anon_sym_pattern,
      anon_sym_unquoteDecl,
      anon_sym_unquoteDef,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_AT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [350602] = 5,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(394), 1,
      anon_sym_BSLASH,
    ACTIONS(4456), 1,
      anon_sym_in,
    STATE(8976), 1,
      sym__let_body,
    ACTIONS(4240), 52,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_field,
      anon_sym_instance,
      anon_sym_module,
      anon_sym_data,
      anon_sym_codata,
      anon_sym_record,
      anon_sym_infix,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_variable,
      anon_sym_mutual,
      anon_sym_abstract,
      anon_sym_private,
      anon_sym_macro,
      anon_sym_postulate,
      anon_sym_primitive,
      anon_sym_open,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      sym_pragma,
      anon_sym_syntax,
      anon_sym_LBRACE,
      anon_sym_pattern,
      anon_sym_unquoteDecl,
      anon_sym_unquoteDef,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_AT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [350669] = 30,
    ACTIONS(706), 1,
      aux_sym__qid_token1,
    ACTIONS(714), 1,
      anon_sym_quoteGoal,
    ACTIONS(722), 1,
      anon_sym_let,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(3554), 1,
      sym_id,
    ACTIONS(3556), 1,
      anon_sym_BSLASH,
    ACTIONS(3558), 1,
      anon_sym_u03bb,
    ACTIONS(3562), 1,
      anon_sym_record,
    ACTIONS(3564), 1,
      anon_sym_LPAREN,
    ACTIONS(3566), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3568), 1,
      anon_sym_u2983,
    ACTIONS(3570), 1,
      anon_sym_LBRACE,
    ACTIONS(3572), 1,
      anon_sym_DOT,
    ACTIONS(3574), 1,
      anon_sym_tactic,
    ACTIONS(3576), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3578), 1,
      anon_sym_u2987,
    ACTIONS(3582), 1,
      anon_sym_Set,
    STATE(2596), 1,
      sym__ARROW,
    STATE(3598), 1,
      aux_sym__atoms,
    STATE(5237), 1,
      sym_atom,
    STATE(8092), 1,
      sym__LAMBDA,
    STATE(8495), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(682), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3580), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(4286), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(5081), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5079), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8968), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3560), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [350786] = 5,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(394), 1,
      anon_sym_BSLASH,
    ACTIONS(4440), 1,
      anon_sym_in,
    STATE(8938), 1,
      sym__let_body,
    ACTIONS(4240), 52,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_field,
      anon_sym_instance,
      anon_sym_module,
      anon_sym_data,
      anon_sym_codata,
      anon_sym_record,
      anon_sym_infix,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_variable,
      anon_sym_mutual,
      anon_sym_abstract,
      anon_sym_private,
      anon_sym_macro,
      anon_sym_postulate,
      anon_sym_primitive,
      anon_sym_open,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      sym_pragma,
      anon_sym_syntax,
      anon_sym_LBRACE,
      anon_sym_pattern,
      anon_sym_unquoteDecl,
      anon_sym_unquoteDef,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_AT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [350853] = 5,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(394), 1,
      anon_sym_BSLASH,
    ACTIONS(4642), 1,
      anon_sym_in,
    STATE(8938), 1,
      sym__let_body,
    ACTIONS(4240), 52,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_field,
      anon_sym_instance,
      anon_sym_module,
      anon_sym_data,
      anon_sym_codata,
      anon_sym_record,
      anon_sym_infix,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_variable,
      anon_sym_mutual,
      anon_sym_abstract,
      anon_sym_private,
      anon_sym_macro,
      anon_sym_postulate,
      anon_sym_primitive,
      anon_sym_open,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      sym_pragma,
      anon_sym_syntax,
      anon_sym_LBRACE,
      anon_sym_pattern,
      anon_sym_unquoteDecl,
      anon_sym_unquoteDef,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_AT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [350920] = 5,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(394), 1,
      anon_sym_BSLASH,
    ACTIONS(4644), 1,
      anon_sym_in,
    STATE(8976), 1,
      sym__let_body,
    ACTIONS(4240), 52,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_field,
      anon_sym_instance,
      anon_sym_module,
      anon_sym_data,
      anon_sym_codata,
      anon_sym_record,
      anon_sym_infix,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_variable,
      anon_sym_mutual,
      anon_sym_abstract,
      anon_sym_private,
      anon_sym_macro,
      anon_sym_postulate,
      anon_sym_primitive,
      anon_sym_open,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      sym_pragma,
      anon_sym_syntax,
      anon_sym_LBRACE,
      anon_sym_pattern,
      anon_sym_unquoteDecl,
      anon_sym_unquoteDef,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_AT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [350987] = 5,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(394), 1,
      anon_sym_BSLASH,
    ACTIONS(4640), 1,
      anon_sym_in,
    STATE(8947), 1,
      sym__let_body,
    ACTIONS(4240), 52,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_field,
      anon_sym_instance,
      anon_sym_module,
      anon_sym_data,
      anon_sym_codata,
      anon_sym_record,
      anon_sym_infix,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_variable,
      anon_sym_mutual,
      anon_sym_abstract,
      anon_sym_private,
      anon_sym_macro,
      anon_sym_postulate,
      anon_sym_primitive,
      anon_sym_open,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      sym_pragma,
      anon_sym_syntax,
      anon_sym_LBRACE,
      anon_sym_pattern,
      anon_sym_unquoteDecl,
      anon_sym_unquoteDef,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_AT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [351054] = 5,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(394), 1,
      anon_sym_BSLASH,
    ACTIONS(4646), 1,
      anon_sym_in,
    STATE(8944), 1,
      sym__let_body,
    ACTIONS(4240), 52,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_field,
      anon_sym_instance,
      anon_sym_module,
      anon_sym_data,
      anon_sym_codata,
      anon_sym_record,
      anon_sym_infix,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_variable,
      anon_sym_mutual,
      anon_sym_abstract,
      anon_sym_private,
      anon_sym_macro,
      anon_sym_postulate,
      anon_sym_primitive,
      anon_sym_open,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      sym_pragma,
      anon_sym_syntax,
      anon_sym_LBRACE,
      anon_sym_pattern,
      anon_sym_unquoteDecl,
      anon_sym_unquoteDef,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_AT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [351121] = 5,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(394), 1,
      anon_sym_BSLASH,
    ACTIONS(4648), 1,
      anon_sym_in,
    STATE(8994), 1,
      sym__let_body,
    ACTIONS(4240), 52,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_field,
      anon_sym_instance,
      anon_sym_module,
      anon_sym_data,
      anon_sym_codata,
      anon_sym_record,
      anon_sym_infix,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_variable,
      anon_sym_mutual,
      anon_sym_abstract,
      anon_sym_private,
      anon_sym_macro,
      anon_sym_postulate,
      anon_sym_primitive,
      anon_sym_open,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      sym_pragma,
      anon_sym_syntax,
      anon_sym_LBRACE,
      anon_sym_pattern,
      anon_sym_unquoteDecl,
      anon_sym_unquoteDef,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_AT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [351188] = 5,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(394), 1,
      anon_sym_BSLASH,
    ACTIONS(4650), 1,
      anon_sym_in,
    STATE(9478), 1,
      sym__let_body,
    ACTIONS(4240), 52,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_field,
      anon_sym_instance,
      anon_sym_module,
      anon_sym_data,
      anon_sym_codata,
      anon_sym_record,
      anon_sym_infix,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_variable,
      anon_sym_mutual,
      anon_sym_abstract,
      anon_sym_private,
      anon_sym_macro,
      anon_sym_postulate,
      anon_sym_primitive,
      anon_sym_open,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      sym_pragma,
      anon_sym_syntax,
      anon_sym_LBRACE,
      anon_sym_pattern,
      anon_sym_unquoteDecl,
      anon_sym_unquoteDef,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_AT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [351255] = 5,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(394), 1,
      anon_sym_BSLASH,
    ACTIONS(4652), 1,
      anon_sym_in,
    STATE(8947), 1,
      sym__let_body,
    ACTIONS(4240), 52,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_field,
      anon_sym_instance,
      anon_sym_module,
      anon_sym_data,
      anon_sym_codata,
      anon_sym_record,
      anon_sym_infix,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_variable,
      anon_sym_mutual,
      anon_sym_abstract,
      anon_sym_private,
      anon_sym_macro,
      anon_sym_postulate,
      anon_sym_primitive,
      anon_sym_open,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      sym_pragma,
      anon_sym_syntax,
      anon_sym_LBRACE,
      anon_sym_pattern,
      anon_sym_unquoteDecl,
      anon_sym_unquoteDef,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_AT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [351322] = 5,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(394), 1,
      anon_sym_BSLASH,
    ACTIONS(4246), 1,
      anon_sym_in,
    STATE(8938), 1,
      sym__let_body,
    ACTIONS(4240), 52,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_field,
      anon_sym_instance,
      anon_sym_module,
      anon_sym_data,
      anon_sym_codata,
      anon_sym_record,
      anon_sym_infix,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_variable,
      anon_sym_mutual,
      anon_sym_abstract,
      anon_sym_private,
      anon_sym_macro,
      anon_sym_postulate,
      anon_sym_primitive,
      anon_sym_open,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      sym_pragma,
      anon_sym_syntax,
      anon_sym_LBRACE,
      anon_sym_pattern,
      anon_sym_unquoteDecl,
      anon_sym_unquoteDef,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_AT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [351389] = 31,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(2652), 1,
      sym_id,
    ACTIONS(2656), 1,
      anon_sym_BSLASH,
    ACTIONS(2658), 1,
      anon_sym_u03bb,
    ACTIONS(2662), 1,
      anon_sym_record,
    ACTIONS(2672), 1,
      aux_sym__qid_token1,
    ACTIONS(2676), 1,
      anon_sym_quoteGoal,
    ACTIONS(2678), 1,
      anon_sym_tactic,
    ACTIONS(2680), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2682), 1,
      anon_sym_u2987,
    ACTIONS(2684), 1,
      anon_sym_let,
    ACTIONS(2688), 1,
      anon_sym_Set,
    ACTIONS(4238), 1,
      anon_sym_PIPE,
    ACTIONS(4524), 1,
      anon_sym_LPAREN,
    ACTIONS(4526), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4528), 1,
      anon_sym_u2983,
    ACTIONS(4530), 1,
      anon_sym_LBRACE,
    ACTIONS(4532), 1,
      anon_sym_DOT,
    STATE(1967), 1,
      sym__ARROW,
    STATE(3982), 1,
      aux_sym__atoms,
    STATE(4916), 1,
      sym_atom,
    STATE(8132), 1,
      sym__LAMBDA,
    STATE(8470), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2654), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2686), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(4654), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(4732), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4735), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9454), 7,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2660), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [351508] = 5,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(394), 1,
      anon_sym_BSLASH,
    ACTIONS(4438), 1,
      anon_sym_in,
    STATE(8943), 1,
      sym__let_body,
    ACTIONS(4240), 52,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_field,
      anon_sym_instance,
      anon_sym_module,
      anon_sym_data,
      anon_sym_codata,
      anon_sym_record,
      anon_sym_infix,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_variable,
      anon_sym_mutual,
      anon_sym_abstract,
      anon_sym_private,
      anon_sym_macro,
      anon_sym_postulate,
      anon_sym_primitive,
      anon_sym_open,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      sym_pragma,
      anon_sym_syntax,
      anon_sym_LBRACE,
      anon_sym_pattern,
      anon_sym_unquoteDecl,
      anon_sym_unquoteDef,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_AT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [351575] = 5,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(394), 1,
      anon_sym_BSLASH,
    ACTIONS(4440), 1,
      anon_sym_in,
    STATE(8947), 1,
      sym__let_body,
    ACTIONS(4240), 52,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_field,
      anon_sym_instance,
      anon_sym_module,
      anon_sym_data,
      anon_sym_codata,
      anon_sym_record,
      anon_sym_infix,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_variable,
      anon_sym_mutual,
      anon_sym_abstract,
      anon_sym_private,
      anon_sym_macro,
      anon_sym_postulate,
      anon_sym_primitive,
      anon_sym_open,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      sym_pragma,
      anon_sym_syntax,
      anon_sym_LBRACE,
      anon_sym_pattern,
      anon_sym_unquoteDecl,
      anon_sym_unquoteDef,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_AT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [351642] = 31,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(3814), 1,
      sym_id,
    ACTIONS(3818), 1,
      anon_sym_BSLASH,
    ACTIONS(3820), 1,
      anon_sym_u03bb,
    ACTIONS(3824), 1,
      anon_sym_record,
    ACTIONS(3834), 1,
      aux_sym__qid_token1,
    ACTIONS(3838), 1,
      anon_sym_quoteGoal,
    ACTIONS(3840), 1,
      anon_sym_tactic,
    ACTIONS(3842), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3844), 1,
      anon_sym_u2987,
    ACTIONS(3846), 1,
      anon_sym_let,
    ACTIONS(3850), 1,
      anon_sym_Set,
    ACTIONS(4238), 1,
      anon_sym_PIPE,
    ACTIONS(4658), 1,
      anon_sym_LPAREN,
    ACTIONS(4660), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4662), 1,
      anon_sym_u2983,
    ACTIONS(4664), 1,
      anon_sym_LBRACE,
    ACTIONS(4666), 1,
      anon_sym_DOT,
    STATE(2328), 1,
      sym__ARROW,
    STATE(3982), 1,
      aux_sym__atoms,
    STATE(4371), 1,
      sym_atom,
    STATE(8085), 1,
      sym__LAMBDA,
    STATE(8442), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3816), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3848), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(4656), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(4342), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4273), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9001), 7,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3822), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [351761] = 30,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(2350), 1,
      anon_sym_BSLASH,
    ACTIONS(2352), 1,
      anon_sym_u03bb,
    ACTIONS(2370), 1,
      anon_sym_quoteGoal,
    ACTIONS(2372), 1,
      anon_sym_tactic,
    ACTIONS(2378), 1,
      anon_sym_let,
    ACTIONS(3786), 1,
      sym_id,
    ACTIONS(3792), 1,
      anon_sym_record,
    ACTIONS(3794), 1,
      anon_sym_LPAREN,
    ACTIONS(3796), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3798), 1,
      anon_sym_u2983,
    ACTIONS(3800), 1,
      anon_sym_LBRACE,
    ACTIONS(3802), 1,
      aux_sym__qid_token1,
    ACTIONS(3804), 1,
      anon_sym_DOT,
    ACTIONS(3806), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3808), 1,
      anon_sym_u2987,
    ACTIONS(3812), 1,
      anon_sym_Set,
    STATE(1482), 1,
      sym__ARROW,
    STATE(3656), 1,
      aux_sym__atoms,
    STATE(4255), 1,
      sym_atom,
    STATE(8119), 1,
      sym__LAMBDA,
    STATE(8372), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2348), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3810), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(4668), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(4284), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4282), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8929), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3790), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [351878] = 5,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(394), 1,
      anon_sym_BSLASH,
    ACTIONS(4646), 1,
      anon_sym_in,
    STATE(8994), 1,
      sym__let_body,
    ACTIONS(4240), 52,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_field,
      anon_sym_instance,
      anon_sym_module,
      anon_sym_data,
      anon_sym_codata,
      anon_sym_record,
      anon_sym_infix,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_variable,
      anon_sym_mutual,
      anon_sym_abstract,
      anon_sym_private,
      anon_sym_macro,
      anon_sym_postulate,
      anon_sym_primitive,
      anon_sym_open,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      sym_pragma,
      anon_sym_syntax,
      anon_sym_LBRACE,
      anon_sym_pattern,
      anon_sym_unquoteDecl,
      anon_sym_unquoteDef,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_AT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [351945] = 5,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(394), 1,
      anon_sym_BSLASH,
    ACTIONS(4670), 1,
      anon_sym_in,
    STATE(8994), 1,
      sym__let_body,
    ACTIONS(4240), 52,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_field,
      anon_sym_instance,
      anon_sym_module,
      anon_sym_data,
      anon_sym_codata,
      anon_sym_record,
      anon_sym_infix,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_variable,
      anon_sym_mutual,
      anon_sym_abstract,
      anon_sym_private,
      anon_sym_macro,
      anon_sym_postulate,
      anon_sym_primitive,
      anon_sym_open,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      sym_pragma,
      anon_sym_syntax,
      anon_sym_LBRACE,
      anon_sym_pattern,
      anon_sym_unquoteDecl,
      anon_sym_unquoteDef,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_AT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [352012] = 5,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(394), 1,
      anon_sym_BSLASH,
    ACTIONS(4670), 1,
      anon_sym_in,
    STATE(8944), 1,
      sym__let_body,
    ACTIONS(4240), 52,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_field,
      anon_sym_instance,
      anon_sym_module,
      anon_sym_data,
      anon_sym_codata,
      anon_sym_record,
      anon_sym_infix,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_variable,
      anon_sym_mutual,
      anon_sym_abstract,
      anon_sym_private,
      anon_sym_macro,
      anon_sym_postulate,
      anon_sym_primitive,
      anon_sym_open,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      sym_pragma,
      anon_sym_syntax,
      anon_sym_LBRACE,
      anon_sym_pattern,
      anon_sym_unquoteDecl,
      anon_sym_unquoteDef,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_AT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [352079] = 5,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(394), 1,
      anon_sym_BSLASH,
    ACTIONS(4454), 1,
      anon_sym_in,
    STATE(8994), 1,
      sym__let_body,
    ACTIONS(4240), 52,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_field,
      anon_sym_instance,
      anon_sym_module,
      anon_sym_data,
      anon_sym_codata,
      anon_sym_record,
      anon_sym_infix,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_variable,
      anon_sym_mutual,
      anon_sym_abstract,
      anon_sym_private,
      anon_sym_macro,
      anon_sym_postulate,
      anon_sym_primitive,
      anon_sym_open,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      sym_pragma,
      anon_sym_syntax,
      anon_sym_LBRACE,
      anon_sym_pattern,
      anon_sym_unquoteDecl,
      anon_sym_unquoteDef,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_AT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [352146] = 5,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(394), 1,
      anon_sym_BSLASH,
    ACTIONS(4242), 1,
      anon_sym_in,
    STATE(8994), 1,
      sym__let_body,
    ACTIONS(4240), 52,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_field,
      anon_sym_instance,
      anon_sym_module,
      anon_sym_data,
      anon_sym_codata,
      anon_sym_record,
      anon_sym_infix,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_variable,
      anon_sym_mutual,
      anon_sym_abstract,
      anon_sym_private,
      anon_sym_macro,
      anon_sym_postulate,
      anon_sym_primitive,
      anon_sym_open,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      sym_pragma,
      anon_sym_syntax,
      anon_sym_LBRACE,
      anon_sym_pattern,
      anon_sym_unquoteDecl,
      anon_sym_unquoteDef,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_AT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [352213] = 5,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(394), 1,
      anon_sym_BSLASH,
    ACTIONS(4454), 1,
      anon_sym_in,
    STATE(8944), 1,
      sym__let_body,
    ACTIONS(4240), 52,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_field,
      anon_sym_instance,
      anon_sym_module,
      anon_sym_data,
      anon_sym_codata,
      anon_sym_record,
      anon_sym_infix,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_variable,
      anon_sym_mutual,
      anon_sym_abstract,
      anon_sym_private,
      anon_sym_macro,
      anon_sym_postulate,
      anon_sym_primitive,
      anon_sym_open,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      sym_pragma,
      anon_sym_syntax,
      anon_sym_LBRACE,
      anon_sym_pattern,
      anon_sym_unquoteDecl,
      anon_sym_unquoteDef,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_AT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [352280] = 5,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(394), 1,
      anon_sym_BSLASH,
    ACTIONS(4650), 1,
      anon_sym_in,
    STATE(9480), 1,
      sym__let_body,
    ACTIONS(4240), 52,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_field,
      anon_sym_instance,
      anon_sym_module,
      anon_sym_data,
      anon_sym_codata,
      anon_sym_record,
      anon_sym_infix,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_variable,
      anon_sym_mutual,
      anon_sym_abstract,
      anon_sym_private,
      anon_sym_macro,
      anon_sym_postulate,
      anon_sym_primitive,
      anon_sym_open,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      sym_pragma,
      anon_sym_syntax,
      anon_sym_LBRACE,
      anon_sym_pattern,
      anon_sym_unquoteDecl,
      anon_sym_unquoteDef,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_AT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [352347] = 5,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(394), 1,
      anon_sym_BSLASH,
    ACTIONS(4672), 1,
      anon_sym_in,
    STATE(8943), 1,
      sym__let_body,
    ACTIONS(4240), 52,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_field,
      anon_sym_instance,
      anon_sym_module,
      anon_sym_data,
      anon_sym_codata,
      anon_sym_record,
      anon_sym_infix,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_variable,
      anon_sym_mutual,
      anon_sym_abstract,
      anon_sym_private,
      anon_sym_macro,
      anon_sym_postulate,
      anon_sym_primitive,
      anon_sym_open,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      sym_pragma,
      anon_sym_syntax,
      anon_sym_LBRACE,
      anon_sym_pattern,
      anon_sym_unquoteDecl,
      anon_sym_unquoteDef,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_AT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [352414] = 5,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(394), 1,
      anon_sym_BSLASH,
    ACTIONS(4674), 1,
      anon_sym_in,
    STATE(9478), 1,
      sym__let_body,
    ACTIONS(4240), 52,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_field,
      anon_sym_instance,
      anon_sym_module,
      anon_sym_data,
      anon_sym_codata,
      anon_sym_record,
      anon_sym_infix,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_variable,
      anon_sym_mutual,
      anon_sym_abstract,
      anon_sym_private,
      anon_sym_macro,
      anon_sym_postulate,
      anon_sym_primitive,
      anon_sym_open,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      sym_pragma,
      anon_sym_syntax,
      anon_sym_LBRACE,
      anon_sym_pattern,
      anon_sym_unquoteDecl,
      anon_sym_unquoteDef,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_AT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [352481] = 5,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(394), 1,
      anon_sym_BSLASH,
    ACTIONS(4350), 1,
      anon_sym_in,
    STATE(8994), 1,
      sym__let_body,
    ACTIONS(4240), 52,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_field,
      anon_sym_instance,
      anon_sym_module,
      anon_sym_data,
      anon_sym_codata,
      anon_sym_record,
      anon_sym_infix,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_variable,
      anon_sym_mutual,
      anon_sym_abstract,
      anon_sym_private,
      anon_sym_macro,
      anon_sym_postulate,
      anon_sym_primitive,
      anon_sym_open,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      sym_pragma,
      anon_sym_syntax,
      anon_sym_LBRACE,
      anon_sym_pattern,
      anon_sym_unquoteDecl,
      anon_sym_unquoteDef,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_AT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [352548] = 5,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(394), 1,
      anon_sym_BSLASH,
    ACTIONS(4350), 1,
      anon_sym_in,
    STATE(8944), 1,
      sym__let_body,
    ACTIONS(4240), 52,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_field,
      anon_sym_instance,
      anon_sym_module,
      anon_sym_data,
      anon_sym_codata,
      anon_sym_record,
      anon_sym_infix,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_variable,
      anon_sym_mutual,
      anon_sym_abstract,
      anon_sym_private,
      anon_sym_macro,
      anon_sym_postulate,
      anon_sym_primitive,
      anon_sym_open,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      sym_pragma,
      anon_sym_syntax,
      anon_sym_LBRACE,
      anon_sym_pattern,
      anon_sym_unquoteDecl,
      anon_sym_unquoteDef,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_AT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [352615] = 31,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(109), 1,
      anon_sym_BSLASH,
    ACTIONS(111), 1,
      anon_sym_u03bb,
    ACTIONS(147), 1,
      anon_sym_quoteGoal,
    ACTIONS(149), 1,
      anon_sym_tactic,
    ACTIONS(155), 1,
      anon_sym_let,
    ACTIONS(2462), 1,
      sym_id,
    ACTIONS(2466), 1,
      anon_sym_record,
    ACTIONS(2476), 1,
      aux_sym__qid_token1,
    ACTIONS(2480), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2482), 1,
      anon_sym_u2987,
    ACTIONS(2486), 1,
      anon_sym_Set,
    ACTIONS(4238), 1,
      anon_sym_PIPE,
    ACTIONS(4678), 1,
      anon_sym_LPAREN,
    ACTIONS(4680), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4682), 1,
      anon_sym_u2983,
    ACTIONS(4684), 1,
      anon_sym_LBRACE,
    ACTIONS(4686), 1,
      anon_sym_DOT,
    STATE(1653), 1,
      sym__ARROW,
    STATE(3982), 1,
      aux_sym__atoms,
    STATE(4054), 1,
      sym_atom,
    STATE(8146), 1,
      sym__LAMBDA,
    STATE(8343), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(107), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2484), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(4676), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(4044), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4052), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9001), 7,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2464), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [352734] = 5,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(394), 1,
      anon_sym_BSLASH,
    ACTIONS(4688), 1,
      anon_sym_in,
    STATE(8943), 1,
      sym__let_body,
    ACTIONS(4240), 52,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_field,
      anon_sym_instance,
      anon_sym_module,
      anon_sym_data,
      anon_sym_codata,
      anon_sym_record,
      anon_sym_infix,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_variable,
      anon_sym_mutual,
      anon_sym_abstract,
      anon_sym_private,
      anon_sym_macro,
      anon_sym_postulate,
      anon_sym_primitive,
      anon_sym_open,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      sym_pragma,
      anon_sym_syntax,
      anon_sym_LBRACE,
      anon_sym_pattern,
      anon_sym_unquoteDecl,
      anon_sym_unquoteDef,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_AT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [352801] = 5,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(394), 1,
      anon_sym_BSLASH,
    ACTIONS(4674), 1,
      anon_sym_in,
    STATE(9480), 1,
      sym__let_body,
    ACTIONS(4240), 52,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_field,
      anon_sym_instance,
      anon_sym_module,
      anon_sym_data,
      anon_sym_codata,
      anon_sym_record,
      anon_sym_infix,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_variable,
      anon_sym_mutual,
      anon_sym_abstract,
      anon_sym_private,
      anon_sym_macro,
      anon_sym_postulate,
      anon_sym_primitive,
      anon_sym_open,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      sym_pragma,
      anon_sym_syntax,
      anon_sym_LBRACE,
      anon_sym_pattern,
      anon_sym_unquoteDecl,
      anon_sym_unquoteDef,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_AT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [352868] = 31,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    ACTIONS(4238), 1,
      anon_sym_PIPE,
    ACTIONS(4540), 1,
      anon_sym_LPAREN,
    ACTIONS(4542), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4544), 1,
      anon_sym_u2983,
    ACTIONS(4546), 1,
      anon_sym_LBRACE,
    ACTIONS(4548), 1,
      anon_sym_DOT,
    STATE(1848), 1,
      sym__ARROW,
    STATE(3982), 1,
      aux_sym__atoms,
    STATE(5247), 1,
      sym_atom,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4690), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8997), 7,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [352987] = 5,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(394), 1,
      anon_sym_BSLASH,
    ACTIONS(4378), 1,
      anon_sym_in,
    STATE(8943), 1,
      sym__let_body,
    ACTIONS(4240), 52,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_field,
      anon_sym_instance,
      anon_sym_module,
      anon_sym_data,
      anon_sym_codata,
      anon_sym_record,
      anon_sym_infix,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_variable,
      anon_sym_mutual,
      anon_sym_abstract,
      anon_sym_private,
      anon_sym_macro,
      anon_sym_postulate,
      anon_sym_primitive,
      anon_sym_open,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      sym_pragma,
      anon_sym_syntax,
      anon_sym_LBRACE,
      anon_sym_pattern,
      anon_sym_unquoteDecl,
      anon_sym_unquoteDef,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_AT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [353054] = 5,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(394), 1,
      anon_sym_BSLASH,
    ACTIONS(4642), 1,
      anon_sym_in,
    STATE(8947), 1,
      sym__let_body,
    ACTIONS(4240), 52,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_field,
      anon_sym_instance,
      anon_sym_module,
      anon_sym_data,
      anon_sym_codata,
      anon_sym_record,
      anon_sym_infix,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_variable,
      anon_sym_mutual,
      anon_sym_abstract,
      anon_sym_private,
      anon_sym_macro,
      anon_sym_postulate,
      anon_sym_primitive,
      anon_sym_open,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      sym_pragma,
      anon_sym_syntax,
      anon_sym_LBRACE,
      anon_sym_pattern,
      anon_sym_unquoteDecl,
      anon_sym_unquoteDef,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_AT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [353121] = 5,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(394), 1,
      anon_sym_BSLASH,
    ACTIONS(4566), 1,
      anon_sym_in,
    STATE(9478), 1,
      sym__let_body,
    ACTIONS(4240), 52,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_field,
      anon_sym_instance,
      anon_sym_module,
      anon_sym_data,
      anon_sym_codata,
      anon_sym_record,
      anon_sym_infix,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_variable,
      anon_sym_mutual,
      anon_sym_abstract,
      anon_sym_private,
      anon_sym_macro,
      anon_sym_postulate,
      anon_sym_primitive,
      anon_sym_open,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      sym_pragma,
      anon_sym_syntax,
      anon_sym_LBRACE,
      anon_sym_pattern,
      anon_sym_unquoteDecl,
      anon_sym_unquoteDef,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_AT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [353188] = 31,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(3406), 1,
      sym_id,
    ACTIONS(3410), 1,
      anon_sym_BSLASH,
    ACTIONS(3412), 1,
      anon_sym_u03bb,
    ACTIONS(3416), 1,
      anon_sym_record,
    ACTIONS(3426), 1,
      aux_sym__qid_token1,
    ACTIONS(3430), 1,
      anon_sym_quoteGoal,
    ACTIONS(3432), 1,
      anon_sym_tactic,
    ACTIONS(3434), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3436), 1,
      anon_sym_u2987,
    ACTIONS(3438), 1,
      anon_sym_let,
    ACTIONS(3442), 1,
      anon_sym_Set,
    ACTIONS(4238), 1,
      anon_sym_PIPE,
    ACTIONS(4694), 1,
      anon_sym_LPAREN,
    ACTIONS(4696), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4698), 1,
      anon_sym_u2983,
    ACTIONS(4700), 1,
      anon_sym_LBRACE,
    ACTIONS(4702), 1,
      anon_sym_DOT,
    STATE(1814), 1,
      sym__ARROW,
    STATE(3982), 1,
      aux_sym__atoms,
    STATE(4189), 1,
      sym_atom,
    STATE(8038), 1,
      sym__LAMBDA,
    STATE(8435), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3408), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3440), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(4692), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(4158), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4162), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9001), 7,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3414), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [353307] = 5,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(394), 1,
      anon_sym_BSLASH,
    ACTIONS(4566), 1,
      anon_sym_in,
    STATE(9480), 1,
      sym__let_body,
    ACTIONS(4240), 52,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_field,
      anon_sym_instance,
      anon_sym_module,
      anon_sym_data,
      anon_sym_codata,
      anon_sym_record,
      anon_sym_infix,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_variable,
      anon_sym_mutual,
      anon_sym_abstract,
      anon_sym_private,
      anon_sym_macro,
      anon_sym_postulate,
      anon_sym_primitive,
      anon_sym_open,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      sym_pragma,
      anon_sym_syntax,
      anon_sym_LBRACE,
      anon_sym_pattern,
      anon_sym_unquoteDecl,
      anon_sym_unquoteDef,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_AT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [353374] = 5,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(394), 1,
      anon_sym_BSLASH,
    ACTIONS(4474), 1,
      anon_sym_in,
    STATE(8943), 1,
      sym__let_body,
    ACTIONS(4240), 52,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_field,
      anon_sym_instance,
      anon_sym_module,
      anon_sym_data,
      anon_sym_codata,
      anon_sym_record,
      anon_sym_infix,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_variable,
      anon_sym_mutual,
      anon_sym_abstract,
      anon_sym_private,
      anon_sym_macro,
      anon_sym_postulate,
      anon_sym_primitive,
      anon_sym_open,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      sym_pragma,
      anon_sym_syntax,
      anon_sym_LBRACE,
      anon_sym_pattern,
      anon_sym_unquoteDecl,
      anon_sym_unquoteDef,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_AT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [353441] = 5,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(394), 1,
      anon_sym_BSLASH,
    ACTIONS(4316), 1,
      anon_sym_in,
    STATE(8947), 1,
      sym__let_body,
    ACTIONS(4240), 52,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_field,
      anon_sym_instance,
      anon_sym_module,
      anon_sym_data,
      anon_sym_codata,
      anon_sym_record,
      anon_sym_infix,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_variable,
      anon_sym_mutual,
      anon_sym_abstract,
      anon_sym_private,
      anon_sym_macro,
      anon_sym_postulate,
      anon_sym_primitive,
      anon_sym_open,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      sym_pragma,
      anon_sym_syntax,
      anon_sym_LBRACE,
      anon_sym_pattern,
      anon_sym_unquoteDecl,
      anon_sym_unquoteDef,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_AT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [353508] = 5,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(394), 1,
      anon_sym_BSLASH,
    ACTIONS(4316), 1,
      anon_sym_in,
    STATE(8938), 1,
      sym__let_body,
    ACTIONS(4240), 52,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_field,
      anon_sym_instance,
      anon_sym_module,
      anon_sym_data,
      anon_sym_codata,
      anon_sym_record,
      anon_sym_infix,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_variable,
      anon_sym_mutual,
      anon_sym_abstract,
      anon_sym_private,
      anon_sym_macro,
      anon_sym_postulate,
      anon_sym_primitive,
      anon_sym_open,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      sym_pragma,
      anon_sym_syntax,
      anon_sym_LBRACE,
      anon_sym_pattern,
      anon_sym_unquoteDecl,
      anon_sym_unquoteDef,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_AT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [353575] = 31,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2018), 1,
      sym_id,
    ACTIONS(2022), 1,
      anon_sym_BSLASH,
    ACTIONS(2024), 1,
      anon_sym_u03bb,
    ACTIONS(2028), 1,
      anon_sym_record,
    ACTIONS(2038), 1,
      aux_sym__qid_token1,
    ACTIONS(2042), 1,
      anon_sym_quoteGoal,
    ACTIONS(2044), 1,
      anon_sym_tactic,
    ACTIONS(2046), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2048), 1,
      anon_sym_u2987,
    ACTIONS(2050), 1,
      anon_sym_let,
    ACTIONS(2054), 1,
      anon_sym_Set,
    ACTIONS(4238), 1,
      anon_sym_PIPE,
    ACTIONS(4706), 1,
      anon_sym_LPAREN,
    ACTIONS(4708), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4710), 1,
      anon_sym_u2983,
    ACTIONS(4712), 1,
      anon_sym_LBRACE,
    ACTIONS(4714), 1,
      anon_sym_DOT,
    STATE(1475), 1,
      sym__ARROW,
    STATE(3982), 1,
      aux_sym__atoms,
    STATE(4997), 1,
      sym_atom,
    STATE(8033), 1,
      sym__LAMBDA,
    STATE(8463), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2020), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2052), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(4704), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(5176), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5183), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8997), 7,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2026), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [353694] = 5,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(394), 1,
      anon_sym_BSLASH,
    ACTIONS(4348), 1,
      anon_sym_in,
    STATE(8976), 1,
      sym__let_body,
    ACTIONS(4240), 52,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_field,
      anon_sym_instance,
      anon_sym_module,
      anon_sym_data,
      anon_sym_codata,
      anon_sym_record,
      anon_sym_infix,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_variable,
      anon_sym_mutual,
      anon_sym_abstract,
      anon_sym_private,
      anon_sym_macro,
      anon_sym_postulate,
      anon_sym_primitive,
      anon_sym_open,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      sym_pragma,
      anon_sym_syntax,
      anon_sym_LBRACE,
      anon_sym_pattern,
      anon_sym_unquoteDecl,
      anon_sym_unquoteDef,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_AT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [353761] = 5,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(394), 1,
      anon_sym_BSLASH,
    ACTIONS(4516), 1,
      anon_sym_in,
    STATE(8976), 1,
      sym__let_body,
    ACTIONS(4240), 52,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_field,
      anon_sym_instance,
      anon_sym_module,
      anon_sym_data,
      anon_sym_codata,
      anon_sym_record,
      anon_sym_infix,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_variable,
      anon_sym_mutual,
      anon_sym_abstract,
      anon_sym_private,
      anon_sym_macro,
      anon_sym_postulate,
      anon_sym_primitive,
      anon_sym_open,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      sym_pragma,
      anon_sym_syntax,
      anon_sym_LBRACE,
      anon_sym_pattern,
      anon_sym_unquoteDecl,
      anon_sym_unquoteDef,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_AT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [353828] = 31,
    ACTIONS(850), 1,
      sym_id,
    ACTIONS(854), 1,
      anon_sym_BSLASH,
    ACTIONS(856), 1,
      anon_sym_u03bb,
    ACTIONS(860), 1,
      anon_sym_record,
    ACTIONS(872), 1,
      aux_sym__qid_token1,
    ACTIONS(878), 1,
      anon_sym_quoteGoal,
    ACTIONS(880), 1,
      anon_sym_tactic,
    ACTIONS(882), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(884), 1,
      anon_sym_u2987,
    ACTIONS(886), 1,
      anon_sym_let,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(892), 1,
      anon_sym_Set,
    ACTIONS(4238), 1,
      anon_sym_PIPE,
    ACTIONS(4290), 1,
      anon_sym_LPAREN,
    ACTIONS(4292), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4294), 1,
      anon_sym_u2983,
    ACTIONS(4296), 1,
      anon_sym_LBRACE,
    ACTIONS(4298), 1,
      anon_sym_DOT,
    STATE(2027), 1,
      sym__ARROW,
    STATE(3982), 1,
      aux_sym__atoms,
    STATE(5204), 1,
      sym_atom,
    STATE(8152), 1,
      sym__LAMBDA,
    STATE(8369), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(852), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(890), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(4716), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(5180), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5168), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8997), 7,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(858), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [353947] = 30,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2302), 1,
      anon_sym_BSLASH,
    ACTIONS(2304), 1,
      anon_sym_u03bb,
    ACTIONS(2322), 1,
      anon_sym_quoteGoal,
    ACTIONS(2324), 1,
      anon_sym_tactic,
    ACTIONS(2330), 1,
      anon_sym_let,
    ACTIONS(3638), 1,
      sym_id,
    ACTIONS(3644), 1,
      anon_sym_record,
    ACTIONS(3646), 1,
      anon_sym_LPAREN,
    ACTIONS(3648), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3650), 1,
      anon_sym_u2983,
    ACTIONS(3652), 1,
      anon_sym_LBRACE,
    ACTIONS(3654), 1,
      aux_sym__qid_token1,
    ACTIONS(3656), 1,
      anon_sym_DOT,
    ACTIONS(3658), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3660), 1,
      anon_sym_u2987,
    ACTIONS(3664), 1,
      anon_sym_Set,
    STATE(1611), 1,
      sym__ARROW,
    STATE(3349), 1,
      aux_sym__atoms,
    STATE(5734), 1,
      sym_atom,
    STATE(8138), 1,
      sym__LAMBDA,
    STATE(8476), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2300), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3662), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(4718), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(5680), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5681), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8968), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3642), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [354064] = 31,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(940), 1,
      sym_id,
    ACTIONS(944), 1,
      anon_sym_BSLASH,
    ACTIONS(946), 1,
      anon_sym_u03bb,
    ACTIONS(950), 1,
      anon_sym_record,
    ACTIONS(960), 1,
      aux_sym__qid_token1,
    ACTIONS(964), 1,
      anon_sym_quoteGoal,
    ACTIONS(966), 1,
      anon_sym_tactic,
    ACTIONS(968), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(970), 1,
      anon_sym_u2987,
    ACTIONS(972), 1,
      anon_sym_let,
    ACTIONS(976), 1,
      anon_sym_Set,
    ACTIONS(4238), 1,
      anon_sym_PIPE,
    ACTIONS(4580), 1,
      anon_sym_LPAREN,
    ACTIONS(4582), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4584), 1,
      anon_sym_u2983,
    ACTIONS(4586), 1,
      anon_sym_LBRACE,
    ACTIONS(4588), 1,
      anon_sym_DOT,
    STATE(1848), 1,
      sym__ARROW,
    STATE(3982), 1,
      aux_sym__atoms,
    STATE(4712), 1,
      sym_atom,
    STATE(8054), 1,
      sym__LAMBDA,
    STATE(8355), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(942), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(974), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(4690), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(4733), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4742), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8997), 7,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(948), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [354183] = 5,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(394), 1,
      anon_sym_BSLASH,
    ACTIONS(4348), 1,
      anon_sym_in,
    STATE(8938), 1,
      sym__let_body,
    ACTIONS(4240), 52,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_field,
      anon_sym_instance,
      anon_sym_module,
      anon_sym_data,
      anon_sym_codata,
      anon_sym_record,
      anon_sym_infix,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_variable,
      anon_sym_mutual,
      anon_sym_abstract,
      anon_sym_private,
      anon_sym_macro,
      anon_sym_postulate,
      anon_sym_primitive,
      anon_sym_open,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      sym_pragma,
      anon_sym_syntax,
      anon_sym_LBRACE,
      anon_sym_pattern,
      anon_sym_unquoteDecl,
      anon_sym_unquoteDef,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_AT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [354250] = 31,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(940), 1,
      sym_id,
    ACTIONS(944), 1,
      anon_sym_BSLASH,
    ACTIONS(946), 1,
      anon_sym_u03bb,
    ACTIONS(950), 1,
      anon_sym_record,
    ACTIONS(960), 1,
      aux_sym__qid_token1,
    ACTIONS(964), 1,
      anon_sym_quoteGoal,
    ACTIONS(966), 1,
      anon_sym_tactic,
    ACTIONS(968), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(970), 1,
      anon_sym_u2987,
    ACTIONS(972), 1,
      anon_sym_let,
    ACTIONS(976), 1,
      anon_sym_Set,
    ACTIONS(4238), 1,
      anon_sym_PIPE,
    ACTIONS(4580), 1,
      anon_sym_LPAREN,
    ACTIONS(4582), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4584), 1,
      anon_sym_u2983,
    ACTIONS(4586), 1,
      anon_sym_LBRACE,
    ACTIONS(4588), 1,
      anon_sym_DOT,
    STATE(1642), 1,
      sym__ARROW,
    STATE(3982), 1,
      aux_sym__atoms,
    STATE(4712), 1,
      sym_atom,
    STATE(8054), 1,
      sym__LAMBDA,
    STATE(8355), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(942), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(974), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(4720), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(4733), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4742), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8997), 7,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(948), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [354369] = 31,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(3174), 1,
      anon_sym_BSLASH,
    ACTIONS(3176), 1,
      anon_sym_u03bb,
    ACTIONS(3194), 1,
      anon_sym_quoteGoal,
    ACTIONS(3196), 1,
      anon_sym_tactic,
    ACTIONS(3202), 1,
      anon_sym_let,
    ACTIONS(3852), 1,
      sym_id,
    ACTIONS(3856), 1,
      anon_sym_record,
    ACTIONS(3866), 1,
      aux_sym__qid_token1,
    ACTIONS(3870), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3872), 1,
      anon_sym_u2987,
    ACTIONS(3876), 1,
      anon_sym_Set,
    ACTIONS(4238), 1,
      anon_sym_PIPE,
    ACTIONS(4724), 1,
      anon_sym_LPAREN,
    ACTIONS(4726), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4728), 1,
      anon_sym_u2983,
    ACTIONS(4730), 1,
      anon_sym_LBRACE,
    ACTIONS(4732), 1,
      anon_sym_DOT,
    STATE(2613), 1,
      sym__ARROW,
    STATE(3982), 1,
      aux_sym__atoms,
    STATE(4769), 1,
      sym_atom,
    STATE(8051), 1,
      sym__LAMBDA,
    STATE(8409), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3170), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3874), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(4722), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(4642), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4643), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9001), 7,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3854), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [354488] = 5,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(394), 1,
      anon_sym_BSLASH,
    ACTIONS(4688), 1,
      anon_sym_in,
    STATE(8944), 1,
      sym__let_body,
    ACTIONS(4240), 52,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_field,
      anon_sym_instance,
      anon_sym_module,
      anon_sym_data,
      anon_sym_codata,
      anon_sym_record,
      anon_sym_infix,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_variable,
      anon_sym_mutual,
      anon_sym_abstract,
      anon_sym_private,
      anon_sym_macro,
      anon_sym_postulate,
      anon_sym_primitive,
      anon_sym_open,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      sym_pragma,
      anon_sym_syntax,
      anon_sym_LBRACE,
      anon_sym_pattern,
      anon_sym_unquoteDecl,
      anon_sym_unquoteDef,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_AT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [354555] = 30,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(2526), 1,
      sym_id,
    ACTIONS(2532), 1,
      anon_sym_BSLASH,
    ACTIONS(2534), 1,
      anon_sym_u03bb,
    ACTIONS(2538), 1,
      anon_sym_record,
    ACTIONS(2540), 1,
      anon_sym_LPAREN,
    ACTIONS(2542), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2544), 1,
      anon_sym_u2983,
    ACTIONS(2546), 1,
      anon_sym_LBRACE,
    ACTIONS(2548), 1,
      aux_sym__qid_token1,
    ACTIONS(2550), 1,
      anon_sym_DOT,
    ACTIONS(2552), 1,
      anon_sym_quoteGoal,
    ACTIONS(2554), 1,
      anon_sym_tactic,
    ACTIONS(2556), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2558), 1,
      anon_sym_u2987,
    ACTIONS(2560), 1,
      anon_sym_let,
    ACTIONS(2564), 1,
      anon_sym_Set,
    STATE(1917), 1,
      sym__ARROW,
    STATE(3551), 1,
      aux_sym__atoms,
    STATE(4603), 1,
      sym_atom,
    STATE(8066), 1,
      sym__LAMBDA,
    STATE(8398), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2528), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2562), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(4734), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(4464), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4473), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8929), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2536), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [354672] = 5,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(394), 1,
      anon_sym_BSLASH,
    ACTIONS(4346), 1,
      anon_sym_in,
    STATE(8944), 1,
      sym__let_body,
    ACTIONS(4240), 52,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_field,
      anon_sym_instance,
      anon_sym_module,
      anon_sym_data,
      anon_sym_codata,
      anon_sym_record,
      anon_sym_infix,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_variable,
      anon_sym_mutual,
      anon_sym_abstract,
      anon_sym_private,
      anon_sym_macro,
      anon_sym_postulate,
      anon_sym_primitive,
      anon_sym_open,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      sym_pragma,
      anon_sym_syntax,
      anon_sym_LBRACE,
      anon_sym_pattern,
      anon_sym_unquoteDecl,
      anon_sym_unquoteDef,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_AT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [354739] = 5,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(394), 1,
      anon_sym_BSLASH,
    ACTIONS(4634), 1,
      anon_sym_in,
    STATE(8947), 1,
      sym__let_body,
    ACTIONS(4240), 52,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_field,
      anon_sym_instance,
      anon_sym_module,
      anon_sym_data,
      anon_sym_codata,
      anon_sym_record,
      anon_sym_infix,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_variable,
      anon_sym_mutual,
      anon_sym_abstract,
      anon_sym_private,
      anon_sym_macro,
      anon_sym_postulate,
      anon_sym_primitive,
      anon_sym_open,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      sym_pragma,
      anon_sym_syntax,
      anon_sym_LBRACE,
      anon_sym_pattern,
      anon_sym_unquoteDecl,
      anon_sym_unquoteDef,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_AT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [354806] = 5,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(394), 1,
      anon_sym_BSLASH,
    ACTIONS(4688), 1,
      anon_sym_in,
    STATE(8994), 1,
      sym__let_body,
    ACTIONS(4240), 52,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_field,
      anon_sym_instance,
      anon_sym_module,
      anon_sym_data,
      anon_sym_codata,
      anon_sym_record,
      anon_sym_infix,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_variable,
      anon_sym_mutual,
      anon_sym_abstract,
      anon_sym_private,
      anon_sym_macro,
      anon_sym_postulate,
      anon_sym_primitive,
      anon_sym_open,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      sym_pragma,
      anon_sym_syntax,
      anon_sym_LBRACE,
      anon_sym_pattern,
      anon_sym_unquoteDecl,
      anon_sym_unquoteDef,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_AT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [354873] = 31,
    ACTIONS(13), 1,
      anon_sym_BSLASH,
    ACTIONS(15), 1,
      anon_sym_u03bb,
    ACTIONS(75), 1,
      anon_sym_quoteGoal,
    ACTIONS(77), 1,
      anon_sym_tactic,
    ACTIONS(83), 1,
      anon_sym_let,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(2246), 1,
      sym_id,
    ACTIONS(2250), 1,
      anon_sym_record,
    ACTIONS(2260), 1,
      aux_sym__qid_token1,
    ACTIONS(2264), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2266), 1,
      anon_sym_u2987,
    ACTIONS(2270), 1,
      anon_sym_Set,
    ACTIONS(4238), 1,
      anon_sym_PIPE,
    ACTIONS(4738), 1,
      anon_sym_LPAREN,
    ACTIONS(4740), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4742), 1,
      anon_sym_u2983,
    ACTIONS(4744), 1,
      anon_sym_LBRACE,
    ACTIONS(4746), 1,
      anon_sym_DOT,
    STATE(2398), 1,
      sym__ARROW,
    STATE(3982), 1,
      aux_sym__atoms,
    STATE(4216), 1,
      sym_atom,
    STATE(8114), 1,
      sym__LAMBDA,
    STATE(8288), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(11), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2268), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(4736), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(4151), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4153), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9001), 7,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2248), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [354992] = 5,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(394), 1,
      anon_sym_BSLASH,
    ACTIONS(4670), 1,
      anon_sym_in,
    STATE(8943), 1,
      sym__let_body,
    ACTIONS(4240), 52,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_field,
      anon_sym_instance,
      anon_sym_module,
      anon_sym_data,
      anon_sym_codata,
      anon_sym_record,
      anon_sym_infix,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_variable,
      anon_sym_mutual,
      anon_sym_abstract,
      anon_sym_private,
      anon_sym_macro,
      anon_sym_postulate,
      anon_sym_primitive,
      anon_sym_open,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      sym_pragma,
      anon_sym_syntax,
      anon_sym_LBRACE,
      anon_sym_pattern,
      anon_sym_unquoteDecl,
      anon_sym_unquoteDef,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_AT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [355059] = 31,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(2346), 1,
      sym_id,
    ACTIONS(2350), 1,
      anon_sym_BSLASH,
    ACTIONS(2352), 1,
      anon_sym_u03bb,
    ACTIONS(2356), 1,
      anon_sym_record,
    ACTIONS(2366), 1,
      aux_sym__qid_token1,
    ACTIONS(2370), 1,
      anon_sym_quoteGoal,
    ACTIONS(2372), 1,
      anon_sym_tactic,
    ACTIONS(2374), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2376), 1,
      anon_sym_u2987,
    ACTIONS(2378), 1,
      anon_sym_let,
    ACTIONS(2382), 1,
      anon_sym_Set,
    ACTIONS(4238), 1,
      anon_sym_PIPE,
    ACTIONS(4750), 1,
      anon_sym_LPAREN,
    ACTIONS(4752), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4754), 1,
      anon_sym_u2983,
    ACTIONS(4756), 1,
      anon_sym_LBRACE,
    ACTIONS(4758), 1,
      anon_sym_DOT,
    STATE(1892), 1,
      sym__ARROW,
    STATE(3982), 1,
      aux_sym__atoms,
    STATE(4181), 1,
      sym_atom,
    STATE(8119), 1,
      sym__LAMBDA,
    STATE(8372), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2348), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2380), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(4748), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(4180), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4192), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9001), 7,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2354), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [355178] = 31,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(2728), 1,
      sym_id,
    ACTIONS(2732), 1,
      anon_sym_BSLASH,
    ACTIONS(2734), 1,
      anon_sym_u03bb,
    ACTIONS(2738), 1,
      anon_sym_record,
    ACTIONS(2748), 1,
      aux_sym__qid_token1,
    ACTIONS(2752), 1,
      anon_sym_quoteGoal,
    ACTIONS(2754), 1,
      anon_sym_tactic,
    ACTIONS(2756), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2758), 1,
      anon_sym_u2987,
    ACTIONS(2760), 1,
      anon_sym_let,
    ACTIONS(2764), 1,
      anon_sym_Set,
    ACTIONS(4238), 1,
      anon_sym_PIPE,
    ACTIONS(4762), 1,
      anon_sym_LPAREN,
    ACTIONS(4764), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4766), 1,
      anon_sym_u2983,
    ACTIONS(4768), 1,
      anon_sym_LBRACE,
    ACTIONS(4770), 1,
      anon_sym_DOT,
    STATE(2066), 1,
      sym__ARROW,
    STATE(3982), 1,
      aux_sym__atoms,
    STATE(4895), 1,
      sym_atom,
    STATE(8061), 1,
      sym__LAMBDA,
    STATE(8384), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2730), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2762), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(4760), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(4685), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4682), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9001), 7,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2736), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [355297] = 5,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(394), 1,
      anon_sym_BSLASH,
    ACTIONS(4408), 1,
      anon_sym_in,
    STATE(8976), 1,
      sym__let_body,
    ACTIONS(4240), 52,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_field,
      anon_sym_instance,
      anon_sym_module,
      anon_sym_data,
      anon_sym_codata,
      anon_sym_record,
      anon_sym_infix,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_variable,
      anon_sym_mutual,
      anon_sym_abstract,
      anon_sym_private,
      anon_sym_macro,
      anon_sym_postulate,
      anon_sym_primitive,
      anon_sym_open,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      sym_pragma,
      anon_sym_syntax,
      anon_sym_LBRACE,
      anon_sym_pattern,
      anon_sym_unquoteDecl,
      anon_sym_unquoteDef,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_AT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [355364] = 5,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(394), 1,
      anon_sym_BSLASH,
    ACTIONS(4646), 1,
      anon_sym_in,
    STATE(8943), 1,
      sym__let_body,
    ACTIONS(4240), 52,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_field,
      anon_sym_instance,
      anon_sym_module,
      anon_sym_data,
      anon_sym_codata,
      anon_sym_record,
      anon_sym_infix,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_variable,
      anon_sym_mutual,
      anon_sym_abstract,
      anon_sym_private,
      anon_sym_macro,
      anon_sym_postulate,
      anon_sym_primitive,
      anon_sym_open,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      sym_pragma,
      anon_sym_syntax,
      anon_sym_LBRACE,
      anon_sym_pattern,
      anon_sym_unquoteDecl,
      anon_sym_unquoteDef,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_AT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [355431] = 30,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2094), 1,
      sym_id,
    ACTIONS(2100), 1,
      anon_sym_BSLASH,
    ACTIONS(2102), 1,
      anon_sym_u03bb,
    ACTIONS(2106), 1,
      anon_sym_record,
    ACTIONS(2108), 1,
      anon_sym_LPAREN,
    ACTIONS(2110), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2112), 1,
      anon_sym_u2983,
    ACTIONS(2114), 1,
      anon_sym_LBRACE,
    ACTIONS(2116), 1,
      aux_sym__qid_token1,
    ACTIONS(2118), 1,
      anon_sym_DOT,
    ACTIONS(2120), 1,
      anon_sym_quoteGoal,
    ACTIONS(2122), 1,
      anon_sym_tactic,
    ACTIONS(2124), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2126), 1,
      anon_sym_u2987,
    ACTIONS(2128), 1,
      anon_sym_let,
    ACTIONS(2132), 1,
      anon_sym_Set,
    STATE(1481), 1,
      sym__ARROW,
    STATE(3354), 1,
      aux_sym__atoms,
    STATE(5601), 1,
      sym_atom,
    STATE(8075), 1,
      sym__LAMBDA,
    STATE(8428), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2096), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2130), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(4302), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(5451), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5453), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9472), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2104), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [355548] = 5,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(394), 1,
      anon_sym_BSLASH,
    ACTIONS(4346), 1,
      anon_sym_in,
    STATE(8994), 1,
      sym__let_body,
    ACTIONS(4240), 52,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_field,
      anon_sym_instance,
      anon_sym_module,
      anon_sym_data,
      anon_sym_codata,
      anon_sym_record,
      anon_sym_infix,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_variable,
      anon_sym_mutual,
      anon_sym_abstract,
      anon_sym_private,
      anon_sym_macro,
      anon_sym_postulate,
      anon_sym_primitive,
      anon_sym_open,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      sym_pragma,
      anon_sym_syntax,
      anon_sym_LBRACE,
      anon_sym_pattern,
      anon_sym_unquoteDecl,
      anon_sym_unquoteDef,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_AT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [355615] = 5,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(394), 1,
      anon_sym_BSLASH,
    ACTIONS(4406), 1,
      anon_sym_in,
    STATE(8943), 1,
      sym__let_body,
    ACTIONS(4240), 52,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_field,
      anon_sym_instance,
      anon_sym_module,
      anon_sym_data,
      anon_sym_codata,
      anon_sym_record,
      anon_sym_infix,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_variable,
      anon_sym_mutual,
      anon_sym_abstract,
      anon_sym_private,
      anon_sym_macro,
      anon_sym_postulate,
      anon_sym_primitive,
      anon_sym_open,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      sym_pragma,
      anon_sym_syntax,
      anon_sym_LBRACE,
      anon_sym_pattern,
      anon_sym_unquoteDecl,
      anon_sym_unquoteDef,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_AT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [355682] = 5,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(394), 1,
      anon_sym_BSLASH,
    ACTIONS(4648), 1,
      anon_sym_in,
    STATE(8944), 1,
      sym__let_body,
    ACTIONS(4240), 52,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_field,
      anon_sym_instance,
      anon_sym_module,
      anon_sym_data,
      anon_sym_codata,
      anon_sym_record,
      anon_sym_infix,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_variable,
      anon_sym_mutual,
      anon_sym_abstract,
      anon_sym_private,
      anon_sym_macro,
      anon_sym_postulate,
      anon_sym_primitive,
      anon_sym_open,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      sym_pragma,
      anon_sym_syntax,
      anon_sym_LBRACE,
      anon_sym_pattern,
      anon_sym_unquoteDecl,
      anon_sym_unquoteDef,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_AT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [355749] = 31,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(3694), 1,
      sym_id,
    ACTIONS(3698), 1,
      anon_sym_BSLASH,
    ACTIONS(3700), 1,
      anon_sym_u03bb,
    ACTIONS(3704), 1,
      anon_sym_record,
    ACTIONS(3714), 1,
      aux_sym__qid_token1,
    ACTIONS(3718), 1,
      anon_sym_quoteGoal,
    ACTIONS(3720), 1,
      anon_sym_tactic,
    ACTIONS(3722), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3724), 1,
      anon_sym_u2987,
    ACTIONS(3726), 1,
      anon_sym_let,
    ACTIONS(3730), 1,
      anon_sym_Set,
    ACTIONS(4238), 1,
      anon_sym_PIPE,
    ACTIONS(4774), 1,
      anon_sym_LPAREN,
    ACTIONS(4776), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4778), 1,
      anon_sym_u2983,
    ACTIONS(4780), 1,
      anon_sym_LBRACE,
    ACTIONS(4782), 1,
      anon_sym_DOT,
    STATE(2486), 1,
      sym__ARROW,
    STATE(3982), 1,
      aux_sym__atoms,
    STATE(4435), 1,
      sym_atom,
    STATE(8124), 1,
      sym__LAMBDA,
    STATE(8446), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3696), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3728), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(4772), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(4467), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4459), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9001), 7,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3702), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [355868] = 5,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(394), 1,
      anon_sym_BSLASH,
    ACTIONS(4496), 1,
      anon_sym_in,
    STATE(8943), 1,
      sym__let_body,
    ACTIONS(4240), 52,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_field,
      anon_sym_instance,
      anon_sym_module,
      anon_sym_data,
      anon_sym_codata,
      anon_sym_record,
      anon_sym_infix,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_variable,
      anon_sym_mutual,
      anon_sym_abstract,
      anon_sym_private,
      anon_sym_macro,
      anon_sym_postulate,
      anon_sym_primitive,
      anon_sym_open,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      sym_pragma,
      anon_sym_syntax,
      anon_sym_LBRACE,
      anon_sym_pattern,
      anon_sym_unquoteDecl,
      anon_sym_unquoteDef,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_AT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [355935] = 5,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(394), 1,
      anon_sym_BSLASH,
    ACTIONS(4784), 1,
      anon_sym_in,
    STATE(8943), 1,
      sym__let_body,
    ACTIONS(4240), 52,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_field,
      anon_sym_instance,
      anon_sym_module,
      anon_sym_data,
      anon_sym_codata,
      anon_sym_record,
      anon_sym_infix,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_variable,
      anon_sym_mutual,
      anon_sym_abstract,
      anon_sym_private,
      anon_sym_macro,
      anon_sym_postulate,
      anon_sym_primitive,
      anon_sym_open,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      sym_pragma,
      anon_sym_syntax,
      anon_sym_LBRACE,
      anon_sym_pattern,
      anon_sym_unquoteDecl,
      anon_sym_unquoteDef,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_AT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [356002] = 5,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(394), 1,
      anon_sym_BSLASH,
    ACTIONS(4648), 1,
      anon_sym_in,
    STATE(8943), 1,
      sym__let_body,
    ACTIONS(4240), 52,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_field,
      anon_sym_instance,
      anon_sym_module,
      anon_sym_data,
      anon_sym_codata,
      anon_sym_record,
      anon_sym_infix,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_variable,
      anon_sym_mutual,
      anon_sym_abstract,
      anon_sym_private,
      anon_sym_macro,
      anon_sym_postulate,
      anon_sym_primitive,
      anon_sym_open,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      sym_pragma,
      anon_sym_syntax,
      anon_sym_LBRACE,
      anon_sym_pattern,
      anon_sym_unquoteDecl,
      anon_sym_unquoteDef,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_AT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [356069] = 30,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2796), 1,
      anon_sym_BSLASH,
    ACTIONS(2798), 1,
      anon_sym_u03bb,
    ACTIONS(2800), 1,
      anon_sym_quoteGoal,
    ACTIONS(2802), 1,
      anon_sym_tactic,
    ACTIONS(2804), 1,
      anon_sym_let,
    ACTIONS(3380), 1,
      sym_id,
    ACTIONS(3384), 1,
      anon_sym_record,
    ACTIONS(3386), 1,
      anon_sym_LPAREN,
    ACTIONS(3388), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3390), 1,
      anon_sym_u2983,
    ACTIONS(3392), 1,
      anon_sym_LBRACE,
    ACTIONS(3394), 1,
      aux_sym__qid_token1,
    ACTIONS(3396), 1,
      anon_sym_DOT,
    ACTIONS(3398), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3400), 1,
      anon_sym_u2987,
    ACTIONS(3404), 1,
      anon_sym_Set,
    STATE(2143), 1,
      sym__ARROW,
    STATE(3563), 1,
      aux_sym__atoms,
    STATE(5099), 1,
      sym_atom,
    STATE(8041), 1,
      sym__LAMBDA,
    STATE(8490), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2794), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3402), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(4434), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(4937), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4939), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8968), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3382), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [356186] = 31,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(2532), 1,
      anon_sym_BSLASH,
    ACTIONS(2534), 1,
      anon_sym_u03bb,
    ACTIONS(2552), 1,
      anon_sym_quoteGoal,
    ACTIONS(2554), 1,
      anon_sym_tactic,
    ACTIONS(2560), 1,
      anon_sym_let,
    ACTIONS(3584), 1,
      sym_id,
    ACTIONS(3588), 1,
      anon_sym_record,
    ACTIONS(3598), 1,
      aux_sym__qid_token1,
    ACTIONS(3602), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3604), 1,
      anon_sym_u2987,
    ACTIONS(3608), 1,
      anon_sym_Set,
    ACTIONS(4238), 1,
      anon_sym_PIPE,
    ACTIONS(4788), 1,
      anon_sym_LPAREN,
    ACTIONS(4790), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4792), 1,
      anon_sym_u2983,
    ACTIONS(4794), 1,
      anon_sym_LBRACE,
    ACTIONS(4796), 1,
      anon_sym_DOT,
    STATE(2467), 1,
      sym__ARROW,
    STATE(3982), 1,
      aux_sym__atoms,
    STATE(4261), 1,
      sym_atom,
    STATE(8066), 1,
      sym__LAMBDA,
    STATE(8398), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2528), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3606), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(4786), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(4400), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4403), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9001), 7,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3586), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [356305] = 31,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2140), 1,
      anon_sym_BSLASH,
    ACTIONS(2142), 1,
      anon_sym_u03bb,
    ACTIONS(2160), 1,
      anon_sym_quoteGoal,
    ACTIONS(2162), 1,
      anon_sym_tactic,
    ACTIONS(2168), 1,
      anon_sym_let,
    ACTIONS(2272), 1,
      sym_id,
    ACTIONS(2276), 1,
      anon_sym_record,
    ACTIONS(2286), 1,
      aux_sym__qid_token1,
    ACTIONS(2290), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2292), 1,
      anon_sym_u2987,
    ACTIONS(2296), 1,
      anon_sym_Set,
    ACTIONS(4238), 1,
      anon_sym_PIPE,
    ACTIONS(4800), 1,
      anon_sym_LPAREN,
    ACTIONS(4802), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4804), 1,
      anon_sym_u2983,
    ACTIONS(4806), 1,
      anon_sym_LBRACE,
    ACTIONS(4808), 1,
      anon_sym_DOT,
    STATE(1459), 1,
      sym__ARROW,
    STATE(3982), 1,
      aux_sym__atoms,
    STATE(5012), 1,
      sym_atom,
    STATE(8040), 1,
      sym__LAMBDA,
    STATE(8460), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2136), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2294), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(4798), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(5139), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5053), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8997), 7,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2274), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [356424] = 30,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(3020), 1,
      anon_sym_BSLASH,
    ACTIONS(3022), 1,
      anon_sym_u03bb,
    ACTIONS(3040), 1,
      anon_sym_quoteGoal,
    ACTIONS(3042), 1,
      anon_sym_tactic,
    ACTIONS(3048), 1,
      anon_sym_let,
    ACTIONS(3234), 1,
      sym_id,
    ACTIONS(3240), 1,
      anon_sym_record,
    ACTIONS(3242), 1,
      anon_sym_LPAREN,
    ACTIONS(3244), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3246), 1,
      anon_sym_u2983,
    ACTIONS(3248), 1,
      anon_sym_LBRACE,
    ACTIONS(3250), 1,
      aux_sym__qid_token1,
    ACTIONS(3252), 1,
      anon_sym_DOT,
    ACTIONS(3254), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3256), 1,
      anon_sym_u2987,
    ACTIONS(3260), 1,
      anon_sym_Set,
    STATE(1623), 1,
      sym__ARROW,
    STATE(3385), 1,
      aux_sym__atoms,
    STATE(5549), 1,
      sym_atom,
    STATE(8127), 1,
      sym__LAMBDA,
    STATE(8388), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3018), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3258), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(4810), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(5387), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5375), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8968), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3238), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [356541] = 5,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(394), 1,
      anon_sym_BSLASH,
    ACTIONS(4812), 1,
      anon_sym_in,
    STATE(8944), 1,
      sym__let_body,
    ACTIONS(4240), 52,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_field,
      anon_sym_instance,
      anon_sym_module,
      anon_sym_data,
      anon_sym_codata,
      anon_sym_record,
      anon_sym_infix,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_variable,
      anon_sym_mutual,
      anon_sym_abstract,
      anon_sym_private,
      anon_sym_macro,
      anon_sym_postulate,
      anon_sym_primitive,
      anon_sym_open,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      sym_pragma,
      anon_sym_syntax,
      anon_sym_LBRACE,
      anon_sym_pattern,
      anon_sym_unquoteDecl,
      anon_sym_unquoteDef,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_AT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [356608] = 5,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(394), 1,
      anon_sym_BSLASH,
    ACTIONS(4812), 1,
      anon_sym_in,
    STATE(8994), 1,
      sym__let_body,
    ACTIONS(4240), 52,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_field,
      anon_sym_instance,
      anon_sym_module,
      anon_sym_data,
      anon_sym_codata,
      anon_sym_record,
      anon_sym_infix,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_variable,
      anon_sym_mutual,
      anon_sym_abstract,
      anon_sym_private,
      anon_sym_macro,
      anon_sym_postulate,
      anon_sym_primitive,
      anon_sym_open,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      sym_pragma,
      anon_sym_syntax,
      anon_sym_LBRACE,
      anon_sym_pattern,
      anon_sym_unquoteDecl,
      anon_sym_unquoteDef,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_AT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [356675] = 5,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(394), 1,
      anon_sym_BSLASH,
    ACTIONS(4616), 1,
      anon_sym_in,
    STATE(8943), 1,
      sym__let_body,
    ACTIONS(4240), 52,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_field,
      anon_sym_instance,
      anon_sym_module,
      anon_sym_data,
      anon_sym_codata,
      anon_sym_record,
      anon_sym_infix,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_variable,
      anon_sym_mutual,
      anon_sym_abstract,
      anon_sym_private,
      anon_sym_macro,
      anon_sym_postulate,
      anon_sym_primitive,
      anon_sym_open,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      sym_pragma,
      anon_sym_syntax,
      anon_sym_LBRACE,
      anon_sym_pattern,
      anon_sym_unquoteDecl,
      anon_sym_unquoteDef,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_AT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [356742] = 31,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(2212), 1,
      anon_sym_BSLASH,
    ACTIONS(2214), 1,
      anon_sym_u03bb,
    ACTIONS(2232), 1,
      anon_sym_quoteGoal,
    ACTIONS(2234), 1,
      anon_sym_tactic,
    ACTIONS(2240), 1,
      anon_sym_let,
    ACTIONS(3760), 1,
      sym_id,
    ACTIONS(3764), 1,
      anon_sym_record,
    ACTIONS(3774), 1,
      aux_sym__qid_token1,
    ACTIONS(3778), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3780), 1,
      anon_sym_u2987,
    ACTIONS(3784), 1,
      anon_sym_Set,
    ACTIONS(4238), 1,
      anon_sym_PIPE,
    ACTIONS(4816), 1,
      anon_sym_LPAREN,
    ACTIONS(4818), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4820), 1,
      anon_sym_u2983,
    ACTIONS(4822), 1,
      anon_sym_LBRACE,
    ACTIONS(4824), 1,
      anon_sym_DOT,
    STATE(2540), 1,
      sym__ARROW,
    STATE(3982), 1,
      aux_sym__atoms,
    STATE(4506), 1,
      sym_atom,
    STATE(8035), 1,
      sym__LAMBDA,
    STATE(8402), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3782), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(4814), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(4599), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4613), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9001), 7,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3762), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [356861] = 30,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(2694), 1,
      anon_sym_BSLASH,
    ACTIONS(2696), 1,
      anon_sym_u03bb,
    ACTIONS(2714), 1,
      anon_sym_quoteGoal,
    ACTIONS(2716), 1,
      anon_sym_tactic,
    ACTIONS(2722), 1,
      anon_sym_let,
    ACTIONS(3878), 1,
      sym_id,
    ACTIONS(3884), 1,
      anon_sym_record,
    ACTIONS(3886), 1,
      anon_sym_LPAREN,
    ACTIONS(3888), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3890), 1,
      anon_sym_u2983,
    ACTIONS(3892), 1,
      anon_sym_LBRACE,
    ACTIONS(3894), 1,
      aux_sym__qid_token1,
    ACTIONS(3896), 1,
      anon_sym_DOT,
    ACTIONS(3898), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3900), 1,
      anon_sym_u2987,
    ACTIONS(3904), 1,
      anon_sym_Set,
    STATE(1610), 1,
      sym__ARROW,
    STATE(3433), 1,
      aux_sym__atoms,
    STATE(4243), 1,
      sym_atom,
    STATE(8133), 1,
      sym__LAMBDA,
    STATE(8368), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2692), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3902), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(4826), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(4214), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4218), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8929), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3882), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [356978] = 30,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(2964), 1,
      anon_sym_quoteGoal,
    ACTIONS(2972), 1,
      anon_sym_let,
    ACTIONS(3520), 1,
      sym_id,
    ACTIONS(3522), 1,
      anon_sym_BSLASH,
    ACTIONS(3524), 1,
      anon_sym_u03bb,
    ACTIONS(3528), 1,
      anon_sym_record,
    ACTIONS(3530), 1,
      anon_sym_LPAREN,
    ACTIONS(3532), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3534), 1,
      anon_sym_u2983,
    ACTIONS(3536), 1,
      anon_sym_LBRACE,
    ACTIONS(3538), 1,
      aux_sym__qid_token1,
    ACTIONS(3540), 1,
      anon_sym_DOT,
    ACTIONS(3542), 1,
      anon_sym_tactic,
    ACTIONS(3544), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3546), 1,
      anon_sym_u2987,
    ACTIONS(3550), 1,
      anon_sym_Set,
    STATE(2434), 1,
      sym__ARROW,
    STATE(3542), 1,
      aux_sym__atoms,
    STATE(5625), 1,
      sym_atom,
    STATE(8058), 1,
      sym__LAMBDA,
    STATE(8418), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2940), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3548), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(4534), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(5537), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5538), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8929), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3526), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [357095] = 30,
    ACTIONS(692), 1,
      anon_sym_record,
    ACTIONS(694), 1,
      anon_sym_LPAREN,
    ACTIONS(696), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(698), 1,
      anon_sym_u2983,
    ACTIONS(702), 1,
      anon_sym_LBRACE,
    ACTIONS(708), 1,
      anon_sym_DOT,
    ACTIONS(718), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(720), 1,
      anon_sym_u2987,
    ACTIONS(728), 1,
      anon_sym_Set,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1928), 1,
      anon_sym_quoteGoal,
    ACTIONS(1936), 1,
      anon_sym_let,
    ACTIONS(2336), 1,
      sym_id,
    ACTIONS(2338), 1,
      anon_sym_BSLASH,
    ACTIONS(2340), 1,
      anon_sym_u03bb,
    ACTIONS(2342), 1,
      aux_sym__qid_token1,
    ACTIONS(2344), 1,
      anon_sym_tactic,
    STATE(1765), 1,
      sym__ARROW,
    STATE(3594), 1,
      aux_sym__atoms,
    STATE(5128), 1,
      sym_atom,
    STATE(8079), 1,
      sym__LAMBDA,
    STATE(8431), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(726), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1906), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4476), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(5069), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5056), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8968), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(690), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [357212] = 5,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(394), 1,
      anon_sym_BSLASH,
    ACTIONS(4812), 1,
      anon_sym_in,
    STATE(8943), 1,
      sym__let_body,
    ACTIONS(4240), 52,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_field,
      anon_sym_instance,
      anon_sym_module,
      anon_sym_data,
      anon_sym_codata,
      anon_sym_record,
      anon_sym_infix,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_variable,
      anon_sym_mutual,
      anon_sym_abstract,
      anon_sym_private,
      anon_sym_macro,
      anon_sym_postulate,
      anon_sym_primitive,
      anon_sym_open,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      sym_pragma,
      anon_sym_syntax,
      anon_sym_LBRACE,
      anon_sym_pattern,
      anon_sym_unquoteDecl,
      anon_sym_unquoteDef,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_AT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [357279] = 31,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(2092), 1,
      anon_sym_Set,
    ACTIONS(4238), 1,
      anon_sym_PIPE,
    ACTIONS(4830), 1,
      anon_sym_LPAREN,
    ACTIONS(4832), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4834), 1,
      anon_sym_u2983,
    ACTIONS(4836), 1,
      anon_sym_LBRACE,
    ACTIONS(4838), 1,
      anon_sym_DOT,
    STATE(1671), 1,
      sym__ARROW,
    STATE(3982), 1,
      aux_sym__atoms,
    STATE(5469), 1,
      sym_atom,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(4828), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8997), 7,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [357398] = 5,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(394), 1,
      anon_sym_BSLASH,
    ACTIONS(4784), 1,
      anon_sym_in,
    STATE(8994), 1,
      sym__let_body,
    ACTIONS(4240), 52,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_field,
      anon_sym_instance,
      anon_sym_module,
      anon_sym_data,
      anon_sym_codata,
      anon_sym_record,
      anon_sym_infix,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_variable,
      anon_sym_mutual,
      anon_sym_abstract,
      anon_sym_private,
      anon_sym_macro,
      anon_sym_postulate,
      anon_sym_primitive,
      anon_sym_open,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      sym_pragma,
      anon_sym_syntax,
      anon_sym_LBRACE,
      anon_sym_pattern,
      anon_sym_unquoteDecl,
      anon_sym_unquoteDef,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_AT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [357465] = 31,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(3444), 1,
      sym_id,
    ACTIONS(3448), 1,
      anon_sym_BSLASH,
    ACTIONS(3450), 1,
      anon_sym_u03bb,
    ACTIONS(3454), 1,
      anon_sym_record,
    ACTIONS(3464), 1,
      aux_sym__qid_token1,
    ACTIONS(3468), 1,
      anon_sym_quoteGoal,
    ACTIONS(3470), 1,
      anon_sym_tactic,
    ACTIONS(3472), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3474), 1,
      anon_sym_u2987,
    ACTIONS(3476), 1,
      anon_sym_let,
    ACTIONS(3480), 1,
      anon_sym_Set,
    ACTIONS(4238), 1,
      anon_sym_PIPE,
    ACTIONS(4842), 1,
      anon_sym_LPAREN,
    ACTIONS(4844), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4846), 1,
      anon_sym_u2983,
    ACTIONS(4848), 1,
      anon_sym_LBRACE,
    ACTIONS(4850), 1,
      anon_sym_DOT,
    STATE(2657), 1,
      sym__ARROW,
    STATE(3982), 1,
      aux_sym__atoms,
    STATE(5018), 1,
      sym_atom,
    STATE(8072), 1,
      sym__LAMBDA,
    STATE(8455), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3446), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3478), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(4840), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(5013), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5000), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9001), 7,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3452), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [357584] = 5,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(394), 1,
      anon_sym_BSLASH,
    ACTIONS(4406), 1,
      anon_sym_in,
    STATE(8944), 1,
      sym__let_body,
    ACTIONS(4240), 52,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_field,
      anon_sym_instance,
      anon_sym_module,
      anon_sym_data,
      anon_sym_codata,
      anon_sym_record,
      anon_sym_infix,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_variable,
      anon_sym_mutual,
      anon_sym_abstract,
      anon_sym_private,
      anon_sym_macro,
      anon_sym_postulate,
      anon_sym_primitive,
      anon_sym_open,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      sym_pragma,
      anon_sym_syntax,
      anon_sym_LBRACE,
      anon_sym_pattern,
      anon_sym_unquoteDecl,
      anon_sym_unquoteDef,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_AT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [357651] = 5,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(394), 1,
      anon_sym_BSLASH,
    ACTIONS(4784), 1,
      anon_sym_in,
    STATE(8944), 1,
      sym__let_body,
    ACTIONS(4240), 52,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_field,
      anon_sym_instance,
      anon_sym_module,
      anon_sym_data,
      anon_sym_codata,
      anon_sym_record,
      anon_sym_infix,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_variable,
      anon_sym_mutual,
      anon_sym_abstract,
      anon_sym_private,
      anon_sym_macro,
      anon_sym_postulate,
      anon_sym_primitive,
      anon_sym_open,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      sym_pragma,
      anon_sym_syntax,
      anon_sym_LBRACE,
      anon_sym_pattern,
      anon_sym_unquoteDecl,
      anon_sym_unquoteDef,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_AT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [357718] = 31,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(2904), 1,
      anon_sym_BSLASH,
    ACTIONS(2906), 1,
      anon_sym_u03bb,
    ACTIONS(2924), 1,
      anon_sym_quoteGoal,
    ACTIONS(2926), 1,
      anon_sym_tactic,
    ACTIONS(2932), 1,
      anon_sym_let,
    ACTIONS(3300), 1,
      sym_id,
    ACTIONS(3304), 1,
      anon_sym_record,
    ACTIONS(3314), 1,
      aux_sym__qid_token1,
    ACTIONS(3318), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3320), 1,
      anon_sym_u2987,
    ACTIONS(3324), 1,
      anon_sym_Set,
    ACTIONS(4238), 1,
      anon_sym_PIPE,
    ACTIONS(4854), 1,
      anon_sym_LPAREN,
    ACTIONS(4856), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4858), 1,
      anon_sym_u2983,
    ACTIONS(4860), 1,
      anon_sym_LBRACE,
    ACTIONS(4862), 1,
      anon_sym_DOT,
    STATE(2171), 1,
      sym__ARROW,
    STATE(3982), 1,
      aux_sym__atoms,
    STATE(4056), 1,
      sym_atom,
    STATE(8094), 1,
      sym__LAMBDA,
    STATE(8489), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2900), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3322), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(4852), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(4053), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4049), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9001), 7,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3302), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [357837] = 5,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(394), 1,
      anon_sym_BSLASH,
    ACTIONS(4520), 1,
      anon_sym_in,
    STATE(8938), 1,
      sym__let_body,
    ACTIONS(4240), 52,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_field,
      anon_sym_instance,
      anon_sym_module,
      anon_sym_data,
      anon_sym_codata,
      anon_sym_record,
      anon_sym_infix,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_variable,
      anon_sym_mutual,
      anon_sym_abstract,
      anon_sym_private,
      anon_sym_macro,
      anon_sym_postulate,
      anon_sym_primitive,
      anon_sym_open,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      sym_pragma,
      anon_sym_syntax,
      anon_sym_LBRACE,
      anon_sym_pattern,
      anon_sym_unquoteDecl,
      anon_sym_unquoteDef,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_AT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [357904] = 5,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(394), 1,
      anon_sym_BSLASH,
    ACTIONS(4520), 1,
      anon_sym_in,
    STATE(8947), 1,
      sym__let_body,
    ACTIONS(4240), 52,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_field,
      anon_sym_instance,
      anon_sym_module,
      anon_sym_data,
      anon_sym_codata,
      anon_sym_record,
      anon_sym_infix,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_variable,
      anon_sym_mutual,
      anon_sym_abstract,
      anon_sym_private,
      anon_sym_macro,
      anon_sym_postulate,
      anon_sym_primitive,
      anon_sym_open,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      sym_pragma,
      anon_sym_syntax,
      anon_sym_LBRACE,
      anon_sym_pattern,
      anon_sym_unquoteDecl,
      anon_sym_unquoteDef,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_AT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [357971] = 30,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(3090), 1,
      sym_id,
    ACTIONS(3096), 1,
      anon_sym_BSLASH,
    ACTIONS(3098), 1,
      anon_sym_u03bb,
    ACTIONS(3102), 1,
      anon_sym_record,
    ACTIONS(3104), 1,
      anon_sym_LPAREN,
    ACTIONS(3106), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3108), 1,
      anon_sym_u2983,
    ACTIONS(3110), 1,
      anon_sym_LBRACE,
    ACTIONS(3112), 1,
      aux_sym__qid_token1,
    ACTIONS(3114), 1,
      anon_sym_DOT,
    ACTIONS(3116), 1,
      anon_sym_quoteGoal,
    ACTIONS(3118), 1,
      anon_sym_tactic,
    ACTIONS(3120), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3122), 1,
      anon_sym_u2987,
    ACTIONS(3124), 1,
      anon_sym_let,
    ACTIONS(3128), 1,
      anon_sym_Set,
    STATE(1805), 1,
      sym__ARROW,
    STATE(3463), 1,
      aux_sym__atoms,
    STATE(4365), 1,
      sym_atom,
    STATE(8099), 1,
      sym__LAMBDA,
    STATE(8393), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3092), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3126), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(4864), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(4293), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4285), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8929), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3100), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [358088] = 5,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(394), 1,
      anon_sym_BSLASH,
    ACTIONS(4460), 1,
      anon_sym_in,
    STATE(8944), 1,
      sym__let_body,
    ACTIONS(4240), 52,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_field,
      anon_sym_instance,
      anon_sym_module,
      anon_sym_data,
      anon_sym_codata,
      anon_sym_record,
      anon_sym_infix,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_variable,
      anon_sym_mutual,
      anon_sym_abstract,
      anon_sym_private,
      anon_sym_macro,
      anon_sym_postulate,
      anon_sym_primitive,
      anon_sym_open,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      sym_pragma,
      anon_sym_syntax,
      anon_sym_LBRACE,
      anon_sym_pattern,
      anon_sym_unquoteDecl,
      anon_sym_unquoteDef,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_AT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [358155] = 5,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(394), 1,
      anon_sym_BSLASH,
    ACTIONS(4492), 1,
      anon_sym_in,
    STATE(8943), 1,
      sym__let_body,
    ACTIONS(4240), 52,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_field,
      anon_sym_instance,
      anon_sym_module,
      anon_sym_data,
      anon_sym_codata,
      anon_sym_record,
      anon_sym_infix,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_variable,
      anon_sym_mutual,
      anon_sym_abstract,
      anon_sym_private,
      anon_sym_macro,
      anon_sym_postulate,
      anon_sym_primitive,
      anon_sym_open,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      sym_pragma,
      anon_sym_syntax,
      anon_sym_LBRACE,
      anon_sym_pattern,
      anon_sym_unquoteDecl,
      anon_sym_unquoteDef,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_AT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [358222] = 5,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(394), 1,
      anon_sym_BSLASH,
    ACTIONS(4460), 1,
      anon_sym_in,
    STATE(8994), 1,
      sym__let_body,
    ACTIONS(4240), 52,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_field,
      anon_sym_instance,
      anon_sym_module,
      anon_sym_data,
      anon_sym_codata,
      anon_sym_record,
      anon_sym_infix,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_variable,
      anon_sym_mutual,
      anon_sym_abstract,
      anon_sym_private,
      anon_sym_macro,
      anon_sym_postulate,
      anon_sym_primitive,
      anon_sym_open,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      sym_pragma,
      anon_sym_syntax,
      anon_sym_LBRACE,
      anon_sym_pattern,
      anon_sym_unquoteDecl,
      anon_sym_unquoteDef,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_AT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [358289] = 5,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(394), 1,
      anon_sym_BSLASH,
    ACTIONS(4634), 1,
      anon_sym_in,
    STATE(8938), 1,
      sym__let_body,
    ACTIONS(4240), 52,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_field,
      anon_sym_instance,
      anon_sym_module,
      anon_sym_data,
      anon_sym_codata,
      anon_sym_record,
      anon_sym_infix,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_variable,
      anon_sym_mutual,
      anon_sym_abstract,
      anon_sym_private,
      anon_sym_macro,
      anon_sym_postulate,
      anon_sym_primitive,
      anon_sym_open,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      sym_pragma,
      anon_sym_syntax,
      anon_sym_LBRACE,
      anon_sym_pattern,
      anon_sym_unquoteDecl,
      anon_sym_unquoteDef,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_AT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [358356] = 5,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(394), 1,
      anon_sym_BSLASH,
    ACTIONS(4284), 1,
      anon_sym_in,
    STATE(8938), 1,
      sym__let_body,
    ACTIONS(4240), 52,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_field,
      anon_sym_instance,
      anon_sym_module,
      anon_sym_data,
      anon_sym_codata,
      anon_sym_record,
      anon_sym_infix,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_variable,
      anon_sym_mutual,
      anon_sym_abstract,
      anon_sym_private,
      anon_sym_macro,
      anon_sym_postulate,
      anon_sym_primitive,
      anon_sym_open,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      sym_pragma,
      anon_sym_syntax,
      anon_sym_LBRACE,
      anon_sym_pattern,
      anon_sym_unquoteDecl,
      anon_sym_unquoteDef,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_AT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [358423] = 5,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(394), 1,
      anon_sym_BSLASH,
    ACTIONS(4284), 1,
      anon_sym_in,
    STATE(8976), 1,
      sym__let_body,
    ACTIONS(4240), 52,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_field,
      anon_sym_instance,
      anon_sym_module,
      anon_sym_data,
      anon_sym_codata,
      anon_sym_record,
      anon_sym_infix,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_variable,
      anon_sym_mutual,
      anon_sym_abstract,
      anon_sym_private,
      anon_sym_macro,
      anon_sym_postulate,
      anon_sym_primitive,
      anon_sym_open,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      sym_pragma,
      anon_sym_syntax,
      anon_sym_LBRACE,
      anon_sym_pattern,
      anon_sym_unquoteDecl,
      anon_sym_unquoteDef,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_AT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [358490] = 31,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(734), 1,
      sym_id,
    ACTIONS(738), 1,
      anon_sym_BSLASH,
    ACTIONS(740), 1,
      anon_sym_u03bb,
    ACTIONS(744), 1,
      anon_sym_record,
    ACTIONS(754), 1,
      aux_sym__qid_token1,
    ACTIONS(762), 1,
      anon_sym_quoteGoal,
    ACTIONS(764), 1,
      anon_sym_tactic,
    ACTIONS(766), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(768), 1,
      anon_sym_u2987,
    ACTIONS(774), 1,
      anon_sym_Set,
    ACTIONS(3054), 1,
      anon_sym_let,
    ACTIONS(4228), 1,
      anon_sym_LPAREN,
    ACTIONS(4230), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4232), 1,
      anon_sym_u2983,
    ACTIONS(4234), 1,
      anon_sym_LBRACE,
    ACTIONS(4236), 1,
      anon_sym_DOT,
    ACTIONS(4238), 1,
      anon_sym_PIPE,
    STATE(2616), 1,
      sym__ARROW,
    STATE(3982), 1,
      aux_sym__atoms,
    STATE(5147), 1,
      sym_atom,
    STATE(8156), 1,
      sym__LAMBDA,
    STATE(8456), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(736), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(772), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(4866), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(5108), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5102), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9001), 7,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(742), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [358609] = 30,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(2898), 1,
      sym_id,
    ACTIONS(2904), 1,
      anon_sym_BSLASH,
    ACTIONS(2906), 1,
      anon_sym_u03bb,
    ACTIONS(2910), 1,
      anon_sym_record,
    ACTIONS(2912), 1,
      anon_sym_LPAREN,
    ACTIONS(2914), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2916), 1,
      anon_sym_u2983,
    ACTIONS(2918), 1,
      anon_sym_LBRACE,
    ACTIONS(2920), 1,
      aux_sym__qid_token1,
    ACTIONS(2922), 1,
      anon_sym_DOT,
    ACTIONS(2924), 1,
      anon_sym_quoteGoal,
    ACTIONS(2926), 1,
      anon_sym_tactic,
    ACTIONS(2928), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2930), 1,
      anon_sym_u2987,
    ACTIONS(2932), 1,
      anon_sym_let,
    ACTIONS(2936), 1,
      anon_sym_Set,
    STATE(1947), 1,
      sym__ARROW,
    STATE(3684), 1,
      aux_sym__atoms,
    STATE(4154), 1,
      sym_atom,
    STATE(8094), 1,
      sym__LAMBDA,
    STATE(8489), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2900), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2934), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(4868), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(4184), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4206), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8929), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2908), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [358726] = 5,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(394), 1,
      anon_sym_BSLASH,
    ACTIONS(4242), 1,
      anon_sym_in,
    STATE(8944), 1,
      sym__let_body,
    ACTIONS(4240), 52,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_field,
      anon_sym_instance,
      anon_sym_module,
      anon_sym_data,
      anon_sym_codata,
      anon_sym_record,
      anon_sym_infix,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_variable,
      anon_sym_mutual,
      anon_sym_abstract,
      anon_sym_private,
      anon_sym_macro,
      anon_sym_postulate,
      anon_sym_primitive,
      anon_sym_open,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      sym_pragma,
      anon_sym_syntax,
      anon_sym_LBRACE,
      anon_sym_pattern,
      anon_sym_unquoteDecl,
      anon_sym_unquoteDef,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_AT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [358793] = 5,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(394), 1,
      anon_sym_BSLASH,
    ACTIONS(4650), 1,
      anon_sym_in,
    STATE(9467), 1,
      sym__let_body,
    ACTIONS(4240), 52,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_field,
      anon_sym_instance,
      anon_sym_module,
      anon_sym_data,
      anon_sym_codata,
      anon_sym_record,
      anon_sym_infix,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_variable,
      anon_sym_mutual,
      anon_sym_abstract,
      anon_sym_private,
      anon_sym_macro,
      anon_sym_postulate,
      anon_sym_primitive,
      anon_sym_open,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      sym_pragma,
      anon_sym_syntax,
      anon_sym_LBRACE,
      anon_sym_pattern,
      anon_sym_unquoteDecl,
      anon_sym_unquoteDef,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_AT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [358860] = 5,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(394), 1,
      anon_sym_BSLASH,
    ACTIONS(4640), 1,
      anon_sym_in,
    STATE(8976), 1,
      sym__let_body,
    ACTIONS(4240), 52,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_field,
      anon_sym_instance,
      anon_sym_module,
      anon_sym_data,
      anon_sym_codata,
      anon_sym_record,
      anon_sym_infix,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_variable,
      anon_sym_mutual,
      anon_sym_abstract,
      anon_sym_private,
      anon_sym_macro,
      anon_sym_postulate,
      anon_sym_primitive,
      anon_sym_open,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      sym_pragma,
      anon_sym_syntax,
      anon_sym_LBRACE,
      anon_sym_pattern,
      anon_sym_unquoteDecl,
      anon_sym_unquoteDef,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_AT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [358927] = 31,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2120), 1,
      anon_sym_quoteGoal,
    ACTIONS(2128), 1,
      anon_sym_let,
    ACTIONS(2174), 1,
      sym_id,
    ACTIONS(2176), 1,
      anon_sym_BSLASH,
    ACTIONS(2178), 1,
      anon_sym_u03bb,
    ACTIONS(2182), 1,
      anon_sym_record,
    ACTIONS(2192), 1,
      aux_sym__qid_token1,
    ACTIONS(2196), 1,
      anon_sym_tactic,
    ACTIONS(2198), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2200), 1,
      anon_sym_u2987,
    ACTIONS(2204), 1,
      anon_sym_Set,
    ACTIONS(4238), 1,
      anon_sym_PIPE,
    ACTIONS(4872), 1,
      anon_sym_LPAREN,
    ACTIONS(4874), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4876), 1,
      anon_sym_u2983,
    ACTIONS(4878), 1,
      anon_sym_LBRACE,
    ACTIONS(4880), 1,
      anon_sym_DOT,
    STATE(1809), 1,
      sym__ARROW,
    STATE(3982), 1,
      aux_sym__atoms,
    STATE(4611), 1,
      sym_atom,
    STATE(8044), 1,
      sym__LAMBDA,
    STATE(8428), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2096), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(4870), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(4536), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4531), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8997), 7,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2180), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [359046] = 5,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(394), 1,
      anon_sym_BSLASH,
    ACTIONS(4642), 1,
      anon_sym_in,
    STATE(8976), 1,
      sym__let_body,
    ACTIONS(4240), 52,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_field,
      anon_sym_instance,
      anon_sym_module,
      anon_sym_data,
      anon_sym_codata,
      anon_sym_record,
      anon_sym_infix,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_variable,
      anon_sym_mutual,
      anon_sym_abstract,
      anon_sym_private,
      anon_sym_macro,
      anon_sym_postulate,
      anon_sym_primitive,
      anon_sym_open,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      sym_pragma,
      anon_sym_syntax,
      anon_sym_LBRACE,
      anon_sym_pattern,
      anon_sym_unquoteDecl,
      anon_sym_unquoteDef,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_AT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [359113] = 5,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(394), 1,
      anon_sym_BSLASH,
    ACTIONS(4644), 1,
      anon_sym_in,
    STATE(8938), 1,
      sym__let_body,
    ACTIONS(4240), 52,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_field,
      anon_sym_instance,
      anon_sym_module,
      anon_sym_data,
      anon_sym_codata,
      anon_sym_record,
      anon_sym_infix,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_variable,
      anon_sym_mutual,
      anon_sym_abstract,
      anon_sym_private,
      anon_sym_macro,
      anon_sym_postulate,
      anon_sym_primitive,
      anon_sym_open,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      sym_pragma,
      anon_sym_syntax,
      anon_sym_LBRACE,
      anon_sym_pattern,
      anon_sym_unquoteDecl,
      anon_sym_unquoteDef,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_AT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [359180] = 5,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(394), 1,
      anon_sym_BSLASH,
    ACTIONS(4644), 1,
      anon_sym_in,
    STATE(8947), 1,
      sym__let_body,
    ACTIONS(4240), 52,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_field,
      anon_sym_instance,
      anon_sym_module,
      anon_sym_data,
      anon_sym_codata,
      anon_sym_record,
      anon_sym_infix,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_variable,
      anon_sym_mutual,
      anon_sym_abstract,
      anon_sym_private,
      anon_sym_macro,
      anon_sym_postulate,
      anon_sym_primitive,
      anon_sym_open,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      sym_pragma,
      anon_sym_syntax,
      anon_sym_LBRACE,
      anon_sym_pattern,
      anon_sym_unquoteDecl,
      anon_sym_unquoteDef,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_AT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [359247] = 5,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(394), 1,
      anon_sym_BSLASH,
    ACTIONS(4672), 1,
      anon_sym_in,
    STATE(8944), 1,
      sym__let_body,
    ACTIONS(4240), 52,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_field,
      anon_sym_instance,
      anon_sym_module,
      anon_sym_data,
      anon_sym_codata,
      anon_sym_record,
      anon_sym_infix,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_variable,
      anon_sym_mutual,
      anon_sym_abstract,
      anon_sym_private,
      anon_sym_macro,
      anon_sym_postulate,
      anon_sym_primitive,
      anon_sym_open,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      sym_pragma,
      anon_sym_syntax,
      anon_sym_LBRACE,
      anon_sym_pattern,
      anon_sym_unquoteDecl,
      anon_sym_unquoteDef,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_AT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [359314] = 5,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(394), 1,
      anon_sym_BSLASH,
    ACTIONS(4672), 1,
      anon_sym_in,
    STATE(8994), 1,
      sym__let_body,
    ACTIONS(4240), 52,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_field,
      anon_sym_instance,
      anon_sym_module,
      anon_sym_data,
      anon_sym_codata,
      anon_sym_record,
      anon_sym_infix,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_variable,
      anon_sym_mutual,
      anon_sym_abstract,
      anon_sym_private,
      anon_sym_macro,
      anon_sym_postulate,
      anon_sym_primitive,
      anon_sym_open,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      sym_pragma,
      anon_sym_syntax,
      anon_sym_LBRACE,
      anon_sym_pattern,
      anon_sym_unquoteDecl,
      anon_sym_unquoteDef,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_AT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [359381] = 31,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(1866), 1,
      sym_id,
    ACTIONS(1870), 1,
      anon_sym_BSLASH,
    ACTIONS(1872), 1,
      anon_sym_u03bb,
    ACTIONS(1876), 1,
      anon_sym_record,
    ACTIONS(1886), 1,
      aux_sym__qid_token1,
    ACTIONS(1890), 1,
      anon_sym_quoteGoal,
    ACTIONS(1892), 1,
      anon_sym_tactic,
    ACTIONS(1894), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1896), 1,
      anon_sym_u2987,
    ACTIONS(1898), 1,
      anon_sym_let,
    ACTIONS(1902), 1,
      anon_sym_Set,
    ACTIONS(4238), 1,
      anon_sym_PIPE,
    ACTIONS(4884), 1,
      anon_sym_LPAREN,
    ACTIONS(4886), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4888), 1,
      anon_sym_u2983,
    ACTIONS(4890), 1,
      anon_sym_LBRACE,
    ACTIONS(4892), 1,
      anon_sym_DOT,
    STATE(1982), 1,
      sym__ARROW,
    STATE(3982), 1,
      aux_sym__atoms,
    STATE(4366), 1,
      sym_atom,
    STATE(8032), 1,
      sym__LAMBDA,
    STATE(8379), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1868), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1900), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(4882), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(4264), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4263), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9001), 7,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1874), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [359500] = 5,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(394), 1,
      anon_sym_BSLASH,
    ACTIONS(4246), 1,
      anon_sym_in,
    STATE(8947), 1,
      sym__let_body,
    ACTIONS(4240), 52,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_field,
      anon_sym_instance,
      anon_sym_module,
      anon_sym_data,
      anon_sym_codata,
      anon_sym_record,
      anon_sym_infix,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_variable,
      anon_sym_mutual,
      anon_sym_abstract,
      anon_sym_private,
      anon_sym_macro,
      anon_sym_postulate,
      anon_sym_primitive,
      anon_sym_open,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      sym_pragma,
      anon_sym_syntax,
      anon_sym_LBRACE,
      anon_sym_pattern,
      anon_sym_unquoteDecl,
      anon_sym_unquoteDef,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_AT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [359567] = 31,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1910), 1,
      anon_sym_BSLASH,
    ACTIONS(1912), 1,
      anon_sym_u03bb,
    ACTIONS(1928), 1,
      anon_sym_quoteGoal,
    ACTIONS(1930), 1,
      anon_sym_tactic,
    ACTIONS(1936), 1,
      anon_sym_let,
    ACTIONS(2174), 1,
      sym_id,
    ACTIONS(2182), 1,
      anon_sym_record,
    ACTIONS(2192), 1,
      aux_sym__qid_token1,
    ACTIONS(2198), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2200), 1,
      anon_sym_u2987,
    ACTIONS(2204), 1,
      anon_sym_Set,
    ACTIONS(4238), 1,
      anon_sym_PIPE,
    ACTIONS(4872), 1,
      anon_sym_LPAREN,
    ACTIONS(4874), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4876), 1,
      anon_sym_u2983,
    ACTIONS(4878), 1,
      anon_sym_LBRACE,
    ACTIONS(4880), 1,
      anon_sym_DOT,
    STATE(1931), 1,
      sym__ARROW,
    STATE(3982), 1,
      aux_sym__atoms,
    STATE(4611), 1,
      sym_atom,
    STATE(8153), 1,
      sym__LAMBDA,
    STATE(8431), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1906), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(4894), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(4536), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4531), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8997), 7,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2180), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [359686] = 5,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(394), 1,
      anon_sym_BSLASH,
    ACTIONS(4494), 1,
      anon_sym_in,
    STATE(8976), 1,
      sym__let_body,
    ACTIONS(4240), 52,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_field,
      anon_sym_instance,
      anon_sym_module,
      anon_sym_data,
      anon_sym_codata,
      anon_sym_record,
      anon_sym_infix,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_variable,
      anon_sym_mutual,
      anon_sym_abstract,
      anon_sym_private,
      anon_sym_macro,
      anon_sym_postulate,
      anon_sym_primitive,
      anon_sym_open,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      sym_pragma,
      anon_sym_syntax,
      anon_sym_LBRACE,
      anon_sym_pattern,
      anon_sym_unquoteDecl,
      anon_sym_unquoteDef,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_AT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [359753] = 5,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(394), 1,
      anon_sym_BSLASH,
    ACTIONS(4478), 1,
      anon_sym_in,
    STATE(8994), 1,
      sym__let_body,
    ACTIONS(4240), 52,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_field,
      anon_sym_instance,
      anon_sym_module,
      anon_sym_data,
      anon_sym_codata,
      anon_sym_record,
      anon_sym_infix,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_variable,
      anon_sym_mutual,
      anon_sym_abstract,
      anon_sym_private,
      anon_sym_macro,
      anon_sym_postulate,
      anon_sym_primitive,
      anon_sym_open,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      sym_pragma,
      anon_sym_syntax,
      anon_sym_LBRACE,
      anon_sym_pattern,
      anon_sym_unquoteDecl,
      anon_sym_unquoteDef,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_AT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [359820] = 5,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(394), 1,
      anon_sym_BSLASH,
    ACTIONS(4652), 1,
      anon_sym_in,
    STATE(8976), 1,
      sym__let_body,
    ACTIONS(4240), 52,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_field,
      anon_sym_instance,
      anon_sym_module,
      anon_sym_data,
      anon_sym_codata,
      anon_sym_record,
      anon_sym_infix,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_variable,
      anon_sym_mutual,
      anon_sym_abstract,
      anon_sym_private,
      anon_sym_macro,
      anon_sym_postulate,
      anon_sym_primitive,
      anon_sym_open,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      sym_pragma,
      anon_sym_syntax,
      anon_sym_LBRACE,
      anon_sym_pattern,
      anon_sym_unquoteDecl,
      anon_sym_unquoteDef,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_AT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [359887] = 31,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(2614), 1,
      sym_id,
    ACTIONS(2618), 1,
      anon_sym_BSLASH,
    ACTIONS(2620), 1,
      anon_sym_u03bb,
    ACTIONS(2624), 1,
      anon_sym_record,
    ACTIONS(2634), 1,
      aux_sym__qid_token1,
    ACTIONS(2638), 1,
      anon_sym_quoteGoal,
    ACTIONS(2640), 1,
      anon_sym_tactic,
    ACTIONS(2642), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2644), 1,
      anon_sym_u2987,
    ACTIONS(2646), 1,
      anon_sym_let,
    ACTIONS(2650), 1,
      anon_sym_Set,
    ACTIONS(4238), 1,
      anon_sym_PIPE,
    ACTIONS(4898), 1,
      anon_sym_LPAREN,
    ACTIONS(4900), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4902), 1,
      anon_sym_u2983,
    ACTIONS(4904), 1,
      anon_sym_LBRACE,
    ACTIONS(4906), 1,
      anon_sym_DOT,
    STATE(1538), 1,
      sym__ARROW,
    STATE(3982), 1,
      aux_sym__atoms,
    STATE(4849), 1,
      sym_atom,
    STATE(8093), 1,
      sym__LAMBDA,
    STATE(8414), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2616), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2648), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(4896), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(4799), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4784), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9001), 7,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2622), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [360006] = 31,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(1242), 1,
      anon_sym_Set,
    ACTIONS(4238), 1,
      anon_sym_PIPE,
    ACTIONS(4908), 1,
      anon_sym_LPAREN,
    ACTIONS(4910), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4912), 1,
      anon_sym_u2983,
    ACTIONS(4914), 1,
      anon_sym_LBRACE,
    ACTIONS(4916), 1,
      anon_sym_DOT,
    STATE(2204), 1,
      sym__ARROW,
    STATE(3982), 1,
      aux_sym__atoms,
    STATE(5404), 1,
      sym_atom,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(4436), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9454), 7,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [360125] = 5,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(394), 1,
      anon_sym_BSLASH,
    ACTIONS(4674), 1,
      anon_sym_in,
    STATE(9467), 1,
      sym__let_body,
    ACTIONS(4240), 52,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_field,
      anon_sym_instance,
      anon_sym_module,
      anon_sym_data,
      anon_sym_codata,
      anon_sym_record,
      anon_sym_infix,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_variable,
      anon_sym_mutual,
      anon_sym_abstract,
      anon_sym_private,
      anon_sym_macro,
      anon_sym_postulate,
      anon_sym_primitive,
      anon_sym_open,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      sym_pragma,
      anon_sym_syntax,
      anon_sym_LBRACE,
      anon_sym_pattern,
      anon_sym_unquoteDecl,
      anon_sym_unquoteDef,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_AT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [360192] = 5,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(394), 1,
      anon_sym_BSLASH,
    ACTIONS(4652), 1,
      anon_sym_in,
    STATE(8938), 1,
      sym__let_body,
    ACTIONS(4240), 52,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_field,
      anon_sym_instance,
      anon_sym_module,
      anon_sym_data,
      anon_sym_codata,
      anon_sym_record,
      anon_sym_infix,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_variable,
      anon_sym_mutual,
      anon_sym_abstract,
      anon_sym_private,
      anon_sym_macro,
      anon_sym_postulate,
      anon_sym_primitive,
      anon_sym_open,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      sym_pragma,
      anon_sym_syntax,
      anon_sym_LBRACE,
      anon_sym_pattern,
      anon_sym_unquoteDecl,
      anon_sym_unquoteDef,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_AT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [360259] = 5,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(394), 1,
      anon_sym_BSLASH,
    ACTIONS(4478), 1,
      anon_sym_in,
    STATE(8944), 1,
      sym__let_body,
    ACTIONS(4240), 52,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_field,
      anon_sym_instance,
      anon_sym_module,
      anon_sym_data,
      anon_sym_codata,
      anon_sym_record,
      anon_sym_infix,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_variable,
      anon_sym_mutual,
      anon_sym_abstract,
      anon_sym_private,
      anon_sym_macro,
      anon_sym_postulate,
      anon_sym_primitive,
      anon_sym_open,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      sym_pragma,
      anon_sym_syntax,
      anon_sym_LBRACE,
      anon_sym_pattern,
      anon_sym_unquoteDecl,
      anon_sym_unquoteDef,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_AT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [360326] = 30,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(964), 1,
      anon_sym_quoteGoal,
    ACTIONS(972), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4214), 1,
      anon_sym_BSLASH,
    ACTIONS(4216), 1,
      anon_sym_u03bb,
    ACTIONS(4218), 1,
      anon_sym_tactic,
    STATE(3891), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8047), 1,
      sym__LAMBDA,
    STATE(8355), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(942), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9841), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [360442] = 30,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2302), 1,
      anon_sym_BSLASH,
    ACTIONS(2304), 1,
      anon_sym_u03bb,
    ACTIONS(2322), 1,
      anon_sym_quoteGoal,
    ACTIONS(2324), 1,
      anon_sym_tactic,
    ACTIONS(2330), 1,
      anon_sym_let,
    ACTIONS(3638), 1,
      sym_id,
    ACTIONS(3644), 1,
      anon_sym_record,
    ACTIONS(3646), 1,
      anon_sym_LPAREN,
    ACTIONS(3648), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3650), 1,
      anon_sym_u2983,
    ACTIONS(3652), 1,
      anon_sym_LBRACE,
    ACTIONS(3654), 1,
      aux_sym__qid_token1,
    ACTIONS(3656), 1,
      anon_sym_DOT,
    ACTIONS(3658), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3660), 1,
      anon_sym_u2987,
    ACTIONS(3664), 1,
      anon_sym_Set,
    STATE(1599), 1,
      sym__ARROW,
    STATE(4004), 1,
      aux_sym__atoms,
    STATE(5734), 1,
      sym_atom,
    STATE(8138), 1,
      sym__LAMBDA,
    STATE(8476), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2300), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3662), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(4918), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(5680), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5681), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8997), 7,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3642), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [360558] = 30,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(878), 1,
      anon_sym_quoteGoal,
    ACTIONS(886), 1,
      anon_sym_let,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(4182), 1,
      sym_id,
    ACTIONS(4184), 1,
      anon_sym_BSLASH,
    ACTIONS(4186), 1,
      anon_sym_u03bb,
    ACTIONS(4190), 1,
      anon_sym_record,
    ACTIONS(4192), 1,
      anon_sym_LPAREN,
    ACTIONS(4194), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4196), 1,
      anon_sym_u2983,
    ACTIONS(4198), 1,
      anon_sym_LBRACE,
    ACTIONS(4200), 1,
      aux_sym__qid_token1,
    ACTIONS(4202), 1,
      anon_sym_DOT,
    ACTIONS(4204), 1,
      anon_sym_tactic,
    ACTIONS(4206), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4208), 1,
      anon_sym_u2987,
    ACTIONS(4212), 1,
      anon_sym_Set,
    STATE(3888), 1,
      aux_sym__atoms,
    STATE(6121), 1,
      sym__qid,
    STATE(6386), 1,
      sym_atom,
    STATE(8067), 1,
      sym__LAMBDA,
    STATE(8369), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(852), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4210), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6575), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6565), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(4188), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9887), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [360674] = 31,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(1302), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(11927), 1,
      sym__binding_ids_and_absurds,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(10049), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [360792] = 30,
    ACTIONS(710), 1,
      anon_sym_DASH,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(920), 1,
      anon_sym_quoteGoal,
    ACTIONS(928), 1,
      anon_sym_let,
    ACTIONS(3058), 1,
      anon_sym_BSLASH,
    ACTIONS(3060), 1,
      anon_sym_u03bb,
    ACTIONS(3064), 1,
      anon_sym_record,
    ACTIONS(3066), 1,
      anon_sym_LPAREN,
    ACTIONS(3068), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3070), 1,
      anon_sym_u2983,
    ACTIONS(3072), 1,
      anon_sym_LBRACE,
    ACTIONS(3076), 1,
      aux_sym__qid_token1,
    ACTIONS(3078), 1,
      anon_sym_DOT,
    ACTIONS(3080), 1,
      anon_sym_tactic,
    ACTIONS(3082), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3084), 1,
      anon_sym_u2987,
    ACTIONS(3088), 1,
      anon_sym_Set,
    ACTIONS(4220), 1,
      sym_id,
    STATE(3892), 1,
      aux_sym__atoms,
    STATE(6084), 1,
      sym__qid,
    STATE(6427), 1,
      sym_atom,
    STATE(8123), 1,
      sym__LAMBDA,
    STATE(8396), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3086), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6715), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6714), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3062), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9809), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [360908] = 31,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(1302), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(10234), 1,
      sym__binding_ids_and_absurds,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9856), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [361026] = 30,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2094), 1,
      sym_id,
    ACTIONS(2100), 1,
      anon_sym_BSLASH,
    ACTIONS(2102), 1,
      anon_sym_u03bb,
    ACTIONS(2106), 1,
      anon_sym_record,
    ACTIONS(2108), 1,
      anon_sym_LPAREN,
    ACTIONS(2110), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2112), 1,
      anon_sym_u2983,
    ACTIONS(2114), 1,
      anon_sym_LBRACE,
    ACTIONS(2116), 1,
      aux_sym__qid_token1,
    ACTIONS(2118), 1,
      anon_sym_DOT,
    ACTIONS(2120), 1,
      anon_sym_quoteGoal,
    ACTIONS(2122), 1,
      anon_sym_tactic,
    ACTIONS(2124), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2126), 1,
      anon_sym_u2987,
    ACTIONS(2128), 1,
      anon_sym_let,
    ACTIONS(2132), 1,
      anon_sym_Set,
    STATE(1427), 1,
      sym__ARROW,
    STATE(4004), 1,
      aux_sym__atoms,
    STATE(5601), 1,
      sym_atom,
    STATE(8075), 1,
      sym__LAMBDA,
    STATE(8428), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2096), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2130), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(4920), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(5451), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5453), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8997), 7,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2104), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [361142] = 30,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(878), 1,
      anon_sym_quoteGoal,
    ACTIONS(886), 1,
      anon_sym_let,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(4182), 1,
      sym_id,
    ACTIONS(4184), 1,
      anon_sym_BSLASH,
    ACTIONS(4186), 1,
      anon_sym_u03bb,
    ACTIONS(4190), 1,
      anon_sym_record,
    ACTIONS(4192), 1,
      anon_sym_LPAREN,
    ACTIONS(4194), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4196), 1,
      anon_sym_u2983,
    ACTIONS(4198), 1,
      anon_sym_LBRACE,
    ACTIONS(4200), 1,
      aux_sym__qid_token1,
    ACTIONS(4202), 1,
      anon_sym_DOT,
    ACTIONS(4204), 1,
      anon_sym_tactic,
    ACTIONS(4206), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4208), 1,
      anon_sym_u2987,
    ACTIONS(4212), 1,
      anon_sym_Set,
    STATE(3888), 1,
      aux_sym__atoms,
    STATE(6121), 1,
      sym__qid,
    STATE(6386), 1,
      sym_atom,
    STATE(8067), 1,
      sym__LAMBDA,
    STATE(8369), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(852), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4210), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6575), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6565), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(4188), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9789), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [361258] = 30,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2134), 1,
      sym_id,
    ACTIONS(2140), 1,
      anon_sym_BSLASH,
    ACTIONS(2142), 1,
      anon_sym_u03bb,
    ACTIONS(2146), 1,
      anon_sym_record,
    ACTIONS(2148), 1,
      anon_sym_LPAREN,
    ACTIONS(2150), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2152), 1,
      anon_sym_u2983,
    ACTIONS(2154), 1,
      anon_sym_LBRACE,
    ACTIONS(2156), 1,
      aux_sym__qid_token1,
    ACTIONS(2158), 1,
      anon_sym_DOT,
    ACTIONS(2160), 1,
      anon_sym_quoteGoal,
    ACTIONS(2162), 1,
      anon_sym_tactic,
    ACTIONS(2164), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2166), 1,
      anon_sym_u2987,
    ACTIONS(2168), 1,
      anon_sym_let,
    ACTIONS(2172), 1,
      anon_sym_Set,
    STATE(1835), 1,
      sym__ARROW,
    STATE(4004), 1,
      aux_sym__atoms,
    STATE(5718), 1,
      sym_atom,
    STATE(8040), 1,
      sym__LAMBDA,
    STATE(8460), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2136), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2170), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(4922), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(5624), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5627), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8997), 7,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2144), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [361374] = 31,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(1302), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(10404), 1,
      sym__binding_ids_and_absurds,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9874), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [361492] = 30,
    ACTIONS(710), 1,
      anon_sym_DASH,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(920), 1,
      anon_sym_quoteGoal,
    ACTIONS(928), 1,
      anon_sym_let,
    ACTIONS(3058), 1,
      anon_sym_BSLASH,
    ACTIONS(3060), 1,
      anon_sym_u03bb,
    ACTIONS(3064), 1,
      anon_sym_record,
    ACTIONS(3066), 1,
      anon_sym_LPAREN,
    ACTIONS(3068), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3070), 1,
      anon_sym_u2983,
    ACTIONS(3072), 1,
      anon_sym_LBRACE,
    ACTIONS(3076), 1,
      aux_sym__qid_token1,
    ACTIONS(3078), 1,
      anon_sym_DOT,
    ACTIONS(3080), 1,
      anon_sym_tactic,
    ACTIONS(3082), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3084), 1,
      anon_sym_u2987,
    ACTIONS(3088), 1,
      anon_sym_Set,
    ACTIONS(4220), 1,
      sym_id,
    STATE(3892), 1,
      aux_sym__atoms,
    STATE(6084), 1,
      sym__qid,
    STATE(6427), 1,
      sym_atom,
    STATE(8123), 1,
      sym__LAMBDA,
    STATE(8396), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3086), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6715), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6714), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3062), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10077), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [361608] = 30,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(2964), 1,
      anon_sym_quoteGoal,
    ACTIONS(2972), 1,
      anon_sym_let,
    ACTIONS(3522), 1,
      anon_sym_BSLASH,
    ACTIONS(3524), 1,
      anon_sym_u03bb,
    ACTIONS(3542), 1,
      anon_sym_tactic,
    ACTIONS(4924), 1,
      sym_id,
    ACTIONS(4928), 1,
      anon_sym_record,
    ACTIONS(4930), 1,
      anon_sym_LPAREN,
    ACTIONS(4932), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4934), 1,
      anon_sym_u2983,
    ACTIONS(4936), 1,
      anon_sym_LBRACE,
    ACTIONS(4938), 1,
      aux_sym__qid_token1,
    ACTIONS(4940), 1,
      anon_sym_DOT,
    ACTIONS(4942), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4944), 1,
      anon_sym_u2987,
    ACTIONS(4948), 1,
      anon_sym_Set,
    STATE(3712), 1,
      aux_sym__with_exprs_repeat1,
    STATE(3842), 1,
      aux_sym__atoms,
    STATE(5872), 1,
      sym_atom,
    STATE(8058), 1,
      sym__LAMBDA,
    STATE(8418), 1,
      sym__FORALL,
    STATE(8939), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2940), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4946), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5898), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5899), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(4926), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [361724] = 30,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(964), 1,
      anon_sym_quoteGoal,
    ACTIONS(972), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4214), 1,
      anon_sym_BSLASH,
    ACTIONS(4216), 1,
      anon_sym_u03bb,
    ACTIONS(4218), 1,
      anon_sym_tactic,
    STATE(3891), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8047), 1,
      sym__LAMBDA,
    STATE(8355), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(942), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10098), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [361840] = 30,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(3266), 1,
      anon_sym_BSLASH,
    ACTIONS(3268), 1,
      anon_sym_u03bb,
    ACTIONS(3286), 1,
      anon_sym_quoteGoal,
    ACTIONS(3288), 1,
      anon_sym_tactic,
    ACTIONS(3294), 1,
      anon_sym_let,
    ACTIONS(4950), 1,
      sym_id,
    ACTIONS(4954), 1,
      anon_sym_record,
    ACTIONS(4956), 1,
      anon_sym_LPAREN,
    ACTIONS(4958), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4960), 1,
      anon_sym_u2983,
    ACTIONS(4962), 1,
      anon_sym_LBRACE,
    ACTIONS(4964), 1,
      aux_sym__qid_token1,
    ACTIONS(4966), 1,
      anon_sym_DOT,
    ACTIONS(4968), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4970), 1,
      anon_sym_u2987,
    ACTIONS(4974), 1,
      anon_sym_Set,
    STATE(3739), 1,
      aux_sym__with_exprs_repeat1,
    STATE(3878), 1,
      aux_sym__atoms,
    STATE(4226), 1,
      sym_atom,
    STATE(8143), 1,
      sym__LAMBDA,
    STATE(8451), 1,
      sym__FORALL,
    STATE(8939), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3264), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4972), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4253), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4254), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(4952), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [361956] = 30,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(878), 1,
      anon_sym_quoteGoal,
    ACTIONS(886), 1,
      anon_sym_let,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(4182), 1,
      sym_id,
    ACTIONS(4184), 1,
      anon_sym_BSLASH,
    ACTIONS(4186), 1,
      anon_sym_u03bb,
    ACTIONS(4190), 1,
      anon_sym_record,
    ACTIONS(4192), 1,
      anon_sym_LPAREN,
    ACTIONS(4194), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4196), 1,
      anon_sym_u2983,
    ACTIONS(4198), 1,
      anon_sym_LBRACE,
    ACTIONS(4200), 1,
      aux_sym__qid_token1,
    ACTIONS(4202), 1,
      anon_sym_DOT,
    ACTIONS(4204), 1,
      anon_sym_tactic,
    ACTIONS(4206), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4208), 1,
      anon_sym_u2987,
    ACTIONS(4212), 1,
      anon_sym_Set,
    STATE(3888), 1,
      aux_sym__atoms,
    STATE(6121), 1,
      sym__qid,
    STATE(6386), 1,
      sym_atom,
    STATE(8067), 1,
      sym__LAMBDA,
    STATE(8369), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(852), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4210), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6575), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6565), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(4188), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10097), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [362072] = 30,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(920), 1,
      anon_sym_quoteGoal,
    ACTIONS(928), 1,
      anon_sym_let,
    ACTIONS(3058), 1,
      anon_sym_BSLASH,
    ACTIONS(3060), 1,
      anon_sym_u03bb,
    ACTIONS(3080), 1,
      anon_sym_tactic,
    ACTIONS(4976), 1,
      sym_id,
    ACTIONS(4980), 1,
      anon_sym_record,
    ACTIONS(4982), 1,
      anon_sym_LPAREN,
    ACTIONS(4984), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4986), 1,
      anon_sym_u2983,
    ACTIONS(4988), 1,
      anon_sym_LBRACE,
    ACTIONS(4990), 1,
      aux_sym__qid_token1,
    ACTIONS(4992), 1,
      anon_sym_DOT,
    ACTIONS(4994), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4996), 1,
      anon_sym_u2987,
    ACTIONS(5000), 1,
      anon_sym_Set,
    STATE(3759), 1,
      aux_sym__with_exprs_repeat1,
    STATE(3776), 1,
      aux_sym__atoms,
    STATE(6120), 1,
      sym_atom,
    STATE(8123), 1,
      sym__LAMBDA,
    STATE(8396), 1,
      sym__FORALL,
    STATE(9466), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6124), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6161), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(4978), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [362188] = 30,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2800), 1,
      anon_sym_quoteGoal,
    ACTIONS(2804), 1,
      anon_sym_let,
    ACTIONS(2806), 1,
      sym_id,
    ACTIONS(2810), 1,
      anon_sym_BSLASH,
    ACTIONS(2812), 1,
      anon_sym_u03bb,
    ACTIONS(2816), 1,
      anon_sym_record,
    ACTIONS(2818), 1,
      anon_sym_LPAREN,
    ACTIONS(2820), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2822), 1,
      anon_sym_u2983,
    ACTIONS(2824), 1,
      anon_sym_LBRACE,
    ACTIONS(2826), 1,
      aux_sym__qid_token1,
    ACTIONS(2828), 1,
      anon_sym_DOT,
    ACTIONS(2830), 1,
      anon_sym_tactic,
    ACTIONS(2832), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2834), 1,
      anon_sym_u2987,
    ACTIONS(2838), 1,
      anon_sym_Set,
    STATE(2143), 1,
      sym__ARROW,
    STATE(4004), 1,
      aux_sym__atoms,
    STATE(5831), 1,
      sym_atom,
    STATE(8081), 1,
      sym__LAMBDA,
    STATE(8490), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2794), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2836), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(4434), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(5982), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5981), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8997), 7,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2814), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [362304] = 30,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(964), 1,
      anon_sym_quoteGoal,
    ACTIONS(972), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4214), 1,
      anon_sym_BSLASH,
    ACTIONS(4216), 1,
      anon_sym_u03bb,
    ACTIONS(4218), 1,
      anon_sym_tactic,
    STATE(3891), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8047), 1,
      sym__LAMBDA,
    STATE(8355), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(942), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9885), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [362420] = 30,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2100), 1,
      anon_sym_BSLASH,
    ACTIONS(2102), 1,
      anon_sym_u03bb,
    ACTIONS(2120), 1,
      anon_sym_quoteGoal,
    ACTIONS(2122), 1,
      anon_sym_tactic,
    ACTIONS(2128), 1,
      anon_sym_let,
    ACTIONS(5002), 1,
      sym_id,
    ACTIONS(5006), 1,
      anon_sym_record,
    ACTIONS(5008), 1,
      anon_sym_LPAREN,
    ACTIONS(5010), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(5012), 1,
      anon_sym_u2983,
    ACTIONS(5014), 1,
      anon_sym_LBRACE,
    ACTIONS(5016), 1,
      aux_sym__qid_token1,
    ACTIONS(5018), 1,
      anon_sym_DOT,
    ACTIONS(5020), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(5022), 1,
      anon_sym_u2987,
    ACTIONS(5026), 1,
      anon_sym_Set,
    STATE(3757), 1,
      aux_sym__with_exprs_repeat1,
    STATE(3795), 1,
      aux_sym__atoms,
    STATE(5751), 1,
      sym_atom,
    STATE(8075), 1,
      sym__LAMBDA,
    STATE(8428), 1,
      sym__FORALL,
    STATE(8978), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2096), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(5024), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5805), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5804), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(5004), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [362536] = 30,
    ACTIONS(710), 1,
      anon_sym_DASH,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(920), 1,
      anon_sym_quoteGoal,
    ACTIONS(928), 1,
      anon_sym_let,
    ACTIONS(3058), 1,
      anon_sym_BSLASH,
    ACTIONS(3060), 1,
      anon_sym_u03bb,
    ACTIONS(3064), 1,
      anon_sym_record,
    ACTIONS(3066), 1,
      anon_sym_LPAREN,
    ACTIONS(3068), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3070), 1,
      anon_sym_u2983,
    ACTIONS(3072), 1,
      anon_sym_LBRACE,
    ACTIONS(3076), 1,
      aux_sym__qid_token1,
    ACTIONS(3078), 1,
      anon_sym_DOT,
    ACTIONS(3080), 1,
      anon_sym_tactic,
    ACTIONS(3082), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3084), 1,
      anon_sym_u2987,
    ACTIONS(3088), 1,
      anon_sym_Set,
    ACTIONS(4220), 1,
      sym_id,
    STATE(3892), 1,
      aux_sym__atoms,
    STATE(6084), 1,
      sym__qid,
    STATE(6427), 1,
      sym_atom,
    STATE(8123), 1,
      sym__LAMBDA,
    STATE(8396), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3086), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6715), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6714), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3062), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9788), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [362652] = 30,
    ACTIONS(710), 1,
      anon_sym_DASH,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(920), 1,
      anon_sym_quoteGoal,
    ACTIONS(928), 1,
      anon_sym_let,
    ACTIONS(3058), 1,
      anon_sym_BSLASH,
    ACTIONS(3060), 1,
      anon_sym_u03bb,
    ACTIONS(3064), 1,
      anon_sym_record,
    ACTIONS(3066), 1,
      anon_sym_LPAREN,
    ACTIONS(3068), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3070), 1,
      anon_sym_u2983,
    ACTIONS(3072), 1,
      anon_sym_LBRACE,
    ACTIONS(3076), 1,
      aux_sym__qid_token1,
    ACTIONS(3078), 1,
      anon_sym_DOT,
    ACTIONS(3080), 1,
      anon_sym_tactic,
    ACTIONS(3082), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3084), 1,
      anon_sym_u2987,
    ACTIONS(3088), 1,
      anon_sym_Set,
    ACTIONS(4220), 1,
      sym_id,
    STATE(3892), 1,
      aux_sym__atoms,
    STATE(6084), 1,
      sym__qid,
    STATE(6427), 1,
      sym_atom,
    STATE(8123), 1,
      sym__LAMBDA,
    STATE(8396), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3086), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6715), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6714), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3062), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10096), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [362768] = 30,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(2656), 1,
      anon_sym_BSLASH,
    ACTIONS(2658), 1,
      anon_sym_u03bb,
    ACTIONS(2676), 1,
      anon_sym_quoteGoal,
    ACTIONS(2678), 1,
      anon_sym_tactic,
    ACTIONS(2684), 1,
      anon_sym_let,
    ACTIONS(5028), 1,
      sym_id,
    ACTIONS(5032), 1,
      anon_sym_record,
    ACTIONS(5034), 1,
      anon_sym_LPAREN,
    ACTIONS(5036), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(5038), 1,
      anon_sym_u2983,
    ACTIONS(5040), 1,
      anon_sym_LBRACE,
    ACTIONS(5042), 1,
      aux_sym__qid_token1,
    ACTIONS(5044), 1,
      anon_sym_DOT,
    ACTIONS(5046), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(5048), 1,
      anon_sym_u2987,
    ACTIONS(5052), 1,
      anon_sym_Set,
    STATE(3732), 1,
      aux_sym__with_exprs_repeat1,
    STATE(3876), 1,
      aux_sym__atoms,
    STATE(5588), 1,
      sym_atom,
    STATE(8132), 1,
      sym__LAMBDA,
    STATE(8470), 1,
      sym__FORALL,
    STATE(9466), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2654), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(5050), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5401), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5405), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(5030), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [362884] = 30,
    ACTIONS(710), 1,
      anon_sym_DASH,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(920), 1,
      anon_sym_quoteGoal,
    ACTIONS(928), 1,
      anon_sym_let,
    ACTIONS(3058), 1,
      anon_sym_BSLASH,
    ACTIONS(3060), 1,
      anon_sym_u03bb,
    ACTIONS(3064), 1,
      anon_sym_record,
    ACTIONS(3066), 1,
      anon_sym_LPAREN,
    ACTIONS(3068), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3070), 1,
      anon_sym_u2983,
    ACTIONS(3072), 1,
      anon_sym_LBRACE,
    ACTIONS(3076), 1,
      aux_sym__qid_token1,
    ACTIONS(3078), 1,
      anon_sym_DOT,
    ACTIONS(3080), 1,
      anon_sym_tactic,
    ACTIONS(3082), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3084), 1,
      anon_sym_u2987,
    ACTIONS(3088), 1,
      anon_sym_Set,
    ACTIONS(4220), 1,
      sym_id,
    STATE(3892), 1,
      aux_sym__atoms,
    STATE(6084), 1,
      sym__qid,
    STATE(6427), 1,
      sym_atom,
    STATE(8123), 1,
      sym__LAMBDA,
    STATE(8396), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3086), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6715), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6714), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3062), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9782), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [363000] = 30,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(2350), 1,
      anon_sym_BSLASH,
    ACTIONS(2352), 1,
      anon_sym_u03bb,
    ACTIONS(2370), 1,
      anon_sym_quoteGoal,
    ACTIONS(2372), 1,
      anon_sym_tactic,
    ACTIONS(2378), 1,
      anon_sym_let,
    ACTIONS(5054), 1,
      sym_id,
    ACTIONS(5058), 1,
      anon_sym_record,
    ACTIONS(5060), 1,
      anon_sym_LPAREN,
    ACTIONS(5062), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(5064), 1,
      anon_sym_u2983,
    ACTIONS(5066), 1,
      anon_sym_LBRACE,
    ACTIONS(5068), 1,
      aux_sym__qid_token1,
    ACTIONS(5070), 1,
      anon_sym_DOT,
    ACTIONS(5072), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(5074), 1,
      anon_sym_u2987,
    ACTIONS(5078), 1,
      anon_sym_Set,
    STATE(3711), 1,
      aux_sym__with_exprs_repeat1,
    STATE(3807), 1,
      aux_sym__atoms,
    STATE(4532), 1,
      sym_atom,
    STATE(8119), 1,
      sym__LAMBDA,
    STATE(8372), 1,
      sym__FORALL,
    STATE(8939), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2348), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(5076), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4453), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4455), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(5056), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [363116] = 30,
    ACTIONS(706), 1,
      aux_sym__qid_token1,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1904), 1,
      sym_id,
    ACTIONS(1910), 1,
      anon_sym_BSLASH,
    ACTIONS(1912), 1,
      anon_sym_u03bb,
    ACTIONS(1916), 1,
      anon_sym_record,
    ACTIONS(1918), 1,
      anon_sym_LPAREN,
    ACTIONS(1920), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1922), 1,
      anon_sym_u2983,
    ACTIONS(1924), 1,
      anon_sym_LBRACE,
    ACTIONS(1926), 1,
      anon_sym_DOT,
    ACTIONS(1928), 1,
      anon_sym_quoteGoal,
    ACTIONS(1930), 1,
      anon_sym_tactic,
    ACTIONS(1932), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1934), 1,
      anon_sym_u2987,
    ACTIONS(1936), 1,
      anon_sym_let,
    ACTIONS(1940), 1,
      anon_sym_Set,
    STATE(1644), 1,
      sym__ARROW,
    STATE(4004), 1,
      aux_sym__atoms,
    STATE(4914), 1,
      sym_atom,
    STATE(8153), 1,
      sym__LAMBDA,
    STATE(8431), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1906), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1938), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(5080), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(4675), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4679), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8997), 7,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1914), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [363232] = 30,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(964), 1,
      anon_sym_quoteGoal,
    ACTIONS(972), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4214), 1,
      anon_sym_BSLASH,
    ACTIONS(4216), 1,
      anon_sym_u03bb,
    ACTIONS(4218), 1,
      anon_sym_tactic,
    STATE(3891), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8047), 1,
      sym__LAMBDA,
    STATE(8355), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(942), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10074), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [363348] = 30,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2448), 1,
      anon_sym_quoteGoal,
    ACTIONS(2456), 1,
      anon_sym_let,
    ACTIONS(2842), 1,
      anon_sym_BSLASH,
    ACTIONS(2844), 1,
      anon_sym_u03bb,
    ACTIONS(2862), 1,
      anon_sym_tactic,
    ACTIONS(2872), 1,
      sym_id,
    ACTIONS(2876), 1,
      anon_sym_record,
    ACTIONS(2878), 1,
      anon_sym_LPAREN,
    ACTIONS(2880), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2882), 1,
      anon_sym_u2983,
    ACTIONS(2884), 1,
      anon_sym_LBRACE,
    ACTIONS(2886), 1,
      aux_sym__qid_token1,
    ACTIONS(2888), 1,
      anon_sym_DOT,
    ACTIONS(2890), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2892), 1,
      anon_sym_u2987,
    ACTIONS(2896), 1,
      anon_sym_Set,
    STATE(1578), 1,
      sym__ARROW,
    STATE(4004), 1,
      aux_sym__atoms,
    STATE(4945), 1,
      sym_atom,
    STATE(8053), 1,
      sym__LAMBDA,
    STATE(8423), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2424), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2894), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(4300), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(5291), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5287), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8997), 7,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2874), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [363464] = 31,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(1302), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(10677), 1,
      sym__binding_ids_and_absurds,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9748), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [363582] = 30,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(2388), 1,
      anon_sym_BSLASH,
    ACTIONS(2390), 1,
      anon_sym_u03bb,
    ACTIONS(2408), 1,
      anon_sym_quoteGoal,
    ACTIONS(2410), 1,
      anon_sym_tactic,
    ACTIONS(2416), 1,
      anon_sym_let,
    ACTIONS(5082), 1,
      sym_id,
    ACTIONS(5086), 1,
      anon_sym_record,
    ACTIONS(5088), 1,
      anon_sym_LPAREN,
    ACTIONS(5090), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(5092), 1,
      anon_sym_u2983,
    ACTIONS(5094), 1,
      anon_sym_LBRACE,
    ACTIONS(5096), 1,
      aux_sym__qid_token1,
    ACTIONS(5098), 1,
      anon_sym_DOT,
    ACTIONS(5100), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(5102), 1,
      anon_sym_u2987,
    ACTIONS(5106), 1,
      anon_sym_Set,
    STATE(3752), 1,
      aux_sym__with_exprs_repeat1,
    STATE(3838), 1,
      aux_sym__atoms,
    STATE(5358), 1,
      sym_atom,
    STATE(8139), 1,
      sym__LAMBDA,
    STATE(8518), 1,
      sym__FORALL,
    STATE(8939), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2386), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(5104), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5584), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5587), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(5084), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [363698] = 31,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(1302), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(10441), 1,
      sym__binding_ids_and_absurds,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9793), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [363816] = 31,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(1302), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(11312), 1,
      sym__binding_ids_and_absurds,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9991), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [363934] = 30,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(964), 1,
      anon_sym_quoteGoal,
    ACTIONS(972), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4214), 1,
      anon_sym_BSLASH,
    ACTIONS(4216), 1,
      anon_sym_u03bb,
    ACTIONS(4218), 1,
      anon_sym_tactic,
    STATE(3891), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8047), 1,
      sym__LAMBDA,
    STATE(8355), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(942), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10113), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [364050] = 30,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(3168), 1,
      sym_id,
    ACTIONS(3174), 1,
      anon_sym_BSLASH,
    ACTIONS(3176), 1,
      anon_sym_u03bb,
    ACTIONS(3180), 1,
      anon_sym_record,
    ACTIONS(3182), 1,
      anon_sym_LPAREN,
    ACTIONS(3184), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3186), 1,
      anon_sym_u2983,
    ACTIONS(3188), 1,
      anon_sym_LBRACE,
    ACTIONS(3190), 1,
      aux_sym__qid_token1,
    ACTIONS(3192), 1,
      anon_sym_DOT,
    ACTIONS(3194), 1,
      anon_sym_quoteGoal,
    ACTIONS(3196), 1,
      anon_sym_tactic,
    ACTIONS(3198), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3200), 1,
      anon_sym_u2987,
    ACTIONS(3202), 1,
      anon_sym_let,
    ACTIONS(3206), 1,
      anon_sym_Set,
    STATE(2246), 1,
      sym__ARROW,
    STATE(4004), 1,
      aux_sym__atoms,
    STATE(5142), 1,
      sym_atom,
    STATE(8051), 1,
      sym__LAMBDA,
    STATE(8409), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3170), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3204), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(5108), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(4934), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4921), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9001), 7,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3178), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [364166] = 30,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(3266), 1,
      anon_sym_BSLASH,
    ACTIONS(3268), 1,
      anon_sym_u03bb,
    ACTIONS(3286), 1,
      anon_sym_quoteGoal,
    ACTIONS(3288), 1,
      anon_sym_tactic,
    ACTIONS(3294), 1,
      anon_sym_let,
    ACTIONS(3732), 1,
      sym_id,
    ACTIONS(3738), 1,
      anon_sym_record,
    ACTIONS(3740), 1,
      anon_sym_LPAREN,
    ACTIONS(3742), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3744), 1,
      anon_sym_u2983,
    ACTIONS(3746), 1,
      anon_sym_LBRACE,
    ACTIONS(3748), 1,
      aux_sym__qid_token1,
    ACTIONS(3750), 1,
      anon_sym_DOT,
    ACTIONS(3752), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3754), 1,
      anon_sym_u2987,
    ACTIONS(3758), 1,
      anon_sym_Set,
    STATE(2283), 1,
      sym__ARROW,
    STATE(4004), 1,
      aux_sym__atoms,
    STATE(4058), 1,
      sym_atom,
    STATE(8143), 1,
      sym__LAMBDA,
    STATE(8451), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3264), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3756), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(5110), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(4073), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4070), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9001), 7,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3736), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [364282] = 30,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(5112), 1,
      sym_id,
    ACTIONS(5116), 1,
      anon_sym_record,
    ACTIONS(5118), 1,
      anon_sym_LPAREN,
    ACTIONS(5120), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(5122), 1,
      anon_sym_u2983,
    ACTIONS(5124), 1,
      anon_sym_LBRACE,
    ACTIONS(5126), 1,
      aux_sym__qid_token1,
    ACTIONS(5128), 1,
      anon_sym_DOT,
    ACTIONS(5130), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(5132), 1,
      anon_sym_u2987,
    ACTIONS(5136), 1,
      anon_sym_Set,
    STATE(3754), 1,
      aux_sym__with_exprs_repeat1,
    STATE(3871), 1,
      aux_sym__atoms,
    STATE(6081), 1,
      sym_atom,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    STATE(8978), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(5134), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6010), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6007), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(5114), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [364398] = 30,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(878), 1,
      anon_sym_quoteGoal,
    ACTIONS(886), 1,
      anon_sym_let,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(4182), 1,
      sym_id,
    ACTIONS(4184), 1,
      anon_sym_BSLASH,
    ACTIONS(4186), 1,
      anon_sym_u03bb,
    ACTIONS(4190), 1,
      anon_sym_record,
    ACTIONS(4192), 1,
      anon_sym_LPAREN,
    ACTIONS(4194), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4196), 1,
      anon_sym_u2983,
    ACTIONS(4198), 1,
      anon_sym_LBRACE,
    ACTIONS(4200), 1,
      aux_sym__qid_token1,
    ACTIONS(4202), 1,
      anon_sym_DOT,
    ACTIONS(4204), 1,
      anon_sym_tactic,
    ACTIONS(4206), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4208), 1,
      anon_sym_u2987,
    ACTIONS(4212), 1,
      anon_sym_Set,
    STATE(3888), 1,
      aux_sym__atoms,
    STATE(6121), 1,
      sym__qid,
    STATE(6386), 1,
      sym_atom,
    STATE(8067), 1,
      sym__LAMBDA,
    STATE(8369), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(852), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4210), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6575), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6565), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(4188), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9943), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [364514] = 30,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(964), 1,
      anon_sym_quoteGoal,
    ACTIONS(972), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4214), 1,
      anon_sym_BSLASH,
    ACTIONS(4216), 1,
      anon_sym_u03bb,
    ACTIONS(4218), 1,
      anon_sym_tactic,
    STATE(3891), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8047), 1,
      sym__LAMBDA,
    STATE(8355), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(942), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9932), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [364630] = 30,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(3020), 1,
      anon_sym_BSLASH,
    ACTIONS(3022), 1,
      anon_sym_u03bb,
    ACTIONS(3040), 1,
      anon_sym_quoteGoal,
    ACTIONS(3042), 1,
      anon_sym_tactic,
    ACTIONS(3048), 1,
      anon_sym_let,
    ACTIONS(3234), 1,
      sym_id,
    ACTIONS(3240), 1,
      anon_sym_record,
    ACTIONS(3242), 1,
      anon_sym_LPAREN,
    ACTIONS(3244), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3246), 1,
      anon_sym_u2983,
    ACTIONS(3248), 1,
      anon_sym_LBRACE,
    ACTIONS(3250), 1,
      aux_sym__qid_token1,
    ACTIONS(3252), 1,
      anon_sym_DOT,
    ACTIONS(3254), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3256), 1,
      anon_sym_u2987,
    ACTIONS(3260), 1,
      anon_sym_Set,
    STATE(1620), 1,
      sym__ARROW,
    STATE(4004), 1,
      aux_sym__atoms,
    STATE(5549), 1,
      sym_atom,
    STATE(8127), 1,
      sym__LAMBDA,
    STATE(8388), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3018), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3258), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(5138), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(5387), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5375), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8997), 7,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3238), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [364746] = 31,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(1302), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(10387), 1,
      sym__binding_ids_and_absurds,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9891), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [364864] = 30,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(2898), 1,
      sym_id,
    ACTIONS(2904), 1,
      anon_sym_BSLASH,
    ACTIONS(2906), 1,
      anon_sym_u03bb,
    ACTIONS(2910), 1,
      anon_sym_record,
    ACTIONS(2912), 1,
      anon_sym_LPAREN,
    ACTIONS(2914), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2916), 1,
      anon_sym_u2983,
    ACTIONS(2918), 1,
      anon_sym_LBRACE,
    ACTIONS(2920), 1,
      aux_sym__qid_token1,
    ACTIONS(2922), 1,
      anon_sym_DOT,
    ACTIONS(2924), 1,
      anon_sym_quoteGoal,
    ACTIONS(2926), 1,
      anon_sym_tactic,
    ACTIONS(2928), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2930), 1,
      anon_sym_u2987,
    ACTIONS(2932), 1,
      anon_sym_let,
    ACTIONS(2936), 1,
      anon_sym_Set,
    STATE(1947), 1,
      sym__ARROW,
    STATE(4004), 1,
      aux_sym__atoms,
    STATE(4154), 1,
      sym_atom,
    STATE(8094), 1,
      sym__LAMBDA,
    STATE(8489), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2900), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2934), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(4868), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(4184), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4206), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9001), 7,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2908), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [364980] = 30,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(964), 1,
      anon_sym_quoteGoal,
    ACTIONS(972), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4214), 1,
      anon_sym_BSLASH,
    ACTIONS(4216), 1,
      anon_sym_u03bb,
    ACTIONS(4218), 1,
      anon_sym_tactic,
    STATE(3891), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8047), 1,
      sym__LAMBDA,
    STATE(8355), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(942), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10060), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [365096] = 30,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(878), 1,
      anon_sym_quoteGoal,
    ACTIONS(886), 1,
      anon_sym_let,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(4182), 1,
      sym_id,
    ACTIONS(4184), 1,
      anon_sym_BSLASH,
    ACTIONS(4186), 1,
      anon_sym_u03bb,
    ACTIONS(4190), 1,
      anon_sym_record,
    ACTIONS(4192), 1,
      anon_sym_LPAREN,
    ACTIONS(4194), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4196), 1,
      anon_sym_u2983,
    ACTIONS(4198), 1,
      anon_sym_LBRACE,
    ACTIONS(4200), 1,
      aux_sym__qid_token1,
    ACTIONS(4202), 1,
      anon_sym_DOT,
    ACTIONS(4204), 1,
      anon_sym_tactic,
    ACTIONS(4206), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4208), 1,
      anon_sym_u2987,
    ACTIONS(4212), 1,
      anon_sym_Set,
    STATE(3888), 1,
      aux_sym__atoms,
    STATE(6121), 1,
      sym__qid,
    STATE(6386), 1,
      sym_atom,
    STATE(8067), 1,
      sym__LAMBDA,
    STATE(8369), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(852), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4210), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6575), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6565), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(4188), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10059), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [365212] = 31,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(1302), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(10490), 1,
      sym__binding_ids_and_absurds,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9897), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [365330] = 30,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2022), 1,
      anon_sym_BSLASH,
    ACTIONS(2024), 1,
      anon_sym_u03bb,
    ACTIONS(2042), 1,
      anon_sym_quoteGoal,
    ACTIONS(2044), 1,
      anon_sym_tactic,
    ACTIONS(2050), 1,
      anon_sym_let,
    ACTIONS(5140), 1,
      sym_id,
    ACTIONS(5144), 1,
      anon_sym_record,
    ACTIONS(5146), 1,
      anon_sym_LPAREN,
    ACTIONS(5148), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(5150), 1,
      anon_sym_u2983,
    ACTIONS(5152), 1,
      anon_sym_LBRACE,
    ACTIONS(5154), 1,
      aux_sym__qid_token1,
    ACTIONS(5156), 1,
      anon_sym_DOT,
    ACTIONS(5158), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(5160), 1,
      anon_sym_u2987,
    ACTIONS(5164), 1,
      anon_sym_Set,
    STATE(3748), 1,
      aux_sym__with_exprs_repeat1,
    STATE(3802), 1,
      aux_sym__atoms,
    STATE(5948), 1,
      sym_atom,
    STATE(8033), 1,
      sym__LAMBDA,
    STATE(8463), 1,
      sym__FORALL,
    STATE(8978), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2020), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(5162), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5797), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5795), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(5142), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [365446] = 30,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(964), 1,
      anon_sym_quoteGoal,
    ACTIONS(972), 1,
      anon_sym_let,
    ACTIONS(4214), 1,
      anon_sym_BSLASH,
    ACTIONS(4216), 1,
      anon_sym_u03bb,
    ACTIONS(4218), 1,
      anon_sym_tactic,
    ACTIONS(5166), 1,
      sym_id,
    ACTIONS(5170), 1,
      anon_sym_record,
    ACTIONS(5172), 1,
      anon_sym_LPAREN,
    ACTIONS(5174), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(5176), 1,
      anon_sym_u2983,
    ACTIONS(5178), 1,
      anon_sym_LBRACE,
    ACTIONS(5180), 1,
      aux_sym__qid_token1,
    ACTIONS(5182), 1,
      anon_sym_DOT,
    ACTIONS(5184), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(5186), 1,
      anon_sym_u2987,
    ACTIONS(5190), 1,
      anon_sym_Set,
    STATE(3744), 1,
      aux_sym__with_exprs_repeat1,
    STATE(3834), 1,
      aux_sym__atoms,
    STATE(5916), 1,
      sym_atom,
    STATE(8047), 1,
      sym__LAMBDA,
    STATE(8355), 1,
      sym__FORALL,
    STATE(8978), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(942), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(5188), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5928), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5926), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(5168), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [365562] = 30,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(3020), 1,
      anon_sym_BSLASH,
    ACTIONS(3022), 1,
      anon_sym_u03bb,
    ACTIONS(3040), 1,
      anon_sym_quoteGoal,
    ACTIONS(3042), 1,
      anon_sym_tactic,
    ACTIONS(3048), 1,
      anon_sym_let,
    ACTIONS(3234), 1,
      sym_id,
    ACTIONS(3240), 1,
      anon_sym_record,
    ACTIONS(3242), 1,
      anon_sym_LPAREN,
    ACTIONS(3244), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3246), 1,
      anon_sym_u2983,
    ACTIONS(3248), 1,
      anon_sym_LBRACE,
    ACTIONS(3250), 1,
      aux_sym__qid_token1,
    ACTIONS(3252), 1,
      anon_sym_DOT,
    ACTIONS(3254), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3256), 1,
      anon_sym_u2987,
    ACTIONS(3260), 1,
      anon_sym_Set,
    STATE(1623), 1,
      sym__ARROW,
    STATE(4004), 1,
      aux_sym__atoms,
    STATE(5549), 1,
      sym_atom,
    STATE(8127), 1,
      sym__LAMBDA,
    STATE(8388), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3018), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3258), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(4810), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(5387), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5375), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8997), 7,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3238), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [365678] = 31,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(1302), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(10868), 1,
      sym__binding_ids_and_absurds,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9721), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [365796] = 30,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(964), 1,
      anon_sym_quoteGoal,
    ACTIONS(972), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4214), 1,
      anon_sym_BSLASH,
    ACTIONS(4216), 1,
      anon_sym_u03bb,
    ACTIONS(4218), 1,
      anon_sym_tactic,
    STATE(3891), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8047), 1,
      sym__LAMBDA,
    STATE(8355), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(942), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9764), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [365912] = 30,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(964), 1,
      anon_sym_quoteGoal,
    ACTIONS(972), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4214), 1,
      anon_sym_BSLASH,
    ACTIONS(4216), 1,
      anon_sym_u03bb,
    ACTIONS(4218), 1,
      anon_sym_tactic,
    STATE(3891), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8047), 1,
      sym__LAMBDA,
    STATE(8355), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(942), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10216), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [366028] = 30,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(878), 1,
      anon_sym_quoteGoal,
    ACTIONS(886), 1,
      anon_sym_let,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(4182), 1,
      sym_id,
    ACTIONS(4184), 1,
      anon_sym_BSLASH,
    ACTIONS(4186), 1,
      anon_sym_u03bb,
    ACTIONS(4190), 1,
      anon_sym_record,
    ACTIONS(4192), 1,
      anon_sym_LPAREN,
    ACTIONS(4194), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4196), 1,
      anon_sym_u2983,
    ACTIONS(4198), 1,
      anon_sym_LBRACE,
    ACTIONS(4200), 1,
      aux_sym__qid_token1,
    ACTIONS(4202), 1,
      anon_sym_DOT,
    ACTIONS(4204), 1,
      anon_sym_tactic,
    ACTIONS(4206), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4208), 1,
      anon_sym_u2987,
    ACTIONS(4212), 1,
      anon_sym_Set,
    STATE(3888), 1,
      aux_sym__atoms,
    STATE(6121), 1,
      sym__qid,
    STATE(6386), 1,
      sym_atom,
    STATE(8067), 1,
      sym__LAMBDA,
    STATE(8369), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(852), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4210), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6575), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6565), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(4188), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10215), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [366144] = 30,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(878), 1,
      anon_sym_quoteGoal,
    ACTIONS(886), 1,
      anon_sym_let,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(4182), 1,
      sym_id,
    ACTIONS(4184), 1,
      anon_sym_BSLASH,
    ACTIONS(4186), 1,
      anon_sym_u03bb,
    ACTIONS(4190), 1,
      anon_sym_record,
    ACTIONS(4192), 1,
      anon_sym_LPAREN,
    ACTIONS(4194), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4196), 1,
      anon_sym_u2983,
    ACTIONS(4198), 1,
      anon_sym_LBRACE,
    ACTIONS(4200), 1,
      aux_sym__qid_token1,
    ACTIONS(4202), 1,
      anon_sym_DOT,
    ACTIONS(4204), 1,
      anon_sym_tactic,
    ACTIONS(4206), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4208), 1,
      anon_sym_u2987,
    ACTIONS(4212), 1,
      anon_sym_Set,
    STATE(3888), 1,
      aux_sym__atoms,
    STATE(6121), 1,
      sym__qid,
    STATE(6386), 1,
      sym_atom,
    STATE(8067), 1,
      sym__LAMBDA,
    STATE(8369), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(852), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4210), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6575), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6565), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(4188), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9935), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [366260] = 30,
    ACTIONS(710), 1,
      anon_sym_DASH,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(920), 1,
      anon_sym_quoteGoal,
    ACTIONS(928), 1,
      anon_sym_let,
    ACTIONS(3058), 1,
      anon_sym_BSLASH,
    ACTIONS(3060), 1,
      anon_sym_u03bb,
    ACTIONS(3064), 1,
      anon_sym_record,
    ACTIONS(3066), 1,
      anon_sym_LPAREN,
    ACTIONS(3068), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3070), 1,
      anon_sym_u2983,
    ACTIONS(3072), 1,
      anon_sym_LBRACE,
    ACTIONS(3076), 1,
      aux_sym__qid_token1,
    ACTIONS(3078), 1,
      anon_sym_DOT,
    ACTIONS(3080), 1,
      anon_sym_tactic,
    ACTIONS(3082), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3084), 1,
      anon_sym_u2987,
    ACTIONS(3088), 1,
      anon_sym_Set,
    ACTIONS(4220), 1,
      sym_id,
    STATE(3892), 1,
      aux_sym__atoms,
    STATE(6084), 1,
      sym__qid,
    STATE(6427), 1,
      sym_atom,
    STATE(8123), 1,
      sym__LAMBDA,
    STATE(8396), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3086), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6715), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6714), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3062), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9909), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [366376] = 30,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(878), 1,
      anon_sym_quoteGoal,
    ACTIONS(886), 1,
      anon_sym_let,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(4182), 1,
      sym_id,
    ACTIONS(4184), 1,
      anon_sym_BSLASH,
    ACTIONS(4186), 1,
      anon_sym_u03bb,
    ACTIONS(4190), 1,
      anon_sym_record,
    ACTIONS(4192), 1,
      anon_sym_LPAREN,
    ACTIONS(4194), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4196), 1,
      anon_sym_u2983,
    ACTIONS(4198), 1,
      anon_sym_LBRACE,
    ACTIONS(4200), 1,
      aux_sym__qid_token1,
    ACTIONS(4202), 1,
      anon_sym_DOT,
    ACTIONS(4204), 1,
      anon_sym_tactic,
    ACTIONS(4206), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4208), 1,
      anon_sym_u2987,
    ACTIONS(4212), 1,
      anon_sym_Set,
    STATE(3888), 1,
      aux_sym__atoms,
    STATE(6121), 1,
      sym__qid,
    STATE(6386), 1,
      sym_atom,
    STATE(8067), 1,
      sym__LAMBDA,
    STATE(8369), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(852), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4210), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6575), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6565), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(4188), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9766), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [366492] = 30,
    ACTIONS(710), 1,
      anon_sym_DASH,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(920), 1,
      anon_sym_quoteGoal,
    ACTIONS(928), 1,
      anon_sym_let,
    ACTIONS(3058), 1,
      anon_sym_BSLASH,
    ACTIONS(3060), 1,
      anon_sym_u03bb,
    ACTIONS(3064), 1,
      anon_sym_record,
    ACTIONS(3066), 1,
      anon_sym_LPAREN,
    ACTIONS(3068), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3070), 1,
      anon_sym_u2983,
    ACTIONS(3072), 1,
      anon_sym_LBRACE,
    ACTIONS(3076), 1,
      aux_sym__qid_token1,
    ACTIONS(3078), 1,
      anon_sym_DOT,
    ACTIONS(3080), 1,
      anon_sym_tactic,
    ACTIONS(3082), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3084), 1,
      anon_sym_u2987,
    ACTIONS(3088), 1,
      anon_sym_Set,
    ACTIONS(4220), 1,
      sym_id,
    STATE(3892), 1,
      aux_sym__atoms,
    STATE(6084), 1,
      sym__qid,
    STATE(6427), 1,
      sym_atom,
    STATE(8123), 1,
      sym__LAMBDA,
    STATE(8396), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3086), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6715), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6714), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3062), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9767), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [366608] = 30,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(878), 1,
      anon_sym_quoteGoal,
    ACTIONS(886), 1,
      anon_sym_let,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(4182), 1,
      sym_id,
    ACTIONS(4184), 1,
      anon_sym_BSLASH,
    ACTIONS(4186), 1,
      anon_sym_u03bb,
    ACTIONS(4190), 1,
      anon_sym_record,
    ACTIONS(4192), 1,
      anon_sym_LPAREN,
    ACTIONS(4194), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4196), 1,
      anon_sym_u2983,
    ACTIONS(4198), 1,
      anon_sym_LBRACE,
    ACTIONS(4200), 1,
      aux_sym__qid_token1,
    ACTIONS(4202), 1,
      anon_sym_DOT,
    ACTIONS(4204), 1,
      anon_sym_tactic,
    ACTIONS(4206), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4208), 1,
      anon_sym_u2987,
    ACTIONS(4212), 1,
      anon_sym_Set,
    STATE(3888), 1,
      aux_sym__atoms,
    STATE(6121), 1,
      sym__qid,
    STATE(6386), 1,
      sym_atom,
    STATE(8067), 1,
      sym__LAMBDA,
    STATE(8369), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(852), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4210), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6575), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6565), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(4188), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9803), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [366724] = 30,
    ACTIONS(710), 1,
      anon_sym_DASH,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(920), 1,
      anon_sym_quoteGoal,
    ACTIONS(928), 1,
      anon_sym_let,
    ACTIONS(3058), 1,
      anon_sym_BSLASH,
    ACTIONS(3060), 1,
      anon_sym_u03bb,
    ACTIONS(3064), 1,
      anon_sym_record,
    ACTIONS(3066), 1,
      anon_sym_LPAREN,
    ACTIONS(3068), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3070), 1,
      anon_sym_u2983,
    ACTIONS(3072), 1,
      anon_sym_LBRACE,
    ACTIONS(3076), 1,
      aux_sym__qid_token1,
    ACTIONS(3078), 1,
      anon_sym_DOT,
    ACTIONS(3080), 1,
      anon_sym_tactic,
    ACTIONS(3082), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3084), 1,
      anon_sym_u2987,
    ACTIONS(3088), 1,
      anon_sym_Set,
    ACTIONS(4220), 1,
      sym_id,
    STATE(3892), 1,
      aux_sym__atoms,
    STATE(6084), 1,
      sym__qid,
    STATE(6427), 1,
      sym_atom,
    STATE(8123), 1,
      sym__LAMBDA,
    STATE(8396), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3086), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6715), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6714), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3062), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10114), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [366840] = 30,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(2964), 1,
      anon_sym_quoteGoal,
    ACTIONS(2972), 1,
      anon_sym_let,
    ACTIONS(3520), 1,
      sym_id,
    ACTIONS(3522), 1,
      anon_sym_BSLASH,
    ACTIONS(3524), 1,
      anon_sym_u03bb,
    ACTIONS(3528), 1,
      anon_sym_record,
    ACTIONS(3530), 1,
      anon_sym_LPAREN,
    ACTIONS(3532), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3534), 1,
      anon_sym_u2983,
    ACTIONS(3536), 1,
      anon_sym_LBRACE,
    ACTIONS(3538), 1,
      aux_sym__qid_token1,
    ACTIONS(3540), 1,
      anon_sym_DOT,
    ACTIONS(3542), 1,
      anon_sym_tactic,
    ACTIONS(3544), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3546), 1,
      anon_sym_u2987,
    ACTIONS(3550), 1,
      anon_sym_Set,
    STATE(2434), 1,
      sym__ARROW,
    STATE(4004), 1,
      aux_sym__atoms,
    STATE(5625), 1,
      sym_atom,
    STATE(8058), 1,
      sym__LAMBDA,
    STATE(8418), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2940), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3548), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(4534), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(5537), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5538), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9001), 7,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3526), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [366956] = 30,
    ACTIONS(710), 1,
      anon_sym_DASH,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(920), 1,
      anon_sym_quoteGoal,
    ACTIONS(928), 1,
      anon_sym_let,
    ACTIONS(3058), 1,
      anon_sym_BSLASH,
    ACTIONS(3060), 1,
      anon_sym_u03bb,
    ACTIONS(3064), 1,
      anon_sym_record,
    ACTIONS(3066), 1,
      anon_sym_LPAREN,
    ACTIONS(3068), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3070), 1,
      anon_sym_u2983,
    ACTIONS(3072), 1,
      anon_sym_LBRACE,
    ACTIONS(3076), 1,
      aux_sym__qid_token1,
    ACTIONS(3078), 1,
      anon_sym_DOT,
    ACTIONS(3080), 1,
      anon_sym_tactic,
    ACTIONS(3082), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3084), 1,
      anon_sym_u2987,
    ACTIONS(3088), 1,
      anon_sym_Set,
    ACTIONS(4220), 1,
      sym_id,
    STATE(3892), 1,
      aux_sym__atoms,
    STATE(6084), 1,
      sym__qid,
    STATE(6427), 1,
      sym_atom,
    STATE(8123), 1,
      sym__LAMBDA,
    STATE(8396), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3086), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6715), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6714), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3062), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10227), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [367072] = 30,
    ACTIONS(710), 1,
      anon_sym_DASH,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(920), 1,
      anon_sym_quoteGoal,
    ACTIONS(928), 1,
      anon_sym_let,
    ACTIONS(3058), 1,
      anon_sym_BSLASH,
    ACTIONS(3060), 1,
      anon_sym_u03bb,
    ACTIONS(3064), 1,
      anon_sym_record,
    ACTIONS(3066), 1,
      anon_sym_LPAREN,
    ACTIONS(3068), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3070), 1,
      anon_sym_u2983,
    ACTIONS(3072), 1,
      anon_sym_LBRACE,
    ACTIONS(3076), 1,
      aux_sym__qid_token1,
    ACTIONS(3078), 1,
      anon_sym_DOT,
    ACTIONS(3080), 1,
      anon_sym_tactic,
    ACTIONS(3082), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3084), 1,
      anon_sym_u2987,
    ACTIONS(3088), 1,
      anon_sym_Set,
    ACTIONS(4220), 1,
      sym_id,
    STATE(3892), 1,
      aux_sym__atoms,
    STATE(6084), 1,
      sym__qid,
    STATE(6427), 1,
      sym_atom,
    STATE(8123), 1,
      sym__LAMBDA,
    STATE(8396), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3086), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6715), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6714), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3062), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10204), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [367188] = 30,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(878), 1,
      anon_sym_quoteGoal,
    ACTIONS(886), 1,
      anon_sym_let,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(4182), 1,
      sym_id,
    ACTIONS(4184), 1,
      anon_sym_BSLASH,
    ACTIONS(4186), 1,
      anon_sym_u03bb,
    ACTIONS(4190), 1,
      anon_sym_record,
    ACTIONS(4192), 1,
      anon_sym_LPAREN,
    ACTIONS(4194), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4196), 1,
      anon_sym_u2983,
    ACTIONS(4198), 1,
      anon_sym_LBRACE,
    ACTIONS(4200), 1,
      aux_sym__qid_token1,
    ACTIONS(4202), 1,
      anon_sym_DOT,
    ACTIONS(4204), 1,
      anon_sym_tactic,
    ACTIONS(4206), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4208), 1,
      anon_sym_u2987,
    ACTIONS(4212), 1,
      anon_sym_Set,
    STATE(3888), 1,
      aux_sym__atoms,
    STATE(6121), 1,
      sym__qid,
    STATE(6386), 1,
      sym_atom,
    STATE(8067), 1,
      sym__LAMBDA,
    STATE(8369), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(852), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4210), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6575), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6565), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(4188), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10150), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [367304] = 30,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(964), 1,
      anon_sym_quoteGoal,
    ACTIONS(972), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4214), 1,
      anon_sym_BSLASH,
    ACTIONS(4216), 1,
      anon_sym_u03bb,
    ACTIONS(4218), 1,
      anon_sym_tactic,
    STATE(3891), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8047), 1,
      sym__LAMBDA,
    STATE(8355), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(942), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10003), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [367420] = 30,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(878), 1,
      anon_sym_quoteGoal,
    ACTIONS(886), 1,
      anon_sym_let,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(4182), 1,
      sym_id,
    ACTIONS(4184), 1,
      anon_sym_BSLASH,
    ACTIONS(4186), 1,
      anon_sym_u03bb,
    ACTIONS(4190), 1,
      anon_sym_record,
    ACTIONS(4192), 1,
      anon_sym_LPAREN,
    ACTIONS(4194), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4196), 1,
      anon_sym_u2983,
    ACTIONS(4198), 1,
      anon_sym_LBRACE,
    ACTIONS(4200), 1,
      aux_sym__qid_token1,
    ACTIONS(4202), 1,
      anon_sym_DOT,
    ACTIONS(4204), 1,
      anon_sym_tactic,
    ACTIONS(4206), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4208), 1,
      anon_sym_u2987,
    ACTIONS(4212), 1,
      anon_sym_Set,
    STATE(3888), 1,
      aux_sym__atoms,
    STATE(6121), 1,
      sym__qid,
    STATE(6386), 1,
      sym_atom,
    STATE(8067), 1,
      sym__LAMBDA,
    STATE(8369), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(852), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4210), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6575), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6565), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(4188), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9700), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [367536] = 31,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(1302), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(12310), 1,
      sym__binding_ids_and_absurds,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(10112), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [367654] = 30,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(878), 1,
      anon_sym_quoteGoal,
    ACTIONS(886), 1,
      anon_sym_let,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(4182), 1,
      sym_id,
    ACTIONS(4184), 1,
      anon_sym_BSLASH,
    ACTIONS(4186), 1,
      anon_sym_u03bb,
    ACTIONS(4190), 1,
      anon_sym_record,
    ACTIONS(4192), 1,
      anon_sym_LPAREN,
    ACTIONS(4194), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4196), 1,
      anon_sym_u2983,
    ACTIONS(4198), 1,
      anon_sym_LBRACE,
    ACTIONS(4200), 1,
      aux_sym__qid_token1,
    ACTIONS(4202), 1,
      anon_sym_DOT,
    ACTIONS(4204), 1,
      anon_sym_tactic,
    ACTIONS(4206), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4208), 1,
      anon_sym_u2987,
    ACTIONS(4212), 1,
      anon_sym_Set,
    STATE(3888), 1,
      aux_sym__atoms,
    STATE(6121), 1,
      sym__qid,
    STATE(6386), 1,
      sym_atom,
    STATE(8067), 1,
      sym__LAMBDA,
    STATE(8369), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(852), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4210), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6575), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6565), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(4188), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9808), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [367770] = 31,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(1302), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(11048), 1,
      sym__binding_ids_and_absurds,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9801), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [367888] = 30,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(964), 1,
      anon_sym_quoteGoal,
    ACTIONS(972), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4214), 1,
      anon_sym_BSLASH,
    ACTIONS(4216), 1,
      anon_sym_u03bb,
    ACTIONS(4218), 1,
      anon_sym_tactic,
    STATE(3891), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8047), 1,
      sym__LAMBDA,
    STATE(8355), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(942), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9735), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [368004] = 30,
    ACTIONS(710), 1,
      anon_sym_DASH,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(920), 1,
      anon_sym_quoteGoal,
    ACTIONS(928), 1,
      anon_sym_let,
    ACTIONS(3058), 1,
      anon_sym_BSLASH,
    ACTIONS(3060), 1,
      anon_sym_u03bb,
    ACTIONS(3064), 1,
      anon_sym_record,
    ACTIONS(3066), 1,
      anon_sym_LPAREN,
    ACTIONS(3068), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3070), 1,
      anon_sym_u2983,
    ACTIONS(3072), 1,
      anon_sym_LBRACE,
    ACTIONS(3076), 1,
      aux_sym__qid_token1,
    ACTIONS(3078), 1,
      anon_sym_DOT,
    ACTIONS(3080), 1,
      anon_sym_tactic,
    ACTIONS(3082), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3084), 1,
      anon_sym_u2987,
    ACTIONS(3088), 1,
      anon_sym_Set,
    ACTIONS(4220), 1,
      sym_id,
    STATE(3892), 1,
      aux_sym__atoms,
    STATE(6084), 1,
      sym__qid,
    STATE(6427), 1,
      sym_atom,
    STATE(8123), 1,
      sym__LAMBDA,
    STATE(8396), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3086), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6715), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6714), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3062), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9939), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [368120] = 30,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(878), 1,
      anon_sym_quoteGoal,
    ACTIONS(886), 1,
      anon_sym_let,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(4182), 1,
      sym_id,
    ACTIONS(4184), 1,
      anon_sym_BSLASH,
    ACTIONS(4186), 1,
      anon_sym_u03bb,
    ACTIONS(4190), 1,
      anon_sym_record,
    ACTIONS(4192), 1,
      anon_sym_LPAREN,
    ACTIONS(4194), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4196), 1,
      anon_sym_u2983,
    ACTIONS(4198), 1,
      anon_sym_LBRACE,
    ACTIONS(4200), 1,
      aux_sym__qid_token1,
    ACTIONS(4202), 1,
      anon_sym_DOT,
    ACTIONS(4204), 1,
      anon_sym_tactic,
    ACTIONS(4206), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4208), 1,
      anon_sym_u2987,
    ACTIONS(4212), 1,
      anon_sym_Set,
    STATE(3888), 1,
      aux_sym__atoms,
    STATE(6121), 1,
      sym__qid,
    STATE(6386), 1,
      sym_atom,
    STATE(8067), 1,
      sym__LAMBDA,
    STATE(8369), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(852), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4210), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6575), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6565), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(4188), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9910), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [368236] = 30,
    ACTIONS(692), 1,
      anon_sym_record,
    ACTIONS(694), 1,
      anon_sym_LPAREN,
    ACTIONS(696), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(698), 1,
      anon_sym_u2983,
    ACTIONS(702), 1,
      anon_sym_LBRACE,
    ACTIONS(708), 1,
      anon_sym_DOT,
    ACTIONS(718), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(720), 1,
      anon_sym_u2987,
    ACTIONS(728), 1,
      anon_sym_Set,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1928), 1,
      anon_sym_quoteGoal,
    ACTIONS(1936), 1,
      anon_sym_let,
    ACTIONS(2336), 1,
      sym_id,
    ACTIONS(2338), 1,
      anon_sym_BSLASH,
    ACTIONS(2340), 1,
      anon_sym_u03bb,
    ACTIONS(2342), 1,
      aux_sym__qid_token1,
    ACTIONS(2344), 1,
      anon_sym_tactic,
    STATE(1765), 1,
      sym__ARROW,
    STATE(4004), 1,
      aux_sym__atoms,
    STATE(5128), 1,
      sym_atom,
    STATE(8079), 1,
      sym__LAMBDA,
    STATE(8431), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(726), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1906), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4476), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(5069), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5056), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8997), 7,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(690), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [368352] = 30,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(964), 1,
      anon_sym_quoteGoal,
    ACTIONS(972), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4214), 1,
      anon_sym_BSLASH,
    ACTIONS(4216), 1,
      anon_sym_u03bb,
    ACTIONS(4218), 1,
      anon_sym_tactic,
    STATE(3891), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8047), 1,
      sym__LAMBDA,
    STATE(8355), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(942), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9807), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [368468] = 30,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(878), 1,
      anon_sym_quoteGoal,
    ACTIONS(886), 1,
      anon_sym_let,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(4182), 1,
      sym_id,
    ACTIONS(4184), 1,
      anon_sym_BSLASH,
    ACTIONS(4186), 1,
      anon_sym_u03bb,
    ACTIONS(4190), 1,
      anon_sym_record,
    ACTIONS(4192), 1,
      anon_sym_LPAREN,
    ACTIONS(4194), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4196), 1,
      anon_sym_u2983,
    ACTIONS(4198), 1,
      anon_sym_LBRACE,
    ACTIONS(4200), 1,
      aux_sym__qid_token1,
    ACTIONS(4202), 1,
      anon_sym_DOT,
    ACTIONS(4204), 1,
      anon_sym_tactic,
    ACTIONS(4206), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4208), 1,
      anon_sym_u2987,
    ACTIONS(4212), 1,
      anon_sym_Set,
    STATE(3888), 1,
      aux_sym__atoms,
    STATE(6121), 1,
      sym__qid,
    STATE(6386), 1,
      sym_atom,
    STATE(8067), 1,
      sym__LAMBDA,
    STATE(8369), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(852), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4210), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6575), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6565), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(4188), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9732), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [368584] = 30,
    ACTIONS(710), 1,
      anon_sym_DASH,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(920), 1,
      anon_sym_quoteGoal,
    ACTIONS(928), 1,
      anon_sym_let,
    ACTIONS(3058), 1,
      anon_sym_BSLASH,
    ACTIONS(3060), 1,
      anon_sym_u03bb,
    ACTIONS(3064), 1,
      anon_sym_record,
    ACTIONS(3066), 1,
      anon_sym_LPAREN,
    ACTIONS(3068), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3070), 1,
      anon_sym_u2983,
    ACTIONS(3072), 1,
      anon_sym_LBRACE,
    ACTIONS(3076), 1,
      aux_sym__qid_token1,
    ACTIONS(3078), 1,
      anon_sym_DOT,
    ACTIONS(3080), 1,
      anon_sym_tactic,
    ACTIONS(3082), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3084), 1,
      anon_sym_u2987,
    ACTIONS(3088), 1,
      anon_sym_Set,
    ACTIONS(4220), 1,
      sym_id,
    STATE(3892), 1,
      aux_sym__atoms,
    STATE(6084), 1,
      sym__qid,
    STATE(6427), 1,
      sym_atom,
    STATE(8123), 1,
      sym__LAMBDA,
    STATE(8396), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3086), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6715), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6714), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3062), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9731), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [368700] = 30,
    ACTIONS(710), 1,
      anon_sym_DASH,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(920), 1,
      anon_sym_quoteGoal,
    ACTIONS(928), 1,
      anon_sym_let,
    ACTIONS(3058), 1,
      anon_sym_BSLASH,
    ACTIONS(3060), 1,
      anon_sym_u03bb,
    ACTIONS(3064), 1,
      anon_sym_record,
    ACTIONS(3066), 1,
      anon_sym_LPAREN,
    ACTIONS(3068), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3070), 1,
      anon_sym_u2983,
    ACTIONS(3072), 1,
      anon_sym_LBRACE,
    ACTIONS(3076), 1,
      aux_sym__qid_token1,
    ACTIONS(3078), 1,
      anon_sym_DOT,
    ACTIONS(3080), 1,
      anon_sym_tactic,
    ACTIONS(3082), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3084), 1,
      anon_sym_u2987,
    ACTIONS(3088), 1,
      anon_sym_Set,
    ACTIONS(4220), 1,
      sym_id,
    STATE(3892), 1,
      aux_sym__atoms,
    STATE(6084), 1,
      sym__qid,
    STATE(6427), 1,
      sym_atom,
    STATE(8123), 1,
      sym__LAMBDA,
    STATE(8396), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3086), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6715), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6714), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3062), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9945), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [368816] = 30,
    ACTIONS(710), 1,
      anon_sym_DASH,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(920), 1,
      anon_sym_quoteGoal,
    ACTIONS(928), 1,
      anon_sym_let,
    ACTIONS(3058), 1,
      anon_sym_BSLASH,
    ACTIONS(3060), 1,
      anon_sym_u03bb,
    ACTIONS(3064), 1,
      anon_sym_record,
    ACTIONS(3066), 1,
      anon_sym_LPAREN,
    ACTIONS(3068), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3070), 1,
      anon_sym_u2983,
    ACTIONS(3072), 1,
      anon_sym_LBRACE,
    ACTIONS(3076), 1,
      aux_sym__qid_token1,
    ACTIONS(3078), 1,
      anon_sym_DOT,
    ACTIONS(3080), 1,
      anon_sym_tactic,
    ACTIONS(3082), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3084), 1,
      anon_sym_u2987,
    ACTIONS(3088), 1,
      anon_sym_Set,
    ACTIONS(4220), 1,
      sym_id,
    STATE(3892), 1,
      aux_sym__atoms,
    STATE(6084), 1,
      sym__qid,
    STATE(6427), 1,
      sym_atom,
    STATE(8123), 1,
      sym__LAMBDA,
    STATE(8396), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3086), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6715), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6714), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3062), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10058), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [368932] = 30,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(964), 1,
      anon_sym_quoteGoal,
    ACTIONS(972), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4214), 1,
      anon_sym_BSLASH,
    ACTIONS(4216), 1,
      anon_sym_u03bb,
    ACTIONS(4218), 1,
      anon_sym_tactic,
    STATE(3891), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8047), 1,
      sym__LAMBDA,
    STATE(8355), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(942), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9911), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [369048] = 31,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(1302), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(10792), 1,
      sym__binding_ids_and_absurds,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9714), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [369166] = 30,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(878), 1,
      anon_sym_quoteGoal,
    ACTIONS(886), 1,
      anon_sym_let,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(4182), 1,
      sym_id,
    ACTIONS(4184), 1,
      anon_sym_BSLASH,
    ACTIONS(4186), 1,
      anon_sym_u03bb,
    ACTIONS(4190), 1,
      anon_sym_record,
    ACTIONS(4192), 1,
      anon_sym_LPAREN,
    ACTIONS(4194), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4196), 1,
      anon_sym_u2983,
    ACTIONS(4198), 1,
      anon_sym_LBRACE,
    ACTIONS(4200), 1,
      aux_sym__qid_token1,
    ACTIONS(4202), 1,
      anon_sym_DOT,
    ACTIONS(4204), 1,
      anon_sym_tactic,
    ACTIONS(4206), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4208), 1,
      anon_sym_u2987,
    ACTIONS(4212), 1,
      anon_sym_Set,
    STATE(3888), 1,
      aux_sym__atoms,
    STATE(6121), 1,
      sym__qid,
    STATE(6386), 1,
      sym_atom,
    STATE(8067), 1,
      sym__LAMBDA,
    STATE(8369), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(852), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4210), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6575), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6565), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(4188), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9780), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [369282] = 30,
    ACTIONS(854), 1,
      anon_sym_BSLASH,
    ACTIONS(856), 1,
      anon_sym_u03bb,
    ACTIONS(878), 1,
      anon_sym_quoteGoal,
    ACTIONS(880), 1,
      anon_sym_tactic,
    ACTIONS(886), 1,
      anon_sym_let,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(5192), 1,
      sym_id,
    ACTIONS(5196), 1,
      anon_sym_record,
    ACTIONS(5198), 1,
      anon_sym_LPAREN,
    ACTIONS(5200), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(5202), 1,
      anon_sym_u2983,
    ACTIONS(5204), 1,
      anon_sym_LBRACE,
    ACTIONS(5206), 1,
      aux_sym__qid_token1,
    ACTIONS(5208), 1,
      anon_sym_DOT,
    ACTIONS(5210), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(5212), 1,
      anon_sym_u2987,
    ACTIONS(5216), 1,
      anon_sym_Set,
    STATE(3763), 1,
      aux_sym__with_exprs_repeat1,
    STATE(3780), 1,
      aux_sym__atoms,
    STATE(5956), 1,
      sym_atom,
    STATE(8152), 1,
      sym__LAMBDA,
    STATE(8369), 1,
      sym__FORALL,
    STATE(8978), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(852), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(5214), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5737), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5736), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(5194), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [369398] = 31,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(1302), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(10634), 1,
      sym__binding_ids_and_absurds,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [369516] = 30,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(3134), 1,
      anon_sym_BSLASH,
    ACTIONS(3136), 1,
      anon_sym_u03bb,
    ACTIONS(3154), 1,
      anon_sym_quoteGoal,
    ACTIONS(3156), 1,
      anon_sym_tactic,
    ACTIONS(3162), 1,
      anon_sym_let,
    ACTIONS(3326), 1,
      sym_id,
    ACTIONS(3332), 1,
      anon_sym_record,
    ACTIONS(3334), 1,
      anon_sym_LPAREN,
    ACTIONS(3336), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3338), 1,
      anon_sym_u2983,
    ACTIONS(3340), 1,
      anon_sym_LBRACE,
    ACTIONS(3342), 1,
      aux_sym__qid_token1,
    ACTIONS(3344), 1,
      anon_sym_DOT,
    ACTIONS(3346), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3348), 1,
      anon_sym_u2987,
    ACTIONS(3352), 1,
      anon_sym_Set,
    STATE(1681), 1,
      sym__ARROW,
    STATE(4004), 1,
      aux_sym__atoms,
    STATE(4908), 1,
      sym_atom,
    STATE(8076), 1,
      sym__LAMBDA,
    STATE(8363), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3132), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3350), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(4638), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(4650), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4649), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9001), 7,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3330), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [369632] = 30,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(1302), 1,
      anon_sym_let,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(5218), 1,
      sym_id,
    ACTIONS(5224), 1,
      anon_sym_record,
    ACTIONS(5226), 1,
      anon_sym_LPAREN,
    ACTIONS(5228), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(5230), 1,
      anon_sym_u2983,
    ACTIONS(5232), 1,
      anon_sym_LBRACE,
    ACTIONS(5234), 1,
      aux_sym__qid_token1,
    ACTIONS(5236), 1,
      anon_sym_DOT,
    ACTIONS(5238), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(5240), 1,
      anon_sym_u2987,
    ACTIONS(5244), 1,
      anon_sym_Set,
    STATE(2154), 1,
      sym__ARROW,
    STATE(4004), 1,
      aux_sym__atoms,
    STATE(6203), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(5220), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(5242), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6166), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6188), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8997), 7,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(5222), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [369748] = 30,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(2732), 1,
      anon_sym_BSLASH,
    ACTIONS(2734), 1,
      anon_sym_u03bb,
    ACTIONS(2752), 1,
      anon_sym_quoteGoal,
    ACTIONS(2754), 1,
      anon_sym_tactic,
    ACTIONS(2760), 1,
      anon_sym_let,
    ACTIONS(3610), 1,
      sym_id,
    ACTIONS(3616), 1,
      anon_sym_record,
    ACTIONS(3618), 1,
      anon_sym_LPAREN,
    ACTIONS(3620), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3622), 1,
      anon_sym_u2983,
    ACTIONS(3624), 1,
      anon_sym_LBRACE,
    ACTIONS(3626), 1,
      aux_sym__qid_token1,
    ACTIONS(3628), 1,
      anon_sym_DOT,
    ACTIONS(3630), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3632), 1,
      anon_sym_u2987,
    ACTIONS(3636), 1,
      anon_sym_Set,
    STATE(1557), 1,
      sym__ARROW,
    STATE(4004), 1,
      aux_sym__atoms,
    STATE(5352), 1,
      sym_atom,
    STATE(8061), 1,
      sym__LAMBDA,
    STATE(8384), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2730), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3634), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(4500), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(5254), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5242), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9001), 7,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3614), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [369864] = 30,
    ACTIONS(714), 1,
      anon_sym_quoteGoal,
    ACTIONS(722), 1,
      anon_sym_let,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(3556), 1,
      anon_sym_BSLASH,
    ACTIONS(3558), 1,
      anon_sym_u03bb,
    ACTIONS(3574), 1,
      anon_sym_tactic,
    ACTIONS(5246), 1,
      sym_id,
    ACTIONS(5250), 1,
      anon_sym_record,
    ACTIONS(5252), 1,
      anon_sym_LPAREN,
    ACTIONS(5254), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(5256), 1,
      anon_sym_u2983,
    ACTIONS(5258), 1,
      anon_sym_LBRACE,
    ACTIONS(5260), 1,
      aux_sym__qid_token1,
    ACTIONS(5262), 1,
      anon_sym_DOT,
    ACTIONS(5264), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(5266), 1,
      anon_sym_u2987,
    ACTIONS(5270), 1,
      anon_sym_Set,
    STATE(3706), 1,
      aux_sym__with_exprs_repeat1,
    STATE(3769), 1,
      aux_sym__atoms,
    STATE(5510), 1,
      sym_atom,
    STATE(8092), 1,
      sym__LAMBDA,
    STATE(8495), 1,
      sym__FORALL,
    STATE(9466), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(682), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(5268), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5466), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5472), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(5248), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [369980] = 30,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(964), 1,
      anon_sym_quoteGoal,
    ACTIONS(972), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4214), 1,
      anon_sym_BSLASH,
    ACTIONS(4216), 1,
      anon_sym_u03bb,
    ACTIONS(4218), 1,
      anon_sym_tactic,
    STATE(3891), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8047), 1,
      sym__LAMBDA,
    STATE(8355), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(942), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10001), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [370096] = 30,
    ACTIONS(9), 1,
      sym_id,
    ACTIONS(13), 1,
      anon_sym_BSLASH,
    ACTIONS(15), 1,
      anon_sym_u03bb,
    ACTIONS(51), 1,
      anon_sym_LPAREN,
    ACTIONS(53), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(55), 1,
      anon_sym_u2983,
    ACTIONS(61), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      aux_sym__qid_token1,
    ACTIONS(71), 1,
      anon_sym_DOT,
    ACTIONS(75), 1,
      anon_sym_quoteGoal,
    ACTIONS(77), 1,
      anon_sym_tactic,
    ACTIONS(79), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(81), 1,
      anon_sym_u2987,
    ACTIONS(83), 1,
      anon_sym_let,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(89), 1,
      anon_sym_Set,
    ACTIONS(4280), 1,
      anon_sym_record,
    STATE(3710), 1,
      aux_sym__with_exprs_repeat1,
    STATE(3848), 1,
      aux_sym__atoms,
    STATE(4600), 1,
      sym_atom,
    STATE(8114), 1,
      sym__LAMBDA,
    STATE(8288), 1,
      sym__FORALL,
    STATE(8939), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(11), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(87), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4564), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4608), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(17), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [370212] = 30,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(2694), 1,
      anon_sym_BSLASH,
    ACTIONS(2696), 1,
      anon_sym_u03bb,
    ACTIONS(2714), 1,
      anon_sym_quoteGoal,
    ACTIONS(2716), 1,
      anon_sym_tactic,
    ACTIONS(2722), 1,
      anon_sym_let,
    ACTIONS(3878), 1,
      sym_id,
    ACTIONS(3884), 1,
      anon_sym_record,
    ACTIONS(3886), 1,
      anon_sym_LPAREN,
    ACTIONS(3888), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3890), 1,
      anon_sym_u2983,
    ACTIONS(3892), 1,
      anon_sym_LBRACE,
    ACTIONS(3894), 1,
      aux_sym__qid_token1,
    ACTIONS(3896), 1,
      anon_sym_DOT,
    ACTIONS(3898), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3900), 1,
      anon_sym_u2987,
    ACTIONS(3904), 1,
      anon_sym_Set,
    STATE(1621), 1,
      sym__ARROW,
    STATE(4004), 1,
      aux_sym__atoms,
    STATE(4243), 1,
      sym_atom,
    STATE(8133), 1,
      sym__LAMBDA,
    STATE(8368), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2692), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3902), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(5272), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(4214), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4218), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9001), 7,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3882), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [370328] = 31,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(1302), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(10754), 1,
      sym__binding_ids_and_absurds,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9730), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [370446] = 30,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(2676), 1,
      anon_sym_quoteGoal,
    ACTIONS(2684), 1,
      anon_sym_let,
    ACTIONS(2806), 1,
      sym_id,
    ACTIONS(2816), 1,
      anon_sym_record,
    ACTIONS(2818), 1,
      anon_sym_LPAREN,
    ACTIONS(2820), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2822), 1,
      anon_sym_u2983,
    ACTIONS(2824), 1,
      anon_sym_LBRACE,
    ACTIONS(2826), 1,
      aux_sym__qid_token1,
    ACTIONS(2828), 1,
      anon_sym_DOT,
    ACTIONS(2832), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2834), 1,
      anon_sym_u2987,
    ACTIONS(2838), 1,
      anon_sym_Set,
    ACTIONS(3906), 1,
      anon_sym_BSLASH,
    ACTIONS(3908), 1,
      anon_sym_u03bb,
    ACTIONS(3910), 1,
      anon_sym_tactic,
    STATE(2295), 1,
      sym__ARROW,
    STATE(4004), 1,
      aux_sym__atoms,
    STATE(5831), 1,
      sym_atom,
    STATE(8086), 1,
      sym__LAMBDA,
    STATE(8470), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2654), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2836), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(5274), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(5982), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5981), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9454), 7,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2814), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [370562] = 31,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(1302), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(10839), 1,
      sym__binding_ids_and_absurds,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9961), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [370680] = 30,
    ACTIONS(710), 1,
      anon_sym_DASH,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(920), 1,
      anon_sym_quoteGoal,
    ACTIONS(928), 1,
      anon_sym_let,
    ACTIONS(3058), 1,
      anon_sym_BSLASH,
    ACTIONS(3060), 1,
      anon_sym_u03bb,
    ACTIONS(3064), 1,
      anon_sym_record,
    ACTIONS(3066), 1,
      anon_sym_LPAREN,
    ACTIONS(3068), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3070), 1,
      anon_sym_u2983,
    ACTIONS(3072), 1,
      anon_sym_LBRACE,
    ACTIONS(3076), 1,
      aux_sym__qid_token1,
    ACTIONS(3078), 1,
      anon_sym_DOT,
    ACTIONS(3080), 1,
      anon_sym_tactic,
    ACTIONS(3082), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3084), 1,
      anon_sym_u2987,
    ACTIONS(3088), 1,
      anon_sym_Set,
    ACTIONS(4220), 1,
      sym_id,
    STATE(3892), 1,
      aux_sym__atoms,
    STATE(6084), 1,
      sym__qid,
    STATE(6427), 1,
      sym_atom,
    STATE(8123), 1,
      sym__LAMBDA,
    STATE(8396), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3086), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6715), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6714), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3062), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10005), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [370796] = 30,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(878), 1,
      anon_sym_quoteGoal,
    ACTIONS(886), 1,
      anon_sym_let,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(4182), 1,
      sym_id,
    ACTIONS(4184), 1,
      anon_sym_BSLASH,
    ACTIONS(4186), 1,
      anon_sym_u03bb,
    ACTIONS(4190), 1,
      anon_sym_record,
    ACTIONS(4192), 1,
      anon_sym_LPAREN,
    ACTIONS(4194), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4196), 1,
      anon_sym_u2983,
    ACTIONS(4198), 1,
      anon_sym_LBRACE,
    ACTIONS(4200), 1,
      aux_sym__qid_token1,
    ACTIONS(4202), 1,
      anon_sym_DOT,
    ACTIONS(4204), 1,
      anon_sym_tactic,
    ACTIONS(4206), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4208), 1,
      anon_sym_u2987,
    ACTIONS(4212), 1,
      anon_sym_Set,
    STATE(3888), 1,
      aux_sym__atoms,
    STATE(6121), 1,
      sym__qid,
    STATE(6386), 1,
      sym_atom,
    STATE(8067), 1,
      sym__LAMBDA,
    STATE(8369), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(852), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4210), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6575), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6565), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(4188), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10004), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [370912] = 31,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(1302), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(11343), 1,
      sym__binding_ids_and_absurds,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9949), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [371030] = 30,
    ACTIONS(710), 1,
      anon_sym_DASH,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(920), 1,
      anon_sym_quoteGoal,
    ACTIONS(928), 1,
      anon_sym_let,
    ACTIONS(3058), 1,
      anon_sym_BSLASH,
    ACTIONS(3060), 1,
      anon_sym_u03bb,
    ACTIONS(3064), 1,
      anon_sym_record,
    ACTIONS(3066), 1,
      anon_sym_LPAREN,
    ACTIONS(3068), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3070), 1,
      anon_sym_u2983,
    ACTIONS(3072), 1,
      anon_sym_LBRACE,
    ACTIONS(3076), 1,
      aux_sym__qid_token1,
    ACTIONS(3078), 1,
      anon_sym_DOT,
    ACTIONS(3080), 1,
      anon_sym_tactic,
    ACTIONS(3082), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3084), 1,
      anon_sym_u2987,
    ACTIONS(3088), 1,
      anon_sym_Set,
    ACTIONS(4220), 1,
      sym_id,
    STATE(3892), 1,
      aux_sym__atoms,
    STATE(6084), 1,
      sym__qid,
    STATE(6427), 1,
      sym_atom,
    STATE(8123), 1,
      sym__LAMBDA,
    STATE(8396), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3086), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6715), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6714), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3062), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9836), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [371146] = 30,
    ACTIONS(710), 1,
      anon_sym_DASH,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(920), 1,
      anon_sym_quoteGoal,
    ACTIONS(928), 1,
      anon_sym_let,
    ACTIONS(3058), 1,
      anon_sym_BSLASH,
    ACTIONS(3060), 1,
      anon_sym_u03bb,
    ACTIONS(3064), 1,
      anon_sym_record,
    ACTIONS(3066), 1,
      anon_sym_LPAREN,
    ACTIONS(3068), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3070), 1,
      anon_sym_u2983,
    ACTIONS(3072), 1,
      anon_sym_LBRACE,
    ACTIONS(3076), 1,
      aux_sym__qid_token1,
    ACTIONS(3078), 1,
      anon_sym_DOT,
    ACTIONS(3080), 1,
      anon_sym_tactic,
    ACTIONS(3082), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3084), 1,
      anon_sym_u2987,
    ACTIONS(3088), 1,
      anon_sym_Set,
    ACTIONS(4220), 1,
      sym_id,
    STATE(3892), 1,
      aux_sym__atoms,
    STATE(6084), 1,
      sym__qid,
    STATE(6427), 1,
      sym_atom,
    STATE(8123), 1,
      sym__LAMBDA,
    STATE(8396), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3086), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6715), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6714), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3062), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10037), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [371262] = 30,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(878), 1,
      anon_sym_quoteGoal,
    ACTIONS(886), 1,
      anon_sym_let,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(4182), 1,
      sym_id,
    ACTIONS(4184), 1,
      anon_sym_BSLASH,
    ACTIONS(4186), 1,
      anon_sym_u03bb,
    ACTIONS(4190), 1,
      anon_sym_record,
    ACTIONS(4192), 1,
      anon_sym_LPAREN,
    ACTIONS(4194), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4196), 1,
      anon_sym_u2983,
    ACTIONS(4198), 1,
      anon_sym_LBRACE,
    ACTIONS(4200), 1,
      aux_sym__qid_token1,
    ACTIONS(4202), 1,
      anon_sym_DOT,
    ACTIONS(4204), 1,
      anon_sym_tactic,
    ACTIONS(4206), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4208), 1,
      anon_sym_u2987,
    ACTIONS(4212), 1,
      anon_sym_Set,
    STATE(3888), 1,
      aux_sym__atoms,
    STATE(6121), 1,
      sym__qid,
    STATE(6386), 1,
      sym_atom,
    STATE(8067), 1,
      sym__LAMBDA,
    STATE(8369), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(852), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4210), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6575), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6565), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(4188), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10039), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [371378] = 30,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(964), 1,
      anon_sym_quoteGoal,
    ACTIONS(972), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4214), 1,
      anon_sym_BSLASH,
    ACTIONS(4216), 1,
      anon_sym_u03bb,
    ACTIONS(4218), 1,
      anon_sym_tactic,
    STATE(3891), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8047), 1,
      sym__LAMBDA,
    STATE(8355), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(942), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10040), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [371494] = 31,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(1302), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(11489), 1,
      sym__binding_ids_and_absurds,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(10031), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [371612] = 30,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(878), 1,
      anon_sym_quoteGoal,
    ACTIONS(886), 1,
      anon_sym_let,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(4182), 1,
      sym_id,
    ACTIONS(4184), 1,
      anon_sym_BSLASH,
    ACTIONS(4186), 1,
      anon_sym_u03bb,
    ACTIONS(4190), 1,
      anon_sym_record,
    ACTIONS(4192), 1,
      anon_sym_LPAREN,
    ACTIONS(4194), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4196), 1,
      anon_sym_u2983,
    ACTIONS(4198), 1,
      anon_sym_LBRACE,
    ACTIONS(4200), 1,
      aux_sym__qid_token1,
    ACTIONS(4202), 1,
      anon_sym_DOT,
    ACTIONS(4204), 1,
      anon_sym_tactic,
    ACTIONS(4206), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4208), 1,
      anon_sym_u2987,
    ACTIONS(4212), 1,
      anon_sym_Set,
    STATE(3888), 1,
      aux_sym__atoms,
    STATE(6121), 1,
      sym__qid,
    STATE(6386), 1,
      sym_atom,
    STATE(8067), 1,
      sym__LAMBDA,
    STATE(8369), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(852), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4210), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6575), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6565), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(4188), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9838), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [371728] = 30,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2796), 1,
      anon_sym_BSLASH,
    ACTIONS(2798), 1,
      anon_sym_u03bb,
    ACTIONS(2800), 1,
      anon_sym_quoteGoal,
    ACTIONS(2802), 1,
      anon_sym_tactic,
    ACTIONS(2804), 1,
      anon_sym_let,
    ACTIONS(3380), 1,
      sym_id,
    ACTIONS(3384), 1,
      anon_sym_record,
    ACTIONS(3386), 1,
      anon_sym_LPAREN,
    ACTIONS(3388), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3390), 1,
      anon_sym_u2983,
    ACTIONS(3392), 1,
      anon_sym_LBRACE,
    ACTIONS(3394), 1,
      aux_sym__qid_token1,
    ACTIONS(3396), 1,
      anon_sym_DOT,
    ACTIONS(3398), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3400), 1,
      anon_sym_u2987,
    ACTIONS(3404), 1,
      anon_sym_Set,
    STATE(2143), 1,
      sym__ARROW,
    STATE(4004), 1,
      aux_sym__atoms,
    STATE(5099), 1,
      sym_atom,
    STATE(8041), 1,
      sym__LAMBDA,
    STATE(8490), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2794), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3402), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(4434), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(4937), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4939), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8997), 7,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3382), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [371844] = 30,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(3134), 1,
      anon_sym_BSLASH,
    ACTIONS(3136), 1,
      anon_sym_u03bb,
    ACTIONS(3154), 1,
      anon_sym_quoteGoal,
    ACTIONS(3156), 1,
      anon_sym_tactic,
    ACTIONS(3162), 1,
      anon_sym_let,
    ACTIONS(3326), 1,
      sym_id,
    ACTIONS(3332), 1,
      anon_sym_record,
    ACTIONS(3334), 1,
      anon_sym_LPAREN,
    ACTIONS(3336), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3338), 1,
      anon_sym_u2983,
    ACTIONS(3340), 1,
      anon_sym_LBRACE,
    ACTIONS(3342), 1,
      aux_sym__qid_token1,
    ACTIONS(3344), 1,
      anon_sym_DOT,
    ACTIONS(3346), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3348), 1,
      anon_sym_u2987,
    ACTIONS(3352), 1,
      anon_sym_Set,
    STATE(1684), 1,
      sym__ARROW,
    STATE(4004), 1,
      aux_sym__atoms,
    STATE(4908), 1,
      sym_atom,
    STATE(8076), 1,
      sym__LAMBDA,
    STATE(8363), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3132), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3350), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(5276), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(4650), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4649), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9001), 7,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3330), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [371960] = 30,
    ACTIONS(710), 1,
      anon_sym_DASH,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(920), 1,
      anon_sym_quoteGoal,
    ACTIONS(928), 1,
      anon_sym_let,
    ACTIONS(3058), 1,
      anon_sym_BSLASH,
    ACTIONS(3060), 1,
      anon_sym_u03bb,
    ACTIONS(3064), 1,
      anon_sym_record,
    ACTIONS(3066), 1,
      anon_sym_LPAREN,
    ACTIONS(3068), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3070), 1,
      anon_sym_u2983,
    ACTIONS(3072), 1,
      anon_sym_LBRACE,
    ACTIONS(3076), 1,
      aux_sym__qid_token1,
    ACTIONS(3078), 1,
      anon_sym_DOT,
    ACTIONS(3080), 1,
      anon_sym_tactic,
    ACTIONS(3082), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3084), 1,
      anon_sym_u2987,
    ACTIONS(3088), 1,
      anon_sym_Set,
    ACTIONS(4220), 1,
      sym_id,
    STATE(3892), 1,
      aux_sym__atoms,
    STATE(6084), 1,
      sym__qid,
    STATE(6427), 1,
      sym_atom,
    STATE(8123), 1,
      sym__LAMBDA,
    STATE(8396), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3086), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6715), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6714), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3062), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9752), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [372076] = 30,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2302), 1,
      anon_sym_BSLASH,
    ACTIONS(2304), 1,
      anon_sym_u03bb,
    ACTIONS(2322), 1,
      anon_sym_quoteGoal,
    ACTIONS(2324), 1,
      anon_sym_tactic,
    ACTIONS(2330), 1,
      anon_sym_let,
    ACTIONS(5278), 1,
      sym_id,
    ACTIONS(5282), 1,
      anon_sym_record,
    ACTIONS(5284), 1,
      anon_sym_LPAREN,
    ACTIONS(5286), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(5288), 1,
      anon_sym_u2983,
    ACTIONS(5290), 1,
      anon_sym_LBRACE,
    ACTIONS(5292), 1,
      aux_sym__qid_token1,
    ACTIONS(5294), 1,
      anon_sym_DOT,
    ACTIONS(5296), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(5298), 1,
      anon_sym_u2987,
    ACTIONS(5302), 1,
      anon_sym_Set,
    STATE(3707), 1,
      aux_sym__with_exprs_repeat1,
    STATE(3786), 1,
      aux_sym__atoms,
    STATE(5949), 1,
      sym_atom,
    STATE(8138), 1,
      sym__LAMBDA,
    STATE(8476), 1,
      sym__FORALL,
    STATE(8978), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2300), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(5300), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5779), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5778), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(5280), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [372192] = 31,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(1302), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(11823), 1,
      sym__binding_ids_and_absurds,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(10047), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [372310] = 30,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2800), 1,
      anon_sym_quoteGoal,
    ACTIONS(2804), 1,
      anon_sym_let,
    ACTIONS(2806), 1,
      sym_id,
    ACTIONS(2810), 1,
      anon_sym_BSLASH,
    ACTIONS(2812), 1,
      anon_sym_u03bb,
    ACTIONS(2816), 1,
      anon_sym_record,
    ACTIONS(2818), 1,
      anon_sym_LPAREN,
    ACTIONS(2820), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2822), 1,
      anon_sym_u2983,
    ACTIONS(2824), 1,
      anon_sym_LBRACE,
    ACTIONS(2826), 1,
      aux_sym__qid_token1,
    ACTIONS(2828), 1,
      anon_sym_DOT,
    ACTIONS(2830), 1,
      anon_sym_tactic,
    ACTIONS(2832), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2834), 1,
      anon_sym_u2987,
    ACTIONS(2838), 1,
      anon_sym_Set,
    STATE(2135), 1,
      sym__ARROW,
    STATE(4004), 1,
      aux_sym__atoms,
    STATE(5831), 1,
      sym_atom,
    STATE(8081), 1,
      sym__LAMBDA,
    STATE(8490), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2794), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2836), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(5304), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(5982), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5981), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8997), 7,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2814), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [372426] = 30,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(878), 1,
      anon_sym_quoteGoal,
    ACTIONS(886), 1,
      anon_sym_let,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(4182), 1,
      sym_id,
    ACTIONS(4184), 1,
      anon_sym_BSLASH,
    ACTIONS(4186), 1,
      anon_sym_u03bb,
    ACTIONS(4190), 1,
      anon_sym_record,
    ACTIONS(4192), 1,
      anon_sym_LPAREN,
    ACTIONS(4194), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4196), 1,
      anon_sym_u2983,
    ACTIONS(4198), 1,
      anon_sym_LBRACE,
    ACTIONS(4200), 1,
      aux_sym__qid_token1,
    ACTIONS(4202), 1,
      anon_sym_DOT,
    ACTIONS(4204), 1,
      anon_sym_tactic,
    ACTIONS(4206), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4208), 1,
      anon_sym_u2987,
    ACTIONS(4212), 1,
      anon_sym_Set,
    STATE(3888), 1,
      aux_sym__atoms,
    STATE(6121), 1,
      sym__qid,
    STATE(6386), 1,
      sym_atom,
    STATE(8067), 1,
      sym__LAMBDA,
    STATE(8369), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(852), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4210), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6575), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6565), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(4188), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9754), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [372542] = 30,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(964), 1,
      anon_sym_quoteGoal,
    ACTIONS(972), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4214), 1,
      anon_sym_BSLASH,
    ACTIONS(4216), 1,
      anon_sym_u03bb,
    ACTIONS(4218), 1,
      anon_sym_tactic,
    STATE(3891), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8047), 1,
      sym__LAMBDA,
    STATE(8355), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(942), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9873), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [372658] = 30,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(964), 1,
      anon_sym_quoteGoal,
    ACTIONS(972), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4214), 1,
      anon_sym_BSLASH,
    ACTIONS(4216), 1,
      anon_sym_u03bb,
    ACTIONS(4218), 1,
      anon_sym_tactic,
    STATE(3891), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8047), 1,
      sym__LAMBDA,
    STATE(8355), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(942), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9779), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [372774] = 30,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2428), 1,
      anon_sym_BSLASH,
    ACTIONS(2430), 1,
      anon_sym_u03bb,
    ACTIONS(2448), 1,
      anon_sym_quoteGoal,
    ACTIONS(2450), 1,
      anon_sym_tactic,
    ACTIONS(2456), 1,
      anon_sym_let,
    ACTIONS(5306), 1,
      sym_id,
    ACTIONS(5310), 1,
      anon_sym_record,
    ACTIONS(5312), 1,
      anon_sym_LPAREN,
    ACTIONS(5314), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(5316), 1,
      anon_sym_u2983,
    ACTIONS(5318), 1,
      anon_sym_LBRACE,
    ACTIONS(5320), 1,
      aux_sym__qid_token1,
    ACTIONS(5322), 1,
      anon_sym_DOT,
    ACTIONS(5324), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(5326), 1,
      anon_sym_u2987,
    ACTIONS(5330), 1,
      anon_sym_Set,
    STATE(3753), 1,
      aux_sym__with_exprs_repeat1,
    STATE(3793), 1,
      aux_sym__atoms,
    STATE(5759), 1,
      sym_atom,
    STATE(8125), 1,
      sym__LAMBDA,
    STATE(8423), 1,
      sym__FORALL,
    STATE(8978), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2424), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(5328), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5854), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5853), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(5308), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [372890] = 30,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(1870), 1,
      anon_sym_BSLASH,
    ACTIONS(1872), 1,
      anon_sym_u03bb,
    ACTIONS(1890), 1,
      anon_sym_quoteGoal,
    ACTIONS(1892), 1,
      anon_sym_tactic,
    ACTIONS(1898), 1,
      anon_sym_let,
    ACTIONS(5332), 1,
      sym_id,
    ACTIONS(5336), 1,
      anon_sym_record,
    ACTIONS(5338), 1,
      anon_sym_LPAREN,
    ACTIONS(5340), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(5342), 1,
      anon_sym_u2983,
    ACTIONS(5344), 1,
      anon_sym_LBRACE,
    ACTIONS(5346), 1,
      aux_sym__qid_token1,
    ACTIONS(5348), 1,
      anon_sym_DOT,
    ACTIONS(5350), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(5352), 1,
      anon_sym_u2987,
    ACTIONS(5356), 1,
      anon_sym_Set,
    STATE(3738), 1,
      aux_sym__with_exprs_repeat1,
    STATE(3847), 1,
      aux_sym__atoms,
    STATE(4786), 1,
      sym_atom,
    STATE(8032), 1,
      sym__LAMBDA,
    STATE(8379), 1,
      sym__FORALL,
    STATE(8939), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1868), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(5354), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4898), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4840), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(5334), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [373006] = 31,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(1302), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(10833), 1,
      sym__binding_ids_and_absurds,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9703), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [373124] = 31,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(1302), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(11199), 1,
      sym__binding_ids_and_absurds,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9866), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [373242] = 30,
    ACTIONS(710), 1,
      anon_sym_DASH,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(920), 1,
      anon_sym_quoteGoal,
    ACTIONS(928), 1,
      anon_sym_let,
    ACTIONS(3058), 1,
      anon_sym_BSLASH,
    ACTIONS(3060), 1,
      anon_sym_u03bb,
    ACTIONS(3064), 1,
      anon_sym_record,
    ACTIONS(3066), 1,
      anon_sym_LPAREN,
    ACTIONS(3068), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3070), 1,
      anon_sym_u2983,
    ACTIONS(3072), 1,
      anon_sym_LBRACE,
    ACTIONS(3076), 1,
      aux_sym__qid_token1,
    ACTIONS(3078), 1,
      anon_sym_DOT,
    ACTIONS(3080), 1,
      anon_sym_tactic,
    ACTIONS(3082), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3084), 1,
      anon_sym_u2987,
    ACTIONS(3088), 1,
      anon_sym_Set,
    ACTIONS(4220), 1,
      sym_id,
    STATE(3892), 1,
      aux_sym__atoms,
    STATE(6084), 1,
      sym__qid,
    STATE(6427), 1,
      sym_atom,
    STATE(8123), 1,
      sym__LAMBDA,
    STATE(8396), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3086), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6715), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6714), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3062), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9953), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [373358] = 30,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(964), 1,
      anon_sym_quoteGoal,
    ACTIONS(972), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4214), 1,
      anon_sym_BSLASH,
    ACTIONS(4216), 1,
      anon_sym_u03bb,
    ACTIONS(4218), 1,
      anon_sym_tactic,
    STATE(3891), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8047), 1,
      sym__LAMBDA,
    STATE(8355), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(942), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9827), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [373474] = 30,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(964), 1,
      anon_sym_quoteGoal,
    ACTIONS(972), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4214), 1,
      anon_sym_BSLASH,
    ACTIONS(4216), 1,
      anon_sym_u03bb,
    ACTIONS(4218), 1,
      anon_sym_tactic,
    STATE(3891), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8047), 1,
      sym__LAMBDA,
    STATE(8355), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(942), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9941), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [373590] = 30,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(878), 1,
      anon_sym_quoteGoal,
    ACTIONS(886), 1,
      anon_sym_let,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(4182), 1,
      sym_id,
    ACTIONS(4184), 1,
      anon_sym_BSLASH,
    ACTIONS(4186), 1,
      anon_sym_u03bb,
    ACTIONS(4190), 1,
      anon_sym_record,
    ACTIONS(4192), 1,
      anon_sym_LPAREN,
    ACTIONS(4194), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4196), 1,
      anon_sym_u2983,
    ACTIONS(4198), 1,
      anon_sym_LBRACE,
    ACTIONS(4200), 1,
      aux_sym__qid_token1,
    ACTIONS(4202), 1,
      anon_sym_DOT,
    ACTIONS(4204), 1,
      anon_sym_tactic,
    ACTIONS(4206), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4208), 1,
      anon_sym_u2987,
    ACTIONS(4212), 1,
      anon_sym_Set,
    STATE(3888), 1,
      aux_sym__atoms,
    STATE(6121), 1,
      sym__qid,
    STATE(6386), 1,
      sym_atom,
    STATE(8067), 1,
      sym__LAMBDA,
    STATE(8369), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(852), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4210), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6575), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6565), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(4188), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9828), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [373706] = 30,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(3090), 1,
      sym_id,
    ACTIONS(3096), 1,
      anon_sym_BSLASH,
    ACTIONS(3098), 1,
      anon_sym_u03bb,
    ACTIONS(3102), 1,
      anon_sym_record,
    ACTIONS(3104), 1,
      anon_sym_LPAREN,
    ACTIONS(3106), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3108), 1,
      anon_sym_u2983,
    ACTIONS(3110), 1,
      anon_sym_LBRACE,
    ACTIONS(3112), 1,
      aux_sym__qid_token1,
    ACTIONS(3114), 1,
      anon_sym_DOT,
    ACTIONS(3116), 1,
      anon_sym_quoteGoal,
    ACTIONS(3118), 1,
      anon_sym_tactic,
    ACTIONS(3120), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3122), 1,
      anon_sym_u2987,
    ACTIONS(3124), 1,
      anon_sym_let,
    ACTIONS(3128), 1,
      anon_sym_Set,
    STATE(1757), 1,
      sym__ARROW,
    STATE(4004), 1,
      aux_sym__atoms,
    STATE(4365), 1,
      sym_atom,
    STATE(8099), 1,
      sym__LAMBDA,
    STATE(8393), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3092), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3126), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(5358), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(4293), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4285), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9001), 7,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3100), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [373822] = 30,
    ACTIONS(710), 1,
      anon_sym_DASH,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(920), 1,
      anon_sym_quoteGoal,
    ACTIONS(928), 1,
      anon_sym_let,
    ACTIONS(3058), 1,
      anon_sym_BSLASH,
    ACTIONS(3060), 1,
      anon_sym_u03bb,
    ACTIONS(3064), 1,
      anon_sym_record,
    ACTIONS(3066), 1,
      anon_sym_LPAREN,
    ACTIONS(3068), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3070), 1,
      anon_sym_u2983,
    ACTIONS(3072), 1,
      anon_sym_LBRACE,
    ACTIONS(3076), 1,
      aux_sym__qid_token1,
    ACTIONS(3078), 1,
      anon_sym_DOT,
    ACTIONS(3080), 1,
      anon_sym_tactic,
    ACTIONS(3082), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3084), 1,
      anon_sym_u2987,
    ACTIONS(3088), 1,
      anon_sym_Set,
    ACTIONS(4220), 1,
      sym_id,
    STATE(3892), 1,
      aux_sym__atoms,
    STATE(6084), 1,
      sym__qid,
    STATE(6427), 1,
      sym_atom,
    STATE(8123), 1,
      sym__LAMBDA,
    STATE(8396), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3086), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6715), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6714), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3062), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9832), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [373938] = 30,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(878), 1,
      anon_sym_quoteGoal,
    ACTIONS(886), 1,
      anon_sym_let,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(4182), 1,
      sym_id,
    ACTIONS(4184), 1,
      anon_sym_BSLASH,
    ACTIONS(4186), 1,
      anon_sym_u03bb,
    ACTIONS(4190), 1,
      anon_sym_record,
    ACTIONS(4192), 1,
      anon_sym_LPAREN,
    ACTIONS(4194), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4196), 1,
      anon_sym_u2983,
    ACTIONS(4198), 1,
      anon_sym_LBRACE,
    ACTIONS(4200), 1,
      aux_sym__qid_token1,
    ACTIONS(4202), 1,
      anon_sym_DOT,
    ACTIONS(4204), 1,
      anon_sym_tactic,
    ACTIONS(4206), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4208), 1,
      anon_sym_u2987,
    ACTIONS(4212), 1,
      anon_sym_Set,
    STATE(3888), 1,
      aux_sym__atoms,
    STATE(6121), 1,
      sym__qid,
    STATE(6386), 1,
      sym_atom,
    STATE(8067), 1,
      sym__LAMBDA,
    STATE(8369), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(852), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4210), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6575), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6565), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(4188), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9940), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [374054] = 30,
    ACTIONS(710), 1,
      anon_sym_DASH,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(920), 1,
      anon_sym_quoteGoal,
    ACTIONS(928), 1,
      anon_sym_let,
    ACTIONS(3058), 1,
      anon_sym_BSLASH,
    ACTIONS(3060), 1,
      anon_sym_u03bb,
    ACTIONS(3064), 1,
      anon_sym_record,
    ACTIONS(3066), 1,
      anon_sym_LPAREN,
    ACTIONS(3068), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3070), 1,
      anon_sym_u2983,
    ACTIONS(3072), 1,
      anon_sym_LBRACE,
    ACTIONS(3076), 1,
      aux_sym__qid_token1,
    ACTIONS(3078), 1,
      anon_sym_DOT,
    ACTIONS(3080), 1,
      anon_sym_tactic,
    ACTIONS(3082), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3084), 1,
      anon_sym_u2987,
    ACTIONS(3088), 1,
      anon_sym_Set,
    ACTIONS(4220), 1,
      sym_id,
    STATE(3892), 1,
      aux_sym__atoms,
    STATE(6084), 1,
      sym__qid,
    STATE(6427), 1,
      sym_atom,
    STATE(8123), 1,
      sym__LAMBDA,
    STATE(8396), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3086), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6715), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6714), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3062), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9929), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [374170] = 30,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(878), 1,
      anon_sym_quoteGoal,
    ACTIONS(886), 1,
      anon_sym_let,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(4182), 1,
      sym_id,
    ACTIONS(4184), 1,
      anon_sym_BSLASH,
    ACTIONS(4186), 1,
      anon_sym_u03bb,
    ACTIONS(4190), 1,
      anon_sym_record,
    ACTIONS(4192), 1,
      anon_sym_LPAREN,
    ACTIONS(4194), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4196), 1,
      anon_sym_u2983,
    ACTIONS(4198), 1,
      anon_sym_LBRACE,
    ACTIONS(4200), 1,
      aux_sym__qid_token1,
    ACTIONS(4202), 1,
      anon_sym_DOT,
    ACTIONS(4204), 1,
      anon_sym_tactic,
    ACTIONS(4206), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4208), 1,
      anon_sym_u2987,
    ACTIONS(4212), 1,
      anon_sym_Set,
    STATE(3888), 1,
      aux_sym__atoms,
    STATE(6121), 1,
      sym__qid,
    STATE(6386), 1,
      sym_atom,
    STATE(8067), 1,
      sym__LAMBDA,
    STATE(8369), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(852), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4210), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6575), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6565), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(4188), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9872), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [374286] = 30,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(964), 1,
      anon_sym_quoteGoal,
    ACTIONS(972), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4214), 1,
      anon_sym_BSLASH,
    ACTIONS(4216), 1,
      anon_sym_u03bb,
    ACTIONS(4218), 1,
      anon_sym_tactic,
    STATE(3891), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8047), 1,
      sym__LAMBDA,
    STATE(8355), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(942), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10095), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [374402] = 30,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(3698), 1,
      anon_sym_BSLASH,
    ACTIONS(3700), 1,
      anon_sym_u03bb,
    ACTIONS(3718), 1,
      anon_sym_quoteGoal,
    ACTIONS(3720), 1,
      anon_sym_tactic,
    ACTIONS(3726), 1,
      anon_sym_let,
    ACTIONS(5360), 1,
      sym_id,
    ACTIONS(5364), 1,
      anon_sym_record,
    ACTIONS(5366), 1,
      anon_sym_LPAREN,
    ACTIONS(5368), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(5370), 1,
      anon_sym_u2983,
    ACTIONS(5372), 1,
      anon_sym_LBRACE,
    ACTIONS(5374), 1,
      aux_sym__qid_token1,
    ACTIONS(5376), 1,
      anon_sym_DOT,
    ACTIONS(5378), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(5380), 1,
      anon_sym_u2987,
    ACTIONS(5384), 1,
      anon_sym_Set,
    STATE(3761), 1,
      aux_sym__with_exprs_repeat1,
    STATE(3837), 1,
      aux_sym__atoms,
    STATE(5117), 1,
      sym_atom,
    STATE(8124), 1,
      sym__LAMBDA,
    STATE(8446), 1,
      sym__FORALL,
    STATE(8939), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3696), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(5382), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5038), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4980), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(5362), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [374518] = 30,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(964), 1,
      anon_sym_quoteGoal,
    ACTIONS(972), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4214), 1,
      anon_sym_BSLASH,
    ACTIONS(4216), 1,
      anon_sym_u03bb,
    ACTIONS(4218), 1,
      anon_sym_tactic,
    STATE(3891), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8047), 1,
      sym__LAMBDA,
    STATE(8355), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(942), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9756), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [374634] = 30,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2094), 1,
      sym_id,
    ACTIONS(2100), 1,
      anon_sym_BSLASH,
    ACTIONS(2102), 1,
      anon_sym_u03bb,
    ACTIONS(2106), 1,
      anon_sym_record,
    ACTIONS(2108), 1,
      anon_sym_LPAREN,
    ACTIONS(2110), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2112), 1,
      anon_sym_u2983,
    ACTIONS(2114), 1,
      anon_sym_LBRACE,
    ACTIONS(2116), 1,
      aux_sym__qid_token1,
    ACTIONS(2118), 1,
      anon_sym_DOT,
    ACTIONS(2120), 1,
      anon_sym_quoteGoal,
    ACTIONS(2122), 1,
      anon_sym_tactic,
    ACTIONS(2124), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2126), 1,
      anon_sym_u2987,
    ACTIONS(2128), 1,
      anon_sym_let,
    ACTIONS(2132), 1,
      anon_sym_Set,
    STATE(1481), 1,
      sym__ARROW,
    STATE(4004), 1,
      aux_sym__atoms,
    STATE(5601), 1,
      sym_atom,
    STATE(8075), 1,
      sym__LAMBDA,
    STATE(8428), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2096), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2130), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(4302), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(5451), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5453), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8997), 7,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2104), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [374750] = 30,
    ACTIONS(710), 1,
      anon_sym_DASH,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(920), 1,
      anon_sym_quoteGoal,
    ACTIONS(928), 1,
      anon_sym_let,
    ACTIONS(3058), 1,
      anon_sym_BSLASH,
    ACTIONS(3060), 1,
      anon_sym_u03bb,
    ACTIONS(3064), 1,
      anon_sym_record,
    ACTIONS(3066), 1,
      anon_sym_LPAREN,
    ACTIONS(3068), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3070), 1,
      anon_sym_u2983,
    ACTIONS(3072), 1,
      anon_sym_LBRACE,
    ACTIONS(3076), 1,
      aux_sym__qid_token1,
    ACTIONS(3078), 1,
      anon_sym_DOT,
    ACTIONS(3080), 1,
      anon_sym_tactic,
    ACTIONS(3082), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3084), 1,
      anon_sym_u2987,
    ACTIONS(3088), 1,
      anon_sym_Set,
    ACTIONS(4220), 1,
      sym_id,
    STATE(3892), 1,
      aux_sym__atoms,
    STATE(6084), 1,
      sym__qid,
    STATE(6427), 1,
      sym_atom,
    STATE(8123), 1,
      sym__LAMBDA,
    STATE(8396), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3086), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6715), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6714), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3062), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9948), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [374866] = 31,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(1302), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(11086), 1,
      sym__binding_ids_and_absurds,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9814), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [374984] = 30,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(1302), 1,
      anon_sym_let,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(5218), 1,
      sym_id,
    ACTIONS(5224), 1,
      anon_sym_record,
    ACTIONS(5226), 1,
      anon_sym_LPAREN,
    ACTIONS(5228), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(5230), 1,
      anon_sym_u2983,
    ACTIONS(5232), 1,
      anon_sym_LBRACE,
    ACTIONS(5234), 1,
      aux_sym__qid_token1,
    ACTIONS(5236), 1,
      anon_sym_DOT,
    ACTIONS(5238), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(5240), 1,
      anon_sym_u2987,
    ACTIONS(5244), 1,
      anon_sym_Set,
    STATE(1845), 1,
      sym__ARROW,
    STATE(4004), 1,
      aux_sym__atoms,
    STATE(6203), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(5242), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(5386), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(6166), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6188), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8997), 7,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(5222), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [375100] = 30,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(878), 1,
      anon_sym_quoteGoal,
    ACTIONS(886), 1,
      anon_sym_let,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(4182), 1,
      sym_id,
    ACTIONS(4184), 1,
      anon_sym_BSLASH,
    ACTIONS(4186), 1,
      anon_sym_u03bb,
    ACTIONS(4190), 1,
      anon_sym_record,
    ACTIONS(4192), 1,
      anon_sym_LPAREN,
    ACTIONS(4194), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4196), 1,
      anon_sym_u2983,
    ACTIONS(4198), 1,
      anon_sym_LBRACE,
    ACTIONS(4200), 1,
      aux_sym__qid_token1,
    ACTIONS(4202), 1,
      anon_sym_DOT,
    ACTIONS(4204), 1,
      anon_sym_tactic,
    ACTIONS(4206), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4208), 1,
      anon_sym_u2987,
    ACTIONS(4212), 1,
      anon_sym_Set,
    STATE(3888), 1,
      aux_sym__atoms,
    STATE(6121), 1,
      sym__qid,
    STATE(6386), 1,
      sym_atom,
    STATE(8067), 1,
      sym__LAMBDA,
    STATE(8369), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(852), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4210), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6575), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6565), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(4188), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9950), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [375216] = 30,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(2732), 1,
      anon_sym_BSLASH,
    ACTIONS(2734), 1,
      anon_sym_u03bb,
    ACTIONS(2752), 1,
      anon_sym_quoteGoal,
    ACTIONS(2754), 1,
      anon_sym_tactic,
    ACTIONS(2760), 1,
      anon_sym_let,
    ACTIONS(3610), 1,
      sym_id,
    ACTIONS(3616), 1,
      anon_sym_record,
    ACTIONS(3618), 1,
      anon_sym_LPAREN,
    ACTIONS(3620), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3622), 1,
      anon_sym_u2983,
    ACTIONS(3624), 1,
      anon_sym_LBRACE,
    ACTIONS(3626), 1,
      aux_sym__qid_token1,
    ACTIONS(3628), 1,
      anon_sym_DOT,
    ACTIONS(3630), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3632), 1,
      anon_sym_u2987,
    ACTIONS(3636), 1,
      anon_sym_Set,
    STATE(1549), 1,
      sym__ARROW,
    STATE(4004), 1,
      aux_sym__atoms,
    STATE(5352), 1,
      sym_atom,
    STATE(8061), 1,
      sym__LAMBDA,
    STATE(8384), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2730), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3634), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(5388), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(5254), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5242), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9001), 7,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3614), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [375332] = 30,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(3090), 1,
      sym_id,
    ACTIONS(3096), 1,
      anon_sym_BSLASH,
    ACTIONS(3098), 1,
      anon_sym_u03bb,
    ACTIONS(3102), 1,
      anon_sym_record,
    ACTIONS(3104), 1,
      anon_sym_LPAREN,
    ACTIONS(3106), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3108), 1,
      anon_sym_u2983,
    ACTIONS(3110), 1,
      anon_sym_LBRACE,
    ACTIONS(3112), 1,
      aux_sym__qid_token1,
    ACTIONS(3114), 1,
      anon_sym_DOT,
    ACTIONS(3116), 1,
      anon_sym_quoteGoal,
    ACTIONS(3118), 1,
      anon_sym_tactic,
    ACTIONS(3120), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3122), 1,
      anon_sym_u2987,
    ACTIONS(3124), 1,
      anon_sym_let,
    ACTIONS(3128), 1,
      anon_sym_Set,
    STATE(1805), 1,
      sym__ARROW,
    STATE(4004), 1,
      aux_sym__atoms,
    STATE(4365), 1,
      sym_atom,
    STATE(8099), 1,
      sym__LAMBDA,
    STATE(8393), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3092), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3126), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(4864), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(4293), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4285), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9001), 7,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3100), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [375448] = 30,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(5390), 1,
      sym_id,
    ACTIONS(5394), 1,
      anon_sym_record,
    ACTIONS(5396), 1,
      anon_sym_LPAREN,
    ACTIONS(5398), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(5400), 1,
      anon_sym_u2983,
    ACTIONS(5402), 1,
      anon_sym_LBRACE,
    ACTIONS(5404), 1,
      aux_sym__qid_token1,
    ACTIONS(5406), 1,
      anon_sym_DOT,
    ACTIONS(5408), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(5410), 1,
      anon_sym_u2987,
    ACTIONS(5414), 1,
      anon_sym_Set,
    STATE(3746), 1,
      aux_sym__with_exprs_repeat1,
    STATE(3818), 1,
      aux_sym__atoms,
    STATE(6075), 1,
      sym_atom,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    STATE(8978), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(5412), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6026), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6060), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(5392), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [375564] = 30,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(964), 1,
      anon_sym_quoteGoal,
    ACTIONS(972), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4214), 1,
      anon_sym_BSLASH,
    ACTIONS(4216), 1,
      anon_sym_u03bb,
    ACTIONS(4218), 1,
      anon_sym_tactic,
    STATE(3891), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8047), 1,
      sym__LAMBDA,
    STATE(8355), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(942), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9951), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [375680] = 31,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(1302), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(10587), 1,
      sym__binding_ids_and_absurds,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9936), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [375798] = 30,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(944), 1,
      anon_sym_BSLASH,
    ACTIONS(946), 1,
      anon_sym_u03bb,
    ACTIONS(964), 1,
      anon_sym_quoteGoal,
    ACTIONS(966), 1,
      anon_sym_tactic,
    ACTIONS(972), 1,
      anon_sym_let,
    ACTIONS(5416), 1,
      sym_id,
    ACTIONS(5420), 1,
      anon_sym_record,
    ACTIONS(5422), 1,
      anon_sym_LPAREN,
    ACTIONS(5424), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(5426), 1,
      anon_sym_u2983,
    ACTIONS(5428), 1,
      anon_sym_LBRACE,
    ACTIONS(5430), 1,
      aux_sym__qid_token1,
    ACTIONS(5432), 1,
      anon_sym_DOT,
    ACTIONS(5434), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(5436), 1,
      anon_sym_u2987,
    ACTIONS(5440), 1,
      anon_sym_Set,
    STATE(3743), 1,
      aux_sym__with_exprs_repeat1,
    STATE(3857), 1,
      aux_sym__atoms,
    STATE(5548), 1,
      sym_atom,
    STATE(8054), 1,
      sym__LAMBDA,
    STATE(8355), 1,
      sym__FORALL,
    STATE(8978), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(942), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(5438), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5369), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5364), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(5418), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [375914] = 30,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2134), 1,
      sym_id,
    ACTIONS(2140), 1,
      anon_sym_BSLASH,
    ACTIONS(2142), 1,
      anon_sym_u03bb,
    ACTIONS(2146), 1,
      anon_sym_record,
    ACTIONS(2148), 1,
      anon_sym_LPAREN,
    ACTIONS(2150), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2152), 1,
      anon_sym_u2983,
    ACTIONS(2154), 1,
      anon_sym_LBRACE,
    ACTIONS(2156), 1,
      aux_sym__qid_token1,
    ACTIONS(2158), 1,
      anon_sym_DOT,
    ACTIONS(2160), 1,
      anon_sym_quoteGoal,
    ACTIONS(2162), 1,
      anon_sym_tactic,
    ACTIONS(2164), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2166), 1,
      anon_sym_u2987,
    ACTIONS(2168), 1,
      anon_sym_let,
    ACTIONS(2172), 1,
      anon_sym_Set,
    STATE(1769), 1,
      sym__ARROW,
    STATE(4004), 1,
      aux_sym__atoms,
    STATE(5718), 1,
      sym_atom,
    STATE(8040), 1,
      sym__LAMBDA,
    STATE(8460), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2136), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2170), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(4590), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(5624), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5627), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8997), 7,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2144), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [376030] = 31,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(1302), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(11415), 1,
      sym__binding_ids_and_absurds,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9984), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [376148] = 30,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2448), 1,
      anon_sym_quoteGoal,
    ACTIONS(2456), 1,
      anon_sym_let,
    ACTIONS(2842), 1,
      anon_sym_BSLASH,
    ACTIONS(2844), 1,
      anon_sym_u03bb,
    ACTIONS(2862), 1,
      anon_sym_tactic,
    ACTIONS(5442), 1,
      sym_id,
    ACTIONS(5446), 1,
      anon_sym_record,
    ACTIONS(5448), 1,
      anon_sym_LPAREN,
    ACTIONS(5450), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(5452), 1,
      anon_sym_u2983,
    ACTIONS(5454), 1,
      anon_sym_LBRACE,
    ACTIONS(5456), 1,
      aux_sym__qid_token1,
    ACTIONS(5458), 1,
      anon_sym_DOT,
    ACTIONS(5460), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(5462), 1,
      anon_sym_u2987,
    ACTIONS(5466), 1,
      anon_sym_Set,
    STATE(3747), 1,
      aux_sym__with_exprs_repeat1,
    STATE(3859), 1,
      aux_sym__atoms,
    STATE(5485), 1,
      sym_atom,
    STATE(8053), 1,
      sym__LAMBDA,
    STATE(8423), 1,
      sym__FORALL,
    STATE(8978), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2424), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(5464), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5639), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5635), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(5444), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [376264] = 30,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2302), 1,
      anon_sym_BSLASH,
    ACTIONS(2304), 1,
      anon_sym_u03bb,
    ACTIONS(2322), 1,
      anon_sym_quoteGoal,
    ACTIONS(2324), 1,
      anon_sym_tactic,
    ACTIONS(2330), 1,
      anon_sym_let,
    ACTIONS(3638), 1,
      sym_id,
    ACTIONS(3644), 1,
      anon_sym_record,
    ACTIONS(3646), 1,
      anon_sym_LPAREN,
    ACTIONS(3648), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3650), 1,
      anon_sym_u2983,
    ACTIONS(3652), 1,
      anon_sym_LBRACE,
    ACTIONS(3654), 1,
      aux_sym__qid_token1,
    ACTIONS(3656), 1,
      anon_sym_DOT,
    ACTIONS(3658), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3660), 1,
      anon_sym_u2987,
    ACTIONS(3664), 1,
      anon_sym_Set,
    STATE(1611), 1,
      sym__ARROW,
    STATE(4004), 1,
      aux_sym__atoms,
    STATE(5734), 1,
      sym_atom,
    STATE(8138), 1,
      sym__LAMBDA,
    STATE(8476), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2300), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3662), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(4718), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(5680), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5681), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8997), 7,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3642), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [376380] = 30,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(3410), 1,
      anon_sym_BSLASH,
    ACTIONS(3412), 1,
      anon_sym_u03bb,
    ACTIONS(3430), 1,
      anon_sym_quoteGoal,
    ACTIONS(3432), 1,
      anon_sym_tactic,
    ACTIONS(3438), 1,
      anon_sym_let,
    ACTIONS(5468), 1,
      sym_id,
    ACTIONS(5472), 1,
      anon_sym_record,
    ACTIONS(5474), 1,
      anon_sym_LPAREN,
    ACTIONS(5476), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(5478), 1,
      anon_sym_u2983,
    ACTIONS(5480), 1,
      anon_sym_LBRACE,
    ACTIONS(5482), 1,
      aux_sym__qid_token1,
    ACTIONS(5484), 1,
      anon_sym_DOT,
    ACTIONS(5486), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(5488), 1,
      anon_sym_u2987,
    ACTIONS(5492), 1,
      anon_sym_Set,
    STATE(3727), 1,
      aux_sym__with_exprs_repeat1,
    STATE(3875), 1,
      aux_sym__atoms,
    STATE(4421), 1,
      sym_atom,
    STATE(8038), 1,
      sym__LAMBDA,
    STATE(8435), 1,
      sym__FORALL,
    STATE(8939), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3408), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(5490), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4533), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4527), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(5470), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [376496] = 30,
    ACTIONS(878), 1,
      anon_sym_quoteGoal,
    ACTIONS(886), 1,
      anon_sym_let,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(4184), 1,
      anon_sym_BSLASH,
    ACTIONS(4186), 1,
      anon_sym_u03bb,
    ACTIONS(4204), 1,
      anon_sym_tactic,
    ACTIONS(5494), 1,
      sym_id,
    ACTIONS(5498), 1,
      anon_sym_record,
    ACTIONS(5500), 1,
      anon_sym_LPAREN,
    ACTIONS(5502), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(5504), 1,
      anon_sym_u2983,
    ACTIONS(5506), 1,
      anon_sym_LBRACE,
    ACTIONS(5508), 1,
      aux_sym__qid_token1,
    ACTIONS(5510), 1,
      anon_sym_DOT,
    ACTIONS(5512), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(5514), 1,
      anon_sym_u2987,
    ACTIONS(5518), 1,
      anon_sym_Set,
    STATE(3751), 1,
      aux_sym__with_exprs_repeat1,
    STATE(3785), 1,
      aux_sym__atoms,
    STATE(6095), 1,
      sym_atom,
    STATE(8067), 1,
      sym__LAMBDA,
    STATE(8369), 1,
      sym__FORALL,
    STATE(8978), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(852), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(5516), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6047), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6050), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(5496), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [376612] = 30,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(2938), 1,
      sym_id,
    ACTIONS(2944), 1,
      anon_sym_BSLASH,
    ACTIONS(2946), 1,
      anon_sym_u03bb,
    ACTIONS(2950), 1,
      anon_sym_record,
    ACTIONS(2952), 1,
      anon_sym_LPAREN,
    ACTIONS(2954), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2956), 1,
      anon_sym_u2983,
    ACTIONS(2958), 1,
      anon_sym_LBRACE,
    ACTIONS(2960), 1,
      aux_sym__qid_token1,
    ACTIONS(2962), 1,
      anon_sym_DOT,
    ACTIONS(2964), 1,
      anon_sym_quoteGoal,
    ACTIONS(2966), 1,
      anon_sym_tactic,
    ACTIONS(2968), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2970), 1,
      anon_sym_u2987,
    ACTIONS(2972), 1,
      anon_sym_let,
    ACTIONS(2976), 1,
      anon_sym_Set,
    STATE(2421), 1,
      sym__ARROW,
    STATE(4004), 1,
      aux_sym__atoms,
    STATE(5967), 1,
      sym_atom,
    STATE(8126), 1,
      sym__LAMBDA,
    STATE(8418), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2940), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2974), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(5520), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(5870), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5838), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9001), 7,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2948), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [376728] = 30,
    ACTIONS(710), 1,
      anon_sym_DASH,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(920), 1,
      anon_sym_quoteGoal,
    ACTIONS(928), 1,
      anon_sym_let,
    ACTIONS(3058), 1,
      anon_sym_BSLASH,
    ACTIONS(3060), 1,
      anon_sym_u03bb,
    ACTIONS(3064), 1,
      anon_sym_record,
    ACTIONS(3066), 1,
      anon_sym_LPAREN,
    ACTIONS(3068), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3070), 1,
      anon_sym_u2983,
    ACTIONS(3072), 1,
      anon_sym_LBRACE,
    ACTIONS(3076), 1,
      aux_sym__qid_token1,
    ACTIONS(3078), 1,
      anon_sym_DOT,
    ACTIONS(3080), 1,
      anon_sym_tactic,
    ACTIONS(3082), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3084), 1,
      anon_sym_u2987,
    ACTIONS(3088), 1,
      anon_sym_Set,
    ACTIONS(4220), 1,
      sym_id,
    STATE(3892), 1,
      aux_sym__atoms,
    STATE(6084), 1,
      sym__qid,
    STATE(6427), 1,
      sym_atom,
    STATE(8123), 1,
      sym__LAMBDA,
    STATE(8396), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3086), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6715), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6714), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3062), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10173), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [376844] = 30,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2120), 1,
      anon_sym_quoteGoal,
    ACTIONS(2128), 1,
      anon_sym_let,
    ACTIONS(2176), 1,
      anon_sym_BSLASH,
    ACTIONS(2178), 1,
      anon_sym_u03bb,
    ACTIONS(2196), 1,
      anon_sym_tactic,
    ACTIONS(5522), 1,
      sym_id,
    ACTIONS(5526), 1,
      anon_sym_record,
    ACTIONS(5528), 1,
      anon_sym_LPAREN,
    ACTIONS(5530), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(5532), 1,
      anon_sym_u2983,
    ACTIONS(5534), 1,
      anon_sym_LBRACE,
    ACTIONS(5536), 1,
      aux_sym__qid_token1,
    ACTIONS(5538), 1,
      anon_sym_DOT,
    ACTIONS(5540), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(5542), 1,
      anon_sym_u2987,
    ACTIONS(5546), 1,
      anon_sym_Set,
    STATE(3762), 1,
      aux_sym__with_exprs_repeat1,
    STATE(3829), 1,
      aux_sym__atoms,
    STATE(5007), 1,
      sym_atom,
    STATE(8044), 1,
      sym__LAMBDA,
    STATE(8428), 1,
      sym__FORALL,
    STATE(8978), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2096), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(5544), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5318), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5319), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(5524), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [376960] = 30,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(878), 1,
      anon_sym_quoteGoal,
    ACTIONS(886), 1,
      anon_sym_let,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(4182), 1,
      sym_id,
    ACTIONS(4184), 1,
      anon_sym_BSLASH,
    ACTIONS(4186), 1,
      anon_sym_u03bb,
    ACTIONS(4190), 1,
      anon_sym_record,
    ACTIONS(4192), 1,
      anon_sym_LPAREN,
    ACTIONS(4194), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4196), 1,
      anon_sym_u2983,
    ACTIONS(4198), 1,
      anon_sym_LBRACE,
    ACTIONS(4200), 1,
      aux_sym__qid_token1,
    ACTIONS(4202), 1,
      anon_sym_DOT,
    ACTIONS(4204), 1,
      anon_sym_tactic,
    ACTIONS(4206), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4208), 1,
      anon_sym_u2987,
    ACTIONS(4212), 1,
      anon_sym_Set,
    STATE(3888), 1,
      aux_sym__atoms,
    STATE(6121), 1,
      sym__qid,
    STATE(6386), 1,
      sym_atom,
    STATE(8067), 1,
      sym__LAMBDA,
    STATE(8369), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(852), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4210), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6575), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6565), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(4188), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9956), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [377076] = 30,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(964), 1,
      anon_sym_quoteGoal,
    ACTIONS(972), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4214), 1,
      anon_sym_BSLASH,
    ACTIONS(4216), 1,
      anon_sym_u03bb,
    ACTIONS(4218), 1,
      anon_sym_tactic,
    STATE(3891), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8047), 1,
      sym__LAMBDA,
    STATE(8355), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(942), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9964), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [377192] = 30,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(878), 1,
      anon_sym_quoteGoal,
    ACTIONS(886), 1,
      anon_sym_let,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(4182), 1,
      sym_id,
    ACTIONS(4184), 1,
      anon_sym_BSLASH,
    ACTIONS(4186), 1,
      anon_sym_u03bb,
    ACTIONS(4190), 1,
      anon_sym_record,
    ACTIONS(4192), 1,
      anon_sym_LPAREN,
    ACTIONS(4194), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4196), 1,
      anon_sym_u2983,
    ACTIONS(4198), 1,
      anon_sym_LBRACE,
    ACTIONS(4200), 1,
      aux_sym__qid_token1,
    ACTIONS(4202), 1,
      anon_sym_DOT,
    ACTIONS(4204), 1,
      anon_sym_tactic,
    ACTIONS(4206), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4208), 1,
      anon_sym_u2987,
    ACTIONS(4212), 1,
      anon_sym_Set,
    STATE(3888), 1,
      aux_sym__atoms,
    STATE(6121), 1,
      sym__qid,
    STATE(6386), 1,
      sym_atom,
    STATE(8067), 1,
      sym__LAMBDA,
    STATE(8369), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(852), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4210), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6575), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6565), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(4188), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9993), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [377308] = 30,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(1302), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(12357), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [377424] = 30,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(1302), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(12358), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [377540] = 30,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(1302), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(12359), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [377656] = 31,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(1302), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(11378), 1,
      sym__binding_ids_and_absurds,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9969), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [377774] = 30,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(2656), 1,
      anon_sym_BSLASH,
    ACTIONS(2658), 1,
      anon_sym_u03bb,
    ACTIONS(2676), 1,
      anon_sym_quoteGoal,
    ACTIONS(2678), 1,
      anon_sym_tactic,
    ACTIONS(2684), 1,
      anon_sym_let,
    ACTIONS(3208), 1,
      sym_id,
    ACTIONS(3212), 1,
      anon_sym_record,
    ACTIONS(3214), 1,
      anon_sym_LPAREN,
    ACTIONS(3216), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3218), 1,
      anon_sym_u2983,
    ACTIONS(3220), 1,
      anon_sym_LBRACE,
    ACTIONS(3222), 1,
      aux_sym__qid_token1,
    ACTIONS(3224), 1,
      anon_sym_DOT,
    ACTIONS(3226), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3228), 1,
      anon_sym_u2987,
    ACTIONS(3232), 1,
      anon_sym_Set,
    STATE(2347), 1,
      sym__ARROW,
    STATE(4004), 1,
      aux_sym__atoms,
    STATE(5433), 1,
      sym_atom,
    STATE(8132), 1,
      sym__LAMBDA,
    STATE(8470), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2654), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3230), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(4536), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(5579), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5582), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9454), 7,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3210), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [377890] = 30,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(964), 1,
      anon_sym_quoteGoal,
    ACTIONS(972), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4214), 1,
      anon_sym_BSLASH,
    ACTIONS(4216), 1,
      anon_sym_u03bb,
    ACTIONS(4218), 1,
      anon_sym_tactic,
    STATE(3891), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8047), 1,
      sym__LAMBDA,
    STATE(8355), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(942), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10214), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [378006] = 30,
    ACTIONS(710), 1,
      anon_sym_DASH,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(920), 1,
      anon_sym_quoteGoal,
    ACTIONS(928), 1,
      anon_sym_let,
    ACTIONS(3058), 1,
      anon_sym_BSLASH,
    ACTIONS(3060), 1,
      anon_sym_u03bb,
    ACTIONS(3064), 1,
      anon_sym_record,
    ACTIONS(3066), 1,
      anon_sym_LPAREN,
    ACTIONS(3068), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3070), 1,
      anon_sym_u2983,
    ACTIONS(3072), 1,
      anon_sym_LBRACE,
    ACTIONS(3076), 1,
      aux_sym__qid_token1,
    ACTIONS(3078), 1,
      anon_sym_DOT,
    ACTIONS(3080), 1,
      anon_sym_tactic,
    ACTIONS(3082), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3084), 1,
      anon_sym_u2987,
    ACTIONS(3088), 1,
      anon_sym_Set,
    ACTIONS(4220), 1,
      sym_id,
    STATE(3892), 1,
      aux_sym__atoms,
    STATE(6084), 1,
      sym__qid,
    STATE(6427), 1,
      sym_atom,
    STATE(8123), 1,
      sym__LAMBDA,
    STATE(8396), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3086), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6715), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6714), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3062), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9893), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [378122] = 30,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(878), 1,
      anon_sym_quoteGoal,
    ACTIONS(886), 1,
      anon_sym_let,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(4182), 1,
      sym_id,
    ACTIONS(4184), 1,
      anon_sym_BSLASH,
    ACTIONS(4186), 1,
      anon_sym_u03bb,
    ACTIONS(4190), 1,
      anon_sym_record,
    ACTIONS(4192), 1,
      anon_sym_LPAREN,
    ACTIONS(4194), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4196), 1,
      anon_sym_u2983,
    ACTIONS(4198), 1,
      anon_sym_LBRACE,
    ACTIONS(4200), 1,
      aux_sym__qid_token1,
    ACTIONS(4202), 1,
      anon_sym_DOT,
    ACTIONS(4204), 1,
      anon_sym_tactic,
    ACTIONS(4206), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4208), 1,
      anon_sym_u2987,
    ACTIONS(4212), 1,
      anon_sym_Set,
    STATE(3888), 1,
      aux_sym__atoms,
    STATE(6121), 1,
      sym__qid,
    STATE(6386), 1,
      sym_atom,
    STATE(8067), 1,
      sym__LAMBDA,
    STATE(8369), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(852), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4210), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6575), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6565), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(4188), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10099), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [378238] = 30,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2492), 1,
      anon_sym_BSLASH,
    ACTIONS(2494), 1,
      anon_sym_u03bb,
    ACTIONS(2512), 1,
      anon_sym_quoteGoal,
    ACTIONS(2514), 1,
      anon_sym_tactic,
    ACTIONS(2520), 1,
      anon_sym_let,
    ACTIONS(5548), 1,
      sym_id,
    ACTIONS(5552), 1,
      anon_sym_record,
    ACTIONS(5554), 1,
      anon_sym_LPAREN,
    ACTIONS(5556), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(5558), 1,
      anon_sym_u2983,
    ACTIONS(5560), 1,
      anon_sym_LBRACE,
    ACTIONS(5562), 1,
      aux_sym__qid_token1,
    ACTIONS(5564), 1,
      anon_sym_DOT,
    ACTIONS(5566), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(5568), 1,
      anon_sym_u2987,
    ACTIONS(5572), 1,
      anon_sym_Set,
    STATE(3709), 1,
      aux_sym__with_exprs_repeat1,
    STATE(3783), 1,
      aux_sym__atoms,
    STATE(6137), 1,
      sym_atom,
    STATE(8096), 1,
      sym__LAMBDA,
    STATE(8497), 1,
      sym__FORALL,
    STATE(8978), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2490), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(5570), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6032), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6059), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(5550), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [378354] = 30,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(2694), 1,
      anon_sym_BSLASH,
    ACTIONS(2696), 1,
      anon_sym_u03bb,
    ACTIONS(2714), 1,
      anon_sym_quoteGoal,
    ACTIONS(2716), 1,
      anon_sym_tactic,
    ACTIONS(2722), 1,
      anon_sym_let,
    ACTIONS(5574), 1,
      sym_id,
    ACTIONS(5578), 1,
      anon_sym_record,
    ACTIONS(5580), 1,
      anon_sym_LPAREN,
    ACTIONS(5582), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(5584), 1,
      anon_sym_u2983,
    ACTIONS(5586), 1,
      anon_sym_LBRACE,
    ACTIONS(5588), 1,
      aux_sym__qid_token1,
    ACTIONS(5590), 1,
      anon_sym_DOT,
    ACTIONS(5592), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(5594), 1,
      anon_sym_u2987,
    ACTIONS(5598), 1,
      anon_sym_Set,
    STATE(3725), 1,
      aux_sym__with_exprs_repeat1,
    STATE(3797), 1,
      aux_sym__atoms,
    STATE(4408), 1,
      sym_atom,
    STATE(8133), 1,
      sym__LAMBDA,
    STATE(8368), 1,
      sym__FORALL,
    STATE(8939), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2692), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(5596), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4312), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4307), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(5576), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [378470] = 30,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(1302), 1,
      anon_sym_let,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(5224), 1,
      anon_sym_record,
    ACTIONS(5226), 1,
      anon_sym_LPAREN,
    ACTIONS(5228), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(5230), 1,
      anon_sym_u2983,
    ACTIONS(5232), 1,
      anon_sym_LBRACE,
    ACTIONS(5236), 1,
      anon_sym_DOT,
    ACTIONS(5238), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(5240), 1,
      anon_sym_u2987,
    ACTIONS(5244), 1,
      anon_sym_Set,
    ACTIONS(5600), 1,
      sym_id,
    ACTIONS(5602), 1,
      aux_sym__qid_token1,
    STATE(3428), 1,
      aux_sym__atoms,
    STATE(5875), 1,
      sym__qid,
    STATE(6203), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(5242), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6166), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6188), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(5222), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(12357), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [378586] = 30,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(1302), 1,
      anon_sym_let,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(5224), 1,
      anon_sym_record,
    ACTIONS(5226), 1,
      anon_sym_LPAREN,
    ACTIONS(5228), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(5230), 1,
      anon_sym_u2983,
    ACTIONS(5232), 1,
      anon_sym_LBRACE,
    ACTIONS(5236), 1,
      anon_sym_DOT,
    ACTIONS(5238), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(5240), 1,
      anon_sym_u2987,
    ACTIONS(5244), 1,
      anon_sym_Set,
    ACTIONS(5600), 1,
      sym_id,
    ACTIONS(5602), 1,
      aux_sym__qid_token1,
    STATE(3617), 1,
      aux_sym__atoms,
    STATE(5875), 1,
      sym__qid,
    STATE(6203), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(5242), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6166), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6188), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(5222), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(12358), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [378702] = 30,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(1302), 1,
      anon_sym_let,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(5224), 1,
      anon_sym_record,
    ACTIONS(5226), 1,
      anon_sym_LPAREN,
    ACTIONS(5228), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(5230), 1,
      anon_sym_u2983,
    ACTIONS(5232), 1,
      anon_sym_LBRACE,
    ACTIONS(5236), 1,
      anon_sym_DOT,
    ACTIONS(5238), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(5240), 1,
      anon_sym_u2987,
    ACTIONS(5244), 1,
      anon_sym_Set,
    ACTIONS(5600), 1,
      sym_id,
    ACTIONS(5602), 1,
      aux_sym__qid_token1,
    STATE(3550), 1,
      aux_sym__atoms,
    STATE(5875), 1,
      sym__qid,
    STATE(6203), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(5242), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6166), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6188), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(5222), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(12359), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [378818] = 30,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1916), 1,
      anon_sym_record,
    ACTIONS(1918), 1,
      anon_sym_LPAREN,
    ACTIONS(1920), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1922), 1,
      anon_sym_u2983,
    ACTIONS(1924), 1,
      anon_sym_LBRACE,
    ACTIONS(1932), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1934), 1,
      anon_sym_u2987,
    ACTIONS(2120), 1,
      anon_sym_quoteGoal,
    ACTIONS(2128), 1,
      anon_sym_let,
    ACTIONS(2176), 1,
      anon_sym_BSLASH,
    ACTIONS(2178), 1,
      anon_sym_u03bb,
    ACTIONS(2196), 1,
      anon_sym_tactic,
    ACTIONS(2606), 1,
      sym_id,
    ACTIONS(2608), 1,
      aux_sym__qid_token1,
    ACTIONS(2610), 1,
      anon_sym_DOT,
    ACTIONS(2612), 1,
      anon_sym_Set,
    STATE(1481), 1,
      sym__ARROW,
    STATE(4004), 1,
      aux_sym__atoms,
    STATE(4914), 1,
      sym_atom,
    STATE(8044), 1,
      sym__LAMBDA,
    STATE(8428), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1938), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(2096), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4302), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(4675), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4679), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8997), 7,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1914), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [378934] = 30,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2800), 1,
      anon_sym_quoteGoal,
    ACTIONS(2804), 1,
      anon_sym_let,
    ACTIONS(2810), 1,
      anon_sym_BSLASH,
    ACTIONS(2812), 1,
      anon_sym_u03bb,
    ACTIONS(2830), 1,
      anon_sym_tactic,
    ACTIONS(5604), 1,
      sym_id,
    ACTIONS(5608), 1,
      anon_sym_record,
    ACTIONS(5610), 1,
      anon_sym_LPAREN,
    ACTIONS(5612), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(5614), 1,
      anon_sym_u2983,
    ACTIONS(5616), 1,
      anon_sym_LBRACE,
    ACTIONS(5618), 1,
      aux_sym__qid_token1,
    ACTIONS(5620), 1,
      anon_sym_DOT,
    ACTIONS(5622), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(5624), 1,
      anon_sym_u2987,
    ACTIONS(5628), 1,
      anon_sym_Set,
    STATE(3713), 1,
      aux_sym__with_exprs_repeat1,
    STATE(3825), 1,
      aux_sym__atoms,
    STATE(6230), 1,
      sym_atom,
    STATE(8081), 1,
      sym__LAMBDA,
    STATE(8490), 1,
      sym__FORALL,
    STATE(8978), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2794), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(5626), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6226), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6214), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(5606), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [379050] = 31,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(1302), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(10521), 1,
      sym__binding_ids_and_absurds,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9776), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [379168] = 30,
    ACTIONS(710), 1,
      anon_sym_DASH,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(920), 1,
      anon_sym_quoteGoal,
    ACTIONS(928), 1,
      anon_sym_let,
    ACTIONS(3058), 1,
      anon_sym_BSLASH,
    ACTIONS(3060), 1,
      anon_sym_u03bb,
    ACTIONS(3064), 1,
      anon_sym_record,
    ACTIONS(3066), 1,
      anon_sym_LPAREN,
    ACTIONS(3068), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3070), 1,
      anon_sym_u2983,
    ACTIONS(3072), 1,
      anon_sym_LBRACE,
    ACTIONS(3076), 1,
      aux_sym__qid_token1,
    ACTIONS(3078), 1,
      anon_sym_DOT,
    ACTIONS(3080), 1,
      anon_sym_tactic,
    ACTIONS(3082), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3084), 1,
      anon_sym_u2987,
    ACTIONS(3088), 1,
      anon_sym_Set,
    ACTIONS(4220), 1,
      sym_id,
    STATE(3892), 1,
      aux_sym__atoms,
    STATE(6084), 1,
      sym__qid,
    STATE(6427), 1,
      sym_atom,
    STATE(8123), 1,
      sym__LAMBDA,
    STATE(8396), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3086), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6715), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6714), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3062), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10212), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [379284] = 30,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(964), 1,
      anon_sym_quoteGoal,
    ACTIONS(972), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4214), 1,
      anon_sym_BSLASH,
    ACTIONS(4216), 1,
      anon_sym_u03bb,
    ACTIONS(4218), 1,
      anon_sym_tactic,
    STATE(3891), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8047), 1,
      sym__LAMBDA,
    STATE(8355), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(942), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10169), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [379400] = 30,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(2732), 1,
      anon_sym_BSLASH,
    ACTIONS(2734), 1,
      anon_sym_u03bb,
    ACTIONS(2752), 1,
      anon_sym_quoteGoal,
    ACTIONS(2754), 1,
      anon_sym_tactic,
    ACTIONS(2760), 1,
      anon_sym_let,
    ACTIONS(5630), 1,
      sym_id,
    ACTIONS(5634), 1,
      anon_sym_record,
    ACTIONS(5636), 1,
      anon_sym_LPAREN,
    ACTIONS(5638), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(5640), 1,
      anon_sym_u2983,
    ACTIONS(5642), 1,
      anon_sym_LBRACE,
    ACTIONS(5644), 1,
      aux_sym__qid_token1,
    ACTIONS(5646), 1,
      anon_sym_DOT,
    ACTIONS(5648), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(5650), 1,
      anon_sym_u2987,
    ACTIONS(5654), 1,
      anon_sym_Set,
    STATE(3749), 1,
      aux_sym__with_exprs_repeat1,
    STATE(3864), 1,
      aux_sym__atoms,
    STATE(5368), 1,
      sym_atom,
    STATE(8061), 1,
      sym__LAMBDA,
    STATE(8384), 1,
      sym__FORALL,
    STATE(8939), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2730), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(5652), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5733), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5727), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(5632), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [379516] = 30,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(2570), 1,
      anon_sym_BSLASH,
    ACTIONS(2572), 1,
      anon_sym_u03bb,
    ACTIONS(2590), 1,
      anon_sym_quoteGoal,
    ACTIONS(2592), 1,
      anon_sym_tactic,
    ACTIONS(2598), 1,
      anon_sym_let,
    ACTIONS(5656), 1,
      sym_id,
    ACTIONS(5660), 1,
      anon_sym_record,
    ACTIONS(5662), 1,
      anon_sym_LPAREN,
    ACTIONS(5664), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(5666), 1,
      anon_sym_u2983,
    ACTIONS(5668), 1,
      anon_sym_LBRACE,
    ACTIONS(5670), 1,
      aux_sym__qid_token1,
    ACTIONS(5672), 1,
      anon_sym_DOT,
    ACTIONS(5674), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(5676), 1,
      anon_sym_u2987,
    ACTIONS(5680), 1,
      anon_sym_Set,
    STATE(3714), 1,
      aux_sym__with_exprs_repeat1,
    STATE(3817), 1,
      aux_sym__atoms,
    STATE(6281), 1,
      sym_atom,
    STATE(8111), 1,
      sym__LAMBDA,
    STATE(8412), 1,
      sym__FORALL,
    STATE(8939), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2568), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(5678), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6130), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6053), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(5658), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [379632] = 30,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(898), 1,
      anon_sym_BSLASH,
    ACTIONS(900), 1,
      anon_sym_u03bb,
    ACTIONS(920), 1,
      anon_sym_quoteGoal,
    ACTIONS(922), 1,
      anon_sym_tactic,
    ACTIONS(928), 1,
      anon_sym_let,
    ACTIONS(5682), 1,
      sym_id,
    ACTIONS(5686), 1,
      anon_sym_record,
    ACTIONS(5688), 1,
      anon_sym_LPAREN,
    ACTIONS(5690), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(5692), 1,
      anon_sym_u2983,
    ACTIONS(5694), 1,
      anon_sym_LBRACE,
    ACTIONS(5696), 1,
      aux_sym__qid_token1,
    ACTIONS(5698), 1,
      anon_sym_DOT,
    ACTIONS(5700), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(5702), 1,
      anon_sym_u2987,
    ACTIONS(5706), 1,
      anon_sym_Set,
    STATE(3718), 1,
      aux_sym__with_exprs_repeat1,
    STATE(3796), 1,
      aux_sym__atoms,
    STATE(5867), 1,
      sym_atom,
    STATE(8031), 1,
      sym__LAMBDA,
    STATE(8396), 1,
      sym__FORALL,
    STATE(9466), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(5704), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5924), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5925), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(5684), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [379748] = 30,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1928), 1,
      anon_sym_quoteGoal,
    ACTIONS(1936), 1,
      anon_sym_let,
    ACTIONS(2338), 1,
      anon_sym_BSLASH,
    ACTIONS(2340), 1,
      anon_sym_u03bb,
    ACTIONS(2344), 1,
      anon_sym_tactic,
    ACTIONS(5708), 1,
      sym_id,
    ACTIONS(5712), 1,
      anon_sym_record,
    ACTIONS(5714), 1,
      anon_sym_LPAREN,
    ACTIONS(5716), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(5718), 1,
      anon_sym_u2983,
    ACTIONS(5720), 1,
      anon_sym_LBRACE,
    ACTIONS(5722), 1,
      aux_sym__qid_token1,
    ACTIONS(5724), 1,
      anon_sym_DOT,
    ACTIONS(5726), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(5728), 1,
      anon_sym_u2987,
    ACTIONS(5732), 1,
      anon_sym_Set,
    STATE(3735), 1,
      aux_sym__with_exprs_repeat1,
    STATE(3800), 1,
      aux_sym__atoms,
    STATE(5512), 1,
      sym_atom,
    STATE(8079), 1,
      sym__LAMBDA,
    STATE(8431), 1,
      sym__FORALL,
    STATE(8978), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1906), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(5730), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5553), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5550), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(5710), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [379864] = 30,
    ACTIONS(710), 1,
      anon_sym_DASH,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(920), 1,
      anon_sym_quoteGoal,
    ACTIONS(928), 1,
      anon_sym_let,
    ACTIONS(3058), 1,
      anon_sym_BSLASH,
    ACTIONS(3060), 1,
      anon_sym_u03bb,
    ACTIONS(3064), 1,
      anon_sym_record,
    ACTIONS(3066), 1,
      anon_sym_LPAREN,
    ACTIONS(3068), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3070), 1,
      anon_sym_u2983,
    ACTIONS(3072), 1,
      anon_sym_LBRACE,
    ACTIONS(3076), 1,
      aux_sym__qid_token1,
    ACTIONS(3078), 1,
      anon_sym_DOT,
    ACTIONS(3080), 1,
      anon_sym_tactic,
    ACTIONS(3082), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3084), 1,
      anon_sym_u2987,
    ACTIONS(3088), 1,
      anon_sym_Set,
    ACTIONS(4220), 1,
      sym_id,
    STATE(3892), 1,
      aux_sym__atoms,
    STATE(6084), 1,
      sym__qid,
    STATE(6427), 1,
      sym_atom,
    STATE(8123), 1,
      sym__LAMBDA,
    STATE(8396), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3086), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6715), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6714), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3062), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10228), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [379980] = 30,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1984), 1,
      anon_sym_BSLASH,
    ACTIONS(1986), 1,
      anon_sym_u03bb,
    ACTIONS(2004), 1,
      anon_sym_quoteGoal,
    ACTIONS(2006), 1,
      anon_sym_tactic,
    ACTIONS(2012), 1,
      anon_sym_let,
    ACTIONS(5734), 1,
      sym_id,
    ACTIONS(5738), 1,
      anon_sym_record,
    ACTIONS(5740), 1,
      anon_sym_LPAREN,
    ACTIONS(5742), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(5744), 1,
      anon_sym_u2983,
    ACTIONS(5746), 1,
      anon_sym_LBRACE,
    ACTIONS(5748), 1,
      aux_sym__qid_token1,
    ACTIONS(5750), 1,
      anon_sym_DOT,
    ACTIONS(5752), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(5754), 1,
      anon_sym_u2987,
    ACTIONS(5758), 1,
      anon_sym_Set,
    STATE(3740), 1,
      aux_sym__with_exprs_repeat1,
    STATE(3844), 1,
      aux_sym__atoms,
    STATE(5950), 1,
      sym_atom,
    STATE(8039), 1,
      sym__LAMBDA,
    STATE(8483), 1,
      sym__FORALL,
    STATE(8978), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1982), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(5756), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5762), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5752), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(5736), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [380096] = 31,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(1302), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(11541), 1,
      sym__binding_ids_and_absurds,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(10085), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [380214] = 30,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(878), 1,
      anon_sym_quoteGoal,
    ACTIONS(886), 1,
      anon_sym_let,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(4182), 1,
      sym_id,
    ACTIONS(4184), 1,
      anon_sym_BSLASH,
    ACTIONS(4186), 1,
      anon_sym_u03bb,
    ACTIONS(4190), 1,
      anon_sym_record,
    ACTIONS(4192), 1,
      anon_sym_LPAREN,
    ACTIONS(4194), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4196), 1,
      anon_sym_u2983,
    ACTIONS(4198), 1,
      anon_sym_LBRACE,
    ACTIONS(4200), 1,
      aux_sym__qid_token1,
    ACTIONS(4202), 1,
      anon_sym_DOT,
    ACTIONS(4204), 1,
      anon_sym_tactic,
    ACTIONS(4206), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4208), 1,
      anon_sym_u2987,
    ACTIONS(4212), 1,
      anon_sym_Set,
    STATE(3888), 1,
      aux_sym__atoms,
    STATE(6121), 1,
      sym__qid,
    STATE(6386), 1,
      sym_atom,
    STATE(8067), 1,
      sym__LAMBDA,
    STATE(8369), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(852), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4210), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6575), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6565), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(4188), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10231), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [380330] = 30,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    ACTIONS(5760), 1,
      sym_id,
    ACTIONS(5764), 1,
      anon_sym_record,
    ACTIONS(5766), 1,
      anon_sym_LPAREN,
    ACTIONS(5768), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(5770), 1,
      anon_sym_u2983,
    ACTIONS(5772), 1,
      anon_sym_LBRACE,
    ACTIONS(5774), 1,
      aux_sym__qid_token1,
    ACTIONS(5776), 1,
      anon_sym_DOT,
    ACTIONS(5778), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(5780), 1,
      anon_sym_u2987,
    ACTIONS(5784), 1,
      anon_sym_Set,
    STATE(3745), 1,
      aux_sym__with_exprs_repeat1,
    STATE(3781), 1,
      aux_sym__atoms,
    STATE(5927), 1,
      sym_atom,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    STATE(8978), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(5782), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5941), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5965), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(5762), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [380446] = 30,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(964), 1,
      anon_sym_quoteGoal,
    ACTIONS(972), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4214), 1,
      anon_sym_BSLASH,
    ACTIONS(4216), 1,
      anon_sym_u03bb,
    ACTIONS(4218), 1,
      anon_sym_tactic,
    STATE(3891), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8047), 1,
      sym__LAMBDA,
    STATE(8355), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(942), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9802), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [380562] = 30,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(964), 1,
      anon_sym_quoteGoal,
    ACTIONS(972), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4214), 1,
      anon_sym_BSLASH,
    ACTIONS(4216), 1,
      anon_sym_u03bb,
    ACTIONS(4218), 1,
      anon_sym_tactic,
    STATE(3891), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8047), 1,
      sym__LAMBDA,
    STATE(8355), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(942), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10036), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [380678] = 31,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(1302), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(11013), 1,
      sym__binding_ids_and_absurds,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9778), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [380796] = 30,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(964), 1,
      anon_sym_quoteGoal,
    ACTIONS(972), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4214), 1,
      anon_sym_BSLASH,
    ACTIONS(4216), 1,
      anon_sym_u03bb,
    ACTIONS(4218), 1,
      anon_sym_tactic,
    STATE(3891), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8047), 1,
      sym__LAMBDA,
    STATE(8355), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(942), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9699), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [380912] = 31,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(1302), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(10716), 1,
      sym__binding_ids_and_absurds,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9736), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [381030] = 30,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(878), 1,
      anon_sym_quoteGoal,
    ACTIONS(886), 1,
      anon_sym_let,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(4182), 1,
      sym_id,
    ACTIONS(4184), 1,
      anon_sym_BSLASH,
    ACTIONS(4186), 1,
      anon_sym_u03bb,
    ACTIONS(4190), 1,
      anon_sym_record,
    ACTIONS(4192), 1,
      anon_sym_LPAREN,
    ACTIONS(4194), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4196), 1,
      anon_sym_u2983,
    ACTIONS(4198), 1,
      anon_sym_LBRACE,
    ACTIONS(4200), 1,
      aux_sym__qid_token1,
    ACTIONS(4202), 1,
      anon_sym_DOT,
    ACTIONS(4204), 1,
      anon_sym_tactic,
    ACTIONS(4206), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4208), 1,
      anon_sym_u2987,
    ACTIONS(4212), 1,
      anon_sym_Set,
    STATE(3888), 1,
      aux_sym__atoms,
    STATE(6121), 1,
      sym__qid,
    STATE(6386), 1,
      sym_atom,
    STATE(8067), 1,
      sym__LAMBDA,
    STATE(8369), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(852), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4210), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6575), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6565), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(4188), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9695), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [381146] = 30,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(878), 1,
      anon_sym_quoteGoal,
    ACTIONS(886), 1,
      anon_sym_let,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(4182), 1,
      sym_id,
    ACTIONS(4184), 1,
      anon_sym_BSLASH,
    ACTIONS(4186), 1,
      anon_sym_u03bb,
    ACTIONS(4190), 1,
      anon_sym_record,
    ACTIONS(4192), 1,
      anon_sym_LPAREN,
    ACTIONS(4194), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4196), 1,
      anon_sym_u2983,
    ACTIONS(4198), 1,
      anon_sym_LBRACE,
    ACTIONS(4200), 1,
      aux_sym__qid_token1,
    ACTIONS(4202), 1,
      anon_sym_DOT,
    ACTIONS(4204), 1,
      anon_sym_tactic,
    ACTIONS(4206), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4208), 1,
      anon_sym_u2987,
    ACTIONS(4212), 1,
      anon_sym_Set,
    STATE(3888), 1,
      aux_sym__atoms,
    STATE(6121), 1,
      sym__qid,
    STATE(6386), 1,
      sym_atom,
    STATE(8067), 1,
      sym__LAMBDA,
    STATE(8369), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(852), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4210), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6575), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6565), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(4188), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9894), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [381262] = 30,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2422), 1,
      sym_id,
    ACTIONS(2428), 1,
      anon_sym_BSLASH,
    ACTIONS(2430), 1,
      anon_sym_u03bb,
    ACTIONS(2434), 1,
      anon_sym_record,
    ACTIONS(2436), 1,
      anon_sym_LPAREN,
    ACTIONS(2438), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2440), 1,
      anon_sym_u2983,
    ACTIONS(2442), 1,
      anon_sym_LBRACE,
    ACTIONS(2444), 1,
      aux_sym__qid_token1,
    ACTIONS(2446), 1,
      anon_sym_DOT,
    ACTIONS(2448), 1,
      anon_sym_quoteGoal,
    ACTIONS(2450), 1,
      anon_sym_tactic,
    ACTIONS(2452), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2454), 1,
      anon_sym_u2987,
    ACTIONS(2456), 1,
      anon_sym_let,
    ACTIONS(2460), 1,
      anon_sym_Set,
    STATE(1774), 1,
      sym__ARROW,
    STATE(4004), 1,
      aux_sym__atoms,
    STATE(5596), 1,
      sym_atom,
    STATE(8125), 1,
      sym__LAMBDA,
    STATE(8423), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2424), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2458), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(5786), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(5422), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5423), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8997), 7,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2432), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [381378] = 30,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(964), 1,
      anon_sym_quoteGoal,
    ACTIONS(972), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4214), 1,
      anon_sym_BSLASH,
    ACTIONS(4216), 1,
      anon_sym_u03bb,
    ACTIONS(4218), 1,
      anon_sym_tactic,
    STATE(3891), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8047), 1,
      sym__LAMBDA,
    STATE(8355), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(942), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10021), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [381494] = 30,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(878), 1,
      anon_sym_quoteGoal,
    ACTIONS(886), 1,
      anon_sym_let,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(4182), 1,
      sym_id,
    ACTIONS(4184), 1,
      anon_sym_BSLASH,
    ACTIONS(4186), 1,
      anon_sym_u03bb,
    ACTIONS(4190), 1,
      anon_sym_record,
    ACTIONS(4192), 1,
      anon_sym_LPAREN,
    ACTIONS(4194), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4196), 1,
      anon_sym_u2983,
    ACTIONS(4198), 1,
      anon_sym_LBRACE,
    ACTIONS(4200), 1,
      aux_sym__qid_token1,
    ACTIONS(4202), 1,
      anon_sym_DOT,
    ACTIONS(4204), 1,
      anon_sym_tactic,
    ACTIONS(4206), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4208), 1,
      anon_sym_u2987,
    ACTIONS(4212), 1,
      anon_sym_Set,
    STATE(3888), 1,
      aux_sym__atoms,
    STATE(6121), 1,
      sym__qid,
    STATE(6386), 1,
      sym_atom,
    STATE(8067), 1,
      sym__LAMBDA,
    STATE(8369), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(852), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4210), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6575), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6565), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(4188), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10213), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [381610] = 31,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(1302), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(11376), 1,
      sym__binding_ids_and_absurds,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9980), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [381728] = 30,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(878), 1,
      anon_sym_quoteGoal,
    ACTIONS(886), 1,
      anon_sym_let,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(4182), 1,
      sym_id,
    ACTIONS(4184), 1,
      anon_sym_BSLASH,
    ACTIONS(4186), 1,
      anon_sym_u03bb,
    ACTIONS(4190), 1,
      anon_sym_record,
    ACTIONS(4192), 1,
      anon_sym_LPAREN,
    ACTIONS(4194), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4196), 1,
      anon_sym_u2983,
    ACTIONS(4198), 1,
      anon_sym_LBRACE,
    ACTIONS(4200), 1,
      aux_sym__qid_token1,
    ACTIONS(4202), 1,
      anon_sym_DOT,
    ACTIONS(4204), 1,
      anon_sym_tactic,
    ACTIONS(4206), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4208), 1,
      anon_sym_u2987,
    ACTIONS(4212), 1,
      anon_sym_Set,
    STATE(3888), 1,
      aux_sym__atoms,
    STATE(6121), 1,
      sym__qid,
    STATE(6386), 1,
      sym_atom,
    STATE(8067), 1,
      sym__LAMBDA,
    STATE(8369), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(852), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4210), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6575), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6565), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(4188), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10020), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [381844] = 30,
    ACTIONS(710), 1,
      anon_sym_DASH,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(920), 1,
      anon_sym_quoteGoal,
    ACTIONS(928), 1,
      anon_sym_let,
    ACTIONS(3058), 1,
      anon_sym_BSLASH,
    ACTIONS(3060), 1,
      anon_sym_u03bb,
    ACTIONS(3064), 1,
      anon_sym_record,
    ACTIONS(3066), 1,
      anon_sym_LPAREN,
    ACTIONS(3068), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3070), 1,
      anon_sym_u2983,
    ACTIONS(3072), 1,
      anon_sym_LBRACE,
    ACTIONS(3076), 1,
      aux_sym__qid_token1,
    ACTIONS(3078), 1,
      anon_sym_DOT,
    ACTIONS(3080), 1,
      anon_sym_tactic,
    ACTIONS(3082), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3084), 1,
      anon_sym_u2987,
    ACTIONS(3088), 1,
      anon_sym_Set,
    ACTIONS(4220), 1,
      sym_id,
    STATE(3892), 1,
      aux_sym__atoms,
    STATE(6084), 1,
      sym__qid,
    STATE(6427), 1,
      sym_atom,
    STATE(8123), 1,
      sym__LAMBDA,
    STATE(8396), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3086), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6715), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6714), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3062), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9702), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [381960] = 30,
    ACTIONS(710), 1,
      anon_sym_DASH,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(920), 1,
      anon_sym_quoteGoal,
    ACTIONS(928), 1,
      anon_sym_let,
    ACTIONS(3058), 1,
      anon_sym_BSLASH,
    ACTIONS(3060), 1,
      anon_sym_u03bb,
    ACTIONS(3064), 1,
      anon_sym_record,
    ACTIONS(3066), 1,
      anon_sym_LPAREN,
    ACTIONS(3068), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3070), 1,
      anon_sym_u2983,
    ACTIONS(3072), 1,
      anon_sym_LBRACE,
    ACTIONS(3076), 1,
      aux_sym__qid_token1,
    ACTIONS(3078), 1,
      anon_sym_DOT,
    ACTIONS(3080), 1,
      anon_sym_tactic,
    ACTIONS(3082), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3084), 1,
      anon_sym_u2987,
    ACTIONS(3088), 1,
      anon_sym_Set,
    ACTIONS(4220), 1,
      sym_id,
    STATE(3892), 1,
      aux_sym__atoms,
    STATE(6084), 1,
      sym__qid,
    STATE(6427), 1,
      sym_atom,
    STATE(8123), 1,
      sym__LAMBDA,
    STATE(8396), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3086), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6715), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6714), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3062), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9747), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [382076] = 30,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(964), 1,
      anon_sym_quoteGoal,
    ACTIONS(972), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4214), 1,
      anon_sym_BSLASH,
    ACTIONS(4216), 1,
      anon_sym_u03bb,
    ACTIONS(4218), 1,
      anon_sym_tactic,
    STATE(3891), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8047), 1,
      sym__LAMBDA,
    STATE(8355), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(942), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10217), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [382192] = 30,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(878), 1,
      anon_sym_quoteGoal,
    ACTIONS(886), 1,
      anon_sym_let,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(4182), 1,
      sym_id,
    ACTIONS(4184), 1,
      anon_sym_BSLASH,
    ACTIONS(4186), 1,
      anon_sym_u03bb,
    ACTIONS(4190), 1,
      anon_sym_record,
    ACTIONS(4192), 1,
      anon_sym_LPAREN,
    ACTIONS(4194), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4196), 1,
      anon_sym_u2983,
    ACTIONS(4198), 1,
      anon_sym_LBRACE,
    ACTIONS(4200), 1,
      aux_sym__qid_token1,
    ACTIONS(4202), 1,
      anon_sym_DOT,
    ACTIONS(4204), 1,
      anon_sym_tactic,
    ACTIONS(4206), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4208), 1,
      anon_sym_u2987,
    ACTIONS(4212), 1,
      anon_sym_Set,
    STATE(3888), 1,
      aux_sym__atoms,
    STATE(6121), 1,
      sym__qid,
    STATE(6386), 1,
      sym_atom,
    STATE(8067), 1,
      sym__LAMBDA,
    STATE(8369), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(852), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4210), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6575), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6565), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(4188), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9745), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [382308] = 30,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(964), 1,
      anon_sym_quoteGoal,
    ACTIONS(972), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4214), 1,
      anon_sym_BSLASH,
    ACTIONS(4216), 1,
      anon_sym_u03bb,
    ACTIONS(4218), 1,
      anon_sym_tactic,
    STATE(3891), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8047), 1,
      sym__LAMBDA,
    STATE(8355), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(942), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9744), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [382424] = 31,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(1302), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(10903), 1,
      sym__binding_ids_and_absurds,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9724), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [382542] = 31,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(1302), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(11449), 1,
      sym__binding_ids_and_absurds,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(10008), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [382660] = 30,
    ACTIONS(710), 1,
      anon_sym_DASH,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(920), 1,
      anon_sym_quoteGoal,
    ACTIONS(928), 1,
      anon_sym_let,
    ACTIONS(3058), 1,
      anon_sym_BSLASH,
    ACTIONS(3060), 1,
      anon_sym_u03bb,
    ACTIONS(3064), 1,
      anon_sym_record,
    ACTIONS(3066), 1,
      anon_sym_LPAREN,
    ACTIONS(3068), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3070), 1,
      anon_sym_u2983,
    ACTIONS(3072), 1,
      anon_sym_LBRACE,
    ACTIONS(3076), 1,
      aux_sym__qid_token1,
    ACTIONS(3078), 1,
      anon_sym_DOT,
    ACTIONS(3080), 1,
      anon_sym_tactic,
    ACTIONS(3082), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3084), 1,
      anon_sym_u2987,
    ACTIONS(3088), 1,
      anon_sym_Set,
    ACTIONS(4220), 1,
      sym_id,
    STATE(3892), 1,
      aux_sym__atoms,
    STATE(6084), 1,
      sym__qid,
    STATE(6427), 1,
      sym_atom,
    STATE(8123), 1,
      sym__LAMBDA,
    STATE(8396), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3086), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6715), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6714), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3062), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10019), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [382776] = 30,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(964), 1,
      anon_sym_quoteGoal,
    ACTIONS(972), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4214), 1,
      anon_sym_BSLASH,
    ACTIONS(4216), 1,
      anon_sym_u03bb,
    ACTIONS(4218), 1,
      anon_sym_tactic,
    STATE(3891), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8047), 1,
      sym__LAMBDA,
    STATE(8355), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(942), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9896), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [382892] = 30,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(2964), 1,
      anon_sym_quoteGoal,
    ACTIONS(2972), 1,
      anon_sym_let,
    ACTIONS(3520), 1,
      sym_id,
    ACTIONS(3522), 1,
      anon_sym_BSLASH,
    ACTIONS(3524), 1,
      anon_sym_u03bb,
    ACTIONS(3528), 1,
      anon_sym_record,
    ACTIONS(3530), 1,
      anon_sym_LPAREN,
    ACTIONS(3532), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3534), 1,
      anon_sym_u2983,
    ACTIONS(3536), 1,
      anon_sym_LBRACE,
    ACTIONS(3538), 1,
      aux_sym__qid_token1,
    ACTIONS(3540), 1,
      anon_sym_DOT,
    ACTIONS(3542), 1,
      anon_sym_tactic,
    ACTIONS(3544), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3546), 1,
      anon_sym_u2987,
    ACTIONS(3550), 1,
      anon_sym_Set,
    STATE(2421), 1,
      sym__ARROW,
    STATE(4004), 1,
      aux_sym__atoms,
    STATE(5625), 1,
      sym_atom,
    STATE(8058), 1,
      sym__LAMBDA,
    STATE(8418), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2940), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3548), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(5520), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(5537), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5538), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9001), 7,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3526), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [383008] = 30,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(2982), 1,
      anon_sym_BSLASH,
    ACTIONS(2984), 1,
      anon_sym_u03bb,
    ACTIONS(3002), 1,
      anon_sym_quoteGoal,
    ACTIONS(3004), 1,
      anon_sym_tactic,
    ACTIONS(3010), 1,
      anon_sym_let,
    ACTIONS(5788), 1,
      sym_id,
    ACTIONS(5792), 1,
      anon_sym_record,
    ACTIONS(5794), 1,
      anon_sym_LPAREN,
    ACTIONS(5796), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(5798), 1,
      anon_sym_u2983,
    ACTIONS(5800), 1,
      anon_sym_LBRACE,
    ACTIONS(5802), 1,
      aux_sym__qid_token1,
    ACTIONS(5804), 1,
      anon_sym_DOT,
    ACTIONS(5806), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(5808), 1,
      anon_sym_u2987,
    ACTIONS(5812), 1,
      anon_sym_Set,
    STATE(3737), 1,
      aux_sym__with_exprs_repeat1,
    STATE(3804), 1,
      aux_sym__atoms,
    STATE(4924), 1,
      sym_atom,
    STATE(8117), 1,
      sym__LAMBDA,
    STATE(8511), 1,
      sym__FORALL,
    STATE(8939), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(5810), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5245), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5235), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(5790), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [383124] = 30,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(3486), 1,
      anon_sym_BSLASH,
    ACTIONS(3488), 1,
      anon_sym_u03bb,
    ACTIONS(3506), 1,
      anon_sym_quoteGoal,
    ACTIONS(3508), 1,
      anon_sym_tactic,
    ACTIONS(3514), 1,
      anon_sym_let,
    ACTIONS(5814), 1,
      sym_id,
    ACTIONS(5818), 1,
      anon_sym_record,
    ACTIONS(5820), 1,
      anon_sym_LPAREN,
    ACTIONS(5822), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(5824), 1,
      anon_sym_u2983,
    ACTIONS(5826), 1,
      anon_sym_LBRACE,
    ACTIONS(5828), 1,
      aux_sym__qid_token1,
    ACTIONS(5830), 1,
      anon_sym_DOT,
    ACTIONS(5832), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(5834), 1,
      anon_sym_u2987,
    ACTIONS(5838), 1,
      anon_sym_Set,
    STATE(3736), 1,
      aux_sym__with_exprs_repeat1,
    STATE(3767), 1,
      aux_sym__atoms,
    STATE(4780), 1,
      sym_atom,
    STATE(8140), 1,
      sym__LAMBDA,
    STATE(8504), 1,
      sym__FORALL,
    STATE(9092), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3484), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(5836), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4860), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4868), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(5816), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [383240] = 31,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(1302), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(10255), 1,
      sym__binding_ids_and_absurds,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9845), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [383358] = 30,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(2938), 1,
      sym_id,
    ACTIONS(2944), 1,
      anon_sym_BSLASH,
    ACTIONS(2946), 1,
      anon_sym_u03bb,
    ACTIONS(2950), 1,
      anon_sym_record,
    ACTIONS(2952), 1,
      anon_sym_LPAREN,
    ACTIONS(2954), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2956), 1,
      anon_sym_u2983,
    ACTIONS(2958), 1,
      anon_sym_LBRACE,
    ACTIONS(2960), 1,
      aux_sym__qid_token1,
    ACTIONS(2962), 1,
      anon_sym_DOT,
    ACTIONS(2964), 1,
      anon_sym_quoteGoal,
    ACTIONS(2966), 1,
      anon_sym_tactic,
    ACTIONS(2968), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2970), 1,
      anon_sym_u2987,
    ACTIONS(2972), 1,
      anon_sym_let,
    ACTIONS(2976), 1,
      anon_sym_Set,
    STATE(2434), 1,
      sym__ARROW,
    STATE(4004), 1,
      aux_sym__atoms,
    STATE(5967), 1,
      sym_atom,
    STATE(8126), 1,
      sym__LAMBDA,
    STATE(8418), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2940), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2974), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(4534), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(5870), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5838), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9001), 7,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2948), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [383474] = 30,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(964), 1,
      anon_sym_quoteGoal,
    ACTIONS(972), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4214), 1,
      anon_sym_BSLASH,
    ACTIONS(4216), 1,
      anon_sym_u03bb,
    ACTIONS(4218), 1,
      anon_sym_tactic,
    STATE(3891), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8047), 1,
      sym__LAMBDA,
    STATE(8355), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(942), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10014), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [383590] = 30,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(878), 1,
      anon_sym_quoteGoal,
    ACTIONS(886), 1,
      anon_sym_let,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(4182), 1,
      sym_id,
    ACTIONS(4184), 1,
      anon_sym_BSLASH,
    ACTIONS(4186), 1,
      anon_sym_u03bb,
    ACTIONS(4190), 1,
      anon_sym_record,
    ACTIONS(4192), 1,
      anon_sym_LPAREN,
    ACTIONS(4194), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4196), 1,
      anon_sym_u2983,
    ACTIONS(4198), 1,
      anon_sym_LBRACE,
    ACTIONS(4200), 1,
      aux_sym__qid_token1,
    ACTIONS(4202), 1,
      anon_sym_DOT,
    ACTIONS(4204), 1,
      anon_sym_tactic,
    ACTIONS(4206), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4208), 1,
      anon_sym_u2987,
    ACTIONS(4212), 1,
      anon_sym_Set,
    STATE(3888), 1,
      aux_sym__atoms,
    STATE(6121), 1,
      sym__qid,
    STATE(6386), 1,
      sym_atom,
    STATE(8067), 1,
      sym__LAMBDA,
    STATE(8369), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(852), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4210), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6575), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6565), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(4188), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10013), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [383706] = 3,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(394), 2,
      ts_builtin_sym_end,
      anon_sym_BSLASH,
    ACTIONS(4240), 52,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_field,
      anon_sym_instance,
      anon_sym_module,
      anon_sym_data,
      anon_sym_codata,
      anon_sym_record,
      anon_sym_infix,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_variable,
      anon_sym_mutual,
      anon_sym_abstract,
      anon_sym_private,
      anon_sym_macro,
      anon_sym_postulate,
      anon_sym_primitive,
      anon_sym_open,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      sym_pragma,
      anon_sym_syntax,
      anon_sym_LBRACE,
      anon_sym_pattern,
      anon_sym_unquoteDecl,
      anon_sym_unquoteDef,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_AT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [383768] = 30,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(1302), 1,
      anon_sym_let,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(5218), 1,
      sym_id,
    ACTIONS(5224), 1,
      anon_sym_record,
    ACTIONS(5226), 1,
      anon_sym_LPAREN,
    ACTIONS(5228), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(5230), 1,
      anon_sym_u2983,
    ACTIONS(5232), 1,
      anon_sym_LBRACE,
    ACTIONS(5234), 1,
      aux_sym__qid_token1,
    ACTIONS(5236), 1,
      anon_sym_DOT,
    ACTIONS(5238), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(5240), 1,
      anon_sym_u2987,
    ACTIONS(5244), 1,
      anon_sym_Set,
    STATE(1846), 1,
      sym__ARROW,
    STATE(4004), 1,
      aux_sym__atoms,
    STATE(6203), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(5242), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(5840), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(6166), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6188), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8997), 7,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(5222), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [383884] = 30,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(2526), 1,
      sym_id,
    ACTIONS(2532), 1,
      anon_sym_BSLASH,
    ACTIONS(2534), 1,
      anon_sym_u03bb,
    ACTIONS(2538), 1,
      anon_sym_record,
    ACTIONS(2540), 1,
      anon_sym_LPAREN,
    ACTIONS(2542), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2544), 1,
      anon_sym_u2983,
    ACTIONS(2546), 1,
      anon_sym_LBRACE,
    ACTIONS(2548), 1,
      aux_sym__qid_token1,
    ACTIONS(2550), 1,
      anon_sym_DOT,
    ACTIONS(2552), 1,
      anon_sym_quoteGoal,
    ACTIONS(2554), 1,
      anon_sym_tactic,
    ACTIONS(2556), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2558), 1,
      anon_sym_u2987,
    ACTIONS(2560), 1,
      anon_sym_let,
    ACTIONS(2564), 1,
      anon_sym_Set,
    STATE(1910), 1,
      sym__ARROW,
    STATE(4004), 1,
      aux_sym__atoms,
    STATE(4603), 1,
      sym_atom,
    STATE(8066), 1,
      sym__LAMBDA,
    STATE(8398), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2528), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2562), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(5842), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(4464), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4473), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9001), 7,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2536), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [384000] = 30,
    ACTIONS(710), 1,
      anon_sym_DASH,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(920), 1,
      anon_sym_quoteGoal,
    ACTIONS(928), 1,
      anon_sym_let,
    ACTIONS(3058), 1,
      anon_sym_BSLASH,
    ACTIONS(3060), 1,
      anon_sym_u03bb,
    ACTIONS(3064), 1,
      anon_sym_record,
    ACTIONS(3066), 1,
      anon_sym_LPAREN,
    ACTIONS(3068), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3070), 1,
      anon_sym_u2983,
    ACTIONS(3072), 1,
      anon_sym_LBRACE,
    ACTIONS(3076), 1,
      aux_sym__qid_token1,
    ACTIONS(3078), 1,
      anon_sym_DOT,
    ACTIONS(3080), 1,
      anon_sym_tactic,
    ACTIONS(3082), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3084), 1,
      anon_sym_u2987,
    ACTIONS(3088), 1,
      anon_sym_Set,
    ACTIONS(4220), 1,
      sym_id,
    STATE(3892), 1,
      aux_sym__atoms,
    STATE(6084), 1,
      sym__qid,
    STATE(6427), 1,
      sym_atom,
    STATE(8123), 1,
      sym__LAMBDA,
    STATE(8396), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3086), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6715), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6714), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3062), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10011), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [384116] = 30,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(3168), 1,
      sym_id,
    ACTIONS(3174), 1,
      anon_sym_BSLASH,
    ACTIONS(3176), 1,
      anon_sym_u03bb,
    ACTIONS(3180), 1,
      anon_sym_record,
    ACTIONS(3182), 1,
      anon_sym_LPAREN,
    ACTIONS(3184), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3186), 1,
      anon_sym_u2983,
    ACTIONS(3188), 1,
      anon_sym_LBRACE,
    ACTIONS(3190), 1,
      aux_sym__qid_token1,
    ACTIONS(3192), 1,
      anon_sym_DOT,
    ACTIONS(3194), 1,
      anon_sym_quoteGoal,
    ACTIONS(3196), 1,
      anon_sym_tactic,
    ACTIONS(3198), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3200), 1,
      anon_sym_u2987,
    ACTIONS(3202), 1,
      anon_sym_let,
    ACTIONS(3206), 1,
      anon_sym_Set,
    STATE(2263), 1,
      sym__ARROW,
    STATE(4004), 1,
      aux_sym__atoms,
    STATE(5142), 1,
      sym_atom,
    STATE(8051), 1,
      sym__LAMBDA,
    STATE(8409), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3170), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3204), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(4636), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(4934), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4921), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9001), 7,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3178), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [384232] = 30,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(2694), 1,
      anon_sym_BSLASH,
    ACTIONS(2696), 1,
      anon_sym_u03bb,
    ACTIONS(2714), 1,
      anon_sym_quoteGoal,
    ACTIONS(2716), 1,
      anon_sym_tactic,
    ACTIONS(2722), 1,
      anon_sym_let,
    ACTIONS(3878), 1,
      sym_id,
    ACTIONS(3884), 1,
      anon_sym_record,
    ACTIONS(3886), 1,
      anon_sym_LPAREN,
    ACTIONS(3888), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3890), 1,
      anon_sym_u2983,
    ACTIONS(3892), 1,
      anon_sym_LBRACE,
    ACTIONS(3894), 1,
      aux_sym__qid_token1,
    ACTIONS(3896), 1,
      anon_sym_DOT,
    ACTIONS(3898), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3900), 1,
      anon_sym_u2987,
    ACTIONS(3904), 1,
      anon_sym_Set,
    STATE(1610), 1,
      sym__ARROW,
    STATE(4004), 1,
      aux_sym__atoms,
    STATE(4243), 1,
      sym_atom,
    STATE(8133), 1,
      sym__LAMBDA,
    STATE(8368), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2692), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3902), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(4826), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(4214), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4218), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9001), 7,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3882), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [384348] = 31,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(1302), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(11270), 1,
      sym__binding_ids_and_absurds,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9906), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [384466] = 30,
    ACTIONS(710), 1,
      anon_sym_DASH,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(920), 1,
      anon_sym_quoteGoal,
    ACTIONS(928), 1,
      anon_sym_let,
    ACTIONS(3058), 1,
      anon_sym_BSLASH,
    ACTIONS(3060), 1,
      anon_sym_u03bb,
    ACTIONS(3064), 1,
      anon_sym_record,
    ACTIONS(3066), 1,
      anon_sym_LPAREN,
    ACTIONS(3068), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3070), 1,
      anon_sym_u2983,
    ACTIONS(3072), 1,
      anon_sym_LBRACE,
    ACTIONS(3076), 1,
      aux_sym__qid_token1,
    ACTIONS(3078), 1,
      anon_sym_DOT,
    ACTIONS(3080), 1,
      anon_sym_tactic,
    ACTIONS(3082), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3084), 1,
      anon_sym_u2987,
    ACTIONS(3088), 1,
      anon_sym_Set,
    ACTIONS(4220), 1,
      sym_id,
    STATE(3892), 1,
      aux_sym__atoms,
    STATE(6084), 1,
      sym__qid,
    STATE(6427), 1,
      sym_atom,
    STATE(8123), 1,
      sym__LAMBDA,
    STATE(8396), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3086), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6715), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6714), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3062), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9804), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [384582] = 31,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(1302), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(11165), 1,
      sym__binding_ids_and_absurds,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9851), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [384700] = 30,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(964), 1,
      anon_sym_quoteGoal,
    ACTIONS(972), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4214), 1,
      anon_sym_BSLASH,
    ACTIONS(4216), 1,
      anon_sym_u03bb,
    ACTIONS(4218), 1,
      anon_sym_tactic,
    STATE(3891), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8047), 1,
      sym__LAMBDA,
    STATE(8355), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(942), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9825), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [384816] = 30,
    ACTIONS(710), 1,
      anon_sym_DASH,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(920), 1,
      anon_sym_quoteGoal,
    ACTIONS(928), 1,
      anon_sym_let,
    ACTIONS(3058), 1,
      anon_sym_BSLASH,
    ACTIONS(3060), 1,
      anon_sym_u03bb,
    ACTIONS(3064), 1,
      anon_sym_record,
    ACTIONS(3066), 1,
      anon_sym_LPAREN,
    ACTIONS(3068), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3070), 1,
      anon_sym_u2983,
    ACTIONS(3072), 1,
      anon_sym_LBRACE,
    ACTIONS(3076), 1,
      aux_sym__qid_token1,
    ACTIONS(3078), 1,
      anon_sym_DOT,
    ACTIONS(3080), 1,
      anon_sym_tactic,
    ACTIONS(3082), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3084), 1,
      anon_sym_u2987,
    ACTIONS(3088), 1,
      anon_sym_Set,
    ACTIONS(4220), 1,
      sym_id,
    STATE(3892), 1,
      aux_sym__atoms,
    STATE(6084), 1,
      sym__qid,
    STATE(6427), 1,
      sym_atom,
    STATE(8123), 1,
      sym__LAMBDA,
    STATE(8396), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3086), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6715), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6714), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3062), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9871), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [384932] = 30,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(2656), 1,
      anon_sym_BSLASH,
    ACTIONS(2658), 1,
      anon_sym_u03bb,
    ACTIONS(2676), 1,
      anon_sym_quoteGoal,
    ACTIONS(2678), 1,
      anon_sym_tactic,
    ACTIONS(2684), 1,
      anon_sym_let,
    ACTIONS(3208), 1,
      sym_id,
    ACTIONS(3212), 1,
      anon_sym_record,
    ACTIONS(3214), 1,
      anon_sym_LPAREN,
    ACTIONS(3216), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3218), 1,
      anon_sym_u2983,
    ACTIONS(3220), 1,
      anon_sym_LBRACE,
    ACTIONS(3222), 1,
      aux_sym__qid_token1,
    ACTIONS(3224), 1,
      anon_sym_DOT,
    ACTIONS(3226), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3228), 1,
      anon_sym_u2987,
    ACTIONS(3232), 1,
      anon_sym_Set,
    STATE(2295), 1,
      sym__ARROW,
    STATE(4004), 1,
      aux_sym__atoms,
    STATE(5433), 1,
      sym_atom,
    STATE(8132), 1,
      sym__LAMBDA,
    STATE(8470), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2654), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3230), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(5274), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(5579), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5582), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9454), 7,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3210), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [385048] = 30,
    ACTIONS(686), 1,
      anon_sym_BSLASH,
    ACTIONS(688), 1,
      anon_sym_u03bb,
    ACTIONS(692), 1,
      anon_sym_record,
    ACTIONS(694), 1,
      anon_sym_LPAREN,
    ACTIONS(696), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(698), 1,
      anon_sym_u2983,
    ACTIONS(702), 1,
      anon_sym_LBRACE,
    ACTIONS(708), 1,
      anon_sym_DOT,
    ACTIONS(714), 1,
      anon_sym_quoteGoal,
    ACTIONS(716), 1,
      anon_sym_tactic,
    ACTIONS(718), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(720), 1,
      anon_sym_u2987,
    ACTIONS(722), 1,
      anon_sym_let,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(728), 1,
      anon_sym_Set,
    ACTIONS(2336), 1,
      sym_id,
    ACTIONS(2342), 1,
      aux_sym__qid_token1,
    STATE(2347), 1,
      sym__ARROW,
    STATE(4004), 1,
      aux_sym__atoms,
    STATE(5128), 1,
      sym_atom,
    STATE(8064), 1,
      sym__LAMBDA,
    STATE(8495), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(682), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(726), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(4536), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(5069), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5056), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9454), 7,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(690), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [385164] = 31,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(1302), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(10635), 1,
      sym__binding_ids_and_absurds,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9751), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [385282] = 30,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2796), 1,
      anon_sym_BSLASH,
    ACTIONS(2798), 1,
      anon_sym_u03bb,
    ACTIONS(2800), 1,
      anon_sym_quoteGoal,
    ACTIONS(2802), 1,
      anon_sym_tactic,
    ACTIONS(2804), 1,
      anon_sym_let,
    ACTIONS(3380), 1,
      sym_id,
    ACTIONS(3384), 1,
      anon_sym_record,
    ACTIONS(3386), 1,
      anon_sym_LPAREN,
    ACTIONS(3388), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3390), 1,
      anon_sym_u2983,
    ACTIONS(3392), 1,
      anon_sym_LBRACE,
    ACTIONS(3394), 1,
      aux_sym__qid_token1,
    ACTIONS(3396), 1,
      anon_sym_DOT,
    ACTIONS(3398), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3400), 1,
      anon_sym_u2987,
    ACTIONS(3404), 1,
      anon_sym_Set,
    STATE(2135), 1,
      sym__ARROW,
    STATE(4004), 1,
      aux_sym__atoms,
    STATE(5099), 1,
      sym_atom,
    STATE(8041), 1,
      sym__LAMBDA,
    STATE(8490), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2794), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3402), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(5304), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(4937), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4939), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8997), 7,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3382), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [385398] = 30,
    ACTIONS(710), 1,
      anon_sym_DASH,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(920), 1,
      anon_sym_quoteGoal,
    ACTIONS(928), 1,
      anon_sym_let,
    ACTIONS(3058), 1,
      anon_sym_BSLASH,
    ACTIONS(3060), 1,
      anon_sym_u03bb,
    ACTIONS(3064), 1,
      anon_sym_record,
    ACTIONS(3066), 1,
      anon_sym_LPAREN,
    ACTIONS(3068), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3070), 1,
      anon_sym_u2983,
    ACTIONS(3072), 1,
      anon_sym_LBRACE,
    ACTIONS(3076), 1,
      aux_sym__qid_token1,
    ACTIONS(3078), 1,
      anon_sym_DOT,
    ACTIONS(3080), 1,
      anon_sym_tactic,
    ACTIONS(3082), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3084), 1,
      anon_sym_u2987,
    ACTIONS(3088), 1,
      anon_sym_Set,
    ACTIONS(4220), 1,
      sym_id,
    STATE(3892), 1,
      aux_sym__atoms,
    STATE(6084), 1,
      sym__qid,
    STATE(6427), 1,
      sym_atom,
    STATE(8123), 1,
      sym__LAMBDA,
    STATE(8396), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3086), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6715), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6714), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3062), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10135), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [385514] = 30,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(878), 1,
      anon_sym_quoteGoal,
    ACTIONS(886), 1,
      anon_sym_let,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(4182), 1,
      sym_id,
    ACTIONS(4184), 1,
      anon_sym_BSLASH,
    ACTIONS(4186), 1,
      anon_sym_u03bb,
    ACTIONS(4190), 1,
      anon_sym_record,
    ACTIONS(4192), 1,
      anon_sym_LPAREN,
    ACTIONS(4194), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4196), 1,
      anon_sym_u2983,
    ACTIONS(4198), 1,
      anon_sym_LBRACE,
    ACTIONS(4200), 1,
      aux_sym__qid_token1,
    ACTIONS(4202), 1,
      anon_sym_DOT,
    ACTIONS(4204), 1,
      anon_sym_tactic,
    ACTIONS(4206), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4208), 1,
      anon_sym_u2987,
    ACTIONS(4212), 1,
      anon_sym_Set,
    STATE(3888), 1,
      aux_sym__atoms,
    STATE(6121), 1,
      sym__qid,
    STATE(6386), 1,
      sym_atom,
    STATE(8067), 1,
      sym__LAMBDA,
    STATE(8369), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(852), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4210), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6575), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6565), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(4188), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10136), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [385630] = 31,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(1302), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(10364), 1,
      sym__binding_ids_and_absurds,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9815), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [385748] = 30,
    ACTIONS(706), 1,
      aux_sym__qid_token1,
    ACTIONS(714), 1,
      anon_sym_quoteGoal,
    ACTIONS(722), 1,
      anon_sym_let,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(3554), 1,
      sym_id,
    ACTIONS(3556), 1,
      anon_sym_BSLASH,
    ACTIONS(3558), 1,
      anon_sym_u03bb,
    ACTIONS(3562), 1,
      anon_sym_record,
    ACTIONS(3564), 1,
      anon_sym_LPAREN,
    ACTIONS(3566), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3568), 1,
      anon_sym_u2983,
    ACTIONS(3570), 1,
      anon_sym_LBRACE,
    ACTIONS(3572), 1,
      anon_sym_DOT,
    ACTIONS(3574), 1,
      anon_sym_tactic,
    ACTIONS(3576), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3578), 1,
      anon_sym_u2987,
    ACTIONS(3582), 1,
      anon_sym_Set,
    STATE(2596), 1,
      sym__ARROW,
    STATE(4004), 1,
      aux_sym__atoms,
    STATE(5237), 1,
      sym_atom,
    STATE(8092), 1,
      sym__LAMBDA,
    STATE(8495), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(682), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3580), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(4286), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(5081), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5079), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9454), 7,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3560), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [385864] = 30,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(964), 1,
      anon_sym_quoteGoal,
    ACTIONS(972), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4214), 1,
      anon_sym_BSLASH,
    ACTIONS(4216), 1,
      anon_sym_u03bb,
    ACTIONS(4218), 1,
      anon_sym_tactic,
    STATE(3891), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8047), 1,
      sym__LAMBDA,
    STATE(8355), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(942), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10137), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [385980] = 31,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(1302), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(11495), 1,
      sym__binding_ids_and_absurds,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9999), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [386098] = 30,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(878), 1,
      anon_sym_quoteGoal,
    ACTIONS(886), 1,
      anon_sym_let,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(4182), 1,
      sym_id,
    ACTIONS(4184), 1,
      anon_sym_BSLASH,
    ACTIONS(4186), 1,
      anon_sym_u03bb,
    ACTIONS(4190), 1,
      anon_sym_record,
    ACTIONS(4192), 1,
      anon_sym_LPAREN,
    ACTIONS(4194), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4196), 1,
      anon_sym_u2983,
    ACTIONS(4198), 1,
      anon_sym_LBRACE,
    ACTIONS(4200), 1,
      aux_sym__qid_token1,
    ACTIONS(4202), 1,
      anon_sym_DOT,
    ACTIONS(4204), 1,
      anon_sym_tactic,
    ACTIONS(4206), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4208), 1,
      anon_sym_u2987,
    ACTIONS(4212), 1,
      anon_sym_Set,
    STATE(3888), 1,
      aux_sym__atoms,
    STATE(6121), 1,
      sym__qid,
    STATE(6386), 1,
      sym_atom,
    STATE(8067), 1,
      sym__LAMBDA,
    STATE(8369), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(852), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4210), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6575), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6565), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(4188), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10070), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [386214] = 31,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(1302), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(10351), 1,
      sym__binding_ids_and_absurds,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9865), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [386332] = 30,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(964), 1,
      anon_sym_quoteGoal,
    ACTIONS(972), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4214), 1,
      anon_sym_BSLASH,
    ACTIONS(4216), 1,
      anon_sym_u03bb,
    ACTIONS(4218), 1,
      anon_sym_tactic,
    STATE(3891), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8047), 1,
      sym__LAMBDA,
    STATE(8355), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(942), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10063), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [386448] = 30,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1984), 1,
      anon_sym_BSLASH,
    ACTIONS(1986), 1,
      anon_sym_u03bb,
    ACTIONS(2004), 1,
      anon_sym_quoteGoal,
    ACTIONS(2006), 1,
      anon_sym_tactic,
    ACTIONS(2012), 1,
      anon_sym_let,
    ACTIONS(3380), 1,
      sym_id,
    ACTIONS(3384), 1,
      anon_sym_record,
    ACTIONS(3386), 1,
      anon_sym_LPAREN,
    ACTIONS(3388), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3390), 1,
      anon_sym_u2983,
    ACTIONS(3392), 1,
      anon_sym_LBRACE,
    ACTIONS(3394), 1,
      aux_sym__qid_token1,
    ACTIONS(3396), 1,
      anon_sym_DOT,
    ACTIONS(3398), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3400), 1,
      anon_sym_u2987,
    ACTIONS(3404), 1,
      anon_sym_Set,
    STATE(1858), 1,
      sym__ARROW,
    STATE(4004), 1,
      aux_sym__atoms,
    STATE(5099), 1,
      sym_atom,
    STATE(8039), 1,
      sym__LAMBDA,
    STATE(8483), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1982), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3402), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(5844), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(4937), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4939), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8997), 7,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3382), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [386564] = 30,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(878), 1,
      anon_sym_quoteGoal,
    ACTIONS(886), 1,
      anon_sym_let,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(4182), 1,
      sym_id,
    ACTIONS(4184), 1,
      anon_sym_BSLASH,
    ACTIONS(4186), 1,
      anon_sym_u03bb,
    ACTIONS(4190), 1,
      anon_sym_record,
    ACTIONS(4192), 1,
      anon_sym_LPAREN,
    ACTIONS(4194), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4196), 1,
      anon_sym_u2983,
    ACTIONS(4198), 1,
      anon_sym_LBRACE,
    ACTIONS(4200), 1,
      aux_sym__qid_token1,
    ACTIONS(4202), 1,
      anon_sym_DOT,
    ACTIONS(4204), 1,
      anon_sym_tactic,
    ACTIONS(4206), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4208), 1,
      anon_sym_u2987,
    ACTIONS(4212), 1,
      anon_sym_Set,
    STATE(3888), 1,
      aux_sym__atoms,
    STATE(6121), 1,
      sym__qid,
    STATE(6386), 1,
      sym_atom,
    STATE(8067), 1,
      sym__LAMBDA,
    STATE(8369), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(852), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4210), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6575), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6565), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(4188), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10174), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [386680] = 30,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(5846), 1,
      sym_id,
    ACTIONS(5850), 1,
      anon_sym_record,
    ACTIONS(5852), 1,
      anon_sym_LPAREN,
    ACTIONS(5854), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(5856), 1,
      anon_sym_u2983,
    ACTIONS(5858), 1,
      anon_sym_LBRACE,
    ACTIONS(5860), 1,
      aux_sym__qid_token1,
    ACTIONS(5862), 1,
      anon_sym_DOT,
    ACTIONS(5864), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(5866), 1,
      anon_sym_u2987,
    ACTIONS(5870), 1,
      anon_sym_Set,
    STATE(3729), 1,
      aux_sym__with_exprs_repeat1,
    STATE(3823), 1,
      aux_sym__atoms,
    STATE(6072), 1,
      sym_atom,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    STATE(8978), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(5868), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6096), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6100), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(5848), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [386796] = 30,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2448), 1,
      anon_sym_quoteGoal,
    ACTIONS(2456), 1,
      anon_sym_let,
    ACTIONS(2842), 1,
      anon_sym_BSLASH,
    ACTIONS(2844), 1,
      anon_sym_u03bb,
    ACTIONS(2862), 1,
      anon_sym_tactic,
    ACTIONS(2872), 1,
      sym_id,
    ACTIONS(2876), 1,
      anon_sym_record,
    ACTIONS(2878), 1,
      anon_sym_LPAREN,
    ACTIONS(2880), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2882), 1,
      anon_sym_u2983,
    ACTIONS(2884), 1,
      anon_sym_LBRACE,
    ACTIONS(2886), 1,
      aux_sym__qid_token1,
    ACTIONS(2888), 1,
      anon_sym_DOT,
    ACTIONS(2890), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2892), 1,
      anon_sym_u2987,
    ACTIONS(2896), 1,
      anon_sym_Set,
    STATE(1774), 1,
      sym__ARROW,
    STATE(4004), 1,
      aux_sym__atoms,
    STATE(4945), 1,
      sym_atom,
    STATE(8053), 1,
      sym__LAMBDA,
    STATE(8423), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2424), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2894), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(5786), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(5291), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5287), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8997), 7,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2874), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [386912] = 30,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(964), 1,
      anon_sym_quoteGoal,
    ACTIONS(972), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4214), 1,
      anon_sym_BSLASH,
    ACTIONS(4216), 1,
      anon_sym_u03bb,
    ACTIONS(4218), 1,
      anon_sym_tactic,
    STATE(3891), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8047), 1,
      sym__LAMBDA,
    STATE(8355), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(942), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10175), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [387028] = 30,
    ACTIONS(686), 1,
      anon_sym_BSLASH,
    ACTIONS(688), 1,
      anon_sym_u03bb,
    ACTIONS(714), 1,
      anon_sym_quoteGoal,
    ACTIONS(716), 1,
      anon_sym_tactic,
    ACTIONS(722), 1,
      anon_sym_let,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(5708), 1,
      sym_id,
    ACTIONS(5712), 1,
      anon_sym_record,
    ACTIONS(5714), 1,
      anon_sym_LPAREN,
    ACTIONS(5716), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(5718), 1,
      anon_sym_u2983,
    ACTIONS(5720), 1,
      anon_sym_LBRACE,
    ACTIONS(5722), 1,
      aux_sym__qid_token1,
    ACTIONS(5724), 1,
      anon_sym_DOT,
    ACTIONS(5726), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(5728), 1,
      anon_sym_u2987,
    ACTIONS(5732), 1,
      anon_sym_Set,
    STATE(3722), 1,
      aux_sym__with_exprs_repeat1,
    STATE(3782), 1,
      aux_sym__atoms,
    STATE(5512), 1,
      sym_atom,
    STATE(8064), 1,
      sym__LAMBDA,
    STATE(8495), 1,
      sym__FORALL,
    STATE(9466), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(682), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(5730), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5553), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5550), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(5710), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [387144] = 30,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(878), 1,
      anon_sym_quoteGoal,
    ACTIONS(886), 1,
      anon_sym_let,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(4182), 1,
      sym_id,
    ACTIONS(4184), 1,
      anon_sym_BSLASH,
    ACTIONS(4186), 1,
      anon_sym_u03bb,
    ACTIONS(4190), 1,
      anon_sym_record,
    ACTIONS(4192), 1,
      anon_sym_LPAREN,
    ACTIONS(4194), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4196), 1,
      anon_sym_u2983,
    ACTIONS(4198), 1,
      anon_sym_LBRACE,
    ACTIONS(4200), 1,
      aux_sym__qid_token1,
    ACTIONS(4202), 1,
      anon_sym_DOT,
    ACTIONS(4204), 1,
      anon_sym_tactic,
    ACTIONS(4206), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4208), 1,
      anon_sym_u2987,
    ACTIONS(4212), 1,
      anon_sym_Set,
    STATE(3888), 1,
      aux_sym__atoms,
    STATE(6121), 1,
      sym__qid,
    STATE(6386), 1,
      sym_atom,
    STATE(8067), 1,
      sym__LAMBDA,
    STATE(8369), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(852), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4210), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6575), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6565), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(4188), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10064), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [387260] = 30,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(964), 1,
      anon_sym_quoteGoal,
    ACTIONS(972), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4214), 1,
      anon_sym_BSLASH,
    ACTIONS(4216), 1,
      anon_sym_u03bb,
    ACTIONS(4218), 1,
      anon_sym_tactic,
    STATE(3891), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8047), 1,
      sym__LAMBDA,
    STATE(8355), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(942), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10131), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [387376] = 31,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(1302), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(10798), 1,
      sym__binding_ids_and_absurds,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9971), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [387494] = 30,
    ACTIONS(710), 1,
      anon_sym_DASH,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(920), 1,
      anon_sym_quoteGoal,
    ACTIONS(928), 1,
      anon_sym_let,
    ACTIONS(3058), 1,
      anon_sym_BSLASH,
    ACTIONS(3060), 1,
      anon_sym_u03bb,
    ACTIONS(3064), 1,
      anon_sym_record,
    ACTIONS(3066), 1,
      anon_sym_LPAREN,
    ACTIONS(3068), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3070), 1,
      anon_sym_u2983,
    ACTIONS(3072), 1,
      anon_sym_LBRACE,
    ACTIONS(3076), 1,
      aux_sym__qid_token1,
    ACTIONS(3078), 1,
      anon_sym_DOT,
    ACTIONS(3080), 1,
      anon_sym_tactic,
    ACTIONS(3082), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3084), 1,
      anon_sym_u2987,
    ACTIONS(3088), 1,
      anon_sym_Set,
    ACTIONS(4220), 1,
      sym_id,
    STATE(3892), 1,
      aux_sym__atoms,
    STATE(6084), 1,
      sym__qid,
    STATE(6427), 1,
      sym_atom,
    STATE(8123), 1,
      sym__LAMBDA,
    STATE(8396), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3086), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6715), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6714), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3062), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10102), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [387610] = 30,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(878), 1,
      anon_sym_quoteGoal,
    ACTIONS(886), 1,
      anon_sym_let,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(4182), 1,
      sym_id,
    ACTIONS(4184), 1,
      anon_sym_BSLASH,
    ACTIONS(4186), 1,
      anon_sym_u03bb,
    ACTIONS(4190), 1,
      anon_sym_record,
    ACTIONS(4192), 1,
      anon_sym_LPAREN,
    ACTIONS(4194), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4196), 1,
      anon_sym_u2983,
    ACTIONS(4198), 1,
      anon_sym_LBRACE,
    ACTIONS(4200), 1,
      aux_sym__qid_token1,
    ACTIONS(4202), 1,
      anon_sym_DOT,
    ACTIONS(4204), 1,
      anon_sym_tactic,
    ACTIONS(4206), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4208), 1,
      anon_sym_u2987,
    ACTIONS(4212), 1,
      anon_sym_Set,
    STATE(3888), 1,
      aux_sym__atoms,
    STATE(6121), 1,
      sym__qid,
    STATE(6386), 1,
      sym_atom,
    STATE(8067), 1,
      sym__LAMBDA,
    STATE(8369), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(852), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4210), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6575), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6565), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(4188), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9820), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [387726] = 30,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(964), 1,
      anon_sym_quoteGoal,
    ACTIONS(972), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4214), 1,
      anon_sym_BSLASH,
    ACTIONS(4216), 1,
      anon_sym_u03bb,
    ACTIONS(4218), 1,
      anon_sym_tactic,
    STATE(3891), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8047), 1,
      sym__LAMBDA,
    STATE(8355), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(942), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9908), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [387842] = 30,
    ACTIONS(710), 1,
      anon_sym_DASH,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(920), 1,
      anon_sym_quoteGoal,
    ACTIONS(928), 1,
      anon_sym_let,
    ACTIONS(3058), 1,
      anon_sym_BSLASH,
    ACTIONS(3060), 1,
      anon_sym_u03bb,
    ACTIONS(3064), 1,
      anon_sym_record,
    ACTIONS(3066), 1,
      anon_sym_LPAREN,
    ACTIONS(3068), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3070), 1,
      anon_sym_u2983,
    ACTIONS(3072), 1,
      anon_sym_LBRACE,
    ACTIONS(3076), 1,
      aux_sym__qid_token1,
    ACTIONS(3078), 1,
      anon_sym_DOT,
    ACTIONS(3080), 1,
      anon_sym_tactic,
    ACTIONS(3082), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3084), 1,
      anon_sym_u2987,
    ACTIONS(3088), 1,
      anon_sym_Set,
    ACTIONS(4220), 1,
      sym_id,
    STATE(3892), 1,
      aux_sym__atoms,
    STATE(6084), 1,
      sym__qid,
    STATE(6427), 1,
      sym_atom,
    STATE(8123), 1,
      sym__LAMBDA,
    STATE(8396), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3086), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6715), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6714), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3062), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9818), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [387958] = 30,
    ACTIONS(710), 1,
      anon_sym_DASH,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(920), 1,
      anon_sym_quoteGoal,
    ACTIONS(928), 1,
      anon_sym_let,
    ACTIONS(3058), 1,
      anon_sym_BSLASH,
    ACTIONS(3060), 1,
      anon_sym_u03bb,
    ACTIONS(3064), 1,
      anon_sym_record,
    ACTIONS(3066), 1,
      anon_sym_LPAREN,
    ACTIONS(3068), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3070), 1,
      anon_sym_u2983,
    ACTIONS(3072), 1,
      anon_sym_LBRACE,
    ACTIONS(3076), 1,
      aux_sym__qid_token1,
    ACTIONS(3078), 1,
      anon_sym_DOT,
    ACTIONS(3080), 1,
      anon_sym_tactic,
    ACTIONS(3082), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3084), 1,
      anon_sym_u2987,
    ACTIONS(3088), 1,
      anon_sym_Set,
    ACTIONS(4220), 1,
      sym_id,
    STATE(3892), 1,
      aux_sym__atoms,
    STATE(6084), 1,
      sym__qid,
    STATE(6427), 1,
      sym_atom,
    STATE(8123), 1,
      sym__LAMBDA,
    STATE(8396), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3086), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6715), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6714), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3062), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10067), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [388074] = 30,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(2532), 1,
      anon_sym_BSLASH,
    ACTIONS(2534), 1,
      anon_sym_u03bb,
    ACTIONS(2552), 1,
      anon_sym_quoteGoal,
    ACTIONS(2554), 1,
      anon_sym_tactic,
    ACTIONS(2560), 1,
      anon_sym_let,
    ACTIONS(5872), 1,
      sym_id,
    ACTIONS(5876), 1,
      anon_sym_record,
    ACTIONS(5878), 1,
      anon_sym_LPAREN,
    ACTIONS(5880), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(5882), 1,
      anon_sym_u2983,
    ACTIONS(5884), 1,
      anon_sym_LBRACE,
    ACTIONS(5886), 1,
      aux_sym__qid_token1,
    ACTIONS(5888), 1,
      anon_sym_DOT,
    ACTIONS(5890), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(5892), 1,
      anon_sym_u2987,
    ACTIONS(5896), 1,
      anon_sym_Set,
    STATE(3720), 1,
      aux_sym__with_exprs_repeat1,
    STATE(3810), 1,
      aux_sym__atoms,
    STATE(4839), 1,
      sym_atom,
    STATE(8066), 1,
      sym__LAMBDA,
    STATE(8398), 1,
      sym__FORALL,
    STATE(8939), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2528), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(5894), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4787), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4785), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(5874), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [388190] = 30,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2422), 1,
      sym_id,
    ACTIONS(2428), 1,
      anon_sym_BSLASH,
    ACTIONS(2430), 1,
      anon_sym_u03bb,
    ACTIONS(2434), 1,
      anon_sym_record,
    ACTIONS(2436), 1,
      anon_sym_LPAREN,
    ACTIONS(2438), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2440), 1,
      anon_sym_u2983,
    ACTIONS(2442), 1,
      anon_sym_LBRACE,
    ACTIONS(2444), 1,
      aux_sym__qid_token1,
    ACTIONS(2446), 1,
      anon_sym_DOT,
    ACTIONS(2448), 1,
      anon_sym_quoteGoal,
    ACTIONS(2450), 1,
      anon_sym_tactic,
    ACTIONS(2452), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2454), 1,
      anon_sym_u2987,
    ACTIONS(2456), 1,
      anon_sym_let,
    ACTIONS(2460), 1,
      anon_sym_Set,
    STATE(1578), 1,
      sym__ARROW,
    STATE(4004), 1,
      aux_sym__atoms,
    STATE(5596), 1,
      sym_atom,
    STATE(8125), 1,
      sym__LAMBDA,
    STATE(8423), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2424), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2458), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(4300), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(5422), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5423), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8997), 7,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2432), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [388306] = 30,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(5898), 1,
      sym_id,
    ACTIONS(5902), 1,
      anon_sym_record,
    ACTIONS(5904), 1,
      anon_sym_LPAREN,
    ACTIONS(5906), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(5908), 1,
      anon_sym_u2983,
    ACTIONS(5910), 1,
      anon_sym_LBRACE,
    ACTIONS(5912), 1,
      aux_sym__qid_token1,
    ACTIONS(5914), 1,
      anon_sym_DOT,
    ACTIONS(5916), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(5918), 1,
      anon_sym_u2987,
    ACTIONS(5922), 1,
      anon_sym_Set,
    STATE(3726), 1,
      aux_sym__with_exprs_repeat1,
    STATE(3811), 1,
      aux_sym__atoms,
    STATE(6198), 1,
      sym_atom,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    STATE(9466), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(5920), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6087), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6089), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(5900), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [388422] = 30,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(878), 1,
      anon_sym_quoteGoal,
    ACTIONS(886), 1,
      anon_sym_let,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(4182), 1,
      sym_id,
    ACTIONS(4184), 1,
      anon_sym_BSLASH,
    ACTIONS(4186), 1,
      anon_sym_u03bb,
    ACTIONS(4190), 1,
      anon_sym_record,
    ACTIONS(4192), 1,
      anon_sym_LPAREN,
    ACTIONS(4194), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4196), 1,
      anon_sym_u2983,
    ACTIONS(4198), 1,
      anon_sym_LBRACE,
    ACTIONS(4200), 1,
      aux_sym__qid_token1,
    ACTIONS(4202), 1,
      anon_sym_DOT,
    ACTIONS(4204), 1,
      anon_sym_tactic,
    ACTIONS(4206), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4208), 1,
      anon_sym_u2987,
    ACTIONS(4212), 1,
      anon_sym_Set,
    STATE(3888), 1,
      aux_sym__atoms,
    STATE(6121), 1,
      sym__qid,
    STATE(6386), 1,
      sym_atom,
    STATE(8067), 1,
      sym__LAMBDA,
    STATE(8369), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(852), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4210), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6575), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6565), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(4188), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9912), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [388538] = 31,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(738), 1,
      anon_sym_BSLASH,
    ACTIONS(740), 1,
      anon_sym_u03bb,
    ACTIONS(762), 1,
      anon_sym_quoteGoal,
    ACTIONS(764), 1,
      anon_sym_tactic,
    ACTIONS(770), 1,
      anon_sym_let,
    ACTIONS(4238), 1,
      anon_sym_PIPE,
    ACTIONS(4248), 1,
      sym_id,
    ACTIONS(4252), 1,
      anon_sym_record,
    ACTIONS(4254), 1,
      anon_sym_LPAREN,
    ACTIONS(4256), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4258), 1,
      anon_sym_u2983,
    ACTIONS(4260), 1,
      anon_sym_LBRACE,
    ACTIONS(4262), 1,
      aux_sym__qid_token1,
    ACTIONS(4264), 1,
      anon_sym_DOT,
    ACTIONS(4266), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4268), 1,
      anon_sym_u2987,
    ACTIONS(4272), 1,
      anon_sym_Set,
    STATE(4039), 1,
      aux_sym__atoms,
    STATE(5812), 1,
      sym_atom,
    STATE(8156), 1,
      sym__LAMBDA,
    STATE(8456), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(736), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4270), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5952), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(8997), 2,
      sym__expr2,
      sym_let,
    STATE(10106), 2,
      sym__expr2_stmt,
      sym_let_in_do,
    STATE(9605), 5,
      sym__expr2_without_let,
      sym_forall,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    STATE(5976), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(4250), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [388656] = 30,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(3266), 1,
      anon_sym_BSLASH,
    ACTIONS(3268), 1,
      anon_sym_u03bb,
    ACTIONS(3286), 1,
      anon_sym_quoteGoal,
    ACTIONS(3288), 1,
      anon_sym_tactic,
    ACTIONS(3294), 1,
      anon_sym_let,
    ACTIONS(3732), 1,
      sym_id,
    ACTIONS(3738), 1,
      anon_sym_record,
    ACTIONS(3740), 1,
      anon_sym_LPAREN,
    ACTIONS(3742), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3744), 1,
      anon_sym_u2983,
    ACTIONS(3746), 1,
      anon_sym_LBRACE,
    ACTIONS(3748), 1,
      aux_sym__qid_token1,
    ACTIONS(3750), 1,
      anon_sym_DOT,
    ACTIONS(3752), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3754), 1,
      anon_sym_u2987,
    ACTIONS(3758), 1,
      anon_sym_Set,
    STATE(2259), 1,
      sym__ARROW,
    STATE(4004), 1,
      aux_sym__atoms,
    STATE(4058), 1,
      sym_atom,
    STATE(8143), 1,
      sym__LAMBDA,
    STATE(8451), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3264), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3756), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(4518), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(4073), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4070), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9001), 7,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3736), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [388772] = 30,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1910), 1,
      anon_sym_BSLASH,
    ACTIONS(1912), 1,
      anon_sym_u03bb,
    ACTIONS(1928), 1,
      anon_sym_quoteGoal,
    ACTIONS(1930), 1,
      anon_sym_tactic,
    ACTIONS(1936), 1,
      anon_sym_let,
    ACTIONS(5522), 1,
      sym_id,
    ACTIONS(5526), 1,
      anon_sym_record,
    ACTIONS(5528), 1,
      anon_sym_LPAREN,
    ACTIONS(5530), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(5532), 1,
      anon_sym_u2983,
    ACTIONS(5534), 1,
      anon_sym_LBRACE,
    ACTIONS(5536), 1,
      aux_sym__qid_token1,
    ACTIONS(5538), 1,
      anon_sym_DOT,
    ACTIONS(5540), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(5542), 1,
      anon_sym_u2987,
    ACTIONS(5546), 1,
      anon_sym_Set,
    STATE(3717), 1,
      aux_sym__with_exprs_repeat1,
    STATE(3846), 1,
      aux_sym__atoms,
    STATE(5007), 1,
      sym_atom,
    STATE(8153), 1,
      sym__LAMBDA,
    STATE(8431), 1,
      sym__FORALL,
    STATE(8978), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1906), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(5544), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5318), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5319), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(5524), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [388888] = 30,
    ACTIONS(692), 1,
      anon_sym_record,
    ACTIONS(694), 1,
      anon_sym_LPAREN,
    ACTIONS(696), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(698), 1,
      anon_sym_u2983,
    ACTIONS(702), 1,
      anon_sym_LBRACE,
    ACTIONS(708), 1,
      anon_sym_DOT,
    ACTIONS(718), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(720), 1,
      anon_sym_u2987,
    ACTIONS(728), 1,
      anon_sym_Set,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1928), 1,
      anon_sym_quoteGoal,
    ACTIONS(1936), 1,
      anon_sym_let,
    ACTIONS(2336), 1,
      sym_id,
    ACTIONS(2338), 1,
      anon_sym_BSLASH,
    ACTIONS(2340), 1,
      anon_sym_u03bb,
    ACTIONS(2342), 1,
      aux_sym__qid_token1,
    ACTIONS(2344), 1,
      anon_sym_tactic,
    STATE(1644), 1,
      sym__ARROW,
    STATE(4004), 1,
      aux_sym__atoms,
    STATE(5128), 1,
      sym_atom,
    STATE(8079), 1,
      sym__LAMBDA,
    STATE(8431), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(726), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(1906), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(5080), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(5069), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5056), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8997), 7,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(690), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [389004] = 30,
    ACTIONS(710), 1,
      anon_sym_DASH,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(920), 1,
      anon_sym_quoteGoal,
    ACTIONS(928), 1,
      anon_sym_let,
    ACTIONS(3058), 1,
      anon_sym_BSLASH,
    ACTIONS(3060), 1,
      anon_sym_u03bb,
    ACTIONS(3064), 1,
      anon_sym_record,
    ACTIONS(3066), 1,
      anon_sym_LPAREN,
    ACTIONS(3068), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3070), 1,
      anon_sym_u2983,
    ACTIONS(3072), 1,
      anon_sym_LBRACE,
    ACTIONS(3076), 1,
      aux_sym__qid_token1,
    ACTIONS(3078), 1,
      anon_sym_DOT,
    ACTIONS(3080), 1,
      anon_sym_tactic,
    ACTIONS(3082), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3084), 1,
      anon_sym_u2987,
    ACTIONS(3088), 1,
      anon_sym_Set,
    ACTIONS(4220), 1,
      sym_id,
    STATE(3892), 1,
      aux_sym__atoms,
    STATE(6084), 1,
      sym__qid,
    STATE(6427), 1,
      sym_atom,
    STATE(8123), 1,
      sym__LAMBDA,
    STATE(8396), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3086), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6715), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6714), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3062), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10193), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [389120] = 30,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(2676), 1,
      anon_sym_quoteGoal,
    ACTIONS(2684), 1,
      anon_sym_let,
    ACTIONS(2806), 1,
      sym_id,
    ACTIONS(2816), 1,
      anon_sym_record,
    ACTIONS(2818), 1,
      anon_sym_LPAREN,
    ACTIONS(2820), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2822), 1,
      anon_sym_u2983,
    ACTIONS(2824), 1,
      anon_sym_LBRACE,
    ACTIONS(2826), 1,
      aux_sym__qid_token1,
    ACTIONS(2828), 1,
      anon_sym_DOT,
    ACTIONS(2832), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2834), 1,
      anon_sym_u2987,
    ACTIONS(2838), 1,
      anon_sym_Set,
    ACTIONS(3906), 1,
      anon_sym_BSLASH,
    ACTIONS(3908), 1,
      anon_sym_u03bb,
    ACTIONS(3910), 1,
      anon_sym_tactic,
    STATE(2347), 1,
      sym__ARROW,
    STATE(4004), 1,
      aux_sym__atoms,
    STATE(5831), 1,
      sym_atom,
    STATE(8086), 1,
      sym__LAMBDA,
    STATE(8470), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2654), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2836), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(4536), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(5982), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5981), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9454), 7,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2814), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [389236] = 30,
    ACTIONS(710), 1,
      anon_sym_DASH,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(920), 1,
      anon_sym_quoteGoal,
    ACTIONS(928), 1,
      anon_sym_let,
    ACTIONS(3058), 1,
      anon_sym_BSLASH,
    ACTIONS(3060), 1,
      anon_sym_u03bb,
    ACTIONS(3064), 1,
      anon_sym_record,
    ACTIONS(3066), 1,
      anon_sym_LPAREN,
    ACTIONS(3068), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3070), 1,
      anon_sym_u2983,
    ACTIONS(3072), 1,
      anon_sym_LBRACE,
    ACTIONS(3076), 1,
      aux_sym__qid_token1,
    ACTIONS(3078), 1,
      anon_sym_DOT,
    ACTIONS(3080), 1,
      anon_sym_tactic,
    ACTIONS(3082), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3084), 1,
      anon_sym_u2987,
    ACTIONS(3088), 1,
      anon_sym_Set,
    ACTIONS(4220), 1,
      sym_id,
    STATE(3892), 1,
      aux_sym__atoms,
    STATE(6084), 1,
      sym__qid,
    STATE(6427), 1,
      sym_atom,
    STATE(8123), 1,
      sym__LAMBDA,
    STATE(8396), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3086), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6715), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6714), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3062), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10068), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [389352] = 30,
    ACTIONS(706), 1,
      aux_sym__qid_token1,
    ACTIONS(714), 1,
      anon_sym_quoteGoal,
    ACTIONS(722), 1,
      anon_sym_let,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(3554), 1,
      sym_id,
    ACTIONS(3556), 1,
      anon_sym_BSLASH,
    ACTIONS(3558), 1,
      anon_sym_u03bb,
    ACTIONS(3562), 1,
      anon_sym_record,
    ACTIONS(3564), 1,
      anon_sym_LPAREN,
    ACTIONS(3566), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3568), 1,
      anon_sym_u2983,
    ACTIONS(3570), 1,
      anon_sym_LBRACE,
    ACTIONS(3572), 1,
      anon_sym_DOT,
    ACTIONS(3574), 1,
      anon_sym_tactic,
    ACTIONS(3576), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3578), 1,
      anon_sym_u2987,
    ACTIONS(3582), 1,
      anon_sym_Set,
    STATE(2587), 1,
      sym__ARROW,
    STATE(4004), 1,
      aux_sym__atoms,
    STATE(5237), 1,
      sym_atom,
    STATE(8092), 1,
      sym__LAMBDA,
    STATE(8495), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(682), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3580), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(5924), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(5081), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5079), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9454), 7,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3560), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [389468] = 30,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(2618), 1,
      anon_sym_BSLASH,
    ACTIONS(2620), 1,
      anon_sym_u03bb,
    ACTIONS(2638), 1,
      anon_sym_quoteGoal,
    ACTIONS(2640), 1,
      anon_sym_tactic,
    ACTIONS(2646), 1,
      anon_sym_let,
    ACTIONS(5926), 1,
      sym_id,
    ACTIONS(5930), 1,
      anon_sym_record,
    ACTIONS(5932), 1,
      anon_sym_LPAREN,
    ACTIONS(5934), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(5936), 1,
      anon_sym_u2983,
    ACTIONS(5938), 1,
      anon_sym_LBRACE,
    ACTIONS(5940), 1,
      aux_sym__qid_token1,
    ACTIONS(5942), 1,
      anon_sym_DOT,
    ACTIONS(5944), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(5946), 1,
      anon_sym_u2987,
    ACTIONS(5950), 1,
      anon_sym_Set,
    STATE(3758), 1,
      aux_sym__with_exprs_repeat1,
    STATE(3830), 1,
      aux_sym__atoms,
    STATE(5542), 1,
      sym_atom,
    STATE(8093), 1,
      sym__LAMBDA,
    STATE(8414), 1,
      sym__FORALL,
    STATE(8939), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2616), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(5948), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5470), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5454), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(5928), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [389584] = 31,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(1302), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(11307), 1,
      sym__binding_ids_and_absurds,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9925), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [389702] = 30,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(964), 1,
      anon_sym_quoteGoal,
    ACTIONS(972), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4214), 1,
      anon_sym_BSLASH,
    ACTIONS(4216), 1,
      anon_sym_u03bb,
    ACTIONS(4218), 1,
      anon_sym_tactic,
    STATE(3891), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8047), 1,
      sym__LAMBDA,
    STATE(8355), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(942), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9918), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [389818] = 30,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(878), 1,
      anon_sym_quoteGoal,
    ACTIONS(886), 1,
      anon_sym_let,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(4182), 1,
      sym_id,
    ACTIONS(4184), 1,
      anon_sym_BSLASH,
    ACTIONS(4186), 1,
      anon_sym_u03bb,
    ACTIONS(4190), 1,
      anon_sym_record,
    ACTIONS(4192), 1,
      anon_sym_LPAREN,
    ACTIONS(4194), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4196), 1,
      anon_sym_u2983,
    ACTIONS(4198), 1,
      anon_sym_LBRACE,
    ACTIONS(4200), 1,
      aux_sym__qid_token1,
    ACTIONS(4202), 1,
      anon_sym_DOT,
    ACTIONS(4204), 1,
      anon_sym_tactic,
    ACTIONS(4206), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4208), 1,
      anon_sym_u2987,
    ACTIONS(4212), 1,
      anon_sym_Set,
    STATE(3888), 1,
      aux_sym__atoms,
    STATE(6121), 1,
      sym__qid,
    STATE(6386), 1,
      sym_atom,
    STATE(8067), 1,
      sym__LAMBDA,
    STATE(8369), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(852), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4210), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6575), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6565), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(4188), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10192), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [389934] = 30,
    ACTIONS(686), 1,
      anon_sym_BSLASH,
    ACTIONS(688), 1,
      anon_sym_u03bb,
    ACTIONS(692), 1,
      anon_sym_record,
    ACTIONS(694), 1,
      anon_sym_LPAREN,
    ACTIONS(696), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(698), 1,
      anon_sym_u2983,
    ACTIONS(702), 1,
      anon_sym_LBRACE,
    ACTIONS(708), 1,
      anon_sym_DOT,
    ACTIONS(714), 1,
      anon_sym_quoteGoal,
    ACTIONS(716), 1,
      anon_sym_tactic,
    ACTIONS(718), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(720), 1,
      anon_sym_u2987,
    ACTIONS(722), 1,
      anon_sym_let,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(728), 1,
      anon_sym_Set,
    ACTIONS(2336), 1,
      sym_id,
    ACTIONS(2342), 1,
      aux_sym__qid_token1,
    STATE(2587), 1,
      sym__ARROW,
    STATE(4004), 1,
      aux_sym__atoms,
    STATE(5128), 1,
      sym_atom,
    STATE(8064), 1,
      sym__LAMBDA,
    STATE(8495), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(682), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(726), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(5924), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(5069), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5056), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9454), 7,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(690), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [390050] = 30,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(878), 1,
      anon_sym_quoteGoal,
    ACTIONS(886), 1,
      anon_sym_let,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(4182), 1,
      sym_id,
    ACTIONS(4184), 1,
      anon_sym_BSLASH,
    ACTIONS(4186), 1,
      anon_sym_u03bb,
    ACTIONS(4190), 1,
      anon_sym_record,
    ACTIONS(4192), 1,
      anon_sym_LPAREN,
    ACTIONS(4194), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4196), 1,
      anon_sym_u2983,
    ACTIONS(4198), 1,
      anon_sym_LBRACE,
    ACTIONS(4200), 1,
      aux_sym__qid_token1,
    ACTIONS(4202), 1,
      anon_sym_DOT,
    ACTIONS(4204), 1,
      anon_sym_tactic,
    ACTIONS(4206), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4208), 1,
      anon_sym_u2987,
    ACTIONS(4212), 1,
      anon_sym_Set,
    STATE(3888), 1,
      aux_sym__atoms,
    STATE(6121), 1,
      sym__qid,
    STATE(6386), 1,
      sym_atom,
    STATE(8067), 1,
      sym__LAMBDA,
    STATE(8369), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(852), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4210), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6575), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6565), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(4188), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9916), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [390166] = 30,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(964), 1,
      anon_sym_quoteGoal,
    ACTIONS(972), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4214), 1,
      anon_sym_BSLASH,
    ACTIONS(4216), 1,
      anon_sym_u03bb,
    ACTIONS(4218), 1,
      anon_sym_tactic,
    STATE(3891), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8047), 1,
      sym__LAMBDA,
    STATE(8355), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(942), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10210), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [390282] = 31,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(1302), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(10291), 1,
      sym__binding_ids_and_absurds,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9837), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [390400] = 30,
    ACTIONS(710), 1,
      anon_sym_DASH,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(920), 1,
      anon_sym_quoteGoal,
    ACTIONS(928), 1,
      anon_sym_let,
    ACTIONS(3058), 1,
      anon_sym_BSLASH,
    ACTIONS(3060), 1,
      anon_sym_u03bb,
    ACTIONS(3064), 1,
      anon_sym_record,
    ACTIONS(3066), 1,
      anon_sym_LPAREN,
    ACTIONS(3068), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3070), 1,
      anon_sym_u2983,
    ACTIONS(3072), 1,
      anon_sym_LBRACE,
    ACTIONS(3076), 1,
      aux_sym__qid_token1,
    ACTIONS(3078), 1,
      anon_sym_DOT,
    ACTIONS(3080), 1,
      anon_sym_tactic,
    ACTIONS(3082), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3084), 1,
      anon_sym_u2987,
    ACTIONS(3088), 1,
      anon_sym_Set,
    ACTIONS(4220), 1,
      sym_id,
    STATE(3892), 1,
      aux_sym__atoms,
    STATE(6084), 1,
      sym__qid,
    STATE(6427), 1,
      sym_atom,
    STATE(8123), 1,
      sym__LAMBDA,
    STATE(8396), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3086), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6715), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6714), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3062), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9915), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [390516] = 30,
    ACTIONS(710), 1,
      anon_sym_DASH,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(920), 1,
      anon_sym_quoteGoal,
    ACTIONS(928), 1,
      anon_sym_let,
    ACTIONS(3058), 1,
      anon_sym_BSLASH,
    ACTIONS(3060), 1,
      anon_sym_u03bb,
    ACTIONS(3064), 1,
      anon_sym_record,
    ACTIONS(3066), 1,
      anon_sym_LPAREN,
    ACTIONS(3068), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3070), 1,
      anon_sym_u2983,
    ACTIONS(3072), 1,
      anon_sym_LBRACE,
    ACTIONS(3076), 1,
      aux_sym__qid_token1,
    ACTIONS(3078), 1,
      anon_sym_DOT,
    ACTIONS(3080), 1,
      anon_sym_tactic,
    ACTIONS(3082), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3084), 1,
      anon_sym_u2987,
    ACTIONS(3088), 1,
      anon_sym_Set,
    ACTIONS(4220), 1,
      sym_id,
    STATE(3892), 1,
      aux_sym__atoms,
    STATE(6084), 1,
      sym__qid,
    STATE(6427), 1,
      sym_atom,
    STATE(8123), 1,
      sym__LAMBDA,
    STATE(8396), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3086), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6715), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6714), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3062), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10211), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [390632] = 30,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(878), 1,
      anon_sym_quoteGoal,
    ACTIONS(886), 1,
      anon_sym_let,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(4182), 1,
      sym_id,
    ACTIONS(4184), 1,
      anon_sym_BSLASH,
    ACTIONS(4186), 1,
      anon_sym_u03bb,
    ACTIONS(4190), 1,
      anon_sym_record,
    ACTIONS(4192), 1,
      anon_sym_LPAREN,
    ACTIONS(4194), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4196), 1,
      anon_sym_u2983,
    ACTIONS(4198), 1,
      anon_sym_LBRACE,
    ACTIONS(4200), 1,
      aux_sym__qid_token1,
    ACTIONS(4202), 1,
      anon_sym_DOT,
    ACTIONS(4204), 1,
      anon_sym_tactic,
    ACTIONS(4206), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4208), 1,
      anon_sym_u2987,
    ACTIONS(4212), 1,
      anon_sym_Set,
    STATE(3888), 1,
      aux_sym__atoms,
    STATE(6121), 1,
      sym__qid,
    STATE(6386), 1,
      sym_atom,
    STATE(8067), 1,
      sym__LAMBDA,
    STATE(8369), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(852), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4210), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6575), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6565), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(4188), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10209), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [390748] = 30,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(2526), 1,
      sym_id,
    ACTIONS(2532), 1,
      anon_sym_BSLASH,
    ACTIONS(2534), 1,
      anon_sym_u03bb,
    ACTIONS(2538), 1,
      anon_sym_record,
    ACTIONS(2540), 1,
      anon_sym_LPAREN,
    ACTIONS(2542), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2544), 1,
      anon_sym_u2983,
    ACTIONS(2546), 1,
      anon_sym_LBRACE,
    ACTIONS(2548), 1,
      aux_sym__qid_token1,
    ACTIONS(2550), 1,
      anon_sym_DOT,
    ACTIONS(2552), 1,
      anon_sym_quoteGoal,
    ACTIONS(2554), 1,
      anon_sym_tactic,
    ACTIONS(2556), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2558), 1,
      anon_sym_u2987,
    ACTIONS(2560), 1,
      anon_sym_let,
    ACTIONS(2564), 1,
      anon_sym_Set,
    STATE(1917), 1,
      sym__ARROW,
    STATE(4004), 1,
      aux_sym__atoms,
    STATE(4603), 1,
      sym_atom,
    STATE(8066), 1,
      sym__LAMBDA,
    STATE(8398), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2528), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2562), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(4734), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(4464), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4473), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9001), 7,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2536), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [390864] = 30,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1984), 1,
      anon_sym_BSLASH,
    ACTIONS(1986), 1,
      anon_sym_u03bb,
    ACTIONS(2004), 1,
      anon_sym_quoteGoal,
    ACTIONS(2006), 1,
      anon_sym_tactic,
    ACTIONS(2012), 1,
      anon_sym_let,
    ACTIONS(3380), 1,
      sym_id,
    ACTIONS(3384), 1,
      anon_sym_record,
    ACTIONS(3386), 1,
      anon_sym_LPAREN,
    ACTIONS(3388), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3390), 1,
      anon_sym_u2983,
    ACTIONS(3392), 1,
      anon_sym_LBRACE,
    ACTIONS(3394), 1,
      aux_sym__qid_token1,
    ACTIONS(3396), 1,
      anon_sym_DOT,
    ACTIONS(3398), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3400), 1,
      anon_sym_u2987,
    ACTIONS(3404), 1,
      anon_sym_Set,
    STATE(1870), 1,
      sym__ARROW,
    STATE(4004), 1,
      aux_sym__atoms,
    STATE(5099), 1,
      sym_atom,
    STATE(8039), 1,
      sym__LAMBDA,
    STATE(8483), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1982), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3402), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(4562), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(4937), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4939), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8997), 7,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3382), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [390980] = 30,
    ACTIONS(710), 1,
      anon_sym_DASH,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(920), 1,
      anon_sym_quoteGoal,
    ACTIONS(928), 1,
      anon_sym_let,
    ACTIONS(3058), 1,
      anon_sym_BSLASH,
    ACTIONS(3060), 1,
      anon_sym_u03bb,
    ACTIONS(3064), 1,
      anon_sym_record,
    ACTIONS(3066), 1,
      anon_sym_LPAREN,
    ACTIONS(3068), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3070), 1,
      anon_sym_u2983,
    ACTIONS(3072), 1,
      anon_sym_LBRACE,
    ACTIONS(3076), 1,
      aux_sym__qid_token1,
    ACTIONS(3078), 1,
      anon_sym_DOT,
    ACTIONS(3080), 1,
      anon_sym_tactic,
    ACTIONS(3082), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3084), 1,
      anon_sym_u2987,
    ACTIONS(3088), 1,
      anon_sym_Set,
    ACTIONS(4220), 1,
      sym_id,
    STATE(3892), 1,
      aux_sym__atoms,
    STATE(6084), 1,
      sym__qid,
    STATE(6427), 1,
      sym_atom,
    STATE(8123), 1,
      sym__LAMBDA,
    STATE(8396), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3086), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6715), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6714), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3062), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10133), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [391096] = 30,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(2944), 1,
      anon_sym_BSLASH,
    ACTIONS(2946), 1,
      anon_sym_u03bb,
    ACTIONS(2964), 1,
      anon_sym_quoteGoal,
    ACTIONS(2966), 1,
      anon_sym_tactic,
    ACTIONS(2972), 1,
      anon_sym_let,
    ACTIONS(5952), 1,
      sym_id,
    ACTIONS(5956), 1,
      anon_sym_record,
    ACTIONS(5958), 1,
      anon_sym_LPAREN,
    ACTIONS(5960), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(5962), 1,
      anon_sym_u2983,
    ACTIONS(5964), 1,
      anon_sym_LBRACE,
    ACTIONS(5966), 1,
      aux_sym__qid_token1,
    ACTIONS(5968), 1,
      anon_sym_DOT,
    ACTIONS(5970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(5972), 1,
      anon_sym_u2987,
    ACTIONS(5976), 1,
      anon_sym_Set,
    STATE(3731), 1,
      aux_sym__with_exprs_repeat1,
    STATE(3764), 1,
      aux_sym__atoms,
    STATE(6277), 1,
      sym_atom,
    STATE(8126), 1,
      sym__LAMBDA,
    STATE(8418), 1,
      sym__FORALL,
    STATE(8939), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2940), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(5974), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6213), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6217), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(5954), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [391212] = 31,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(1302), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(10406), 1,
      sym__binding_ids_and_absurds,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9810), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [391330] = 31,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(1302), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(10482), 1,
      sym__binding_ids_and_absurds,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9787), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [391448] = 30,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(3020), 1,
      anon_sym_BSLASH,
    ACTIONS(3022), 1,
      anon_sym_u03bb,
    ACTIONS(3040), 1,
      anon_sym_quoteGoal,
    ACTIONS(3042), 1,
      anon_sym_tactic,
    ACTIONS(3048), 1,
      anon_sym_let,
    ACTIONS(5978), 1,
      sym_id,
    ACTIONS(5982), 1,
      anon_sym_record,
    ACTIONS(5984), 1,
      anon_sym_LPAREN,
    ACTIONS(5986), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(5988), 1,
      anon_sym_u2983,
    ACTIONS(5990), 1,
      anon_sym_LBRACE,
    ACTIONS(5992), 1,
      aux_sym__qid_token1,
    ACTIONS(5994), 1,
      anon_sym_DOT,
    ACTIONS(5996), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(5998), 1,
      anon_sym_u2987,
    ACTIONS(6002), 1,
      anon_sym_Set,
    STATE(3760), 1,
      aux_sym__with_exprs_repeat1,
    STATE(3826), 1,
      aux_sym__atoms,
    STATE(5749), 1,
      sym_atom,
    STATE(8127), 1,
      sym__LAMBDA,
    STATE(8388), 1,
      sym__FORALL,
    STATE(8978), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3018), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(6000), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5765), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5767), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(5980), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [391564] = 30,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(1302), 1,
      anon_sym_let,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(5218), 1,
      sym_id,
    ACTIONS(5224), 1,
      anon_sym_record,
    ACTIONS(5226), 1,
      anon_sym_LPAREN,
    ACTIONS(5228), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(5230), 1,
      anon_sym_u2983,
    ACTIONS(5232), 1,
      anon_sym_LBRACE,
    ACTIONS(5234), 1,
      aux_sym__qid_token1,
    ACTIONS(5236), 1,
      anon_sym_DOT,
    ACTIONS(5238), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(5240), 1,
      anon_sym_u2987,
    ACTIONS(5244), 1,
      anon_sym_Set,
    STATE(2406), 1,
      sym__ARROW,
    STATE(4004), 1,
      aux_sym__atoms,
    STATE(6203), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(5242), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(6004), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(6166), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6188), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8997), 7,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(5222), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [391680] = 31,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(1302), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(10598), 1,
      sym__binding_ids_and_absurds,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9759), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [391798] = 30,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(964), 1,
      anon_sym_quoteGoal,
    ACTIONS(972), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4214), 1,
      anon_sym_BSLASH,
    ACTIONS(4216), 1,
      anon_sym_u03bb,
    ACTIONS(4218), 1,
      anon_sym_tactic,
    STATE(3891), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8047), 1,
      sym__LAMBDA,
    STATE(8355), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(942), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9848), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [391914] = 30,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(878), 1,
      anon_sym_quoteGoal,
    ACTIONS(886), 1,
      anon_sym_let,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(4182), 1,
      sym_id,
    ACTIONS(4184), 1,
      anon_sym_BSLASH,
    ACTIONS(4186), 1,
      anon_sym_u03bb,
    ACTIONS(4190), 1,
      anon_sym_record,
    ACTIONS(4192), 1,
      anon_sym_LPAREN,
    ACTIONS(4194), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4196), 1,
      anon_sym_u2983,
    ACTIONS(4198), 1,
      anon_sym_LBRACE,
    ACTIONS(4200), 1,
      aux_sym__qid_token1,
    ACTIONS(4202), 1,
      anon_sym_DOT,
    ACTIONS(4204), 1,
      anon_sym_tactic,
    ACTIONS(4206), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4208), 1,
      anon_sym_u2987,
    ACTIONS(4212), 1,
      anon_sym_Set,
    STATE(3888), 1,
      aux_sym__atoms,
    STATE(6121), 1,
      sym__qid,
    STATE(6386), 1,
      sym_atom,
    STATE(8067), 1,
      sym__LAMBDA,
    STATE(8369), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(852), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4210), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6575), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6565), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(4188), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9852), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [392030] = 30,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(3486), 1,
      anon_sym_BSLASH,
    ACTIONS(3488), 1,
      anon_sym_u03bb,
    ACTIONS(3506), 1,
      anon_sym_quoteGoal,
    ACTIONS(3508), 1,
      anon_sym_tactic,
    ACTIONS(3514), 1,
      anon_sym_let,
    ACTIONS(5814), 1,
      sym_id,
    ACTIONS(5818), 1,
      anon_sym_record,
    ACTIONS(5820), 1,
      anon_sym_LPAREN,
    ACTIONS(5822), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(5824), 1,
      anon_sym_u2983,
    ACTIONS(5826), 1,
      anon_sym_LBRACE,
    ACTIONS(5828), 1,
      aux_sym__qid_token1,
    ACTIONS(5830), 1,
      anon_sym_DOT,
    ACTIONS(5832), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(5834), 1,
      anon_sym_u2987,
    ACTIONS(5838), 1,
      anon_sym_Set,
    STATE(3736), 1,
      aux_sym__with_exprs_repeat1,
    STATE(3767), 1,
      aux_sym__atoms,
    STATE(4780), 1,
      sym_atom,
    STATE(8140), 1,
      sym__LAMBDA,
    STATE(8504), 1,
      sym__FORALL,
    STATE(8939), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3484), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(5836), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4860), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4868), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(5816), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [392146] = 30,
    ACTIONS(710), 1,
      anon_sym_DASH,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(920), 1,
      anon_sym_quoteGoal,
    ACTIONS(928), 1,
      anon_sym_let,
    ACTIONS(3058), 1,
      anon_sym_BSLASH,
    ACTIONS(3060), 1,
      anon_sym_u03bb,
    ACTIONS(3064), 1,
      anon_sym_record,
    ACTIONS(3066), 1,
      anon_sym_LPAREN,
    ACTIONS(3068), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3070), 1,
      anon_sym_u2983,
    ACTIONS(3072), 1,
      anon_sym_LBRACE,
    ACTIONS(3076), 1,
      aux_sym__qid_token1,
    ACTIONS(3078), 1,
      anon_sym_DOT,
    ACTIONS(3080), 1,
      anon_sym_tactic,
    ACTIONS(3082), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3084), 1,
      anon_sym_u2987,
    ACTIONS(3088), 1,
      anon_sym_Set,
    ACTIONS(4220), 1,
      sym_id,
    STATE(3892), 1,
      aux_sym__atoms,
    STATE(6084), 1,
      sym__qid,
    STATE(6427), 1,
      sym_atom,
    STATE(8123), 1,
      sym__LAMBDA,
    STATE(8396), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3086), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6715), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6714), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3062), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9860), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [392262] = 30,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(964), 1,
      anon_sym_quoteGoal,
    ACTIONS(972), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4214), 1,
      anon_sym_BSLASH,
    ACTIONS(4216), 1,
      anon_sym_u03bb,
    ACTIONS(4218), 1,
      anon_sym_tactic,
    STATE(3891), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8047), 1,
      sym__LAMBDA,
    STATE(8355), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(942), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10205), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [392378] = 31,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(1302), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(11612), 1,
      sym__binding_ids_and_absurds,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(10012), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [392496] = 30,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(964), 1,
      anon_sym_quoteGoal,
    ACTIONS(972), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4214), 1,
      anon_sym_BSLASH,
    ACTIONS(4216), 1,
      anon_sym_u03bb,
    ACTIONS(4218), 1,
      anon_sym_tactic,
    STATE(3891), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8047), 1,
      sym__LAMBDA,
    STATE(8355), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(942), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10116), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [392612] = 30,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(878), 1,
      anon_sym_quoteGoal,
    ACTIONS(886), 1,
      anon_sym_let,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(4182), 1,
      sym_id,
    ACTIONS(4184), 1,
      anon_sym_BSLASH,
    ACTIONS(4186), 1,
      anon_sym_u03bb,
    ACTIONS(4190), 1,
      anon_sym_record,
    ACTIONS(4192), 1,
      anon_sym_LPAREN,
    ACTIONS(4194), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4196), 1,
      anon_sym_u2983,
    ACTIONS(4198), 1,
      anon_sym_LBRACE,
    ACTIONS(4200), 1,
      aux_sym__qid_token1,
    ACTIONS(4202), 1,
      anon_sym_DOT,
    ACTIONS(4204), 1,
      anon_sym_tactic,
    ACTIONS(4206), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4208), 1,
      anon_sym_u2987,
    ACTIONS(4212), 1,
      anon_sym_Set,
    STATE(3888), 1,
      aux_sym__atoms,
    STATE(6121), 1,
      sym__qid,
    STATE(6386), 1,
      sym_atom,
    STATE(8067), 1,
      sym__LAMBDA,
    STATE(8369), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(852), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4210), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6575), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6565), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(4188), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10117), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [392728] = 30,
    ACTIONS(710), 1,
      anon_sym_DASH,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(920), 1,
      anon_sym_quoteGoal,
    ACTIONS(928), 1,
      anon_sym_let,
    ACTIONS(3058), 1,
      anon_sym_BSLASH,
    ACTIONS(3060), 1,
      anon_sym_u03bb,
    ACTIONS(3064), 1,
      anon_sym_record,
    ACTIONS(3066), 1,
      anon_sym_LPAREN,
    ACTIONS(3068), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3070), 1,
      anon_sym_u2983,
    ACTIONS(3072), 1,
      anon_sym_LBRACE,
    ACTIONS(3076), 1,
      aux_sym__qid_token1,
    ACTIONS(3078), 1,
      anon_sym_DOT,
    ACTIONS(3080), 1,
      anon_sym_tactic,
    ACTIONS(3082), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3084), 1,
      anon_sym_u2987,
    ACTIONS(3088), 1,
      anon_sym_Set,
    ACTIONS(4220), 1,
      sym_id,
    STATE(3892), 1,
      aux_sym__atoms,
    STATE(6084), 1,
      sym__qid,
    STATE(6427), 1,
      sym_atom,
    STATE(8123), 1,
      sym__LAMBDA,
    STATE(8396), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3086), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6715), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6714), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3062), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10119), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [392844] = 30,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(964), 1,
      anon_sym_quoteGoal,
    ACTIONS(972), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4214), 1,
      anon_sym_BSLASH,
    ACTIONS(4216), 1,
      anon_sym_u03bb,
    ACTIONS(4218), 1,
      anon_sym_tactic,
    STATE(3891), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8047), 1,
      sym__LAMBDA,
    STATE(8355), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(942), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9942), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [392960] = 30,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(3410), 1,
      anon_sym_BSLASH,
    ACTIONS(3412), 1,
      anon_sym_u03bb,
    ACTIONS(3430), 1,
      anon_sym_quoteGoal,
    ACTIONS(3432), 1,
      anon_sym_tactic,
    ACTIONS(3438), 1,
      anon_sym_let,
    ACTIONS(5468), 1,
      sym_id,
    ACTIONS(5472), 1,
      anon_sym_record,
    ACTIONS(5474), 1,
      anon_sym_LPAREN,
    ACTIONS(5476), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(5478), 1,
      anon_sym_u2983,
    ACTIONS(5480), 1,
      anon_sym_LBRACE,
    ACTIONS(5482), 1,
      aux_sym__qid_token1,
    ACTIONS(5484), 1,
      anon_sym_DOT,
    ACTIONS(5486), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(5488), 1,
      anon_sym_u2987,
    ACTIONS(5492), 1,
      anon_sym_Set,
    STATE(3727), 1,
      aux_sym__with_exprs_repeat1,
    STATE(3875), 1,
      aux_sym__atoms,
    STATE(4421), 1,
      sym_atom,
    STATE(8038), 1,
      sym__LAMBDA,
    STATE(8435), 1,
      sym__FORALL,
    STATE(9092), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3408), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(5490), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4533), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4527), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(5470), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [393076] = 30,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(878), 1,
      anon_sym_quoteGoal,
    ACTIONS(886), 1,
      anon_sym_let,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(4182), 1,
      sym_id,
    ACTIONS(4184), 1,
      anon_sym_BSLASH,
    ACTIONS(4186), 1,
      anon_sym_u03bb,
    ACTIONS(4190), 1,
      anon_sym_record,
    ACTIONS(4192), 1,
      anon_sym_LPAREN,
    ACTIONS(4194), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4196), 1,
      anon_sym_u2983,
    ACTIONS(4198), 1,
      anon_sym_LBRACE,
    ACTIONS(4200), 1,
      aux_sym__qid_token1,
    ACTIONS(4202), 1,
      anon_sym_DOT,
    ACTIONS(4204), 1,
      anon_sym_tactic,
    ACTIONS(4206), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4208), 1,
      anon_sym_u2987,
    ACTIONS(4212), 1,
      anon_sym_Set,
    STATE(3888), 1,
      aux_sym__atoms,
    STATE(6121), 1,
      sym__qid,
    STATE(6386), 1,
      sym_atom,
    STATE(8067), 1,
      sym__LAMBDA,
    STATE(8369), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(852), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4210), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6575), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6565), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(4188), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10075), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [393192] = 30,
    ACTIONS(710), 1,
      anon_sym_DASH,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(920), 1,
      anon_sym_quoteGoal,
    ACTIONS(928), 1,
      anon_sym_let,
    ACTIONS(3058), 1,
      anon_sym_BSLASH,
    ACTIONS(3060), 1,
      anon_sym_u03bb,
    ACTIONS(3064), 1,
      anon_sym_record,
    ACTIONS(3066), 1,
      anon_sym_LPAREN,
    ACTIONS(3068), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3070), 1,
      anon_sym_u2983,
    ACTIONS(3072), 1,
      anon_sym_LBRACE,
    ACTIONS(3076), 1,
      aux_sym__qid_token1,
    ACTIONS(3078), 1,
      anon_sym_DOT,
    ACTIONS(3080), 1,
      anon_sym_tactic,
    ACTIONS(3082), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3084), 1,
      anon_sym_u2987,
    ACTIONS(3088), 1,
      anon_sym_Set,
    ACTIONS(4220), 1,
      sym_id,
    STATE(3892), 1,
      aux_sym__atoms,
    STATE(6084), 1,
      sym__qid,
    STATE(6427), 1,
      sym_atom,
    STATE(8123), 1,
      sym__LAMBDA,
    STATE(8396), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3086), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6715), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6714), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3062), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9913), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [393308] = 30,
    ACTIONS(710), 1,
      anon_sym_DASH,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(920), 1,
      anon_sym_quoteGoal,
    ACTIONS(928), 1,
      anon_sym_let,
    ACTIONS(3058), 1,
      anon_sym_BSLASH,
    ACTIONS(3060), 1,
      anon_sym_u03bb,
    ACTIONS(3064), 1,
      anon_sym_record,
    ACTIONS(3066), 1,
      anon_sym_LPAREN,
    ACTIONS(3068), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3070), 1,
      anon_sym_u2983,
    ACTIONS(3072), 1,
      anon_sym_LBRACE,
    ACTIONS(3076), 1,
      aux_sym__qid_token1,
    ACTIONS(3078), 1,
      anon_sym_DOT,
    ACTIONS(3080), 1,
      anon_sym_tactic,
    ACTIONS(3082), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3084), 1,
      anon_sym_u2987,
    ACTIONS(3088), 1,
      anon_sym_Set,
    ACTIONS(4220), 1,
      sym_id,
    STATE(3892), 1,
      aux_sym__atoms,
    STATE(6084), 1,
      sym__qid,
    STATE(6427), 1,
      sym_atom,
    STATE(8123), 1,
      sym__LAMBDA,
    STATE(8396), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3086), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6715), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6714), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3062), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10188), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [393424] = 30,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(3818), 1,
      anon_sym_BSLASH,
    ACTIONS(3820), 1,
      anon_sym_u03bb,
    ACTIONS(3838), 1,
      anon_sym_quoteGoal,
    ACTIONS(3840), 1,
      anon_sym_tactic,
    ACTIONS(3846), 1,
      anon_sym_let,
    ACTIONS(6006), 1,
      sym_id,
    ACTIONS(6010), 1,
      anon_sym_record,
    ACTIONS(6012), 1,
      anon_sym_LPAREN,
    ACTIONS(6014), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(6016), 1,
      anon_sym_u2983,
    ACTIONS(6018), 1,
      anon_sym_LBRACE,
    ACTIONS(6020), 1,
      aux_sym__qid_token1,
    ACTIONS(6022), 1,
      anon_sym_DOT,
    ACTIONS(6024), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(6026), 1,
      anon_sym_u2987,
    ACTIONS(6030), 1,
      anon_sym_Set,
    STATE(3716), 1,
      aux_sym__with_exprs_repeat1,
    STATE(3828), 1,
      aux_sym__atoms,
    STATE(4773), 1,
      sym_atom,
    STATE(8085), 1,
      sym__LAMBDA,
    STATE(8442), 1,
      sym__FORALL,
    STATE(8939), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3816), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(6028), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4881), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4870), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(6008), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [393540] = 30,
    ACTIONS(710), 1,
      anon_sym_DASH,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(920), 1,
      anon_sym_quoteGoal,
    ACTIONS(928), 1,
      anon_sym_let,
    ACTIONS(3058), 1,
      anon_sym_BSLASH,
    ACTIONS(3060), 1,
      anon_sym_u03bb,
    ACTIONS(3064), 1,
      anon_sym_record,
    ACTIONS(3066), 1,
      anon_sym_LPAREN,
    ACTIONS(3068), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3070), 1,
      anon_sym_u2983,
    ACTIONS(3072), 1,
      anon_sym_LBRACE,
    ACTIONS(3076), 1,
      aux_sym__qid_token1,
    ACTIONS(3078), 1,
      anon_sym_DOT,
    ACTIONS(3080), 1,
      anon_sym_tactic,
    ACTIONS(3082), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3084), 1,
      anon_sym_u2987,
    ACTIONS(3088), 1,
      anon_sym_Set,
    ACTIONS(4220), 1,
      sym_id,
    STATE(3892), 1,
      aux_sym__atoms,
    STATE(6084), 1,
      sym__qid,
    STATE(6427), 1,
      sym_atom,
    STATE(8123), 1,
      sym__LAMBDA,
    STATE(8396), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3086), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6715), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6714), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3062), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9864), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [393656] = 30,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(964), 1,
      anon_sym_quoteGoal,
    ACTIONS(972), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4214), 1,
      anon_sym_BSLASH,
    ACTIONS(4216), 1,
      anon_sym_u03bb,
    ACTIONS(4218), 1,
      anon_sym_tactic,
    STATE(3891), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8047), 1,
      sym__LAMBDA,
    STATE(8355), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(942), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9790), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [393772] = 30,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(3448), 1,
      anon_sym_BSLASH,
    ACTIONS(3450), 1,
      anon_sym_u03bb,
    ACTIONS(3468), 1,
      anon_sym_quoteGoal,
    ACTIONS(3470), 1,
      anon_sym_tactic,
    ACTIONS(3476), 1,
      anon_sym_let,
    ACTIONS(6032), 1,
      sym_id,
    ACTIONS(6036), 1,
      anon_sym_record,
    ACTIONS(6038), 1,
      anon_sym_LPAREN,
    ACTIONS(6040), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(6042), 1,
      anon_sym_u2983,
    ACTIONS(6044), 1,
      anon_sym_LBRACE,
    ACTIONS(6046), 1,
      aux_sym__qid_token1,
    ACTIONS(6048), 1,
      anon_sym_DOT,
    ACTIONS(6050), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(6052), 1,
      anon_sym_u2987,
    ACTIONS(6056), 1,
      anon_sym_Set,
    STATE(3742), 1,
      aux_sym__with_exprs_repeat1,
    STATE(3801), 1,
      aux_sym__atoms,
    STATE(5944), 1,
      sym_atom,
    STATE(8072), 1,
      sym__LAMBDA,
    STATE(8455), 1,
      sym__FORALL,
    STATE(8939), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3446), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(6054), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5909), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5914), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(6034), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [393888] = 30,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2022), 1,
      anon_sym_BSLASH,
    ACTIONS(2024), 1,
      anon_sym_u03bb,
    ACTIONS(2042), 1,
      anon_sym_quoteGoal,
    ACTIONS(2044), 1,
      anon_sym_tactic,
    ACTIONS(2050), 1,
      anon_sym_let,
    ACTIONS(2766), 1,
      sym_id,
    ACTIONS(2772), 1,
      anon_sym_record,
    ACTIONS(2774), 1,
      anon_sym_LPAREN,
    ACTIONS(2776), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2778), 1,
      anon_sym_u2983,
    ACTIONS(2780), 1,
      anon_sym_LBRACE,
    ACTIONS(2782), 1,
      aux_sym__qid_token1,
    ACTIONS(2784), 1,
      anon_sym_DOT,
    ACTIONS(2786), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2788), 1,
      anon_sym_u2987,
    ACTIONS(2792), 1,
      anon_sym_Set,
    STATE(1495), 1,
      sym__ARROW,
    STATE(4004), 1,
      aux_sym__atoms,
    STATE(5719), 1,
      sym_atom,
    STATE(8033), 1,
      sym__LAMBDA,
    STATE(8463), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2020), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2790), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(4282), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(5666), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5668), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8997), 7,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2770), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [394004] = 30,
    ACTIONS(710), 1,
      anon_sym_DASH,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(920), 1,
      anon_sym_quoteGoal,
    ACTIONS(928), 1,
      anon_sym_let,
    ACTIONS(3058), 1,
      anon_sym_BSLASH,
    ACTIONS(3060), 1,
      anon_sym_u03bb,
    ACTIONS(3064), 1,
      anon_sym_record,
    ACTIONS(3066), 1,
      anon_sym_LPAREN,
    ACTIONS(3068), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3070), 1,
      anon_sym_u2983,
    ACTIONS(3072), 1,
      anon_sym_LBRACE,
    ACTIONS(3076), 1,
      aux_sym__qid_token1,
    ACTIONS(3078), 1,
      anon_sym_DOT,
    ACTIONS(3080), 1,
      anon_sym_tactic,
    ACTIONS(3082), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3084), 1,
      anon_sym_u2987,
    ACTIONS(3088), 1,
      anon_sym_Set,
    ACTIONS(4220), 1,
      sym_id,
    STATE(3892), 1,
      aux_sym__atoms,
    STATE(6084), 1,
      sym__qid,
    STATE(6427), 1,
      sym_atom,
    STATE(8123), 1,
      sym__LAMBDA,
    STATE(8396), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3086), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6715), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6714), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3062), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9888), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [394120] = 3,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(394), 2,
      sym__dedent,
      anon_sym_BSLASH,
    ACTIONS(4240), 52,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_field,
      anon_sym_instance,
      anon_sym_module,
      anon_sym_data,
      anon_sym_codata,
      anon_sym_record,
      anon_sym_infix,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_variable,
      anon_sym_mutual,
      anon_sym_abstract,
      anon_sym_private,
      anon_sym_macro,
      anon_sym_postulate,
      anon_sym_primitive,
      anon_sym_open,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      sym_pragma,
      anon_sym_syntax,
      anon_sym_LBRACE,
      anon_sym_pattern,
      anon_sym_unquoteDecl,
      anon_sym_unquoteDef,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_AT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [394182] = 30,
    ACTIONS(710), 1,
      anon_sym_DASH,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(920), 1,
      anon_sym_quoteGoal,
    ACTIONS(928), 1,
      anon_sym_let,
    ACTIONS(3058), 1,
      anon_sym_BSLASH,
    ACTIONS(3060), 1,
      anon_sym_u03bb,
    ACTIONS(3064), 1,
      anon_sym_record,
    ACTIONS(3066), 1,
      anon_sym_LPAREN,
    ACTIONS(3068), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3070), 1,
      anon_sym_u2983,
    ACTIONS(3072), 1,
      anon_sym_LBRACE,
    ACTIONS(3076), 1,
      aux_sym__qid_token1,
    ACTIONS(3078), 1,
      anon_sym_DOT,
    ACTIONS(3080), 1,
      anon_sym_tactic,
    ACTIONS(3082), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3084), 1,
      anon_sym_u2987,
    ACTIONS(3088), 1,
      anon_sym_Set,
    ACTIONS(4220), 1,
      sym_id,
    STATE(3892), 1,
      aux_sym__atoms,
    STATE(6084), 1,
      sym__qid,
    STATE(6427), 1,
      sym_atom,
    STATE(8123), 1,
      sym__LAMBDA,
    STATE(8396), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3086), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6715), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6714), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3062), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9707), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [394298] = 30,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(878), 1,
      anon_sym_quoteGoal,
    ACTIONS(886), 1,
      anon_sym_let,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(4182), 1,
      sym_id,
    ACTIONS(4184), 1,
      anon_sym_BSLASH,
    ACTIONS(4186), 1,
      anon_sym_u03bb,
    ACTIONS(4190), 1,
      anon_sym_record,
    ACTIONS(4192), 1,
      anon_sym_LPAREN,
    ACTIONS(4194), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4196), 1,
      anon_sym_u2983,
    ACTIONS(4198), 1,
      anon_sym_LBRACE,
    ACTIONS(4200), 1,
      aux_sym__qid_token1,
    ACTIONS(4202), 1,
      anon_sym_DOT,
    ACTIONS(4204), 1,
      anon_sym_tactic,
    ACTIONS(4206), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4208), 1,
      anon_sym_u2987,
    ACTIONS(4212), 1,
      anon_sym_Set,
    STATE(3888), 1,
      aux_sym__atoms,
    STATE(6121), 1,
      sym__qid,
    STATE(6386), 1,
      sym_atom,
    STATE(8067), 1,
      sym__LAMBDA,
    STATE(8369), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(852), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4210), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6575), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6565), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(4188), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9867), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [394414] = 30,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(878), 1,
      anon_sym_quoteGoal,
    ACTIONS(886), 1,
      anon_sym_let,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(4182), 1,
      sym_id,
    ACTIONS(4184), 1,
      anon_sym_BSLASH,
    ACTIONS(4186), 1,
      anon_sym_u03bb,
    ACTIONS(4190), 1,
      anon_sym_record,
    ACTIONS(4192), 1,
      anon_sym_LPAREN,
    ACTIONS(4194), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4196), 1,
      anon_sym_u2983,
    ACTIONS(4198), 1,
      anon_sym_LBRACE,
    ACTIONS(4200), 1,
      aux_sym__qid_token1,
    ACTIONS(4202), 1,
      anon_sym_DOT,
    ACTIONS(4204), 1,
      anon_sym_tactic,
    ACTIONS(4206), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4208), 1,
      anon_sym_u2987,
    ACTIONS(4212), 1,
      anon_sym_Set,
    STATE(3888), 1,
      aux_sym__atoms,
    STATE(6121), 1,
      sym__qid,
    STATE(6386), 1,
      sym_atom,
    STATE(8067), 1,
      sym__LAMBDA,
    STATE(8369), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(852), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4210), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6575), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6565), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(4188), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9708), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [394530] = 30,
    ACTIONS(710), 1,
      anon_sym_DASH,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(920), 1,
      anon_sym_quoteGoal,
    ACTIONS(928), 1,
      anon_sym_let,
    ACTIONS(3058), 1,
      anon_sym_BSLASH,
    ACTIONS(3060), 1,
      anon_sym_u03bb,
    ACTIONS(3064), 1,
      anon_sym_record,
    ACTIONS(3066), 1,
      anon_sym_LPAREN,
    ACTIONS(3068), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3070), 1,
      anon_sym_u2983,
    ACTIONS(3072), 1,
      anon_sym_LBRACE,
    ACTIONS(3076), 1,
      aux_sym__qid_token1,
    ACTIONS(3078), 1,
      anon_sym_DOT,
    ACTIONS(3080), 1,
      anon_sym_tactic,
    ACTIONS(3082), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3084), 1,
      anon_sym_u2987,
    ACTIONS(3088), 1,
      anon_sym_Set,
    ACTIONS(4220), 1,
      sym_id,
    STATE(3892), 1,
      aux_sym__atoms,
    STATE(6084), 1,
      sym__qid,
    STATE(6427), 1,
      sym_atom,
    STATE(8123), 1,
      sym__LAMBDA,
    STATE(8396), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3086), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6715), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6714), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3062), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9728), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [394646] = 30,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(964), 1,
      anon_sym_quoteGoal,
    ACTIONS(972), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4214), 1,
      anon_sym_BSLASH,
    ACTIONS(4216), 1,
      anon_sym_u03bb,
    ACTIONS(4218), 1,
      anon_sym_tactic,
    STATE(3891), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8047), 1,
      sym__LAMBDA,
    STATE(8355), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(942), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10042), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [394762] = 30,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(878), 1,
      anon_sym_quoteGoal,
    ACTIONS(886), 1,
      anon_sym_let,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(4182), 1,
      sym_id,
    ACTIONS(4184), 1,
      anon_sym_BSLASH,
    ACTIONS(4186), 1,
      anon_sym_u03bb,
    ACTIONS(4190), 1,
      anon_sym_record,
    ACTIONS(4192), 1,
      anon_sym_LPAREN,
    ACTIONS(4194), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4196), 1,
      anon_sym_u2983,
    ACTIONS(4198), 1,
      anon_sym_LBRACE,
    ACTIONS(4200), 1,
      aux_sym__qid_token1,
    ACTIONS(4202), 1,
      anon_sym_DOT,
    ACTIONS(4204), 1,
      anon_sym_tactic,
    ACTIONS(4206), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4208), 1,
      anon_sym_u2987,
    ACTIONS(4212), 1,
      anon_sym_Set,
    STATE(3888), 1,
      aux_sym__atoms,
    STATE(6121), 1,
      sym__qid,
    STATE(6386), 1,
      sym_atom,
    STATE(8067), 1,
      sym__LAMBDA,
    STATE(8369), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(852), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4210), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6575), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6565), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(4188), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9725), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [394878] = 30,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(878), 1,
      anon_sym_quoteGoal,
    ACTIONS(886), 1,
      anon_sym_let,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(4182), 1,
      sym_id,
    ACTIONS(4184), 1,
      anon_sym_BSLASH,
    ACTIONS(4186), 1,
      anon_sym_u03bb,
    ACTIONS(4190), 1,
      anon_sym_record,
    ACTIONS(4192), 1,
      anon_sym_LPAREN,
    ACTIONS(4194), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4196), 1,
      anon_sym_u2983,
    ACTIONS(4198), 1,
      anon_sym_LBRACE,
    ACTIONS(4200), 1,
      aux_sym__qid_token1,
    ACTIONS(4202), 1,
      anon_sym_DOT,
    ACTIONS(4204), 1,
      anon_sym_tactic,
    ACTIONS(4206), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4208), 1,
      anon_sym_u2987,
    ACTIONS(4212), 1,
      anon_sym_Set,
    STATE(3888), 1,
      aux_sym__atoms,
    STATE(6121), 1,
      sym__qid,
    STATE(6386), 1,
      sym_atom,
    STATE(8067), 1,
      sym__LAMBDA,
    STATE(8369), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(852), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4210), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6575), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6565), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(4188), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10132), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [394994] = 30,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(964), 1,
      anon_sym_quoteGoal,
    ACTIONS(972), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4214), 1,
      anon_sym_BSLASH,
    ACTIONS(4216), 1,
      anon_sym_u03bb,
    ACTIONS(4218), 1,
      anon_sym_tactic,
    STATE(3891), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8047), 1,
      sym__LAMBDA,
    STATE(8355), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(942), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9723), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [395110] = 30,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(2904), 1,
      anon_sym_BSLASH,
    ACTIONS(2906), 1,
      anon_sym_u03bb,
    ACTIONS(2924), 1,
      anon_sym_quoteGoal,
    ACTIONS(2926), 1,
      anon_sym_tactic,
    ACTIONS(2932), 1,
      anon_sym_let,
    ACTIONS(6058), 1,
      sym_id,
    ACTIONS(6062), 1,
      anon_sym_record,
    ACTIONS(6064), 1,
      anon_sym_LPAREN,
    ACTIONS(6066), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(6068), 1,
      anon_sym_u2983,
    ACTIONS(6070), 1,
      anon_sym_LBRACE,
    ACTIONS(6072), 1,
      aux_sym__qid_token1,
    ACTIONS(6074), 1,
      anon_sym_DOT,
    ACTIONS(6076), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(6078), 1,
      anon_sym_u2987,
    ACTIONS(6082), 1,
      anon_sym_Set,
    STATE(3756), 1,
      aux_sym__with_exprs_repeat1,
    STATE(3773), 1,
      aux_sym__atoms,
    STATE(4278), 1,
      sym_atom,
    STATE(8094), 1,
      sym__LAMBDA,
    STATE(8489), 1,
      sym__FORALL,
    STATE(8939), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2900), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(6080), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4341), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4349), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(6060), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [395226] = 30,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(964), 1,
      anon_sym_quoteGoal,
    ACTIONS(972), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4214), 1,
      anon_sym_BSLASH,
    ACTIONS(4216), 1,
      anon_sym_u03bb,
    ACTIONS(4218), 1,
      anon_sym_tactic,
    STATE(3891), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8047), 1,
      sym__LAMBDA,
    STATE(8355), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(942), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9709), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [395342] = 31,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(1302), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(10543), 1,
      sym__binding_ids_and_absurds,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9928), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [395460] = 31,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(1302), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(10962), 1,
      sym__binding_ids_and_absurds,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9863), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [395578] = 30,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(5760), 1,
      sym_id,
    ACTIONS(5764), 1,
      anon_sym_record,
    ACTIONS(5766), 1,
      anon_sym_LPAREN,
    ACTIONS(5768), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(5770), 1,
      anon_sym_u2983,
    ACTIONS(5772), 1,
      anon_sym_LBRACE,
    ACTIONS(5774), 1,
      aux_sym__qid_token1,
    ACTIONS(5776), 1,
      anon_sym_DOT,
    ACTIONS(5778), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(5780), 1,
      anon_sym_u2987,
    ACTIONS(5784), 1,
      anon_sym_Set,
    STATE(3728), 1,
      aux_sym__with_exprs_repeat1,
    STATE(3771), 1,
      aux_sym__atoms,
    STATE(5927), 1,
      sym_atom,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    STATE(8978), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(5782), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5941), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5965), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(5762), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [395694] = 30,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(1870), 1,
      anon_sym_BSLASH,
    ACTIONS(1872), 1,
      anon_sym_u03bb,
    ACTIONS(1890), 1,
      anon_sym_quoteGoal,
    ACTIONS(1892), 1,
      anon_sym_tactic,
    ACTIONS(1898), 1,
      anon_sym_let,
    ACTIONS(3666), 1,
      sym_id,
    ACTIONS(3672), 1,
      anon_sym_record,
    ACTIONS(3674), 1,
      anon_sym_LPAREN,
    ACTIONS(3676), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3678), 1,
      anon_sym_u2983,
    ACTIONS(3680), 1,
      anon_sym_LBRACE,
    ACTIONS(3682), 1,
      aux_sym__qid_token1,
    ACTIONS(3684), 1,
      anon_sym_DOT,
    ACTIONS(3686), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3688), 1,
      anon_sym_u2987,
    ACTIONS(3692), 1,
      anon_sym_Set,
    STATE(1413), 1,
      sym__ARROW,
    STATE(4004), 1,
      aux_sym__atoms,
    STATE(4587), 1,
      sym_atom,
    STATE(8032), 1,
      sym__LAMBDA,
    STATE(8379), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1868), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3690), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(4458), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(4585), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4584), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9001), 7,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3670), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [395810] = 30,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(964), 1,
      anon_sym_quoteGoal,
    ACTIONS(972), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4214), 1,
      anon_sym_BSLASH,
    ACTIONS(4216), 1,
      anon_sym_u03bb,
    ACTIONS(4218), 1,
      anon_sym_tactic,
    STATE(3891), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8047), 1,
      sym__LAMBDA,
    STATE(8355), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(942), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9983), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [395926] = 31,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(1302), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(10940), 1,
      sym__binding_ids_and_absurds,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9720), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [396044] = 30,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(2350), 1,
      anon_sym_BSLASH,
    ACTIONS(2352), 1,
      anon_sym_u03bb,
    ACTIONS(2370), 1,
      anon_sym_quoteGoal,
    ACTIONS(2372), 1,
      anon_sym_tactic,
    ACTIONS(2378), 1,
      anon_sym_let,
    ACTIONS(3786), 1,
      sym_id,
    ACTIONS(3792), 1,
      anon_sym_record,
    ACTIONS(3794), 1,
      anon_sym_LPAREN,
    ACTIONS(3796), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3798), 1,
      anon_sym_u2983,
    ACTIONS(3800), 1,
      anon_sym_LBRACE,
    ACTIONS(3802), 1,
      aux_sym__qid_token1,
    ACTIONS(3804), 1,
      anon_sym_DOT,
    ACTIONS(3806), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3808), 1,
      anon_sym_u2987,
    ACTIONS(3812), 1,
      anon_sym_Set,
    STATE(1487), 1,
      sym__ARROW,
    STATE(4004), 1,
      aux_sym__atoms,
    STATE(4255), 1,
      sym_atom,
    STATE(8119), 1,
      sym__LAMBDA,
    STATE(8372), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2348), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3810), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(6084), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(4284), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4282), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9001), 7,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3790), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [396160] = 31,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(1302), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(11127), 1,
      sym__binding_ids_and_absurds,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9834), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [396278] = 30,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(3096), 1,
      anon_sym_BSLASH,
    ACTIONS(3098), 1,
      anon_sym_u03bb,
    ACTIONS(3116), 1,
      anon_sym_quoteGoal,
    ACTIONS(3118), 1,
      anon_sym_tactic,
    ACTIONS(3124), 1,
      anon_sym_let,
    ACTIONS(6086), 1,
      sym_id,
    ACTIONS(6090), 1,
      anon_sym_record,
    ACTIONS(6092), 1,
      anon_sym_LPAREN,
    ACTIONS(6094), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(6096), 1,
      anon_sym_u2983,
    ACTIONS(6098), 1,
      anon_sym_LBRACE,
    ACTIONS(6100), 1,
      aux_sym__qid_token1,
    ACTIONS(6102), 1,
      anon_sym_DOT,
    ACTIONS(6104), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(6106), 1,
      anon_sym_u2987,
    ACTIONS(6110), 1,
      anon_sym_Set,
    STATE(3705), 1,
      aux_sym__with_exprs_repeat1,
    STATE(3814), 1,
      aux_sym__atoms,
    STATE(4488), 1,
      sym_atom,
    STATE(8099), 1,
      sym__LAMBDA,
    STATE(8393), 1,
      sym__FORALL,
    STATE(8939), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3092), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(6108), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4522), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4523), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(6088), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [396394] = 30,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(964), 1,
      anon_sym_quoteGoal,
    ACTIONS(972), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4214), 1,
      anon_sym_BSLASH,
    ACTIONS(4216), 1,
      anon_sym_u03bb,
    ACTIONS(4218), 1,
      anon_sym_tactic,
    STATE(3891), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8047), 1,
      sym__LAMBDA,
    STATE(8355), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(942), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9868), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [396510] = 30,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2140), 1,
      anon_sym_BSLASH,
    ACTIONS(2142), 1,
      anon_sym_u03bb,
    ACTIONS(2160), 1,
      anon_sym_quoteGoal,
    ACTIONS(2162), 1,
      anon_sym_tactic,
    ACTIONS(2168), 1,
      anon_sym_let,
    ACTIONS(6112), 1,
      sym_id,
    ACTIONS(6116), 1,
      anon_sym_record,
    ACTIONS(6118), 1,
      anon_sym_LPAREN,
    ACTIONS(6120), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(6122), 1,
      anon_sym_u2983,
    ACTIONS(6124), 1,
      anon_sym_LBRACE,
    ACTIONS(6126), 1,
      aux_sym__qid_token1,
    ACTIONS(6128), 1,
      anon_sym_DOT,
    ACTIONS(6130), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(6132), 1,
      anon_sym_u2987,
    ACTIONS(6136), 1,
      anon_sym_Set,
    STATE(3750), 1,
      aux_sym__with_exprs_repeat1,
    STATE(3874), 1,
      aux_sym__atoms,
    STATE(5942), 1,
      sym_atom,
    STATE(8040), 1,
      sym__LAMBDA,
    STATE(8460), 1,
      sym__FORALL,
    STATE(8978), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2136), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(6134), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5819), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5817), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(6114), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [396626] = 30,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(2212), 1,
      anon_sym_BSLASH,
    ACTIONS(2214), 1,
      anon_sym_u03bb,
    ACTIONS(2232), 1,
      anon_sym_quoteGoal,
    ACTIONS(2234), 1,
      anon_sym_tactic,
    ACTIONS(2240), 1,
      anon_sym_let,
    ACTIONS(6138), 1,
      sym_id,
    ACTIONS(6142), 1,
      anon_sym_record,
    ACTIONS(6144), 1,
      anon_sym_LPAREN,
    ACTIONS(6146), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(6148), 1,
      anon_sym_u2983,
    ACTIONS(6150), 1,
      anon_sym_LBRACE,
    ACTIONS(6152), 1,
      aux_sym__qid_token1,
    ACTIONS(6154), 1,
      anon_sym_DOT,
    ACTIONS(6156), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(6158), 1,
      anon_sym_u2987,
    ACTIONS(6162), 1,
      anon_sym_Set,
    STATE(3733), 1,
      aux_sym__with_exprs_repeat1,
    STATE(3803), 1,
      aux_sym__atoms,
    STATE(5008), 1,
      sym_atom,
    STATE(8035), 1,
      sym__LAMBDA,
    STATE(8402), 1,
      sym__FORALL,
    STATE(8939), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(6160), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5132), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5134), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(6140), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [396742] = 30,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(982), 1,
      anon_sym_BSLASH,
    ACTIONS(984), 1,
      anon_sym_u03bb,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(990), 1,
      anon_sym_tactic,
    ACTIONS(1302), 1,
      anon_sym_let,
    ACTIONS(5416), 1,
      sym_id,
    ACTIONS(5420), 1,
      anon_sym_record,
    ACTIONS(5422), 1,
      anon_sym_LPAREN,
    ACTIONS(5424), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(5426), 1,
      anon_sym_u2983,
    ACTIONS(5428), 1,
      anon_sym_LBRACE,
    ACTIONS(5430), 1,
      aux_sym__qid_token1,
    ACTIONS(5432), 1,
      anon_sym_DOT,
    ACTIONS(5434), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(5436), 1,
      anon_sym_u2987,
    ACTIONS(5440), 1,
      anon_sym_Set,
    STATE(3708), 1,
      aux_sym__with_exprs_repeat1,
    STATE(3850), 1,
      aux_sym__atoms,
    STATE(5548), 1,
      sym_atom,
    STATE(8095), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(8978), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(5438), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5369), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5364), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(5418), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [396858] = 30,
    ACTIONS(710), 1,
      anon_sym_DASH,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(920), 1,
      anon_sym_quoteGoal,
    ACTIONS(928), 1,
      anon_sym_let,
    ACTIONS(3058), 1,
      anon_sym_BSLASH,
    ACTIONS(3060), 1,
      anon_sym_u03bb,
    ACTIONS(3064), 1,
      anon_sym_record,
    ACTIONS(3066), 1,
      anon_sym_LPAREN,
    ACTIONS(3068), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3070), 1,
      anon_sym_u2983,
    ACTIONS(3072), 1,
      anon_sym_LBRACE,
    ACTIONS(3076), 1,
      aux_sym__qid_token1,
    ACTIONS(3078), 1,
      anon_sym_DOT,
    ACTIONS(3080), 1,
      anon_sym_tactic,
    ACTIONS(3082), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3084), 1,
      anon_sym_u2987,
    ACTIONS(3088), 1,
      anon_sym_Set,
    ACTIONS(4220), 1,
      sym_id,
    STATE(3892), 1,
      aux_sym__atoms,
    STATE(6084), 1,
      sym__qid,
    STATE(6427), 1,
      sym_atom,
    STATE(8123), 1,
      sym__LAMBDA,
    STATE(8396), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3086), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6715), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6714), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3062), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9975), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [396974] = 30,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(878), 1,
      anon_sym_quoteGoal,
    ACTIONS(886), 1,
      anon_sym_let,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(4182), 1,
      sym_id,
    ACTIONS(4184), 1,
      anon_sym_BSLASH,
    ACTIONS(4186), 1,
      anon_sym_u03bb,
    ACTIONS(4190), 1,
      anon_sym_record,
    ACTIONS(4192), 1,
      anon_sym_LPAREN,
    ACTIONS(4194), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4196), 1,
      anon_sym_u2983,
    ACTIONS(4198), 1,
      anon_sym_LBRACE,
    ACTIONS(4200), 1,
      aux_sym__qid_token1,
    ACTIONS(4202), 1,
      anon_sym_DOT,
    ACTIONS(4204), 1,
      anon_sym_tactic,
    ACTIONS(4206), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4208), 1,
      anon_sym_u2987,
    ACTIONS(4212), 1,
      anon_sym_Set,
    STATE(3888), 1,
      aux_sym__atoms,
    STATE(6121), 1,
      sym__qid,
    STATE(6386), 1,
      sym_atom,
    STATE(8067), 1,
      sym__LAMBDA,
    STATE(8369), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(852), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4210), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6575), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6565), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(4188), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9974), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [397090] = 30,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2022), 1,
      anon_sym_BSLASH,
    ACTIONS(2024), 1,
      anon_sym_u03bb,
    ACTIONS(2042), 1,
      anon_sym_quoteGoal,
    ACTIONS(2044), 1,
      anon_sym_tactic,
    ACTIONS(2050), 1,
      anon_sym_let,
    ACTIONS(2766), 1,
      sym_id,
    ACTIONS(2772), 1,
      anon_sym_record,
    ACTIONS(2774), 1,
      anon_sym_LPAREN,
    ACTIONS(2776), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2778), 1,
      anon_sym_u2983,
    ACTIONS(2780), 1,
      anon_sym_LBRACE,
    ACTIONS(2782), 1,
      aux_sym__qid_token1,
    ACTIONS(2784), 1,
      anon_sym_DOT,
    ACTIONS(2786), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2788), 1,
      anon_sym_u2987,
    ACTIONS(2792), 1,
      anon_sym_Set,
    STATE(1484), 1,
      sym__ARROW,
    STATE(4004), 1,
      aux_sym__atoms,
    STATE(5719), 1,
      sym_atom,
    STATE(8033), 1,
      sym__LAMBDA,
    STATE(8463), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2020), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2790), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(6164), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(5666), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5668), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8997), 7,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2770), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [397206] = 30,
    ACTIONS(710), 1,
      anon_sym_DASH,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(920), 1,
      anon_sym_quoteGoal,
    ACTIONS(928), 1,
      anon_sym_let,
    ACTIONS(3058), 1,
      anon_sym_BSLASH,
    ACTIONS(3060), 1,
      anon_sym_u03bb,
    ACTIONS(3064), 1,
      anon_sym_record,
    ACTIONS(3066), 1,
      anon_sym_LPAREN,
    ACTIONS(3068), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3070), 1,
      anon_sym_u2983,
    ACTIONS(3072), 1,
      anon_sym_LBRACE,
    ACTIONS(3076), 1,
      aux_sym__qid_token1,
    ACTIONS(3078), 1,
      anon_sym_DOT,
    ACTIONS(3080), 1,
      anon_sym_tactic,
    ACTIONS(3082), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3084), 1,
      anon_sym_u2987,
    ACTIONS(3088), 1,
      anon_sym_Set,
    ACTIONS(4220), 1,
      sym_id,
    STATE(3892), 1,
      aux_sym__atoms,
    STATE(6084), 1,
      sym__qid,
    STATE(6427), 1,
      sym_atom,
    STATE(8123), 1,
      sym__LAMBDA,
    STATE(8396), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3086), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6715), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6714), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3062), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10165), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [397322] = 30,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(1302), 1,
      anon_sym_let,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(5166), 1,
      sym_id,
    ACTIONS(5170), 1,
      anon_sym_record,
    ACTIONS(5172), 1,
      anon_sym_LPAREN,
    ACTIONS(5174), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(5176), 1,
      anon_sym_u2983,
    ACTIONS(5178), 1,
      anon_sym_LBRACE,
    ACTIONS(5180), 1,
      aux_sym__qid_token1,
    ACTIONS(5182), 1,
      anon_sym_DOT,
    ACTIONS(5184), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(5186), 1,
      anon_sym_u2987,
    ACTIONS(5190), 1,
      anon_sym_Set,
    STATE(3741), 1,
      aux_sym__with_exprs_repeat1,
    STATE(3813), 1,
      aux_sym__atoms,
    STATE(5916), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(8978), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(5188), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5928), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5926), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(5168), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [397438] = 30,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(3134), 1,
      anon_sym_BSLASH,
    ACTIONS(3136), 1,
      anon_sym_u03bb,
    ACTIONS(3154), 1,
      anon_sym_quoteGoal,
    ACTIONS(3156), 1,
      anon_sym_tactic,
    ACTIONS(3162), 1,
      anon_sym_let,
    ACTIONS(6166), 1,
      sym_id,
    ACTIONS(6170), 1,
      anon_sym_record,
    ACTIONS(6172), 1,
      anon_sym_LPAREN,
    ACTIONS(6174), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(6176), 1,
      anon_sym_u2983,
    ACTIONS(6178), 1,
      anon_sym_LBRACE,
    ACTIONS(6180), 1,
      aux_sym__qid_token1,
    ACTIONS(6182), 1,
      anon_sym_DOT,
    ACTIONS(6184), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(6186), 1,
      anon_sym_u2987,
    ACTIONS(6190), 1,
      anon_sym_Set,
    STATE(3719), 1,
      aux_sym__with_exprs_repeat1,
    STATE(3772), 1,
      aux_sym__atoms,
    STATE(5226), 1,
      sym_atom,
    STATE(8076), 1,
      sym__LAMBDA,
    STATE(8363), 1,
      sym__FORALL,
    STATE(8939), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3132), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(6188), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4960), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4966), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(6168), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [397554] = 30,
    ACTIONS(706), 1,
      aux_sym__qid_token1,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1904), 1,
      sym_id,
    ACTIONS(1910), 1,
      anon_sym_BSLASH,
    ACTIONS(1912), 1,
      anon_sym_u03bb,
    ACTIONS(1916), 1,
      anon_sym_record,
    ACTIONS(1918), 1,
      anon_sym_LPAREN,
    ACTIONS(1920), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1922), 1,
      anon_sym_u2983,
    ACTIONS(1924), 1,
      anon_sym_LBRACE,
    ACTIONS(1926), 1,
      anon_sym_DOT,
    ACTIONS(1928), 1,
      anon_sym_quoteGoal,
    ACTIONS(1930), 1,
      anon_sym_tactic,
    ACTIONS(1932), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1934), 1,
      anon_sym_u2987,
    ACTIONS(1936), 1,
      anon_sym_let,
    ACTIONS(1940), 1,
      anon_sym_Set,
    STATE(1765), 1,
      sym__ARROW,
    STATE(4004), 1,
      aux_sym__atoms,
    STATE(4914), 1,
      sym_atom,
    STATE(8153), 1,
      sym__LAMBDA,
    STATE(8431), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1906), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(1938), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(4476), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(4675), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4679), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8997), 7,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1914), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [397670] = 30,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(2676), 1,
      anon_sym_quoteGoal,
    ACTIONS(2684), 1,
      anon_sym_let,
    ACTIONS(3906), 1,
      anon_sym_BSLASH,
    ACTIONS(3908), 1,
      anon_sym_u03bb,
    ACTIONS(3910), 1,
      anon_sym_tactic,
    ACTIONS(5604), 1,
      sym_id,
    ACTIONS(5608), 1,
      anon_sym_record,
    ACTIONS(5610), 1,
      anon_sym_LPAREN,
    ACTIONS(5612), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(5614), 1,
      anon_sym_u2983,
    ACTIONS(5616), 1,
      anon_sym_LBRACE,
    ACTIONS(5618), 1,
      aux_sym__qid_token1,
    ACTIONS(5620), 1,
      anon_sym_DOT,
    ACTIONS(5622), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(5624), 1,
      anon_sym_u2987,
    ACTIONS(5628), 1,
      anon_sym_Set,
    STATE(3715), 1,
      aux_sym__with_exprs_repeat1,
    STATE(3775), 1,
      aux_sym__atoms,
    STATE(6230), 1,
      sym_atom,
    STATE(8086), 1,
      sym__LAMBDA,
    STATE(8470), 1,
      sym__FORALL,
    STATE(9466), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2654), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(5626), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6226), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6214), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9470), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(5606), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [397786] = 30,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(878), 1,
      anon_sym_quoteGoal,
    ACTIONS(886), 1,
      anon_sym_let,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(4182), 1,
      sym_id,
    ACTIONS(4184), 1,
      anon_sym_BSLASH,
    ACTIONS(4186), 1,
      anon_sym_u03bb,
    ACTIONS(4190), 1,
      anon_sym_record,
    ACTIONS(4192), 1,
      anon_sym_LPAREN,
    ACTIONS(4194), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4196), 1,
      anon_sym_u2983,
    ACTIONS(4198), 1,
      anon_sym_LBRACE,
    ACTIONS(4200), 1,
      aux_sym__qid_token1,
    ACTIONS(4202), 1,
      anon_sym_DOT,
    ACTIONS(4204), 1,
      anon_sym_tactic,
    ACTIONS(4206), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4208), 1,
      anon_sym_u2987,
    ACTIONS(4212), 1,
      anon_sym_Set,
    STATE(3888), 1,
      aux_sym__atoms,
    STATE(6121), 1,
      sym__qid,
    STATE(6386), 1,
      sym_atom,
    STATE(8067), 1,
      sym__LAMBDA,
    STATE(8369), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(852), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4210), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6575), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6565), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(4188), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10043), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [397902] = 30,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2796), 1,
      anon_sym_BSLASH,
    ACTIONS(2798), 1,
      anon_sym_u03bb,
    ACTIONS(2800), 1,
      anon_sym_quoteGoal,
    ACTIONS(2802), 1,
      anon_sym_tactic,
    ACTIONS(2804), 1,
      anon_sym_let,
    ACTIONS(5028), 1,
      sym_id,
    ACTIONS(5032), 1,
      anon_sym_record,
    ACTIONS(5034), 1,
      anon_sym_LPAREN,
    ACTIONS(5036), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(5038), 1,
      anon_sym_u2983,
    ACTIONS(5040), 1,
      anon_sym_LBRACE,
    ACTIONS(5042), 1,
      aux_sym__qid_token1,
    ACTIONS(5044), 1,
      anon_sym_DOT,
    ACTIONS(5046), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(5048), 1,
      anon_sym_u2987,
    ACTIONS(5052), 1,
      anon_sym_Set,
    STATE(3721), 1,
      aux_sym__with_exprs_repeat1,
    STATE(3849), 1,
      aux_sym__atoms,
    STATE(5588), 1,
      sym_atom,
    STATE(8041), 1,
      sym__LAMBDA,
    STATE(8490), 1,
      sym__FORALL,
    STATE(8978), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2794), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(5050), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5401), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5405), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8964), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(5030), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [398018] = 30,
    ACTIONS(710), 1,
      anon_sym_DASH,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(920), 1,
      anon_sym_quoteGoal,
    ACTIONS(928), 1,
      anon_sym_let,
    ACTIONS(3058), 1,
      anon_sym_BSLASH,
    ACTIONS(3060), 1,
      anon_sym_u03bb,
    ACTIONS(3064), 1,
      anon_sym_record,
    ACTIONS(3066), 1,
      anon_sym_LPAREN,
    ACTIONS(3068), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3070), 1,
      anon_sym_u2983,
    ACTIONS(3072), 1,
      anon_sym_LBRACE,
    ACTIONS(3076), 1,
      aux_sym__qid_token1,
    ACTIONS(3078), 1,
      anon_sym_DOT,
    ACTIONS(3080), 1,
      anon_sym_tactic,
    ACTIONS(3082), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3084), 1,
      anon_sym_u2987,
    ACTIONS(3088), 1,
      anon_sym_Set,
    ACTIONS(4220), 1,
      sym_id,
    STATE(3892), 1,
      aux_sym__atoms,
    STATE(6084), 1,
      sym__qid,
    STATE(6427), 1,
      sym_atom,
    STATE(8123), 1,
      sym__LAMBDA,
    STATE(8396), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3086), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6715), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6714), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3062), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10045), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [398134] = 30,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(878), 1,
      anon_sym_quoteGoal,
    ACTIONS(886), 1,
      anon_sym_let,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(4182), 1,
      sym_id,
    ACTIONS(4184), 1,
      anon_sym_BSLASH,
    ACTIONS(4186), 1,
      anon_sym_u03bb,
    ACTIONS(4190), 1,
      anon_sym_record,
    ACTIONS(4192), 1,
      anon_sym_LPAREN,
    ACTIONS(4194), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4196), 1,
      anon_sym_u2983,
    ACTIONS(4198), 1,
      anon_sym_LBRACE,
    ACTIONS(4200), 1,
      aux_sym__qid_token1,
    ACTIONS(4202), 1,
      anon_sym_DOT,
    ACTIONS(4204), 1,
      anon_sym_tactic,
    ACTIONS(4206), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4208), 1,
      anon_sym_u2987,
    ACTIONS(4212), 1,
      anon_sym_Set,
    STATE(3888), 1,
      aux_sym__atoms,
    STATE(6121), 1,
      sym__qid,
    STATE(6386), 1,
      sym_atom,
    STATE(8067), 1,
      sym__LAMBDA,
    STATE(8369), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(852), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4210), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6575), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6565), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(4188), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10162), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [398250] = 30,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(964), 1,
      anon_sym_quoteGoal,
    ACTIONS(972), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4214), 1,
      anon_sym_BSLASH,
    ACTIONS(4216), 1,
      anon_sym_u03bb,
    ACTIONS(4218), 1,
      anon_sym_tactic,
    STATE(3891), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8047), 1,
      sym__LAMBDA,
    STATE(8355), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(942), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9973), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [398366] = 31,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(1302), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(10560), 1,
      sym__binding_ids_and_absurds,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9770), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [398484] = 30,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(964), 1,
      anon_sym_quoteGoal,
    ACTIONS(972), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4214), 1,
      anon_sym_BSLASH,
    ACTIONS(4216), 1,
      anon_sym_u03bb,
    ACTIONS(4218), 1,
      anon_sym_tactic,
    STATE(3891), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8047), 1,
      sym__LAMBDA,
    STATE(8355), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(942), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10161), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [398600] = 31,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(1302), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(10302), 1,
      sym__binding_ids_and_absurds,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9862), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [398718] = 31,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(1302), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(11236), 1,
      sym__binding_ids_and_absurds,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9884), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [398836] = 30,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(2350), 1,
      anon_sym_BSLASH,
    ACTIONS(2352), 1,
      anon_sym_u03bb,
    ACTIONS(2370), 1,
      anon_sym_quoteGoal,
    ACTIONS(2372), 1,
      anon_sym_tactic,
    ACTIONS(2378), 1,
      anon_sym_let,
    ACTIONS(3786), 1,
      sym_id,
    ACTIONS(3792), 1,
      anon_sym_record,
    ACTIONS(3794), 1,
      anon_sym_LPAREN,
    ACTIONS(3796), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3798), 1,
      anon_sym_u2983,
    ACTIONS(3800), 1,
      anon_sym_LBRACE,
    ACTIONS(3802), 1,
      aux_sym__qid_token1,
    ACTIONS(3804), 1,
      anon_sym_DOT,
    ACTIONS(3806), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3808), 1,
      anon_sym_u2987,
    ACTIONS(3812), 1,
      anon_sym_Set,
    STATE(1482), 1,
      sym__ARROW,
    STATE(4004), 1,
      aux_sym__atoms,
    STATE(4255), 1,
      sym_atom,
    STATE(8119), 1,
      sym__LAMBDA,
    STATE(8372), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2348), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3810), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(4668), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(4284), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4282), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9001), 7,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3790), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [398952] = 31,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(1302), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(10326), 1,
      sym__binding_ids_and_absurds,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9821), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [399070] = 30,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(1870), 1,
      anon_sym_BSLASH,
    ACTIONS(1872), 1,
      anon_sym_u03bb,
    ACTIONS(1890), 1,
      anon_sym_quoteGoal,
    ACTIONS(1892), 1,
      anon_sym_tactic,
    ACTIONS(1898), 1,
      anon_sym_let,
    ACTIONS(3666), 1,
      sym_id,
    ACTIONS(3672), 1,
      anon_sym_record,
    ACTIONS(3674), 1,
      anon_sym_LPAREN,
    ACTIONS(3676), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3678), 1,
      anon_sym_u2983,
    ACTIONS(3680), 1,
      anon_sym_LBRACE,
    ACTIONS(3682), 1,
      aux_sym__qid_token1,
    ACTIONS(3684), 1,
      anon_sym_DOT,
    ACTIONS(3686), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3688), 1,
      anon_sym_u2987,
    ACTIONS(3692), 1,
      anon_sym_Set,
    STATE(1419), 1,
      sym__ARROW,
    STATE(4004), 1,
      aux_sym__atoms,
    STATE(4587), 1,
      sym_atom,
    STATE(8032), 1,
      sym__LAMBDA,
    STATE(8379), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1868), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3690), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(6192), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(4585), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4584), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9001), 7,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3670), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [399186] = 30,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(878), 1,
      anon_sym_quoteGoal,
    ACTIONS(886), 1,
      anon_sym_let,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(4182), 1,
      sym_id,
    ACTIONS(4184), 1,
      anon_sym_BSLASH,
    ACTIONS(4186), 1,
      anon_sym_u03bb,
    ACTIONS(4190), 1,
      anon_sym_record,
    ACTIONS(4192), 1,
      anon_sym_LPAREN,
    ACTIONS(4194), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4196), 1,
      anon_sym_u2983,
    ACTIONS(4198), 1,
      anon_sym_LBRACE,
    ACTIONS(4200), 1,
      aux_sym__qid_token1,
    ACTIONS(4202), 1,
      anon_sym_DOT,
    ACTIONS(4204), 1,
      anon_sym_tactic,
    ACTIONS(4206), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4208), 1,
      anon_sym_u2987,
    ACTIONS(4212), 1,
      anon_sym_Set,
    STATE(3888), 1,
      aux_sym__atoms,
    STATE(6121), 1,
      sym__qid,
    STATE(6386), 1,
      sym_atom,
    STATE(8067), 1,
      sym__LAMBDA,
    STATE(8369), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(852), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4210), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6575), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6565), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(4188), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9982), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [399302] = 30,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(2898), 1,
      sym_id,
    ACTIONS(2904), 1,
      anon_sym_BSLASH,
    ACTIONS(2906), 1,
      anon_sym_u03bb,
    ACTIONS(2910), 1,
      anon_sym_record,
    ACTIONS(2912), 1,
      anon_sym_LPAREN,
    ACTIONS(2914), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2916), 1,
      anon_sym_u2983,
    ACTIONS(2918), 1,
      anon_sym_LBRACE,
    ACTIONS(2920), 1,
      aux_sym__qid_token1,
    ACTIONS(2922), 1,
      anon_sym_DOT,
    ACTIONS(2924), 1,
      anon_sym_quoteGoal,
    ACTIONS(2926), 1,
      anon_sym_tactic,
    ACTIONS(2928), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2930), 1,
      anon_sym_u2987,
    ACTIONS(2932), 1,
      anon_sym_let,
    ACTIONS(2936), 1,
      anon_sym_Set,
    STATE(2200), 1,
      sym__ARROW,
    STATE(4004), 1,
      aux_sym__atoms,
    STATE(4154), 1,
      sym_atom,
    STATE(8094), 1,
      sym__LAMBDA,
    STATE(8489), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2900), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2934), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(6194), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(4184), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4206), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9001), 7,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2908), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [399418] = 30,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(2206), 1,
      sym_id,
    ACTIONS(2212), 1,
      anon_sym_BSLASH,
    ACTIONS(2214), 1,
      anon_sym_u03bb,
    ACTIONS(2218), 1,
      anon_sym_record,
    ACTIONS(2220), 1,
      anon_sym_LPAREN,
    ACTIONS(2222), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2224), 1,
      anon_sym_u2983,
    ACTIONS(2226), 1,
      anon_sym_LBRACE,
    ACTIONS(2228), 1,
      aux_sym__qid_token1,
    ACTIONS(2230), 1,
      anon_sym_DOT,
    ACTIONS(2232), 1,
      anon_sym_quoteGoal,
    ACTIONS(2234), 1,
      anon_sym_tactic,
    ACTIONS(2236), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2238), 1,
      anon_sym_u2987,
    ACTIONS(2240), 1,
      anon_sym_let,
    ACTIONS(2244), 1,
      anon_sym_Set,
    STATE(2115), 1,
      sym__ARROW,
    STATE(4004), 1,
      aux_sym__atoms,
    STATE(4718), 1,
      sym_atom,
    STATE(8035), 1,
      sym__LAMBDA,
    STATE(8402), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2242), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(6196), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(4812), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4858), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9001), 7,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2216), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [399534] = 31,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(1302), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(11759), 1,
      sym__binding_ids_and_absurds,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(10038), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [399652] = 30,
    ACTIONS(710), 1,
      anon_sym_DASH,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(920), 1,
      anon_sym_quoteGoal,
    ACTIONS(928), 1,
      anon_sym_let,
    ACTIONS(3058), 1,
      anon_sym_BSLASH,
    ACTIONS(3060), 1,
      anon_sym_u03bb,
    ACTIONS(3064), 1,
      anon_sym_record,
    ACTIONS(3066), 1,
      anon_sym_LPAREN,
    ACTIONS(3068), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3070), 1,
      anon_sym_u2983,
    ACTIONS(3072), 1,
      anon_sym_LBRACE,
    ACTIONS(3076), 1,
      aux_sym__qid_token1,
    ACTIONS(3078), 1,
      anon_sym_DOT,
    ACTIONS(3080), 1,
      anon_sym_tactic,
    ACTIONS(3082), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3084), 1,
      anon_sym_u2987,
    ACTIONS(3088), 1,
      anon_sym_Set,
    ACTIONS(4220), 1,
      sym_id,
    STATE(3892), 1,
      aux_sym__atoms,
    STATE(6084), 1,
      sym__qid,
    STATE(6427), 1,
      sym_atom,
    STATE(8123), 1,
      sym__LAMBDA,
    STATE(8396), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3086), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6715), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6714), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3062), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9981), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [399768] = 30,
    ACTIONS(686), 1,
      anon_sym_BSLASH,
    ACTIONS(688), 1,
      anon_sym_u03bb,
    ACTIONS(692), 1,
      anon_sym_record,
    ACTIONS(694), 1,
      anon_sym_LPAREN,
    ACTIONS(696), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(698), 1,
      anon_sym_u2983,
    ACTIONS(702), 1,
      anon_sym_LBRACE,
    ACTIONS(708), 1,
      anon_sym_DOT,
    ACTIONS(714), 1,
      anon_sym_quoteGoal,
    ACTIONS(716), 1,
      anon_sym_tactic,
    ACTIONS(718), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(720), 1,
      anon_sym_u2987,
    ACTIONS(722), 1,
      anon_sym_let,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(728), 1,
      anon_sym_Set,
    ACTIONS(2336), 1,
      sym_id,
    ACTIONS(2342), 1,
      aux_sym__qid_token1,
    STATE(2596), 1,
      sym__ARROW,
    STATE(4004), 1,
      aux_sym__atoms,
    STATE(5128), 1,
      sym_atom,
    STATE(8064), 1,
      sym__LAMBDA,
    STATE(8495), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(682), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(726), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(4286), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(5069), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5056), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9454), 7,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(690), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [399884] = 31,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(1302), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(11684), 1,
      sym__binding_ids_and_absurds,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(10017), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [400002] = 30,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1916), 1,
      anon_sym_record,
    ACTIONS(1918), 1,
      anon_sym_LPAREN,
    ACTIONS(1920), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1922), 1,
      anon_sym_u2983,
    ACTIONS(1924), 1,
      anon_sym_LBRACE,
    ACTIONS(1932), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1934), 1,
      anon_sym_u2987,
    ACTIONS(2120), 1,
      anon_sym_quoteGoal,
    ACTIONS(2128), 1,
      anon_sym_let,
    ACTIONS(2176), 1,
      anon_sym_BSLASH,
    ACTIONS(2178), 1,
      anon_sym_u03bb,
    ACTIONS(2196), 1,
      anon_sym_tactic,
    ACTIONS(2606), 1,
      sym_id,
    ACTIONS(2608), 1,
      aux_sym__qid_token1,
    ACTIONS(2610), 1,
      anon_sym_DOT,
    ACTIONS(2612), 1,
      anon_sym_Set,
    STATE(1427), 1,
      sym__ARROW,
    STATE(4004), 1,
      aux_sym__atoms,
    STATE(4914), 1,
      sym_atom,
    STATE(8044), 1,
      sym__LAMBDA,
    STATE(8428), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1938), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(2096), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4920), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(4675), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4679), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8997), 7,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(1914), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [400118] = 30,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(3174), 1,
      anon_sym_BSLASH,
    ACTIONS(3176), 1,
      anon_sym_u03bb,
    ACTIONS(3194), 1,
      anon_sym_quoteGoal,
    ACTIONS(3196), 1,
      anon_sym_tactic,
    ACTIONS(3202), 1,
      anon_sym_let,
    ACTIONS(6198), 1,
      sym_id,
    ACTIONS(6202), 1,
      anon_sym_record,
    ACTIONS(6204), 1,
      anon_sym_LPAREN,
    ACTIONS(6206), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(6208), 1,
      anon_sym_u2983,
    ACTIONS(6210), 1,
      anon_sym_LBRACE,
    ACTIONS(6212), 1,
      aux_sym__qid_token1,
    ACTIONS(6214), 1,
      anon_sym_DOT,
    ACTIONS(6216), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(6218), 1,
      anon_sym_u2987,
    ACTIONS(6222), 1,
      anon_sym_Set,
    STATE(3724), 1,
      aux_sym__with_exprs_repeat1,
    STATE(3855), 1,
      aux_sym__atoms,
    STATE(5407), 1,
      sym_atom,
    STATE(8051), 1,
      sym__LAMBDA,
    STATE(8409), 1,
      sym__FORALL,
    STATE(8939), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3170), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(6220), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5699), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5697), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(6200), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [400234] = 31,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(1302), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    STATE(10978), 1,
      sym__binding_ids_and_absurds,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9760), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [400352] = 30,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(738), 1,
      anon_sym_BSLASH,
    ACTIONS(740), 1,
      anon_sym_u03bb,
    ACTIONS(762), 1,
      anon_sym_quoteGoal,
    ACTIONS(764), 1,
      anon_sym_tactic,
    ACTIONS(3054), 1,
      anon_sym_let,
    ACTIONS(4248), 1,
      sym_id,
    ACTIONS(4252), 1,
      anon_sym_record,
    ACTIONS(4254), 1,
      anon_sym_LPAREN,
    ACTIONS(4256), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4258), 1,
      anon_sym_u2983,
    ACTIONS(4260), 1,
      anon_sym_LBRACE,
    ACTIONS(4262), 1,
      aux_sym__qid_token1,
    ACTIONS(4264), 1,
      anon_sym_DOT,
    ACTIONS(4266), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4268), 1,
      anon_sym_u2987,
    ACTIONS(4272), 1,
      anon_sym_Set,
    STATE(3730), 1,
      aux_sym__with_exprs_repeat1,
    STATE(3768), 1,
      aux_sym__atoms,
    STATE(5812), 1,
      sym_atom,
    STATE(8156), 1,
      sym__LAMBDA,
    STATE(8456), 1,
      sym__FORALL,
    STATE(8939), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(736), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4270), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5952), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5976), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(4250), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [400468] = 30,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(964), 1,
      anon_sym_quoteGoal,
    ACTIONS(972), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4214), 1,
      anon_sym_BSLASH,
    ACTIONS(4216), 1,
      anon_sym_u03bb,
    ACTIONS(4218), 1,
      anon_sym_tactic,
    STATE(3891), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8047), 1,
      sym__LAMBDA,
    STATE(8355), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(942), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9710), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [400584] = 30,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(878), 1,
      anon_sym_quoteGoal,
    ACTIONS(886), 1,
      anon_sym_let,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(4182), 1,
      sym_id,
    ACTIONS(4184), 1,
      anon_sym_BSLASH,
    ACTIONS(4186), 1,
      anon_sym_u03bb,
    ACTIONS(4190), 1,
      anon_sym_record,
    ACTIONS(4192), 1,
      anon_sym_LPAREN,
    ACTIONS(4194), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4196), 1,
      anon_sym_u2983,
    ACTIONS(4198), 1,
      anon_sym_LBRACE,
    ACTIONS(4200), 1,
      aux_sym__qid_token1,
    ACTIONS(4202), 1,
      anon_sym_DOT,
    ACTIONS(4204), 1,
      anon_sym_tactic,
    ACTIONS(4206), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4208), 1,
      anon_sym_u2987,
    ACTIONS(4212), 1,
      anon_sym_Set,
    STATE(3888), 1,
      aux_sym__atoms,
    STATE(6121), 1,
      sym__qid,
    STATE(6386), 1,
      sym_atom,
    STATE(8067), 1,
      sym__LAMBDA,
    STATE(8369), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(852), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4210), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6575), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6565), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(4188), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9711), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [400700] = 30,
    ACTIONS(710), 1,
      anon_sym_DASH,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(920), 1,
      anon_sym_quoteGoal,
    ACTIONS(928), 1,
      anon_sym_let,
    ACTIONS(3058), 1,
      anon_sym_BSLASH,
    ACTIONS(3060), 1,
      anon_sym_u03bb,
    ACTIONS(3064), 1,
      anon_sym_record,
    ACTIONS(3066), 1,
      anon_sym_LPAREN,
    ACTIONS(3068), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3070), 1,
      anon_sym_u2983,
    ACTIONS(3072), 1,
      anon_sym_LBRACE,
    ACTIONS(3076), 1,
      aux_sym__qid_token1,
    ACTIONS(3078), 1,
      anon_sym_DOT,
    ACTIONS(3080), 1,
      anon_sym_tactic,
    ACTIONS(3082), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3084), 1,
      anon_sym_u2987,
    ACTIONS(3088), 1,
      anon_sym_Set,
    ACTIONS(4220), 1,
      sym_id,
    STATE(3892), 1,
      aux_sym__atoms,
    STATE(6084), 1,
      sym__qid,
    STATE(6427), 1,
      sym_atom,
    STATE(8123), 1,
      sym__LAMBDA,
    STATE(8396), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3086), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6715), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6714), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3062), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9712), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [400816] = 30,
    ACTIONS(710), 1,
      anon_sym_DASH,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(920), 1,
      anon_sym_quoteGoal,
    ACTIONS(928), 1,
      anon_sym_let,
    ACTIONS(3058), 1,
      anon_sym_BSLASH,
    ACTIONS(3060), 1,
      anon_sym_u03bb,
    ACTIONS(3064), 1,
      anon_sym_record,
    ACTIONS(3066), 1,
      anon_sym_LPAREN,
    ACTIONS(3068), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3070), 1,
      anon_sym_u2983,
    ACTIONS(3072), 1,
      anon_sym_LBRACE,
    ACTIONS(3076), 1,
      aux_sym__qid_token1,
    ACTIONS(3078), 1,
      anon_sym_DOT,
    ACTIONS(3080), 1,
      anon_sym_tactic,
    ACTIONS(3082), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3084), 1,
      anon_sym_u2987,
    ACTIONS(3088), 1,
      anon_sym_Set,
    ACTIONS(4220), 1,
      sym_id,
    STATE(3892), 1,
      aux_sym__atoms,
    STATE(6084), 1,
      sym__qid,
    STATE(6427), 1,
      sym_atom,
    STATE(8123), 1,
      sym__LAMBDA,
    STATE(8396), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3086), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6715), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6714), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3062), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9995), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [400932] = 30,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(964), 1,
      anon_sym_quoteGoal,
    ACTIONS(972), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4214), 1,
      anon_sym_BSLASH,
    ACTIONS(4216), 1,
      anon_sym_u03bb,
    ACTIONS(4218), 1,
      anon_sym_tactic,
    STATE(3891), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8047), 1,
      sym__LAMBDA,
    STATE(8355), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(942), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10177), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [401048] = 30,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(964), 1,
      anon_sym_quoteGoal,
    ACTIONS(972), 1,
      anon_sym_let,
    ACTIONS(3966), 1,
      sym_id,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3986), 1,
      aux_sym__qid_token1,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4214), 1,
      anon_sym_BSLASH,
    ACTIONS(4216), 1,
      anon_sym_u03bb,
    ACTIONS(4218), 1,
      anon_sym_tactic,
    STATE(3891), 1,
      aux_sym__atoms,
    STATE(5842), 1,
      sym__qid,
    STATE(6022), 1,
      sym_atom,
    STATE(8047), 1,
      sym__LAMBDA,
    STATE(8355), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(942), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9794), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [401164] = 30,
    ACTIONS(710), 1,
      anon_sym_DASH,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(920), 1,
      anon_sym_quoteGoal,
    ACTIONS(928), 1,
      anon_sym_let,
    ACTIONS(3058), 1,
      anon_sym_BSLASH,
    ACTIONS(3060), 1,
      anon_sym_u03bb,
    ACTIONS(3064), 1,
      anon_sym_record,
    ACTIONS(3066), 1,
      anon_sym_LPAREN,
    ACTIONS(3068), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3070), 1,
      anon_sym_u2983,
    ACTIONS(3072), 1,
      anon_sym_LBRACE,
    ACTIONS(3076), 1,
      aux_sym__qid_token1,
    ACTIONS(3078), 1,
      anon_sym_DOT,
    ACTIONS(3080), 1,
      anon_sym_tactic,
    ACTIONS(3082), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3084), 1,
      anon_sym_u2987,
    ACTIONS(3088), 1,
      anon_sym_Set,
    ACTIONS(4220), 1,
      sym_id,
    STATE(3892), 1,
      aux_sym__atoms,
    STATE(6084), 1,
      sym__qid,
    STATE(6427), 1,
      sym_atom,
    STATE(8123), 1,
      sym__LAMBDA,
    STATE(8396), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3086), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6715), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6714), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3062), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9784), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [401280] = 30,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(2206), 1,
      sym_id,
    ACTIONS(2212), 1,
      anon_sym_BSLASH,
    ACTIONS(2214), 1,
      anon_sym_u03bb,
    ACTIONS(2218), 1,
      anon_sym_record,
    ACTIONS(2220), 1,
      anon_sym_LPAREN,
    ACTIONS(2222), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2224), 1,
      anon_sym_u2983,
    ACTIONS(2226), 1,
      anon_sym_LBRACE,
    ACTIONS(2228), 1,
      aux_sym__qid_token1,
    ACTIONS(2230), 1,
      anon_sym_DOT,
    ACTIONS(2232), 1,
      anon_sym_quoteGoal,
    ACTIONS(2234), 1,
      anon_sym_tactic,
    ACTIONS(2236), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2238), 1,
      anon_sym_u2987,
    ACTIONS(2240), 1,
      anon_sym_let,
    ACTIONS(2244), 1,
      anon_sym_Set,
    STATE(2120), 1,
      sym__ARROW,
    STATE(4004), 1,
      aux_sym__atoms,
    STATE(4718), 1,
      sym_atom,
    STATE(8035), 1,
      sym__LAMBDA,
    STATE(8402), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(2242), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(4564), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(4812), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4858), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9001), 7,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(2216), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [401396] = 30,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(878), 1,
      anon_sym_quoteGoal,
    ACTIONS(886), 1,
      anon_sym_let,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(4182), 1,
      sym_id,
    ACTIONS(4184), 1,
      anon_sym_BSLASH,
    ACTIONS(4186), 1,
      anon_sym_u03bb,
    ACTIONS(4190), 1,
      anon_sym_record,
    ACTIONS(4192), 1,
      anon_sym_LPAREN,
    ACTIONS(4194), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4196), 1,
      anon_sym_u2983,
    ACTIONS(4198), 1,
      anon_sym_LBRACE,
    ACTIONS(4200), 1,
      aux_sym__qid_token1,
    ACTIONS(4202), 1,
      anon_sym_DOT,
    ACTIONS(4204), 1,
      anon_sym_tactic,
    ACTIONS(4206), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4208), 1,
      anon_sym_u2987,
    ACTIONS(4212), 1,
      anon_sym_Set,
    STATE(3888), 1,
      aux_sym__atoms,
    STATE(6121), 1,
      sym__qid,
    STATE(6386), 1,
      sym_atom,
    STATE(8067), 1,
      sym__LAMBDA,
    STATE(8369), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(852), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4210), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6575), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6565), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(4188), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(9791), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [401512] = 30,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(105), 1,
      sym_id,
    ACTIONS(109), 1,
      anon_sym_BSLASH,
    ACTIONS(111), 1,
      anon_sym_u03bb,
    ACTIONS(125), 1,
      anon_sym_LPAREN,
    ACTIONS(127), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(129), 1,
      anon_sym_u2983,
    ACTIONS(135), 1,
      anon_sym_LBRACE,
    ACTIONS(143), 1,
      aux_sym__qid_token1,
    ACTIONS(145), 1,
      anon_sym_DOT,
    ACTIONS(147), 1,
      anon_sym_quoteGoal,
    ACTIONS(149), 1,
      anon_sym_tactic,
    ACTIONS(151), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(153), 1,
      anon_sym_u2987,
    ACTIONS(155), 1,
      anon_sym_let,
    ACTIONS(159), 1,
      anon_sym_Set,
    ACTIONS(4274), 1,
      anon_sym_record,
    STATE(3734), 1,
      aux_sym__with_exprs_repeat1,
    STATE(3854), 1,
      aux_sym__atoms,
    STATE(4271), 1,
      sym_atom,
    STATE(8146), 1,
      sym__LAMBDA,
    STATE(8343), 1,
      sym__FORALL,
    STATE(8939), 1,
      sym__with_exprs,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(107), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(157), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4311), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4327), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8955), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(113), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [401628] = 30,
    ACTIONS(876), 1,
      anon_sym_DASH,
    ACTIONS(878), 1,
      anon_sym_quoteGoal,
    ACTIONS(886), 1,
      anon_sym_let,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(4182), 1,
      sym_id,
    ACTIONS(4184), 1,
      anon_sym_BSLASH,
    ACTIONS(4186), 1,
      anon_sym_u03bb,
    ACTIONS(4190), 1,
      anon_sym_record,
    ACTIONS(4192), 1,
      anon_sym_LPAREN,
    ACTIONS(4194), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4196), 1,
      anon_sym_u2983,
    ACTIONS(4198), 1,
      anon_sym_LBRACE,
    ACTIONS(4200), 1,
      aux_sym__qid_token1,
    ACTIONS(4202), 1,
      anon_sym_DOT,
    ACTIONS(4204), 1,
      anon_sym_tactic,
    ACTIONS(4206), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4208), 1,
      anon_sym_u2987,
    ACTIONS(4212), 1,
      anon_sym_Set,
    STATE(3888), 1,
      aux_sym__atoms,
    STATE(6121), 1,
      sym__qid,
    STATE(6386), 1,
      sym_atom,
    STATE(8067), 1,
      sym__LAMBDA,
    STATE(8369), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(852), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4210), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6575), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6565), 6,
      sym__ELLIPSIS,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(4188), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    STATE(10184), 9,
      sym__binding_ids_and_absurds,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
  [401744] = 29,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(3096), 1,
      anon_sym_BSLASH,
    ACTIONS(3098), 1,
      anon_sym_u03bb,
    ACTIONS(3116), 1,
      anon_sym_quoteGoal,
    ACTIONS(3118), 1,
      anon_sym_tactic,
    ACTIONS(3124), 1,
      anon_sym_let,
    ACTIONS(6086), 1,
      sym_id,
    ACTIONS(6090), 1,
      anon_sym_record,
    ACTIONS(6092), 1,
      anon_sym_LPAREN,
    ACTIONS(6094), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(6096), 1,
      anon_sym_u2983,
    ACTIONS(6098), 1,
      anon_sym_LBRACE,
    ACTIONS(6100), 1,
      aux_sym__qid_token1,
    ACTIONS(6102), 1,
      anon_sym_DOT,
    ACTIONS(6104), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(6106), 1,
      anon_sym_u2987,
    ACTIONS(6110), 1,
      anon_sym_Set,
    STATE(3814), 1,
      aux_sym__atoms,
    STATE(4038), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4488), 1,
      sym_atom,
    STATE(8099), 1,
      sym__LAMBDA,
    STATE(8393), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3092), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(6108), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4522), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4523), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8996), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(6088), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [401857] = 29,
    ACTIONS(714), 1,
      anon_sym_quoteGoal,
    ACTIONS(722), 1,
      anon_sym_let,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(3556), 1,
      anon_sym_BSLASH,
    ACTIONS(3558), 1,
      anon_sym_u03bb,
    ACTIONS(3574), 1,
      anon_sym_tactic,
    ACTIONS(5246), 1,
      sym_id,
    ACTIONS(5250), 1,
      anon_sym_record,
    ACTIONS(5252), 1,
      anon_sym_LPAREN,
    ACTIONS(5254), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(5256), 1,
      anon_sym_u2983,
    ACTIONS(5258), 1,
      anon_sym_LBRACE,
    ACTIONS(5260), 1,
      aux_sym__qid_token1,
    ACTIONS(5262), 1,
      anon_sym_DOT,
    ACTIONS(5264), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(5266), 1,
      anon_sym_u2987,
    ACTIONS(5270), 1,
      anon_sym_Set,
    STATE(3769), 1,
      aux_sym__atoms,
    STATE(4038), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5510), 1,
      sym_atom,
    STATE(8092), 1,
      sym__LAMBDA,
    STATE(8495), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(682), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(5268), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5466), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5472), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9456), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(5248), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [401970] = 29,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2302), 1,
      anon_sym_BSLASH,
    ACTIONS(2304), 1,
      anon_sym_u03bb,
    ACTIONS(2322), 1,
      anon_sym_quoteGoal,
    ACTIONS(2324), 1,
      anon_sym_tactic,
    ACTIONS(2330), 1,
      anon_sym_let,
    ACTIONS(5278), 1,
      sym_id,
    ACTIONS(5282), 1,
      anon_sym_record,
    ACTIONS(5284), 1,
      anon_sym_LPAREN,
    ACTIONS(5286), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(5288), 1,
      anon_sym_u2983,
    ACTIONS(5290), 1,
      anon_sym_LBRACE,
    ACTIONS(5292), 1,
      aux_sym__qid_token1,
    ACTIONS(5294), 1,
      anon_sym_DOT,
    ACTIONS(5296), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(5298), 1,
      anon_sym_u2987,
    ACTIONS(5302), 1,
      anon_sym_Set,
    STATE(3786), 1,
      aux_sym__atoms,
    STATE(4038), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5949), 1,
      sym_atom,
    STATE(8138), 1,
      sym__LAMBDA,
    STATE(8476), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2300), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(5300), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5779), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5778), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8995), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(5280), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [402083] = 29,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(982), 1,
      anon_sym_BSLASH,
    ACTIONS(984), 1,
      anon_sym_u03bb,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(990), 1,
      anon_sym_tactic,
    ACTIONS(1302), 1,
      anon_sym_let,
    ACTIONS(5416), 1,
      sym_id,
    ACTIONS(5420), 1,
      anon_sym_record,
    ACTIONS(5422), 1,
      anon_sym_LPAREN,
    ACTIONS(5424), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(5426), 1,
      anon_sym_u2983,
    ACTIONS(5428), 1,
      anon_sym_LBRACE,
    ACTIONS(5430), 1,
      aux_sym__qid_token1,
    ACTIONS(5432), 1,
      anon_sym_DOT,
    ACTIONS(5434), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(5436), 1,
      anon_sym_u2987,
    ACTIONS(5440), 1,
      anon_sym_Set,
    STATE(3850), 1,
      aux_sym__atoms,
    STATE(4038), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5548), 1,
      sym_atom,
    STATE(8095), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(5438), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5369), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5364), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8995), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(5418), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [402196] = 29,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2492), 1,
      anon_sym_BSLASH,
    ACTIONS(2494), 1,
      anon_sym_u03bb,
    ACTIONS(2512), 1,
      anon_sym_quoteGoal,
    ACTIONS(2514), 1,
      anon_sym_tactic,
    ACTIONS(2520), 1,
      anon_sym_let,
    ACTIONS(5548), 1,
      sym_id,
    ACTIONS(5552), 1,
      anon_sym_record,
    ACTIONS(5554), 1,
      anon_sym_LPAREN,
    ACTIONS(5556), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(5558), 1,
      anon_sym_u2983,
    ACTIONS(5560), 1,
      anon_sym_LBRACE,
    ACTIONS(5562), 1,
      aux_sym__qid_token1,
    ACTIONS(5564), 1,
      anon_sym_DOT,
    ACTIONS(5566), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(5568), 1,
      anon_sym_u2987,
    ACTIONS(5572), 1,
      anon_sym_Set,
    STATE(3783), 1,
      aux_sym__atoms,
    STATE(4038), 1,
      aux_sym__with_exprs_repeat1,
    STATE(6137), 1,
      sym_atom,
    STATE(8096), 1,
      sym__LAMBDA,
    STATE(8497), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2490), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(5570), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6032), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6059), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8995), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(5550), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [402309] = 29,
    ACTIONS(9), 1,
      sym_id,
    ACTIONS(13), 1,
      anon_sym_BSLASH,
    ACTIONS(15), 1,
      anon_sym_u03bb,
    ACTIONS(51), 1,
      anon_sym_LPAREN,
    ACTIONS(53), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(55), 1,
      anon_sym_u2983,
    ACTIONS(61), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      aux_sym__qid_token1,
    ACTIONS(71), 1,
      anon_sym_DOT,
    ACTIONS(75), 1,
      anon_sym_quoteGoal,
    ACTIONS(77), 1,
      anon_sym_tactic,
    ACTIONS(79), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(81), 1,
      anon_sym_u2987,
    ACTIONS(83), 1,
      anon_sym_let,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(89), 1,
      anon_sym_Set,
    ACTIONS(4280), 1,
      anon_sym_record,
    STATE(3848), 1,
      aux_sym__atoms,
    STATE(4038), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4600), 1,
      sym_atom,
    STATE(8114), 1,
      sym__LAMBDA,
    STATE(8288), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(11), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(87), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4564), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4608), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8996), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(17), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [402422] = 29,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(2350), 1,
      anon_sym_BSLASH,
    ACTIONS(2352), 1,
      anon_sym_u03bb,
    ACTIONS(2370), 1,
      anon_sym_quoteGoal,
    ACTIONS(2372), 1,
      anon_sym_tactic,
    ACTIONS(2378), 1,
      anon_sym_let,
    ACTIONS(5054), 1,
      sym_id,
    ACTIONS(5058), 1,
      anon_sym_record,
    ACTIONS(5060), 1,
      anon_sym_LPAREN,
    ACTIONS(5062), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(5064), 1,
      anon_sym_u2983,
    ACTIONS(5066), 1,
      anon_sym_LBRACE,
    ACTIONS(5068), 1,
      aux_sym__qid_token1,
    ACTIONS(5070), 1,
      anon_sym_DOT,
    ACTIONS(5072), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(5074), 1,
      anon_sym_u2987,
    ACTIONS(5078), 1,
      anon_sym_Set,
    STATE(3807), 1,
      aux_sym__atoms,
    STATE(4038), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4532), 1,
      sym_atom,
    STATE(8119), 1,
      sym__LAMBDA,
    STATE(8372), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2348), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(5076), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4453), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4455), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8996), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(5056), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [402535] = 29,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(2964), 1,
      anon_sym_quoteGoal,
    ACTIONS(2972), 1,
      anon_sym_let,
    ACTIONS(3522), 1,
      anon_sym_BSLASH,
    ACTIONS(3524), 1,
      anon_sym_u03bb,
    ACTIONS(3542), 1,
      anon_sym_tactic,
    ACTIONS(4924), 1,
      sym_id,
    ACTIONS(4928), 1,
      anon_sym_record,
    ACTIONS(4930), 1,
      anon_sym_LPAREN,
    ACTIONS(4932), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4934), 1,
      anon_sym_u2983,
    ACTIONS(4936), 1,
      anon_sym_LBRACE,
    ACTIONS(4938), 1,
      aux_sym__qid_token1,
    ACTIONS(4940), 1,
      anon_sym_DOT,
    ACTIONS(4942), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4944), 1,
      anon_sym_u2987,
    ACTIONS(4948), 1,
      anon_sym_Set,
    STATE(3842), 1,
      aux_sym__atoms,
    STATE(4038), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5872), 1,
      sym_atom,
    STATE(8058), 1,
      sym__LAMBDA,
    STATE(8418), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2940), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4946), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5898), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5899), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8996), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(4926), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [402648] = 29,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2800), 1,
      anon_sym_quoteGoal,
    ACTIONS(2804), 1,
      anon_sym_let,
    ACTIONS(2810), 1,
      anon_sym_BSLASH,
    ACTIONS(2812), 1,
      anon_sym_u03bb,
    ACTIONS(2830), 1,
      anon_sym_tactic,
    ACTIONS(5604), 1,
      sym_id,
    ACTIONS(5608), 1,
      anon_sym_record,
    ACTIONS(5610), 1,
      anon_sym_LPAREN,
    ACTIONS(5612), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(5614), 1,
      anon_sym_u2983,
    ACTIONS(5616), 1,
      anon_sym_LBRACE,
    ACTIONS(5618), 1,
      aux_sym__qid_token1,
    ACTIONS(5620), 1,
      anon_sym_DOT,
    ACTIONS(5622), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(5624), 1,
      anon_sym_u2987,
    ACTIONS(5628), 1,
      anon_sym_Set,
    STATE(3825), 1,
      aux_sym__atoms,
    STATE(4038), 1,
      aux_sym__with_exprs_repeat1,
    STATE(6230), 1,
      sym_atom,
    STATE(8081), 1,
      sym__LAMBDA,
    STATE(8490), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2794), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(5626), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6226), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6214), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8995), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(5606), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [402761] = 29,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(2570), 1,
      anon_sym_BSLASH,
    ACTIONS(2572), 1,
      anon_sym_u03bb,
    ACTIONS(2590), 1,
      anon_sym_quoteGoal,
    ACTIONS(2592), 1,
      anon_sym_tactic,
    ACTIONS(2598), 1,
      anon_sym_let,
    ACTIONS(5656), 1,
      sym_id,
    ACTIONS(5660), 1,
      anon_sym_record,
    ACTIONS(5662), 1,
      anon_sym_LPAREN,
    ACTIONS(5664), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(5666), 1,
      anon_sym_u2983,
    ACTIONS(5668), 1,
      anon_sym_LBRACE,
    ACTIONS(5670), 1,
      aux_sym__qid_token1,
    ACTIONS(5672), 1,
      anon_sym_DOT,
    ACTIONS(5674), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(5676), 1,
      anon_sym_u2987,
    ACTIONS(5680), 1,
      anon_sym_Set,
    STATE(3817), 1,
      aux_sym__atoms,
    STATE(4038), 1,
      aux_sym__with_exprs_repeat1,
    STATE(6281), 1,
      sym_atom,
    STATE(8111), 1,
      sym__LAMBDA,
    STATE(8412), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2568), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(5678), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6130), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6053), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8996), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(5658), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [402874] = 29,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(2676), 1,
      anon_sym_quoteGoal,
    ACTIONS(2684), 1,
      anon_sym_let,
    ACTIONS(3906), 1,
      anon_sym_BSLASH,
    ACTIONS(3908), 1,
      anon_sym_u03bb,
    ACTIONS(3910), 1,
      anon_sym_tactic,
    ACTIONS(5604), 1,
      sym_id,
    ACTIONS(5608), 1,
      anon_sym_record,
    ACTIONS(5610), 1,
      anon_sym_LPAREN,
    ACTIONS(5612), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(5614), 1,
      anon_sym_u2983,
    ACTIONS(5616), 1,
      anon_sym_LBRACE,
    ACTIONS(5618), 1,
      aux_sym__qid_token1,
    ACTIONS(5620), 1,
      anon_sym_DOT,
    ACTIONS(5622), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(5624), 1,
      anon_sym_u2987,
    ACTIONS(5628), 1,
      anon_sym_Set,
    STATE(3775), 1,
      aux_sym__atoms,
    STATE(4038), 1,
      aux_sym__with_exprs_repeat1,
    STATE(6230), 1,
      sym_atom,
    STATE(8086), 1,
      sym__LAMBDA,
    STATE(8470), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2654), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(5626), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6226), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6214), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9456), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(5606), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [402987] = 29,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(3818), 1,
      anon_sym_BSLASH,
    ACTIONS(3820), 1,
      anon_sym_u03bb,
    ACTIONS(3838), 1,
      anon_sym_quoteGoal,
    ACTIONS(3840), 1,
      anon_sym_tactic,
    ACTIONS(3846), 1,
      anon_sym_let,
    ACTIONS(6006), 1,
      sym_id,
    ACTIONS(6010), 1,
      anon_sym_record,
    ACTIONS(6012), 1,
      anon_sym_LPAREN,
    ACTIONS(6014), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(6016), 1,
      anon_sym_u2983,
    ACTIONS(6018), 1,
      anon_sym_LBRACE,
    ACTIONS(6020), 1,
      aux_sym__qid_token1,
    ACTIONS(6022), 1,
      anon_sym_DOT,
    ACTIONS(6024), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(6026), 1,
      anon_sym_u2987,
    ACTIONS(6030), 1,
      anon_sym_Set,
    STATE(3828), 1,
      aux_sym__atoms,
    STATE(4038), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4773), 1,
      sym_atom,
    STATE(8085), 1,
      sym__LAMBDA,
    STATE(8442), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3816), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(6028), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4881), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4870), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8996), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(6008), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [403100] = 29,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1910), 1,
      anon_sym_BSLASH,
    ACTIONS(1912), 1,
      anon_sym_u03bb,
    ACTIONS(1928), 1,
      anon_sym_quoteGoal,
    ACTIONS(1930), 1,
      anon_sym_tactic,
    ACTIONS(1936), 1,
      anon_sym_let,
    ACTIONS(5522), 1,
      sym_id,
    ACTIONS(5526), 1,
      anon_sym_record,
    ACTIONS(5528), 1,
      anon_sym_LPAREN,
    ACTIONS(5530), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(5532), 1,
      anon_sym_u2983,
    ACTIONS(5534), 1,
      anon_sym_LBRACE,
    ACTIONS(5536), 1,
      aux_sym__qid_token1,
    ACTIONS(5538), 1,
      anon_sym_DOT,
    ACTIONS(5540), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(5542), 1,
      anon_sym_u2987,
    ACTIONS(5546), 1,
      anon_sym_Set,
    STATE(3846), 1,
      aux_sym__atoms,
    STATE(4038), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5007), 1,
      sym_atom,
    STATE(8153), 1,
      sym__LAMBDA,
    STATE(8431), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1906), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(5544), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5318), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5319), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8995), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(5524), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [403213] = 29,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(898), 1,
      anon_sym_BSLASH,
    ACTIONS(900), 1,
      anon_sym_u03bb,
    ACTIONS(920), 1,
      anon_sym_quoteGoal,
    ACTIONS(922), 1,
      anon_sym_tactic,
    ACTIONS(928), 1,
      anon_sym_let,
    ACTIONS(5682), 1,
      sym_id,
    ACTIONS(5686), 1,
      anon_sym_record,
    ACTIONS(5688), 1,
      anon_sym_LPAREN,
    ACTIONS(5690), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(5692), 1,
      anon_sym_u2983,
    ACTIONS(5694), 1,
      anon_sym_LBRACE,
    ACTIONS(5696), 1,
      aux_sym__qid_token1,
    ACTIONS(5698), 1,
      anon_sym_DOT,
    ACTIONS(5700), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(5702), 1,
      anon_sym_u2987,
    ACTIONS(5706), 1,
      anon_sym_Set,
    STATE(3796), 1,
      aux_sym__atoms,
    STATE(4038), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5867), 1,
      sym_atom,
    STATE(8031), 1,
      sym__LAMBDA,
    STATE(8396), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(5704), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5924), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5925), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9456), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(5684), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [403326] = 29,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(3134), 1,
      anon_sym_BSLASH,
    ACTIONS(3136), 1,
      anon_sym_u03bb,
    ACTIONS(3154), 1,
      anon_sym_quoteGoal,
    ACTIONS(3156), 1,
      anon_sym_tactic,
    ACTIONS(3162), 1,
      anon_sym_let,
    ACTIONS(6166), 1,
      sym_id,
    ACTIONS(6170), 1,
      anon_sym_record,
    ACTIONS(6172), 1,
      anon_sym_LPAREN,
    ACTIONS(6174), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(6176), 1,
      anon_sym_u2983,
    ACTIONS(6178), 1,
      anon_sym_LBRACE,
    ACTIONS(6180), 1,
      aux_sym__qid_token1,
    ACTIONS(6182), 1,
      anon_sym_DOT,
    ACTIONS(6184), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(6186), 1,
      anon_sym_u2987,
    ACTIONS(6190), 1,
      anon_sym_Set,
    STATE(3772), 1,
      aux_sym__atoms,
    STATE(4038), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5226), 1,
      sym_atom,
    STATE(8076), 1,
      sym__LAMBDA,
    STATE(8363), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3132), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(6188), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4960), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4966), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8996), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(6168), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [403439] = 29,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(2532), 1,
      anon_sym_BSLASH,
    ACTIONS(2534), 1,
      anon_sym_u03bb,
    ACTIONS(2552), 1,
      anon_sym_quoteGoal,
    ACTIONS(2554), 1,
      anon_sym_tactic,
    ACTIONS(2560), 1,
      anon_sym_let,
    ACTIONS(5872), 1,
      sym_id,
    ACTIONS(5876), 1,
      anon_sym_record,
    ACTIONS(5878), 1,
      anon_sym_LPAREN,
    ACTIONS(5880), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(5882), 1,
      anon_sym_u2983,
    ACTIONS(5884), 1,
      anon_sym_LBRACE,
    ACTIONS(5886), 1,
      aux_sym__qid_token1,
    ACTIONS(5888), 1,
      anon_sym_DOT,
    ACTIONS(5890), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(5892), 1,
      anon_sym_u2987,
    ACTIONS(5896), 1,
      anon_sym_Set,
    STATE(3810), 1,
      aux_sym__atoms,
    STATE(4038), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4839), 1,
      sym_atom,
    STATE(8066), 1,
      sym__LAMBDA,
    STATE(8398), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2528), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(5894), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4787), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4785), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8996), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(5874), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [403552] = 29,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2796), 1,
      anon_sym_BSLASH,
    ACTIONS(2798), 1,
      anon_sym_u03bb,
    ACTIONS(2800), 1,
      anon_sym_quoteGoal,
    ACTIONS(2802), 1,
      anon_sym_tactic,
    ACTIONS(2804), 1,
      anon_sym_let,
    ACTIONS(5028), 1,
      sym_id,
    ACTIONS(5032), 1,
      anon_sym_record,
    ACTIONS(5034), 1,
      anon_sym_LPAREN,
    ACTIONS(5036), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(5038), 1,
      anon_sym_u2983,
    ACTIONS(5040), 1,
      anon_sym_LBRACE,
    ACTIONS(5042), 1,
      aux_sym__qid_token1,
    ACTIONS(5044), 1,
      anon_sym_DOT,
    ACTIONS(5046), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(5048), 1,
      anon_sym_u2987,
    ACTIONS(5052), 1,
      anon_sym_Set,
    STATE(3849), 1,
      aux_sym__atoms,
    STATE(4038), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5588), 1,
      sym_atom,
    STATE(8041), 1,
      sym__LAMBDA,
    STATE(8490), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2794), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(5050), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5401), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5405), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8995), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(5030), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [403665] = 29,
    ACTIONS(686), 1,
      anon_sym_BSLASH,
    ACTIONS(688), 1,
      anon_sym_u03bb,
    ACTIONS(714), 1,
      anon_sym_quoteGoal,
    ACTIONS(716), 1,
      anon_sym_tactic,
    ACTIONS(722), 1,
      anon_sym_let,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(5708), 1,
      sym_id,
    ACTIONS(5712), 1,
      anon_sym_record,
    ACTIONS(5714), 1,
      anon_sym_LPAREN,
    ACTIONS(5716), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(5718), 1,
      anon_sym_u2983,
    ACTIONS(5720), 1,
      anon_sym_LBRACE,
    ACTIONS(5722), 1,
      aux_sym__qid_token1,
    ACTIONS(5724), 1,
      anon_sym_DOT,
    ACTIONS(5726), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(5728), 1,
      anon_sym_u2987,
    ACTIONS(5732), 1,
      anon_sym_Set,
    STATE(3782), 1,
      aux_sym__atoms,
    STATE(4038), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5512), 1,
      sym_atom,
    STATE(8064), 1,
      sym__LAMBDA,
    STATE(8495), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(682), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(5730), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5553), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5550), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9456), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(5710), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [403778] = 3,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(394), 1,
      anon_sym_BSLASH,
    ACTIONS(4240), 52,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_field,
      anon_sym_instance,
      anon_sym_module,
      anon_sym_data,
      anon_sym_codata,
      anon_sym_record,
      anon_sym_infix,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_variable,
      anon_sym_mutual,
      anon_sym_abstract,
      anon_sym_private,
      anon_sym_macro,
      anon_sym_postulate,
      anon_sym_primitive,
      anon_sym_open,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      sym_pragma,
      anon_sym_syntax,
      anon_sym_LBRACE,
      anon_sym_pattern,
      anon_sym_unquoteDecl,
      anon_sym_unquoteDef,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_AT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [403839] = 29,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(3174), 1,
      anon_sym_BSLASH,
    ACTIONS(3176), 1,
      anon_sym_u03bb,
    ACTIONS(3194), 1,
      anon_sym_quoteGoal,
    ACTIONS(3196), 1,
      anon_sym_tactic,
    ACTIONS(3202), 1,
      anon_sym_let,
    ACTIONS(6198), 1,
      sym_id,
    ACTIONS(6202), 1,
      anon_sym_record,
    ACTIONS(6204), 1,
      anon_sym_LPAREN,
    ACTIONS(6206), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(6208), 1,
      anon_sym_u2983,
    ACTIONS(6210), 1,
      anon_sym_LBRACE,
    ACTIONS(6212), 1,
      aux_sym__qid_token1,
    ACTIONS(6214), 1,
      anon_sym_DOT,
    ACTIONS(6216), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(6218), 1,
      anon_sym_u2987,
    ACTIONS(6222), 1,
      anon_sym_Set,
    STATE(3855), 1,
      aux_sym__atoms,
    STATE(4038), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5407), 1,
      sym_atom,
    STATE(8051), 1,
      sym__LAMBDA,
    STATE(8409), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3170), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(6220), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5699), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5697), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8996), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(6200), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [403952] = 29,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(2694), 1,
      anon_sym_BSLASH,
    ACTIONS(2696), 1,
      anon_sym_u03bb,
    ACTIONS(2714), 1,
      anon_sym_quoteGoal,
    ACTIONS(2716), 1,
      anon_sym_tactic,
    ACTIONS(2722), 1,
      anon_sym_let,
    ACTIONS(5574), 1,
      sym_id,
    ACTIONS(5578), 1,
      anon_sym_record,
    ACTIONS(5580), 1,
      anon_sym_LPAREN,
    ACTIONS(5582), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(5584), 1,
      anon_sym_u2983,
    ACTIONS(5586), 1,
      anon_sym_LBRACE,
    ACTIONS(5588), 1,
      aux_sym__qid_token1,
    ACTIONS(5590), 1,
      anon_sym_DOT,
    ACTIONS(5592), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(5594), 1,
      anon_sym_u2987,
    ACTIONS(5598), 1,
      anon_sym_Set,
    STATE(3797), 1,
      aux_sym__atoms,
    STATE(4038), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4408), 1,
      sym_atom,
    STATE(8133), 1,
      sym__LAMBDA,
    STATE(8368), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2692), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(5596), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4312), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4307), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8996), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(5576), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [404065] = 29,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(5898), 1,
      sym_id,
    ACTIONS(5902), 1,
      anon_sym_record,
    ACTIONS(5904), 1,
      anon_sym_LPAREN,
    ACTIONS(5906), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(5908), 1,
      anon_sym_u2983,
    ACTIONS(5910), 1,
      anon_sym_LBRACE,
    ACTIONS(5912), 1,
      aux_sym__qid_token1,
    ACTIONS(5914), 1,
      anon_sym_DOT,
    ACTIONS(5916), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(5918), 1,
      anon_sym_u2987,
    ACTIONS(5922), 1,
      anon_sym_Set,
    STATE(3811), 1,
      aux_sym__atoms,
    STATE(4038), 1,
      aux_sym__with_exprs_repeat1,
    STATE(6198), 1,
      sym_atom,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(5920), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6087), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6089), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9456), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(5900), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [404178] = 29,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(3410), 1,
      anon_sym_BSLASH,
    ACTIONS(3412), 1,
      anon_sym_u03bb,
    ACTIONS(3430), 1,
      anon_sym_quoteGoal,
    ACTIONS(3432), 1,
      anon_sym_tactic,
    ACTIONS(3438), 1,
      anon_sym_let,
    ACTIONS(5468), 1,
      sym_id,
    ACTIONS(5472), 1,
      anon_sym_record,
    ACTIONS(5474), 1,
      anon_sym_LPAREN,
    ACTIONS(5476), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(5478), 1,
      anon_sym_u2983,
    ACTIONS(5480), 1,
      anon_sym_LBRACE,
    ACTIONS(5482), 1,
      aux_sym__qid_token1,
    ACTIONS(5484), 1,
      anon_sym_DOT,
    ACTIONS(5486), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(5488), 1,
      anon_sym_u2987,
    ACTIONS(5492), 1,
      anon_sym_Set,
    STATE(3875), 1,
      aux_sym__atoms,
    STATE(4038), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4421), 1,
      sym_atom,
    STATE(8038), 1,
      sym__LAMBDA,
    STATE(8435), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3408), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(5490), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4533), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4527), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8996), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(5470), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [404291] = 29,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(5760), 1,
      sym_id,
    ACTIONS(5764), 1,
      anon_sym_record,
    ACTIONS(5766), 1,
      anon_sym_LPAREN,
    ACTIONS(5768), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(5770), 1,
      anon_sym_u2983,
    ACTIONS(5772), 1,
      anon_sym_LBRACE,
    ACTIONS(5774), 1,
      aux_sym__qid_token1,
    ACTIONS(5776), 1,
      anon_sym_DOT,
    ACTIONS(5778), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(5780), 1,
      anon_sym_u2987,
    ACTIONS(5784), 1,
      anon_sym_Set,
    STATE(3771), 1,
      aux_sym__atoms,
    STATE(4038), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5927), 1,
      sym_atom,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(5782), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5941), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5965), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8995), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(5762), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [404404] = 29,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(5846), 1,
      sym_id,
    ACTIONS(5850), 1,
      anon_sym_record,
    ACTIONS(5852), 1,
      anon_sym_LPAREN,
    ACTIONS(5854), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(5856), 1,
      anon_sym_u2983,
    ACTIONS(5858), 1,
      anon_sym_LBRACE,
    ACTIONS(5860), 1,
      aux_sym__qid_token1,
    ACTIONS(5862), 1,
      anon_sym_DOT,
    ACTIONS(5864), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(5866), 1,
      anon_sym_u2987,
    ACTIONS(5870), 1,
      anon_sym_Set,
    STATE(3823), 1,
      aux_sym__atoms,
    STATE(4038), 1,
      aux_sym__with_exprs_repeat1,
    STATE(6072), 1,
      sym_atom,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(5868), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6096), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6100), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8995), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(5848), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [404517] = 29,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(738), 1,
      anon_sym_BSLASH,
    ACTIONS(740), 1,
      anon_sym_u03bb,
    ACTIONS(762), 1,
      anon_sym_quoteGoal,
    ACTIONS(764), 1,
      anon_sym_tactic,
    ACTIONS(3054), 1,
      anon_sym_let,
    ACTIONS(4248), 1,
      sym_id,
    ACTIONS(4252), 1,
      anon_sym_record,
    ACTIONS(4254), 1,
      anon_sym_LPAREN,
    ACTIONS(4256), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4258), 1,
      anon_sym_u2983,
    ACTIONS(4260), 1,
      anon_sym_LBRACE,
    ACTIONS(4262), 1,
      aux_sym__qid_token1,
    ACTIONS(4264), 1,
      anon_sym_DOT,
    ACTIONS(4266), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4268), 1,
      anon_sym_u2987,
    ACTIONS(4272), 1,
      anon_sym_Set,
    STATE(3768), 1,
      aux_sym__atoms,
    STATE(4038), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5812), 1,
      sym_atom,
    STATE(8156), 1,
      sym__LAMBDA,
    STATE(8456), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(736), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4270), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5952), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5976), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8996), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(4250), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [404630] = 29,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(2944), 1,
      anon_sym_BSLASH,
    ACTIONS(2946), 1,
      anon_sym_u03bb,
    ACTIONS(2964), 1,
      anon_sym_quoteGoal,
    ACTIONS(2966), 1,
      anon_sym_tactic,
    ACTIONS(2972), 1,
      anon_sym_let,
    ACTIONS(5952), 1,
      sym_id,
    ACTIONS(5956), 1,
      anon_sym_record,
    ACTIONS(5958), 1,
      anon_sym_LPAREN,
    ACTIONS(5960), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(5962), 1,
      anon_sym_u2983,
    ACTIONS(5964), 1,
      anon_sym_LBRACE,
    ACTIONS(5966), 1,
      aux_sym__qid_token1,
    ACTIONS(5968), 1,
      anon_sym_DOT,
    ACTIONS(5970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(5972), 1,
      anon_sym_u2987,
    ACTIONS(5976), 1,
      anon_sym_Set,
    STATE(3764), 1,
      aux_sym__atoms,
    STATE(4038), 1,
      aux_sym__with_exprs_repeat1,
    STATE(6277), 1,
      sym_atom,
    STATE(8126), 1,
      sym__LAMBDA,
    STATE(8418), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2940), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(5974), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6213), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6217), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8996), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(5954), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [404743] = 29,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(2656), 1,
      anon_sym_BSLASH,
    ACTIONS(2658), 1,
      anon_sym_u03bb,
    ACTIONS(2676), 1,
      anon_sym_quoteGoal,
    ACTIONS(2678), 1,
      anon_sym_tactic,
    ACTIONS(2684), 1,
      anon_sym_let,
    ACTIONS(5028), 1,
      sym_id,
    ACTIONS(5032), 1,
      anon_sym_record,
    ACTIONS(5034), 1,
      anon_sym_LPAREN,
    ACTIONS(5036), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(5038), 1,
      anon_sym_u2983,
    ACTIONS(5040), 1,
      anon_sym_LBRACE,
    ACTIONS(5042), 1,
      aux_sym__qid_token1,
    ACTIONS(5044), 1,
      anon_sym_DOT,
    ACTIONS(5046), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(5048), 1,
      anon_sym_u2987,
    ACTIONS(5052), 1,
      anon_sym_Set,
    STATE(3876), 1,
      aux_sym__atoms,
    STATE(4038), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5588), 1,
      sym_atom,
    STATE(8132), 1,
      sym__LAMBDA,
    STATE(8470), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2654), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(5050), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5401), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5405), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9456), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(5030), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [404856] = 29,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(2212), 1,
      anon_sym_BSLASH,
    ACTIONS(2214), 1,
      anon_sym_u03bb,
    ACTIONS(2232), 1,
      anon_sym_quoteGoal,
    ACTIONS(2234), 1,
      anon_sym_tactic,
    ACTIONS(2240), 1,
      anon_sym_let,
    ACTIONS(6138), 1,
      sym_id,
    ACTIONS(6142), 1,
      anon_sym_record,
    ACTIONS(6144), 1,
      anon_sym_LPAREN,
    ACTIONS(6146), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(6148), 1,
      anon_sym_u2983,
    ACTIONS(6150), 1,
      anon_sym_LBRACE,
    ACTIONS(6152), 1,
      aux_sym__qid_token1,
    ACTIONS(6154), 1,
      anon_sym_DOT,
    ACTIONS(6156), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(6158), 1,
      anon_sym_u2987,
    ACTIONS(6162), 1,
      anon_sym_Set,
    STATE(3803), 1,
      aux_sym__atoms,
    STATE(4038), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5008), 1,
      sym_atom,
    STATE(8035), 1,
      sym__LAMBDA,
    STATE(8402), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(6160), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5132), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5134), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8996), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(6140), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [404969] = 29,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(105), 1,
      sym_id,
    ACTIONS(109), 1,
      anon_sym_BSLASH,
    ACTIONS(111), 1,
      anon_sym_u03bb,
    ACTIONS(125), 1,
      anon_sym_LPAREN,
    ACTIONS(127), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(129), 1,
      anon_sym_u2983,
    ACTIONS(135), 1,
      anon_sym_LBRACE,
    ACTIONS(143), 1,
      aux_sym__qid_token1,
    ACTIONS(145), 1,
      anon_sym_DOT,
    ACTIONS(147), 1,
      anon_sym_quoteGoal,
    ACTIONS(149), 1,
      anon_sym_tactic,
    ACTIONS(151), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(153), 1,
      anon_sym_u2987,
    ACTIONS(155), 1,
      anon_sym_let,
    ACTIONS(159), 1,
      anon_sym_Set,
    ACTIONS(4274), 1,
      anon_sym_record,
    STATE(3854), 1,
      aux_sym__atoms,
    STATE(4038), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4271), 1,
      sym_atom,
    STATE(8146), 1,
      sym__LAMBDA,
    STATE(8343), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(107), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(157), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4311), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4327), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8996), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(113), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [405082] = 29,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1928), 1,
      anon_sym_quoteGoal,
    ACTIONS(1936), 1,
      anon_sym_let,
    ACTIONS(2338), 1,
      anon_sym_BSLASH,
    ACTIONS(2340), 1,
      anon_sym_u03bb,
    ACTIONS(2344), 1,
      anon_sym_tactic,
    ACTIONS(5708), 1,
      sym_id,
    ACTIONS(5712), 1,
      anon_sym_record,
    ACTIONS(5714), 1,
      anon_sym_LPAREN,
    ACTIONS(5716), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(5718), 1,
      anon_sym_u2983,
    ACTIONS(5720), 1,
      anon_sym_LBRACE,
    ACTIONS(5722), 1,
      aux_sym__qid_token1,
    ACTIONS(5724), 1,
      anon_sym_DOT,
    ACTIONS(5726), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(5728), 1,
      anon_sym_u2987,
    ACTIONS(5732), 1,
      anon_sym_Set,
    STATE(3800), 1,
      aux_sym__atoms,
    STATE(4038), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5512), 1,
      sym_atom,
    STATE(8079), 1,
      sym__LAMBDA,
    STATE(8431), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1906), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(5730), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5553), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5550), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8995), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(5710), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [405195] = 29,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(3486), 1,
      anon_sym_BSLASH,
    ACTIONS(3488), 1,
      anon_sym_u03bb,
    ACTIONS(3506), 1,
      anon_sym_quoteGoal,
    ACTIONS(3508), 1,
      anon_sym_tactic,
    ACTIONS(3514), 1,
      anon_sym_let,
    ACTIONS(5814), 1,
      sym_id,
    ACTIONS(5818), 1,
      anon_sym_record,
    ACTIONS(5820), 1,
      anon_sym_LPAREN,
    ACTIONS(5822), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(5824), 1,
      anon_sym_u2983,
    ACTIONS(5826), 1,
      anon_sym_LBRACE,
    ACTIONS(5828), 1,
      aux_sym__qid_token1,
    ACTIONS(5830), 1,
      anon_sym_DOT,
    ACTIONS(5832), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(5834), 1,
      anon_sym_u2987,
    ACTIONS(5838), 1,
      anon_sym_Set,
    STATE(3767), 1,
      aux_sym__atoms,
    STATE(4038), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4780), 1,
      sym_atom,
    STATE(8140), 1,
      sym__LAMBDA,
    STATE(8504), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3484), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(5836), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4860), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4868), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8996), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(5816), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [405308] = 29,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(2982), 1,
      anon_sym_BSLASH,
    ACTIONS(2984), 1,
      anon_sym_u03bb,
    ACTIONS(3002), 1,
      anon_sym_quoteGoal,
    ACTIONS(3004), 1,
      anon_sym_tactic,
    ACTIONS(3010), 1,
      anon_sym_let,
    ACTIONS(5788), 1,
      sym_id,
    ACTIONS(5792), 1,
      anon_sym_record,
    ACTIONS(5794), 1,
      anon_sym_LPAREN,
    ACTIONS(5796), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(5798), 1,
      anon_sym_u2983,
    ACTIONS(5800), 1,
      anon_sym_LBRACE,
    ACTIONS(5802), 1,
      aux_sym__qid_token1,
    ACTIONS(5804), 1,
      anon_sym_DOT,
    ACTIONS(5806), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(5808), 1,
      anon_sym_u2987,
    ACTIONS(5812), 1,
      anon_sym_Set,
    STATE(3804), 1,
      aux_sym__atoms,
    STATE(4038), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4924), 1,
      sym_atom,
    STATE(8117), 1,
      sym__LAMBDA,
    STATE(8511), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(5810), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5245), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5235), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8996), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(5790), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [405421] = 29,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(1870), 1,
      anon_sym_BSLASH,
    ACTIONS(1872), 1,
      anon_sym_u03bb,
    ACTIONS(1890), 1,
      anon_sym_quoteGoal,
    ACTIONS(1892), 1,
      anon_sym_tactic,
    ACTIONS(1898), 1,
      anon_sym_let,
    ACTIONS(5332), 1,
      sym_id,
    ACTIONS(5336), 1,
      anon_sym_record,
    ACTIONS(5338), 1,
      anon_sym_LPAREN,
    ACTIONS(5340), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(5342), 1,
      anon_sym_u2983,
    ACTIONS(5344), 1,
      anon_sym_LBRACE,
    ACTIONS(5346), 1,
      aux_sym__qid_token1,
    ACTIONS(5348), 1,
      anon_sym_DOT,
    ACTIONS(5350), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(5352), 1,
      anon_sym_u2987,
    ACTIONS(5356), 1,
      anon_sym_Set,
    STATE(3847), 1,
      aux_sym__atoms,
    STATE(4038), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4786), 1,
      sym_atom,
    STATE(8032), 1,
      sym__LAMBDA,
    STATE(8379), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1868), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(5354), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4898), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4840), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8996), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(5334), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [405534] = 29,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(3266), 1,
      anon_sym_BSLASH,
    ACTIONS(3268), 1,
      anon_sym_u03bb,
    ACTIONS(3286), 1,
      anon_sym_quoteGoal,
    ACTIONS(3288), 1,
      anon_sym_tactic,
    ACTIONS(3294), 1,
      anon_sym_let,
    ACTIONS(4950), 1,
      sym_id,
    ACTIONS(4954), 1,
      anon_sym_record,
    ACTIONS(4956), 1,
      anon_sym_LPAREN,
    ACTIONS(4958), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4960), 1,
      anon_sym_u2983,
    ACTIONS(4962), 1,
      anon_sym_LBRACE,
    ACTIONS(4964), 1,
      aux_sym__qid_token1,
    ACTIONS(4966), 1,
      anon_sym_DOT,
    ACTIONS(4968), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4970), 1,
      anon_sym_u2987,
    ACTIONS(4974), 1,
      anon_sym_Set,
    STATE(3878), 1,
      aux_sym__atoms,
    STATE(4038), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4226), 1,
      sym_atom,
    STATE(8143), 1,
      sym__LAMBDA,
    STATE(8451), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3264), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4972), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4253), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4254), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8996), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(4952), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [405647] = 29,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1984), 1,
      anon_sym_BSLASH,
    ACTIONS(1986), 1,
      anon_sym_u03bb,
    ACTIONS(2004), 1,
      anon_sym_quoteGoal,
    ACTIONS(2006), 1,
      anon_sym_tactic,
    ACTIONS(2012), 1,
      anon_sym_let,
    ACTIONS(5734), 1,
      sym_id,
    ACTIONS(5738), 1,
      anon_sym_record,
    ACTIONS(5740), 1,
      anon_sym_LPAREN,
    ACTIONS(5742), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(5744), 1,
      anon_sym_u2983,
    ACTIONS(5746), 1,
      anon_sym_LBRACE,
    ACTIONS(5748), 1,
      aux_sym__qid_token1,
    ACTIONS(5750), 1,
      anon_sym_DOT,
    ACTIONS(5752), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(5754), 1,
      anon_sym_u2987,
    ACTIONS(5758), 1,
      anon_sym_Set,
    STATE(3844), 1,
      aux_sym__atoms,
    STATE(4038), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5950), 1,
      sym_atom,
    STATE(8039), 1,
      sym__LAMBDA,
    STATE(8483), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1982), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(5756), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5762), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5752), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8995), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(5736), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [405760] = 29,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(1302), 1,
      anon_sym_let,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(5166), 1,
      sym_id,
    ACTIONS(5170), 1,
      anon_sym_record,
    ACTIONS(5172), 1,
      anon_sym_LPAREN,
    ACTIONS(5174), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(5176), 1,
      anon_sym_u2983,
    ACTIONS(5178), 1,
      anon_sym_LBRACE,
    ACTIONS(5180), 1,
      aux_sym__qid_token1,
    ACTIONS(5182), 1,
      anon_sym_DOT,
    ACTIONS(5184), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(5186), 1,
      anon_sym_u2987,
    ACTIONS(5190), 1,
      anon_sym_Set,
    STATE(3813), 1,
      aux_sym__atoms,
    STATE(4038), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5916), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(5188), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5928), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5926), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8995), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(5168), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [405873] = 29,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(3448), 1,
      anon_sym_BSLASH,
    ACTIONS(3450), 1,
      anon_sym_u03bb,
    ACTIONS(3468), 1,
      anon_sym_quoteGoal,
    ACTIONS(3470), 1,
      anon_sym_tactic,
    ACTIONS(3476), 1,
      anon_sym_let,
    ACTIONS(6032), 1,
      sym_id,
    ACTIONS(6036), 1,
      anon_sym_record,
    ACTIONS(6038), 1,
      anon_sym_LPAREN,
    ACTIONS(6040), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(6042), 1,
      anon_sym_u2983,
    ACTIONS(6044), 1,
      anon_sym_LBRACE,
    ACTIONS(6046), 1,
      aux_sym__qid_token1,
    ACTIONS(6048), 1,
      anon_sym_DOT,
    ACTIONS(6050), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(6052), 1,
      anon_sym_u2987,
    ACTIONS(6056), 1,
      anon_sym_Set,
    STATE(3801), 1,
      aux_sym__atoms,
    STATE(4038), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5944), 1,
      sym_atom,
    STATE(8072), 1,
      sym__LAMBDA,
    STATE(8455), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3446), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(6054), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5909), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5914), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8996), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(6034), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [405986] = 29,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(944), 1,
      anon_sym_BSLASH,
    ACTIONS(946), 1,
      anon_sym_u03bb,
    ACTIONS(964), 1,
      anon_sym_quoteGoal,
    ACTIONS(966), 1,
      anon_sym_tactic,
    ACTIONS(972), 1,
      anon_sym_let,
    ACTIONS(5416), 1,
      sym_id,
    ACTIONS(5420), 1,
      anon_sym_record,
    ACTIONS(5422), 1,
      anon_sym_LPAREN,
    ACTIONS(5424), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(5426), 1,
      anon_sym_u2983,
    ACTIONS(5428), 1,
      anon_sym_LBRACE,
    ACTIONS(5430), 1,
      aux_sym__qid_token1,
    ACTIONS(5432), 1,
      anon_sym_DOT,
    ACTIONS(5434), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(5436), 1,
      anon_sym_u2987,
    ACTIONS(5440), 1,
      anon_sym_Set,
    STATE(3857), 1,
      aux_sym__atoms,
    STATE(4038), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5548), 1,
      sym_atom,
    STATE(8054), 1,
      sym__LAMBDA,
    STATE(8355), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(942), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(5438), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5369), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5364), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8995), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(5418), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [406099] = 29,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(964), 1,
      anon_sym_quoteGoal,
    ACTIONS(972), 1,
      anon_sym_let,
    ACTIONS(4214), 1,
      anon_sym_BSLASH,
    ACTIONS(4216), 1,
      anon_sym_u03bb,
    ACTIONS(4218), 1,
      anon_sym_tactic,
    ACTIONS(5166), 1,
      sym_id,
    ACTIONS(5170), 1,
      anon_sym_record,
    ACTIONS(5172), 1,
      anon_sym_LPAREN,
    ACTIONS(5174), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(5176), 1,
      anon_sym_u2983,
    ACTIONS(5178), 1,
      anon_sym_LBRACE,
    ACTIONS(5180), 1,
      aux_sym__qid_token1,
    ACTIONS(5182), 1,
      anon_sym_DOT,
    ACTIONS(5184), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(5186), 1,
      anon_sym_u2987,
    ACTIONS(5190), 1,
      anon_sym_Set,
    STATE(3834), 1,
      aux_sym__atoms,
    STATE(4038), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5916), 1,
      sym_atom,
    STATE(8047), 1,
      sym__LAMBDA,
    STATE(8355), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(942), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(5188), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5928), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5926), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8995), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(5168), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [406212] = 29,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    ACTIONS(5760), 1,
      sym_id,
    ACTIONS(5764), 1,
      anon_sym_record,
    ACTIONS(5766), 1,
      anon_sym_LPAREN,
    ACTIONS(5768), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(5770), 1,
      anon_sym_u2983,
    ACTIONS(5772), 1,
      anon_sym_LBRACE,
    ACTIONS(5774), 1,
      aux_sym__qid_token1,
    ACTIONS(5776), 1,
      anon_sym_DOT,
    ACTIONS(5778), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(5780), 1,
      anon_sym_u2987,
    ACTIONS(5784), 1,
      anon_sym_Set,
    STATE(3781), 1,
      aux_sym__atoms,
    STATE(4038), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5927), 1,
      sym_atom,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(5782), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5941), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5965), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8995), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(5762), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [406325] = 29,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(5390), 1,
      sym_id,
    ACTIONS(5394), 1,
      anon_sym_record,
    ACTIONS(5396), 1,
      anon_sym_LPAREN,
    ACTIONS(5398), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(5400), 1,
      anon_sym_u2983,
    ACTIONS(5402), 1,
      anon_sym_LBRACE,
    ACTIONS(5404), 1,
      aux_sym__qid_token1,
    ACTIONS(5406), 1,
      anon_sym_DOT,
    ACTIONS(5408), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(5410), 1,
      anon_sym_u2987,
    ACTIONS(5414), 1,
      anon_sym_Set,
    STATE(3818), 1,
      aux_sym__atoms,
    STATE(4038), 1,
      aux_sym__with_exprs_repeat1,
    STATE(6075), 1,
      sym_atom,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(5412), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6026), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6060), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8995), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(5392), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [406438] = 29,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2448), 1,
      anon_sym_quoteGoal,
    ACTIONS(2456), 1,
      anon_sym_let,
    ACTIONS(2842), 1,
      anon_sym_BSLASH,
    ACTIONS(2844), 1,
      anon_sym_u03bb,
    ACTIONS(2862), 1,
      anon_sym_tactic,
    ACTIONS(5442), 1,
      sym_id,
    ACTIONS(5446), 1,
      anon_sym_record,
    ACTIONS(5448), 1,
      anon_sym_LPAREN,
    ACTIONS(5450), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(5452), 1,
      anon_sym_u2983,
    ACTIONS(5454), 1,
      anon_sym_LBRACE,
    ACTIONS(5456), 1,
      aux_sym__qid_token1,
    ACTIONS(5458), 1,
      anon_sym_DOT,
    ACTIONS(5460), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(5462), 1,
      anon_sym_u2987,
    ACTIONS(5466), 1,
      anon_sym_Set,
    STATE(3859), 1,
      aux_sym__atoms,
    STATE(4038), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5485), 1,
      sym_atom,
    STATE(8053), 1,
      sym__LAMBDA,
    STATE(8423), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2424), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(5464), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5639), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5635), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8995), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(5444), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [406551] = 29,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2022), 1,
      anon_sym_BSLASH,
    ACTIONS(2024), 1,
      anon_sym_u03bb,
    ACTIONS(2042), 1,
      anon_sym_quoteGoal,
    ACTIONS(2044), 1,
      anon_sym_tactic,
    ACTIONS(2050), 1,
      anon_sym_let,
    ACTIONS(5140), 1,
      sym_id,
    ACTIONS(5144), 1,
      anon_sym_record,
    ACTIONS(5146), 1,
      anon_sym_LPAREN,
    ACTIONS(5148), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(5150), 1,
      anon_sym_u2983,
    ACTIONS(5152), 1,
      anon_sym_LBRACE,
    ACTIONS(5154), 1,
      aux_sym__qid_token1,
    ACTIONS(5156), 1,
      anon_sym_DOT,
    ACTIONS(5158), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(5160), 1,
      anon_sym_u2987,
    ACTIONS(5164), 1,
      anon_sym_Set,
    STATE(3802), 1,
      aux_sym__atoms,
    STATE(4038), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5948), 1,
      sym_atom,
    STATE(8033), 1,
      sym__LAMBDA,
    STATE(8463), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2020), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(5162), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5797), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5795), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8995), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(5142), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [406664] = 29,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(2732), 1,
      anon_sym_BSLASH,
    ACTIONS(2734), 1,
      anon_sym_u03bb,
    ACTIONS(2752), 1,
      anon_sym_quoteGoal,
    ACTIONS(2754), 1,
      anon_sym_tactic,
    ACTIONS(2760), 1,
      anon_sym_let,
    ACTIONS(5630), 1,
      sym_id,
    ACTIONS(5634), 1,
      anon_sym_record,
    ACTIONS(5636), 1,
      anon_sym_LPAREN,
    ACTIONS(5638), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(5640), 1,
      anon_sym_u2983,
    ACTIONS(5642), 1,
      anon_sym_LBRACE,
    ACTIONS(5644), 1,
      aux_sym__qid_token1,
    ACTIONS(5646), 1,
      anon_sym_DOT,
    ACTIONS(5648), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(5650), 1,
      anon_sym_u2987,
    ACTIONS(5654), 1,
      anon_sym_Set,
    STATE(3864), 1,
      aux_sym__atoms,
    STATE(4038), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5368), 1,
      sym_atom,
    STATE(8061), 1,
      sym__LAMBDA,
    STATE(8384), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2730), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(5652), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5733), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5727), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8996), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(5632), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [406777] = 29,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2140), 1,
      anon_sym_BSLASH,
    ACTIONS(2142), 1,
      anon_sym_u03bb,
    ACTIONS(2160), 1,
      anon_sym_quoteGoal,
    ACTIONS(2162), 1,
      anon_sym_tactic,
    ACTIONS(2168), 1,
      anon_sym_let,
    ACTIONS(6112), 1,
      sym_id,
    ACTIONS(6116), 1,
      anon_sym_record,
    ACTIONS(6118), 1,
      anon_sym_LPAREN,
    ACTIONS(6120), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(6122), 1,
      anon_sym_u2983,
    ACTIONS(6124), 1,
      anon_sym_LBRACE,
    ACTIONS(6126), 1,
      aux_sym__qid_token1,
    ACTIONS(6128), 1,
      anon_sym_DOT,
    ACTIONS(6130), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(6132), 1,
      anon_sym_u2987,
    ACTIONS(6136), 1,
      anon_sym_Set,
    STATE(3874), 1,
      aux_sym__atoms,
    STATE(4038), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5942), 1,
      sym_atom,
    STATE(8040), 1,
      sym__LAMBDA,
    STATE(8460), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2136), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(6134), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5819), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5817), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8995), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(6114), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [406890] = 29,
    ACTIONS(878), 1,
      anon_sym_quoteGoal,
    ACTIONS(886), 1,
      anon_sym_let,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(4184), 1,
      anon_sym_BSLASH,
    ACTIONS(4186), 1,
      anon_sym_u03bb,
    ACTIONS(4204), 1,
      anon_sym_tactic,
    ACTIONS(5494), 1,
      sym_id,
    ACTIONS(5498), 1,
      anon_sym_record,
    ACTIONS(5500), 1,
      anon_sym_LPAREN,
    ACTIONS(5502), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(5504), 1,
      anon_sym_u2983,
    ACTIONS(5506), 1,
      anon_sym_LBRACE,
    ACTIONS(5508), 1,
      aux_sym__qid_token1,
    ACTIONS(5510), 1,
      anon_sym_DOT,
    ACTIONS(5512), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(5514), 1,
      anon_sym_u2987,
    ACTIONS(5518), 1,
      anon_sym_Set,
    STATE(3785), 1,
      aux_sym__atoms,
    STATE(4038), 1,
      aux_sym__with_exprs_repeat1,
    STATE(6095), 1,
      sym_atom,
    STATE(8067), 1,
      sym__LAMBDA,
    STATE(8369), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(852), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(5516), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6047), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6050), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8995), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(5496), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [407003] = 29,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(2388), 1,
      anon_sym_BSLASH,
    ACTIONS(2390), 1,
      anon_sym_u03bb,
    ACTIONS(2408), 1,
      anon_sym_quoteGoal,
    ACTIONS(2410), 1,
      anon_sym_tactic,
    ACTIONS(2416), 1,
      anon_sym_let,
    ACTIONS(5082), 1,
      sym_id,
    ACTIONS(5086), 1,
      anon_sym_record,
    ACTIONS(5088), 1,
      anon_sym_LPAREN,
    ACTIONS(5090), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(5092), 1,
      anon_sym_u2983,
    ACTIONS(5094), 1,
      anon_sym_LBRACE,
    ACTIONS(5096), 1,
      aux_sym__qid_token1,
    ACTIONS(5098), 1,
      anon_sym_DOT,
    ACTIONS(5100), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(5102), 1,
      anon_sym_u2987,
    ACTIONS(5106), 1,
      anon_sym_Set,
    STATE(3838), 1,
      aux_sym__atoms,
    STATE(4038), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5358), 1,
      sym_atom,
    STATE(8139), 1,
      sym__LAMBDA,
    STATE(8518), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2386), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(5104), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5584), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5587), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8996), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(5084), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [407116] = 29,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2428), 1,
      anon_sym_BSLASH,
    ACTIONS(2430), 1,
      anon_sym_u03bb,
    ACTIONS(2448), 1,
      anon_sym_quoteGoal,
    ACTIONS(2450), 1,
      anon_sym_tactic,
    ACTIONS(2456), 1,
      anon_sym_let,
    ACTIONS(5306), 1,
      sym_id,
    ACTIONS(5310), 1,
      anon_sym_record,
    ACTIONS(5312), 1,
      anon_sym_LPAREN,
    ACTIONS(5314), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(5316), 1,
      anon_sym_u2983,
    ACTIONS(5318), 1,
      anon_sym_LBRACE,
    ACTIONS(5320), 1,
      aux_sym__qid_token1,
    ACTIONS(5322), 1,
      anon_sym_DOT,
    ACTIONS(5324), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(5326), 1,
      anon_sym_u2987,
    ACTIONS(5330), 1,
      anon_sym_Set,
    STATE(3793), 1,
      aux_sym__atoms,
    STATE(4038), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5759), 1,
      sym_atom,
    STATE(8125), 1,
      sym__LAMBDA,
    STATE(8423), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2424), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(5328), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5854), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5853), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8995), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(5308), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [407229] = 29,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(5112), 1,
      sym_id,
    ACTIONS(5116), 1,
      anon_sym_record,
    ACTIONS(5118), 1,
      anon_sym_LPAREN,
    ACTIONS(5120), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(5122), 1,
      anon_sym_u2983,
    ACTIONS(5124), 1,
      anon_sym_LBRACE,
    ACTIONS(5126), 1,
      aux_sym__qid_token1,
    ACTIONS(5128), 1,
      anon_sym_DOT,
    ACTIONS(5130), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(5132), 1,
      anon_sym_u2987,
    ACTIONS(5136), 1,
      anon_sym_Set,
    STATE(3871), 1,
      aux_sym__atoms,
    STATE(4038), 1,
      aux_sym__with_exprs_repeat1,
    STATE(6081), 1,
      sym_atom,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(5134), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6010), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6007), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8995), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(5114), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [407342] = 19,
    ACTIONS(3262), 1,
      sym_id,
    ACTIONS(3272), 1,
      anon_sym_record,
    ACTIONS(3282), 1,
      aux_sym__qid_token1,
    ACTIONS(3290), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3292), 1,
      anon_sym_u2987,
    ACTIONS(3298), 1,
      anon_sym_Set,
    ACTIONS(4354), 1,
      anon_sym_LPAREN,
    ACTIONS(4356), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4358), 1,
      anon_sym_u2983,
    ACTIONS(4360), 1,
      anon_sym_LBRACE,
    ACTIONS(4362), 1,
      anon_sym_DOT,
    STATE(4034), 1,
      sym_atom,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3296), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(6226), 2,
      sym__newline,
      anon_sym_BSLASH,
    STATE(4032), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4012), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3270), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    ACTIONS(6224), 18,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_let,
      anon_sym_do,
  [407435] = 29,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(2904), 1,
      anon_sym_BSLASH,
    ACTIONS(2906), 1,
      anon_sym_u03bb,
    ACTIONS(2924), 1,
      anon_sym_quoteGoal,
    ACTIONS(2926), 1,
      anon_sym_tactic,
    ACTIONS(2932), 1,
      anon_sym_let,
    ACTIONS(6058), 1,
      sym_id,
    ACTIONS(6062), 1,
      anon_sym_record,
    ACTIONS(6064), 1,
      anon_sym_LPAREN,
    ACTIONS(6066), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(6068), 1,
      anon_sym_u2983,
    ACTIONS(6070), 1,
      anon_sym_LBRACE,
    ACTIONS(6072), 1,
      aux_sym__qid_token1,
    ACTIONS(6074), 1,
      anon_sym_DOT,
    ACTIONS(6076), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(6078), 1,
      anon_sym_u2987,
    ACTIONS(6082), 1,
      anon_sym_Set,
    STATE(3773), 1,
      aux_sym__atoms,
    STATE(4038), 1,
      aux_sym__with_exprs_repeat1,
    STATE(4278), 1,
      sym_atom,
    STATE(8094), 1,
      sym__LAMBDA,
    STATE(8489), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2900), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(6080), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4341), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4349), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8996), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(6060), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [407548] = 29,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2100), 1,
      anon_sym_BSLASH,
    ACTIONS(2102), 1,
      anon_sym_u03bb,
    ACTIONS(2120), 1,
      anon_sym_quoteGoal,
    ACTIONS(2122), 1,
      anon_sym_tactic,
    ACTIONS(2128), 1,
      anon_sym_let,
    ACTIONS(5002), 1,
      sym_id,
    ACTIONS(5006), 1,
      anon_sym_record,
    ACTIONS(5008), 1,
      anon_sym_LPAREN,
    ACTIONS(5010), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(5012), 1,
      anon_sym_u2983,
    ACTIONS(5014), 1,
      anon_sym_LBRACE,
    ACTIONS(5016), 1,
      aux_sym__qid_token1,
    ACTIONS(5018), 1,
      anon_sym_DOT,
    ACTIONS(5020), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(5022), 1,
      anon_sym_u2987,
    ACTIONS(5026), 1,
      anon_sym_Set,
    STATE(3795), 1,
      aux_sym__atoms,
    STATE(4038), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5751), 1,
      sym_atom,
    STATE(8075), 1,
      sym__LAMBDA,
    STATE(8428), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2096), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(5024), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5805), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5804), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8995), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(5004), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [407661] = 29,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(2618), 1,
      anon_sym_BSLASH,
    ACTIONS(2620), 1,
      anon_sym_u03bb,
    ACTIONS(2638), 1,
      anon_sym_quoteGoal,
    ACTIONS(2640), 1,
      anon_sym_tactic,
    ACTIONS(2646), 1,
      anon_sym_let,
    ACTIONS(5926), 1,
      sym_id,
    ACTIONS(5930), 1,
      anon_sym_record,
    ACTIONS(5932), 1,
      anon_sym_LPAREN,
    ACTIONS(5934), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(5936), 1,
      anon_sym_u2983,
    ACTIONS(5938), 1,
      anon_sym_LBRACE,
    ACTIONS(5940), 1,
      aux_sym__qid_token1,
    ACTIONS(5942), 1,
      anon_sym_DOT,
    ACTIONS(5944), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(5946), 1,
      anon_sym_u2987,
    ACTIONS(5950), 1,
      anon_sym_Set,
    STATE(3830), 1,
      aux_sym__atoms,
    STATE(4038), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5542), 1,
      sym_atom,
    STATE(8093), 1,
      sym__LAMBDA,
    STATE(8414), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2616), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(5948), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5470), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5454), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8996), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(5928), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [407774] = 29,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(920), 1,
      anon_sym_quoteGoal,
    ACTIONS(928), 1,
      anon_sym_let,
    ACTIONS(3058), 1,
      anon_sym_BSLASH,
    ACTIONS(3060), 1,
      anon_sym_u03bb,
    ACTIONS(3080), 1,
      anon_sym_tactic,
    ACTIONS(4976), 1,
      sym_id,
    ACTIONS(4980), 1,
      anon_sym_record,
    ACTIONS(4982), 1,
      anon_sym_LPAREN,
    ACTIONS(4984), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4986), 1,
      anon_sym_u2983,
    ACTIONS(4988), 1,
      anon_sym_LBRACE,
    ACTIONS(4990), 1,
      aux_sym__qid_token1,
    ACTIONS(4992), 1,
      anon_sym_DOT,
    ACTIONS(4994), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4996), 1,
      anon_sym_u2987,
    ACTIONS(5000), 1,
      anon_sym_Set,
    STATE(3776), 1,
      aux_sym__atoms,
    STATE(4038), 1,
      aux_sym__with_exprs_repeat1,
    STATE(6120), 1,
      sym_atom,
    STATE(8123), 1,
      sym__LAMBDA,
    STATE(8396), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6124), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6161), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9456), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(4978), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [407887] = 29,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(3020), 1,
      anon_sym_BSLASH,
    ACTIONS(3022), 1,
      anon_sym_u03bb,
    ACTIONS(3040), 1,
      anon_sym_quoteGoal,
    ACTIONS(3042), 1,
      anon_sym_tactic,
    ACTIONS(3048), 1,
      anon_sym_let,
    ACTIONS(5978), 1,
      sym_id,
    ACTIONS(5982), 1,
      anon_sym_record,
    ACTIONS(5984), 1,
      anon_sym_LPAREN,
    ACTIONS(5986), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(5988), 1,
      anon_sym_u2983,
    ACTIONS(5990), 1,
      anon_sym_LBRACE,
    ACTIONS(5992), 1,
      aux_sym__qid_token1,
    ACTIONS(5994), 1,
      anon_sym_DOT,
    ACTIONS(5996), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(5998), 1,
      anon_sym_u2987,
    ACTIONS(6002), 1,
      anon_sym_Set,
    STATE(3826), 1,
      aux_sym__atoms,
    STATE(4038), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5749), 1,
      sym_atom,
    STATE(8127), 1,
      sym__LAMBDA,
    STATE(8388), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3018), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(6000), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5765), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5767), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8995), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(5980), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [408000] = 29,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(3698), 1,
      anon_sym_BSLASH,
    ACTIONS(3700), 1,
      anon_sym_u03bb,
    ACTIONS(3718), 1,
      anon_sym_quoteGoal,
    ACTIONS(3720), 1,
      anon_sym_tactic,
    ACTIONS(3726), 1,
      anon_sym_let,
    ACTIONS(5360), 1,
      sym_id,
    ACTIONS(5364), 1,
      anon_sym_record,
    ACTIONS(5366), 1,
      anon_sym_LPAREN,
    ACTIONS(5368), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(5370), 1,
      anon_sym_u2983,
    ACTIONS(5372), 1,
      anon_sym_LBRACE,
    ACTIONS(5374), 1,
      aux_sym__qid_token1,
    ACTIONS(5376), 1,
      anon_sym_DOT,
    ACTIONS(5378), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(5380), 1,
      anon_sym_u2987,
    ACTIONS(5384), 1,
      anon_sym_Set,
    STATE(3837), 1,
      aux_sym__atoms,
    STATE(4038), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5117), 1,
      sym_atom,
    STATE(8124), 1,
      sym__LAMBDA,
    STATE(8446), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3696), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(5382), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5038), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4980), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8996), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(5362), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [408113] = 29,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2120), 1,
      anon_sym_quoteGoal,
    ACTIONS(2128), 1,
      anon_sym_let,
    ACTIONS(2176), 1,
      anon_sym_BSLASH,
    ACTIONS(2178), 1,
      anon_sym_u03bb,
    ACTIONS(2196), 1,
      anon_sym_tactic,
    ACTIONS(5522), 1,
      sym_id,
    ACTIONS(5526), 1,
      anon_sym_record,
    ACTIONS(5528), 1,
      anon_sym_LPAREN,
    ACTIONS(5530), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(5532), 1,
      anon_sym_u2983,
    ACTIONS(5534), 1,
      anon_sym_LBRACE,
    ACTIONS(5536), 1,
      aux_sym__qid_token1,
    ACTIONS(5538), 1,
      anon_sym_DOT,
    ACTIONS(5540), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(5542), 1,
      anon_sym_u2987,
    ACTIONS(5546), 1,
      anon_sym_Set,
    STATE(3829), 1,
      aux_sym__atoms,
    STATE(4038), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5007), 1,
      sym_atom,
    STATE(8044), 1,
      sym__LAMBDA,
    STATE(8428), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2096), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(5544), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5318), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5319), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8995), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(5524), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [408226] = 29,
    ACTIONS(854), 1,
      anon_sym_BSLASH,
    ACTIONS(856), 1,
      anon_sym_u03bb,
    ACTIONS(878), 1,
      anon_sym_quoteGoal,
    ACTIONS(880), 1,
      anon_sym_tactic,
    ACTIONS(886), 1,
      anon_sym_let,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(5192), 1,
      sym_id,
    ACTIONS(5196), 1,
      anon_sym_record,
    ACTIONS(5198), 1,
      anon_sym_LPAREN,
    ACTIONS(5200), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(5202), 1,
      anon_sym_u2983,
    ACTIONS(5204), 1,
      anon_sym_LBRACE,
    ACTIONS(5206), 1,
      aux_sym__qid_token1,
    ACTIONS(5208), 1,
      anon_sym_DOT,
    ACTIONS(5210), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(5212), 1,
      anon_sym_u2987,
    ACTIONS(5216), 1,
      anon_sym_Set,
    STATE(3780), 1,
      aux_sym__atoms,
    STATE(4038), 1,
      aux_sym__with_exprs_repeat1,
    STATE(5956), 1,
      sym_atom,
    STATE(8152), 1,
      sym__LAMBDA,
    STATE(8369), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(852), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(5214), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5737), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5736), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8995), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(5194), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [408339] = 29,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(2944), 1,
      anon_sym_BSLASH,
    ACTIONS(2946), 1,
      anon_sym_u03bb,
    ACTIONS(2964), 1,
      anon_sym_quoteGoal,
    ACTIONS(2966), 1,
      anon_sym_tactic,
    ACTIONS(2972), 1,
      anon_sym_let,
    ACTIONS(4238), 1,
      anon_sym_PIPE,
    ACTIONS(5952), 1,
      sym_id,
    ACTIONS(5956), 1,
      anon_sym_record,
    ACTIONS(5958), 1,
      anon_sym_LPAREN,
    ACTIONS(5960), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(5962), 1,
      anon_sym_u2983,
    ACTIONS(5964), 1,
      anon_sym_LBRACE,
    ACTIONS(5966), 1,
      aux_sym__qid_token1,
    ACTIONS(5968), 1,
      anon_sym_DOT,
    ACTIONS(5970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(5972), 1,
      anon_sym_u2987,
    ACTIONS(5976), 1,
      anon_sym_Set,
    STATE(4039), 1,
      aux_sym__atoms,
    STATE(6277), 1,
      sym_atom,
    STATE(8126), 1,
      sym__LAMBDA,
    STATE(8418), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2940), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(5974), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6213), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6217), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9001), 7,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(5954), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [408451] = 28,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(1302), 1,
      anon_sym_let,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4222), 1,
      sym_id,
    ACTIONS(4224), 1,
      aux_sym__qid_token1,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(12658), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [408561] = 28,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(1302), 1,
      anon_sym_let,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4222), 1,
      sym_id,
    ACTIONS(4224), 1,
      aux_sym__qid_token1,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(12747), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [408671] = 29,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(3486), 1,
      anon_sym_BSLASH,
    ACTIONS(3488), 1,
      anon_sym_u03bb,
    ACTIONS(3506), 1,
      anon_sym_quoteGoal,
    ACTIONS(3508), 1,
      anon_sym_tactic,
    ACTIONS(3514), 1,
      anon_sym_let,
    ACTIONS(4238), 1,
      anon_sym_PIPE,
    ACTIONS(5814), 1,
      sym_id,
    ACTIONS(5818), 1,
      anon_sym_record,
    ACTIONS(5820), 1,
      anon_sym_LPAREN,
    ACTIONS(5822), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(5824), 1,
      anon_sym_u2983,
    ACTIONS(5826), 1,
      anon_sym_LBRACE,
    ACTIONS(5828), 1,
      aux_sym__qid_token1,
    ACTIONS(5830), 1,
      anon_sym_DOT,
    ACTIONS(5832), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(5834), 1,
      anon_sym_u2987,
    ACTIONS(5838), 1,
      anon_sym_Set,
    STATE(4039), 1,
      aux_sym__atoms,
    STATE(4780), 1,
      sym_atom,
    STATE(8140), 1,
      sym__LAMBDA,
    STATE(8504), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3484), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(5836), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4860), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4868), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9001), 7,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(5816), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [408783] = 29,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(738), 1,
      anon_sym_BSLASH,
    ACTIONS(740), 1,
      anon_sym_u03bb,
    ACTIONS(762), 1,
      anon_sym_quoteGoal,
    ACTIONS(764), 1,
      anon_sym_tactic,
    ACTIONS(3054), 1,
      anon_sym_let,
    ACTIONS(4238), 1,
      anon_sym_PIPE,
    ACTIONS(4248), 1,
      sym_id,
    ACTIONS(4252), 1,
      anon_sym_record,
    ACTIONS(4254), 1,
      anon_sym_LPAREN,
    ACTIONS(4256), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4258), 1,
      anon_sym_u2983,
    ACTIONS(4260), 1,
      anon_sym_LBRACE,
    ACTIONS(4262), 1,
      aux_sym__qid_token1,
    ACTIONS(4264), 1,
      anon_sym_DOT,
    ACTIONS(4266), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4268), 1,
      anon_sym_u2987,
    ACTIONS(4272), 1,
      anon_sym_Set,
    STATE(4039), 1,
      aux_sym__atoms,
    STATE(5812), 1,
      sym_atom,
    STATE(8156), 1,
      sym__LAMBDA,
    STATE(8456), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(736), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4270), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5952), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5976), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9001), 7,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(4250), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [408895] = 29,
    ACTIONS(714), 1,
      anon_sym_quoteGoal,
    ACTIONS(722), 1,
      anon_sym_let,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(3556), 1,
      anon_sym_BSLASH,
    ACTIONS(3558), 1,
      anon_sym_u03bb,
    ACTIONS(3574), 1,
      anon_sym_tactic,
    ACTIONS(4238), 1,
      anon_sym_PIPE,
    ACTIONS(5246), 1,
      sym_id,
    ACTIONS(5250), 1,
      anon_sym_record,
    ACTIONS(5252), 1,
      anon_sym_LPAREN,
    ACTIONS(5254), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(5256), 1,
      anon_sym_u2983,
    ACTIONS(5258), 1,
      anon_sym_LBRACE,
    ACTIONS(5260), 1,
      aux_sym__qid_token1,
    ACTIONS(5262), 1,
      anon_sym_DOT,
    ACTIONS(5264), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(5266), 1,
      anon_sym_u2987,
    ACTIONS(5270), 1,
      anon_sym_Set,
    STATE(4039), 1,
      aux_sym__atoms,
    STATE(5510), 1,
      sym_atom,
    STATE(8092), 1,
      sym__LAMBDA,
    STATE(8495), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(682), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(5268), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5466), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5472), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9454), 7,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(5248), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [409007] = 28,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(1302), 1,
      anon_sym_let,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4222), 1,
      sym_id,
    ACTIONS(4224), 1,
      aux_sym__qid_token1,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(12460), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [409117] = 29,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1170), 1,
      anon_sym_BSLASH,
    ACTIONS(1172), 1,
      anon_sym_u03bb,
    ACTIONS(1192), 1,
      anon_sym_quoteGoal,
    ACTIONS(1194), 1,
      anon_sym_tactic,
    ACTIONS(1200), 1,
      anon_sym_let,
    ACTIONS(4238), 1,
      anon_sym_PIPE,
    ACTIONS(5760), 1,
      sym_id,
    ACTIONS(5764), 1,
      anon_sym_record,
    ACTIONS(5766), 1,
      anon_sym_LPAREN,
    ACTIONS(5768), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(5770), 1,
      anon_sym_u2983,
    ACTIONS(5772), 1,
      anon_sym_LBRACE,
    ACTIONS(5774), 1,
      aux_sym__qid_token1,
    ACTIONS(5776), 1,
      anon_sym_DOT,
    ACTIONS(5778), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(5780), 1,
      anon_sym_u2987,
    ACTIONS(5784), 1,
      anon_sym_Set,
    STATE(4039), 1,
      aux_sym__atoms,
    STATE(5927), 1,
      sym_atom,
    STATE(8091), 1,
      sym__LAMBDA,
    STATE(8315), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1168), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(5782), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5941), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5965), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8997), 7,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(5762), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [409229] = 29,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(3134), 1,
      anon_sym_BSLASH,
    ACTIONS(3136), 1,
      anon_sym_u03bb,
    ACTIONS(3154), 1,
      anon_sym_quoteGoal,
    ACTIONS(3156), 1,
      anon_sym_tactic,
    ACTIONS(3162), 1,
      anon_sym_let,
    ACTIONS(4238), 1,
      anon_sym_PIPE,
    ACTIONS(6166), 1,
      sym_id,
    ACTIONS(6170), 1,
      anon_sym_record,
    ACTIONS(6172), 1,
      anon_sym_LPAREN,
    ACTIONS(6174), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(6176), 1,
      anon_sym_u2983,
    ACTIONS(6178), 1,
      anon_sym_LBRACE,
    ACTIONS(6180), 1,
      aux_sym__qid_token1,
    ACTIONS(6182), 1,
      anon_sym_DOT,
    ACTIONS(6184), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(6186), 1,
      anon_sym_u2987,
    ACTIONS(6190), 1,
      anon_sym_Set,
    STATE(4039), 1,
      aux_sym__atoms,
    STATE(5226), 1,
      sym_atom,
    STATE(8076), 1,
      sym__LAMBDA,
    STATE(8363), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3132), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(6188), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4960), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4966), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9001), 7,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(6168), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [409341] = 29,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(2904), 1,
      anon_sym_BSLASH,
    ACTIONS(2906), 1,
      anon_sym_u03bb,
    ACTIONS(2924), 1,
      anon_sym_quoteGoal,
    ACTIONS(2926), 1,
      anon_sym_tactic,
    ACTIONS(2932), 1,
      anon_sym_let,
    ACTIONS(4238), 1,
      anon_sym_PIPE,
    ACTIONS(6058), 1,
      sym_id,
    ACTIONS(6062), 1,
      anon_sym_record,
    ACTIONS(6064), 1,
      anon_sym_LPAREN,
    ACTIONS(6066), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(6068), 1,
      anon_sym_u2983,
    ACTIONS(6070), 1,
      anon_sym_LBRACE,
    ACTIONS(6072), 1,
      aux_sym__qid_token1,
    ACTIONS(6074), 1,
      anon_sym_DOT,
    ACTIONS(6076), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(6078), 1,
      anon_sym_u2987,
    ACTIONS(6082), 1,
      anon_sym_Set,
    STATE(4039), 1,
      aux_sym__atoms,
    STATE(4278), 1,
      sym_atom,
    STATE(8094), 1,
      sym__LAMBDA,
    STATE(8489), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2900), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(6080), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4341), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4349), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9001), 7,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(6060), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [409453] = 28,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(1302), 1,
      anon_sym_let,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4222), 1,
      sym_id,
    ACTIONS(4224), 1,
      aux_sym__qid_token1,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(12469), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [409563] = 29,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(2676), 1,
      anon_sym_quoteGoal,
    ACTIONS(2684), 1,
      anon_sym_let,
    ACTIONS(3906), 1,
      anon_sym_BSLASH,
    ACTIONS(3908), 1,
      anon_sym_u03bb,
    ACTIONS(3910), 1,
      anon_sym_tactic,
    ACTIONS(4238), 1,
      anon_sym_PIPE,
    ACTIONS(5604), 1,
      sym_id,
    ACTIONS(5608), 1,
      anon_sym_record,
    ACTIONS(5610), 1,
      anon_sym_LPAREN,
    ACTIONS(5612), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(5614), 1,
      anon_sym_u2983,
    ACTIONS(5616), 1,
      anon_sym_LBRACE,
    ACTIONS(5618), 1,
      aux_sym__qid_token1,
    ACTIONS(5620), 1,
      anon_sym_DOT,
    ACTIONS(5622), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(5624), 1,
      anon_sym_u2987,
    ACTIONS(5628), 1,
      anon_sym_Set,
    STATE(4039), 1,
      aux_sym__atoms,
    STATE(6230), 1,
      sym_atom,
    STATE(8086), 1,
      sym__LAMBDA,
    STATE(8470), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2654), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(5626), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6226), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6214), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9454), 7,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(5606), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [409675] = 29,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(920), 1,
      anon_sym_quoteGoal,
    ACTIONS(928), 1,
      anon_sym_let,
    ACTIONS(3058), 1,
      anon_sym_BSLASH,
    ACTIONS(3060), 1,
      anon_sym_u03bb,
    ACTIONS(3080), 1,
      anon_sym_tactic,
    ACTIONS(4238), 1,
      anon_sym_PIPE,
    ACTIONS(4976), 1,
      sym_id,
    ACTIONS(4980), 1,
      anon_sym_record,
    ACTIONS(4982), 1,
      anon_sym_LPAREN,
    ACTIONS(4984), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4986), 1,
      anon_sym_u2983,
    ACTIONS(4988), 1,
      anon_sym_LBRACE,
    ACTIONS(4990), 1,
      aux_sym__qid_token1,
    ACTIONS(4992), 1,
      anon_sym_DOT,
    ACTIONS(4994), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4996), 1,
      anon_sym_u2987,
    ACTIONS(5000), 1,
      anon_sym_Set,
    STATE(4039), 1,
      aux_sym__atoms,
    STATE(6120), 1,
      sym_atom,
    STATE(8123), 1,
      sym__LAMBDA,
    STATE(8396), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6124), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6161), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9454), 7,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(4978), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [409787] = 28,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(1302), 1,
      anon_sym_let,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4222), 1,
      sym_id,
    ACTIONS(4224), 1,
      aux_sym__qid_token1,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(12478), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [409897] = 28,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(1302), 1,
      anon_sym_let,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4222), 1,
      sym_id,
    ACTIONS(4224), 1,
      aux_sym__qid_token1,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(12487), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [410007] = 28,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(1302), 1,
      anon_sym_let,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4222), 1,
      sym_id,
    ACTIONS(4224), 1,
      aux_sym__qid_token1,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(12496), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [410117] = 29,
    ACTIONS(854), 1,
      anon_sym_BSLASH,
    ACTIONS(856), 1,
      anon_sym_u03bb,
    ACTIONS(878), 1,
      anon_sym_quoteGoal,
    ACTIONS(880), 1,
      anon_sym_tactic,
    ACTIONS(886), 1,
      anon_sym_let,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(4238), 1,
      anon_sym_PIPE,
    ACTIONS(5192), 1,
      sym_id,
    ACTIONS(5196), 1,
      anon_sym_record,
    ACTIONS(5198), 1,
      anon_sym_LPAREN,
    ACTIONS(5200), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(5202), 1,
      anon_sym_u2983,
    ACTIONS(5204), 1,
      anon_sym_LBRACE,
    ACTIONS(5206), 1,
      aux_sym__qid_token1,
    ACTIONS(5208), 1,
      anon_sym_DOT,
    ACTIONS(5210), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(5212), 1,
      anon_sym_u2987,
    ACTIONS(5216), 1,
      anon_sym_Set,
    STATE(4039), 1,
      aux_sym__atoms,
    STATE(5956), 1,
      sym_atom,
    STATE(8152), 1,
      sym__LAMBDA,
    STATE(8369), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(852), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(5214), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5737), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5736), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8997), 7,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(5194), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [410229] = 29,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1286), 1,
      anon_sym_BSLASH,
    ACTIONS(1288), 1,
      anon_sym_u03bb,
    ACTIONS(1290), 1,
      anon_sym_quoteGoal,
    ACTIONS(1292), 1,
      anon_sym_tactic,
    ACTIONS(1294), 1,
      anon_sym_let,
    ACTIONS(4238), 1,
      anon_sym_PIPE,
    ACTIONS(5760), 1,
      sym_id,
    ACTIONS(5764), 1,
      anon_sym_record,
    ACTIONS(5766), 1,
      anon_sym_LPAREN,
    ACTIONS(5768), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(5770), 1,
      anon_sym_u2983,
    ACTIONS(5772), 1,
      anon_sym_LBRACE,
    ACTIONS(5774), 1,
      aux_sym__qid_token1,
    ACTIONS(5776), 1,
      anon_sym_DOT,
    ACTIONS(5778), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(5780), 1,
      anon_sym_u2987,
    ACTIONS(5784), 1,
      anon_sym_Set,
    STATE(4039), 1,
      aux_sym__atoms,
    STATE(5927), 1,
      sym_atom,
    STATE(8077), 1,
      sym__LAMBDA,
    STATE(8268), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1284), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(5782), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5941), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5965), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8997), 7,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(5762), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [410341] = 29,
    ACTIONS(686), 1,
      anon_sym_BSLASH,
    ACTIONS(688), 1,
      anon_sym_u03bb,
    ACTIONS(714), 1,
      anon_sym_quoteGoal,
    ACTIONS(716), 1,
      anon_sym_tactic,
    ACTIONS(722), 1,
      anon_sym_let,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(4238), 1,
      anon_sym_PIPE,
    ACTIONS(5708), 1,
      sym_id,
    ACTIONS(5712), 1,
      anon_sym_record,
    ACTIONS(5714), 1,
      anon_sym_LPAREN,
    ACTIONS(5716), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(5718), 1,
      anon_sym_u2983,
    ACTIONS(5720), 1,
      anon_sym_LBRACE,
    ACTIONS(5722), 1,
      aux_sym__qid_token1,
    ACTIONS(5724), 1,
      anon_sym_DOT,
    ACTIONS(5726), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(5728), 1,
      anon_sym_u2987,
    ACTIONS(5732), 1,
      anon_sym_Set,
    STATE(4039), 1,
      aux_sym__atoms,
    STATE(5512), 1,
      sym_atom,
    STATE(8064), 1,
      sym__LAMBDA,
    STATE(8495), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(682), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(5730), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5553), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5550), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9454), 7,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(5710), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [410453] = 29,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2492), 1,
      anon_sym_BSLASH,
    ACTIONS(2494), 1,
      anon_sym_u03bb,
    ACTIONS(2512), 1,
      anon_sym_quoteGoal,
    ACTIONS(2514), 1,
      anon_sym_tactic,
    ACTIONS(2520), 1,
      anon_sym_let,
    ACTIONS(4238), 1,
      anon_sym_PIPE,
    ACTIONS(5548), 1,
      sym_id,
    ACTIONS(5552), 1,
      anon_sym_record,
    ACTIONS(5554), 1,
      anon_sym_LPAREN,
    ACTIONS(5556), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(5558), 1,
      anon_sym_u2983,
    ACTIONS(5560), 1,
      anon_sym_LBRACE,
    ACTIONS(5562), 1,
      aux_sym__qid_token1,
    ACTIONS(5564), 1,
      anon_sym_DOT,
    ACTIONS(5566), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(5568), 1,
      anon_sym_u2987,
    ACTIONS(5572), 1,
      anon_sym_Set,
    STATE(4039), 1,
      aux_sym__atoms,
    STATE(6137), 1,
      sym_atom,
    STATE(8096), 1,
      sym__LAMBDA,
    STATE(8497), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2490), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(5570), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6032), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6059), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8997), 7,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(5550), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [410565] = 28,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(1302), 1,
      anon_sym_let,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4222), 1,
      sym_id,
    ACTIONS(4224), 1,
      aux_sym__qid_token1,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(12505), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [410675] = 29,
    ACTIONS(878), 1,
      anon_sym_quoteGoal,
    ACTIONS(886), 1,
      anon_sym_let,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(4184), 1,
      anon_sym_BSLASH,
    ACTIONS(4186), 1,
      anon_sym_u03bb,
    ACTIONS(4204), 1,
      anon_sym_tactic,
    ACTIONS(4238), 1,
      anon_sym_PIPE,
    ACTIONS(5494), 1,
      sym_id,
    ACTIONS(5498), 1,
      anon_sym_record,
    ACTIONS(5500), 1,
      anon_sym_LPAREN,
    ACTIONS(5502), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(5504), 1,
      anon_sym_u2983,
    ACTIONS(5506), 1,
      anon_sym_LBRACE,
    ACTIONS(5508), 1,
      aux_sym__qid_token1,
    ACTIONS(5510), 1,
      anon_sym_DOT,
    ACTIONS(5512), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(5514), 1,
      anon_sym_u2987,
    ACTIONS(5518), 1,
      anon_sym_Set,
    STATE(4039), 1,
      aux_sym__atoms,
    STATE(6095), 1,
      sym_atom,
    STATE(8067), 1,
      sym__LAMBDA,
    STATE(8369), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(852), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(5516), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6047), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6050), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8997), 7,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(5496), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [410787] = 29,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2302), 1,
      anon_sym_BSLASH,
    ACTIONS(2304), 1,
      anon_sym_u03bb,
    ACTIONS(2322), 1,
      anon_sym_quoteGoal,
    ACTIONS(2324), 1,
      anon_sym_tactic,
    ACTIONS(2330), 1,
      anon_sym_let,
    ACTIONS(4238), 1,
      anon_sym_PIPE,
    ACTIONS(5278), 1,
      sym_id,
    ACTIONS(5282), 1,
      anon_sym_record,
    ACTIONS(5284), 1,
      anon_sym_LPAREN,
    ACTIONS(5286), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(5288), 1,
      anon_sym_u2983,
    ACTIONS(5290), 1,
      anon_sym_LBRACE,
    ACTIONS(5292), 1,
      aux_sym__qid_token1,
    ACTIONS(5294), 1,
      anon_sym_DOT,
    ACTIONS(5296), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(5298), 1,
      anon_sym_u2987,
    ACTIONS(5302), 1,
      anon_sym_Set,
    STATE(4039), 1,
      aux_sym__atoms,
    STATE(5949), 1,
      sym_atom,
    STATE(8138), 1,
      sym__LAMBDA,
    STATE(8476), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2300), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(5300), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5779), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5778), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8997), 7,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(5280), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [410899] = 19,
    ACTIONS(3300), 1,
      sym_id,
    ACTIONS(3304), 1,
      anon_sym_record,
    ACTIONS(3314), 1,
      aux_sym__qid_token1,
    ACTIONS(3318), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3320), 1,
      anon_sym_u2987,
    ACTIONS(3324), 1,
      anon_sym_Set,
    ACTIONS(4854), 1,
      anon_sym_LPAREN,
    ACTIONS(4856), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4858), 1,
      anon_sym_u2983,
    ACTIONS(4860), 1,
      anon_sym_LBRACE,
    ACTIONS(4862), 1,
      anon_sym_DOT,
    STATE(4062), 1,
      sym_atom,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3322), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(6226), 2,
      sym__newline,
      anon_sym_BSLASH,
    STATE(4053), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4049), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3302), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    ACTIONS(6224), 17,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_let,
      anon_sym_do,
  [410991] = 28,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(1302), 1,
      anon_sym_let,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4222), 1,
      sym_id,
    ACTIONS(4224), 1,
      aux_sym__qid_token1,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(12744), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [411101] = 28,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(1302), 1,
      anon_sym_let,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4222), 1,
      sym_id,
    ACTIONS(4224), 1,
      aux_sym__qid_token1,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(12514), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [411211] = 28,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(1302), 1,
      anon_sym_let,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4222), 1,
      sym_id,
    ACTIONS(4224), 1,
      aux_sym__qid_token1,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(12741), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [411321] = 28,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(1302), 1,
      anon_sym_let,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4222), 1,
      sym_id,
    ACTIONS(4224), 1,
      aux_sym__qid_token1,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(12738), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [411431] = 28,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(1302), 1,
      anon_sym_let,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4222), 1,
      sym_id,
    ACTIONS(4224), 1,
      aux_sym__qid_token1,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(12735), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [411541] = 29,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2428), 1,
      anon_sym_BSLASH,
    ACTIONS(2430), 1,
      anon_sym_u03bb,
    ACTIONS(2448), 1,
      anon_sym_quoteGoal,
    ACTIONS(2450), 1,
      anon_sym_tactic,
    ACTIONS(2456), 1,
      anon_sym_let,
    ACTIONS(4238), 1,
      anon_sym_PIPE,
    ACTIONS(5306), 1,
      sym_id,
    ACTIONS(5310), 1,
      anon_sym_record,
    ACTIONS(5312), 1,
      anon_sym_LPAREN,
    ACTIONS(5314), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(5316), 1,
      anon_sym_u2983,
    ACTIONS(5318), 1,
      anon_sym_LBRACE,
    ACTIONS(5320), 1,
      aux_sym__qid_token1,
    ACTIONS(5322), 1,
      anon_sym_DOT,
    ACTIONS(5324), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(5326), 1,
      anon_sym_u2987,
    ACTIONS(5330), 1,
      anon_sym_Set,
    STATE(4039), 1,
      aux_sym__atoms,
    STATE(5759), 1,
      sym_atom,
    STATE(8125), 1,
      sym__LAMBDA,
    STATE(8423), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2424), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(5328), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5854), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5853), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8997), 7,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(5308), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [411653] = 28,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(1302), 1,
      anon_sym_let,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4222), 1,
      sym_id,
    ACTIONS(4224), 1,
      aux_sym__qid_token1,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(12732), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [411763] = 29,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2100), 1,
      anon_sym_BSLASH,
    ACTIONS(2102), 1,
      anon_sym_u03bb,
    ACTIONS(2120), 1,
      anon_sym_quoteGoal,
    ACTIONS(2122), 1,
      anon_sym_tactic,
    ACTIONS(2128), 1,
      anon_sym_let,
    ACTIONS(4238), 1,
      anon_sym_PIPE,
    ACTIONS(5002), 1,
      sym_id,
    ACTIONS(5006), 1,
      anon_sym_record,
    ACTIONS(5008), 1,
      anon_sym_LPAREN,
    ACTIONS(5010), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(5012), 1,
      anon_sym_u2983,
    ACTIONS(5014), 1,
      anon_sym_LBRACE,
    ACTIONS(5016), 1,
      aux_sym__qid_token1,
    ACTIONS(5018), 1,
      anon_sym_DOT,
    ACTIONS(5020), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(5022), 1,
      anon_sym_u2987,
    ACTIONS(5026), 1,
      anon_sym_Set,
    STATE(4039), 1,
      aux_sym__atoms,
    STATE(5751), 1,
      sym_atom,
    STATE(8075), 1,
      sym__LAMBDA,
    STATE(8428), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2096), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(5024), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5805), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5804), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8997), 7,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(5004), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [411875] = 29,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(898), 1,
      anon_sym_BSLASH,
    ACTIONS(900), 1,
      anon_sym_u03bb,
    ACTIONS(920), 1,
      anon_sym_quoteGoal,
    ACTIONS(922), 1,
      anon_sym_tactic,
    ACTIONS(928), 1,
      anon_sym_let,
    ACTIONS(4238), 1,
      anon_sym_PIPE,
    ACTIONS(5682), 1,
      sym_id,
    ACTIONS(5686), 1,
      anon_sym_record,
    ACTIONS(5688), 1,
      anon_sym_LPAREN,
    ACTIONS(5690), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(5692), 1,
      anon_sym_u2983,
    ACTIONS(5694), 1,
      anon_sym_LBRACE,
    ACTIONS(5696), 1,
      aux_sym__qid_token1,
    ACTIONS(5698), 1,
      anon_sym_DOT,
    ACTIONS(5700), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(5702), 1,
      anon_sym_u2987,
    ACTIONS(5706), 1,
      anon_sym_Set,
    STATE(4039), 1,
      aux_sym__atoms,
    STATE(5867), 1,
      sym_atom,
    STATE(8031), 1,
      sym__LAMBDA,
    STATE(8396), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(5704), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5924), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5925), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9454), 7,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(5684), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [411987] = 29,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(2694), 1,
      anon_sym_BSLASH,
    ACTIONS(2696), 1,
      anon_sym_u03bb,
    ACTIONS(2714), 1,
      anon_sym_quoteGoal,
    ACTIONS(2716), 1,
      anon_sym_tactic,
    ACTIONS(2722), 1,
      anon_sym_let,
    ACTIONS(4238), 1,
      anon_sym_PIPE,
    ACTIONS(5574), 1,
      sym_id,
    ACTIONS(5578), 1,
      anon_sym_record,
    ACTIONS(5580), 1,
      anon_sym_LPAREN,
    ACTIONS(5582), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(5584), 1,
      anon_sym_u2983,
    ACTIONS(5586), 1,
      anon_sym_LBRACE,
    ACTIONS(5588), 1,
      aux_sym__qid_token1,
    ACTIONS(5590), 1,
      anon_sym_DOT,
    ACTIONS(5592), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(5594), 1,
      anon_sym_u2987,
    ACTIONS(5598), 1,
      anon_sym_Set,
    STATE(4039), 1,
      aux_sym__atoms,
    STATE(4408), 1,
      sym_atom,
    STATE(8133), 1,
      sym__LAMBDA,
    STATE(8368), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2692), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(5596), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4312), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4307), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9001), 7,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(5576), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [412099] = 28,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(1302), 1,
      anon_sym_let,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4222), 1,
      sym_id,
    ACTIONS(4224), 1,
      aux_sym__qid_token1,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(12729), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [412209] = 28,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(1302), 1,
      anon_sym_let,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4222), 1,
      sym_id,
    ACTIONS(4224), 1,
      aux_sym__qid_token1,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(12726), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [412319] = 29,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1928), 1,
      anon_sym_quoteGoal,
    ACTIONS(1936), 1,
      anon_sym_let,
    ACTIONS(2338), 1,
      anon_sym_BSLASH,
    ACTIONS(2340), 1,
      anon_sym_u03bb,
    ACTIONS(2344), 1,
      anon_sym_tactic,
    ACTIONS(4238), 1,
      anon_sym_PIPE,
    ACTIONS(5708), 1,
      sym_id,
    ACTIONS(5712), 1,
      anon_sym_record,
    ACTIONS(5714), 1,
      anon_sym_LPAREN,
    ACTIONS(5716), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(5718), 1,
      anon_sym_u2983,
    ACTIONS(5720), 1,
      anon_sym_LBRACE,
    ACTIONS(5722), 1,
      aux_sym__qid_token1,
    ACTIONS(5724), 1,
      anon_sym_DOT,
    ACTIONS(5726), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(5728), 1,
      anon_sym_u2987,
    ACTIONS(5732), 1,
      anon_sym_Set,
    STATE(4039), 1,
      aux_sym__atoms,
    STATE(5512), 1,
      sym_atom,
    STATE(8079), 1,
      sym__LAMBDA,
    STATE(8431), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1906), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(5730), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5553), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5550), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8997), 7,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(5710), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [412431] = 29,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(3448), 1,
      anon_sym_BSLASH,
    ACTIONS(3450), 1,
      anon_sym_u03bb,
    ACTIONS(3468), 1,
      anon_sym_quoteGoal,
    ACTIONS(3470), 1,
      anon_sym_tactic,
    ACTIONS(3476), 1,
      anon_sym_let,
    ACTIONS(4238), 1,
      anon_sym_PIPE,
    ACTIONS(6032), 1,
      sym_id,
    ACTIONS(6036), 1,
      anon_sym_record,
    ACTIONS(6038), 1,
      anon_sym_LPAREN,
    ACTIONS(6040), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(6042), 1,
      anon_sym_u2983,
    ACTIONS(6044), 1,
      anon_sym_LBRACE,
    ACTIONS(6046), 1,
      aux_sym__qid_token1,
    ACTIONS(6048), 1,
      anon_sym_DOT,
    ACTIONS(6050), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(6052), 1,
      anon_sym_u2987,
    ACTIONS(6056), 1,
      anon_sym_Set,
    STATE(4039), 1,
      aux_sym__atoms,
    STATE(5944), 1,
      sym_atom,
    STATE(8072), 1,
      sym__LAMBDA,
    STATE(8455), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3446), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(6054), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5909), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5914), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9001), 7,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(6034), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [412543] = 29,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2022), 1,
      anon_sym_BSLASH,
    ACTIONS(2024), 1,
      anon_sym_u03bb,
    ACTIONS(2042), 1,
      anon_sym_quoteGoal,
    ACTIONS(2044), 1,
      anon_sym_tactic,
    ACTIONS(2050), 1,
      anon_sym_let,
    ACTIONS(4238), 1,
      anon_sym_PIPE,
    ACTIONS(5140), 1,
      sym_id,
    ACTIONS(5144), 1,
      anon_sym_record,
    ACTIONS(5146), 1,
      anon_sym_LPAREN,
    ACTIONS(5148), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(5150), 1,
      anon_sym_u2983,
    ACTIONS(5152), 1,
      anon_sym_LBRACE,
    ACTIONS(5154), 1,
      aux_sym__qid_token1,
    ACTIONS(5156), 1,
      anon_sym_DOT,
    ACTIONS(5158), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(5160), 1,
      anon_sym_u2987,
    ACTIONS(5164), 1,
      anon_sym_Set,
    STATE(4039), 1,
      aux_sym__atoms,
    STATE(5948), 1,
      sym_atom,
    STATE(8033), 1,
      sym__LAMBDA,
    STATE(8463), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2020), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(5162), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5797), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5795), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8997), 7,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(5142), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [412655] = 29,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(2212), 1,
      anon_sym_BSLASH,
    ACTIONS(2214), 1,
      anon_sym_u03bb,
    ACTIONS(2232), 1,
      anon_sym_quoteGoal,
    ACTIONS(2234), 1,
      anon_sym_tactic,
    ACTIONS(2240), 1,
      anon_sym_let,
    ACTIONS(4238), 1,
      anon_sym_PIPE,
    ACTIONS(6138), 1,
      sym_id,
    ACTIONS(6142), 1,
      anon_sym_record,
    ACTIONS(6144), 1,
      anon_sym_LPAREN,
    ACTIONS(6146), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(6148), 1,
      anon_sym_u2983,
    ACTIONS(6150), 1,
      anon_sym_LBRACE,
    ACTIONS(6152), 1,
      aux_sym__qid_token1,
    ACTIONS(6154), 1,
      anon_sym_DOT,
    ACTIONS(6156), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(6158), 1,
      anon_sym_u2987,
    ACTIONS(6162), 1,
      anon_sym_Set,
    STATE(4039), 1,
      aux_sym__atoms,
    STATE(5008), 1,
      sym_atom,
    STATE(8035), 1,
      sym__LAMBDA,
    STATE(8402), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(6160), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5132), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5134), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9001), 7,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(6140), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [412767] = 29,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(2982), 1,
      anon_sym_BSLASH,
    ACTIONS(2984), 1,
      anon_sym_u03bb,
    ACTIONS(3002), 1,
      anon_sym_quoteGoal,
    ACTIONS(3004), 1,
      anon_sym_tactic,
    ACTIONS(3010), 1,
      anon_sym_let,
    ACTIONS(4238), 1,
      anon_sym_PIPE,
    ACTIONS(5788), 1,
      sym_id,
    ACTIONS(5792), 1,
      anon_sym_record,
    ACTIONS(5794), 1,
      anon_sym_LPAREN,
    ACTIONS(5796), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(5798), 1,
      anon_sym_u2983,
    ACTIONS(5800), 1,
      anon_sym_LBRACE,
    ACTIONS(5802), 1,
      aux_sym__qid_token1,
    ACTIONS(5804), 1,
      anon_sym_DOT,
    ACTIONS(5806), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(5808), 1,
      anon_sym_u2987,
    ACTIONS(5812), 1,
      anon_sym_Set,
    STATE(4039), 1,
      aux_sym__atoms,
    STATE(4924), 1,
      sym_atom,
    STATE(8117), 1,
      sym__LAMBDA,
    STATE(8511), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(5810), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5245), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5235), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9001), 7,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(5790), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [412879] = 28,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(1302), 1,
      anon_sym_let,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4222), 1,
      sym_id,
    ACTIONS(4224), 1,
      aux_sym__qid_token1,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(12523), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [412989] = 28,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(1302), 1,
      anon_sym_let,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4222), 1,
      sym_id,
    ACTIONS(4224), 1,
      aux_sym__qid_token1,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(12532), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [413099] = 29,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(2350), 1,
      anon_sym_BSLASH,
    ACTIONS(2352), 1,
      anon_sym_u03bb,
    ACTIONS(2370), 1,
      anon_sym_quoteGoal,
    ACTIONS(2372), 1,
      anon_sym_tactic,
    ACTIONS(2378), 1,
      anon_sym_let,
    ACTIONS(4238), 1,
      anon_sym_PIPE,
    ACTIONS(5054), 1,
      sym_id,
    ACTIONS(5058), 1,
      anon_sym_record,
    ACTIONS(5060), 1,
      anon_sym_LPAREN,
    ACTIONS(5062), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(5064), 1,
      anon_sym_u2983,
    ACTIONS(5066), 1,
      anon_sym_LBRACE,
    ACTIONS(5068), 1,
      aux_sym__qid_token1,
    ACTIONS(5070), 1,
      anon_sym_DOT,
    ACTIONS(5072), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(5074), 1,
      anon_sym_u2987,
    ACTIONS(5078), 1,
      anon_sym_Set,
    STATE(4039), 1,
      aux_sym__atoms,
    STATE(4532), 1,
      sym_atom,
    STATE(8119), 1,
      sym__LAMBDA,
    STATE(8372), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2348), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(5076), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4453), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4455), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9001), 7,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(5056), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [413211] = 28,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(1302), 1,
      anon_sym_let,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4222), 1,
      sym_id,
    ACTIONS(4224), 1,
      aux_sym__qid_token1,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(12541), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [413321] = 28,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(1302), 1,
      anon_sym_let,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4222), 1,
      sym_id,
    ACTIONS(4224), 1,
      aux_sym__qid_token1,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(12550), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [413431] = 29,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(2532), 1,
      anon_sym_BSLASH,
    ACTIONS(2534), 1,
      anon_sym_u03bb,
    ACTIONS(2552), 1,
      anon_sym_quoteGoal,
    ACTIONS(2554), 1,
      anon_sym_tactic,
    ACTIONS(2560), 1,
      anon_sym_let,
    ACTIONS(4238), 1,
      anon_sym_PIPE,
    ACTIONS(5872), 1,
      sym_id,
    ACTIONS(5876), 1,
      anon_sym_record,
    ACTIONS(5878), 1,
      anon_sym_LPAREN,
    ACTIONS(5880), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(5882), 1,
      anon_sym_u2983,
    ACTIONS(5884), 1,
      anon_sym_LBRACE,
    ACTIONS(5886), 1,
      aux_sym__qid_token1,
    ACTIONS(5888), 1,
      anon_sym_DOT,
    ACTIONS(5890), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(5892), 1,
      anon_sym_u2987,
    ACTIONS(5896), 1,
      anon_sym_Set,
    STATE(4039), 1,
      aux_sym__atoms,
    STATE(4839), 1,
      sym_atom,
    STATE(8066), 1,
      sym__LAMBDA,
    STATE(8398), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2528), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(5894), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4787), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4785), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9001), 7,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(5874), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [413543] = 29,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(1210), 1,
      anon_sym_BSLASH,
    ACTIONS(1212), 1,
      anon_sym_u03bb,
    ACTIONS(1230), 1,
      anon_sym_quoteGoal,
    ACTIONS(1232), 1,
      anon_sym_tactic,
    ACTIONS(1238), 1,
      anon_sym_let,
    ACTIONS(4238), 1,
      anon_sym_PIPE,
    ACTIONS(5898), 1,
      sym_id,
    ACTIONS(5902), 1,
      anon_sym_record,
    ACTIONS(5904), 1,
      anon_sym_LPAREN,
    ACTIONS(5906), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(5908), 1,
      anon_sym_u2983,
    ACTIONS(5910), 1,
      anon_sym_LBRACE,
    ACTIONS(5912), 1,
      aux_sym__qid_token1,
    ACTIONS(5914), 1,
      anon_sym_DOT,
    ACTIONS(5916), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(5918), 1,
      anon_sym_u2987,
    ACTIONS(5922), 1,
      anon_sym_Set,
    STATE(4039), 1,
      aux_sym__atoms,
    STATE(6198), 1,
      sym_atom,
    STATE(8104), 1,
      sym__LAMBDA,
    STATE(8302), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1208), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(5920), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6087), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6089), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9454), 7,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(5900), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [413655] = 28,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(1302), 1,
      anon_sym_let,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4222), 1,
      sym_id,
    ACTIONS(4224), 1,
      aux_sym__qid_token1,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(12559), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [413765] = 29,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(1302), 1,
      anon_sym_let,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(4238), 1,
      anon_sym_PIPE,
    ACTIONS(5166), 1,
      sym_id,
    ACTIONS(5170), 1,
      anon_sym_record,
    ACTIONS(5172), 1,
      anon_sym_LPAREN,
    ACTIONS(5174), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(5176), 1,
      anon_sym_u2983,
    ACTIONS(5178), 1,
      anon_sym_LBRACE,
    ACTIONS(5180), 1,
      aux_sym__qid_token1,
    ACTIONS(5182), 1,
      anon_sym_DOT,
    ACTIONS(5184), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(5186), 1,
      anon_sym_u2987,
    ACTIONS(5190), 1,
      anon_sym_Set,
    STATE(4039), 1,
      aux_sym__atoms,
    STATE(5916), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(5188), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5928), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5926), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8997), 7,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(5168), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [413877] = 29,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(3096), 1,
      anon_sym_BSLASH,
    ACTIONS(3098), 1,
      anon_sym_u03bb,
    ACTIONS(3116), 1,
      anon_sym_quoteGoal,
    ACTIONS(3118), 1,
      anon_sym_tactic,
    ACTIONS(3124), 1,
      anon_sym_let,
    ACTIONS(4238), 1,
      anon_sym_PIPE,
    ACTIONS(6086), 1,
      sym_id,
    ACTIONS(6090), 1,
      anon_sym_record,
    ACTIONS(6092), 1,
      anon_sym_LPAREN,
    ACTIONS(6094), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(6096), 1,
      anon_sym_u2983,
    ACTIONS(6098), 1,
      anon_sym_LBRACE,
    ACTIONS(6100), 1,
      aux_sym__qid_token1,
    ACTIONS(6102), 1,
      anon_sym_DOT,
    ACTIONS(6104), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(6106), 1,
      anon_sym_u2987,
    ACTIONS(6110), 1,
      anon_sym_Set,
    STATE(4039), 1,
      aux_sym__atoms,
    STATE(4488), 1,
      sym_atom,
    STATE(8099), 1,
      sym__LAMBDA,
    STATE(8393), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3092), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(6108), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4522), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4523), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9001), 7,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(6088), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [413989] = 28,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(1302), 1,
      anon_sym_let,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4222), 1,
      sym_id,
    ACTIONS(4224), 1,
      aux_sym__qid_token1,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(12723), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [414099] = 28,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(1302), 1,
      anon_sym_let,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4222), 1,
      sym_id,
    ACTIONS(4224), 1,
      aux_sym__qid_token1,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(12568), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [414209] = 29,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(2570), 1,
      anon_sym_BSLASH,
    ACTIONS(2572), 1,
      anon_sym_u03bb,
    ACTIONS(2590), 1,
      anon_sym_quoteGoal,
    ACTIONS(2592), 1,
      anon_sym_tactic,
    ACTIONS(2598), 1,
      anon_sym_let,
    ACTIONS(4238), 1,
      anon_sym_PIPE,
    ACTIONS(5656), 1,
      sym_id,
    ACTIONS(5660), 1,
      anon_sym_record,
    ACTIONS(5662), 1,
      anon_sym_LPAREN,
    ACTIONS(5664), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(5666), 1,
      anon_sym_u2983,
    ACTIONS(5668), 1,
      anon_sym_LBRACE,
    ACTIONS(5670), 1,
      aux_sym__qid_token1,
    ACTIONS(5672), 1,
      anon_sym_DOT,
    ACTIONS(5674), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(5676), 1,
      anon_sym_u2987,
    ACTIONS(5680), 1,
      anon_sym_Set,
    STATE(4039), 1,
      aux_sym__atoms,
    STATE(6281), 1,
      sym_atom,
    STATE(8111), 1,
      sym__LAMBDA,
    STATE(8412), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2568), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(5678), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6130), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6053), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9001), 7,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(5658), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [414321] = 29,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1946), 1,
      anon_sym_BSLASH,
    ACTIONS(1948), 1,
      anon_sym_u03bb,
    ACTIONS(1966), 1,
      anon_sym_quoteGoal,
    ACTIONS(1968), 1,
      anon_sym_tactic,
    ACTIONS(1974), 1,
      anon_sym_let,
    ACTIONS(4238), 1,
      anon_sym_PIPE,
    ACTIONS(5390), 1,
      sym_id,
    ACTIONS(5394), 1,
      anon_sym_record,
    ACTIONS(5396), 1,
      anon_sym_LPAREN,
    ACTIONS(5398), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(5400), 1,
      anon_sym_u2983,
    ACTIONS(5402), 1,
      anon_sym_LBRACE,
    ACTIONS(5404), 1,
      aux_sym__qid_token1,
    ACTIONS(5406), 1,
      anon_sym_DOT,
    ACTIONS(5408), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(5410), 1,
      anon_sym_u2987,
    ACTIONS(5414), 1,
      anon_sym_Set,
    STATE(4039), 1,
      aux_sym__atoms,
    STATE(6075), 1,
      sym_atom,
    STATE(8062), 1,
      sym__LAMBDA,
    STATE(8321), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1944), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(5412), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6026), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6060), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8997), 7,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(5392), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [414433] = 28,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(1302), 1,
      anon_sym_let,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4222), 1,
      sym_id,
    ACTIONS(4224), 1,
      aux_sym__qid_token1,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(12577), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [414543] = 19,
    ACTIONS(2690), 1,
      sym_id,
    ACTIONS(2700), 1,
      anon_sym_record,
    ACTIONS(2710), 1,
      aux_sym__qid_token1,
    ACTIONS(2718), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2720), 1,
      anon_sym_u2987,
    ACTIONS(2726), 1,
      anon_sym_Set,
    ACTIONS(4444), 1,
      anon_sym_LPAREN,
    ACTIONS(4446), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4448), 1,
      anon_sym_u2983,
    ACTIONS(4450), 1,
      anon_sym_LBRACE,
    ACTIONS(4452), 1,
      anon_sym_DOT,
    STATE(4112), 1,
      sym_atom,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2724), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(6226), 2,
      sym__newline,
      anon_sym_BSLASH,
    STATE(4108), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4103), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(2698), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    ACTIONS(6224), 17,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_let,
      anon_sym_do,
  [414635] = 28,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(1302), 1,
      anon_sym_let,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4222), 1,
      sym_id,
    ACTIONS(4224), 1,
      aux_sym__qid_token1,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(12586), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [414745] = 28,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(1302), 1,
      anon_sym_let,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4222), 1,
      sym_id,
    ACTIONS(4224), 1,
      aux_sym__qid_token1,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(12720), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [414855] = 29,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2060), 1,
      anon_sym_BSLASH,
    ACTIONS(2062), 1,
      anon_sym_u03bb,
    ACTIONS(2080), 1,
      anon_sym_quoteGoal,
    ACTIONS(2082), 1,
      anon_sym_tactic,
    ACTIONS(2088), 1,
      anon_sym_let,
    ACTIONS(4238), 1,
      anon_sym_PIPE,
    ACTIONS(5846), 1,
      sym_id,
    ACTIONS(5850), 1,
      anon_sym_record,
    ACTIONS(5852), 1,
      anon_sym_LPAREN,
    ACTIONS(5854), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(5856), 1,
      anon_sym_u2983,
    ACTIONS(5858), 1,
      anon_sym_LBRACE,
    ACTIONS(5860), 1,
      aux_sym__qid_token1,
    ACTIONS(5862), 1,
      anon_sym_DOT,
    ACTIONS(5864), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(5866), 1,
      anon_sym_u2987,
    ACTIONS(5870), 1,
      anon_sym_Set,
    STATE(4039), 1,
      aux_sym__atoms,
    STATE(6072), 1,
      sym_atom,
    STATE(8089), 1,
      sym__LAMBDA,
    STATE(8334), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2058), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(5868), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6096), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6100), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8997), 7,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(5848), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [414967] = 28,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(1302), 1,
      anon_sym_let,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4222), 1,
      sym_id,
    ACTIONS(4224), 1,
      aux_sym__qid_token1,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(12592), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [415077] = 29,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2800), 1,
      anon_sym_quoteGoal,
    ACTIONS(2804), 1,
      anon_sym_let,
    ACTIONS(2810), 1,
      anon_sym_BSLASH,
    ACTIONS(2812), 1,
      anon_sym_u03bb,
    ACTIONS(2830), 1,
      anon_sym_tactic,
    ACTIONS(4238), 1,
      anon_sym_PIPE,
    ACTIONS(5604), 1,
      sym_id,
    ACTIONS(5608), 1,
      anon_sym_record,
    ACTIONS(5610), 1,
      anon_sym_LPAREN,
    ACTIONS(5612), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(5614), 1,
      anon_sym_u2983,
    ACTIONS(5616), 1,
      anon_sym_LBRACE,
    ACTIONS(5618), 1,
      aux_sym__qid_token1,
    ACTIONS(5620), 1,
      anon_sym_DOT,
    ACTIONS(5622), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(5624), 1,
      anon_sym_u2987,
    ACTIONS(5628), 1,
      anon_sym_Set,
    STATE(4039), 1,
      aux_sym__atoms,
    STATE(6230), 1,
      sym_atom,
    STATE(8081), 1,
      sym__LAMBDA,
    STATE(8490), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2794), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(5626), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6226), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6214), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8997), 7,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(5606), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [415189] = 29,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(3020), 1,
      anon_sym_BSLASH,
    ACTIONS(3022), 1,
      anon_sym_u03bb,
    ACTIONS(3040), 1,
      anon_sym_quoteGoal,
    ACTIONS(3042), 1,
      anon_sym_tactic,
    ACTIONS(3048), 1,
      anon_sym_let,
    ACTIONS(4238), 1,
      anon_sym_PIPE,
    ACTIONS(5978), 1,
      sym_id,
    ACTIONS(5982), 1,
      anon_sym_record,
    ACTIONS(5984), 1,
      anon_sym_LPAREN,
    ACTIONS(5986), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(5988), 1,
      anon_sym_u2983,
    ACTIONS(5990), 1,
      anon_sym_LBRACE,
    ACTIONS(5992), 1,
      aux_sym__qid_token1,
    ACTIONS(5994), 1,
      anon_sym_DOT,
    ACTIONS(5996), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(5998), 1,
      anon_sym_u2987,
    ACTIONS(6002), 1,
      anon_sym_Set,
    STATE(4039), 1,
      aux_sym__atoms,
    STATE(5749), 1,
      sym_atom,
    STATE(8127), 1,
      sym__LAMBDA,
    STATE(8388), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3018), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(6000), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5765), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5767), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8997), 7,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(5980), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [415301] = 28,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(1302), 1,
      anon_sym_let,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4222), 1,
      sym_id,
    ACTIONS(4224), 1,
      aux_sym__qid_token1,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(12598), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [415411] = 29,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(3818), 1,
      anon_sym_BSLASH,
    ACTIONS(3820), 1,
      anon_sym_u03bb,
    ACTIONS(3838), 1,
      anon_sym_quoteGoal,
    ACTIONS(3840), 1,
      anon_sym_tactic,
    ACTIONS(3846), 1,
      anon_sym_let,
    ACTIONS(4238), 1,
      anon_sym_PIPE,
    ACTIONS(6006), 1,
      sym_id,
    ACTIONS(6010), 1,
      anon_sym_record,
    ACTIONS(6012), 1,
      anon_sym_LPAREN,
    ACTIONS(6014), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(6016), 1,
      anon_sym_u2983,
    ACTIONS(6018), 1,
      anon_sym_LBRACE,
    ACTIONS(6020), 1,
      aux_sym__qid_token1,
    ACTIONS(6022), 1,
      anon_sym_DOT,
    ACTIONS(6024), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(6026), 1,
      anon_sym_u2987,
    ACTIONS(6030), 1,
      anon_sym_Set,
    STATE(4039), 1,
      aux_sym__atoms,
    STATE(4773), 1,
      sym_atom,
    STATE(8085), 1,
      sym__LAMBDA,
    STATE(8442), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3816), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(6028), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4881), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4870), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9001), 7,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(6008), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [415523] = 29,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2120), 1,
      anon_sym_quoteGoal,
    ACTIONS(2128), 1,
      anon_sym_let,
    ACTIONS(2176), 1,
      anon_sym_BSLASH,
    ACTIONS(2178), 1,
      anon_sym_u03bb,
    ACTIONS(2196), 1,
      anon_sym_tactic,
    ACTIONS(4238), 1,
      anon_sym_PIPE,
    ACTIONS(5522), 1,
      sym_id,
    ACTIONS(5526), 1,
      anon_sym_record,
    ACTIONS(5528), 1,
      anon_sym_LPAREN,
    ACTIONS(5530), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(5532), 1,
      anon_sym_u2983,
    ACTIONS(5534), 1,
      anon_sym_LBRACE,
    ACTIONS(5536), 1,
      aux_sym__qid_token1,
    ACTIONS(5538), 1,
      anon_sym_DOT,
    ACTIONS(5540), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(5542), 1,
      anon_sym_u2987,
    ACTIONS(5546), 1,
      anon_sym_Set,
    STATE(4039), 1,
      aux_sym__atoms,
    STATE(5007), 1,
      sym_atom,
    STATE(8044), 1,
      sym__LAMBDA,
    STATE(8428), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2096), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(5544), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5318), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5319), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8997), 7,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(5524), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [415635] = 29,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(2618), 1,
      anon_sym_BSLASH,
    ACTIONS(2620), 1,
      anon_sym_u03bb,
    ACTIONS(2638), 1,
      anon_sym_quoteGoal,
    ACTIONS(2640), 1,
      anon_sym_tactic,
    ACTIONS(2646), 1,
      anon_sym_let,
    ACTIONS(4238), 1,
      anon_sym_PIPE,
    ACTIONS(5926), 1,
      sym_id,
    ACTIONS(5930), 1,
      anon_sym_record,
    ACTIONS(5932), 1,
      anon_sym_LPAREN,
    ACTIONS(5934), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(5936), 1,
      anon_sym_u2983,
    ACTIONS(5938), 1,
      anon_sym_LBRACE,
    ACTIONS(5940), 1,
      aux_sym__qid_token1,
    ACTIONS(5942), 1,
      anon_sym_DOT,
    ACTIONS(5944), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(5946), 1,
      anon_sym_u2987,
    ACTIONS(5950), 1,
      anon_sym_Set,
    STATE(4039), 1,
      aux_sym__atoms,
    STATE(5542), 1,
      sym_atom,
    STATE(8093), 1,
      sym__LAMBDA,
    STATE(8414), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2616), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(5948), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5470), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5454), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9001), 7,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(5928), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [415747] = 28,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(1302), 1,
      anon_sym_let,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4222), 1,
      sym_id,
    ACTIONS(4224), 1,
      aux_sym__qid_token1,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(12717), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [415857] = 28,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(1302), 1,
      anon_sym_let,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4222), 1,
      sym_id,
    ACTIONS(4224), 1,
      aux_sym__qid_token1,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(12712), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [415967] = 28,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(1302), 1,
      anon_sym_let,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4222), 1,
      sym_id,
    ACTIONS(4224), 1,
      aux_sym__qid_token1,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(12706), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [416077] = 29,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(964), 1,
      anon_sym_quoteGoal,
    ACTIONS(972), 1,
      anon_sym_let,
    ACTIONS(4214), 1,
      anon_sym_BSLASH,
    ACTIONS(4216), 1,
      anon_sym_u03bb,
    ACTIONS(4218), 1,
      anon_sym_tactic,
    ACTIONS(4238), 1,
      anon_sym_PIPE,
    ACTIONS(5166), 1,
      sym_id,
    ACTIONS(5170), 1,
      anon_sym_record,
    ACTIONS(5172), 1,
      anon_sym_LPAREN,
    ACTIONS(5174), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(5176), 1,
      anon_sym_u2983,
    ACTIONS(5178), 1,
      anon_sym_LBRACE,
    ACTIONS(5180), 1,
      aux_sym__qid_token1,
    ACTIONS(5182), 1,
      anon_sym_DOT,
    ACTIONS(5184), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(5186), 1,
      anon_sym_u2987,
    ACTIONS(5190), 1,
      anon_sym_Set,
    STATE(4039), 1,
      aux_sym__atoms,
    STATE(5916), 1,
      sym_atom,
    STATE(8047), 1,
      sym__LAMBDA,
    STATE(8355), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(942), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(5188), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5928), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5926), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8997), 7,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(5168), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [416189] = 28,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(1302), 1,
      anon_sym_let,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4222), 1,
      sym_id,
    ACTIONS(4224), 1,
      aux_sym__qid_token1,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(12604), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [416299] = 28,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(1302), 1,
      anon_sym_let,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4222), 1,
      sym_id,
    ACTIONS(4224), 1,
      aux_sym__qid_token1,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(12700), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [416409] = 29,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(3698), 1,
      anon_sym_BSLASH,
    ACTIONS(3700), 1,
      anon_sym_u03bb,
    ACTIONS(3718), 1,
      anon_sym_quoteGoal,
    ACTIONS(3720), 1,
      anon_sym_tactic,
    ACTIONS(3726), 1,
      anon_sym_let,
    ACTIONS(4238), 1,
      anon_sym_PIPE,
    ACTIONS(5360), 1,
      sym_id,
    ACTIONS(5364), 1,
      anon_sym_record,
    ACTIONS(5366), 1,
      anon_sym_LPAREN,
    ACTIONS(5368), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(5370), 1,
      anon_sym_u2983,
    ACTIONS(5372), 1,
      anon_sym_LBRACE,
    ACTIONS(5374), 1,
      aux_sym__qid_token1,
    ACTIONS(5376), 1,
      anon_sym_DOT,
    ACTIONS(5378), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(5380), 1,
      anon_sym_u2987,
    ACTIONS(5384), 1,
      anon_sym_Set,
    STATE(4039), 1,
      aux_sym__atoms,
    STATE(5117), 1,
      sym_atom,
    STATE(8124), 1,
      sym__LAMBDA,
    STATE(8446), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3696), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(5382), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5038), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4980), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9001), 7,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(5362), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [416521] = 29,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(2388), 1,
      anon_sym_BSLASH,
    ACTIONS(2390), 1,
      anon_sym_u03bb,
    ACTIONS(2408), 1,
      anon_sym_quoteGoal,
    ACTIONS(2410), 1,
      anon_sym_tactic,
    ACTIONS(2416), 1,
      anon_sym_let,
    ACTIONS(4238), 1,
      anon_sym_PIPE,
    ACTIONS(5082), 1,
      sym_id,
    ACTIONS(5086), 1,
      anon_sym_record,
    ACTIONS(5088), 1,
      anon_sym_LPAREN,
    ACTIONS(5090), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(5092), 1,
      anon_sym_u2983,
    ACTIONS(5094), 1,
      anon_sym_LBRACE,
    ACTIONS(5096), 1,
      aux_sym__qid_token1,
    ACTIONS(5098), 1,
      anon_sym_DOT,
    ACTIONS(5100), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(5102), 1,
      anon_sym_u2987,
    ACTIONS(5106), 1,
      anon_sym_Set,
    STATE(4039), 1,
      aux_sym__atoms,
    STATE(5358), 1,
      sym_atom,
    STATE(8139), 1,
      sym__LAMBDA,
    STATE(8518), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2386), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(5104), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5584), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5587), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9001), 7,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(5084), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [416633] = 28,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(1302), 1,
      anon_sym_let,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4222), 1,
      sym_id,
    ACTIONS(4224), 1,
      aux_sym__qid_token1,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(12694), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [416743] = 28,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(1302), 1,
      anon_sym_let,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4222), 1,
      sym_id,
    ACTIONS(4224), 1,
      aux_sym__qid_token1,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(12688), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [416853] = 28,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(1302), 1,
      anon_sym_let,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4222), 1,
      sym_id,
    ACTIONS(4224), 1,
      aux_sym__qid_token1,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(12682), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [416963] = 29,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(2964), 1,
      anon_sym_quoteGoal,
    ACTIONS(2972), 1,
      anon_sym_let,
    ACTIONS(3522), 1,
      anon_sym_BSLASH,
    ACTIONS(3524), 1,
      anon_sym_u03bb,
    ACTIONS(3542), 1,
      anon_sym_tactic,
    ACTIONS(4238), 1,
      anon_sym_PIPE,
    ACTIONS(4924), 1,
      sym_id,
    ACTIONS(4928), 1,
      anon_sym_record,
    ACTIONS(4930), 1,
      anon_sym_LPAREN,
    ACTIONS(4932), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4934), 1,
      anon_sym_u2983,
    ACTIONS(4936), 1,
      anon_sym_LBRACE,
    ACTIONS(4938), 1,
      aux_sym__qid_token1,
    ACTIONS(4940), 1,
      anon_sym_DOT,
    ACTIONS(4942), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4944), 1,
      anon_sym_u2987,
    ACTIONS(4948), 1,
      anon_sym_Set,
    STATE(4039), 1,
      aux_sym__atoms,
    STATE(5872), 1,
      sym_atom,
    STATE(8058), 1,
      sym__LAMBDA,
    STATE(8418), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2940), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4946), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5898), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5899), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9001), 7,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(4926), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [417075] = 28,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(1302), 1,
      anon_sym_let,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4222), 1,
      sym_id,
    ACTIONS(4224), 1,
      aux_sym__qid_token1,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(12610), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [417185] = 29,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1984), 1,
      anon_sym_BSLASH,
    ACTIONS(1986), 1,
      anon_sym_u03bb,
    ACTIONS(2004), 1,
      anon_sym_quoteGoal,
    ACTIONS(2006), 1,
      anon_sym_tactic,
    ACTIONS(2012), 1,
      anon_sym_let,
    ACTIONS(4238), 1,
      anon_sym_PIPE,
    ACTIONS(5734), 1,
      sym_id,
    ACTIONS(5738), 1,
      anon_sym_record,
    ACTIONS(5740), 1,
      anon_sym_LPAREN,
    ACTIONS(5742), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(5744), 1,
      anon_sym_u2983,
    ACTIONS(5746), 1,
      anon_sym_LBRACE,
    ACTIONS(5748), 1,
      aux_sym__qid_token1,
    ACTIONS(5750), 1,
      anon_sym_DOT,
    ACTIONS(5752), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(5754), 1,
      anon_sym_u2987,
    ACTIONS(5758), 1,
      anon_sym_Set,
    STATE(4039), 1,
      aux_sym__atoms,
    STATE(5950), 1,
      sym_atom,
    STATE(8039), 1,
      sym__LAMBDA,
    STATE(8483), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1982), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(5756), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5762), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5752), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8997), 7,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(5736), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [417297] = 28,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(1302), 1,
      anon_sym_let,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4222), 1,
      sym_id,
    ACTIONS(4224), 1,
      aux_sym__qid_token1,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(12616), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [417407] = 29,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1910), 1,
      anon_sym_BSLASH,
    ACTIONS(1912), 1,
      anon_sym_u03bb,
    ACTIONS(1928), 1,
      anon_sym_quoteGoal,
    ACTIONS(1930), 1,
      anon_sym_tactic,
    ACTIONS(1936), 1,
      anon_sym_let,
    ACTIONS(4238), 1,
      anon_sym_PIPE,
    ACTIONS(5522), 1,
      sym_id,
    ACTIONS(5526), 1,
      anon_sym_record,
    ACTIONS(5528), 1,
      anon_sym_LPAREN,
    ACTIONS(5530), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(5532), 1,
      anon_sym_u2983,
    ACTIONS(5534), 1,
      anon_sym_LBRACE,
    ACTIONS(5536), 1,
      aux_sym__qid_token1,
    ACTIONS(5538), 1,
      anon_sym_DOT,
    ACTIONS(5540), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(5542), 1,
      anon_sym_u2987,
    ACTIONS(5546), 1,
      anon_sym_Set,
    STATE(4039), 1,
      aux_sym__atoms,
    STATE(5007), 1,
      sym_atom,
    STATE(8153), 1,
      sym__LAMBDA,
    STATE(8431), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1906), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(5544), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5318), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5319), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8997), 7,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(5524), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [417519] = 29,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(1870), 1,
      anon_sym_BSLASH,
    ACTIONS(1872), 1,
      anon_sym_u03bb,
    ACTIONS(1890), 1,
      anon_sym_quoteGoal,
    ACTIONS(1892), 1,
      anon_sym_tactic,
    ACTIONS(1898), 1,
      anon_sym_let,
    ACTIONS(4238), 1,
      anon_sym_PIPE,
    ACTIONS(5332), 1,
      sym_id,
    ACTIONS(5336), 1,
      anon_sym_record,
    ACTIONS(5338), 1,
      anon_sym_LPAREN,
    ACTIONS(5340), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(5342), 1,
      anon_sym_u2983,
    ACTIONS(5344), 1,
      anon_sym_LBRACE,
    ACTIONS(5346), 1,
      aux_sym__qid_token1,
    ACTIONS(5348), 1,
      anon_sym_DOT,
    ACTIONS(5350), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(5352), 1,
      anon_sym_u2987,
    ACTIONS(5356), 1,
      anon_sym_Set,
    STATE(4039), 1,
      aux_sym__atoms,
    STATE(4786), 1,
      sym_atom,
    STATE(8032), 1,
      sym__LAMBDA,
    STATE(8379), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1868), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(5354), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4898), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4840), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9001), 7,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(5334), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [417631] = 29,
    ACTIONS(9), 1,
      sym_id,
    ACTIONS(13), 1,
      anon_sym_BSLASH,
    ACTIONS(15), 1,
      anon_sym_u03bb,
    ACTIONS(51), 1,
      anon_sym_LPAREN,
    ACTIONS(53), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(55), 1,
      anon_sym_u2983,
    ACTIONS(61), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      aux_sym__qid_token1,
    ACTIONS(71), 1,
      anon_sym_DOT,
    ACTIONS(75), 1,
      anon_sym_quoteGoal,
    ACTIONS(77), 1,
      anon_sym_tactic,
    ACTIONS(79), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(81), 1,
      anon_sym_u2987,
    ACTIONS(83), 1,
      anon_sym_let,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(89), 1,
      anon_sym_Set,
    ACTIONS(4238), 1,
      anon_sym_PIPE,
    ACTIONS(4280), 1,
      anon_sym_record,
    STATE(4039), 1,
      aux_sym__atoms,
    STATE(4600), 1,
      sym_atom,
    STATE(8114), 1,
      sym__LAMBDA,
    STATE(8288), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(11), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(87), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4564), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4608), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9001), 7,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(17), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [417743] = 29,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2796), 1,
      anon_sym_BSLASH,
    ACTIONS(2798), 1,
      anon_sym_u03bb,
    ACTIONS(2800), 1,
      anon_sym_quoteGoal,
    ACTIONS(2802), 1,
      anon_sym_tactic,
    ACTIONS(2804), 1,
      anon_sym_let,
    ACTIONS(4238), 1,
      anon_sym_PIPE,
    ACTIONS(5028), 1,
      sym_id,
    ACTIONS(5032), 1,
      anon_sym_record,
    ACTIONS(5034), 1,
      anon_sym_LPAREN,
    ACTIONS(5036), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(5038), 1,
      anon_sym_u2983,
    ACTIONS(5040), 1,
      anon_sym_LBRACE,
    ACTIONS(5042), 1,
      aux_sym__qid_token1,
    ACTIONS(5044), 1,
      anon_sym_DOT,
    ACTIONS(5046), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(5048), 1,
      anon_sym_u2987,
    ACTIONS(5052), 1,
      anon_sym_Set,
    STATE(4039), 1,
      aux_sym__atoms,
    STATE(5588), 1,
      sym_atom,
    STATE(8041), 1,
      sym__LAMBDA,
    STATE(8490), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2794), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(5050), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5401), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5405), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8997), 7,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(5030), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [417855] = 29,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(982), 1,
      anon_sym_BSLASH,
    ACTIONS(984), 1,
      anon_sym_u03bb,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(990), 1,
      anon_sym_tactic,
    ACTIONS(1302), 1,
      anon_sym_let,
    ACTIONS(4238), 1,
      anon_sym_PIPE,
    ACTIONS(5416), 1,
      sym_id,
    ACTIONS(5420), 1,
      anon_sym_record,
    ACTIONS(5422), 1,
      anon_sym_LPAREN,
    ACTIONS(5424), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(5426), 1,
      anon_sym_u2983,
    ACTIONS(5428), 1,
      anon_sym_LBRACE,
    ACTIONS(5430), 1,
      aux_sym__qid_token1,
    ACTIONS(5432), 1,
      anon_sym_DOT,
    ACTIONS(5434), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(5436), 1,
      anon_sym_u2987,
    ACTIONS(5440), 1,
      anon_sym_Set,
    STATE(4039), 1,
      aux_sym__atoms,
    STATE(5548), 1,
      sym_atom,
    STATE(8095), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(5438), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5369), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5364), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8997), 7,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(5418), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [417967] = 19,
    ACTIONS(2462), 1,
      sym_id,
    ACTIONS(2466), 1,
      anon_sym_record,
    ACTIONS(2476), 1,
      aux_sym__qid_token1,
    ACTIONS(2480), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2482), 1,
      anon_sym_u2987,
    ACTIONS(2486), 1,
      anon_sym_Set,
    ACTIONS(4678), 1,
      anon_sym_LPAREN,
    ACTIONS(4680), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4682), 1,
      anon_sym_u2983,
    ACTIONS(4684), 1,
      anon_sym_LBRACE,
    ACTIONS(4686), 1,
      anon_sym_DOT,
    STATE(4069), 1,
      sym_atom,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2484), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(6226), 2,
      sym__newline,
      anon_sym_BSLASH,
    STATE(4044), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4052), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(2464), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    ACTIONS(6224), 17,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_let,
      anon_sym_do,
  [418059] = 28,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(1302), 1,
      anon_sym_let,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4222), 1,
      sym_id,
    ACTIONS(4224), 1,
      aux_sym__qid_token1,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(12676), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [418169] = 19,
    ACTIONS(3732), 1,
      sym_id,
    ACTIONS(3738), 1,
      anon_sym_record,
    ACTIONS(3740), 1,
      anon_sym_LPAREN,
    ACTIONS(3742), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3744), 1,
      anon_sym_u2983,
    ACTIONS(3746), 1,
      anon_sym_LBRACE,
    ACTIONS(3748), 1,
      aux_sym__qid_token1,
    ACTIONS(3750), 1,
      anon_sym_DOT,
    ACTIONS(3752), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3754), 1,
      anon_sym_u2987,
    ACTIONS(3758), 1,
      anon_sym_Set,
    STATE(4080), 1,
      sym_atom,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3756), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(6226), 2,
      sym__newline,
      anon_sym_BSLASH,
    STATE(4073), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4070), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3736), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    ACTIONS(6224), 17,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_let,
      anon_sym_do,
  [418261] = 29,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(105), 1,
      sym_id,
    ACTIONS(109), 1,
      anon_sym_BSLASH,
    ACTIONS(111), 1,
      anon_sym_u03bb,
    ACTIONS(125), 1,
      anon_sym_LPAREN,
    ACTIONS(127), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(129), 1,
      anon_sym_u2983,
    ACTIONS(135), 1,
      anon_sym_LBRACE,
    ACTIONS(143), 1,
      aux_sym__qid_token1,
    ACTIONS(145), 1,
      anon_sym_DOT,
    ACTIONS(147), 1,
      anon_sym_quoteGoal,
    ACTIONS(149), 1,
      anon_sym_tactic,
    ACTIONS(151), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(153), 1,
      anon_sym_u2987,
    ACTIONS(155), 1,
      anon_sym_let,
    ACTIONS(159), 1,
      anon_sym_Set,
    ACTIONS(4238), 1,
      anon_sym_PIPE,
    ACTIONS(4274), 1,
      anon_sym_record,
    STATE(4039), 1,
      aux_sym__atoms,
    STATE(4271), 1,
      sym_atom,
    STATE(8146), 1,
      sym__LAMBDA,
    STATE(8343), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(107), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(157), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4311), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4327), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9001), 7,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(113), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [418373] = 29,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(3174), 1,
      anon_sym_BSLASH,
    ACTIONS(3176), 1,
      anon_sym_u03bb,
    ACTIONS(3194), 1,
      anon_sym_quoteGoal,
    ACTIONS(3196), 1,
      anon_sym_tactic,
    ACTIONS(3202), 1,
      anon_sym_let,
    ACTIONS(4238), 1,
      anon_sym_PIPE,
    ACTIONS(6198), 1,
      sym_id,
    ACTIONS(6202), 1,
      anon_sym_record,
    ACTIONS(6204), 1,
      anon_sym_LPAREN,
    ACTIONS(6206), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(6208), 1,
      anon_sym_u2983,
    ACTIONS(6210), 1,
      anon_sym_LBRACE,
    ACTIONS(6212), 1,
      aux_sym__qid_token1,
    ACTIONS(6214), 1,
      anon_sym_DOT,
    ACTIONS(6216), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(6218), 1,
      anon_sym_u2987,
    ACTIONS(6222), 1,
      anon_sym_Set,
    STATE(4039), 1,
      aux_sym__atoms,
    STATE(5407), 1,
      sym_atom,
    STATE(8051), 1,
      sym__LAMBDA,
    STATE(8409), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3170), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(6220), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5699), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5697), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9001), 7,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(6200), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [418485] = 28,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(1302), 1,
      anon_sym_let,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4222), 1,
      sym_id,
    ACTIONS(4224), 1,
      aux_sym__qid_token1,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(12622), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [418595] = 29,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(944), 1,
      anon_sym_BSLASH,
    ACTIONS(946), 1,
      anon_sym_u03bb,
    ACTIONS(964), 1,
      anon_sym_quoteGoal,
    ACTIONS(966), 1,
      anon_sym_tactic,
    ACTIONS(972), 1,
      anon_sym_let,
    ACTIONS(4238), 1,
      anon_sym_PIPE,
    ACTIONS(5416), 1,
      sym_id,
    ACTIONS(5420), 1,
      anon_sym_record,
    ACTIONS(5422), 1,
      anon_sym_LPAREN,
    ACTIONS(5424), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(5426), 1,
      anon_sym_u2983,
    ACTIONS(5428), 1,
      anon_sym_LBRACE,
    ACTIONS(5430), 1,
      aux_sym__qid_token1,
    ACTIONS(5432), 1,
      anon_sym_DOT,
    ACTIONS(5434), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(5436), 1,
      anon_sym_u2987,
    ACTIONS(5440), 1,
      anon_sym_Set,
    STATE(4039), 1,
      aux_sym__atoms,
    STATE(5548), 1,
      sym_atom,
    STATE(8054), 1,
      sym__LAMBDA,
    STATE(8355), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(942), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(5438), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5369), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5364), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8997), 7,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(5418), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [418707] = 28,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(1302), 1,
      anon_sym_let,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4222), 1,
      sym_id,
    ACTIONS(4224), 1,
      aux_sym__qid_token1,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(12628), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [418817] = 29,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2448), 1,
      anon_sym_quoteGoal,
    ACTIONS(2456), 1,
      anon_sym_let,
    ACTIONS(2842), 1,
      anon_sym_BSLASH,
    ACTIONS(2844), 1,
      anon_sym_u03bb,
    ACTIONS(2862), 1,
      anon_sym_tactic,
    ACTIONS(4238), 1,
      anon_sym_PIPE,
    ACTIONS(5442), 1,
      sym_id,
    ACTIONS(5446), 1,
      anon_sym_record,
    ACTIONS(5448), 1,
      anon_sym_LPAREN,
    ACTIONS(5450), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(5452), 1,
      anon_sym_u2983,
    ACTIONS(5454), 1,
      anon_sym_LBRACE,
    ACTIONS(5456), 1,
      aux_sym__qid_token1,
    ACTIONS(5458), 1,
      anon_sym_DOT,
    ACTIONS(5460), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(5462), 1,
      anon_sym_u2987,
    ACTIONS(5466), 1,
      anon_sym_Set,
    STATE(4039), 1,
      aux_sym__atoms,
    STATE(5485), 1,
      sym_atom,
    STATE(8053), 1,
      sym__LAMBDA,
    STATE(8423), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2424), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(5464), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5639), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5635), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8997), 7,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(5444), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [418929] = 28,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(1302), 1,
      anon_sym_let,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4222), 1,
      sym_id,
    ACTIONS(4224), 1,
      aux_sym__qid_token1,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(12634), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [419039] = 28,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(1302), 1,
      anon_sym_let,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4222), 1,
      sym_id,
    ACTIONS(4224), 1,
      aux_sym__qid_token1,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(12442), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [419149] = 28,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(1302), 1,
      anon_sym_let,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4222), 1,
      sym_id,
    ACTIONS(4224), 1,
      aux_sym__qid_token1,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(12640), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [419259] = 28,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(1302), 1,
      anon_sym_let,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4222), 1,
      sym_id,
    ACTIONS(4224), 1,
      aux_sym__qid_token1,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(12646), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [419369] = 29,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(2732), 1,
      anon_sym_BSLASH,
    ACTIONS(2734), 1,
      anon_sym_u03bb,
    ACTIONS(2752), 1,
      anon_sym_quoteGoal,
    ACTIONS(2754), 1,
      anon_sym_tactic,
    ACTIONS(2760), 1,
      anon_sym_let,
    ACTIONS(4238), 1,
      anon_sym_PIPE,
    ACTIONS(5630), 1,
      sym_id,
    ACTIONS(5634), 1,
      anon_sym_record,
    ACTIONS(5636), 1,
      anon_sym_LPAREN,
    ACTIONS(5638), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(5640), 1,
      anon_sym_u2983,
    ACTIONS(5642), 1,
      anon_sym_LBRACE,
    ACTIONS(5644), 1,
      aux_sym__qid_token1,
    ACTIONS(5646), 1,
      anon_sym_DOT,
    ACTIONS(5648), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(5650), 1,
      anon_sym_u2987,
    ACTIONS(5654), 1,
      anon_sym_Set,
    STATE(4039), 1,
      aux_sym__atoms,
    STATE(5368), 1,
      sym_atom,
    STATE(8061), 1,
      sym__LAMBDA,
    STATE(8384), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2730), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(5652), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5733), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5727), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9001), 7,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(5632), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [419481] = 28,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(1302), 1,
      anon_sym_let,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4222), 1,
      sym_id,
    ACTIONS(4224), 1,
      aux_sym__qid_token1,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(12347), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [419591] = 28,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(1302), 1,
      anon_sym_let,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4222), 1,
      sym_id,
    ACTIONS(4224), 1,
      aux_sym__qid_token1,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(12670), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [419701] = 28,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(1302), 1,
      anon_sym_let,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4222), 1,
      sym_id,
    ACTIONS(4224), 1,
      aux_sym__qid_token1,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(12664), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [419811] = 28,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(1302), 1,
      anon_sym_let,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4222), 1,
      sym_id,
    ACTIONS(4224), 1,
      aux_sym__qid_token1,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(12652), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [419921] = 28,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(1302), 1,
      anon_sym_let,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4222), 1,
      sym_id,
    ACTIONS(4224), 1,
      aux_sym__qid_token1,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(12451), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [420031] = 28,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(1302), 1,
      anon_sym_let,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4222), 1,
      sym_id,
    ACTIONS(4224), 1,
      aux_sym__qid_token1,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(12361), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [420141] = 29,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(1248), 1,
      anon_sym_BSLASH,
    ACTIONS(1250), 1,
      anon_sym_u03bb,
    ACTIONS(1270), 1,
      anon_sym_quoteGoal,
    ACTIONS(1272), 1,
      anon_sym_tactic,
    ACTIONS(1278), 1,
      anon_sym_let,
    ACTIONS(4238), 1,
      anon_sym_PIPE,
    ACTIONS(5112), 1,
      sym_id,
    ACTIONS(5116), 1,
      anon_sym_record,
    ACTIONS(5118), 1,
      anon_sym_LPAREN,
    ACTIONS(5120), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(5122), 1,
      anon_sym_u2983,
    ACTIONS(5124), 1,
      anon_sym_LBRACE,
    ACTIONS(5126), 1,
      aux_sym__qid_token1,
    ACTIONS(5128), 1,
      anon_sym_DOT,
    ACTIONS(5130), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(5132), 1,
      anon_sym_u2987,
    ACTIONS(5136), 1,
      anon_sym_Set,
    STATE(4039), 1,
      aux_sym__atoms,
    STATE(6081), 1,
      sym_atom,
    STATE(8148), 1,
      sym__LAMBDA,
    STATE(8275), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1246), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(5134), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6010), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6007), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8997), 7,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(5114), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [420253] = 28,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(1302), 1,
      anon_sym_let,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4222), 1,
      sym_id,
    ACTIONS(4224), 1,
      aux_sym__qid_token1,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(12433), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [420363] = 28,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(1302), 1,
      anon_sym_let,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(5218), 1,
      sym_id,
    ACTIONS(5224), 1,
      anon_sym_record,
    ACTIONS(5226), 1,
      anon_sym_LPAREN,
    ACTIONS(5228), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(5230), 1,
      anon_sym_u2983,
    ACTIONS(5232), 1,
      anon_sym_LBRACE,
    ACTIONS(5234), 1,
      aux_sym__qid_token1,
    ACTIONS(5236), 1,
      anon_sym_DOT,
    ACTIONS(5238), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(5240), 1,
      anon_sym_u2987,
    ACTIONS(5244), 1,
      anon_sym_Set,
    STATE(3474), 1,
      aux_sym__atoms,
    STATE(6203), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(5242), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6166), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6188), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(12361), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(5222), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [420473] = 29,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(2140), 1,
      anon_sym_BSLASH,
    ACTIONS(2142), 1,
      anon_sym_u03bb,
    ACTIONS(2160), 1,
      anon_sym_quoteGoal,
    ACTIONS(2162), 1,
      anon_sym_tactic,
    ACTIONS(2168), 1,
      anon_sym_let,
    ACTIONS(4238), 1,
      anon_sym_PIPE,
    ACTIONS(6112), 1,
      sym_id,
    ACTIONS(6116), 1,
      anon_sym_record,
    ACTIONS(6118), 1,
      anon_sym_LPAREN,
    ACTIONS(6120), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(6122), 1,
      anon_sym_u2983,
    ACTIONS(6124), 1,
      anon_sym_LBRACE,
    ACTIONS(6126), 1,
      aux_sym__qid_token1,
    ACTIONS(6128), 1,
      anon_sym_DOT,
    ACTIONS(6130), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(6132), 1,
      anon_sym_u2987,
    ACTIONS(6136), 1,
      anon_sym_Set,
    STATE(4039), 1,
      aux_sym__atoms,
    STATE(5942), 1,
      sym_atom,
    STATE(8040), 1,
      sym__LAMBDA,
    STATE(8460), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2136), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(6134), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5819), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5817), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8997), 7,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(6114), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [420585] = 29,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(3410), 1,
      anon_sym_BSLASH,
    ACTIONS(3412), 1,
      anon_sym_u03bb,
    ACTIONS(3430), 1,
      anon_sym_quoteGoal,
    ACTIONS(3432), 1,
      anon_sym_tactic,
    ACTIONS(3438), 1,
      anon_sym_let,
    ACTIONS(4238), 1,
      anon_sym_PIPE,
    ACTIONS(5468), 1,
      sym_id,
    ACTIONS(5472), 1,
      anon_sym_record,
    ACTIONS(5474), 1,
      anon_sym_LPAREN,
    ACTIONS(5476), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(5478), 1,
      anon_sym_u2983,
    ACTIONS(5480), 1,
      anon_sym_LBRACE,
    ACTIONS(5482), 1,
      aux_sym__qid_token1,
    ACTIONS(5484), 1,
      anon_sym_DOT,
    ACTIONS(5486), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(5488), 1,
      anon_sym_u2987,
    ACTIONS(5492), 1,
      anon_sym_Set,
    STATE(4039), 1,
      aux_sym__atoms,
    STATE(4421), 1,
      sym_atom,
    STATE(8038), 1,
      sym__LAMBDA,
    STATE(8435), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3408), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(5490), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4533), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4527), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9001), 7,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(5470), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [420697] = 29,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(2656), 1,
      anon_sym_BSLASH,
    ACTIONS(2658), 1,
      anon_sym_u03bb,
    ACTIONS(2676), 1,
      anon_sym_quoteGoal,
    ACTIONS(2678), 1,
      anon_sym_tactic,
    ACTIONS(2684), 1,
      anon_sym_let,
    ACTIONS(4238), 1,
      anon_sym_PIPE,
    ACTIONS(5028), 1,
      sym_id,
    ACTIONS(5032), 1,
      anon_sym_record,
    ACTIONS(5034), 1,
      anon_sym_LPAREN,
    ACTIONS(5036), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(5038), 1,
      anon_sym_u2983,
    ACTIONS(5040), 1,
      anon_sym_LBRACE,
    ACTIONS(5042), 1,
      aux_sym__qid_token1,
    ACTIONS(5044), 1,
      anon_sym_DOT,
    ACTIONS(5046), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(5048), 1,
      anon_sym_u2987,
    ACTIONS(5052), 1,
      anon_sym_Set,
    STATE(4039), 1,
      aux_sym__atoms,
    STATE(5588), 1,
      sym_atom,
    STATE(8132), 1,
      sym__LAMBDA,
    STATE(8470), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2654), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(5050), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5401), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5405), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9454), 7,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(5030), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [420809] = 28,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(1302), 1,
      anon_sym_let,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4222), 1,
      sym_id,
    ACTIONS(4224), 1,
      aux_sym__qid_token1,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(12749), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [420919] = 29,
    ACTIONS(85), 1,
      anon_sym_do,
    ACTIONS(3266), 1,
      anon_sym_BSLASH,
    ACTIONS(3268), 1,
      anon_sym_u03bb,
    ACTIONS(3286), 1,
      anon_sym_quoteGoal,
    ACTIONS(3288), 1,
      anon_sym_tactic,
    ACTIONS(3294), 1,
      anon_sym_let,
    ACTIONS(4238), 1,
      anon_sym_PIPE,
    ACTIONS(4950), 1,
      sym_id,
    ACTIONS(4954), 1,
      anon_sym_record,
    ACTIONS(4956), 1,
      anon_sym_LPAREN,
    ACTIONS(4958), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4960), 1,
      anon_sym_u2983,
    ACTIONS(4962), 1,
      anon_sym_LBRACE,
    ACTIONS(4964), 1,
      aux_sym__qid_token1,
    ACTIONS(4966), 1,
      anon_sym_DOT,
    ACTIONS(4968), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4970), 1,
      anon_sym_u2987,
    ACTIONS(4974), 1,
      anon_sym_Set,
    STATE(4039), 1,
      aux_sym__atoms,
    STATE(4226), 1,
      sym_atom,
    STATE(8143), 1,
      sym__LAMBDA,
    STATE(8451), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3264), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4972), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4253), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4254), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9001), 7,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(4952), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [421031] = 28,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(1302), 1,
      anon_sym_let,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4222), 1,
      sym_id,
    ACTIONS(4224), 1,
      aux_sym__qid_token1,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(12397), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [421141] = 28,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(1302), 1,
      anon_sym_let,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4222), 1,
      sym_id,
    ACTIONS(4224), 1,
      aux_sym__qid_token1,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(12406), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [421251] = 28,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(1302), 1,
      anon_sym_let,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4222), 1,
      sym_id,
    ACTIONS(4224), 1,
      aux_sym__qid_token1,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(12415), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [421361] = 28,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(1302), 1,
      anon_sym_let,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4222), 1,
      sym_id,
    ACTIONS(4224), 1,
      aux_sym__qid_token1,
    STATE(3887), 1,
      aux_sym__atoms,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(12424), 8,
      sym__application,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [421471] = 19,
    ACTIONS(2246), 1,
      sym_id,
    ACTIONS(2250), 1,
      anon_sym_record,
    ACTIONS(2260), 1,
      aux_sym__qid_token1,
    ACTIONS(2264), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2266), 1,
      anon_sym_u2987,
    ACTIONS(2270), 1,
      anon_sym_Set,
    ACTIONS(4738), 1,
      anon_sym_LPAREN,
    ACTIONS(4740), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4742), 1,
      anon_sym_u2983,
    ACTIONS(4744), 1,
      anon_sym_LBRACE,
    ACTIONS(4746), 1,
      anon_sym_DOT,
    STATE(4144), 1,
      sym_atom,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2268), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(6226), 2,
      sym__newline,
      anon_sym_BSLASH,
    STATE(4151), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4153), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(2248), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    ACTIONS(6224), 16,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_let,
      anon_sym_do,
  [421562] = 19,
    ACTIONS(3354), 1,
      sym_id,
    ACTIONS(3358), 1,
      anon_sym_record,
    ACTIONS(3368), 1,
      aux_sym__qid_token1,
    ACTIONS(3372), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3374), 1,
      anon_sym_u2987,
    ACTIONS(3378), 1,
      anon_sym_Set,
    ACTIONS(4336), 1,
      anon_sym_LPAREN,
    ACTIONS(4338), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4340), 1,
      anon_sym_u2983,
    ACTIONS(4342), 1,
      anon_sym_LBRACE,
    ACTIONS(4344), 1,
      anon_sym_DOT,
    STATE(4188), 1,
      sym_atom,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3376), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(6226), 2,
      sym__newline,
      anon_sym_BSLASH,
    STATE(4178), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4177), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3356), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    ACTIONS(6224), 16,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_let,
      anon_sym_do,
  [421653] = 19,
    ACTIONS(2346), 1,
      sym_id,
    ACTIONS(2356), 1,
      anon_sym_record,
    ACTIONS(2366), 1,
      aux_sym__qid_token1,
    ACTIONS(2374), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2376), 1,
      anon_sym_u2987,
    ACTIONS(2382), 1,
      anon_sym_Set,
    ACTIONS(4750), 1,
      anon_sym_LPAREN,
    ACTIONS(4752), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4754), 1,
      anon_sym_u2983,
    ACTIONS(4756), 1,
      anon_sym_LBRACE,
    ACTIONS(4758), 1,
      anon_sym_DOT,
    STATE(4172), 1,
      sym_atom,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2380), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(6226), 2,
      sym__newline,
      anon_sym_BSLASH,
    STATE(4180), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4192), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(2354), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    ACTIONS(6224), 16,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_let,
      anon_sym_do,
  [421744] = 19,
    ACTIONS(4950), 1,
      sym_id,
    ACTIONS(4954), 1,
      anon_sym_record,
    ACTIONS(4956), 1,
      anon_sym_LPAREN,
    ACTIONS(4958), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4960), 1,
      anon_sym_u2983,
    ACTIONS(4962), 1,
      anon_sym_LBRACE,
    ACTIONS(4964), 1,
      aux_sym__qid_token1,
    ACTIONS(4966), 1,
      anon_sym_DOT,
    ACTIONS(4968), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4970), 1,
      anon_sym_u2987,
    ACTIONS(4974), 1,
      anon_sym_Set,
    STATE(4236), 1,
      sym_atom,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(4972), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(6226), 2,
      sym__newline,
      anon_sym_BSLASH,
    STATE(4253), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4254), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(4952), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    ACTIONS(6224), 16,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_let,
      anon_sym_do,
  [421835] = 28,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(988), 1,
      anon_sym_quoteGoal,
    ACTIONS(1302), 1,
      anon_sym_let,
    ACTIONS(3968), 1,
      anon_sym_BSLASH,
    ACTIONS(3970), 1,
      anon_sym_u03bb,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3990), 1,
      anon_sym_tactic,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4222), 1,
      sym_id,
    ACTIONS(4224), 1,
      aux_sym__qid_token1,
    STATE(4093), 1,
      aux_sym__atoms,
    STATE(6022), 1,
      sym_atom,
    STATE(8142), 1,
      sym__LAMBDA,
    STATE(8345), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(980), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8997), 7,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [421944] = 28,
    ACTIONS(878), 1,
      anon_sym_quoteGoal,
    ACTIONS(886), 1,
      anon_sym_let,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(4184), 1,
      anon_sym_BSLASH,
    ACTIONS(4186), 1,
      anon_sym_u03bb,
    ACTIONS(4190), 1,
      anon_sym_record,
    ACTIONS(4192), 1,
      anon_sym_LPAREN,
    ACTIONS(4194), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4196), 1,
      anon_sym_u2983,
    ACTIONS(4198), 1,
      anon_sym_LBRACE,
    ACTIONS(4202), 1,
      anon_sym_DOT,
    ACTIONS(4204), 1,
      anon_sym_tactic,
    ACTIONS(4206), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4208), 1,
      anon_sym_u2987,
    ACTIONS(4212), 1,
      anon_sym_Set,
    ACTIONS(6228), 1,
      sym_id,
    ACTIONS(6230), 1,
      aux_sym__qid_token1,
    STATE(4093), 1,
      aux_sym__atoms,
    STATE(6386), 1,
      sym_atom,
    STATE(8067), 1,
      sym__LAMBDA,
    STATE(8369), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(852), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(4210), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6575), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6565), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8997), 7,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(4188), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [422053] = 19,
    ACTIONS(2898), 1,
      sym_id,
    ACTIONS(2910), 1,
      anon_sym_record,
    ACTIONS(2912), 1,
      anon_sym_LPAREN,
    ACTIONS(2914), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2916), 1,
      anon_sym_u2983,
    ACTIONS(2918), 1,
      anon_sym_LBRACE,
    ACTIONS(2920), 1,
      aux_sym__qid_token1,
    ACTIONS(2922), 1,
      anon_sym_DOT,
    ACTIONS(2928), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2930), 1,
      anon_sym_u2987,
    ACTIONS(2936), 1,
      anon_sym_Set,
    STATE(4233), 1,
      sym_atom,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2934), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(6226), 2,
      sym__newline,
      anon_sym_BSLASH,
    STATE(4184), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4206), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(2908), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    ACTIONS(6224), 16,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_let,
      anon_sym_do,
  [422144] = 19,
    ACTIONS(3406), 1,
      sym_id,
    ACTIONS(3416), 1,
      anon_sym_record,
    ACTIONS(3426), 1,
      aux_sym__qid_token1,
    ACTIONS(3434), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3436), 1,
      anon_sym_u2987,
    ACTIONS(3442), 1,
      anon_sym_Set,
    ACTIONS(4694), 1,
      anon_sym_LPAREN,
    ACTIONS(4696), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4698), 1,
      anon_sym_u2983,
    ACTIONS(4700), 1,
      anon_sym_LBRACE,
    ACTIONS(4702), 1,
      anon_sym_DOT,
    STATE(4126), 1,
      sym_atom,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3440), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(6226), 2,
      sym__newline,
      anon_sym_BSLASH,
    STATE(4158), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4162), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3414), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    ACTIONS(6224), 16,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_let,
      anon_sym_do,
  [422235] = 28,
    ACTIONS(888), 1,
      anon_sym_do,
    ACTIONS(964), 1,
      anon_sym_quoteGoal,
    ACTIONS(972), 1,
      anon_sym_let,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4214), 1,
      anon_sym_BSLASH,
    ACTIONS(4216), 1,
      anon_sym_u03bb,
    ACTIONS(4218), 1,
      anon_sym_tactic,
    ACTIONS(4222), 1,
      sym_id,
    ACTIONS(4224), 1,
      aux_sym__qid_token1,
    STATE(4093), 1,
      aux_sym__atoms,
    STATE(6022), 1,
      sym_atom,
    STATE(8047), 1,
      sym__LAMBDA,
    STATE(8355), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(942), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(8997), 7,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [422344] = 28,
    ACTIONS(724), 1,
      anon_sym_do,
    ACTIONS(920), 1,
      anon_sym_quoteGoal,
    ACTIONS(928), 1,
      anon_sym_let,
    ACTIONS(3058), 1,
      anon_sym_BSLASH,
    ACTIONS(3060), 1,
      anon_sym_u03bb,
    ACTIONS(3064), 1,
      anon_sym_record,
    ACTIONS(3066), 1,
      anon_sym_LPAREN,
    ACTIONS(3068), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3070), 1,
      anon_sym_u2983,
    ACTIONS(3072), 1,
      anon_sym_LBRACE,
    ACTIONS(3078), 1,
      anon_sym_DOT,
    ACTIONS(3080), 1,
      anon_sym_tactic,
    ACTIONS(3082), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3084), 1,
      anon_sym_u2987,
    ACTIONS(3088), 1,
      anon_sym_Set,
    ACTIONS(6232), 1,
      sym_id,
    ACTIONS(6234), 1,
      aux_sym__qid_token1,
    STATE(4093), 1,
      aux_sym__atoms,
    STATE(6427), 1,
      sym_atom,
    STATE(8123), 1,
      sym__LAMBDA,
    STATE(8396), 1,
      sym__FORALL,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3086), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6715), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6714), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    STATE(9454), 7,
      sym__expr2_without_let,
      sym__expr2,
      sym_forall,
      sym_let,
      sym_lambda,
      sym_lambda_extended_or_absurd,
      sym_do,
    ACTIONS(3062), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [422453] = 19,
    ACTIONS(3878), 1,
      sym_id,
    ACTIONS(3884), 1,
      anon_sym_record,
    ACTIONS(3886), 1,
      anon_sym_LPAREN,
    ACTIONS(3888), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3890), 1,
      anon_sym_u2983,
    ACTIONS(3892), 1,
      anon_sym_LBRACE,
    ACTIONS(3894), 1,
      aux_sym__qid_token1,
    ACTIONS(3896), 1,
      anon_sym_DOT,
    ACTIONS(3898), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3900), 1,
      anon_sym_u2987,
    ACTIONS(3904), 1,
      anon_sym_Set,
    STATE(4209), 1,
      sym_atom,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3902), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(6226), 2,
      sym__newline,
      anon_sym_BSLASH,
    STATE(4214), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4218), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3882), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    ACTIONS(6224), 16,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_let,
      anon_sym_do,
  [422544] = 19,
    ACTIONS(105), 1,
      sym_id,
    ACTIONS(125), 1,
      anon_sym_LPAREN,
    ACTIONS(127), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(129), 1,
      anon_sym_u2983,
    ACTIONS(135), 1,
      anon_sym_LBRACE,
    ACTIONS(143), 1,
      aux_sym__qid_token1,
    ACTIONS(145), 1,
      anon_sym_DOT,
    ACTIONS(151), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(153), 1,
      anon_sym_u2987,
    ACTIONS(159), 1,
      anon_sym_Set,
    ACTIONS(4274), 1,
      anon_sym_record,
    STATE(4329), 1,
      sym_atom,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(157), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(6226), 2,
      sym__newline,
      anon_sym_BSLASH,
    STATE(4311), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4327), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(113), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    ACTIONS(6224), 15,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_let,
      anon_sym_do,
  [422634] = 19,
    ACTIONS(3786), 1,
      sym_id,
    ACTIONS(3792), 1,
      anon_sym_record,
    ACTIONS(3794), 1,
      anon_sym_LPAREN,
    ACTIONS(3796), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3798), 1,
      anon_sym_u2983,
    ACTIONS(3800), 1,
      anon_sym_LBRACE,
    ACTIONS(3802), 1,
      aux_sym__qid_token1,
    ACTIONS(3804), 1,
      anon_sym_DOT,
    ACTIONS(3806), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3808), 1,
      anon_sym_u2987,
    ACTIONS(3812), 1,
      anon_sym_Set,
    STATE(4287), 1,
      sym_atom,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3810), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(6226), 2,
      sym__newline,
      anon_sym_BSLASH,
    STATE(4284), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4282), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3790), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    ACTIONS(6224), 15,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_let,
      anon_sym_do,
  [422724] = 19,
    ACTIONS(6058), 1,
      sym_id,
    ACTIONS(6062), 1,
      anon_sym_record,
    ACTIONS(6064), 1,
      anon_sym_LPAREN,
    ACTIONS(6066), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(6068), 1,
      anon_sym_u2983,
    ACTIONS(6070), 1,
      anon_sym_LBRACE,
    ACTIONS(6072), 1,
      aux_sym__qid_token1,
    ACTIONS(6074), 1,
      anon_sym_DOT,
    ACTIONS(6076), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(6078), 1,
      anon_sym_u2987,
    ACTIONS(6082), 1,
      anon_sym_Set,
    STATE(4338), 1,
      sym_atom,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6080), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(6226), 2,
      sym__newline,
      anon_sym_BSLASH,
    STATE(4341), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4349), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(6060), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    ACTIONS(6224), 15,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_let,
      anon_sym_do,
  [422814] = 19,
    ACTIONS(5574), 1,
      sym_id,
    ACTIONS(5578), 1,
      anon_sym_record,
    ACTIONS(5580), 1,
      anon_sym_LPAREN,
    ACTIONS(5582), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(5584), 1,
      anon_sym_u2983,
    ACTIONS(5586), 1,
      anon_sym_LBRACE,
    ACTIONS(5588), 1,
      aux_sym__qid_token1,
    ACTIONS(5590), 1,
      anon_sym_DOT,
    ACTIONS(5592), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(5594), 1,
      anon_sym_u2987,
    ACTIONS(5598), 1,
      anon_sym_Set,
    STATE(4316), 1,
      sym_atom,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(5596), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(6226), 2,
      sym__newline,
      anon_sym_BSLASH,
    STATE(4312), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4307), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(5576), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    ACTIONS(6224), 15,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_let,
      anon_sym_do,
  [422904] = 19,
    ACTIONS(3814), 1,
      sym_id,
    ACTIONS(3824), 1,
      anon_sym_record,
    ACTIONS(3834), 1,
      aux_sym__qid_token1,
    ACTIONS(3842), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3844), 1,
      anon_sym_u2987,
    ACTIONS(3850), 1,
      anon_sym_Set,
    ACTIONS(4658), 1,
      anon_sym_LPAREN,
    ACTIONS(4660), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4662), 1,
      anon_sym_u2983,
    ACTIONS(4664), 1,
      anon_sym_LBRACE,
    ACTIONS(4666), 1,
      anon_sym_DOT,
    STATE(4346), 1,
      sym_atom,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3848), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(6226), 2,
      sym__newline,
      anon_sym_BSLASH,
    STATE(4342), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4273), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3822), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    ACTIONS(6224), 15,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_let,
      anon_sym_do,
  [422994] = 19,
    ACTIONS(3482), 1,
      sym_id,
    ACTIONS(3492), 1,
      anon_sym_record,
    ACTIONS(3502), 1,
      aux_sym__qid_token1,
    ACTIONS(3510), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3512), 1,
      anon_sym_u2987,
    ACTIONS(3518), 1,
      anon_sym_Set,
    ACTIONS(4552), 1,
      anon_sym_LPAREN,
    ACTIONS(4554), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4556), 1,
      anon_sym_u2983,
    ACTIONS(4558), 1,
      anon_sym_LBRACE,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    STATE(4377), 1,
      sym_atom,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3516), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(6226), 2,
      sym__newline,
      anon_sym_BSLASH,
    STATE(4382), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4385), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3490), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    ACTIONS(6224), 15,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_let,
      anon_sym_do,
  [423084] = 19,
    ACTIONS(1866), 1,
      sym_id,
    ACTIONS(1876), 1,
      anon_sym_record,
    ACTIONS(1886), 1,
      aux_sym__qid_token1,
    ACTIONS(1894), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1896), 1,
      anon_sym_u2987,
    ACTIONS(1902), 1,
      anon_sym_Set,
    ACTIONS(4884), 1,
      anon_sym_LPAREN,
    ACTIONS(4886), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4888), 1,
      anon_sym_u2983,
    ACTIONS(4890), 1,
      anon_sym_LBRACE,
    ACTIONS(4892), 1,
      anon_sym_DOT,
    STATE(4402), 1,
      sym_atom,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1900), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(6226), 2,
      sym__newline,
      anon_sym_BSLASH,
    STATE(4264), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4263), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(1874), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    ACTIONS(6224), 15,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_let,
      anon_sym_do,
  [423174] = 19,
    ACTIONS(3584), 1,
      sym_id,
    ACTIONS(3588), 1,
      anon_sym_record,
    ACTIONS(3598), 1,
      aux_sym__qid_token1,
    ACTIONS(3602), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3604), 1,
      anon_sym_u2987,
    ACTIONS(3608), 1,
      anon_sym_Set,
    ACTIONS(4788), 1,
      anon_sym_LPAREN,
    ACTIONS(4790), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4792), 1,
      anon_sym_u2983,
    ACTIONS(4794), 1,
      anon_sym_LBRACE,
    ACTIONS(4796), 1,
      anon_sym_DOT,
    STATE(4396), 1,
      sym_atom,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3606), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(6226), 2,
      sym__newline,
      anon_sym_BSLASH,
    STATE(4400), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4403), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3586), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    ACTIONS(6224), 15,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_let,
      anon_sym_do,
  [423264] = 19,
    ACTIONS(3090), 1,
      sym_id,
    ACTIONS(3102), 1,
      anon_sym_record,
    ACTIONS(3104), 1,
      anon_sym_LPAREN,
    ACTIONS(3106), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3108), 1,
      anon_sym_u2983,
    ACTIONS(3110), 1,
      anon_sym_LBRACE,
    ACTIONS(3112), 1,
      aux_sym__qid_token1,
    ACTIONS(3114), 1,
      anon_sym_DOT,
    ACTIONS(3120), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3122), 1,
      anon_sym_u2987,
    ACTIONS(3128), 1,
      anon_sym_Set,
    STATE(4300), 1,
      sym_atom,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3126), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(6226), 2,
      sym__newline,
      anon_sym_BSLASH,
    STATE(4293), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4285), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3100), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    ACTIONS(6224), 15,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_let,
      anon_sym_do,
  [423354] = 19,
    ACTIONS(3666), 1,
      sym_id,
    ACTIONS(3672), 1,
      anon_sym_record,
    ACTIONS(3674), 1,
      anon_sym_LPAREN,
    ACTIONS(3676), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3678), 1,
      anon_sym_u2983,
    ACTIONS(3680), 1,
      anon_sym_LBRACE,
    ACTIONS(3682), 1,
      aux_sym__qid_token1,
    ACTIONS(3684), 1,
      anon_sym_DOT,
    ACTIONS(3686), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3688), 1,
      anon_sym_u2987,
    ACTIONS(3692), 1,
      anon_sym_Set,
    STATE(4589), 1,
      sym_atom,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3690), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(6226), 2,
      sym__newline,
      anon_sym_BSLASH,
    STATE(4585), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4584), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3670), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    ACTIONS(6224), 14,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_let,
      anon_sym_do,
  [423443] = 19,
    ACTIONS(6086), 1,
      sym_id,
    ACTIONS(6090), 1,
      anon_sym_record,
    ACTIONS(6092), 1,
      anon_sym_LPAREN,
    ACTIONS(6094), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(6096), 1,
      anon_sym_u2983,
    ACTIONS(6098), 1,
      anon_sym_LBRACE,
    ACTIONS(6100), 1,
      aux_sym__qid_token1,
    ACTIONS(6102), 1,
      anon_sym_DOT,
    ACTIONS(6104), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(6106), 1,
      anon_sym_u2987,
    ACTIONS(6110), 1,
      anon_sym_Set,
    STATE(4517), 1,
      sym_atom,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6108), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(6226), 2,
      sym__newline,
      anon_sym_BSLASH,
    STATE(4522), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4523), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(6088), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    ACTIONS(6224), 14,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_let,
      anon_sym_do,
  [423532] = 19,
    ACTIONS(2978), 1,
      sym_id,
    ACTIONS(2988), 1,
      anon_sym_record,
    ACTIONS(2998), 1,
      aux_sym__qid_token1,
    ACTIONS(3006), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3008), 1,
      anon_sym_u2987,
    ACTIONS(3014), 1,
      anon_sym_Set,
    ACTIONS(4306), 1,
      anon_sym_LPAREN,
    ACTIONS(4308), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4310), 1,
      anon_sym_u2983,
    ACTIONS(4312), 1,
      anon_sym_LBRACE,
    ACTIONS(4314), 1,
      anon_sym_DOT,
    STATE(4458), 1,
      sym_atom,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3012), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(6226), 2,
      sym__newline,
      anon_sym_BSLASH,
    STATE(4469), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4463), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(2986), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    ACTIONS(6224), 14,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_let,
      anon_sym_do,
  [423621] = 19,
    ACTIONS(2174), 1,
      sym_id,
    ACTIONS(2182), 1,
      anon_sym_record,
    ACTIONS(2192), 1,
      aux_sym__qid_token1,
    ACTIONS(2198), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2200), 1,
      anon_sym_u2987,
    ACTIONS(2204), 1,
      anon_sym_Set,
    ACTIONS(4872), 1,
      anon_sym_LPAREN,
    ACTIONS(4874), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4876), 1,
      anon_sym_u2983,
    ACTIONS(4878), 1,
      anon_sym_LBRACE,
    ACTIONS(4880), 1,
      anon_sym_DOT,
    ACTIONS(6226), 1,
      anon_sym_BSLASH,
    STATE(4546), 1,
      sym_atom,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4536), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4531), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(2180), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    ACTIONS(6224), 15,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE_RBRACE,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_let,
      anon_sym_do,
  [423710] = 19,
    ACTIONS(3130), 1,
      sym_id,
    ACTIONS(3140), 1,
      anon_sym_record,
    ACTIONS(3150), 1,
      aux_sym__qid_token1,
    ACTIONS(3158), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3160), 1,
      anon_sym_u2987,
    ACTIONS(3166), 1,
      anon_sym_Set,
    ACTIONS(4368), 1,
      anon_sym_LPAREN,
    ACTIONS(4370), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4372), 1,
      anon_sym_u2983,
    ACTIONS(4374), 1,
      anon_sym_LBRACE,
    ACTIONS(4376), 1,
      anon_sym_DOT,
    STATE(4486), 1,
      sym_atom,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3164), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(6226), 2,
      sym__newline,
      anon_sym_BSLASH,
    STATE(4493), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4496), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3138), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    ACTIONS(6224), 14,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_let,
      anon_sym_do,
  [423799] = 19,
    ACTIONS(2526), 1,
      sym_id,
    ACTIONS(2538), 1,
      anon_sym_record,
    ACTIONS(2540), 1,
      anon_sym_LPAREN,
    ACTIONS(2542), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2544), 1,
      anon_sym_u2983,
    ACTIONS(2546), 1,
      anon_sym_LBRACE,
    ACTIONS(2548), 1,
      aux_sym__qid_token1,
    ACTIONS(2550), 1,
      anon_sym_DOT,
    ACTIONS(2556), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2558), 1,
      anon_sym_u2987,
    ACTIONS(2564), 1,
      anon_sym_Set,
    STATE(4502), 1,
      sym_atom,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2562), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(6226), 2,
      sym__newline,
      anon_sym_BSLASH,
    STATE(4464), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4473), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(2536), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    ACTIONS(6224), 14,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_let,
      anon_sym_do,
  [423888] = 19,
    ACTIONS(5054), 1,
      sym_id,
    ACTIONS(5058), 1,
      anon_sym_record,
    ACTIONS(5060), 1,
      anon_sym_LPAREN,
    ACTIONS(5062), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(5064), 1,
      anon_sym_u2983,
    ACTIONS(5066), 1,
      anon_sym_LBRACE,
    ACTIONS(5068), 1,
      aux_sym__qid_token1,
    ACTIONS(5070), 1,
      anon_sym_DOT,
    ACTIONS(5072), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(5074), 1,
      anon_sym_u2987,
    ACTIONS(5078), 1,
      anon_sym_Set,
    STATE(4449), 1,
      sym_atom,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(5076), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(6226), 2,
      sym__newline,
      anon_sym_BSLASH,
    STATE(4453), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4455), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(5056), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    ACTIONS(6224), 14,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_let,
      anon_sym_do,
  [423977] = 19,
    ACTIONS(3760), 1,
      sym_id,
    ACTIONS(3764), 1,
      anon_sym_record,
    ACTIONS(3774), 1,
      aux_sym__qid_token1,
    ACTIONS(3778), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3780), 1,
      anon_sym_u2987,
    ACTIONS(3784), 1,
      anon_sym_Set,
    ACTIONS(4816), 1,
      anon_sym_LPAREN,
    ACTIONS(4818), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4820), 1,
      anon_sym_u2983,
    ACTIONS(4822), 1,
      anon_sym_LBRACE,
    ACTIONS(4824), 1,
      anon_sym_DOT,
    STATE(4621), 1,
      sym_atom,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3782), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(6226), 2,
      sym__newline,
      anon_sym_BSLASH,
    STATE(4599), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4613), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3762), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    ACTIONS(6224), 14,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_let,
      anon_sym_do,
  [424066] = 19,
    ACTIONS(5468), 1,
      sym_id,
    ACTIONS(5472), 1,
      anon_sym_record,
    ACTIONS(5474), 1,
      anon_sym_LPAREN,
    ACTIONS(5476), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(5478), 1,
      anon_sym_u2983,
    ACTIONS(5480), 1,
      anon_sym_LBRACE,
    ACTIONS(5482), 1,
      aux_sym__qid_token1,
    ACTIONS(5484), 1,
      anon_sym_DOT,
    ACTIONS(5486), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(5488), 1,
      anon_sym_u2987,
    ACTIONS(5492), 1,
      anon_sym_Set,
    STATE(4537), 1,
      sym_atom,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(5490), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(6226), 2,
      sym__newline,
      anon_sym_BSLASH,
    STATE(4533), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4527), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(5470), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    ACTIONS(6224), 14,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_let,
      anon_sym_do,
  [424155] = 19,
    ACTIONS(9), 1,
      sym_id,
    ACTIONS(51), 1,
      anon_sym_LPAREN,
    ACTIONS(53), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(55), 1,
      anon_sym_u2983,
    ACTIONS(61), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      aux_sym__qid_token1,
    ACTIONS(71), 1,
      anon_sym_DOT,
    ACTIONS(79), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(81), 1,
      anon_sym_u2987,
    ACTIONS(89), 1,
      anon_sym_Set,
    ACTIONS(4280), 1,
      anon_sym_record,
    STATE(4581), 1,
      sym_atom,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(87), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(6226), 2,
      sym__newline,
      anon_sym_BSLASH,
    STATE(4564), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4608), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(17), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    ACTIONS(6224), 14,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_let,
      anon_sym_do,
  [424244] = 19,
    ACTIONS(3694), 1,
      sym_id,
    ACTIONS(3704), 1,
      anon_sym_record,
    ACTIONS(3714), 1,
      aux_sym__qid_token1,
    ACTIONS(3722), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3724), 1,
      anon_sym_u2987,
    ACTIONS(3730), 1,
      anon_sym_Set,
    ACTIONS(4774), 1,
      anon_sym_LPAREN,
    ACTIONS(4776), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4778), 1,
      anon_sym_u2983,
    ACTIONS(4780), 1,
      anon_sym_LBRACE,
    ACTIONS(4782), 1,
      anon_sym_DOT,
    STATE(4484), 1,
      sym_atom,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3728), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(6226), 2,
      sym__newline,
      anon_sym_BSLASH,
    STATE(4467), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4459), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3702), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    ACTIONS(6224), 14,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_let,
      anon_sym_do,
  [424333] = 19,
    ACTIONS(2614), 1,
      sym_id,
    ACTIONS(2624), 1,
      anon_sym_record,
    ACTIONS(2634), 1,
      aux_sym__qid_token1,
    ACTIONS(2642), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2644), 1,
      anon_sym_u2987,
    ACTIONS(2650), 1,
      anon_sym_Set,
    ACTIONS(4898), 1,
      anon_sym_LPAREN,
    ACTIONS(4900), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4902), 1,
      anon_sym_u2983,
    ACTIONS(4904), 1,
      anon_sym_LBRACE,
    ACTIONS(4906), 1,
      anon_sym_DOT,
    STATE(4804), 1,
      sym_atom,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2648), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(6226), 2,
      sym__newline,
      anon_sym_BSLASH,
    STATE(4799), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4784), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(2622), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    ACTIONS(6224), 13,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_let,
      anon_sym_do,
  [424421] = 19,
    ACTIONS(5814), 1,
      sym_id,
    ACTIONS(5818), 1,
      anon_sym_record,
    ACTIONS(5820), 1,
      anon_sym_LPAREN,
    ACTIONS(5822), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(5824), 1,
      anon_sym_u2983,
    ACTIONS(5826), 1,
      anon_sym_LBRACE,
    ACTIONS(5828), 1,
      aux_sym__qid_token1,
    ACTIONS(5830), 1,
      anon_sym_DOT,
    ACTIONS(5832), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(5834), 1,
      anon_sym_u2987,
    ACTIONS(5838), 1,
      anon_sym_Set,
    STATE(4877), 1,
      sym_atom,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(5836), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(6226), 2,
      sym__newline,
      anon_sym_BSLASH,
    STATE(4860), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4868), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(5816), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    ACTIONS(6224), 13,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_let,
      anon_sym_do,
  [424509] = 19,
    ACTIONS(5872), 1,
      sym_id,
    ACTIONS(5876), 1,
      anon_sym_record,
    ACTIONS(5878), 1,
      anon_sym_LPAREN,
    ACTIONS(5880), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(5882), 1,
      anon_sym_u2983,
    ACTIONS(5884), 1,
      anon_sym_LBRACE,
    ACTIONS(5886), 1,
      aux_sym__qid_token1,
    ACTIONS(5888), 1,
      anon_sym_DOT,
    ACTIONS(5890), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(5892), 1,
      anon_sym_u2987,
    ACTIONS(5896), 1,
      anon_sym_Set,
    STATE(4792), 1,
      sym_atom,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(5894), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(6226), 2,
      sym__newline,
      anon_sym_BSLASH,
    STATE(4787), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4785), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(5874), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    ACTIONS(6224), 13,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_let,
      anon_sym_do,
  [424597] = 19,
    ACTIONS(3326), 1,
      sym_id,
    ACTIONS(3332), 1,
      anon_sym_record,
    ACTIONS(3334), 1,
      anon_sym_LPAREN,
    ACTIONS(3336), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3338), 1,
      anon_sym_u2983,
    ACTIONS(3340), 1,
      anon_sym_LBRACE,
    ACTIONS(3342), 1,
      aux_sym__qid_token1,
    ACTIONS(3344), 1,
      anon_sym_DOT,
    ACTIONS(3346), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3348), 1,
      anon_sym_u2987,
    ACTIONS(3352), 1,
      anon_sym_Set,
    STATE(4655), 1,
      sym_atom,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3350), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(6226), 2,
      sym__newline,
      anon_sym_BSLASH,
    STATE(4650), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4649), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3330), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    ACTIONS(6224), 13,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_let,
      anon_sym_do,
  [424685] = 19,
    ACTIONS(2728), 1,
      sym_id,
    ACTIONS(2738), 1,
      anon_sym_record,
    ACTIONS(2748), 1,
      aux_sym__qid_token1,
    ACTIONS(2756), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2758), 1,
      anon_sym_u2987,
    ACTIONS(2764), 1,
      anon_sym_Set,
    ACTIONS(4762), 1,
      anon_sym_LPAREN,
    ACTIONS(4764), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4766), 1,
      anon_sym_u2983,
    ACTIONS(4768), 1,
      anon_sym_LBRACE,
    ACTIONS(4770), 1,
      anon_sym_DOT,
    STATE(4689), 1,
      sym_atom,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2762), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(6226), 2,
      sym__newline,
      anon_sym_BSLASH,
    STATE(4685), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4682), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(2736), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    ACTIONS(6224), 13,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_let,
      anon_sym_do,
  [424773] = 19,
    ACTIONS(2840), 1,
      sym_id,
    ACTIONS(2848), 1,
      anon_sym_record,
    ACTIONS(2858), 1,
      aux_sym__qid_token1,
    ACTIONS(2864), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2866), 1,
      anon_sym_u2987,
    ACTIONS(2870), 1,
      anon_sym_Set,
    ACTIONS(4464), 1,
      anon_sym_LPAREN,
    ACTIONS(4466), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4468), 1,
      anon_sym_u2983,
    ACTIONS(4470), 1,
      anon_sym_LBRACE,
    ACTIONS(4472), 1,
      anon_sym_DOT,
    ACTIONS(6226), 1,
      anon_sym_BSLASH,
    STATE(4761), 1,
      sym_atom,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2868), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4765), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4766), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(2846), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    ACTIONS(6224), 14,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_u2984,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_let,
      anon_sym_do,
  [424861] = 19,
    ACTIONS(2384), 1,
      sym_id,
    ACTIONS(2394), 1,
      anon_sym_record,
    ACTIONS(2404), 1,
      aux_sym__qid_token1,
    ACTIONS(2412), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2414), 1,
      anon_sym_u2987,
    ACTIONS(2420), 1,
      anon_sym_Set,
    ACTIONS(4570), 1,
      anon_sym_LPAREN,
    ACTIONS(4572), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4574), 1,
      anon_sym_u2983,
    ACTIONS(4576), 1,
      anon_sym_LBRACE,
    ACTIONS(4578), 1,
      anon_sym_DOT,
    STATE(4847), 1,
      sym_atom,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2418), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(6226), 2,
      sym__newline,
      anon_sym_BSLASH,
    STATE(4831), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4896), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(2392), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    ACTIONS(6224), 13,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_let,
      anon_sym_do,
  [424949] = 19,
    ACTIONS(6006), 1,
      sym_id,
    ACTIONS(6010), 1,
      anon_sym_record,
    ACTIONS(6012), 1,
      anon_sym_LPAREN,
    ACTIONS(6014), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(6016), 1,
      anon_sym_u2983,
    ACTIONS(6018), 1,
      anon_sym_LBRACE,
    ACTIONS(6020), 1,
      aux_sym__qid_token1,
    ACTIONS(6022), 1,
      anon_sym_DOT,
    ACTIONS(6024), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(6026), 1,
      anon_sym_u2987,
    ACTIONS(6030), 1,
      anon_sym_Set,
    STATE(4887), 1,
      sym_atom,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6028), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(6226), 2,
      sym__newline,
      anon_sym_BSLASH,
    STATE(4881), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4870), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(6008), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    ACTIONS(6224), 13,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_let,
      anon_sym_do,
  [425037] = 19,
    ACTIONS(3912), 1,
      sym_id,
    ACTIONS(3916), 1,
      anon_sym_record,
    ACTIONS(3926), 1,
      aux_sym__qid_token1,
    ACTIONS(3930), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3932), 1,
      anon_sym_u2987,
    ACTIONS(3936), 1,
      anon_sym_Set,
    ACTIONS(4412), 1,
      anon_sym_LPAREN,
    ACTIONS(4414), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4416), 1,
      anon_sym_u2983,
    ACTIONS(4418), 1,
      anon_sym_LBRACE,
    ACTIONS(4420), 1,
      anon_sym_DOT,
    ACTIONS(6226), 1,
      anon_sym_BSLASH,
    STATE(4711), 1,
      sym_atom,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3934), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4662), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4728), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3914), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    ACTIONS(6224), 14,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_let,
      anon_sym_do,
  [425125] = 19,
    ACTIONS(2652), 1,
      sym_id,
    ACTIONS(2662), 1,
      anon_sym_record,
    ACTIONS(2672), 1,
      aux_sym__qid_token1,
    ACTIONS(2680), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2682), 1,
      anon_sym_u2987,
    ACTIONS(2688), 1,
      anon_sym_Set,
    ACTIONS(4524), 1,
      anon_sym_LPAREN,
    ACTIONS(4526), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4528), 1,
      anon_sym_u2983,
    ACTIONS(4530), 1,
      anon_sym_LBRACE,
    ACTIONS(4532), 1,
      anon_sym_DOT,
    ACTIONS(6226), 1,
      anon_sym_BSLASH,
    STATE(4729), 1,
      sym_atom,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2686), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4732), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4735), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(2660), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    ACTIONS(6224), 14,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_let,
      anon_sym_do,
  [425213] = 19,
    ACTIONS(2206), 1,
      sym_id,
    ACTIONS(2218), 1,
      anon_sym_record,
    ACTIONS(2220), 1,
      anon_sym_LPAREN,
    ACTIONS(2222), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2224), 1,
      anon_sym_u2983,
    ACTIONS(2226), 1,
      anon_sym_LBRACE,
    ACTIONS(2228), 1,
      aux_sym__qid_token1,
    ACTIONS(2230), 1,
      anon_sym_DOT,
    ACTIONS(2236), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2238), 1,
      anon_sym_u2987,
    ACTIONS(2244), 1,
      anon_sym_Set,
    STATE(4833), 1,
      sym_atom,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2242), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(6226), 2,
      sym__newline,
      anon_sym_BSLASH,
    STATE(4812), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4858), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(2216), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    ACTIONS(6224), 13,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_let,
      anon_sym_do,
  [425301] = 19,
    ACTIONS(5332), 1,
      sym_id,
    ACTIONS(5336), 1,
      anon_sym_record,
    ACTIONS(5338), 1,
      anon_sym_LPAREN,
    ACTIONS(5340), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(5342), 1,
      anon_sym_u2983,
    ACTIONS(5344), 1,
      anon_sym_LBRACE,
    ACTIONS(5346), 1,
      aux_sym__qid_token1,
    ACTIONS(5348), 1,
      anon_sym_DOT,
    ACTIONS(5350), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(5352), 1,
      anon_sym_u2987,
    ACTIONS(5356), 1,
      anon_sym_Set,
    STATE(4852), 1,
      sym_atom,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(5354), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(6226), 2,
      sym__newline,
      anon_sym_BSLASH,
    STATE(4898), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4840), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(5334), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    ACTIONS(6224), 13,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_let,
      anon_sym_do,
  [425389] = 19,
    ACTIONS(940), 1,
      sym_id,
    ACTIONS(950), 1,
      anon_sym_record,
    ACTIONS(960), 1,
      aux_sym__qid_token1,
    ACTIONS(968), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(970), 1,
      anon_sym_u2987,
    ACTIONS(976), 1,
      anon_sym_Set,
    ACTIONS(4580), 1,
      anon_sym_LPAREN,
    ACTIONS(4582), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4584), 1,
      anon_sym_u2983,
    ACTIONS(4586), 1,
      anon_sym_LBRACE,
    ACTIONS(4588), 1,
      anon_sym_DOT,
    ACTIONS(6226), 1,
      anon_sym_BSLASH,
    STATE(4747), 1,
      sym_atom,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(974), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4733), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4742), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(948), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    ACTIONS(6224), 14,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_RBRACE_RBRACE,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_let,
      anon_sym_do,
  [425477] = 19,
    ACTIONS(3852), 1,
      sym_id,
    ACTIONS(3856), 1,
      anon_sym_record,
    ACTIONS(3866), 1,
      aux_sym__qid_token1,
    ACTIONS(3870), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3872), 1,
      anon_sym_u2987,
    ACTIONS(3876), 1,
      anon_sym_Set,
    ACTIONS(4724), 1,
      anon_sym_LPAREN,
    ACTIONS(4726), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4728), 1,
      anon_sym_u2983,
    ACTIONS(4730), 1,
      anon_sym_LBRACE,
    ACTIONS(4732), 1,
      anon_sym_DOT,
    STATE(4639), 1,
      sym_atom,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3874), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(6226), 2,
      sym__newline,
      anon_sym_BSLASH,
    STATE(4642), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4643), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3854), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    ACTIONS(6224), 13,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_let,
      anon_sym_do,
  [425565] = 19,
    ACTIONS(3168), 1,
      sym_id,
    ACTIONS(3180), 1,
      anon_sym_record,
    ACTIONS(3182), 1,
      anon_sym_LPAREN,
    ACTIONS(3184), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3186), 1,
      anon_sym_u2983,
    ACTIONS(3188), 1,
      anon_sym_LBRACE,
    ACTIONS(3190), 1,
      aux_sym__qid_token1,
    ACTIONS(3192), 1,
      anon_sym_DOT,
    ACTIONS(3198), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3200), 1,
      anon_sym_u2987,
    ACTIONS(3206), 1,
      anon_sym_Set,
    STATE(4941), 1,
      sym_atom,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3204), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(6226), 2,
      sym__newline,
      anon_sym_BSLASH,
    STATE(4934), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4921), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3178), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    ACTIONS(6224), 12,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_let,
      anon_sym_do,
  [425652] = 19,
    ACTIONS(734), 1,
      sym_id,
    ACTIONS(744), 1,
      anon_sym_record,
    ACTIONS(754), 1,
      aux_sym__qid_token1,
    ACTIONS(766), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(768), 1,
      anon_sym_u2987,
    ACTIONS(774), 1,
      anon_sym_Set,
    ACTIONS(4228), 1,
      anon_sym_LPAREN,
    ACTIONS(4230), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4232), 1,
      anon_sym_u2983,
    ACTIONS(4234), 1,
      anon_sym_LBRACE,
    ACTIONS(4236), 1,
      anon_sym_DOT,
    STATE(5096), 1,
      sym_atom,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(772), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(6226), 2,
      sym__newline,
      anon_sym_BSLASH,
    STATE(5108), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5102), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(742), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    ACTIONS(6224), 12,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_let,
      anon_sym_do,
  [425739] = 19,
    ACTIONS(2298), 1,
      sym_id,
    ACTIONS(2308), 1,
      anon_sym_record,
    ACTIONS(2318), 1,
      aux_sym__qid_token1,
    ACTIONS(2326), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2328), 1,
      anon_sym_u2987,
    ACTIONS(2334), 1,
      anon_sym_Set,
    ACTIONS(4482), 1,
      anon_sym_LPAREN,
    ACTIONS(4484), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4486), 1,
      anon_sym_u2983,
    ACTIONS(4488), 1,
      anon_sym_LBRACE,
    ACTIONS(4490), 1,
      anon_sym_DOT,
    ACTIONS(6226), 1,
      anon_sym_BSLASH,
    STATE(5281), 1,
      sym_atom,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2332), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5354), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5347), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(2306), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    ACTIONS(6224), 13,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_u2984,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_let,
      anon_sym_do,
  [425826] = 19,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1196), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(4540), 1,
      anon_sym_LPAREN,
    ACTIONS(4542), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4544), 1,
      anon_sym_u2983,
    ACTIONS(4546), 1,
      anon_sym_LBRACE,
    ACTIONS(4548), 1,
      anon_sym_DOT,
    ACTIONS(6226), 1,
      anon_sym_BSLASH,
    STATE(5238), 1,
      sym_atom,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(1174), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    ACTIONS(6224), 13,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_RBRACE_RBRACE,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_let,
      anon_sym_do,
  [425913] = 19,
    ACTIONS(706), 1,
      aux_sym__qid_token1,
    ACTIONS(3554), 1,
      sym_id,
    ACTIONS(3562), 1,
      anon_sym_record,
    ACTIONS(3564), 1,
      anon_sym_LPAREN,
    ACTIONS(3566), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3568), 1,
      anon_sym_u2983,
    ACTIONS(3570), 1,
      anon_sym_LBRACE,
    ACTIONS(3572), 1,
      anon_sym_DOT,
    ACTIONS(3576), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3578), 1,
      anon_sym_u2987,
    ACTIONS(3582), 1,
      anon_sym_Set,
    ACTIONS(6226), 1,
      anon_sym_BSLASH,
    STATE(5084), 1,
      sym_atom,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3580), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5081), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5079), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3560), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    ACTIONS(6224), 13,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_let,
      anon_sym_do,
  [426000] = 19,
    ACTIONS(6166), 1,
      sym_id,
    ACTIONS(6170), 1,
      anon_sym_record,
    ACTIONS(6172), 1,
      anon_sym_LPAREN,
    ACTIONS(6174), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(6176), 1,
      anon_sym_u2983,
    ACTIONS(6178), 1,
      anon_sym_LBRACE,
    ACTIONS(6180), 1,
      aux_sym__qid_token1,
    ACTIONS(6182), 1,
      anon_sym_DOT,
    ACTIONS(6184), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(6186), 1,
      anon_sym_u2987,
    ACTIONS(6190), 1,
      anon_sym_Set,
    STATE(4954), 1,
      sym_atom,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6188), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(6226), 2,
      sym__newline,
      anon_sym_BSLASH,
    STATE(4960), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4966), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(6168), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    ACTIONS(6224), 12,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_let,
      anon_sym_do,
  [426087] = 19,
    ACTIONS(6138), 1,
      sym_id,
    ACTIONS(6142), 1,
      anon_sym_record,
    ACTIONS(6144), 1,
      anon_sym_LPAREN,
    ACTIONS(6146), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(6148), 1,
      anon_sym_u2983,
    ACTIONS(6150), 1,
      anon_sym_LBRACE,
    ACTIONS(6152), 1,
      aux_sym__qid_token1,
    ACTIONS(6154), 1,
      anon_sym_DOT,
    ACTIONS(6156), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(6158), 1,
      anon_sym_u2987,
    ACTIONS(6162), 1,
      anon_sym_Set,
    STATE(5125), 1,
      sym_atom,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6160), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(6226), 2,
      sym__newline,
      anon_sym_BSLASH,
    STATE(5132), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5134), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(6140), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    ACTIONS(6224), 12,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_let,
      anon_sym_do,
  [426174] = 19,
    ACTIONS(3016), 1,
      sym_id,
    ACTIONS(3026), 1,
      anon_sym_record,
    ACTIONS(3036), 1,
      aux_sym__qid_token1,
    ACTIONS(3044), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3046), 1,
      anon_sym_u2987,
    ACTIONS(3052), 1,
      anon_sym_Set,
    ACTIONS(4606), 1,
      anon_sym_LPAREN,
    ACTIONS(4608), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4610), 1,
      anon_sym_u2983,
    ACTIONS(4612), 1,
      anon_sym_LBRACE,
    ACTIONS(4614), 1,
      anon_sym_DOT,
    ACTIONS(6226), 1,
      anon_sym_BSLASH,
    STATE(5327), 1,
      sym_atom,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3050), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5330), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5333), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3024), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    ACTIONS(6224), 13,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_let,
      anon_sym_do,
  [426261] = 19,
    ACTIONS(1916), 1,
      anon_sym_record,
    ACTIONS(1918), 1,
      anon_sym_LPAREN,
    ACTIONS(1920), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1922), 1,
      anon_sym_u2983,
    ACTIONS(1924), 1,
      anon_sym_LBRACE,
    ACTIONS(1932), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1934), 1,
      anon_sym_u2987,
    ACTIONS(2606), 1,
      sym_id,
    ACTIONS(2608), 1,
      aux_sym__qid_token1,
    ACTIONS(2610), 1,
      anon_sym_DOT,
    ACTIONS(2612), 1,
      anon_sym_Set,
    ACTIONS(6226), 1,
      anon_sym_BSLASH,
    STATE(4672), 1,
      sym_atom,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1938), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4675), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4679), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(1914), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    ACTIONS(6224), 13,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE_RBRACE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_let,
      anon_sym_do,
  [426348] = 19,
    ACTIONS(3380), 1,
      sym_id,
    ACTIONS(3384), 1,
      anon_sym_record,
    ACTIONS(3386), 1,
      anon_sym_LPAREN,
    ACTIONS(3388), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3390), 1,
      anon_sym_u2983,
    ACTIONS(3392), 1,
      anon_sym_LBRACE,
    ACTIONS(3394), 1,
      aux_sym__qid_token1,
    ACTIONS(3396), 1,
      anon_sym_DOT,
    ACTIONS(3398), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3400), 1,
      anon_sym_u2987,
    ACTIONS(3404), 1,
      anon_sym_Set,
    ACTIONS(6226), 1,
      anon_sym_BSLASH,
    STATE(4933), 1,
      sym_atom,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3402), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4937), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4939), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3382), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    ACTIONS(6224), 13,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE_RBRACE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_let,
      anon_sym_do,
  [426435] = 19,
    ACTIONS(5788), 1,
      sym_id,
    ACTIONS(5792), 1,
      anon_sym_record,
    ACTIONS(5794), 1,
      anon_sym_LPAREN,
    ACTIONS(5796), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(5798), 1,
      anon_sym_u2983,
    ACTIONS(5800), 1,
      anon_sym_LBRACE,
    ACTIONS(5802), 1,
      aux_sym__qid_token1,
    ACTIONS(5804), 1,
      anon_sym_DOT,
    ACTIONS(5806), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(5808), 1,
      anon_sym_u2987,
    ACTIONS(5812), 1,
      anon_sym_Set,
    STATE(5256), 1,
      sym_atom,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(5810), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(6226), 2,
      sym__newline,
      anon_sym_BSLASH,
    STATE(5245), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5235), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(5790), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    ACTIONS(6224), 12,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_let,
      anon_sym_do,
  [426522] = 19,
    ACTIONS(692), 1,
      anon_sym_record,
    ACTIONS(694), 1,
      anon_sym_LPAREN,
    ACTIONS(696), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(698), 1,
      anon_sym_u2983,
    ACTIONS(702), 1,
      anon_sym_LBRACE,
    ACTIONS(708), 1,
      anon_sym_DOT,
    ACTIONS(718), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(720), 1,
      anon_sym_u2987,
    ACTIONS(728), 1,
      anon_sym_Set,
    ACTIONS(2336), 1,
      sym_id,
    ACTIONS(2342), 1,
      aux_sym__qid_token1,
    ACTIONS(6226), 1,
      anon_sym_BSLASH,
    STATE(5049), 1,
      sym_atom,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(726), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5069), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5056), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(690), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    ACTIONS(6224), 13,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_let,
      anon_sym_do,
  [426609] = 19,
    ACTIONS(3610), 1,
      sym_id,
    ACTIONS(3616), 1,
      anon_sym_record,
    ACTIONS(3618), 1,
      anon_sym_LPAREN,
    ACTIONS(3620), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3622), 1,
      anon_sym_u2983,
    ACTIONS(3624), 1,
      anon_sym_LBRACE,
    ACTIONS(3626), 1,
      aux_sym__qid_token1,
    ACTIONS(3628), 1,
      anon_sym_DOT,
    ACTIONS(3630), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3632), 1,
      anon_sym_u2987,
    ACTIONS(3636), 1,
      anon_sym_Set,
    STATE(5270), 1,
      sym_atom,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3634), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(6226), 2,
      sym__newline,
      anon_sym_BSLASH,
    STATE(5254), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5242), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3614), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    ACTIONS(6224), 12,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_let,
      anon_sym_do,
  [426696] = 19,
    ACTIONS(894), 1,
      sym_id,
    ACTIONS(904), 1,
      anon_sym_record,
    ACTIONS(916), 1,
      aux_sym__qid_token1,
    ACTIONS(924), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(926), 1,
      anon_sym_u2987,
    ACTIONS(932), 1,
      anon_sym_Set,
    ACTIONS(4320), 1,
      anon_sym_LPAREN,
    ACTIONS(4322), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4324), 1,
      anon_sym_u2983,
    ACTIONS(4326), 1,
      anon_sym_LBRACE,
    ACTIONS(4328), 1,
      anon_sym_DOT,
    ACTIONS(6226), 1,
      anon_sym_BSLASH,
    STATE(4976), 1,
      sym_atom,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(930), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4961), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4920), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(902), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    ACTIONS(6224), 13,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_let,
      anon_sym_do,
  [426783] = 19,
    ACTIONS(850), 1,
      sym_id,
    ACTIONS(860), 1,
      anon_sym_record,
    ACTIONS(872), 1,
      aux_sym__qid_token1,
    ACTIONS(882), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(884), 1,
      anon_sym_u2987,
    ACTIONS(892), 1,
      anon_sym_Set,
    ACTIONS(4290), 1,
      anon_sym_LPAREN,
    ACTIONS(4292), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4294), 1,
      anon_sym_u2983,
    ACTIONS(4296), 1,
      anon_sym_LBRACE,
    ACTIONS(4298), 1,
      anon_sym_DOT,
    ACTIONS(6226), 1,
      anon_sym_BSLASH,
    STATE(5160), 1,
      sym_atom,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(890), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5180), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5168), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(858), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    ACTIONS(6224), 13,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_u2984,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_let,
      anon_sym_do,
  [426870] = 19,
    ACTIONS(1980), 1,
      sym_id,
    ACTIONS(1990), 1,
      anon_sym_record,
    ACTIONS(2000), 1,
      aux_sym__qid_token1,
    ACTIONS(2008), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2010), 1,
      anon_sym_u2987,
    ACTIONS(2016), 1,
      anon_sym_Set,
    ACTIONS(4386), 1,
      anon_sym_LPAREN,
    ACTIONS(4388), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4390), 1,
      anon_sym_u2983,
    ACTIONS(4392), 1,
      anon_sym_LBRACE,
    ACTIONS(4394), 1,
      anon_sym_DOT,
    ACTIONS(6226), 1,
      anon_sym_BSLASH,
    STATE(5339), 1,
      sym_atom,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2014), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5336), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5185), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(1988), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    ACTIONS(6224), 13,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE_RBRACE,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_let,
      anon_sym_do,
  [426957] = 19,
    ACTIONS(5360), 1,
      sym_id,
    ACTIONS(5364), 1,
      anon_sym_record,
    ACTIONS(5366), 1,
      anon_sym_LPAREN,
    ACTIONS(5368), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(5370), 1,
      anon_sym_u2983,
    ACTIONS(5372), 1,
      anon_sym_LBRACE,
    ACTIONS(5374), 1,
      aux_sym__qid_token1,
    ACTIONS(5376), 1,
      anon_sym_DOT,
    ACTIONS(5378), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(5380), 1,
      anon_sym_u2987,
    ACTIONS(5384), 1,
      anon_sym_Set,
    STATE(5035), 1,
      sym_atom,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(5382), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(6226), 2,
      sym__newline,
      anon_sym_BSLASH,
    STATE(5038), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4980), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(5362), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    ACTIONS(6224), 12,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_let,
      anon_sym_do,
  [427044] = 19,
    ACTIONS(2018), 1,
      sym_id,
    ACTIONS(2028), 1,
      anon_sym_record,
    ACTIONS(2038), 1,
      aux_sym__qid_token1,
    ACTIONS(2046), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2048), 1,
      anon_sym_u2987,
    ACTIONS(2054), 1,
      anon_sym_Set,
    ACTIONS(4706), 1,
      anon_sym_LPAREN,
    ACTIONS(4708), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4710), 1,
      anon_sym_u2983,
    ACTIONS(4712), 1,
      anon_sym_LBRACE,
    ACTIONS(4714), 1,
      anon_sym_DOT,
    ACTIONS(6226), 1,
      anon_sym_BSLASH,
    STATE(5173), 1,
      sym_atom,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2052), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5176), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5183), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(2026), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    ACTIONS(6224), 13,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_PIPE_RPAREN,
      anon_sym_let,
      anon_sym_do,
  [427131] = 19,
    ACTIONS(2272), 1,
      sym_id,
    ACTIONS(2276), 1,
      anon_sym_record,
    ACTIONS(2286), 1,
      aux_sym__qid_token1,
    ACTIONS(2290), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2292), 1,
      anon_sym_u2987,
    ACTIONS(2296), 1,
      anon_sym_Set,
    ACTIONS(4800), 1,
      anon_sym_LPAREN,
    ACTIONS(4802), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4804), 1,
      anon_sym_u2983,
    ACTIONS(4806), 1,
      anon_sym_LBRACE,
    ACTIONS(4808), 1,
      anon_sym_DOT,
    ACTIONS(6226), 1,
      anon_sym_BSLASH,
    STATE(5133), 1,
      sym_atom,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2294), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5139), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5053), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(2274), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    ACTIONS(6224), 13,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_u2988,
      anon_sym_let,
      anon_sym_do,
  [427218] = 19,
    ACTIONS(706), 1,
      aux_sym__qid_token1,
    ACTIONS(1904), 1,
      sym_id,
    ACTIONS(1916), 1,
      anon_sym_record,
    ACTIONS(1918), 1,
      anon_sym_LPAREN,
    ACTIONS(1920), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(1922), 1,
      anon_sym_u2983,
    ACTIONS(1924), 1,
      anon_sym_LBRACE,
    ACTIONS(1926), 1,
      anon_sym_DOT,
    ACTIONS(1932), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1934), 1,
      anon_sym_u2987,
    ACTIONS(1940), 1,
      anon_sym_Set,
    ACTIONS(6226), 1,
      anon_sym_BSLASH,
    STATE(4672), 1,
      sym_atom,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1938), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4675), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4679), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(1914), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    ACTIONS(6224), 13,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_let,
      anon_sym_do,
  [427305] = 19,
    ACTIONS(2872), 1,
      sym_id,
    ACTIONS(2876), 1,
      anon_sym_record,
    ACTIONS(2878), 1,
      anon_sym_LPAREN,
    ACTIONS(2880), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2882), 1,
      anon_sym_u2983,
    ACTIONS(2884), 1,
      anon_sym_LBRACE,
    ACTIONS(2886), 1,
      aux_sym__qid_token1,
    ACTIONS(2888), 1,
      anon_sym_DOT,
    ACTIONS(2890), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2892), 1,
      anon_sym_u2987,
    ACTIONS(2896), 1,
      anon_sym_Set,
    ACTIONS(6226), 1,
      anon_sym_BSLASH,
    STATE(5296), 1,
      sym_atom,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2894), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5291), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5287), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(2874), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    ACTIONS(6224), 13,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_u2984,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_let,
      anon_sym_do,
  [427392] = 19,
    ACTIONS(3938), 1,
      sym_id,
    ACTIONS(3942), 1,
      anon_sym_record,
    ACTIONS(3952), 1,
      aux_sym__qid_token1,
    ACTIONS(3956), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3958), 1,
      anon_sym_u2987,
    ACTIONS(3962), 1,
      anon_sym_Set,
    ACTIONS(4620), 1,
      anon_sym_LPAREN,
    ACTIONS(4622), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4624), 1,
      anon_sym_u2983,
    ACTIONS(4626), 1,
      anon_sym_LBRACE,
    ACTIONS(4628), 1,
      anon_sym_DOT,
    STATE(5208), 1,
      sym_atom,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3960), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(6226), 2,
      sym__newline,
      anon_sym_BSLASH,
    STATE(5203), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5201), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3940), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    ACTIONS(6224), 12,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_let,
      anon_sym_do,
  [427479] = 19,
    ACTIONS(3444), 1,
      sym_id,
    ACTIONS(3454), 1,
      anon_sym_record,
    ACTIONS(3464), 1,
      aux_sym__qid_token1,
    ACTIONS(3472), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3474), 1,
      anon_sym_u2987,
    ACTIONS(3480), 1,
      anon_sym_Set,
    ACTIONS(4842), 1,
      anon_sym_LPAREN,
    ACTIONS(4844), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4846), 1,
      anon_sym_u2983,
    ACTIONS(4848), 1,
      anon_sym_LBRACE,
    ACTIONS(4850), 1,
      anon_sym_DOT,
    STATE(5017), 1,
      sym_atom,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3478), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(6226), 2,
      sym__newline,
      anon_sym_BSLASH,
    STATE(5013), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5000), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3452), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    ACTIONS(6224), 12,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_let,
      anon_sym_do,
  [427566] = 19,
    ACTIONS(5522), 1,
      sym_id,
    ACTIONS(5526), 1,
      anon_sym_record,
    ACTIONS(5528), 1,
      anon_sym_LPAREN,
    ACTIONS(5530), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(5532), 1,
      anon_sym_u2983,
    ACTIONS(5534), 1,
      anon_sym_LBRACE,
    ACTIONS(5536), 1,
      aux_sym__qid_token1,
    ACTIONS(5538), 1,
      anon_sym_DOT,
    ACTIONS(5540), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(5542), 1,
      anon_sym_u2987,
    ACTIONS(5546), 1,
      anon_sym_Set,
    ACTIONS(6226), 1,
      anon_sym_BSLASH,
    STATE(5315), 1,
      sym_atom,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(5544), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5318), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5319), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(5524), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    ACTIONS(6224), 13,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE_RBRACE,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_let,
      anon_sym_do,
  [427653] = 19,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1234), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1242), 1,
      anon_sym_Set,
    ACTIONS(4908), 1,
      anon_sym_LPAREN,
    ACTIONS(4910), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4912), 1,
      anon_sym_u2983,
    ACTIONS(4914), 1,
      anon_sym_LBRACE,
    ACTIONS(4916), 1,
      anon_sym_DOT,
    ACTIONS(6226), 1,
      anon_sym_BSLASH,
    STATE(5657), 1,
      sym_atom,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1240), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(1214), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    ACTIONS(6224), 12,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_let,
      anon_sym_do,
  [427739] = 19,
    ACTIONS(2134), 1,
      sym_id,
    ACTIONS(2146), 1,
      anon_sym_record,
    ACTIONS(2148), 1,
      anon_sym_LPAREN,
    ACTIONS(2150), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2152), 1,
      anon_sym_u2983,
    ACTIONS(2154), 1,
      anon_sym_LBRACE,
    ACTIONS(2156), 1,
      aux_sym__qid_token1,
    ACTIONS(2158), 1,
      anon_sym_DOT,
    ACTIONS(2164), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2166), 1,
      anon_sym_u2987,
    ACTIONS(2172), 1,
      anon_sym_Set,
    ACTIONS(6226), 1,
      anon_sym_BSLASH,
    STATE(5620), 1,
      sym_atom,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2170), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5624), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5627), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(2144), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    ACTIONS(6224), 12,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_u2988,
      anon_sym_let,
      anon_sym_do,
  [427825] = 19,
    ACTIONS(5416), 1,
      sym_id,
    ACTIONS(5420), 1,
      anon_sym_record,
    ACTIONS(5422), 1,
      anon_sym_LPAREN,
    ACTIONS(5424), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(5426), 1,
      anon_sym_u2983,
    ACTIONS(5428), 1,
      anon_sym_LBRACE,
    ACTIONS(5430), 1,
      aux_sym__qid_token1,
    ACTIONS(5432), 1,
      anon_sym_DOT,
    ACTIONS(5434), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(5436), 1,
      anon_sym_u2987,
    ACTIONS(5440), 1,
      anon_sym_Set,
    ACTIONS(6226), 1,
      anon_sym_BSLASH,
    STATE(5380), 1,
      sym_atom,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(5438), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5369), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5364), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(5418), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    ACTIONS(6224), 12,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_RBRACE_RBRACE,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_let,
      anon_sym_do,
  [427911] = 19,
    ACTIONS(5926), 1,
      sym_id,
    ACTIONS(5930), 1,
      anon_sym_record,
    ACTIONS(5932), 1,
      anon_sym_LPAREN,
    ACTIONS(5934), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(5936), 1,
      anon_sym_u2983,
    ACTIONS(5938), 1,
      anon_sym_LBRACE,
    ACTIONS(5940), 1,
      aux_sym__qid_token1,
    ACTIONS(5942), 1,
      anon_sym_DOT,
    ACTIONS(5944), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(5946), 1,
      anon_sym_u2987,
    ACTIONS(5950), 1,
      anon_sym_Set,
    STATE(5475), 1,
      sym_atom,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(5948), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(6226), 2,
      sym__newline,
      anon_sym_BSLASH,
    STATE(5470), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5454), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(5928), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    ACTIONS(6224), 11,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_let,
      anon_sym_do,
  [427997] = 19,
    ACTIONS(2094), 1,
      sym_id,
    ACTIONS(2106), 1,
      anon_sym_record,
    ACTIONS(2108), 1,
      anon_sym_LPAREN,
    ACTIONS(2110), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2112), 1,
      anon_sym_u2983,
    ACTIONS(2114), 1,
      anon_sym_LBRACE,
    ACTIONS(2116), 1,
      aux_sym__qid_token1,
    ACTIONS(2118), 1,
      anon_sym_DOT,
    ACTIONS(2124), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2126), 1,
      anon_sym_u2987,
    ACTIONS(2132), 1,
      anon_sym_Set,
    ACTIONS(6226), 1,
      anon_sym_BSLASH,
    STATE(5448), 1,
      sym_atom,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2130), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5451), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5453), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(2104), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    ACTIONS(6224), 12,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE_RBRACE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_let,
      anon_sym_do,
  [428083] = 19,
    ACTIONS(2422), 1,
      sym_id,
    ACTIONS(2434), 1,
      anon_sym_record,
    ACTIONS(2436), 1,
      anon_sym_LPAREN,
    ACTIONS(2438), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2440), 1,
      anon_sym_u2983,
    ACTIONS(2442), 1,
      anon_sym_LBRACE,
    ACTIONS(2444), 1,
      aux_sym__qid_token1,
    ACTIONS(2446), 1,
      anon_sym_DOT,
    ACTIONS(2452), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2454), 1,
      anon_sym_u2987,
    ACTIONS(2460), 1,
      anon_sym_Set,
    ACTIONS(6226), 1,
      anon_sym_BSLASH,
    STATE(5417), 1,
      sym_atom,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2458), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5422), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5423), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(2432), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    ACTIONS(6224), 12,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_u2984,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_let,
      anon_sym_do,
  [428169] = 19,
    ACTIONS(3520), 1,
      sym_id,
    ACTIONS(3528), 1,
      anon_sym_record,
    ACTIONS(3530), 1,
      anon_sym_LPAREN,
    ACTIONS(3532), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3534), 1,
      anon_sym_u2983,
    ACTIONS(3536), 1,
      anon_sym_LBRACE,
    ACTIONS(3538), 1,
      aux_sym__qid_token1,
    ACTIONS(3540), 1,
      anon_sym_DOT,
    ACTIONS(3544), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3546), 1,
      anon_sym_u2987,
    ACTIONS(3550), 1,
      anon_sym_Set,
    STATE(5529), 1,
      sym_atom,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3548), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(6226), 2,
      sym__newline,
      anon_sym_BSLASH,
    STATE(5537), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5538), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3526), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    ACTIONS(6224), 11,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_let,
      anon_sym_do,
  [428255] = 19,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1274), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1282), 1,
      anon_sym_Set,
    ACTIONS(4396), 1,
      anon_sym_LPAREN,
    ACTIONS(4398), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4400), 1,
      anon_sym_u2983,
    ACTIONS(4402), 1,
      anon_sym_LBRACE,
    ACTIONS(4404), 1,
      anon_sym_DOT,
    ACTIONS(6226), 1,
      anon_sym_BSLASH,
    STATE(5447), 1,
      sym_atom,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1280), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(1252), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    ACTIONS(6224), 12,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_EQ,
      anon_sym_u2984,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_let,
      anon_sym_do,
  [428341] = 19,
    ACTIONS(5028), 1,
      sym_id,
    ACTIONS(5032), 1,
      anon_sym_record,
    ACTIONS(5034), 1,
      anon_sym_LPAREN,
    ACTIONS(5036), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(5038), 1,
      anon_sym_u2983,
    ACTIONS(5040), 1,
      anon_sym_LBRACE,
    ACTIONS(5042), 1,
      aux_sym__qid_token1,
    ACTIONS(5044), 1,
      anon_sym_DOT,
    ACTIONS(5046), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(5048), 1,
      anon_sym_u2987,
    ACTIONS(5052), 1,
      anon_sym_Set,
    ACTIONS(6226), 1,
      anon_sym_BSLASH,
    STATE(5398), 1,
      sym_atom,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(5050), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5401), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5405), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(5030), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    ACTIONS(6224), 12,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_let,
      anon_sym_do,
  [428427] = 19,
    ACTIONS(3234), 1,
      sym_id,
    ACTIONS(3240), 1,
      anon_sym_record,
    ACTIONS(3242), 1,
      anon_sym_LPAREN,
    ACTIONS(3244), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3246), 1,
      anon_sym_u2983,
    ACTIONS(3248), 1,
      anon_sym_LBRACE,
    ACTIONS(3250), 1,
      aux_sym__qid_token1,
    ACTIONS(3252), 1,
      anon_sym_DOT,
    ACTIONS(3254), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3256), 1,
      anon_sym_u2987,
    ACTIONS(3260), 1,
      anon_sym_Set,
    ACTIONS(6226), 1,
      anon_sym_BSLASH,
    STATE(5361), 1,
      sym_atom,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3258), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5387), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5375), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3238), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    ACTIONS(6224), 12,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_let,
      anon_sym_do,
  [428513] = 19,
    ACTIONS(3638), 1,
      sym_id,
    ACTIONS(3644), 1,
      anon_sym_record,
    ACTIONS(3646), 1,
      anon_sym_LPAREN,
    ACTIONS(3648), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3650), 1,
      anon_sym_u2983,
    ACTIONS(3652), 1,
      anon_sym_LBRACE,
    ACTIONS(3654), 1,
      aux_sym__qid_token1,
    ACTIONS(3656), 1,
      anon_sym_DOT,
    ACTIONS(3658), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3660), 1,
      anon_sym_u2987,
    ACTIONS(3664), 1,
      anon_sym_Set,
    ACTIONS(6226), 1,
      anon_sym_BSLASH,
    STATE(5678), 1,
      sym_atom,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3662), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5680), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5681), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3642), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    ACTIONS(6224), 12,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_u2984,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_let,
      anon_sym_do,
  [428599] = 19,
    ACTIONS(5630), 1,
      sym_id,
    ACTIONS(5634), 1,
      anon_sym_record,
    ACTIONS(5636), 1,
      anon_sym_LPAREN,
    ACTIONS(5638), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(5640), 1,
      anon_sym_u2983,
    ACTIONS(5642), 1,
      anon_sym_LBRACE,
    ACTIONS(5644), 1,
      aux_sym__qid_token1,
    ACTIONS(5646), 1,
      anon_sym_DOT,
    ACTIONS(5648), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(5650), 1,
      anon_sym_u2987,
    ACTIONS(5654), 1,
      anon_sym_Set,
    STATE(5728), 1,
      sym_atom,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(5652), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(6226), 2,
      sym__newline,
      anon_sym_BSLASH,
    STATE(5733), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5727), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(5632), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    ACTIONS(6224), 11,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_let,
      anon_sym_do,
  [428685] = 19,
    ACTIONS(5082), 1,
      sym_id,
    ACTIONS(5086), 1,
      anon_sym_record,
    ACTIONS(5088), 1,
      anon_sym_LPAREN,
    ACTIONS(5090), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(5092), 1,
      anon_sym_u2983,
    ACTIONS(5094), 1,
      anon_sym_LBRACE,
    ACTIONS(5096), 1,
      aux_sym__qid_token1,
    ACTIONS(5098), 1,
      anon_sym_DOT,
    ACTIONS(5100), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(5102), 1,
      anon_sym_u2987,
    ACTIONS(5106), 1,
      anon_sym_Set,
    STATE(5580), 1,
      sym_atom,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(5104), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(6226), 2,
      sym__newline,
      anon_sym_BSLASH,
    STATE(5584), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5587), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(5084), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    ACTIONS(6224), 11,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_let,
      anon_sym_do,
  [428771] = 19,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1978), 1,
      anon_sym_Set,
    ACTIONS(4424), 1,
      anon_sym_LPAREN,
    ACTIONS(4426), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4428), 1,
      anon_sym_u2983,
    ACTIONS(4430), 1,
      anon_sym_LBRACE,
    ACTIONS(4432), 1,
      anon_sym_DOT,
    ACTIONS(6226), 1,
      anon_sym_BSLASH,
    STATE(5495), 1,
      sym_atom,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(1976), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(1950), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    ACTIONS(6224), 12,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_PIPE_RPAREN,
      anon_sym_let,
      anon_sym_do,
  [428857] = 19,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2084), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2092), 1,
      anon_sym_Set,
    ACTIONS(4830), 1,
      anon_sym_LPAREN,
    ACTIONS(4832), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4834), 1,
      anon_sym_u2983,
    ACTIONS(4836), 1,
      anon_sym_LBRACE,
    ACTIONS(4838), 1,
      anon_sym_DOT,
    ACTIONS(6226), 1,
      anon_sym_BSLASH,
    STATE(5507), 1,
      sym_atom,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2090), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(2064), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    ACTIONS(6224), 12,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_u2988,
      anon_sym_let,
      anon_sym_do,
  [428943] = 19,
    ACTIONS(2766), 1,
      sym_id,
    ACTIONS(2772), 1,
      anon_sym_record,
    ACTIONS(2774), 1,
      anon_sym_LPAREN,
    ACTIONS(2776), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2778), 1,
      anon_sym_u2983,
    ACTIONS(2780), 1,
      anon_sym_LBRACE,
    ACTIONS(2782), 1,
      aux_sym__qid_token1,
    ACTIONS(2784), 1,
      anon_sym_DOT,
    ACTIONS(2786), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2788), 1,
      anon_sym_u2987,
    ACTIONS(2792), 1,
      anon_sym_Set,
    ACTIONS(6226), 1,
      anon_sym_BSLASH,
    STATE(5645), 1,
      sym_atom,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2790), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5666), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5668), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(2770), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    ACTIONS(6224), 12,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_PIPE_RPAREN,
      anon_sym_let,
      anon_sym_do,
  [429029] = 19,
    ACTIONS(5708), 1,
      sym_id,
    ACTIONS(5712), 1,
      anon_sym_record,
    ACTIONS(5714), 1,
      anon_sym_LPAREN,
    ACTIONS(5716), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(5718), 1,
      anon_sym_u2983,
    ACTIONS(5720), 1,
      anon_sym_LBRACE,
    ACTIONS(5722), 1,
      aux_sym__qid_token1,
    ACTIONS(5724), 1,
      anon_sym_DOT,
    ACTIONS(5726), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(5728), 1,
      anon_sym_u2987,
    ACTIONS(5732), 1,
      anon_sym_Set,
    ACTIONS(6226), 1,
      anon_sym_BSLASH,
    STATE(5558), 1,
      sym_atom,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(5730), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5553), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5550), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(5710), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    ACTIONS(6224), 12,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_let,
      anon_sym_do,
  [429115] = 19,
    ACTIONS(5246), 1,
      sym_id,
    ACTIONS(5250), 1,
      anon_sym_record,
    ACTIONS(5252), 1,
      anon_sym_LPAREN,
    ACTIONS(5254), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(5256), 1,
      anon_sym_u2983,
    ACTIONS(5258), 1,
      anon_sym_LBRACE,
    ACTIONS(5260), 1,
      aux_sym__qid_token1,
    ACTIONS(5262), 1,
      anon_sym_DOT,
    ACTIONS(5264), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(5266), 1,
      anon_sym_u2987,
    ACTIONS(5270), 1,
      anon_sym_Set,
    ACTIONS(6226), 1,
      anon_sym_BSLASH,
    STATE(5462), 1,
      sym_atom,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(5268), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5466), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5472), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(5248), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    ACTIONS(6224), 12,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_let,
      anon_sym_do,
  [429201] = 19,
    ACTIONS(2566), 1,
      sym_id,
    ACTIONS(2576), 1,
      anon_sym_record,
    ACTIONS(2586), 1,
      aux_sym__qid_token1,
    ACTIONS(2594), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2596), 1,
      anon_sym_u2987,
    ACTIONS(2602), 1,
      anon_sym_Set,
    ACTIONS(4594), 1,
      anon_sym_LPAREN,
    ACTIONS(4596), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4598), 1,
      anon_sym_u2983,
    ACTIONS(4600), 1,
      anon_sym_LBRACE,
    ACTIONS(4602), 1,
      anon_sym_DOT,
    STATE(5593), 1,
      sym_atom,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2600), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(6226), 2,
      sym__newline,
      anon_sym_BSLASH,
    STATE(5566), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5590), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(2574), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    ACTIONS(6224), 11,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_let,
      anon_sym_do,
  [429287] = 19,
    ACTIONS(2488), 1,
      sym_id,
    ACTIONS(2498), 1,
      anon_sym_record,
    ACTIONS(2508), 1,
      aux_sym__qid_token1,
    ACTIONS(2516), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2518), 1,
      anon_sym_u2987,
    ACTIONS(2524), 1,
      anon_sym_Set,
    ACTIONS(4506), 1,
      anon_sym_LPAREN,
    ACTIONS(4508), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4510), 1,
      anon_sym_u2983,
    ACTIONS(4512), 1,
      anon_sym_LBRACE,
    ACTIONS(4514), 1,
      anon_sym_DOT,
    ACTIONS(6226), 1,
      anon_sym_BSLASH,
    STATE(5695), 1,
      sym_atom,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2522), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5713), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5698), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(2496), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    ACTIONS(6224), 12,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_let,
      anon_sym_do,
  [429373] = 19,
    ACTIONS(5442), 1,
      sym_id,
    ACTIONS(5446), 1,
      anon_sym_record,
    ACTIONS(5448), 1,
      anon_sym_LPAREN,
    ACTIONS(5450), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(5452), 1,
      anon_sym_u2983,
    ACTIONS(5454), 1,
      anon_sym_LBRACE,
    ACTIONS(5456), 1,
      aux_sym__qid_token1,
    ACTIONS(5458), 1,
      anon_sym_DOT,
    ACTIONS(5460), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(5462), 1,
      anon_sym_u2987,
    ACTIONS(5466), 1,
      anon_sym_Set,
    ACTIONS(6226), 1,
      anon_sym_BSLASH,
    STATE(5646), 1,
      sym_atom,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(5464), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5639), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5635), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(5444), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    ACTIONS(6224), 12,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_u2984,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_let,
      anon_sym_do,
  [429459] = 19,
    ACTIONS(6198), 1,
      sym_id,
    ACTIONS(6202), 1,
      anon_sym_record,
    ACTIONS(6204), 1,
      anon_sym_LPAREN,
    ACTIONS(6206), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(6208), 1,
      anon_sym_u2983,
    ACTIONS(6210), 1,
      anon_sym_LBRACE,
    ACTIONS(6212), 1,
      aux_sym__qid_token1,
    ACTIONS(6214), 1,
      anon_sym_DOT,
    ACTIONS(6216), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(6218), 1,
      anon_sym_u2987,
    ACTIONS(6222), 1,
      anon_sym_Set,
    STATE(5702), 1,
      sym_atom,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6220), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(6226), 2,
      sym__newline,
      anon_sym_BSLASH,
    STATE(5699), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5697), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(6200), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    ACTIONS(6224), 11,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_let,
      anon_sym_do,
  [429545] = 19,
    ACTIONS(3208), 1,
      sym_id,
    ACTIONS(3212), 1,
      anon_sym_record,
    ACTIONS(3214), 1,
      anon_sym_LPAREN,
    ACTIONS(3216), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3218), 1,
      anon_sym_u2983,
    ACTIONS(3220), 1,
      anon_sym_LBRACE,
    ACTIONS(3222), 1,
      aux_sym__qid_token1,
    ACTIONS(3224), 1,
      anon_sym_DOT,
    ACTIONS(3226), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3228), 1,
      anon_sym_u2987,
    ACTIONS(3232), 1,
      anon_sym_Set,
    ACTIONS(6226), 1,
      anon_sym_BSLASH,
    STATE(5575), 1,
      sym_atom,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3230), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5579), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5582), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3210), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    ACTIONS(6224), 12,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_let,
      anon_sym_do,
  [429631] = 19,
    ACTIONS(4248), 1,
      sym_id,
    ACTIONS(4252), 1,
      anon_sym_record,
    ACTIONS(4254), 1,
      anon_sym_LPAREN,
    ACTIONS(4256), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4258), 1,
      anon_sym_u2983,
    ACTIONS(4260), 1,
      anon_sym_LBRACE,
    ACTIONS(4262), 1,
      aux_sym__qid_token1,
    ACTIONS(4264), 1,
      anon_sym_DOT,
    ACTIONS(4266), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4268), 1,
      anon_sym_u2987,
    ACTIONS(4272), 1,
      anon_sym_Set,
    STATE(5955), 1,
      sym_atom,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(4270), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(6226), 2,
      sym__newline,
      anon_sym_BSLASH,
    STATE(5952), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5976), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(4250), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    ACTIONS(6224), 10,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_let,
      anon_sym_do,
  [429716] = 19,
    ACTIONS(5002), 1,
      sym_id,
    ACTIONS(5006), 1,
      anon_sym_record,
    ACTIONS(5008), 1,
      anon_sym_LPAREN,
    ACTIONS(5010), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(5012), 1,
      anon_sym_u2983,
    ACTIONS(5014), 1,
      anon_sym_LBRACE,
    ACTIONS(5016), 1,
      aux_sym__qid_token1,
    ACTIONS(5018), 1,
      anon_sym_DOT,
    ACTIONS(5020), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(5022), 1,
      anon_sym_u2987,
    ACTIONS(5026), 1,
      anon_sym_Set,
    ACTIONS(6226), 1,
      anon_sym_BSLASH,
    STATE(5810), 1,
      sym_atom,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(5024), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5805), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5804), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(5004), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    ACTIONS(6224), 11,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE_RBRACE,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_let,
      anon_sym_do,
  [429801] = 19,
    ACTIONS(6112), 1,
      sym_id,
    ACTIONS(6116), 1,
      anon_sym_record,
    ACTIONS(6118), 1,
      anon_sym_LPAREN,
    ACTIONS(6120), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(6122), 1,
      anon_sym_u2983,
    ACTIONS(6124), 1,
      anon_sym_LBRACE,
    ACTIONS(6126), 1,
      aux_sym__qid_token1,
    ACTIONS(6128), 1,
      anon_sym_DOT,
    ACTIONS(6130), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(6132), 1,
      anon_sym_u2987,
    ACTIONS(6136), 1,
      anon_sym_Set,
    ACTIONS(6226), 1,
      anon_sym_BSLASH,
    STATE(5822), 1,
      sym_atom,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6134), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5819), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5817), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(6114), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    ACTIONS(6224), 11,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_u2988,
      anon_sym_let,
      anon_sym_do,
  [429886] = 19,
    ACTIONS(5306), 1,
      sym_id,
    ACTIONS(5310), 1,
      anon_sym_record,
    ACTIONS(5312), 1,
      anon_sym_LPAREN,
    ACTIONS(5314), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(5316), 1,
      anon_sym_u2983,
    ACTIONS(5318), 1,
      anon_sym_LBRACE,
    ACTIONS(5320), 1,
      aux_sym__qid_token1,
    ACTIONS(5322), 1,
      anon_sym_DOT,
    ACTIONS(5324), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(5326), 1,
      anon_sym_u2987,
    ACTIONS(5330), 1,
      anon_sym_Set,
    ACTIONS(6226), 1,
      anon_sym_BSLASH,
    STATE(5859), 1,
      sym_atom,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(5328), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5854), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5853), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(5308), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    ACTIONS(6224), 11,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_u2984,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_let,
      anon_sym_do,
  [429971] = 19,
    ACTIONS(5166), 1,
      sym_id,
    ACTIONS(5170), 1,
      anon_sym_record,
    ACTIONS(5172), 1,
      anon_sym_LPAREN,
    ACTIONS(5174), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(5176), 1,
      anon_sym_u2983,
    ACTIONS(5178), 1,
      anon_sym_LBRACE,
    ACTIONS(5180), 1,
      aux_sym__qid_token1,
    ACTIONS(5182), 1,
      anon_sym_DOT,
    ACTIONS(5184), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(5186), 1,
      anon_sym_u2987,
    ACTIONS(5190), 1,
      anon_sym_Set,
    ACTIONS(6226), 1,
      anon_sym_BSLASH,
    STATE(5931), 1,
      sym_atom,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(5188), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5928), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5926), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(5168), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    ACTIONS(6224), 11,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACE_RBRACE,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_let,
      anon_sym_do,
  [430056] = 19,
    ACTIONS(5192), 1,
      sym_id,
    ACTIONS(5196), 1,
      anon_sym_record,
    ACTIONS(5198), 1,
      anon_sym_LPAREN,
    ACTIONS(5200), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(5202), 1,
      anon_sym_u2983,
    ACTIONS(5204), 1,
      anon_sym_LBRACE,
    ACTIONS(5206), 1,
      aux_sym__qid_token1,
    ACTIONS(5208), 1,
      anon_sym_DOT,
    ACTIONS(5210), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(5212), 1,
      anon_sym_u2987,
    ACTIONS(5216), 1,
      anon_sym_Set,
    ACTIONS(6226), 1,
      anon_sym_BSLASH,
    STATE(5739), 1,
      sym_atom,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(5214), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5737), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5736), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(5194), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    ACTIONS(6224), 11,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_u2984,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_let,
      anon_sym_do,
  [430141] = 19,
    ACTIONS(5278), 1,
      sym_id,
    ACTIONS(5282), 1,
      anon_sym_record,
    ACTIONS(5284), 1,
      anon_sym_LPAREN,
    ACTIONS(5286), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(5288), 1,
      anon_sym_u2983,
    ACTIONS(5290), 1,
      anon_sym_LBRACE,
    ACTIONS(5292), 1,
      aux_sym__qid_token1,
    ACTIONS(5294), 1,
      anon_sym_DOT,
    ACTIONS(5296), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(5298), 1,
      anon_sym_u2987,
    ACTIONS(5302), 1,
      anon_sym_Set,
    ACTIONS(6226), 1,
      anon_sym_BSLASH,
    STATE(5782), 1,
      sym_atom,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(5300), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5779), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5778), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(5280), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    ACTIONS(6224), 11,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_u2984,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_let,
      anon_sym_do,
  [430226] = 19,
    ACTIONS(6236), 1,
      sym_id,
    ACTIONS(6241), 1,
      anon_sym_BSLASH,
    ACTIONS(6246), 1,
      anon_sym_record,
    ACTIONS(6249), 1,
      anon_sym_LPAREN,
    ACTIONS(6252), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(6255), 1,
      anon_sym_u2983,
    ACTIONS(6258), 1,
      anon_sym_LBRACE,
    ACTIONS(6261), 1,
      aux_sym__qid_token1,
    ACTIONS(6264), 1,
      anon_sym_DOT,
    ACTIONS(6267), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(6270), 1,
      anon_sym_u2987,
    ACTIONS(6276), 1,
      anon_sym_Set,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6273), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(3982), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(6157), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6162), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(6243), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    ACTIONS(6239), 10,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_let,
      anon_sym_do,
  [430311] = 19,
    ACTIONS(5140), 1,
      sym_id,
    ACTIONS(5144), 1,
      anon_sym_record,
    ACTIONS(5146), 1,
      anon_sym_LPAREN,
    ACTIONS(5148), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(5150), 1,
      anon_sym_u2983,
    ACTIONS(5152), 1,
      anon_sym_LBRACE,
    ACTIONS(5154), 1,
      aux_sym__qid_token1,
    ACTIONS(5156), 1,
      anon_sym_DOT,
    ACTIONS(5158), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(5160), 1,
      anon_sym_u2987,
    ACTIONS(5164), 1,
      anon_sym_Set,
    ACTIONS(6226), 1,
      anon_sym_BSLASH,
    STATE(5800), 1,
      sym_atom,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(5162), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5797), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5795), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(5142), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    ACTIONS(6224), 11,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_PIPE_RPAREN,
      anon_sym_let,
      anon_sym_do,
  [430396] = 19,
    ACTIONS(5682), 1,
      sym_id,
    ACTIONS(5686), 1,
      anon_sym_record,
    ACTIONS(5688), 1,
      anon_sym_LPAREN,
    ACTIONS(5690), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(5692), 1,
      anon_sym_u2983,
    ACTIONS(5694), 1,
      anon_sym_LBRACE,
    ACTIONS(5696), 1,
      aux_sym__qid_token1,
    ACTIONS(5698), 1,
      anon_sym_DOT,
    ACTIONS(5700), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(5702), 1,
      anon_sym_u2987,
    ACTIONS(5706), 1,
      anon_sym_Set,
    ACTIONS(6226), 1,
      anon_sym_BSLASH,
    STATE(5921), 1,
      sym_atom,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(5704), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5924), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5925), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(5684), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    ACTIONS(6224), 11,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_let,
      anon_sym_do,
  [430481] = 19,
    ACTIONS(5760), 1,
      sym_id,
    ACTIONS(5764), 1,
      anon_sym_record,
    ACTIONS(5766), 1,
      anon_sym_LPAREN,
    ACTIONS(5768), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(5770), 1,
      anon_sym_u2983,
    ACTIONS(5772), 1,
      anon_sym_LBRACE,
    ACTIONS(5774), 1,
      aux_sym__qid_token1,
    ACTIONS(5776), 1,
      anon_sym_DOT,
    ACTIONS(5778), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(5780), 1,
      anon_sym_u2987,
    ACTIONS(5784), 1,
      anon_sym_Set,
    ACTIONS(6226), 1,
      anon_sym_BSLASH,
    STATE(5977), 1,
      sym_atom,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(5782), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5941), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5965), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(5762), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    ACTIONS(6224), 11,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_RBRACE_RBRACE,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_let,
      anon_sym_do,
  [430566] = 19,
    ACTIONS(5978), 1,
      sym_id,
    ACTIONS(5982), 1,
      anon_sym_record,
    ACTIONS(5984), 1,
      anon_sym_LPAREN,
    ACTIONS(5986), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(5988), 1,
      anon_sym_u2983,
    ACTIONS(5990), 1,
      anon_sym_LBRACE,
    ACTIONS(5992), 1,
      aux_sym__qid_token1,
    ACTIONS(5994), 1,
      anon_sym_DOT,
    ACTIONS(5996), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(5998), 1,
      anon_sym_u2987,
    ACTIONS(6002), 1,
      anon_sym_Set,
    ACTIONS(6226), 1,
      anon_sym_BSLASH,
    STATE(5761), 1,
      sym_atom,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6000), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5765), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5767), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(5980), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    ACTIONS(6224), 11,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_let,
      anon_sym_do,
  [430651] = 19,
    ACTIONS(2938), 1,
      sym_id,
    ACTIONS(2950), 1,
      anon_sym_record,
    ACTIONS(2952), 1,
      anon_sym_LPAREN,
    ACTIONS(2954), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2956), 1,
      anon_sym_u2983,
    ACTIONS(2958), 1,
      anon_sym_LBRACE,
    ACTIONS(2960), 1,
      aux_sym__qid_token1,
    ACTIONS(2962), 1,
      anon_sym_DOT,
    ACTIONS(2968), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2970), 1,
      anon_sym_u2987,
    ACTIONS(2976), 1,
      anon_sym_Set,
    STATE(5852), 1,
      sym_atom,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2974), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(6226), 2,
      sym__newline,
      anon_sym_BSLASH,
    STATE(5870), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5838), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(2948), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    ACTIONS(6224), 10,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_SEMI,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_let,
      anon_sym_do,
  [430736] = 19,
    ACTIONS(4924), 1,
      sym_id,
    ACTIONS(4928), 1,
      anon_sym_record,
    ACTIONS(4930), 1,
      anon_sym_LPAREN,
    ACTIONS(4932), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4934), 1,
      anon_sym_u2983,
    ACTIONS(4936), 1,
      anon_sym_LBRACE,
    ACTIONS(4938), 1,
      aux_sym__qid_token1,
    ACTIONS(4940), 1,
      anon_sym_DOT,
    ACTIONS(4942), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4944), 1,
      anon_sym_u2987,
    ACTIONS(4948), 1,
      anon_sym_Set,
    STATE(5893), 1,
      sym_atom,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(4946), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(6226), 2,
      sym__newline,
      anon_sym_BSLASH,
    STATE(5898), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5899), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(4926), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    ACTIONS(6224), 10,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_let,
      anon_sym_do,
  [430821] = 19,
    ACTIONS(5734), 1,
      sym_id,
    ACTIONS(5738), 1,
      anon_sym_record,
    ACTIONS(5740), 1,
      anon_sym_LPAREN,
    ACTIONS(5742), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(5744), 1,
      anon_sym_u2983,
    ACTIONS(5746), 1,
      anon_sym_LBRACE,
    ACTIONS(5748), 1,
      aux_sym__qid_token1,
    ACTIONS(5750), 1,
      anon_sym_DOT,
    ACTIONS(5752), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(5754), 1,
      anon_sym_u2987,
    ACTIONS(5758), 1,
      anon_sym_Set,
    ACTIONS(6226), 1,
      anon_sym_BSLASH,
    STATE(5769), 1,
      sym_atom,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(5756), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5762), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5752), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(5736), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    ACTIONS(6224), 11,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE_RBRACE,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_let,
      anon_sym_do,
  [430906] = 19,
    ACTIONS(6032), 1,
      sym_id,
    ACTIONS(6036), 1,
      anon_sym_record,
    ACTIONS(6038), 1,
      anon_sym_LPAREN,
    ACTIONS(6040), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(6042), 1,
      anon_sym_u2983,
    ACTIONS(6044), 1,
      anon_sym_LBRACE,
    ACTIONS(6046), 1,
      aux_sym__qid_token1,
    ACTIONS(6048), 1,
      anon_sym_DOT,
    ACTIONS(6050), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(6052), 1,
      anon_sym_u2987,
    ACTIONS(6056), 1,
      anon_sym_Set,
    STATE(5903), 1,
      sym_atom,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6054), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(6226), 2,
      sym__newline,
      anon_sym_BSLASH,
    STATE(5909), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5914), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(6034), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    ACTIONS(6224), 10,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_let,
      anon_sym_do,
  [430991] = 19,
    ACTIONS(2806), 1,
      sym_id,
    ACTIONS(2816), 1,
      anon_sym_record,
    ACTIONS(2818), 1,
      anon_sym_LPAREN,
    ACTIONS(2820), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(2822), 1,
      anon_sym_u2983,
    ACTIONS(2824), 1,
      anon_sym_LBRACE,
    ACTIONS(2826), 1,
      aux_sym__qid_token1,
    ACTIONS(2828), 1,
      anon_sym_DOT,
    ACTIONS(2832), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2834), 1,
      anon_sym_u2987,
    ACTIONS(2838), 1,
      anon_sym_Set,
    ACTIONS(6226), 1,
      anon_sym_BSLASH,
    STATE(5985), 1,
      sym_atom,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(2836), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5982), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5981), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(2814), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    ACTIONS(6224), 11,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_let,
      anon_sym_do,
  [431076] = 19,
    ACTIONS(5218), 1,
      sym_id,
    ACTIONS(5224), 1,
      anon_sym_record,
    ACTIONS(5226), 1,
      anon_sym_LPAREN,
    ACTIONS(5228), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(5230), 1,
      anon_sym_u2983,
    ACTIONS(5232), 1,
      anon_sym_LBRACE,
    ACTIONS(5234), 1,
      aux_sym__qid_token1,
    ACTIONS(5236), 1,
      anon_sym_DOT,
    ACTIONS(5238), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(5240), 1,
      anon_sym_u2987,
    ACTIONS(5244), 1,
      anon_sym_Set,
    ACTIONS(6226), 1,
      anon_sym_BSLASH,
    STATE(6180), 1,
      sym_atom,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(5242), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6166), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6188), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(5222), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    ACTIONS(6224), 10,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_COLON,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_let,
      anon_sym_do,
  [431160] = 22,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6241), 1,
      sym__newline,
    ACTIONS(6279), 1,
      sym_id,
    ACTIONS(6282), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6288), 1,
      anon_sym_record,
    ACTIONS(6291), 1,
      anon_sym_LPAREN,
    ACTIONS(6294), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(6297), 1,
      anon_sym_u2983,
    ACTIONS(6300), 1,
      anon_sym_LBRACE,
    ACTIONS(6303), 1,
      aux_sym__qid_token1,
    ACTIONS(6306), 1,
      anon_sym_DOT,
    ACTIONS(6309), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(6312), 1,
      anon_sym_u2987,
    ACTIONS(6315), 1,
      aux_sym_integer_token1,
    ACTIONS(6318), 1,
      aux_sym_string_token1,
    ACTIONS(6321), 1,
      anon_sym_Set,
    STATE(3993), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(6547), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6549), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(6285), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    ACTIONS(6239), 9,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_in,
  [431250] = 4,
    ACTIONS(6328), 1,
      anon_sym_AT,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6326), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6324), 40,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [431304] = 19,
    ACTIONS(5112), 1,
      sym_id,
    ACTIONS(5116), 1,
      anon_sym_record,
    ACTIONS(5118), 1,
      anon_sym_LPAREN,
    ACTIONS(5120), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(5122), 1,
      anon_sym_u2983,
    ACTIONS(5124), 1,
      anon_sym_LBRACE,
    ACTIONS(5126), 1,
      aux_sym__qid_token1,
    ACTIONS(5128), 1,
      anon_sym_DOT,
    ACTIONS(5130), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(5132), 1,
      anon_sym_u2987,
    ACTIONS(5136), 1,
      anon_sym_Set,
    ACTIONS(6226), 1,
      anon_sym_BSLASH,
    STATE(6155), 1,
      sym_atom,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(5134), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6010), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6007), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(5114), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    ACTIONS(6224), 10,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_EQ,
      anon_sym_u2984,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_let,
      anon_sym_do,
  [431388] = 19,
    ACTIONS(5898), 1,
      sym_id,
    ACTIONS(5902), 1,
      anon_sym_record,
    ACTIONS(5904), 1,
      anon_sym_LPAREN,
    ACTIONS(5906), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(5908), 1,
      anon_sym_u2983,
    ACTIONS(5910), 1,
      anon_sym_LBRACE,
    ACTIONS(5912), 1,
      aux_sym__qid_token1,
    ACTIONS(5914), 1,
      anon_sym_DOT,
    ACTIONS(5916), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(5918), 1,
      anon_sym_u2987,
    ACTIONS(5922), 1,
      anon_sym_Set,
    ACTIONS(6226), 1,
      anon_sym_BSLASH,
    STATE(6080), 1,
      sym_atom,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(5920), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6087), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6089), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(5900), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    ACTIONS(6224), 10,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_let,
      anon_sym_do,
  [431472] = 19,
    ACTIONS(4976), 1,
      sym_id,
    ACTIONS(4980), 1,
      anon_sym_record,
    ACTIONS(4982), 1,
      anon_sym_LPAREN,
    ACTIONS(4984), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4986), 1,
      anon_sym_u2983,
    ACTIONS(4988), 1,
      anon_sym_LBRACE,
    ACTIONS(4990), 1,
      aux_sym__qid_token1,
    ACTIONS(4992), 1,
      anon_sym_DOT,
    ACTIONS(4994), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4996), 1,
      anon_sym_u2987,
    ACTIONS(5000), 1,
      anon_sym_Set,
    ACTIONS(6226), 1,
      anon_sym_BSLASH,
    STATE(6134), 1,
      sym_atom,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(4998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6124), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6161), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(4978), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    ACTIONS(6224), 10,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_let,
      anon_sym_do,
  [431556] = 19,
    ACTIONS(5952), 1,
      sym_id,
    ACTIONS(5956), 1,
      anon_sym_record,
    ACTIONS(5958), 1,
      anon_sym_LPAREN,
    ACTIONS(5960), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(5962), 1,
      anon_sym_u2983,
    ACTIONS(5964), 1,
      anon_sym_LBRACE,
    ACTIONS(5966), 1,
      aux_sym__qid_token1,
    ACTIONS(5968), 1,
      anon_sym_DOT,
    ACTIONS(5970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(5972), 1,
      anon_sym_u2987,
    ACTIONS(5976), 1,
      anon_sym_Set,
    STATE(6202), 1,
      sym_atom,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(5974), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(6226), 2,
      sym__newline,
      anon_sym_BSLASH,
    STATE(6213), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6217), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(5954), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    ACTIONS(6224), 9,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_let,
      anon_sym_do,
  [431640] = 19,
    ACTIONS(5846), 1,
      sym_id,
    ACTIONS(5850), 1,
      anon_sym_record,
    ACTIONS(5852), 1,
      anon_sym_LPAREN,
    ACTIONS(5854), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(5856), 1,
      anon_sym_u2983,
    ACTIONS(5858), 1,
      anon_sym_LBRACE,
    ACTIONS(5860), 1,
      aux_sym__qid_token1,
    ACTIONS(5862), 1,
      anon_sym_DOT,
    ACTIONS(5864), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(5866), 1,
      anon_sym_u2987,
    ACTIONS(5870), 1,
      anon_sym_Set,
    ACTIONS(6226), 1,
      anon_sym_BSLASH,
    STATE(6104), 1,
      sym_atom,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(5868), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6096), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6100), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(5848), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    ACTIONS(6224), 10,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_u2988,
      anon_sym_let,
      anon_sym_do,
  [431724] = 19,
    ACTIONS(5494), 1,
      sym_id,
    ACTIONS(5498), 1,
      anon_sym_record,
    ACTIONS(5500), 1,
      anon_sym_LPAREN,
    ACTIONS(5502), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(5504), 1,
      anon_sym_u2983,
    ACTIONS(5506), 1,
      anon_sym_LBRACE,
    ACTIONS(5508), 1,
      aux_sym__qid_token1,
    ACTIONS(5510), 1,
      anon_sym_DOT,
    ACTIONS(5512), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(5514), 1,
      anon_sym_u2987,
    ACTIONS(5518), 1,
      anon_sym_Set,
    ACTIONS(6226), 1,
      anon_sym_BSLASH,
    STATE(6043), 1,
      sym_atom,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(5516), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6047), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6050), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(5496), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    ACTIONS(6224), 10,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_COLON,
      anon_sym_u2984,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_let,
      anon_sym_do,
  [431808] = 19,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3992), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4222), 1,
      sym_id,
    ACTIONS(4224), 1,
      aux_sym__qid_token1,
    ACTIONS(6226), 1,
      anon_sym_BSLASH,
    STATE(6290), 1,
      sym_atom,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3998), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3972), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    ACTIONS(6224), 10,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACE_RBRACE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_let,
      anon_sym_do,
  [431892] = 19,
    ACTIONS(5604), 1,
      sym_id,
    ACTIONS(5608), 1,
      anon_sym_record,
    ACTIONS(5610), 1,
      anon_sym_LPAREN,
    ACTIONS(5612), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(5614), 1,
      anon_sym_u2983,
    ACTIONS(5616), 1,
      anon_sym_LBRACE,
    ACTIONS(5618), 1,
      aux_sym__qid_token1,
    ACTIONS(5620), 1,
      anon_sym_DOT,
    ACTIONS(5622), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(5624), 1,
      anon_sym_u2987,
    ACTIONS(5628), 1,
      anon_sym_Set,
    ACTIONS(6226), 1,
      anon_sym_BSLASH,
    STATE(6231), 1,
      sym_atom,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(5626), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6226), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6214), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(5606), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    ACTIONS(6224), 10,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_let,
      anon_sym_do,
  [431976] = 23,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6330), 1,
      sym_id,
    ACTIONS(6332), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6338), 1,
      anon_sym_record,
    ACTIONS(6340), 1,
      anon_sym_LPAREN,
    ACTIONS(6342), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(6344), 1,
      anon_sym_u2983,
    ACTIONS(6346), 1,
      anon_sym_LBRACE,
    ACTIONS(6348), 1,
      aux_sym__qid_token1,
    ACTIONS(6350), 1,
      anon_sym_DOT,
    ACTIONS(6352), 1,
      anon_sym_PIPE,
    ACTIONS(6354), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(6356), 1,
      anon_sym_u2987,
    ACTIONS(6358), 1,
      aux_sym_integer_token1,
    ACTIONS(6360), 1,
      aux_sym_string_token1,
    ACTIONS(6362), 1,
      anon_sym_Set,
    ACTIONS(6364), 1,
      sym__newline,
    STATE(3993), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(6547), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6549), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(6334), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    ACTIONS(6336), 8,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_in,
  [432068] = 19,
    ACTIONS(6241), 1,
      anon_sym_BSLASH,
    ACTIONS(6366), 1,
      sym_id,
    ACTIONS(6372), 1,
      anon_sym_record,
    ACTIONS(6375), 1,
      anon_sym_LPAREN,
    ACTIONS(6378), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(6381), 1,
      anon_sym_u2983,
    ACTIONS(6384), 1,
      anon_sym_LBRACE,
    ACTIONS(6387), 1,
      aux_sym__qid_token1,
    ACTIONS(6390), 1,
      anon_sym_DOT,
    ACTIONS(6393), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(6396), 1,
      anon_sym_u2987,
    ACTIONS(6402), 1,
      anon_sym_Set,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6399), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4004), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(6402), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6407), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(6239), 9,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_let,
      anon_sym_do,
    ACTIONS(6369), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [432152] = 19,
    ACTIONS(5656), 1,
      sym_id,
    ACTIONS(5660), 1,
      anon_sym_record,
    ACTIONS(5662), 1,
      anon_sym_LPAREN,
    ACTIONS(5664), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(5666), 1,
      anon_sym_u2983,
    ACTIONS(5668), 1,
      anon_sym_LBRACE,
    ACTIONS(5670), 1,
      aux_sym__qid_token1,
    ACTIONS(5672), 1,
      anon_sym_DOT,
    ACTIONS(5674), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(5676), 1,
      anon_sym_u2987,
    ACTIONS(5680), 1,
      anon_sym_Set,
    STATE(6126), 1,
      sym_atom,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(5678), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    ACTIONS(6226), 2,
      sym__newline,
      anon_sym_BSLASH,
    STATE(6130), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6053), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(5658), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    ACTIONS(6224), 9,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_let,
      anon_sym_do,
  [432236] = 19,
    ACTIONS(5390), 1,
      sym_id,
    ACTIONS(5394), 1,
      anon_sym_record,
    ACTIONS(5396), 1,
      anon_sym_LPAREN,
    ACTIONS(5398), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(5400), 1,
      anon_sym_u2983,
    ACTIONS(5402), 1,
      anon_sym_LBRACE,
    ACTIONS(5404), 1,
      aux_sym__qid_token1,
    ACTIONS(5406), 1,
      anon_sym_DOT,
    ACTIONS(5408), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(5410), 1,
      anon_sym_u2987,
    ACTIONS(5414), 1,
      anon_sym_Set,
    ACTIONS(6226), 1,
      anon_sym_BSLASH,
    STATE(6073), 1,
      sym_atom,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(5412), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6026), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6060), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(5392), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    ACTIONS(6224), 10,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_PIPE_RPAREN,
      anon_sym_let,
      anon_sym_do,
  [432320] = 19,
    ACTIONS(5548), 1,
      sym_id,
    ACTIONS(5552), 1,
      anon_sym_record,
    ACTIONS(5554), 1,
      anon_sym_LPAREN,
    ACTIONS(5556), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(5558), 1,
      anon_sym_u2983,
    ACTIONS(5560), 1,
      anon_sym_LBRACE,
    ACTIONS(5562), 1,
      aux_sym__qid_token1,
    ACTIONS(5564), 1,
      anon_sym_DOT,
    ACTIONS(5566), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(5568), 1,
      anon_sym_u2987,
    ACTIONS(5572), 1,
      anon_sym_Set,
    ACTIONS(6226), 1,
      anon_sym_BSLASH,
    STATE(6035), 1,
      sym_atom,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(5570), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6032), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6059), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(5550), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    ACTIONS(6224), 10,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_let,
      anon_sym_do,
  [432404] = 19,
    ACTIONS(6226), 1,
      anon_sym_BSLASH,
    ACTIONS(6405), 1,
      sym_id,
    ACTIONS(6409), 1,
      anon_sym_record,
    ACTIONS(6411), 1,
      anon_sym_LPAREN,
    ACTIONS(6413), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(6415), 1,
      anon_sym_u2983,
    ACTIONS(6417), 1,
      anon_sym_LBRACE,
    ACTIONS(6419), 1,
      aux_sym__qid_token1,
    ACTIONS(6421), 1,
      anon_sym_DOT,
    ACTIONS(6423), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(6425), 1,
      anon_sym_u2987,
    ACTIONS(6429), 1,
      anon_sym_Set,
    STATE(6153), 1,
      sym_atom,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6427), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6157), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6162), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(6407), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    ACTIONS(6224), 10,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_let,
      anon_sym_do,
  [432488] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6433), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6431), 40,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [432539] = 4,
    ACTIONS(6435), 1,
      anon_sym_AT,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6326), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6324), 39,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [432592] = 22,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6241), 1,
      sym__newline,
    ACTIONS(6437), 1,
      sym_id,
    ACTIONS(6440), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6446), 1,
      anon_sym_record,
    ACTIONS(6449), 1,
      anon_sym_LPAREN,
    ACTIONS(6452), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(6455), 1,
      anon_sym_u2983,
    ACTIONS(6458), 1,
      anon_sym_LBRACE,
    ACTIONS(6461), 1,
      aux_sym__qid_token1,
    ACTIONS(6464), 1,
      anon_sym_DOT,
    ACTIONS(6467), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(6470), 1,
      anon_sym_u2987,
    ACTIONS(6473), 1,
      aux_sym_integer_token1,
    ACTIONS(6476), 1,
      aux_sym_string_token1,
    ACTIONS(6479), 1,
      anon_sym_Set,
    STATE(4011), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(6850), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6851), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(6239), 8,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_in,
    ACTIONS(6443), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [432681] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6484), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6482), 40,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [432732] = 22,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6226), 1,
      sym__newline,
    ACTIONS(6330), 1,
      sym_id,
    ACTIONS(6332), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6338), 1,
      anon_sym_record,
    ACTIONS(6340), 1,
      anon_sym_LPAREN,
    ACTIONS(6342), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(6344), 1,
      anon_sym_u2983,
    ACTIONS(6346), 1,
      anon_sym_LBRACE,
    ACTIONS(6348), 1,
      aux_sym__qid_token1,
    ACTIONS(6350), 1,
      anon_sym_DOT,
    ACTIONS(6354), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(6356), 1,
      anon_sym_u2987,
    ACTIONS(6358), 1,
      aux_sym_integer_token1,
    ACTIONS(6360), 1,
      aux_sym_string_token1,
    ACTIONS(6362), 1,
      anon_sym_Set,
    STATE(6543), 1,
      sym_atom,
    STATE(6547), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6549), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(6334), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    ACTIONS(6224), 9,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_in,
  [432821] = 5,
    ACTIONS(6488), 1,
      anon_sym_BSLASH,
    ACTIONS(6492), 1,
      sym__newline,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6490), 8,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_in,
    ACTIONS(6486), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [432876] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6496), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6494), 40,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [432927] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6500), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6498), 40,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [432978] = 23,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6364), 1,
      sym__newline,
    ACTIONS(6502), 1,
      sym_id,
    ACTIONS(6504), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6508), 1,
      anon_sym_record,
    ACTIONS(6510), 1,
      anon_sym_LPAREN,
    ACTIONS(6512), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(6514), 1,
      anon_sym_u2983,
    ACTIONS(6516), 1,
      anon_sym_LBRACE,
    ACTIONS(6518), 1,
      aux_sym__qid_token1,
    ACTIONS(6520), 1,
      anon_sym_DOT,
    ACTIONS(6522), 1,
      anon_sym_PIPE,
    ACTIONS(6524), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(6526), 1,
      anon_sym_u2987,
    ACTIONS(6528), 1,
      aux_sym_integer_token1,
    ACTIONS(6530), 1,
      aux_sym_string_token1,
    ACTIONS(6532), 1,
      anon_sym_Set,
    STATE(4011), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(6850), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    ACTIONS(6336), 7,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_in,
    STATE(6851), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(6506), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [433069] = 23,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6364), 1,
      sym__newline,
    ACTIONS(6534), 1,
      sym_id,
    ACTIONS(6536), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6540), 1,
      anon_sym_record,
    ACTIONS(6542), 1,
      anon_sym_LPAREN,
    ACTIONS(6544), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(6546), 1,
      anon_sym_u2983,
    ACTIONS(6548), 1,
      anon_sym_LBRACE,
    ACTIONS(6550), 1,
      aux_sym__qid_token1,
    ACTIONS(6552), 1,
      anon_sym_DOT,
    ACTIONS(6554), 1,
      anon_sym_PIPE,
    ACTIONS(6556), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(6558), 1,
      anon_sym_u2987,
    ACTIONS(6560), 1,
      aux_sym_integer_token1,
    ACTIONS(6562), 1,
      aux_sym_string_token1,
    ACTIONS(6564), 1,
      anon_sym_Set,
    STATE(4029), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(6795), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    ACTIONS(6336), 7,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
    STATE(6796), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(6538), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [433160] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6568), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6566), 40,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [433211] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6572), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6570), 40,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [433262] = 22,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6241), 1,
      sym__newline,
    ACTIONS(6574), 1,
      sym_id,
    ACTIONS(6577), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6583), 1,
      anon_sym_record,
    ACTIONS(6586), 1,
      anon_sym_LPAREN,
    ACTIONS(6589), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(6592), 1,
      anon_sym_u2983,
    ACTIONS(6595), 1,
      anon_sym_LBRACE,
    ACTIONS(6598), 1,
      aux_sym__qid_token1,
    ACTIONS(6601), 1,
      anon_sym_DOT,
    ACTIONS(6604), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(6607), 1,
      anon_sym_u2987,
    ACTIONS(6610), 1,
      aux_sym_integer_token1,
    ACTIONS(6613), 1,
      aux_sym_string_token1,
    ACTIONS(6616), 1,
      anon_sym_Set,
    STATE(4021), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(6805), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6809), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(6239), 8,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_PIPE,
      anon_sym_in,
    ACTIONS(6580), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [433351] = 19,
    ACTIONS(4190), 1,
      anon_sym_record,
    ACTIONS(4192), 1,
      anon_sym_LPAREN,
    ACTIONS(4194), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(4196), 1,
      anon_sym_u2983,
    ACTIONS(4198), 1,
      anon_sym_LBRACE,
    ACTIONS(4202), 1,
      anon_sym_DOT,
    ACTIONS(4206), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(4208), 1,
      anon_sym_u2987,
    ACTIONS(4212), 1,
      anon_sym_Set,
    ACTIONS(6226), 1,
      anon_sym_BSLASH,
    ACTIONS(6228), 1,
      sym_id,
    ACTIONS(6230), 1,
      aux_sym__qid_token1,
    STATE(6557), 1,
      sym_atom,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(4210), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6575), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6565), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(4188), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    ACTIONS(6224), 9,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_COLON,
      anon_sym_u2984,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_let,
      anon_sym_do,
  [433434] = 19,
    ACTIONS(6226), 1,
      anon_sym_BSLASH,
    ACTIONS(6619), 1,
      sym_id,
    ACTIONS(6623), 1,
      anon_sym_record,
    ACTIONS(6625), 1,
      anon_sym_LPAREN,
    ACTIONS(6627), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(6629), 1,
      anon_sym_u2983,
    ACTIONS(6631), 1,
      anon_sym_LBRACE,
    ACTIONS(6633), 1,
      aux_sym__qid_token1,
    ACTIONS(6635), 1,
      anon_sym_DOT,
    ACTIONS(6637), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(6639), 1,
      anon_sym_u2987,
    ACTIONS(6643), 1,
      anon_sym_Set,
    STATE(6397), 1,
      sym_atom,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6641), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6402), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6407), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(6224), 9,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_let,
      anon_sym_do,
    ACTIONS(6621), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [433517] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6647), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6645), 40,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [433568] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6651), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6649), 40,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [433619] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6655), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6653), 40,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [433670] = 4,
    ACTIONS(6657), 1,
      anon_sym_AT,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6326), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6324), 39,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [433723] = 4,
    ACTIONS(6659), 1,
      anon_sym_AT,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6326), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6324), 39,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [433776] = 22,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6241), 1,
      sym__newline,
    ACTIONS(6661), 1,
      sym_id,
    ACTIONS(6664), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6670), 1,
      anon_sym_record,
    ACTIONS(6673), 1,
      anon_sym_LPAREN,
    ACTIONS(6676), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(6679), 1,
      anon_sym_u2983,
    ACTIONS(6682), 1,
      anon_sym_LBRACE,
    ACTIONS(6685), 1,
      aux_sym__qid_token1,
    ACTIONS(6688), 1,
      anon_sym_DOT,
    ACTIONS(6691), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(6694), 1,
      anon_sym_u2987,
    ACTIONS(6697), 1,
      aux_sym_integer_token1,
    ACTIONS(6700), 1,
      aux_sym_string_token1,
    ACTIONS(6703), 1,
      anon_sym_Set,
    STATE(4029), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(6795), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6796), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(6239), 8,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_PIPE,
    ACTIONS(6667), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [433865] = 4,
    ACTIONS(6706), 1,
      anon_sym_AT,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6326), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6324), 39,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [433918] = 19,
    ACTIONS(3064), 1,
      anon_sym_record,
    ACTIONS(3066), 1,
      anon_sym_LPAREN,
    ACTIONS(3068), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(3070), 1,
      anon_sym_u2983,
    ACTIONS(3072), 1,
      anon_sym_LBRACE,
    ACTIONS(3078), 1,
      anon_sym_DOT,
    ACTIONS(3082), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3084), 1,
      anon_sym_u2987,
    ACTIONS(3088), 1,
      anon_sym_Set,
    ACTIONS(6226), 1,
      anon_sym_BSLASH,
    ACTIONS(6232), 1,
      sym_id,
    ACTIONS(6234), 1,
      aux_sym__qid_token1,
    STATE(6734), 1,
      sym_atom,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(3086), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6715), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6714), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3062), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
    ACTIONS(6224), 9,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_let,
      anon_sym_do,
  [434001] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6710), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6708), 40,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [434052] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6326), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6324), 40,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [434103] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6714), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6712), 40,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [434154] = 23,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6364), 1,
      sym__newline,
    ACTIONS(6716), 1,
      sym_id,
    ACTIONS(6718), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6722), 1,
      anon_sym_record,
    ACTIONS(6724), 1,
      anon_sym_LPAREN,
    ACTIONS(6726), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(6728), 1,
      anon_sym_u2983,
    ACTIONS(6730), 1,
      anon_sym_LBRACE,
    ACTIONS(6732), 1,
      aux_sym__qid_token1,
    ACTIONS(6734), 1,
      anon_sym_DOT,
    ACTIONS(6736), 1,
      anon_sym_PIPE,
    ACTIONS(6738), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(6740), 1,
      anon_sym_u2987,
    ACTIONS(6742), 1,
      aux_sym_integer_token1,
    ACTIONS(6744), 1,
      aux_sym_string_token1,
    ACTIONS(6746), 1,
      anon_sym_Set,
    STATE(4021), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(6805), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    ACTIONS(6336), 7,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_in,
    STATE(6809), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(6720), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [434245] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6750), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6748), 40,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [434296] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6754), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6752), 40,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [434347] = 20,
    ACTIONS(6756), 1,
      sym_id,
    ACTIONS(6761), 1,
      anon_sym_BSLASH,
    ACTIONS(6766), 1,
      anon_sym_record,
    ACTIONS(6769), 1,
      anon_sym_LPAREN,
    ACTIONS(6772), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(6775), 1,
      anon_sym_u2983,
    ACTIONS(6778), 1,
      anon_sym_LBRACE,
    ACTIONS(6781), 1,
      aux_sym__qid_token1,
    ACTIONS(6784), 1,
      anon_sym_DOT,
    ACTIONS(6787), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(6790), 1,
      anon_sym_u2987,
    ACTIONS(6796), 1,
      anon_sym_Set,
    STATE(4038), 1,
      aux_sym__with_exprs_repeat1,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6793), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(5792), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7835), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    ACTIONS(6759), 7,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_let,
      anon_sym_do,
    STATE(7830), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(6763), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [434432] = 19,
    ACTIONS(6241), 1,
      anon_sym_BSLASH,
    ACTIONS(6799), 1,
      sym_id,
    ACTIONS(6805), 1,
      anon_sym_record,
    ACTIONS(6808), 1,
      anon_sym_LPAREN,
    ACTIONS(6811), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(6814), 1,
      anon_sym_u2983,
    ACTIONS(6817), 1,
      anon_sym_LBRACE,
    ACTIONS(6820), 1,
      aux_sym__qid_token1,
    ACTIONS(6823), 1,
      anon_sym_DOT,
    ACTIONS(6826), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(6829), 1,
      anon_sym_u2987,
    ACTIONS(6835), 1,
      anon_sym_Set,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6832), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4039), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(6791), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6826), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(6239), 8,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_let,
      anon_sym_do,
    ACTIONS(6802), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [434515] = 4,
    ACTIONS(6838), 1,
      anon_sym_AT,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6326), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6324), 38,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [434567] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6655), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6653), 39,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [434617] = 22,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6226), 1,
      sym__newline,
    ACTIONS(6502), 1,
      sym_id,
    ACTIONS(6504), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6508), 1,
      anon_sym_record,
    ACTIONS(6510), 1,
      anon_sym_LPAREN,
    ACTIONS(6512), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(6514), 1,
      anon_sym_u2983,
    ACTIONS(6516), 1,
      anon_sym_LBRACE,
    ACTIONS(6518), 1,
      aux_sym__qid_token1,
    ACTIONS(6520), 1,
      anon_sym_DOT,
    ACTIONS(6524), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(6526), 1,
      anon_sym_u2987,
    ACTIONS(6528), 1,
      aux_sym_integer_token1,
    ACTIONS(6530), 1,
      aux_sym_string_token1,
    ACTIONS(6532), 1,
      anon_sym_Set,
    STATE(6846), 1,
      sym_atom,
    STATE(6850), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6851), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(6224), 8,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_in,
    ACTIONS(6506), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [434705] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6750), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6748), 39,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [434755] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6710), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6708), 39,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [434805] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6647), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6645), 39,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [434855] = 23,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6364), 1,
      sym__newline,
    ACTIONS(6840), 1,
      sym_id,
    ACTIONS(6842), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6846), 1,
      anon_sym_record,
    ACTIONS(6848), 1,
      anon_sym_LPAREN,
    ACTIONS(6850), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(6852), 1,
      anon_sym_u2983,
    ACTIONS(6854), 1,
      anon_sym_LBRACE,
    ACTIONS(6856), 1,
      aux_sym__qid_token1,
    ACTIONS(6858), 1,
      anon_sym_DOT,
    ACTIONS(6860), 1,
      anon_sym_PIPE,
    ACTIONS(6862), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(6864), 1,
      anon_sym_u2987,
    ACTIONS(6866), 1,
      aux_sym_integer_token1,
    ACTIONS(6868), 1,
      aux_sym_string_token1,
    ACTIONS(6870), 1,
      anon_sym_Set,
    STATE(4060), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7069), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    ACTIONS(6336), 6,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_in,
    STATE(7066), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(6844), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [434945] = 5,
    ACTIONS(6488), 1,
      anon_sym_BSLASH,
    ACTIONS(6492), 1,
      sym__newline,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6490), 7,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_in,
    ACTIONS(6486), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [434999] = 22,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6226), 1,
      sym__newline,
    ACTIONS(6716), 1,
      sym_id,
    ACTIONS(6718), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6722), 1,
      anon_sym_record,
    ACTIONS(6724), 1,
      anon_sym_LPAREN,
    ACTIONS(6726), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(6728), 1,
      anon_sym_u2983,
    ACTIONS(6730), 1,
      anon_sym_LBRACE,
    ACTIONS(6732), 1,
      aux_sym__qid_token1,
    ACTIONS(6734), 1,
      anon_sym_DOT,
    ACTIONS(6738), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(6740), 1,
      anon_sym_u2987,
    ACTIONS(6742), 1,
      aux_sym_integer_token1,
    ACTIONS(6744), 1,
      aux_sym_string_token1,
    ACTIONS(6746), 1,
      anon_sym_Set,
    STATE(6812), 1,
      sym_atom,
    STATE(6805), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6809), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(6224), 8,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_PIPE,
      anon_sym_in,
    ACTIONS(6720), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [435087] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6484), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6482), 39,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [435137] = 26,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6872), 1,
      sym_id,
    ACTIONS(6874), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6878), 1,
      anon_sym_record,
    ACTIONS(6880), 1,
      anon_sym_public,
    ACTIONS(6884), 1,
      anon_sym_LPAREN,
    ACTIONS(6886), 1,
      anon_sym_renaming,
    ACTIONS(6888), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(6890), 1,
      anon_sym_u2983,
    ACTIONS(6892), 1,
      anon_sym_LBRACE,
    ACTIONS(6894), 1,
      aux_sym__qid_token1,
    ACTIONS(6896), 1,
      anon_sym_DOT,
    ACTIONS(6898), 1,
      anon_sym_in,
    ACTIONS(6900), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(6902), 1,
      anon_sym_u2987,
    ACTIONS(6904), 1,
      aux_sym_integer_token1,
    ACTIONS(6906), 1,
      aux_sym_string_token1,
    ACTIONS(6908), 1,
      anon_sym_Set,
    ACTIONS(6910), 1,
      sym__newline,
    ACTIONS(6882), 2,
      anon_sym_using,
      anon_sym_hiding,
    STATE(4067), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(9007), 2,
      aux_sym__import_directives,
      sym_import_directive,
    STATE(7256), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(6876), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [435233] = 22,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6226), 1,
      sym__newline,
    ACTIONS(6534), 1,
      sym_id,
    ACTIONS(6536), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6540), 1,
      anon_sym_record,
    ACTIONS(6542), 1,
      anon_sym_LPAREN,
    ACTIONS(6544), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(6546), 1,
      anon_sym_u2983,
    ACTIONS(6548), 1,
      anon_sym_LBRACE,
    ACTIONS(6550), 1,
      aux_sym__qid_token1,
    ACTIONS(6552), 1,
      anon_sym_DOT,
    ACTIONS(6556), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(6558), 1,
      anon_sym_u2987,
    ACTIONS(6560), 1,
      aux_sym_integer_token1,
    ACTIONS(6562), 1,
      aux_sym_string_token1,
    ACTIONS(6564), 1,
      anon_sym_Set,
    STATE(6823), 1,
      sym_atom,
    STATE(6795), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6796), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(6224), 8,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_PIPE,
    ACTIONS(6538), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [435321] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6484), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6482), 39,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [435371] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6710), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6708), 39,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [435421] = 5,
    ACTIONS(6488), 1,
      anon_sym_BSLASH,
    ACTIONS(6492), 1,
      sym__newline,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6490), 7,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_in,
    ACTIONS(6486), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [435475] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6750), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6748), 39,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [435525] = 5,
    ACTIONS(6488), 1,
      anon_sym_BSLASH,
    ACTIONS(6492), 1,
      sym__newline,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6490), 7,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
    ACTIONS(6486), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [435579] = 26,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6912), 1,
      sym_id,
    ACTIONS(6914), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6918), 1,
      anon_sym_record,
    ACTIONS(6920), 1,
      anon_sym_public,
    ACTIONS(6924), 1,
      anon_sym_LPAREN,
    ACTIONS(6926), 1,
      anon_sym_renaming,
    ACTIONS(6928), 1,
      anon_sym_SEMI,
    ACTIONS(6930), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(6932), 1,
      anon_sym_u2983,
    ACTIONS(6934), 1,
      anon_sym_LBRACE,
    ACTIONS(6936), 1,
      anon_sym_RBRACE,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(6940), 1,
      anon_sym_DOT,
    ACTIONS(6942), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(6944), 1,
      anon_sym_u2987,
    ACTIONS(6946), 1,
      aux_sym_integer_token1,
    ACTIONS(6948), 1,
      aux_sym_string_token1,
    ACTIONS(6950), 1,
      anon_sym_Set,
    ACTIONS(6922), 2,
      anon_sym_using,
      anon_sym_hiding,
    STATE(4411), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7268), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(9005), 2,
      aux_sym__import_directives,
      sym_import_directive,
    STATE(7266), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(6916), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [435675] = 5,
    ACTIONS(6488), 1,
      anon_sym_BSLASH,
    ACTIONS(6492), 1,
      sym__newline,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6490), 8,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_in,
    ACTIONS(6486), 31,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [435729] = 19,
    ACTIONS(6226), 1,
      anon_sym_BSLASH,
    ACTIONS(6952), 1,
      sym_id,
    ACTIONS(6956), 1,
      anon_sym_record,
    ACTIONS(6958), 1,
      anon_sym_LPAREN,
    ACTIONS(6960), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(6962), 1,
      anon_sym_u2983,
    ACTIONS(6964), 1,
      anon_sym_LBRACE,
    ACTIONS(6966), 1,
      aux_sym__qid_token1,
    ACTIONS(6968), 1,
      anon_sym_DOT,
    ACTIONS(6970), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(6972), 1,
      anon_sym_u2987,
    ACTIONS(6976), 1,
      anon_sym_Set,
    STATE(6829), 1,
      sym_atom,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6974), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6791), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6826), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(6224), 8,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_let,
      anon_sym_do,
    ACTIONS(6954), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [435811] = 22,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6241), 1,
      sym__newline,
    ACTIONS(6978), 1,
      sym_id,
    ACTIONS(6981), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6987), 1,
      anon_sym_record,
    ACTIONS(6990), 1,
      anon_sym_LPAREN,
    ACTIONS(6993), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(6996), 1,
      anon_sym_u2983,
    ACTIONS(6999), 1,
      anon_sym_LBRACE,
    ACTIONS(7002), 1,
      aux_sym__qid_token1,
    ACTIONS(7005), 1,
      anon_sym_DOT,
    ACTIONS(7008), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(7011), 1,
      anon_sym_u2987,
    ACTIONS(7014), 1,
      aux_sym_integer_token1,
    ACTIONS(7017), 1,
      aux_sym_string_token1,
    ACTIONS(7020), 1,
      anon_sym_Set,
    STATE(4060), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7069), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    ACTIONS(6239), 7,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_PIPE,
      anon_sym_in,
    STATE(7066), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(6984), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [435899] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6433), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6431), 39,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [435949] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6714), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6712), 39,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [435999] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6754), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6752), 39,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [436049] = 26,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6912), 1,
      sym_id,
    ACTIONS(6914), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6918), 1,
      anon_sym_record,
    ACTIONS(6920), 1,
      anon_sym_public,
    ACTIONS(6924), 1,
      anon_sym_LPAREN,
    ACTIONS(6926), 1,
      anon_sym_renaming,
    ACTIONS(6930), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(6932), 1,
      anon_sym_u2983,
    ACTIONS(6934), 1,
      anon_sym_LBRACE,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(6940), 1,
      anon_sym_DOT,
    ACTIONS(6942), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(6944), 1,
      anon_sym_u2987,
    ACTIONS(6946), 1,
      aux_sym_integer_token1,
    ACTIONS(6948), 1,
      aux_sym_string_token1,
    ACTIONS(6950), 1,
      anon_sym_Set,
    ACTIONS(7023), 1,
      anon_sym_SEMI,
    ACTIONS(7025), 1,
      anon_sym_RBRACE,
    ACTIONS(6922), 2,
      anon_sym_using,
      anon_sym_hiding,
    STATE(4057), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7268), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(9025), 2,
      aux_sym__import_directives,
      sym_import_directive,
    STATE(7266), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(6916), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [436145] = 23,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6364), 1,
      sym__newline,
    ACTIONS(7027), 1,
      sym_id,
    ACTIONS(7029), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7033), 1,
      anon_sym_record,
    ACTIONS(7035), 1,
      anon_sym_LPAREN,
    ACTIONS(7037), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(7039), 1,
      anon_sym_u2983,
    ACTIONS(7041), 1,
      anon_sym_LBRACE,
    ACTIONS(7043), 1,
      aux_sym__qid_token1,
    ACTIONS(7045), 1,
      anon_sym_DOT,
    ACTIONS(7047), 1,
      anon_sym_PIPE,
    ACTIONS(7049), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(7051), 1,
      anon_sym_u2987,
    ACTIONS(7053), 1,
      aux_sym_integer_token1,
    ACTIONS(7055), 1,
      aux_sym_string_token1,
    ACTIONS(7057), 1,
      anon_sym_Set,
    STATE(4084), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(6939), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    ACTIONS(6336), 6,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
    STATE(6933), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(7031), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [436235] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6496), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6494), 39,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [436285] = 26,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6872), 1,
      sym_id,
    ACTIONS(6874), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6878), 1,
      anon_sym_record,
    ACTIONS(6880), 1,
      anon_sym_public,
    ACTIONS(6884), 1,
      anon_sym_LPAREN,
    ACTIONS(6886), 1,
      anon_sym_renaming,
    ACTIONS(6888), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(6890), 1,
      anon_sym_u2983,
    ACTIONS(6892), 1,
      anon_sym_LBRACE,
    ACTIONS(6894), 1,
      aux_sym__qid_token1,
    ACTIONS(6896), 1,
      anon_sym_DOT,
    ACTIONS(6900), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(6902), 1,
      anon_sym_u2987,
    ACTIONS(6904), 1,
      aux_sym_integer_token1,
    ACTIONS(6906), 1,
      aux_sym_string_token1,
    ACTIONS(6908), 1,
      anon_sym_Set,
    ACTIONS(7059), 1,
      anon_sym_in,
    ACTIONS(7061), 1,
      sym__newline,
    ACTIONS(6882), 2,
      anon_sym_using,
      anon_sym_hiding,
    STATE(4397), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(9040), 2,
      aux_sym__import_directives,
      sym_import_directive,
    STATE(7256), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(6876), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [436381] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6651), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6649), 39,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [436431] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6714), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6712), 39,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [436481] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6484), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6482), 39,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [436531] = 4,
    ACTIONS(7063), 1,
      anon_sym_AT,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6326), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6324), 38,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [436583] = 23,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6364), 1,
      sym__newline,
    ACTIONS(7065), 1,
      sym_id,
    ACTIONS(7067), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7071), 1,
      anon_sym_record,
    ACTIONS(7073), 1,
      anon_sym_LPAREN,
    ACTIONS(7075), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(7077), 1,
      anon_sym_u2983,
    ACTIONS(7079), 1,
      anon_sym_LBRACE,
    ACTIONS(7081), 1,
      aux_sym__qid_token1,
    ACTIONS(7083), 1,
      anon_sym_DOT,
    ACTIONS(7085), 1,
      anon_sym_PIPE,
    ACTIONS(7087), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(7089), 1,
      anon_sym_u2987,
    ACTIONS(7091), 1,
      aux_sym_integer_token1,
    ACTIONS(7093), 1,
      aux_sym_string_token1,
    ACTIONS(7095), 1,
      anon_sym_Set,
    STATE(4121), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(6955), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    ACTIONS(6336), 6,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
    STATE(6945), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(7069), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [436673] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6710), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6708), 39,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [436723] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6655), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6653), 39,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [436773] = 4,
    ACTIONS(7097), 1,
      anon_sym_AT,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6326), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6324), 38,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [436825] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6750), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6748), 39,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [436875] = 23,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6364), 1,
      sym__newline,
    ACTIONS(7099), 1,
      sym_id,
    ACTIONS(7101), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7105), 1,
      anon_sym_record,
    ACTIONS(7107), 1,
      anon_sym_LPAREN,
    ACTIONS(7109), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(7111), 1,
      anon_sym_u2983,
    ACTIONS(7113), 1,
      anon_sym_LBRACE,
    ACTIONS(7115), 1,
      aux_sym__qid_token1,
    ACTIONS(7117), 1,
      anon_sym_DOT,
    ACTIONS(7119), 1,
      anon_sym_PIPE,
    ACTIONS(7121), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(7123), 1,
      anon_sym_u2987,
    ACTIONS(7125), 1,
      aux_sym_integer_token1,
    ACTIONS(7127), 1,
      aux_sym_string_token1,
    ACTIONS(7129), 1,
      anon_sym_Set,
    STATE(4088), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(6905), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    ACTIONS(6336), 6,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_in,
    STATE(6865), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(7103), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [436965] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6754), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6752), 39,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [437015] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6433), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6431), 39,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [437065] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6714), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6712), 39,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [437115] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6433), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6431), 39,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [437165] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6572), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6570), 39,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [437215] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6754), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6752), 39,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [437265] = 22,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6241), 1,
      sym__newline,
    ACTIONS(7131), 1,
      sym_id,
    ACTIONS(7134), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7140), 1,
      anon_sym_record,
    ACTIONS(7143), 1,
      anon_sym_LPAREN,
    ACTIONS(7146), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(7149), 1,
      anon_sym_u2983,
    ACTIONS(7152), 1,
      anon_sym_LBRACE,
    ACTIONS(7155), 1,
      aux_sym__qid_token1,
    ACTIONS(7158), 1,
      anon_sym_DOT,
    ACTIONS(7161), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(7164), 1,
      anon_sym_u2987,
    ACTIONS(7167), 1,
      aux_sym_integer_token1,
    ACTIONS(7170), 1,
      aux_sym_string_token1,
    ACTIONS(7173), 1,
      anon_sym_Set,
    STATE(4084), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(6939), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    ACTIONS(6239), 7,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_PIPE,
    STATE(6933), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(7137), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [437353] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6496), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6494), 39,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [437403] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6647), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6645), 39,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [437453] = 4,
    ACTIONS(7176), 1,
      anon_sym_AT,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6326), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6324), 38,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [437505] = 22,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6241), 1,
      sym__newline,
    ACTIONS(7178), 1,
      sym_id,
    ACTIONS(7181), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7187), 1,
      anon_sym_record,
    ACTIONS(7190), 1,
      anon_sym_LPAREN,
    ACTIONS(7193), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(7196), 1,
      anon_sym_u2983,
    ACTIONS(7199), 1,
      anon_sym_LBRACE,
    ACTIONS(7202), 1,
      aux_sym__qid_token1,
    ACTIONS(7205), 1,
      anon_sym_DOT,
    ACTIONS(7208), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(7211), 1,
      anon_sym_u2987,
    ACTIONS(7214), 1,
      aux_sym_integer_token1,
    ACTIONS(7217), 1,
      aux_sym_string_token1,
    ACTIONS(7220), 1,
      anon_sym_Set,
    STATE(4088), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(6905), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    ACTIONS(6239), 7,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_in,
    STATE(6865), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(7184), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [437593] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6326), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6324), 39,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [437643] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6655), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6653), 39,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [437693] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6651), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6649), 39,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [437743] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6647), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6645), 39,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [437793] = 19,
    ACTIONS(6241), 1,
      anon_sym_BSLASH,
    ACTIONS(7223), 1,
      sym_id,
    ACTIONS(7229), 1,
      anon_sym_record,
    ACTIONS(7232), 1,
      anon_sym_LPAREN,
    ACTIONS(7235), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(7238), 1,
      anon_sym_u2983,
    ACTIONS(7241), 1,
      anon_sym_LBRACE,
    ACTIONS(7244), 1,
      aux_sym__qid_token1,
    ACTIONS(7247), 1,
      anon_sym_DOT,
    ACTIONS(7250), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(7253), 1,
      anon_sym_u2987,
    ACTIONS(7259), 1,
      anon_sym_Set,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(7256), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(4093), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(6904), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    ACTIONS(6239), 7,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_let,
      anon_sym_do,
    STATE(7094), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(7226), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [437875] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6655), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6653), 39,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [437925] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6572), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6570), 39,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [437975] = 4,
    ACTIONS(7262), 1,
      anon_sym_AT,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6326), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6324), 38,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [438027] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6496), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6494), 39,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [438077] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6568), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6566), 39,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [438127] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6500), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6498), 39,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [438177] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6496), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6494), 39,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [438227] = 4,
    ACTIONS(7264), 1,
      anon_sym_AT,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6326), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6324), 38,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [438279] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6568), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6566), 39,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [438329] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6484), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6482), 39,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [438379] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6500), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6498), 39,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [438429] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6326), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6324), 39,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [438479] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6568), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6566), 39,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [438529] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6326), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6324), 39,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [438579] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6710), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6708), 39,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [438629] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6750), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6748), 39,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [438679] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6433), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6431), 39,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [438729] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6572), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6570), 39,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [438779] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6714), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6712), 39,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [438829] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6754), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6752), 39,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [438879] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6500), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6498), 39,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [438929] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6651), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6649), 39,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [438979] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6647), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6645), 39,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [439029] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6572), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6570), 39,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [439079] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6568), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6566), 39,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [439129] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6500), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6498), 39,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [439179] = 4,
    ACTIONS(7266), 1,
      anon_sym_AT,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6326), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6324), 38,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [439231] = 22,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6241), 1,
      sym__newline,
    ACTIONS(7268), 1,
      sym_id,
    ACTIONS(7271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7277), 1,
      anon_sym_record,
    ACTIONS(7280), 1,
      anon_sym_LPAREN,
    ACTIONS(7283), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(7286), 1,
      anon_sym_u2983,
    ACTIONS(7289), 1,
      anon_sym_LBRACE,
    ACTIONS(7292), 1,
      aux_sym__qid_token1,
    ACTIONS(7295), 1,
      anon_sym_DOT,
    ACTIONS(7298), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(7301), 1,
      anon_sym_u2987,
    ACTIONS(7304), 1,
      aux_sym_integer_token1,
    ACTIONS(7307), 1,
      aux_sym_string_token1,
    ACTIONS(7310), 1,
      anon_sym_Set,
    STATE(4121), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(6955), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    ACTIONS(6239), 7,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_PIPE,
    STATE(6945), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(7274), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [439319] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6651), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6649), 39,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [439369] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6326), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6324), 39,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [439419] = 22,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6226), 1,
      sym__newline,
    ACTIONS(7027), 1,
      sym_id,
    ACTIONS(7029), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7033), 1,
      anon_sym_record,
    ACTIONS(7035), 1,
      anon_sym_LPAREN,
    ACTIONS(7037), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(7039), 1,
      anon_sym_u2983,
    ACTIONS(7041), 1,
      anon_sym_LBRACE,
    ACTIONS(7043), 1,
      aux_sym__qid_token1,
    ACTIONS(7045), 1,
      anon_sym_DOT,
    ACTIONS(7049), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(7051), 1,
      anon_sym_u2987,
    ACTIONS(7053), 1,
      aux_sym_integer_token1,
    ACTIONS(7055), 1,
      aux_sym_string_token1,
    ACTIONS(7057), 1,
      anon_sym_Set,
    STATE(6980), 1,
      sym_atom,
    STATE(6939), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    ACTIONS(6224), 7,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_PIPE,
    STATE(6933), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(7031), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [439506] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6572), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6570), 38,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [439555] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6714), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6712), 38,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [439604] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6754), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6752), 38,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [439653] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6500), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6498), 38,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [439702] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6651), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6649), 38,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [439751] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6647), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6645), 38,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [439800] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6572), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6570), 38,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [439849] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6568), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6566), 38,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [439898] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6500), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6498), 38,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [439947] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6568), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6566), 38,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [439996] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6572), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6570), 38,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [440045] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6647), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6645), 38,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [440094] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6651), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6649), 38,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [440143] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6326), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6324), 38,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [440192] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6754), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6752), 38,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [440241] = 4,
    ACTIONS(7313), 1,
      anon_sym_AT,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6326), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6324), 37,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [440292] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6655), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6653), 38,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [440341] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6496), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6494), 38,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [440390] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6655), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6653), 38,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [440439] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6714), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6712), 38,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [440488] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6433), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6431), 38,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [440537] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6496), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6494), 38,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [440586] = 4,
    ACTIONS(7315), 1,
      anon_sym_AT,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6326), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6324), 37,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [440637] = 4,
    ACTIONS(7317), 1,
      anon_sym_AT,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6326), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6324), 37,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [440688] = 22,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6241), 1,
      sym__newline,
    ACTIONS(7319), 1,
      sym_id,
    ACTIONS(7322), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7328), 1,
      anon_sym_record,
    ACTIONS(7331), 1,
      anon_sym_LPAREN,
    ACTIONS(7334), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(7337), 1,
      anon_sym_u2983,
    ACTIONS(7340), 1,
      anon_sym_LBRACE,
    ACTIONS(7343), 1,
      aux_sym__qid_token1,
    ACTIONS(7346), 1,
      anon_sym_DOT,
    ACTIONS(7349), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(7352), 1,
      anon_sym_u2987,
    ACTIONS(7355), 1,
      aux_sym_integer_token1,
    ACTIONS(7358), 1,
      aux_sym_string_token1,
    ACTIONS(7361), 1,
      anon_sym_Set,
    STATE(4149), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7163), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    ACTIONS(6239), 6,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_in,
    STATE(7161), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(7325), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [440775] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6750), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6748), 38,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [440824] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6710), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6708), 38,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [440873] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6326), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6324), 38,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [440922] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6484), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6482), 38,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [440971] = 5,
    ACTIONS(6488), 1,
      anon_sym_BSLASH,
    ACTIONS(6492), 1,
      sym__newline,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6490), 7,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
    ACTIONS(6486), 31,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [441024] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6750), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6748), 38,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [441073] = 23,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6364), 1,
      sym__newline,
    ACTIONS(7364), 1,
      sym_id,
    ACTIONS(7366), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7370), 1,
      anon_sym_record,
    ACTIONS(7372), 1,
      anon_sym_LPAREN,
    ACTIONS(7374), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(7376), 1,
      anon_sym_u2983,
    ACTIONS(7378), 1,
      anon_sym_LBRACE,
    ACTIONS(7380), 1,
      aux_sym__qid_token1,
    ACTIONS(7382), 1,
      anon_sym_DOT,
    ACTIONS(7384), 1,
      anon_sym_PIPE,
    ACTIONS(7386), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(7388), 1,
      anon_sym_u2987,
    ACTIONS(7390), 1,
      aux_sym_integer_token1,
    ACTIONS(7392), 1,
      aux_sym_string_token1,
    ACTIONS(7394), 1,
      anon_sym_Set,
    STATE(4187), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7162), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    ACTIONS(6336), 5,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
    STATE(7144), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(7368), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [441162] = 23,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6364), 1,
      sym__newline,
    ACTIONS(7396), 1,
      sym_id,
    ACTIONS(7398), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7402), 1,
      anon_sym_record,
    ACTIONS(7404), 1,
      anon_sym_LPAREN,
    ACTIONS(7406), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(7408), 1,
      anon_sym_u2983,
    ACTIONS(7410), 1,
      anon_sym_LBRACE,
    ACTIONS(7412), 1,
      aux_sym__qid_token1,
    ACTIONS(7414), 1,
      anon_sym_DOT,
    ACTIONS(7416), 1,
      anon_sym_PIPE,
    ACTIONS(7418), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(7420), 1,
      anon_sym_u2987,
    ACTIONS(7422), 1,
      aux_sym_integer_token1,
    ACTIONS(7424), 1,
      aux_sym_string_token1,
    ACTIONS(7426), 1,
      anon_sym_Set,
    STATE(4149), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7163), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    ACTIONS(6336), 5,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_in,
    STATE(7161), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(7400), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [441251] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6710), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6708), 38,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [441300] = 4,
    ACTIONS(7428), 1,
      anon_sym_AT,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6326), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6324), 37,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [441351] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6496), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6494), 38,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [441400] = 4,
    ACTIONS(7430), 1,
      anon_sym_AT,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6326), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6324), 37,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [441451] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6484), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6482), 38,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [441500] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6500), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6498), 38,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [441549] = 23,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6364), 1,
      sym__newline,
    ACTIONS(7432), 1,
      sym_id,
    ACTIONS(7434), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7438), 1,
      anon_sym_record,
    ACTIONS(7440), 1,
      anon_sym_LPAREN,
    ACTIONS(7442), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(7444), 1,
      anon_sym_u2983,
    ACTIONS(7446), 1,
      anon_sym_LBRACE,
    ACTIONS(7448), 1,
      aux_sym__qid_token1,
    ACTIONS(7450), 1,
      anon_sym_DOT,
    ACTIONS(7452), 1,
      anon_sym_PIPE,
    ACTIONS(7454), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(7456), 1,
      anon_sym_u2987,
    ACTIONS(7458), 1,
      aux_sym_integer_token1,
    ACTIONS(7460), 1,
      aux_sym_string_token1,
    ACTIONS(7462), 1,
      anon_sym_Set,
    STATE(4211), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7168), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    ACTIONS(6336), 5,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
    STATE(7173), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(7436), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [441638] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6568), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6566), 38,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [441687] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6572), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6570), 38,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [441736] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6647), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6645), 38,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [441785] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6651), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6649), 38,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [441834] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6655), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6653), 38,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [441883] = 22,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6241), 1,
      sym__newline,
    ACTIONS(7464), 1,
      sym_id,
    ACTIONS(7467), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7473), 1,
      anon_sym_record,
    ACTIONS(7476), 1,
      anon_sym_LPAREN,
    ACTIONS(7479), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(7482), 1,
      anon_sym_u2983,
    ACTIONS(7485), 1,
      anon_sym_LBRACE,
    ACTIONS(7488), 1,
      aux_sym__qid_token1,
    ACTIONS(7491), 1,
      anon_sym_DOT,
    ACTIONS(7494), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(7497), 1,
      anon_sym_u2987,
    ACTIONS(7500), 1,
      aux_sym_integer_token1,
    ACTIONS(7503), 1,
      aux_sym_string_token1,
    ACTIONS(7506), 1,
      anon_sym_Set,
    STATE(4170), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7129), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    ACTIONS(6239), 6,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_PIPE,
      anon_sym_in,
    STATE(7130), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(7470), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [441970] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6754), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6752), 38,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [442019] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6714), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6712), 38,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [442068] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6326), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6324), 38,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [442117] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6326), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6324), 38,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [442166] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6433), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6431), 38,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [442215] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6750), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6748), 38,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [442264] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6484), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6482), 38,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [442313] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6710), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6708), 38,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [442362] = 19,
    ACTIONS(6226), 1,
      anon_sym_BSLASH,
    ACTIONS(7509), 1,
      sym_id,
    ACTIONS(7513), 1,
      anon_sym_record,
    ACTIONS(7515), 1,
      anon_sym_LPAREN,
    ACTIONS(7517), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(7519), 1,
      anon_sym_u2983,
    ACTIONS(7521), 1,
      anon_sym_LBRACE,
    ACTIONS(7523), 1,
      aux_sym__qid_token1,
    ACTIONS(7525), 1,
      anon_sym_DOT,
    ACTIONS(7527), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(7529), 1,
      anon_sym_u2987,
    ACTIONS(7533), 1,
      anon_sym_Set,
    STATE(7101), 1,
      sym_atom,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(7531), 2,
      aux_sym_integer_token1,
      aux_sym_string_token1,
    STATE(6904), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    ACTIONS(6224), 7,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_let,
      anon_sym_do,
    STATE(7094), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(7511), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [442443] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6710), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6708), 38,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [442492] = 5,
    ACTIONS(6488), 1,
      anon_sym_BSLASH,
    ACTIONS(6492), 1,
      sym__newline,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6490), 6,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_in,
    ACTIONS(6486), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [442545] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6750), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6748), 38,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [442594] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6433), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6431), 38,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [442643] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6710), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6708), 38,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [442692] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6433), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6431), 38,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [442741] = 23,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6364), 1,
      sym__newline,
    ACTIONS(7535), 1,
      sym_id,
    ACTIONS(7537), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7541), 1,
      anon_sym_record,
    ACTIONS(7543), 1,
      anon_sym_LPAREN,
    ACTIONS(7545), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(7547), 1,
      anon_sym_u2983,
    ACTIONS(7549), 1,
      anon_sym_LBRACE,
    ACTIONS(7551), 1,
      aux_sym__qid_token1,
    ACTIONS(7553), 1,
      anon_sym_DOT,
    ACTIONS(7555), 1,
      anon_sym_PIPE,
    ACTIONS(7557), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(7559), 1,
      anon_sym_u2987,
    ACTIONS(7561), 1,
      aux_sym_integer_token1,
    ACTIONS(7563), 1,
      aux_sym_string_token1,
    ACTIONS(7565), 1,
      anon_sym_Set,
    STATE(4170), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7129), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    ACTIONS(6336), 5,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_in,
    STATE(7130), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(7539), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [442830] = 22,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6241), 1,
      sym__newline,
    ACTIONS(7567), 1,
      sym_id,
    ACTIONS(7570), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7576), 1,
      anon_sym_record,
    ACTIONS(7579), 1,
      anon_sym_LPAREN,
    ACTIONS(7582), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(7585), 1,
      anon_sym_u2983,
    ACTIONS(7588), 1,
      anon_sym_LBRACE,
    ACTIONS(7591), 1,
      aux_sym__qid_token1,
    ACTIONS(7594), 1,
      anon_sym_DOT,
    ACTIONS(7597), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(7600), 1,
      anon_sym_u2987,
    ACTIONS(7603), 1,
      aux_sym_integer_token1,
    ACTIONS(7606), 1,
      aux_sym_string_token1,
    ACTIONS(7609), 1,
      anon_sym_Set,
    STATE(4187), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7162), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    ACTIONS(6239), 6,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_PIPE,
    STATE(7144), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(7573), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [442917] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6714), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6712), 38,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [442966] = 5,
    ACTIONS(6488), 1,
      anon_sym_BSLASH,
    ACTIONS(6492), 1,
      sym__newline,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6490), 6,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_in,
    ACTIONS(6486), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [443019] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6754), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6752), 38,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [443068] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6647), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6645), 38,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [443117] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6484), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6482), 38,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [443166] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6651), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6649), 38,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [443215] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6647), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6645), 38,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [443264] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6433), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6431), 38,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [443313] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6568), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6566), 38,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [443362] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6500), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6498), 38,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [443411] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6500), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6498), 38,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [443460] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6568), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6566), 38,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [443509] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6572), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6570), 38,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [443558] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6647), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6645), 38,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [443607] = 4,
    ACTIONS(7612), 1,
      anon_sym_AT,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6326), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6324), 37,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [443658] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6651), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6649), 38,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [443707] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6655), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6653), 38,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [443756] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6496), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6494), 38,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [443805] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6484), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6482), 38,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [443854] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6754), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6752), 38,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [443903] = 22,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6226), 1,
      sym__newline,
    ACTIONS(7099), 1,
      sym_id,
    ACTIONS(7101), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7105), 1,
      anon_sym_record,
    ACTIONS(7107), 1,
      anon_sym_LPAREN,
    ACTIONS(7109), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(7111), 1,
      anon_sym_u2983,
    ACTIONS(7113), 1,
      anon_sym_LBRACE,
    ACTIONS(7115), 1,
      aux_sym__qid_token1,
    ACTIONS(7117), 1,
      anon_sym_DOT,
    ACTIONS(7121), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(7123), 1,
      anon_sym_u2987,
    ACTIONS(7125), 1,
      aux_sym_integer_token1,
    ACTIONS(7127), 1,
      aux_sym_string_token1,
    ACTIONS(7129), 1,
      anon_sym_Set,
    STATE(6878), 1,
      sym_atom,
    STATE(6905), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    ACTIONS(6224), 7,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_in,
    STATE(6865), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(7103), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [443990] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6714), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6712), 38,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [444039] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6433), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6431), 38,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [444088] = 22,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6241), 1,
      sym__newline,
    ACTIONS(7614), 1,
      sym_id,
    ACTIONS(7617), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7623), 1,
      anon_sym_record,
    ACTIONS(7626), 1,
      anon_sym_LPAREN,
    ACTIONS(7629), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(7632), 1,
      anon_sym_u2983,
    ACTIONS(7635), 1,
      anon_sym_LBRACE,
    ACTIONS(7638), 1,
      aux_sym__qid_token1,
    ACTIONS(7641), 1,
      anon_sym_DOT,
    ACTIONS(7644), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(7647), 1,
      anon_sym_u2987,
    ACTIONS(7650), 1,
      aux_sym_integer_token1,
    ACTIONS(7653), 1,
      aux_sym_string_token1,
    ACTIONS(7656), 1,
      anon_sym_Set,
    STATE(4211), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7168), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    ACTIONS(6239), 6,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_PIPE,
    STATE(7173), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(7620), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [444175] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6750), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6748), 38,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [444224] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6496), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6494), 38,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [444273] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6710), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6708), 38,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [444322] = 4,
    ACTIONS(7659), 1,
      anon_sym_AT,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6326), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6324), 37,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [444373] = 5,
    ACTIONS(6488), 1,
      anon_sym_BSLASH,
    ACTIONS(6492), 1,
      sym__newline,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6490), 6,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
    ACTIONS(6486), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [444426] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6655), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6653), 38,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [444475] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6484), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6482), 38,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [444524] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6655), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6653), 38,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [444573] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6496), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6494), 38,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [444622] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6651), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6649), 38,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [444671] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6750), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6748), 38,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [444720] = 4,
    ACTIONS(7661), 1,
      anon_sym_AT,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6326), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6324), 37,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [444771] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6326), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6324), 38,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [444820] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6496), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6494), 38,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [444869] = 5,
    ACTIONS(6488), 1,
      anon_sym_BSLASH,
    ACTIONS(6492), 1,
      sym__newline,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6490), 8,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_in,
    ACTIONS(6486), 30,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [444922] = 5,
    ACTIONS(6488), 1,
      anon_sym_BSLASH,
    ACTIONS(6492), 1,
      sym__newline,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6490), 6,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
    ACTIONS(6486), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [444975] = 25,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6880), 1,
      anon_sym_public,
    ACTIONS(6886), 1,
      anon_sym_renaming,
    ACTIONS(6910), 1,
      sym__newline,
    ACTIONS(7663), 1,
      sym_id,
    ACTIONS(7665), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7669), 1,
      anon_sym_record,
    ACTIONS(7671), 1,
      anon_sym_LPAREN,
    ACTIONS(7673), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(7675), 1,
      anon_sym_u2983,
    ACTIONS(7677), 1,
      anon_sym_LBRACE,
    ACTIONS(7679), 1,
      aux_sym__qid_token1,
    ACTIONS(7681), 1,
      anon_sym_DOT,
    ACTIONS(7683), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(7685), 1,
      anon_sym_u2987,
    ACTIONS(7687), 1,
      aux_sym_integer_token1,
    ACTIONS(7689), 1,
      aux_sym_string_token1,
    ACTIONS(7691), 1,
      anon_sym_Set,
    ACTIONS(6882), 2,
      anon_sym_using,
      anon_sym_hiding,
    STATE(4252), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7400), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(9007), 2,
      aux_sym__import_directives,
      sym_import_directive,
    STATE(7291), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(7667), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [445068] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6500), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6498), 38,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [445117] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6568), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6566), 38,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [445166] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6655), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6653), 38,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [445215] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6572), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6570), 38,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [445264] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6714), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6712), 38,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [445313] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6647), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6645), 38,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [445362] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6754), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6752), 38,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [445411] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6714), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6712), 38,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [445460] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6500), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6498), 38,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [445509] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6326), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6324), 38,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [445558] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6568), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6566), 38,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [445607] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6754), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6752), 38,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [445656] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6326), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6324), 38,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [445705] = 22,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6226), 1,
      sym__newline,
    ACTIONS(7065), 1,
      sym_id,
    ACTIONS(7067), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7071), 1,
      anon_sym_record,
    ACTIONS(7073), 1,
      anon_sym_LPAREN,
    ACTIONS(7075), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(7077), 1,
      anon_sym_u2983,
    ACTIONS(7079), 1,
      anon_sym_LBRACE,
    ACTIONS(7081), 1,
      aux_sym__qid_token1,
    ACTIONS(7083), 1,
      anon_sym_DOT,
    ACTIONS(7087), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(7089), 1,
      anon_sym_u2987,
    ACTIONS(7091), 1,
      aux_sym_integer_token1,
    ACTIONS(7093), 1,
      aux_sym_string_token1,
    ACTIONS(7095), 1,
      anon_sym_Set,
    STATE(6936), 1,
      sym_atom,
    STATE(6955), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    ACTIONS(6224), 7,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_PIPE,
    STATE(6945), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(7069), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [445792] = 5,
    ACTIONS(6488), 1,
      anon_sym_BSLASH,
    ACTIONS(6492), 1,
      sym__newline,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6490), 7,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_in,
    ACTIONS(6486), 31,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [445845] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6572), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6570), 38,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [445894] = 25,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6920), 1,
      anon_sym_public,
    ACTIONS(6926), 1,
      anon_sym_renaming,
    ACTIONS(7061), 1,
      anon_sym_RPAREN,
    ACTIONS(7693), 1,
      sym_id,
    ACTIONS(7695), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7699), 1,
      anon_sym_record,
    ACTIONS(7701), 1,
      anon_sym_LPAREN,
    ACTIONS(7703), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(7705), 1,
      anon_sym_u2983,
    ACTIONS(7707), 1,
      anon_sym_LBRACE,
    ACTIONS(7709), 1,
      aux_sym__qid_token1,
    ACTIONS(7711), 1,
      anon_sym_DOT,
    ACTIONS(7713), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(7715), 1,
      anon_sym_u2987,
    ACTIONS(7717), 1,
      aux_sym_integer_token1,
    ACTIONS(7719), 1,
      aux_sym_string_token1,
    ACTIONS(7721), 1,
      anon_sym_Set,
    ACTIONS(6922), 2,
      anon_sym_using,
      anon_sym_hiding,
    STATE(4472), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7459), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(9110), 2,
      aux_sym__import_directives,
      sym_import_directive,
    STATE(7461), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(7697), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [445987] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6651), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6649), 38,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [446036] = 25,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6910), 1,
      anon_sym_RPAREN,
    ACTIONS(6920), 1,
      anon_sym_public,
    ACTIONS(6926), 1,
      anon_sym_renaming,
    ACTIONS(7693), 1,
      sym_id,
    ACTIONS(7695), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7699), 1,
      anon_sym_record,
    ACTIONS(7701), 1,
      anon_sym_LPAREN,
    ACTIONS(7703), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(7705), 1,
      anon_sym_u2983,
    ACTIONS(7707), 1,
      anon_sym_LBRACE,
    ACTIONS(7709), 1,
      aux_sym__qid_token1,
    ACTIONS(7711), 1,
      anon_sym_DOT,
    ACTIONS(7713), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(7715), 1,
      anon_sym_u2987,
    ACTIONS(7717), 1,
      aux_sym_integer_token1,
    ACTIONS(7719), 1,
      aux_sym_string_token1,
    ACTIONS(7721), 1,
      anon_sym_Set,
    ACTIONS(6922), 2,
      anon_sym_using,
      anon_sym_hiding,
    STATE(4245), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7459), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(9091), 2,
      aux_sym__import_directives,
      sym_import_directive,
    STATE(7461), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(7697), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [446129] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6433), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6431), 38,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [446178] = 4,
    ACTIONS(7723), 1,
      anon_sym_AT,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6326), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6324), 37,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [446229] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6750), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6748), 38,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [446278] = 22,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6226), 1,
      sym__newline,
    ACTIONS(6840), 1,
      sym_id,
    ACTIONS(6842), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6846), 1,
      anon_sym_record,
    ACTIONS(6848), 1,
      anon_sym_LPAREN,
    ACTIONS(6850), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(6852), 1,
      anon_sym_u2983,
    ACTIONS(6854), 1,
      anon_sym_LBRACE,
    ACTIONS(6856), 1,
      aux_sym__qid_token1,
    ACTIONS(6858), 1,
      anon_sym_DOT,
    ACTIONS(6862), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(6864), 1,
      anon_sym_u2987,
    ACTIONS(6866), 1,
      aux_sym_integer_token1,
    ACTIONS(6868), 1,
      aux_sym_string_token1,
    ACTIONS(6870), 1,
      anon_sym_Set,
    STATE(7072), 1,
      sym_atom,
    STATE(7069), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    ACTIONS(6224), 7,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_PIPE,
      anon_sym_in,
    STATE(7066), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(6844), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [446365] = 25,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6880), 1,
      anon_sym_public,
    ACTIONS(6886), 1,
      anon_sym_renaming,
    ACTIONS(7061), 1,
      sym__newline,
    ACTIONS(7663), 1,
      sym_id,
    ACTIONS(7665), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7669), 1,
      anon_sym_record,
    ACTIONS(7671), 1,
      anon_sym_LPAREN,
    ACTIONS(7673), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(7675), 1,
      anon_sym_u2983,
    ACTIONS(7677), 1,
      anon_sym_LBRACE,
    ACTIONS(7679), 1,
      aux_sym__qid_token1,
    ACTIONS(7681), 1,
      anon_sym_DOT,
    ACTIONS(7683), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(7685), 1,
      anon_sym_u2987,
    ACTIONS(7687), 1,
      aux_sym_integer_token1,
    ACTIONS(7689), 1,
      aux_sym_string_token1,
    ACTIONS(7691), 1,
      anon_sym_Set,
    ACTIONS(6882), 2,
      anon_sym_using,
      anon_sym_hiding,
    STATE(4566), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7400), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(9040), 2,
      aux_sym__import_directives,
      sym_import_directive,
    STATE(7291), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(7667), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [446458] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6710), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6708), 38,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [446507] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6484), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6482), 38,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [446556] = 5,
    ACTIONS(6488), 1,
      anon_sym_BSLASH,
    ACTIONS(6492), 1,
      sym__newline,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6490), 6,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_in,
    ACTIONS(6486), 31,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [446608] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6326), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6324), 37,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [446656] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6326), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6324), 37,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [446704] = 22,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6872), 1,
      sym_id,
    ACTIONS(6874), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6878), 1,
      anon_sym_record,
    ACTIONS(6884), 1,
      anon_sym_LPAREN,
    ACTIONS(6892), 1,
      anon_sym_LBRACE,
    ACTIONS(6894), 1,
      aux_sym__qid_token1,
    ACTIONS(6896), 1,
      anon_sym_DOT,
    ACTIONS(6900), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(6902), 1,
      anon_sym_u2987,
    ACTIONS(6904), 1,
      aux_sym_integer_token1,
    ACTIONS(6906), 1,
      aux_sym_string_token1,
    ACTIONS(6908), 1,
      anon_sym_Set,
    ACTIONS(7727), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(7729), 1,
      anon_sym_u2983,
    ACTIONS(7731), 1,
      sym__newline,
    STATE(4262), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    ACTIONS(7725), 5,
      anon_sym_public,
      anon_sym_using,
      anon_sym_hiding,
      anon_sym_renaming,
      anon_sym_in,
    STATE(7256), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(6876), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [446790] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6326), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6324), 37,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [446838] = 5,
    ACTIONS(6488), 1,
      anon_sym_BSLASH,
    ACTIONS(6492), 1,
      sym__newline,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6490), 5,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
    ACTIONS(6486), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [446890] = 5,
    ACTIONS(6488), 1,
      anon_sym_BSLASH,
    ACTIONS(6492), 1,
      sym__newline,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6490), 5,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
    ACTIONS(6486), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [446942] = 22,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6872), 1,
      sym_id,
    ACTIONS(6874), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6878), 1,
      anon_sym_record,
    ACTIONS(6884), 1,
      anon_sym_LPAREN,
    ACTIONS(6888), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(6890), 1,
      anon_sym_u2983,
    ACTIONS(6892), 1,
      anon_sym_LBRACE,
    ACTIONS(6894), 1,
      aux_sym__qid_token1,
    ACTIONS(6896), 1,
      anon_sym_DOT,
    ACTIONS(6900), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(6902), 1,
      anon_sym_u2987,
    ACTIONS(6904), 1,
      aux_sym_integer_token1,
    ACTIONS(6906), 1,
      aux_sym_string_token1,
    ACTIONS(6908), 1,
      anon_sym_Set,
    ACTIONS(7735), 1,
      sym__newline,
    STATE(4397), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    ACTIONS(7733), 5,
      anon_sym_public,
      anon_sym_using,
      anon_sym_hiding,
      anon_sym_renaming,
      anon_sym_in,
    STATE(7256), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(6876), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [447028] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6484), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6482), 37,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [447076] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6710), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6708), 37,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [447124] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6750), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6748), 37,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [447172] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6433), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6431), 37,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [447220] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6496), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6494), 37,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [447268] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6750), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6748), 37,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [447316] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6754), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6752), 37,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [447364] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6572), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6570), 37,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [447412] = 5,
    ACTIONS(6488), 1,
      anon_sym_BSLASH,
    ACTIONS(6492), 1,
      sym__newline,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6490), 7,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_in,
    ACTIONS(6486), 30,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [447464] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6651), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6649), 37,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [447512] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6484), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6482), 37,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [447560] = 4,
    ACTIONS(7737), 1,
      anon_sym_AT,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6326), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6324), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [447610] = 4,
    ACTIONS(7739), 1,
      anon_sym_AT,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6326), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6324), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [447660] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6647), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6645), 37,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [447708] = 22,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6226), 1,
      sym__newline,
    ACTIONS(7396), 1,
      sym_id,
    ACTIONS(7398), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7402), 1,
      anon_sym_record,
    ACTIONS(7404), 1,
      anon_sym_LPAREN,
    ACTIONS(7406), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(7408), 1,
      anon_sym_u2983,
    ACTIONS(7410), 1,
      anon_sym_LBRACE,
    ACTIONS(7412), 1,
      aux_sym__qid_token1,
    ACTIONS(7414), 1,
      anon_sym_DOT,
    ACTIONS(7418), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(7420), 1,
      anon_sym_u2987,
    ACTIONS(7422), 1,
      aux_sym_integer_token1,
    ACTIONS(7424), 1,
      aux_sym_string_token1,
    ACTIONS(7426), 1,
      anon_sym_Set,
    STATE(7170), 1,
      sym_atom,
    STATE(7163), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    ACTIONS(6224), 6,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_in,
    STATE(7161), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(7400), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [447794] = 5,
    ACTIONS(6488), 1,
      anon_sym_BSLASH,
    ACTIONS(6492), 1,
      sym__newline,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6490), 7,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
    ACTIONS(6486), 30,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [447846] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6572), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6570), 37,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [447894] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6568), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6566), 37,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [447942] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6326), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6324), 37,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [447990] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6484), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6482), 37,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [448038] = 4,
    ACTIONS(7741), 1,
      anon_sym_AT,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6326), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6324), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [448088] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6710), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6708), 37,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [448136] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6484), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6482), 37,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [448184] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6433), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6431), 37,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [448232] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6714), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6712), 37,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [448280] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6754), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6752), 37,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [448328] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6500), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6498), 37,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [448376] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6651), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6649), 37,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [448424] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6496), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6494), 37,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [448472] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6647), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6645), 37,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [448520] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6710), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6708), 37,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [448568] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6572), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6570), 37,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [448616] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6750), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6748), 37,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [448664] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6568), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6566), 37,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [448712] = 22,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6226), 1,
      sym__newline,
    ACTIONS(7364), 1,
      sym_id,
    ACTIONS(7366), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7370), 1,
      anon_sym_record,
    ACTIONS(7372), 1,
      anon_sym_LPAREN,
    ACTIONS(7374), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(7376), 1,
      anon_sym_u2983,
    ACTIONS(7378), 1,
      anon_sym_LBRACE,
    ACTIONS(7380), 1,
      aux_sym__qid_token1,
    ACTIONS(7382), 1,
      anon_sym_DOT,
    ACTIONS(7386), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(7388), 1,
      anon_sym_u2987,
    ACTIONS(7390), 1,
      aux_sym_integer_token1,
    ACTIONS(7392), 1,
      aux_sym_string_token1,
    ACTIONS(7394), 1,
      anon_sym_Set,
    STATE(7157), 1,
      sym_atom,
    STATE(7162), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    ACTIONS(6224), 6,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_PIPE,
    STATE(7144), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(7368), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [448798] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6500), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6498), 37,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [448846] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6433), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6431), 37,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [448894] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6714), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6712), 37,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [448942] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6754), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6752), 37,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [448990] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6651), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6649), 37,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [449038] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6647), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6645), 37,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [449086] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6572), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6570), 37,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [449134] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6568), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6566), 37,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [449182] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6500), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6498), 37,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [449230] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6484), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6482), 37,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [449278] = 22,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6226), 1,
      sym__newline,
    ACTIONS(7535), 1,
      sym_id,
    ACTIONS(7537), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7541), 1,
      anon_sym_record,
    ACTIONS(7543), 1,
      anon_sym_LPAREN,
    ACTIONS(7545), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(7547), 1,
      anon_sym_u2983,
    ACTIONS(7549), 1,
      anon_sym_LBRACE,
    ACTIONS(7551), 1,
      aux_sym__qid_token1,
    ACTIONS(7553), 1,
      anon_sym_DOT,
    ACTIONS(7557), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(7559), 1,
      anon_sym_u2987,
    ACTIONS(7561), 1,
      aux_sym_integer_token1,
    ACTIONS(7563), 1,
      aux_sym_string_token1,
    ACTIONS(7565), 1,
      anon_sym_Set,
    STATE(7127), 1,
      sym_atom,
    STATE(7129), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    ACTIONS(6224), 6,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_PIPE,
      anon_sym_in,
    STATE(7130), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(7539), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [449364] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6655), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6653), 37,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [449412] = 22,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6241), 1,
      sym__newline,
    ACTIONS(7743), 1,
      sym_id,
    ACTIONS(7746), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7752), 1,
      anon_sym_record,
    ACTIONS(7755), 1,
      anon_sym_LPAREN,
    ACTIONS(7758), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(7761), 1,
      anon_sym_u2983,
    ACTIONS(7764), 1,
      anon_sym_LBRACE,
    ACTIONS(7767), 1,
      aux_sym__qid_token1,
    ACTIONS(7770), 1,
      anon_sym_DOT,
    ACTIONS(7773), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(7776), 1,
      anon_sym_u2987,
    ACTIONS(7779), 1,
      aux_sym_integer_token1,
    ACTIONS(7782), 1,
      aux_sym_string_token1,
    ACTIONS(7785), 1,
      anon_sym_Set,
    STATE(4310), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7212), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    ACTIONS(6239), 5,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_in,
    STATE(7249), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(7749), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [449498] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6710), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6708), 37,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [449546] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6710), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6708), 37,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [449594] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6750), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6748), 37,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [449642] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6433), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6431), 37,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [449690] = 22,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6226), 1,
      sym__newline,
    ACTIONS(7432), 1,
      sym_id,
    ACTIONS(7434), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7438), 1,
      anon_sym_record,
    ACTIONS(7440), 1,
      anon_sym_LPAREN,
    ACTIONS(7442), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(7444), 1,
      anon_sym_u2983,
    ACTIONS(7446), 1,
      anon_sym_LBRACE,
    ACTIONS(7448), 1,
      aux_sym__qid_token1,
    ACTIONS(7450), 1,
      anon_sym_DOT,
    ACTIONS(7454), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(7456), 1,
      anon_sym_u2987,
    ACTIONS(7458), 1,
      aux_sym_integer_token1,
    ACTIONS(7460), 1,
      aux_sym_string_token1,
    ACTIONS(7462), 1,
      anon_sym_Set,
    STATE(7171), 1,
      sym_atom,
    STATE(7168), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    ACTIONS(6224), 6,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_PIPE,
    STATE(7173), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(7436), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [449776] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6714), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6712), 37,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [449824] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6754), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6752), 37,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [449872] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6496), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6494), 37,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [449920] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6651), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6649), 37,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [449968] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6647), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6645), 37,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [450016] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6572), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6570), 37,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [450064] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6568), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6566), 37,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [450112] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6500), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6498), 37,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [450160] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6433), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6431), 37,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [450208] = 4,
    ACTIONS(7788), 1,
      anon_sym_AT,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6326), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6324), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [450258] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6647), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6645), 37,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [450306] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6484), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6482), 37,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [450354] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6750), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6748), 37,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [450402] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6714), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6712), 37,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [450450] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6754), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6752), 37,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [450498] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6500), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6498), 37,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [450546] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6568), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6566), 37,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [450594] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6651), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6649), 37,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [450642] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6647), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6645), 37,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [450690] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6655), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6653), 37,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [450738] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6651), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6649), 37,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [450786] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6754), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6752), 37,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [450834] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6714), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6712), 37,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [450882] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6433), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6431), 37,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [450930] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6750), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6748), 37,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [450978] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6710), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6708), 37,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [451026] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6710), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6708), 37,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [451074] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6750), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6748), 37,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [451122] = 22,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6241), 1,
      sym__newline,
    ACTIONS(7790), 1,
      sym_id,
    ACTIONS(7793), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7799), 1,
      anon_sym_record,
    ACTIONS(7802), 1,
      anon_sym_LPAREN,
    ACTIONS(7805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(7808), 1,
      anon_sym_u2983,
    ACTIONS(7811), 1,
      anon_sym_LBRACE,
    ACTIONS(7814), 1,
      aux_sym__qid_token1,
    ACTIONS(7817), 1,
      anon_sym_DOT,
    ACTIONS(7820), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(7823), 1,
      anon_sym_u2987,
    ACTIONS(7826), 1,
      aux_sym_integer_token1,
    ACTIONS(7829), 1,
      aux_sym_string_token1,
    ACTIONS(7832), 1,
      anon_sym_Set,
    STATE(4344), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7226), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    ACTIONS(6239), 5,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_PIPE,
    STATE(7206), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(7796), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [451208] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6433), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6431), 37,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [451256] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6714), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6712), 37,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [451304] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6754), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6752), 37,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [451352] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6496), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6494), 37,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [451400] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6484), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6482), 37,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [451448] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6326), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6324), 37,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [451496] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6572), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6570), 37,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [451544] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6651), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6649), 37,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [451592] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6568), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6566), 37,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [451640] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6647), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6645), 37,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [451688] = 22,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6241), 1,
      sym__newline,
    ACTIONS(7835), 1,
      sym_id,
    ACTIONS(7838), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7844), 1,
      anon_sym_record,
    ACTIONS(7847), 1,
      anon_sym_LPAREN,
    ACTIONS(7850), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(7853), 1,
      anon_sym_u2983,
    ACTIONS(7856), 1,
      anon_sym_LBRACE,
    ACTIONS(7859), 1,
      aux_sym__qid_token1,
    ACTIONS(7862), 1,
      anon_sym_DOT,
    ACTIONS(7865), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(7868), 1,
      anon_sym_u2987,
    ACTIONS(7871), 1,
      aux_sym_integer_token1,
    ACTIONS(7874), 1,
      aux_sym_string_token1,
    ACTIONS(7877), 1,
      anon_sym_Set,
    STATE(4355), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7213), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    ACTIONS(6239), 5,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_PIPE,
    STATE(7209), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(7841), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [451774] = 23,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6364), 1,
      sym__newline,
    ACTIONS(7880), 1,
      sym_id,
    ACTIONS(7882), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7886), 1,
      anon_sym_record,
    ACTIONS(7888), 1,
      anon_sym_LPAREN,
    ACTIONS(7890), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(7892), 1,
      anon_sym_u2983,
    ACTIONS(7894), 1,
      anon_sym_LBRACE,
    ACTIONS(7896), 1,
      aux_sym__qid_token1,
    ACTIONS(7898), 1,
      anon_sym_DOT,
    ACTIONS(7900), 1,
      anon_sym_PIPE,
    ACTIONS(7902), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(7904), 1,
      anon_sym_u2987,
    ACTIONS(7906), 1,
      aux_sym_integer_token1,
    ACTIONS(7908), 1,
      aux_sym_string_token1,
    ACTIONS(7910), 1,
      anon_sym_Set,
    STATE(4380), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7276), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    ACTIONS(6336), 4,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_in,
    STATE(7267), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(7884), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [451862] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6655), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6653), 37,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [451910] = 4,
    ACTIONS(7912), 1,
      anon_sym_AT,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6326), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6324), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [451960] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6572), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6570), 37,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [452008] = 23,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6364), 1,
      sym__newline,
    ACTIONS(7914), 1,
      sym_id,
    ACTIONS(7916), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7920), 1,
      anon_sym_record,
    ACTIONS(7922), 1,
      anon_sym_LPAREN,
    ACTIONS(7924), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(7926), 1,
      anon_sym_u2983,
    ACTIONS(7928), 1,
      anon_sym_LBRACE,
    ACTIONS(7930), 1,
      aux_sym__qid_token1,
    ACTIONS(7932), 1,
      anon_sym_DOT,
    ACTIONS(7934), 1,
      anon_sym_PIPE,
    ACTIONS(7936), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(7938), 1,
      anon_sym_u2987,
    ACTIONS(7940), 1,
      aux_sym_integer_token1,
    ACTIONS(7942), 1,
      aux_sym_string_token1,
    ACTIONS(7944), 1,
      anon_sym_Set,
    STATE(4310), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7212), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    ACTIONS(6336), 4,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_in,
    STATE(7249), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(7918), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [452096] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6655), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6653), 37,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [452144] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6655), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6653), 37,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [452192] = 4,
    ACTIONS(7946), 1,
      anon_sym_AT,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6326), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6324), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [452242] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6496), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6494), 37,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [452290] = 5,
    ACTIONS(6488), 1,
      anon_sym_BSLASH,
    ACTIONS(6492), 1,
      sym__newline,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6490), 6,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
    ACTIONS(6486), 31,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [452342] = 5,
    ACTIONS(6488), 1,
      anon_sym_BSLASH,
    ACTIONS(6492), 1,
      sym__newline,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6490), 5,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_in,
    ACTIONS(6486), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [452394] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6500), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6498), 37,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [452442] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6568), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6566), 37,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [452490] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6496), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6494), 37,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [452538] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6572), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6570), 37,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [452586] = 5,
    ACTIONS(6488), 1,
      anon_sym_BSLASH,
    ACTIONS(6492), 1,
      sym__newline,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6490), 5,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_in,
    ACTIONS(6486), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [452638] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6647), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6645), 37,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [452686] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6326), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6324), 37,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [452734] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6651), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6649), 37,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [452782] = 4,
    ACTIONS(7948), 1,
      anon_sym_AT,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6326), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6324), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [452832] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6754), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6752), 37,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [452880] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6714), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6712), 37,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [452928] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6433), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6431), 37,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [452976] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6568), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6566), 37,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [453024] = 22,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6241), 1,
      sym__newline,
    ACTIONS(7950), 1,
      sym_id,
    ACTIONS(7953), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7959), 1,
      anon_sym_record,
    ACTIONS(7962), 1,
      anon_sym_LPAREN,
    ACTIONS(7965), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(7968), 1,
      anon_sym_u2983,
    ACTIONS(7971), 1,
      anon_sym_LBRACE,
    ACTIONS(7974), 1,
      aux_sym__qid_token1,
    ACTIONS(7977), 1,
      anon_sym_DOT,
    ACTIONS(7980), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(7983), 1,
      anon_sym_u2987,
    ACTIONS(7986), 1,
      aux_sym_integer_token1,
    ACTIONS(7989), 1,
      aux_sym_string_token1,
    ACTIONS(7992), 1,
      anon_sym_Set,
    STATE(4380), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7276), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    ACTIONS(6239), 5,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_PIPE,
      anon_sym_in,
    STATE(7267), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(7956), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [453110] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6750), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6748), 37,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [453158] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6710), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6708), 37,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [453206] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6500), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6498), 37,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [453254] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6500), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6498), 37,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [453302] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6484), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6482), 37,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [453350] = 23,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6364), 1,
      sym__newline,
    ACTIONS(7995), 1,
      sym_id,
    ACTIONS(7997), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8001), 1,
      anon_sym_record,
    ACTIONS(8003), 1,
      anon_sym_LPAREN,
    ACTIONS(8005), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(8007), 1,
      anon_sym_u2983,
    ACTIONS(8009), 1,
      anon_sym_LBRACE,
    ACTIONS(8011), 1,
      aux_sym__qid_token1,
    ACTIONS(8013), 1,
      anon_sym_DOT,
    ACTIONS(8015), 1,
      anon_sym_PIPE,
    ACTIONS(8017), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(8019), 1,
      anon_sym_u2987,
    ACTIONS(8021), 1,
      aux_sym_integer_token1,
    ACTIONS(8023), 1,
      aux_sym_string_token1,
    ACTIONS(8025), 1,
      anon_sym_Set,
    STATE(4344), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7226), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    ACTIONS(6336), 4,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
    STATE(7206), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(7999), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [453438] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6500), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6498), 37,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [453486] = 4,
    ACTIONS(8027), 1,
      anon_sym_AT,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6326), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6324), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [453536] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6568), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6566), 37,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [453584] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6655), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6653), 37,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [453632] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6572), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6570), 37,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [453680] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6647), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6645), 37,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [453728] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6651), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6649), 37,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [453776] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6754), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6752), 37,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [453824] = 22,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(8029), 1,
      sym_id,
    ACTIONS(8032), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8038), 1,
      anon_sym_record,
    ACTIONS(8041), 1,
      anon_sym_LPAREN,
    ACTIONS(8044), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(8047), 1,
      anon_sym_u2983,
    ACTIONS(8050), 1,
      anon_sym_LBRACE,
    ACTIONS(8053), 1,
      aux_sym__qid_token1,
    ACTIONS(8056), 1,
      anon_sym_DOT,
    ACTIONS(8059), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(8062), 1,
      anon_sym_u2987,
    ACTIONS(8065), 1,
      aux_sym_integer_token1,
    ACTIONS(8068), 1,
      aux_sym_string_token1,
    ACTIONS(8071), 1,
      anon_sym_Set,
    ACTIONS(6241), 2,
      anon_sym_RPAREN,
      anon_sym_RBRACE_RBRACE,
    STATE(4395), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7201), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    ACTIONS(6239), 4,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_PIPE,
    STATE(7202), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(8035), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [453910] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6714), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6712), 37,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [453958] = 22,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6241), 1,
      sym__newline,
    ACTIONS(8074), 1,
      sym_id,
    ACTIONS(8077), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8083), 1,
      anon_sym_record,
    ACTIONS(8086), 1,
      anon_sym_LPAREN,
    ACTIONS(8089), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(8092), 1,
      anon_sym_u2983,
    ACTIONS(8095), 1,
      anon_sym_LBRACE,
    ACTIONS(8098), 1,
      aux_sym__qid_token1,
    ACTIONS(8101), 1,
      anon_sym_DOT,
    ACTIONS(8104), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(8107), 1,
      anon_sym_u2987,
    ACTIONS(8110), 1,
      aux_sym_integer_token1,
    ACTIONS(8113), 1,
      aux_sym_string_token1,
    ACTIONS(8116), 1,
      anon_sym_Set,
    STATE(4397), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    ACTIONS(6239), 5,
      anon_sym_public,
      anon_sym_using,
      anon_sym_hiding,
      anon_sym_renaming,
      anon_sym_in,
    STATE(7256), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(8080), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [454044] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6433), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6431), 37,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [454092] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6750), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6748), 37,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [454140] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6710), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6708), 37,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [454188] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6655), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6653), 37,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [454236] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6714), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6712), 37,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [454284] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6484), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6482), 37,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [454332] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6655), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6653), 37,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [454380] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6496), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6494), 37,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [454428] = 4,
    ACTIONS(8119), 1,
      anon_sym_AT,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6326), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6324), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [454478] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6326), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6324), 37,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [454526] = 5,
    ACTIONS(6488), 1,
      anon_sym_BSLASH,
    ACTIONS(6492), 1,
      sym__newline,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6490), 7,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_in,
    ACTIONS(6486), 30,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [454578] = 4,
    ACTIONS(8121), 1,
      anon_sym_AT,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6326), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6324), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [454628] = 23,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6364), 1,
      sym__newline,
    ACTIONS(8123), 1,
      sym_id,
    ACTIONS(8125), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8129), 1,
      anon_sym_record,
    ACTIONS(8131), 1,
      anon_sym_LPAREN,
    ACTIONS(8133), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(8135), 1,
      anon_sym_u2983,
    ACTIONS(8137), 1,
      anon_sym_LBRACE,
    ACTIONS(8139), 1,
      aux_sym__qid_token1,
    ACTIONS(8141), 1,
      anon_sym_DOT,
    ACTIONS(8143), 1,
      anon_sym_PIPE,
    ACTIONS(8145), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(8147), 1,
      anon_sym_u2987,
    ACTIONS(8149), 1,
      aux_sym_integer_token1,
    ACTIONS(8151), 1,
      aux_sym_string_token1,
    ACTIONS(8153), 1,
      anon_sym_Set,
    STATE(4355), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7213), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    ACTIONS(6336), 4,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
    STATE(7209), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(8127), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [454716] = 22,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6241), 1,
      anon_sym_RBRACE,
    ACTIONS(8155), 1,
      sym_id,
    ACTIONS(8158), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8164), 1,
      anon_sym_record,
    ACTIONS(8167), 1,
      anon_sym_LPAREN,
    ACTIONS(8170), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(8173), 1,
      anon_sym_u2983,
    ACTIONS(8176), 1,
      anon_sym_LBRACE,
    ACTIONS(8179), 1,
      aux_sym__qid_token1,
    ACTIONS(8182), 1,
      anon_sym_DOT,
    ACTIONS(8185), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(8188), 1,
      anon_sym_u2987,
    ACTIONS(8191), 1,
      aux_sym_integer_token1,
    ACTIONS(8194), 1,
      aux_sym_string_token1,
    ACTIONS(8197), 1,
      anon_sym_Set,
    STATE(4411), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7268), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    ACTIONS(6239), 5,
      anon_sym_public,
      anon_sym_using,
      anon_sym_hiding,
      anon_sym_renaming,
      anon_sym_SEMI,
    STATE(7266), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(8161), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [454802] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6326), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6324), 37,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [454850] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6326), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6324), 37,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [454898] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6655), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6653), 37,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [454946] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6496), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6494), 37,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [454994] = 4,
    ACTIONS(6326), 1,
      anon_sym_BSLASH,
    ACTIONS(8200), 1,
      anon_sym_AT,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6324), 37,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [455044] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6496), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6494), 37,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [455092] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6433), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6431), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [455139] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6326), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6324), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [455186] = 22,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6226), 1,
      anon_sym_RBRACE,
    ACTIONS(6912), 1,
      sym_id,
    ACTIONS(6914), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6918), 1,
      anon_sym_record,
    ACTIONS(6924), 1,
      anon_sym_LPAREN,
    ACTIONS(6930), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(6932), 1,
      anon_sym_u2983,
    ACTIONS(6934), 1,
      anon_sym_LBRACE,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(6940), 1,
      anon_sym_DOT,
    ACTIONS(6942), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(6944), 1,
      anon_sym_u2987,
    ACTIONS(6946), 1,
      aux_sym_integer_token1,
    ACTIONS(6948), 1,
      aux_sym_string_token1,
    ACTIONS(6950), 1,
      anon_sym_Set,
    STATE(7273), 1,
      sym_atom,
    STATE(7268), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    ACTIONS(6224), 5,
      anon_sym_public,
      anon_sym_using,
      anon_sym_hiding,
      anon_sym_renaming,
      anon_sym_SEMI,
    STATE(7266), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(6916), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [455271] = 5,
    ACTIONS(6488), 1,
      anon_sym_BSLASH,
    ACTIONS(6492), 1,
      sym__newline,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6490), 6,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_in,
    ACTIONS(6486), 30,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [455322] = 21,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(8202), 1,
      sym_id,
    ACTIONS(8205), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8211), 1,
      anon_sym_record,
    ACTIONS(8214), 1,
      anon_sym_LPAREN,
    ACTIONS(8217), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(8220), 1,
      anon_sym_u2983,
    ACTIONS(8223), 1,
      anon_sym_LBRACE,
    ACTIONS(8226), 1,
      aux_sym__qid_token1,
    ACTIONS(8229), 1,
      anon_sym_DOT,
    ACTIONS(8232), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(8235), 1,
      anon_sym_u2987,
    ACTIONS(8238), 1,
      aux_sym_integer_token1,
    ACTIONS(8241), 1,
      aux_sym_string_token1,
    ACTIONS(8244), 1,
      anon_sym_Set,
    STATE(4422), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7331), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    ACTIONS(6239), 5,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_u2984,
      anon_sym_PIPE,
    STATE(7333), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(8208), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [455405] = 23,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6364), 1,
      sym__newline,
    ACTIONS(8247), 1,
      sym_id,
    ACTIONS(8249), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8253), 1,
      anon_sym_record,
    ACTIONS(8255), 1,
      anon_sym_LPAREN,
    ACTIONS(8257), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(8259), 1,
      anon_sym_u2983,
    ACTIONS(8261), 1,
      anon_sym_LBRACE,
    ACTIONS(8263), 1,
      aux_sym__qid_token1,
    ACTIONS(8265), 1,
      anon_sym_DOT,
    ACTIONS(8267), 1,
      anon_sym_PIPE,
    ACTIONS(8269), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(8271), 1,
      anon_sym_u2987,
    ACTIONS(8273), 1,
      aux_sym_integer_token1,
    ACTIONS(8275), 1,
      aux_sym_string_token1,
    ACTIONS(8277), 1,
      anon_sym_Set,
    STATE(4426), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7320), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    ACTIONS(6336), 3,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_SEMI,
    STATE(7319), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(8251), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [455492] = 22,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6241), 1,
      sym__newline,
    ACTIONS(8279), 1,
      sym_id,
    ACTIONS(8282), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8288), 1,
      anon_sym_record,
    ACTIONS(8291), 1,
      anon_sym_LPAREN,
    ACTIONS(8294), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(8297), 1,
      anon_sym_u2983,
    ACTIONS(8300), 1,
      anon_sym_LBRACE,
    ACTIONS(8303), 1,
      aux_sym__qid_token1,
    ACTIONS(8306), 1,
      anon_sym_DOT,
    ACTIONS(8309), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(8312), 1,
      anon_sym_u2987,
    ACTIONS(8315), 1,
      aux_sym_integer_token1,
    ACTIONS(8318), 1,
      aux_sym_string_token1,
    ACTIONS(8321), 1,
      anon_sym_Set,
    STATE(4424), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7446), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    ACTIONS(6239), 4,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_PIPE,
      anon_sym_in,
    STATE(7448), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(8285), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [455577] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6326), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6324), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [455624] = 22,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6241), 1,
      sym__newline,
    ACTIONS(8324), 1,
      sym_id,
    ACTIONS(8327), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8333), 1,
      anon_sym_record,
    ACTIONS(8336), 1,
      anon_sym_LPAREN,
    ACTIONS(8339), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(8342), 1,
      anon_sym_u2983,
    ACTIONS(8345), 1,
      anon_sym_LBRACE,
    ACTIONS(8348), 1,
      aux_sym__qid_token1,
    ACTIONS(8351), 1,
      anon_sym_DOT,
    ACTIONS(8354), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(8357), 1,
      anon_sym_u2987,
    ACTIONS(8360), 1,
      aux_sym_integer_token1,
    ACTIONS(8363), 1,
      aux_sym_string_token1,
    ACTIONS(8366), 1,
      anon_sym_Set,
    STATE(4426), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7320), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    ACTIONS(6239), 4,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_PIPE,
    STATE(7319), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(8330), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [455709] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6647), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6645), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [455756] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6496), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6494), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [455803] = 23,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6364), 1,
      sym__newline,
    ACTIONS(8369), 1,
      sym_id,
    ACTIONS(8371), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8375), 1,
      anon_sym_record,
    ACTIONS(8377), 1,
      anon_sym_LPAREN,
    ACTIONS(8379), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(8381), 1,
      anon_sym_u2983,
    ACTIONS(8383), 1,
      anon_sym_LBRACE,
    ACTIONS(8385), 1,
      aux_sym__qid_token1,
    ACTIONS(8387), 1,
      anon_sym_DOT,
    ACTIONS(8389), 1,
      anon_sym_PIPE,
    ACTIONS(8391), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(8393), 1,
      anon_sym_u2987,
    ACTIONS(8395), 1,
      aux_sym_integer_token1,
    ACTIONS(8397), 1,
      aux_sym_string_token1,
    ACTIONS(8399), 1,
      anon_sym_Set,
    STATE(4520), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7389), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    ACTIONS(6336), 3,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_in,
    STATE(7302), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(8373), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [455890] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6326), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6324), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [455937] = 4,
    ACTIONS(8401), 1,
      anon_sym_AT,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6326), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6324), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [455986] = 4,
    ACTIONS(8403), 1,
      anon_sym_AT,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6326), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6324), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [456035] = 23,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6364), 1,
      sym__newline,
    ACTIONS(8405), 1,
      sym_id,
    ACTIONS(8407), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8411), 1,
      anon_sym_record,
    ACTIONS(8413), 1,
      anon_sym_LPAREN,
    ACTIONS(8415), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(8417), 1,
      anon_sym_u2983,
    ACTIONS(8419), 1,
      anon_sym_LBRACE,
    ACTIONS(8421), 1,
      aux_sym__qid_token1,
    ACTIONS(8423), 1,
      anon_sym_DOT,
    ACTIONS(8425), 1,
      anon_sym_PIPE,
    ACTIONS(8427), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(8429), 1,
      anon_sym_u2987,
    ACTIONS(8431), 1,
      aux_sym_integer_token1,
    ACTIONS(8433), 1,
      aux_sym_string_token1,
    ACTIONS(8435), 1,
      anon_sym_Set,
    STATE(4424), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7446), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    ACTIONS(6336), 3,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_in,
    STATE(7448), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(8409), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [456122] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6496), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6494), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [456169] = 5,
    ACTIONS(6488), 1,
      anon_sym_BSLASH,
    ACTIONS(6492), 1,
      sym__newline,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6490), 4,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_in,
    ACTIONS(6486), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [456220] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6655), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6653), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [456267] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6655), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6653), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [456314] = 22,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6226), 1,
      sym__newline,
    ACTIONS(7880), 1,
      sym_id,
    ACTIONS(7882), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7886), 1,
      anon_sym_record,
    ACTIONS(7888), 1,
      anon_sym_LPAREN,
    ACTIONS(7890), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(7892), 1,
      anon_sym_u2983,
    ACTIONS(7894), 1,
      anon_sym_LBRACE,
    ACTIONS(7896), 1,
      aux_sym__qid_token1,
    ACTIONS(7898), 1,
      anon_sym_DOT,
    ACTIONS(7902), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(7904), 1,
      anon_sym_u2987,
    ACTIONS(7906), 1,
      aux_sym_integer_token1,
    ACTIONS(7908), 1,
      aux_sym_string_token1,
    ACTIONS(7910), 1,
      anon_sym_Set,
    STATE(7285), 1,
      sym_atom,
    STATE(7276), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    ACTIONS(6224), 5,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_PIPE,
      anon_sym_in,
    STATE(7267), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(7884), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [456399] = 4,
    ACTIONS(8437), 1,
      anon_sym_AT,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6326), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6324), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [456448] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6500), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6498), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [456495] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6568), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6566), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [456542] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6500), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6498), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [456589] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6568), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6566), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [456636] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6572), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6570), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [456683] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6647), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6645), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [456730] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6651), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6649), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [456777] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6496), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6494), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [456824] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6754), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6752), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [456871] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6714), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6712), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [456918] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6572), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6570), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [456965] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6433), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6431), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [457012] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6750), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6748), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [457059] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6710), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6708), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [457106] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6655), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6653), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [457153] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6484), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6482), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [457200] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6651), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6649), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [457247] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6754), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6752), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [457294] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6714), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6712), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [457341] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6484), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6482), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [457388] = 22,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(8439), 1,
      sym_id,
    ACTIONS(8441), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8445), 1,
      anon_sym_record,
    ACTIONS(8447), 1,
      anon_sym_LPAREN,
    ACTIONS(8449), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(8451), 1,
      anon_sym_u2983,
    ACTIONS(8453), 1,
      anon_sym_LBRACE,
    ACTIONS(8455), 1,
      aux_sym__qid_token1,
    ACTIONS(8457), 1,
      anon_sym_DOT,
    ACTIONS(8459), 1,
      anon_sym_PIPE,
    ACTIONS(8461), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(8463), 1,
      anon_sym_u2987,
    ACTIONS(8465), 1,
      aux_sym_integer_token1,
    ACTIONS(8467), 1,
      aux_sym_string_token1,
    ACTIONS(8469), 1,
      anon_sym_Set,
    STATE(4422), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7331), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    ACTIONS(6336), 4,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_u2984,
    STATE(7333), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(8443), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [457473] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6750), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6748), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [457520] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6326), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6324), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [457567] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6484), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6482), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [457614] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6710), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6708), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [457661] = 22,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(8471), 1,
      sym_id,
    ACTIONS(8474), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8480), 1,
      anon_sym_record,
    ACTIONS(8483), 1,
      anon_sym_LPAREN,
    ACTIONS(8486), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(8489), 1,
      anon_sym_u2983,
    ACTIONS(8492), 1,
      anon_sym_LBRACE,
    ACTIONS(8495), 1,
      aux_sym__qid_token1,
    ACTIONS(8498), 1,
      anon_sym_DOT,
    ACTIONS(8501), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(8504), 1,
      anon_sym_u2987,
    ACTIONS(8507), 1,
      aux_sym_integer_token1,
    ACTIONS(8510), 1,
      aux_sym_string_token1,
    ACTIONS(8513), 1,
      anon_sym_Set,
    ACTIONS(6241), 2,
      anon_sym_RPAREN,
      anon_sym_RBRACE_RBRACE,
    STATE(4465), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7442), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    ACTIONS(6239), 3,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_PIPE,
    STATE(7445), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(8477), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [457746] = 23,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6364), 1,
      anon_sym_RPAREN,
    ACTIONS(8516), 1,
      sym_id,
    ACTIONS(8518), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8522), 1,
      anon_sym_record,
    ACTIONS(8524), 1,
      anon_sym_LPAREN,
    ACTIONS(8526), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(8528), 1,
      anon_sym_u2983,
    ACTIONS(8530), 1,
      anon_sym_LBRACE,
    ACTIONS(8532), 1,
      aux_sym__qid_token1,
    ACTIONS(8534), 1,
      anon_sym_DOT,
    ACTIONS(8536), 1,
      anon_sym_PIPE,
    ACTIONS(8538), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(8540), 1,
      anon_sym_u2987,
    ACTIONS(8542), 1,
      aux_sym_integer_token1,
    ACTIONS(8544), 1,
      aux_sym_string_token1,
    ACTIONS(8546), 1,
      anon_sym_Set,
    STATE(4395), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7201), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    ACTIONS(6336), 3,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_SEMI,
    STATE(7202), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(8520), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [457833] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6710), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6708), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [457880] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6433), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6431), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [457927] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6710), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6708), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [457974] = 4,
    ACTIONS(8548), 1,
      anon_sym_AT,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6326), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6324), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [458023] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6750), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6748), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [458070] = 22,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6241), 1,
      anon_sym_RPAREN,
    ACTIONS(8550), 1,
      sym_id,
    ACTIONS(8553), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8559), 1,
      anon_sym_record,
    ACTIONS(8562), 1,
      anon_sym_LPAREN,
    ACTIONS(8565), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(8568), 1,
      anon_sym_u2983,
    ACTIONS(8571), 1,
      anon_sym_LBRACE,
    ACTIONS(8574), 1,
      aux_sym__qid_token1,
    ACTIONS(8577), 1,
      anon_sym_DOT,
    ACTIONS(8580), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(8583), 1,
      anon_sym_u2987,
    ACTIONS(8586), 1,
      aux_sym_integer_token1,
    ACTIONS(8589), 1,
      aux_sym_string_token1,
    ACTIONS(8592), 1,
      anon_sym_Set,
    STATE(4472), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7459), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    ACTIONS(6239), 4,
      anon_sym_public,
      anon_sym_using,
      anon_sym_hiding,
      anon_sym_renaming,
    STATE(7461), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(8556), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [458155] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6484), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6482), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [458202] = 4,
    ACTIONS(8595), 1,
      anon_sym_AT,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6326), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6324), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [458251] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6500), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6498), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [458298] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6568), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6566), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [458345] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6572), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6570), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [458392] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6433), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6431), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [458439] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6647), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6645), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [458486] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6651), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6649), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [458533] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6496), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6494), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [458580] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6754), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6752), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [458627] = 23,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6364), 1,
      anon_sym_RBRACE,
    ACTIONS(8597), 1,
      sym_id,
    ACTIONS(8599), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8603), 1,
      anon_sym_record,
    ACTIONS(8605), 1,
      anon_sym_LPAREN,
    ACTIONS(8607), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(8609), 1,
      anon_sym_u2983,
    ACTIONS(8611), 1,
      anon_sym_LBRACE,
    ACTIONS(8613), 1,
      aux_sym__qid_token1,
    ACTIONS(8615), 1,
      anon_sym_DOT,
    ACTIONS(8617), 1,
      anon_sym_PIPE,
    ACTIONS(8619), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(8621), 1,
      anon_sym_u2987,
    ACTIONS(8623), 1,
      aux_sym_integer_token1,
    ACTIONS(8625), 1,
      aux_sym_string_token1,
    ACTIONS(8627), 1,
      anon_sym_Set,
    STATE(4596), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7406), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    ACTIONS(6336), 3,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_SEMI,
    STATE(7405), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(8601), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [458714] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6714), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6712), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [458761] = 4,
    ACTIONS(8629), 1,
      anon_sym_AT,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6326), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6324), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [458810] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6714), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6712), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [458857] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6754), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6752), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [458904] = 5,
    ACTIONS(6488), 1,
      anon_sym_BSLASH,
    ACTIONS(6492), 1,
      sym__newline,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6490), 6,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
    ACTIONS(6486), 30,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [458955] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6433), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6431), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [459002] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6651), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6649), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [459049] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6647), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6645), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [459096] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6750), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6748), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [459143] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6710), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6708), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [459190] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6655), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6653), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [459237] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6572), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6570), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [459284] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6484), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6482), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [459331] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6568), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6566), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [459378] = 22,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6226), 1,
      sym__newline,
    ACTIONS(7914), 1,
      sym_id,
    ACTIONS(7916), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7920), 1,
      anon_sym_record,
    ACTIONS(7922), 1,
      anon_sym_LPAREN,
    ACTIONS(7924), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(7926), 1,
      anon_sym_u2983,
    ACTIONS(7928), 1,
      anon_sym_LBRACE,
    ACTIONS(7930), 1,
      aux_sym__qid_token1,
    ACTIONS(7932), 1,
      anon_sym_DOT,
    ACTIONS(7936), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(7938), 1,
      anon_sym_u2987,
    ACTIONS(7940), 1,
      aux_sym_integer_token1,
    ACTIONS(7942), 1,
      aux_sym_string_token1,
    ACTIONS(7944), 1,
      anon_sym_Set,
    STATE(7239), 1,
      sym_atom,
    STATE(7212), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    ACTIONS(6224), 5,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_in,
    STATE(7249), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(7918), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [459463] = 4,
    ACTIONS(8631), 1,
      anon_sym_AT,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6326), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6324), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [459512] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6750), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6748), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [459559] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6433), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6431), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [459606] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6714), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6712), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [459653] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6754), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6752), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [459700] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6651), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6649), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [459747] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6647), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6645), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [459794] = 5,
    ACTIONS(6488), 1,
      anon_sym_BSLASH,
    ACTIONS(6492), 1,
      sym__newline,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6490), 4,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
    ACTIONS(6486), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [459845] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6500), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6498), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [459892] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6572), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6570), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [459939] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6568), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6566), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [459986] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6500), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6498), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [460033] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6500), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6498), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [460080] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6568), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6566), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [460127] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6572), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6570), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [460174] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6647), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6645), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [460221] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6651), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6649), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [460268] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6754), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6752), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [460315] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6714), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6712), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [460362] = 5,
    ACTIONS(6488), 1,
      anon_sym_BSLASH,
    ACTIONS(6492), 1,
      sym__newline,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6490), 4,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_in,
    ACTIONS(6486), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [460413] = 22,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6226), 1,
      sym__newline,
    ACTIONS(8123), 1,
      sym_id,
    ACTIONS(8125), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8129), 1,
      anon_sym_record,
    ACTIONS(8131), 1,
      anon_sym_LPAREN,
    ACTIONS(8133), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(8135), 1,
      anon_sym_u2983,
    ACTIONS(8137), 1,
      anon_sym_LBRACE,
    ACTIONS(8139), 1,
      aux_sym__qid_token1,
    ACTIONS(8141), 1,
      anon_sym_DOT,
    ACTIONS(8145), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(8147), 1,
      anon_sym_u2987,
    ACTIONS(8149), 1,
      aux_sym_integer_token1,
    ACTIONS(8151), 1,
      aux_sym_string_token1,
    ACTIONS(8153), 1,
      anon_sym_Set,
    STATE(7216), 1,
      sym_atom,
    STATE(7213), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    ACTIONS(6224), 5,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_PIPE,
    STATE(7209), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(8127), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [460498] = 22,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6241), 1,
      sym__newline,
    ACTIONS(8633), 1,
      sym_id,
    ACTIONS(8636), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8642), 1,
      anon_sym_record,
    ACTIONS(8645), 1,
      anon_sym_LPAREN,
    ACTIONS(8648), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(8651), 1,
      anon_sym_u2983,
    ACTIONS(8654), 1,
      anon_sym_LBRACE,
    ACTIONS(8657), 1,
      aux_sym__qid_token1,
    ACTIONS(8660), 1,
      anon_sym_DOT,
    ACTIONS(8663), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(8666), 1,
      anon_sym_u2987,
    ACTIONS(8669), 1,
      aux_sym_integer_token1,
    ACTIONS(8672), 1,
      aux_sym_string_token1,
    ACTIONS(8675), 1,
      anon_sym_Set,
    STATE(4520), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7389), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    ACTIONS(6239), 4,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_in,
    STATE(7302), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(8639), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [460583] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6750), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6748), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [460630] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6710), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6708), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [460677] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6484), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6482), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [460724] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6655), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6653), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [460771] = 22,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6241), 1,
      sym__newline,
    ACTIONS(8678), 1,
      sym_id,
    ACTIONS(8681), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8687), 1,
      anon_sym_record,
    ACTIONS(8690), 1,
      anon_sym_LPAREN,
    ACTIONS(8693), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(8696), 1,
      anon_sym_u2983,
    ACTIONS(8699), 1,
      anon_sym_LBRACE,
    ACTIONS(8702), 1,
      aux_sym__qid_token1,
    ACTIONS(8705), 1,
      anon_sym_DOT,
    ACTIONS(8708), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(8711), 1,
      anon_sym_u2987,
    ACTIONS(8714), 1,
      aux_sym_integer_token1,
    ACTIONS(8717), 1,
      aux_sym_string_token1,
    ACTIONS(8720), 1,
      anon_sym_Set,
    STATE(4525), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7354), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    ACTIONS(6239), 4,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_PIPE,
    STATE(7353), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(8684), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [460856] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6496), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6494), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [460903] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6484), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6482), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [460950] = 22,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(8723), 1,
      sym_id,
    ACTIONS(8726), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8732), 1,
      anon_sym_record,
    ACTIONS(8735), 1,
      anon_sym_LPAREN,
    ACTIONS(8738), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(8741), 1,
      anon_sym_u2983,
    ACTIONS(8744), 1,
      anon_sym_LBRACE,
    ACTIONS(8747), 1,
      aux_sym__qid_token1,
    ACTIONS(8750), 1,
      anon_sym_DOT,
    ACTIONS(8753), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(8756), 1,
      anon_sym_u2987,
    ACTIONS(8759), 1,
      aux_sym_integer_token1,
    ACTIONS(8762), 1,
      aux_sym_string_token1,
    ACTIONS(8765), 1,
      anon_sym_Set,
    ACTIONS(6241), 2,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
    STATE(4528), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7312), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    ACTIONS(6239), 3,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_PIPE,
    STATE(7309), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(8729), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [461035] = 5,
    ACTIONS(6488), 1,
      anon_sym_BSLASH,
    ACTIONS(6492), 1,
      sym__newline,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6490), 4,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
    ACTIONS(6486), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [461086] = 4,
    ACTIONS(6326), 1,
      anon_sym_BSLASH,
    ACTIONS(8768), 1,
      anon_sym_AT,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6324), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [461135] = 3,
    ACTIONS(6484), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6482), 37,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [461182] = 5,
    ACTIONS(6488), 1,
      anon_sym_BSLASH,
    ACTIONS(6492), 1,
      sym__newline,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6490), 6,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_in,
    ACTIONS(6486), 30,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [461233] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6710), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6708), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [461280] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6750), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6748), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [461327] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6433), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6431), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [461374] = 3,
    ACTIONS(6710), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6708), 37,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [461421] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6714), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6712), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [461468] = 3,
    ACTIONS(6750), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6748), 37,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [461515] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6754), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6752), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [461562] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6651), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6649), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [461609] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6647), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6645), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [461656] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6572), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6570), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [461703] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6568), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6566), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [461750] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6500), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6498), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [461797] = 3,
    ACTIONS(6433), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6431), 37,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [461844] = 3,
    ACTIONS(6714), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6712), 37,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [461891] = 3,
    ACTIONS(6754), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6752), 37,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [461938] = 3,
    ACTIONS(6651), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6649), 37,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [461985] = 3,
    ACTIONS(6647), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6645), 37,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [462032] = 3,
    ACTIONS(6572), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6570), 37,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [462079] = 3,
    ACTIONS(6568), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6566), 37,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [462126] = 3,
    ACTIONS(6500), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6498), 37,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [462173] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6655), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6653), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [462220] = 22,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6226), 1,
      sym__newline,
    ACTIONS(6872), 1,
      sym_id,
    ACTIONS(6874), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6878), 1,
      anon_sym_record,
    ACTIONS(6884), 1,
      anon_sym_LPAREN,
    ACTIONS(6888), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(6890), 1,
      anon_sym_u2983,
    ACTIONS(6892), 1,
      anon_sym_LBRACE,
    ACTIONS(6894), 1,
      aux_sym__qid_token1,
    ACTIONS(6896), 1,
      anon_sym_DOT,
    ACTIONS(6900), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(6902), 1,
      anon_sym_u2987,
    ACTIONS(6904), 1,
      aux_sym_integer_token1,
    ACTIONS(6906), 1,
      aux_sym_string_token1,
    ACTIONS(6908), 1,
      anon_sym_Set,
    STATE(7252), 1,
      sym_atom,
    STATE(7255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    ACTIONS(6224), 5,
      anon_sym_public,
      anon_sym_using,
      anon_sym_hiding,
      anon_sym_renaming,
      anon_sym_in,
    STATE(7256), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(6876), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [462305] = 22,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(8770), 1,
      sym_id,
    ACTIONS(8773), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8779), 1,
      anon_sym_record,
    ACTIONS(8782), 1,
      anon_sym_LPAREN,
    ACTIONS(8785), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(8788), 1,
      anon_sym_u2983,
    ACTIONS(8791), 1,
      anon_sym_LBRACE,
    ACTIONS(8794), 1,
      aux_sym__qid_token1,
    ACTIONS(8797), 1,
      anon_sym_DOT,
    ACTIONS(8800), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(8803), 1,
      anon_sym_u2987,
    ACTIONS(8806), 1,
      aux_sym_integer_token1,
    ACTIONS(8809), 1,
      aux_sym_string_token1,
    ACTIONS(8812), 1,
      anon_sym_Set,
    ACTIONS(6241), 2,
      anon_sym_RPAREN,
      anon_sym_RBRACE_RBRACE,
    STATE(4555), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7305), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    ACTIONS(6239), 3,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PIPE,
    STATE(7306), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(8776), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [462390] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6496), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6494), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [462437] = 23,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6364), 1,
      sym__newline,
    ACTIONS(8815), 1,
      sym_id,
    ACTIONS(8817), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8821), 1,
      anon_sym_record,
    ACTIONS(8823), 1,
      anon_sym_LPAREN,
    ACTIONS(8825), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(8827), 1,
      anon_sym_u2983,
    ACTIONS(8829), 1,
      anon_sym_LBRACE,
    ACTIONS(8831), 1,
      aux_sym__qid_token1,
    ACTIONS(8833), 1,
      anon_sym_DOT,
    ACTIONS(8835), 1,
      anon_sym_PIPE,
    ACTIONS(8837), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(8839), 1,
      anon_sym_u2987,
    ACTIONS(8841), 1,
      aux_sym_integer_token1,
    ACTIONS(8843), 1,
      aux_sym_string_token1,
    ACTIONS(8845), 1,
      anon_sym_Set,
    STATE(4525), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7354), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    ACTIONS(6336), 3,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
    STATE(7353), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(8819), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [462524] = 3,
    ACTIONS(6655), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6653), 37,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [462571] = 3,
    ACTIONS(6496), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6494), 37,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [462618] = 4,
    ACTIONS(6326), 1,
      anon_sym_BSLASH,
    ACTIONS(8847), 1,
      anon_sym_AT,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6324), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [462667] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6326), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6324), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [462714] = 4,
    ACTIONS(8849), 1,
      anon_sym_AT,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6326), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6324), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [462763] = 4,
    ACTIONS(8851), 1,
      anon_sym_AT,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6326), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6324), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [462812] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6710), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6708), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [462859] = 3,
    ACTIONS(6326), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6324), 37,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [462906] = 22,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6241), 1,
      sym__newline,
    ACTIONS(8853), 1,
      sym_id,
    ACTIONS(8856), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8862), 1,
      anon_sym_record,
    ACTIONS(8865), 1,
      anon_sym_LPAREN,
    ACTIONS(8868), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(8871), 1,
      anon_sym_u2983,
    ACTIONS(8874), 1,
      anon_sym_LBRACE,
    ACTIONS(8877), 1,
      aux_sym__qid_token1,
    ACTIONS(8880), 1,
      anon_sym_DOT,
    ACTIONS(8883), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(8886), 1,
      anon_sym_u2987,
    ACTIONS(8889), 1,
      aux_sym_integer_token1,
    ACTIONS(8892), 1,
      aux_sym_string_token1,
    ACTIONS(8895), 1,
      anon_sym_Set,
    STATE(4566), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7400), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    ACTIONS(6239), 4,
      anon_sym_public,
      anon_sym_using,
      anon_sym_hiding,
      anon_sym_renaming,
    STATE(7291), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(8859), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [462991] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6655), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6653), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [463038] = 22,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(8516), 1,
      sym_id,
    ACTIONS(8518), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8522), 1,
      anon_sym_record,
    ACTIONS(8524), 1,
      anon_sym_LPAREN,
    ACTIONS(8526), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(8528), 1,
      anon_sym_u2983,
    ACTIONS(8530), 1,
      anon_sym_LBRACE,
    ACTIONS(8532), 1,
      aux_sym__qid_token1,
    ACTIONS(8534), 1,
      anon_sym_DOT,
    ACTIONS(8538), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(8540), 1,
      anon_sym_u2987,
    ACTIONS(8542), 1,
      aux_sym_integer_token1,
    ACTIONS(8544), 1,
      aux_sym_string_token1,
    ACTIONS(8546), 1,
      anon_sym_Set,
    STATE(7195), 1,
      sym_atom,
    ACTIONS(6226), 2,
      anon_sym_RPAREN,
      anon_sym_RBRACE_RBRACE,
    STATE(7201), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    ACTIONS(6224), 4,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_PIPE,
    STATE(7202), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(8520), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [463123] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6496), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6494), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [463170] = 22,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6226), 1,
      sym__newline,
    ACTIONS(7995), 1,
      sym_id,
    ACTIONS(7997), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8001), 1,
      anon_sym_record,
    ACTIONS(8003), 1,
      anon_sym_LPAREN,
    ACTIONS(8005), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(8007), 1,
      anon_sym_u2983,
    ACTIONS(8009), 1,
      anon_sym_LBRACE,
    ACTIONS(8011), 1,
      aux_sym__qid_token1,
    ACTIONS(8013), 1,
      anon_sym_DOT,
    ACTIONS(8017), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(8019), 1,
      anon_sym_u2987,
    ACTIONS(8021), 1,
      aux_sym_integer_token1,
    ACTIONS(8023), 1,
      aux_sym_string_token1,
    ACTIONS(8025), 1,
      anon_sym_Set,
    STATE(7199), 1,
      sym_atom,
    STATE(7226), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    ACTIONS(6224), 5,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_PIPE,
    STATE(7206), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(7999), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [463255] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6500), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6498), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [463302] = 22,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(7663), 1,
      sym_id,
    ACTIONS(7665), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7669), 1,
      anon_sym_record,
    ACTIONS(7671), 1,
      anon_sym_LPAREN,
    ACTIONS(7673), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(7675), 1,
      anon_sym_u2983,
    ACTIONS(7677), 1,
      anon_sym_LBRACE,
    ACTIONS(7679), 1,
      aux_sym__qid_token1,
    ACTIONS(7681), 1,
      anon_sym_DOT,
    ACTIONS(7683), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(7685), 1,
      anon_sym_u2987,
    ACTIONS(7687), 1,
      aux_sym_integer_token1,
    ACTIONS(7689), 1,
      aux_sym_string_token1,
    ACTIONS(7691), 1,
      anon_sym_Set,
    ACTIONS(7735), 1,
      sym__newline,
    STATE(4566), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7400), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    ACTIONS(7733), 4,
      anon_sym_public,
      anon_sym_using,
      anon_sym_hiding,
      anon_sym_renaming,
    STATE(7291), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(7667), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [463387] = 22,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(7663), 1,
      sym_id,
    ACTIONS(7665), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7669), 1,
      anon_sym_record,
    ACTIONS(7671), 1,
      anon_sym_LPAREN,
    ACTIONS(7677), 1,
      anon_sym_LBRACE,
    ACTIONS(7679), 1,
      aux_sym__qid_token1,
    ACTIONS(7681), 1,
      anon_sym_DOT,
    ACTIONS(7683), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(7685), 1,
      anon_sym_u2987,
    ACTIONS(7687), 1,
      aux_sym_integer_token1,
    ACTIONS(7689), 1,
      aux_sym_string_token1,
    ACTIONS(7691), 1,
      anon_sym_Set,
    ACTIONS(7731), 1,
      sym__newline,
    ACTIONS(8898), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(8900), 1,
      anon_sym_u2983,
    STATE(4572), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7400), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    ACTIONS(7725), 4,
      anon_sym_public,
      anon_sym_using,
      anon_sym_hiding,
      anon_sym_renaming,
    STATE(7291), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(7667), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [463472] = 23,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6364), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(8516), 1,
      sym_id,
    ACTIONS(8518), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8522), 1,
      anon_sym_record,
    ACTIONS(8524), 1,
      anon_sym_LPAREN,
    ACTIONS(8526), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(8528), 1,
      anon_sym_u2983,
    ACTIONS(8530), 1,
      anon_sym_LBRACE,
    ACTIONS(8532), 1,
      aux_sym__qid_token1,
    ACTIONS(8534), 1,
      anon_sym_DOT,
    ACTIONS(8538), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(8540), 1,
      anon_sym_u2987,
    ACTIONS(8542), 1,
      aux_sym_integer_token1,
    ACTIONS(8544), 1,
      aux_sym_string_token1,
    ACTIONS(8546), 1,
      anon_sym_Set,
    ACTIONS(8902), 1,
      anon_sym_PIPE,
    STATE(4395), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7201), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    ACTIONS(6336), 3,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_SEMI,
    STATE(7202), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(8520), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [463559] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6568), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6566), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [463606] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6572), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6570), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [463653] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6647), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6645), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [463700] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6651), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6649), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [463747] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6496), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6494), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [463794] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6754), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6752), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [463841] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6714), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6712), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [463888] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6433), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6431), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [463935] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6750), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6748), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [463982] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6484), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6482), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [464029] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6710), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6708), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [464076] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6750), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6748), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [464123] = 5,
    ACTIONS(6488), 1,
      anon_sym_BSLASH,
    ACTIONS(6492), 1,
      sym__newline,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6490), 5,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_in,
    ACTIONS(6486), 31,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [464174] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6433), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6431), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [464221] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6714), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6712), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [464268] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6326), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6324), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [464315] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6326), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6324), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [464362] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6754), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6752), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [464409] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6651), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6649), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [464456] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6647), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6645), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [464503] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6572), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6570), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [464550] = 22,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6241), 1,
      anon_sym_RBRACE,
    ACTIONS(8904), 1,
      sym_id,
    ACTIONS(8907), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8913), 1,
      anon_sym_record,
    ACTIONS(8916), 1,
      anon_sym_LPAREN,
    ACTIONS(8919), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(8922), 1,
      anon_sym_u2983,
    ACTIONS(8925), 1,
      anon_sym_LBRACE,
    ACTIONS(8928), 1,
      aux_sym__qid_token1,
    ACTIONS(8931), 1,
      anon_sym_DOT,
    ACTIONS(8934), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(8937), 1,
      anon_sym_u2987,
    ACTIONS(8940), 1,
      aux_sym_integer_token1,
    ACTIONS(8943), 1,
      aux_sym_string_token1,
    ACTIONS(8946), 1,
      anon_sym_Set,
    STATE(4596), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7406), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    ACTIONS(6239), 4,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_PIPE,
    STATE(7405), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(8910), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [464635] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6568), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6566), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [464682] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6500), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6498), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [464729] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6710), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6708), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [464776] = 5,
    ACTIONS(6488), 1,
      anon_sym_BSLASH,
    ACTIONS(6492), 1,
      sym__newline,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6490), 6,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
    ACTIONS(6486), 30,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [464827] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6326), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6324), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [464874] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6655), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6653), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [464921] = 5,
    ACTIONS(6488), 1,
      anon_sym_BSLASH,
    ACTIONS(6492), 1,
      sym__newline,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6490), 5,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
    ACTIONS(6486), 31,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [464972] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6655), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6653), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [465019] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6496), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6494), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [465066] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6326), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6324), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [465113] = 4,
    ACTIONS(6326), 1,
      anon_sym_BSLASH,
    ACTIONS(8949), 1,
      anon_sym_AT,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6324), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [465162] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6484), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6482), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [465209] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6496), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6494), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [465256] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6655), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6653), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [465303] = 4,
    ACTIONS(6488), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6490), 5,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(6486), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [465352] = 4,
    ACTIONS(8951), 1,
      anon_sym_AT,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6326), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6324), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [465401] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6484), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6482), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [465448] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6500), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6498), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [465495] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6568), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6566), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [465542] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6572), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6570), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [465589] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6647), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6645), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [465636] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6651), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6649), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [465683] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6754), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6752), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [465730] = 4,
    ACTIONS(6326), 1,
      anon_sym_BSLASH,
    ACTIONS(8953), 1,
      anon_sym_AT,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6324), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [465779] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6714), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6712), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [465826] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6326), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6324), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [465873] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6433), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6431), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [465920] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6750), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6748), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [465967] = 23,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6364), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(8955), 1,
      sym_id,
    ACTIONS(8957), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8961), 1,
      anon_sym_record,
    ACTIONS(8963), 1,
      anon_sym_LPAREN,
    ACTIONS(8965), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(8967), 1,
      anon_sym_u2983,
    ACTIONS(8969), 1,
      anon_sym_LBRACE,
    ACTIONS(8971), 1,
      aux_sym__qid_token1,
    ACTIONS(8973), 1,
      anon_sym_DOT,
    ACTIONS(8975), 1,
      anon_sym_PIPE,
    ACTIONS(8977), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(8979), 1,
      anon_sym_u2987,
    ACTIONS(8981), 1,
      aux_sym_integer_token1,
    ACTIONS(8983), 1,
      aux_sym_string_token1,
    ACTIONS(8985), 1,
      anon_sym_Set,
    ACTIONS(6336), 2,
      anon_sym_COLON,
      anon_sym_SEMI,
    STATE(4845), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7468), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7497), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(8959), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [466053] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6651), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6649), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [466099] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6496), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6494), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [466145] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6655), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6653), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [466191] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6326), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6324), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [466237] = 4,
    ACTIONS(6326), 1,
      anon_sym_BSLASH,
    ACTIONS(8987), 1,
      anon_sym_AT,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6324), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [466285] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6500), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6498), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [466331] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6568), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6566), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [466377] = 3,
    ACTIONS(6496), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6494), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [466423] = 3,
    ACTIONS(6655), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6653), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [466469] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6572), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6570), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [466515] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6647), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6645), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [466561] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6651), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6649), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [466607] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6754), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6752), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [466653] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6714), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6712), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [466699] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6433), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6431), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [466745] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6750), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6748), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [466791] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6710), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6708), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [466837] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6484), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6482), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [466883] = 22,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6226), 1,
      sym__newline,
    ACTIONS(8247), 1,
      sym_id,
    ACTIONS(8249), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8253), 1,
      anon_sym_record,
    ACTIONS(8255), 1,
      anon_sym_LPAREN,
    ACTIONS(8257), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(8259), 1,
      anon_sym_u2983,
    ACTIONS(8261), 1,
      anon_sym_LBRACE,
    ACTIONS(8263), 1,
      aux_sym__qid_token1,
    ACTIONS(8265), 1,
      anon_sym_DOT,
    ACTIONS(8269), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(8271), 1,
      anon_sym_u2987,
    ACTIONS(8273), 1,
      aux_sym_integer_token1,
    ACTIONS(8275), 1,
      aux_sym_string_token1,
    ACTIONS(8277), 1,
      anon_sym_Set,
    STATE(7324), 1,
      sym_atom,
    STATE(7320), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    ACTIONS(6224), 4,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_PIPE,
    STATE(7319), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(8251), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [466967] = 4,
    ACTIONS(8989), 1,
      anon_sym_AT,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6326), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6324), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [467015] = 22,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6226), 1,
      anon_sym_RBRACE,
    ACTIONS(8597), 1,
      sym_id,
    ACTIONS(8599), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8603), 1,
      anon_sym_record,
    ACTIONS(8605), 1,
      anon_sym_LPAREN,
    ACTIONS(8607), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(8609), 1,
      anon_sym_u2983,
    ACTIONS(8611), 1,
      anon_sym_LBRACE,
    ACTIONS(8613), 1,
      aux_sym__qid_token1,
    ACTIONS(8615), 1,
      anon_sym_DOT,
    ACTIONS(8619), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(8621), 1,
      anon_sym_u2987,
    ACTIONS(8623), 1,
      aux_sym_integer_token1,
    ACTIONS(8625), 1,
      aux_sym_string_token1,
    ACTIONS(8627), 1,
      anon_sym_Set,
    STATE(7410), 1,
      sym_atom,
    STATE(7406), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    ACTIONS(6224), 4,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_PIPE,
    STATE(7405), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(8601), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [467099] = 3,
    ACTIONS(6326), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6324), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [467145] = 22,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6226), 1,
      sym__newline,
    ACTIONS(8405), 1,
      sym_id,
    ACTIONS(8407), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8411), 1,
      anon_sym_record,
    ACTIONS(8413), 1,
      anon_sym_LPAREN,
    ACTIONS(8415), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(8417), 1,
      anon_sym_u2983,
    ACTIONS(8419), 1,
      anon_sym_LBRACE,
    ACTIONS(8421), 1,
      aux_sym__qid_token1,
    ACTIONS(8423), 1,
      anon_sym_DOT,
    ACTIONS(8427), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(8429), 1,
      anon_sym_u2987,
    ACTIONS(8431), 1,
      aux_sym_integer_token1,
    ACTIONS(8433), 1,
      aux_sym_string_token1,
    ACTIONS(8435), 1,
      anon_sym_Set,
    STATE(7434), 1,
      sym_atom,
    STATE(7446), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    ACTIONS(6224), 4,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_PIPE,
      anon_sym_in,
    STATE(7448), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(8409), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [467229] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6484), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6482), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [467275] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6710), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6708), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [467321] = 3,
    ACTIONS(6655), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6653), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [467367] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6750), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6748), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [467413] = 3,
    ACTIONS(6496), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6494), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [467459] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6433), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6431), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [467505] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6714), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6712), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [467551] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6754), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6752), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [467597] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6651), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6649), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [467643] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6647), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6645), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [467689] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6572), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6570), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [467735] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6568), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6566), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [467781] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6500), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6498), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [467827] = 3,
    ACTIONS(6710), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6708), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [467873] = 4,
    ACTIONS(6326), 1,
      anon_sym_BSLASH,
    ACTIONS(8991), 1,
      anon_sym_AT,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6324), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [467921] = 4,
    ACTIONS(6488), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6490), 4,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(6486), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [467969] = 3,
    ACTIONS(6500), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6498), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [468015] = 3,
    ACTIONS(6568), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6566), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [468061] = 3,
    ACTIONS(6326), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6324), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [468107] = 3,
    ACTIONS(6572), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6570), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [468153] = 3,
    ACTIONS(6647), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6645), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [468199] = 3,
    ACTIONS(6651), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6649), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [468245] = 3,
    ACTIONS(6754), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6752), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [468291] = 3,
    ACTIONS(6714), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6712), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [468337] = 3,
    ACTIONS(6433), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6431), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [468383] = 3,
    ACTIONS(6750), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6748), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [468429] = 3,
    ACTIONS(6710), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6708), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [468475] = 22,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6226), 1,
      sym__newline,
    ACTIONS(8815), 1,
      sym_id,
    ACTIONS(8817), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8821), 1,
      anon_sym_record,
    ACTIONS(8823), 1,
      anon_sym_LPAREN,
    ACTIONS(8825), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(8827), 1,
      anon_sym_u2983,
    ACTIONS(8829), 1,
      anon_sym_LBRACE,
    ACTIONS(8831), 1,
      aux_sym__qid_token1,
    ACTIONS(8833), 1,
      anon_sym_DOT,
    ACTIONS(8837), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(8839), 1,
      anon_sym_u2987,
    ACTIONS(8841), 1,
      aux_sym_integer_token1,
    ACTIONS(8843), 1,
      aux_sym_string_token1,
    ACTIONS(8845), 1,
      anon_sym_Set,
    STATE(7359), 1,
      sym_atom,
    STATE(7354), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    ACTIONS(6224), 4,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_PIPE,
    STATE(7353), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(8819), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [468559] = 23,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6364), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(8993), 1,
      sym_id,
    ACTIONS(8995), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8999), 1,
      anon_sym_record,
    ACTIONS(9001), 1,
      anon_sym_LPAREN,
    ACTIONS(9003), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(9005), 1,
      anon_sym_u2983,
    ACTIONS(9007), 1,
      anon_sym_LBRACE,
    ACTIONS(9009), 1,
      aux_sym__qid_token1,
    ACTIONS(9011), 1,
      anon_sym_DOT,
    ACTIONS(9013), 1,
      anon_sym_PIPE,
    ACTIONS(9015), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(9017), 1,
      anon_sym_u2987,
    ACTIONS(9019), 1,
      aux_sym_integer_token1,
    ACTIONS(9021), 1,
      aux_sym_string_token1,
    ACTIONS(9023), 1,
      anon_sym_Set,
    ACTIONS(6336), 2,
      anon_sym_COLON,
      anon_sym_EQ,
    STATE(4555), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7305), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7306), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(8997), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [468645] = 4,
    ACTIONS(9025), 1,
      anon_sym_AT,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6326), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6324), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [468693] = 3,
    ACTIONS(6484), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6482), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [468739] = 21,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(8439), 1,
      sym_id,
    ACTIONS(8441), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8445), 1,
      anon_sym_record,
    ACTIONS(8447), 1,
      anon_sym_LPAREN,
    ACTIONS(8449), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(8451), 1,
      anon_sym_u2983,
    ACTIONS(8453), 1,
      anon_sym_LBRACE,
    ACTIONS(8455), 1,
      aux_sym__qid_token1,
    ACTIONS(8457), 1,
      anon_sym_DOT,
    ACTIONS(8461), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(8463), 1,
      anon_sym_u2987,
    ACTIONS(8465), 1,
      aux_sym_integer_token1,
    ACTIONS(8467), 1,
      aux_sym_string_token1,
    ACTIONS(8469), 1,
      anon_sym_Set,
    STATE(7376), 1,
      sym_atom,
    STATE(7331), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    ACTIONS(6224), 5,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_u2984,
      anon_sym_PIPE,
    STATE(7333), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(8443), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [468821] = 3,
    ACTIONS(6326), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6324), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [468867] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6484), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6482), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [468913] = 4,
    ACTIONS(6326), 1,
      anon_sym_BSLASH,
    ACTIONS(9027), 1,
      anon_sym_AT,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6324), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [468961] = 4,
    ACTIONS(6488), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6490), 4,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_u2984,
    ACTIONS(6486), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [469009] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6710), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6708), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [469055] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6750), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6748), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [469101] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6433), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6431), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [469147] = 22,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(9029), 1,
      sym_id,
    ACTIONS(9031), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9035), 1,
      anon_sym_record,
    ACTIONS(9037), 1,
      anon_sym_LPAREN,
    ACTIONS(9039), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(9041), 1,
      anon_sym_u2983,
    ACTIONS(9043), 1,
      anon_sym_LBRACE,
    ACTIONS(9045), 1,
      aux_sym__qid_token1,
    ACTIONS(9047), 1,
      anon_sym_DOT,
    ACTIONS(9049), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(9051), 1,
      anon_sym_u2987,
    ACTIONS(9053), 1,
      aux_sym_integer_token1,
    ACTIONS(9055), 1,
      aux_sym_string_token1,
    ACTIONS(9057), 1,
      anon_sym_Set,
    STATE(7317), 1,
      sym_atom,
    ACTIONS(6226), 2,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
    STATE(7312), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    ACTIONS(6224), 3,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_PIPE,
    STATE(7309), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(9033), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [469231] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6714), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6712), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [469277] = 3,
    ACTIONS(6500), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6498), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [469323] = 3,
    ACTIONS(6568), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6566), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [469369] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6754), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6752), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [469415] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6651), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6649), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [469461] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6647), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6645), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [469507] = 3,
    ACTIONS(6572), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6570), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [469553] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6572), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6570), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [469599] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6568), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6566), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [469645] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6500), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6498), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [469691] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6655), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6653), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [469737] = 4,
    ACTIONS(9059), 1,
      anon_sym_AT,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6326), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6324), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [469785] = 4,
    ACTIONS(6326), 1,
      anon_sym_BSLASH,
    ACTIONS(9061), 1,
      anon_sym_AT,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6324), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [469833] = 3,
    ACTIONS(6647), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6645), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [469879] = 3,
    ACTIONS(6651), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6649), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [469925] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6496), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6494), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [469971] = 22,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(9063), 1,
      sym_id,
    ACTIONS(9066), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9072), 1,
      anon_sym_record,
    ACTIONS(9075), 1,
      anon_sym_LPAREN,
    ACTIONS(9078), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(9081), 1,
      anon_sym_u2983,
    ACTIONS(9084), 1,
      anon_sym_LBRACE,
    ACTIONS(9087), 1,
      aux_sym__qid_token1,
    ACTIONS(9090), 1,
      anon_sym_DOT,
    ACTIONS(9093), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(9096), 1,
      anon_sym_u2987,
    ACTIONS(9099), 1,
      aux_sym_integer_token1,
    ACTIONS(9102), 1,
      aux_sym_string_token1,
    ACTIONS(9105), 1,
      anon_sym_Set,
    ACTIONS(6239), 2,
      anon_sym_EQ,
      anon_sym_PIPE,
    ACTIONS(6241), 2,
      anon_sym_RPAREN,
      anon_sym_RBRACE_RBRACE,
    STATE(4705), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7582), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7590), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(9069), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [470055] = 3,
    ACTIONS(6496), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6494), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [470101] = 3,
    ACTIONS(6655), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6653), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [470147] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6655), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6653), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [470193] = 4,
    ACTIONS(6326), 1,
      anon_sym_BSLASH,
    ACTIONS(9108), 1,
      anon_sym_AT,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6324), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [470241] = 3,
    ACTIONS(6754), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6752), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [470287] = 3,
    ACTIONS(6714), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6712), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [470333] = 4,
    ACTIONS(6488), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6490), 4,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(6486), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [470381] = 23,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6364), 1,
      anon_sym_RPAREN,
    ACTIONS(8993), 1,
      sym_id,
    ACTIONS(8995), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8999), 1,
      anon_sym_record,
    ACTIONS(9001), 1,
      anon_sym_LPAREN,
    ACTIONS(9003), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(9005), 1,
      anon_sym_u2983,
    ACTIONS(9007), 1,
      anon_sym_LBRACE,
    ACTIONS(9009), 1,
      aux_sym__qid_token1,
    ACTIONS(9011), 1,
      anon_sym_DOT,
    ACTIONS(9015), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(9017), 1,
      anon_sym_u2987,
    ACTIONS(9019), 1,
      aux_sym_integer_token1,
    ACTIONS(9021), 1,
      aux_sym_string_token1,
    ACTIONS(9023), 1,
      anon_sym_Set,
    ACTIONS(9110), 1,
      anon_sym_PIPE,
    ACTIONS(6336), 2,
      anon_sym_COLON,
      anon_sym_EQ,
    STATE(4555), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7305), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7306), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(8997), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [470467] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6496), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6494), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [470513] = 3,
    ACTIONS(6433), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6431), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [470559] = 3,
    ACTIONS(6750), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6748), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [470605] = 3,
    ACTIONS(6496), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6494), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [470651] = 5,
    ACTIONS(6488), 1,
      anon_sym_BSLASH,
    ACTIONS(6492), 1,
      sym__newline,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6490), 4,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
    ACTIONS(6486), 31,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [470701] = 3,
    ACTIONS(6655), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6653), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [470747] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6326), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6324), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [470793] = 3,
    ACTIONS(6500), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6498), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [470839] = 3,
    ACTIONS(6568), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6566), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [470885] = 3,
    ACTIONS(6572), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6570), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [470931] = 3,
    ACTIONS(6647), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6645), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [470977] = 3,
    ACTIONS(6651), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6649), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [471023] = 3,
    ACTIONS(6754), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6752), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [471069] = 3,
    ACTIONS(6500), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6498), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [471115] = 3,
    ACTIONS(6484), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6482), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [471161] = 3,
    ACTIONS(6714), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6712), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [471207] = 3,
    ACTIONS(6433), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6431), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [471253] = 3,
    ACTIONS(6750), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6748), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [471299] = 3,
    ACTIONS(6710), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6708), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [471345] = 3,
    ACTIONS(6710), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6708), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [471391] = 4,
    ACTIONS(6326), 1,
      anon_sym_BSLASH,
    ACTIONS(9112), 1,
      anon_sym_AT,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6324), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [471439] = 3,
    ACTIONS(6484), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6482), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [471485] = 22,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6241), 1,
      anon_sym_RBRACE,
    ACTIONS(9114), 1,
      sym_id,
    ACTIONS(9117), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9123), 1,
      anon_sym_record,
    ACTIONS(9126), 1,
      anon_sym_LPAREN,
    ACTIONS(9129), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(9132), 1,
      anon_sym_u2983,
    ACTIONS(9135), 1,
      anon_sym_LBRACE,
    ACTIONS(9138), 1,
      aux_sym__qid_token1,
    ACTIONS(9141), 1,
      anon_sym_DOT,
    ACTIONS(9144), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(9147), 1,
      anon_sym_u2987,
    ACTIONS(9150), 1,
      aux_sym_integer_token1,
    ACTIONS(9153), 1,
      aux_sym_string_token1,
    ACTIONS(9156), 1,
      anon_sym_Set,
    STATE(4736), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7594), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    ACTIONS(6239), 3,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_PIPE,
    STATE(7606), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(9120), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [471569] = 3,
    ACTIONS(6433), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6431), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [471615] = 23,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6364), 1,
      sym__newline,
    ACTIONS(9159), 1,
      sym_id,
    ACTIONS(9161), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9165), 1,
      anon_sym_record,
    ACTIONS(9167), 1,
      anon_sym_LPAREN,
    ACTIONS(9169), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(9171), 1,
      anon_sym_u2983,
    ACTIONS(9173), 1,
      anon_sym_LBRACE,
    ACTIONS(9175), 1,
      aux_sym__qid_token1,
    ACTIONS(9177), 1,
      anon_sym_DOT,
    ACTIONS(9179), 1,
      anon_sym_PIPE,
    ACTIONS(9181), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(9183), 1,
      anon_sym_u2987,
    ACTIONS(9185), 1,
      aux_sym_integer_token1,
    ACTIONS(9187), 1,
      aux_sym_string_token1,
    ACTIONS(9189), 1,
      anon_sym_Set,
    ACTIONS(6336), 2,
      anon_sym_EQ,
      anon_sym_where,
    STATE(4777), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7577), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7571), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(9163), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [471701] = 3,
    ACTIONS(6568), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6566), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [471747] = 22,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6226), 1,
      anon_sym_RPAREN,
    ACTIONS(7693), 1,
      sym_id,
    ACTIONS(7695), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7699), 1,
      anon_sym_record,
    ACTIONS(7701), 1,
      anon_sym_LPAREN,
    ACTIONS(7703), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(7705), 1,
      anon_sym_u2983,
    ACTIONS(7707), 1,
      anon_sym_LBRACE,
    ACTIONS(7709), 1,
      aux_sym__qid_token1,
    ACTIONS(7711), 1,
      anon_sym_DOT,
    ACTIONS(7713), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(7715), 1,
      anon_sym_u2987,
    ACTIONS(7717), 1,
      aux_sym_integer_token1,
    ACTIONS(7719), 1,
      aux_sym_string_token1,
    ACTIONS(7721), 1,
      anon_sym_Set,
    STATE(7456), 1,
      sym_atom,
    STATE(7459), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    ACTIONS(6224), 4,
      anon_sym_public,
      anon_sym_using,
      anon_sym_hiding,
      anon_sym_renaming,
    STATE(7461), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(7697), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [471831] = 3,
    ACTIONS(6647), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6645), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [471877] = 3,
    ACTIONS(6484), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6482), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [471923] = 4,
    ACTIONS(6326), 1,
      anon_sym_BSLASH,
    ACTIONS(9191), 1,
      anon_sym_AT,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6324), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [471971] = 3,
    ACTIONS(6572), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6570), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [472017] = 22,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6226), 1,
      sym__newline,
    ACTIONS(7663), 1,
      sym_id,
    ACTIONS(7665), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7669), 1,
      anon_sym_record,
    ACTIONS(7671), 1,
      anon_sym_LPAREN,
    ACTIONS(7673), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(7675), 1,
      anon_sym_u2983,
    ACTIONS(7677), 1,
      anon_sym_LBRACE,
    ACTIONS(7679), 1,
      aux_sym__qid_token1,
    ACTIONS(7681), 1,
      anon_sym_DOT,
    ACTIONS(7683), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(7685), 1,
      anon_sym_u2987,
    ACTIONS(7687), 1,
      aux_sym_integer_token1,
    ACTIONS(7689), 1,
      aux_sym_string_token1,
    ACTIONS(7691), 1,
      anon_sym_Set,
    STATE(7379), 1,
      sym_atom,
    STATE(7400), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    ACTIONS(6224), 4,
      anon_sym_public,
      anon_sym_using,
      anon_sym_hiding,
      anon_sym_renaming,
    STATE(7291), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(7667), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [472101] = 3,
    ACTIONS(6750), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6748), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [472147] = 3,
    ACTIONS(6714), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6712), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [472193] = 3,
    ACTIONS(6647), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6645), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [472239] = 3,
    ACTIONS(6754), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6752), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [472285] = 3,
    ACTIONS(6651), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6649), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [472331] = 3,
    ACTIONS(6572), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6570), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [472377] = 3,
    ACTIONS(6568), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6566), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [472423] = 3,
    ACTIONS(6500), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6498), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [472469] = 4,
    ACTIONS(6326), 1,
      anon_sym_BSLASH,
    ACTIONS(9193), 1,
      anon_sym_AT,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6324), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [472517] = 3,
    ACTIONS(6651), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6649), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [472563] = 22,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6241), 1,
      anon_sym_RBRACE,
    ACTIONS(9195), 1,
      sym_id,
    ACTIONS(9198), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9204), 1,
      anon_sym_record,
    ACTIONS(9207), 1,
      anon_sym_LPAREN,
    ACTIONS(9210), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(9213), 1,
      anon_sym_u2983,
    ACTIONS(9216), 1,
      anon_sym_LBRACE,
    ACTIONS(9219), 1,
      aux_sym__qid_token1,
    ACTIONS(9222), 1,
      anon_sym_DOT,
    ACTIONS(9225), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(9228), 1,
      anon_sym_u2987,
    ACTIONS(9231), 1,
      aux_sym_integer_token1,
    ACTIONS(9234), 1,
      aux_sym_string_token1,
    ACTIONS(9237), 1,
      anon_sym_Set,
    STATE(4756), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7652), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    ACTIONS(6239), 3,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PIPE,
    STATE(7667), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(9201), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [472647] = 3,
    ACTIONS(6655), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6653), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [472693] = 3,
    ACTIONS(6754), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6752), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [472739] = 22,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(9240), 1,
      sym_id,
    ACTIONS(9242), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9246), 1,
      anon_sym_record,
    ACTIONS(9248), 1,
      anon_sym_LPAREN,
    ACTIONS(9250), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(9252), 1,
      anon_sym_u2983,
    ACTIONS(9254), 1,
      anon_sym_LBRACE,
    ACTIONS(9256), 1,
      aux_sym__qid_token1,
    ACTIONS(9258), 1,
      anon_sym_DOT,
    ACTIONS(9260), 1,
      anon_sym_PIPE,
    ACTIONS(9262), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(9264), 1,
      anon_sym_u2987,
    ACTIONS(9266), 1,
      aux_sym_integer_token1,
    ACTIONS(9268), 1,
      aux_sym_string_token1,
    ACTIONS(9270), 1,
      anon_sym_Set,
    STATE(4772), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7475), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    ACTIONS(6336), 3,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_u2984,
    STATE(7469), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(9244), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [472823] = 3,
    ACTIONS(6496), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6494), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [472869] = 3,
    ACTIONS(6714), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6712), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [472915] = 3,
    ACTIONS(6433), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6431), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [472961] = 3,
    ACTIONS(6750), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6748), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [473007] = 23,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6364), 1,
      anon_sym_RBRACE,
    ACTIONS(9029), 1,
      sym_id,
    ACTIONS(9031), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9035), 1,
      anon_sym_record,
    ACTIONS(9037), 1,
      anon_sym_LPAREN,
    ACTIONS(9039), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(9041), 1,
      anon_sym_u2983,
    ACTIONS(9043), 1,
      anon_sym_LBRACE,
    ACTIONS(9045), 1,
      aux_sym__qid_token1,
    ACTIONS(9047), 1,
      anon_sym_DOT,
    ACTIONS(9049), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(9051), 1,
      anon_sym_u2987,
    ACTIONS(9053), 1,
      aux_sym_integer_token1,
    ACTIONS(9055), 1,
      aux_sym_string_token1,
    ACTIONS(9057), 1,
      anon_sym_Set,
    ACTIONS(9272), 1,
      anon_sym_PIPE,
    ACTIONS(6336), 2,
      anon_sym_COLON,
      anon_sym_SEMI,
    STATE(4528), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7312), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7309), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(9033), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [473093] = 3,
    ACTIONS(6710), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6708), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [473139] = 3,
    ACTIONS(6484), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6482), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [473185] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6326), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6324), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [473231] = 4,
    ACTIONS(6326), 1,
      anon_sym_BSLASH,
    ACTIONS(9274), 1,
      anon_sym_AT,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6324), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [473279] = 5,
    ACTIONS(6488), 1,
      anon_sym_BSLASH,
    ACTIONS(6492), 1,
      sym__newline,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6490), 3,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_SEMI,
    ACTIONS(6486), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [473329] = 3,
    ACTIONS(6326), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6324), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [473375] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6655), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6653), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [473421] = 21,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(9276), 1,
      sym_id,
    ACTIONS(9279), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9285), 1,
      anon_sym_record,
    ACTIONS(9288), 1,
      anon_sym_LPAREN,
    ACTIONS(9291), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(9294), 1,
      anon_sym_u2983,
    ACTIONS(9297), 1,
      anon_sym_LBRACE,
    ACTIONS(9300), 1,
      aux_sym__qid_token1,
    ACTIONS(9303), 1,
      anon_sym_DOT,
    ACTIONS(9306), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(9309), 1,
      anon_sym_u2987,
    ACTIONS(9312), 1,
      aux_sym_integer_token1,
    ACTIONS(9315), 1,
      aux_sym_string_token1,
    ACTIONS(9318), 1,
      anon_sym_Set,
    STATE(4772), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7475), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    ACTIONS(6239), 4,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_u2984,
      anon_sym_PIPE,
    STATE(7469), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(9282), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [473503] = 5,
    ACTIONS(6488), 1,
      anon_sym_BSLASH,
    ACTIONS(6492), 1,
      sym__newline,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6490), 5,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_in,
    ACTIONS(6486), 30,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [473553] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6326), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6324), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [473599] = 5,
    ACTIONS(6488), 1,
      anon_sym_BSLASH,
    ACTIONS(6492), 1,
      sym__newline,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6490), 3,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
    ACTIONS(6486), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [473649] = 23,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6364), 1,
      anon_sym_RPAREN,
    ACTIONS(9321), 1,
      sym_id,
    ACTIONS(9323), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9327), 1,
      anon_sym_record,
    ACTIONS(9329), 1,
      anon_sym_LPAREN,
    ACTIONS(9331), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(9333), 1,
      anon_sym_u2983,
    ACTIONS(9335), 1,
      anon_sym_LBRACE,
    ACTIONS(9337), 1,
      aux_sym__qid_token1,
    ACTIONS(9339), 1,
      anon_sym_DOT,
    ACTIONS(9341), 1,
      anon_sym_PIPE,
    ACTIONS(9343), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(9345), 1,
      anon_sym_u2987,
    ACTIONS(9347), 1,
      aux_sym_integer_token1,
    ACTIONS(9349), 1,
      aux_sym_string_token1,
    ACTIONS(9351), 1,
      anon_sym_Set,
    ACTIONS(6336), 2,
      anon_sym_EQ,
      anon_sym_SEMI,
    STATE(4465), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7442), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7445), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(9325), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [473735] = 22,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6241), 1,
      sym__newline,
    ACTIONS(9353), 1,
      sym_id,
    ACTIONS(9356), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9362), 1,
      anon_sym_record,
    ACTIONS(9365), 1,
      anon_sym_LPAREN,
    ACTIONS(9368), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(9371), 1,
      anon_sym_u2983,
    ACTIONS(9374), 1,
      anon_sym_LBRACE,
    ACTIONS(9377), 1,
      aux_sym__qid_token1,
    ACTIONS(9380), 1,
      anon_sym_DOT,
    ACTIONS(9383), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(9386), 1,
      anon_sym_u2987,
    ACTIONS(9389), 1,
      aux_sym_integer_token1,
    ACTIONS(9392), 1,
      aux_sym_string_token1,
    ACTIONS(9395), 1,
      anon_sym_Set,
    STATE(4777), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7577), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    ACTIONS(6239), 3,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_PIPE,
    STATE(7571), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(9359), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [473819] = 22,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(9398), 1,
      sym_id,
    ACTIONS(9400), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9404), 1,
      anon_sym_record,
    ACTIONS(9406), 1,
      anon_sym_LPAREN,
    ACTIONS(9408), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(9410), 1,
      anon_sym_u2983,
    ACTIONS(9412), 1,
      anon_sym_LBRACE,
    ACTIONS(9414), 1,
      aux_sym__qid_token1,
    ACTIONS(9416), 1,
      anon_sym_DOT,
    ACTIONS(9418), 1,
      anon_sym_PIPE,
    ACTIONS(9420), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(9422), 1,
      anon_sym_u2987,
    ACTIONS(9424), 1,
      aux_sym_integer_token1,
    ACTIONS(9426), 1,
      aux_sym_string_token1,
    ACTIONS(9428), 1,
      anon_sym_Set,
    STATE(4865), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7502), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    ACTIONS(6336), 3,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_u2984,
    STATE(7501), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(9402), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [473903] = 22,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(9430), 1,
      sym_id,
    ACTIONS(9433), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9439), 1,
      anon_sym_record,
    ACTIONS(9442), 1,
      anon_sym_LPAREN,
    ACTIONS(9445), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(9448), 1,
      anon_sym_u2983,
    ACTIONS(9451), 1,
      anon_sym_LBRACE,
    ACTIONS(9454), 1,
      aux_sym__qid_token1,
    ACTIONS(9457), 1,
      anon_sym_DOT,
    ACTIONS(9460), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(9463), 1,
      anon_sym_u2987,
    ACTIONS(9466), 1,
      aux_sym_integer_token1,
    ACTIONS(9469), 1,
      aux_sym_string_token1,
    ACTIONS(9472), 1,
      anon_sym_Set,
    ACTIONS(6239), 2,
      anon_sym_COLON,
      anon_sym_PIPE,
    ACTIONS(6241), 2,
      anon_sym_RPAREN,
      anon_sym_RBRACE_RBRACE,
    STATE(4779), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7641), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7631), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(9436), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [473987] = 5,
    ACTIONS(6488), 1,
      anon_sym_BSLASH,
    ACTIONS(6492), 1,
      sym__newline,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6490), 5,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
    ACTIONS(6486), 30,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [474037] = 23,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6364), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(9475), 1,
      sym_id,
    ACTIONS(9477), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9481), 1,
      anon_sym_record,
    ACTIONS(9483), 1,
      anon_sym_LPAREN,
    ACTIONS(9485), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(9487), 1,
      anon_sym_u2983,
    ACTIONS(9489), 1,
      anon_sym_LBRACE,
    ACTIONS(9491), 1,
      aux_sym__qid_token1,
    ACTIONS(9493), 1,
      anon_sym_DOT,
    ACTIONS(9495), 1,
      anon_sym_PIPE,
    ACTIONS(9497), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(9499), 1,
      anon_sym_u2987,
    ACTIONS(9501), 1,
      aux_sym_integer_token1,
    ACTIONS(9503), 1,
      aux_sym_string_token1,
    ACTIONS(9505), 1,
      anon_sym_Set,
    ACTIONS(6336), 2,
      anon_sym_EQ,
      anon_sym_SEMI,
    STATE(4878), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7555), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7552), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(9479), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [474123] = 22,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(9507), 1,
      sym_id,
    ACTIONS(9509), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9513), 1,
      anon_sym_record,
    ACTIONS(9515), 1,
      anon_sym_LPAREN,
    ACTIONS(9517), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(9519), 1,
      anon_sym_u2983,
    ACTIONS(9521), 1,
      anon_sym_LBRACE,
    ACTIONS(9523), 1,
      aux_sym__qid_token1,
    ACTIONS(9525), 1,
      anon_sym_DOT,
    ACTIONS(9527), 1,
      anon_sym_PIPE,
    ACTIONS(9529), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(9531), 1,
      anon_sym_u2987,
    ACTIONS(9533), 1,
      aux_sym_integer_token1,
    ACTIONS(9535), 1,
      aux_sym_string_token1,
    ACTIONS(9537), 1,
      anon_sym_Set,
    STATE(4893), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7575), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    ACTIONS(6336), 3,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_u2988,
    STATE(7573), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(9511), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [474207] = 23,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6364), 1,
      sym__newline,
    ACTIONS(9539), 1,
      sym_id,
    ACTIONS(9541), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9545), 1,
      anon_sym_record,
    ACTIONS(9547), 1,
      anon_sym_LPAREN,
    ACTIONS(9549), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(9551), 1,
      anon_sym_u2983,
    ACTIONS(9553), 1,
      anon_sym_LBRACE,
    ACTIONS(9555), 1,
      aux_sym__qid_token1,
    ACTIONS(9557), 1,
      anon_sym_DOT,
    ACTIONS(9559), 1,
      anon_sym_PIPE,
    ACTIONS(9561), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(9563), 1,
      anon_sym_u2987,
    ACTIONS(9565), 1,
      aux_sym_integer_token1,
    ACTIONS(9567), 1,
      aux_sym_string_token1,
    ACTIONS(9569), 1,
      anon_sym_Set,
    ACTIONS(6336), 2,
      anon_sym_EQ,
      anon_sym_in,
    STATE(4900), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7603), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7600), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(9543), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [474293] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6484), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6482), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [474339] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6484), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6482), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [474385] = 5,
    ACTIONS(6488), 1,
      anon_sym_BSLASH,
    ACTIONS(6492), 1,
      sym__newline,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6490), 5,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_in,
    ACTIONS(6486), 30,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [474435] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6710), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6708), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [474481] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6750), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6748), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [474527] = 4,
    ACTIONS(6326), 1,
      anon_sym_BSLASH,
    ACTIONS(9571), 1,
      anon_sym_AT,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6324), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [474575] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6433), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6431), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [474621] = 4,
    ACTIONS(9573), 1,
      anon_sym_AT,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6326), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6324), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [474669] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6714), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6712), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [474715] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6754), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6752), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [474761] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6651), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6649), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [474807] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6647), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6645), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [474853] = 23,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6364), 1,
      anon_sym_RPAREN,
    ACTIONS(9029), 1,
      sym_id,
    ACTIONS(9031), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9035), 1,
      anon_sym_record,
    ACTIONS(9037), 1,
      anon_sym_LPAREN,
    ACTIONS(9039), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(9041), 1,
      anon_sym_u2983,
    ACTIONS(9043), 1,
      anon_sym_LBRACE,
    ACTIONS(9045), 1,
      aux_sym__qid_token1,
    ACTIONS(9047), 1,
      anon_sym_DOT,
    ACTIONS(9049), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(9051), 1,
      anon_sym_u2987,
    ACTIONS(9053), 1,
      aux_sym_integer_token1,
    ACTIONS(9055), 1,
      aux_sym_string_token1,
    ACTIONS(9057), 1,
      anon_sym_Set,
    ACTIONS(9575), 1,
      anon_sym_PIPE,
    ACTIONS(6336), 2,
      anon_sym_COLON,
      anon_sym_SEMI,
    STATE(4528), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7312), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7309), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(9033), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [474939] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6572), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6570), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [474985] = 23,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6364), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(9321), 1,
      sym_id,
    ACTIONS(9323), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9327), 1,
      anon_sym_record,
    ACTIONS(9329), 1,
      anon_sym_LPAREN,
    ACTIONS(9331), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(9333), 1,
      anon_sym_u2983,
    ACTIONS(9335), 1,
      anon_sym_LBRACE,
    ACTIONS(9337), 1,
      aux_sym__qid_token1,
    ACTIONS(9339), 1,
      anon_sym_DOT,
    ACTIONS(9343), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(9345), 1,
      anon_sym_u2987,
    ACTIONS(9347), 1,
      aux_sym_integer_token1,
    ACTIONS(9349), 1,
      aux_sym_string_token1,
    ACTIONS(9351), 1,
      anon_sym_Set,
    ACTIONS(9577), 1,
      anon_sym_PIPE,
    ACTIONS(6336), 2,
      anon_sym_EQ,
      anon_sym_SEMI,
    STATE(4465), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7442), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7445), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(9325), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [475071] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6710), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6708), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [475117] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6568), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6566), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [475163] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6750), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6748), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [475209] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6500), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6498), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [475255] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6433), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6431), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [475301] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6714), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6712), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [475347] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6754), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6752), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [475393] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6651), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6649), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [475439] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6647), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6645), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [475485] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6572), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6570), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [475531] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6568), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6566), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [475577] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6500), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6498), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [475623] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6496), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6494), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [475669] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6710), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6708), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [475715] = 22,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(9321), 1,
      sym_id,
    ACTIONS(9323), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9327), 1,
      anon_sym_record,
    ACTIONS(9329), 1,
      anon_sym_LPAREN,
    ACTIONS(9331), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(9333), 1,
      anon_sym_u2983,
    ACTIONS(9335), 1,
      anon_sym_LBRACE,
    ACTIONS(9337), 1,
      aux_sym__qid_token1,
    ACTIONS(9339), 1,
      anon_sym_DOT,
    ACTIONS(9343), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(9345), 1,
      anon_sym_u2987,
    ACTIONS(9347), 1,
      aux_sym_integer_token1,
    ACTIONS(9349), 1,
      aux_sym_string_token1,
    ACTIONS(9351), 1,
      anon_sym_Set,
    STATE(7438), 1,
      sym_atom,
    ACTIONS(6226), 2,
      anon_sym_RPAREN,
      anon_sym_RBRACE_RBRACE,
    STATE(7442), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    ACTIONS(6224), 3,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_PIPE,
    STATE(7445), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(9325), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [475799] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6655), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6653), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [475845] = 4,
    ACTIONS(6326), 1,
      anon_sym_BSLASH,
    ACTIONS(9579), 1,
      anon_sym_AT,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6324), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_PIPE_RPAREN,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [475893] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6496), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6494), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [475939] = 4,
    ACTIONS(9581), 1,
      anon_sym_AT,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6326), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6324), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [475987] = 22,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6226), 1,
      sym__newline,
    ACTIONS(8369), 1,
      sym_id,
    ACTIONS(8371), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8375), 1,
      anon_sym_record,
    ACTIONS(8377), 1,
      anon_sym_LPAREN,
    ACTIONS(8379), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(8381), 1,
      anon_sym_u2983,
    ACTIONS(8383), 1,
      anon_sym_LBRACE,
    ACTIONS(8385), 1,
      aux_sym__qid_token1,
    ACTIONS(8387), 1,
      anon_sym_DOT,
    ACTIONS(8391), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(8393), 1,
      anon_sym_u2987,
    ACTIONS(8395), 1,
      aux_sym_integer_token1,
    ACTIONS(8397), 1,
      aux_sym_string_token1,
    ACTIONS(8399), 1,
      anon_sym_Set,
    STATE(7426), 1,
      sym_atom,
    STATE(7389), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    ACTIONS(6224), 4,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_in,
    STATE(7302), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(8373), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [476071] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6500), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6498), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [476117] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6568), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6566), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [476163] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6572), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6570), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [476209] = 4,
    ACTIONS(6326), 1,
      anon_sym_BSLASH,
    ACTIONS(9583), 1,
      anon_sym_AT,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6324), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [476257] = 4,
    ACTIONS(6326), 1,
      anon_sym_BSLASH,
    ACTIONS(9585), 1,
      anon_sym_AT,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6324), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_u2988,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [476305] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6655), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6653), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [476351] = 21,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(9587), 1,
      sym_id,
    ACTIONS(9590), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9596), 1,
      anon_sym_record,
    ACTIONS(9599), 1,
      anon_sym_LPAREN,
    ACTIONS(9602), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(9605), 1,
      anon_sym_u2983,
    ACTIONS(9608), 1,
      anon_sym_LBRACE,
    ACTIONS(9611), 1,
      aux_sym__qid_token1,
    ACTIONS(9614), 1,
      anon_sym_DOT,
    ACTIONS(9617), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(9620), 1,
      anon_sym_u2987,
    ACTIONS(9623), 1,
      aux_sym_integer_token1,
    ACTIONS(9626), 1,
      aux_sym_string_token1,
    ACTIONS(9629), 1,
      anon_sym_Set,
    STATE(4825), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7504), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    ACTIONS(6239), 4,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_PIPE,
    STATE(7499), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(9593), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [476433] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6496), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6494), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [476479] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6647), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6645), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [476525] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6651), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6649), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [476571] = 4,
    ACTIONS(6326), 1,
      anon_sym_BSLASH,
    ACTIONS(9108), 1,
      anon_sym_AT,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6324), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [476619] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6754), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6752), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [476665] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6710), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6708), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [476711] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6433), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6431), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [476757] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6714), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6712), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [476803] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6433), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6431), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [476849] = 4,
    ACTIONS(9632), 1,
      anon_sym_AT,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6326), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6324), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [476897] = 4,
    ACTIONS(9634), 1,
      anon_sym_AT,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6326), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6324), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [476945] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6647), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6645), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [476991] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6750), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6748), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [477037] = 5,
    ACTIONS(6488), 1,
      anon_sym_BSLASH,
    ACTIONS(6492), 1,
      sym__newline,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6490), 5,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
    ACTIONS(6486), 30,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [477087] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6484), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6482), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [477133] = 23,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6364), 1,
      anon_sym_RBRACE,
    ACTIONS(9636), 1,
      sym_id,
    ACTIONS(9638), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9642), 1,
      anon_sym_record,
    ACTIONS(9644), 1,
      anon_sym_LPAREN,
    ACTIONS(9646), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(9648), 1,
      anon_sym_u2983,
    ACTIONS(9650), 1,
      anon_sym_LBRACE,
    ACTIONS(9652), 1,
      aux_sym__qid_token1,
    ACTIONS(9654), 1,
      anon_sym_DOT,
    ACTIONS(9656), 1,
      anon_sym_PIPE,
    ACTIONS(9658), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(9660), 1,
      anon_sym_u2987,
    ACTIONS(9662), 1,
      aux_sym_integer_token1,
    ACTIONS(9664), 1,
      aux_sym_string_token1,
    ACTIONS(9666), 1,
      anon_sym_Set,
    ACTIONS(6336), 2,
      anon_sym_EQ,
      anon_sym_SEMI,
    STATE(4736), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7594), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7606), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(9640), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [477219] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6326), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6324), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [477265] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6750), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6748), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [477311] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6750), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6748), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [477357] = 22,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6241), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(9668), 1,
      sym_id,
    ACTIONS(9671), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9677), 1,
      anon_sym_record,
    ACTIONS(9680), 1,
      anon_sym_LPAREN,
    ACTIONS(9683), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(9686), 1,
      anon_sym_u2983,
    ACTIONS(9689), 1,
      anon_sym_LBRACE,
    ACTIONS(9692), 1,
      aux_sym__qid_token1,
    ACTIONS(9695), 1,
      anon_sym_DOT,
    ACTIONS(9698), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(9701), 1,
      anon_sym_u2987,
    ACTIONS(9704), 1,
      aux_sym_integer_token1,
    ACTIONS(9707), 1,
      aux_sym_string_token1,
    ACTIONS(9710), 1,
      anon_sym_Set,
    STATE(4845), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7468), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    ACTIONS(6239), 3,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_PIPE,
    STATE(7497), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(9674), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [477441] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6500), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6498), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [477487] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6714), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6712), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [477533] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6433), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6431), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [477579] = 5,
    ACTIONS(6488), 1,
      anon_sym_BSLASH,
    ACTIONS(6492), 1,
      sym__newline,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6490), 3,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_in,
    ACTIONS(6486), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [477629] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6754), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6752), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [477675] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6651), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6649), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [477721] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6714), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6712), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [477767] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6572), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6570), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [477813] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6568), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6566), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [477859] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6500), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6498), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [477905] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6326), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6324), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [477951] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6754), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6752), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [477997] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6484), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6482), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [478043] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6651), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6649), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [478089] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6710), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6708), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [478135] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6647), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6645), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [478181] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6433), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6431), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [478227] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6572), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6570), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [478273] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6568), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6566), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [478319] = 21,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(9713), 1,
      sym_id,
    ACTIONS(9716), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9722), 1,
      anon_sym_record,
    ACTIONS(9725), 1,
      anon_sym_LPAREN,
    ACTIONS(9728), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(9731), 1,
      anon_sym_u2983,
    ACTIONS(9734), 1,
      anon_sym_LBRACE,
    ACTIONS(9737), 1,
      aux_sym__qid_token1,
    ACTIONS(9740), 1,
      anon_sym_DOT,
    ACTIONS(9743), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(9746), 1,
      anon_sym_u2987,
    ACTIONS(9749), 1,
      aux_sym_integer_token1,
    ACTIONS(9752), 1,
      aux_sym_string_token1,
    ACTIONS(9755), 1,
      anon_sym_Set,
    STATE(4865), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7502), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    ACTIONS(6239), 4,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_u2984,
      anon_sym_PIPE,
    STATE(7501), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(9719), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [478401] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6500), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6498), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [478447] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6647), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6645), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [478493] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6484), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6482), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [478539] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6655), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6653), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [478585] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6484), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6482), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [478631] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6655), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6653), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [478677] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6496), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6494), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [478723] = 23,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6364), 1,
      anon_sym_RBRACE,
    ACTIONS(9758), 1,
      sym_id,
    ACTIONS(9760), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9764), 1,
      anon_sym_record,
    ACTIONS(9766), 1,
      anon_sym_LPAREN,
    ACTIONS(9768), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(9770), 1,
      anon_sym_u2983,
    ACTIONS(9772), 1,
      anon_sym_LBRACE,
    ACTIONS(9774), 1,
      aux_sym__qid_token1,
    ACTIONS(9776), 1,
      anon_sym_DOT,
    ACTIONS(9778), 1,
      anon_sym_PIPE,
    ACTIONS(9780), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(9782), 1,
      anon_sym_u2987,
    ACTIONS(9784), 1,
      aux_sym_integer_token1,
    ACTIONS(9786), 1,
      aux_sym_string_token1,
    ACTIONS(9788), 1,
      anon_sym_Set,
    ACTIONS(6336), 2,
      anon_sym_COLON,
      anon_sym_EQ,
    STATE(4756), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7652), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7667), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(9762), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [478809] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6750), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6748), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [478855] = 4,
    ACTIONS(6326), 1,
      anon_sym_BSLASH,
    ACTIONS(9790), 1,
      anon_sym_AT,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6324), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [478903] = 23,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6364), 1,
      sym__newline,
    ACTIONS(9792), 1,
      sym_id,
    ACTIONS(9794), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9798), 1,
      anon_sym_record,
    ACTIONS(9800), 1,
      anon_sym_LPAREN,
    ACTIONS(9802), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(9804), 1,
      anon_sym_u2983,
    ACTIONS(9806), 1,
      anon_sym_LBRACE,
    ACTIONS(9808), 1,
      aux_sym__qid_token1,
    ACTIONS(9810), 1,
      anon_sym_DOT,
    ACTIONS(9812), 1,
      anon_sym_PIPE,
    ACTIONS(9814), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(9816), 1,
      anon_sym_u2987,
    ACTIONS(9818), 1,
      aux_sym_integer_token1,
    ACTIONS(9820), 1,
      aux_sym_string_token1,
    ACTIONS(9822), 1,
      anon_sym_Set,
    ACTIONS(6336), 2,
      anon_sym_EQ,
      anon_sym_SEMI,
    STATE(4917), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7535), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7536), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(9796), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [478989] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6714), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6712), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [479035] = 22,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6241), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(9824), 1,
      sym_id,
    ACTIONS(9827), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9833), 1,
      anon_sym_record,
    ACTIONS(9836), 1,
      anon_sym_LPAREN,
    ACTIONS(9839), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(9842), 1,
      anon_sym_u2983,
    ACTIONS(9845), 1,
      anon_sym_LBRACE,
    ACTIONS(9848), 1,
      aux_sym__qid_token1,
    ACTIONS(9851), 1,
      anon_sym_DOT,
    ACTIONS(9854), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(9857), 1,
      anon_sym_u2987,
    ACTIONS(9860), 1,
      aux_sym_integer_token1,
    ACTIONS(9863), 1,
      aux_sym_string_token1,
    ACTIONS(9866), 1,
      anon_sym_Set,
    STATE(4878), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7555), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    ACTIONS(6239), 3,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_PIPE,
    STATE(7552), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(9830), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [479119] = 21,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(9869), 1,
      sym_id,
    ACTIONS(9872), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9878), 1,
      anon_sym_record,
    ACTIONS(9881), 1,
      anon_sym_LPAREN,
    ACTIONS(9884), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(9887), 1,
      anon_sym_u2983,
    ACTIONS(9890), 1,
      anon_sym_LBRACE,
    ACTIONS(9893), 1,
      aux_sym__qid_token1,
    ACTIONS(9896), 1,
      anon_sym_DOT,
    ACTIONS(9899), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(9902), 1,
      anon_sym_u2987,
    ACTIONS(9905), 1,
      aux_sym_integer_token1,
    ACTIONS(9908), 1,
      aux_sym_string_token1,
    ACTIONS(9911), 1,
      anon_sym_Set,
    STATE(4879), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7489), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    ACTIONS(6239), 4,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_u2984,
      anon_sym_PIPE,
    STATE(7488), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(9875), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [479201] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6754), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6752), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [479247] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6710), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6708), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [479293] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6750), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6748), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [479339] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6433), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6431), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [479385] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6496), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6494), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [479431] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6572), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6570), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [479477] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6568), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6566), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [479523] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6714), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6712), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [479569] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6754), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6752), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [479615] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6500), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6498), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [479661] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6326), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6324), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [479707] = 4,
    ACTIONS(9914), 1,
      anon_sym_AT,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6326), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6324), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [479755] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6496), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6494), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [479801] = 21,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(9916), 1,
      sym_id,
    ACTIONS(9919), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9925), 1,
      anon_sym_record,
    ACTIONS(9928), 1,
      anon_sym_LPAREN,
    ACTIONS(9931), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(9934), 1,
      anon_sym_u2983,
    ACTIONS(9937), 1,
      anon_sym_LBRACE,
    ACTIONS(9940), 1,
      aux_sym__qid_token1,
    ACTIONS(9943), 1,
      anon_sym_DOT,
    ACTIONS(9946), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(9949), 1,
      anon_sym_u2987,
    ACTIONS(9952), 1,
      aux_sym_integer_token1,
    ACTIONS(9955), 1,
      aux_sym_string_token1,
    ACTIONS(9958), 1,
      anon_sym_Set,
    STATE(4893), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7575), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    ACTIONS(6239), 4,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_u2988,
    STATE(7573), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(9922), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [479883] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6655), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6653), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [479929] = 5,
    ACTIONS(6488), 1,
      anon_sym_BSLASH,
    ACTIONS(6492), 1,
      sym__newline,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6490), 3,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_in,
    ACTIONS(6486), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [479979] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6484), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6482), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [480025] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6651), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6649), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [480071] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6710), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6708), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [480117] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6655), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6653), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [480163] = 22,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6241), 1,
      sym__newline,
    ACTIONS(9961), 1,
      sym_id,
    ACTIONS(9964), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9970), 1,
      anon_sym_record,
    ACTIONS(9973), 1,
      anon_sym_LPAREN,
    ACTIONS(9976), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(9979), 1,
      anon_sym_u2983,
    ACTIONS(9982), 1,
      anon_sym_LBRACE,
    ACTIONS(9985), 1,
      aux_sym__qid_token1,
    ACTIONS(9988), 1,
      anon_sym_DOT,
    ACTIONS(9991), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(9994), 1,
      anon_sym_u2987,
    ACTIONS(9997), 1,
      aux_sym_integer_token1,
    ACTIONS(10000), 1,
      aux_sym_string_token1,
    ACTIONS(10003), 1,
      anon_sym_Set,
    STATE(4900), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7603), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    ACTIONS(6239), 3,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_in,
    STATE(7600), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(9967), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [480247] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6496), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6494), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [480293] = 3,
    ACTIONS(6326), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6324), 36,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [480339] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6326), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6324), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [480385] = 22,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(10006), 1,
      sym_id,
    ACTIONS(10008), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10012), 1,
      anon_sym_record,
    ACTIONS(10014), 1,
      anon_sym_LPAREN,
    ACTIONS(10016), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(10018), 1,
      anon_sym_u2983,
    ACTIONS(10020), 1,
      anon_sym_LBRACE,
    ACTIONS(10022), 1,
      aux_sym__qid_token1,
    ACTIONS(10024), 1,
      anon_sym_DOT,
    ACTIONS(10026), 1,
      anon_sym_PIPE,
    ACTIONS(10028), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(10030), 1,
      anon_sym_u2987,
    ACTIONS(10032), 1,
      aux_sym_integer_token1,
    ACTIONS(10034), 1,
      aux_sym_string_token1,
    ACTIONS(10036), 1,
      anon_sym_Set,
    STATE(4879), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7489), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    ACTIONS(6336), 3,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_u2984,
    STATE(7488), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(10010), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [480469] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6647), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6645), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [480515] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6572), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6570), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [480561] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6326), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6324), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [480607] = 5,
    ACTIONS(6488), 1,
      anon_sym_BSLASH,
    ACTIONS(6492), 1,
      sym__newline,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6490), 4,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_in,
    ACTIONS(6486), 31,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [480657] = 22,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(10038), 1,
      sym_id,
    ACTIONS(10040), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10044), 1,
      anon_sym_record,
    ACTIONS(10046), 1,
      anon_sym_LPAREN,
    ACTIONS(10048), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(10050), 1,
      anon_sym_u2983,
    ACTIONS(10052), 1,
      anon_sym_LBRACE,
    ACTIONS(10054), 1,
      aux_sym__qid_token1,
    ACTIONS(10056), 1,
      anon_sym_DOT,
    ACTIONS(10058), 1,
      anon_sym_PIPE,
    ACTIONS(10060), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(10062), 1,
      anon_sym_u2987,
    ACTIONS(10064), 1,
      aux_sym_integer_token1,
    ACTIONS(10066), 1,
      aux_sym_string_token1,
    ACTIONS(10068), 1,
      anon_sym_Set,
    STATE(4825), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7504), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    ACTIONS(6336), 3,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_SEMI,
    STATE(7499), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(10042), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [480741] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6326), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6324), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [480787] = 4,
    ACTIONS(6326), 1,
      anon_sym_BSLASH,
    ACTIONS(10070), 1,
      anon_sym_AT,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6324), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [480835] = 22,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(8993), 1,
      sym_id,
    ACTIONS(8995), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8999), 1,
      anon_sym_record,
    ACTIONS(9001), 1,
      anon_sym_LPAREN,
    ACTIONS(9003), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(9005), 1,
      anon_sym_u2983,
    ACTIONS(9007), 1,
      anon_sym_LBRACE,
    ACTIONS(9009), 1,
      aux_sym__qid_token1,
    ACTIONS(9011), 1,
      anon_sym_DOT,
    ACTIONS(9015), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(9017), 1,
      anon_sym_u2987,
    ACTIONS(9019), 1,
      aux_sym_integer_token1,
    ACTIONS(9021), 1,
      aux_sym_string_token1,
    ACTIONS(9023), 1,
      anon_sym_Set,
    STATE(7301), 1,
      sym_atom,
    ACTIONS(6226), 2,
      anon_sym_RPAREN,
      anon_sym_RBRACE_RBRACE,
    STATE(7305), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    ACTIONS(6224), 3,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PIPE,
    STATE(7306), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(8997), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [480919] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6568), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6566), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [480965] = 4,
    ACTIONS(6488), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6490), 5,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(6486), 31,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [481013] = 4,
    ACTIONS(10072), 1,
      anon_sym_AT,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6326), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6324), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [481061] = 4,
    ACTIONS(6488), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6490), 4,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(6486), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [481109] = 22,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6241), 1,
      sym__newline,
    ACTIONS(10074), 1,
      sym_id,
    ACTIONS(10077), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10083), 1,
      anon_sym_record,
    ACTIONS(10086), 1,
      anon_sym_LPAREN,
    ACTIONS(10089), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(10092), 1,
      anon_sym_u2983,
    ACTIONS(10095), 1,
      anon_sym_LBRACE,
    ACTIONS(10098), 1,
      aux_sym__qid_token1,
    ACTIONS(10101), 1,
      anon_sym_DOT,
    ACTIONS(10104), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(10107), 1,
      anon_sym_u2987,
    ACTIONS(10110), 1,
      aux_sym_integer_token1,
    ACTIONS(10113), 1,
      aux_sym_string_token1,
    ACTIONS(10116), 1,
      anon_sym_Set,
    STATE(4917), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7535), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    ACTIONS(6239), 3,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_PIPE,
    STATE(7536), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(10080), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [481193] = 3,
    ACTIONS(6326), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6324), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_u2988,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [481238] = 22,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(10119), 1,
      sym_id,
    ACTIONS(10123), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10127), 1,
      anon_sym_record,
    ACTIONS(10129), 1,
      anon_sym_LPAREN,
    ACTIONS(10131), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(10133), 1,
      anon_sym_u2983,
    ACTIONS(10135), 1,
      anon_sym_LBRACE,
    ACTIONS(10137), 1,
      aux_sym__qid_token1,
    ACTIONS(10139), 1,
      anon_sym_DOT,
    ACTIONS(10141), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(10143), 1,
      anon_sym_u2987,
    ACTIONS(10145), 1,
      aux_sym_integer_token1,
    ACTIONS(10147), 1,
      aux_sym_string_token1,
    ACTIONS(10149), 1,
      anon_sym_Set,
    STATE(2119), 1,
      sym__ARROW,
    ACTIONS(10121), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(5496), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7812), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7815), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(10125), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [481321] = 3,
    ACTIONS(6484), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6482), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [481366] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6484), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6482), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [481411] = 4,
    ACTIONS(6326), 1,
      anon_sym_BSLASH,
    ACTIONS(10151), 1,
      anon_sym_AT,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6324), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [481458] = 3,
    ACTIONS(6655), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6653), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [481503] = 5,
    ACTIONS(6488), 1,
      anon_sym_BSLASH,
    ACTIONS(6492), 1,
      sym__newline,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6490), 4,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
    ACTIONS(6486), 30,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [481552] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6655), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6653), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [481597] = 3,
    ACTIONS(6500), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6498), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [481642] = 3,
    ACTIONS(6568), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6566), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [481687] = 3,
    ACTIONS(6572), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6570), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [481732] = 3,
    ACTIONS(6647), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6645), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [481777] = 3,
    ACTIONS(6651), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6649), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [481822] = 3,
    ACTIONS(6754), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6752), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [481867] = 21,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(9240), 1,
      sym_id,
    ACTIONS(9242), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9246), 1,
      anon_sym_record,
    ACTIONS(9248), 1,
      anon_sym_LPAREN,
    ACTIONS(9250), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(9252), 1,
      anon_sym_u2983,
    ACTIONS(9254), 1,
      anon_sym_LBRACE,
    ACTIONS(9256), 1,
      aux_sym__qid_token1,
    ACTIONS(9258), 1,
      anon_sym_DOT,
    ACTIONS(9262), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(9264), 1,
      anon_sym_u2987,
    ACTIONS(9266), 1,
      aux_sym_integer_token1,
    ACTIONS(9268), 1,
      aux_sym_string_token1,
    ACTIONS(9270), 1,
      anon_sym_Set,
    STATE(7474), 1,
      sym_atom,
    STATE(7475), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    ACTIONS(6224), 4,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_u2984,
      anon_sym_PIPE,
    STATE(7469), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(9244), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [481948] = 3,
    ACTIONS(6714), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6712), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [481993] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6710), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6708), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [482038] = 3,
    ACTIONS(6433), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6431), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [482083] = 3,
    ACTIONS(6750), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6748), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [482128] = 3,
    ACTIONS(6710), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6708), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [482173] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6750), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6748), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [482218] = 3,
    ACTIONS(6484), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6482), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [482263] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6433), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6431), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [482308] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6714), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6712), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [482353] = 22,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(10119), 1,
      sym_id,
    ACTIONS(10123), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10127), 1,
      anon_sym_record,
    ACTIONS(10129), 1,
      anon_sym_LPAREN,
    ACTIONS(10131), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(10133), 1,
      anon_sym_u2983,
    ACTIONS(10135), 1,
      anon_sym_LBRACE,
    ACTIONS(10137), 1,
      aux_sym__qid_token1,
    ACTIONS(10139), 1,
      anon_sym_DOT,
    ACTIONS(10141), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(10143), 1,
      anon_sym_u2987,
    ACTIONS(10145), 1,
      aux_sym_integer_token1,
    ACTIONS(10147), 1,
      aux_sym_string_token1,
    ACTIONS(10149), 1,
      anon_sym_Set,
    STATE(1893), 1,
      sym__ARROW,
    ACTIONS(10153), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(5496), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7812), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7815), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(10125), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [482436] = 22,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6241), 1,
      anon_sym_RBRACE,
    ACTIONS(10155), 1,
      sym_id,
    ACTIONS(10158), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10164), 1,
      anon_sym_record,
    ACTIONS(10167), 1,
      anon_sym_LPAREN,
    ACTIONS(10170), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(10173), 1,
      anon_sym_u2983,
    ACTIONS(10176), 1,
      anon_sym_LBRACE,
    ACTIONS(10179), 1,
      aux_sym__qid_token1,
    ACTIONS(10182), 1,
      anon_sym_DOT,
    ACTIONS(10185), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(10188), 1,
      anon_sym_u2987,
    ACTIONS(10191), 1,
      aux_sym_integer_token1,
    ACTIONS(10194), 1,
      aux_sym_string_token1,
    ACTIONS(10197), 1,
      anon_sym_Set,
    ACTIONS(6239), 2,
      anon_sym_SEMI,
      anon_sym_PIPE,
    STATE(4943), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7690), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7735), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(10161), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [482519] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6754), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6752), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [482564] = 4,
    ACTIONS(6488), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6490), 4,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_u2984,
    ACTIONS(6486), 31,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [482611] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6500), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6498), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [482656] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6568), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6566), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [482701] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6572), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6570), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [482746] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6647), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6645), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [482791] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6651), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6649), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [482836] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6496), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6494), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [482881] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6754), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6752), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [482926] = 3,
    ACTIONS(6496), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6494), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [482971] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6714), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6712), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [483016] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6651), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6649), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [483061] = 22,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(10119), 1,
      sym_id,
    ACTIONS(10123), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10127), 1,
      anon_sym_record,
    ACTIONS(10129), 1,
      anon_sym_LPAREN,
    ACTIONS(10131), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(10133), 1,
      anon_sym_u2983,
    ACTIONS(10135), 1,
      anon_sym_LBRACE,
    ACTIONS(10137), 1,
      aux_sym__qid_token1,
    ACTIONS(10139), 1,
      anon_sym_DOT,
    ACTIONS(10141), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(10143), 1,
      anon_sym_u2987,
    ACTIONS(10145), 1,
      aux_sym_integer_token1,
    ACTIONS(10147), 1,
      aux_sym_string_token1,
    ACTIONS(10149), 1,
      anon_sym_Set,
    STATE(1622), 1,
      sym__ARROW,
    ACTIONS(10200), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(5496), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7812), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7815), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(10125), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [483144] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6433), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6431), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [483189] = 22,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(10119), 1,
      sym_id,
    ACTIONS(10123), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10127), 1,
      anon_sym_record,
    ACTIONS(10129), 1,
      anon_sym_LPAREN,
    ACTIONS(10131), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(10133), 1,
      anon_sym_u2983,
    ACTIONS(10135), 1,
      anon_sym_LBRACE,
    ACTIONS(10137), 1,
      aux_sym__qid_token1,
    ACTIONS(10139), 1,
      anon_sym_DOT,
    ACTIONS(10141), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(10143), 1,
      anon_sym_u2987,
    ACTIONS(10145), 1,
      aux_sym_integer_token1,
    ACTIONS(10147), 1,
      aux_sym_string_token1,
    ACTIONS(10149), 1,
      anon_sym_Set,
    STATE(2247), 1,
      sym__ARROW,
    ACTIONS(10202), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(5496), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7812), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7815), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(10125), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [483272] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6750), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6748), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [483317] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6710), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6708), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [483362] = 3,
    ACTIONS(6710), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6708), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [483407] = 22,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(10119), 1,
      sym_id,
    ACTIONS(10123), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10127), 1,
      anon_sym_record,
    ACTIONS(10129), 1,
      anon_sym_LPAREN,
    ACTIONS(10131), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(10133), 1,
      anon_sym_u2983,
    ACTIONS(10135), 1,
      anon_sym_LBRACE,
    ACTIONS(10137), 1,
      aux_sym__qid_token1,
    ACTIONS(10139), 1,
      anon_sym_DOT,
    ACTIONS(10141), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(10143), 1,
      anon_sym_u2987,
    ACTIONS(10145), 1,
      aux_sym_integer_token1,
    ACTIONS(10147), 1,
      aux_sym_string_token1,
    ACTIONS(10149), 1,
      anon_sym_Set,
    STATE(1955), 1,
      sym__ARROW,
    ACTIONS(10204), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(5496), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7812), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7815), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(10125), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [483490] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6647), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6645), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [483535] = 23,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6336), 1,
      anon_sym_SEMI,
    ACTIONS(6364), 1,
      sym__newline,
    ACTIONS(10206), 1,
      sym_id,
    ACTIONS(10208), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10212), 1,
      anon_sym_record,
    ACTIONS(10214), 1,
      anon_sym_LPAREN,
    ACTIONS(10216), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(10218), 1,
      anon_sym_u2983,
    ACTIONS(10220), 1,
      anon_sym_LBRACE,
    ACTIONS(10222), 1,
      aux_sym__qid_token1,
    ACTIONS(10224), 1,
      anon_sym_DOT,
    ACTIONS(10226), 1,
      anon_sym_PIPE,
    ACTIONS(10228), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(10230), 1,
      anon_sym_u2987,
    ACTIONS(10232), 1,
      aux_sym_integer_token1,
    ACTIONS(10234), 1,
      aux_sym_string_token1,
    ACTIONS(10236), 1,
      anon_sym_Set,
    STATE(4978), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7731), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7724), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(10210), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [483620] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6572), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6570), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [483665] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6484), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6482), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [483710] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6568), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6566), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [483755] = 4,
    ACTIONS(6326), 1,
      anon_sym_BSLASH,
    ACTIONS(10238), 1,
      anon_sym_AT,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6324), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [483802] = 22,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(10119), 1,
      sym_id,
    ACTIONS(10123), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10127), 1,
      anon_sym_record,
    ACTIONS(10129), 1,
      anon_sym_LPAREN,
    ACTIONS(10131), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(10133), 1,
      anon_sym_u2983,
    ACTIONS(10135), 1,
      anon_sym_LBRACE,
    ACTIONS(10137), 1,
      aux_sym__qid_token1,
    ACTIONS(10139), 1,
      anon_sym_DOT,
    ACTIONS(10141), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(10143), 1,
      anon_sym_u2987,
    ACTIONS(10145), 1,
      aux_sym_integer_token1,
    ACTIONS(10147), 1,
      aux_sym_string_token1,
    ACTIONS(10149), 1,
      anon_sym_Set,
    STATE(2154), 1,
      sym__ARROW,
    ACTIONS(5220), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(5496), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7812), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7815), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(10125), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [483885] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6500), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6498), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [483930] = 22,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6226), 1,
      anon_sym_RBRACE,
    ACTIONS(9758), 1,
      sym_id,
    ACTIONS(9760), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9764), 1,
      anon_sym_record,
    ACTIONS(9766), 1,
      anon_sym_LPAREN,
    ACTIONS(9768), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(9770), 1,
      anon_sym_u2983,
    ACTIONS(9772), 1,
      anon_sym_LBRACE,
    ACTIONS(9774), 1,
      aux_sym__qid_token1,
    ACTIONS(9776), 1,
      anon_sym_DOT,
    ACTIONS(9780), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(9782), 1,
      anon_sym_u2987,
    ACTIONS(9784), 1,
      aux_sym_integer_token1,
    ACTIONS(9786), 1,
      aux_sym_string_token1,
    ACTIONS(9788), 1,
      anon_sym_Set,
    STATE(7666), 1,
      sym_atom,
    STATE(7652), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    ACTIONS(6224), 3,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PIPE,
    STATE(7667), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(9762), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [484013] = 4,
    ACTIONS(6488), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6490), 3,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(6486), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [484060] = 3,
    ACTIONS(6750), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6748), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [484105] = 3,
    ACTIONS(6433), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6431), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [484150] = 22,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6226), 1,
      sym__newline,
    ACTIONS(9539), 1,
      sym_id,
    ACTIONS(9541), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9545), 1,
      anon_sym_record,
    ACTIONS(9547), 1,
      anon_sym_LPAREN,
    ACTIONS(9549), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(9551), 1,
      anon_sym_u2983,
    ACTIONS(9553), 1,
      anon_sym_LBRACE,
    ACTIONS(9555), 1,
      aux_sym__qid_token1,
    ACTIONS(9557), 1,
      anon_sym_DOT,
    ACTIONS(9561), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(9563), 1,
      anon_sym_u2987,
    ACTIONS(9565), 1,
      aux_sym_integer_token1,
    ACTIONS(9567), 1,
      aux_sym_string_token1,
    ACTIONS(9569), 1,
      anon_sym_Set,
    STATE(7620), 1,
      sym_atom,
    STATE(7603), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    ACTIONS(6224), 3,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_in,
    STATE(7600), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(9543), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [484233] = 3,
    ACTIONS(6714), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6712), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [484278] = 3,
    ACTIONS(6754), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6752), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [484323] = 22,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6241), 1,
      sym__newline,
    ACTIONS(10240), 1,
      sym_id,
    ACTIONS(10243), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10249), 1,
      anon_sym_record,
    ACTIONS(10252), 1,
      anon_sym_LPAREN,
    ACTIONS(10255), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(10258), 1,
      anon_sym_u2983,
    ACTIONS(10261), 1,
      anon_sym_LBRACE,
    ACTIONS(10264), 1,
      aux_sym__qid_token1,
    ACTIONS(10267), 1,
      anon_sym_DOT,
    ACTIONS(10270), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(10273), 1,
      anon_sym_u2987,
    ACTIONS(10276), 1,
      aux_sym_integer_token1,
    ACTIONS(10279), 1,
      aux_sym_string_token1,
    ACTIONS(10282), 1,
      anon_sym_Set,
    ACTIONS(6239), 2,
      anon_sym_SEMI,
      anon_sym_PIPE,
    STATE(4978), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7731), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7724), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(10246), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [484406] = 3,
    ACTIONS(6651), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6649), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [484451] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6484), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6482), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [484496] = 3,
    ACTIONS(6647), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6645), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [484541] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6655), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6653), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [484586] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6496), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6494), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [484631] = 3,
    ACTIONS(6572), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6570), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [484676] = 3,
    ACTIONS(6568), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6566), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [484721] = 4,
    ACTIONS(10285), 1,
      anon_sym_AT,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6326), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6324), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [484768] = 3,
    ACTIONS(6500), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6498), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [484813] = 22,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(10119), 1,
      sym_id,
    ACTIONS(10123), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10127), 1,
      anon_sym_record,
    ACTIONS(10129), 1,
      anon_sym_LPAREN,
    ACTIONS(10131), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(10133), 1,
      anon_sym_u2983,
    ACTIONS(10135), 1,
      anon_sym_LBRACE,
    ACTIONS(10137), 1,
      aux_sym__qid_token1,
    ACTIONS(10139), 1,
      anon_sym_DOT,
    ACTIONS(10141), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(10143), 1,
      anon_sym_u2987,
    ACTIONS(10145), 1,
      aux_sym_integer_token1,
    ACTIONS(10147), 1,
      aux_sym_string_token1,
    ACTIONS(10149), 1,
      anon_sym_Set,
    STATE(2630), 1,
      sym__ARROW,
    ACTIONS(10287), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(5496), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7812), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7815), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(10125), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [484896] = 4,
    ACTIONS(6488), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6490), 3,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_u2984,
    ACTIONS(6486), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [484943] = 3,
    ACTIONS(6750), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6748), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [484988] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6655), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6653), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [485033] = 23,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6336), 1,
      anon_sym_EQ,
    ACTIONS(6364), 1,
      anon_sym_RBRACE,
    ACTIONS(10289), 1,
      sym_id,
    ACTIONS(10291), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10295), 1,
      anon_sym_record,
    ACTIONS(10297), 1,
      anon_sym_LPAREN,
    ACTIONS(10299), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(10301), 1,
      anon_sym_u2983,
    ACTIONS(10303), 1,
      anon_sym_LBRACE,
    ACTIONS(10305), 1,
      aux_sym__qid_token1,
    ACTIONS(10307), 1,
      anon_sym_DOT,
    ACTIONS(10309), 1,
      anon_sym_PIPE,
    ACTIONS(10311), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(10313), 1,
      anon_sym_u2987,
    ACTIONS(10315), 1,
      aux_sym_integer_token1,
    ACTIONS(10317), 1,
      aux_sym_string_token1,
    ACTIONS(10319), 1,
      anon_sym_Set,
    STATE(5157), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7770), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7764), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(10293), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [485118] = 4,
    ACTIONS(6326), 1,
      anon_sym_BSLASH,
    ACTIONS(10321), 1,
      anon_sym_AT,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6324), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_PIPE_RPAREN,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [485165] = 22,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(10119), 1,
      sym_id,
    ACTIONS(10123), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10127), 1,
      anon_sym_record,
    ACTIONS(10129), 1,
      anon_sym_LPAREN,
    ACTIONS(10131), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(10133), 1,
      anon_sym_u2983,
    ACTIONS(10135), 1,
      anon_sym_LBRACE,
    ACTIONS(10137), 1,
      aux_sym__qid_token1,
    ACTIONS(10139), 1,
      anon_sym_DOT,
    ACTIONS(10141), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(10143), 1,
      anon_sym_u2987,
    ACTIONS(10145), 1,
      aux_sym_integer_token1,
    ACTIONS(10147), 1,
      aux_sym_string_token1,
    ACTIONS(10149), 1,
      anon_sym_Set,
    STATE(2357), 1,
      sym__ARROW,
    ACTIONS(10323), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(5496), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7812), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7815), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(10125), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [485248] = 22,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(10119), 1,
      sym_id,
    ACTIONS(10123), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10127), 1,
      anon_sym_record,
    ACTIONS(10129), 1,
      anon_sym_LPAREN,
    ACTIONS(10131), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(10133), 1,
      anon_sym_u2983,
    ACTIONS(10135), 1,
      anon_sym_LBRACE,
    ACTIONS(10137), 1,
      aux_sym__qid_token1,
    ACTIONS(10139), 1,
      anon_sym_DOT,
    ACTIONS(10141), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(10143), 1,
      anon_sym_u2987,
    ACTIONS(10145), 1,
      aux_sym_integer_token1,
    ACTIONS(10147), 1,
      aux_sym_string_token1,
    ACTIONS(10149), 1,
      anon_sym_Set,
    STATE(1588), 1,
      sym__ARROW,
    ACTIONS(10325), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(5496), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7812), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7815), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(10125), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [485331] = 21,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(9507), 1,
      sym_id,
    ACTIONS(9509), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9513), 1,
      anon_sym_record,
    ACTIONS(9515), 1,
      anon_sym_LPAREN,
    ACTIONS(9517), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(9519), 1,
      anon_sym_u2983,
    ACTIONS(9521), 1,
      anon_sym_LBRACE,
    ACTIONS(9523), 1,
      aux_sym__qid_token1,
    ACTIONS(9525), 1,
      anon_sym_DOT,
    ACTIONS(9529), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(9531), 1,
      anon_sym_u2987,
    ACTIONS(9533), 1,
      aux_sym_integer_token1,
    ACTIONS(9535), 1,
      aux_sym_string_token1,
    ACTIONS(9537), 1,
      anon_sym_Set,
    STATE(7579), 1,
      sym_atom,
    STATE(7575), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    ACTIONS(6224), 4,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_u2988,
    STATE(7573), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(9511), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [485412] = 4,
    ACTIONS(6488), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6490), 3,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_PIPE_RPAREN,
    ACTIONS(6486), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [485459] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6496), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6494), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [485504] = 22,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(10119), 1,
      sym_id,
    ACTIONS(10123), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10127), 1,
      anon_sym_record,
    ACTIONS(10129), 1,
      anon_sym_LPAREN,
    ACTIONS(10131), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(10133), 1,
      anon_sym_u2983,
    ACTIONS(10135), 1,
      anon_sym_LBRACE,
    ACTIONS(10137), 1,
      aux_sym__qid_token1,
    ACTIONS(10139), 1,
      anon_sym_DOT,
    ACTIONS(10141), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(10143), 1,
      anon_sym_u2987,
    ACTIONS(10145), 1,
      aux_sym_integer_token1,
    ACTIONS(10147), 1,
      aux_sym_string_token1,
    ACTIONS(10149), 1,
      anon_sym_Set,
    STATE(2438), 1,
      sym__ARROW,
    ACTIONS(10327), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(5496), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7812), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7815), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(10125), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [485587] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6484), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6482), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [485632] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6326), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6324), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [485677] = 4,
    ACTIONS(6326), 1,
      anon_sym_BSLASH,
    ACTIONS(10329), 1,
      anon_sym_AT,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6324), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_u2988,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [485724] = 22,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(10119), 1,
      sym_id,
    ACTIONS(10123), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10127), 1,
      anon_sym_record,
    ACTIONS(10129), 1,
      anon_sym_LPAREN,
    ACTIONS(10131), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(10133), 1,
      anon_sym_u2983,
    ACTIONS(10135), 1,
      anon_sym_LBRACE,
    ACTIONS(10137), 1,
      aux_sym__qid_token1,
    ACTIONS(10139), 1,
      anon_sym_DOT,
    ACTIONS(10141), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(10143), 1,
      anon_sym_u2987,
    ACTIONS(10145), 1,
      aux_sym_integer_token1,
    ACTIONS(10147), 1,
      aux_sym_string_token1,
    ACTIONS(10149), 1,
      anon_sym_Set,
    STATE(2052), 1,
      sym__ARROW,
    ACTIONS(10331), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(5496), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7812), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7815), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(10125), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [485807] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6326), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6324), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [485852] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6326), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6324), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [485897] = 4,
    ACTIONS(6326), 1,
      anon_sym_BSLASH,
    ACTIONS(10333), 1,
      anon_sym_AT,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6324), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [485944] = 4,
    ACTIONS(6488), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6490), 5,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(6486), 30,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [485991] = 5,
    ACTIONS(6488), 1,
      anon_sym_BSLASH,
    ACTIONS(6492), 1,
      sym__newline,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6490), 4,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
    ACTIONS(6486), 30,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [486040] = 22,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(10119), 1,
      sym_id,
    ACTIONS(10123), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10127), 1,
      anon_sym_record,
    ACTIONS(10129), 1,
      anon_sym_LPAREN,
    ACTIONS(10131), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(10133), 1,
      anon_sym_u2983,
    ACTIONS(10135), 1,
      anon_sym_LBRACE,
    ACTIONS(10137), 1,
      aux_sym__qid_token1,
    ACTIONS(10139), 1,
      anon_sym_DOT,
    ACTIONS(10141), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(10143), 1,
      anon_sym_u2987,
    ACTIONS(10145), 1,
      aux_sym_integer_token1,
    ACTIONS(10147), 1,
      aux_sym_string_token1,
    ACTIONS(10149), 1,
      anon_sym_Set,
    STATE(1473), 1,
      sym__ARROW,
    ACTIONS(10335), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(5496), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7812), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7815), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(10125), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [486123] = 3,
    ACTIONS(6496), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6494), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [486168] = 3,
    ACTIONS(6326), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6324), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_PIPE_RPAREN,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [486213] = 4,
    ACTIONS(6488), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6490), 3,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_u2988,
    ACTIONS(6486), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [486260] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6710), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6708), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [486305] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6750), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6748), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [486350] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6433), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6431), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [486395] = 23,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6336), 1,
      anon_sym_COLON,
    ACTIONS(6364), 1,
      anon_sym_RBRACE,
    ACTIONS(10337), 1,
      sym_id,
    ACTIONS(10339), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10343), 1,
      anon_sym_record,
    ACTIONS(10345), 1,
      anon_sym_LPAREN,
    ACTIONS(10347), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(10349), 1,
      anon_sym_u2983,
    ACTIONS(10351), 1,
      anon_sym_LBRACE,
    ACTIONS(10353), 1,
      aux_sym__qid_token1,
    ACTIONS(10355), 1,
      anon_sym_DOT,
    ACTIONS(10357), 1,
      anon_sym_PIPE,
    ACTIONS(10359), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(10361), 1,
      anon_sym_u2987,
    ACTIONS(10363), 1,
      aux_sym_integer_token1,
    ACTIONS(10365), 1,
      aux_sym_string_token1,
    ACTIONS(10367), 1,
      anon_sym_Set,
    STATE(5179), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7712), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7709), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(10341), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [486480] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6714), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6712), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [486525] = 5,
    ACTIONS(6488), 1,
      anon_sym_BSLASH,
    ACTIONS(6492), 1,
      sym__newline,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6490), 2,
      anon_sym_EQ,
      anon_sym_in,
    ACTIONS(6486), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [486574] = 22,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(10119), 1,
      sym_id,
    ACTIONS(10123), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10127), 1,
      anon_sym_record,
    ACTIONS(10129), 1,
      anon_sym_LPAREN,
    ACTIONS(10131), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(10133), 1,
      anon_sym_u2983,
    ACTIONS(10135), 1,
      anon_sym_LBRACE,
    ACTIONS(10137), 1,
      aux_sym__qid_token1,
    ACTIONS(10139), 1,
      anon_sym_DOT,
    ACTIONS(10141), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(10143), 1,
      anon_sym_u2987,
    ACTIONS(10145), 1,
      aux_sym_integer_token1,
    ACTIONS(10147), 1,
      aux_sym_string_token1,
    ACTIONS(10149), 1,
      anon_sym_Set,
    STATE(1506), 1,
      sym__ARROW,
    ACTIONS(10369), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(5496), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7812), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7815), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(10125), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [486657] = 3,
    ACTIONS(6655), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6653), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [486702] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6500), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6498), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [486747] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6754), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6752), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [486792] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6651), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6649), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [486837] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6647), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6645), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [486882] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6572), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6570), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [486927] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6568), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6566), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [486972] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6500), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6498), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [487017] = 4,
    ACTIONS(6326), 1,
      anon_sym_BSLASH,
    ACTIONS(10371), 1,
      anon_sym_AT,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6324), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [487064] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6568), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6566), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [487109] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6572), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6570), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [487154] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6647), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6645), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [487199] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6754), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6752), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [487244] = 22,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(10119), 1,
      sym_id,
    ACTIONS(10123), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10127), 1,
      anon_sym_record,
    ACTIONS(10129), 1,
      anon_sym_LPAREN,
    ACTIONS(10131), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(10133), 1,
      anon_sym_u2983,
    ACTIONS(10135), 1,
      anon_sym_LBRACE,
    ACTIONS(10137), 1,
      aux_sym__qid_token1,
    ACTIONS(10139), 1,
      anon_sym_DOT,
    ACTIONS(10141), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(10143), 1,
      anon_sym_u2987,
    ACTIONS(10145), 1,
      aux_sym_integer_token1,
    ACTIONS(10147), 1,
      aux_sym_string_token1,
    ACTIONS(10149), 1,
      anon_sym_Set,
    STATE(2278), 1,
      sym__ARROW,
    ACTIONS(10373), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(5496), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7812), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7815), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(10125), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [487327] = 22,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(10119), 1,
      sym_id,
    ACTIONS(10123), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10127), 1,
      anon_sym_record,
    ACTIONS(10129), 1,
      anon_sym_LPAREN,
    ACTIONS(10131), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(10133), 1,
      anon_sym_u2983,
    ACTIONS(10135), 1,
      anon_sym_LBRACE,
    ACTIONS(10137), 1,
      aux_sym__qid_token1,
    ACTIONS(10139), 1,
      anon_sym_DOT,
    ACTIONS(10141), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(10143), 1,
      anon_sym_u2987,
    ACTIONS(10145), 1,
      aux_sym_integer_token1,
    ACTIONS(10147), 1,
      aux_sym_string_token1,
    ACTIONS(10149), 1,
      anon_sym_Set,
    STATE(2447), 1,
      sym__ARROW,
    ACTIONS(10375), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(5496), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7812), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7815), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(10125), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [487410] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6714), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6712), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [487455] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6433), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6431), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [487500] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6750), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6748), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [487545] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6710), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6708), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [487590] = 4,
    ACTIONS(6488), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6490), 3,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_SEMI,
    ACTIONS(6486), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [487637] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6500), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6498), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [487682] = 3,
    ACTIONS(6500), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6498), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [487727] = 3,
    ACTIONS(6568), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6566), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [487772] = 3,
    ACTIONS(6572), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6570), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [487817] = 22,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6226), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(9475), 1,
      sym_id,
    ACTIONS(9477), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9481), 1,
      anon_sym_record,
    ACTIONS(9483), 1,
      anon_sym_LPAREN,
    ACTIONS(9485), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(9487), 1,
      anon_sym_u2983,
    ACTIONS(9489), 1,
      anon_sym_LBRACE,
    ACTIONS(9491), 1,
      aux_sym__qid_token1,
    ACTIONS(9493), 1,
      anon_sym_DOT,
    ACTIONS(9497), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(9499), 1,
      anon_sym_u2987,
    ACTIONS(9501), 1,
      aux_sym_integer_token1,
    ACTIONS(9503), 1,
      aux_sym_string_token1,
    ACTIONS(9505), 1,
      anon_sym_Set,
    STATE(7560), 1,
      sym_atom,
    STATE(7555), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    ACTIONS(6224), 3,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_PIPE,
    STATE(7552), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(9479), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [487900] = 3,
    ACTIONS(6651), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6649), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [487945] = 3,
    ACTIONS(6754), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6752), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [487990] = 3,
    ACTIONS(6326), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6324), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [488035] = 22,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(10119), 1,
      sym_id,
    ACTIONS(10123), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10127), 1,
      anon_sym_record,
    ACTIONS(10129), 1,
      anon_sym_LPAREN,
    ACTIONS(10131), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(10133), 1,
      anon_sym_u2983,
    ACTIONS(10135), 1,
      anon_sym_LBRACE,
    ACTIONS(10137), 1,
      aux_sym__qid_token1,
    ACTIONS(10139), 1,
      anon_sym_DOT,
    ACTIONS(10141), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(10143), 1,
      anon_sym_u2987,
    ACTIONS(10145), 1,
      aux_sym_integer_token1,
    ACTIONS(10147), 1,
      aux_sym_string_token1,
    ACTIONS(10149), 1,
      anon_sym_Set,
    STATE(1957), 1,
      sym__ARROW,
    ACTIONS(10377), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(5496), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7812), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7815), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(10125), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [488118] = 3,
    ACTIONS(6714), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6712), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [488163] = 23,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6336), 1,
      anon_sym_SEMI,
    ACTIONS(6364), 1,
      anon_sym_RBRACE,
    ACTIONS(10379), 1,
      sym_id,
    ACTIONS(10381), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10385), 1,
      anon_sym_record,
    ACTIONS(10387), 1,
      anon_sym_LPAREN,
    ACTIONS(10389), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(10391), 1,
      anon_sym_u2983,
    ACTIONS(10393), 1,
      anon_sym_LBRACE,
    ACTIONS(10395), 1,
      aux_sym__qid_token1,
    ACTIONS(10397), 1,
      anon_sym_DOT,
    ACTIONS(10399), 1,
      anon_sym_PIPE,
    ACTIONS(10401), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(10403), 1,
      anon_sym_u2987,
    ACTIONS(10405), 1,
      aux_sym_integer_token1,
    ACTIONS(10407), 1,
      aux_sym_string_token1,
    ACTIONS(10409), 1,
      anon_sym_Set,
    STATE(4943), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7690), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7735), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(10383), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [488248] = 3,
    ACTIONS(6655), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6653), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [488293] = 3,
    ACTIONS(6750), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6748), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [488338] = 3,
    ACTIONS(6484), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6482), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_u2988,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [488383] = 3,
    ACTIONS(6496), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6494), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [488428] = 4,
    ACTIONS(6326), 1,
      anon_sym_BSLASH,
    ACTIONS(10411), 1,
      anon_sym_AT,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6324), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [488475] = 3,
    ACTIONS(6484), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6482), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [488520] = 22,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6226), 1,
      anon_sym_RBRACE,
    ACTIONS(9636), 1,
      sym_id,
    ACTIONS(9638), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9642), 1,
      anon_sym_record,
    ACTIONS(9644), 1,
      anon_sym_LPAREN,
    ACTIONS(9646), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(9648), 1,
      anon_sym_u2983,
    ACTIONS(9650), 1,
      anon_sym_LBRACE,
    ACTIONS(9652), 1,
      aux_sym__qid_token1,
    ACTIONS(9654), 1,
      anon_sym_DOT,
    ACTIONS(9658), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(9660), 1,
      anon_sym_u2987,
    ACTIONS(9662), 1,
      aux_sym_integer_token1,
    ACTIONS(9664), 1,
      aux_sym_string_token1,
    ACTIONS(9666), 1,
      anon_sym_Set,
    STATE(7550), 1,
      sym_atom,
    STATE(7594), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    ACTIONS(6224), 3,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_PIPE,
    STATE(7606), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(9640), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [488603] = 3,
    ACTIONS(6326), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6324), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [488648] = 22,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(10119), 1,
      sym_id,
    ACTIONS(10123), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10127), 1,
      anon_sym_record,
    ACTIONS(10129), 1,
      anon_sym_LPAREN,
    ACTIONS(10131), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(10133), 1,
      anon_sym_u2983,
    ACTIONS(10135), 1,
      anon_sym_LBRACE,
    ACTIONS(10137), 1,
      aux_sym__qid_token1,
    ACTIONS(10139), 1,
      anon_sym_DOT,
    ACTIONS(10141), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(10143), 1,
      anon_sym_u2987,
    ACTIONS(10145), 1,
      aux_sym_integer_token1,
    ACTIONS(10147), 1,
      aux_sym_string_token1,
    ACTIONS(10149), 1,
      anon_sym_Set,
    STATE(1680), 1,
      sym__ARROW,
    ACTIONS(10413), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(5496), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7812), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7815), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(10125), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [488731] = 3,
    ACTIONS(6647), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6645), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [488776] = 3,
    ACTIONS(6496), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6494), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_u2988,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [488821] = 21,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(9398), 1,
      sym_id,
    ACTIONS(9400), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9404), 1,
      anon_sym_record,
    ACTIONS(9406), 1,
      anon_sym_LPAREN,
    ACTIONS(9408), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(9410), 1,
      anon_sym_u2983,
    ACTIONS(9412), 1,
      anon_sym_LBRACE,
    ACTIONS(9414), 1,
      aux_sym__qid_token1,
    ACTIONS(9416), 1,
      anon_sym_DOT,
    ACTIONS(9420), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(9422), 1,
      anon_sym_u2987,
    ACTIONS(9424), 1,
      aux_sym_integer_token1,
    ACTIONS(9426), 1,
      aux_sym_string_token1,
    ACTIONS(9428), 1,
      anon_sym_Set,
    STATE(7511), 1,
      sym_atom,
    STATE(7502), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    ACTIONS(6224), 4,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_u2984,
      anon_sym_PIPE,
    STATE(7501), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(9402), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [488902] = 3,
    ACTIONS(6655), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6653), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_u2988,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [488947] = 21,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(10415), 1,
      sym_id,
    ACTIONS(10418), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10424), 1,
      anon_sym_record,
    ACTIONS(10427), 1,
      anon_sym_LPAREN,
    ACTIONS(10430), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(10433), 1,
      anon_sym_u2983,
    ACTIONS(10436), 1,
      anon_sym_LBRACE,
    ACTIONS(10439), 1,
      aux_sym__qid_token1,
    ACTIONS(10442), 1,
      anon_sym_DOT,
    ACTIONS(10445), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(10448), 1,
      anon_sym_u2987,
    ACTIONS(10451), 1,
      aux_sym_integer_token1,
    ACTIONS(10454), 1,
      aux_sym_string_token1,
    ACTIONS(10457), 1,
      anon_sym_Set,
    STATE(5064), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7698), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    ACTIONS(6239), 3,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_PIPE,
    STATE(7681), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(10421), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [489028] = 3,
    ACTIONS(6326), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6324), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [489073] = 22,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(10119), 1,
      sym_id,
    ACTIONS(10123), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10127), 1,
      anon_sym_record,
    ACTIONS(10129), 1,
      anon_sym_LPAREN,
    ACTIONS(10131), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(10133), 1,
      anon_sym_u2983,
    ACTIONS(10135), 1,
      anon_sym_LBRACE,
    ACTIONS(10137), 1,
      aux_sym__qid_token1,
    ACTIONS(10139), 1,
      anon_sym_DOT,
    ACTIONS(10141), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(10143), 1,
      anon_sym_u2987,
    ACTIONS(10145), 1,
      aux_sym_integer_token1,
    ACTIONS(10147), 1,
      aux_sym_string_token1,
    ACTIONS(10149), 1,
      anon_sym_Set,
    STATE(1457), 1,
      sym__ARROW,
    ACTIONS(10460), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(5496), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7812), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7815), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(10125), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [489156] = 3,
    ACTIONS(6433), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6431), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [489201] = 3,
    ACTIONS(6496), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6494), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_PIPE_RPAREN,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [489246] = 3,
    ACTIONS(6710), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6708), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [489291] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6326), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6324), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [489336] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6496), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6494), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [489381] = 22,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(10119), 1,
      sym_id,
    ACTIONS(10123), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10127), 1,
      anon_sym_record,
    ACTIONS(10129), 1,
      anon_sym_LPAREN,
    ACTIONS(10131), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(10133), 1,
      anon_sym_u2983,
    ACTIONS(10135), 1,
      anon_sym_LBRACE,
    ACTIONS(10137), 1,
      aux_sym__qid_token1,
    ACTIONS(10139), 1,
      anon_sym_DOT,
    ACTIONS(10141), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(10143), 1,
      anon_sym_u2987,
    ACTIONS(10145), 1,
      aux_sym_integer_token1,
    ACTIONS(10147), 1,
      aux_sym_string_token1,
    ACTIONS(10149), 1,
      anon_sym_Set,
    STATE(2526), 1,
      sym__ARROW,
    ACTIONS(10462), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(5496), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7812), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7815), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(10125), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [489464] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6655), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6653), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [489509] = 4,
    ACTIONS(6326), 1,
      anon_sym_BSLASH,
    ACTIONS(10464), 1,
      anon_sym_AT,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6324), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [489556] = 4,
    ACTIONS(10466), 1,
      anon_sym_AT,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6326), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6324), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [489603] = 3,
    ACTIONS(6655), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6653), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_PIPE_RPAREN,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [489648] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6496), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6494), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [489693] = 3,
    ACTIONS(6326), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6324), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [489738] = 3,
    ACTIONS(6484), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6482), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [489783] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6655), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6653), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [489828] = 3,
    ACTIONS(6710), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6708), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [489873] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6651), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6649), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [489918] = 3,
    ACTIONS(6433), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6431), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [489963] = 3,
    ACTIONS(6714), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6712), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [490008] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6655), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6653), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [490053] = 3,
    ACTIONS(6754), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6752), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [490098] = 3,
    ACTIONS(6326), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6324), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [490143] = 3,
    ACTIONS(6651), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6649), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [490188] = 22,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(10119), 1,
      sym_id,
    ACTIONS(10123), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10127), 1,
      anon_sym_record,
    ACTIONS(10129), 1,
      anon_sym_LPAREN,
    ACTIONS(10131), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(10133), 1,
      anon_sym_u2983,
    ACTIONS(10135), 1,
      anon_sym_LBRACE,
    ACTIONS(10137), 1,
      aux_sym__qid_token1,
    ACTIONS(10139), 1,
      anon_sym_DOT,
    ACTIONS(10141), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(10143), 1,
      anon_sym_u2987,
    ACTIONS(10145), 1,
      aux_sym_integer_token1,
    ACTIONS(10147), 1,
      aux_sym_string_token1,
    ACTIONS(10149), 1,
      anon_sym_Set,
    STATE(2406), 1,
      sym__ARROW,
    ACTIONS(6004), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(5496), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7812), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7815), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(10125), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [490271] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6496), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6494), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [490316] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6568), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6566), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [490361] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6572), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6570), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [490406] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6651), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6649), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [490451] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6754), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6752), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [490496] = 3,
    ACTIONS(6647), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6645), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [490541] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6714), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6712), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [490586] = 3,
    ACTIONS(6572), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6570), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [490631] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6750), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6748), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [490676] = 4,
    ACTIONS(6488), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6490), 4,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(6486), 31,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [490723] = 3,
    ACTIONS(6568), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6566), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [490768] = 3,
    ACTIONS(6500), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6498), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [490813] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6484), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6482), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [490858] = 4,
    ACTIONS(10468), 1,
      anon_sym_AT,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6326), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6324), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [490905] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6647), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6645), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [490950] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6500), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6498), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [490995] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6326), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6324), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [491040] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6433), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6431), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [491085] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6710), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6708), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [491130] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6568), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6566), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [491175] = 22,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(10119), 1,
      sym_id,
    ACTIONS(10123), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10127), 1,
      anon_sym_record,
    ACTIONS(10129), 1,
      anon_sym_LPAREN,
    ACTIONS(10131), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(10133), 1,
      anon_sym_u2983,
    ACTIONS(10135), 1,
      anon_sym_LBRACE,
    ACTIONS(10137), 1,
      aux_sym__qid_token1,
    ACTIONS(10139), 1,
      anon_sym_DOT,
    ACTIONS(10141), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(10143), 1,
      anon_sym_u2987,
    ACTIONS(10145), 1,
      aux_sym_integer_token1,
    ACTIONS(10147), 1,
      aux_sym_string_token1,
    ACTIONS(10149), 1,
      anon_sym_Set,
    STATE(1876), 1,
      sym__ARROW,
    ACTIONS(10470), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(5496), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7812), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7815), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(10125), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [491258] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6572), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6570), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [491303] = 21,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(10472), 1,
      sym_id,
    ACTIONS(10475), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10481), 1,
      anon_sym_record,
    ACTIONS(10484), 1,
      anon_sym_LPAREN,
    ACTIONS(10487), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(10490), 1,
      anon_sym_u2983,
    ACTIONS(10493), 1,
      anon_sym_LBRACE,
    ACTIONS(10496), 1,
      aux_sym__qid_token1,
    ACTIONS(10499), 1,
      anon_sym_DOT,
    ACTIONS(10502), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(10505), 1,
      anon_sym_u2987,
    ACTIONS(10508), 1,
      aux_sym_integer_token1,
    ACTIONS(10511), 1,
      aux_sym_string_token1,
    ACTIONS(10514), 1,
      anon_sym_Set,
    STATE(5112), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7700), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    ACTIONS(6239), 3,
      anon_sym_COLON,
      anon_sym_u2984,
      anon_sym_PIPE,
    STATE(7701), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(10478), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [491384] = 3,
    ACTIONS(6500), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6498), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_u2988,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [491429] = 3,
    ACTIONS(6568), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6566), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_u2988,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [491474] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6647), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6645), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [491519] = 3,
    ACTIONS(6326), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6324), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [491564] = 5,
    ACTIONS(6488), 1,
      anon_sym_BSLASH,
    ACTIONS(6492), 1,
      sym__newline,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6490), 4,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_in,
    ACTIONS(6486), 30,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [491613] = 3,
    ACTIONS(6572), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6570), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_u2988,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [491658] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6651), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6649), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [491703] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6754), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6752), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [491748] = 22,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(10119), 1,
      sym_id,
    ACTIONS(10123), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10127), 1,
      anon_sym_record,
    ACTIONS(10129), 1,
      anon_sym_LPAREN,
    ACTIONS(10131), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(10133), 1,
      anon_sym_u2983,
    ACTIONS(10135), 1,
      anon_sym_LBRACE,
    ACTIONS(10137), 1,
      aux_sym__qid_token1,
    ACTIONS(10139), 1,
      anon_sym_DOT,
    ACTIONS(10141), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(10143), 1,
      anon_sym_u2987,
    ACTIONS(10145), 1,
      aux_sym_integer_token1,
    ACTIONS(10147), 1,
      aux_sym_string_token1,
    ACTIONS(10149), 1,
      anon_sym_Set,
    STATE(2597), 1,
      sym__ARROW,
    ACTIONS(10517), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(5496), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7812), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7815), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(10125), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [491831] = 3,
    ACTIONS(6647), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6645), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_u2988,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [491876] = 3,
    ACTIONS(6651), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6649), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_u2988,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [491921] = 3,
    ACTIONS(6754), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6752), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_u2988,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [491966] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6714), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6712), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [492011] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6433), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6431), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [492056] = 22,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(10519), 1,
      sym_id,
    ACTIONS(10521), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10525), 1,
      anon_sym_record,
    ACTIONS(10527), 1,
      anon_sym_LPAREN,
    ACTIONS(10529), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(10531), 1,
      anon_sym_u2983,
    ACTIONS(10533), 1,
      anon_sym_LBRACE,
    ACTIONS(10535), 1,
      aux_sym__qid_token1,
    ACTIONS(10537), 1,
      anon_sym_DOT,
    ACTIONS(10539), 1,
      anon_sym_PIPE,
    ACTIONS(10541), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(10543), 1,
      anon_sym_u2987,
    ACTIONS(10545), 1,
      aux_sym_integer_token1,
    ACTIONS(10547), 1,
      aux_sym_string_token1,
    ACTIONS(10549), 1,
      anon_sym_Set,
    ACTIONS(6336), 2,
      anon_sym_EQ,
      anon_sym_where,
    STATE(5064), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7698), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7681), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(10523), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [492139] = 4,
    ACTIONS(6488), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6490), 4,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(6486), 31,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [492186] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6750), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6748), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [492231] = 4,
    ACTIONS(10551), 1,
      anon_sym_AT,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6326), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6324), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [492278] = 22,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6241), 1,
      sym__newline,
    ACTIONS(10553), 1,
      sym_id,
    ACTIONS(10556), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10562), 1,
      anon_sym_record,
    ACTIONS(10565), 1,
      anon_sym_LPAREN,
    ACTIONS(10568), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(10571), 1,
      anon_sym_u2983,
    ACTIONS(10574), 1,
      anon_sym_LBRACE,
    ACTIONS(10577), 1,
      aux_sym__qid_token1,
    ACTIONS(10580), 1,
      anon_sym_DOT,
    ACTIONS(10583), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(10586), 1,
      anon_sym_u2987,
    ACTIONS(10589), 1,
      aux_sym_integer_token1,
    ACTIONS(10592), 1,
      aux_sym_string_token1,
    ACTIONS(10595), 1,
      anon_sym_Set,
    ACTIONS(6239), 2,
      anon_sym_EQ,
      anon_sym_PIPE,
    STATE(5131), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7705), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7719), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(10559), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [492361] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6710), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6708), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [492406] = 3,
    ACTIONS(6714), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6712), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_u2988,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [492451] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6484), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6482), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [492496] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6500), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6498), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [492541] = 3,
    ACTIONS(6433), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6431), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_u2988,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [492586] = 22,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(10119), 1,
      sym_id,
    ACTIONS(10123), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10127), 1,
      anon_sym_record,
    ACTIONS(10129), 1,
      anon_sym_LPAREN,
    ACTIONS(10131), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(10133), 1,
      anon_sym_u2983,
    ACTIONS(10135), 1,
      anon_sym_LBRACE,
    ACTIONS(10137), 1,
      aux_sym__qid_token1,
    ACTIONS(10139), 1,
      anon_sym_DOT,
    ACTIONS(10141), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(10143), 1,
      anon_sym_u2987,
    ACTIONS(10145), 1,
      aux_sym_integer_token1,
    ACTIONS(10147), 1,
      aux_sym_string_token1,
    ACTIONS(10149), 1,
      anon_sym_Set,
    STATE(1405), 1,
      sym__ARROW,
    ACTIONS(10598), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(5496), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7812), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7815), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(10125), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [492669] = 3,
    ACTIONS(6750), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6748), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_u2988,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [492714] = 3,
    ACTIONS(6710), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6708), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_u2988,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [492759] = 21,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(10038), 1,
      sym_id,
    ACTIONS(10040), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10044), 1,
      anon_sym_record,
    ACTIONS(10046), 1,
      anon_sym_LPAREN,
    ACTIONS(10048), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(10050), 1,
      anon_sym_u2983,
    ACTIONS(10052), 1,
      anon_sym_LBRACE,
    ACTIONS(10054), 1,
      aux_sym__qid_token1,
    ACTIONS(10056), 1,
      anon_sym_DOT,
    ACTIONS(10060), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(10062), 1,
      anon_sym_u2987,
    ACTIONS(10064), 1,
      aux_sym_integer_token1,
    ACTIONS(10066), 1,
      aux_sym_string_token1,
    ACTIONS(10068), 1,
      anon_sym_Set,
    STATE(7538), 1,
      sym_atom,
    STATE(7504), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    ACTIONS(6224), 4,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_PIPE,
    STATE(7499), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(10042), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [492840] = 3,
    ACTIONS(6655), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6653), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [492885] = 5,
    ACTIONS(6488), 1,
      anon_sym_BSLASH,
    ACTIONS(6492), 1,
      sym__newline,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6490), 3,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_SEMI,
    ACTIONS(6486), 31,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [492934] = 22,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(10600), 1,
      sym_id,
    ACTIONS(10602), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10606), 1,
      anon_sym_record,
    ACTIONS(10608), 1,
      anon_sym_LPAREN,
    ACTIONS(10610), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(10612), 1,
      anon_sym_u2983,
    ACTIONS(10614), 1,
      anon_sym_LBRACE,
    ACTIONS(10616), 1,
      aux_sym__qid_token1,
    ACTIONS(10618), 1,
      anon_sym_DOT,
    ACTIONS(10620), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(10622), 1,
      anon_sym_u2987,
    ACTIONS(10624), 1,
      aux_sym_integer_token1,
    ACTIONS(10626), 1,
      aux_sym_string_token1,
    ACTIONS(10628), 1,
      anon_sym_Set,
    STATE(7602), 1,
      sym_atom,
    ACTIONS(6224), 2,
      anon_sym_EQ,
      anon_sym_PIPE,
    ACTIONS(6226), 2,
      anon_sym_RPAREN,
      anon_sym_RBRACE_RBRACE,
    STATE(7582), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7590), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(10604), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [493017] = 4,
    ACTIONS(6326), 1,
      anon_sym_BSLASH,
    ACTIONS(10630), 1,
      anon_sym_AT,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6324), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [493064] = 22,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(10119), 1,
      sym_id,
    ACTIONS(10123), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10127), 1,
      anon_sym_record,
    ACTIONS(10129), 1,
      anon_sym_LPAREN,
    ACTIONS(10131), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(10133), 1,
      anon_sym_u2983,
    ACTIONS(10135), 1,
      anon_sym_LBRACE,
    ACTIONS(10137), 1,
      aux_sym__qid_token1,
    ACTIONS(10139), 1,
      anon_sym_DOT,
    ACTIONS(10141), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(10143), 1,
      anon_sym_u2987,
    ACTIONS(10145), 1,
      aux_sym_integer_token1,
    ACTIONS(10147), 1,
      aux_sym_string_token1,
    ACTIONS(10149), 1,
      anon_sym_Set,
    STATE(1689), 1,
      sym__ARROW,
    ACTIONS(10632), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(5496), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7812), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7815), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(10125), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [493147] = 3,
    ACTIONS(6496), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6494), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [493192] = 5,
    ACTIONS(6488), 1,
      anon_sym_BSLASH,
    ACTIONS(6492), 1,
      sym__newline,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6490), 2,
      anon_sym_EQ,
      anon_sym_where,
    ACTIONS(6486), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [493241] = 3,
    ACTIONS(6655), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6653), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [493286] = 3,
    ACTIONS(6496), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6494), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [493331] = 3,
    ACTIONS(6500), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6498), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_PIPE_RPAREN,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [493376] = 3,
    ACTIONS(6568), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6566), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_PIPE_RPAREN,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [493421] = 3,
    ACTIONS(6655), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6653), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [493466] = 3,
    ACTIONS(6500), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6498), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [493511] = 3,
    ACTIONS(6568), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6566), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [493556] = 3,
    ACTIONS(6572), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6570), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [493601] = 3,
    ACTIONS(6651), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6649), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [493646] = 22,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6241), 1,
      anon_sym_RBRACE,
    ACTIONS(10634), 1,
      sym_id,
    ACTIONS(10637), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10643), 1,
      anon_sym_record,
    ACTIONS(10646), 1,
      anon_sym_LPAREN,
    ACTIONS(10649), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(10652), 1,
      anon_sym_u2983,
    ACTIONS(10655), 1,
      anon_sym_LBRACE,
    ACTIONS(10658), 1,
      aux_sym__qid_token1,
    ACTIONS(10661), 1,
      anon_sym_DOT,
    ACTIONS(10664), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(10667), 1,
      anon_sym_u2987,
    ACTIONS(10670), 1,
      aux_sym_integer_token1,
    ACTIONS(10673), 1,
      aux_sym_string_token1,
    ACTIONS(10676), 1,
      anon_sym_Set,
    ACTIONS(6239), 2,
      anon_sym_EQ,
      anon_sym_PIPE,
    STATE(5157), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7770), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7764), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(10640), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [493729] = 3,
    ACTIONS(6754), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6752), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [493774] = 3,
    ACTIONS(6572), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6570), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_PIPE_RPAREN,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [493819] = 3,
    ACTIONS(6714), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6712), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [493864] = 22,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(10679), 1,
      sym_id,
    ACTIONS(10681), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10685), 1,
      anon_sym_record,
    ACTIONS(10687), 1,
      anon_sym_LPAREN,
    ACTIONS(10689), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(10691), 1,
      anon_sym_u2983,
    ACTIONS(10693), 1,
      anon_sym_LBRACE,
    ACTIONS(10695), 1,
      aux_sym__qid_token1,
    ACTIONS(10697), 1,
      anon_sym_DOT,
    ACTIONS(10699), 1,
      anon_sym_PIPE,
    ACTIONS(10701), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(10703), 1,
      anon_sym_u2987,
    ACTIONS(10705), 1,
      aux_sym_integer_token1,
    ACTIONS(10707), 1,
      aux_sym_string_token1,
    ACTIONS(10709), 1,
      anon_sym_Set,
    ACTIONS(6336), 2,
      anon_sym_COLON,
      anon_sym_u2984,
    STATE(5112), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7700), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7701), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(10683), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [493947] = 22,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(10119), 1,
      sym_id,
    ACTIONS(10123), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10127), 1,
      anon_sym_record,
    ACTIONS(10129), 1,
      anon_sym_LPAREN,
    ACTIONS(10131), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(10133), 1,
      anon_sym_u2983,
    ACTIONS(10135), 1,
      anon_sym_LBRACE,
    ACTIONS(10137), 1,
      aux_sym__qid_token1,
    ACTIONS(10139), 1,
      anon_sym_DOT,
    ACTIONS(10141), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(10143), 1,
      anon_sym_u2987,
    ACTIONS(10145), 1,
      aux_sym_integer_token1,
    ACTIONS(10147), 1,
      aux_sym_string_token1,
    ACTIONS(10149), 1,
      anon_sym_Set,
    STATE(2618), 1,
      sym__ARROW,
    ACTIONS(10711), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(5496), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7812), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7815), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(10125), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [494030] = 3,
    ACTIONS(6750), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6748), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [494075] = 22,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(10119), 1,
      sym_id,
    ACTIONS(10123), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10127), 1,
      anon_sym_record,
    ACTIONS(10129), 1,
      anon_sym_LPAREN,
    ACTIONS(10131), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(10133), 1,
      anon_sym_u2983,
    ACTIONS(10135), 1,
      anon_sym_LBRACE,
    ACTIONS(10137), 1,
      aux_sym__qid_token1,
    ACTIONS(10139), 1,
      anon_sym_DOT,
    ACTIONS(10141), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(10143), 1,
      anon_sym_u2987,
    ACTIONS(10145), 1,
      aux_sym_integer_token1,
    ACTIONS(10147), 1,
      aux_sym_string_token1,
    ACTIONS(10149), 1,
      anon_sym_Set,
    STATE(1654), 1,
      sym__ARROW,
    ACTIONS(10713), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(5496), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7812), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7815), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(10125), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [494158] = 3,
    ACTIONS(6647), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6645), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_PIPE_RPAREN,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [494203] = 22,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(10119), 1,
      sym_id,
    ACTIONS(10123), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10127), 1,
      anon_sym_record,
    ACTIONS(10129), 1,
      anon_sym_LPAREN,
    ACTIONS(10131), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(10133), 1,
      anon_sym_u2983,
    ACTIONS(10135), 1,
      anon_sym_LBRACE,
    ACTIONS(10137), 1,
      aux_sym__qid_token1,
    ACTIONS(10139), 1,
      anon_sym_DOT,
    ACTIONS(10141), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(10143), 1,
      anon_sym_u2987,
    ACTIONS(10145), 1,
      aux_sym_integer_token1,
    ACTIONS(10147), 1,
      aux_sym_string_token1,
    ACTIONS(10149), 1,
      anon_sym_Set,
    STATE(1748), 1,
      sym__ARROW,
    ACTIONS(10715), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(5496), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7812), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7815), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(10125), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [494286] = 22,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(10119), 1,
      sym_id,
    ACTIONS(10123), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10127), 1,
      anon_sym_record,
    ACTIONS(10129), 1,
      anon_sym_LPAREN,
    ACTIONS(10131), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(10133), 1,
      anon_sym_u2983,
    ACTIONS(10135), 1,
      anon_sym_LBRACE,
    ACTIONS(10137), 1,
      aux_sym__qid_token1,
    ACTIONS(10139), 1,
      anon_sym_DOT,
    ACTIONS(10141), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(10143), 1,
      anon_sym_u2987,
    ACTIONS(10145), 1,
      aux_sym_integer_token1,
    ACTIONS(10147), 1,
      aux_sym_string_token1,
    ACTIONS(10149), 1,
      anon_sym_Set,
    STATE(1793), 1,
      sym__ARROW,
    ACTIONS(10717), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(5496), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7812), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7815), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(10125), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [494369] = 3,
    ACTIONS(6484), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6482), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [494414] = 3,
    ACTIONS(6651), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6649), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_PIPE_RPAREN,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [494459] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6326), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6324), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [494504] = 3,
    ACTIONS(6754), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6752), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_PIPE_RPAREN,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [494549] = 3,
    ACTIONS(6647), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6645), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [494594] = 3,
    ACTIONS(6714), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6712), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_PIPE_RPAREN,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [494639] = 3,
    ACTIONS(6433), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6431), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_PIPE_RPAREN,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [494684] = 3,
    ACTIONS(6750), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6748), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_PIPE_RPAREN,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [494729] = 3,
    ACTIONS(6710), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6708), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_PIPE_RPAREN,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [494774] = 23,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6336), 1,
      anon_sym_COLON,
    ACTIONS(6364), 1,
      anon_sym_RPAREN,
    ACTIONS(10719), 1,
      sym_id,
    ACTIONS(10721), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10725), 1,
      anon_sym_record,
    ACTIONS(10727), 1,
      anon_sym_LPAREN,
    ACTIONS(10729), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(10731), 1,
      anon_sym_u2983,
    ACTIONS(10733), 1,
      anon_sym_LBRACE,
    ACTIONS(10735), 1,
      aux_sym__qid_token1,
    ACTIONS(10737), 1,
      anon_sym_DOT,
    ACTIONS(10739), 1,
      anon_sym_PIPE,
    ACTIONS(10741), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(10743), 1,
      anon_sym_u2987,
    ACTIONS(10745), 1,
      aux_sym_integer_token1,
    ACTIONS(10747), 1,
      aux_sym_string_token1,
    ACTIONS(10749), 1,
      anon_sym_Set,
    STATE(4779), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7641), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7631), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(10723), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [494859] = 3,
    ACTIONS(6433), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6431), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [494904] = 22,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6241), 1,
      anon_sym_RBRACE,
    ACTIONS(10751), 1,
      sym_id,
    ACTIONS(10754), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10760), 1,
      anon_sym_record,
    ACTIONS(10763), 1,
      anon_sym_LPAREN,
    ACTIONS(10766), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(10769), 1,
      anon_sym_u2983,
    ACTIONS(10772), 1,
      anon_sym_LBRACE,
    ACTIONS(10775), 1,
      aux_sym__qid_token1,
    ACTIONS(10778), 1,
      anon_sym_DOT,
    ACTIONS(10781), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(10784), 1,
      anon_sym_u2987,
    ACTIONS(10787), 1,
      aux_sym_integer_token1,
    ACTIONS(10790), 1,
      aux_sym_string_token1,
    ACTIONS(10793), 1,
      anon_sym_Set,
    ACTIONS(6239), 2,
      anon_sym_COLON,
      anon_sym_PIPE,
    STATE(5179), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7712), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7709), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(10757), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [494987] = 3,
    ACTIONS(6710), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6708), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [495032] = 4,
    ACTIONS(6326), 1,
      anon_sym_BSLASH,
    ACTIONS(10796), 1,
      anon_sym_AT,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6324), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [495079] = 3,
    ACTIONS(6655), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6653), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [495124] = 3,
    ACTIONS(6484), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6482), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_PIPE_RPAREN,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [495169] = 3,
    ACTIONS(6496), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6494), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [495214] = 3,
    ACTIONS(6484), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6482), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [495259] = 3,
    ACTIONS(6496), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6494), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [495304] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6326), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6324), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [495349] = 22,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6226), 1,
      sym__newline,
    ACTIONS(9159), 1,
      sym_id,
    ACTIONS(9161), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9165), 1,
      anon_sym_record,
    ACTIONS(9167), 1,
      anon_sym_LPAREN,
    ACTIONS(9169), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(9171), 1,
      anon_sym_u2983,
    ACTIONS(9173), 1,
      anon_sym_LBRACE,
    ACTIONS(9175), 1,
      aux_sym__qid_token1,
    ACTIONS(9177), 1,
      anon_sym_DOT,
    ACTIONS(9181), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(9183), 1,
      anon_sym_u2987,
    ACTIONS(9185), 1,
      aux_sym_integer_token1,
    ACTIONS(9187), 1,
      aux_sym_string_token1,
    ACTIONS(9189), 1,
      anon_sym_Set,
    STATE(7593), 1,
      sym_atom,
    STATE(7577), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    ACTIONS(6224), 3,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_PIPE,
    STATE(7571), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(9163), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [495432] = 3,
    ACTIONS(6500), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6498), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [495477] = 21,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(10798), 1,
      sym_id,
    ACTIONS(10801), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10807), 1,
      anon_sym_record,
    ACTIONS(10810), 1,
      anon_sym_LPAREN,
    ACTIONS(10813), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(10816), 1,
      anon_sym_u2983,
    ACTIONS(10819), 1,
      anon_sym_LBRACE,
    ACTIONS(10822), 1,
      aux_sym__qid_token1,
    ACTIONS(10825), 1,
      anon_sym_DOT,
    ACTIONS(10828), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(10831), 1,
      anon_sym_u2987,
    ACTIONS(10834), 1,
      aux_sym_integer_token1,
    ACTIONS(10837), 1,
      aux_sym_string_token1,
    ACTIONS(10840), 1,
      anon_sym_Set,
    STATE(5190), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7784), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    ACTIONS(6239), 3,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_u2988,
    STATE(7798), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(10804), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [495558] = 23,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6336), 1,
      anon_sym_EQ,
    ACTIONS(6364), 1,
      sym__newline,
    ACTIONS(10843), 1,
      sym_id,
    ACTIONS(10845), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10849), 1,
      anon_sym_record,
    ACTIONS(10851), 1,
      anon_sym_LPAREN,
    ACTIONS(10853), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(10855), 1,
      anon_sym_u2983,
    ACTIONS(10857), 1,
      anon_sym_LBRACE,
    ACTIONS(10859), 1,
      aux_sym__qid_token1,
    ACTIONS(10861), 1,
      anon_sym_DOT,
    ACTIONS(10863), 1,
      anon_sym_PIPE,
    ACTIONS(10865), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(10867), 1,
      anon_sym_u2987,
    ACTIONS(10869), 1,
      aux_sym_integer_token1,
    ACTIONS(10871), 1,
      aux_sym_string_token1,
    ACTIONS(10873), 1,
      anon_sym_Set,
    STATE(5131), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7705), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7719), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(10847), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [495643] = 3,
    ACTIONS(6326), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6324), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [495688] = 4,
    ACTIONS(6326), 1,
      anon_sym_BSLASH,
    ACTIONS(10875), 1,
      anon_sym_AT,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6324), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [495735] = 3,
    ACTIONS(6326), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6324), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [495780] = 22,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(10119), 1,
      sym_id,
    ACTIONS(10123), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10127), 1,
      anon_sym_record,
    ACTIONS(10129), 1,
      anon_sym_LPAREN,
    ACTIONS(10131), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(10133), 1,
      anon_sym_u2983,
    ACTIONS(10135), 1,
      anon_sym_LBRACE,
    ACTIONS(10137), 1,
      aux_sym__qid_token1,
    ACTIONS(10139), 1,
      anon_sym_DOT,
    ACTIONS(10141), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(10143), 1,
      anon_sym_u2987,
    ACTIONS(10145), 1,
      aux_sym_integer_token1,
    ACTIONS(10147), 1,
      aux_sym_string_token1,
    ACTIONS(10149), 1,
      anon_sym_Set,
    STATE(2122), 1,
      sym__ARROW,
    ACTIONS(10877), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(5496), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7812), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7815), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(10125), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [495863] = 3,
    ACTIONS(6568), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6566), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [495908] = 3,
    ACTIONS(6326), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6324), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [495953] = 3,
    ACTIONS(6750), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6748), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [495998] = 22,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(10119), 1,
      sym_id,
    ACTIONS(10123), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10127), 1,
      anon_sym_record,
    ACTIONS(10129), 1,
      anon_sym_LPAREN,
    ACTIONS(10131), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(10133), 1,
      anon_sym_u2983,
    ACTIONS(10135), 1,
      anon_sym_LBRACE,
    ACTIONS(10137), 1,
      aux_sym__qid_token1,
    ACTIONS(10139), 1,
      anon_sym_DOT,
    ACTIONS(10141), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(10143), 1,
      anon_sym_u2987,
    ACTIONS(10145), 1,
      aux_sym_integer_token1,
    ACTIONS(10147), 1,
      aux_sym_string_token1,
    ACTIONS(10149), 1,
      anon_sym_Set,
    STATE(2508), 1,
      sym__ARROW,
    ACTIONS(10879), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(5496), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7812), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7815), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(10125), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [496081] = 22,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6241), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(10881), 1,
      sym_id,
    ACTIONS(10884), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10890), 1,
      anon_sym_record,
    ACTIONS(10893), 1,
      anon_sym_LPAREN,
    ACTIONS(10896), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(10899), 1,
      anon_sym_u2983,
    ACTIONS(10902), 1,
      anon_sym_LBRACE,
    ACTIONS(10905), 1,
      aux_sym__qid_token1,
    ACTIONS(10908), 1,
      anon_sym_DOT,
    ACTIONS(10911), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(10914), 1,
      anon_sym_u2987,
    ACTIONS(10917), 1,
      aux_sym_integer_token1,
    ACTIONS(10920), 1,
      aux_sym_string_token1,
    ACTIONS(10923), 1,
      anon_sym_Set,
    ACTIONS(6239), 2,
      anon_sym_EQ,
      anon_sym_PIPE,
    STATE(5200), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7686), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7699), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(10887), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [496164] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6484), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6482), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [496209] = 4,
    ACTIONS(6488), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6490), 3,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RBRACE,
    ACTIONS(6486), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [496256] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6710), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6708), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [496301] = 4,
    ACTIONS(6488), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6490), 3,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_u2984,
    ACTIONS(6486), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [496348] = 22,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(10719), 1,
      sym_id,
    ACTIONS(10721), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10725), 1,
      anon_sym_record,
    ACTIONS(10727), 1,
      anon_sym_LPAREN,
    ACTIONS(10729), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(10731), 1,
      anon_sym_u2983,
    ACTIONS(10733), 1,
      anon_sym_LBRACE,
    ACTIONS(10735), 1,
      aux_sym__qid_token1,
    ACTIONS(10737), 1,
      anon_sym_DOT,
    ACTIONS(10741), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(10743), 1,
      anon_sym_u2987,
    ACTIONS(10745), 1,
      aux_sym_integer_token1,
    ACTIONS(10747), 1,
      aux_sym_string_token1,
    ACTIONS(10749), 1,
      anon_sym_Set,
    STATE(7648), 1,
      sym_atom,
    ACTIONS(6224), 2,
      anon_sym_COLON,
      anon_sym_PIPE,
    ACTIONS(6226), 2,
      anon_sym_RPAREN,
      anon_sym_RBRACE_RBRACE,
    STATE(7641), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7631), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(10723), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [496431] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6750), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6748), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [496476] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6433), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6431), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [496521] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6714), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6712), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [496566] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6754), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6752), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [496611] = 21,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(10926), 1,
      sym_id,
    ACTIONS(10929), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10935), 1,
      anon_sym_record,
    ACTIONS(10938), 1,
      anon_sym_LPAREN,
    ACTIONS(10941), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(10944), 1,
      anon_sym_u2983,
    ACTIONS(10947), 1,
      anon_sym_LBRACE,
    ACTIONS(10950), 1,
      aux_sym__qid_token1,
    ACTIONS(10953), 1,
      anon_sym_DOT,
    ACTIONS(10956), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(10959), 1,
      anon_sym_u2987,
    ACTIONS(10962), 1,
      aux_sym_integer_token1,
    ACTIONS(10965), 1,
      aux_sym_string_token1,
    ACTIONS(10968), 1,
      anon_sym_Set,
    STATE(5210), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7756), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    ACTIONS(6239), 3,
      anon_sym_EQ,
      anon_sym_u2984,
      anon_sym_PIPE,
    STATE(7737), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(10932), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [496692] = 3,
    ACTIONS(6572), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6570), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [496737] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6651), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6649), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [496782] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6647), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6645), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [496827] = 22,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(10119), 1,
      sym_id,
    ACTIONS(10123), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10127), 1,
      anon_sym_record,
    ACTIONS(10129), 1,
      anon_sym_LPAREN,
    ACTIONS(10131), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(10133), 1,
      anon_sym_u2983,
    ACTIONS(10135), 1,
      anon_sym_LBRACE,
    ACTIONS(10137), 1,
      aux_sym__qid_token1,
    ACTIONS(10139), 1,
      anon_sym_DOT,
    ACTIONS(10141), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(10143), 1,
      anon_sym_u2987,
    ACTIONS(10145), 1,
      aux_sym_integer_token1,
    ACTIONS(10147), 1,
      aux_sym_string_token1,
    ACTIONS(10149), 1,
      anon_sym_Set,
    STATE(2206), 1,
      sym__ARROW,
    ACTIONS(10971), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(5496), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7812), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7815), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(10125), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [496910] = 3,
    ACTIONS(6647), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6645), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [496955] = 4,
    ACTIONS(6326), 1,
      anon_sym_BSLASH,
    ACTIONS(10973), 1,
      anon_sym_AT,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6324), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_u2988,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [497002] = 4,
    ACTIONS(10977), 1,
      anon_sym_BSLASH,
    ACTIONS(10979), 1,
      anon_sym_EQ,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(10975), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [497049] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6572), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6570), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [497094] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6568), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6566), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [497139] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6496), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6494), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [497184] = 3,
    ACTIONS(6326), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6324), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [497229] = 4,
    ACTIONS(6326), 1,
      anon_sym_BSLASH,
    ACTIONS(10981), 1,
      anon_sym_AT,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6324), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_PIPE_RPAREN,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [497276] = 22,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(10119), 1,
      sym_id,
    ACTIONS(10123), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10127), 1,
      anon_sym_record,
    ACTIONS(10129), 1,
      anon_sym_LPAREN,
    ACTIONS(10131), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(10133), 1,
      anon_sym_u2983,
    ACTIONS(10135), 1,
      anon_sym_LBRACE,
    ACTIONS(10137), 1,
      aux_sym__qid_token1,
    ACTIONS(10139), 1,
      anon_sym_DOT,
    ACTIONS(10141), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(10143), 1,
      anon_sym_u2987,
    ACTIONS(10145), 1,
      aux_sym_integer_token1,
    ACTIONS(10147), 1,
      aux_sym_string_token1,
    ACTIONS(10149), 1,
      anon_sym_Set,
    STATE(1715), 1,
      sym__ARROW,
    ACTIONS(10983), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(5496), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7812), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7815), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(10125), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [497359] = 22,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(10985), 1,
      sym_id,
    ACTIONS(10987), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10991), 1,
      anon_sym_record,
    ACTIONS(10993), 1,
      anon_sym_LPAREN,
    ACTIONS(10995), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(10997), 1,
      anon_sym_u2983,
    ACTIONS(10999), 1,
      anon_sym_LBRACE,
    ACTIONS(11001), 1,
      aux_sym__qid_token1,
    ACTIONS(11003), 1,
      anon_sym_DOT,
    ACTIONS(11005), 1,
      anon_sym_PIPE,
    ACTIONS(11007), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11009), 1,
      anon_sym_u2987,
    ACTIONS(11011), 1,
      aux_sym_integer_token1,
    ACTIONS(11013), 1,
      aux_sym_string_token1,
    ACTIONS(11015), 1,
      anon_sym_Set,
    ACTIONS(6336), 2,
      anon_sym_EQ,
      anon_sym_u2988,
    STATE(5190), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7784), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7798), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(10989), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [497442] = 4,
    ACTIONS(6326), 1,
      anon_sym_BSLASH,
    ACTIONS(11017), 1,
      anon_sym_AT,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6324), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [497489] = 5,
    ACTIONS(6488), 1,
      anon_sym_BSLASH,
    ACTIONS(6492), 1,
      sym__newline,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6490), 4,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_in,
    ACTIONS(6486), 30,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [497538] = 23,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6336), 1,
      anon_sym_EQ,
    ACTIONS(6364), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(11019), 1,
      sym_id,
    ACTIONS(11021), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11025), 1,
      anon_sym_record,
    ACTIONS(11027), 1,
      anon_sym_LPAREN,
    ACTIONS(11029), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11031), 1,
      anon_sym_u2983,
    ACTIONS(11033), 1,
      anon_sym_LBRACE,
    ACTIONS(11035), 1,
      aux_sym__qid_token1,
    ACTIONS(11037), 1,
      anon_sym_DOT,
    ACTIONS(11039), 1,
      anon_sym_PIPE,
    ACTIONS(11041), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11043), 1,
      anon_sym_u2987,
    ACTIONS(11045), 1,
      aux_sym_integer_token1,
    ACTIONS(11047), 1,
      aux_sym_string_token1,
    ACTIONS(11049), 1,
      anon_sym_Set,
    STATE(5200), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7686), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7699), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11023), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [497623] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6655), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6653), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [497668] = 3,
    ACTIONS(6651), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6649), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [497713] = 3,
    ACTIONS(6500), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6498), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [497758] = 3,
    ACTIONS(6568), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6566), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [497803] = 3,
    ACTIONS(6572), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6570), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [497848] = 3,
    ACTIONS(6651), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6649), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [497893] = 3,
    ACTIONS(6496), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6494), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [497938] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6484), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6482), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [497983] = 3,
    ACTIONS(6754), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6752), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [498028] = 4,
    ACTIONS(6488), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6490), 4,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(6486), 31,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [498075] = 3,
    ACTIONS(6714), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6712), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [498120] = 22,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11051), 1,
      sym_id,
    ACTIONS(11053), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11057), 1,
      anon_sym_record,
    ACTIONS(11059), 1,
      anon_sym_LPAREN,
    ACTIONS(11061), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11063), 1,
      anon_sym_u2983,
    ACTIONS(11065), 1,
      anon_sym_LBRACE,
    ACTIONS(11067), 1,
      aux_sym__qid_token1,
    ACTIONS(11069), 1,
      anon_sym_DOT,
    ACTIONS(11071), 1,
      anon_sym_PIPE,
    ACTIONS(11073), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11075), 1,
      anon_sym_u2987,
    ACTIONS(11077), 1,
      aux_sym_integer_token1,
    ACTIONS(11079), 1,
      aux_sym_string_token1,
    ACTIONS(11081), 1,
      anon_sym_Set,
    ACTIONS(6336), 2,
      anon_sym_EQ,
      anon_sym_u2984,
    STATE(5210), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7756), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7737), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11055), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [498203] = 3,
    ACTIONS(6750), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6748), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [498248] = 22,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(10119), 1,
      sym_id,
    ACTIONS(10123), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10127), 1,
      anon_sym_record,
    ACTIONS(10129), 1,
      anon_sym_LPAREN,
    ACTIONS(10131), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(10133), 1,
      anon_sym_u2983,
    ACTIONS(10135), 1,
      anon_sym_LBRACE,
    ACTIONS(10137), 1,
      aux_sym__qid_token1,
    ACTIONS(10139), 1,
      anon_sym_DOT,
    ACTIONS(10141), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(10143), 1,
      anon_sym_u2987,
    ACTIONS(10145), 1,
      aux_sym_integer_token1,
    ACTIONS(10147), 1,
      aux_sym_string_token1,
    ACTIONS(10149), 1,
      anon_sym_Set,
    STATE(1932), 1,
      sym__ARROW,
    ACTIONS(11083), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(5496), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7812), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7815), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(10125), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [498331] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6484), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6482), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [498376] = 3,
    ACTIONS(6655), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6653), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [498421] = 22,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(10119), 1,
      sym_id,
    ACTIONS(10123), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10127), 1,
      anon_sym_record,
    ACTIONS(10129), 1,
      anon_sym_LPAREN,
    ACTIONS(10131), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(10133), 1,
      anon_sym_u2983,
    ACTIONS(10135), 1,
      anon_sym_LBRACE,
    ACTIONS(10137), 1,
      aux_sym__qid_token1,
    ACTIONS(10139), 1,
      anon_sym_DOT,
    ACTIONS(10141), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(10143), 1,
      anon_sym_u2987,
    ACTIONS(10145), 1,
      aux_sym_integer_token1,
    ACTIONS(10147), 1,
      aux_sym_string_token1,
    ACTIONS(10149), 1,
      anon_sym_Set,
    STATE(2354), 1,
      sym__ARROW,
    ACTIONS(11085), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(5496), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7812), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7815), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(10125), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [498504] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6710), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6708), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [498549] = 3,
    ACTIONS(6484), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6482), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [498594] = 4,
    ACTIONS(6488), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6490), 3,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(6486), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [498641] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6750), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6748), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [498686] = 3,
    ACTIONS(6647), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6645), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [498731] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6433), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6431), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [498776] = 4,
    ACTIONS(6326), 1,
      anon_sym_BSLASH,
    ACTIONS(11087), 1,
      anon_sym_AT,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6324), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [498823] = 23,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6336), 1,
      anon_sym_EQ,
    ACTIONS(6364), 1,
      anon_sym_RPAREN,
    ACTIONS(10600), 1,
      sym_id,
    ACTIONS(10602), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10606), 1,
      anon_sym_record,
    ACTIONS(10608), 1,
      anon_sym_LPAREN,
    ACTIONS(10610), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(10612), 1,
      anon_sym_u2983,
    ACTIONS(10614), 1,
      anon_sym_LBRACE,
    ACTIONS(10616), 1,
      aux_sym__qid_token1,
    ACTIONS(10618), 1,
      anon_sym_DOT,
    ACTIONS(10620), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(10622), 1,
      anon_sym_u2987,
    ACTIONS(10624), 1,
      aux_sym_integer_token1,
    ACTIONS(10626), 1,
      aux_sym_string_token1,
    ACTIONS(10628), 1,
      anon_sym_Set,
    ACTIONS(11089), 1,
      anon_sym_PIPE,
    STATE(4705), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7582), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7590), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(10604), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [498908] = 3,
    ACTIONS(6433), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6431), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [498953] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6710), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6708), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [498998] = 3,
    ACTIONS(6710), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6708), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [499043] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6714), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6712), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [499088] = 22,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(10119), 1,
      sym_id,
    ACTIONS(10123), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10127), 1,
      anon_sym_record,
    ACTIONS(10129), 1,
      anon_sym_LPAREN,
    ACTIONS(10131), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(10133), 1,
      anon_sym_u2983,
    ACTIONS(10135), 1,
      anon_sym_LBRACE,
    ACTIONS(10137), 1,
      aux_sym__qid_token1,
    ACTIONS(10139), 1,
      anon_sym_DOT,
    ACTIONS(10141), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(10143), 1,
      anon_sym_u2987,
    ACTIONS(10145), 1,
      aux_sym_integer_token1,
    ACTIONS(10147), 1,
      aux_sym_string_token1,
    ACTIONS(10149), 1,
      anon_sym_Set,
    STATE(2182), 1,
      sym__ARROW,
    ACTIONS(11091), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(5496), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7812), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7815), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(10125), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [499171] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6754), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6752), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [499216] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6651), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6649), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [499261] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6572), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6570), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [499306] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6568), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6566), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [499351] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6750), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6748), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [499396] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6500), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6498), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [499441] = 22,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(10119), 1,
      sym_id,
    ACTIONS(10123), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10127), 1,
      anon_sym_record,
    ACTIONS(10129), 1,
      anon_sym_LPAREN,
    ACTIONS(10131), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(10133), 1,
      anon_sym_u2983,
    ACTIONS(10135), 1,
      anon_sym_LBRACE,
    ACTIONS(10137), 1,
      aux_sym__qid_token1,
    ACTIONS(10139), 1,
      anon_sym_DOT,
    ACTIONS(10141), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(10143), 1,
      anon_sym_u2987,
    ACTIONS(10145), 1,
      aux_sym_integer_token1,
    ACTIONS(10147), 1,
      aux_sym_string_token1,
    ACTIONS(10149), 1,
      anon_sym_Set,
    STATE(1799), 1,
      sym__ARROW,
    ACTIONS(11093), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(5496), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7812), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7815), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(10125), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [499524] = 3,
    ACTIONS(6651), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6649), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [499569] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6433), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6431), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [499614] = 22,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(10119), 1,
      sym_id,
    ACTIONS(10123), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10127), 1,
      anon_sym_record,
    ACTIONS(10129), 1,
      anon_sym_LPAREN,
    ACTIONS(10131), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(10133), 1,
      anon_sym_u2983,
    ACTIONS(10135), 1,
      anon_sym_LBRACE,
    ACTIONS(10137), 1,
      aux_sym__qid_token1,
    ACTIONS(10139), 1,
      anon_sym_DOT,
    ACTIONS(10141), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(10143), 1,
      anon_sym_u2987,
    ACTIONS(10145), 1,
      aux_sym_integer_token1,
    ACTIONS(10147), 1,
      aux_sym_string_token1,
    ACTIONS(10149), 1,
      anon_sym_Set,
    STATE(2031), 1,
      sym__ARROW,
    ACTIONS(11095), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(5496), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7812), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7815), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(10125), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [499697] = 4,
    ACTIONS(11097), 1,
      anon_sym_AT,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6326), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6324), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [499744] = 3,
    ACTIONS(6496), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6494), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [499789] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6714), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6712), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [499834] = 3,
    ACTIONS(6754), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6752), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [499879] = 22,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(10119), 1,
      sym_id,
    ACTIONS(10123), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10127), 1,
      anon_sym_record,
    ACTIONS(10129), 1,
      anon_sym_LPAREN,
    ACTIONS(10131), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(10133), 1,
      anon_sym_u2983,
    ACTIONS(10135), 1,
      anon_sym_LBRACE,
    ACTIONS(10137), 1,
      aux_sym__qid_token1,
    ACTIONS(10139), 1,
      anon_sym_DOT,
    ACTIONS(10141), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(10143), 1,
      anon_sym_u2987,
    ACTIONS(10145), 1,
      aux_sym_integer_token1,
    ACTIONS(10147), 1,
      aux_sym_string_token1,
    ACTIONS(10149), 1,
      anon_sym_Set,
    STATE(1845), 1,
      sym__ARROW,
    ACTIONS(5386), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(5496), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7812), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7815), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(10125), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [499962] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6655), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6653), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [500007] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6754), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6752), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [500052] = 22,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(10119), 1,
      sym_id,
    ACTIONS(10123), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10127), 1,
      anon_sym_record,
    ACTIONS(10129), 1,
      anon_sym_LPAREN,
    ACTIONS(10131), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(10133), 1,
      anon_sym_u2983,
    ACTIONS(10135), 1,
      anon_sym_LBRACE,
    ACTIONS(10137), 1,
      aux_sym__qid_token1,
    ACTIONS(10139), 1,
      anon_sym_DOT,
    ACTIONS(10141), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(10143), 1,
      anon_sym_u2987,
    ACTIONS(10145), 1,
      aux_sym_integer_token1,
    ACTIONS(10147), 1,
      aux_sym_string_token1,
    ACTIONS(10149), 1,
      anon_sym_Set,
    STATE(2181), 1,
      sym__ARROW,
    ACTIONS(11099), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(5496), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7812), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7815), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(10125), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [500135] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6651), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6649), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [500180] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6647), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6645), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [500225] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6572), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6570), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [500270] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6568), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6566), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [500315] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6500), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6498), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [500360] = 3,
    ACTIONS(6714), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6712), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [500405] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6496), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6494), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [500450] = 22,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(10119), 1,
      sym_id,
    ACTIONS(10123), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10127), 1,
      anon_sym_record,
    ACTIONS(10129), 1,
      anon_sym_LPAREN,
    ACTIONS(10131), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(10133), 1,
      anon_sym_u2983,
    ACTIONS(10135), 1,
      anon_sym_LBRACE,
    ACTIONS(10137), 1,
      aux_sym__qid_token1,
    ACTIONS(10139), 1,
      anon_sym_DOT,
    ACTIONS(10141), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(10143), 1,
      anon_sym_u2987,
    ACTIONS(10145), 1,
      aux_sym_integer_token1,
    ACTIONS(10147), 1,
      aux_sym_string_token1,
    ACTIONS(10149), 1,
      anon_sym_Set,
    STATE(1846), 1,
      sym__ARROW,
    ACTIONS(5840), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(5496), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7812), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7815), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(10125), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [500533] = 23,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6336), 1,
      anon_sym_EQ,
    ACTIONS(6364), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(10600), 1,
      sym_id,
    ACTIONS(10602), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10606), 1,
      anon_sym_record,
    ACTIONS(10608), 1,
      anon_sym_LPAREN,
    ACTIONS(10610), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(10612), 1,
      anon_sym_u2983,
    ACTIONS(10614), 1,
      anon_sym_LBRACE,
    ACTIONS(10616), 1,
      aux_sym__qid_token1,
    ACTIONS(10618), 1,
      anon_sym_DOT,
    ACTIONS(10620), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(10622), 1,
      anon_sym_u2987,
    ACTIONS(10624), 1,
      aux_sym_integer_token1,
    ACTIONS(10626), 1,
      aux_sym_string_token1,
    ACTIONS(10628), 1,
      anon_sym_Set,
    ACTIONS(11101), 1,
      anon_sym_PIPE,
    STATE(4705), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7582), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7590), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(10604), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [500618] = 3,
    ACTIONS(6326), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6324), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [500663] = 23,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6336), 1,
      anon_sym_COLON,
    ACTIONS(6364), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(10719), 1,
      sym_id,
    ACTIONS(10721), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10725), 1,
      anon_sym_record,
    ACTIONS(10727), 1,
      anon_sym_LPAREN,
    ACTIONS(10729), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(10731), 1,
      anon_sym_u2983,
    ACTIONS(10733), 1,
      anon_sym_LBRACE,
    ACTIONS(10735), 1,
      aux_sym__qid_token1,
    ACTIONS(10737), 1,
      anon_sym_DOT,
    ACTIONS(10741), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(10743), 1,
      anon_sym_u2987,
    ACTIONS(10745), 1,
      aux_sym_integer_token1,
    ACTIONS(10747), 1,
      aux_sym_string_token1,
    ACTIONS(10749), 1,
      anon_sym_Set,
    ACTIONS(11103), 1,
      anon_sym_PIPE,
    STATE(4779), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7641), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7631), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(10723), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [500748] = 3,
    ACTIONS(6484), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6482), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [500793] = 3,
    ACTIONS(6433), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6431), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [500838] = 4,
    ACTIONS(6326), 1,
      anon_sym_BSLASH,
    ACTIONS(11105), 1,
      anon_sym_AT,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6324), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [500885] = 5,
    ACTIONS(6488), 1,
      anon_sym_BSLASH,
    ACTIONS(6492), 1,
      sym__newline,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6490), 2,
      anon_sym_EQ,
      anon_sym_SEMI,
    ACTIONS(6486), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [500934] = 3,
    ACTIONS(6710), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6708), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [500979] = 22,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(10119), 1,
      sym_id,
    ACTIONS(10123), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10127), 1,
      anon_sym_record,
    ACTIONS(10129), 1,
      anon_sym_LPAREN,
    ACTIONS(10131), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(10133), 1,
      anon_sym_u2983,
    ACTIONS(10135), 1,
      anon_sym_LBRACE,
    ACTIONS(10137), 1,
      aux_sym__qid_token1,
    ACTIONS(10139), 1,
      anon_sym_DOT,
    ACTIONS(10141), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(10143), 1,
      anon_sym_u2987,
    ACTIONS(10145), 1,
      aux_sym_integer_token1,
    ACTIONS(10147), 1,
      aux_sym_string_token1,
    ACTIONS(10149), 1,
      anon_sym_Set,
    STATE(1643), 1,
      sym__ARROW,
    ACTIONS(11107), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(5496), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7812), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7815), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(10125), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [501062] = 3,
    ACTIONS(6750), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6748), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [501107] = 3,
    ACTIONS(6433), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6431), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [501152] = 3,
    ACTIONS(6496), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6494), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [501197] = 3,
    ACTIONS(6714), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6712), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [501242] = 3,
    ACTIONS(6754), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6752), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [501287] = 3,
    ACTIONS(6651), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6649), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [501332] = 3,
    ACTIONS(6647), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6645), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [501377] = 3,
    ACTIONS(6572), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6570), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [501422] = 21,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(10006), 1,
      sym_id,
    ACTIONS(10008), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10012), 1,
      anon_sym_record,
    ACTIONS(10014), 1,
      anon_sym_LPAREN,
    ACTIONS(10016), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(10018), 1,
      anon_sym_u2983,
    ACTIONS(10020), 1,
      anon_sym_LBRACE,
    ACTIONS(10022), 1,
      aux_sym__qid_token1,
    ACTIONS(10024), 1,
      anon_sym_DOT,
    ACTIONS(10028), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(10030), 1,
      anon_sym_u2987,
    ACTIONS(10032), 1,
      aux_sym_integer_token1,
    ACTIONS(10034), 1,
      aux_sym_string_token1,
    ACTIONS(10036), 1,
      anon_sym_Set,
    STATE(7512), 1,
      sym_atom,
    STATE(7489), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    ACTIONS(6224), 4,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_u2984,
      anon_sym_PIPE,
    STATE(7488), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(10010), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [501503] = 3,
    ACTIONS(6655), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6653), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [501548] = 22,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(10119), 1,
      sym_id,
    ACTIONS(10123), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10127), 1,
      anon_sym_record,
    ACTIONS(10129), 1,
      anon_sym_LPAREN,
    ACTIONS(10131), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(10133), 1,
      anon_sym_u2983,
    ACTIONS(10135), 1,
      anon_sym_LBRACE,
    ACTIONS(10137), 1,
      aux_sym__qid_token1,
    ACTIONS(10139), 1,
      anon_sym_DOT,
    ACTIONS(10141), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(10143), 1,
      anon_sym_u2987,
    ACTIONS(10145), 1,
      aux_sym_integer_token1,
    ACTIONS(10147), 1,
      aux_sym_string_token1,
    ACTIONS(10149), 1,
      anon_sym_Set,
    STATE(1560), 1,
      sym__ARROW,
    ACTIONS(11109), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(5496), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7812), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7815), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(10125), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [501631] = 3,
    ACTIONS(6568), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6566), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [501676] = 3,
    ACTIONS(6496), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6494), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [501721] = 3,
    ACTIONS(6655), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6653), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [501766] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6655), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6653), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [501811] = 22,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6226), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(8955), 1,
      sym_id,
    ACTIONS(8957), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8961), 1,
      anon_sym_record,
    ACTIONS(8963), 1,
      anon_sym_LPAREN,
    ACTIONS(8965), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(8967), 1,
      anon_sym_u2983,
    ACTIONS(8969), 1,
      anon_sym_LBRACE,
    ACTIONS(8971), 1,
      aux_sym__qid_token1,
    ACTIONS(8973), 1,
      anon_sym_DOT,
    ACTIONS(8977), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(8979), 1,
      anon_sym_u2987,
    ACTIONS(8981), 1,
      aux_sym_integer_token1,
    ACTIONS(8983), 1,
      aux_sym_string_token1,
    ACTIONS(8985), 1,
      anon_sym_Set,
    STATE(7493), 1,
      sym_atom,
    STATE(7468), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    ACTIONS(6224), 3,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_PIPE,
    STATE(7497), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(8959), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [501894] = 3,
    ACTIONS(6500), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6498), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [501939] = 3,
    ACTIONS(6568), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6566), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [501984] = 3,
    ACTIONS(6572), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6570), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [502029] = 3,
    ACTIONS(6647), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6645), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [502074] = 3,
    ACTIONS(6651), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6649), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [502119] = 3,
    ACTIONS(6754), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6752), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [502164] = 3,
    ACTIONS(6714), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6712), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [502209] = 3,
    ACTIONS(6433), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6431), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [502254] = 3,
    ACTIONS(6750), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6748), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [502299] = 3,
    ACTIONS(6710), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6708), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [502344] = 3,
    ACTIONS(6484), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6482), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [502389] = 3,
    ACTIONS(6500), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6498), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [502434] = 3,
    ACTIONS(6568), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6566), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [502479] = 3,
    ACTIONS(6572), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6570), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [502524] = 3,
    ACTIONS(6647), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6645), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [502569] = 3,
    ACTIONS(6500), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6498), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [502614] = 3,
    ACTIONS(6754), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6752), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [502659] = 22,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(10119), 1,
      sym_id,
    ACTIONS(10123), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10127), 1,
      anon_sym_record,
    ACTIONS(10129), 1,
      anon_sym_LPAREN,
    ACTIONS(10131), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(10133), 1,
      anon_sym_u2983,
    ACTIONS(10135), 1,
      anon_sym_LBRACE,
    ACTIONS(10137), 1,
      aux_sym__qid_token1,
    ACTIONS(10139), 1,
      anon_sym_DOT,
    ACTIONS(10141), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(10143), 1,
      anon_sym_u2987,
    ACTIONS(10145), 1,
      aux_sym_integer_token1,
    ACTIONS(10147), 1,
      aux_sym_string_token1,
    ACTIONS(10149), 1,
      anon_sym_Set,
    STATE(2058), 1,
      sym__ARROW,
    ACTIONS(11111), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(5496), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7812), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7815), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(10125), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [502742] = 3,
    ACTIONS(6714), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6712), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [502787] = 3,
    ACTIONS(6433), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6431), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [502832] = 3,
    ACTIONS(6750), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6748), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [502877] = 3,
    ACTIONS(6710), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6708), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [502922] = 4,
    ACTIONS(11113), 1,
      anon_sym_AT,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6326), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6324), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [502969] = 22,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(10119), 1,
      sym_id,
    ACTIONS(10123), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10127), 1,
      anon_sym_record,
    ACTIONS(10129), 1,
      anon_sym_LPAREN,
    ACTIONS(10131), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(10133), 1,
      anon_sym_u2983,
    ACTIONS(10135), 1,
      anon_sym_LBRACE,
    ACTIONS(10137), 1,
      aux_sym__qid_token1,
    ACTIONS(10139), 1,
      anon_sym_DOT,
    ACTIONS(10141), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(10143), 1,
      anon_sym_u2987,
    ACTIONS(10145), 1,
      aux_sym_integer_token1,
    ACTIONS(10147), 1,
      aux_sym_string_token1,
    ACTIONS(10149), 1,
      anon_sym_Set,
    STATE(1826), 1,
      sym__ARROW,
    ACTIONS(11115), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(5496), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7812), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7815), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(10125), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [503052] = 3,
    ACTIONS(6484), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6482), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [503097] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6647), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6645), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [503142] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6326), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6324), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [503187] = 3,
    ACTIONS(6710), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6708), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [503232] = 3,
    ACTIONS(6750), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6748), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [503277] = 3,
    ACTIONS(6433), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6431), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [503322] = 3,
    ACTIONS(6714), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6712), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [503367] = 3,
    ACTIONS(6754), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6752), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [503412] = 3,
    ACTIONS(6651), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6649), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [503457] = 3,
    ACTIONS(6647), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6645), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [503502] = 3,
    ACTIONS(6572), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6570), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [503547] = 3,
    ACTIONS(6568), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6566), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [503592] = 3,
    ACTIONS(6500), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6498), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [503637] = 22,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(10119), 1,
      sym_id,
    ACTIONS(10123), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10127), 1,
      anon_sym_record,
    ACTIONS(10129), 1,
      anon_sym_LPAREN,
    ACTIONS(10131), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(10133), 1,
      anon_sym_u2983,
    ACTIONS(10135), 1,
      anon_sym_LBRACE,
    ACTIONS(10137), 1,
      aux_sym__qid_token1,
    ACTIONS(10139), 1,
      anon_sym_DOT,
    ACTIONS(10141), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(10143), 1,
      anon_sym_u2987,
    ACTIONS(10145), 1,
      aux_sym_integer_token1,
    ACTIONS(10147), 1,
      aux_sym_string_token1,
    ACTIONS(10149), 1,
      anon_sym_Set,
    STATE(1486), 1,
      sym__ARROW,
    ACTIONS(11117), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(5496), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7812), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7815), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(10125), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [503720] = 3,
    ACTIONS(6484), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6482), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [503765] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6496), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6494), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [503810] = 4,
    ACTIONS(6326), 1,
      anon_sym_BSLASH,
    ACTIONS(11119), 1,
      anon_sym_AT,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6324), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [503857] = 3,
    ACTIONS(6655), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6653), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [503902] = 22,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6226), 1,
      sym__newline,
    ACTIONS(9792), 1,
      sym_id,
    ACTIONS(9794), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9798), 1,
      anon_sym_record,
    ACTIONS(9800), 1,
      anon_sym_LPAREN,
    ACTIONS(9802), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(9804), 1,
      anon_sym_u2983,
    ACTIONS(9806), 1,
      anon_sym_LBRACE,
    ACTIONS(9808), 1,
      aux_sym__qid_token1,
    ACTIONS(9810), 1,
      anon_sym_DOT,
    ACTIONS(9814), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(9816), 1,
      anon_sym_u2987,
    ACTIONS(9818), 1,
      aux_sym_integer_token1,
    ACTIONS(9820), 1,
      aux_sym_string_token1,
    ACTIONS(9822), 1,
      anon_sym_Set,
    STATE(7479), 1,
      sym_atom,
    STATE(7535), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    ACTIONS(6224), 3,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_PIPE,
    STATE(7536), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(9796), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [503985] = 5,
    ACTIONS(6488), 1,
      anon_sym_BSLASH,
    ACTIONS(6492), 1,
      sym__newline,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6490), 3,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_in,
    ACTIONS(6486), 31,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [504034] = 22,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(10119), 1,
      sym_id,
    ACTIONS(10123), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10127), 1,
      anon_sym_record,
    ACTIONS(10129), 1,
      anon_sym_LPAREN,
    ACTIONS(10131), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(10133), 1,
      anon_sym_u2983,
    ACTIONS(10135), 1,
      anon_sym_LBRACE,
    ACTIONS(10137), 1,
      aux_sym__qid_token1,
    ACTIONS(10139), 1,
      anon_sym_DOT,
    ACTIONS(10141), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(10143), 1,
      anon_sym_u2987,
    ACTIONS(10145), 1,
      aux_sym_integer_token1,
    ACTIONS(10147), 1,
      aux_sym_string_token1,
    ACTIONS(10149), 1,
      anon_sym_Set,
    STATE(1816), 1,
      sym__ARROW,
    ACTIONS(11121), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(5496), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7812), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7815), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(10125), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [504117] = 3,
    ACTIONS(6710), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6708), 35,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [504162] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6326), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6324), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [504207] = 22,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(10119), 1,
      sym_id,
    ACTIONS(10123), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10127), 1,
      anon_sym_record,
    ACTIONS(10129), 1,
      anon_sym_LPAREN,
    ACTIONS(10131), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(10133), 1,
      anon_sym_u2983,
    ACTIONS(10135), 1,
      anon_sym_LBRACE,
    ACTIONS(10137), 1,
      aux_sym__qid_token1,
    ACTIONS(10139), 1,
      anon_sym_DOT,
    ACTIONS(10141), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(10143), 1,
      anon_sym_u2987,
    ACTIONS(10145), 1,
      aux_sym_integer_token1,
    ACTIONS(10147), 1,
      aux_sym_string_token1,
    ACTIONS(10149), 1,
      anon_sym_Set,
    STATE(1635), 1,
      sym__ARROW,
    ACTIONS(11123), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(5496), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7812), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7815), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(10125), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [504290] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6651), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6649), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [504334] = 5,
    ACTIONS(6488), 1,
      anon_sym_BSLASH,
    ACTIONS(6492), 1,
      sym__newline,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6490), 3,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
    ACTIONS(6486), 30,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [504382] = 3,
    ACTIONS(6326), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6324), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [504426] = 3,
    ACTIONS(6750), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6748), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [504470] = 3,
    ACTIONS(6714), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6712), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [504514] = 3,
    ACTIONS(6568), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6566), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [504558] = 3,
    ACTIONS(6500), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6498), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [504602] = 3,
    ACTIONS(6484), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6482), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [504646] = 3,
    ACTIONS(6433), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6431), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [504690] = 3,
    ACTIONS(6326), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6324), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [504734] = 3,
    ACTIONS(6754), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6752), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [504778] = 5,
    ACTIONS(6488), 1,
      anon_sym_BSLASH,
    ACTIONS(6492), 1,
      sym__newline,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6490), 3,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_in,
    ACTIONS(6486), 30,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [504826] = 3,
    ACTIONS(6710), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6708), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [504870] = 3,
    ACTIONS(6655), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6653), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [504914] = 3,
    ACTIONS(6750), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6748), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [504958] = 3,
    ACTIONS(6496), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6494), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [505002] = 3,
    ACTIONS(6433), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6431), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [505046] = 3,
    ACTIONS(6655), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6653), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [505090] = 3,
    ACTIONS(6484), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6482), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [505134] = 3,
    ACTIONS(6651), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6649), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [505178] = 3,
    ACTIONS(6496), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6494), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [505222] = 3,
    ACTIONS(6647), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6645), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [505266] = 3,
    ACTIONS(6326), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6324), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [505310] = 3,
    ACTIONS(6714), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6712), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [505354] = 3,
    ACTIONS(6754), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6752), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [505398] = 3,
    ACTIONS(6651), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6649), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [505442] = 3,
    ACTIONS(6647), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6645), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [505486] = 3,
    ACTIONS(6572), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6570), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [505530] = 3,
    ACTIONS(6568), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6566), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [505574] = 3,
    ACTIONS(6500), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6498), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [505618] = 3,
    ACTIONS(6710), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6708), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [505662] = 3,
    ACTIONS(6496), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6494), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [505706] = 3,
    ACTIONS(6655), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6653), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [505750] = 3,
    ACTIONS(6500), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6498), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [505794] = 3,
    ACTIONS(6568), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6566), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [505838] = 3,
    ACTIONS(6572), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6570), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [505882] = 3,
    ACTIONS(6647), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6645), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [505926] = 3,
    ACTIONS(6651), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6649), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [505970] = 3,
    ACTIONS(6496), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6494), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [506014] = 22,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6226), 1,
      anon_sym_RBRACE,
    ACTIONS(10379), 1,
      sym_id,
    ACTIONS(10381), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10385), 1,
      anon_sym_record,
    ACTIONS(10387), 1,
      anon_sym_LPAREN,
    ACTIONS(10389), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(10391), 1,
      anon_sym_u2983,
    ACTIONS(10393), 1,
      anon_sym_LBRACE,
    ACTIONS(10395), 1,
      aux_sym__qid_token1,
    ACTIONS(10397), 1,
      anon_sym_DOT,
    ACTIONS(10401), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(10403), 1,
      anon_sym_u2987,
    ACTIONS(10405), 1,
      aux_sym_integer_token1,
    ACTIONS(10407), 1,
      aux_sym_string_token1,
    ACTIONS(10409), 1,
      anon_sym_Set,
    STATE(7749), 1,
      sym_atom,
    ACTIONS(6224), 2,
      anon_sym_SEMI,
      anon_sym_PIPE,
    STATE(7690), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7735), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(10383), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [506096] = 3,
    ACTIONS(6754), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6752), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [506140] = 3,
    ACTIONS(6714), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6712), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [506184] = 3,
    ACTIONS(6433), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6431), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [506228] = 3,
    ACTIONS(6750), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6748), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [506272] = 3,
    ACTIONS(6710), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6708), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [506316] = 3,
    ACTIONS(6655), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6653), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [506360] = 4,
    ACTIONS(6326), 1,
      anon_sym_BSLASH,
    ACTIONS(11125), 1,
      anon_sym_AT,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6324), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [506406] = 4,
    ACTIONS(6488), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6490), 2,
      anon_sym_EQ,
      anon_sym_RBRACE,
    ACTIONS(6486), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [506452] = 3,
    ACTIONS(6484), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6482), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [506496] = 3,
    ACTIONS(6496), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6494), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [506540] = 5,
    ACTIONS(6488), 1,
      anon_sym_BSLASH,
    ACTIONS(6492), 1,
      sym__newline,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6490), 3,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_SEMI,
    ACTIONS(6486), 30,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [506588] = 3,
    ACTIONS(6655), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6653), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [506632] = 4,
    ACTIONS(11127), 1,
      anon_sym_AT,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6326), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6324), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [506678] = 3,
    ACTIONS(6500), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6498), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [506722] = 3,
    ACTIONS(6568), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6566), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [506766] = 3,
    ACTIONS(6572), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6570), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [506810] = 3,
    ACTIONS(6647), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6645), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [506854] = 3,
    ACTIONS(6651), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6649), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [506898] = 3,
    ACTIONS(6326), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6324), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [506942] = 3,
    ACTIONS(6754), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6752), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [506986] = 3,
    ACTIONS(6714), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6712), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [507030] = 3,
    ACTIONS(6326), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6324), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [507074] = 3,
    ACTIONS(6433), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6431), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [507118] = 4,
    ACTIONS(6326), 1,
      anon_sym_BSLASH,
    ACTIONS(11129), 1,
      anon_sym_AT,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6324), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [507164] = 3,
    ACTIONS(6750), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6748), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [507208] = 3,
    ACTIONS(6710), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6708), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [507252] = 3,
    ACTIONS(6484), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6482), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [507296] = 3,
    ACTIONS(6500), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6498), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [507340] = 3,
    ACTIONS(6568), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6566), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [507384] = 4,
    ACTIONS(6484), 1,
      anon_sym_BSLASH,
    ACTIONS(11131), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6482), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [507430] = 3,
    ACTIONS(6572), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6570), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [507474] = 4,
    ACTIONS(6484), 1,
      anon_sym_BSLASH,
    ACTIONS(11131), 1,
      anon_sym_u2984,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6482), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [507520] = 21,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11133), 1,
      sym_id,
    ACTIONS(11135), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11139), 1,
      anon_sym_record,
    ACTIONS(11141), 1,
      anon_sym_LPAREN,
    ACTIONS(11143), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11145), 1,
      anon_sym_u2983,
    ACTIONS(11147), 1,
      anon_sym_LBRACE,
    ACTIONS(11149), 1,
      aux_sym__qid_token1,
    ACTIONS(11151), 1,
      anon_sym_DOT,
    ACTIONS(11153), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11155), 1,
      anon_sym_u2987,
    ACTIONS(11157), 1,
      aux_sym_integer_token1,
    ACTIONS(11159), 1,
      aux_sym_string_token1,
    ACTIONS(11161), 1,
      anon_sym_Set,
    STATE(8841), 1,
      sym_atom,
    STATE(8809), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    ACTIONS(6224), 3,
      anon_sym_COLON,
      anon_sym_where,
      anon_sym_DOT_DOT,
    STATE(8832), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11137), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [507600] = 4,
    ACTIONS(6488), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6490), 2,
      anon_sym_EQ,
      anon_sym_u2984,
    ACTIONS(6486), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [507646] = 3,
    ACTIONS(6710), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6708), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [507690] = 4,
    ACTIONS(6326), 1,
      anon_sym_BSLASH,
    ACTIONS(11163), 1,
      anon_sym_AT,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6324), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [507736] = 4,
    ACTIONS(6488), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6490), 3,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(6486), 31,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [507782] = 3,
    ACTIONS(6433), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6431), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [507826] = 3,
    ACTIONS(6647), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6645), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [507870] = 3,
    ACTIONS(6484), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6482), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [507914] = 3,
    ACTIONS(6647), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6645), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [507958] = 3,
    ACTIONS(6326), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6324), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [508002] = 3,
    ACTIONS(6651), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6649), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [508046] = 3,
    ACTIONS(6655), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6653), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [508090] = 3,
    ACTIONS(6754), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6752), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [508134] = 4,
    ACTIONS(6488), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6490), 2,
      anon_sym_EQ,
      anon_sym_PIPE_RPAREN,
    ACTIONS(6486), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [508180] = 3,
    ACTIONS(6750), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6748), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [508224] = 3,
    ACTIONS(6326), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6324), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [508268] = 3,
    ACTIONS(6496), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6494), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [508312] = 3,
    ACTIONS(6655), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6653), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [508356] = 3,
    ACTIONS(6714), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6712), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [508400] = 3,
    ACTIONS(6714), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6712), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [508444] = 3,
    ACTIONS(6433), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6431), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [508488] = 3,
    ACTIONS(6750), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6748), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [508532] = 3,
    ACTIONS(6710), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6708), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [508576] = 3,
    ACTIONS(6754), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6752), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [508620] = 3,
    ACTIONS(6484), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6482), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [508664] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6484), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6482), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [508708] = 3,
    ACTIONS(6500), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6498), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [508752] = 3,
    ACTIONS(6568), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6566), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [508796] = 3,
    ACTIONS(6572), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6570), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [508840] = 3,
    ACTIONS(6647), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6645), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [508884] = 3,
    ACTIONS(6651), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6649), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [508928] = 3,
    ACTIONS(6496), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6494), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [508972] = 3,
    ACTIONS(6754), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6752), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [509016] = 3,
    ACTIONS(6714), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6712), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [509060] = 3,
    ACTIONS(6572), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6570), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [509104] = 3,
    ACTIONS(6433), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6431), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [509148] = 3,
    ACTIONS(6750), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6748), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [509192] = 3,
    ACTIONS(6710), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6708), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [509236] = 3,
    ACTIONS(6568), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6566), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [509280] = 3,
    ACTIONS(6500), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6498), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [509324] = 4,
    ACTIONS(6488), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6490), 2,
      anon_sym_EQ,
      anon_sym_u2988,
    ACTIONS(6486), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [509370] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6710), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6708), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [509414] = 4,
    ACTIONS(6326), 1,
      anon_sym_BSLASH,
    ACTIONS(11165), 1,
      anon_sym_AT,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6324), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [509460] = 3,
    ACTIONS(6484), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6482), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [509504] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6750), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6748), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [509548] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6433), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6431), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [509592] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6714), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6712), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [509636] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6754), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6752), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [509680] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6651), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6649), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [509724] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6647), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6645), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [509768] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6572), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6570), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [509812] = 3,
    ACTIONS(6710), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6708), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_PIPE_RPAREN,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [509856] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6568), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6566), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [509900] = 3,
    ACTIONS(6433), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6431), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_PIPE_RPAREN,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [509944] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6500), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6498), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [509988] = 4,
    ACTIONS(6326), 1,
      anon_sym_BSLASH,
    ACTIONS(11167), 1,
      anon_sym_AT,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6324), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_PIPE_RPAREN,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [510034] = 4,
    ACTIONS(6488), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6490), 4,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_u2984,
    ACTIONS(6486), 30,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [510080] = 4,
    ACTIONS(6326), 1,
      anon_sym_BSLASH,
    ACTIONS(11169), 1,
      anon_sym_AT,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6324), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_u2988,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [510126] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6655), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6653), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [510170] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6496), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6494), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [510214] = 3,
    ACTIONS(6647), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6645), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_PIPE_RPAREN,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [510258] = 3,
    ACTIONS(6484), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6482), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_PIPE_RPAREN,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [510302] = 3,
    ACTIONS(6433), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6431), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [510346] = 3,
    ACTIONS(6710), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6708), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_u2988,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [510390] = 3,
    ACTIONS(6750), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6748), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_PIPE_RPAREN,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [510434] = 3,
    ACTIONS(6433), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6431), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_u2988,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [510478] = 3,
    ACTIONS(6714), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6712), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_PIPE_RPAREN,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [510522] = 21,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11171), 1,
      sym_id,
    ACTIONS(11174), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11180), 1,
      anon_sym_record,
    ACTIONS(11183), 1,
      anon_sym_LPAREN,
    ACTIONS(11186), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11189), 1,
      anon_sym_u2983,
    ACTIONS(11192), 1,
      anon_sym_LBRACE,
    ACTIONS(11195), 1,
      aux_sym__qid_token1,
    ACTIONS(11198), 1,
      anon_sym_DOT,
    ACTIONS(11201), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11204), 1,
      anon_sym_u2987,
    ACTIONS(11207), 1,
      aux_sym_integer_token1,
    ACTIONS(11210), 1,
      aux_sym_string_token1,
    ACTIONS(11213), 1,
      anon_sym_Set,
    ACTIONS(6239), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(5496), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7812), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7815), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11177), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [510602] = 3,
    ACTIONS(6754), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6752), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_PIPE_RPAREN,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [510646] = 3,
    ACTIONS(6651), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6649), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_PIPE_RPAREN,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [510690] = 3,
    ACTIONS(6647), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6645), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_u2988,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [510734] = 3,
    ACTIONS(6572), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6570), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_PIPE_RPAREN,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [510778] = 3,
    ACTIONS(6568), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6566), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_PIPE_RPAREN,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [510822] = 3,
    ACTIONS(6500), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6498), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_PIPE_RPAREN,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [510866] = 3,
    ACTIONS(6484), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6482), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_u2988,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [510910] = 3,
    ACTIONS(6326), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6324), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [510954] = 3,
    ACTIONS(6655), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6653), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_PIPE_RPAREN,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [510998] = 3,
    ACTIONS(6750), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6748), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_u2988,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [511042] = 3,
    ACTIONS(6714), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6712), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_u2988,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [511086] = 3,
    ACTIONS(6754), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6752), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_u2988,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [511130] = 4,
    ACTIONS(11216), 1,
      anon_sym_AT,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6326), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6324), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [511176] = 4,
    ACTIONS(6488), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6490), 4,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(6486), 30,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [511222] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6326), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6324), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [511266] = 4,
    ACTIONS(6488), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6490), 4,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(6486), 30,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [511312] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6496), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6494), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [511356] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6655), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6653), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [511400] = 3,
    ACTIONS(6496), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6494), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_PIPE_RPAREN,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [511444] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6500), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6498), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [511488] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6568), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6566), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [511532] = 3,
    ACTIONS(6651), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6649), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_u2988,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [511576] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6572), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6570), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [511620] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6647), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6645), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [511664] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6651), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6649), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [511708] = 3,
    ACTIONS(6572), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6570), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_u2988,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [511752] = 3,
    ACTIONS(6326), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6324), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [511796] = 3,
    ACTIONS(6568), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6566), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_u2988,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [511840] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6754), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6752), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [511884] = 3,
    ACTIONS(6500), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6498), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_u2988,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [511928] = 3,
    ACTIONS(6655), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6653), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_u2988,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [511972] = 3,
    ACTIONS(6651), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6649), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [512016] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6714), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6712), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [512060] = 3,
    ACTIONS(6496), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6494), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_u2988,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [512104] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6433), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6431), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [512148] = 3,
    ACTIONS(6326), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6324), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_PIPE_RPAREN,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [512192] = 3,
    ACTIONS(6496), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6494), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [512236] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6750), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6748), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [512280] = 3,
    ACTIONS(6326), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6324), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_u2988,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [512324] = 5,
    ACTIONS(6488), 1,
      anon_sym_BSLASH,
    ACTIONS(6490), 1,
      anon_sym_EQ,
    ACTIONS(6492), 1,
      sym__newline,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6486), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [512372] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6710), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6708), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [512416] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6484), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6482), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [512460] = 21,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(10519), 1,
      sym_id,
    ACTIONS(10521), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10525), 1,
      anon_sym_record,
    ACTIONS(10527), 1,
      anon_sym_LPAREN,
    ACTIONS(10529), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(10531), 1,
      anon_sym_u2983,
    ACTIONS(10533), 1,
      anon_sym_LBRACE,
    ACTIONS(10535), 1,
      aux_sym__qid_token1,
    ACTIONS(10537), 1,
      anon_sym_DOT,
    ACTIONS(10541), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(10543), 1,
      anon_sym_u2987,
    ACTIONS(10545), 1,
      aux_sym_integer_token1,
    ACTIONS(10547), 1,
      aux_sym_string_token1,
    ACTIONS(10549), 1,
      anon_sym_Set,
    STATE(7713), 1,
      sym_atom,
    STATE(7698), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    ACTIONS(6224), 3,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_PIPE,
    STATE(7681), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(10523), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [512540] = 3,
    ACTIONS(6655), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6653), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [512584] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6326), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6324), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [512628] = 5,
    ACTIONS(6488), 1,
      anon_sym_BSLASH,
    ACTIONS(6492), 1,
      sym__newline,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6490), 3,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_in,
    ACTIONS(6486), 30,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [512676] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6326), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6324), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [512720] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6496), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6494), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [512764] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6655), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6653), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [512808] = 4,
    ACTIONS(6326), 1,
      anon_sym_BSLASH,
    ACTIONS(11218), 1,
      anon_sym_AT,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6324), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [512854] = 4,
    ACTIONS(6326), 1,
      anon_sym_BSLASH,
    ACTIONS(11220), 1,
      anon_sym_AT,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6324), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [512900] = 4,
    ACTIONS(6488), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6490), 4,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(6486), 30,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [512946] = 4,
    ACTIONS(6488), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6490), 3,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_SEMI,
    ACTIONS(6486), 31,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [512992] = 3,
    ACTIONS(6484), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6482), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [513036] = 22,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6226), 1,
      anon_sym_RBRACE,
    ACTIONS(10337), 1,
      sym_id,
    ACTIONS(10339), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10343), 1,
      anon_sym_record,
    ACTIONS(10345), 1,
      anon_sym_LPAREN,
    ACTIONS(10347), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(10349), 1,
      anon_sym_u2983,
    ACTIONS(10351), 1,
      anon_sym_LBRACE,
    ACTIONS(10353), 1,
      aux_sym__qid_token1,
    ACTIONS(10355), 1,
      anon_sym_DOT,
    ACTIONS(10359), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(10361), 1,
      anon_sym_u2987,
    ACTIONS(10363), 1,
      aux_sym_integer_token1,
    ACTIONS(10365), 1,
      aux_sym_string_token1,
    ACTIONS(10367), 1,
      anon_sym_Set,
    STATE(7739), 1,
      sym_atom,
    ACTIONS(6224), 2,
      anon_sym_COLON,
      anon_sym_PIPE,
    STATE(7712), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7709), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(10341), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [513118] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6500), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6498), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [513162] = 3,
    ACTIONS(6710), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6708), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [513206] = 3,
    ACTIONS(6750), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6748), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [513250] = 3,
    ACTIONS(6433), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6431), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [513294] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6568), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6566), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [513338] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6572), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6570), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [513382] = 3,
    ACTIONS(6714), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6712), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [513426] = 3,
    ACTIONS(6754), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6752), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [513470] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6647), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6645), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [513514] = 3,
    ACTIONS(6651), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6649), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [513558] = 3,
    ACTIONS(6647), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6645), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [513602] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6651), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6649), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [513646] = 3,
    ACTIONS(6572), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6570), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [513690] = 3,
    ACTIONS(6568), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6566), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [513734] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6710), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6708), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [513778] = 3,
    ACTIONS(6500), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6498), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [513822] = 3,
    ACTIONS(6500), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6498), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [513866] = 3,
    ACTIONS(6568), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6566), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [513910] = 3,
    ACTIONS(6572), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6570), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [513954] = 3,
    ACTIONS(6647), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6645), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [513998] = 3,
    ACTIONS(6651), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6649), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [514042] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6754), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6752), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [514086] = 3,
    ACTIONS(6754), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6752), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [514130] = 3,
    ACTIONS(6714), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6712), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [514174] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6433), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6431), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [514218] = 4,
    ACTIONS(6326), 1,
      anon_sym_BSLASH,
    ACTIONS(11222), 1,
      anon_sym_AT,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6324), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [514264] = 3,
    ACTIONS(6750), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6748), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [514308] = 3,
    ACTIONS(6710), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6708), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [514352] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6714), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6712), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [514396] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6433), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6431), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [514440] = 3,
    ACTIONS(6484), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6482), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [514484] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6750), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6748), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [514528] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6710), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6708), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [514572] = 21,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(10679), 1,
      sym_id,
    ACTIONS(10681), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10685), 1,
      anon_sym_record,
    ACTIONS(10687), 1,
      anon_sym_LPAREN,
    ACTIONS(10689), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(10691), 1,
      anon_sym_u2983,
    ACTIONS(10693), 1,
      anon_sym_LBRACE,
    ACTIONS(10695), 1,
      aux_sym__qid_token1,
    ACTIONS(10697), 1,
      anon_sym_DOT,
    ACTIONS(10701), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(10703), 1,
      anon_sym_u2987,
    ACTIONS(10705), 1,
      aux_sym_integer_token1,
    ACTIONS(10707), 1,
      aux_sym_string_token1,
    ACTIONS(10709), 1,
      anon_sym_Set,
    STATE(7672), 1,
      sym_atom,
    STATE(7700), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    ACTIONS(6224), 3,
      anon_sym_COLON,
      anon_sym_u2984,
      anon_sym_PIPE,
    STATE(7701), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(10683), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [514652] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6647), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6645), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [514696] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6484), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6482), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [514740] = 4,
    ACTIONS(6488), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6490), 4,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(6486), 30,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [514786] = 3,
    ACTIONS(6655), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6653), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [514830] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6484), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6482), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [514874] = 21,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11051), 1,
      sym_id,
    ACTIONS(11053), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11057), 1,
      anon_sym_record,
    ACTIONS(11059), 1,
      anon_sym_LPAREN,
    ACTIONS(11061), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11063), 1,
      anon_sym_u2983,
    ACTIONS(11065), 1,
      anon_sym_LBRACE,
    ACTIONS(11067), 1,
      aux_sym__qid_token1,
    ACTIONS(11069), 1,
      anon_sym_DOT,
    ACTIONS(11073), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11075), 1,
      anon_sym_u2987,
    ACTIONS(11077), 1,
      aux_sym_integer_token1,
    ACTIONS(11079), 1,
      aux_sym_string_token1,
    ACTIONS(11081), 1,
      anon_sym_Set,
    STATE(7726), 1,
      sym_atom,
    STATE(7756), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    ACTIONS(6224), 3,
      anon_sym_EQ,
      anon_sym_u2984,
      anon_sym_PIPE,
    STATE(7737), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11055), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [514954] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6750), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6748), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [514998] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6714), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6712), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [515042] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6754), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6752), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [515086] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6651), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6649), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [515130] = 4,
    ACTIONS(6488), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6490), 3,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_u2984,
    ACTIONS(6486), 31,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [515176] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6572), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6570), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [515220] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6568), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6566), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [515264] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6500), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6498), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [515308] = 3,
    ACTIONS(6496), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6494), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [515352] = 4,
    ACTIONS(6488), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6490), 3,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(6486), 31,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [515398] = 3,
    ACTIONS(6326), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6324), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_u2988,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [515442] = 3,
    ACTIONS(6326), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6324), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_PIPE_RPAREN,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [515486] = 4,
    ACTIONS(11224), 1,
      anon_sym_AT,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6326), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6324), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [515532] = 3,
    ACTIONS(6326), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6324), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [515576] = 3,
    ACTIONS(6496), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6494), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_PIPE_RPAREN,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [515620] = 3,
    ACTIONS(6496), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6494), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_u2988,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [515664] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6655), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6653), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [515708] = 22,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6226), 1,
      anon_sym_RBRACE,
    ACTIONS(10289), 1,
      sym_id,
    ACTIONS(10291), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10295), 1,
      anon_sym_record,
    ACTIONS(10297), 1,
      anon_sym_LPAREN,
    ACTIONS(10299), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(10301), 1,
      anon_sym_u2983,
    ACTIONS(10303), 1,
      anon_sym_LBRACE,
    ACTIONS(10305), 1,
      aux_sym__qid_token1,
    ACTIONS(10307), 1,
      anon_sym_DOT,
    ACTIONS(10311), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(10313), 1,
      anon_sym_u2987,
    ACTIONS(10315), 1,
      aux_sym_integer_token1,
    ACTIONS(10317), 1,
      aux_sym_string_token1,
    ACTIONS(10319), 1,
      anon_sym_Set,
    STATE(7803), 1,
      sym_atom,
    ACTIONS(6224), 2,
      anon_sym_EQ,
      anon_sym_PIPE,
    STATE(7770), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7764), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(10293), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [515790] = 3,
    ACTIONS(6655), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6653), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_u2988,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [515834] = 22,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6226), 1,
      sym__newline,
    ACTIONS(10843), 1,
      sym_id,
    ACTIONS(10845), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10849), 1,
      anon_sym_record,
    ACTIONS(10851), 1,
      anon_sym_LPAREN,
    ACTIONS(10853), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(10855), 1,
      anon_sym_u2983,
    ACTIONS(10857), 1,
      anon_sym_LBRACE,
    ACTIONS(10859), 1,
      aux_sym__qid_token1,
    ACTIONS(10861), 1,
      anon_sym_DOT,
    ACTIONS(10865), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(10867), 1,
      anon_sym_u2987,
    ACTIONS(10869), 1,
      aux_sym_integer_token1,
    ACTIONS(10871), 1,
      aux_sym_string_token1,
    ACTIONS(10873), 1,
      anon_sym_Set,
    STATE(7675), 1,
      sym_atom,
    ACTIONS(6224), 2,
      anon_sym_EQ,
      anon_sym_PIPE,
    STATE(7705), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7719), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(10847), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [515916] = 3,
    ACTIONS(6655), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6653), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_PIPE_RPAREN,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [515960] = 3,
    ACTIONS(6500), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6498), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_u2988,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [516004] = 3,
    ACTIONS(6568), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6566), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_u2988,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [516048] = 3,
    ACTIONS(6572), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6570), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_u2988,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [516092] = 3,
    ACTIONS(6647), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6645), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_u2988,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [516136] = 3,
    ACTIONS(6496), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6494), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [516180] = 3,
    ACTIONS(6651), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6649), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_u2988,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [516224] = 3,
    ACTIONS(6754), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6752), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_u2988,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [516268] = 3,
    ACTIONS(6714), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6712), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_u2988,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [516312] = 3,
    ACTIONS(6433), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6431), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_u2988,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [516356] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6496), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6494), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [516400] = 3,
    ACTIONS(6750), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6748), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_u2988,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [516444] = 3,
    ACTIONS(6710), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6708), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_u2988,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [516488] = 5,
    ACTIONS(6488), 1,
      anon_sym_BSLASH,
    ACTIONS(6492), 1,
      sym__newline,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6490), 2,
      anon_sym_EQ,
      anon_sym_SEMI,
    ACTIONS(6486), 31,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [516536] = 3,
    ACTIONS(6655), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6653), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [516580] = 3,
    ACTIONS(6484), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6482), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_u2988,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [516624] = 4,
    ACTIONS(6326), 1,
      anon_sym_BSLASH,
    ACTIONS(11226), 1,
      anon_sym_AT,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6324), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [516670] = 3,
    ACTIONS(6500), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6498), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_PIPE_RPAREN,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [516714] = 22,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6226), 1,
      sym__newline,
    ACTIONS(10206), 1,
      sym_id,
    ACTIONS(10208), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10212), 1,
      anon_sym_record,
    ACTIONS(10214), 1,
      anon_sym_LPAREN,
    ACTIONS(10216), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(10218), 1,
      anon_sym_u2983,
    ACTIONS(10220), 1,
      anon_sym_LBRACE,
    ACTIONS(10222), 1,
      aux_sym__qid_token1,
    ACTIONS(10224), 1,
      anon_sym_DOT,
    ACTIONS(10228), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(10230), 1,
      anon_sym_u2987,
    ACTIONS(10232), 1,
      aux_sym_integer_token1,
    ACTIONS(10234), 1,
      aux_sym_string_token1,
    ACTIONS(10236), 1,
      anon_sym_Set,
    STATE(7692), 1,
      sym_atom,
    ACTIONS(6224), 2,
      anon_sym_SEMI,
      anon_sym_PIPE,
    STATE(7731), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7724), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(10210), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [516796] = 3,
    ACTIONS(6568), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6566), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_PIPE_RPAREN,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [516840] = 3,
    ACTIONS(6572), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6570), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_PIPE_RPAREN,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [516884] = 3,
    ACTIONS(6326), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6324), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [516928] = 3,
    ACTIONS(6647), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6645), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_PIPE_RPAREN,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [516972] = 3,
    ACTIONS(6484), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6482), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [517016] = 3,
    ACTIONS(6651), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6649), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_PIPE_RPAREN,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [517060] = 3,
    ACTIONS(6496), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6494), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [517104] = 3,
    ACTIONS(6754), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6752), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_PIPE_RPAREN,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [517148] = 3,
    ACTIONS(6710), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6708), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [517192] = 3,
    ACTIONS(6750), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6748), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [517236] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6326), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6324), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [517280] = 4,
    ACTIONS(6326), 1,
      anon_sym_BSLASH,
    ACTIONS(11228), 1,
      anon_sym_AT,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6324), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [517326] = 4,
    ACTIONS(6488), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6490), 2,
      anon_sym_EQ,
      anon_sym_where,
    ACTIONS(6486), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [517372] = 3,
    ACTIONS(6433), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6431), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [517416] = 3,
    ACTIONS(6714), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6712), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_PIPE_RPAREN,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [517460] = 3,
    ACTIONS(6714), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6712), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [517504] = 3,
    ACTIONS(6754), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6752), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [517548] = 3,
    ACTIONS(6500), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6498), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [517592] = 3,
    ACTIONS(6433), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6431), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_PIPE_RPAREN,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [517636] = 3,
    ACTIONS(6568), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6566), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [517680] = 3,
    ACTIONS(6572), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6570), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [517724] = 3,
    ACTIONS(6647), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6645), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [517768] = 3,
    ACTIONS(6651), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6649), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [517812] = 3,
    ACTIONS(6651), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6649), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [517856] = 3,
    ACTIONS(6754), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6752), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [517900] = 3,
    ACTIONS(6647), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6645), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [517944] = 3,
    ACTIONS(6714), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6712), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [517988] = 3,
    ACTIONS(6572), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6570), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [518032] = 3,
    ACTIONS(6433), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6431), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [518076] = 3,
    ACTIONS(6750), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6748), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [518120] = 3,
    ACTIONS(6710), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6708), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [518164] = 3,
    ACTIONS(6568), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6566), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [518208] = 3,
    ACTIONS(6500), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6498), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [518252] = 3,
    ACTIONS(6484), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6482), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [518296] = 3,
    ACTIONS(6750), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6748), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_PIPE_RPAREN,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [518340] = 3,
    ACTIONS(6710), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6708), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_PIPE_RPAREN,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [518384] = 3,
    ACTIONS(6655), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6653), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [518428] = 3,
    ACTIONS(6484), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6482), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_PIPE_RPAREN,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [518472] = 3,
    ACTIONS(6433), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6431), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [518516] = 3,
    ACTIONS(6496), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6494), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [518560] = 3,
    ACTIONS(6326), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6324), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [518604] = 3,
    ACTIONS(6500), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6498), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [518648] = 3,
    ACTIONS(6568), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6566), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [518692] = 3,
    ACTIONS(6572), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6570), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [518736] = 3,
    ACTIONS(6647), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6645), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [518780] = 3,
    ACTIONS(6651), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6649), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [518824] = 3,
    ACTIONS(6754), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6752), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [518868] = 3,
    ACTIONS(6714), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6712), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [518912] = 3,
    ACTIONS(6750), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6748), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [518956] = 3,
    ACTIONS(6710), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6708), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [519000] = 3,
    ACTIONS(6484), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6482), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [519044] = 4,
    ACTIONS(11230), 1,
      anon_sym_AT,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6326), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6324), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [519090] = 3,
    ACTIONS(6572), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6570), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [519134] = 3,
    ACTIONS(6655), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6653), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [519178] = 4,
    ACTIONS(6326), 1,
      anon_sym_BSLASH,
    ACTIONS(11232), 1,
      anon_sym_AT,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6324), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [519224] = 3,
    ACTIONS(6326), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6324), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [519268] = 3,
    ACTIONS(6496), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6494), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [519312] = 3,
    ACTIONS(6655), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6653), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [519356] = 3,
    ACTIONS(6500), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6498), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [519400] = 3,
    ACTIONS(6568), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6566), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [519444] = 3,
    ACTIONS(6572), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6570), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [519488] = 3,
    ACTIONS(6651), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6649), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [519532] = 3,
    ACTIONS(6754), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6752), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [519576] = 22,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6226), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(11019), 1,
      sym_id,
    ACTIONS(11021), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11025), 1,
      anon_sym_record,
    ACTIONS(11027), 1,
      anon_sym_LPAREN,
    ACTIONS(11029), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11031), 1,
      anon_sym_u2983,
    ACTIONS(11033), 1,
      anon_sym_LBRACE,
    ACTIONS(11035), 1,
      aux_sym__qid_token1,
    ACTIONS(11037), 1,
      anon_sym_DOT,
    ACTIONS(11041), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11043), 1,
      anon_sym_u2987,
    ACTIONS(11045), 1,
      aux_sym_integer_token1,
    ACTIONS(11047), 1,
      aux_sym_string_token1,
    ACTIONS(11049), 1,
      anon_sym_Set,
    STATE(7707), 1,
      sym_atom,
    ACTIONS(6224), 2,
      anon_sym_EQ,
      anon_sym_PIPE,
    STATE(7686), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7699), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11023), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [519658] = 3,
    ACTIONS(6714), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6712), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [519702] = 3,
    ACTIONS(6750), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6748), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [519746] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6484), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6482), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [519790] = 3,
    ACTIONS(6484), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6482), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [519834] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6710), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6708), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [519878] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6750), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6748), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [519922] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6433), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6431), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [519966] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6714), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6712), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [520010] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6754), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6752), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [520054] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6647), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6645), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [520098] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6572), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6570), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [520142] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6568), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6566), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [520186] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6500), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6498), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [520230] = 3,
    ACTIONS(6647), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6645), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [520274] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6496), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6494), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [520318] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6326), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6324), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [520362] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6655), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6653), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [520406] = 3,
    ACTIONS(6433), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6431), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [520450] = 3,
    ACTIONS(6710), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6708), 34,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [520494] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6655), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6653), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [520538] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6326), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6324), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [520582] = 4,
    ACTIONS(6326), 1,
      anon_sym_BSLASH,
    ACTIONS(11234), 1,
      anon_sym_AT,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6324), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [520628] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6496), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6494), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [520672] = 4,
    ACTIONS(6488), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6490), 3,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_u2988,
    ACTIONS(6486), 31,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [520718] = 4,
    ACTIONS(6488), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6490), 3,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_PIPE_RPAREN,
    ACTIONS(6486), 31,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [520764] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6500), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6498), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [520808] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6568), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6566), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [520852] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6572), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6570), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [520896] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6647), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6645), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [520940] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6651), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6649), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [520984] = 22,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6336), 1,
      anon_sym_SEMI,
    ACTIONS(10379), 1,
      sym_id,
    ACTIONS(10381), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10385), 1,
      anon_sym_record,
    ACTIONS(10387), 1,
      anon_sym_LPAREN,
    ACTIONS(10389), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(10391), 1,
      anon_sym_u2983,
    ACTIONS(10393), 1,
      anon_sym_LBRACE,
    ACTIONS(10395), 1,
      aux_sym__qid_token1,
    ACTIONS(10397), 1,
      anon_sym_DOT,
    ACTIONS(10401), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(10403), 1,
      anon_sym_u2987,
    ACTIONS(10405), 1,
      aux_sym_integer_token1,
    ACTIONS(10407), 1,
      aux_sym_string_token1,
    ACTIONS(10409), 1,
      anon_sym_Set,
    ACTIONS(11236), 1,
      anon_sym_PIPE,
    STATE(4943), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7690), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7735), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(10383), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [521066] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6754), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6752), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [521110] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6484), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6482), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [521154] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6714), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6712), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [521198] = 4,
    ACTIONS(6326), 1,
      anon_sym_BSLASH,
    ACTIONS(11238), 1,
      anon_sym_AT,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6324), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [521244] = 21,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(10985), 1,
      sym_id,
    ACTIONS(10987), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10991), 1,
      anon_sym_record,
    ACTIONS(10993), 1,
      anon_sym_LPAREN,
    ACTIONS(10995), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(10997), 1,
      anon_sym_u2983,
    ACTIONS(10999), 1,
      anon_sym_LBRACE,
    ACTIONS(11001), 1,
      aux_sym__qid_token1,
    ACTIONS(11003), 1,
      anon_sym_DOT,
    ACTIONS(11007), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11009), 1,
      anon_sym_u2987,
    ACTIONS(11011), 1,
      aux_sym_integer_token1,
    ACTIONS(11013), 1,
      aux_sym_string_token1,
    ACTIONS(11015), 1,
      anon_sym_Set,
    STATE(7805), 1,
      sym_atom,
    STATE(7784), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    ACTIONS(6224), 3,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_u2988,
    STATE(7798), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(10989), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [521324] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6433), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6431), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [521368] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6750), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6748), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [521412] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6710), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6708), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [521456] = 4,
    ACTIONS(6488), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6490), 3,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_u2984,
    ACTIONS(6486), 31,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [521502] = 3,
    ACTIONS(6651), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6649), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [521545] = 3,
    ACTIONS(6484), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6482), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [521588] = 3,
    ACTIONS(6710), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6708), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [521631] = 3,
    ACTIONS(6433), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6431), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [521674] = 3,
    ACTIONS(6714), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6712), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [521717] = 3,
    ACTIONS(6754), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6752), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [521760] = 3,
    ACTIONS(6651), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6649), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [521803] = 3,
    ACTIONS(6647), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6645), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [521846] = 3,
    ACTIONS(6572), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6570), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [521889] = 3,
    ACTIONS(6568), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6566), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [521932] = 4,
    ACTIONS(6326), 1,
      anon_sym_BSLASH,
    ACTIONS(11240), 1,
      anon_sym_AT,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6324), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [521977] = 3,
    ACTIONS(6500), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6498), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [522020] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6326), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6324), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [522063] = 3,
    ACTIONS(6496), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6494), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [522106] = 4,
    ACTIONS(6488), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6490), 3,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_SEMI,
    ACTIONS(6486), 30,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [522151] = 4,
    ACTIONS(6326), 1,
      anon_sym_BSLASH,
    ACTIONS(11242), 1,
      anon_sym_AT,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6324), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [522196] = 4,
    ACTIONS(6488), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6490), 3,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(6486), 30,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [522241] = 3,
    ACTIONS(6484), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6482), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [522284] = 3,
    ACTIONS(6655), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6653), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [522327] = 3,
    ACTIONS(6500), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6498), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [522370] = 3,
    ACTIONS(6568), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6566), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [522413] = 3,
    ACTIONS(6572), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6570), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [522456] = 3,
    ACTIONS(6647), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6645), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [522499] = 3,
    ACTIONS(6651), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6649), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [522542] = 4,
    ACTIONS(6488), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6490), 3,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_u2984,
    ACTIONS(6486), 30,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [522587] = 3,
    ACTIONS(6754), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6752), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [522630] = 3,
    ACTIONS(6714), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6712), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [522673] = 3,
    ACTIONS(6710), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6708), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [522716] = 3,
    ACTIONS(6433), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6431), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [522759] = 3,
    ACTIONS(6750), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6748), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [522802] = 3,
    ACTIONS(6710), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6708), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [522845] = 3,
    ACTIONS(6750), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6748), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [522888] = 3,
    ACTIONS(6484), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6482), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [522931] = 3,
    ACTIONS(6433), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6431), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [522974] = 3,
    ACTIONS(6714), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6712), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [523017] = 3,
    ACTIONS(6754), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6752), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [523060] = 3,
    ACTIONS(6496), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6494), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [523103] = 3,
    ACTIONS(6326), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6324), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [523146] = 3,
    ACTIONS(6651), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6649), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [523189] = 3,
    ACTIONS(6647), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6645), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [523232] = 3,
    ACTIONS(6572), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6570), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [523275] = 3,
    ACTIONS(6568), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6566), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [523318] = 3,
    ACTIONS(6500), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6498), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [523361] = 3,
    ACTIONS(6484), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6482), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [523404] = 3,
    ACTIONS(6710), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6708), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [523447] = 3,
    ACTIONS(6750), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6748), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [523490] = 3,
    ACTIONS(6433), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6431), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [523533] = 3,
    ACTIONS(6714), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6712), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [523576] = 3,
    ACTIONS(6754), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6752), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [523619] = 3,
    ACTIONS(6651), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6649), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [523662] = 3,
    ACTIONS(6647), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6645), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [523705] = 3,
    ACTIONS(6572), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6570), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [523748] = 3,
    ACTIONS(6568), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6566), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [523791] = 3,
    ACTIONS(6500), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6498), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [523834] = 3,
    ACTIONS(6750), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6748), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [523877] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6496), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6494), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [523920] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6655), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6653), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [523963] = 21,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(4238), 1,
      anon_sym_PIPE,
    ACTIONS(11244), 1,
      sym_id,
    ACTIONS(11246), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11250), 1,
      anon_sym_record,
    ACTIONS(11252), 1,
      anon_sym_LPAREN,
    ACTIONS(11254), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11256), 1,
      anon_sym_u2983,
    ACTIONS(11258), 1,
      anon_sym_LBRACE,
    ACTIONS(11260), 1,
      aux_sym__qid_token1,
    ACTIONS(11262), 1,
      anon_sym_DOT,
    ACTIONS(11264), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11266), 1,
      anon_sym_u2987,
    ACTIONS(11268), 1,
      aux_sym_integer_token1,
    ACTIONS(11270), 1,
      aux_sym_string_token1,
    ACTIONS(11272), 1,
      anon_sym_Set,
    STATE(5933), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7835), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7830), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11248), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [524042] = 3,
    ACTIONS(6655), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6653), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [524085] = 3,
    ACTIONS(6496), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6494), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [524128] = 3,
    ACTIONS(6484), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6482), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_PIPE_RPAREN,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [524171] = 3,
    ACTIONS(6655), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6653), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [524214] = 3,
    ACTIONS(6710), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6708), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_PIPE_RPAREN,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [524257] = 3,
    ACTIONS(6750), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6748), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_PIPE_RPAREN,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [524300] = 3,
    ACTIONS(6433), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6431), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_PIPE_RPAREN,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [524343] = 3,
    ACTIONS(6714), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6712), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_PIPE_RPAREN,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [524386] = 3,
    ACTIONS(6754), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6752), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_PIPE_RPAREN,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [524429] = 3,
    ACTIONS(6496), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6494), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [524472] = 3,
    ACTIONS(6651), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6649), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_PIPE_RPAREN,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [524515] = 3,
    ACTIONS(6484), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6482), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [524558] = 3,
    ACTIONS(6710), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6708), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [524601] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6326), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6324), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [524644] = 3,
    ACTIONS(6750), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6748), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [524687] = 3,
    ACTIONS(6433), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6431), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [524730] = 3,
    ACTIONS(6647), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6645), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_PIPE_RPAREN,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [524773] = 3,
    ACTIONS(6714), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6712), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [524816] = 3,
    ACTIONS(6754), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6752), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [524859] = 5,
    ACTIONS(6488), 1,
      anon_sym_BSLASH,
    ACTIONS(6492), 1,
      sym__newline,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6490), 2,
      anon_sym_EQ,
      anon_sym_where,
    ACTIONS(6486), 30,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [524906] = 3,
    ACTIONS(6572), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6570), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_PIPE_RPAREN,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [524949] = 3,
    ACTIONS(6568), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6566), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_PIPE_RPAREN,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [524992] = 4,
    ACTIONS(6326), 1,
      anon_sym_BSLASH,
    ACTIONS(11232), 1,
      anon_sym_AT,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6324), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [525037] = 3,
    ACTIONS(6500), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6498), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_PIPE_RPAREN,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [525080] = 3,
    ACTIONS(6484), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6482), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_u2988,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [525123] = 4,
    ACTIONS(6326), 1,
      anon_sym_BSLASH,
    ACTIONS(11274), 1,
      anon_sym_AT,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6324), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [525168] = 3,
    ACTIONS(6710), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6708), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_u2988,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [525211] = 3,
    ACTIONS(6750), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6748), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_u2988,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [525254] = 3,
    ACTIONS(6433), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6431), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_u2988,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [525297] = 3,
    ACTIONS(6714), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6712), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_u2988,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [525340] = 3,
    ACTIONS(6754), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6752), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_u2988,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [525383] = 3,
    ACTIONS(6651), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6649), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_u2988,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [525426] = 3,
    ACTIONS(6651), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6649), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [525469] = 3,
    ACTIONS(6647), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6645), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_u2988,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [525512] = 3,
    ACTIONS(6572), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6570), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_u2988,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [525555] = 3,
    ACTIONS(6568), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6566), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_u2988,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [525598] = 3,
    ACTIONS(6500), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6498), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_u2988,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [525641] = 5,
    ACTIONS(712), 1,
      anon_sym_AT,
    ACTIONS(11278), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    STATE(5836), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    ACTIONS(11276), 30,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_DASH,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [525688] = 4,
    ACTIONS(6488), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6490), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(6486), 31,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [525733] = 3,
    ACTIONS(6326), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6324), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [525776] = 3,
    ACTIONS(6572), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6570), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [525819] = 4,
    ACTIONS(6326), 1,
      anon_sym_BSLASH,
    ACTIONS(11280), 1,
      anon_sym_AT,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6324), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [525864] = 3,
    ACTIONS(6568), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6566), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [525907] = 5,
    ACTIONS(11284), 1,
      anon_sym_BSLASH,
    ACTIONS(11286), 1,
      anon_sym_AT,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    STATE(5836), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    ACTIONS(11282), 30,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_DASH,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [525954] = 4,
    ACTIONS(6326), 1,
      anon_sym_BSLASH,
    ACTIONS(11238), 1,
      anon_sym_AT,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6324), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [525999] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6484), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6482), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [526042] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6326), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6324), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [526085] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6500), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6498), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [526128] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6568), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6566), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [526171] = 4,
    ACTIONS(10977), 1,
      anon_sym_BSLASH,
    ACTIONS(11289), 1,
      anon_sym_EQ,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(10975), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [526216] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6572), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6570), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [526259] = 3,
    ACTIONS(6326), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6324), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [526302] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6647), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6645), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [526345] = 3,
    ACTIONS(6655), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6653), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_PIPE_RPAREN,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [526388] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6651), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6649), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [526431] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6754), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6752), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [526474] = 3,
    ACTIONS(6500), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6498), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [526517] = 3,
    ACTIONS(6496), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6494), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_PIPE_RPAREN,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [526560] = 3,
    ACTIONS(6496), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6494), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [526603] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6714), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6712), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [526646] = 3,
    ACTIONS(6484), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6482), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [526689] = 3,
    ACTIONS(6710), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6708), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [526732] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6433), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6431), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [526775] = 3,
    ACTIONS(6750), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6748), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [526818] = 3,
    ACTIONS(6433), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6431), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [526861] = 3,
    ACTIONS(6655), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6653), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_u2988,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [526904] = 3,
    ACTIONS(6714), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6712), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [526947] = 3,
    ACTIONS(6754), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6752), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [526990] = 3,
    ACTIONS(6651), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6649), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [527033] = 3,
    ACTIONS(6647), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6645), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [527076] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6496), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6494), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [527119] = 4,
    ACTIONS(6326), 1,
      anon_sym_BSLASH,
    ACTIONS(11291), 1,
      anon_sym_AT,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6324), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [527164] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6655), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6653), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [527207] = 3,
    ACTIONS(6572), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6570), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [527250] = 4,
    ACTIONS(6488), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6490), 3,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RBRACE,
    ACTIONS(6486), 30,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [527295] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6750), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6748), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [527338] = 3,
    ACTIONS(6496), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6494), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_u2988,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [527381] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6710), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6708), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [527424] = 3,
    ACTIONS(6568), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6566), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [527467] = 5,
    ACTIONS(6488), 1,
      anon_sym_BSLASH,
    ACTIONS(6492), 1,
      sym__newline,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6490), 2,
      anon_sym_EQ,
      anon_sym_SEMI,
    ACTIONS(6486), 30,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [527514] = 3,
    ACTIONS(6326), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6324), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [527557] = 3,
    ACTIONS(6655), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6653), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [527600] = 4,
    ACTIONS(10977), 1,
      anon_sym_BSLASH,
    ACTIONS(11289), 1,
      anon_sym_EQ,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(10975), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [527645] = 3,
    ACTIONS(6326), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6324), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [527688] = 3,
    ACTIONS(6500), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6498), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [527731] = 3,
    ACTIONS(6655), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6653), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [527774] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6496), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6494), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [527817] = 3,
    ACTIONS(6500), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6498), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [527860] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6655), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6653), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [527903] = 3,
    ACTIONS(6568), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6566), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [527946] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6500), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6498), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [527989] = 3,
    ACTIONS(6326), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6324), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [528032] = 4,
    ACTIONS(11293), 1,
      anon_sym_AT,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6326), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6324), 31,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [528077] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6500), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6498), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [528120] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6568), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6566), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [528163] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6572), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6570), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [528206] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6568), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6566), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [528249] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6647), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6645), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [528292] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6651), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6649), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [528335] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6754), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6752), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [528378] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6714), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6712), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [528421] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6572), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6570), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [528464] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6433), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6431), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [528507] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6647), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6645), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [528550] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6750), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6748), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [528593] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6710), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6708), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [528636] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6484), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6482), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [528679] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6651), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6649), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [528722] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6754), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6752), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [528765] = 3,
    ACTIONS(6655), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6653), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [528808] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6714), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6712), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [528851] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6433), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6431), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [528894] = 3,
    ACTIONS(6496), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6494), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [528937] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6750), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6748), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [528980] = 4,
    ACTIONS(11295), 1,
      anon_sym_AT,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6326), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6324), 31,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [529025] = 3,
    ACTIONS(6655), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6653), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [529068] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6710), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6708), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [529111] = 3,
    ACTIONS(6496), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6494), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [529154] = 3,
    ACTIONS(6572), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6570), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [529197] = 4,
    ACTIONS(6326), 1,
      anon_sym_BSLASH,
    ACTIONS(11297), 1,
      anon_sym_AT,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6324), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_u2988,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [529242] = 3,
    ACTIONS(6326), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6324), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_PIPE_RPAREN,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [529285] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6484), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6482), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_in,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [529328] = 3,
    ACTIONS(6326), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6324), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_u2988,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [529371] = 4,
    ACTIONS(6488), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6490), 3,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(6486), 30,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [529416] = 3,
    ACTIONS(6326), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6324), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [529459] = 3,
    ACTIONS(6647), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6645), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [529502] = 3,
    ACTIONS(6651), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6649), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [529545] = 3,
    ACTIONS(6754), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6752), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [529588] = 3,
    ACTIONS(6714), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6712), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [529631] = 3,
    ACTIONS(6433), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6431), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [529674] = 3,
    ACTIONS(6750), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6748), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [529717] = 3,
    ACTIONS(6710), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6708), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [529760] = 3,
    ACTIONS(6484), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6482), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [529803] = 3,
    ACTIONS(6484), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6482), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [529846] = 4,
    ACTIONS(6488), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6490), 3,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(6486), 30,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [529891] = 3,
    ACTIONS(6710), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6708), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [529934] = 3,
    ACTIONS(6750), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6748), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [529977] = 3,
    ACTIONS(6433), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6431), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [530020] = 3,
    ACTIONS(6714), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6712), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [530063] = 3,
    ACTIONS(6754), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6752), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [530106] = 21,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6239), 1,
      anon_sym_PIPE,
    ACTIONS(11299), 1,
      sym_id,
    ACTIONS(11302), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11308), 1,
      anon_sym_record,
    ACTIONS(11311), 1,
      anon_sym_LPAREN,
    ACTIONS(11314), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11317), 1,
      anon_sym_u2983,
    ACTIONS(11320), 1,
      anon_sym_LBRACE,
    ACTIONS(11323), 1,
      aux_sym__qid_token1,
    ACTIONS(11326), 1,
      anon_sym_DOT,
    ACTIONS(11329), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11332), 1,
      anon_sym_u2987,
    ACTIONS(11335), 1,
      aux_sym_integer_token1,
    ACTIONS(11338), 1,
      aux_sym_string_token1,
    ACTIONS(11341), 1,
      anon_sym_Set,
    STATE(5933), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7835), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7830), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11305), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [530185] = 3,
    ACTIONS(6651), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6649), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [530228] = 3,
    ACTIONS(6647), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6645), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [530271] = 3,
    ACTIONS(6572), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6570), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [530314] = 3,
    ACTIONS(6326), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6324), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [530357] = 4,
    ACTIONS(6326), 1,
      anon_sym_BSLASH,
    ACTIONS(11274), 1,
      anon_sym_AT,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6324), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [530402] = 3,
    ACTIONS(6568), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6566), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [530445] = 3,
    ACTIONS(6500), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6498), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [530488] = 3,
    ACTIONS(6710), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6708), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [530531] = 4,
    ACTIONS(6488), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6490), 3,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_u2988,
    ACTIONS(6486), 30,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [530576] = 3,
    ACTIONS(6433), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6431), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [530619] = 5,
    ACTIONS(6488), 1,
      anon_sym_BSLASH,
    ACTIONS(6492), 1,
      sym__newline,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6490), 2,
      anon_sym_EQ,
      anon_sym_in,
    ACTIONS(6486), 30,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [530666] = 3,
    ACTIONS(6326), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6324), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [530709] = 4,
    ACTIONS(6326), 1,
      anon_sym_BSLASH,
    ACTIONS(11344), 1,
      anon_sym_AT,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6324), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_PIPE_RPAREN,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [530754] = 4,
    ACTIONS(6326), 1,
      anon_sym_BSLASH,
    ACTIONS(11346), 1,
      anon_sym_AT,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6324), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [530799] = 4,
    ACTIONS(6488), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6490), 3,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_PIPE_RPAREN,
    ACTIONS(6486), 30,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [530844] = 4,
    ACTIONS(6488), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6490), 3,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_u2984,
    ACTIONS(6486), 30,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [530889] = 4,
    ACTIONS(6488), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6490), 3,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(6486), 30,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [530934] = 3,
    ACTIONS(6647), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6645), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [530977] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6710), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6708), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [531020] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6750), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6748), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [531063] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6433), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6431), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [531106] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6714), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6712), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [531149] = 4,
    ACTIONS(6488), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6490), 3,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_u2984,
    ACTIONS(6486), 30,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [531194] = 3,
    ACTIONS(6326), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6324), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [531237] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6754), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6752), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [531280] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6651), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6649), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [531323] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6647), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6645), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [531366] = 3,
    ACTIONS(6655), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6653), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [531409] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6572), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6570), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [531452] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6568), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6566), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [531495] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6500), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6498), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [531538] = 3,
    ACTIONS(6484), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6482), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [531581] = 3,
    ACTIONS(6496), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6494), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [531624] = 5,
    ACTIONS(6488), 1,
      anon_sym_BSLASH,
    ACTIONS(6490), 1,
      anon_sym_SEMI,
    ACTIONS(6492), 1,
      sym__newline,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6486), 31,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [531671] = 3,
    ACTIONS(6326), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6324), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [531714] = 3,
    ACTIONS(6496), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6494), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [531757] = 4,
    ACTIONS(6326), 1,
      anon_sym_BSLASH,
    ACTIONS(11348), 1,
      anon_sym_AT,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6324), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [531802] = 3,
    ACTIONS(6655), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6653), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [531845] = 3,
    ACTIONS(6750), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6748), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [531888] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6655), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6653), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [531931] = 3,
    ACTIONS(6647), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6645), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [531974] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6496), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6494), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [532017] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6484), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6482), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [532060] = 3,
    ACTIONS(6714), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6712), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [532103] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6326), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6324), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [532146] = 3,
    ACTIONS(6754), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6752), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [532189] = 4,
    ACTIONS(6326), 1,
      anon_sym_BSLASH,
    ACTIONS(11350), 1,
      anon_sym_AT,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6324), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [532234] = 3,
    ACTIONS(6484), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6482), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [532277] = 3,
    ACTIONS(6710), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6708), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [532320] = 3,
    ACTIONS(6750), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6748), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [532363] = 3,
    ACTIONS(6433), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6431), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [532406] = 3,
    ACTIONS(6714), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6712), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [532449] = 3,
    ACTIONS(6754), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6752), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [532492] = 3,
    ACTIONS(6651), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6649), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [532535] = 3,
    ACTIONS(6647), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6645), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [532578] = 3,
    ACTIONS(6572), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6570), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [532621] = 3,
    ACTIONS(6568), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6566), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [532664] = 3,
    ACTIONS(6500), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6498), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [532707] = 3,
    ACTIONS(6496), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6494), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [532750] = 3,
    ACTIONS(6326), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6324), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [532793] = 3,
    ACTIONS(6655), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6653), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [532836] = 4,
    ACTIONS(6326), 1,
      anon_sym_BSLASH,
    ACTIONS(11352), 1,
      anon_sym_AT,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6324), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [532881] = 21,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(10119), 1,
      sym_id,
    ACTIONS(10123), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10127), 1,
      anon_sym_record,
    ACTIONS(10129), 1,
      anon_sym_LPAREN,
    ACTIONS(10131), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(10133), 1,
      anon_sym_u2983,
    ACTIONS(10135), 1,
      anon_sym_LBRACE,
    ACTIONS(10137), 1,
      aux_sym__qid_token1,
    ACTIONS(10139), 1,
      anon_sym_DOT,
    ACTIONS(10141), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(10143), 1,
      anon_sym_u2987,
    ACTIONS(10145), 1,
      aux_sym_integer_token1,
    ACTIONS(10147), 1,
      aux_sym_string_token1,
    ACTIONS(10149), 1,
      anon_sym_Set,
    STATE(7817), 1,
      sym_atom,
    ACTIONS(6224), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(7812), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7815), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(10125), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [532960] = 3,
    ACTIONS(6500), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6498), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [533003] = 3,
    ACTIONS(6568), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6566), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [533046] = 3,
    ACTIONS(6572), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6570), 33,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [533089] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6500), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6498), 31,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [533131] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6330), 1,
      sym_id,
    ACTIONS(6332), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6338), 1,
      anon_sym_record,
    ACTIONS(6340), 1,
      anon_sym_LPAREN,
    ACTIONS(6342), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(6344), 1,
      anon_sym_u2983,
    ACTIONS(6346), 1,
      anon_sym_LBRACE,
    ACTIONS(6348), 1,
      aux_sym__qid_token1,
    ACTIONS(6350), 1,
      anon_sym_DOT,
    ACTIONS(6354), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(6356), 1,
      anon_sym_u2987,
    ACTIONS(6358), 1,
      aux_sym_integer_token1,
    ACTIONS(6360), 1,
      aux_sym_string_token1,
    ACTIONS(6362), 1,
      anon_sym_Set,
    STATE(4003), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(6547), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6549), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(6334), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [533207] = 3,
    ACTIONS(6496), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6494), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [533249] = 3,
    ACTIONS(6750), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6748), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [533291] = 3,
    ACTIONS(6496), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6494), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [533333] = 3,
    ACTIONS(6572), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6570), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [533375] = 3,
    ACTIONS(6651), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6649), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [533417] = 3,
    ACTIONS(6484), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6482), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [533459] = 3,
    ACTIONS(6647), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6645), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [533501] = 3,
    ACTIONS(6433), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6431), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [533543] = 3,
    ACTIONS(6710), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6708), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [533585] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(8439), 1,
      sym_id,
    ACTIONS(8441), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8445), 1,
      anon_sym_record,
    ACTIONS(8447), 1,
      anon_sym_LPAREN,
    ACTIONS(8449), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(8451), 1,
      anon_sym_u2983,
    ACTIONS(8453), 1,
      anon_sym_LBRACE,
    ACTIONS(8455), 1,
      aux_sym__qid_token1,
    ACTIONS(8457), 1,
      anon_sym_DOT,
    ACTIONS(8461), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(8463), 1,
      anon_sym_u2987,
    ACTIONS(8465), 1,
      aux_sym_integer_token1,
    ACTIONS(8467), 1,
      aux_sym_string_token1,
    ACTIONS(8469), 1,
      anon_sym_Set,
    STATE(4460), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7331), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7333), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(8443), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [533661] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(10519), 1,
      sym_id,
    ACTIONS(10521), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10525), 1,
      anon_sym_record,
    ACTIONS(10527), 1,
      anon_sym_LPAREN,
    ACTIONS(10529), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(10531), 1,
      anon_sym_u2983,
    ACTIONS(10533), 1,
      anon_sym_LBRACE,
    ACTIONS(10535), 1,
      aux_sym__qid_token1,
    ACTIONS(10537), 1,
      anon_sym_DOT,
    ACTIONS(10541), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(10543), 1,
      anon_sym_u2987,
    ACTIONS(10545), 1,
      aux_sym_integer_token1,
    ACTIONS(10547), 1,
      aux_sym_string_token1,
    ACTIONS(10549), 1,
      anon_sym_Set,
    STATE(5127), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7698), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7681), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(10523), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [533737] = 3,
    ACTIONS(6754), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6752), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [533779] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6326), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6324), 31,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [533821] = 3,
    ACTIONS(6655), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6653), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [533863] = 3,
    ACTIONS(6655), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6653), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [533905] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(10679), 1,
      sym_id,
    ACTIONS(10681), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10685), 1,
      anon_sym_record,
    ACTIONS(10687), 1,
      anon_sym_LPAREN,
    ACTIONS(10689), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(10691), 1,
      anon_sym_u2983,
    ACTIONS(10693), 1,
      anon_sym_LBRACE,
    ACTIONS(10695), 1,
      aux_sym__qid_token1,
    ACTIONS(10697), 1,
      anon_sym_DOT,
    ACTIONS(10701), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(10703), 1,
      anon_sym_u2987,
    ACTIONS(10705), 1,
      aux_sym_integer_token1,
    ACTIONS(10707), 1,
      aux_sym_string_token1,
    ACTIONS(10709), 1,
      anon_sym_Set,
    STATE(5161), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7700), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7701), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(10683), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [533981] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6326), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6324), 31,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [534023] = 3,
    ACTIONS(6568), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6566), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [534065] = 3,
    ACTIONS(6500), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6498), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [534107] = 4,
    ACTIONS(6326), 1,
      anon_sym_BSLASH,
    ACTIONS(11274), 1,
      anon_sym_AT,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6324), 31,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [534151] = 4,
    ACTIONS(6488), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6490), 3,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(6486), 29,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [534195] = 4,
    ACTIONS(6326), 1,
      anon_sym_BSLASH,
    ACTIONS(11240), 1,
      anon_sym_AT,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6324), 31,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [534239] = 3,
    ACTIONS(6655), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6653), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [534281] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(8597), 1,
      sym_id,
    ACTIONS(8599), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8603), 1,
      anon_sym_record,
    ACTIONS(8605), 1,
      anon_sym_LPAREN,
    ACTIONS(8607), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(8609), 1,
      anon_sym_u2983,
    ACTIONS(8611), 1,
      anon_sym_LBRACE,
    ACTIONS(8613), 1,
      aux_sym__qid_token1,
    ACTIONS(8615), 1,
      anon_sym_DOT,
    ACTIONS(8619), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(8621), 1,
      anon_sym_u2987,
    ACTIONS(8623), 1,
      aux_sym_integer_token1,
    ACTIONS(8625), 1,
      aux_sym_string_token1,
    ACTIONS(8627), 1,
      anon_sym_Set,
    STATE(4483), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7406), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7405), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(8601), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [534357] = 3,
    ACTIONS(6710), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6708), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_PIPE_RPAREN,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [534399] = 3,
    ACTIONS(6433), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6431), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_PIPE_RPAREN,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [534441] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(8516), 1,
      sym_id,
    ACTIONS(8518), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8522), 1,
      anon_sym_record,
    ACTIONS(8524), 1,
      anon_sym_LPAREN,
    ACTIONS(8526), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(8528), 1,
      anon_sym_u2983,
    ACTIONS(8530), 1,
      anon_sym_LBRACE,
    ACTIONS(8532), 1,
      aux_sym__qid_token1,
    ACTIONS(8534), 1,
      anon_sym_DOT,
    ACTIONS(8538), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(8540), 1,
      anon_sym_u2987,
    ACTIONS(8542), 1,
      aux_sym_integer_token1,
    ACTIONS(8544), 1,
      aux_sym_string_token1,
    ACTIONS(8546), 1,
      anon_sym_Set,
    STATE(4466), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7201), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7202), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(8520), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [534517] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(7914), 1,
      sym_id,
    ACTIONS(7916), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7920), 1,
      anon_sym_record,
    ACTIONS(7922), 1,
      anon_sym_LPAREN,
    ACTIONS(7924), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(7926), 1,
      anon_sym_u2983,
    ACTIONS(7928), 1,
      anon_sym_LBRACE,
    ACTIONS(7930), 1,
      aux_sym__qid_token1,
    ACTIONS(7932), 1,
      anon_sym_DOT,
    ACTIONS(7936), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(7938), 1,
      anon_sym_u2987,
    ACTIONS(7940), 1,
      aux_sym_integer_token1,
    ACTIONS(7942), 1,
      aux_sym_string_token1,
    ACTIONS(7944), 1,
      anon_sym_Set,
    STATE(4360), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7212), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7249), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(7918), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [534593] = 3,
    ACTIONS(6496), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6494), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [534635] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(9792), 1,
      sym_id,
    ACTIONS(9794), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9798), 1,
      anon_sym_record,
    ACTIONS(9800), 1,
      anon_sym_LPAREN,
    ACTIONS(9802), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(9804), 1,
      anon_sym_u2983,
    ACTIONS(9806), 1,
      anon_sym_LBRACE,
    ACTIONS(9808), 1,
      aux_sym__qid_token1,
    ACTIONS(9810), 1,
      anon_sym_DOT,
    ACTIONS(9814), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(9816), 1,
      anon_sym_u2987,
    ACTIONS(9818), 1,
      aux_sym_integer_token1,
    ACTIONS(9820), 1,
      aux_sym_string_token1,
    ACTIONS(9822), 1,
      anon_sym_Set,
    STATE(4876), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7535), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7536), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(9796), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [534711] = 3,
    ACTIONS(6710), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6708), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [534753] = 3,
    ACTIONS(6750), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6748), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [534795] = 3,
    ACTIONS(6433), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6431), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [534837] = 3,
    ACTIONS(6714), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6712), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [534879] = 3,
    ACTIONS(6500), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6498), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [534921] = 3,
    ACTIONS(6568), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6566), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [534963] = 3,
    ACTIONS(6572), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6570), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [535005] = 3,
    ACTIONS(6647), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6645), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [535047] = 3,
    ACTIONS(6651), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6649), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [535089] = 3,
    ACTIONS(6754), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6752), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [535131] = 3,
    ACTIONS(6754), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6752), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [535173] = 3,
    ACTIONS(6714), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6712), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [535215] = 3,
    ACTIONS(6651), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6649), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [535257] = 3,
    ACTIONS(6433), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6431), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [535299] = 3,
    ACTIONS(6750), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6748), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [535341] = 3,
    ACTIONS(6710), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6708), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [535383] = 3,
    ACTIONS(6647), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6645), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [535425] = 3,
    ACTIONS(6572), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6570), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [535467] = 3,
    ACTIONS(6484), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6482), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [535509] = 3,
    ACTIONS(6568), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6566), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [535551] = 3,
    ACTIONS(6500), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6498), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [535593] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6484), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6482), 31,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [535635] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(10379), 1,
      sym_id,
    ACTIONS(10381), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10385), 1,
      anon_sym_record,
    ACTIONS(10387), 1,
      anon_sym_LPAREN,
    ACTIONS(10389), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(10391), 1,
      anon_sym_u2983,
    ACTIONS(10393), 1,
      anon_sym_LBRACE,
    ACTIONS(10395), 1,
      aux_sym__qid_token1,
    ACTIONS(10397), 1,
      anon_sym_DOT,
    ACTIONS(10401), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(10403), 1,
      anon_sym_u2987,
    ACTIONS(10405), 1,
      aux_sym_integer_token1,
    ACTIONS(10407), 1,
      aux_sym_string_token1,
    ACTIONS(10409), 1,
      anon_sym_Set,
    STATE(5050), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7690), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7735), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(10383), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [535711] = 3,
    ACTIONS(6647), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6645), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_PIPE_RPAREN,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [535753] = 3,
    ACTIONS(6655), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6653), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [535795] = 3,
    ACTIONS(6326), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6324), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [535837] = 3,
    ACTIONS(6496), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6494), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [535879] = 3,
    ACTIONS(6484), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6482), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [535921] = 3,
    ACTIONS(6484), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6482), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_PIPE_RPAREN,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [535963] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(7364), 1,
      sym_id,
    ACTIONS(7366), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7370), 1,
      anon_sym_record,
    ACTIONS(7372), 1,
      anon_sym_LPAREN,
    ACTIONS(7374), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(7376), 1,
      anon_sym_u2983,
    ACTIONS(7378), 1,
      anon_sym_LBRACE,
    ACTIONS(7380), 1,
      aux_sym__qid_token1,
    ACTIONS(7382), 1,
      anon_sym_DOT,
    ACTIONS(7386), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(7388), 1,
      anon_sym_u2987,
    ACTIONS(7390), 1,
      aux_sym_integer_token1,
    ACTIONS(7392), 1,
      aux_sym_string_token1,
    ACTIONS(7394), 1,
      anon_sym_Set,
    STATE(4156), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7162), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7144), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(7368), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [536039] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(8405), 1,
      sym_id,
    ACTIONS(8407), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8411), 1,
      anon_sym_record,
    ACTIONS(8413), 1,
      anon_sym_LPAREN,
    ACTIONS(8415), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(8417), 1,
      anon_sym_u2983,
    ACTIONS(8419), 1,
      anon_sym_LBRACE,
    ACTIONS(8421), 1,
      aux_sym__qid_token1,
    ACTIONS(8423), 1,
      anon_sym_DOT,
    ACTIONS(8427), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(8429), 1,
      anon_sym_u2987,
    ACTIONS(8431), 1,
      aux_sym_integer_token1,
    ACTIONS(8433), 1,
      aux_sym_string_token1,
    ACTIONS(8435), 1,
      anon_sym_Set,
    STATE(4433), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7446), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7448), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(8409), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [536115] = 3,
    ACTIONS(6750), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6748), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_PIPE_RPAREN,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [536157] = 3,
    ACTIONS(6500), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6498), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [536199] = 3,
    ACTIONS(6568), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6566), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [536241] = 3,
    ACTIONS(6326), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6324), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [536283] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6496), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6494), 31,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [536325] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6655), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6653), 31,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [536367] = 3,
    ACTIONS(6572), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6570), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [536409] = 3,
    ACTIONS(6326), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6324), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [536451] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(8247), 1,
      sym_id,
    ACTIONS(8249), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8253), 1,
      anon_sym_record,
    ACTIONS(8255), 1,
      anon_sym_LPAREN,
    ACTIONS(8257), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(8259), 1,
      anon_sym_u2983,
    ACTIONS(8261), 1,
      anon_sym_LBRACE,
    ACTIONS(8263), 1,
      aux_sym__qid_token1,
    ACTIONS(8265), 1,
      anon_sym_DOT,
    ACTIONS(8269), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(8271), 1,
      anon_sym_u2987,
    ACTIONS(8273), 1,
      aux_sym_integer_token1,
    ACTIONS(8275), 1,
      aux_sym_string_token1,
    ACTIONS(8277), 1,
      anon_sym_Set,
    STATE(4423), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7320), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7319), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(8251), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [536527] = 4,
    ACTIONS(6488), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6490), 2,
      anon_sym_EQ,
      anon_sym_u2988,
    ACTIONS(6486), 30,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [536571] = 3,
    ACTIONS(6714), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6712), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_PIPE_RPAREN,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [536613] = 3,
    ACTIONS(6647), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6645), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [536655] = 4,
    ACTIONS(6488), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6490), 2,
      anon_sym_EQ,
      anon_sym_PIPE_RPAREN,
    ACTIONS(6486), 30,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [536699] = 3,
    ACTIONS(6651), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6649), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [536741] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(9321), 1,
      sym_id,
    ACTIONS(9323), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9327), 1,
      anon_sym_record,
    ACTIONS(9329), 1,
      anon_sym_LPAREN,
    ACTIONS(9331), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(9333), 1,
      anon_sym_u2983,
    ACTIONS(9335), 1,
      anon_sym_LBRACE,
    ACTIONS(9337), 1,
      aux_sym__qid_token1,
    ACTIONS(9339), 1,
      anon_sym_DOT,
    ACTIONS(9343), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(9345), 1,
      anon_sym_u2987,
    ACTIONS(9347), 1,
      aux_sym_integer_token1,
    ACTIONS(9349), 1,
      aux_sym_string_token1,
    ACTIONS(9351), 1,
      anon_sym_Set,
    STATE(4776), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7442), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7445), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(9325), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [536817] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6840), 1,
      sym_id,
    ACTIONS(6842), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6846), 1,
      anon_sym_record,
    ACTIONS(6848), 1,
      anon_sym_LPAREN,
    ACTIONS(6850), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(6852), 1,
      anon_sym_u2983,
    ACTIONS(6854), 1,
      anon_sym_LBRACE,
    ACTIONS(6856), 1,
      aux_sym__qid_token1,
    ACTIONS(6858), 1,
      anon_sym_DOT,
    ACTIONS(6862), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(6864), 1,
      anon_sym_u2987,
    ACTIONS(6866), 1,
      aux_sym_integer_token1,
    ACTIONS(6868), 1,
      aux_sym_string_token1,
    ACTIONS(6870), 1,
      anon_sym_Set,
    STATE(4046), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7069), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7066), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(6844), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [536893] = 3,
    ACTIONS(6754), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6752), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [536935] = 3,
    ACTIONS(6714), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6712), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [536977] = 4,
    ACTIONS(6488), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6490), 2,
      anon_sym_EQ,
      anon_sym_u2984,
    ACTIONS(6486), 30,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [537021] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(10337), 1,
      sym_id,
    ACTIONS(10339), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10343), 1,
      anon_sym_record,
    ACTIONS(10345), 1,
      anon_sym_LPAREN,
    ACTIONS(10347), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(10349), 1,
      anon_sym_u2983,
    ACTIONS(10351), 1,
      anon_sym_LBRACE,
    ACTIONS(10353), 1,
      aux_sym__qid_token1,
    ACTIONS(10355), 1,
      anon_sym_DOT,
    ACTIONS(10359), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(10361), 1,
      anon_sym_u2987,
    ACTIONS(10363), 1,
      aux_sym_integer_token1,
    ACTIONS(10365), 1,
      aux_sym_string_token1,
    ACTIONS(10367), 1,
      anon_sym_Set,
    STATE(5016), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7712), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7709), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(10341), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [537097] = 3,
    ACTIONS(6754), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6752), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_PIPE_RPAREN,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [537139] = 4,
    ACTIONS(10977), 1,
      anon_sym_BSLASH,
    ACTIONS(10979), 1,
      anon_sym_EQ,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(10975), 31,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [537183] = 3,
    ACTIONS(6433), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6431), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [537225] = 3,
    ACTIONS(6750), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6748), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [537267] = 3,
    ACTIONS(6710), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6708), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [537309] = 3,
    ACTIONS(6651), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6649), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_PIPE_RPAREN,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [537351] = 3,
    ACTIONS(6484), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6482), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [537393] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6502), 1,
      sym_id,
    ACTIONS(6504), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6508), 1,
      anon_sym_record,
    ACTIONS(6510), 1,
      anon_sym_LPAREN,
    ACTIONS(6512), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(6514), 1,
      anon_sym_u2983,
    ACTIONS(6516), 1,
      anon_sym_LBRACE,
    ACTIONS(6518), 1,
      aux_sym__qid_token1,
    ACTIONS(6520), 1,
      anon_sym_DOT,
    ACTIONS(6524), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(6526), 1,
      anon_sym_u2987,
    ACTIONS(6528), 1,
      aux_sym_integer_token1,
    ACTIONS(6530), 1,
      aux_sym_string_token1,
    ACTIONS(6532), 1,
      anon_sym_Set,
    STATE(4017), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(6850), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6851), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(6506), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [537469] = 3,
    ACTIONS(6326), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6324), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [537511] = 3,
    ACTIONS(6572), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6570), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_PIPE_RPAREN,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [537553] = 3,
    ACTIONS(6568), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6566), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_PIPE_RPAREN,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [537595] = 3,
    ACTIONS(6500), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6498), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_PIPE_RPAREN,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [537637] = 4,
    ACTIONS(6488), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6490), 2,
      anon_sym_COLON,
      anon_sym_u2984,
    ACTIONS(6486), 30,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [537681] = 3,
    ACTIONS(6710), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6708), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_u2988,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [537723] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(7535), 1,
      sym_id,
    ACTIONS(7537), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7541), 1,
      anon_sym_record,
    ACTIONS(7543), 1,
      anon_sym_LPAREN,
    ACTIONS(7545), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(7547), 1,
      anon_sym_u2983,
    ACTIONS(7549), 1,
      anon_sym_LBRACE,
    ACTIONS(7551), 1,
      aux_sym__qid_token1,
    ACTIONS(7553), 1,
      anon_sym_DOT,
    ACTIONS(7557), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(7559), 1,
      anon_sym_u2987,
    ACTIONS(7561), 1,
      aux_sym_integer_token1,
    ACTIONS(7563), 1,
      aux_sym_string_token1,
    ACTIONS(7565), 1,
      anon_sym_Set,
    STATE(4186), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7129), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7130), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(7539), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [537799] = 3,
    ACTIONS(6433), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6431), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_u2988,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [537841] = 3,
    ACTIONS(6647), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6645), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_u2988,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [537883] = 3,
    ACTIONS(6484), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6482), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_u2988,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [537925] = 3,
    ACTIONS(6655), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6653), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_PIPE_RPAREN,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [537967] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(7099), 1,
      sym_id,
    ACTIONS(7101), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7105), 1,
      anon_sym_record,
    ACTIONS(7107), 1,
      anon_sym_LPAREN,
    ACTIONS(7109), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(7111), 1,
      anon_sym_u2983,
    ACTIONS(7113), 1,
      anon_sym_LBRACE,
    ACTIONS(7115), 1,
      aux_sym__qid_token1,
    ACTIONS(7117), 1,
      anon_sym_DOT,
    ACTIONS(7121), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(7123), 1,
      anon_sym_u2987,
    ACTIONS(7125), 1,
      aux_sym_integer_token1,
    ACTIONS(7127), 1,
      aux_sym_string_token1,
    ACTIONS(7129), 1,
      anon_sym_Set,
    STATE(4077), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(6905), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6865), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(7103), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [538043] = 3,
    ACTIONS(6750), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6748), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_u2988,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [538085] = 3,
    ACTIONS(6714), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6712), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_u2988,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [538127] = 3,
    ACTIONS(6754), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6752), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_u2988,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [538169] = 3,
    ACTIONS(6496), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6494), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_PIPE_RPAREN,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [538211] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6496), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6494), 31,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [538253] = 3,
    ACTIONS(6651), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6649), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_u2988,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [538295] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6655), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6653), 31,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [538337] = 3,
    ACTIONS(6326), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6324), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [538379] = 3,
    ACTIONS(6496), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6494), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [538421] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(8123), 1,
      sym_id,
    ACTIONS(8125), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8129), 1,
      anon_sym_record,
    ACTIONS(8131), 1,
      anon_sym_LPAREN,
    ACTIONS(8133), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(8135), 1,
      anon_sym_u2983,
    ACTIONS(8137), 1,
      anon_sym_LBRACE,
    ACTIONS(8139), 1,
      aux_sym__qid_token1,
    ACTIONS(8141), 1,
      anon_sym_DOT,
    ACTIONS(8145), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(8147), 1,
      anon_sym_u2987,
    ACTIONS(8149), 1,
      aux_sym_integer_token1,
    ACTIONS(8151), 1,
      aux_sym_string_token1,
    ACTIONS(8153), 1,
      anon_sym_Set,
    STATE(4410), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7213), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7209), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(8127), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [538497] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(10206), 1,
      sym_id,
    ACTIONS(10208), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10212), 1,
      anon_sym_record,
    ACTIONS(10214), 1,
      anon_sym_LPAREN,
    ACTIONS(10216), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(10218), 1,
      anon_sym_u2983,
    ACTIONS(10220), 1,
      anon_sym_LBRACE,
    ACTIONS(10222), 1,
      aux_sym__qid_token1,
    ACTIONS(10224), 1,
      anon_sym_DOT,
    ACTIONS(10228), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(10230), 1,
      anon_sym_u2987,
    ACTIONS(10232), 1,
      aux_sym_integer_token1,
    ACTIONS(10234), 1,
      aux_sym_string_token1,
    ACTIONS(10236), 1,
      anon_sym_Set,
    STATE(4964), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7731), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7724), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(10210), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [538573] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(7880), 1,
      sym_id,
    ACTIONS(7882), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7886), 1,
      anon_sym_record,
    ACTIONS(7888), 1,
      anon_sym_LPAREN,
    ACTIONS(7890), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(7892), 1,
      anon_sym_u2983,
    ACTIONS(7894), 1,
      anon_sym_LBRACE,
    ACTIONS(7896), 1,
      aux_sym__qid_token1,
    ACTIONS(7898), 1,
      anon_sym_DOT,
    ACTIONS(7902), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(7904), 1,
      anon_sym_u2987,
    ACTIONS(7906), 1,
      aux_sym_integer_token1,
    ACTIONS(7908), 1,
      aux_sym_string_token1,
    ACTIONS(7910), 1,
      anon_sym_Set,
    STATE(4356), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7276), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7267), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(7884), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [538649] = 3,
    ACTIONS(6655), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6653), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [538691] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6568), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6566), 31,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [538733] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6572), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6570), 31,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [538775] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6647), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6645), 31,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [538817] = 5,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11354), 1,
      anon_sym_AT,
    ACTIONS(6326), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6324), 27,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [538863] = 4,
    ACTIONS(6488), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6490), 2,
      anon_sym_COLON,
      anon_sym_RBRACE,
    ACTIONS(6486), 30,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [538907] = 4,
    ACTIONS(10977), 1,
      anon_sym_BSLASH,
    ACTIONS(11289), 1,
      anon_sym_EQ,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(10975), 31,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [538951] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6651), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6649), 31,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [538993] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(10719), 1,
      sym_id,
    ACTIONS(10721), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10725), 1,
      anon_sym_record,
    ACTIONS(10727), 1,
      anon_sym_LPAREN,
    ACTIONS(10729), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(10731), 1,
      anon_sym_u2983,
    ACTIONS(10733), 1,
      anon_sym_LBRACE,
    ACTIONS(10735), 1,
      aux_sym__qid_token1,
    ACTIONS(10737), 1,
      anon_sym_DOT,
    ACTIONS(10741), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(10743), 1,
      anon_sym_u2987,
    ACTIONS(10745), 1,
      aux_sym_integer_token1,
    ACTIONS(10747), 1,
      aux_sym_string_token1,
    ACTIONS(10749), 1,
      anon_sym_Set,
    STATE(5177), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7641), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7631), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(10723), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [539069] = 3,
    ACTIONS(6710), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6708), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [539111] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6754), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6752), 31,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [539153] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6714), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6712), 31,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [539195] = 3,
    ACTIONS(6750), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6748), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [539237] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6433), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6431), 31,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [539279] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6750), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6748), 31,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [539321] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6710), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6708), 31,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [539363] = 21,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6224), 1,
      anon_sym_PIPE,
    ACTIONS(11244), 1,
      sym_id,
    ACTIONS(11246), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11250), 1,
      anon_sym_record,
    ACTIONS(11252), 1,
      anon_sym_LPAREN,
    ACTIONS(11254), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11256), 1,
      anon_sym_u2983,
    ACTIONS(11258), 1,
      anon_sym_LBRACE,
    ACTIONS(11260), 1,
      aux_sym__qid_token1,
    ACTIONS(11262), 1,
      anon_sym_DOT,
    ACTIONS(11264), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11266), 1,
      anon_sym_u2987,
    ACTIONS(11268), 1,
      aux_sym_integer_token1,
    ACTIONS(11270), 1,
      aux_sym_string_token1,
    ACTIONS(11272), 1,
      anon_sym_Set,
    STATE(7840), 1,
      sym_atom,
    STATE(7835), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7830), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11248), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [539441] = 3,
    ACTIONS(6572), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6570), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_u2988,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [539483] = 3,
    ACTIONS(6433), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6431), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [539525] = 3,
    ACTIONS(6714), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6712), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [539567] = 3,
    ACTIONS(6754), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6752), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [539609] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(8955), 1,
      sym_id,
    ACTIONS(8957), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8961), 1,
      anon_sym_record,
    ACTIONS(8963), 1,
      anon_sym_LPAREN,
    ACTIONS(8965), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(8967), 1,
      anon_sym_u2983,
    ACTIONS(8969), 1,
      anon_sym_LBRACE,
    ACTIONS(8971), 1,
      aux_sym__qid_token1,
    ACTIONS(8973), 1,
      anon_sym_DOT,
    ACTIONS(8977), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(8979), 1,
      anon_sym_u2987,
    ACTIONS(8981), 1,
      aux_sym_integer_token1,
    ACTIONS(8983), 1,
      aux_sym_string_token1,
    ACTIONS(8985), 1,
      anon_sym_Set,
    STATE(4625), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7468), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7497), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(8959), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [539685] = 4,
    ACTIONS(6488), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6490), 2,
      anon_sym_EQ,
      anon_sym_where,
    ACTIONS(6486), 30,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [539729] = 3,
    ACTIONS(6651), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6649), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [539771] = 3,
    ACTIONS(6568), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6566), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_u2988,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [539813] = 3,
    ACTIONS(6647), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6645), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [539855] = 3,
    ACTIONS(6572), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6570), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [539897] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(9398), 1,
      sym_id,
    ACTIONS(9400), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9404), 1,
      anon_sym_record,
    ACTIONS(9406), 1,
      anon_sym_LPAREN,
    ACTIONS(9408), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(9410), 1,
      anon_sym_u2983,
    ACTIONS(9412), 1,
      anon_sym_LBRACE,
    ACTIONS(9414), 1,
      aux_sym__qid_token1,
    ACTIONS(9416), 1,
      anon_sym_DOT,
    ACTIONS(9420), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(9422), 1,
      anon_sym_u2987,
    ACTIONS(9424), 1,
      aux_sym_integer_token1,
    ACTIONS(9426), 1,
      aux_sym_string_token1,
    ACTIONS(9428), 1,
      anon_sym_Set,
    STATE(4778), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7502), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7501), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(9402), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [539973] = 3,
    ACTIONS(6500), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6498), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [540015] = 3,
    ACTIONS(6568), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6566), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [540057] = 3,
    ACTIONS(6568), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6566), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [540099] = 3,
    ACTIONS(6500), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6498), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [540141] = 3,
    ACTIONS(6326), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6324), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [540183] = 3,
    ACTIONS(6572), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6570), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [540225] = 3,
    ACTIONS(6647), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6645), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [540267] = 3,
    ACTIONS(6651), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6649), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [540309] = 3,
    ACTIONS(6496), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6494), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [540351] = 3,
    ACTIONS(6754), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6752), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [540393] = 3,
    ACTIONS(6714), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6712), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [540435] = 3,
    ACTIONS(6433), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6431), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [540477] = 3,
    ACTIONS(6714), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6712), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [540519] = 3,
    ACTIONS(6750), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6748), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [540561] = 3,
    ACTIONS(6710), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6708), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [540603] = 3,
    ACTIONS(6326), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6324), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [540645] = 3,
    ACTIONS(6655), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6653), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [540687] = 3,
    ACTIONS(6655), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6653), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [540729] = 3,
    ACTIONS(6484), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6482), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [540771] = 3,
    ACTIONS(6484), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6482), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [540813] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(10006), 1,
      sym_id,
    ACTIONS(10008), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10012), 1,
      anon_sym_record,
    ACTIONS(10014), 1,
      anon_sym_LPAREN,
    ACTIONS(10016), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(10018), 1,
      anon_sym_u2983,
    ACTIONS(10020), 1,
      anon_sym_LBRACE,
    ACTIONS(10022), 1,
      aux_sym__qid_token1,
    ACTIONS(10024), 1,
      anon_sym_DOT,
    ACTIONS(10028), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(10030), 1,
      anon_sym_u2987,
    ACTIONS(10032), 1,
      aux_sym_integer_token1,
    ACTIONS(10034), 1,
      aux_sym_string_token1,
    ACTIONS(10036), 1,
      anon_sym_Set,
    STATE(4904), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7489), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7488), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(10010), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [540889] = 3,
    ACTIONS(6326), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6324), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [540931] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(10600), 1,
      sym_id,
    ACTIONS(10602), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10606), 1,
      anon_sym_record,
    ACTIONS(10608), 1,
      anon_sym_LPAREN,
    ACTIONS(10610), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(10612), 1,
      anon_sym_u2983,
    ACTIONS(10614), 1,
      anon_sym_LBRACE,
    ACTIONS(10616), 1,
      aux_sym__qid_token1,
    ACTIONS(10618), 1,
      anon_sym_DOT,
    ACTIONS(10620), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(10622), 1,
      anon_sym_u2987,
    ACTIONS(10624), 1,
      aux_sym_integer_token1,
    ACTIONS(10626), 1,
      aux_sym_string_token1,
    ACTIONS(10628), 1,
      anon_sym_Set,
    STATE(5252), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7582), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7590), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(10604), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [541007] = 3,
    ACTIONS(6710), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6708), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [541049] = 3,
    ACTIONS(6496), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6494), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [541091] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11051), 1,
      sym_id,
    ACTIONS(11053), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11057), 1,
      anon_sym_record,
    ACTIONS(11059), 1,
      anon_sym_LPAREN,
    ACTIONS(11061), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11063), 1,
      anon_sym_u2983,
    ACTIONS(11065), 1,
      anon_sym_LBRACE,
    ACTIONS(11067), 1,
      aux_sym__qid_token1,
    ACTIONS(11069), 1,
      anon_sym_DOT,
    ACTIONS(11073), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11075), 1,
      anon_sym_u2987,
    ACTIONS(11077), 1,
      aux_sym_integer_token1,
    ACTIONS(11079), 1,
      aux_sym_string_token1,
    ACTIONS(11081), 1,
      anon_sym_Set,
    STATE(5239), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7756), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7737), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11055), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [541167] = 3,
    ACTIONS(6484), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6482), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [541209] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6433), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6431), 31,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [541251] = 3,
    ACTIONS(6500), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6498), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [541293] = 3,
    ACTIONS(6568), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6566), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [541335] = 3,
    ACTIONS(6572), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6570), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [541377] = 3,
    ACTIONS(11358), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(11356), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE_DASH_POUND,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [541419] = 3,
    ACTIONS(6647), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6645), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [541461] = 3,
    ACTIONS(6651), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6649), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [541503] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(844), 2,
      sym__dedent,
      anon_sym_BSLASH,
    ACTIONS(11360), 31,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
      anon_sym_AT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [541545] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6534), 1,
      sym_id,
    ACTIONS(6536), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6540), 1,
      anon_sym_record,
    ACTIONS(6542), 1,
      anon_sym_LPAREN,
    ACTIONS(6544), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(6546), 1,
      anon_sym_u2983,
    ACTIONS(6548), 1,
      anon_sym_LBRACE,
    ACTIONS(6550), 1,
      aux_sym__qid_token1,
    ACTIONS(6552), 1,
      anon_sym_DOT,
    ACTIONS(6556), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(6558), 1,
      anon_sym_u2987,
    ACTIONS(6560), 1,
      aux_sym_integer_token1,
    ACTIONS(6562), 1,
      aux_sym_string_token1,
    ACTIONS(6564), 1,
      anon_sym_Set,
    STATE(4018), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(6795), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6796), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(6538), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [541621] = 3,
    ACTIONS(6754), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6752), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [541663] = 3,
    ACTIONS(6714), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6712), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [541705] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(10119), 1,
      sym_id,
    ACTIONS(10123), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10127), 1,
      anon_sym_record,
    ACTIONS(10129), 1,
      anon_sym_LPAREN,
    ACTIONS(10131), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(10133), 1,
      anon_sym_u2983,
    ACTIONS(10135), 1,
      anon_sym_LBRACE,
    ACTIONS(10137), 1,
      aux_sym__qid_token1,
    ACTIONS(10139), 1,
      anon_sym_DOT,
    ACTIONS(10141), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(10143), 1,
      anon_sym_u2987,
    ACTIONS(10145), 1,
      aux_sym_integer_token1,
    ACTIONS(10147), 1,
      aux_sym_string_token1,
    ACTIONS(10149), 1,
      anon_sym_Set,
    STATE(4999), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7812), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7815), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(10125), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [541781] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(10119), 1,
      sym_id,
    ACTIONS(10123), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10127), 1,
      anon_sym_record,
    ACTIONS(10129), 1,
      anon_sym_LPAREN,
    ACTIONS(10131), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(10133), 1,
      anon_sym_u2983,
    ACTIONS(10135), 1,
      anon_sym_LBRACE,
    ACTIONS(10137), 1,
      aux_sym__qid_token1,
    ACTIONS(10139), 1,
      anon_sym_DOT,
    ACTIONS(10141), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(10143), 1,
      anon_sym_u2987,
    ACTIONS(10145), 1,
      aux_sym_integer_token1,
    ACTIONS(10147), 1,
      aux_sym_string_token1,
    ACTIONS(10149), 1,
      anon_sym_Set,
    STATE(5089), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7812), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7815), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(10125), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [541857] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(8516), 1,
      sym_id,
    ACTIONS(8518), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8522), 1,
      anon_sym_record,
    ACTIONS(8524), 1,
      anon_sym_LPAREN,
    ACTIONS(8526), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(8528), 1,
      anon_sym_u2983,
    ACTIONS(8530), 1,
      anon_sym_LBRACE,
    ACTIONS(8532), 1,
      aux_sym__qid_token1,
    ACTIONS(8534), 1,
      anon_sym_DOT,
    ACTIONS(8538), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(8540), 1,
      anon_sym_u2987,
    ACTIONS(8542), 1,
      aux_sym_integer_token1,
    ACTIONS(8544), 1,
      aux_sym_string_token1,
    ACTIONS(8546), 1,
      anon_sym_Set,
    STATE(4574), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7201), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7202), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(8520), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [541933] = 3,
    ACTIONS(6433), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6431), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [541975] = 3,
    ACTIONS(6750), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6748), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [542017] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(8815), 1,
      sym_id,
    ACTIONS(8817), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8821), 1,
      anon_sym_record,
    ACTIONS(8823), 1,
      anon_sym_LPAREN,
    ACTIONS(8825), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(8827), 1,
      anon_sym_u2983,
    ACTIONS(8829), 1,
      anon_sym_LBRACE,
    ACTIONS(8831), 1,
      aux_sym__qid_token1,
    ACTIONS(8833), 1,
      anon_sym_DOT,
    ACTIONS(8837), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(8839), 1,
      anon_sym_u2987,
    ACTIONS(8841), 1,
      aux_sym_integer_token1,
    ACTIONS(8843), 1,
      aux_sym_string_token1,
    ACTIONS(8845), 1,
      anon_sym_Set,
    STATE(4557), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7354), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7353), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(8819), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [542093] = 3,
    ACTIONS(6500), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6498), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_u2988,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [542135] = 3,
    ACTIONS(6484), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6482), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [542177] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(7995), 1,
      sym_id,
    ACTIONS(7997), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8001), 1,
      anon_sym_record,
    ACTIONS(8003), 1,
      anon_sym_LPAREN,
    ACTIONS(8005), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(8007), 1,
      anon_sym_u2983,
    ACTIONS(8009), 1,
      anon_sym_LBRACE,
    ACTIONS(8011), 1,
      aux_sym__qid_token1,
    ACTIONS(8013), 1,
      anon_sym_DOT,
    ACTIONS(8017), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(8019), 1,
      anon_sym_u2987,
    ACTIONS(8021), 1,
      aux_sym_integer_token1,
    ACTIONS(8023), 1,
      aux_sym_string_token1,
    ACTIONS(8025), 1,
      anon_sym_Set,
    STATE(4386), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7226), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7206), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(7999), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [542253] = 3,
    ACTIONS(6326), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6324), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [542295] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6500), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6498), 31,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [542337] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6568), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6566), 31,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [542379] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6572), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6570), 31,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [542421] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(9159), 1,
      sym_id,
    ACTIONS(9161), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9165), 1,
      anon_sym_record,
    ACTIONS(9167), 1,
      anon_sym_LPAREN,
    ACTIONS(9169), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(9171), 1,
      anon_sym_u2983,
    ACTIONS(9173), 1,
      anon_sym_LBRACE,
    ACTIONS(9175), 1,
      aux_sym__qid_token1,
    ACTIONS(9177), 1,
      anon_sym_DOT,
    ACTIONS(9181), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(9183), 1,
      anon_sym_u2987,
    ACTIONS(9185), 1,
      aux_sym_integer_token1,
    ACTIONS(9187), 1,
      aux_sym_string_token1,
    ACTIONS(9189), 1,
      anon_sym_Set,
    STATE(4738), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7577), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7571), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(9163), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [542497] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6647), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6645), 31,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [542539] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6651), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6649), 31,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [542581] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(7432), 1,
      sym_id,
    ACTIONS(7434), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7438), 1,
      anon_sym_record,
    ACTIONS(7440), 1,
      anon_sym_LPAREN,
    ACTIONS(7442), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(7444), 1,
      anon_sym_u2983,
    ACTIONS(7446), 1,
      anon_sym_LBRACE,
    ACTIONS(7448), 1,
      aux_sym__qid_token1,
    ACTIONS(7450), 1,
      anon_sym_DOT,
    ACTIONS(7454), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(7456), 1,
      anon_sym_u2987,
    ACTIONS(7458), 1,
      aux_sym_integer_token1,
    ACTIONS(7460), 1,
      aux_sym_string_token1,
    ACTIONS(7462), 1,
      anon_sym_Set,
    STATE(4164), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7168), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7173), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(7436), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [542657] = 4,
    ACTIONS(6488), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6490), 2,
      anon_sym_EQ,
      anon_sym_RBRACE,
    ACTIONS(6486), 30,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [542701] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6754), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6752), 31,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [542743] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(10119), 1,
      sym_id,
    ACTIONS(10123), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10127), 1,
      anon_sym_record,
    ACTIONS(10129), 1,
      anon_sym_LPAREN,
    ACTIONS(10131), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(10133), 1,
      anon_sym_u2983,
    ACTIONS(10135), 1,
      anon_sym_LBRACE,
    ACTIONS(10137), 1,
      aux_sym__qid_token1,
    ACTIONS(10139), 1,
      anon_sym_DOT,
    ACTIONS(10141), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(10143), 1,
      anon_sym_u2987,
    ACTIONS(10145), 1,
      aux_sym_integer_token1,
    ACTIONS(10147), 1,
      aux_sym_string_token1,
    ACTIONS(10149), 1,
      anon_sym_Set,
    STATE(4969), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7812), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7815), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(10125), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [542819] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(10119), 1,
      sym_id,
    ACTIONS(10123), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10127), 1,
      anon_sym_record,
    ACTIONS(10129), 1,
      anon_sym_LPAREN,
    ACTIONS(10131), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(10133), 1,
      anon_sym_u2983,
    ACTIONS(10135), 1,
      anon_sym_LBRACE,
    ACTIONS(10137), 1,
      aux_sym__qid_token1,
    ACTIONS(10139), 1,
      anon_sym_DOT,
    ACTIONS(10141), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(10143), 1,
      anon_sym_u2987,
    ACTIONS(10145), 1,
      aux_sym_integer_token1,
    ACTIONS(10147), 1,
      aux_sym_string_token1,
    ACTIONS(10149), 1,
      anon_sym_Set,
    STATE(4942), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7812), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7815), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(10125), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [542895] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6714), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6712), 31,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [542937] = 4,
    ACTIONS(6488), 1,
      anon_sym_BSLASH,
    ACTIONS(6490), 1,
      anon_sym_COLON,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6486), 31,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [542981] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(10289), 1,
      sym_id,
    ACTIONS(10291), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10295), 1,
      anon_sym_record,
    ACTIONS(10297), 1,
      anon_sym_LPAREN,
    ACTIONS(10299), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(10301), 1,
      anon_sym_u2983,
    ACTIONS(10303), 1,
      anon_sym_LBRACE,
    ACTIONS(10305), 1,
      aux_sym__qid_token1,
    ACTIONS(10307), 1,
      anon_sym_DOT,
    ACTIONS(10311), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(10313), 1,
      anon_sym_u2987,
    ACTIONS(10315), 1,
      aux_sym_integer_token1,
    ACTIONS(10317), 1,
      aux_sym_string_token1,
    ACTIONS(10319), 1,
      anon_sym_Set,
    STATE(4992), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7770), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7764), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(10293), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [543057] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(7396), 1,
      sym_id,
    ACTIONS(7398), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7402), 1,
      anon_sym_record,
    ACTIONS(7404), 1,
      anon_sym_LPAREN,
    ACTIONS(7406), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(7408), 1,
      anon_sym_u2983,
    ACTIONS(7410), 1,
      anon_sym_LBRACE,
    ACTIONS(7412), 1,
      aux_sym__qid_token1,
    ACTIONS(7414), 1,
      anon_sym_DOT,
    ACTIONS(7418), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(7420), 1,
      anon_sym_u2987,
    ACTIONS(7422), 1,
      aux_sym_integer_token1,
    ACTIONS(7424), 1,
      aux_sym_string_token1,
    ACTIONS(7426), 1,
      anon_sym_Set,
    STATE(4157), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7163), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7161), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(7400), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [543133] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(10119), 1,
      sym_id,
    ACTIONS(10123), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10127), 1,
      anon_sym_record,
    ACTIONS(10129), 1,
      anon_sym_LPAREN,
    ACTIONS(10131), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(10133), 1,
      anon_sym_u2983,
    ACTIONS(10135), 1,
      anon_sym_LBRACE,
    ACTIONS(10137), 1,
      aux_sym__qid_token1,
    ACTIONS(10139), 1,
      anon_sym_DOT,
    ACTIONS(10141), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(10143), 1,
      anon_sym_u2987,
    ACTIONS(10145), 1,
      aux_sym_integer_token1,
    ACTIONS(10147), 1,
      aux_sym_string_token1,
    ACTIONS(10149), 1,
      anon_sym_Set,
    STATE(4956), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7812), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7815), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(10125), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [543209] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(9636), 1,
      sym_id,
    ACTIONS(9638), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9642), 1,
      anon_sym_record,
    ACTIONS(9644), 1,
      anon_sym_LPAREN,
    ACTIONS(9646), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(9648), 1,
      anon_sym_u2983,
    ACTIONS(9650), 1,
      anon_sym_LBRACE,
    ACTIONS(9652), 1,
      aux_sym__qid_token1,
    ACTIONS(9654), 1,
      anon_sym_DOT,
    ACTIONS(9658), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(9660), 1,
      anon_sym_u2987,
    ACTIONS(9662), 1,
      aux_sym_integer_token1,
    ACTIONS(9664), 1,
      aux_sym_string_token1,
    ACTIONS(9666), 1,
      anon_sym_Set,
    STATE(4841), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7594), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7606), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(9640), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [543285] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(10119), 1,
      sym_id,
    ACTIONS(10123), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10127), 1,
      anon_sym_record,
    ACTIONS(10129), 1,
      anon_sym_LPAREN,
    ACTIONS(10131), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(10133), 1,
      anon_sym_u2983,
    ACTIONS(10135), 1,
      anon_sym_LBRACE,
    ACTIONS(10137), 1,
      aux_sym__qid_token1,
    ACTIONS(10139), 1,
      anon_sym_DOT,
    ACTIONS(10141), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(10143), 1,
      anon_sym_u2987,
    ACTIONS(10145), 1,
      aux_sym_integer_token1,
    ACTIONS(10147), 1,
      aux_sym_string_token1,
    ACTIONS(10149), 1,
      anon_sym_Set,
    STATE(5019), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7812), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7815), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(10125), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [543361] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(10119), 1,
      sym_id,
    ACTIONS(10123), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10127), 1,
      anon_sym_record,
    ACTIONS(10129), 1,
      anon_sym_LPAREN,
    ACTIONS(10131), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(10133), 1,
      anon_sym_u2983,
    ACTIONS(10135), 1,
      anon_sym_LBRACE,
    ACTIONS(10137), 1,
      aux_sym__qid_token1,
    ACTIONS(10139), 1,
      anon_sym_DOT,
    ACTIONS(10141), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(10143), 1,
      anon_sym_u2987,
    ACTIONS(10145), 1,
      aux_sym_integer_token1,
    ACTIONS(10147), 1,
      aux_sym_string_token1,
    ACTIONS(10149), 1,
      anon_sym_Set,
    STATE(5145), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7812), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7815), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(10125), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [543437] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(10119), 1,
      sym_id,
    ACTIONS(10123), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10127), 1,
      anon_sym_record,
    ACTIONS(10129), 1,
      anon_sym_LPAREN,
    ACTIONS(10131), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(10133), 1,
      anon_sym_u2983,
    ACTIONS(10135), 1,
      anon_sym_LBRACE,
    ACTIONS(10137), 1,
      aux_sym__qid_token1,
    ACTIONS(10139), 1,
      anon_sym_DOT,
    ACTIONS(10141), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(10143), 1,
      anon_sym_u2987,
    ACTIONS(10145), 1,
      aux_sym_integer_token1,
    ACTIONS(10147), 1,
      aux_sym_string_token1,
    ACTIONS(10149), 1,
      anon_sym_Set,
    STATE(5214), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7812), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7815), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(10125), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [543513] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6750), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6748), 31,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [543555] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(10119), 1,
      sym_id,
    ACTIONS(10123), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10127), 1,
      anon_sym_record,
    ACTIONS(10129), 1,
      anon_sym_LPAREN,
    ACTIONS(10131), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(10133), 1,
      anon_sym_u2983,
    ACTIONS(10135), 1,
      anon_sym_LBRACE,
    ACTIONS(10137), 1,
      aux_sym__qid_token1,
    ACTIONS(10139), 1,
      anon_sym_DOT,
    ACTIONS(10141), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(10143), 1,
      anon_sym_u2987,
    ACTIONS(10145), 1,
      aux_sym_integer_token1,
    ACTIONS(10147), 1,
      aux_sym_string_token1,
    ACTIONS(10149), 1,
      anon_sym_Set,
    STATE(5267), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7812), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7815), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(10125), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [543631] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6710), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6708), 31,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [543673] = 3,
    ACTIONS(6484), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6482), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [543715] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11019), 1,
      sym_id,
    ACTIONS(11021), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11025), 1,
      anon_sym_record,
    ACTIONS(11027), 1,
      anon_sym_LPAREN,
    ACTIONS(11029), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11031), 1,
      anon_sym_u2983,
    ACTIONS(11033), 1,
      anon_sym_LBRACE,
    ACTIONS(11035), 1,
      aux_sym__qid_token1,
    ACTIONS(11037), 1,
      anon_sym_DOT,
    ACTIONS(11041), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11043), 1,
      anon_sym_u2987,
    ACTIONS(11045), 1,
      aux_sym_integer_token1,
    ACTIONS(11047), 1,
      aux_sym_string_token1,
    ACTIONS(11049), 1,
      anon_sym_Set,
    STATE(5227), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7686), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7699), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11023), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [543791] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(10119), 1,
      sym_id,
    ACTIONS(10123), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10127), 1,
      anon_sym_record,
    ACTIONS(10129), 1,
      anon_sym_LPAREN,
    ACTIONS(10131), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(10133), 1,
      anon_sym_u2983,
    ACTIONS(10135), 1,
      anon_sym_LBRACE,
    ACTIONS(10137), 1,
      aux_sym__qid_token1,
    ACTIONS(10139), 1,
      anon_sym_DOT,
    ACTIONS(10141), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(10143), 1,
      anon_sym_u2987,
    ACTIONS(10145), 1,
      aux_sym_integer_token1,
    ACTIONS(10147), 1,
      aux_sym_string_token1,
    ACTIONS(10149), 1,
      anon_sym_Set,
    STATE(5346), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7812), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7815), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(10125), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [543867] = 3,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6484), 2,
      sym__newline,
      anon_sym_BSLASH,
    ACTIONS(6482), 31,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [543909] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(10119), 1,
      sym_id,
    ACTIONS(10123), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10127), 1,
      anon_sym_record,
    ACTIONS(10129), 1,
      anon_sym_LPAREN,
    ACTIONS(10131), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(10133), 1,
      anon_sym_u2983,
    ACTIONS(10135), 1,
      anon_sym_LBRACE,
    ACTIONS(10137), 1,
      aux_sym__qid_token1,
    ACTIONS(10139), 1,
      anon_sym_DOT,
    ACTIONS(10141), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(10143), 1,
      anon_sym_u2987,
    ACTIONS(10145), 1,
      aux_sym_integer_token1,
    ACTIONS(10147), 1,
      aux_sym_string_token1,
    ACTIONS(10149), 1,
      anon_sym_Set,
    STATE(5066), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7812), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7815), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(10125), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [543985] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(10119), 1,
      sym_id,
    ACTIONS(10123), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10127), 1,
      anon_sym_record,
    ACTIONS(10129), 1,
      anon_sym_LPAREN,
    ACTIONS(10131), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(10133), 1,
      anon_sym_u2983,
    ACTIONS(10135), 1,
      anon_sym_LBRACE,
    ACTIONS(10137), 1,
      aux_sym__qid_token1,
    ACTIONS(10139), 1,
      anon_sym_DOT,
    ACTIONS(10141), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(10143), 1,
      anon_sym_u2987,
    ACTIONS(10145), 1,
      aux_sym_integer_token1,
    ACTIONS(10147), 1,
      aux_sym_string_token1,
    ACTIONS(10149), 1,
      anon_sym_Set,
    STATE(4988), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7812), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7815), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(10125), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [544061] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(9539), 1,
      sym_id,
    ACTIONS(9541), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9545), 1,
      anon_sym_record,
    ACTIONS(9547), 1,
      anon_sym_LPAREN,
    ACTIONS(9549), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(9551), 1,
      anon_sym_u2983,
    ACTIONS(9553), 1,
      anon_sym_LBRACE,
    ACTIONS(9555), 1,
      aux_sym__qid_token1,
    ACTIONS(9557), 1,
      anon_sym_DOT,
    ACTIONS(9561), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(9563), 1,
      anon_sym_u2987,
    ACTIONS(9565), 1,
      aux_sym_integer_token1,
    ACTIONS(9567), 1,
      aux_sym_string_token1,
    ACTIONS(9569), 1,
      anon_sym_Set,
    STATE(4783), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7603), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7600), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(9543), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [544137] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(10119), 1,
      sym_id,
    ACTIONS(10123), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10127), 1,
      anon_sym_record,
    ACTIONS(10129), 1,
      anon_sym_LPAREN,
    ACTIONS(10131), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(10133), 1,
      anon_sym_u2983,
    ACTIONS(10135), 1,
      anon_sym_LBRACE,
    ACTIONS(10137), 1,
      aux_sym__qid_token1,
    ACTIONS(10139), 1,
      anon_sym_DOT,
    ACTIONS(10141), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(10143), 1,
      anon_sym_u2987,
    ACTIONS(10145), 1,
      aux_sym_integer_token1,
    ACTIONS(10147), 1,
      aux_sym_string_token1,
    ACTIONS(10149), 1,
      anon_sym_Set,
    STATE(5164), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7812), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7815), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(10125), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [544213] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(10119), 1,
      sym_id,
    ACTIONS(10123), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10127), 1,
      anon_sym_record,
    ACTIONS(10129), 1,
      anon_sym_LPAREN,
    ACTIONS(10131), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(10133), 1,
      anon_sym_u2983,
    ACTIONS(10135), 1,
      anon_sym_LBRACE,
    ACTIONS(10137), 1,
      aux_sym__qid_token1,
    ACTIONS(10139), 1,
      anon_sym_DOT,
    ACTIONS(10141), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(10143), 1,
      anon_sym_u2987,
    ACTIONS(10145), 1,
      aux_sym_integer_token1,
    ACTIONS(10147), 1,
      aux_sym_string_token1,
    ACTIONS(10149), 1,
      anon_sym_Set,
    STATE(5033), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7812), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7815), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(10125), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [544289] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(10119), 1,
      sym_id,
    ACTIONS(10123), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10127), 1,
      anon_sym_record,
    ACTIONS(10129), 1,
      anon_sym_LPAREN,
    ACTIONS(10131), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(10133), 1,
      anon_sym_u2983,
    ACTIONS(10135), 1,
      anon_sym_LBRACE,
    ACTIONS(10137), 1,
      aux_sym__qid_token1,
    ACTIONS(10139), 1,
      anon_sym_DOT,
    ACTIONS(10141), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(10143), 1,
      anon_sym_u2987,
    ACTIONS(10145), 1,
      aux_sym_integer_token1,
    ACTIONS(10147), 1,
      aux_sym_string_token1,
    ACTIONS(10149), 1,
      anon_sym_Set,
    STATE(5195), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7812), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7815), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(10125), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [544365] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(10119), 1,
      sym_id,
    ACTIONS(10123), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10127), 1,
      anon_sym_record,
    ACTIONS(10129), 1,
      anon_sym_LPAREN,
    ACTIONS(10131), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(10133), 1,
      anon_sym_u2983,
    ACTIONS(10135), 1,
      anon_sym_LBRACE,
    ACTIONS(10137), 1,
      aux_sym__qid_token1,
    ACTIONS(10139), 1,
      anon_sym_DOT,
    ACTIONS(10141), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(10143), 1,
      anon_sym_u2987,
    ACTIONS(10145), 1,
      aux_sym_integer_token1,
    ACTIONS(10147), 1,
      aux_sym_string_token1,
    ACTIONS(10149), 1,
      anon_sym_Set,
    STATE(5257), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7812), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7815), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(10125), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [544441] = 3,
    ACTIONS(6326), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6324), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [544483] = 3,
    ACTIONS(6710), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6708), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [544525] = 3,
    ACTIONS(6750), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6748), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [544567] = 3,
    ACTIONS(6433), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6431), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [544609] = 3,
    ACTIONS(6655), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6653), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_u2988,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [544651] = 4,
    ACTIONS(6488), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6490), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(6486), 30,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [544695] = 3,
    ACTIONS(6714), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6712), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [544737] = 3,
    ACTIONS(6754), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6752), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [544779] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(10119), 1,
      sym_id,
    ACTIONS(10123), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10127), 1,
      anon_sym_record,
    ACTIONS(10129), 1,
      anon_sym_LPAREN,
    ACTIONS(10131), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(10133), 1,
      anon_sym_u2983,
    ACTIONS(10135), 1,
      anon_sym_LBRACE,
    ACTIONS(10137), 1,
      aux_sym__qid_token1,
    ACTIONS(10139), 1,
      anon_sym_DOT,
    ACTIONS(10141), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(10143), 1,
      anon_sym_u2987,
    ACTIONS(10145), 1,
      aux_sym_integer_token1,
    ACTIONS(10147), 1,
      aux_sym_string_token1,
    ACTIONS(10149), 1,
      anon_sym_Set,
    STATE(5241), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7812), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7815), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(10125), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [544855] = 3,
    ACTIONS(6326), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6324), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [544897] = 3,
    ACTIONS(6651), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6649), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [544939] = 3,
    ACTIONS(6647), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6645), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [544981] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(10119), 1,
      sym_id,
    ACTIONS(10123), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10127), 1,
      anon_sym_record,
    ACTIONS(10129), 1,
      anon_sym_LPAREN,
    ACTIONS(10131), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(10133), 1,
      anon_sym_u2983,
    ACTIONS(10135), 1,
      anon_sym_LBRACE,
    ACTIONS(10137), 1,
      aux_sym__qid_token1,
    ACTIONS(10139), 1,
      anon_sym_DOT,
    ACTIONS(10141), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(10143), 1,
      anon_sym_u2987,
    ACTIONS(10145), 1,
      aux_sym_integer_token1,
    ACTIONS(10147), 1,
      aux_sym_string_token1,
    ACTIONS(10149), 1,
      anon_sym_Set,
    STATE(5353), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7812), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7815), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(10125), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [545057] = 3,
    ACTIONS(6572), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6570), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [545099] = 3,
    ACTIONS(6568), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6566), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [545141] = 3,
    ACTIONS(6500), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6498), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [545183] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(10379), 1,
      sym_id,
    ACTIONS(10381), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10385), 1,
      anon_sym_record,
    ACTIONS(10387), 1,
      anon_sym_LPAREN,
    ACTIONS(10389), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(10391), 1,
      anon_sym_u2983,
    ACTIONS(10393), 1,
      anon_sym_LBRACE,
    ACTIONS(10395), 1,
      aux_sym__qid_token1,
    ACTIONS(10397), 1,
      anon_sym_DOT,
    ACTIONS(10401), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(10403), 1,
      anon_sym_u2987,
    ACTIONS(10405), 1,
      aux_sym_integer_token1,
    ACTIONS(10407), 1,
      aux_sym_string_token1,
    ACTIONS(10409), 1,
      anon_sym_Set,
    STATE(5725), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7690), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7735), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(10383), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [545259] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(9321), 1,
      sym_id,
    ACTIONS(9323), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9327), 1,
      anon_sym_record,
    ACTIONS(9329), 1,
      anon_sym_LPAREN,
    ACTIONS(9331), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(9333), 1,
      anon_sym_u2983,
    ACTIONS(9335), 1,
      anon_sym_LBRACE,
    ACTIONS(9337), 1,
      aux_sym__qid_token1,
    ACTIONS(9339), 1,
      anon_sym_DOT,
    ACTIONS(9343), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(9345), 1,
      anon_sym_u2987,
    ACTIONS(9347), 1,
      aux_sym_integer_token1,
    ACTIONS(9349), 1,
      aux_sym_string_token1,
    ACTIONS(9351), 1,
      anon_sym_Set,
    STATE(4798), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7442), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7445), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(9325), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [545335] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(9029), 1,
      sym_id,
    ACTIONS(9031), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9035), 1,
      anon_sym_record,
    ACTIONS(9037), 1,
      anon_sym_LPAREN,
    ACTIONS(9039), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(9041), 1,
      anon_sym_u2983,
    ACTIONS(9043), 1,
      anon_sym_LBRACE,
    ACTIONS(9045), 1,
      aux_sym__qid_token1,
    ACTIONS(9047), 1,
      anon_sym_DOT,
    ACTIONS(9049), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(9051), 1,
      anon_sym_u2987,
    ACTIONS(9053), 1,
      aux_sym_integer_token1,
    ACTIONS(9055), 1,
      aux_sym_string_token1,
    ACTIONS(9057), 1,
      anon_sym_Set,
    STATE(4796), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7312), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7309), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(9033), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [545411] = 3,
    ACTIONS(6710), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6708), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [545453] = 3,
    ACTIONS(6433), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6431), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [545495] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(10985), 1,
      sym_id,
    ACTIONS(10987), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10991), 1,
      anon_sym_record,
    ACTIONS(10993), 1,
      anon_sym_LPAREN,
    ACTIONS(10995), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(10997), 1,
      anon_sym_u2983,
    ACTIONS(10999), 1,
      anon_sym_LBRACE,
    ACTIONS(11001), 1,
      aux_sym__qid_token1,
    ACTIONS(11003), 1,
      anon_sym_DOT,
    ACTIONS(11007), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11009), 1,
      anon_sym_u2987,
    ACTIONS(11011), 1,
      aux_sym_integer_token1,
    ACTIONS(11013), 1,
      aux_sym_string_token1,
    ACTIONS(11015), 1,
      anon_sym_Set,
    STATE(5224), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7784), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7798), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(10989), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [545571] = 3,
    ACTIONS(6655), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6653), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [545613] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(10119), 1,
      sym_id,
    ACTIONS(10123), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10127), 1,
      anon_sym_record,
    ACTIONS(10129), 1,
      anon_sym_LPAREN,
    ACTIONS(10131), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(10133), 1,
      anon_sym_u2983,
    ACTIONS(10135), 1,
      anon_sym_LBRACE,
    ACTIONS(10137), 1,
      aux_sym__qid_token1,
    ACTIONS(10139), 1,
      anon_sym_DOT,
    ACTIONS(10141), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(10143), 1,
      anon_sym_u2987,
    ACTIONS(10145), 1,
      aux_sym_integer_token1,
    ACTIONS(10147), 1,
      aux_sym_string_token1,
    ACTIONS(10149), 1,
      anon_sym_Set,
    STATE(5356), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7812), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7815), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(10125), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [545689] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(10119), 1,
      sym_id,
    ACTIONS(10123), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10127), 1,
      anon_sym_record,
    ACTIONS(10129), 1,
      anon_sym_LPAREN,
    ACTIONS(10131), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(10133), 1,
      anon_sym_u2983,
    ACTIONS(10135), 1,
      anon_sym_LBRACE,
    ACTIONS(10137), 1,
      aux_sym__qid_token1,
    ACTIONS(10139), 1,
      anon_sym_DOT,
    ACTIONS(10141), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(10143), 1,
      anon_sym_u2987,
    ACTIONS(10145), 1,
      aux_sym_integer_token1,
    ACTIONS(10147), 1,
      aux_sym_string_token1,
    ACTIONS(10149), 1,
      anon_sym_Set,
    STATE(5303), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7812), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7815), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(10125), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [545765] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(7027), 1,
      sym_id,
    ACTIONS(7029), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7033), 1,
      anon_sym_record,
    ACTIONS(7035), 1,
      anon_sym_LPAREN,
    ACTIONS(7037), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(7039), 1,
      anon_sym_u2983,
    ACTIONS(7041), 1,
      anon_sym_LBRACE,
    ACTIONS(7043), 1,
      aux_sym__qid_token1,
    ACTIONS(7045), 1,
      anon_sym_DOT,
    ACTIONS(7049), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(7051), 1,
      anon_sym_u2987,
    ACTIONS(7053), 1,
      aux_sym_integer_token1,
    ACTIONS(7055), 1,
      aux_sym_string_token1,
    ACTIONS(7057), 1,
      anon_sym_Set,
    STATE(4065), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(6939), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6933), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(7031), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [545841] = 3,
    ACTIONS(6496), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6494), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [545883] = 3,
    ACTIONS(6496), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6494), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_u2988,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [545925] = 3,
    ACTIONS(6647), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6645), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [545967] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(10119), 1,
      sym_id,
    ACTIONS(10123), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10127), 1,
      anon_sym_record,
    ACTIONS(10129), 1,
      anon_sym_LPAREN,
    ACTIONS(10131), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(10133), 1,
      anon_sym_u2983,
    ACTIONS(10135), 1,
      anon_sym_LBRACE,
    ACTIONS(10137), 1,
      aux_sym__qid_token1,
    ACTIONS(10139), 1,
      anon_sym_DOT,
    ACTIONS(10141), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(10143), 1,
      anon_sym_u2987,
    ACTIONS(10145), 1,
      aux_sym_integer_token1,
    ACTIONS(10147), 1,
      aux_sym_string_token1,
    ACTIONS(10149), 1,
      anon_sym_Set,
    STATE(5137), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7812), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7815), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(10125), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [546043] = 3,
    ACTIONS(6326), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6324), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_u2988,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [546085] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(10119), 1,
      sym_id,
    ACTIONS(10123), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10127), 1,
      anon_sym_record,
    ACTIONS(10129), 1,
      anon_sym_LPAREN,
    ACTIONS(10131), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(10133), 1,
      anon_sym_u2983,
    ACTIONS(10135), 1,
      anon_sym_LBRACE,
    ACTIONS(10137), 1,
      aux_sym__qid_token1,
    ACTIONS(10139), 1,
      anon_sym_DOT,
    ACTIONS(10141), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(10143), 1,
      anon_sym_u2987,
    ACTIONS(10145), 1,
      aux_sym_integer_token1,
    ACTIONS(10147), 1,
      aux_sym_string_token1,
    ACTIONS(10149), 1,
      anon_sym_Set,
    STATE(5009), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7812), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7815), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(10125), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [546161] = 3,
    ACTIONS(6496), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6494), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [546203] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(10119), 1,
      sym_id,
    ACTIONS(10123), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10127), 1,
      anon_sym_record,
    ACTIONS(10129), 1,
      anon_sym_LPAREN,
    ACTIONS(10131), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(10133), 1,
      anon_sym_u2983,
    ACTIONS(10135), 1,
      anon_sym_LBRACE,
    ACTIONS(10137), 1,
      aux_sym__qid_token1,
    ACTIONS(10139), 1,
      anon_sym_DOT,
    ACTIONS(10141), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(10143), 1,
      anon_sym_u2987,
    ACTIONS(10145), 1,
      aux_sym_integer_token1,
    ACTIONS(10147), 1,
      aux_sym_string_token1,
    ACTIONS(10149), 1,
      anon_sym_Set,
    STATE(4995), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7812), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7815), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(10125), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [546279] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(9029), 1,
      sym_id,
    ACTIONS(9031), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9035), 1,
      anon_sym_record,
    ACTIONS(9037), 1,
      anon_sym_LPAREN,
    ACTIONS(9039), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(9041), 1,
      anon_sym_u2983,
    ACTIONS(9043), 1,
      anon_sym_LBRACE,
    ACTIONS(9045), 1,
      aux_sym__qid_token1,
    ACTIONS(9047), 1,
      anon_sym_DOT,
    ACTIONS(9049), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(9051), 1,
      anon_sym_u2987,
    ACTIONS(9053), 1,
      aux_sym_integer_token1,
    ACTIONS(9055), 1,
      aux_sym_string_token1,
    ACTIONS(9057), 1,
      anon_sym_Set,
    STATE(4764), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7312), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7309), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(9033), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [546355] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(10119), 1,
      sym_id,
    ACTIONS(10123), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10127), 1,
      anon_sym_record,
    ACTIONS(10129), 1,
      anon_sym_LPAREN,
    ACTIONS(10131), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(10133), 1,
      anon_sym_u2983,
    ACTIONS(10135), 1,
      anon_sym_LBRACE,
    ACTIONS(10137), 1,
      aux_sym__qid_token1,
    ACTIONS(10139), 1,
      anon_sym_DOT,
    ACTIONS(10141), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(10143), 1,
      anon_sym_u2987,
    ACTIONS(10145), 1,
      aux_sym_integer_token1,
    ACTIONS(10147), 1,
      aux_sym_string_token1,
    ACTIONS(10149), 1,
      anon_sym_Set,
    STATE(5059), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7812), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7815), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(10125), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [546431] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(10119), 1,
      sym_id,
    ACTIONS(10123), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10127), 1,
      anon_sym_record,
    ACTIONS(10129), 1,
      anon_sym_LPAREN,
    ACTIONS(10131), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(10133), 1,
      anon_sym_u2983,
    ACTIONS(10135), 1,
      anon_sym_LBRACE,
    ACTIONS(10137), 1,
      aux_sym__qid_token1,
    ACTIONS(10139), 1,
      anon_sym_DOT,
    ACTIONS(10141), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(10143), 1,
      anon_sym_u2987,
    ACTIONS(10145), 1,
      aux_sym_integer_token1,
    ACTIONS(10147), 1,
      aux_sym_string_token1,
    ACTIONS(10149), 1,
      anon_sym_Set,
    STATE(5166), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7812), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7815), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(10125), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [546507] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6716), 1,
      sym_id,
    ACTIONS(6718), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6722), 1,
      anon_sym_record,
    ACTIONS(6724), 1,
      anon_sym_LPAREN,
    ACTIONS(6726), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(6728), 1,
      anon_sym_u2983,
    ACTIONS(6730), 1,
      anon_sym_LBRACE,
    ACTIONS(6732), 1,
      aux_sym__qid_token1,
    ACTIONS(6734), 1,
      anon_sym_DOT,
    ACTIONS(6738), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(6740), 1,
      anon_sym_u2987,
    ACTIONS(6742), 1,
      aux_sym_integer_token1,
    ACTIONS(6744), 1,
      aux_sym_string_token1,
    ACTIONS(6746), 1,
      anon_sym_Set,
    STATE(4035), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(6805), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6809), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(6720), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [546583] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(10119), 1,
      sym_id,
    ACTIONS(10123), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10127), 1,
      anon_sym_record,
    ACTIONS(10129), 1,
      anon_sym_LPAREN,
    ACTIONS(10131), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(10133), 1,
      anon_sym_u2983,
    ACTIONS(10135), 1,
      anon_sym_LBRACE,
    ACTIONS(10137), 1,
      aux_sym__qid_token1,
    ACTIONS(10139), 1,
      anon_sym_DOT,
    ACTIONS(10141), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(10143), 1,
      anon_sym_u2987,
    ACTIONS(10145), 1,
      aux_sym_integer_token1,
    ACTIONS(10147), 1,
      aux_sym_string_token1,
    ACTIONS(10149), 1,
      anon_sym_Set,
    STATE(5332), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7812), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7815), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(10125), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [546659] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(10119), 1,
      sym_id,
    ACTIONS(10123), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10127), 1,
      anon_sym_record,
    ACTIONS(10129), 1,
      anon_sym_LPAREN,
    ACTIONS(10131), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(10133), 1,
      anon_sym_u2983,
    ACTIONS(10135), 1,
      anon_sym_LBRACE,
    ACTIONS(10137), 1,
      aux_sym__qid_token1,
    ACTIONS(10139), 1,
      anon_sym_DOT,
    ACTIONS(10141), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(10143), 1,
      anon_sym_u2987,
    ACTIONS(10145), 1,
      aux_sym_integer_token1,
    ACTIONS(10147), 1,
      aux_sym_string_token1,
    ACTIONS(10149), 1,
      anon_sym_Set,
    STATE(4962), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7812), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7815), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(10125), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [546735] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(10119), 1,
      sym_id,
    ACTIONS(10123), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10127), 1,
      anon_sym_record,
    ACTIONS(10129), 1,
      anon_sym_LPAREN,
    ACTIONS(10131), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(10133), 1,
      anon_sym_u2983,
    ACTIONS(10135), 1,
      anon_sym_LBRACE,
    ACTIONS(10137), 1,
      aux_sym__qid_token1,
    ACTIONS(10139), 1,
      anon_sym_DOT,
    ACTIONS(10141), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(10143), 1,
      anon_sym_u2987,
    ACTIONS(10145), 1,
      aux_sym_integer_token1,
    ACTIONS(10147), 1,
      aux_sym_string_token1,
    ACTIONS(10149), 1,
      anon_sym_Set,
    STATE(5292), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7812), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7815), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(10125), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [546811] = 4,
    ACTIONS(6326), 1,
      anon_sym_BSLASH,
    ACTIONS(11362), 1,
      anon_sym_AT,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6324), 31,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [546855] = 3,
    ACTIONS(6655), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6653), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [546897] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(10038), 1,
      sym_id,
    ACTIONS(10040), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10044), 1,
      anon_sym_record,
    ACTIONS(10046), 1,
      anon_sym_LPAREN,
    ACTIONS(10048), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(10050), 1,
      anon_sym_u2983,
    ACTIONS(10052), 1,
      anon_sym_LBRACE,
    ACTIONS(10054), 1,
      aux_sym__qid_token1,
    ACTIONS(10056), 1,
      anon_sym_DOT,
    ACTIONS(10060), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(10062), 1,
      anon_sym_u2987,
    ACTIONS(10064), 1,
      aux_sym_integer_token1,
    ACTIONS(10066), 1,
      aux_sym_string_token1,
    ACTIONS(10068), 1,
      anon_sym_Set,
    STATE(4909), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7504), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7499), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(10042), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [546973] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(9475), 1,
      sym_id,
    ACTIONS(9477), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9481), 1,
      anon_sym_record,
    ACTIONS(9483), 1,
      anon_sym_LPAREN,
    ACTIONS(9485), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(9487), 1,
      anon_sym_u2983,
    ACTIONS(9489), 1,
      anon_sym_LBRACE,
    ACTIONS(9491), 1,
      aux_sym__qid_token1,
    ACTIONS(9493), 1,
      anon_sym_DOT,
    ACTIONS(9497), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(9499), 1,
      anon_sym_u2987,
    ACTIONS(9501), 1,
      aux_sym_integer_token1,
    ACTIONS(9503), 1,
      aux_sym_string_token1,
    ACTIONS(9505), 1,
      anon_sym_Set,
    STATE(4781), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7555), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7552), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(9479), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [547049] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(10119), 1,
      sym_id,
    ACTIONS(10123), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10127), 1,
      anon_sym_record,
    ACTIONS(10129), 1,
      anon_sym_LPAREN,
    ACTIONS(10131), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(10133), 1,
      anon_sym_u2983,
    ACTIONS(10135), 1,
      anon_sym_LBRACE,
    ACTIONS(10137), 1,
      aux_sym__qid_token1,
    ACTIONS(10139), 1,
      anon_sym_DOT,
    ACTIONS(10141), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(10143), 1,
      anon_sym_u2987,
    ACTIONS(10145), 1,
      aux_sym_integer_token1,
    ACTIONS(10147), 1,
      aux_sym_string_token1,
    ACTIONS(10149), 1,
      anon_sym_Set,
    STATE(5264), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7812), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7815), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(10125), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [547125] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(10119), 1,
      sym_id,
    ACTIONS(10123), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10127), 1,
      anon_sym_record,
    ACTIONS(10129), 1,
      anon_sym_LPAREN,
    ACTIONS(10131), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(10133), 1,
      anon_sym_u2983,
    ACTIONS(10135), 1,
      anon_sym_LBRACE,
    ACTIONS(10137), 1,
      aux_sym__qid_token1,
    ACTIONS(10139), 1,
      anon_sym_DOT,
    ACTIONS(10141), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(10143), 1,
      anon_sym_u2987,
    ACTIONS(10145), 1,
      aux_sym_integer_token1,
    ACTIONS(10147), 1,
      aux_sym_string_token1,
    ACTIONS(10149), 1,
      anon_sym_Set,
    STATE(5326), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7812), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7815), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(10125), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [547201] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(8993), 1,
      sym_id,
    ACTIONS(8995), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8999), 1,
      anon_sym_record,
    ACTIONS(9001), 1,
      anon_sym_LPAREN,
    ACTIONS(9003), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(9005), 1,
      anon_sym_u2983,
    ACTIONS(9007), 1,
      anon_sym_LBRACE,
    ACTIONS(9009), 1,
      aux_sym__qid_token1,
    ACTIONS(9011), 1,
      anon_sym_DOT,
    ACTIONS(9015), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(9017), 1,
      anon_sym_u2987,
    ACTIONS(9019), 1,
      aux_sym_integer_token1,
    ACTIONS(9021), 1,
      aux_sym_string_token1,
    ACTIONS(9023), 1,
      anon_sym_Set,
    STATE(4713), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7305), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7306), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(8997), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [547277] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(10119), 1,
      sym_id,
    ACTIONS(10123), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10127), 1,
      anon_sym_record,
    ACTIONS(10129), 1,
      anon_sym_LPAREN,
    ACTIONS(10131), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(10133), 1,
      anon_sym_u2983,
    ACTIONS(10135), 1,
      anon_sym_LBRACE,
    ACTIONS(10137), 1,
      aux_sym__qid_token1,
    ACTIONS(10139), 1,
      anon_sym_DOT,
    ACTIONS(10141), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(10143), 1,
      anon_sym_u2987,
    ACTIONS(10145), 1,
      aux_sym_integer_token1,
    ACTIONS(10147), 1,
      aux_sym_string_token1,
    ACTIONS(10149), 1,
      anon_sym_Set,
    STATE(5275), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7812), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7815), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(10125), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [547353] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(10119), 1,
      sym_id,
    ACTIONS(10123), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10127), 1,
      anon_sym_record,
    ACTIONS(10129), 1,
      anon_sym_LPAREN,
    ACTIONS(10131), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(10133), 1,
      anon_sym_u2983,
    ACTIONS(10135), 1,
      anon_sym_LBRACE,
    ACTIONS(10137), 1,
      aux_sym__qid_token1,
    ACTIONS(10139), 1,
      anon_sym_DOT,
    ACTIONS(10141), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(10143), 1,
      anon_sym_u2987,
    ACTIONS(10145), 1,
      aux_sym_integer_token1,
    ACTIONS(10147), 1,
      aux_sym_string_token1,
    ACTIONS(10149), 1,
      anon_sym_Set,
    STATE(5244), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7812), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7815), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(10125), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [547429] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(10119), 1,
      sym_id,
    ACTIONS(10123), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10127), 1,
      anon_sym_record,
    ACTIONS(10129), 1,
      anon_sym_LPAREN,
    ACTIONS(10131), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(10133), 1,
      anon_sym_u2983,
    ACTIONS(10135), 1,
      anon_sym_LBRACE,
    ACTIONS(10137), 1,
      aux_sym__qid_token1,
    ACTIONS(10139), 1,
      anon_sym_DOT,
    ACTIONS(10141), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(10143), 1,
      anon_sym_u2987,
    ACTIONS(10145), 1,
      aux_sym_integer_token1,
    ACTIONS(10147), 1,
      aux_sym_string_token1,
    ACTIONS(10149), 1,
      anon_sym_Set,
    STATE(5199), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7812), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7815), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(10125), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [547505] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(10119), 1,
      sym_id,
    ACTIONS(10123), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10127), 1,
      anon_sym_record,
    ACTIONS(10129), 1,
      anon_sym_LPAREN,
    ACTIONS(10131), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(10133), 1,
      anon_sym_u2983,
    ACTIONS(10135), 1,
      anon_sym_LBRACE,
    ACTIONS(10137), 1,
      aux_sym__qid_token1,
    ACTIONS(10139), 1,
      anon_sym_DOT,
    ACTIONS(10141), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(10143), 1,
      anon_sym_u2987,
    ACTIONS(10145), 1,
      aux_sym_integer_token1,
    ACTIONS(10147), 1,
      aux_sym_string_token1,
    ACTIONS(10149), 1,
      anon_sym_Set,
    STATE(5162), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7812), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7815), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(10125), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [547581] = 5,
    ACTIONS(6488), 1,
      anon_sym_BSLASH,
    ACTIONS(6490), 1,
      anon_sym_SEMI,
    ACTIONS(6492), 1,
      sym__newline,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6486), 30,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [547627] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(10119), 1,
      sym_id,
    ACTIONS(10123), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10127), 1,
      anon_sym_record,
    ACTIONS(10129), 1,
      anon_sym_LPAREN,
    ACTIONS(10131), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(10133), 1,
      anon_sym_u2983,
    ACTIONS(10135), 1,
      anon_sym_LBRACE,
    ACTIONS(10137), 1,
      aux_sym__qid_token1,
    ACTIONS(10139), 1,
      anon_sym_DOT,
    ACTIONS(10141), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(10143), 1,
      anon_sym_u2987,
    ACTIONS(10145), 1,
      aux_sym_integer_token1,
    ACTIONS(10147), 1,
      aux_sym_string_token1,
    ACTIONS(10149), 1,
      anon_sym_Set,
    STATE(5121), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7812), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7815), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(10125), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [547703] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(10119), 1,
      sym_id,
    ACTIONS(10123), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10127), 1,
      anon_sym_record,
    ACTIONS(10129), 1,
      anon_sym_LPAREN,
    ACTIONS(10131), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(10133), 1,
      anon_sym_u2983,
    ACTIONS(10135), 1,
      anon_sym_LBRACE,
    ACTIONS(10137), 1,
      aux_sym__qid_token1,
    ACTIONS(10139), 1,
      anon_sym_DOT,
    ACTIONS(10141), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(10143), 1,
      anon_sym_u2987,
    ACTIONS(10145), 1,
      aux_sym_integer_token1,
    ACTIONS(10147), 1,
      aux_sym_string_token1,
    ACTIONS(10149), 1,
      anon_sym_Set,
    STATE(5072), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7812), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7815), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(10125), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [547779] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(10119), 1,
      sym_id,
    ACTIONS(10123), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10127), 1,
      anon_sym_record,
    ACTIONS(10129), 1,
      anon_sym_LPAREN,
    ACTIONS(10131), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(10133), 1,
      anon_sym_u2983,
    ACTIONS(10135), 1,
      anon_sym_LBRACE,
    ACTIONS(10137), 1,
      aux_sym__qid_token1,
    ACTIONS(10139), 1,
      anon_sym_DOT,
    ACTIONS(10141), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(10143), 1,
      anon_sym_u2987,
    ACTIONS(10145), 1,
      aux_sym_integer_token1,
    ACTIONS(10147), 1,
      aux_sym_string_token1,
    ACTIONS(10149), 1,
      anon_sym_Set,
    STATE(5034), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7812), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7815), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(10125), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [547855] = 5,
    ACTIONS(6488), 1,
      anon_sym_BSLASH,
    ACTIONS(6490), 1,
      anon_sym_EQ,
    ACTIONS(6492), 1,
      sym__newline,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6486), 30,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [547901] = 3,
    ACTIONS(6326), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6324), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_PIPE_RPAREN,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [547943] = 3,
    ACTIONS(6500), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6498), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [547985] = 3,
    ACTIONS(6568), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6566), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [548027] = 3,
    ACTIONS(6572), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6570), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [548069] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(9240), 1,
      sym_id,
    ACTIONS(9242), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9246), 1,
      anon_sym_record,
    ACTIONS(9248), 1,
      anon_sym_LPAREN,
    ACTIONS(9250), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(9252), 1,
      anon_sym_u2983,
    ACTIONS(9254), 1,
      anon_sym_LBRACE,
    ACTIONS(9256), 1,
      aux_sym__qid_token1,
    ACTIONS(9258), 1,
      anon_sym_DOT,
    ACTIONS(9262), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(9264), 1,
      anon_sym_u2987,
    ACTIONS(9266), 1,
      aux_sym_integer_token1,
    ACTIONS(9268), 1,
      aux_sym_string_token1,
    ACTIONS(9270), 1,
      anon_sym_Set,
    STATE(4759), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7475), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7469), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(9244), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [548145] = 3,
    ACTIONS(6651), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6649), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [548187] = 3,
    ACTIONS(6754), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6752), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [548229] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(10119), 1,
      sym_id,
    ACTIONS(10123), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10127), 1,
      anon_sym_record,
    ACTIONS(10129), 1,
      anon_sym_LPAREN,
    ACTIONS(10131), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(10133), 1,
      anon_sym_u2983,
    ACTIONS(10135), 1,
      anon_sym_LBRACE,
    ACTIONS(10137), 1,
      aux_sym__qid_token1,
    ACTIONS(10139), 1,
      anon_sym_DOT,
    ACTIONS(10141), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(10143), 1,
      anon_sym_u2987,
    ACTIONS(10145), 1,
      aux_sym_integer_token1,
    ACTIONS(10147), 1,
      aux_sym_string_token1,
    ACTIONS(10149), 1,
      anon_sym_Set,
    STATE(4994), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7812), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7815), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(10125), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [548305] = 3,
    ACTIONS(6714), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6712), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [548347] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(10119), 1,
      sym_id,
    ACTIONS(10123), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10127), 1,
      anon_sym_record,
    ACTIONS(10129), 1,
      anon_sym_LPAREN,
    ACTIONS(10131), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(10133), 1,
      anon_sym_u2983,
    ACTIONS(10135), 1,
      anon_sym_LBRACE,
    ACTIONS(10137), 1,
      aux_sym__qid_token1,
    ACTIONS(10139), 1,
      anon_sym_DOT,
    ACTIONS(10141), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(10143), 1,
      anon_sym_u2987,
    ACTIONS(10145), 1,
      aux_sym_integer_token1,
    ACTIONS(10147), 1,
      aux_sym_string_token1,
    ACTIONS(10149), 1,
      anon_sym_Set,
    STATE(4958), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7812), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7815), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(10125), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [548423] = 3,
    ACTIONS(6750), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6748), 32,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [548465] = 5,
    ACTIONS(11284), 1,
      anon_sym_BSLASH,
    ACTIONS(11364), 1,
      anon_sym_AT,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    STATE(6293), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    ACTIONS(11282), 29,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [548511] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(10119), 1,
      sym_id,
    ACTIONS(10123), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10127), 1,
      anon_sym_record,
    ACTIONS(10129), 1,
      anon_sym_LPAREN,
    ACTIONS(10131), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(10133), 1,
      anon_sym_u2983,
    ACTIONS(10135), 1,
      anon_sym_LBRACE,
    ACTIONS(10137), 1,
      aux_sym__qid_token1,
    ACTIONS(10139), 1,
      anon_sym_DOT,
    ACTIONS(10141), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(10143), 1,
      anon_sym_u2987,
    ACTIONS(10145), 1,
      aux_sym_integer_token1,
    ACTIONS(10147), 1,
      aux_sym_string_token1,
    ACTIONS(10149), 1,
      anon_sym_Set,
    STATE(4919), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7812), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7815), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(10125), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [548587] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(8369), 1,
      sym_id,
    ACTIONS(8371), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8375), 1,
      anon_sym_record,
    ACTIONS(8377), 1,
      anon_sym_LPAREN,
    ACTIONS(8379), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(8381), 1,
      anon_sym_u2983,
    ACTIONS(8383), 1,
      anon_sym_LBRACE,
    ACTIONS(8385), 1,
      aux_sym__qid_token1,
    ACTIONS(8387), 1,
      anon_sym_DOT,
    ACTIONS(8391), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(8393), 1,
      anon_sym_u2987,
    ACTIONS(8395), 1,
      aux_sym_integer_token1,
    ACTIONS(8397), 1,
      aux_sym_string_token1,
    ACTIONS(8399), 1,
      anon_sym_Set,
    STATE(4429), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7389), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7302), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(8373), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [548663] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(10119), 1,
      sym_id,
    ACTIONS(10123), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10127), 1,
      anon_sym_record,
    ACTIONS(10129), 1,
      anon_sym_LPAREN,
    ACTIONS(10131), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(10133), 1,
      anon_sym_u2983,
    ACTIONS(10135), 1,
      anon_sym_LBRACE,
    ACTIONS(10137), 1,
      aux_sym__qid_token1,
    ACTIONS(10139), 1,
      anon_sym_DOT,
    ACTIONS(10141), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(10143), 1,
      anon_sym_u2987,
    ACTIONS(10145), 1,
      aux_sym_integer_token1,
    ACTIONS(10147), 1,
      aux_sym_string_token1,
    ACTIONS(10149), 1,
      anon_sym_Set,
    STATE(5003), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7812), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7815), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(10125), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [548739] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(9758), 1,
      sym_id,
    ACTIONS(9760), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9764), 1,
      anon_sym_record,
    ACTIONS(9766), 1,
      anon_sym_LPAREN,
    ACTIONS(9768), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(9770), 1,
      anon_sym_u2983,
    ACTIONS(9772), 1,
      anon_sym_LBRACE,
    ACTIONS(9774), 1,
      aux_sym__qid_token1,
    ACTIONS(9776), 1,
      anon_sym_DOT,
    ACTIONS(9780), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(9782), 1,
      anon_sym_u2987,
    ACTIONS(9784), 1,
      aux_sym_integer_token1,
    ACTIONS(9786), 1,
      aux_sym_string_token1,
    ACTIONS(9788), 1,
      anon_sym_Set,
    STATE(4873), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7652), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7667), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(9762), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [548815] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(10119), 1,
      sym_id,
    ACTIONS(10123), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10127), 1,
      anon_sym_record,
    ACTIONS(10129), 1,
      anon_sym_LPAREN,
    ACTIONS(10131), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(10133), 1,
      anon_sym_u2983,
    ACTIONS(10135), 1,
      anon_sym_LBRACE,
    ACTIONS(10137), 1,
      aux_sym__qid_token1,
    ACTIONS(10139), 1,
      anon_sym_DOT,
    ACTIONS(10141), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(10143), 1,
      anon_sym_u2987,
    ACTIONS(10145), 1,
      aux_sym_integer_token1,
    ACTIONS(10147), 1,
      aux_sym_string_token1,
    ACTIONS(10149), 1,
      anon_sym_Set,
    STATE(5048), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7812), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7815), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(10125), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [548891] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(10119), 1,
      sym_id,
    ACTIONS(10123), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10127), 1,
      anon_sym_record,
    ACTIONS(10129), 1,
      anon_sym_LPAREN,
    ACTIONS(10131), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(10133), 1,
      anon_sym_u2983,
    ACTIONS(10135), 1,
      anon_sym_LBRACE,
    ACTIONS(10137), 1,
      aux_sym__qid_token1,
    ACTIONS(10139), 1,
      anon_sym_DOT,
    ACTIONS(10141), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(10143), 1,
      anon_sym_u2987,
    ACTIONS(10145), 1,
      aux_sym_integer_token1,
    ACTIONS(10147), 1,
      aux_sym_string_token1,
    ACTIONS(10149), 1,
      anon_sym_Set,
    STATE(5110), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7812), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7815), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(10125), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [548967] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(10119), 1,
      sym_id,
    ACTIONS(10123), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10127), 1,
      anon_sym_record,
    ACTIONS(10129), 1,
      anon_sym_LPAREN,
    ACTIONS(10131), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(10133), 1,
      anon_sym_u2983,
    ACTIONS(10135), 1,
      anon_sym_LBRACE,
    ACTIONS(10137), 1,
      aux_sym__qid_token1,
    ACTIONS(10139), 1,
      anon_sym_DOT,
    ACTIONS(10141), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(10143), 1,
      anon_sym_u2987,
    ACTIONS(10145), 1,
      aux_sym_integer_token1,
    ACTIONS(10147), 1,
      aux_sym_string_token1,
    ACTIONS(10149), 1,
      anon_sym_Set,
    STATE(5167), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7812), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7815), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(10125), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [549043] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(10119), 1,
      sym_id,
    ACTIONS(10123), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10127), 1,
      anon_sym_record,
    ACTIONS(10129), 1,
      anon_sym_LPAREN,
    ACTIONS(10131), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(10133), 1,
      anon_sym_u2983,
    ACTIONS(10135), 1,
      anon_sym_LBRACE,
    ACTIONS(10137), 1,
      aux_sym__qid_token1,
    ACTIONS(10139), 1,
      anon_sym_DOT,
    ACTIONS(10141), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(10143), 1,
      anon_sym_u2987,
    ACTIONS(10145), 1,
      aux_sym_integer_token1,
    ACTIONS(10147), 1,
      aux_sym_string_token1,
    ACTIONS(10149), 1,
      anon_sym_Set,
    STATE(5223), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7812), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7815), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(10125), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [549119] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(10119), 1,
      sym_id,
    ACTIONS(10123), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10127), 1,
      anon_sym_record,
    ACTIONS(10129), 1,
      anon_sym_LPAREN,
    ACTIONS(10131), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(10133), 1,
      anon_sym_u2983,
    ACTIONS(10135), 1,
      anon_sym_LBRACE,
    ACTIONS(10137), 1,
      aux_sym__qid_token1,
    ACTIONS(10139), 1,
      anon_sym_DOT,
    ACTIONS(10141), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(10143), 1,
      anon_sym_u2987,
    ACTIONS(10145), 1,
      aux_sym_integer_token1,
    ACTIONS(10147), 1,
      aux_sym_string_token1,
    ACTIONS(10149), 1,
      anon_sym_Set,
    STATE(5283), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7812), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7815), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(10125), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [549195] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(10600), 1,
      sym_id,
    ACTIONS(10602), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10606), 1,
      anon_sym_record,
    ACTIONS(10608), 1,
      anon_sym_LPAREN,
    ACTIONS(10610), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(10612), 1,
      anon_sym_u2983,
    ACTIONS(10614), 1,
      anon_sym_LBRACE,
    ACTIONS(10616), 1,
      aux_sym__qid_token1,
    ACTIONS(10618), 1,
      anon_sym_DOT,
    ACTIONS(10620), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(10622), 1,
      anon_sym_u2987,
    ACTIONS(10624), 1,
      aux_sym_integer_token1,
    ACTIONS(10626), 1,
      aux_sym_string_token1,
    ACTIONS(10628), 1,
      anon_sym_Set,
    STATE(5284), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7582), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7590), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(10604), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [549271] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(8993), 1,
      sym_id,
    ACTIONS(8995), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8999), 1,
      anon_sym_record,
    ACTIONS(9001), 1,
      anon_sym_LPAREN,
    ACTIONS(9003), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(9005), 1,
      anon_sym_u2983,
    ACTIONS(9007), 1,
      anon_sym_LBRACE,
    ACTIONS(9009), 1,
      aux_sym__qid_token1,
    ACTIONS(9011), 1,
      anon_sym_DOT,
    ACTIONS(9015), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(9017), 1,
      anon_sym_u2987,
    ACTIONS(9019), 1,
      aux_sym_integer_token1,
    ACTIONS(9021), 1,
      aux_sym_string_token1,
    ACTIONS(9023), 1,
      anon_sym_Set,
    STATE(4677), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7305), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7306), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(8997), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [549347] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(10843), 1,
      sym_id,
    ACTIONS(10845), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10849), 1,
      anon_sym_record,
    ACTIONS(10851), 1,
      anon_sym_LPAREN,
    ACTIONS(10853), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(10855), 1,
      anon_sym_u2983,
    ACTIONS(10857), 1,
      anon_sym_LBRACE,
    ACTIONS(10859), 1,
      aux_sym__qid_token1,
    ACTIONS(10861), 1,
      anon_sym_DOT,
    ACTIONS(10865), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(10867), 1,
      anon_sym_u2987,
    ACTIONS(10869), 1,
      aux_sym_integer_token1,
    ACTIONS(10871), 1,
      aux_sym_string_token1,
    ACTIONS(10873), 1,
      anon_sym_Set,
    STATE(5191), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7705), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7719), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(10847), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [549423] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(10719), 1,
      sym_id,
    ACTIONS(10721), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10725), 1,
      anon_sym_record,
    ACTIONS(10727), 1,
      anon_sym_LPAREN,
    ACTIONS(10729), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(10731), 1,
      anon_sym_u2983,
    ACTIONS(10733), 1,
      anon_sym_LBRACE,
    ACTIONS(10735), 1,
      aux_sym__qid_token1,
    ACTIONS(10737), 1,
      anon_sym_DOT,
    ACTIONS(10741), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(10743), 1,
      anon_sym_u2987,
    ACTIONS(10745), 1,
      aux_sym_integer_token1,
    ACTIONS(10747), 1,
      aux_sym_string_token1,
    ACTIONS(10749), 1,
      anon_sym_Set,
    STATE(5286), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7641), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7631), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(10723), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [549499] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(9507), 1,
      sym_id,
    ACTIONS(9509), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9513), 1,
      anon_sym_record,
    ACTIONS(9515), 1,
      anon_sym_LPAREN,
    ACTIONS(9517), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(9519), 1,
      anon_sym_u2983,
    ACTIONS(9521), 1,
      anon_sym_LBRACE,
    ACTIONS(9523), 1,
      aux_sym__qid_token1,
    ACTIONS(9525), 1,
      anon_sym_DOT,
    ACTIONS(9529), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(9531), 1,
      anon_sym_u2987,
    ACTIONS(9533), 1,
      aux_sym_integer_token1,
    ACTIONS(9535), 1,
      aux_sym_string_token1,
    ACTIONS(9537), 1,
      anon_sym_Set,
    STATE(4782), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7575), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7573), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(9511), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [549575] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(10119), 1,
      sym_id,
    ACTIONS(10123), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10127), 1,
      anon_sym_record,
    ACTIONS(10129), 1,
      anon_sym_LPAREN,
    ACTIONS(10131), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(10133), 1,
      anon_sym_u2983,
    ACTIONS(10135), 1,
      anon_sym_LBRACE,
    ACTIONS(10137), 1,
      aux_sym__qid_token1,
    ACTIONS(10139), 1,
      anon_sym_DOT,
    ACTIONS(10141), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(10143), 1,
      anon_sym_u2987,
    ACTIONS(10145), 1,
      aux_sym_integer_token1,
    ACTIONS(10147), 1,
      aux_sym_string_token1,
    ACTIONS(10149), 1,
      anon_sym_Set,
    STATE(5272), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(7812), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7815), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(10125), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [549651] = 5,
    ACTIONS(73), 1,
      anon_sym_AT,
    ACTIONS(11278), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    STATE(6293), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    ACTIONS(11276), 29,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [549697] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(7065), 1,
      sym_id,
    ACTIONS(7067), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7071), 1,
      anon_sym_record,
    ACTIONS(7073), 1,
      anon_sym_LPAREN,
    ACTIONS(7075), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(7077), 1,
      anon_sym_u2983,
    ACTIONS(7079), 1,
      anon_sym_LBRACE,
    ACTIONS(7081), 1,
      aux_sym__qid_token1,
    ACTIONS(7083), 1,
      anon_sym_DOT,
    ACTIONS(7087), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(7089), 1,
      anon_sym_u2987,
    ACTIONS(7091), 1,
      aux_sym_integer_token1,
    ACTIONS(7093), 1,
      aux_sym_string_token1,
    ACTIONS(7095), 1,
      anon_sym_Set,
    STATE(4072), 2,
      sym_atom,
      aux_sym__atoms,
    STATE(6955), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6945), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(7069), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [549773] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11019), 1,
      sym_id,
    ACTIONS(11021), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11025), 1,
      anon_sym_record,
    ACTIONS(11027), 1,
      anon_sym_LPAREN,
    ACTIONS(11029), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11031), 1,
      anon_sym_u2983,
    ACTIONS(11033), 1,
      anon_sym_LBRACE,
    ACTIONS(11035), 1,
      aux_sym__qid_token1,
    ACTIONS(11037), 1,
      anon_sym_DOT,
    ACTIONS(11041), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11043), 1,
      anon_sym_u2987,
    ACTIONS(11045), 1,
      aux_sym_integer_token1,
    ACTIONS(11047), 1,
      aux_sym_string_token1,
    ACTIONS(11049), 1,
      anon_sym_Set,
    STATE(7711), 1,
      sym_atom,
    STATE(7686), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7699), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11023), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [549848] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(105), 1,
      sym_id,
    ACTIONS(125), 1,
      anon_sym_LPAREN,
    ACTIONS(129), 1,
      anon_sym_u2983,
    ACTIONS(135), 1,
      anon_sym_LBRACE,
    ACTIONS(143), 1,
      aux_sym__qid_token1,
    ACTIONS(145), 1,
      anon_sym_DOT,
    ACTIONS(153), 1,
      anon_sym_u2987,
    ACTIONS(157), 1,
      aux_sym_integer_token1,
    ACTIONS(159), 1,
      anon_sym_Set,
    ACTIONS(4274), 1,
      anon_sym_record,
    ACTIONS(11367), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11369), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11371), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11373), 1,
      aux_sym_string_token1,
    STATE(4328), 1,
      sym_atom,
    STATE(4311), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4327), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(113), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [549923] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6619), 1,
      sym_id,
    ACTIONS(6623), 1,
      anon_sym_record,
    ACTIONS(6625), 1,
      anon_sym_LPAREN,
    ACTIONS(6629), 1,
      anon_sym_u2983,
    ACTIONS(6631), 1,
      anon_sym_LBRACE,
    ACTIONS(6633), 1,
      aux_sym__qid_token1,
    ACTIONS(6635), 1,
      anon_sym_DOT,
    ACTIONS(6639), 1,
      anon_sym_u2987,
    ACTIONS(6641), 1,
      aux_sym_integer_token1,
    ACTIONS(6643), 1,
      anon_sym_Set,
    ACTIONS(11375), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11377), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11379), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11381), 1,
      aux_sym_string_token1,
    STATE(6392), 1,
      sym_atom,
    STATE(6402), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6407), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(6621), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [549998] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(3406), 1,
      sym_id,
    ACTIONS(3416), 1,
      anon_sym_record,
    ACTIONS(3426), 1,
      aux_sym__qid_token1,
    ACTIONS(3436), 1,
      anon_sym_u2987,
    ACTIONS(3440), 1,
      aux_sym_integer_token1,
    ACTIONS(3442), 1,
      anon_sym_Set,
    ACTIONS(4702), 1,
      anon_sym_DOT,
    ACTIONS(11383), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11385), 1,
      anon_sym_LPAREN,
    ACTIONS(11387), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11389), 1,
      anon_sym_u2983,
    ACTIONS(11391), 1,
      anon_sym_LBRACE,
    ACTIONS(11393), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11395), 1,
      aux_sym_string_token1,
    STATE(4155), 1,
      sym_atom,
    STATE(4158), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4162), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3414), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [550073] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(9), 1,
      sym_id,
    ACTIONS(51), 1,
      anon_sym_LPAREN,
    ACTIONS(55), 1,
      anon_sym_u2983,
    ACTIONS(61), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      aux_sym__qid_token1,
    ACTIONS(71), 1,
      anon_sym_DOT,
    ACTIONS(81), 1,
      anon_sym_u2987,
    ACTIONS(87), 1,
      aux_sym_integer_token1,
    ACTIONS(89), 1,
      anon_sym_Set,
    ACTIONS(4280), 1,
      anon_sym_record,
    ACTIONS(11397), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11399), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11401), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11403), 1,
      aux_sym_string_token1,
    STATE(4583), 1,
      sym_atom,
    STATE(4564), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4608), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(17), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [550148] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(5112), 1,
      sym_id,
    ACTIONS(5116), 1,
      anon_sym_record,
    ACTIONS(5118), 1,
      anon_sym_LPAREN,
    ACTIONS(5122), 1,
      anon_sym_u2983,
    ACTIONS(5124), 1,
      anon_sym_LBRACE,
    ACTIONS(5126), 1,
      aux_sym__qid_token1,
    ACTIONS(5128), 1,
      anon_sym_DOT,
    ACTIONS(5132), 1,
      anon_sym_u2987,
    ACTIONS(5134), 1,
      aux_sym_integer_token1,
    ACTIONS(5136), 1,
      anon_sym_Set,
    ACTIONS(11405), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11407), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11409), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11411), 1,
      aux_sym_string_token1,
    STATE(6003), 1,
      sym_atom,
    STATE(6010), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6007), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(5114), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [550223] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2462), 1,
      sym_id,
    ACTIONS(2466), 1,
      anon_sym_record,
    ACTIONS(2476), 1,
      aux_sym__qid_token1,
    ACTIONS(2482), 1,
      anon_sym_u2987,
    ACTIONS(2484), 1,
      aux_sym_integer_token1,
    ACTIONS(2486), 1,
      anon_sym_Set,
    ACTIONS(4686), 1,
      anon_sym_DOT,
    ACTIONS(11413), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11415), 1,
      anon_sym_LPAREN,
    ACTIONS(11417), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11419), 1,
      anon_sym_u2983,
    ACTIONS(11421), 1,
      anon_sym_LBRACE,
    ACTIONS(11423), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11425), 1,
      aux_sym_string_token1,
    STATE(4043), 1,
      sym_atom,
    STATE(4044), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4052), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(2464), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [550298] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6032), 1,
      sym_id,
    ACTIONS(6036), 1,
      anon_sym_record,
    ACTIONS(6038), 1,
      anon_sym_LPAREN,
    ACTIONS(6042), 1,
      anon_sym_u2983,
    ACTIONS(6044), 1,
      anon_sym_LBRACE,
    ACTIONS(6046), 1,
      aux_sym__qid_token1,
    ACTIONS(6048), 1,
      anon_sym_DOT,
    ACTIONS(6052), 1,
      anon_sym_u2987,
    ACTIONS(6054), 1,
      aux_sym_integer_token1,
    ACTIONS(6056), 1,
      anon_sym_Set,
    ACTIONS(11427), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11429), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11431), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11433), 1,
      aux_sym_string_token1,
    STATE(5906), 1,
      sym_atom,
    STATE(5909), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5914), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(6034), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [550373] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(9475), 1,
      sym_id,
    ACTIONS(9477), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9481), 1,
      anon_sym_record,
    ACTIONS(9483), 1,
      anon_sym_LPAREN,
    ACTIONS(9485), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(9487), 1,
      anon_sym_u2983,
    ACTIONS(9489), 1,
      anon_sym_LBRACE,
    ACTIONS(9491), 1,
      aux_sym__qid_token1,
    ACTIONS(9493), 1,
      anon_sym_DOT,
    ACTIONS(9497), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(9499), 1,
      anon_sym_u2987,
    ACTIONS(9501), 1,
      aux_sym_integer_token1,
    ACTIONS(9503), 1,
      aux_sym_string_token1,
    ACTIONS(9505), 1,
      anon_sym_Set,
    STATE(7557), 1,
      sym_atom,
    STATE(7555), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7552), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(9479), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [550448] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6058), 1,
      sym_id,
    ACTIONS(6062), 1,
      anon_sym_record,
    ACTIONS(6064), 1,
      anon_sym_LPAREN,
    ACTIONS(6068), 1,
      anon_sym_u2983,
    ACTIONS(6070), 1,
      anon_sym_LBRACE,
    ACTIONS(6072), 1,
      aux_sym__qid_token1,
    ACTIONS(6074), 1,
      anon_sym_DOT,
    ACTIONS(6078), 1,
      anon_sym_u2987,
    ACTIONS(6080), 1,
      aux_sym_integer_token1,
    ACTIONS(6082), 1,
      anon_sym_Set,
    ACTIONS(11435), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11437), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11439), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11441), 1,
      aux_sym_string_token1,
    STATE(4336), 1,
      sym_atom,
    STATE(4341), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4349), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(6060), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [550523] = 3,
    ACTIONS(6326), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6324), 31,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [550564] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2422), 1,
      sym_id,
    ACTIONS(2434), 1,
      anon_sym_record,
    ACTIONS(2436), 1,
      anon_sym_LPAREN,
    ACTIONS(2440), 1,
      anon_sym_u2983,
    ACTIONS(2442), 1,
      anon_sym_LBRACE,
    ACTIONS(2444), 1,
      aux_sym__qid_token1,
    ACTIONS(2446), 1,
      anon_sym_DOT,
    ACTIONS(2454), 1,
      anon_sym_u2987,
    ACTIONS(2458), 1,
      aux_sym_integer_token1,
    ACTIONS(2460), 1,
      anon_sym_Set,
    ACTIONS(11443), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11445), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11447), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11449), 1,
      aux_sym_string_token1,
    STATE(5414), 1,
      sym_atom,
    STATE(5422), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5423), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(2432), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [550639] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(8993), 1,
      sym_id,
    ACTIONS(8995), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8999), 1,
      anon_sym_record,
    ACTIONS(9001), 1,
      anon_sym_LPAREN,
    ACTIONS(9003), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(9005), 1,
      anon_sym_u2983,
    ACTIONS(9007), 1,
      anon_sym_LBRACE,
    ACTIONS(9009), 1,
      aux_sym__qid_token1,
    ACTIONS(9011), 1,
      anon_sym_DOT,
    ACTIONS(9015), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(9017), 1,
      anon_sym_u2987,
    ACTIONS(9019), 1,
      aux_sym_integer_token1,
    ACTIONS(9021), 1,
      aux_sym_string_token1,
    ACTIONS(9023), 1,
      anon_sym_Set,
    STATE(7298), 1,
      sym_atom,
    STATE(7305), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7306), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(8997), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [550714] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(9539), 1,
      sym_id,
    ACTIONS(9541), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9545), 1,
      anon_sym_record,
    ACTIONS(9547), 1,
      anon_sym_LPAREN,
    ACTIONS(9549), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(9551), 1,
      anon_sym_u2983,
    ACTIONS(9553), 1,
      anon_sym_LBRACE,
    ACTIONS(9555), 1,
      aux_sym__qid_token1,
    ACTIONS(9557), 1,
      anon_sym_DOT,
    ACTIONS(9561), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(9563), 1,
      anon_sym_u2987,
    ACTIONS(9565), 1,
      aux_sym_integer_token1,
    ACTIONS(9567), 1,
      aux_sym_string_token1,
    ACTIONS(9569), 1,
      anon_sym_Set,
    STATE(7604), 1,
      sym_atom,
    STATE(7603), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7600), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(9543), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [550789] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1202), 1,
      aux_sym_integer_token1,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(4548), 1,
      anon_sym_DOT,
    ACTIONS(11451), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11453), 1,
      anon_sym_LPAREN,
    ACTIONS(11455), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11457), 1,
      anon_sym_u2983,
    ACTIONS(11459), 1,
      anon_sym_LBRACE,
    ACTIONS(11461), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11463), 1,
      aux_sym_string_token1,
    STATE(5240), 1,
      sym_atom,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(1174), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [550864] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(7995), 1,
      sym_id,
    ACTIONS(7997), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8001), 1,
      anon_sym_record,
    ACTIONS(8003), 1,
      anon_sym_LPAREN,
    ACTIONS(8005), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(8007), 1,
      anon_sym_u2983,
    ACTIONS(8009), 1,
      anon_sym_LBRACE,
    ACTIONS(8011), 1,
      aux_sym__qid_token1,
    ACTIONS(8013), 1,
      anon_sym_DOT,
    ACTIONS(8017), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(8019), 1,
      anon_sym_u2987,
    ACTIONS(8021), 1,
      aux_sym_integer_token1,
    ACTIONS(8023), 1,
      aux_sym_string_token1,
    ACTIONS(8025), 1,
      anon_sym_Set,
    STATE(7191), 1,
      sym_atom,
    STATE(7226), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7206), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(7999), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [550939] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(9507), 1,
      sym_id,
    ACTIONS(9509), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9513), 1,
      anon_sym_record,
    ACTIONS(9515), 1,
      anon_sym_LPAREN,
    ACTIONS(9517), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(9519), 1,
      anon_sym_u2983,
    ACTIONS(9521), 1,
      anon_sym_LBRACE,
    ACTIONS(9523), 1,
      aux_sym__qid_token1,
    ACTIONS(9525), 1,
      anon_sym_DOT,
    ACTIONS(9529), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(9531), 1,
      anon_sym_u2987,
    ACTIONS(9533), 1,
      aux_sym_integer_token1,
    ACTIONS(9535), 1,
      aux_sym_string_token1,
    ACTIONS(9537), 1,
      anon_sym_Set,
    STATE(7576), 1,
      sym_atom,
    STATE(7575), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7573), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(9511), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [551014] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(9), 1,
      sym_id,
    ACTIONS(51), 1,
      anon_sym_LPAREN,
    ACTIONS(55), 1,
      anon_sym_u2983,
    ACTIONS(61), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      aux_sym__qid_token1,
    ACTIONS(71), 1,
      anon_sym_DOT,
    ACTIONS(81), 1,
      anon_sym_u2987,
    ACTIONS(87), 1,
      aux_sym_integer_token1,
    ACTIONS(89), 1,
      anon_sym_Set,
    ACTIONS(4280), 1,
      anon_sym_record,
    ACTIONS(11397), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11399), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11401), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11403), 1,
      aux_sym_string_token1,
    STATE(4578), 1,
      sym_atom,
    STATE(4564), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4608), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(17), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [551089] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(3814), 1,
      sym_id,
    ACTIONS(3824), 1,
      anon_sym_record,
    ACTIONS(3834), 1,
      aux_sym__qid_token1,
    ACTIONS(3844), 1,
      anon_sym_u2987,
    ACTIONS(3848), 1,
      aux_sym_integer_token1,
    ACTIONS(3850), 1,
      anon_sym_Set,
    ACTIONS(4658), 1,
      anon_sym_LPAREN,
    ACTIONS(4662), 1,
      anon_sym_u2983,
    ACTIONS(4664), 1,
      anon_sym_LBRACE,
    ACTIONS(4666), 1,
      anon_sym_DOT,
    ACTIONS(11465), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11467), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11469), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11471), 1,
      aux_sym_string_token1,
    STATE(4352), 1,
      sym_atom,
    STATE(4342), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4273), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3822), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [551164] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2094), 1,
      sym_id,
    ACTIONS(2106), 1,
      anon_sym_record,
    ACTIONS(2108), 1,
      anon_sym_LPAREN,
    ACTIONS(2112), 1,
      anon_sym_u2983,
    ACTIONS(2114), 1,
      anon_sym_LBRACE,
    ACTIONS(2116), 1,
      aux_sym__qid_token1,
    ACTIONS(2118), 1,
      anon_sym_DOT,
    ACTIONS(2126), 1,
      anon_sym_u2987,
    ACTIONS(2130), 1,
      aux_sym_integer_token1,
    ACTIONS(2132), 1,
      anon_sym_Set,
    ACTIONS(11473), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11475), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11477), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11479), 1,
      aux_sym_string_token1,
    STATE(5439), 1,
      sym_atom,
    STATE(5451), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5453), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(2104), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [551239] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11051), 1,
      sym_id,
    ACTIONS(11053), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11057), 1,
      anon_sym_record,
    ACTIONS(11059), 1,
      anon_sym_LPAREN,
    ACTIONS(11061), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11063), 1,
      anon_sym_u2983,
    ACTIONS(11065), 1,
      anon_sym_LBRACE,
    ACTIONS(11067), 1,
      aux_sym__qid_token1,
    ACTIONS(11069), 1,
      anon_sym_DOT,
    ACTIONS(11073), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11075), 1,
      anon_sym_u2987,
    ACTIONS(11077), 1,
      aux_sym_integer_token1,
    ACTIONS(11079), 1,
      aux_sym_string_token1,
    ACTIONS(11081), 1,
      anon_sym_Set,
    STATE(7729), 1,
      sym_atom,
    STATE(7756), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7737), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11055), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [551314] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2246), 1,
      sym_id,
    ACTIONS(2250), 1,
      anon_sym_record,
    ACTIONS(2260), 1,
      aux_sym__qid_token1,
    ACTIONS(2266), 1,
      anon_sym_u2987,
    ACTIONS(2268), 1,
      aux_sym_integer_token1,
    ACTIONS(2270), 1,
      anon_sym_Set,
    ACTIONS(4738), 1,
      anon_sym_LPAREN,
    ACTIONS(4742), 1,
      anon_sym_u2983,
    ACTIONS(4744), 1,
      anon_sym_LBRACE,
    ACTIONS(4746), 1,
      anon_sym_DOT,
    ACTIONS(11481), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11483), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11485), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11487), 1,
      aux_sym_string_token1,
    STATE(4150), 1,
      sym_atom,
    STATE(4151), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4153), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(2248), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [551389] = 3,
    ACTIONS(6496), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6494), 31,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [551430] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(734), 1,
      sym_id,
    ACTIONS(744), 1,
      anon_sym_record,
    ACTIONS(754), 1,
      aux_sym__qid_token1,
    ACTIONS(768), 1,
      anon_sym_u2987,
    ACTIONS(772), 1,
      aux_sym_integer_token1,
    ACTIONS(774), 1,
      anon_sym_Set,
    ACTIONS(4236), 1,
      anon_sym_DOT,
    ACTIONS(11489), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11491), 1,
      anon_sym_LPAREN,
    ACTIONS(11493), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11495), 1,
      anon_sym_u2983,
    ACTIONS(11497), 1,
      anon_sym_LBRACE,
    ACTIONS(11499), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11501), 1,
      aux_sym_string_token1,
    STATE(5098), 1,
      sym_atom,
    STATE(5108), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5102), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(742), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [551505] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(7509), 1,
      sym_id,
    ACTIONS(7513), 1,
      anon_sym_record,
    ACTIONS(7515), 1,
      anon_sym_LPAREN,
    ACTIONS(7519), 1,
      anon_sym_u2983,
    ACTIONS(7521), 1,
      anon_sym_LBRACE,
    ACTIONS(7523), 1,
      aux_sym__qid_token1,
    ACTIONS(7525), 1,
      anon_sym_DOT,
    ACTIONS(7529), 1,
      anon_sym_u2987,
    ACTIONS(7531), 1,
      aux_sym_integer_token1,
    ACTIONS(7533), 1,
      anon_sym_Set,
    ACTIONS(11503), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11505), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11507), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11509), 1,
      aux_sym_string_token1,
    STATE(7105), 1,
      sym_atom,
    STATE(6904), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7094), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(7511), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [551580] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(3444), 1,
      sym_id,
    ACTIONS(3454), 1,
      anon_sym_record,
    ACTIONS(3464), 1,
      aux_sym__qid_token1,
    ACTIONS(3474), 1,
      anon_sym_u2987,
    ACTIONS(3478), 1,
      aux_sym_integer_token1,
    ACTIONS(3480), 1,
      anon_sym_Set,
    ACTIONS(4842), 1,
      anon_sym_LPAREN,
    ACTIONS(4846), 1,
      anon_sym_u2983,
    ACTIONS(4848), 1,
      anon_sym_LBRACE,
    ACTIONS(4850), 1,
      anon_sym_DOT,
    ACTIONS(11511), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11513), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11515), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11517), 1,
      aux_sym_string_token1,
    STATE(5014), 1,
      sym_atom,
    STATE(5013), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5000), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3452), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [551655] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(692), 1,
      anon_sym_record,
    ACTIONS(694), 1,
      anon_sym_LPAREN,
    ACTIONS(698), 1,
      anon_sym_u2983,
    ACTIONS(702), 1,
      anon_sym_LBRACE,
    ACTIONS(708), 1,
      anon_sym_DOT,
    ACTIONS(720), 1,
      anon_sym_u2987,
    ACTIONS(726), 1,
      aux_sym_integer_token1,
    ACTIONS(728), 1,
      anon_sym_Set,
    ACTIONS(2336), 1,
      sym_id,
    ACTIONS(2342), 1,
      aux_sym__qid_token1,
    ACTIONS(11519), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11521), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11523), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11525), 1,
      aux_sym_string_token1,
    STATE(5052), 1,
      sym_atom,
    STATE(5069), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5056), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(690), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [551730] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6330), 1,
      sym_id,
    ACTIONS(6332), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6338), 1,
      anon_sym_record,
    ACTIONS(6340), 1,
      anon_sym_LPAREN,
    ACTIONS(6342), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(6344), 1,
      anon_sym_u2983,
    ACTIONS(6346), 1,
      anon_sym_LBRACE,
    ACTIONS(6348), 1,
      aux_sym__qid_token1,
    ACTIONS(6350), 1,
      anon_sym_DOT,
    ACTIONS(6354), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(6356), 1,
      anon_sym_u2987,
    ACTIONS(6358), 1,
      aux_sym_integer_token1,
    ACTIONS(6360), 1,
      aux_sym_string_token1,
    ACTIONS(6362), 1,
      anon_sym_Set,
    STATE(6546), 1,
      sym_atom,
    STATE(6547), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6549), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(6334), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [551805] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(3638), 1,
      sym_id,
    ACTIONS(3644), 1,
      anon_sym_record,
    ACTIONS(3646), 1,
      anon_sym_LPAREN,
    ACTIONS(3650), 1,
      anon_sym_u2983,
    ACTIONS(3652), 1,
      anon_sym_LBRACE,
    ACTIONS(3654), 1,
      aux_sym__qid_token1,
    ACTIONS(3656), 1,
      anon_sym_DOT,
    ACTIONS(3660), 1,
      anon_sym_u2987,
    ACTIONS(3662), 1,
      aux_sym_integer_token1,
    ACTIONS(3664), 1,
      anon_sym_Set,
    ACTIONS(11527), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11529), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11531), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11533), 1,
      aux_sym_string_token1,
    STATE(5679), 1,
      sym_atom,
    STATE(5680), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5681), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3642), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [551880] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(5708), 1,
      sym_id,
    ACTIONS(5712), 1,
      anon_sym_record,
    ACTIONS(5714), 1,
      anon_sym_LPAREN,
    ACTIONS(5718), 1,
      anon_sym_u2983,
    ACTIONS(5720), 1,
      anon_sym_LBRACE,
    ACTIONS(5722), 1,
      aux_sym__qid_token1,
    ACTIONS(5724), 1,
      anon_sym_DOT,
    ACTIONS(5728), 1,
      anon_sym_u2987,
    ACTIONS(5730), 1,
      aux_sym_integer_token1,
    ACTIONS(5732), 1,
      anon_sym_Set,
    ACTIONS(11535), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11537), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11539), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11541), 1,
      aux_sym_string_token1,
    STATE(5561), 1,
      sym_atom,
    STATE(5553), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5550), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(5710), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [551955] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(3262), 1,
      sym_id,
    ACTIONS(3272), 1,
      anon_sym_record,
    ACTIONS(3282), 1,
      aux_sym__qid_token1,
    ACTIONS(3292), 1,
      anon_sym_u2987,
    ACTIONS(3296), 1,
      aux_sym_integer_token1,
    ACTIONS(3298), 1,
      anon_sym_Set,
    ACTIONS(4362), 1,
      anon_sym_DOT,
    ACTIONS(11543), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11545), 1,
      anon_sym_LPAREN,
    ACTIONS(11547), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11549), 1,
      anon_sym_u2983,
    ACTIONS(11551), 1,
      anon_sym_LBRACE,
    ACTIONS(11553), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11555), 1,
      aux_sym_string_token1,
    STATE(4036), 1,
      sym_atom,
    STATE(4032), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4012), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3270), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [552030] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2938), 1,
      sym_id,
    ACTIONS(2950), 1,
      anon_sym_record,
    ACTIONS(2952), 1,
      anon_sym_LPAREN,
    ACTIONS(2956), 1,
      anon_sym_u2983,
    ACTIONS(2958), 1,
      anon_sym_LBRACE,
    ACTIONS(2960), 1,
      aux_sym__qid_token1,
    ACTIONS(2962), 1,
      anon_sym_DOT,
    ACTIONS(2970), 1,
      anon_sym_u2987,
    ACTIONS(2974), 1,
      aux_sym_integer_token1,
    ACTIONS(2976), 1,
      anon_sym_Set,
    ACTIONS(11557), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11559), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11561), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11563), 1,
      aux_sym_string_token1,
    STATE(5847), 1,
      sym_atom,
    STATE(5870), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5838), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(2948), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [552105] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(3760), 1,
      sym_id,
    ACTIONS(3764), 1,
      anon_sym_record,
    ACTIONS(3774), 1,
      aux_sym__qid_token1,
    ACTIONS(3780), 1,
      anon_sym_u2987,
    ACTIONS(3782), 1,
      aux_sym_integer_token1,
    ACTIONS(3784), 1,
      anon_sym_Set,
    ACTIONS(4816), 1,
      anon_sym_LPAREN,
    ACTIONS(4820), 1,
      anon_sym_u2983,
    ACTIONS(4822), 1,
      anon_sym_LBRACE,
    ACTIONS(4824), 1,
      anon_sym_DOT,
    ACTIONS(11565), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11567), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11569), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11571), 1,
      aux_sym_string_token1,
    STATE(4618), 1,
      sym_atom,
    STATE(4599), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4613), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3762), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [552180] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(7432), 1,
      sym_id,
    ACTIONS(7434), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7438), 1,
      anon_sym_record,
    ACTIONS(7440), 1,
      anon_sym_LPAREN,
    ACTIONS(7442), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(7444), 1,
      anon_sym_u2983,
    ACTIONS(7446), 1,
      anon_sym_LBRACE,
    ACTIONS(7448), 1,
      aux_sym__qid_token1,
    ACTIONS(7450), 1,
      anon_sym_DOT,
    ACTIONS(7454), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(7456), 1,
      anon_sym_u2987,
    ACTIONS(7458), 1,
      aux_sym_integer_token1,
    ACTIONS(7460), 1,
      aux_sym_string_token1,
    ACTIONS(7462), 1,
      anon_sym_Set,
    STATE(7166), 1,
      sym_atom,
    STATE(7168), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7173), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(7436), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [552255] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6006), 1,
      sym_id,
    ACTIONS(6010), 1,
      anon_sym_record,
    ACTIONS(6012), 1,
      anon_sym_LPAREN,
    ACTIONS(6016), 1,
      anon_sym_u2983,
    ACTIONS(6018), 1,
      anon_sym_LBRACE,
    ACTIONS(6020), 1,
      aux_sym__qid_token1,
    ACTIONS(6022), 1,
      anon_sym_DOT,
    ACTIONS(6026), 1,
      anon_sym_u2987,
    ACTIONS(6028), 1,
      aux_sym_integer_token1,
    ACTIONS(6030), 1,
      anon_sym_Set,
    ACTIONS(11573), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11575), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11577), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11579), 1,
      aux_sym_string_token1,
    STATE(4897), 1,
      sym_atom,
    STATE(4881), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4870), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(6008), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [552330] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6912), 1,
      sym_id,
    ACTIONS(6914), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6918), 1,
      anon_sym_record,
    ACTIONS(6924), 1,
      anon_sym_LPAREN,
    ACTIONS(6930), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(6932), 1,
      anon_sym_u2983,
    ACTIONS(6934), 1,
      anon_sym_LBRACE,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(6940), 1,
      anon_sym_DOT,
    ACTIONS(6942), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(6944), 1,
      anon_sym_u2987,
    ACTIONS(6946), 1,
      aux_sym_integer_token1,
    ACTIONS(6948), 1,
      aux_sym_string_token1,
    ACTIONS(6950), 1,
      anon_sym_Set,
    STATE(7287), 1,
      sym_atom,
    STATE(7268), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7266), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(6916), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [552405] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(3168), 1,
      sym_id,
    ACTIONS(3180), 1,
      anon_sym_record,
    ACTIONS(3182), 1,
      anon_sym_LPAREN,
    ACTIONS(3186), 1,
      anon_sym_u2983,
    ACTIONS(3188), 1,
      anon_sym_LBRACE,
    ACTIONS(3190), 1,
      aux_sym__qid_token1,
    ACTIONS(3192), 1,
      anon_sym_DOT,
    ACTIONS(3200), 1,
      anon_sym_u2987,
    ACTIONS(3204), 1,
      aux_sym_integer_token1,
    ACTIONS(3206), 1,
      anon_sym_Set,
    ACTIONS(11581), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11583), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11585), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11587), 1,
      aux_sym_string_token1,
    STATE(4955), 1,
      sym_atom,
    STATE(4934), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4921), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3178), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [552480] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(3520), 1,
      sym_id,
    ACTIONS(3528), 1,
      anon_sym_record,
    ACTIONS(3530), 1,
      anon_sym_LPAREN,
    ACTIONS(3534), 1,
      anon_sym_u2983,
    ACTIONS(3536), 1,
      anon_sym_LBRACE,
    ACTIONS(3538), 1,
      aux_sym__qid_token1,
    ACTIONS(3540), 1,
      anon_sym_DOT,
    ACTIONS(3546), 1,
      anon_sym_u2987,
    ACTIONS(3548), 1,
      aux_sym_integer_token1,
    ACTIONS(3550), 1,
      anon_sym_Set,
    ACTIONS(11589), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11591), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11593), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11595), 1,
      aux_sym_string_token1,
    STATE(5534), 1,
      sym_atom,
    STATE(5537), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5538), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3526), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [552555] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(3694), 1,
      sym_id,
    ACTIONS(3704), 1,
      anon_sym_record,
    ACTIONS(3714), 1,
      aux_sym__qid_token1,
    ACTIONS(3724), 1,
      anon_sym_u2987,
    ACTIONS(3728), 1,
      aux_sym_integer_token1,
    ACTIONS(3730), 1,
      anon_sym_Set,
    ACTIONS(4774), 1,
      anon_sym_LPAREN,
    ACTIONS(4778), 1,
      anon_sym_u2983,
    ACTIONS(4780), 1,
      anon_sym_LBRACE,
    ACTIONS(4782), 1,
      anon_sym_DOT,
    ACTIONS(11597), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11599), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11601), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11603), 1,
      aux_sym_string_token1,
    STATE(4471), 1,
      sym_atom,
    STATE(4467), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4459), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3702), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [552630] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2566), 1,
      sym_id,
    ACTIONS(2576), 1,
      anon_sym_record,
    ACTIONS(2586), 1,
      aux_sym__qid_token1,
    ACTIONS(2596), 1,
      anon_sym_u2987,
    ACTIONS(2600), 1,
      aux_sym_integer_token1,
    ACTIONS(2602), 1,
      anon_sym_Set,
    ACTIONS(4602), 1,
      anon_sym_DOT,
    ACTIONS(11605), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11607), 1,
      anon_sym_LPAREN,
    ACTIONS(11609), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11611), 1,
      anon_sym_u2983,
    ACTIONS(11613), 1,
      anon_sym_LBRACE,
    ACTIONS(11615), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11617), 1,
      aux_sym_string_token1,
    STATE(5592), 1,
      sym_atom,
    STATE(5566), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5590), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(2574), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [552705] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1280), 1,
      aux_sym_integer_token1,
    ACTIONS(1282), 1,
      anon_sym_Set,
    ACTIONS(4396), 1,
      anon_sym_LPAREN,
    ACTIONS(4400), 1,
      anon_sym_u2983,
    ACTIONS(4402), 1,
      anon_sym_LBRACE,
    ACTIONS(4404), 1,
      anon_sym_DOT,
    ACTIONS(11619), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11621), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11623), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11625), 1,
      aux_sym_string_token1,
    STATE(5443), 1,
      sym_atom,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(1252), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [552780] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6840), 1,
      sym_id,
    ACTIONS(6842), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6846), 1,
      anon_sym_record,
    ACTIONS(6848), 1,
      anon_sym_LPAREN,
    ACTIONS(6850), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(6852), 1,
      anon_sym_u2983,
    ACTIONS(6854), 1,
      anon_sym_LBRACE,
    ACTIONS(6856), 1,
      aux_sym__qid_token1,
    ACTIONS(6858), 1,
      anon_sym_DOT,
    ACTIONS(6862), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(6864), 1,
      anon_sym_u2987,
    ACTIONS(6866), 1,
      aux_sym_integer_token1,
    ACTIONS(6868), 1,
      aux_sym_string_token1,
    ACTIONS(6870), 1,
      anon_sym_Set,
    STATE(7077), 1,
      sym_atom,
    STATE(7069), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7066), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(6844), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [552855] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(7880), 1,
      sym_id,
    ACTIONS(7882), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7886), 1,
      anon_sym_record,
    ACTIONS(7888), 1,
      anon_sym_LPAREN,
    ACTIONS(7890), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(7892), 1,
      anon_sym_u2983,
    ACTIONS(7894), 1,
      anon_sym_LBRACE,
    ACTIONS(7896), 1,
      aux_sym__qid_token1,
    ACTIONS(7898), 1,
      anon_sym_DOT,
    ACTIONS(7902), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(7904), 1,
      anon_sym_u2987,
    ACTIONS(7906), 1,
      aux_sym_integer_token1,
    ACTIONS(7908), 1,
      aux_sym_string_token1,
    ACTIONS(7910), 1,
      anon_sym_Set,
    STATE(7275), 1,
      sym_atom,
    STATE(7276), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7267), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(7884), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [552930] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(5218), 1,
      sym_id,
    ACTIONS(5224), 1,
      anon_sym_record,
    ACTIONS(5226), 1,
      anon_sym_LPAREN,
    ACTIONS(5230), 1,
      anon_sym_u2983,
    ACTIONS(5232), 1,
      anon_sym_LBRACE,
    ACTIONS(5234), 1,
      aux_sym__qid_token1,
    ACTIONS(5236), 1,
      anon_sym_DOT,
    ACTIONS(5240), 1,
      anon_sym_u2987,
    ACTIONS(5242), 1,
      aux_sym_integer_token1,
    ACTIONS(5244), 1,
      anon_sym_Set,
    ACTIONS(11627), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11629), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11631), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11633), 1,
      aux_sym_string_token1,
    STATE(6176), 1,
      sym_atom,
    STATE(6166), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6188), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(5222), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [553005] = 3,
    ACTIONS(6496), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6494), 31,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [553046] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2488), 1,
      sym_id,
    ACTIONS(2498), 1,
      anon_sym_record,
    ACTIONS(2508), 1,
      aux_sym__qid_token1,
    ACTIONS(2518), 1,
      anon_sym_u2987,
    ACTIONS(2522), 1,
      aux_sym_integer_token1,
    ACTIONS(2524), 1,
      anon_sym_Set,
    ACTIONS(4506), 1,
      anon_sym_LPAREN,
    ACTIONS(4510), 1,
      anon_sym_u2983,
    ACTIONS(4512), 1,
      anon_sym_LBRACE,
    ACTIONS(4514), 1,
      anon_sym_DOT,
    ACTIONS(11635), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11637), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11639), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11641), 1,
      aux_sym_string_token1,
    STATE(5692), 1,
      sym_atom,
    STATE(5713), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5698), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(2496), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [553121] = 3,
    ACTIONS(6655), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6653), 31,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [553162] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(10119), 1,
      sym_id,
    ACTIONS(10123), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10127), 1,
      anon_sym_record,
    ACTIONS(10129), 1,
      anon_sym_LPAREN,
    ACTIONS(10131), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(10133), 1,
      anon_sym_u2983,
    ACTIONS(10135), 1,
      anon_sym_LBRACE,
    ACTIONS(10137), 1,
      aux_sym__qid_token1,
    ACTIONS(10139), 1,
      anon_sym_DOT,
    ACTIONS(10141), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(10143), 1,
      anon_sym_u2987,
    ACTIONS(10145), 1,
      aux_sym_integer_token1,
    ACTIONS(10147), 1,
      aux_sym_string_token1,
    ACTIONS(10149), 1,
      anon_sym_Set,
    STATE(7819), 1,
      sym_atom,
    STATE(7812), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7815), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(10125), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [553237] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(3208), 1,
      sym_id,
    ACTIONS(3212), 1,
      anon_sym_record,
    ACTIONS(3214), 1,
      anon_sym_LPAREN,
    ACTIONS(3218), 1,
      anon_sym_u2983,
    ACTIONS(3220), 1,
      anon_sym_LBRACE,
    ACTIONS(3222), 1,
      aux_sym__qid_token1,
    ACTIONS(3224), 1,
      anon_sym_DOT,
    ACTIONS(3228), 1,
      anon_sym_u2987,
    ACTIONS(3230), 1,
      aux_sym_integer_token1,
    ACTIONS(3232), 1,
      anon_sym_Set,
    ACTIONS(11643), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11645), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11647), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11649), 1,
      aux_sym_string_token1,
    STATE(5578), 1,
      sym_atom,
    STATE(5579), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5582), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3210), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [553312] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(894), 1,
      sym_id,
    ACTIONS(904), 1,
      anon_sym_record,
    ACTIONS(916), 1,
      aux_sym__qid_token1,
    ACTIONS(926), 1,
      anon_sym_u2987,
    ACTIONS(930), 1,
      aux_sym_integer_token1,
    ACTIONS(932), 1,
      anon_sym_Set,
    ACTIONS(4328), 1,
      anon_sym_DOT,
    ACTIONS(11651), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11653), 1,
      anon_sym_LPAREN,
    ACTIONS(11655), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11657), 1,
      anon_sym_u2983,
    ACTIONS(11659), 1,
      anon_sym_LBRACE,
    ACTIONS(11661), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11663), 1,
      aux_sym_string_token1,
    STATE(4973), 1,
      sym_atom,
    STATE(4961), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4920), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(902), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [553387] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(5760), 1,
      sym_id,
    ACTIONS(5764), 1,
      anon_sym_record,
    ACTIONS(5766), 1,
      anon_sym_LPAREN,
    ACTIONS(5770), 1,
      anon_sym_u2983,
    ACTIONS(5772), 1,
      anon_sym_LBRACE,
    ACTIONS(5774), 1,
      aux_sym__qid_token1,
    ACTIONS(5776), 1,
      anon_sym_DOT,
    ACTIONS(5780), 1,
      anon_sym_u2987,
    ACTIONS(5782), 1,
      aux_sym_integer_token1,
    ACTIONS(5784), 1,
      anon_sym_Set,
    ACTIONS(11665), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11667), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11669), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11671), 1,
      aux_sym_string_token1,
    STATE(5972), 1,
      sym_atom,
    STATE(5941), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5965), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(5762), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [553462] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2690), 1,
      sym_id,
    ACTIONS(2700), 1,
      anon_sym_record,
    ACTIONS(2710), 1,
      aux_sym__qid_token1,
    ACTIONS(2720), 1,
      anon_sym_u2987,
    ACTIONS(2724), 1,
      aux_sym_integer_token1,
    ACTIONS(2726), 1,
      anon_sym_Set,
    ACTIONS(4452), 1,
      anon_sym_DOT,
    ACTIONS(11673), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11675), 1,
      anon_sym_LPAREN,
    ACTIONS(11677), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11679), 1,
      anon_sym_u2983,
    ACTIONS(11681), 1,
      anon_sym_LBRACE,
    ACTIONS(11683), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11685), 1,
      aux_sym_string_token1,
    STATE(4109), 1,
      sym_atom,
    STATE(4108), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4103), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(2698), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [553537] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(9636), 1,
      sym_id,
    ACTIONS(9638), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9642), 1,
      anon_sym_record,
    ACTIONS(9644), 1,
      anon_sym_LPAREN,
    ACTIONS(9646), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(9648), 1,
      anon_sym_u2983,
    ACTIONS(9650), 1,
      anon_sym_LBRACE,
    ACTIONS(9652), 1,
      aux_sym__qid_token1,
    ACTIONS(9654), 1,
      anon_sym_DOT,
    ACTIONS(9658), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(9660), 1,
      anon_sym_u2987,
    ACTIONS(9662), 1,
      aux_sym_integer_token1,
    ACTIONS(9664), 1,
      aux_sym_string_token1,
    ACTIONS(9666), 1,
      anon_sym_Set,
    STATE(7580), 1,
      sym_atom,
    STATE(7594), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7606), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(9640), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [553612] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(5360), 1,
      sym_id,
    ACTIONS(5364), 1,
      anon_sym_record,
    ACTIONS(5366), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_u2983,
    ACTIONS(5372), 1,
      anon_sym_LBRACE,
    ACTIONS(5374), 1,
      aux_sym__qid_token1,
    ACTIONS(5376), 1,
      anon_sym_DOT,
    ACTIONS(5380), 1,
      anon_sym_u2987,
    ACTIONS(5382), 1,
      aux_sym_integer_token1,
    ACTIONS(5384), 1,
      anon_sym_Set,
    ACTIONS(11687), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11689), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11691), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11693), 1,
      aux_sym_string_token1,
    STATE(5037), 1,
      sym_atom,
    STATE(5038), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4980), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(5362), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [553687] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(7535), 1,
      sym_id,
    ACTIONS(7537), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7541), 1,
      anon_sym_record,
    ACTIONS(7543), 1,
      anon_sym_LPAREN,
    ACTIONS(7545), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(7547), 1,
      anon_sym_u2983,
    ACTIONS(7549), 1,
      anon_sym_LBRACE,
    ACTIONS(7551), 1,
      aux_sym__qid_token1,
    ACTIONS(7553), 1,
      anon_sym_DOT,
    ACTIONS(7557), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(7559), 1,
      anon_sym_u2987,
    ACTIONS(7561), 1,
      aux_sym_integer_token1,
    ACTIONS(7563), 1,
      aux_sym_string_token1,
    ACTIONS(7565), 1,
      anon_sym_Set,
    STATE(7125), 1,
      sym_atom,
    STATE(7129), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7130), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(7539), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [553762] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(850), 1,
      sym_id,
    ACTIONS(860), 1,
      anon_sym_record,
    ACTIONS(872), 1,
      aux_sym__qid_token1,
    ACTIONS(884), 1,
      anon_sym_u2987,
    ACTIONS(890), 1,
      aux_sym_integer_token1,
    ACTIONS(892), 1,
      anon_sym_Set,
    ACTIONS(4298), 1,
      anon_sym_DOT,
    ACTIONS(11695), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11697), 1,
      anon_sym_LPAREN,
    ACTIONS(11699), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11701), 1,
      anon_sym_u2983,
    ACTIONS(11703), 1,
      anon_sym_LBRACE,
    ACTIONS(11705), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11707), 1,
      aux_sym_string_token1,
    STATE(5163), 1,
      sym_atom,
    STATE(5180), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5168), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(858), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [553837] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(3814), 1,
      sym_id,
    ACTIONS(3824), 1,
      anon_sym_record,
    ACTIONS(3834), 1,
      aux_sym__qid_token1,
    ACTIONS(3844), 1,
      anon_sym_u2987,
    ACTIONS(3848), 1,
      aux_sym_integer_token1,
    ACTIONS(3850), 1,
      anon_sym_Set,
    ACTIONS(4658), 1,
      anon_sym_LPAREN,
    ACTIONS(4662), 1,
      anon_sym_u2983,
    ACTIONS(4664), 1,
      anon_sym_LBRACE,
    ACTIONS(4666), 1,
      anon_sym_DOT,
    ACTIONS(11465), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11467), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11469), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11471), 1,
      aux_sym_string_token1,
    STATE(4343), 1,
      sym_atom,
    STATE(4342), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4273), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3822), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [553912] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11244), 1,
      sym_id,
    ACTIONS(11246), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11250), 1,
      anon_sym_record,
    ACTIONS(11252), 1,
      anon_sym_LPAREN,
    ACTIONS(11254), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11256), 1,
      anon_sym_u2983,
    ACTIONS(11258), 1,
      anon_sym_LBRACE,
    ACTIONS(11260), 1,
      aux_sym__qid_token1,
    ACTIONS(11262), 1,
      anon_sym_DOT,
    ACTIONS(11264), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11266), 1,
      anon_sym_u2987,
    ACTIONS(11268), 1,
      aux_sym_integer_token1,
    ACTIONS(11270), 1,
      aux_sym_string_token1,
    ACTIONS(11272), 1,
      anon_sym_Set,
    STATE(7836), 1,
      sym_atom,
    STATE(7835), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7830), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11248), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [553987] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(4248), 1,
      sym_id,
    ACTIONS(4252), 1,
      anon_sym_record,
    ACTIONS(4254), 1,
      anon_sym_LPAREN,
    ACTIONS(4258), 1,
      anon_sym_u2983,
    ACTIONS(4260), 1,
      anon_sym_LBRACE,
    ACTIONS(4262), 1,
      aux_sym__qid_token1,
    ACTIONS(4264), 1,
      anon_sym_DOT,
    ACTIONS(4268), 1,
      anon_sym_u2987,
    ACTIONS(4270), 1,
      aux_sym_integer_token1,
    ACTIONS(4272), 1,
      anon_sym_Set,
    ACTIONS(11709), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11711), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11713), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11715), 1,
      aux_sym_string_token1,
    STATE(5953), 1,
      sym_atom,
    STATE(5952), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5976), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(4250), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [554062] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(3584), 1,
      sym_id,
    ACTIONS(3588), 1,
      anon_sym_record,
    ACTIONS(3598), 1,
      aux_sym__qid_token1,
    ACTIONS(3604), 1,
      anon_sym_u2987,
    ACTIONS(3606), 1,
      aux_sym_integer_token1,
    ACTIONS(3608), 1,
      anon_sym_Set,
    ACTIONS(4788), 1,
      anon_sym_LPAREN,
    ACTIONS(4792), 1,
      anon_sym_u2983,
    ACTIONS(4794), 1,
      anon_sym_LBRACE,
    ACTIONS(4796), 1,
      anon_sym_DOT,
    ACTIONS(11717), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11719), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11721), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11723), 1,
      aux_sym_string_token1,
    STATE(4393), 1,
      sym_atom,
    STATE(4400), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4403), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3586), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [554137] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(10119), 1,
      sym_id,
    ACTIONS(10123), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10127), 1,
      anon_sym_record,
    ACTIONS(10129), 1,
      anon_sym_LPAREN,
    ACTIONS(10131), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(10133), 1,
      anon_sym_u2983,
    ACTIONS(10135), 1,
      anon_sym_LBRACE,
    ACTIONS(10137), 1,
      aux_sym__qid_token1,
    ACTIONS(10139), 1,
      anon_sym_DOT,
    ACTIONS(10141), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(10143), 1,
      anon_sym_u2987,
    ACTIONS(10145), 1,
      aux_sym_integer_token1,
    ACTIONS(10147), 1,
      aux_sym_string_token1,
    ACTIONS(10149), 1,
      anon_sym_Set,
    STATE(7816), 1,
      sym_atom,
    STATE(7812), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7815), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(10125), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [554212] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2898), 1,
      sym_id,
    ACTIONS(2910), 1,
      anon_sym_record,
    ACTIONS(2912), 1,
      anon_sym_LPAREN,
    ACTIONS(2916), 1,
      anon_sym_u2983,
    ACTIONS(2918), 1,
      anon_sym_LBRACE,
    ACTIONS(2920), 1,
      aux_sym__qid_token1,
    ACTIONS(2922), 1,
      anon_sym_DOT,
    ACTIONS(2930), 1,
      anon_sym_u2987,
    ACTIONS(2934), 1,
      aux_sym_integer_token1,
    ACTIONS(2936), 1,
      anon_sym_Set,
    ACTIONS(11725), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11727), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11729), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11731), 1,
      aux_sym_string_token1,
    STATE(4222), 1,
      sym_atom,
    STATE(4184), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4206), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(2908), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [554287] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(9398), 1,
      sym_id,
    ACTIONS(9400), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9404), 1,
      anon_sym_record,
    ACTIONS(9406), 1,
      anon_sym_LPAREN,
    ACTIONS(9408), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(9410), 1,
      anon_sym_u2983,
    ACTIONS(9412), 1,
      anon_sym_LBRACE,
    ACTIONS(9414), 1,
      aux_sym__qid_token1,
    ACTIONS(9416), 1,
      anon_sym_DOT,
    ACTIONS(9420), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(9422), 1,
      anon_sym_u2987,
    ACTIONS(9424), 1,
      aux_sym_integer_token1,
    ACTIONS(9426), 1,
      aux_sym_string_token1,
    ACTIONS(9428), 1,
      anon_sym_Set,
    STATE(7473), 1,
      sym_atom,
    STATE(7502), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7501), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(9402), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [554362] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(7535), 1,
      sym_id,
    ACTIONS(7537), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7541), 1,
      anon_sym_record,
    ACTIONS(7543), 1,
      anon_sym_LPAREN,
    ACTIONS(7545), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(7547), 1,
      anon_sym_u2983,
    ACTIONS(7549), 1,
      anon_sym_LBRACE,
    ACTIONS(7551), 1,
      aux_sym__qid_token1,
    ACTIONS(7553), 1,
      anon_sym_DOT,
    ACTIONS(7557), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(7559), 1,
      anon_sym_u2987,
    ACTIONS(7561), 1,
      aux_sym_integer_token1,
    ACTIONS(7563), 1,
      aux_sym_string_token1,
    ACTIONS(7565), 1,
      anon_sym_Set,
    STATE(7131), 1,
      sym_atom,
    STATE(7129), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7130), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(7539), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [554437] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(3482), 1,
      sym_id,
    ACTIONS(3492), 1,
      anon_sym_record,
    ACTIONS(3502), 1,
      aux_sym__qid_token1,
    ACTIONS(3512), 1,
      anon_sym_u2987,
    ACTIONS(3516), 1,
      aux_sym_integer_token1,
    ACTIONS(3518), 1,
      anon_sym_Set,
    ACTIONS(4552), 1,
      anon_sym_LPAREN,
    ACTIONS(4556), 1,
      anon_sym_u2983,
    ACTIONS(4558), 1,
      anon_sym_LBRACE,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(11733), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11735), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11737), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11739), 1,
      aux_sym_string_token1,
    STATE(4374), 1,
      sym_atom,
    STATE(4382), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4385), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3490), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [554512] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(5028), 1,
      sym_id,
    ACTIONS(5032), 1,
      anon_sym_record,
    ACTIONS(5034), 1,
      anon_sym_LPAREN,
    ACTIONS(5038), 1,
      anon_sym_u2983,
    ACTIONS(5040), 1,
      anon_sym_LBRACE,
    ACTIONS(5042), 1,
      aux_sym__qid_token1,
    ACTIONS(5044), 1,
      anon_sym_DOT,
    ACTIONS(5048), 1,
      anon_sym_u2987,
    ACTIONS(5050), 1,
      aux_sym_integer_token1,
    ACTIONS(5052), 1,
      anon_sym_Set,
    ACTIONS(11741), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11743), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11745), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11747), 1,
      aux_sym_string_token1,
    STATE(5394), 1,
      sym_atom,
    STATE(5401), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5405), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(5030), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [554587] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(5192), 1,
      sym_id,
    ACTIONS(5196), 1,
      anon_sym_record,
    ACTIONS(5198), 1,
      anon_sym_LPAREN,
    ACTIONS(5202), 1,
      anon_sym_u2983,
    ACTIONS(5204), 1,
      anon_sym_LBRACE,
    ACTIONS(5206), 1,
      aux_sym__qid_token1,
    ACTIONS(5208), 1,
      anon_sym_DOT,
    ACTIONS(5212), 1,
      anon_sym_u2987,
    ACTIONS(5214), 1,
      aux_sym_integer_token1,
    ACTIONS(5216), 1,
      anon_sym_Set,
    ACTIONS(11749), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11751), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11753), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11755), 1,
      aux_sym_string_token1,
    STATE(5741), 1,
      sym_atom,
    STATE(5737), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5736), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(5194), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [554662] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(9240), 1,
      sym_id,
    ACTIONS(9242), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9246), 1,
      anon_sym_record,
    ACTIONS(9248), 1,
      anon_sym_LPAREN,
    ACTIONS(9250), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(9252), 1,
      anon_sym_u2983,
    ACTIONS(9254), 1,
      anon_sym_LBRACE,
    ACTIONS(9256), 1,
      aux_sym__qid_token1,
    ACTIONS(9258), 1,
      anon_sym_DOT,
    ACTIONS(9262), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(9264), 1,
      anon_sym_u2987,
    ACTIONS(9266), 1,
      aux_sym_integer_token1,
    ACTIONS(9268), 1,
      aux_sym_string_token1,
    ACTIONS(9270), 1,
      anon_sym_Set,
    STATE(7485), 1,
      sym_atom,
    STATE(7475), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7469), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(9244), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [554737] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(5360), 1,
      sym_id,
    ACTIONS(5364), 1,
      anon_sym_record,
    ACTIONS(5366), 1,
      anon_sym_LPAREN,
    ACTIONS(5370), 1,
      anon_sym_u2983,
    ACTIONS(5372), 1,
      anon_sym_LBRACE,
    ACTIONS(5374), 1,
      aux_sym__qid_token1,
    ACTIONS(5376), 1,
      anon_sym_DOT,
    ACTIONS(5380), 1,
      anon_sym_u2987,
    ACTIONS(5382), 1,
      aux_sym_integer_token1,
    ACTIONS(5384), 1,
      anon_sym_Set,
    ACTIONS(11687), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11689), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11691), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11693), 1,
      aux_sym_string_token1,
    STATE(5082), 1,
      sym_atom,
    STATE(5038), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4980), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(5362), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [554812] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(10379), 1,
      sym_id,
    ACTIONS(10381), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10385), 1,
      anon_sym_record,
    ACTIONS(10387), 1,
      anon_sym_LPAREN,
    ACTIONS(10389), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(10391), 1,
      anon_sym_u2983,
    ACTIONS(10393), 1,
      anon_sym_LBRACE,
    ACTIONS(10395), 1,
      aux_sym__qid_token1,
    ACTIONS(10397), 1,
      anon_sym_DOT,
    ACTIONS(10401), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(10403), 1,
      anon_sym_u2987,
    ACTIONS(10405), 1,
      aux_sym_integer_token1,
    ACTIONS(10407), 1,
      aux_sym_string_token1,
    ACTIONS(10409), 1,
      anon_sym_Set,
    STATE(7769), 1,
      sym_atom,
    STATE(7690), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7735), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(10383), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [554887] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6006), 1,
      sym_id,
    ACTIONS(6010), 1,
      anon_sym_record,
    ACTIONS(6012), 1,
      anon_sym_LPAREN,
    ACTIONS(6016), 1,
      anon_sym_u2983,
    ACTIONS(6018), 1,
      anon_sym_LBRACE,
    ACTIONS(6020), 1,
      aux_sym__qid_token1,
    ACTIONS(6022), 1,
      anon_sym_DOT,
    ACTIONS(6026), 1,
      anon_sym_u2987,
    ACTIONS(6028), 1,
      aux_sym_integer_token1,
    ACTIONS(6030), 1,
      anon_sym_Set,
    ACTIONS(11573), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11575), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11577), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11579), 1,
      aux_sym_string_token1,
    STATE(4882), 1,
      sym_atom,
    STATE(4881), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4870), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(6008), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [554962] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(940), 1,
      sym_id,
    ACTIONS(950), 1,
      anon_sym_record,
    ACTIONS(960), 1,
      aux_sym__qid_token1,
    ACTIONS(970), 1,
      anon_sym_u2987,
    ACTIONS(974), 1,
      aux_sym_integer_token1,
    ACTIONS(976), 1,
      anon_sym_Set,
    ACTIONS(4588), 1,
      anon_sym_DOT,
    ACTIONS(11757), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11759), 1,
      anon_sym_LPAREN,
    ACTIONS(11761), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11763), 1,
      anon_sym_u2983,
    ACTIONS(11765), 1,
      anon_sym_LBRACE,
    ACTIONS(11767), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11769), 1,
      aux_sym_string_token1,
    STATE(4746), 1,
      sym_atom,
    STATE(4733), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4742), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(948), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [555037] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2206), 1,
      sym_id,
    ACTIONS(2218), 1,
      anon_sym_record,
    ACTIONS(2220), 1,
      anon_sym_LPAREN,
    ACTIONS(2224), 1,
      anon_sym_u2983,
    ACTIONS(2226), 1,
      anon_sym_LBRACE,
    ACTIONS(2228), 1,
      aux_sym__qid_token1,
    ACTIONS(2230), 1,
      anon_sym_DOT,
    ACTIONS(2238), 1,
      anon_sym_u2987,
    ACTIONS(2242), 1,
      aux_sym_integer_token1,
    ACTIONS(2244), 1,
      anon_sym_Set,
    ACTIONS(11771), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11773), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11775), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11777), 1,
      aux_sym_string_token1,
    STATE(4828), 1,
      sym_atom,
    STATE(4812), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4858), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(2216), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [555112] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(10600), 1,
      sym_id,
    ACTIONS(10602), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10606), 1,
      anon_sym_record,
    ACTIONS(10608), 1,
      anon_sym_LPAREN,
    ACTIONS(10610), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(10612), 1,
      anon_sym_u2983,
    ACTIONS(10614), 1,
      anon_sym_LBRACE,
    ACTIONS(10616), 1,
      aux_sym__qid_token1,
    ACTIONS(10618), 1,
      anon_sym_DOT,
    ACTIONS(10620), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(10622), 1,
      anon_sym_u2987,
    ACTIONS(10624), 1,
      aux_sym_integer_token1,
    ACTIONS(10626), 1,
      aux_sym_string_token1,
    ACTIONS(10628), 1,
      anon_sym_Set,
    STATE(7598), 1,
      sym_atom,
    STATE(7582), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7590), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(10604), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [555187] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2246), 1,
      sym_id,
    ACTIONS(2250), 1,
      anon_sym_record,
    ACTIONS(2260), 1,
      aux_sym__qid_token1,
    ACTIONS(2266), 1,
      anon_sym_u2987,
    ACTIONS(2268), 1,
      aux_sym_integer_token1,
    ACTIONS(2270), 1,
      anon_sym_Set,
    ACTIONS(4746), 1,
      anon_sym_DOT,
    ACTIONS(11481), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11485), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11487), 1,
      aux_sym_string_token1,
    ACTIONS(11779), 1,
      anon_sym_LPAREN,
    ACTIONS(11781), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11783), 1,
      anon_sym_u2983,
    ACTIONS(11785), 1,
      anon_sym_LBRACE,
    STATE(4150), 1,
      sym_atom,
    STATE(4151), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4153), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(2248), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [555262] = 4,
    ACTIONS(6488), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6490), 2,
      anon_sym_COLON,
      anon_sym_u2984,
    ACTIONS(6486), 29,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [555305] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(5814), 1,
      sym_id,
    ACTIONS(5818), 1,
      anon_sym_record,
    ACTIONS(5820), 1,
      anon_sym_LPAREN,
    ACTIONS(5824), 1,
      anon_sym_u2983,
    ACTIONS(5826), 1,
      anon_sym_LBRACE,
    ACTIONS(5828), 1,
      aux_sym__qid_token1,
    ACTIONS(5830), 1,
      anon_sym_DOT,
    ACTIONS(5834), 1,
      anon_sym_u2987,
    ACTIONS(5836), 1,
      aux_sym_integer_token1,
    ACTIONS(5838), 1,
      anon_sym_Set,
    ACTIONS(11787), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11789), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11791), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11793), 1,
      aux_sym_string_token1,
    STATE(4874), 1,
      sym_atom,
    STATE(4860), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4868), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(5816), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [555380] = 3,
    ACTIONS(6500), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6498), 31,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [555421] = 3,
    ACTIONS(6568), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6566), 31,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [555462] = 3,
    ACTIONS(6572), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6570), 31,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [555503] = 3,
    ACTIONS(6647), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6645), 31,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [555544] = 3,
    ACTIONS(6651), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6649), 31,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [555585] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11795), 1,
      sym_id,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_record,
    ACTIONS(11803), 1,
      anon_sym_LPAREN,
    ACTIONS(11805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11807), 1,
      anon_sym_u2983,
    ACTIONS(11809), 1,
      anon_sym_LBRACE,
    ACTIONS(11811), 1,
      aux_sym__qid_token1,
    ACTIONS(11813), 1,
      anon_sym_DOT,
    ACTIONS(11815), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11817), 1,
      anon_sym_u2987,
    ACTIONS(11819), 1,
      aux_sym_integer_token1,
    ACTIONS(11821), 1,
      aux_sym_string_token1,
    ACTIONS(11823), 1,
      anon_sym_Set,
    STATE(11887), 1,
      sym_atom,
    STATE(11687), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(11890), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11799), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [555660] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(3300), 1,
      sym_id,
    ACTIONS(3304), 1,
      anon_sym_record,
    ACTIONS(3314), 1,
      aux_sym__qid_token1,
    ACTIONS(3320), 1,
      anon_sym_u2987,
    ACTIONS(3322), 1,
      aux_sym_integer_token1,
    ACTIONS(3324), 1,
      anon_sym_Set,
    ACTIONS(4862), 1,
      anon_sym_DOT,
    ACTIONS(11825), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11827), 1,
      anon_sym_LPAREN,
    ACTIONS(11829), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11831), 1,
      anon_sym_u2983,
    ACTIONS(11833), 1,
      anon_sym_LBRACE,
    ACTIONS(11835), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11837), 1,
      aux_sym_string_token1,
    STATE(4055), 1,
      sym_atom,
    STATE(4053), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4049), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3302), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [555735] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2090), 1,
      aux_sym_integer_token1,
    ACTIONS(2092), 1,
      anon_sym_Set,
    ACTIONS(4838), 1,
      anon_sym_DOT,
    ACTIONS(11839), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11841), 1,
      anon_sym_LPAREN,
    ACTIONS(11843), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11845), 1,
      anon_sym_u2983,
    ACTIONS(11847), 1,
      anon_sym_LBRACE,
    ACTIONS(11849), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11851), 1,
      aux_sym_string_token1,
    STATE(5506), 1,
      sym_atom,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(2064), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [555810] = 3,
    ACTIONS(6754), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6752), 31,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [555851] = 3,
    ACTIONS(6714), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6712), 31,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [555892] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(7880), 1,
      sym_id,
    ACTIONS(7882), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7886), 1,
      anon_sym_record,
    ACTIONS(7888), 1,
      anon_sym_LPAREN,
    ACTIONS(7890), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(7892), 1,
      anon_sym_u2983,
    ACTIONS(7894), 1,
      anon_sym_LBRACE,
    ACTIONS(7896), 1,
      aux_sym__qid_token1,
    ACTIONS(7898), 1,
      anon_sym_DOT,
    ACTIONS(7902), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(7904), 1,
      anon_sym_u2987,
    ACTIONS(7906), 1,
      aux_sym_integer_token1,
    ACTIONS(7908), 1,
      aux_sym_string_token1,
    ACTIONS(7910), 1,
      anon_sym_Set,
    STATE(7278), 1,
      sym_atom,
    STATE(7276), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7267), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(7884), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [555967] = 3,
    ACTIONS(6433), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6431), 31,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [556008] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2174), 1,
      sym_id,
    ACTIONS(2182), 1,
      anon_sym_record,
    ACTIONS(2192), 1,
      aux_sym__qid_token1,
    ACTIONS(2200), 1,
      anon_sym_u2987,
    ACTIONS(2202), 1,
      aux_sym_integer_token1,
    ACTIONS(2204), 1,
      anon_sym_Set,
    ACTIONS(4880), 1,
      anon_sym_DOT,
    ACTIONS(11853), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11855), 1,
      anon_sym_LPAREN,
    ACTIONS(11857), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11859), 1,
      anon_sym_u2983,
    ACTIONS(11861), 1,
      anon_sym_LBRACE,
    ACTIONS(11863), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11865), 1,
      aux_sym_string_token1,
    STATE(4538), 1,
      sym_atom,
    STATE(4536), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4531), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(2180), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [556083] = 3,
    ACTIONS(6750), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6748), 31,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [556124] = 3,
    ACTIONS(6710), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6708), 31,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [556165] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(9321), 1,
      sym_id,
    ACTIONS(9323), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9327), 1,
      anon_sym_record,
    ACTIONS(9329), 1,
      anon_sym_LPAREN,
    ACTIONS(9331), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(9333), 1,
      anon_sym_u2983,
    ACTIONS(9335), 1,
      anon_sym_LBRACE,
    ACTIONS(9337), 1,
      aux_sym__qid_token1,
    ACTIONS(9339), 1,
      anon_sym_DOT,
    ACTIONS(9343), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(9345), 1,
      anon_sym_u2987,
    ACTIONS(9347), 1,
      aux_sym_integer_token1,
    ACTIONS(9349), 1,
      aux_sym_string_token1,
    ACTIONS(9351), 1,
      anon_sym_Set,
    STATE(7441), 1,
      sym_atom,
    STATE(7442), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7445), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(9325), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [556240] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2526), 1,
      sym_id,
    ACTIONS(2538), 1,
      anon_sym_record,
    ACTIONS(2540), 1,
      anon_sym_LPAREN,
    ACTIONS(2544), 1,
      anon_sym_u2983,
    ACTIONS(2546), 1,
      anon_sym_LBRACE,
    ACTIONS(2548), 1,
      aux_sym__qid_token1,
    ACTIONS(2550), 1,
      anon_sym_DOT,
    ACTIONS(2558), 1,
      anon_sym_u2987,
    ACTIONS(2562), 1,
      aux_sym_integer_token1,
    ACTIONS(2564), 1,
      anon_sym_Set,
    ACTIONS(11867), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11869), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11871), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11873), 1,
      aux_sym_string_token1,
    STATE(4504), 1,
      sym_atom,
    STATE(4464), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4473), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(2536), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [556315] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6840), 1,
      sym_id,
    ACTIONS(6842), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6846), 1,
      anon_sym_record,
    ACTIONS(6848), 1,
      anon_sym_LPAREN,
    ACTIONS(6850), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(6852), 1,
      anon_sym_u2983,
    ACTIONS(6854), 1,
      anon_sym_LBRACE,
    ACTIONS(6856), 1,
      aux_sym__qid_token1,
    ACTIONS(6858), 1,
      anon_sym_DOT,
    ACTIONS(6862), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(6864), 1,
      anon_sym_u2987,
    ACTIONS(6866), 1,
      aux_sym_integer_token1,
    ACTIONS(6868), 1,
      aux_sym_string_token1,
    ACTIONS(6870), 1,
      anon_sym_Set,
    STATE(7070), 1,
      sym_atom,
    STATE(7069), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7066), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(6844), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [556390] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(4976), 1,
      sym_id,
    ACTIONS(4980), 1,
      anon_sym_record,
    ACTIONS(4982), 1,
      anon_sym_LPAREN,
    ACTIONS(4986), 1,
      anon_sym_u2983,
    ACTIONS(4988), 1,
      anon_sym_LBRACE,
    ACTIONS(4990), 1,
      aux_sym__qid_token1,
    ACTIONS(4992), 1,
      anon_sym_DOT,
    ACTIONS(4996), 1,
      anon_sym_u2987,
    ACTIONS(4998), 1,
      aux_sym_integer_token1,
    ACTIONS(5000), 1,
      anon_sym_Set,
    ACTIONS(11875), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11877), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11879), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11881), 1,
      aux_sym_string_token1,
    STATE(6138), 1,
      sym_atom,
    STATE(6124), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6161), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(4978), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [556465] = 3,
    ACTIONS(6484), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6482), 31,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [556506] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(3168), 1,
      sym_id,
    ACTIONS(3180), 1,
      anon_sym_record,
    ACTIONS(3182), 1,
      anon_sym_LPAREN,
    ACTIONS(3186), 1,
      anon_sym_u2983,
    ACTIONS(3188), 1,
      anon_sym_LBRACE,
    ACTIONS(3190), 1,
      aux_sym__qid_token1,
    ACTIONS(3192), 1,
      anon_sym_DOT,
    ACTIONS(3200), 1,
      anon_sym_u2987,
    ACTIONS(3204), 1,
      aux_sym_integer_token1,
    ACTIONS(3206), 1,
      anon_sym_Set,
    ACTIONS(11581), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11583), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11585), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11587), 1,
      aux_sym_string_token1,
    STATE(4938), 1,
      sym_atom,
    STATE(4934), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4921), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3178), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [556581] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(3262), 1,
      sym_id,
    ACTIONS(3272), 1,
      anon_sym_record,
    ACTIONS(3282), 1,
      aux_sym__qid_token1,
    ACTIONS(3292), 1,
      anon_sym_u2987,
    ACTIONS(3296), 1,
      aux_sym_integer_token1,
    ACTIONS(3298), 1,
      anon_sym_Set,
    ACTIONS(4354), 1,
      anon_sym_LPAREN,
    ACTIONS(4358), 1,
      anon_sym_u2983,
    ACTIONS(4360), 1,
      anon_sym_LBRACE,
    ACTIONS(4362), 1,
      anon_sym_DOT,
    ACTIONS(11543), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11553), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11555), 1,
      aux_sym_string_token1,
    ACTIONS(11883), 1,
      anon_sym_LBRACE_LBRACE,
    STATE(4025), 1,
      sym_atom,
    STATE(4032), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4012), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3270), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [556656] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2614), 1,
      sym_id,
    ACTIONS(2624), 1,
      anon_sym_record,
    ACTIONS(2634), 1,
      aux_sym__qid_token1,
    ACTIONS(2644), 1,
      anon_sym_u2987,
    ACTIONS(2648), 1,
      aux_sym_integer_token1,
    ACTIONS(2650), 1,
      anon_sym_Set,
    ACTIONS(4906), 1,
      anon_sym_DOT,
    ACTIONS(11885), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11887), 1,
      anon_sym_LPAREN,
    ACTIONS(11889), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11891), 1,
      anon_sym_u2983,
    ACTIONS(11893), 1,
      anon_sym_LBRACE,
    ACTIONS(11895), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11897), 1,
      aux_sym_string_token1,
    STATE(4801), 1,
      sym_atom,
    STATE(4799), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4784), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(2622), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [556731] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(7663), 1,
      sym_id,
    ACTIONS(7665), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7669), 1,
      anon_sym_record,
    ACTIONS(7671), 1,
      anon_sym_LPAREN,
    ACTIONS(7673), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(7675), 1,
      anon_sym_u2983,
    ACTIONS(7677), 1,
      anon_sym_LBRACE,
    ACTIONS(7679), 1,
      aux_sym__qid_token1,
    ACTIONS(7681), 1,
      anon_sym_DOT,
    ACTIONS(7683), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(7685), 1,
      anon_sym_u2987,
    ACTIONS(7687), 1,
      aux_sym_integer_token1,
    ACTIONS(7689), 1,
      aux_sym_string_token1,
    ACTIONS(7691), 1,
      anon_sym_Set,
    STATE(7382), 1,
      sym_atom,
    STATE(7400), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7291), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(7667), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [556806] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(10985), 1,
      sym_id,
    ACTIONS(10987), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10991), 1,
      anon_sym_record,
    ACTIONS(10993), 1,
      anon_sym_LPAREN,
    ACTIONS(10995), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(10997), 1,
      anon_sym_u2983,
    ACTIONS(10999), 1,
      anon_sym_LBRACE,
    ACTIONS(11001), 1,
      aux_sym__qid_token1,
    ACTIONS(11003), 1,
      anon_sym_DOT,
    ACTIONS(11007), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11009), 1,
      anon_sym_u2987,
    ACTIONS(11011), 1,
      aux_sym_integer_token1,
    ACTIONS(11013), 1,
      aux_sym_string_token1,
    ACTIONS(11015), 1,
      anon_sym_Set,
    STATE(7804), 1,
      sym_atom,
    STATE(7784), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7798), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(10989), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [556881] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1240), 1,
      aux_sym_integer_token1,
    ACTIONS(1242), 1,
      anon_sym_Set,
    ACTIONS(4908), 1,
      anon_sym_LPAREN,
    ACTIONS(4912), 1,
      anon_sym_u2983,
    ACTIONS(4914), 1,
      anon_sym_LBRACE,
    ACTIONS(4916), 1,
      anon_sym_DOT,
    ACTIONS(11899), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11901), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11903), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11905), 1,
      aux_sym_string_token1,
    STATE(5660), 1,
      sym_atom,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(1214), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [556956] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1976), 1,
      aux_sym_integer_token1,
    ACTIONS(1978), 1,
      anon_sym_Set,
    ACTIONS(4432), 1,
      anon_sym_DOT,
    ACTIONS(11907), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11909), 1,
      anon_sym_LPAREN,
    ACTIONS(11911), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11913), 1,
      anon_sym_u2983,
    ACTIONS(11915), 1,
      anon_sym_LBRACE,
    ACTIONS(11917), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11919), 1,
      aux_sym_string_token1,
    STATE(5493), 1,
      sym_atom,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(1950), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [557031] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(706), 1,
      aux_sym__qid_token1,
    ACTIONS(3554), 1,
      sym_id,
    ACTIONS(3562), 1,
      anon_sym_record,
    ACTIONS(3564), 1,
      anon_sym_LPAREN,
    ACTIONS(3568), 1,
      anon_sym_u2983,
    ACTIONS(3570), 1,
      anon_sym_LBRACE,
    ACTIONS(3572), 1,
      anon_sym_DOT,
    ACTIONS(3578), 1,
      anon_sym_u2987,
    ACTIONS(3580), 1,
      aux_sym_integer_token1,
    ACTIONS(3582), 1,
      anon_sym_Set,
    ACTIONS(11921), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11923), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11925), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11927), 1,
      aux_sym_string_token1,
    STATE(5198), 1,
      sym_atom,
    STATE(5081), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5079), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3560), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [557106] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2938), 1,
      sym_id,
    ACTIONS(2950), 1,
      anon_sym_record,
    ACTIONS(2952), 1,
      anon_sym_LPAREN,
    ACTIONS(2956), 1,
      anon_sym_u2983,
    ACTIONS(2958), 1,
      anon_sym_LBRACE,
    ACTIONS(2960), 1,
      aux_sym__qid_token1,
    ACTIONS(2962), 1,
      anon_sym_DOT,
    ACTIONS(2970), 1,
      anon_sym_u2987,
    ACTIONS(2974), 1,
      aux_sym_integer_token1,
    ACTIONS(2976), 1,
      anon_sym_Set,
    ACTIONS(11557), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11559), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11561), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11563), 1,
      aux_sym_string_token1,
    STATE(5868), 1,
      sym_atom,
    STATE(5870), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5838), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(2948), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [557181] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(3130), 1,
      sym_id,
    ACTIONS(3140), 1,
      anon_sym_record,
    ACTIONS(3150), 1,
      aux_sym__qid_token1,
    ACTIONS(3160), 1,
      anon_sym_u2987,
    ACTIONS(3164), 1,
      aux_sym_integer_token1,
    ACTIONS(3166), 1,
      anon_sym_Set,
    ACTIONS(4368), 1,
      anon_sym_LPAREN,
    ACTIONS(4372), 1,
      anon_sym_u2983,
    ACTIONS(4374), 1,
      anon_sym_LBRACE,
    ACTIONS(4376), 1,
      anon_sym_DOT,
    ACTIONS(11929), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11931), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11933), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11935), 1,
      aux_sym_string_token1,
    STATE(4480), 1,
      sym_atom,
    STATE(4493), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4496), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3138), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [557256] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(3090), 1,
      sym_id,
    ACTIONS(3102), 1,
      anon_sym_record,
    ACTIONS(3104), 1,
      anon_sym_LPAREN,
    ACTIONS(3108), 1,
      anon_sym_u2983,
    ACTIONS(3110), 1,
      anon_sym_LBRACE,
    ACTIONS(3112), 1,
      aux_sym__qid_token1,
    ACTIONS(3114), 1,
      anon_sym_DOT,
    ACTIONS(3122), 1,
      anon_sym_u2987,
    ACTIONS(3126), 1,
      aux_sym_integer_token1,
    ACTIONS(3128), 1,
      anon_sym_Set,
    ACTIONS(11937), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11939), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11941), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11943), 1,
      aux_sym_string_token1,
    STATE(4302), 1,
      sym_atom,
    STATE(4293), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4285), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3100), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [557331] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6330), 1,
      sym_id,
    ACTIONS(6332), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6338), 1,
      anon_sym_record,
    ACTIONS(6340), 1,
      anon_sym_LPAREN,
    ACTIONS(6342), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(6344), 1,
      anon_sym_u2983,
    ACTIONS(6346), 1,
      anon_sym_LBRACE,
    ACTIONS(6348), 1,
      aux_sym__qid_token1,
    ACTIONS(6350), 1,
      anon_sym_DOT,
    ACTIONS(6354), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(6356), 1,
      anon_sym_u2987,
    ACTIONS(6358), 1,
      aux_sym_integer_token1,
    ACTIONS(6360), 1,
      aux_sym_string_token1,
    ACTIONS(6362), 1,
      anon_sym_Set,
    STATE(6541), 1,
      sym_atom,
    STATE(6547), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6549), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(6334), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [557406] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(3064), 1,
      anon_sym_record,
    ACTIONS(3066), 1,
      anon_sym_LPAREN,
    ACTIONS(3070), 1,
      anon_sym_u2983,
    ACTIONS(3072), 1,
      anon_sym_LBRACE,
    ACTIONS(3078), 1,
      anon_sym_DOT,
    ACTIONS(3084), 1,
      anon_sym_u2987,
    ACTIONS(3086), 1,
      aux_sym_integer_token1,
    ACTIONS(3088), 1,
      anon_sym_Set,
    ACTIONS(6232), 1,
      sym_id,
    ACTIONS(6234), 1,
      aux_sym__qid_token1,
    ACTIONS(11945), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11947), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11949), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11951), 1,
      aux_sym_string_token1,
    STATE(6716), 1,
      sym_atom,
    STATE(6715), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6714), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3062), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [557481] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(7099), 1,
      sym_id,
    ACTIONS(7101), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7105), 1,
      anon_sym_record,
    ACTIONS(7107), 1,
      anon_sym_LPAREN,
    ACTIONS(7109), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(7111), 1,
      anon_sym_u2983,
    ACTIONS(7113), 1,
      anon_sym_LBRACE,
    ACTIONS(7115), 1,
      aux_sym__qid_token1,
    ACTIONS(7117), 1,
      anon_sym_DOT,
    ACTIONS(7121), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(7123), 1,
      anon_sym_u2987,
    ACTIONS(7125), 1,
      aux_sym_integer_token1,
    ACTIONS(7127), 1,
      aux_sym_string_token1,
    ACTIONS(7129), 1,
      anon_sym_Set,
    STATE(6902), 1,
      sym_atom,
    STATE(6905), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6865), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(7103), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [557556] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(7509), 1,
      sym_id,
    ACTIONS(7513), 1,
      anon_sym_record,
    ACTIONS(7515), 1,
      anon_sym_LPAREN,
    ACTIONS(7519), 1,
      anon_sym_u2983,
    ACTIONS(7521), 1,
      anon_sym_LBRACE,
    ACTIONS(7523), 1,
      aux_sym__qid_token1,
    ACTIONS(7525), 1,
      anon_sym_DOT,
    ACTIONS(7529), 1,
      anon_sym_u2987,
    ACTIONS(7531), 1,
      aux_sym_integer_token1,
    ACTIONS(7533), 1,
      anon_sym_Set,
    ACTIONS(11503), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11505), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11507), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11509), 1,
      aux_sym_string_token1,
    STATE(7099), 1,
      sym_atom,
    STATE(6904), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7094), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(7511), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [557631] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6952), 1,
      sym_id,
    ACTIONS(6956), 1,
      anon_sym_record,
    ACTIONS(6958), 1,
      anon_sym_LPAREN,
    ACTIONS(6962), 1,
      anon_sym_u2983,
    ACTIONS(6964), 1,
      anon_sym_LBRACE,
    ACTIONS(6966), 1,
      aux_sym__qid_token1,
    ACTIONS(6968), 1,
      anon_sym_DOT,
    ACTIONS(6972), 1,
      anon_sym_u2987,
    ACTIONS(6974), 1,
      aux_sym_integer_token1,
    ACTIONS(6976), 1,
      anon_sym_Set,
    ACTIONS(11953), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11955), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11957), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11959), 1,
      aux_sym_string_token1,
    STATE(6831), 1,
      sym_atom,
    STATE(6791), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6826), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(6954), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [557706] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6326), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6324), 27,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [557749] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(5468), 1,
      sym_id,
    ACTIONS(5472), 1,
      anon_sym_record,
    ACTIONS(5474), 1,
      anon_sym_LPAREN,
    ACTIONS(5478), 1,
      anon_sym_u2983,
    ACTIONS(5480), 1,
      anon_sym_LBRACE,
    ACTIONS(5482), 1,
      aux_sym__qid_token1,
    ACTIONS(5484), 1,
      anon_sym_DOT,
    ACTIONS(5488), 1,
      anon_sym_u2987,
    ACTIONS(5490), 1,
      aux_sym_integer_token1,
    ACTIONS(5492), 1,
      anon_sym_Set,
    ACTIONS(11961), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11963), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11965), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11967), 1,
      aux_sym_string_token1,
    STATE(4540), 1,
      sym_atom,
    STATE(4533), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4527), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(5470), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [557824] = 3,
    ACTIONS(6496), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6494), 31,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [557865] = 4,
    ACTIONS(6488), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6490), 2,
      anon_sym_COLON,
      anon_sym_RBRACE,
    ACTIONS(6486), 29,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [557908] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(5416), 1,
      sym_id,
    ACTIONS(5420), 1,
      anon_sym_record,
    ACTIONS(5422), 1,
      anon_sym_LPAREN,
    ACTIONS(5426), 1,
      anon_sym_u2983,
    ACTIONS(5428), 1,
      anon_sym_LBRACE,
    ACTIONS(5430), 1,
      aux_sym__qid_token1,
    ACTIONS(5432), 1,
      anon_sym_DOT,
    ACTIONS(5436), 1,
      anon_sym_u2987,
    ACTIONS(5438), 1,
      aux_sym_integer_token1,
    ACTIONS(5440), 1,
      anon_sym_Set,
    ACTIONS(11969), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11971), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11973), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11975), 1,
      aux_sym_string_token1,
    STATE(5382), 1,
      sym_atom,
    STATE(5369), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5364), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(5418), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [557983] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(7027), 1,
      sym_id,
    ACTIONS(7029), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7033), 1,
      anon_sym_record,
    ACTIONS(7035), 1,
      anon_sym_LPAREN,
    ACTIONS(7037), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(7039), 1,
      anon_sym_u2983,
    ACTIONS(7041), 1,
      anon_sym_LBRACE,
    ACTIONS(7043), 1,
      aux_sym__qid_token1,
    ACTIONS(7045), 1,
      anon_sym_DOT,
    ACTIONS(7049), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(7051), 1,
      anon_sym_u2987,
    ACTIONS(7053), 1,
      aux_sym_integer_token1,
    ACTIONS(7055), 1,
      aux_sym_string_token1,
    ACTIONS(7057), 1,
      anon_sym_Set,
    STATE(6996), 1,
      sym_atom,
    STATE(6939), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6933), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(7031), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [558058] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2346), 1,
      sym_id,
    ACTIONS(2356), 1,
      anon_sym_record,
    ACTIONS(2366), 1,
      aux_sym__qid_token1,
    ACTIONS(2376), 1,
      anon_sym_u2987,
    ACTIONS(2380), 1,
      aux_sym_integer_token1,
    ACTIONS(2382), 1,
      anon_sym_Set,
    ACTIONS(4758), 1,
      anon_sym_DOT,
    ACTIONS(11977), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11979), 1,
      anon_sym_LPAREN,
    ACTIONS(11981), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11983), 1,
      anon_sym_u2983,
    ACTIONS(11985), 1,
      anon_sym_LBRACE,
    ACTIONS(11987), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11989), 1,
      aux_sym_string_token1,
    STATE(4176), 1,
      sym_atom,
    STATE(4180), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4192), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(2354), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [558133] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1240), 1,
      aux_sym_integer_token1,
    ACTIONS(1242), 1,
      anon_sym_Set,
    ACTIONS(4916), 1,
      anon_sym_DOT,
    ACTIONS(11899), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11903), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11905), 1,
      aux_sym_string_token1,
    ACTIONS(11991), 1,
      anon_sym_LPAREN,
    ACTIONS(11993), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11995), 1,
      anon_sym_u2983,
    ACTIONS(11997), 1,
      anon_sym_LBRACE,
    STATE(5660), 1,
      sym_atom,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(1214), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [558208] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(7396), 1,
      sym_id,
    ACTIONS(7398), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7402), 1,
      anon_sym_record,
    ACTIONS(7404), 1,
      anon_sym_LPAREN,
    ACTIONS(7406), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(7408), 1,
      anon_sym_u2983,
    ACTIONS(7410), 1,
      anon_sym_LBRACE,
    ACTIONS(7412), 1,
      aux_sym__qid_token1,
    ACTIONS(7414), 1,
      anon_sym_DOT,
    ACTIONS(7418), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(7420), 1,
      anon_sym_u2987,
    ACTIONS(7422), 1,
      aux_sym_integer_token1,
    ACTIONS(7424), 1,
      aux_sym_string_token1,
    ACTIONS(7426), 1,
      anon_sym_Set,
    STATE(7165), 1,
      sym_atom,
    STATE(7163), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7161), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(7400), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [558283] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2872), 1,
      sym_id,
    ACTIONS(2876), 1,
      anon_sym_record,
    ACTIONS(2878), 1,
      anon_sym_LPAREN,
    ACTIONS(2882), 1,
      anon_sym_u2983,
    ACTIONS(2884), 1,
      anon_sym_LBRACE,
    ACTIONS(2886), 1,
      aux_sym__qid_token1,
    ACTIONS(2888), 1,
      anon_sym_DOT,
    ACTIONS(2892), 1,
      anon_sym_u2987,
    ACTIONS(2894), 1,
      aux_sym_integer_token1,
    ACTIONS(2896), 1,
      anon_sym_Set,
    ACTIONS(11999), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12001), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(12003), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(12005), 1,
      aux_sym_string_token1,
    STATE(5293), 1,
      sym_atom,
    STATE(5291), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5287), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(2874), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [558358] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2094), 1,
      sym_id,
    ACTIONS(2106), 1,
      anon_sym_record,
    ACTIONS(2108), 1,
      anon_sym_LPAREN,
    ACTIONS(2112), 1,
      anon_sym_u2983,
    ACTIONS(2114), 1,
      anon_sym_LBRACE,
    ACTIONS(2116), 1,
      aux_sym__qid_token1,
    ACTIONS(2118), 1,
      anon_sym_DOT,
    ACTIONS(2126), 1,
      anon_sym_u2987,
    ACTIONS(2130), 1,
      aux_sym_integer_token1,
    ACTIONS(2132), 1,
      anon_sym_Set,
    ACTIONS(11473), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11475), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11477), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11479), 1,
      aux_sym_string_token1,
    STATE(5450), 1,
      sym_atom,
    STATE(5451), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5453), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(2104), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [558433] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2462), 1,
      sym_id,
    ACTIONS(2466), 1,
      anon_sym_record,
    ACTIONS(2476), 1,
      aux_sym__qid_token1,
    ACTIONS(2482), 1,
      anon_sym_u2987,
    ACTIONS(2484), 1,
      aux_sym_integer_token1,
    ACTIONS(2486), 1,
      anon_sym_Set,
    ACTIONS(4678), 1,
      anon_sym_LPAREN,
    ACTIONS(4682), 1,
      anon_sym_u2983,
    ACTIONS(4684), 1,
      anon_sym_LBRACE,
    ACTIONS(4686), 1,
      anon_sym_DOT,
    ACTIONS(11413), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11423), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11425), 1,
      aux_sym_string_token1,
    ACTIONS(12007), 1,
      anon_sym_LBRACE_LBRACE,
    STATE(4091), 1,
      sym_atom,
    STATE(4044), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4052), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(2464), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [558508] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(8516), 1,
      sym_id,
    ACTIONS(8518), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8522), 1,
      anon_sym_record,
    ACTIONS(8524), 1,
      anon_sym_LPAREN,
    ACTIONS(8526), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(8528), 1,
      anon_sym_u2983,
    ACTIONS(8530), 1,
      anon_sym_LBRACE,
    ACTIONS(8532), 1,
      aux_sym__qid_token1,
    ACTIONS(8534), 1,
      anon_sym_DOT,
    ACTIONS(8538), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(8540), 1,
      anon_sym_u2987,
    ACTIONS(8542), 1,
      aux_sym_integer_token1,
    ACTIONS(8544), 1,
      aux_sym_string_token1,
    ACTIONS(8546), 1,
      anon_sym_Set,
    STATE(7193), 1,
      sym_atom,
    STATE(7201), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7202), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(8520), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [558583] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(8369), 1,
      sym_id,
    ACTIONS(8371), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8375), 1,
      anon_sym_record,
    ACTIONS(8377), 1,
      anon_sym_LPAREN,
    ACTIONS(8379), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(8381), 1,
      anon_sym_u2983,
    ACTIONS(8383), 1,
      anon_sym_LBRACE,
    ACTIONS(8385), 1,
      aux_sym__qid_token1,
    ACTIONS(8387), 1,
      anon_sym_DOT,
    ACTIONS(8391), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(8393), 1,
      anon_sym_u2987,
    ACTIONS(8395), 1,
      aux_sym_integer_token1,
    ACTIONS(8397), 1,
      aux_sym_string_token1,
    ACTIONS(8399), 1,
      anon_sym_Set,
    STATE(7390), 1,
      sym_atom,
    STATE(7389), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7302), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(8373), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [558658] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2566), 1,
      sym_id,
    ACTIONS(2576), 1,
      anon_sym_record,
    ACTIONS(2586), 1,
      aux_sym__qid_token1,
    ACTIONS(2596), 1,
      anon_sym_u2987,
    ACTIONS(2600), 1,
      aux_sym_integer_token1,
    ACTIONS(2602), 1,
      anon_sym_Set,
    ACTIONS(4594), 1,
      anon_sym_LPAREN,
    ACTIONS(4598), 1,
      anon_sym_u2983,
    ACTIONS(4600), 1,
      anon_sym_LBRACE,
    ACTIONS(4602), 1,
      anon_sym_DOT,
    ACTIONS(11605), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11615), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11617), 1,
      aux_sym_string_token1,
    ACTIONS(12009), 1,
      anon_sym_LBRACE_LBRACE,
    STATE(5592), 1,
      sym_atom,
    STATE(5566), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5590), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(2574), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [558733] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(9758), 1,
      sym_id,
    ACTIONS(9760), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9764), 1,
      anon_sym_record,
    ACTIONS(9766), 1,
      anon_sym_LPAREN,
    ACTIONS(9768), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(9770), 1,
      anon_sym_u2983,
    ACTIONS(9772), 1,
      anon_sym_LBRACE,
    ACTIONS(9774), 1,
      aux_sym__qid_token1,
    ACTIONS(9776), 1,
      anon_sym_DOT,
    ACTIONS(9780), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(9782), 1,
      anon_sym_u2987,
    ACTIONS(9784), 1,
      aux_sym_integer_token1,
    ACTIONS(9786), 1,
      aux_sym_string_token1,
    ACTIONS(9788), 1,
      anon_sym_Set,
    STATE(7664), 1,
      sym_atom,
    STATE(7652), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7667), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(9762), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [558808] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(10006), 1,
      sym_id,
    ACTIONS(10008), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10012), 1,
      anon_sym_record,
    ACTIONS(10014), 1,
      anon_sym_LPAREN,
    ACTIONS(10016), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(10018), 1,
      anon_sym_u2983,
    ACTIONS(10020), 1,
      anon_sym_LBRACE,
    ACTIONS(10022), 1,
      aux_sym__qid_token1,
    ACTIONS(10024), 1,
      anon_sym_DOT,
    ACTIONS(10028), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(10030), 1,
      anon_sym_u2987,
    ACTIONS(10032), 1,
      aux_sym_integer_token1,
    ACTIONS(10034), 1,
      aux_sym_string_token1,
    ACTIONS(10036), 1,
      anon_sym_Set,
    STATE(7520), 1,
      sym_atom,
    STATE(7489), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7488), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(10010), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [558883] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(5814), 1,
      sym_id,
    ACTIONS(5818), 1,
      anon_sym_record,
    ACTIONS(5820), 1,
      anon_sym_LPAREN,
    ACTIONS(5824), 1,
      anon_sym_u2983,
    ACTIONS(5826), 1,
      anon_sym_LBRACE,
    ACTIONS(5828), 1,
      aux_sym__qid_token1,
    ACTIONS(5830), 1,
      anon_sym_DOT,
    ACTIONS(5834), 1,
      anon_sym_u2987,
    ACTIONS(5836), 1,
      aux_sym_integer_token1,
    ACTIONS(5838), 1,
      anon_sym_Set,
    ACTIONS(11787), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11789), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11791), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11793), 1,
      aux_sym_string_token1,
    STATE(4626), 1,
      sym_atom,
    STATE(4860), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4868), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(5816), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [558958] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(3130), 1,
      sym_id,
    ACTIONS(3140), 1,
      anon_sym_record,
    ACTIONS(3150), 1,
      aux_sym__qid_token1,
    ACTIONS(3160), 1,
      anon_sym_u2987,
    ACTIONS(3164), 1,
      aux_sym_integer_token1,
    ACTIONS(3166), 1,
      anon_sym_Set,
    ACTIONS(4376), 1,
      anon_sym_DOT,
    ACTIONS(11929), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11933), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11935), 1,
      aux_sym_string_token1,
    ACTIONS(12011), 1,
      anon_sym_LPAREN,
    ACTIONS(12013), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(12015), 1,
      anon_sym_u2983,
    ACTIONS(12017), 1,
      anon_sym_LBRACE,
    STATE(4492), 1,
      sym_atom,
    STATE(4493), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4496), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3138), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [559033] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2978), 1,
      sym_id,
    ACTIONS(2988), 1,
      anon_sym_record,
    ACTIONS(2998), 1,
      aux_sym__qid_token1,
    ACTIONS(3008), 1,
      anon_sym_u2987,
    ACTIONS(3012), 1,
      aux_sym_integer_token1,
    ACTIONS(3014), 1,
      anon_sym_Set,
    ACTIONS(4306), 1,
      anon_sym_LPAREN,
    ACTIONS(4310), 1,
      anon_sym_u2983,
    ACTIONS(4312), 1,
      anon_sym_LBRACE,
    ACTIONS(4314), 1,
      anon_sym_DOT,
    ACTIONS(12019), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12021), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(12023), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(12025), 1,
      aux_sym_string_token1,
    STATE(4456), 1,
      sym_atom,
    STATE(4469), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4463), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(2986), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [559108] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6405), 1,
      sym_id,
    ACTIONS(6409), 1,
      anon_sym_record,
    ACTIONS(6411), 1,
      anon_sym_LPAREN,
    ACTIONS(6415), 1,
      anon_sym_u2983,
    ACTIONS(6417), 1,
      anon_sym_LBRACE,
    ACTIONS(6419), 1,
      aux_sym__qid_token1,
    ACTIONS(6421), 1,
      anon_sym_DOT,
    ACTIONS(6425), 1,
      anon_sym_u2987,
    ACTIONS(6427), 1,
      aux_sym_integer_token1,
    ACTIONS(6429), 1,
      anon_sym_Set,
    ACTIONS(12027), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12029), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(12031), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(12033), 1,
      aux_sym_string_token1,
    STATE(6156), 1,
      sym_atom,
    STATE(6157), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6162), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(6407), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [559183] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2090), 1,
      aux_sym_integer_token1,
    ACTIONS(2092), 1,
      anon_sym_Set,
    ACTIONS(4830), 1,
      anon_sym_LPAREN,
    ACTIONS(4834), 1,
      anon_sym_u2983,
    ACTIONS(4836), 1,
      anon_sym_LBRACE,
    ACTIONS(4838), 1,
      anon_sym_DOT,
    ACTIONS(11839), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11849), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11851), 1,
      aux_sym_string_token1,
    ACTIONS(12035), 1,
      anon_sym_LBRACE_LBRACE,
    STATE(5506), 1,
      sym_atom,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(2064), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [559258] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(10600), 1,
      sym_id,
    ACTIONS(10602), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10606), 1,
      anon_sym_record,
    ACTIONS(10608), 1,
      anon_sym_LPAREN,
    ACTIONS(10610), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(10612), 1,
      anon_sym_u2983,
    ACTIONS(10614), 1,
      anon_sym_LBRACE,
    ACTIONS(10616), 1,
      aux_sym__qid_token1,
    ACTIONS(10618), 1,
      anon_sym_DOT,
    ACTIONS(10620), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(10622), 1,
      anon_sym_u2987,
    ACTIONS(10624), 1,
      aux_sym_integer_token1,
    ACTIONS(10626), 1,
      aux_sym_string_token1,
    ACTIONS(10628), 1,
      anon_sym_Set,
    STATE(7608), 1,
      sym_atom,
    STATE(7582), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7590), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(10604), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [559333] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(3326), 1,
      sym_id,
    ACTIONS(3332), 1,
      anon_sym_record,
    ACTIONS(3334), 1,
      anon_sym_LPAREN,
    ACTIONS(3338), 1,
      anon_sym_u2983,
    ACTIONS(3340), 1,
      anon_sym_LBRACE,
    ACTIONS(3342), 1,
      aux_sym__qid_token1,
    ACTIONS(3344), 1,
      anon_sym_DOT,
    ACTIONS(3348), 1,
      anon_sym_u2987,
    ACTIONS(3350), 1,
      aux_sym_integer_token1,
    ACTIONS(3352), 1,
      anon_sym_Set,
    ACTIONS(12037), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12039), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(12041), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(12043), 1,
      aux_sym_string_token1,
    STATE(4652), 1,
      sym_atom,
    STATE(4650), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4649), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3330), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [559408] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6032), 1,
      sym_id,
    ACTIONS(6036), 1,
      anon_sym_record,
    ACTIONS(6038), 1,
      anon_sym_LPAREN,
    ACTIONS(6042), 1,
      anon_sym_u2983,
    ACTIONS(6044), 1,
      anon_sym_LBRACE,
    ACTIONS(6046), 1,
      aux_sym__qid_token1,
    ACTIONS(6048), 1,
      anon_sym_DOT,
    ACTIONS(6052), 1,
      anon_sym_u2987,
    ACTIONS(6054), 1,
      aux_sym_integer_token1,
    ACTIONS(6056), 1,
      anon_sym_Set,
    ACTIONS(11427), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11429), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11431), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11433), 1,
      aux_sym_string_token1,
    STATE(5900), 1,
      sym_atom,
    STATE(5909), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5914), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(6034), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [559483] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6952), 1,
      sym_id,
    ACTIONS(6956), 1,
      anon_sym_record,
    ACTIONS(6958), 1,
      anon_sym_LPAREN,
    ACTIONS(6962), 1,
      anon_sym_u2983,
    ACTIONS(6964), 1,
      anon_sym_LBRACE,
    ACTIONS(6966), 1,
      aux_sym__qid_token1,
    ACTIONS(6968), 1,
      anon_sym_DOT,
    ACTIONS(6972), 1,
      anon_sym_u2987,
    ACTIONS(6974), 1,
      aux_sym_integer_token1,
    ACTIONS(6976), 1,
      anon_sym_Set,
    ACTIONS(11953), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11955), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11957), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11959), 1,
      aux_sym_string_token1,
    STATE(6828), 1,
      sym_atom,
    STATE(6791), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6826), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(6954), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [559558] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(4924), 1,
      sym_id,
    ACTIONS(4928), 1,
      anon_sym_record,
    ACTIONS(4930), 1,
      anon_sym_LPAREN,
    ACTIONS(4934), 1,
      anon_sym_u2983,
    ACTIONS(4936), 1,
      anon_sym_LBRACE,
    ACTIONS(4938), 1,
      aux_sym__qid_token1,
    ACTIONS(4940), 1,
      anon_sym_DOT,
    ACTIONS(4944), 1,
      anon_sym_u2987,
    ACTIONS(4946), 1,
      aux_sym_integer_token1,
    ACTIONS(4948), 1,
      anon_sym_Set,
    ACTIONS(12045), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12047), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(12049), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(12051), 1,
      aux_sym_string_token1,
    STATE(5897), 1,
      sym_atom,
    STATE(5898), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5899), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(4926), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [559633] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2652), 1,
      sym_id,
    ACTIONS(2662), 1,
      anon_sym_record,
    ACTIONS(2672), 1,
      aux_sym__qid_token1,
    ACTIONS(2682), 1,
      anon_sym_u2987,
    ACTIONS(2686), 1,
      aux_sym_integer_token1,
    ACTIONS(2688), 1,
      anon_sym_Set,
    ACTIONS(4532), 1,
      anon_sym_DOT,
    ACTIONS(12053), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12055), 1,
      anon_sym_LPAREN,
    ACTIONS(12057), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(12059), 1,
      anon_sym_u2983,
    ACTIONS(12061), 1,
      anon_sym_LBRACE,
    ACTIONS(12063), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(12065), 1,
      aux_sym_string_token1,
    STATE(4731), 1,
      sym_atom,
    STATE(4732), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4735), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(2660), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [559708] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(5494), 1,
      sym_id,
    ACTIONS(5498), 1,
      anon_sym_record,
    ACTIONS(5500), 1,
      anon_sym_LPAREN,
    ACTIONS(5504), 1,
      anon_sym_u2983,
    ACTIONS(5506), 1,
      anon_sym_LBRACE,
    ACTIONS(5508), 1,
      aux_sym__qid_token1,
    ACTIONS(5510), 1,
      anon_sym_DOT,
    ACTIONS(5514), 1,
      anon_sym_u2987,
    ACTIONS(5516), 1,
      aux_sym_integer_token1,
    ACTIONS(5518), 1,
      anon_sym_Set,
    ACTIONS(12067), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12069), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(12071), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(12073), 1,
      aux_sym_string_token1,
    STATE(6040), 1,
      sym_atom,
    STATE(6047), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6050), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(5496), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [559783] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2422), 1,
      sym_id,
    ACTIONS(2434), 1,
      anon_sym_record,
    ACTIONS(2436), 1,
      anon_sym_LPAREN,
    ACTIONS(2440), 1,
      anon_sym_u2983,
    ACTIONS(2442), 1,
      anon_sym_LBRACE,
    ACTIONS(2444), 1,
      aux_sym__qid_token1,
    ACTIONS(2446), 1,
      anon_sym_DOT,
    ACTIONS(2454), 1,
      anon_sym_u2987,
    ACTIONS(2458), 1,
      aux_sym_integer_token1,
    ACTIONS(2460), 1,
      anon_sym_Set,
    ACTIONS(11443), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11445), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11447), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11449), 1,
      aux_sym_string_token1,
    STATE(5421), 1,
      sym_atom,
    STATE(5422), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5423), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(2432), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [559858] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(5898), 1,
      sym_id,
    ACTIONS(5902), 1,
      anon_sym_record,
    ACTIONS(5904), 1,
      anon_sym_LPAREN,
    ACTIONS(5908), 1,
      anon_sym_u2983,
    ACTIONS(5910), 1,
      anon_sym_LBRACE,
    ACTIONS(5912), 1,
      aux_sym__qid_token1,
    ACTIONS(5914), 1,
      anon_sym_DOT,
    ACTIONS(5918), 1,
      anon_sym_u2987,
    ACTIONS(5920), 1,
      aux_sym_integer_token1,
    ACTIONS(5922), 1,
      anon_sym_Set,
    ACTIONS(12075), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12077), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(12079), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(12081), 1,
      aux_sym_string_token1,
    STATE(6086), 1,
      sym_atom,
    STATE(6087), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6089), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(5900), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [559933] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(3938), 1,
      sym_id,
    ACTIONS(3942), 1,
      anon_sym_record,
    ACTIONS(3952), 1,
      aux_sym__qid_token1,
    ACTIONS(3958), 1,
      anon_sym_u2987,
    ACTIONS(3960), 1,
      aux_sym_integer_token1,
    ACTIONS(3962), 1,
      anon_sym_Set,
    ACTIONS(4620), 1,
      anon_sym_LPAREN,
    ACTIONS(4624), 1,
      anon_sym_u2983,
    ACTIONS(4626), 1,
      anon_sym_LBRACE,
    ACTIONS(4628), 1,
      anon_sym_DOT,
    ACTIONS(12083), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12085), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(12087), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(12089), 1,
      aux_sym_string_token1,
    STATE(5206), 1,
      sym_atom,
    STATE(5203), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5201), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3940), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [560008] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2384), 1,
      sym_id,
    ACTIONS(2394), 1,
      anon_sym_record,
    ACTIONS(2404), 1,
      aux_sym__qid_token1,
    ACTIONS(2414), 1,
      anon_sym_u2987,
    ACTIONS(2418), 1,
      aux_sym_integer_token1,
    ACTIONS(2420), 1,
      anon_sym_Set,
    ACTIONS(4578), 1,
      anon_sym_DOT,
    ACTIONS(12091), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12093), 1,
      anon_sym_LPAREN,
    ACTIONS(12095), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(12097), 1,
      anon_sym_u2983,
    ACTIONS(12099), 1,
      anon_sym_LBRACE,
    ACTIONS(12101), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(12103), 1,
      aux_sym_string_token1,
    STATE(4843), 1,
      sym_atom,
    STATE(4831), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4896), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(2392), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [560083] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(8955), 1,
      sym_id,
    ACTIONS(8957), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8961), 1,
      anon_sym_record,
    ACTIONS(8963), 1,
      anon_sym_LPAREN,
    ACTIONS(8965), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(8967), 1,
      anon_sym_u2983,
    ACTIONS(8969), 1,
      anon_sym_LBRACE,
    ACTIONS(8971), 1,
      aux_sym__qid_token1,
    ACTIONS(8973), 1,
      anon_sym_DOT,
    ACTIONS(8977), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(8979), 1,
      anon_sym_u2987,
    ACTIONS(8981), 1,
      aux_sym_integer_token1,
    ACTIONS(8983), 1,
      aux_sym_string_token1,
    ACTIONS(8985), 1,
      anon_sym_Set,
    STATE(7526), 1,
      sym_atom,
    STATE(7468), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7497), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(8959), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [560158] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(3380), 1,
      sym_id,
    ACTIONS(3384), 1,
      anon_sym_record,
    ACTIONS(3386), 1,
      anon_sym_LPAREN,
    ACTIONS(3390), 1,
      anon_sym_u2983,
    ACTIONS(3392), 1,
      anon_sym_LBRACE,
    ACTIONS(3394), 1,
      aux_sym__qid_token1,
    ACTIONS(3396), 1,
      anon_sym_DOT,
    ACTIONS(3400), 1,
      anon_sym_u2987,
    ACTIONS(3402), 1,
      aux_sym_integer_token1,
    ACTIONS(3404), 1,
      anon_sym_Set,
    ACTIONS(12105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12107), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(12109), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(12111), 1,
      aux_sym_string_token1,
    STATE(4930), 1,
      sym_atom,
    STATE(4937), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4939), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3382), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [560233] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2384), 1,
      sym_id,
    ACTIONS(2394), 1,
      anon_sym_record,
    ACTIONS(2404), 1,
      aux_sym__qid_token1,
    ACTIONS(2414), 1,
      anon_sym_u2987,
    ACTIONS(2418), 1,
      aux_sym_integer_token1,
    ACTIONS(2420), 1,
      anon_sym_Set,
    ACTIONS(4570), 1,
      anon_sym_LPAREN,
    ACTIONS(4574), 1,
      anon_sym_u2983,
    ACTIONS(4576), 1,
      anon_sym_LBRACE,
    ACTIONS(4578), 1,
      anon_sym_DOT,
    ACTIONS(12091), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12101), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(12103), 1,
      aux_sym_string_token1,
    ACTIONS(12113), 1,
      anon_sym_LBRACE_LBRACE,
    STATE(4851), 1,
      sym_atom,
    STATE(4831), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4896), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(2392), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [560308] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(10719), 1,
      sym_id,
    ACTIONS(10721), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10725), 1,
      anon_sym_record,
    ACTIONS(10727), 1,
      anon_sym_LPAREN,
    ACTIONS(10729), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(10731), 1,
      anon_sym_u2983,
    ACTIONS(10733), 1,
      anon_sym_LBRACE,
    ACTIONS(10735), 1,
      aux_sym__qid_token1,
    ACTIONS(10737), 1,
      anon_sym_DOT,
    ACTIONS(10741), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(10743), 1,
      anon_sym_u2987,
    ACTIONS(10745), 1,
      aux_sym_integer_token1,
    ACTIONS(10747), 1,
      aux_sym_string_token1,
    ACTIONS(10749), 1,
      anon_sym_Set,
    STATE(7645), 1,
      sym_atom,
    STATE(7641), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7631), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(10723), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [560383] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(3354), 1,
      sym_id,
    ACTIONS(3358), 1,
      anon_sym_record,
    ACTIONS(3368), 1,
      aux_sym__qid_token1,
    ACTIONS(3374), 1,
      anon_sym_u2987,
    ACTIONS(3376), 1,
      aux_sym_integer_token1,
    ACTIONS(3378), 1,
      anon_sym_Set,
    ACTIONS(4336), 1,
      anon_sym_LPAREN,
    ACTIONS(4340), 1,
      anon_sym_u2983,
    ACTIONS(4342), 1,
      anon_sym_LBRACE,
    ACTIONS(4344), 1,
      anon_sym_DOT,
    ACTIONS(12115), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12117), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(12119), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(12121), 1,
      aux_sym_string_token1,
    STATE(4193), 1,
      sym_atom,
    STATE(4178), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4177), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3356), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [560458] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2840), 1,
      sym_id,
    ACTIONS(2848), 1,
      anon_sym_record,
    ACTIONS(2858), 1,
      aux_sym__qid_token1,
    ACTIONS(2866), 1,
      anon_sym_u2987,
    ACTIONS(2868), 1,
      aux_sym_integer_token1,
    ACTIONS(2870), 1,
      anon_sym_Set,
    ACTIONS(4472), 1,
      anon_sym_DOT,
    ACTIONS(12123), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12125), 1,
      anon_sym_LPAREN,
    ACTIONS(12127), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(12129), 1,
      anon_sym_u2983,
    ACTIONS(12131), 1,
      anon_sym_LBRACE,
    ACTIONS(12133), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(12135), 1,
      aux_sym_string_token1,
    STATE(4763), 1,
      sym_atom,
    STATE(4765), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4766), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(2846), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [560533] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2272), 1,
      sym_id,
    ACTIONS(2276), 1,
      anon_sym_record,
    ACTIONS(2286), 1,
      aux_sym__qid_token1,
    ACTIONS(2292), 1,
      anon_sym_u2987,
    ACTIONS(2294), 1,
      aux_sym_integer_token1,
    ACTIONS(2296), 1,
      anon_sym_Set,
    ACTIONS(4808), 1,
      anon_sym_DOT,
    ACTIONS(12137), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12139), 1,
      anon_sym_LPAREN,
    ACTIONS(12141), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(12143), 1,
      anon_sym_u2983,
    ACTIONS(12145), 1,
      anon_sym_LBRACE,
    ACTIONS(12147), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(12149), 1,
      aux_sym_string_token1,
    STATE(5138), 1,
      sym_atom,
    STATE(5139), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5053), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(2274), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [560608] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(10843), 1,
      sym_id,
    ACTIONS(10845), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10849), 1,
      anon_sym_record,
    ACTIONS(10851), 1,
      anon_sym_LPAREN,
    ACTIONS(10853), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(10855), 1,
      anon_sym_u2983,
    ACTIONS(10857), 1,
      anon_sym_LBRACE,
    ACTIONS(10859), 1,
      aux_sym__qid_token1,
    ACTIONS(10861), 1,
      anon_sym_DOT,
    ACTIONS(10865), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(10867), 1,
      anon_sym_u2987,
    ACTIONS(10869), 1,
      aux_sym_integer_token1,
    ACTIONS(10871), 1,
      aux_sym_string_token1,
    ACTIONS(10873), 1,
      anon_sym_Set,
    STATE(7697), 1,
      sym_atom,
    STATE(7705), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7719), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(10847), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [560683] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2174), 1,
      sym_id,
    ACTIONS(2182), 1,
      anon_sym_record,
    ACTIONS(2192), 1,
      aux_sym__qid_token1,
    ACTIONS(2200), 1,
      anon_sym_u2987,
    ACTIONS(2202), 1,
      aux_sym_integer_token1,
    ACTIONS(2204), 1,
      anon_sym_Set,
    ACTIONS(4872), 1,
      anon_sym_LPAREN,
    ACTIONS(4876), 1,
      anon_sym_u2983,
    ACTIONS(4878), 1,
      anon_sym_LBRACE,
    ACTIONS(4880), 1,
      anon_sym_DOT,
    ACTIONS(11853), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11863), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11865), 1,
      aux_sym_string_token1,
    ACTIONS(12151), 1,
      anon_sym_LBRACE_LBRACE,
    STATE(4548), 1,
      sym_atom,
    STATE(4536), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4531), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(2180), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [560758] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(894), 1,
      sym_id,
    ACTIONS(904), 1,
      anon_sym_record,
    ACTIONS(916), 1,
      aux_sym__qid_token1,
    ACTIONS(926), 1,
      anon_sym_u2987,
    ACTIONS(930), 1,
      aux_sym_integer_token1,
    ACTIONS(932), 1,
      anon_sym_Set,
    ACTIONS(4320), 1,
      anon_sym_LPAREN,
    ACTIONS(4324), 1,
      anon_sym_u2983,
    ACTIONS(4326), 1,
      anon_sym_LBRACE,
    ACTIONS(4328), 1,
      anon_sym_DOT,
    ACTIONS(11651), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11661), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11663), 1,
      aux_sym_string_token1,
    ACTIONS(12153), 1,
      anon_sym_LBRACE_LBRACE,
    STATE(4979), 1,
      sym_atom,
    STATE(4961), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4920), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(902), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [560833] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(9539), 1,
      sym_id,
    ACTIONS(9541), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9545), 1,
      anon_sym_record,
    ACTIONS(9547), 1,
      anon_sym_LPAREN,
    ACTIONS(9549), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(9551), 1,
      anon_sym_u2983,
    ACTIONS(9553), 1,
      anon_sym_LBRACE,
    ACTIONS(9555), 1,
      aux_sym__qid_token1,
    ACTIONS(9557), 1,
      anon_sym_DOT,
    ACTIONS(9561), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(9563), 1,
      anon_sym_u2987,
    ACTIONS(9565), 1,
      aux_sym_integer_token1,
    ACTIONS(9567), 1,
      aux_sym_string_token1,
    ACTIONS(9569), 1,
      anon_sym_Set,
    STATE(7623), 1,
      sym_atom,
    STATE(7603), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7600), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(9543), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [560908] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(4190), 1,
      anon_sym_record,
    ACTIONS(4192), 1,
      anon_sym_LPAREN,
    ACTIONS(4196), 1,
      anon_sym_u2983,
    ACTIONS(4198), 1,
      anon_sym_LBRACE,
    ACTIONS(4202), 1,
      anon_sym_DOT,
    ACTIONS(4208), 1,
      anon_sym_u2987,
    ACTIONS(4210), 1,
      aux_sym_integer_token1,
    ACTIONS(4212), 1,
      anon_sym_Set,
    ACTIONS(6228), 1,
      sym_id,
    ACTIONS(6230), 1,
      aux_sym__qid_token1,
    ACTIONS(12155), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12157), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(12159), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(12161), 1,
      aux_sym_string_token1,
    STATE(6562), 1,
      sym_atom,
    STATE(6575), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6565), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(4188), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [560983] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(5166), 1,
      sym_id,
    ACTIONS(5170), 1,
      anon_sym_record,
    ACTIONS(5172), 1,
      anon_sym_LPAREN,
    ACTIONS(5176), 1,
      anon_sym_u2983,
    ACTIONS(5178), 1,
      anon_sym_LBRACE,
    ACTIONS(5180), 1,
      aux_sym__qid_token1,
    ACTIONS(5182), 1,
      anon_sym_DOT,
    ACTIONS(5186), 1,
      anon_sym_u2987,
    ACTIONS(5188), 1,
      aux_sym_integer_token1,
    ACTIONS(5190), 1,
      anon_sym_Set,
    ACTIONS(12163), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12165), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(12167), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(12169), 1,
      aux_sym_string_token1,
    STATE(5934), 1,
      sym_atom,
    STATE(5928), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5926), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(5168), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [561058] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1916), 1,
      anon_sym_record,
    ACTIONS(1918), 1,
      anon_sym_LPAREN,
    ACTIONS(1922), 1,
      anon_sym_u2983,
    ACTIONS(1924), 1,
      anon_sym_LBRACE,
    ACTIONS(1934), 1,
      anon_sym_u2987,
    ACTIONS(1938), 1,
      aux_sym_integer_token1,
    ACTIONS(2606), 1,
      sym_id,
    ACTIONS(2608), 1,
      aux_sym__qid_token1,
    ACTIONS(2610), 1,
      anon_sym_DOT,
    ACTIONS(2612), 1,
      anon_sym_Set,
    ACTIONS(12171), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12173), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(12175), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(12177), 1,
      aux_sym_string_token1,
    STATE(4674), 1,
      sym_atom,
    STATE(4675), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4679), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(1914), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [561133] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(9159), 1,
      sym_id,
    ACTIONS(9161), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9165), 1,
      anon_sym_record,
    ACTIONS(9167), 1,
      anon_sym_LPAREN,
    ACTIONS(9169), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(9171), 1,
      anon_sym_u2983,
    ACTIONS(9173), 1,
      anon_sym_LBRACE,
    ACTIONS(9175), 1,
      aux_sym__qid_token1,
    ACTIONS(9177), 1,
      anon_sym_DOT,
    ACTIONS(9181), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(9183), 1,
      anon_sym_u2987,
    ACTIONS(9185), 1,
      aux_sym_integer_token1,
    ACTIONS(9187), 1,
      aux_sym_string_token1,
    ACTIONS(9189), 1,
      anon_sym_Set,
    STATE(7599), 1,
      sym_atom,
    STATE(7577), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7571), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(9163), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [561208] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(3300), 1,
      sym_id,
    ACTIONS(3304), 1,
      anon_sym_record,
    ACTIONS(3314), 1,
      aux_sym__qid_token1,
    ACTIONS(3320), 1,
      anon_sym_u2987,
    ACTIONS(3322), 1,
      aux_sym_integer_token1,
    ACTIONS(3324), 1,
      anon_sym_Set,
    ACTIONS(4854), 1,
      anon_sym_LPAREN,
    ACTIONS(4858), 1,
      anon_sym_u2983,
    ACTIONS(4860), 1,
      anon_sym_LBRACE,
    ACTIONS(4862), 1,
      anon_sym_DOT,
    ACTIONS(11825), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11835), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11837), 1,
      aux_sym_string_token1,
    ACTIONS(12179), 1,
      anon_sym_LBRACE_LBRACE,
    STATE(4055), 1,
      sym_atom,
    STATE(4053), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4049), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3302), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [561283] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(10038), 1,
      sym_id,
    ACTIONS(10040), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10044), 1,
      anon_sym_record,
    ACTIONS(10046), 1,
      anon_sym_LPAREN,
    ACTIONS(10048), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(10050), 1,
      anon_sym_u2983,
    ACTIONS(10052), 1,
      anon_sym_LBRACE,
    ACTIONS(10054), 1,
      aux_sym__qid_token1,
    ACTIONS(10056), 1,
      anon_sym_DOT,
    ACTIONS(10060), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(10062), 1,
      anon_sym_u2987,
    ACTIONS(10064), 1,
      aux_sym_integer_token1,
    ACTIONS(10066), 1,
      aux_sym_string_token1,
    ACTIONS(10068), 1,
      anon_sym_Set,
    STATE(7463), 1,
      sym_atom,
    STATE(7504), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7499), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(10042), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [561358] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2614), 1,
      sym_id,
    ACTIONS(2624), 1,
      anon_sym_record,
    ACTIONS(2634), 1,
      aux_sym__qid_token1,
    ACTIONS(2644), 1,
      anon_sym_u2987,
    ACTIONS(2648), 1,
      aux_sym_integer_token1,
    ACTIONS(2650), 1,
      anon_sym_Set,
    ACTIONS(4898), 1,
      anon_sym_LPAREN,
    ACTIONS(4902), 1,
      anon_sym_u2983,
    ACTIONS(4904), 1,
      anon_sym_LBRACE,
    ACTIONS(4906), 1,
      anon_sym_DOT,
    ACTIONS(11885), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11895), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11897), 1,
      aux_sym_string_token1,
    ACTIONS(12181), 1,
      anon_sym_LBRACE_LBRACE,
    STATE(4806), 1,
      sym_atom,
    STATE(4799), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4784), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(2622), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [561433] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(10206), 1,
      sym_id,
    ACTIONS(10208), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10212), 1,
      anon_sym_record,
    ACTIONS(10214), 1,
      anon_sym_LPAREN,
    ACTIONS(10216), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(10218), 1,
      anon_sym_u2983,
    ACTIONS(10220), 1,
      anon_sym_LBRACE,
    ACTIONS(10222), 1,
      aux_sym__qid_token1,
    ACTIONS(10224), 1,
      anon_sym_DOT,
    ACTIONS(10228), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(10230), 1,
      anon_sym_u2987,
    ACTIONS(10232), 1,
      aux_sym_integer_token1,
    ACTIONS(10234), 1,
      aux_sym_string_token1,
    ACTIONS(10236), 1,
      anon_sym_Set,
    STATE(7750), 1,
      sym_atom,
    STATE(7731), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7724), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(10210), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [561508] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(692), 1,
      anon_sym_record,
    ACTIONS(694), 1,
      anon_sym_LPAREN,
    ACTIONS(698), 1,
      anon_sym_u2983,
    ACTIONS(702), 1,
      anon_sym_LBRACE,
    ACTIONS(708), 1,
      anon_sym_DOT,
    ACTIONS(720), 1,
      anon_sym_u2987,
    ACTIONS(726), 1,
      aux_sym_integer_token1,
    ACTIONS(728), 1,
      anon_sym_Set,
    ACTIONS(2336), 1,
      sym_id,
    ACTIONS(2342), 1,
      aux_sym__qid_token1,
    ACTIONS(11519), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11521), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11523), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11525), 1,
      aux_sym_string_token1,
    STATE(5045), 1,
      sym_atom,
    STATE(5069), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5056), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(690), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [561583] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(5630), 1,
      sym_id,
    ACTIONS(5634), 1,
      anon_sym_record,
    ACTIONS(5636), 1,
      anon_sym_LPAREN,
    ACTIONS(5640), 1,
      anon_sym_u2983,
    ACTIONS(5642), 1,
      anon_sym_LBRACE,
    ACTIONS(5644), 1,
      aux_sym__qid_token1,
    ACTIONS(5646), 1,
      anon_sym_DOT,
    ACTIONS(5650), 1,
      anon_sym_u2987,
    ACTIONS(5652), 1,
      aux_sym_integer_token1,
    ACTIONS(5654), 1,
      anon_sym_Set,
    ACTIONS(12183), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12185), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(12187), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(12189), 1,
      aux_sym_string_token1,
    STATE(5724), 1,
      sym_atom,
    STATE(5733), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5727), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(5632), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [561658] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(3016), 1,
      sym_id,
    ACTIONS(3026), 1,
      anon_sym_record,
    ACTIONS(3036), 1,
      aux_sym__qid_token1,
    ACTIONS(3046), 1,
      anon_sym_u2987,
    ACTIONS(3050), 1,
      aux_sym_integer_token1,
    ACTIONS(3052), 1,
      anon_sym_Set,
    ACTIONS(4606), 1,
      anon_sym_LPAREN,
    ACTIONS(4610), 1,
      anon_sym_u2983,
    ACTIONS(4612), 1,
      anon_sym_LBRACE,
    ACTIONS(4614), 1,
      anon_sym_DOT,
    ACTIONS(12191), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12193), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(12195), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(12197), 1,
      aux_sym_string_token1,
    STATE(5229), 1,
      sym_atom,
    STATE(5330), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5333), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3024), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [561733] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(5246), 1,
      sym_id,
    ACTIONS(5250), 1,
      anon_sym_record,
    ACTIONS(5252), 1,
      anon_sym_LPAREN,
    ACTIONS(5256), 1,
      anon_sym_u2983,
    ACTIONS(5258), 1,
      anon_sym_LBRACE,
    ACTIONS(5260), 1,
      aux_sym__qid_token1,
    ACTIONS(5262), 1,
      anon_sym_DOT,
    ACTIONS(5266), 1,
      anon_sym_u2987,
    ACTIONS(5268), 1,
      aux_sym_integer_token1,
    ACTIONS(5270), 1,
      anon_sym_Set,
    ACTIONS(12199), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12201), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(12203), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(12205), 1,
      aux_sym_string_token1,
    STATE(5465), 1,
      sym_atom,
    STATE(5466), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5472), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(5248), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [561808] = 5,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(12207), 1,
      anon_sym_AT,
    ACTIONS(6326), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6324), 26,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [561853] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(3610), 1,
      sym_id,
    ACTIONS(3616), 1,
      anon_sym_record,
    ACTIONS(3618), 1,
      anon_sym_LPAREN,
    ACTIONS(3622), 1,
      anon_sym_u2983,
    ACTIONS(3624), 1,
      anon_sym_LBRACE,
    ACTIONS(3626), 1,
      aux_sym__qid_token1,
    ACTIONS(3628), 1,
      anon_sym_DOT,
    ACTIONS(3632), 1,
      anon_sym_u2987,
    ACTIONS(3634), 1,
      aux_sym_integer_token1,
    ACTIONS(3636), 1,
      anon_sym_Set,
    ACTIONS(12209), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12211), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(12213), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(12215), 1,
      aux_sym_string_token1,
    STATE(5276), 1,
      sym_atom,
    STATE(5254), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5242), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3614), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [561928] = 3,
    ACTIONS(6326), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6324), 31,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [561969] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(3912), 1,
      sym_id,
    ACTIONS(3916), 1,
      anon_sym_record,
    ACTIONS(3926), 1,
      aux_sym__qid_token1,
    ACTIONS(3932), 1,
      anon_sym_u2987,
    ACTIONS(3934), 1,
      aux_sym_integer_token1,
    ACTIONS(3936), 1,
      anon_sym_Set,
    ACTIONS(4412), 1,
      anon_sym_LPAREN,
    ACTIONS(4416), 1,
      anon_sym_u2983,
    ACTIONS(4418), 1,
      anon_sym_LBRACE,
    ACTIONS(4420), 1,
      anon_sym_DOT,
    ACTIONS(12217), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12219), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(12221), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(12223), 1,
      aux_sym_string_token1,
    STATE(4716), 1,
      sym_atom,
    STATE(4662), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4728), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3914), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [562044] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2272), 1,
      sym_id,
    ACTIONS(2276), 1,
      anon_sym_record,
    ACTIONS(2286), 1,
      aux_sym__qid_token1,
    ACTIONS(2292), 1,
      anon_sym_u2987,
    ACTIONS(2294), 1,
      aux_sym_integer_token1,
    ACTIONS(2296), 1,
      anon_sym_Set,
    ACTIONS(4800), 1,
      anon_sym_LPAREN,
    ACTIONS(4804), 1,
      anon_sym_u2983,
    ACTIONS(4806), 1,
      anon_sym_LBRACE,
    ACTIONS(4808), 1,
      anon_sym_DOT,
    ACTIONS(12137), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12147), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(12149), 1,
      aux_sym_string_token1,
    ACTIONS(12225), 1,
      anon_sym_LBRACE_LBRACE,
    STATE(5123), 1,
      sym_atom,
    STATE(5139), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5053), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(2274), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [562119] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(5442), 1,
      sym_id,
    ACTIONS(5446), 1,
      anon_sym_record,
    ACTIONS(5448), 1,
      anon_sym_LPAREN,
    ACTIONS(5452), 1,
      anon_sym_u2983,
    ACTIONS(5454), 1,
      anon_sym_LBRACE,
    ACTIONS(5456), 1,
      aux_sym__qid_token1,
    ACTIONS(5458), 1,
      anon_sym_DOT,
    ACTIONS(5462), 1,
      anon_sym_u2987,
    ACTIONS(5464), 1,
      aux_sym_integer_token1,
    ACTIONS(5466), 1,
      anon_sym_Set,
    ACTIONS(12227), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12229), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(12231), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(12233), 1,
      aux_sym_string_token1,
    STATE(5640), 1,
      sym_atom,
    STATE(5639), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5635), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(5444), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [562194] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(4248), 1,
      sym_id,
    ACTIONS(4252), 1,
      anon_sym_record,
    ACTIONS(4254), 1,
      anon_sym_LPAREN,
    ACTIONS(4258), 1,
      anon_sym_u2983,
    ACTIONS(4260), 1,
      anon_sym_LBRACE,
    ACTIONS(4262), 1,
      aux_sym__qid_token1,
    ACTIONS(4264), 1,
      anon_sym_DOT,
    ACTIONS(4268), 1,
      anon_sym_u2987,
    ACTIONS(4270), 1,
      aux_sym_integer_token1,
    ACTIONS(4272), 1,
      anon_sym_Set,
    ACTIONS(11709), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11711), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11713), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11715), 1,
      aux_sym_string_token1,
    STATE(5959), 1,
      sym_atom,
    STATE(5952), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5976), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(4250), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [562269] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2898), 1,
      sym_id,
    ACTIONS(2910), 1,
      anon_sym_record,
    ACTIONS(2912), 1,
      anon_sym_LPAREN,
    ACTIONS(2916), 1,
      anon_sym_u2983,
    ACTIONS(2918), 1,
      anon_sym_LBRACE,
    ACTIONS(2920), 1,
      aux_sym__qid_token1,
    ACTIONS(2922), 1,
      anon_sym_DOT,
    ACTIONS(2930), 1,
      anon_sym_u2987,
    ACTIONS(2934), 1,
      aux_sym_integer_token1,
    ACTIONS(2936), 1,
      anon_sym_Set,
    ACTIONS(11725), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11727), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11729), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11731), 1,
      aux_sym_string_token1,
    STATE(4246), 1,
      sym_atom,
    STATE(4184), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4206), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(2908), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [562344] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(5522), 1,
      sym_id,
    ACTIONS(5526), 1,
      anon_sym_record,
    ACTIONS(5528), 1,
      anon_sym_LPAREN,
    ACTIONS(5532), 1,
      anon_sym_u2983,
    ACTIONS(5534), 1,
      anon_sym_LBRACE,
    ACTIONS(5536), 1,
      aux_sym__qid_token1,
    ACTIONS(5538), 1,
      anon_sym_DOT,
    ACTIONS(5542), 1,
      anon_sym_u2987,
    ACTIONS(5544), 1,
      aux_sym_integer_token1,
    ACTIONS(5546), 1,
      anon_sym_Set,
    ACTIONS(12235), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12237), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(12239), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(12241), 1,
      aux_sym_string_token1,
    STATE(5313), 1,
      sym_atom,
    STATE(5318), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5319), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(5524), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [562419] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6405), 1,
      sym_id,
    ACTIONS(6409), 1,
      anon_sym_record,
    ACTIONS(6411), 1,
      anon_sym_LPAREN,
    ACTIONS(6415), 1,
      anon_sym_u2983,
    ACTIONS(6417), 1,
      anon_sym_LBRACE,
    ACTIONS(6419), 1,
      aux_sym__qid_token1,
    ACTIONS(6421), 1,
      anon_sym_DOT,
    ACTIONS(6425), 1,
      anon_sym_u2987,
    ACTIONS(6427), 1,
      aux_sym_integer_token1,
    ACTIONS(6429), 1,
      anon_sym_Set,
    ACTIONS(12027), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12029), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(12031), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(12033), 1,
      aux_sym_string_token1,
    STATE(6150), 1,
      sym_atom,
    STATE(6157), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6162), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(6407), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [562494] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2840), 1,
      sym_id,
    ACTIONS(2848), 1,
      anon_sym_record,
    ACTIONS(2858), 1,
      aux_sym__qid_token1,
    ACTIONS(2866), 1,
      anon_sym_u2987,
    ACTIONS(2868), 1,
      aux_sym_integer_token1,
    ACTIONS(2870), 1,
      anon_sym_Set,
    ACTIONS(4464), 1,
      anon_sym_LPAREN,
    ACTIONS(4468), 1,
      anon_sym_u2983,
    ACTIONS(4470), 1,
      anon_sym_LBRACE,
    ACTIONS(4472), 1,
      anon_sym_DOT,
    ACTIONS(12123), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12133), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(12135), 1,
      aux_sym_string_token1,
    ACTIONS(12243), 1,
      anon_sym_LBRACE_LBRACE,
    STATE(4763), 1,
      sym_atom,
    STATE(4765), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4766), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(2846), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [562569] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(9507), 1,
      sym_id,
    ACTIONS(9509), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9513), 1,
      anon_sym_record,
    ACTIONS(9515), 1,
      anon_sym_LPAREN,
    ACTIONS(9517), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(9519), 1,
      anon_sym_u2983,
    ACTIONS(9521), 1,
      anon_sym_LBRACE,
    ACTIONS(9523), 1,
      aux_sym__qid_token1,
    ACTIONS(9525), 1,
      anon_sym_DOT,
    ACTIONS(9529), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(9531), 1,
      anon_sym_u2987,
    ACTIONS(9533), 1,
      aux_sym_integer_token1,
    ACTIONS(9535), 1,
      aux_sym_string_token1,
    ACTIONS(9537), 1,
      anon_sym_Set,
    STATE(7585), 1,
      sym_atom,
    STATE(7575), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7573), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(9511), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [562644] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(8439), 1,
      sym_id,
    ACTIONS(8441), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8445), 1,
      anon_sym_record,
    ACTIONS(8447), 1,
      anon_sym_LPAREN,
    ACTIONS(8449), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(8451), 1,
      anon_sym_u2983,
    ACTIONS(8453), 1,
      anon_sym_LBRACE,
    ACTIONS(8455), 1,
      aux_sym__qid_token1,
    ACTIONS(8457), 1,
      anon_sym_DOT,
    ACTIONS(8461), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(8463), 1,
      anon_sym_u2987,
    ACTIONS(8465), 1,
      aux_sym_integer_token1,
    ACTIONS(8467), 1,
      aux_sym_string_token1,
    ACTIONS(8469), 1,
      anon_sym_Set,
    STATE(7375), 1,
      sym_atom,
    STATE(7331), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7333), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(8443), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [562719] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6058), 1,
      sym_id,
    ACTIONS(6062), 1,
      anon_sym_record,
    ACTIONS(6064), 1,
      anon_sym_LPAREN,
    ACTIONS(6068), 1,
      anon_sym_u2983,
    ACTIONS(6070), 1,
      anon_sym_LBRACE,
    ACTIONS(6072), 1,
      aux_sym__qid_token1,
    ACTIONS(6074), 1,
      anon_sym_DOT,
    ACTIONS(6078), 1,
      anon_sym_u2987,
    ACTIONS(6080), 1,
      aux_sym_integer_token1,
    ACTIONS(6082), 1,
      anon_sym_Set,
    ACTIONS(11435), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11437), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11439), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11441), 1,
      aux_sym_string_token1,
    STATE(4340), 1,
      sym_atom,
    STATE(4341), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4349), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(6060), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [562794] = 5,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(12245), 1,
      anon_sym_AT,
    ACTIONS(6326), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6324), 26,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [562839] = 4,
    ACTIONS(6326), 1,
      anon_sym_BSLASH,
    ACTIONS(12247), 1,
      anon_sym_AT,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6324), 30,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [562882] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(5656), 1,
      sym_id,
    ACTIONS(5660), 1,
      anon_sym_record,
    ACTIONS(5662), 1,
      anon_sym_LPAREN,
    ACTIONS(5666), 1,
      anon_sym_u2983,
    ACTIONS(5668), 1,
      anon_sym_LBRACE,
    ACTIONS(5670), 1,
      aux_sym__qid_token1,
    ACTIONS(5672), 1,
      anon_sym_DOT,
    ACTIONS(5676), 1,
      anon_sym_u2987,
    ACTIONS(5678), 1,
      aux_sym_integer_token1,
    ACTIONS(5680), 1,
      anon_sym_Set,
    ACTIONS(12249), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12251), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(12253), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(12255), 1,
      aux_sym_string_token1,
    STATE(6129), 1,
      sym_atom,
    STATE(6130), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6053), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(5658), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [562957] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1866), 1,
      sym_id,
    ACTIONS(1876), 1,
      anon_sym_record,
    ACTIONS(1886), 1,
      aux_sym__qid_token1,
    ACTIONS(1896), 1,
      anon_sym_u2987,
    ACTIONS(1900), 1,
      aux_sym_integer_token1,
    ACTIONS(1902), 1,
      anon_sym_Set,
    ACTIONS(4892), 1,
      anon_sym_DOT,
    ACTIONS(12257), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12259), 1,
      anon_sym_LPAREN,
    ACTIONS(12261), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(12263), 1,
      anon_sym_u2983,
    ACTIONS(12265), 1,
      anon_sym_LBRACE,
    ACTIONS(12267), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(12269), 1,
      aux_sym_string_token1,
    STATE(4265), 1,
      sym_atom,
    STATE(4264), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4263), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(1874), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [563032] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(3852), 1,
      sym_id,
    ACTIONS(3856), 1,
      anon_sym_record,
    ACTIONS(3866), 1,
      aux_sym__qid_token1,
    ACTIONS(3872), 1,
      anon_sym_u2987,
    ACTIONS(3874), 1,
      aux_sym_integer_token1,
    ACTIONS(3876), 1,
      anon_sym_Set,
    ACTIONS(4724), 1,
      anon_sym_LPAREN,
    ACTIONS(4728), 1,
      anon_sym_u2983,
    ACTIONS(4730), 1,
      anon_sym_LBRACE,
    ACTIONS(4732), 1,
      anon_sym_DOT,
    ACTIONS(12271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12273), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(12275), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(12277), 1,
      aux_sym_string_token1,
    STATE(4637), 1,
      sym_atom,
    STATE(4642), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4643), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3854), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [563107] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(5522), 1,
      sym_id,
    ACTIONS(5526), 1,
      anon_sym_record,
    ACTIONS(5528), 1,
      anon_sym_LPAREN,
    ACTIONS(5532), 1,
      anon_sym_u2983,
    ACTIONS(5534), 1,
      anon_sym_LBRACE,
    ACTIONS(5536), 1,
      aux_sym__qid_token1,
    ACTIONS(5538), 1,
      anon_sym_DOT,
    ACTIONS(5542), 1,
      anon_sym_u2987,
    ACTIONS(5544), 1,
      aux_sym_integer_token1,
    ACTIONS(5546), 1,
      anon_sym_Set,
    ACTIONS(12235), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12237), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(12239), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(12241), 1,
      aux_sym_string_token1,
    STATE(5317), 1,
      sym_atom,
    STATE(5318), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5319), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(5524), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [563182] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(5442), 1,
      sym_id,
    ACTIONS(5446), 1,
      anon_sym_record,
    ACTIONS(5448), 1,
      anon_sym_LPAREN,
    ACTIONS(5452), 1,
      anon_sym_u2983,
    ACTIONS(5454), 1,
      anon_sym_LBRACE,
    ACTIONS(5456), 1,
      aux_sym__qid_token1,
    ACTIONS(5458), 1,
      anon_sym_DOT,
    ACTIONS(5462), 1,
      anon_sym_u2987,
    ACTIONS(5464), 1,
      aux_sym_integer_token1,
    ACTIONS(5466), 1,
      anon_sym_Set,
    ACTIONS(12227), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12229), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(12231), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(12233), 1,
      aux_sym_string_token1,
    STATE(5654), 1,
      sym_atom,
    STATE(5639), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5635), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(5444), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [563257] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6502), 1,
      sym_id,
    ACTIONS(6504), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6508), 1,
      anon_sym_record,
    ACTIONS(6510), 1,
      anon_sym_LPAREN,
    ACTIONS(6512), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(6514), 1,
      anon_sym_u2983,
    ACTIONS(6516), 1,
      anon_sym_LBRACE,
    ACTIONS(6518), 1,
      aux_sym__qid_token1,
    ACTIONS(6520), 1,
      anon_sym_DOT,
    ACTIONS(6524), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(6526), 1,
      anon_sym_u2987,
    ACTIONS(6528), 1,
      aux_sym_integer_token1,
    ACTIONS(6530), 1,
      aux_sym_string_token1,
    ACTIONS(6532), 1,
      anon_sym_Set,
    STATE(6849), 1,
      sym_atom,
    STATE(6850), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6851), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(6506), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [563332] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6496), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6494), 27,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [563375] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(3064), 1,
      anon_sym_record,
    ACTIONS(3066), 1,
      anon_sym_LPAREN,
    ACTIONS(3070), 1,
      anon_sym_u2983,
    ACTIONS(3072), 1,
      anon_sym_LBRACE,
    ACTIONS(3078), 1,
      anon_sym_DOT,
    ACTIONS(3084), 1,
      anon_sym_u2987,
    ACTIONS(3086), 1,
      aux_sym_integer_token1,
    ACTIONS(3088), 1,
      anon_sym_Set,
    ACTIONS(6232), 1,
      sym_id,
    ACTIONS(6234), 1,
      aux_sym__qid_token1,
    ACTIONS(11945), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11947), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11949), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11951), 1,
      aux_sym_string_token1,
    STATE(6745), 1,
      sym_atom,
    STATE(6715), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6714), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3062), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [563450] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(850), 1,
      sym_id,
    ACTIONS(860), 1,
      anon_sym_record,
    ACTIONS(872), 1,
      aux_sym__qid_token1,
    ACTIONS(884), 1,
      anon_sym_u2987,
    ACTIONS(890), 1,
      aux_sym_integer_token1,
    ACTIONS(892), 1,
      anon_sym_Set,
    ACTIONS(4290), 1,
      anon_sym_LPAREN,
    ACTIONS(4294), 1,
      anon_sym_u2983,
    ACTIONS(4296), 1,
      anon_sym_LBRACE,
    ACTIONS(4298), 1,
      anon_sym_DOT,
    ACTIONS(11695), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11705), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11707), 1,
      aux_sym_string_token1,
    ACTIONS(12279), 1,
      anon_sym_LBRACE_LBRACE,
    STATE(5156), 1,
      sym_atom,
    STATE(5180), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5168), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(858), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [563525] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2018), 1,
      sym_id,
    ACTIONS(2028), 1,
      anon_sym_record,
    ACTIONS(2038), 1,
      aux_sym__qid_token1,
    ACTIONS(2048), 1,
      anon_sym_u2987,
    ACTIONS(2052), 1,
      aux_sym_integer_token1,
    ACTIONS(2054), 1,
      anon_sym_Set,
    ACTIONS(4706), 1,
      anon_sym_LPAREN,
    ACTIONS(4710), 1,
      anon_sym_u2983,
    ACTIONS(4712), 1,
      anon_sym_LBRACE,
    ACTIONS(4714), 1,
      anon_sym_DOT,
    ACTIONS(12281), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12283), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(12285), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(12287), 1,
      aux_sym_string_token1,
    STATE(5169), 1,
      sym_atom,
    STATE(5176), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5183), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(2026), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [563600] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(3482), 1,
      sym_id,
    ACTIONS(3492), 1,
      anon_sym_record,
    ACTIONS(3502), 1,
      aux_sym__qid_token1,
    ACTIONS(3512), 1,
      anon_sym_u2987,
    ACTIONS(3516), 1,
      aux_sym_integer_token1,
    ACTIONS(3518), 1,
      anon_sym_Set,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(11733), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11737), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11739), 1,
      aux_sym_string_token1,
    ACTIONS(12289), 1,
      anon_sym_LPAREN,
    ACTIONS(12291), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(12293), 1,
      anon_sym_u2983,
    ACTIONS(12295), 1,
      anon_sym_LBRACE,
    STATE(4381), 1,
      sym_atom,
    STATE(4382), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4385), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3490), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [563675] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(4190), 1,
      anon_sym_record,
    ACTIONS(4192), 1,
      anon_sym_LPAREN,
    ACTIONS(4196), 1,
      anon_sym_u2983,
    ACTIONS(4198), 1,
      anon_sym_LBRACE,
    ACTIONS(4202), 1,
      anon_sym_DOT,
    ACTIONS(4208), 1,
      anon_sym_u2987,
    ACTIONS(4210), 1,
      aux_sym_integer_token1,
    ACTIONS(4212), 1,
      anon_sym_Set,
    ACTIONS(6228), 1,
      sym_id,
    ACTIONS(6230), 1,
      aux_sym__qid_token1,
    ACTIONS(12155), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12157), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(12159), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(12161), 1,
      aux_sym_string_token1,
    STATE(6552), 1,
      sym_atom,
    STATE(6575), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6565), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(4188), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [563750] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2174), 1,
      sym_id,
    ACTIONS(2182), 1,
      anon_sym_record,
    ACTIONS(2192), 1,
      aux_sym__qid_token1,
    ACTIONS(2200), 1,
      anon_sym_u2987,
    ACTIONS(2202), 1,
      aux_sym_integer_token1,
    ACTIONS(2204), 1,
      anon_sym_Set,
    ACTIONS(4872), 1,
      anon_sym_LPAREN,
    ACTIONS(4876), 1,
      anon_sym_u2983,
    ACTIONS(4878), 1,
      anon_sym_LBRACE,
    ACTIONS(4880), 1,
      anon_sym_DOT,
    ACTIONS(11853), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11863), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11865), 1,
      aux_sym_string_token1,
    ACTIONS(12151), 1,
      anon_sym_LBRACE_LBRACE,
    STATE(4538), 1,
      sym_atom,
    STATE(4536), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4531), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(2180), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [563825] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6655), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6653), 27,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [563868] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(3998), 1,
      aux_sym_integer_token1,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4222), 1,
      sym_id,
    ACTIONS(4224), 1,
      aux_sym__qid_token1,
    ACTIONS(12297), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12299), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(12301), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(12303), 1,
      aux_sym_string_token1,
    STATE(6287), 1,
      sym_atom,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3972), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [563943] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11244), 1,
      sym_id,
    ACTIONS(11246), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11250), 1,
      anon_sym_record,
    ACTIONS(11252), 1,
      anon_sym_LPAREN,
    ACTIONS(11254), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11256), 1,
      anon_sym_u2983,
    ACTIONS(11258), 1,
      anon_sym_LBRACE,
    ACTIONS(11260), 1,
      aux_sym__qid_token1,
    ACTIONS(11262), 1,
      anon_sym_DOT,
    ACTIONS(11264), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11266), 1,
      anon_sym_u2987,
    ACTIONS(11268), 1,
      aux_sym_integer_token1,
    ACTIONS(11270), 1,
      aux_sym_string_token1,
    ACTIONS(11272), 1,
      anon_sym_Set,
    STATE(7841), 1,
      sym_atom,
    STATE(7835), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7830), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11248), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [564018] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(9475), 1,
      sym_id,
    ACTIONS(9477), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9481), 1,
      anon_sym_record,
    ACTIONS(9483), 1,
      anon_sym_LPAREN,
    ACTIONS(9485), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(9487), 1,
      anon_sym_u2983,
    ACTIONS(9489), 1,
      anon_sym_LBRACE,
    ACTIONS(9491), 1,
      aux_sym__qid_token1,
    ACTIONS(9493), 1,
      anon_sym_DOT,
    ACTIONS(9497), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(9499), 1,
      anon_sym_u2987,
    ACTIONS(9501), 1,
      aux_sym_integer_token1,
    ACTIONS(9503), 1,
      aux_sym_string_token1,
    ACTIONS(9505), 1,
      anon_sym_Set,
    STATE(7562), 1,
      sym_atom,
    STATE(7555), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7552), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(9479), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [564093] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(3380), 1,
      sym_id,
    ACTIONS(3384), 1,
      anon_sym_record,
    ACTIONS(3386), 1,
      anon_sym_LPAREN,
    ACTIONS(3390), 1,
      anon_sym_u2983,
    ACTIONS(3392), 1,
      anon_sym_LBRACE,
    ACTIONS(3394), 1,
      aux_sym__qid_token1,
    ACTIONS(3396), 1,
      anon_sym_DOT,
    ACTIONS(3400), 1,
      anon_sym_u2987,
    ACTIONS(3402), 1,
      aux_sym_integer_token1,
    ACTIONS(3404), 1,
      anon_sym_Set,
    ACTIONS(12105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12107), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(12109), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(12111), 1,
      aux_sym_string_token1,
    STATE(4936), 1,
      sym_atom,
    STATE(4937), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4939), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3382), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [564168] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2840), 1,
      sym_id,
    ACTIONS(2848), 1,
      anon_sym_record,
    ACTIONS(2858), 1,
      aux_sym__qid_token1,
    ACTIONS(2866), 1,
      anon_sym_u2987,
    ACTIONS(2868), 1,
      aux_sym_integer_token1,
    ACTIONS(2870), 1,
      anon_sym_Set,
    ACTIONS(4464), 1,
      anon_sym_LPAREN,
    ACTIONS(4468), 1,
      anon_sym_u2983,
    ACTIONS(4470), 1,
      anon_sym_LBRACE,
    ACTIONS(4472), 1,
      anon_sym_DOT,
    ACTIONS(12123), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12133), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(12135), 1,
      aux_sym_string_token1,
    ACTIONS(12243), 1,
      anon_sym_LBRACE_LBRACE,
    STATE(4755), 1,
      sym_atom,
    STATE(4765), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4766), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(2846), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [564243] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(5246), 1,
      sym_id,
    ACTIONS(5250), 1,
      anon_sym_record,
    ACTIONS(5252), 1,
      anon_sym_LPAREN,
    ACTIONS(5256), 1,
      anon_sym_u2983,
    ACTIONS(5258), 1,
      anon_sym_LBRACE,
    ACTIONS(5260), 1,
      aux_sym__qid_token1,
    ACTIONS(5262), 1,
      anon_sym_DOT,
    ACTIONS(5266), 1,
      anon_sym_u2987,
    ACTIONS(5268), 1,
      aux_sym_integer_token1,
    ACTIONS(5270), 1,
      anon_sym_Set,
    ACTIONS(12199), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12201), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(12203), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(12205), 1,
      aux_sym_string_token1,
    STATE(5459), 1,
      sym_atom,
    STATE(5466), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5472), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(5248), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [564318] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(8247), 1,
      sym_id,
    ACTIONS(8249), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8253), 1,
      anon_sym_record,
    ACTIONS(8255), 1,
      anon_sym_LPAREN,
    ACTIONS(8257), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(8259), 1,
      anon_sym_u2983,
    ACTIONS(8261), 1,
      anon_sym_LBRACE,
    ACTIONS(8263), 1,
      aux_sym__qid_token1,
    ACTIONS(8265), 1,
      anon_sym_DOT,
    ACTIONS(8269), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(8271), 1,
      anon_sym_u2987,
    ACTIONS(8273), 1,
      aux_sym_integer_token1,
    ACTIONS(8275), 1,
      aux_sym_string_token1,
    ACTIONS(8277), 1,
      anon_sym_Set,
    STATE(7326), 1,
      sym_atom,
    STATE(7320), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7319), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(8251), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [564393] = 3,
    ACTIONS(6496), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6494), 31,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [564434] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(734), 1,
      sym_id,
    ACTIONS(744), 1,
      anon_sym_record,
    ACTIONS(754), 1,
      aux_sym__qid_token1,
    ACTIONS(768), 1,
      anon_sym_u2987,
    ACTIONS(772), 1,
      aux_sym_integer_token1,
    ACTIONS(774), 1,
      anon_sym_Set,
    ACTIONS(4228), 1,
      anon_sym_LPAREN,
    ACTIONS(4232), 1,
      anon_sym_u2983,
    ACTIONS(4234), 1,
      anon_sym_LBRACE,
    ACTIONS(4236), 1,
      anon_sym_DOT,
    ACTIONS(11489), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11499), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11501), 1,
      aux_sym_string_token1,
    ACTIONS(12305), 1,
      anon_sym_LBRACE_LBRACE,
    STATE(5093), 1,
      sym_atom,
    STATE(5108), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5102), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(742), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [564509] = 3,
    ACTIONS(6655), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6653), 31,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [564550] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(706), 1,
      aux_sym__qid_token1,
    ACTIONS(1904), 1,
      sym_id,
    ACTIONS(1916), 1,
      anon_sym_record,
    ACTIONS(1918), 1,
      anon_sym_LPAREN,
    ACTIONS(1922), 1,
      anon_sym_u2983,
    ACTIONS(1924), 1,
      anon_sym_LBRACE,
    ACTIONS(1926), 1,
      anon_sym_DOT,
    ACTIONS(1934), 1,
      anon_sym_u2987,
    ACTIONS(1938), 1,
      aux_sym_integer_token1,
    ACTIONS(1940), 1,
      anon_sym_Set,
    ACTIONS(12171), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12173), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(12175), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(12177), 1,
      aux_sym_string_token1,
    STATE(4674), 1,
      sym_atom,
    STATE(4675), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4679), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(1914), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [564625] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6619), 1,
      sym_id,
    ACTIONS(6623), 1,
      anon_sym_record,
    ACTIONS(6625), 1,
      anon_sym_LPAREN,
    ACTIONS(6629), 1,
      anon_sym_u2983,
    ACTIONS(6631), 1,
      anon_sym_LBRACE,
    ACTIONS(6633), 1,
      aux_sym__qid_token1,
    ACTIONS(6635), 1,
      anon_sym_DOT,
    ACTIONS(6639), 1,
      anon_sym_u2987,
    ACTIONS(6641), 1,
      aux_sym_integer_token1,
    ACTIONS(6643), 1,
      anon_sym_Set,
    ACTIONS(11375), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11377), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11379), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11381), 1,
      aux_sym_string_token1,
    STATE(6401), 1,
      sym_atom,
    STATE(6402), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6407), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(6621), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [564700] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(5682), 1,
      sym_id,
    ACTIONS(5686), 1,
      anon_sym_record,
    ACTIONS(5688), 1,
      anon_sym_LPAREN,
    ACTIONS(5692), 1,
      anon_sym_u2983,
    ACTIONS(5694), 1,
      anon_sym_LBRACE,
    ACTIONS(5696), 1,
      aux_sym__qid_token1,
    ACTIONS(5698), 1,
      anon_sym_DOT,
    ACTIONS(5702), 1,
      anon_sym_u2987,
    ACTIONS(5704), 1,
      aux_sym_integer_token1,
    ACTIONS(5706), 1,
      anon_sym_Set,
    ACTIONS(12307), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12309), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(12311), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(12313), 1,
      aux_sym_string_token1,
    STATE(5919), 1,
      sym_atom,
    STATE(5924), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5925), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(5684), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [564775] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(3638), 1,
      sym_id,
    ACTIONS(3644), 1,
      anon_sym_record,
    ACTIONS(3646), 1,
      anon_sym_LPAREN,
    ACTIONS(3650), 1,
      anon_sym_u2983,
    ACTIONS(3652), 1,
      anon_sym_LBRACE,
    ACTIONS(3654), 1,
      aux_sym__qid_token1,
    ACTIONS(3656), 1,
      anon_sym_DOT,
    ACTIONS(3660), 1,
      anon_sym_u2987,
    ACTIONS(3662), 1,
      aux_sym_integer_token1,
    ACTIONS(3664), 1,
      anon_sym_Set,
    ACTIONS(11527), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11529), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11531), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11533), 1,
      aux_sym_string_token1,
    STATE(5676), 1,
      sym_atom,
    STATE(5680), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5681), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3642), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [564850] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(3912), 1,
      sym_id,
    ACTIONS(3916), 1,
      anon_sym_record,
    ACTIONS(3926), 1,
      aux_sym__qid_token1,
    ACTIONS(3932), 1,
      anon_sym_u2987,
    ACTIONS(3934), 1,
      aux_sym_integer_token1,
    ACTIONS(3936), 1,
      anon_sym_Set,
    ACTIONS(4420), 1,
      anon_sym_DOT,
    ACTIONS(12217), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12221), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(12223), 1,
      aux_sym_string_token1,
    ACTIONS(12315), 1,
      anon_sym_LPAREN,
    ACTIONS(12317), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(12319), 1,
      anon_sym_u2983,
    ACTIONS(12321), 1,
      anon_sym_LBRACE,
    STATE(4716), 1,
      sym_atom,
    STATE(4662), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4728), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3914), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [564925] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(4924), 1,
      sym_id,
    ACTIONS(4928), 1,
      anon_sym_record,
    ACTIONS(4930), 1,
      anon_sym_LPAREN,
    ACTIONS(4934), 1,
      anon_sym_u2983,
    ACTIONS(4936), 1,
      anon_sym_LBRACE,
    ACTIONS(4938), 1,
      aux_sym__qid_token1,
    ACTIONS(4940), 1,
      anon_sym_DOT,
    ACTIONS(4944), 1,
      anon_sym_u2987,
    ACTIONS(4946), 1,
      aux_sym_integer_token1,
    ACTIONS(4948), 1,
      anon_sym_Set,
    ACTIONS(12045), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12047), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(12049), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(12051), 1,
      aux_sym_string_token1,
    STATE(5891), 1,
      sym_atom,
    STATE(5898), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5899), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(4926), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [565000] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(3520), 1,
      sym_id,
    ACTIONS(3528), 1,
      anon_sym_record,
    ACTIONS(3530), 1,
      anon_sym_LPAREN,
    ACTIONS(3534), 1,
      anon_sym_u2983,
    ACTIONS(3536), 1,
      anon_sym_LBRACE,
    ACTIONS(3538), 1,
      aux_sym__qid_token1,
    ACTIONS(3540), 1,
      anon_sym_DOT,
    ACTIONS(3546), 1,
      anon_sym_u2987,
    ACTIONS(3548), 1,
      aux_sym_integer_token1,
    ACTIONS(3550), 1,
      anon_sym_Set,
    ACTIONS(11589), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11591), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11593), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11595), 1,
      aux_sym_string_token1,
    STATE(5521), 1,
      sym_atom,
    STATE(5537), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5538), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3526), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [565075] = 3,
    ACTIONS(6655), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6653), 31,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [565116] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(3814), 1,
      sym_id,
    ACTIONS(3824), 1,
      anon_sym_record,
    ACTIONS(3834), 1,
      aux_sym__qid_token1,
    ACTIONS(3844), 1,
      anon_sym_u2987,
    ACTIONS(3848), 1,
      aux_sym_integer_token1,
    ACTIONS(3850), 1,
      anon_sym_Set,
    ACTIONS(4666), 1,
      anon_sym_DOT,
    ACTIONS(11465), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11469), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11471), 1,
      aux_sym_string_token1,
    ACTIONS(12323), 1,
      anon_sym_LPAREN,
    ACTIONS(12325), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(12327), 1,
      anon_sym_u2983,
    ACTIONS(12329), 1,
      anon_sym_LBRACE,
    STATE(4343), 1,
      sym_atom,
    STATE(4342), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4273), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3822), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [565191] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2652), 1,
      sym_id,
    ACTIONS(2662), 1,
      anon_sym_record,
    ACTIONS(2672), 1,
      aux_sym__qid_token1,
    ACTIONS(2682), 1,
      anon_sym_u2987,
    ACTIONS(2686), 1,
      aux_sym_integer_token1,
    ACTIONS(2688), 1,
      anon_sym_Set,
    ACTIONS(4524), 1,
      anon_sym_LPAREN,
    ACTIONS(4528), 1,
      anon_sym_u2983,
    ACTIONS(4530), 1,
      anon_sym_LBRACE,
    ACTIONS(4532), 1,
      anon_sym_DOT,
    ACTIONS(12053), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12063), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(12065), 1,
      aux_sym_string_token1,
    ACTIONS(12331), 1,
      anon_sym_LBRACE_LBRACE,
    STATE(4731), 1,
      sym_atom,
    STATE(4732), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4735), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(2660), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [565266] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(3234), 1,
      sym_id,
    ACTIONS(3240), 1,
      anon_sym_record,
    ACTIONS(3242), 1,
      anon_sym_LPAREN,
    ACTIONS(3246), 1,
      anon_sym_u2983,
    ACTIONS(3248), 1,
      anon_sym_LBRACE,
    ACTIONS(3250), 1,
      aux_sym__qid_token1,
    ACTIONS(3252), 1,
      anon_sym_DOT,
    ACTIONS(3256), 1,
      anon_sym_u2987,
    ACTIONS(3258), 1,
      aux_sym_integer_token1,
    ACTIONS(3260), 1,
      anon_sym_Set,
    ACTIONS(12333), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12335), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(12337), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(12339), 1,
      aux_sym_string_token1,
    STATE(5376), 1,
      sym_atom,
    STATE(5387), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5375), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3238), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [565341] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(8597), 1,
      sym_id,
    ACTIONS(8599), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8603), 1,
      anon_sym_record,
    ACTIONS(8605), 1,
      anon_sym_LPAREN,
    ACTIONS(8607), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(8609), 1,
      anon_sym_u2983,
    ACTIONS(8611), 1,
      anon_sym_LBRACE,
    ACTIONS(8613), 1,
      aux_sym__qid_token1,
    ACTIONS(8615), 1,
      anon_sym_DOT,
    ACTIONS(8619), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(8621), 1,
      anon_sym_u2987,
    ACTIONS(8623), 1,
      aux_sym_integer_token1,
    ACTIONS(8625), 1,
      aux_sym_string_token1,
    ACTIONS(8627), 1,
      anon_sym_Set,
    STATE(7417), 1,
      sym_atom,
    STATE(7406), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7405), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(8601), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [565416] = 3,
    ACTIONS(12343), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(12341), 31,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [565457] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2766), 1,
      sym_id,
    ACTIONS(2772), 1,
      anon_sym_record,
    ACTIONS(2774), 1,
      anon_sym_LPAREN,
    ACTIONS(2778), 1,
      anon_sym_u2983,
    ACTIONS(2780), 1,
      anon_sym_LBRACE,
    ACTIONS(2782), 1,
      aux_sym__qid_token1,
    ACTIONS(2784), 1,
      anon_sym_DOT,
    ACTIONS(2788), 1,
      anon_sym_u2987,
    ACTIONS(2790), 1,
      aux_sym_integer_token1,
    ACTIONS(2792), 1,
      anon_sym_Set,
    ACTIONS(12345), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12347), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(12349), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(12351), 1,
      aux_sym_string_token1,
    STATE(5665), 1,
      sym_atom,
    STATE(5666), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5668), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(2770), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [565532] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6716), 1,
      sym_id,
    ACTIONS(6718), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6722), 1,
      anon_sym_record,
    ACTIONS(6724), 1,
      anon_sym_LPAREN,
    ACTIONS(6726), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(6728), 1,
      anon_sym_u2983,
    ACTIONS(6730), 1,
      anon_sym_LBRACE,
    ACTIONS(6732), 1,
      aux_sym__qid_token1,
    ACTIONS(6734), 1,
      anon_sym_DOT,
    ACTIONS(6738), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(6740), 1,
      anon_sym_u2987,
    ACTIONS(6742), 1,
      aux_sym_integer_token1,
    ACTIONS(6744), 1,
      aux_sym_string_token1,
    ACTIONS(6746), 1,
      anon_sym_Set,
    STATE(6814), 1,
      sym_atom,
    STATE(6805), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6809), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(6720), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [565607] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(9636), 1,
      sym_id,
    ACTIONS(9638), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9642), 1,
      anon_sym_record,
    ACTIONS(9644), 1,
      anon_sym_LPAREN,
    ACTIONS(9646), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(9648), 1,
      anon_sym_u2983,
    ACTIONS(9650), 1,
      anon_sym_LBRACE,
    ACTIONS(9652), 1,
      aux_sym__qid_token1,
    ACTIONS(9654), 1,
      anon_sym_DOT,
    ACTIONS(9658), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(9660), 1,
      anon_sym_u2987,
    ACTIONS(9662), 1,
      aux_sym_integer_token1,
    ACTIONS(9664), 1,
      aux_sym_string_token1,
    ACTIONS(9666), 1,
      anon_sym_Set,
    STATE(7529), 1,
      sym_atom,
    STATE(7594), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7606), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(9640), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [565682] = 3,
    ACTIONS(6500), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6498), 31,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [565723] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6500), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6498), 27,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [565766] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6568), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6566), 27,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [565809] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6572), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6570), 27,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [565852] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6647), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6645), 27,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [565895] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6651), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6649), 27,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [565938] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6754), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6752), 27,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [565981] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6714), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6712), 27,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [566024] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2298), 1,
      sym_id,
    ACTIONS(2308), 1,
      anon_sym_record,
    ACTIONS(2318), 1,
      aux_sym__qid_token1,
    ACTIONS(2328), 1,
      anon_sym_u2987,
    ACTIONS(2332), 1,
      aux_sym_integer_token1,
    ACTIONS(2334), 1,
      anon_sym_Set,
    ACTIONS(4482), 1,
      anon_sym_LPAREN,
    ACTIONS(4486), 1,
      anon_sym_u2983,
    ACTIONS(4488), 1,
      anon_sym_LBRACE,
    ACTIONS(4490), 1,
      anon_sym_DOT,
    ACTIONS(12353), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12355), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(12357), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(12359), 1,
      aux_sym_string_token1,
    STATE(5265), 1,
      sym_atom,
    STATE(5354), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5347), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(2306), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [566099] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6433), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6431), 27,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [566142] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6750), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6748), 27,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [566185] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6710), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6708), 27,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [566228] = 3,
    ACTIONS(6568), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6566), 31,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [566269] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6484), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6482), 27,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [566312] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(9398), 1,
      sym_id,
    ACTIONS(9400), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9404), 1,
      anon_sym_record,
    ACTIONS(9406), 1,
      anon_sym_LPAREN,
    ACTIONS(9408), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(9410), 1,
      anon_sym_u2983,
    ACTIONS(9412), 1,
      anon_sym_LBRACE,
    ACTIONS(9414), 1,
      aux_sym__qid_token1,
    ACTIONS(9416), 1,
      anon_sym_DOT,
    ACTIONS(9420), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(9422), 1,
      anon_sym_u2987,
    ACTIONS(9424), 1,
      aux_sym_integer_token1,
    ACTIONS(9426), 1,
      aux_sym_string_token1,
    ACTIONS(9428), 1,
      anon_sym_Set,
    STATE(7516), 1,
      sym_atom,
    STATE(7502), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7501), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(9402), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [566387] = 3,
    ACTIONS(6572), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6570), 31,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [566428] = 3,
    ACTIONS(6651), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6649), 31,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [566469] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(7693), 1,
      sym_id,
    ACTIONS(7695), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7699), 1,
      anon_sym_record,
    ACTIONS(7701), 1,
      anon_sym_LPAREN,
    ACTIONS(7703), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(7705), 1,
      anon_sym_u2983,
    ACTIONS(7707), 1,
      anon_sym_LBRACE,
    ACTIONS(7709), 1,
      aux_sym__qid_token1,
    ACTIONS(7711), 1,
      anon_sym_DOT,
    ACTIONS(7713), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(7715), 1,
      anon_sym_u2987,
    ACTIONS(7717), 1,
      aux_sym_integer_token1,
    ACTIONS(7719), 1,
      aux_sym_string_token1,
    ACTIONS(7721), 1,
      anon_sym_Set,
    STATE(7458), 1,
      sym_atom,
    STATE(7459), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7461), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(7697), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [566544] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(5028), 1,
      sym_id,
    ACTIONS(5032), 1,
      anon_sym_record,
    ACTIONS(5034), 1,
      anon_sym_LPAREN,
    ACTIONS(5038), 1,
      anon_sym_u2983,
    ACTIONS(5040), 1,
      anon_sym_LBRACE,
    ACTIONS(5042), 1,
      aux_sym__qid_token1,
    ACTIONS(5044), 1,
      anon_sym_DOT,
    ACTIONS(5048), 1,
      anon_sym_u2987,
    ACTIONS(5050), 1,
      aux_sym_integer_token1,
    ACTIONS(5052), 1,
      anon_sym_Set,
    ACTIONS(11741), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11743), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11745), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11747), 1,
      aux_sym_string_token1,
    STATE(5400), 1,
      sym_atom,
    STATE(5401), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5405), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(5030), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [566619] = 3,
    ACTIONS(6754), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6752), 31,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [566660] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(3912), 1,
      sym_id,
    ACTIONS(3916), 1,
      anon_sym_record,
    ACTIONS(3926), 1,
      aux_sym__qid_token1,
    ACTIONS(3932), 1,
      anon_sym_u2987,
    ACTIONS(3934), 1,
      aux_sym_integer_token1,
    ACTIONS(3936), 1,
      anon_sym_Set,
    ACTIONS(4412), 1,
      anon_sym_LPAREN,
    ACTIONS(4416), 1,
      anon_sym_u2983,
    ACTIONS(4418), 1,
      anon_sym_LBRACE,
    ACTIONS(4420), 1,
      anon_sym_DOT,
    ACTIONS(12217), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12219), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(12221), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(12223), 1,
      aux_sym_string_token1,
    STATE(4703), 1,
      sym_atom,
    STATE(4662), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4728), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3914), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [566735] = 3,
    ACTIONS(6714), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6712), 31,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [566776] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(10679), 1,
      sym_id,
    ACTIONS(10681), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10685), 1,
      anon_sym_record,
    ACTIONS(10687), 1,
      anon_sym_LPAREN,
    ACTIONS(10689), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(10691), 1,
      anon_sym_u2983,
    ACTIONS(10693), 1,
      anon_sym_LBRACE,
    ACTIONS(10695), 1,
      aux_sym__qid_token1,
    ACTIONS(10697), 1,
      anon_sym_DOT,
    ACTIONS(10701), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(10703), 1,
      anon_sym_u2987,
    ACTIONS(10705), 1,
      aux_sym_integer_token1,
    ACTIONS(10707), 1,
      aux_sym_string_token1,
    ACTIONS(10709), 1,
      anon_sym_Set,
    STATE(7693), 1,
      sym_atom,
    STATE(7700), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7701), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(10683), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [566851] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(5846), 1,
      sym_id,
    ACTIONS(5850), 1,
      anon_sym_record,
    ACTIONS(5852), 1,
      anon_sym_LPAREN,
    ACTIONS(5856), 1,
      anon_sym_u2983,
    ACTIONS(5858), 1,
      anon_sym_LBRACE,
    ACTIONS(5860), 1,
      aux_sym__qid_token1,
    ACTIONS(5862), 1,
      anon_sym_DOT,
    ACTIONS(5866), 1,
      anon_sym_u2987,
    ACTIONS(5868), 1,
      aux_sym_integer_token1,
    ACTIONS(5870), 1,
      anon_sym_Set,
    ACTIONS(12361), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12363), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(12365), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(12367), 1,
      aux_sym_string_token1,
    STATE(6108), 1,
      sym_atom,
    STATE(6096), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6100), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(5848), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [566926] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1980), 1,
      sym_id,
    ACTIONS(1990), 1,
      anon_sym_record,
    ACTIONS(2000), 1,
      aux_sym__qid_token1,
    ACTIONS(2010), 1,
      anon_sym_u2987,
    ACTIONS(2014), 1,
      aux_sym_integer_token1,
    ACTIONS(2016), 1,
      anon_sym_Set,
    ACTIONS(4386), 1,
      anon_sym_LPAREN,
    ACTIONS(4390), 1,
      anon_sym_u2983,
    ACTIONS(4392), 1,
      anon_sym_LBRACE,
    ACTIONS(4394), 1,
      anon_sym_DOT,
    ACTIONS(12369), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12371), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(12373), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(12375), 1,
      aux_sym_string_token1,
    STATE(5341), 1,
      sym_atom,
    STATE(5336), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5185), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(1988), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [567001] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(10379), 1,
      sym_id,
    ACTIONS(10381), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10385), 1,
      anon_sym_record,
    ACTIONS(10387), 1,
      anon_sym_LPAREN,
    ACTIONS(10389), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(10391), 1,
      anon_sym_u2983,
    ACTIONS(10393), 1,
      anon_sym_LBRACE,
    ACTIONS(10395), 1,
      aux_sym__qid_token1,
    ACTIONS(10397), 1,
      anon_sym_DOT,
    ACTIONS(10401), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(10403), 1,
      anon_sym_u2987,
    ACTIONS(10405), 1,
      aux_sym_integer_token1,
    ACTIONS(10407), 1,
      aux_sym_string_token1,
    ACTIONS(10409), 1,
      anon_sym_Set,
    STATE(7696), 1,
      sym_atom,
    STATE(7690), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7735), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(10383), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [567076] = 3,
    ACTIONS(6750), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6748), 31,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [567117] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(3208), 1,
      sym_id,
    ACTIONS(3212), 1,
      anon_sym_record,
    ACTIONS(3214), 1,
      anon_sym_LPAREN,
    ACTIONS(3218), 1,
      anon_sym_u2983,
    ACTIONS(3220), 1,
      anon_sym_LBRACE,
    ACTIONS(3222), 1,
      aux_sym__qid_token1,
    ACTIONS(3224), 1,
      anon_sym_DOT,
    ACTIONS(3228), 1,
      anon_sym_u2987,
    ACTIONS(3230), 1,
      aux_sym_integer_token1,
    ACTIONS(3232), 1,
      anon_sym_Set,
    ACTIONS(11643), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11645), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11647), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11649), 1,
      aux_sym_string_token1,
    STATE(5572), 1,
      sym_atom,
    STATE(5579), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5582), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3210), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [567192] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(5390), 1,
      sym_id,
    ACTIONS(5394), 1,
      anon_sym_record,
    ACTIONS(5396), 1,
      anon_sym_LPAREN,
    ACTIONS(5400), 1,
      anon_sym_u2983,
    ACTIONS(5402), 1,
      anon_sym_LBRACE,
    ACTIONS(5404), 1,
      aux_sym__qid_token1,
    ACTIONS(5406), 1,
      anon_sym_DOT,
    ACTIONS(5410), 1,
      anon_sym_u2987,
    ACTIONS(5412), 1,
      aux_sym_integer_token1,
    ACTIONS(5414), 1,
      anon_sym_Set,
    ACTIONS(12377), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12379), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(12381), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(12383), 1,
      aux_sym_string_token1,
    STATE(6063), 1,
      sym_atom,
    STATE(6026), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6060), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(5392), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [567267] = 3,
    ACTIONS(6484), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6482), 31,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [567308] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(3326), 1,
      sym_id,
    ACTIONS(3332), 1,
      anon_sym_record,
    ACTIONS(3334), 1,
      anon_sym_LPAREN,
    ACTIONS(3338), 1,
      anon_sym_u2983,
    ACTIONS(3340), 1,
      anon_sym_LBRACE,
    ACTIONS(3342), 1,
      aux_sym__qid_token1,
    ACTIONS(3344), 1,
      anon_sym_DOT,
    ACTIONS(3348), 1,
      anon_sym_u2987,
    ACTIONS(3350), 1,
      aux_sym_integer_token1,
    ACTIONS(3352), 1,
      anon_sym_Set,
    ACTIONS(12037), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12039), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(12041), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(12043), 1,
      aux_sym_string_token1,
    STATE(4657), 1,
      sym_atom,
    STATE(4650), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4649), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3330), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [567383] = 3,
    ACTIONS(6647), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6645), 31,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [567424] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(3852), 1,
      sym_id,
    ACTIONS(3856), 1,
      anon_sym_record,
    ACTIONS(3866), 1,
      aux_sym__qid_token1,
    ACTIONS(3872), 1,
      anon_sym_u2987,
    ACTIONS(3874), 1,
      aux_sym_integer_token1,
    ACTIONS(3876), 1,
      anon_sym_Set,
    ACTIONS(4724), 1,
      anon_sym_LPAREN,
    ACTIONS(4728), 1,
      anon_sym_u2983,
    ACTIONS(4730), 1,
      anon_sym_LBRACE,
    ACTIONS(4732), 1,
      anon_sym_DOT,
    ACTIONS(12271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12273), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(12275), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(12277), 1,
      aux_sym_string_token1,
    STATE(4641), 1,
      sym_atom,
    STATE(4642), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4643), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3854), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [567499] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2134), 1,
      sym_id,
    ACTIONS(2146), 1,
      anon_sym_record,
    ACTIONS(2148), 1,
      anon_sym_LPAREN,
    ACTIONS(2152), 1,
      anon_sym_u2983,
    ACTIONS(2154), 1,
      anon_sym_LBRACE,
    ACTIONS(2156), 1,
      aux_sym__qid_token1,
    ACTIONS(2158), 1,
      anon_sym_DOT,
    ACTIONS(2166), 1,
      anon_sym_u2987,
    ACTIONS(2170), 1,
      aux_sym_integer_token1,
    ACTIONS(2172), 1,
      anon_sym_Set,
    ACTIONS(12385), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12387), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(12389), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(12391), 1,
      aux_sym_string_token1,
    STATE(5623), 1,
      sym_atom,
    STATE(5624), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5627), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(2144), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [567574] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(5548), 1,
      sym_id,
    ACTIONS(5552), 1,
      anon_sym_record,
    ACTIONS(5554), 1,
      anon_sym_LPAREN,
    ACTIONS(5558), 1,
      anon_sym_u2983,
    ACTIONS(5560), 1,
      anon_sym_LBRACE,
    ACTIONS(5562), 1,
      aux_sym__qid_token1,
    ACTIONS(5564), 1,
      anon_sym_DOT,
    ACTIONS(5568), 1,
      anon_sym_u2987,
    ACTIONS(5570), 1,
      aux_sym_integer_token1,
    ACTIONS(5572), 1,
      anon_sym_Set,
    ACTIONS(12393), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12395), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(12397), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(12399), 1,
      aux_sym_string_token1,
    STATE(6033), 1,
      sym_atom,
    STATE(6032), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6059), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(5550), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [567649] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2206), 1,
      sym_id,
    ACTIONS(2218), 1,
      anon_sym_record,
    ACTIONS(2220), 1,
      anon_sym_LPAREN,
    ACTIONS(2224), 1,
      anon_sym_u2983,
    ACTIONS(2226), 1,
      anon_sym_LBRACE,
    ACTIONS(2228), 1,
      aux_sym__qid_token1,
    ACTIONS(2230), 1,
      anon_sym_DOT,
    ACTIONS(2238), 1,
      anon_sym_u2987,
    ACTIONS(2242), 1,
      aux_sym_integer_token1,
    ACTIONS(2244), 1,
      anon_sym_Set,
    ACTIONS(11771), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11773), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11775), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11777), 1,
      aux_sym_string_token1,
    STATE(4838), 1,
      sym_atom,
    STATE(4812), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4858), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(2216), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [567724] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(10985), 1,
      sym_id,
    ACTIONS(10987), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10991), 1,
      anon_sym_record,
    ACTIONS(10993), 1,
      anon_sym_LPAREN,
    ACTIONS(10995), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(10997), 1,
      anon_sym_u2983,
    ACTIONS(10999), 1,
      anon_sym_LBRACE,
    ACTIONS(11001), 1,
      aux_sym__qid_token1,
    ACTIONS(11003), 1,
      anon_sym_DOT,
    ACTIONS(11007), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11009), 1,
      anon_sym_u2987,
    ACTIONS(11011), 1,
      aux_sym_integer_token1,
    ACTIONS(11013), 1,
      aux_sym_string_token1,
    ACTIONS(11015), 1,
      anon_sym_Set,
    STATE(7811), 1,
      sym_atom,
    STATE(7784), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7798), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(10989), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [567799] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6912), 1,
      sym_id,
    ACTIONS(6914), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6918), 1,
      anon_sym_record,
    ACTIONS(6924), 1,
      anon_sym_LPAREN,
    ACTIONS(6930), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(6932), 1,
      anon_sym_u2983,
    ACTIONS(6934), 1,
      anon_sym_LBRACE,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(6940), 1,
      anon_sym_DOT,
    ACTIONS(6942), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(6944), 1,
      anon_sym_u2987,
    ACTIONS(6946), 1,
      aux_sym_integer_token1,
    ACTIONS(6948), 1,
      aux_sym_string_token1,
    ACTIONS(6950), 1,
      anon_sym_Set,
    STATE(7269), 1,
      sym_atom,
    STATE(7268), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7266), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(6916), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [567874] = 3,
    ACTIONS(6433), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6431), 31,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [567915] = 3,
    ACTIONS(6710), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6708), 31,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [567956] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(9321), 1,
      sym_id,
    ACTIONS(9323), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9327), 1,
      anon_sym_record,
    ACTIONS(9329), 1,
      anon_sym_LPAREN,
    ACTIONS(9331), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(9333), 1,
      anon_sym_u2983,
    ACTIONS(9335), 1,
      anon_sym_LBRACE,
    ACTIONS(9337), 1,
      aux_sym__qid_token1,
    ACTIONS(9339), 1,
      anon_sym_DOT,
    ACTIONS(9343), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(9345), 1,
      anon_sym_u2987,
    ACTIONS(9347), 1,
      aux_sym_integer_token1,
    ACTIONS(9349), 1,
      aux_sym_string_token1,
    ACTIONS(9351), 1,
      anon_sym_Set,
    STATE(7432), 1,
      sym_atom,
    STATE(7442), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7445), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(9325), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [568031] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(5846), 1,
      sym_id,
    ACTIONS(5850), 1,
      anon_sym_record,
    ACTIONS(5852), 1,
      anon_sym_LPAREN,
    ACTIONS(5856), 1,
      anon_sym_u2983,
    ACTIONS(5858), 1,
      anon_sym_LBRACE,
    ACTIONS(5860), 1,
      aux_sym__qid_token1,
    ACTIONS(5862), 1,
      anon_sym_DOT,
    ACTIONS(5866), 1,
      anon_sym_u2987,
    ACTIONS(5868), 1,
      aux_sym_integer_token1,
    ACTIONS(5870), 1,
      anon_sym_Set,
    ACTIONS(12361), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12363), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(12365), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(12367), 1,
      aux_sym_string_token1,
    STATE(6103), 1,
      sym_atom,
    STATE(6096), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6100), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(5848), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [568106] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2526), 1,
      sym_id,
    ACTIONS(2538), 1,
      anon_sym_record,
    ACTIONS(2540), 1,
      anon_sym_LPAREN,
    ACTIONS(2544), 1,
      anon_sym_u2983,
    ACTIONS(2546), 1,
      anon_sym_LBRACE,
    ACTIONS(2548), 1,
      aux_sym__qid_token1,
    ACTIONS(2550), 1,
      anon_sym_DOT,
    ACTIONS(2558), 1,
      anon_sym_u2987,
    ACTIONS(2562), 1,
      aux_sym_integer_token1,
    ACTIONS(2564), 1,
      anon_sym_Set,
    ACTIONS(11867), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11869), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11871), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11873), 1,
      aux_sym_string_token1,
    STATE(4500), 1,
      sym_atom,
    STATE(4464), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4473), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(2536), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [568181] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(5734), 1,
      sym_id,
    ACTIONS(5738), 1,
      anon_sym_record,
    ACTIONS(5740), 1,
      anon_sym_LPAREN,
    ACTIONS(5744), 1,
      anon_sym_u2983,
    ACTIONS(5746), 1,
      anon_sym_LBRACE,
    ACTIONS(5748), 1,
      aux_sym__qid_token1,
    ACTIONS(5750), 1,
      anon_sym_DOT,
    ACTIONS(5754), 1,
      anon_sym_u2987,
    ACTIONS(5756), 1,
      aux_sym_integer_token1,
    ACTIONS(5758), 1,
      anon_sym_Set,
    ACTIONS(12401), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12403), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(12405), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(12407), 1,
      aux_sym_string_token1,
    STATE(5773), 1,
      sym_atom,
    STATE(5762), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5752), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(5736), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [568256] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(10843), 1,
      sym_id,
    ACTIONS(10845), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10849), 1,
      anon_sym_record,
    ACTIONS(10851), 1,
      anon_sym_LPAREN,
    ACTIONS(10853), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(10855), 1,
      anon_sym_u2983,
    ACTIONS(10857), 1,
      anon_sym_LBRACE,
    ACTIONS(10859), 1,
      aux_sym__qid_token1,
    ACTIONS(10861), 1,
      anon_sym_DOT,
    ACTIONS(10865), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(10867), 1,
      anon_sym_u2987,
    ACTIONS(10869), 1,
      aux_sym_integer_token1,
    ACTIONS(10871), 1,
      aux_sym_string_token1,
    ACTIONS(10873), 1,
      anon_sym_Set,
    STATE(7748), 1,
      sym_atom,
    STATE(7705), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7719), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(10847), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [568331] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(8369), 1,
      sym_id,
    ACTIONS(8371), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8375), 1,
      anon_sym_record,
    ACTIONS(8377), 1,
      anon_sym_LPAREN,
    ACTIONS(8379), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(8381), 1,
      anon_sym_u2983,
    ACTIONS(8383), 1,
      anon_sym_LBRACE,
    ACTIONS(8385), 1,
      aux_sym__qid_token1,
    ACTIONS(8387), 1,
      anon_sym_DOT,
    ACTIONS(8391), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(8393), 1,
      anon_sym_u2987,
    ACTIONS(8395), 1,
      aux_sym_integer_token1,
    ACTIONS(8397), 1,
      aux_sym_string_token1,
    ACTIONS(8399), 1,
      anon_sym_Set,
    STATE(7427), 1,
      sym_atom,
    STATE(7389), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7302), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(8373), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [568406] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(10038), 1,
      sym_id,
    ACTIONS(10040), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10044), 1,
      anon_sym_record,
    ACTIONS(10046), 1,
      anon_sym_LPAREN,
    ACTIONS(10048), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(10050), 1,
      anon_sym_u2983,
    ACTIONS(10052), 1,
      anon_sym_LBRACE,
    ACTIONS(10054), 1,
      aux_sym__qid_token1,
    ACTIONS(10056), 1,
      anon_sym_DOT,
    ACTIONS(10060), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(10062), 1,
      anon_sym_u2987,
    ACTIONS(10064), 1,
      aux_sym_integer_token1,
    ACTIONS(10066), 1,
      aux_sym_string_token1,
    ACTIONS(10068), 1,
      anon_sym_Set,
    STATE(7506), 1,
      sym_atom,
    STATE(7504), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7499), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(10042), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [568481] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11133), 1,
      sym_id,
    ACTIONS(11135), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11139), 1,
      anon_sym_record,
    ACTIONS(11141), 1,
      anon_sym_LPAREN,
    ACTIONS(11143), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11145), 1,
      anon_sym_u2983,
    ACTIONS(11147), 1,
      anon_sym_LBRACE,
    ACTIONS(11149), 1,
      aux_sym__qid_token1,
    ACTIONS(11151), 1,
      anon_sym_DOT,
    ACTIONS(11153), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11155), 1,
      anon_sym_u2987,
    ACTIONS(11157), 1,
      aux_sym_integer_token1,
    ACTIONS(11159), 1,
      aux_sym_string_token1,
    ACTIONS(11161), 1,
      anon_sym_Set,
    STATE(8838), 1,
      sym_atom,
    STATE(8809), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(8832), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11137), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [568556] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(4950), 1,
      sym_id,
    ACTIONS(4954), 1,
      anon_sym_record,
    ACTIONS(4956), 1,
      anon_sym_LPAREN,
    ACTIONS(4960), 1,
      anon_sym_u2983,
    ACTIONS(4962), 1,
      anon_sym_LBRACE,
    ACTIONS(4964), 1,
      aux_sym__qid_token1,
    ACTIONS(4966), 1,
      anon_sym_DOT,
    ACTIONS(4970), 1,
      anon_sym_u2987,
    ACTIONS(4972), 1,
      aux_sym_integer_token1,
    ACTIONS(4974), 1,
      anon_sym_Set,
    ACTIONS(12409), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12411), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(12413), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(12415), 1,
      aux_sym_string_token1,
    STATE(4221), 1,
      sym_atom,
    STATE(4253), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4254), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(4952), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [568631] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(7027), 1,
      sym_id,
    ACTIONS(7029), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7033), 1,
      anon_sym_record,
    ACTIONS(7035), 1,
      anon_sym_LPAREN,
    ACTIONS(7037), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(7039), 1,
      anon_sym_u2983,
    ACTIONS(7041), 1,
      anon_sym_LBRACE,
    ACTIONS(7043), 1,
      aux_sym__qid_token1,
    ACTIONS(7045), 1,
      anon_sym_DOT,
    ACTIONS(7049), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(7051), 1,
      anon_sym_u2987,
    ACTIONS(7053), 1,
      aux_sym_integer_token1,
    ACTIONS(7055), 1,
      aux_sym_string_token1,
    ACTIONS(7057), 1,
      anon_sym_Set,
    STATE(6942), 1,
      sym_atom,
    STATE(6939), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6933), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(7031), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [568706] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(3938), 1,
      sym_id,
    ACTIONS(3942), 1,
      anon_sym_record,
    ACTIONS(3952), 1,
      aux_sym__qid_token1,
    ACTIONS(3958), 1,
      anon_sym_u2987,
    ACTIONS(3960), 1,
      aux_sym_integer_token1,
    ACTIONS(3962), 1,
      anon_sym_Set,
    ACTIONS(4628), 1,
      anon_sym_DOT,
    ACTIONS(12083), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12087), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(12089), 1,
      aux_sym_string_token1,
    ACTIONS(12417), 1,
      anon_sym_LPAREN,
    ACTIONS(12419), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(12421), 1,
      anon_sym_u2983,
    ACTIONS(12423), 1,
      anon_sym_LBRACE,
    STATE(5206), 1,
      sym_atom,
    STATE(5203), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5201), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3940), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [568781] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(10519), 1,
      sym_id,
    ACTIONS(10521), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10525), 1,
      anon_sym_record,
    ACTIONS(10527), 1,
      anon_sym_LPAREN,
    ACTIONS(10529), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(10531), 1,
      anon_sym_u2983,
    ACTIONS(10533), 1,
      anon_sym_LBRACE,
    ACTIONS(10535), 1,
      aux_sym__qid_token1,
    ACTIONS(10537), 1,
      anon_sym_DOT,
    ACTIONS(10541), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(10543), 1,
      anon_sym_u2987,
    ACTIONS(10545), 1,
      aux_sym_integer_token1,
    ACTIONS(10547), 1,
      aux_sym_string_token1,
    ACTIONS(10549), 1,
      anon_sym_Set,
    STATE(7703), 1,
      sym_atom,
    STATE(7698), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7681), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(10523), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [568856] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(706), 1,
      aux_sym__qid_token1,
    ACTIONS(3554), 1,
      sym_id,
    ACTIONS(3562), 1,
      anon_sym_record,
    ACTIONS(3564), 1,
      anon_sym_LPAREN,
    ACTIONS(3568), 1,
      anon_sym_u2983,
    ACTIONS(3570), 1,
      anon_sym_LBRACE,
    ACTIONS(3572), 1,
      anon_sym_DOT,
    ACTIONS(3578), 1,
      anon_sym_u2987,
    ACTIONS(3580), 1,
      aux_sym_integer_token1,
    ACTIONS(3582), 1,
      anon_sym_Set,
    ACTIONS(11921), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11923), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11925), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11927), 1,
      aux_sym_string_token1,
    STATE(5088), 1,
      sym_atom,
    STATE(5081), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5079), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3560), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [568931] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(3090), 1,
      sym_id,
    ACTIONS(3102), 1,
      anon_sym_record,
    ACTIONS(3104), 1,
      anon_sym_LPAREN,
    ACTIONS(3108), 1,
      anon_sym_u2983,
    ACTIONS(3110), 1,
      anon_sym_LBRACE,
    ACTIONS(3112), 1,
      aux_sym__qid_token1,
    ACTIONS(3114), 1,
      anon_sym_DOT,
    ACTIONS(3122), 1,
      anon_sym_u2987,
    ACTIONS(3126), 1,
      aux_sym_integer_token1,
    ACTIONS(3128), 1,
      anon_sym_Set,
    ACTIONS(11937), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11939), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11941), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11943), 1,
      aux_sym_string_token1,
    STATE(4295), 1,
      sym_atom,
    STATE(4293), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4285), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3100), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [569006] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2728), 1,
      sym_id,
    ACTIONS(2738), 1,
      anon_sym_record,
    ACTIONS(2748), 1,
      aux_sym__qid_token1,
    ACTIONS(2758), 1,
      anon_sym_u2987,
    ACTIONS(2762), 1,
      aux_sym_integer_token1,
    ACTIONS(2764), 1,
      anon_sym_Set,
    ACTIONS(4762), 1,
      anon_sym_LPAREN,
    ACTIONS(4766), 1,
      anon_sym_u2983,
    ACTIONS(4768), 1,
      anon_sym_LBRACE,
    ACTIONS(4770), 1,
      anon_sym_DOT,
    ACTIONS(12425), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12427), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(12429), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(12431), 1,
      aux_sym_string_token1,
    STATE(4693), 1,
      sym_atom,
    STATE(4685), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4682), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(2736), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [569081] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11133), 1,
      sym_id,
    ACTIONS(11135), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11139), 1,
      anon_sym_record,
    ACTIONS(11141), 1,
      anon_sym_LPAREN,
    ACTIONS(11143), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11145), 1,
      anon_sym_u2983,
    ACTIONS(11147), 1,
      anon_sym_LBRACE,
    ACTIONS(11149), 1,
      aux_sym__qid_token1,
    ACTIONS(11151), 1,
      anon_sym_DOT,
    ACTIONS(11153), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11155), 1,
      anon_sym_u2987,
    ACTIONS(11157), 1,
      aux_sym_integer_token1,
    ACTIONS(11159), 1,
      aux_sym_string_token1,
    ACTIONS(11161), 1,
      anon_sym_Set,
    STATE(8856), 1,
      sym_atom,
    STATE(8809), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(8832), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11137), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [569156] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(5390), 1,
      sym_id,
    ACTIONS(5394), 1,
      anon_sym_record,
    ACTIONS(5396), 1,
      anon_sym_LPAREN,
    ACTIONS(5400), 1,
      anon_sym_u2983,
    ACTIONS(5402), 1,
      anon_sym_LBRACE,
    ACTIONS(5404), 1,
      aux_sym__qid_token1,
    ACTIONS(5406), 1,
      anon_sym_DOT,
    ACTIONS(5410), 1,
      anon_sym_u2987,
    ACTIONS(5412), 1,
      aux_sym_integer_token1,
    ACTIONS(5414), 1,
      anon_sym_Set,
    ACTIONS(12377), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12379), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(12381), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(12383), 1,
      aux_sym_string_token1,
    STATE(6088), 1,
      sym_atom,
    STATE(6026), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6060), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(5392), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [569231] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2872), 1,
      sym_id,
    ACTIONS(2876), 1,
      anon_sym_record,
    ACTIONS(2878), 1,
      anon_sym_LPAREN,
    ACTIONS(2882), 1,
      anon_sym_u2983,
    ACTIONS(2884), 1,
      anon_sym_LBRACE,
    ACTIONS(2886), 1,
      aux_sym__qid_token1,
    ACTIONS(2888), 1,
      anon_sym_DOT,
    ACTIONS(2892), 1,
      anon_sym_u2987,
    ACTIONS(2894), 1,
      aux_sym_integer_token1,
    ACTIONS(2896), 1,
      anon_sym_Set,
    ACTIONS(11999), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12001), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(12003), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(12005), 1,
      aux_sym_string_token1,
    STATE(5298), 1,
      sym_atom,
    STATE(5291), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5287), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(2874), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [569306] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(3234), 1,
      sym_id,
    ACTIONS(3240), 1,
      anon_sym_record,
    ACTIONS(3242), 1,
      anon_sym_LPAREN,
    ACTIONS(3246), 1,
      anon_sym_u2983,
    ACTIONS(3248), 1,
      anon_sym_LBRACE,
    ACTIONS(3250), 1,
      aux_sym__qid_token1,
    ACTIONS(3252), 1,
      anon_sym_DOT,
    ACTIONS(3256), 1,
      anon_sym_u2987,
    ACTIONS(3258), 1,
      aux_sym_integer_token1,
    ACTIONS(3260), 1,
      anon_sym_Set,
    ACTIONS(12333), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12335), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(12337), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(12339), 1,
      aux_sym_string_token1,
    STATE(5360), 1,
      sym_atom,
    STATE(5387), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5375), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3238), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [569381] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(5278), 1,
      sym_id,
    ACTIONS(5282), 1,
      anon_sym_record,
    ACTIONS(5284), 1,
      anon_sym_LPAREN,
    ACTIONS(5288), 1,
      anon_sym_u2983,
    ACTIONS(5290), 1,
      anon_sym_LBRACE,
    ACTIONS(5292), 1,
      aux_sym__qid_token1,
    ACTIONS(5294), 1,
      anon_sym_DOT,
    ACTIONS(5298), 1,
      anon_sym_u2987,
    ACTIONS(5300), 1,
      aux_sym_integer_token1,
    ACTIONS(5302), 1,
      anon_sym_Set,
    ACTIONS(12433), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12435), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(12437), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(12439), 1,
      aux_sym_string_token1,
    STATE(5784), 1,
      sym_atom,
    STATE(5779), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5778), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(5280), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [569456] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(7396), 1,
      sym_id,
    ACTIONS(7398), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7402), 1,
      anon_sym_record,
    ACTIONS(7404), 1,
      anon_sym_LPAREN,
    ACTIONS(7406), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(7408), 1,
      anon_sym_u2983,
    ACTIONS(7410), 1,
      anon_sym_LBRACE,
    ACTIONS(7412), 1,
      aux_sym__qid_token1,
    ACTIONS(7414), 1,
      anon_sym_DOT,
    ACTIONS(7418), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(7420), 1,
      anon_sym_u2987,
    ACTIONS(7422), 1,
      aux_sym_integer_token1,
    ACTIONS(7424), 1,
      aux_sym_string_token1,
    ACTIONS(7426), 1,
      anon_sym_Set,
    STATE(7175), 1,
      sym_atom,
    STATE(7163), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7161), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(7400), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [569531] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2728), 1,
      sym_id,
    ACTIONS(2738), 1,
      anon_sym_record,
    ACTIONS(2748), 1,
      aux_sym__qid_token1,
    ACTIONS(2758), 1,
      anon_sym_u2987,
    ACTIONS(2762), 1,
      aux_sym_integer_token1,
    ACTIONS(2764), 1,
      anon_sym_Set,
    ACTIONS(4770), 1,
      anon_sym_DOT,
    ACTIONS(12425), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12429), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(12431), 1,
      aux_sym_string_token1,
    ACTIONS(12441), 1,
      anon_sym_LPAREN,
    ACTIONS(12443), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(12445), 1,
      anon_sym_u2983,
    ACTIONS(12447), 1,
      anon_sym_LBRACE,
    STATE(4686), 1,
      sym_atom,
    STATE(4685), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4682), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(2736), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [569606] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1866), 1,
      sym_id,
    ACTIONS(1876), 1,
      anon_sym_record,
    ACTIONS(1886), 1,
      aux_sym__qid_token1,
    ACTIONS(1896), 1,
      anon_sym_u2987,
    ACTIONS(1900), 1,
      aux_sym_integer_token1,
    ACTIONS(1902), 1,
      anon_sym_Set,
    ACTIONS(4884), 1,
      anon_sym_LPAREN,
    ACTIONS(4888), 1,
      anon_sym_u2983,
    ACTIONS(4890), 1,
      anon_sym_LBRACE,
    ACTIONS(4892), 1,
      anon_sym_DOT,
    ACTIONS(12257), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12267), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(12269), 1,
      aux_sym_string_token1,
    ACTIONS(12449), 1,
      anon_sym_LBRACE_LBRACE,
    STATE(4272), 1,
      sym_atom,
    STATE(4264), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4263), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(1874), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [569681] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(5656), 1,
      sym_id,
    ACTIONS(5660), 1,
      anon_sym_record,
    ACTIONS(5662), 1,
      anon_sym_LPAREN,
    ACTIONS(5666), 1,
      anon_sym_u2983,
    ACTIONS(5668), 1,
      anon_sym_LBRACE,
    ACTIONS(5670), 1,
      aux_sym__qid_token1,
    ACTIONS(5672), 1,
      anon_sym_DOT,
    ACTIONS(5676), 1,
      anon_sym_u2987,
    ACTIONS(5678), 1,
      aux_sym_integer_token1,
    ACTIONS(5680), 1,
      anon_sym_Set,
    ACTIONS(12249), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12251), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(12253), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(12255), 1,
      aux_sym_string_token1,
    STATE(6122), 1,
      sym_atom,
    STATE(6130), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6053), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(5658), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [569756] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2488), 1,
      sym_id,
    ACTIONS(2498), 1,
      anon_sym_record,
    ACTIONS(2508), 1,
      aux_sym__qid_token1,
    ACTIONS(2518), 1,
      anon_sym_u2987,
    ACTIONS(2522), 1,
      aux_sym_integer_token1,
    ACTIONS(2524), 1,
      anon_sym_Set,
    ACTIONS(4506), 1,
      anon_sym_LPAREN,
    ACTIONS(4510), 1,
      anon_sym_u2983,
    ACTIONS(4512), 1,
      anon_sym_LBRACE,
    ACTIONS(4514), 1,
      anon_sym_DOT,
    ACTIONS(11635), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11637), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11639), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11641), 1,
      aux_sym_string_token1,
    STATE(5696), 1,
      sym_atom,
    STATE(5713), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5698), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(2496), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [569831] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(5416), 1,
      sym_id,
    ACTIONS(5420), 1,
      anon_sym_record,
    ACTIONS(5422), 1,
      anon_sym_LPAREN,
    ACTIONS(5426), 1,
      anon_sym_u2983,
    ACTIONS(5428), 1,
      anon_sym_LBRACE,
    ACTIONS(5430), 1,
      aux_sym__qid_token1,
    ACTIONS(5432), 1,
      anon_sym_DOT,
    ACTIONS(5436), 1,
      anon_sym_u2987,
    ACTIONS(5438), 1,
      aux_sym_integer_token1,
    ACTIONS(5440), 1,
      anon_sym_Set,
    ACTIONS(11969), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11971), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11973), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11975), 1,
      aux_sym_string_token1,
    STATE(5371), 1,
      sym_atom,
    STATE(5369), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5364), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(5418), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [569906] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6198), 1,
      sym_id,
    ACTIONS(6202), 1,
      anon_sym_record,
    ACTIONS(6204), 1,
      anon_sym_LPAREN,
    ACTIONS(6208), 1,
      anon_sym_u2983,
    ACTIONS(6210), 1,
      anon_sym_LBRACE,
    ACTIONS(6212), 1,
      aux_sym__qid_token1,
    ACTIONS(6214), 1,
      anon_sym_DOT,
    ACTIONS(6218), 1,
      anon_sym_u2987,
    ACTIONS(6220), 1,
      aux_sym_integer_token1,
    ACTIONS(6222), 1,
      anon_sym_Set,
    ACTIONS(12451), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12453), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(12455), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(12457), 1,
      aux_sym_string_token1,
    STATE(5700), 1,
      sym_atom,
    STATE(5699), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5697), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(6200), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [569981] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1916), 1,
      anon_sym_record,
    ACTIONS(1918), 1,
      anon_sym_LPAREN,
    ACTIONS(1922), 1,
      anon_sym_u2983,
    ACTIONS(1924), 1,
      anon_sym_LBRACE,
    ACTIONS(1934), 1,
      anon_sym_u2987,
    ACTIONS(1938), 1,
      aux_sym_integer_token1,
    ACTIONS(2606), 1,
      sym_id,
    ACTIONS(2608), 1,
      aux_sym__qid_token1,
    ACTIONS(2610), 1,
      anon_sym_DOT,
    ACTIONS(2612), 1,
      anon_sym_Set,
    ACTIONS(12171), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12173), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(12175), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(12177), 1,
      aux_sym_string_token1,
    STATE(4670), 1,
      sym_atom,
    STATE(4675), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4679), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(1914), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [570056] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6872), 1,
      sym_id,
    ACTIONS(6874), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6878), 1,
      anon_sym_record,
    ACTIONS(6884), 1,
      anon_sym_LPAREN,
    ACTIONS(6888), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(6890), 1,
      anon_sym_u2983,
    ACTIONS(6892), 1,
      anon_sym_LBRACE,
    ACTIONS(6894), 1,
      aux_sym__qid_token1,
    ACTIONS(6896), 1,
      anon_sym_DOT,
    ACTIONS(6900), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(6902), 1,
      anon_sym_u2987,
    ACTIONS(6904), 1,
      aux_sym_integer_token1,
    ACTIONS(6906), 1,
      aux_sym_string_token1,
    ACTIONS(6908), 1,
      anon_sym_Set,
    STATE(7254), 1,
      sym_atom,
    STATE(7255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7256), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(6876), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [570131] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(940), 1,
      sym_id,
    ACTIONS(950), 1,
      anon_sym_record,
    ACTIONS(960), 1,
      aux_sym__qid_token1,
    ACTIONS(970), 1,
      anon_sym_u2987,
    ACTIONS(974), 1,
      aux_sym_integer_token1,
    ACTIONS(976), 1,
      anon_sym_Set,
    ACTIONS(4580), 1,
      anon_sym_LPAREN,
    ACTIONS(4584), 1,
      anon_sym_u2983,
    ACTIONS(4586), 1,
      anon_sym_LBRACE,
    ACTIONS(4588), 1,
      anon_sym_DOT,
    ACTIONS(11757), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11767), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11769), 1,
      aux_sym_string_token1,
    ACTIONS(12459), 1,
      anon_sym_LBRACE_LBRACE,
    STATE(4750), 1,
      sym_atom,
    STATE(4733), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4742), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(948), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [570206] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(7432), 1,
      sym_id,
    ACTIONS(7434), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7438), 1,
      anon_sym_record,
    ACTIONS(7440), 1,
      anon_sym_LPAREN,
    ACTIONS(7442), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(7444), 1,
      anon_sym_u2983,
    ACTIONS(7446), 1,
      anon_sym_LBRACE,
    ACTIONS(7448), 1,
      aux_sym__qid_token1,
    ACTIONS(7450), 1,
      anon_sym_DOT,
    ACTIONS(7454), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(7456), 1,
      anon_sym_u2987,
    ACTIONS(7458), 1,
      aux_sym_integer_token1,
    ACTIONS(7460), 1,
      aux_sym_string_token1,
    ACTIONS(7462), 1,
      anon_sym_Set,
    STATE(7177), 1,
      sym_atom,
    STATE(7168), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7173), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(7436), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [570281] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(8516), 1,
      sym_id,
    ACTIONS(8518), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8522), 1,
      anon_sym_record,
    ACTIONS(8524), 1,
      anon_sym_LPAREN,
    ACTIONS(8526), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(8528), 1,
      anon_sym_u2983,
    ACTIONS(8530), 1,
      anon_sym_LBRACE,
    ACTIONS(8532), 1,
      aux_sym__qid_token1,
    ACTIONS(8534), 1,
      anon_sym_DOT,
    ACTIONS(8538), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(8540), 1,
      anon_sym_u2987,
    ACTIONS(8542), 1,
      aux_sym_integer_token1,
    ACTIONS(8544), 1,
      aux_sym_string_token1,
    ACTIONS(8546), 1,
      anon_sym_Set,
    STATE(7200), 1,
      sym_atom,
    STATE(7201), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7202), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(8520), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [570356] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(10719), 1,
      sym_id,
    ACTIONS(10721), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10725), 1,
      anon_sym_record,
    ACTIONS(10727), 1,
      anon_sym_LPAREN,
    ACTIONS(10729), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(10731), 1,
      anon_sym_u2983,
    ACTIONS(10733), 1,
      anon_sym_LBRACE,
    ACTIONS(10735), 1,
      aux_sym__qid_token1,
    ACTIONS(10737), 1,
      anon_sym_DOT,
    ACTIONS(10741), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(10743), 1,
      anon_sym_u2987,
    ACTIONS(10745), 1,
      aux_sym_integer_token1,
    ACTIONS(10747), 1,
      aux_sym_string_token1,
    ACTIONS(10749), 1,
      anon_sym_Set,
    STATE(7653), 1,
      sym_atom,
    STATE(7641), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7631), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(10723), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [570431] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(9758), 1,
      sym_id,
    ACTIONS(9760), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9764), 1,
      anon_sym_record,
    ACTIONS(9766), 1,
      anon_sym_LPAREN,
    ACTIONS(9768), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(9770), 1,
      anon_sym_u2983,
    ACTIONS(9772), 1,
      anon_sym_LBRACE,
    ACTIONS(9774), 1,
      aux_sym__qid_token1,
    ACTIONS(9776), 1,
      anon_sym_DOT,
    ACTIONS(9780), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(9782), 1,
      anon_sym_u2987,
    ACTIONS(9784), 1,
      aux_sym_integer_token1,
    ACTIONS(9786), 1,
      aux_sym_string_token1,
    ACTIONS(9788), 1,
      anon_sym_Set,
    STATE(7668), 1,
      sym_atom,
    STATE(7652), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7667), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(9762), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [570506] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(7099), 1,
      sym_id,
    ACTIONS(7101), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7105), 1,
      anon_sym_record,
    ACTIONS(7107), 1,
      anon_sym_LPAREN,
    ACTIONS(7109), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(7111), 1,
      anon_sym_u2983,
    ACTIONS(7113), 1,
      anon_sym_LBRACE,
    ACTIONS(7115), 1,
      aux_sym__qid_token1,
    ACTIONS(7117), 1,
      anon_sym_DOT,
    ACTIONS(7121), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(7123), 1,
      anon_sym_u2987,
    ACTIONS(7125), 1,
      aux_sym_integer_token1,
    ACTIONS(7127), 1,
      aux_sym_string_token1,
    ACTIONS(7129), 1,
      anon_sym_Set,
    STATE(6862), 1,
      sym_atom,
    STATE(6905), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6865), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(7103), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [570581] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(706), 1,
      aux_sym__qid_token1,
    ACTIONS(1904), 1,
      sym_id,
    ACTIONS(1916), 1,
      anon_sym_record,
    ACTIONS(1918), 1,
      anon_sym_LPAREN,
    ACTIONS(1922), 1,
      anon_sym_u2983,
    ACTIONS(1924), 1,
      anon_sym_LBRACE,
    ACTIONS(1926), 1,
      anon_sym_DOT,
    ACTIONS(1934), 1,
      anon_sym_u2987,
    ACTIONS(1938), 1,
      aux_sym_integer_token1,
    ACTIONS(1940), 1,
      anon_sym_Set,
    ACTIONS(12171), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12173), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(12175), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(12177), 1,
      aux_sym_string_token1,
    STATE(4670), 1,
      sym_atom,
    STATE(4675), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4679), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(1914), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [570656] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(9240), 1,
      sym_id,
    ACTIONS(9242), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9246), 1,
      anon_sym_record,
    ACTIONS(9248), 1,
      anon_sym_LPAREN,
    ACTIONS(9250), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(9252), 1,
      anon_sym_u2983,
    ACTIONS(9254), 1,
      anon_sym_LBRACE,
    ACTIONS(9256), 1,
      aux_sym__qid_token1,
    ACTIONS(9258), 1,
      anon_sym_DOT,
    ACTIONS(9262), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(9264), 1,
      anon_sym_u2987,
    ACTIONS(9266), 1,
      aux_sym_integer_token1,
    ACTIONS(9268), 1,
      aux_sym_string_token1,
    ACTIONS(9270), 1,
      anon_sym_Set,
    STATE(7596), 1,
      sym_atom,
    STATE(7475), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7469), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(9244), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [570731] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(7995), 1,
      sym_id,
    ACTIONS(7997), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8001), 1,
      anon_sym_record,
    ACTIONS(8003), 1,
      anon_sym_LPAREN,
    ACTIONS(8005), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(8007), 1,
      anon_sym_u2983,
    ACTIONS(8009), 1,
      anon_sym_LBRACE,
    ACTIONS(8011), 1,
      aux_sym__qid_token1,
    ACTIONS(8013), 1,
      anon_sym_DOT,
    ACTIONS(8017), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(8019), 1,
      anon_sym_u2987,
    ACTIONS(8021), 1,
      aux_sym_integer_token1,
    ACTIONS(8023), 1,
      aux_sym_string_token1,
    ACTIONS(8025), 1,
      anon_sym_Set,
    STATE(7178), 1,
      sym_atom,
    STATE(7226), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7206), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(7999), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [570806] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(850), 1,
      sym_id,
    ACTIONS(860), 1,
      anon_sym_record,
    ACTIONS(872), 1,
      aux_sym__qid_token1,
    ACTIONS(884), 1,
      anon_sym_u2987,
    ACTIONS(890), 1,
      aux_sym_integer_token1,
    ACTIONS(892), 1,
      anon_sym_Set,
    ACTIONS(4290), 1,
      anon_sym_LPAREN,
    ACTIONS(4294), 1,
      anon_sym_u2983,
    ACTIONS(4296), 1,
      anon_sym_LBRACE,
    ACTIONS(4298), 1,
      anon_sym_DOT,
    ACTIONS(11695), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11705), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11707), 1,
      aux_sym_string_token1,
    ACTIONS(12279), 1,
      anon_sym_LBRACE_LBRACE,
    STATE(5163), 1,
      sym_atom,
    STATE(5180), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5168), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(858), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [570881] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2346), 1,
      sym_id,
    ACTIONS(2356), 1,
      anon_sym_record,
    ACTIONS(2366), 1,
      aux_sym__qid_token1,
    ACTIONS(2376), 1,
      anon_sym_u2987,
    ACTIONS(2380), 1,
      aux_sym_integer_token1,
    ACTIONS(2382), 1,
      anon_sym_Set,
    ACTIONS(4750), 1,
      anon_sym_LPAREN,
    ACTIONS(4754), 1,
      anon_sym_u2983,
    ACTIONS(4756), 1,
      anon_sym_LBRACE,
    ACTIONS(4758), 1,
      anon_sym_DOT,
    ACTIONS(11977), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11987), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11989), 1,
      aux_sym_string_token1,
    ACTIONS(12461), 1,
      anon_sym_LBRACE_LBRACE,
    STATE(4168), 1,
      sym_atom,
    STATE(4180), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4192), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(2354), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [570956] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2246), 1,
      sym_id,
    ACTIONS(2250), 1,
      anon_sym_record,
    ACTIONS(2260), 1,
      aux_sym__qid_token1,
    ACTIONS(2266), 1,
      anon_sym_u2987,
    ACTIONS(2268), 1,
      aux_sym_integer_token1,
    ACTIONS(2270), 1,
      anon_sym_Set,
    ACTIONS(4738), 1,
      anon_sym_LPAREN,
    ACTIONS(4742), 1,
      anon_sym_u2983,
    ACTIONS(4744), 1,
      anon_sym_LBRACE,
    ACTIONS(4746), 1,
      anon_sym_DOT,
    ACTIONS(11481), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11483), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11485), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11487), 1,
      aux_sym_string_token1,
    STATE(4137), 1,
      sym_atom,
    STATE(4151), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4153), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(2248), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [571031] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(3694), 1,
      sym_id,
    ACTIONS(3704), 1,
      anon_sym_record,
    ACTIONS(3714), 1,
      aux_sym__qid_token1,
    ACTIONS(3724), 1,
      anon_sym_u2987,
    ACTIONS(3728), 1,
      aux_sym_integer_token1,
    ACTIONS(3730), 1,
      anon_sym_Set,
    ACTIONS(4782), 1,
      anon_sym_DOT,
    ACTIONS(11597), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11601), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11603), 1,
      aux_sym_string_token1,
    ACTIONS(12463), 1,
      anon_sym_LPAREN,
    ACTIONS(12465), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(12467), 1,
      anon_sym_u2983,
    ACTIONS(12469), 1,
      anon_sym_LBRACE,
    STATE(4471), 1,
      sym_atom,
    STATE(4467), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4459), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3702), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [571106] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(7364), 1,
      sym_id,
    ACTIONS(7366), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7370), 1,
      anon_sym_record,
    ACTIONS(7372), 1,
      anon_sym_LPAREN,
    ACTIONS(7374), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(7376), 1,
      anon_sym_u2983,
    ACTIONS(7378), 1,
      anon_sym_LBRACE,
    ACTIONS(7380), 1,
      aux_sym__qid_token1,
    ACTIONS(7382), 1,
      anon_sym_DOT,
    ACTIONS(7386), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(7388), 1,
      anon_sym_u2987,
    ACTIONS(7390), 1,
      aux_sym_integer_token1,
    ACTIONS(7392), 1,
      aux_sym_string_token1,
    ACTIONS(7394), 1,
      anon_sym_Set,
    STATE(7159), 1,
      sym_atom,
    STATE(7162), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7144), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(7368), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [571181] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(5192), 1,
      sym_id,
    ACTIONS(5196), 1,
      anon_sym_record,
    ACTIONS(5198), 1,
      anon_sym_LPAREN,
    ACTIONS(5202), 1,
      anon_sym_u2983,
    ACTIONS(5204), 1,
      anon_sym_LBRACE,
    ACTIONS(5206), 1,
      aux_sym__qid_token1,
    ACTIONS(5208), 1,
      anon_sym_DOT,
    ACTIONS(5212), 1,
      anon_sym_u2987,
    ACTIONS(5214), 1,
      aux_sym_integer_token1,
    ACTIONS(5216), 1,
      anon_sym_Set,
    ACTIONS(11749), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11751), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11753), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11755), 1,
      aux_sym_string_token1,
    STATE(5789), 1,
      sym_atom,
    STATE(5737), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5736), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(5194), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [571256] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6166), 1,
      sym_id,
    ACTIONS(6170), 1,
      anon_sym_record,
    ACTIONS(6172), 1,
      anon_sym_LPAREN,
    ACTIONS(6176), 1,
      anon_sym_u2983,
    ACTIONS(6178), 1,
      anon_sym_LBRACE,
    ACTIONS(6180), 1,
      aux_sym__qid_token1,
    ACTIONS(6182), 1,
      anon_sym_DOT,
    ACTIONS(6186), 1,
      anon_sym_u2987,
    ACTIONS(6188), 1,
      aux_sym_integer_token1,
    ACTIONS(6190), 1,
      anon_sym_Set,
    ACTIONS(12471), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12473), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(12475), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(12477), 1,
      aux_sym_string_token1,
    STATE(4959), 1,
      sym_atom,
    STATE(4960), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4966), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(6168), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [571331] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(7693), 1,
      sym_id,
    ACTIONS(7695), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7699), 1,
      anon_sym_record,
    ACTIONS(7701), 1,
      anon_sym_LPAREN,
    ACTIONS(7703), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(7705), 1,
      anon_sym_u2983,
    ACTIONS(7707), 1,
      anon_sym_LBRACE,
    ACTIONS(7709), 1,
      aux_sym__qid_token1,
    ACTIONS(7711), 1,
      anon_sym_DOT,
    ACTIONS(7713), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(7715), 1,
      anon_sym_u2987,
    ACTIONS(7717), 1,
      aux_sym_integer_token1,
    ACTIONS(7719), 1,
      aux_sym_string_token1,
    ACTIONS(7721), 1,
      anon_sym_Set,
    STATE(7454), 1,
      sym_atom,
    STATE(7459), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7461), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(7697), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [571406] = 5,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(12479), 1,
      anon_sym_AT,
    ACTIONS(6326), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6324), 26,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [571451] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(5708), 1,
      sym_id,
    ACTIONS(5712), 1,
      anon_sym_record,
    ACTIONS(5714), 1,
      anon_sym_LPAREN,
    ACTIONS(5718), 1,
      anon_sym_u2983,
    ACTIONS(5720), 1,
      anon_sym_LBRACE,
    ACTIONS(5722), 1,
      aux_sym__qid_token1,
    ACTIONS(5724), 1,
      anon_sym_DOT,
    ACTIONS(5728), 1,
      anon_sym_u2987,
    ACTIONS(5730), 1,
      aux_sym_integer_token1,
    ACTIONS(5732), 1,
      anon_sym_Set,
    ACTIONS(11535), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11537), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11539), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11541), 1,
      aux_sym_string_token1,
    STATE(5554), 1,
      sym_atom,
    STATE(5553), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5550), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(5710), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [571526] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(8439), 1,
      sym_id,
    ACTIONS(8441), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8445), 1,
      anon_sym_record,
    ACTIONS(8447), 1,
      anon_sym_LPAREN,
    ACTIONS(8449), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(8451), 1,
      anon_sym_u2983,
    ACTIONS(8453), 1,
      anon_sym_LBRACE,
    ACTIONS(8455), 1,
      aux_sym__qid_token1,
    ACTIONS(8457), 1,
      anon_sym_DOT,
    ACTIONS(8461), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(8463), 1,
      anon_sym_u2987,
    ACTIONS(8465), 1,
      aux_sym_integer_token1,
    ACTIONS(8467), 1,
      aux_sym_string_token1,
    ACTIONS(8469), 1,
      anon_sym_Set,
    STATE(7409), 1,
      sym_atom,
    STATE(7331), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7333), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(8443), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [571601] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(3130), 1,
      sym_id,
    ACTIONS(3140), 1,
      anon_sym_record,
    ACTIONS(3150), 1,
      aux_sym__qid_token1,
    ACTIONS(3160), 1,
      anon_sym_u2987,
    ACTIONS(3164), 1,
      aux_sym_integer_token1,
    ACTIONS(3166), 1,
      anon_sym_Set,
    ACTIONS(4368), 1,
      anon_sym_LPAREN,
    ACTIONS(4372), 1,
      anon_sym_u2983,
    ACTIONS(4374), 1,
      anon_sym_LBRACE,
    ACTIONS(4376), 1,
      anon_sym_DOT,
    ACTIONS(11929), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11931), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11933), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11935), 1,
      aux_sym_string_token1,
    STATE(4492), 1,
      sym_atom,
    STATE(4493), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4496), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3138), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [571676] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(7065), 1,
      sym_id,
    ACTIONS(7067), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7071), 1,
      anon_sym_record,
    ACTIONS(7073), 1,
      anon_sym_LPAREN,
    ACTIONS(7075), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(7077), 1,
      anon_sym_u2983,
    ACTIONS(7079), 1,
      anon_sym_LBRACE,
    ACTIONS(7081), 1,
      aux_sym__qid_token1,
    ACTIONS(7083), 1,
      anon_sym_DOT,
    ACTIONS(7087), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(7089), 1,
      anon_sym_u2987,
    ACTIONS(7091), 1,
      aux_sym_integer_token1,
    ACTIONS(7093), 1,
      aux_sym_string_token1,
    ACTIONS(7095), 1,
      anon_sym_Set,
    STATE(6922), 1,
      sym_atom,
    STATE(6955), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6945), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(7069), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [571751] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(3406), 1,
      sym_id,
    ACTIONS(3416), 1,
      anon_sym_record,
    ACTIONS(3426), 1,
      aux_sym__qid_token1,
    ACTIONS(3436), 1,
      anon_sym_u2987,
    ACTIONS(3440), 1,
      aux_sym_integer_token1,
    ACTIONS(3442), 1,
      anon_sym_Set,
    ACTIONS(4694), 1,
      anon_sym_LPAREN,
    ACTIONS(4698), 1,
      anon_sym_u2983,
    ACTIONS(4700), 1,
      anon_sym_LBRACE,
    ACTIONS(4702), 1,
      anon_sym_DOT,
    ACTIONS(11383), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11393), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11395), 1,
      aux_sym_string_token1,
    ACTIONS(12481), 1,
      anon_sym_LBRACE_LBRACE,
    STATE(4129), 1,
      sym_atom,
    STATE(4158), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4162), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3414), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [571826] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(5306), 1,
      sym_id,
    ACTIONS(5310), 1,
      anon_sym_record,
    ACTIONS(5312), 1,
      anon_sym_LPAREN,
    ACTIONS(5316), 1,
      anon_sym_u2983,
    ACTIONS(5318), 1,
      anon_sym_LBRACE,
    ACTIONS(5320), 1,
      aux_sym__qid_token1,
    ACTIONS(5322), 1,
      anon_sym_DOT,
    ACTIONS(5326), 1,
      anon_sym_u2987,
    ACTIONS(5328), 1,
      aux_sym_integer_token1,
    ACTIONS(5330), 1,
      anon_sym_Set,
    ACTIONS(12483), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12485), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(12487), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(12489), 1,
      aux_sym_string_token1,
    STATE(5856), 1,
      sym_atom,
    STATE(5854), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5853), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(5308), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [571901] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11019), 1,
      sym_id,
    ACTIONS(11021), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11025), 1,
      anon_sym_record,
    ACTIONS(11027), 1,
      anon_sym_LPAREN,
    ACTIONS(11029), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11031), 1,
      anon_sym_u2983,
    ACTIONS(11033), 1,
      anon_sym_LBRACE,
    ACTIONS(11035), 1,
      aux_sym__qid_token1,
    ACTIONS(11037), 1,
      anon_sym_DOT,
    ACTIONS(11041), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11043), 1,
      anon_sym_u2987,
    ACTIONS(11045), 1,
      aux_sym_integer_token1,
    ACTIONS(11047), 1,
      aux_sym_string_token1,
    ACTIONS(11049), 1,
      anon_sym_Set,
    STATE(7704), 1,
      sym_atom,
    STATE(7686), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7699), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11023), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [571976] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(5788), 1,
      sym_id,
    ACTIONS(5792), 1,
      anon_sym_record,
    ACTIONS(5794), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_u2983,
    ACTIONS(5800), 1,
      anon_sym_LBRACE,
    ACTIONS(5802), 1,
      aux_sym__qid_token1,
    ACTIONS(5804), 1,
      anon_sym_DOT,
    ACTIONS(5808), 1,
      anon_sym_u2987,
    ACTIONS(5810), 1,
      aux_sym_integer_token1,
    ACTIONS(5812), 1,
      anon_sym_Set,
    ACTIONS(12491), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12493), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(12495), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(12497), 1,
      aux_sym_string_token1,
    STATE(5248), 1,
      sym_atom,
    STATE(5245), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5235), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(5790), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [572051] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(5682), 1,
      sym_id,
    ACTIONS(5686), 1,
      anon_sym_record,
    ACTIONS(5688), 1,
      anon_sym_LPAREN,
    ACTIONS(5692), 1,
      anon_sym_u2983,
    ACTIONS(5694), 1,
      anon_sym_LBRACE,
    ACTIONS(5696), 1,
      aux_sym__qid_token1,
    ACTIONS(5698), 1,
      anon_sym_DOT,
    ACTIONS(5702), 1,
      anon_sym_u2987,
    ACTIONS(5704), 1,
      aux_sym_integer_token1,
    ACTIONS(5706), 1,
      anon_sym_Set,
    ACTIONS(12307), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12309), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(12311), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(12313), 1,
      aux_sym_string_token1,
    STATE(5923), 1,
      sym_atom,
    STATE(5924), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5925), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(5684), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [572126] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1280), 1,
      aux_sym_integer_token1,
    ACTIONS(1282), 1,
      anon_sym_Set,
    ACTIONS(4404), 1,
      anon_sym_DOT,
    ACTIONS(11619), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11623), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11625), 1,
      aux_sym_string_token1,
    ACTIONS(12499), 1,
      anon_sym_LPAREN,
    ACTIONS(12501), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(12503), 1,
      anon_sym_u2983,
    ACTIONS(12505), 1,
      anon_sym_LBRACE,
    STATE(5443), 1,
      sym_atom,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(1252), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [572201] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(940), 1,
      sym_id,
    ACTIONS(950), 1,
      anon_sym_record,
    ACTIONS(960), 1,
      aux_sym__qid_token1,
    ACTIONS(970), 1,
      anon_sym_u2987,
    ACTIONS(974), 1,
      aux_sym_integer_token1,
    ACTIONS(976), 1,
      anon_sym_Set,
    ACTIONS(4580), 1,
      anon_sym_LPAREN,
    ACTIONS(4584), 1,
      anon_sym_u2983,
    ACTIONS(4586), 1,
      anon_sym_LBRACE,
    ACTIONS(4588), 1,
      anon_sym_DOT,
    ACTIONS(11757), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11767), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11769), 1,
      aux_sym_string_token1,
    ACTIONS(12459), 1,
      anon_sym_LBRACE_LBRACE,
    STATE(4746), 1,
      sym_atom,
    STATE(4733), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4742), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(948), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [572276] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1202), 1,
      aux_sym_integer_token1,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(4540), 1,
      anon_sym_LPAREN,
    ACTIONS(4544), 1,
      anon_sym_u2983,
    ACTIONS(4546), 1,
      anon_sym_LBRACE,
    ACTIONS(4548), 1,
      anon_sym_DOT,
    ACTIONS(11451), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11461), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11463), 1,
      aux_sym_string_token1,
    ACTIONS(12507), 1,
      anon_sym_LBRACE_LBRACE,
    STATE(5233), 1,
      sym_atom,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(1174), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [572351] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(7663), 1,
      sym_id,
    ACTIONS(7665), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7669), 1,
      anon_sym_record,
    ACTIONS(7671), 1,
      anon_sym_LPAREN,
    ACTIONS(7673), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(7675), 1,
      anon_sym_u2983,
    ACTIONS(7677), 1,
      anon_sym_LBRACE,
    ACTIONS(7679), 1,
      aux_sym__qid_token1,
    ACTIONS(7681), 1,
      anon_sym_DOT,
    ACTIONS(7683), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(7685), 1,
      anon_sym_u2987,
    ACTIONS(7687), 1,
      aux_sym_integer_token1,
    ACTIONS(7689), 1,
      aux_sym_string_token1,
    ACTIONS(7691), 1,
      anon_sym_Set,
    STATE(7374), 1,
      sym_atom,
    STATE(7400), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7291), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(7667), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [572426] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(5548), 1,
      sym_id,
    ACTIONS(5552), 1,
      anon_sym_record,
    ACTIONS(5554), 1,
      anon_sym_LPAREN,
    ACTIONS(5558), 1,
      anon_sym_u2983,
    ACTIONS(5560), 1,
      anon_sym_LBRACE,
    ACTIONS(5562), 1,
      aux_sym__qid_token1,
    ACTIONS(5564), 1,
      anon_sym_DOT,
    ACTIONS(5568), 1,
      anon_sym_u2987,
    ACTIONS(5570), 1,
      aux_sym_integer_token1,
    ACTIONS(5572), 1,
      anon_sym_Set,
    ACTIONS(12393), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12395), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(12397), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(12399), 1,
      aux_sym_string_token1,
    STATE(6044), 1,
      sym_atom,
    STATE(6032), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6059), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(5550), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [572501] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2018), 1,
      sym_id,
    ACTIONS(2028), 1,
      anon_sym_record,
    ACTIONS(2038), 1,
      aux_sym__qid_token1,
    ACTIONS(2048), 1,
      anon_sym_u2987,
    ACTIONS(2052), 1,
      aux_sym_integer_token1,
    ACTIONS(2054), 1,
      anon_sym_Set,
    ACTIONS(4714), 1,
      anon_sym_DOT,
    ACTIONS(12281), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12285), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(12287), 1,
      aux_sym_string_token1,
    ACTIONS(12509), 1,
      anon_sym_LPAREN,
    ACTIONS(12511), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(12513), 1,
      anon_sym_u2983,
    ACTIONS(12515), 1,
      anon_sym_LBRACE,
    STATE(5175), 1,
      sym_atom,
    STATE(5176), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5183), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(2026), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [572576] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(5002), 1,
      sym_id,
    ACTIONS(5006), 1,
      anon_sym_record,
    ACTIONS(5008), 1,
      anon_sym_LPAREN,
    ACTIONS(5012), 1,
      anon_sym_u2983,
    ACTIONS(5014), 1,
      anon_sym_LBRACE,
    ACTIONS(5016), 1,
      aux_sym__qid_token1,
    ACTIONS(5018), 1,
      anon_sym_DOT,
    ACTIONS(5022), 1,
      anon_sym_u2987,
    ACTIONS(5024), 1,
      aux_sym_integer_token1,
    ACTIONS(5026), 1,
      anon_sym_Set,
    ACTIONS(12517), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12519), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(12521), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(12523), 1,
      aux_sym_string_token1,
    STATE(5807), 1,
      sym_atom,
    STATE(5805), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5804), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(5004), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [572651] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(8597), 1,
      sym_id,
    ACTIONS(8599), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8603), 1,
      anon_sym_record,
    ACTIONS(8605), 1,
      anon_sym_LPAREN,
    ACTIONS(8607), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(8609), 1,
      anon_sym_u2983,
    ACTIONS(8611), 1,
      anon_sym_LBRACE,
    ACTIONS(8613), 1,
      aux_sym__qid_token1,
    ACTIONS(8615), 1,
      anon_sym_DOT,
    ACTIONS(8619), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(8621), 1,
      anon_sym_u2987,
    ACTIONS(8623), 1,
      aux_sym_integer_token1,
    ACTIONS(8625), 1,
      aux_sym_string_token1,
    ACTIONS(8627), 1,
      anon_sym_Set,
    STATE(7407), 1,
      sym_atom,
    STATE(7406), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7405), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(8601), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [572726] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6502), 1,
      sym_id,
    ACTIONS(6504), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6508), 1,
      anon_sym_record,
    ACTIONS(6510), 1,
      anon_sym_LPAREN,
    ACTIONS(6512), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(6514), 1,
      anon_sym_u2983,
    ACTIONS(6516), 1,
      anon_sym_LBRACE,
    ACTIONS(6518), 1,
      aux_sym__qid_token1,
    ACTIONS(6520), 1,
      anon_sym_DOT,
    ACTIONS(6524), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(6526), 1,
      anon_sym_u2987,
    ACTIONS(6528), 1,
      aux_sym_integer_token1,
    ACTIONS(6530), 1,
      aux_sym_string_token1,
    ACTIONS(6532), 1,
      anon_sym_Set,
    STATE(6821), 1,
      sym_atom,
    STATE(6850), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6851), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(6506), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [572801] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2978), 1,
      sym_id,
    ACTIONS(2988), 1,
      anon_sym_record,
    ACTIONS(2998), 1,
      aux_sym__qid_token1,
    ACTIONS(3008), 1,
      anon_sym_u2987,
    ACTIONS(3012), 1,
      aux_sym_integer_token1,
    ACTIONS(3014), 1,
      anon_sym_Set,
    ACTIONS(4314), 1,
      anon_sym_DOT,
    ACTIONS(12019), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12023), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(12025), 1,
      aux_sym_string_token1,
    ACTIONS(12525), 1,
      anon_sym_LPAREN,
    ACTIONS(12527), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(12529), 1,
      anon_sym_u2983,
    ACTIONS(12531), 1,
      anon_sym_LBRACE,
    STATE(4461), 1,
      sym_atom,
    STATE(4469), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4463), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(2986), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [572876] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2690), 1,
      sym_id,
    ACTIONS(2700), 1,
      anon_sym_record,
    ACTIONS(2710), 1,
      aux_sym__qid_token1,
    ACTIONS(2720), 1,
      anon_sym_u2987,
    ACTIONS(2724), 1,
      aux_sym_integer_token1,
    ACTIONS(2726), 1,
      anon_sym_Set,
    ACTIONS(4444), 1,
      anon_sym_LPAREN,
    ACTIONS(4448), 1,
      anon_sym_u2983,
    ACTIONS(4450), 1,
      anon_sym_LBRACE,
    ACTIONS(4452), 1,
      anon_sym_DOT,
    ACTIONS(11673), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11683), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11685), 1,
      aux_sym_string_token1,
    ACTIONS(12533), 1,
      anon_sym_LBRACE_LBRACE,
    STATE(4115), 1,
      sym_atom,
    STATE(4108), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4103), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(2698), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [572951] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(3878), 1,
      sym_id,
    ACTIONS(3884), 1,
      anon_sym_record,
    ACTIONS(3886), 1,
      anon_sym_LPAREN,
    ACTIONS(3890), 1,
      anon_sym_u2983,
    ACTIONS(3892), 1,
      anon_sym_LBRACE,
    ACTIONS(3894), 1,
      aux_sym__qid_token1,
    ACTIONS(3896), 1,
      anon_sym_DOT,
    ACTIONS(3900), 1,
      anon_sym_u2987,
    ACTIONS(3902), 1,
      aux_sym_integer_token1,
    ACTIONS(3904), 1,
      anon_sym_Set,
    ACTIONS(12535), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12537), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(12539), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(12541), 1,
      aux_sym_string_token1,
    STATE(4203), 1,
      sym_atom,
    STATE(4214), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4218), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3882), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [573026] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(9792), 1,
      sym_id,
    ACTIONS(9794), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9798), 1,
      anon_sym_record,
    ACTIONS(9800), 1,
      anon_sym_LPAREN,
    ACTIONS(9802), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(9804), 1,
      anon_sym_u2983,
    ACTIONS(9806), 1,
      anon_sym_LBRACE,
    ACTIONS(9808), 1,
      aux_sym__qid_token1,
    ACTIONS(9810), 1,
      anon_sym_DOT,
    ACTIONS(9814), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(9816), 1,
      anon_sym_u2987,
    ACTIONS(9818), 1,
      aux_sym_integer_token1,
    ACTIONS(9820), 1,
      aux_sym_string_token1,
    ACTIONS(9822), 1,
      anon_sym_Set,
    STATE(7556), 1,
      sym_atom,
    STATE(7535), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7536), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(9796), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [573101] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(10519), 1,
      sym_id,
    ACTIONS(10521), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10525), 1,
      anon_sym_record,
    ACTIONS(10527), 1,
      anon_sym_LPAREN,
    ACTIONS(10529), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(10531), 1,
      anon_sym_u2983,
    ACTIONS(10533), 1,
      anon_sym_LBRACE,
    ACTIONS(10535), 1,
      aux_sym__qid_token1,
    ACTIONS(10537), 1,
      anon_sym_DOT,
    ACTIONS(10541), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(10543), 1,
      anon_sym_u2987,
    ACTIONS(10545), 1,
      aux_sym_integer_token1,
    ACTIONS(10547), 1,
      aux_sym_string_token1,
    ACTIONS(10549), 1,
      anon_sym_Set,
    STATE(7721), 1,
      sym_atom,
    STATE(7698), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7681), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(10523), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [573176] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(3852), 1,
      sym_id,
    ACTIONS(3856), 1,
      anon_sym_record,
    ACTIONS(3866), 1,
      aux_sym__qid_token1,
    ACTIONS(3872), 1,
      anon_sym_u2987,
    ACTIONS(3874), 1,
      aux_sym_integer_token1,
    ACTIONS(3876), 1,
      anon_sym_Set,
    ACTIONS(4732), 1,
      anon_sym_DOT,
    ACTIONS(12271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12275), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(12277), 1,
      aux_sym_string_token1,
    ACTIONS(12543), 1,
      anon_sym_LPAREN,
    ACTIONS(12545), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(12547), 1,
      anon_sym_u2983,
    ACTIONS(12549), 1,
      anon_sym_LBRACE,
    STATE(4641), 1,
      sym_atom,
    STATE(4642), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4643), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3854), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [573251] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2766), 1,
      sym_id,
    ACTIONS(2772), 1,
      anon_sym_record,
    ACTIONS(2774), 1,
      anon_sym_LPAREN,
    ACTIONS(2778), 1,
      anon_sym_u2983,
    ACTIONS(2780), 1,
      anon_sym_LBRACE,
    ACTIONS(2782), 1,
      aux_sym__qid_token1,
    ACTIONS(2784), 1,
      anon_sym_DOT,
    ACTIONS(2788), 1,
      anon_sym_u2987,
    ACTIONS(2790), 1,
      aux_sym_integer_token1,
    ACTIONS(2792), 1,
      anon_sym_Set,
    ACTIONS(12345), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12347), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(12349), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(12351), 1,
      aux_sym_string_token1,
    STATE(5636), 1,
      sym_atom,
    STATE(5666), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5668), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(2770), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [573326] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(3974), 1,
      anon_sym_record,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    ACTIONS(3982), 1,
      anon_sym_u2983,
    ACTIONS(3984), 1,
      anon_sym_LBRACE,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(3994), 1,
      anon_sym_u2987,
    ACTIONS(3998), 1,
      aux_sym_integer_token1,
    ACTIONS(4000), 1,
      anon_sym_Set,
    ACTIONS(4222), 1,
      sym_id,
    ACTIONS(4224), 1,
      aux_sym__qid_token1,
    ACTIONS(12297), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12299), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(12301), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(12303), 1,
      aux_sym_string_token1,
    STATE(6292), 1,
      sym_atom,
    STATE(6244), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6169), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3972), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [573401] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(3732), 1,
      sym_id,
    ACTIONS(3738), 1,
      anon_sym_record,
    ACTIONS(3740), 1,
      anon_sym_LPAREN,
    ACTIONS(3744), 1,
      anon_sym_u2983,
    ACTIONS(3746), 1,
      anon_sym_LBRACE,
    ACTIONS(3748), 1,
      aux_sym__qid_token1,
    ACTIONS(3750), 1,
      anon_sym_DOT,
    ACTIONS(3754), 1,
      anon_sym_u2987,
    ACTIONS(3756), 1,
      aux_sym_integer_token1,
    ACTIONS(3758), 1,
      anon_sym_Set,
    ACTIONS(12551), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12553), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(12555), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(12557), 1,
      aux_sym_string_token1,
    STATE(4076), 1,
      sym_atom,
    STATE(4073), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4070), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3736), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [573476] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(8123), 1,
      sym_id,
    ACTIONS(8125), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8129), 1,
      anon_sym_record,
    ACTIONS(8131), 1,
      anon_sym_LPAREN,
    ACTIONS(8133), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(8135), 1,
      anon_sym_u2983,
    ACTIONS(8137), 1,
      anon_sym_LBRACE,
    ACTIONS(8139), 1,
      aux_sym__qid_token1,
    ACTIONS(8141), 1,
      anon_sym_DOT,
    ACTIONS(8145), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(8147), 1,
      anon_sym_u2987,
    ACTIONS(8149), 1,
      aux_sym_integer_token1,
    ACTIONS(8151), 1,
      aux_sym_string_token1,
    ACTIONS(8153), 1,
      anon_sym_Set,
    STATE(7214), 1,
      sym_atom,
    STATE(7213), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7209), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(8127), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [573551] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1980), 1,
      sym_id,
    ACTIONS(1990), 1,
      anon_sym_record,
    ACTIONS(2000), 1,
      aux_sym__qid_token1,
    ACTIONS(2010), 1,
      anon_sym_u2987,
    ACTIONS(2014), 1,
      aux_sym_integer_token1,
    ACTIONS(2016), 1,
      anon_sym_Set,
    ACTIONS(4386), 1,
      anon_sym_LPAREN,
    ACTIONS(4390), 1,
      anon_sym_u2983,
    ACTIONS(4392), 1,
      anon_sym_LBRACE,
    ACTIONS(4394), 1,
      anon_sym_DOT,
    ACTIONS(12369), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12371), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(12373), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(12375), 1,
      aux_sym_string_token1,
    STATE(5337), 1,
      sym_atom,
    STATE(5336), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5185), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(1988), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [573626] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6198), 1,
      sym_id,
    ACTIONS(6202), 1,
      anon_sym_record,
    ACTIONS(6204), 1,
      anon_sym_LPAREN,
    ACTIONS(6208), 1,
      anon_sym_u2983,
    ACTIONS(6210), 1,
      anon_sym_LBRACE,
    ACTIONS(6212), 1,
      aux_sym__qid_token1,
    ACTIONS(6214), 1,
      anon_sym_DOT,
    ACTIONS(6218), 1,
      anon_sym_u2987,
    ACTIONS(6220), 1,
      aux_sym_integer_token1,
    ACTIONS(6222), 1,
      anon_sym_Set,
    ACTIONS(12451), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12453), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(12455), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(12457), 1,
      aux_sym_string_token1,
    STATE(5357), 1,
      sym_atom,
    STATE(5699), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5697), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(6200), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [573701] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2566), 1,
      sym_id,
    ACTIONS(2576), 1,
      anon_sym_record,
    ACTIONS(2586), 1,
      aux_sym__qid_token1,
    ACTIONS(2596), 1,
      anon_sym_u2987,
    ACTIONS(2600), 1,
      aux_sym_integer_token1,
    ACTIONS(2602), 1,
      anon_sym_Set,
    ACTIONS(4594), 1,
      anon_sym_LPAREN,
    ACTIONS(4598), 1,
      anon_sym_u2983,
    ACTIONS(4600), 1,
      anon_sym_LBRACE,
    ACTIONS(4602), 1,
      anon_sym_DOT,
    ACTIONS(11605), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11615), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11617), 1,
      aux_sym_string_token1,
    ACTIONS(12009), 1,
      anon_sym_LBRACE_LBRACE,
    STATE(5595), 1,
      sym_atom,
    STATE(5566), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5590), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(2574), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [573776] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(10337), 1,
      sym_id,
    ACTIONS(10339), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10343), 1,
      anon_sym_record,
    ACTIONS(10345), 1,
      anon_sym_LPAREN,
    ACTIONS(10347), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(10349), 1,
      anon_sym_u2983,
    ACTIONS(10351), 1,
      anon_sym_LBRACE,
    ACTIONS(10353), 1,
      aux_sym__qid_token1,
    ACTIONS(10355), 1,
      anon_sym_DOT,
    ACTIONS(10359), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(10361), 1,
      anon_sym_u2987,
    ACTIONS(10363), 1,
      aux_sym_integer_token1,
    ACTIONS(10365), 1,
      aux_sym_string_token1,
    ACTIONS(10367), 1,
      anon_sym_Set,
    STATE(7720), 1,
      sym_atom,
    STATE(7712), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7709), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(10341), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [573851] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(5332), 1,
      sym_id,
    ACTIONS(5336), 1,
      anon_sym_record,
    ACTIONS(5338), 1,
      anon_sym_LPAREN,
    ACTIONS(5342), 1,
      anon_sym_u2983,
    ACTIONS(5344), 1,
      anon_sym_LBRACE,
    ACTIONS(5346), 1,
      aux_sym__qid_token1,
    ACTIONS(5348), 1,
      anon_sym_DOT,
    ACTIONS(5352), 1,
      anon_sym_u2987,
    ACTIONS(5354), 1,
      aux_sym_integer_token1,
    ACTIONS(5356), 1,
      anon_sym_Set,
    ACTIONS(12559), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12561), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(12563), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(12565), 1,
      aux_sym_string_token1,
    STATE(4859), 1,
      sym_atom,
    STATE(4898), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4840), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(5334), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [573926] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(7364), 1,
      sym_id,
    ACTIONS(7366), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7370), 1,
      anon_sym_record,
    ACTIONS(7372), 1,
      anon_sym_LPAREN,
    ACTIONS(7374), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(7376), 1,
      anon_sym_u2983,
    ACTIONS(7378), 1,
      anon_sym_LBRACE,
    ACTIONS(7380), 1,
      aux_sym__qid_token1,
    ACTIONS(7382), 1,
      anon_sym_DOT,
    ACTIONS(7386), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(7388), 1,
      anon_sym_u2987,
    ACTIONS(7390), 1,
      aux_sym_integer_token1,
    ACTIONS(7392), 1,
      aux_sym_string_token1,
    ACTIONS(7394), 1,
      anon_sym_Set,
    STATE(7154), 1,
      sym_atom,
    STATE(7162), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7144), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(7368), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [574001] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(5734), 1,
      sym_id,
    ACTIONS(5738), 1,
      anon_sym_record,
    ACTIONS(5740), 1,
      anon_sym_LPAREN,
    ACTIONS(5744), 1,
      anon_sym_u2983,
    ACTIONS(5746), 1,
      anon_sym_LBRACE,
    ACTIONS(5748), 1,
      aux_sym__qid_token1,
    ACTIONS(5750), 1,
      anon_sym_DOT,
    ACTIONS(5754), 1,
      anon_sym_u2987,
    ACTIONS(5756), 1,
      aux_sym_integer_token1,
    ACTIONS(5758), 1,
      anon_sym_Set,
    ACTIONS(12401), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12403), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(12405), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(12407), 1,
      aux_sym_string_token1,
    STATE(5766), 1,
      sym_atom,
    STATE(5762), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5752), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(5736), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [574076] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(5604), 1,
      sym_id,
    ACTIONS(5608), 1,
      anon_sym_record,
    ACTIONS(5610), 1,
      anon_sym_LPAREN,
    ACTIONS(5614), 1,
      anon_sym_u2983,
    ACTIONS(5616), 1,
      anon_sym_LBRACE,
    ACTIONS(5618), 1,
      aux_sym__qid_token1,
    ACTIONS(5620), 1,
      anon_sym_DOT,
    ACTIONS(5624), 1,
      anon_sym_u2987,
    ACTIONS(5626), 1,
      aux_sym_integer_token1,
    ACTIONS(5628), 1,
      anon_sym_Set,
    ACTIONS(12567), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12569), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(12571), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(12573), 1,
      aux_sym_string_token1,
    STATE(6235), 1,
      sym_atom,
    STATE(6226), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6214), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(5606), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [574151] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(5952), 1,
      sym_id,
    ACTIONS(5956), 1,
      anon_sym_record,
    ACTIONS(5958), 1,
      anon_sym_LPAREN,
    ACTIONS(5962), 1,
      anon_sym_u2983,
    ACTIONS(5964), 1,
      anon_sym_LBRACE,
    ACTIONS(5966), 1,
      aux_sym__qid_token1,
    ACTIONS(5968), 1,
      anon_sym_DOT,
    ACTIONS(5972), 1,
      anon_sym_u2987,
    ACTIONS(5974), 1,
      aux_sym_integer_token1,
    ACTIONS(5976), 1,
      anon_sym_Set,
    ACTIONS(12575), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12577), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(12579), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(12581), 1,
      aux_sym_string_token1,
    STATE(6211), 1,
      sym_atom,
    STATE(6213), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6217), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(5954), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [574226] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(5574), 1,
      sym_id,
    ACTIONS(5578), 1,
      anon_sym_record,
    ACTIONS(5580), 1,
      anon_sym_LPAREN,
    ACTIONS(5584), 1,
      anon_sym_u2983,
    ACTIONS(5586), 1,
      anon_sym_LBRACE,
    ACTIONS(5588), 1,
      aux_sym__qid_token1,
    ACTIONS(5590), 1,
      anon_sym_DOT,
    ACTIONS(5594), 1,
      anon_sym_u2987,
    ACTIONS(5596), 1,
      aux_sym_integer_token1,
    ACTIONS(5598), 1,
      anon_sym_Set,
    ACTIONS(12583), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12585), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(12587), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(12589), 1,
      aux_sym_string_token1,
    STATE(4313), 1,
      sym_atom,
    STATE(4312), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4307), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(5576), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [574301] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1166), 1,
      sym_id,
    ACTIONS(1176), 1,
      anon_sym_record,
    ACTIONS(1188), 1,
      aux_sym__qid_token1,
    ACTIONS(1198), 1,
      anon_sym_u2987,
    ACTIONS(1202), 1,
      aux_sym_integer_token1,
    ACTIONS(1204), 1,
      anon_sym_Set,
    ACTIONS(4540), 1,
      anon_sym_LPAREN,
    ACTIONS(4544), 1,
      anon_sym_u2983,
    ACTIONS(4546), 1,
      anon_sym_LBRACE,
    ACTIONS(4548), 1,
      anon_sym_DOT,
    ACTIONS(11451), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11461), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11463), 1,
      aux_sym_string_token1,
    ACTIONS(12507), 1,
      anon_sym_LBRACE_LBRACE,
    STATE(5240), 1,
      sym_atom,
    STATE(5255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5246), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(1174), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [574376] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2978), 1,
      sym_id,
    ACTIONS(2988), 1,
      anon_sym_record,
    ACTIONS(2998), 1,
      aux_sym__qid_token1,
    ACTIONS(3008), 1,
      anon_sym_u2987,
    ACTIONS(3012), 1,
      aux_sym_integer_token1,
    ACTIONS(3014), 1,
      anon_sym_Set,
    ACTIONS(4306), 1,
      anon_sym_LPAREN,
    ACTIONS(4310), 1,
      anon_sym_u2983,
    ACTIONS(4312), 1,
      anon_sym_LBRACE,
    ACTIONS(4314), 1,
      anon_sym_DOT,
    ACTIONS(12019), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12021), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(12023), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(12025), 1,
      aux_sym_string_token1,
    STATE(4461), 1,
      sym_atom,
    STATE(4469), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4463), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(2986), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [574451] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2298), 1,
      sym_id,
    ACTIONS(2308), 1,
      anon_sym_record,
    ACTIONS(2318), 1,
      aux_sym__qid_token1,
    ACTIONS(2328), 1,
      anon_sym_u2987,
    ACTIONS(2332), 1,
      aux_sym_integer_token1,
    ACTIONS(2334), 1,
      anon_sym_Set,
    ACTIONS(4482), 1,
      anon_sym_LPAREN,
    ACTIONS(4486), 1,
      anon_sym_u2983,
    ACTIONS(4488), 1,
      anon_sym_LBRACE,
    ACTIONS(4490), 1,
      anon_sym_DOT,
    ACTIONS(12353), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12355), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(12357), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(12359), 1,
      aux_sym_string_token1,
    STATE(4990), 1,
      sym_atom,
    STATE(5354), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5347), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(2306), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [574526] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2690), 1,
      sym_id,
    ACTIONS(2700), 1,
      anon_sym_record,
    ACTIONS(2710), 1,
      aux_sym__qid_token1,
    ACTIONS(2720), 1,
      anon_sym_u2987,
    ACTIONS(2724), 1,
      aux_sym_integer_token1,
    ACTIONS(2726), 1,
      anon_sym_Set,
    ACTIONS(4444), 1,
      anon_sym_LPAREN,
    ACTIONS(4448), 1,
      anon_sym_u2983,
    ACTIONS(4450), 1,
      anon_sym_LBRACE,
    ACTIONS(4452), 1,
      anon_sym_DOT,
    ACTIONS(11673), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11683), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11685), 1,
      aux_sym_string_token1,
    ACTIONS(12533), 1,
      anon_sym_LBRACE_LBRACE,
    STATE(4109), 1,
      sym_atom,
    STATE(4108), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4103), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(2698), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [574601] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(5788), 1,
      sym_id,
    ACTIONS(5792), 1,
      anon_sym_record,
    ACTIONS(5794), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_u2983,
    ACTIONS(5800), 1,
      anon_sym_LBRACE,
    ACTIONS(5802), 1,
      aux_sym__qid_token1,
    ACTIONS(5804), 1,
      anon_sym_DOT,
    ACTIONS(5808), 1,
      anon_sym_u2987,
    ACTIONS(5810), 1,
      aux_sym_integer_token1,
    ACTIONS(5812), 1,
      anon_sym_Set,
    ACTIONS(12491), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12493), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(12495), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(12497), 1,
      aux_sym_string_token1,
    STATE(5259), 1,
      sym_atom,
    STATE(5245), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5235), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(5790), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [574676] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(5278), 1,
      sym_id,
    ACTIONS(5282), 1,
      anon_sym_record,
    ACTIONS(5284), 1,
      anon_sym_LPAREN,
    ACTIONS(5288), 1,
      anon_sym_u2983,
    ACTIONS(5290), 1,
      anon_sym_LBRACE,
    ACTIONS(5292), 1,
      aux_sym__qid_token1,
    ACTIONS(5294), 1,
      anon_sym_DOT,
    ACTIONS(5298), 1,
      anon_sym_u2987,
    ACTIONS(5300), 1,
      aux_sym_integer_token1,
    ACTIONS(5302), 1,
      anon_sym_Set,
    ACTIONS(12433), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12435), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(12437), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(12439), 1,
      aux_sym_string_token1,
    STATE(5780), 1,
      sym_atom,
    STATE(5779), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5778), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(5280), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [574751] = 3,
    ACTIONS(6326), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6324), 31,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [574792] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2134), 1,
      sym_id,
    ACTIONS(2146), 1,
      anon_sym_record,
    ACTIONS(2148), 1,
      anon_sym_LPAREN,
    ACTIONS(2152), 1,
      anon_sym_u2983,
    ACTIONS(2154), 1,
      anon_sym_LBRACE,
    ACTIONS(2156), 1,
      aux_sym__qid_token1,
    ACTIONS(2158), 1,
      anon_sym_DOT,
    ACTIONS(2166), 1,
      anon_sym_u2987,
    ACTIONS(2170), 1,
      aux_sym_integer_token1,
    ACTIONS(2172), 1,
      anon_sym_Set,
    ACTIONS(12385), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12387), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(12389), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(12391), 1,
      aux_sym_string_token1,
    STATE(5618), 1,
      sym_atom,
    STATE(5624), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5627), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(2144), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [574867] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1244), 1,
      sym_id,
    ACTIONS(1254), 1,
      anon_sym_record,
    ACTIONS(1266), 1,
      aux_sym__qid_token1,
    ACTIONS(1276), 1,
      anon_sym_u2987,
    ACTIONS(1280), 1,
      aux_sym_integer_token1,
    ACTIONS(1282), 1,
      anon_sym_Set,
    ACTIONS(4396), 1,
      anon_sym_LPAREN,
    ACTIONS(4400), 1,
      anon_sym_u2983,
    ACTIONS(4402), 1,
      anon_sym_LBRACE,
    ACTIONS(4404), 1,
      anon_sym_DOT,
    ACTIONS(11619), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11621), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11623), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11625), 1,
      aux_sym_string_token1,
    STATE(5528), 1,
      sym_atom,
    STATE(5431), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5436), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(1252), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [574942] = 3,
    ACTIONS(12593), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(12591), 31,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [574983] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(3406), 1,
      sym_id,
    ACTIONS(3416), 1,
      anon_sym_record,
    ACTIONS(3426), 1,
      aux_sym__qid_token1,
    ACTIONS(3436), 1,
      anon_sym_u2987,
    ACTIONS(3440), 1,
      aux_sym_integer_token1,
    ACTIONS(3442), 1,
      anon_sym_Set,
    ACTIONS(4694), 1,
      anon_sym_LPAREN,
    ACTIONS(4698), 1,
      anon_sym_u2983,
    ACTIONS(4700), 1,
      anon_sym_LBRACE,
    ACTIONS(4702), 1,
      anon_sym_DOT,
    ACTIONS(11383), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11393), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11395), 1,
      aux_sym_string_token1,
    ACTIONS(12481), 1,
      anon_sym_LBRACE_LBRACE,
    STATE(4155), 1,
      sym_atom,
    STATE(4158), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4162), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3414), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [575058] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(5898), 1,
      sym_id,
    ACTIONS(5902), 1,
      anon_sym_record,
    ACTIONS(5904), 1,
      anon_sym_LPAREN,
    ACTIONS(5908), 1,
      anon_sym_u2983,
    ACTIONS(5910), 1,
      anon_sym_LBRACE,
    ACTIONS(5912), 1,
      aux_sym__qid_token1,
    ACTIONS(5914), 1,
      anon_sym_DOT,
    ACTIONS(5918), 1,
      anon_sym_u2987,
    ACTIONS(5920), 1,
      aux_sym_integer_token1,
    ACTIONS(5922), 1,
      anon_sym_Set,
    ACTIONS(12075), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12077), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(12079), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(12081), 1,
      aux_sym_string_token1,
    STATE(6076), 1,
      sym_atom,
    STATE(6087), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6089), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(5900), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [575133] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6166), 1,
      sym_id,
    ACTIONS(6170), 1,
      anon_sym_record,
    ACTIONS(6172), 1,
      anon_sym_LPAREN,
    ACTIONS(6176), 1,
      anon_sym_u2983,
    ACTIONS(6178), 1,
      anon_sym_LBRACE,
    ACTIONS(6180), 1,
      aux_sym__qid_token1,
    ACTIONS(6182), 1,
      anon_sym_DOT,
    ACTIONS(6186), 1,
      anon_sym_u2987,
    ACTIONS(6188), 1,
      aux_sym_integer_token1,
    ACTIONS(6190), 1,
      anon_sym_Set,
    ACTIONS(12471), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12473), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(12475), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(12477), 1,
      aux_sym_string_token1,
    STATE(4950), 1,
      sym_atom,
    STATE(4960), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4966), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(6168), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [575208] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(5082), 1,
      sym_id,
    ACTIONS(5086), 1,
      anon_sym_record,
    ACTIONS(5088), 1,
      anon_sym_LPAREN,
    ACTIONS(5092), 1,
      anon_sym_u2983,
    ACTIONS(5094), 1,
      anon_sym_LBRACE,
    ACTIONS(5096), 1,
      aux_sym__qid_token1,
    ACTIONS(5098), 1,
      anon_sym_DOT,
    ACTIONS(5102), 1,
      anon_sym_u2987,
    ACTIONS(5104), 1,
      aux_sym_integer_token1,
    ACTIONS(5106), 1,
      anon_sym_Set,
    ACTIONS(12595), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12597), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(12599), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(12601), 1,
      aux_sym_string_token1,
    STATE(5583), 1,
      sym_atom,
    STATE(5584), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5587), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(5084), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [575283] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(9792), 1,
      sym_id,
    ACTIONS(9794), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9798), 1,
      anon_sym_record,
    ACTIONS(9800), 1,
      anon_sym_LPAREN,
    ACTIONS(9802), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(9804), 1,
      anon_sym_u2983,
    ACTIONS(9806), 1,
      anon_sym_LBRACE,
    ACTIONS(9808), 1,
      aux_sym__qid_token1,
    ACTIONS(9810), 1,
      anon_sym_DOT,
    ACTIONS(9814), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(9816), 1,
      anon_sym_u2987,
    ACTIONS(9818), 1,
      aux_sym_integer_token1,
    ACTIONS(9820), 1,
      aux_sym_string_token1,
    ACTIONS(9822), 1,
      anon_sym_Set,
    STATE(7528), 1,
      sym_atom,
    STATE(7535), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7536), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(9796), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [575358] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(5306), 1,
      sym_id,
    ACTIONS(5310), 1,
      anon_sym_record,
    ACTIONS(5312), 1,
      anon_sym_LPAREN,
    ACTIONS(5316), 1,
      anon_sym_u2983,
    ACTIONS(5318), 1,
      anon_sym_LBRACE,
    ACTIONS(5320), 1,
      aux_sym__qid_token1,
    ACTIONS(5322), 1,
      anon_sym_DOT,
    ACTIONS(5326), 1,
      anon_sym_u2987,
    ACTIONS(5328), 1,
      aux_sym_integer_token1,
    ACTIONS(5330), 1,
      anon_sym_Set,
    ACTIONS(12483), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12485), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(12487), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(12489), 1,
      aux_sym_string_token1,
    STATE(5861), 1,
      sym_atom,
    STATE(5854), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5853), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(5308), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [575433] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2018), 1,
      sym_id,
    ACTIONS(2028), 1,
      anon_sym_record,
    ACTIONS(2038), 1,
      aux_sym__qid_token1,
    ACTIONS(2048), 1,
      anon_sym_u2987,
    ACTIONS(2052), 1,
      aux_sym_integer_token1,
    ACTIONS(2054), 1,
      anon_sym_Set,
    ACTIONS(4706), 1,
      anon_sym_LPAREN,
    ACTIONS(4710), 1,
      anon_sym_u2983,
    ACTIONS(4712), 1,
      anon_sym_LBRACE,
    ACTIONS(4714), 1,
      anon_sym_DOT,
    ACTIONS(12281), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12283), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(12285), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(12287), 1,
      aux_sym_string_token1,
    STATE(5175), 1,
      sym_atom,
    STATE(5176), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5183), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(2026), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [575508] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(5054), 1,
      sym_id,
    ACTIONS(5058), 1,
      anon_sym_record,
    ACTIONS(5060), 1,
      anon_sym_LPAREN,
    ACTIONS(5064), 1,
      anon_sym_u2983,
    ACTIONS(5066), 1,
      anon_sym_LBRACE,
    ACTIONS(5068), 1,
      aux_sym__qid_token1,
    ACTIONS(5070), 1,
      anon_sym_DOT,
    ACTIONS(5074), 1,
      anon_sym_u2987,
    ACTIONS(5076), 1,
      aux_sym_integer_token1,
    ACTIONS(5078), 1,
      anon_sym_Set,
    ACTIONS(12603), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12605), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(12607), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(12609), 1,
      aux_sym_string_token1,
    STATE(4452), 1,
      sym_atom,
    STATE(4453), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4455), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(5056), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [575583] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6138), 1,
      sym_id,
    ACTIONS(6142), 1,
      anon_sym_record,
    ACTIONS(6144), 1,
      anon_sym_LPAREN,
    ACTIONS(6148), 1,
      anon_sym_u2983,
    ACTIONS(6150), 1,
      anon_sym_LBRACE,
    ACTIONS(6152), 1,
      aux_sym__qid_token1,
    ACTIONS(6154), 1,
      anon_sym_DOT,
    ACTIONS(6158), 1,
      anon_sym_u2987,
    ACTIONS(6160), 1,
      aux_sym_integer_token1,
    ACTIONS(6162), 1,
      anon_sym_Set,
    ACTIONS(12611), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12613), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(12615), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(12617), 1,
      aux_sym_string_token1,
    STATE(5119), 1,
      sym_atom,
    STATE(5132), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5134), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(6140), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [575658] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(8123), 1,
      sym_id,
    ACTIONS(8125), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8129), 1,
      anon_sym_record,
    ACTIONS(8131), 1,
      anon_sym_LPAREN,
    ACTIONS(8133), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(8135), 1,
      anon_sym_u2983,
    ACTIONS(8137), 1,
      anon_sym_LBRACE,
    ACTIONS(8139), 1,
      aux_sym__qid_token1,
    ACTIONS(8141), 1,
      anon_sym_DOT,
    ACTIONS(8145), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(8147), 1,
      anon_sym_u2987,
    ACTIONS(8149), 1,
      aux_sym_integer_token1,
    ACTIONS(8151), 1,
      aux_sym_string_token1,
    ACTIONS(8153), 1,
      anon_sym_Set,
    STATE(7218), 1,
      sym_atom,
    STATE(7213), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7209), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(8127), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [575733] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2346), 1,
      sym_id,
    ACTIONS(2356), 1,
      anon_sym_record,
    ACTIONS(2366), 1,
      aux_sym__qid_token1,
    ACTIONS(2376), 1,
      anon_sym_u2987,
    ACTIONS(2380), 1,
      aux_sym_integer_token1,
    ACTIONS(2382), 1,
      anon_sym_Set,
    ACTIONS(4750), 1,
      anon_sym_LPAREN,
    ACTIONS(4754), 1,
      anon_sym_u2983,
    ACTIONS(4756), 1,
      anon_sym_LBRACE,
    ACTIONS(4758), 1,
      anon_sym_DOT,
    ACTIONS(11977), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11987), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11989), 1,
      aux_sym_string_token1,
    ACTIONS(12461), 1,
      anon_sym_LBRACE_LBRACE,
    STATE(4176), 1,
      sym_atom,
    STATE(4180), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4192), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(2354), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [575808] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(5468), 1,
      sym_id,
    ACTIONS(5472), 1,
      anon_sym_record,
    ACTIONS(5474), 1,
      anon_sym_LPAREN,
    ACTIONS(5478), 1,
      anon_sym_u2983,
    ACTIONS(5480), 1,
      anon_sym_LBRACE,
    ACTIONS(5482), 1,
      aux_sym__qid_token1,
    ACTIONS(5484), 1,
      anon_sym_DOT,
    ACTIONS(5488), 1,
      anon_sym_u2987,
    ACTIONS(5490), 1,
      aux_sym_integer_token1,
    ACTIONS(5492), 1,
      anon_sym_Set,
    ACTIONS(11961), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11963), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11965), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11967), 1,
      aux_sym_string_token1,
    STATE(4534), 1,
      sym_atom,
    STATE(4533), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4527), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(5470), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [575883] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(5332), 1,
      sym_id,
    ACTIONS(5336), 1,
      anon_sym_record,
    ACTIONS(5338), 1,
      anon_sym_LPAREN,
    ACTIONS(5342), 1,
      anon_sym_u2983,
    ACTIONS(5344), 1,
      anon_sym_LBRACE,
    ACTIONS(5346), 1,
      aux_sym__qid_token1,
    ACTIONS(5348), 1,
      anon_sym_DOT,
    ACTIONS(5352), 1,
      anon_sym_u2987,
    ACTIONS(5354), 1,
      aux_sym_integer_token1,
    ACTIONS(5356), 1,
      anon_sym_Set,
    ACTIONS(12559), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12561), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(12563), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(12565), 1,
      aux_sym_string_token1,
    STATE(4844), 1,
      sym_atom,
    STATE(4898), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4840), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(5334), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [575958] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(3938), 1,
      sym_id,
    ACTIONS(3942), 1,
      anon_sym_record,
    ACTIONS(3952), 1,
      aux_sym__qid_token1,
    ACTIONS(3958), 1,
      anon_sym_u2987,
    ACTIONS(3960), 1,
      aux_sym_integer_token1,
    ACTIONS(3962), 1,
      anon_sym_Set,
    ACTIONS(4620), 1,
      anon_sym_LPAREN,
    ACTIONS(4624), 1,
      anon_sym_u2983,
    ACTIONS(4626), 1,
      anon_sym_LBRACE,
    ACTIONS(4628), 1,
      anon_sym_DOT,
    ACTIONS(12083), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12085), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(12087), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(12089), 1,
      aux_sym_string_token1,
    STATE(5212), 1,
      sym_atom,
    STATE(5203), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5201), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3940), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [576033] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(8815), 1,
      sym_id,
    ACTIONS(8817), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8821), 1,
      anon_sym_record,
    ACTIONS(8823), 1,
      anon_sym_LPAREN,
    ACTIONS(8825), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(8827), 1,
      anon_sym_u2983,
    ACTIONS(8829), 1,
      anon_sym_LBRACE,
    ACTIONS(8831), 1,
      aux_sym__qid_token1,
    ACTIONS(8833), 1,
      anon_sym_DOT,
    ACTIONS(8837), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(8839), 1,
      anon_sym_u2987,
    ACTIONS(8841), 1,
      aux_sym_integer_token1,
    ACTIONS(8843), 1,
      aux_sym_string_token1,
    ACTIONS(8845), 1,
      anon_sym_Set,
    STATE(7355), 1,
      sym_atom,
    STATE(7354), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7353), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(8819), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [576108] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(5140), 1,
      sym_id,
    ACTIONS(5144), 1,
      anon_sym_record,
    ACTIONS(5146), 1,
      anon_sym_LPAREN,
    ACTIONS(5150), 1,
      anon_sym_u2983,
    ACTIONS(5152), 1,
      anon_sym_LBRACE,
    ACTIONS(5154), 1,
      aux_sym__qid_token1,
    ACTIONS(5156), 1,
      anon_sym_DOT,
    ACTIONS(5160), 1,
      anon_sym_u2987,
    ACTIONS(5162), 1,
      aux_sym_integer_token1,
    ACTIONS(5164), 1,
      anon_sym_Set,
    ACTIONS(12619), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12621), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(12623), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(12625), 1,
      aux_sym_string_token1,
    STATE(5798), 1,
      sym_atom,
    STATE(5797), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5795), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(5142), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [576183] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(3444), 1,
      sym_id,
    ACTIONS(3454), 1,
      anon_sym_record,
    ACTIONS(3464), 1,
      aux_sym__qid_token1,
    ACTIONS(3474), 1,
      anon_sym_u2987,
    ACTIONS(3478), 1,
      aux_sym_integer_token1,
    ACTIONS(3480), 1,
      anon_sym_Set,
    ACTIONS(4850), 1,
      anon_sym_DOT,
    ACTIONS(11511), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11515), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11517), 1,
      aux_sym_string_token1,
    ACTIONS(12627), 1,
      anon_sym_LPAREN,
    ACTIONS(12629), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(12631), 1,
      anon_sym_u2983,
    ACTIONS(12633), 1,
      anon_sym_LBRACE,
    STATE(5014), 1,
      sym_atom,
    STATE(5013), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5000), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3452), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [576258] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(5872), 1,
      sym_id,
    ACTIONS(5876), 1,
      anon_sym_record,
    ACTIONS(5878), 1,
      anon_sym_LPAREN,
    ACTIONS(5882), 1,
      anon_sym_u2983,
    ACTIONS(5884), 1,
      anon_sym_LBRACE,
    ACTIONS(5886), 1,
      aux_sym__qid_token1,
    ACTIONS(5888), 1,
      anon_sym_DOT,
    ACTIONS(5892), 1,
      anon_sym_u2987,
    ACTIONS(5894), 1,
      aux_sym_integer_token1,
    ACTIONS(5896), 1,
      anon_sym_Set,
    ACTIONS(12635), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12637), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(12639), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(12641), 1,
      aux_sym_string_token1,
    STATE(4794), 1,
      sym_atom,
    STATE(4787), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4785), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(5874), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [576333] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(5082), 1,
      sym_id,
    ACTIONS(5086), 1,
      anon_sym_record,
    ACTIONS(5088), 1,
      anon_sym_LPAREN,
    ACTIONS(5092), 1,
      anon_sym_u2983,
    ACTIONS(5094), 1,
      anon_sym_LBRACE,
    ACTIONS(5096), 1,
      aux_sym__qid_token1,
    ACTIONS(5098), 1,
      anon_sym_DOT,
    ACTIONS(5102), 1,
      anon_sym_u2987,
    ACTIONS(5104), 1,
      aux_sym_integer_token1,
    ACTIONS(5106), 1,
      anon_sym_Set,
    ACTIONS(12595), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12597), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(12599), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(12601), 1,
      aux_sym_string_token1,
    STATE(5563), 1,
      sym_atom,
    STATE(5584), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5587), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(5084), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [576408] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(5926), 1,
      sym_id,
    ACTIONS(5930), 1,
      anon_sym_record,
    ACTIONS(5932), 1,
      anon_sym_LPAREN,
    ACTIONS(5936), 1,
      anon_sym_u2983,
    ACTIONS(5938), 1,
      anon_sym_LBRACE,
    ACTIONS(5940), 1,
      aux_sym__qid_token1,
    ACTIONS(5942), 1,
      anon_sym_DOT,
    ACTIONS(5946), 1,
      anon_sym_u2987,
    ACTIONS(5948), 1,
      aux_sym_integer_token1,
    ACTIONS(5950), 1,
      anon_sym_Set,
    ACTIONS(12643), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12645), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(12647), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(12649), 1,
      aux_sym_string_token1,
    STATE(5477), 1,
      sym_atom,
    STATE(5470), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5454), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(5928), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [576483] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(4976), 1,
      sym_id,
    ACTIONS(4980), 1,
      anon_sym_record,
    ACTIONS(4982), 1,
      anon_sym_LPAREN,
    ACTIONS(4986), 1,
      anon_sym_u2983,
    ACTIONS(4988), 1,
      anon_sym_LBRACE,
    ACTIONS(4990), 1,
      aux_sym__qid_token1,
    ACTIONS(4992), 1,
      anon_sym_DOT,
    ACTIONS(4996), 1,
      anon_sym_u2987,
    ACTIONS(4998), 1,
      aux_sym_integer_token1,
    ACTIONS(5000), 1,
      anon_sym_Set,
    ACTIONS(11875), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11877), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11879), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11881), 1,
      aux_sym_string_token1,
    STATE(6127), 1,
      sym_atom,
    STATE(6124), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6161), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(4978), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [576558] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(8993), 1,
      sym_id,
    ACTIONS(8995), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8999), 1,
      anon_sym_record,
    ACTIONS(9001), 1,
      anon_sym_LPAREN,
    ACTIONS(9003), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(9005), 1,
      anon_sym_u2983,
    ACTIONS(9007), 1,
      anon_sym_LBRACE,
    ACTIONS(9009), 1,
      aux_sym__qid_token1,
    ACTIONS(9011), 1,
      anon_sym_DOT,
    ACTIONS(9015), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(9017), 1,
      anon_sym_u2987,
    ACTIONS(9019), 1,
      aux_sym_integer_token1,
    ACTIONS(9021), 1,
      aux_sym_string_token1,
    ACTIONS(9023), 1,
      anon_sym_Set,
    STATE(7304), 1,
      sym_atom,
    STATE(7305), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7306), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(8997), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [576633] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(3016), 1,
      sym_id,
    ACTIONS(3026), 1,
      anon_sym_record,
    ACTIONS(3036), 1,
      aux_sym__qid_token1,
    ACTIONS(3046), 1,
      anon_sym_u2987,
    ACTIONS(3050), 1,
      aux_sym_integer_token1,
    ACTIONS(3052), 1,
      anon_sym_Set,
    ACTIONS(4614), 1,
      anon_sym_DOT,
    ACTIONS(12191), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12195), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(12197), 1,
      aux_sym_string_token1,
    ACTIONS(12651), 1,
      anon_sym_LPAREN,
    ACTIONS(12653), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(12655), 1,
      anon_sym_u2983,
    ACTIONS(12657), 1,
      anon_sym_LBRACE,
    STATE(5329), 1,
      sym_atom,
    STATE(5330), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5333), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3024), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [576708] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1980), 1,
      sym_id,
    ACTIONS(1990), 1,
      anon_sym_record,
    ACTIONS(2000), 1,
      aux_sym__qid_token1,
    ACTIONS(2010), 1,
      anon_sym_u2987,
    ACTIONS(2014), 1,
      aux_sym_integer_token1,
    ACTIONS(2016), 1,
      anon_sym_Set,
    ACTIONS(4394), 1,
      anon_sym_DOT,
    ACTIONS(12369), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12373), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(12375), 1,
      aux_sym_string_token1,
    ACTIONS(12659), 1,
      anon_sym_LPAREN,
    ACTIONS(12661), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(12663), 1,
      anon_sym_u2983,
    ACTIONS(12665), 1,
      anon_sym_LBRACE,
    STATE(5337), 1,
      sym_atom,
    STATE(5336), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5185), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(1988), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [576783] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(8815), 1,
      sym_id,
    ACTIONS(8817), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8821), 1,
      anon_sym_record,
    ACTIONS(8823), 1,
      anon_sym_LPAREN,
    ACTIONS(8825), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(8827), 1,
      anon_sym_u2983,
    ACTIONS(8829), 1,
      anon_sym_LBRACE,
    ACTIONS(8831), 1,
      aux_sym__qid_token1,
    ACTIONS(8833), 1,
      anon_sym_DOT,
    ACTIONS(8837), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(8839), 1,
      anon_sym_u2987,
    ACTIONS(8841), 1,
      aux_sym_integer_token1,
    ACTIONS(8843), 1,
      aux_sym_string_token1,
    ACTIONS(8845), 1,
      anon_sym_Set,
    STATE(7362), 1,
      sym_atom,
    STATE(7354), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7353), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(8819), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [576858] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(10289), 1,
      sym_id,
    ACTIONS(10291), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10295), 1,
      anon_sym_record,
    ACTIONS(10297), 1,
      anon_sym_LPAREN,
    ACTIONS(10299), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(10301), 1,
      anon_sym_u2983,
    ACTIONS(10303), 1,
      anon_sym_LBRACE,
    ACTIONS(10305), 1,
      aux_sym__qid_token1,
    ACTIONS(10307), 1,
      anon_sym_DOT,
    ACTIONS(10311), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(10313), 1,
      anon_sym_u2987,
    ACTIONS(10315), 1,
      aux_sym_integer_token1,
    ACTIONS(10317), 1,
      aux_sym_string_token1,
    ACTIONS(10319), 1,
      anon_sym_Set,
    STATE(7774), 1,
      sym_atom,
    STATE(7770), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7764), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(10293), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [576933] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6872), 1,
      sym_id,
    ACTIONS(6874), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6878), 1,
      anon_sym_record,
    ACTIONS(6884), 1,
      anon_sym_LPAREN,
    ACTIONS(6888), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(6890), 1,
      anon_sym_u2983,
    ACTIONS(6892), 1,
      anon_sym_LBRACE,
    ACTIONS(6894), 1,
      aux_sym__qid_token1,
    ACTIONS(6896), 1,
      anon_sym_DOT,
    ACTIONS(6900), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(6902), 1,
      anon_sym_u2987,
    ACTIONS(6904), 1,
      aux_sym_integer_token1,
    ACTIONS(6906), 1,
      aux_sym_string_token1,
    ACTIONS(6908), 1,
      anon_sym_Set,
    STATE(7248), 1,
      sym_atom,
    STATE(7255), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7256), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(6876), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [577008] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2272), 1,
      sym_id,
    ACTIONS(2276), 1,
      anon_sym_record,
    ACTIONS(2286), 1,
      aux_sym__qid_token1,
    ACTIONS(2292), 1,
      anon_sym_u2987,
    ACTIONS(2294), 1,
      aux_sym_integer_token1,
    ACTIONS(2296), 1,
      anon_sym_Set,
    ACTIONS(4800), 1,
      anon_sym_LPAREN,
    ACTIONS(4804), 1,
      anon_sym_u2983,
    ACTIONS(4806), 1,
      anon_sym_LBRACE,
    ACTIONS(4808), 1,
      anon_sym_DOT,
    ACTIONS(12137), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12147), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(12149), 1,
      aux_sym_string_token1,
    ACTIONS(12225), 1,
      anon_sym_LBRACE_LBRACE,
    STATE(5138), 1,
      sym_atom,
    STATE(5139), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5053), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(2274), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [577083] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(5002), 1,
      sym_id,
    ACTIONS(5006), 1,
      anon_sym_record,
    ACTIONS(5008), 1,
      anon_sym_LPAREN,
    ACTIONS(5012), 1,
      anon_sym_u2983,
    ACTIONS(5014), 1,
      anon_sym_LBRACE,
    ACTIONS(5016), 1,
      aux_sym__qid_token1,
    ACTIONS(5018), 1,
      anon_sym_DOT,
    ACTIONS(5022), 1,
      anon_sym_u2987,
    ACTIONS(5024), 1,
      aux_sym_integer_token1,
    ACTIONS(5026), 1,
      anon_sym_Set,
    ACTIONS(12517), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12519), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(12521), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(12523), 1,
      aux_sym_string_token1,
    STATE(5825), 1,
      sym_atom,
    STATE(5805), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5804), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(5004), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [577158] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1866), 1,
      sym_id,
    ACTIONS(1876), 1,
      anon_sym_record,
    ACTIONS(1886), 1,
      aux_sym__qid_token1,
    ACTIONS(1896), 1,
      anon_sym_u2987,
    ACTIONS(1900), 1,
      aux_sym_integer_token1,
    ACTIONS(1902), 1,
      anon_sym_Set,
    ACTIONS(4884), 1,
      anon_sym_LPAREN,
    ACTIONS(4888), 1,
      anon_sym_u2983,
    ACTIONS(4890), 1,
      anon_sym_LBRACE,
    ACTIONS(4892), 1,
      anon_sym_DOT,
    ACTIONS(12257), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12267), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(12269), 1,
      aux_sym_string_token1,
    ACTIONS(12449), 1,
      anon_sym_LBRACE_LBRACE,
    STATE(4265), 1,
      sym_atom,
    STATE(4264), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4263), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(1874), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [577233] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1206), 1,
      sym_id,
    ACTIONS(1216), 1,
      anon_sym_record,
    ACTIONS(1226), 1,
      aux_sym__qid_token1,
    ACTIONS(1236), 1,
      anon_sym_u2987,
    ACTIONS(1240), 1,
      aux_sym_integer_token1,
    ACTIONS(1242), 1,
      anon_sym_Set,
    ACTIONS(4908), 1,
      anon_sym_LPAREN,
    ACTIONS(4912), 1,
      anon_sym_u2983,
    ACTIONS(4914), 1,
      anon_sym_LBRACE,
    ACTIONS(4916), 1,
      anon_sym_DOT,
    ACTIONS(11899), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11901), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11903), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11905), 1,
      aux_sym_string_token1,
    STATE(5653), 1,
      sym_atom,
    STATE(5661), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5664), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(1214), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [577308] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1976), 1,
      aux_sym_integer_token1,
    ACTIONS(1978), 1,
      anon_sym_Set,
    ACTIONS(4424), 1,
      anon_sym_LPAREN,
    ACTIONS(4428), 1,
      anon_sym_u2983,
    ACTIONS(4430), 1,
      anon_sym_LBRACE,
    ACTIONS(4432), 1,
      anon_sym_DOT,
    ACTIONS(11907), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11917), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11919), 1,
      aux_sym_string_token1,
    ACTIONS(12667), 1,
      anon_sym_LBRACE_LBRACE,
    STATE(5493), 1,
      sym_atom,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(1950), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [577383] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(3786), 1,
      sym_id,
    ACTIONS(3792), 1,
      anon_sym_record,
    ACTIONS(3794), 1,
      anon_sym_LPAREN,
    ACTIONS(3798), 1,
      anon_sym_u2983,
    ACTIONS(3800), 1,
      anon_sym_LBRACE,
    ACTIONS(3802), 1,
      aux_sym__qid_token1,
    ACTIONS(3804), 1,
      anon_sym_DOT,
    ACTIONS(3808), 1,
      anon_sym_u2987,
    ACTIONS(3810), 1,
      aux_sym_integer_token1,
    ACTIONS(3812), 1,
      anon_sym_Set,
    ACTIONS(12669), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12671), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(12673), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(12675), 1,
      aux_sym_string_token1,
    STATE(4290), 1,
      sym_atom,
    STATE(4284), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4282), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3790), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [577458] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(10289), 1,
      sym_id,
    ACTIONS(10291), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10295), 1,
      anon_sym_record,
    ACTIONS(10297), 1,
      anon_sym_LPAREN,
    ACTIONS(10299), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(10301), 1,
      anon_sym_u2983,
    ACTIONS(10303), 1,
      anon_sym_LBRACE,
    ACTIONS(10305), 1,
      aux_sym__qid_token1,
    ACTIONS(10307), 1,
      anon_sym_DOT,
    ACTIONS(10311), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(10313), 1,
      anon_sym_u2987,
    ACTIONS(10315), 1,
      aux_sym_integer_token1,
    ACTIONS(10317), 1,
      aux_sym_string_token1,
    ACTIONS(10319), 1,
      anon_sym_Set,
    STATE(7795), 1,
      sym_atom,
    STATE(7770), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7764), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(10293), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [577533] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(3760), 1,
      sym_id,
    ACTIONS(3764), 1,
      anon_sym_record,
    ACTIONS(3774), 1,
      aux_sym__qid_token1,
    ACTIONS(3780), 1,
      anon_sym_u2987,
    ACTIONS(3782), 1,
      aux_sym_integer_token1,
    ACTIONS(3784), 1,
      anon_sym_Set,
    ACTIONS(4824), 1,
      anon_sym_DOT,
    ACTIONS(11565), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11569), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11571), 1,
      aux_sym_string_token1,
    ACTIONS(12677), 1,
      anon_sym_LPAREN,
    ACTIONS(12679), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(12681), 1,
      anon_sym_u2983,
    ACTIONS(12683), 1,
      anon_sym_LBRACE,
    STATE(4624), 1,
      sym_atom,
    STATE(4599), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4613), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3762), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [577608] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2384), 1,
      sym_id,
    ACTIONS(2394), 1,
      anon_sym_record,
    ACTIONS(2404), 1,
      aux_sym__qid_token1,
    ACTIONS(2414), 1,
      anon_sym_u2987,
    ACTIONS(2418), 1,
      aux_sym_integer_token1,
    ACTIONS(2420), 1,
      anon_sym_Set,
    ACTIONS(4570), 1,
      anon_sym_LPAREN,
    ACTIONS(4574), 1,
      anon_sym_u2983,
    ACTIONS(4576), 1,
      anon_sym_LBRACE,
    ACTIONS(4578), 1,
      anon_sym_DOT,
    ACTIONS(12091), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12101), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(12103), 1,
      aux_sym_string_token1,
    ACTIONS(12113), 1,
      anon_sym_LBRACE_LBRACE,
    STATE(4843), 1,
      sym_atom,
    STATE(4831), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4896), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(2392), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [577683] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6112), 1,
      sym_id,
    ACTIONS(6116), 1,
      anon_sym_record,
    ACTIONS(6118), 1,
      anon_sym_LPAREN,
    ACTIONS(6122), 1,
      anon_sym_u2983,
    ACTIONS(6124), 1,
      anon_sym_LBRACE,
    ACTIONS(6126), 1,
      aux_sym__qid_token1,
    ACTIONS(6128), 1,
      anon_sym_DOT,
    ACTIONS(6132), 1,
      anon_sym_u2987,
    ACTIONS(6134), 1,
      aux_sym_integer_token1,
    ACTIONS(6136), 1,
      anon_sym_Set,
    ACTIONS(12685), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12687), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(12689), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(12691), 1,
      aux_sym_string_token1,
    STATE(5820), 1,
      sym_atom,
    STATE(5819), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5817), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(6114), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [577758] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2806), 1,
      sym_id,
    ACTIONS(2816), 1,
      anon_sym_record,
    ACTIONS(2818), 1,
      anon_sym_LPAREN,
    ACTIONS(2822), 1,
      anon_sym_u2983,
    ACTIONS(2824), 1,
      anon_sym_LBRACE,
    ACTIONS(2826), 1,
      aux_sym__qid_token1,
    ACTIONS(2828), 1,
      anon_sym_DOT,
    ACTIONS(2834), 1,
      anon_sym_u2987,
    ACTIONS(2836), 1,
      aux_sym_integer_token1,
    ACTIONS(2838), 1,
      anon_sym_Set,
    ACTIONS(12693), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12695), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(12697), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(12699), 1,
      aux_sym_string_token1,
    STATE(5987), 1,
      sym_atom,
    STATE(5982), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5981), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(2814), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [577833] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(3666), 1,
      sym_id,
    ACTIONS(3672), 1,
      anon_sym_record,
    ACTIONS(3674), 1,
      anon_sym_LPAREN,
    ACTIONS(3678), 1,
      anon_sym_u2983,
    ACTIONS(3680), 1,
      anon_sym_LBRACE,
    ACTIONS(3682), 1,
      aux_sym__qid_token1,
    ACTIONS(3684), 1,
      anon_sym_DOT,
    ACTIONS(3688), 1,
      anon_sym_u2987,
    ACTIONS(3690), 1,
      aux_sym_integer_token1,
    ACTIONS(3692), 1,
      anon_sym_Set,
    ACTIONS(12701), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12703), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(12705), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(12707), 1,
      aux_sym_string_token1,
    STATE(4593), 1,
      sym_atom,
    STATE(4585), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4584), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3670), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [577908] = 3,
    ACTIONS(6655), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6653), 31,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [577949] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(894), 1,
      sym_id,
    ACTIONS(904), 1,
      anon_sym_record,
    ACTIONS(916), 1,
      aux_sym__qid_token1,
    ACTIONS(926), 1,
      anon_sym_u2987,
    ACTIONS(930), 1,
      aux_sym_integer_token1,
    ACTIONS(932), 1,
      anon_sym_Set,
    ACTIONS(4320), 1,
      anon_sym_LPAREN,
    ACTIONS(4324), 1,
      anon_sym_u2983,
    ACTIONS(4326), 1,
      anon_sym_LBRACE,
    ACTIONS(4328), 1,
      anon_sym_DOT,
    ACTIONS(11651), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11661), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11663), 1,
      aux_sym_string_token1,
    ACTIONS(12153), 1,
      anon_sym_LBRACE_LBRACE,
    STATE(4973), 1,
      sym_atom,
    STATE(4961), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4920), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(902), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [578024] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2614), 1,
      sym_id,
    ACTIONS(2624), 1,
      anon_sym_record,
    ACTIONS(2634), 1,
      aux_sym__qid_token1,
    ACTIONS(2644), 1,
      anon_sym_u2987,
    ACTIONS(2648), 1,
      aux_sym_integer_token1,
    ACTIONS(2650), 1,
      anon_sym_Set,
    ACTIONS(4898), 1,
      anon_sym_LPAREN,
    ACTIONS(4902), 1,
      anon_sym_u2983,
    ACTIONS(4904), 1,
      anon_sym_LBRACE,
    ACTIONS(4906), 1,
      anon_sym_DOT,
    ACTIONS(11885), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11895), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11897), 1,
      aux_sym_string_token1,
    ACTIONS(12181), 1,
      anon_sym_LBRACE_LBRACE,
    STATE(4801), 1,
      sym_atom,
    STATE(4799), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4784), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(2622), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [578099] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(5630), 1,
      sym_id,
    ACTIONS(5634), 1,
      anon_sym_record,
    ACTIONS(5636), 1,
      anon_sym_LPAREN,
    ACTIONS(5640), 1,
      anon_sym_u2983,
    ACTIONS(5642), 1,
      anon_sym_LBRACE,
    ACTIONS(5644), 1,
      aux_sym__qid_token1,
    ACTIONS(5646), 1,
      anon_sym_DOT,
    ACTIONS(5650), 1,
      anon_sym_u2987,
    ACTIONS(5652), 1,
      aux_sym_integer_token1,
    ACTIONS(5654), 1,
      anon_sym_Set,
    ACTIONS(12183), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12185), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(12187), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(12189), 1,
      aux_sym_string_token1,
    STATE(5732), 1,
      sym_atom,
    STATE(5733), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5727), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(5632), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [578174] = 3,
    ACTIONS(6484), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6482), 31,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [578215] = 3,
    ACTIONS(6710), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6708), 31,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [578256] = 3,
    ACTIONS(6750), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6748), 31,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [578297] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2728), 1,
      sym_id,
    ACTIONS(2738), 1,
      anon_sym_record,
    ACTIONS(2748), 1,
      aux_sym__qid_token1,
    ACTIONS(2758), 1,
      anon_sym_u2987,
    ACTIONS(2762), 1,
      aux_sym_integer_token1,
    ACTIONS(2764), 1,
      anon_sym_Set,
    ACTIONS(4762), 1,
      anon_sym_LPAREN,
    ACTIONS(4766), 1,
      anon_sym_u2983,
    ACTIONS(4768), 1,
      anon_sym_LBRACE,
    ACTIONS(4770), 1,
      anon_sym_DOT,
    ACTIONS(12425), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12427), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(12429), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(12431), 1,
      aux_sym_string_token1,
    STATE(4686), 1,
      sym_atom,
    STATE(4685), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4682), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(2736), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [578372] = 3,
    ACTIONS(6433), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6431), 31,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [578413] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(7914), 1,
      sym_id,
    ACTIONS(7916), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7920), 1,
      anon_sym_record,
    ACTIONS(7922), 1,
      anon_sym_LPAREN,
    ACTIONS(7924), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(7926), 1,
      anon_sym_u2983,
    ACTIONS(7928), 1,
      anon_sym_LBRACE,
    ACTIONS(7930), 1,
      aux_sym__qid_token1,
    ACTIONS(7932), 1,
      anon_sym_DOT,
    ACTIONS(7936), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(7938), 1,
      anon_sym_u2987,
    ACTIONS(7940), 1,
      aux_sym_integer_token1,
    ACTIONS(7942), 1,
      aux_sym_string_token1,
    ACTIONS(7944), 1,
      anon_sym_Set,
    STATE(7241), 1,
      sym_atom,
    STATE(7212), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7249), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(7918), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [578488] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2806), 1,
      sym_id,
    ACTIONS(2816), 1,
      anon_sym_record,
    ACTIONS(2818), 1,
      anon_sym_LPAREN,
    ACTIONS(2822), 1,
      anon_sym_u2983,
    ACTIONS(2824), 1,
      anon_sym_LBRACE,
    ACTIONS(2826), 1,
      aux_sym__qid_token1,
    ACTIONS(2828), 1,
      anon_sym_DOT,
    ACTIONS(2834), 1,
      anon_sym_u2987,
    ACTIONS(2836), 1,
      aux_sym_integer_token1,
    ACTIONS(2838), 1,
      anon_sym_Set,
    ACTIONS(12693), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12695), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(12697), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(12699), 1,
      aux_sym_string_token1,
    STATE(5983), 1,
      sym_atom,
    STATE(5982), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5981), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(2814), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [578563] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(5140), 1,
      sym_id,
    ACTIONS(5144), 1,
      anon_sym_record,
    ACTIONS(5146), 1,
      anon_sym_LPAREN,
    ACTIONS(5150), 1,
      anon_sym_u2983,
    ACTIONS(5152), 1,
      anon_sym_LBRACE,
    ACTIONS(5154), 1,
      aux_sym__qid_token1,
    ACTIONS(5156), 1,
      anon_sym_DOT,
    ACTIONS(5160), 1,
      anon_sym_u2987,
    ACTIONS(5162), 1,
      aux_sym_integer_token1,
    ACTIONS(5164), 1,
      anon_sym_Set,
    ACTIONS(12619), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12621), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(12623), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(12625), 1,
      aux_sym_string_token1,
    STATE(5803), 1,
      sym_atom,
    STATE(5797), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5795), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(5142), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [578638] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(8405), 1,
      sym_id,
    ACTIONS(8407), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8411), 1,
      anon_sym_record,
    ACTIONS(8413), 1,
      anon_sym_LPAREN,
    ACTIONS(8415), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(8417), 1,
      anon_sym_u2983,
    ACTIONS(8419), 1,
      anon_sym_LBRACE,
    ACTIONS(8421), 1,
      aux_sym__qid_token1,
    ACTIONS(8423), 1,
      anon_sym_DOT,
    ACTIONS(8427), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(8429), 1,
      anon_sym_u2987,
    ACTIONS(8431), 1,
      aux_sym_integer_token1,
    ACTIONS(8433), 1,
      aux_sym_string_token1,
    ACTIONS(8435), 1,
      anon_sym_Set,
    STATE(7440), 1,
      sym_atom,
    STATE(7446), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7448), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(8409), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [578713] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2652), 1,
      sym_id,
    ACTIONS(2662), 1,
      anon_sym_record,
    ACTIONS(2672), 1,
      aux_sym__qid_token1,
    ACTIONS(2682), 1,
      anon_sym_u2987,
    ACTIONS(2686), 1,
      aux_sym_integer_token1,
    ACTIONS(2688), 1,
      anon_sym_Set,
    ACTIONS(4524), 1,
      anon_sym_LPAREN,
    ACTIONS(4528), 1,
      anon_sym_u2983,
    ACTIONS(4530), 1,
      anon_sym_LBRACE,
    ACTIONS(4532), 1,
      anon_sym_DOT,
    ACTIONS(12053), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12063), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(12065), 1,
      aux_sym_string_token1,
    ACTIONS(12331), 1,
      anon_sym_LBRACE_LBRACE,
    STATE(4725), 1,
      sym_atom,
    STATE(4732), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4735), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(2660), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [578788] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(5978), 1,
      sym_id,
    ACTIONS(5982), 1,
      anon_sym_record,
    ACTIONS(5984), 1,
      anon_sym_LPAREN,
    ACTIONS(5988), 1,
      anon_sym_u2983,
    ACTIONS(5990), 1,
      anon_sym_LBRACE,
    ACTIONS(5992), 1,
      aux_sym__qid_token1,
    ACTIONS(5994), 1,
      anon_sym_DOT,
    ACTIONS(5998), 1,
      anon_sym_u2987,
    ACTIONS(6000), 1,
      aux_sym_integer_token1,
    ACTIONS(6002), 1,
      anon_sym_Set,
    ACTIONS(12709), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12711), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(12713), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(12715), 1,
      aux_sym_string_token1,
    STATE(5764), 1,
      sym_atom,
    STATE(5765), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5767), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(5980), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [578863] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2488), 1,
      sym_id,
    ACTIONS(2498), 1,
      anon_sym_record,
    ACTIONS(2508), 1,
      aux_sym__qid_token1,
    ACTIONS(2518), 1,
      anon_sym_u2987,
    ACTIONS(2522), 1,
      aux_sym_integer_token1,
    ACTIONS(2524), 1,
      anon_sym_Set,
    ACTIONS(4514), 1,
      anon_sym_DOT,
    ACTIONS(11635), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11639), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11641), 1,
      aux_sym_string_token1,
    ACTIONS(12717), 1,
      anon_sym_LPAREN,
    ACTIONS(12719), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(12721), 1,
      anon_sym_u2983,
    ACTIONS(12723), 1,
      anon_sym_LBRACE,
    STATE(5696), 1,
      sym_atom,
    STATE(5713), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5698), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(2496), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [578938] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(5952), 1,
      sym_id,
    ACTIONS(5956), 1,
      anon_sym_record,
    ACTIONS(5958), 1,
      anon_sym_LPAREN,
    ACTIONS(5962), 1,
      anon_sym_u2983,
    ACTIONS(5964), 1,
      anon_sym_LBRACE,
    ACTIONS(5966), 1,
      aux_sym__qid_token1,
    ACTIONS(5968), 1,
      anon_sym_DOT,
    ACTIONS(5972), 1,
      anon_sym_u2987,
    ACTIONS(5974), 1,
      aux_sym_integer_token1,
    ACTIONS(5976), 1,
      anon_sym_Set,
    ACTIONS(12575), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12577), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(12579), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(12581), 1,
      aux_sym_string_token1,
    STATE(6196), 1,
      sym_atom,
    STATE(6213), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6217), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(5954), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [579013] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(5926), 1,
      sym_id,
    ACTIONS(5930), 1,
      anon_sym_record,
    ACTIONS(5932), 1,
      anon_sym_LPAREN,
    ACTIONS(5936), 1,
      anon_sym_u2983,
    ACTIONS(5938), 1,
      anon_sym_LBRACE,
    ACTIONS(5940), 1,
      aux_sym__qid_token1,
    ACTIONS(5942), 1,
      anon_sym_DOT,
    ACTIONS(5946), 1,
      anon_sym_u2987,
    ACTIONS(5948), 1,
      aux_sym_integer_token1,
    ACTIONS(5950), 1,
      anon_sym_Set,
    ACTIONS(12643), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12645), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(12647), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(12649), 1,
      aux_sym_string_token1,
    STATE(5473), 1,
      sym_atom,
    STATE(5470), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5454), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(5928), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [579088] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(10679), 1,
      sym_id,
    ACTIONS(10681), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10685), 1,
      anon_sym_record,
    ACTIONS(10687), 1,
      anon_sym_LPAREN,
    ACTIONS(10689), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(10691), 1,
      anon_sym_u2983,
    ACTIONS(10693), 1,
      anon_sym_LBRACE,
    ACTIONS(10695), 1,
      aux_sym__qid_token1,
    ACTIONS(10697), 1,
      anon_sym_DOT,
    ACTIONS(10701), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(10703), 1,
      anon_sym_u2987,
    ACTIONS(10705), 1,
      aux_sym_integer_token1,
    ACTIONS(10707), 1,
      aux_sym_string_token1,
    ACTIONS(10709), 1,
      anon_sym_Set,
    STATE(7682), 1,
      sym_atom,
    STATE(7700), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7701), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(10683), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [579163] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6086), 1,
      sym_id,
    ACTIONS(6090), 1,
      anon_sym_record,
    ACTIONS(6092), 1,
      anon_sym_LPAREN,
    ACTIONS(6096), 1,
      anon_sym_u2983,
    ACTIONS(6098), 1,
      anon_sym_LBRACE,
    ACTIONS(6100), 1,
      aux_sym__qid_token1,
    ACTIONS(6102), 1,
      anon_sym_DOT,
    ACTIONS(6106), 1,
      anon_sym_u2987,
    ACTIONS(6108), 1,
      aux_sym_integer_token1,
    ACTIONS(6110), 1,
      anon_sym_Set,
    ACTIONS(12725), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12727), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(12729), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(12731), 1,
      aux_sym_string_token1,
    STATE(4515), 1,
      sym_atom,
    STATE(4522), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4523), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(6088), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [579238] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(7065), 1,
      sym_id,
    ACTIONS(7067), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7071), 1,
      anon_sym_record,
    ACTIONS(7073), 1,
      anon_sym_LPAREN,
    ACTIONS(7075), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(7077), 1,
      anon_sym_u2983,
    ACTIONS(7079), 1,
      anon_sym_LBRACE,
    ACTIONS(7081), 1,
      aux_sym__qid_token1,
    ACTIONS(7083), 1,
      anon_sym_DOT,
    ACTIONS(7087), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(7089), 1,
      anon_sym_u2987,
    ACTIONS(7091), 1,
      aux_sym_integer_token1,
    ACTIONS(7093), 1,
      aux_sym_string_token1,
    ACTIONS(7095), 1,
      anon_sym_Set,
    STATE(6930), 1,
      sym_atom,
    STATE(6955), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6945), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(7069), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [579313] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(3444), 1,
      sym_id,
    ACTIONS(3454), 1,
      anon_sym_record,
    ACTIONS(3464), 1,
      aux_sym__qid_token1,
    ACTIONS(3474), 1,
      anon_sym_u2987,
    ACTIONS(3478), 1,
      aux_sym_integer_token1,
    ACTIONS(3480), 1,
      anon_sym_Set,
    ACTIONS(4842), 1,
      anon_sym_LPAREN,
    ACTIONS(4846), 1,
      anon_sym_u2983,
    ACTIONS(4848), 1,
      anon_sym_LBRACE,
    ACTIONS(4850), 1,
      anon_sym_DOT,
    ACTIONS(11511), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11513), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11515), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11517), 1,
      aux_sym_string_token1,
    STATE(5023), 1,
      sym_atom,
    STATE(5013), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5000), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3452), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [579388] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(3610), 1,
      sym_id,
    ACTIONS(3616), 1,
      anon_sym_record,
    ACTIONS(3618), 1,
      anon_sym_LPAREN,
    ACTIONS(3622), 1,
      anon_sym_u2983,
    ACTIONS(3624), 1,
      anon_sym_LBRACE,
    ACTIONS(3626), 1,
      aux_sym__qid_token1,
    ACTIONS(3628), 1,
      anon_sym_DOT,
    ACTIONS(3632), 1,
      anon_sym_u2987,
    ACTIONS(3634), 1,
      aux_sym_integer_token1,
    ACTIONS(3636), 1,
      anon_sym_Set,
    ACTIONS(12209), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12211), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(12213), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(12215), 1,
      aux_sym_string_token1,
    STATE(5262), 1,
      sym_atom,
    STATE(5254), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5242), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3614), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [579463] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(734), 1,
      sym_id,
    ACTIONS(744), 1,
      anon_sym_record,
    ACTIONS(754), 1,
      aux_sym__qid_token1,
    ACTIONS(768), 1,
      anon_sym_u2987,
    ACTIONS(772), 1,
      aux_sym_integer_token1,
    ACTIONS(774), 1,
      anon_sym_Set,
    ACTIONS(4228), 1,
      anon_sym_LPAREN,
    ACTIONS(4232), 1,
      anon_sym_u2983,
    ACTIONS(4234), 1,
      anon_sym_LBRACE,
    ACTIONS(4236), 1,
      anon_sym_DOT,
    ACTIONS(11489), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11499), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11501), 1,
      aux_sym_string_token1,
    ACTIONS(12305), 1,
      anon_sym_LBRACE_LBRACE,
    STATE(5098), 1,
      sym_atom,
    STATE(5108), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5102), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(742), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [579538] = 3,
    ACTIONS(6714), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6712), 31,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [579579] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2462), 1,
      sym_id,
    ACTIONS(2466), 1,
      anon_sym_record,
    ACTIONS(2476), 1,
      aux_sym__qid_token1,
    ACTIONS(2482), 1,
      anon_sym_u2987,
    ACTIONS(2484), 1,
      aux_sym_integer_token1,
    ACTIONS(2486), 1,
      anon_sym_Set,
    ACTIONS(4678), 1,
      anon_sym_LPAREN,
    ACTIONS(4682), 1,
      anon_sym_u2983,
    ACTIONS(4684), 1,
      anon_sym_LBRACE,
    ACTIONS(4686), 1,
      anon_sym_DOT,
    ACTIONS(11413), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11423), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11425), 1,
      aux_sym_string_token1,
    ACTIONS(12007), 1,
      anon_sym_LBRACE_LBRACE,
    STATE(4043), 1,
      sym_atom,
    STATE(4044), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4052), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(2464), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [579654] = 3,
    ACTIONS(6754), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6752), 31,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [579695] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(5112), 1,
      sym_id,
    ACTIONS(5116), 1,
      anon_sym_record,
    ACTIONS(5118), 1,
      anon_sym_LPAREN,
    ACTIONS(5122), 1,
      anon_sym_u2983,
    ACTIONS(5124), 1,
      anon_sym_LBRACE,
    ACTIONS(5126), 1,
      aux_sym__qid_token1,
    ACTIONS(5128), 1,
      anon_sym_DOT,
    ACTIONS(5132), 1,
      anon_sym_u2987,
    ACTIONS(5134), 1,
      aux_sym_integer_token1,
    ACTIONS(5136), 1,
      anon_sym_Set,
    ACTIONS(11405), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11407), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11409), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11411), 1,
      aux_sym_string_token1,
    STATE(6006), 1,
      sym_atom,
    STATE(6010), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6007), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(5114), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [579770] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(9029), 1,
      sym_id,
    ACTIONS(9031), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9035), 1,
      anon_sym_record,
    ACTIONS(9037), 1,
      anon_sym_LPAREN,
    ACTIONS(9039), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(9041), 1,
      anon_sym_u2983,
    ACTIONS(9043), 1,
      anon_sym_LBRACE,
    ACTIONS(9045), 1,
      aux_sym__qid_token1,
    ACTIONS(9047), 1,
      anon_sym_DOT,
    ACTIONS(9049), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(9051), 1,
      anon_sym_u2987,
    ACTIONS(9053), 1,
      aux_sym_integer_token1,
    ACTIONS(9055), 1,
      aux_sym_string_token1,
    ACTIONS(9057), 1,
      anon_sym_Set,
    STATE(7336), 1,
      sym_atom,
    STATE(7312), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7309), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(9033), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [579845] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(5574), 1,
      sym_id,
    ACTIONS(5578), 1,
      anon_sym_record,
    ACTIONS(5580), 1,
      anon_sym_LPAREN,
    ACTIONS(5584), 1,
      anon_sym_u2983,
    ACTIONS(5586), 1,
      anon_sym_LBRACE,
    ACTIONS(5588), 1,
      aux_sym__qid_token1,
    ACTIONS(5590), 1,
      anon_sym_DOT,
    ACTIONS(5594), 1,
      anon_sym_u2987,
    ACTIONS(5596), 1,
      aux_sym_integer_token1,
    ACTIONS(5598), 1,
      anon_sym_Set,
    ACTIONS(12583), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12585), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(12587), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(12589), 1,
      aux_sym_string_token1,
    STATE(4319), 1,
      sym_atom,
    STATE(4312), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4307), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(5576), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [579920] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(9029), 1,
      sym_id,
    ACTIONS(9031), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9035), 1,
      anon_sym_record,
    ACTIONS(9037), 1,
      anon_sym_LPAREN,
    ACTIONS(9039), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(9041), 1,
      anon_sym_u2983,
    ACTIONS(9043), 1,
      anon_sym_LBRACE,
    ACTIONS(9045), 1,
      aux_sym__qid_token1,
    ACTIONS(9047), 1,
      anon_sym_DOT,
    ACTIONS(9049), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(9051), 1,
      anon_sym_u2987,
    ACTIONS(9053), 1,
      aux_sym_integer_token1,
    ACTIONS(9055), 1,
      aux_sym_string_token1,
    ACTIONS(9057), 1,
      anon_sym_Set,
    STATE(7313), 1,
      sym_atom,
    STATE(7312), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7309), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(9033), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [579995] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(3262), 1,
      sym_id,
    ACTIONS(3272), 1,
      anon_sym_record,
    ACTIONS(3282), 1,
      aux_sym__qid_token1,
    ACTIONS(3292), 1,
      anon_sym_u2987,
    ACTIONS(3296), 1,
      aux_sym_integer_token1,
    ACTIONS(3298), 1,
      anon_sym_Set,
    ACTIONS(4354), 1,
      anon_sym_LPAREN,
    ACTIONS(4358), 1,
      anon_sym_u2983,
    ACTIONS(4360), 1,
      anon_sym_LBRACE,
    ACTIONS(4362), 1,
      anon_sym_DOT,
    ACTIONS(11543), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11553), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11555), 1,
      aux_sym_string_token1,
    ACTIONS(11883), 1,
      anon_sym_LBRACE_LBRACE,
    STATE(4036), 1,
      sym_atom,
    STATE(4032), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4012), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3270), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [580070] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1942), 1,
      sym_id,
    ACTIONS(1952), 1,
      anon_sym_record,
    ACTIONS(1962), 1,
      aux_sym__qid_token1,
    ACTIONS(1972), 1,
      anon_sym_u2987,
    ACTIONS(1976), 1,
      aux_sym_integer_token1,
    ACTIONS(1978), 1,
      anon_sym_Set,
    ACTIONS(4424), 1,
      anon_sym_LPAREN,
    ACTIONS(4428), 1,
      anon_sym_u2983,
    ACTIONS(4430), 1,
      anon_sym_LBRACE,
    ACTIONS(4432), 1,
      anon_sym_DOT,
    ACTIONS(11907), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11917), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11919), 1,
      aux_sym_string_token1,
    ACTIONS(12667), 1,
      anon_sym_LBRACE_LBRACE,
    STATE(5498), 1,
      sym_atom,
    STATE(5480), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5490), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(1950), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [580145] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(3016), 1,
      sym_id,
    ACTIONS(3026), 1,
      anon_sym_record,
    ACTIONS(3036), 1,
      aux_sym__qid_token1,
    ACTIONS(3046), 1,
      anon_sym_u2987,
    ACTIONS(3050), 1,
      aux_sym_integer_token1,
    ACTIONS(3052), 1,
      anon_sym_Set,
    ACTIONS(4606), 1,
      anon_sym_LPAREN,
    ACTIONS(4610), 1,
      anon_sym_u2983,
    ACTIONS(4612), 1,
      anon_sym_LBRACE,
    ACTIONS(4614), 1,
      anon_sym_DOT,
    ACTIONS(12191), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12193), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(12195), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(12197), 1,
      aux_sym_string_token1,
    STATE(5329), 1,
      sym_atom,
    STATE(5330), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5333), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3024), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [580220] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6112), 1,
      sym_id,
    ACTIONS(6116), 1,
      anon_sym_record,
    ACTIONS(6118), 1,
      anon_sym_LPAREN,
    ACTIONS(6122), 1,
      anon_sym_u2983,
    ACTIONS(6124), 1,
      anon_sym_LBRACE,
    ACTIONS(6126), 1,
      aux_sym__qid_token1,
    ACTIONS(6128), 1,
      anon_sym_DOT,
    ACTIONS(6132), 1,
      anon_sym_u2987,
    ACTIONS(6134), 1,
      aux_sym_integer_token1,
    ACTIONS(6136), 1,
      anon_sym_Set,
    ACTIONS(12685), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12687), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(12689), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(12691), 1,
      aux_sym_string_token1,
    STATE(5824), 1,
      sym_atom,
    STATE(5819), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5817), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(6114), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [580295] = 3,
    ACTIONS(6651), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6649), 31,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [580336] = 3,
    ACTIONS(6647), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6645), 31,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [580377] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(4950), 1,
      sym_id,
    ACTIONS(4954), 1,
      anon_sym_record,
    ACTIONS(4956), 1,
      anon_sym_LPAREN,
    ACTIONS(4960), 1,
      anon_sym_u2983,
    ACTIONS(4962), 1,
      anon_sym_LBRACE,
    ACTIONS(4964), 1,
      aux_sym__qid_token1,
    ACTIONS(4966), 1,
      anon_sym_DOT,
    ACTIONS(4970), 1,
      anon_sym_u2987,
    ACTIONS(4972), 1,
      aux_sym_integer_token1,
    ACTIONS(4974), 1,
      anon_sym_Set,
    ACTIONS(12409), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12411), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(12413), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(12415), 1,
      aux_sym_string_token1,
    STATE(4250), 1,
      sym_atom,
    STATE(4253), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4254), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(4952), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [580452] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(5054), 1,
      sym_id,
    ACTIONS(5058), 1,
      anon_sym_record,
    ACTIONS(5060), 1,
      anon_sym_LPAREN,
    ACTIONS(5064), 1,
      anon_sym_u2983,
    ACTIONS(5066), 1,
      anon_sym_LBRACE,
    ACTIONS(5068), 1,
      aux_sym__qid_token1,
    ACTIONS(5070), 1,
      anon_sym_DOT,
    ACTIONS(5074), 1,
      anon_sym_u2987,
    ACTIONS(5076), 1,
      aux_sym_integer_token1,
    ACTIONS(5078), 1,
      anon_sym_Set,
    ACTIONS(12603), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12605), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(12607), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(12609), 1,
      aux_sym_string_token1,
    STATE(4446), 1,
      sym_atom,
    STATE(4453), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4455), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(5056), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [580527] = 3,
    ACTIONS(6572), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6570), 31,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [580568] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6086), 1,
      sym_id,
    ACTIONS(6090), 1,
      anon_sym_record,
    ACTIONS(6092), 1,
      anon_sym_LPAREN,
    ACTIONS(6096), 1,
      anon_sym_u2983,
    ACTIONS(6098), 1,
      anon_sym_LBRACE,
    ACTIONS(6100), 1,
      aux_sym__qid_token1,
    ACTIONS(6102), 1,
      anon_sym_DOT,
    ACTIONS(6106), 1,
      anon_sym_u2987,
    ACTIONS(6108), 1,
      aux_sym_integer_token1,
    ACTIONS(6110), 1,
      anon_sym_Set,
    ACTIONS(12725), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12727), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(12729), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(12731), 1,
      aux_sym_string_token1,
    STATE(4521), 1,
      sym_atom,
    STATE(4522), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4523), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(6088), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [580643] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(5218), 1,
      sym_id,
    ACTIONS(5224), 1,
      anon_sym_record,
    ACTIONS(5226), 1,
      anon_sym_LPAREN,
    ACTIONS(5230), 1,
      anon_sym_u2983,
    ACTIONS(5232), 1,
      anon_sym_LBRACE,
    ACTIONS(5234), 1,
      aux_sym__qid_token1,
    ACTIONS(5236), 1,
      anon_sym_DOT,
    ACTIONS(5240), 1,
      anon_sym_u2987,
    ACTIONS(5242), 1,
      aux_sym_integer_token1,
    ACTIONS(5244), 1,
      anon_sym_Set,
    ACTIONS(11627), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11629), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11631), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11633), 1,
      aux_sym_string_token1,
    STATE(6185), 1,
      sym_atom,
    STATE(6166), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6188), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(5222), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [580718] = 3,
    ACTIONS(6568), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6566), 31,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [580759] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(3732), 1,
      sym_id,
    ACTIONS(3738), 1,
      anon_sym_record,
    ACTIONS(3740), 1,
      anon_sym_LPAREN,
    ACTIONS(3744), 1,
      anon_sym_u2983,
    ACTIONS(3746), 1,
      anon_sym_LBRACE,
    ACTIONS(3748), 1,
      aux_sym__qid_token1,
    ACTIONS(3750), 1,
      anon_sym_DOT,
    ACTIONS(3754), 1,
      anon_sym_u2987,
    ACTIONS(3756), 1,
      aux_sym_integer_token1,
    ACTIONS(3758), 1,
      anon_sym_Set,
    ACTIONS(12551), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12553), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(12555), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(12557), 1,
      aux_sym_string_token1,
    STATE(4122), 1,
      sym_atom,
    STATE(4073), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4070), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3736), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [580834] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(3354), 1,
      sym_id,
    ACTIONS(3358), 1,
      anon_sym_record,
    ACTIONS(3368), 1,
      aux_sym__qid_token1,
    ACTIONS(3374), 1,
      anon_sym_u2987,
    ACTIONS(3376), 1,
      aux_sym_integer_token1,
    ACTIONS(3378), 1,
      anon_sym_Set,
    ACTIONS(4336), 1,
      anon_sym_LPAREN,
    ACTIONS(4340), 1,
      anon_sym_u2983,
    ACTIONS(4342), 1,
      anon_sym_LBRACE,
    ACTIONS(4344), 1,
      anon_sym_DOT,
    ACTIONS(12115), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12117), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(12119), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(12121), 1,
      aux_sym_string_token1,
    STATE(4182), 1,
      sym_atom,
    STATE(4178), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4177), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3356), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [580909] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(3666), 1,
      sym_id,
    ACTIONS(3672), 1,
      anon_sym_record,
    ACTIONS(3674), 1,
      anon_sym_LPAREN,
    ACTIONS(3678), 1,
      anon_sym_u2983,
    ACTIONS(3680), 1,
      anon_sym_LBRACE,
    ACTIONS(3682), 1,
      aux_sym__qid_token1,
    ACTIONS(3684), 1,
      anon_sym_DOT,
    ACTIONS(3688), 1,
      anon_sym_u2987,
    ACTIONS(3690), 1,
      aux_sym_integer_token1,
    ACTIONS(3692), 1,
      anon_sym_Set,
    ACTIONS(12701), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12703), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(12705), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(12707), 1,
      aux_sym_string_token1,
    STATE(4586), 1,
      sym_atom,
    STATE(4585), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4584), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3670), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [580984] = 3,
    ACTIONS(6500), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6498), 31,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [581025] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(3482), 1,
      sym_id,
    ACTIONS(3492), 1,
      anon_sym_record,
    ACTIONS(3502), 1,
      aux_sym__qid_token1,
    ACTIONS(3512), 1,
      anon_sym_u2987,
    ACTIONS(3516), 1,
      aux_sym_integer_token1,
    ACTIONS(3518), 1,
      anon_sym_Set,
    ACTIONS(4552), 1,
      anon_sym_LPAREN,
    ACTIONS(4556), 1,
      anon_sym_u2983,
    ACTIONS(4558), 1,
      anon_sym_LBRACE,
    ACTIONS(4560), 1,
      anon_sym_DOT,
    ACTIONS(11733), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11735), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11737), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11739), 1,
      aux_sym_string_token1,
    STATE(4381), 1,
      sym_atom,
    STATE(4382), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4385), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3490), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [581100] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(3786), 1,
      sym_id,
    ACTIONS(3792), 1,
      anon_sym_record,
    ACTIONS(3794), 1,
      anon_sym_LPAREN,
    ACTIONS(3798), 1,
      anon_sym_u2983,
    ACTIONS(3800), 1,
      anon_sym_LBRACE,
    ACTIONS(3802), 1,
      aux_sym__qid_token1,
    ACTIONS(3804), 1,
      anon_sym_DOT,
    ACTIONS(3808), 1,
      anon_sym_u2987,
    ACTIONS(3810), 1,
      aux_sym_integer_token1,
    ACTIONS(3812), 1,
      anon_sym_Set,
    ACTIONS(12669), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12671), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(12673), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(12675), 1,
      aux_sym_string_token1,
    STATE(4268), 1,
      sym_atom,
    STATE(4284), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4282), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3790), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [581175] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(5872), 1,
      sym_id,
    ACTIONS(5876), 1,
      anon_sym_record,
    ACTIONS(5878), 1,
      anon_sym_LPAREN,
    ACTIONS(5882), 1,
      anon_sym_u2983,
    ACTIONS(5884), 1,
      anon_sym_LBRACE,
    ACTIONS(5886), 1,
      aux_sym__qid_token1,
    ACTIONS(5888), 1,
      anon_sym_DOT,
    ACTIONS(5892), 1,
      anon_sym_u2987,
    ACTIONS(5894), 1,
      aux_sym_integer_token1,
    ACTIONS(5896), 1,
      anon_sym_Set,
    ACTIONS(12635), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12637), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(12639), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(12641), 1,
      aux_sym_string_token1,
    STATE(4788), 1,
      sym_atom,
    STATE(4787), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4785), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(5874), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [581250] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(3300), 1,
      sym_id,
    ACTIONS(3304), 1,
      anon_sym_record,
    ACTIONS(3314), 1,
      aux_sym__qid_token1,
    ACTIONS(3320), 1,
      anon_sym_u2987,
    ACTIONS(3322), 1,
      aux_sym_integer_token1,
    ACTIONS(3324), 1,
      anon_sym_Set,
    ACTIONS(4854), 1,
      anon_sym_LPAREN,
    ACTIONS(4858), 1,
      anon_sym_u2983,
    ACTIONS(4860), 1,
      anon_sym_LBRACE,
    ACTIONS(4862), 1,
      anon_sym_DOT,
    ACTIONS(11825), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11835), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11837), 1,
      aux_sym_string_token1,
    ACTIONS(12179), 1,
      anon_sym_LBRACE_LBRACE,
    STATE(4068), 1,
      sym_atom,
    STATE(4053), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4049), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3302), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [581325] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11051), 1,
      sym_id,
    ACTIONS(11053), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11057), 1,
      anon_sym_record,
    ACTIONS(11059), 1,
      anon_sym_LPAREN,
    ACTIONS(11061), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11063), 1,
      anon_sym_u2983,
    ACTIONS(11065), 1,
      anon_sym_LBRACE,
    ACTIONS(11067), 1,
      aux_sym__qid_token1,
    ACTIONS(11069), 1,
      anon_sym_DOT,
    ACTIONS(11073), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11075), 1,
      anon_sym_u2987,
    ACTIONS(11077), 1,
      aux_sym_integer_token1,
    ACTIONS(11079), 1,
      aux_sym_string_token1,
    ACTIONS(11081), 1,
      anon_sym_Set,
    STATE(7669), 1,
      sym_atom,
    STATE(7756), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7737), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11055), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [581400] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(3584), 1,
      sym_id,
    ACTIONS(3588), 1,
      anon_sym_record,
    ACTIONS(3598), 1,
      aux_sym__qid_token1,
    ACTIONS(3604), 1,
      anon_sym_u2987,
    ACTIONS(3606), 1,
      aux_sym_integer_token1,
    ACTIONS(3608), 1,
      anon_sym_Set,
    ACTIONS(4788), 1,
      anon_sym_LPAREN,
    ACTIONS(4792), 1,
      anon_sym_u2983,
    ACTIONS(4794), 1,
      anon_sym_LBRACE,
    ACTIONS(4796), 1,
      anon_sym_DOT,
    ACTIONS(11717), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11719), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11721), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11723), 1,
      aux_sym_string_token1,
    STATE(4399), 1,
      sym_atom,
    STATE(4400), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4403), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3586), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [581475] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(5978), 1,
      sym_id,
    ACTIONS(5982), 1,
      anon_sym_record,
    ACTIONS(5984), 1,
      anon_sym_LPAREN,
    ACTIONS(5988), 1,
      anon_sym_u2983,
    ACTIONS(5990), 1,
      anon_sym_LBRACE,
    ACTIONS(5992), 1,
      aux_sym__qid_token1,
    ACTIONS(5994), 1,
      anon_sym_DOT,
    ACTIONS(5998), 1,
      anon_sym_u2987,
    ACTIONS(6000), 1,
      aux_sym_integer_token1,
    ACTIONS(6002), 1,
      anon_sym_Set,
    ACTIONS(12709), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12711), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(12713), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(12715), 1,
      aux_sym_string_token1,
    STATE(5758), 1,
      sym_atom,
    STATE(5765), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5767), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(5980), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [581550] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(3584), 1,
      sym_id,
    ACTIONS(3588), 1,
      anon_sym_record,
    ACTIONS(3598), 1,
      aux_sym__qid_token1,
    ACTIONS(3604), 1,
      anon_sym_u2987,
    ACTIONS(3606), 1,
      aux_sym_integer_token1,
    ACTIONS(3608), 1,
      anon_sym_Set,
    ACTIONS(4796), 1,
      anon_sym_DOT,
    ACTIONS(11717), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11721), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11723), 1,
      aux_sym_string_token1,
    ACTIONS(12733), 1,
      anon_sym_LPAREN,
    ACTIONS(12735), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(12737), 1,
      anon_sym_u2983,
    ACTIONS(12739), 1,
      anon_sym_LBRACE,
    STATE(4399), 1,
      sym_atom,
    STATE(4400), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4403), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3586), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [581625] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(9159), 1,
      sym_id,
    ACTIONS(9161), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9165), 1,
      anon_sym_record,
    ACTIONS(9167), 1,
      anon_sym_LPAREN,
    ACTIONS(9169), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(9171), 1,
      anon_sym_u2983,
    ACTIONS(9173), 1,
      anon_sym_LBRACE,
    ACTIONS(9175), 1,
      aux_sym__qid_token1,
    ACTIONS(9177), 1,
      anon_sym_DOT,
    ACTIONS(9181), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(9183), 1,
      anon_sym_u2987,
    ACTIONS(9185), 1,
      aux_sym_integer_token1,
    ACTIONS(9187), 1,
      aux_sym_string_token1,
    ACTIONS(9189), 1,
      anon_sym_Set,
    STATE(7583), 1,
      sym_atom,
    STATE(7577), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7571), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(9163), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [581700] = 3,
    ACTIONS(6326), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6324), 31,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [581741] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(10006), 1,
      sym_id,
    ACTIONS(10008), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10012), 1,
      anon_sym_record,
    ACTIONS(10014), 1,
      anon_sym_LPAREN,
    ACTIONS(10016), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(10018), 1,
      anon_sym_u2983,
    ACTIONS(10020), 1,
      anon_sym_LBRACE,
    ACTIONS(10022), 1,
      aux_sym__qid_token1,
    ACTIONS(10024), 1,
      anon_sym_DOT,
    ACTIONS(10028), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(10030), 1,
      anon_sym_u2987,
    ACTIONS(10032), 1,
      aux_sym_integer_token1,
    ACTIONS(10034), 1,
      aux_sym_string_token1,
    ACTIONS(10036), 1,
      anon_sym_Set,
    STATE(7548), 1,
      sym_atom,
    STATE(7489), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7488), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(10010), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [581816] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6138), 1,
      sym_id,
    ACTIONS(6142), 1,
      anon_sym_record,
    ACTIONS(6144), 1,
      anon_sym_LPAREN,
    ACTIONS(6148), 1,
      anon_sym_u2983,
    ACTIONS(6150), 1,
      anon_sym_LBRACE,
    ACTIONS(6152), 1,
      aux_sym__qid_token1,
    ACTIONS(6154), 1,
      anon_sym_DOT,
    ACTIONS(6158), 1,
      anon_sym_u2987,
    ACTIONS(6160), 1,
      aux_sym_integer_token1,
    ACTIONS(6162), 1,
      anon_sym_Set,
    ACTIONS(12611), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12613), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(12615), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(12617), 1,
      aux_sym_string_token1,
    STATE(5129), 1,
      sym_atom,
    STATE(5132), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5134), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(6140), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [581891] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(3878), 1,
      sym_id,
    ACTIONS(3884), 1,
      anon_sym_record,
    ACTIONS(3886), 1,
      anon_sym_LPAREN,
    ACTIONS(3890), 1,
      anon_sym_u2983,
    ACTIONS(3892), 1,
      anon_sym_LBRACE,
    ACTIONS(3894), 1,
      aux_sym__qid_token1,
    ACTIONS(3896), 1,
      anon_sym_DOT,
    ACTIONS(3900), 1,
      anon_sym_u2987,
    ACTIONS(3902), 1,
      aux_sym_integer_token1,
    ACTIONS(3904), 1,
      anon_sym_Set,
    ACTIONS(12535), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12537), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(12539), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(12541), 1,
      aux_sym_string_token1,
    STATE(4212), 1,
      sym_atom,
    STATE(4214), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4218), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3882), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [581966] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6534), 1,
      sym_id,
    ACTIONS(6536), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6540), 1,
      anon_sym_record,
    ACTIONS(6542), 1,
      anon_sym_LPAREN,
    ACTIONS(6544), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(6546), 1,
      anon_sym_u2983,
    ACTIONS(6548), 1,
      anon_sym_LBRACE,
    ACTIONS(6550), 1,
      aux_sym__qid_token1,
    ACTIONS(6552), 1,
      anon_sym_DOT,
    ACTIONS(6556), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(6558), 1,
      anon_sym_u2987,
    ACTIONS(6560), 1,
      aux_sym_integer_token1,
    ACTIONS(6562), 1,
      aux_sym_string_token1,
    ACTIONS(6564), 1,
      anon_sym_Set,
    STATE(6799), 1,
      sym_atom,
    STATE(6795), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6796), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(6538), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [582041] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(3760), 1,
      sym_id,
    ACTIONS(3764), 1,
      anon_sym_record,
    ACTIONS(3774), 1,
      aux_sym__qid_token1,
    ACTIONS(3780), 1,
      anon_sym_u2987,
    ACTIONS(3782), 1,
      aux_sym_integer_token1,
    ACTIONS(3784), 1,
      anon_sym_Set,
    ACTIONS(4816), 1,
      anon_sym_LPAREN,
    ACTIONS(4820), 1,
      anon_sym_u2983,
    ACTIONS(4822), 1,
      anon_sym_LBRACE,
    ACTIONS(4824), 1,
      anon_sym_DOT,
    ACTIONS(11565), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11567), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11569), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11571), 1,
      aux_sym_string_token1,
    STATE(4624), 1,
      sym_atom,
    STATE(4599), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4613), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3762), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [582116] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6716), 1,
      sym_id,
    ACTIONS(6718), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6722), 1,
      anon_sym_record,
    ACTIONS(6724), 1,
      anon_sym_LPAREN,
    ACTIONS(6726), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(6728), 1,
      anon_sym_u2983,
    ACTIONS(6730), 1,
      anon_sym_LBRACE,
    ACTIONS(6732), 1,
      aux_sym__qid_token1,
    ACTIONS(6734), 1,
      anon_sym_DOT,
    ACTIONS(6738), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(6740), 1,
      anon_sym_u2987,
    ACTIONS(6742), 1,
      aux_sym_integer_token1,
    ACTIONS(6744), 1,
      aux_sym_string_token1,
    ACTIONS(6746), 1,
      anon_sym_Set,
    STATE(6810), 1,
      sym_atom,
    STATE(6805), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6809), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(6720), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [582191] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(8247), 1,
      sym_id,
    ACTIONS(8249), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8253), 1,
      anon_sym_record,
    ACTIONS(8255), 1,
      anon_sym_LPAREN,
    ACTIONS(8257), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(8259), 1,
      anon_sym_u2983,
    ACTIONS(8261), 1,
      anon_sym_LBRACE,
    ACTIONS(8263), 1,
      aux_sym__qid_token1,
    ACTIONS(8265), 1,
      anon_sym_DOT,
    ACTIONS(8269), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(8271), 1,
      anon_sym_u2987,
    ACTIONS(8273), 1,
      aux_sym_integer_token1,
    ACTIONS(8275), 1,
      aux_sym_string_token1,
    ACTIONS(8277), 1,
      anon_sym_Set,
    STATE(7321), 1,
      sym_atom,
    STATE(7320), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7319), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(8251), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [582266] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(5760), 1,
      sym_id,
    ACTIONS(5764), 1,
      anon_sym_record,
    ACTIONS(5766), 1,
      anon_sym_LPAREN,
    ACTIONS(5770), 1,
      anon_sym_u2983,
    ACTIONS(5772), 1,
      anon_sym_LBRACE,
    ACTIONS(5774), 1,
      aux_sym__qid_token1,
    ACTIONS(5776), 1,
      anon_sym_DOT,
    ACTIONS(5780), 1,
      anon_sym_u2987,
    ACTIONS(5782), 1,
      aux_sym_integer_token1,
    ACTIONS(5784), 1,
      anon_sym_Set,
    ACTIONS(11665), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11667), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11669), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11671), 1,
      aux_sym_string_token1,
    STATE(5735), 1,
      sym_atom,
    STATE(5941), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5965), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(5762), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [582341] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2056), 1,
      sym_id,
    ACTIONS(2066), 1,
      anon_sym_record,
    ACTIONS(2076), 1,
      aux_sym__qid_token1,
    ACTIONS(2086), 1,
      anon_sym_u2987,
    ACTIONS(2090), 1,
      aux_sym_integer_token1,
    ACTIONS(2092), 1,
      anon_sym_Set,
    ACTIONS(4830), 1,
      anon_sym_LPAREN,
    ACTIONS(4834), 1,
      anon_sym_u2983,
    ACTIONS(4836), 1,
      anon_sym_LBRACE,
    ACTIONS(4838), 1,
      anon_sym_DOT,
    ACTIONS(11839), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11849), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11851), 1,
      aux_sym_string_token1,
    ACTIONS(12035), 1,
      anon_sym_LBRACE_LBRACE,
    STATE(5518), 1,
      sym_atom,
    STATE(5492), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5503), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(2064), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [582416] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(7914), 1,
      sym_id,
    ACTIONS(7916), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7920), 1,
      anon_sym_record,
    ACTIONS(7922), 1,
      anon_sym_LPAREN,
    ACTIONS(7924), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(7926), 1,
      anon_sym_u2983,
    ACTIONS(7928), 1,
      anon_sym_LBRACE,
    ACTIONS(7930), 1,
      aux_sym__qid_token1,
    ACTIONS(7932), 1,
      anon_sym_DOT,
    ACTIONS(7936), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(7938), 1,
      anon_sym_u2987,
    ACTIONS(7940), 1,
      aux_sym_integer_token1,
    ACTIONS(7942), 1,
      aux_sym_string_token1,
    ACTIONS(7944), 1,
      anon_sym_Set,
    STATE(7238), 1,
      sym_atom,
    STATE(7212), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7249), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(7918), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [582491] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(5604), 1,
      sym_id,
    ACTIONS(5608), 1,
      anon_sym_record,
    ACTIONS(5610), 1,
      anon_sym_LPAREN,
    ACTIONS(5614), 1,
      anon_sym_u2983,
    ACTIONS(5616), 1,
      anon_sym_LBRACE,
    ACTIONS(5618), 1,
      aux_sym__qid_token1,
    ACTIONS(5620), 1,
      anon_sym_DOT,
    ACTIONS(5624), 1,
      anon_sym_u2987,
    ACTIONS(5626), 1,
      aux_sym_integer_token1,
    ACTIONS(5628), 1,
      anon_sym_Set,
    ACTIONS(12567), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12569), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(12571), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(12573), 1,
      aux_sym_string_token1,
    STATE(6227), 1,
      sym_atom,
    STATE(6226), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6214), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(5606), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [582566] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6534), 1,
      sym_id,
    ACTIONS(6536), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6540), 1,
      anon_sym_record,
    ACTIONS(6542), 1,
      anon_sym_LPAREN,
    ACTIONS(6544), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(6546), 1,
      anon_sym_u2983,
    ACTIONS(6548), 1,
      anon_sym_LBRACE,
    ACTIONS(6550), 1,
      aux_sym__qid_token1,
    ACTIONS(6552), 1,
      anon_sym_DOT,
    ACTIONS(6556), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(6558), 1,
      anon_sym_u2987,
    ACTIONS(6560), 1,
      aux_sym_integer_token1,
    ACTIONS(6562), 1,
      aux_sym_string_token1,
    ACTIONS(6564), 1,
      anon_sym_Set,
    STATE(6794), 1,
      sym_atom,
    STATE(6795), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6796), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(6538), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [582641] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(10206), 1,
      sym_id,
    ACTIONS(10208), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10212), 1,
      anon_sym_record,
    ACTIONS(10214), 1,
      anon_sym_LPAREN,
    ACTIONS(10216), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(10218), 1,
      anon_sym_u2983,
    ACTIONS(10220), 1,
      anon_sym_LBRACE,
    ACTIONS(10222), 1,
      aux_sym__qid_token1,
    ACTIONS(10224), 1,
      anon_sym_DOT,
    ACTIONS(10228), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(10230), 1,
      anon_sym_u2987,
    ACTIONS(10232), 1,
      aux_sym_integer_token1,
    ACTIONS(10234), 1,
      aux_sym_string_token1,
    ACTIONS(10236), 1,
      anon_sym_Set,
    STATE(7736), 1,
      sym_atom,
    STATE(7731), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7724), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(10210), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [582716] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(105), 1,
      sym_id,
    ACTIONS(125), 1,
      anon_sym_LPAREN,
    ACTIONS(129), 1,
      anon_sym_u2983,
    ACTIONS(135), 1,
      anon_sym_LBRACE,
    ACTIONS(143), 1,
      aux_sym__qid_token1,
    ACTIONS(145), 1,
      anon_sym_DOT,
    ACTIONS(153), 1,
      anon_sym_u2987,
    ACTIONS(157), 1,
      aux_sym_integer_token1,
    ACTIONS(159), 1,
      anon_sym_Set,
    ACTIONS(4274), 1,
      anon_sym_record,
    ACTIONS(11367), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11369), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11371), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11373), 1,
      aux_sym_string_token1,
    STATE(4333), 1,
      sym_atom,
    STATE(4311), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4327), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(113), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [582791] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(10337), 1,
      sym_id,
    ACTIONS(10339), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10343), 1,
      anon_sym_record,
    ACTIONS(10345), 1,
      anon_sym_LPAREN,
    ACTIONS(10347), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(10349), 1,
      anon_sym_u2983,
    ACTIONS(10351), 1,
      anon_sym_LBRACE,
    ACTIONS(10353), 1,
      aux_sym__qid_token1,
    ACTIONS(10355), 1,
      anon_sym_DOT,
    ACTIONS(10359), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(10361), 1,
      anon_sym_u2987,
    ACTIONS(10363), 1,
      aux_sym_integer_token1,
    ACTIONS(10365), 1,
      aux_sym_string_token1,
    ACTIONS(10367), 1,
      anon_sym_Set,
    STATE(7745), 1,
      sym_atom,
    STATE(7712), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7709), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(10341), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [582866] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11795), 1,
      sym_id,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_record,
    ACTIONS(11803), 1,
      anon_sym_LPAREN,
    ACTIONS(11805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11807), 1,
      anon_sym_u2983,
    ACTIONS(11809), 1,
      anon_sym_LBRACE,
    ACTIONS(11811), 1,
      aux_sym__qid_token1,
    ACTIONS(11813), 1,
      anon_sym_DOT,
    ACTIONS(11815), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11817), 1,
      anon_sym_u2987,
    ACTIONS(11819), 1,
      aux_sym_integer_token1,
    ACTIONS(11821), 1,
      aux_sym_string_token1,
    ACTIONS(11823), 1,
      anon_sym_Set,
    STATE(11879), 1,
      sym_atom,
    STATE(11687), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(11890), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11799), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [582941] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(5494), 1,
      sym_id,
    ACTIONS(5498), 1,
      anon_sym_record,
    ACTIONS(5500), 1,
      anon_sym_LPAREN,
    ACTIONS(5504), 1,
      anon_sym_u2983,
    ACTIONS(5506), 1,
      anon_sym_LBRACE,
    ACTIONS(5508), 1,
      aux_sym__qid_token1,
    ACTIONS(5510), 1,
      anon_sym_DOT,
    ACTIONS(5514), 1,
      anon_sym_u2987,
    ACTIONS(5516), 1,
      aux_sym_integer_token1,
    ACTIONS(5518), 1,
      anon_sym_Set,
    ACTIONS(12067), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12069), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(12071), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(12073), 1,
      aux_sym_string_token1,
    STATE(6046), 1,
      sym_atom,
    STATE(6047), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(6050), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(5496), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [583016] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(5166), 1,
      sym_id,
    ACTIONS(5170), 1,
      anon_sym_record,
    ACTIONS(5172), 1,
      anon_sym_LPAREN,
    ACTIONS(5176), 1,
      anon_sym_u2983,
    ACTIONS(5178), 1,
      anon_sym_LBRACE,
    ACTIONS(5180), 1,
      aux_sym__qid_token1,
    ACTIONS(5182), 1,
      anon_sym_DOT,
    ACTIONS(5186), 1,
      anon_sym_u2987,
    ACTIONS(5188), 1,
      aux_sym_integer_token1,
    ACTIONS(5190), 1,
      anon_sym_Set,
    ACTIONS(12163), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12165), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(12167), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(12169), 1,
      aux_sym_string_token1,
    STATE(5929), 1,
      sym_atom,
    STATE(5928), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5926), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(5168), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [583091] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(3354), 1,
      sym_id,
    ACTIONS(3358), 1,
      anon_sym_record,
    ACTIONS(3368), 1,
      aux_sym__qid_token1,
    ACTIONS(3374), 1,
      anon_sym_u2987,
    ACTIONS(3376), 1,
      aux_sym_integer_token1,
    ACTIONS(3378), 1,
      anon_sym_Set,
    ACTIONS(4344), 1,
      anon_sym_DOT,
    ACTIONS(12115), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12119), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(12121), 1,
      aux_sym_string_token1,
    ACTIONS(12741), 1,
      anon_sym_LPAREN,
    ACTIONS(12743), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(12745), 1,
      anon_sym_u2983,
    ACTIONS(12747), 1,
      anon_sym_LBRACE,
    STATE(4182), 1,
      sym_atom,
    STATE(4178), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4177), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3356), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [583166] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(3694), 1,
      sym_id,
    ACTIONS(3704), 1,
      anon_sym_record,
    ACTIONS(3714), 1,
      aux_sym__qid_token1,
    ACTIONS(3724), 1,
      anon_sym_u2987,
    ACTIONS(3728), 1,
      aux_sym_integer_token1,
    ACTIONS(3730), 1,
      anon_sym_Set,
    ACTIONS(4774), 1,
      anon_sym_LPAREN,
    ACTIONS(4778), 1,
      anon_sym_u2983,
    ACTIONS(4780), 1,
      anon_sym_LBRACE,
    ACTIONS(4782), 1,
      anon_sym_DOT,
    ACTIONS(11597), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11599), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11601), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11603), 1,
      aux_sym_string_token1,
    STATE(4490), 1,
      sym_atom,
    STATE(4467), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(4459), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(3702), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [583241] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(8405), 1,
      sym_id,
    ACTIONS(8407), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8411), 1,
      anon_sym_record,
    ACTIONS(8413), 1,
      anon_sym_LPAREN,
    ACTIONS(8415), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(8417), 1,
      anon_sym_u2983,
    ACTIONS(8419), 1,
      anon_sym_LBRACE,
    ACTIONS(8421), 1,
      aux_sym__qid_token1,
    ACTIONS(8423), 1,
      anon_sym_DOT,
    ACTIONS(8427), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(8429), 1,
      anon_sym_u2987,
    ACTIONS(8431), 1,
      aux_sym_integer_token1,
    ACTIONS(8433), 1,
      aux_sym_string_token1,
    ACTIONS(8435), 1,
      anon_sym_Set,
    STATE(7316), 1,
      sym_atom,
    STATE(7446), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7448), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(8409), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [583316] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11795), 1,
      sym_id,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_record,
    ACTIONS(11803), 1,
      anon_sym_LPAREN,
    ACTIONS(11805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11807), 1,
      anon_sym_u2983,
    ACTIONS(11809), 1,
      anon_sym_LBRACE,
    ACTIONS(11811), 1,
      aux_sym__qid_token1,
    ACTIONS(11813), 1,
      anon_sym_DOT,
    ACTIONS(11815), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11817), 1,
      anon_sym_u2987,
    ACTIONS(11819), 1,
      aux_sym_integer_token1,
    ACTIONS(11821), 1,
      aux_sym_string_token1,
    ACTIONS(11823), 1,
      anon_sym_Set,
    STATE(11886), 1,
      sym_atom,
    STATE(11687), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(11890), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11799), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [583391] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(8955), 1,
      sym_id,
    ACTIONS(8957), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8961), 1,
      anon_sym_record,
    ACTIONS(8963), 1,
      anon_sym_LPAREN,
    ACTIONS(8965), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(8967), 1,
      anon_sym_u2983,
    ACTIONS(8969), 1,
      anon_sym_LBRACE,
    ACTIONS(8971), 1,
      aux_sym__qid_token1,
    ACTIONS(8973), 1,
      anon_sym_DOT,
    ACTIONS(8977), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(8979), 1,
      anon_sym_u2987,
    ACTIONS(8981), 1,
      aux_sym_integer_token1,
    ACTIONS(8983), 1,
      aux_sym_string_token1,
    ACTIONS(8985), 1,
      anon_sym_Set,
    STATE(7494), 1,
      sym_atom,
    STATE(7468), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(7497), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(8959), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [583466] = 20,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2298), 1,
      sym_id,
    ACTIONS(2308), 1,
      anon_sym_record,
    ACTIONS(2318), 1,
      aux_sym__qid_token1,
    ACTIONS(2328), 1,
      anon_sym_u2987,
    ACTIONS(2332), 1,
      aux_sym_integer_token1,
    ACTIONS(2334), 1,
      anon_sym_Set,
    ACTIONS(4490), 1,
      anon_sym_DOT,
    ACTIONS(12353), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12357), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(12359), 1,
      aux_sym_string_token1,
    ACTIONS(12749), 1,
      anon_sym_LPAREN,
    ACTIONS(12751), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(12753), 1,
      anon_sym_u2983,
    ACTIONS(12755), 1,
      anon_sym_LBRACE,
    STATE(4990), 1,
      sym_atom,
    STATE(5354), 2,
      sym__atom_curly,
      sym__atom_no_curly,
    STATE(5347), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(2306), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [583541] = 3,
    ACTIONS(6710), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6708), 30,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [583581] = 3,
    ACTIONS(6433), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6431), 30,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [583621] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6433), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6431), 26,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [583663] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6750), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6748), 26,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [583705] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6710), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6708), 26,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [583747] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6484), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6482), 26,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [583789] = 3,
    ACTIONS(6326), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6324), 30,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_AT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [583829] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6326), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6324), 26,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [583871] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6651), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6649), 26,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [583913] = 3,
    ACTIONS(6496), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6494), 30,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_AT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [583953] = 3,
    ACTIONS(6655), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6653), 30,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_AT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [583993] = 5,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(12757), 1,
      anon_sym_AT,
    ACTIONS(6326), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6324), 25,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [584037] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6647), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6645), 26,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [584079] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6572), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6570), 26,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [584121] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6710), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6708), 26,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [584163] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6433), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6431), 26,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [584205] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6647), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6645), 26,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [584247] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6568), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6566), 26,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [584289] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6484), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6482), 26,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [584331] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6750), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6748), 26,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [584373] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6500), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6498), 26,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [584415] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6714), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6712), 26,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [584457] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6754), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6752), 26,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [584499] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6651), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6649), 26,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [584541] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6572), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6570), 26,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [584583] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6568), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6566), 26,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [584625] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6500), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6498), 26,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [584667] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6655), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6653), 26,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [584709] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6326), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6324), 26,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [584751] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6496), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6494), 26,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [584793] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6651), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6649), 26,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [584835] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6326), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6324), 26,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [584877] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6714), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6712), 26,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [584919] = 3,
    ACTIONS(6647), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6645), 30,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [584959] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6754), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6752), 26,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [585001] = 3,
    ACTIONS(6484), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6482), 30,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [585041] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6496), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6494), 26,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [585083] = 3,
    ACTIONS(6750), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6748), 30,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [585123] = 3,
    ACTIONS(6714), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6712), 30,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [585163] = 3,
    ACTIONS(6754), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6752), 30,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [585203] = 3,
    ACTIONS(6651), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6649), 30,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [585243] = 3,
    ACTIONS(6572), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6570), 30,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [585283] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6655), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6653), 26,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [585325] = 3,
    ACTIONS(6568), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6566), 30,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [585365] = 3,
    ACTIONS(6500), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6498), 30,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [585405] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6655), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6653), 26,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [585447] = 5,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(12759), 1,
      anon_sym_AT,
    ACTIONS(6326), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6324), 25,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [585491] = 5,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(12761), 1,
      anon_sym_AT,
    ACTIONS(6326), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6324), 25,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [585535] = 3,
    ACTIONS(6655), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6653), 30,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [585575] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6500), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6498), 26,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [585617] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6568), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6566), 26,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [585659] = 3,
    ACTIONS(6496), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6494), 30,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [585699] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6572), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6570), 26,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [585741] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6647), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6645), 26,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [585783] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6754), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6752), 26,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [585825] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6714), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6712), 26,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [585867] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6433), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6431), 26,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [585909] = 5,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(12763), 1,
      anon_sym_AT,
    ACTIONS(6326), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6324), 25,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [585953] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6750), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6748), 26,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [585995] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6710), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6708), 26,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [586037] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6484), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6482), 26,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [586079] = 4,
    ACTIONS(6326), 1,
      anon_sym_BSLASH,
    ACTIONS(12765), 1,
      anon_sym_AT,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6324), 29,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [586121] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6496), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6494), 26,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [586163] = 3,
    ACTIONS(6326), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6324), 30,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [586203] = 3,
    ACTIONS(12593), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(12591), 30,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_AT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [586243] = 19,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11795), 1,
      sym_id,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_record,
    ACTIONS(11803), 1,
      anon_sym_LPAREN,
    ACTIONS(11805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11807), 1,
      anon_sym_u2983,
    ACTIONS(11811), 1,
      aux_sym__qid_token1,
    ACTIONS(11813), 1,
      anon_sym_DOT,
    ACTIONS(11815), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11817), 1,
      anon_sym_u2987,
    ACTIONS(11819), 1,
      aux_sym_integer_token1,
    ACTIONS(11821), 1,
      aux_sym_string_token1,
    ACTIONS(11823), 1,
      anon_sym_Set,
    ACTIONS(12767), 1,
      anon_sym_LBRACE,
    STATE(12217), 1,
      sym__atom_no_curly,
    STATE(11890), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11799), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [586314] = 19,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11795), 1,
      sym_id,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_record,
    ACTIONS(11803), 1,
      anon_sym_LPAREN,
    ACTIONS(11805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11807), 1,
      anon_sym_u2983,
    ACTIONS(11811), 1,
      aux_sym__qid_token1,
    ACTIONS(11813), 1,
      anon_sym_DOT,
    ACTIONS(11815), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11817), 1,
      anon_sym_u2987,
    ACTIONS(11819), 1,
      aux_sym_integer_token1,
    ACTIONS(11821), 1,
      aux_sym_string_token1,
    ACTIONS(11823), 1,
      anon_sym_Set,
    ACTIONS(12769), 1,
      anon_sym_LBRACE,
    STATE(12149), 1,
      sym__atom_no_curly,
    STATE(11890), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11799), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [586385] = 19,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11795), 1,
      sym_id,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_record,
    ACTIONS(11803), 1,
      anon_sym_LPAREN,
    ACTIONS(11805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11807), 1,
      anon_sym_u2983,
    ACTIONS(11811), 1,
      aux_sym__qid_token1,
    ACTIONS(11813), 1,
      anon_sym_DOT,
    ACTIONS(11815), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11817), 1,
      anon_sym_u2987,
    ACTIONS(11819), 1,
      aux_sym_integer_token1,
    ACTIONS(11821), 1,
      aux_sym_string_token1,
    ACTIONS(11823), 1,
      anon_sym_Set,
    ACTIONS(12771), 1,
      anon_sym_LBRACE,
    STATE(10347), 1,
      sym__atom_no_curly,
    STATE(11890), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11799), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [586456] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6754), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6752), 25,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [586497] = 19,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11795), 1,
      sym_id,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_record,
    ACTIONS(11803), 1,
      anon_sym_LPAREN,
    ACTIONS(11805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11807), 1,
      anon_sym_u2983,
    ACTIONS(11811), 1,
      aux_sym__qid_token1,
    ACTIONS(11813), 1,
      anon_sym_DOT,
    ACTIONS(11815), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11817), 1,
      anon_sym_u2987,
    ACTIONS(11819), 1,
      aux_sym_integer_token1,
    ACTIONS(11821), 1,
      aux_sym_string_token1,
    ACTIONS(11823), 1,
      anon_sym_Set,
    ACTIONS(12773), 1,
      anon_sym_LBRACE,
    STATE(12590), 1,
      sym__atom_no_curly,
    STATE(11890), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11799), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [586568] = 19,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11795), 1,
      sym_id,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_record,
    ACTIONS(11803), 1,
      anon_sym_LPAREN,
    ACTIONS(11805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11807), 1,
      anon_sym_u2983,
    ACTIONS(11811), 1,
      aux_sym__qid_token1,
    ACTIONS(11813), 1,
      anon_sym_DOT,
    ACTIONS(11815), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11817), 1,
      anon_sym_u2987,
    ACTIONS(11819), 1,
      aux_sym_integer_token1,
    ACTIONS(11821), 1,
      aux_sym_string_token1,
    ACTIONS(11823), 1,
      anon_sym_Set,
    ACTIONS(12775), 1,
      anon_sym_LBRACE,
    STATE(11812), 1,
      sym__atom_no_curly,
    STATE(11890), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11799), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [586639] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6651), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6649), 25,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [586680] = 19,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11795), 1,
      sym_id,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_record,
    ACTIONS(11803), 1,
      anon_sym_LPAREN,
    ACTIONS(11805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11807), 1,
      anon_sym_u2983,
    ACTIONS(11811), 1,
      aux_sym__qid_token1,
    ACTIONS(11813), 1,
      anon_sym_DOT,
    ACTIONS(11815), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11817), 1,
      anon_sym_u2987,
    ACTIONS(11819), 1,
      aux_sym_integer_token1,
    ACTIONS(11821), 1,
      aux_sym_string_token1,
    ACTIONS(11823), 1,
      anon_sym_Set,
    ACTIONS(12777), 1,
      anon_sym_LBRACE,
    STATE(11234), 1,
      sym__atom_no_curly,
    STATE(11890), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11799), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [586751] = 19,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11795), 1,
      sym_id,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_record,
    ACTIONS(11803), 1,
      anon_sym_LPAREN,
    ACTIONS(11805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11807), 1,
      anon_sym_u2983,
    ACTIONS(11811), 1,
      aux_sym__qid_token1,
    ACTIONS(11813), 1,
      anon_sym_DOT,
    ACTIONS(11815), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11817), 1,
      anon_sym_u2987,
    ACTIONS(11819), 1,
      aux_sym_integer_token1,
    ACTIONS(11821), 1,
      aux_sym_string_token1,
    ACTIONS(11823), 1,
      anon_sym_Set,
    ACTIONS(12779), 1,
      anon_sym_LBRACE,
    STATE(11825), 1,
      sym__atom_no_curly,
    STATE(11890), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11799), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [586822] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6484), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6482), 25,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [586863] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6500), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6498), 25,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [586904] = 19,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11795), 1,
      sym_id,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_record,
    ACTIONS(11803), 1,
      anon_sym_LPAREN,
    ACTIONS(11805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11807), 1,
      anon_sym_u2983,
    ACTIONS(11811), 1,
      aux_sym__qid_token1,
    ACTIONS(11813), 1,
      anon_sym_DOT,
    ACTIONS(11815), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11817), 1,
      anon_sym_u2987,
    ACTIONS(11819), 1,
      aux_sym_integer_token1,
    ACTIONS(11821), 1,
      aux_sym_string_token1,
    ACTIONS(11823), 1,
      anon_sym_Set,
    ACTIONS(12781), 1,
      anon_sym_LBRACE,
    STATE(10875), 1,
      sym__atom_no_curly,
    STATE(11890), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11799), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [586975] = 19,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11795), 1,
      sym_id,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_record,
    ACTIONS(11803), 1,
      anon_sym_LPAREN,
    ACTIONS(11805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11807), 1,
      anon_sym_u2983,
    ACTIONS(11811), 1,
      aux_sym__qid_token1,
    ACTIONS(11813), 1,
      anon_sym_DOT,
    ACTIONS(11815), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11817), 1,
      anon_sym_u2987,
    ACTIONS(11819), 1,
      aux_sym_integer_token1,
    ACTIONS(11821), 1,
      aux_sym_string_token1,
    ACTIONS(11823), 1,
      anon_sym_Set,
    ACTIONS(12783), 1,
      anon_sym_LBRACE,
    STATE(11833), 1,
      sym__atom_no_curly,
    STATE(11890), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11799), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [587046] = 19,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11795), 1,
      sym_id,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_record,
    ACTIONS(11803), 1,
      anon_sym_LPAREN,
    ACTIONS(11805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11807), 1,
      anon_sym_u2983,
    ACTIONS(11811), 1,
      aux_sym__qid_token1,
    ACTIONS(11813), 1,
      anon_sym_DOT,
    ACTIONS(11815), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11817), 1,
      anon_sym_u2987,
    ACTIONS(11819), 1,
      aux_sym_integer_token1,
    ACTIONS(11821), 1,
      aux_sym_string_token1,
    ACTIONS(11823), 1,
      anon_sym_Set,
    ACTIONS(12785), 1,
      anon_sym_LBRACE,
    STATE(11893), 1,
      sym__atom_no_curly,
    STATE(11890), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11799), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [587117] = 19,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11795), 1,
      sym_id,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_record,
    ACTIONS(11803), 1,
      anon_sym_LPAREN,
    ACTIONS(11805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11807), 1,
      anon_sym_u2983,
    ACTIONS(11811), 1,
      aux_sym__qid_token1,
    ACTIONS(11813), 1,
      anon_sym_DOT,
    ACTIONS(11815), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11817), 1,
      anon_sym_u2987,
    ACTIONS(11819), 1,
      aux_sym_integer_token1,
    ACTIONS(11821), 1,
      aux_sym_string_token1,
    ACTIONS(11823), 1,
      anon_sym_Set,
    ACTIONS(12787), 1,
      anon_sym_LBRACE,
    STATE(11837), 1,
      sym__atom_no_curly,
    STATE(11890), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11799), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [587188] = 19,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11795), 1,
      sym_id,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_record,
    ACTIONS(11803), 1,
      anon_sym_LPAREN,
    ACTIONS(11805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11807), 1,
      anon_sym_u2983,
    ACTIONS(11811), 1,
      aux_sym__qid_token1,
    ACTIONS(11813), 1,
      anon_sym_DOT,
    ACTIONS(11815), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11817), 1,
      anon_sym_u2987,
    ACTIONS(11819), 1,
      aux_sym_integer_token1,
    ACTIONS(11821), 1,
      aux_sym_string_token1,
    ACTIONS(11823), 1,
      anon_sym_Set,
    ACTIONS(12789), 1,
      anon_sym_LBRACE,
    STATE(11795), 1,
      sym__atom_no_curly,
    STATE(11890), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11799), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [587259] = 19,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11795), 1,
      sym_id,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_record,
    ACTIONS(11803), 1,
      anon_sym_LPAREN,
    ACTIONS(11805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11807), 1,
      anon_sym_u2983,
    ACTIONS(11811), 1,
      aux_sym__qid_token1,
    ACTIONS(11813), 1,
      anon_sym_DOT,
    ACTIONS(11815), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11817), 1,
      anon_sym_u2987,
    ACTIONS(11819), 1,
      aux_sym_integer_token1,
    ACTIONS(11821), 1,
      aux_sym_string_token1,
    ACTIONS(11823), 1,
      anon_sym_Set,
    ACTIONS(12791), 1,
      anon_sym_LBRACE,
    STATE(11841), 1,
      sym__atom_no_curly,
    STATE(11890), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11799), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [587330] = 19,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11795), 1,
      sym_id,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_record,
    ACTIONS(11803), 1,
      anon_sym_LPAREN,
    ACTIONS(11805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11807), 1,
      anon_sym_u2983,
    ACTIONS(11811), 1,
      aux_sym__qid_token1,
    ACTIONS(11813), 1,
      anon_sym_DOT,
    ACTIONS(11815), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11817), 1,
      anon_sym_u2987,
    ACTIONS(11819), 1,
      aux_sym_integer_token1,
    ACTIONS(11821), 1,
      aux_sym_string_token1,
    ACTIONS(11823), 1,
      anon_sym_Set,
    ACTIONS(12793), 1,
      anon_sym_LBRACE,
    STATE(11845), 1,
      sym__atom_no_curly,
    STATE(11890), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11799), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [587401] = 19,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11795), 1,
      sym_id,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_record,
    ACTIONS(11803), 1,
      anon_sym_LPAREN,
    ACTIONS(11805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11807), 1,
      anon_sym_u2983,
    ACTIONS(11811), 1,
      aux_sym__qid_token1,
    ACTIONS(11813), 1,
      anon_sym_DOT,
    ACTIONS(11815), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11817), 1,
      anon_sym_u2987,
    ACTIONS(11819), 1,
      aux_sym_integer_token1,
    ACTIONS(11821), 1,
      aux_sym_string_token1,
    ACTIONS(11823), 1,
      anon_sym_Set,
    ACTIONS(12795), 1,
      anon_sym_LBRACE,
    STATE(11849), 1,
      sym__atom_no_curly,
    STATE(11890), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11799), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [587472] = 19,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11795), 1,
      sym_id,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_record,
    ACTIONS(11803), 1,
      anon_sym_LPAREN,
    ACTIONS(11805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11807), 1,
      anon_sym_u2983,
    ACTIONS(11811), 1,
      aux_sym__qid_token1,
    ACTIONS(11813), 1,
      anon_sym_DOT,
    ACTIONS(11815), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11817), 1,
      anon_sym_u2987,
    ACTIONS(11819), 1,
      aux_sym_integer_token1,
    ACTIONS(11821), 1,
      aux_sym_string_token1,
    ACTIONS(11823), 1,
      anon_sym_Set,
    ACTIONS(12797), 1,
      anon_sym_LBRACE,
    STATE(11256), 1,
      sym__atom_no_curly,
    STATE(11890), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11799), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [587543] = 19,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11795), 1,
      sym_id,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_record,
    ACTIONS(11803), 1,
      anon_sym_LPAREN,
    ACTIONS(11805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11807), 1,
      anon_sym_u2983,
    ACTIONS(11811), 1,
      aux_sym__qid_token1,
    ACTIONS(11813), 1,
      anon_sym_DOT,
    ACTIONS(11815), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11817), 1,
      anon_sym_u2987,
    ACTIONS(11819), 1,
      aux_sym_integer_token1,
    ACTIONS(11821), 1,
      aux_sym_string_token1,
    ACTIONS(11823), 1,
      anon_sym_Set,
    ACTIONS(12799), 1,
      anon_sym_LBRACE,
    STATE(11853), 1,
      sym__atom_no_curly,
    STATE(11890), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11799), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [587614] = 19,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11795), 1,
      sym_id,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_record,
    ACTIONS(11803), 1,
      anon_sym_LPAREN,
    ACTIONS(11805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11807), 1,
      anon_sym_u2983,
    ACTIONS(11811), 1,
      aux_sym__qid_token1,
    ACTIONS(11813), 1,
      anon_sym_DOT,
    ACTIONS(11815), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11817), 1,
      anon_sym_u2987,
    ACTIONS(11819), 1,
      aux_sym_integer_token1,
    ACTIONS(11821), 1,
      aux_sym_string_token1,
    ACTIONS(11823), 1,
      anon_sym_Set,
    ACTIONS(12801), 1,
      anon_sym_LBRACE,
    STATE(11857), 1,
      sym__atom_no_curly,
    STATE(11890), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11799), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [587685] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6714), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6712), 25,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [587726] = 19,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11795), 1,
      sym_id,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_record,
    ACTIONS(11803), 1,
      anon_sym_LPAREN,
    ACTIONS(11805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11807), 1,
      anon_sym_u2983,
    ACTIONS(11811), 1,
      aux_sym__qid_token1,
    ACTIONS(11813), 1,
      anon_sym_DOT,
    ACTIONS(11815), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11817), 1,
      anon_sym_u2987,
    ACTIONS(11819), 1,
      aux_sym_integer_token1,
    ACTIONS(11821), 1,
      aux_sym_string_token1,
    ACTIONS(11823), 1,
      anon_sym_Set,
    ACTIONS(12803), 1,
      anon_sym_LBRACE,
    STATE(11861), 1,
      sym__atom_no_curly,
    STATE(11890), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11799), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [587797] = 19,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11795), 1,
      sym_id,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_record,
    ACTIONS(11803), 1,
      anon_sym_LPAREN,
    ACTIONS(11805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11807), 1,
      anon_sym_u2983,
    ACTIONS(11811), 1,
      aux_sym__qid_token1,
    ACTIONS(11813), 1,
      anon_sym_DOT,
    ACTIONS(11815), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11817), 1,
      anon_sym_u2987,
    ACTIONS(11819), 1,
      aux_sym_integer_token1,
    ACTIONS(11821), 1,
      aux_sym_string_token1,
    ACTIONS(11823), 1,
      anon_sym_Set,
    ACTIONS(12805), 1,
      anon_sym_LBRACE,
    STATE(11865), 1,
      sym__atom_no_curly,
    STATE(11890), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11799), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [587868] = 19,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11795), 1,
      sym_id,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_record,
    ACTIONS(11803), 1,
      anon_sym_LPAREN,
    ACTIONS(11805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11807), 1,
      anon_sym_u2983,
    ACTIONS(11811), 1,
      aux_sym__qid_token1,
    ACTIONS(11813), 1,
      anon_sym_DOT,
    ACTIONS(11815), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11817), 1,
      anon_sym_u2987,
    ACTIONS(11819), 1,
      aux_sym_integer_token1,
    ACTIONS(11821), 1,
      aux_sym_string_token1,
    ACTIONS(11823), 1,
      anon_sym_Set,
    ACTIONS(12807), 1,
      anon_sym_LBRACE,
    STATE(11869), 1,
      sym__atom_no_curly,
    STATE(11890), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11799), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [587939] = 19,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11795), 1,
      sym_id,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_record,
    ACTIONS(11803), 1,
      anon_sym_LPAREN,
    ACTIONS(11805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11807), 1,
      anon_sym_u2983,
    ACTIONS(11811), 1,
      aux_sym__qid_token1,
    ACTIONS(11813), 1,
      anon_sym_DOT,
    ACTIONS(11815), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11817), 1,
      anon_sym_u2987,
    ACTIONS(11819), 1,
      aux_sym_integer_token1,
    ACTIONS(11821), 1,
      aux_sym_string_token1,
    ACTIONS(11823), 1,
      anon_sym_Set,
    ACTIONS(12809), 1,
      anon_sym_LBRACE,
    STATE(11873), 1,
      sym__atom_no_curly,
    STATE(11890), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11799), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [588010] = 19,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11795), 1,
      sym_id,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_record,
    ACTIONS(11803), 1,
      anon_sym_LPAREN,
    ACTIONS(11805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11807), 1,
      anon_sym_u2983,
    ACTIONS(11811), 1,
      aux_sym__qid_token1,
    ACTIONS(11813), 1,
      anon_sym_DOT,
    ACTIONS(11815), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11817), 1,
      anon_sym_u2987,
    ACTIONS(11819), 1,
      aux_sym_integer_token1,
    ACTIONS(11821), 1,
      aux_sym_string_token1,
    ACTIONS(11823), 1,
      anon_sym_Set,
    ACTIONS(12811), 1,
      anon_sym_LBRACE,
    STATE(11877), 1,
      sym__atom_no_curly,
    STATE(11890), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11799), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [588081] = 19,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11795), 1,
      sym_id,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_record,
    ACTIONS(11803), 1,
      anon_sym_LPAREN,
    ACTIONS(11805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11807), 1,
      anon_sym_u2983,
    ACTIONS(11811), 1,
      aux_sym__qid_token1,
    ACTIONS(11813), 1,
      anon_sym_DOT,
    ACTIONS(11815), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11817), 1,
      anon_sym_u2987,
    ACTIONS(11819), 1,
      aux_sym_integer_token1,
    ACTIONS(11821), 1,
      aux_sym_string_token1,
    ACTIONS(11823), 1,
      anon_sym_Set,
    ACTIONS(12813), 1,
      anon_sym_LBRACE,
    STATE(11881), 1,
      sym__atom_no_curly,
    STATE(11890), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11799), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [588152] = 19,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11795), 1,
      sym_id,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_record,
    ACTIONS(11803), 1,
      anon_sym_LPAREN,
    ACTIONS(11805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11807), 1,
      anon_sym_u2983,
    ACTIONS(11811), 1,
      aux_sym__qid_token1,
    ACTIONS(11813), 1,
      anon_sym_DOT,
    ACTIONS(11815), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11817), 1,
      anon_sym_u2987,
    ACTIONS(11819), 1,
      aux_sym_integer_token1,
    ACTIONS(11821), 1,
      aux_sym_string_token1,
    ACTIONS(11823), 1,
      anon_sym_Set,
    ACTIONS(12815), 1,
      anon_sym_LBRACE,
    STATE(11885), 1,
      sym__atom_no_curly,
    STATE(11890), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11799), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [588223] = 19,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11795), 1,
      sym_id,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_record,
    ACTIONS(11803), 1,
      anon_sym_LPAREN,
    ACTIONS(11805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11807), 1,
      anon_sym_u2983,
    ACTIONS(11811), 1,
      aux_sym__qid_token1,
    ACTIONS(11813), 1,
      anon_sym_DOT,
    ACTIONS(11815), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11817), 1,
      anon_sym_u2987,
    ACTIONS(11819), 1,
      aux_sym_integer_token1,
    ACTIONS(11821), 1,
      aux_sym_string_token1,
    ACTIONS(11823), 1,
      anon_sym_Set,
    ACTIONS(12817), 1,
      anon_sym_LBRACE,
    STATE(11212), 1,
      sym__atom_no_curly,
    STATE(11890), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11799), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [588294] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6326), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6324), 25,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [588335] = 19,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11795), 1,
      sym_id,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_record,
    ACTIONS(11803), 1,
      anon_sym_LPAREN,
    ACTIONS(11805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11807), 1,
      anon_sym_u2983,
    ACTIONS(11811), 1,
      aux_sym__qid_token1,
    ACTIONS(11813), 1,
      anon_sym_DOT,
    ACTIONS(11815), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11817), 1,
      anon_sym_u2987,
    ACTIONS(11819), 1,
      aux_sym_integer_token1,
    ACTIONS(11821), 1,
      aux_sym_string_token1,
    ACTIONS(11823), 1,
      anon_sym_Set,
    ACTIONS(12819), 1,
      anon_sym_LBRACE,
    STATE(10669), 1,
      sym__atom_no_curly,
    STATE(11890), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11799), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [588406] = 19,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11795), 1,
      sym_id,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_record,
    ACTIONS(11803), 1,
      anon_sym_LPAREN,
    ACTIONS(11805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11807), 1,
      anon_sym_u2983,
    ACTIONS(11811), 1,
      aux_sym__qid_token1,
    ACTIONS(11813), 1,
      anon_sym_DOT,
    ACTIONS(11815), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11817), 1,
      anon_sym_u2987,
    ACTIONS(11819), 1,
      aux_sym_integer_token1,
    ACTIONS(11821), 1,
      aux_sym_string_token1,
    ACTIONS(11823), 1,
      anon_sym_Set,
    ACTIONS(12821), 1,
      anon_sym_LBRACE,
    STATE(11889), 1,
      sym__atom_no_curly,
    STATE(11890), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11799), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [588477] = 19,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11795), 1,
      sym_id,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_record,
    ACTIONS(11803), 1,
      anon_sym_LPAREN,
    ACTIONS(11805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11807), 1,
      anon_sym_u2983,
    ACTIONS(11811), 1,
      aux_sym__qid_token1,
    ACTIONS(11813), 1,
      anon_sym_DOT,
    ACTIONS(11815), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11817), 1,
      anon_sym_u2987,
    ACTIONS(11819), 1,
      aux_sym_integer_token1,
    ACTIONS(11821), 1,
      aux_sym_string_token1,
    ACTIONS(11823), 1,
      anon_sym_Set,
    ACTIONS(12823), 1,
      anon_sym_LBRACE,
    STATE(11897), 1,
      sym__atom_no_curly,
    STATE(11890), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11799), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [588548] = 19,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11795), 1,
      sym_id,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_record,
    ACTIONS(11803), 1,
      anon_sym_LPAREN,
    ACTIONS(11805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11807), 1,
      anon_sym_u2983,
    ACTIONS(11811), 1,
      aux_sym__qid_token1,
    ACTIONS(11813), 1,
      anon_sym_DOT,
    ACTIONS(11815), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11817), 1,
      anon_sym_u2987,
    ACTIONS(11819), 1,
      aux_sym_integer_token1,
    ACTIONS(11821), 1,
      aux_sym_string_token1,
    ACTIONS(11823), 1,
      anon_sym_Set,
    ACTIONS(12825), 1,
      anon_sym_LBRACE,
    STATE(11131), 1,
      sym__atom_no_curly,
    STATE(11890), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11799), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [588619] = 19,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11795), 1,
      sym_id,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_record,
    ACTIONS(11803), 1,
      anon_sym_LPAREN,
    ACTIONS(11805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11807), 1,
      anon_sym_u2983,
    ACTIONS(11811), 1,
      aux_sym__qid_token1,
    ACTIONS(11813), 1,
      anon_sym_DOT,
    ACTIONS(11815), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11817), 1,
      anon_sym_u2987,
    ACTIONS(11819), 1,
      aux_sym_integer_token1,
    ACTIONS(11821), 1,
      aux_sym_string_token1,
    ACTIONS(11823), 1,
      anon_sym_Set,
    ACTIONS(12827), 1,
      anon_sym_LBRACE,
    STATE(11901), 1,
      sym__atom_no_curly,
    STATE(11890), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11799), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [588690] = 19,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11795), 1,
      sym_id,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_record,
    ACTIONS(11803), 1,
      anon_sym_LPAREN,
    ACTIONS(11805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11807), 1,
      anon_sym_u2983,
    ACTIONS(11811), 1,
      aux_sym__qid_token1,
    ACTIONS(11813), 1,
      anon_sym_DOT,
    ACTIONS(11815), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11817), 1,
      anon_sym_u2987,
    ACTIONS(11819), 1,
      aux_sym_integer_token1,
    ACTIONS(11821), 1,
      aux_sym_string_token1,
    ACTIONS(11823), 1,
      anon_sym_Set,
    ACTIONS(12829), 1,
      anon_sym_LBRACE,
    STATE(11905), 1,
      sym__atom_no_curly,
    STATE(11890), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11799), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [588761] = 19,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11795), 1,
      sym_id,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_record,
    ACTIONS(11803), 1,
      anon_sym_LPAREN,
    ACTIONS(11805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11807), 1,
      anon_sym_u2983,
    ACTIONS(11811), 1,
      aux_sym__qid_token1,
    ACTIONS(11813), 1,
      anon_sym_DOT,
    ACTIONS(11815), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11817), 1,
      anon_sym_u2987,
    ACTIONS(11819), 1,
      aux_sym_integer_token1,
    ACTIONS(11821), 1,
      aux_sym_string_token1,
    ACTIONS(11823), 1,
      anon_sym_Set,
    ACTIONS(12831), 1,
      anon_sym_LBRACE,
    STATE(11909), 1,
      sym__atom_no_curly,
    STATE(11890), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11799), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [588832] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6326), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6324), 25,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [588873] = 19,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11795), 1,
      sym_id,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_record,
    ACTIONS(11803), 1,
      anon_sym_LPAREN,
    ACTIONS(11805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11807), 1,
      anon_sym_u2983,
    ACTIONS(11811), 1,
      aux_sym__qid_token1,
    ACTIONS(11813), 1,
      anon_sym_DOT,
    ACTIONS(11815), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11817), 1,
      anon_sym_u2987,
    ACTIONS(11819), 1,
      aux_sym_integer_token1,
    ACTIONS(11821), 1,
      aux_sym_string_token1,
    ACTIONS(11823), 1,
      anon_sym_Set,
    ACTIONS(12833), 1,
      anon_sym_LBRACE,
    STATE(11659), 1,
      sym__atom_no_curly,
    STATE(11890), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11799), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [588944] = 19,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11795), 1,
      sym_id,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_record,
    ACTIONS(11803), 1,
      anon_sym_LPAREN,
    ACTIONS(11805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11807), 1,
      anon_sym_u2983,
    ACTIONS(11811), 1,
      aux_sym__qid_token1,
    ACTIONS(11813), 1,
      anon_sym_DOT,
    ACTIONS(11815), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11817), 1,
      anon_sym_u2987,
    ACTIONS(11819), 1,
      aux_sym_integer_token1,
    ACTIONS(11821), 1,
      aux_sym_string_token1,
    ACTIONS(11823), 1,
      anon_sym_Set,
    ACTIONS(12835), 1,
      anon_sym_LBRACE,
    STATE(11096), 1,
      sym__atom_no_curly,
    STATE(11890), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11799), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [589015] = 19,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11795), 1,
      sym_id,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_record,
    ACTIONS(11803), 1,
      anon_sym_LPAREN,
    ACTIONS(11805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11807), 1,
      anon_sym_u2983,
    ACTIONS(11811), 1,
      aux_sym__qid_token1,
    ACTIONS(11813), 1,
      anon_sym_DOT,
    ACTIONS(11815), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11817), 1,
      anon_sym_u2987,
    ACTIONS(11819), 1,
      aux_sym_integer_token1,
    ACTIONS(11821), 1,
      aux_sym_string_token1,
    ACTIONS(11823), 1,
      anon_sym_Set,
    ACTIONS(12837), 1,
      anon_sym_LBRACE,
    STATE(11278), 1,
      sym__atom_no_curly,
    STATE(11890), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11799), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [589086] = 3,
    ACTIONS(6761), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6759), 29,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [589125] = 19,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11795), 1,
      sym_id,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_record,
    ACTIONS(11803), 1,
      anon_sym_LPAREN,
    ACTIONS(11805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11807), 1,
      anon_sym_u2983,
    ACTIONS(11811), 1,
      aux_sym__qid_token1,
    ACTIONS(11813), 1,
      anon_sym_DOT,
    ACTIONS(11815), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11817), 1,
      anon_sym_u2987,
    ACTIONS(11819), 1,
      aux_sym_integer_token1,
    ACTIONS(11821), 1,
      aux_sym_string_token1,
    ACTIONS(11823), 1,
      anon_sym_Set,
    ACTIONS(12839), 1,
      anon_sym_LBRACE,
    STATE(11913), 1,
      sym__atom_no_curly,
    STATE(11890), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11799), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [589196] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6433), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6431), 25,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [589237] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6750), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6748), 25,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [589278] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6326), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6324), 25,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [589319] = 3,
    ACTIONS(6710), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6708), 29,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [589358] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6710), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6708), 25,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [589399] = 19,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11795), 1,
      sym_id,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_record,
    ACTIONS(11803), 1,
      anon_sym_LPAREN,
    ACTIONS(11805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11807), 1,
      anon_sym_u2983,
    ACTIONS(11811), 1,
      aux_sym__qid_token1,
    ACTIONS(11813), 1,
      anon_sym_DOT,
    ACTIONS(11815), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11817), 1,
      anon_sym_u2987,
    ACTIONS(11819), 1,
      aux_sym_integer_token1,
    ACTIONS(11821), 1,
      aux_sym_string_token1,
    ACTIONS(11823), 1,
      anon_sym_Set,
    ACTIONS(12841), 1,
      anon_sym_LBRACE,
    STATE(10335), 1,
      sym__atom_no_curly,
    STATE(11890), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11799), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [589470] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6754), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6752), 25,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [589511] = 19,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11795), 1,
      sym_id,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_record,
    ACTIONS(11803), 1,
      anon_sym_LPAREN,
    ACTIONS(11805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11807), 1,
      anon_sym_u2983,
    ACTIONS(11811), 1,
      aux_sym__qid_token1,
    ACTIONS(11813), 1,
      anon_sym_DOT,
    ACTIONS(11815), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11817), 1,
      anon_sym_u2987,
    ACTIONS(11819), 1,
      aux_sym_integer_token1,
    ACTIONS(11821), 1,
      aux_sym_string_token1,
    ACTIONS(11823), 1,
      anon_sym_Set,
    ACTIONS(12843), 1,
      anon_sym_LBRACE,
    STATE(11300), 1,
      sym__atom_no_curly,
    STATE(11890), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11799), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [589582] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6647), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6645), 25,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [589623] = 19,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11795), 1,
      sym_id,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_record,
    ACTIONS(11803), 1,
      anon_sym_LPAREN,
    ACTIONS(11805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11807), 1,
      anon_sym_u2983,
    ACTIONS(11811), 1,
      aux_sym__qid_token1,
    ACTIONS(11813), 1,
      anon_sym_DOT,
    ACTIONS(11815), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11817), 1,
      anon_sym_u2987,
    ACTIONS(11819), 1,
      aux_sym_integer_token1,
    ACTIONS(11821), 1,
      aux_sym_string_token1,
    ACTIONS(11823), 1,
      anon_sym_Set,
    ACTIONS(12845), 1,
      anon_sym_LBRACE,
    STATE(11917), 1,
      sym__atom_no_curly,
    STATE(11890), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11799), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [589694] = 19,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11795), 1,
      sym_id,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_record,
    ACTIONS(11803), 1,
      anon_sym_LPAREN,
    ACTIONS(11805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11807), 1,
      anon_sym_u2983,
    ACTIONS(11811), 1,
      aux_sym__qid_token1,
    ACTIONS(11813), 1,
      anon_sym_DOT,
    ACTIONS(11815), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11817), 1,
      anon_sym_u2987,
    ACTIONS(11819), 1,
      aux_sym_integer_token1,
    ACTIONS(11821), 1,
      aux_sym_string_token1,
    ACTIONS(11823), 1,
      anon_sym_Set,
    ACTIONS(12847), 1,
      anon_sym_LBRACE,
    STATE(10402), 1,
      sym__atom_no_curly,
    STATE(11890), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11799), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [589765] = 19,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11795), 1,
      sym_id,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_record,
    ACTIONS(11803), 1,
      anon_sym_LPAREN,
    ACTIONS(11805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11807), 1,
      anon_sym_u2983,
    ACTIONS(11811), 1,
      aux_sym__qid_token1,
    ACTIONS(11813), 1,
      anon_sym_DOT,
    ACTIONS(11815), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11817), 1,
      anon_sym_u2987,
    ACTIONS(11819), 1,
      aux_sym_integer_token1,
    ACTIONS(11821), 1,
      aux_sym_string_token1,
    ACTIONS(11823), 1,
      anon_sym_Set,
    ACTIONS(12849), 1,
      anon_sym_LBRACE,
    STATE(11586), 1,
      sym__atom_no_curly,
    STATE(11890), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11799), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [589836] = 19,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11795), 1,
      sym_id,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_record,
    ACTIONS(11803), 1,
      anon_sym_LPAREN,
    ACTIONS(11805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11807), 1,
      anon_sym_u2983,
    ACTIONS(11811), 1,
      aux_sym__qid_token1,
    ACTIONS(11813), 1,
      anon_sym_DOT,
    ACTIONS(11815), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11817), 1,
      anon_sym_u2987,
    ACTIONS(11819), 1,
      aux_sym_integer_token1,
    ACTIONS(11821), 1,
      aux_sym_string_token1,
    ACTIONS(11823), 1,
      anon_sym_Set,
    ACTIONS(12851), 1,
      anon_sym_LBRACE,
    STATE(11921), 1,
      sym__atom_no_curly,
    STATE(11890), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11799), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [589907] = 19,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11795), 1,
      sym_id,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_record,
    ACTIONS(11803), 1,
      anon_sym_LPAREN,
    ACTIONS(11805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11807), 1,
      anon_sym_u2983,
    ACTIONS(11811), 1,
      aux_sym__qid_token1,
    ACTIONS(11813), 1,
      anon_sym_DOT,
    ACTIONS(11815), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11817), 1,
      anon_sym_u2987,
    ACTIONS(11819), 1,
      aux_sym_integer_token1,
    ACTIONS(11821), 1,
      aux_sym_string_token1,
    ACTIONS(11823), 1,
      anon_sym_Set,
    ACTIONS(12853), 1,
      anon_sym_LBRACE,
    STATE(11778), 1,
      sym__atom_no_curly,
    STATE(11890), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11799), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [589978] = 19,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11795), 1,
      sym_id,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_record,
    ACTIONS(11803), 1,
      anon_sym_LPAREN,
    ACTIONS(11805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11807), 1,
      anon_sym_u2983,
    ACTIONS(11811), 1,
      aux_sym__qid_token1,
    ACTIONS(11813), 1,
      anon_sym_DOT,
    ACTIONS(11815), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11817), 1,
      anon_sym_u2987,
    ACTIONS(11819), 1,
      aux_sym_integer_token1,
    ACTIONS(11821), 1,
      aux_sym_string_token1,
    ACTIONS(11823), 1,
      anon_sym_Set,
    ACTIONS(12855), 1,
      anon_sym_LBRACE,
    STATE(11925), 1,
      sym__atom_no_curly,
    STATE(11890), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11799), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [590049] = 19,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11795), 1,
      sym_id,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_record,
    ACTIONS(11803), 1,
      anon_sym_LPAREN,
    ACTIONS(11805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11807), 1,
      anon_sym_u2983,
    ACTIONS(11811), 1,
      aux_sym__qid_token1,
    ACTIONS(11813), 1,
      anon_sym_DOT,
    ACTIONS(11815), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11817), 1,
      anon_sym_u2987,
    ACTIONS(11819), 1,
      aux_sym_integer_token1,
    ACTIONS(11821), 1,
      aux_sym_string_token1,
    ACTIONS(11823), 1,
      anon_sym_Set,
    ACTIONS(12857), 1,
      anon_sym_LBRACE,
    STATE(11929), 1,
      sym__atom_no_curly,
    STATE(11890), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11799), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [590120] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6496), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6494), 25,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [590161] = 19,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11795), 1,
      sym_id,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_record,
    ACTIONS(11803), 1,
      anon_sym_LPAREN,
    ACTIONS(11805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11807), 1,
      anon_sym_u2983,
    ACTIONS(11811), 1,
      aux_sym__qid_token1,
    ACTIONS(11813), 1,
      anon_sym_DOT,
    ACTIONS(11815), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11817), 1,
      anon_sym_u2987,
    ACTIONS(11819), 1,
      aux_sym_integer_token1,
    ACTIONS(11821), 1,
      aux_sym_string_token1,
    ACTIONS(11823), 1,
      anon_sym_Set,
    ACTIONS(12859), 1,
      anon_sym_LBRACE,
    STATE(11933), 1,
      sym__atom_no_curly,
    STATE(11890), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11799), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [590232] = 19,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11795), 1,
      sym_id,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_record,
    ACTIONS(11803), 1,
      anon_sym_LPAREN,
    ACTIONS(11805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11807), 1,
      anon_sym_u2983,
    ACTIONS(11811), 1,
      aux_sym__qid_token1,
    ACTIONS(11813), 1,
      anon_sym_DOT,
    ACTIONS(11815), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11817), 1,
      anon_sym_u2987,
    ACTIONS(11819), 1,
      aux_sym_integer_token1,
    ACTIONS(11821), 1,
      aux_sym_string_token1,
    ACTIONS(11823), 1,
      anon_sym_Set,
    ACTIONS(12861), 1,
      anon_sym_LBRACE,
    STATE(11322), 1,
      sym__atom_no_curly,
    STATE(11890), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11799), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [590303] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6655), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6653), 25,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [590344] = 19,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11795), 1,
      sym_id,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_record,
    ACTIONS(11803), 1,
      anon_sym_LPAREN,
    ACTIONS(11805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11807), 1,
      anon_sym_u2983,
    ACTIONS(11811), 1,
      aux_sym__qid_token1,
    ACTIONS(11813), 1,
      anon_sym_DOT,
    ACTIONS(11815), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11817), 1,
      anon_sym_u2987,
    ACTIONS(11819), 1,
      aux_sym_integer_token1,
    ACTIONS(11821), 1,
      aux_sym_string_token1,
    ACTIONS(11823), 1,
      anon_sym_Set,
    ACTIONS(12863), 1,
      anon_sym_LBRACE,
    STATE(11937), 1,
      sym__atom_no_curly,
    STATE(11890), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11799), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [590415] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6750), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6748), 25,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [590456] = 19,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11795), 1,
      sym_id,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_record,
    ACTIONS(11803), 1,
      anon_sym_LPAREN,
    ACTIONS(11805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11807), 1,
      anon_sym_u2983,
    ACTIONS(11811), 1,
      aux_sym__qid_token1,
    ACTIONS(11813), 1,
      anon_sym_DOT,
    ACTIONS(11815), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11817), 1,
      anon_sym_u2987,
    ACTIONS(11819), 1,
      aux_sym_integer_token1,
    ACTIONS(11821), 1,
      aux_sym_string_token1,
    ACTIONS(11823), 1,
      anon_sym_Set,
    ACTIONS(12865), 1,
      anon_sym_LBRACE,
    STATE(11941), 1,
      sym__atom_no_curly,
    STATE(11890), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11799), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [590527] = 19,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11795), 1,
      sym_id,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_record,
    ACTIONS(11803), 1,
      anon_sym_LPAREN,
    ACTIONS(11805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11807), 1,
      anon_sym_u2983,
    ACTIONS(11811), 1,
      aux_sym__qid_token1,
    ACTIONS(11813), 1,
      anon_sym_DOT,
    ACTIONS(11815), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11817), 1,
      anon_sym_u2987,
    ACTIONS(11819), 1,
      aux_sym_integer_token1,
    ACTIONS(11821), 1,
      aux_sym_string_token1,
    ACTIONS(11823), 1,
      anon_sym_Set,
    ACTIONS(12867), 1,
      anon_sym_LBRACE,
    STATE(11607), 1,
      sym__atom_no_curly,
    STATE(11890), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11799), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [590598] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6568), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6566), 25,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [590639] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6572), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6570), 25,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [590680] = 19,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11795), 1,
      sym_id,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_record,
    ACTIONS(11803), 1,
      anon_sym_LPAREN,
    ACTIONS(11805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11807), 1,
      anon_sym_u2983,
    ACTIONS(11811), 1,
      aux_sym__qid_token1,
    ACTIONS(11813), 1,
      anon_sym_DOT,
    ACTIONS(11815), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11817), 1,
      anon_sym_u2987,
    ACTIONS(11819), 1,
      aux_sym_integer_token1,
    ACTIONS(11821), 1,
      aux_sym_string_token1,
    ACTIONS(11823), 1,
      anon_sym_Set,
    ACTIONS(12869), 1,
      anon_sym_LBRACE,
    STATE(11945), 1,
      sym__atom_no_curly,
    STATE(11890), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11799), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [590751] = 19,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11795), 1,
      sym_id,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_record,
    ACTIONS(11803), 1,
      anon_sym_LPAREN,
    ACTIONS(11805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11807), 1,
      anon_sym_u2983,
    ACTIONS(11811), 1,
      aux_sym__qid_token1,
    ACTIONS(11813), 1,
      anon_sym_DOT,
    ACTIONS(11815), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11817), 1,
      anon_sym_u2987,
    ACTIONS(11819), 1,
      aux_sym_integer_token1,
    ACTIONS(11821), 1,
      aux_sym_string_token1,
    ACTIONS(11823), 1,
      anon_sym_Set,
    ACTIONS(12871), 1,
      anon_sym_LBRACE,
    STATE(11676), 1,
      sym__atom_no_curly,
    STATE(11890), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11799), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [590822] = 19,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11795), 1,
      sym_id,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_record,
    ACTIONS(11803), 1,
      anon_sym_LPAREN,
    ACTIONS(11805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11807), 1,
      anon_sym_u2983,
    ACTIONS(11811), 1,
      aux_sym__qid_token1,
    ACTIONS(11813), 1,
      anon_sym_DOT,
    ACTIONS(11815), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11817), 1,
      anon_sym_u2987,
    ACTIONS(11819), 1,
      aux_sym_integer_token1,
    ACTIONS(11821), 1,
      aux_sym_string_token1,
    ACTIONS(11823), 1,
      anon_sym_Set,
    ACTIONS(12873), 1,
      anon_sym_LBRACE,
    STATE(10284), 1,
      sym__atom_no_curly,
    STATE(11890), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11799), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [590893] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6651), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6649), 25,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [590934] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6754), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6752), 25,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [590975] = 19,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11795), 1,
      sym_id,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_record,
    ACTIONS(11803), 1,
      anon_sym_LPAREN,
    ACTIONS(11805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11807), 1,
      anon_sym_u2983,
    ACTIONS(11811), 1,
      aux_sym__qid_token1,
    ACTIONS(11813), 1,
      anon_sym_DOT,
    ACTIONS(11815), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11817), 1,
      anon_sym_u2987,
    ACTIONS(11819), 1,
      aux_sym_integer_token1,
    ACTIONS(11821), 1,
      aux_sym_string_token1,
    ACTIONS(11823), 1,
      anon_sym_Set,
    ACTIONS(12875), 1,
      anon_sym_LBRACE,
    STATE(11949), 1,
      sym__atom_no_curly,
    STATE(11890), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11799), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [591046] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6484), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6482), 25,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [591087] = 19,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11795), 1,
      sym_id,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_record,
    ACTIONS(11803), 1,
      anon_sym_LPAREN,
    ACTIONS(11805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11807), 1,
      anon_sym_u2983,
    ACTIONS(11811), 1,
      aux_sym__qid_token1,
    ACTIONS(11813), 1,
      anon_sym_DOT,
    ACTIONS(11815), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11817), 1,
      anon_sym_u2987,
    ACTIONS(11819), 1,
      aux_sym_integer_token1,
    ACTIONS(11821), 1,
      aux_sym_string_token1,
    ACTIONS(11823), 1,
      anon_sym_Set,
    ACTIONS(12877), 1,
      anon_sym_LBRACE,
    STATE(11344), 1,
      sym__atom_no_curly,
    STATE(11890), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11799), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [591158] = 19,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11795), 1,
      sym_id,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_record,
    ACTIONS(11803), 1,
      anon_sym_LPAREN,
    ACTIONS(11805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11807), 1,
      anon_sym_u2983,
    ACTIONS(11811), 1,
      aux_sym__qid_token1,
    ACTIONS(11813), 1,
      anon_sym_DOT,
    ACTIONS(11815), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11817), 1,
      anon_sym_u2987,
    ACTIONS(11819), 1,
      aux_sym_integer_token1,
    ACTIONS(11821), 1,
      aux_sym_string_token1,
    ACTIONS(11823), 1,
      anon_sym_Set,
    ACTIONS(12879), 1,
      anon_sym_LBRACE,
    STATE(11953), 1,
      sym__atom_no_curly,
    STATE(11890), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11799), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [591229] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6714), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6712), 25,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [591270] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6572), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6570), 25,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [591311] = 19,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11795), 1,
      sym_id,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_record,
    ACTIONS(11803), 1,
      anon_sym_LPAREN,
    ACTIONS(11805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11807), 1,
      anon_sym_u2983,
    ACTIONS(11811), 1,
      aux_sym__qid_token1,
    ACTIONS(11813), 1,
      anon_sym_DOT,
    ACTIONS(11815), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11817), 1,
      anon_sym_u2987,
    ACTIONS(11819), 1,
      aux_sym_integer_token1,
    ACTIONS(11821), 1,
      aux_sym_string_token1,
    ACTIONS(11823), 1,
      anon_sym_Set,
    ACTIONS(12881), 1,
      anon_sym_LBRACE,
    STATE(12141), 1,
      sym__atom_no_curly,
    STATE(11890), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11799), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [591382] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6710), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6708), 25,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [591423] = 19,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11795), 1,
      sym_id,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_record,
    ACTIONS(11803), 1,
      anon_sym_LPAREN,
    ACTIONS(11805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11807), 1,
      anon_sym_u2983,
    ACTIONS(11811), 1,
      aux_sym__qid_token1,
    ACTIONS(11813), 1,
      anon_sym_DOT,
    ACTIONS(11815), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11817), 1,
      anon_sym_u2987,
    ACTIONS(11819), 1,
      aux_sym_integer_token1,
    ACTIONS(11821), 1,
      aux_sym_string_token1,
    ACTIONS(11823), 1,
      anon_sym_Set,
    ACTIONS(12883), 1,
      anon_sym_LBRACE,
    STATE(11366), 1,
      sym__atom_no_curly,
    STATE(11890), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11799), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [591494] = 19,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11795), 1,
      sym_id,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_record,
    ACTIONS(11803), 1,
      anon_sym_LPAREN,
    ACTIONS(11805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11807), 1,
      anon_sym_u2983,
    ACTIONS(11811), 1,
      aux_sym__qid_token1,
    ACTIONS(11813), 1,
      anon_sym_DOT,
    ACTIONS(11815), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11817), 1,
      anon_sym_u2987,
    ACTIONS(11819), 1,
      aux_sym_integer_token1,
    ACTIONS(11821), 1,
      aux_sym_string_token1,
    ACTIONS(11823), 1,
      anon_sym_Set,
    ACTIONS(12885), 1,
      anon_sym_LBRACE,
    STATE(11388), 1,
      sym__atom_no_curly,
    STATE(11890), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11799), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [591565] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6750), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6748), 25,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [591606] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6433), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6431), 25,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [591647] = 5,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(12887), 1,
      anon_sym_AT,
    ACTIONS(6326), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6324), 24,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [591690] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6484), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6482), 25,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [591731] = 19,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11795), 1,
      sym_id,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_record,
    ACTIONS(11803), 1,
      anon_sym_LPAREN,
    ACTIONS(11805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11807), 1,
      anon_sym_u2983,
    ACTIONS(11811), 1,
      aux_sym__qid_token1,
    ACTIONS(11813), 1,
      anon_sym_DOT,
    ACTIONS(11815), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11817), 1,
      anon_sym_u2987,
    ACTIONS(11819), 1,
      aux_sym_integer_token1,
    ACTIONS(11821), 1,
      aux_sym_string_token1,
    ACTIONS(11823), 1,
      anon_sym_Set,
    ACTIONS(12889), 1,
      anon_sym_LBRACE,
    STATE(11957), 1,
      sym__atom_no_curly,
    STATE(11890), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11799), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [591802] = 19,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11795), 1,
      sym_id,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_record,
    ACTIONS(11803), 1,
      anon_sym_LPAREN,
    ACTIONS(11805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11807), 1,
      anon_sym_u2983,
    ACTIONS(11811), 1,
      aux_sym__qid_token1,
    ACTIONS(11813), 1,
      anon_sym_DOT,
    ACTIONS(11815), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11817), 1,
      anon_sym_u2987,
    ACTIONS(11819), 1,
      aux_sym_integer_token1,
    ACTIONS(11821), 1,
      aux_sym_string_token1,
    ACTIONS(11823), 1,
      anon_sym_Set,
    ACTIONS(12891), 1,
      anon_sym_LBRACE,
    STATE(11961), 1,
      sym__atom_no_curly,
    STATE(11890), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11799), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [591873] = 19,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11795), 1,
      sym_id,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_record,
    ACTIONS(11803), 1,
      anon_sym_LPAREN,
    ACTIONS(11805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11807), 1,
      anon_sym_u2983,
    ACTIONS(11811), 1,
      aux_sym__qid_token1,
    ACTIONS(11813), 1,
      anon_sym_DOT,
    ACTIONS(11815), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11817), 1,
      anon_sym_u2987,
    ACTIONS(11819), 1,
      aux_sym_integer_token1,
    ACTIONS(11821), 1,
      aux_sym_string_token1,
    ACTIONS(11823), 1,
      anon_sym_Set,
    ACTIONS(12893), 1,
      anon_sym_LBRACE,
    STATE(11965), 1,
      sym__atom_no_curly,
    STATE(11890), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11799), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [591944] = 19,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11795), 1,
      sym_id,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_record,
    ACTIONS(11803), 1,
      anon_sym_LPAREN,
    ACTIONS(11805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11807), 1,
      anon_sym_u2983,
    ACTIONS(11811), 1,
      aux_sym__qid_token1,
    ACTIONS(11813), 1,
      anon_sym_DOT,
    ACTIONS(11815), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11817), 1,
      anon_sym_u2987,
    ACTIONS(11819), 1,
      aux_sym_integer_token1,
    ACTIONS(11821), 1,
      aux_sym_string_token1,
    ACTIONS(11823), 1,
      anon_sym_Set,
    ACTIONS(12895), 1,
      anon_sym_LBRACE,
    STATE(11164), 1,
      sym__atom_no_curly,
    STATE(11890), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11799), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [592015] = 19,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11795), 1,
      sym_id,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_record,
    ACTIONS(11803), 1,
      anon_sym_LPAREN,
    ACTIONS(11805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11807), 1,
      anon_sym_u2983,
    ACTIONS(11811), 1,
      aux_sym__qid_token1,
    ACTIONS(11813), 1,
      anon_sym_DOT,
    ACTIONS(11815), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11817), 1,
      anon_sym_u2987,
    ACTIONS(11819), 1,
      aux_sym_integer_token1,
    ACTIONS(11821), 1,
      aux_sym_string_token1,
    ACTIONS(11823), 1,
      anon_sym_Set,
    ACTIONS(12897), 1,
      anon_sym_LBRACE,
    STATE(11969), 1,
      sym__atom_no_curly,
    STATE(11890), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11799), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [592086] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6647), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6645), 25,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [592127] = 19,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11795), 1,
      sym_id,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_record,
    ACTIONS(11803), 1,
      anon_sym_LPAREN,
    ACTIONS(11805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11807), 1,
      anon_sym_u2983,
    ACTIONS(11811), 1,
      aux_sym__qid_token1,
    ACTIONS(11813), 1,
      anon_sym_DOT,
    ACTIONS(11815), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11817), 1,
      anon_sym_u2987,
    ACTIONS(11819), 1,
      aux_sym_integer_token1,
    ACTIONS(11821), 1,
      aux_sym_string_token1,
    ACTIONS(11823), 1,
      anon_sym_Set,
    ACTIONS(12899), 1,
      anon_sym_LBRACE,
    STATE(10457), 1,
      sym__atom_no_curly,
    STATE(11890), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11799), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [592198] = 19,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11795), 1,
      sym_id,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_record,
    ACTIONS(11803), 1,
      anon_sym_LPAREN,
    ACTIONS(11805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11807), 1,
      anon_sym_u2983,
    ACTIONS(11811), 1,
      aux_sym__qid_token1,
    ACTIONS(11813), 1,
      anon_sym_DOT,
    ACTIONS(11815), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11817), 1,
      anon_sym_u2987,
    ACTIONS(11819), 1,
      aux_sym_integer_token1,
    ACTIONS(11821), 1,
      aux_sym_string_token1,
    ACTIONS(11823), 1,
      anon_sym_Set,
    ACTIONS(12901), 1,
      anon_sym_LBRACE,
    STATE(11973), 1,
      sym__atom_no_curly,
    STATE(11890), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11799), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [592269] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6433), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6431), 25,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [592310] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6710), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6708), 25,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [592351] = 19,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11795), 1,
      sym_id,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_record,
    ACTIONS(11803), 1,
      anon_sym_LPAREN,
    ACTIONS(11805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11807), 1,
      anon_sym_u2983,
    ACTIONS(11811), 1,
      aux_sym__qid_token1,
    ACTIONS(11813), 1,
      anon_sym_DOT,
    ACTIONS(11815), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11817), 1,
      anon_sym_u2987,
    ACTIONS(11819), 1,
      aux_sym_integer_token1,
    ACTIONS(11821), 1,
      aux_sym_string_token1,
    ACTIONS(11823), 1,
      anon_sym_Set,
    ACTIONS(12903), 1,
      anon_sym_LBRACE,
    STATE(10827), 1,
      sym__atom_no_curly,
    STATE(11890), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11799), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [592422] = 19,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11795), 1,
      sym_id,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_record,
    ACTIONS(11803), 1,
      anon_sym_LPAREN,
    ACTIONS(11805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11807), 1,
      anon_sym_u2983,
    ACTIONS(11811), 1,
      aux_sym__qid_token1,
    ACTIONS(11813), 1,
      anon_sym_DOT,
    ACTIONS(11815), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11817), 1,
      anon_sym_u2987,
    ACTIONS(11819), 1,
      aux_sym_integer_token1,
    ACTIONS(11821), 1,
      aux_sym_string_token1,
    ACTIONS(11823), 1,
      anon_sym_Set,
    ACTIONS(12905), 1,
      anon_sym_LBRACE,
    STATE(11977), 1,
      sym__atom_no_curly,
    STATE(11890), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11799), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [592493] = 19,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11795), 1,
      sym_id,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_record,
    ACTIONS(11803), 1,
      anon_sym_LPAREN,
    ACTIONS(11805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11807), 1,
      anon_sym_u2983,
    ACTIONS(11811), 1,
      aux_sym__qid_token1,
    ACTIONS(11813), 1,
      anon_sym_DOT,
    ACTIONS(11815), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11817), 1,
      anon_sym_u2987,
    ACTIONS(11819), 1,
      aux_sym_integer_token1,
    ACTIONS(11821), 1,
      aux_sym_string_token1,
    ACTIONS(11823), 1,
      anon_sym_Set,
    ACTIONS(12907), 1,
      anon_sym_LBRACE,
    STATE(11981), 1,
      sym__atom_no_curly,
    STATE(11890), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11799), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [592564] = 19,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11795), 1,
      sym_id,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_record,
    ACTIONS(11803), 1,
      anon_sym_LPAREN,
    ACTIONS(11805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11807), 1,
      anon_sym_u2983,
    ACTIONS(11811), 1,
      aux_sym__qid_token1,
    ACTIONS(11813), 1,
      anon_sym_DOT,
    ACTIONS(11815), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11817), 1,
      anon_sym_u2987,
    ACTIONS(11819), 1,
      aux_sym_integer_token1,
    ACTIONS(11821), 1,
      aux_sym_string_token1,
    ACTIONS(11823), 1,
      anon_sym_Set,
    ACTIONS(12909), 1,
      anon_sym_LBRACE,
    STATE(11061), 1,
      sym__atom_no_curly,
    STATE(11890), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11799), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [592635] = 19,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11795), 1,
      sym_id,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_record,
    ACTIONS(11803), 1,
      anon_sym_LPAREN,
    ACTIONS(11805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11807), 1,
      anon_sym_u2983,
    ACTIONS(11811), 1,
      aux_sym__qid_token1,
    ACTIONS(11813), 1,
      anon_sym_DOT,
    ACTIONS(11815), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11817), 1,
      anon_sym_u2987,
    ACTIONS(11819), 1,
      aux_sym_integer_token1,
    ACTIONS(11821), 1,
      aux_sym_string_token1,
    ACTIONS(11823), 1,
      anon_sym_Set,
    ACTIONS(12911), 1,
      anon_sym_LBRACE,
    STATE(11985), 1,
      sym__atom_no_curly,
    STATE(11890), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11799), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [592706] = 19,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11795), 1,
      sym_id,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_record,
    ACTIONS(11803), 1,
      anon_sym_LPAREN,
    ACTIONS(11805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11807), 1,
      anon_sym_u2983,
    ACTIONS(11811), 1,
      aux_sym__qid_token1,
    ACTIONS(11813), 1,
      anon_sym_DOT,
    ACTIONS(11815), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11817), 1,
      anon_sym_u2987,
    ACTIONS(11819), 1,
      aux_sym_integer_token1,
    ACTIONS(11821), 1,
      aux_sym_string_token1,
    ACTIONS(11823), 1,
      anon_sym_Set,
    ACTIONS(12913), 1,
      anon_sym_LBRACE,
    STATE(11989), 1,
      sym__atom_no_curly,
    STATE(11890), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11799), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [592777] = 19,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11795), 1,
      sym_id,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_record,
    ACTIONS(11803), 1,
      anon_sym_LPAREN,
    ACTIONS(11805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11807), 1,
      anon_sym_u2983,
    ACTIONS(11811), 1,
      aux_sym__qid_token1,
    ACTIONS(11813), 1,
      anon_sym_DOT,
    ACTIONS(11815), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11817), 1,
      anon_sym_u2987,
    ACTIONS(11819), 1,
      aux_sym_integer_token1,
    ACTIONS(11821), 1,
      aux_sym_string_token1,
    ACTIONS(11823), 1,
      anon_sym_Set,
    ACTIONS(12915), 1,
      anon_sym_LBRACE,
    STATE(11993), 1,
      sym__atom_no_curly,
    STATE(11890), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11799), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [592848] = 19,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11795), 1,
      sym_id,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_record,
    ACTIONS(11803), 1,
      anon_sym_LPAREN,
    ACTIONS(11805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11807), 1,
      anon_sym_u2983,
    ACTIONS(11811), 1,
      aux_sym__qid_token1,
    ACTIONS(11813), 1,
      anon_sym_DOT,
    ACTIONS(11815), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11817), 1,
      anon_sym_u2987,
    ACTIONS(11819), 1,
      aux_sym_integer_token1,
    ACTIONS(11821), 1,
      aux_sym_string_token1,
    ACTIONS(11823), 1,
      anon_sym_Set,
    ACTIONS(12917), 1,
      anon_sym_LBRACE,
    STATE(11997), 1,
      sym__atom_no_curly,
    STATE(11890), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11799), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [592919] = 19,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11795), 1,
      sym_id,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_record,
    ACTIONS(11803), 1,
      anon_sym_LPAREN,
    ACTIONS(11805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11807), 1,
      anon_sym_u2983,
    ACTIONS(11811), 1,
      aux_sym__qid_token1,
    ACTIONS(11813), 1,
      anon_sym_DOT,
    ACTIONS(11815), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11817), 1,
      anon_sym_u2987,
    ACTIONS(11819), 1,
      aux_sym_integer_token1,
    ACTIONS(11821), 1,
      aux_sym_string_token1,
    ACTIONS(11823), 1,
      anon_sym_Set,
    ACTIONS(12919), 1,
      anon_sym_LBRACE,
    STATE(12001), 1,
      sym__atom_no_curly,
    STATE(11890), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11799), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [592990] = 19,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11795), 1,
      sym_id,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_record,
    ACTIONS(11803), 1,
      anon_sym_LPAREN,
    ACTIONS(11805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11807), 1,
      anon_sym_u2983,
    ACTIONS(11811), 1,
      aux_sym__qid_token1,
    ACTIONS(11813), 1,
      anon_sym_DOT,
    ACTIONS(11815), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11817), 1,
      anon_sym_u2987,
    ACTIONS(11819), 1,
      aux_sym_integer_token1,
    ACTIONS(11821), 1,
      aux_sym_string_token1,
    ACTIONS(11823), 1,
      anon_sym_Set,
    ACTIONS(12921), 1,
      anon_sym_LBRACE,
    STATE(12005), 1,
      sym__atom_no_curly,
    STATE(11890), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11799), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [593061] = 19,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11795), 1,
      sym_id,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_record,
    ACTIONS(11803), 1,
      anon_sym_LPAREN,
    ACTIONS(11805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11807), 1,
      anon_sym_u2983,
    ACTIONS(11811), 1,
      aux_sym__qid_token1,
    ACTIONS(11813), 1,
      anon_sym_DOT,
    ACTIONS(11815), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11817), 1,
      anon_sym_u2987,
    ACTIONS(11819), 1,
      aux_sym_integer_token1,
    ACTIONS(11821), 1,
      aux_sym_string_token1,
    ACTIONS(11823), 1,
      anon_sym_Set,
    ACTIONS(12923), 1,
      anon_sym_LBRACE,
    STATE(12009), 1,
      sym__atom_no_curly,
    STATE(11890), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11799), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [593132] = 19,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11795), 1,
      sym_id,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_record,
    ACTIONS(11803), 1,
      anon_sym_LPAREN,
    ACTIONS(11805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11807), 1,
      anon_sym_u2983,
    ACTIONS(11811), 1,
      aux_sym__qid_token1,
    ACTIONS(11813), 1,
      anon_sym_DOT,
    ACTIONS(11815), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11817), 1,
      anon_sym_u2987,
    ACTIONS(11819), 1,
      aux_sym_integer_token1,
    ACTIONS(11821), 1,
      aux_sym_string_token1,
    ACTIONS(11823), 1,
      anon_sym_Set,
    ACTIONS(12925), 1,
      anon_sym_LBRACE,
    STATE(12013), 1,
      sym__atom_no_curly,
    STATE(11890), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11799), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [593203] = 19,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11795), 1,
      sym_id,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_record,
    ACTIONS(11803), 1,
      anon_sym_LPAREN,
    ACTIONS(11805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11807), 1,
      anon_sym_u2983,
    ACTIONS(11811), 1,
      aux_sym__qid_token1,
    ACTIONS(11813), 1,
      anon_sym_DOT,
    ACTIONS(11815), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11817), 1,
      anon_sym_u2987,
    ACTIONS(11819), 1,
      aux_sym_integer_token1,
    ACTIONS(11821), 1,
      aux_sym_string_token1,
    ACTIONS(11823), 1,
      anon_sym_Set,
    ACTIONS(12927), 1,
      anon_sym_LBRACE,
    STATE(12017), 1,
      sym__atom_no_curly,
    STATE(11890), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11799), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [593274] = 19,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11795), 1,
      sym_id,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_record,
    ACTIONS(11803), 1,
      anon_sym_LPAREN,
    ACTIONS(11805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11807), 1,
      anon_sym_u2983,
    ACTIONS(11811), 1,
      aux_sym__qid_token1,
    ACTIONS(11813), 1,
      anon_sym_DOT,
    ACTIONS(11815), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11817), 1,
      anon_sym_u2987,
    ACTIONS(11819), 1,
      aux_sym_integer_token1,
    ACTIONS(11821), 1,
      aux_sym_string_token1,
    ACTIONS(11823), 1,
      anon_sym_Set,
    ACTIONS(12929), 1,
      anon_sym_LBRACE,
    STATE(12021), 1,
      sym__atom_no_curly,
    STATE(11890), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11799), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [593345] = 19,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11795), 1,
      sym_id,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_record,
    ACTIONS(11803), 1,
      anon_sym_LPAREN,
    ACTIONS(11805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11807), 1,
      anon_sym_u2983,
    ACTIONS(11811), 1,
      aux_sym__qid_token1,
    ACTIONS(11813), 1,
      anon_sym_DOT,
    ACTIONS(11815), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11817), 1,
      anon_sym_u2987,
    ACTIONS(11819), 1,
      aux_sym_integer_token1,
    ACTIONS(11821), 1,
      aux_sym_string_token1,
    ACTIONS(11823), 1,
      anon_sym_Set,
    ACTIONS(12931), 1,
      anon_sym_LBRACE,
    STATE(12025), 1,
      sym__atom_no_curly,
    STATE(11890), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11799), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [593416] = 19,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11795), 1,
      sym_id,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_record,
    ACTIONS(11803), 1,
      anon_sym_LPAREN,
    ACTIONS(11805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11807), 1,
      anon_sym_u2983,
    ACTIONS(11811), 1,
      aux_sym__qid_token1,
    ACTIONS(11813), 1,
      anon_sym_DOT,
    ACTIONS(11815), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11817), 1,
      anon_sym_u2987,
    ACTIONS(11819), 1,
      aux_sym_integer_token1,
    ACTIONS(11821), 1,
      aux_sym_string_token1,
    ACTIONS(11823), 1,
      anon_sym_Set,
    ACTIONS(12933), 1,
      anon_sym_LBRACE,
    STATE(12029), 1,
      sym__atom_no_curly,
    STATE(11890), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11799), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [593487] = 19,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11795), 1,
      sym_id,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_record,
    ACTIONS(11803), 1,
      anon_sym_LPAREN,
    ACTIONS(11805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11807), 1,
      anon_sym_u2983,
    ACTIONS(11811), 1,
      aux_sym__qid_token1,
    ACTIONS(11813), 1,
      anon_sym_DOT,
    ACTIONS(11815), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11817), 1,
      anon_sym_u2987,
    ACTIONS(11819), 1,
      aux_sym_integer_token1,
    ACTIONS(11821), 1,
      aux_sym_string_token1,
    ACTIONS(11823), 1,
      anon_sym_Set,
    ACTIONS(12935), 1,
      anon_sym_LBRACE,
    STATE(11564), 1,
      sym__atom_no_curly,
    STATE(11890), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11799), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [593558] = 19,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11795), 1,
      sym_id,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_record,
    ACTIONS(11803), 1,
      anon_sym_LPAREN,
    ACTIONS(11805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11807), 1,
      anon_sym_u2983,
    ACTIONS(11811), 1,
      aux_sym__qid_token1,
    ACTIONS(11813), 1,
      anon_sym_DOT,
    ACTIONS(11815), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11817), 1,
      anon_sym_u2987,
    ACTIONS(11819), 1,
      aux_sym_integer_token1,
    ACTIONS(11821), 1,
      aux_sym_string_token1,
    ACTIONS(11823), 1,
      anon_sym_Set,
    ACTIONS(12937), 1,
      anon_sym_LBRACE,
    STATE(11542), 1,
      sym__atom_no_curly,
    STATE(11890), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11799), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [593629] = 19,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11795), 1,
      sym_id,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_record,
    ACTIONS(11803), 1,
      anon_sym_LPAREN,
    ACTIONS(11805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11807), 1,
      anon_sym_u2983,
    ACTIONS(11811), 1,
      aux_sym__qid_token1,
    ACTIONS(11813), 1,
      anon_sym_DOT,
    ACTIONS(11815), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11817), 1,
      anon_sym_u2987,
    ACTIONS(11819), 1,
      aux_sym_integer_token1,
    ACTIONS(11821), 1,
      aux_sym_string_token1,
    ACTIONS(11823), 1,
      anon_sym_Set,
    ACTIONS(12939), 1,
      anon_sym_LBRACE,
    STATE(12033), 1,
      sym__atom_no_curly,
    STATE(11890), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11799), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [593700] = 19,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11795), 1,
      sym_id,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_record,
    ACTIONS(11803), 1,
      anon_sym_LPAREN,
    ACTIONS(11805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11807), 1,
      anon_sym_u2983,
    ACTIONS(11811), 1,
      aux_sym__qid_token1,
    ACTIONS(11813), 1,
      anon_sym_DOT,
    ACTIONS(11815), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11817), 1,
      anon_sym_u2987,
    ACTIONS(11819), 1,
      aux_sym_integer_token1,
    ACTIONS(11821), 1,
      aux_sym_string_token1,
    ACTIONS(11823), 1,
      anon_sym_Set,
    ACTIONS(12941), 1,
      anon_sym_LBRACE,
    STATE(12037), 1,
      sym__atom_no_curly,
    STATE(11890), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11799), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [593771] = 19,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11795), 1,
      sym_id,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_record,
    ACTIONS(11803), 1,
      anon_sym_LPAREN,
    ACTIONS(11805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11807), 1,
      anon_sym_u2983,
    ACTIONS(11811), 1,
      aux_sym__qid_token1,
    ACTIONS(11813), 1,
      anon_sym_DOT,
    ACTIONS(11815), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11817), 1,
      anon_sym_u2987,
    ACTIONS(11819), 1,
      aux_sym_integer_token1,
    ACTIONS(11821), 1,
      aux_sym_string_token1,
    ACTIONS(11823), 1,
      anon_sym_Set,
    ACTIONS(12943), 1,
      anon_sym_LBRACE,
    STATE(12041), 1,
      sym__atom_no_curly,
    STATE(11890), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11799), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [593842] = 19,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11795), 1,
      sym_id,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_record,
    ACTIONS(11803), 1,
      anon_sym_LPAREN,
    ACTIONS(11805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11807), 1,
      anon_sym_u2983,
    ACTIONS(11811), 1,
      aux_sym__qid_token1,
    ACTIONS(11813), 1,
      anon_sym_DOT,
    ACTIONS(11815), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11817), 1,
      anon_sym_u2987,
    ACTIONS(11819), 1,
      aux_sym_integer_token1,
    ACTIONS(11821), 1,
      aux_sym_string_token1,
    ACTIONS(11823), 1,
      anon_sym_Set,
    ACTIONS(12945), 1,
      anon_sym_LBRACE,
    STATE(12045), 1,
      sym__atom_no_curly,
    STATE(11890), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11799), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [593913] = 19,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11795), 1,
      sym_id,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_record,
    ACTIONS(11803), 1,
      anon_sym_LPAREN,
    ACTIONS(11805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11807), 1,
      anon_sym_u2983,
    ACTIONS(11811), 1,
      aux_sym__qid_token1,
    ACTIONS(11813), 1,
      anon_sym_DOT,
    ACTIONS(11815), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11817), 1,
      anon_sym_u2987,
    ACTIONS(11819), 1,
      aux_sym_integer_token1,
    ACTIONS(11821), 1,
      aux_sym_string_token1,
    ACTIONS(11823), 1,
      anon_sym_Set,
    ACTIONS(12947), 1,
      anon_sym_LBRACE,
    STATE(12049), 1,
      sym__atom_no_curly,
    STATE(11890), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11799), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [593984] = 19,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11795), 1,
      sym_id,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_record,
    ACTIONS(11803), 1,
      anon_sym_LPAREN,
    ACTIONS(11805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11807), 1,
      anon_sym_u2983,
    ACTIONS(11811), 1,
      aux_sym__qid_token1,
    ACTIONS(11813), 1,
      anon_sym_DOT,
    ACTIONS(11815), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11817), 1,
      anon_sym_u2987,
    ACTIONS(11819), 1,
      aux_sym_integer_token1,
    ACTIONS(11821), 1,
      aux_sym_string_token1,
    ACTIONS(11823), 1,
      anon_sym_Set,
    ACTIONS(12949), 1,
      anon_sym_LBRACE,
    STATE(12053), 1,
      sym__atom_no_curly,
    STATE(11890), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11799), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [594055] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6714), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6712), 25,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [594096] = 19,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11795), 1,
      sym_id,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_record,
    ACTIONS(11803), 1,
      anon_sym_LPAREN,
    ACTIONS(11805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11807), 1,
      anon_sym_u2983,
    ACTIONS(11811), 1,
      aux_sym__qid_token1,
    ACTIONS(11813), 1,
      anon_sym_DOT,
    ACTIONS(11815), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11817), 1,
      anon_sym_u2987,
    ACTIONS(11819), 1,
      aux_sym_integer_token1,
    ACTIONS(11821), 1,
      aux_sym_string_token1,
    ACTIONS(11823), 1,
      anon_sym_Set,
    ACTIONS(12951), 1,
      anon_sym_LBRACE,
    STATE(12057), 1,
      sym__atom_no_curly,
    STATE(11890), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11799), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [594167] = 19,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11795), 1,
      sym_id,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_record,
    ACTIONS(11803), 1,
      anon_sym_LPAREN,
    ACTIONS(11805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11807), 1,
      anon_sym_u2983,
    ACTIONS(11811), 1,
      aux_sym__qid_token1,
    ACTIONS(11813), 1,
      anon_sym_DOT,
    ACTIONS(11815), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11817), 1,
      anon_sym_u2987,
    ACTIONS(11819), 1,
      aux_sym_integer_token1,
    ACTIONS(11821), 1,
      aux_sym_string_token1,
    ACTIONS(11823), 1,
      anon_sym_Set,
    ACTIONS(12953), 1,
      anon_sym_LBRACE,
    STATE(12061), 1,
      sym__atom_no_curly,
    STATE(11890), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11799), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [594238] = 19,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11795), 1,
      sym_id,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_record,
    ACTIONS(11803), 1,
      anon_sym_LPAREN,
    ACTIONS(11805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11807), 1,
      anon_sym_u2983,
    ACTIONS(11811), 1,
      aux_sym__qid_token1,
    ACTIONS(11813), 1,
      anon_sym_DOT,
    ACTIONS(11815), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11817), 1,
      anon_sym_u2987,
    ACTIONS(11819), 1,
      aux_sym_integer_token1,
    ACTIONS(11821), 1,
      aux_sym_string_token1,
    ACTIONS(11823), 1,
      anon_sym_Set,
    ACTIONS(12955), 1,
      anon_sym_LBRACE,
    STATE(11761), 1,
      sym__atom_no_curly,
    STATE(11890), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11799), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [594309] = 19,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11133), 1,
      sym_id,
    ACTIONS(11135), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11139), 1,
      anon_sym_record,
    ACTIONS(11141), 1,
      anon_sym_LPAREN,
    ACTIONS(11143), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11145), 1,
      anon_sym_u2983,
    ACTIONS(11149), 1,
      aux_sym__qid_token1,
    ACTIONS(11151), 1,
      anon_sym_DOT,
    ACTIONS(11153), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11155), 1,
      anon_sym_u2987,
    ACTIONS(11157), 1,
      aux_sym_integer_token1,
    ACTIONS(11159), 1,
      aux_sym_string_token1,
    ACTIONS(11161), 1,
      anon_sym_Set,
    ACTIONS(12957), 1,
      anon_sym_LBRACE,
    STATE(8009), 1,
      sym__atom_no_curly,
    STATE(8832), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11137), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [594380] = 19,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11795), 1,
      sym_id,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_record,
    ACTIONS(11803), 1,
      anon_sym_LPAREN,
    ACTIONS(11805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11807), 1,
      anon_sym_u2983,
    ACTIONS(11811), 1,
      aux_sym__qid_token1,
    ACTIONS(11813), 1,
      anon_sym_DOT,
    ACTIONS(11815), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11817), 1,
      anon_sym_u2987,
    ACTIONS(11819), 1,
      aux_sym_integer_token1,
    ACTIONS(11821), 1,
      aux_sym_string_token1,
    ACTIONS(11823), 1,
      anon_sym_Set,
    ACTIONS(12959), 1,
      anon_sym_LBRACE,
    STATE(10722), 1,
      sym__atom_no_curly,
    STATE(11890), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11799), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [594451] = 19,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11795), 1,
      sym_id,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_record,
    ACTIONS(11803), 1,
      anon_sym_LPAREN,
    ACTIONS(11805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11807), 1,
      anon_sym_u2983,
    ACTIONS(11811), 1,
      aux_sym__qid_token1,
    ACTIONS(11813), 1,
      anon_sym_DOT,
    ACTIONS(11815), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11817), 1,
      anon_sym_u2987,
    ACTIONS(11819), 1,
      aux_sym_integer_token1,
    ACTIONS(11821), 1,
      aux_sym_string_token1,
    ACTIONS(11823), 1,
      anon_sym_Set,
    ACTIONS(12961), 1,
      anon_sym_LBRACE,
    STATE(12193), 1,
      sym__atom_no_curly,
    STATE(11890), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11799), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [594522] = 19,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11795), 1,
      sym_id,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_record,
    ACTIONS(11803), 1,
      anon_sym_LPAREN,
    ACTIONS(11805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11807), 1,
      anon_sym_u2983,
    ACTIONS(11811), 1,
      aux_sym__qid_token1,
    ACTIONS(11813), 1,
      anon_sym_DOT,
    ACTIONS(11815), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11817), 1,
      anon_sym_u2987,
    ACTIONS(11819), 1,
      aux_sym_integer_token1,
    ACTIONS(11821), 1,
      aux_sym_string_token1,
    ACTIONS(11823), 1,
      anon_sym_Set,
    ACTIONS(12963), 1,
      anon_sym_LBRACE,
    STATE(12065), 1,
      sym__atom_no_curly,
    STATE(11890), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11799), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [594593] = 19,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11795), 1,
      sym_id,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_record,
    ACTIONS(11803), 1,
      anon_sym_LPAREN,
    ACTIONS(11805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11807), 1,
      anon_sym_u2983,
    ACTIONS(11811), 1,
      aux_sym__qid_token1,
    ACTIONS(11813), 1,
      anon_sym_DOT,
    ACTIONS(11815), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11817), 1,
      anon_sym_u2987,
    ACTIONS(11819), 1,
      aux_sym_integer_token1,
    ACTIONS(11821), 1,
      aux_sym_string_token1,
    ACTIONS(11823), 1,
      anon_sym_Set,
    ACTIONS(12965), 1,
      anon_sym_LBRACE,
    STATE(11625), 1,
      sym__atom_no_curly,
    STATE(11890), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11799), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [594664] = 19,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11795), 1,
      sym_id,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_record,
    ACTIONS(11803), 1,
      anon_sym_LPAREN,
    ACTIONS(11805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11807), 1,
      anon_sym_u2983,
    ACTIONS(11811), 1,
      aux_sym__qid_token1,
    ACTIONS(11813), 1,
      anon_sym_DOT,
    ACTIONS(11815), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11817), 1,
      anon_sym_u2987,
    ACTIONS(11819), 1,
      aux_sym_integer_token1,
    ACTIONS(11821), 1,
      aux_sym_string_token1,
    ACTIONS(11823), 1,
      anon_sym_Set,
    ACTIONS(12967), 1,
      anon_sym_LBRACE,
    STATE(12069), 1,
      sym__atom_no_curly,
    STATE(11890), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11799), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [594735] = 19,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11795), 1,
      sym_id,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_record,
    ACTIONS(11803), 1,
      anon_sym_LPAREN,
    ACTIONS(11805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11807), 1,
      anon_sym_u2983,
    ACTIONS(11811), 1,
      aux_sym__qid_token1,
    ACTIONS(11813), 1,
      anon_sym_DOT,
    ACTIONS(11815), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11817), 1,
      anon_sym_u2987,
    ACTIONS(11819), 1,
      aux_sym_integer_token1,
    ACTIONS(11821), 1,
      aux_sym_string_token1,
    ACTIONS(11823), 1,
      anon_sym_Set,
    ACTIONS(12969), 1,
      anon_sym_LBRACE,
    STATE(12073), 1,
      sym__atom_no_curly,
    STATE(11890), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11799), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [594806] = 19,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11795), 1,
      sym_id,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_record,
    ACTIONS(11803), 1,
      anon_sym_LPAREN,
    ACTIONS(11805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11807), 1,
      anon_sym_u2983,
    ACTIONS(11811), 1,
      aux_sym__qid_token1,
    ACTIONS(11813), 1,
      anon_sym_DOT,
    ACTIONS(11815), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11817), 1,
      anon_sym_u2987,
    ACTIONS(11819), 1,
      aux_sym_integer_token1,
    ACTIONS(11821), 1,
      aux_sym_string_token1,
    ACTIONS(11823), 1,
      anon_sym_Set,
    ACTIONS(12971), 1,
      anon_sym_LBRACE,
    STATE(12077), 1,
      sym__atom_no_curly,
    STATE(11890), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11799), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [594877] = 19,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11795), 1,
      sym_id,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_record,
    ACTIONS(11803), 1,
      anon_sym_LPAREN,
    ACTIONS(11805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11807), 1,
      anon_sym_u2983,
    ACTIONS(11811), 1,
      aux_sym__qid_token1,
    ACTIONS(11813), 1,
      anon_sym_DOT,
    ACTIONS(11815), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11817), 1,
      anon_sym_u2987,
    ACTIONS(11819), 1,
      aux_sym_integer_token1,
    ACTIONS(11821), 1,
      aux_sym_string_token1,
    ACTIONS(11823), 1,
      anon_sym_Set,
    ACTIONS(12973), 1,
      anon_sym_LBRACE,
    STATE(12081), 1,
      sym__atom_no_curly,
    STATE(11890), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11799), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [594948] = 19,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11795), 1,
      sym_id,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_record,
    ACTIONS(11803), 1,
      anon_sym_LPAREN,
    ACTIONS(11805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11807), 1,
      anon_sym_u2983,
    ACTIONS(11811), 1,
      aux_sym__qid_token1,
    ACTIONS(11813), 1,
      anon_sym_DOT,
    ACTIONS(11815), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11817), 1,
      anon_sym_u2987,
    ACTIONS(11819), 1,
      aux_sym_integer_token1,
    ACTIONS(11821), 1,
      aux_sym_string_token1,
    ACTIONS(11823), 1,
      anon_sym_Set,
    ACTIONS(12975), 1,
      anon_sym_LBRACE,
    STATE(12085), 1,
      sym__atom_no_curly,
    STATE(11890), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11799), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [595019] = 19,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11795), 1,
      sym_id,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_record,
    ACTIONS(11803), 1,
      anon_sym_LPAREN,
    ACTIONS(11805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11807), 1,
      anon_sym_u2983,
    ACTIONS(11811), 1,
      aux_sym__qid_token1,
    ACTIONS(11813), 1,
      anon_sym_DOT,
    ACTIONS(11815), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11817), 1,
      anon_sym_u2987,
    ACTIONS(11819), 1,
      aux_sym_integer_token1,
    ACTIONS(11821), 1,
      aux_sym_string_token1,
    ACTIONS(11823), 1,
      anon_sym_Set,
    ACTIONS(12977), 1,
      anon_sym_LBRACE,
    STATE(10682), 1,
      sym__atom_no_curly,
    STATE(11890), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11799), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [595090] = 19,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11795), 1,
      sym_id,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_record,
    ACTIONS(11803), 1,
      anon_sym_LPAREN,
    ACTIONS(11805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11807), 1,
      anon_sym_u2983,
    ACTIONS(11811), 1,
      aux_sym__qid_token1,
    ACTIONS(11813), 1,
      anon_sym_DOT,
    ACTIONS(11815), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11817), 1,
      anon_sym_u2987,
    ACTIONS(11819), 1,
      aux_sym_integer_token1,
    ACTIONS(11821), 1,
      aux_sym_string_token1,
    ACTIONS(11823), 1,
      anon_sym_Set,
    ACTIONS(12979), 1,
      anon_sym_LBRACE,
    STATE(12089), 1,
      sym__atom_no_curly,
    STATE(11890), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11799), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [595161] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6651), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6649), 25,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [595202] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6647), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6645), 25,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [595243] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6568), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6566), 25,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [595284] = 19,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11795), 1,
      sym_id,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_record,
    ACTIONS(11803), 1,
      anon_sym_LPAREN,
    ACTIONS(11805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11807), 1,
      anon_sym_u2983,
    ACTIONS(11811), 1,
      aux_sym__qid_token1,
    ACTIONS(11813), 1,
      anon_sym_DOT,
    ACTIONS(11815), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11817), 1,
      anon_sym_u2987,
    ACTIONS(11819), 1,
      aux_sym_integer_token1,
    ACTIONS(11821), 1,
      aux_sym_string_token1,
    ACTIONS(11823), 1,
      anon_sym_Set,
    ACTIONS(12981), 1,
      anon_sym_LBRACE,
    STATE(12093), 1,
      sym__atom_no_curly,
    STATE(11890), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11799), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [595355] = 19,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11795), 1,
      sym_id,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_record,
    ACTIONS(11803), 1,
      anon_sym_LPAREN,
    ACTIONS(11805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11807), 1,
      anon_sym_u2983,
    ACTIONS(11811), 1,
      aux_sym__qid_token1,
    ACTIONS(11813), 1,
      anon_sym_DOT,
    ACTIONS(11815), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11817), 1,
      anon_sym_u2987,
    ACTIONS(11819), 1,
      aux_sym_integer_token1,
    ACTIONS(11821), 1,
      aux_sym_string_token1,
    ACTIONS(11823), 1,
      anon_sym_Set,
    ACTIONS(12983), 1,
      anon_sym_LBRACE,
    STATE(12097), 1,
      sym__atom_no_curly,
    STATE(11890), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11799), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [595426] = 19,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11795), 1,
      sym_id,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_record,
    ACTIONS(11803), 1,
      anon_sym_LPAREN,
    ACTIONS(11805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11807), 1,
      anon_sym_u2983,
    ACTIONS(11811), 1,
      aux_sym__qid_token1,
    ACTIONS(11813), 1,
      anon_sym_DOT,
    ACTIONS(11815), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11817), 1,
      anon_sym_u2987,
    ACTIONS(11819), 1,
      aux_sym_integer_token1,
    ACTIONS(11821), 1,
      aux_sym_string_token1,
    ACTIONS(11823), 1,
      anon_sym_Set,
    ACTIONS(12985), 1,
      anon_sym_LBRACE,
    STATE(12101), 1,
      sym__atom_no_curly,
    STATE(11890), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11799), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [595497] = 19,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11795), 1,
      sym_id,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_record,
    ACTIONS(11803), 1,
      anon_sym_LPAREN,
    ACTIONS(11805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11807), 1,
      anon_sym_u2983,
    ACTIONS(11811), 1,
      aux_sym__qid_token1,
    ACTIONS(11813), 1,
      anon_sym_DOT,
    ACTIONS(11815), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11817), 1,
      anon_sym_u2987,
    ACTIONS(11819), 1,
      aux_sym_integer_token1,
    ACTIONS(11821), 1,
      aux_sym_string_token1,
    ACTIONS(11823), 1,
      anon_sym_Set,
    ACTIONS(12987), 1,
      anon_sym_LBRACE,
    STATE(12105), 1,
      sym__atom_no_curly,
    STATE(11890), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11799), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [595568] = 19,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11795), 1,
      sym_id,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_record,
    ACTIONS(11803), 1,
      anon_sym_LPAREN,
    ACTIONS(11805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11807), 1,
      anon_sym_u2983,
    ACTIONS(11811), 1,
      aux_sym__qid_token1,
    ACTIONS(11813), 1,
      anon_sym_DOT,
    ACTIONS(11815), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11817), 1,
      anon_sym_u2987,
    ACTIONS(11819), 1,
      aux_sym_integer_token1,
    ACTIONS(11821), 1,
      aux_sym_string_token1,
    ACTIONS(11823), 1,
      anon_sym_Set,
    ACTIONS(12989), 1,
      anon_sym_LBRACE,
    STATE(12109), 1,
      sym__atom_no_curly,
    STATE(11890), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11799), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [595639] = 19,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11795), 1,
      sym_id,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_record,
    ACTIONS(11803), 1,
      anon_sym_LPAREN,
    ACTIONS(11805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11807), 1,
      anon_sym_u2983,
    ACTIONS(11811), 1,
      aux_sym__qid_token1,
    ACTIONS(11813), 1,
      anon_sym_DOT,
    ACTIONS(11815), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11817), 1,
      anon_sym_u2987,
    ACTIONS(11819), 1,
      aux_sym_integer_token1,
    ACTIONS(11821), 1,
      aux_sym_string_token1,
    ACTIONS(11823), 1,
      anon_sym_Set,
    ACTIONS(12991), 1,
      anon_sym_LBRACE,
    STATE(11019), 1,
      sym__atom_no_curly,
    STATE(11890), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11799), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [595710] = 19,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11795), 1,
      sym_id,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_record,
    ACTIONS(11803), 1,
      anon_sym_LPAREN,
    ACTIONS(11805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11807), 1,
      anon_sym_u2983,
    ACTIONS(11811), 1,
      aux_sym__qid_token1,
    ACTIONS(11813), 1,
      anon_sym_DOT,
    ACTIONS(11815), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11817), 1,
      anon_sym_u2987,
    ACTIONS(11819), 1,
      aux_sym_integer_token1,
    ACTIONS(11821), 1,
      aux_sym_string_token1,
    ACTIONS(11823), 1,
      anon_sym_Set,
    ACTIONS(12993), 1,
      anon_sym_LBRACE,
    STATE(10510), 1,
      sym__atom_no_curly,
    STATE(11890), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11799), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [595781] = 19,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11795), 1,
      sym_id,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_record,
    ACTIONS(11803), 1,
      anon_sym_LPAREN,
    ACTIONS(11805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11807), 1,
      anon_sym_u2983,
    ACTIONS(11811), 1,
      aux_sym__qid_token1,
    ACTIONS(11813), 1,
      anon_sym_DOT,
    ACTIONS(11815), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11817), 1,
      anon_sym_u2987,
    ACTIONS(11819), 1,
      aux_sym_integer_token1,
    ACTIONS(11821), 1,
      aux_sym_string_token1,
    ACTIONS(11823), 1,
      anon_sym_Set,
    ACTIONS(12995), 1,
      anon_sym_LBRACE,
    STATE(12113), 1,
      sym__atom_no_curly,
    STATE(11890), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11799), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [595852] = 19,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11795), 1,
      sym_id,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_record,
    ACTIONS(11803), 1,
      anon_sym_LPAREN,
    ACTIONS(11805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11807), 1,
      anon_sym_u2983,
    ACTIONS(11811), 1,
      aux_sym__qid_token1,
    ACTIONS(11813), 1,
      anon_sym_DOT,
    ACTIONS(11815), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11817), 1,
      anon_sym_u2987,
    ACTIONS(11819), 1,
      aux_sym_integer_token1,
    ACTIONS(11821), 1,
      aux_sym_string_token1,
    ACTIONS(11823), 1,
      anon_sym_Set,
    ACTIONS(12997), 1,
      anon_sym_LBRACE,
    STATE(12117), 1,
      sym__atom_no_curly,
    STATE(11890), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11799), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [595923] = 19,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11795), 1,
      sym_id,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_record,
    ACTIONS(11803), 1,
      anon_sym_LPAREN,
    ACTIONS(11805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11807), 1,
      anon_sym_u2983,
    ACTIONS(11811), 1,
      aux_sym__qid_token1,
    ACTIONS(11813), 1,
      anon_sym_DOT,
    ACTIONS(11815), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11817), 1,
      anon_sym_u2987,
    ACTIONS(11819), 1,
      aux_sym_integer_token1,
    ACTIONS(11821), 1,
      aux_sym_string_token1,
    ACTIONS(11823), 1,
      anon_sym_Set,
    ACTIONS(12999), 1,
      anon_sym_LBRACE,
    STATE(12121), 1,
      sym__atom_no_curly,
    STATE(11890), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11799), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [595994] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6572), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6570), 25,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [596035] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6568), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6566), 25,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [596076] = 19,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11795), 1,
      sym_id,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_record,
    ACTIONS(11803), 1,
      anon_sym_LPAREN,
    ACTIONS(11805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11807), 1,
      anon_sym_u2983,
    ACTIONS(11811), 1,
      aux_sym__qid_token1,
    ACTIONS(11813), 1,
      anon_sym_DOT,
    ACTIONS(11815), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11817), 1,
      anon_sym_u2987,
    ACTIONS(11819), 1,
      aux_sym_integer_token1,
    ACTIONS(11821), 1,
      aux_sym_string_token1,
    ACTIONS(11823), 1,
      anon_sym_Set,
    ACTIONS(13001), 1,
      anon_sym_LBRACE,
    STATE(12125), 1,
      sym__atom_no_curly,
    STATE(11890), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11799), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [596147] = 19,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11795), 1,
      sym_id,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_record,
    ACTIONS(11803), 1,
      anon_sym_LPAREN,
    ACTIONS(11805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11807), 1,
      anon_sym_u2983,
    ACTIONS(11811), 1,
      aux_sym__qid_token1,
    ACTIONS(11813), 1,
      anon_sym_DOT,
    ACTIONS(11815), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11817), 1,
      anon_sym_u2987,
    ACTIONS(11819), 1,
      aux_sym_integer_token1,
    ACTIONS(11821), 1,
      aux_sym_string_token1,
    ACTIONS(11823), 1,
      anon_sym_Set,
    ACTIONS(13003), 1,
      anon_sym_LBRACE,
    STATE(11410), 1,
      sym__atom_no_curly,
    STATE(11890), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11799), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [596218] = 19,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11795), 1,
      sym_id,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_record,
    ACTIONS(11803), 1,
      anon_sym_LPAREN,
    ACTIONS(11805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11807), 1,
      anon_sym_u2983,
    ACTIONS(11811), 1,
      aux_sym__qid_token1,
    ACTIONS(11813), 1,
      anon_sym_DOT,
    ACTIONS(11815), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11817), 1,
      anon_sym_u2987,
    ACTIONS(11819), 1,
      aux_sym_integer_token1,
    ACTIONS(11821), 1,
      aux_sym_string_token1,
    ACTIONS(11823), 1,
      anon_sym_Set,
    ACTIONS(13005), 1,
      anon_sym_LBRACE,
    STATE(12129), 1,
      sym__atom_no_curly,
    STATE(11890), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11799), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [596289] = 19,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11795), 1,
      sym_id,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_record,
    ACTIONS(11803), 1,
      anon_sym_LPAREN,
    ACTIONS(11805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11807), 1,
      anon_sym_u2983,
    ACTIONS(11811), 1,
      aux_sym__qid_token1,
    ACTIONS(11813), 1,
      anon_sym_DOT,
    ACTIONS(11815), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11817), 1,
      anon_sym_u2987,
    ACTIONS(11819), 1,
      aux_sym_integer_token1,
    ACTIONS(11821), 1,
      aux_sym_string_token1,
    ACTIONS(11823), 1,
      anon_sym_Set,
    ACTIONS(13007), 1,
      anon_sym_LBRACE,
    STATE(12133), 1,
      sym__atom_no_curly,
    STATE(11890), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11799), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [596360] = 19,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11795), 1,
      sym_id,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_record,
    ACTIONS(11803), 1,
      anon_sym_LPAREN,
    ACTIONS(11805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11807), 1,
      anon_sym_u2983,
    ACTIONS(11811), 1,
      aux_sym__qid_token1,
    ACTIONS(11813), 1,
      anon_sym_DOT,
    ACTIONS(11815), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11817), 1,
      anon_sym_u2987,
    ACTIONS(11819), 1,
      aux_sym_integer_token1,
    ACTIONS(11821), 1,
      aux_sym_string_token1,
    ACTIONS(11823), 1,
      anon_sym_Set,
    ACTIONS(13009), 1,
      anon_sym_LBRACE,
    STATE(12137), 1,
      sym__atom_no_curly,
    STATE(11890), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11799), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [596431] = 19,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11795), 1,
      sym_id,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_record,
    ACTIONS(11803), 1,
      anon_sym_LPAREN,
    ACTIONS(11805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11807), 1,
      anon_sym_u2983,
    ACTIONS(11811), 1,
      aux_sym__qid_token1,
    ACTIONS(11813), 1,
      anon_sym_DOT,
    ACTIONS(11815), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11817), 1,
      anon_sym_u2987,
    ACTIONS(11819), 1,
      aux_sym_integer_token1,
    ACTIONS(11821), 1,
      aux_sym_string_token1,
    ACTIONS(11823), 1,
      anon_sym_Set,
    ACTIONS(13011), 1,
      anon_sym_LBRACE,
    STATE(11432), 1,
      sym__atom_no_curly,
    STATE(11890), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11799), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [596502] = 19,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11795), 1,
      sym_id,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_record,
    ACTIONS(11803), 1,
      anon_sym_LPAREN,
    ACTIONS(11805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11807), 1,
      anon_sym_u2983,
    ACTIONS(11811), 1,
      aux_sym__qid_token1,
    ACTIONS(11813), 1,
      anon_sym_DOT,
    ACTIONS(11815), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11817), 1,
      anon_sym_u2987,
    ACTIONS(11819), 1,
      aux_sym_integer_token1,
    ACTIONS(11821), 1,
      aux_sym_string_token1,
    ACTIONS(11823), 1,
      anon_sym_Set,
    ACTIONS(13013), 1,
      anon_sym_LBRACE,
    STATE(12145), 1,
      sym__atom_no_curly,
    STATE(11890), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11799), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [596573] = 19,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11795), 1,
      sym_id,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_record,
    ACTIONS(11803), 1,
      anon_sym_LPAREN,
    ACTIONS(11805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11807), 1,
      anon_sym_u2983,
    ACTIONS(11811), 1,
      aux_sym__qid_token1,
    ACTIONS(11813), 1,
      anon_sym_DOT,
    ACTIONS(11815), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11817), 1,
      anon_sym_u2987,
    ACTIONS(11819), 1,
      aux_sym_integer_token1,
    ACTIONS(11821), 1,
      aux_sym_string_token1,
    ACTIONS(11823), 1,
      anon_sym_Set,
    ACTIONS(13015), 1,
      anon_sym_LBRACE,
    STATE(11829), 1,
      sym__atom_no_curly,
    STATE(11890), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11799), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [596644] = 19,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11795), 1,
      sym_id,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_record,
    ACTIONS(11803), 1,
      anon_sym_LPAREN,
    ACTIONS(11805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11807), 1,
      anon_sym_u2983,
    ACTIONS(11811), 1,
      aux_sym__qid_token1,
    ACTIONS(11813), 1,
      anon_sym_DOT,
    ACTIONS(11815), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11817), 1,
      anon_sym_u2987,
    ACTIONS(11819), 1,
      aux_sym_integer_token1,
    ACTIONS(11821), 1,
      aux_sym_string_token1,
    ACTIONS(11823), 1,
      anon_sym_Set,
    ACTIONS(13017), 1,
      anon_sym_LBRACE,
    STATE(12153), 1,
      sym__atom_no_curly,
    STATE(11890), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11799), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [596715] = 19,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11795), 1,
      sym_id,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_record,
    ACTIONS(11803), 1,
      anon_sym_LPAREN,
    ACTIONS(11805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11807), 1,
      anon_sym_u2983,
    ACTIONS(11811), 1,
      aux_sym__qid_token1,
    ACTIONS(11813), 1,
      anon_sym_DOT,
    ACTIONS(11815), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11817), 1,
      anon_sym_u2987,
    ACTIONS(11819), 1,
      aux_sym_integer_token1,
    ACTIONS(11821), 1,
      aux_sym_string_token1,
    ACTIONS(11823), 1,
      anon_sym_Set,
    ACTIONS(13019), 1,
      anon_sym_LBRACE,
    STATE(12157), 1,
      sym__atom_no_curly,
    STATE(11890), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11799), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [596786] = 19,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11795), 1,
      sym_id,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_record,
    ACTIONS(11803), 1,
      anon_sym_LPAREN,
    ACTIONS(11805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11807), 1,
      anon_sym_u2983,
    ACTIONS(11811), 1,
      aux_sym__qid_token1,
    ACTIONS(11813), 1,
      anon_sym_DOT,
    ACTIONS(11815), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11817), 1,
      anon_sym_u2987,
    ACTIONS(11819), 1,
      aux_sym_integer_token1,
    ACTIONS(11821), 1,
      aux_sym_string_token1,
    ACTIONS(11823), 1,
      anon_sym_Set,
    ACTIONS(13021), 1,
      anon_sym_LBRACE,
    STATE(12161), 1,
      sym__atom_no_curly,
    STATE(11890), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11799), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [596857] = 19,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11795), 1,
      sym_id,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_record,
    ACTIONS(11803), 1,
      anon_sym_LPAREN,
    ACTIONS(11805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11807), 1,
      anon_sym_u2983,
    ACTIONS(11811), 1,
      aux_sym__qid_token1,
    ACTIONS(11813), 1,
      anon_sym_DOT,
    ACTIONS(11815), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11817), 1,
      anon_sym_u2987,
    ACTIONS(11819), 1,
      aux_sym_integer_token1,
    ACTIONS(11821), 1,
      aux_sym_string_token1,
    ACTIONS(11823), 1,
      anon_sym_Set,
    ACTIONS(13023), 1,
      anon_sym_LBRACE,
    STATE(12165), 1,
      sym__atom_no_curly,
    STATE(11890), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11799), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [596928] = 19,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11795), 1,
      sym_id,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_record,
    ACTIONS(11803), 1,
      anon_sym_LPAREN,
    ACTIONS(11805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11807), 1,
      anon_sym_u2983,
    ACTIONS(11811), 1,
      aux_sym__qid_token1,
    ACTIONS(11813), 1,
      anon_sym_DOT,
    ACTIONS(11815), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11817), 1,
      anon_sym_u2987,
    ACTIONS(11819), 1,
      aux_sym_integer_token1,
    ACTIONS(11821), 1,
      aux_sym_string_token1,
    ACTIONS(11823), 1,
      anon_sym_Set,
    ACTIONS(13025), 1,
      anon_sym_LBRACE,
    STATE(12169), 1,
      sym__atom_no_curly,
    STATE(11890), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11799), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [596999] = 19,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11795), 1,
      sym_id,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_record,
    ACTIONS(11803), 1,
      anon_sym_LPAREN,
    ACTIONS(11805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11807), 1,
      anon_sym_u2983,
    ACTIONS(11811), 1,
      aux_sym__qid_token1,
    ACTIONS(11813), 1,
      anon_sym_DOT,
    ACTIONS(11815), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11817), 1,
      anon_sym_u2987,
    ACTIONS(11819), 1,
      aux_sym_integer_token1,
    ACTIONS(11821), 1,
      aux_sym_string_token1,
    ACTIONS(11823), 1,
      anon_sym_Set,
    ACTIONS(13027), 1,
      anon_sym_LBRACE,
    STATE(12173), 1,
      sym__atom_no_curly,
    STATE(11890), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11799), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [597070] = 19,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11795), 1,
      sym_id,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_record,
    ACTIONS(11803), 1,
      anon_sym_LPAREN,
    ACTIONS(11805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11807), 1,
      anon_sym_u2983,
    ACTIONS(11811), 1,
      aux_sym__qid_token1,
    ACTIONS(11813), 1,
      anon_sym_DOT,
    ACTIONS(11815), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11817), 1,
      anon_sym_u2987,
    ACTIONS(11819), 1,
      aux_sym_integer_token1,
    ACTIONS(11821), 1,
      aux_sym_string_token1,
    ACTIONS(11823), 1,
      anon_sym_Set,
    ACTIONS(13029), 1,
      anon_sym_LBRACE,
    STATE(12177), 1,
      sym__atom_no_curly,
    STATE(11890), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11799), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [597141] = 19,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11795), 1,
      sym_id,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_record,
    ACTIONS(11803), 1,
      anon_sym_LPAREN,
    ACTIONS(11805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11807), 1,
      anon_sym_u2983,
    ACTIONS(11811), 1,
      aux_sym__qid_token1,
    ACTIONS(11813), 1,
      anon_sym_DOT,
    ACTIONS(11815), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11817), 1,
      anon_sym_u2987,
    ACTIONS(11819), 1,
      aux_sym_integer_token1,
    ACTIONS(11821), 1,
      aux_sym_string_token1,
    ACTIONS(11823), 1,
      anon_sym_Set,
    ACTIONS(13031), 1,
      anon_sym_LBRACE,
    STATE(12181), 1,
      sym__atom_no_curly,
    STATE(11890), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11799), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [597212] = 19,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11795), 1,
      sym_id,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_record,
    ACTIONS(11803), 1,
      anon_sym_LPAREN,
    ACTIONS(11805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11807), 1,
      anon_sym_u2983,
    ACTIONS(11811), 1,
      aux_sym__qid_token1,
    ACTIONS(11813), 1,
      anon_sym_DOT,
    ACTIONS(11815), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11817), 1,
      anon_sym_u2987,
    ACTIONS(11819), 1,
      aux_sym_integer_token1,
    ACTIONS(11821), 1,
      aux_sym_string_token1,
    ACTIONS(11823), 1,
      anon_sym_Set,
    ACTIONS(13033), 1,
      anon_sym_LBRACE,
    STATE(12185), 1,
      sym__atom_no_curly,
    STATE(11890), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11799), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [597283] = 19,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11795), 1,
      sym_id,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_record,
    ACTIONS(11803), 1,
      anon_sym_LPAREN,
    ACTIONS(11805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11807), 1,
      anon_sym_u2983,
    ACTIONS(11811), 1,
      aux_sym__qid_token1,
    ACTIONS(11813), 1,
      anon_sym_DOT,
    ACTIONS(11815), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11817), 1,
      anon_sym_u2987,
    ACTIONS(11819), 1,
      aux_sym_integer_token1,
    ACTIONS(11821), 1,
      aux_sym_string_token1,
    ACTIONS(11823), 1,
      anon_sym_Set,
    ACTIONS(13035), 1,
      anon_sym_LBRACE,
    STATE(12189), 1,
      sym__atom_no_curly,
    STATE(11890), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11799), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [597354] = 19,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11795), 1,
      sym_id,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_record,
    ACTIONS(11803), 1,
      anon_sym_LPAREN,
    ACTIONS(11805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11807), 1,
      anon_sym_u2983,
    ACTIONS(11811), 1,
      aux_sym__qid_token1,
    ACTIONS(11813), 1,
      anon_sym_DOT,
    ACTIONS(11815), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11817), 1,
      anon_sym_u2987,
    ACTIONS(11819), 1,
      aux_sym_integer_token1,
    ACTIONS(11821), 1,
      aux_sym_string_token1,
    ACTIONS(11823), 1,
      anon_sym_Set,
    ACTIONS(13037), 1,
      anon_sym_LBRACE,
    STATE(12277), 1,
      sym__atom_no_curly,
    STATE(11890), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11799), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [597425] = 19,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11795), 1,
      sym_id,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_record,
    ACTIONS(11803), 1,
      anon_sym_LPAREN,
    ACTIONS(11805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11807), 1,
      anon_sym_u2983,
    ACTIONS(11811), 1,
      aux_sym__qid_token1,
    ACTIONS(11813), 1,
      anon_sym_DOT,
    ACTIONS(11815), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11817), 1,
      anon_sym_u2987,
    ACTIONS(11819), 1,
      aux_sym_integer_token1,
    ACTIONS(11821), 1,
      aux_sym_string_token1,
    ACTIONS(11823), 1,
      anon_sym_Set,
    ACTIONS(13039), 1,
      anon_sym_LBRACE,
    STATE(12197), 1,
      sym__atom_no_curly,
    STATE(11890), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11799), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [597496] = 19,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11795), 1,
      sym_id,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_record,
    ACTIONS(11803), 1,
      anon_sym_LPAREN,
    ACTIONS(11805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11807), 1,
      anon_sym_u2983,
    ACTIONS(11811), 1,
      aux_sym__qid_token1,
    ACTIONS(11813), 1,
      anon_sym_DOT,
    ACTIONS(11815), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11817), 1,
      anon_sym_u2987,
    ACTIONS(11819), 1,
      aux_sym_integer_token1,
    ACTIONS(11821), 1,
      aux_sym_string_token1,
    ACTIONS(11823), 1,
      anon_sym_Set,
    ACTIONS(13041), 1,
      anon_sym_LBRACE,
    STATE(12201), 1,
      sym__atom_no_curly,
    STATE(11890), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11799), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [597567] = 19,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11795), 1,
      sym_id,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_record,
    ACTIONS(11803), 1,
      anon_sym_LPAREN,
    ACTIONS(11805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11807), 1,
      anon_sym_u2983,
    ACTIONS(11811), 1,
      aux_sym__qid_token1,
    ACTIONS(11813), 1,
      anon_sym_DOT,
    ACTIONS(11815), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11817), 1,
      anon_sym_u2987,
    ACTIONS(11819), 1,
      aux_sym_integer_token1,
    ACTIONS(11821), 1,
      aux_sym_string_token1,
    ACTIONS(11823), 1,
      anon_sym_Set,
    ACTIONS(13043), 1,
      anon_sym_LBRACE,
    STATE(11520), 1,
      sym__atom_no_curly,
    STATE(11890), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11799), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [597638] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6500), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6498), 25,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [597679] = 19,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11795), 1,
      sym_id,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_record,
    ACTIONS(11803), 1,
      anon_sym_LPAREN,
    ACTIONS(11805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11807), 1,
      anon_sym_u2983,
    ACTIONS(11811), 1,
      aux_sym__qid_token1,
    ACTIONS(11813), 1,
      anon_sym_DOT,
    ACTIONS(11815), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11817), 1,
      anon_sym_u2987,
    ACTIONS(11819), 1,
      aux_sym_integer_token1,
    ACTIONS(11821), 1,
      aux_sym_string_token1,
    ACTIONS(11823), 1,
      anon_sym_Set,
    ACTIONS(13045), 1,
      anon_sym_LBRACE,
    STATE(11744), 1,
      sym__atom_no_curly,
    STATE(11890), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11799), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [597750] = 19,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11795), 1,
      sym_id,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_record,
    ACTIONS(11803), 1,
      anon_sym_LPAREN,
    ACTIONS(11805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11807), 1,
      anon_sym_u2983,
    ACTIONS(11811), 1,
      aux_sym__qid_token1,
    ACTIONS(11813), 1,
      anon_sym_DOT,
    ACTIONS(11815), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11817), 1,
      anon_sym_u2987,
    ACTIONS(11819), 1,
      aux_sym_integer_token1,
    ACTIONS(11821), 1,
      aux_sym_string_token1,
    ACTIONS(11823), 1,
      anon_sym_Set,
    ACTIONS(13047), 1,
      anon_sym_LBRACE,
    STATE(12205), 1,
      sym__atom_no_curly,
    STATE(11890), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11799), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [597821] = 19,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11795), 1,
      sym_id,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_record,
    ACTIONS(11803), 1,
      anon_sym_LPAREN,
    ACTIONS(11805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11807), 1,
      anon_sym_u2983,
    ACTIONS(11811), 1,
      aux_sym__qid_token1,
    ACTIONS(11813), 1,
      anon_sym_DOT,
    ACTIONS(11815), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11817), 1,
      anon_sym_u2987,
    ACTIONS(11819), 1,
      aux_sym_integer_token1,
    ACTIONS(11821), 1,
      aux_sym_string_token1,
    ACTIONS(11823), 1,
      anon_sym_Set,
    ACTIONS(13049), 1,
      anon_sym_LBRACE,
    STATE(12209), 1,
      sym__atom_no_curly,
    STATE(11890), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11799), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [597892] = 19,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11795), 1,
      sym_id,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_record,
    ACTIONS(11803), 1,
      anon_sym_LPAREN,
    ACTIONS(11805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11807), 1,
      anon_sym_u2983,
    ACTIONS(11811), 1,
      aux_sym__qid_token1,
    ACTIONS(11813), 1,
      anon_sym_DOT,
    ACTIONS(11815), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11817), 1,
      anon_sym_u2987,
    ACTIONS(11819), 1,
      aux_sym_integer_token1,
    ACTIONS(11821), 1,
      aux_sym_string_token1,
    ACTIONS(11823), 1,
      anon_sym_Set,
    ACTIONS(13051), 1,
      anon_sym_LBRACE,
    STATE(10237), 1,
      sym__atom_no_curly,
    STATE(11890), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11799), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [597963] = 19,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11795), 1,
      sym_id,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_record,
    ACTIONS(11803), 1,
      anon_sym_LPAREN,
    ACTIONS(11805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11807), 1,
      anon_sym_u2983,
    ACTIONS(11811), 1,
      aux_sym__qid_token1,
    ACTIONS(11813), 1,
      anon_sym_DOT,
    ACTIONS(11815), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11817), 1,
      anon_sym_u2987,
    ACTIONS(11819), 1,
      aux_sym_integer_token1,
    ACTIONS(11821), 1,
      aux_sym_string_token1,
    ACTIONS(11823), 1,
      anon_sym_Set,
    ACTIONS(13053), 1,
      anon_sym_LBRACE,
    STATE(12213), 1,
      sym__atom_no_curly,
    STATE(11890), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11799), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [598034] = 19,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11795), 1,
      sym_id,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_record,
    ACTIONS(11803), 1,
      anon_sym_LPAREN,
    ACTIONS(11805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11807), 1,
      anon_sym_u2983,
    ACTIONS(11811), 1,
      aux_sym__qid_token1,
    ACTIONS(11813), 1,
      anon_sym_DOT,
    ACTIONS(11815), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11817), 1,
      anon_sym_u2987,
    ACTIONS(11819), 1,
      aux_sym_integer_token1,
    ACTIONS(11821), 1,
      aux_sym_string_token1,
    ACTIONS(11823), 1,
      anon_sym_Set,
    ACTIONS(13055), 1,
      anon_sym_LBRACE,
    STATE(12221), 1,
      sym__atom_no_curly,
    STATE(11890), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11799), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [598105] = 19,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11795), 1,
      sym_id,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_record,
    ACTIONS(11803), 1,
      anon_sym_LPAREN,
    ACTIONS(11805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11807), 1,
      anon_sym_u2983,
    ACTIONS(11811), 1,
      aux_sym__qid_token1,
    ACTIONS(11813), 1,
      anon_sym_DOT,
    ACTIONS(11815), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11817), 1,
      anon_sym_u2987,
    ACTIONS(11819), 1,
      aux_sym_integer_token1,
    ACTIONS(11821), 1,
      aux_sym_string_token1,
    ACTIONS(11823), 1,
      anon_sym_Set,
    ACTIONS(13057), 1,
      anon_sym_LBRACE,
    STATE(12225), 1,
      sym__atom_no_curly,
    STATE(11890), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11799), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [598176] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6326), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6324), 25,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [598217] = 19,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11795), 1,
      sym_id,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_record,
    ACTIONS(11803), 1,
      anon_sym_LPAREN,
    ACTIONS(11805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11807), 1,
      anon_sym_u2983,
    ACTIONS(11811), 1,
      aux_sym__qid_token1,
    ACTIONS(11813), 1,
      anon_sym_DOT,
    ACTIONS(11815), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11817), 1,
      anon_sym_u2987,
    ACTIONS(11819), 1,
      aux_sym_integer_token1,
    ACTIONS(11821), 1,
      aux_sym_string_token1,
    ACTIONS(11823), 1,
      anon_sym_Set,
    ACTIONS(13059), 1,
      anon_sym_LBRACE,
    STATE(12229), 1,
      sym__atom_no_curly,
    STATE(11890), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11799), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [598288] = 19,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11795), 1,
      sym_id,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_record,
    ACTIONS(11803), 1,
      anon_sym_LPAREN,
    ACTIONS(11805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11807), 1,
      anon_sym_u2983,
    ACTIONS(11811), 1,
      aux_sym__qid_token1,
    ACTIONS(11813), 1,
      anon_sym_DOT,
    ACTIONS(11815), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11817), 1,
      anon_sym_u2987,
    ACTIONS(11819), 1,
      aux_sym_integer_token1,
    ACTIONS(11821), 1,
      aux_sym_string_token1,
    ACTIONS(11823), 1,
      anon_sym_Set,
    ACTIONS(13061), 1,
      anon_sym_LBRACE,
    STATE(12233), 1,
      sym__atom_no_curly,
    STATE(11890), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11799), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [598359] = 19,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11795), 1,
      sym_id,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_record,
    ACTIONS(11803), 1,
      anon_sym_LPAREN,
    ACTIONS(11805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11807), 1,
      anon_sym_u2983,
    ACTIONS(11811), 1,
      aux_sym__qid_token1,
    ACTIONS(11813), 1,
      anon_sym_DOT,
    ACTIONS(11815), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11817), 1,
      anon_sym_u2987,
    ACTIONS(11819), 1,
      aux_sym_integer_token1,
    ACTIONS(11821), 1,
      aux_sym_string_token1,
    ACTIONS(11823), 1,
      anon_sym_Set,
    ACTIONS(13063), 1,
      anon_sym_LBRACE,
    STATE(12237), 1,
      sym__atom_no_curly,
    STATE(11890), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11799), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [598430] = 19,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11795), 1,
      sym_id,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_record,
    ACTIONS(11803), 1,
      anon_sym_LPAREN,
    ACTIONS(11805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11807), 1,
      anon_sym_u2983,
    ACTIONS(11811), 1,
      aux_sym__qid_token1,
    ACTIONS(11813), 1,
      anon_sym_DOT,
    ACTIONS(11815), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11817), 1,
      anon_sym_u2987,
    ACTIONS(11819), 1,
      aux_sym_integer_token1,
    ACTIONS(11821), 1,
      aux_sym_string_token1,
    ACTIONS(11823), 1,
      anon_sym_Set,
    ACTIONS(13065), 1,
      anon_sym_LBRACE,
    STATE(12241), 1,
      sym__atom_no_curly,
    STATE(11890), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11799), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [598501] = 19,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11795), 1,
      sym_id,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_record,
    ACTIONS(11803), 1,
      anon_sym_LPAREN,
    ACTIONS(11805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11807), 1,
      anon_sym_u2983,
    ACTIONS(11811), 1,
      aux_sym__qid_token1,
    ACTIONS(11813), 1,
      anon_sym_DOT,
    ACTIONS(11815), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11817), 1,
      anon_sym_u2987,
    ACTIONS(11819), 1,
      aux_sym_integer_token1,
    ACTIONS(11821), 1,
      aux_sym_string_token1,
    ACTIONS(11823), 1,
      anon_sym_Set,
    ACTIONS(13067), 1,
      anon_sym_LBRACE,
    STATE(12245), 1,
      sym__atom_no_curly,
    STATE(11890), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11799), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [598572] = 19,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11795), 1,
      sym_id,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_record,
    ACTIONS(11803), 1,
      anon_sym_LPAREN,
    ACTIONS(11805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11807), 1,
      anon_sym_u2983,
    ACTIONS(11811), 1,
      aux_sym__qid_token1,
    ACTIONS(11813), 1,
      anon_sym_DOT,
    ACTIONS(11815), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11817), 1,
      anon_sym_u2987,
    ACTIONS(11819), 1,
      aux_sym_integer_token1,
    ACTIONS(11821), 1,
      aux_sym_string_token1,
    ACTIONS(11823), 1,
      anon_sym_Set,
    ACTIONS(13069), 1,
      anon_sym_LBRACE,
    STATE(12249), 1,
      sym__atom_no_curly,
    STATE(11890), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11799), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [598643] = 5,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13071), 1,
      anon_sym_AT,
    ACTIONS(6326), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6324), 24,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [598686] = 19,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11795), 1,
      sym_id,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_record,
    ACTIONS(11803), 1,
      anon_sym_LPAREN,
    ACTIONS(11805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11807), 1,
      anon_sym_u2983,
    ACTIONS(11811), 1,
      aux_sym__qid_token1,
    ACTIONS(11813), 1,
      anon_sym_DOT,
    ACTIONS(11815), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11817), 1,
      anon_sym_u2987,
    ACTIONS(11819), 1,
      aux_sym_integer_token1,
    ACTIONS(11821), 1,
      aux_sym_string_token1,
    ACTIONS(11823), 1,
      anon_sym_Set,
    ACTIONS(12957), 1,
      anon_sym_LBRACE,
    STATE(11190), 1,
      sym__atom_no_curly,
    STATE(11890), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11799), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [598757] = 19,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11795), 1,
      sym_id,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_record,
    ACTIONS(11803), 1,
      anon_sym_LPAREN,
    ACTIONS(11805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11807), 1,
      anon_sym_u2983,
    ACTIONS(11811), 1,
      aux_sym__qid_token1,
    ACTIONS(11813), 1,
      anon_sym_DOT,
    ACTIONS(11815), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11817), 1,
      anon_sym_u2987,
    ACTIONS(11819), 1,
      aux_sym_integer_token1,
    ACTIONS(11821), 1,
      aux_sym_string_token1,
    ACTIONS(11823), 1,
      anon_sym_Set,
    ACTIONS(13073), 1,
      anon_sym_LBRACE,
    STATE(11710), 1,
      sym__atom_no_curly,
    STATE(11890), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11799), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [598828] = 3,
    ACTIONS(6568), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6566), 29,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [598867] = 5,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13075), 1,
      anon_sym_AT,
    ACTIONS(6326), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6324), 24,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [598910] = 19,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11795), 1,
      sym_id,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_record,
    ACTIONS(11803), 1,
      anon_sym_LPAREN,
    ACTIONS(11805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11807), 1,
      anon_sym_u2983,
    ACTIONS(11811), 1,
      aux_sym__qid_token1,
    ACTIONS(11813), 1,
      anon_sym_DOT,
    ACTIONS(11815), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11817), 1,
      anon_sym_u2987,
    ACTIONS(11819), 1,
      aux_sym_integer_token1,
    ACTIONS(11821), 1,
      aux_sym_string_token1,
    ACTIONS(11823), 1,
      anon_sym_Set,
    ACTIONS(13077), 1,
      anon_sym_LBRACE,
    STATE(11454), 1,
      sym__atom_no_curly,
    STATE(11890), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11799), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [598981] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6655), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6653), 25,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [599022] = 19,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11795), 1,
      sym_id,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_record,
    ACTIONS(11803), 1,
      anon_sym_LPAREN,
    ACTIONS(11805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11807), 1,
      anon_sym_u2983,
    ACTIONS(11811), 1,
      aux_sym__qid_token1,
    ACTIONS(11813), 1,
      anon_sym_DOT,
    ACTIONS(11815), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11817), 1,
      anon_sym_u2987,
    ACTIONS(11819), 1,
      aux_sym_integer_token1,
    ACTIONS(11821), 1,
      aux_sym_string_token1,
    ACTIONS(11823), 1,
      anon_sym_Set,
    ACTIONS(13079), 1,
      anon_sym_LBRACE,
    STATE(11476), 1,
      sym__atom_no_curly,
    STATE(11890), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11799), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [599093] = 19,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11795), 1,
      sym_id,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_record,
    ACTIONS(11803), 1,
      anon_sym_LPAREN,
    ACTIONS(11805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11807), 1,
      anon_sym_u2983,
    ACTIONS(11811), 1,
      aux_sym__qid_token1,
    ACTIONS(11813), 1,
      anon_sym_DOT,
    ACTIONS(11815), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11817), 1,
      anon_sym_u2987,
    ACTIONS(11819), 1,
      aux_sym_integer_token1,
    ACTIONS(11821), 1,
      aux_sym_string_token1,
    ACTIONS(11823), 1,
      anon_sym_Set,
    ACTIONS(13081), 1,
      anon_sym_LBRACE,
    STATE(10563), 1,
      sym__atom_no_curly,
    STATE(11890), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11799), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [599164] = 19,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11795), 1,
      sym_id,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_record,
    ACTIONS(11803), 1,
      anon_sym_LPAREN,
    ACTIONS(11805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11807), 1,
      anon_sym_u2983,
    ACTIONS(11811), 1,
      aux_sym__qid_token1,
    ACTIONS(11813), 1,
      anon_sym_DOT,
    ACTIONS(11815), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11817), 1,
      anon_sym_u2987,
    ACTIONS(11819), 1,
      aux_sym_integer_token1,
    ACTIONS(11821), 1,
      aux_sym_string_token1,
    ACTIONS(11823), 1,
      anon_sym_Set,
    ACTIONS(13083), 1,
      anon_sym_LBRACE,
    STATE(10616), 1,
      sym__atom_no_curly,
    STATE(11890), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11799), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [599235] = 19,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11795), 1,
      sym_id,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_record,
    ACTIONS(11803), 1,
      anon_sym_LPAREN,
    ACTIONS(11805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11807), 1,
      anon_sym_u2983,
    ACTIONS(11811), 1,
      aux_sym__qid_token1,
    ACTIONS(11813), 1,
      anon_sym_DOT,
    ACTIONS(11815), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11817), 1,
      anon_sym_u2987,
    ACTIONS(11819), 1,
      aux_sym_integer_token1,
    ACTIONS(11821), 1,
      aux_sym_string_token1,
    ACTIONS(11823), 1,
      anon_sym_Set,
    ACTIONS(13085), 1,
      anon_sym_LBRACE,
    STATE(11498), 1,
      sym__atom_no_curly,
    STATE(11890), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11799), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [599306] = 19,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11795), 1,
      sym_id,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_record,
    ACTIONS(11803), 1,
      anon_sym_LPAREN,
    ACTIONS(11805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11807), 1,
      anon_sym_u2983,
    ACTIONS(11811), 1,
      aux_sym__qid_token1,
    ACTIONS(11813), 1,
      anon_sym_DOT,
    ACTIONS(11815), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11817), 1,
      anon_sym_u2987,
    ACTIONS(11819), 1,
      aux_sym_integer_token1,
    ACTIONS(11821), 1,
      aux_sym_string_token1,
    ACTIONS(11823), 1,
      anon_sym_Set,
    ACTIONS(13087), 1,
      anon_sym_LBRACE,
    STATE(12329), 1,
      sym__atom_no_curly,
    STATE(11890), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11799), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [599377] = 19,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11795), 1,
      sym_id,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_record,
    ACTIONS(11803), 1,
      anon_sym_LPAREN,
    ACTIONS(11805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11807), 1,
      anon_sym_u2983,
    ACTIONS(11811), 1,
      aux_sym__qid_token1,
    ACTIONS(11813), 1,
      anon_sym_DOT,
    ACTIONS(11815), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11817), 1,
      anon_sym_u2987,
    ACTIONS(11819), 1,
      aux_sym_integer_token1,
    ACTIONS(11821), 1,
      aux_sym_string_token1,
    ACTIONS(11823), 1,
      anon_sym_Set,
    ACTIONS(13089), 1,
      anon_sym_LBRACE,
    STATE(12253), 1,
      sym__atom_no_curly,
    STATE(11890), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11799), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [599448] = 19,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11795), 1,
      sym_id,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_record,
    ACTIONS(11803), 1,
      anon_sym_LPAREN,
    ACTIONS(11805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11807), 1,
      anon_sym_u2983,
    ACTIONS(11811), 1,
      aux_sym__qid_token1,
    ACTIONS(11813), 1,
      anon_sym_DOT,
    ACTIONS(11815), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11817), 1,
      anon_sym_u2987,
    ACTIONS(11819), 1,
      aux_sym_integer_token1,
    ACTIONS(11821), 1,
      aux_sym_string_token1,
    ACTIONS(11823), 1,
      anon_sym_Set,
    ACTIONS(13091), 1,
      anon_sym_LBRACE,
    STATE(10427), 1,
      sym__atom_no_curly,
    STATE(11890), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11799), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [599519] = 19,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11795), 1,
      sym_id,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_record,
    ACTIONS(11803), 1,
      anon_sym_LPAREN,
    ACTIONS(11805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11807), 1,
      anon_sym_u2983,
    ACTIONS(11811), 1,
      aux_sym__qid_token1,
    ACTIONS(11813), 1,
      anon_sym_DOT,
    ACTIONS(11815), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11817), 1,
      anon_sym_u2987,
    ACTIONS(11819), 1,
      aux_sym_integer_token1,
    ACTIONS(11821), 1,
      aux_sym_string_token1,
    ACTIONS(11823), 1,
      anon_sym_Set,
    ACTIONS(13093), 1,
      anon_sym_LBRACE,
    STATE(12325), 1,
      sym__atom_no_curly,
    STATE(11890), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11799), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [599590] = 19,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11795), 1,
      sym_id,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_record,
    ACTIONS(11803), 1,
      anon_sym_LPAREN,
    ACTIONS(11805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11807), 1,
      anon_sym_u2983,
    ACTIONS(11811), 1,
      aux_sym__qid_token1,
    ACTIONS(11813), 1,
      anon_sym_DOT,
    ACTIONS(11815), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11817), 1,
      anon_sym_u2987,
    ACTIONS(11819), 1,
      aux_sym_integer_token1,
    ACTIONS(11821), 1,
      aux_sym_string_token1,
    ACTIONS(11823), 1,
      anon_sym_Set,
    ACTIONS(13095), 1,
      anon_sym_LBRACE,
    STATE(11642), 1,
      sym__atom_no_curly,
    STATE(11890), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11799), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [599661] = 19,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11795), 1,
      sym_id,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_record,
    ACTIONS(11803), 1,
      anon_sym_LPAREN,
    ACTIONS(11805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11807), 1,
      anon_sym_u2983,
    ACTIONS(11811), 1,
      aux_sym__qid_token1,
    ACTIONS(11813), 1,
      anon_sym_DOT,
    ACTIONS(11815), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11817), 1,
      anon_sym_u2987,
    ACTIONS(11819), 1,
      aux_sym_integer_token1,
    ACTIONS(11821), 1,
      aux_sym_string_token1,
    ACTIONS(11823), 1,
      anon_sym_Set,
    ACTIONS(13097), 1,
      anon_sym_LBRACE,
    STATE(12321), 1,
      sym__atom_no_curly,
    STATE(11890), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11799), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [599732] = 19,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11795), 1,
      sym_id,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_record,
    ACTIONS(11803), 1,
      anon_sym_LPAREN,
    ACTIONS(11805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11807), 1,
      anon_sym_u2983,
    ACTIONS(11811), 1,
      aux_sym__qid_token1,
    ACTIONS(11813), 1,
      anon_sym_DOT,
    ACTIONS(11815), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11817), 1,
      anon_sym_u2987,
    ACTIONS(11819), 1,
      aux_sym_integer_token1,
    ACTIONS(11821), 1,
      aux_sym_string_token1,
    ACTIONS(11823), 1,
      anon_sym_Set,
    ACTIONS(13099), 1,
      anon_sym_LBRACE,
    STATE(12257), 1,
      sym__atom_no_curly,
    STATE(11890), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11799), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [599803] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6484), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6482), 25,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [599844] = 19,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11795), 1,
      sym_id,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_record,
    ACTIONS(11803), 1,
      anon_sym_LPAREN,
    ACTIONS(11805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11807), 1,
      anon_sym_u2983,
    ACTIONS(11811), 1,
      aux_sym__qid_token1,
    ACTIONS(11813), 1,
      anon_sym_DOT,
    ACTIONS(11815), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11817), 1,
      anon_sym_u2987,
    ACTIONS(11819), 1,
      aux_sym_integer_token1,
    ACTIONS(11821), 1,
      aux_sym_string_token1,
    ACTIONS(11823), 1,
      anon_sym_Set,
    ACTIONS(13101), 1,
      anon_sym_LBRACE,
    STATE(12261), 1,
      sym__atom_no_curly,
    STATE(11890), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11799), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [599915] = 19,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11795), 1,
      sym_id,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_record,
    ACTIONS(11803), 1,
      anon_sym_LPAREN,
    ACTIONS(11805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11807), 1,
      anon_sym_u2983,
    ACTIONS(11811), 1,
      aux_sym__qid_token1,
    ACTIONS(11813), 1,
      anon_sym_DOT,
    ACTIONS(11815), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11817), 1,
      anon_sym_u2987,
    ACTIONS(11819), 1,
      aux_sym_integer_token1,
    ACTIONS(11821), 1,
      aux_sym_string_token1,
    ACTIONS(11823), 1,
      anon_sym_Set,
    ACTIONS(13103), 1,
      anon_sym_LBRACE,
    STATE(12265), 1,
      sym__atom_no_curly,
    STATE(11890), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11799), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [599986] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6710), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6708), 25,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [600027] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6750), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6748), 25,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [600068] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6433), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6431), 25,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [600109] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6714), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6712), 25,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [600150] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6754), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6752), 25,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [600191] = 19,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11795), 1,
      sym_id,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_record,
    ACTIONS(11803), 1,
      anon_sym_LPAREN,
    ACTIONS(11805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11807), 1,
      anon_sym_u2983,
    ACTIONS(11811), 1,
      aux_sym__qid_token1,
    ACTIONS(11813), 1,
      anon_sym_DOT,
    ACTIONS(11815), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11817), 1,
      anon_sym_u2987,
    ACTIONS(11819), 1,
      aux_sym_integer_token1,
    ACTIONS(11821), 1,
      aux_sym_string_token1,
    ACTIONS(11823), 1,
      anon_sym_Set,
    ACTIONS(13105), 1,
      anon_sym_LBRACE,
    STATE(12269), 1,
      sym__atom_no_curly,
    STATE(11890), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11799), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [600262] = 19,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11795), 1,
      sym_id,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_record,
    ACTIONS(11803), 1,
      anon_sym_LPAREN,
    ACTIONS(11805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11807), 1,
      anon_sym_u2983,
    ACTIONS(11811), 1,
      aux_sym__qid_token1,
    ACTIONS(11813), 1,
      anon_sym_DOT,
    ACTIONS(11815), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11817), 1,
      anon_sym_u2987,
    ACTIONS(11819), 1,
      aux_sym_integer_token1,
    ACTIONS(11821), 1,
      aux_sym_string_token1,
    ACTIONS(11823), 1,
      anon_sym_Set,
    ACTIONS(13107), 1,
      anon_sym_LBRACE,
    STATE(11727), 1,
      sym__atom_no_curly,
    STATE(11890), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11799), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [600333] = 19,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11795), 1,
      sym_id,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_record,
    ACTIONS(11803), 1,
      anon_sym_LPAREN,
    ACTIONS(11805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11807), 1,
      anon_sym_u2983,
    ACTIONS(11811), 1,
      aux_sym__qid_token1,
    ACTIONS(11813), 1,
      anon_sym_DOT,
    ACTIONS(11815), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11817), 1,
      anon_sym_u2987,
    ACTIONS(11819), 1,
      aux_sym_integer_token1,
    ACTIONS(11821), 1,
      aux_sym_string_token1,
    ACTIONS(11823), 1,
      anon_sym_Set,
    ACTIONS(13109), 1,
      anon_sym_LBRACE,
    STATE(10450), 1,
      sym__atom_no_curly,
    STATE(11890), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11799), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [600404] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6651), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6649), 25,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [600445] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6647), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6645), 25,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [600486] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6572), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6570), 25,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [600527] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6568), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6566), 25,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [600568] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6655), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6653), 25,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [600609] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6500), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6498), 25,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [600650] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6496), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6494), 25,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [600691] = 19,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11795), 1,
      sym_id,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_record,
    ACTIONS(11803), 1,
      anon_sym_LPAREN,
    ACTIONS(11805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11807), 1,
      anon_sym_u2983,
    ACTIONS(11811), 1,
      aux_sym__qid_token1,
    ACTIONS(11813), 1,
      anon_sym_DOT,
    ACTIONS(11815), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11817), 1,
      anon_sym_u2987,
    ACTIONS(11819), 1,
      aux_sym_integer_token1,
    ACTIONS(11821), 1,
      aux_sym_string_token1,
    ACTIONS(11823), 1,
      anon_sym_Set,
    ACTIONS(13111), 1,
      anon_sym_LBRACE,
    STATE(12273), 1,
      sym__atom_no_curly,
    STATE(11890), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11799), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [600762] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6496), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6494), 25,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [600803] = 19,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11795), 1,
      sym_id,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_record,
    ACTIONS(11803), 1,
      anon_sym_LPAREN,
    ACTIONS(11805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11807), 1,
      anon_sym_u2983,
    ACTIONS(11811), 1,
      aux_sym__qid_token1,
    ACTIONS(11813), 1,
      anon_sym_DOT,
    ACTIONS(11815), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11817), 1,
      anon_sym_u2987,
    ACTIONS(11819), 1,
      aux_sym_integer_token1,
    ACTIONS(11821), 1,
      aux_sym_string_token1,
    ACTIONS(11823), 1,
      anon_sym_Set,
    ACTIONS(13113), 1,
      anon_sym_LBRACE,
    STATE(12313), 1,
      sym__atom_no_curly,
    STATE(11890), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11799), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [600874] = 19,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11795), 1,
      sym_id,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_record,
    ACTIONS(11803), 1,
      anon_sym_LPAREN,
    ACTIONS(11805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11807), 1,
      anon_sym_u2983,
    ACTIONS(11811), 1,
      aux_sym__qid_token1,
    ACTIONS(11813), 1,
      anon_sym_DOT,
    ACTIONS(11815), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11817), 1,
      anon_sym_u2987,
    ACTIONS(11819), 1,
      aux_sym_integer_token1,
    ACTIONS(11821), 1,
      aux_sym_string_token1,
    ACTIONS(11823), 1,
      anon_sym_Set,
    ACTIONS(13115), 1,
      anon_sym_LBRACE,
    STATE(12317), 1,
      sym__atom_no_curly,
    STATE(11890), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11799), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [600945] = 19,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11795), 1,
      sym_id,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_record,
    ACTIONS(11803), 1,
      anon_sym_LPAREN,
    ACTIONS(11805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11807), 1,
      anon_sym_u2983,
    ACTIONS(11811), 1,
      aux_sym__qid_token1,
    ACTIONS(11813), 1,
      anon_sym_DOT,
    ACTIONS(11815), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11817), 1,
      anon_sym_u2987,
    ACTIONS(11819), 1,
      aux_sym_integer_token1,
    ACTIONS(11821), 1,
      aux_sym_string_token1,
    ACTIONS(11823), 1,
      anon_sym_Set,
    ACTIONS(13117), 1,
      anon_sym_LBRACE,
    STATE(12281), 1,
      sym__atom_no_curly,
    STATE(11890), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11799), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [601016] = 19,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11795), 1,
      sym_id,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_record,
    ACTIONS(11803), 1,
      anon_sym_LPAREN,
    ACTIONS(11805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11807), 1,
      anon_sym_u2983,
    ACTIONS(11811), 1,
      aux_sym__qid_token1,
    ACTIONS(11813), 1,
      anon_sym_DOT,
    ACTIONS(11815), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11817), 1,
      anon_sym_u2987,
    ACTIONS(11819), 1,
      aux_sym_integer_token1,
    ACTIONS(11821), 1,
      aux_sym_string_token1,
    ACTIONS(11823), 1,
      anon_sym_Set,
    ACTIONS(13119), 1,
      anon_sym_LBRACE,
    STATE(10775), 1,
      sym__atom_no_curly,
    STATE(11890), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11799), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [601087] = 19,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11795), 1,
      sym_id,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_record,
    ACTIONS(11803), 1,
      anon_sym_LPAREN,
    ACTIONS(11805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11807), 1,
      anon_sym_u2983,
    ACTIONS(11811), 1,
      aux_sym__qid_token1,
    ACTIONS(11813), 1,
      anon_sym_DOT,
    ACTIONS(11815), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11817), 1,
      anon_sym_u2987,
    ACTIONS(11819), 1,
      aux_sym_integer_token1,
    ACTIONS(11821), 1,
      aux_sym_string_token1,
    ACTIONS(11823), 1,
      anon_sym_Set,
    ACTIONS(13121), 1,
      anon_sym_LBRACE,
    STATE(12285), 1,
      sym__atom_no_curly,
    STATE(11890), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11799), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [601158] = 19,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11795), 1,
      sym_id,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_record,
    ACTIONS(11803), 1,
      anon_sym_LPAREN,
    ACTIONS(11805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11807), 1,
      anon_sym_u2983,
    ACTIONS(11811), 1,
      aux_sym__qid_token1,
    ACTIONS(11813), 1,
      anon_sym_DOT,
    ACTIONS(11815), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11817), 1,
      anon_sym_u2987,
    ACTIONS(11819), 1,
      aux_sym_integer_token1,
    ACTIONS(11821), 1,
      aux_sym_string_token1,
    ACTIONS(11823), 1,
      anon_sym_Set,
    ACTIONS(13123), 1,
      anon_sym_LBRACE,
    STATE(12289), 1,
      sym__atom_no_curly,
    STATE(11890), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11799), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [601229] = 19,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11795), 1,
      sym_id,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_record,
    ACTIONS(11803), 1,
      anon_sym_LPAREN,
    ACTIONS(11805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11807), 1,
      anon_sym_u2983,
    ACTIONS(11811), 1,
      aux_sym__qid_token1,
    ACTIONS(11813), 1,
      anon_sym_DOT,
    ACTIONS(11815), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11817), 1,
      anon_sym_u2987,
    ACTIONS(11819), 1,
      aux_sym_integer_token1,
    ACTIONS(11821), 1,
      aux_sym_string_token1,
    ACTIONS(11823), 1,
      anon_sym_Set,
    ACTIONS(13125), 1,
      anon_sym_LBRACE,
    STATE(12293), 1,
      sym__atom_no_curly,
    STATE(11890), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11799), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [601300] = 19,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11795), 1,
      sym_id,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_record,
    ACTIONS(11803), 1,
      anon_sym_LPAREN,
    ACTIONS(11805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11807), 1,
      anon_sym_u2983,
    ACTIONS(11811), 1,
      aux_sym__qid_token1,
    ACTIONS(11813), 1,
      anon_sym_DOT,
    ACTIONS(11815), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11817), 1,
      anon_sym_u2987,
    ACTIONS(11819), 1,
      aux_sym_integer_token1,
    ACTIONS(11821), 1,
      aux_sym_string_token1,
    ACTIONS(11823), 1,
      anon_sym_Set,
    ACTIONS(13127), 1,
      anon_sym_LBRACE,
    STATE(12297), 1,
      sym__atom_no_curly,
    STATE(11890), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11799), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [601371] = 3,
    ACTIONS(6484), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6482), 29,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [601410] = 19,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11795), 1,
      sym_id,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_record,
    ACTIONS(11803), 1,
      anon_sym_LPAREN,
    ACTIONS(11805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11807), 1,
      anon_sym_u2983,
    ACTIONS(11811), 1,
      aux_sym__qid_token1,
    ACTIONS(11813), 1,
      anon_sym_DOT,
    ACTIONS(11815), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11817), 1,
      anon_sym_u2987,
    ACTIONS(11819), 1,
      aux_sym_integer_token1,
    ACTIONS(11821), 1,
      aux_sym_string_token1,
    ACTIONS(11823), 1,
      anon_sym_Set,
    ACTIONS(13129), 1,
      anon_sym_LBRACE,
    STATE(10923), 1,
      sym__atom_no_curly,
    STATE(11890), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11799), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [601481] = 19,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11795), 1,
      sym_id,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_record,
    ACTIONS(11803), 1,
      anon_sym_LPAREN,
    ACTIONS(11805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11807), 1,
      anon_sym_u2983,
    ACTIONS(11811), 1,
      aux_sym__qid_token1,
    ACTIONS(11813), 1,
      anon_sym_DOT,
    ACTIONS(11815), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11817), 1,
      anon_sym_u2987,
    ACTIONS(11819), 1,
      aux_sym_integer_token1,
    ACTIONS(11821), 1,
      aux_sym_string_token1,
    ACTIONS(11823), 1,
      anon_sym_Set,
    ACTIONS(13131), 1,
      anon_sym_LBRACE,
    STATE(12301), 1,
      sym__atom_no_curly,
    STATE(11890), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11799), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [601552] = 5,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13133), 1,
      anon_sym_AT,
    ACTIONS(6326), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6324), 24,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [601595] = 19,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11795), 1,
      sym_id,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_record,
    ACTIONS(11803), 1,
      anon_sym_LPAREN,
    ACTIONS(11805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11807), 1,
      anon_sym_u2983,
    ACTIONS(11811), 1,
      aux_sym__qid_token1,
    ACTIONS(11813), 1,
      anon_sym_DOT,
    ACTIONS(11815), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11817), 1,
      anon_sym_u2987,
    ACTIONS(11819), 1,
      aux_sym_integer_token1,
    ACTIONS(11821), 1,
      aux_sym_string_token1,
    ACTIONS(11823), 1,
      anon_sym_Set,
    ACTIONS(13135), 1,
      anon_sym_LBRACE,
    STATE(12305), 1,
      sym__atom_no_curly,
    STATE(11890), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11799), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [601666] = 3,
    ACTIONS(6750), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6748), 29,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [601705] = 3,
    ACTIONS(6433), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6431), 29,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [601744] = 3,
    ACTIONS(6714), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6712), 29,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [601783] = 3,
    ACTIONS(6754), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6752), 29,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [601822] = 19,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11795), 1,
      sym_id,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_record,
    ACTIONS(11803), 1,
      anon_sym_LPAREN,
    ACTIONS(11805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11807), 1,
      anon_sym_u2983,
    ACTIONS(11811), 1,
      aux_sym__qid_token1,
    ACTIONS(11813), 1,
      anon_sym_DOT,
    ACTIONS(11815), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11817), 1,
      anon_sym_u2987,
    ACTIONS(11819), 1,
      aux_sym_integer_token1,
    ACTIONS(11821), 1,
      aux_sym_string_token1,
    ACTIONS(11823), 1,
      anon_sym_Set,
    ACTIONS(13137), 1,
      anon_sym_LBRACE,
    STATE(10971), 1,
      sym__atom_no_curly,
    STATE(11890), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11799), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [601893] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6655), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6653), 25,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [601934] = 3,
    ACTIONS(6651), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6649), 29,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [601973] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6500), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6498), 25,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [602014] = 3,
    ACTIONS(6647), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6645), 29,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [602053] = 3,
    ACTIONS(6572), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6570), 29,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [602092] = 19,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11795), 1,
      sym_id,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_record,
    ACTIONS(11803), 1,
      anon_sym_LPAREN,
    ACTIONS(11805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11807), 1,
      anon_sym_u2983,
    ACTIONS(11811), 1,
      aux_sym__qid_token1,
    ACTIONS(11813), 1,
      anon_sym_DOT,
    ACTIONS(11815), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11817), 1,
      anon_sym_u2987,
    ACTIONS(11819), 1,
      aux_sym_integer_token1,
    ACTIONS(11821), 1,
      aux_sym_string_token1,
    ACTIONS(11823), 1,
      anon_sym_Set,
    ACTIONS(13139), 1,
      anon_sym_LBRACE,
    STATE(12309), 1,
      sym__atom_no_curly,
    STATE(11890), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11799), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [602163] = 19,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11795), 1,
      sym_id,
    ACTIONS(11797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_record,
    ACTIONS(11803), 1,
      anon_sym_LPAREN,
    ACTIONS(11805), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11807), 1,
      anon_sym_u2983,
    ACTIONS(11811), 1,
      aux_sym__qid_token1,
    ACTIONS(11813), 1,
      anon_sym_DOT,
    ACTIONS(11815), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11817), 1,
      anon_sym_u2987,
    ACTIONS(11819), 1,
      aux_sym_integer_token1,
    ACTIONS(11821), 1,
      aux_sym_string_token1,
    ACTIONS(11823), 1,
      anon_sym_Set,
    ACTIONS(13141), 1,
      anon_sym_LBRACE,
    STATE(11693), 1,
      sym__atom_no_curly,
    STATE(11890), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11799), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [602234] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6496), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6494), 25,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [602275] = 19,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11133), 1,
      sym_id,
    ACTIONS(11135), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11139), 1,
      anon_sym_record,
    ACTIONS(11141), 1,
      anon_sym_LPAREN,
    ACTIONS(11143), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(11145), 1,
      anon_sym_u2983,
    ACTIONS(11149), 1,
      aux_sym__qid_token1,
    ACTIONS(11151), 1,
      anon_sym_DOT,
    ACTIONS(11153), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11155), 1,
      anon_sym_u2987,
    ACTIONS(11157), 1,
      aux_sym_integer_token1,
    ACTIONS(11159), 1,
      aux_sym_string_token1,
    ACTIONS(11161), 1,
      anon_sym_Set,
    ACTIONS(12841), 1,
      anon_sym_LBRACE,
    STATE(7969), 1,
      sym__atom_no_curly,
    STATE(8832), 7,
      sym__ELLIPSIS,
      sym__qid,
      sym__expr_or_attr,
      sym_record_assignments,
      sym_field_assignments,
      sym_literal,
      sym_SetN,
    ACTIONS(11137), 8,
      anon_sym_u2026,
      anon_sym__,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      sym_PropN,
  [602346] = 3,
    ACTIONS(6500), 1,
      anon_sym_BSLASH,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6498), 29,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_u03bb,
      anon_sym_DOT_DOT_DOT,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_quoteGoal,
      anon_sym_tactic,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_LPAREN_PIPE,
      anon_sym_u2987,
      anon_sym_let,
      anon_sym_do,
      aux_sym_integer_token1,
      aux_sym_string_token1,
      anon_sym_Set,
      sym_PropN,
  [602385] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6326), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6324), 24,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [602425] = 5,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13143), 1,
      anon_sym_AT,
    ACTIONS(6326), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6324), 23,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_public,
      anon_sym_using,
      anon_sym_LPAREN,
      anon_sym_hiding,
      anon_sym_renaming,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [602467] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6496), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6494), 24,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [602507] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6655), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6653), 24,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [602547] = 5,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13145), 1,
      anon_sym_AT,
    ACTIONS(6326), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6324), 23,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [602589] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6500), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6498), 24,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [602629] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6496), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6494), 24,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [602669] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6326), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6324), 24,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [602709] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6568), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6566), 24,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [602749] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6572), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6570), 24,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [602789] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6647), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6645), 24,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [602829] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6651), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6649), 24,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [602869] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6754), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6752), 24,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [602909] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6714), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6712), 24,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [602949] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6433), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6431), 24,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [602989] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6710), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6708), 24,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [603029] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6484), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6482), 24,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [603069] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6750), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6748), 24,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [603109] = 5,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13147), 1,
      anon_sym_AT,
    ACTIONS(6326), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6324), 23,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_public,
      anon_sym_using,
      anon_sym_LPAREN,
      anon_sym_hiding,
      anon_sym_renaming,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [603151] = 5,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13149), 1,
      anon_sym_AT,
    ACTIONS(6326), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6324), 23,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [603193] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6326), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6324), 24,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [603233] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6496), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6494), 24,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [603273] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6496), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6494), 24,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [603313] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6655), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6653), 24,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [603353] = 5,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13151), 1,
      anon_sym_EQ,
    ACTIONS(6326), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6324), 23,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_public,
      anon_sym_using,
      anon_sym_LPAREN,
      anon_sym_hiding,
      anon_sym_renaming,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [603395] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6326), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6324), 24,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [603435] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6655), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6653), 24,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [603475] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6655), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6653), 24,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [603515] = 5,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13153), 1,
      anon_sym_AT,
    ACTIONS(6326), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6324), 23,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [603557] = 5,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13155), 1,
      anon_sym_AT,
    ACTIONS(6326), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6324), 23,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [603599] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6484), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6482), 24,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [603639] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6500), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6498), 24,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [603679] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6500), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6498), 24,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [603719] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6572), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6570), 24,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [603759] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6568), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6566), 24,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [603799] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6572), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6570), 24,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [603839] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6568), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6566), 24,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [603879] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6572), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6570), 24,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [603919] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6647), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6645), 24,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [603959] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6568), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6566), 24,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [603999] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6651), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6649), 24,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [604039] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6500), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6498), 24,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [604079] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6754), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6752), 24,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [604119] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6714), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6712), 24,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [604159] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6433), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6431), 24,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [604199] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6750), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6748), 24,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [604239] = 5,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13157), 1,
      anon_sym_AT,
    ACTIONS(6326), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6324), 22,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [604281] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6484), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6482), 24,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [604321] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6710), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6708), 24,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [604361] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6710), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6708), 24,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [604401] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6647), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6645), 24,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [604441] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6750), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6748), 24,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [604481] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6651), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6649), 24,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [604521] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6433), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6431), 24,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [604561] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6710), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6708), 24,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [604601] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6754), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6752), 24,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [604641] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6714), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6712), 24,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [604681] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6714), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6712), 24,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [604721] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6433), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6431), 24,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [604761] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6484), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6482), 24,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [604801] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6754), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6752), 24,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [604841] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6651), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6649), 24,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [604881] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6647), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6645), 24,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [604921] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6750), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6748), 24,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [604961] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6750), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6748), 23,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [605000] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6754), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6752), 23,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_public,
      anon_sym_using,
      anon_sym_LPAREN,
      anon_sym_hiding,
      anon_sym_renaming,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [605039] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6568), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6566), 23,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [605078] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6655), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6653), 23,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [605117] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6655), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6653), 22,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [605156] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6326), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6324), 23,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_public,
      anon_sym_using,
      anon_sym_LPAREN,
      anon_sym_hiding,
      anon_sym_renaming,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [605195] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6500), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6498), 22,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [605234] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6500), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6498), 23,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [605273] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6572), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6570), 23,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [605312] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6572), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6570), 23,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [605351] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6568), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6566), 22,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [605390] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6572), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6570), 22,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [605429] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6647), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6645), 23,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [605468] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6651), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6649), 23,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [605507] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6647), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6645), 22,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [605546] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6651), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6649), 22,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [605585] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6754), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6752), 22,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [605624] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6714), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6712), 22,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [605663] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6496), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6494), 23,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [605702] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6433), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6431), 22,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [605741] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6754), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6752), 23,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [605780] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6714), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6712), 23,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [605819] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6750), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6748), 22,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [605858] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6710), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6708), 22,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [605897] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6484), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6482), 22,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [605936] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6326), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6324), 23,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [605975] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6433), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6431), 23,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [606014] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6496), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6494), 22,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [606053] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6484), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6482), 23,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [606092] = 5,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13159), 1,
      anon_sym_AT,
    ACTIONS(6326), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6324), 22,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_public,
      anon_sym_using,
      anon_sym_LPAREN,
      anon_sym_hiding,
      anon_sym_renaming,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [606133] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6496), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6494), 23,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_public,
      anon_sym_using,
      anon_sym_LPAREN,
      anon_sym_hiding,
      anon_sym_renaming,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [606172] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6484), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6482), 23,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [606211] = 5,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13161), 1,
      anon_sym_AT,
    ACTIONS(6326), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6324), 21,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [606252] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6655), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6653), 23,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_public,
      anon_sym_using,
      anon_sym_LPAREN,
      anon_sym_hiding,
      anon_sym_renaming,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [606291] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6710), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6708), 23,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [606330] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6710), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6708), 23,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [606369] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6750), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6748), 23,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [606408] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6433), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6431), 23,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [606447] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6714), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6712), 23,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [606486] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6754), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6752), 23,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [606525] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6651), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6649), 23,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [606564] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6647), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6645), 23,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [606603] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6568), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6566), 23,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [606642] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6500), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6498), 23,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [606681] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6326), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6324), 23,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [606720] = 5,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13163), 1,
      anon_sym_AT,
    ACTIONS(6326), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6324), 22,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [606761] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6496), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6494), 23,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [606800] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6655), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6653), 23,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [606839] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6710), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6708), 23,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [606878] = 5,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13165), 1,
      anon_sym_EQ,
    ACTIONS(6326), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6324), 23,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_public,
      anon_sym_using,
      anon_sym_LPAREN,
      anon_sym_hiding,
      anon_sym_renaming,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [606919] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6655), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6653), 23,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [606958] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6496), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6494), 23,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [606997] = 5,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13167), 1,
      anon_sym_AT,
    ACTIONS(6326), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6324), 22,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [607038] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6500), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6498), 23,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [607077] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6496), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6494), 23,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_public,
      anon_sym_using,
      anon_sym_LPAREN,
      anon_sym_hiding,
      anon_sym_renaming,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [607116] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6568), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6566), 23,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [607155] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6572), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6570), 23,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [607194] = 5,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13169), 1,
      anon_sym_AT,
    ACTIONS(6326), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6324), 23,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [607235] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6647), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6645), 23,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [607274] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6326), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6324), 22,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [607313] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6651), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6649), 23,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [607352] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6714), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6712), 23,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [607391] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6433), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6431), 23,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [607430] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6750), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6748), 23,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [607469] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6500), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6498), 23,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_public,
      anon_sym_using,
      anon_sym_LPAREN,
      anon_sym_hiding,
      anon_sym_renaming,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [607508] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6568), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6566), 23,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_public,
      anon_sym_using,
      anon_sym_LPAREN,
      anon_sym_hiding,
      anon_sym_renaming,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [607547] = 5,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13171), 1,
      anon_sym_AT,
    ACTIONS(6326), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6324), 22,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [607588] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6572), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6570), 23,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_public,
      anon_sym_using,
      anon_sym_LPAREN,
      anon_sym_hiding,
      anon_sym_renaming,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [607627] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6655), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6653), 23,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_public,
      anon_sym_using,
      anon_sym_LPAREN,
      anon_sym_hiding,
      anon_sym_renaming,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [607666] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6647), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6645), 23,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_public,
      anon_sym_using,
      anon_sym_LPAREN,
      anon_sym_hiding,
      anon_sym_renaming,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [607705] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6651), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6649), 23,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_public,
      anon_sym_using,
      anon_sym_LPAREN,
      anon_sym_hiding,
      anon_sym_renaming,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [607744] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6484), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6482), 23,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [607783] = 5,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13173), 1,
      anon_sym_AT,
    ACTIONS(6326), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6324), 22,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [607824] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6754), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6752), 23,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_public,
      anon_sym_using,
      anon_sym_LPAREN,
      anon_sym_hiding,
      anon_sym_renaming,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [607863] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6714), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6712), 23,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_public,
      anon_sym_using,
      anon_sym_LPAREN,
      anon_sym_hiding,
      anon_sym_renaming,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [607902] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6433), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6431), 23,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_public,
      anon_sym_using,
      anon_sym_LPAREN,
      anon_sym_hiding,
      anon_sym_renaming,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [607941] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6750), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6748), 23,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_public,
      anon_sym_using,
      anon_sym_LPAREN,
      anon_sym_hiding,
      anon_sym_renaming,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [607980] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6710), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6708), 23,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_public,
      anon_sym_using,
      anon_sym_LPAREN,
      anon_sym_hiding,
      anon_sym_renaming,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [608019] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6484), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6482), 23,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_public,
      anon_sym_using,
      anon_sym_LPAREN,
      anon_sym_hiding,
      anon_sym_renaming,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [608058] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6326), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6324), 23,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_public,
      anon_sym_using,
      anon_sym_LPAREN,
      anon_sym_hiding,
      anon_sym_renaming,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [608097] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13177), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(13175), 23,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_public,
      anon_sym_using,
      anon_sym_LPAREN,
      anon_sym_hiding,
      anon_sym_renaming,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [608136] = 5,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13179), 1,
      anon_sym_AT,
    ACTIONS(6326), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6324), 22,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_public,
      anon_sym_using,
      anon_sym_LPAREN,
      anon_sym_hiding,
      anon_sym_renaming,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [608177] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6326), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6324), 23,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [608216] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13183), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(13181), 23,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_public,
      anon_sym_using,
      anon_sym_LPAREN,
      anon_sym_hiding,
      anon_sym_renaming,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [608255] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13177), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(13175), 23,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_public,
      anon_sym_using,
      anon_sym_LPAREN,
      anon_sym_hiding,
      anon_sym_renaming,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [608294] = 5,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13185), 1,
      anon_sym_AT,
    ACTIONS(6326), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6324), 21,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [608335] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6754), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6752), 23,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [608374] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6326), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6324), 23,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [608413] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6484), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6482), 23,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_public,
      anon_sym_using,
      anon_sym_LPAREN,
      anon_sym_hiding,
      anon_sym_renaming,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [608452] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6484), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6482), 23,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [608491] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6710), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6708), 23,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_public,
      anon_sym_using,
      anon_sym_LPAREN,
      anon_sym_hiding,
      anon_sym_renaming,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [608530] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6750), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6748), 23,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_public,
      anon_sym_using,
      anon_sym_LPAREN,
      anon_sym_hiding,
      anon_sym_renaming,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [608569] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6433), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6431), 23,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_public,
      anon_sym_using,
      anon_sym_LPAREN,
      anon_sym_hiding,
      anon_sym_renaming,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [608608] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6496), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6494), 23,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [608647] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6655), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6653), 23,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [608686] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6714), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6712), 23,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_public,
      anon_sym_using,
      anon_sym_LPAREN,
      anon_sym_hiding,
      anon_sym_renaming,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [608725] = 5,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13187), 1,
      anon_sym_AT,
    ACTIONS(6326), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6324), 21,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [608766] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6750), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6748), 23,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [608805] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6710), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6708), 23,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [608844] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6647), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6645), 23,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [608883] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6651), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6649), 23,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [608922] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6500), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6498), 23,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_public,
      anon_sym_using,
      anon_sym_LPAREN,
      anon_sym_hiding,
      anon_sym_renaming,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [608961] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6754), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6752), 23,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [609000] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6568), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6566), 23,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_public,
      anon_sym_using,
      anon_sym_LPAREN,
      anon_sym_hiding,
      anon_sym_renaming,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [609039] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6572), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6570), 23,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_public,
      anon_sym_using,
      anon_sym_LPAREN,
      anon_sym_hiding,
      anon_sym_renaming,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [609078] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6500), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6498), 23,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [609117] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6568), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6566), 23,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [609156] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6714), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6712), 23,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [609195] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6647), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6645), 23,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_public,
      anon_sym_using,
      anon_sym_LPAREN,
      anon_sym_hiding,
      anon_sym_renaming,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [609234] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6651), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6649), 23,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_public,
      anon_sym_using,
      anon_sym_LPAREN,
      anon_sym_hiding,
      anon_sym_renaming,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [609273] = 5,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13189), 1,
      anon_sym_AT,
    ACTIONS(6326), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6324), 22,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [609314] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6572), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6570), 23,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [609353] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6433), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6431), 23,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [609392] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6484), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6482), 22,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_public,
      anon_sym_using,
      anon_sym_LPAREN,
      anon_sym_hiding,
      anon_sym_renaming,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [609430] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6568), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6566), 22,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [609468] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6496), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6494), 22,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [609506] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6568), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6566), 21,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [609544] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6572), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6570), 21,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [609582] = 5,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13191), 1,
      anon_sym_AT,
    ACTIONS(6326), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6324), 20,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [609622] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6647), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6645), 21,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [609660] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6651), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6649), 21,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [609698] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6754), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6752), 21,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [609736] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6326), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6324), 21,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [609774] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6714), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6712), 21,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [609812] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6484), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6482), 22,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [609850] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6433), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6431), 21,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [609888] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6750), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6748), 21,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [609926] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6710), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6708), 21,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [609964] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6484), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6482), 21,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [610002] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6754), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6752), 22,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [610040] = 5,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13193), 1,
      anon_sym_AT,
    ACTIONS(6326), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6324), 21,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [610080] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6484), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6482), 21,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [610118] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6500), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6498), 21,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [610156] = 5,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13195), 1,
      anon_sym_AT,
    ACTIONS(6326), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6324), 21,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [610196] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6710), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6708), 21,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [610234] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6750), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6748), 21,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [610272] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6433), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6431), 21,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [610310] = 5,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13197), 1,
      anon_sym_AT,
    ACTIONS(6326), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6324), 21,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [610350] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6651), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6649), 22,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [610388] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6714), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6712), 21,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [610426] = 5,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13199), 1,
      anon_sym_AT,
    ACTIONS(6326), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6324), 22,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      anon_sym_u2988,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [610466] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6484), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6482), 22,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [610504] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6710), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6708), 22,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [610542] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6750), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6748), 22,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [610580] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6433), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6431), 22,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [610618] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6754), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6752), 21,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [610656] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6714), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6712), 22,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [610694] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6754), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6752), 22,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [610732] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6651), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6649), 22,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [610770] = 5,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13201), 1,
      anon_sym_AT,
    ACTIONS(6326), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6324), 22,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [610810] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6647), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6645), 22,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [610848] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6572), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6570), 22,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [610886] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6568), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6566), 22,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [610924] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6710), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6708), 23,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [610962] = 5,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13203), 1,
      anon_sym_AT,
    ACTIONS(6326), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6324), 22,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [611002] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6484), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6482), 23,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [611040] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6326), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6324), 21,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [611078] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6500), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6498), 22,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [611116] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6651), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6649), 21,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [611154] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6647), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6645), 21,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [611192] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6655), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6653), 22,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [611230] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6572), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6570), 21,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [611268] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6568), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6566), 21,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [611306] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6500), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6498), 21,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [611344] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6326), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6324), 22,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [611382] = 5,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13205), 1,
      anon_sym_AT,
    ACTIONS(6326), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6324), 21,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [611422] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6568), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6566), 22,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [611460] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6500), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6498), 22,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [611498] = 5,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13207), 1,
      anon_sym_AT,
    ACTIONS(6326), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      anon_sym_PIPE_RPAREN,
      aux_sym_string_token1,
    ACTIONS(6324), 21,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [611538] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6326), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6324), 23,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [611576] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13177), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(13175), 22,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_public,
      anon_sym_using,
      anon_sym_LPAREN,
      anon_sym_hiding,
      anon_sym_renaming,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [611614] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6655), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6653), 22,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [611652] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13183), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(13181), 22,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_public,
      anon_sym_using,
      anon_sym_LPAREN,
      anon_sym_hiding,
      anon_sym_renaming,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [611690] = 5,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13209), 1,
      anon_sym_AT,
    ACTIONS(6326), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6324), 20,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [611730] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6496), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6494), 22,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [611768] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6484), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6482), 22,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [611806] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6710), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6708), 22,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [611844] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6750), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6748), 22,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [611882] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6433), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6431), 22,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [611920] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6572), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6570), 21,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [611958] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6326), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6324), 22,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [611996] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6714), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6712), 22,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [612034] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6754), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6752), 22,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [612072] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6496), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6494), 22,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_public,
      anon_sym_using,
      anon_sym_LPAREN,
      anon_sym_hiding,
      anon_sym_renaming,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [612110] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6651), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6649), 22,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [612148] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6647), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6645), 22,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [612186] = 5,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13211), 1,
      anon_sym_AT,
    ACTIONS(6326), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6324), 22,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [612226] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6572), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6570), 22,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [612264] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6655), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6653), 22,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_public,
      anon_sym_using,
      anon_sym_LPAREN,
      anon_sym_hiding,
      anon_sym_renaming,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [612302] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6568), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6566), 22,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [612340] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6500), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6498), 22,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [612378] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6500), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6498), 22,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_public,
      anon_sym_using,
      anon_sym_LPAREN,
      anon_sym_hiding,
      anon_sym_renaming,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [612416] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6655), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6653), 21,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [612454] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6568), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6566), 22,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_public,
      anon_sym_using,
      anon_sym_LPAREN,
      anon_sym_hiding,
      anon_sym_renaming,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [612492] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6572), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6570), 22,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_public,
      anon_sym_using,
      anon_sym_LPAREN,
      anon_sym_hiding,
      anon_sym_renaming,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [612530] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6754), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6752), 23,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [612568] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6651), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6649), 22,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_public,
      anon_sym_using,
      anon_sym_LPAREN,
      anon_sym_hiding,
      anon_sym_renaming,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [612606] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6651), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6649), 23,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [612644] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6714), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6712), 23,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [612682] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6754), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6752), 22,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_public,
      anon_sym_using,
      anon_sym_LPAREN,
      anon_sym_hiding,
      anon_sym_renaming,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [612720] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6647), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6645), 23,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [612758] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6714), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6712), 22,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_public,
      anon_sym_using,
      anon_sym_LPAREN,
      anon_sym_hiding,
      anon_sym_renaming,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [612796] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6500), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6498), 22,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [612834] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6496), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6494), 21,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [612872] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6750), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6748), 22,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_public,
      anon_sym_using,
      anon_sym_LPAREN,
      anon_sym_hiding,
      anon_sym_renaming,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [612910] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6572), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6570), 23,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [612948] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6568), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6566), 23,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [612986] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6496), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6494), 21,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [613024] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6500), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6498), 23,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [613062] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6655), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6653), 23,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [613100] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6647), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6645), 22,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_public,
      anon_sym_using,
      anon_sym_LPAREN,
      anon_sym_hiding,
      anon_sym_renaming,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [613138] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6710), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6708), 22,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [613176] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6750), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6748), 22,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [613214] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6496), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6494), 23,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [613252] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6496), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6494), 21,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [613290] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6326), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6324), 22,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [613328] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6655), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6653), 22,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [613366] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6655), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6653), 21,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [613404] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6568), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6566), 22,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [613442] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6655), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6653), 21,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [613480] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6496), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6494), 22,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [613518] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6433), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6431), 22,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_public,
      anon_sym_using,
      anon_sym_LPAREN,
      anon_sym_hiding,
      anon_sym_renaming,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [613556] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6710), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6708), 22,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_public,
      anon_sym_using,
      anon_sym_LPAREN,
      anon_sym_hiding,
      anon_sym_renaming,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [613594] = 5,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13213), 1,
      anon_sym_AT,
    ACTIONS(6326), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6324), 22,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [613634] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6655), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6653), 22,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [613672] = 5,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13215), 1,
      anon_sym_AT,
    ACTIONS(6326), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6324), 21,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [613712] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6496), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6494), 22,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [613750] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6484), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6482), 22,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [613788] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6710), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6708), 22,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [613826] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6750), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6748), 22,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [613864] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6433), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6431), 22,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [613902] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6750), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6748), 23,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [613940] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6714), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6712), 22,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [613978] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6326), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6324), 22,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [614016] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6326), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6324), 22,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [614054] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6326), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6324), 22,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_public,
      anon_sym_using,
      anon_sym_LPAREN,
      anon_sym_hiding,
      anon_sym_renaming,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [614092] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6572), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6570), 22,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [614130] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6754), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6752), 22,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [614168] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6496), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6494), 22,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_public,
      anon_sym_using,
      anon_sym_LPAREN,
      anon_sym_hiding,
      anon_sym_renaming,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [614206] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6651), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6649), 22,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [614244] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6647), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6645), 22,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [614282] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6433), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6431), 22,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [614320] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13183), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(13181), 22,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_public,
      anon_sym_using,
      anon_sym_LPAREN,
      anon_sym_hiding,
      anon_sym_renaming,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [614358] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6655), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6653), 22,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_public,
      anon_sym_using,
      anon_sym_LPAREN,
      anon_sym_hiding,
      anon_sym_renaming,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [614396] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6647), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6645), 22,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [614434] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6572), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6570), 22,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [614472] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6433), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6431), 23,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [614510] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6500), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6498), 21,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [614548] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6714), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6712), 22,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [614586] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6651), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6649), 22,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [614624] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6647), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6645), 22,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [614662] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6568), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6566), 21,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [614700] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6754), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6752), 22,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [614738] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6647), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6645), 21,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [614776] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6651), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6649), 21,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [614814] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6326), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6324), 22,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_public,
      anon_sym_using,
      anon_sym_LPAREN,
      anon_sym_hiding,
      anon_sym_renaming,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [614852] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6714), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6712), 22,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [614890] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6496), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6494), 22,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [614928] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6433), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6431), 22,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [614966] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6754), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6752), 21,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [615004] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6714), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6712), 21,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [615042] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6433), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6431), 21,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [615080] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6750), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6748), 22,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [615118] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6750), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6748), 21,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [615156] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6710), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6708), 21,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [615194] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6655), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6653), 22,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [615232] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6572), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6570), 22,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [615270] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6484), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6482), 21,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [615308] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6710), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6708), 22,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [615346] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6326), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6324), 21,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [615384] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6484), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6482), 22,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [615422] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6500), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6498), 22,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_public,
      anon_sym_using,
      anon_sym_LPAREN,
      anon_sym_hiding,
      anon_sym_renaming,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [615460] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13177), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(13175), 22,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_public,
      anon_sym_using,
      anon_sym_LPAREN,
      anon_sym_hiding,
      anon_sym_renaming,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [615498] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6568), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6566), 22,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_public,
      anon_sym_using,
      anon_sym_LPAREN,
      anon_sym_hiding,
      anon_sym_renaming,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [615536] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6572), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6570), 22,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_public,
      anon_sym_using,
      anon_sym_LPAREN,
      anon_sym_hiding,
      anon_sym_renaming,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [615574] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6647), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6645), 22,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_public,
      anon_sym_using,
      anon_sym_LPAREN,
      anon_sym_hiding,
      anon_sym_renaming,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [615612] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6651), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6649), 22,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_public,
      anon_sym_using,
      anon_sym_LPAREN,
      anon_sym_hiding,
      anon_sym_renaming,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [615650] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6754), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6752), 22,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_public,
      anon_sym_using,
      anon_sym_LPAREN,
      anon_sym_hiding,
      anon_sym_renaming,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [615688] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6714), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6712), 22,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_public,
      anon_sym_using,
      anon_sym_LPAREN,
      anon_sym_hiding,
      anon_sym_renaming,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [615726] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6433), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6431), 22,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_public,
      anon_sym_using,
      anon_sym_LPAREN,
      anon_sym_hiding,
      anon_sym_renaming,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [615764] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6750), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6748), 22,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_public,
      anon_sym_using,
      anon_sym_LPAREN,
      anon_sym_hiding,
      anon_sym_renaming,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [615802] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6710), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6708), 22,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_public,
      anon_sym_using,
      anon_sym_LPAREN,
      anon_sym_hiding,
      anon_sym_renaming,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [615840] = 5,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13217), 1,
      anon_sym_AT,
    ACTIONS(6326), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6324), 21,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [615880] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6484), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6482), 22,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_public,
      anon_sym_using,
      anon_sym_LPAREN,
      anon_sym_hiding,
      anon_sym_renaming,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [615918] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6500), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6498), 22,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [615956] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6651), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6649), 22,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [615993] = 5,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13219), 1,
      anon_sym_AT,
    ACTIONS(6326), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6324), 20,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [616032] = 5,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13221), 1,
      anon_sym_AT,
    ACTIONS(6326), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6324), 21,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [616071] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6433), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6431), 22,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [616108] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6433), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6431), 21,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [616145] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6710), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6708), 21,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [616182] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6484), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6482), 22,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [616219] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6754), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6752), 21,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [616256] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6326), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6324), 21,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [616293] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6655), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6653), 21,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [616330] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6750), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6748), 22,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [616367] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6714), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6712), 22,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [616404] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6710), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6708), 22,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [616441] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6647), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6645), 21,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [616478] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6496), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6494), 21,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [616515] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6326), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6324), 22,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [616552] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6714), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6712), 21,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [616589] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6572), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6570), 21,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [616626] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6568), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6566), 21,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [616663] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6500), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6498), 21,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [616700] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6500), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6498), 21,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [616737] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6754), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6752), 22,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [616774] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6651), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6649), 22,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [616811] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6568), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6566), 21,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [616848] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6496), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6494), 21,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [616885] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6484), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6482), 22,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [616922] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6710), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6708), 22,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [616959] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6572), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6570), 21,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [616996] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6655), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6653), 21,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [617033] = 5,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13223), 1,
      anon_sym_AT,
    ACTIONS(6326), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6324), 20,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [617072] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6714), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6712), 21,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [617109] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6750), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6748), 21,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [617146] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6647), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6645), 22,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [617183] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6647), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6645), 22,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [617220] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6484), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6482), 21,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [617257] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6647), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6645), 21,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [617294] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6484), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6482), 22,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [617331] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6326), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6324), 21,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [617368] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6484), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6482), 22,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [617405] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6710), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6708), 22,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [617442] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6572), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6570), 21,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [617479] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6710), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6708), 22,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [617516] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6433), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6431), 21,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [617553] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6750), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6748), 22,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [617590] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6572), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6570), 22,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [617627] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6433), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6431), 22,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [617664] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6568), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6566), 22,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [617701] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6433), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6431), 22,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [617738] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6714), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6712), 22,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [617775] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6714), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6712), 22,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [617812] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6754), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6752), 22,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [617849] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6500), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6498), 21,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [617886] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6568), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6566), 21,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [617923] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6651), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6649), 22,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [617960] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6754), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6752), 22,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [617997] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6655), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6653), 20,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [618034] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6572), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6570), 21,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [618071] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6651), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6649), 22,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [618108] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6647), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6645), 22,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [618145] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6572), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6570), 22,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [618182] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6326), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6324), 20,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [618219] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6754), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6752), 21,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [618256] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6500), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6498), 22,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [618293] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6651), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6649), 21,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [618330] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6433), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6431), 21,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [618367] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6750), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6748), 21,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [618404] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6651), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6649), 21,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [618441] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6326), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      anon_sym_PIPE_RPAREN,
      aux_sym_string_token1,
    ACTIONS(6324), 21,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [618478] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6572), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6570), 22,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [618515] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6568), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6566), 22,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [618552] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6496), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6494), 22,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [618589] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6500), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6498), 22,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [618626] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6710), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6708), 21,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [618663] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6484), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6482), 21,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [618700] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6433), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6431), 22,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [618737] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6714), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6712), 22,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [618774] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6568), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6566), 22,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [618811] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6326), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6324), 21,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [618848] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6500), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6498), 22,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [618885] = 5,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13225), 1,
      anon_sym_AT,
    ACTIONS(6326), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6324), 20,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [618924] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6754), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6752), 22,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [618961] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6326), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6324), 22,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      anon_sym_u2988,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [618998] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6655), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6653), 21,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [619035] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6433), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6431), 21,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [619072] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6647), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6645), 22,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [619109] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6750), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6748), 22,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [619146] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6754), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6752), 21,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [619183] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6714), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6712), 21,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [619220] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6496), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6494), 21,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [619257] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6484), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      anon_sym_PIPE_RPAREN,
      aux_sym_string_token1,
    ACTIONS(6482), 21,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [619294] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6572), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6570), 22,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [619331] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6568), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6566), 22,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [619368] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6710), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      anon_sym_PIPE_RPAREN,
      aux_sym_string_token1,
    ACTIONS(6708), 21,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [619405] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6651), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6649), 21,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [619442] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6750), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      anon_sym_PIPE_RPAREN,
      aux_sym_string_token1,
    ACTIONS(6748), 21,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [619479] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6500), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6498), 22,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [619516] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6433), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      anon_sym_PIPE_RPAREN,
      aux_sym_string_token1,
    ACTIONS(6431), 21,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [619553] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6714), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      anon_sym_PIPE_RPAREN,
      aux_sym_string_token1,
    ACTIONS(6712), 21,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [619590] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6754), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      anon_sym_PIPE_RPAREN,
      aux_sym_string_token1,
    ACTIONS(6752), 21,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [619627] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6651), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      anon_sym_PIPE_RPAREN,
      aux_sym_string_token1,
    ACTIONS(6649), 21,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [619664] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6647), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      anon_sym_PIPE_RPAREN,
      aux_sym_string_token1,
    ACTIONS(6645), 21,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [619701] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6326), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6324), 21,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [619738] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6572), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      anon_sym_PIPE_RPAREN,
      aux_sym_string_token1,
    ACTIONS(6570), 21,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [619775] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6326), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6324), 21,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [619812] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6568), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      anon_sym_PIPE_RPAREN,
      aux_sym_string_token1,
    ACTIONS(6566), 21,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [619849] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6500), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      anon_sym_PIPE_RPAREN,
      aux_sym_string_token1,
    ACTIONS(6498), 21,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [619886] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6655), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6653), 22,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [619923] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6433), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6431), 21,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [619960] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6484), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6482), 21,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [619997] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6496), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6494), 22,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [620034] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6484), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6482), 22,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      anon_sym_u2988,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [620071] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6326), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6324), 22,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [620108] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6710), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6708), 22,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      anon_sym_u2988,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [620145] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6750), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6748), 22,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      anon_sym_u2988,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [620182] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6710), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6708), 21,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [620219] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6433), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6431), 22,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      anon_sym_u2988,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [620256] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6714), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6712), 22,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      anon_sym_u2988,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [620293] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6750), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6748), 21,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [620330] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6326), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6324), 22,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [620367] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6710), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6708), 20,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [620404] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6750), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6748), 21,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [620441] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6433), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6431), 20,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [620478] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6651), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6649), 22,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      anon_sym_u2988,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [620515] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6647), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6645), 22,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      anon_sym_u2988,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [620552] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6647), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6645), 20,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [620589] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6572), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6570), 22,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      anon_sym_u2988,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [620626] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6568), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6566), 22,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      anon_sym_u2988,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [620663] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6484), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6482), 20,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [620700] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6754), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6752), 22,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      anon_sym_u2988,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [620737] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6655), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      anon_sym_PIPE_RPAREN,
      aux_sym_string_token1,
    ACTIONS(6653), 21,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [620774] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6714), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6712), 21,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [620811] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6710), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6708), 21,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [620848] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6754), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6752), 21,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [620885] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6750), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6748), 22,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [620922] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6496), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      anon_sym_PIPE_RPAREN,
      aux_sym_string_token1,
    ACTIONS(6494), 21,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [620959] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6750), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6748), 20,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [620996] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6651), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6649), 21,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [621033] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6484), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6482), 21,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [621070] = 5,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13227), 1,
      anon_sym_AT,
    ACTIONS(6326), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6324), 21,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      anon_sym_u2988,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [621109] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6714), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6712), 20,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [621146] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6710), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6708), 21,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [621183] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6750), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6748), 21,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [621220] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6647), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6645), 21,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [621257] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6484), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6482), 21,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [621294] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6754), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6752), 20,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [621331] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6651), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6649), 20,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [621368] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6572), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6570), 20,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [621405] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6568), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6566), 20,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [621442] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6655), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6653), 22,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [621479] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6500), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6498), 20,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [621516] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6496), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6494), 22,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [621553] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6572), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6570), 21,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [621590] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6655), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6653), 22,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [621627] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6496), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6494), 21,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [621664] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6568), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6566), 21,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [621701] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6500), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6498), 21,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [621738] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6433), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6431), 21,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [621775] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6714), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6712), 21,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [621812] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6655), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6653), 21,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [621849] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6754), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6752), 21,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [621886] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6651), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6649), 21,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [621923] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6647), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6645), 21,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [621960] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6568), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6566), 21,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [621997] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6655), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6653), 20,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [622034] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6500), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6498), 21,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [622071] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6655), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6653), 22,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [622108] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6655), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6653), 22,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      anon_sym_u2988,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [622145] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6496), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6494), 20,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [622182] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6484), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6482), 20,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [622219] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6647), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6645), 21,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [622256] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6496), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6494), 22,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [622293] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6496), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6494), 20,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [622330] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6496), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6494), 22,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      anon_sym_u2988,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [622367] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6326), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6324), 22,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [622404] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6655), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6653), 21,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [622441] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6496), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6494), 21,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [622478] = 5,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13229), 1,
      anon_sym_AT,
    ACTIONS(6326), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6324), 21,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [622517] = 5,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13231), 1,
      anon_sym_AT,
    ACTIONS(6326), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6324), 20,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [622556] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6710), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6708), 20,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [622593] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6326), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6324), 21,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [622630] = 5,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13233), 1,
      anon_sym_AT,
    ACTIONS(6326), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6324), 21,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [622669] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6496), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6494), 21,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [622706] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6750), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6748), 20,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [622743] = 5,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13235), 1,
      anon_sym_AT,
    ACTIONS(6326), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6324), 20,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [622782] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6433), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6431), 20,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [622819] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6714), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6712), 20,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [622856] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6655), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6653), 21,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [622893] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6754), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6752), 20,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [622930] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6500), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6498), 22,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      anon_sym_u2988,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [622967] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6710), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6708), 21,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [623004] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6651), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6649), 20,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [623041] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6500), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6498), 21,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [623078] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6647), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6645), 20,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [623115] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6572), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6570), 20,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [623152] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6568), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6566), 20,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [623189] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6568), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6566), 21,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [623226] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6500), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6498), 20,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [623263] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6572), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6570), 21,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [623300] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6647), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6645), 21,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [623337] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6326), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6324), 20,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [623374] = 5,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13237), 1,
      anon_sym_AT,
    ACTIONS(6326), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      anon_sym_PIPE_RPAREN,
      aux_sym_string_token1,
    ACTIONS(6324), 20,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [623413] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6651), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6649), 21,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [623450] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6754), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6752), 21,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [623487] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6714), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6712), 21,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [623524] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6484), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6482), 21,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [623561] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6750), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6748), 21,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [623598] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6651), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6649), 21,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [623634] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6433), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6431), 20,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [623670] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6326), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6324), 20,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [623706] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6714), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6712), 21,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [623742] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6568), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6566), 20,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [623778] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6655), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6653), 20,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [623814] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6714), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6712), 20,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [623850] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6647), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      anon_sym_PIPE_RPAREN,
      aux_sym_string_token1,
    ACTIONS(6645), 20,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [623886] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6655), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6653), 20,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [623922] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6496), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6494), 21,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [623958] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6754), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6752), 21,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [623994] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6496), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6494), 20,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [624030] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6484), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6482), 21,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [624066] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6651), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6649), 21,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [624102] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6647), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6645), 21,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [624138] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6433), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6431), 20,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [624174] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6433), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      anon_sym_PIPE_RPAREN,
      aux_sym_string_token1,
    ACTIONS(6431), 20,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [624210] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6710), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      anon_sym_PIPE_RPAREN,
      aux_sym_string_token1,
    ACTIONS(6708), 20,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [624246] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6572), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6570), 21,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [624282] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6655), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6653), 21,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [624318] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6568), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6566), 21,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [624354] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6710), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6708), 20,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [624390] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6326), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6324), 21,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [624426] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6714), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6712), 20,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [624462] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6750), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6748), 21,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [624498] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6496), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6494), 20,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [624534] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6572), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6570), 20,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [624570] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6750), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6748), 20,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [624606] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6750), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6748), 20,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [624642] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6710), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6708), 21,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [624678] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6484), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      anon_sym_PIPE_RPAREN,
      aux_sym_string_token1,
    ACTIONS(6482), 20,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [624714] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6710), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6708), 21,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [624750] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6484), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6482), 21,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [624786] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6500), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6498), 21,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [624822] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6750), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6748), 21,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [624858] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6750), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      anon_sym_PIPE_RPAREN,
      aux_sym_string_token1,
    ACTIONS(6748), 20,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [624894] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6710), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6708), 20,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [624930] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6433), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6431), 21,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [624966] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6714), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      anon_sym_PIPE_RPAREN,
      aux_sym_string_token1,
    ACTIONS(6712), 20,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [625002] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6496), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6494), 21,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      anon_sym_u2988,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [625038] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6484), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6482), 20,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [625074] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6754), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      anon_sym_PIPE_RPAREN,
      aux_sym_string_token1,
    ACTIONS(6752), 20,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [625110] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6651), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      anon_sym_PIPE_RPAREN,
      aux_sym_string_token1,
    ACTIONS(6649), 20,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [625146] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6710), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6708), 20,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [625182] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6714), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6712), 21,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [625218] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6754), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6752), 21,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [625254] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6500), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6498), 21,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [625290] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6568), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6566), 21,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [625326] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6572), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6570), 21,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [625362] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6647), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6645), 21,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      anon_sym_u2988,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [625398] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6484), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6482), 20,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [625434] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6750), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6748), 20,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [625470] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6651), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6649), 21,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [625506] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6655), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6653), 21,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [625542] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6433), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6431), 21,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [625578] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6484), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6482), 20,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [625614] = 6,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13239), 1,
      anon_sym_AT,
    STATE(7746), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    ACTIONS(11278), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(11276), 18,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [625654] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6714), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6712), 21,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [625690] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6647), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6645), 21,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [625726] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6433), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6431), 20,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [625762] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6750), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6748), 21,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [625798] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6572), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6570), 21,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [625834] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6710), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6708), 20,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [625870] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6572), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      anon_sym_PIPE_RPAREN,
      aux_sym_string_token1,
    ACTIONS(6570), 20,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [625906] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6568), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      anon_sym_PIPE_RPAREN,
      aux_sym_string_token1,
    ACTIONS(6566), 20,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [625942] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6496), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6494), 21,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [625978] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6484), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6482), 20,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [626014] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6750), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6748), 20,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [626050] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6484), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6482), 21,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [626086] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6655), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6653), 21,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      anon_sym_u2988,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [626122] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6714), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6712), 20,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [626158] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6754), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6752), 20,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [626194] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6500), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      anon_sym_PIPE_RPAREN,
      aux_sym_string_token1,
    ACTIONS(6498), 20,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [626230] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6433), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6431), 20,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [626266] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6568), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6566), 21,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [626302] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6647), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6645), 21,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [626338] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6651), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6649), 20,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [626374] = 6,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13241), 1,
      anon_sym_AT,
    STATE(7746), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    ACTIONS(11284), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(11282), 18,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [626414] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6500), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6498), 21,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [626450] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6651), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6649), 20,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [626486] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6714), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6712), 20,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [626522] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6651), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6649), 20,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [626558] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6754), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6752), 20,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [626594] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6326), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      anon_sym_PIPE_RPAREN,
      aux_sym_string_token1,
    ACTIONS(6324), 20,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [626630] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6496), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6494), 20,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [626666] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6572), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6570), 20,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [626702] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6647), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6645), 20,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [626738] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6710), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6708), 21,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [626774] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6568), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6566), 20,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [626810] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6326), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6324), 21,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      anon_sym_u2988,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [626846] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6500), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6498), 20,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [626882] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6754), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6752), 21,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [626918] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6647), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6645), 20,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [626954] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6326), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6324), 20,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [626990] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6326), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6324), 20,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [627026] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6484), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6482), 20,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [627062] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6433), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6431), 21,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      anon_sym_u2988,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [627098] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6655), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6653), 20,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [627134] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6326), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6324), 21,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [627170] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6326), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6324), 21,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [627206] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6651), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6649), 20,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [627242] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6710), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6708), 20,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [627278] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6326), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6324), 20,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [627314] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6326), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6324), 20,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [627350] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6655), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6653), 20,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [627386] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6750), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6748), 20,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [627422] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6500), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6498), 20,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [627458] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6655), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6653), 21,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [627494] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6500), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6498), 21,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      anon_sym_u2988,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [627530] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6496), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6494), 21,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [627566] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6754), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6752), 20,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [627602] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6647), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6645), 20,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [627638] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6500), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6498), 20,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [627674] = 5,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13244), 1,
      anon_sym_AT,
    ACTIONS(6326), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6324), 20,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [627712] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6572), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6570), 20,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [627748] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6710), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6708), 21,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      anon_sym_u2988,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [627784] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6754), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6752), 20,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [627820] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6496), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6494), 20,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [627856] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6647), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6645), 20,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [627892] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6572), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6570), 20,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [627928] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6568), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6566), 20,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [627964] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6568), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6566), 20,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [628000] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6572), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6570), 20,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [628036] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6568), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6566), 21,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      anon_sym_u2988,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [628072] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6500), 5,
      sym__newline,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6498), 20,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [628108] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6647), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6645), 20,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [628144] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6651), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6649), 20,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [628180] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6496), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6494), 20,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [628216] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6655), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6653), 20,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [628252] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6484), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6482), 21,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      anon_sym_u2988,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [628288] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6572), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6570), 21,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      anon_sym_u2988,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [628324] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6754), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6752), 20,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [628360] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6655), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      anon_sym_PIPE_RPAREN,
      aux_sym_string_token1,
    ACTIONS(6653), 20,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [628396] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6433), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6431), 20,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [628432] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6714), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6712), 20,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [628468] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6750), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6748), 21,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      anon_sym_u2988,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [628504] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6714), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6712), 21,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      anon_sym_u2988,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [628540] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6433), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6431), 21,
      anon_sym_u2026,
      anon_sym_COLON,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [628576] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6500), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6498), 20,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [628612] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6754), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6752), 21,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      anon_sym_u2988,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [628648] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6496), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      anon_sym_PIPE_RPAREN,
      aux_sym_string_token1,
    ACTIONS(6494), 20,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [628684] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6568), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6566), 20,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [628720] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6651), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6649), 21,
      anon_sym_u2026,
      anon_sym_EQ,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      anon_sym_u2988,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [628756] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6710), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6708), 20,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [628791] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6433), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6431), 20,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [628826] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6647), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6645), 20,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [628861] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6484), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6482), 20,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [628896] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6750), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6748), 20,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [628931] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6714), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6712), 20,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [628966] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6754), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6752), 20,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [629001] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6651), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6649), 20,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [629036] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6572), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6570), 20,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [629071] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6568), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6566), 20,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [629106] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6500), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6498), 20,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [629141] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6326), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6324), 20,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [629176] = 5,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13246), 1,
      anon_sym_AT,
    ACTIONS(6326), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6324), 19,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [629213] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6655), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6653), 20,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [629248] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6496), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6494), 20,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [629283] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6655), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_AT,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6653), 18,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [629317] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6572), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6570), 19,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [629351] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6326), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_AT,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6324), 18,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [629385] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6484), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6482), 19,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [629419] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6496), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6494), 19,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [629453] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6655), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6653), 19,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [629487] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6500), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6498), 19,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [629521] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6568), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6566), 19,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [629555] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6710), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6708), 19,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [629589] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6651), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6649), 19,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [629623] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6754), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6752), 19,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [629657] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(12593), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_AT,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(12591), 18,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [629691] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6326), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6324), 19,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [629725] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6714), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6712), 19,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [629759] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6750), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6748), 19,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [629793] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6496), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_AT,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6494), 18,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [629827] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6647), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6645), 19,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [629861] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6433), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE_LBRACE,
      anon_sym_LPAREN_PIPE,
      aux_sym_string_token1,
    ACTIONS(6431), 19,
      anon_sym_u2026,
      anon_sym_record,
      anon_sym_LPAREN,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      aux_sym__qid_token1,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_Prop,
      anon_sym_quote,
      anon_sym_quoteTerm,
      anon_sym_quoteContext,
      anon_sym_unquote,
      anon_sym_u2987,
      aux_sym_integer_token1,
      anon_sym_Set,
      sym_PropN,
  [629895] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13250), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13248), 15,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
      anon_sym_in,
  [629925] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13254), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13252), 15,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
      anon_sym_in,
  [629955] = 17,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13256), 1,
      sym_id,
    ACTIONS(13259), 1,
      anon_sym_overlap,
    ACTIONS(13262), 1,
      anon_sym_instance,
    ACTIONS(13265), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(13268), 1,
      anon_sym_u2983,
    ACTIONS(13271), 1,
      anon_sym_LBRACE,
    ACTIONS(13274), 1,
      anon_sym_DOT,
    ACTIONS(13277), 1,
      anon_sym_DOT_DOT,
    ACTIONS(13280), 1,
      anon_sym_AT,
    ACTIONS(13283), 1,
      sym__dedent,
    STATE(7847), 1,
      aux_sym__signature_block_repeat1,
    STATE(12626), 1,
      sym__modal_arg_ids,
    STATE(12632), 1,
      sym_signature,
    STATE(8445), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8658), 4,
      sym__field_name,
      sym__maybe_dotted_id,
      aux_sym__arg_ids,
      sym__arg_id,
  [630011] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13287), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13285), 15,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
      anon_sym_in,
  [630041] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13291), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13289), 15,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
      anon_sym_in,
  [630071] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13295), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13293), 15,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
      anon_sym_in,
  [630101] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13299), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13297), 15,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
      anon_sym_in,
  [630131] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13303), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13301), 15,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
      anon_sym_in,
  [630161] = 17,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13305), 1,
      sym_id,
    ACTIONS(13307), 1,
      anon_sym_overlap,
    ACTIONS(13309), 1,
      anon_sym_instance,
    ACTIONS(13311), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(13313), 1,
      anon_sym_u2983,
    ACTIONS(13315), 1,
      anon_sym_LBRACE,
    ACTIONS(13317), 1,
      anon_sym_DOT,
    ACTIONS(13319), 1,
      anon_sym_DOT_DOT,
    ACTIONS(13321), 1,
      anon_sym_AT,
    ACTIONS(13323), 1,
      sym__dedent,
    STATE(7847), 1,
      aux_sym__signature_block_repeat1,
    STATE(12626), 1,
      sym__modal_arg_ids,
    STATE(12632), 1,
      sym_signature,
    STATE(8445), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8658), 4,
      sym__field_name,
      sym__maybe_dotted_id,
      aux_sym__arg_ids,
      sym__arg_id,
  [630217] = 6,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13331), 1,
      sym__newline,
    ACTIONS(13329), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13325), 5,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
    ACTIONS(13327), 10,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_in,
  [630251] = 6,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13335), 1,
      sym__newline,
    ACTIONS(13329), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13325), 5,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
    ACTIONS(13333), 10,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_in,
  [630285] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13339), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13337), 15,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
      anon_sym_in,
  [630315] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13343), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13341), 15,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
      anon_sym_in,
  [630345] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13291), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13289), 14,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
      anon_sym_in,
  [630374] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13287), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13285), 14,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
      anon_sym_in,
  [630403] = 6,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13335), 1,
      sym__newline,
    ACTIONS(13329), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13325), 5,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
    ACTIONS(13333), 9,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
  [630436] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13299), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13297), 14,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [630465] = 6,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13331), 1,
      sym__newline,
    ACTIONS(13329), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13325), 5,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
    ACTIONS(13327), 9,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
  [630498] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13299), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13297), 14,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
      anon_sym_in,
  [630527] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13295), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13293), 14,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [630556] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13250), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13248), 14,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [630585] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13299), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13297), 14,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
      anon_sym_in,
  [630614] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13250), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13248), 14,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
      anon_sym_in,
  [630643] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13303), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13301), 14,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
      anon_sym_in,
  [630672] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13343), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13341), 14,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
      anon_sym_in,
  [630701] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13303), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13301), 14,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [630730] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13250), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13248), 14,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
      anon_sym_in,
  [630759] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13291), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13289), 14,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [630788] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13291), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13289), 14,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
      anon_sym_in,
  [630817] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13254), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13252), 14,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
      anon_sym_in,
  [630846] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13295), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13293), 14,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
      anon_sym_in,
  [630875] = 6,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13331), 1,
      sym__newline,
    ACTIONS(13329), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13325), 5,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
    ACTIONS(13327), 9,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_in,
  [630908] = 16,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13305), 1,
      sym_id,
    ACTIONS(13307), 1,
      anon_sym_overlap,
    ACTIONS(13309), 1,
      anon_sym_instance,
    ACTIONS(13311), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(13313), 1,
      anon_sym_u2983,
    ACTIONS(13315), 1,
      anon_sym_LBRACE,
    ACTIONS(13317), 1,
      anon_sym_DOT,
    ACTIONS(13319), 1,
      anon_sym_DOT_DOT,
    ACTIONS(13321), 1,
      anon_sym_AT,
    STATE(7853), 1,
      aux_sym__signature_block_repeat1,
    STATE(12626), 1,
      sym__modal_arg_ids,
    STATE(12632), 1,
      sym_signature,
    STATE(8445), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8658), 4,
      sym__field_name,
      sym__maybe_dotted_id,
      aux_sym__arg_ids,
      sym__arg_id,
  [630961] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13339), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13337), 14,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
      anon_sym_in,
  [630990] = 6,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13335), 1,
      sym__newline,
    ACTIONS(13329), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13325), 5,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
    ACTIONS(13333), 9,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_in,
  [631023] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13343), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13341), 14,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [631052] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13303), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13301), 14,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
      anon_sym_in,
  [631081] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13343), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13341), 14,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
      anon_sym_in,
  [631110] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13254), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13252), 14,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [631139] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13295), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13293), 14,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
      anon_sym_in,
  [631168] = 6,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13335), 1,
      sym__newline,
    ACTIONS(13329), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13325), 5,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
    ACTIONS(13333), 9,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_in,
  [631201] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13287), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13285), 14,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
      anon_sym_in,
  [631230] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13254), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13252), 14,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
      anon_sym_in,
  [631259] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13339), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13337), 14,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
      anon_sym_in,
  [631288] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13287), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13285), 14,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [631317] = 6,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13331), 1,
      sym__newline,
    ACTIONS(13329), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13325), 5,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
    ACTIONS(13327), 9,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_in,
  [631350] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13339), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13337), 14,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [631379] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13254), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13252), 13,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
      anon_sym_in,
  [631407] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13339), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13337), 13,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
      anon_sym_in,
  [631435] = 6,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13335), 1,
      sym__newline,
    ACTIONS(13329), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13325), 5,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
    ACTIONS(13333), 8,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
  [631467] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13254), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13252), 13,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [631495] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13291), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13289), 13,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [631523] = 6,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13331), 1,
      sym__newline,
    ACTIONS(13329), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13325), 5,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
    ACTIONS(13327), 8,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
  [631555] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13343), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13341), 13,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [631583] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13343), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13341), 13,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
      anon_sym_in,
  [631611] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13250), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13248), 13,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [631639] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13295), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13293), 13,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [631667] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13343), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13341), 13,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [631695] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13303), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13301), 13,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [631723] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13250), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13248), 13,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [631751] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13295), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13293), 13,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [631779] = 6,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13331), 1,
      sym__newline,
    ACTIONS(13329), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13325), 5,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
    ACTIONS(13327), 8,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_in,
  [631811] = 6,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13335), 1,
      sym__newline,
    ACTIONS(13329), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13325), 5,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
    ACTIONS(13333), 8,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_in,
  [631843] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13299), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13297), 13,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
      anon_sym_in,
  [631871] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13291), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13289), 13,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [631899] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13339), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13337), 13,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [631927] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13254), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13252), 13,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [631955] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13303), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13301), 13,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [631983] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13287), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13285), 13,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
      anon_sym_in,
  [632011] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13287), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13285), 13,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [632039] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13299), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13297), 13,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [632067] = 6,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13335), 1,
      sym__newline,
    ACTIONS(13329), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13325), 5,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
    ACTIONS(13333), 8,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
  [632099] = 6,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13331), 1,
      sym__newline,
    ACTIONS(13329), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13325), 5,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
    ACTIONS(13327), 8,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
  [632131] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13299), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13297), 13,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
      anon_sym_in,
  [632159] = 6,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13335), 1,
      sym__newline,
    ACTIONS(13329), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13325), 5,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
    ACTIONS(13333), 8,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_in,
  [632191] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13339), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13337), 13,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [632219] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13291), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13289), 13,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
      anon_sym_in,
  [632247] = 6,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13331), 1,
      sym__newline,
    ACTIONS(13329), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13325), 5,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
    ACTIONS(13327), 8,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_in,
  [632279] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13339), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13337), 13,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
      anon_sym_in,
  [632307] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13295), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13293), 13,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
      anon_sym_in,
  [632335] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13250), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13248), 13,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
      anon_sym_in,
  [632363] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13303), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13301), 13,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
      anon_sym_in,
  [632391] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13299), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13297), 13,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [632419] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13343), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13341), 13,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
      anon_sym_in,
  [632447] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13303), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13301), 13,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
      anon_sym_in,
  [632475] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13254), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13252), 13,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
      anon_sym_in,
  [632503] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13250), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13248), 13,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
      anon_sym_in,
  [632531] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13295), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13293), 13,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
      anon_sym_in,
  [632559] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13291), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13289), 13,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
      anon_sym_in,
  [632587] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13287), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13285), 13,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [632615] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13287), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13285), 13,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
      anon_sym_in,
  [632643] = 14,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13347), 1,
      anon_sym_COLON,
    ACTIONS(13349), 1,
      anon_sym_where,
    ACTIONS(13351), 1,
      anon_sym_LPAREN,
    ACTIONS(13353), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(13355), 1,
      anon_sym_u2983,
    ACTIONS(13357), 1,
      anon_sym_LBRACE,
    ACTIONS(13359), 1,
      anon_sym_DOT,
    ACTIONS(13361), 1,
      anon_sym_DOT_DOT,
    STATE(8871), 1,
      sym_bid,
    STATE(10076), 1,
      sym_record_declarations_block,
    ACTIONS(13345), 2,
      anon_sym__,
      sym_id,
    STATE(8070), 4,
      sym_typed_binding,
      aux_sym__typed_untyped_bindings,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [632690] = 13,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13367), 1,
      anon_sym_LPAREN,
    ACTIONS(13369), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(13371), 1,
      anon_sym_u2983,
    ACTIONS(13373), 1,
      anon_sym_LBRACE,
    ACTIONS(13375), 1,
      anon_sym_DOT,
    ACTIONS(13377), 1,
      anon_sym_DOT_DOT,
    STATE(1744), 1,
      sym__ARROW,
    STATE(8750), 1,
      sym_bid,
    ACTIONS(13363), 2,
      anon_sym__,
      sym_id,
    ACTIONS(13365), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(8063), 4,
      sym_typed_binding,
      aux_sym__typed_untyped_bindings,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [632735] = 13,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13367), 1,
      anon_sym_LPAREN,
    ACTIONS(13369), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(13371), 1,
      anon_sym_u2983,
    ACTIONS(13373), 1,
      anon_sym_LBRACE,
    ACTIONS(13375), 1,
      anon_sym_DOT,
    ACTIONS(13377), 1,
      anon_sym_DOT_DOT,
    STATE(1966), 1,
      sym__ARROW,
    STATE(8750), 1,
      sym_bid,
    ACTIONS(13363), 2,
      anon_sym__,
      sym_id,
    ACTIONS(13379), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(8063), 4,
      sym_typed_binding,
      aux_sym__typed_untyped_bindings,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [632780] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13299), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13297), 12,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
      anon_sym_in,
  [632807] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13295), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13293), 12,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [632834] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13291), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13289), 12,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
      anon_sym_in,
  [632861] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13343), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13341), 12,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [632888] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13254), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13252), 12,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [632915] = 13,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13367), 1,
      anon_sym_LPAREN,
    ACTIONS(13369), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(13371), 1,
      anon_sym_u2983,
    ACTIONS(13373), 1,
      anon_sym_LBRACE,
    ACTIONS(13375), 1,
      anon_sym_DOT,
    ACTIONS(13377), 1,
      anon_sym_DOT_DOT,
    STATE(1821), 1,
      sym__ARROW,
    STATE(8750), 1,
      sym_bid,
    ACTIONS(13363), 2,
      anon_sym__,
      sym_id,
    ACTIONS(13381), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(8063), 4,
      sym_typed_binding,
      aux_sym__typed_untyped_bindings,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [632960] = 13,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13367), 1,
      anon_sym_LPAREN,
    ACTIONS(13369), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(13371), 1,
      anon_sym_u2983,
    ACTIONS(13373), 1,
      anon_sym_LBRACE,
    ACTIONS(13375), 1,
      anon_sym_DOT,
    ACTIONS(13377), 1,
      anon_sym_DOT_DOT,
    STATE(1695), 1,
      sym__ARROW,
    STATE(8750), 1,
      sym_bid,
    ACTIONS(13363), 2,
      anon_sym__,
      sym_id,
    ACTIONS(13383), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(8063), 4,
      sym_typed_binding,
      aux_sym__typed_untyped_bindings,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [633005] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13287), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13285), 12,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [633032] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13254), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13252), 12,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
      anon_sym_in,
  [633059] = 6,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13335), 1,
      sym__newline,
    ACTIONS(13329), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13325), 5,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
    ACTIONS(13333), 7,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
  [633090] = 14,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13349), 1,
      anon_sym_where,
    ACTIONS(13351), 1,
      anon_sym_LPAREN,
    ACTIONS(13353), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(13355), 1,
      anon_sym_u2983,
    ACTIONS(13357), 1,
      anon_sym_LBRACE,
    ACTIONS(13359), 1,
      anon_sym_DOT,
    ACTIONS(13361), 1,
      anon_sym_DOT_DOT,
    ACTIONS(13385), 1,
      anon_sym_COLON,
    STATE(8871), 1,
      sym_bid,
    STATE(10076), 1,
      sym_record_declarations_block,
    ACTIONS(13345), 2,
      anon_sym__,
      sym_id,
    STATE(8070), 4,
      sym_typed_binding,
      aux_sym__typed_untyped_bindings,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [633137] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13343), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13341), 12,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
      anon_sym_in,
  [633164] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13295), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13293), 12,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
      anon_sym_in,
  [633191] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13250), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13248), 12,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
      anon_sym_in,
  [633218] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13303), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13301), 12,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
      anon_sym_in,
  [633245] = 13,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13367), 1,
      anon_sym_LPAREN,
    ACTIONS(13369), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(13371), 1,
      anon_sym_u2983,
    ACTIONS(13373), 1,
      anon_sym_LBRACE,
    ACTIONS(13375), 1,
      anon_sym_DOT,
    ACTIONS(13377), 1,
      anon_sym_DOT_DOT,
    STATE(2603), 1,
      sym__ARROW,
    STATE(8750), 1,
      sym_bid,
    ACTIONS(13363), 2,
      anon_sym__,
      sym_id,
    ACTIONS(13387), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(8063), 4,
      sym_typed_binding,
      aux_sym__typed_untyped_bindings,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [633290] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13339), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13337), 12,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
      anon_sym_in,
  [633317] = 13,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13367), 1,
      anon_sym_LPAREN,
    ACTIONS(13369), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(13371), 1,
      anon_sym_u2983,
    ACTIONS(13373), 1,
      anon_sym_LBRACE,
    ACTIONS(13375), 1,
      anon_sym_DOT,
    ACTIONS(13377), 1,
      anon_sym_DOT_DOT,
    STATE(2455), 1,
      sym__ARROW,
    STATE(8750), 1,
      sym_bid,
    ACTIONS(13363), 2,
      anon_sym__,
      sym_id,
    ACTIONS(13389), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(8063), 4,
      sym_typed_binding,
      aux_sym__typed_untyped_bindings,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [633362] = 13,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13367), 1,
      anon_sym_LPAREN,
    ACTIONS(13369), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(13371), 1,
      anon_sym_u2983,
    ACTIONS(13373), 1,
      anon_sym_LBRACE,
    ACTIONS(13375), 1,
      anon_sym_DOT,
    ACTIONS(13377), 1,
      anon_sym_DOT_DOT,
    STATE(2532), 1,
      sym__ARROW,
    STATE(8750), 1,
      sym_bid,
    ACTIONS(13363), 2,
      anon_sym__,
      sym_id,
    ACTIONS(13391), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(8063), 4,
      sym_typed_binding,
      aux_sym__typed_untyped_bindings,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [633407] = 13,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13367), 1,
      anon_sym_LPAREN,
    ACTIONS(13369), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(13371), 1,
      anon_sym_u2983,
    ACTIONS(13373), 1,
      anon_sym_LBRACE,
    ACTIONS(13375), 1,
      anon_sym_DOT,
    ACTIONS(13377), 1,
      anon_sym_DOT_DOT,
    STATE(1782), 1,
      sym__ARROW,
    STATE(8750), 1,
      sym_bid,
    ACTIONS(13363), 2,
      anon_sym__,
      sym_id,
    ACTIONS(13393), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(8063), 4,
      sym_typed_binding,
      aux_sym__typed_untyped_bindings,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [633452] = 13,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13367), 1,
      anon_sym_LPAREN,
    ACTIONS(13369), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(13371), 1,
      anon_sym_u2983,
    ACTIONS(13373), 1,
      anon_sym_LBRACE,
    ACTIONS(13375), 1,
      anon_sym_DOT,
    ACTIONS(13377), 1,
      anon_sym_DOT_DOT,
    STATE(1575), 1,
      sym__ARROW,
    STATE(8750), 1,
      sym_bid,
    ACTIONS(13363), 2,
      anon_sym__,
      sym_id,
    ACTIONS(13395), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(8063), 4,
      sym_typed_binding,
      aux_sym__typed_untyped_bindings,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [633497] = 13,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13367), 1,
      anon_sym_LPAREN,
    ACTIONS(13369), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(13371), 1,
      anon_sym_u2983,
    ACTIONS(13373), 1,
      anon_sym_LBRACE,
    ACTIONS(13375), 1,
      anon_sym_DOT,
    ACTIONS(13377), 1,
      anon_sym_DOT_DOT,
    STATE(1941), 1,
      sym__ARROW,
    STATE(8750), 1,
      sym_bid,
    ACTIONS(13363), 2,
      anon_sym__,
      sym_id,
    ACTIONS(13397), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(8063), 4,
      sym_typed_binding,
      aux_sym__typed_untyped_bindings,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [633542] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13291), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13289), 12,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
      anon_sym_in,
  [633569] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13287), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13285), 12,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
      anon_sym_in,
  [633596] = 13,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13367), 1,
      anon_sym_LPAREN,
    ACTIONS(13369), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(13371), 1,
      anon_sym_u2983,
    ACTIONS(13373), 1,
      anon_sym_LBRACE,
    ACTIONS(13375), 1,
      anon_sym_DOT,
    ACTIONS(13377), 1,
      anon_sym_DOT_DOT,
    STATE(2256), 1,
      sym__ARROW,
    STATE(8750), 1,
      sym_bid,
    ACTIONS(13363), 2,
      anon_sym__,
      sym_id,
    ACTIONS(13399), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(8063), 4,
      sym_typed_binding,
      aux_sym__typed_untyped_bindings,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [633641] = 13,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13367), 1,
      anon_sym_LPAREN,
    ACTIONS(13369), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(13371), 1,
      anon_sym_u2983,
    ACTIONS(13373), 1,
      anon_sym_LBRACE,
    ACTIONS(13375), 1,
      anon_sym_DOT,
    ACTIONS(13377), 1,
      anon_sym_DOT_DOT,
    STATE(2558), 1,
      sym__ARROW,
    STATE(8750), 1,
      sym_bid,
    ACTIONS(13363), 2,
      anon_sym__,
      sym_id,
    ACTIONS(13401), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(8063), 4,
      sym_typed_binding,
      aux_sym__typed_untyped_bindings,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [633686] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13287), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13285), 12,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [633713] = 13,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13367), 1,
      anon_sym_LPAREN,
    ACTIONS(13369), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(13371), 1,
      anon_sym_u2983,
    ACTIONS(13373), 1,
      anon_sym_LBRACE,
    ACTIONS(13375), 1,
      anon_sym_DOT,
    ACTIONS(13377), 1,
      anon_sym_DOT_DOT,
    STATE(1939), 1,
      sym__ARROW,
    STATE(8750), 1,
      sym_bid,
    ACTIONS(13363), 2,
      anon_sym__,
      sym_id,
    ACTIONS(13403), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(8063), 4,
      sym_typed_binding,
      aux_sym__typed_untyped_bindings,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [633758] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13291), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13289), 12,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [633785] = 13,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13367), 1,
      anon_sym_LPAREN,
    ACTIONS(13369), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(13371), 1,
      anon_sym_u2983,
    ACTIONS(13373), 1,
      anon_sym_LBRACE,
    ACTIONS(13375), 1,
      anon_sym_DOT,
    ACTIONS(13377), 1,
      anon_sym_DOT_DOT,
    STATE(1724), 1,
      sym__ARROW,
    STATE(8750), 1,
      sym_bid,
    ACTIONS(13363), 2,
      anon_sym__,
      sym_id,
    ACTIONS(13405), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(8063), 4,
      sym_typed_binding,
      aux_sym__typed_untyped_bindings,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [633830] = 14,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13349), 1,
      anon_sym_where,
    ACTIONS(13351), 1,
      anon_sym_LPAREN,
    ACTIONS(13353), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(13355), 1,
      anon_sym_u2983,
    ACTIONS(13359), 1,
      anon_sym_DOT,
    ACTIONS(13361), 1,
      anon_sym_DOT_DOT,
    ACTIONS(13407), 1,
      anon_sym_COLON,
    ACTIONS(13409), 1,
      anon_sym_LBRACE,
    STATE(8871), 1,
      sym_bid,
    STATE(9716), 1,
      sym_record_declarations_block,
    ACTIONS(13345), 2,
      anon_sym__,
      sym_id,
    STATE(7949), 4,
      sym_typed_binding,
      aux_sym__typed_untyped_bindings,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [633877] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13299), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13297), 12,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
      anon_sym_in,
  [633904] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13299), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13297), 12,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [633931] = 13,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13367), 1,
      anon_sym_LPAREN,
    ACTIONS(13369), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(13371), 1,
      anon_sym_u2983,
    ACTIONS(13373), 1,
      anon_sym_LBRACE,
    ACTIONS(13375), 1,
      anon_sym_DOT,
    ACTIONS(13377), 1,
      anon_sym_DOT_DOT,
    STATE(2454), 1,
      sym__ARROW,
    STATE(8750), 1,
      sym_bid,
    ACTIONS(13363), 2,
      anon_sym__,
      sym_id,
    ACTIONS(13411), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(8063), 4,
      sym_typed_binding,
      aux_sym__typed_untyped_bindings,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [633976] = 13,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13367), 1,
      anon_sym_LPAREN,
    ACTIONS(13369), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(13371), 1,
      anon_sym_u2983,
    ACTIONS(13373), 1,
      anon_sym_LBRACE,
    ACTIONS(13375), 1,
      anon_sym_DOT,
    ACTIONS(13377), 1,
      anon_sym_DOT_DOT,
    STATE(1491), 1,
      sym__ARROW,
    STATE(8750), 1,
      sym_bid,
    ACTIONS(13363), 2,
      anon_sym__,
      sym_id,
    ACTIONS(13413), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(8063), 4,
      sym_typed_binding,
      aux_sym__typed_untyped_bindings,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [634021] = 13,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13367), 1,
      anon_sym_LPAREN,
    ACTIONS(13369), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(13371), 1,
      anon_sym_u2983,
    ACTIONS(13373), 1,
      anon_sym_LBRACE,
    ACTIONS(13375), 1,
      anon_sym_DOT,
    ACTIONS(13377), 1,
      anon_sym_DOT_DOT,
    STATE(1472), 1,
      sym__ARROW,
    STATE(8750), 1,
      sym_bid,
    ACTIONS(13363), 2,
      anon_sym__,
      sym_id,
    ACTIONS(13415), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(8063), 4,
      sym_typed_binding,
      aux_sym__typed_untyped_bindings,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [634066] = 13,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13367), 1,
      anon_sym_LPAREN,
    ACTIONS(13369), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(13371), 1,
      anon_sym_u2983,
    ACTIONS(13373), 1,
      anon_sym_LBRACE,
    ACTIONS(13375), 1,
      anon_sym_DOT,
    ACTIONS(13377), 1,
      anon_sym_DOT_DOT,
    STATE(1645), 1,
      sym__ARROW,
    STATE(8750), 1,
      sym_bid,
    ACTIONS(13363), 2,
      anon_sym__,
      sym_id,
    ACTIONS(13417), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(8063), 4,
      sym_typed_binding,
      aux_sym__typed_untyped_bindings,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [634111] = 13,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13367), 1,
      anon_sym_LPAREN,
    ACTIONS(13369), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(13371), 1,
      anon_sym_u2983,
    ACTIONS(13373), 1,
      anon_sym_LBRACE,
    ACTIONS(13375), 1,
      anon_sym_DOT,
    ACTIONS(13377), 1,
      anon_sym_DOT_DOT,
    STATE(1677), 1,
      sym__ARROW,
    STATE(8750), 1,
      sym_bid,
    ACTIONS(13363), 2,
      anon_sym__,
      sym_id,
    ACTIONS(13419), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(8063), 4,
      sym_typed_binding,
      aux_sym__typed_untyped_bindings,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [634156] = 13,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13367), 1,
      anon_sym_LPAREN,
    ACTIONS(13369), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(13371), 1,
      anon_sym_u2983,
    ACTIONS(13373), 1,
      anon_sym_LBRACE,
    ACTIONS(13375), 1,
      anon_sym_DOT,
    ACTIONS(13377), 1,
      anon_sym_DOT_DOT,
    STATE(2462), 1,
      sym__ARROW,
    STATE(8750), 1,
      sym_bid,
    ACTIONS(13363), 2,
      anon_sym__,
      sym_id,
    ACTIONS(13421), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(8063), 4,
      sym_typed_binding,
      aux_sym__typed_untyped_bindings,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [634201] = 13,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13367), 1,
      anon_sym_LPAREN,
    ACTIONS(13369), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(13371), 1,
      anon_sym_u2983,
    ACTIONS(13373), 1,
      anon_sym_LBRACE,
    ACTIONS(13375), 1,
      anon_sym_DOT,
    ACTIONS(13377), 1,
      anon_sym_DOT_DOT,
    STATE(2371), 1,
      sym__ARROW,
    STATE(8750), 1,
      sym_bid,
    ACTIONS(13363), 2,
      anon_sym__,
      sym_id,
    ACTIONS(13423), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(8063), 4,
      sym_typed_binding,
      aux_sym__typed_untyped_bindings,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [634246] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13303), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13301), 12,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
      anon_sym_in,
  [634273] = 13,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13367), 1,
      anon_sym_LPAREN,
    ACTIONS(13369), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(13371), 1,
      anon_sym_u2983,
    ACTIONS(13373), 1,
      anon_sym_LBRACE,
    ACTIONS(13375), 1,
      anon_sym_DOT,
    ACTIONS(13377), 1,
      anon_sym_DOT_DOT,
    STATE(2652), 1,
      sym__ARROW,
    STATE(8750), 1,
      sym_bid,
    ACTIONS(13363), 2,
      anon_sym__,
      sym_id,
    ACTIONS(13425), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(8063), 4,
      sym_typed_binding,
      aux_sym__typed_untyped_bindings,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [634318] = 13,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13367), 1,
      anon_sym_LPAREN,
    ACTIONS(13369), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(13371), 1,
      anon_sym_u2983,
    ACTIONS(13373), 1,
      anon_sym_LBRACE,
    ACTIONS(13375), 1,
      anon_sym_DOT,
    ACTIONS(13377), 1,
      anon_sym_DOT_DOT,
    STATE(2128), 1,
      sym__ARROW,
    STATE(8750), 1,
      sym_bid,
    ACTIONS(13363), 2,
      anon_sym__,
      sym_id,
    ACTIONS(13427), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(8063), 4,
      sym_typed_binding,
      aux_sym__typed_untyped_bindings,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [634363] = 13,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13367), 1,
      anon_sym_LPAREN,
    ACTIONS(13369), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(13371), 1,
      anon_sym_u2983,
    ACTIONS(13373), 1,
      anon_sym_LBRACE,
    ACTIONS(13375), 1,
      anon_sym_DOT,
    ACTIONS(13377), 1,
      anon_sym_DOT_DOT,
    STATE(1523), 1,
      sym__ARROW,
    STATE(8750), 1,
      sym_bid,
    ACTIONS(13363), 2,
      anon_sym__,
      sym_id,
    ACTIONS(13429), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(8063), 4,
      sym_typed_binding,
      aux_sym__typed_untyped_bindings,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [634408] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13250), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13248), 12,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [634435] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13339), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13337), 12,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [634462] = 13,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13367), 1,
      anon_sym_LPAREN,
    ACTIONS(13369), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(13371), 1,
      anon_sym_u2983,
    ACTIONS(13373), 1,
      anon_sym_LBRACE,
    ACTIONS(13375), 1,
      anon_sym_DOT,
    ACTIONS(13377), 1,
      anon_sym_DOT_DOT,
    STATE(2090), 1,
      sym__ARROW,
    STATE(8750), 1,
      sym_bid,
    ACTIONS(13363), 2,
      anon_sym__,
      sym_id,
    ACTIONS(13431), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(8063), 4,
      sym_typed_binding,
      aux_sym__typed_untyped_bindings,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [634507] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13250), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13248), 12,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
      anon_sym_in,
  [634534] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13299), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13297), 12,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [634561] = 6,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13335), 1,
      sym__newline,
    ACTIONS(13329), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13325), 5,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
    ACTIONS(13333), 7,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_in,
  [634592] = 6,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13331), 1,
      sym__newline,
    ACTIONS(13329), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13325), 5,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
    ACTIONS(13327), 7,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_in,
  [634623] = 13,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13367), 1,
      anon_sym_LPAREN,
    ACTIONS(13369), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(13371), 1,
      anon_sym_u2983,
    ACTIONS(13373), 1,
      anon_sym_LBRACE,
    ACTIONS(13375), 1,
      anon_sym_DOT,
    ACTIONS(13377), 1,
      anon_sym_DOT_DOT,
    STATE(1661), 1,
      sym__ARROW,
    STATE(8750), 1,
      sym_bid,
    ACTIONS(13363), 2,
      anon_sym__,
      sym_id,
    ACTIONS(13433), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(8063), 4,
      sym_typed_binding,
      aux_sym__typed_untyped_bindings,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [634668] = 6,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13331), 1,
      sym__newline,
    ACTIONS(13329), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13325), 5,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
    ACTIONS(13327), 7,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_in,
  [634699] = 13,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13367), 1,
      anon_sym_LPAREN,
    ACTIONS(13369), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(13371), 1,
      anon_sym_u2983,
    ACTIONS(13373), 1,
      anon_sym_LBRACE,
    ACTIONS(13375), 1,
      anon_sym_DOT,
    ACTIONS(13377), 1,
      anon_sym_DOT_DOT,
    STATE(2311), 1,
      sym__ARROW,
    STATE(8750), 1,
      sym_bid,
    ACTIONS(13363), 2,
      anon_sym__,
      sym_id,
    ACTIONS(13435), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(8063), 4,
      sym_typed_binding,
      aux_sym__typed_untyped_bindings,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [634744] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13303), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13301), 12,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [634771] = 13,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13367), 1,
      anon_sym_LPAREN,
    ACTIONS(13369), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(13371), 1,
      anon_sym_u2983,
    ACTIONS(13373), 1,
      anon_sym_LBRACE,
    ACTIONS(13375), 1,
      anon_sym_DOT,
    ACTIONS(13377), 1,
      anon_sym_DOT_DOT,
    STATE(1542), 1,
      sym__ARROW,
    STATE(8750), 1,
      sym_bid,
    ACTIONS(13363), 2,
      anon_sym__,
      sym_id,
    ACTIONS(13437), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(8063), 4,
      sym_typed_binding,
      aux_sym__typed_untyped_bindings,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [634816] = 13,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13367), 1,
      anon_sym_LPAREN,
    ACTIONS(13369), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(13371), 1,
      anon_sym_u2983,
    ACTIONS(13373), 1,
      anon_sym_LBRACE,
    ACTIONS(13375), 1,
      anon_sym_DOT,
    ACTIONS(13377), 1,
      anon_sym_DOT_DOT,
    STATE(2165), 1,
      sym__ARROW,
    STATE(8750), 1,
      sym_bid,
    ACTIONS(13363), 2,
      anon_sym__,
      sym_id,
    ACTIONS(13439), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(8063), 4,
      sym_typed_binding,
      aux_sym__typed_untyped_bindings,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [634861] = 6,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13335), 1,
      sym__newline,
    ACTIONS(13329), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13325), 5,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
    ACTIONS(13333), 7,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_in,
  [634892] = 13,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13367), 1,
      anon_sym_LPAREN,
    ACTIONS(13369), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(13371), 1,
      anon_sym_u2983,
    ACTIONS(13373), 1,
      anon_sym_LBRACE,
    ACTIONS(13375), 1,
      anon_sym_DOT,
    ACTIONS(13377), 1,
      anon_sym_DOT_DOT,
    STATE(1601), 1,
      sym__ARROW,
    STATE(8750), 1,
      sym_bid,
    ACTIONS(13363), 2,
      anon_sym__,
      sym_id,
    ACTIONS(13441), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(8063), 4,
      sym_typed_binding,
      aux_sym__typed_untyped_bindings,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [634937] = 13,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13367), 1,
      anon_sym_LPAREN,
    ACTIONS(13369), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(13371), 1,
      anon_sym_u2983,
    ACTIONS(13373), 1,
      anon_sym_LBRACE,
    ACTIONS(13375), 1,
      anon_sym_DOT,
    ACTIONS(13377), 1,
      anon_sym_DOT_DOT,
    STATE(1883), 1,
      sym__ARROW,
    STATE(8750), 1,
      sym_bid,
    ACTIONS(13363), 2,
      anon_sym__,
      sym_id,
    ACTIONS(13443), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(8063), 4,
      sym_typed_binding,
      aux_sym__typed_untyped_bindings,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [634982] = 13,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13367), 1,
      anon_sym_LPAREN,
    ACTIONS(13369), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(13371), 1,
      anon_sym_u2983,
    ACTIONS(13373), 1,
      anon_sym_LBRACE,
    ACTIONS(13375), 1,
      anon_sym_DOT,
    ACTIONS(13377), 1,
      anon_sym_DOT_DOT,
    STATE(1950), 1,
      sym__ARROW,
    STATE(8750), 1,
      sym_bid,
    ACTIONS(13363), 2,
      anon_sym__,
      sym_id,
    ACTIONS(13445), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(8063), 4,
      sym_typed_binding,
      aux_sym__typed_untyped_bindings,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [635027] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13291), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13289), 12,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [635054] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13254), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13252), 12,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [635081] = 13,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13367), 1,
      anon_sym_LPAREN,
    ACTIONS(13369), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(13371), 1,
      anon_sym_u2983,
    ACTIONS(13373), 1,
      anon_sym_LBRACE,
    ACTIONS(13375), 1,
      anon_sym_DOT,
    ACTIONS(13377), 1,
      anon_sym_DOT_DOT,
    STATE(2458), 1,
      sym__ARROW,
    STATE(8750), 1,
      sym_bid,
    ACTIONS(13363), 2,
      anon_sym__,
      sym_id,
    ACTIONS(13447), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(8063), 4,
      sym_typed_binding,
      aux_sym__typed_untyped_bindings,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [635126] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13303), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13301), 12,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [635153] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13254), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13252), 12,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
      anon_sym_in,
  [635180] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13343), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13341), 12,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [635207] = 13,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13367), 1,
      anon_sym_LPAREN,
    ACTIONS(13369), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(13371), 1,
      anon_sym_u2983,
    ACTIONS(13373), 1,
      anon_sym_LBRACE,
    ACTIONS(13375), 1,
      anon_sym_DOT,
    ACTIONS(13377), 1,
      anon_sym_DOT_DOT,
    STATE(2309), 1,
      sym__ARROW,
    STATE(8750), 1,
      sym_bid,
    ACTIONS(13363), 2,
      anon_sym__,
      sym_id,
    ACTIONS(13449), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(8063), 4,
      sym_typed_binding,
      aux_sym__typed_untyped_bindings,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [635252] = 13,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13367), 1,
      anon_sym_LPAREN,
    ACTIONS(13369), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(13371), 1,
      anon_sym_u2983,
    ACTIONS(13373), 1,
      anon_sym_LBRACE,
    ACTIONS(13375), 1,
      anon_sym_DOT,
    ACTIONS(13377), 1,
      anon_sym_DOT_DOT,
    STATE(2188), 1,
      sym__ARROW,
    STATE(8750), 1,
      sym_bid,
    ACTIONS(13363), 2,
      anon_sym__,
      sym_id,
    ACTIONS(13451), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(8063), 4,
      sym_typed_binding,
      aux_sym__typed_untyped_bindings,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [635297] = 13,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13367), 1,
      anon_sym_LPAREN,
    ACTIONS(13369), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(13371), 1,
      anon_sym_u2983,
    ACTIONS(13373), 1,
      anon_sym_LBRACE,
    ACTIONS(13375), 1,
      anon_sym_DOT,
    ACTIONS(13377), 1,
      anon_sym_DOT_DOT,
    STATE(2059), 1,
      sym__ARROW,
    STATE(8750), 1,
      sym_bid,
    ACTIONS(13363), 2,
      anon_sym__,
      sym_id,
    ACTIONS(13453), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(8063), 4,
      sym_typed_binding,
      aux_sym__typed_untyped_bindings,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [635342] = 14,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13349), 1,
      anon_sym_where,
    ACTIONS(13351), 1,
      anon_sym_LPAREN,
    ACTIONS(13353), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(13355), 1,
      anon_sym_u2983,
    ACTIONS(13359), 1,
      anon_sym_DOT,
    ACTIONS(13361), 1,
      anon_sym_DOT_DOT,
    ACTIONS(13455), 1,
      anon_sym_COLON,
    ACTIONS(13457), 1,
      anon_sym_LBRACE,
    STATE(8871), 1,
      sym_bid,
    STATE(9716), 1,
      sym_record_declarations_block,
    ACTIONS(13345), 2,
      anon_sym__,
      sym_id,
    STATE(7936), 4,
      sym_typed_binding,
      aux_sym__typed_untyped_bindings,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [635389] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13339), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13337), 12,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [635416] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13343), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13341), 12,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
      anon_sym_in,
  [635443] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13250), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13248), 12,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [635470] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13295), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13293), 12,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
      anon_sym_in,
  [635497] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13295), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13293), 12,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [635524] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13339), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13337), 12,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
      anon_sym_in,
  [635551] = 13,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13367), 1,
      anon_sym_LPAREN,
    ACTIONS(13369), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(13371), 1,
      anon_sym_u2983,
    ACTIONS(13373), 1,
      anon_sym_LBRACE,
    ACTIONS(13375), 1,
      anon_sym_DOT,
    ACTIONS(13377), 1,
      anon_sym_DOT_DOT,
    STATE(1738), 1,
      sym__ARROW,
    STATE(8750), 1,
      sym_bid,
    ACTIONS(13363), 2,
      anon_sym__,
      sym_id,
    ACTIONS(13459), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(8063), 4,
      sym_typed_binding,
      aux_sym__typed_untyped_bindings,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [635596] = 13,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13367), 1,
      anon_sym_LPAREN,
    ACTIONS(13369), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(13371), 1,
      anon_sym_u2983,
    ACTIONS(13373), 1,
      anon_sym_LBRACE,
    ACTIONS(13375), 1,
      anon_sym_DOT,
    ACTIONS(13377), 1,
      anon_sym_DOT_DOT,
    STATE(2020), 1,
      sym__ARROW,
    STATE(8750), 1,
      sym_bid,
    ACTIONS(13363), 2,
      anon_sym__,
      sym_id,
    ACTIONS(13461), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(8063), 4,
      sym_typed_binding,
      aux_sym__typed_untyped_bindings,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [635641] = 13,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13367), 1,
      anon_sym_LPAREN,
    ACTIONS(13369), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(13371), 1,
      anon_sym_u2983,
    ACTIONS(13373), 1,
      anon_sym_LBRACE,
    ACTIONS(13375), 1,
      anon_sym_DOT,
    ACTIONS(13377), 1,
      anon_sym_DOT_DOT,
    STATE(1462), 1,
      sym__ARROW,
    STATE(8750), 1,
      sym_bid,
    ACTIONS(13363), 2,
      anon_sym__,
      sym_id,
    ACTIONS(13463), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(8063), 4,
      sym_typed_binding,
      aux_sym__typed_untyped_bindings,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [635686] = 6,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13331), 1,
      sym__newline,
    ACTIONS(13329), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13325), 5,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
    ACTIONS(13327), 7,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
  [635717] = 13,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13367), 1,
      anon_sym_LPAREN,
    ACTIONS(13369), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(13371), 1,
      anon_sym_u2983,
    ACTIONS(13373), 1,
      anon_sym_LBRACE,
    ACTIONS(13375), 1,
      anon_sym_DOT,
    ACTIONS(13377), 1,
      anon_sym_DOT_DOT,
    STATE(1396), 1,
      sym__ARROW,
    STATE(8750), 1,
      sym_bid,
    ACTIONS(13363), 2,
      anon_sym__,
      sym_id,
    ACTIONS(13465), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(8063), 4,
      sym_typed_binding,
      aux_sym__typed_untyped_bindings,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [635762] = 6,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13335), 1,
      sym__newline,
    ACTIONS(13329), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13325), 5,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
    ACTIONS(13333), 7,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
  [635793] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13287), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13285), 12,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
      anon_sym_in,
  [635820] = 13,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13367), 1,
      anon_sym_LPAREN,
    ACTIONS(13369), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(13371), 1,
      anon_sym_u2983,
    ACTIONS(13373), 1,
      anon_sym_LBRACE,
    ACTIONS(13375), 1,
      anon_sym_DOT,
    ACTIONS(13377), 1,
      anon_sym_DOT_DOT,
    STATE(2158), 1,
      sym__ARROW,
    STATE(8750), 1,
      sym_bid,
    ACTIONS(13363), 2,
      anon_sym__,
      sym_id,
    ACTIONS(13467), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(8063), 4,
      sym_typed_binding,
      aux_sym__typed_untyped_bindings,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [635865] = 13,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13367), 1,
      anon_sym_LPAREN,
    ACTIONS(13369), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(13371), 1,
      anon_sym_u2983,
    ACTIONS(13373), 1,
      anon_sym_LBRACE,
    ACTIONS(13375), 1,
      anon_sym_DOT,
    ACTIONS(13377), 1,
      anon_sym_DOT_DOT,
    STATE(2038), 1,
      sym__ARROW,
    STATE(8750), 1,
      sym_bid,
    ACTIONS(13363), 2,
      anon_sym__,
      sym_id,
    ACTIONS(13469), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(8063), 4,
      sym_typed_binding,
      aux_sym__typed_untyped_bindings,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [635910] = 13,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13367), 1,
      anon_sym_LPAREN,
    ACTIONS(13369), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(13371), 1,
      anon_sym_u2983,
    ACTIONS(13373), 1,
      anon_sym_LBRACE,
    ACTIONS(13375), 1,
      anon_sym_DOT,
    ACTIONS(13377), 1,
      anon_sym_DOT_DOT,
    STATE(1822), 1,
      sym__ARROW,
    STATE(8750), 1,
      sym_bid,
    ACTIONS(13363), 2,
      anon_sym__,
      sym_id,
    ACTIONS(13471), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(8063), 4,
      sym_typed_binding,
      aux_sym__typed_untyped_bindings,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [635955] = 13,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13367), 1,
      anon_sym_LPAREN,
    ACTIONS(13369), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(13371), 1,
      anon_sym_u2983,
    ACTIONS(13373), 1,
      anon_sym_LBRACE,
    ACTIONS(13375), 1,
      anon_sym_DOT,
    ACTIONS(13377), 1,
      anon_sym_DOT_DOT,
    STATE(1801), 1,
      sym__ARROW,
    STATE(8750), 1,
      sym_bid,
    ACTIONS(13363), 2,
      anon_sym__,
      sym_id,
    ACTIONS(13473), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(8063), 4,
      sym_typed_binding,
      aux_sym__typed_untyped_bindings,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [636000] = 6,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13331), 1,
      sym__newline,
    ACTIONS(13329), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13325), 5,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
    ACTIONS(13327), 7,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
  [636031] = 13,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13367), 1,
      anon_sym_LPAREN,
    ACTIONS(13369), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(13371), 1,
      anon_sym_u2983,
    ACTIONS(13373), 1,
      anon_sym_LBRACE,
    ACTIONS(13375), 1,
      anon_sym_DOT,
    ACTIONS(13377), 1,
      anon_sym_DOT_DOT,
    STATE(2605), 1,
      sym__ARROW,
    STATE(8750), 1,
      sym_bid,
    ACTIONS(13363), 2,
      anon_sym__,
      sym_id,
    ACTIONS(13475), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(8063), 4,
      sym_typed_binding,
      aux_sym__typed_untyped_bindings,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [636076] = 13,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13367), 1,
      anon_sym_LPAREN,
    ACTIONS(13369), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(13371), 1,
      anon_sym_u2983,
    ACTIONS(13373), 1,
      anon_sym_LBRACE,
    ACTIONS(13375), 1,
      anon_sym_DOT,
    ACTIONS(13377), 1,
      anon_sym_DOT_DOT,
    STATE(1608), 1,
      sym__ARROW,
    STATE(8750), 1,
      sym_bid,
    ACTIONS(13363), 2,
      anon_sym__,
      sym_id,
    ACTIONS(13477), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(8063), 4,
      sym_typed_binding,
      aux_sym__typed_untyped_bindings,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [636121] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13339), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13337), 11,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [636147] = 14,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13481), 1,
      anon_sym_where,
    ACTIONS(13483), 1,
      anon_sym_LPAREN,
    ACTIONS(13485), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(13487), 1,
      anon_sym_u2983,
    ACTIONS(13489), 1,
      anon_sym_LBRACE,
    ACTIONS(13491), 1,
      anon_sym_DOT,
    ACTIONS(13493), 1,
      anon_sym_DOT_DOT,
    STATE(8344), 1,
      sym_bid,
    STATE(8407), 1,
      aux_sym__lambda_bindings_repeat1,
    STATE(9146), 1,
      sym__lambda_bindings,
    ACTIONS(13479), 2,
      anon_sym__,
      sym_id,
    STATE(8361), 3,
      sym_typed_binding,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [636193] = 14,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13497), 1,
      anon_sym_where,
    ACTIONS(13499), 1,
      anon_sym_LPAREN,
    ACTIONS(13501), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(13503), 1,
      anon_sym_u2983,
    ACTIONS(13505), 1,
      anon_sym_LBRACE,
    ACTIONS(13507), 1,
      anon_sym_DOT,
    ACTIONS(13509), 1,
      anon_sym_DOT_DOT,
    STATE(7962), 1,
      sym_bid,
    STATE(8381), 1,
      aux_sym__lambda_bindings_repeat1,
    STATE(8998), 1,
      sym__lambda_bindings,
    ACTIONS(13495), 2,
      anon_sym__,
      sym_id,
    STATE(7996), 3,
      sym_typed_binding,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [636239] = 14,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13513), 1,
      anon_sym_where,
    ACTIONS(13515), 1,
      anon_sym_LPAREN,
    ACTIONS(13517), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(13519), 1,
      anon_sym_u2983,
    ACTIONS(13521), 1,
      anon_sym_LBRACE,
    ACTIONS(13523), 1,
      anon_sym_DOT,
    ACTIONS(13525), 1,
      anon_sym_DOT_DOT,
    STATE(8378), 1,
      aux_sym__lambda_bindings_repeat1,
    STATE(8424), 1,
      sym_bid,
    STATE(9144), 1,
      sym__lambda_bindings,
    ACTIONS(13511), 2,
      anon_sym__,
      sym_id,
    STATE(8380), 3,
      sym_typed_binding,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [636285] = 6,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13335), 1,
      sym__newline,
    ACTIONS(13329), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13325), 5,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
    ACTIONS(13333), 6,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_in,
  [636315] = 14,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13529), 1,
      anon_sym_where,
    ACTIONS(13531), 1,
      anon_sym_LPAREN,
    ACTIONS(13533), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(13535), 1,
      anon_sym_u2983,
    ACTIONS(13537), 1,
      anon_sym_LBRACE,
    ACTIONS(13539), 1,
      anon_sym_DOT,
    ACTIONS(13541), 1,
      anon_sym_DOT_DOT,
    STATE(8147), 1,
      sym_bid,
    STATE(8371), 1,
      aux_sym__lambda_bindings_repeat1,
    STATE(9035), 1,
      sym__lambda_bindings,
    ACTIONS(13527), 2,
      anon_sym__,
      sym_id,
    STATE(8101), 3,
      sym_typed_binding,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [636361] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13299), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13297), 11,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [636387] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13254), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13252), 11,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
      anon_sym_in,
  [636413] = 14,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13545), 1,
      anon_sym_where,
    ACTIONS(13547), 1,
      anon_sym_LPAREN,
    ACTIONS(13549), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(13551), 1,
      anon_sym_u2983,
    ACTIONS(13553), 1,
      anon_sym_LBRACE,
    ACTIONS(13555), 1,
      anon_sym_DOT,
    ACTIONS(13557), 1,
      anon_sym_DOT_DOT,
    STATE(7913), 1,
      sym_bid,
    STATE(8312), 1,
      aux_sym__lambda_bindings_repeat1,
    STATE(8804), 1,
      sym__lambda_bindings,
    ACTIONS(13543), 2,
      anon_sym__,
      sym_id,
    STATE(7907), 3,
      sym_typed_binding,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [636459] = 14,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13561), 1,
      anon_sym_where,
    ACTIONS(13563), 1,
      anon_sym_LPAREN,
    ACTIONS(13565), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(13567), 1,
      anon_sym_u2983,
    ACTIONS(13569), 1,
      anon_sym_LBRACE,
    ACTIONS(13571), 1,
      anon_sym_DOT,
    ACTIONS(13573), 1,
      anon_sym_DOT_DOT,
    STATE(8197), 1,
      sym_bid,
    STATE(8421), 1,
      aux_sym__lambda_bindings_repeat1,
    STATE(9147), 1,
      sym__lambda_bindings,
    ACTIONS(13559), 2,
      anon_sym__,
      sym_id,
    STATE(8238), 3,
      sym_typed_binding,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [636505] = 14,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13577), 1,
      anon_sym_where,
    ACTIONS(13579), 1,
      anon_sym_LPAREN,
    ACTIONS(13581), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(13583), 1,
      anon_sym_u2983,
    ACTIONS(13585), 1,
      anon_sym_LBRACE,
    ACTIONS(13587), 1,
      anon_sym_DOT,
    ACTIONS(13589), 1,
      anon_sym_DOT_DOT,
    STATE(8265), 1,
      aux_sym__lambda_bindings_repeat1,
    STATE(8436), 1,
      sym_bid,
    STATE(9151), 1,
      sym__lambda_bindings,
    ACTIONS(13575), 2,
      anon_sym__,
      sym_id,
    STATE(8392), 3,
      sym_typed_binding,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [636551] = 14,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13563), 1,
      anon_sym_LPAREN,
    ACTIONS(13565), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(13567), 1,
      anon_sym_u2983,
    ACTIONS(13569), 1,
      anon_sym_LBRACE,
    ACTIONS(13571), 1,
      anon_sym_DOT,
    ACTIONS(13573), 1,
      anon_sym_DOT_DOT,
    ACTIONS(13591), 1,
      anon_sym_where,
    STATE(8197), 1,
      sym_bid,
    STATE(8421), 1,
      aux_sym__lambda_bindings_repeat1,
    STATE(9156), 1,
      sym__lambda_bindings,
    ACTIONS(13559), 2,
      anon_sym__,
      sym_id,
    STATE(8238), 3,
      sym_typed_binding,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [636597] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13303), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13301), 11,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [636623] = 12,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13598), 1,
      anon_sym_LPAREN,
    ACTIONS(13601), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(13604), 1,
      anon_sym_u2983,
    ACTIONS(13607), 1,
      anon_sym_LBRACE,
    ACTIONS(13610), 1,
      anon_sym_DOT,
    ACTIONS(13613), 1,
      anon_sym_DOT_DOT,
    STATE(8885), 1,
      sym_bid,
    ACTIONS(13593), 2,
      anon_sym__,
      sym_id,
    ACTIONS(13596), 2,
      anon_sym_EQ,
      anon_sym_where,
    STATE(8043), 4,
      sym_typed_binding,
      aux_sym__typed_untyped_bindings,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [636665] = 14,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13618), 1,
      anon_sym_where,
    ACTIONS(13620), 1,
      anon_sym_LPAREN,
    ACTIONS(13622), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(13624), 1,
      anon_sym_u2983,
    ACTIONS(13626), 1,
      anon_sym_LBRACE,
    ACTIONS(13628), 1,
      anon_sym_DOT,
    ACTIONS(13630), 1,
      anon_sym_DOT_DOT,
    STATE(8118), 1,
      sym_bid,
    STATE(8299), 1,
      aux_sym__lambda_bindings_repeat1,
    STATE(9100), 1,
      sym__lambda_bindings,
    ACTIONS(13616), 2,
      anon_sym__,
      sym_id,
    STATE(8060), 3,
      sym_typed_binding,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [636711] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13343), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13341), 11,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
      anon_sym_in,
  [636737] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13339), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13337), 11,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
      anon_sym_in,
  [636763] = 14,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13634), 1,
      anon_sym_where,
    ACTIONS(13636), 1,
      anon_sym_LPAREN,
    ACTIONS(13638), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(13640), 1,
      anon_sym_u2983,
    ACTIONS(13642), 1,
      anon_sym_LBRACE,
    ACTIONS(13644), 1,
      anon_sym_DOT,
    ACTIONS(13646), 1,
      anon_sym_DOT_DOT,
    STATE(8298), 1,
      sym_bid,
    STATE(8517), 1,
      aux_sym__lambda_bindings_repeat1,
    STATE(9170), 1,
      sym__lambda_bindings,
    ACTIONS(13632), 2,
      anon_sym__,
      sym_id,
    STATE(8297), 3,
      sym_typed_binding,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [636809] = 6,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13331), 1,
      sym__newline,
    ACTIONS(13329), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13325), 5,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
    ACTIONS(13327), 6,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_in,
  [636839] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13291), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13289), 11,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
      anon_sym_in,
  [636865] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13287), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13285), 11,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
      anon_sym_in,
  [636891] = 14,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13650), 1,
      anon_sym_where,
    ACTIONS(13652), 1,
      anon_sym_LPAREN,
    ACTIONS(13654), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(13656), 1,
      anon_sym_u2983,
    ACTIONS(13658), 1,
      anon_sym_LBRACE,
    ACTIONS(13660), 1,
      anon_sym_DOT,
    ACTIONS(13662), 1,
      anon_sym_DOT_DOT,
    STATE(8196), 1,
      sym_bid,
    STATE(8292), 1,
      aux_sym__lambda_bindings_repeat1,
    STATE(9118), 1,
      sym__lambda_bindings,
    ACTIONS(13648), 2,
      anon_sym__,
      sym_id,
    STATE(8171), 3,
      sym_typed_binding,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [636937] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13303), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13301), 11,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
      anon_sym_in,
  [636963] = 14,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13666), 1,
      anon_sym_where,
    ACTIONS(13668), 1,
      anon_sym_LPAREN,
    ACTIONS(13670), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(13672), 1,
      anon_sym_u2983,
    ACTIONS(13674), 1,
      anon_sym_LBRACE,
    ACTIONS(13676), 1,
      anon_sym_DOT,
    ACTIONS(13678), 1,
      anon_sym_DOT_DOT,
    STATE(8168), 1,
      sym_bid,
    STATE(8284), 1,
      aux_sym__lambda_bindings_repeat1,
    STATE(9112), 1,
      sym__lambda_bindings,
    ACTIONS(13664), 2,
      anon_sym__,
      sym_id,
    STATE(8178), 3,
      sym_typed_binding,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [637009] = 14,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13682), 1,
      anon_sym_where,
    ACTIONS(13684), 1,
      anon_sym_LPAREN,
    ACTIONS(13686), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(13688), 1,
      anon_sym_u2983,
    ACTIONS(13690), 1,
      anon_sym_LBRACE,
    ACTIONS(13692), 1,
      anon_sym_DOT,
    ACTIONS(13694), 1,
      anon_sym_DOT_DOT,
    STATE(8220), 1,
      sym_bid,
    STATE(8356), 1,
      aux_sym__lambda_bindings_repeat1,
    STATE(9170), 1,
      sym__lambda_bindings,
    ACTIONS(13680), 2,
      anon_sym__,
      sym_id,
    STATE(8207), 3,
      sym_typed_binding,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [637055] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13250), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13248), 11,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
      anon_sym_in,
  [637081] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13299), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13297), 11,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
      anon_sym_in,
  [637107] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13295), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13293), 11,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
      anon_sym_in,
  [637133] = 14,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13698), 1,
      anon_sym_where,
    ACTIONS(13700), 1,
      anon_sym_LPAREN,
    ACTIONS(13702), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(13704), 1,
      anon_sym_u2983,
    ACTIONS(13706), 1,
      anon_sym_LBRACE,
    ACTIONS(13708), 1,
      anon_sym_DOT,
    ACTIONS(13710), 1,
      anon_sym_DOT_DOT,
    STATE(8267), 1,
      aux_sym__lambda_bindings_repeat1,
    STATE(8500), 1,
      sym_bid,
    STATE(9153), 1,
      sym__lambda_bindings,
    ACTIONS(13696), 2,
      anon_sym__,
      sym_id,
    STATE(8478), 3,
      sym_typed_binding,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [637179] = 6,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13331), 2,
      anon_sym_RPAREN,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(13329), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13325), 5,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
    ACTIONS(13327), 5,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_SEMI,
  [637209] = 6,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13335), 2,
      anon_sym_RPAREN,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(13329), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13325), 5,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
    ACTIONS(13333), 5,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_SEMI,
  [637239] = 14,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13714), 1,
      anon_sym_where,
    ACTIONS(13716), 1,
      anon_sym_LPAREN,
    ACTIONS(13718), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(13720), 1,
      anon_sym_u2983,
    ACTIONS(13722), 1,
      anon_sym_LBRACE,
    ACTIONS(13724), 1,
      anon_sym_DOT,
    ACTIONS(13726), 1,
      anon_sym_DOT_DOT,
    STATE(8209), 1,
      sym_bid,
    STATE(8508), 1,
      aux_sym__lambda_bindings_repeat1,
    STATE(9099), 1,
      sym__lambda_bindings,
    ACTIONS(13712), 2,
      anon_sym__,
      sym_id,
    STATE(8256), 3,
      sym_typed_binding,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [637285] = 14,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13730), 1,
      anon_sym_where,
    ACTIONS(13732), 1,
      anon_sym_LPAREN,
    ACTIONS(13734), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(13736), 1,
      anon_sym_u2983,
    ACTIONS(13738), 1,
      anon_sym_LBRACE,
    ACTIONS(13740), 1,
      anon_sym_DOT,
    ACTIONS(13742), 1,
      anon_sym_DOT_DOT,
    STATE(8333), 1,
      aux_sym__lambda_bindings_repeat1,
    STATE(8568), 1,
      sym_bid,
    STATE(9229), 1,
      sym__lambda_bindings,
    ACTIONS(13728), 2,
      anon_sym__,
      sym_id,
    STATE(8551), 3,
      sym_typed_binding,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [637331] = 12,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13747), 1,
      anon_sym_LPAREN,
    ACTIONS(13750), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(13753), 1,
      anon_sym_u2983,
    ACTIONS(13756), 1,
      anon_sym_LBRACE,
    ACTIONS(13759), 1,
      anon_sym_DOT,
    ACTIONS(13762), 1,
      anon_sym_DOT_DOT,
    STATE(8750), 1,
      sym_bid,
    ACTIONS(13596), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(13744), 2,
      anon_sym__,
      sym_id,
    STATE(8063), 4,
      sym_typed_binding,
      aux_sym__typed_untyped_bindings,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [637373] = 14,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13767), 1,
      anon_sym_where,
    ACTIONS(13769), 1,
      anon_sym_LPAREN,
    ACTIONS(13771), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(13773), 1,
      anon_sym_u2983,
    ACTIONS(13775), 1,
      anon_sym_LBRACE,
    ACTIONS(13777), 1,
      anon_sym_DOT,
    ACTIONS(13779), 1,
      anon_sym_DOT_DOT,
    STATE(8261), 1,
      sym_bid,
    STATE(8474), 1,
      aux_sym__lambda_bindings_repeat1,
    STATE(9072), 1,
      sym__lambda_bindings,
    ACTIONS(13765), 2,
      anon_sym__,
      sym_id,
    STATE(8243), 3,
      sym_typed_binding,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [637419] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13295), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13293), 11,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
      anon_sym_in,
  [637445] = 14,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13783), 1,
      anon_sym_where,
    ACTIONS(13785), 1,
      anon_sym_LPAREN,
    ACTIONS(13787), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(13789), 1,
      anon_sym_u2983,
    ACTIONS(13791), 1,
      anon_sym_LBRACE,
    ACTIONS(13793), 1,
      anon_sym_DOT,
    ACTIONS(13795), 1,
      anon_sym_DOT_DOT,
    STATE(7946), 1,
      sym_bid,
    STATE(8385), 1,
      aux_sym__lambda_bindings_repeat1,
    STATE(8928), 1,
      sym__lambda_bindings,
    ACTIONS(13781), 2,
      anon_sym__,
      sym_id,
    STATE(7948), 3,
      sym_typed_binding,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [637491] = 14,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13799), 1,
      anon_sym_where,
    ACTIONS(13801), 1,
      anon_sym_LPAREN,
    ACTIONS(13803), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(13805), 1,
      anon_sym_u2983,
    ACTIONS(13807), 1,
      anon_sym_LBRACE,
    ACTIONS(13809), 1,
      anon_sym_DOT,
    ACTIONS(13811), 1,
      anon_sym_DOT_DOT,
    STATE(8506), 1,
      aux_sym__lambda_bindings_repeat1,
    STATE(8618), 1,
      sym_bid,
    STATE(9178), 1,
      sym__lambda_bindings,
    ACTIONS(13797), 2,
      anon_sym__,
      sym_id,
    STATE(8602), 3,
      sym_typed_binding,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [637537] = 6,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13331), 1,
      sym__newline,
    ACTIONS(13329), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13325), 5,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
    ACTIONS(13327), 6,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
  [637567] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13250), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13248), 11,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
      anon_sym_in,
  [637593] = 12,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13816), 1,
      anon_sym_LPAREN,
    ACTIONS(13819), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(13822), 1,
      anon_sym_u2983,
    ACTIONS(13825), 1,
      anon_sym_LBRACE,
    ACTIONS(13828), 1,
      anon_sym_DOT,
    ACTIONS(13831), 1,
      anon_sym_DOT_DOT,
    STATE(8871), 1,
      sym_bid,
    ACTIONS(13596), 2,
      anon_sym_COLON,
      anon_sym_where,
    ACTIONS(13813), 2,
      anon_sym__,
      sym_id,
    STATE(8070), 4,
      sym_typed_binding,
      aux_sym__typed_untyped_bindings,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [637635] = 6,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13331), 1,
      sym__newline,
    ACTIONS(13329), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13325), 5,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
    ACTIONS(13327), 6,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_in,
  [637665] = 14,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13836), 1,
      anon_sym_where,
    ACTIONS(13838), 1,
      anon_sym_LPAREN,
    ACTIONS(13840), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(13842), 1,
      anon_sym_u2983,
    ACTIONS(13844), 1,
      anon_sym_LBRACE,
    ACTIONS(13846), 1,
      anon_sym_DOT,
    ACTIONS(13848), 1,
      anon_sym_DOT_DOT,
    STATE(8360), 1,
      aux_sym__lambda_bindings_repeat1,
    STATE(8450), 1,
      sym_bid,
    STATE(9160), 1,
      sym__lambda_bindings,
    ACTIONS(13834), 2,
      anon_sym__,
      sym_id,
    STATE(8401), 3,
      sym_typed_binding,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [637711] = 6,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13335), 1,
      sym__newline,
    ACTIONS(13329), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13325), 5,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
    ACTIONS(13333), 6,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_in,
  [637741] = 14,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13852), 1,
      anon_sym_EQ,
    ACTIONS(13854), 1,
      anon_sym_LPAREN,
    ACTIONS(13856), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(13858), 1,
      anon_sym_u2983,
    ACTIONS(13860), 1,
      anon_sym_LBRACE,
    ACTIONS(13862), 1,
      anon_sym_DOT,
    ACTIONS(13864), 1,
      anon_sym_DOT_DOT,
    STATE(8304), 1,
      aux_sym__lambda_bindings_repeat1,
    STATE(8980), 1,
      sym_bid,
    STATE(12520), 1,
      sym__lambda_bindings,
    ACTIONS(13850), 2,
      anon_sym__,
      sym_id,
    STATE(8962), 3,
      sym_typed_binding,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [637787] = 14,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13868), 1,
      anon_sym_where,
    ACTIONS(13870), 1,
      anon_sym_LPAREN,
    ACTIONS(13872), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(13874), 1,
      anon_sym_u2983,
    ACTIONS(13876), 1,
      anon_sym_LBRACE,
    ACTIONS(13878), 1,
      anon_sym_DOT,
    ACTIONS(13880), 1,
      anon_sym_DOT_DOT,
    STATE(8339), 1,
      aux_sym__lambda_bindings_repeat1,
    STATE(8515), 1,
      sym_bid,
    STATE(9100), 1,
      sym__lambda_bindings,
    ACTIONS(13866), 2,
      anon_sym__,
      sym_id,
    STATE(8498), 3,
      sym_typed_binding,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [637833] = 14,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13884), 1,
      anon_sym_where,
    ACTIONS(13886), 1,
      anon_sym_LPAREN,
    ACTIONS(13888), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(13890), 1,
      anon_sym_u2983,
    ACTIONS(13892), 1,
      anon_sym_LBRACE,
    ACTIONS(13894), 1,
      anon_sym_DOT,
    ACTIONS(13896), 1,
      anon_sym_DOT_DOT,
    STATE(8110), 1,
      sym_bid,
    STATE(8492), 1,
      aux_sym__lambda_bindings_repeat1,
    STATE(9044), 1,
      sym__lambda_bindings,
    ACTIONS(13882), 2,
      anon_sym__,
      sym_id,
    STATE(8034), 3,
      sym_typed_binding,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [637879] = 14,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13900), 1,
      anon_sym_where,
    ACTIONS(13902), 1,
      anon_sym_LPAREN,
    ACTIONS(13904), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(13906), 1,
      anon_sym_u2983,
    ACTIONS(13908), 1,
      anon_sym_LBRACE,
    ACTIONS(13910), 1,
      anon_sym_DOT,
    ACTIONS(13912), 1,
      anon_sym_DOT_DOT,
    STATE(8269), 1,
      aux_sym__lambda_bindings_repeat1,
    STATE(8400), 1,
      sym_bid,
    STATE(9380), 1,
      sym__lambda_bindings,
    ACTIONS(13898), 2,
      anon_sym__,
      sym_id,
    STATE(8488), 3,
      sym_typed_binding,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [637925] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13303), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13301), 11,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
      anon_sym_in,
  [637951] = 14,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13777), 1,
      anon_sym_DOT,
    ACTIONS(13779), 1,
      anon_sym_DOT_DOT,
    ACTIONS(13914), 1,
      anon_sym_where,
    ACTIONS(13916), 1,
      anon_sym_LPAREN,
    ACTIONS(13918), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(13920), 1,
      anon_sym_u2983,
    ACTIONS(13922), 1,
      anon_sym_LBRACE,
    STATE(8261), 1,
      sym_bid,
    STATE(8320), 1,
      aux_sym__lambda_bindings_repeat1,
    STATE(9071), 1,
      sym__lambda_bindings,
    ACTIONS(13765), 2,
      anon_sym__,
      sym_id,
    STATE(8243), 3,
      sym_typed_binding,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [637997] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13291), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13289), 11,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
      anon_sym_in,
  [638023] = 14,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13926), 1,
      anon_sym_where,
    ACTIONS(13928), 1,
      anon_sym_LPAREN,
    ACTIONS(13930), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(13932), 1,
      anon_sym_u2983,
    ACTIONS(13934), 1,
      anon_sym_LBRACE,
    ACTIONS(13936), 1,
      anon_sym_DOT,
    ACTIONS(13938), 1,
      anon_sym_DOT_DOT,
    STATE(8359), 1,
      aux_sym__lambda_bindings_repeat1,
    STATE(8538), 1,
      sym_bid,
    STATE(9156), 1,
      sym__lambda_bindings,
    ACTIONS(13924), 2,
      anon_sym__,
      sym_id,
    STATE(8541), 3,
      sym_typed_binding,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [638069] = 13,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13351), 1,
      anon_sym_LPAREN,
    ACTIONS(13353), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(13355), 1,
      anon_sym_u2983,
    ACTIONS(13357), 1,
      anon_sym_LBRACE,
    ACTIONS(13359), 1,
      anon_sym_DOT,
    ACTIONS(13361), 1,
      anon_sym_DOT_DOT,
    ACTIONS(13940), 1,
      anon_sym_COLON,
    ACTIONS(13942), 1,
      anon_sym_where,
    STATE(8871), 1,
      sym_bid,
    ACTIONS(13345), 2,
      anon_sym__,
      sym_id,
    STATE(8098), 4,
      sym_typed_binding,
      aux_sym__typed_untyped_bindings,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [638113] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13287), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13285), 11,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [638139] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13254), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13252), 11,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
      anon_sym_in,
  [638165] = 14,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13946), 1,
      anon_sym_where,
    ACTIONS(13948), 1,
      anon_sym_LPAREN,
    ACTIONS(13950), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(13952), 1,
      anon_sym_u2983,
    ACTIONS(13954), 1,
      anon_sym_LBRACE,
    ACTIONS(13956), 1,
      anon_sym_DOT,
    ACTIONS(13958), 1,
      anon_sym_DOT_DOT,
    STATE(8022), 1,
      sym_bid,
    STATE(8330), 1,
      aux_sym__lambda_bindings_repeat1,
    STATE(8984), 1,
      sym__lambda_bindings,
    ACTIONS(13944), 2,
      anon_sym__,
      sym_id,
    STATE(7988), 3,
      sym_typed_binding,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [638211] = 14,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13936), 1,
      anon_sym_DOT,
    ACTIONS(13938), 1,
      anon_sym_DOT_DOT,
    ACTIONS(13960), 1,
      anon_sym_where,
    ACTIONS(13962), 1,
      anon_sym_LPAREN,
    ACTIONS(13964), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(13966), 1,
      anon_sym_u2983,
    ACTIONS(13968), 1,
      anon_sym_LBRACE,
    STATE(8307), 1,
      aux_sym__lambda_bindings_repeat1,
    STATE(8538), 1,
      sym_bid,
    STATE(9161), 1,
      sym__lambda_bindings,
    ACTIONS(13924), 2,
      anon_sym__,
      sym_id,
    STATE(8541), 3,
      sym_typed_binding,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [638257] = 13,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13351), 1,
      anon_sym_LPAREN,
    ACTIONS(13353), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(13355), 1,
      anon_sym_u2983,
    ACTIONS(13357), 1,
      anon_sym_LBRACE,
    ACTIONS(13359), 1,
      anon_sym_DOT,
    ACTIONS(13361), 1,
      anon_sym_DOT_DOT,
    ACTIONS(13942), 1,
      anon_sym_where,
    ACTIONS(13970), 1,
      anon_sym_COLON,
    STATE(8871), 1,
      sym_bid,
    ACTIONS(13345), 2,
      anon_sym__,
      sym_id,
    STATE(8105), 4,
      sym_typed_binding,
      aux_sym__typed_untyped_bindings,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [638301] = 13,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13974), 1,
      anon_sym_EQ,
    ACTIONS(13976), 1,
      anon_sym_where,
    ACTIONS(13978), 1,
      anon_sym_LPAREN,
    ACTIONS(13980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(13982), 1,
      anon_sym_u2983,
    ACTIONS(13984), 1,
      anon_sym_LBRACE,
    ACTIONS(13986), 1,
      anon_sym_DOT,
    ACTIONS(13988), 1,
      anon_sym_DOT_DOT,
    STATE(8885), 1,
      sym_bid,
    ACTIONS(13972), 2,
      anon_sym__,
      sym_id,
    STATE(8129), 4,
      sym_typed_binding,
      aux_sym__typed_untyped_bindings,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [638345] = 14,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13992), 1,
      anon_sym_where,
    ACTIONS(13994), 1,
      anon_sym_LPAREN,
    ACTIONS(13996), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(13998), 1,
      anon_sym_u2983,
    ACTIONS(14000), 1,
      anon_sym_LBRACE,
    ACTIONS(14002), 1,
      anon_sym_DOT,
    ACTIONS(14004), 1,
      anon_sym_DOT_DOT,
    STATE(8340), 1,
      aux_sym__lambda_bindings_repeat1,
    STATE(8573), 1,
      sym_bid,
    STATE(9356), 1,
      sym__lambda_bindings,
    ACTIONS(13990), 2,
      anon_sym__,
      sym_id,
    STATE(8554), 3,
      sym_typed_binding,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [638391] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13343), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13341), 11,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
      anon_sym_in,
  [638417] = 14,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13902), 1,
      anon_sym_LPAREN,
    ACTIONS(13904), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(13906), 1,
      anon_sym_u2983,
    ACTIONS(13908), 1,
      anon_sym_LBRACE,
    ACTIONS(13910), 1,
      anon_sym_DOT,
    ACTIONS(13912), 1,
      anon_sym_DOT_DOT,
    ACTIONS(14006), 1,
      anon_sym_where,
    STATE(8269), 1,
      aux_sym__lambda_bindings_repeat1,
    STATE(8400), 1,
      sym_bid,
    STATE(9251), 1,
      sym__lambda_bindings,
    ACTIONS(13898), 2,
      anon_sym__,
      sym_id,
    STATE(8488), 3,
      sym_typed_binding,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [638463] = 14,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(14010), 1,
      anon_sym_where,
    ACTIONS(14012), 1,
      anon_sym_LPAREN,
    ACTIONS(14014), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(14016), 1,
      anon_sym_u2983,
    ACTIONS(14018), 1,
      anon_sym_LBRACE,
    ACTIONS(14020), 1,
      anon_sym_DOT,
    ACTIONS(14022), 1,
      anon_sym_DOT_DOT,
    STATE(8226), 1,
      sym_bid,
    STATE(8273), 1,
      aux_sym__lambda_bindings_repeat1,
    STATE(9072), 1,
      sym__lambda_bindings,
    ACTIONS(14008), 2,
      anon_sym__,
      sym_id,
    STATE(8210), 3,
      sym_typed_binding,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [638509] = 14,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(14026), 1,
      anon_sym_where,
    ACTIONS(14028), 1,
      anon_sym_LPAREN,
    ACTIONS(14030), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(14032), 1,
      anon_sym_u2983,
    ACTIONS(14034), 1,
      anon_sym_LBRACE,
    ACTIONS(14036), 1,
      anon_sym_DOT,
    ACTIONS(14038), 1,
      anon_sym_DOT_DOT,
    STATE(8169), 1,
      sym_bid,
    STATE(8280), 1,
      aux_sym__lambda_bindings_repeat1,
    STATE(9108), 1,
      sym__lambda_bindings,
    ACTIONS(14024), 2,
      anon_sym__,
      sym_id,
    STATE(8174), 3,
      sym_typed_binding,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [638555] = 14,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(14042), 1,
      anon_sym_where,
    ACTIONS(14044), 1,
      anon_sym_LPAREN,
    ACTIONS(14046), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(14048), 1,
      anon_sym_u2983,
    ACTIONS(14050), 1,
      anon_sym_LBRACE,
    ACTIONS(14052), 1,
      anon_sym_DOT,
    ACTIONS(14054), 1,
      anon_sym_DOT_DOT,
    STATE(7889), 1,
      sym_bid,
    STATE(8481), 1,
      aux_sym__lambda_bindings_repeat1,
    STATE(8637), 1,
      sym__lambda_bindings,
    ACTIONS(14040), 2,
      anon_sym__,
      sym_id,
    STATE(7860), 3,
      sym_typed_binding,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [638601] = 14,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13684), 1,
      anon_sym_LPAREN,
    ACTIONS(13686), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(13688), 1,
      anon_sym_u2983,
    ACTIONS(13690), 1,
      anon_sym_LBRACE,
    ACTIONS(13692), 1,
      anon_sym_DOT,
    ACTIONS(13694), 1,
      anon_sym_DOT_DOT,
    ACTIONS(14056), 1,
      anon_sym_where,
    STATE(8220), 1,
      sym_bid,
    STATE(8356), 1,
      aux_sym__lambda_bindings_repeat1,
    STATE(9181), 1,
      sym__lambda_bindings,
    ACTIONS(13680), 2,
      anon_sym__,
      sym_id,
    STATE(8207), 3,
      sym_typed_binding,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [638647] = 14,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(14060), 1,
      anon_sym_where,
    ACTIONS(14062), 1,
      anon_sym_LPAREN,
    ACTIONS(14064), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(14066), 1,
      anon_sym_u2983,
    ACTIONS(14068), 1,
      anon_sym_LBRACE,
    ACTIONS(14070), 1,
      anon_sym_DOT,
    ACTIONS(14072), 1,
      anon_sym_DOT_DOT,
    STATE(8430), 1,
      aux_sym__lambda_bindings_repeat1,
    STATE(8556), 1,
      sym_bid,
    STATE(9330), 1,
      sym__lambda_bindings,
    ACTIONS(14058), 2,
      anon_sym__,
      sym_id,
    STATE(8627), 3,
      sym_typed_binding,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [638693] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13299), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13297), 11,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [638719] = 13,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13351), 1,
      anon_sym_LPAREN,
    ACTIONS(13353), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(13355), 1,
      anon_sym_u2983,
    ACTIONS(13357), 1,
      anon_sym_LBRACE,
    ACTIONS(13359), 1,
      anon_sym_DOT,
    ACTIONS(13361), 1,
      anon_sym_DOT_DOT,
    ACTIONS(14074), 1,
      anon_sym_COLON,
    ACTIONS(14076), 1,
      anon_sym_where,
    STATE(8871), 1,
      sym_bid,
    ACTIONS(13345), 2,
      anon_sym__,
      sym_id,
    STATE(8070), 4,
      sym_typed_binding,
      aux_sym__typed_untyped_bindings,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [638763] = 14,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(14080), 1,
      anon_sym_where,
    ACTIONS(14082), 1,
      anon_sym_LPAREN,
    ACTIONS(14084), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(14086), 1,
      anon_sym_u2983,
    ACTIONS(14088), 1,
      anon_sym_LBRACE,
    ACTIONS(14090), 1,
      anon_sym_DOT,
    ACTIONS(14092), 1,
      anon_sym_DOT_DOT,
    STATE(7934), 1,
      sym_bid,
    STATE(8417), 1,
      aux_sym__lambda_bindings_repeat1,
    STATE(8917), 1,
      sym__lambda_bindings,
    ACTIONS(14078), 2,
      anon_sym__,
      sym_id,
    STATE(7916), 3,
      sym_typed_binding,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [638809] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13299), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13297), 11,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
      anon_sym_in,
  [638835] = 6,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13335), 1,
      sym__newline,
    ACTIONS(13329), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13325), 5,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
    ACTIONS(13333), 6,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
  [638865] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13295), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13293), 11,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [638891] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13250), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13248), 11,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [638917] = 14,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(14096), 1,
      anon_sym_where,
    ACTIONS(14098), 1,
      anon_sym_LPAREN,
    ACTIONS(14100), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(14102), 1,
      anon_sym_u2983,
    ACTIONS(14104), 1,
      anon_sym_LBRACE,
    ACTIONS(14106), 1,
      anon_sym_DOT,
    ACTIONS(14108), 1,
      anon_sym_DOT_DOT,
    STATE(8274), 1,
      aux_sym__lambda_bindings_repeat1,
    STATE(8580), 1,
      sym_bid,
    STATE(9232), 1,
      sym__lambda_bindings,
    ACTIONS(14094), 2,
      anon_sym__,
      sym_id,
    STATE(8559), 3,
      sym_typed_binding,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [638963] = 13,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13351), 1,
      anon_sym_LPAREN,
    ACTIONS(13353), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(13355), 1,
      anon_sym_u2983,
    ACTIONS(13357), 1,
      anon_sym_LBRACE,
    ACTIONS(13359), 1,
      anon_sym_DOT,
    ACTIONS(13361), 1,
      anon_sym_DOT_DOT,
    ACTIONS(14076), 1,
      anon_sym_where,
    ACTIONS(14110), 1,
      anon_sym_COLON,
    STATE(8871), 1,
      sym_bid,
    ACTIONS(13345), 2,
      anon_sym__,
      sym_id,
    STATE(8070), 4,
      sym_typed_binding,
      aux_sym__typed_untyped_bindings,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [639007] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13303), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13301), 11,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [639033] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13343), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13341), 11,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [639059] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13339), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13337), 11,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
      anon_sym_in,
  [639085] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13254), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13252), 11,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [639111] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13287), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13285), 11,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
      anon_sym_in,
  [639137] = 14,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(14114), 1,
      anon_sym_where,
    ACTIONS(14116), 1,
      anon_sym_LPAREN,
    ACTIONS(14118), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(14120), 1,
      anon_sym_u2983,
    ACTIONS(14122), 1,
      anon_sym_LBRACE,
    ACTIONS(14124), 1,
      anon_sym_DOT,
    ACTIONS(14126), 1,
      anon_sym_DOT_DOT,
    STATE(8485), 1,
      aux_sym__lambda_bindings_repeat1,
    STATE(8604), 1,
      sym_bid,
    STATE(9207), 1,
      sym__lambda_bindings,
    ACTIONS(14112), 2,
      anon_sym__,
      sym_id,
    STATE(8575), 3,
      sym_typed_binding,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [639183] = 13,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13351), 1,
      anon_sym_LPAREN,
    ACTIONS(13353), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(13355), 1,
      anon_sym_u2983,
    ACTIONS(13357), 1,
      anon_sym_LBRACE,
    ACTIONS(13359), 1,
      anon_sym_DOT,
    ACTIONS(13361), 1,
      anon_sym_DOT_DOT,
    ACTIONS(14076), 1,
      anon_sym_where,
    ACTIONS(14128), 1,
      anon_sym_COLON,
    STATE(8871), 1,
      sym_bid,
    ACTIONS(13345), 2,
      anon_sym__,
      sym_id,
    STATE(8070), 4,
      sym_typed_binding,
      aux_sym__typed_untyped_bindings,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [639227] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13291), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13289), 11,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [639253] = 14,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(14132), 1,
      anon_sym_where,
    ACTIONS(14134), 1,
      anon_sym_LPAREN,
    ACTIONS(14136), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(14138), 1,
      anon_sym_u2983,
    ACTIONS(14140), 1,
      anon_sym_LBRACE,
    ACTIONS(14142), 1,
      anon_sym_DOT,
    ACTIONS(14144), 1,
      anon_sym_DOT_DOT,
    STATE(7914), 1,
      sym_bid,
    STATE(8327), 1,
      aux_sym__lambda_bindings_repeat1,
    STATE(8753), 1,
      sym__lambda_bindings,
    ACTIONS(14130), 2,
      anon_sym__,
      sym_id,
    STATE(7894), 3,
      sym_typed_binding,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [639299] = 13,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13978), 1,
      anon_sym_LPAREN,
    ACTIONS(13980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(13982), 1,
      anon_sym_u2983,
    ACTIONS(13984), 1,
      anon_sym_LBRACE,
    ACTIONS(13986), 1,
      anon_sym_DOT,
    ACTIONS(13988), 1,
      anon_sym_DOT_DOT,
    ACTIONS(14146), 1,
      anon_sym_EQ,
    ACTIONS(14148), 1,
      anon_sym_where,
    STATE(8885), 1,
      sym_bid,
    ACTIONS(13972), 2,
      anon_sym__,
      sym_id,
    STATE(8043), 4,
      sym_typed_binding,
      aux_sym__typed_untyped_bindings,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [639343] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13295), 5,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13293), 10,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [639369] = 14,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(14152), 1,
      anon_sym_where,
    ACTIONS(14154), 1,
      anon_sym_LPAREN,
    ACTIONS(14156), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(14158), 1,
      anon_sym_u2983,
    ACTIONS(14160), 1,
      anon_sym_LBRACE,
    ACTIONS(14162), 1,
      anon_sym_DOT,
    ACTIONS(14164), 1,
      anon_sym_DOT_DOT,
    STATE(8083), 1,
      sym_bid,
    STATE(8454), 1,
      aux_sym__lambda_bindings_repeat1,
    STATE(9032), 1,
      sym__lambda_bindings,
    ACTIONS(14150), 2,
      anon_sym__,
      sym_id,
    STATE(8128), 3,
      sym_typed_binding,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [639415] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13287), 5,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13285), 10,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [639441] = 14,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(14168), 1,
      anon_sym_where,
    ACTIONS(14170), 1,
      anon_sym_LPAREN,
    ACTIONS(14172), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(14174), 1,
      anon_sym_u2983,
    ACTIONS(14176), 1,
      anon_sym_LBRACE,
    ACTIONS(14178), 1,
      anon_sym_DOT,
    ACTIONS(14180), 1,
      anon_sym_DOT_DOT,
    STATE(7935), 1,
      sym_bid,
    STATE(8287), 1,
      aux_sym__lambda_bindings_repeat1,
    STATE(8819), 1,
      sym__lambda_bindings,
    ACTIONS(14166), 2,
      anon_sym__,
      sym_id,
    STATE(7919), 3,
      sym_typed_binding,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [639487] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13339), 5,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13337), 10,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [639513] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13343), 5,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13341), 10,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [639539] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13254), 5,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13252), 10,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [639565] = 14,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(14184), 1,
      anon_sym_where,
    ACTIONS(14186), 1,
      anon_sym_LPAREN,
    ACTIONS(14188), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(14190), 1,
      anon_sym_u2983,
    ACTIONS(14192), 1,
      anon_sym_LBRACE,
    ACTIONS(14194), 1,
      anon_sym_DOT,
    ACTIONS(14196), 1,
      anon_sym_DOT_DOT,
    STATE(8491), 1,
      aux_sym__lambda_bindings_repeat1,
    STATE(8594), 1,
      sym_bid,
    STATE(9146), 1,
      sym__lambda_bindings,
    ACTIONS(14182), 2,
      anon_sym__,
      sym_id,
    STATE(8574), 3,
      sym_typed_binding,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [639611] = 14,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(14200), 1,
      anon_sym_where,
    ACTIONS(14202), 1,
      anon_sym_LPAREN,
    ACTIONS(14204), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(14206), 1,
      anon_sym_u2983,
    ACTIONS(14208), 1,
      anon_sym_LBRACE,
    ACTIONS(14210), 1,
      anon_sym_DOT,
    ACTIONS(14212), 1,
      anon_sym_DOT_DOT,
    STATE(8050), 1,
      sym_bid,
    STATE(8341), 1,
      aux_sym__lambda_bindings_repeat1,
    STATE(9016), 1,
      sym__lambda_bindings,
    ACTIONS(14198), 2,
      anon_sym__,
      sym_id,
    STATE(8073), 3,
      sym_typed_binding,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [639657] = 14,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(14216), 1,
      anon_sym_where,
    ACTIONS(14218), 1,
      anon_sym_LPAREN,
    ACTIONS(14220), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(14222), 1,
      anon_sym_u2983,
    ACTIONS(14224), 1,
      anon_sym_LBRACE,
    ACTIONS(14226), 1,
      anon_sym_DOT,
    ACTIONS(14228), 1,
      anon_sym_DOT_DOT,
    STATE(8348), 1,
      aux_sym__lambda_bindings_repeat1,
    STATE(8487), 1,
      sym_bid,
    STATE(9112), 1,
      sym__lambda_bindings,
    ACTIONS(14214), 2,
      anon_sym__,
      sym_id,
    STATE(8501), 3,
      sym_typed_binding,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [639703] = 14,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(14232), 1,
      anon_sym_where,
    ACTIONS(14234), 1,
      anon_sym_LPAREN,
    ACTIONS(14236), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(14238), 1,
      anon_sym_u2983,
    ACTIONS(14240), 1,
      anon_sym_LBRACE,
    ACTIONS(14242), 1,
      anon_sym_DOT,
    ACTIONS(14244), 1,
      anon_sym_DOT_DOT,
    STATE(8309), 1,
      aux_sym__lambda_bindings_repeat1,
    STATE(8524), 1,
      sym_bid,
    STATE(9153), 1,
      sym__lambda_bindings,
    ACTIONS(14230), 2,
      anon_sym__,
      sym_id,
    STATE(8534), 3,
      sym_typed_binding,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [639749] = 14,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(14248), 1,
      anon_sym_where,
    ACTIONS(14250), 1,
      anon_sym_LPAREN,
    ACTIONS(14252), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(14254), 1,
      anon_sym_u2983,
    ACTIONS(14256), 1,
      anon_sym_LBRACE,
    ACTIONS(14258), 1,
      anon_sym_DOT,
    ACTIONS(14260), 1,
      anon_sym_DOT_DOT,
    STATE(8399), 1,
      sym_bid,
    STATE(8462), 1,
      aux_sym__lambda_bindings_repeat1,
    STATE(9163), 1,
      sym__lambda_bindings,
    ACTIONS(14246), 2,
      anon_sym__,
      sym_id,
    STATE(8519), 3,
      sym_typed_binding,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [639795] = 6,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13335), 1,
      sym__newline,
    ACTIONS(13329), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13325), 5,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
    ACTIONS(13333), 6,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
  [639825] = 13,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13978), 1,
      anon_sym_LPAREN,
    ACTIONS(13980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(13982), 1,
      anon_sym_u2983,
    ACTIONS(13984), 1,
      anon_sym_LBRACE,
    ACTIONS(13986), 1,
      anon_sym_DOT,
    ACTIONS(13988), 1,
      anon_sym_DOT_DOT,
    ACTIONS(14148), 1,
      anon_sym_where,
    ACTIONS(14262), 1,
      anon_sym_EQ,
    STATE(8885), 1,
      sym_bid,
    ACTIONS(13972), 2,
      anon_sym__,
      sym_id,
    STATE(8043), 4,
      sym_typed_binding,
      aux_sym__typed_untyped_bindings,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [639869] = 6,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13331), 1,
      sym__newline,
    ACTIONS(13329), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13325), 5,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
    ACTIONS(13327), 6,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
  [639899] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13291), 5,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13289), 10,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [639925] = 14,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(14266), 1,
      anon_sym_where,
    ACTIONS(14268), 1,
      anon_sym_LPAREN,
    ACTIONS(14270), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(14272), 1,
      anon_sym_u2983,
    ACTIONS(14274), 1,
      anon_sym_LBRACE,
    ACTIONS(14276), 1,
      anon_sym_DOT,
    ACTIONS(14278), 1,
      anon_sym_DOT_DOT,
    STATE(8319), 1,
      sym_bid,
    STATE(8389), 1,
      aux_sym__lambda_bindings_repeat1,
    STATE(9161), 1,
      sym__lambda_bindings,
    ACTIONS(14264), 2,
      anon_sym__,
      sym_id,
    STATE(8350), 3,
      sym_typed_binding,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [639971] = 14,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(14282), 1,
      anon_sym_where,
    ACTIONS(14284), 1,
      anon_sym_LPAREN,
    ACTIONS(14286), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(14288), 1,
      anon_sym_u2983,
    ACTIONS(14290), 1,
      anon_sym_LBRACE,
    ACTIONS(14292), 1,
      anon_sym_DOT,
    ACTIONS(14294), 1,
      anon_sym_DOT_DOT,
    STATE(7886), 1,
      sym_bid,
    STATE(8270), 1,
      aux_sym__lambda_bindings_repeat1,
    STATE(8668), 1,
      sym__lambda_bindings,
    ACTIONS(14280), 2,
      anon_sym__,
      sym_id,
    STATE(7879), 3,
      sym_typed_binding,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [640017] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13303), 5,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13301), 10,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [640043] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13299), 5,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13297), 10,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [640069] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13250), 5,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13248), 10,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [640095] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13254), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13252), 11,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [640121] = 14,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(14298), 1,
      anon_sym_where,
    ACTIONS(14300), 1,
      anon_sym_LPAREN,
    ACTIONS(14302), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(14304), 1,
      anon_sym_u2983,
    ACTIONS(14306), 1,
      anon_sym_LBRACE,
    ACTIONS(14308), 1,
      anon_sym_DOT,
    ACTIONS(14310), 1,
      anon_sym_DOT_DOT,
    STATE(8410), 1,
      aux_sym__lambda_bindings_repeat1,
    STATE(8415), 1,
      sym_bid,
    STATE(9143), 1,
      sym__lambda_bindings,
    ACTIONS(14296), 2,
      anon_sym__,
      sym_id,
    STATE(8347), 3,
      sym_typed_binding,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [640167] = 14,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(14314), 1,
      anon_sym_where,
    ACTIONS(14316), 1,
      anon_sym_LPAREN,
    ACTIONS(14318), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(14320), 1,
      anon_sym_u2983,
    ACTIONS(14322), 1,
      anon_sym_LBRACE,
    ACTIONS(14324), 1,
      anon_sym_DOT,
    ACTIONS(14326), 1,
      anon_sym_DOT_DOT,
    STATE(8223), 1,
      sym_bid,
    STATE(8465), 1,
      aux_sym__lambda_bindings_repeat1,
    STATE(9138), 1,
      sym__lambda_bindings,
    ACTIONS(14312), 2,
      anon_sym__,
      sym_id,
    STATE(8254), 3,
      sym_typed_binding,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [640213] = 14,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(14330), 1,
      anon_sym_where,
    ACTIONS(14332), 1,
      anon_sym_LPAREN,
    ACTIONS(14334), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(14336), 1,
      anon_sym_u2983,
    ACTIONS(14338), 1,
      anon_sym_LBRACE,
    ACTIONS(14340), 1,
      anon_sym_DOT,
    ACTIONS(14342), 1,
      anon_sym_DOT_DOT,
    STATE(7965), 1,
      sym_bid,
    STATE(8443), 1,
      aux_sym__lambda_bindings_repeat1,
    STATE(8967), 1,
      sym__lambda_bindings,
    ACTIONS(14328), 2,
      anon_sym__,
      sym_id,
    STATE(8021), 3,
      sym_typed_binding,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [640259] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13343), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13341), 11,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [640285] = 14,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13636), 1,
      anon_sym_LPAREN,
    ACTIONS(13638), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(13640), 1,
      anon_sym_u2983,
    ACTIONS(13642), 1,
      anon_sym_LBRACE,
    ACTIONS(13644), 1,
      anon_sym_DOT,
    ACTIONS(13646), 1,
      anon_sym_DOT_DOT,
    ACTIONS(14344), 1,
      anon_sym_where,
    STATE(8298), 1,
      sym_bid,
    STATE(8517), 1,
      aux_sym__lambda_bindings_repeat1,
    STATE(9181), 1,
      sym__lambda_bindings,
    ACTIONS(13632), 2,
      anon_sym__,
      sym_id,
    STATE(8297), 3,
      sym_typed_binding,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [640331] = 14,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(14348), 1,
      anon_sym_where,
    ACTIONS(14350), 1,
      anon_sym_LPAREN,
    ACTIONS(14352), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(14354), 1,
      anon_sym_u2983,
    ACTIONS(14356), 1,
      anon_sym_LBRACE,
    ACTIONS(14358), 1,
      anon_sym_DOT,
    ACTIONS(14360), 1,
      anon_sym_DOT_DOT,
    STATE(7848), 1,
      sym_bid,
    STATE(8352), 1,
      aux_sym__lambda_bindings_repeat1,
    STATE(8600), 1,
      sym__lambda_bindings,
    ACTIONS(14346), 2,
      anon_sym__,
      sym_id,
    STATE(7855), 3,
      sym_typed_binding,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [640377] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13295), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13293), 11,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [640403] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13339), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13337), 11,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [640429] = 14,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(14364), 1,
      anon_sym_where,
    ACTIONS(14366), 1,
      anon_sym_LPAREN,
    ACTIONS(14368), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(14370), 1,
      anon_sym_u2983,
    ACTIONS(14372), 1,
      anon_sym_LBRACE,
    ACTIONS(14374), 1,
      anon_sym_DOT,
    ACTIONS(14376), 1,
      anon_sym_DOT_DOT,
    STATE(7859), 1,
      sym_bid,
    STATE(8346), 1,
      aux_sym__lambda_bindings_repeat1,
    STATE(8653), 1,
      sym__lambda_bindings,
    ACTIONS(14362), 2,
      anon_sym__,
      sym_id,
    STATE(7885), 3,
      sym_typed_binding,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [640475] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13287), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13285), 11,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [640501] = 14,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(14380), 1,
      anon_sym_where,
    ACTIONS(14382), 1,
      anon_sym_LPAREN,
    ACTIONS(14384), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(14386), 1,
      anon_sym_u2983,
    ACTIONS(14388), 1,
      anon_sym_LBRACE,
    ACTIONS(14390), 1,
      anon_sym_DOT,
    ACTIONS(14392), 1,
      anon_sym_DOT_DOT,
    STATE(8449), 1,
      aux_sym__lambda_bindings_repeat1,
    STATE(8557), 1,
      sym_bid,
    STATE(9263), 1,
      sym__lambda_bindings,
    ACTIONS(14378), 2,
      anon_sym__,
      sym_id,
    STATE(8539), 3,
      sym_typed_binding,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [640547] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13250), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13248), 11,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [640573] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13291), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13289), 11,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [640599] = 14,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13854), 1,
      anon_sym_LPAREN,
    ACTIONS(13856), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(13858), 1,
      anon_sym_u2983,
    ACTIONS(13860), 1,
      anon_sym_LBRACE,
    ACTIONS(13862), 1,
      anon_sym_DOT,
    ACTIONS(13864), 1,
      anon_sym_DOT_DOT,
    ACTIONS(14394), 1,
      anon_sym_EQ,
    STATE(8304), 1,
      aux_sym__lambda_bindings_repeat1,
    STATE(8980), 1,
      sym_bid,
    STATE(10661), 1,
      sym__lambda_bindings,
    ACTIONS(13850), 2,
      anon_sym__,
      sym_id,
    STATE(8962), 3,
      sym_typed_binding,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [640645] = 14,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(14398), 1,
      anon_sym_where,
    ACTIONS(14400), 1,
      anon_sym_LPAREN,
    ACTIONS(14402), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(14404), 1,
      anon_sym_u2983,
    ACTIONS(14406), 1,
      anon_sym_LBRACE,
    ACTIONS(14408), 1,
      anon_sym_DOT,
    ACTIONS(14410), 1,
      anon_sym_DOT_DOT,
    STATE(8328), 1,
      sym_bid,
    STATE(8370), 1,
      aux_sym__lambda_bindings_repeat1,
    STATE(9178), 1,
      sym__lambda_bindings,
    ACTIONS(14396), 2,
      anon_sym__,
      sym_id,
    STATE(8362), 3,
      sym_typed_binding,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [640691] = 14,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13620), 1,
      anon_sym_LPAREN,
    ACTIONS(13622), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(13624), 1,
      anon_sym_u2983,
    ACTIONS(13626), 1,
      anon_sym_LBRACE,
    ACTIONS(13628), 1,
      anon_sym_DOT,
    ACTIONS(13630), 1,
      anon_sym_DOT_DOT,
    ACTIONS(14412), 1,
      anon_sym_where,
    STATE(8118), 1,
      sym_bid,
    STATE(8299), 1,
      aux_sym__lambda_bindings_repeat1,
    STATE(9071), 1,
      sym__lambda_bindings,
    ACTIONS(13616), 2,
      anon_sym__,
      sym_id,
    STATE(8060), 3,
      sym_typed_binding,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [640737] = 13,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13351), 1,
      anon_sym_LPAREN,
    ACTIONS(13353), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(13355), 1,
      anon_sym_u2983,
    ACTIONS(13357), 1,
      anon_sym_LBRACE,
    ACTIONS(13359), 1,
      anon_sym_DOT,
    ACTIONS(13361), 1,
      anon_sym_DOT_DOT,
    ACTIONS(13942), 1,
      anon_sym_where,
    ACTIONS(14414), 1,
      anon_sym_COLON,
    STATE(8871), 1,
      sym_bid,
    ACTIONS(13345), 2,
      anon_sym__,
      sym_id,
    STATE(8112), 4,
      sym_typed_binding,
      aux_sym__typed_untyped_bindings,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [640781] = 13,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13976), 1,
      anon_sym_where,
    ACTIONS(13978), 1,
      anon_sym_LPAREN,
    ACTIONS(13980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(13982), 1,
      anon_sym_u2983,
    ACTIONS(13984), 1,
      anon_sym_LBRACE,
    ACTIONS(13986), 1,
      anon_sym_DOT,
    ACTIONS(13988), 1,
      anon_sym_DOT_DOT,
    ACTIONS(14416), 1,
      anon_sym_EQ,
    STATE(8885), 1,
      sym_bid,
    ACTIONS(13972), 2,
      anon_sym__,
      sym_id,
    STATE(8115), 4,
      sym_typed_binding,
      aux_sym__typed_untyped_bindings,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [640825] = 14,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(14420), 1,
      anon_sym_where,
    ACTIONS(14422), 1,
      anon_sym_LPAREN,
    ACTIONS(14424), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(14426), 1,
      anon_sym_u2983,
    ACTIONS(14428), 1,
      anon_sym_LBRACE,
    ACTIONS(14430), 1,
      anon_sym_DOT,
    ACTIONS(14432), 1,
      anon_sym_DOT_DOT,
    STATE(8310), 1,
      sym_bid,
    STATE(8494), 1,
      aux_sym__lambda_bindings_repeat1,
    STATE(9154), 1,
      sym__lambda_bindings,
    ACTIONS(14418), 2,
      anon_sym__,
      sym_id,
    STATE(8337), 3,
      sym_typed_binding,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [640871] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13343), 5,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13341), 9,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [640896] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13250), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13248), 11,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [640921] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13295), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13293), 11,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [640946] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13299), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13297), 10,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [640971] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13291), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13289), 11,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [640996] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13303), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13301), 11,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [641021] = 12,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13862), 1,
      anon_sym_DOT,
    ACTIONS(13864), 1,
      anon_sym_DOT_DOT,
    ACTIONS(14434), 1,
      anon_sym_EQ,
    ACTIONS(14436), 1,
      anon_sym_LPAREN,
    ACTIONS(14438), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(14440), 1,
      anon_sym_u2983,
    ACTIONS(14442), 1,
      anon_sym_LBRACE,
    STATE(8980), 1,
      sym_bid,
    ACTIONS(13850), 2,
      anon_sym__,
      sym_id,
    STATE(8200), 4,
      sym_typed_binding,
      aux_sym__typed_untyped_bindings,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [641062] = 12,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13596), 1,
      anon_sym_where,
    ACTIONS(14447), 1,
      anon_sym_LPAREN,
    ACTIONS(14450), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(14453), 1,
      anon_sym_u2983,
    ACTIONS(14456), 1,
      anon_sym_LBRACE,
    ACTIONS(14459), 1,
      anon_sym_DOT,
    ACTIONS(14462), 1,
      anon_sym_DOT_DOT,
    STATE(8960), 1,
      sym_bid,
    ACTIONS(14444), 2,
      anon_sym__,
      sym_id,
    STATE(8164), 4,
      sym_typed_binding,
      aux_sym__typed_untyped_bindings,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [641103] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13254), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13252), 11,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [641128] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13343), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13341), 11,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [641153] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13339), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13337), 11,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [641178] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13287), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13285), 11,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [641203] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13287), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13285), 10,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
      anon_sym_in,
  [641228] = 6,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13331), 1,
      sym__newline,
    ACTIONS(13329), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13325), 5,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
    ACTIONS(13327), 5,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_SEMI,
  [641257] = 6,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13335), 1,
      sym__newline,
    ACTIONS(13329), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13325), 5,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
    ACTIONS(13333), 5,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_SEMI,
  [641286] = 6,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13331), 1,
      sym__newline,
    ACTIONS(13329), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13325), 5,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
    ACTIONS(13327), 5,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_in,
  [641315] = 6,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13331), 1,
      sym__newline,
    ACTIONS(13329), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13325), 5,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
    ACTIONS(13327), 5,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_in,
  [641344] = 6,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13335), 1,
      sym__newline,
    ACTIONS(13329), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13325), 5,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
    ACTIONS(13333), 5,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_in,
  [641373] = 12,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13862), 1,
      anon_sym_DOT,
    ACTIONS(13864), 1,
      anon_sym_DOT_DOT,
    ACTIONS(14436), 1,
      anon_sym_LPAREN,
    ACTIONS(14438), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(14440), 1,
      anon_sym_u2983,
    ACTIONS(14442), 1,
      anon_sym_LBRACE,
    ACTIONS(14465), 1,
      anon_sym_EQ,
    STATE(8980), 1,
      sym_bid,
    ACTIONS(13850), 2,
      anon_sym__,
      sym_id,
    STATE(8192), 4,
      sym_typed_binding,
      aux_sym__typed_untyped_bindings,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [641414] = 5,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13329), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13325), 5,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
    ACTIONS(13327), 6,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_u2984,
  [641441] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13339), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13337), 10,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
      anon_sym_in,
  [641466] = 5,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13329), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13325), 5,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
    ACTIONS(13333), 6,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_u2984,
  [641493] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13299), 5,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13297), 9,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [641518] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13295), 5,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13293), 9,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [641543] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13250), 5,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13248), 9,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [641568] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13343), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13341), 10,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
      anon_sym_in,
  [641593] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13303), 5,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13301), 9,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [641618] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13254), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13252), 10,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
      anon_sym_in,
  [641643] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13291), 5,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13289), 9,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [641668] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13339), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13337), 10,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
      anon_sym_in,
  [641693] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13343), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13341), 10,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
      anon_sym_in,
  [641718] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13254), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13252), 10,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
      anon_sym_in,
  [641743] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13254), 5,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13252), 9,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [641768] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13299), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13297), 11,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [641793] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13343), 5,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13341), 9,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [641818] = 12,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13862), 1,
      anon_sym_DOT,
    ACTIONS(13864), 1,
      anon_sym_DOT_DOT,
    ACTIONS(14436), 1,
      anon_sym_LPAREN,
    ACTIONS(14438), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(14440), 1,
      anon_sym_u2983,
    ACTIONS(14442), 1,
      anon_sym_LBRACE,
    ACTIONS(14467), 1,
      anon_sym_EQ,
    STATE(8980), 1,
      sym_bid,
    ACTIONS(13850), 2,
      anon_sym__,
      sym_id,
    STATE(8200), 4,
      sym_typed_binding,
      aux_sym__typed_untyped_bindings,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [641859] = 12,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13862), 1,
      anon_sym_DOT,
    ACTIONS(13864), 1,
      anon_sym_DOT_DOT,
    ACTIONS(14436), 1,
      anon_sym_LPAREN,
    ACTIONS(14438), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(14440), 1,
      anon_sym_u2983,
    ACTIONS(14442), 1,
      anon_sym_LBRACE,
    ACTIONS(14469), 1,
      anon_sym_EQ,
    STATE(8980), 1,
      sym_bid,
    ACTIONS(13850), 2,
      anon_sym__,
      sym_id,
    STATE(8163), 4,
      sym_typed_binding,
      aux_sym__typed_untyped_bindings,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [641900] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13339), 5,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13337), 9,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [641925] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13291), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13289), 10,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
      anon_sym_in,
  [641950] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13287), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13285), 10,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [641975] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13287), 5,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13285), 9,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [642000] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13303), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13301), 10,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
      anon_sym_in,
  [642025] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13339), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13337), 10,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [642050] = 12,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13596), 1,
      anon_sym_EQ,
    ACTIONS(14474), 1,
      anon_sym_LPAREN,
    ACTIONS(14477), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(14480), 1,
      anon_sym_u2983,
    ACTIONS(14483), 1,
      anon_sym_LBRACE,
    ACTIONS(14486), 1,
      anon_sym_DOT,
    ACTIONS(14489), 1,
      anon_sym_DOT_DOT,
    STATE(8980), 1,
      sym_bid,
    ACTIONS(14471), 2,
      anon_sym__,
      sym_id,
    STATE(8200), 4,
      sym_typed_binding,
      aux_sym__typed_untyped_bindings,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [642091] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13250), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13248), 10,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
      anon_sym_in,
  [642116] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13295), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13293), 10,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
      anon_sym_in,
  [642141] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13254), 5,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13252), 9,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [642166] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13299), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13297), 10,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [642191] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13299), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13297), 10,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
      anon_sym_in,
  [642216] = 12,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(14148), 1,
      anon_sym_where,
    ACTIONS(14494), 1,
      anon_sym_LPAREN,
    ACTIONS(14496), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(14498), 1,
      anon_sym_u2983,
    ACTIONS(14500), 1,
      anon_sym_LBRACE,
    ACTIONS(14502), 1,
      anon_sym_DOT,
    ACTIONS(14504), 1,
      anon_sym_DOT_DOT,
    STATE(8960), 1,
      sym_bid,
    ACTIONS(14492), 2,
      anon_sym__,
      sym_id,
    STATE(8164), 4,
      sym_typed_binding,
      aux_sym__typed_untyped_bindings,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [642257] = 6,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13335), 2,
      anon_sym_RPAREN,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(13329), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13333), 4,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
    ACTIONS(13325), 5,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [642286] = 6,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13331), 2,
      anon_sym_RPAREN,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(13329), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13327), 4,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
    ACTIONS(13325), 5,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [642315] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13287), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13285), 10,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
      anon_sym_in,
  [642340] = 6,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13335), 1,
      anon_sym_RBRACE,
    ACTIONS(13329), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13325), 5,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
    ACTIONS(13333), 5,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_SEMI,
  [642369] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13295), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13293), 10,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [642394] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13250), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13248), 10,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [642419] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13303), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13301), 10,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [642444] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13291), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13289), 10,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [642469] = 6,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13331), 1,
      anon_sym_RBRACE,
    ACTIONS(13329), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13325), 5,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
    ACTIONS(13327), 5,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_SEMI,
  [642498] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13299), 5,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13297), 9,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [642523] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13254), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13252), 10,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [642548] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13343), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13341), 10,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [642573] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13339), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13337), 10,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [642598] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13287), 5,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13285), 9,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [642623] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13339), 5,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13337), 9,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [642648] = 12,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13305), 1,
      sym_id,
    ACTIONS(13311), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(13313), 1,
      anon_sym_u2983,
    ACTIONS(13315), 1,
      anon_sym_LBRACE,
    ACTIONS(13317), 1,
      anon_sym_DOT,
    ACTIONS(13319), 1,
      anon_sym_DOT_DOT,
    ACTIONS(13321), 1,
      anon_sym_AT,
    STATE(12445), 1,
      sym__modal_arg_ids,
    STATE(8445), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8658), 4,
      sym__field_name,
      sym__maybe_dotted_id,
      aux_sym__arg_ids,
      sym__arg_id,
  [642689] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13287), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13285), 10,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [642714] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13291), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13289), 10,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
      anon_sym_in,
  [642739] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13343), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13341), 10,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [642764] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13287), 4,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13285), 10,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [642789] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13295), 5,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13293), 9,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [642814] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13303), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13301), 10,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
      anon_sym_in,
  [642839] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13250), 5,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13248), 9,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [642864] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13303), 5,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13301), 9,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [642889] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13291), 5,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13289), 9,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [642914] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13291), 5,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13289), 9,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [642939] = 6,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13331), 2,
      anon_sym_RPAREN,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(13329), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13327), 4,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_SEMI,
    ACTIONS(13325), 5,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [642968] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13303), 5,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13301), 9,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [642993] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13250), 5,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13248), 9,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [643018] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13254), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13252), 10,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [643043] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13295), 5,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13293), 9,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [643068] = 6,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13335), 2,
      anon_sym_RPAREN,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(13329), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13333), 4,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_SEMI,
    ACTIONS(13325), 5,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [643097] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13299), 5,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13297), 9,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [643122] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13250), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13248), 10,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
      anon_sym_in,
  [643147] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13295), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13293), 10,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
      anon_sym_in,
  [643172] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13299), 4,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13297), 10,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [643197] = 6,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13335), 2,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
    ACTIONS(13329), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13333), 4,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_SEMI,
    ACTIONS(13325), 5,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [643226] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13254), 5,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13252), 9,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [643251] = 6,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13331), 2,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
    ACTIONS(13329), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13327), 4,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_SEMI,
    ACTIONS(13325), 5,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [643280] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13291), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13289), 10,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [643305] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13303), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13301), 10,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [643330] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13250), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13248), 10,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [643355] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13295), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13293), 10,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [643380] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13343), 5,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13341), 9,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [643405] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13339), 5,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13337), 9,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [643430] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13299), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13297), 10,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
      anon_sym_in,
  [643455] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13295), 4,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13293), 10,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [643480] = 6,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13335), 1,
      sym__newline,
    ACTIONS(13329), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13325), 5,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
    ACTIONS(13333), 5,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
  [643509] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13250), 4,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13248), 10,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [643534] = 6,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13335), 1,
      sym__newline,
    ACTIONS(13329), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13325), 5,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
    ACTIONS(13333), 5,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_in,
  [643563] = 12,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13976), 1,
      anon_sym_where,
    ACTIONS(14494), 1,
      anon_sym_LPAREN,
    ACTIONS(14496), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(14498), 1,
      anon_sym_u2983,
    ACTIONS(14500), 1,
      anon_sym_LBRACE,
    ACTIONS(14502), 1,
      anon_sym_DOT,
    ACTIONS(14504), 1,
      anon_sym_DOT_DOT,
    STATE(8960), 1,
      sym_bid,
    ACTIONS(14492), 2,
      anon_sym__,
      sym_id,
    STATE(8206), 4,
      sym_typed_binding,
      aux_sym__typed_untyped_bindings,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [643604] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13303), 4,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13301), 10,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [643629] = 6,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13331), 1,
      sym__newline,
    ACTIONS(13329), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13325), 5,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
    ACTIONS(13327), 5,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
  [643658] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13291), 4,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13289), 10,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [643683] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13287), 5,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13285), 9,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [643708] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13254), 4,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13252), 10,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [643733] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13343), 4,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13341), 10,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [643758] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13339), 4,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13337), 10,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [643783] = 12,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13587), 1,
      anon_sym_DOT,
    ACTIONS(13589), 1,
      anon_sym_DOT_DOT,
    ACTIONS(14506), 1,
      anon_sym_LPAREN,
    ACTIONS(14508), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(14510), 1,
      anon_sym_u2983,
    ACTIONS(14512), 1,
      anon_sym_LBRACE,
    STATE(8376), 1,
      aux_sym__lambda_bindings_repeat1,
    STATE(8436), 1,
      sym_bid,
    ACTIONS(13575), 2,
      anon_sym__,
      sym_id,
    STATE(8394), 3,
      sym_typed_binding,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [643823] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13299), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13297), 10,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [643847] = 12,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13708), 1,
      anon_sym_DOT,
    ACTIONS(13710), 1,
      anon_sym_DOT_DOT,
    ACTIONS(14514), 1,
      anon_sym_LPAREN,
    ACTIONS(14516), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(14518), 1,
      anon_sym_u2983,
    ACTIONS(14520), 1,
      anon_sym_LBRACE,
    STATE(8376), 1,
      aux_sym__lambda_bindings_repeat1,
    STATE(8500), 1,
      sym_bid,
    ACTIONS(13696), 2,
      anon_sym__,
      sym_id,
    STATE(8479), 3,
      sym_typed_binding,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [643887] = 11,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13367), 1,
      anon_sym_LPAREN,
    ACTIONS(13369), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(13371), 1,
      anon_sym_u2983,
    ACTIONS(13373), 1,
      anon_sym_LBRACE,
    ACTIONS(13375), 1,
      anon_sym_DOT,
    ACTIONS(13377), 1,
      anon_sym_DOT_DOT,
    STATE(8750), 1,
      sym_bid,
    ACTIONS(13363), 2,
      anon_sym__,
      sym_id,
    STATE(7974), 4,
      sym_typed_binding,
      aux_sym__typed_untyped_bindings,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [643925] = 12,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13910), 1,
      anon_sym_DOT,
    ACTIONS(13912), 1,
      anon_sym_DOT_DOT,
    ACTIONS(14522), 1,
      anon_sym_LPAREN,
    ACTIONS(14524), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(14526), 1,
      anon_sym_u2983,
    ACTIONS(14528), 1,
      anon_sym_LBRACE,
    STATE(8376), 1,
      aux_sym__lambda_bindings_repeat1,
    STATE(8400), 1,
      sym_bid,
    ACTIONS(13898), 2,
      anon_sym__,
      sym_id,
    STATE(8480), 3,
      sym_typed_binding,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [643965] = 12,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(14292), 1,
      anon_sym_DOT,
    ACTIONS(14294), 1,
      anon_sym_DOT_DOT,
    ACTIONS(14530), 1,
      anon_sym_LPAREN,
    ACTIONS(14532), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(14534), 1,
      anon_sym_u2983,
    ACTIONS(14536), 1,
      anon_sym_LBRACE,
    STATE(7886), 1,
      sym_bid,
    STATE(8376), 1,
      aux_sym__lambda_bindings_repeat1,
    ACTIONS(14280), 2,
      anon_sym__,
      sym_id,
    STATE(7890), 3,
      sym_typed_binding,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [644005] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13299), 5,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13297), 8,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [644029] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13299), 4,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13297), 9,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [644053] = 12,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(14020), 1,
      anon_sym_DOT,
    ACTIONS(14022), 1,
      anon_sym_DOT_DOT,
    ACTIONS(14538), 1,
      anon_sym_LPAREN,
    ACTIONS(14540), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(14542), 1,
      anon_sym_u2983,
    ACTIONS(14544), 1,
      anon_sym_LBRACE,
    STATE(8226), 1,
      sym_bid,
    STATE(8376), 1,
      aux_sym__lambda_bindings_repeat1,
    ACTIONS(14008), 2,
      anon_sym__,
      sym_id,
    STATE(8215), 3,
      sym_typed_binding,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [644093] = 12,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(14106), 1,
      anon_sym_DOT,
    ACTIONS(14108), 1,
      anon_sym_DOT_DOT,
    ACTIONS(14546), 1,
      anon_sym_LPAREN,
    ACTIONS(14548), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(14550), 1,
      anon_sym_u2983,
    ACTIONS(14552), 1,
      anon_sym_LBRACE,
    STATE(8376), 1,
      aux_sym__lambda_bindings_repeat1,
    STATE(8580), 1,
      sym_bid,
    ACTIONS(14094), 2,
      anon_sym__,
      sym_id,
    STATE(8561), 3,
      sym_typed_binding,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [644133] = 11,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13367), 1,
      anon_sym_LPAREN,
    ACTIONS(13369), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(13371), 1,
      anon_sym_u2983,
    ACTIONS(13373), 1,
      anon_sym_LBRACE,
    ACTIONS(13375), 1,
      anon_sym_DOT,
    ACTIONS(13377), 1,
      anon_sym_DOT_DOT,
    STATE(8750), 1,
      sym_bid,
    ACTIONS(13363), 2,
      anon_sym__,
      sym_id,
    STATE(8007), 4,
      sym_typed_binding,
      aux_sym__typed_untyped_bindings,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [644171] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13295), 4,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13293), 9,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [644195] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13299), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13297), 9,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [644219] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13295), 5,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13293), 8,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [644243] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13250), 5,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13248), 8,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [644267] = 12,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(14036), 1,
      anon_sym_DOT,
    ACTIONS(14038), 1,
      anon_sym_DOT_DOT,
    ACTIONS(14554), 1,
      anon_sym_LPAREN,
    ACTIONS(14556), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(14558), 1,
      anon_sym_u2983,
    ACTIONS(14560), 1,
      anon_sym_LBRACE,
    STATE(8169), 1,
      sym_bid,
    STATE(8376), 1,
      aux_sym__lambda_bindings_repeat1,
    ACTIONS(14024), 2,
      anon_sym__,
      sym_id,
    STATE(8172), 3,
      sym_typed_binding,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [644307] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13250), 4,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13248), 9,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [644331] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13303), 5,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13301), 8,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [644355] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13303), 4,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13301), 9,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [644379] = 12,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13676), 1,
      anon_sym_DOT,
    ACTIONS(13678), 1,
      anon_sym_DOT_DOT,
    ACTIONS(14562), 1,
      anon_sym_LPAREN,
    ACTIONS(14564), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(14566), 1,
      anon_sym_u2983,
    ACTIONS(14568), 1,
      anon_sym_LBRACE,
    STATE(8168), 1,
      sym_bid,
    STATE(8376), 1,
      aux_sym__lambda_bindings_repeat1,
    ACTIONS(13664), 2,
      anon_sym__,
      sym_id,
    STATE(8176), 3,
      sym_typed_binding,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [644419] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13291), 5,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13289), 8,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [644443] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13291), 4,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13289), 9,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [644467] = 12,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(14178), 1,
      anon_sym_DOT,
    ACTIONS(14180), 1,
      anon_sym_DOT_DOT,
    ACTIONS(14570), 1,
      anon_sym_LPAREN,
    ACTIONS(14572), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(14574), 1,
      anon_sym_u2983,
    ACTIONS(14576), 1,
      anon_sym_LBRACE,
    STATE(7935), 1,
      sym_bid,
    STATE(8376), 1,
      aux_sym__lambda_bindings_repeat1,
    ACTIONS(14166), 2,
      anon_sym__,
      sym_id,
    STATE(7922), 3,
      sym_typed_binding,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [644507] = 11,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13367), 1,
      anon_sym_LPAREN,
    ACTIONS(13369), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(13371), 1,
      anon_sym_u2983,
    ACTIONS(13373), 1,
      anon_sym_LBRACE,
    ACTIONS(13375), 1,
      anon_sym_DOT,
    ACTIONS(13377), 1,
      anon_sym_DOT_DOT,
    STATE(8750), 1,
      sym_bid,
    ACTIONS(13363), 2,
      anon_sym__,
      sym_id,
    STATE(8016), 4,
      sym_typed_binding,
      aux_sym__typed_untyped_bindings,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [644545] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13339), 5,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13337), 8,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [644569] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13295), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13293), 9,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [644593] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13250), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13248), 9,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [644617] = 12,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13660), 1,
      anon_sym_DOT,
    ACTIONS(13662), 1,
      anon_sym_DOT_DOT,
    ACTIONS(14578), 1,
      anon_sym_LPAREN,
    ACTIONS(14580), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(14582), 1,
      anon_sym_u2983,
    ACTIONS(14584), 1,
      anon_sym_LBRACE,
    STATE(8196), 1,
      sym_bid,
    STATE(8376), 1,
      aux_sym__lambda_bindings_repeat1,
    ACTIONS(13648), 2,
      anon_sym__,
      sym_id,
    STATE(8170), 3,
      sym_typed_binding,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [644657] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13254), 5,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13252), 8,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [644681] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13303), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13301), 9,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [644705] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13343), 5,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13341), 8,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [644729] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13291), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13289), 9,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [644753] = 6,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13335), 2,
      anon_sym_RPAREN,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(13329), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13333), 3,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
    ACTIONS(13325), 5,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [644781] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13287), 5,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13285), 8,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [644805] = 12,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13628), 1,
      anon_sym_DOT,
    ACTIONS(13630), 1,
      anon_sym_DOT_DOT,
    ACTIONS(14586), 1,
      anon_sym_LPAREN,
    ACTIONS(14588), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(14590), 1,
      anon_sym_u2983,
    ACTIONS(14592), 1,
      anon_sym_LBRACE,
    STATE(8118), 1,
      sym_bid,
    STATE(8376), 1,
      aux_sym__lambda_bindings_repeat1,
    ACTIONS(13616), 2,
      anon_sym__,
      sym_id,
    STATE(8059), 3,
      sym_typed_binding,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [644845] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13299), 4,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13297), 9,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [644869] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13254), 4,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13252), 9,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [644893] = 11,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13367), 1,
      anon_sym_LPAREN,
    ACTIONS(13369), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(13371), 1,
      anon_sym_u2983,
    ACTIONS(13373), 1,
      anon_sym_LBRACE,
    ACTIONS(13375), 1,
      anon_sym_DOT,
    ACTIONS(13377), 1,
      anon_sym_DOT_DOT,
    STATE(8750), 1,
      sym_bid,
    ACTIONS(13363), 2,
      anon_sym__,
      sym_id,
    STATE(7999), 4,
      sym_typed_binding,
      aux_sym__typed_untyped_bindings,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [644931] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13254), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13252), 9,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [644955] = 12,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13862), 1,
      anon_sym_DOT,
    ACTIONS(13864), 1,
      anon_sym_DOT_DOT,
    ACTIONS(14594), 1,
      anon_sym_LPAREN,
    ACTIONS(14596), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(14598), 1,
      anon_sym_u2983,
    ACTIONS(14600), 1,
      anon_sym_LBRACE,
    STATE(8376), 1,
      aux_sym__lambda_bindings_repeat1,
    STATE(8980), 1,
      sym_bid,
    ACTIONS(13850), 2,
      anon_sym__,
      sym_id,
    STATE(8965), 3,
      sym_typed_binding,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [644995] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13343), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13341), 9,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [645019] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13343), 4,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13341), 9,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [645043] = 12,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13936), 1,
      anon_sym_DOT,
    ACTIONS(13938), 1,
      anon_sym_DOT_DOT,
    ACTIONS(14602), 1,
      anon_sym_LPAREN,
    ACTIONS(14604), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(14606), 1,
      anon_sym_u2983,
    ACTIONS(14608), 1,
      anon_sym_LBRACE,
    STATE(8376), 1,
      aux_sym__lambda_bindings_repeat1,
    STATE(8538), 1,
      sym_bid,
    ACTIONS(13924), 2,
      anon_sym__,
      sym_id,
    STATE(8540), 3,
      sym_typed_binding,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [645083] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13339), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13337), 9,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [645107] = 12,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(14242), 1,
      anon_sym_DOT,
    ACTIONS(14244), 1,
      anon_sym_DOT_DOT,
    ACTIONS(14610), 1,
      anon_sym_LPAREN,
    ACTIONS(14612), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(14614), 1,
      anon_sym_u2983,
    ACTIONS(14616), 1,
      anon_sym_LBRACE,
    STATE(8376), 1,
      aux_sym__lambda_bindings_repeat1,
    STATE(8524), 1,
      sym_bid,
    ACTIONS(14230), 2,
      anon_sym__,
      sym_id,
    STATE(8532), 3,
      sym_typed_binding,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [645147] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13287), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13285), 9,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [645171] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13299), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13297), 10,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [645195] = 12,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13555), 1,
      anon_sym_DOT,
    ACTIONS(13557), 1,
      anon_sym_DOT_DOT,
    ACTIONS(14618), 1,
      anon_sym_LPAREN,
    ACTIONS(14620), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(14622), 1,
      anon_sym_u2983,
    ACTIONS(14624), 1,
      anon_sym_LBRACE,
    STATE(7913), 1,
      sym_bid,
    STATE(8376), 1,
      aux_sym__lambda_bindings_repeat1,
    ACTIONS(13543), 2,
      anon_sym__,
      sym_id,
    STATE(7906), 3,
      sym_typed_binding,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [645235] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13295), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13293), 10,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [645259] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13250), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13248), 10,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [645283] = 11,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13367), 1,
      anon_sym_LPAREN,
    ACTIONS(13369), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(13371), 1,
      anon_sym_u2983,
    ACTIONS(13373), 1,
      anon_sym_LBRACE,
    ACTIONS(13375), 1,
      anon_sym_DOT,
    ACTIONS(13377), 1,
      anon_sym_DOT_DOT,
    STATE(8750), 1,
      sym_bid,
    ACTIONS(13363), 2,
      anon_sym__,
      sym_id,
    STATE(7977), 4,
      sym_typed_binding,
      aux_sym__typed_untyped_bindings,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [645321] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13303), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13301), 10,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [645345] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13339), 4,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13337), 9,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [645369] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13291), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13289), 10,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [645393] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13287), 4,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13285), 9,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [645417] = 12,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13777), 1,
      anon_sym_DOT,
    ACTIONS(13779), 1,
      anon_sym_DOT_DOT,
    ACTIONS(14626), 1,
      anon_sym_LPAREN,
    ACTIONS(14628), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(14630), 1,
      anon_sym_u2983,
    ACTIONS(14632), 1,
      anon_sym_LBRACE,
    STATE(8261), 1,
      sym_bid,
    STATE(8376), 1,
      aux_sym__lambda_bindings_repeat1,
    ACTIONS(13765), 2,
      anon_sym__,
      sym_id,
    STATE(8245), 3,
      sym_typed_binding,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [645457] = 11,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13367), 1,
      anon_sym_LPAREN,
    ACTIONS(13369), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(13371), 1,
      anon_sym_u2983,
    ACTIONS(13373), 1,
      anon_sym_LBRACE,
    ACTIONS(13375), 1,
      anon_sym_DOT,
    ACTIONS(13377), 1,
      anon_sym_DOT_DOT,
    STATE(8750), 1,
      sym_bid,
    ACTIONS(13363), 2,
      anon_sym__,
      sym_id,
    STATE(7975), 4,
      sym_typed_binding,
      aux_sym__typed_untyped_bindings,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [645495] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13254), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13252), 10,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [645519] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13343), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13341), 10,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [645543] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13295), 4,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13293), 9,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [645567] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13339), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13337), 10,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [645591] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13250), 4,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13248), 9,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [645615] = 12,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(14142), 1,
      anon_sym_DOT,
    ACTIONS(14144), 1,
      anon_sym_DOT_DOT,
    ACTIONS(14634), 1,
      anon_sym_LPAREN,
    ACTIONS(14636), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(14638), 1,
      anon_sym_u2983,
    ACTIONS(14640), 1,
      anon_sym_LBRACE,
    STATE(7914), 1,
      sym_bid,
    STATE(8376), 1,
      aux_sym__lambda_bindings_repeat1,
    ACTIONS(14130), 2,
      anon_sym__,
      sym_id,
    STATE(7897), 3,
      sym_typed_binding,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [645655] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13287), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13285), 10,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [645679] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13303), 4,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13301), 9,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [645703] = 12,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13956), 1,
      anon_sym_DOT,
    ACTIONS(13958), 1,
      anon_sym_DOT_DOT,
    ACTIONS(14642), 1,
      anon_sym_LPAREN,
    ACTIONS(14644), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(14646), 1,
      anon_sym_u2983,
    ACTIONS(14648), 1,
      anon_sym_LBRACE,
    STATE(8022), 1,
      sym_bid,
    STATE(8376), 1,
      aux_sym__lambda_bindings_repeat1,
    ACTIONS(13944), 2,
      anon_sym__,
      sym_id,
    STATE(7989), 3,
      sym_typed_binding,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [645743] = 6,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13331), 2,
      anon_sym_RPAREN,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(13327), 3,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
    ACTIONS(13329), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13325), 5,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [645771] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13291), 4,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13289), 9,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [645795] = 12,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13740), 1,
      anon_sym_DOT,
    ACTIONS(13742), 1,
      anon_sym_DOT_DOT,
    ACTIONS(14650), 1,
      anon_sym_LPAREN,
    ACTIONS(14652), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(14654), 1,
      anon_sym_u2983,
    ACTIONS(14656), 1,
      anon_sym_LBRACE,
    STATE(8376), 1,
      aux_sym__lambda_bindings_repeat1,
    STATE(8568), 1,
      sym_bid,
    ACTIONS(13728), 2,
      anon_sym__,
      sym_id,
    STATE(8552), 3,
      sym_typed_binding,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [645835] = 11,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13367), 1,
      anon_sym_LPAREN,
    ACTIONS(13369), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(13371), 1,
      anon_sym_u2983,
    ACTIONS(13373), 1,
      anon_sym_LBRACE,
    ACTIONS(13375), 1,
      anon_sym_DOT,
    ACTIONS(13377), 1,
      anon_sym_DOT_DOT,
    STATE(8750), 1,
      sym_bid,
    ACTIONS(13363), 2,
      anon_sym__,
      sym_id,
    STATE(7982), 4,
      sym_typed_binding,
      aux_sym__typed_untyped_bindings,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [645873] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13254), 4,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13252), 9,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [645897] = 6,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13331), 1,
      sym__newline,
    ACTIONS(13329), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13327), 4,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_where,
    ACTIONS(13325), 5,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [645925] = 6,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13335), 1,
      sym__newline,
    ACTIONS(13329), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13333), 4,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_where,
    ACTIONS(13325), 5,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [645953] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13343), 4,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13341), 9,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [645977] = 12,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13878), 1,
      anon_sym_DOT,
    ACTIONS(13880), 1,
      anon_sym_DOT_DOT,
    ACTIONS(14658), 1,
      anon_sym_LPAREN,
    ACTIONS(14660), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(14662), 1,
      anon_sym_u2983,
    ACTIONS(14664), 1,
      anon_sym_LBRACE,
    STATE(8376), 1,
      aux_sym__lambda_bindings_repeat1,
    STATE(8515), 1,
      sym_bid,
    ACTIONS(13866), 2,
      anon_sym__,
      sym_id,
    STATE(8499), 3,
      sym_typed_binding,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [646017] = 12,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(14002), 1,
      anon_sym_DOT,
    ACTIONS(14004), 1,
      anon_sym_DOT_DOT,
    ACTIONS(14666), 1,
      anon_sym_LPAREN,
    ACTIONS(14668), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(14670), 1,
      anon_sym_u2983,
    ACTIONS(14672), 1,
      anon_sym_LBRACE,
    STATE(8376), 1,
      aux_sym__lambda_bindings_repeat1,
    STATE(8573), 1,
      sym_bid,
    ACTIONS(13990), 2,
      anon_sym__,
      sym_id,
    STATE(8555), 3,
      sym_typed_binding,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [646057] = 12,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(14210), 1,
      anon_sym_DOT,
    ACTIONS(14212), 1,
      anon_sym_DOT_DOT,
    ACTIONS(14674), 1,
      anon_sym_LPAREN,
    ACTIONS(14676), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(14678), 1,
      anon_sym_u2983,
    ACTIONS(14680), 1,
      anon_sym_LBRACE,
    STATE(8050), 1,
      sym_bid,
    STATE(8376), 1,
      aux_sym__lambda_bindings_repeat1,
    ACTIONS(14198), 2,
      anon_sym__,
      sym_id,
    STATE(8071), 3,
      sym_typed_binding,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [646097] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13339), 4,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13337), 9,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [646121] = 11,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13367), 1,
      anon_sym_LPAREN,
    ACTIONS(13369), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(13371), 1,
      anon_sym_u2983,
    ACTIONS(13373), 1,
      anon_sym_LBRACE,
    ACTIONS(13375), 1,
      anon_sym_DOT,
    ACTIONS(13377), 1,
      anon_sym_DOT_DOT,
    STATE(8750), 1,
      sym_bid,
    ACTIONS(13363), 2,
      anon_sym__,
      sym_id,
    STATE(8029), 4,
      sym_typed_binding,
      aux_sym__typed_untyped_bindings,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [646159] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13287), 4,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13285), 9,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [646183] = 11,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13367), 1,
      anon_sym_LPAREN,
    ACTIONS(13369), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(13371), 1,
      anon_sym_u2983,
    ACTIONS(13373), 1,
      anon_sym_LBRACE,
    ACTIONS(13375), 1,
      anon_sym_DOT,
    ACTIONS(13377), 1,
      anon_sym_DOT_DOT,
    STATE(8750), 1,
      sym_bid,
    ACTIONS(13363), 2,
      anon_sym__,
      sym_id,
    STATE(7985), 4,
      sym_typed_binding,
      aux_sym__typed_untyped_bindings,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [646221] = 12,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(14374), 1,
      anon_sym_DOT,
    ACTIONS(14376), 1,
      anon_sym_DOT_DOT,
    ACTIONS(14682), 1,
      anon_sym_LPAREN,
    ACTIONS(14684), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(14686), 1,
      anon_sym_u2983,
    ACTIONS(14688), 1,
      anon_sym_LBRACE,
    STATE(7859), 1,
      sym_bid,
    STATE(8376), 1,
      aux_sym__lambda_bindings_repeat1,
    ACTIONS(14362), 2,
      anon_sym__,
      sym_id,
    STATE(7876), 3,
      sym_typed_binding,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [646261] = 5,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13329), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13325), 5,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
    ACTIONS(13333), 5,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_u2984,
  [646287] = 12,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(14226), 1,
      anon_sym_DOT,
    ACTIONS(14228), 1,
      anon_sym_DOT_DOT,
    ACTIONS(14690), 1,
      anon_sym_LPAREN,
    ACTIONS(14692), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(14694), 1,
      anon_sym_u2983,
    ACTIONS(14696), 1,
      anon_sym_LBRACE,
    STATE(8376), 1,
      aux_sym__lambda_bindings_repeat1,
    STATE(8487), 1,
      sym_bid,
    ACTIONS(14214), 2,
      anon_sym__,
      sym_id,
    STATE(8503), 3,
      sym_typed_binding,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [646327] = 6,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13331), 1,
      anon_sym_RBRACE,
    ACTIONS(13329), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13327), 4,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_SEMI,
    ACTIONS(13325), 5,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [646355] = 6,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13335), 1,
      anon_sym_RBRACE,
    ACTIONS(13329), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13333), 4,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_SEMI,
    ACTIONS(13325), 5,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [646383] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13299), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13297), 10,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [646407] = 12,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(14358), 1,
      anon_sym_DOT,
    ACTIONS(14360), 1,
      anon_sym_DOT_DOT,
    ACTIONS(14698), 1,
      anon_sym_LPAREN,
    ACTIONS(14700), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(14702), 1,
      anon_sym_u2983,
    ACTIONS(14704), 1,
      anon_sym_LBRACE,
    STATE(7848), 1,
      sym_bid,
    STATE(8376), 1,
      aux_sym__lambda_bindings_repeat1,
    ACTIONS(14346), 2,
      anon_sym__,
      sym_id,
    STATE(7854), 3,
      sym_typed_binding,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [646447] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13299), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13297), 10,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [646471] = 6,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13331), 1,
      anon_sym_RBRACE,
    ACTIONS(13329), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13327), 4,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
    ACTIONS(13325), 5,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [646499] = 11,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13367), 1,
      anon_sym_LPAREN,
    ACTIONS(13369), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(13371), 1,
      anon_sym_u2983,
    ACTIONS(13373), 1,
      anon_sym_LBRACE,
    ACTIONS(13375), 1,
      anon_sym_DOT,
    ACTIONS(13377), 1,
      anon_sym_DOT_DOT,
    STATE(8750), 1,
      sym_bid,
    ACTIONS(13363), 2,
      anon_sym__,
      sym_id,
    STATE(7997), 4,
      sym_typed_binding,
      aux_sym__typed_untyped_bindings,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [646537] = 12,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13692), 1,
      anon_sym_DOT,
    ACTIONS(13694), 1,
      anon_sym_DOT_DOT,
    ACTIONS(14706), 1,
      anon_sym_LPAREN,
    ACTIONS(14708), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(14710), 1,
      anon_sym_u2983,
    ACTIONS(14712), 1,
      anon_sym_LBRACE,
    STATE(8220), 1,
      sym_bid,
    STATE(8376), 1,
      aux_sym__lambda_bindings_repeat1,
    ACTIONS(13680), 2,
      anon_sym__,
      sym_id,
    STATE(8208), 3,
      sym_typed_binding,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [646577] = 5,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13329), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13325), 5,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
    ACTIONS(13327), 5,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_u2984,
  [646603] = 5,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13329), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13325), 5,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
    ACTIONS(13327), 5,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_u2984,
  [646629] = 12,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13936), 1,
      anon_sym_DOT,
    ACTIONS(13938), 1,
      anon_sym_DOT_DOT,
    ACTIONS(14714), 1,
      anon_sym_LPAREN,
    ACTIONS(14716), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(14718), 1,
      anon_sym_u2983,
    ACTIONS(14720), 1,
      anon_sym_LBRACE,
    STATE(8376), 1,
      aux_sym__lambda_bindings_repeat1,
    STATE(8538), 1,
      sym_bid,
    ACTIONS(13924), 2,
      anon_sym__,
      sym_id,
    STATE(8540), 3,
      sym_typed_binding,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [646669] = 12,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13846), 1,
      anon_sym_DOT,
    ACTIONS(13848), 1,
      anon_sym_DOT_DOT,
    ACTIONS(14722), 1,
      anon_sym_LPAREN,
    ACTIONS(14724), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(14726), 1,
      anon_sym_u2983,
    ACTIONS(14728), 1,
      anon_sym_LBRACE,
    STATE(8376), 1,
      aux_sym__lambda_bindings_repeat1,
    STATE(8450), 1,
      sym_bid,
    ACTIONS(13834), 2,
      anon_sym__,
      sym_id,
    STATE(8405), 3,
      sym_typed_binding,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [646709] = 6,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13335), 1,
      anon_sym_RBRACE,
    ACTIONS(13329), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13333), 4,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
    ACTIONS(13325), 5,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [646737] = 5,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13329), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13325), 5,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
    ACTIONS(13333), 5,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_u2984,
  [646763] = 11,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13367), 1,
      anon_sym_LPAREN,
    ACTIONS(13369), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(13371), 1,
      anon_sym_u2983,
    ACTIONS(13373), 1,
      anon_sym_LBRACE,
    ACTIONS(13375), 1,
      anon_sym_DOT,
    ACTIONS(13377), 1,
      anon_sym_DOT_DOT,
    STATE(8750), 1,
      sym_bid,
    ACTIONS(13363), 2,
      anon_sym__,
      sym_id,
    STATE(7990), 4,
      sym_typed_binding,
      aux_sym__typed_untyped_bindings,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [646801] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13295), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13293), 10,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [646825] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13250), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13248), 10,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [646849] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13303), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13301), 10,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [646873] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13291), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13289), 10,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [646897] = 11,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13367), 1,
      anon_sym_LPAREN,
    ACTIONS(13369), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(13371), 1,
      anon_sym_u2983,
    ACTIONS(13373), 1,
      anon_sym_LBRACE,
    ACTIONS(13375), 1,
      anon_sym_DOT,
    ACTIONS(13377), 1,
      anon_sym_DOT_DOT,
    STATE(8750), 1,
      sym_bid,
    ACTIONS(13363), 2,
      anon_sym__,
      sym_id,
    STATE(7968), 4,
      sym_typed_binding,
      aux_sym__typed_untyped_bindings,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [646935] = 11,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13367), 1,
      anon_sym_LPAREN,
    ACTIONS(13369), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(13371), 1,
      anon_sym_u2983,
    ACTIONS(13373), 1,
      anon_sym_LBRACE,
    ACTIONS(13375), 1,
      anon_sym_DOT,
    ACTIONS(13377), 1,
      anon_sym_DOT_DOT,
    STATE(8750), 1,
      sym_bid,
    ACTIONS(13363), 2,
      anon_sym__,
      sym_id,
    STATE(7964), 4,
      sym_typed_binding,
      aux_sym__typed_untyped_bindings,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [646973] = 12,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(14408), 1,
      anon_sym_DOT,
    ACTIONS(14410), 1,
      anon_sym_DOT_DOT,
    ACTIONS(14730), 1,
      anon_sym_LPAREN,
    ACTIONS(14732), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(14734), 1,
      anon_sym_u2983,
    ACTIONS(14736), 1,
      anon_sym_LBRACE,
    STATE(8328), 1,
      sym_bid,
    STATE(8376), 1,
      aux_sym__lambda_bindings_repeat1,
    ACTIONS(14396), 2,
      anon_sym__,
      sym_id,
    STATE(8357), 3,
      sym_typed_binding,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [647013] = 12,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13539), 1,
      anon_sym_DOT,
    ACTIONS(13541), 1,
      anon_sym_DOT_DOT,
    ACTIONS(14738), 1,
      anon_sym_LPAREN,
    ACTIONS(14740), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(14742), 1,
      anon_sym_u2983,
    ACTIONS(14744), 1,
      anon_sym_LBRACE,
    STATE(8147), 1,
      sym_bid,
    STATE(8376), 1,
      aux_sym__lambda_bindings_repeat1,
    ACTIONS(13527), 2,
      anon_sym__,
      sym_id,
    STATE(8068), 3,
      sym_typed_binding,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [647053] = 11,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13367), 1,
      anon_sym_LPAREN,
    ACTIONS(13369), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(13371), 1,
      anon_sym_u2983,
    ACTIONS(13373), 1,
      anon_sym_LBRACE,
    ACTIONS(13375), 1,
      anon_sym_DOT,
    ACTIONS(13377), 1,
      anon_sym_DOT_DOT,
    STATE(8750), 1,
      sym_bid,
    ACTIONS(13363), 2,
      anon_sym__,
      sym_id,
    STATE(8026), 4,
      sym_typed_binding,
      aux_sym__typed_untyped_bindings,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [647091] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13254), 5,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13252), 8,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [647115] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13295), 5,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13293), 8,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [647139] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13250), 5,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13248), 8,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [647163] = 11,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(14749), 1,
      anon_sym_LPAREN,
    ACTIONS(14752), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(14755), 1,
      anon_sym_u2983,
    ACTIONS(14758), 1,
      anon_sym_LBRACE,
    ACTIONS(14761), 1,
      anon_sym_DOT,
    ACTIONS(14764), 1,
      anon_sym_DOT_DOT,
    STATE(9039), 1,
      sym_bid,
    ACTIONS(14746), 2,
      anon_sym__,
      sym_id,
    STATE(8376), 4,
      sym_typed_binding,
      sym__typed_untyped_binding,
      sym_untyped_binding,
      aux_sym__lambda_bindings_repeat1,
  [647201] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13303), 5,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13301), 8,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [647225] = 12,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13523), 1,
      anon_sym_DOT,
    ACTIONS(13525), 1,
      anon_sym_DOT_DOT,
    ACTIONS(14767), 1,
      anon_sym_LPAREN,
    ACTIONS(14769), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(14771), 1,
      anon_sym_u2983,
    ACTIONS(14773), 1,
      anon_sym_LBRACE,
    STATE(8376), 1,
      aux_sym__lambda_bindings_repeat1,
    STATE(8424), 1,
      sym_bid,
    ACTIONS(13511), 2,
      anon_sym__,
      sym_id,
    STATE(8382), 3,
      sym_typed_binding,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [647265] = 11,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13367), 1,
      anon_sym_LPAREN,
    ACTIONS(13369), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(13371), 1,
      anon_sym_u2983,
    ACTIONS(13373), 1,
      anon_sym_LBRACE,
    ACTIONS(13375), 1,
      anon_sym_DOT,
    ACTIONS(13377), 1,
      anon_sym_DOT_DOT,
    STATE(8750), 1,
      sym_bid,
    ACTIONS(13363), 2,
      anon_sym__,
      sym_id,
    STATE(8020), 4,
      sym_typed_binding,
      aux_sym__typed_untyped_bindings,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [647303] = 6,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13335), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(13329), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13333), 4,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_SEMI,
    ACTIONS(13325), 5,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [647331] = 12,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13507), 1,
      anon_sym_DOT,
    ACTIONS(13509), 1,
      anon_sym_DOT_DOT,
    ACTIONS(14775), 1,
      anon_sym_LPAREN,
    ACTIONS(14777), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(14779), 1,
      anon_sym_u2983,
    ACTIONS(14781), 1,
      anon_sym_LBRACE,
    STATE(7962), 1,
      sym_bid,
    STATE(8376), 1,
      aux_sym__lambda_bindings_repeat1,
    ACTIONS(13495), 2,
      anon_sym__,
      sym_id,
    STATE(7991), 3,
      sym_typed_binding,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [647371] = 6,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13331), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(13329), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13327), 4,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_SEMI,
    ACTIONS(13325), 5,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [647399] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13291), 5,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13289), 8,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [647423] = 11,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13367), 1,
      anon_sym_LPAREN,
    ACTIONS(13369), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(13371), 1,
      anon_sym_u2983,
    ACTIONS(13373), 1,
      anon_sym_LBRACE,
    ACTIONS(13375), 1,
      anon_sym_DOT,
    ACTIONS(13377), 1,
      anon_sym_DOT_DOT,
    STATE(8750), 1,
      sym_bid,
    ACTIONS(13363), 2,
      anon_sym__,
      sym_id,
    STATE(7938), 4,
      sym_typed_binding,
      aux_sym__typed_untyped_bindings,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [647461] = 12,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13793), 1,
      anon_sym_DOT,
    ACTIONS(13795), 1,
      anon_sym_DOT_DOT,
    ACTIONS(14783), 1,
      anon_sym_LPAREN,
    ACTIONS(14785), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(14787), 1,
      anon_sym_u2983,
    ACTIONS(14789), 1,
      anon_sym_LBRACE,
    STATE(7946), 1,
      sym_bid,
    STATE(8376), 1,
      aux_sym__lambda_bindings_repeat1,
    ACTIONS(13781), 2,
      anon_sym__,
      sym_id,
    STATE(8019), 3,
      sym_typed_binding,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [647501] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13254), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13252), 10,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [647525] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13343), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13341), 10,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [647549] = 11,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13367), 1,
      anon_sym_LPAREN,
    ACTIONS(13369), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(13371), 1,
      anon_sym_u2983,
    ACTIONS(13373), 1,
      anon_sym_LBRACE,
    ACTIONS(13375), 1,
      anon_sym_DOT,
    ACTIONS(13377), 1,
      anon_sym_DOT_DOT,
    STATE(8750), 1,
      sym_bid,
    ACTIONS(13363), 2,
      anon_sym__,
      sym_id,
    STATE(8008), 4,
      sym_typed_binding,
      aux_sym__typed_untyped_bindings,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [647587] = 12,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(14276), 1,
      anon_sym_DOT,
    ACTIONS(14278), 1,
      anon_sym_DOT_DOT,
    ACTIONS(14791), 1,
      anon_sym_LPAREN,
    ACTIONS(14793), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(14795), 1,
      anon_sym_u2983,
    ACTIONS(14797), 1,
      anon_sym_LBRACE,
    STATE(8319), 1,
      sym_bid,
    STATE(8376), 1,
      aux_sym__lambda_bindings_repeat1,
    ACTIONS(14264), 2,
      anon_sym__,
      sym_id,
    STATE(8349), 3,
      sym_typed_binding,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [647627] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13299), 5,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13297), 8,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [647651] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13343), 5,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13341), 8,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [647675] = 5,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13329), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13325), 5,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
    ACTIONS(13333), 5,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_u2988,
  [647701] = 11,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13367), 1,
      anon_sym_LPAREN,
    ACTIONS(13369), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(13371), 1,
      anon_sym_u2983,
    ACTIONS(13373), 1,
      anon_sym_LBRACE,
    ACTIONS(13375), 1,
      anon_sym_DOT,
    ACTIONS(13377), 1,
      anon_sym_DOT_DOT,
    STATE(8750), 1,
      sym_bid,
    ACTIONS(13363), 2,
      anon_sym__,
      sym_id,
    STATE(7981), 4,
      sym_typed_binding,
      aux_sym__typed_untyped_bindings,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [647739] = 5,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13329), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13325), 5,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
    ACTIONS(13327), 5,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_u2988,
  [647765] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13339), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13337), 10,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [647789] = 11,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13367), 1,
      anon_sym_LPAREN,
    ACTIONS(13369), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(13371), 1,
      anon_sym_u2983,
    ACTIONS(13373), 1,
      anon_sym_LBRACE,
    ACTIONS(13375), 1,
      anon_sym_DOT,
    ACTIONS(13377), 1,
      anon_sym_DOT_DOT,
    STATE(8750), 1,
      sym_bid,
    ACTIONS(13363), 2,
      anon_sym__,
      sym_id,
    STATE(7973), 4,
      sym_typed_binding,
      aux_sym__typed_untyped_bindings,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [647827] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13339), 5,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13337), 8,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [647851] = 11,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13367), 1,
      anon_sym_LPAREN,
    ACTIONS(13369), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(13371), 1,
      anon_sym_u2983,
    ACTIONS(13373), 1,
      anon_sym_LBRACE,
    ACTIONS(13375), 1,
      anon_sym_DOT,
    ACTIONS(13377), 1,
      anon_sym_DOT_DOT,
    STATE(8750), 1,
      sym_bid,
    ACTIONS(13363), 2,
      anon_sym__,
      sym_id,
    STATE(7963), 4,
      sym_typed_binding,
      aux_sym__typed_untyped_bindings,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [647889] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13287), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13285), 10,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [647913] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13287), 5,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13285), 8,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [647937] = 6,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13335), 1,
      sym__newline,
    ACTIONS(13329), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13333), 4,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_in,
    ACTIONS(13325), 5,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [647965] = 11,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13367), 1,
      anon_sym_LPAREN,
    ACTIONS(13369), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(13371), 1,
      anon_sym_u2983,
    ACTIONS(13373), 1,
      anon_sym_LBRACE,
    ACTIONS(13375), 1,
      anon_sym_DOT,
    ACTIONS(13377), 1,
      anon_sym_DOT_DOT,
    STATE(8750), 1,
      sym_bid,
    ACTIONS(13363), 2,
      anon_sym__,
      sym_id,
    STATE(7978), 4,
      sym_typed_binding,
      aux_sym__typed_untyped_bindings,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [648003] = 5,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13329), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13325), 5,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
    ACTIONS(13327), 5,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_SEMI,
  [648029] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13299), 4,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13297), 9,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [648053] = 6,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13331), 1,
      sym__newline,
    ACTIONS(13329), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13327), 4,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_in,
    ACTIONS(13325), 5,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [648081] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13295), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13293), 10,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [648105] = 12,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13491), 1,
      anon_sym_DOT,
    ACTIONS(13493), 1,
      anon_sym_DOT_DOT,
    ACTIONS(14799), 1,
      anon_sym_LPAREN,
    ACTIONS(14801), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(14803), 1,
      anon_sym_u2983,
    ACTIONS(14805), 1,
      anon_sym_LBRACE,
    STATE(8344), 1,
      sym_bid,
    STATE(8376), 1,
      aux_sym__lambda_bindings_repeat1,
    ACTIONS(13479), 2,
      anon_sym__,
      sym_id,
    STATE(8354), 3,
      sym_typed_binding,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [648145] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13250), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13248), 10,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [648169] = 11,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13367), 1,
      anon_sym_LPAREN,
    ACTIONS(13369), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(13371), 1,
      anon_sym_u2983,
    ACTIONS(13373), 1,
      anon_sym_LBRACE,
    ACTIONS(13375), 1,
      anon_sym_DOT,
    ACTIONS(13377), 1,
      anon_sym_DOT_DOT,
    STATE(8750), 1,
      sym_bid,
    ACTIONS(13363), 2,
      anon_sym__,
      sym_id,
    STATE(7972), 4,
      sym_typed_binding,
      aux_sym__typed_untyped_bindings,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [648207] = 12,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(14308), 1,
      anon_sym_DOT,
    ACTIONS(14310), 1,
      anon_sym_DOT_DOT,
    ACTIONS(14807), 1,
      anon_sym_LPAREN,
    ACTIONS(14809), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(14811), 1,
      anon_sym_u2983,
    ACTIONS(14813), 1,
      anon_sym_LBRACE,
    STATE(8376), 1,
      aux_sym__lambda_bindings_repeat1,
    STATE(8415), 1,
      sym_bid,
    ACTIONS(14296), 2,
      anon_sym__,
      sym_id,
    STATE(8358), 3,
      sym_typed_binding,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [648247] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13303), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13301), 10,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [648271] = 11,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13367), 1,
      anon_sym_LPAREN,
    ACTIONS(13369), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(13371), 1,
      anon_sym_u2983,
    ACTIONS(13373), 1,
      anon_sym_LBRACE,
    ACTIONS(13375), 1,
      anon_sym_DOT,
    ACTIONS(13377), 1,
      anon_sym_DOT_DOT,
    STATE(8750), 1,
      sym_bid,
    ACTIONS(13363), 2,
      anon_sym__,
      sym_id,
    STATE(8017), 4,
      sym_typed_binding,
      aux_sym__typed_untyped_bindings,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [648309] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13291), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13289), 10,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [648333] = 11,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13367), 1,
      anon_sym_LPAREN,
    ACTIONS(13369), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(13371), 1,
      anon_sym_u2983,
    ACTIONS(13373), 1,
      anon_sym_LBRACE,
    ACTIONS(13375), 1,
      anon_sym_DOT,
    ACTIONS(13377), 1,
      anon_sym_DOT_DOT,
    STATE(8750), 1,
      sym_bid,
    ACTIONS(13363), 2,
      anon_sym__,
      sym_id,
    STATE(7957), 4,
      sym_typed_binding,
      aux_sym__typed_untyped_bindings,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [648371] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13287), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13285), 10,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [648395] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13339), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13337), 10,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [648419] = 12,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(14090), 1,
      anon_sym_DOT,
    ACTIONS(14092), 1,
      anon_sym_DOT_DOT,
    ACTIONS(14815), 1,
      anon_sym_LPAREN,
    ACTIONS(14817), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(14819), 1,
      anon_sym_u2983,
    ACTIONS(14821), 1,
      anon_sym_LBRACE,
    STATE(7934), 1,
      sym_bid,
    STATE(8376), 1,
      aux_sym__lambda_bindings_repeat1,
    ACTIONS(14078), 2,
      anon_sym__,
      sym_id,
    STATE(7917), 3,
      sym_typed_binding,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [648459] = 11,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13367), 1,
      anon_sym_LPAREN,
    ACTIONS(13369), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(13371), 1,
      anon_sym_u2983,
    ACTIONS(13373), 1,
      anon_sym_LBRACE,
    ACTIONS(13375), 1,
      anon_sym_DOT,
    ACTIONS(13377), 1,
      anon_sym_DOT_DOT,
    STATE(8750), 1,
      sym_bid,
    ACTIONS(13363), 2,
      anon_sym__,
      sym_id,
    STATE(7954), 4,
      sym_typed_binding,
      aux_sym__typed_untyped_bindings,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [648497] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13343), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13341), 10,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [648521] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13254), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13252), 10,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [648545] = 12,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13571), 1,
      anon_sym_DOT,
    ACTIONS(13573), 1,
      anon_sym_DOT_DOT,
    ACTIONS(14823), 1,
      anon_sym_LPAREN,
    ACTIONS(14825), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(14827), 1,
      anon_sym_u2983,
    ACTIONS(14829), 1,
      anon_sym_LBRACE,
    STATE(8197), 1,
      sym_bid,
    STATE(8376), 1,
      aux_sym__lambda_bindings_repeat1,
    ACTIONS(13559), 2,
      anon_sym__,
      sym_id,
    STATE(8233), 3,
      sym_typed_binding,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [648585] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13295), 4,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13293), 9,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [648609] = 11,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13367), 1,
      anon_sym_LPAREN,
    ACTIONS(13369), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(13371), 1,
      anon_sym_u2983,
    ACTIONS(13373), 1,
      anon_sym_LBRACE,
    ACTIONS(13375), 1,
      anon_sym_DOT,
    ACTIONS(13377), 1,
      anon_sym_DOT_DOT,
    STATE(8750), 1,
      sym_bid,
    ACTIONS(13363), 2,
      anon_sym__,
      sym_id,
    STATE(8028), 4,
      sym_typed_binding,
      aux_sym__typed_untyped_bindings,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [648647] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13287), 4,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_RPAREN,
    ACTIONS(13285), 9,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [648671] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13339), 4,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_RPAREN,
    ACTIONS(13337), 9,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [648695] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13291), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13289), 10,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [648719] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13343), 4,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_RPAREN,
    ACTIONS(13341), 9,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [648743] = 11,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13367), 1,
      anon_sym_LPAREN,
    ACTIONS(13369), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(13371), 1,
      anon_sym_u2983,
    ACTIONS(13373), 1,
      anon_sym_LBRACE,
    ACTIONS(13375), 1,
      anon_sym_DOT,
    ACTIONS(13377), 1,
      anon_sym_DOT_DOT,
    STATE(8750), 1,
      sym_bid,
    ACTIONS(13363), 2,
      anon_sym__,
      sym_id,
    STATE(7958), 4,
      sym_typed_binding,
      aux_sym__typed_untyped_bindings,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [648781] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13303), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13301), 10,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [648805] = 12,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(14070), 1,
      anon_sym_DOT,
    ACTIONS(14072), 1,
      anon_sym_DOT_DOT,
    ACTIONS(14831), 1,
      anon_sym_LPAREN,
    ACTIONS(14833), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(14835), 1,
      anon_sym_u2983,
    ACTIONS(14837), 1,
      anon_sym_LBRACE,
    STATE(8376), 1,
      aux_sym__lambda_bindings_repeat1,
    STATE(8556), 1,
      sym_bid,
    ACTIONS(14058), 2,
      anon_sym__,
      sym_id,
    STATE(8629), 3,
      sym_typed_binding,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [648845] = 11,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13367), 1,
      anon_sym_LPAREN,
    ACTIONS(13369), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(13371), 1,
      anon_sym_u2983,
    ACTIONS(13373), 1,
      anon_sym_LBRACE,
    ACTIONS(13375), 1,
      anon_sym_DOT,
    ACTIONS(13377), 1,
      anon_sym_DOT_DOT,
    STATE(8750), 1,
      sym_bid,
    ACTIONS(13363), 2,
      anon_sym__,
      sym_id,
    STATE(8002), 4,
      sym_typed_binding,
      aux_sym__typed_untyped_bindings,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [648883] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13254), 4,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_RPAREN,
    ACTIONS(13252), 9,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [648907] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13250), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13248), 10,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [648931] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13295), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13293), 10,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [648955] = 11,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13367), 1,
      anon_sym_LPAREN,
    ACTIONS(13369), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(13371), 1,
      anon_sym_u2983,
    ACTIONS(13373), 1,
      anon_sym_LBRACE,
    ACTIONS(13375), 1,
      anon_sym_DOT,
    ACTIONS(13377), 1,
      anon_sym_DOT_DOT,
    STATE(8750), 1,
      sym_bid,
    ACTIONS(13363), 2,
      anon_sym__,
      sym_id,
    STATE(8006), 4,
      sym_typed_binding,
      aux_sym__typed_untyped_bindings,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [648993] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13287), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13285), 10,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
      anon_sym_u2988,
  [649017] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13339), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13337), 10,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
      anon_sym_u2988,
  [649041] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13291), 4,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_RPAREN,
    ACTIONS(13289), 9,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [649065] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13343), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13341), 10,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
      anon_sym_u2988,
  [649089] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13250), 4,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13248), 9,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [649113] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13254), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13252), 10,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
      anon_sym_u2988,
  [649137] = 11,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13367), 1,
      anon_sym_LPAREN,
    ACTIONS(13369), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(13371), 1,
      anon_sym_u2983,
    ACTIONS(13373), 1,
      anon_sym_LBRACE,
    ACTIONS(13375), 1,
      anon_sym_DOT,
    ACTIONS(13377), 1,
      anon_sym_DOT_DOT,
    STATE(8750), 1,
      sym_bid,
    ACTIONS(13363), 2,
      anon_sym__,
      sym_id,
    STATE(8023), 4,
      sym_typed_binding,
      aux_sym__typed_untyped_bindings,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [649175] = 12,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(14340), 1,
      anon_sym_DOT,
    ACTIONS(14342), 1,
      anon_sym_DOT_DOT,
    ACTIONS(14839), 1,
      anon_sym_LPAREN,
    ACTIONS(14841), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(14843), 1,
      anon_sym_u2983,
    ACTIONS(14845), 1,
      anon_sym_LBRACE,
    STATE(7965), 1,
      sym_bid,
    STATE(8376), 1,
      aux_sym__lambda_bindings_repeat1,
    ACTIONS(14328), 2,
      anon_sym__,
      sym_id,
    STATE(8027), 3,
      sym_typed_binding,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [649215] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13250), 4,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_RPAREN,
    ACTIONS(13248), 9,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [649239] = 11,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13305), 1,
      sym_id,
    ACTIONS(13311), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(13313), 1,
      anon_sym_u2983,
    ACTIONS(13315), 1,
      anon_sym_LBRACE,
    ACTIONS(13317), 1,
      anon_sym_DOT,
    ACTIONS(13319), 1,
      anon_sym_DOT_DOT,
    ACTIONS(13321), 1,
      anon_sym_AT,
    STATE(8923), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    STATE(8683), 4,
      sym__field_name,
      sym__maybe_dotted_id,
      aux_sym__arg_ids,
      sym__arg_id,
  [649277] = 11,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13367), 1,
      anon_sym_LPAREN,
    ACTIONS(13369), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(13371), 1,
      anon_sym_u2983,
    ACTIONS(13373), 1,
      anon_sym_LBRACE,
    ACTIONS(13375), 1,
      anon_sym_DOT,
    ACTIONS(13377), 1,
      anon_sym_DOT_DOT,
    STATE(8750), 1,
      sym_bid,
    ACTIONS(13363), 2,
      anon_sym__,
      sym_id,
    STATE(8024), 4,
      sym_typed_binding,
      aux_sym__typed_untyped_bindings,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [649315] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13295), 4,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_RPAREN,
    ACTIONS(13293), 9,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [649339] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13254), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13252), 10,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [649363] = 12,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(14390), 1,
      anon_sym_DOT,
    ACTIONS(14392), 1,
      anon_sym_DOT_DOT,
    ACTIONS(14847), 1,
      anon_sym_LPAREN,
    ACTIONS(14849), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(14851), 1,
      anon_sym_u2983,
    ACTIONS(14853), 1,
      anon_sym_LBRACE,
    STATE(8376), 1,
      aux_sym__lambda_bindings_repeat1,
    STATE(8557), 1,
      sym_bid,
    ACTIONS(14378), 2,
      anon_sym__,
      sym_id,
    STATE(8542), 3,
      sym_typed_binding,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [649403] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13287), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13285), 9,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
      anon_sym_in,
  [649427] = 11,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13367), 1,
      anon_sym_LPAREN,
    ACTIONS(13369), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(13371), 1,
      anon_sym_u2983,
    ACTIONS(13373), 1,
      anon_sym_LBRACE,
    ACTIONS(13375), 1,
      anon_sym_DOT,
    ACTIONS(13377), 1,
      anon_sym_DOT_DOT,
    STATE(8750), 1,
      sym_bid,
    ACTIONS(13363), 2,
      anon_sym__,
      sym_id,
    STATE(7960), 4,
      sym_typed_binding,
      aux_sym__typed_untyped_bindings,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [649465] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13303), 4,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13301), 9,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [649489] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13339), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13337), 9,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
      anon_sym_in,
  [649513] = 12,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(14162), 1,
      anon_sym_DOT,
    ACTIONS(14164), 1,
      anon_sym_DOT_DOT,
    ACTIONS(14855), 1,
      anon_sym_LPAREN,
    ACTIONS(14857), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(14859), 1,
      anon_sym_u2983,
    ACTIONS(14861), 1,
      anon_sym_LBRACE,
    STATE(8083), 1,
      sym_bid,
    STATE(8376), 1,
      aux_sym__lambda_bindings_repeat1,
    ACTIONS(14150), 2,
      anon_sym__,
      sym_id,
    STATE(8130), 3,
      sym_typed_binding,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [649553] = 11,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13367), 1,
      anon_sym_LPAREN,
    ACTIONS(13369), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(13371), 1,
      anon_sym_u2983,
    ACTIONS(13373), 1,
      anon_sym_LBRACE,
    ACTIONS(13375), 1,
      anon_sym_DOT,
    ACTIONS(13377), 1,
      anon_sym_DOT_DOT,
    STATE(8750), 1,
      sym_bid,
    ACTIONS(13363), 2,
      anon_sym__,
      sym_id,
    STATE(8025), 4,
      sym_typed_binding,
      aux_sym__typed_untyped_bindings,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [649591] = 11,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13367), 1,
      anon_sym_LPAREN,
    ACTIONS(13369), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(13371), 1,
      anon_sym_u2983,
    ACTIONS(13373), 1,
      anon_sym_LBRACE,
    ACTIONS(13375), 1,
      anon_sym_DOT,
    ACTIONS(13377), 1,
      anon_sym_DOT_DOT,
    STATE(8750), 1,
      sym_bid,
    ACTIONS(13363), 2,
      anon_sym__,
      sym_id,
    STATE(7980), 4,
      sym_typed_binding,
      aux_sym__typed_untyped_bindings,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [649629] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13291), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13289), 10,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
      anon_sym_u2988,
  [649653] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13343), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13341), 9,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
      anon_sym_in,
  [649677] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13303), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13301), 10,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
      anon_sym_u2988,
  [649701] = 11,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13367), 1,
      anon_sym_LPAREN,
    ACTIONS(13369), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(13371), 1,
      anon_sym_u2983,
    ACTIONS(13373), 1,
      anon_sym_LBRACE,
    ACTIONS(13375), 1,
      anon_sym_DOT,
    ACTIONS(13377), 1,
      anon_sym_DOT_DOT,
    STATE(8750), 1,
      sym_bid,
    ACTIONS(13363), 2,
      anon_sym__,
      sym_id,
    STATE(7937), 4,
      sym_typed_binding,
      aux_sym__typed_untyped_bindings,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [649739] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13343), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13341), 10,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [649763] = 12,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(14258), 1,
      anon_sym_DOT,
    ACTIONS(14260), 1,
      anon_sym_DOT_DOT,
    ACTIONS(14863), 1,
      anon_sym_LPAREN,
    ACTIONS(14865), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(14867), 1,
      anon_sym_u2983,
    ACTIONS(14869), 1,
      anon_sym_LBRACE,
    STATE(8376), 1,
      aux_sym__lambda_bindings_repeat1,
    STATE(8399), 1,
      sym_bid,
    ACTIONS(14246), 2,
      anon_sym__,
      sym_id,
    STATE(8403), 3,
      sym_typed_binding,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [649803] = 11,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13367), 1,
      anon_sym_LPAREN,
    ACTIONS(13369), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(13371), 1,
      anon_sym_u2983,
    ACTIONS(13373), 1,
      anon_sym_LBRACE,
    ACTIONS(13375), 1,
      anon_sym_DOT,
    ACTIONS(13377), 1,
      anon_sym_DOT_DOT,
    STATE(8750), 1,
      sym_bid,
    ACTIONS(13363), 2,
      anon_sym__,
      sym_id,
    STATE(7976), 4,
      sym_typed_binding,
      aux_sym__typed_untyped_bindings,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [649841] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13254), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13252), 9,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
      anon_sym_in,
  [649865] = 12,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(14324), 1,
      anon_sym_DOT,
    ACTIONS(14326), 1,
      anon_sym_DOT_DOT,
    ACTIONS(14871), 1,
      anon_sym_LPAREN,
    ACTIONS(14873), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(14875), 1,
      anon_sym_u2983,
    ACTIONS(14877), 1,
      anon_sym_LBRACE,
    STATE(8223), 1,
      sym_bid,
    STATE(8376), 1,
      aux_sym__lambda_bindings_repeat1,
    ACTIONS(14312), 2,
      anon_sym__,
      sym_id,
    STATE(8259), 3,
      sym_typed_binding,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [649905] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13250), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13248), 10,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
      anon_sym_u2988,
  [649929] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13295), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13293), 10,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
      anon_sym_u2988,
  [649953] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13299), 4,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_RPAREN,
    ACTIONS(13297), 9,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [649977] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13291), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13289), 9,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
      anon_sym_in,
  [650001] = 11,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13367), 1,
      anon_sym_LPAREN,
    ACTIONS(13369), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(13371), 1,
      anon_sym_u2983,
    ACTIONS(13373), 1,
      anon_sym_LBRACE,
    ACTIONS(13375), 1,
      anon_sym_DOT,
    ACTIONS(13377), 1,
      anon_sym_DOT_DOT,
    STATE(8750), 1,
      sym_bid,
    ACTIONS(13363), 2,
      anon_sym__,
      sym_id,
    STATE(7994), 4,
      sym_typed_binding,
      aux_sym__typed_untyped_bindings,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [650039] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13303), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13301), 9,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
      anon_sym_in,
  [650063] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13250), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13248), 9,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
      anon_sym_in,
  [650087] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13295), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13293), 9,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
      anon_sym_in,
  [650111] = 12,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13777), 1,
      anon_sym_DOT,
    ACTIONS(13779), 1,
      anon_sym_DOT_DOT,
    ACTIONS(14879), 1,
      anon_sym_LPAREN,
    ACTIONS(14881), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(14883), 1,
      anon_sym_u2983,
    ACTIONS(14885), 1,
      anon_sym_LBRACE,
    STATE(8261), 1,
      sym_bid,
    STATE(8376), 1,
      aux_sym__lambda_bindings_repeat1,
    ACTIONS(13765), 2,
      anon_sym__,
      sym_id,
    STATE(8245), 3,
      sym_typed_binding,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [650151] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13299), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13297), 10,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
      anon_sym_u2988,
  [650175] = 11,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13367), 1,
      anon_sym_LPAREN,
    ACTIONS(13369), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(13371), 1,
      anon_sym_u2983,
    ACTIONS(13373), 1,
      anon_sym_LBRACE,
    ACTIONS(13375), 1,
      anon_sym_DOT,
    ACTIONS(13377), 1,
      anon_sym_DOT_DOT,
    STATE(8750), 1,
      sym_bid,
    ACTIONS(13363), 2,
      anon_sym__,
      sym_id,
    STATE(8018), 4,
      sym_typed_binding,
      aux_sym__typed_untyped_bindings,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [650213] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13299), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13297), 9,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
      anon_sym_in,
  [650237] = 6,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13335), 1,
      sym__newline,
    ACTIONS(13329), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13333), 4,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_SEMI,
    ACTIONS(13325), 5,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [650265] = 6,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13331), 1,
      sym__newline,
    ACTIONS(13329), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13327), 4,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_SEMI,
    ACTIONS(13325), 5,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [650293] = 6,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13331), 2,
      anon_sym_RPAREN,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(13327), 3,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
    ACTIONS(13329), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13325), 5,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [650321] = 12,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(14052), 1,
      anon_sym_DOT,
    ACTIONS(14054), 1,
      anon_sym_DOT_DOT,
    ACTIONS(14887), 1,
      anon_sym_LPAREN,
    ACTIONS(14889), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(14891), 1,
      anon_sym_u2983,
    ACTIONS(14893), 1,
      anon_sym_LBRACE,
    STATE(7889), 1,
      sym_bid,
    STATE(8376), 1,
      aux_sym__lambda_bindings_repeat1,
    ACTIONS(14040), 2,
      anon_sym__,
      sym_id,
    STATE(7862), 3,
      sym_typed_binding,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [650361] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13303), 4,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_RPAREN,
    ACTIONS(13301), 9,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [650385] = 11,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13367), 1,
      anon_sym_LPAREN,
    ACTIONS(13369), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(13371), 1,
      anon_sym_u2983,
    ACTIONS(13373), 1,
      anon_sym_LBRACE,
    ACTIONS(13375), 1,
      anon_sym_DOT,
    ACTIONS(13377), 1,
      anon_sym_DOT_DOT,
    STATE(8750), 1,
      sym_bid,
    ACTIONS(13363), 2,
      anon_sym__,
      sym_id,
    STATE(7998), 4,
      sym_typed_binding,
      aux_sym__typed_untyped_bindings,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [650423] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13291), 4,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13289), 9,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [650447] = 12,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(14124), 1,
      anon_sym_DOT,
    ACTIONS(14126), 1,
      anon_sym_DOT_DOT,
    ACTIONS(14895), 1,
      anon_sym_LPAREN,
    ACTIONS(14897), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(14899), 1,
      anon_sym_u2983,
    ACTIONS(14901), 1,
      anon_sym_LBRACE,
    STATE(8376), 1,
      aux_sym__lambda_bindings_repeat1,
    STATE(8604), 1,
      sym_bid,
    ACTIONS(14112), 2,
      anon_sym__,
      sym_id,
    STATE(8577), 3,
      sym_typed_binding,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [650487] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13339), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13337), 10,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [650511] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13287), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13285), 10,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [650535] = 6,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13335), 2,
      anon_sym_RPAREN,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(13329), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13333), 3,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
    ACTIONS(13325), 5,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [650563] = 11,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13367), 1,
      anon_sym_LPAREN,
    ACTIONS(13369), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(13371), 1,
      anon_sym_u2983,
    ACTIONS(13373), 1,
      anon_sym_LBRACE,
    ACTIONS(13375), 1,
      anon_sym_DOT,
    ACTIONS(13377), 1,
      anon_sym_DOT_DOT,
    STATE(8750), 1,
      sym_bid,
    ACTIONS(13363), 2,
      anon_sym__,
      sym_id,
    STATE(7956), 4,
      sym_typed_binding,
      aux_sym__typed_untyped_bindings,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [650601] = 11,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13367), 1,
      anon_sym_LPAREN,
    ACTIONS(13369), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(13371), 1,
      anon_sym_u2983,
    ACTIONS(13373), 1,
      anon_sym_LBRACE,
    ACTIONS(13375), 1,
      anon_sym_DOT,
    ACTIONS(13377), 1,
      anon_sym_DOT_DOT,
    STATE(8750), 1,
      sym_bid,
    ACTIONS(13363), 2,
      anon_sym__,
      sym_id,
    STATE(7959), 4,
      sym_typed_binding,
      aux_sym__typed_untyped_bindings,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [650639] = 12,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(14194), 1,
      anon_sym_DOT,
    ACTIONS(14196), 1,
      anon_sym_DOT_DOT,
    ACTIONS(14903), 1,
      anon_sym_LPAREN,
    ACTIONS(14905), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(14907), 1,
      anon_sym_u2983,
    ACTIONS(14909), 1,
      anon_sym_LBRACE,
    STATE(8376), 1,
      aux_sym__lambda_bindings_repeat1,
    STATE(8594), 1,
      sym_bid,
    ACTIONS(14182), 2,
      anon_sym__,
      sym_id,
    STATE(8590), 3,
      sym_typed_binding,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [650679] = 12,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13894), 1,
      anon_sym_DOT,
    ACTIONS(13896), 1,
      anon_sym_DOT_DOT,
    ACTIONS(14911), 1,
      anon_sym_LPAREN,
    ACTIONS(14913), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(14915), 1,
      anon_sym_u2983,
    ACTIONS(14917), 1,
      anon_sym_LBRACE,
    STATE(8110), 1,
      sym_bid,
    STATE(8376), 1,
      aux_sym__lambda_bindings_repeat1,
    ACTIONS(13882), 2,
      anon_sym__,
      sym_id,
    STATE(8048), 3,
      sym_typed_binding,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [650719] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13254), 4,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13252), 9,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [650743] = 12,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(14430), 1,
      anon_sym_DOT,
    ACTIONS(14432), 1,
      anon_sym_DOT_DOT,
    ACTIONS(14919), 1,
      anon_sym_LPAREN,
    ACTIONS(14921), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(14923), 1,
      anon_sym_u2983,
    ACTIONS(14925), 1,
      anon_sym_LBRACE,
    STATE(8310), 1,
      sym_bid,
    STATE(8376), 1,
      aux_sym__lambda_bindings_repeat1,
    ACTIONS(14418), 2,
      anon_sym__,
      sym_id,
    STATE(8336), 3,
      sym_typed_binding,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [650783] = 11,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13367), 1,
      anon_sym_LPAREN,
    ACTIONS(13369), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(13371), 1,
      anon_sym_u2983,
    ACTIONS(13373), 1,
      anon_sym_LBRACE,
    ACTIONS(13375), 1,
      anon_sym_DOT,
    ACTIONS(13377), 1,
      anon_sym_DOT_DOT,
    STATE(8750), 1,
      sym_bid,
    ACTIONS(13363), 2,
      anon_sym__,
      sym_id,
    STATE(7992), 4,
      sym_typed_binding,
      aux_sym__typed_untyped_bindings,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [650821] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13343), 4,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13341), 9,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [650845] = 11,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13367), 1,
      anon_sym_LPAREN,
    ACTIONS(13369), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(13371), 1,
      anon_sym_u2983,
    ACTIONS(13373), 1,
      anon_sym_LBRACE,
    ACTIONS(13375), 1,
      anon_sym_DOT,
    ACTIONS(13377), 1,
      anon_sym_DOT_DOT,
    STATE(8750), 1,
      sym_bid,
    ACTIONS(13363), 2,
      anon_sym__,
      sym_id,
    STATE(7945), 4,
      sym_typed_binding,
      aux_sym__typed_untyped_bindings,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [650883] = 6,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13335), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(13329), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13333), 4,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_SEMI,
    ACTIONS(13325), 5,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [650911] = 6,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13331), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(13329), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13327), 4,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_SEMI,
    ACTIONS(13325), 5,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [650939] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13287), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13285), 9,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [650963] = 5,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13329), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13325), 5,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
    ACTIONS(13333), 5,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_u2984,
  [650989] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13339), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13337), 9,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [651013] = 5,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13329), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13325), 5,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
    ACTIONS(13327), 5,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_u2984,
  [651039] = 11,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13367), 1,
      anon_sym_LPAREN,
    ACTIONS(13369), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(13371), 1,
      anon_sym_u2983,
    ACTIONS(13373), 1,
      anon_sym_LBRACE,
    ACTIONS(13375), 1,
      anon_sym_DOT,
    ACTIONS(13377), 1,
      anon_sym_DOT_DOT,
    STATE(8750), 1,
      sym_bid,
    ACTIONS(13363), 2,
      anon_sym__,
      sym_id,
    STATE(7944), 4,
      sym_typed_binding,
      aux_sym__typed_untyped_bindings,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [651077] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13343), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13341), 9,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [651101] = 12,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13809), 1,
      anon_sym_DOT,
    ACTIONS(13811), 1,
      anon_sym_DOT_DOT,
    ACTIONS(14927), 1,
      anon_sym_LPAREN,
    ACTIONS(14929), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(14931), 1,
      anon_sym_u2983,
    ACTIONS(14933), 1,
      anon_sym_LBRACE,
    STATE(8376), 1,
      aux_sym__lambda_bindings_repeat1,
    STATE(8618), 1,
      sym_bid,
    ACTIONS(13797), 2,
      anon_sym__,
      sym_id,
    STATE(8603), 3,
      sym_typed_binding,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [651141] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13254), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13252), 9,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [651165] = 12,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13724), 1,
      anon_sym_DOT,
    ACTIONS(13726), 1,
      anon_sym_DOT_DOT,
    ACTIONS(14935), 1,
      anon_sym_LPAREN,
    ACTIONS(14937), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(14939), 1,
      anon_sym_u2983,
    ACTIONS(14941), 1,
      anon_sym_LBRACE,
    STATE(8209), 1,
      sym_bid,
    STATE(8376), 1,
      aux_sym__lambda_bindings_repeat1,
    ACTIONS(13712), 2,
      anon_sym__,
      sym_id,
    STATE(8173), 3,
      sym_typed_binding,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [651205] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13291), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13289), 9,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [651229] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13303), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13301), 9,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [651253] = 11,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13367), 1,
      anon_sym_LPAREN,
    ACTIONS(13369), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(13371), 1,
      anon_sym_u2983,
    ACTIONS(13373), 1,
      anon_sym_LBRACE,
    ACTIONS(13375), 1,
      anon_sym_DOT,
    ACTIONS(13377), 1,
      anon_sym_DOT_DOT,
    STATE(8750), 1,
      sym_bid,
    ACTIONS(13363), 2,
      anon_sym__,
      sym_id,
    STATE(7966), 4,
      sym_typed_binding,
      aux_sym__typed_untyped_bindings,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [651291] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13250), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13248), 9,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [651315] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13295), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13293), 9,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [651339] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13299), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13297), 9,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [651363] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13287), 4,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13285), 9,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [651387] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13339), 4,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13337), 9,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [651411] = 12,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13644), 1,
      anon_sym_DOT,
    ACTIONS(13646), 1,
      anon_sym_DOT_DOT,
    ACTIONS(14943), 1,
      anon_sym_LPAREN,
    ACTIONS(14945), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(14947), 1,
      anon_sym_u2983,
    ACTIONS(14949), 1,
      anon_sym_LBRACE,
    STATE(8298), 1,
      sym_bid,
    STATE(8376), 1,
      aux_sym__lambda_bindings_repeat1,
    ACTIONS(13632), 2,
      anon_sym__,
      sym_id,
    STATE(8331), 3,
      sym_typed_binding,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [651451] = 11,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13367), 1,
      anon_sym_LPAREN,
    ACTIONS(13369), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(13371), 1,
      anon_sym_u2983,
    ACTIONS(13373), 1,
      anon_sym_LBRACE,
    ACTIONS(13375), 1,
      anon_sym_DOT,
    ACTIONS(13377), 1,
      anon_sym_DOT_DOT,
    STATE(8750), 1,
      sym_bid,
    ACTIONS(13363), 2,
      anon_sym__,
      sym_id,
    STATE(7995), 4,
      sym_typed_binding,
      aux_sym__typed_untyped_bindings,
      sym__typed_untyped_binding,
      sym_untyped_binding,
  [651489] = 5,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13329), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13325), 5,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
    ACTIONS(13333), 5,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_SEMI,
  [651515] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13254), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13252), 8,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [651538] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13299), 4,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13297), 8,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [651561] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13343), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13341), 8,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [651584] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13339), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13337), 8,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [651607] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13287), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13285), 8,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [651630] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13291), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13289), 8,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [651653] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13295), 4,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13293), 8,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [651676] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13250), 4,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13248), 8,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [651699] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13303), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13301), 8,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [651722] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13303), 4,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13301), 8,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [651745] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13291), 4,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13289), 8,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [651768] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13250), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13248), 8,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [651791] = 6,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13331), 1,
      sym__newline,
    ACTIONS(13327), 3,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_SEMI,
    ACTIONS(13329), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13325), 5,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [651818] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13295), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13293), 8,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [651841] = 6,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13335), 1,
      sym__newline,
    ACTIONS(13329), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13333), 3,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_SEMI,
    ACTIONS(13325), 5,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [651868] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13254), 4,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13252), 8,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [651891] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13343), 4,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13341), 8,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [651914] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13339), 4,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13337), 8,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [651937] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13287), 4,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13285), 8,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [651960] = 5,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13329), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13333), 4,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_u2984,
    ACTIONS(13325), 5,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [651985] = 6,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13331), 1,
      anon_sym_RBRACE,
    ACTIONS(13327), 3,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_SEMI,
    ACTIONS(13329), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13325), 5,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [652012] = 6,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13335), 1,
      anon_sym_RBRACE,
    ACTIONS(13329), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13333), 3,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_SEMI,
    ACTIONS(13325), 5,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [652039] = 5,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13329), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13327), 4,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_u2984,
    ACTIONS(13325), 5,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [652064] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13343), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13341), 9,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [652087] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13299), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13297), 9,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [652110] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13299), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13297), 8,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_SEMI,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [652133] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13295), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13293), 9,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [652156] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13250), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13248), 9,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [652179] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13303), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13301), 9,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [652202] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13291), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13289), 9,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [652225] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13254), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13252), 9,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [652248] = 6,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13335), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(13329), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13333), 3,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
    ACTIONS(13325), 5,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [652275] = 6,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13331), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(13327), 3,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
    ACTIONS(13329), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13325), 5,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [652302] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13339), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13337), 9,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [652325] = 5,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13329), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13333), 4,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_u2988,
    ACTIONS(13325), 5,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [652350] = 5,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13329), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13327), 4,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_u2988,
    ACTIONS(13325), 5,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [652375] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13287), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13285), 9,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [652398] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13287), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13285), 9,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [652421] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13339), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13337), 9,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [652444] = 6,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13335), 1,
      anon_sym_RBRACE,
    ACTIONS(13329), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13333), 3,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
    ACTIONS(13325), 5,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [652471] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13343), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13341), 9,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [652494] = 6,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13331), 1,
      anon_sym_RBRACE,
    ACTIONS(13327), 3,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
    ACTIONS(13329), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13325), 5,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [652521] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13254), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13252), 9,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [652544] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13299), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13297), 9,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [652567] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13291), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13289), 9,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [652590] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13303), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13301), 9,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [652613] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13250), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13248), 9,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [652636] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13295), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13293), 9,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [652659] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13287), 4,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_RPAREN,
    ACTIONS(13285), 8,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [652682] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13339), 4,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_RPAREN,
    ACTIONS(13337), 8,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [652705] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13343), 4,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_RPAREN,
    ACTIONS(13341), 8,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [652728] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13254), 4,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_RPAREN,
    ACTIONS(13252), 8,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [652751] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13299), 4,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_RPAREN,
    ACTIONS(13297), 8,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [652774] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13287), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13285), 9,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
      anon_sym_u2988,
  [652797] = 6,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13335), 1,
      anon_sym_RBRACE,
    ACTIONS(13329), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13333), 3,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
    ACTIONS(13325), 5,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [652824] = 6,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13335), 1,
      sym__newline,
    ACTIONS(13329), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13333), 3,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
    ACTIONS(13325), 5,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [652851] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13339), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13337), 9,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
      anon_sym_u2988,
  [652874] = 6,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13331), 1,
      sym__newline,
    ACTIONS(13327), 3,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
    ACTIONS(13329), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13325), 5,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [652901] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13291), 4,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_RPAREN,
    ACTIONS(13289), 8,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [652924] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13343), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13341), 9,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
      anon_sym_u2988,
  [652947] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13287), 4,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13285), 8,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [652970] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13339), 4,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13337), 8,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [652993] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13343), 4,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13341), 8,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [653016] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13254), 4,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13252), 8,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [653039] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13303), 4,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_RPAREN,
    ACTIONS(13301), 8,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [653062] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13254), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13252), 9,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
      anon_sym_u2988,
  [653085] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13250), 4,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_RPAREN,
    ACTIONS(13248), 8,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [653108] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13291), 4,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13289), 8,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [653131] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13295), 4,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_RPAREN,
    ACTIONS(13293), 8,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [653154] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13299), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13297), 9,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
      anon_sym_u2988,
  [653177] = 6,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13331), 1,
      anon_sym_RBRACE,
    ACTIONS(13327), 3,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
    ACTIONS(13329), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13325), 5,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [653204] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13291), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13289), 9,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
      anon_sym_u2988,
  [653227] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13250), 4,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13248), 8,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [653250] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13295), 4,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13293), 8,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [653273] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13287), 4,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13285), 8,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [653296] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13303), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13301), 9,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
      anon_sym_u2988,
  [653319] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13339), 4,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13337), 8,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [653342] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13250), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13248), 9,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
      anon_sym_u2988,
  [653365] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13295), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13293), 9,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
      anon_sym_u2988,
  [653388] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13343), 4,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13341), 8,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [653411] = 4,
    STATE(1944), 1,
      sym__ARROW,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(14951), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(14953), 9,
      sym__newline,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_in,
  [653434] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13254), 4,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13252), 8,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [653457] = 5,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13329), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13333), 4,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_u2984,
    ACTIONS(13325), 5,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [653482] = 5,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13329), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13327), 4,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_u2984,
    ACTIONS(13325), 5,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [653507] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13287), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13285), 8,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [653530] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13299), 4,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13297), 8,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [653553] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13339), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13337), 8,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [653576] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13343), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13341), 8,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [653599] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13291), 4,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13289), 8,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [653622] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13254), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13252), 8,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [653645] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13291), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13289), 8,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [653668] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13303), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13301), 8,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [653691] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13250), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13248), 8,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [653714] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13303), 4,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13301), 8,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [653737] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13295), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13293), 8,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [653760] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13250), 4,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13248), 8,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [653783] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13295), 4,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13293), 8,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [653806] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13299), 4,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13297), 8,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [653829] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13287), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13285), 9,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [653852] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13339), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13337), 9,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [653875] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13343), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13341), 9,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [653898] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13254), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13252), 9,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [653921] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13291), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13289), 9,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [653944] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13303), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13301), 9,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [653967] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13250), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13248), 9,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [653990] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13299), 4,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13297), 8,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [654013] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13295), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13293), 9,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [654036] = 5,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13329), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13333), 4,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_where,
    ACTIONS(13325), 5,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [654061] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13303), 4,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13301), 8,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [654084] = 5,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13329), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13327), 4,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_EQ,
      anon_sym_where,
    ACTIONS(13325), 5,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [654109] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13299), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13297), 9,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_u2983,
      anon_sym_u2984,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [654132] = 10,
    ACTIONS(758), 1,
      anon_sym_DOT,
    ACTIONS(14957), 1,
      anon_sym_LPAREN,
    ACTIONS(14959), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(14961), 1,
      anon_sym_u2983,
    ACTIONS(14963), 1,
      anon_sym_LBRACE,
    ACTIONS(14965), 1,
      anon_sym_DOT_DOT,
    STATE(1459), 1,
      sym__ARROW,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(14955), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(8821), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
  [654166] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(14967), 1,
      sym_id,
    ACTIONS(14970), 1,
      anon_sym_COLON,
    ACTIONS(14972), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(14975), 1,
      anon_sym_u2983,
    ACTIONS(14978), 1,
      anon_sym_LBRACE,
    ACTIONS(14981), 1,
      anon_sym_DOT,
    ACTIONS(14984), 1,
      anon_sym_DOT_DOT,
    STATE(8632), 4,
      sym__field_name,
      sym__maybe_dotted_id,
      aux_sym__arg_ids,
      sym__arg_id,
  [654200] = 10,
    ACTIONS(758), 1,
      anon_sym_DOT,
    ACTIONS(14957), 1,
      anon_sym_LPAREN,
    ACTIONS(14959), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(14961), 1,
      anon_sym_u2983,
    ACTIONS(14963), 1,
      anon_sym_LBRACE,
    ACTIONS(14965), 1,
      anon_sym_DOT_DOT,
    STATE(1982), 1,
      sym__ARROW,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(14987), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(8821), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
  [654234] = 10,
    ACTIONS(758), 1,
      anon_sym_DOT,
    ACTIONS(14957), 1,
      anon_sym_LPAREN,
    ACTIONS(14959), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(14961), 1,
      anon_sym_u2983,
    ACTIONS(14963), 1,
      anon_sym_LBRACE,
    ACTIONS(14965), 1,
      anon_sym_DOT_DOT,
    STATE(1537), 1,
      sym__ARROW,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(14989), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(8821), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
  [654268] = 10,
    ACTIONS(758), 1,
      anon_sym_DOT,
    ACTIONS(14957), 1,
      anon_sym_LPAREN,
    ACTIONS(14959), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(14961), 1,
      anon_sym_u2983,
    ACTIONS(14963), 1,
      anon_sym_LBRACE,
    ACTIONS(14965), 1,
      anon_sym_DOT_DOT,
    STATE(1809), 1,
      sym__ARROW,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(14991), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(8821), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
  [654302] = 10,
    ACTIONS(758), 1,
      anon_sym_DOT,
    ACTIONS(14957), 1,
      anon_sym_LPAREN,
    ACTIONS(14959), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(14961), 1,
      anon_sym_u2983,
    ACTIONS(14963), 1,
      anon_sym_LBRACE,
    ACTIONS(14965), 1,
      anon_sym_DOT_DOT,
    STATE(1479), 1,
      sym__ARROW,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(14993), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(8821), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
  [654336] = 4,
    STATE(2451), 1,
      sym__ARROW,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(14995), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(14953), 8,
      sym__newline,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
  [654358] = 10,
    ACTIONS(758), 1,
      anon_sym_DOT,
    ACTIONS(14957), 1,
      anon_sym_LPAREN,
    ACTIONS(14959), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(14961), 1,
      anon_sym_u2983,
    ACTIONS(14963), 1,
      anon_sym_LBRACE,
    ACTIONS(14965), 1,
      anon_sym_DOT_DOT,
    STATE(2071), 1,
      sym__ARROW,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(14997), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(8821), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
  [654392] = 10,
    ACTIONS(758), 1,
      anon_sym_DOT,
    ACTIONS(14957), 1,
      anon_sym_LPAREN,
    ACTIONS(14959), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(14961), 1,
      anon_sym_u2983,
    ACTIONS(14963), 1,
      anon_sym_LBRACE,
    ACTIONS(14965), 1,
      anon_sym_DOT_DOT,
    STATE(1671), 1,
      sym__ARROW,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(14999), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(8821), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
  [654426] = 10,
    ACTIONS(758), 1,
      anon_sym_DOT,
    ACTIONS(14957), 1,
      anon_sym_LPAREN,
    ACTIONS(14959), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(14961), 1,
      anon_sym_u2983,
    ACTIONS(14963), 1,
      anon_sym_LBRACE,
    ACTIONS(14965), 1,
      anon_sym_DOT_DOT,
    STATE(1892), 1,
      sym__ARROW,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15001), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(8821), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
  [654460] = 10,
    ACTIONS(758), 1,
      anon_sym_DOT,
    ACTIONS(14957), 1,
      anon_sym_LPAREN,
    ACTIONS(14959), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(14961), 1,
      anon_sym_u2983,
    ACTIONS(14963), 1,
      anon_sym_LBRACE,
    ACTIONS(14965), 1,
      anon_sym_DOT_DOT,
    STATE(2616), 1,
      sym__ARROW,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15003), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(8821), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
  [654494] = 10,
    ACTIONS(758), 1,
      anon_sym_DOT,
    ACTIONS(14957), 1,
      anon_sym_LPAREN,
    ACTIONS(14959), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(14961), 1,
      anon_sym_u2983,
    ACTIONS(14963), 1,
      anon_sym_LBRACE,
    ACTIONS(14965), 1,
      anon_sym_DOT_DOT,
    STATE(1646), 1,
      sym__ARROW,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15005), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(8821), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
  [654528] = 10,
    ACTIONS(758), 1,
      anon_sym_DOT,
    ACTIONS(14957), 1,
      anon_sym_LPAREN,
    ACTIONS(14959), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(14961), 1,
      anon_sym_u2983,
    ACTIONS(14963), 1,
      anon_sym_LBRACE,
    ACTIONS(14965), 1,
      anon_sym_DOT_DOT,
    STATE(1986), 1,
      sym__ARROW,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15007), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(8821), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
  [654562] = 10,
    ACTIONS(758), 1,
      anon_sym_DOT,
    ACTIONS(14957), 1,
      anon_sym_LPAREN,
    ACTIONS(14959), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(14961), 1,
      anon_sym_u2983,
    ACTIONS(14963), 1,
      anon_sym_LBRACE,
    ACTIONS(14965), 1,
      anon_sym_DOT_DOT,
    STATE(1814), 1,
      sym__ARROW,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15009), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(8821), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
  [654596] = 10,
    ACTIONS(758), 1,
      anon_sym_DOT,
    ACTIONS(14957), 1,
      anon_sym_LPAREN,
    ACTIONS(14959), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(14961), 1,
      anon_sym_u2983,
    ACTIONS(14963), 1,
      anon_sym_LBRACE,
    ACTIONS(14965), 1,
      anon_sym_DOT_DOT,
    STATE(1518), 1,
      sym__ARROW,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15011), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(8821), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
  [654630] = 10,
    ACTIONS(758), 1,
      anon_sym_DOT,
    ACTIONS(14957), 1,
      anon_sym_LPAREN,
    ACTIONS(14959), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(14961), 1,
      anon_sym_u2983,
    ACTIONS(14963), 1,
      anon_sym_LBRACE,
    ACTIONS(14965), 1,
      anon_sym_DOT_DOT,
    STATE(1848), 1,
      sym__ARROW,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15013), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(8821), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
  [654664] = 10,
    ACTIONS(758), 1,
      anon_sym_DOT,
    ACTIONS(14957), 1,
      anon_sym_LPAREN,
    ACTIONS(14959), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(14961), 1,
      anon_sym_u2983,
    ACTIONS(14963), 1,
      anon_sym_LBRACE,
    ACTIONS(14965), 1,
      anon_sym_DOT_DOT,
    STATE(2398), 1,
      sym__ARROW,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15015), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(8821), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
  [654698] = 10,
    ACTIONS(758), 1,
      anon_sym_DOT,
    ACTIONS(14957), 1,
      anon_sym_LPAREN,
    ACTIONS(14959), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(14961), 1,
      anon_sym_u2983,
    ACTIONS(14963), 1,
      anon_sym_LBRACE,
    ACTIONS(14965), 1,
      anon_sym_DOT_DOT,
    STATE(2204), 1,
      sym__ARROW,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15017), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(8821), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
  [654732] = 10,
    ACTIONS(758), 1,
      anon_sym_DOT,
    ACTIONS(14957), 1,
      anon_sym_LPAREN,
    ACTIONS(14959), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(14961), 1,
      anon_sym_u2983,
    ACTIONS(14963), 1,
      anon_sym_LBRACE,
    ACTIONS(14965), 1,
      anon_sym_DOT_DOT,
    STATE(2657), 1,
      sym__ARROW,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15019), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(8821), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
  [654766] = 10,
    ACTIONS(758), 1,
      anon_sym_DOT,
    ACTIONS(14957), 1,
      anon_sym_LPAREN,
    ACTIONS(14959), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(14961), 1,
      anon_sym_u2983,
    ACTIONS(14963), 1,
      anon_sym_LBRACE,
    ACTIONS(14965), 1,
      anon_sym_DOT_DOT,
    STATE(1734), 1,
      sym__ARROW,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15021), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(8821), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
  [654800] = 10,
    ACTIONS(758), 1,
      anon_sym_DOT,
    ACTIONS(14957), 1,
      anon_sym_LPAREN,
    ACTIONS(14959), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(14961), 1,
      anon_sym_u2983,
    ACTIONS(14963), 1,
      anon_sym_LBRACE,
    ACTIONS(14965), 1,
      anon_sym_DOT_DOT,
    STATE(2486), 1,
      sym__ARROW,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15023), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(8821), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
  [654834] = 10,
    ACTIONS(758), 1,
      anon_sym_DOT,
    ACTIONS(14957), 1,
      anon_sym_LPAREN,
    ACTIONS(14959), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(14961), 1,
      anon_sym_u2983,
    ACTIONS(14963), 1,
      anon_sym_LBRACE,
    ACTIONS(14965), 1,
      anon_sym_DOT_DOT,
    STATE(2328), 1,
      sym__ARROW,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15025), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(8821), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
  [654868] = 4,
    STATE(1686), 1,
      sym__ARROW,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15027), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(14953), 8,
      sym__newline,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_in,
  [654890] = 10,
    ACTIONS(758), 1,
      anon_sym_DOT,
    ACTIONS(14957), 1,
      anon_sym_LPAREN,
    ACTIONS(14959), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(14961), 1,
      anon_sym_u2983,
    ACTIONS(14963), 1,
      anon_sym_LBRACE,
    ACTIONS(14965), 1,
      anon_sym_DOT_DOT,
    STATE(2479), 1,
      sym__ARROW,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15029), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(8821), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
  [654924] = 10,
    ACTIONS(758), 1,
      anon_sym_DOT,
    ACTIONS(14957), 1,
      anon_sym_LPAREN,
    ACTIONS(14959), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(14961), 1,
      anon_sym_u2983,
    ACTIONS(14963), 1,
      anon_sym_LBRACE,
    ACTIONS(14965), 1,
      anon_sym_DOT_DOT,
    STATE(2171), 1,
      sym__ARROW,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15031), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(8821), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
  [654958] = 10,
    ACTIONS(758), 1,
      anon_sym_DOT,
    ACTIONS(14957), 1,
      anon_sym_LPAREN,
    ACTIONS(14959), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(14961), 1,
      anon_sym_u2983,
    ACTIONS(14963), 1,
      anon_sym_LBRACE,
    ACTIONS(14965), 1,
      anon_sym_DOT_DOT,
    STATE(1967), 1,
      sym__ARROW,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15033), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(8821), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
  [654992] = 10,
    ACTIONS(758), 1,
      anon_sym_DOT,
    ACTIONS(14957), 1,
      anon_sym_LPAREN,
    ACTIONS(14959), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(14961), 1,
      anon_sym_u2983,
    ACTIONS(14963), 1,
      anon_sym_LBRACE,
    ACTIONS(14965), 1,
      anon_sym_DOT_DOT,
    STATE(1831), 1,
      sym__ARROW,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15035), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(8821), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
  [655026] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13305), 1,
      sym_id,
    ACTIONS(13311), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(13313), 1,
      anon_sym_u2983,
    ACTIONS(13315), 1,
      anon_sym_LBRACE,
    ACTIONS(13317), 1,
      anon_sym_DOT,
    ACTIONS(13319), 1,
      anon_sym_DOT_DOT,
    ACTIONS(15037), 1,
      anon_sym_COLON,
    STATE(8632), 4,
      sym__field_name,
      sym__maybe_dotted_id,
      aux_sym__arg_ids,
      sym__arg_id,
  [655060] = 10,
    ACTIONS(758), 1,
      anon_sym_DOT,
    ACTIONS(14957), 1,
      anon_sym_LPAREN,
    ACTIONS(14959), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(14961), 1,
      anon_sym_u2983,
    ACTIONS(14963), 1,
      anon_sym_LBRACE,
    ACTIONS(14965), 1,
      anon_sym_DOT_DOT,
    STATE(1706), 1,
      sym__ARROW,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15039), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(8821), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
  [655094] = 10,
    ACTIONS(758), 1,
      anon_sym_DOT,
    ACTIONS(14957), 1,
      anon_sym_LPAREN,
    ACTIONS(14959), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(14961), 1,
      anon_sym_u2983,
    ACTIONS(14963), 1,
      anon_sym_LBRACE,
    ACTIONS(14965), 1,
      anon_sym_DOT_DOT,
    STATE(1590), 1,
      sym__ARROW,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15041), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(8821), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
  [655128] = 2,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15043), 11,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2984,
      anon_sym_PIPE_RPAREN,
      anon_sym_u2988,
  [655146] = 10,
    ACTIONS(758), 1,
      anon_sym_DOT,
    ACTIONS(14957), 1,
      anon_sym_LPAREN,
    ACTIONS(14959), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(14961), 1,
      anon_sym_u2983,
    ACTIONS(14963), 1,
      anon_sym_LBRACE,
    ACTIONS(14965), 1,
      anon_sym_DOT_DOT,
    STATE(1667), 1,
      sym__ARROW,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15045), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(8821), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
  [655180] = 2,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(13331), 11,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2984,
      anon_sym_PIPE_RPAREN,
      anon_sym_u2988,
  [655198] = 5,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(15047), 1,
      anon_sym_AT,
    ACTIONS(6326), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(6324), 7,
      anon_sym_COLON,
      anon_sym_where,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [655222] = 10,
    ACTIONS(758), 1,
      anon_sym_DOT,
    ACTIONS(14957), 1,
      anon_sym_LPAREN,
    ACTIONS(14959), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(14961), 1,
      anon_sym_u2983,
    ACTIONS(14963), 1,
      anon_sym_LBRACE,
    ACTIONS(14965), 1,
      anon_sym_DOT_DOT,
    STATE(2066), 1,
      sym__ARROW,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15049), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(8821), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
  [655256] = 10,
    ACTIONS(758), 1,
      anon_sym_DOT,
    ACTIONS(14957), 1,
      anon_sym_LPAREN,
    ACTIONS(14959), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(14961), 1,
      anon_sym_u2983,
    ACTIONS(14963), 1,
      anon_sym_LBRACE,
    ACTIONS(14965), 1,
      anon_sym_DOT_DOT,
    STATE(1538), 1,
      sym__ARROW,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15051), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(8821), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
  [655290] = 10,
    ACTIONS(758), 1,
      anon_sym_DOT,
    ACTIONS(14957), 1,
      anon_sym_LPAREN,
    ACTIONS(14959), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(14961), 1,
      anon_sym_u2983,
    ACTIONS(14963), 1,
      anon_sym_LBRACE,
    ACTIONS(14965), 1,
      anon_sym_DOT_DOT,
    STATE(1653), 1,
      sym__ARROW,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15053), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(8821), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
  [655324] = 4,
    STATE(1721), 1,
      sym__ARROW,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15055), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(14953), 8,
      sym__newline,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_in,
  [655346] = 10,
    ACTIONS(758), 1,
      anon_sym_DOT,
    ACTIONS(14957), 1,
      anon_sym_LPAREN,
    ACTIONS(14959), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(14961), 1,
      anon_sym_u2983,
    ACTIONS(14963), 1,
      anon_sym_LBRACE,
    ACTIONS(14965), 1,
      anon_sym_DOT_DOT,
    STATE(1475), 1,
      sym__ARROW,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15057), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(8821), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
  [655380] = 10,
    ACTIONS(758), 1,
      anon_sym_DOT,
    ACTIONS(14957), 1,
      anon_sym_LPAREN,
    ACTIONS(14959), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(14961), 1,
      anon_sym_u2983,
    ACTIONS(14963), 1,
      anon_sym_LBRACE,
    ACTIONS(14965), 1,
      anon_sym_DOT_DOT,
    STATE(1807), 1,
      sym__ARROW,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15059), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(8821), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
  [655414] = 10,
    ACTIONS(758), 1,
      anon_sym_DOT,
    ACTIONS(14957), 1,
      anon_sym_LPAREN,
    ACTIONS(14959), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(14961), 1,
      anon_sym_u2983,
    ACTIONS(14963), 1,
      anon_sym_LBRACE,
    ACTIONS(14965), 1,
      anon_sym_DOT_DOT,
    STATE(1907), 1,
      sym__ARROW,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15061), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(8821), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
  [655448] = 10,
    ACTIONS(758), 1,
      anon_sym_DOT,
    ACTIONS(14957), 1,
      anon_sym_LPAREN,
    ACTIONS(14959), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(14961), 1,
      anon_sym_u2983,
    ACTIONS(14963), 1,
      anon_sym_LBRACE,
    ACTIONS(14965), 1,
      anon_sym_DOT_DOT,
    STATE(2156), 1,
      sym__ARROW,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15063), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(8821), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
  [655482] = 10,
    ACTIONS(758), 1,
      anon_sym_DOT,
    ACTIONS(14957), 1,
      anon_sym_LPAREN,
    ACTIONS(14959), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(14961), 1,
      anon_sym_u2983,
    ACTIONS(14963), 1,
      anon_sym_LBRACE,
    ACTIONS(14965), 1,
      anon_sym_DOT_DOT,
    STATE(1931), 1,
      sym__ARROW,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15065), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(8821), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
  [655516] = 10,
    ACTIONS(758), 1,
      anon_sym_DOT,
    ACTIONS(14957), 1,
      anon_sym_LPAREN,
    ACTIONS(14959), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(14961), 1,
      anon_sym_u2983,
    ACTIONS(14963), 1,
      anon_sym_LBRACE,
    ACTIONS(14965), 1,
      anon_sym_DOT_DOT,
    STATE(1642), 1,
      sym__ARROW,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15067), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(8821), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
  [655550] = 10,
    ACTIONS(758), 1,
      anon_sym_DOT,
    ACTIONS(14957), 1,
      anon_sym_LPAREN,
    ACTIONS(14959), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(14961), 1,
      anon_sym_u2983,
    ACTIONS(14963), 1,
      anon_sym_LBRACE,
    ACTIONS(14965), 1,
      anon_sym_DOT_DOT,
    STATE(2613), 1,
      sym__ARROW,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15069), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(8821), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
  [655584] = 10,
    ACTIONS(758), 1,
      anon_sym_DOT,
    ACTIONS(14957), 1,
      anon_sym_LPAREN,
    ACTIONS(14959), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(14961), 1,
      anon_sym_u2983,
    ACTIONS(14963), 1,
      anon_sym_LBRACE,
    ACTIONS(14965), 1,
      anon_sym_DOT_DOT,
    STATE(2467), 1,
      sym__ARROW,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15071), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(8821), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
  [655618] = 2,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(13331), 11,
      sym__newline,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_in,
  [655636] = 10,
    ACTIONS(758), 1,
      anon_sym_DOT,
    ACTIONS(14957), 1,
      anon_sym_LPAREN,
    ACTIONS(14959), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(14961), 1,
      anon_sym_u2983,
    ACTIONS(14963), 1,
      anon_sym_LBRACE,
    ACTIONS(14965), 1,
      anon_sym_DOT_DOT,
    STATE(2292), 1,
      sym__ARROW,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15073), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(8821), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
  [655670] = 10,
    ACTIONS(758), 1,
      anon_sym_DOT,
    ACTIONS(14957), 1,
      anon_sym_LPAREN,
    ACTIONS(14959), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(14961), 1,
      anon_sym_u2983,
    ACTIONS(14963), 1,
      anon_sym_LBRACE,
    ACTIONS(14965), 1,
      anon_sym_DOT_DOT,
    STATE(2282), 1,
      sym__ARROW,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15075), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(8821), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
  [655704] = 10,
    ACTIONS(758), 1,
      anon_sym_DOT,
    ACTIONS(14957), 1,
      anon_sym_LPAREN,
    ACTIONS(14959), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(14961), 1,
      anon_sym_u2983,
    ACTIONS(14963), 1,
      anon_sym_LBRACE,
    ACTIONS(14965), 1,
      anon_sym_DOT_DOT,
    STATE(2540), 1,
      sym__ARROW,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15077), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(8821), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
  [655738] = 2,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15043), 11,
      sym__newline,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_in,
  [655756] = 10,
    ACTIONS(758), 1,
      anon_sym_DOT,
    ACTIONS(14957), 1,
      anon_sym_LPAREN,
    ACTIONS(14959), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(14961), 1,
      anon_sym_u2983,
    ACTIONS(14963), 1,
      anon_sym_LBRACE,
    ACTIONS(14965), 1,
      anon_sym_DOT_DOT,
    STATE(2380), 1,
      sym__ARROW,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15079), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(8821), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
  [655790] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13305), 1,
      sym_id,
    ACTIONS(13311), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(13313), 1,
      anon_sym_u2983,
    ACTIONS(13315), 1,
      anon_sym_LBRACE,
    ACTIONS(13317), 1,
      anon_sym_DOT,
    ACTIONS(13319), 1,
      anon_sym_DOT_DOT,
    ACTIONS(15081), 1,
      anon_sym_COLON,
    STATE(8632), 4,
      sym__field_name,
      sym__maybe_dotted_id,
      aux_sym__arg_ids,
      sym__arg_id,
  [655824] = 10,
    ACTIONS(758), 1,
      anon_sym_DOT,
    ACTIONS(14957), 1,
      anon_sym_LPAREN,
    ACTIONS(14959), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(14961), 1,
      anon_sym_u2983,
    ACTIONS(14963), 1,
      anon_sym_LBRACE,
    ACTIONS(14965), 1,
      anon_sym_DOT_DOT,
    STATE(2445), 1,
      sym__ARROW,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15083), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(8821), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
  [655858] = 10,
    ACTIONS(758), 1,
      anon_sym_DOT,
    ACTIONS(14957), 1,
      anon_sym_LPAREN,
    ACTIONS(14959), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(14961), 1,
      anon_sym_u2983,
    ACTIONS(14963), 1,
      anon_sym_LBRACE,
    ACTIONS(14965), 1,
      anon_sym_DOT_DOT,
    STATE(2586), 1,
      sym__ARROW,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15085), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(8821), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
  [655892] = 10,
    ACTIONS(758), 1,
      anon_sym_DOT,
    ACTIONS(14957), 1,
      anon_sym_LPAREN,
    ACTIONS(14959), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(14961), 1,
      anon_sym_u2983,
    ACTIONS(14963), 1,
      anon_sym_LBRACE,
    ACTIONS(14965), 1,
      anon_sym_DOT_DOT,
    STATE(2139), 1,
      sym__ARROW,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15087), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(8821), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
  [655926] = 10,
    ACTIONS(758), 1,
      anon_sym_DOT,
    ACTIONS(14957), 1,
      anon_sym_LPAREN,
    ACTIONS(14959), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(14961), 1,
      anon_sym_u2983,
    ACTIONS(14963), 1,
      anon_sym_LBRACE,
    ACTIONS(14965), 1,
      anon_sym_DOT_DOT,
    STATE(1732), 1,
      sym__ARROW,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15089), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(8821), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
  [655960] = 10,
    ACTIONS(758), 1,
      anon_sym_DOT,
    ACTIONS(14957), 1,
      anon_sym_LPAREN,
    ACTIONS(14959), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(14961), 1,
      anon_sym_u2983,
    ACTIONS(14963), 1,
      anon_sym_LBRACE,
    ACTIONS(14965), 1,
      anon_sym_DOT_DOT,
    STATE(2027), 1,
      sym__ARROW,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15091), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(8821), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
  [655994] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(15093), 1,
      sym_id,
    ACTIONS(15095), 1,
      anon_sym_RBRACE,
    STATE(4064), 1,
      sym_module_name,
    STATE(7262), 1,
      sym__qid,
    STATE(9037), 1,
      aux_sym__record_assignments_repeat1,
    STATE(12091), 1,
      sym__record_assignments,
    STATE(9733), 3,
      sym__record_assignment,
      sym_field_assignment,
      sym_module_assignment,
  [656027] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(15093), 1,
      sym_id,
    ACTIONS(15097), 1,
      anon_sym_RBRACE,
    STATE(4064), 1,
      sym_module_name,
    STATE(7262), 1,
      sym__qid,
    STATE(9037), 1,
      aux_sym__record_assignments_repeat1,
    STATE(10678), 1,
      sym__record_assignments,
    STATE(9733), 3,
      sym__record_assignment,
      sym_field_assignment,
      sym_module_assignment,
  [656060] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(15093), 1,
      sym_id,
    ACTIONS(15099), 1,
      anon_sym_RBRACE,
    STATE(4064), 1,
      sym_module_name,
    STATE(7262), 1,
      sym__qid,
    STATE(9037), 1,
      aux_sym__record_assignments_repeat1,
    STATE(12436), 1,
      sym__record_assignments,
    STATE(9733), 3,
      sym__record_assignment,
      sym_field_assignment,
      sym_module_assignment,
  [656093] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(15093), 1,
      sym_id,
    ACTIONS(15101), 1,
      anon_sym_RBRACE,
    STATE(4064), 1,
      sym_module_name,
    STATE(7262), 1,
      sym__qid,
    STATE(9037), 1,
      aux_sym__record_assignments_repeat1,
    STATE(10240), 1,
      sym__record_assignments,
    STATE(9733), 3,
      sym__record_assignment,
      sym_field_assignment,
      sym_module_assignment,
  [656126] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(15093), 1,
      sym_id,
    ACTIONS(15103), 1,
      anon_sym_RBRACE,
    STATE(4064), 1,
      sym_module_name,
    STATE(7262), 1,
      sym__qid,
    STATE(9037), 1,
      aux_sym__record_assignments_repeat1,
    STATE(11425), 1,
      sym__record_assignments,
    STATE(9733), 3,
      sym__record_assignment,
      sym_field_assignment,
      sym_module_assignment,
  [656159] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(15093), 1,
      sym_id,
    ACTIONS(15105), 1,
      anon_sym_RBRACE,
    STATE(4064), 1,
      sym_module_name,
    STATE(7262), 1,
      sym__qid,
    STATE(9037), 1,
      aux_sym__record_assignments_repeat1,
    STATE(11416), 1,
      sym__record_assignments,
    STATE(9733), 3,
      sym__record_assignment,
      sym_field_assignment,
      sym_module_assignment,
  [656192] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(15093), 1,
      sym_id,
    ACTIONS(15107), 1,
      anon_sym_RBRACE,
    STATE(4064), 1,
      sym_module_name,
    STATE(7262), 1,
      sym__qid,
    STATE(9037), 1,
      aux_sym__record_assignments_repeat1,
    STATE(12327), 1,
      sym__record_assignments,
    STATE(9733), 3,
      sym__record_assignment,
      sym_field_assignment,
      sym_module_assignment,
  [656225] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(15093), 1,
      sym_id,
    ACTIONS(15109), 1,
      anon_sym_RBRACE,
    STATE(4064), 1,
      sym_module_name,
    STATE(7262), 1,
      sym__qid,
    STATE(9037), 1,
      aux_sym__record_assignments_repeat1,
    STATE(11464), 1,
      sym__record_assignments,
    STATE(9733), 3,
      sym__record_assignment,
      sym_field_assignment,
      sym_module_assignment,
  [656258] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(15093), 1,
      sym_id,
    ACTIONS(15111), 1,
      anon_sym_RBRACE,
    STATE(4064), 1,
      sym_module_name,
    STATE(7262), 1,
      sym__qid,
    STATE(9037), 1,
      aux_sym__record_assignments_repeat1,
    STATE(12809), 1,
      sym__record_assignments,
    STATE(9733), 3,
      sym__record_assignment,
      sym_field_assignment,
      sym_module_assignment,
  [656291] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(15093), 1,
      sym_id,
    ACTIONS(15113), 1,
      anon_sym_RBRACE,
    STATE(4064), 1,
      sym_module_name,
    STATE(7262), 1,
      sym__qid,
    STATE(9037), 1,
      aux_sym__record_assignments_repeat1,
    STATE(12410), 1,
      sym__record_assignments,
    STATE(9733), 3,
      sym__record_assignment,
      sym_field_assignment,
      sym_module_assignment,
  [656324] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(15093), 1,
      sym_id,
    ACTIONS(15115), 1,
      anon_sym_RBRACE,
    STATE(4064), 1,
      sym_module_name,
    STATE(7262), 1,
      sym__qid,
    STATE(9037), 1,
      aux_sym__record_assignments_repeat1,
    STATE(12377), 1,
      sym__record_assignments,
    STATE(9733), 3,
      sym__record_assignment,
      sym_field_assignment,
      sym_module_assignment,
  [656357] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(15093), 1,
      sym_id,
    ACTIONS(15117), 1,
      anon_sym_RBRACE,
    STATE(4064), 1,
      sym_module_name,
    STATE(7262), 1,
      sym__qid,
    STATE(9037), 1,
      aux_sym__record_assignments_repeat1,
    STATE(10263), 1,
      sym__record_assignments,
    STATE(9733), 3,
      sym__record_assignment,
      sym_field_assignment,
      sym_module_assignment,
  [656390] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13283), 4,
      sym__dedent,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
      anon_sym_AT,
    ACTIONS(15119), 6,
      anon_sym_overlap,
      anon_sym_instance,
      anon_sym_u2983,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [656411] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(15093), 1,
      sym_id,
    ACTIONS(15121), 1,
      anon_sym_RBRACE,
    STATE(4064), 1,
      sym_module_name,
    STATE(7262), 1,
      sym__qid,
    STATE(9037), 1,
      aux_sym__record_assignments_repeat1,
    STATE(11775), 1,
      sym__record_assignments,
    STATE(9733), 3,
      sym__record_assignment,
      sym_field_assignment,
      sym_module_assignment,
  [656444] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(15093), 1,
      sym_id,
    ACTIONS(15123), 1,
      anon_sym_RBRACE,
    STATE(4064), 1,
      sym_module_name,
    STATE(7262), 1,
      sym__qid,
    STATE(9037), 1,
      aux_sym__record_assignments_repeat1,
    STATE(11505), 1,
      sym__record_assignments,
    STATE(9733), 3,
      sym__record_assignment,
      sym_field_assignment,
      sym_module_assignment,
  [656477] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(15093), 1,
      sym_id,
    ACTIONS(15125), 1,
      anon_sym_RBRACE,
    STATE(4064), 1,
      sym_module_name,
    STATE(7262), 1,
      sym__qid,
    STATE(9037), 1,
      aux_sym__record_assignments_repeat1,
    STATE(12374), 1,
      sym__record_assignments,
    STATE(9733), 3,
      sym__record_assignment,
      sym_field_assignment,
      sym_module_assignment,
  [656510] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(15093), 1,
      sym_id,
    ACTIONS(15127), 1,
      anon_sym_RBRACE,
    STATE(4064), 1,
      sym_module_name,
    STATE(7262), 1,
      sym__qid,
    STATE(9037), 1,
      aux_sym__record_assignments_repeat1,
    STATE(10292), 1,
      sym__record_assignments,
    STATE(9733), 3,
      sym__record_assignment,
      sym_field_assignment,
      sym_module_assignment,
  [656543] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(15093), 1,
      sym_id,
    ACTIONS(15129), 1,
      anon_sym_RBRACE,
    STATE(4064), 1,
      sym_module_name,
    STATE(7262), 1,
      sym__qid,
    STATE(9037), 1,
      aux_sym__record_assignments_repeat1,
    STATE(11601), 1,
      sym__record_assignments,
    STATE(9733), 3,
      sym__record_assignment,
      sym_field_assignment,
      sym_module_assignment,
  [656576] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(15093), 1,
      sym_id,
    ACTIONS(15131), 1,
      anon_sym_RBRACE,
    STATE(4064), 1,
      sym_module_name,
    STATE(7262), 1,
      sym__qid,
    STATE(9037), 1,
      aux_sym__record_assignments_repeat1,
    STATE(12307), 1,
      sym__record_assignments,
    STATE(9733), 3,
      sym__record_assignment,
      sym_field_assignment,
      sym_module_assignment,
  [656609] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(15093), 1,
      sym_id,
    ACTIONS(15133), 1,
      anon_sym_RBRACE,
    STATE(4064), 1,
      sym_module_name,
    STATE(7262), 1,
      sym__qid,
    STATE(9037), 1,
      aux_sym__record_assignments_repeat1,
    STATE(11809), 1,
      sym__record_assignments,
    STATE(9733), 3,
      sym__record_assignment,
      sym_field_assignment,
      sym_module_assignment,
  [656642] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(15093), 1,
      sym_id,
    ACTIONS(15135), 1,
      anon_sym_RBRACE,
    STATE(4064), 1,
      sym_module_name,
    STATE(7262), 1,
      sym__qid,
    STATE(9037), 1,
      aux_sym__record_assignments_repeat1,
    STATE(11383), 1,
      sym__record_assignments,
    STATE(9733), 3,
      sym__record_assignment,
      sym_field_assignment,
      sym_module_assignment,
  [656675] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(15093), 1,
      sym_id,
    ACTIONS(15137), 1,
      anon_sym_RBRACE,
    STATE(4064), 1,
      sym_module_name,
    STATE(7262), 1,
      sym__qid,
    STATE(9037), 1,
      aux_sym__record_assignments_repeat1,
    STATE(12799), 1,
      sym__record_assignments,
    STATE(9733), 3,
      sym__record_assignment,
      sym_field_assignment,
      sym_module_assignment,
  [656708] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13343), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13341), 7,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [656729] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(15093), 1,
      sym_id,
    ACTIONS(15139), 1,
      anon_sym_RBRACE,
    STATE(4064), 1,
      sym_module_name,
    STATE(7262), 1,
      sym__qid,
    STATE(9037), 1,
      aux_sym__record_assignments_repeat1,
    STATE(11391), 1,
      sym__record_assignments,
    STATE(9733), 3,
      sym__record_assignment,
      sym_field_assignment,
      sym_module_assignment,
  [656762] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(15093), 1,
      sym_id,
    ACTIONS(15141), 1,
      anon_sym_RBRACE,
    STATE(4064), 1,
      sym_module_name,
    STATE(7262), 1,
      sym__qid,
    STATE(9037), 1,
      aux_sym__record_assignments_repeat1,
    STATE(10301), 1,
      sym__record_assignments,
    STATE(9733), 3,
      sym__record_assignment,
      sym_field_assignment,
      sym_module_assignment,
  [656795] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(15093), 1,
      sym_id,
    ACTIONS(15143), 1,
      anon_sym_RBRACE,
    STATE(4064), 1,
      sym_module_name,
    STATE(7262), 1,
      sym__qid,
    STATE(9037), 1,
      aux_sym__record_assignments_repeat1,
    STATE(11788), 1,
      sym__record_assignments,
    STATE(9733), 3,
      sym__record_assignment,
      sym_field_assignment,
      sym_module_assignment,
  [656828] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(15093), 1,
      sym_id,
    ACTIONS(15145), 1,
      anon_sym_RBRACE,
    STATE(4064), 1,
      sym_module_name,
    STATE(7262), 1,
      sym__qid,
    STATE(9037), 1,
      aux_sym__record_assignments_repeat1,
    STATE(12341), 1,
      sym__record_assignments,
    STATE(9733), 3,
      sym__record_assignment,
      sym_field_assignment,
      sym_module_assignment,
  [656861] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(15093), 1,
      sym_id,
    ACTIONS(15147), 1,
      anon_sym_RBRACE,
    STATE(4064), 1,
      sym_module_name,
    STATE(7262), 1,
      sym__qid,
    STATE(9037), 1,
      aux_sym__record_assignments_repeat1,
    STATE(10336), 1,
      sym__record_assignments,
    STATE(9733), 3,
      sym__record_assignment,
      sym_field_assignment,
      sym_module_assignment,
  [656894] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(15093), 1,
      sym_id,
    ACTIONS(15149), 1,
      anon_sym_RBRACE,
    STATE(4064), 1,
      sym_module_name,
    STATE(7262), 1,
      sym__qid,
    STATE(9037), 1,
      aux_sym__record_assignments_repeat1,
    STATE(12787), 1,
      sym__record_assignments,
    STATE(9733), 3,
      sym__record_assignment,
      sym_field_assignment,
      sym_module_assignment,
  [656927] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(15093), 1,
      sym_id,
    ACTIONS(15151), 1,
      anon_sym_RBRACE,
    STATE(4064), 1,
      sym_module_name,
    STATE(7262), 1,
      sym__qid,
    STATE(9037), 1,
      aux_sym__record_assignments_repeat1,
    STATE(11500), 1,
      sym__record_assignments,
    STATE(9733), 3,
      sym__record_assignment,
      sym_field_assignment,
      sym_module_assignment,
  [656960] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(15155), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(15153), 7,
      anon_sym_COLON,
      anon_sym_where,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [656981] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(15093), 1,
      sym_id,
    ACTIONS(15157), 1,
      anon_sym_RBRACE,
    STATE(4064), 1,
      sym_module_name,
    STATE(7262), 1,
      sym__qid,
    STATE(9037), 1,
      aux_sym__record_assignments_repeat1,
    STATE(12291), 1,
      sym__record_assignments,
    STATE(9733), 3,
      sym__record_assignment,
      sym_field_assignment,
      sym_module_assignment,
  [657014] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(15093), 1,
      sym_id,
    ACTIONS(15159), 1,
      anon_sym_RBRACE,
    STATE(4064), 1,
      sym_module_name,
    STATE(7262), 1,
      sym__qid,
    STATE(9037), 1,
      aux_sym__record_assignments_repeat1,
    STATE(12584), 1,
      sym__record_assignments,
    STATE(9733), 3,
      sym__record_assignment,
      sym_field_assignment,
      sym_module_assignment,
  [657047] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(15093), 1,
      sym_id,
    ACTIONS(15161), 1,
      anon_sym_RBRACE,
    STATE(4064), 1,
      sym_module_name,
    STATE(7262), 1,
      sym__qid,
    STATE(9037), 1,
      aux_sym__record_assignments_repeat1,
    STATE(12779), 1,
      sym__record_assignments,
    STATE(9733), 3,
      sym__record_assignment,
      sym_field_assignment,
      sym_module_assignment,
  [657080] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(15093), 1,
      sym_id,
    ACTIONS(15163), 1,
      anon_sym_RBRACE,
    STATE(4064), 1,
      sym_module_name,
    STATE(7262), 1,
      sym__qid,
    STATE(9037), 1,
      aux_sym__record_assignments_repeat1,
    STATE(10340), 1,
      sym__record_assignments,
    STATE(9733), 3,
      sym__record_assignment,
      sym_field_assignment,
      sym_module_assignment,
  [657113] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(15093), 1,
      sym_id,
    ACTIONS(15165), 1,
      anon_sym_RBRACE,
    STATE(4064), 1,
      sym_module_name,
    STATE(7262), 1,
      sym__qid,
    STATE(9037), 1,
      aux_sym__record_assignments_repeat1,
    STATE(12425), 1,
      sym__record_assignments,
    STATE(9733), 3,
      sym__record_assignment,
      sym_field_assignment,
      sym_module_assignment,
  [657146] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(15093), 1,
      sym_id,
    ACTIONS(15167), 1,
      anon_sym_RBRACE,
    STATE(4064), 1,
      sym_module_name,
    STATE(7262), 1,
      sym__qid,
    STATE(9037), 1,
      aux_sym__record_assignments_repeat1,
    STATE(11348), 1,
      sym__record_assignments,
    STATE(9733), 3,
      sym__record_assignment,
      sym_field_assignment,
      sym_module_assignment,
  [657179] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(15093), 1,
      sym_id,
    ACTIONS(15169), 1,
      anon_sym_RBRACE,
    STATE(4064), 1,
      sym_module_name,
    STATE(7262), 1,
      sym__qid,
    STATE(9037), 1,
      aux_sym__record_assignments_repeat1,
    STATE(11802), 1,
      sym__record_assignments,
    STATE(9733), 3,
      sym__record_assignment,
      sym_field_assignment,
      sym_module_assignment,
  [657212] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(15093), 1,
      sym_id,
    ACTIONS(15171), 1,
      anon_sym_RBRACE,
    STATE(4064), 1,
      sym_module_name,
    STATE(7262), 1,
      sym__qid,
    STATE(9037), 1,
      aux_sym__record_assignments_repeat1,
    STATE(11354), 1,
      sym__record_assignments,
    STATE(9733), 3,
      sym__record_assignment,
      sym_field_assignment,
      sym_module_assignment,
  [657245] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(15093), 1,
      sym_id,
    ACTIONS(15173), 1,
      anon_sym_RBRACE,
    STATE(4064), 1,
      sym_module_name,
    STATE(7262), 1,
      sym__qid,
    STATE(9037), 1,
      aux_sym__record_assignments_repeat1,
    STATE(10378), 1,
      sym__record_assignments,
    STATE(9733), 3,
      sym__record_assignment,
      sym_field_assignment,
      sym_module_assignment,
  [657278] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(15093), 1,
      sym_id,
    ACTIONS(15175), 1,
      anon_sym_RBRACE,
    STATE(4064), 1,
      sym_module_name,
    STATE(7262), 1,
      sym__qid,
    STATE(9037), 1,
      aux_sym__record_assignments_repeat1,
    STATE(12124), 1,
      sym__record_assignments,
    STATE(9733), 3,
      sym__record_assignment,
      sym_field_assignment,
      sym_module_assignment,
  [657311] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(15093), 1,
      sym_id,
    ACTIONS(15177), 1,
      anon_sym_RBRACE,
    STATE(4064), 1,
      sym_module_name,
    STATE(7262), 1,
      sym__qid,
    STATE(9037), 1,
      aux_sym__record_assignments_repeat1,
    STATE(11614), 1,
      sym__record_assignments,
    STATE(9733), 3,
      sym__record_assignment,
      sym_field_assignment,
      sym_module_assignment,
  [657344] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(15093), 1,
      sym_id,
    ACTIONS(15179), 1,
      anon_sym_RBRACE,
    STATE(4064), 1,
      sym_module_name,
    STATE(7262), 1,
      sym__qid,
    STATE(9037), 1,
      aux_sym__record_assignments_repeat1,
    STATE(12472), 1,
      sym__record_assignments,
    STATE(9733), 3,
      sym__record_assignment,
      sym_field_assignment,
      sym_module_assignment,
  [657377] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(15093), 1,
      sym_id,
    ACTIONS(15181), 1,
      anon_sym_RBRACE,
    STATE(4064), 1,
      sym_module_name,
    STATE(7262), 1,
      sym__qid,
    STATE(9037), 1,
      aux_sym__record_assignments_repeat1,
    STATE(11314), 1,
      sym__record_assignments,
    STATE(9733), 3,
      sym__record_assignment,
      sym_field_assignment,
      sym_module_assignment,
  [657410] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(15093), 1,
      sym_id,
    ACTIONS(15183), 1,
      anon_sym_RBRACE,
    STATE(4064), 1,
      sym_module_name,
    STATE(7262), 1,
      sym__qid,
    STATE(9037), 1,
      aux_sym__record_assignments_repeat1,
    STATE(12271), 1,
      sym__record_assignments,
    STATE(9733), 3,
      sym__record_assignment,
      sym_field_assignment,
      sym_module_assignment,
  [657443] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(15093), 1,
      sym_id,
    ACTIONS(15185), 1,
      anon_sym_RBRACE,
    STATE(4064), 1,
      sym_module_name,
    STATE(7262), 1,
      sym__qid,
    STATE(9037), 1,
      aux_sym__record_assignments_repeat1,
    STATE(11737), 1,
      sym__record_assignments,
    STATE(9733), 3,
      sym__record_assignment,
      sym_field_assignment,
      sym_module_assignment,
  [657476] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(15093), 1,
      sym_id,
    ACTIONS(15187), 1,
      anon_sym_RBRACE,
    STATE(4064), 1,
      sym_module_name,
    STATE(7262), 1,
      sym__qid,
    STATE(9037), 1,
      aux_sym__record_assignments_repeat1,
    STATE(12770), 1,
      sym__record_assignments,
    STATE(9733), 3,
      sym__record_assignment,
      sym_field_assignment,
      sym_module_assignment,
  [657509] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(15093), 1,
      sym_id,
    ACTIONS(15189), 1,
      anon_sym_RBRACE,
    STATE(4064), 1,
      sym_module_name,
    STATE(7262), 1,
      sym__qid,
    STATE(9037), 1,
      aux_sym__record_assignments_repeat1,
    STATE(10440), 1,
      sym__record_assignments,
    STATE(9733), 3,
      sym__record_assignment,
      sym_field_assignment,
      sym_module_assignment,
  [657542] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(15093), 1,
      sym_id,
    ACTIONS(15191), 1,
      anon_sym_RBRACE,
    STATE(4064), 1,
      sym_module_name,
    STATE(7262), 1,
      sym__qid,
    STATE(9037), 1,
      aux_sym__record_assignments_repeat1,
    STATE(10416), 1,
      sym__record_assignments,
    STATE(9733), 3,
      sym__record_assignment,
      sym_field_assignment,
      sym_module_assignment,
  [657575] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(15093), 1,
      sym_id,
    ACTIONS(15193), 1,
      anon_sym_RBRACE,
    STATE(4064), 1,
      sym_module_name,
    STATE(7262), 1,
      sym__qid,
    STATE(9037), 1,
      aux_sym__record_assignments_repeat1,
    STATE(11317), 1,
      sym__record_assignments,
    STATE(9733), 3,
      sym__record_assignment,
      sym_field_assignment,
      sym_module_assignment,
  [657608] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(15093), 1,
      sym_id,
    ACTIONS(15195), 1,
      anon_sym_RBRACE,
    STATE(4064), 1,
      sym_module_name,
    STATE(7262), 1,
      sym__qid,
    STATE(9037), 1,
      aux_sym__record_assignments_repeat1,
    STATE(11527), 1,
      sym__record_assignments,
    STATE(9733), 3,
      sym__record_assignment,
      sym_field_assignment,
      sym_module_assignment,
  [657641] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(15093), 1,
      sym_id,
    ACTIONS(15197), 1,
      anon_sym_RBRACE,
    STATE(4064), 1,
      sym_module_name,
    STATE(7262), 1,
      sym__qid,
    STATE(9037), 1,
      aux_sym__record_assignments_repeat1,
    STATE(11814), 1,
      sym__record_assignments,
    STATE(9733), 3,
      sym__record_assignment,
      sym_field_assignment,
      sym_module_assignment,
  [657674] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(15093), 1,
      sym_id,
    ACTIONS(15199), 1,
      anon_sym_RBRACE,
    STATE(4064), 1,
      sym_module_name,
    STATE(7262), 1,
      sym__qid,
    STATE(9037), 1,
      aux_sym__record_assignments_repeat1,
    STATE(12439), 1,
      sym__record_assignments,
    STATE(9733), 3,
      sym__record_assignment,
      sym_field_assignment,
      sym_module_assignment,
  [657707] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(15093), 1,
      sym_id,
    ACTIONS(15201), 1,
      anon_sym_RBRACE,
    STATE(4064), 1,
      sym_module_name,
    STATE(7262), 1,
      sym__qid,
    STATE(9037), 1,
      aux_sym__record_assignments_repeat1,
    STATE(12303), 1,
      sym__record_assignments,
    STATE(9733), 3,
      sym__record_assignment,
      sym_field_assignment,
      sym_module_assignment,
  [657740] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(15093), 1,
      sym_id,
    ACTIONS(15203), 1,
      anon_sym_RBRACE,
    STATE(4064), 1,
      sym_module_name,
    STATE(7262), 1,
      sym__qid,
    STATE(9037), 1,
      aux_sym__record_assignments_repeat1,
    STATE(11279), 1,
      sym__record_assignments,
    STATE(9733), 3,
      sym__record_assignment,
      sym_field_assignment,
      sym_module_assignment,
  [657773] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(15093), 1,
      sym_id,
    ACTIONS(15205), 1,
      anon_sym_RBRACE,
    STATE(4064), 1,
      sym_module_name,
    STATE(7262), 1,
      sym__qid,
    STATE(9037), 1,
      aux_sym__record_assignments_repeat1,
    STATE(11624), 1,
      sym__record_assignments,
    STATE(9733), 3,
      sym__record_assignment,
      sym_field_assignment,
      sym_module_assignment,
  [657806] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(15093), 1,
      sym_id,
    ACTIONS(15207), 1,
      anon_sym_RBRACE,
    STATE(4064), 1,
      sym_module_name,
    STATE(7262), 1,
      sym__qid,
    STATE(9037), 1,
      aux_sym__record_assignments_repeat1,
    STATE(12756), 1,
      sym__record_assignments,
    STATE(9733), 3,
      sym__record_assignment,
      sym_field_assignment,
      sym_module_assignment,
  [657839] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(15093), 1,
      sym_id,
    ACTIONS(15209), 1,
      anon_sym_RBRACE,
    STATE(4064), 1,
      sym_module_name,
    STATE(7262), 1,
      sym__qid,
    STATE(9037), 1,
      aux_sym__record_assignments_repeat1,
    STATE(12244), 1,
      sym__record_assignments,
    STATE(9733), 3,
      sym__record_assignment,
      sym_field_assignment,
      sym_module_assignment,
  [657872] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(15093), 1,
      sym_id,
    ACTIONS(15211), 1,
      anon_sym_RBRACE,
    STATE(4064), 1,
      sym_module_name,
    STATE(7262), 1,
      sym__qid,
    STATE(9037), 1,
      aux_sym__record_assignments_repeat1,
    STATE(11283), 1,
      sym__record_assignments,
    STATE(9733), 3,
      sym__record_assignment,
      sym_field_assignment,
      sym_module_assignment,
  [657905] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13299), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13297), 7,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [657926] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(15093), 1,
      sym_id,
    ACTIONS(15213), 1,
      anon_sym_RBRACE,
    STATE(4064), 1,
      sym_module_name,
    STATE(7262), 1,
      sym__qid,
    STATE(9037), 1,
      aux_sym__record_assignments_repeat1,
    STATE(11253), 1,
      sym__record_assignments,
    STATE(9733), 3,
      sym__record_assignment,
      sym_field_assignment,
      sym_module_assignment,
  [657959] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13287), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13285), 7,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [657980] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(15093), 1,
      sym_id,
    ACTIONS(15215), 1,
      anon_sym_RBRACE,
    STATE(4064), 1,
      sym_module_name,
    STATE(7262), 1,
      sym__qid,
    STATE(9037), 1,
      aux_sym__record_assignments_repeat1,
    STATE(11246), 1,
      sym__record_assignments,
    STATE(9733), 3,
      sym__record_assignment,
      sym_field_assignment,
      sym_module_assignment,
  [658013] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(15093), 1,
      sym_id,
    ACTIONS(15217), 1,
      anon_sym_RBRACE,
    STATE(4064), 1,
      sym_module_name,
    STATE(7262), 1,
      sym__qid,
    STATE(9037), 1,
      aux_sym__record_assignments_repeat1,
    STATE(12458), 1,
      sym__record_assignments,
    STATE(9733), 3,
      sym__record_assignment,
      sym_field_assignment,
      sym_module_assignment,
  [658046] = 4,
    STATE(1751), 1,
      sym__ARROW,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15219), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(14953), 7,
      sym__newline,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
  [658067] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(15093), 1,
      sym_id,
    ACTIONS(15221), 1,
      anon_sym_RBRACE,
    STATE(4064), 1,
      sym_module_name,
    STATE(7262), 1,
      sym__qid,
    STATE(9037), 1,
      aux_sym__record_assignments_repeat1,
    STATE(11220), 1,
      sym__record_assignments,
    STATE(9733), 3,
      sym__record_assignment,
      sym_field_assignment,
      sym_module_assignment,
  [658100] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(15093), 1,
      sym_id,
    ACTIONS(15223), 1,
      anon_sym_RBRACE,
    STATE(4064), 1,
      sym_module_name,
    STATE(7262), 1,
      sym__qid,
    STATE(9037), 1,
      aux_sym__record_assignments_repeat1,
    STATE(12405), 1,
      sym__record_assignments,
    STATE(9733), 3,
      sym__record_assignment,
      sym_field_assignment,
      sym_module_assignment,
  [658133] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(15093), 1,
      sym_id,
    ACTIONS(15225), 1,
      anon_sym_RBRACE,
    STATE(4064), 1,
      sym_module_name,
    STATE(7262), 1,
      sym__qid,
    STATE(9037), 1,
      aux_sym__record_assignments_repeat1,
    STATE(12817), 1,
      sym__record_assignments,
    STATE(9733), 3,
      sym__record_assignment,
      sym_field_assignment,
      sym_module_assignment,
  [658166] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(15093), 1,
      sym_id,
    ACTIONS(15227), 1,
      anon_sym_RBRACE,
    STATE(4064), 1,
      sym_module_name,
    STATE(7262), 1,
      sym__qid,
    STATE(9037), 1,
      aux_sym__record_assignments_repeat1,
    STATE(12219), 1,
      sym__record_assignments,
    STATE(9733), 3,
      sym__record_assignment,
      sym_field_assignment,
      sym_module_assignment,
  [658199] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(15093), 1,
      sym_id,
    ACTIONS(15229), 1,
      anon_sym_RBRACE,
    STATE(4064), 1,
      sym_module_name,
    STATE(7262), 1,
      sym__qid,
    STATE(9037), 1,
      aux_sym__record_assignments_repeat1,
    STATE(11211), 1,
      sym__record_assignments,
    STATE(9733), 3,
      sym__record_assignment,
      sym_field_assignment,
      sym_module_assignment,
  [658232] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(15093), 1,
      sym_id,
    ACTIONS(15231), 1,
      anon_sym_RBRACE,
    STATE(4064), 1,
      sym_module_name,
    STATE(7262), 1,
      sym__qid,
    STATE(9037), 1,
      aux_sym__record_assignments_repeat1,
    STATE(11638), 1,
      sym__record_assignments,
    STATE(9733), 3,
      sym__record_assignment,
      sym_field_assignment,
      sym_module_assignment,
  [658265] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(15093), 1,
      sym_id,
    ACTIONS(15233), 1,
      anon_sym_RBRACE,
    STATE(4064), 1,
      sym_module_name,
    STATE(7262), 1,
      sym__qid,
    STATE(9037), 1,
      aux_sym__record_assignments_repeat1,
    STATE(11538), 1,
      sym__record_assignments,
    STATE(9733), 3,
      sym__record_assignment,
      sym_field_assignment,
      sym_module_assignment,
  [658298] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(15093), 1,
      sym_id,
    ACTIONS(15235), 1,
      anon_sym_RBRACE,
    STATE(4064), 1,
      sym_module_name,
    STATE(7262), 1,
      sym__qid,
    STATE(9037), 1,
      aux_sym__record_assignments_repeat1,
    STATE(11826), 1,
      sym__record_assignments,
    STATE(9733), 3,
      sym__record_assignment,
      sym_field_assignment,
      sym_module_assignment,
  [658331] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(15093), 1,
      sym_id,
    ACTIONS(15237), 1,
      anon_sym_RBRACE,
    STATE(4064), 1,
      sym_module_name,
    STATE(7262), 1,
      sym__qid,
    STATE(9037), 1,
      aux_sym__record_assignments_repeat1,
    STATE(10455), 1,
      sym__record_assignments,
    STATE(9733), 3,
      sym__record_assignment,
      sym_field_assignment,
      sym_module_assignment,
  [658364] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6433), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(6431), 7,
      anon_sym_COLON,
      anon_sym_where,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [658385] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(15093), 1,
      sym_id,
    ACTIONS(15239), 1,
      anon_sym_RBRACE,
    STATE(4064), 1,
      sym_module_name,
    STATE(7262), 1,
      sym__qid,
    STATE(9037), 1,
      aux_sym__record_assignments_repeat1,
    STATE(11475), 1,
      sym__record_assignments,
    STATE(9733), 3,
      sym__record_assignment,
      sym_field_assignment,
      sym_module_assignment,
  [658418] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(15093), 1,
      sym_id,
    ACTIONS(15241), 1,
      anon_sym_RBRACE,
    STATE(4064), 1,
      sym_module_name,
    STATE(7262), 1,
      sym__qid,
    STATE(9037), 1,
      aux_sym__record_assignments_repeat1,
    STATE(11551), 1,
      sym__record_assignments,
    STATE(9733), 3,
      sym__record_assignment,
      sym_field_assignment,
      sym_module_assignment,
  [658451] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(15093), 1,
      sym_id,
    ACTIONS(15243), 1,
      anon_sym_RBRACE,
    STATE(4064), 1,
      sym_module_name,
    STATE(7262), 1,
      sym__qid,
    STATE(9037), 1,
      aux_sym__record_assignments_repeat1,
    STATE(12266), 1,
      sym__record_assignments,
    STATE(9733), 3,
      sym__record_assignment,
      sym_field_assignment,
      sym_module_assignment,
  [658484] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(15093), 1,
      sym_id,
    ACTIONS(15245), 1,
      anon_sym_RBRACE,
    STATE(4064), 1,
      sym_module_name,
    STATE(7262), 1,
      sym__qid,
    STATE(9037), 1,
      aux_sym__record_assignments_repeat1,
    STATE(12475), 1,
      sym__record_assignments,
    STATE(9733), 3,
      sym__record_assignment,
      sym_field_assignment,
      sym_module_assignment,
  [658517] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13339), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13337), 7,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [658538] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13254), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13252), 7,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [658559] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(15093), 1,
      sym_id,
    ACTIONS(15247), 1,
      anon_sym_RBRACE,
    STATE(4064), 1,
      sym_module_name,
    STATE(7262), 1,
      sym__qid,
    STATE(9037), 1,
      aux_sym__record_assignments_repeat1,
    STATE(12739), 1,
      sym__record_assignments,
    STATE(9733), 3,
      sym__record_assignment,
      sym_field_assignment,
      sym_module_assignment,
  [658592] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(15093), 1,
      sym_id,
    ACTIONS(15249), 1,
      anon_sym_RBRACE,
    STATE(4064), 1,
      sym_module_name,
    STATE(7262), 1,
      sym__qid,
    STATE(9037), 1,
      aux_sym__record_assignments_repeat1,
    STATE(12200), 1,
      sym__record_assignments,
    STATE(9733), 3,
      sym__record_assignment,
      sym_field_assignment,
      sym_module_assignment,
  [658625] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(15093), 1,
      sym_id,
    ACTIONS(15251), 1,
      anon_sym_RBRACE,
    STATE(4064), 1,
      sym_module_name,
    STATE(7262), 1,
      sym__qid,
    STATE(9037), 1,
      aux_sym__record_assignments_repeat1,
    STATE(11275), 1,
      sym__record_assignments,
    STATE(9733), 3,
      sym__record_assignment,
      sym_field_assignment,
      sym_module_assignment,
  [658658] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(15093), 1,
      sym_id,
    ACTIONS(15253), 1,
      anon_sym_RBRACE,
    STATE(4064), 1,
      sym_module_name,
    STATE(7262), 1,
      sym__qid,
    STATE(9037), 1,
      aux_sym__record_assignments_repeat1,
    STATE(10483), 1,
      sym__record_assignments,
    STATE(9733), 3,
      sym__record_assignment,
      sym_field_assignment,
      sym_module_assignment,
  [658691] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(15093), 1,
      sym_id,
    ACTIONS(15255), 1,
      anon_sym_RBRACE,
    STATE(4064), 1,
      sym_module_name,
    STATE(7262), 1,
      sym__qid,
    STATE(9037), 1,
      aux_sym__record_assignments_repeat1,
    STATE(10391), 1,
      sym__record_assignments,
    STATE(9733), 3,
      sym__record_assignment,
      sym_field_assignment,
      sym_module_assignment,
  [658724] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(15093), 1,
      sym_id,
    ACTIONS(15257), 1,
      anon_sym_RBRACE,
    STATE(4064), 1,
      sym_module_name,
    STATE(7262), 1,
      sym__qid,
    STATE(9037), 1,
      aux_sym__record_assignments_repeat1,
    STATE(11839), 1,
      sym__record_assignments,
    STATE(9733), 3,
      sym__record_assignment,
      sym_field_assignment,
      sym_module_assignment,
  [658757] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(15093), 1,
      sym_id,
    ACTIONS(15259), 1,
      anon_sym_RBRACE,
    STATE(4064), 1,
      sym_module_name,
    STATE(7262), 1,
      sym__qid,
    STATE(9037), 1,
      aux_sym__record_assignments_repeat1,
    STATE(10493), 1,
      sym__record_assignments,
    STATE(9733), 3,
      sym__record_assignment,
      sym_field_assignment,
      sym_module_assignment,
  [658790] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(15093), 1,
      sym_id,
    ACTIONS(15261), 1,
      anon_sym_RBRACE,
    STATE(4064), 1,
      sym_module_name,
    STATE(7262), 1,
      sym__qid,
    STATE(9037), 1,
      aux_sym__record_assignments_repeat1,
    STATE(11196), 1,
      sym__record_assignments,
    STATE(9733), 3,
      sym__record_assignment,
      sym_field_assignment,
      sym_module_assignment,
  [658823] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(15093), 1,
      sym_id,
    ACTIONS(15263), 1,
      anon_sym_RBRACE,
    STATE(4064), 1,
      sym_module_name,
    STATE(7262), 1,
      sym__qid,
    STATE(9037), 1,
      aux_sym__record_assignments_repeat1,
    STATE(10528), 1,
      sym__record_assignments,
    STATE(9733), 3,
      sym__record_assignment,
      sym_field_assignment,
      sym_module_assignment,
  [658856] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(15093), 1,
      sym_id,
    ACTIONS(15265), 1,
      anon_sym_RBRACE,
    STATE(4064), 1,
      sym_module_name,
    STATE(7262), 1,
      sym__qid,
    STATE(9037), 1,
      aux_sym__record_assignments_repeat1,
    STATE(11596), 1,
      sym__record_assignments,
    STATE(9733), 3,
      sym__record_assignment,
      sym_field_assignment,
      sym_module_assignment,
  [658889] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(15093), 1,
      sym_id,
    ACTIONS(15267), 1,
      anon_sym_RBRACE,
    STATE(4064), 1,
      sym_module_name,
    STATE(7262), 1,
      sym__qid,
    STATE(9037), 1,
      aux_sym__record_assignments_repeat1,
    STATE(11651), 1,
      sym__record_assignments,
    STATE(9733), 3,
      sym__record_assignment,
      sym_field_assignment,
      sym_module_assignment,
  [658922] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(15093), 1,
      sym_id,
    ACTIONS(15269), 1,
      anon_sym_RBRACE,
    STATE(4064), 1,
      sym_module_name,
    STATE(7262), 1,
      sym__qid,
    STATE(9037), 1,
      aux_sym__record_assignments_repeat1,
    STATE(11175), 1,
      sym__record_assignments,
    STATE(9733), 3,
      sym__record_assignment,
      sym_field_assignment,
      sym_module_assignment,
  [658955] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(15093), 1,
      sym_id,
    ACTIONS(15271), 1,
      anon_sym_RBRACE,
    STATE(4064), 1,
      sym_module_name,
    STATE(7262), 1,
      sym__qid,
    STATE(9037), 1,
      aux_sym__record_assignments_repeat1,
    STATE(12722), 1,
      sym__record_assignments,
    STATE(9733), 3,
      sym__record_assignment,
      sym_field_assignment,
      sym_module_assignment,
  [658988] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(15093), 1,
      sym_id,
    ACTIONS(15273), 1,
      anon_sym_RBRACE,
    STATE(4064), 1,
      sym_module_name,
    STATE(7262), 1,
      sym__qid,
    STATE(9037), 1,
      aux_sym__record_assignments_repeat1,
    STATE(10531), 1,
      sym__record_assignments,
    STATE(9733), 3,
      sym__record_assignment,
      sym_field_assignment,
      sym_module_assignment,
  [659021] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(15093), 1,
      sym_id,
    ACTIONS(15275), 1,
      anon_sym_RBRACE,
    STATE(4064), 1,
      sym_module_name,
    STATE(7262), 1,
      sym__qid,
    STATE(9037), 1,
      aux_sym__record_assignments_repeat1,
    STATE(11027), 1,
      sym__record_assignments,
    STATE(9733), 3,
      sym__record_assignment,
      sym_field_assignment,
      sym_module_assignment,
  [659054] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(15093), 1,
      sym_id,
    ACTIONS(15277), 1,
      anon_sym_RBRACE,
    STATE(4064), 1,
      sym_module_name,
    STATE(7262), 1,
      sym__qid,
    STATE(9037), 1,
      aux_sym__record_assignments_repeat1,
    STATE(12366), 1,
      sym__record_assignments,
    STATE(9733), 3,
      sym__record_assignment,
      sym_field_assignment,
      sym_module_assignment,
  [659087] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(15093), 1,
      sym_id,
    ACTIONS(15279), 1,
      anon_sym_RBRACE,
    STATE(4064), 1,
      sym_module_name,
    STATE(7262), 1,
      sym__qid,
    STATE(9037), 1,
      aux_sym__record_assignments_repeat1,
    STATE(12167), 1,
      sym__record_assignments,
    STATE(9733), 3,
      sym__record_assignment,
      sym_field_assignment,
      sym_module_assignment,
  [659120] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(15093), 1,
      sym_id,
    ACTIONS(15281), 1,
      anon_sym_RBRACE,
    STATE(4064), 1,
      sym_module_name,
    STATE(7262), 1,
      sym__qid,
    STATE(9037), 1,
      aux_sym__record_assignments_repeat1,
    STATE(12395), 1,
      sym__record_assignments,
    STATE(9733), 3,
      sym__record_assignment,
      sym_field_assignment,
      sym_module_assignment,
  [659153] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(15093), 1,
      sym_id,
    ACTIONS(15283), 1,
      anon_sym_RBRACE,
    STATE(4064), 1,
      sym_module_name,
    STATE(7262), 1,
      sym__qid,
    STATE(9037), 1,
      aux_sym__record_assignments_repeat1,
    STATE(11856), 1,
      sym__record_assignments,
    STATE(9733), 3,
      sym__record_assignment,
      sym_field_assignment,
      sym_module_assignment,
  [659186] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(15093), 1,
      sym_id,
    ACTIONS(15285), 1,
      anon_sym_RBRACE,
    STATE(4064), 1,
      sym_module_name,
    STATE(7262), 1,
      sym__qid,
    STATE(9037), 1,
      aux_sym__record_assignments_repeat1,
    STATE(12495), 1,
      sym__record_assignments,
    STATE(9733), 3,
      sym__record_assignment,
      sym_field_assignment,
      sym_module_assignment,
  [659219] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(15093), 1,
      sym_id,
    ACTIONS(15287), 1,
      anon_sym_RBRACE,
    STATE(4064), 1,
      sym_module_name,
    STATE(7262), 1,
      sym__qid,
    STATE(9037), 1,
      aux_sym__record_assignments_repeat1,
    STATE(11140), 1,
      sym__record_assignments,
    STATE(9733), 3,
      sym__record_assignment,
      sym_field_assignment,
      sym_module_assignment,
  [659252] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(15093), 1,
      sym_id,
    ACTIONS(15289), 1,
      anon_sym_RBRACE,
    STATE(4064), 1,
      sym_module_name,
    STATE(7262), 1,
      sym__qid,
    STATE(9037), 1,
      aux_sym__record_assignments_repeat1,
    STATE(11899), 1,
      sym__record_assignments,
    STATE(9733), 3,
      sym__record_assignment,
      sym_field_assignment,
      sym_module_assignment,
  [659285] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(15093), 1,
      sym_id,
    ACTIONS(15291), 1,
      anon_sym_RBRACE,
    STATE(4064), 1,
      sym_module_name,
    STATE(7262), 1,
      sym__qid,
    STATE(9037), 1,
      aux_sym__record_assignments_repeat1,
    STATE(11130), 1,
      sym__record_assignments,
    STATE(9733), 3,
      sym__record_assignment,
      sym_field_assignment,
      sym_module_assignment,
  [659318] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(15093), 1,
      sym_id,
    ACTIONS(15293), 1,
      anon_sym_RBRACE,
    STATE(4064), 1,
      sym_module_name,
    STATE(7262), 1,
      sym__qid,
    STATE(9037), 1,
      aux_sym__record_assignments_repeat1,
    STATE(10574), 1,
      sym__record_assignments,
    STATE(9733), 3,
      sym__record_assignment,
      sym_field_assignment,
      sym_module_assignment,
  [659351] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(15093), 1,
      sym_id,
    ACTIONS(15295), 1,
      anon_sym_RBRACE,
    STATE(4064), 1,
      sym_module_name,
    STATE(7262), 1,
      sym__qid,
    STATE(9037), 1,
      aux_sym__record_assignments_repeat1,
    STATE(12545), 1,
      sym__record_assignments,
    STATE(9733), 3,
      sym__record_assignment,
      sym_field_assignment,
      sym_module_assignment,
  [659384] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(15093), 1,
      sym_id,
    ACTIONS(15297), 1,
      anon_sym_RBRACE,
    STATE(4064), 1,
      sym_module_name,
    STATE(7262), 1,
      sym__qid,
    STATE(9037), 1,
      aux_sym__record_assignments_repeat1,
    STATE(10573), 1,
      sym__record_assignments,
    STATE(9733), 3,
      sym__record_assignment,
      sym_field_assignment,
      sym_module_assignment,
  [659417] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(15093), 1,
      sym_id,
    ACTIONS(15299), 1,
      anon_sym_RBRACE,
    STATE(4064), 1,
      sym_module_name,
    STATE(7262), 1,
      sym__qid,
    STATE(9037), 1,
      aux_sym__record_assignments_repeat1,
    STATE(12214), 1,
      sym__record_assignments,
    STATE(9733), 3,
      sym__record_assignment,
      sym_field_assignment,
      sym_module_assignment,
  [659450] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(15093), 1,
      sym_id,
    ACTIONS(15301), 1,
      anon_sym_RBRACE,
    STATE(4064), 1,
      sym_module_name,
    STATE(7262), 1,
      sym__qid,
    STATE(9037), 1,
      aux_sym__record_assignments_repeat1,
    STATE(11450), 1,
      sym__record_assignments,
    STATE(9733), 3,
      sym__record_assignment,
      sym_field_assignment,
      sym_module_assignment,
  [659483] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(15093), 1,
      sym_id,
    ACTIONS(15303), 1,
      anon_sym_RBRACE,
    STATE(4064), 1,
      sym_module_name,
    STATE(7262), 1,
      sym__qid,
    STATE(9037), 1,
      aux_sym__record_assignments_repeat1,
    STATE(12703), 1,
      sym__record_assignments,
    STATE(9733), 3,
      sym__record_assignment,
      sym_field_assignment,
      sym_module_assignment,
  [659516] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(15093), 1,
      sym_id,
    ACTIONS(15305), 1,
      anon_sym_RBRACE,
    STATE(4064), 1,
      sym_module_name,
    STATE(7262), 1,
      sym__qid,
    STATE(9037), 1,
      aux_sym__record_assignments_repeat1,
    STATE(11099), 1,
      sym__record_assignments,
    STATE(9733), 3,
      sym__record_assignment,
      sym_field_assignment,
      sym_module_assignment,
  [659549] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(15093), 1,
      sym_id,
    ACTIONS(15307), 1,
      anon_sym_RBRACE,
    STATE(4064), 1,
      sym_module_name,
    STATE(7262), 1,
      sym__qid,
    STATE(9037), 1,
      aux_sym__record_assignments_repeat1,
    STATE(11664), 1,
      sym__record_assignments,
    STATE(9733), 3,
      sym__record_assignment,
      sym_field_assignment,
      sym_module_assignment,
  [659582] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(15093), 1,
      sym_id,
    ACTIONS(15309), 1,
      anon_sym_RBRACE,
    STATE(4064), 1,
      sym_module_name,
    STATE(7262), 1,
      sym__qid,
    STATE(9037), 1,
      aux_sym__record_assignments_repeat1,
    STATE(12150), 1,
      sym__record_assignments,
    STATE(9733), 3,
      sym__record_assignment,
      sym_field_assignment,
      sym_module_assignment,
  [659615] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(15093), 1,
      sym_id,
    ACTIONS(15311), 1,
      anon_sym_RBRACE,
    STATE(4064), 1,
      sym_module_name,
    STATE(7262), 1,
      sym__qid,
    STATE(9037), 1,
      aux_sym__record_assignments_repeat1,
    STATE(10620), 1,
      sym__record_assignments,
    STATE(9733), 3,
      sym__record_assignment,
      sym_field_assignment,
      sym_module_assignment,
  [659648] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(15093), 1,
      sym_id,
    ACTIONS(15313), 1,
      anon_sym_RBRACE,
    STATE(4064), 1,
      sym_module_name,
    STATE(7262), 1,
      sym__qid,
    STATE(9037), 1,
      aux_sym__record_assignments_repeat1,
    STATE(11882), 1,
      sym__record_assignments,
    STATE(9733), 3,
      sym__record_assignment,
      sym_field_assignment,
      sym_module_assignment,
  [659681] = 4,
    STATE(2344), 1,
      sym__ARROW,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15315), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(14953), 7,
      sym__newline,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_in,
  [659702] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6647), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(6645), 7,
      anon_sym_COLON,
      anon_sym_where,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [659723] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(15093), 1,
      sym_id,
    ACTIONS(15317), 1,
      anon_sym_RBRACE,
    STATE(4064), 1,
      sym_module_name,
    STATE(7262), 1,
      sym__qid,
    STATE(9037), 1,
      aux_sym__record_assignments_repeat1,
    STATE(11102), 1,
      sym__record_assignments,
    STATE(9733), 3,
      sym__record_assignment,
      sym_field_assignment,
      sym_module_assignment,
  [659756] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(15093), 1,
      sym_id,
    ACTIONS(15319), 1,
      anon_sym_RBRACE,
    STATE(4064), 1,
      sym_module_name,
    STATE(7262), 1,
      sym__qid,
    STATE(9037), 1,
      aux_sym__record_assignments_repeat1,
    STATE(10612), 1,
      sym__record_assignments,
    STATE(9733), 3,
      sym__record_assignment,
      sym_field_assignment,
      sym_module_assignment,
  [659789] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(15093), 1,
      sym_id,
    ACTIONS(15321), 1,
      anon_sym_RBRACE,
    STATE(4064), 1,
      sym_module_name,
    STATE(7262), 1,
      sym__qid,
    STATE(9037), 1,
      aux_sym__record_assignments_repeat1,
    STATE(12434), 1,
      sym__record_assignments,
    STATE(9733), 3,
      sym__record_assignment,
      sym_field_assignment,
      sym_module_assignment,
  [659822] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6710), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(6708), 7,
      anon_sym_COLON,
      anon_sym_where,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [659843] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(15093), 1,
      sym_id,
    ACTIONS(15323), 1,
      anon_sym_RBRACE,
    STATE(4064), 1,
      sym_module_name,
    STATE(7262), 1,
      sym__qid,
    STATE(9037), 1,
      aux_sym__record_assignments_repeat1,
    STATE(11463), 1,
      sym__record_assignments,
    STATE(9733), 3,
      sym__record_assignment,
      sym_field_assignment,
      sym_module_assignment,
  [659876] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(15093), 1,
      sym_id,
    ACTIONS(15325), 1,
      anon_sym_RBRACE,
    STATE(4064), 1,
      sym_module_name,
    STATE(7262), 1,
      sym__qid,
    STATE(9037), 1,
      aux_sym__record_assignments_repeat1,
    STATE(11083), 1,
      sym__record_assignments,
    STATE(9733), 3,
      sym__record_assignment,
      sym_field_assignment,
      sym_module_assignment,
  [659909] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(15093), 1,
      sym_id,
    ACTIONS(15327), 1,
      anon_sym_RBRACE,
    STATE(4064), 1,
      sym_module_name,
    STATE(7262), 1,
      sym__qid,
    STATE(9037), 1,
      aux_sym__record_assignments_repeat1,
    STATE(12734), 1,
      sym__record_assignments,
    STATE(9733), 3,
      sym__record_assignment,
      sym_field_assignment,
      sym_module_assignment,
  [659942] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(15093), 1,
      sym_id,
    ACTIONS(15329), 1,
      anon_sym_RBRACE,
    STATE(4064), 1,
      sym_module_name,
    STATE(7262), 1,
      sym__qid,
    STATE(9037), 1,
      aux_sym__record_assignments_repeat1,
    STATE(11589), 1,
      sym__record_assignments,
    STATE(9733), 3,
      sym__record_assignment,
      sym_field_assignment,
      sym_module_assignment,
  [659975] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(15093), 1,
      sym_id,
    ACTIONS(15331), 1,
      anon_sym_RBRACE,
    STATE(4064), 1,
      sym_module_name,
    STATE(7262), 1,
      sym__qid,
    STATE(9037), 1,
      aux_sym__record_assignments_repeat1,
    STATE(11674), 1,
      sym__record_assignments,
    STATE(9733), 3,
      sym__record_assignment,
      sym_field_assignment,
      sym_module_assignment,
  [660008] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(15093), 1,
      sym_id,
    ACTIONS(15333), 1,
      anon_sym_RBRACE,
    STATE(4064), 1,
      sym_module_name,
    STATE(7262), 1,
      sym__qid,
    STATE(9037), 1,
      aux_sym__record_assignments_repeat1,
    STATE(11903), 1,
      sym__record_assignments,
    STATE(9733), 3,
      sym__record_assignment,
      sym_field_assignment,
      sym_module_assignment,
  [660041] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(15093), 1,
      sym_id,
    ACTIONS(15335), 1,
      anon_sym_RBRACE,
    STATE(4064), 1,
      sym_module_name,
    STATE(7262), 1,
      sym__qid,
    STATE(9037), 1,
      aux_sym__record_assignments_repeat1,
    STATE(12128), 1,
      sym__record_assignments,
    STATE(9733), 3,
      sym__record_assignment,
      sym_field_assignment,
      sym_module_assignment,
  [660074] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(15093), 1,
      sym_id,
    ACTIONS(15337), 1,
      anon_sym_RBRACE,
    STATE(4064), 1,
      sym_module_name,
    STATE(7262), 1,
      sym__qid,
    STATE(9037), 1,
      aux_sym__record_assignments_repeat1,
    STATE(11762), 1,
      sym__record_assignments,
    STATE(9733), 3,
      sym__record_assignment,
      sym_field_assignment,
      sym_module_assignment,
  [660107] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(15093), 1,
      sym_id,
    ACTIONS(15339), 1,
      anon_sym_RBRACE,
    STATE(4064), 1,
      sym_module_name,
    STATE(7262), 1,
      sym__qid,
    STATE(9037), 1,
      aux_sym__record_assignments_repeat1,
    STATE(11063), 1,
      sym__record_assignments,
    STATE(9733), 3,
      sym__record_assignment,
      sym_field_assignment,
      sym_module_assignment,
  [660140] = 4,
    STATE(1798), 1,
      sym__ARROW,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15341), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(14953), 7,
      sym__newline,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_in,
  [660161] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(15093), 1,
      sym_id,
    ACTIONS(15343), 1,
      anon_sym_RBRACE,
    STATE(4064), 1,
      sym_module_name,
    STATE(7262), 1,
      sym__qid,
    STATE(9037), 1,
      aux_sym__record_assignments_repeat1,
    STATE(11052), 1,
      sym__record_assignments,
    STATE(9733), 3,
      sym__record_assignment,
      sym_field_assignment,
      sym_module_assignment,
  [660194] = 9,
    ACTIONS(15347), 1,
      anon_sym_LPAREN,
    ACTIONS(15350), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(15353), 1,
      anon_sym_u2983,
    ACTIONS(15356), 1,
      anon_sym_LBRACE,
    ACTIONS(15359), 1,
      anon_sym_DOT,
    ACTIONS(15362), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15345), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(8821), 2,
      aux_sym__typed_bindings,
      sym_typed_binding,
  [660225] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(15093), 1,
      sym_id,
    ACTIONS(15365), 1,
      anon_sym_RBRACE,
    STATE(4064), 1,
      sym_module_name,
    STATE(7262), 1,
      sym__qid,
    STATE(9037), 1,
      aux_sym__record_assignments_repeat1,
    STATE(12531), 1,
      sym__record_assignments,
    STATE(9733), 3,
      sym__record_assignment,
      sym_field_assignment,
      sym_module_assignment,
  [660258] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(15093), 1,
      sym_id,
    ACTIONS(15367), 1,
      anon_sym_RBRACE,
    STATE(4064), 1,
      sym_module_name,
    STATE(7262), 1,
      sym__qid,
    STATE(9037), 1,
      aux_sym__record_assignments_repeat1,
    STATE(12686), 1,
      sym__record_assignments,
    STATE(9733), 3,
      sym__record_assignment,
      sym_field_assignment,
      sym_module_assignment,
  [660291] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(15093), 1,
      sym_id,
    ACTIONS(15369), 1,
      anon_sym_RBRACE,
    STATE(4064), 1,
      sym_module_name,
    STATE(7262), 1,
      sym__qid,
    STATE(9037), 1,
      aux_sym__record_assignments_repeat1,
    STATE(10649), 1,
      sym__record_assignments,
    STATE(9733), 3,
      sym__record_assignment,
      sym_field_assignment,
      sym_module_assignment,
  [660324] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(15093), 1,
      sym_id,
    ACTIONS(15371), 1,
      anon_sym_RBRACE,
    STATE(4064), 1,
      sym_module_name,
    STATE(7262), 1,
      sym__qid,
    STATE(9037), 1,
      aux_sym__record_assignments_repeat1,
    STATE(11094), 1,
      sym__record_assignments,
    STATE(9733), 3,
      sym__record_assignment,
      sym_field_assignment,
      sym_module_assignment,
  [660357] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(15093), 1,
      sym_id,
    ACTIONS(15373), 1,
      anon_sym_RBRACE,
    STATE(4064), 1,
      sym_module_name,
    STATE(7262), 1,
      sym__qid,
    STATE(9037), 1,
      aux_sym__record_assignments_repeat1,
    STATE(12163), 1,
      sym__record_assignments,
    STATE(9733), 3,
      sym__record_assignment,
      sym_field_assignment,
      sym_module_assignment,
  [660390] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13295), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13293), 7,
      anon_sym_COLON,
      anon_sym_where,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [660411] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13250), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13248), 7,
      anon_sym_COLON,
      anon_sym_where,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [660432] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(15093), 1,
      sym_id,
    ACTIONS(15375), 1,
      anon_sym_RBRACE,
    STATE(4064), 1,
      sym_module_name,
    STATE(7262), 1,
      sym__qid,
    STATE(9037), 1,
      aux_sym__record_assignments_repeat1,
    STATE(11686), 1,
      sym__record_assignments,
    STATE(9733), 3,
      sym__record_assignment,
      sym_field_assignment,
      sym_module_assignment,
  [660465] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(15093), 1,
      sym_id,
    ACTIONS(15377), 1,
      anon_sym_RBRACE,
    STATE(4064), 1,
      sym_module_name,
    STATE(7262), 1,
      sym__qid,
    STATE(9037), 1,
      aux_sym__record_assignments_repeat1,
    STATE(12583), 1,
      sym__record_assignments,
    STATE(9733), 3,
      sym__record_assignment,
      sym_field_assignment,
      sym_module_assignment,
  [660498] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(15093), 1,
      sym_id,
    ACTIONS(15379), 1,
      anon_sym_RBRACE,
    STATE(4064), 1,
      sym_module_name,
    STATE(7262), 1,
      sym__qid,
    STATE(9037), 1,
      aux_sym__record_assignments_repeat1,
    STATE(12114), 1,
      sym__record_assignments,
    STATE(9733), 3,
      sym__record_assignment,
      sym_field_assignment,
      sym_module_assignment,
  [660531] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6484), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(6482), 7,
      anon_sym_COLON,
      anon_sym_where,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [660552] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(15093), 1,
      sym_id,
    ACTIONS(15381), 1,
      anon_sym_RBRACE,
    STATE(4064), 1,
      sym_module_name,
    STATE(7262), 1,
      sym__qid,
    STATE(9037), 1,
      aux_sym__record_assignments_repeat1,
    STATE(12346), 1,
      sym__record_assignments,
    STATE(9733), 3,
      sym__record_assignment,
      sym_field_assignment,
      sym_module_assignment,
  [660585] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6326), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(6324), 7,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [660606] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6655), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(6653), 7,
      anon_sym_COLON,
      anon_sym_where,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [660627] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13339), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13337), 7,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [660648] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(15093), 1,
      sym_id,
    ACTIONS(15383), 1,
      anon_sym_RBRACE,
    STATE(4064), 1,
      sym_module_name,
    STATE(7262), 1,
      sym__qid,
    STATE(9037), 1,
      aux_sym__record_assignments_repeat1,
    STATE(11915), 1,
      sym__record_assignments,
    STATE(9733), 3,
      sym__record_assignment,
      sym_field_assignment,
      sym_module_assignment,
  [660681] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6750), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(6748), 7,
      anon_sym_COLON,
      anon_sym_where,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [660702] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(15093), 1,
      sym_id,
    ACTIONS(15385), 1,
      anon_sym_RBRACE,
    STATE(4064), 1,
      sym_module_name,
    STATE(7262), 1,
      sym__qid,
    STATE(9037), 1,
      aux_sym__record_assignments_repeat1,
    STATE(11021), 1,
      sym__record_assignments,
    STATE(9733), 3,
      sym__record_assignment,
      sym_field_assignment,
      sym_module_assignment,
  [660735] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13303), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13301), 7,
      anon_sym_COLON,
      anon_sym_where,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [660756] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6714), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(6712), 7,
      anon_sym_COLON,
      anon_sym_where,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [660777] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(15093), 1,
      sym_id,
    ACTIONS(15387), 1,
      anon_sym_RBRACE,
    STATE(4064), 1,
      sym_module_name,
    STATE(7262), 1,
      sym__qid,
    STATE(9037), 1,
      aux_sym__record_assignments_repeat1,
    STATE(12509), 1,
      sym__record_assignments,
    STATE(9733), 3,
      sym__record_assignment,
      sym_field_assignment,
      sym_module_assignment,
  [660810] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(15093), 1,
      sym_id,
    ACTIONS(15389), 1,
      anon_sym_RBRACE,
    STATE(4064), 1,
      sym_module_name,
    STATE(7262), 1,
      sym__qid,
    STATE(9037), 1,
      aux_sym__record_assignments_repeat1,
    STATE(10995), 1,
      sym__record_assignments,
    STATE(9733), 3,
      sym__record_assignment,
      sym_field_assignment,
      sym_module_assignment,
  [660843] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13291), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13289), 7,
      anon_sym_COLON,
      anon_sym_where,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [660864] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(15093), 1,
      sym_id,
    ACTIONS(15391), 1,
      anon_sym_RBRACE,
    STATE(4064), 1,
      sym_module_name,
    STATE(7262), 1,
      sym__qid,
    STATE(9037), 1,
      aux_sym__record_assignments_repeat1,
    STATE(10687), 1,
      sym__record_assignments,
    STATE(9733), 3,
      sym__record_assignment,
      sym_field_assignment,
      sym_module_assignment,
  [660897] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(15093), 1,
      sym_id,
    ACTIONS(15393), 1,
      anon_sym_RBRACE,
    STATE(4064), 1,
      sym_module_name,
    STATE(7262), 1,
      sym__qid,
    STATE(9037), 1,
      aux_sym__record_assignments_repeat1,
    STATE(12096), 1,
      sym__record_assignments,
    STATE(9733), 3,
      sym__record_assignment,
      sym_field_assignment,
      sym_module_assignment,
  [660930] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(15093), 1,
      sym_id,
    ACTIONS(15395), 1,
      anon_sym_RBRACE,
    STATE(4064), 1,
      sym_module_name,
    STATE(7262), 1,
      sym__qid,
    STATE(9037), 1,
      aux_sym__record_assignments_repeat1,
    STATE(11563), 1,
      sym__record_assignments,
    STATE(9733), 3,
      sym__record_assignment,
      sym_field_assignment,
      sym_module_assignment,
  [660963] = 7,
    ACTIONS(15397), 1,
      anon_sym_COLON,
    ACTIONS(15401), 1,
      anon_sym_with,
    ACTIONS(15403), 1,
      anon_sym_rewrite,
    STATE(9038), 1,
      sym_rewrite_equations,
    STATE(9164), 1,
      sym_with_expressions,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15399), 5,
      sym__newline,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_in,
  [660990] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6754), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(6752), 7,
      anon_sym_COLON,
      anon_sym_where,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [661011] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(15093), 1,
      sym_id,
    ACTIONS(15405), 1,
      anon_sym_RBRACE,
    STATE(4064), 1,
      sym_module_name,
    STATE(7262), 1,
      sym__qid,
    STATE(9037), 1,
      aux_sym__record_assignments_repeat1,
    STATE(10989), 1,
      sym__record_assignments,
    STATE(9733), 3,
      sym__record_assignment,
      sym_field_assignment,
      sym_module_assignment,
  [661044] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13295), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13293), 7,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [661065] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(15093), 1,
      sym_id,
    ACTIONS(15407), 1,
      anon_sym_RBRACE,
    STATE(4064), 1,
      sym_module_name,
    STATE(7262), 1,
      sym__qid,
    STATE(9037), 1,
      aux_sym__record_assignments_repeat1,
    STATE(11930), 1,
      sym__record_assignments,
    STATE(9733), 3,
      sym__record_assignment,
      sym_field_assignment,
      sym_module_assignment,
  [661098] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(15093), 1,
      sym_id,
    ACTIONS(15409), 1,
      anon_sym_RBRACE,
    STATE(4064), 1,
      sym_module_name,
    STATE(7262), 1,
      sym__qid,
    STATE(9037), 1,
      aux_sym__record_assignments_repeat1,
    STATE(12551), 1,
      sym__record_assignments,
    STATE(9733), 3,
      sym__record_assignment,
      sym_field_assignment,
      sym_module_assignment,
  [661131] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13250), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13248), 7,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [661152] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6496), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(6494), 7,
      anon_sym_COLON,
      anon_sym_where,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [661173] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6651), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(6649), 7,
      anon_sym_COLON,
      anon_sym_where,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [661194] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13254), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13252), 7,
      anon_sym_COLON,
      anon_sym_where,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [661215] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13303), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13301), 7,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [661236] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13343), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13341), 7,
      anon_sym_COLON,
      anon_sym_where,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [661257] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(15093), 1,
      sym_id,
    ACTIONS(15411), 1,
      anon_sym_RBRACE,
    STATE(4064), 1,
      sym_module_name,
    STATE(7262), 1,
      sym__qid,
    STATE(9037), 1,
      aux_sym__record_assignments_repeat1,
    STATE(11751), 1,
      sym__record_assignments,
    STATE(9733), 3,
      sym__record_assignment,
      sym_field_assignment,
      sym_module_assignment,
  [661290] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(15093), 1,
      sym_id,
    ACTIONS(15413), 1,
      anon_sym_RBRACE,
    STATE(4064), 1,
      sym_module_name,
    STATE(7262), 1,
      sym__qid,
    STATE(9037), 1,
      aux_sym__record_assignments_repeat1,
    STATE(12079), 1,
      sym__record_assignments,
    STATE(9733), 3,
      sym__record_assignment,
      sym_field_assignment,
      sym_module_assignment,
  [661323] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13291), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13289), 7,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [661344] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(15093), 1,
      sym_id,
    ACTIONS(15415), 1,
      anon_sym_RBRACE,
    STATE(4064), 1,
      sym_module_name,
    STATE(7262), 1,
      sym__qid,
    STATE(9037), 1,
      aux_sym__record_assignments_repeat1,
    STATE(10764), 1,
      sym__record_assignments,
    STATE(9733), 3,
      sym__record_assignment,
      sym_field_assignment,
      sym_module_assignment,
  [661377] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(15093), 1,
      sym_id,
    ACTIONS(15417), 1,
      anon_sym_RBRACE,
    STATE(4064), 1,
      sym_module_name,
    STATE(7262), 1,
      sym__qid,
    STATE(9037), 1,
      aux_sym__record_assignments_repeat1,
    STATE(10988), 1,
      sym__record_assignments,
    STATE(9733), 3,
      sym__record_assignment,
      sym_field_assignment,
      sym_module_assignment,
  [661410] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(15093), 1,
      sym_id,
    ACTIONS(15419), 1,
      anon_sym_RBRACE,
    STATE(4064), 1,
      sym_module_name,
    STATE(7262), 1,
      sym__qid,
    STATE(9037), 1,
      aux_sym__record_assignments_repeat1,
    STATE(10970), 1,
      sym__record_assignments,
    STATE(9733), 3,
      sym__record_assignment,
      sym_field_assignment,
      sym_module_assignment,
  [661443] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6572), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(6570), 7,
      anon_sym_COLON,
      anon_sym_where,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [661464] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6568), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(6566), 7,
      anon_sym_COLON,
      anon_sym_where,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [661485] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(15093), 1,
      sym_id,
    ACTIONS(15421), 1,
      anon_sym_RBRACE,
    STATE(4064), 1,
      sym_module_name,
    STATE(7262), 1,
      sym__qid,
    STATE(9037), 1,
      aux_sym__record_assignments_repeat1,
    STATE(11699), 1,
      sym__record_assignments,
    STATE(9733), 3,
      sym__record_assignment,
      sym_field_assignment,
      sym_module_assignment,
  [661518] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13339), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13337), 7,
      anon_sym_COLON,
      anon_sym_where,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [661539] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(15093), 1,
      sym_id,
    ACTIONS(15423), 1,
      anon_sym_RBRACE,
    STATE(4064), 1,
      sym_module_name,
    STATE(7262), 1,
      sym__qid,
    STATE(9037), 1,
      aux_sym__record_assignments_repeat1,
    STATE(12698), 1,
      sym__record_assignments,
    STATE(9733), 3,
      sym__record_assignment,
      sym_field_assignment,
      sym_module_assignment,
  [661572] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13287), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13285), 7,
      anon_sym_COLON,
      anon_sym_where,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [661593] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(15093), 1,
      sym_id,
    ACTIONS(15425), 1,
      anon_sym_RBRACE,
    STATE(4064), 1,
      sym_module_name,
    STATE(7262), 1,
      sym__qid,
    STATE(9037), 1,
      aux_sym__record_assignments_repeat1,
    STATE(11946), 1,
      sym__record_assignments,
    STATE(9733), 3,
      sym__record_assignment,
      sym_field_assignment,
      sym_module_assignment,
  [661626] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13291), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13289), 7,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [661647] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(15093), 1,
      sym_id,
    ACTIONS(15427), 1,
      anon_sym_RBRACE,
    STATE(4064), 1,
      sym_module_name,
    STATE(7262), 1,
      sym__qid,
    STATE(9037), 1,
      aux_sym__record_assignments_repeat1,
    STATE(10910), 1,
      sym__record_assignments,
    STATE(9733), 3,
      sym__record_assignment,
      sym_field_assignment,
      sym_module_assignment,
  [661680] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(15093), 1,
      sym_id,
    ACTIONS(15429), 1,
      anon_sym_RBRACE,
    STATE(4064), 1,
      sym_module_name,
    STATE(7262), 1,
      sym__qid,
    STATE(9037), 1,
      aux_sym__record_assignments_repeat1,
    STATE(12623), 1,
      sym__record_assignments,
    STATE(9733), 3,
      sym__record_assignment,
      sym_field_assignment,
      sym_module_assignment,
  [661713] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(15093), 1,
      sym_id,
    ACTIONS(15431), 1,
      anon_sym_RBRACE,
    STATE(4064), 1,
      sym_module_name,
    STATE(7262), 1,
      sym__qid,
    STATE(9037), 1,
      aux_sym__record_assignments_repeat1,
    STATE(12060), 1,
      sym__record_assignments,
    STATE(9733), 3,
      sym__record_assignment,
      sym_field_assignment,
      sym_module_assignment,
  [661746] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(15093), 1,
      sym_id,
    ACTIONS(15433), 1,
      anon_sym_RBRACE,
    STATE(4064), 1,
      sym_module_name,
    STATE(7262), 1,
      sym__qid,
    STATE(9037), 1,
      aux_sym__record_assignments_repeat1,
    STATE(11988), 1,
      sym__record_assignments,
    STATE(9733), 3,
      sym__record_assignment,
      sym_field_assignment,
      sym_module_assignment,
  [661779] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(15093), 1,
      sym_id,
    ACTIONS(15435), 1,
      anon_sym_RBRACE,
    STATE(4064), 1,
      sym_module_name,
    STATE(7262), 1,
      sym__qid,
    STATE(9037), 1,
      aux_sym__record_assignments_repeat1,
    STATE(12650), 1,
      sym__record_assignments,
    STATE(9733), 3,
      sym__record_assignment,
      sym_field_assignment,
      sym_module_assignment,
  [661812] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13254), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13252), 7,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [661833] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13343), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13341), 7,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [661854] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(15093), 1,
      sym_id,
    ACTIONS(15437), 1,
      anon_sym_RBRACE,
    STATE(4064), 1,
      sym_module_name,
    STATE(7262), 1,
      sym__qid,
    STATE(9037), 1,
      aux_sym__record_assignments_repeat1,
    STATE(10729), 1,
      sym__record_assignments,
    STATE(9733), 3,
      sym__record_assignment,
      sym_field_assignment,
      sym_module_assignment,
  [661887] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(15093), 1,
      sym_id,
    ACTIONS(15439), 1,
      anon_sym_RBRACE,
    STATE(4064), 1,
      sym_module_name,
    STATE(7262), 1,
      sym__qid,
    STATE(9037), 1,
      aux_sym__record_assignments_repeat1,
    STATE(11960), 1,
      sym__record_assignments,
    STATE(9733), 3,
      sym__record_assignment,
      sym_field_assignment,
      sym_module_assignment,
  [661920] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(15093), 1,
      sym_id,
    ACTIONS(15441), 1,
      anon_sym_RBRACE,
    STATE(4064), 1,
      sym_module_name,
    STATE(7262), 1,
      sym__qid,
    STATE(9037), 1,
      aux_sym__record_assignments_repeat1,
    STATE(10725), 1,
      sym__record_assignments,
    STATE(9733), 3,
      sym__record_assignment,
      sym_field_assignment,
      sym_module_assignment,
  [661953] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(15093), 1,
      sym_id,
    ACTIONS(15443), 1,
      anon_sym_RBRACE,
    STATE(4064), 1,
      sym_module_name,
    STATE(7262), 1,
      sym__qid,
    STATE(9037), 1,
      aux_sym__record_assignments_repeat1,
    STATE(12667), 1,
      sym__record_assignments,
    STATE(9733), 3,
      sym__record_assignment,
      sym_field_assignment,
      sym_module_assignment,
  [661986] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13287), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13285), 7,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [662007] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(15093), 1,
      sym_id,
    ACTIONS(15445), 1,
      anon_sym_RBRACE,
    STATE(4064), 1,
      sym_module_name,
    STATE(7262), 1,
      sym__qid,
    STATE(9037), 1,
      aux_sym__record_assignments_repeat1,
    STATE(10753), 1,
      sym__record_assignments,
    STATE(9733), 3,
      sym__record_assignment,
      sym_field_assignment,
      sym_module_assignment,
  [662040] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13299), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13297), 7,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [662061] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(15093), 1,
      sym_id,
    ACTIONS(15447), 1,
      anon_sym_RBRACE,
    STATE(4064), 1,
      sym_module_name,
    STATE(7262), 1,
      sym__qid,
    STATE(9037), 1,
      aux_sym__record_assignments_repeat1,
    STATE(10951), 1,
      sym__record_assignments,
    STATE(9733), 3,
      sym__record_assignment,
      sym_field_assignment,
      sym_module_assignment,
  [662094] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(15093), 1,
      sym_id,
    ACTIONS(15449), 1,
      anon_sym_RBRACE,
    STATE(4064), 1,
      sym_module_name,
    STATE(7262), 1,
      sym__qid,
    STATE(9037), 1,
      aux_sym__record_assignments_repeat1,
    STATE(11741), 1,
      sym__record_assignments,
    STATE(9733), 3,
      sym__record_assignment,
      sym_field_assignment,
      sym_module_assignment,
  [662127] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6500), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(6498), 7,
      anon_sym_COLON,
      anon_sym_where,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [662148] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(15093), 1,
      sym_id,
    ACTIONS(15451), 1,
      anon_sym_RBRACE,
    STATE(4064), 1,
      sym_module_name,
    STATE(7262), 1,
      sym__qid,
    STATE(9037), 1,
      aux_sym__record_assignments_repeat1,
    STATE(12046), 1,
      sym__record_assignments,
    STATE(9733), 3,
      sym__record_assignment,
      sym_field_assignment,
      sym_module_assignment,
  [662181] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(15093), 1,
      sym_id,
    ACTIONS(15453), 1,
      anon_sym_RBRACE,
    STATE(4064), 1,
      sym_module_name,
    STATE(7262), 1,
      sym__qid,
    STATE(9037), 1,
      aux_sym__record_assignments_repeat1,
    STATE(10768), 1,
      sym__record_assignments,
    STATE(9733), 3,
      sym__record_assignment,
      sym_field_assignment,
      sym_module_assignment,
  [662214] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13303), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13301), 7,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [662235] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(15093), 1,
      sym_id,
    ACTIONS(15455), 1,
      anon_sym_RBRACE,
    STATE(4064), 1,
      sym_module_name,
    STATE(7262), 1,
      sym__qid,
    STATE(9037), 1,
      aux_sym__record_assignments_repeat1,
    STATE(11978), 1,
      sym__record_assignments,
    STATE(9733), 3,
      sym__record_assignment,
      sym_field_assignment,
      sym_module_assignment,
  [662268] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(15093), 1,
      sym_id,
    ACTIONS(15457), 1,
      anon_sym_RBRACE,
    STATE(4064), 1,
      sym_module_name,
    STATE(7262), 1,
      sym__qid,
    STATE(9037), 1,
      aux_sym__record_assignments_repeat1,
    STATE(12629), 1,
      sym__record_assignments,
    STATE(9733), 3,
      sym__record_assignment,
      sym_field_assignment,
      sym_module_assignment,
  [662301] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(15093), 1,
      sym_id,
    ACTIONS(15459), 1,
      anon_sym_RBRACE,
    STATE(4064), 1,
      sym_module_name,
    STATE(7262), 1,
      sym__qid,
    STATE(9037), 1,
      aux_sym__record_assignments_repeat1,
    STATE(10941), 1,
      sym__record_assignments,
    STATE(9733), 3,
      sym__record_assignment,
      sym_field_assignment,
      sym_module_assignment,
  [662334] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(15093), 1,
      sym_id,
    ACTIONS(15461), 1,
      anon_sym_RBRACE,
    STATE(4064), 1,
      sym_module_name,
    STATE(7262), 1,
      sym__qid,
    STATE(9037), 1,
      aux_sym__record_assignments_repeat1,
    STATE(10778), 1,
      sym__record_assignments,
    STATE(9733), 3,
      sym__record_assignment,
      sym_field_assignment,
      sym_module_assignment,
  [662367] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(15093), 1,
      sym_id,
    ACTIONS(15463), 1,
      anon_sym_RBRACE,
    STATE(4064), 1,
      sym_module_name,
    STATE(7262), 1,
      sym__qid,
    STATE(9037), 1,
      aux_sym__record_assignments_repeat1,
    STATE(10800), 1,
      sym__record_assignments,
    STATE(9733), 3,
      sym__record_assignment,
      sym_field_assignment,
      sym_module_assignment,
  [662400] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(15093), 1,
      sym_id,
    ACTIONS(15465), 1,
      anon_sym_RBRACE,
    STATE(4064), 1,
      sym_module_name,
    STATE(7262), 1,
      sym__qid,
    STATE(9037), 1,
      aux_sym__record_assignments_repeat1,
    STATE(12662), 1,
      sym__record_assignments,
    STATE(9733), 3,
      sym__record_assignment,
      sym_field_assignment,
      sym_module_assignment,
  [662433] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(15093), 1,
      sym_id,
    ACTIONS(15467), 1,
      anon_sym_RBRACE,
    STATE(4064), 1,
      sym_module_name,
    STATE(7262), 1,
      sym__qid,
    STATE(9037), 1,
      aux_sym__record_assignments_repeat1,
    STATE(11728), 1,
      sym__record_assignments,
    STATE(9733), 3,
      sym__record_assignment,
      sym_field_assignment,
      sym_module_assignment,
  [662466] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13250), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13248), 7,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [662487] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(15093), 1,
      sym_id,
    ACTIONS(15469), 1,
      anon_sym_RBRACE,
    STATE(4064), 1,
      sym_module_name,
    STATE(7262), 1,
      sym__qid,
    STATE(9037), 1,
      aux_sym__record_assignments_repeat1,
    STATE(12571), 1,
      sym__record_assignments,
    STATE(9733), 3,
      sym__record_assignment,
      sym_field_assignment,
      sym_module_assignment,
  [662520] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(15093), 1,
      sym_id,
    ACTIONS(15471), 1,
      anon_sym_RBRACE,
    STATE(4064), 1,
      sym_module_name,
    STATE(7262), 1,
      sym__qid,
    STATE(9037), 1,
      aux_sym__record_assignments_repeat1,
    STATE(10829), 1,
      sym__record_assignments,
    STATE(9733), 3,
      sym__record_assignment,
      sym_field_assignment,
      sym_module_assignment,
  [662553] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(15093), 1,
      sym_id,
    ACTIONS(15473), 1,
      anon_sym_RBRACE,
    STATE(4064), 1,
      sym_module_name,
    STATE(7262), 1,
      sym__qid,
    STATE(9037), 1,
      aux_sym__record_assignments_repeat1,
    STATE(11568), 1,
      sym__record_assignments,
    STATE(9733), 3,
      sym__record_assignment,
      sym_field_assignment,
      sym_module_assignment,
  [662586] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(15093), 1,
      sym_id,
    ACTIONS(15475), 1,
      anon_sym_RBRACE,
    STATE(4064), 1,
      sym_module_name,
    STATE(7262), 1,
      sym__qid,
    STATE(9037), 1,
      aux_sym__record_assignments_repeat1,
    STATE(11994), 1,
      sym__record_assignments,
    STATE(9733), 3,
      sym__record_assignment,
      sym_field_assignment,
      sym_module_assignment,
  [662619] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(15093), 1,
      sym_id,
    ACTIONS(15477), 1,
      anon_sym_RBRACE,
    STATE(4064), 1,
      sym_module_name,
    STATE(7262), 1,
      sym__qid,
    STATE(9037), 1,
      aux_sym__record_assignments_repeat1,
    STATE(12027), 1,
      sym__record_assignments,
    STATE(9733), 3,
      sym__record_assignment,
      sym_field_assignment,
      sym_module_assignment,
  [662652] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13295), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13293), 7,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [662673] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6326), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(6324), 7,
      anon_sym_COLON,
      anon_sym_where,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [662694] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(15093), 1,
      sym_id,
    ACTIONS(15479), 1,
      anon_sym_RBRACE,
    STATE(4064), 1,
      sym_module_name,
    STATE(7262), 1,
      sym__qid,
    STATE(9037), 1,
      aux_sym__record_assignments_repeat1,
    STATE(12611), 1,
      sym__record_assignments,
    STATE(9733), 3,
      sym__record_assignment,
      sym_field_assignment,
      sym_module_assignment,
  [662727] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(15093), 1,
      sym_id,
    ACTIONS(15481), 1,
      anon_sym_RBRACE,
    STATE(4064), 1,
      sym_module_name,
    STATE(7262), 1,
      sym__qid,
    STATE(9037), 1,
      aux_sym__record_assignments_repeat1,
    STATE(10916), 1,
      sym__record_assignments,
    STATE(9733), 3,
      sym__record_assignment,
      sym_field_assignment,
      sym_module_assignment,
  [662760] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(15093), 1,
      sym_id,
    ACTIONS(15483), 1,
      anon_sym_RBRACE,
    STATE(4064), 1,
      sym_module_name,
    STATE(7262), 1,
      sym__qid,
    STATE(9037), 1,
      aux_sym__record_assignments_repeat1,
    STATE(10843), 1,
      sym__record_assignments,
    STATE(9733), 3,
      sym__record_assignment,
      sym_field_assignment,
      sym_module_assignment,
  [662793] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(15093), 1,
      sym_id,
    ACTIONS(15485), 1,
      anon_sym_RBRACE,
    STATE(4064), 1,
      sym_module_name,
    STATE(7262), 1,
      sym__qid,
    STATE(9037), 1,
      aux_sym__record_assignments_repeat1,
    STATE(10862), 1,
      sym__record_assignments,
    STATE(9733), 3,
      sym__record_assignment,
      sym_field_assignment,
      sym_module_assignment,
  [662826] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(15093), 1,
      sym_id,
    ACTIONS(15487), 1,
      anon_sym_RBRACE,
    STATE(4064), 1,
      sym_module_name,
    STATE(7262), 1,
      sym__qid,
    STATE(9037), 1,
      aux_sym__record_assignments_repeat1,
    STATE(10806), 1,
      sym__record_assignments,
    STATE(9733), 3,
      sym__record_assignment,
      sym_field_assignment,
      sym_module_assignment,
  [662859] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13299), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13297), 7,
      anon_sym_COLON,
      anon_sym_where,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [662880] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(15093), 1,
      sym_id,
    ACTIONS(15489), 1,
      anon_sym_RBRACE,
    STATE(4064), 1,
      sym_module_name,
    STATE(7262), 1,
      sym__qid,
    STATE(9037), 1,
      aux_sym__record_assignments_repeat1,
    STATE(10928), 1,
      sym__record_assignments,
    STATE(9733), 3,
      sym__record_assignment,
      sym_field_assignment,
      sym_module_assignment,
  [662913] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(15093), 1,
      sym_id,
    ACTIONS(15491), 1,
      anon_sym_RBRACE,
    STATE(4064), 1,
      sym_module_name,
    STATE(7262), 1,
      sym__qid,
    STATE(9037), 1,
      aux_sym__record_assignments_repeat1,
    STATE(12056), 1,
      sym__record_assignments,
    STATE(9733), 3,
      sym__record_assignment,
      sym_field_assignment,
      sym_module_assignment,
  [662946] = 4,
    STATE(2125), 1,
      sym__ARROW,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15493), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(14953), 7,
      sym__newline,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
  [662967] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(15093), 1,
      sym_id,
    ACTIONS(15495), 1,
      anon_sym_RBRACE,
    STATE(4064), 1,
      sym_module_name,
    STATE(7262), 1,
      sym__qid,
    STATE(9037), 1,
      aux_sym__record_assignments_repeat1,
    STATE(12591), 1,
      sym__record_assignments,
    STATE(9733), 3,
      sym__record_assignment,
      sym_field_assignment,
      sym_module_assignment,
  [663000] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(15093), 1,
      sym_id,
    ACTIONS(15497), 1,
      anon_sym_RBRACE,
    STATE(4064), 1,
      sym_module_name,
    STATE(7262), 1,
      sym__qid,
    STATE(9037), 1,
      aux_sym__record_assignments_repeat1,
    STATE(10878), 1,
      sym__record_assignments,
    STATE(9733), 3,
      sym__record_assignment,
      sym_field_assignment,
      sym_module_assignment,
  [663033] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(15093), 1,
      sym_id,
    ACTIONS(15499), 1,
      anon_sym_RBRACE,
    STATE(4064), 1,
      sym_module_name,
    STATE(7262), 1,
      sym__qid,
    STATE(9037), 1,
      aux_sym__record_assignments_repeat1,
    STATE(10881), 1,
      sym__record_assignments,
    STATE(9733), 3,
      sym__record_assignment,
      sym_field_assignment,
      sym_module_assignment,
  [663066] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(15093), 1,
      sym_id,
    ACTIONS(15501), 1,
      anon_sym_RBRACE,
    STATE(4064), 1,
      sym_module_name,
    STATE(7262), 1,
      sym__qid,
    STATE(9037), 1,
      aux_sym__record_assignments_repeat1,
    STATE(12011), 1,
      sym__record_assignments,
    STATE(9733), 3,
      sym__record_assignment,
      sym_field_assignment,
      sym_module_assignment,
  [663099] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(15093), 1,
      sym_id,
    ACTIONS(15503), 1,
      anon_sym_RBRACE,
    STATE(4064), 1,
      sym_module_name,
    STATE(7262), 1,
      sym__qid,
    STATE(9037), 1,
      aux_sym__record_assignments_repeat1,
    STATE(11714), 1,
      sym__record_assignments,
    STATE(9733), 3,
      sym__record_assignment,
      sym_field_assignment,
      sym_module_assignment,
  [663132] = 6,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(15505), 1,
      anon_sym_AT,
    ACTIONS(11284), 2,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    STATE(8923), 2,
      sym_attribute,
      aux_sym__modal_arg_ids_repeat1,
    ACTIONS(11282), 4,
      anon_sym_u2983,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [663156] = 2,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15508), 9,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2984,
      anon_sym_PIPE_RPAREN,
      anon_sym_u2988,
  [663172] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13339), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13337), 6,
      anon_sym_where,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [663192] = 3,
    ACTIONS(15089), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15510), 8,
      sym__newline,
      anon_sym_COLON,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_in,
  [663210] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13299), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13297), 6,
      anon_sym_EQ,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [663230] = 4,
    STATE(2252), 1,
      sym__ARROW,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15512), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(14953), 6,
      sym__newline,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
  [663250] = 2,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15514), 9,
      sym__newline,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_in,
  [663266] = 2,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15516), 9,
      sym__newline,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_in,
  [663282] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13299), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13297), 6,
      anon_sym_where,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [663302] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13254), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13252), 6,
      anon_sym_EQ,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [663322] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13343), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13341), 6,
      anon_sym_EQ,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [663342] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(15518), 1,
      sym_id,
    ACTIONS(15520), 1,
      anon_sym_LPAREN,
    ACTIONS(15522), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(15524), 1,
      anon_sym_u2983,
    ACTIONS(15526), 1,
      anon_sym_LBRACE,
    STATE(9169), 1,
      sym__simple_top_hole,
    STATE(10662), 1,
      sym_hole_names,
    STATE(8979), 2,
      sym_hole_name,
      aux_sym_hole_names_repeat1,
  [663374] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13339), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13337), 6,
      anon_sym_EQ,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [663394] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(15528), 1,
      sym_id,
    ACTIONS(15531), 1,
      anon_sym_EQ,
    ACTIONS(15533), 1,
      anon_sym_LPAREN,
    ACTIONS(15536), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(15539), 1,
      anon_sym_u2983,
    ACTIONS(15542), 1,
      anon_sym_LBRACE,
    STATE(9169), 1,
      sym__simple_top_hole,
    STATE(8936), 2,
      sym_hole_name,
      aux_sym_hole_names_repeat1,
  [663426] = 2,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15545), 9,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_u2984,
      anon_sym_RBRACE,
      anon_sym_PIPE_RPAREN,
      anon_sym_u2988,
  [663442] = 2,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15547), 9,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2984,
      anon_sym_PIPE_RPAREN,
      anon_sym_u2988,
  [663458] = 2,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15549), 9,
      sym__newline,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_in,
  [663474] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13343), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13341), 6,
      anon_sym_where,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [663494] = 2,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15551), 9,
      sym__newline,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_in,
  [663510] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13291), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13289), 6,
      anon_sym_EQ,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [663530] = 2,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15553), 9,
      sym__newline,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_in,
  [663546] = 2,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15547), 9,
      sym__newline,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_in,
  [663562] = 2,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15555), 9,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_u2984,
      anon_sym_RBRACE,
      anon_sym_PIPE_RPAREN,
      anon_sym_u2988,
  [663578] = 2,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15557), 9,
      sym__newline,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_in,
  [663594] = 2,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15559), 9,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2984,
      anon_sym_PIPE_RPAREN,
      anon_sym_u2988,
  [663610] = 2,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15561), 9,
      sym__newline,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_in,
  [663626] = 2,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15563), 9,
      sym__newline,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_in,
  [663642] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13303), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13301), 6,
      anon_sym_EQ,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [663662] = 2,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15565), 9,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2984,
      anon_sym_PIPE_RPAREN,
      anon_sym_u2988,
  [663678] = 2,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15565), 9,
      sym__newline,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_in,
  [663694] = 7,
    ACTIONS(15397), 1,
      anon_sym_COLON,
    ACTIONS(15567), 1,
      anon_sym_with,
    ACTIONS(15569), 1,
      anon_sym_rewrite,
    STATE(9067), 1,
      sym_rewrite_equations,
    STATE(9164), 1,
      sym_with_expressions,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15399), 4,
      sym__newline,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
  [663720] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13254), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13252), 6,
      anon_sym_where,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [663740] = 2,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15571), 9,
      sym__newline,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_in,
  [663756] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13250), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13248), 6,
      anon_sym_EQ,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [663776] = 2,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15573), 9,
      sym__newline,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_in,
  [663792] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13295), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13293), 6,
      anon_sym_EQ,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [663812] = 2,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15551), 9,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2984,
      anon_sym_PIPE_RPAREN,
      anon_sym_u2988,
  [663828] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13287), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13285), 6,
      anon_sym_where,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [663848] = 2,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15575), 9,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2984,
      anon_sym_PIPE_RPAREN,
      anon_sym_u2988,
  [663864] = 5,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13333), 1,
      anon_sym_EQ,
    ACTIONS(13329), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13325), 5,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [663886] = 3,
    ACTIONS(15579), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15577), 8,
      sym__newline,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_in,
  [663904] = 2,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15571), 9,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2984,
      anon_sym_PIPE_RPAREN,
      anon_sym_u2988,
  [663920] = 5,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13327), 1,
      anon_sym_EQ,
    ACTIONS(13329), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13325), 5,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [663942] = 3,
    ACTIONS(15579), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15577), 8,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_RPAREN,
      anon_sym_u2984,
      anon_sym_RBRACE,
      anon_sym_PIPE_RPAREN,
      anon_sym_u2988,
  [663960] = 4,
    STATE(1819), 1,
      sym__ARROW,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15581), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(14953), 6,
      sym__newline,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
  [663980] = 2,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15514), 9,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_u2984,
      anon_sym_RBRACE,
      anon_sym_PIPE_RPAREN,
      anon_sym_u2988,
  [663996] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13291), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13289), 6,
      anon_sym_where,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [664016] = 2,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15573), 9,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_u2984,
      anon_sym_RBRACE,
      anon_sym_PIPE_RPAREN,
      anon_sym_u2988,
  [664032] = 2,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15577), 9,
      sym__newline,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_in,
  [664048] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13303), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13301), 6,
      anon_sym_where,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [664068] = 2,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15557), 9,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2984,
      anon_sym_PIPE_RPAREN,
      anon_sym_u2988,
  [664084] = 2,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15561), 9,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2984,
      anon_sym_PIPE_RPAREN,
      anon_sym_u2988,
  [664100] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13250), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13248), 6,
      anon_sym_where,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [664120] = 2,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15553), 9,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2984,
      anon_sym_PIPE_RPAREN,
      anon_sym_u2988,
  [664136] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13295), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13293), 6,
      anon_sym_where,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [664156] = 2,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15549), 9,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2984,
      anon_sym_PIPE_RPAREN,
      anon_sym_u2988,
  [664172] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(15518), 1,
      sym_id,
    ACTIONS(15520), 1,
      anon_sym_LPAREN,
    ACTIONS(15522), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(15524), 1,
      anon_sym_u2983,
    ACTIONS(15526), 1,
      anon_sym_LBRACE,
    ACTIONS(15583), 1,
      anon_sym_EQ,
    STATE(9169), 1,
      sym__simple_top_hole,
    STATE(8936), 2,
      sym_hole_name,
      aux_sym_hole_names_repeat1,
  [664204] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13287), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13285), 6,
      anon_sym_EQ,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [664224] = 2,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15508), 9,
      sym__newline,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_in,
  [664240] = 2,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15575), 9,
      sym__newline,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_in,
  [664256] = 6,
    ACTIONS(15585), 1,
      anon_sym_public,
    ACTIONS(15593), 1,
      anon_sym_renaming,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15588), 2,
      anon_sym_using,
      anon_sym_hiding,
    STATE(8983), 2,
      aux_sym__import_directives,
      sym_import_directive,
    ACTIONS(15591), 3,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [664280] = 4,
    STATE(2164), 1,
      sym__ARROW,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15596), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(14953), 6,
      sym__newline,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_in,
  [664300] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6326), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(6324), 6,
      anon_sym_EQ,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [664320] = 3,
    ACTIONS(15579), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15598), 8,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_RPAREN,
      anon_sym_u2984,
      anon_sym_RBRACE,
      anon_sym_PIPE_RPAREN,
      anon_sym_u2988,
  [664338] = 2,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15600), 9,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2984,
      anon_sym_PIPE_RPAREN,
      anon_sym_u2988,
  [664354] = 2,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15602), 9,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2984,
      anon_sym_PIPE_RPAREN,
      anon_sym_u2988,
  [664370] = 2,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15577), 9,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_u2984,
      anon_sym_RBRACE,
      anon_sym_PIPE_RPAREN,
      anon_sym_u2988,
  [664386] = 2,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15516), 9,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2984,
      anon_sym_PIPE_RPAREN,
      anon_sym_u2988,
  [664402] = 10,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(15518), 1,
      sym_id,
    ACTIONS(15520), 1,
      anon_sym_LPAREN,
    ACTIONS(15522), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(15524), 1,
      anon_sym_u2983,
    ACTIONS(15526), 1,
      anon_sym_LBRACE,
    STATE(9169), 1,
      sym__simple_top_hole,
    STATE(12528), 1,
      sym_hole_names,
    STATE(8979), 2,
      sym_hole_name,
      aux_sym_hole_names_repeat1,
  [664434] = 2,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15563), 9,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2984,
      anon_sym_PIPE_RPAREN,
      anon_sym_u2988,
  [664450] = 3,
    ACTIONS(15579), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15598), 8,
      sym__newline,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_in,
  [664468] = 2,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15559), 9,
      sym__newline,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_in,
  [664484] = 2,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15604), 9,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2984,
      anon_sym_PIPE_RPAREN,
      anon_sym_u2988,
  [664500] = 2,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15604), 9,
      sym__newline,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_in,
  [664516] = 2,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15606), 9,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2984,
      anon_sym_PIPE_RPAREN,
      anon_sym_u2988,
  [664532] = 4,
    STATE(1881), 1,
      sym__ARROW,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15608), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(14953), 6,
      sym__newline,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_in,
  [664552] = 2,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15600), 9,
      sym__newline,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_in,
  [664568] = 2,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15602), 9,
      sym__newline,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_in,
  [664584] = 2,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15606), 9,
      sym__newline,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_in,
  [664600] = 2,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15545), 9,
      sym__newline,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_in,
  [664616] = 2,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15555), 9,
      sym__newline,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_in,
  [664632] = 6,
    ACTIONS(15610), 1,
      anon_sym_public,
    ACTIONS(15614), 1,
      anon_sym_renaming,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15612), 2,
      anon_sym_using,
      anon_sym_hiding,
    ACTIONS(15616), 2,
      sym__newline,
      anon_sym_in,
    STATE(9013), 2,
      sym_import_directive,
      aux_sym_module_macro_repeat1,
  [664655] = 6,
    ACTIONS(15618), 1,
      anon_sym_public,
    ACTIONS(15622), 1,
      anon_sym_renaming,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15620), 2,
      anon_sym_using,
      anon_sym_hiding,
    ACTIONS(15624), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    STATE(8983), 2,
      aux_sym__import_directives,
      sym_import_directive,
  [664678] = 6,
    ACTIONS(15610), 1,
      anon_sym_public,
    ACTIONS(15614), 1,
      anon_sym_renaming,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15612), 2,
      anon_sym_using,
      anon_sym_hiding,
    ACTIONS(15616), 2,
      sym__newline,
      anon_sym_in,
    STATE(9015), 2,
      sym_import_directive,
      aux_sym_module_macro_repeat1,
  [664701] = 6,
    ACTIONS(15610), 1,
      anon_sym_public,
    ACTIONS(15614), 1,
      anon_sym_renaming,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(7061), 2,
      sym__newline,
      anon_sym_in,
    ACTIONS(15612), 2,
      anon_sym_using,
      anon_sym_hiding,
    STATE(9033), 2,
      aux_sym__import_directives,
      sym_import_directive,
  [664724] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13254), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13252), 5,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [664743] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13299), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13297), 5,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [664762] = 3,
    ACTIONS(15031), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15510), 7,
      sym__newline,
      anon_sym_COLON,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
  [664779] = 6,
    ACTIONS(15610), 1,
      anon_sym_public,
    ACTIONS(15614), 1,
      anon_sym_renaming,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15612), 2,
      anon_sym_using,
      anon_sym_hiding,
    ACTIONS(15626), 2,
      sym__newline,
      anon_sym_in,
    STATE(9019), 2,
      sym_import_directive,
      aux_sym_module_macro_repeat1,
  [664802] = 3,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(13301), 2,
      anon_sym_LBRACE,
      anon_sym_DOT,
    ACTIONS(13303), 6,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_DOT_DOT,
  [664819] = 6,
    ACTIONS(15628), 1,
      anon_sym_public,
    ACTIONS(15634), 1,
      anon_sym_renaming,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15631), 2,
      anon_sym_using,
      anon_sym_hiding,
    ACTIONS(15637), 2,
      sym__newline,
      anon_sym_in,
    STATE(9013), 2,
      sym_import_directive,
      aux_sym_module_macro_repeat1,
  [664842] = 6,
    ACTIONS(15610), 1,
      anon_sym_public,
    ACTIONS(15614), 1,
      anon_sym_renaming,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15612), 2,
      anon_sym_using,
      anon_sym_hiding,
    ACTIONS(15639), 2,
      sym__newline,
      anon_sym_in,
    STATE(9013), 2,
      sym_import_directive,
      aux_sym_module_macro_repeat1,
  [664865] = 6,
    ACTIONS(15610), 1,
      anon_sym_public,
    ACTIONS(15614), 1,
      anon_sym_renaming,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15612), 2,
      anon_sym_using,
      anon_sym_hiding,
    ACTIONS(15641), 2,
      sym__newline,
      anon_sym_in,
    STATE(9013), 2,
      sym_import_directive,
      aux_sym_module_macro_repeat1,
  [664888] = 4,
    STATE(2051), 1,
      sym__ARROW,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15643), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(14953), 5,
      sym__newline,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_in,
  [664907] = 3,
    ACTIONS(15053), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15510), 7,
      sym__newline,
      anon_sym_COLON,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
      anon_sym_in,
  [664924] = 8,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(15645), 1,
      sym_id,
    ACTIONS(15648), 1,
      aux_sym__qid_token1,
    STATE(4064), 1,
      sym_module_name,
    STATE(7262), 1,
      sym__qid,
    STATE(9018), 1,
      aux_sym__record_assignments_repeat1,
    STATE(12268), 3,
      sym__record_assignment,
      sym_field_assignment,
      sym_module_assignment,
  [664951] = 6,
    ACTIONS(15610), 1,
      anon_sym_public,
    ACTIONS(15614), 1,
      anon_sym_renaming,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15612), 2,
      anon_sym_using,
      anon_sym_hiding,
    ACTIONS(15651), 2,
      sym__newline,
      anon_sym_in,
    STATE(9013), 2,
      sym_import_directive,
      aux_sym_module_macro_repeat1,
  [664974] = 6,
    ACTIONS(15610), 1,
      anon_sym_public,
    ACTIONS(15614), 1,
      anon_sym_renaming,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15612), 2,
      anon_sym_using,
      anon_sym_hiding,
    ACTIONS(15651), 2,
      sym__newline,
      anon_sym_in,
    STATE(9014), 2,
      sym_import_directive,
      aux_sym_module_macro_repeat1,
  [664997] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13339), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13337), 5,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [665016] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13295), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13293), 5,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [665035] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13250), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13248), 5,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [665054] = 6,
    ACTIONS(15610), 1,
      anon_sym_public,
    ACTIONS(15614), 1,
      anon_sym_renaming,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15612), 2,
      anon_sym_using,
      anon_sym_hiding,
    ACTIONS(15653), 2,
      sym__newline,
      anon_sym_in,
    STATE(9004), 2,
      sym_import_directive,
      aux_sym_module_macro_repeat1,
  [665077] = 6,
    ACTIONS(15618), 1,
      anon_sym_public,
    ACTIONS(15622), 1,
      anon_sym_renaming,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6936), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(15620), 2,
      anon_sym_using,
      anon_sym_hiding,
    STATE(8983), 2,
      aux_sym__import_directives,
      sym_import_directive,
  [665100] = 3,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(13293), 2,
      anon_sym_LBRACE,
      anon_sym_DOT,
    ACTIONS(13295), 6,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_DOT_DOT,
  [665117] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(15657), 1,
      anon_sym_LPAREN,
    ACTIONS(15659), 1,
      aux_sym_integer_token1,
    ACTIONS(15661), 1,
      aux_sym_string_token1,
    ACTIONS(15655), 2,
      sym_id,
      aux_sym__qid_token1,
    STATE(9139), 3,
      sym__qid,
      sym__expr_or_attr,
      sym_literal,
  [665142] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(15665), 1,
      anon_sym_LPAREN,
    ACTIONS(15667), 1,
      aux_sym_integer_token1,
    ACTIONS(15669), 1,
      aux_sym_string_token1,
    ACTIONS(15663), 2,
      sym_id,
      aux_sym__qid_token1,
    STATE(6670), 3,
      sym__qid,
      sym__expr_or_attr,
      sym_literal,
  [665167] = 3,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(13248), 2,
      anon_sym_LBRACE,
      anon_sym_DOT,
    ACTIONS(13250), 6,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_DOT_DOT,
  [665184] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(15673), 1,
      anon_sym_LPAREN,
    ACTIONS(15675), 1,
      aux_sym_integer_token1,
    ACTIONS(15677), 1,
      aux_sym_string_token1,
    ACTIONS(15671), 2,
      sym_id,
      aux_sym__qid_token1,
    STATE(7838), 3,
      sym__qid,
      sym__expr_or_attr,
      sym_literal,
  [665209] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(7531), 1,
      aux_sym_integer_token1,
    ACTIONS(11509), 1,
      aux_sym_string_token1,
    ACTIONS(15679), 1,
      anon_sym_LPAREN,
    ACTIONS(7523), 2,
      sym_id,
      aux_sym__qid_token1,
    STATE(6855), 3,
      sym__qid,
      sym__expr_or_attr,
      sym_literal,
  [665234] = 4,
    STATE(1936), 1,
      sym__ARROW,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15681), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(14953), 5,
      sym__newline,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
  [665253] = 6,
    ACTIONS(15683), 1,
      anon_sym_public,
    ACTIONS(15689), 1,
      anon_sym_renaming,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15591), 2,
      sym__newline,
      anon_sym_in,
    ACTIONS(15686), 2,
      anon_sym_using,
      anon_sym_hiding,
    STATE(9033), 2,
      aux_sym__import_directives,
      sym_import_directive,
  [665276] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13303), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13301), 5,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [665295] = 4,
    STATE(2367), 1,
      sym__ARROW,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15692), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(14953), 5,
      sym__newline,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
  [665314] = 3,
    ACTIONS(15021), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15510), 7,
      sym__newline,
      anon_sym_COLON,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_in,
  [665331] = 8,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6938), 1,
      aux_sym__qid_token1,
    ACTIONS(15093), 1,
      sym_id,
    STATE(4064), 1,
      sym_module_name,
    STATE(7262), 1,
      sym__qid,
    STATE(9018), 1,
      aux_sym__record_assignments_repeat1,
    STATE(10052), 3,
      sym__record_assignment,
      sym_field_assignment,
      sym_module_assignment,
  [665358] = 5,
    ACTIONS(15401), 1,
      anon_sym_with,
    ACTIONS(15694), 1,
      anon_sym_COLON,
    STATE(9148), 1,
      sym_with_expressions,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15696), 5,
      sym__newline,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_in,
  [665379] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13287), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13285), 5,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [665398] = 6,
    ACTIONS(15610), 1,
      anon_sym_public,
    ACTIONS(15614), 1,
      anon_sym_renaming,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15612), 2,
      anon_sym_using,
      anon_sym_hiding,
    ACTIONS(15698), 2,
      sym__newline,
      anon_sym_in,
    STATE(9033), 2,
      aux_sym__import_directives,
      sym_import_directive,
  [665421] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13291), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13289), 5,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [665440] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13343), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(13341), 5,
      anon_sym_u2983,
      anon_sym__,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [665459] = 3,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(13289), 2,
      anon_sym_LBRACE,
      anon_sym_DOT,
    ACTIONS(13291), 6,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
      anon_sym_u2983,
      anon_sym_DOT_DOT,
  [665476] = 4,
    STATE(1659), 1,
      sym__ARROW,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15700), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(14953), 5,
      sym__newline,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_in,
  [665495] = 8,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(15702), 1,
      anon_sym_LPAREN,
    ACTIONS(15704), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(15706), 1,
      anon_sym_u2983,
    ACTIONS(15708), 1,
      anon_sym_LBRACE,
    STATE(8516), 1,
      sym_bid,
    ACTIONS(13866), 2,
      anon_sym__,
      sym_id,
  [665521] = 8,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(15710), 1,
      anon_sym_LPAREN,
    ACTIONS(15712), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(15714), 1,
      anon_sym_u2983,
    ACTIONS(15716), 1,
      anon_sym_LBRACE,
    STATE(8010), 1,
      sym_bid,
    ACTIONS(13781), 2,
      anon_sym__,
      sym_id,
  [665547] = 8,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(15718), 1,
      anon_sym_LPAREN,
    ACTIONS(15720), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(15722), 1,
      anon_sym_u2983,
    ACTIONS(15724), 1,
      anon_sym_LBRACE,
    STATE(8289), 1,
      sym_bid,
    ACTIONS(13632), 2,
      anon_sym__,
      sym_id,
  [665573] = 8,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(15726), 1,
      anon_sym_LPAREN,
    ACTIONS(15728), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(15730), 1,
      anon_sym_u2983,
    ACTIONS(15732), 1,
      anon_sym_LBRACE,
    STATE(8437), 1,
      sym_bid,
    ACTIONS(13575), 2,
      anon_sym__,
      sym_id,
  [665599] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6326), 3,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
      anon_sym_AT,
    ACTIONS(6324), 4,
      anon_sym_u2983,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [665617] = 8,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(15734), 1,
      anon_sym_LPAREN,
    ACTIONS(15736), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(15738), 1,
      anon_sym_u2983,
    ACTIONS(15740), 1,
      anon_sym_LBRACE,
    STATE(8425), 1,
      sym_bid,
    ACTIONS(13511), 2,
      anon_sym__,
      sym_id,
  [665643] = 8,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(15742), 1,
      anon_sym_LPAREN,
    ACTIONS(15744), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(15746), 1,
      anon_sym_u2983,
    ACTIONS(15748), 1,
      anon_sym_LBRACE,
    STATE(8186), 1,
      sym_bid,
    ACTIONS(13712), 2,
      anon_sym__,
      sym_id,
  [665669] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(15752), 2,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(15750), 5,
      anon_sym_COLON,
      anon_sym_u2983,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [665687] = 8,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(15754), 1,
      anon_sym_LPAREN,
    ACTIONS(15756), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(15758), 1,
      anon_sym_u2983,
    ACTIONS(15760), 1,
      anon_sym_LBRACE,
    STATE(8219), 1,
      sym_bid,
    ACTIONS(14312), 2,
      anon_sym__,
      sym_id,
  [665713] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6655), 3,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
      anon_sym_AT,
    ACTIONS(6653), 4,
      anon_sym_u2983,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [665731] = 8,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(15762), 1,
      anon_sym_LPAREN,
    ACTIONS(15764), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(15766), 1,
      anon_sym_u2983,
    ACTIONS(15768), 1,
      anon_sym_LBRACE,
    STATE(8145), 1,
      sym_bid,
    ACTIONS(13527), 2,
      anon_sym__,
      sym_id,
  [665757] = 8,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(15770), 1,
      anon_sym_LPAREN,
    ACTIONS(15772), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(15774), 1,
      anon_sym_u2983,
    ACTIONS(15776), 1,
      anon_sym_LBRACE,
    STATE(8308), 1,
      sym_bid,
    ACTIONS(14418), 2,
      anon_sym__,
      sym_id,
  [665783] = 8,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(15778), 1,
      anon_sym_LPAREN,
    ACTIONS(15780), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(15782), 1,
      anon_sym_u2983,
    ACTIONS(15784), 1,
      anon_sym_LBRACE,
    STATE(7920), 1,
      sym_bid,
    ACTIONS(14078), 2,
      anon_sym__,
      sym_id,
  [665809] = 3,
    ACTIONS(15009), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15510), 6,
      sym__newline,
      anon_sym_COLON,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_in,
  [665825] = 7,
    ACTIONS(15786), 1,
      anon_sym_EQ,
    ACTIONS(15788), 1,
      anon_sym_module,
    ACTIONS(15790), 1,
      anon_sym_where,
    STATE(9317), 1,
      sym_rhs_defn,
    STATE(9892), 1,
      sym_where,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15792), 2,
      sym__newline,
      anon_sym_in,
  [665849] = 8,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(15794), 1,
      anon_sym_LPAREN,
    ACTIONS(15796), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(15798), 1,
      anon_sym_u2983,
    ACTIONS(15800), 1,
      anon_sym_LBRACE,
    STATE(8453), 1,
      sym_bid,
    ACTIONS(13834), 2,
      anon_sym__,
      sym_id,
  [665875] = 8,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(15802), 1,
      anon_sym_LPAREN,
    ACTIONS(15804), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(15806), 1,
      anon_sym_u2983,
    ACTIONS(15808), 1,
      anon_sym_LBRACE,
    STATE(8619), 1,
      sym_bid,
    ACTIONS(13797), 2,
      anon_sym__,
      sym_id,
  [665901] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(6496), 3,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
      anon_sym_AT,
    ACTIONS(6494), 4,
      anon_sym_u2983,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [665919] = 8,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(15810), 1,
      anon_sym_LPAREN,
    ACTIONS(15812), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(15814), 1,
      anon_sym_u2983,
    ACTIONS(15816), 1,
      anon_sym_LBRACE,
    STATE(8606), 1,
      sym_bid,
    ACTIONS(14112), 2,
      anon_sym__,
      sym_id,
  [665945] = 8,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(15818), 1,
      anon_sym_LPAREN,
    ACTIONS(15820), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(15822), 1,
      anon_sym_u2983,
    ACTIONS(15824), 1,
      anon_sym_LBRACE,
    STATE(8317), 1,
      sym_bid,
    ACTIONS(14264), 2,
      anon_sym__,
      sym_id,
  [665971] = 8,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(15826), 1,
      anon_sym_LPAREN,
    ACTIONS(15828), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(15830), 1,
      anon_sym_u2983,
    ACTIONS(15832), 1,
      anon_sym_LBRACE,
    STATE(8935), 1,
      sym_bid,
    ACTIONS(13850), 2,
      anon_sym__,
      sym_id,
  [665997] = 8,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(15834), 1,
      anon_sym_LPAREN,
    ACTIONS(15836), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(15838), 1,
      anon_sym_u2983,
    ACTIONS(15840), 1,
      anon_sym_LBRACE,
    STATE(8486), 1,
      sym_bid,
    ACTIONS(14214), 2,
      anon_sym__,
      sym_id,
  [666023] = 5,
    ACTIONS(15567), 1,
      anon_sym_with,
    ACTIONS(15694), 1,
      anon_sym_COLON,
    STATE(9148), 1,
      sym_with_expressions,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15696), 4,
      sym__newline,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
  [666043] = 8,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(15842), 1,
      anon_sym_LPAREN,
    ACTIONS(15844), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(15846), 1,
      anon_sym_u2983,
    ACTIONS(15848), 1,
      anon_sym_LBRACE,
    STATE(7856), 1,
      sym_bid,
    ACTIONS(14346), 2,
      anon_sym__,
      sym_id,
  [666069] = 8,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(15850), 1,
      anon_sym_LPAREN,
    ACTIONS(15852), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(15854), 1,
      anon_sym_u2983,
    ACTIONS(15856), 1,
      anon_sym_LBRACE,
    STATE(7893), 1,
      sym_bid,
    ACTIONS(14166), 2,
      anon_sym__,
      sym_id,
  [666095] = 8,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(15858), 1,
      anon_sym_LPAREN,
    ACTIONS(15860), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(15862), 1,
      anon_sym_u2983,
    ACTIONS(15864), 1,
      anon_sym_LBRACE,
    STATE(8108), 1,
      sym_bid,
    ACTIONS(13882), 2,
      anon_sym__,
      sym_id,
  [666121] = 4,
    STATE(2488), 1,
      sym__ARROW,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15866), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(14953), 4,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [666139] = 4,
    STATE(2308), 1,
      sym__ARROW,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15868), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(14953), 4,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [666157] = 8,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(15870), 1,
      anon_sym_LPAREN,
    ACTIONS(15872), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(15874), 1,
      anon_sym_u2983,
    ACTIONS(15876), 1,
      anon_sym_LBRACE,
    STATE(8264), 1,
      sym_bid,
    ACTIONS(14008), 2,
      anon_sym__,
      sym_id,
  [666183] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(15880), 2,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(15878), 5,
      anon_sym_COLON,
      anon_sym_u2983,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [666201] = 8,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(15882), 1,
      anon_sym_LPAREN,
    ACTIONS(15884), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(15886), 1,
      anon_sym_u2983,
    ACTIONS(15888), 1,
      anon_sym_LBRACE,
    STATE(7955), 1,
      sym_bid,
    ACTIONS(13495), 2,
      anon_sym__,
      sym_id,
  [666227] = 3,
    ACTIONS(15001), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15510), 6,
      sym__newline,
      anon_sym_COLON,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_in,
  [666243] = 8,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(15890), 1,
      anon_sym_LPAREN,
    ACTIONS(15892), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(15894), 1,
      anon_sym_u2983,
    ACTIONS(15896), 1,
      anon_sym_LBRACE,
    STATE(8046), 1,
      sym_bid,
    ACTIONS(14198), 2,
      anon_sym__,
      sym_id,
  [666269] = 8,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(15898), 1,
      anon_sym_LPAREN,
    ACTIONS(15900), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(15902), 1,
      anon_sym_u2983,
    ACTIONS(15904), 1,
      anon_sym_LBRACE,
    STATE(8596), 1,
      sym_bid,
    ACTIONS(14182), 2,
      anon_sym__,
      sym_id,
  [666295] = 8,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(15906), 1,
      anon_sym_LPAREN,
    ACTIONS(15908), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(15910), 1,
      anon_sym_u2983,
    ACTIONS(15912), 1,
      anon_sym_LBRACE,
    STATE(8416), 1,
      sym_bid,
    ACTIONS(14296), 2,
      anon_sym__,
      sym_id,
  [666321] = 8,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(15914), 1,
      anon_sym_LPAREN,
    ACTIONS(15916), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(15918), 1,
      anon_sym_u2983,
    ACTIONS(15920), 1,
      anon_sym_LBRACE,
    STATE(7910), 1,
      sym_bid,
    ACTIONS(14130), 2,
      anon_sym__,
      sym_id,
  [666347] = 8,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(15922), 1,
      anon_sym_LPAREN,
    ACTIONS(15924), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(15926), 1,
      anon_sym_u2983,
    ACTIONS(15928), 1,
      anon_sym_LBRACE,
    STATE(8395), 1,
      sym_bid,
    ACTIONS(14246), 2,
      anon_sym__,
      sym_id,
  [666373] = 8,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(15930), 1,
      anon_sym_LPAREN,
    ACTIONS(15932), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(15934), 1,
      anon_sym_u2983,
    ACTIONS(15936), 1,
      anon_sym_LBRACE,
    STATE(8342), 1,
      sym_bid,
    ACTIONS(13479), 2,
      anon_sym__,
      sym_id,
  [666399] = 8,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(15938), 1,
      anon_sym_LPAREN,
    ACTIONS(15940), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(15942), 1,
      anon_sym_u2983,
    ACTIONS(15944), 1,
      anon_sym_LBRACE,
    STATE(8397), 1,
      sym_bid,
    ACTIONS(13898), 2,
      anon_sym__,
      sym_id,
  [666425] = 7,
    ACTIONS(15786), 1,
      anon_sym_EQ,
    ACTIONS(15788), 1,
      anon_sym_module,
    ACTIONS(15790), 1,
      anon_sym_where,
    STATE(9299), 1,
      sym_rhs_defn,
    STATE(9937), 1,
      sym_where,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15946), 2,
      sym__newline,
      anon_sym_in,
  [666449] = 8,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(15948), 1,
      anon_sym_LPAREN,
    ACTIONS(15950), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(15952), 1,
      anon_sym_u2983,
    ACTIONS(15954), 1,
      anon_sym_LBRACE,
    STATE(8325), 1,
      sym_bid,
    ACTIONS(14396), 2,
      anon_sym__,
      sym_id,
  [666475] = 8,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(15956), 1,
      anon_sym_LPAREN,
    ACTIONS(15958), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(15960), 1,
      anon_sym_u2983,
    ACTIONS(15962), 1,
      anon_sym_LBRACE,
    STATE(8768), 1,
      sym_bid,
    ACTIONS(13363), 2,
      anon_sym__,
      sym_id,
  [666501] = 2,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15964), 7,
      anon_sym_public,
      anon_sym_using,
      anon_sym_RPAREN,
      anon_sym_hiding,
      anon_sym_renaming,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [666515] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(15966), 1,
      anon_sym_module,
    ACTIONS(15968), 1,
      anon_sym_import,
    STATE(7258), 1,
      sym__qid,
    ACTIONS(6894), 2,
      sym_id,
      aux_sym__qid_token1,
    STATE(4050), 2,
      sym_import,
      sym_module_name,
  [666539] = 8,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(15970), 1,
      anon_sym_LPAREN,
    ACTIONS(15972), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(15974), 1,
      anon_sym_u2983,
    ACTIONS(15976), 1,
      anon_sym_LBRACE,
    STATE(8221), 1,
      sym_bid,
    ACTIONS(13680), 2,
      anon_sym__,
      sym_id,
  [666565] = 8,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(15978), 1,
      anon_sym_LPAREN,
    ACTIONS(15980), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(15982), 1,
      anon_sym_u2983,
    ACTIONS(15984), 1,
      anon_sym_LBRACE,
    STATE(8015), 1,
      sym_bid,
    ACTIONS(13944), 2,
      anon_sym__,
      sym_id,
  [666591] = 6,
    ACTIONS(7061), 1,
      anon_sym_RPAREN,
    ACTIONS(15618), 1,
      anon_sym_public,
    ACTIONS(15622), 1,
      anon_sym_renaming,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15620), 2,
      anon_sym_using,
      anon_sym_hiding,
    STATE(8983), 2,
      aux_sym__import_directives,
      sym_import_directive,
  [666613] = 2,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15986), 7,
      sym__newline,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_in,
  [666627] = 7,
    ACTIONS(15788), 1,
      anon_sym_module,
    ACTIONS(15790), 1,
      anon_sym_where,
    ACTIONS(15988), 1,
      anon_sym_COLON,
    STATE(9299), 1,
      sym_rhs_decl,
    STATE(9937), 1,
      sym_where,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15946), 2,
      sym__newline,
      anon_sym_in,
  [666651] = 8,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(15990), 1,
      anon_sym_LPAREN,
    ACTIONS(15992), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(15994), 1,
      anon_sym_u2983,
    ACTIONS(15996), 1,
      anon_sym_LBRACE,
    STATE(7878), 1,
      sym_bid,
    ACTIONS(14362), 2,
      anon_sym__,
      sym_id,
  [666677] = 8,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(15998), 1,
      anon_sym_LPAREN,
    ACTIONS(16000), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(16002), 1,
      anon_sym_u2983,
    ACTIONS(16004), 1,
      anon_sym_LBRACE,
    STATE(7891), 1,
      sym_bid,
    ACTIONS(14040), 2,
      anon_sym__,
      sym_id,
  [666703] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16006), 1,
      sym_id,
    ACTIONS(16008), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(16010), 1,
      anon_sym_DOT,
    ACTIONS(16012), 1,
      anon_sym_DOT_DOT,
    STATE(9103), 3,
      sym__field_name,
      sym__maybe_dotted_id,
      aux_sym__maybe_dotted_ids,
  [666727] = 8,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16014), 1,
      anon_sym_LPAREN,
    ACTIONS(16016), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(16018), 1,
      anon_sym_u2983,
    ACTIONS(16020), 1,
      anon_sym_LBRACE,
    STATE(8581), 1,
      sym_bid,
    ACTIONS(14094), 2,
      anon_sym__,
      sym_id,
  [666753] = 8,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16022), 1,
      anon_sym_LPAREN,
    ACTIONS(16024), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(16026), 1,
      anon_sym_u2983,
    ACTIONS(16028), 1,
      anon_sym_LBRACE,
    STATE(8523), 1,
      sym_bid,
    ACTIONS(14230), 2,
      anon_sym__,
      sym_id,
  [666779] = 4,
    STATE(1963), 1,
      sym__ARROW,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(16030), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(14953), 4,
      sym__newline,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_in,
  [666797] = 4,
    STATE(1779), 1,
      sym__ARROW,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(16032), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(14953), 4,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE_RBRACE,
  [666815] = 8,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16034), 1,
      anon_sym_LPAREN,
    ACTIONS(16036), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(16038), 1,
      anon_sym_u2983,
    ACTIONS(16040), 1,
      anon_sym_LBRACE,
    STATE(8251), 1,
      sym_bid,
    ACTIONS(13765), 2,
      anon_sym__,
      sym_id,
  [666841] = 8,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16042), 1,
      anon_sym_LPAREN,
    ACTIONS(16044), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(16046), 1,
      anon_sym_u2983,
    ACTIONS(16048), 1,
      anon_sym_LBRACE,
    STATE(7923), 1,
      sym_bid,
    ACTIONS(13543), 2,
      anon_sym__,
      sym_id,
  [666867] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16050), 1,
      sym_id,
    ACTIONS(16053), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(16055), 1,
      anon_sym_DOT,
    ACTIONS(16058), 1,
      anon_sym_DOT_DOT,
    STATE(9103), 3,
      sym__field_name,
      sym__maybe_dotted_id,
      aux_sym__maybe_dotted_ids,
  [666891] = 8,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16061), 1,
      anon_sym_LPAREN,
    ACTIONS(16063), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(16065), 1,
      anon_sym_u2983,
    ACTIONS(16067), 1,
      anon_sym_LBRACE,
    STATE(8199), 1,
      sym_bid,
    ACTIONS(13648), 2,
      anon_sym__,
      sym_id,
  [666917] = 3,
    ACTIONS(15075), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15510), 6,
      sym__newline,
      anon_sym_COLON,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
  [666933] = 8,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16069), 1,
      anon_sym_LPAREN,
    ACTIONS(16071), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(16073), 1,
      anon_sym_u2983,
    ACTIONS(16075), 1,
      anon_sym_LBRACE,
    STATE(8537), 1,
      sym_bid,
    ACTIONS(13924), 2,
      anon_sym__,
      sym_id,
  [666959] = 8,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16077), 1,
      anon_sym_LPAREN,
    ACTIONS(16079), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(16081), 1,
      anon_sym_u2983,
    ACTIONS(16083), 1,
      anon_sym_LBRACE,
    STATE(8558), 1,
      sym_bid,
    ACTIONS(14378), 2,
      anon_sym__,
      sym_id,
  [666985] = 4,
    STATE(2530), 1,
      sym__ARROW,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(16085), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(14953), 4,
      sym__newline,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_in,
  [667003] = 8,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16087), 1,
      anon_sym_LPAREN,
    ACTIONS(16089), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(16091), 1,
      anon_sym_u2983,
    ACTIONS(16093), 1,
      anon_sym_LBRACE,
    STATE(8869), 1,
      sym_bid,
    ACTIONS(13345), 2,
      anon_sym__,
      sym_id,
  [667029] = 6,
    ACTIONS(15618), 1,
      anon_sym_public,
    ACTIONS(15622), 1,
      anon_sym_renaming,
    ACTIONS(15698), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15620), 2,
      anon_sym_using,
      anon_sym_hiding,
    STATE(8983), 2,
      aux_sym__import_directives,
      sym_import_directive,
  [667051] = 8,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16095), 1,
      anon_sym_LPAREN,
    ACTIONS(16097), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(16099), 1,
      anon_sym_u2983,
    ACTIONS(16101), 1,
      anon_sym_LBRACE,
    STATE(8194), 1,
      sym_bid,
    ACTIONS(13559), 2,
      anon_sym__,
      sym_id,
  [667077] = 4,
    STATE(2606), 1,
      sym__ARROW,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(16103), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(14953), 4,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_u2984,
  [667095] = 8,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16105), 1,
      anon_sym_LPAREN,
    ACTIONS(16107), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(16109), 1,
      anon_sym_u2983,
    ACTIONS(16111), 1,
      anon_sym_LBRACE,
    STATE(8836), 1,
      sym_bid,
    ACTIONS(13972), 2,
      anon_sym__,
      sym_id,
  [667121] = 7,
    ACTIONS(15788), 1,
      anon_sym_module,
    ACTIONS(15790), 1,
      anon_sym_where,
    ACTIONS(15988), 1,
      anon_sym_COLON,
    STATE(9317), 1,
      sym_rhs_decl,
    STATE(9892), 1,
      sym_where,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15792), 2,
      sym__newline,
      anon_sym_in,
  [667145] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16113), 1,
      sym_id,
    ACTIONS(16116), 1,
      anon_sym_u2984,
    ACTIONS(16118), 1,
      anon_sym_DOT,
    ACTIONS(16121), 1,
      anon_sym_DOT_DOT,
    STATE(9115), 3,
      sym__field_name,
      sym__maybe_dotted_id,
      aux_sym__maybe_dotted_ids,
  [667169] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16126), 2,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(16124), 5,
      anon_sym_COLON,
      anon_sym_u2983,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [667187] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16008), 1,
      anon_sym_RBRACE,
    ACTIONS(16128), 1,
      sym_id,
    ACTIONS(16130), 1,
      anon_sym_DOT,
    ACTIONS(16132), 1,
      anon_sym_DOT_DOT,
    STATE(9123), 3,
      sym__field_name,
      sym__maybe_dotted_id,
      aux_sym__maybe_dotted_ids,
  [667211] = 4,
    STATE(2452), 1,
      sym__ARROW,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(16134), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(14953), 4,
      sym__newline,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_SEMI,
  [667229] = 8,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16136), 1,
      anon_sym_LPAREN,
    ACTIONS(16138), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(16140), 1,
      anon_sym_u2983,
    ACTIONS(16142), 1,
      anon_sym_LBRACE,
    STATE(8576), 1,
      sym_bid,
    ACTIONS(13990), 2,
      anon_sym__,
      sym_id,
  [667255] = 8,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16144), 1,
      anon_sym_LPAREN,
    ACTIONS(16146), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(16148), 1,
      anon_sym_u2983,
    ACTIONS(16150), 1,
      anon_sym_LBRACE,
    STATE(8177), 1,
      sym_bid,
    ACTIONS(14024), 2,
      anon_sym__,
      sym_id,
  [667281] = 2,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(16152), 7,
      anon_sym_public,
      anon_sym_using,
      anon_sym_RPAREN,
      anon_sym_hiding,
      anon_sym_renaming,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [667295] = 8,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16154), 1,
      anon_sym_LPAREN,
    ACTIONS(16156), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(16158), 1,
      anon_sym_u2983,
    ACTIONS(16160), 1,
      anon_sym_LBRACE,
    STATE(8120), 1,
      sym_bid,
    ACTIONS(13616), 2,
      anon_sym__,
      sym_id,
  [667321] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16053), 1,
      anon_sym_RBRACE,
    ACTIONS(16162), 1,
      sym_id,
    ACTIONS(16165), 1,
      anon_sym_DOT,
    ACTIONS(16168), 1,
      anon_sym_DOT_DOT,
    STATE(9123), 3,
      sym__field_name,
      sym__maybe_dotted_id,
      aux_sym__maybe_dotted_ids,
  [667345] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16171), 1,
      anon_sym_module,
    ACTIONS(16173), 1,
      anon_sym_import,
    STATE(7348), 1,
      sym__qid,
    ACTIONS(7679), 2,
      sym_id,
      aux_sym__qid_token1,
    STATE(4228), 2,
      sym_import,
      sym_module_name,
  [667369] = 3,
    ACTIONS(15015), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15510), 6,
      sym__newline,
      anon_sym_COLON,
      anon_sym_with,
      anon_sym_rewrite,
      anon_sym_module,
      anon_sym_where,
  [667385] = 8,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16175), 1,
      anon_sym_LPAREN,
    ACTIONS(16177), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(16179), 1,
      anon_sym_u2983,
    ACTIONS(16181), 1,
      anon_sym_LBRACE,
    STATE(8553), 1,
      sym_bid,
    ACTIONS(14058), 2,
      anon_sym__,
      sym_id,
  [667411] = 8,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16183), 1,
      anon_sym_LPAREN,
    ACTIONS(16185), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(16187), 1,
      anon_sym_u2983,
    ACTIONS(16189), 1,
      anon_sym_LBRACE,
    STATE(8925), 1,
      sym_bid,
    ACTIONS(14492), 2,
      anon_sym__,
      sym_id,
  [667437] = 8,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16191), 1,
      anon_sym_LPAREN,
    ACTIONS(16193), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(16195), 1,
      anon_sym_u2983,
    ACTIONS(16197), 1,
      anon_sym_LBRACE,
    STATE(8167), 1,
      sym_bid,
    ACTIONS(13664), 2,
      anon_sym__,
      sym_id,
  [667463] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16201), 2,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
    ACTIONS(16199), 5,
      anon_sym_COLON,
      anon_sym_u2983,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [667481] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16203), 1,
      sym_id,
    ACTIONS(16205), 1,
      anon_sym_u2984,
    ACTIONS(16207), 1,
      anon_sym_DOT,
    ACTIONS(16209), 1,
      anon_sym_DOT_DOT,
    STATE(9115), 3,
      sym__field_name,
      sym__maybe_dotted_id,
      aux_sym__maybe_dotted_ids,
  [667505] = 8,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16211), 1,
      anon_sym_LPAREN,
    ACTIONS(16213), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(16215), 1,
      anon_sym_u2983,
    ACTIONS(16217), 1,
      anon_sym_LBRACE,
    STATE(8502), 1,
      sym_bid,
    ACTIONS(13696), 2,
      anon_sym__,
      sym_id,
  [667531] = 8,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16219), 1,
      anon_sym_LPAREN,
    ACTIONS(16221), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(16223), 1,
      anon_sym_u2983,
    ACTIONS(16225), 1,
      anon_sym_LBRACE,
    STATE(7984), 1,
      sym_bid,
    ACTIONS(14328), 2,
      anon_sym__,
      sym_id,
  [667557] = 8,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16229), 1,
      anon_sym_LPAREN,
    ACTIONS(16231), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(16233), 1,
      anon_sym_u2983,
    ACTIONS(16235), 1,
      anon_sym_LBRACE,
    STATE(9021), 1,
      sym_bid,
    ACTIONS(16227), 2,
      anon_sym__,
      sym_id,
  [667583] = 8,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16237), 1,
      anon_sym_LPAREN,
    ACTIONS(16239), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(16241), 1,
      anon_sym_u2983,
    ACTIONS(16243), 1,
      anon_sym_LBRACE,
    STATE(8569), 1,
      sym_bid,
    ACTIONS(13728), 2,
      anon_sym__,
      sym_id,
  [667609] = 2,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(16245), 7,
      anon_sym_public,
      anon_sym_using,
      anon_sym_RPAREN,
      anon_sym_hiding,
      anon_sym_renaming,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [667623] = 8,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16247), 1,
      anon_sym_LPAREN,
    ACTIONS(16249), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(16251), 1,
      anon_sym_u2983,
    ACTIONS(16253), 1,
      anon_sym_LBRACE,
    STATE(7888), 1,
      sym_bid,
    ACTIONS(14280), 2,
      anon_sym__,
      sym_id,
  [667649] = 2,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(16255), 7,
      anon_sym_public,
      anon_sym_using,
      anon_sym_RPAREN,
      anon_sym_hiding,
      anon_sym_renaming,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [667663] = 4,
    STATE(2132), 1,
      sym__ARROW,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(16257), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(14953), 4,
      sym__newline,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
  [667681] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(12593), 3,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DOT_DOT,
      anon_sym_AT,
    ACTIONS(12591), 4,
      anon_sym_u2983,
      anon_sym_LBRACE,
      sym_id,
      anon_sym_DOT,
  [667699] = 8,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16259), 1,
      anon_sym_LPAREN,
    ACTIONS(16261), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(16263), 1,
      anon_sym_u2983,
    ACTIONS(16265), 1,
      anon_sym_LBRACE,
    STATE(8030), 1,
      sym_bid,
    ACTIONS(14150), 2,
      anon_sym__,
      sym_id,
  [667725] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16269), 2,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(16267), 4,
      anon_sym_EQ,
      anon_sym_u2983,
      anon_sym_LBRACE,
      sym_id,
  [667742] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16273), 2,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(16271), 4,
      anon_sym_EQ,
      anon_sym_u2983,
      anon_sym_LBRACE,
      sym_id,
  [667759] = 4,
    STATE(1469), 1,
      sym__ARROW,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(16275), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(14953), 3,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_u2984,
  [667776] = 4,
    STATE(1679), 1,
      sym__ARROW,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(16277), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(14953), 3,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_PIPE_RPAREN,
  [667793] = 7,
    ACTIONS(15788), 1,
      anon_sym_module,
    ACTIONS(15790), 1,
      anon_sym_where,
    ACTIONS(15792), 1,
      sym__newline,
    ACTIONS(16279), 1,
      anon_sym_COLON,
    STATE(9317), 1,
      sym_rhs_decl,
    STATE(9892), 1,
      sym_where,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [667816] = 4,
    STATE(1488), 1,
      sym__ARROW,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(16281), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(14953), 3,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [667833] = 4,
    STATE(1404), 1,
      sym__ARROW,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(16283), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(14953), 3,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE_RBRACE,
  [667850] = 3,
    ACTIONS(16285), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(16287), 5,
      sym__newline,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_in,
  [667865] = 2,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(16289), 6,
      sym__newline,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_in,
  [667878] = 2,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15964), 6,
      sym__newline,
      anon_sym_public,
      anon_sym_using,
      anon_sym_hiding,
      anon_sym_renaming,
      anon_sym_in,
  [667891] = 4,
    STATE(1746), 1,
      sym__ARROW,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(16291), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(14953), 3,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_u2988,
  [667908] = 7,
    ACTIONS(15788), 1,
      anon_sym_module,
    ACTIONS(15790), 1,
      anon_sym_where,
    ACTIONS(15792), 1,
      sym__newline,
    ACTIONS(16293), 1,
      anon_sym_EQ,
    STATE(9317), 1,
      sym_rhs_defn,
    STATE(9892), 1,
      sym_where,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [667931] = 4,
    STATE(2601), 1,
      sym__ARROW,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(16295), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(14953), 3,
      sym__newline,
      anon_sym_EQ,
      anon_sym_SEMI,
  [667948] = 4,
    STATE(2644), 1,
      sym__ARROW,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(16297), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(14953), 3,
      sym__newline,
      anon_sym_EQ,
      anon_sym_where,
  [667965] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16299), 1,
      sym_id,
    ACTIONS(16302), 1,
      sym__dedent,
    STATE(9155), 1,
      aux_sym__type_signature_block_repeat1,
    STATE(12573), 1,
      sym_type_signature,
    STATE(9417), 2,
      sym__field_name,
      aux_sym__field_names,
  [667988] = 4,
    STATE(1564), 1,
      sym__ARROW,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(16304), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(14953), 3,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [668005] = 3,
    ACTIONS(14987), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15510), 5,
      sym__newline,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_in,
  [668020] = 6,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16203), 1,
      sym_id,
    ACTIONS(16207), 1,
      anon_sym_DOT,
    ACTIONS(16209), 1,
      anon_sym_DOT_DOT,
    STATE(9130), 3,
      sym__field_name,
      sym__maybe_dotted_id,
      aux_sym__maybe_dotted_ids,
  [668041] = 6,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16128), 1,
      sym_id,
    ACTIONS(16130), 1,
      anon_sym_DOT,
    ACTIONS(16132), 1,
      anon_sym_DOT_DOT,
    STATE(9117), 3,
      sym__field_name,
      sym__maybe_dotted_id,
      aux_sym__maybe_dotted_ids,
  [668062] = 4,
    STATE(1824), 1,
      sym__ARROW,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(16306), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(14953), 3,
      sym__newline,
      anon_sym_EQ,
      anon_sym_in,
  [668079] = 4,
    STATE(1558), 1,
      sym__ARROW,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(16308), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(14953), 3,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [668096] = 3,
    ACTIONS(15071), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15510), 5,
      sym__newline,
      anon_sym_COLON,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
  [668111] = 4,
    STATE(2057), 1,
      sym__ARROW,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(16310), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(14953), 3,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_SEMI,
  [668128] = 3,
    ACTIONS(15694), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15696), 5,
      sym__newline,
      anon_sym_EQ,
      anon_sym_module,
      anon_sym_where,
      anon_sym_in,
  [668143] = 3,
    ACTIONS(15025), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15510), 5,
      sym__newline,
      anon_sym_COLON,
      anon_sym_module,
      anon_sym_where,
      anon_sym_in,
  [668158] = 2,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(16152), 6,
      sym__newline,
      anon_sym_public,
      anon_sym_using,
      anon_sym_hiding,
      anon_sym_renaming,
      anon_sym_in,
  [668171] = 3,
    ACTIONS(15079), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15510), 5,
      sym__newline,
      anon_sym_COLON,
      anon_sym_with,
      anon_sym_module,
      anon_sym_where,
  [668186] = 2,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(16245), 6,
      sym__newline,
      anon_sym_public,
      anon_sym_using,
      anon_sym_hiding,
      anon_sym_renaming,
      anon_sym_in,
  [668199] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16314), 2,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(16312), 4,
      anon_sym_EQ,
      anon_sym_u2983,
      anon_sym_LBRACE,
      sym_id,
  [668216] = 4,
    STATE(1603), 1,
      sym__ARROW,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(16316), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(14953), 3,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RBRACE_RBRACE,
  [668233] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16318), 1,
      sym_id,
    ACTIONS(16320), 1,
      sym__dedent,
    STATE(9155), 1,
      aux_sym__type_signature_block_repeat1,
    STATE(12573), 1,
      sym_type_signature,
    STATE(9417), 2,
      sym__field_name,
      aux_sym__field_names,
  [668256] = 6,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16322), 1,
      anon_sym_import,
    STATE(7450), 1,
      sym__qid,
    ACTIONS(7709), 2,
      sym_id,
      aux_sym__qid_token1,
    STATE(4247), 2,
      sym_import,
      sym_module_name,
  [668277] = 2,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(16324), 6,
      sym__newline,
      anon_sym_public,
      anon_sym_using,
      anon_sym_hiding,
      anon_sym_renaming,
      anon_sym_in,
  [668290] = 7,
    ACTIONS(15788), 1,
      anon_sym_module,
    ACTIONS(15790), 1,
      anon_sym_where,
    ACTIONS(15946), 1,
      sym__newline,
    ACTIONS(16293), 1,
      anon_sym_EQ,
    STATE(9299), 1,
      sym_rhs_defn,
    STATE(9937), 1,
      sym_where,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [668313] = 7,
    ACTIONS(15788), 1,
      anon_sym_module,
    ACTIONS(15790), 1,
      anon_sym_where,
    ACTIONS(15946), 1,
      sym__newline,
    ACTIONS(16279), 1,
      anon_sym_COLON,
    STATE(9299), 1,
      sym_rhs_decl,
    STATE(9937), 1,
      sym_where,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [668336] = 2,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(13331), 6,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [668349] = 2,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15043), 6,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [668362] = 4,
    STATE(2487), 1,
      sym__ARROW,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(16326), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(14953), 3,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_u2984,
  [668379] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16330), 2,
      anon_sym_LPAREN,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(16328), 4,
      anon_sym_EQ,
      anon_sym_u2983,
      anon_sym_LBRACE,
      sym_id,
  [668396] = 6,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16334), 1,
      anon_sym_in,
    ACTIONS(16336), 1,
      sym__newline,
    ACTIONS(16332), 2,
      anon_sym__,
      sym_id,
    STATE(9183), 2,
      sym_bid,
      aux_sym_infix_repeat1,
  [668417] = 4,
    STATE(2133), 1,
      sym__ARROW,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(16338), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(14953), 3,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RPAREN,
  [668434] = 2,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(16255), 6,
      sym__newline,
      anon_sym_public,
      anon_sym_using,
      anon_sym_hiding,
      anon_sym_renaming,
      anon_sym_in,
  [668447] = 6,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16343), 1,
      anon_sym_in,
    ACTIONS(16345), 1,
      sym__newline,
    ACTIONS(16340), 2,
      anon_sym__,
      sym_id,
    STATE(9183), 2,
      sym_bid,
      aux_sym_infix_repeat1,
  [668468] = 6,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16006), 1,
      sym_id,
    ACTIONS(16010), 1,
      anon_sym_DOT,
    ACTIONS(16012), 1,
      anon_sym_DOT_DOT,
    STATE(9096), 3,
      sym__field_name,
      sym__maybe_dotted_id,
      aux_sym__maybe_dotted_ids,
  [668489] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16347), 1,
      sym_id,
    ACTIONS(16349), 1,
      anon_sym_RBRACE,
    STATE(9546), 1,
      aux_sym__field_assignments_repeat1,
    STATE(10062), 1,
      sym_field_assignment,
    STATE(12627), 1,
      sym__field_assignments,
  [668511] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16347), 1,
      sym_id,
    ACTIONS(16351), 1,
      anon_sym_RBRACE,
    STATE(9546), 1,
      aux_sym__field_assignments_repeat1,
    STATE(10062), 1,
      sym_field_assignment,
    STATE(12778), 1,
      sym__field_assignments,
  [668533] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16347), 1,
      sym_id,
    ACTIONS(16353), 1,
      anon_sym_RBRACE,
    STATE(9546), 1,
      aux_sym__field_assignments_repeat1,
    STATE(10062), 1,
      sym_field_assignment,
    STATE(11944), 1,
      sym__field_assignments,
  [668555] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16347), 1,
      sym_id,
    ACTIONS(16355), 1,
      anon_sym_RBRACE,
    STATE(9546), 1,
      aux_sym__field_assignments_repeat1,
    STATE(10062), 1,
      sym_field_assignment,
    STATE(10565), 1,
      sym__field_assignments,
  [668577] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16347), 1,
      sym_id,
    ACTIONS(16357), 1,
      anon_sym_RBRACE,
    STATE(9546), 1,
      aux_sym__field_assignments_repeat1,
    STATE(10062), 1,
      sym_field_assignment,
    STATE(10981), 1,
      sym__field_assignments,
  [668599] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16347), 1,
      sym_id,
    ACTIONS(16359), 1,
      anon_sym_RBRACE,
    STATE(9546), 1,
      aux_sym__field_assignments_repeat1,
    STATE(10062), 1,
      sym_field_assignment,
    STATE(12721), 1,
      sym__field_assignments,
  [668621] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16347), 1,
      sym_id,
    ACTIONS(16361), 1,
      anon_sym_RBRACE,
    STATE(9546), 1,
      aux_sym__field_assignments_repeat1,
    STATE(10062), 1,
      sym_field_assignment,
    STATE(11959), 1,
      sym__field_assignments,
  [668643] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16347), 1,
      sym_id,
    ACTIONS(16363), 1,
      anon_sym_RBRACE,
    STATE(9546), 1,
      aux_sym__field_assignments_repeat1,
    STATE(10062), 1,
      sym_field_assignment,
    STATE(12423), 1,
      sym__field_assignments,
  [668665] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16347), 1,
      sym_id,
    ACTIONS(16365), 1,
      anon_sym_RBRACE,
    STATE(9546), 1,
      aux_sym__field_assignments_repeat1,
    STATE(10062), 1,
      sym_field_assignment,
    STATE(10535), 1,
      sym__field_assignments,
  [668687] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16347), 1,
      sym_id,
    ACTIONS(16367), 1,
      anon_sym_RBRACE,
    STATE(9546), 1,
      aux_sym__field_assignments_repeat1,
    STATE(10062), 1,
      sym_field_assignment,
    STATE(11750), 1,
      sym__field_assignments,
  [668709] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16347), 1,
      sym_id,
    ACTIONS(16369), 1,
      anon_sym_RBRACE,
    STATE(9546), 1,
      aux_sym__field_assignments_repeat1,
    STATE(10062), 1,
      sym_field_assignment,
    STATE(11821), 1,
      sym__field_assignments,
  [668731] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16347), 1,
      sym_id,
    ACTIONS(16371), 1,
      anon_sym_RBRACE,
    STATE(9546), 1,
      aux_sym__field_assignments_repeat1,
    STATE(10062), 1,
      sym_field_assignment,
    STATE(11414), 1,
      sym__field_assignments,
  [668753] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16347), 1,
      sym_id,
    ACTIONS(16373), 1,
      anon_sym_RBRACE,
    STATE(9546), 1,
      aux_sym__field_assignments_repeat1,
    STATE(10062), 1,
      sym_field_assignment,
    STATE(11749), 1,
      sym__field_assignments,
  [668775] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16347), 1,
      sym_id,
    ACTIONS(16375), 1,
      anon_sym_RBRACE,
    STATE(9546), 1,
      aux_sym__field_assignments_repeat1,
    STATE(10062), 1,
      sym_field_assignment,
    STATE(11382), 1,
      sym__field_assignments,
  [668797] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16347), 1,
      sym_id,
    ACTIONS(16377), 1,
      anon_sym_RBRACE,
    STATE(9546), 1,
      aux_sym__field_assignments_repeat1,
    STATE(10062), 1,
      sym_field_assignment,
    STATE(12808), 1,
      sym__field_assignments,
  [668819] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16347), 1,
      sym_id,
    ACTIONS(16379), 1,
      anon_sym_RBRACE,
    STATE(9546), 1,
      aux_sym__field_assignments_repeat1,
    STATE(10062), 1,
      sym_field_assignment,
    STATE(11020), 1,
      sym__field_assignments,
  [668841] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16347), 1,
      sym_id,
    ACTIONS(16381), 1,
      anon_sym_RBRACE,
    STATE(9546), 1,
      aux_sym__field_assignments_repeat1,
    STATE(10062), 1,
      sym_field_assignment,
    STATE(11976), 1,
      sym__field_assignments,
  [668863] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16347), 1,
      sym_id,
    ACTIONS(16383), 1,
      anon_sym_RBRACE,
    STATE(9546), 1,
      aux_sym__field_assignments_repeat1,
    STATE(10062), 1,
      sym_field_assignment,
    STATE(12382), 1,
      sym__field_assignments,
  [668885] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16347), 1,
      sym_id,
    ACTIONS(16385), 1,
      anon_sym_RBRACE,
    STATE(9546), 1,
      aux_sym__field_assignments_repeat1,
    STATE(10062), 1,
      sym_field_assignment,
    STATE(10524), 1,
      sym__field_assignments,
  [668907] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16347), 1,
      sym_id,
    ACTIONS(16387), 1,
      anon_sym_RBRACE,
    STATE(9546), 1,
      aux_sym__field_assignments_repeat1,
    STATE(10062), 1,
      sym_field_assignment,
    STATE(10585), 1,
      sym__field_assignments,
  [668929] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16347), 1,
      sym_id,
    ACTIONS(16389), 1,
      anon_sym_RBRACE,
    STATE(9546), 1,
      aux_sym__field_assignments_repeat1,
    STATE(10062), 1,
      sym_field_assignment,
    STATE(12736), 1,
      sym__field_assignments,
  [668951] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16347), 1,
      sym_id,
    ACTIONS(16391), 1,
      anon_sym_RBRACE,
    STATE(9546), 1,
      aux_sym__field_assignments_repeat1,
    STATE(10062), 1,
      sym_field_assignment,
    STATE(12409), 1,
      sym__field_assignments,
  [668973] = 4,
    STATE(1737), 1,
      sym__ARROW,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(14953), 2,
      sym__newline,
      anon_sym_EQ,
    ACTIONS(16393), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
  [668989] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16347), 1,
      sym_id,
    ACTIONS(16395), 1,
      anon_sym_RBRACE,
    STATE(9546), 1,
      aux_sym__field_assignments_repeat1,
    STATE(10062), 1,
      sym_field_assignment,
    STATE(11740), 1,
      sym__field_assignments,
  [669011] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16347), 1,
      sym_id,
    ACTIONS(16397), 1,
      anon_sym_RBRACE,
    STATE(9546), 1,
      aux_sym__field_assignments_repeat1,
    STATE(10062), 1,
      sym_field_assignment,
    STATE(11991), 1,
      sym__field_assignments,
  [669033] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16347), 1,
      sym_id,
    ACTIONS(16399), 1,
      anon_sym_RBRACE,
    STATE(9546), 1,
      aux_sym__field_assignments_repeat1,
    STATE(10062), 1,
      sym_field_assignment,
    STATE(11813), 1,
      sym__field_assignments,
  [669055] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16347), 1,
      sym_id,
    ACTIONS(16401), 1,
      anon_sym_RBRACE,
    STATE(9546), 1,
      aux_sym__field_assignments_repeat1,
    STATE(10062), 1,
      sym_field_assignment,
    STATE(12407), 1,
      sym__field_assignments,
  [669077] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16347), 1,
      sym_id,
    ACTIONS(16403), 1,
      anon_sym_RBRACE,
    STATE(9546), 1,
      aux_sym__field_assignments_repeat1,
    STATE(10062), 1,
      sym_field_assignment,
    STATE(11992), 1,
      sym__field_assignments,
  [669099] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16347), 1,
      sym_id,
    ACTIONS(16405), 1,
      anon_sym_RBRACE,
    STATE(9546), 1,
      aux_sym__field_assignments_repeat1,
    STATE(10062), 1,
      sym_field_assignment,
    STATE(12663), 1,
      sym__field_assignments,
  [669121] = 6,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    STATE(4573), 1,
      sym_module_name,
    STATE(7348), 1,
      sym__qid,
    STATE(9006), 1,
      sym_module_application,
    ACTIONS(7679), 2,
      sym_id,
      aux_sym__qid_token1,
  [669141] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16347), 1,
      sym_id,
    ACTIONS(16407), 1,
      anon_sym_RBRACE,
    STATE(9546), 1,
      aux_sym__field_assignments_repeat1,
    STATE(10062), 1,
      sym_field_assignment,
    STATE(11347), 1,
      sym__field_assignments,
  [669163] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16347), 1,
      sym_id,
    ACTIONS(16409), 1,
      anon_sym_RBRACE,
    STATE(9546), 1,
      aux_sym__field_assignments_repeat1,
    STATE(10062), 1,
      sym_field_assignment,
    STATE(11448), 1,
      sym__field_assignments,
  [669185] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16347), 1,
      sym_id,
    ACTIONS(16411), 1,
      anon_sym_RBRACE,
    STATE(9546), 1,
      aux_sym__field_assignments_repeat1,
    STATE(10062), 1,
      sym_field_assignment,
    STATE(12737), 1,
      sym__field_assignments,
  [669207] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16347), 1,
      sym_id,
    ACTIONS(16413), 1,
      anon_sym_RBRACE,
    STATE(9546), 1,
      aux_sym__field_assignments_repeat1,
    STATE(10062), 1,
      sym_field_assignment,
    STATE(11345), 1,
      sym__field_assignments,
  [669229] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16347), 1,
      sym_id,
    ACTIONS(16415), 1,
      anon_sym_RBRACE,
    STATE(9546), 1,
      aux_sym__field_assignments_repeat1,
    STATE(10062), 1,
      sym_field_assignment,
    STATE(12437), 1,
      sym__field_assignments,
  [669251] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16347), 1,
      sym_id,
    ACTIONS(16417), 1,
      anon_sym_RBRACE,
    STATE(9546), 1,
      aux_sym__field_assignments_repeat1,
    STATE(10062), 1,
      sym_field_assignment,
    STATE(11418), 1,
      sym__field_assignments,
  [669273] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16347), 1,
      sym_id,
    ACTIONS(16419), 1,
      anon_sym_RBRACE,
    STATE(9546), 1,
      aux_sym__field_assignments_repeat1,
    STATE(10062), 1,
      sym_field_assignment,
    STATE(10601), 1,
      sym__field_assignments,
  [669295] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16347), 1,
      sym_id,
    ACTIONS(16421), 1,
      anon_sym_RBRACE,
    STATE(9546), 1,
      aux_sym__field_assignments_repeat1,
    STATE(10062), 1,
      sym_field_assignment,
    STATE(10485), 1,
      sym__field_assignments,
  [669317] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16347), 1,
      sym_id,
    ACTIONS(16423), 1,
      anon_sym_RBRACE,
    STATE(9546), 1,
      aux_sym__field_assignments_repeat1,
    STATE(10062), 1,
      sym_field_assignment,
    STATE(11726), 1,
      sym__field_assignments,
  [669339] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16347), 1,
      sym_id,
    ACTIONS(16425), 1,
      anon_sym_RBRACE,
    STATE(9546), 1,
      aux_sym__field_assignments_repeat1,
    STATE(10062), 1,
      sym_field_assignment,
    STATE(12010), 1,
      sym__field_assignments,
  [669361] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16347), 1,
      sym_id,
    ACTIONS(16427), 1,
      anon_sym_RBRACE,
    STATE(9546), 1,
      aux_sym__field_assignments_repeat1,
    STATE(10062), 1,
      sym_field_assignment,
    STATE(10488), 1,
      sym__field_assignments,
  [669383] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16347), 1,
      sym_id,
    ACTIONS(16429), 1,
      anon_sym_RBRACE,
    STATE(9546), 1,
      aux_sym__field_assignments_repeat1,
    STATE(10062), 1,
      sym_field_assignment,
    STATE(12438), 1,
      sym__field_assignments,
  [669405] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16347), 1,
      sym_id,
    ACTIONS(16431), 1,
      anon_sym_RBRACE,
    STATE(9546), 1,
      aux_sym__field_assignments_repeat1,
    STATE(10062), 1,
      sym_field_assignment,
    STATE(11273), 1,
      sym__field_assignments,
  [669427] = 3,
    ACTIONS(14997), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15510), 4,
      sym__newline,
      anon_sym_COLON,
      anon_sym_module,
      anon_sym_where,
  [669441] = 4,
    STATE(1637), 1,
      sym__ARROW,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(14953), 2,
      anon_sym_EQ,
      anon_sym_PIPE_RPAREN,
    ACTIONS(16433), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
  [669457] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16347), 1,
      sym_id,
    ACTIONS(16435), 1,
      anon_sym_RBRACE,
    STATE(9546), 1,
      aux_sym__field_assignments_repeat1,
    STATE(10062), 1,
      sym_field_assignment,
    STATE(12701), 1,
      sym__field_assignments,
  [669479] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16347), 1,
      sym_id,
    ACTIONS(16437), 1,
      anon_sym_RBRACE,
    STATE(9546), 1,
      aux_sym__field_assignments_repeat1,
    STATE(10062), 1,
      sym_field_assignment,
    STATE(11473), 1,
      sym__field_assignments,
  [669501] = 4,
    STATE(1918), 1,
      sym__ARROW,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(14953), 2,
      anon_sym_EQ,
      anon_sym_RBRACE,
    ACTIONS(16439), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
  [669517] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16347), 1,
      sym_id,
    ACTIONS(16441), 1,
      anon_sym_RBRACE,
    STATE(9546), 1,
      aux_sym__field_assignments_repeat1,
    STATE(10062), 1,
      sym_field_assignment,
    STATE(12026), 1,
      sym__field_assignments,
  [669539] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16347), 1,
      sym_id,
    ACTIONS(16443), 1,
      anon_sym_RBRACE,
    STATE(9546), 1,
      aux_sym__field_assignments_repeat1,
    STATE(10062), 1,
      sym_field_assignment,
    STATE(11550), 1,
      sym__field_assignments,
  [669561] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16347), 1,
      sym_id,
    ACTIONS(16445), 1,
      anon_sym_RBRACE,
    STATE(9546), 1,
      aux_sym__field_assignments_repeat1,
    STATE(10062), 1,
      sym_field_assignment,
    STATE(12179), 1,
      sym__field_assignments,
  [669583] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16347), 1,
      sym_id,
    ACTIONS(16447), 1,
      anon_sym_RBRACE,
    STATE(9546), 1,
      aux_sym__field_assignments_repeat1,
    STATE(10062), 1,
      sym_field_assignment,
    STATE(12393), 1,
      sym__field_assignments,
  [669605] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16347), 1,
      sym_id,
    ACTIONS(16449), 1,
      anon_sym_RBRACE,
    STATE(9546), 1,
      aux_sym__field_assignments_repeat1,
    STATE(10062), 1,
      sym_field_assignment,
    STATE(11713), 1,
      sym__field_assignments,
  [669627] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16347), 1,
      sym_id,
    ACTIONS(16451), 1,
      anon_sym_RBRACE,
    STATE(9546), 1,
      aux_sym__field_assignments_repeat1,
    STATE(10062), 1,
      sym_field_assignment,
    STATE(12044), 1,
      sym__field_assignments,
  [669649] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16347), 1,
      sym_id,
    ACTIONS(16453), 1,
      anon_sym_RBRACE,
    STATE(9546), 1,
      aux_sym__field_assignments_repeat1,
    STATE(10062), 1,
      sym_field_assignment,
    STATE(10632), 1,
      sym__field_assignments,
  [669671] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16347), 1,
      sym_id,
    ACTIONS(16455), 1,
      anon_sym_RBRACE,
    STATE(9546), 1,
      aux_sym__field_assignments_repeat1,
    STATE(10062), 1,
      sym_field_assignment,
    STATE(12058), 1,
      sym__field_assignments,
  [669693] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16347), 1,
      sym_id,
    ACTIONS(16457), 1,
      anon_sym_RBRACE,
    STATE(9546), 1,
      aux_sym__field_assignments_repeat1,
    STATE(10062), 1,
      sym_field_assignment,
    STATE(12059), 1,
      sym__field_assignments,
  [669715] = 5,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16336), 1,
      sym__newline,
    ACTIONS(16459), 2,
      anon_sym__,
      sym_id,
    STATE(9398), 2,
      sym_bid,
      aux_sym_infix_repeat1,
  [669733] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16347), 1,
      sym_id,
    ACTIONS(16461), 1,
      anon_sym_RBRACE,
    STATE(9546), 1,
      aux_sym__field_assignments_repeat1,
    STATE(10062), 1,
      sym_field_assignment,
    STATE(11838), 1,
      sym__field_assignments,
  [669755] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16347), 1,
      sym_id,
    ACTIONS(16463), 1,
      anon_sym_RBRACE,
    STATE(9546), 1,
      aux_sym__field_assignments_repeat1,
    STATE(10062), 1,
      sym_field_assignment,
    STATE(12078), 1,
      sym__field_assignments,
  [669777] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16347), 1,
      sym_id,
    ACTIONS(16465), 1,
      anon_sym_RBRACE,
    STATE(9546), 1,
      aux_sym__field_assignments_repeat1,
    STATE(10062), 1,
      sym_field_assignment,
    STATE(11313), 1,
      sym__field_assignments,
  [669799] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16347), 1,
      sym_id,
    ACTIONS(16467), 1,
      anon_sym_RBRACE,
    STATE(9546), 1,
      aux_sym__field_assignments_repeat1,
    STATE(10062), 1,
      sym_field_assignment,
    STATE(12092), 1,
      sym__field_assignments,
  [669821] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16347), 1,
      sym_id,
    ACTIONS(16469), 1,
      anon_sym_RBRACE,
    STATE(9546), 1,
      aux_sym__field_assignments_repeat1,
    STATE(10062), 1,
      sym_field_assignment,
    STATE(12095), 1,
      sym__field_assignments,
  [669843] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16347), 1,
      sym_id,
    ACTIONS(16471), 1,
      anon_sym_RBRACE,
    STATE(9546), 1,
      aux_sym__field_assignments_repeat1,
    STATE(10062), 1,
      sym_field_assignment,
    STATE(10943), 1,
      sym__field_assignments,
  [669865] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16347), 1,
      sym_id,
    ACTIONS(16473), 1,
      anon_sym_RBRACE,
    STATE(9546), 1,
      aux_sym__field_assignments_repeat1,
    STATE(10062), 1,
      sym_field_assignment,
    STATE(10959), 1,
      sym__field_assignments,
  [669887] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16347), 1,
      sym_id,
    ACTIONS(16475), 1,
      anon_sym_RBRACE,
    STATE(9546), 1,
      aux_sym__field_assignments_repeat1,
    STATE(10062), 1,
      sym_field_assignment,
    STATE(11698), 1,
      sym__field_assignments,
  [669909] = 4,
    STATE(2440), 1,
      sym__ARROW,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(14953), 2,
      anon_sym_EQ,
      anon_sym_RPAREN,
    ACTIONS(16477), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
  [669925] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16347), 1,
      sym_id,
    ACTIONS(16479), 1,
      anon_sym_RBRACE,
    STATE(9546), 1,
      aux_sym__field_assignments_repeat1,
    STATE(10062), 1,
      sym_field_assignment,
    STATE(11310), 1,
      sym__field_assignments,
  [669947] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16347), 1,
      sym_id,
    ACTIONS(16481), 1,
      anon_sym_RBRACE,
    STATE(9546), 1,
      aux_sym__field_assignments_repeat1,
    STATE(10062), 1,
      sym_field_assignment,
    STATE(12112), 1,
      sym__field_assignments,
  [669969] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16347), 1,
      sym_id,
    ACTIONS(16483), 1,
      anon_sym_RBRACE,
    STATE(9546), 1,
      aux_sym__field_assignments_repeat1,
    STATE(10062), 1,
      sym_field_assignment,
    STATE(10294), 1,
      sym__field_assignments,
  [669991] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16347), 1,
      sym_id,
    ACTIONS(16485), 1,
      anon_sym_RBRACE,
    STATE(9546), 1,
      aux_sym__field_assignments_repeat1,
    STATE(10062), 1,
      sym_field_assignment,
    STATE(10297), 1,
      sym__field_assignments,
  [670013] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16347), 1,
      sym_id,
    ACTIONS(16487), 1,
      anon_sym_RBRACE,
    STATE(9546), 1,
      aux_sym__field_assignments_repeat1,
    STATE(10062), 1,
      sym_field_assignment,
    STATE(10906), 1,
      sym__field_assignments,
  [670035] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16347), 1,
      sym_id,
    ACTIONS(16489), 1,
      anon_sym_RBRACE,
    STATE(9546), 1,
      aux_sym__field_assignments_repeat1,
    STATE(10062), 1,
      sym_field_assignment,
    STATE(12549), 1,
      sym__field_assignments,
  [670057] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16347), 1,
      sym_id,
    ACTIONS(16491), 1,
      anon_sym_RBRACE,
    STATE(9546), 1,
      aux_sym__field_assignments_repeat1,
    STATE(10062), 1,
      sym_field_assignment,
    STATE(11493), 1,
      sym__field_assignments,
  [670079] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16347), 1,
      sym_id,
    ACTIONS(16493), 1,
      anon_sym_RBRACE,
    STATE(9546), 1,
      aux_sym__field_assignments_repeat1,
    STATE(10062), 1,
      sym_field_assignment,
    STATE(12126), 1,
      sym__field_assignments,
  [670101] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16347), 1,
      sym_id,
    ACTIONS(16495), 1,
      anon_sym_RBRACE,
    STATE(9546), 1,
      aux_sym__field_assignments_repeat1,
    STATE(10062), 1,
      sym_field_assignment,
    STATE(12546), 1,
      sym__field_assignments,
  [670123] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16347), 1,
      sym_id,
    ACTIONS(16497), 1,
      anon_sym_RBRACE,
    STATE(9546), 1,
      aux_sym__field_assignments_repeat1,
    STATE(10062), 1,
      sym_field_assignment,
    STATE(12127), 1,
      sym__field_assignments,
  [670145] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16347), 1,
      sym_id,
    ACTIONS(16499), 1,
      anon_sym_RBRACE,
    STATE(9546), 1,
      aux_sym__field_assignments_repeat1,
    STATE(10062), 1,
      sym_field_assignment,
    STATE(10939), 1,
      sym__field_assignments,
  [670167] = 4,
    STATE(2177), 1,
      sym__ARROW,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(14953), 2,
      anon_sym_EQ,
      anon_sym_u2984,
    ACTIONS(16501), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
  [670183] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16347), 1,
      sym_id,
    ACTIONS(16503), 1,
      anon_sym_RBRACE,
    STATE(9546), 1,
      aux_sym__field_assignments_repeat1,
    STATE(10062), 1,
      sym_field_assignment,
    STATE(11685), 1,
      sym__field_assignments,
  [670205] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16347), 1,
      sym_id,
    ACTIONS(16505), 1,
      anon_sym_RBRACE,
    STATE(9546), 1,
      aux_sym__field_assignments_repeat1,
    STATE(10062), 1,
      sym_field_assignment,
    STATE(11455), 1,
      sym__field_assignments,
  [670227] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16347), 1,
      sym_id,
    ACTIONS(16507), 1,
      anon_sym_RBRACE,
    STATE(9546), 1,
      aux_sym__field_assignments_repeat1,
    STATE(10062), 1,
      sym_field_assignment,
    STATE(12585), 1,
      sym__field_assignments,
  [670249] = 3,
    ACTIONS(15023), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15510), 4,
      sym__newline,
      anon_sym_module,
      anon_sym_where,
      anon_sym_in,
  [670263] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16347), 1,
      sym_id,
    ACTIONS(16509), 1,
      anon_sym_RBRACE,
    STATE(9546), 1,
      aux_sym__field_assignments_repeat1,
    STATE(10062), 1,
      sym_field_assignment,
    STATE(11682), 1,
      sym__field_assignments,
  [670285] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16347), 1,
      sym_id,
    ACTIONS(16511), 1,
      anon_sym_RBRACE,
    STATE(9546), 1,
      aux_sym__field_assignments_repeat1,
    STATE(10062), 1,
      sym_field_assignment,
    STATE(11049), 1,
      sym__field_assignments,
  [670307] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16347), 1,
      sym_id,
    ACTIONS(16513), 1,
      anon_sym_RBRACE,
    STATE(9546), 1,
      aux_sym__field_assignments_repeat1,
    STATE(10062), 1,
      sym_field_assignment,
    STATE(11016), 1,
      sym__field_assignments,
  [670329] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16347), 1,
      sym_id,
    ACTIONS(16515), 1,
      anon_sym_RBRACE,
    STATE(9546), 1,
      aux_sym__field_assignments_repeat1,
    STATE(10062), 1,
      sym_field_assignment,
    STATE(10909), 1,
      sym__field_assignments,
  [670351] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16347), 1,
      sym_id,
    ACTIONS(16517), 1,
      anon_sym_RBRACE,
    STATE(9546), 1,
      aux_sym__field_assignments_repeat1,
    STATE(10062), 1,
      sym_field_assignment,
    STATE(12148), 1,
      sym__field_assignments,
  [670373] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16347), 1,
      sym_id,
    ACTIONS(16519), 1,
      anon_sym_RBRACE,
    STATE(9546), 1,
      aux_sym__field_assignments_repeat1,
    STATE(10062), 1,
      sym_field_assignment,
    STATE(12589), 1,
      sym__field_assignments,
  [670395] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16347), 1,
      sym_id,
    ACTIONS(16521), 1,
      anon_sym_RBRACE,
    STATE(9546), 1,
      aux_sym__field_assignments_repeat1,
    STATE(10062), 1,
      sym_field_assignment,
    STATE(11673), 1,
      sym__field_assignments,
  [670417] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16347), 1,
      sym_id,
    ACTIONS(16523), 1,
      anon_sym_RBRACE,
    STATE(9546), 1,
      aux_sym__field_assignments_repeat1,
    STATE(10062), 1,
      sym_field_assignment,
    STATE(12795), 1,
      sym__field_assignments,
  [670439] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16347), 1,
      sym_id,
    ACTIONS(16525), 1,
      anon_sym_RBRACE,
    STATE(9546), 1,
      aux_sym__field_assignments_repeat1,
    STATE(10062), 1,
      sym_field_assignment,
    STATE(11794), 1,
      sym__field_assignments,
  [670461] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16347), 1,
      sym_id,
    ACTIONS(16527), 1,
      anon_sym_RBRACE,
    STATE(9546), 1,
      aux_sym__field_assignments_repeat1,
    STATE(10062), 1,
      sym_field_assignment,
    STATE(10963), 1,
      sym__field_assignments,
  [670483] = 6,
    ACTIONS(16529), 1,
      sym_id,
    ACTIONS(16531), 1,
      anon_sym_BSLASH,
    ACTIONS(16533), 1,
      anon_sym_u03bb,
    STATE(9587), 1,
      sym__LAMBDA,
    STATE(12343), 1,
      sym__simple_hole,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
  [670503] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16347), 1,
      sym_id,
    ACTIONS(16535), 1,
      anon_sym_RBRACE,
    STATE(9546), 1,
      aux_sym__field_assignments_repeat1,
    STATE(10062), 1,
      sym_field_assignment,
    STATE(11308), 1,
      sym__field_assignments,
  [670525] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16347), 1,
      sym_id,
    ACTIONS(16537), 1,
      anon_sym_RBRACE,
    STATE(9546), 1,
      aux_sym__field_assignments_repeat1,
    STATE(10062), 1,
      sym_field_assignment,
    STATE(10329), 1,
      sym__field_assignments,
  [670547] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16347), 1,
      sym_id,
    ACTIONS(16539), 1,
      anon_sym_RBRACE,
    STATE(9546), 1,
      aux_sym__field_assignments_repeat1,
    STATE(10062), 1,
      sym_field_assignment,
    STATE(11928), 1,
      sym__field_assignments,
  [670569] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16347), 1,
      sym_id,
    ACTIONS(16541), 1,
      anon_sym_RBRACE,
    STATE(9546), 1,
      aux_sym__field_assignments_repeat1,
    STATE(10062), 1,
      sym_field_assignment,
    STATE(10871), 1,
      sym__field_assignments,
  [670591] = 6,
    ACTIONS(16531), 1,
      anon_sym_BSLASH,
    ACTIONS(16533), 1,
      anon_sym_u03bb,
    ACTIONS(16543), 1,
      sym_id,
    STATE(9587), 1,
      sym__LAMBDA,
    STATE(12340), 1,
      sym__simple_hole,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
  [670611] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16347), 1,
      sym_id,
    ACTIONS(16545), 1,
      anon_sym_RBRACE,
    STATE(9546), 1,
      aux_sym__field_assignments_repeat1,
    STATE(10062), 1,
      sym_field_assignment,
    STATE(12164), 1,
      sym__field_assignments,
  [670633] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16347), 1,
      sym_id,
    ACTIONS(16547), 1,
      anon_sym_RBRACE,
    STATE(9546), 1,
      aux_sym__field_assignments_repeat1,
    STATE(10062), 1,
      sym_field_assignment,
    STATE(12530), 1,
      sym__field_assignments,
  [670655] = 6,
    ACTIONS(16549), 1,
      sym_id,
    ACTIONS(16551), 1,
      anon_sym_BSLASH,
    ACTIONS(16553), 1,
      anon_sym_u03bb,
    STATE(9583), 1,
      sym__LAMBDA,
    STATE(12335), 1,
      sym__simple_hole,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
  [670675] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16347), 1,
      sym_id,
    ACTIONS(16555), 1,
      anon_sym_RBRACE,
    STATE(9546), 1,
      aux_sym__field_assignments_repeat1,
    STATE(10062), 1,
      sym_field_assignment,
    STATE(12166), 1,
      sym__field_assignments,
  [670697] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16347), 1,
      sym_id,
    ACTIONS(16557), 1,
      anon_sym_RBRACE,
    STATE(9546), 1,
      aux_sym__field_assignments_repeat1,
    STATE(10062), 1,
      sym_field_assignment,
    STATE(11082), 1,
      sym__field_assignments,
  [670719] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16347), 1,
      sym_id,
    ACTIONS(16559), 1,
      anon_sym_RBRACE,
    STATE(9546), 1,
      aux_sym__field_assignments_repeat1,
    STATE(10062), 1,
      sym_field_assignment,
    STATE(11663), 1,
      sym__field_assignments,
  [670741] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16347), 1,
      sym_id,
    ACTIONS(16561), 1,
      anon_sym_RBRACE,
    STATE(9546), 1,
      aux_sym__field_assignments_repeat1,
    STATE(10062), 1,
      sym_field_assignment,
    STATE(11499), 1,
      sym__field_assignments,
  [670763] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16347), 1,
      sym_id,
    ACTIONS(16563), 1,
      anon_sym_RBRACE,
    STATE(9546), 1,
      aux_sym__field_assignments_repeat1,
    STATE(10062), 1,
      sym_field_assignment,
    STATE(11801), 1,
      sym__field_assignments,
  [670785] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16347), 1,
      sym_id,
    ACTIONS(16565), 1,
      anon_sym_RBRACE,
    STATE(9546), 1,
      aux_sym__field_assignments_repeat1,
    STATE(10062), 1,
      sym_field_assignment,
    STATE(10877), 1,
      sym__field_assignments,
  [670807] = 6,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    STATE(4573), 1,
      sym_module_name,
    STATE(7348), 1,
      sym__qid,
    STATE(9024), 1,
      sym_module_application,
    ACTIONS(7679), 2,
      sym_id,
      aux_sym__qid_token1,
  [670827] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16347), 1,
      sym_id,
    ACTIONS(16567), 1,
      anon_sym_RBRACE,
    STATE(9546), 1,
      aux_sym__field_assignments_repeat1,
    STATE(10062), 1,
      sym_field_assignment,
    STATE(11760), 1,
      sym__field_assignments,
  [670849] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16347), 1,
      sym_id,
    ACTIONS(16569), 1,
      anon_sym_RBRACE,
    STATE(9546), 1,
      aux_sym__field_assignments_repeat1,
    STATE(10062), 1,
      sym_field_assignment,
    STATE(12786), 1,
      sym__field_assignments,
  [670871] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16347), 1,
      sym_id,
    ACTIONS(16571), 1,
      anon_sym_RBRACE,
    STATE(9546), 1,
      aux_sym__field_assignments_repeat1,
    STATE(10062), 1,
      sym_field_assignment,
    STATE(10836), 1,
      sym__field_assignments,
  [670893] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16347), 1,
      sym_id,
    ACTIONS(16573), 1,
      anon_sym_RBRACE,
    STATE(9546), 1,
      aux_sym__field_assignments_repeat1,
    STATE(10062), 1,
      sym_field_assignment,
    STATE(10346), 1,
      sym__field_assignments,
  [670915] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16347), 1,
      sym_id,
    ACTIONS(16575), 1,
      anon_sym_RBRACE,
    STATE(9546), 1,
      aux_sym__field_assignments_repeat1,
    STATE(10062), 1,
      sym_field_assignment,
    STATE(11051), 1,
      sym__field_assignments,
  [670937] = 5,
    ACTIONS(15788), 1,
      anon_sym_module,
    ACTIONS(15790), 1,
      anon_sym_where,
    STATE(9892), 1,
      sym_where,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15792), 2,
      sym__newline,
      anon_sym_in,
  [670955] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16347), 1,
      sym_id,
    ACTIONS(16577), 1,
      anon_sym_RBRACE,
    STATE(9546), 1,
      aux_sym__field_assignments_repeat1,
    STATE(10062), 1,
      sym_field_assignment,
    STATE(11824), 1,
      sym__field_assignments,
  [670977] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16347), 1,
      sym_id,
    ACTIONS(16579), 1,
      anon_sym_RBRACE,
    STATE(9546), 1,
      aux_sym__field_assignments_repeat1,
    STATE(10062), 1,
      sym_field_assignment,
    STATE(11787), 1,
      sym__field_assignments,
  [670999] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16347), 1,
      sym_id,
    ACTIONS(16581), 1,
      anon_sym_RBRACE,
    STATE(9546), 1,
      aux_sym__field_assignments_repeat1,
    STATE(10062), 1,
      sym_field_assignment,
    STATE(12609), 1,
      sym__field_assignments,
  [671021] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16347), 1,
      sym_id,
    ACTIONS(16583), 1,
      anon_sym_RBRACE,
    STATE(9546), 1,
      aux_sym__field_assignments_repeat1,
    STATE(10062), 1,
      sym_field_assignment,
    STATE(12216), 1,
      sym__field_assignments,
  [671043] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16347), 1,
      sym_id,
    ACTIONS(16585), 1,
      anon_sym_RBRACE,
    STATE(9546), 1,
      aux_sym__field_assignments_repeat1,
    STATE(10062), 1,
      sym_field_assignment,
    STATE(11650), 1,
      sym__field_assignments,
  [671065] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16347), 1,
      sym_id,
    ACTIONS(16587), 1,
      anon_sym_RBRACE,
    STATE(9546), 1,
      aux_sym__field_assignments_repeat1,
    STATE(10062), 1,
      sym_field_assignment,
    STATE(10853), 1,
      sym__field_assignments,
  [671087] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16347), 1,
      sym_id,
    ACTIONS(16589), 1,
      anon_sym_RBRACE,
    STATE(9546), 1,
      aux_sym__field_assignments_repeat1,
    STATE(10062), 1,
      sym_field_assignment,
    STATE(11098), 1,
      sym__field_assignments,
  [671109] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16347), 1,
      sym_id,
    ACTIONS(16591), 1,
      anon_sym_RBRACE,
    STATE(9546), 1,
      aux_sym__field_assignments_repeat1,
    STATE(10062), 1,
      sym_field_assignment,
    STATE(12218), 1,
      sym__field_assignments,
  [671131] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16347), 1,
      sym_id,
    ACTIONS(16593), 1,
      anon_sym_RBRACE,
    STATE(9546), 1,
      aux_sym__field_assignments_repeat1,
    STATE(10062), 1,
      sym_field_assignment,
    STATE(12569), 1,
      sym__field_assignments,
  [671153] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16347), 1,
      sym_id,
    ACTIONS(16595), 1,
      anon_sym_RBRACE,
    STATE(9546), 1,
      aux_sym__field_assignments_repeat1,
    STATE(10062), 1,
      sym_field_assignment,
    STATE(10795), 1,
      sym__field_assignments,
  [671175] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16347), 1,
      sym_id,
    ACTIONS(16597), 1,
      anon_sym_RBRACE,
    STATE(9546), 1,
      aux_sym__field_assignments_repeat1,
    STATE(10062), 1,
      sym_field_assignment,
    STATE(10826), 1,
      sym__field_assignments,
  [671197] = 6,
    ACTIONS(16551), 1,
      anon_sym_BSLASH,
    ACTIONS(16553), 1,
      anon_sym_u03bb,
    ACTIONS(16599), 1,
      sym_id,
    STATE(9583), 1,
      sym__LAMBDA,
    STATE(12168), 1,
      sym__simple_hole,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
  [671217] = 6,
    ACTIONS(16531), 1,
      anon_sym_BSLASH,
    ACTIONS(16533), 1,
      anon_sym_u03bb,
    ACTIONS(16601), 1,
      sym_id,
    STATE(9587), 1,
      sym__LAMBDA,
    STATE(12170), 1,
      sym__simple_hole,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
  [671237] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16347), 1,
      sym_id,
    ACTIONS(16603), 1,
      anon_sym_RBRACE,
    STATE(9546), 1,
      aux_sym__field_assignments_repeat1,
    STATE(10062), 1,
      sym_field_assignment,
    STATE(11124), 1,
      sym__field_assignments,
  [671259] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16347), 1,
      sym_id,
    ACTIONS(16605), 1,
      anon_sym_RBRACE,
    STATE(9546), 1,
      aux_sym__field_assignments_repeat1,
    STATE(10062), 1,
      sym_field_assignment,
    STATE(12625), 1,
      sym__field_assignments,
  [671281] = 6,
    ACTIONS(16531), 1,
      anon_sym_BSLASH,
    ACTIONS(16533), 1,
      anon_sym_u03bb,
    ACTIONS(16607), 1,
      sym_id,
    STATE(9587), 1,
      sym__LAMBDA,
    STATE(12172), 1,
      sym__simple_hole,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
  [671301] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16347), 1,
      sym_id,
    ACTIONS(16609), 1,
      anon_sym_RBRACE,
    STATE(9546), 1,
      aux_sym__field_assignments_repeat1,
    STATE(10062), 1,
      sym_field_assignment,
    STATE(11381), 1,
      sym__field_assignments,
  [671323] = 5,
    ACTIONS(15788), 1,
      anon_sym_module,
    ACTIONS(15790), 1,
      anon_sym_where,
    STATE(10115), 1,
      sym_where,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(16611), 2,
      sym__newline,
      anon_sym_in,
  [671341] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16347), 1,
      sym_id,
    ACTIONS(16613), 1,
      anon_sym_RBRACE,
    STATE(9546), 1,
      aux_sym__field_assignments_repeat1,
    STATE(10062), 1,
      sym_field_assignment,
    STATE(12240), 1,
      sym__field_assignments,
  [671363] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16347), 1,
      sym_id,
    ACTIONS(16615), 1,
      anon_sym_RBRACE,
    STATE(9546), 1,
      aux_sym__field_assignments_repeat1,
    STATE(10062), 1,
      sym_field_assignment,
    STATE(11637), 1,
      sym__field_assignments,
  [671385] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16347), 1,
      sym_id,
    ACTIONS(16617), 1,
      anon_sym_RBRACE,
    STATE(9546), 1,
      aux_sym__field_assignments_repeat1,
    STATE(10062), 1,
      sym_field_assignment,
    STATE(11128), 1,
      sym__field_assignments,
  [671407] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16347), 1,
      sym_id,
    ACTIONS(16619), 1,
      anon_sym_RBRACE,
    STATE(9546), 1,
      aux_sym__field_assignments_repeat1,
    STATE(10062), 1,
      sym_field_assignment,
    STATE(12510), 1,
      sym__field_assignments,
  [671429] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16347), 1,
      sym_id,
    ACTIONS(16621), 1,
      anon_sym_RBRACE,
    STATE(9546), 1,
      aux_sym__field_assignments_repeat1,
    STATE(10062), 1,
      sym_field_assignment,
    STATE(11280), 1,
      sym__field_assignments,
  [671451] = 6,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    STATE(4573), 1,
      sym_module_name,
    STATE(7348), 1,
      sym__qid,
    STATE(9020), 1,
      sym_module_application,
    ACTIONS(7679), 2,
      sym_id,
      aux_sym__qid_token1,
  [671471] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16347), 1,
      sym_id,
    ACTIONS(16623), 1,
      anon_sym_RBRACE,
    STATE(9546), 1,
      aux_sym__field_assignments_repeat1,
    STATE(10062), 1,
      sym_field_assignment,
    STATE(10444), 1,
      sym__field_assignments,
  [671493] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16347), 1,
      sym_id,
    ACTIONS(16625), 1,
      anon_sym_RBRACE,
    STATE(9546), 1,
      aux_sym__field_assignments_repeat1,
    STATE(10062), 1,
      sym_field_assignment,
    STATE(11092), 1,
      sym__field_assignments,
  [671515] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16347), 1,
      sym_id,
    ACTIONS(16627), 1,
      anon_sym_RBRACE,
    STATE(9546), 1,
      aux_sym__field_assignments_repeat1,
    STATE(10062), 1,
      sym_field_assignment,
    STATE(10367), 1,
      sym__field_assignments,
  [671537] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16347), 1,
      sym_id,
    ACTIONS(16629), 1,
      anon_sym_RBRACE,
    STATE(9546), 1,
      aux_sym__field_assignments_repeat1,
    STATE(10062), 1,
      sym_field_assignment,
    STATE(10799), 1,
      sym__field_assignments,
  [671559] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16347), 1,
      sym_id,
    ACTIONS(16631), 1,
      anon_sym_RBRACE,
    STATE(9546), 1,
      aux_sym__field_assignments_repeat1,
    STATE(10062), 1,
      sym_field_assignment,
    STATE(12267), 1,
      sym__field_assignments,
  [671581] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16347), 1,
      sym_id,
    ACTIONS(16633), 1,
      anon_sym_RBRACE,
    STATE(9546), 1,
      aux_sym__field_assignments_repeat1,
    STATE(10062), 1,
      sym_field_assignment,
    STATE(11914), 1,
      sym__field_assignments,
  [671603] = 4,
    STATE(1660), 1,
      sym__ARROW,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(14953), 2,
      anon_sym_EQ,
      anon_sym_where,
    ACTIONS(16635), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
  [671619] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16347), 1,
      sym_id,
    ACTIONS(16637), 1,
      anon_sym_RBRACE,
    STATE(9546), 1,
      aux_sym__field_assignments_repeat1,
    STATE(10062), 1,
      sym_field_assignment,
    STATE(12270), 1,
      sym__field_assignments,
  [671641] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16347), 1,
      sym_id,
    ACTIONS(16639), 1,
      anon_sym_RBRACE,
    STATE(9546), 1,
      aux_sym__field_assignments_repeat1,
    STATE(10062), 1,
      sym_field_assignment,
    STATE(11924), 1,
      sym__field_assignments,
  [671663] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16347), 1,
      sym_id,
    ACTIONS(16641), 1,
      anon_sym_RBRACE,
    STATE(9546), 1,
      aux_sym__field_assignments_repeat1,
    STATE(10062), 1,
      sym_field_assignment,
    STATE(10236), 1,
      sym__field_assignments,
  [671685] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16347), 1,
      sym_id,
    ACTIONS(16643), 1,
      anon_sym_RBRACE,
    STATE(9546), 1,
      aux_sym__field_assignments_repeat1,
    STATE(10062), 1,
      sym_field_assignment,
    STATE(11623), 1,
      sym__field_assignments,
  [671707] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16347), 1,
      sym_id,
    ACTIONS(16645), 1,
      anon_sym_RBRACE,
    STATE(9546), 1,
      aux_sym__field_assignments_repeat1,
    STATE(10062), 1,
      sym_field_assignment,
    STATE(10757), 1,
      sym__field_assignments,
  [671729] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16347), 1,
      sym_id,
    ACTIONS(16647), 1,
      anon_sym_RBRACE,
    STATE(9546), 1,
      aux_sym__field_assignments_repeat1,
    STATE(10062), 1,
      sym_field_assignment,
    STATE(12755), 1,
      sym__field_assignments,
  [671751] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16347), 1,
      sym_id,
    ACTIONS(16649), 1,
      anon_sym_RBRACE,
    STATE(9546), 1,
      aux_sym__field_assignments_repeat1,
    STATE(10062), 1,
      sym_field_assignment,
    STATE(10774), 1,
      sym__field_assignments,
  [671773] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16347), 1,
      sym_id,
    ACTIONS(16651), 1,
      anon_sym_RBRACE,
    STATE(9546), 1,
      aux_sym__field_assignments_repeat1,
    STATE(10062), 1,
      sym_field_assignment,
    STATE(12699), 1,
      sym__field_assignments,
  [671795] = 6,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16318), 1,
      sym_id,
    STATE(9171), 1,
      aux_sym__type_signature_block_repeat1,
    STATE(12573), 1,
      sym_type_signature,
    STATE(9417), 2,
      sym__field_name,
      aux_sym__field_names,
  [671815] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13305), 1,
      sym_id,
    ACTIONS(16653), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(16655), 1,
      anon_sym_u2983,
    ACTIONS(16657), 1,
      anon_sym_LBRACE,
    STATE(9129), 1,
      sym__field_name,
  [671837] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16347), 1,
      sym_id,
    ACTIONS(16659), 1,
      anon_sym_RBRACE,
    STATE(9546), 1,
      aux_sym__field_assignments_repeat1,
    STATE(10062), 1,
      sym_field_assignment,
    STATE(11521), 1,
      sym__field_assignments,
  [671859] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16347), 1,
      sym_id,
    ACTIONS(16661), 1,
      anon_sym_RBRACE,
    STATE(9546), 1,
      aux_sym__field_assignments_repeat1,
    STATE(10062), 1,
      sym_field_assignment,
    STATE(12457), 1,
      sym__field_assignments,
  [671881] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16347), 1,
      sym_id,
    ACTIONS(16663), 1,
      anon_sym_RBRACE,
    STATE(9546), 1,
      aux_sym__field_assignments_repeat1,
    STATE(10062), 1,
      sym_field_assignment,
    STATE(11774), 1,
      sym__field_assignments,
  [671903] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16347), 1,
      sym_id,
    ACTIONS(16665), 1,
      anon_sym_RBRACE,
    STATE(9546), 1,
      aux_sym__field_assignments_repeat1,
    STATE(10062), 1,
      sym_field_assignment,
    STATE(12290), 1,
      sym__field_assignments,
  [671925] = 6,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    STATE(4258), 1,
      sym_module_name,
    STATE(7258), 1,
      sym__qid,
    STATE(9020), 1,
      sym_module_application,
    ACTIONS(6894), 2,
      sym_id,
      aux_sym__qid_token1,
  [671945] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16347), 1,
      sym_id,
    ACTIONS(16667), 1,
      anon_sym_RBRACE,
    STATE(9546), 1,
      aux_sym__field_assignments_repeat1,
    STATE(10062), 1,
      sym_field_assignment,
    STATE(10448), 1,
      sym__field_assignments,
  [671967] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16347), 1,
      sym_id,
    ACTIONS(16669), 1,
      anon_sym_RBRACE,
    STATE(9546), 1,
      aux_sym__field_assignments_repeat1,
    STATE(10062), 1,
      sym_field_assignment,
    STATE(12304), 1,
      sym__field_assignments,
  [671989] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16347), 1,
      sym_id,
    ACTIONS(16671), 1,
      anon_sym_RBRACE,
    STATE(9546), 1,
      aux_sym__field_assignments_repeat1,
    STATE(10062), 1,
      sym_field_assignment,
    STATE(11153), 1,
      sym__field_assignments,
  [672011] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16347), 1,
      sym_id,
    ACTIONS(16673), 1,
      anon_sym_RBRACE,
    STATE(9546), 1,
      aux_sym__field_assignments_repeat1,
    STATE(10062), 1,
      sym_field_assignment,
    STATE(11613), 1,
      sym__field_assignments,
  [672033] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16347), 1,
      sym_id,
    ACTIONS(16675), 1,
      anon_sym_RBRACE,
    STATE(9546), 1,
      aux_sym__field_assignments_repeat1,
    STATE(10062), 1,
      sym_field_assignment,
    STATE(12198), 1,
      sym__field_assignments,
  [672055] = 3,
    ACTIONS(15045), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15510), 4,
      sym__newline,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_in,
  [672069] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16347), 1,
      sym_id,
    ACTIONS(16677), 1,
      anon_sym_RBRACE,
    STATE(9546), 1,
      aux_sym__field_assignments_repeat1,
    STATE(10062), 1,
      sym_field_assignment,
    STATE(10643), 1,
      sym__field_assignments,
  [672091] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16347), 1,
      sym_id,
    ACTIONS(16679), 1,
      anon_sym_RBRACE,
    STATE(9546), 1,
      aux_sym__field_assignments_repeat1,
    STATE(10062), 1,
      sym_field_assignment,
    STATE(12816), 1,
      sym__field_assignments,
  [672113] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16347), 1,
      sym_id,
    ACTIONS(16681), 1,
      anon_sym_RBRACE,
    STATE(9546), 1,
      aux_sym__field_assignments_repeat1,
    STATE(10062), 1,
      sym_field_assignment,
    STATE(11610), 1,
      sym__field_assignments,
  [672135] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16347), 1,
      sym_id,
    ACTIONS(16683), 1,
      anon_sym_RBRACE,
    STATE(9546), 1,
      aux_sym__field_assignments_repeat1,
    STATE(10062), 1,
      sym_field_assignment,
    STATE(10641), 1,
      sym__field_assignments,
  [672157] = 4,
    STATE(1517), 1,
      sym__ARROW,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(14953), 2,
      anon_sym_EQ,
      anon_sym_u2988,
    ACTIONS(16685), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
  [672173] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16347), 1,
      sym_id,
    ACTIONS(16687), 1,
      anon_sym_RBRACE,
    STATE(9546), 1,
      aux_sym__field_assignments_repeat1,
    STATE(10062), 1,
      sym_field_assignment,
    STATE(11132), 1,
      sym__field_assignments,
  [672195] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16347), 1,
      sym_id,
    ACTIONS(16689), 1,
      anon_sym_RBRACE,
    STATE(9546), 1,
      aux_sym__field_assignments_repeat1,
    STATE(10062), 1,
      sym_field_assignment,
    STATE(10719), 1,
      sym__field_assignments,
  [672217] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16347), 1,
      sym_id,
    ACTIONS(16691), 1,
      anon_sym_RBRACE,
    STATE(9546), 1,
      aux_sym__field_assignments_repeat1,
    STATE(10062), 1,
      sym_field_assignment,
    STATE(10752), 1,
      sym__field_assignments,
  [672239] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16347), 1,
      sym_id,
    ACTIONS(16693), 1,
      anon_sym_RBRACE,
    STATE(9546), 1,
      aux_sym__field_assignments_repeat1,
    STATE(10062), 1,
      sym_field_assignment,
    STATE(12326), 1,
      sym__field_assignments,
  [672261] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16347), 1,
      sym_id,
    ACTIONS(16695), 1,
      anon_sym_RBRACE,
    STATE(9546), 1,
      aux_sym__field_assignments_repeat1,
    STATE(10062), 1,
      sym_field_assignment,
    STATE(10401), 1,
      sym__field_assignments,
  [672283] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16347), 1,
      sym_id,
    ACTIONS(16697), 1,
      anon_sym_RBRACE,
    STATE(9546), 1,
      aux_sym__field_assignments_repeat1,
    STATE(10062), 1,
      sym_field_assignment,
    STATE(10985), 1,
      sym__field_assignments,
  [672305] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16347), 1,
      sym_id,
    ACTIONS(16699), 1,
      anon_sym_RBRACE,
    STATE(9546), 1,
      aux_sym__field_assignments_repeat1,
    STATE(10062), 1,
      sym_field_assignment,
    STATE(12376), 1,
      sym__field_assignments,
  [672327] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16347), 1,
      sym_id,
    ACTIONS(16701), 1,
      anon_sym_RBRACE,
    STATE(9546), 1,
      aux_sym__field_assignments_repeat1,
    STATE(10062), 1,
      sym_field_assignment,
    STATE(11600), 1,
      sym__field_assignments,
  [672349] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16347), 1,
      sym_id,
    ACTIONS(16703), 1,
      anon_sym_RBRACE,
    STATE(9546), 1,
      aux_sym__field_assignments_repeat1,
    STATE(10062), 1,
      sym_field_assignment,
    STATE(12649), 1,
      sym__field_assignments,
  [672371] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16347), 1,
      sym_id,
    ACTIONS(16705), 1,
      anon_sym_RBRACE,
    STATE(9546), 1,
      aux_sym__field_assignments_repeat1,
    STATE(10062), 1,
      sym_field_assignment,
    STATE(12493), 1,
      sym__field_assignments,
  [672393] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16347), 1,
      sym_id,
    ACTIONS(16707), 1,
      anon_sym_RBRACE,
    STATE(9546), 1,
      aux_sym__field_assignments_repeat1,
    STATE(10062), 1,
      sym_field_assignment,
    STATE(12511), 1,
      sym__field_assignments,
  [672415] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16347), 1,
      sym_id,
    ACTIONS(16709), 1,
      anon_sym_RBRACE,
    STATE(9546), 1,
      aux_sym__field_assignments_repeat1,
    STATE(10062), 1,
      sym_field_assignment,
    STATE(11187), 1,
      sym__field_assignments,
  [672437] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16347), 1,
      sym_id,
    ACTIONS(16711), 1,
      anon_sym_RBRACE,
    STATE(9546), 1,
      aux_sym__field_assignments_repeat1,
    STATE(10062), 1,
      sym_field_assignment,
    STATE(10409), 1,
      sym__field_assignments,
  [672459] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16347), 1,
      sym_id,
    ACTIONS(16713), 1,
      anon_sym_RBRACE,
    STATE(9546), 1,
      aux_sym__field_assignments_repeat1,
    STATE(10062), 1,
      sym_field_assignment,
    STATE(12342), 1,
      sym__field_assignments,
  [672481] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16347), 1,
      sym_id,
    ACTIONS(16715), 1,
      anon_sym_RBRACE,
    STATE(9546), 1,
      aux_sym__field_assignments_repeat1,
    STATE(10062), 1,
      sym_field_assignment,
    STATE(11247), 1,
      sym__field_assignments,
  [672503] = 3,
    ACTIONS(15077), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15510), 4,
      sym__newline,
      anon_sym_module,
      anon_sym_where,
      anon_sym_SEMI,
  [672517] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16347), 1,
      sym_id,
    ACTIONS(16717), 1,
      anon_sym_RBRACE,
    STATE(9546), 1,
      aux_sym__field_assignments_repeat1,
    STATE(10062), 1,
      sym_field_assignment,
    STATE(12345), 1,
      sym__field_assignments,
  [672539] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16347), 1,
      sym_id,
    ACTIONS(16719), 1,
      anon_sym_RBRACE,
    STATE(9546), 1,
      aux_sym__field_assignments_repeat1,
    STATE(10062), 1,
      sym_field_assignment,
    STATE(12685), 1,
      sym__field_assignments,
  [672561] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16347), 1,
      sym_id,
    ACTIONS(16721), 1,
      anon_sym_RBRACE,
    STATE(9546), 1,
      aux_sym__field_assignments_repeat1,
    STATE(10062), 1,
      sym_field_assignment,
    STATE(11878), 1,
      sym__field_assignments,
  [672583] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16347), 1,
      sym_id,
    ACTIONS(16723), 1,
      anon_sym_RBRACE,
    STATE(9546), 1,
      aux_sym__field_assignments_repeat1,
    STATE(10062), 1,
      sym_field_assignment,
    STATE(11168), 1,
      sym__field_assignments,
  [672605] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16347), 1,
      sym_id,
    ACTIONS(16725), 1,
      anon_sym_RBRACE,
    STATE(9546), 1,
      aux_sym__field_assignments_repeat1,
    STATE(10062), 1,
      sym_field_assignment,
    STATE(10724), 1,
      sym__field_assignments,
  [672627] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16347), 1,
      sym_id,
    ACTIONS(16727), 1,
      anon_sym_RBRACE,
    STATE(9546), 1,
      aux_sym__field_assignments_repeat1,
    STATE(10062), 1,
      sym_field_assignment,
    STATE(11855), 1,
      sym__field_assignments,
  [672649] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16347), 1,
      sym_id,
    ACTIONS(16729), 1,
      anon_sym_RBRACE,
    STATE(9546), 1,
      aux_sym__field_assignments_repeat1,
    STATE(10062), 1,
      sym_field_assignment,
    STATE(11588), 1,
      sym__field_assignments,
  [672671] = 4,
    STATE(1476), 1,
      sym__ARROW,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(14953), 2,
      anon_sym_EQ,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(16731), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
  [672687] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16347), 1,
      sym_id,
    ACTIONS(16733), 1,
      anon_sym_RBRACE,
    STATE(9546), 1,
      aux_sym__field_assignments_repeat1,
    STATE(10062), 1,
      sym_field_assignment,
    STATE(10680), 1,
      sym__field_assignments,
  [672709] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16347), 1,
      sym_id,
    ACTIONS(16735), 1,
      anon_sym_RBRACE,
    STATE(9546), 1,
      aux_sym__field_assignments_repeat1,
    STATE(10062), 1,
      sym_field_assignment,
    STATE(11239), 1,
      sym__field_assignments,
  [672731] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16347), 1,
      sym_id,
    ACTIONS(16737), 1,
      anon_sym_RBRACE,
    STATE(9546), 1,
      aux_sym__field_assignments_repeat1,
    STATE(10062), 1,
      sym_field_assignment,
    STATE(12665), 1,
      sym__field_assignments,
  [672753] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16347), 1,
      sym_id,
    ACTIONS(16739), 1,
      anon_sym_RBRACE,
    STATE(9546), 1,
      aux_sym__field_assignments_repeat1,
    STATE(10062), 1,
      sym_field_assignment,
    STATE(11213), 1,
      sym__field_assignments,
  [672775] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16741), 1,
      sym_id,
    ACTIONS(16743), 1,
      anon_sym_module,
    ACTIONS(16745), 1,
      anon_sym_RPAREN,
    STATE(9619), 1,
      sym__import_name,
    STATE(11533), 1,
      sym__comma_import_names,
  [672797] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16347), 1,
      sym_id,
    ACTIONS(16747), 1,
      anon_sym_RBRACE,
    STATE(9546), 1,
      aux_sym__field_assignments_repeat1,
    STATE(10062), 1,
      sym_field_assignment,
    STATE(11549), 1,
      sym__field_assignments,
  [672819] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16347), 1,
      sym_id,
    ACTIONS(16749), 1,
      anon_sym_RBRACE,
    STATE(9546), 1,
      aux_sym__field_assignments_repeat1,
    STATE(10062), 1,
      sym_field_assignment,
    STATE(12365), 1,
      sym__field_assignments,
  [672841] = 6,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    STATE(4258), 1,
      sym_module_name,
    STATE(7258), 1,
      sym__qid,
    STATE(9011), 1,
      sym_module_application,
    ACTIONS(6894), 2,
      sym_id,
      aux_sym__qid_token1,
  [672861] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16347), 1,
      sym_id,
    ACTIONS(16751), 1,
      anon_sym_RBRACE,
    STATE(9546), 1,
      aux_sym__field_assignments_repeat1,
    STATE(10062), 1,
      sym_field_assignment,
    STATE(11492), 1,
      sym__field_assignments,
  [672883] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16347), 1,
      sym_id,
    ACTIONS(16753), 1,
      anon_sym_RBRACE,
    STATE(9546), 1,
      aux_sym__field_assignments_repeat1,
    STATE(10062), 1,
      sym_field_assignment,
    STATE(12474), 1,
      sym__field_assignments,
  [672905] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16741), 1,
      sym_id,
    ACTIONS(16743), 1,
      anon_sym_module,
    ACTIONS(16755), 1,
      anon_sym_RPAREN,
    STATE(9619), 1,
      sym__import_name,
    STATE(12246), 1,
      sym__comma_import_names,
  [672927] = 6,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    STATE(4573), 1,
      sym_module_name,
    STATE(7348), 1,
      sym__qid,
    STATE(9011), 1,
      sym_module_application,
    ACTIONS(7679), 2,
      sym_id,
      aux_sym__qid_token1,
  [672947] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16347), 1,
      sym_id,
    ACTIONS(16757), 1,
      anon_sym_RBRACE,
    STATE(9546), 1,
      aux_sym__field_assignments_repeat1,
    STATE(10062), 1,
      sym_field_assignment,
    STATE(12473), 1,
      sym__field_assignments,
  [672969] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16347), 1,
      sym_id,
    ACTIONS(16759), 1,
      anon_sym_RBRACE,
    STATE(9546), 1,
      aux_sym__field_assignments_repeat1,
    STATE(10062), 1,
      sym_field_assignment,
    STATE(11567), 1,
      sym__field_assignments,
  [672991] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16347), 1,
      sym_id,
    ACTIONS(16761), 1,
      anon_sym_RBRACE,
    STATE(9546), 1,
      aux_sym__field_assignments_repeat1,
    STATE(10062), 1,
      sym_field_assignment,
    STATE(10257), 1,
      sym__field_assignments,
  [673013] = 6,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    STATE(4258), 1,
      sym_module_name,
    STATE(7258), 1,
      sym__qid,
    STATE(9024), 1,
      sym_module_application,
    ACTIONS(6894), 2,
      sym_id,
      aux_sym__qid_token1,
  [673033] = 6,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    STATE(4258), 1,
      sym_module_name,
    STATE(7258), 1,
      sym__qid,
    STATE(9006), 1,
      sym_module_application,
    ACTIONS(6894), 2,
      sym_id,
      aux_sym__qid_token1,
  [673053] = 5,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16345), 1,
      sym__newline,
    ACTIONS(16763), 2,
      anon_sym__,
      sym_id,
    STATE(9398), 2,
      sym_bid,
      aux_sym_infix_repeat1,
  [673071] = 3,
    ACTIONS(6324), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6326), 4,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2984,
  [673085] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16347), 1,
      sym_id,
    ACTIONS(16766), 1,
      anon_sym_RBRACE,
    STATE(9546), 1,
      aux_sym__field_assignments_repeat1,
    STATE(10062), 1,
      sym_field_assignment,
    STATE(11202), 1,
      sym__field_assignments,
  [673107] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16347), 1,
      sym_id,
    ACTIONS(16768), 1,
      anon_sym_RBRACE,
    STATE(9546), 1,
      aux_sym__field_assignments_repeat1,
    STATE(10062), 1,
      sym_field_assignment,
    STATE(12375), 1,
      sym__field_assignments,
  [673129] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16347), 1,
      sym_id,
    ACTIONS(16770), 1,
      anon_sym_RBRACE,
    STATE(9546), 1,
      aux_sym__field_assignments_repeat1,
    STATE(10062), 1,
      sym_field_assignment,
    STATE(12767), 1,
      sym__field_assignments,
  [673151] = 7,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16347), 1,
      sym_id,
    ACTIONS(16772), 1,
      anon_sym_RBRACE,
    STATE(9546), 1,
      aux_sym__field_assignments_repeat1,
    STATE(10062), 1,
      sym_field_assignment,
    STATE(10684), 1,
      sym__field_assignments,
  [673173] = 3,
    ACTIONS(15049), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15510), 3,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_in,
  [673186] = 2,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15561), 4,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [673197] = 3,
    ACTIONS(15087), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15510), 3,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_u2984,
  [673210] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16332), 2,
      anon_sym__,
      sym_id,
    STATE(9180), 2,
      sym_bid,
      aux_sym_infix_repeat1,
  [673225] = 6,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16755), 1,
      anon_sym_RPAREN,
    ACTIONS(16774), 1,
      sym_id,
    ACTIONS(16776), 1,
      anon_sym_module,
    STATE(9620), 1,
      sym_renaming,
  [673244] = 5,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16778), 1,
      anon_sym__,
    STATE(9432), 1,
      sym__qid,
    ACTIONS(11811), 2,
      sym_id,
      aux_sym__qid_token1,
  [673261] = 5,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    STATE(7348), 1,
      sym__qid,
    STATE(7350), 1,
      sym_module_name,
    ACTIONS(7679), 2,
      sym_id,
      aux_sym__qid_token1,
  [673278] = 6,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16745), 1,
      anon_sym_RPAREN,
    ACTIONS(16774), 1,
      sym_id,
    ACTIONS(16776), 1,
      anon_sym_module,
    STATE(9558), 1,
      sym_renaming,
  [673297] = 5,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16782), 1,
      anon_sym__,
    STATE(10201), 1,
      sym__qid,
    ACTIONS(16780), 2,
      sym_id,
      aux_sym__qid_token1,
  [673314] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16199), 2,
      sym_id,
      anon_sym_DOT,
    ACTIONS(16201), 2,
      anon_sym_RBRACE_RBRACE,
      anon_sym_DOT_DOT,
  [673329] = 5,
    ACTIONS(16784), 1,
      anon_sym_LPAREN,
    ACTIONS(16786), 1,
      anon_sym_LBRACE_LBRACE,
    ACTIONS(16788), 1,
      anon_sym_u2983,
    ACTIONS(16790), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [673346] = 2,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15565), 4,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [673357] = 5,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16794), 1,
      anon_sym__,
    STATE(8155), 1,
      sym__qid,
    ACTIONS(16792), 2,
      sym_id,
      aux_sym__qid_token1,
  [673374] = 5,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16318), 1,
      sym_id,
    ACTIONS(16796), 1,
      anon_sym_COLON,
    STATE(9447), 2,
      sym__field_name,
      aux_sym__field_names,
  [673391] = 3,
    ACTIONS(15083), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15510), 3,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [673404] = 4,
    ACTIONS(16800), 1,
      sym__indent,
    STATE(10143), 1,
      sym__declaration_block,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(16798), 2,
      sym__newline,
      anon_sym_in,
  [673419] = 4,
    ACTIONS(16800), 1,
      sym__indent,
    STATE(10153), 1,
      sym__declaration_block,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(16802), 2,
      sym__newline,
      anon_sym_in,
  [673434] = 5,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16006), 1,
      sym_id,
    ACTIONS(16804), 1,
      anon_sym_RBRACE_RBRACE,
    STATE(9449), 2,
      sym__field_name,
      aux_sym__field_names,
  [673451] = 5,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16203), 1,
      sym_id,
    ACTIONS(16806), 1,
      anon_sym_u2984,
    STATE(9464), 2,
      sym__field_name,
      aux_sym__field_names,
  [673468] = 3,
    ACTIONS(14991), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15510), 3,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE_RBRACE,
  [673481] = 5,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16128), 1,
      sym_id,
    ACTIONS(16804), 1,
      anon_sym_RBRACE,
    STATE(9487), 2,
      sym__field_name,
      aux_sym__field_names,
  [673498] = 5,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    STATE(7258), 1,
      sym__qid,
    STATE(7261), 1,
      sym_module_name,
    ACTIONS(6894), 2,
      sym_id,
      aux_sym__qid_token1,
  [673515] = 3,
    ACTIONS(15069), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15510), 3,
      sym__newline,
      anon_sym_where,
      anon_sym_SEMI,
  [673528] = 4,
    ACTIONS(16800), 1,
      sym__indent,
    STATE(10139), 1,
      sym__declaration_block,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(16808), 2,
      sym__newline,
      anon_sym_in,
  [673543] = 4,
    ACTIONS(16800), 1,
      sym__indent,
    STATE(10144), 1,
      sym__declaration_block,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(16810), 2,
      sym__newline,
      anon_sym_in,
  [673558] = 4,
    ACTIONS(16812), 1,
      anon_sym_where,
    STATE(10151), 1,
      sym_record_declarations_block,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(16814), 2,
      sym__newline,
      anon_sym_in,
  [673573] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13299), 1,
      sym__newline,
    ACTIONS(13297), 3,
      anon_sym__,
      sym_id,
      anon_sym_in,
  [673588] = 2,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15577), 4,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE_RBRACE,
  [673599] = 2,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(16816), 4,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2984,
  [673610] = 4,
    ACTIONS(16800), 1,
      sym__indent,
    STATE(9988), 1,
      sym__declaration_block,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(16818), 2,
      sym__newline,
      anon_sym_in,
  [673625] = 4,
    ACTIONS(16812), 1,
      anon_sym_where,
    STATE(10128), 1,
      sym_record_declarations_block,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(16820), 2,
      sym__newline,
      anon_sym_in,
  [673640] = 4,
    ACTIONS(16800), 1,
      sym__indent,
    STATE(10160), 1,
      sym__declaration_block,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(16822), 2,
      sym__newline,
      anon_sym_in,
  [673655] = 4,
    ACTIONS(16800), 1,
      sym__indent,
    STATE(9890), 1,
      sym__declaration_block,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(16824), 2,
      sym__newline,
      anon_sym_in,
  [673670] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16459), 2,
      anon_sym__,
      sym_id,
    STATE(9242), 2,
      sym_bid,
      aux_sym_infix_repeat1,
  [673685] = 4,
    ACTIONS(16828), 1,
      sym__indent,
    STATE(10140), 1,
      sym__signature_block,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(16826), 2,
      sym__newline,
      anon_sym_in,
  [673700] = 4,
    ACTIONS(16800), 1,
      sym__indent,
    STATE(10030), 1,
      sym__declaration_block,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(16830), 2,
      sym__newline,
      anon_sym_in,
  [673715] = 3,
    ACTIONS(14993), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15510), 3,
      sym__newline,
      anon_sym_module,
      anon_sym_where,
  [673728] = 5,
    ACTIONS(16832), 1,
      anon_sym_constructor,
    ACTIONS(16834), 1,
      sym__dedent,
    STATE(9443), 1,
      aux_sym_record_constructor_instance_repeat1,
    STATE(12155), 1,
      sym_record_constructor,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [673745] = 5,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    STATE(10087), 1,
      sym_module_name,
    STATE(10189), 1,
      sym__qid,
    ACTIONS(16836), 2,
      sym_id,
      aux_sym__qid_token1,
  [673762] = 5,
    ACTIONS(16838), 1,
      anon_sym_constructor,
    ACTIONS(16841), 1,
      sym__dedent,
    STATE(9443), 1,
      aux_sym_record_constructor_instance_repeat1,
    STATE(12155), 1,
      sym_record_constructor,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [673779] = 3,
    ACTIONS(16843), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15571), 3,
      anon_sym_EQ,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2984,
  [673792] = 3,
    ACTIONS(15051), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15510), 3,
      sym__newline,
      anon_sym_where,
      anon_sym_in,
  [673805] = 2,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(16845), 4,
      sym__newline,
      anon_sym_module,
      anon_sym_where,
      anon_sym_in,
  [673816] = 5,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16847), 1,
      sym_id,
    ACTIONS(16850), 1,
      anon_sym_COLON,
    STATE(9447), 2,
      sym__field_name,
      aux_sym__field_names,
  [673833] = 2,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(16852), 4,
      sym__newline,
      anon_sym_module,
      anon_sym_where,
      anon_sym_in,
  [673844] = 5,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16854), 1,
      sym_id,
    ACTIONS(16857), 1,
      anon_sym_RBRACE_RBRACE,
    STATE(9449), 2,
      sym__field_name,
      aux_sym__field_names,
  [673861] = 6,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16859), 1,
      sym_id,
    ACTIONS(16861), 1,
      anon_sym_in,
    ACTIONS(16863), 1,
      sym__newline,
    STATE(9451), 1,
      aux_sym_syntax_repeat1,
  [673880] = 6,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16865), 1,
      sym_id,
    ACTIONS(16868), 1,
      anon_sym_in,
    ACTIONS(16870), 1,
      sym__newline,
    STATE(9451), 1,
      aux_sym_syntax_repeat1,
  [673899] = 5,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    STATE(7420), 1,
      sym_module_name,
    STATE(7450), 1,
      sym__qid,
    ACTIONS(7709), 2,
      sym_id,
      aux_sym__qid_token1,
  [673916] = 4,
    ACTIONS(16800), 1,
      sym__indent,
    STATE(10118), 1,
      sym__declaration_block,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(16872), 2,
      sym__newline,
      anon_sym_in,
  [673931] = 2,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15606), 4,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [673942] = 4,
    ACTIONS(16800), 1,
      sym__indent,
    STATE(10125), 1,
      sym__declaration_block,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(16874), 2,
      sym__newline,
      anon_sym_in,
  [673957] = 2,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15604), 4,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [673968] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16124), 2,
      sym_id,
      anon_sym_DOT,
    ACTIONS(16126), 2,
      anon_sym_RBRACE_RBRACE,
      anon_sym_DOT_DOT,
  [673983] = 2,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15516), 4,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [673994] = 2,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15602), 4,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [674005] = 2,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15600), 4,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [674016] = 3,
    ACTIONS(15579), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15598), 3,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RBRACE_RBRACE,
  [674029] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16201), 1,
      anon_sym_DOT_DOT,
    ACTIONS(16199), 3,
      anon_sym_u2984,
      sym_id,
      anon_sym_DOT,
  [674044] = 5,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16794), 1,
      anon_sym__,
    STATE(8088), 1,
      sym__qid,
    ACTIONS(16792), 2,
      sym_id,
      aux_sym__qid_token1,
  [674061] = 5,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16850), 1,
      anon_sym_u2984,
    ACTIONS(16876), 1,
      sym_id,
    STATE(9464), 2,
      sym__field_name,
      aux_sym__field_names,
  [674078] = 2,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15551), 4,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [674089] = 2,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15549), 4,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [674100] = 2,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15553), 4,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [674111] = 4,
    ACTIONS(16881), 1,
      sym__indent,
    STATE(9977), 1,
      sym__type_signature_block,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(16879), 2,
      sym__newline,
      anon_sym_in,
  [674126] = 2,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15557), 4,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [674137] = 2,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15571), 4,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [674148] = 2,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15573), 4,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE_RBRACE,
  [674159] = 2,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15514), 4,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE_RBRACE,
  [674170] = 3,
    ACTIONS(15579), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15577), 3,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RBRACE_RBRACE,
  [674183] = 2,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15508), 4,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [674194] = 2,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15575), 4,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [674205] = 2,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15563), 4,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [674216] = 4,
    ACTIONS(16800), 1,
      sym__indent,
    STATE(10120), 1,
      sym__declaration_block,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(16883), 2,
      sym__newline,
      anon_sym_in,
  [674231] = 2,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15559), 4,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [674242] = 2,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15555), 4,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE_RBRACE,
  [674253] = 2,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15547), 4,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [674264] = 2,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15545), 4,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE_RBRACE,
  [674275] = 4,
    ACTIONS(16800), 1,
      sym__indent,
    STATE(10123), 1,
      sym__declaration_block,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(16885), 2,
      sym__newline,
      anon_sym_in,
  [674290] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16126), 1,
      anon_sym_DOT_DOT,
    ACTIONS(16124), 3,
      anon_sym_u2984,
      sym_id,
      anon_sym_DOT,
  [674305] = 4,
    ACTIONS(16800), 1,
      sym__indent,
    STATE(10126), 1,
      sym__declaration_block,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(16887), 2,
      sym__newline,
      anon_sym_in,
  [674320] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16199), 2,
      sym_id,
      anon_sym_DOT,
    ACTIONS(16201), 2,
      anon_sym_RBRACE,
      anon_sym_DOT_DOT,
  [674335] = 3,
    ACTIONS(15065), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15510), 3,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [674348] = 5,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16857), 1,
      anon_sym_RBRACE,
    ACTIONS(16889), 1,
      sym_id,
    STATE(9487), 2,
      sym__field_name,
      aux_sym__field_names,
  [674365] = 4,
    ACTIONS(16800), 1,
      sym__indent,
    STATE(10134), 1,
      sym__declaration_block,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(16892), 2,
      sym__newline,
      anon_sym_in,
  [674380] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16124), 2,
      sym_id,
      anon_sym_DOT,
    ACTIONS(16126), 2,
      anon_sym_RBRACE,
      anon_sym_DOT_DOT,
  [674395] = 4,
    ACTIONS(16894), 1,
      anon_sym_in,
    ACTIONS(16896), 1,
      sym__newline,
    STATE(8930), 1,
      sym__let_body,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [674409] = 4,
    ACTIONS(16898), 1,
      anon_sym_in,
    ACTIONS(16900), 1,
      sym__newline,
    STATE(8930), 1,
      sym__let_body,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [674423] = 4,
    ACTIONS(16902), 1,
      anon_sym_in,
    ACTIONS(16904), 1,
      sym__newline,
    STATE(8990), 1,
      sym__let_body,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [674437] = 4,
    ACTIONS(16906), 1,
      anon_sym_in,
    ACTIONS(16908), 1,
      sym__newline,
    STATE(8994), 1,
      sym__let_body,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [674451] = 4,
    ACTIONS(16910), 1,
      anon_sym_in,
    ACTIONS(16912), 1,
      sym__newline,
    STATE(8994), 1,
      sym__let_body,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [674465] = 4,
    ACTIONS(16898), 1,
      anon_sym_in,
    ACTIONS(16914), 1,
      sym__newline,
    STATE(8943), 1,
      sym__let_body,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [674479] = 4,
    ACTIONS(16902), 1,
      anon_sym_in,
    ACTIONS(16916), 1,
      sym__newline,
    STATE(8976), 1,
      sym__let_body,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [674493] = 4,
    ACTIONS(16918), 1,
      anon_sym_in,
    ACTIONS(16920), 1,
      sym__newline,
    STATE(8947), 1,
      sym__let_body,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [674507] = 4,
    ACTIONS(16922), 1,
      anon_sym_in,
    ACTIONS(16924), 1,
      sym__newline,
    STATE(8930), 1,
      sym__let_body,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [674521] = 4,
    ACTIONS(16926), 1,
      anon_sym_in,
    ACTIONS(16928), 1,
      sym__newline,
    STATE(8976), 1,
      sym__let_body,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [674535] = 4,
    ACTIONS(16930), 1,
      anon_sym_in,
    ACTIONS(16932), 1,
      sym__newline,
    STATE(8947), 1,
      sym__let_body,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [674549] = 4,
    ACTIONS(16934), 1,
      anon_sym_in,
    ACTIONS(16936), 1,
      sym__newline,
    STATE(8947), 1,
      sym__let_body,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [674563] = 4,
    ACTIONS(16938), 1,
      anon_sym_in,
    ACTIONS(16940), 1,
      sym__newline,
    STATE(8994), 1,
      sym__let_body,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [674577] = 4,
    ACTIONS(16898), 1,
      anon_sym_in,
    ACTIONS(16942), 1,
      sym__newline,
    STATE(8994), 1,
      sym__let_body,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [674591] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16128), 1,
      sym_id,
    STATE(9424), 2,
      sym__field_name,
      aux_sym__field_names,
  [674605] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16203), 1,
      sym_id,
    STATE(9422), 2,
      sym__field_name,
      aux_sym__field_names,
  [674619] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16006), 1,
      sym_id,
    STATE(9421), 2,
      sym__field_name,
      aux_sym__field_names,
  [674633] = 4,
    ACTIONS(16944), 1,
      anon_sym_in,
    ACTIONS(16946), 1,
      sym__newline,
    STATE(9467), 1,
      sym__let_body,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [674647] = 4,
    ACTIONS(16948), 1,
      anon_sym_in,
    ACTIONS(16950), 1,
      sym__newline,
    STATE(8990), 1,
      sym__let_body,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [674661] = 4,
    ACTIONS(16948), 1,
      anon_sym_in,
    ACTIONS(16952), 1,
      sym__newline,
    STATE(8976), 1,
      sym__let_body,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [674675] = 4,
    ACTIONS(16944), 1,
      anon_sym_in,
    ACTIONS(16954), 1,
      sym__newline,
    STATE(9458), 1,
      sym__let_body,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [674689] = 4,
    ACTIONS(16956), 1,
      anon_sym_in,
    ACTIONS(16958), 1,
      sym__newline,
    STATE(8947), 1,
      sym__let_body,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [674703] = 4,
    ACTIONS(16906), 1,
      anon_sym_in,
    ACTIONS(16960), 1,
      sym__newline,
    STATE(8943), 1,
      sym__let_body,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [674717] = 4,
    ACTIONS(16962), 1,
      anon_sym_in,
    ACTIONS(16964), 1,
      sym__newline,
    STATE(8994), 1,
      sym__let_body,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [674731] = 4,
    ACTIONS(16922), 1,
      anon_sym_in,
    ACTIONS(16966), 1,
      sym__newline,
    STATE(8943), 1,
      sym__let_body,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [674745] = 4,
    ACTIONS(16968), 1,
      anon_sym_in,
    ACTIONS(16970), 1,
      sym__newline,
    STATE(9478), 1,
      sym__let_body,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [674759] = 4,
    ACTIONS(16972), 1,
      anon_sym_in,
    ACTIONS(16974), 1,
      sym__newline,
    STATE(8994), 1,
      sym__let_body,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [674773] = 4,
    ACTIONS(16906), 1,
      anon_sym_in,
    ACTIONS(16976), 1,
      sym__newline,
    STATE(8930), 1,
      sym__let_body,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [674787] = 3,
    ACTIONS(15067), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15510), 2,
      anon_sym_COLON,
      anon_sym_RBRACE_RBRACE,
  [674799] = 4,
    ACTIONS(16978), 1,
      anon_sym_in,
    ACTIONS(16980), 1,
      sym__newline,
    STATE(8930), 1,
      sym__let_body,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [674813] = 4,
    ACTIONS(16982), 1,
      anon_sym_in,
    ACTIONS(16984), 1,
      sym__newline,
    STATE(8976), 1,
      sym__let_body,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [674827] = 3,
    ACTIONS(15059), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15510), 2,
      anon_sym_COLON,
      anon_sym_RPAREN,
  [674839] = 4,
    ACTIONS(16978), 1,
      anon_sym_in,
    ACTIONS(16986), 1,
      sym__newline,
    STATE(8943), 1,
      sym__let_body,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [674853] = 4,
    ACTIONS(16988), 1,
      anon_sym_in,
    ACTIONS(16990), 1,
      sym__newline,
    STATE(8994), 1,
      sym__let_body,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [674867] = 4,
    ACTIONS(16918), 1,
      anon_sym_in,
    ACTIONS(16992), 1,
      sym__newline,
    STATE(8976), 1,
      sym__let_body,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [674881] = 4,
    ACTIONS(16994), 1,
      anon_sym_in,
    ACTIONS(16996), 1,
      sym__newline,
    STATE(8976), 1,
      sym__let_body,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [674895] = 4,
    ACTIONS(16982), 1,
      anon_sym_in,
    ACTIONS(16998), 1,
      sym__newline,
    STATE(8990), 1,
      sym__let_body,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [674909] = 3,
    ACTIONS(15073), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15510), 2,
      anon_sym_COLON,
      anon_sym_RBRACE,
  [674921] = 4,
    ACTIONS(16934), 1,
      anon_sym_in,
    ACTIONS(17000), 1,
      sym__newline,
    STATE(8990), 1,
      sym__let_body,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [674935] = 4,
    ACTIONS(16978), 1,
      anon_sym_in,
    ACTIONS(17002), 1,
      sym__newline,
    STATE(8994), 1,
      sym__let_body,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [674949] = 3,
    ACTIONS(15033), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15510), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [674961] = 4,
    ACTIONS(16994), 1,
      anon_sym_in,
    ACTIONS(17004), 1,
      sym__newline,
    STATE(8990), 1,
      sym__let_body,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [674975] = 4,
    ACTIONS(16918), 1,
      anon_sym_in,
    ACTIONS(17006), 1,
      sym__newline,
    STATE(8947), 1,
      sym__let_body,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [674989] = 4,
    ACTIONS(16934), 1,
      anon_sym_in,
    ACTIONS(17008), 1,
      sym__newline,
    STATE(8976), 1,
      sym__let_body,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [675003] = 4,
    ACTIONS(16982), 1,
      anon_sym_in,
    ACTIONS(17010), 1,
      sym__newline,
    STATE(8947), 1,
      sym__let_body,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [675017] = 4,
    ACTIONS(17012), 1,
      anon_sym_in,
    ACTIONS(17014), 1,
      sym__newline,
    STATE(9458), 1,
      sym__let_body,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [675031] = 4,
    ACTIONS(17012), 1,
      anon_sym_in,
    ACTIONS(17016), 1,
      sym__newline,
    STATE(9467), 1,
      sym__let_body,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [675045] = 3,
    STATE(11522), 1,
      sym__ARROW,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(17018), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
  [675057] = 4,
    ACTIONS(17020), 1,
      anon_sym_in,
    ACTIONS(17022), 1,
      sym__newline,
    STATE(8994), 1,
      sym__let_body,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [675071] = 4,
    ACTIONS(16972), 1,
      anon_sym_in,
    ACTIONS(17024), 1,
      sym__newline,
    STATE(8943), 1,
      sym__let_body,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [675085] = 3,
    ACTIONS(15085), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15510), 2,
      sym__newline,
      anon_sym_SEMI,
  [675097] = 4,
    ACTIONS(16968), 1,
      anon_sym_in,
    ACTIONS(17026), 1,
      sym__newline,
    STATE(9467), 1,
      sym__let_body,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [675111] = 4,
    ACTIONS(16968), 1,
      anon_sym_in,
    ACTIONS(17028), 1,
      sym__newline,
    STATE(9458), 1,
      sym__let_body,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [675125] = 4,
    ACTIONS(17030), 1,
      anon_sym_in,
    ACTIONS(17032), 1,
      sym__newline,
    STATE(8990), 1,
      sym__let_body,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [675139] = 4,
    ACTIONS(16972), 1,
      anon_sym_in,
    ACTIONS(17034), 1,
      sym__newline,
    STATE(8930), 1,
      sym__let_body,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [675153] = 4,
    ACTIONS(17030), 1,
      anon_sym_in,
    ACTIONS(17036), 1,
      sym__newline,
    STATE(8976), 1,
      sym__let_body,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [675167] = 5,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16347), 1,
      sym_id,
    STATE(9617), 1,
      aux_sym__field_assignments_repeat1,
    STATE(10130), 1,
      sym_field_assignment,
  [675183] = 4,
    ACTIONS(17038), 1,
      anon_sym_in,
    ACTIONS(17040), 1,
      sym__newline,
    STATE(8994), 1,
      sym__let_body,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [675197] = 3,
    ACTIONS(15091), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15510), 2,
      anon_sym_COLON,
      anon_sym_u2984,
  [675209] = 4,
    ACTIONS(17042), 1,
      anon_sym_in,
    ACTIONS(17044), 1,
      sym__newline,
    STATE(8976), 1,
      sym__let_body,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [675223] = 4,
    ACTIONS(17046), 1,
      anon_sym_in,
    ACTIONS(17048), 1,
      sym__newline,
    STATE(8947), 1,
      sym__let_body,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [675237] = 4,
    ACTIONS(17042), 1,
      anon_sym_in,
    ACTIONS(17050), 1,
      sym__newline,
    STATE(8990), 1,
      sym__let_body,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [675251] = 4,
    ACTIONS(16962), 1,
      anon_sym_in,
    ACTIONS(17052), 1,
      sym__newline,
    STATE(8943), 1,
      sym__let_body,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [675265] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    STATE(12463), 1,
      sym_bid,
    ACTIONS(17054), 2,
      anon_sym__,
      sym_id,
  [675279] = 4,
    ACTIONS(17056), 1,
      anon_sym_in,
    ACTIONS(17058), 1,
      sym__newline,
    STATE(8930), 1,
      sym__let_body,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [675293] = 4,
    ACTIONS(17060), 1,
      anon_sym_RPAREN,
    ACTIONS(17062), 1,
      anon_sym_SEMI,
    STATE(9666), 1,
      aux_sym_import_directive_repeat1,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [675307] = 4,
    ACTIONS(17056), 1,
      anon_sym_in,
    ACTIONS(17064), 1,
      sym__newline,
    STATE(8943), 1,
      sym__let_body,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [675321] = 4,
    ACTIONS(17030), 1,
      anon_sym_in,
    ACTIONS(17066), 1,
      sym__newline,
    STATE(8947), 1,
      sym__let_body,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [675335] = 4,
    ACTIONS(17062), 1,
      anon_sym_SEMI,
    ACTIONS(17068), 1,
      anon_sym_RPAREN,
    STATE(9555), 1,
      aux_sym_import_directive_repeat1,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [675349] = 3,
    ACTIONS(14955), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15510), 2,
      anon_sym_SEMI,
      anon_sym_u2988,
  [675361] = 4,
    ACTIONS(17070), 1,
      anon_sym_in,
    ACTIONS(17072), 1,
      sym__newline,
    STATE(8947), 1,
      sym__let_body,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [675375] = 4,
    ACTIONS(16926), 1,
      anon_sym_in,
    ACTIONS(17074), 1,
      sym__newline,
    STATE(8947), 1,
      sym__let_body,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [675389] = 4,
    ACTIONS(17076), 1,
      anon_sym_in,
    ACTIONS(17078), 1,
      sym__newline,
    STATE(8930), 1,
      sym__let_body,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [675403] = 4,
    ACTIONS(17080), 1,
      anon_sym_in,
    ACTIONS(17082), 1,
      sym__newline,
    STATE(8976), 1,
      sym__let_body,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [675417] = 5,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(17084), 1,
      sym_id,
    ACTIONS(17086), 1,
      anon_sym_EQ,
    STATE(9631), 1,
      aux_sym__ids,
  [675433] = 4,
    ACTIONS(17088), 1,
      anon_sym_in,
    ACTIONS(17090), 1,
      sym__newline,
    STATE(8947), 1,
      sym__let_body,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [675447] = 4,
    ACTIONS(16962), 1,
      anon_sym_in,
    ACTIONS(17092), 1,
      sym__newline,
    STATE(8930), 1,
      sym__let_body,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [675461] = 4,
    ACTIONS(17070), 1,
      anon_sym_in,
    ACTIONS(17094), 1,
      sym__newline,
    STATE(8990), 1,
      sym__let_body,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [675475] = 4,
    ACTIONS(17070), 1,
      anon_sym_in,
    ACTIONS(17096), 1,
      sym__newline,
    STATE(8976), 1,
      sym__let_body,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [675489] = 5,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(17084), 1,
      sym_id,
    ACTIONS(17098), 1,
      anon_sym_EQ,
    STATE(9631), 1,
      aux_sym__ids,
  [675505] = 4,
    ACTIONS(17100), 1,
      anon_sym_RPAREN,
    ACTIONS(17102), 1,
      anon_sym_SEMI,
    STATE(9570), 1,
      aux_sym__comma_import_names_repeat1,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [675519] = 3,
    ACTIONS(17105), 1,
      anon_sym_where,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(17107), 2,
      sym__newline,
      anon_sym_in,
  [675531] = 3,
    ACTIONS(16843), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15602), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [675543] = 4,
    ACTIONS(17042), 1,
      anon_sym_in,
    ACTIONS(17109), 1,
      sym__newline,
    STATE(8947), 1,
      sym__let_body,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [675557] = 4,
    ACTIONS(16926), 1,
      anon_sym_in,
    ACTIONS(17111), 1,
      sym__newline,
    STATE(8990), 1,
      sym__let_body,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [675571] = 4,
    ACTIONS(17080), 1,
      anon_sym_in,
    ACTIONS(17113), 1,
      sym__newline,
    STATE(8990), 1,
      sym__let_body,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [675585] = 4,
    ACTIONS(16956), 1,
      anon_sym_in,
    ACTIONS(17115), 1,
      sym__newline,
    STATE(8976), 1,
      sym__let_body,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [675599] = 4,
    ACTIONS(17117), 1,
      anon_sym_in,
    ACTIONS(17119), 1,
      sym__newline,
    STATE(8930), 1,
      sym__let_body,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [675613] = 5,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(17121), 1,
      sym_id,
    ACTIONS(17123), 1,
      anon_sym_EQ,
    STATE(9569), 1,
      aux_sym__ids,
  [675629] = 4,
    ACTIONS(16948), 1,
      anon_sym_in,
    ACTIONS(17125), 1,
      sym__newline,
    STATE(8947), 1,
      sym__let_body,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [675643] = 4,
    ACTIONS(16956), 1,
      anon_sym_in,
    ACTIONS(17127), 1,
      sym__newline,
    STATE(8990), 1,
      sym__let_body,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [675657] = 3,
    ACTIONS(17129), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15571), 2,
      anon_sym_EQ,
      anon_sym_RPAREN,
  [675669] = 4,
    ACTIONS(17117), 1,
      anon_sym_in,
    ACTIONS(17131), 1,
      sym__newline,
    STATE(8943), 1,
      sym__let_body,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [675683] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    STATE(9537), 1,
      sym_bid,
    ACTIONS(17054), 2,
      anon_sym__,
      sym_id,
  [675697] = 4,
    ACTIONS(16944), 1,
      anon_sym_in,
    ACTIONS(17133), 1,
      sym__newline,
    STATE(9478), 1,
      sym__let_body,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [675711] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    STATE(9621), 1,
      sym_bid,
    ACTIONS(17054), 2,
      anon_sym__,
      sym_id,
  [675725] = 4,
    ACTIONS(16894), 1,
      anon_sym_in,
    ACTIONS(17135), 1,
      sym__newline,
    STATE(8943), 1,
      sym__let_body,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [675739] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    STATE(9624), 1,
      sym_bid,
    ACTIONS(17054), 2,
      anon_sym__,
      sym_id,
  [675753] = 4,
    ACTIONS(17137), 1,
      anon_sym_in,
    ACTIONS(17139), 1,
      sym__newline,
    STATE(8990), 1,
      sym__let_body,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [675767] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    STATE(8193), 1,
      sym__qid,
    ACTIONS(17141), 2,
      sym_id,
      aux_sym__qid_token1,
  [675781] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    STATE(8175), 1,
      sym__qid,
    ACTIONS(17141), 2,
      sym_id,
      aux_sym__qid_token1,
  [675795] = 4,
    ACTIONS(17137), 1,
      anon_sym_in,
    ACTIONS(17143), 1,
      sym__newline,
    STATE(8947), 1,
      sym__let_body,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [675809] = 4,
    ACTIONS(17020), 1,
      anon_sym_in,
    ACTIONS(17145), 1,
      sym__newline,
    STATE(8943), 1,
      sym__let_body,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [675823] = 4,
    ACTIONS(17137), 1,
      anon_sym_in,
    ACTIONS(17147), 1,
      sym__newline,
    STATE(8976), 1,
      sym__let_body,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [675837] = 4,
    ACTIONS(17149), 1,
      anon_sym_in,
    ACTIONS(17151), 1,
      sym__newline,
    STATE(8994), 1,
      sym__let_body,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [675851] = 4,
    ACTIONS(17153), 1,
      anon_sym_in,
    ACTIONS(17155), 1,
      sym__newline,
    STATE(9478), 1,
      sym__let_body,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [675865] = 3,
    ACTIONS(15003), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15510), 2,
      sym__newline,
      anon_sym_where,
  [675877] = 4,
    ACTIONS(17076), 1,
      anon_sym_in,
    ACTIONS(17157), 1,
      sym__newline,
    STATE(8994), 1,
      sym__let_body,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [675891] = 4,
    ACTIONS(16922), 1,
      anon_sym_in,
    ACTIONS(17159), 1,
      sym__newline,
    STATE(8994), 1,
      sym__let_body,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [675905] = 3,
    ACTIONS(15063), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15510), 2,
      anon_sym_where,
      anon_sym_SEMI,
  [675917] = 4,
    ACTIONS(17161), 1,
      anon_sym_in,
    ACTIONS(17163), 1,
      sym__newline,
    STATE(8930), 1,
      sym__let_body,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [675931] = 4,
    ACTIONS(17165), 1,
      anon_sym_in,
    ACTIONS(17167), 1,
      sym__newline,
    STATE(9635), 1,
      sym__let_body,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [675945] = 4,
    ACTIONS(17161), 1,
      anon_sym_in,
    ACTIONS(17169), 1,
      sym__newline,
    STATE(8943), 1,
      sym__let_body,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [675959] = 4,
    ACTIONS(16930), 1,
      anon_sym_in,
    ACTIONS(17171), 1,
      sym__newline,
    STATE(8990), 1,
      sym__let_body,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [675973] = 4,
    ACTIONS(17020), 1,
      anon_sym_in,
    ACTIONS(17173), 1,
      sym__newline,
    STATE(8930), 1,
      sym__let_body,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [675987] = 3,
    ACTIONS(17175), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(17177), 2,
      sym__newline,
      anon_sym_where,
  [675999] = 4,
    ACTIONS(16930), 1,
      anon_sym_in,
    ACTIONS(17179), 1,
      sym__newline,
    STATE(8976), 1,
      sym__let_body,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [676013] = 3,
    ACTIONS(15057), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15510), 2,
      anon_sym_SEMI,
      anon_sym_PIPE_RPAREN,
  [676025] = 4,
    ACTIONS(16902), 1,
      anon_sym_in,
    ACTIONS(17181), 1,
      sym__newline,
    STATE(8947), 1,
      sym__let_body,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [676039] = 4,
    ACTIONS(17153), 1,
      anon_sym_in,
    ACTIONS(17183), 1,
      sym__newline,
    STATE(9458), 1,
      sym__let_body,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [676053] = 4,
    ACTIONS(17185), 1,
      anon_sym_in,
    ACTIONS(17187), 1,
      sym__newline,
    STATE(8976), 1,
      sym__let_body,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [676067] = 4,
    ACTIONS(17153), 1,
      anon_sym_in,
    ACTIONS(17189), 1,
      sym__newline,
    STATE(9467), 1,
      sym__let_body,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [676081] = 4,
    ACTIONS(17185), 1,
      anon_sym_in,
    ACTIONS(17191), 1,
      sym__newline,
    STATE(8990), 1,
      sym__let_body,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [676095] = 4,
    ACTIONS(17193), 1,
      anon_sym_in,
    ACTIONS(17195), 1,
      sym__newline,
    STATE(8990), 1,
      sym__let_body,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [676109] = 4,
    ACTIONS(17193), 1,
      anon_sym_in,
    ACTIONS(17197), 1,
      sym__newline,
    STATE(8976), 1,
      sym__let_body,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [676123] = 4,
    ACTIONS(16938), 1,
      anon_sym_in,
    ACTIONS(17199), 1,
      sym__newline,
    STATE(8943), 1,
      sym__let_body,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [676137] = 4,
    ACTIONS(16802), 1,
      sym__newline,
    ACTIONS(17201), 1,
      sym__indent,
    STATE(10153), 1,
      sym__declaration_block,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [676151] = 5,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(17203), 1,
      sym_id,
    STATE(9617), 1,
      aux_sym__field_assignments_repeat1,
    STATE(12178), 1,
      sym_field_assignment,
  [676167] = 4,
    ACTIONS(16894), 1,
      anon_sym_in,
    ACTIONS(17206), 1,
      sym__newline,
    STATE(8994), 1,
      sym__let_body,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [676181] = 4,
    ACTIONS(17208), 1,
      anon_sym_RPAREN,
    ACTIONS(17210), 1,
      anon_sym_SEMI,
    STATE(9647), 1,
      aux_sym__comma_import_names_repeat1,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [676195] = 4,
    ACTIONS(17062), 1,
      anon_sym_SEMI,
    ACTIONS(17212), 1,
      anon_sym_RPAREN,
    STATE(9649), 1,
      aux_sym_import_directive_repeat1,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [676209] = 3,
    STATE(12174), 1,
      sym__ARROW,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(17214), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
  [676221] = 4,
    ACTIONS(16938), 1,
      anon_sym_in,
    ACTIONS(17216), 1,
      sym__newline,
    STATE(8930), 1,
      sym__let_body,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [676235] = 4,
    ACTIONS(17218), 1,
      anon_sym_where,
    ACTIONS(17220), 1,
      sym__newline,
    STATE(12316), 1,
      sym_do_where,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [676249] = 3,
    STATE(12171), 1,
      sym__ARROW,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(17222), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
  [676261] = 4,
    ACTIONS(17224), 1,
      anon_sym_in,
    ACTIONS(17226), 1,
      sym__newline,
    STATE(8930), 1,
      sym__let_body,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [676275] = 3,
    ACTIONS(15019), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15510), 2,
      sym__newline,
      anon_sym_in,
  [676287] = 4,
    ACTIONS(17224), 1,
      anon_sym_in,
    ACTIONS(17228), 1,
      sym__newline,
    STATE(8943), 1,
      sym__let_body,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [676301] = 4,
    ACTIONS(17076), 1,
      anon_sym_in,
    ACTIONS(17230), 1,
      sym__newline,
    STATE(8943), 1,
      sym__let_body,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [676315] = 4,
    ACTIONS(16994), 1,
      anon_sym_in,
    ACTIONS(17232), 1,
      sym__newline,
    STATE(8947), 1,
      sym__let_body,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [676329] = 5,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16863), 1,
      sym__newline,
    ACTIONS(17234), 1,
      sym_id,
    STATE(9650), 1,
      aux_sym_syntax_repeat1,
  [676345] = 5,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(17236), 1,
      sym_id,
    ACTIONS(17239), 1,
      anon_sym_EQ,
    STATE(9631), 1,
      aux_sym__ids,
  [676361] = 4,
    ACTIONS(16910), 1,
      anon_sym_in,
    ACTIONS(17241), 1,
      sym__newline,
    STATE(8943), 1,
      sym__let_body,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [676375] = 4,
    ACTIONS(17056), 1,
      anon_sym_in,
    ACTIONS(17243), 1,
      sym__newline,
    STATE(8994), 1,
      sym__let_body,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [676389] = 4,
    ACTIONS(17165), 1,
      anon_sym_in,
    ACTIONS(17245), 1,
      sym__newline,
    STATE(9651), 1,
      sym__let_body,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [676403] = 3,
    ACTIONS(15516), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(17247), 2,
      sym__newline,
      anon_sym_where,
  [676415] = 4,
    ACTIONS(17165), 1,
      anon_sym_in,
    ACTIONS(17249), 1,
      sym__newline,
    STATE(8943), 1,
      sym__let_body,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [676429] = 4,
    ACTIONS(17251), 1,
      anon_sym_in,
    ACTIONS(17253), 1,
      sym__newline,
    STATE(8930), 1,
      sym__let_body,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [676443] = 4,
    ACTIONS(17080), 1,
      anon_sym_in,
    ACTIONS(17255), 1,
      sym__newline,
    STATE(8947), 1,
      sym__let_body,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [676457] = 4,
    ACTIONS(17257), 1,
      anon_sym_in,
    ACTIONS(17259), 1,
      sym__newline,
    STATE(8930), 1,
      sym__let_body,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [676471] = 4,
    ACTIONS(17193), 1,
      anon_sym_in,
    ACTIONS(17261), 1,
      sym__newline,
    STATE(8947), 1,
      sym__let_body,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [676485] = 3,
    ACTIONS(17263), 1,
      anon_sym_where,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(17265), 2,
      sym__newline,
      anon_sym_in,
  [676497] = 4,
    ACTIONS(17012), 1,
      anon_sym_in,
    ACTIONS(17267), 1,
      sym__newline,
    STATE(9478), 1,
      sym__let_body,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [676511] = 4,
    ACTIONS(16910), 1,
      anon_sym_in,
    ACTIONS(17269), 1,
      sym__newline,
    STATE(8930), 1,
      sym__let_body,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [676525] = 4,
    ACTIONS(17165), 1,
      anon_sym_in,
    ACTIONS(17271), 1,
      sym__newline,
    STATE(8930), 1,
      sym__let_body,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [676539] = 5,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16743), 1,
      anon_sym_module,
    ACTIONS(17273), 1,
      sym_id,
    STATE(10103), 1,
      sym__import_name,
  [676555] = 4,
    ACTIONS(17251), 1,
      anon_sym_in,
    ACTIONS(17275), 1,
      sym__newline,
    STATE(8943), 1,
      sym__let_body,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [676569] = 4,
    ACTIONS(17210), 1,
      anon_sym_SEMI,
    ACTIONS(17277), 1,
      anon_sym_RPAREN,
    STATE(9570), 1,
      aux_sym__comma_import_names_repeat1,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [676583] = 5,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16774), 1,
      sym_id,
    ACTIONS(16776), 1,
      anon_sym_module,
    STATE(10171), 1,
      sym_renaming,
  [676599] = 4,
    ACTIONS(17062), 1,
      anon_sym_SEMI,
    ACTIONS(17279), 1,
      anon_sym_RPAREN,
    STATE(9666), 1,
      aux_sym_import_directive_repeat1,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [676613] = 5,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16870), 1,
      sym__newline,
    ACTIONS(17281), 1,
      sym_id,
    STATE(9650), 1,
      aux_sym_syntax_repeat1,
  [676629] = 3,
    ACTIONS(15553), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(17284), 2,
      sym__newline,
      anon_sym_where,
  [676641] = 4,
    ACTIONS(17165), 1,
      anon_sym_in,
    ACTIONS(17286), 1,
      sym__newline,
    STATE(9668), 1,
      sym__let_body,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [676655] = 4,
    ACTIONS(17185), 1,
      anon_sym_in,
    ACTIONS(17288), 1,
      sym__newline,
    STATE(8947), 1,
      sym__let_body,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [676669] = 4,
    ACTIONS(16988), 1,
      anon_sym_in,
    ACTIONS(17290), 1,
      sym__newline,
    STATE(8943), 1,
      sym__let_body,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [676683] = 3,
    ACTIONS(15041), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15510), 2,
      anon_sym_SEMI,
      anon_sym_u2984,
  [676695] = 4,
    ACTIONS(17257), 1,
      anon_sym_in,
    ACTIONS(17292), 1,
      sym__newline,
    STATE(8943), 1,
      sym__let_body,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [676709] = 4,
    ACTIONS(17117), 1,
      anon_sym_in,
    ACTIONS(17294), 1,
      sym__newline,
    STATE(8994), 1,
      sym__let_body,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [676723] = 4,
    ACTIONS(17088), 1,
      anon_sym_in,
    ACTIONS(17296), 1,
      sym__newline,
    STATE(8976), 1,
      sym__let_body,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [676737] = 4,
    ACTIONS(17298), 1,
      anon_sym_in,
    ACTIONS(17300), 1,
      sym__newline,
    STATE(8930), 1,
      sym__let_body,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [676751] = 4,
    ACTIONS(17046), 1,
      anon_sym_in,
    ACTIONS(17302), 1,
      sym__newline,
    STATE(8976), 1,
      sym__let_body,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [676765] = 4,
    ACTIONS(16988), 1,
      anon_sym_in,
    ACTIONS(17304), 1,
      sym__newline,
    STATE(8930), 1,
      sym__let_body,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [676779] = 4,
    ACTIONS(17306), 1,
      anon_sym_BSLASH,
    ACTIONS(17308), 1,
      anon_sym_u03bb,
    STATE(9585), 1,
      sym__LAMBDA,
    ACTIONS(5), 2,
      sym_pragma,
      sym_comment,
  [676793] = 4,
    ACTIONS(17257), 1,
      anon_sym_in,
    ACTIONS(17310), 1,
      sym__newline,
    STATE(8994), 1,
      sym__let_body,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [676807] = 4,
    ACTIONS(17088), 1,
      anon_sym_in,
    ACTIONS(17312), 1,
      sym__newline,
    STATE(8990), 1,
      sym__let_body,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [676821] = 4,
    ACTIONS(17298), 1,
      anon_sym_in,
    ACTIONS(17314), 1,
      sym__newline,
    STATE(8943), 1,
      sym__let_body,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [676835] = 4,
    ACTIONS(17316), 1,
      anon_sym_RPAREN,
    ACTIONS(17318), 1,
      anon_sym_SEMI,
    STATE(9666), 1,
      aux_sym_import_directive_repeat1,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [676849] = 5,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(17321), 1,
      sym_id,
    ACTIONS(17323), 1,
      anon_sym_EQ,
    STATE(9564), 1,
      aux_sym__ids,
  [676865] = 3,
    ACTIONS(15559), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(17325), 2,
      sym__newline,
      anon_sym_where,
  [676877] = 4,
    ACTIONS(17165), 1,
      anon_sym_in,
    ACTIONS(17327), 1,
      sym__newline,
    STATE(8994), 1,
      sym__let_body,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [676891] = 4,
    ACTIONS(16832), 1,
      anon_sym_constructor,
    STATE(9441), 1,
      aux_sym_record_constructor_instance_repeat1,
    STATE(12155), 1,
      sym_record_constructor,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [676905] = 4,
    ACTIONS(16918), 1,
      anon_sym_in,
    ACTIONS(17329), 1,
      sym__newline,
    STATE(8990), 1,
      sym__let_body,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [676919] = 4,
    ACTIONS(17298), 1,
      anon_sym_in,
    ACTIONS(17331), 1,
      sym__newline,
    STATE(8994), 1,
      sym__let_body,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [676933] = 3,
    ACTIONS(15547), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(17333), 2,
      sym__newline,
      anon_sym_where,
  [676945] = 4,
    ACTIONS(16918), 1,
      anon_sym_in,
    ACTIONS(17335), 1,
      sym__newline,
    STATE(8976), 1,
      sym__let_body,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [676959] = 4,
    ACTIONS(17149), 1,
      anon_sym_in,
    ACTIONS(17337), 1,
      sym__newline,
    STATE(8943), 1,
      sym__let_body,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [676973] = 4,
    ACTIONS(17038), 1,
      anon_sym_in,
    ACTIONS(17339), 1,
      sym__newline,
    STATE(8943), 1,
      sym__let_body,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [676987] = 4,
    ACTIONS(17161), 1,
      anon_sym_in,
    ACTIONS(17341), 1,
      sym__newline,
    STATE(8994), 1,
      sym__let_body,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [677001] = 3,
    ACTIONS(16843), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15571), 2,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [677013] = 4,
    ACTIONS(17343), 1,
      anon_sym_in,
    ACTIONS(17345), 1,
      sym__newline,
    STATE(8943), 1,
      sym__let_body,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [677027] = 3,
    ACTIONS(17347), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15571), 2,
      anon_sym_EQ,
      anon_sym_RPAREN,
  [677039] = 4,
    ACTIONS(17343), 1,
      anon_sym_in,
    ACTIONS(17349), 1,
      sym__newline,
    STATE(8930), 1,
      sym__let_body,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [677053] = 4,
    ACTIONS(17351), 1,
      anon_sym_in,
    ACTIONS(17353), 1,
      sym__newline,
    STATE(8994), 1,
      sym__let_body,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [677067] = 4,
    ACTIONS(17149), 1,
      anon_sym_in,
    ACTIONS(17355), 1,
      sym__newline,
    STATE(8930), 1,
      sym__let_body,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [677081] = 4,
    ACTIONS(17038), 1,
      anon_sym_in,
    ACTIONS(17357), 1,
      sym__newline,
    STATE(8930), 1,
      sym__let_body,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [677095] = 3,
    ACTIONS(15039), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15510), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE_RBRACE,
  [677107] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(13299), 1,
      sym__newline,
    ACTIONS(13297), 2,
      anon_sym__,
      sym_id,
  [677121] = 3,
    ACTIONS(15035), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15510), 2,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [677133] = 4,
    ACTIONS(17343), 1,
      anon_sym_in,
    ACTIONS(17359), 1,
      sym__newline,
    STATE(8994), 1,
      sym__let_body,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [677147] = 4,
    ACTIONS(17351), 1,
      anon_sym_in,
    ACTIONS(17361), 1,
      sym__newline,
    STATE(8930), 1,
      sym__let_body,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [677161] = 4,
    ACTIONS(17046), 1,
      anon_sym_in,
    ACTIONS(17363), 1,
      sym__newline,
    STATE(8990), 1,
      sym__let_body,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [677175] = 4,
    ACTIONS(17251), 1,
      anon_sym_in,
    ACTIONS(17365), 1,
      sym__newline,
    STATE(8994), 1,
      sym__let_body,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [677189] = 4,
    ACTIONS(17351), 1,
      anon_sym_in,
    ACTIONS(17367), 1,
      sym__newline,
    STATE(8943), 1,
      sym__let_body,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [677203] = 2,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(13299), 3,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_where,
  [677213] = 4,
    ACTIONS(17224), 1,
      anon_sym_in,
    ACTIONS(17369), 1,
      sym__newline,
    STATE(8994), 1,
      sym__let_body,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [677227] = 3,
    ACTIONS(17371), 1,
      anon_sym_COLON,
    ACTIONS(17373), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [677238] = 3,
    ACTIONS(17375), 1,
      anon_sym_COLON,
    ACTIONS(17377), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [677249] = 3,
    ACTIONS(17377), 1,
      anon_sym_u2984,
    ACTIONS(17379), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [677260] = 3,
    ACTIONS(17377), 1,
      anon_sym_RBRACE,
    ACTIONS(17381), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [677271] = 3,
    ACTIONS(17373), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(17383), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [677282] = 3,
    ACTIONS(17385), 1,
      anon_sym_COLON,
    ACTIONS(17387), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [677293] = 3,
    ACTIONS(16843), 1,
      anon_sym_RPAREN,
    ACTIONS(17389), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [677304] = 3,
    ACTIONS(17373), 1,
      anon_sym_RBRACE,
    ACTIONS(17391), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [677315] = 3,
    ACTIONS(16843), 1,
      anon_sym_RPAREN,
    ACTIONS(17393), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [677326] = 3,
    ACTIONS(17395), 1,
      anon_sym_COLON,
    ACTIONS(17397), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [677337] = 3,
    ACTIONS(17397), 1,
      anon_sym_u2984,
    ACTIONS(17399), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [677348] = 3,
    ACTIONS(17397), 1,
      anon_sym_RBRACE,
    ACTIONS(17401), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [677359] = 3,
    ACTIONS(17403), 1,
      anon_sym_COLON,
    ACTIONS(17405), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [677370] = 3,
    ACTIONS(17405), 1,
      anon_sym_u2984,
    ACTIONS(17407), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [677381] = 3,
    ACTIONS(17405), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(17409), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [677392] = 3,
    ACTIONS(17411), 1,
      anon_sym_COLON,
    ACTIONS(17413), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [677403] = 3,
    ACTIONS(17413), 1,
      anon_sym_u2984,
    ACTIONS(17415), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [677414] = 3,
    ACTIONS(17413), 1,
      anon_sym_RBRACE,
    ACTIONS(17417), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [677425] = 3,
    ACTIONS(16843), 1,
      anon_sym_RPAREN,
    ACTIONS(17419), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [677436] = 3,
    ACTIONS(16843), 1,
      anon_sym_RPAREN,
    ACTIONS(17421), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [677447] = 3,
    ACTIONS(17423), 1,
      anon_sym_COLON,
    ACTIONS(17425), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [677458] = 2,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(17427), 2,
      sym__newline,
      anon_sym_in,
  [677467] = 3,
    ACTIONS(17429), 1,
      anon_sym_COLON,
    ACTIONS(17431), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [677478] = 3,
    ACTIONS(17431), 1,
      anon_sym_u2984,
    ACTIONS(17433), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [677489] = 3,
    ACTIONS(17431), 1,
      anon_sym_RBRACE,
    ACTIONS(17435), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [677500] = 3,
    ACTIONS(16843), 1,
      anon_sym_RPAREN,
    ACTIONS(17437), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [677511] = 3,
    ACTIONS(16843), 1,
      anon_sym_RPAREN,
    ACTIONS(17439), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [677522] = 3,
    ACTIONS(16843), 1,
      anon_sym_RPAREN,
    ACTIONS(17441), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [677533] = 3,
    ACTIONS(17443), 1,
      anon_sym_COLON,
    ACTIONS(17445), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [677544] = 3,
    ACTIONS(16843), 1,
      anon_sym_RPAREN,
    ACTIONS(17447), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [677555] = 3,
    ACTIONS(17445), 1,
      anon_sym_u2984,
    ACTIONS(17449), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [677566] = 3,
    ACTIONS(17425), 1,
      anon_sym_u2984,
    ACTIONS(17451), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [677577] = 3,
    ACTIONS(17425), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(17453), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [677588] = 3,
    ACTIONS(17445), 1,
      anon_sym_RBRACE,
    ACTIONS(17455), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [677599] = 3,
    ACTIONS(16843), 1,
      anon_sym_RPAREN,
    ACTIONS(17457), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [677610] = 3,
    ACTIONS(16843), 1,
      anon_sym_RPAREN,
    ACTIONS(17459), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [677621] = 3,
    ACTIONS(17461), 1,
      anon_sym_COLON,
    ACTIONS(17463), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [677632] = 3,
    ACTIONS(17463), 1,
      anon_sym_u2984,
    ACTIONS(17465), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [677643] = 3,
    ACTIONS(17467), 1,
      anon_sym_SEMI,
    ACTIONS(17469), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [677654] = 3,
    ACTIONS(16843), 1,
      anon_sym_RPAREN,
    ACTIONS(17471), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [677665] = 3,
    ACTIONS(17463), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(17473), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [677676] = 3,
    ACTIONS(16843), 1,
      anon_sym_RPAREN,
    ACTIONS(17475), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [677687] = 3,
    ACTIONS(17477), 1,
      anon_sym_COLON,
    ACTIONS(17479), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [677698] = 3,
    ACTIONS(17479), 1,
      anon_sym_u2984,
    ACTIONS(17481), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [677709] = 3,
    ACTIONS(17483), 1,
      anon_sym_COLON,
    ACTIONS(17485), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [677720] = 3,
    ACTIONS(17479), 1,
      anon_sym_RBRACE,
    ACTIONS(17487), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [677731] = 3,
    ACTIONS(17485), 1,
      anon_sym_u2984,
    ACTIONS(17489), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [677742] = 3,
    ACTIONS(17485), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(17491), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [677753] = 3,
    ACTIONS(17493), 1,
      anon_sym_COLON,
    ACTIONS(17495), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [677764] = 3,
    ACTIONS(17497), 1,
      anon_sym_COLON,
    ACTIONS(17499), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [677775] = 3,
    ACTIONS(17499), 1,
      anon_sym_u2984,
    ACTIONS(17501), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [677786] = 3,
    ACTIONS(16843), 1,
      anon_sym_RPAREN,
    ACTIONS(17503), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [677797] = 3,
    ACTIONS(17499), 1,
      anon_sym_RBRACE,
    ACTIONS(17505), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [677808] = 3,
    ACTIONS(16843), 1,
      anon_sym_RPAREN,
    ACTIONS(17507), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [677819] = 3,
    ACTIONS(16843), 1,
      anon_sym_RPAREN,
    ACTIONS(17509), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [677830] = 3,
    ACTIONS(16843), 1,
      anon_sym_RPAREN,
    ACTIONS(17511), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [677841] = 3,
    ACTIONS(16843), 1,
      anon_sym_RPAREN,
    ACTIONS(17513), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [677852] = 3,
    ACTIONS(17515), 1,
      anon_sym_COLON,
    ACTIONS(17517), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [677863] = 3,
    ACTIONS(17519), 1,
      anon_sym_COLON,
    ACTIONS(17521), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [677874] = 3,
    ACTIONS(17517), 1,
      anon_sym_u2984,
    ACTIONS(17523), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [677885] = 3,
    ACTIONS(17521), 1,
      anon_sym_u2984,
    ACTIONS(17525), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [677896] = 3,
    ACTIONS(17517), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(17527), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [677907] = 3,
    ACTIONS(17521), 1,
      anon_sym_RBRACE,
    ACTIONS(17529), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [677918] = 3,
    ACTIONS(16843), 1,
      anon_sym_RPAREN,
    ACTIONS(17531), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [677929] = 3,
    ACTIONS(16843), 1,
      anon_sym_RPAREN,
    ACTIONS(17533), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [677940] = 3,
    ACTIONS(16843), 1,
      anon_sym_RPAREN,
    ACTIONS(17535), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [677951] = 3,
    ACTIONS(16843), 1,
      anon_sym_RPAREN,
    ACTIONS(17537), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [677962] = 3,
    ACTIONS(17539), 1,
      anon_sym_COLON,
    ACTIONS(17541), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [677973] = 2,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(17543), 2,
      sym__newline,
      anon_sym_in,
  [677982] = 3,
    ACTIONS(17545), 1,
      anon_sym_COLON,
    ACTIONS(17547), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [677993] = 3,
    ACTIONS(17549), 1,
      anon_sym_COLON,
    ACTIONS(17551), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [678004] = 3,
    ACTIONS(17547), 1,
      anon_sym_u2984,
    ACTIONS(17553), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [678015] = 3,
    ACTIONS(17547), 1,
      anon_sym_RBRACE,
    ACTIONS(17555), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [678026] = 3,
    ACTIONS(16843), 1,
      anon_sym_RPAREN,
    ACTIONS(17557), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [678037] = 3,
    ACTIONS(17551), 1,
      anon_sym_u2984,
    ACTIONS(17559), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [678048] = 3,
    ACTIONS(16843), 1,
      anon_sym_RPAREN,
    ACTIONS(17561), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [678059] = 3,
    ACTIONS(17541), 1,
      anon_sym_u2984,
    ACTIONS(17563), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [678070] = 3,
    ACTIONS(16843), 1,
      anon_sym_RPAREN,
    ACTIONS(17565), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [678081] = 3,
    ACTIONS(17567), 1,
      anon_sym_COLON,
    ACTIONS(17569), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [678092] = 3,
    ACTIONS(17569), 1,
      anon_sym_u2984,
    ACTIONS(17571), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [678103] = 3,
    ACTIONS(17569), 1,
      anon_sym_RBRACE,
    ACTIONS(17573), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [678114] = 3,
    ACTIONS(16843), 1,
      anon_sym_RPAREN,
    ACTIONS(17575), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [678125] = 3,
    ACTIONS(17541), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(17577), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [678136] = 3,
    ACTIONS(16843), 1,
      anon_sym_RPAREN,
    ACTIONS(17579), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [678147] = 3,
    ACTIONS(17581), 1,
      anon_sym_COLON,
    ACTIONS(17583), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [678158] = 3,
    ACTIONS(17583), 1,
      anon_sym_u2984,
    ACTIONS(17585), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [678169] = 3,
    ACTIONS(16843), 1,
      anon_sym_RPAREN,
    ACTIONS(17587), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [678180] = 3,
    ACTIONS(17583), 1,
      anon_sym_RBRACE,
    ACTIONS(17589), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [678191] = 3,
    ACTIONS(16843), 1,
      anon_sym_RPAREN,
    ACTIONS(17591), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [678202] = 3,
    ACTIONS(17593), 1,
      anon_sym_COLON,
    ACTIONS(17595), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [678213] = 3,
    ACTIONS(16843), 1,
      anon_sym_RPAREN,
    ACTIONS(17597), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [678224] = 3,
    ACTIONS(17551), 1,
      anon_sym_RBRACE,
    ACTIONS(17599), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [678235] = 3,
    ACTIONS(16843), 1,
      anon_sym_RPAREN,
    ACTIONS(17601), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [678246] = 3,
    ACTIONS(17603), 1,
      anon_sym_COLON,
    ACTIONS(17605), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [678257] = 3,
    ACTIONS(17605), 1,
      anon_sym_u2984,
    ACTIONS(17607), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [678268] = 3,
    ACTIONS(17605), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(17609), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [678279] = 3,
    ACTIONS(17595), 1,
      anon_sym_u2984,
    ACTIONS(17611), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [678290] = 3,
    ACTIONS(16843), 1,
      anon_sym_RPAREN,
    ACTIONS(17613), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [678301] = 3,
    ACTIONS(16843), 1,
      anon_sym_RPAREN,
    ACTIONS(17615), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [678312] = 3,
    ACTIONS(17595), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(17617), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [678323] = 3,
    ACTIONS(17619), 1,
      anon_sym_COLON,
    ACTIONS(17621), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [678334] = 3,
    ACTIONS(17621), 1,
      anon_sym_u2984,
    ACTIONS(17623), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [678345] = 3,
    ACTIONS(17621), 1,
      anon_sym_RBRACE,
    ACTIONS(17625), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [678356] = 3,
    ACTIONS(17627), 1,
      anon_sym_COLON,
    ACTIONS(17629), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [678367] = 3,
    ACTIONS(17629), 1,
      anon_sym_u2984,
    ACTIONS(17631), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [678378] = 3,
    ACTIONS(17629), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(17633), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [678389] = 3,
    ACTIONS(16843), 1,
      anon_sym_RPAREN,
    ACTIONS(17635), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [678400] = 3,
    ACTIONS(17637), 1,
      anon_sym_COLON,
    ACTIONS(17639), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [678411] = 3,
    ACTIONS(17639), 1,
      anon_sym_u2984,
    ACTIONS(17641), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [678422] = 3,
    ACTIONS(17639), 1,
      anon_sym_RBRACE,
    ACTIONS(17643), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [678433] = 3,
    ACTIONS(17645), 1,
      anon_sym_COLON,
    ACTIONS(17647), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [678444] = 3,
    ACTIONS(16843), 1,
      anon_sym_RPAREN,
    ACTIONS(17649), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [678455] = 3,
    ACTIONS(17651), 1,
      anon_sym_COLON,
    ACTIONS(17653), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [678466] = 3,
    ACTIONS(17653), 1,
      anon_sym_u2984,
    ACTIONS(17655), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [678477] = 3,
    ACTIONS(17653), 1,
      anon_sym_RBRACE,
    ACTIONS(17657), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [678488] = 3,
    ACTIONS(16843), 1,
      anon_sym_RPAREN,
    ACTIONS(17659), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [678499] = 3,
    ACTIONS(16843), 1,
      anon_sym_RPAREN,
    ACTIONS(17661), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [678510] = 2,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(17663), 2,
      sym__newline,
      anon_sym_where,
  [678519] = 3,
    ACTIONS(16843), 1,
      anon_sym_RPAREN,
    ACTIONS(17665), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [678530] = 3,
    ACTIONS(16843), 1,
      anon_sym_RPAREN,
    ACTIONS(17667), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [678541] = 3,
    ACTIONS(16843), 1,
      anon_sym_RPAREN,
    ACTIONS(17669), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [678552] = 3,
    ACTIONS(17647), 1,
      anon_sym_u2984,
    ACTIONS(17671), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [678563] = 3,
    ACTIONS(17647), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(17673), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [678574] = 3,
    ACTIONS(17675), 1,
      anon_sym_COLON,
    ACTIONS(17677), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [678585] = 3,
    ACTIONS(16843), 1,
      anon_sym_RPAREN,
    ACTIONS(17679), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [678596] = 3,
    ACTIONS(17677), 1,
      anon_sym_u2984,
    ACTIONS(17681), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [678607] = 3,
    ACTIONS(16843), 1,
      anon_sym_RPAREN,
    ACTIONS(17683), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [678618] = 3,
    ACTIONS(17685), 1,
      anon_sym_COLON,
    ACTIONS(17687), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [678629] = 3,
    ACTIONS(17687), 1,
      anon_sym_u2984,
    ACTIONS(17689), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [678640] = 3,
    ACTIONS(17687), 1,
      anon_sym_RBRACE,
    ACTIONS(17691), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [678651] = 3,
    ACTIONS(17677), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(17693), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [678662] = 3,
    ACTIONS(16843), 1,
      anon_sym_RPAREN,
    ACTIONS(17695), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [678673] = 3,
    ACTIONS(17697), 1,
      anon_sym_COLON,
    ACTIONS(17699), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [678684] = 3,
    ACTIONS(17699), 1,
      anon_sym_u2984,
    ACTIONS(17701), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [678695] = 3,
    ACTIONS(17703), 1,
      anon_sym_COLON,
    ACTIONS(17705), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [678706] = 3,
    ACTIONS(17705), 1,
      anon_sym_u2984,
    ACTIONS(17707), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [678717] = 3,
    ACTIONS(17705), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(17709), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [678728] = 3,
    ACTIONS(17699), 1,
      anon_sym_RBRACE,
    ACTIONS(17711), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [678739] = 3,
    ACTIONS(16843), 1,
      anon_sym_RPAREN,
    ACTIONS(17713), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [678750] = 3,
    ACTIONS(16843), 1,
      anon_sym_RPAREN,
    ACTIONS(17715), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [678761] = 3,
    ACTIONS(16843), 1,
      anon_sym_RPAREN,
    ACTIONS(17717), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [678772] = 3,
    ACTIONS(17719), 1,
      anon_sym_COLON,
    ACTIONS(17721), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [678783] = 3,
    ACTIONS(16843), 1,
      anon_sym_RPAREN,
    ACTIONS(17723), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [678794] = 3,
    ACTIONS(17721), 1,
      anon_sym_u2984,
    ACTIONS(17725), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [678805] = 3,
    ACTIONS(16843), 1,
      anon_sym_RPAREN,
    ACTIONS(17727), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [678816] = 3,
    ACTIONS(17729), 1,
      anon_sym_COLON,
    ACTIONS(17731), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [678827] = 3,
    ACTIONS(17721), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(17733), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [678838] = 3,
    ACTIONS(17731), 1,
      anon_sym_u2984,
    ACTIONS(17735), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [678849] = 3,
    ACTIONS(17495), 1,
      anon_sym_RBRACE,
    ACTIONS(17737), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [678860] = 3,
    ACTIONS(17731), 1,
      anon_sym_RBRACE,
    ACTIONS(17739), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [678871] = 3,
    ACTIONS(16843), 1,
      anon_sym_RPAREN,
    ACTIONS(17741), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [678882] = 3,
    ACTIONS(16843), 1,
      anon_sym_RPAREN,
    ACTIONS(17743), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [678893] = 3,
    ACTIONS(17745), 1,
      anon_sym_COLON,
    ACTIONS(17747), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [678904] = 3,
    ACTIONS(17749), 1,
      anon_sym_COLON,
    ACTIONS(17751), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [678915] = 3,
    ACTIONS(17753), 1,
      aux_sym_integer_token1,
    STATE(9407), 1,
      sym_integer,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [678926] = 3,
    ACTIONS(17755), 1,
      anon_sym_COLON,
    ACTIONS(17757), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [678937] = 3,
    ACTIONS(16843), 1,
      anon_sym_RPAREN,
    ACTIONS(17759), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [678948] = 3,
    ACTIONS(17751), 1,
      anon_sym_u2984,
    ACTIONS(17761), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [678959] = 3,
    ACTIONS(16843), 1,
      anon_sym_RPAREN,
    ACTIONS(17763), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [678970] = 3,
    ACTIONS(16843), 1,
      anon_sym_RPAREN,
    ACTIONS(17765), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [678981] = 3,
    ACTIONS(17495), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(17767), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [678992] = 3,
    ACTIONS(16843), 1,
      anon_sym_RPAREN,
    ACTIONS(17769), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [679003] = 3,
    ACTIONS(16828), 1,
      sym__indent,
    STATE(12440), 1,
      sym__signature_block,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [679014] = 3,
    ACTIONS(16843), 1,
      anon_sym_RPAREN,
    ACTIONS(17771), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [679025] = 3,
    ACTIONS(16843), 1,
      anon_sym_RPAREN,
    ACTIONS(17773), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [679036] = 3,
    ACTIONS(17751), 1,
      anon_sym_RBRACE,
    ACTIONS(17775), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [679047] = 3,
    ACTIONS(15029), 1,
      anon_sym_EQ,
    ACTIONS(15510), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [679058] = 3,
    ACTIONS(16843), 1,
      anon_sym_RPAREN,
    ACTIONS(17777), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [679069] = 3,
    ACTIONS(16843), 1,
      anon_sym_RPAREN,
    ACTIONS(17779), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [679080] = 3,
    ACTIONS(17781), 1,
      anon_sym_COLON,
    ACTIONS(17783), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [679091] = 3,
    ACTIONS(16843), 1,
      anon_sym_RPAREN,
    ACTIONS(17785), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [679102] = 3,
    ACTIONS(16843), 1,
      anon_sym_RPAREN,
    ACTIONS(17787), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [679113] = 3,
    ACTIONS(17783), 1,
      anon_sym_u2984,
    ACTIONS(17789), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [679124] = 3,
    ACTIONS(17783), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(17791), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [679135] = 3,
    ACTIONS(16843), 1,
      anon_sym_RPAREN,
    ACTIONS(17793), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [679146] = 3,
    ACTIONS(16843), 1,
      anon_sym_RPAREN,
    ACTIONS(17795), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [679157] = 3,
    ACTIONS(17797), 1,
      anon_sym_COLON,
    ACTIONS(17799), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [679168] = 3,
    ACTIONS(17799), 1,
      anon_sym_u2984,
    ACTIONS(17801), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [679179] = 3,
    ACTIONS(17799), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(17803), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [679190] = 3,
    ACTIONS(16843), 1,
      anon_sym_RPAREN,
    ACTIONS(17805), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [679201] = 3,
    ACTIONS(17807), 1,
      anon_sym_COLON,
    ACTIONS(17809), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [679212] = 3,
    ACTIONS(17809), 1,
      anon_sym_u2984,
    ACTIONS(17811), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [679223] = 3,
    ACTIONS(17813), 1,
      anon_sym_COLON,
    ACTIONS(17815), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [679234] = 3,
    ACTIONS(17817), 1,
      anon_sym_COLON,
    ACTIONS(17819), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [679245] = 3,
    ACTIONS(17819), 1,
      anon_sym_u2984,
    ACTIONS(17821), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [679256] = 3,
    ACTIONS(17815), 1,
      anon_sym_u2984,
    ACTIONS(17823), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [679267] = 3,
    ACTIONS(17819), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(17825), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [679278] = 3,
    ACTIONS(17809), 1,
      anon_sym_RBRACE,
    ACTIONS(17827), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [679289] = 3,
    ACTIONS(17815), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(17829), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [679300] = 3,
    ACTIONS(16843), 1,
      anon_sym_RPAREN,
    ACTIONS(17831), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [679311] = 3,
    ACTIONS(17833), 1,
      anon_sym_COLON,
    ACTIONS(17835), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [679322] = 3,
    ACTIONS(16843), 1,
      anon_sym_RPAREN,
    ACTIONS(17837), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [679333] = 3,
    ACTIONS(17835), 1,
      anon_sym_u2984,
    ACTIONS(17839), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [679344] = 3,
    ACTIONS(17835), 1,
      anon_sym_RBRACE,
    ACTIONS(17841), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [679355] = 3,
    ACTIONS(16843), 1,
      anon_sym_RPAREN,
    ACTIONS(17843), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [679366] = 2,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(17845), 2,
      sym__newline,
      anon_sym_in,
  [679375] = 3,
    ACTIONS(16843), 1,
      anon_sym_RPAREN,
    ACTIONS(17847), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [679386] = 2,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(16611), 2,
      sym__newline,
      anon_sym_in,
  [679395] = 3,
    ACTIONS(17849), 1,
      anon_sym_COLON,
    ACTIONS(17851), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [679406] = 3,
    ACTIONS(17851), 1,
      anon_sym_u2984,
    ACTIONS(17853), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [679417] = 3,
    ACTIONS(16843), 1,
      anon_sym_RPAREN,
    ACTIONS(17855), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [679428] = 3,
    ACTIONS(17851), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(17857), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [679439] = 3,
    ACTIONS(16843), 1,
      anon_sym_RPAREN,
    ACTIONS(17859), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [679450] = 3,
    ACTIONS(17861), 1,
      anon_sym_COLON,
    ACTIONS(17863), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [679461] = 3,
    ACTIONS(17865), 1,
      anon_sym_COLON,
    ACTIONS(17867), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [679472] = 3,
    ACTIONS(17869), 1,
      anon_sym_COLON,
    ACTIONS(17871), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [679483] = 3,
    ACTIONS(17871), 1,
      anon_sym_u2984,
    ACTIONS(17873), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [679494] = 3,
    ACTIONS(17863), 1,
      anon_sym_u2984,
    ACTIONS(17875), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [679505] = 3,
    ACTIONS(17863), 1,
      anon_sym_RBRACE,
    ACTIONS(17877), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [679516] = 3,
    ACTIONS(17867), 1,
      anon_sym_u2984,
    ACTIONS(17879), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [679527] = 3,
    ACTIONS(17867), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(17881), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [679538] = 3,
    ACTIONS(16843), 1,
      anon_sym_RPAREN,
    ACTIONS(17883), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [679549] = 3,
    ACTIONS(16843), 1,
      anon_sym_RPAREN,
    ACTIONS(17885), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [679560] = 3,
    ACTIONS(17887), 1,
      anon_sym_COLON,
    ACTIONS(17889), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [679571] = 3,
    ACTIONS(17891), 1,
      anon_sym_COLON,
    ACTIONS(17893), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [679582] = 3,
    ACTIONS(17893), 1,
      anon_sym_u2984,
    ACTIONS(17895), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [679593] = 3,
    ACTIONS(17893), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(17897), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [679604] = 3,
    ACTIONS(17889), 1,
      anon_sym_u2984,
    ACTIONS(17899), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [679615] = 3,
    ACTIONS(17889), 1,
      anon_sym_RBRACE,
    ACTIONS(17901), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [679626] = 3,
    ACTIONS(16843), 1,
      anon_sym_RPAREN,
    ACTIONS(17903), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [679637] = 3,
    ACTIONS(17905), 1,
      anon_sym_COLON,
    ACTIONS(17907), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [679648] = 3,
    ACTIONS(17907), 1,
      anon_sym_u2984,
    ACTIONS(17909), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [679659] = 3,
    ACTIONS(17871), 1,
      anon_sym_RBRACE,
    ACTIONS(17911), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [679670] = 3,
    ACTIONS(17907), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(17913), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [679681] = 3,
    ACTIONS(17747), 1,
      anon_sym_RBRACE,
    ACTIONS(17915), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [679692] = 3,
    ACTIONS(17747), 1,
      anon_sym_u2984,
    ACTIONS(17917), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [679703] = 3,
    ACTIONS(17919), 1,
      anon_sym_COLON,
    ACTIONS(17921), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [679714] = 3,
    ACTIONS(17921), 1,
      anon_sym_u2984,
    ACTIONS(17923), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [679725] = 3,
    ACTIONS(17921), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(17925), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [679736] = 3,
    ACTIONS(16843), 1,
      anon_sym_RPAREN,
    ACTIONS(17927), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [679747] = 3,
    ACTIONS(16843), 1,
      anon_sym_RPAREN,
    ACTIONS(17929), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [679758] = 3,
    ACTIONS(16843), 1,
      anon_sym_RPAREN,
    ACTIONS(17931), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [679769] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16006), 1,
      sym_id,
    STATE(9413), 1,
      sym__field_name,
  [679782] = 3,
    ACTIONS(16843), 1,
      anon_sym_RPAREN,
    ACTIONS(17933), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [679793] = 3,
    ACTIONS(17935), 1,
      anon_sym_COLON,
    ACTIONS(17937), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [679804] = 3,
    ACTIONS(17757), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(17939), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [679815] = 3,
    ACTIONS(17941), 1,
      anon_sym_COLON,
    ACTIONS(17943), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [679826] = 3,
    ACTIONS(17945), 1,
      anon_sym_COLON,
    ACTIONS(17947), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [679837] = 3,
    ACTIONS(17943), 1,
      anon_sym_u2984,
    ACTIONS(17949), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [679848] = 3,
    ACTIONS(16843), 1,
      anon_sym_RPAREN,
    ACTIONS(17951), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [679859] = 3,
    ACTIONS(17947), 1,
      anon_sym_u2984,
    ACTIONS(17953), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [679870] = 3,
    ACTIONS(16843), 1,
      anon_sym_RPAREN,
    ACTIONS(17955), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [679881] = 2,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(15792), 2,
      sym__newline,
      anon_sym_in,
  [679890] = 3,
    ACTIONS(17943), 1,
      anon_sym_RBRACE,
    ACTIONS(17957), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [679901] = 3,
    ACTIONS(17947), 1,
      anon_sym_RBRACE,
    ACTIONS(17959), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [679912] = 3,
    ACTIONS(17937), 1,
      anon_sym_u2984,
    ACTIONS(17961), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [679923] = 3,
    ACTIONS(17937), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(17963), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [679934] = 3,
    ACTIONS(17965), 1,
      anon_sym_COLON,
    ACTIONS(17967), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [679945] = 3,
    ACTIONS(17967), 1,
      anon_sym_u2984,
    ACTIONS(17969), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [679956] = 3,
    ACTIONS(17971), 1,
      anon_sym_COLON,
    ACTIONS(17973), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [679967] = 3,
    ACTIONS(17967), 1,
      anon_sym_RBRACE,
    ACTIONS(17975), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [679978] = 3,
    ACTIONS(17973), 1,
      anon_sym_u2984,
    ACTIONS(17977), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [679989] = 3,
    ACTIONS(17973), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(17979), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [680000] = 3,
    ACTIONS(17981), 1,
      anon_sym_COLON,
    ACTIONS(17983), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [680011] = 3,
    ACTIONS(16843), 1,
      anon_sym_RPAREN,
    ACTIONS(17985), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [680022] = 3,
    ACTIONS(17983), 1,
      anon_sym_u2984,
    ACTIONS(17987), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [680033] = 3,
    ACTIONS(17983), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(17989), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [680044] = 3,
    ACTIONS(16843), 1,
      anon_sym_RPAREN,
    ACTIONS(17991), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [680055] = 3,
    ACTIONS(17993), 1,
      anon_sym_COLON,
    ACTIONS(17995), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [680066] = 3,
    ACTIONS(16843), 1,
      anon_sym_RPAREN,
    ACTIONS(17997), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [680077] = 3,
    ACTIONS(16843), 1,
      anon_sym_RPAREN,
    ACTIONS(17999), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [680088] = 3,
    ACTIONS(17995), 1,
      anon_sym_u2984,
    ACTIONS(18001), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [680099] = 3,
    ACTIONS(18003), 1,
      anon_sym_COLON,
    ACTIONS(18005), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [680110] = 3,
    ACTIONS(18005), 1,
      anon_sym_u2984,
    ACTIONS(18007), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [680121] = 3,
    ACTIONS(18005), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(18009), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [680132] = 3,
    ACTIONS(16843), 1,
      anon_sym_RPAREN,
    ACTIONS(18011), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [680143] = 3,
    ACTIONS(16843), 1,
      anon_sym_RPAREN,
    ACTIONS(18013), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [680154] = 3,
    ACTIONS(18015), 1,
      anon_sym_COLON,
    ACTIONS(18017), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [680165] = 3,
    ACTIONS(16843), 1,
      anon_sym_RPAREN,
    ACTIONS(18019), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [680176] = 3,
    ACTIONS(17995), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(18021), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [680187] = 3,
    ACTIONS(18017), 1,
      anon_sym_u2984,
    ACTIONS(18023), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [680198] = 3,
    ACTIONS(18017), 1,
      anon_sym_RBRACE,
    ACTIONS(18025), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [680209] = 3,
    ACTIONS(18027), 1,
      anon_sym_COLON,
    ACTIONS(18029), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [680220] = 3,
    ACTIONS(18029), 1,
      anon_sym_u2984,
    ACTIONS(18031), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [680231] = 3,
    ACTIONS(16843), 1,
      anon_sym_RPAREN,
    ACTIONS(18033), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [680242] = 3,
    ACTIONS(18029), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(18035), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [680253] = 3,
    ACTIONS(16843), 1,
      anon_sym_RPAREN,
    ACTIONS(18037), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [680264] = 3,
    ACTIONS(16843), 1,
      anon_sym_RPAREN,
    ACTIONS(18039), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [680275] = 3,
    ACTIONS(18041), 1,
      anon_sym_COLON,
    ACTIONS(18043), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [680286] = 3,
    ACTIONS(18043), 1,
      anon_sym_u2984,
    ACTIONS(18045), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [680297] = 3,
    ACTIONS(18043), 1,
      anon_sym_RBRACE,
    ACTIONS(18047), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [680308] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16302), 1,
      sym__dedent,
    ACTIONS(18049), 1,
      sym_id,
  [680321] = 2,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(18051), 2,
      sym__newline,
      anon_sym_in,
  [680330] = 2,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(18053), 2,
      sym__newline,
      anon_sym_in,
  [680339] = 3,
    ACTIONS(16843), 1,
      anon_sym_RPAREN,
    ACTIONS(18055), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [680350] = 3,
    ACTIONS(16843), 1,
      anon_sym_RPAREN,
    ACTIONS(18057), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [680361] = 3,
    ACTIONS(18059), 1,
      anon_sym_COLON,
    ACTIONS(18061), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [680372] = 3,
    ACTIONS(18061), 1,
      anon_sym_u2984,
    ACTIONS(18063), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [680383] = 3,
    ACTIONS(18061), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(18065), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [680394] = 3,
    ACTIONS(16843), 1,
      anon_sym_RPAREN,
    ACTIONS(18067), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [680405] = 3,
    ACTIONS(16843), 1,
      anon_sym_RPAREN,
    ACTIONS(18069), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [680416] = 3,
    ACTIONS(16843), 1,
      anon_sym_RPAREN,
    ACTIONS(18071), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [680427] = 2,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(18073), 2,
      sym__newline,
      anon_sym_in,
  [680436] = 2,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(16883), 2,
      sym__newline,
      anon_sym_in,
  [680445] = 3,
    ACTIONS(18075), 1,
      anon_sym_COLON,
    ACTIONS(18077), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [680456] = 3,
    ACTIONS(15007), 1,
      anon_sym_EQ,
    ACTIONS(15510), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [680467] = 3,
    ACTIONS(16843), 1,
      anon_sym_RPAREN,
    ACTIONS(18079), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [680478] = 3,
    ACTIONS(18077), 1,
      anon_sym_u2984,
    ACTIONS(18081), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [680489] = 3,
    ACTIONS(18083), 1,
      anon_sym_COLON,
    ACTIONS(18085), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [680500] = 3,
    ACTIONS(18077), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(18087), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [680511] = 3,
    ACTIONS(18085), 1,
      anon_sym_RBRACE,
    ACTIONS(18089), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [680522] = 3,
    ACTIONS(16843), 1,
      anon_sym_RPAREN,
    ACTIONS(18091), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [680533] = 3,
    ACTIONS(18093), 1,
      anon_sym_COLON,
    ACTIONS(18095), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [680544] = 3,
    ACTIONS(18095), 1,
      anon_sym_u2984,
    ACTIONS(18097), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [680555] = 3,
    ACTIONS(16843), 1,
      anon_sym_RPAREN,
    ACTIONS(18099), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [680566] = 3,
    ACTIONS(18095), 1,
      anon_sym_RBRACE,
    ACTIONS(18101), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [680577] = 3,
    ACTIONS(18085), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(18103), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [680588] = 3,
    ACTIONS(18105), 1,
      anon_sym_COLON,
    ACTIONS(18107), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [680599] = 3,
    ACTIONS(18109), 1,
      anon_sym_COLON,
    ACTIONS(18111), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [680610] = 3,
    ACTIONS(18111), 1,
      anon_sym_u2984,
    ACTIONS(18113), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [680621] = 3,
    ACTIONS(18111), 1,
      anon_sym_RBRACE,
    ACTIONS(18115), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [680632] = 3,
    ACTIONS(18107), 1,
      anon_sym_u2984,
    ACTIONS(18117), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [680643] = 3,
    ACTIONS(18107), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(18119), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [680654] = 3,
    ACTIONS(16843), 1,
      anon_sym_RPAREN,
    ACTIONS(18121), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [680665] = 3,
    ACTIONS(16843), 1,
      anon_sym_RPAREN,
    ACTIONS(18123), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [680676] = 3,
    ACTIONS(16843), 1,
      anon_sym_RPAREN,
    ACTIONS(18125), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [680687] = 3,
    ACTIONS(18127), 1,
      anon_sym_COLON,
    ACTIONS(18129), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [680698] = 3,
    ACTIONS(16843), 1,
      anon_sym_RPAREN,
    ACTIONS(18131), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [680709] = 3,
    ACTIONS(18129), 1,
      anon_sym_u2984,
    ACTIONS(18133), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [680720] = 3,
    ACTIONS(18129), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(18135), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [680731] = 3,
    ACTIONS(16843), 1,
      anon_sym_RPAREN,
    ACTIONS(18137), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [680742] = 3,
    ACTIONS(17757), 1,
      anon_sym_u2984,
    ACTIONS(18139), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [680753] = 3,
    ACTIONS(16843), 1,
      anon_sym_RPAREN,
    ACTIONS(18141), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [680764] = 3,
    ACTIONS(18143), 1,
      anon_sym_COLON,
    ACTIONS(18145), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [680775] = 3,
    ACTIONS(18147), 1,
      anon_sym_COLON,
    ACTIONS(18149), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [680786] = 3,
    ACTIONS(18149), 1,
      anon_sym_u2984,
    ACTIONS(18151), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [680797] = 3,
    ACTIONS(18149), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(18153), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [680808] = 3,
    ACTIONS(18145), 1,
      anon_sym_u2984,
    ACTIONS(18155), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [680819] = 3,
    ACTIONS(18157), 1,
      anon_sym_COLON,
    ACTIONS(18159), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [680830] = 3,
    ACTIONS(18145), 1,
      anon_sym_RBRACE,
    ACTIONS(18161), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [680841] = 3,
    ACTIONS(18159), 1,
      anon_sym_u2984,
    ACTIONS(18163), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [680852] = 3,
    ACTIONS(18159), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(18165), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [680863] = 3,
    ACTIONS(18167), 1,
      anon_sym_COLON,
    ACTIONS(18169), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [680874] = 3,
    ACTIONS(18169), 1,
      anon_sym_u2984,
    ACTIONS(18171), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [680885] = 3,
    ACTIONS(18169), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(18173), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [680896] = 2,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(16874), 2,
      sym__newline,
      anon_sym_in,
  [680905] = 3,
    ACTIONS(16843), 1,
      anon_sym_RPAREN,
    ACTIONS(18175), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [680916] = 3,
    ACTIONS(16843), 1,
      anon_sym_RPAREN,
    ACTIONS(18177), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [680927] = 3,
    ACTIONS(18179), 1,
      anon_sym_COLON,
    ACTIONS(18181), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [680938] = 3,
    ACTIONS(16843), 1,
      anon_sym_RPAREN,
    ACTIONS(18183), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [680949] = 3,
    ACTIONS(18181), 1,
      anon_sym_u2984,
    ACTIONS(18185), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [680960] = 3,
    ACTIONS(18187), 1,
      anon_sym_COLON,
    ACTIONS(18189), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [680971] = 3,
    ACTIONS(18191), 1,
      anon_sym_COLON,
    ACTIONS(18193), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [680982] = 3,
    ACTIONS(16843), 1,
      anon_sym_RPAREN,
    ACTIONS(18195), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [680993] = 3,
    ACTIONS(18193), 1,
      anon_sym_u2984,
    ACTIONS(18197), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [681004] = 3,
    ACTIONS(18193), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(18199), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [681015] = 3,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(18201), 2,
      sym_id,
      aux_sym__qid_token1,
  [681026] = 3,
    ACTIONS(18203), 1,
      anon_sym_COLON,
    ACTIONS(18205), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [681037] = 3,
    ACTIONS(18205), 1,
      anon_sym_u2984,
    ACTIONS(18207), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [681048] = 3,
    ACTIONS(16843), 1,
      anon_sym_RPAREN,
    ACTIONS(18209), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [681059] = 3,
    ACTIONS(18205), 1,
      anon_sym_RBRACE,
    ACTIONS(18211), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [681070] = 3,
    ACTIONS(18181), 1,
      anon_sym_RBRACE,
    ACTIONS(18213), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [681081] = 3,
    ACTIONS(16843), 1,
      anon_sym_RPAREN,
    ACTIONS(18215), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [681092] = 3,
    ACTIONS(16843), 1,
      anon_sym_RPAREN,
    ACTIONS(18217), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [681103] = 3,
    ACTIONS(16843), 1,
      anon_sym_RPAREN,
    ACTIONS(18219), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [681114] = 3,
    ACTIONS(15013), 1,
      anon_sym_EQ,
    ACTIONS(15510), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [681125] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16128), 1,
      sym_id,
    STATE(9485), 1,
      sym__field_name,
  [681138] = 3,
    ACTIONS(17467), 1,
      anon_sym_SEMI,
    ACTIONS(18221), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [681149] = 3,
    ACTIONS(18223), 1,
      anon_sym_COLON,
    ACTIONS(18225), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [681160] = 3,
    ACTIONS(18225), 1,
      anon_sym_u2984,
    ACTIONS(18227), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [681171] = 3,
    ACTIONS(18229), 1,
      anon_sym_COLON,
    ACTIONS(18231), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [681182] = 3,
    ACTIONS(18231), 1,
      anon_sym_u2984,
    ACTIONS(18233), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [681193] = 3,
    ACTIONS(18231), 1,
      anon_sym_RBRACE,
    ACTIONS(18235), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [681204] = 3,
    ACTIONS(18237), 1,
      anon_sym_COLON,
    ACTIONS(18239), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [681215] = 3,
    ACTIONS(18239), 1,
      anon_sym_u2984,
    ACTIONS(18241), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [681226] = 3,
    ACTIONS(18239), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(18243), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [681237] = 3,
    ACTIONS(18225), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(18245), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [681248] = 3,
    ACTIONS(18247), 1,
      anon_sym_SEMI,
    ACTIONS(18249), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [681259] = 3,
    ACTIONS(18251), 1,
      anon_sym_COLON,
    ACTIONS(18253), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [681270] = 3,
    ACTIONS(18253), 1,
      anon_sym_u2984,
    ACTIONS(18255), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [681281] = 3,
    ACTIONS(14999), 1,
      anon_sym_EQ,
    ACTIONS(15510), 1,
      anon_sym_u2988,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [681292] = 3,
    ACTIONS(16828), 1,
      sym__indent,
    STATE(10155), 1,
      sym__signature_block,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [681303] = 3,
    ACTIONS(18253), 1,
      anon_sym_RBRACE,
    ACTIONS(18257), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [681314] = 3,
    ACTIONS(18189), 1,
      anon_sym_RBRACE,
    ACTIONS(18259), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [681325] = 3,
    ACTIONS(18261), 1,
      anon_sym_COLON,
    ACTIONS(18263), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [681336] = 3,
    ACTIONS(18189), 1,
      anon_sym_u2984,
    ACTIONS(18265), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [681347] = 3,
    ACTIONS(18263), 1,
      anon_sym_u2984,
    ACTIONS(18267), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [681358] = 3,
    ACTIONS(18263), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(18269), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [681369] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16203), 1,
      sym_id,
    STATE(9462), 1,
      sym__field_name,
  [681382] = 3,
    ACTIONS(18271), 1,
      anon_sym_COLON,
    ACTIONS(18273), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [681393] = 3,
    ACTIONS(18273), 1,
      anon_sym_u2984,
    ACTIONS(18275), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [681404] = 2,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(18277), 2,
      sym__newline,
      anon_sym_in,
  [681413] = 3,
    ACTIONS(18273), 1,
      anon_sym_RBRACE,
    ACTIONS(18279), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [681424] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(18281), 1,
      sym_id,
    STATE(9450), 1,
      aux_sym_syntax_repeat1,
  [681437] = 3,
    ACTIONS(18283), 1,
      anon_sym_COLON,
    ACTIONS(18285), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [681448] = 3,
    ACTIONS(18285), 1,
      anon_sym_u2984,
    ACTIONS(18287), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [681459] = 3,
    ACTIONS(18285), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(18289), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [681470] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(18291), 1,
      sym_id,
    STATE(9630), 1,
      aux_sym_syntax_repeat1,
  [681483] = 2,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6326), 2,
      anon_sym_COLON,
      anon_sym_RBRACE,
  [681492] = 3,
    ACTIONS(15005), 1,
      anon_sym_EQ,
    ACTIONS(15510), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [681503] = 3,
    ACTIONS(16843), 1,
      anon_sym_RPAREN,
    ACTIONS(18293), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [681514] = 3,
    ACTIONS(18295), 1,
      anon_sym_EQ,
    ACTIONS(18297), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [681525] = 2,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(13183), 2,
      sym__newline,
      anon_sym_in,
  [681534] = 3,
    ACTIONS(16843), 1,
      anon_sym_RPAREN,
    ACTIONS(18299), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [681545] = 3,
    ACTIONS(18301), 1,
      anon_sym_COLON,
    ACTIONS(18303), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [681556] = 3,
    ACTIONS(18303), 1,
      anon_sym_u2984,
    ACTIONS(18305), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [681567] = 3,
    ACTIONS(18303), 1,
      anon_sym_RBRACE,
    ACTIONS(18307), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [681578] = 3,
    ACTIONS(18297), 1,
      anon_sym_u2984,
    ACTIONS(18309), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [681589] = 3,
    ACTIONS(18297), 1,
      anon_sym_RBRACE,
    ACTIONS(18311), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [681600] = 3,
    ACTIONS(18313), 1,
      anon_sym_COLON,
    ACTIONS(18315), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [681611] = 3,
    ACTIONS(18317), 1,
      anon_sym_COLON,
    ACTIONS(18319), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [681622] = 3,
    ACTIONS(18321), 1,
      anon_sym_COLON,
    ACTIONS(18323), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [681633] = 3,
    ACTIONS(18323), 1,
      anon_sym_u2984,
    ACTIONS(18325), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [681644] = 3,
    ACTIONS(18323), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(18327), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [681655] = 3,
    ACTIONS(18319), 1,
      anon_sym_u2984,
    ACTIONS(18329), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [681666] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(17121), 1,
      sym_id,
    STATE(9569), 1,
      aux_sym__ids,
  [681679] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(18331), 1,
      sym_id,
    STATE(8154), 1,
      sym_data_name,
  [681692] = 3,
    ACTIONS(18319), 1,
      anon_sym_RBRACE,
    ACTIONS(18333), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [681703] = 2,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(17100), 2,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [681712] = 2,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(18335), 2,
      sym__newline,
      anon_sym_in,
  [681721] = 2,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(18337), 2,
      sym__newline,
      anon_sym_in,
  [681730] = 2,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(18339), 2,
      sym__newline,
      anon_sym_where,
  [681739] = 3,
    ACTIONS(18315), 1,
      anon_sym_RBRACE,
    ACTIONS(18341), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [681750] = 2,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(18343), 2,
      sym__newline,
      anon_sym_where,
  [681759] = 3,
    ACTIONS(18345), 1,
      anon_sym_COLON,
    ACTIONS(18347), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [681770] = 3,
    ACTIONS(18347), 1,
      anon_sym_u2984,
    ACTIONS(18349), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [681781] = 3,
    ACTIONS(18347), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(18351), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [681792] = 3,
    ACTIONS(16843), 1,
      anon_sym_RPAREN,
    ACTIONS(18353), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [681803] = 3,
    ACTIONS(18355), 1,
      anon_sym_COLON,
    ACTIONS(18357), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [681814] = 3,
    ACTIONS(18357), 1,
      anon_sym_RBRACE,
    ACTIONS(18359), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [681825] = 2,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(18361), 2,
      sym__newline,
      anon_sym_in,
  [681834] = 3,
    ACTIONS(18363), 1,
      anon_sym_COLON,
    ACTIONS(18365), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [681845] = 3,
    ACTIONS(18365), 1,
      anon_sym_u2984,
    ACTIONS(18367), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [681856] = 2,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(18369), 2,
      sym__newline,
      anon_sym_in,
  [681865] = 3,
    ACTIONS(18365), 1,
      anon_sym_RBRACE,
    ACTIONS(18371), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [681876] = 2,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(18373), 2,
      sym__newline,
      anon_sym_in,
  [681885] = 3,
    ACTIONS(18375), 1,
      anon_sym_COLON,
    ACTIONS(18377), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [681896] = 3,
    ACTIONS(18377), 1,
      anon_sym_u2984,
    ACTIONS(18379), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [681907] = 2,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(18381), 2,
      sym__newline,
      anon_sym_in,
  [681916] = 2,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(18383), 2,
      sym__newline,
      anon_sym_in,
  [681925] = 2,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(16810), 2,
      sym__newline,
      anon_sym_in,
  [681934] = 2,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(18385), 2,
      sym__newline,
      anon_sym_in,
  [681943] = 2,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(18387), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [681952] = 2,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(18389), 2,
      sym__newline,
      anon_sym_in,
  [681961] = 2,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(18391), 2,
      sym__newline,
      anon_sym_in,
  [681970] = 3,
    ACTIONS(18247), 1,
      anon_sym_SEMI,
    ACTIONS(18393), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [681981] = 3,
    ACTIONS(18395), 1,
      anon_sym_COLON,
    ACTIONS(18397), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [681992] = 3,
    ACTIONS(18397), 1,
      anon_sym_u2984,
    ACTIONS(18399), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [682003] = 3,
    ACTIONS(18397), 1,
      anon_sym_RBRACE,
    ACTIONS(18401), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [682014] = 2,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(18403), 2,
      sym__newline,
      anon_sym_in,
  [682023] = 3,
    ACTIONS(18405), 1,
      anon_sym_COLON,
    ACTIONS(18407), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [682034] = 3,
    ACTIONS(18407), 1,
      anon_sym_u2984,
    ACTIONS(18409), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [682045] = 3,
    ACTIONS(18407), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(18411), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [682056] = 3,
    ACTIONS(15011), 1,
      anon_sym_EQ,
    ACTIONS(15510), 1,
      anon_sym_where,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [682067] = 2,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(18413), 2,
      sym__newline,
      anon_sym_in,
  [682076] = 2,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(18415), 2,
      sym__newline,
      anon_sym_in,
  [682085] = 2,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(18417), 2,
      sym__newline,
      anon_sym_in,
  [682094] = 2,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(18419), 2,
      sym__newline,
      anon_sym_where,
  [682103] = 2,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(18421), 2,
      sym__newline,
      anon_sym_in,
  [682112] = 2,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(16822), 2,
      sym__newline,
      anon_sym_in,
  [682121] = 3,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(18423), 2,
      anon_sym__,
      sym_id,
  [682132] = 2,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(18425), 2,
      sym__newline,
      anon_sym_in,
  [682141] = 3,
    ACTIONS(18427), 1,
      anon_sym_COLON,
    ACTIONS(18429), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [682152] = 3,
    ACTIONS(18429), 1,
      anon_sym_u2984,
    ACTIONS(18431), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [682163] = 3,
    ACTIONS(18429), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(18433), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [682174] = 3,
    ACTIONS(18357), 1,
      anon_sym_u2984,
    ACTIONS(18435), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [682185] = 2,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(18437), 2,
      sym__newline,
      anon_sym_in,
  [682194] = 2,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(18439), 2,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [682203] = 2,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(18441), 2,
      sym__newline,
      anon_sym_in,
  [682212] = 3,
    ACTIONS(18443), 1,
      anon_sym_COLON,
    ACTIONS(18445), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [682223] = 2,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(18447), 2,
      sym__newline,
      anon_sym_in,
  [682232] = 3,
    ACTIONS(18445), 1,
      anon_sym_u2984,
    ACTIONS(18449), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [682243] = 2,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(17284), 2,
      sym__newline,
      anon_sym_where,
  [682252] = 3,
    ACTIONS(18445), 1,
      anon_sym_RBRACE,
    ACTIONS(18451), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [682263] = 2,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(18453), 2,
      sym__newline,
      anon_sym_where,
  [682272] = 2,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(18455), 2,
      sym__newline,
      anon_sym_in,
  [682281] = 3,
    ACTIONS(18457), 1,
      anon_sym_COLON,
    ACTIONS(18459), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [682292] = 3,
    ACTIONS(18459), 1,
      anon_sym_u2984,
    ACTIONS(18461), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [682303] = 3,
    ACTIONS(18463), 1,
      anon_sym_COLON,
    ACTIONS(18465), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [682314] = 3,
    ACTIONS(18465), 1,
      anon_sym_u2984,
    ACTIONS(18467), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [682325] = 3,
    ACTIONS(18459), 1,
      anon_sym_RBRACE,
    ACTIONS(18469), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [682336] = 3,
    ACTIONS(18465), 1,
      anon_sym_RBRACE,
    ACTIONS(18471), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [682347] = 2,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(18473), 2,
      sym__newline,
      anon_sym_in,
  [682356] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(17321), 1,
      sym_id,
    STATE(9564), 1,
      aux_sym__ids,
  [682369] = 3,
    ACTIONS(17387), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(18475), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [682380] = 2,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(18477), 2,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [682389] = 2,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(17316), 2,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [682398] = 2,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(18479), 2,
      anon_sym_RBRACE_RBRACE,
      anon_sym_u2984,
  [682407] = 3,
    ACTIONS(18481), 1,
      anon_sym_COLON,
    ACTIONS(18483), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [682418] = 3,
    ACTIONS(18483), 1,
      anon_sym_u2984,
    ACTIONS(18485), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [682429] = 3,
    ACTIONS(18483), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(18487), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [682440] = 2,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(17325), 2,
      sym__newline,
      anon_sym_where,
  [682449] = 3,
    ACTIONS(18489), 1,
      anon_sym_COLON,
    ACTIONS(18491), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [682460] = 2,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(16841), 2,
      sym__dedent,
      anon_sym_constructor,
  [682469] = 3,
    ACTIONS(18493), 1,
      anon_sym_COLON,
    ACTIONS(18495), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [682480] = 2,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(18497), 2,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [682489] = 3,
    ACTIONS(18495), 1,
      anon_sym_u2984,
    ACTIONS(18499), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [682500] = 3,
    ACTIONS(18495), 1,
      anon_sym_RBRACE,
    ACTIONS(18501), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [682511] = 2,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(17333), 2,
      sym__newline,
      anon_sym_where,
  [682520] = 3,
    ACTIONS(18491), 1,
      anon_sym_u2984,
    ACTIONS(18503), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [682531] = 3,
    ACTIONS(18505), 1,
      anon_sym_COLON,
    ACTIONS(18507), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [682542] = 3,
    ACTIONS(18507), 1,
      anon_sym_u2984,
    ACTIONS(18509), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [682553] = 3,
    ACTIONS(18507), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(18511), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [682564] = 3,
    ACTIONS(18491), 1,
      anon_sym_RBRACE,
    ACTIONS(18513), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [682575] = 2,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(13177), 2,
      sym__newline,
      anon_sym_in,
  [682584] = 3,
    ACTIONS(18377), 1,
      anon_sym_RBRACE,
    ACTIONS(18515), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [682595] = 3,
    ACTIONS(14989), 1,
      anon_sym_EQ,
    ACTIONS(15510), 1,
      sym__newline,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [682606] = 3,
    ACTIONS(18517), 1,
      anon_sym_COLON,
    ACTIONS(18519), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [682617] = 3,
    ACTIONS(18519), 1,
      anon_sym_RBRACE,
    ACTIONS(18521), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [682628] = 3,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(16124), 2,
      anon_sym_COLON,
      sym_id,
  [682639] = 3,
    ACTIONS(18315), 1,
      anon_sym_u2984,
    ACTIONS(18523), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [682650] = 3,
    ACTIONS(15017), 1,
      anon_sym_EQ,
    ACTIONS(15510), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [682661] = 3,
    ACTIONS(18525), 1,
      anon_sym_COLON,
    ACTIONS(18527), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [682672] = 3,
    ACTIONS(18527), 1,
      anon_sym_u2984,
    ACTIONS(18529), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [682683] = 3,
    ACTIONS(18527), 1,
      anon_sym_RBRACE,
    ACTIONS(18531), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [682694] = 3,
    ACTIONS(18533), 1,
      anon_sym_COLON,
    ACTIONS(18535), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [682705] = 2,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(16816), 2,
      anon_sym_COLON,
      anon_sym_RBRACE,
  [682714] = 3,
    ACTIONS(18537), 1,
      anon_sym_COLON,
    ACTIONS(18539), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [682725] = 2,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
    ACTIONS(6326), 2,
      sym__newline,
      anon_sym_in,
  [682734] = 3,
    ACTIONS(18541), 1,
      anon_sym_COLON,
    ACTIONS(18543), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [682745] = 3,
    ACTIONS(18545), 1,
      anon_sym_COLON,
    ACTIONS(18547), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [682756] = 3,
    ACTIONS(17753), 1,
      aux_sym_integer_token1,
    STATE(9437), 1,
      sym_integer,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [682767] = 3,
    ACTIONS(18535), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(18549), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [682778] = 3,
    ACTIONS(18535), 1,
      anon_sym_u2984,
    ACTIONS(18551), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [682789] = 3,
    ACTIONS(18547), 1,
      anon_sym_u2984,
    ACTIONS(18553), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [682800] = 3,
    ACTIONS(18519), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(18555), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [682811] = 3,
    ACTIONS(18547), 1,
      anon_sym_RBRACE,
    ACTIONS(18557), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [682822] = 3,
    ACTIONS(18559), 1,
      anon_sym_COLON,
    ACTIONS(18561), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [682833] = 3,
    ACTIONS(18561), 1,
      anon_sym_u2984,
    ACTIONS(18563), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [682844] = 3,
    ACTIONS(18561), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(18565), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [682855] = 3,
    ACTIONS(18543), 1,
      anon_sym_u2984,
    ACTIONS(18567), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [682866] = 3,
    ACTIONS(18543), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(18569), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [682877] = 3,
    ACTIONS(18571), 1,
      anon_sym_COLON,
    ACTIONS(18573), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [682888] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(18331), 1,
      sym_id,
    STATE(8082), 1,
      sym_data_name,
  [682901] = 3,
    ACTIONS(18575), 1,
      anon_sym_COLON,
    ACTIONS(18577), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [682912] = 4,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(18331), 1,
      sym_id,
    STATE(8087), 1,
      sym_data_name,
  [682925] = 3,
    ACTIONS(18577), 1,
      anon_sym_u2984,
    ACTIONS(18579), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [682936] = 3,
    ACTIONS(18581), 1,
      anon_sym_COLON,
    ACTIONS(18583), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [682947] = 3,
    ACTIONS(18583), 1,
      anon_sym_u2984,
    ACTIONS(18585), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [682958] = 3,
    ACTIONS(18577), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(18587), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [682969] = 3,
    ACTIONS(18583), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(18589), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [682980] = 3,
    ACTIONS(6324), 1,
      anon_sym_LBRACE,
    ACTIONS(18591), 1,
      anon_sym_AT,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [682991] = 3,
    ACTIONS(17387), 1,
      anon_sym_RBRACE,
    ACTIONS(18593), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [683002] = 3,
    ACTIONS(18573), 1,
      anon_sym_RBRACE,
    ACTIONS(18595), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [683013] = 3,
    ACTIONS(18539), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(18597), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [683024] = 3,
    ACTIONS(18539), 1,
      anon_sym_RBRACE,
    ACTIONS(18599), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [683035] = 3,
    ACTIONS(18573), 1,
      anon_sym_u2984,
    ACTIONS(18601), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [683046] = 2,
    ACTIONS(18603), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [683054] = 2,
    ACTIONS(18605), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [683062] = 2,
    ACTIONS(18561), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [683070] = 2,
    ACTIONS(18607), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [683078] = 2,
    ACTIONS(18609), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [683086] = 2,
    ACTIONS(18611), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [683094] = 2,
    ACTIONS(18583), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [683102] = 2,
    ACTIONS(18613), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [683110] = 2,
    ACTIONS(18615), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [683118] = 2,
    ACTIONS(18617), 1,
      anon_sym_u2988,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [683126] = 2,
    ACTIONS(18617), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [683134] = 2,
    ACTIONS(18619), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [683142] = 2,
    ACTIONS(18617), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [683150] = 2,
    ACTIONS(18617), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [683158] = 2,
    ACTIONS(18621), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [683166] = 2,
    ACTIONS(18623), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [683174] = 2,
    ACTIONS(18623), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [683182] = 2,
    ACTIONS(18623), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [683190] = 2,
    ACTIONS(18623), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [683198] = 2,
    ACTIONS(18625), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [683206] = 2,
    ACTIONS(18625), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [683214] = 2,
    ACTIONS(18625), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [683222] = 2,
    ACTIONS(18625), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [683230] = 2,
    ACTIONS(18573), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [683238] = 2,
    ACTIONS(18627), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [683246] = 2,
    ACTIONS(18629), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [683254] = 2,
    ACTIONS(18507), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [683262] = 2,
    ACTIONS(18631), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [683270] = 2,
    ACTIONS(18631), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [683278] = 2,
    ACTIONS(18535), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [683286] = 2,
    ACTIONS(18633), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [683294] = 2,
    ACTIONS(18635), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [683302] = 2,
    ACTIONS(18637), 1,
      anon_sym_in,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [683310] = 2,
    ACTIONS(18639), 1,
      anon_sym_u2988,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [683318] = 2,
    ACTIONS(18639), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [683326] = 2,
    ACTIONS(18641), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [683334] = 2,
    ACTIONS(18639), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [683342] = 2,
    ACTIONS(18639), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [683350] = 2,
    ACTIONS(18643), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [683358] = 2,
    ACTIONS(18631), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [683366] = 2,
    ACTIONS(18645), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [683374] = 2,
    ACTIONS(18645), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [683382] = 2,
    ACTIONS(18647), 1,
      anon_sym_in,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [683390] = 2,
    ACTIONS(18645), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [683398] = 2,
    ACTIONS(18649), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [683406] = 2,
    ACTIONS(18651), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [683414] = 2,
    ACTIONS(18651), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [683422] = 2,
    ACTIONS(18651), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [683430] = 2,
    ACTIONS(18651), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [683438] = 2,
    ACTIONS(18653), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [683446] = 2,
    ACTIONS(18653), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [683454] = 2,
    ACTIONS(18655), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [683462] = 2,
    ACTIONS(18657), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [683470] = 2,
    ACTIONS(18653), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [683478] = 2,
    ACTIONS(18653), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [683486] = 2,
    ACTIONS(18655), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [683494] = 2,
    ACTIONS(18659), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [683502] = 2,
    ACTIONS(18655), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [683510] = 2,
    ACTIONS(18655), 1,
      anon_sym_u2988,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [683518] = 2,
    ACTIONS(18519), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [683526] = 2,
    ACTIONS(18661), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [683534] = 2,
    ACTIONS(18663), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [683542] = 2,
    ACTIONS(18665), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [683550] = 2,
    ACTIONS(18667), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [683558] = 2,
    ACTIONS(18669), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [683566] = 2,
    ACTIONS(18671), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [683574] = 2,
    ACTIONS(18673), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [683582] = 2,
    ACTIONS(18495), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [683590] = 2,
    ACTIONS(18675), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [683598] = 2,
    ACTIONS(18677), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [683606] = 2,
    ACTIONS(18483), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [683614] = 2,
    ACTIONS(18679), 1,
      anon_sym_u2988,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [683622] = 2,
    ACTIONS(18679), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [683630] = 2,
    ACTIONS(18681), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [683638] = 2,
    ACTIONS(18683), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [683646] = 2,
    ACTIONS(18683), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [683654] = 2,
    ACTIONS(18683), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [683662] = 2,
    ACTIONS(18679), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [683670] = 2,
    ACTIONS(18679), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [683678] = 2,
    ACTIONS(18685), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [683686] = 2,
    ACTIONS(18683), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [683694] = 2,
    ACTIONS(18687), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [683702] = 2,
    ACTIONS(18687), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [683710] = 2,
    ACTIONS(18689), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [683718] = 2,
    ACTIONS(18689), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [683726] = 2,
    ACTIONS(18689), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [683734] = 2,
    ACTIONS(18689), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [683742] = 2,
    ACTIONS(18691), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [683750] = 2,
    ACTIONS(18691), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [683758] = 2,
    ACTIONS(18691), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [683766] = 2,
    ACTIONS(18691), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [683774] = 2,
    ACTIONS(18687), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [683782] = 2,
    ACTIONS(18687), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [683790] = 2,
    ACTIONS(18693), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [683798] = 2,
    ACTIONS(18459), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [683806] = 2,
    ACTIONS(18695), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [683814] = 2,
    ACTIONS(18697), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [683822] = 2,
    ACTIONS(18699), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [683830] = 2,
    ACTIONS(18695), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [683838] = 2,
    ACTIONS(18701), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [683846] = 2,
    ACTIONS(18695), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [683854] = 2,
    ACTIONS(18695), 1,
      anon_sym_u2988,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [683862] = 2,
    ACTIONS(18445), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [683870] = 2,
    ACTIONS(18703), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [683878] = 2,
    ACTIONS(18705), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [683886] = 2,
    ACTIONS(18707), 1,
      anon_sym_in,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [683894] = 2,
    ACTIONS(18709), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [683902] = 2,
    ACTIONS(18711), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [683910] = 2,
    ACTIONS(18713), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [683918] = 2,
    ACTIONS(18429), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [683926] = 2,
    ACTIONS(18715), 1,
      anon_sym_u2988,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [683934] = 2,
    ACTIONS(18715), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [683942] = 2,
    ACTIONS(18717), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [683950] = 2,
    ACTIONS(18715), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [683958] = 2,
    ACTIONS(18719), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [683966] = 2,
    ACTIONS(18721), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [683974] = 2,
    ACTIONS(18715), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [683982] = 2,
    ACTIONS(18723), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [683990] = 2,
    ACTIONS(18725), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [683998] = 2,
    ACTIONS(18407), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [684006] = 2,
    ACTIONS(18727), 1,
      anon_sym_in,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [684014] = 2,
    ACTIONS(18729), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [684022] = 2,
    ACTIONS(18729), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [684030] = 2,
    ACTIONS(18729), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [684038] = 2,
    ACTIONS(18729), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [684046] = 2,
    ACTIONS(18731), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [684054] = 2,
    ACTIONS(18731), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [684062] = 2,
    ACTIONS(18731), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [684070] = 2,
    ACTIONS(18731), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [684078] = 2,
    ACTIONS(18733), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [684086] = 2,
    ACTIONS(18733), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [684094] = 2,
    ACTIONS(18733), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [684102] = 2,
    ACTIONS(18397), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [684110] = 2,
    ACTIONS(18733), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [684118] = 2,
    ACTIONS(18735), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [684126] = 2,
    ACTIONS(18737), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [684134] = 2,
    ACTIONS(18645), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [684142] = 2,
    ACTIONS(18739), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [684150] = 2,
    ACTIONS(18739), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [684158] = 2,
    ACTIONS(18739), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [684166] = 2,
    ACTIONS(18739), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [684174] = 2,
    ACTIONS(18741), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [684182] = 2,
    ACTIONS(18669), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [684190] = 2,
    ACTIONS(18377), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [684198] = 2,
    ACTIONS(18669), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [684206] = 2,
    ACTIONS(18743), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [684214] = 2,
    ACTIONS(18745), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [684222] = 2,
    ACTIONS(18747), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [684230] = 2,
    ACTIONS(18749), 1,
      anon_sym_u2988,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [684238] = 2,
    ACTIONS(18749), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [684246] = 2,
    ACTIONS(18751), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [684254] = 2,
    ACTIONS(18749), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [684262] = 2,
    ACTIONS(18749), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [684270] = 2,
    ACTIONS(18753), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [684278] = 2,
    ACTIONS(18231), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [684286] = 2,
    ACTIONS(18239), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [684294] = 2,
    ACTIONS(18755), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [684302] = 2,
    ACTIONS(18755), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [684310] = 2,
    ACTIONS(18669), 1,
      anon_sym_u2988,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [684318] = 2,
    ACTIONS(18757), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [684326] = 2,
    ACTIONS(18759), 1,
      anon_sym_in,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [684334] = 2,
    ACTIONS(18755), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [684342] = 2,
    ACTIONS(18761), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [684350] = 2,
    ACTIONS(18755), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [684358] = 2,
    ACTIONS(18763), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [684366] = 2,
    ACTIONS(18763), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [684374] = 2,
    ACTIONS(18763), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [684382] = 2,
    ACTIONS(18763), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [684390] = 2,
    ACTIONS(18347), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [684398] = 2,
    ACTIONS(18765), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [684406] = 2,
    ACTIONS(18767), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [684414] = 2,
    ACTIONS(18769), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [684422] = 2,
    ACTIONS(18323), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [684430] = 2,
    ACTIONS(18771), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [684438] = 2,
    ACTIONS(18319), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [684446] = 2,
    ACTIONS(18771), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [684454] = 2,
    ACTIONS(18773), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [684462] = 2,
    ACTIONS(18775), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [684470] = 2,
    ACTIONS(18771), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [684478] = 2,
    ACTIONS(18771), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [684486] = 2,
    ACTIONS(18777), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [684494] = 2,
    ACTIONS(18777), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [684502] = 2,
    ACTIONS(18303), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [684510] = 2,
    ACTIONS(18779), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [684518] = 2,
    ACTIONS(18781), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [684526] = 2,
    ACTIONS(18777), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [684534] = 2,
    ACTIONS(18783), 1,
      anon_sym_u2988,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [684542] = 2,
    ACTIONS(18783), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [684550] = 2,
    ACTIONS(18785), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [684558] = 2,
    ACTIONS(18783), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [684566] = 2,
    ACTIONS(18783), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [684574] = 2,
    ACTIONS(18787), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [684582] = 2,
    ACTIONS(18777), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [684590] = 2,
    ACTIONS(18789), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [684598] = 2,
    ACTIONS(18791), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [684606] = 2,
    ACTIONS(18793), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [684614] = 2,
    ACTIONS(18791), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [684622] = 2,
    ACTIONS(18795), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [684630] = 2,
    ACTIONS(18795), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [684638] = 2,
    ACTIONS(18797), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [684646] = 2,
    ACTIONS(18795), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [684654] = 2,
    ACTIONS(18795), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [684662] = 2,
    ACTIONS(18799), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [684670] = 2,
    ACTIONS(18799), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [684678] = 2,
    ACTIONS(18799), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [684686] = 2,
    ACTIONS(18799), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [684694] = 2,
    ACTIONS(18791), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [684702] = 2,
    ACTIONS(18791), 1,
      anon_sym_u2988,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [684710] = 2,
    ACTIONS(18801), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [684718] = 2,
    ACTIONS(18273), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [684726] = 2,
    ACTIONS(18803), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [684734] = 2,
    ACTIONS(18805), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [684742] = 2,
    ACTIONS(18807), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [684750] = 2,
    ACTIONS(18263), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [684758] = 2,
    ACTIONS(18809), 1,
      anon_sym_in,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [684766] = 2,
    ACTIONS(18811), 1,
      anon_sym_in,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [684774] = 2,
    ACTIONS(18813), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [684782] = 2,
    ACTIONS(18815), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [684790] = 2,
    ACTIONS(18817), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [684798] = 2,
    ACTIONS(18819), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [684806] = 2,
    ACTIONS(18819), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [684814] = 2,
    ACTIONS(18821), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [684822] = 2,
    ACTIONS(18823), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [684830] = 2,
    ACTIONS(18825), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [684838] = 2,
    ACTIONS(18819), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [684846] = 2,
    ACTIONS(18827), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [684854] = 2,
    ACTIONS(18819), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [684862] = 2,
    ACTIONS(18829), 1,
      anon_sym_u2988,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [684870] = 2,
    ACTIONS(18831), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [684878] = 2,
    ACTIONS(18829), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [684886] = 2,
    ACTIONS(18833), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [684894] = 2,
    ACTIONS(18829), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [684902] = 2,
    ACTIONS(18829), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [684910] = 2,
    ACTIONS(18835), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [684918] = 2,
    ACTIONS(18831), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [684926] = 2,
    ACTIONS(18831), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [684934] = 2,
    ACTIONS(18837), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [684942] = 2,
    ACTIONS(18837), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [684950] = 2,
    ACTIONS(18837), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [684958] = 2,
    ACTIONS(18837), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [684966] = 2,
    ACTIONS(18839), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [684974] = 2,
    ACTIONS(18839), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [684982] = 2,
    ACTIONS(18839), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [684990] = 2,
    ACTIONS(18839), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [684998] = 2,
    ACTIONS(18831), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [685006] = 2,
    ACTIONS(18841), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [685014] = 2,
    ACTIONS(18843), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [685022] = 2,
    ACTIONS(18845), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [685030] = 2,
    ACTIONS(18843), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [685038] = 2,
    ACTIONS(18843), 1,
      anon_sym_u2988,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [685046] = 2,
    ACTIONS(18205), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [685054] = 2,
    ACTIONS(18847), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [685062] = 2,
    ACTIONS(18849), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [685070] = 2,
    ACTIONS(18851), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [685078] = 2,
    ACTIONS(18853), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [685086] = 2,
    ACTIONS(18169), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [685094] = 2,
    ACTIONS(18855), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [685102] = 2,
    ACTIONS(18857), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [685110] = 2,
    ACTIONS(18149), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [685118] = 2,
    ACTIONS(18145), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [685126] = 2,
    ACTIONS(18859), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [685134] = 2,
    ACTIONS(18861), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [685142] = 2,
    ACTIONS(18863), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [685150] = 2,
    ACTIONS(18865), 1,
      anon_sym_u2988,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [685158] = 2,
    ACTIONS(18865), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [685166] = 2,
    ACTIONS(18867), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [685174] = 2,
    ACTIONS(18863), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [685182] = 2,
    ACTIONS(18863), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [685190] = 2,
    ACTIONS(18869), 1,
      anon_sym_in,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [685198] = 2,
    ACTIONS(18865), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [685206] = 2,
    ACTIONS(18863), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [685214] = 2,
    ACTIONS(18865), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [685222] = 2,
    ACTIONS(18871), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [685230] = 2,
    ACTIONS(18873), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [685238] = 2,
    ACTIONS(18873), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [685246] = 2,
    ACTIONS(18875), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [685254] = 2,
    ACTIONS(18875), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [685262] = 2,
    ACTIONS(18873), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [685270] = 2,
    ACTIONS(18877), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [685278] = 2,
    ACTIONS(18875), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [685286] = 2,
    ACTIONS(18875), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [685294] = 2,
    ACTIONS(18873), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [685302] = 2,
    ACTIONS(18879), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [685310] = 2,
    ACTIONS(18821), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [685318] = 2,
    ACTIONS(18821), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [685326] = 2,
    ACTIONS(18821), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [685334] = 2,
    ACTIONS(18881), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [685342] = 2,
    ACTIONS(18883), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [685350] = 2,
    ACTIONS(18885), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [685358] = 2,
    ACTIONS(18111), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [685366] = 2,
    ACTIONS(18885), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [685374] = 2,
    ACTIONS(18887), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [685382] = 2,
    ACTIONS(18889), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [685390] = 2,
    ACTIONS(18843), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [685398] = 2,
    ACTIONS(18885), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [685406] = 2,
    ACTIONS(18885), 1,
      anon_sym_u2988,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [685414] = 2,
    ACTIONS(18891), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [685422] = 2,
    ACTIONS(18095), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [685430] = 2,
    ACTIONS(18893), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [685438] = 2,
    ACTIONS(18895), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [685446] = 2,
    ACTIONS(18897), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [685454] = 2,
    ACTIONS(18077), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [685462] = 2,
    ACTIONS(18899), 1,
      anon_sym_in,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [685470] = 2,
    ACTIONS(18901), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [685478] = 2,
    ACTIONS(18879), 1,
      anon_sym_u2988,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [685486] = 2,
    ACTIONS(18903), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [685494] = 2,
    ACTIONS(18905), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [685502] = 2,
    ACTIONS(18907), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [685510] = 2,
    ACTIONS(18879), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [685518] = 2,
    ACTIONS(18879), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [685526] = 2,
    ACTIONS(18909), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [685534] = 2,
    ACTIONS(18061), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [685542] = 2,
    ACTIONS(18911), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [685550] = 2,
    ACTIONS(18913), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [685558] = 2,
    ACTIONS(18913), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [685566] = 2,
    ACTIONS(18913), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [685574] = 2,
    ACTIONS(18913), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [685582] = 2,
    ACTIONS(18915), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [685590] = 2,
    ACTIONS(18915), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [685598] = 2,
    ACTIONS(18911), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [685606] = 2,
    ACTIONS(18911), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [685614] = 2,
    ACTIONS(18917), 1,
      anon_sym_in,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [685622] = 2,
    ACTIONS(18915), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [685630] = 2,
    ACTIONS(18911), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [685638] = 2,
    ACTIONS(18915), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [685646] = 2,
    ACTIONS(18919), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [685654] = 2,
    ACTIONS(18919), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [685662] = 2,
    ACTIONS(18919), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [685670] = 2,
    ACTIONS(18043), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [685678] = 2,
    ACTIONS(18919), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [685686] = 2,
    ACTIONS(18921), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [685694] = 2,
    ACTIONS(18923), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [685702] = 2,
    ACTIONS(18925), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [685710] = 2,
    ACTIONS(18927), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [685718] = 2,
    ACTIONS(18929), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [685726] = 2,
    ACTIONS(18929), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [685734] = 2,
    ACTIONS(18931), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [685742] = 2,
    ACTIONS(18929), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [685750] = 2,
    ACTIONS(18929), 1,
      anon_sym_u2988,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [685758] = 2,
    ACTIONS(18017), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [685766] = 2,
    ACTIONS(18933), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [685774] = 2,
    ACTIONS(18935), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [685782] = 2,
    ACTIONS(18937), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [685790] = 2,
    ACTIONS(18939), 1,
      anon_sym_u2988,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [685798] = 2,
    ACTIONS(18939), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [685806] = 2,
    ACTIONS(18941), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [685814] = 2,
    ACTIONS(18939), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [685822] = 2,
    ACTIONS(18939), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [685830] = 2,
    ACTIONS(18943), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [685838] = 2,
    ACTIONS(18945), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [685846] = 2,
    ACTIONS(18005), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [685854] = 2,
    ACTIONS(18947), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [685862] = 2,
    ACTIONS(18947), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [685870] = 2,
    ACTIONS(18949), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [685878] = 2,
    ACTIONS(18951), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [685886] = 2,
    ACTIONS(17983), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [685894] = 2,
    ACTIONS(18947), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [685902] = 2,
    ACTIONS(18947), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [685910] = 2,
    ACTIONS(18953), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [685918] = 2,
    ACTIONS(18953), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [685926] = 2,
    ACTIONS(18955), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [685934] = 2,
    ACTIONS(18953), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [685942] = 2,
    ACTIONS(18953), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [685950] = 2,
    ACTIONS(18955), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [685958] = 2,
    ACTIONS(18957), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [685966] = 2,
    ACTIONS(18955), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [685974] = 2,
    ACTIONS(17967), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [685982] = 2,
    ACTIONS(18959), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [685990] = 2,
    ACTIONS(18961), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [685998] = 2,
    ACTIONS(18963), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [686006] = 2,
    ACTIONS(18959), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [686014] = 2,
    ACTIONS(18959), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [686022] = 2,
    ACTIONS(18959), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [686030] = 2,
    ACTIONS(18965), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [686038] = 2,
    ACTIONS(18967), 1,
      anon_sym_in,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [686046] = 2,
    ACTIONS(18881), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [686054] = 2,
    ACTIONS(18881), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [686062] = 2,
    ACTIONS(18969), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [686070] = 2,
    ACTIONS(17943), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [686078] = 2,
    ACTIONS(18971), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [686086] = 2,
    ACTIONS(18973), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [686094] = 2,
    ACTIONS(18903), 1,
      anon_sym_u2988,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [686102] = 2,
    ACTIONS(18903), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [686110] = 2,
    ACTIONS(18975), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [686118] = 2,
    ACTIONS(18977), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [686126] = 2,
    ACTIONS(18979), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [686134] = 2,
    ACTIONS(18903), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [686142] = 2,
    ACTIONS(18881), 1,
      anon_sym_u2988,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [686150] = 2,
    ACTIONS(18981), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [686158] = 2,
    ACTIONS(18983), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [686166] = 2,
    ACTIONS(18985), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [686174] = 2,
    ACTIONS(17921), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [686182] = 2,
    ACTIONS(18987), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [686190] = 2,
    ACTIONS(18987), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [686198] = 2,
    ACTIONS(18987), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [686206] = 2,
    ACTIONS(18987), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [686214] = 2,
    ACTIONS(18989), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [686222] = 2,
    ACTIONS(18989), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [686230] = 2,
    ACTIONS(18989), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [686238] = 2,
    ACTIONS(18989), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [686246] = 2,
    ACTIONS(18991), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [686254] = 2,
    ACTIONS(18993), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [686262] = 2,
    ACTIONS(17893), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [686270] = 2,
    ACTIONS(17889), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [686278] = 2,
    ACTIONS(18995), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [686286] = 2,
    ACTIONS(18997), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [686294] = 2,
    ACTIONS(18995), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [686302] = 2,
    ACTIONS(18995), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [686310] = 2,
    ACTIONS(18995), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [686318] = 2,
    ACTIONS(18999), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [686326] = 2,
    ACTIONS(19001), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [686334] = 2,
    ACTIONS(19003), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [686342] = 2,
    ACTIONS(18975), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [686350] = 2,
    ACTIONS(18975), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [686358] = 2,
    ACTIONS(18975), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [686366] = 2,
    ACTIONS(17863), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [686374] = 2,
    ACTIONS(19005), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [686382] = 2,
    ACTIONS(19007), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [686390] = 2,
    ACTIONS(19009), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [686398] = 2,
    ACTIONS(19011), 1,
      anon_sym_u2988,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [686406] = 2,
    ACTIONS(19011), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [686414] = 2,
    ACTIONS(19013), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [686422] = 2,
    ACTIONS(19011), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [686430] = 2,
    ACTIONS(19011), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [686438] = 2,
    ACTIONS(19015), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [686446] = 2,
    ACTIONS(19017), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [686454] = 2,
    ACTIONS(19017), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [686462] = 2,
    ACTIONS(19019), 1,
      anon_sym_in,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [686470] = 2,
    ACTIONS(19021), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [686478] = 2,
    ACTIONS(19023), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [686486] = 2,
    ACTIONS(19025), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [686494] = 2,
    ACTIONS(19027), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [686502] = 2,
    ACTIONS(19027), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [686510] = 2,
    ACTIONS(19027), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [686518] = 2,
    ACTIONS(19027), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [686526] = 2,
    ACTIONS(19029), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [686534] = 2,
    ACTIONS(19017), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [686542] = 2,
    ACTIONS(19031), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [686550] = 2,
    ACTIONS(19029), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [686558] = 2,
    ACTIONS(19029), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [686566] = 2,
    ACTIONS(19033), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [686574] = 2,
    ACTIONS(19029), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [686582] = 2,
    ACTIONS(19017), 1,
      anon_sym_u2988,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [686590] = 2,
    ACTIONS(19035), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [686598] = 2,
    ACTIONS(19037), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [686606] = 2,
    ACTIONS(17835), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [686614] = 2,
    ACTIONS(19039), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [686622] = 2,
    ACTIONS(19041), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [686630] = 2,
    ACTIONS(19043), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [686638] = 2,
    ACTIONS(19045), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [686646] = 2,
    ACTIONS(19047), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [686654] = 2,
    ACTIONS(17819), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [686662] = 2,
    ACTIONS(19049), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [686670] = 2,
    ACTIONS(17809), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [686678] = 2,
    ACTIONS(19051), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [686686] = 2,
    ACTIONS(19053), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [686694] = 2,
    ACTIONS(19055), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [686702] = 2,
    ACTIONS(19057), 1,
      anon_sym_u2988,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [686710] = 2,
    ACTIONS(19057), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [686718] = 2,
    ACTIONS(18955), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [686726] = 2,
    ACTIONS(19059), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [686734] = 2,
    ACTIONS(19059), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [686742] = 2,
    ACTIONS(19061), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [686750] = 2,
    ACTIONS(19057), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [686758] = 2,
    ACTIONS(19057), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [686766] = 2,
    ACTIONS(19063), 1,
      anon_sym_u2988,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [686774] = 2,
    ACTIONS(19059), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [686782] = 2,
    ACTIONS(19065), 1,
      anon_sym_in,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [686790] = 2,
    ACTIONS(19059), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [686798] = 2,
    ACTIONS(19067), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [686806] = 2,
    ACTIONS(19067), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [686814] = 2,
    ACTIONS(19067), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [686822] = 2,
    ACTIONS(19067), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [686830] = 2,
    ACTIONS(19069), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [686838] = 2,
    ACTIONS(19069), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [686846] = 2,
    ACTIONS(19069), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [686854] = 2,
    ACTIONS(19069), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [686862] = 2,
    ACTIONS(19071), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [686870] = 2,
    ACTIONS(19071), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [686878] = 2,
    ACTIONS(19071), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [686886] = 2,
    ACTIONS(19073), 1,
      anon_sym_in,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [686894] = 2,
    ACTIONS(19071), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [686902] = 2,
    ACTIONS(19075), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [686910] = 2,
    ACTIONS(19077), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [686918] = 2,
    ACTIONS(17751), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [686926] = 2,
    ACTIONS(19077), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [686934] = 2,
    ACTIONS(19079), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [686942] = 2,
    ACTIONS(19081), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [686950] = 2,
    ACTIONS(19083), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [686958] = 2,
    ACTIONS(19085), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [686966] = 2,
    ACTIONS(19087), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [686974] = 2,
    ACTIONS(19089), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [686982] = 2,
    ACTIONS(19091), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [686990] = 2,
    ACTIONS(19093), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [686998] = 2,
    ACTIONS(19095), 1,
      anon_sym_u2988,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [687006] = 2,
    ACTIONS(17731), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [687014] = 2,
    ACTIONS(19097), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [687022] = 2,
    ACTIONS(19099), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [687030] = 2,
    ACTIONS(19095), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [687038] = 2,
    ACTIONS(19101), 1,
      anon_sym_u2988,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [687046] = 2,
    ACTIONS(19101), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [687054] = 2,
    ACTIONS(19103), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [687062] = 2,
    ACTIONS(19101), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [687070] = 2,
    ACTIONS(19101), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [687078] = 2,
    ACTIONS(19105), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [687086] = 2,
    ACTIONS(19107), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [687094] = 2,
    ACTIONS(19095), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [687102] = 2,
    ACTIONS(19109), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [687110] = 2,
    ACTIONS(19109), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [687118] = 2,
    ACTIONS(19109), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [687126] = 2,
    ACTIONS(19109), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [687134] = 2,
    ACTIONS(19111), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [687142] = 2,
    ACTIONS(19095), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [687150] = 2,
    ACTIONS(19113), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [687158] = 2,
    ACTIONS(19115), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [687166] = 2,
    ACTIONS(19111), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [687174] = 2,
    ACTIONS(19111), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [687182] = 2,
    ACTIONS(19111), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [687190] = 2,
    ACTIONS(19077), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [687198] = 2,
    ACTIONS(19077), 1,
      anon_sym_u2988,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [687206] = 2,
    ACTIONS(19117), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [687214] = 2,
    ACTIONS(19119), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [687222] = 2,
    ACTIONS(17699), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [687230] = 2,
    ACTIONS(19121), 1,
      anon_sym_u2988,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [687238] = 2,
    ACTIONS(19123), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [687246] = 2,
    ACTIONS(19125), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [687254] = 2,
    ACTIONS(19121), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [687262] = 2,
    ACTIONS(19127), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [687270] = 2,
    ACTIONS(19121), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [687278] = 2,
    ACTIONS(19121), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [687286] = 2,
    ACTIONS(17687), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [687294] = 2,
    ACTIONS(19129), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [687302] = 2,
    ACTIONS(19131), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [687310] = 2,
    ACTIONS(19133), 1,
      anon_sym_in,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [687318] = 2,
    ACTIONS(19135), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [687326] = 2,
    ACTIONS(19137), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [687334] = 2,
    ACTIONS(19139), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [687342] = 2,
    ACTIONS(17647), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [687350] = 2,
    ACTIONS(19141), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [687358] = 2,
    ACTIONS(19063), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [687366] = 2,
    ACTIONS(19143), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [687374] = 2,
    ACTIONS(19063), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [687382] = 2,
    ACTIONS(19145), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [687390] = 2,
    ACTIONS(19147), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [687398] = 2,
    ACTIONS(19063), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [687406] = 2,
    ACTIONS(19149), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [687414] = 2,
    ACTIONS(19151), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [687422] = 2,
    ACTIONS(19153), 1,
      anon_sym_u2988,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [687430] = 2,
    ACTIONS(19153), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [687438] = 2,
    ACTIONS(19155), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [687446] = 2,
    ACTIONS(19155), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [687454] = 2,
    ACTIONS(19155), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [687462] = 2,
    ACTIONS(19155), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [687470] = 2,
    ACTIONS(19157), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [687478] = 2,
    ACTIONS(19157), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [687486] = 2,
    ACTIONS(19157), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [687494] = 2,
    ACTIONS(19157), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [687502] = 2,
    ACTIONS(19159), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [687510] = 2,
    ACTIONS(19153), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [687518] = 2,
    ACTIONS(19153), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [687526] = 2,
    ACTIONS(17653), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [687534] = 2,
    ACTIONS(19161), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [687542] = 2,
    ACTIONS(19163), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [687550] = 2,
    ACTIONS(19165), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [687558] = 2,
    ACTIONS(19167), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [687566] = 2,
    ACTIONS(19169), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [687574] = 2,
    ACTIONS(17605), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [687582] = 2,
    ACTIONS(19171), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [687590] = 2,
    ACTIONS(19173), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [687598] = 2,
    ACTIONS(19175), 1,
      anon_sym_u2988,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [687606] = 2,
    ACTIONS(19175), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [687614] = 2,
    ACTIONS(17621), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [687622] = 2,
    ACTIONS(19177), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [687630] = 2,
    ACTIONS(19179), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [687638] = 2,
    ACTIONS(19181), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [687646] = 2,
    ACTIONS(19175), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [687654] = 2,
    ACTIONS(19183), 1,
      anon_sym_u2988,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [687662] = 2,
    ACTIONS(19183), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [687670] = 2,
    ACTIONS(19185), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [687678] = 2,
    ACTIONS(19183), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [687686] = 2,
    ACTIONS(19183), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [687694] = 2,
    ACTIONS(19187), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [687702] = 2,
    ACTIONS(19175), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [687710] = 2,
    ACTIONS(19189), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [687718] = 2,
    ACTIONS(19191), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [687726] = 2,
    ACTIONS(19193), 1,
      anon_sym_in,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [687734] = 2,
    ACTIONS(19195), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [687742] = 2,
    ACTIONS(19191), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [687750] = 2,
    ACTIONS(19195), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [687758] = 2,
    ACTIONS(19195), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [687766] = 2,
    ACTIONS(19195), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [687774] = 2,
    ACTIONS(19197), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [687782] = 2,
    ACTIONS(19197), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [687790] = 2,
    ACTIONS(19197), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [687798] = 2,
    ACTIONS(19199), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [687806] = 2,
    ACTIONS(19201), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [687814] = 2,
    ACTIONS(19197), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [687822] = 2,
    ACTIONS(19203), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [687830] = 2,
    ACTIONS(19205), 1,
      anon_sym_u2988,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [687838] = 2,
    ACTIONS(19205), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [687846] = 2,
    ACTIONS(19207), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [687854] = 2,
    ACTIONS(17583), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [687862] = 2,
    ACTIONS(19205), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [687870] = 2,
    ACTIONS(19209), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [687878] = 2,
    ACTIONS(19211), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [687886] = 2,
    ACTIONS(19205), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [687894] = 2,
    ACTIONS(19213), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [687902] = 2,
    ACTIONS(17799), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [687910] = 2,
    ACTIONS(19191), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [687918] = 2,
    ACTIONS(17569), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [687926] = 2,
    ACTIONS(19215), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [687934] = 2,
    ACTIONS(19217), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [687942] = 2,
    ACTIONS(19219), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [687950] = 2,
    ACTIONS(19221), 1,
      anon_sym_u2988,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [687958] = 2,
    ACTIONS(19221), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [687966] = 2,
    ACTIONS(19223), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [687974] = 2,
    ACTIONS(19221), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [687982] = 2,
    ACTIONS(19219), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [687990] = 2,
    ACTIONS(19221), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [687998] = 2,
    ACTIONS(19225), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [688006] = 2,
    ACTIONS(19219), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [688014] = 2,
    ACTIONS(19227), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [688022] = 2,
    ACTIONS(19229), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [688030] = 2,
    ACTIONS(19229), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [688038] = 2,
    ACTIONS(19229), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [688046] = 2,
    ACTIONS(19229), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [688054] = 2,
    ACTIONS(19231), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [688062] = 2,
    ACTIONS(19231), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [688070] = 2,
    ACTIONS(19231), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [688078] = 2,
    ACTIONS(19231), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [688086] = 2,
    ACTIONS(19233), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [688094] = 2,
    ACTIONS(19235), 1,
      anon_sym_u2988,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [688102] = 2,
    ACTIONS(19235), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [688110] = 2,
    ACTIONS(19237), 1,
      anon_sym_in,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [688118] = 2,
    ACTIONS(19239), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [688126] = 2,
    ACTIONS(19235), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [688134] = 2,
    ACTIONS(17547), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [688142] = 2,
    ACTIONS(19235), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [688150] = 2,
    ACTIONS(19241), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [688158] = 2,
    ACTIONS(19243), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [688166] = 2,
    ACTIONS(19245), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [688174] = 2,
    ACTIONS(19219), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [688182] = 2,
    ACTIONS(19247), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [688190] = 2,
    ACTIONS(19249), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [688198] = 2,
    ACTIONS(19191), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [688206] = 2,
    ACTIONS(19251), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [688214] = 2,
    ACTIONS(19253), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [688222] = 2,
    ACTIONS(17521), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [688230] = 2,
    ACTIONS(19255), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [688238] = 2,
    ACTIONS(19257), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [688246] = 2,
    ACTIONS(19167), 1,
      anon_sym_u2988,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [688254] = 2,
    ACTIONS(19259), 1,
      anon_sym_u2988,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [688262] = 2,
    ACTIONS(19259), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [688270] = 2,
    ACTIONS(19261), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [688278] = 2,
    ACTIONS(19259), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [688286] = 2,
    ACTIONS(19259), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [688294] = 2,
    ACTIONS(19263), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [688302] = 2,
    ACTIONS(19167), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [688310] = 2,
    ACTIONS(19265), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [688318] = 2,
    ACTIONS(19267), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [688326] = 2,
    ACTIONS(19267), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [688334] = 2,
    ACTIONS(19267), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [688342] = 2,
    ACTIONS(19267), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [688350] = 2,
    ACTIONS(19225), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [688358] = 2,
    ACTIONS(19225), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [688366] = 2,
    ACTIONS(19167), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [688374] = 2,
    ACTIONS(19269), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [688382] = 2,
    ACTIONS(19225), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [688390] = 2,
    ACTIONS(19271), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [688398] = 2,
    ACTIONS(19273), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [688406] = 2,
    ACTIONS(19275), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [688414] = 2,
    ACTIONS(17499), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [688422] = 2,
    ACTIONS(19277), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [688430] = 2,
    ACTIONS(19279), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [688438] = 2,
    ACTIONS(19281), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [688446] = 2,
    ACTIONS(19275), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [688454] = 2,
    ACTIONS(19275), 1,
      anon_sym_u2988,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [688462] = 2,
    ACTIONS(19283), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [688470] = 2,
    ACTIONS(19285), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [688478] = 2,
    ACTIONS(17479), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [688486] = 2,
    ACTIONS(19287), 1,
      anon_sym_u2988,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [688494] = 2,
    ACTIONS(19289), 1,
      anon_sym_in,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [688502] = 2,
    ACTIONS(19291), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [688510] = 2,
    ACTIONS(19287), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [688518] = 2,
    ACTIONS(19293), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [688526] = 2,
    ACTIONS(19295), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [688534] = 2,
    ACTIONS(19297), 1,
      anon_sym_u2988,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [688542] = 2,
    ACTIONS(19297), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [688550] = 2,
    ACTIONS(19299), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [688558] = 2,
    ACTIONS(19297), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [688566] = 2,
    ACTIONS(19287), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [688574] = 2,
    ACTIONS(19301), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [688582] = 2,
    ACTIONS(19297), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [688590] = 2,
    ACTIONS(19303), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [688598] = 2,
    ACTIONS(19287), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [688606] = 2,
    ACTIONS(19305), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [688614] = 2,
    ACTIONS(19307), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [688622] = 2,
    ACTIONS(19309), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [688630] = 2,
    ACTIONS(19309), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [688638] = 2,
    ACTIONS(19309), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [688646] = 2,
    ACTIONS(19309), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [688654] = 2,
    ACTIONS(19311), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [688662] = 2,
    ACTIONS(19311), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [688670] = 2,
    ACTIONS(19311), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [688678] = 2,
    ACTIONS(19311), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [688686] = 2,
    ACTIONS(19313), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [688694] = 2,
    ACTIONS(17425), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [688702] = 2,
    ACTIONS(19315), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [688710] = 2,
    ACTIONS(17445), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [688718] = 2,
    ACTIONS(19317), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [688726] = 2,
    ACTIONS(19319), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [688734] = 2,
    ACTIONS(19321), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [688742] = 2,
    ACTIONS(19323), 1,
      anon_sym_u2988,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [688750] = 2,
    ACTIONS(19323), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [688758] = 2,
    ACTIONS(19325), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [688766] = 2,
    ACTIONS(19323), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [688774] = 2,
    ACTIONS(19323), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [688782] = 2,
    ACTIONS(17431), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [688790] = 2,
    ACTIONS(19327), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [688798] = 2,
    ACTIONS(19329), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [688806] = 2,
    ACTIONS(19331), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [688814] = 2,
    ACTIONS(19333), 1,
      anon_sym_u2988,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [688822] = 2,
    ACTIONS(19333), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [688830] = 2,
    ACTIONS(19335), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [688838] = 2,
    ACTIONS(19333), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [688846] = 2,
    ACTIONS(19333), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [688854] = 2,
    ACTIONS(19337), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [688862] = 2,
    ACTIONS(19339), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [688870] = 2,
    ACTIONS(19341), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [688878] = 2,
    ACTIONS(19343), 1,
      anon_sym_in,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [688886] = 2,
    ACTIONS(17405), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [688894] = 2,
    ACTIONS(19345), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [688902] = 2,
    ACTIONS(19347), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [688910] = 2,
    ACTIONS(19347), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [688918] = 2,
    ACTIONS(19347), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [688926] = 2,
    ACTIONS(19347), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [688934] = 2,
    ACTIONS(19349), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [688942] = 2,
    ACTIONS(19349), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [688950] = 2,
    ACTIONS(19351), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [688958] = 2,
    ACTIONS(19353), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [688966] = 2,
    ACTIONS(19349), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [688974] = 2,
    ACTIONS(19349), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [688982] = 2,
    ACTIONS(19355), 1,
      anon_sym_u2988,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [688990] = 2,
    ACTIONS(19355), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [688998] = 2,
    ACTIONS(19357), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [689006] = 2,
    ACTIONS(19355), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [689014] = 2,
    ACTIONS(17413), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [689022] = 2,
    ACTIONS(19355), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [689030] = 2,
    ACTIONS(19359), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [689038] = 2,
    ACTIONS(19361), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [689046] = 2,
    ACTIONS(19363), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [689054] = 2,
    ACTIONS(19365), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [689062] = 2,
    ACTIONS(19365), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [689070] = 2,
    ACTIONS(19367), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [689078] = 2,
    ACTIONS(17397), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [689086] = 2,
    ACTIONS(19369), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [689094] = 2,
    ACTIONS(19371), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [689102] = 2,
    ACTIONS(19373), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [689110] = 2,
    ACTIONS(19303), 1,
      anon_sym_u2988,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [689118] = 2,
    ACTIONS(19303), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [689126] = 2,
    ACTIONS(19375), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [689134] = 2,
    ACTIONS(19377), 1,
      anon_sym_u2988,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [689142] = 2,
    ACTIONS(19303), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [689150] = 2,
    ACTIONS(19379), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [689158] = 2,
    ACTIONS(19381), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [689166] = 2,
    ACTIONS(19377), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [689174] = 2,
    ACTIONS(19383), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [689182] = 2,
    ACTIONS(19385), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [689190] = 2,
    ACTIONS(19385), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [689198] = 2,
    ACTIONS(19385), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [689206] = 2,
    ACTIONS(19385), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [689214] = 2,
    ACTIONS(19387), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [689222] = 2,
    ACTIONS(19387), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [689230] = 2,
    ACTIONS(19387), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [689238] = 2,
    ACTIONS(19387), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [689246] = 2,
    ACTIONS(19377), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [689254] = 2,
    ACTIONS(19377), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [689262] = 2,
    ACTIONS(19389), 1,
      anon_sym_in,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [689270] = 2,
    ACTIONS(19391), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [689278] = 2,
    ACTIONS(19365), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [689286] = 2,
    ACTIONS(19365), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [689294] = 2,
    ACTIONS(17373), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [689302] = 2,
    ACTIONS(19393), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [689310] = 2,
    ACTIONS(19395), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [689318] = 2,
    ACTIONS(19397), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [689326] = 2,
    ACTIONS(19393), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [689334] = 2,
    ACTIONS(19393), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [689342] = 2,
    ACTIONS(19399), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [689350] = 2,
    ACTIONS(19401), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [689358] = 2,
    ACTIONS(19403), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [689366] = 2,
    ACTIONS(19405), 1,
      anon_sym_u2988,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [689374] = 2,
    ACTIONS(19405), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [689382] = 2,
    ACTIONS(17377), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [689390] = 2,
    ACTIONS(19407), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [689398] = 2,
    ACTIONS(19409), 1,
      anon_sym_u2988,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [689406] = 2,
    ACTIONS(19411), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [689414] = 2,
    ACTIONS(19413), 1,
      anon_sym_u2988,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [689422] = 2,
    ACTIONS(19413), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [689430] = 2,
    ACTIONS(19415), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [689438] = 2,
    ACTIONS(19413), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [689446] = 2,
    ACTIONS(19413), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [689454] = 2,
    ACTIONS(19417), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [689462] = 2,
    ACTIONS(19405), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [689470] = 2,
    ACTIONS(19405), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [689478] = 2,
    ACTIONS(19419), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [689486] = 2,
    ACTIONS(19419), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [689494] = 2,
    ACTIONS(19419), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [689502] = 2,
    ACTIONS(19419), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [689510] = 2,
    ACTIONS(19421), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [689518] = 2,
    ACTIONS(19423), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [689526] = 2,
    ACTIONS(19421), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [689534] = 2,
    ACTIONS(19421), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [689542] = 2,
    ACTIONS(19421), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [689550] = 2,
    ACTIONS(19393), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [689558] = 2,
    ACTIONS(19425), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [689566] = 2,
    ACTIONS(19427), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [689574] = 2,
    ACTIONS(17463), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [689582] = 2,
    ACTIONS(19429), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [689590] = 2,
    ACTIONS(19431), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [689598] = 2,
    ACTIONS(19433), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [689606] = 2,
    ACTIONS(19435), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [689614] = 2,
    ACTIONS(19437), 1,
      anon_sym_in,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [689622] = 2,
    ACTIONS(19439), 1,
      anon_sym_u2988,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [689630] = 2,
    ACTIONS(19439), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [689638] = 2,
    ACTIONS(19441), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [689646] = 2,
    ACTIONS(19439), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [689654] = 2,
    ACTIONS(19439), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [689662] = 2,
    ACTIONS(17485), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [689670] = 2,
    ACTIONS(19443), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [689678] = 2,
    ACTIONS(19445), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [689686] = 2,
    ACTIONS(19447), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [689694] = 2,
    ACTIONS(19449), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [689702] = 2,
    ACTIONS(19427), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [689710] = 2,
    ACTIONS(19451), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [689718] = 2,
    ACTIONS(17629), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [689726] = 2,
    ACTIONS(19409), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [689734] = 2,
    ACTIONS(19453), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [689742] = 2,
    ACTIONS(19409), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [689750] = 2,
    ACTIONS(19409), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [689758] = 2,
    ACTIONS(19455), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [689766] = 2,
    ACTIONS(19427), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [689774] = 2,
    ACTIONS(19427), 1,
      anon_sym_u2988,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [689782] = 2,
    ACTIONS(19457), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [689790] = 2,
    ACTIONS(19457), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [689798] = 2,
    ACTIONS(19457), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [689806] = 2,
    ACTIONS(19457), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [689814] = 2,
    ACTIONS(19459), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [689822] = 2,
    ACTIONS(19459), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [689830] = 2,
    ACTIONS(19459), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [689838] = 2,
    ACTIONS(19459), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [689846] = 2,
    ACTIONS(19461), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [689854] = 2,
    ACTIONS(19463), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [689862] = 2,
    ACTIONS(19465), 1,
      anon_sym_u2988,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [689870] = 2,
    ACTIONS(19465), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [689878] = 2,
    ACTIONS(17517), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [689886] = 2,
    ACTIONS(19467), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [689894] = 2,
    ACTIONS(19469), 1,
      anon_sym_in,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [689902] = 2,
    ACTIONS(19465), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [689910] = 2,
    ACTIONS(19465), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [689918] = 2,
    ACTIONS(19471), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [689926] = 2,
    ACTIONS(19473), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [689934] = 2,
    ACTIONS(19475), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [689942] = 2,
    ACTIONS(19477), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [689950] = 2,
    ACTIONS(19479), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [689958] = 2,
    ACTIONS(19481), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [689966] = 2,
    ACTIONS(17551), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [689974] = 2,
    ACTIONS(19483), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [689982] = 2,
    ACTIONS(19485), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [689990] = 2,
    ACTIONS(17541), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [689998] = 2,
    ACTIONS(19487), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [690006] = 2,
    ACTIONS(19489), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [690014] = 2,
    ACTIONS(19491), 1,
      anon_sym_u2988,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [690022] = 2,
    ACTIONS(19493), 1,
      anon_sym_u2988,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [690030] = 2,
    ACTIONS(19493), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [690038] = 2,
    ACTIONS(19495), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [690046] = 2,
    ACTIONS(19493), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [690054] = 2,
    ACTIONS(19493), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [690062] = 2,
    ACTIONS(19497), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [690070] = 2,
    ACTIONS(19491), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [690078] = 2,
    ACTIONS(19499), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [690086] = 2,
    ACTIONS(19501), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [690094] = 2,
    ACTIONS(19501), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [690102] = 2,
    ACTIONS(19501), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [690110] = 2,
    ACTIONS(19501), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [690118] = 2,
    ACTIONS(19503), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [690126] = 2,
    ACTIONS(19503), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [690134] = 2,
    ACTIONS(19491), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [690142] = 2,
    ACTIONS(19503), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [690150] = 2,
    ACTIONS(19503), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [690158] = 2,
    ACTIONS(19491), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [690166] = 2,
    ACTIONS(19505), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [690174] = 2,
    ACTIONS(19507), 1,
      anon_sym_in,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [690182] = 2,
    ACTIONS(19509), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [690190] = 2,
    ACTIONS(19511), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [690198] = 2,
    ACTIONS(19275), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [690206] = 2,
    ACTIONS(17595), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [690214] = 2,
    ACTIONS(19513), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [690222] = 2,
    ACTIONS(19515), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [690230] = 2,
    ACTIONS(19517), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [690238] = 2,
    ACTIONS(19519), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [690246] = 2,
    ACTIONS(19521), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [690254] = 2,
    ACTIONS(19523), 1,
      anon_sym_u2988,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [690262] = 2,
    ACTIONS(19523), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [690270] = 2,
    ACTIONS(19525), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [690278] = 2,
    ACTIONS(19523), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [690286] = 2,
    ACTIONS(19523), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [690294] = 2,
    ACTIONS(19527), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [690302] = 2,
    ACTIONS(19529), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [690310] = 2,
    ACTIONS(19531), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [690318] = 2,
    ACTIONS(19533), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [690326] = 2,
    ACTIONS(19535), 1,
      anon_sym_u2988,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [690334] = 2,
    ACTIONS(19535), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [690342] = 2,
    ACTIONS(19537), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [690350] = 2,
    ACTIONS(19535), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [690358] = 2,
    ACTIONS(19535), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [690366] = 2,
    ACTIONS(19539), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [690374] = 2,
    ACTIONS(19541), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [690382] = 2,
    ACTIONS(19541), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [690390] = 2,
    ACTIONS(19527), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [690398] = 2,
    ACTIONS(19527), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [690406] = 2,
    ACTIONS(19527), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [690414] = 2,
    ACTIONS(19543), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [690422] = 2,
    ACTIONS(17495), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [690430] = 2,
    ACTIONS(19545), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [690438] = 2,
    ACTIONS(19545), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [690446] = 2,
    ACTIONS(17871), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [690454] = 2,
    ACTIONS(19547), 1,
      anon_sym_in,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [690462] = 2,
    ACTIONS(19545), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [690470] = 2,
    ACTIONS(19545), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [690478] = 2,
    ACTIONS(19549), 1,
      anon_sym_u2988,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [690486] = 2,
    ACTIONS(19549), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [690494] = 2,
    ACTIONS(19551), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [690502] = 2,
    ACTIONS(19553), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [690510] = 2,
    ACTIONS(17677), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [690518] = 2,
    ACTIONS(19549), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [690526] = 2,
    ACTIONS(19555), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [690534] = 2,
    ACTIONS(19557), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [690542] = 2,
    ACTIONS(19549), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [690550] = 2,
    ACTIONS(19559), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [690558] = 2,
    ACTIONS(19541), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [690566] = 2,
    ACTIONS(19541), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [690574] = 2,
    ACTIONS(17705), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [690582] = 2,
    ACTIONS(19561), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [690590] = 2,
    ACTIONS(19563), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [690598] = 2,
    ACTIONS(19565), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [690606] = 2,
    ACTIONS(19567), 1,
      anon_sym_u2988,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [690614] = 2,
    ACTIONS(19567), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [690622] = 2,
    ACTIONS(19569), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [690630] = 2,
    ACTIONS(19567), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [690638] = 2,
    ACTIONS(19567), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [690646] = 2,
    ACTIONS(19571), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [690654] = 2,
    ACTIONS(19565), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [690662] = 2,
    ACTIONS(19565), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [690670] = 2,
    ACTIONS(19573), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [690678] = 2,
    ACTIONS(19573), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [690686] = 2,
    ACTIONS(19575), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [690694] = 2,
    ACTIONS(19577), 1,
      anon_sym_in,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [690702] = 2,
    ACTIONS(19573), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [690710] = 2,
    ACTIONS(19579), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [690718] = 2,
    ACTIONS(19573), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [690726] = 2,
    ACTIONS(19581), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [690734] = 2,
    ACTIONS(19581), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [690742] = 2,
    ACTIONS(19581), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [690750] = 2,
    ACTIONS(19581), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [690758] = 2,
    ACTIONS(19583), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [690766] = 2,
    ACTIONS(19585), 1,
      anon_sym_u2988,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [690774] = 2,
    ACTIONS(19585), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [690782] = 2,
    ACTIONS(17721), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [690790] = 2,
    ACTIONS(19587), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [690798] = 2,
    ACTIONS(19589), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [690806] = 2,
    ACTIONS(19591), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [690814] = 2,
    ACTIONS(19585), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [690822] = 2,
    ACTIONS(19585), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [690830] = 2,
    ACTIONS(19593), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [690838] = 2,
    ACTIONS(19565), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [690846] = 2,
    ACTIONS(19595), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [690854] = 2,
    ACTIONS(19597), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [690862] = 2,
    ACTIONS(19599), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [690870] = 2,
    ACTIONS(19601), 1,
      anon_sym_in,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [690878] = 2,
    ACTIONS(19603), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [690886] = 2,
    ACTIONS(19605), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [690894] = 2,
    ACTIONS(19607), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [690902] = 2,
    ACTIONS(19609), 1,
      anon_sym_u2988,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [690910] = 2,
    ACTIONS(19609), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [690918] = 2,
    ACTIONS(19611), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [690926] = 2,
    ACTIONS(19609), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [690934] = 2,
    ACTIONS(19609), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [690942] = 2,
    ACTIONS(19613), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [690950] = 2,
    ACTIONS(19615), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [690958] = 2,
    ACTIONS(19617), 1,
      anon_sym_u2988,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [690966] = 2,
    ACTIONS(19619), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [690974] = 2,
    ACTIONS(19619), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [690982] = 2,
    ACTIONS(19619), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [690990] = 2,
    ACTIONS(19619), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [690998] = 2,
    ACTIONS(19621), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [691006] = 2,
    ACTIONS(19621), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [691014] = 2,
    ACTIONS(19621), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [691022] = 2,
    ACTIONS(19621), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [691030] = 2,
    ACTIONS(19617), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [691038] = 2,
    ACTIONS(19623), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [691046] = 2,
    ACTIONS(19625), 1,
      anon_sym_in,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [691054] = 2,
    ACTIONS(19617), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [691062] = 2,
    ACTIONS(19627), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [691070] = 2,
    ACTIONS(19617), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [691078] = 2,
    ACTIONS(17783), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [691086] = 2,
    ACTIONS(19629), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [691094] = 2,
    ACTIONS(19631), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [691102] = 2,
    ACTIONS(19633), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [691110] = 2,
    ACTIONS(19599), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [691118] = 2,
    ACTIONS(19635), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [691126] = 2,
    ACTIONS(19599), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [691134] = 2,
    ACTIONS(19599), 1,
      anon_sym_u2988,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [691142] = 2,
    ACTIONS(17815), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [691150] = 2,
    ACTIONS(19637), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [691158] = 2,
    ACTIONS(19639), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [691166] = 2,
    ACTIONS(19641), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [691174] = 2,
    ACTIONS(19643), 1,
      anon_sym_u2988,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [691182] = 2,
    ACTIONS(19643), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [691190] = 2,
    ACTIONS(19645), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [691198] = 2,
    ACTIONS(19643), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [691206] = 2,
    ACTIONS(19643), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [691214] = 2,
    ACTIONS(19647), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [691222] = 2,
    ACTIONS(19649), 1,
      anon_sym_in,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [691230] = 2,
    ACTIONS(19651), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [691238] = 2,
    ACTIONS(19653), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [691246] = 2,
    ACTIONS(19655), 1,
      anon_sym_u2988,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [691254] = 2,
    ACTIONS(19655), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [691262] = 2,
    ACTIONS(19657), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [691270] = 2,
    ACTIONS(19657), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [691278] = 2,
    ACTIONS(19657), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [691286] = 2,
    ACTIONS(19657), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [691294] = 2,
    ACTIONS(19659), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [691302] = 2,
    ACTIONS(19659), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [691310] = 2,
    ACTIONS(19659), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [691318] = 2,
    ACTIONS(19659), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [691326] = 2,
    ACTIONS(19661), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [691334] = 2,
    ACTIONS(19655), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [691342] = 2,
    ACTIONS(19655), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [691350] = 2,
    ACTIONS(17851), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [691358] = 2,
    ACTIONS(19663), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [691366] = 2,
    ACTIONS(19665), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [691374] = 2,
    ACTIONS(19667), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [691382] = 2,
    ACTIONS(19669), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [691390] = 2,
    ACTIONS(19671), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [691398] = 2,
    ACTIONS(19673), 1,
      anon_sym_in,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [691406] = 2,
    ACTIONS(19675), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [691414] = 2,
    ACTIONS(19677), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [691422] = 2,
    ACTIONS(19679), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [691430] = 2,
    ACTIONS(19681), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [691438] = 2,
    ACTIONS(17867), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [691446] = 2,
    ACTIONS(19683), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [691454] = 2,
    ACTIONS(19685), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [691462] = 2,
    ACTIONS(19687), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [691470] = 2,
    ACTIONS(19689), 1,
      anon_sym_u2988,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [691478] = 2,
    ACTIONS(19689), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [691486] = 2,
    ACTIONS(19691), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [691494] = 2,
    ACTIONS(19689), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [691502] = 2,
    ACTIONS(19689), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [691510] = 2,
    ACTIONS(19693), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [691518] = 2,
    ACTIONS(19695), 1,
      anon_sym_u2988,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [691526] = 2,
    ACTIONS(19695), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [691534] = 2,
    ACTIONS(19697), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [691542] = 2,
    ACTIONS(19697), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [691550] = 2,
    ACTIONS(19697), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [691558] = 2,
    ACTIONS(19697), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [691566] = 2,
    ACTIONS(19699), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [691574] = 2,
    ACTIONS(19701), 1,
      anon_sym_in,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [691582] = 2,
    ACTIONS(19703), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [691590] = 2,
    ACTIONS(19705), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [691598] = 2,
    ACTIONS(19703), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [691606] = 2,
    ACTIONS(19703), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [691614] = 2,
    ACTIONS(19703), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [691622] = 2,
    ACTIONS(19695), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [691630] = 2,
    ACTIONS(19695), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [691638] = 2,
    ACTIONS(19707), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [691646] = 2,
    ACTIONS(17907), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [691654] = 2,
    ACTIONS(19709), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [691662] = 2,
    ACTIONS(19711), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [691670] = 2,
    ACTIONS(19713), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [691678] = 2,
    ACTIONS(19715), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [691686] = 2,
    ACTIONS(17947), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [691694] = 2,
    ACTIONS(19717), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [691702] = 2,
    ACTIONS(19719), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [691710] = 2,
    ACTIONS(17747), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [691718] = 2,
    ACTIONS(19721), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [691726] = 2,
    ACTIONS(19723), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [691734] = 2,
    ACTIONS(19725), 1,
      anon_sym_u2988,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [691742] = 2,
    ACTIONS(19725), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [691750] = 2,
    ACTIONS(19727), 1,
      anon_sym_in,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [691758] = 2,
    ACTIONS(19729), 1,
      anon_sym_u2988,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [691766] = 2,
    ACTIONS(19731), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [691774] = 2,
    ACTIONS(19729), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [691782] = 2,
    ACTIONS(19733), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [691790] = 2,
    ACTIONS(19729), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [691798] = 2,
    ACTIONS(19729), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [691806] = 2,
    ACTIONS(19735), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [691814] = 2,
    ACTIONS(19737), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [691822] = 2,
    ACTIONS(19725), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [691830] = 2,
    ACTIONS(19739), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [691838] = 2,
    ACTIONS(19739), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [691846] = 2,
    ACTIONS(19739), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [691854] = 2,
    ACTIONS(19739), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [691862] = 2,
    ACTIONS(19741), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [691870] = 2,
    ACTIONS(19741), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [691878] = 2,
    ACTIONS(19741), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [691886] = 2,
    ACTIONS(19741), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [691894] = 2,
    ACTIONS(19725), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [691902] = 2,
    ACTIONS(19743), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [691910] = 2,
    ACTIONS(19745), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [691918] = 2,
    ACTIONS(19745), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [691926] = 2,
    ACTIONS(19747), 1,
      anon_sym_in,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [691934] = 2,
    ACTIONS(17937), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [691942] = 2,
    ACTIONS(19749), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [691950] = 2,
    ACTIONS(19751), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [691958] = 2,
    ACTIONS(19753), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [691966] = 2,
    ACTIONS(19755), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [691974] = 2,
    ACTIONS(19757), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [691982] = 2,
    ACTIONS(19759), 1,
      anon_sym_u2988,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [691990] = 2,
    ACTIONS(19759), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [691998] = 2,
    ACTIONS(19761), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [692006] = 2,
    ACTIONS(17973), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [692014] = 2,
    ACTIONS(19763), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [692022] = 2,
    ACTIONS(19765), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [692030] = 2,
    ACTIONS(19759), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [692038] = 2,
    ACTIONS(19767), 1,
      anon_sym_u2988,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [692046] = 2,
    ACTIONS(19767), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [692054] = 2,
    ACTIONS(19769), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [692062] = 2,
    ACTIONS(19767), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [692070] = 2,
    ACTIONS(19767), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [692078] = 2,
    ACTIONS(19771), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [692086] = 2,
    ACTIONS(19759), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [692094] = 2,
    ACTIONS(19773), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [692102] = 2,
    ACTIONS(19775), 1,
      anon_sym_in,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [692110] = 2,
    ACTIONS(19745), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [692118] = 2,
    ACTIONS(19777), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [692126] = 2,
    ACTIONS(19779), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [692134] = 2,
    ACTIONS(19779), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [692142] = 2,
    ACTIONS(19779), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [692150] = 2,
    ACTIONS(19779), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [692158] = 2,
    ACTIONS(19781), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [692166] = 2,
    ACTIONS(19781), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [692174] = 2,
    ACTIONS(19781), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [692182] = 2,
    ACTIONS(19781), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [692190] = 2,
    ACTIONS(19745), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [692198] = 2,
    ACTIONS(17639), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [692206] = 2,
    ACTIONS(19783), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [692214] = 2,
    ACTIONS(17995), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [692222] = 2,
    ACTIONS(19783), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [692230] = 2,
    ACTIONS(19785), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [692238] = 2,
    ACTIONS(19787), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [692246] = 2,
    ACTIONS(19789), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [692254] = 2,
    ACTIONS(19791), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [692262] = 2,
    ACTIONS(19793), 1,
      anon_sym_u2988,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [692270] = 2,
    ACTIONS(19793), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [692278] = 2,
    ACTIONS(19795), 1,
      anon_sym_in,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [692286] = 2,
    ACTIONS(19797), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [692294] = 2,
    ACTIONS(19799), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [692302] = 2,
    ACTIONS(18029), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [692310] = 2,
    ACTIONS(19801), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [692318] = 2,
    ACTIONS(19803), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [692326] = 2,
    ACTIONS(19793), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [692334] = 2,
    ACTIONS(19805), 1,
      anon_sym_u2988,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [692342] = 2,
    ACTIONS(19805), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [692350] = 2,
    ACTIONS(19807), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [692358] = 2,
    ACTIONS(19805), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [692366] = 2,
    ACTIONS(19805), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [692374] = 2,
    ACTIONS(19809), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [692382] = 2,
    ACTIONS(19793), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [692390] = 2,
    ACTIONS(19811), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [692398] = 2,
    ACTIONS(19813), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [692406] = 2,
    ACTIONS(19813), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [692414] = 2,
    ACTIONS(19813), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [692422] = 2,
    ACTIONS(19813), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [692430] = 2,
    ACTIONS(19753), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [692438] = 2,
    ACTIONS(19753), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [692446] = 2,
    ACTIONS(19783), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [692454] = 2,
    ACTIONS(19815), 1,
      anon_sym_in,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [692462] = 2,
    ACTIONS(19753), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [692470] = 2,
    ACTIONS(19817), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [692478] = 2,
    ACTIONS(19819), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [692486] = 2,
    ACTIONS(19821), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [692494] = 2,
    ACTIONS(19823), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [692502] = 2,
    ACTIONS(19825), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [692510] = 2,
    ACTIONS(18085), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [692518] = 2,
    ACTIONS(19827), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [692526] = 2,
    ACTIONS(19829), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [692534] = 2,
    ACTIONS(19831), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [692542] = 2,
    ACTIONS(19833), 1,
      anon_sym_u2988,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [692550] = 2,
    ACTIONS(19833), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [692558] = 2,
    ACTIONS(19835), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [692566] = 2,
    ACTIONS(19833), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [692574] = 2,
    ACTIONS(18107), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [692582] = 2,
    ACTIONS(19837), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [692590] = 2,
    ACTIONS(19839), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [692598] = 2,
    ACTIONS(19833), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [692606] = 2,
    ACTIONS(19841), 1,
      anon_sym_u2988,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [692614] = 2,
    ACTIONS(19841), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [692622] = 2,
    ACTIONS(19843), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [692630] = 2,
    ACTIONS(19845), 1,
      anon_sym_in,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [692638] = 2,
    ACTIONS(19847), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [692646] = 2,
    ACTIONS(19849), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [692654] = 2,
    ACTIONS(19841), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [692662] = 2,
    ACTIONS(19841), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [692670] = 2,
    ACTIONS(19851), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [692678] = 2,
    ACTIONS(19821), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [692686] = 2,
    ACTIONS(19853), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [692694] = 2,
    ACTIONS(19855), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [692702] = 2,
    ACTIONS(19855), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [692710] = 2,
    ACTIONS(19855), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [692718] = 2,
    ACTIONS(19855), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [692726] = 2,
    ACTIONS(19857), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [692734] = 2,
    ACTIONS(19857), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [692742] = 2,
    ACTIONS(19857), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [692750] = 2,
    ACTIONS(19857), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [692758] = 2,
    ACTIONS(19821), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [692766] = 2,
    ACTIONS(19821), 1,
      anon_sym_u2988,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [692774] = 2,
    ACTIONS(19859), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [692782] = 2,
    ACTIONS(18129), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [692790] = 2,
    ACTIONS(19861), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [692798] = 2,
    ACTIONS(19863), 1,
      anon_sym_u2988,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [692806] = 2,
    ACTIONS(19865), 1,
      anon_sym_in,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [692814] = 2,
    ACTIONS(19867), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [692822] = 2,
    ACTIONS(19869), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [692830] = 2,
    ACTIONS(19871), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [692838] = 2,
    ACTIONS(19863), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [692846] = 2,
    ACTIONS(19873), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [692854] = 2,
    ACTIONS(19863), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [692862] = 2,
    ACTIONS(19863), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [692870] = 2,
    ACTIONS(18159), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [692878] = 2,
    ACTIONS(19875), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [692886] = 2,
    ACTIONS(19877), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [692894] = 2,
    ACTIONS(19879), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [692902] = 2,
    ACTIONS(19881), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [692910] = 2,
    ACTIONS(19883), 1,
      anon_sym_u2988,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [692918] = 2,
    ACTIONS(19883), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [692926] = 2,
    ACTIONS(19885), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [692934] = 2,
    ACTIONS(19883), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [692942] = 2,
    ACTIONS(19883), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [692950] = 2,
    ACTIONS(19887), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [692958] = 2,
    ACTIONS(19889), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [692966] = 2,
    ACTIONS(18181), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [692974] = 2,
    ACTIONS(19891), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [692982] = 2,
    ACTIONS(19893), 1,
      anon_sym_in,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [692990] = 2,
    ACTIONS(19895), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [692998] = 2,
    ACTIONS(19897), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [693006] = 2,
    ACTIONS(19899), 1,
      anon_sym_u2988,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [693014] = 2,
    ACTIONS(19823), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [693022] = 2,
    ACTIONS(19823), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [693030] = 2,
    ACTIONS(19823), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [693038] = 2,
    ACTIONS(19899), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [693046] = 2,
    ACTIONS(19901), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [693054] = 2,
    ACTIONS(19901), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [693062] = 2,
    ACTIONS(19901), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [693070] = 2,
    ACTIONS(19901), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [693078] = 2,
    ACTIONS(19903), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [693086] = 2,
    ACTIONS(19899), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [693094] = 2,
    ACTIONS(19899), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [693102] = 2,
    ACTIONS(18193), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [693110] = 2,
    ACTIONS(19905), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [693118] = 2,
    ACTIONS(19907), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [693126] = 2,
    ACTIONS(19909), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [693134] = 2,
    ACTIONS(19911), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [693142] = 2,
    ACTIONS(19913), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [693150] = 2,
    ACTIONS(18253), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [693158] = 2,
    ACTIONS(19915), 1,
      anon_sym_in,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [693166] = 2,
    ACTIONS(19917), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [693174] = 2,
    ACTIONS(19919), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [693182] = 2,
    ACTIONS(19921), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [693190] = 2,
    ACTIONS(19923), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [693198] = 2,
    ACTIONS(19925), 1,
      anon_sym_u2988,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [693206] = 2,
    ACTIONS(18225), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [693214] = 2,
    ACTIONS(19925), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [693222] = 2,
    ACTIONS(19927), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [693230] = 2,
    ACTIONS(19929), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [693238] = 2,
    ACTIONS(19931), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [693246] = 2,
    ACTIONS(19925), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [693254] = 2,
    ACTIONS(19933), 1,
      anon_sym_u2988,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [693262] = 2,
    ACTIONS(19933), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [693270] = 2,
    ACTIONS(19935), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [693278] = 2,
    ACTIONS(19933), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [693286] = 2,
    ACTIONS(19933), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [693294] = 2,
    ACTIONS(19937), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [693302] = 2,
    ACTIONS(19925), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [693310] = 2,
    ACTIONS(19939), 1,
      sym__newline,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [693318] = 2,
    ACTIONS(19941), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [693326] = 2,
    ACTIONS(19943), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [693334] = 2,
    ACTIONS(19945), 1,
      anon_sym_in,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [693342] = 2,
    ACTIONS(19943), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [693350] = 2,
    ACTIONS(19947), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [693358] = 2,
    ACTIONS(19949), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [693366] = 3,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(19951), 1,
      sym_id,
  [693376] = 2,
    ACTIONS(18605), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [693384] = 2,
    ACTIONS(18605), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [693392] = 2,
    ACTIONS(18631), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [693400] = 2,
    ACTIONS(18605), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [693408] = 2,
    ACTIONS(19953), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [693416] = 2,
    ACTIONS(19955), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [693424] = 2,
    ACTIONS(19955), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [693432] = 2,
    ACTIONS(19955), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [693440] = 2,
    ACTIONS(19955), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [693448] = 2,
    ACTIONS(19819), 1,
      anon_sym_u2988,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [693456] = 2,
    ACTIONS(17068), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [693464] = 2,
    ACTIONS(19819), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [693472] = 2,
    ACTIONS(19957), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [693480] = 2,
    ACTIONS(19959), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [693488] = 2,
    ACTIONS(19819), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [693496] = 2,
    ACTIONS(19961), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [693504] = 2,
    ACTIONS(19963), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [693512] = 2,
    ACTIONS(19965), 1,
      anon_sym_in,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [693520] = 2,
    ACTIONS(18189), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [693528] = 2,
    ACTIONS(19967), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [693536] = 2,
    ACTIONS(19943), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [693544] = 2,
    ACTIONS(19943), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [693552] = 2,
    ACTIONS(19969), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [693560] = 2,
    ACTIONS(19971), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [693568] = 2,
    ACTIONS(19969), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [693576] = 2,
    ACTIONS(19969), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [693584] = 2,
    ACTIONS(19973), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [693592] = 2,
    ACTIONS(19975), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [693600] = 2,
    ACTIONS(19977), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [693608] = 2,
    ACTIONS(18603), 1,
      anon_sym_u2988,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [693616] = 2,
    ACTIONS(18603), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [693624] = 2,
    ACTIONS(19979), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [693632] = 2,
    ACTIONS(19981), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [693640] = 2,
    ACTIONS(19983), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [693648] = 2,
    ACTIONS(18603), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [693656] = 2,
    ACTIONS(18285), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [693664] = 2,
    ACTIONS(19985), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [693672] = 2,
    ACTIONS(19987), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [693680] = 2,
    ACTIONS(19969), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [693688] = 2,
    ACTIONS(19989), 1,
      anon_sym_in,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [693696] = 2,
    ACTIONS(19991), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [693704] = 2,
    ACTIONS(19993), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [693712] = 2,
    ACTIONS(19995), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [693720] = 2,
    ACTIONS(19997), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [693728] = 2,
    ACTIONS(19999), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [693736] = 2,
    ACTIONS(20001), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [693744] = 2,
    ACTIONS(20003), 1,
      anon_sym_u2988,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [693752] = 2,
    ACTIONS(20003), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [693760] = 2,
    ACTIONS(20005), 1,
      anon_sym_u2988,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [693768] = 2,
    ACTIONS(20005), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [693776] = 2,
    ACTIONS(20007), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [693784] = 2,
    ACTIONS(20005), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [693792] = 2,
    ACTIONS(20005), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [693800] = 2,
    ACTIONS(20009), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [693808] = 2,
    ACTIONS(20011), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [693816] = 2,
    ACTIONS(20003), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [693824] = 2,
    ACTIONS(20013), 1,
      sym__newline,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [693832] = 2,
    ACTIONS(20003), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [693840] = 2,
    ACTIONS(20015), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [693848] = 2,
    ACTIONS(19997), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [693856] = 2,
    ACTIONS(20017), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [693864] = 2,
    ACTIONS(20019), 1,
      anon_sym_in,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [693872] = 2,
    ACTIONS(19997), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [693880] = 2,
    ACTIONS(20021), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [693888] = 2,
    ACTIONS(19997), 1,
      anon_sym_u2988,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [693896] = 2,
    ACTIONS(20023), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [693904] = 2,
    ACTIONS(20025), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [693912] = 2,
    ACTIONS(20027), 1,
      anon_sym_u2988,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [693920] = 2,
    ACTIONS(20027), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [693928] = 2,
    ACTIONS(20029), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [693936] = 2,
    ACTIONS(20027), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [693944] = 2,
    ACTIONS(20027), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [693952] = 2,
    ACTIONS(20031), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [693960] = 2,
    ACTIONS(20033), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [693968] = 2,
    ACTIONS(20035), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [693976] = 2,
    ACTIONS(18315), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [693984] = 2,
    ACTIONS(19783), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [693992] = 2,
    ACTIONS(20037), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [694000] = 2,
    ACTIONS(20039), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [694008] = 2,
    ACTIONS(20041), 1,
      anon_sym_u2988,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [694016] = 2,
    ACTIONS(20041), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [694024] = 2,
    ACTIONS(20043), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [694032] = 2,
    ACTIONS(20045), 1,
      anon_sym_in,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [694040] = 2,
    ACTIONS(20041), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [694048] = 2,
    ACTIONS(20047), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [694056] = 2,
    ACTIONS(20041), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [694064] = 2,
    ACTIONS(20049), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [694072] = 2,
    ACTIONS(20051), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [694080] = 2,
    ACTIONS(20053), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [694088] = 2,
    ACTIONS(18365), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [694096] = 2,
    ACTIONS(20055), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [694104] = 2,
    ACTIONS(20057), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [694112] = 2,
    ACTIONS(20059), 1,
      anon_sym_u2988,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [694120] = 2,
    ACTIONS(20059), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [694128] = 2,
    ACTIONS(20061), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [694136] = 2,
    ACTIONS(20059), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [694144] = 2,
    ACTIONS(20059), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [694152] = 2,
    ACTIONS(20063), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [694160] = 2,
    ACTIONS(20065), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [694168] = 2,
    ACTIONS(20065), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [694176] = 2,
    ACTIONS(20067), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [694184] = 2,
    ACTIONS(20069), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [694192] = 2,
    ACTIONS(20071), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [694200] = 2,
    ACTIONS(20073), 1,
      anon_sym_u2988,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [694208] = 2,
    ACTIONS(20073), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [694216] = 2,
    ACTIONS(20075), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [694224] = 2,
    ACTIONS(20073), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [694232] = 2,
    ACTIONS(20073), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [694240] = 2,
    ACTIONS(20077), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [694248] = 2,
    ACTIONS(20065), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [694256] = 2,
    ACTIONS(20065), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [694264] = 2,
    ACTIONS(20079), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [694272] = 2,
    ACTIONS(20079), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [694280] = 2,
    ACTIONS(20079), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [694288] = 2,
    ACTIONS(20081), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [694296] = 2,
    ACTIONS(20083), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [694304] = 2,
    ACTIONS(20085), 1,
      anon_sym_u2988,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [694312] = 2,
    ACTIONS(20085), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [694320] = 2,
    ACTIONS(20087), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [694328] = 2,
    ACTIONS(20089), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [694336] = 2,
    ACTIONS(20085), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [694344] = 2,
    ACTIONS(20085), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [694352] = 2,
    ACTIONS(20091), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [694360] = 2,
    ACTIONS(20079), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [694368] = 2,
    ACTIONS(20093), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [694376] = 2,
    ACTIONS(20095), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [694384] = 2,
    ACTIONS(20095), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [694392] = 2,
    ACTIONS(20097), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [694400] = 2,
    ACTIONS(20099), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [694408] = 2,
    ACTIONS(20101), 1,
      anon_sym_u2988,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [694416] = 2,
    ACTIONS(20101), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [694424] = 2,
    ACTIONS(20103), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [694432] = 2,
    ACTIONS(20101), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [694440] = 2,
    ACTIONS(20101), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [694448] = 2,
    ACTIONS(20105), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [694456] = 2,
    ACTIONS(20107), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [694464] = 2,
    ACTIONS(20109), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [694472] = 2,
    ACTIONS(20095), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [694480] = 2,
    ACTIONS(20095), 1,
      anon_sym_u2988,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [694488] = 2,
    ACTIONS(20111), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [694496] = 2,
    ACTIONS(20113), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [694504] = 2,
    ACTIONS(20115), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [694512] = 2,
    ACTIONS(20111), 1,
      anon_sym_u2988,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [694520] = 2,
    ACTIONS(20117), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [694528] = 2,
    ACTIONS(20119), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [694536] = 2,
    ACTIONS(20111), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [694544] = 2,
    ACTIONS(20111), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [694552] = 2,
    ACTIONS(20121), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [694560] = 2,
    ACTIONS(20123), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [694568] = 2,
    ACTIONS(18465), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [694576] = 2,
    ACTIONS(20125), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [694584] = 2,
    ACTIONS(20127), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [694592] = 2,
    ACTIONS(20129), 1,
      anon_sym_u2988,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [694600] = 2,
    ACTIONS(20131), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [694608] = 2,
    ACTIONS(20129), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [694616] = 2,
    ACTIONS(20133), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [694624] = 2,
    ACTIONS(20129), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [694632] = 2,
    ACTIONS(20129), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [694640] = 2,
    ACTIONS(20135), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [694648] = 2,
    ACTIONS(20137), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [694656] = 2,
    ACTIONS(20139), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [694664] = 2,
    ACTIONS(18491), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [694672] = 2,
    ACTIONS(20141), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [694680] = 2,
    ACTIONS(20143), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [694688] = 2,
    ACTIONS(6708), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [694696] = 2,
    ACTIONS(20145), 1,
      anon_sym_u2988,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [694704] = 2,
    ACTIONS(20145), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [694712] = 2,
    ACTIONS(20147), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [694720] = 2,
    ACTIONS(20145), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [694728] = 2,
    ACTIONS(20145), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [694736] = 2,
    ACTIONS(20149), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [694744] = 2,
    ACTIONS(20151), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [694752] = 2,
    ACTIONS(20153), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [694760] = 2,
    ACTIONS(20153), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [694768] = 2,
    ACTIONS(20153), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [694776] = 2,
    ACTIONS(20155), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [694784] = 2,
    ACTIONS(20157), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [694792] = 2,
    ACTIONS(20159), 1,
      anon_sym_u2988,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [694800] = 2,
    ACTIONS(20159), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [694808] = 2,
    ACTIONS(6645), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [694816] = 2,
    ACTIONS(20161), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [694824] = 2,
    ACTIONS(6431), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [694832] = 2,
    ACTIONS(20159), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [694840] = 2,
    ACTIONS(20159), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [694848] = 2,
    ACTIONS(20163), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [694856] = 2,
    ACTIONS(20153), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [694864] = 2,
    ACTIONS(20165), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [694872] = 2,
    ACTIONS(20167), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [694880] = 2,
    ACTIONS(20165), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [694888] = 2,
    ACTIONS(20165), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [694896] = 2,
    ACTIONS(20169), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [694904] = 2,
    ACTIONS(20171), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [694912] = 2,
    ACTIONS(20173), 1,
      anon_sym_u2988,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [694920] = 2,
    ACTIONS(20173), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [694928] = 2,
    ACTIONS(20175), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [694936] = 2,
    ACTIONS(20173), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [694944] = 2,
    ACTIONS(20173), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [694952] = 2,
    ACTIONS(20177), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [694960] = 2,
    ACTIONS(20165), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [694968] = 2,
    ACTIONS(20179), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [694976] = 2,
    ACTIONS(20181), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [694984] = 2,
    ACTIONS(20181), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [694992] = 2,
    ACTIONS(20183), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [695000] = 2,
    ACTIONS(20185), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [695008] = 2,
    ACTIONS(20187), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [695016] = 2,
    ACTIONS(20189), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [695024] = 2,
    ACTIONS(20191), 1,
      anon_sym_u2988,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [695032] = 2,
    ACTIONS(20191), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [695040] = 2,
    ACTIONS(20193), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [695048] = 2,
    ACTIONS(20191), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [695056] = 2,
    ACTIONS(20191), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [695064] = 2,
    ACTIONS(20195), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [695072] = 2,
    ACTIONS(20181), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [695080] = 2,
    ACTIONS(20181), 1,
      anon_sym_u2988,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [695088] = 2,
    ACTIONS(20197), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [695096] = 2,
    ACTIONS(20199), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [695104] = 2,
    ACTIONS(18527), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [695112] = 2,
    ACTIONS(20201), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [695120] = 2,
    ACTIONS(20203), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [695128] = 2,
    ACTIONS(20205), 1,
      anon_sym_u2988,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [695136] = 2,
    ACTIONS(20205), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [695144] = 2,
    ACTIONS(20207), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [695152] = 2,
    ACTIONS(20209), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [695160] = 2,
    ACTIONS(20205), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [695168] = 2,
    ACTIONS(20205), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [695176] = 2,
    ACTIONS(20211), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [695184] = 2,
    ACTIONS(20213), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [695192] = 2,
    ACTIONS(20215), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [695200] = 2,
    ACTIONS(20217), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [695208] = 2,
    ACTIONS(20219), 1,
      anon_sym_u2988,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [695216] = 2,
    ACTIONS(20219), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [695224] = 2,
    ACTIONS(20221), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [695232] = 2,
    ACTIONS(20219), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [695240] = 2,
    ACTIONS(20219), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [695248] = 2,
    ACTIONS(20223), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [695256] = 2,
    ACTIONS(20225), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [695264] = 2,
    ACTIONS(18547), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [695272] = 2,
    ACTIONS(20227), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [695280] = 2,
    ACTIONS(20229), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [695288] = 2,
    ACTIONS(20231), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [695296] = 2,
    ACTIONS(20117), 1,
      anon_sym_u2988,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [695304] = 2,
    ACTIONS(20117), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [695312] = 2,
    ACTIONS(20233), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [695320] = 2,
    ACTIONS(20117), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [695328] = 2,
    ACTIONS(20235), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [695336] = 2,
    ACTIONS(20237), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [695344] = 2,
    ACTIONS(20239), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [695352] = 2,
    ACTIONS(20239), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [695360] = 2,
    ACTIONS(20239), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [695368] = 2,
    ACTIONS(20239), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [695376] = 2,
    ACTIONS(20241), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [695384] = 2,
    ACTIONS(20243), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [695392] = 2,
    ACTIONS(20245), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [695400] = 2,
    ACTIONS(20247), 1,
      anon_sym_u2988,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [695408] = 2,
    ACTIONS(20247), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [695416] = 2,
    ACTIONS(20249), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [695424] = 2,
    ACTIONS(20251), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [695432] = 2,
    ACTIONS(20247), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [695440] = 2,
    ACTIONS(20247), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [695448] = 2,
    ACTIONS(20253), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [695456] = 2,
    ACTIONS(20241), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [695464] = 2,
    ACTIONS(20241), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [695472] = 2,
    ACTIONS(20241), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [695480] = 2,
    ACTIONS(20255), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [695488] = 2,
    ACTIONS(20257), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [695496] = 2,
    ACTIONS(20259), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [695504] = 2,
    ACTIONS(20261), 1,
      anon_sym_u2988,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [695512] = 2,
    ACTIONS(20261), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [695520] = 2,
    ACTIONS(20263), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [695528] = 2,
    ACTIONS(20261), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [695536] = 2,
    ACTIONS(20261), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [695544] = 2,
    ACTIONS(20265), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [695552] = 2,
    ACTIONS(20267), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [695560] = 2,
    ACTIONS(20269), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [695568] = 2,
    ACTIONS(20269), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [695576] = 2,
    ACTIONS(20271), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [695584] = 2,
    ACTIONS(20269), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [695592] = 2,
    ACTIONS(20269), 1,
      anon_sym_u2988,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [695600] = 2,
    ACTIONS(20273), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [695608] = 2,
    ACTIONS(20275), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [695616] = 2,
    ACTIONS(20277), 1,
      anon_sym_u2988,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [695624] = 2,
    ACTIONS(20277), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [695632] = 2,
    ACTIONS(20279), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [695640] = 2,
    ACTIONS(20277), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [695648] = 2,
    ACTIONS(20277), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [695656] = 2,
    ACTIONS(20281), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [695664] = 2,
    ACTIONS(20283), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [695672] = 2,
    ACTIONS(20285), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [695680] = 2,
    ACTIONS(18539), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [695688] = 2,
    ACTIONS(20287), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [695696] = 2,
    ACTIONS(20289), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [695704] = 2,
    ACTIONS(20291), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [695712] = 2,
    ACTIONS(20293), 1,
      anon_sym_u2988,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [695720] = 2,
    ACTIONS(20293), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [695728] = 2,
    ACTIONS(20295), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [695736] = 2,
    ACTIONS(20293), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [695744] = 2,
    ACTIONS(20293), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [695752] = 2,
    ACTIONS(20297), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [695760] = 2,
    ACTIONS(20299), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [695768] = 2,
    ACTIONS(20301), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [695776] = 2,
    ACTIONS(17387), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [695784] = 2,
    ACTIONS(20303), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [695792] = 2,
    ACTIONS(20305), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [695800] = 2,
    ACTIONS(20307), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [695808] = 2,
    ACTIONS(20309), 1,
      anon_sym_u2988,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [695816] = 2,
    ACTIONS(20309), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [695824] = 2,
    ACTIONS(20311), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [695832] = 2,
    ACTIONS(20313), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [695840] = 2,
    ACTIONS(20309), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [695848] = 2,
    ACTIONS(20309), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [695856] = 2,
    ACTIONS(20315), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [695864] = 2,
    ACTIONS(20317), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [695872] = 2,
    ACTIONS(20319), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [695880] = 2,
    ACTIONS(20319), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [695888] = 2,
    ACTIONS(20321), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [695896] = 2,
    ACTIONS(20323), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [695904] = 2,
    ACTIONS(20325), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [695912] = 2,
    ACTIONS(20327), 1,
      anon_sym_u2988,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [695920] = 2,
    ACTIONS(20329), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [695928] = 2,
    ACTIONS(20327), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [695936] = 2,
    ACTIONS(20331), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [695944] = 2,
    ACTIONS(20327), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [695952] = 2,
    ACTIONS(20333), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [695960] = 2,
    ACTIONS(20327), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [695968] = 2,
    ACTIONS(20335), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [695976] = 2,
    ACTIONS(20319), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [695984] = 2,
    ACTIONS(20337), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [695992] = 2,
    ACTIONS(20319), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [696000] = 2,
    ACTIONS(20339), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [696008] = 2,
    ACTIONS(20339), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [696016] = 2,
    ACTIONS(20341), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [696024] = 2,
    ACTIONS(20339), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [696032] = 2,
    ACTIONS(20343), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [696040] = 2,
    ACTIONS(20345), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [696048] = 2,
    ACTIONS(20347), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [696056] = 2,
    ACTIONS(6494), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [696064] = 2,
    ACTIONS(20349), 1,
      anon_sym_u2988,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [696072] = 2,
    ACTIONS(20349), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [696080] = 2,
    ACTIONS(20351), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [696088] = 2,
    ACTIONS(20353), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [696096] = 2,
    ACTIONS(6653), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [696104] = 2,
    ACTIONS(20349), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [696112] = 2,
    ACTIONS(20355), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [696120] = 2,
    ACTIONS(20349), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [696128] = 2,
    ACTIONS(20357), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [696136] = 2,
    ACTIONS(20339), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [696144] = 2,
    ACTIONS(20359), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [696152] = 2,
    ACTIONS(6498), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [696160] = 2,
    ACTIONS(20361), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [696168] = 2,
    ACTIONS(20363), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [696176] = 2,
    ACTIONS(20365), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [696184] = 2,
    ACTIONS(6566), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [696192] = 2,
    ACTIONS(6570), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [696200] = 2,
    ACTIONS(20363), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [696208] = 2,
    ACTIONS(20367), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [696216] = 2,
    ACTIONS(20369), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [696224] = 2,
    ACTIONS(6649), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [696232] = 2,
    ACTIONS(6752), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [696240] = 2,
    ACTIONS(20371), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [696248] = 2,
    ACTIONS(20373), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [696256] = 2,
    ACTIONS(20375), 1,
      anon_sym_u2988,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [696264] = 2,
    ACTIONS(20375), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [696272] = 2,
    ACTIONS(20377), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [696280] = 2,
    ACTIONS(6712), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [696288] = 2,
    ACTIONS(6748), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [696296] = 2,
    ACTIONS(20379), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [696304] = 2,
    ACTIONS(20381), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [696312] = 2,
    ACTIONS(6482), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [696320] = 2,
    ACTIONS(20375), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [696328] = 2,
    ACTIONS(20375), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [696336] = 2,
    ACTIONS(20383), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [696344] = 2,
    ACTIONS(20385), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [696352] = 2,
    ACTIONS(20387), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [696360] = 2,
    ACTIONS(20363), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [696368] = 2,
    ACTIONS(20389), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [696376] = 2,
    ACTIONS(20363), 1,
      anon_sym_u2988,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [696384] = 2,
    ACTIONS(20391), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [696392] = 2,
    ACTIONS(20393), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [696400] = 2,
    ACTIONS(20395), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [696408] = 2,
    ACTIONS(20397), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [696416] = 2,
    ACTIONS(20399), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [696424] = 2,
    ACTIONS(20401), 1,
      anon_sym_u2988,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [696432] = 2,
    ACTIONS(20403), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [696440] = 2,
    ACTIONS(20401), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [696448] = 2,
    ACTIONS(20405), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [696456] = 2,
    ACTIONS(20401), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [696464] = 2,
    ACTIONS(20407), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [696472] = 2,
    ACTIONS(20401), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [696480] = 2,
    ACTIONS(20409), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [696488] = 2,
    ACTIONS(18577), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [696496] = 2,
    ACTIONS(20411), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [696504] = 2,
    ACTIONS(20413), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [696512] = 2,
    ACTIONS(20415), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [696520] = 2,
    ACTIONS(20397), 1,
      anon_sym_u2988,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [696528] = 2,
    ACTIONS(20417), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [696536] = 2,
    ACTIONS(20397), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [696544] = 2,
    ACTIONS(20419), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [696552] = 2,
    ACTIONS(20397), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [696560] = 2,
    ACTIONS(20421), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [696568] = 2,
    ACTIONS(20423), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [696576] = 2,
    ACTIONS(20425), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [696584] = 2,
    ACTIONS(20427), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [696592] = 2,
    ACTIONS(20429), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [696600] = 2,
    ACTIONS(20431), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [696608] = 2,
    ACTIONS(18543), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [696616] = 2,
    ACTIONS(20433), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [696624] = 2,
    ACTIONS(20435), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [696632] = 2,
    ACTIONS(20437), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [696640] = 2,
    ACTIONS(20439), 1,
      anon_sym_u2988,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [696648] = 2,
    ACTIONS(20439), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [696656] = 2,
    ACTIONS(20441), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [696664] = 2,
    ACTIONS(20443), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [696672] = 2,
    ACTIONS(20439), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [696680] = 2,
    ACTIONS(20439), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [696688] = 2,
    ACTIONS(20445), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [696696] = 2,
    ACTIONS(20447), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [696704] = 2,
    ACTIONS(20449), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [696712] = 2,
    ACTIONS(20449), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [696720] = 2,
    ACTIONS(20451), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [696728] = 2,
    ACTIONS(20449), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [696736] = 2,
    ACTIONS(20449), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [696744] = 2,
    ACTIONS(20453), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [696752] = 2,
    ACTIONS(20455), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [696760] = 2,
    ACTIONS(20457), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [696768] = 2,
    ACTIONS(20459), 1,
      anon_sym_u2988,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [696776] = 2,
    ACTIONS(20459), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [696784] = 2,
    ACTIONS(20461), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [696792] = 2,
    ACTIONS(20463), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [696800] = 2,
    ACTIONS(20459), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [696808] = 2,
    ACTIONS(20459), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [696816] = 2,
    ACTIONS(20465), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [696824] = 2,
    ACTIONS(20467), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [696832] = 2,
    ACTIONS(20469), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [696840] = 2,
    ACTIONS(20469), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [696848] = 2,
    ACTIONS(20471), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [696856] = 2,
    ACTIONS(20469), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [696864] = 2,
    ACTIONS(20473), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [696872] = 2,
    ACTIONS(20475), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [696880] = 2,
    ACTIONS(20477), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [696888] = 2,
    ACTIONS(20479), 1,
      anon_sym_u2988,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [696896] = 2,
    ACTIONS(20479), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [696904] = 2,
    ACTIONS(20481), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [696912] = 2,
    ACTIONS(20483), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [696920] = 2,
    ACTIONS(20479), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [696928] = 2,
    ACTIONS(20479), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [696936] = 2,
    ACTIONS(20485), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [696944] = 2,
    ACTIONS(20487), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [696952] = 2,
    ACTIONS(20489), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [696960] = 2,
    ACTIONS(20491), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [696968] = 2,
    ACTIONS(20491), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [696976] = 2,
    ACTIONS(20493), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [696984] = 2,
    ACTIONS(20495), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [696992] = 2,
    ACTIONS(20491), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [697000] = 2,
    ACTIONS(20497), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [697008] = 2,
    ACTIONS(20499), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [697016] = 2,
    ACTIONS(20501), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [697024] = 2,
    ACTIONS(20503), 1,
      anon_sym_u2988,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [697032] = 2,
    ACTIONS(20503), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [697040] = 2,
    ACTIONS(20505), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [697048] = 2,
    ACTIONS(20507), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [697056] = 2,
    ACTIONS(20503), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [697064] = 2,
    ACTIONS(20503), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [697072] = 2,
    ACTIONS(20509), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [697080] = 2,
    ACTIONS(20511), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [697088] = 2,
    ACTIONS(20491), 1,
      anon_sym_u2988,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [697096] = 2,
    ACTIONS(20513), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [697104] = 2,
    ACTIONS(20515), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [697112] = 2,
    ACTIONS(20517), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [697120] = 2,
    ACTIONS(20519), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [697128] = 2,
    ACTIONS(20521), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [697136] = 2,
    ACTIONS(20523), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [697144] = 2,
    ACTIONS(20525), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [697152] = 2,
    ACTIONS(20527), 1,
      anon_sym_u2988,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [697160] = 2,
    ACTIONS(20527), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [697168] = 2,
    ACTIONS(20529), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [697176] = 2,
    ACTIONS(20531), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [697184] = 2,
    ACTIONS(20527), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [697192] = 2,
    ACTIONS(20527), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [697200] = 2,
    ACTIONS(20533), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [697208] = 2,
    ACTIONS(20535), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [697216] = 2,
    ACTIONS(20537), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [697224] = 2,
    ACTIONS(20539), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [697232] = 2,
    ACTIONS(20541), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [697240] = 2,
    ACTIONS(20539), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [697248] = 2,
    ACTIONS(20539), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [697256] = 2,
    ACTIONS(20539), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [697264] = 2,
    ACTIONS(20543), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [697272] = 2,
    ACTIONS(20545), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [697280] = 2,
    ACTIONS(20547), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [697288] = 2,
    ACTIONS(20549), 1,
      anon_sym_u2988,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [697296] = 2,
    ACTIONS(20551), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [697304] = 2,
    ACTIONS(20549), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [697312] = 2,
    ACTIONS(20553), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [697320] = 2,
    ACTIONS(20549), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [697328] = 2,
    ACTIONS(20555), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [697336] = 2,
    ACTIONS(20549), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [697344] = 2,
    ACTIONS(20557), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [697352] = 2,
    ACTIONS(20559), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [697360] = 2,
    ACTIONS(20561), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [697368] = 2,
    ACTIONS(20559), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [697376] = 2,
    ACTIONS(20559), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [697384] = 2,
    ACTIONS(20469), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [697392] = 2,
    ACTIONS(20563), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [697400] = 2,
    ACTIONS(20565), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [697408] = 2,
    ACTIONS(20567), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [697416] = 2,
    ACTIONS(20569), 1,
      anon_sym_u2988,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [697424] = 2,
    ACTIONS(20571), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [697432] = 2,
    ACTIONS(20569), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [697440] = 2,
    ACTIONS(20573), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [697448] = 2,
    ACTIONS(20569), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [697456] = 2,
    ACTIONS(20575), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [697464] = 2,
    ACTIONS(18479), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [697472] = 2,
    ACTIONS(20569), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [697480] = 2,
    ACTIONS(20577), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [697488] = 2,
    ACTIONS(20579), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [697496] = 2,
    ACTIONS(20581), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [697504] = 2,
    ACTIONS(20583), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [697512] = 2,
    ACTIONS(20583), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [697520] = 2,
    ACTIONS(20585), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [697528] = 2,
    ACTIONS(20587), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [697536] = 2,
    ACTIONS(20583), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [697544] = 2,
    ACTIONS(20589), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [697552] = 2,
    ACTIONS(20591), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [697560] = 2,
    ACTIONS(20593), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [697568] = 2,
    ACTIONS(20595), 1,
      anon_sym_u2988,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [697576] = 2,
    ACTIONS(20595), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [697584] = 2,
    ACTIONS(20597), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [697592] = 2,
    ACTIONS(20599), 1,
      anon_sym_u2988,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [697600] = 2,
    ACTIONS(20595), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [697608] = 2,
    ACTIONS(20595), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [697616] = 2,
    ACTIONS(20601), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [697624] = 2,
    ACTIONS(20603), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [697632] = 2,
    ACTIONS(20583), 1,
      anon_sym_u2988,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [697640] = 2,
    ACTIONS(20605), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [697648] = 2,
    ACTIONS(20607), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [697656] = 2,
    ACTIONS(20609), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [697664] = 2,
    ACTIONS(20611), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [697672] = 2,
    ACTIONS(20613), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [697680] = 2,
    ACTIONS(20615), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [697688] = 2,
    ACTIONS(20617), 1,
      anon_sym_u2988,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [697696] = 2,
    ACTIONS(20617), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [697704] = 2,
    ACTIONS(20619), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [697712] = 2,
    ACTIONS(20621), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [697720] = 2,
    ACTIONS(20623), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [697728] = 2,
    ACTIONS(20617), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [697736] = 2,
    ACTIONS(20617), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [697744] = 2,
    ACTIONS(20625), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [697752] = 2,
    ACTIONS(20627), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [697760] = 2,
    ACTIONS(20629), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [697768] = 2,
    ACTIONS(20631), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [697776] = 2,
    ACTIONS(20633), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [697784] = 2,
    ACTIONS(20631), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [697792] = 2,
    ACTIONS(20635), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [697800] = 2,
    ACTIONS(20631), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [697808] = 2,
    ACTIONS(20637), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [697816] = 2,
    ACTIONS(20639), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [697824] = 2,
    ACTIONS(20641), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [697832] = 2,
    ACTIONS(20643), 1,
      anon_sym_u2988,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [697840] = 2,
    ACTIONS(20645), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [697848] = 2,
    ACTIONS(18073), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [697856] = 2,
    ACTIONS(20643), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [697864] = 2,
    ACTIONS(20647), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [697872] = 2,
    ACTIONS(20649), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [697880] = 2,
    ACTIONS(20643), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [697888] = 2,
    ACTIONS(20643), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [697896] = 2,
    ACTIONS(20651), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [697904] = 2,
    ACTIONS(20653), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [697912] = 2,
    ACTIONS(20631), 1,
      anon_sym_u2988,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [697920] = 2,
    ACTIONS(20655), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [697928] = 2,
    ACTIONS(20657), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [697936] = 2,
    ACTIONS(20659), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [697944] = 2,
    ACTIONS(20559), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [697952] = 2,
    ACTIONS(20661), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [697960] = 2,
    ACTIONS(20663), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [697968] = 2,
    ACTIONS(20665), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [697976] = 2,
    ACTIONS(20667), 1,
      anon_sym_u2988,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [697984] = 2,
    ACTIONS(20667), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [697992] = 2,
    ACTIONS(20669), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [698000] = 2,
    ACTIONS(20671), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [698008] = 2,
    ACTIONS(20667), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [698016] = 2,
    ACTIONS(20667), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [698024] = 2,
    ACTIONS(20673), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [698032] = 2,
    ACTIONS(20675), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [698040] = 2,
    ACTIONS(20677), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [698048] = 2,
    ACTIONS(20679), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [698056] = 2,
    ACTIONS(20679), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [698064] = 2,
    ACTIONS(20681), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [698072] = 2,
    ACTIONS(20683), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [698080] = 2,
    ACTIONS(20679), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [698088] = 2,
    ACTIONS(20685), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [698096] = 2,
    ACTIONS(20687), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [698104] = 2,
    ACTIONS(20689), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [698112] = 2,
    ACTIONS(20691), 1,
      anon_sym_u2988,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [698120] = 2,
    ACTIONS(20691), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [698128] = 2,
    ACTIONS(20693), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [698136] = 2,
    ACTIONS(20695), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [698144] = 2,
    ACTIONS(20691), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [698152] = 2,
    ACTIONS(20691), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [698160] = 2,
    ACTIONS(20697), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [698168] = 2,
    ACTIONS(20699), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [698176] = 2,
    ACTIONS(20679), 1,
      anon_sym_u2988,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [698184] = 2,
    ACTIONS(20701), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [698192] = 2,
    ACTIONS(20703), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [698200] = 2,
    ACTIONS(20705), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [698208] = 2,
    ACTIONS(20707), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [698216] = 2,
    ACTIONS(20709), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [698224] = 2,
    ACTIONS(20711), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [698232] = 2,
    ACTIONS(20713), 1,
      sym__newline,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [698240] = 2,
    ACTIONS(20715), 1,
      anon_sym_u2988,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [698248] = 2,
    ACTIONS(20715), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [698256] = 2,
    ACTIONS(20717), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [698264] = 2,
    ACTIONS(20719), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [698272] = 2,
    ACTIONS(20715), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [698280] = 2,
    ACTIONS(20715), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [698288] = 2,
    ACTIONS(20721), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [698296] = 2,
    ACTIONS(20723), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [698304] = 2,
    ACTIONS(20725), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [698312] = 2,
    ACTIONS(20727), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [698320] = 2,
    ACTIONS(20729), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [698328] = 2,
    ACTIONS(20731), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [698336] = 2,
    ACTIONS(20731), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [698344] = 2,
    ACTIONS(20733), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [698352] = 2,
    ACTIONS(20735), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [698360] = 3,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(20737), 1,
      sym_id,
  [698370] = 2,
    ACTIONS(20731), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [698378] = 2,
    ACTIONS(20739), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [698386] = 2,
    ACTIONS(20741), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [698394] = 2,
    ACTIONS(20743), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [698402] = 2,
    ACTIONS(20745), 1,
      sym__indent,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [698410] = 2,
    ACTIONS(20747), 1,
      anon_sym_u2988,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [698418] = 2,
    ACTIONS(20749), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [698426] = 2,
    ACTIONS(20747), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [698434] = 2,
    ACTIONS(20751), 1,
      sym__newline,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [698442] = 2,
    ACTIONS(20753), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [698450] = 2,
    ACTIONS(20755), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [698458] = 2,
    ACTIONS(20747), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [698466] = 2,
    ACTIONS(20747), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [698474] = 2,
    ACTIONS(20757), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [698482] = 2,
    ACTIONS(20759), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [698490] = 2,
    ACTIONS(20731), 1,
      anon_sym_u2988,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [698498] = 2,
    ACTIONS(20761), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [698506] = 2,
    ACTIONS(20763), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [698514] = 2,
    ACTIONS(20765), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [698522] = 2,
    ACTIONS(20767), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [698530] = 2,
    ACTIONS(20769), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [698538] = 2,
    ACTIONS(20771), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [698546] = 2,
    ACTIONS(20773), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [698554] = 2,
    ACTIONS(20771), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [698562] = 3,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(20775), 1,
      sym_id,
  [698572] = 2,
    ACTIONS(20771), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [698580] = 2,
    ACTIONS(20777), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [698588] = 3,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(20779), 1,
      sym_id,
  [698598] = 2,
    ACTIONS(20619), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [698606] = 2,
    ACTIONS(20619), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [698614] = 2,
    ACTIONS(20781), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [698622] = 2,
    ACTIONS(18247), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [698630] = 2,
    ACTIONS(20783), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [698638] = 2,
    ACTIONS(20619), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [698646] = 2,
    ACTIONS(20785), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [698654] = 2,
    ACTIONS(20599), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [698662] = 2,
    ACTIONS(20787), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [698670] = 3,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(20789), 1,
      sym_id,
  [698680] = 2,
    ACTIONS(20791), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [698688] = 2,
    ACTIONS(20793), 1,
      anon_sym_to,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [698696] = 2,
    ACTIONS(20599), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [698704] = 2,
    ACTIONS(20599), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [698712] = 2,
    ACTIONS(20795), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [698720] = 2,
    ACTIONS(20797), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [698728] = 2,
    ACTIONS(20799), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [698736] = 2,
    ACTIONS(20801), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [698744] = 2,
    ACTIONS(20803), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [698752] = 2,
    ACTIONS(20801), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [698760] = 2,
    ACTIONS(20805), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [698768] = 2,
    ACTIONS(20801), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [698776] = 2,
    ACTIONS(20807), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [698784] = 2,
    ACTIONS(20809), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [698792] = 2,
    ACTIONS(20811), 1,
      sym__newline,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [698800] = 2,
    ACTIONS(20813), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [698808] = 2,
    ACTIONS(20815), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [698816] = 2,
    ACTIONS(20817), 1,
      anon_sym_u2988,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [698824] = 2,
    ACTIONS(20817), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [698832] = 2,
    ACTIONS(20819), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [698840] = 2,
    ACTIONS(20821), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [698848] = 2,
    ACTIONS(20817), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [698856] = 2,
    ACTIONS(20823), 1,
      sym__newline,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [698864] = 2,
    ACTIONS(20817), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [698872] = 2,
    ACTIONS(20825), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [698880] = 2,
    ACTIONS(15579), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [698888] = 2,
    ACTIONS(20827), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [698896] = 2,
    ACTIONS(20801), 1,
      anon_sym_u2988,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [698904] = 2,
    ACTIONS(20829), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [698912] = 2,
    ACTIONS(20831), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [698920] = 2,
    ACTIONS(20833), 1,
      sym__newline,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [698928] = 2,
    ACTIONS(20835), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [698936] = 2,
    ACTIONS(20837), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [698944] = 2,
    ACTIONS(20839), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [698952] = 2,
    ACTIONS(20841), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [698960] = 2,
    ACTIONS(20843), 1,
      anon_sym_u2988,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [698968] = 2,
    ACTIONS(20845), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [698976] = 2,
    ACTIONS(20843), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [698984] = 2,
    ACTIONS(20847), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [698992] = 2,
    ACTIONS(20843), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [699000] = 2,
    ACTIONS(20849), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [699008] = 2,
    ACTIONS(20843), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [699016] = 2,
    ACTIONS(20851), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [699024] = 2,
    ACTIONS(20853), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [699032] = 2,
    ACTIONS(20855), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [699040] = 2,
    ACTIONS(20857), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [699048] = 2,
    ACTIONS(20857), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [699056] = 2,
    ACTIONS(20859), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [699064] = 2,
    ACTIONS(20861), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [699072] = 2,
    ACTIONS(20859), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [699080] = 2,
    ACTIONS(20859), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [699088] = 2,
    ACTIONS(20863), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [699096] = 2,
    ACTIONS(20865), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [699104] = 2,
    ACTIONS(20859), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [699112] = 2,
    ACTIONS(20857), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [699120] = 2,
    ACTIONS(20867), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [699128] = 2,
    ACTIONS(20869), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [699136] = 2,
    ACTIONS(20871), 1,
      anon_sym_to,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [699144] = 3,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(20873), 1,
      sym_id,
  [699154] = 2,
    ACTIONS(20875), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [699162] = 2,
    ACTIONS(20877), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [699170] = 2,
    ACTIONS(17212), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [699178] = 2,
    ACTIONS(20879), 1,
      anon_sym_u2988,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [699186] = 3,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(20881), 1,
      sym_id,
  [699196] = 2,
    ACTIONS(20883), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [699204] = 2,
    ACTIONS(20879), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [699212] = 2,
    ACTIONS(20885), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [699220] = 2,
    ACTIONS(20887), 1,
      sym__newline,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [699228] = 2,
    ACTIONS(20889), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [699236] = 2,
    ACTIONS(20879), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [699244] = 2,
    ACTIONS(20879), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [699252] = 2,
    ACTIONS(20891), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [699260] = 2,
    ACTIONS(20893), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [699268] = 3,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(20895), 1,
      sym_id,
  [699278] = 2,
    ACTIONS(20897), 1,
      sym__newline,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [699286] = 2,
    ACTIONS(20899), 1,
      sym__newline,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [699294] = 2,
    ACTIONS(20901), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [699302] = 2,
    ACTIONS(20903), 1,
      sym__newline,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [699310] = 3,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(20905), 1,
      sym_id,
  [699320] = 2,
    ACTIONS(20857), 1,
      anon_sym_u2988,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [699328] = 2,
    ACTIONS(20907), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [699336] = 2,
    ACTIONS(20909), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [699344] = 2,
    ACTIONS(20911), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [699352] = 2,
    ACTIONS(17467), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [699360] = 2,
    ACTIONS(20913), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [699368] = 2,
    ACTIONS(20915), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [699376] = 2,
    ACTIONS(20917), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [699384] = 2,
    ACTIONS(20919), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [699392] = 2,
    ACTIONS(20921), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [699400] = 2,
    ACTIONS(17263), 1,
      anon_sym_where,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [699408] = 2,
    ACTIONS(20923), 1,
      anon_sym_u2988,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [699416] = 2,
    ACTIONS(20923), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [699424] = 2,
    ACTIONS(20925), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [699432] = 2,
    ACTIONS(20927), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [699440] = 2,
    ACTIONS(20923), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [699448] = 2,
    ACTIONS(20923), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [699456] = 2,
    ACTIONS(20929), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [699464] = 2,
    ACTIONS(20931), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [699472] = 2,
    ACTIONS(20933), 1,
      sym__newline,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [699480] = 2,
    ACTIONS(20935), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [699488] = 2,
    ACTIONS(20937), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [699496] = 2,
    ACTIONS(20939), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [699504] = 2,
    ACTIONS(20939), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [699512] = 2,
    ACTIONS(20939), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [699520] = 2,
    ACTIONS(20941), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [699528] = 2,
    ACTIONS(20943), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [699536] = 2,
    ACTIONS(20945), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [699544] = 2,
    ACTIONS(20947), 1,
      anon_sym_u2988,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [699552] = 2,
    ACTIONS(20949), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [699560] = 2,
    ACTIONS(20947), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [699568] = 2,
    ACTIONS(20951), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [699576] = 2,
    ACTIONS(20947), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [699584] = 2,
    ACTIONS(20953), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [699592] = 2,
    ACTIONS(20947), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [699600] = 2,
    ACTIONS(20955), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [699608] = 2,
    ACTIONS(20939), 1,
      anon_sym_u2988,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [699616] = 2,
    ACTIONS(20957), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [699624] = 2,
    ACTIONS(20959), 1,
      anon_sym_POUND_DASH_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [699632] = 2,
    ACTIONS(20961), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [699640] = 2,
    ACTIONS(20963), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [699648] = 2,
    ACTIONS(20965), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [699656] = 2,
    ACTIONS(20967), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [699664] = 2,
    ACTIONS(20969), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [699672] = 2,
    ACTIONS(20971), 1,
      anon_sym_u2988,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [699680] = 2,
    ACTIONS(20973), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [699688] = 2,
    ACTIONS(18357), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [699696] = 2,
    ACTIONS(20971), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [699704] = 2,
    ACTIONS(20975), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [699712] = 2,
    ACTIONS(20977), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [699720] = 2,
    ACTIONS(20971), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [699728] = 2,
    ACTIONS(20971), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [699736] = 2,
    ACTIONS(20979), 1,
      sym__newline,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [699744] = 2,
    ACTIONS(20981), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [699752] = 2,
    ACTIONS(20983), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [699760] = 2,
    ACTIONS(20985), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [699768] = 2,
    ACTIONS(20987), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [699776] = 2,
    ACTIONS(20989), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [699784] = 2,
    ACTIONS(20987), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [699792] = 2,
    ACTIONS(20991), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [699800] = 2,
    ACTIONS(20987), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [699808] = 2,
    ACTIONS(20993), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [699816] = 2,
    ACTIONS(20995), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [699824] = 2,
    ACTIONS(20997), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [699832] = 2,
    ACTIONS(20999), 1,
      anon_sym_u2988,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [699840] = 2,
    ACTIONS(21001), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [699848] = 2,
    ACTIONS(20999), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [699856] = 2,
    ACTIONS(21003), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [699864] = 3,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(21005), 1,
      sym_id,
  [699874] = 2,
    ACTIONS(20999), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [699882] = 3,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(21007), 1,
      sym_id,
  [699892] = 2,
    ACTIONS(21009), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [699900] = 2,
    ACTIONS(21011), 1,
      sym__indent,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [699908] = 2,
    ACTIONS(20999), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [699916] = 2,
    ACTIONS(21013), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [699924] = 2,
    ACTIONS(20987), 1,
      anon_sym_u2988,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [699932] = 2,
    ACTIONS(21009), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [699940] = 2,
    ACTIONS(21015), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [699948] = 2,
    ACTIONS(21017), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [699956] = 2,
    ACTIONS(21009), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [699964] = 2,
    ACTIONS(21019), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [699972] = 2,
    ACTIONS(21021), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [699980] = 2,
    ACTIONS(21023), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [699988] = 2,
    ACTIONS(18353), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [699996] = 2,
    ACTIONS(21025), 1,
      anon_sym_u2988,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [700004] = 2,
    ACTIONS(21025), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [700012] = 2,
    ACTIONS(21027), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [700020] = 2,
    ACTIONS(17347), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [700028] = 2,
    ACTIONS(21025), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [700036] = 2,
    ACTIONS(21025), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [700044] = 2,
    ACTIONS(21029), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [700052] = 2,
    ACTIONS(21031), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [700060] = 2,
    ACTIONS(21033), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [700068] = 2,
    ACTIONS(21035), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [700076] = 2,
    ACTIONS(21037), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [700084] = 2,
    ACTIONS(21039), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [700092] = 2,
    ACTIONS(21033), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [700100] = 2,
    ACTIONS(17129), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [700108] = 2,
    ACTIONS(21041), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [700116] = 2,
    ACTIONS(21043), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [700124] = 2,
    ACTIONS(21033), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [700132] = 2,
    ACTIONS(21045), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [700140] = 2,
    ACTIONS(21047), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [700148] = 2,
    ACTIONS(21049), 1,
      anon_sym_u2988,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [700156] = 2,
    ACTIONS(21049), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [700164] = 2,
    ACTIONS(21051), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [700172] = 2,
    ACTIONS(21049), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [700180] = 2,
    ACTIONS(21049), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [700188] = 2,
    ACTIONS(21053), 1,
      anon_sym_u2988,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [700196] = 2,
    ACTIONS(21033), 1,
      anon_sym_u2988,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [700204] = 2,
    ACTIONS(21055), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [700212] = 2,
    ACTIONS(21057), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [700220] = 2,
    ACTIONS(21059), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [700228] = 2,
    ACTIONS(21061), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [700236] = 2,
    ACTIONS(21063), 1,
      anon_sym_u2988,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [700244] = 2,
    ACTIONS(21063), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [700252] = 2,
    ACTIONS(21065), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [700260] = 2,
    ACTIONS(21063), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [700268] = 2,
    ACTIONS(21067), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [700276] = 2,
    ACTIONS(21063), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [700284] = 2,
    ACTIONS(21069), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [700292] = 2,
    ACTIONS(21071), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [700300] = 2,
    ACTIONS(21073), 1,
      anon_sym_in,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [700308] = 2,
    ACTIONS(21075), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [700316] = 2,
    ACTIONS(21075), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [700324] = 3,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(21077), 1,
      sym_id,
  [700334] = 2,
    ACTIONS(21079), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [700342] = 2,
    ACTIONS(21081), 1,
      sym__indent,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [700350] = 2,
    ACTIONS(21075), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [700358] = 2,
    ACTIONS(21083), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [700366] = 2,
    ACTIONS(17105), 1,
      anon_sym_where,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [700374] = 2,
    ACTIONS(21085), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [700382] = 2,
    ACTIONS(21087), 1,
      anon_sym_u2988,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [700390] = 2,
    ACTIONS(18293), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [700398] = 2,
    ACTIONS(21087), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [700406] = 3,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(21089), 1,
      sym_id,
  [700416] = 2,
    ACTIONS(21091), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [700424] = 2,
    ACTIONS(21087), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [700432] = 2,
    ACTIONS(21087), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [700440] = 2,
    ACTIONS(21093), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [700448] = 2,
    ACTIONS(21075), 1,
      anon_sym_u2988,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [700456] = 2,
    ACTIONS(21095), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [700464] = 2,
    ACTIONS(18175), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [700472] = 2,
    ACTIONS(21097), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [700480] = 3,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(21099), 1,
      sym_id,
  [700490] = 2,
    ACTIONS(21101), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [700498] = 2,
    ACTIONS(21103), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [700506] = 2,
    ACTIONS(21105), 1,
      anon_sym_u2988,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [700514] = 2,
    ACTIONS(21105), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [700522] = 2,
    ACTIONS(21107), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [700530] = 2,
    ACTIONS(21105), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [700538] = 2,
    ACTIONS(18121), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [700546] = 2,
    ACTIONS(21105), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [700554] = 3,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(21109), 1,
      sym_id,
  [700564] = 2,
    ACTIONS(21111), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [700572] = 2,
    ACTIONS(21113), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [700580] = 2,
    ACTIONS(21053), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [700588] = 2,
    ACTIONS(21053), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [700596] = 2,
    ACTIONS(21115), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [700604] = 2,
    ACTIONS(21117), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [700612] = 2,
    ACTIONS(18067), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [700620] = 2,
    ACTIONS(21119), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [700628] = 3,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(21121), 1,
      sym_id,
  [700638] = 2,
    ACTIONS(21123), 1,
      anon_sym_u2988,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [700646] = 2,
    ACTIONS(21123), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [700654] = 2,
    ACTIONS(21125), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [700662] = 2,
    ACTIONS(21123), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [700670] = 2,
    ACTIONS(21123), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [700678] = 2,
    ACTIONS(21127), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [700686] = 2,
    ACTIONS(18033), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [700694] = 2,
    ACTIONS(21129), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [700702] = 3,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(21131), 1,
      sym_id,
  [700712] = 2,
    ACTIONS(21133), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [700720] = 2,
    ACTIONS(21135), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [700728] = 2,
    ACTIONS(21137), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [700736] = 2,
    ACTIONS(21139), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [700744] = 2,
    ACTIONS(21141), 1,
      sym__newline,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [700752] = 2,
    ACTIONS(21143), 1,
      anon_sym_u2988,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [700760] = 2,
    ACTIONS(17985), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [700768] = 2,
    ACTIONS(21143), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [700776] = 3,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(21145), 1,
      sym_id,
  [700786] = 2,
    ACTIONS(21147), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [700794] = 2,
    ACTIONS(21149), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [700802] = 2,
    ACTIONS(21143), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [700810] = 2,
    ACTIONS(21143), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [700818] = 2,
    ACTIONS(21151), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [700826] = 2,
    ACTIONS(21153), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [700834] = 2,
    ACTIONS(17929), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [700842] = 2,
    ACTIONS(21155), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [700850] = 3,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(21157), 1,
      sym_id,
  [700860] = 2,
    ACTIONS(21155), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [700868] = 2,
    ACTIONS(21159), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [700876] = 2,
    ACTIONS(21155), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [700884] = 2,
    ACTIONS(21161), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [700892] = 2,
    ACTIONS(21163), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [700900] = 2,
    ACTIONS(21165), 1,
      anon_sym_u2988,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [700908] = 2,
    ACTIONS(17883), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [700916] = 2,
    ACTIONS(21165), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [700924] = 3,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(21167), 1,
      sym_id,
  [700934] = 2,
    ACTIONS(21169), 1,
      anon_sym_where,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [700942] = 2,
    ACTIONS(21171), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [700950] = 2,
    ACTIONS(21165), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [700958] = 2,
    ACTIONS(21165), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [700966] = 2,
    ACTIONS(21173), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [700974] = 2,
    ACTIONS(21175), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [700982] = 2,
    ACTIONS(17831), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [700990] = 2,
    ACTIONS(21155), 1,
      anon_sym_u2988,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [700998] = 3,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(21177), 1,
      sym_id,
  [701008] = 2,
    ACTIONS(21179), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [701016] = 2,
    ACTIONS(21181), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [701024] = 2,
    ACTIONS(21183), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [701032] = 2,
    ACTIONS(21185), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [701040] = 2,
    ACTIONS(21187), 1,
      anon_sym_u2988,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [701048] = 2,
    ACTIONS(21187), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [701056] = 2,
    ACTIONS(17787), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [701064] = 2,
    ACTIONS(21189), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [701072] = 3,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(21191), 1,
      sym_id,
  [701082] = 2,
    ACTIONS(21187), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [701090] = 2,
    ACTIONS(21187), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [701098] = 2,
    ACTIONS(21193), 1,
      anon_sym_CATCHALL,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [701106] = 2,
    ACTIONS(21195), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [701114] = 2,
    ACTIONS(21197), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [701122] = 2,
    ACTIONS(21199), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [701130] = 2,
    ACTIONS(17759), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [701138] = 2,
    ACTIONS(21199), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [701146] = 3,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(21201), 1,
      sym_id,
  [701156] = 2,
    ACTIONS(21203), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [701164] = 2,
    ACTIONS(21199), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [701172] = 2,
    ACTIONS(21205), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [701180] = 2,
    ACTIONS(21207), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [701188] = 2,
    ACTIONS(17757), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [701196] = 2,
    ACTIONS(21209), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [701204] = 2,
    ACTIONS(17715), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [701212] = 2,
    ACTIONS(21211), 1,
      anon_sym_u2988,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [701220] = 3,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(21213), 1,
      sym_id,
  [701230] = 2,
    ACTIONS(21211), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [701238] = 2,
    ACTIONS(21215), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [701246] = 2,
    ACTIONS(21217), 1,
      sym__newline,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [701254] = 2,
    ACTIONS(21211), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [701262] = 2,
    ACTIONS(21211), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [701270] = 2,
    ACTIONS(21219), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [701278] = 2,
    ACTIONS(17667), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [701286] = 2,
    ACTIONS(21199), 1,
      anon_sym_u2988,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [701294] = 3,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(21221), 1,
      sym_id,
  [701304] = 2,
    ACTIONS(15061), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [701312] = 2,
    ACTIONS(21223), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [701320] = 2,
    ACTIONS(21225), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [701328] = 2,
    ACTIONS(21227), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [701336] = 2,
    ACTIONS(21229), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [701344] = 2,
    ACTIONS(21231), 1,
      anon_sym_u2988,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [701352] = 2,
    ACTIONS(17635), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [701360] = 2,
    ACTIONS(21231), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [701368] = 3,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(21233), 1,
      sym_id,
  [701378] = 2,
    ACTIONS(21235), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [701386] = 2,
    ACTIONS(21231), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [701394] = 2,
    ACTIONS(21231), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [701402] = 2,
    ACTIONS(21237), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [701410] = 2,
    ACTIONS(21239), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [701418] = 2,
    ACTIONS(21241), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [701426] = 2,
    ACTIONS(17579), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [701434] = 2,
    ACTIONS(21243), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [701442] = 3,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(21245), 1,
      sym_id,
  [701452] = 2,
    ACTIONS(21243), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [701460] = 2,
    ACTIONS(21247), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [701468] = 2,
    ACTIONS(21249), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [701476] = 2,
    ACTIONS(21243), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [701484] = 2,
    ACTIONS(21251), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [701492] = 2,
    ACTIONS(21253), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [701500] = 2,
    ACTIONS(17535), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [701508] = 2,
    ACTIONS(21255), 1,
      anon_sym_u2988,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [701516] = 3,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(21257), 1,
      sym_id,
  [701526] = 2,
    ACTIONS(21255), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [701534] = 2,
    ACTIONS(21259), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [701542] = 2,
    ACTIONS(21255), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [701550] = 2,
    ACTIONS(21255), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [701558] = 2,
    ACTIONS(21261), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [701566] = 2,
    ACTIONS(21263), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [701574] = 2,
    ACTIONS(17437), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [701582] = 2,
    ACTIONS(21243), 1,
      anon_sym_u2988,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [701590] = 3,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(21265), 1,
      sym_id,
  [701600] = 2,
    ACTIONS(21267), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [701608] = 2,
    ACTIONS(21269), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [701616] = 2,
    ACTIONS(21271), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [701624] = 2,
    ACTIONS(21273), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [701632] = 2,
    ACTIONS(21275), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [701640] = 2,
    ACTIONS(21277), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [701648] = 2,
    ACTIONS(17447), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [701656] = 2,
    ACTIONS(21279), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [701664] = 3,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(21281), 1,
      sym_id,
  [701674] = 2,
    ACTIONS(21283), 1,
      anon_sym_u2988,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [701682] = 2,
    ACTIONS(21283), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [701690] = 2,
    ACTIONS(21285), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [701698] = 2,
    ACTIONS(21287), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [701706] = 2,
    ACTIONS(21283), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [701714] = 2,
    ACTIONS(21283), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [701722] = 2,
    ACTIONS(17439), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [701730] = 2,
    ACTIONS(21289), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [701738] = 3,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(21291), 1,
      sym_id,
  [701748] = 2,
    ACTIONS(21293), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [701756] = 2,
    ACTIONS(21295), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [701764] = 2,
    ACTIONS(21297), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [701772] = 2,
    ACTIONS(21295), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [701780] = 2,
    ACTIONS(21299), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [701788] = 2,
    ACTIONS(21295), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [701796] = 2,
    ACTIONS(17393), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [701804] = 2,
    ACTIONS(21301), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [701812] = 3,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(21303), 1,
      sym_id,
  [701822] = 2,
    ACTIONS(21305), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [701830] = 2,
    ACTIONS(21307), 1,
      anon_sym_u2988,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [701838] = 2,
    ACTIONS(21309), 1,
      sym__newline,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [701846] = 2,
    ACTIONS(21307), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [701854] = 2,
    ACTIONS(21311), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [701862] = 2,
    ACTIONS(21307), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [701870] = 2,
    ACTIONS(17421), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [701878] = 2,
    ACTIONS(21307), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [701886] = 3,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(21313), 1,
      sym_id,
  [701896] = 2,
    ACTIONS(21315), 1,
      sym__indent,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [701904] = 2,
    ACTIONS(21317), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [701912] = 2,
    ACTIONS(21295), 1,
      anon_sym_u2988,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [701920] = 2,
    ACTIONS(21319), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [701928] = 2,
    ACTIONS(21321), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [701936] = 2,
    ACTIONS(21323), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [701944] = 2,
    ACTIONS(17459), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [701952] = 2,
    ACTIONS(21053), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [701960] = 3,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(21325), 1,
      sym_id,
  [701970] = 2,
    ACTIONS(21327), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [701978] = 2,
    ACTIONS(21329), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [701986] = 2,
    ACTIONS(21331), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [701994] = 2,
    ACTIONS(17475), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [702002] = 2,
    ACTIONS(21333), 1,
      anon_sym_u2988,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [702010] = 3,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(21335), 1,
      sym_id,
  [702020] = 2,
    ACTIONS(21333), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [702028] = 2,
    ACTIONS(21337), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [702036] = 2,
    ACTIONS(21333), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [702044] = 2,
    ACTIONS(17507), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [702052] = 2,
    ACTIONS(21333), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [702060] = 3,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(21339), 1,
      sym_id,
  [702070] = 2,
    ACTIONS(21341), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [702078] = 2,
    ACTIONS(21343), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [702086] = 2,
    ACTIONS(21345), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [702094] = 2,
    ACTIONS(17513), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [702102] = 2,
    ACTIONS(21345), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [702110] = 3,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(21347), 1,
      sym_id,
  [702120] = 2,
    ACTIONS(21349), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [702128] = 2,
    ACTIONS(21345), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [702136] = 2,
    ACTIONS(21351), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [702144] = 2,
    ACTIONS(17533), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [702152] = 2,
    ACTIONS(21353), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [702160] = 3,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(21355), 1,
      sym_id,
  [702170] = 2,
    ACTIONS(21357), 1,
      anon_sym_u2988,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [702178] = 2,
    ACTIONS(21357), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [702186] = 2,
    ACTIONS(21359), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [702194] = 2,
    ACTIONS(17561), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [702202] = 2,
    ACTIONS(21357), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [702210] = 3,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(21361), 1,
      sym_id,
  [702220] = 2,
    ACTIONS(21357), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [702228] = 2,
    ACTIONS(21363), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [702236] = 2,
    ACTIONS(21345), 1,
      anon_sym_u2988,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [702244] = 2,
    ACTIONS(17575), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [702252] = 2,
    ACTIONS(21365), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [702260] = 3,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(21367), 1,
      sym_id,
  [702270] = 2,
    ACTIONS(21369), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [702278] = 2,
    ACTIONS(21371), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [702286] = 2,
    ACTIONS(21373), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [702294] = 2,
    ACTIONS(17601), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [702302] = 2,
    ACTIONS(21375), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [702310] = 3,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(21377), 1,
      sym_id,
  [702320] = 2,
    ACTIONS(21379), 1,
      anon_sym_u2988,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [702328] = 2,
    ACTIONS(21381), 1,
      sym__newline,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [702336] = 2,
    ACTIONS(21379), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [702344] = 2,
    ACTIONS(17615), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [702352] = 2,
    ACTIONS(21383), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [702360] = 3,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(21385), 1,
      sym_id,
  [702370] = 2,
    ACTIONS(21379), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [702378] = 2,
    ACTIONS(21379), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [702386] = 2,
    ACTIONS(21387), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [702394] = 2,
    ACTIONS(17659), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [702402] = 2,
    ACTIONS(21389), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [702410] = 3,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(21391), 1,
      sym_id,
  [702420] = 2,
    ACTIONS(21393), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [702428] = 2,
    ACTIONS(21393), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [702436] = 2,
    ACTIONS(21395), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [702444] = 2,
    ACTIONS(17669), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [702452] = 2,
    ACTIONS(21393), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [702460] = 3,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(21397), 1,
      sym_id,
  [702470] = 2,
    ACTIONS(21399), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [702478] = 2,
    ACTIONS(21401), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [702486] = 2,
    ACTIONS(21403), 1,
      anon_sym_u2988,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [702494] = 2,
    ACTIONS(17683), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [702502] = 2,
    ACTIONS(21403), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [702510] = 3,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(21405), 1,
      sym_id,
  [702520] = 2,
    ACTIONS(21407), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [702528] = 2,
    ACTIONS(21403), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [702536] = 2,
    ACTIONS(21403), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [702544] = 2,
    ACTIONS(17723), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [702552] = 2,
    ACTIONS(21409), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [702560] = 3,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(21411), 1,
      sym_id,
  [702570] = 2,
    ACTIONS(21393), 1,
      anon_sym_u2988,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [702578] = 2,
    ACTIONS(21413), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [702586] = 2,
    ACTIONS(21415), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [702594] = 2,
    ACTIONS(17741), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [702602] = 2,
    ACTIONS(21417), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [702610] = 3,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(21419), 1,
      sym_id,
  [702620] = 2,
    ACTIONS(21421), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [702628] = 2,
    ACTIONS(21423), 1,
      anon_sym_u2988,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [702636] = 2,
    ACTIONS(21423), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [702644] = 2,
    ACTIONS(17769), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [702652] = 2,
    ACTIONS(21425), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [702660] = 3,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(21427), 1,
      sym_id,
  [702670] = 2,
    ACTIONS(21423), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [702678] = 2,
    ACTIONS(21423), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [702686] = 2,
    ACTIONS(21429), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [702694] = 2,
    ACTIONS(17777), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [702702] = 2,
    ACTIONS(21431), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [702710] = 3,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(21433), 1,
      sym_id,
  [702720] = 2,
    ACTIONS(21435), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [702728] = 2,
    ACTIONS(21435), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [702736] = 2,
    ACTIONS(21437), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [702744] = 2,
    ACTIONS(17785), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [702752] = 2,
    ACTIONS(21435), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [702760] = 3,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(21439), 1,
      sym_id,
  [702770] = 2,
    ACTIONS(21441), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [702778] = 2,
    ACTIONS(21443), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [702786] = 2,
    ACTIONS(21445), 1,
      anon_sym_u2988,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [702794] = 2,
    ACTIONS(17805), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [702802] = 2,
    ACTIONS(21445), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [702810] = 3,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(21447), 1,
      sym_id,
  [702820] = 2,
    ACTIONS(19983), 1,
      anon_sym_u2988,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [702828] = 2,
    ACTIONS(21445), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [702836] = 2,
    ACTIONS(21445), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [702844] = 2,
    ACTIONS(17847), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [702852] = 2,
    ACTIONS(21449), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [702860] = 3,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(21451), 1,
      sym_id,
  [702870] = 2,
    ACTIONS(21435), 1,
      anon_sym_u2988,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [702878] = 2,
    ACTIONS(21453), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [702886] = 2,
    ACTIONS(21455), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [702894] = 2,
    ACTIONS(17859), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [702902] = 2,
    ACTIONS(21457), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [702910] = 3,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(21459), 1,
      sym_id,
  [702920] = 2,
    ACTIONS(21461), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [702928] = 2,
    ACTIONS(21463), 1,
      anon_sym_u2988,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [702936] = 2,
    ACTIONS(21463), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [702944] = 2,
    ACTIONS(17933), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [702952] = 2,
    ACTIONS(21465), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [702960] = 3,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(21467), 1,
      sym_id,
  [702970] = 2,
    ACTIONS(21463), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [702978] = 2,
    ACTIONS(21463), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [702986] = 2,
    ACTIONS(21469), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [702994] = 2,
    ACTIONS(17955), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [703002] = 2,
    ACTIONS(21471), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [703010] = 3,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(21473), 1,
      sym_id,
  [703020] = 2,
    ACTIONS(21475), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [703028] = 2,
    ACTIONS(21475), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [703036] = 2,
    ACTIONS(17999), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [703044] = 2,
    ACTIONS(21477), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [703052] = 2,
    ACTIONS(21475), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [703060] = 2,
    ACTIONS(18013), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [703068] = 2,
    ACTIONS(21479), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [703076] = 2,
    ACTIONS(21481), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [703084] = 2,
    ACTIONS(18037), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [703092] = 2,
    ACTIONS(21483), 1,
      anon_sym_u2988,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [703100] = 2,
    ACTIONS(21483), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [703108] = 2,
    ACTIONS(17779), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [703116] = 2,
    ACTIONS(21485), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [703124] = 2,
    ACTIONS(21483), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [703132] = 2,
    ACTIONS(18057), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [703140] = 2,
    ACTIONS(21483), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [703148] = 2,
    ACTIONS(21487), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [703156] = 2,
    ACTIONS(18079), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [703164] = 2,
    ACTIONS(21475), 1,
      anon_sym_u2988,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [703172] = 2,
    ACTIONS(21489), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [703180] = 2,
    ACTIONS(18099), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [703188] = 2,
    ACTIONS(21491), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [703196] = 2,
    ACTIONS(21493), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [703204] = 2,
    ACTIONS(18131), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [703212] = 2,
    ACTIONS(21495), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [703220] = 2,
    ACTIONS(21497), 1,
      anon_sym_u2988,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [703228] = 2,
    ACTIONS(18141), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [703236] = 2,
    ACTIONS(21497), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [703244] = 2,
    ACTIONS(21499), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [703252] = 2,
    ACTIONS(18195), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [703260] = 2,
    ACTIONS(21497), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [703268] = 2,
    ACTIONS(21497), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [703276] = 2,
    ACTIONS(18215), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [703284] = 2,
    ACTIONS(21501), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [703292] = 2,
    ACTIONS(18219), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [703300] = 3,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(21503), 1,
      sym_id,
  [703310] = 2,
    ACTIONS(21505), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [703318] = 2,
    ACTIONS(19983), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [703326] = 2,
    ACTIONS(19983), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [703334] = 2,
    ACTIONS(21507), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [703342] = 2,
    ACTIONS(21509), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [703350] = 2,
    ACTIONS(21511), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [703358] = 2,
    ACTIONS(21513), 1,
      anon_sym_u2988,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [703366] = 2,
    ACTIONS(21513), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [703374] = 2,
    ACTIONS(21515), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [703382] = 2,
    ACTIONS(21513), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [703390] = 2,
    ACTIONS(21513), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [703398] = 2,
    ACTIONS(21517), 1,
      anon_sym_u2988,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [703406] = 2,
    ACTIONS(21517), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [703414] = 2,
    ACTIONS(21519), 1,
      anon_sym_in,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [703422] = 2,
    ACTIONS(21521), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [703430] = 2,
    ACTIONS(21523), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [703438] = 2,
    ACTIONS(21525), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [703446] = 2,
    ACTIONS(21517), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [703454] = 2,
    ACTIONS(21517), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [703462] = 2,
    ACTIONS(21527), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [703470] = 2,
    ACTIONS(21529), 1,
      anon_sym_u2988,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [703478] = 2,
    ACTIONS(21531), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [703486] = 2,
    ACTIONS(21529), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [703494] = 2,
    ACTIONS(21533), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [703502] = 2,
    ACTIONS(21529), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [703510] = 2,
    ACTIONS(21529), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [703518] = 2,
    ACTIONS(21535), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [703526] = 2,
    ACTIONS(21537), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [703534] = 2,
    ACTIONS(21539), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [703542] = 2,
    ACTIONS(21541), 1,
      anon_sym_u2988,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [703550] = 2,
    ACTIONS(21541), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [703558] = 2,
    ACTIONS(21543), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [703566] = 2,
    ACTIONS(21541), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [703574] = 2,
    ACTIONS(21541), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [703582] = 2,
    ACTIONS(21545), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [703590] = 2,
    ACTIONS(21547), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [703598] = 2,
    ACTIONS(21549), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [703606] = 2,
    ACTIONS(21551), 1,
      anon_sym_u2988,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [703614] = 2,
    ACTIONS(21551), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [703622] = 2,
    ACTIONS(21553), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [703630] = 2,
    ACTIONS(21551), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [703638] = 2,
    ACTIONS(21551), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [703646] = 2,
    ACTIONS(21555), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [703654] = 2,
    ACTIONS(21557), 1,
      sym__newline,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [703662] = 2,
    ACTIONS(21559), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [703670] = 2,
    ACTIONS(21561), 1,
      ts_builtin_sym_end,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [703678] = 2,
    ACTIONS(21563), 1,
      sym__indent,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [703686] = 3,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(21565), 1,
      sym_id,
  [703696] = 2,
    ACTIONS(21567), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [703704] = 2,
    ACTIONS(21569), 1,
      anon_sym_u2988,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [703712] = 2,
    ACTIONS(21569), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [703720] = 3,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(21571), 1,
      sym_id,
  [703730] = 3,
    ACTIONS(3), 1,
      sym_pragma,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(21573), 1,
      sym_id,
  [703740] = 2,
    ACTIONS(21575), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [703748] = 2,
    ACTIONS(21569), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [703756] = 2,
    ACTIONS(21569), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [703764] = 2,
    ACTIONS(21577), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [703772] = 2,
    ACTIONS(21579), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [703780] = 2,
    ACTIONS(21581), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [703788] = 2,
    ACTIONS(21583), 1,
      anon_sym_u2988,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [703796] = 2,
    ACTIONS(21583), 1,
      anon_sym_PIPE_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [703804] = 2,
    ACTIONS(21585), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [703812] = 2,
    ACTIONS(21583), 1,
      anon_sym_u2984,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [703820] = 2,
    ACTIONS(21583), 1,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [703828] = 2,
    ACTIONS(21587), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [703836] = 2,
    ACTIONS(21589), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
  [703844] = 2,
    ACTIONS(21591), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_pragma,
      sym_comment,
};

static const uint32_t ts_small_parse_table_map[] = {
  [SMALL_STATE(614)] = 0,
  [SMALL_STATE(615)] = 139,
  [SMALL_STATE(616)] = 278,
  [SMALL_STATE(617)] = 417,
  [SMALL_STATE(618)] = 556,
  [SMALL_STATE(619)] = 695,
  [SMALL_STATE(620)] = 834,
  [SMALL_STATE(621)] = 973,
  [SMALL_STATE(622)] = 1112,
  [SMALL_STATE(623)] = 1251,
  [SMALL_STATE(624)] = 1390,
  [SMALL_STATE(625)] = 1529,
  [SMALL_STATE(626)] = 1668,
  [SMALL_STATE(627)] = 1807,
  [SMALL_STATE(628)] = 1946,
  [SMALL_STATE(629)] = 2085,
  [SMALL_STATE(630)] = 2224,
  [SMALL_STATE(631)] = 2363,
  [SMALL_STATE(632)] = 2502,
  [SMALL_STATE(633)] = 2641,
  [SMALL_STATE(634)] = 2780,
  [SMALL_STATE(635)] = 2919,
  [SMALL_STATE(636)] = 3058,
  [SMALL_STATE(637)] = 3197,
  [SMALL_STATE(638)] = 3336,
  [SMALL_STATE(639)] = 3475,
  [SMALL_STATE(640)] = 3614,
  [SMALL_STATE(641)] = 3753,
  [SMALL_STATE(642)] = 3892,
  [SMALL_STATE(643)] = 4031,
  [SMALL_STATE(644)] = 4170,
  [SMALL_STATE(645)] = 4309,
  [SMALL_STATE(646)] = 4448,
  [SMALL_STATE(647)] = 4587,
  [SMALL_STATE(648)] = 4726,
  [SMALL_STATE(649)] = 4865,
  [SMALL_STATE(650)] = 5004,
  [SMALL_STATE(651)] = 5143,
  [SMALL_STATE(652)] = 5282,
  [SMALL_STATE(653)] = 5421,
  [SMALL_STATE(654)] = 5560,
  [SMALL_STATE(655)] = 5699,
  [SMALL_STATE(656)] = 5838,
  [SMALL_STATE(657)] = 5977,
  [SMALL_STATE(658)] = 6116,
  [SMALL_STATE(659)] = 6255,
  [SMALL_STATE(660)] = 6394,
  [SMALL_STATE(661)] = 6533,
  [SMALL_STATE(662)] = 6672,
  [SMALL_STATE(663)] = 6811,
  [SMALL_STATE(664)] = 6950,
  [SMALL_STATE(665)] = 7089,
  [SMALL_STATE(666)] = 7228,
  [SMALL_STATE(667)] = 7367,
  [SMALL_STATE(668)] = 7506,
  [SMALL_STATE(669)] = 7645,
  [SMALL_STATE(670)] = 7784,
  [SMALL_STATE(671)] = 7923,
  [SMALL_STATE(672)] = 8062,
  [SMALL_STATE(673)] = 8201,
  [SMALL_STATE(674)] = 8340,
  [SMALL_STATE(675)] = 8479,
  [SMALL_STATE(676)] = 8618,
  [SMALL_STATE(677)] = 8757,
  [SMALL_STATE(678)] = 8896,
  [SMALL_STATE(679)] = 9035,
  [SMALL_STATE(680)] = 9174,
  [SMALL_STATE(681)] = 9313,
  [SMALL_STATE(682)] = 9452,
  [SMALL_STATE(683)] = 9591,
  [SMALL_STATE(684)] = 9730,
  [SMALL_STATE(685)] = 9869,
  [SMALL_STATE(686)] = 10008,
  [SMALL_STATE(687)] = 10147,
  [SMALL_STATE(688)] = 10286,
  [SMALL_STATE(689)] = 10425,
  [SMALL_STATE(690)] = 10564,
  [SMALL_STATE(691)] = 10703,
  [SMALL_STATE(692)] = 10842,
  [SMALL_STATE(693)] = 10981,
  [SMALL_STATE(694)] = 11120,
  [SMALL_STATE(695)] = 11259,
  [SMALL_STATE(696)] = 11398,
  [SMALL_STATE(697)] = 11537,
  [SMALL_STATE(698)] = 11676,
  [SMALL_STATE(699)] = 11815,
  [SMALL_STATE(700)] = 11954,
  [SMALL_STATE(701)] = 12093,
  [SMALL_STATE(702)] = 12232,
  [SMALL_STATE(703)] = 12371,
  [SMALL_STATE(704)] = 12510,
  [SMALL_STATE(705)] = 12649,
  [SMALL_STATE(706)] = 12788,
  [SMALL_STATE(707)] = 12927,
  [SMALL_STATE(708)] = 13066,
  [SMALL_STATE(709)] = 13205,
  [SMALL_STATE(710)] = 13344,
  [SMALL_STATE(711)] = 13483,
  [SMALL_STATE(712)] = 13622,
  [SMALL_STATE(713)] = 13761,
  [SMALL_STATE(714)] = 13900,
  [SMALL_STATE(715)] = 14039,
  [SMALL_STATE(716)] = 14178,
  [SMALL_STATE(717)] = 14317,
  [SMALL_STATE(718)] = 14456,
  [SMALL_STATE(719)] = 14595,
  [SMALL_STATE(720)] = 14734,
  [SMALL_STATE(721)] = 14873,
  [SMALL_STATE(722)] = 15012,
  [SMALL_STATE(723)] = 15151,
  [SMALL_STATE(724)] = 15290,
  [SMALL_STATE(725)] = 15429,
  [SMALL_STATE(726)] = 15568,
  [SMALL_STATE(727)] = 15707,
  [SMALL_STATE(728)] = 15846,
  [SMALL_STATE(729)] = 15985,
  [SMALL_STATE(730)] = 16124,
  [SMALL_STATE(731)] = 16263,
  [SMALL_STATE(732)] = 16402,
  [SMALL_STATE(733)] = 16541,
  [SMALL_STATE(734)] = 16680,
  [SMALL_STATE(735)] = 16819,
  [SMALL_STATE(736)] = 16958,
  [SMALL_STATE(737)] = 17097,
  [SMALL_STATE(738)] = 17236,
  [SMALL_STATE(739)] = 17375,
  [SMALL_STATE(740)] = 17514,
  [SMALL_STATE(741)] = 17653,
  [SMALL_STATE(742)] = 17792,
  [SMALL_STATE(743)] = 17931,
  [SMALL_STATE(744)] = 18070,
  [SMALL_STATE(745)] = 18209,
  [SMALL_STATE(746)] = 18348,
  [SMALL_STATE(747)] = 18487,
  [SMALL_STATE(748)] = 18626,
  [SMALL_STATE(749)] = 18765,
  [SMALL_STATE(750)] = 18904,
  [SMALL_STATE(751)] = 19043,
  [SMALL_STATE(752)] = 19182,
  [SMALL_STATE(753)] = 19321,
  [SMALL_STATE(754)] = 19460,
  [SMALL_STATE(755)] = 19599,
  [SMALL_STATE(756)] = 19738,
  [SMALL_STATE(757)] = 19877,
  [SMALL_STATE(758)] = 20016,
  [SMALL_STATE(759)] = 20155,
  [SMALL_STATE(760)] = 20294,
  [SMALL_STATE(761)] = 20433,
  [SMALL_STATE(762)] = 20572,
  [SMALL_STATE(763)] = 20711,
  [SMALL_STATE(764)] = 20850,
  [SMALL_STATE(765)] = 20989,
  [SMALL_STATE(766)] = 21128,
  [SMALL_STATE(767)] = 21267,
  [SMALL_STATE(768)] = 21406,
  [SMALL_STATE(769)] = 21545,
  [SMALL_STATE(770)] = 21684,
  [SMALL_STATE(771)] = 21823,
  [SMALL_STATE(772)] = 21962,
  [SMALL_STATE(773)] = 22101,
  [SMALL_STATE(774)] = 22240,
  [SMALL_STATE(775)] = 22379,
  [SMALL_STATE(776)] = 22518,
  [SMALL_STATE(777)] = 22657,
  [SMALL_STATE(778)] = 22796,
  [SMALL_STATE(779)] = 22935,
  [SMALL_STATE(780)] = 23074,
  [SMALL_STATE(781)] = 23213,
  [SMALL_STATE(782)] = 23352,
  [SMALL_STATE(783)] = 23491,
  [SMALL_STATE(784)] = 23630,
  [SMALL_STATE(785)] = 23769,
  [SMALL_STATE(786)] = 23908,
  [SMALL_STATE(787)] = 24047,
  [SMALL_STATE(788)] = 24186,
  [SMALL_STATE(789)] = 24325,
  [SMALL_STATE(790)] = 24464,
  [SMALL_STATE(791)] = 24603,
  [SMALL_STATE(792)] = 24742,
  [SMALL_STATE(793)] = 24881,
  [SMALL_STATE(794)] = 25020,
  [SMALL_STATE(795)] = 25159,
  [SMALL_STATE(796)] = 25298,
  [SMALL_STATE(797)] = 25437,
  [SMALL_STATE(798)] = 25576,
  [SMALL_STATE(799)] = 25715,
  [SMALL_STATE(800)] = 25854,
  [SMALL_STATE(801)] = 25993,
  [SMALL_STATE(802)] = 26132,
  [SMALL_STATE(803)] = 26271,
  [SMALL_STATE(804)] = 26410,
  [SMALL_STATE(805)] = 26549,
  [SMALL_STATE(806)] = 26688,
  [SMALL_STATE(807)] = 26827,
  [SMALL_STATE(808)] = 26966,
  [SMALL_STATE(809)] = 27105,
  [SMALL_STATE(810)] = 27244,
  [SMALL_STATE(811)] = 27383,
  [SMALL_STATE(812)] = 27522,
  [SMALL_STATE(813)] = 27661,
  [SMALL_STATE(814)] = 27800,
  [SMALL_STATE(815)] = 27939,
  [SMALL_STATE(816)] = 28078,
  [SMALL_STATE(817)] = 28217,
  [SMALL_STATE(818)] = 28356,
  [SMALL_STATE(819)] = 28495,
  [SMALL_STATE(820)] = 28634,
  [SMALL_STATE(821)] = 28773,
  [SMALL_STATE(822)] = 28912,
  [SMALL_STATE(823)] = 29051,
  [SMALL_STATE(824)] = 29190,
  [SMALL_STATE(825)] = 29329,
  [SMALL_STATE(826)] = 29468,
  [SMALL_STATE(827)] = 29607,
  [SMALL_STATE(828)] = 29746,
  [SMALL_STATE(829)] = 29885,
  [SMALL_STATE(830)] = 30024,
  [SMALL_STATE(831)] = 30163,
  [SMALL_STATE(832)] = 30302,
  [SMALL_STATE(833)] = 30441,
  [SMALL_STATE(834)] = 30580,
  [SMALL_STATE(835)] = 30719,
  [SMALL_STATE(836)] = 30858,
  [SMALL_STATE(837)] = 30997,
  [SMALL_STATE(838)] = 31136,
  [SMALL_STATE(839)] = 31275,
  [SMALL_STATE(840)] = 31414,
  [SMALL_STATE(841)] = 31553,
  [SMALL_STATE(842)] = 31692,
  [SMALL_STATE(843)] = 31831,
  [SMALL_STATE(844)] = 31970,
  [SMALL_STATE(845)] = 32109,
  [SMALL_STATE(846)] = 32248,
  [SMALL_STATE(847)] = 32387,
  [SMALL_STATE(848)] = 32526,
  [SMALL_STATE(849)] = 32665,
  [SMALL_STATE(850)] = 32804,
  [SMALL_STATE(851)] = 32947,
  [SMALL_STATE(852)] = 33086,
  [SMALL_STATE(853)] = 33229,
  [SMALL_STATE(854)] = 33368,
  [SMALL_STATE(855)] = 33507,
  [SMALL_STATE(856)] = 33646,
  [SMALL_STATE(857)] = 33785,
  [SMALL_STATE(858)] = 33924,
  [SMALL_STATE(859)] = 34063,
  [SMALL_STATE(860)] = 34202,
  [SMALL_STATE(861)] = 34341,
  [SMALL_STATE(862)] = 34480,
  [SMALL_STATE(863)] = 34619,
  [SMALL_STATE(864)] = 34758,
  [SMALL_STATE(865)] = 34897,
  [SMALL_STATE(866)] = 35036,
  [SMALL_STATE(867)] = 35175,
  [SMALL_STATE(868)] = 35314,
  [SMALL_STATE(869)] = 35453,
  [SMALL_STATE(870)] = 35592,
  [SMALL_STATE(871)] = 35731,
  [SMALL_STATE(872)] = 35870,
  [SMALL_STATE(873)] = 36009,
  [SMALL_STATE(874)] = 36148,
  [SMALL_STATE(875)] = 36287,
  [SMALL_STATE(876)] = 36426,
  [SMALL_STATE(877)] = 36565,
  [SMALL_STATE(878)] = 36704,
  [SMALL_STATE(879)] = 36843,
  [SMALL_STATE(880)] = 36982,
  [SMALL_STATE(881)] = 37121,
  [SMALL_STATE(882)] = 37260,
  [SMALL_STATE(883)] = 37399,
  [SMALL_STATE(884)] = 37538,
  [SMALL_STATE(885)] = 37677,
  [SMALL_STATE(886)] = 37816,
  [SMALL_STATE(887)] = 37955,
  [SMALL_STATE(888)] = 38094,
  [SMALL_STATE(889)] = 38233,
  [SMALL_STATE(890)] = 38372,
  [SMALL_STATE(891)] = 38511,
  [SMALL_STATE(892)] = 38650,
  [SMALL_STATE(893)] = 38789,
  [SMALL_STATE(894)] = 38928,
  [SMALL_STATE(895)] = 39067,
  [SMALL_STATE(896)] = 39206,
  [SMALL_STATE(897)] = 39345,
  [SMALL_STATE(898)] = 39484,
  [SMALL_STATE(899)] = 39623,
  [SMALL_STATE(900)] = 39762,
  [SMALL_STATE(901)] = 39901,
  [SMALL_STATE(902)] = 40040,
  [SMALL_STATE(903)] = 40179,
  [SMALL_STATE(904)] = 40318,
  [SMALL_STATE(905)] = 40457,
  [SMALL_STATE(906)] = 40596,
  [SMALL_STATE(907)] = 40735,
  [SMALL_STATE(908)] = 40874,
  [SMALL_STATE(909)] = 41013,
  [SMALL_STATE(910)] = 41152,
  [SMALL_STATE(911)] = 41291,
  [SMALL_STATE(912)] = 41430,
  [SMALL_STATE(913)] = 41569,
  [SMALL_STATE(914)] = 41708,
  [SMALL_STATE(915)] = 41847,
  [SMALL_STATE(916)] = 41986,
  [SMALL_STATE(917)] = 42125,
  [SMALL_STATE(918)] = 42264,
  [SMALL_STATE(919)] = 42403,
  [SMALL_STATE(920)] = 42542,
  [SMALL_STATE(921)] = 42681,
  [SMALL_STATE(922)] = 42820,
  [SMALL_STATE(923)] = 42959,
  [SMALL_STATE(924)] = 43098,
  [SMALL_STATE(925)] = 43237,
  [SMALL_STATE(926)] = 43376,
  [SMALL_STATE(927)] = 43515,
  [SMALL_STATE(928)] = 43654,
  [SMALL_STATE(929)] = 43793,
  [SMALL_STATE(930)] = 43932,
  [SMALL_STATE(931)] = 44071,
  [SMALL_STATE(932)] = 44210,
  [SMALL_STATE(933)] = 44349,
  [SMALL_STATE(934)] = 44488,
  [SMALL_STATE(935)] = 44627,
  [SMALL_STATE(936)] = 44766,
  [SMALL_STATE(937)] = 44905,
  [SMALL_STATE(938)] = 45044,
  [SMALL_STATE(939)] = 45183,
  [SMALL_STATE(940)] = 45322,
  [SMALL_STATE(941)] = 45461,
  [SMALL_STATE(942)] = 45600,
  [SMALL_STATE(943)] = 45739,
  [SMALL_STATE(944)] = 45878,
  [SMALL_STATE(945)] = 46017,
  [SMALL_STATE(946)] = 46156,
  [SMALL_STATE(947)] = 46295,
  [SMALL_STATE(948)] = 46434,
  [SMALL_STATE(949)] = 46573,
  [SMALL_STATE(950)] = 46712,
  [SMALL_STATE(951)] = 46851,
  [SMALL_STATE(952)] = 46990,
  [SMALL_STATE(953)] = 47129,
  [SMALL_STATE(954)] = 47268,
  [SMALL_STATE(955)] = 47407,
  [SMALL_STATE(956)] = 47546,
  [SMALL_STATE(957)] = 47685,
  [SMALL_STATE(958)] = 47824,
  [SMALL_STATE(959)] = 47963,
  [SMALL_STATE(960)] = 48102,
  [SMALL_STATE(961)] = 48241,
  [SMALL_STATE(962)] = 48380,
  [SMALL_STATE(963)] = 48519,
  [SMALL_STATE(964)] = 48658,
  [SMALL_STATE(965)] = 48797,
  [SMALL_STATE(966)] = 48936,
  [SMALL_STATE(967)] = 49075,
  [SMALL_STATE(968)] = 49214,
  [SMALL_STATE(969)] = 49353,
  [SMALL_STATE(970)] = 49492,
  [SMALL_STATE(971)] = 49631,
  [SMALL_STATE(972)] = 49770,
  [SMALL_STATE(973)] = 49909,
  [SMALL_STATE(974)] = 50048,
  [SMALL_STATE(975)] = 50187,
  [SMALL_STATE(976)] = 50326,
  [SMALL_STATE(977)] = 50465,
  [SMALL_STATE(978)] = 50604,
  [SMALL_STATE(979)] = 50743,
  [SMALL_STATE(980)] = 50882,
  [SMALL_STATE(981)] = 51021,
  [SMALL_STATE(982)] = 51160,
  [SMALL_STATE(983)] = 51299,
  [SMALL_STATE(984)] = 51438,
  [SMALL_STATE(985)] = 51577,
  [SMALL_STATE(986)] = 51716,
  [SMALL_STATE(987)] = 51855,
  [SMALL_STATE(988)] = 51994,
  [SMALL_STATE(989)] = 52133,
  [SMALL_STATE(990)] = 52272,
  [SMALL_STATE(991)] = 52411,
  [SMALL_STATE(992)] = 52550,
  [SMALL_STATE(993)] = 52689,
  [SMALL_STATE(994)] = 52828,
  [SMALL_STATE(995)] = 52967,
  [SMALL_STATE(996)] = 53106,
  [SMALL_STATE(997)] = 53245,
  [SMALL_STATE(998)] = 53384,
  [SMALL_STATE(999)] = 53523,
  [SMALL_STATE(1000)] = 53662,
  [SMALL_STATE(1001)] = 53801,
  [SMALL_STATE(1002)] = 53940,
  [SMALL_STATE(1003)] = 54079,
  [SMALL_STATE(1004)] = 54218,
  [SMALL_STATE(1005)] = 54357,
  [SMALL_STATE(1006)] = 54496,
  [SMALL_STATE(1007)] = 54635,
  [SMALL_STATE(1008)] = 54774,
  [SMALL_STATE(1009)] = 54913,
  [SMALL_STATE(1010)] = 55052,
  [SMALL_STATE(1011)] = 55191,
  [SMALL_STATE(1012)] = 55330,
  [SMALL_STATE(1013)] = 55469,
  [SMALL_STATE(1014)] = 55608,
  [SMALL_STATE(1015)] = 55747,
  [SMALL_STATE(1016)] = 55886,
  [SMALL_STATE(1017)] = 56025,
  [SMALL_STATE(1018)] = 56164,
  [SMALL_STATE(1019)] = 56303,
  [SMALL_STATE(1020)] = 56442,
  [SMALL_STATE(1021)] = 56581,
  [SMALL_STATE(1022)] = 56720,
  [SMALL_STATE(1023)] = 56859,
  [SMALL_STATE(1024)] = 56998,
  [SMALL_STATE(1025)] = 57137,
  [SMALL_STATE(1026)] = 57276,
  [SMALL_STATE(1027)] = 57415,
  [SMALL_STATE(1028)] = 57554,
  [SMALL_STATE(1029)] = 57693,
  [SMALL_STATE(1030)] = 57832,
  [SMALL_STATE(1031)] = 57971,
  [SMALL_STATE(1032)] = 58110,
  [SMALL_STATE(1033)] = 58249,
  [SMALL_STATE(1034)] = 58388,
  [SMALL_STATE(1035)] = 58527,
  [SMALL_STATE(1036)] = 58666,
  [SMALL_STATE(1037)] = 58805,
  [SMALL_STATE(1038)] = 58944,
  [SMALL_STATE(1039)] = 59083,
  [SMALL_STATE(1040)] = 59222,
  [SMALL_STATE(1041)] = 59361,
  [SMALL_STATE(1042)] = 59500,
  [SMALL_STATE(1043)] = 59639,
  [SMALL_STATE(1044)] = 59778,
  [SMALL_STATE(1045)] = 59917,
  [SMALL_STATE(1046)] = 60056,
  [SMALL_STATE(1047)] = 60195,
  [SMALL_STATE(1048)] = 60334,
  [SMALL_STATE(1049)] = 60473,
  [SMALL_STATE(1050)] = 60612,
  [SMALL_STATE(1051)] = 60751,
  [SMALL_STATE(1052)] = 60890,
  [SMALL_STATE(1053)] = 61029,
  [SMALL_STATE(1054)] = 61168,
  [SMALL_STATE(1055)] = 61307,
  [SMALL_STATE(1056)] = 61446,
  [SMALL_STATE(1057)] = 61585,
  [SMALL_STATE(1058)] = 61724,
  [SMALL_STATE(1059)] = 61863,
  [SMALL_STATE(1060)] = 62002,
  [SMALL_STATE(1061)] = 62141,
  [SMALL_STATE(1062)] = 62280,
  [SMALL_STATE(1063)] = 62419,
  [SMALL_STATE(1064)] = 62558,
  [SMALL_STATE(1065)] = 62697,
  [SMALL_STATE(1066)] = 62836,
  [SMALL_STATE(1067)] = 62979,
  [SMALL_STATE(1068)] = 63122,
  [SMALL_STATE(1069)] = 63261,
  [SMALL_STATE(1070)] = 63400,
  [SMALL_STATE(1071)] = 63539,
  [SMALL_STATE(1072)] = 63678,
  [SMALL_STATE(1073)] = 63817,
  [SMALL_STATE(1074)] = 63956,
  [SMALL_STATE(1075)] = 64095,
  [SMALL_STATE(1076)] = 64234,
  [SMALL_STATE(1077)] = 64373,
  [SMALL_STATE(1078)] = 64512,
  [SMALL_STATE(1079)] = 64651,
  [SMALL_STATE(1080)] = 64790,
  [SMALL_STATE(1081)] = 64929,
  [SMALL_STATE(1082)] = 65068,
  [SMALL_STATE(1083)] = 65207,
  [SMALL_STATE(1084)] = 65346,
  [SMALL_STATE(1085)] = 65485,
  [SMALL_STATE(1086)] = 65624,
  [SMALL_STATE(1087)] = 65763,
  [SMALL_STATE(1088)] = 65902,
  [SMALL_STATE(1089)] = 66041,
  [SMALL_STATE(1090)] = 66180,
  [SMALL_STATE(1091)] = 66319,
  [SMALL_STATE(1092)] = 66458,
  [SMALL_STATE(1093)] = 66597,
  [SMALL_STATE(1094)] = 66736,
  [SMALL_STATE(1095)] = 66875,
  [SMALL_STATE(1096)] = 67014,
  [SMALL_STATE(1097)] = 67153,
  [SMALL_STATE(1098)] = 67292,
  [SMALL_STATE(1099)] = 67431,
  [SMALL_STATE(1100)] = 67570,
  [SMALL_STATE(1101)] = 67709,
  [SMALL_STATE(1102)] = 67848,
  [SMALL_STATE(1103)] = 67987,
  [SMALL_STATE(1104)] = 68126,
  [SMALL_STATE(1105)] = 68265,
  [SMALL_STATE(1106)] = 68404,
  [SMALL_STATE(1107)] = 68543,
  [SMALL_STATE(1108)] = 68682,
  [SMALL_STATE(1109)] = 68821,
  [SMALL_STATE(1110)] = 68960,
  [SMALL_STATE(1111)] = 69099,
  [SMALL_STATE(1112)] = 69238,
  [SMALL_STATE(1113)] = 69377,
  [SMALL_STATE(1114)] = 69516,
  [SMALL_STATE(1115)] = 69655,
  [SMALL_STATE(1116)] = 69794,
  [SMALL_STATE(1117)] = 69933,
  [SMALL_STATE(1118)] = 70072,
  [SMALL_STATE(1119)] = 70211,
  [SMALL_STATE(1120)] = 70350,
  [SMALL_STATE(1121)] = 70489,
  [SMALL_STATE(1122)] = 70628,
  [SMALL_STATE(1123)] = 70767,
  [SMALL_STATE(1124)] = 70906,
  [SMALL_STATE(1125)] = 71045,
  [SMALL_STATE(1126)] = 71184,
  [SMALL_STATE(1127)] = 71323,
  [SMALL_STATE(1128)] = 71462,
  [SMALL_STATE(1129)] = 71601,
  [SMALL_STATE(1130)] = 71740,
  [SMALL_STATE(1131)] = 71879,
  [SMALL_STATE(1132)] = 72018,
  [SMALL_STATE(1133)] = 72157,
  [SMALL_STATE(1134)] = 72296,
  [SMALL_STATE(1135)] = 72435,
  [SMALL_STATE(1136)] = 72574,
  [SMALL_STATE(1137)] = 72713,
  [SMALL_STATE(1138)] = 72852,
  [SMALL_STATE(1139)] = 72991,
  [SMALL_STATE(1140)] = 73130,
  [SMALL_STATE(1141)] = 73269,
  [SMALL_STATE(1142)] = 73408,
  [SMALL_STATE(1143)] = 73547,
  [SMALL_STATE(1144)] = 73686,
  [SMALL_STATE(1145)] = 73825,
  [SMALL_STATE(1146)] = 73964,
  [SMALL_STATE(1147)] = 74103,
  [SMALL_STATE(1148)] = 74242,
  [SMALL_STATE(1149)] = 74381,
  [SMALL_STATE(1150)] = 74520,
  [SMALL_STATE(1151)] = 74659,
  [SMALL_STATE(1152)] = 74798,
  [SMALL_STATE(1153)] = 74937,
  [SMALL_STATE(1154)] = 75076,
  [SMALL_STATE(1155)] = 75215,
  [SMALL_STATE(1156)] = 75354,
  [SMALL_STATE(1157)] = 75493,
  [SMALL_STATE(1158)] = 75632,
  [SMALL_STATE(1159)] = 75771,
  [SMALL_STATE(1160)] = 75910,
  [SMALL_STATE(1161)] = 76049,
  [SMALL_STATE(1162)] = 76188,
  [SMALL_STATE(1163)] = 76327,
  [SMALL_STATE(1164)] = 76466,
  [SMALL_STATE(1165)] = 76605,
  [SMALL_STATE(1166)] = 76744,
  [SMALL_STATE(1167)] = 76883,
  [SMALL_STATE(1168)] = 77022,
  [SMALL_STATE(1169)] = 77161,
  [SMALL_STATE(1170)] = 77300,
  [SMALL_STATE(1171)] = 77439,
  [SMALL_STATE(1172)] = 77578,
  [SMALL_STATE(1173)] = 77717,
  [SMALL_STATE(1174)] = 77856,
  [SMALL_STATE(1175)] = 77995,
  [SMALL_STATE(1176)] = 78134,
  [SMALL_STATE(1177)] = 78273,
  [SMALL_STATE(1178)] = 78412,
  [SMALL_STATE(1179)] = 78551,
  [SMALL_STATE(1180)] = 78690,
  [SMALL_STATE(1181)] = 78829,
  [SMALL_STATE(1182)] = 78968,
  [SMALL_STATE(1183)] = 79107,
  [SMALL_STATE(1184)] = 79246,
  [SMALL_STATE(1185)] = 79385,
  [SMALL_STATE(1186)] = 79524,
  [SMALL_STATE(1187)] = 79663,
  [SMALL_STATE(1188)] = 79802,
  [SMALL_STATE(1189)] = 79941,
  [SMALL_STATE(1190)] = 80080,
  [SMALL_STATE(1191)] = 80219,
  [SMALL_STATE(1192)] = 80358,
  [SMALL_STATE(1193)] = 80497,
  [SMALL_STATE(1194)] = 80636,
  [SMALL_STATE(1195)] = 80775,
  [SMALL_STATE(1196)] = 80914,
  [SMALL_STATE(1197)] = 81053,
  [SMALL_STATE(1198)] = 81192,
  [SMALL_STATE(1199)] = 81331,
  [SMALL_STATE(1200)] = 81470,
  [SMALL_STATE(1201)] = 81609,
  [SMALL_STATE(1202)] = 81748,
  [SMALL_STATE(1203)] = 81887,
  [SMALL_STATE(1204)] = 82026,
  [SMALL_STATE(1205)] = 82165,
  [SMALL_STATE(1206)] = 82304,
  [SMALL_STATE(1207)] = 82443,
  [SMALL_STATE(1208)] = 82582,
  [SMALL_STATE(1209)] = 82721,
  [SMALL_STATE(1210)] = 82860,
  [SMALL_STATE(1211)] = 82999,
  [SMALL_STATE(1212)] = 83138,
  [SMALL_STATE(1213)] = 83277,
  [SMALL_STATE(1214)] = 83416,
  [SMALL_STATE(1215)] = 83555,
  [SMALL_STATE(1216)] = 83694,
  [SMALL_STATE(1217)] = 83833,
  [SMALL_STATE(1218)] = 83972,
  [SMALL_STATE(1219)] = 84111,
  [SMALL_STATE(1220)] = 84250,
  [SMALL_STATE(1221)] = 84389,
  [SMALL_STATE(1222)] = 84528,
  [SMALL_STATE(1223)] = 84667,
  [SMALL_STATE(1224)] = 84806,
  [SMALL_STATE(1225)] = 84945,
  [SMALL_STATE(1226)] = 85084,
  [SMALL_STATE(1227)] = 85223,
  [SMALL_STATE(1228)] = 85362,
  [SMALL_STATE(1229)] = 85501,
  [SMALL_STATE(1230)] = 85640,
  [SMALL_STATE(1231)] = 85779,
  [SMALL_STATE(1232)] = 85918,
  [SMALL_STATE(1233)] = 86057,
  [SMALL_STATE(1234)] = 86196,
  [SMALL_STATE(1235)] = 86335,
  [SMALL_STATE(1236)] = 86474,
  [SMALL_STATE(1237)] = 86613,
  [SMALL_STATE(1238)] = 86752,
  [SMALL_STATE(1239)] = 86891,
  [SMALL_STATE(1240)] = 87030,
  [SMALL_STATE(1241)] = 87169,
  [SMALL_STATE(1242)] = 87308,
  [SMALL_STATE(1243)] = 87447,
  [SMALL_STATE(1244)] = 87586,
  [SMALL_STATE(1245)] = 87725,
  [SMALL_STATE(1246)] = 87864,
  [SMALL_STATE(1247)] = 88003,
  [SMALL_STATE(1248)] = 88142,
  [SMALL_STATE(1249)] = 88281,
  [SMALL_STATE(1250)] = 88420,
  [SMALL_STATE(1251)] = 88559,
  [SMALL_STATE(1252)] = 88698,
  [SMALL_STATE(1253)] = 88837,
  [SMALL_STATE(1254)] = 88976,
  [SMALL_STATE(1255)] = 89115,
  [SMALL_STATE(1256)] = 89254,
  [SMALL_STATE(1257)] = 89393,
  [SMALL_STATE(1258)] = 89532,
  [SMALL_STATE(1259)] = 89671,
  [SMALL_STATE(1260)] = 89810,
  [SMALL_STATE(1261)] = 89949,
  [SMALL_STATE(1262)] = 90088,
  [SMALL_STATE(1263)] = 90227,
  [SMALL_STATE(1264)] = 90366,
  [SMALL_STATE(1265)] = 90505,
  [SMALL_STATE(1266)] = 90644,
  [SMALL_STATE(1267)] = 90783,
  [SMALL_STATE(1268)] = 90922,
  [SMALL_STATE(1269)] = 91061,
  [SMALL_STATE(1270)] = 91200,
  [SMALL_STATE(1271)] = 91339,
  [SMALL_STATE(1272)] = 91478,
  [SMALL_STATE(1273)] = 91617,
  [SMALL_STATE(1274)] = 91756,
  [SMALL_STATE(1275)] = 91895,
  [SMALL_STATE(1276)] = 92034,
  [SMALL_STATE(1277)] = 92173,
  [SMALL_STATE(1278)] = 92312,
  [SMALL_STATE(1279)] = 92451,
  [SMALL_STATE(1280)] = 92590,
  [SMALL_STATE(1281)] = 92729,
  [SMALL_STATE(1282)] = 92868,
  [SMALL_STATE(1283)] = 93007,
  [SMALL_STATE(1284)] = 93146,
  [SMALL_STATE(1285)] = 93285,
  [SMALL_STATE(1286)] = 93424,
  [SMALL_STATE(1287)] = 93563,
  [SMALL_STATE(1288)] = 93702,
  [SMALL_STATE(1289)] = 93841,
  [SMALL_STATE(1290)] = 93980,
  [SMALL_STATE(1291)] = 94119,
  [SMALL_STATE(1292)] = 94258,
  [SMALL_STATE(1293)] = 94397,
  [SMALL_STATE(1294)] = 94536,
  [SMALL_STATE(1295)] = 94675,
  [SMALL_STATE(1296)] = 94814,
  [SMALL_STATE(1297)] = 94953,
  [SMALL_STATE(1298)] = 95092,
  [SMALL_STATE(1299)] = 95231,
  [SMALL_STATE(1300)] = 95370,
  [SMALL_STATE(1301)] = 95509,
  [SMALL_STATE(1302)] = 95648,
  [SMALL_STATE(1303)] = 95787,
  [SMALL_STATE(1304)] = 95926,
  [SMALL_STATE(1305)] = 96065,
  [SMALL_STATE(1306)] = 96204,
  [SMALL_STATE(1307)] = 96343,
  [SMALL_STATE(1308)] = 96482,
  [SMALL_STATE(1309)] = 96621,
  [SMALL_STATE(1310)] = 96760,
  [SMALL_STATE(1311)] = 96899,
  [SMALL_STATE(1312)] = 97038,
  [SMALL_STATE(1313)] = 97177,
  [SMALL_STATE(1314)] = 97316,
  [SMALL_STATE(1315)] = 97455,
  [SMALL_STATE(1316)] = 97594,
  [SMALL_STATE(1317)] = 97733,
  [SMALL_STATE(1318)] = 97872,
  [SMALL_STATE(1319)] = 98011,
  [SMALL_STATE(1320)] = 98150,
  [SMALL_STATE(1321)] = 98289,
  [SMALL_STATE(1322)] = 98428,
  [SMALL_STATE(1323)] = 98567,
  [SMALL_STATE(1324)] = 98706,
  [SMALL_STATE(1325)] = 98845,
  [SMALL_STATE(1326)] = 98984,
  [SMALL_STATE(1327)] = 99123,
  [SMALL_STATE(1328)] = 99262,
  [SMALL_STATE(1329)] = 99401,
  [SMALL_STATE(1330)] = 99540,
  [SMALL_STATE(1331)] = 99679,
  [SMALL_STATE(1332)] = 99818,
  [SMALL_STATE(1333)] = 99957,
  [SMALL_STATE(1334)] = 100096,
  [SMALL_STATE(1335)] = 100235,
  [SMALL_STATE(1336)] = 100374,
  [SMALL_STATE(1337)] = 100513,
  [SMALL_STATE(1338)] = 100652,
  [SMALL_STATE(1339)] = 100791,
  [SMALL_STATE(1340)] = 100930,
  [SMALL_STATE(1341)] = 101069,
  [SMALL_STATE(1342)] = 101208,
  [SMALL_STATE(1343)] = 101347,
  [SMALL_STATE(1344)] = 101486,
  [SMALL_STATE(1345)] = 101625,
  [SMALL_STATE(1346)] = 101764,
  [SMALL_STATE(1347)] = 101903,
  [SMALL_STATE(1348)] = 102042,
  [SMALL_STATE(1349)] = 102181,
  [SMALL_STATE(1350)] = 102320,
  [SMALL_STATE(1351)] = 102459,
  [SMALL_STATE(1352)] = 102598,
  [SMALL_STATE(1353)] = 102737,
  [SMALL_STATE(1354)] = 102876,
  [SMALL_STATE(1355)] = 103015,
  [SMALL_STATE(1356)] = 103154,
  [SMALL_STATE(1357)] = 103293,
  [SMALL_STATE(1358)] = 103432,
  [SMALL_STATE(1359)] = 103571,
  [SMALL_STATE(1360)] = 103710,
  [SMALL_STATE(1361)] = 103849,
  [SMALL_STATE(1362)] = 103988,
  [SMALL_STATE(1363)] = 104127,
  [SMALL_STATE(1364)] = 104266,
  [SMALL_STATE(1365)] = 104405,
  [SMALL_STATE(1366)] = 104544,
  [SMALL_STATE(1367)] = 104683,
  [SMALL_STATE(1368)] = 104822,
  [SMALL_STATE(1369)] = 104961,
  [SMALL_STATE(1370)] = 105100,
  [SMALL_STATE(1371)] = 105239,
  [SMALL_STATE(1372)] = 105378,
  [SMALL_STATE(1373)] = 105517,
  [SMALL_STATE(1374)] = 105656,
  [SMALL_STATE(1375)] = 105795,
  [SMALL_STATE(1376)] = 105934,
  [SMALL_STATE(1377)] = 106073,
  [SMALL_STATE(1378)] = 106212,
  [SMALL_STATE(1379)] = 106351,
  [SMALL_STATE(1380)] = 106490,
  [SMALL_STATE(1381)] = 106629,
  [SMALL_STATE(1382)] = 106768,
  [SMALL_STATE(1383)] = 106907,
  [SMALL_STATE(1384)] = 107046,
  [SMALL_STATE(1385)] = 107185,
  [SMALL_STATE(1386)] = 107324,
  [SMALL_STATE(1387)] = 107463,
  [SMALL_STATE(1388)] = 107602,
  [SMALL_STATE(1389)] = 107741,
  [SMALL_STATE(1390)] = 107880,
  [SMALL_STATE(1391)] = 108019,
  [SMALL_STATE(1392)] = 108158,
  [SMALL_STATE(1393)] = 108297,
  [SMALL_STATE(1394)] = 108436,
  [SMALL_STATE(1395)] = 108575,
  [SMALL_STATE(1396)] = 108714,
  [SMALL_STATE(1397)] = 108850,
  [SMALL_STATE(1398)] = 108984,
  [SMALL_STATE(1399)] = 109120,
  [SMALL_STATE(1400)] = 109256,
  [SMALL_STATE(1401)] = 109392,
  [SMALL_STATE(1402)] = 109528,
  [SMALL_STATE(1403)] = 109664,
  [SMALL_STATE(1404)] = 109800,
  [SMALL_STATE(1405)] = 109936,
  [SMALL_STATE(1406)] = 110072,
  [SMALL_STATE(1407)] = 110208,
  [SMALL_STATE(1408)] = 110344,
  [SMALL_STATE(1409)] = 110480,
  [SMALL_STATE(1410)] = 110616,
  [SMALL_STATE(1411)] = 110752,
  [SMALL_STATE(1412)] = 110888,
  [SMALL_STATE(1413)] = 111024,
  [SMALL_STATE(1414)] = 111160,
  [SMALL_STATE(1415)] = 111292,
  [SMALL_STATE(1416)] = 111428,
  [SMALL_STATE(1417)] = 111564,
  [SMALL_STATE(1418)] = 111700,
  [SMALL_STATE(1419)] = 111836,
  [SMALL_STATE(1420)] = 111972,
  [SMALL_STATE(1421)] = 112108,
  [SMALL_STATE(1422)] = 112244,
  [SMALL_STATE(1423)] = 112380,
  [SMALL_STATE(1424)] = 112514,
  [SMALL_STATE(1425)] = 112650,
  [SMALL_STATE(1426)] = 112786,
  [SMALL_STATE(1427)] = 112922,
  [SMALL_STATE(1428)] = 113058,
  [SMALL_STATE(1429)] = 113194,
  [SMALL_STATE(1430)] = 113330,
  [SMALL_STATE(1431)] = 113466,
  [SMALL_STATE(1432)] = 113602,
  [SMALL_STATE(1433)] = 113738,
  [SMALL_STATE(1434)] = 113874,
  [SMALL_STATE(1435)] = 114010,
  [SMALL_STATE(1436)] = 114146,
  [SMALL_STATE(1437)] = 114280,
  [SMALL_STATE(1438)] = 114416,
  [SMALL_STATE(1439)] = 114552,
  [SMALL_STATE(1440)] = 114688,
  [SMALL_STATE(1441)] = 114824,
  [SMALL_STATE(1442)] = 114960,
  [SMALL_STATE(1443)] = 115096,
  [SMALL_STATE(1444)] = 115232,
  [SMALL_STATE(1445)] = 115368,
  [SMALL_STATE(1446)] = 115504,
  [SMALL_STATE(1447)] = 115640,
  [SMALL_STATE(1448)] = 115776,
  [SMALL_STATE(1449)] = 115912,
  [SMALL_STATE(1450)] = 116048,
  [SMALL_STATE(1451)] = 116184,
  [SMALL_STATE(1452)] = 116320,
  [SMALL_STATE(1453)] = 116456,
  [SMALL_STATE(1454)] = 116592,
  [SMALL_STATE(1455)] = 116728,
  [SMALL_STATE(1456)] = 116864,
  [SMALL_STATE(1457)] = 117000,
  [SMALL_STATE(1458)] = 117136,
  [SMALL_STATE(1459)] = 117272,
  [SMALL_STATE(1460)] = 117408,
  [SMALL_STATE(1461)] = 117544,
  [SMALL_STATE(1462)] = 117680,
  [SMALL_STATE(1463)] = 117816,
  [SMALL_STATE(1464)] = 117948,
  [SMALL_STATE(1465)] = 118084,
  [SMALL_STATE(1466)] = 118220,
  [SMALL_STATE(1467)] = 118356,
  [SMALL_STATE(1468)] = 118492,
  [SMALL_STATE(1469)] = 118628,
  [SMALL_STATE(1470)] = 118764,
  [SMALL_STATE(1471)] = 118900,
  [SMALL_STATE(1472)] = 119036,
  [SMALL_STATE(1473)] = 119172,
  [SMALL_STATE(1474)] = 119308,
  [SMALL_STATE(1475)] = 119444,
  [SMALL_STATE(1476)] = 119580,
  [SMALL_STATE(1477)] = 119716,
  [SMALL_STATE(1478)] = 119852,
  [SMALL_STATE(1479)] = 119988,
  [SMALL_STATE(1480)] = 120124,
  [SMALL_STATE(1481)] = 120256,
  [SMALL_STATE(1482)] = 120392,
  [SMALL_STATE(1483)] = 120528,
  [SMALL_STATE(1484)] = 120664,
  [SMALL_STATE(1485)] = 120800,
  [SMALL_STATE(1486)] = 120936,
  [SMALL_STATE(1487)] = 121072,
  [SMALL_STATE(1488)] = 121208,
  [SMALL_STATE(1489)] = 121344,
  [SMALL_STATE(1490)] = 121480,
  [SMALL_STATE(1491)] = 121616,
  [SMALL_STATE(1492)] = 121752,
  [SMALL_STATE(1493)] = 121888,
  [SMALL_STATE(1494)] = 122024,
  [SMALL_STATE(1495)] = 122160,
  [SMALL_STATE(1496)] = 122296,
  [SMALL_STATE(1497)] = 122432,
  [SMALL_STATE(1498)] = 122568,
  [SMALL_STATE(1499)] = 122704,
  [SMALL_STATE(1500)] = 122840,
  [SMALL_STATE(1501)] = 122976,
  [SMALL_STATE(1502)] = 123112,
  [SMALL_STATE(1503)] = 123248,
  [SMALL_STATE(1504)] = 123382,
  [SMALL_STATE(1505)] = 123518,
  [SMALL_STATE(1506)] = 123654,
  [SMALL_STATE(1507)] = 123790,
  [SMALL_STATE(1508)] = 123926,
  [SMALL_STATE(1509)] = 124062,
  [SMALL_STATE(1510)] = 124198,
  [SMALL_STATE(1511)] = 124334,
  [SMALL_STATE(1512)] = 124470,
  [SMALL_STATE(1513)] = 124606,
  [SMALL_STATE(1514)] = 124738,
  [SMALL_STATE(1515)] = 124874,
  [SMALL_STATE(1516)] = 125010,
  [SMALL_STATE(1517)] = 125146,
  [SMALL_STATE(1518)] = 125282,
  [SMALL_STATE(1519)] = 125418,
  [SMALL_STATE(1520)] = 125554,
  [SMALL_STATE(1521)] = 125690,
  [SMALL_STATE(1522)] = 125826,
  [SMALL_STATE(1523)] = 125962,
  [SMALL_STATE(1524)] = 126098,
  [SMALL_STATE(1525)] = 126234,
  [SMALL_STATE(1526)] = 126368,
  [SMALL_STATE(1527)] = 126504,
  [SMALL_STATE(1528)] = 126640,
  [SMALL_STATE(1529)] = 126776,
  [SMALL_STATE(1530)] = 126912,
  [SMALL_STATE(1531)] = 127048,
  [SMALL_STATE(1532)] = 127184,
  [SMALL_STATE(1533)] = 127320,
  [SMALL_STATE(1534)] = 127456,
  [SMALL_STATE(1535)] = 127592,
  [SMALL_STATE(1536)] = 127728,
  [SMALL_STATE(1537)] = 127864,
  [SMALL_STATE(1538)] = 128000,
  [SMALL_STATE(1539)] = 128136,
  [SMALL_STATE(1540)] = 128272,
  [SMALL_STATE(1541)] = 128408,
  [SMALL_STATE(1542)] = 128544,
  [SMALL_STATE(1543)] = 128680,
  [SMALL_STATE(1544)] = 128816,
  [SMALL_STATE(1545)] = 128952,
  [SMALL_STATE(1546)] = 129088,
  [SMALL_STATE(1547)] = 129224,
  [SMALL_STATE(1548)] = 129360,
  [SMALL_STATE(1549)] = 129496,
  [SMALL_STATE(1550)] = 129632,
  [SMALL_STATE(1551)] = 129766,
  [SMALL_STATE(1552)] = 129902,
  [SMALL_STATE(1553)] = 130038,
  [SMALL_STATE(1554)] = 130174,
  [SMALL_STATE(1555)] = 130310,
  [SMALL_STATE(1556)] = 130446,
  [SMALL_STATE(1557)] = 130582,
  [SMALL_STATE(1558)] = 130718,
  [SMALL_STATE(1559)] = 130854,
  [SMALL_STATE(1560)] = 130990,
  [SMALL_STATE(1561)] = 131126,
  [SMALL_STATE(1562)] = 131262,
  [SMALL_STATE(1563)] = 131398,
  [SMALL_STATE(1564)] = 131534,
  [SMALL_STATE(1565)] = 131670,
  [SMALL_STATE(1566)] = 131806,
  [SMALL_STATE(1567)] = 131942,
  [SMALL_STATE(1568)] = 132078,
  [SMALL_STATE(1569)] = 132210,
  [SMALL_STATE(1570)] = 132346,
  [SMALL_STATE(1571)] = 132482,
  [SMALL_STATE(1572)] = 132618,
  [SMALL_STATE(1573)] = 132754,
  [SMALL_STATE(1574)] = 132890,
  [SMALL_STATE(1575)] = 133026,
  [SMALL_STATE(1576)] = 133162,
  [SMALL_STATE(1577)] = 133298,
  [SMALL_STATE(1578)] = 133434,
  [SMALL_STATE(1579)] = 133570,
  [SMALL_STATE(1580)] = 133706,
  [SMALL_STATE(1581)] = 133842,
  [SMALL_STATE(1582)] = 133978,
  [SMALL_STATE(1583)] = 134114,
  [SMALL_STATE(1584)] = 134250,
  [SMALL_STATE(1585)] = 134386,
  [SMALL_STATE(1586)] = 134522,
  [SMALL_STATE(1587)] = 134658,
  [SMALL_STATE(1588)] = 134794,
  [SMALL_STATE(1589)] = 134930,
  [SMALL_STATE(1590)] = 135066,
  [SMALL_STATE(1591)] = 135202,
  [SMALL_STATE(1592)] = 135338,
  [SMALL_STATE(1593)] = 135474,
  [SMALL_STATE(1594)] = 135610,
  [SMALL_STATE(1595)] = 135746,
  [SMALL_STATE(1596)] = 135882,
  [SMALL_STATE(1597)] = 136018,
  [SMALL_STATE(1598)] = 136152,
  [SMALL_STATE(1599)] = 136288,
  [SMALL_STATE(1600)] = 136424,
  [SMALL_STATE(1601)] = 136560,
  [SMALL_STATE(1602)] = 136696,
  [SMALL_STATE(1603)] = 136832,
  [SMALL_STATE(1604)] = 136968,
  [SMALL_STATE(1605)] = 137100,
  [SMALL_STATE(1606)] = 137236,
  [SMALL_STATE(1607)] = 137372,
  [SMALL_STATE(1608)] = 137508,
  [SMALL_STATE(1609)] = 137644,
  [SMALL_STATE(1610)] = 137780,
  [SMALL_STATE(1611)] = 137916,
  [SMALL_STATE(1612)] = 138052,
  [SMALL_STATE(1613)] = 138184,
  [SMALL_STATE(1614)] = 138320,
  [SMALL_STATE(1615)] = 138456,
  [SMALL_STATE(1616)] = 138590,
  [SMALL_STATE(1617)] = 138726,
  [SMALL_STATE(1618)] = 138862,
  [SMALL_STATE(1619)] = 138998,
  [SMALL_STATE(1620)] = 139134,
  [SMALL_STATE(1621)] = 139270,
  [SMALL_STATE(1622)] = 139406,
  [SMALL_STATE(1623)] = 139542,
  [SMALL_STATE(1624)] = 139678,
  [SMALL_STATE(1625)] = 139814,
  [SMALL_STATE(1626)] = 139950,
  [SMALL_STATE(1627)] = 140086,
  [SMALL_STATE(1628)] = 140222,
  [SMALL_STATE(1629)] = 140358,
  [SMALL_STATE(1630)] = 140494,
  [SMALL_STATE(1631)] = 140630,
  [SMALL_STATE(1632)] = 140766,
  [SMALL_STATE(1633)] = 140902,
  [SMALL_STATE(1634)] = 141038,
  [SMALL_STATE(1635)] = 141176,
  [SMALL_STATE(1636)] = 141312,
  [SMALL_STATE(1637)] = 141448,
  [SMALL_STATE(1638)] = 141584,
  [SMALL_STATE(1639)] = 141720,
  [SMALL_STATE(1640)] = 141854,
  [SMALL_STATE(1641)] = 141990,
  [SMALL_STATE(1642)] = 142126,
  [SMALL_STATE(1643)] = 142262,
  [SMALL_STATE(1644)] = 142398,
  [SMALL_STATE(1645)] = 142534,
  [SMALL_STATE(1646)] = 142670,
  [SMALL_STATE(1647)] = 142806,
  [SMALL_STATE(1648)] = 142942,
  [SMALL_STATE(1649)] = 143078,
  [SMALL_STATE(1650)] = 143214,
  [SMALL_STATE(1651)] = 143350,
  [SMALL_STATE(1652)] = 143486,
  [SMALL_STATE(1653)] = 143622,
  [SMALL_STATE(1654)] = 143758,
  [SMALL_STATE(1655)] = 143894,
  [SMALL_STATE(1656)] = 144030,
  [SMALL_STATE(1657)] = 144166,
  [SMALL_STATE(1658)] = 144302,
  [SMALL_STATE(1659)] = 144438,
  [SMALL_STATE(1660)] = 144574,
  [SMALL_STATE(1661)] = 144710,
  [SMALL_STATE(1662)] = 144846,
  [SMALL_STATE(1663)] = 144982,
  [SMALL_STATE(1664)] = 145118,
  [SMALL_STATE(1665)] = 145254,
  [SMALL_STATE(1666)] = 145390,
  [SMALL_STATE(1667)] = 145526,
  [SMALL_STATE(1668)] = 145662,
  [SMALL_STATE(1669)] = 145798,
  [SMALL_STATE(1670)] = 145934,
  [SMALL_STATE(1671)] = 146070,
  [SMALL_STATE(1672)] = 146206,
  [SMALL_STATE(1673)] = 146338,
  [SMALL_STATE(1674)] = 146474,
  [SMALL_STATE(1675)] = 146606,
  [SMALL_STATE(1676)] = 146742,
  [SMALL_STATE(1677)] = 146878,
  [SMALL_STATE(1678)] = 147014,
  [SMALL_STATE(1679)] = 147150,
  [SMALL_STATE(1680)] = 147286,
  [SMALL_STATE(1681)] = 147422,
  [SMALL_STATE(1682)] = 147558,
  [SMALL_STATE(1683)] = 147694,
  [SMALL_STATE(1684)] = 147830,
  [SMALL_STATE(1685)] = 147966,
  [SMALL_STATE(1686)] = 148102,
  [SMALL_STATE(1687)] = 148238,
  [SMALL_STATE(1688)] = 148374,
  [SMALL_STATE(1689)] = 148510,
  [SMALL_STATE(1690)] = 148646,
  [SMALL_STATE(1691)] = 148782,
  [SMALL_STATE(1692)] = 148918,
  [SMALL_STATE(1693)] = 149054,
  [SMALL_STATE(1694)] = 149186,
  [SMALL_STATE(1695)] = 149322,
  [SMALL_STATE(1696)] = 149458,
  [SMALL_STATE(1697)] = 149594,
  [SMALL_STATE(1698)] = 149730,
  [SMALL_STATE(1699)] = 149866,
  [SMALL_STATE(1700)] = 150002,
  [SMALL_STATE(1701)] = 150138,
  [SMALL_STATE(1702)] = 150272,
  [SMALL_STATE(1703)] = 150408,
  [SMALL_STATE(1704)] = 150544,
  [SMALL_STATE(1705)] = 150680,
  [SMALL_STATE(1706)] = 150816,
  [SMALL_STATE(1707)] = 150952,
  [SMALL_STATE(1708)] = 151088,
  [SMALL_STATE(1709)] = 151224,
  [SMALL_STATE(1710)] = 151360,
  [SMALL_STATE(1711)] = 151496,
  [SMALL_STATE(1712)] = 151632,
  [SMALL_STATE(1713)] = 151768,
  [SMALL_STATE(1714)] = 151904,
  [SMALL_STATE(1715)] = 152040,
  [SMALL_STATE(1716)] = 152176,
  [SMALL_STATE(1717)] = 152312,
  [SMALL_STATE(1718)] = 152448,
  [SMALL_STATE(1719)] = 152584,
  [SMALL_STATE(1720)] = 152720,
  [SMALL_STATE(1721)] = 152856,
  [SMALL_STATE(1722)] = 152992,
  [SMALL_STATE(1723)] = 153128,
  [SMALL_STATE(1724)] = 153262,
  [SMALL_STATE(1725)] = 153398,
  [SMALL_STATE(1726)] = 153532,
  [SMALL_STATE(1727)] = 153668,
  [SMALL_STATE(1728)] = 153804,
  [SMALL_STATE(1729)] = 153940,
  [SMALL_STATE(1730)] = 154076,
  [SMALL_STATE(1731)] = 154212,
  [SMALL_STATE(1732)] = 154348,
  [SMALL_STATE(1733)] = 154484,
  [SMALL_STATE(1734)] = 154620,
  [SMALL_STATE(1735)] = 154756,
  [SMALL_STATE(1736)] = 154892,
  [SMALL_STATE(1737)] = 155028,
  [SMALL_STATE(1738)] = 155164,
  [SMALL_STATE(1739)] = 155300,
  [SMALL_STATE(1740)] = 155436,
  [SMALL_STATE(1741)] = 155572,
  [SMALL_STATE(1742)] = 155708,
  [SMALL_STATE(1743)] = 155844,
  [SMALL_STATE(1744)] = 155980,
  [SMALL_STATE(1745)] = 156116,
  [SMALL_STATE(1746)] = 156250,
  [SMALL_STATE(1747)] = 156386,
  [SMALL_STATE(1748)] = 156522,
  [SMALL_STATE(1749)] = 156658,
  [SMALL_STATE(1750)] = 156794,
  [SMALL_STATE(1751)] = 156930,
  [SMALL_STATE(1752)] = 157066,
  [SMALL_STATE(1753)] = 157202,
  [SMALL_STATE(1754)] = 157338,
  [SMALL_STATE(1755)] = 157474,
  [SMALL_STATE(1756)] = 157610,
  [SMALL_STATE(1757)] = 157746,
  [SMALL_STATE(1758)] = 157882,
  [SMALL_STATE(1759)] = 158018,
  [SMALL_STATE(1760)] = 158154,
  [SMALL_STATE(1761)] = 158290,
  [SMALL_STATE(1762)] = 158426,
  [SMALL_STATE(1763)] = 158562,
  [SMALL_STATE(1764)] = 158698,
  [SMALL_STATE(1765)] = 158834,
  [SMALL_STATE(1766)] = 158970,
  [SMALL_STATE(1767)] = 159106,
  [SMALL_STATE(1768)] = 159242,
  [SMALL_STATE(1769)] = 159378,
  [SMALL_STATE(1770)] = 159514,
  [SMALL_STATE(1771)] = 159650,
  [SMALL_STATE(1772)] = 159786,
  [SMALL_STATE(1773)] = 159922,
  [SMALL_STATE(1774)] = 160058,
  [SMALL_STATE(1775)] = 160194,
  [SMALL_STATE(1776)] = 160330,
  [SMALL_STATE(1777)] = 160466,
  [SMALL_STATE(1778)] = 160602,
  [SMALL_STATE(1779)] = 160738,
  [SMALL_STATE(1780)] = 160874,
  [SMALL_STATE(1781)] = 161010,
  [SMALL_STATE(1782)] = 161146,
  [SMALL_STATE(1783)] = 161282,
  [SMALL_STATE(1784)] = 161418,
  [SMALL_STATE(1785)] = 161554,
  [SMALL_STATE(1786)] = 161690,
  [SMALL_STATE(1787)] = 161826,
  [SMALL_STATE(1788)] = 161958,
  [SMALL_STATE(1789)] = 162094,
  [SMALL_STATE(1790)] = 162230,
  [SMALL_STATE(1791)] = 162366,
  [SMALL_STATE(1792)] = 162502,
  [SMALL_STATE(1793)] = 162634,
  [SMALL_STATE(1794)] = 162770,
  [SMALL_STATE(1795)] = 162906,
  [SMALL_STATE(1796)] = 163042,
  [SMALL_STATE(1797)] = 163178,
  [SMALL_STATE(1798)] = 163314,
  [SMALL_STATE(1799)] = 163450,
  [SMALL_STATE(1800)] = 163586,
  [SMALL_STATE(1801)] = 163722,
  [SMALL_STATE(1802)] = 163858,
  [SMALL_STATE(1803)] = 163994,
  [SMALL_STATE(1804)] = 164130,
  [SMALL_STATE(1805)] = 164266,
  [SMALL_STATE(1806)] = 164402,
  [SMALL_STATE(1807)] = 164538,
  [SMALL_STATE(1808)] = 164674,
  [SMALL_STATE(1809)] = 164810,
  [SMALL_STATE(1810)] = 164946,
  [SMALL_STATE(1811)] = 165082,
  [SMALL_STATE(1812)] = 165218,
  [SMALL_STATE(1813)] = 165354,
  [SMALL_STATE(1814)] = 165490,
  [SMALL_STATE(1815)] = 165626,
  [SMALL_STATE(1816)] = 165762,
  [SMALL_STATE(1817)] = 165898,
  [SMALL_STATE(1818)] = 166034,
  [SMALL_STATE(1819)] = 166170,
  [SMALL_STATE(1820)] = 166306,
  [SMALL_STATE(1821)] = 166442,
  [SMALL_STATE(1822)] = 166578,
  [SMALL_STATE(1823)] = 166714,
  [SMALL_STATE(1824)] = 166850,
  [SMALL_STATE(1825)] = 166986,
  [SMALL_STATE(1826)] = 167118,
  [SMALL_STATE(1827)] = 167254,
  [SMALL_STATE(1828)] = 167390,
  [SMALL_STATE(1829)] = 167526,
  [SMALL_STATE(1830)] = 167662,
  [SMALL_STATE(1831)] = 167798,
  [SMALL_STATE(1832)] = 167934,
  [SMALL_STATE(1833)] = 168070,
  [SMALL_STATE(1834)] = 168206,
  [SMALL_STATE(1835)] = 168342,
  [SMALL_STATE(1836)] = 168478,
  [SMALL_STATE(1837)] = 168614,
  [SMALL_STATE(1838)] = 168750,
  [SMALL_STATE(1839)] = 168886,
  [SMALL_STATE(1840)] = 169022,
  [SMALL_STATE(1841)] = 169158,
  [SMALL_STATE(1842)] = 169294,
  [SMALL_STATE(1843)] = 169430,
  [SMALL_STATE(1844)] = 169566,
  [SMALL_STATE(1845)] = 169702,
  [SMALL_STATE(1846)] = 169838,
  [SMALL_STATE(1847)] = 169974,
  [SMALL_STATE(1848)] = 170110,
  [SMALL_STATE(1849)] = 170246,
  [SMALL_STATE(1850)] = 170382,
  [SMALL_STATE(1851)] = 170518,
  [SMALL_STATE(1852)] = 170654,
  [SMALL_STATE(1853)] = 170790,
  [SMALL_STATE(1854)] = 170926,
  [SMALL_STATE(1855)] = 171062,
  [SMALL_STATE(1856)] = 171198,
  [SMALL_STATE(1857)] = 171334,
  [SMALL_STATE(1858)] = 171470,
  [SMALL_STATE(1859)] = 171606,
  [SMALL_STATE(1860)] = 171740,
  [SMALL_STATE(1861)] = 171876,
  [SMALL_STATE(1862)] = 172012,
  [SMALL_STATE(1863)] = 172148,
  [SMALL_STATE(1864)] = 172284,
  [SMALL_STATE(1865)] = 172420,
  [SMALL_STATE(1866)] = 172556,
  [SMALL_STATE(1867)] = 172692,
  [SMALL_STATE(1868)] = 172828,
  [SMALL_STATE(1869)] = 172964,
  [SMALL_STATE(1870)] = 173100,
  [SMALL_STATE(1871)] = 173236,
  [SMALL_STATE(1872)] = 173372,
  [SMALL_STATE(1873)] = 173508,
  [SMALL_STATE(1874)] = 173644,
  [SMALL_STATE(1875)] = 173780,
  [SMALL_STATE(1876)] = 173916,
  [SMALL_STATE(1877)] = 174052,
  [SMALL_STATE(1878)] = 174188,
  [SMALL_STATE(1879)] = 174324,
  [SMALL_STATE(1880)] = 174460,
  [SMALL_STATE(1881)] = 174596,
  [SMALL_STATE(1882)] = 174732,
  [SMALL_STATE(1883)] = 174868,
  [SMALL_STATE(1884)] = 175004,
  [SMALL_STATE(1885)] = 175140,
  [SMALL_STATE(1886)] = 175272,
  [SMALL_STATE(1887)] = 175408,
  [SMALL_STATE(1888)] = 175544,
  [SMALL_STATE(1889)] = 175680,
  [SMALL_STATE(1890)] = 175816,
  [SMALL_STATE(1891)] = 175952,
  [SMALL_STATE(1892)] = 176088,
  [SMALL_STATE(1893)] = 176224,
  [SMALL_STATE(1894)] = 176360,
  [SMALL_STATE(1895)] = 176496,
  [SMALL_STATE(1896)] = 176632,
  [SMALL_STATE(1897)] = 176768,
  [SMALL_STATE(1898)] = 176904,
  [SMALL_STATE(1899)] = 177040,
  [SMALL_STATE(1900)] = 177176,
  [SMALL_STATE(1901)] = 177308,
  [SMALL_STATE(1902)] = 177444,
  [SMALL_STATE(1903)] = 177580,
  [SMALL_STATE(1904)] = 177716,
  [SMALL_STATE(1905)] = 177850,
  [SMALL_STATE(1906)] = 177982,
  [SMALL_STATE(1907)] = 178118,
  [SMALL_STATE(1908)] = 178254,
  [SMALL_STATE(1909)] = 178390,
  [SMALL_STATE(1910)] = 178526,
  [SMALL_STATE(1911)] = 178662,
  [SMALL_STATE(1912)] = 178798,
  [SMALL_STATE(1913)] = 178934,
  [SMALL_STATE(1914)] = 179070,
  [SMALL_STATE(1915)] = 179206,
  [SMALL_STATE(1916)] = 179342,
  [SMALL_STATE(1917)] = 179478,
  [SMALL_STATE(1918)] = 179614,
  [SMALL_STATE(1919)] = 179750,
  [SMALL_STATE(1920)] = 179886,
  [SMALL_STATE(1921)] = 180022,
  [SMALL_STATE(1922)] = 180158,
  [SMALL_STATE(1923)] = 180294,
  [SMALL_STATE(1924)] = 180430,
  [SMALL_STATE(1925)] = 180566,
  [SMALL_STATE(1926)] = 180702,
  [SMALL_STATE(1927)] = 180838,
  [SMALL_STATE(1928)] = 180974,
  [SMALL_STATE(1929)] = 181110,
  [SMALL_STATE(1930)] = 181246,
  [SMALL_STATE(1931)] = 181382,
  [SMALL_STATE(1932)] = 181518,
  [SMALL_STATE(1933)] = 181654,
  [SMALL_STATE(1934)] = 181790,
  [SMALL_STATE(1935)] = 181926,
  [SMALL_STATE(1936)] = 182062,
  [SMALL_STATE(1937)] = 182198,
  [SMALL_STATE(1938)] = 182334,
  [SMALL_STATE(1939)] = 182470,
  [SMALL_STATE(1940)] = 182606,
  [SMALL_STATE(1941)] = 182742,
  [SMALL_STATE(1942)] = 182878,
  [SMALL_STATE(1943)] = 183014,
  [SMALL_STATE(1944)] = 183150,
  [SMALL_STATE(1945)] = 183286,
  [SMALL_STATE(1946)] = 183422,
  [SMALL_STATE(1947)] = 183558,
  [SMALL_STATE(1948)] = 183694,
  [SMALL_STATE(1949)] = 183830,
  [SMALL_STATE(1950)] = 183966,
  [SMALL_STATE(1951)] = 184102,
  [SMALL_STATE(1952)] = 184238,
  [SMALL_STATE(1953)] = 184374,
  [SMALL_STATE(1954)] = 184510,
  [SMALL_STATE(1955)] = 184646,
  [SMALL_STATE(1956)] = 184782,
  [SMALL_STATE(1957)] = 184918,
  [SMALL_STATE(1958)] = 185054,
  [SMALL_STATE(1959)] = 185190,
  [SMALL_STATE(1960)] = 185326,
  [SMALL_STATE(1961)] = 185462,
  [SMALL_STATE(1962)] = 185598,
  [SMALL_STATE(1963)] = 185734,
  [SMALL_STATE(1964)] = 185870,
  [SMALL_STATE(1965)] = 186006,
  [SMALL_STATE(1966)] = 186142,
  [SMALL_STATE(1967)] = 186278,
  [SMALL_STATE(1968)] = 186414,
  [SMALL_STATE(1969)] = 186550,
  [SMALL_STATE(1970)] = 186686,
  [SMALL_STATE(1971)] = 186822,
  [SMALL_STATE(1972)] = 186958,
  [SMALL_STATE(1973)] = 187094,
  [SMALL_STATE(1974)] = 187230,
  [SMALL_STATE(1975)] = 187366,
  [SMALL_STATE(1976)] = 187502,
  [SMALL_STATE(1977)] = 187638,
  [SMALL_STATE(1978)] = 187774,
  [SMALL_STATE(1979)] = 187910,
  [SMALL_STATE(1980)] = 188046,
  [SMALL_STATE(1981)] = 188182,
  [SMALL_STATE(1982)] = 188318,
  [SMALL_STATE(1983)] = 188454,
  [SMALL_STATE(1984)] = 188590,
  [SMALL_STATE(1985)] = 188726,
  [SMALL_STATE(1986)] = 188862,
  [SMALL_STATE(1987)] = 188998,
  [SMALL_STATE(1988)] = 189130,
  [SMALL_STATE(1989)] = 189266,
  [SMALL_STATE(1990)] = 189402,
  [SMALL_STATE(1991)] = 189538,
  [SMALL_STATE(1992)] = 189674,
  [SMALL_STATE(1993)] = 189810,
  [SMALL_STATE(1994)] = 189946,
  [SMALL_STATE(1995)] = 190078,
  [SMALL_STATE(1996)] = 190214,
  [SMALL_STATE(1997)] = 190350,
  [SMALL_STATE(1998)] = 190486,
  [SMALL_STATE(1999)] = 190622,
  [SMALL_STATE(2000)] = 190758,
  [SMALL_STATE(2001)] = 190894,
  [SMALL_STATE(2002)] = 191030,
  [SMALL_STATE(2003)] = 191164,
  [SMALL_STATE(2004)] = 191296,
  [SMALL_STATE(2005)] = 191432,
  [SMALL_STATE(2006)] = 191568,
  [SMALL_STATE(2007)] = 191704,
  [SMALL_STATE(2008)] = 191840,
  [SMALL_STATE(2009)] = 191976,
  [SMALL_STATE(2010)] = 192112,
  [SMALL_STATE(2011)] = 192244,
  [SMALL_STATE(2012)] = 192380,
  [SMALL_STATE(2013)] = 192516,
  [SMALL_STATE(2014)] = 192652,
  [SMALL_STATE(2015)] = 192786,
  [SMALL_STATE(2016)] = 192922,
  [SMALL_STATE(2017)] = 193058,
  [SMALL_STATE(2018)] = 193194,
  [SMALL_STATE(2019)] = 193330,
  [SMALL_STATE(2020)] = 193466,
  [SMALL_STATE(2021)] = 193602,
  [SMALL_STATE(2022)] = 193738,
  [SMALL_STATE(2023)] = 193874,
  [SMALL_STATE(2024)] = 194010,
  [SMALL_STATE(2025)] = 194146,
  [SMALL_STATE(2026)] = 194282,
  [SMALL_STATE(2027)] = 194418,
  [SMALL_STATE(2028)] = 194554,
  [SMALL_STATE(2029)] = 194690,
  [SMALL_STATE(2030)] = 194826,
  [SMALL_STATE(2031)] = 194962,
  [SMALL_STATE(2032)] = 195098,
  [SMALL_STATE(2033)] = 195234,
  [SMALL_STATE(2034)] = 195370,
  [SMALL_STATE(2035)] = 195506,
  [SMALL_STATE(2036)] = 195642,
  [SMALL_STATE(2037)] = 195778,
  [SMALL_STATE(2038)] = 195914,
  [SMALL_STATE(2039)] = 196050,
  [SMALL_STATE(2040)] = 196186,
  [SMALL_STATE(2041)] = 196322,
  [SMALL_STATE(2042)] = 196458,
  [SMALL_STATE(2043)] = 196592,
  [SMALL_STATE(2044)] = 196728,
  [SMALL_STATE(2045)] = 196864,
  [SMALL_STATE(2046)] = 197000,
  [SMALL_STATE(2047)] = 197136,
  [SMALL_STATE(2048)] = 197272,
  [SMALL_STATE(2049)] = 197408,
  [SMALL_STATE(2050)] = 197544,
  [SMALL_STATE(2051)] = 197680,
  [SMALL_STATE(2052)] = 197816,
  [SMALL_STATE(2053)] = 197952,
  [SMALL_STATE(2054)] = 198088,
  [SMALL_STATE(2055)] = 198224,
  [SMALL_STATE(2056)] = 198360,
  [SMALL_STATE(2057)] = 198496,
  [SMALL_STATE(2058)] = 198632,
  [SMALL_STATE(2059)] = 198768,
  [SMALL_STATE(2060)] = 198904,
  [SMALL_STATE(2061)] = 199040,
  [SMALL_STATE(2062)] = 199176,
  [SMALL_STATE(2063)] = 199312,
  [SMALL_STATE(2064)] = 199448,
  [SMALL_STATE(2065)] = 199584,
  [SMALL_STATE(2066)] = 199720,
  [SMALL_STATE(2067)] = 199856,
  [SMALL_STATE(2068)] = 199992,
  [SMALL_STATE(2069)] = 200128,
  [SMALL_STATE(2070)] = 200264,
  [SMALL_STATE(2071)] = 200400,
  [SMALL_STATE(2072)] = 200536,
  [SMALL_STATE(2073)] = 200672,
  [SMALL_STATE(2074)] = 200808,
  [SMALL_STATE(2075)] = 200944,
  [SMALL_STATE(2076)] = 201080,
  [SMALL_STATE(2077)] = 201212,
  [SMALL_STATE(2078)] = 201348,
  [SMALL_STATE(2079)] = 201484,
  [SMALL_STATE(2080)] = 201620,
  [SMALL_STATE(2081)] = 201756,
  [SMALL_STATE(2082)] = 201892,
  [SMALL_STATE(2083)] = 202028,
  [SMALL_STATE(2084)] = 202164,
  [SMALL_STATE(2085)] = 202300,
  [SMALL_STATE(2086)] = 202436,
  [SMALL_STATE(2087)] = 202572,
  [SMALL_STATE(2088)] = 202708,
  [SMALL_STATE(2089)] = 202844,
  [SMALL_STATE(2090)] = 202980,
  [SMALL_STATE(2091)] = 203116,
  [SMALL_STATE(2092)] = 203252,
  [SMALL_STATE(2093)] = 203388,
  [SMALL_STATE(2094)] = 203524,
  [SMALL_STATE(2095)] = 203660,
  [SMALL_STATE(2096)] = 203796,
  [SMALL_STATE(2097)] = 203932,
  [SMALL_STATE(2098)] = 204068,
  [SMALL_STATE(2099)] = 204204,
  [SMALL_STATE(2100)] = 204340,
  [SMALL_STATE(2101)] = 204476,
  [SMALL_STATE(2102)] = 204612,
  [SMALL_STATE(2103)] = 204748,
  [SMALL_STATE(2104)] = 204884,
  [SMALL_STATE(2105)] = 205020,
  [SMALL_STATE(2106)] = 205156,
  [SMALL_STATE(2107)] = 205292,
  [SMALL_STATE(2108)] = 205428,
  [SMALL_STATE(2109)] = 205564,
  [SMALL_STATE(2110)] = 205700,
  [SMALL_STATE(2111)] = 205836,
  [SMALL_STATE(2112)] = 205972,
  [SMALL_STATE(2113)] = 206108,
  [SMALL_STATE(2114)] = 206244,
  [SMALL_STATE(2115)] = 206380,
  [SMALL_STATE(2116)] = 206516,
  [SMALL_STATE(2117)] = 206648,
  [SMALL_STATE(2118)] = 206784,
  [SMALL_STATE(2119)] = 206920,
  [SMALL_STATE(2120)] = 207056,
  [SMALL_STATE(2121)] = 207192,
  [SMALL_STATE(2122)] = 207328,
  [SMALL_STATE(2123)] = 207464,
  [SMALL_STATE(2124)] = 207600,
  [SMALL_STATE(2125)] = 207736,
  [SMALL_STATE(2126)] = 207872,
  [SMALL_STATE(2127)] = 208008,
  [SMALL_STATE(2128)] = 208144,
  [SMALL_STATE(2129)] = 208280,
  [SMALL_STATE(2130)] = 208416,
  [SMALL_STATE(2131)] = 208552,
  [SMALL_STATE(2132)] = 208684,
  [SMALL_STATE(2133)] = 208820,
  [SMALL_STATE(2134)] = 208956,
  [SMALL_STATE(2135)] = 209092,
  [SMALL_STATE(2136)] = 209228,
  [SMALL_STATE(2137)] = 209364,
  [SMALL_STATE(2138)] = 209500,
  [SMALL_STATE(2139)] = 209636,
  [SMALL_STATE(2140)] = 209772,
  [SMALL_STATE(2141)] = 209908,
  [SMALL_STATE(2142)] = 210044,
  [SMALL_STATE(2143)] = 210180,
  [SMALL_STATE(2144)] = 210316,
  [SMALL_STATE(2145)] = 210452,
  [SMALL_STATE(2146)] = 210588,
  [SMALL_STATE(2147)] = 210724,
  [SMALL_STATE(2148)] = 210860,
  [SMALL_STATE(2149)] = 210996,
  [SMALL_STATE(2150)] = 211132,
  [SMALL_STATE(2151)] = 211268,
  [SMALL_STATE(2152)] = 211404,
  [SMALL_STATE(2153)] = 211540,
  [SMALL_STATE(2154)] = 211676,
  [SMALL_STATE(2155)] = 211812,
  [SMALL_STATE(2156)] = 211948,
  [SMALL_STATE(2157)] = 212084,
  [SMALL_STATE(2158)] = 212220,
  [SMALL_STATE(2159)] = 212356,
  [SMALL_STATE(2160)] = 212492,
  [SMALL_STATE(2161)] = 212628,
  [SMALL_STATE(2162)] = 212764,
  [SMALL_STATE(2163)] = 212900,
  [SMALL_STATE(2164)] = 213036,
  [SMALL_STATE(2165)] = 213172,
  [SMALL_STATE(2166)] = 213308,
  [SMALL_STATE(2167)] = 213440,
  [SMALL_STATE(2168)] = 213576,
  [SMALL_STATE(2169)] = 213712,
  [SMALL_STATE(2170)] = 213848,
  [SMALL_STATE(2171)] = 213984,
  [SMALL_STATE(2172)] = 214120,
  [SMALL_STATE(2173)] = 214256,
  [SMALL_STATE(2174)] = 214392,
  [SMALL_STATE(2175)] = 214528,
  [SMALL_STATE(2176)] = 214664,
  [SMALL_STATE(2177)] = 214800,
  [SMALL_STATE(2178)] = 214936,
  [SMALL_STATE(2179)] = 215072,
  [SMALL_STATE(2180)] = 215206,
  [SMALL_STATE(2181)] = 215342,
  [SMALL_STATE(2182)] = 215478,
  [SMALL_STATE(2183)] = 215614,
  [SMALL_STATE(2184)] = 215750,
  [SMALL_STATE(2185)] = 215886,
  [SMALL_STATE(2186)] = 216022,
  [SMALL_STATE(2187)] = 216158,
  [SMALL_STATE(2188)] = 216294,
  [SMALL_STATE(2189)] = 216430,
  [SMALL_STATE(2190)] = 216566,
  [SMALL_STATE(2191)] = 216702,
  [SMALL_STATE(2192)] = 216838,
  [SMALL_STATE(2193)] = 216974,
  [SMALL_STATE(2194)] = 217110,
  [SMALL_STATE(2195)] = 217246,
  [SMALL_STATE(2196)] = 217382,
  [SMALL_STATE(2197)] = 217518,
  [SMALL_STATE(2198)] = 217654,
  [SMALL_STATE(2199)] = 217790,
  [SMALL_STATE(2200)] = 217926,
  [SMALL_STATE(2201)] = 218062,
  [SMALL_STATE(2202)] = 218198,
  [SMALL_STATE(2203)] = 218334,
  [SMALL_STATE(2204)] = 218470,
  [SMALL_STATE(2205)] = 218606,
  [SMALL_STATE(2206)] = 218742,
  [SMALL_STATE(2207)] = 218878,
  [SMALL_STATE(2208)] = 219014,
  [SMALL_STATE(2209)] = 219150,
  [SMALL_STATE(2210)] = 219286,
  [SMALL_STATE(2211)] = 219422,
  [SMALL_STATE(2212)] = 219558,
  [SMALL_STATE(2213)] = 219694,
  [SMALL_STATE(2214)] = 219830,
  [SMALL_STATE(2215)] = 219966,
  [SMALL_STATE(2216)] = 220102,
  [SMALL_STATE(2217)] = 220238,
  [SMALL_STATE(2218)] = 220374,
  [SMALL_STATE(2219)] = 220510,
  [SMALL_STATE(2220)] = 220646,
  [SMALL_STATE(2221)] = 220782,
  [SMALL_STATE(2222)] = 220918,
  [SMALL_STATE(2223)] = 221054,
  [SMALL_STATE(2224)] = 221190,
  [SMALL_STATE(2225)] = 221326,
  [SMALL_STATE(2226)] = 221462,
  [SMALL_STATE(2227)] = 221598,
  [SMALL_STATE(2228)] = 221734,
  [SMALL_STATE(2229)] = 221870,
  [SMALL_STATE(2230)] = 222004,
  [SMALL_STATE(2231)] = 222140,
  [SMALL_STATE(2232)] = 222276,
  [SMALL_STATE(2233)] = 222412,
  [SMALL_STATE(2234)] = 222548,
  [SMALL_STATE(2235)] = 222684,
  [SMALL_STATE(2236)] = 222820,
  [SMALL_STATE(2237)] = 222956,
  [SMALL_STATE(2238)] = 223092,
  [SMALL_STATE(2239)] = 223228,
  [SMALL_STATE(2240)] = 223364,
  [SMALL_STATE(2241)] = 223500,
  [SMALL_STATE(2242)] = 223636,
  [SMALL_STATE(2243)] = 223772,
  [SMALL_STATE(2244)] = 223908,
  [SMALL_STATE(2245)] = 224040,
  [SMALL_STATE(2246)] = 224176,
  [SMALL_STATE(2247)] = 224312,
  [SMALL_STATE(2248)] = 224448,
  [SMALL_STATE(2249)] = 224584,
  [SMALL_STATE(2250)] = 224720,
  [SMALL_STATE(2251)] = 224856,
  [SMALL_STATE(2252)] = 224992,
  [SMALL_STATE(2253)] = 225128,
  [SMALL_STATE(2254)] = 225264,
  [SMALL_STATE(2255)] = 225400,
  [SMALL_STATE(2256)] = 225536,
  [SMALL_STATE(2257)] = 225672,
  [SMALL_STATE(2258)] = 225808,
  [SMALL_STATE(2259)] = 225944,
  [SMALL_STATE(2260)] = 226080,
  [SMALL_STATE(2261)] = 226216,
  [SMALL_STATE(2262)] = 226352,
  [SMALL_STATE(2263)] = 226488,
  [SMALL_STATE(2264)] = 226624,
  [SMALL_STATE(2265)] = 226756,
  [SMALL_STATE(2266)] = 226892,
  [SMALL_STATE(2267)] = 227028,
  [SMALL_STATE(2268)] = 227164,
  [SMALL_STATE(2269)] = 227300,
  [SMALL_STATE(2270)] = 227436,
  [SMALL_STATE(2271)] = 227572,
  [SMALL_STATE(2272)] = 227708,
  [SMALL_STATE(2273)] = 227844,
  [SMALL_STATE(2274)] = 227980,
  [SMALL_STATE(2275)] = 228116,
  [SMALL_STATE(2276)] = 228248,
  [SMALL_STATE(2277)] = 228384,
  [SMALL_STATE(2278)] = 228520,
  [SMALL_STATE(2279)] = 228656,
  [SMALL_STATE(2280)] = 228792,
  [SMALL_STATE(2281)] = 228928,
  [SMALL_STATE(2282)] = 229064,
  [SMALL_STATE(2283)] = 229200,
  [SMALL_STATE(2284)] = 229336,
  [SMALL_STATE(2285)] = 229472,
  [SMALL_STATE(2286)] = 229608,
  [SMALL_STATE(2287)] = 229744,
  [SMALL_STATE(2288)] = 229880,
  [SMALL_STATE(2289)] = 230016,
  [SMALL_STATE(2290)] = 230152,
  [SMALL_STATE(2291)] = 230288,
  [SMALL_STATE(2292)] = 230424,
  [SMALL_STATE(2293)] = 230560,
  [SMALL_STATE(2294)] = 230696,
  [SMALL_STATE(2295)] = 230832,
  [SMALL_STATE(2296)] = 230968,
  [SMALL_STATE(2297)] = 231100,
  [SMALL_STATE(2298)] = 231236,
  [SMALL_STATE(2299)] = 231372,
  [SMALL_STATE(2300)] = 231508,
  [SMALL_STATE(2301)] = 231644,
  [SMALL_STATE(2302)] = 231780,
  [SMALL_STATE(2303)] = 231916,
  [SMALL_STATE(2304)] = 232052,
  [SMALL_STATE(2305)] = 232188,
  [SMALL_STATE(2306)] = 232324,
  [SMALL_STATE(2307)] = 232460,
  [SMALL_STATE(2308)] = 232596,
  [SMALL_STATE(2309)] = 232732,
  [SMALL_STATE(2310)] = 232868,
  [SMALL_STATE(2311)] = 233004,
  [SMALL_STATE(2312)] = 233140,
  [SMALL_STATE(2313)] = 233276,
  [SMALL_STATE(2314)] = 233412,
  [SMALL_STATE(2315)] = 233548,
  [SMALL_STATE(2316)] = 233684,
  [SMALL_STATE(2317)] = 233820,
  [SMALL_STATE(2318)] = 233956,
  [SMALL_STATE(2319)] = 234092,
  [SMALL_STATE(2320)] = 234228,
  [SMALL_STATE(2321)] = 234364,
  [SMALL_STATE(2322)] = 234500,
  [SMALL_STATE(2323)] = 234636,
  [SMALL_STATE(2324)] = 234772,
  [SMALL_STATE(2325)] = 234908,
  [SMALL_STATE(2326)] = 235044,
  [SMALL_STATE(2327)] = 235180,
  [SMALL_STATE(2328)] = 235316,
  [SMALL_STATE(2329)] = 235452,
  [SMALL_STATE(2330)] = 235588,
  [SMALL_STATE(2331)] = 235724,
  [SMALL_STATE(2332)] = 235860,
  [SMALL_STATE(2333)] = 235996,
  [SMALL_STATE(2334)] = 236132,
  [SMALL_STATE(2335)] = 236268,
  [SMALL_STATE(2336)] = 236404,
  [SMALL_STATE(2337)] = 236540,
  [SMALL_STATE(2338)] = 236676,
  [SMALL_STATE(2339)] = 236812,
  [SMALL_STATE(2340)] = 236948,
  [SMALL_STATE(2341)] = 237084,
  [SMALL_STATE(2342)] = 237220,
  [SMALL_STATE(2343)] = 237356,
  [SMALL_STATE(2344)] = 237490,
  [SMALL_STATE(2345)] = 237626,
  [SMALL_STATE(2346)] = 237762,
  [SMALL_STATE(2347)] = 237898,
  [SMALL_STATE(2348)] = 238034,
  [SMALL_STATE(2349)] = 238170,
  [SMALL_STATE(2350)] = 238306,
  [SMALL_STATE(2351)] = 238442,
  [SMALL_STATE(2352)] = 238578,
  [SMALL_STATE(2353)] = 238714,
  [SMALL_STATE(2354)] = 238850,
  [SMALL_STATE(2355)] = 238986,
  [SMALL_STATE(2356)] = 239122,
  [SMALL_STATE(2357)] = 239258,
  [SMALL_STATE(2358)] = 239394,
  [SMALL_STATE(2359)] = 239530,
  [SMALL_STATE(2360)] = 239666,
  [SMALL_STATE(2361)] = 239802,
  [SMALL_STATE(2362)] = 239938,
  [SMALL_STATE(2363)] = 240074,
  [SMALL_STATE(2364)] = 240210,
  [SMALL_STATE(2365)] = 240346,
  [SMALL_STATE(2366)] = 240482,
  [SMALL_STATE(2367)] = 240618,
  [SMALL_STATE(2368)] = 240754,
  [SMALL_STATE(2369)] = 240890,
  [SMALL_STATE(2370)] = 241026,
  [SMALL_STATE(2371)] = 241162,
  [SMALL_STATE(2372)] = 241298,
  [SMALL_STATE(2373)] = 241434,
  [SMALL_STATE(2374)] = 241570,
  [SMALL_STATE(2375)] = 241706,
  [SMALL_STATE(2376)] = 241842,
  [SMALL_STATE(2377)] = 241978,
  [SMALL_STATE(2378)] = 242114,
  [SMALL_STATE(2379)] = 242250,
  [SMALL_STATE(2380)] = 242386,
  [SMALL_STATE(2381)] = 242522,
  [SMALL_STATE(2382)] = 242658,
  [SMALL_STATE(2383)] = 242794,
  [SMALL_STATE(2384)] = 242930,
  [SMALL_STATE(2385)] = 243066,
  [SMALL_STATE(2386)] = 243202,
  [SMALL_STATE(2387)] = 243338,
  [SMALL_STATE(2388)] = 243474,
  [SMALL_STATE(2389)] = 243610,
  [SMALL_STATE(2390)] = 243746,
  [SMALL_STATE(2391)] = 243882,
  [SMALL_STATE(2392)] = 244016,
  [SMALL_STATE(2393)] = 244152,
  [SMALL_STATE(2394)] = 244288,
  [SMALL_STATE(2395)] = 244424,
  [SMALL_STATE(2396)] = 244560,
  [SMALL_STATE(2397)] = 244696,
  [SMALL_STATE(2398)] = 244832,
  [SMALL_STATE(2399)] = 244968,
  [SMALL_STATE(2400)] = 245104,
  [SMALL_STATE(2401)] = 245240,
  [SMALL_STATE(2402)] = 245376,
  [SMALL_STATE(2403)] = 245512,
  [SMALL_STATE(2404)] = 245648,
  [SMALL_STATE(2405)] = 245784,
  [SMALL_STATE(2406)] = 245920,
  [SMALL_STATE(2407)] = 246056,
  [SMALL_STATE(2408)] = 246192,
  [SMALL_STATE(2409)] = 246328,
  [SMALL_STATE(2410)] = 246464,
  [SMALL_STATE(2411)] = 246600,
  [SMALL_STATE(2412)] = 246736,
  [SMALL_STATE(2413)] = 246872,
  [SMALL_STATE(2414)] = 247008,
  [SMALL_STATE(2415)] = 247144,
  [SMALL_STATE(2416)] = 247280,
  [SMALL_STATE(2417)] = 247416,
  [SMALL_STATE(2418)] = 247552,
  [SMALL_STATE(2419)] = 247688,
  [SMALL_STATE(2420)] = 247824,
  [SMALL_STATE(2421)] = 247960,
  [SMALL_STATE(2422)] = 248096,
  [SMALL_STATE(2423)] = 248232,
  [SMALL_STATE(2424)] = 248368,
  [SMALL_STATE(2425)] = 248504,
  [SMALL_STATE(2426)] = 248640,
  [SMALL_STATE(2427)] = 248776,
  [SMALL_STATE(2428)] = 248912,
  [SMALL_STATE(2429)] = 249048,
  [SMALL_STATE(2430)] = 249184,
  [SMALL_STATE(2431)] = 249320,
  [SMALL_STATE(2432)] = 249456,
  [SMALL_STATE(2433)] = 249592,
  [SMALL_STATE(2434)] = 249728,
  [SMALL_STATE(2435)] = 249864,
  [SMALL_STATE(2436)] = 250000,
  [SMALL_STATE(2437)] = 250136,
  [SMALL_STATE(2438)] = 250268,
  [SMALL_STATE(2439)] = 250404,
  [SMALL_STATE(2440)] = 250540,
  [SMALL_STATE(2441)] = 250676,
  [SMALL_STATE(2442)] = 250812,
  [SMALL_STATE(2443)] = 250948,
  [SMALL_STATE(2444)] = 251084,
  [SMALL_STATE(2445)] = 251220,
  [SMALL_STATE(2446)] = 251356,
  [SMALL_STATE(2447)] = 251492,
  [SMALL_STATE(2448)] = 251628,
  [SMALL_STATE(2449)] = 251764,
  [SMALL_STATE(2450)] = 251900,
  [SMALL_STATE(2451)] = 252036,
  [SMALL_STATE(2452)] = 252172,
  [SMALL_STATE(2453)] = 252308,
  [SMALL_STATE(2454)] = 252444,
  [SMALL_STATE(2455)] = 252580,
  [SMALL_STATE(2456)] = 252716,
  [SMALL_STATE(2457)] = 252852,
  [SMALL_STATE(2458)] = 252988,
  [SMALL_STATE(2459)] = 253124,
  [SMALL_STATE(2460)] = 253260,
  [SMALL_STATE(2461)] = 253396,
  [SMALL_STATE(2462)] = 253532,
  [SMALL_STATE(2463)] = 253668,
  [SMALL_STATE(2464)] = 253804,
  [SMALL_STATE(2465)] = 253940,
  [SMALL_STATE(2466)] = 254076,
  [SMALL_STATE(2467)] = 254212,
  [SMALL_STATE(2468)] = 254348,
  [SMALL_STATE(2469)] = 254484,
  [SMALL_STATE(2470)] = 254620,
  [SMALL_STATE(2471)] = 254756,
  [SMALL_STATE(2472)] = 254892,
  [SMALL_STATE(2473)] = 255028,
  [SMALL_STATE(2474)] = 255164,
  [SMALL_STATE(2475)] = 255300,
  [SMALL_STATE(2476)] = 255436,
  [SMALL_STATE(2477)] = 255572,
  [SMALL_STATE(2478)] = 255708,
  [SMALL_STATE(2479)] = 255844,
  [SMALL_STATE(2480)] = 255980,
  [SMALL_STATE(2481)] = 256116,
  [SMALL_STATE(2482)] = 256252,
  [SMALL_STATE(2483)] = 256388,
  [SMALL_STATE(2484)] = 256524,
  [SMALL_STATE(2485)] = 256660,
  [SMALL_STATE(2486)] = 256794,
  [SMALL_STATE(2487)] = 256930,
  [SMALL_STATE(2488)] = 257066,
  [SMALL_STATE(2489)] = 257202,
  [SMALL_STATE(2490)] = 257338,
  [SMALL_STATE(2491)] = 257474,
  [SMALL_STATE(2492)] = 257610,
  [SMALL_STATE(2493)] = 257746,
  [SMALL_STATE(2494)] = 257882,
  [SMALL_STATE(2495)] = 258018,
  [SMALL_STATE(2496)] = 258154,
  [SMALL_STATE(2497)] = 258290,
  [SMALL_STATE(2498)] = 258426,
  [SMALL_STATE(2499)] = 258562,
  [SMALL_STATE(2500)] = 258700,
  [SMALL_STATE(2501)] = 258836,
  [SMALL_STATE(2502)] = 258972,
  [SMALL_STATE(2503)] = 259108,
  [SMALL_STATE(2504)] = 259244,
  [SMALL_STATE(2505)] = 259380,
  [SMALL_STATE(2506)] = 259516,
  [SMALL_STATE(2507)] = 259652,
  [SMALL_STATE(2508)] = 259788,
  [SMALL_STATE(2509)] = 259924,
  [SMALL_STATE(2510)] = 260060,
  [SMALL_STATE(2511)] = 260196,
  [SMALL_STATE(2512)] = 260332,
  [SMALL_STATE(2513)] = 260468,
  [SMALL_STATE(2514)] = 260604,
  [SMALL_STATE(2515)] = 260740,
  [SMALL_STATE(2516)] = 260876,
  [SMALL_STATE(2517)] = 261012,
  [SMALL_STATE(2518)] = 261146,
  [SMALL_STATE(2519)] = 261282,
  [SMALL_STATE(2520)] = 261418,
  [SMALL_STATE(2521)] = 261554,
  [SMALL_STATE(2522)] = 261690,
  [SMALL_STATE(2523)] = 261826,
  [SMALL_STATE(2524)] = 261962,
  [SMALL_STATE(2525)] = 262098,
  [SMALL_STATE(2526)] = 262234,
  [SMALL_STATE(2527)] = 262370,
  [SMALL_STATE(2528)] = 262506,
  [SMALL_STATE(2529)] = 262642,
  [SMALL_STATE(2530)] = 262778,
  [SMALL_STATE(2531)] = 262914,
  [SMALL_STATE(2532)] = 263050,
  [SMALL_STATE(2533)] = 263186,
  [SMALL_STATE(2534)] = 263322,
  [SMALL_STATE(2535)] = 263458,
  [SMALL_STATE(2536)] = 263594,
  [SMALL_STATE(2537)] = 263730,
  [SMALL_STATE(2538)] = 263866,
  [SMALL_STATE(2539)] = 264002,
  [SMALL_STATE(2540)] = 264138,
  [SMALL_STATE(2541)] = 264274,
  [SMALL_STATE(2542)] = 264410,
  [SMALL_STATE(2543)] = 264546,
  [SMALL_STATE(2544)] = 264682,
  [SMALL_STATE(2545)] = 264818,
  [SMALL_STATE(2546)] = 264954,
  [SMALL_STATE(2547)] = 265090,
  [SMALL_STATE(2548)] = 265226,
  [SMALL_STATE(2549)] = 265362,
  [SMALL_STATE(2550)] = 265498,
  [SMALL_STATE(2551)] = 265634,
  [SMALL_STATE(2552)] = 265768,
  [SMALL_STATE(2553)] = 265904,
  [SMALL_STATE(2554)] = 266040,
  [SMALL_STATE(2555)] = 266176,
  [SMALL_STATE(2556)] = 266312,
  [SMALL_STATE(2557)] = 266448,
  [SMALL_STATE(2558)] = 266584,
  [SMALL_STATE(2559)] = 266720,
  [SMALL_STATE(2560)] = 266856,
  [SMALL_STATE(2561)] = 266990,
  [SMALL_STATE(2562)] = 267126,
  [SMALL_STATE(2563)] = 267262,
  [SMALL_STATE(2564)] = 267398,
  [SMALL_STATE(2565)] = 267534,
  [SMALL_STATE(2566)] = 267670,
  [SMALL_STATE(2567)] = 267806,
  [SMALL_STATE(2568)] = 267942,
  [SMALL_STATE(2569)] = 268078,
  [SMALL_STATE(2570)] = 268212,
  [SMALL_STATE(2571)] = 268348,
  [SMALL_STATE(2572)] = 268484,
  [SMALL_STATE(2573)] = 268620,
  [SMALL_STATE(2574)] = 268756,
  [SMALL_STATE(2575)] = 268892,
  [SMALL_STATE(2576)] = 269028,
  [SMALL_STATE(2577)] = 269164,
  [SMALL_STATE(2578)] = 269300,
  [SMALL_STATE(2579)] = 269436,
  [SMALL_STATE(2580)] = 269572,
  [SMALL_STATE(2581)] = 269708,
  [SMALL_STATE(2582)] = 269844,
  [SMALL_STATE(2583)] = 269980,
  [SMALL_STATE(2584)] = 270116,
  [SMALL_STATE(2585)] = 270252,
  [SMALL_STATE(2586)] = 270388,
  [SMALL_STATE(2587)] = 270524,
  [SMALL_STATE(2588)] = 270660,
  [SMALL_STATE(2589)] = 270796,
  [SMALL_STATE(2590)] = 270932,
  [SMALL_STATE(2591)] = 271068,
  [SMALL_STATE(2592)] = 271204,
  [SMALL_STATE(2593)] = 271340,
  [SMALL_STATE(2594)] = 271476,
  [SMALL_STATE(2595)] = 271612,
  [SMALL_STATE(2596)] = 271746,
  [SMALL_STATE(2597)] = 271882,
  [SMALL_STATE(2598)] = 272018,
  [SMALL_STATE(2599)] = 272154,
  [SMALL_STATE(2600)] = 272290,
  [SMALL_STATE(2601)] = 272426,
  [SMALL_STATE(2602)] = 272562,
  [SMALL_STATE(2603)] = 272698,
  [SMALL_STATE(2604)] = 272834,
  [SMALL_STATE(2605)] = 272970,
  [SMALL_STATE(2606)] = 273106,
  [SMALL_STATE(2607)] = 273242,
  [SMALL_STATE(2608)] = 273378,
  [SMALL_STATE(2609)] = 273514,
  [SMALL_STATE(2610)] = 273650,
  [SMALL_STATE(2611)] = 273786,
  [SMALL_STATE(2612)] = 273922,
  [SMALL_STATE(2613)] = 274058,
  [SMALL_STATE(2614)] = 274194,
  [SMALL_STATE(2615)] = 274330,
  [SMALL_STATE(2616)] = 274466,
  [SMALL_STATE(2617)] = 274602,
  [SMALL_STATE(2618)] = 274738,
  [SMALL_STATE(2619)] = 274874,
  [SMALL_STATE(2620)] = 275010,
  [SMALL_STATE(2621)] = 275146,
  [SMALL_STATE(2622)] = 275278,
  [SMALL_STATE(2623)] = 275414,
  [SMALL_STATE(2624)] = 275550,
  [SMALL_STATE(2625)] = 275686,
  [SMALL_STATE(2626)] = 275822,
  [SMALL_STATE(2627)] = 275958,
  [SMALL_STATE(2628)] = 276094,
  [SMALL_STATE(2629)] = 276230,
  [SMALL_STATE(2630)] = 276366,
  [SMALL_STATE(2631)] = 276502,
  [SMALL_STATE(2632)] = 276638,
  [SMALL_STATE(2633)] = 276774,
  [SMALL_STATE(2634)] = 276910,
  [SMALL_STATE(2635)] = 277046,
  [SMALL_STATE(2636)] = 277182,
  [SMALL_STATE(2637)] = 277318,
  [SMALL_STATE(2638)] = 277454,
  [SMALL_STATE(2639)] = 277590,
  [SMALL_STATE(2640)] = 277726,
  [SMALL_STATE(2641)] = 277862,
  [SMALL_STATE(2642)] = 277998,
  [SMALL_STATE(2643)] = 278134,
  [SMALL_STATE(2644)] = 278270,
  [SMALL_STATE(2645)] = 278406,
  [SMALL_STATE(2646)] = 278542,
  [SMALL_STATE(2647)] = 278678,
  [SMALL_STATE(2648)] = 278814,
  [SMALL_STATE(2649)] = 278950,
  [SMALL_STATE(2650)] = 279086,
  [SMALL_STATE(2651)] = 279222,
  [SMALL_STATE(2652)] = 279358,
  [SMALL_STATE(2653)] = 279494,
  [SMALL_STATE(2654)] = 279630,
  [SMALL_STATE(2655)] = 279766,
  [SMALL_STATE(2656)] = 279902,
  [SMALL_STATE(2657)] = 280038,
  [SMALL_STATE(2658)] = 280174,
  [SMALL_STATE(2659)] = 280310,
  [SMALL_STATE(2660)] = 280446,
  [SMALL_STATE(2661)] = 280577,
  [SMALL_STATE(2662)] = 280714,
  [SMALL_STATE(2663)] = 280851,
  [SMALL_STATE(2664)] = 280982,
  [SMALL_STATE(2665)] = 281113,
  [SMALL_STATE(2666)] = 281250,
  [SMALL_STATE(2667)] = 281387,
  [SMALL_STATE(2668)] = 281518,
  [SMALL_STATE(2669)] = 281655,
  [SMALL_STATE(2670)] = 281792,
  [SMALL_STATE(2671)] = 281929,
  [SMALL_STATE(2672)] = 282060,
  [SMALL_STATE(2673)] = 282191,
  [SMALL_STATE(2674)] = 282328,
  [SMALL_STATE(2675)] = 282459,
  [SMALL_STATE(2676)] = 282596,
  [SMALL_STATE(2677)] = 282727,
  [SMALL_STATE(2678)] = 282858,
  [SMALL_STATE(2679)] = 282995,
  [SMALL_STATE(2680)] = 283132,
  [SMALL_STATE(2681)] = 283263,
  [SMALL_STATE(2682)] = 283400,
  [SMALL_STATE(2683)] = 283537,
  [SMALL_STATE(2684)] = 283674,
  [SMALL_STATE(2685)] = 283805,
  [SMALL_STATE(2686)] = 283942,
  [SMALL_STATE(2687)] = 284079,
  [SMALL_STATE(2688)] = 284216,
  [SMALL_STATE(2689)] = 284353,
  [SMALL_STATE(2690)] = 284490,
  [SMALL_STATE(2691)] = 284627,
  [SMALL_STATE(2692)] = 284764,
  [SMALL_STATE(2693)] = 284895,
  [SMALL_STATE(2694)] = 285026,
  [SMALL_STATE(2695)] = 285163,
  [SMALL_STATE(2696)] = 285294,
  [SMALL_STATE(2697)] = 285425,
  [SMALL_STATE(2698)] = 285562,
  [SMALL_STATE(2699)] = 285699,
  [SMALL_STATE(2700)] = 285836,
  [SMALL_STATE(2701)] = 285973,
  [SMALL_STATE(2702)] = 286104,
  [SMALL_STATE(2703)] = 286241,
  [SMALL_STATE(2704)] = 286378,
  [SMALL_STATE(2705)] = 286515,
  [SMALL_STATE(2706)] = 286646,
  [SMALL_STATE(2707)] = 286783,
  [SMALL_STATE(2708)] = 286920,
  [SMALL_STATE(2709)] = 287057,
  [SMALL_STATE(2710)] = 287194,
  [SMALL_STATE(2711)] = 287325,
  [SMALL_STATE(2712)] = 287462,
  [SMALL_STATE(2713)] = 287599,
  [SMALL_STATE(2714)] = 287736,
  [SMALL_STATE(2715)] = 287867,
  [SMALL_STATE(2716)] = 288004,
  [SMALL_STATE(2717)] = 288135,
  [SMALL_STATE(2718)] = 288266,
  [SMALL_STATE(2719)] = 288403,
  [SMALL_STATE(2720)] = 288540,
  [SMALL_STATE(2721)] = 288677,
  [SMALL_STATE(2722)] = 288814,
  [SMALL_STATE(2723)] = 288945,
  [SMALL_STATE(2724)] = 289076,
  [SMALL_STATE(2725)] = 289207,
  [SMALL_STATE(2726)] = 289338,
  [SMALL_STATE(2727)] = 289475,
  [SMALL_STATE(2728)] = 289612,
  [SMALL_STATE(2729)] = 289743,
  [SMALL_STATE(2730)] = 289880,
  [SMALL_STATE(2731)] = 290011,
  [SMALL_STATE(2732)] = 290148,
  [SMALL_STATE(2733)] = 290285,
  [SMALL_STATE(2734)] = 290422,
  [SMALL_STATE(2735)] = 290559,
  [SMALL_STATE(2736)] = 290696,
  [SMALL_STATE(2737)] = 290833,
  [SMALL_STATE(2738)] = 290970,
  [SMALL_STATE(2739)] = 291101,
  [SMALL_STATE(2740)] = 291238,
  [SMALL_STATE(2741)] = 291375,
  [SMALL_STATE(2742)] = 291512,
  [SMALL_STATE(2743)] = 291649,
  [SMALL_STATE(2744)] = 291780,
  [SMALL_STATE(2745)] = 291911,
  [SMALL_STATE(2746)] = 292048,
  [SMALL_STATE(2747)] = 292185,
  [SMALL_STATE(2748)] = 292322,
  [SMALL_STATE(2749)] = 292459,
  [SMALL_STATE(2750)] = 292590,
  [SMALL_STATE(2751)] = 292721,
  [SMALL_STATE(2752)] = 292858,
  [SMALL_STATE(2753)] = 292995,
  [SMALL_STATE(2754)] = 293126,
  [SMALL_STATE(2755)] = 293257,
  [SMALL_STATE(2756)] = 293394,
  [SMALL_STATE(2757)] = 293531,
  [SMALL_STATE(2758)] = 293668,
  [SMALL_STATE(2759)] = 293805,
  [SMALL_STATE(2760)] = 293942,
  [SMALL_STATE(2761)] = 294079,
  [SMALL_STATE(2762)] = 294216,
  [SMALL_STATE(2763)] = 294353,
  [SMALL_STATE(2764)] = 294490,
  [SMALL_STATE(2765)] = 294627,
  [SMALL_STATE(2766)] = 294764,
  [SMALL_STATE(2767)] = 294901,
  [SMALL_STATE(2768)] = 295038,
  [SMALL_STATE(2769)] = 295175,
  [SMALL_STATE(2770)] = 295312,
  [SMALL_STATE(2771)] = 295449,
  [SMALL_STATE(2772)] = 295586,
  [SMALL_STATE(2773)] = 295717,
  [SMALL_STATE(2774)] = 295848,
  [SMALL_STATE(2775)] = 295985,
  [SMALL_STATE(2776)] = 296116,
  [SMALL_STATE(2777)] = 296253,
  [SMALL_STATE(2778)] = 296390,
  [SMALL_STATE(2779)] = 296527,
  [SMALL_STATE(2780)] = 296664,
  [SMALL_STATE(2781)] = 296795,
  [SMALL_STATE(2782)] = 296932,
  [SMALL_STATE(2783)] = 297063,
  [SMALL_STATE(2784)] = 297194,
  [SMALL_STATE(2785)] = 297325,
  [SMALL_STATE(2786)] = 297456,
  [SMALL_STATE(2787)] = 297587,
  [SMALL_STATE(2788)] = 297718,
  [SMALL_STATE(2789)] = 297855,
  [SMALL_STATE(2790)] = 297986,
  [SMALL_STATE(2791)] = 298117,
  [SMALL_STATE(2792)] = 298254,
  [SMALL_STATE(2793)] = 298385,
  [SMALL_STATE(2794)] = 298516,
  [SMALL_STATE(2795)] = 298647,
  [SMALL_STATE(2796)] = 298778,
  [SMALL_STATE(2797)] = 298915,
  [SMALL_STATE(2798)] = 299046,
  [SMALL_STATE(2799)] = 299177,
  [SMALL_STATE(2800)] = 299314,
  [SMALL_STATE(2801)] = 299445,
  [SMALL_STATE(2802)] = 299582,
  [SMALL_STATE(2803)] = 299719,
  [SMALL_STATE(2804)] = 299856,
  [SMALL_STATE(2805)] = 299987,
  [SMALL_STATE(2806)] = 300124,
  [SMALL_STATE(2807)] = 300261,
  [SMALL_STATE(2808)] = 300398,
  [SMALL_STATE(2809)] = 300535,
  [SMALL_STATE(2810)] = 300666,
  [SMALL_STATE(2811)] = 300803,
  [SMALL_STATE(2812)] = 300934,
  [SMALL_STATE(2813)] = 301065,
  [SMALL_STATE(2814)] = 301202,
  [SMALL_STATE(2815)] = 301333,
  [SMALL_STATE(2816)] = 301470,
  [SMALL_STATE(2817)] = 301607,
  [SMALL_STATE(2818)] = 301744,
  [SMALL_STATE(2819)] = 301881,
  [SMALL_STATE(2820)] = 302012,
  [SMALL_STATE(2821)] = 302149,
  [SMALL_STATE(2822)] = 302286,
  [SMALL_STATE(2823)] = 302423,
  [SMALL_STATE(2824)] = 302560,
  [SMALL_STATE(2825)] = 302697,
  [SMALL_STATE(2826)] = 302828,
  [SMALL_STATE(2827)] = 302962,
  [SMALL_STATE(2828)] = 303096,
  [SMALL_STATE(2829)] = 303230,
  [SMALL_STATE(2830)] = 303364,
  [SMALL_STATE(2831)] = 303498,
  [SMALL_STATE(2832)] = 303632,
  [SMALL_STATE(2833)] = 303761,
  [SMALL_STATE(2834)] = 303890,
  [SMALL_STATE(2835)] = 304019,
  [SMALL_STATE(2836)] = 304148,
  [SMALL_STATE(2837)] = 304277,
  [SMALL_STATE(2838)] = 304406,
  [SMALL_STATE(2839)] = 304535,
  [SMALL_STATE(2840)] = 304664,
  [SMALL_STATE(2841)] = 304793,
  [SMALL_STATE(2842)] = 304922,
  [SMALL_STATE(2843)] = 305051,
  [SMALL_STATE(2844)] = 305180,
  [SMALL_STATE(2845)] = 305309,
  [SMALL_STATE(2846)] = 305438,
  [SMALL_STATE(2847)] = 305567,
  [SMALL_STATE(2848)] = 305696,
  [SMALL_STATE(2849)] = 305825,
  [SMALL_STATE(2850)] = 305954,
  [SMALL_STATE(2851)] = 306083,
  [SMALL_STATE(2852)] = 306212,
  [SMALL_STATE(2853)] = 306341,
  [SMALL_STATE(2854)] = 306470,
  [SMALL_STATE(2855)] = 306599,
  [SMALL_STATE(2856)] = 306728,
  [SMALL_STATE(2857)] = 306857,
  [SMALL_STATE(2858)] = 306986,
  [SMALL_STATE(2859)] = 307115,
  [SMALL_STATE(2860)] = 307244,
  [SMALL_STATE(2861)] = 307373,
  [SMALL_STATE(2862)] = 307502,
  [SMALL_STATE(2863)] = 307631,
  [SMALL_STATE(2864)] = 307760,
  [SMALL_STATE(2865)] = 307889,
  [SMALL_STATE(2866)] = 308018,
  [SMALL_STATE(2867)] = 308147,
  [SMALL_STATE(2868)] = 308276,
  [SMALL_STATE(2869)] = 308405,
  [SMALL_STATE(2870)] = 308534,
  [SMALL_STATE(2871)] = 308663,
  [SMALL_STATE(2872)] = 308792,
  [SMALL_STATE(2873)] = 308921,
  [SMALL_STATE(2874)] = 309050,
  [SMALL_STATE(2875)] = 309179,
  [SMALL_STATE(2876)] = 309308,
  [SMALL_STATE(2877)] = 309437,
  [SMALL_STATE(2878)] = 309566,
  [SMALL_STATE(2879)] = 309695,
  [SMALL_STATE(2880)] = 309824,
  [SMALL_STATE(2881)] = 309953,
  [SMALL_STATE(2882)] = 310082,
  [SMALL_STATE(2883)] = 310211,
  [SMALL_STATE(2884)] = 310340,
  [SMALL_STATE(2885)] = 310469,
  [SMALL_STATE(2886)] = 310598,
  [SMALL_STATE(2887)] = 310727,
  [SMALL_STATE(2888)] = 310856,
  [SMALL_STATE(2889)] = 310985,
  [SMALL_STATE(2890)] = 311114,
  [SMALL_STATE(2891)] = 311243,
  [SMALL_STATE(2892)] = 311372,
  [SMALL_STATE(2893)] = 311501,
  [SMALL_STATE(2894)] = 311630,
  [SMALL_STATE(2895)] = 311759,
  [SMALL_STATE(2896)] = 311888,
  [SMALL_STATE(2897)] = 312017,
  [SMALL_STATE(2898)] = 312146,
  [SMALL_STATE(2899)] = 312275,
  [SMALL_STATE(2900)] = 312404,
  [SMALL_STATE(2901)] = 312533,
  [SMALL_STATE(2902)] = 312662,
  [SMALL_STATE(2903)] = 312791,
  [SMALL_STATE(2904)] = 312920,
  [SMALL_STATE(2905)] = 313049,
  [SMALL_STATE(2906)] = 313178,
  [SMALL_STATE(2907)] = 313307,
  [SMALL_STATE(2908)] = 313436,
  [SMALL_STATE(2909)] = 313565,
  [SMALL_STATE(2910)] = 313694,
  [SMALL_STATE(2911)] = 313823,
  [SMALL_STATE(2912)] = 313952,
  [SMALL_STATE(2913)] = 314081,
  [SMALL_STATE(2914)] = 314210,
  [SMALL_STATE(2915)] = 314339,
  [SMALL_STATE(2916)] = 314468,
  [SMALL_STATE(2917)] = 314597,
  [SMALL_STATE(2918)] = 314726,
  [SMALL_STATE(2919)] = 314855,
  [SMALL_STATE(2920)] = 314984,
  [SMALL_STATE(2921)] = 315113,
  [SMALL_STATE(2922)] = 315242,
  [SMALL_STATE(2923)] = 315371,
  [SMALL_STATE(2924)] = 315500,
  [SMALL_STATE(2925)] = 315629,
  [SMALL_STATE(2926)] = 315758,
  [SMALL_STATE(2927)] = 315887,
  [SMALL_STATE(2928)] = 316016,
  [SMALL_STATE(2929)] = 316145,
  [SMALL_STATE(2930)] = 316274,
  [SMALL_STATE(2931)] = 316403,
  [SMALL_STATE(2932)] = 316532,
  [SMALL_STATE(2933)] = 316661,
  [SMALL_STATE(2934)] = 316790,
  [SMALL_STATE(2935)] = 316919,
  [SMALL_STATE(2936)] = 317048,
  [SMALL_STATE(2937)] = 317177,
  [SMALL_STATE(2938)] = 317306,
  [SMALL_STATE(2939)] = 317435,
  [SMALL_STATE(2940)] = 317564,
  [SMALL_STATE(2941)] = 317693,
  [SMALL_STATE(2942)] = 317822,
  [SMALL_STATE(2943)] = 317951,
  [SMALL_STATE(2944)] = 318080,
  [SMALL_STATE(2945)] = 318209,
  [SMALL_STATE(2946)] = 318338,
  [SMALL_STATE(2947)] = 318467,
  [SMALL_STATE(2948)] = 318596,
  [SMALL_STATE(2949)] = 318725,
  [SMALL_STATE(2950)] = 318854,
  [SMALL_STATE(2951)] = 318983,
  [SMALL_STATE(2952)] = 319112,
  [SMALL_STATE(2953)] = 319241,
  [SMALL_STATE(2954)] = 319370,
  [SMALL_STATE(2955)] = 319499,
  [SMALL_STATE(2956)] = 319628,
  [SMALL_STATE(2957)] = 319757,
  [SMALL_STATE(2958)] = 319886,
  [SMALL_STATE(2959)] = 320015,
  [SMALL_STATE(2960)] = 320144,
  [SMALL_STATE(2961)] = 320273,
  [SMALL_STATE(2962)] = 320402,
  [SMALL_STATE(2963)] = 320531,
  [SMALL_STATE(2964)] = 320660,
  [SMALL_STATE(2965)] = 320789,
  [SMALL_STATE(2966)] = 320918,
  [SMALL_STATE(2967)] = 321047,
  [SMALL_STATE(2968)] = 321176,
  [SMALL_STATE(2969)] = 321305,
  [SMALL_STATE(2970)] = 321434,
  [SMALL_STATE(2971)] = 321501,
  [SMALL_STATE(2972)] = 321630,
  [SMALL_STATE(2973)] = 321759,
  [SMALL_STATE(2974)] = 321888,
  [SMALL_STATE(2975)] = 322017,
  [SMALL_STATE(2976)] = 322146,
  [SMALL_STATE(2977)] = 322275,
  [SMALL_STATE(2978)] = 322404,
  [SMALL_STATE(2979)] = 322533,
  [SMALL_STATE(2980)] = 322662,
  [SMALL_STATE(2981)] = 322791,
  [SMALL_STATE(2982)] = 322920,
  [SMALL_STATE(2983)] = 323049,
  [SMALL_STATE(2984)] = 323178,
  [SMALL_STATE(2985)] = 323307,
  [SMALL_STATE(2986)] = 323436,
  [SMALL_STATE(2987)] = 323565,
  [SMALL_STATE(2988)] = 323694,
  [SMALL_STATE(2989)] = 323823,
  [SMALL_STATE(2990)] = 323952,
  [SMALL_STATE(2991)] = 324081,
  [SMALL_STATE(2992)] = 324210,
  [SMALL_STATE(2993)] = 324339,
  [SMALL_STATE(2994)] = 324468,
  [SMALL_STATE(2995)] = 324597,
  [SMALL_STATE(2996)] = 324726,
  [SMALL_STATE(2997)] = 324855,
  [SMALL_STATE(2998)] = 324984,
  [SMALL_STATE(2999)] = 325113,
  [SMALL_STATE(3000)] = 325242,
  [SMALL_STATE(3001)] = 325371,
  [SMALL_STATE(3002)] = 325500,
  [SMALL_STATE(3003)] = 325629,
  [SMALL_STATE(3004)] = 325758,
  [SMALL_STATE(3005)] = 325887,
  [SMALL_STATE(3006)] = 326016,
  [SMALL_STATE(3007)] = 326145,
  [SMALL_STATE(3008)] = 326274,
  [SMALL_STATE(3009)] = 326403,
  [SMALL_STATE(3010)] = 326532,
  [SMALL_STATE(3011)] = 326661,
  [SMALL_STATE(3012)] = 326790,
  [SMALL_STATE(3013)] = 326919,
  [SMALL_STATE(3014)] = 327048,
  [SMALL_STATE(3015)] = 327177,
  [SMALL_STATE(3016)] = 327306,
  [SMALL_STATE(3017)] = 327435,
  [SMALL_STATE(3018)] = 327564,
  [SMALL_STATE(3019)] = 327693,
  [SMALL_STATE(3020)] = 327822,
  [SMALL_STATE(3021)] = 327951,
  [SMALL_STATE(3022)] = 328080,
  [SMALL_STATE(3023)] = 328209,
  [SMALL_STATE(3024)] = 328338,
  [SMALL_STATE(3025)] = 328467,
  [SMALL_STATE(3026)] = 328596,
  [SMALL_STATE(3027)] = 328725,
  [SMALL_STATE(3028)] = 328854,
  [SMALL_STATE(3029)] = 328983,
  [SMALL_STATE(3030)] = 329112,
  [SMALL_STATE(3031)] = 329241,
  [SMALL_STATE(3032)] = 329370,
  [SMALL_STATE(3033)] = 329499,
  [SMALL_STATE(3034)] = 329628,
  [SMALL_STATE(3035)] = 329757,
  [SMALL_STATE(3036)] = 329886,
  [SMALL_STATE(3037)] = 330015,
  [SMALL_STATE(3038)] = 330144,
  [SMALL_STATE(3039)] = 330273,
  [SMALL_STATE(3040)] = 330402,
  [SMALL_STATE(3041)] = 330531,
  [SMALL_STATE(3042)] = 330660,
  [SMALL_STATE(3043)] = 330789,
  [SMALL_STATE(3044)] = 330918,
  [SMALL_STATE(3045)] = 331047,
  [SMALL_STATE(3046)] = 331176,
  [SMALL_STATE(3047)] = 331305,
  [SMALL_STATE(3048)] = 331434,
  [SMALL_STATE(3049)] = 331563,
  [SMALL_STATE(3050)] = 331692,
  [SMALL_STATE(3051)] = 331821,
  [SMALL_STATE(3052)] = 331950,
  [SMALL_STATE(3053)] = 332079,
  [SMALL_STATE(3054)] = 332208,
  [SMALL_STATE(3055)] = 332337,
  [SMALL_STATE(3056)] = 332466,
  [SMALL_STATE(3057)] = 332595,
  [SMALL_STATE(3058)] = 332724,
  [SMALL_STATE(3059)] = 332853,
  [SMALL_STATE(3060)] = 332982,
  [SMALL_STATE(3061)] = 333111,
  [SMALL_STATE(3062)] = 333240,
  [SMALL_STATE(3063)] = 333369,
  [SMALL_STATE(3064)] = 333498,
  [SMALL_STATE(3065)] = 333627,
  [SMALL_STATE(3066)] = 333756,
  [SMALL_STATE(3067)] = 333885,
  [SMALL_STATE(3068)] = 334014,
  [SMALL_STATE(3069)] = 334143,
  [SMALL_STATE(3070)] = 334272,
  [SMALL_STATE(3071)] = 334401,
  [SMALL_STATE(3072)] = 334530,
  [SMALL_STATE(3073)] = 334659,
  [SMALL_STATE(3074)] = 334788,
  [SMALL_STATE(3075)] = 334917,
  [SMALL_STATE(3076)] = 335046,
  [SMALL_STATE(3077)] = 335175,
  [SMALL_STATE(3078)] = 335304,
  [SMALL_STATE(3079)] = 335433,
  [SMALL_STATE(3080)] = 335562,
  [SMALL_STATE(3081)] = 335691,
  [SMALL_STATE(3082)] = 335820,
  [SMALL_STATE(3083)] = 335949,
  [SMALL_STATE(3084)] = 336078,
  [SMALL_STATE(3085)] = 336207,
  [SMALL_STATE(3086)] = 336336,
  [SMALL_STATE(3087)] = 336465,
  [SMALL_STATE(3088)] = 336594,
  [SMALL_STATE(3089)] = 336723,
  [SMALL_STATE(3090)] = 336852,
  [SMALL_STATE(3091)] = 336981,
  [SMALL_STATE(3092)] = 337110,
  [SMALL_STATE(3093)] = 337239,
  [SMALL_STATE(3094)] = 337368,
  [SMALL_STATE(3095)] = 337497,
  [SMALL_STATE(3096)] = 337626,
  [SMALL_STATE(3097)] = 337755,
  [SMALL_STATE(3098)] = 337884,
  [SMALL_STATE(3099)] = 338013,
  [SMALL_STATE(3100)] = 338139,
  [SMALL_STATE(3101)] = 338265,
  [SMALL_STATE(3102)] = 338391,
  [SMALL_STATE(3103)] = 338517,
  [SMALL_STATE(3104)] = 338643,
  [SMALL_STATE(3105)] = 338769,
  [SMALL_STATE(3106)] = 338895,
  [SMALL_STATE(3107)] = 339021,
  [SMALL_STATE(3108)] = 339147,
  [SMALL_STATE(3109)] = 339273,
  [SMALL_STATE(3110)] = 339399,
  [SMALL_STATE(3111)] = 339525,
  [SMALL_STATE(3112)] = 339651,
  [SMALL_STATE(3113)] = 339777,
  [SMALL_STATE(3114)] = 339903,
  [SMALL_STATE(3115)] = 340029,
  [SMALL_STATE(3116)] = 340155,
  [SMALL_STATE(3117)] = 340281,
  [SMALL_STATE(3118)] = 340407,
  [SMALL_STATE(3119)] = 340533,
  [SMALL_STATE(3120)] = 340659,
  [SMALL_STATE(3121)] = 340785,
  [SMALL_STATE(3122)] = 340910,
  [SMALL_STATE(3123)] = 340980,
  [SMALL_STATE(3124)] = 341048,
  [SMALL_STATE(3125)] = 341168,
  [SMALL_STATE(3126)] = 341290,
  [SMALL_STATE(3127)] = 341360,
  [SMALL_STATE(3128)] = 341430,
  [SMALL_STATE(3129)] = 341498,
  [SMALL_STATE(3130)] = 341620,
  [SMALL_STATE(3131)] = 341737,
  [SMALL_STATE(3132)] = 341804,
  [SMALL_STATE(3133)] = 341921,
  [SMALL_STATE(3134)] = 342040,
  [SMALL_STATE(3135)] = 342157,
  [SMALL_STATE(3136)] = 342274,
  [SMALL_STATE(3137)] = 342393,
  [SMALL_STATE(3138)] = 342460,
  [SMALL_STATE(3139)] = 342579,
  [SMALL_STATE(3140)] = 342646,
  [SMALL_STATE(3141)] = 342713,
  [SMALL_STATE(3142)] = 342780,
  [SMALL_STATE(3143)] = 342847,
  [SMALL_STATE(3144)] = 342914,
  [SMALL_STATE(3145)] = 343033,
  [SMALL_STATE(3146)] = 343100,
  [SMALL_STATE(3147)] = 343167,
  [SMALL_STATE(3148)] = 343234,
  [SMALL_STATE(3149)] = 343353,
  [SMALL_STATE(3150)] = 343420,
  [SMALL_STATE(3151)] = 343487,
  [SMALL_STATE(3152)] = 343606,
  [SMALL_STATE(3153)] = 343673,
  [SMALL_STATE(3154)] = 343740,
  [SMALL_STATE(3155)] = 343807,
  [SMALL_STATE(3156)] = 343874,
  [SMALL_STATE(3157)] = 343993,
  [SMALL_STATE(3158)] = 344060,
  [SMALL_STATE(3159)] = 344179,
  [SMALL_STATE(3160)] = 344246,
  [SMALL_STATE(3161)] = 344313,
  [SMALL_STATE(3162)] = 344380,
  [SMALL_STATE(3163)] = 344499,
  [SMALL_STATE(3164)] = 344618,
  [SMALL_STATE(3165)] = 344735,
  [SMALL_STATE(3166)] = 344854,
  [SMALL_STATE(3167)] = 344921,
  [SMALL_STATE(3168)] = 344988,
  [SMALL_STATE(3169)] = 345107,
  [SMALL_STATE(3170)] = 345174,
  [SMALL_STATE(3171)] = 345241,
  [SMALL_STATE(3172)] = 345308,
  [SMALL_STATE(3173)] = 345425,
  [SMALL_STATE(3174)] = 345492,
  [SMALL_STATE(3175)] = 345611,
  [SMALL_STATE(3176)] = 345678,
  [SMALL_STATE(3177)] = 345795,
  [SMALL_STATE(3178)] = 345862,
  [SMALL_STATE(3179)] = 345981,
  [SMALL_STATE(3180)] = 346048,
  [SMALL_STATE(3181)] = 346115,
  [SMALL_STATE(3182)] = 346182,
  [SMALL_STATE(3183)] = 346249,
  [SMALL_STATE(3184)] = 346316,
  [SMALL_STATE(3185)] = 346383,
  [SMALL_STATE(3186)] = 346450,
  [SMALL_STATE(3187)] = 346517,
  [SMALL_STATE(3188)] = 346584,
  [SMALL_STATE(3189)] = 346651,
  [SMALL_STATE(3190)] = 346718,
  [SMALL_STATE(3191)] = 346835,
  [SMALL_STATE(3192)] = 346902,
  [SMALL_STATE(3193)] = 346969,
  [SMALL_STATE(3194)] = 347088,
  [SMALL_STATE(3195)] = 347155,
  [SMALL_STATE(3196)] = 347272,
  [SMALL_STATE(3197)] = 347339,
  [SMALL_STATE(3198)] = 347458,
  [SMALL_STATE(3199)] = 347525,
  [SMALL_STATE(3200)] = 347642,
  [SMALL_STATE(3201)] = 347759,
  [SMALL_STATE(3202)] = 347878,
  [SMALL_STATE(3203)] = 347997,
  [SMALL_STATE(3204)] = 348114,
  [SMALL_STATE(3205)] = 348181,
  [SMALL_STATE(3206)] = 348298,
  [SMALL_STATE(3207)] = 348365,
  [SMALL_STATE(3208)] = 348432,
  [SMALL_STATE(3209)] = 348499,
  [SMALL_STATE(3210)] = 348566,
  [SMALL_STATE(3211)] = 348685,
  [SMALL_STATE(3212)] = 348804,
  [SMALL_STATE(3213)] = 348871,
  [SMALL_STATE(3214)] = 348988,
  [SMALL_STATE(3215)] = 349107,
  [SMALL_STATE(3216)] = 349174,
  [SMALL_STATE(3217)] = 349293,
  [SMALL_STATE(3218)] = 349360,
  [SMALL_STATE(3219)] = 349479,
  [SMALL_STATE(3220)] = 349546,
  [SMALL_STATE(3221)] = 349613,
  [SMALL_STATE(3222)] = 349732,
  [SMALL_STATE(3223)] = 349849,
  [SMALL_STATE(3224)] = 349916,
  [SMALL_STATE(3225)] = 349983,
  [SMALL_STATE(3226)] = 350050,
  [SMALL_STATE(3227)] = 350167,
  [SMALL_STATE(3228)] = 350284,
  [SMALL_STATE(3229)] = 350351,
  [SMALL_STATE(3230)] = 350468,
  [SMALL_STATE(3231)] = 350535,
  [SMALL_STATE(3232)] = 350602,
  [SMALL_STATE(3233)] = 350669,
  [SMALL_STATE(3234)] = 350786,
  [SMALL_STATE(3235)] = 350853,
  [SMALL_STATE(3236)] = 350920,
  [SMALL_STATE(3237)] = 350987,
  [SMALL_STATE(3238)] = 351054,
  [SMALL_STATE(3239)] = 351121,
  [SMALL_STATE(3240)] = 351188,
  [SMALL_STATE(3241)] = 351255,
  [SMALL_STATE(3242)] = 351322,
  [SMALL_STATE(3243)] = 351389,
  [SMALL_STATE(3244)] = 351508,
  [SMALL_STATE(3245)] = 351575,
  [SMALL_STATE(3246)] = 351642,
  [SMALL_STATE(3247)] = 351761,
  [SMALL_STATE(3248)] = 351878,
  [SMALL_STATE(3249)] = 351945,
  [SMALL_STATE(3250)] = 352012,
  [SMALL_STATE(3251)] = 352079,
  [SMALL_STATE(3252)] = 352146,
  [SMALL_STATE(3253)] = 352213,
  [SMALL_STATE(3254)] = 352280,
  [SMALL_STATE(3255)] = 352347,
  [SMALL_STATE(3256)] = 352414,
  [SMALL_STATE(3257)] = 352481,
  [SMALL_STATE(3258)] = 352548,
  [SMALL_STATE(3259)] = 352615,
  [SMALL_STATE(3260)] = 352734,
  [SMALL_STATE(3261)] = 352801,
  [SMALL_STATE(3262)] = 352868,
  [SMALL_STATE(3263)] = 352987,
  [SMALL_STATE(3264)] = 353054,
  [SMALL_STATE(3265)] = 353121,
  [SMALL_STATE(3266)] = 353188,
  [SMALL_STATE(3267)] = 353307,
  [SMALL_STATE(3268)] = 353374,
  [SMALL_STATE(3269)] = 353441,
  [SMALL_STATE(3270)] = 353508,
  [SMALL_STATE(3271)] = 353575,
  [SMALL_STATE(3272)] = 353694,
  [SMALL_STATE(3273)] = 353761,
  [SMALL_STATE(3274)] = 353828,
  [SMALL_STATE(3275)] = 353947,
  [SMALL_STATE(3276)] = 354064,
  [SMALL_STATE(3277)] = 354183,
  [SMALL_STATE(3278)] = 354250,
  [SMALL_STATE(3279)] = 354369,
  [SMALL_STATE(3280)] = 354488,
  [SMALL_STATE(3281)] = 354555,
  [SMALL_STATE(3282)] = 354672,
  [SMALL_STATE(3283)] = 354739,
  [SMALL_STATE(3284)] = 354806,
  [SMALL_STATE(3285)] = 354873,
  [SMALL_STATE(3286)] = 354992,
  [SMALL_STATE(3287)] = 355059,
  [SMALL_STATE(3288)] = 355178,
  [SMALL_STATE(3289)] = 355297,
  [SMALL_STATE(3290)] = 355364,
  [SMALL_STATE(3291)] = 355431,
  [SMALL_STATE(3292)] = 355548,
  [SMALL_STATE(3293)] = 355615,
  [SMALL_STATE(3294)] = 355682,
  [SMALL_STATE(3295)] = 355749,
  [SMALL_STATE(3296)] = 355868,
  [SMALL_STATE(3297)] = 355935,
  [SMALL_STATE(3298)] = 356002,
  [SMALL_STATE(3299)] = 356069,
  [SMALL_STATE(3300)] = 356186,
  [SMALL_STATE(3301)] = 356305,
  [SMALL_STATE(3302)] = 356424,
  [SMALL_STATE(3303)] = 356541,
  [SMALL_STATE(3304)] = 356608,
  [SMALL_STATE(3305)] = 356675,
  [SMALL_STATE(3306)] = 356742,
  [SMALL_STATE(3307)] = 356861,
  [SMALL_STATE(3308)] = 356978,
  [SMALL_STATE(3309)] = 357095,
  [SMALL_STATE(3310)] = 357212,
  [SMALL_STATE(3311)] = 357279,
  [SMALL_STATE(3312)] = 357398,
  [SMALL_STATE(3313)] = 357465,
  [SMALL_STATE(3314)] = 357584,
  [SMALL_STATE(3315)] = 357651,
  [SMALL_STATE(3316)] = 357718,
  [SMALL_STATE(3317)] = 357837,
  [SMALL_STATE(3318)] = 357904,
  [SMALL_STATE(3319)] = 357971,
  [SMALL_STATE(3320)] = 358088,
  [SMALL_STATE(3321)] = 358155,
  [SMALL_STATE(3322)] = 358222,
  [SMALL_STATE(3323)] = 358289,
  [SMALL_STATE(3324)] = 358356,
  [SMALL_STATE(3325)] = 358423,
  [SMALL_STATE(3326)] = 358490,
  [SMALL_STATE(3327)] = 358609,
  [SMALL_STATE(3328)] = 358726,
  [SMALL_STATE(3329)] = 358793,
  [SMALL_STATE(3330)] = 358860,
  [SMALL_STATE(3331)] = 358927,
  [SMALL_STATE(3332)] = 359046,
  [SMALL_STATE(3333)] = 359113,
  [SMALL_STATE(3334)] = 359180,
  [SMALL_STATE(3335)] = 359247,
  [SMALL_STATE(3336)] = 359314,
  [SMALL_STATE(3337)] = 359381,
  [SMALL_STATE(3338)] = 359500,
  [SMALL_STATE(3339)] = 359567,
  [SMALL_STATE(3340)] = 359686,
  [SMALL_STATE(3341)] = 359753,
  [SMALL_STATE(3342)] = 359820,
  [SMALL_STATE(3343)] = 359887,
  [SMALL_STATE(3344)] = 360006,
  [SMALL_STATE(3345)] = 360125,
  [SMALL_STATE(3346)] = 360192,
  [SMALL_STATE(3347)] = 360259,
  [SMALL_STATE(3348)] = 360326,
  [SMALL_STATE(3349)] = 360442,
  [SMALL_STATE(3350)] = 360558,
  [SMALL_STATE(3351)] = 360674,
  [SMALL_STATE(3352)] = 360792,
  [SMALL_STATE(3353)] = 360908,
  [SMALL_STATE(3354)] = 361026,
  [SMALL_STATE(3355)] = 361142,
  [SMALL_STATE(3356)] = 361258,
  [SMALL_STATE(3357)] = 361374,
  [SMALL_STATE(3358)] = 361492,
  [SMALL_STATE(3359)] = 361608,
  [SMALL_STATE(3360)] = 361724,
  [SMALL_STATE(3361)] = 361840,
  [SMALL_STATE(3362)] = 361956,
  [SMALL_STATE(3363)] = 362072,
  [SMALL_STATE(3364)] = 362188,
  [SMALL_STATE(3365)] = 362304,
  [SMALL_STATE(3366)] = 362420,
  [SMALL_STATE(3367)] = 362536,
  [SMALL_STATE(3368)] = 362652,
  [SMALL_STATE(3369)] = 362768,
  [SMALL_STATE(3370)] = 362884,
  [SMALL_STATE(3371)] = 363000,
  [SMALL_STATE(3372)] = 363116,
  [SMALL_STATE(3373)] = 363232,
  [SMALL_STATE(3374)] = 363348,
  [SMALL_STATE(3375)] = 363464,
  [SMALL_STATE(3376)] = 363582,
  [SMALL_STATE(3377)] = 363698,
  [SMALL_STATE(3378)] = 363816,
  [SMALL_STATE(3379)] = 363934,
  [SMALL_STATE(3380)] = 364050,
  [SMALL_STATE(3381)] = 364166,
  [SMALL_STATE(3382)] = 364282,
  [SMALL_STATE(3383)] = 364398,
  [SMALL_STATE(3384)] = 364514,
  [SMALL_STATE(3385)] = 364630,
  [SMALL_STATE(3386)] = 364746,
  [SMALL_STATE(3387)] = 364864,
  [SMALL_STATE(3388)] = 364980,
  [SMALL_STATE(3389)] = 365096,
  [SMALL_STATE(3390)] = 365212,
  [SMALL_STATE(3391)] = 365330,
  [SMALL_STATE(3392)] = 365446,
  [SMALL_STATE(3393)] = 365562,
  [SMALL_STATE(3394)] = 365678,
  [SMALL_STATE(3395)] = 365796,
  [SMALL_STATE(3396)] = 365912,
  [SMALL_STATE(3397)] = 366028,
  [SMALL_STATE(3398)] = 366144,
  [SMALL_STATE(3399)] = 366260,
  [SMALL_STATE(3400)] = 366376,
  [SMALL_STATE(3401)] = 366492,
  [SMALL_STATE(3402)] = 366608,
  [SMALL_STATE(3403)] = 366724,
  [SMALL_STATE(3404)] = 366840,
  [SMALL_STATE(3405)] = 366956,
  [SMALL_STATE(3406)] = 367072,
  [SMALL_STATE(3407)] = 367188,
  [SMALL_STATE(3408)] = 367304,
  [SMALL_STATE(3409)] = 367420,
  [SMALL_STATE(3410)] = 367536,
  [SMALL_STATE(3411)] = 367654,
  [SMALL_STATE(3412)] = 367770,
  [SMALL_STATE(3413)] = 367888,
  [SMALL_STATE(3414)] = 368004,
  [SMALL_STATE(3415)] = 368120,
  [SMALL_STATE(3416)] = 368236,
  [SMALL_STATE(3417)] = 368352,
  [SMALL_STATE(3418)] = 368468,
  [SMALL_STATE(3419)] = 368584,
  [SMALL_STATE(3420)] = 368700,
  [SMALL_STATE(3421)] = 368816,
  [SMALL_STATE(3422)] = 368932,
  [SMALL_STATE(3423)] = 369048,
  [SMALL_STATE(3424)] = 369166,
  [SMALL_STATE(3425)] = 369282,
  [SMALL_STATE(3426)] = 369398,
  [SMALL_STATE(3427)] = 369516,
  [SMALL_STATE(3428)] = 369632,
  [SMALL_STATE(3429)] = 369748,
  [SMALL_STATE(3430)] = 369864,
  [SMALL_STATE(3431)] = 369980,
  [SMALL_STATE(3432)] = 370096,
  [SMALL_STATE(3433)] = 370212,
  [SMALL_STATE(3434)] = 370328,
  [SMALL_STATE(3435)] = 370446,
  [SMALL_STATE(3436)] = 370562,
  [SMALL_STATE(3437)] = 370680,
  [SMALL_STATE(3438)] = 370796,
  [SMALL_STATE(3439)] = 370912,
  [SMALL_STATE(3440)] = 371030,
  [SMALL_STATE(3441)] = 371146,
  [SMALL_STATE(3442)] = 371262,
  [SMALL_STATE(3443)] = 371378,
  [SMALL_STATE(3444)] = 371494,
  [SMALL_STATE(3445)] = 371612,
  [SMALL_STATE(3446)] = 371728,
  [SMALL_STATE(3447)] = 371844,
  [SMALL_STATE(3448)] = 371960,
  [SMALL_STATE(3449)] = 372076,
  [SMALL_STATE(3450)] = 372192,
  [SMALL_STATE(3451)] = 372310,
  [SMALL_STATE(3452)] = 372426,
  [SMALL_STATE(3453)] = 372542,
  [SMALL_STATE(3454)] = 372658,
  [SMALL_STATE(3455)] = 372774,
  [SMALL_STATE(3456)] = 372890,
  [SMALL_STATE(3457)] = 373006,
  [SMALL_STATE(3458)] = 373124,
  [SMALL_STATE(3459)] = 373242,
  [SMALL_STATE(3460)] = 373358,
  [SMALL_STATE(3461)] = 373474,
  [SMALL_STATE(3462)] = 373590,
  [SMALL_STATE(3463)] = 373706,
  [SMALL_STATE(3464)] = 373822,
  [SMALL_STATE(3465)] = 373938,
  [SMALL_STATE(3466)] = 374054,
  [SMALL_STATE(3467)] = 374170,
  [SMALL_STATE(3468)] = 374286,
  [SMALL_STATE(3469)] = 374402,
  [SMALL_STATE(3470)] = 374518,
  [SMALL_STATE(3471)] = 374634,
  [SMALL_STATE(3472)] = 374750,
  [SMALL_STATE(3473)] = 374866,
  [SMALL_STATE(3474)] = 374984,
  [SMALL_STATE(3475)] = 375100,
  [SMALL_STATE(3476)] = 375216,
  [SMALL_STATE(3477)] = 375332,
  [SMALL_STATE(3478)] = 375448,
  [SMALL_STATE(3479)] = 375564,
  [SMALL_STATE(3480)] = 375680,
  [SMALL_STATE(3481)] = 375798,
  [SMALL_STATE(3482)] = 375914,
  [SMALL_STATE(3483)] = 376030,
  [SMALL_STATE(3484)] = 376148,
  [SMALL_STATE(3485)] = 376264,
  [SMALL_STATE(3486)] = 376380,
  [SMALL_STATE(3487)] = 376496,
  [SMALL_STATE(3488)] = 376612,
  [SMALL_STATE(3489)] = 376728,
  [SMALL_STATE(3490)] = 376844,
  [SMALL_STATE(3491)] = 376960,
  [SMALL_STATE(3492)] = 377076,
  [SMALL_STATE(3493)] = 377192,
  [SMALL_STATE(3494)] = 377308,
  [SMALL_STATE(3495)] = 377424,
  [SMALL_STATE(3496)] = 377540,
  [SMALL_STATE(3497)] = 377656,
  [SMALL_STATE(3498)] = 377774,
  [SMALL_STATE(3499)] = 377890,
  [SMALL_STATE(3500)] = 378006,
  [SMALL_STATE(3501)] = 378122,
  [SMALL_STATE(3502)] = 378238,
  [SMALL_STATE(3503)] = 378354,
  [SMALL_STATE(3504)] = 378470,
  [SMALL_STATE(3505)] = 378586,
  [SMALL_STATE(3506)] = 378702,
  [SMALL_STATE(3507)] = 378818,
  [SMALL_STATE(3508)] = 378934,
  [SMALL_STATE(3509)] = 379050,
  [SMALL_STATE(3510)] = 379168,
  [SMALL_STATE(3511)] = 379284,
  [SMALL_STATE(3512)] = 379400,
  [SMALL_STATE(3513)] = 379516,
  [SMALL_STATE(3514)] = 379632,
  [SMALL_STATE(3515)] = 379748,
  [SMALL_STATE(3516)] = 379864,
  [SMALL_STATE(3517)] = 379980,
  [SMALL_STATE(3518)] = 380096,
  [SMALL_STATE(3519)] = 380214,
  [SMALL_STATE(3520)] = 380330,
  [SMALL_STATE(3521)] = 380446,
  [SMALL_STATE(3522)] = 380562,
  [SMALL_STATE(3523)] = 380678,
  [SMALL_STATE(3524)] = 380796,
  [SMALL_STATE(3525)] = 380912,
  [SMALL_STATE(3526)] = 381030,
  [SMALL_STATE(3527)] = 381146,
  [SMALL_STATE(3528)] = 381262,
  [SMALL_STATE(3529)] = 381378,
  [SMALL_STATE(3530)] = 381494,
  [SMALL_STATE(3531)] = 381610,
  [SMALL_STATE(3532)] = 381728,
  [SMALL_STATE(3533)] = 381844,
  [SMALL_STATE(3534)] = 381960,
  [SMALL_STATE(3535)] = 382076,
  [SMALL_STATE(3536)] = 382192,
  [SMALL_STATE(3537)] = 382308,
  [SMALL_STATE(3538)] = 382424,
  [SMALL_STATE(3539)] = 382542,
  [SMALL_STATE(3540)] = 382660,
  [SMALL_STATE(3541)] = 382776,
  [SMALL_STATE(3542)] = 382892,
  [SMALL_STATE(3543)] = 383008,
  [SMALL_STATE(3544)] = 383124,
  [SMALL_STATE(3545)] = 383240,
  [SMALL_STATE(3546)] = 383358,
  [SMALL_STATE(3547)] = 383474,
  [SMALL_STATE(3548)] = 383590,
  [SMALL_STATE(3549)] = 383706,
  [SMALL_STATE(3550)] = 383768,
  [SMALL_STATE(3551)] = 383884,
  [SMALL_STATE(3552)] = 384000,
  [SMALL_STATE(3553)] = 384116,
  [SMALL_STATE(3554)] = 384232,
  [SMALL_STATE(3555)] = 384348,
  [SMALL_STATE(3556)] = 384466,
  [SMALL_STATE(3557)] = 384582,
  [SMALL_STATE(3558)] = 384700,
  [SMALL_STATE(3559)] = 384816,
  [SMALL_STATE(3560)] = 384932,
  [SMALL_STATE(3561)] = 385048,
  [SMALL_STATE(3562)] = 385164,
  [SMALL_STATE(3563)] = 385282,
  [SMALL_STATE(3564)] = 385398,
  [SMALL_STATE(3565)] = 385514,
  [SMALL_STATE(3566)] = 385630,
  [SMALL_STATE(3567)] = 385748,
  [SMALL_STATE(3568)] = 385864,
  [SMALL_STATE(3569)] = 385980,
  [SMALL_STATE(3570)] = 386098,
  [SMALL_STATE(3571)] = 386214,
  [SMALL_STATE(3572)] = 386332,
  [SMALL_STATE(3573)] = 386448,
  [SMALL_STATE(3574)] = 386564,
  [SMALL_STATE(3575)] = 386680,
  [SMALL_STATE(3576)] = 386796,
  [SMALL_STATE(3577)] = 386912,
  [SMALL_STATE(3578)] = 387028,
  [SMALL_STATE(3579)] = 387144,
  [SMALL_STATE(3580)] = 387260,
  [SMALL_STATE(3581)] = 387376,
  [SMALL_STATE(3582)] = 387494,
  [SMALL_STATE(3583)] = 387610,
  [SMALL_STATE(3584)] = 387726,
  [SMALL_STATE(3585)] = 387842,
  [SMALL_STATE(3586)] = 387958,
  [SMALL_STATE(3587)] = 388074,
  [SMALL_STATE(3588)] = 388190,
  [SMALL_STATE(3589)] = 388306,
  [SMALL_STATE(3590)] = 388422,
  [SMALL_STATE(3591)] = 388538,
  [SMALL_STATE(3592)] = 388656,
  [SMALL_STATE(3593)] = 388772,
  [SMALL_STATE(3594)] = 388888,
  [SMALL_STATE(3595)] = 389004,
  [SMALL_STATE(3596)] = 389120,
  [SMALL_STATE(3597)] = 389236,
  [SMALL_STATE(3598)] = 389352,
  [SMALL_STATE(3599)] = 389468,
  [SMALL_STATE(3600)] = 389584,
  [SMALL_STATE(3601)] = 389702,
  [SMALL_STATE(3602)] = 389818,
  [SMALL_STATE(3603)] = 389934,
  [SMALL_STATE(3604)] = 390050,
  [SMALL_STATE(3605)] = 390166,
  [SMALL_STATE(3606)] = 390282,
  [SMALL_STATE(3607)] = 390400,
  [SMALL_STATE(3608)] = 390516,
  [SMALL_STATE(3609)] = 390632,
  [SMALL_STATE(3610)] = 390748,
  [SMALL_STATE(3611)] = 390864,
  [SMALL_STATE(3612)] = 390980,
  [SMALL_STATE(3613)] = 391096,
  [SMALL_STATE(3614)] = 391212,
  [SMALL_STATE(3615)] = 391330,
  [SMALL_STATE(3616)] = 391448,
  [SMALL_STATE(3617)] = 391564,
  [SMALL_STATE(3618)] = 391680,
  [SMALL_STATE(3619)] = 391798,
  [SMALL_STATE(3620)] = 391914,
  [SMALL_STATE(3621)] = 392030,
  [SMALL_STATE(3622)] = 392146,
  [SMALL_STATE(3623)] = 392262,
  [SMALL_STATE(3624)] = 392378,
  [SMALL_STATE(3625)] = 392496,
  [SMALL_STATE(3626)] = 392612,
  [SMALL_STATE(3627)] = 392728,
  [SMALL_STATE(3628)] = 392844,
  [SMALL_STATE(3629)] = 392960,
  [SMALL_STATE(3630)] = 393076,
  [SMALL_STATE(3631)] = 393192,
  [SMALL_STATE(3632)] = 393308,
  [SMALL_STATE(3633)] = 393424,
  [SMALL_STATE(3634)] = 393540,
  [SMALL_STATE(3635)] = 393656,
  [SMALL_STATE(3636)] = 393772,
  [SMALL_STATE(3637)] = 393888,
  [SMALL_STATE(3638)] = 394004,
  [SMALL_STATE(3639)] = 394120,
  [SMALL_STATE(3640)] = 394182,
  [SMALL_STATE(3641)] = 394298,
  [SMALL_STATE(3642)] = 394414,
  [SMALL_STATE(3643)] = 394530,
  [SMALL_STATE(3644)] = 394646,
  [SMALL_STATE(3645)] = 394762,
  [SMALL_STATE(3646)] = 394878,
  [SMALL_STATE(3647)] = 394994,
  [SMALL_STATE(3648)] = 395110,
  [SMALL_STATE(3649)] = 395226,
  [SMALL_STATE(3650)] = 395342,
  [SMALL_STATE(3651)] = 395460,
  [SMALL_STATE(3652)] = 395578,
  [SMALL_STATE(3653)] = 395694,
  [SMALL_STATE(3654)] = 395810,
  [SMALL_STATE(3655)] = 395926,
  [SMALL_STATE(3656)] = 396044,
  [SMALL_STATE(3657)] = 396160,
  [SMALL_STATE(3658)] = 396278,
  [SMALL_STATE(3659)] = 396394,
  [SMALL_STATE(3660)] = 396510,
  [SMALL_STATE(3661)] = 396626,
  [SMALL_STATE(3662)] = 396742,
  [SMALL_STATE(3663)] = 396858,
  [SMALL_STATE(3664)] = 396974,
  [SMALL_STATE(3665)] = 397090,
  [SMALL_STATE(3666)] = 397206,
  [SMALL_STATE(3667)] = 397322,
  [SMALL_STATE(3668)] = 397438,
  [SMALL_STATE(3669)] = 397554,
  [SMALL_STATE(3670)] = 397670,
  [SMALL_STATE(3671)] = 397786,
  [SMALL_STATE(3672)] = 397902,
  [SMALL_STATE(3673)] = 398018,
  [SMALL_STATE(3674)] = 398134,
  [SMALL_STATE(3675)] = 398250,
  [SMALL_STATE(3676)] = 398366,
  [SMALL_STATE(3677)] = 398484,
  [SMALL_STATE(3678)] = 398600,
  [SMALL_STATE(3679)] = 398718,
  [SMALL_STATE(3680)] = 398836,
  [SMALL_STATE(3681)] = 398952,
  [SMALL_STATE(3682)] = 399070,
  [SMALL_STATE(3683)] = 399186,
  [SMALL_STATE(3684)] = 399302,
  [SMALL_STATE(3685)] = 399418,
  [SMALL_STATE(3686)] = 399534,
  [SMALL_STATE(3687)] = 399652,
  [SMALL_STATE(3688)] = 399768,
  [SMALL_STATE(3689)] = 399884,
  [SMALL_STATE(3690)] = 400002,
  [SMALL_STATE(3691)] = 400118,
  [SMALL_STATE(3692)] = 400234,
  [SMALL_STATE(3693)] = 400352,
  [SMALL_STATE(3694)] = 400468,
  [SMALL_STATE(3695)] = 400584,
  [SMALL_STATE(3696)] = 400700,
  [SMALL_STATE(3697)] = 400816,
  [SMALL_STATE(3698)] = 400932,
  [SMALL_STATE(3699)] = 401048,
  [SMALL_STATE(3700)] = 401164,
  [SMALL_STATE(3701)] = 401280,
  [SMALL_STATE(3702)] = 401396,
  [SMALL_STATE(3703)] = 401512,
  [SMALL_STATE(3704)] = 401628,
  [SMALL_STATE(3705)] = 401744,
  [SMALL_STATE(3706)] = 401857,
  [SMALL_STATE(3707)] = 401970,
  [SMALL_STATE(3708)] = 402083,
  [SMALL_STATE(3709)] = 402196,
  [SMALL_STATE(3710)] = 402309,
  [SMALL_STATE(3711)] = 402422,
  [SMALL_STATE(3712)] = 402535,
  [SMALL_STATE(3713)] = 402648,
  [SMALL_STATE(3714)] = 402761,
  [SMALL_STATE(3715)] = 402874,
  [SMALL_STATE(3716)] = 402987,
  [SMALL_STATE(3717)] = 403100,
  [SMALL_STATE(3718)] = 403213,
  [SMALL_STATE(3719)] = 403326,
  [SMALL_STATE(3720)] = 403439,
  [SMALL_STATE(3721)] = 403552,
  [SMALL_STATE(3722)] = 403665,
  [SMALL_STATE(3723)] = 403778,
  [SMALL_STATE(3724)] = 403839,
  [SMALL_STATE(3725)] = 403952,
  [SMALL_STATE(3726)] = 404065,
  [SMALL_STATE(3727)] = 404178,
  [SMALL_STATE(3728)] = 404291,
  [SMALL_STATE(3729)] = 404404,
  [SMALL_STATE(3730)] = 404517,
  [SMALL_STATE(3731)] = 404630,
  [SMALL_STATE(3732)] = 404743,
  [SMALL_STATE(3733)] = 404856,
  [SMALL_STATE(3734)] = 404969,
  [SMALL_STATE(3735)] = 405082,
  [SMALL_STATE(3736)] = 405195,
  [SMALL_STATE(3737)] = 405308,
  [SMALL_STATE(3738)] = 405421,
  [SMALL_STATE(3739)] = 405534,
  [SMALL_STATE(3740)] = 405647,
  [SMALL_STATE(3741)] = 405760,
  [SMALL_STATE(3742)] = 405873,
  [SMALL_STATE(3743)] = 405986,
  [SMALL_STATE(3744)] = 406099,
  [SMALL_STATE(3745)] = 406212,
  [SMALL_STATE(3746)] = 406325,
  [SMALL_STATE(3747)] = 406438,
  [SMALL_STATE(3748)] = 406551,
  [SMALL_STATE(3749)] = 406664,
  [SMALL_STATE(3750)] = 406777,
  [SMALL_STATE(3751)] = 406890,
  [SMALL_STATE(3752)] = 407003,
  [SMALL_STATE(3753)] = 407116,
  [SMALL_STATE(3754)] = 407229,
  [SMALL_STATE(3755)] = 407342,
  [SMALL_STATE(3756)] = 407435,
  [SMALL_STATE(3757)] = 407548,
  [SMALL_STATE(3758)] = 407661,
  [SMALL_STATE(3759)] = 407774,
  [SMALL_STATE(3760)] = 407887,
  [SMALL_STATE(3761)] = 408000,
  [SMALL_STATE(3762)] = 408113,
  [SMALL_STATE(3763)] = 408226,
  [SMALL_STATE(3764)] = 408339,
  [SMALL_STATE(3765)] = 408451,
  [SMALL_STATE(3766)] = 408561,
  [SMALL_STATE(3767)] = 408671,
  [SMALL_STATE(3768)] = 408783,
  [SMALL_STATE(3769)] = 408895,
  [SMALL_STATE(3770)] = 409007,
  [SMALL_STATE(3771)] = 409117,
  [SMALL_STATE(3772)] = 409229,
  [SMALL_STATE(3773)] = 409341,
  [SMALL_STATE(3774)] = 409453,
  [SMALL_STATE(3775)] = 409563,
  [SMALL_STATE(3776)] = 409675,
  [SMALL_STATE(3777)] = 409787,
  [SMALL_STATE(3778)] = 409897,
  [SMALL_STATE(3779)] = 410007,
  [SMALL_STATE(3780)] = 410117,
  [SMALL_STATE(3781)] = 410229,
  [SMALL_STATE(3782)] = 410341,
  [SMALL_STATE(3783)] = 410453,
  [SMALL_STATE(3784)] = 410565,
  [SMALL_STATE(3785)] = 410675,
  [SMALL_STATE(3786)] = 410787,
  [SMALL_STATE(3787)] = 410899,
  [SMALL_STATE(3788)] = 410991,
  [SMALL_STATE(3789)] = 411101,
  [SMALL_STATE(3790)] = 411211,
  [SMALL_STATE(3791)] = 411321,
  [SMALL_STATE(3792)] = 411431,
  [SMALL_STATE(3793)] = 411541,
  [SMALL_STATE(3794)] = 411653,
  [SMALL_STATE(3795)] = 411763,
  [SMALL_STATE(3796)] = 411875,
  [SMALL_STATE(3797)] = 411987,
  [SMALL_STATE(3798)] = 412099,
  [SMALL_STATE(3799)] = 412209,
  [SMALL_STATE(3800)] = 412319,
  [SMALL_STATE(3801)] = 412431,
  [SMALL_STATE(3802)] = 412543,
  [SMALL_STATE(3803)] = 412655,
  [SMALL_STATE(3804)] = 412767,
  [SMALL_STATE(3805)] = 412879,
  [SMALL_STATE(3806)] = 412989,
  [SMALL_STATE(3807)] = 413099,
  [SMALL_STATE(3808)] = 413211,
  [SMALL_STATE(3809)] = 413321,
  [SMALL_STATE(3810)] = 413431,
  [SMALL_STATE(3811)] = 413543,
  [SMALL_STATE(3812)] = 413655,
  [SMALL_STATE(3813)] = 413765,
  [SMALL_STATE(3814)] = 413877,
  [SMALL_STATE(3815)] = 413989,
  [SMALL_STATE(3816)] = 414099,
  [SMALL_STATE(3817)] = 414209,
  [SMALL_STATE(3818)] = 414321,
  [SMALL_STATE(3819)] = 414433,
  [SMALL_STATE(3820)] = 414543,
  [SMALL_STATE(3821)] = 414635,
  [SMALL_STATE(3822)] = 414745,
  [SMALL_STATE(3823)] = 414855,
  [SMALL_STATE(3824)] = 414967,
  [SMALL_STATE(3825)] = 415077,
  [SMALL_STATE(3826)] = 415189,
  [SMALL_STATE(3827)] = 415301,
  [SMALL_STATE(3828)] = 415411,
  [SMALL_STATE(3829)] = 415523,
  [SMALL_STATE(3830)] = 415635,
  [SMALL_STATE(3831)] = 415747,
  [SMALL_STATE(3832)] = 415857,
  [SMALL_STATE(3833)] = 415967,
  [SMALL_STATE(3834)] = 416077,
  [SMALL_STATE(3835)] = 416189,
  [SMALL_STATE(3836)] = 416299,
  [SMALL_STATE(3837)] = 416409,
  [SMALL_STATE(3838)] = 416521,
  [SMALL_STATE(3839)] = 416633,
  [SMALL_STATE(3840)] = 416743,
  [SMALL_STATE(3841)] = 416853,
  [SMALL_STATE(3842)] = 416963,
  [SMALL_STATE(3843)] = 417075,
  [SMALL_STATE(3844)] = 417185,
  [SMALL_STATE(3845)] = 417297,
  [SMALL_STATE(3846)] = 417407,
  [SMALL_STATE(3847)] = 417519,
  [SMALL_STATE(3848)] = 417631,
  [SMALL_STATE(3849)] = 417743,
  [SMALL_STATE(3850)] = 417855,
  [SMALL_STATE(3851)] = 417967,
  [SMALL_STATE(3852)] = 418059,
  [SMALL_STATE(3853)] = 418169,
  [SMALL_STATE(3854)] = 418261,
  [SMALL_STATE(3855)] = 418373,
  [SMALL_STATE(3856)] = 418485,
  [SMALL_STATE(3857)] = 418595,
  [SMALL_STATE(3858)] = 418707,
  [SMALL_STATE(3859)] = 418817,
  [SMALL_STATE(3860)] = 418929,
  [SMALL_STATE(3861)] = 419039,
  [SMALL_STATE(3862)] = 419149,
  [SMALL_STATE(3863)] = 419259,
  [SMALL_STATE(3864)] = 419369,
  [SMALL_STATE(3865)] = 419481,
  [SMALL_STATE(3866)] = 419591,
  [SMALL_STATE(3867)] = 419701,
  [SMALL_STATE(3868)] = 419811,
  [SMALL_STATE(3869)] = 419921,
  [SMALL_STATE(3870)] = 420031,
  [SMALL_STATE(3871)] = 420141,
  [SMALL_STATE(3872)] = 420253,
  [SMALL_STATE(3873)] = 420363,
  [SMALL_STATE(3874)] = 420473,
  [SMALL_STATE(3875)] = 420585,
  [SMALL_STATE(3876)] = 420697,
  [SMALL_STATE(3877)] = 420809,
  [SMALL_STATE(3878)] = 420919,
  [SMALL_STATE(3879)] = 421031,
  [SMALL_STATE(3880)] = 421141,
  [SMALL_STATE(3881)] = 421251,
  [SMALL_STATE(3882)] = 421361,
  [SMALL_STATE(3883)] = 421471,
  [SMALL_STATE(3884)] = 421562,
  [SMALL_STATE(3885)] = 421653,
  [SMALL_STATE(3886)] = 421744,
  [SMALL_STATE(3887)] = 421835,
  [SMALL_STATE(3888)] = 421944,
  [SMALL_STATE(3889)] = 422053,
  [SMALL_STATE(3890)] = 422144,
  [SMALL_STATE(3891)] = 422235,
  [SMALL_STATE(3892)] = 422344,
  [SMALL_STATE(3893)] = 422453,
  [SMALL_STATE(3894)] = 422544,
  [SMALL_STATE(3895)] = 422634,
  [SMALL_STATE(3896)] = 422724,
  [SMALL_STATE(3897)] = 422814,
  [SMALL_STATE(3898)] = 422904,
  [SMALL_STATE(3899)] = 422994,
  [SMALL_STATE(3900)] = 423084,
  [SMALL_STATE(3901)] = 423174,
  [SMALL_STATE(3902)] = 423264,
  [SMALL_STATE(3903)] = 423354,
  [SMALL_STATE(3904)] = 423443,
  [SMALL_STATE(3905)] = 423532,
  [SMALL_STATE(3906)] = 423621,
  [SMALL_STATE(3907)] = 423710,
  [SMALL_STATE(3908)] = 423799,
  [SMALL_STATE(3909)] = 423888,
  [SMALL_STATE(3910)] = 423977,
  [SMALL_STATE(3911)] = 424066,
  [SMALL_STATE(3912)] = 424155,
  [SMALL_STATE(3913)] = 424244,
  [SMALL_STATE(3914)] = 424333,
  [SMALL_STATE(3915)] = 424421,
  [SMALL_STATE(3916)] = 424509,
  [SMALL_STATE(3917)] = 424597,
  [SMALL_STATE(3918)] = 424685,
  [SMALL_STATE(3919)] = 424773,
  [SMALL_STATE(3920)] = 424861,
  [SMALL_STATE(3921)] = 424949,
  [SMALL_STATE(3922)] = 425037,
  [SMALL_STATE(3923)] = 425125,
  [SMALL_STATE(3924)] = 425213,
  [SMALL_STATE(3925)] = 425301,
  [SMALL_STATE(3926)] = 425389,
  [SMALL_STATE(3927)] = 425477,
  [SMALL_STATE(3928)] = 425565,
  [SMALL_STATE(3929)] = 425652,
  [SMALL_STATE(3930)] = 425739,
  [SMALL_STATE(3931)] = 425826,
  [SMALL_STATE(3932)] = 425913,
  [SMALL_STATE(3933)] = 426000,
  [SMALL_STATE(3934)] = 426087,
  [SMALL_STATE(3935)] = 426174,
  [SMALL_STATE(3936)] = 426261,
  [SMALL_STATE(3937)] = 426348,
  [SMALL_STATE(3938)] = 426435,
  [SMALL_STATE(3939)] = 426522,
  [SMALL_STATE(3940)] = 426609,
  [SMALL_STATE(3941)] = 426696,
  [SMALL_STATE(3942)] = 426783,
  [SMALL_STATE(3943)] = 426870,
  [SMALL_STATE(3944)] = 426957,
  [SMALL_STATE(3945)] = 427044,
  [SMALL_STATE(3946)] = 427131,
  [SMALL_STATE(3947)] = 427218,
  [SMALL_STATE(3948)] = 427305,
  [SMALL_STATE(3949)] = 427392,
  [SMALL_STATE(3950)] = 427479,
  [SMALL_STATE(3951)] = 427566,
  [SMALL_STATE(3952)] = 427653,
  [SMALL_STATE(3953)] = 427739,
  [SMALL_STATE(3954)] = 427825,
  [SMALL_STATE(3955)] = 427911,
  [SMALL_STATE(3956)] = 427997,
  [SMALL_STATE(3957)] = 428083,
  [SMALL_STATE(3958)] = 428169,
  [SMALL_STATE(3959)] = 428255,
  [SMALL_STATE(3960)] = 428341,
  [SMALL_STATE(3961)] = 428427,
  [SMALL_STATE(3962)] = 428513,
  [SMALL_STATE(3963)] = 428599,
  [SMALL_STATE(3964)] = 428685,
  [SMALL_STATE(3965)] = 428771,
  [SMALL_STATE(3966)] = 428857,
  [SMALL_STATE(3967)] = 428943,
  [SMALL_STATE(3968)] = 429029,
  [SMALL_STATE(3969)] = 429115,
  [SMALL_STATE(3970)] = 429201,
  [SMALL_STATE(3971)] = 429287,
  [SMALL_STATE(3972)] = 429373,
  [SMALL_STATE(3973)] = 429459,
  [SMALL_STATE(3974)] = 429545,
  [SMALL_STATE(3975)] = 429631,
  [SMALL_STATE(3976)] = 429716,
  [SMALL_STATE(3977)] = 429801,
  [SMALL_STATE(3978)] = 429886,
  [SMALL_STATE(3979)] = 429971,
  [SMALL_STATE(3980)] = 430056,
  [SMALL_STATE(3981)] = 430141,
  [SMALL_STATE(3982)] = 430226,
  [SMALL_STATE(3983)] = 430311,
  [SMALL_STATE(3984)] = 430396,
  [SMALL_STATE(3985)] = 430481,
  [SMALL_STATE(3986)] = 430566,
  [SMALL_STATE(3987)] = 430651,
  [SMALL_STATE(3988)] = 430736,
  [SMALL_STATE(3989)] = 430821,
  [SMALL_STATE(3990)] = 430906,
  [SMALL_STATE(3991)] = 430991,
  [SMALL_STATE(3992)] = 431076,
  [SMALL_STATE(3993)] = 431160,
  [SMALL_STATE(3994)] = 431250,
  [SMALL_STATE(3995)] = 431304,
  [SMALL_STATE(3996)] = 431388,
  [SMALL_STATE(3997)] = 431472,
  [SMALL_STATE(3998)] = 431556,
  [SMALL_STATE(3999)] = 431640,
  [SMALL_STATE(4000)] = 431724,
  [SMALL_STATE(4001)] = 431808,
  [SMALL_STATE(4002)] = 431892,
  [SMALL_STATE(4003)] = 431976,
  [SMALL_STATE(4004)] = 432068,
  [SMALL_STATE(4005)] = 432152,
  [SMALL_STATE(4006)] = 432236,
  [SMALL_STATE(4007)] = 432320,
  [SMALL_STATE(4008)] = 432404,
  [SMALL_STATE(4009)] = 432488,
  [SMALL_STATE(4010)] = 432539,
  [SMALL_STATE(4011)] = 432592,
  [SMALL_STATE(4012)] = 432681,
  [SMALL_STATE(4013)] = 432732,
  [SMALL_STATE(4014)] = 432821,
  [SMALL_STATE(4015)] = 432876,
  [SMALL_STATE(4016)] = 432927,
  [SMALL_STATE(4017)] = 432978,
  [SMALL_STATE(4018)] = 433069,
  [SMALL_STATE(4019)] = 433160,
  [SMALL_STATE(4020)] = 433211,
  [SMALL_STATE(4021)] = 433262,
  [SMALL_STATE(4022)] = 433351,
  [SMALL_STATE(4023)] = 433434,
  [SMALL_STATE(4024)] = 433517,
  [SMALL_STATE(4025)] = 433568,
  [SMALL_STATE(4026)] = 433619,
  [SMALL_STATE(4027)] = 433670,
  [SMALL_STATE(4028)] = 433723,
  [SMALL_STATE(4029)] = 433776,
  [SMALL_STATE(4030)] = 433865,
  [SMALL_STATE(4031)] = 433918,
  [SMALL_STATE(4032)] = 434001,
  [SMALL_STATE(4033)] = 434052,
  [SMALL_STATE(4034)] = 434103,
  [SMALL_STATE(4035)] = 434154,
  [SMALL_STATE(4036)] = 434245,
  [SMALL_STATE(4037)] = 434296,
  [SMALL_STATE(4038)] = 434347,
  [SMALL_STATE(4039)] = 434432,
  [SMALL_STATE(4040)] = 434515,
  [SMALL_STATE(4041)] = 434567,
  [SMALL_STATE(4042)] = 434617,
  [SMALL_STATE(4043)] = 434705,
  [SMALL_STATE(4044)] = 434755,
  [SMALL_STATE(4045)] = 434805,
  [SMALL_STATE(4046)] = 434855,
  [SMALL_STATE(4047)] = 434945,
  [SMALL_STATE(4048)] = 434999,
  [SMALL_STATE(4049)] = 435087,
  [SMALL_STATE(4050)] = 435137,
  [SMALL_STATE(4051)] = 435233,
  [SMALL_STATE(4052)] = 435321,
  [SMALL_STATE(4053)] = 435371,
  [SMALL_STATE(4054)] = 435421,
  [SMALL_STATE(4055)] = 435475,
  [SMALL_STATE(4056)] = 435525,
  [SMALL_STATE(4057)] = 435579,
  [SMALL_STATE(4058)] = 435675,
  [SMALL_STATE(4059)] = 435729,
  [SMALL_STATE(4060)] = 435811,
  [SMALL_STATE(4061)] = 435899,
  [SMALL_STATE(4062)] = 435949,
  [SMALL_STATE(4063)] = 435999,
  [SMALL_STATE(4064)] = 436049,
  [SMALL_STATE(4065)] = 436145,
  [SMALL_STATE(4066)] = 436235,
  [SMALL_STATE(4067)] = 436285,
  [SMALL_STATE(4068)] = 436381,
  [SMALL_STATE(4069)] = 436431,
  [SMALL_STATE(4070)] = 436481,
  [SMALL_STATE(4071)] = 436531,
  [SMALL_STATE(4072)] = 436583,
  [SMALL_STATE(4073)] = 436673,
  [SMALL_STATE(4074)] = 436723,
  [SMALL_STATE(4075)] = 436773,
  [SMALL_STATE(4076)] = 436825,
  [SMALL_STATE(4077)] = 436875,
  [SMALL_STATE(4078)] = 436965,
  [SMALL_STATE(4079)] = 437015,
  [SMALL_STATE(4080)] = 437065,
  [SMALL_STATE(4081)] = 437115,
  [SMALL_STATE(4082)] = 437165,
  [SMALL_STATE(4083)] = 437215,
  [SMALL_STATE(4084)] = 437265,
  [SMALL_STATE(4085)] = 437353,
  [SMALL_STATE(4086)] = 437403,
  [SMALL_STATE(4087)] = 437453,
  [SMALL_STATE(4088)] = 437505,
  [SMALL_STATE(4089)] = 437593,
  [SMALL_STATE(4090)] = 437643,
  [SMALL_STATE(4091)] = 437693,
  [SMALL_STATE(4092)] = 437743,
  [SMALL_STATE(4093)] = 437793,
  [SMALL_STATE(4094)] = 437875,
  [SMALL_STATE(4095)] = 437925,
  [SMALL_STATE(4096)] = 437975,
  [SMALL_STATE(4097)] = 438027,
  [SMALL_STATE(4098)] = 438077,
  [SMALL_STATE(4099)] = 438127,
  [SMALL_STATE(4100)] = 438177,
  [SMALL_STATE(4101)] = 438227,
  [SMALL_STATE(4102)] = 438279,
  [SMALL_STATE(4103)] = 438329,
  [SMALL_STATE(4104)] = 438379,
  [SMALL_STATE(4105)] = 438429,
  [SMALL_STATE(4106)] = 438479,
  [SMALL_STATE(4107)] = 438529,
  [SMALL_STATE(4108)] = 438579,
  [SMALL_STATE(4109)] = 438629,
  [SMALL_STATE(4110)] = 438679,
  [SMALL_STATE(4111)] = 438729,
  [SMALL_STATE(4112)] = 438779,
  [SMALL_STATE(4113)] = 438829,
  [SMALL_STATE(4114)] = 438879,
  [SMALL_STATE(4115)] = 438929,
  [SMALL_STATE(4116)] = 438979,
  [SMALL_STATE(4117)] = 439029,
  [SMALL_STATE(4118)] = 439079,
  [SMALL_STATE(4119)] = 439129,
  [SMALL_STATE(4120)] = 439179,
  [SMALL_STATE(4121)] = 439231,
  [SMALL_STATE(4122)] = 439319,
  [SMALL_STATE(4123)] = 439369,
  [SMALL_STATE(4124)] = 439419,
  [SMALL_STATE(4125)] = 439506,
  [SMALL_STATE(4126)] = 439555,
  [SMALL_STATE(4127)] = 439604,
  [SMALL_STATE(4128)] = 439653,
  [SMALL_STATE(4129)] = 439702,
  [SMALL_STATE(4130)] = 439751,
  [SMALL_STATE(4131)] = 439800,
  [SMALL_STATE(4132)] = 439849,
  [SMALL_STATE(4133)] = 439898,
  [SMALL_STATE(4134)] = 439947,
  [SMALL_STATE(4135)] = 439996,
  [SMALL_STATE(4136)] = 440045,
  [SMALL_STATE(4137)] = 440094,
  [SMALL_STATE(4138)] = 440143,
  [SMALL_STATE(4139)] = 440192,
  [SMALL_STATE(4140)] = 440241,
  [SMALL_STATE(4141)] = 440292,
  [SMALL_STATE(4142)] = 440341,
  [SMALL_STATE(4143)] = 440390,
  [SMALL_STATE(4144)] = 440439,
  [SMALL_STATE(4145)] = 440488,
  [SMALL_STATE(4146)] = 440537,
  [SMALL_STATE(4147)] = 440586,
  [SMALL_STATE(4148)] = 440637,
  [SMALL_STATE(4149)] = 440688,
  [SMALL_STATE(4150)] = 440775,
  [SMALL_STATE(4151)] = 440824,
  [SMALL_STATE(4152)] = 440873,
  [SMALL_STATE(4153)] = 440922,
  [SMALL_STATE(4154)] = 440971,
  [SMALL_STATE(4155)] = 441024,
  [SMALL_STATE(4156)] = 441073,
  [SMALL_STATE(4157)] = 441162,
  [SMALL_STATE(4158)] = 441251,
  [SMALL_STATE(4159)] = 441300,
  [SMALL_STATE(4160)] = 441351,
  [SMALL_STATE(4161)] = 441400,
  [SMALL_STATE(4162)] = 441451,
  [SMALL_STATE(4163)] = 441500,
  [SMALL_STATE(4164)] = 441549,
  [SMALL_STATE(4165)] = 441638,
  [SMALL_STATE(4166)] = 441687,
  [SMALL_STATE(4167)] = 441736,
  [SMALL_STATE(4168)] = 441785,
  [SMALL_STATE(4169)] = 441834,
  [SMALL_STATE(4170)] = 441883,
  [SMALL_STATE(4171)] = 441970,
  [SMALL_STATE(4172)] = 442019,
  [SMALL_STATE(4173)] = 442068,
  [SMALL_STATE(4174)] = 442117,
  [SMALL_STATE(4175)] = 442166,
  [SMALL_STATE(4176)] = 442215,
  [SMALL_STATE(4177)] = 442264,
  [SMALL_STATE(4178)] = 442313,
  [SMALL_STATE(4179)] = 442362,
  [SMALL_STATE(4180)] = 442443,
  [SMALL_STATE(4181)] = 442492,
  [SMALL_STATE(4182)] = 442545,
  [SMALL_STATE(4183)] = 442594,
  [SMALL_STATE(4184)] = 442643,
  [SMALL_STATE(4185)] = 442692,
  [SMALL_STATE(4186)] = 442741,
  [SMALL_STATE(4187)] = 442830,
  [SMALL_STATE(4188)] = 442917,
  [SMALL_STATE(4189)] = 442966,
  [SMALL_STATE(4190)] = 443019,
  [SMALL_STATE(4191)] = 443068,
  [SMALL_STATE(4192)] = 443117,
  [SMALL_STATE(4193)] = 443166,
  [SMALL_STATE(4194)] = 443215,
  [SMALL_STATE(4195)] = 443264,
  [SMALL_STATE(4196)] = 443313,
  [SMALL_STATE(4197)] = 443362,
  [SMALL_STATE(4198)] = 443411,
  [SMALL_STATE(4199)] = 443460,
  [SMALL_STATE(4200)] = 443509,
  [SMALL_STATE(4201)] = 443558,
  [SMALL_STATE(4202)] = 443607,
  [SMALL_STATE(4203)] = 443658,
  [SMALL_STATE(4204)] = 443707,
  [SMALL_STATE(4205)] = 443756,
  [SMALL_STATE(4206)] = 443805,
  [SMALL_STATE(4207)] = 443854,
  [SMALL_STATE(4208)] = 443903,
  [SMALL_STATE(4209)] = 443990,
  [SMALL_STATE(4210)] = 444039,
  [SMALL_STATE(4211)] = 444088,
  [SMALL_STATE(4212)] = 444175,
  [SMALL_STATE(4213)] = 444224,
  [SMALL_STATE(4214)] = 444273,
  [SMALL_STATE(4215)] = 444322,
  [SMALL_STATE(4216)] = 444373,
  [SMALL_STATE(4217)] = 444426,
  [SMALL_STATE(4218)] = 444475,
  [SMALL_STATE(4219)] = 444524,
  [SMALL_STATE(4220)] = 444573,
  [SMALL_STATE(4221)] = 444622,
  [SMALL_STATE(4222)] = 444671,
  [SMALL_STATE(4223)] = 444720,
  [SMALL_STATE(4224)] = 444771,
  [SMALL_STATE(4225)] = 444820,
  [SMALL_STATE(4226)] = 444869,
  [SMALL_STATE(4227)] = 444922,
  [SMALL_STATE(4228)] = 444975,
  [SMALL_STATE(4229)] = 445068,
  [SMALL_STATE(4230)] = 445117,
  [SMALL_STATE(4231)] = 445166,
  [SMALL_STATE(4232)] = 445215,
  [SMALL_STATE(4233)] = 445264,
  [SMALL_STATE(4234)] = 445313,
  [SMALL_STATE(4235)] = 445362,
  [SMALL_STATE(4236)] = 445411,
  [SMALL_STATE(4237)] = 445460,
  [SMALL_STATE(4238)] = 445509,
  [SMALL_STATE(4239)] = 445558,
  [SMALL_STATE(4240)] = 445607,
  [SMALL_STATE(4241)] = 445656,
  [SMALL_STATE(4242)] = 445705,
  [SMALL_STATE(4243)] = 445792,
  [SMALL_STATE(4244)] = 445845,
  [SMALL_STATE(4245)] = 445894,
  [SMALL_STATE(4246)] = 445987,
  [SMALL_STATE(4247)] = 446036,
  [SMALL_STATE(4248)] = 446129,
  [SMALL_STATE(4249)] = 446178,
  [SMALL_STATE(4250)] = 446229,
  [SMALL_STATE(4251)] = 446278,
  [SMALL_STATE(4252)] = 446365,
  [SMALL_STATE(4253)] = 446458,
  [SMALL_STATE(4254)] = 446507,
  [SMALL_STATE(4255)] = 446556,
  [SMALL_STATE(4256)] = 446608,
  [SMALL_STATE(4257)] = 446656,
  [SMALL_STATE(4258)] = 446704,
  [SMALL_STATE(4259)] = 446790,
  [SMALL_STATE(4260)] = 446838,
  [SMALL_STATE(4261)] = 446890,
  [SMALL_STATE(4262)] = 446942,
  [SMALL_STATE(4263)] = 447028,
  [SMALL_STATE(4264)] = 447076,
  [SMALL_STATE(4265)] = 447124,
  [SMALL_STATE(4266)] = 447172,
  [SMALL_STATE(4267)] = 447220,
  [SMALL_STATE(4268)] = 447268,
  [SMALL_STATE(4269)] = 447316,
  [SMALL_STATE(4270)] = 447364,
  [SMALL_STATE(4271)] = 447412,
  [SMALL_STATE(4272)] = 447464,
  [SMALL_STATE(4273)] = 447512,
  [SMALL_STATE(4274)] = 447560,
  [SMALL_STATE(4275)] = 447610,
  [SMALL_STATE(4276)] = 447660,
  [SMALL_STATE(4277)] = 447708,
  [SMALL_STATE(4278)] = 447794,
  [SMALL_STATE(4279)] = 447846,
  [SMALL_STATE(4280)] = 447894,
  [SMALL_STATE(4281)] = 447942,
  [SMALL_STATE(4282)] = 447990,
  [SMALL_STATE(4283)] = 448038,
  [SMALL_STATE(4284)] = 448088,
  [SMALL_STATE(4285)] = 448136,
  [SMALL_STATE(4286)] = 448184,
  [SMALL_STATE(4287)] = 448232,
  [SMALL_STATE(4288)] = 448280,
  [SMALL_STATE(4289)] = 448328,
  [SMALL_STATE(4290)] = 448376,
  [SMALL_STATE(4291)] = 448424,
  [SMALL_STATE(4292)] = 448472,
  [SMALL_STATE(4293)] = 448520,
  [SMALL_STATE(4294)] = 448568,
  [SMALL_STATE(4295)] = 448616,
  [SMALL_STATE(4296)] = 448664,
  [SMALL_STATE(4297)] = 448712,
  [SMALL_STATE(4298)] = 448798,
  [SMALL_STATE(4299)] = 448846,
  [SMALL_STATE(4300)] = 448894,
  [SMALL_STATE(4301)] = 448942,
  [SMALL_STATE(4302)] = 448990,
  [SMALL_STATE(4303)] = 449038,
  [SMALL_STATE(4304)] = 449086,
  [SMALL_STATE(4305)] = 449134,
  [SMALL_STATE(4306)] = 449182,
  [SMALL_STATE(4307)] = 449230,
  [SMALL_STATE(4308)] = 449278,
  [SMALL_STATE(4309)] = 449364,
  [SMALL_STATE(4310)] = 449412,
  [SMALL_STATE(4311)] = 449498,
  [SMALL_STATE(4312)] = 449546,
  [SMALL_STATE(4313)] = 449594,
  [SMALL_STATE(4314)] = 449642,
  [SMALL_STATE(4315)] = 449690,
  [SMALL_STATE(4316)] = 449776,
  [SMALL_STATE(4317)] = 449824,
  [SMALL_STATE(4318)] = 449872,
  [SMALL_STATE(4319)] = 449920,
  [SMALL_STATE(4320)] = 449968,
  [SMALL_STATE(4321)] = 450016,
  [SMALL_STATE(4322)] = 450064,
  [SMALL_STATE(4323)] = 450112,
  [SMALL_STATE(4324)] = 450160,
  [SMALL_STATE(4325)] = 450208,
  [SMALL_STATE(4326)] = 450258,
  [SMALL_STATE(4327)] = 450306,
  [SMALL_STATE(4328)] = 450354,
  [SMALL_STATE(4329)] = 450402,
  [SMALL_STATE(4330)] = 450450,
  [SMALL_STATE(4331)] = 450498,
  [SMALL_STATE(4332)] = 450546,
  [SMALL_STATE(4333)] = 450594,
  [SMALL_STATE(4334)] = 450642,
  [SMALL_STATE(4335)] = 450690,
  [SMALL_STATE(4336)] = 450738,
  [SMALL_STATE(4337)] = 450786,
  [SMALL_STATE(4338)] = 450834,
  [SMALL_STATE(4339)] = 450882,
  [SMALL_STATE(4340)] = 450930,
  [SMALL_STATE(4341)] = 450978,
  [SMALL_STATE(4342)] = 451026,
  [SMALL_STATE(4343)] = 451074,
  [SMALL_STATE(4344)] = 451122,
  [SMALL_STATE(4345)] = 451208,
  [SMALL_STATE(4346)] = 451256,
  [SMALL_STATE(4347)] = 451304,
  [SMALL_STATE(4348)] = 451352,
  [SMALL_STATE(4349)] = 451400,
  [SMALL_STATE(4350)] = 451448,
  [SMALL_STATE(4351)] = 451496,
  [SMALL_STATE(4352)] = 451544,
  [SMALL_STATE(4353)] = 451592,
  [SMALL_STATE(4354)] = 451640,
  [SMALL_STATE(4355)] = 451688,
  [SMALL_STATE(4356)] = 451774,
  [SMALL_STATE(4357)] = 451862,
  [SMALL_STATE(4358)] = 451910,
  [SMALL_STATE(4359)] = 451960,
  [SMALL_STATE(4360)] = 452008,
  [SMALL_STATE(4361)] = 452096,
  [SMALL_STATE(4362)] = 452144,
  [SMALL_STATE(4363)] = 452192,
  [SMALL_STATE(4364)] = 452242,
  [SMALL_STATE(4365)] = 452290,
  [SMALL_STATE(4366)] = 452342,
  [SMALL_STATE(4367)] = 452394,
  [SMALL_STATE(4368)] = 452442,
  [SMALL_STATE(4369)] = 452490,
  [SMALL_STATE(4370)] = 452538,
  [SMALL_STATE(4371)] = 452586,
  [SMALL_STATE(4372)] = 452638,
  [SMALL_STATE(4373)] = 452686,
  [SMALL_STATE(4374)] = 452734,
  [SMALL_STATE(4375)] = 452782,
  [SMALL_STATE(4376)] = 452832,
  [SMALL_STATE(4377)] = 452880,
  [SMALL_STATE(4378)] = 452928,
  [SMALL_STATE(4379)] = 452976,
  [SMALL_STATE(4380)] = 453024,
  [SMALL_STATE(4381)] = 453110,
  [SMALL_STATE(4382)] = 453158,
  [SMALL_STATE(4383)] = 453206,
  [SMALL_STATE(4384)] = 453254,
  [SMALL_STATE(4385)] = 453302,
  [SMALL_STATE(4386)] = 453350,
  [SMALL_STATE(4387)] = 453438,
  [SMALL_STATE(4388)] = 453486,
  [SMALL_STATE(4389)] = 453536,
  [SMALL_STATE(4390)] = 453584,
  [SMALL_STATE(4391)] = 453632,
  [SMALL_STATE(4392)] = 453680,
  [SMALL_STATE(4393)] = 453728,
  [SMALL_STATE(4394)] = 453776,
  [SMALL_STATE(4395)] = 453824,
  [SMALL_STATE(4396)] = 453910,
  [SMALL_STATE(4397)] = 453958,
  [SMALL_STATE(4398)] = 454044,
  [SMALL_STATE(4399)] = 454092,
  [SMALL_STATE(4400)] = 454140,
  [SMALL_STATE(4401)] = 454188,
  [SMALL_STATE(4402)] = 454236,
  [SMALL_STATE(4403)] = 454284,
  [SMALL_STATE(4404)] = 454332,
  [SMALL_STATE(4405)] = 454380,
  [SMALL_STATE(4406)] = 454428,
  [SMALL_STATE(4407)] = 454478,
  [SMALL_STATE(4408)] = 454526,
  [SMALL_STATE(4409)] = 454578,
  [SMALL_STATE(4410)] = 454628,
  [SMALL_STATE(4411)] = 454716,
  [SMALL_STATE(4412)] = 454802,
  [SMALL_STATE(4413)] = 454850,
  [SMALL_STATE(4414)] = 454898,
  [SMALL_STATE(4415)] = 454946,
  [SMALL_STATE(4416)] = 454994,
  [SMALL_STATE(4417)] = 455044,
  [SMALL_STATE(4418)] = 455092,
  [SMALL_STATE(4419)] = 455139,
  [SMALL_STATE(4420)] = 455186,
  [SMALL_STATE(4421)] = 455271,
  [SMALL_STATE(4422)] = 455322,
  [SMALL_STATE(4423)] = 455405,
  [SMALL_STATE(4424)] = 455492,
  [SMALL_STATE(4425)] = 455577,
  [SMALL_STATE(4426)] = 455624,
  [SMALL_STATE(4427)] = 455709,
  [SMALL_STATE(4428)] = 455756,
  [SMALL_STATE(4429)] = 455803,
  [SMALL_STATE(4430)] = 455890,
  [SMALL_STATE(4431)] = 455937,
  [SMALL_STATE(4432)] = 455986,
  [SMALL_STATE(4433)] = 456035,
  [SMALL_STATE(4434)] = 456122,
  [SMALL_STATE(4435)] = 456169,
  [SMALL_STATE(4436)] = 456220,
  [SMALL_STATE(4437)] = 456267,
  [SMALL_STATE(4438)] = 456314,
  [SMALL_STATE(4439)] = 456399,
  [SMALL_STATE(4440)] = 456448,
  [SMALL_STATE(4441)] = 456495,
  [SMALL_STATE(4442)] = 456542,
  [SMALL_STATE(4443)] = 456589,
  [SMALL_STATE(4444)] = 456636,
  [SMALL_STATE(4445)] = 456683,
  [SMALL_STATE(4446)] = 456730,
  [SMALL_STATE(4447)] = 456777,
  [SMALL_STATE(4448)] = 456824,
  [SMALL_STATE(4449)] = 456871,
  [SMALL_STATE(4450)] = 456918,
  [SMALL_STATE(4451)] = 456965,
  [SMALL_STATE(4452)] = 457012,
  [SMALL_STATE(4453)] = 457059,
  [SMALL_STATE(4454)] = 457106,
  [SMALL_STATE(4455)] = 457153,
  [SMALL_STATE(4456)] = 457200,
  [SMALL_STATE(4457)] = 457247,
  [SMALL_STATE(4458)] = 457294,
  [SMALL_STATE(4459)] = 457341,
  [SMALL_STATE(4460)] = 457388,
  [SMALL_STATE(4461)] = 457473,
  [SMALL_STATE(4462)] = 457520,
  [SMALL_STATE(4463)] = 457567,
  [SMALL_STATE(4464)] = 457614,
  [SMALL_STATE(4465)] = 457661,
  [SMALL_STATE(4466)] = 457746,
  [SMALL_STATE(4467)] = 457833,
  [SMALL_STATE(4468)] = 457880,
  [SMALL_STATE(4469)] = 457927,
  [SMALL_STATE(4470)] = 457974,
  [SMALL_STATE(4471)] = 458023,
  [SMALL_STATE(4472)] = 458070,
  [SMALL_STATE(4473)] = 458155,
  [SMALL_STATE(4474)] = 458202,
  [SMALL_STATE(4475)] = 458251,
  [SMALL_STATE(4476)] = 458298,
  [SMALL_STATE(4477)] = 458345,
  [SMALL_STATE(4478)] = 458392,
  [SMALL_STATE(4479)] = 458439,
  [SMALL_STATE(4480)] = 458486,
  [SMALL_STATE(4481)] = 458533,
  [SMALL_STATE(4482)] = 458580,
  [SMALL_STATE(4483)] = 458627,
  [SMALL_STATE(4484)] = 458714,
  [SMALL_STATE(4485)] = 458761,
  [SMALL_STATE(4486)] = 458810,
  [SMALL_STATE(4487)] = 458857,
  [SMALL_STATE(4488)] = 458904,
  [SMALL_STATE(4489)] = 458955,
  [SMALL_STATE(4490)] = 459002,
  [SMALL_STATE(4491)] = 459049,
  [SMALL_STATE(4492)] = 459096,
  [SMALL_STATE(4493)] = 459143,
  [SMALL_STATE(4494)] = 459190,
  [SMALL_STATE(4495)] = 459237,
  [SMALL_STATE(4496)] = 459284,
  [SMALL_STATE(4497)] = 459331,
  [SMALL_STATE(4498)] = 459378,
  [SMALL_STATE(4499)] = 459463,
  [SMALL_STATE(4500)] = 459512,
  [SMALL_STATE(4501)] = 459559,
  [SMALL_STATE(4502)] = 459606,
  [SMALL_STATE(4503)] = 459653,
  [SMALL_STATE(4504)] = 459700,
  [SMALL_STATE(4505)] = 459747,
  [SMALL_STATE(4506)] = 459794,
  [SMALL_STATE(4507)] = 459845,
  [SMALL_STATE(4508)] = 459892,
  [SMALL_STATE(4509)] = 459939,
  [SMALL_STATE(4510)] = 459986,
  [SMALL_STATE(4511)] = 460033,
  [SMALL_STATE(4512)] = 460080,
  [SMALL_STATE(4513)] = 460127,
  [SMALL_STATE(4514)] = 460174,
  [SMALL_STATE(4515)] = 460221,
  [SMALL_STATE(4516)] = 460268,
  [SMALL_STATE(4517)] = 460315,
  [SMALL_STATE(4518)] = 460362,
  [SMALL_STATE(4519)] = 460413,
  [SMALL_STATE(4520)] = 460498,
  [SMALL_STATE(4521)] = 460583,
  [SMALL_STATE(4522)] = 460630,
  [SMALL_STATE(4523)] = 460677,
  [SMALL_STATE(4524)] = 460724,
  [SMALL_STATE(4525)] = 460771,
  [SMALL_STATE(4526)] = 460856,
  [SMALL_STATE(4527)] = 460903,
  [SMALL_STATE(4528)] = 460950,
  [SMALL_STATE(4529)] = 461035,
  [SMALL_STATE(4530)] = 461086,
  [SMALL_STATE(4531)] = 461135,
  [SMALL_STATE(4532)] = 461182,
  [SMALL_STATE(4533)] = 461233,
  [SMALL_STATE(4534)] = 461280,
  [SMALL_STATE(4535)] = 461327,
  [SMALL_STATE(4536)] = 461374,
  [SMALL_STATE(4537)] = 461421,
  [SMALL_STATE(4538)] = 461468,
  [SMALL_STATE(4539)] = 461515,
  [SMALL_STATE(4540)] = 461562,
  [SMALL_STATE(4541)] = 461609,
  [SMALL_STATE(4542)] = 461656,
  [SMALL_STATE(4543)] = 461703,
  [SMALL_STATE(4544)] = 461750,
  [SMALL_STATE(4545)] = 461797,
  [SMALL_STATE(4546)] = 461844,
  [SMALL_STATE(4547)] = 461891,
  [SMALL_STATE(4548)] = 461938,
  [SMALL_STATE(4549)] = 461985,
  [SMALL_STATE(4550)] = 462032,
  [SMALL_STATE(4551)] = 462079,
  [SMALL_STATE(4552)] = 462126,
  [SMALL_STATE(4553)] = 462173,
  [SMALL_STATE(4554)] = 462220,
  [SMALL_STATE(4555)] = 462305,
  [SMALL_STATE(4556)] = 462390,
  [SMALL_STATE(4557)] = 462437,
  [SMALL_STATE(4558)] = 462524,
  [SMALL_STATE(4559)] = 462571,
  [SMALL_STATE(4560)] = 462618,
  [SMALL_STATE(4561)] = 462667,
  [SMALL_STATE(4562)] = 462714,
  [SMALL_STATE(4563)] = 462763,
  [SMALL_STATE(4564)] = 462812,
  [SMALL_STATE(4565)] = 462859,
  [SMALL_STATE(4566)] = 462906,
  [SMALL_STATE(4567)] = 462991,
  [SMALL_STATE(4568)] = 463038,
  [SMALL_STATE(4569)] = 463123,
  [SMALL_STATE(4570)] = 463170,
  [SMALL_STATE(4571)] = 463255,
  [SMALL_STATE(4572)] = 463302,
  [SMALL_STATE(4573)] = 463387,
  [SMALL_STATE(4574)] = 463472,
  [SMALL_STATE(4575)] = 463559,
  [SMALL_STATE(4576)] = 463606,
  [SMALL_STATE(4577)] = 463653,
  [SMALL_STATE(4578)] = 463700,
  [SMALL_STATE(4579)] = 463747,
  [SMALL_STATE(4580)] = 463794,
  [SMALL_STATE(4581)] = 463841,
  [SMALL_STATE(4582)] = 463888,
  [SMALL_STATE(4583)] = 463935,
  [SMALL_STATE(4584)] = 463982,
  [SMALL_STATE(4585)] = 464029,
  [SMALL_STATE(4586)] = 464076,
  [SMALL_STATE(4587)] = 464123,
  [SMALL_STATE(4588)] = 464174,
  [SMALL_STATE(4589)] = 464221,
  [SMALL_STATE(4590)] = 464268,
  [SMALL_STATE(4591)] = 464315,
  [SMALL_STATE(4592)] = 464362,
  [SMALL_STATE(4593)] = 464409,
  [SMALL_STATE(4594)] = 464456,
  [SMALL_STATE(4595)] = 464503,
  [SMALL_STATE(4596)] = 464550,
  [SMALL_STATE(4597)] = 464635,
  [SMALL_STATE(4598)] = 464682,
  [SMALL_STATE(4599)] = 464729,
  [SMALL_STATE(4600)] = 464776,
  [SMALL_STATE(4601)] = 464827,
  [SMALL_STATE(4602)] = 464874,
  [SMALL_STATE(4603)] = 464921,
  [SMALL_STATE(4604)] = 464972,
  [SMALL_STATE(4605)] = 465019,
  [SMALL_STATE(4606)] = 465066,
  [SMALL_STATE(4607)] = 465113,
  [SMALL_STATE(4608)] = 465162,
  [SMALL_STATE(4609)] = 465209,
  [SMALL_STATE(4610)] = 465256,
  [SMALL_STATE(4611)] = 465303,
  [SMALL_STATE(4612)] = 465352,
  [SMALL_STATE(4613)] = 465401,
  [SMALL_STATE(4614)] = 465448,
  [SMALL_STATE(4615)] = 465495,
  [SMALL_STATE(4616)] = 465542,
  [SMALL_STATE(4617)] = 465589,
  [SMALL_STATE(4618)] = 465636,
  [SMALL_STATE(4619)] = 465683,
  [SMALL_STATE(4620)] = 465730,
  [SMALL_STATE(4621)] = 465779,
  [SMALL_STATE(4622)] = 465826,
  [SMALL_STATE(4623)] = 465873,
  [SMALL_STATE(4624)] = 465920,
  [SMALL_STATE(4625)] = 465967,
  [SMALL_STATE(4626)] = 466053,
  [SMALL_STATE(4627)] = 466099,
  [SMALL_STATE(4628)] = 466145,
  [SMALL_STATE(4629)] = 466191,
  [SMALL_STATE(4630)] = 466237,
  [SMALL_STATE(4631)] = 466285,
  [SMALL_STATE(4632)] = 466331,
  [SMALL_STATE(4633)] = 466377,
  [SMALL_STATE(4634)] = 466423,
  [SMALL_STATE(4635)] = 466469,
  [SMALL_STATE(4636)] = 466515,
  [SMALL_STATE(4637)] = 466561,
  [SMALL_STATE(4638)] = 466607,
  [SMALL_STATE(4639)] = 466653,
  [SMALL_STATE(4640)] = 466699,
  [SMALL_STATE(4641)] = 466745,
  [SMALL_STATE(4642)] = 466791,
  [SMALL_STATE(4643)] = 466837,
  [SMALL_STATE(4644)] = 466883,
  [SMALL_STATE(4645)] = 466967,
  [SMALL_STATE(4646)] = 467015,
  [SMALL_STATE(4647)] = 467099,
  [SMALL_STATE(4648)] = 467145,
  [SMALL_STATE(4649)] = 467229,
  [SMALL_STATE(4650)] = 467275,
  [SMALL_STATE(4651)] = 467321,
  [SMALL_STATE(4652)] = 467367,
  [SMALL_STATE(4653)] = 467413,
  [SMALL_STATE(4654)] = 467459,
  [SMALL_STATE(4655)] = 467505,
  [SMALL_STATE(4656)] = 467551,
  [SMALL_STATE(4657)] = 467597,
  [SMALL_STATE(4658)] = 467643,
  [SMALL_STATE(4659)] = 467689,
  [SMALL_STATE(4660)] = 467735,
  [SMALL_STATE(4661)] = 467781,
  [SMALL_STATE(4662)] = 467827,
  [SMALL_STATE(4663)] = 467873,
  [SMALL_STATE(4664)] = 467921,
  [SMALL_STATE(4665)] = 467969,
  [SMALL_STATE(4666)] = 468015,
  [SMALL_STATE(4667)] = 468061,
  [SMALL_STATE(4668)] = 468107,
  [SMALL_STATE(4669)] = 468153,
  [SMALL_STATE(4670)] = 468199,
  [SMALL_STATE(4671)] = 468245,
  [SMALL_STATE(4672)] = 468291,
  [SMALL_STATE(4673)] = 468337,
  [SMALL_STATE(4674)] = 468383,
  [SMALL_STATE(4675)] = 468429,
  [SMALL_STATE(4676)] = 468475,
  [SMALL_STATE(4677)] = 468559,
  [SMALL_STATE(4678)] = 468645,
  [SMALL_STATE(4679)] = 468693,
  [SMALL_STATE(4680)] = 468739,
  [SMALL_STATE(4681)] = 468821,
  [SMALL_STATE(4682)] = 468867,
  [SMALL_STATE(4683)] = 468913,
  [SMALL_STATE(4684)] = 468961,
  [SMALL_STATE(4685)] = 469009,
  [SMALL_STATE(4686)] = 469055,
  [SMALL_STATE(4687)] = 469101,
  [SMALL_STATE(4688)] = 469147,
  [SMALL_STATE(4689)] = 469231,
  [SMALL_STATE(4690)] = 469277,
  [SMALL_STATE(4691)] = 469323,
  [SMALL_STATE(4692)] = 469369,
  [SMALL_STATE(4693)] = 469415,
  [SMALL_STATE(4694)] = 469461,
  [SMALL_STATE(4695)] = 469507,
  [SMALL_STATE(4696)] = 469553,
  [SMALL_STATE(4697)] = 469599,
  [SMALL_STATE(4698)] = 469645,
  [SMALL_STATE(4699)] = 469691,
  [SMALL_STATE(4700)] = 469737,
  [SMALL_STATE(4701)] = 469785,
  [SMALL_STATE(4702)] = 469833,
  [SMALL_STATE(4703)] = 469879,
  [SMALL_STATE(4704)] = 469925,
  [SMALL_STATE(4705)] = 469971,
  [SMALL_STATE(4706)] = 470055,
  [SMALL_STATE(4707)] = 470101,
  [SMALL_STATE(4708)] = 470147,
  [SMALL_STATE(4709)] = 470193,
  [SMALL_STATE(4710)] = 470241,
  [SMALL_STATE(4711)] = 470287,
  [SMALL_STATE(4712)] = 470333,
  [SMALL_STATE(4713)] = 470381,
  [SMALL_STATE(4714)] = 470467,
  [SMALL_STATE(4715)] = 470513,
  [SMALL_STATE(4716)] = 470559,
  [SMALL_STATE(4717)] = 470605,
  [SMALL_STATE(4718)] = 470651,
  [SMALL_STATE(4719)] = 470701,
  [SMALL_STATE(4720)] = 470747,
  [SMALL_STATE(4721)] = 470793,
  [SMALL_STATE(4722)] = 470839,
  [SMALL_STATE(4723)] = 470885,
  [SMALL_STATE(4724)] = 470931,
  [SMALL_STATE(4725)] = 470977,
  [SMALL_STATE(4726)] = 471023,
  [SMALL_STATE(4727)] = 471069,
  [SMALL_STATE(4728)] = 471115,
  [SMALL_STATE(4729)] = 471161,
  [SMALL_STATE(4730)] = 471207,
  [SMALL_STATE(4731)] = 471253,
  [SMALL_STATE(4732)] = 471299,
  [SMALL_STATE(4733)] = 471345,
  [SMALL_STATE(4734)] = 471391,
  [SMALL_STATE(4735)] = 471439,
  [SMALL_STATE(4736)] = 471485,
  [SMALL_STATE(4737)] = 471569,
  [SMALL_STATE(4738)] = 471615,
  [SMALL_STATE(4739)] = 471701,
  [SMALL_STATE(4740)] = 471747,
  [SMALL_STATE(4741)] = 471831,
  [SMALL_STATE(4742)] = 471877,
  [SMALL_STATE(4743)] = 471923,
  [SMALL_STATE(4744)] = 471971,
  [SMALL_STATE(4745)] = 472017,
  [SMALL_STATE(4746)] = 472101,
  [SMALL_STATE(4747)] = 472147,
  [SMALL_STATE(4748)] = 472193,
  [SMALL_STATE(4749)] = 472239,
  [SMALL_STATE(4750)] = 472285,
  [SMALL_STATE(4751)] = 472331,
  [SMALL_STATE(4752)] = 472377,
  [SMALL_STATE(4753)] = 472423,
  [SMALL_STATE(4754)] = 472469,
  [SMALL_STATE(4755)] = 472517,
  [SMALL_STATE(4756)] = 472563,
  [SMALL_STATE(4757)] = 472647,
  [SMALL_STATE(4758)] = 472693,
  [SMALL_STATE(4759)] = 472739,
  [SMALL_STATE(4760)] = 472823,
  [SMALL_STATE(4761)] = 472869,
  [SMALL_STATE(4762)] = 472915,
  [SMALL_STATE(4763)] = 472961,
  [SMALL_STATE(4764)] = 473007,
  [SMALL_STATE(4765)] = 473093,
  [SMALL_STATE(4766)] = 473139,
  [SMALL_STATE(4767)] = 473185,
  [SMALL_STATE(4768)] = 473231,
  [SMALL_STATE(4769)] = 473279,
  [SMALL_STATE(4770)] = 473329,
  [SMALL_STATE(4771)] = 473375,
  [SMALL_STATE(4772)] = 473421,
  [SMALL_STATE(4773)] = 473503,
  [SMALL_STATE(4774)] = 473553,
  [SMALL_STATE(4775)] = 473599,
  [SMALL_STATE(4776)] = 473649,
  [SMALL_STATE(4777)] = 473735,
  [SMALL_STATE(4778)] = 473819,
  [SMALL_STATE(4779)] = 473903,
  [SMALL_STATE(4780)] = 473987,
  [SMALL_STATE(4781)] = 474037,
  [SMALL_STATE(4782)] = 474123,
  [SMALL_STATE(4783)] = 474207,
  [SMALL_STATE(4784)] = 474293,
  [SMALL_STATE(4785)] = 474339,
  [SMALL_STATE(4786)] = 474385,
  [SMALL_STATE(4787)] = 474435,
  [SMALL_STATE(4788)] = 474481,
  [SMALL_STATE(4789)] = 474527,
  [SMALL_STATE(4790)] = 474575,
  [SMALL_STATE(4791)] = 474621,
  [SMALL_STATE(4792)] = 474669,
  [SMALL_STATE(4793)] = 474715,
  [SMALL_STATE(4794)] = 474761,
  [SMALL_STATE(4795)] = 474807,
  [SMALL_STATE(4796)] = 474853,
  [SMALL_STATE(4797)] = 474939,
  [SMALL_STATE(4798)] = 474985,
  [SMALL_STATE(4799)] = 475071,
  [SMALL_STATE(4800)] = 475117,
  [SMALL_STATE(4801)] = 475163,
  [SMALL_STATE(4802)] = 475209,
  [SMALL_STATE(4803)] = 475255,
  [SMALL_STATE(4804)] = 475301,
  [SMALL_STATE(4805)] = 475347,
  [SMALL_STATE(4806)] = 475393,
  [SMALL_STATE(4807)] = 475439,
  [SMALL_STATE(4808)] = 475485,
  [SMALL_STATE(4809)] = 475531,
  [SMALL_STATE(4810)] = 475577,
  [SMALL_STATE(4811)] = 475623,
  [SMALL_STATE(4812)] = 475669,
  [SMALL_STATE(4813)] = 475715,
  [SMALL_STATE(4814)] = 475799,
  [SMALL_STATE(4815)] = 475845,
  [SMALL_STATE(4816)] = 475893,
  [SMALL_STATE(4817)] = 475939,
  [SMALL_STATE(4818)] = 475987,
  [SMALL_STATE(4819)] = 476071,
  [SMALL_STATE(4820)] = 476117,
  [SMALL_STATE(4821)] = 476163,
  [SMALL_STATE(4822)] = 476209,
  [SMALL_STATE(4823)] = 476257,
  [SMALL_STATE(4824)] = 476305,
  [SMALL_STATE(4825)] = 476351,
  [SMALL_STATE(4826)] = 476433,
  [SMALL_STATE(4827)] = 476479,
  [SMALL_STATE(4828)] = 476525,
  [SMALL_STATE(4829)] = 476571,
  [SMALL_STATE(4830)] = 476619,
  [SMALL_STATE(4831)] = 476665,
  [SMALL_STATE(4832)] = 476711,
  [SMALL_STATE(4833)] = 476757,
  [SMALL_STATE(4834)] = 476803,
  [SMALL_STATE(4835)] = 476849,
  [SMALL_STATE(4836)] = 476897,
  [SMALL_STATE(4837)] = 476945,
  [SMALL_STATE(4838)] = 476991,
  [SMALL_STATE(4839)] = 477037,
  [SMALL_STATE(4840)] = 477087,
  [SMALL_STATE(4841)] = 477133,
  [SMALL_STATE(4842)] = 477219,
  [SMALL_STATE(4843)] = 477265,
  [SMALL_STATE(4844)] = 477311,
  [SMALL_STATE(4845)] = 477357,
  [SMALL_STATE(4846)] = 477441,
  [SMALL_STATE(4847)] = 477487,
  [SMALL_STATE(4848)] = 477533,
  [SMALL_STATE(4849)] = 477579,
  [SMALL_STATE(4850)] = 477629,
  [SMALL_STATE(4851)] = 477675,
  [SMALL_STATE(4852)] = 477721,
  [SMALL_STATE(4853)] = 477767,
  [SMALL_STATE(4854)] = 477813,
  [SMALL_STATE(4855)] = 477859,
  [SMALL_STATE(4856)] = 477905,
  [SMALL_STATE(4857)] = 477951,
  [SMALL_STATE(4858)] = 477997,
  [SMALL_STATE(4859)] = 478043,
  [SMALL_STATE(4860)] = 478089,
  [SMALL_STATE(4861)] = 478135,
  [SMALL_STATE(4862)] = 478181,
  [SMALL_STATE(4863)] = 478227,
  [SMALL_STATE(4864)] = 478273,
  [SMALL_STATE(4865)] = 478319,
  [SMALL_STATE(4866)] = 478401,
  [SMALL_STATE(4867)] = 478447,
  [SMALL_STATE(4868)] = 478493,
  [SMALL_STATE(4869)] = 478539,
  [SMALL_STATE(4870)] = 478585,
  [SMALL_STATE(4871)] = 478631,
  [SMALL_STATE(4872)] = 478677,
  [SMALL_STATE(4873)] = 478723,
  [SMALL_STATE(4874)] = 478809,
  [SMALL_STATE(4875)] = 478855,
  [SMALL_STATE(4876)] = 478903,
  [SMALL_STATE(4877)] = 478989,
  [SMALL_STATE(4878)] = 479035,
  [SMALL_STATE(4879)] = 479119,
  [SMALL_STATE(4880)] = 479201,
  [SMALL_STATE(4881)] = 479247,
  [SMALL_STATE(4882)] = 479293,
  [SMALL_STATE(4883)] = 479339,
  [SMALL_STATE(4884)] = 479385,
  [SMALL_STATE(4885)] = 479431,
  [SMALL_STATE(4886)] = 479477,
  [SMALL_STATE(4887)] = 479523,
  [SMALL_STATE(4888)] = 479569,
  [SMALL_STATE(4889)] = 479615,
  [SMALL_STATE(4890)] = 479661,
  [SMALL_STATE(4891)] = 479707,
  [SMALL_STATE(4892)] = 479755,
  [SMALL_STATE(4893)] = 479801,
  [SMALL_STATE(4894)] = 479883,
  [SMALL_STATE(4895)] = 479929,
  [SMALL_STATE(4896)] = 479979,
  [SMALL_STATE(4897)] = 480025,
  [SMALL_STATE(4898)] = 480071,
  [SMALL_STATE(4899)] = 480117,
  [SMALL_STATE(4900)] = 480163,
  [SMALL_STATE(4901)] = 480247,
  [SMALL_STATE(4902)] = 480293,
  [SMALL_STATE(4903)] = 480339,
  [SMALL_STATE(4904)] = 480385,
  [SMALL_STATE(4905)] = 480469,
  [SMALL_STATE(4906)] = 480515,
  [SMALL_STATE(4907)] = 480561,
  [SMALL_STATE(4908)] = 480607,
  [SMALL_STATE(4909)] = 480657,
  [SMALL_STATE(4910)] = 480741,
  [SMALL_STATE(4911)] = 480787,
  [SMALL_STATE(4912)] = 480835,
  [SMALL_STATE(4913)] = 480919,
  [SMALL_STATE(4914)] = 480965,
  [SMALL_STATE(4915)] = 481013,
  [SMALL_STATE(4916)] = 481061,
  [SMALL_STATE(4917)] = 481109,
  [SMALL_STATE(4918)] = 481193,
  [SMALL_STATE(4919)] = 481238,
  [SMALL_STATE(4920)] = 481321,
  [SMALL_STATE(4921)] = 481366,
  [SMALL_STATE(4922)] = 481411,
  [SMALL_STATE(4923)] = 481458,
  [SMALL_STATE(4924)] = 481503,
  [SMALL_STATE(4925)] = 481552,
  [SMALL_STATE(4926)] = 481597,
  [SMALL_STATE(4927)] = 481642,
  [SMALL_STATE(4928)] = 481687,
  [SMALL_STATE(4929)] = 481732,
  [SMALL_STATE(4930)] = 481777,
  [SMALL_STATE(4931)] = 481822,
  [SMALL_STATE(4932)] = 481867,
  [SMALL_STATE(4933)] = 481948,
  [SMALL_STATE(4934)] = 481993,
  [SMALL_STATE(4935)] = 482038,
  [SMALL_STATE(4936)] = 482083,
  [SMALL_STATE(4937)] = 482128,
  [SMALL_STATE(4938)] = 482173,
  [SMALL_STATE(4939)] = 482218,
  [SMALL_STATE(4940)] = 482263,
  [SMALL_STATE(4941)] = 482308,
  [SMALL_STATE(4942)] = 482353,
  [SMALL_STATE(4943)] = 482436,
  [SMALL_STATE(4944)] = 482519,
  [SMALL_STATE(4945)] = 482564,
  [SMALL_STATE(4946)] = 482611,
  [SMALL_STATE(4947)] = 482656,
  [SMALL_STATE(4948)] = 482701,
  [SMALL_STATE(4949)] = 482746,
  [SMALL_STATE(4950)] = 482791,
  [SMALL_STATE(4951)] = 482836,
  [SMALL_STATE(4952)] = 482881,
  [SMALL_STATE(4953)] = 482926,
  [SMALL_STATE(4954)] = 482971,
  [SMALL_STATE(4955)] = 483016,
  [SMALL_STATE(4956)] = 483061,
  [SMALL_STATE(4957)] = 483144,
  [SMALL_STATE(4958)] = 483189,
  [SMALL_STATE(4959)] = 483272,
  [SMALL_STATE(4960)] = 483317,
  [SMALL_STATE(4961)] = 483362,
  [SMALL_STATE(4962)] = 483407,
  [SMALL_STATE(4963)] = 483490,
  [SMALL_STATE(4964)] = 483535,
  [SMALL_STATE(4965)] = 483620,
  [SMALL_STATE(4966)] = 483665,
  [SMALL_STATE(4967)] = 483710,
  [SMALL_STATE(4968)] = 483755,
  [SMALL_STATE(4969)] = 483802,
  [SMALL_STATE(4970)] = 483885,
  [SMALL_STATE(4971)] = 483930,
  [SMALL_STATE(4972)] = 484013,
  [SMALL_STATE(4973)] = 484060,
  [SMALL_STATE(4974)] = 484105,
  [SMALL_STATE(4975)] = 484150,
  [SMALL_STATE(4976)] = 484233,
  [SMALL_STATE(4977)] = 484278,
  [SMALL_STATE(4978)] = 484323,
  [SMALL_STATE(4979)] = 484406,
  [SMALL_STATE(4980)] = 484451,
  [SMALL_STATE(4981)] = 484496,
  [SMALL_STATE(4982)] = 484541,
  [SMALL_STATE(4983)] = 484586,
  [SMALL_STATE(4984)] = 484631,
  [SMALL_STATE(4985)] = 484676,
  [SMALL_STATE(4986)] = 484721,
  [SMALL_STATE(4987)] = 484768,
  [SMALL_STATE(4988)] = 484813,
  [SMALL_STATE(4989)] = 484896,
  [SMALL_STATE(4990)] = 484943,
  [SMALL_STATE(4991)] = 484988,
  [SMALL_STATE(4992)] = 485033,
  [SMALL_STATE(4993)] = 485118,
  [SMALL_STATE(4994)] = 485165,
  [SMALL_STATE(4995)] = 485248,
  [SMALL_STATE(4996)] = 485331,
  [SMALL_STATE(4997)] = 485412,
  [SMALL_STATE(4998)] = 485459,
  [SMALL_STATE(4999)] = 485504,
  [SMALL_STATE(5000)] = 485587,
  [SMALL_STATE(5001)] = 485632,
  [SMALL_STATE(5002)] = 485677,
  [SMALL_STATE(5003)] = 485724,
  [SMALL_STATE(5004)] = 485807,
  [SMALL_STATE(5005)] = 485852,
  [SMALL_STATE(5006)] = 485897,
  [SMALL_STATE(5007)] = 485944,
  [SMALL_STATE(5008)] = 485991,
  [SMALL_STATE(5009)] = 486040,
  [SMALL_STATE(5010)] = 486123,
  [SMALL_STATE(5011)] = 486168,
  [SMALL_STATE(5012)] = 486213,
  [SMALL_STATE(5013)] = 486260,
  [SMALL_STATE(5014)] = 486305,
  [SMALL_STATE(5015)] = 486350,
  [SMALL_STATE(5016)] = 486395,
  [SMALL_STATE(5017)] = 486480,
  [SMALL_STATE(5018)] = 486525,
  [SMALL_STATE(5019)] = 486574,
  [SMALL_STATE(5020)] = 486657,
  [SMALL_STATE(5021)] = 486702,
  [SMALL_STATE(5022)] = 486747,
  [SMALL_STATE(5023)] = 486792,
  [SMALL_STATE(5024)] = 486837,
  [SMALL_STATE(5025)] = 486882,
  [SMALL_STATE(5026)] = 486927,
  [SMALL_STATE(5027)] = 486972,
  [SMALL_STATE(5028)] = 487017,
  [SMALL_STATE(5029)] = 487064,
  [SMALL_STATE(5030)] = 487109,
  [SMALL_STATE(5031)] = 487154,
  [SMALL_STATE(5032)] = 487199,
  [SMALL_STATE(5033)] = 487244,
  [SMALL_STATE(5034)] = 487327,
  [SMALL_STATE(5035)] = 487410,
  [SMALL_STATE(5036)] = 487455,
  [SMALL_STATE(5037)] = 487500,
  [SMALL_STATE(5038)] = 487545,
  [SMALL_STATE(5039)] = 487590,
  [SMALL_STATE(5040)] = 487637,
  [SMALL_STATE(5041)] = 487682,
  [SMALL_STATE(5042)] = 487727,
  [SMALL_STATE(5043)] = 487772,
  [SMALL_STATE(5044)] = 487817,
  [SMALL_STATE(5045)] = 487900,
  [SMALL_STATE(5046)] = 487945,
  [SMALL_STATE(5047)] = 487990,
  [SMALL_STATE(5048)] = 488035,
  [SMALL_STATE(5049)] = 488118,
  [SMALL_STATE(5050)] = 488163,
  [SMALL_STATE(5051)] = 488248,
  [SMALL_STATE(5052)] = 488293,
  [SMALL_STATE(5053)] = 488338,
  [SMALL_STATE(5054)] = 488383,
  [SMALL_STATE(5055)] = 488428,
  [SMALL_STATE(5056)] = 488475,
  [SMALL_STATE(5057)] = 488520,
  [SMALL_STATE(5058)] = 488603,
  [SMALL_STATE(5059)] = 488648,
  [SMALL_STATE(5060)] = 488731,
  [SMALL_STATE(5061)] = 488776,
  [SMALL_STATE(5062)] = 488821,
  [SMALL_STATE(5063)] = 488902,
  [SMALL_STATE(5064)] = 488947,
  [SMALL_STATE(5065)] = 489028,
  [SMALL_STATE(5066)] = 489073,
  [SMALL_STATE(5067)] = 489156,
  [SMALL_STATE(5068)] = 489201,
  [SMALL_STATE(5069)] = 489246,
  [SMALL_STATE(5070)] = 489291,
  [SMALL_STATE(5071)] = 489336,
  [SMALL_STATE(5072)] = 489381,
  [SMALL_STATE(5073)] = 489464,
  [SMALL_STATE(5074)] = 489509,
  [SMALL_STATE(5075)] = 489556,
  [SMALL_STATE(5076)] = 489603,
  [SMALL_STATE(5077)] = 489648,
  [SMALL_STATE(5078)] = 489693,
  [SMALL_STATE(5079)] = 489738,
  [SMALL_STATE(5080)] = 489783,
  [SMALL_STATE(5081)] = 489828,
  [SMALL_STATE(5082)] = 489873,
  [SMALL_STATE(5083)] = 489918,
  [SMALL_STATE(5084)] = 489963,
  [SMALL_STATE(5085)] = 490008,
  [SMALL_STATE(5086)] = 490053,
  [SMALL_STATE(5087)] = 490098,
  [SMALL_STATE(5088)] = 490143,
  [SMALL_STATE(5089)] = 490188,
  [SMALL_STATE(5090)] = 490271,
  [SMALL_STATE(5091)] = 490316,
  [SMALL_STATE(5092)] = 490361,
  [SMALL_STATE(5093)] = 490406,
  [SMALL_STATE(5094)] = 490451,
  [SMALL_STATE(5095)] = 490496,
  [SMALL_STATE(5096)] = 490541,
  [SMALL_STATE(5097)] = 490586,
  [SMALL_STATE(5098)] = 490631,
  [SMALL_STATE(5099)] = 490676,
  [SMALL_STATE(5100)] = 490723,
  [SMALL_STATE(5101)] = 490768,
  [SMALL_STATE(5102)] = 490813,
  [SMALL_STATE(5103)] = 490858,
  [SMALL_STATE(5104)] = 490905,
  [SMALL_STATE(5105)] = 490950,
  [SMALL_STATE(5106)] = 490995,
  [SMALL_STATE(5107)] = 491040,
  [SMALL_STATE(5108)] = 491085,
  [SMALL_STATE(5109)] = 491130,
  [SMALL_STATE(5110)] = 491175,
  [SMALL_STATE(5111)] = 491258,
  [SMALL_STATE(5112)] = 491303,
  [SMALL_STATE(5113)] = 491384,
  [SMALL_STATE(5114)] = 491429,
  [SMALL_STATE(5115)] = 491474,
  [SMALL_STATE(5116)] = 491519,
  [SMALL_STATE(5117)] = 491564,
  [SMALL_STATE(5118)] = 491613,
  [SMALL_STATE(5119)] = 491658,
  [SMALL_STATE(5120)] = 491703,
  [SMALL_STATE(5121)] = 491748,
  [SMALL_STATE(5122)] = 491831,
  [SMALL_STATE(5123)] = 491876,
  [SMALL_STATE(5124)] = 491921,
  [SMALL_STATE(5125)] = 491966,
  [SMALL_STATE(5126)] = 492011,
  [SMALL_STATE(5127)] = 492056,
  [SMALL_STATE(5128)] = 492139,
  [SMALL_STATE(5129)] = 492186,
  [SMALL_STATE(5130)] = 492231,
  [SMALL_STATE(5131)] = 492278,
  [SMALL_STATE(5132)] = 492361,
  [SMALL_STATE(5133)] = 492406,
  [SMALL_STATE(5134)] = 492451,
  [SMALL_STATE(5135)] = 492496,
  [SMALL_STATE(5136)] = 492541,
  [SMALL_STATE(5137)] = 492586,
  [SMALL_STATE(5138)] = 492669,
  [SMALL_STATE(5139)] = 492714,
  [SMALL_STATE(5140)] = 492759,
  [SMALL_STATE(5141)] = 492840,
  [SMALL_STATE(5142)] = 492885,
  [SMALL_STATE(5143)] = 492934,
  [SMALL_STATE(5144)] = 493017,
  [SMALL_STATE(5145)] = 493064,
  [SMALL_STATE(5146)] = 493147,
  [SMALL_STATE(5147)] = 493192,
  [SMALL_STATE(5148)] = 493241,
  [SMALL_STATE(5149)] = 493286,
  [SMALL_STATE(5150)] = 493331,
  [SMALL_STATE(5151)] = 493376,
  [SMALL_STATE(5152)] = 493421,
  [SMALL_STATE(5153)] = 493466,
  [SMALL_STATE(5154)] = 493511,
  [SMALL_STATE(5155)] = 493556,
  [SMALL_STATE(5156)] = 493601,
  [SMALL_STATE(5157)] = 493646,
  [SMALL_STATE(5158)] = 493729,
  [SMALL_STATE(5159)] = 493774,
  [SMALL_STATE(5160)] = 493819,
  [SMALL_STATE(5161)] = 493864,
  [SMALL_STATE(5162)] = 493947,
  [SMALL_STATE(5163)] = 494030,
  [SMALL_STATE(5164)] = 494075,
  [SMALL_STATE(5165)] = 494158,
  [SMALL_STATE(5166)] = 494203,
  [SMALL_STATE(5167)] = 494286,
  [SMALL_STATE(5168)] = 494369,
  [SMALL_STATE(5169)] = 494414,
  [SMALL_STATE(5170)] = 494459,
  [SMALL_STATE(5171)] = 494504,
  [SMALL_STATE(5172)] = 494549,
  [SMALL_STATE(5173)] = 494594,
  [SMALL_STATE(5174)] = 494639,
  [SMALL_STATE(5175)] = 494684,
  [SMALL_STATE(5176)] = 494729,
  [SMALL_STATE(5177)] = 494774,
  [SMALL_STATE(5178)] = 494859,
  [SMALL_STATE(5179)] = 494904,
  [SMALL_STATE(5180)] = 494987,
  [SMALL_STATE(5181)] = 495032,
  [SMALL_STATE(5182)] = 495079,
  [SMALL_STATE(5183)] = 495124,
  [SMALL_STATE(5184)] = 495169,
  [SMALL_STATE(5185)] = 495214,
  [SMALL_STATE(5186)] = 495259,
  [SMALL_STATE(5187)] = 495304,
  [SMALL_STATE(5188)] = 495349,
  [SMALL_STATE(5189)] = 495432,
  [SMALL_STATE(5190)] = 495477,
  [SMALL_STATE(5191)] = 495558,
  [SMALL_STATE(5192)] = 495643,
  [SMALL_STATE(5193)] = 495688,
  [SMALL_STATE(5194)] = 495735,
  [SMALL_STATE(5195)] = 495780,
  [SMALL_STATE(5196)] = 495863,
  [SMALL_STATE(5197)] = 495908,
  [SMALL_STATE(5198)] = 495953,
  [SMALL_STATE(5199)] = 495998,
  [SMALL_STATE(5200)] = 496081,
  [SMALL_STATE(5201)] = 496164,
  [SMALL_STATE(5202)] = 496209,
  [SMALL_STATE(5203)] = 496256,
  [SMALL_STATE(5204)] = 496301,
  [SMALL_STATE(5205)] = 496348,
  [SMALL_STATE(5206)] = 496431,
  [SMALL_STATE(5207)] = 496476,
  [SMALL_STATE(5208)] = 496521,
  [SMALL_STATE(5209)] = 496566,
  [SMALL_STATE(5210)] = 496611,
  [SMALL_STATE(5211)] = 496692,
  [SMALL_STATE(5212)] = 496737,
  [SMALL_STATE(5213)] = 496782,
  [SMALL_STATE(5214)] = 496827,
  [SMALL_STATE(5215)] = 496910,
  [SMALL_STATE(5216)] = 496955,
  [SMALL_STATE(5217)] = 497002,
  [SMALL_STATE(5218)] = 497049,
  [SMALL_STATE(5219)] = 497094,
  [SMALL_STATE(5220)] = 497139,
  [SMALL_STATE(5221)] = 497184,
  [SMALL_STATE(5222)] = 497229,
  [SMALL_STATE(5223)] = 497276,
  [SMALL_STATE(5224)] = 497359,
  [SMALL_STATE(5225)] = 497442,
  [SMALL_STATE(5226)] = 497489,
  [SMALL_STATE(5227)] = 497538,
  [SMALL_STATE(5228)] = 497623,
  [SMALL_STATE(5229)] = 497668,
  [SMALL_STATE(5230)] = 497713,
  [SMALL_STATE(5231)] = 497758,
  [SMALL_STATE(5232)] = 497803,
  [SMALL_STATE(5233)] = 497848,
  [SMALL_STATE(5234)] = 497893,
  [SMALL_STATE(5235)] = 497938,
  [SMALL_STATE(5236)] = 497983,
  [SMALL_STATE(5237)] = 498028,
  [SMALL_STATE(5238)] = 498075,
  [SMALL_STATE(5239)] = 498120,
  [SMALL_STATE(5240)] = 498203,
  [SMALL_STATE(5241)] = 498248,
  [SMALL_STATE(5242)] = 498331,
  [SMALL_STATE(5243)] = 498376,
  [SMALL_STATE(5244)] = 498421,
  [SMALL_STATE(5245)] = 498504,
  [SMALL_STATE(5246)] = 498549,
  [SMALL_STATE(5247)] = 498594,
  [SMALL_STATE(5248)] = 498641,
  [SMALL_STATE(5249)] = 498686,
  [SMALL_STATE(5250)] = 498731,
  [SMALL_STATE(5251)] = 498776,
  [SMALL_STATE(5252)] = 498823,
  [SMALL_STATE(5253)] = 498908,
  [SMALL_STATE(5254)] = 498953,
  [SMALL_STATE(5255)] = 498998,
  [SMALL_STATE(5256)] = 499043,
  [SMALL_STATE(5257)] = 499088,
  [SMALL_STATE(5258)] = 499171,
  [SMALL_STATE(5259)] = 499216,
  [SMALL_STATE(5260)] = 499261,
  [SMALL_STATE(5261)] = 499306,
  [SMALL_STATE(5262)] = 499351,
  [SMALL_STATE(5263)] = 499396,
  [SMALL_STATE(5264)] = 499441,
  [SMALL_STATE(5265)] = 499524,
  [SMALL_STATE(5266)] = 499569,
  [SMALL_STATE(5267)] = 499614,
  [SMALL_STATE(5268)] = 499697,
  [SMALL_STATE(5269)] = 499744,
  [SMALL_STATE(5270)] = 499789,
  [SMALL_STATE(5271)] = 499834,
  [SMALL_STATE(5272)] = 499879,
  [SMALL_STATE(5273)] = 499962,
  [SMALL_STATE(5274)] = 500007,
  [SMALL_STATE(5275)] = 500052,
  [SMALL_STATE(5276)] = 500135,
  [SMALL_STATE(5277)] = 500180,
  [SMALL_STATE(5278)] = 500225,
  [SMALL_STATE(5279)] = 500270,
  [SMALL_STATE(5280)] = 500315,
  [SMALL_STATE(5281)] = 500360,
  [SMALL_STATE(5282)] = 500405,
  [SMALL_STATE(5283)] = 500450,
  [SMALL_STATE(5284)] = 500533,
  [SMALL_STATE(5285)] = 500618,
  [SMALL_STATE(5286)] = 500663,
  [SMALL_STATE(5287)] = 500748,
  [SMALL_STATE(5288)] = 500793,
  [SMALL_STATE(5289)] = 500838,
  [SMALL_STATE(5290)] = 500885,
  [SMALL_STATE(5291)] = 500934,
  [SMALL_STATE(5292)] = 500979,
  [SMALL_STATE(5293)] = 501062,
  [SMALL_STATE(5294)] = 501107,
  [SMALL_STATE(5295)] = 501152,
  [SMALL_STATE(5296)] = 501197,
  [SMALL_STATE(5297)] = 501242,
  [SMALL_STATE(5298)] = 501287,
  [SMALL_STATE(5299)] = 501332,
  [SMALL_STATE(5300)] = 501377,
  [SMALL_STATE(5301)] = 501422,
  [SMALL_STATE(5302)] = 501503,
  [SMALL_STATE(5303)] = 501548,
  [SMALL_STATE(5304)] = 501631,
  [SMALL_STATE(5305)] = 501676,
  [SMALL_STATE(5306)] = 501721,
  [SMALL_STATE(5307)] = 501766,
  [SMALL_STATE(5308)] = 501811,
  [SMALL_STATE(5309)] = 501894,
  [SMALL_STATE(5310)] = 501939,
  [SMALL_STATE(5311)] = 501984,
  [SMALL_STATE(5312)] = 502029,
  [SMALL_STATE(5313)] = 502074,
  [SMALL_STATE(5314)] = 502119,
  [SMALL_STATE(5315)] = 502164,
  [SMALL_STATE(5316)] = 502209,
  [SMALL_STATE(5317)] = 502254,
  [SMALL_STATE(5318)] = 502299,
  [SMALL_STATE(5319)] = 502344,
  [SMALL_STATE(5320)] = 502389,
  [SMALL_STATE(5321)] = 502434,
  [SMALL_STATE(5322)] = 502479,
  [SMALL_STATE(5323)] = 502524,
  [SMALL_STATE(5324)] = 502569,
  [SMALL_STATE(5325)] = 502614,
  [SMALL_STATE(5326)] = 502659,
  [SMALL_STATE(5327)] = 502742,
  [SMALL_STATE(5328)] = 502787,
  [SMALL_STATE(5329)] = 502832,
  [SMALL_STATE(5330)] = 502877,
  [SMALL_STATE(5331)] = 502922,
  [SMALL_STATE(5332)] = 502969,
  [SMALL_STATE(5333)] = 503052,
  [SMALL_STATE(5334)] = 503097,
  [SMALL_STATE(5335)] = 503142,
  [SMALL_STATE(5336)] = 503187,
  [SMALL_STATE(5337)] = 503232,
  [SMALL_STATE(5338)] = 503277,
  [SMALL_STATE(5339)] = 503322,
  [SMALL_STATE(5340)] = 503367,
  [SMALL_STATE(5341)] = 503412,
  [SMALL_STATE(5342)] = 503457,
  [SMALL_STATE(5343)] = 503502,
  [SMALL_STATE(5344)] = 503547,
  [SMALL_STATE(5345)] = 503592,
  [SMALL_STATE(5346)] = 503637,
  [SMALL_STATE(5347)] = 503720,
  [SMALL_STATE(5348)] = 503765,
  [SMALL_STATE(5349)] = 503810,
  [SMALL_STATE(5350)] = 503857,
  [SMALL_STATE(5351)] = 503902,
  [SMALL_STATE(5352)] = 503985,
  [SMALL_STATE(5353)] = 504034,
  [SMALL_STATE(5354)] = 504117,
  [SMALL_STATE(5355)] = 504162,
  [SMALL_STATE(5356)] = 504207,
  [SMALL_STATE(5357)] = 504290,
  [SMALL_STATE(5358)] = 504334,
  [SMALL_STATE(5359)] = 504382,
  [SMALL_STATE(5360)] = 504426,
  [SMALL_STATE(5361)] = 504470,
  [SMALL_STATE(5362)] = 504514,
  [SMALL_STATE(5363)] = 504558,
  [SMALL_STATE(5364)] = 504602,
  [SMALL_STATE(5365)] = 504646,
  [SMALL_STATE(5366)] = 504690,
  [SMALL_STATE(5367)] = 504734,
  [SMALL_STATE(5368)] = 504778,
  [SMALL_STATE(5369)] = 504826,
  [SMALL_STATE(5370)] = 504870,
  [SMALL_STATE(5371)] = 504914,
  [SMALL_STATE(5372)] = 504958,
  [SMALL_STATE(5373)] = 505002,
  [SMALL_STATE(5374)] = 505046,
  [SMALL_STATE(5375)] = 505090,
  [SMALL_STATE(5376)] = 505134,
  [SMALL_STATE(5377)] = 505178,
  [SMALL_STATE(5378)] = 505222,
  [SMALL_STATE(5379)] = 505266,
  [SMALL_STATE(5380)] = 505310,
  [SMALL_STATE(5381)] = 505354,
  [SMALL_STATE(5382)] = 505398,
  [SMALL_STATE(5383)] = 505442,
  [SMALL_STATE(5384)] = 505486,
  [SMALL_STATE(5385)] = 505530,
  [SMALL_STATE(5386)] = 505574,
  [SMALL_STATE(5387)] = 505618,
  [SMALL_STATE(5388)] = 505662,
  [SMALL_STATE(5389)] = 505706,
  [SMALL_STATE(5390)] = 505750,
  [SMALL_STATE(5391)] = 505794,
  [SMALL_STATE(5392)] = 505838,
  [SMALL_STATE(5393)] = 505882,
  [SMALL_STATE(5394)] = 505926,
  [SMALL_STATE(5395)] = 505970,
  [SMALL_STATE(5396)] = 506014,
  [SMALL_STATE(5397)] = 506096,
  [SMALL_STATE(5398)] = 506140,
  [SMALL_STATE(5399)] = 506184,
  [SMALL_STATE(5400)] = 506228,
  [SMALL_STATE(5401)] = 506272,
  [SMALL_STATE(5402)] = 506316,
  [SMALL_STATE(5403)] = 506360,
  [SMALL_STATE(5404)] = 506406,
  [SMALL_STATE(5405)] = 506452,
  [SMALL_STATE(5406)] = 506496,
  [SMALL_STATE(5407)] = 506540,
  [SMALL_STATE(5408)] = 506588,
  [SMALL_STATE(5409)] = 506632,
  [SMALL_STATE(5410)] = 506678,
  [SMALL_STATE(5411)] = 506722,
  [SMALL_STATE(5412)] = 506766,
  [SMALL_STATE(5413)] = 506810,
  [SMALL_STATE(5414)] = 506854,
  [SMALL_STATE(5415)] = 506898,
  [SMALL_STATE(5416)] = 506942,
  [SMALL_STATE(5417)] = 506986,
  [SMALL_STATE(5418)] = 507030,
  [SMALL_STATE(5419)] = 507074,
  [SMALL_STATE(5420)] = 507118,
  [SMALL_STATE(5421)] = 507164,
  [SMALL_STATE(5422)] = 507208,
  [SMALL_STATE(5423)] = 507252,
  [SMALL_STATE(5424)] = 507296,
  [SMALL_STATE(5425)] = 507340,
  [SMALL_STATE(5426)] = 507384,
  [SMALL_STATE(5427)] = 507430,
  [SMALL_STATE(5428)] = 507474,
  [SMALL_STATE(5429)] = 507520,
  [SMALL_STATE(5430)] = 507600,
  [SMALL_STATE(5431)] = 507646,
  [SMALL_STATE(5432)] = 507690,
  [SMALL_STATE(5433)] = 507736,
  [SMALL_STATE(5434)] = 507782,
  [SMALL_STATE(5435)] = 507826,
  [SMALL_STATE(5436)] = 507870,
  [SMALL_STATE(5437)] = 507914,
  [SMALL_STATE(5438)] = 507958,
  [SMALL_STATE(5439)] = 508002,
  [SMALL_STATE(5440)] = 508046,
  [SMALL_STATE(5441)] = 508090,
  [SMALL_STATE(5442)] = 508134,
  [SMALL_STATE(5443)] = 508180,
  [SMALL_STATE(5444)] = 508224,
  [SMALL_STATE(5445)] = 508268,
  [SMALL_STATE(5446)] = 508312,
  [SMALL_STATE(5447)] = 508356,
  [SMALL_STATE(5448)] = 508400,
  [SMALL_STATE(5449)] = 508444,
  [SMALL_STATE(5450)] = 508488,
  [SMALL_STATE(5451)] = 508532,
  [SMALL_STATE(5452)] = 508576,
  [SMALL_STATE(5453)] = 508620,
  [SMALL_STATE(5454)] = 508664,
  [SMALL_STATE(5455)] = 508708,
  [SMALL_STATE(5456)] = 508752,
  [SMALL_STATE(5457)] = 508796,
  [SMALL_STATE(5458)] = 508840,
  [SMALL_STATE(5459)] = 508884,
  [SMALL_STATE(5460)] = 508928,
  [SMALL_STATE(5461)] = 508972,
  [SMALL_STATE(5462)] = 509016,
  [SMALL_STATE(5463)] = 509060,
  [SMALL_STATE(5464)] = 509104,
  [SMALL_STATE(5465)] = 509148,
  [SMALL_STATE(5466)] = 509192,
  [SMALL_STATE(5467)] = 509236,
  [SMALL_STATE(5468)] = 509280,
  [SMALL_STATE(5469)] = 509324,
  [SMALL_STATE(5470)] = 509370,
  [SMALL_STATE(5471)] = 509414,
  [SMALL_STATE(5472)] = 509460,
  [SMALL_STATE(5473)] = 509504,
  [SMALL_STATE(5474)] = 509548,
  [SMALL_STATE(5475)] = 509592,
  [SMALL_STATE(5476)] = 509636,
  [SMALL_STATE(5477)] = 509680,
  [SMALL_STATE(5478)] = 509724,
  [SMALL_STATE(5479)] = 509768,
  [SMALL_STATE(5480)] = 509812,
  [SMALL_STATE(5481)] = 509856,
  [SMALL_STATE(5482)] = 509900,
  [SMALL_STATE(5483)] = 509944,
  [SMALL_STATE(5484)] = 509988,
  [SMALL_STATE(5485)] = 510034,
  [SMALL_STATE(5486)] = 510080,
  [SMALL_STATE(5487)] = 510126,
  [SMALL_STATE(5488)] = 510170,
  [SMALL_STATE(5489)] = 510214,
  [SMALL_STATE(5490)] = 510258,
  [SMALL_STATE(5491)] = 510302,
  [SMALL_STATE(5492)] = 510346,
  [SMALL_STATE(5493)] = 510390,
  [SMALL_STATE(5494)] = 510434,
  [SMALL_STATE(5495)] = 510478,
  [SMALL_STATE(5496)] = 510522,
  [SMALL_STATE(5497)] = 510602,
  [SMALL_STATE(5498)] = 510646,
  [SMALL_STATE(5499)] = 510690,
  [SMALL_STATE(5500)] = 510734,
  [SMALL_STATE(5501)] = 510778,
  [SMALL_STATE(5502)] = 510822,
  [SMALL_STATE(5503)] = 510866,
  [SMALL_STATE(5504)] = 510910,
  [SMALL_STATE(5505)] = 510954,
  [SMALL_STATE(5506)] = 510998,
  [SMALL_STATE(5507)] = 511042,
  [SMALL_STATE(5508)] = 511086,
  [SMALL_STATE(5509)] = 511130,
  [SMALL_STATE(5510)] = 511176,
  [SMALL_STATE(5511)] = 511222,
  [SMALL_STATE(5512)] = 511266,
  [SMALL_STATE(5513)] = 511312,
  [SMALL_STATE(5514)] = 511356,
  [SMALL_STATE(5515)] = 511400,
  [SMALL_STATE(5516)] = 511444,
  [SMALL_STATE(5517)] = 511488,
  [SMALL_STATE(5518)] = 511532,
  [SMALL_STATE(5519)] = 511576,
  [SMALL_STATE(5520)] = 511620,
  [SMALL_STATE(5521)] = 511664,
  [SMALL_STATE(5522)] = 511708,
  [SMALL_STATE(5523)] = 511752,
  [SMALL_STATE(5524)] = 511796,
  [SMALL_STATE(5525)] = 511840,
  [SMALL_STATE(5526)] = 511884,
  [SMALL_STATE(5527)] = 511928,
  [SMALL_STATE(5528)] = 511972,
  [SMALL_STATE(5529)] = 512016,
  [SMALL_STATE(5530)] = 512060,
  [SMALL_STATE(5531)] = 512104,
  [SMALL_STATE(5532)] = 512148,
  [SMALL_STATE(5533)] = 512192,
  [SMALL_STATE(5534)] = 512236,
  [SMALL_STATE(5535)] = 512280,
  [SMALL_STATE(5536)] = 512324,
  [SMALL_STATE(5537)] = 512372,
  [SMALL_STATE(5538)] = 512416,
  [SMALL_STATE(5539)] = 512460,
  [SMALL_STATE(5540)] = 512540,
  [SMALL_STATE(5541)] = 512584,
  [SMALL_STATE(5542)] = 512628,
  [SMALL_STATE(5543)] = 512676,
  [SMALL_STATE(5544)] = 512720,
  [SMALL_STATE(5545)] = 512764,
  [SMALL_STATE(5546)] = 512808,
  [SMALL_STATE(5547)] = 512854,
  [SMALL_STATE(5548)] = 512900,
  [SMALL_STATE(5549)] = 512946,
  [SMALL_STATE(5550)] = 512992,
  [SMALL_STATE(5551)] = 513036,
  [SMALL_STATE(5552)] = 513118,
  [SMALL_STATE(5553)] = 513162,
  [SMALL_STATE(5554)] = 513206,
  [SMALL_STATE(5555)] = 513250,
  [SMALL_STATE(5556)] = 513294,
  [SMALL_STATE(5557)] = 513338,
  [SMALL_STATE(5558)] = 513382,
  [SMALL_STATE(5559)] = 513426,
  [SMALL_STATE(5560)] = 513470,
  [SMALL_STATE(5561)] = 513514,
  [SMALL_STATE(5562)] = 513558,
  [SMALL_STATE(5563)] = 513602,
  [SMALL_STATE(5564)] = 513646,
  [SMALL_STATE(5565)] = 513690,
  [SMALL_STATE(5566)] = 513734,
  [SMALL_STATE(5567)] = 513778,
  [SMALL_STATE(5568)] = 513822,
  [SMALL_STATE(5569)] = 513866,
  [SMALL_STATE(5570)] = 513910,
  [SMALL_STATE(5571)] = 513954,
  [SMALL_STATE(5572)] = 513998,
  [SMALL_STATE(5573)] = 514042,
  [SMALL_STATE(5574)] = 514086,
  [SMALL_STATE(5575)] = 514130,
  [SMALL_STATE(5576)] = 514174,
  [SMALL_STATE(5577)] = 514218,
  [SMALL_STATE(5578)] = 514264,
  [SMALL_STATE(5579)] = 514308,
  [SMALL_STATE(5580)] = 514352,
  [SMALL_STATE(5581)] = 514396,
  [SMALL_STATE(5582)] = 514440,
  [SMALL_STATE(5583)] = 514484,
  [SMALL_STATE(5584)] = 514528,
  [SMALL_STATE(5585)] = 514572,
  [SMALL_STATE(5586)] = 514652,
  [SMALL_STATE(5587)] = 514696,
  [SMALL_STATE(5588)] = 514740,
  [SMALL_STATE(5589)] = 514786,
  [SMALL_STATE(5590)] = 514830,
  [SMALL_STATE(5591)] = 514874,
  [SMALL_STATE(5592)] = 514954,
  [SMALL_STATE(5593)] = 514998,
  [SMALL_STATE(5594)] = 515042,
  [SMALL_STATE(5595)] = 515086,
  [SMALL_STATE(5596)] = 515130,
  [SMALL_STATE(5597)] = 515176,
  [SMALL_STATE(5598)] = 515220,
  [SMALL_STATE(5599)] = 515264,
  [SMALL_STATE(5600)] = 515308,
  [SMALL_STATE(5601)] = 515352,
  [SMALL_STATE(5602)] = 515398,
  [SMALL_STATE(5603)] = 515442,
  [SMALL_STATE(5604)] = 515486,
  [SMALL_STATE(5605)] = 515532,
  [SMALL_STATE(5606)] = 515576,
  [SMALL_STATE(5607)] = 515620,
  [SMALL_STATE(5608)] = 515664,
  [SMALL_STATE(5609)] = 515708,
  [SMALL_STATE(5610)] = 515790,
  [SMALL_STATE(5611)] = 515834,
  [SMALL_STATE(5612)] = 515916,
  [SMALL_STATE(5613)] = 515960,
  [SMALL_STATE(5614)] = 516004,
  [SMALL_STATE(5615)] = 516048,
  [SMALL_STATE(5616)] = 516092,
  [SMALL_STATE(5617)] = 516136,
  [SMALL_STATE(5618)] = 516180,
  [SMALL_STATE(5619)] = 516224,
  [SMALL_STATE(5620)] = 516268,
  [SMALL_STATE(5621)] = 516312,
  [SMALL_STATE(5622)] = 516356,
  [SMALL_STATE(5623)] = 516400,
  [SMALL_STATE(5624)] = 516444,
  [SMALL_STATE(5625)] = 516488,
  [SMALL_STATE(5626)] = 516536,
  [SMALL_STATE(5627)] = 516580,
  [SMALL_STATE(5628)] = 516624,
  [SMALL_STATE(5629)] = 516670,
  [SMALL_STATE(5630)] = 516714,
  [SMALL_STATE(5631)] = 516796,
  [SMALL_STATE(5632)] = 516840,
  [SMALL_STATE(5633)] = 516884,
  [SMALL_STATE(5634)] = 516928,
  [SMALL_STATE(5635)] = 516972,
  [SMALL_STATE(5636)] = 517016,
  [SMALL_STATE(5637)] = 517060,
  [SMALL_STATE(5638)] = 517104,
  [SMALL_STATE(5639)] = 517148,
  [SMALL_STATE(5640)] = 517192,
  [SMALL_STATE(5641)] = 517236,
  [SMALL_STATE(5642)] = 517280,
  [SMALL_STATE(5643)] = 517326,
  [SMALL_STATE(5644)] = 517372,
  [SMALL_STATE(5645)] = 517416,
  [SMALL_STATE(5646)] = 517460,
  [SMALL_STATE(5647)] = 517504,
  [SMALL_STATE(5648)] = 517548,
  [SMALL_STATE(5649)] = 517592,
  [SMALL_STATE(5650)] = 517636,
  [SMALL_STATE(5651)] = 517680,
  [SMALL_STATE(5652)] = 517724,
  [SMALL_STATE(5653)] = 517768,
  [SMALL_STATE(5654)] = 517812,
  [SMALL_STATE(5655)] = 517856,
  [SMALL_STATE(5656)] = 517900,
  [SMALL_STATE(5657)] = 517944,
  [SMALL_STATE(5658)] = 517988,
  [SMALL_STATE(5659)] = 518032,
  [SMALL_STATE(5660)] = 518076,
  [SMALL_STATE(5661)] = 518120,
  [SMALL_STATE(5662)] = 518164,
  [SMALL_STATE(5663)] = 518208,
  [SMALL_STATE(5664)] = 518252,
  [SMALL_STATE(5665)] = 518296,
  [SMALL_STATE(5666)] = 518340,
  [SMALL_STATE(5667)] = 518384,
  [SMALL_STATE(5668)] = 518428,
  [SMALL_STATE(5669)] = 518472,
  [SMALL_STATE(5670)] = 518516,
  [SMALL_STATE(5671)] = 518560,
  [SMALL_STATE(5672)] = 518604,
  [SMALL_STATE(5673)] = 518648,
  [SMALL_STATE(5674)] = 518692,
  [SMALL_STATE(5675)] = 518736,
  [SMALL_STATE(5676)] = 518780,
  [SMALL_STATE(5677)] = 518824,
  [SMALL_STATE(5678)] = 518868,
  [SMALL_STATE(5679)] = 518912,
  [SMALL_STATE(5680)] = 518956,
  [SMALL_STATE(5681)] = 519000,
  [SMALL_STATE(5682)] = 519044,
  [SMALL_STATE(5683)] = 519090,
  [SMALL_STATE(5684)] = 519134,
  [SMALL_STATE(5685)] = 519178,
  [SMALL_STATE(5686)] = 519224,
  [SMALL_STATE(5687)] = 519268,
  [SMALL_STATE(5688)] = 519312,
  [SMALL_STATE(5689)] = 519356,
  [SMALL_STATE(5690)] = 519400,
  [SMALL_STATE(5691)] = 519444,
  [SMALL_STATE(5692)] = 519488,
  [SMALL_STATE(5693)] = 519532,
  [SMALL_STATE(5694)] = 519576,
  [SMALL_STATE(5695)] = 519658,
  [SMALL_STATE(5696)] = 519702,
  [SMALL_STATE(5697)] = 519746,
  [SMALL_STATE(5698)] = 519790,
  [SMALL_STATE(5699)] = 519834,
  [SMALL_STATE(5700)] = 519878,
  [SMALL_STATE(5701)] = 519922,
  [SMALL_STATE(5702)] = 519966,
  [SMALL_STATE(5703)] = 520010,
  [SMALL_STATE(5704)] = 520054,
  [SMALL_STATE(5705)] = 520098,
  [SMALL_STATE(5706)] = 520142,
  [SMALL_STATE(5707)] = 520186,
  [SMALL_STATE(5708)] = 520230,
  [SMALL_STATE(5709)] = 520274,
  [SMALL_STATE(5710)] = 520318,
  [SMALL_STATE(5711)] = 520362,
  [SMALL_STATE(5712)] = 520406,
  [SMALL_STATE(5713)] = 520450,
  [SMALL_STATE(5714)] = 520494,
  [SMALL_STATE(5715)] = 520538,
  [SMALL_STATE(5716)] = 520582,
  [SMALL_STATE(5717)] = 520628,
  [SMALL_STATE(5718)] = 520672,
  [SMALL_STATE(5719)] = 520718,
  [SMALL_STATE(5720)] = 520764,
  [SMALL_STATE(5721)] = 520808,
  [SMALL_STATE(5722)] = 520852,
  [SMALL_STATE(5723)] = 520896,
  [SMALL_STATE(5724)] = 520940,
  [SMALL_STATE(5725)] = 520984,
  [SMALL_STATE(5726)] = 521066,
  [SMALL_STATE(5727)] = 521110,
  [SMALL_STATE(5728)] = 521154,
  [SMALL_STATE(5729)] = 521198,
  [SMALL_STATE(5730)] = 521244,
  [SMALL_STATE(5731)] = 521324,
  [SMALL_STATE(5732)] = 521368,
  [SMALL_STATE(5733)] = 521412,
  [SMALL_STATE(5734)] = 521456,
  [SMALL_STATE(5735)] = 521502,
  [SMALL_STATE(5736)] = 521545,
  [SMALL_STATE(5737)] = 521588,
  [SMALL_STATE(5738)] = 521631,
  [SMALL_STATE(5739)] = 521674,
  [SMALL_STATE(5740)] = 521717,
  [SMALL_STATE(5741)] = 521760,
  [SMALL_STATE(5742)] = 521803,
  [SMALL_STATE(5743)] = 521846,
  [SMALL_STATE(5744)] = 521889,
  [SMALL_STATE(5745)] = 521932,
  [SMALL_STATE(5746)] = 521977,
  [SMALL_STATE(5747)] = 522020,
  [SMALL_STATE(5748)] = 522063,
  [SMALL_STATE(5749)] = 522106,
  [SMALL_STATE(5750)] = 522151,
  [SMALL_STATE(5751)] = 522196,
  [SMALL_STATE(5752)] = 522241,
  [SMALL_STATE(5753)] = 522284,
  [SMALL_STATE(5754)] = 522327,
  [SMALL_STATE(5755)] = 522370,
  [SMALL_STATE(5756)] = 522413,
  [SMALL_STATE(5757)] = 522456,
  [SMALL_STATE(5758)] = 522499,
  [SMALL_STATE(5759)] = 522542,
  [SMALL_STATE(5760)] = 522587,
  [SMALL_STATE(5761)] = 522630,
  [SMALL_STATE(5762)] = 522673,
  [SMALL_STATE(5763)] = 522716,
  [SMALL_STATE(5764)] = 522759,
  [SMALL_STATE(5765)] = 522802,
  [SMALL_STATE(5766)] = 522845,
  [SMALL_STATE(5767)] = 522888,
  [SMALL_STATE(5768)] = 522931,
  [SMALL_STATE(5769)] = 522974,
  [SMALL_STATE(5770)] = 523017,
  [SMALL_STATE(5771)] = 523060,
  [SMALL_STATE(5772)] = 523103,
  [SMALL_STATE(5773)] = 523146,
  [SMALL_STATE(5774)] = 523189,
  [SMALL_STATE(5775)] = 523232,
  [SMALL_STATE(5776)] = 523275,
  [SMALL_STATE(5777)] = 523318,
  [SMALL_STATE(5778)] = 523361,
  [SMALL_STATE(5779)] = 523404,
  [SMALL_STATE(5780)] = 523447,
  [SMALL_STATE(5781)] = 523490,
  [SMALL_STATE(5782)] = 523533,
  [SMALL_STATE(5783)] = 523576,
  [SMALL_STATE(5784)] = 523619,
  [SMALL_STATE(5785)] = 523662,
  [SMALL_STATE(5786)] = 523705,
  [SMALL_STATE(5787)] = 523748,
  [SMALL_STATE(5788)] = 523791,
  [SMALL_STATE(5789)] = 523834,
  [SMALL_STATE(5790)] = 523877,
  [SMALL_STATE(5791)] = 523920,
  [SMALL_STATE(5792)] = 523963,
  [SMALL_STATE(5793)] = 524042,
  [SMALL_STATE(5794)] = 524085,
  [SMALL_STATE(5795)] = 524128,
  [SMALL_STATE(5796)] = 524171,
  [SMALL_STATE(5797)] = 524214,
  [SMALL_STATE(5798)] = 524257,
  [SMALL_STATE(5799)] = 524300,
  [SMALL_STATE(5800)] = 524343,
  [SMALL_STATE(5801)] = 524386,
  [SMALL_STATE(5802)] = 524429,
  [SMALL_STATE(5803)] = 524472,
  [SMALL_STATE(5804)] = 524515,
  [SMALL_STATE(5805)] = 524558,
  [SMALL_STATE(5806)] = 524601,
  [SMALL_STATE(5807)] = 524644,
  [SMALL_STATE(5808)] = 524687,
  [SMALL_STATE(5809)] = 524730,
  [SMALL_STATE(5810)] = 524773,
  [SMALL_STATE(5811)] = 524816,
  [SMALL_STATE(5812)] = 524859,
  [SMALL_STATE(5813)] = 524906,
  [SMALL_STATE(5814)] = 524949,
  [SMALL_STATE(5815)] = 524992,
  [SMALL_STATE(5816)] = 525037,
  [SMALL_STATE(5817)] = 525080,
  [SMALL_STATE(5818)] = 525123,
  [SMALL_STATE(5819)] = 525168,
  [SMALL_STATE(5820)] = 525211,
  [SMALL_STATE(5821)] = 525254,
  [SMALL_STATE(5822)] = 525297,
  [SMALL_STATE(5823)] = 525340,
  [SMALL_STATE(5824)] = 525383,
  [SMALL_STATE(5825)] = 525426,
  [SMALL_STATE(5826)] = 525469,
  [SMALL_STATE(5827)] = 525512,
  [SMALL_STATE(5828)] = 525555,
  [SMALL_STATE(5829)] = 525598,
  [SMALL_STATE(5830)] = 525641,
  [SMALL_STATE(5831)] = 525688,
  [SMALL_STATE(5832)] = 525733,
  [SMALL_STATE(5833)] = 525776,
  [SMALL_STATE(5834)] = 525819,
  [SMALL_STATE(5835)] = 525864,
  [SMALL_STATE(5836)] = 525907,
  [SMALL_STATE(5837)] = 525954,
  [SMALL_STATE(5838)] = 525999,
  [SMALL_STATE(5839)] = 526042,
  [SMALL_STATE(5840)] = 526085,
  [SMALL_STATE(5841)] = 526128,
  [SMALL_STATE(5842)] = 526171,
  [SMALL_STATE(5843)] = 526216,
  [SMALL_STATE(5844)] = 526259,
  [SMALL_STATE(5845)] = 526302,
  [SMALL_STATE(5846)] = 526345,
  [SMALL_STATE(5847)] = 526388,
  [SMALL_STATE(5848)] = 526431,
  [SMALL_STATE(5849)] = 526474,
  [SMALL_STATE(5850)] = 526517,
  [SMALL_STATE(5851)] = 526560,
  [SMALL_STATE(5852)] = 526603,
  [SMALL_STATE(5853)] = 526646,
  [SMALL_STATE(5854)] = 526689,
  [SMALL_STATE(5855)] = 526732,
  [SMALL_STATE(5856)] = 526775,
  [SMALL_STATE(5857)] = 526818,
  [SMALL_STATE(5858)] = 526861,
  [SMALL_STATE(5859)] = 526904,
  [SMALL_STATE(5860)] = 526947,
  [SMALL_STATE(5861)] = 526990,
  [SMALL_STATE(5862)] = 527033,
  [SMALL_STATE(5863)] = 527076,
  [SMALL_STATE(5864)] = 527119,
  [SMALL_STATE(5865)] = 527164,
  [SMALL_STATE(5866)] = 527207,
  [SMALL_STATE(5867)] = 527250,
  [SMALL_STATE(5868)] = 527295,
  [SMALL_STATE(5869)] = 527338,
  [SMALL_STATE(5870)] = 527381,
  [SMALL_STATE(5871)] = 527424,
  [SMALL_STATE(5872)] = 527467,
  [SMALL_STATE(5873)] = 527514,
  [SMALL_STATE(5874)] = 527557,
  [SMALL_STATE(5875)] = 527600,
  [SMALL_STATE(5876)] = 527645,
  [SMALL_STATE(5877)] = 527688,
  [SMALL_STATE(5878)] = 527731,
  [SMALL_STATE(5879)] = 527774,
  [SMALL_STATE(5880)] = 527817,
  [SMALL_STATE(5881)] = 527860,
  [SMALL_STATE(5882)] = 527903,
  [SMALL_STATE(5883)] = 527946,
  [SMALL_STATE(5884)] = 527989,
  [SMALL_STATE(5885)] = 528032,
  [SMALL_STATE(5886)] = 528077,
  [SMALL_STATE(5887)] = 528120,
  [SMALL_STATE(5888)] = 528163,
  [SMALL_STATE(5889)] = 528206,
  [SMALL_STATE(5890)] = 528249,
  [SMALL_STATE(5891)] = 528292,
  [SMALL_STATE(5892)] = 528335,
  [SMALL_STATE(5893)] = 528378,
  [SMALL_STATE(5894)] = 528421,
  [SMALL_STATE(5895)] = 528464,
  [SMALL_STATE(5896)] = 528507,
  [SMALL_STATE(5897)] = 528550,
  [SMALL_STATE(5898)] = 528593,
  [SMALL_STATE(5899)] = 528636,
  [SMALL_STATE(5900)] = 528679,
  [SMALL_STATE(5901)] = 528722,
  [SMALL_STATE(5902)] = 528765,
  [SMALL_STATE(5903)] = 528808,
  [SMALL_STATE(5904)] = 528851,
  [SMALL_STATE(5905)] = 528894,
  [SMALL_STATE(5906)] = 528937,
  [SMALL_STATE(5907)] = 528980,
  [SMALL_STATE(5908)] = 529025,
  [SMALL_STATE(5909)] = 529068,
  [SMALL_STATE(5910)] = 529111,
  [SMALL_STATE(5911)] = 529154,
  [SMALL_STATE(5912)] = 529197,
  [SMALL_STATE(5913)] = 529242,
  [SMALL_STATE(5914)] = 529285,
  [SMALL_STATE(5915)] = 529328,
  [SMALL_STATE(5916)] = 529371,
  [SMALL_STATE(5917)] = 529416,
  [SMALL_STATE(5918)] = 529459,
  [SMALL_STATE(5919)] = 529502,
  [SMALL_STATE(5920)] = 529545,
  [SMALL_STATE(5921)] = 529588,
  [SMALL_STATE(5922)] = 529631,
  [SMALL_STATE(5923)] = 529674,
  [SMALL_STATE(5924)] = 529717,
  [SMALL_STATE(5925)] = 529760,
  [SMALL_STATE(5926)] = 529803,
  [SMALL_STATE(5927)] = 529846,
  [SMALL_STATE(5928)] = 529891,
  [SMALL_STATE(5929)] = 529934,
  [SMALL_STATE(5930)] = 529977,
  [SMALL_STATE(5931)] = 530020,
  [SMALL_STATE(5932)] = 530063,
  [SMALL_STATE(5933)] = 530106,
  [SMALL_STATE(5934)] = 530185,
  [SMALL_STATE(5935)] = 530228,
  [SMALL_STATE(5936)] = 530271,
  [SMALL_STATE(5937)] = 530314,
  [SMALL_STATE(5938)] = 530357,
  [SMALL_STATE(5939)] = 530402,
  [SMALL_STATE(5940)] = 530445,
  [SMALL_STATE(5941)] = 530488,
  [SMALL_STATE(5942)] = 530531,
  [SMALL_STATE(5943)] = 530576,
  [SMALL_STATE(5944)] = 530619,
  [SMALL_STATE(5945)] = 530666,
  [SMALL_STATE(5946)] = 530709,
  [SMALL_STATE(5947)] = 530754,
  [SMALL_STATE(5948)] = 530799,
  [SMALL_STATE(5949)] = 530844,
  [SMALL_STATE(5950)] = 530889,
  [SMALL_STATE(5951)] = 530934,
  [SMALL_STATE(5952)] = 530977,
  [SMALL_STATE(5953)] = 531020,
  [SMALL_STATE(5954)] = 531063,
  [SMALL_STATE(5955)] = 531106,
  [SMALL_STATE(5956)] = 531149,
  [SMALL_STATE(5957)] = 531194,
  [SMALL_STATE(5958)] = 531237,
  [SMALL_STATE(5959)] = 531280,
  [SMALL_STATE(5960)] = 531323,
  [SMALL_STATE(5961)] = 531366,
  [SMALL_STATE(5962)] = 531409,
  [SMALL_STATE(5963)] = 531452,
  [SMALL_STATE(5964)] = 531495,
  [SMALL_STATE(5965)] = 531538,
  [SMALL_STATE(5966)] = 531581,
  [SMALL_STATE(5967)] = 531624,
  [SMALL_STATE(5968)] = 531671,
  [SMALL_STATE(5969)] = 531714,
  [SMALL_STATE(5970)] = 531757,
  [SMALL_STATE(5971)] = 531802,
  [SMALL_STATE(5972)] = 531845,
  [SMALL_STATE(5973)] = 531888,
  [SMALL_STATE(5974)] = 531931,
  [SMALL_STATE(5975)] = 531974,
  [SMALL_STATE(5976)] = 532017,
  [SMALL_STATE(5977)] = 532060,
  [SMALL_STATE(5978)] = 532103,
  [SMALL_STATE(5979)] = 532146,
  [SMALL_STATE(5980)] = 532189,
  [SMALL_STATE(5981)] = 532234,
  [SMALL_STATE(5982)] = 532277,
  [SMALL_STATE(5983)] = 532320,
  [SMALL_STATE(5984)] = 532363,
  [SMALL_STATE(5985)] = 532406,
  [SMALL_STATE(5986)] = 532449,
  [SMALL_STATE(5987)] = 532492,
  [SMALL_STATE(5988)] = 532535,
  [SMALL_STATE(5989)] = 532578,
  [SMALL_STATE(5990)] = 532621,
  [SMALL_STATE(5991)] = 532664,
  [SMALL_STATE(5992)] = 532707,
  [SMALL_STATE(5993)] = 532750,
  [SMALL_STATE(5994)] = 532793,
  [SMALL_STATE(5995)] = 532836,
  [SMALL_STATE(5996)] = 532881,
  [SMALL_STATE(5997)] = 532960,
  [SMALL_STATE(5998)] = 533003,
  [SMALL_STATE(5999)] = 533046,
  [SMALL_STATE(6000)] = 533089,
  [SMALL_STATE(6001)] = 533131,
  [SMALL_STATE(6002)] = 533207,
  [SMALL_STATE(6003)] = 533249,
  [SMALL_STATE(6004)] = 533291,
  [SMALL_STATE(6005)] = 533333,
  [SMALL_STATE(6006)] = 533375,
  [SMALL_STATE(6007)] = 533417,
  [SMALL_STATE(6008)] = 533459,
  [SMALL_STATE(6009)] = 533501,
  [SMALL_STATE(6010)] = 533543,
  [SMALL_STATE(6011)] = 533585,
  [SMALL_STATE(6012)] = 533661,
  [SMALL_STATE(6013)] = 533737,
  [SMALL_STATE(6014)] = 533779,
  [SMALL_STATE(6015)] = 533821,
  [SMALL_STATE(6016)] = 533863,
  [SMALL_STATE(6017)] = 533905,
  [SMALL_STATE(6018)] = 533981,
  [SMALL_STATE(6019)] = 534023,
  [SMALL_STATE(6020)] = 534065,
  [SMALL_STATE(6021)] = 534107,
  [SMALL_STATE(6022)] = 534151,
  [SMALL_STATE(6023)] = 534195,
  [SMALL_STATE(6024)] = 534239,
  [SMALL_STATE(6025)] = 534281,
  [SMALL_STATE(6026)] = 534357,
  [SMALL_STATE(6027)] = 534399,
  [SMALL_STATE(6028)] = 534441,
  [SMALL_STATE(6029)] = 534517,
  [SMALL_STATE(6030)] = 534593,
  [SMALL_STATE(6031)] = 534635,
  [SMALL_STATE(6032)] = 534711,
  [SMALL_STATE(6033)] = 534753,
  [SMALL_STATE(6034)] = 534795,
  [SMALL_STATE(6035)] = 534837,
  [SMALL_STATE(6036)] = 534879,
  [SMALL_STATE(6037)] = 534921,
  [SMALL_STATE(6038)] = 534963,
  [SMALL_STATE(6039)] = 535005,
  [SMALL_STATE(6040)] = 535047,
  [SMALL_STATE(6041)] = 535089,
  [SMALL_STATE(6042)] = 535131,
  [SMALL_STATE(6043)] = 535173,
  [SMALL_STATE(6044)] = 535215,
  [SMALL_STATE(6045)] = 535257,
  [SMALL_STATE(6046)] = 535299,
  [SMALL_STATE(6047)] = 535341,
  [SMALL_STATE(6048)] = 535383,
  [SMALL_STATE(6049)] = 535425,
  [SMALL_STATE(6050)] = 535467,
  [SMALL_STATE(6051)] = 535509,
  [SMALL_STATE(6052)] = 535551,
  [SMALL_STATE(6053)] = 535593,
  [SMALL_STATE(6054)] = 535635,
  [SMALL_STATE(6055)] = 535711,
  [SMALL_STATE(6056)] = 535753,
  [SMALL_STATE(6057)] = 535795,
  [SMALL_STATE(6058)] = 535837,
  [SMALL_STATE(6059)] = 535879,
  [SMALL_STATE(6060)] = 535921,
  [SMALL_STATE(6061)] = 535963,
  [SMALL_STATE(6062)] = 536039,
  [SMALL_STATE(6063)] = 536115,
  [SMALL_STATE(6064)] = 536157,
  [SMALL_STATE(6065)] = 536199,
  [SMALL_STATE(6066)] = 536241,
  [SMALL_STATE(6067)] = 536283,
  [SMALL_STATE(6068)] = 536325,
  [SMALL_STATE(6069)] = 536367,
  [SMALL_STATE(6070)] = 536409,
  [SMALL_STATE(6071)] = 536451,
  [SMALL_STATE(6072)] = 536527,
  [SMALL_STATE(6073)] = 536571,
  [SMALL_STATE(6074)] = 536613,
  [SMALL_STATE(6075)] = 536655,
  [SMALL_STATE(6076)] = 536699,
  [SMALL_STATE(6077)] = 536741,
  [SMALL_STATE(6078)] = 536817,
  [SMALL_STATE(6079)] = 536893,
  [SMALL_STATE(6080)] = 536935,
  [SMALL_STATE(6081)] = 536977,
  [SMALL_STATE(6082)] = 537021,
  [SMALL_STATE(6083)] = 537097,
  [SMALL_STATE(6084)] = 537139,
  [SMALL_STATE(6085)] = 537183,
  [SMALL_STATE(6086)] = 537225,
  [SMALL_STATE(6087)] = 537267,
  [SMALL_STATE(6088)] = 537309,
  [SMALL_STATE(6089)] = 537351,
  [SMALL_STATE(6090)] = 537393,
  [SMALL_STATE(6091)] = 537469,
  [SMALL_STATE(6092)] = 537511,
  [SMALL_STATE(6093)] = 537553,
  [SMALL_STATE(6094)] = 537595,
  [SMALL_STATE(6095)] = 537637,
  [SMALL_STATE(6096)] = 537681,
  [SMALL_STATE(6097)] = 537723,
  [SMALL_STATE(6098)] = 537799,
  [SMALL_STATE(6099)] = 537841,
  [SMALL_STATE(6100)] = 537883,
  [SMALL_STATE(6101)] = 537925,
  [SMALL_STATE(6102)] = 537967,
  [SMALL_STATE(6103)] = 538043,
  [SMALL_STATE(6104)] = 538085,
  [SMALL_STATE(6105)] = 538127,
  [SMALL_STATE(6106)] = 538169,
  [SMALL_STATE(6107)] = 538211,
  [SMALL_STATE(6108)] = 538253,
  [SMALL_STATE(6109)] = 538295,
  [SMALL_STATE(6110)] = 538337,
  [SMALL_STATE(6111)] = 538379,
  [SMALL_STATE(6112)] = 538421,
  [SMALL_STATE(6113)] = 538497,
  [SMALL_STATE(6114)] = 538573,
  [SMALL_STATE(6115)] = 538649,
  [SMALL_STATE(6116)] = 538691,
  [SMALL_STATE(6117)] = 538733,
  [SMALL_STATE(6118)] = 538775,
  [SMALL_STATE(6119)] = 538817,
  [SMALL_STATE(6120)] = 538863,
  [SMALL_STATE(6121)] = 538907,
  [SMALL_STATE(6122)] = 538951,
  [SMALL_STATE(6123)] = 538993,
  [SMALL_STATE(6124)] = 539069,
  [SMALL_STATE(6125)] = 539111,
  [SMALL_STATE(6126)] = 539153,
  [SMALL_STATE(6127)] = 539195,
  [SMALL_STATE(6128)] = 539237,
  [SMALL_STATE(6129)] = 539279,
  [SMALL_STATE(6130)] = 539321,
  [SMALL_STATE(6131)] = 539363,
  [SMALL_STATE(6132)] = 539441,
  [SMALL_STATE(6133)] = 539483,
  [SMALL_STATE(6134)] = 539525,
  [SMALL_STATE(6135)] = 539567,
  [SMALL_STATE(6136)] = 539609,
  [SMALL_STATE(6137)] = 539685,
  [SMALL_STATE(6138)] = 539729,
  [SMALL_STATE(6139)] = 539771,
  [SMALL_STATE(6140)] = 539813,
  [SMALL_STATE(6141)] = 539855,
  [SMALL_STATE(6142)] = 539897,
  [SMALL_STATE(6143)] = 539973,
  [SMALL_STATE(6144)] = 540015,
  [SMALL_STATE(6145)] = 540057,
  [SMALL_STATE(6146)] = 540099,
  [SMALL_STATE(6147)] = 540141,
  [SMALL_STATE(6148)] = 540183,
  [SMALL_STATE(6149)] = 540225,
  [SMALL_STATE(6150)] = 540267,
  [SMALL_STATE(6151)] = 540309,
  [SMALL_STATE(6152)] = 540351,
  [SMALL_STATE(6153)] = 540393,
  [SMALL_STATE(6154)] = 540435,
  [SMALL_STATE(6155)] = 540477,
  [SMALL_STATE(6156)] = 540519,
  [SMALL_STATE(6157)] = 540561,
  [SMALL_STATE(6158)] = 540603,
  [SMALL_STATE(6159)] = 540645,
  [SMALL_STATE(6160)] = 540687,
  [SMALL_STATE(6161)] = 540729,
  [SMALL_STATE(6162)] = 540771,
  [SMALL_STATE(6163)] = 540813,
  [SMALL_STATE(6164)] = 540889,
  [SMALL_STATE(6165)] = 540931,
  [SMALL_STATE(6166)] = 541007,
  [SMALL_STATE(6167)] = 541049,
  [SMALL_STATE(6168)] = 541091,
  [SMALL_STATE(6169)] = 541167,
  [SMALL_STATE(6170)] = 541209,
  [SMALL_STATE(6171)] = 541251,
  [SMALL_STATE(6172)] = 541293,
  [SMALL_STATE(6173)] = 541335,
  [SMALL_STATE(6174)] = 541377,
  [SMALL_STATE(6175)] = 541419,
  [SMALL_STATE(6176)] = 541461,
  [SMALL_STATE(6177)] = 541503,
  [SMALL_STATE(6178)] = 541545,
  [SMALL_STATE(6179)] = 541621,
  [SMALL_STATE(6180)] = 541663,
  [SMALL_STATE(6181)] = 541705,
  [SMALL_STATE(6182)] = 541781,
  [SMALL_STATE(6183)] = 541857,
  [SMALL_STATE(6184)] = 541933,
  [SMALL_STATE(6185)] = 541975,
  [SMALL_STATE(6186)] = 542017,
  [SMALL_STATE(6187)] = 542093,
  [SMALL_STATE(6188)] = 542135,
  [SMALL_STATE(6189)] = 542177,
  [SMALL_STATE(6190)] = 542253,
  [SMALL_STATE(6191)] = 542295,
  [SMALL_STATE(6192)] = 542337,
  [SMALL_STATE(6193)] = 542379,
  [SMALL_STATE(6194)] = 542421,
  [SMALL_STATE(6195)] = 542497,
  [SMALL_STATE(6196)] = 542539,
  [SMALL_STATE(6197)] = 542581,
  [SMALL_STATE(6198)] = 542657,
  [SMALL_STATE(6199)] = 542701,
  [SMALL_STATE(6200)] = 542743,
  [SMALL_STATE(6201)] = 542819,
  [SMALL_STATE(6202)] = 542895,
  [SMALL_STATE(6203)] = 542937,
  [SMALL_STATE(6204)] = 542981,
  [SMALL_STATE(6205)] = 543057,
  [SMALL_STATE(6206)] = 543133,
  [SMALL_STATE(6207)] = 543209,
  [SMALL_STATE(6208)] = 543285,
  [SMALL_STATE(6209)] = 543361,
  [SMALL_STATE(6210)] = 543437,
  [SMALL_STATE(6211)] = 543513,
  [SMALL_STATE(6212)] = 543555,
  [SMALL_STATE(6213)] = 543631,
  [SMALL_STATE(6214)] = 543673,
  [SMALL_STATE(6215)] = 543715,
  [SMALL_STATE(6216)] = 543791,
  [SMALL_STATE(6217)] = 543867,
  [SMALL_STATE(6218)] = 543909,
  [SMALL_STATE(6219)] = 543985,
  [SMALL_STATE(6220)] = 544061,
  [SMALL_STATE(6221)] = 544137,
  [SMALL_STATE(6222)] = 544213,
  [SMALL_STATE(6223)] = 544289,
  [SMALL_STATE(6224)] = 544365,
  [SMALL_STATE(6225)] = 544441,
  [SMALL_STATE(6226)] = 544483,
  [SMALL_STATE(6227)] = 544525,
  [SMALL_STATE(6228)] = 544567,
  [SMALL_STATE(6229)] = 544609,
  [SMALL_STATE(6230)] = 544651,
  [SMALL_STATE(6231)] = 544695,
  [SMALL_STATE(6232)] = 544737,
  [SMALL_STATE(6233)] = 544779,
  [SMALL_STATE(6234)] = 544855,
  [SMALL_STATE(6235)] = 544897,
  [SMALL_STATE(6236)] = 544939,
  [SMALL_STATE(6237)] = 544981,
  [SMALL_STATE(6238)] = 545057,
  [SMALL_STATE(6239)] = 545099,
  [SMALL_STATE(6240)] = 545141,
  [SMALL_STATE(6241)] = 545183,
  [SMALL_STATE(6242)] = 545259,
  [SMALL_STATE(6243)] = 545335,
  [SMALL_STATE(6244)] = 545411,
  [SMALL_STATE(6245)] = 545453,
  [SMALL_STATE(6246)] = 545495,
  [SMALL_STATE(6247)] = 545571,
  [SMALL_STATE(6248)] = 545613,
  [SMALL_STATE(6249)] = 545689,
  [SMALL_STATE(6250)] = 545765,
  [SMALL_STATE(6251)] = 545841,
  [SMALL_STATE(6252)] = 545883,
  [SMALL_STATE(6253)] = 545925,
  [SMALL_STATE(6254)] = 545967,
  [SMALL_STATE(6255)] = 546043,
  [SMALL_STATE(6256)] = 546085,
  [SMALL_STATE(6257)] = 546161,
  [SMALL_STATE(6258)] = 546203,
  [SMALL_STATE(6259)] = 546279,
  [SMALL_STATE(6260)] = 546355,
  [SMALL_STATE(6261)] = 546431,
  [SMALL_STATE(6262)] = 546507,
  [SMALL_STATE(6263)] = 546583,
  [SMALL_STATE(6264)] = 546659,
  [SMALL_STATE(6265)] = 546735,
  [SMALL_STATE(6266)] = 546811,
  [SMALL_STATE(6267)] = 546855,
  [SMALL_STATE(6268)] = 546897,
  [SMALL_STATE(6269)] = 546973,
  [SMALL_STATE(6270)] = 547049,
  [SMALL_STATE(6271)] = 547125,
  [SMALL_STATE(6272)] = 547201,
  [SMALL_STATE(6273)] = 547277,
  [SMALL_STATE(6274)] = 547353,
  [SMALL_STATE(6275)] = 547429,
  [SMALL_STATE(6276)] = 547505,
  [SMALL_STATE(6277)] = 547581,
  [SMALL_STATE(6278)] = 547627,
  [SMALL_STATE(6279)] = 547703,
  [SMALL_STATE(6280)] = 547779,
  [SMALL_STATE(6281)] = 547855,
  [SMALL_STATE(6282)] = 547901,
  [SMALL_STATE(6283)] = 547943,
  [SMALL_STATE(6284)] = 547985,
  [SMALL_STATE(6285)] = 548027,
  [SMALL_STATE(6286)] = 548069,
  [SMALL_STATE(6287)] = 548145,
  [SMALL_STATE(6288)] = 548187,
  [SMALL_STATE(6289)] = 548229,
  [SMALL_STATE(6290)] = 548305,
  [SMALL_STATE(6291)] = 548347,
  [SMALL_STATE(6292)] = 548423,
  [SMALL_STATE(6293)] = 548465,
  [SMALL_STATE(6294)] = 548511,
  [SMALL_STATE(6295)] = 548587,
  [SMALL_STATE(6296)] = 548663,
  [SMALL_STATE(6297)] = 548739,
  [SMALL_STATE(6298)] = 548815,
  [SMALL_STATE(6299)] = 548891,
  [SMALL_STATE(6300)] = 548967,
  [SMALL_STATE(6301)] = 549043,
  [SMALL_STATE(6302)] = 549119,
  [SMALL_STATE(6303)] = 549195,
  [SMALL_STATE(6304)] = 549271,
  [SMALL_STATE(6305)] = 549347,
  [SMALL_STATE(6306)] = 549423,
  [SMALL_STATE(6307)] = 549499,
  [SMALL_STATE(6308)] = 549575,
  [SMALL_STATE(6309)] = 549651,
  [SMALL_STATE(6310)] = 549697,
  [SMALL_STATE(6311)] = 549773,
  [SMALL_STATE(6312)] = 549848,
  [SMALL_STATE(6313)] = 549923,
  [SMALL_STATE(6314)] = 549998,
  [SMALL_STATE(6315)] = 550073,
  [SMALL_STATE(6316)] = 550148,
  [SMALL_STATE(6317)] = 550223,
  [SMALL_STATE(6318)] = 550298,
  [SMALL_STATE(6319)] = 550373,
  [SMALL_STATE(6320)] = 550448,
  [SMALL_STATE(6321)] = 550523,
  [SMALL_STATE(6322)] = 550564,
  [SMALL_STATE(6323)] = 550639,
  [SMALL_STATE(6324)] = 550714,
  [SMALL_STATE(6325)] = 550789,
  [SMALL_STATE(6326)] = 550864,
  [SMALL_STATE(6327)] = 550939,
  [SMALL_STATE(6328)] = 551014,
  [SMALL_STATE(6329)] = 551089,
  [SMALL_STATE(6330)] = 551164,
  [SMALL_STATE(6331)] = 551239,
  [SMALL_STATE(6332)] = 551314,
  [SMALL_STATE(6333)] = 551389,
  [SMALL_STATE(6334)] = 551430,
  [SMALL_STATE(6335)] = 551505,
  [SMALL_STATE(6336)] = 551580,
  [SMALL_STATE(6337)] = 551655,
  [SMALL_STATE(6338)] = 551730,
  [SMALL_STATE(6339)] = 551805,
  [SMALL_STATE(6340)] = 551880,
  [SMALL_STATE(6341)] = 551955,
  [SMALL_STATE(6342)] = 552030,
  [SMALL_STATE(6343)] = 552105,
  [SMALL_STATE(6344)] = 552180,
  [SMALL_STATE(6345)] = 552255,
  [SMALL_STATE(6346)] = 552330,
  [SMALL_STATE(6347)] = 552405,
  [SMALL_STATE(6348)] = 552480,
  [SMALL_STATE(6349)] = 552555,
  [SMALL_STATE(6350)] = 552630,
  [SMALL_STATE(6351)] = 552705,
  [SMALL_STATE(6352)] = 552780,
  [SMALL_STATE(6353)] = 552855,
  [SMALL_STATE(6354)] = 552930,
  [SMALL_STATE(6355)] = 553005,
  [SMALL_STATE(6356)] = 553046,
  [SMALL_STATE(6357)] = 553121,
  [SMALL_STATE(6358)] = 553162,
  [SMALL_STATE(6359)] = 553237,
  [SMALL_STATE(6360)] = 553312,
  [SMALL_STATE(6361)] = 553387,
  [SMALL_STATE(6362)] = 553462,
  [SMALL_STATE(6363)] = 553537,
  [SMALL_STATE(6364)] = 553612,
  [SMALL_STATE(6365)] = 553687,
  [SMALL_STATE(6366)] = 553762,
  [SMALL_STATE(6367)] = 553837,
  [SMALL_STATE(6368)] = 553912,
  [SMALL_STATE(6369)] = 553987,
  [SMALL_STATE(6370)] = 554062,
  [SMALL_STATE(6371)] = 554137,
  [SMALL_STATE(6372)] = 554212,
  [SMALL_STATE(6373)] = 554287,
  [SMALL_STATE(6374)] = 554362,
  [SMALL_STATE(6375)] = 554437,
  [SMALL_STATE(6376)] = 554512,
  [SMALL_STATE(6377)] = 554587,
  [SMALL_STATE(6378)] = 554662,
  [SMALL_STATE(6379)] = 554737,
  [SMALL_STATE(6380)] = 554812,
  [SMALL_STATE(6381)] = 554887,
  [SMALL_STATE(6382)] = 554962,
  [SMALL_STATE(6383)] = 555037,
  [SMALL_STATE(6384)] = 555112,
  [SMALL_STATE(6385)] = 555187,
  [SMALL_STATE(6386)] = 555262,
  [SMALL_STATE(6387)] = 555305,
  [SMALL_STATE(6388)] = 555380,
  [SMALL_STATE(6389)] = 555421,
  [SMALL_STATE(6390)] = 555462,
  [SMALL_STATE(6391)] = 555503,
  [SMALL_STATE(6392)] = 555544,
  [SMALL_STATE(6393)] = 555585,
  [SMALL_STATE(6394)] = 555660,
  [SMALL_STATE(6395)] = 555735,
  [SMALL_STATE(6396)] = 555810,
  [SMALL_STATE(6397)] = 555851,
  [SMALL_STATE(6398)] = 555892,
  [SMALL_STATE(6399)] = 555967,
  [SMALL_STATE(6400)] = 556008,
  [SMALL_STATE(6401)] = 556083,
  [SMALL_STATE(6402)] = 556124,
  [SMALL_STATE(6403)] = 556165,
  [SMALL_STATE(6404)] = 556240,
  [SMALL_STATE(6405)] = 556315,
  [SMALL_STATE(6406)] = 556390,
  [SMALL_STATE(6407)] = 556465,
  [SMALL_STATE(6408)] = 556506,
  [SMALL_STATE(6409)] = 556581,
  [SMALL_STATE(6410)] = 556656,
  [SMALL_STATE(6411)] = 556731,
  [SMALL_STATE(6412)] = 556806,
  [SMALL_STATE(6413)] = 556881,
  [SMALL_STATE(6414)] = 556956,
  [SMALL_STATE(6415)] = 557031,
  [SMALL_STATE(6416)] = 557106,
  [SMALL_STATE(6417)] = 557181,
  [SMALL_STATE(6418)] = 557256,
  [SMALL_STATE(6419)] = 557331,
  [SMALL_STATE(6420)] = 557406,
  [SMALL_STATE(6421)] = 557481,
  [SMALL_STATE(6422)] = 557556,
  [SMALL_STATE(6423)] = 557631,
  [SMALL_STATE(6424)] = 557706,
  [SMALL_STATE(6425)] = 557749,
  [SMALL_STATE(6426)] = 557824,
  [SMALL_STATE(6427)] = 557865,
  [SMALL_STATE(6428)] = 557908,
  [SMALL_STATE(6429)] = 557983,
  [SMALL_STATE(6430)] = 558058,
  [SMALL_STATE(6431)] = 558133,
  [SMALL_STATE(6432)] = 558208,
  [SMALL_STATE(6433)] = 558283,
  [SMALL_STATE(6434)] = 558358,
  [SMALL_STATE(6435)] = 558433,
  [SMALL_STATE(6436)] = 558508,
  [SMALL_STATE(6437)] = 558583,
  [SMALL_STATE(6438)] = 558658,
  [SMALL_STATE(6439)] = 558733,
  [SMALL_STATE(6440)] = 558808,
  [SMALL_STATE(6441)] = 558883,
  [SMALL_STATE(6442)] = 558958,
  [SMALL_STATE(6443)] = 559033,
  [SMALL_STATE(6444)] = 559108,
  [SMALL_STATE(6445)] = 559183,
  [SMALL_STATE(6446)] = 559258,
  [SMALL_STATE(6447)] = 559333,
  [SMALL_STATE(6448)] = 559408,
  [SMALL_STATE(6449)] = 559483,
  [SMALL_STATE(6450)] = 559558,
  [SMALL_STATE(6451)] = 559633,
  [SMALL_STATE(6452)] = 559708,
  [SMALL_STATE(6453)] = 559783,
  [SMALL_STATE(6454)] = 559858,
  [SMALL_STATE(6455)] = 559933,
  [SMALL_STATE(6456)] = 560008,
  [SMALL_STATE(6457)] = 560083,
  [SMALL_STATE(6458)] = 560158,
  [SMALL_STATE(6459)] = 560233,
  [SMALL_STATE(6460)] = 560308,
  [SMALL_STATE(6461)] = 560383,
  [SMALL_STATE(6462)] = 560458,
  [SMALL_STATE(6463)] = 560533,
  [SMALL_STATE(6464)] = 560608,
  [SMALL_STATE(6465)] = 560683,
  [SMALL_STATE(6466)] = 560758,
  [SMALL_STATE(6467)] = 560833,
  [SMALL_STATE(6468)] = 560908,
  [SMALL_STATE(6469)] = 560983,
  [SMALL_STATE(6470)] = 561058,
  [SMALL_STATE(6471)] = 561133,
  [SMALL_STATE(6472)] = 561208,
  [SMALL_STATE(6473)] = 561283,
  [SMALL_STATE(6474)] = 561358,
  [SMALL_STATE(6475)] = 561433,
  [SMALL_STATE(6476)] = 561508,
  [SMALL_STATE(6477)] = 561583,
  [SMALL_STATE(6478)] = 561658,
  [SMALL_STATE(6479)] = 561733,
  [SMALL_STATE(6480)] = 561808,
  [SMALL_STATE(6481)] = 561853,
  [SMALL_STATE(6482)] = 561928,
  [SMALL_STATE(6483)] = 561969,
  [SMALL_STATE(6484)] = 562044,
  [SMALL_STATE(6485)] = 562119,
  [SMALL_STATE(6486)] = 562194,
  [SMALL_STATE(6487)] = 562269,
  [SMALL_STATE(6488)] = 562344,
  [SMALL_STATE(6489)] = 562419,
  [SMALL_STATE(6490)] = 562494,
  [SMALL_STATE(6491)] = 562569,
  [SMALL_STATE(6492)] = 562644,
  [SMALL_STATE(6493)] = 562719,
  [SMALL_STATE(6494)] = 562794,
  [SMALL_STATE(6495)] = 562839,
  [SMALL_STATE(6496)] = 562882,
  [SMALL_STATE(6497)] = 562957,
  [SMALL_STATE(6498)] = 563032,
  [SMALL_STATE(6499)] = 563107,
  [SMALL_STATE(6500)] = 563182,
  [SMALL_STATE(6501)] = 563257,
  [SMALL_STATE(6502)] = 563332,
  [SMALL_STATE(6503)] = 563375,
  [SMALL_STATE(6504)] = 563450,
  [SMALL_STATE(6505)] = 563525,
  [SMALL_STATE(6506)] = 563600,
  [SMALL_STATE(6507)] = 563675,
  [SMALL_STATE(6508)] = 563750,
  [SMALL_STATE(6509)] = 563825,
  [SMALL_STATE(6510)] = 563868,
  [SMALL_STATE(6511)] = 563943,
  [SMALL_STATE(6512)] = 564018,
  [SMALL_STATE(6513)] = 564093,
  [SMALL_STATE(6514)] = 564168,
  [SMALL_STATE(6515)] = 564243,
  [SMALL_STATE(6516)] = 564318,
  [SMALL_STATE(6517)] = 564393,
  [SMALL_STATE(6518)] = 564434,
  [SMALL_STATE(6519)] = 564509,
  [SMALL_STATE(6520)] = 564550,
  [SMALL_STATE(6521)] = 564625,
  [SMALL_STATE(6522)] = 564700,
  [SMALL_STATE(6523)] = 564775,
  [SMALL_STATE(6524)] = 564850,
  [SMALL_STATE(6525)] = 564925,
  [SMALL_STATE(6526)] = 565000,
  [SMALL_STATE(6527)] = 565075,
  [SMALL_STATE(6528)] = 565116,
  [SMALL_STATE(6529)] = 565191,
  [SMALL_STATE(6530)] = 565266,
  [SMALL_STATE(6531)] = 565341,
  [SMALL_STATE(6532)] = 565416,
  [SMALL_STATE(6533)] = 565457,
  [SMALL_STATE(6534)] = 565532,
  [SMALL_STATE(6535)] = 565607,
  [SMALL_STATE(6536)] = 565682,
  [SMALL_STATE(6537)] = 565723,
  [SMALL_STATE(6538)] = 565766,
  [SMALL_STATE(6539)] = 565809,
  [SMALL_STATE(6540)] = 565852,
  [SMALL_STATE(6541)] = 565895,
  [SMALL_STATE(6542)] = 565938,
  [SMALL_STATE(6543)] = 565981,
  [SMALL_STATE(6544)] = 566024,
  [SMALL_STATE(6545)] = 566099,
  [SMALL_STATE(6546)] = 566142,
  [SMALL_STATE(6547)] = 566185,
  [SMALL_STATE(6548)] = 566228,
  [SMALL_STATE(6549)] = 566269,
  [SMALL_STATE(6550)] = 566312,
  [SMALL_STATE(6551)] = 566387,
  [SMALL_STATE(6552)] = 566428,
  [SMALL_STATE(6553)] = 566469,
  [SMALL_STATE(6554)] = 566544,
  [SMALL_STATE(6555)] = 566619,
  [SMALL_STATE(6556)] = 566660,
  [SMALL_STATE(6557)] = 566735,
  [SMALL_STATE(6558)] = 566776,
  [SMALL_STATE(6559)] = 566851,
  [SMALL_STATE(6560)] = 566926,
  [SMALL_STATE(6561)] = 567001,
  [SMALL_STATE(6562)] = 567076,
  [SMALL_STATE(6563)] = 567117,
  [SMALL_STATE(6564)] = 567192,
  [SMALL_STATE(6565)] = 567267,
  [SMALL_STATE(6566)] = 567308,
  [SMALL_STATE(6567)] = 567383,
  [SMALL_STATE(6568)] = 567424,
  [SMALL_STATE(6569)] = 567499,
  [SMALL_STATE(6570)] = 567574,
  [SMALL_STATE(6571)] = 567649,
  [SMALL_STATE(6572)] = 567724,
  [SMALL_STATE(6573)] = 567799,
  [SMALL_STATE(6574)] = 567874,
  [SMALL_STATE(6575)] = 567915,
  [SMALL_STATE(6576)] = 567956,
  [SMALL_STATE(6577)] = 568031,
  [SMALL_STATE(6578)] = 568106,
  [SMALL_STATE(6579)] = 568181,
  [SMALL_STATE(6580)] = 568256,
  [SMALL_STATE(6581)] = 568331,
  [SMALL_STATE(6582)] = 568406,
  [SMALL_STATE(6583)] = 568481,
  [SMALL_STATE(6584)] = 568556,
  [SMALL_STATE(6585)] = 568631,
  [SMALL_STATE(6586)] = 568706,
  [SMALL_STATE(6587)] = 568781,
  [SMALL_STATE(6588)] = 568856,
  [SMALL_STATE(6589)] = 568931,
  [SMALL_STATE(6590)] = 569006,
  [SMALL_STATE(6591)] = 569081,
  [SMALL_STATE(6592)] = 569156,
  [SMALL_STATE(6593)] = 569231,
  [SMALL_STATE(6594)] = 569306,
  [SMALL_STATE(6595)] = 569381,
  [SMALL_STATE(6596)] = 569456,
  [SMALL_STATE(6597)] = 569531,
  [SMALL_STATE(6598)] = 569606,
  [SMALL_STATE(6599)] = 569681,
  [SMALL_STATE(6600)] = 569756,
  [SMALL_STATE(6601)] = 569831,
  [SMALL_STATE(6602)] = 569906,
  [SMALL_STATE(6603)] = 569981,
  [SMALL_STATE(6604)] = 570056,
  [SMALL_STATE(6605)] = 570131,
  [SMALL_STATE(6606)] = 570206,
  [SMALL_STATE(6607)] = 570281,
  [SMALL_STATE(6608)] = 570356,
  [SMALL_STATE(6609)] = 570431,
  [SMALL_STATE(6610)] = 570506,
  [SMALL_STATE(6611)] = 570581,
  [SMALL_STATE(6612)] = 570656,
  [SMALL_STATE(6613)] = 570731,
  [SMALL_STATE(6614)] = 570806,
  [SMALL_STATE(6615)] = 570881,
  [SMALL_STATE(6616)] = 570956,
  [SMALL_STATE(6617)] = 571031,
  [SMALL_STATE(6618)] = 571106,
  [SMALL_STATE(6619)] = 571181,
  [SMALL_STATE(6620)] = 571256,
  [SMALL_STATE(6621)] = 571331,
  [SMALL_STATE(6622)] = 571406,
  [SMALL_STATE(6623)] = 571451,
  [SMALL_STATE(6624)] = 571526,
  [SMALL_STATE(6625)] = 571601,
  [SMALL_STATE(6626)] = 571676,
  [SMALL_STATE(6627)] = 571751,
  [SMALL_STATE(6628)] = 571826,
  [SMALL_STATE(6629)] = 571901,
  [SMALL_STATE(6630)] = 571976,
  [SMALL_STATE(6631)] = 572051,
  [SMALL_STATE(6632)] = 572126,
  [SMALL_STATE(6633)] = 572201,
  [SMALL_STATE(6634)] = 572276,
  [SMALL_STATE(6635)] = 572351,
  [SMALL_STATE(6636)] = 572426,
  [SMALL_STATE(6637)] = 572501,
  [SMALL_STATE(6638)] = 572576,
  [SMALL_STATE(6639)] = 572651,
  [SMALL_STATE(6640)] = 572726,
  [SMALL_STATE(6641)] = 572801,
  [SMALL_STATE(6642)] = 572876,
  [SMALL_STATE(6643)] = 572951,
  [SMALL_STATE(6644)] = 573026,
  [SMALL_STATE(6645)] = 573101,
  [SMALL_STATE(6646)] = 573176,
  [SMALL_STATE(6647)] = 573251,
  [SMALL_STATE(6648)] = 573326,
  [SMALL_STATE(6649)] = 573401,
  [SMALL_STATE(6650)] = 573476,
  [SMALL_STATE(6651)] = 573551,
  [SMALL_STATE(6652)] = 573626,
  [SMALL_STATE(6653)] = 573701,
  [SMALL_STATE(6654)] = 573776,
  [SMALL_STATE(6655)] = 573851,
  [SMALL_STATE(6656)] = 573926,
  [SMALL_STATE(6657)] = 574001,
  [SMALL_STATE(6658)] = 574076,
  [SMALL_STATE(6659)] = 574151,
  [SMALL_STATE(6660)] = 574226,
  [SMALL_STATE(6661)] = 574301,
  [SMALL_STATE(6662)] = 574376,
  [SMALL_STATE(6663)] = 574451,
  [SMALL_STATE(6664)] = 574526,
  [SMALL_STATE(6665)] = 574601,
  [SMALL_STATE(6666)] = 574676,
  [SMALL_STATE(6667)] = 574751,
  [SMALL_STATE(6668)] = 574792,
  [SMALL_STATE(6669)] = 574867,
  [SMALL_STATE(6670)] = 574942,
  [SMALL_STATE(6671)] = 574983,
  [SMALL_STATE(6672)] = 575058,
  [SMALL_STATE(6673)] = 575133,
  [SMALL_STATE(6674)] = 575208,
  [SMALL_STATE(6675)] = 575283,
  [SMALL_STATE(6676)] = 575358,
  [SMALL_STATE(6677)] = 575433,
  [SMALL_STATE(6678)] = 575508,
  [SMALL_STATE(6679)] = 575583,
  [SMALL_STATE(6680)] = 575658,
  [SMALL_STATE(6681)] = 575733,
  [SMALL_STATE(6682)] = 575808,
  [SMALL_STATE(6683)] = 575883,
  [SMALL_STATE(6684)] = 575958,
  [SMALL_STATE(6685)] = 576033,
  [SMALL_STATE(6686)] = 576108,
  [SMALL_STATE(6687)] = 576183,
  [SMALL_STATE(6688)] = 576258,
  [SMALL_STATE(6689)] = 576333,
  [SMALL_STATE(6690)] = 576408,
  [SMALL_STATE(6691)] = 576483,
  [SMALL_STATE(6692)] = 576558,
  [SMALL_STATE(6693)] = 576633,
  [SMALL_STATE(6694)] = 576708,
  [SMALL_STATE(6695)] = 576783,
  [SMALL_STATE(6696)] = 576858,
  [SMALL_STATE(6697)] = 576933,
  [SMALL_STATE(6698)] = 577008,
  [SMALL_STATE(6699)] = 577083,
  [SMALL_STATE(6700)] = 577158,
  [SMALL_STATE(6701)] = 577233,
  [SMALL_STATE(6702)] = 577308,
  [SMALL_STATE(6703)] = 577383,
  [SMALL_STATE(6704)] = 577458,
  [SMALL_STATE(6705)] = 577533,
  [SMALL_STATE(6706)] = 577608,
  [SMALL_STATE(6707)] = 577683,
  [SMALL_STATE(6708)] = 577758,
  [SMALL_STATE(6709)] = 577833,
  [SMALL_STATE(6710)] = 577908,
  [SMALL_STATE(6711)] = 577949,
  [SMALL_STATE(6712)] = 578024,
  [SMALL_STATE(6713)] = 578099,
  [SMALL_STATE(6714)] = 578174,
  [SMALL_STATE(6715)] = 578215,
  [SMALL_STATE(6716)] = 578256,
  [SMALL_STATE(6717)] = 578297,
  [SMALL_STATE(6718)] = 578372,
  [SMALL_STATE(6719)] = 578413,
  [SMALL_STATE(6720)] = 578488,
  [SMALL_STATE(6721)] = 578563,
  [SMALL_STATE(6722)] = 578638,
  [SMALL_STATE(6723)] = 578713,
  [SMALL_STATE(6724)] = 578788,
  [SMALL_STATE(6725)] = 578863,
  [SMALL_STATE(6726)] = 578938,
  [SMALL_STATE(6727)] = 579013,
  [SMALL_STATE(6728)] = 579088,
  [SMALL_STATE(6729)] = 579163,
  [SMALL_STATE(6730)] = 579238,
  [SMALL_STATE(6731)] = 579313,
  [SMALL_STATE(6732)] = 579388,
  [SMALL_STATE(6733)] = 579463,
  [SMALL_STATE(6734)] = 579538,
  [SMALL_STATE(6735)] = 579579,
  [SMALL_STATE(6736)] = 579654,
  [SMALL_STATE(6737)] = 579695,
  [SMALL_STATE(6738)] = 579770,
  [SMALL_STATE(6739)] = 579845,
  [SMALL_STATE(6740)] = 579920,
  [SMALL_STATE(6741)] = 579995,
  [SMALL_STATE(6742)] = 580070,
  [SMALL_STATE(6743)] = 580145,
  [SMALL_STATE(6744)] = 580220,
  [SMALL_STATE(6745)] = 580295,
  [SMALL_STATE(6746)] = 580336,
  [SMALL_STATE(6747)] = 580377,
  [SMALL_STATE(6748)] = 580452,
  [SMALL_STATE(6749)] = 580527,
  [SMALL_STATE(6750)] = 580568,
  [SMALL_STATE(6751)] = 580643,
  [SMALL_STATE(6752)] = 580718,
  [SMALL_STATE(6753)] = 580759,
  [SMALL_STATE(6754)] = 580834,
  [SMALL_STATE(6755)] = 580909,
  [SMALL_STATE(6756)] = 580984,
  [SMALL_STATE(6757)] = 581025,
  [SMALL_STATE(6758)] = 581100,
  [SMALL_STATE(6759)] = 581175,
  [SMALL_STATE(6760)] = 581250,
  [SMALL_STATE(6761)] = 581325,
  [SMALL_STATE(6762)] = 581400,
  [SMALL_STATE(6763)] = 581475,
  [SMALL_STATE(6764)] = 581550,
  [SMALL_STATE(6765)] = 581625,
  [SMALL_STATE(6766)] = 581700,
  [SMALL_STATE(6767)] = 581741,
  [SMALL_STATE(6768)] = 581816,
  [SMALL_STATE(6769)] = 581891,
  [SMALL_STATE(6770)] = 581966,
  [SMALL_STATE(6771)] = 582041,
  [SMALL_STATE(6772)] = 582116,
  [SMALL_STATE(6773)] = 582191,
  [SMALL_STATE(6774)] = 582266,
  [SMALL_STATE(6775)] = 582341,
  [SMALL_STATE(6776)] = 582416,
  [SMALL_STATE(6777)] = 582491,
  [SMALL_STATE(6778)] = 582566,
  [SMALL_STATE(6779)] = 582641,
  [SMALL_STATE(6780)] = 582716,
  [SMALL_STATE(6781)] = 582791,
  [SMALL_STATE(6782)] = 582866,
  [SMALL_STATE(6783)] = 582941,
  [SMALL_STATE(6784)] = 583016,
  [SMALL_STATE(6785)] = 583091,
  [SMALL_STATE(6786)] = 583166,
  [SMALL_STATE(6787)] = 583241,
  [SMALL_STATE(6788)] = 583316,
  [SMALL_STATE(6789)] = 583391,
  [SMALL_STATE(6790)] = 583466,
  [SMALL_STATE(6791)] = 583541,
  [SMALL_STATE(6792)] = 583581,
  [SMALL_STATE(6793)] = 583621,
  [SMALL_STATE(6794)] = 583663,
  [SMALL_STATE(6795)] = 583705,
  [SMALL_STATE(6796)] = 583747,
  [SMALL_STATE(6797)] = 583789,
  [SMALL_STATE(6798)] = 583829,
  [SMALL_STATE(6799)] = 583871,
  [SMALL_STATE(6800)] = 583913,
  [SMALL_STATE(6801)] = 583953,
  [SMALL_STATE(6802)] = 583993,
  [SMALL_STATE(6803)] = 584037,
  [SMALL_STATE(6804)] = 584079,
  [SMALL_STATE(6805)] = 584121,
  [SMALL_STATE(6806)] = 584163,
  [SMALL_STATE(6807)] = 584205,
  [SMALL_STATE(6808)] = 584247,
  [SMALL_STATE(6809)] = 584289,
  [SMALL_STATE(6810)] = 584331,
  [SMALL_STATE(6811)] = 584373,
  [SMALL_STATE(6812)] = 584415,
  [SMALL_STATE(6813)] = 584457,
  [SMALL_STATE(6814)] = 584499,
  [SMALL_STATE(6815)] = 584541,
  [SMALL_STATE(6816)] = 584583,
  [SMALL_STATE(6817)] = 584625,
  [SMALL_STATE(6818)] = 584667,
  [SMALL_STATE(6819)] = 584709,
  [SMALL_STATE(6820)] = 584751,
  [SMALL_STATE(6821)] = 584793,
  [SMALL_STATE(6822)] = 584835,
  [SMALL_STATE(6823)] = 584877,
  [SMALL_STATE(6824)] = 584919,
  [SMALL_STATE(6825)] = 584959,
  [SMALL_STATE(6826)] = 585001,
  [SMALL_STATE(6827)] = 585041,
  [SMALL_STATE(6828)] = 585083,
  [SMALL_STATE(6829)] = 585123,
  [SMALL_STATE(6830)] = 585163,
  [SMALL_STATE(6831)] = 585203,
  [SMALL_STATE(6832)] = 585243,
  [SMALL_STATE(6833)] = 585283,
  [SMALL_STATE(6834)] = 585325,
  [SMALL_STATE(6835)] = 585365,
  [SMALL_STATE(6836)] = 585405,
  [SMALL_STATE(6837)] = 585447,
  [SMALL_STATE(6838)] = 585491,
  [SMALL_STATE(6839)] = 585535,
  [SMALL_STATE(6840)] = 585575,
  [SMALL_STATE(6841)] = 585617,
  [SMALL_STATE(6842)] = 585659,
  [SMALL_STATE(6843)] = 585699,
  [SMALL_STATE(6844)] = 585741,
  [SMALL_STATE(6845)] = 585783,
  [SMALL_STATE(6846)] = 585825,
  [SMALL_STATE(6847)] = 585867,
  [SMALL_STATE(6848)] = 585909,
  [SMALL_STATE(6849)] = 585953,
  [SMALL_STATE(6850)] = 585995,
  [SMALL_STATE(6851)] = 586037,
  [SMALL_STATE(6852)] = 586079,
  [SMALL_STATE(6853)] = 586121,
  [SMALL_STATE(6854)] = 586163,
  [SMALL_STATE(6855)] = 586203,
  [SMALL_STATE(6856)] = 586243,
  [SMALL_STATE(6857)] = 586314,
  [SMALL_STATE(6858)] = 586385,
  [SMALL_STATE(6859)] = 586456,
  [SMALL_STATE(6860)] = 586497,
  [SMALL_STATE(6861)] = 586568,
  [SMALL_STATE(6862)] = 586639,
  [SMALL_STATE(6863)] = 586680,
  [SMALL_STATE(6864)] = 586751,
  [SMALL_STATE(6865)] = 586822,
  [SMALL_STATE(6866)] = 586863,
  [SMALL_STATE(6867)] = 586904,
  [SMALL_STATE(6868)] = 586975,
  [SMALL_STATE(6869)] = 587046,
  [SMALL_STATE(6870)] = 587117,
  [SMALL_STATE(6871)] = 587188,
  [SMALL_STATE(6872)] = 587259,
  [SMALL_STATE(6873)] = 587330,
  [SMALL_STATE(6874)] = 587401,
  [SMALL_STATE(6875)] = 587472,
  [SMALL_STATE(6876)] = 587543,
  [SMALL_STATE(6877)] = 587614,
  [SMALL_STATE(6878)] = 587685,
  [SMALL_STATE(6879)] = 587726,
  [SMALL_STATE(6880)] = 587797,
  [SMALL_STATE(6881)] = 587868,
  [SMALL_STATE(6882)] = 587939,
  [SMALL_STATE(6883)] = 588010,
  [SMALL_STATE(6884)] = 588081,
  [SMALL_STATE(6885)] = 588152,
  [SMALL_STATE(6886)] = 588223,
  [SMALL_STATE(6887)] = 588294,
  [SMALL_STATE(6888)] = 588335,
  [SMALL_STATE(6889)] = 588406,
  [SMALL_STATE(6890)] = 588477,
  [SMALL_STATE(6891)] = 588548,
  [SMALL_STATE(6892)] = 588619,
  [SMALL_STATE(6893)] = 588690,
  [SMALL_STATE(6894)] = 588761,
  [SMALL_STATE(6895)] = 588832,
  [SMALL_STATE(6896)] = 588873,
  [SMALL_STATE(6897)] = 588944,
  [SMALL_STATE(6898)] = 589015,
  [SMALL_STATE(6899)] = 589086,
  [SMALL_STATE(6900)] = 589125,
  [SMALL_STATE(6901)] = 589196,
  [SMALL_STATE(6902)] = 589237,
  [SMALL_STATE(6903)] = 589278,
  [SMALL_STATE(6904)] = 589319,
  [SMALL_STATE(6905)] = 589358,
  [SMALL_STATE(6906)] = 589399,
  [SMALL_STATE(6907)] = 589470,
  [SMALL_STATE(6908)] = 589511,
  [SMALL_STATE(6909)] = 589582,
  [SMALL_STATE(6910)] = 589623,
  [SMALL_STATE(6911)] = 589694,
  [SMALL_STATE(6912)] = 589765,
  [SMALL_STATE(6913)] = 589836,
  [SMALL_STATE(6914)] = 589907,
  [SMALL_STATE(6915)] = 589978,
  [SMALL_STATE(6916)] = 590049,
  [SMALL_STATE(6917)] = 590120,
  [SMALL_STATE(6918)] = 590161,
  [SMALL_STATE(6919)] = 590232,
  [SMALL_STATE(6920)] = 590303,
  [SMALL_STATE(6921)] = 590344,
  [SMALL_STATE(6922)] = 590415,
  [SMALL_STATE(6923)] = 590456,
  [SMALL_STATE(6924)] = 590527,
  [SMALL_STATE(6925)] = 590598,
  [SMALL_STATE(6926)] = 590639,
  [SMALL_STATE(6927)] = 590680,
  [SMALL_STATE(6928)] = 590751,
  [SMALL_STATE(6929)] = 590822,
  [SMALL_STATE(6930)] = 590893,
  [SMALL_STATE(6931)] = 590934,
  [SMALL_STATE(6932)] = 590975,
  [SMALL_STATE(6933)] = 591046,
  [SMALL_STATE(6934)] = 591087,
  [SMALL_STATE(6935)] = 591158,
  [SMALL_STATE(6936)] = 591229,
  [SMALL_STATE(6937)] = 591270,
  [SMALL_STATE(6938)] = 591311,
  [SMALL_STATE(6939)] = 591382,
  [SMALL_STATE(6940)] = 591423,
  [SMALL_STATE(6941)] = 591494,
  [SMALL_STATE(6942)] = 591565,
  [SMALL_STATE(6943)] = 591606,
  [SMALL_STATE(6944)] = 591647,
  [SMALL_STATE(6945)] = 591690,
  [SMALL_STATE(6946)] = 591731,
  [SMALL_STATE(6947)] = 591802,
  [SMALL_STATE(6948)] = 591873,
  [SMALL_STATE(6949)] = 591944,
  [SMALL_STATE(6950)] = 592015,
  [SMALL_STATE(6951)] = 592086,
  [SMALL_STATE(6952)] = 592127,
  [SMALL_STATE(6953)] = 592198,
  [SMALL_STATE(6954)] = 592269,
  [SMALL_STATE(6955)] = 592310,
  [SMALL_STATE(6956)] = 592351,
  [SMALL_STATE(6957)] = 592422,
  [SMALL_STATE(6958)] = 592493,
  [SMALL_STATE(6959)] = 592564,
  [SMALL_STATE(6960)] = 592635,
  [SMALL_STATE(6961)] = 592706,
  [SMALL_STATE(6962)] = 592777,
  [SMALL_STATE(6963)] = 592848,
  [SMALL_STATE(6964)] = 592919,
  [SMALL_STATE(6965)] = 592990,
  [SMALL_STATE(6966)] = 593061,
  [SMALL_STATE(6967)] = 593132,
  [SMALL_STATE(6968)] = 593203,
  [SMALL_STATE(6969)] = 593274,
  [SMALL_STATE(6970)] = 593345,
  [SMALL_STATE(6971)] = 593416,
  [SMALL_STATE(6972)] = 593487,
  [SMALL_STATE(6973)] = 593558,
  [SMALL_STATE(6974)] = 593629,
  [SMALL_STATE(6975)] = 593700,
  [SMALL_STATE(6976)] = 593771,
  [SMALL_STATE(6977)] = 593842,
  [SMALL_STATE(6978)] = 593913,
  [SMALL_STATE(6979)] = 593984,
  [SMALL_STATE(6980)] = 594055,
  [SMALL_STATE(6981)] = 594096,
  [SMALL_STATE(6982)] = 594167,
  [SMALL_STATE(6983)] = 594238,
  [SMALL_STATE(6984)] = 594309,
  [SMALL_STATE(6985)] = 594380,
  [SMALL_STATE(6986)] = 594451,
  [SMALL_STATE(6987)] = 594522,
  [SMALL_STATE(6988)] = 594593,
  [SMALL_STATE(6989)] = 594664,
  [SMALL_STATE(6990)] = 594735,
  [SMALL_STATE(6991)] = 594806,
  [SMALL_STATE(6992)] = 594877,
  [SMALL_STATE(6993)] = 594948,
  [SMALL_STATE(6994)] = 595019,
  [SMALL_STATE(6995)] = 595090,
  [SMALL_STATE(6996)] = 595161,
  [SMALL_STATE(6997)] = 595202,
  [SMALL_STATE(6998)] = 595243,
  [SMALL_STATE(6999)] = 595284,
  [SMALL_STATE(7000)] = 595355,
  [SMALL_STATE(7001)] = 595426,
  [SMALL_STATE(7002)] = 595497,
  [SMALL_STATE(7003)] = 595568,
  [SMALL_STATE(7004)] = 595639,
  [SMALL_STATE(7005)] = 595710,
  [SMALL_STATE(7006)] = 595781,
  [SMALL_STATE(7007)] = 595852,
  [SMALL_STATE(7008)] = 595923,
  [SMALL_STATE(7009)] = 595994,
  [SMALL_STATE(7010)] = 596035,
  [SMALL_STATE(7011)] = 596076,
  [SMALL_STATE(7012)] = 596147,
  [SMALL_STATE(7013)] = 596218,
  [SMALL_STATE(7014)] = 596289,
  [SMALL_STATE(7015)] = 596360,
  [SMALL_STATE(7016)] = 596431,
  [SMALL_STATE(7017)] = 596502,
  [SMALL_STATE(7018)] = 596573,
  [SMALL_STATE(7019)] = 596644,
  [SMALL_STATE(7020)] = 596715,
  [SMALL_STATE(7021)] = 596786,
  [SMALL_STATE(7022)] = 596857,
  [SMALL_STATE(7023)] = 596928,
  [SMALL_STATE(7024)] = 596999,
  [SMALL_STATE(7025)] = 597070,
  [SMALL_STATE(7026)] = 597141,
  [SMALL_STATE(7027)] = 597212,
  [SMALL_STATE(7028)] = 597283,
  [SMALL_STATE(7029)] = 597354,
  [SMALL_STATE(7030)] = 597425,
  [SMALL_STATE(7031)] = 597496,
  [SMALL_STATE(7032)] = 597567,
  [SMALL_STATE(7033)] = 597638,
  [SMALL_STATE(7034)] = 597679,
  [SMALL_STATE(7035)] = 597750,
  [SMALL_STATE(7036)] = 597821,
  [SMALL_STATE(7037)] = 597892,
  [SMALL_STATE(7038)] = 597963,
  [SMALL_STATE(7039)] = 598034,
  [SMALL_STATE(7040)] = 598105,
  [SMALL_STATE(7041)] = 598176,
  [SMALL_STATE(7042)] = 598217,
  [SMALL_STATE(7043)] = 598288,
  [SMALL_STATE(7044)] = 598359,
  [SMALL_STATE(7045)] = 598430,
  [SMALL_STATE(7046)] = 598501,
  [SMALL_STATE(7047)] = 598572,
  [SMALL_STATE(7048)] = 598643,
  [SMALL_STATE(7049)] = 598686,
  [SMALL_STATE(7050)] = 598757,
  [SMALL_STATE(7051)] = 598828,
  [SMALL_STATE(7052)] = 598867,
  [SMALL_STATE(7053)] = 598910,
  [SMALL_STATE(7054)] = 598981,
  [SMALL_STATE(7055)] = 599022,
  [SMALL_STATE(7056)] = 599093,
  [SMALL_STATE(7057)] = 599164,
  [SMALL_STATE(7058)] = 599235,
  [SMALL_STATE(7059)] = 599306,
  [SMALL_STATE(7060)] = 599377,
  [SMALL_STATE(7061)] = 599448,
  [SMALL_STATE(7062)] = 599519,
  [SMALL_STATE(7063)] = 599590,
  [SMALL_STATE(7064)] = 599661,
  [SMALL_STATE(7065)] = 599732,
  [SMALL_STATE(7066)] = 599803,
  [SMALL_STATE(7067)] = 599844,
  [SMALL_STATE(7068)] = 599915,
  [SMALL_STATE(7069)] = 599986,
  [SMALL_STATE(7070)] = 600027,
  [SMALL_STATE(7071)] = 600068,
  [SMALL_STATE(7072)] = 600109,
  [SMALL_STATE(7073)] = 600150,
  [SMALL_STATE(7074)] = 600191,
  [SMALL_STATE(7075)] = 600262,
  [SMALL_STATE(7076)] = 600333,
  [SMALL_STATE(7077)] = 600404,
  [SMALL_STATE(7078)] = 600445,
  [SMALL_STATE(7079)] = 600486,
  [SMALL_STATE(7080)] = 600527,
  [SMALL_STATE(7081)] = 600568,
  [SMALL_STATE(7082)] = 600609,
  [SMALL_STATE(7083)] = 600650,
  [SMALL_STATE(7084)] = 600691,
  [SMALL_STATE(7085)] = 600762,
  [SMALL_STATE(7086)] = 600803,
  [SMALL_STATE(7087)] = 600874,
  [SMALL_STATE(7088)] = 600945,
  [SMALL_STATE(7089)] = 601016,
  [SMALL_STATE(7090)] = 601087,
  [SMALL_STATE(7091)] = 601158,
  [SMALL_STATE(7092)] = 601229,
  [SMALL_STATE(7093)] = 601300,
  [SMALL_STATE(7094)] = 601371,
  [SMALL_STATE(7095)] = 601410,
  [SMALL_STATE(7096)] = 601481,
  [SMALL_STATE(7097)] = 601552,
  [SMALL_STATE(7098)] = 601595,
  [SMALL_STATE(7099)] = 601666,
  [SMALL_STATE(7100)] = 601705,
  [SMALL_STATE(7101)] = 601744,
  [SMALL_STATE(7102)] = 601783,
  [SMALL_STATE(7103)] = 601822,
  [SMALL_STATE(7104)] = 601893,
  [SMALL_STATE(7105)] = 601934,
  [SMALL_STATE(7106)] = 601973,
  [SMALL_STATE(7107)] = 602014,
  [SMALL_STATE(7108)] = 602053,
  [SMALL_STATE(7109)] = 602092,
  [SMALL_STATE(7110)] = 602163,
  [SMALL_STATE(7111)] = 602234,
  [SMALL_STATE(7112)] = 602275,
  [SMALL_STATE(7113)] = 602346,
  [SMALL_STATE(7114)] = 602385,
  [SMALL_STATE(7115)] = 602425,
  [SMALL_STATE(7116)] = 602467,
  [SMALL_STATE(7117)] = 602507,
  [SMALL_STATE(7118)] = 602547,
  [SMALL_STATE(7119)] = 602589,
  [SMALL_STATE(7120)] = 602629,
  [SMALL_STATE(7121)] = 602669,
  [SMALL_STATE(7122)] = 602709,
  [SMALL_STATE(7123)] = 602749,
  [SMALL_STATE(7124)] = 602789,
  [SMALL_STATE(7125)] = 602829,
  [SMALL_STATE(7126)] = 602869,
  [SMALL_STATE(7127)] = 602909,
  [SMALL_STATE(7128)] = 602949,
  [SMALL_STATE(7129)] = 602989,
  [SMALL_STATE(7130)] = 603029,
  [SMALL_STATE(7131)] = 603069,
  [SMALL_STATE(7132)] = 603109,
  [SMALL_STATE(7133)] = 603151,
  [SMALL_STATE(7134)] = 603193,
  [SMALL_STATE(7135)] = 603233,
  [SMALL_STATE(7136)] = 603273,
  [SMALL_STATE(7137)] = 603313,
  [SMALL_STATE(7138)] = 603353,
  [SMALL_STATE(7139)] = 603395,
  [SMALL_STATE(7140)] = 603435,
  [SMALL_STATE(7141)] = 603475,
  [SMALL_STATE(7142)] = 603515,
  [SMALL_STATE(7143)] = 603557,
  [SMALL_STATE(7144)] = 603599,
  [SMALL_STATE(7145)] = 603639,
  [SMALL_STATE(7146)] = 603679,
  [SMALL_STATE(7147)] = 603719,
  [SMALL_STATE(7148)] = 603759,
  [SMALL_STATE(7149)] = 603799,
  [SMALL_STATE(7150)] = 603839,
  [SMALL_STATE(7151)] = 603879,
  [SMALL_STATE(7152)] = 603919,
  [SMALL_STATE(7153)] = 603959,
  [SMALL_STATE(7154)] = 603999,
  [SMALL_STATE(7155)] = 604039,
  [SMALL_STATE(7156)] = 604079,
  [SMALL_STATE(7157)] = 604119,
  [SMALL_STATE(7158)] = 604159,
  [SMALL_STATE(7159)] = 604199,
  [SMALL_STATE(7160)] = 604239,
  [SMALL_STATE(7161)] = 604281,
  [SMALL_STATE(7162)] = 604321,
  [SMALL_STATE(7163)] = 604361,
  [SMALL_STATE(7164)] = 604401,
  [SMALL_STATE(7165)] = 604441,
  [SMALL_STATE(7166)] = 604481,
  [SMALL_STATE(7167)] = 604521,
  [SMALL_STATE(7168)] = 604561,
  [SMALL_STATE(7169)] = 604601,
  [SMALL_STATE(7170)] = 604641,
  [SMALL_STATE(7171)] = 604681,
  [SMALL_STATE(7172)] = 604721,
  [SMALL_STATE(7173)] = 604761,
  [SMALL_STATE(7174)] = 604801,
  [SMALL_STATE(7175)] = 604841,
  [SMALL_STATE(7176)] = 604881,
  [SMALL_STATE(7177)] = 604921,
  [SMALL_STATE(7178)] = 604961,
  [SMALL_STATE(7179)] = 605000,
  [SMALL_STATE(7180)] = 605039,
  [SMALL_STATE(7181)] = 605078,
  [SMALL_STATE(7182)] = 605117,
  [SMALL_STATE(7183)] = 605156,
  [SMALL_STATE(7184)] = 605195,
  [SMALL_STATE(7185)] = 605234,
  [SMALL_STATE(7186)] = 605273,
  [SMALL_STATE(7187)] = 605312,
  [SMALL_STATE(7188)] = 605351,
  [SMALL_STATE(7189)] = 605390,
  [SMALL_STATE(7190)] = 605429,
  [SMALL_STATE(7191)] = 605468,
  [SMALL_STATE(7192)] = 605507,
  [SMALL_STATE(7193)] = 605546,
  [SMALL_STATE(7194)] = 605585,
  [SMALL_STATE(7195)] = 605624,
  [SMALL_STATE(7196)] = 605663,
  [SMALL_STATE(7197)] = 605702,
  [SMALL_STATE(7198)] = 605741,
  [SMALL_STATE(7199)] = 605780,
  [SMALL_STATE(7200)] = 605819,
  [SMALL_STATE(7201)] = 605858,
  [SMALL_STATE(7202)] = 605897,
  [SMALL_STATE(7203)] = 605936,
  [SMALL_STATE(7204)] = 605975,
  [SMALL_STATE(7205)] = 606014,
  [SMALL_STATE(7206)] = 606053,
  [SMALL_STATE(7207)] = 606092,
  [SMALL_STATE(7208)] = 606133,
  [SMALL_STATE(7209)] = 606172,
  [SMALL_STATE(7210)] = 606211,
  [SMALL_STATE(7211)] = 606252,
  [SMALL_STATE(7212)] = 606291,
  [SMALL_STATE(7213)] = 606330,
  [SMALL_STATE(7214)] = 606369,
  [SMALL_STATE(7215)] = 606408,
  [SMALL_STATE(7216)] = 606447,
  [SMALL_STATE(7217)] = 606486,
  [SMALL_STATE(7218)] = 606525,
  [SMALL_STATE(7219)] = 606564,
  [SMALL_STATE(7220)] = 606603,
  [SMALL_STATE(7221)] = 606642,
  [SMALL_STATE(7222)] = 606681,
  [SMALL_STATE(7223)] = 606720,
  [SMALL_STATE(7224)] = 606761,
  [SMALL_STATE(7225)] = 606800,
  [SMALL_STATE(7226)] = 606839,
  [SMALL_STATE(7227)] = 606878,
  [SMALL_STATE(7228)] = 606919,
  [SMALL_STATE(7229)] = 606958,
  [SMALL_STATE(7230)] = 606997,
  [SMALL_STATE(7231)] = 607038,
  [SMALL_STATE(7232)] = 607077,
  [SMALL_STATE(7233)] = 607116,
  [SMALL_STATE(7234)] = 607155,
  [SMALL_STATE(7235)] = 607194,
  [SMALL_STATE(7236)] = 607235,
  [SMALL_STATE(7237)] = 607274,
  [SMALL_STATE(7238)] = 607313,
  [SMALL_STATE(7239)] = 607352,
  [SMALL_STATE(7240)] = 607391,
  [SMALL_STATE(7241)] = 607430,
  [SMALL_STATE(7242)] = 607469,
  [SMALL_STATE(7243)] = 607508,
  [SMALL_STATE(7244)] = 607547,
  [SMALL_STATE(7245)] = 607588,
  [SMALL_STATE(7246)] = 607627,
  [SMALL_STATE(7247)] = 607666,
  [SMALL_STATE(7248)] = 607705,
  [SMALL_STATE(7249)] = 607744,
  [SMALL_STATE(7250)] = 607783,
  [SMALL_STATE(7251)] = 607824,
  [SMALL_STATE(7252)] = 607863,
  [SMALL_STATE(7253)] = 607902,
  [SMALL_STATE(7254)] = 607941,
  [SMALL_STATE(7255)] = 607980,
  [SMALL_STATE(7256)] = 608019,
  [SMALL_STATE(7257)] = 608058,
  [SMALL_STATE(7258)] = 608097,
  [SMALL_STATE(7259)] = 608136,
  [SMALL_STATE(7260)] = 608177,
  [SMALL_STATE(7261)] = 608216,
  [SMALL_STATE(7262)] = 608255,
  [SMALL_STATE(7263)] = 608294,
  [SMALL_STATE(7264)] = 608335,
  [SMALL_STATE(7265)] = 608374,
  [SMALL_STATE(7266)] = 608413,
  [SMALL_STATE(7267)] = 608452,
  [SMALL_STATE(7268)] = 608491,
  [SMALL_STATE(7269)] = 608530,
  [SMALL_STATE(7270)] = 608569,
  [SMALL_STATE(7271)] = 608608,
  [SMALL_STATE(7272)] = 608647,
  [SMALL_STATE(7273)] = 608686,
  [SMALL_STATE(7274)] = 608725,
  [SMALL_STATE(7275)] = 608766,
  [SMALL_STATE(7276)] = 608805,
  [SMALL_STATE(7277)] = 608844,
  [SMALL_STATE(7278)] = 608883,
  [SMALL_STATE(7279)] = 608922,
  [SMALL_STATE(7280)] = 608961,
  [SMALL_STATE(7281)] = 609000,
  [SMALL_STATE(7282)] = 609039,
  [SMALL_STATE(7283)] = 609078,
  [SMALL_STATE(7284)] = 609117,
  [SMALL_STATE(7285)] = 609156,
  [SMALL_STATE(7286)] = 609195,
  [SMALL_STATE(7287)] = 609234,
  [SMALL_STATE(7288)] = 609273,
  [SMALL_STATE(7289)] = 609314,
  [SMALL_STATE(7290)] = 609353,
  [SMALL_STATE(7291)] = 609392,
  [SMALL_STATE(7292)] = 609430,
  [SMALL_STATE(7293)] = 609468,
  [SMALL_STATE(7294)] = 609506,
  [SMALL_STATE(7295)] = 609544,
  [SMALL_STATE(7296)] = 609582,
  [SMALL_STATE(7297)] = 609622,
  [SMALL_STATE(7298)] = 609660,
  [SMALL_STATE(7299)] = 609698,
  [SMALL_STATE(7300)] = 609736,
  [SMALL_STATE(7301)] = 609774,
  [SMALL_STATE(7302)] = 609812,
  [SMALL_STATE(7303)] = 609850,
  [SMALL_STATE(7304)] = 609888,
  [SMALL_STATE(7305)] = 609926,
  [SMALL_STATE(7306)] = 609964,
  [SMALL_STATE(7307)] = 610002,
  [SMALL_STATE(7308)] = 610040,
  [SMALL_STATE(7309)] = 610080,
  [SMALL_STATE(7310)] = 610118,
  [SMALL_STATE(7311)] = 610156,
  [SMALL_STATE(7312)] = 610196,
  [SMALL_STATE(7313)] = 610234,
  [SMALL_STATE(7314)] = 610272,
  [SMALL_STATE(7315)] = 610310,
  [SMALL_STATE(7316)] = 610350,
  [SMALL_STATE(7317)] = 610388,
  [SMALL_STATE(7318)] = 610426,
  [SMALL_STATE(7319)] = 610466,
  [SMALL_STATE(7320)] = 610504,
  [SMALL_STATE(7321)] = 610542,
  [SMALL_STATE(7322)] = 610580,
  [SMALL_STATE(7323)] = 610618,
  [SMALL_STATE(7324)] = 610656,
  [SMALL_STATE(7325)] = 610694,
  [SMALL_STATE(7326)] = 610732,
  [SMALL_STATE(7327)] = 610770,
  [SMALL_STATE(7328)] = 610810,
  [SMALL_STATE(7329)] = 610848,
  [SMALL_STATE(7330)] = 610886,
  [SMALL_STATE(7331)] = 610924,
  [SMALL_STATE(7332)] = 610962,
  [SMALL_STATE(7333)] = 611002,
  [SMALL_STATE(7334)] = 611040,
  [SMALL_STATE(7335)] = 611078,
  [SMALL_STATE(7336)] = 611116,
  [SMALL_STATE(7337)] = 611154,
  [SMALL_STATE(7338)] = 611192,
  [SMALL_STATE(7339)] = 611230,
  [SMALL_STATE(7340)] = 611268,
  [SMALL_STATE(7341)] = 611306,
  [SMALL_STATE(7342)] = 611344,
  [SMALL_STATE(7343)] = 611382,
  [SMALL_STATE(7344)] = 611422,
  [SMALL_STATE(7345)] = 611460,
  [SMALL_STATE(7346)] = 611498,
  [SMALL_STATE(7347)] = 611538,
  [SMALL_STATE(7348)] = 611576,
  [SMALL_STATE(7349)] = 611614,
  [SMALL_STATE(7350)] = 611652,
  [SMALL_STATE(7351)] = 611690,
  [SMALL_STATE(7352)] = 611730,
  [SMALL_STATE(7353)] = 611768,
  [SMALL_STATE(7354)] = 611806,
  [SMALL_STATE(7355)] = 611844,
  [SMALL_STATE(7356)] = 611882,
  [SMALL_STATE(7357)] = 611920,
  [SMALL_STATE(7358)] = 611958,
  [SMALL_STATE(7359)] = 611996,
  [SMALL_STATE(7360)] = 612034,
  [SMALL_STATE(7361)] = 612072,
  [SMALL_STATE(7362)] = 612110,
  [SMALL_STATE(7363)] = 612148,
  [SMALL_STATE(7364)] = 612186,
  [SMALL_STATE(7365)] = 612226,
  [SMALL_STATE(7366)] = 612264,
  [SMALL_STATE(7367)] = 612302,
  [SMALL_STATE(7368)] = 612340,
  [SMALL_STATE(7369)] = 612378,
  [SMALL_STATE(7370)] = 612416,
  [SMALL_STATE(7371)] = 612454,
  [SMALL_STATE(7372)] = 612492,
  [SMALL_STATE(7373)] = 612530,
  [SMALL_STATE(7374)] = 612568,
  [SMALL_STATE(7375)] = 612606,
  [SMALL_STATE(7376)] = 612644,
  [SMALL_STATE(7377)] = 612682,
  [SMALL_STATE(7378)] = 612720,
  [SMALL_STATE(7379)] = 612758,
  [SMALL_STATE(7380)] = 612796,
  [SMALL_STATE(7381)] = 612834,
  [SMALL_STATE(7382)] = 612872,
  [SMALL_STATE(7383)] = 612910,
  [SMALL_STATE(7384)] = 612948,
  [SMALL_STATE(7385)] = 612986,
  [SMALL_STATE(7386)] = 613024,
  [SMALL_STATE(7387)] = 613062,
  [SMALL_STATE(7388)] = 613100,
  [SMALL_STATE(7389)] = 613138,
  [SMALL_STATE(7390)] = 613176,
  [SMALL_STATE(7391)] = 613214,
  [SMALL_STATE(7392)] = 613252,
  [SMALL_STATE(7393)] = 613290,
  [SMALL_STATE(7394)] = 613328,
  [SMALL_STATE(7395)] = 613366,
  [SMALL_STATE(7396)] = 613404,
  [SMALL_STATE(7397)] = 613442,
  [SMALL_STATE(7398)] = 613480,
  [SMALL_STATE(7399)] = 613518,
  [SMALL_STATE(7400)] = 613556,
  [SMALL_STATE(7401)] = 613594,
  [SMALL_STATE(7402)] = 613634,
  [SMALL_STATE(7403)] = 613672,
  [SMALL_STATE(7404)] = 613712,
  [SMALL_STATE(7405)] = 613750,
  [SMALL_STATE(7406)] = 613788,
  [SMALL_STATE(7407)] = 613826,
  [SMALL_STATE(7408)] = 613864,
  [SMALL_STATE(7409)] = 613902,
  [SMALL_STATE(7410)] = 613940,
  [SMALL_STATE(7411)] = 613978,
  [SMALL_STATE(7412)] = 614016,
  [SMALL_STATE(7413)] = 614054,
  [SMALL_STATE(7414)] = 614092,
  [SMALL_STATE(7415)] = 614130,
  [SMALL_STATE(7416)] = 614168,
  [SMALL_STATE(7417)] = 614206,
  [SMALL_STATE(7418)] = 614244,
  [SMALL_STATE(7419)] = 614282,
  [SMALL_STATE(7420)] = 614320,
  [SMALL_STATE(7421)] = 614358,
  [SMALL_STATE(7422)] = 614396,
  [SMALL_STATE(7423)] = 614434,
  [SMALL_STATE(7424)] = 614472,
  [SMALL_STATE(7425)] = 614510,
  [SMALL_STATE(7426)] = 614548,
  [SMALL_STATE(7427)] = 614586,
  [SMALL_STATE(7428)] = 614624,
  [SMALL_STATE(7429)] = 614662,
  [SMALL_STATE(7430)] = 614700,
  [SMALL_STATE(7431)] = 614738,
  [SMALL_STATE(7432)] = 614776,
  [SMALL_STATE(7433)] = 614814,
  [SMALL_STATE(7434)] = 614852,
  [SMALL_STATE(7435)] = 614890,
  [SMALL_STATE(7436)] = 614928,
  [SMALL_STATE(7437)] = 614966,
  [SMALL_STATE(7438)] = 615004,
  [SMALL_STATE(7439)] = 615042,
  [SMALL_STATE(7440)] = 615080,
  [SMALL_STATE(7441)] = 615118,
  [SMALL_STATE(7442)] = 615156,
  [SMALL_STATE(7443)] = 615194,
  [SMALL_STATE(7444)] = 615232,
  [SMALL_STATE(7445)] = 615270,
  [SMALL_STATE(7446)] = 615308,
  [SMALL_STATE(7447)] = 615346,
  [SMALL_STATE(7448)] = 615384,
  [SMALL_STATE(7449)] = 615422,
  [SMALL_STATE(7450)] = 615460,
  [SMALL_STATE(7451)] = 615498,
  [SMALL_STATE(7452)] = 615536,
  [SMALL_STATE(7453)] = 615574,
  [SMALL_STATE(7454)] = 615612,
  [SMALL_STATE(7455)] = 615650,
  [SMALL_STATE(7456)] = 615688,
  [SMALL_STATE(7457)] = 615726,
  [SMALL_STATE(7458)] = 615764,
  [SMALL_STATE(7459)] = 615802,
  [SMALL_STATE(7460)] = 615840,
  [SMALL_STATE(7461)] = 615880,
  [SMALL_STATE(7462)] = 615918,
  [SMALL_STATE(7463)] = 615956,
  [SMALL_STATE(7464)] = 615993,
  [SMALL_STATE(7465)] = 616032,
  [SMALL_STATE(7466)] = 616071,
  [SMALL_STATE(7467)] = 616108,
  [SMALL_STATE(7468)] = 616145,
  [SMALL_STATE(7469)] = 616182,
  [SMALL_STATE(7470)] = 616219,
  [SMALL_STATE(7471)] = 616256,
  [SMALL_STATE(7472)] = 616293,
  [SMALL_STATE(7473)] = 616330,
  [SMALL_STATE(7474)] = 616367,
  [SMALL_STATE(7475)] = 616404,
  [SMALL_STATE(7476)] = 616441,
  [SMALL_STATE(7477)] = 616478,
  [SMALL_STATE(7478)] = 616515,
  [SMALL_STATE(7479)] = 616552,
  [SMALL_STATE(7480)] = 616589,
  [SMALL_STATE(7481)] = 616626,
  [SMALL_STATE(7482)] = 616663,
  [SMALL_STATE(7483)] = 616700,
  [SMALL_STATE(7484)] = 616737,
  [SMALL_STATE(7485)] = 616774,
  [SMALL_STATE(7486)] = 616811,
  [SMALL_STATE(7487)] = 616848,
  [SMALL_STATE(7488)] = 616885,
  [SMALL_STATE(7489)] = 616922,
  [SMALL_STATE(7490)] = 616959,
  [SMALL_STATE(7491)] = 616996,
  [SMALL_STATE(7492)] = 617033,
  [SMALL_STATE(7493)] = 617072,
  [SMALL_STATE(7494)] = 617109,
  [SMALL_STATE(7495)] = 617146,
  [SMALL_STATE(7496)] = 617183,
  [SMALL_STATE(7497)] = 617220,
  [SMALL_STATE(7498)] = 617257,
  [SMALL_STATE(7499)] = 617294,
  [SMALL_STATE(7500)] = 617331,
  [SMALL_STATE(7501)] = 617368,
  [SMALL_STATE(7502)] = 617405,
  [SMALL_STATE(7503)] = 617442,
  [SMALL_STATE(7504)] = 617479,
  [SMALL_STATE(7505)] = 617516,
  [SMALL_STATE(7506)] = 617553,
  [SMALL_STATE(7507)] = 617590,
  [SMALL_STATE(7508)] = 617627,
  [SMALL_STATE(7509)] = 617664,
  [SMALL_STATE(7510)] = 617701,
  [SMALL_STATE(7511)] = 617738,
  [SMALL_STATE(7512)] = 617775,
  [SMALL_STATE(7513)] = 617812,
  [SMALL_STATE(7514)] = 617849,
  [SMALL_STATE(7515)] = 617886,
  [SMALL_STATE(7516)] = 617923,
  [SMALL_STATE(7517)] = 617960,
  [SMALL_STATE(7518)] = 617997,
  [SMALL_STATE(7519)] = 618034,
  [SMALL_STATE(7520)] = 618071,
  [SMALL_STATE(7521)] = 618108,
  [SMALL_STATE(7522)] = 618145,
  [SMALL_STATE(7523)] = 618182,
  [SMALL_STATE(7524)] = 618219,
  [SMALL_STATE(7525)] = 618256,
  [SMALL_STATE(7526)] = 618293,
  [SMALL_STATE(7527)] = 618330,
  [SMALL_STATE(7528)] = 618367,
  [SMALL_STATE(7529)] = 618404,
  [SMALL_STATE(7530)] = 618441,
  [SMALL_STATE(7531)] = 618478,
  [SMALL_STATE(7532)] = 618515,
  [SMALL_STATE(7533)] = 618552,
  [SMALL_STATE(7534)] = 618589,
  [SMALL_STATE(7535)] = 618626,
  [SMALL_STATE(7536)] = 618663,
  [SMALL_STATE(7537)] = 618700,
  [SMALL_STATE(7538)] = 618737,
  [SMALL_STATE(7539)] = 618774,
  [SMALL_STATE(7540)] = 618811,
  [SMALL_STATE(7541)] = 618848,
  [SMALL_STATE(7542)] = 618885,
  [SMALL_STATE(7543)] = 618924,
  [SMALL_STATE(7544)] = 618961,
  [SMALL_STATE(7545)] = 618998,
  [SMALL_STATE(7546)] = 619035,
  [SMALL_STATE(7547)] = 619072,
  [SMALL_STATE(7548)] = 619109,
  [SMALL_STATE(7549)] = 619146,
  [SMALL_STATE(7550)] = 619183,
  [SMALL_STATE(7551)] = 619220,
  [SMALL_STATE(7552)] = 619257,
  [SMALL_STATE(7553)] = 619294,
  [SMALL_STATE(7554)] = 619331,
  [SMALL_STATE(7555)] = 619368,
  [SMALL_STATE(7556)] = 619405,
  [SMALL_STATE(7557)] = 619442,
  [SMALL_STATE(7558)] = 619479,
  [SMALL_STATE(7559)] = 619516,
  [SMALL_STATE(7560)] = 619553,
  [SMALL_STATE(7561)] = 619590,
  [SMALL_STATE(7562)] = 619627,
  [SMALL_STATE(7563)] = 619664,
  [SMALL_STATE(7564)] = 619701,
  [SMALL_STATE(7565)] = 619738,
  [SMALL_STATE(7566)] = 619775,
  [SMALL_STATE(7567)] = 619812,
  [SMALL_STATE(7568)] = 619849,
  [SMALL_STATE(7569)] = 619886,
  [SMALL_STATE(7570)] = 619923,
  [SMALL_STATE(7571)] = 619960,
  [SMALL_STATE(7572)] = 619997,
  [SMALL_STATE(7573)] = 620034,
  [SMALL_STATE(7574)] = 620071,
  [SMALL_STATE(7575)] = 620108,
  [SMALL_STATE(7576)] = 620145,
  [SMALL_STATE(7577)] = 620182,
  [SMALL_STATE(7578)] = 620219,
  [SMALL_STATE(7579)] = 620256,
  [SMALL_STATE(7580)] = 620293,
  [SMALL_STATE(7581)] = 620330,
  [SMALL_STATE(7582)] = 620367,
  [SMALL_STATE(7583)] = 620404,
  [SMALL_STATE(7584)] = 620441,
  [SMALL_STATE(7585)] = 620478,
  [SMALL_STATE(7586)] = 620515,
  [SMALL_STATE(7587)] = 620552,
  [SMALL_STATE(7588)] = 620589,
  [SMALL_STATE(7589)] = 620626,
  [SMALL_STATE(7590)] = 620663,
  [SMALL_STATE(7591)] = 620700,
  [SMALL_STATE(7592)] = 620737,
  [SMALL_STATE(7593)] = 620774,
  [SMALL_STATE(7594)] = 620811,
  [SMALL_STATE(7595)] = 620848,
  [SMALL_STATE(7596)] = 620885,
  [SMALL_STATE(7597)] = 620922,
  [SMALL_STATE(7598)] = 620959,
  [SMALL_STATE(7599)] = 620996,
  [SMALL_STATE(7600)] = 621033,
  [SMALL_STATE(7601)] = 621070,
  [SMALL_STATE(7602)] = 621109,
  [SMALL_STATE(7603)] = 621146,
  [SMALL_STATE(7604)] = 621183,
  [SMALL_STATE(7605)] = 621220,
  [SMALL_STATE(7606)] = 621257,
  [SMALL_STATE(7607)] = 621294,
  [SMALL_STATE(7608)] = 621331,
  [SMALL_STATE(7609)] = 621368,
  [SMALL_STATE(7610)] = 621405,
  [SMALL_STATE(7611)] = 621442,
  [SMALL_STATE(7612)] = 621479,
  [SMALL_STATE(7613)] = 621516,
  [SMALL_STATE(7614)] = 621553,
  [SMALL_STATE(7615)] = 621590,
  [SMALL_STATE(7616)] = 621627,
  [SMALL_STATE(7617)] = 621664,
  [SMALL_STATE(7618)] = 621701,
  [SMALL_STATE(7619)] = 621738,
  [SMALL_STATE(7620)] = 621775,
  [SMALL_STATE(7621)] = 621812,
  [SMALL_STATE(7622)] = 621849,
  [SMALL_STATE(7623)] = 621886,
  [SMALL_STATE(7624)] = 621923,
  [SMALL_STATE(7625)] = 621960,
  [SMALL_STATE(7626)] = 621997,
  [SMALL_STATE(7627)] = 622034,
  [SMALL_STATE(7628)] = 622071,
  [SMALL_STATE(7629)] = 622108,
  [SMALL_STATE(7630)] = 622145,
  [SMALL_STATE(7631)] = 622182,
  [SMALL_STATE(7632)] = 622219,
  [SMALL_STATE(7633)] = 622256,
  [SMALL_STATE(7634)] = 622293,
  [SMALL_STATE(7635)] = 622330,
  [SMALL_STATE(7636)] = 622367,
  [SMALL_STATE(7637)] = 622404,
  [SMALL_STATE(7638)] = 622441,
  [SMALL_STATE(7639)] = 622478,
  [SMALL_STATE(7640)] = 622517,
  [SMALL_STATE(7641)] = 622556,
  [SMALL_STATE(7642)] = 622593,
  [SMALL_STATE(7643)] = 622630,
  [SMALL_STATE(7644)] = 622669,
  [SMALL_STATE(7645)] = 622706,
  [SMALL_STATE(7646)] = 622743,
  [SMALL_STATE(7647)] = 622782,
  [SMALL_STATE(7648)] = 622819,
  [SMALL_STATE(7649)] = 622856,
  [SMALL_STATE(7650)] = 622893,
  [SMALL_STATE(7651)] = 622930,
  [SMALL_STATE(7652)] = 622967,
  [SMALL_STATE(7653)] = 623004,
  [SMALL_STATE(7654)] = 623041,
  [SMALL_STATE(7655)] = 623078,
  [SMALL_STATE(7656)] = 623115,
  [SMALL_STATE(7657)] = 623152,
  [SMALL_STATE(7658)] = 623189,
  [SMALL_STATE(7659)] = 623226,
  [SMALL_STATE(7660)] = 623263,
  [SMALL_STATE(7661)] = 623300,
  [SMALL_STATE(7662)] = 623337,
  [SMALL_STATE(7663)] = 623374,
  [SMALL_STATE(7664)] = 623413,
  [SMALL_STATE(7665)] = 623450,
  [SMALL_STATE(7666)] = 623487,
  [SMALL_STATE(7667)] = 623524,
  [SMALL_STATE(7668)] = 623561,
  [SMALL_STATE(7669)] = 623598,
  [SMALL_STATE(7670)] = 623634,
  [SMALL_STATE(7671)] = 623670,
  [SMALL_STATE(7672)] = 623706,
  [SMALL_STATE(7673)] = 623742,
  [SMALL_STATE(7674)] = 623778,
  [SMALL_STATE(7675)] = 623814,
  [SMALL_STATE(7676)] = 623850,
  [SMALL_STATE(7677)] = 623886,
  [SMALL_STATE(7678)] = 623922,
  [SMALL_STATE(7679)] = 623958,
  [SMALL_STATE(7680)] = 623994,
  [SMALL_STATE(7681)] = 624030,
  [SMALL_STATE(7682)] = 624066,
  [SMALL_STATE(7683)] = 624102,
  [SMALL_STATE(7684)] = 624138,
  [SMALL_STATE(7685)] = 624174,
  [SMALL_STATE(7686)] = 624210,
  [SMALL_STATE(7687)] = 624246,
  [SMALL_STATE(7688)] = 624282,
  [SMALL_STATE(7689)] = 624318,
  [SMALL_STATE(7690)] = 624354,
  [SMALL_STATE(7691)] = 624390,
  [SMALL_STATE(7692)] = 624426,
  [SMALL_STATE(7693)] = 624462,
  [SMALL_STATE(7694)] = 624498,
  [SMALL_STATE(7695)] = 624534,
  [SMALL_STATE(7696)] = 624570,
  [SMALL_STATE(7697)] = 624606,
  [SMALL_STATE(7698)] = 624642,
  [SMALL_STATE(7699)] = 624678,
  [SMALL_STATE(7700)] = 624714,
  [SMALL_STATE(7701)] = 624750,
  [SMALL_STATE(7702)] = 624786,
  [SMALL_STATE(7703)] = 624822,
  [SMALL_STATE(7704)] = 624858,
  [SMALL_STATE(7705)] = 624894,
  [SMALL_STATE(7706)] = 624930,
  [SMALL_STATE(7707)] = 624966,
  [SMALL_STATE(7708)] = 625002,
  [SMALL_STATE(7709)] = 625038,
  [SMALL_STATE(7710)] = 625074,
  [SMALL_STATE(7711)] = 625110,
  [SMALL_STATE(7712)] = 625146,
  [SMALL_STATE(7713)] = 625182,
  [SMALL_STATE(7714)] = 625218,
  [SMALL_STATE(7715)] = 625254,
  [SMALL_STATE(7716)] = 625290,
  [SMALL_STATE(7717)] = 625326,
  [SMALL_STATE(7718)] = 625362,
  [SMALL_STATE(7719)] = 625398,
  [SMALL_STATE(7720)] = 625434,
  [SMALL_STATE(7721)] = 625470,
  [SMALL_STATE(7722)] = 625506,
  [SMALL_STATE(7723)] = 625542,
  [SMALL_STATE(7724)] = 625578,
  [SMALL_STATE(7725)] = 625614,
  [SMALL_STATE(7726)] = 625654,
  [SMALL_STATE(7727)] = 625690,
  [SMALL_STATE(7728)] = 625726,
  [SMALL_STATE(7729)] = 625762,
  [SMALL_STATE(7730)] = 625798,
  [SMALL_STATE(7731)] = 625834,
  [SMALL_STATE(7732)] = 625870,
  [SMALL_STATE(7733)] = 625906,
  [SMALL_STATE(7734)] = 625942,
  [SMALL_STATE(7735)] = 625978,
  [SMALL_STATE(7736)] = 626014,
  [SMALL_STATE(7737)] = 626050,
  [SMALL_STATE(7738)] = 626086,
  [SMALL_STATE(7739)] = 626122,
  [SMALL_STATE(7740)] = 626158,
  [SMALL_STATE(7741)] = 626194,
  [SMALL_STATE(7742)] = 626230,
  [SMALL_STATE(7743)] = 626266,
  [SMALL_STATE(7744)] = 626302,
  [SMALL_STATE(7745)] = 626338,
  [SMALL_STATE(7746)] = 626374,
  [SMALL_STATE(7747)] = 626414,
  [SMALL_STATE(7748)] = 626450,
  [SMALL_STATE(7749)] = 626486,
  [SMALL_STATE(7750)] = 626522,
  [SMALL_STATE(7751)] = 626558,
  [SMALL_STATE(7752)] = 626594,
  [SMALL_STATE(7753)] = 626630,
  [SMALL_STATE(7754)] = 626666,
  [SMALL_STATE(7755)] = 626702,
  [SMALL_STATE(7756)] = 626738,
  [SMALL_STATE(7757)] = 626774,
  [SMALL_STATE(7758)] = 626810,
  [SMALL_STATE(7759)] = 626846,
  [SMALL_STATE(7760)] = 626882,
  [SMALL_STATE(7761)] = 626918,
  [SMALL_STATE(7762)] = 626954,
  [SMALL_STATE(7763)] = 626990,
  [SMALL_STATE(7764)] = 627026,
  [SMALL_STATE(7765)] = 627062,
  [SMALL_STATE(7766)] = 627098,
  [SMALL_STATE(7767)] = 627134,
  [SMALL_STATE(7768)] = 627170,
  [SMALL_STATE(7769)] = 627206,
  [SMALL_STATE(7770)] = 627242,
  [SMALL_STATE(7771)] = 627278,
  [SMALL_STATE(7772)] = 627314,
  [SMALL_STATE(7773)] = 627350,
  [SMALL_STATE(7774)] = 627386,
  [SMALL_STATE(7775)] = 627422,
  [SMALL_STATE(7776)] = 627458,
  [SMALL_STATE(7777)] = 627494,
  [SMALL_STATE(7778)] = 627530,
  [SMALL_STATE(7779)] = 627566,
  [SMALL_STATE(7780)] = 627602,
  [SMALL_STATE(7781)] = 627638,
  [SMALL_STATE(7782)] = 627674,
  [SMALL_STATE(7783)] = 627712,
  [SMALL_STATE(7784)] = 627748,
  [SMALL_STATE(7785)] = 627784,
  [SMALL_STATE(7786)] = 627820,
  [SMALL_STATE(7787)] = 627856,
  [SMALL_STATE(7788)] = 627892,
  [SMALL_STATE(7789)] = 627928,
  [SMALL_STATE(7790)] = 627964,
  [SMALL_STATE(7791)] = 628000,
  [SMALL_STATE(7792)] = 628036,
  [SMALL_STATE(7793)] = 628072,
  [SMALL_STATE(7794)] = 628108,
  [SMALL_STATE(7795)] = 628144,
  [SMALL_STATE(7796)] = 628180,
  [SMALL_STATE(7797)] = 628216,
  [SMALL_STATE(7798)] = 628252,
  [SMALL_STATE(7799)] = 628288,
  [SMALL_STATE(7800)] = 628324,
  [SMALL_STATE(7801)] = 628360,
  [SMALL_STATE(7802)] = 628396,
  [SMALL_STATE(7803)] = 628432,
  [SMALL_STATE(7804)] = 628468,
  [SMALL_STATE(7805)] = 628504,
  [SMALL_STATE(7806)] = 628540,
  [SMALL_STATE(7807)] = 628576,
  [SMALL_STATE(7808)] = 628612,
  [SMALL_STATE(7809)] = 628648,
  [SMALL_STATE(7810)] = 628684,
  [SMALL_STATE(7811)] = 628720,
  [SMALL_STATE(7812)] = 628756,
  [SMALL_STATE(7813)] = 628791,
  [SMALL_STATE(7814)] = 628826,
  [SMALL_STATE(7815)] = 628861,
  [SMALL_STATE(7816)] = 628896,
  [SMALL_STATE(7817)] = 628931,
  [SMALL_STATE(7818)] = 628966,
  [SMALL_STATE(7819)] = 629001,
  [SMALL_STATE(7820)] = 629036,
  [SMALL_STATE(7821)] = 629071,
  [SMALL_STATE(7822)] = 629106,
  [SMALL_STATE(7823)] = 629141,
  [SMALL_STATE(7824)] = 629176,
  [SMALL_STATE(7825)] = 629213,
  [SMALL_STATE(7826)] = 629248,
  [SMALL_STATE(7827)] = 629283,
  [SMALL_STATE(7828)] = 629317,
  [SMALL_STATE(7829)] = 629351,
  [SMALL_STATE(7830)] = 629385,
  [SMALL_STATE(7831)] = 629419,
  [SMALL_STATE(7832)] = 629453,
  [SMALL_STATE(7833)] = 629487,
  [SMALL_STATE(7834)] = 629521,
  [SMALL_STATE(7835)] = 629555,
  [SMALL_STATE(7836)] = 629589,
  [SMALL_STATE(7837)] = 629623,
  [SMALL_STATE(7838)] = 629657,
  [SMALL_STATE(7839)] = 629691,
  [SMALL_STATE(7840)] = 629725,
  [SMALL_STATE(7841)] = 629759,
  [SMALL_STATE(7842)] = 629793,
  [SMALL_STATE(7843)] = 629827,
  [SMALL_STATE(7844)] = 629861,
  [SMALL_STATE(7845)] = 629895,
  [SMALL_STATE(7846)] = 629925,
  [SMALL_STATE(7847)] = 629955,
  [SMALL_STATE(7848)] = 630011,
  [SMALL_STATE(7849)] = 630041,
  [SMALL_STATE(7850)] = 630071,
  [SMALL_STATE(7851)] = 630101,
  [SMALL_STATE(7852)] = 630131,
  [SMALL_STATE(7853)] = 630161,
  [SMALL_STATE(7854)] = 630217,
  [SMALL_STATE(7855)] = 630251,
  [SMALL_STATE(7856)] = 630285,
  [SMALL_STATE(7857)] = 630315,
  [SMALL_STATE(7858)] = 630345,
  [SMALL_STATE(7859)] = 630374,
  [SMALL_STATE(7860)] = 630403,
  [SMALL_STATE(7861)] = 630436,
  [SMALL_STATE(7862)] = 630465,
  [SMALL_STATE(7863)] = 630498,
  [SMALL_STATE(7864)] = 630527,
  [SMALL_STATE(7865)] = 630556,
  [SMALL_STATE(7866)] = 630585,
  [SMALL_STATE(7867)] = 630614,
  [SMALL_STATE(7868)] = 630643,
  [SMALL_STATE(7869)] = 630672,
  [SMALL_STATE(7870)] = 630701,
  [SMALL_STATE(7871)] = 630730,
  [SMALL_STATE(7872)] = 630759,
  [SMALL_STATE(7873)] = 630788,
  [SMALL_STATE(7874)] = 630817,
  [SMALL_STATE(7875)] = 630846,
  [SMALL_STATE(7876)] = 630875,
  [SMALL_STATE(7877)] = 630908,
  [SMALL_STATE(7878)] = 630961,
  [SMALL_STATE(7879)] = 630990,
  [SMALL_STATE(7880)] = 631023,
  [SMALL_STATE(7881)] = 631052,
  [SMALL_STATE(7882)] = 631081,
  [SMALL_STATE(7883)] = 631110,
  [SMALL_STATE(7884)] = 631139,
  [SMALL_STATE(7885)] = 631168,
  [SMALL_STATE(7886)] = 631201,
  [SMALL_STATE(7887)] = 631230,
  [SMALL_STATE(7888)] = 631259,
  [SMALL_STATE(7889)] = 631288,
  [SMALL_STATE(7890)] = 631317,
  [SMALL_STATE(7891)] = 631350,
  [SMALL_STATE(7892)] = 631379,
  [SMALL_STATE(7893)] = 631407,
  [SMALL_STATE(7894)] = 631435,
  [SMALL_STATE(7895)] = 631467,
  [SMALL_STATE(7896)] = 631495,
  [SMALL_STATE(7897)] = 631523,
  [SMALL_STATE(7898)] = 631555,
  [SMALL_STATE(7899)] = 631583,
  [SMALL_STATE(7900)] = 631611,
  [SMALL_STATE(7901)] = 631639,
  [SMALL_STATE(7902)] = 631667,
  [SMALL_STATE(7903)] = 631695,
  [SMALL_STATE(7904)] = 631723,
  [SMALL_STATE(7905)] = 631751,
  [SMALL_STATE(7906)] = 631779,
  [SMALL_STATE(7907)] = 631811,
  [SMALL_STATE(7908)] = 631843,
  [SMALL_STATE(7909)] = 631871,
  [SMALL_STATE(7910)] = 631899,
  [SMALL_STATE(7911)] = 631927,
  [SMALL_STATE(7912)] = 631955,
  [SMALL_STATE(7913)] = 631983,
  [SMALL_STATE(7914)] = 632011,
  [SMALL_STATE(7915)] = 632039,
  [SMALL_STATE(7916)] = 632067,
  [SMALL_STATE(7917)] = 632099,
  [SMALL_STATE(7918)] = 632131,
  [SMALL_STATE(7919)] = 632159,
  [SMALL_STATE(7920)] = 632191,
  [SMALL_STATE(7921)] = 632219,
  [SMALL_STATE(7922)] = 632247,
  [SMALL_STATE(7923)] = 632279,
  [SMALL_STATE(7924)] = 632307,
  [SMALL_STATE(7925)] = 632335,
  [SMALL_STATE(7926)] = 632363,
  [SMALL_STATE(7927)] = 632391,
  [SMALL_STATE(7928)] = 632419,
  [SMALL_STATE(7929)] = 632447,
  [SMALL_STATE(7930)] = 632475,
  [SMALL_STATE(7931)] = 632503,
  [SMALL_STATE(7932)] = 632531,
  [SMALL_STATE(7933)] = 632559,
  [SMALL_STATE(7934)] = 632587,
  [SMALL_STATE(7935)] = 632615,
  [SMALL_STATE(7936)] = 632643,
  [SMALL_STATE(7937)] = 632690,
  [SMALL_STATE(7938)] = 632735,
  [SMALL_STATE(7939)] = 632780,
  [SMALL_STATE(7940)] = 632807,
  [SMALL_STATE(7941)] = 632834,
  [SMALL_STATE(7942)] = 632861,
  [SMALL_STATE(7943)] = 632888,
  [SMALL_STATE(7944)] = 632915,
  [SMALL_STATE(7945)] = 632960,
  [SMALL_STATE(7946)] = 633005,
  [SMALL_STATE(7947)] = 633032,
  [SMALL_STATE(7948)] = 633059,
  [SMALL_STATE(7949)] = 633090,
  [SMALL_STATE(7950)] = 633137,
  [SMALL_STATE(7951)] = 633164,
  [SMALL_STATE(7952)] = 633191,
  [SMALL_STATE(7953)] = 633218,
  [SMALL_STATE(7954)] = 633245,
  [SMALL_STATE(7955)] = 633290,
  [SMALL_STATE(7956)] = 633317,
  [SMALL_STATE(7957)] = 633362,
  [SMALL_STATE(7958)] = 633407,
  [SMALL_STATE(7959)] = 633452,
  [SMALL_STATE(7960)] = 633497,
  [SMALL_STATE(7961)] = 633542,
  [SMALL_STATE(7962)] = 633569,
  [SMALL_STATE(7963)] = 633596,
  [SMALL_STATE(7964)] = 633641,
  [SMALL_STATE(7965)] = 633686,
  [SMALL_STATE(7966)] = 633713,
  [SMALL_STATE(7967)] = 633758,
  [SMALL_STATE(7968)] = 633785,
  [SMALL_STATE(7969)] = 633830,
  [SMALL_STATE(7970)] = 633877,
  [SMALL_STATE(7971)] = 633904,
  [SMALL_STATE(7972)] = 633931,
  [SMALL_STATE(7973)] = 633976,
  [SMALL_STATE(7974)] = 634021,
  [SMALL_STATE(7975)] = 634066,
  [SMALL_STATE(7976)] = 634111,
  [SMALL_STATE(7977)] = 634156,
  [SMALL_STATE(7978)] = 634201,
  [SMALL_STATE(7979)] = 634246,
  [SMALL_STATE(7980)] = 634273,
  [SMALL_STATE(7981)] = 634318,
  [SMALL_STATE(7982)] = 634363,
  [SMALL_STATE(7983)] = 634408,
  [SMALL_STATE(7984)] = 634435,
  [SMALL_STATE(7985)] = 634462,
  [SMALL_STATE(7986)] = 634507,
  [SMALL_STATE(7987)] = 634534,
  [SMALL_STATE(7988)] = 634561,
  [SMALL_STATE(7989)] = 634592,
  [SMALL_STATE(7990)] = 634623,
  [SMALL_STATE(7991)] = 634668,
  [SMALL_STATE(7992)] = 634699,
  [SMALL_STATE(7993)] = 634744,
  [SMALL_STATE(7994)] = 634771,
  [SMALL_STATE(7995)] = 634816,
  [SMALL_STATE(7996)] = 634861,
  [SMALL_STATE(7997)] = 634892,
  [SMALL_STATE(7998)] = 634937,
  [SMALL_STATE(7999)] = 634982,
  [SMALL_STATE(8000)] = 635027,
  [SMALL_STATE(8001)] = 635054,
  [SMALL_STATE(8002)] = 635081,
  [SMALL_STATE(8003)] = 635126,
  [SMALL_STATE(8004)] = 635153,
  [SMALL_STATE(8005)] = 635180,
  [SMALL_STATE(8006)] = 635207,
  [SMALL_STATE(8007)] = 635252,
  [SMALL_STATE(8008)] = 635297,
  [SMALL_STATE(8009)] = 635342,
  [SMALL_STATE(8010)] = 635389,
  [SMALL_STATE(8011)] = 635416,
  [SMALL_STATE(8012)] = 635443,
  [SMALL_STATE(8013)] = 635470,
  [SMALL_STATE(8014)] = 635497,
  [SMALL_STATE(8015)] = 635524,
  [SMALL_STATE(8016)] = 635551,
  [SMALL_STATE(8017)] = 635596,
  [SMALL_STATE(8018)] = 635641,
  [SMALL_STATE(8019)] = 635686,
  [SMALL_STATE(8020)] = 635717,
  [SMALL_STATE(8021)] = 635762,
  [SMALL_STATE(8022)] = 635793,
  [SMALL_STATE(8023)] = 635820,
  [SMALL_STATE(8024)] = 635865,
  [SMALL_STATE(8025)] = 635910,
  [SMALL_STATE(8026)] = 635955,
  [SMALL_STATE(8027)] = 636000,
  [SMALL_STATE(8028)] = 636031,
  [SMALL_STATE(8029)] = 636076,
  [SMALL_STATE(8030)] = 636121,
  [SMALL_STATE(8031)] = 636147,
  [SMALL_STATE(8032)] = 636193,
  [SMALL_STATE(8033)] = 636239,
  [SMALL_STATE(8034)] = 636285,
  [SMALL_STATE(8035)] = 636315,
  [SMALL_STATE(8036)] = 636361,
  [SMALL_STATE(8037)] = 636387,
  [SMALL_STATE(8038)] = 636413,
  [SMALL_STATE(8039)] = 636459,
  [SMALL_STATE(8040)] = 636505,
  [SMALL_STATE(8041)] = 636551,
  [SMALL_STATE(8042)] = 636597,
  [SMALL_STATE(8043)] = 636623,
  [SMALL_STATE(8044)] = 636665,
  [SMALL_STATE(8045)] = 636711,
  [SMALL_STATE(8046)] = 636737,
  [SMALL_STATE(8047)] = 636763,
  [SMALL_STATE(8048)] = 636809,
  [SMALL_STATE(8049)] = 636839,
  [SMALL_STATE(8050)] = 636865,
  [SMALL_STATE(8051)] = 636891,
  [SMALL_STATE(8052)] = 636937,
  [SMALL_STATE(8053)] = 636963,
  [SMALL_STATE(8054)] = 637009,
  [SMALL_STATE(8055)] = 637055,
  [SMALL_STATE(8056)] = 637081,
  [SMALL_STATE(8057)] = 637107,
  [SMALL_STATE(8058)] = 637133,
  [SMALL_STATE(8059)] = 637179,
  [SMALL_STATE(8060)] = 637209,
  [SMALL_STATE(8061)] = 637239,
  [SMALL_STATE(8062)] = 637285,
  [SMALL_STATE(8063)] = 637331,
  [SMALL_STATE(8064)] = 637373,
  [SMALL_STATE(8065)] = 637419,
  [SMALL_STATE(8066)] = 637445,
  [SMALL_STATE(8067)] = 637491,
  [SMALL_STATE(8068)] = 637537,
  [SMALL_STATE(8069)] = 637567,
  [SMALL_STATE(8070)] = 637593,
  [SMALL_STATE(8071)] = 637635,
  [SMALL_STATE(8072)] = 637665,
  [SMALL_STATE(8073)] = 637711,
  [SMALL_STATE(8074)] = 637741,
  [SMALL_STATE(8075)] = 637787,
  [SMALL_STATE(8076)] = 637833,
  [SMALL_STATE(8077)] = 637879,
  [SMALL_STATE(8078)] = 637925,
  [SMALL_STATE(8079)] = 637951,
  [SMALL_STATE(8080)] = 637997,
  [SMALL_STATE(8081)] = 638023,
  [SMALL_STATE(8082)] = 638069,
  [SMALL_STATE(8083)] = 638113,
  [SMALL_STATE(8084)] = 638139,
  [SMALL_STATE(8085)] = 638165,
  [SMALL_STATE(8086)] = 638211,
  [SMALL_STATE(8087)] = 638257,
  [SMALL_STATE(8088)] = 638301,
  [SMALL_STATE(8089)] = 638345,
  [SMALL_STATE(8090)] = 638391,
  [SMALL_STATE(8091)] = 638417,
  [SMALL_STATE(8092)] = 638463,
  [SMALL_STATE(8093)] = 638509,
  [SMALL_STATE(8094)] = 638555,
  [SMALL_STATE(8095)] = 638601,
  [SMALL_STATE(8096)] = 638647,
  [SMALL_STATE(8097)] = 638693,
  [SMALL_STATE(8098)] = 638719,
  [SMALL_STATE(8099)] = 638763,
  [SMALL_STATE(8100)] = 638809,
  [SMALL_STATE(8101)] = 638835,
  [SMALL_STATE(8102)] = 638865,
  [SMALL_STATE(8103)] = 638891,
  [SMALL_STATE(8104)] = 638917,
  [SMALL_STATE(8105)] = 638963,
  [SMALL_STATE(8106)] = 639007,
  [SMALL_STATE(8107)] = 639033,
  [SMALL_STATE(8108)] = 639059,
  [SMALL_STATE(8109)] = 639085,
  [SMALL_STATE(8110)] = 639111,
  [SMALL_STATE(8111)] = 639137,
  [SMALL_STATE(8112)] = 639183,
  [SMALL_STATE(8113)] = 639227,
  [SMALL_STATE(8114)] = 639253,
  [SMALL_STATE(8115)] = 639299,
  [SMALL_STATE(8116)] = 639343,
  [SMALL_STATE(8117)] = 639369,
  [SMALL_STATE(8118)] = 639415,
  [SMALL_STATE(8119)] = 639441,
  [SMALL_STATE(8120)] = 639487,
  [SMALL_STATE(8121)] = 639513,
  [SMALL_STATE(8122)] = 639539,
  [SMALL_STATE(8123)] = 639565,
  [SMALL_STATE(8124)] = 639611,
  [SMALL_STATE(8125)] = 639657,
  [SMALL_STATE(8126)] = 639703,
  [SMALL_STATE(8127)] = 639749,
  [SMALL_STATE(8128)] = 639795,
  [SMALL_STATE(8129)] = 639825,
  [SMALL_STATE(8130)] = 639869,
  [SMALL_STATE(8131)] = 639899,
  [SMALL_STATE(8132)] = 639925,
  [SMALL_STATE(8133)] = 639971,
  [SMALL_STATE(8134)] = 640017,
  [SMALL_STATE(8135)] = 640043,
  [SMALL_STATE(8136)] = 640069,
  [SMALL_STATE(8137)] = 640095,
  [SMALL_STATE(8138)] = 640121,
  [SMALL_STATE(8139)] = 640167,
  [SMALL_STATE(8140)] = 640213,
  [SMALL_STATE(8141)] = 640259,
  [SMALL_STATE(8142)] = 640285,
  [SMALL_STATE(8143)] = 640331,
  [SMALL_STATE(8144)] = 640377,
  [SMALL_STATE(8145)] = 640403,
  [SMALL_STATE(8146)] = 640429,
  [SMALL_STATE(8147)] = 640475,
  [SMALL_STATE(8148)] = 640501,
  [SMALL_STATE(8149)] = 640547,
  [SMALL_STATE(8150)] = 640573,
  [SMALL_STATE(8151)] = 640599,
  [SMALL_STATE(8152)] = 640645,
  [SMALL_STATE(8153)] = 640691,
  [SMALL_STATE(8154)] = 640737,
  [SMALL_STATE(8155)] = 640781,
  [SMALL_STATE(8156)] = 640825,
  [SMALL_STATE(8157)] = 640871,
  [SMALL_STATE(8158)] = 640896,
  [SMALL_STATE(8159)] = 640921,
  [SMALL_STATE(8160)] = 640946,
  [SMALL_STATE(8161)] = 640971,
  [SMALL_STATE(8162)] = 640996,
  [SMALL_STATE(8163)] = 641021,
  [SMALL_STATE(8164)] = 641062,
  [SMALL_STATE(8165)] = 641103,
  [SMALL_STATE(8166)] = 641128,
  [SMALL_STATE(8167)] = 641153,
  [SMALL_STATE(8168)] = 641178,
  [SMALL_STATE(8169)] = 641203,
  [SMALL_STATE(8170)] = 641228,
  [SMALL_STATE(8171)] = 641257,
  [SMALL_STATE(8172)] = 641286,
  [SMALL_STATE(8173)] = 641315,
  [SMALL_STATE(8174)] = 641344,
  [SMALL_STATE(8175)] = 641373,
  [SMALL_STATE(8176)] = 641414,
  [SMALL_STATE(8177)] = 641441,
  [SMALL_STATE(8178)] = 641466,
  [SMALL_STATE(8179)] = 641493,
  [SMALL_STATE(8180)] = 641518,
  [SMALL_STATE(8181)] = 641543,
  [SMALL_STATE(8182)] = 641568,
  [SMALL_STATE(8183)] = 641593,
  [SMALL_STATE(8184)] = 641618,
  [SMALL_STATE(8185)] = 641643,
  [SMALL_STATE(8186)] = 641668,
  [SMALL_STATE(8187)] = 641693,
  [SMALL_STATE(8188)] = 641718,
  [SMALL_STATE(8189)] = 641743,
  [SMALL_STATE(8190)] = 641768,
  [SMALL_STATE(8191)] = 641793,
  [SMALL_STATE(8192)] = 641818,
  [SMALL_STATE(8193)] = 641859,
  [SMALL_STATE(8194)] = 641900,
  [SMALL_STATE(8195)] = 641925,
  [SMALL_STATE(8196)] = 641950,
  [SMALL_STATE(8197)] = 641975,
  [SMALL_STATE(8198)] = 642000,
  [SMALL_STATE(8199)] = 642025,
  [SMALL_STATE(8200)] = 642050,
  [SMALL_STATE(8201)] = 642091,
  [SMALL_STATE(8202)] = 642116,
  [SMALL_STATE(8203)] = 642141,
  [SMALL_STATE(8204)] = 642166,
  [SMALL_STATE(8205)] = 642191,
  [SMALL_STATE(8206)] = 642216,
  [SMALL_STATE(8207)] = 642257,
  [SMALL_STATE(8208)] = 642286,
  [SMALL_STATE(8209)] = 642315,
  [SMALL_STATE(8210)] = 642340,
  [SMALL_STATE(8211)] = 642369,
  [SMALL_STATE(8212)] = 642394,
  [SMALL_STATE(8213)] = 642419,
  [SMALL_STATE(8214)] = 642444,
  [SMALL_STATE(8215)] = 642469,
  [SMALL_STATE(8216)] = 642498,
  [SMALL_STATE(8217)] = 642523,
  [SMALL_STATE(8218)] = 642548,
  [SMALL_STATE(8219)] = 642573,
  [SMALL_STATE(8220)] = 642598,
  [SMALL_STATE(8221)] = 642623,
  [SMALL_STATE(8222)] = 642648,
  [SMALL_STATE(8223)] = 642689,
  [SMALL_STATE(8224)] = 642714,
  [SMALL_STATE(8225)] = 642739,
  [SMALL_STATE(8226)] = 642764,
  [SMALL_STATE(8227)] = 642789,
  [SMALL_STATE(8228)] = 642814,
  [SMALL_STATE(8229)] = 642839,
  [SMALL_STATE(8230)] = 642864,
  [SMALL_STATE(8231)] = 642889,
  [SMALL_STATE(8232)] = 642914,
  [SMALL_STATE(8233)] = 642939,
  [SMALL_STATE(8234)] = 642968,
  [SMALL_STATE(8235)] = 642993,
  [SMALL_STATE(8236)] = 643018,
  [SMALL_STATE(8237)] = 643043,
  [SMALL_STATE(8238)] = 643068,
  [SMALL_STATE(8239)] = 643097,
  [SMALL_STATE(8240)] = 643122,
  [SMALL_STATE(8241)] = 643147,
  [SMALL_STATE(8242)] = 643172,
  [SMALL_STATE(8243)] = 643197,
  [SMALL_STATE(8244)] = 643226,
  [SMALL_STATE(8245)] = 643251,
  [SMALL_STATE(8246)] = 643280,
  [SMALL_STATE(8247)] = 643305,
  [SMALL_STATE(8248)] = 643330,
  [SMALL_STATE(8249)] = 643355,
  [SMALL_STATE(8250)] = 643380,
  [SMALL_STATE(8251)] = 643405,
  [SMALL_STATE(8252)] = 643430,
  [SMALL_STATE(8253)] = 643455,
  [SMALL_STATE(8254)] = 643480,
  [SMALL_STATE(8255)] = 643509,
  [SMALL_STATE(8256)] = 643534,
  [SMALL_STATE(8257)] = 643563,
  [SMALL_STATE(8258)] = 643604,
  [SMALL_STATE(8259)] = 643629,
  [SMALL_STATE(8260)] = 643658,
  [SMALL_STATE(8261)] = 643683,
  [SMALL_STATE(8262)] = 643708,
  [SMALL_STATE(8263)] = 643733,
  [SMALL_STATE(8264)] = 643758,
  [SMALL_STATE(8265)] = 643783,
  [SMALL_STATE(8266)] = 643823,
  [SMALL_STATE(8267)] = 643847,
  [SMALL_STATE(8268)] = 643887,
  [SMALL_STATE(8269)] = 643925,
  [SMALL_STATE(8270)] = 643965,
  [SMALL_STATE(8271)] = 644005,
  [SMALL_STATE(8272)] = 644029,
  [SMALL_STATE(8273)] = 644053,
  [SMALL_STATE(8274)] = 644093,
  [SMALL_STATE(8275)] = 644133,
  [SMALL_STATE(8276)] = 644171,
  [SMALL_STATE(8277)] = 644195,
  [SMALL_STATE(8278)] = 644219,
  [SMALL_STATE(8279)] = 644243,
  [SMALL_STATE(8280)] = 644267,
  [SMALL_STATE(8281)] = 644307,
  [SMALL_STATE(8282)] = 644331,
  [SMALL_STATE(8283)] = 644355,
  [SMALL_STATE(8284)] = 644379,
  [SMALL_STATE(8285)] = 644419,
  [SMALL_STATE(8286)] = 644443,
  [SMALL_STATE(8287)] = 644467,
  [SMALL_STATE(8288)] = 644507,
  [SMALL_STATE(8289)] = 644545,
  [SMALL_STATE(8290)] = 644569,
  [SMALL_STATE(8291)] = 644593,
  [SMALL_STATE(8292)] = 644617,
  [SMALL_STATE(8293)] = 644657,
  [SMALL_STATE(8294)] = 644681,
  [SMALL_STATE(8295)] = 644705,
  [SMALL_STATE(8296)] = 644729,
  [SMALL_STATE(8297)] = 644753,
  [SMALL_STATE(8298)] = 644781,
  [SMALL_STATE(8299)] = 644805,
  [SMALL_STATE(8300)] = 644845,
  [SMALL_STATE(8301)] = 644869,
  [SMALL_STATE(8302)] = 644893,
  [SMALL_STATE(8303)] = 644931,
  [SMALL_STATE(8304)] = 644955,
  [SMALL_STATE(8305)] = 644995,
  [SMALL_STATE(8306)] = 645019,
  [SMALL_STATE(8307)] = 645043,
  [SMALL_STATE(8308)] = 645083,
  [SMALL_STATE(8309)] = 645107,
  [SMALL_STATE(8310)] = 645147,
  [SMALL_STATE(8311)] = 645171,
  [SMALL_STATE(8312)] = 645195,
  [SMALL_STATE(8313)] = 645235,
  [SMALL_STATE(8314)] = 645259,
  [SMALL_STATE(8315)] = 645283,
  [SMALL_STATE(8316)] = 645321,
  [SMALL_STATE(8317)] = 645345,
  [SMALL_STATE(8318)] = 645369,
  [SMALL_STATE(8319)] = 645393,
  [SMALL_STATE(8320)] = 645417,
  [SMALL_STATE(8321)] = 645457,
  [SMALL_STATE(8322)] = 645495,
  [SMALL_STATE(8323)] = 645519,
  [SMALL_STATE(8324)] = 645543,
  [SMALL_STATE(8325)] = 645567,
  [SMALL_STATE(8326)] = 645591,
  [SMALL_STATE(8327)] = 645615,
  [SMALL_STATE(8328)] = 645655,
  [SMALL_STATE(8329)] = 645679,
  [SMALL_STATE(8330)] = 645703,
  [SMALL_STATE(8331)] = 645743,
  [SMALL_STATE(8332)] = 645771,
  [SMALL_STATE(8333)] = 645795,
  [SMALL_STATE(8334)] = 645835,
  [SMALL_STATE(8335)] = 645873,
  [SMALL_STATE(8336)] = 645897,
  [SMALL_STATE(8337)] = 645925,
  [SMALL_STATE(8338)] = 645953,
  [SMALL_STATE(8339)] = 645977,
  [SMALL_STATE(8340)] = 646017,
  [SMALL_STATE(8341)] = 646057,
  [SMALL_STATE(8342)] = 646097,
  [SMALL_STATE(8343)] = 646121,
  [SMALL_STATE(8344)] = 646159,
  [SMALL_STATE(8345)] = 646183,
  [SMALL_STATE(8346)] = 646221,
  [SMALL_STATE(8347)] = 646261,
  [SMALL_STATE(8348)] = 646287,
  [SMALL_STATE(8349)] = 646327,
  [SMALL_STATE(8350)] = 646355,
  [SMALL_STATE(8351)] = 646383,
  [SMALL_STATE(8352)] = 646407,
  [SMALL_STATE(8353)] = 646447,
  [SMALL_STATE(8354)] = 646471,
  [SMALL_STATE(8355)] = 646499,
  [SMALL_STATE(8356)] = 646537,
  [SMALL_STATE(8357)] = 646577,
  [SMALL_STATE(8358)] = 646603,
  [SMALL_STATE(8359)] = 646629,
  [SMALL_STATE(8360)] = 646669,
  [SMALL_STATE(8361)] = 646709,
  [SMALL_STATE(8362)] = 646737,
  [SMALL_STATE(8363)] = 646763,
  [SMALL_STATE(8364)] = 646801,
  [SMALL_STATE(8365)] = 646825,
  [SMALL_STATE(8366)] = 646849,
  [SMALL_STATE(8367)] = 646873,
  [SMALL_STATE(8368)] = 646897,
  [SMALL_STATE(8369)] = 646935,
  [SMALL_STATE(8370)] = 646973,
  [SMALL_STATE(8371)] = 647013,
  [SMALL_STATE(8372)] = 647053,
  [SMALL_STATE(8373)] = 647091,
  [SMALL_STATE(8374)] = 647115,
  [SMALL_STATE(8375)] = 647139,
  [SMALL_STATE(8376)] = 647163,
  [SMALL_STATE(8377)] = 647201,
  [SMALL_STATE(8378)] = 647225,
  [SMALL_STATE(8379)] = 647265,
  [SMALL_STATE(8380)] = 647303,
  [SMALL_STATE(8381)] = 647331,
  [SMALL_STATE(8382)] = 647371,
  [SMALL_STATE(8383)] = 647399,
  [SMALL_STATE(8384)] = 647423,
  [SMALL_STATE(8385)] = 647461,
  [SMALL_STATE(8386)] = 647501,
  [SMALL_STATE(8387)] = 647525,
  [SMALL_STATE(8388)] = 647549,
  [SMALL_STATE(8389)] = 647587,
  [SMALL_STATE(8390)] = 647627,
  [SMALL_STATE(8391)] = 647651,
  [SMALL_STATE(8392)] = 647675,
  [SMALL_STATE(8393)] = 647701,
  [SMALL_STATE(8394)] = 647739,
  [SMALL_STATE(8395)] = 647765,
  [SMALL_STATE(8396)] = 647789,
  [SMALL_STATE(8397)] = 647827,
  [SMALL_STATE(8398)] = 647851,
  [SMALL_STATE(8399)] = 647889,
  [SMALL_STATE(8400)] = 647913,
  [SMALL_STATE(8401)] = 647937,
  [SMALL_STATE(8402)] = 647965,
  [SMALL_STATE(8403)] = 648003,
  [SMALL_STATE(8404)] = 648029,
  [SMALL_STATE(8405)] = 648053,
  [SMALL_STATE(8406)] = 648081,
  [SMALL_STATE(8407)] = 648105,
  [SMALL_STATE(8408)] = 648145,
  [SMALL_STATE(8409)] = 648169,
  [SMALL_STATE(8410)] = 648207,
  [SMALL_STATE(8411)] = 648247,
  [SMALL_STATE(8412)] = 648271,
  [SMALL_STATE(8413)] = 648309,
  [SMALL_STATE(8414)] = 648333,
  [SMALL_STATE(8415)] = 648371,
  [SMALL_STATE(8416)] = 648395,
  [SMALL_STATE(8417)] = 648419,
  [SMALL_STATE(8418)] = 648459,
  [SMALL_STATE(8419)] = 648497,
  [SMALL_STATE(8420)] = 648521,
  [SMALL_STATE(8421)] = 648545,
  [SMALL_STATE(8422)] = 648585,
  [SMALL_STATE(8423)] = 648609,
  [SMALL_STATE(8424)] = 648647,
  [SMALL_STATE(8425)] = 648671,
  [SMALL_STATE(8426)] = 648695,
  [SMALL_STATE(8427)] = 648719,
  [SMALL_STATE(8428)] = 648743,
  [SMALL_STATE(8429)] = 648781,
  [SMALL_STATE(8430)] = 648805,
  [SMALL_STATE(8431)] = 648845,
  [SMALL_STATE(8432)] = 648883,
  [SMALL_STATE(8433)] = 648907,
  [SMALL_STATE(8434)] = 648931,
  [SMALL_STATE(8435)] = 648955,
  [SMALL_STATE(8436)] = 648993,
  [SMALL_STATE(8437)] = 649017,
  [SMALL_STATE(8438)] = 649041,
  [SMALL_STATE(8439)] = 649065,
  [SMALL_STATE(8440)] = 649089,
  [SMALL_STATE(8441)] = 649113,
  [SMALL_STATE(8442)] = 649137,
  [SMALL_STATE(8443)] = 649175,
  [SMALL_STATE(8444)] = 649215,
  [SMALL_STATE(8445)] = 649239,
  [SMALL_STATE(8446)] = 649277,
  [SMALL_STATE(8447)] = 649315,
  [SMALL_STATE(8448)] = 649339,
  [SMALL_STATE(8449)] = 649363,
  [SMALL_STATE(8450)] = 649403,
  [SMALL_STATE(8451)] = 649427,
  [SMALL_STATE(8452)] = 649465,
  [SMALL_STATE(8453)] = 649489,
  [SMALL_STATE(8454)] = 649513,
  [SMALL_STATE(8455)] = 649553,
  [SMALL_STATE(8456)] = 649591,
  [SMALL_STATE(8457)] = 649629,
  [SMALL_STATE(8458)] = 649653,
  [SMALL_STATE(8459)] = 649677,
  [SMALL_STATE(8460)] = 649701,
  [SMALL_STATE(8461)] = 649739,
  [SMALL_STATE(8462)] = 649763,
  [SMALL_STATE(8463)] = 649803,
  [SMALL_STATE(8464)] = 649841,
  [SMALL_STATE(8465)] = 649865,
  [SMALL_STATE(8466)] = 649905,
  [SMALL_STATE(8467)] = 649929,
  [SMALL_STATE(8468)] = 649953,
  [SMALL_STATE(8469)] = 649977,
  [SMALL_STATE(8470)] = 650001,
  [SMALL_STATE(8471)] = 650039,
  [SMALL_STATE(8472)] = 650063,
  [SMALL_STATE(8473)] = 650087,
  [SMALL_STATE(8474)] = 650111,
  [SMALL_STATE(8475)] = 650151,
  [SMALL_STATE(8476)] = 650175,
  [SMALL_STATE(8477)] = 650213,
  [SMALL_STATE(8478)] = 650237,
  [SMALL_STATE(8479)] = 650265,
  [SMALL_STATE(8480)] = 650293,
  [SMALL_STATE(8481)] = 650321,
  [SMALL_STATE(8482)] = 650361,
  [SMALL_STATE(8483)] = 650385,
  [SMALL_STATE(8484)] = 650423,
  [SMALL_STATE(8485)] = 650447,
  [SMALL_STATE(8486)] = 650487,
  [SMALL_STATE(8487)] = 650511,
  [SMALL_STATE(8488)] = 650535,
  [SMALL_STATE(8489)] = 650563,
  [SMALL_STATE(8490)] = 650601,
  [SMALL_STATE(8491)] = 650639,
  [SMALL_STATE(8492)] = 650679,
  [SMALL_STATE(8493)] = 650719,
  [SMALL_STATE(8494)] = 650743,
  [SMALL_STATE(8495)] = 650783,
  [SMALL_STATE(8496)] = 650821,
  [SMALL_STATE(8497)] = 650845,
  [SMALL_STATE(8498)] = 650883,
  [SMALL_STATE(8499)] = 650911,
  [SMALL_STATE(8500)] = 650939,
  [SMALL_STATE(8501)] = 650963,
  [SMALL_STATE(8502)] = 650989,
  [SMALL_STATE(8503)] = 651013,
  [SMALL_STATE(8504)] = 651039,
  [SMALL_STATE(8505)] = 651077,
  [SMALL_STATE(8506)] = 651101,
  [SMALL_STATE(8507)] = 651141,
  [SMALL_STATE(8508)] = 651165,
  [SMALL_STATE(8509)] = 651205,
  [SMALL_STATE(8510)] = 651229,
  [SMALL_STATE(8511)] = 651253,
  [SMALL_STATE(8512)] = 651291,
  [SMALL_STATE(8513)] = 651315,
  [SMALL_STATE(8514)] = 651339,
  [SMALL_STATE(8515)] = 651363,
  [SMALL_STATE(8516)] = 651387,
  [SMALL_STATE(8517)] = 651411,
  [SMALL_STATE(8518)] = 651451,
  [SMALL_STATE(8519)] = 651489,
  [SMALL_STATE(8520)] = 651515,
  [SMALL_STATE(8521)] = 651538,
  [SMALL_STATE(8522)] = 651561,
  [SMALL_STATE(8523)] = 651584,
  [SMALL_STATE(8524)] = 651607,
  [SMALL_STATE(8525)] = 651630,
  [SMALL_STATE(8526)] = 651653,
  [SMALL_STATE(8527)] = 651676,
  [SMALL_STATE(8528)] = 651699,
  [SMALL_STATE(8529)] = 651722,
  [SMALL_STATE(8530)] = 651745,
  [SMALL_STATE(8531)] = 651768,
  [SMALL_STATE(8532)] = 651791,
  [SMALL_STATE(8533)] = 651818,
  [SMALL_STATE(8534)] = 651841,
  [SMALL_STATE(8535)] = 651868,
  [SMALL_STATE(8536)] = 651891,
  [SMALL_STATE(8537)] = 651914,
  [SMALL_STATE(8538)] = 651937,
  [SMALL_STATE(8539)] = 651960,
  [SMALL_STATE(8540)] = 651985,
  [SMALL_STATE(8541)] = 652012,
  [SMALL_STATE(8542)] = 652039,
  [SMALL_STATE(8543)] = 652064,
  [SMALL_STATE(8544)] = 652087,
  [SMALL_STATE(8545)] = 652110,
  [SMALL_STATE(8546)] = 652133,
  [SMALL_STATE(8547)] = 652156,
  [SMALL_STATE(8548)] = 652179,
  [SMALL_STATE(8549)] = 652202,
  [SMALL_STATE(8550)] = 652225,
  [SMALL_STATE(8551)] = 652248,
  [SMALL_STATE(8552)] = 652275,
  [SMALL_STATE(8553)] = 652302,
  [SMALL_STATE(8554)] = 652325,
  [SMALL_STATE(8555)] = 652350,
  [SMALL_STATE(8556)] = 652375,
  [SMALL_STATE(8557)] = 652398,
  [SMALL_STATE(8558)] = 652421,
  [SMALL_STATE(8559)] = 652444,
  [SMALL_STATE(8560)] = 652471,
  [SMALL_STATE(8561)] = 652494,
  [SMALL_STATE(8562)] = 652521,
  [SMALL_STATE(8563)] = 652544,
  [SMALL_STATE(8564)] = 652567,
  [SMALL_STATE(8565)] = 652590,
  [SMALL_STATE(8566)] = 652613,
  [SMALL_STATE(8567)] = 652636,
  [SMALL_STATE(8568)] = 652659,
  [SMALL_STATE(8569)] = 652682,
  [SMALL_STATE(8570)] = 652705,
  [SMALL_STATE(8571)] = 652728,
  [SMALL_STATE(8572)] = 652751,
  [SMALL_STATE(8573)] = 652774,
  [SMALL_STATE(8574)] = 652797,
  [SMALL_STATE(8575)] = 652824,
  [SMALL_STATE(8576)] = 652851,
  [SMALL_STATE(8577)] = 652874,
  [SMALL_STATE(8578)] = 652901,
  [SMALL_STATE(8579)] = 652924,
  [SMALL_STATE(8580)] = 652947,
  [SMALL_STATE(8581)] = 652970,
  [SMALL_STATE(8582)] = 652993,
  [SMALL_STATE(8583)] = 653016,
  [SMALL_STATE(8584)] = 653039,
  [SMALL_STATE(8585)] = 653062,
  [SMALL_STATE(8586)] = 653085,
  [SMALL_STATE(8587)] = 653108,
  [SMALL_STATE(8588)] = 653131,
  [SMALL_STATE(8589)] = 653154,
  [SMALL_STATE(8590)] = 653177,
  [SMALL_STATE(8591)] = 653204,
  [SMALL_STATE(8592)] = 653227,
  [SMALL_STATE(8593)] = 653250,
  [SMALL_STATE(8594)] = 653273,
  [SMALL_STATE(8595)] = 653296,
  [SMALL_STATE(8596)] = 653319,
  [SMALL_STATE(8597)] = 653342,
  [SMALL_STATE(8598)] = 653365,
  [SMALL_STATE(8599)] = 653388,
  [SMALL_STATE(8600)] = 653411,
  [SMALL_STATE(8601)] = 653434,
  [SMALL_STATE(8602)] = 653457,
  [SMALL_STATE(8603)] = 653482,
  [SMALL_STATE(8604)] = 653507,
  [SMALL_STATE(8605)] = 653530,
  [SMALL_STATE(8606)] = 653553,
  [SMALL_STATE(8607)] = 653576,
  [SMALL_STATE(8608)] = 653599,
  [SMALL_STATE(8609)] = 653622,
  [SMALL_STATE(8610)] = 653645,
  [SMALL_STATE(8611)] = 653668,
  [SMALL_STATE(8612)] = 653691,
  [SMALL_STATE(8613)] = 653714,
  [SMALL_STATE(8614)] = 653737,
  [SMALL_STATE(8615)] = 653760,
  [SMALL_STATE(8616)] = 653783,
  [SMALL_STATE(8617)] = 653806,
  [SMALL_STATE(8618)] = 653829,
  [SMALL_STATE(8619)] = 653852,
  [SMALL_STATE(8620)] = 653875,
  [SMALL_STATE(8621)] = 653898,
  [SMALL_STATE(8622)] = 653921,
  [SMALL_STATE(8623)] = 653944,
  [SMALL_STATE(8624)] = 653967,
  [SMALL_STATE(8625)] = 653990,
  [SMALL_STATE(8626)] = 654013,
  [SMALL_STATE(8627)] = 654036,
  [SMALL_STATE(8628)] = 654061,
  [SMALL_STATE(8629)] = 654084,
  [SMALL_STATE(8630)] = 654109,
  [SMALL_STATE(8631)] = 654132,
  [SMALL_STATE(8632)] = 654166,
  [SMALL_STATE(8633)] = 654200,
  [SMALL_STATE(8634)] = 654234,
  [SMALL_STATE(8635)] = 654268,
  [SMALL_STATE(8636)] = 654302,
  [SMALL_STATE(8637)] = 654336,
  [SMALL_STATE(8638)] = 654358,
  [SMALL_STATE(8639)] = 654392,
  [SMALL_STATE(8640)] = 654426,
  [SMALL_STATE(8641)] = 654460,
  [SMALL_STATE(8642)] = 654494,
  [SMALL_STATE(8643)] = 654528,
  [SMALL_STATE(8644)] = 654562,
  [SMALL_STATE(8645)] = 654596,
  [SMALL_STATE(8646)] = 654630,
  [SMALL_STATE(8647)] = 654664,
  [SMALL_STATE(8648)] = 654698,
  [SMALL_STATE(8649)] = 654732,
  [SMALL_STATE(8650)] = 654766,
  [SMALL_STATE(8651)] = 654800,
  [SMALL_STATE(8652)] = 654834,
  [SMALL_STATE(8653)] = 654868,
  [SMALL_STATE(8654)] = 654890,
  [SMALL_STATE(8655)] = 654924,
  [SMALL_STATE(8656)] = 654958,
  [SMALL_STATE(8657)] = 654992,
  [SMALL_STATE(8658)] = 655026,
  [SMALL_STATE(8659)] = 655060,
  [SMALL_STATE(8660)] = 655094,
  [SMALL_STATE(8661)] = 655128,
  [SMALL_STATE(8662)] = 655146,
  [SMALL_STATE(8663)] = 655180,
  [SMALL_STATE(8664)] = 655198,
  [SMALL_STATE(8665)] = 655222,
  [SMALL_STATE(8666)] = 655256,
  [SMALL_STATE(8667)] = 655290,
  [SMALL_STATE(8668)] = 655324,
  [SMALL_STATE(8669)] = 655346,
  [SMALL_STATE(8670)] = 655380,
  [SMALL_STATE(8671)] = 655414,
  [SMALL_STATE(8672)] = 655448,
  [SMALL_STATE(8673)] = 655482,
  [SMALL_STATE(8674)] = 655516,
  [SMALL_STATE(8675)] = 655550,
  [SMALL_STATE(8676)] = 655584,
  [SMALL_STATE(8677)] = 655618,
  [SMALL_STATE(8678)] = 655636,
  [SMALL_STATE(8679)] = 655670,
  [SMALL_STATE(8680)] = 655704,
  [SMALL_STATE(8681)] = 655738,
  [SMALL_STATE(8682)] = 655756,
  [SMALL_STATE(8683)] = 655790,
  [SMALL_STATE(8684)] = 655824,
  [SMALL_STATE(8685)] = 655858,
  [SMALL_STATE(8686)] = 655892,
  [SMALL_STATE(8687)] = 655926,
  [SMALL_STATE(8688)] = 655960,
  [SMALL_STATE(8689)] = 655994,
  [SMALL_STATE(8690)] = 656027,
  [SMALL_STATE(8691)] = 656060,
  [SMALL_STATE(8692)] = 656093,
  [SMALL_STATE(8693)] = 656126,
  [SMALL_STATE(8694)] = 656159,
  [SMALL_STATE(8695)] = 656192,
  [SMALL_STATE(8696)] = 656225,
  [SMALL_STATE(8697)] = 656258,
  [SMALL_STATE(8698)] = 656291,
  [SMALL_STATE(8699)] = 656324,
  [SMALL_STATE(8700)] = 656357,
  [SMALL_STATE(8701)] = 656390,
  [SMALL_STATE(8702)] = 656411,
  [SMALL_STATE(8703)] = 656444,
  [SMALL_STATE(8704)] = 656477,
  [SMALL_STATE(8705)] = 656510,
  [SMALL_STATE(8706)] = 656543,
  [SMALL_STATE(8707)] = 656576,
  [SMALL_STATE(8708)] = 656609,
  [SMALL_STATE(8709)] = 656642,
  [SMALL_STATE(8710)] = 656675,
  [SMALL_STATE(8711)] = 656708,
  [SMALL_STATE(8712)] = 656729,
  [SMALL_STATE(8713)] = 656762,
  [SMALL_STATE(8714)] = 656795,
  [SMALL_STATE(8715)] = 656828,
  [SMALL_STATE(8716)] = 656861,
  [SMALL_STATE(8717)] = 656894,
  [SMALL_STATE(8718)] = 656927,
  [SMALL_STATE(8719)] = 656960,
  [SMALL_STATE(8720)] = 656981,
  [SMALL_STATE(8721)] = 657014,
  [SMALL_STATE(8722)] = 657047,
  [SMALL_STATE(8723)] = 657080,
  [SMALL_STATE(8724)] = 657113,
  [SMALL_STATE(8725)] = 657146,
  [SMALL_STATE(8726)] = 657179,
  [SMALL_STATE(8727)] = 657212,
  [SMALL_STATE(8728)] = 657245,
  [SMALL_STATE(8729)] = 657278,
  [SMALL_STATE(8730)] = 657311,
  [SMALL_STATE(8731)] = 657344,
  [SMALL_STATE(8732)] = 657377,
  [SMALL_STATE(8733)] = 657410,
  [SMALL_STATE(8734)] = 657443,
  [SMALL_STATE(8735)] = 657476,
  [SMALL_STATE(8736)] = 657509,
  [SMALL_STATE(8737)] = 657542,
  [SMALL_STATE(8738)] = 657575,
  [SMALL_STATE(8739)] = 657608,
  [SMALL_STATE(8740)] = 657641,
  [SMALL_STATE(8741)] = 657674,
  [SMALL_STATE(8742)] = 657707,
  [SMALL_STATE(8743)] = 657740,
  [SMALL_STATE(8744)] = 657773,
  [SMALL_STATE(8745)] = 657806,
  [SMALL_STATE(8746)] = 657839,
  [SMALL_STATE(8747)] = 657872,
  [SMALL_STATE(8748)] = 657905,
  [SMALL_STATE(8749)] = 657926,
  [SMALL_STATE(8750)] = 657959,
  [SMALL_STATE(8751)] = 657980,
  [SMALL_STATE(8752)] = 658013,
  [SMALL_STATE(8753)] = 658046,
  [SMALL_STATE(8754)] = 658067,
  [SMALL_STATE(8755)] = 658100,
  [SMALL_STATE(8756)] = 658133,
  [SMALL_STATE(8757)] = 658166,
  [SMALL_STATE(8758)] = 658199,
  [SMALL_STATE(8759)] = 658232,
  [SMALL_STATE(8760)] = 658265,
  [SMALL_STATE(8761)] = 658298,
  [SMALL_STATE(8762)] = 658331,
  [SMALL_STATE(8763)] = 658364,
  [SMALL_STATE(8764)] = 658385,
  [SMALL_STATE(8765)] = 658418,
  [SMALL_STATE(8766)] = 658451,
  [SMALL_STATE(8767)] = 658484,
  [SMALL_STATE(8768)] = 658517,
  [SMALL_STATE(8769)] = 658538,
  [SMALL_STATE(8770)] = 658559,
  [SMALL_STATE(8771)] = 658592,
  [SMALL_STATE(8772)] = 658625,
  [SMALL_STATE(8773)] = 658658,
  [SMALL_STATE(8774)] = 658691,
  [SMALL_STATE(8775)] = 658724,
  [SMALL_STATE(8776)] = 658757,
  [SMALL_STATE(8777)] = 658790,
  [SMALL_STATE(8778)] = 658823,
  [SMALL_STATE(8779)] = 658856,
  [SMALL_STATE(8780)] = 658889,
  [SMALL_STATE(8781)] = 658922,
  [SMALL_STATE(8782)] = 658955,
  [SMALL_STATE(8783)] = 658988,
  [SMALL_STATE(8784)] = 659021,
  [SMALL_STATE(8785)] = 659054,
  [SMALL_STATE(8786)] = 659087,
  [SMALL_STATE(8787)] = 659120,
  [SMALL_STATE(8788)] = 659153,
  [SMALL_STATE(8789)] = 659186,
  [SMALL_STATE(8790)] = 659219,
  [SMALL_STATE(8791)] = 659252,
  [SMALL_STATE(8792)] = 659285,
  [SMALL_STATE(8793)] = 659318,
  [SMALL_STATE(8794)] = 659351,
  [SMALL_STATE(8795)] = 659384,
  [SMALL_STATE(8796)] = 659417,
  [SMALL_STATE(8797)] = 659450,
  [SMALL_STATE(8798)] = 659483,
  [SMALL_STATE(8799)] = 659516,
  [SMALL_STATE(8800)] = 659549,
  [SMALL_STATE(8801)] = 659582,
  [SMALL_STATE(8802)] = 659615,
  [SMALL_STATE(8803)] = 659648,
  [SMALL_STATE(8804)] = 659681,
  [SMALL_STATE(8805)] = 659702,
  [SMALL_STATE(8806)] = 659723,
  [SMALL_STATE(8807)] = 659756,
  [SMALL_STATE(8808)] = 659789,
  [SMALL_STATE(8809)] = 659822,
  [SMALL_STATE(8810)] = 659843,
  [SMALL_STATE(8811)] = 659876,
  [SMALL_STATE(8812)] = 659909,
  [SMALL_STATE(8813)] = 659942,
  [SMALL_STATE(8814)] = 659975,
  [SMALL_STATE(8815)] = 660008,
  [SMALL_STATE(8816)] = 660041,
  [SMALL_STATE(8817)] = 660074,
  [SMALL_STATE(8818)] = 660107,
  [SMALL_STATE(8819)] = 660140,
  [SMALL_STATE(8820)] = 660161,
  [SMALL_STATE(8821)] = 660194,
  [SMALL_STATE(8822)] = 660225,
  [SMALL_STATE(8823)] = 660258,
  [SMALL_STATE(8824)] = 660291,
  [SMALL_STATE(8825)] = 660324,
  [SMALL_STATE(8826)] = 660357,
  [SMALL_STATE(8827)] = 660390,
  [SMALL_STATE(8828)] = 660411,
  [SMALL_STATE(8829)] = 660432,
  [SMALL_STATE(8830)] = 660465,
  [SMALL_STATE(8831)] = 660498,
  [SMALL_STATE(8832)] = 660531,
  [SMALL_STATE(8833)] = 660552,
  [SMALL_STATE(8834)] = 660585,
  [SMALL_STATE(8835)] = 660606,
  [SMALL_STATE(8836)] = 660627,
  [SMALL_STATE(8837)] = 660648,
  [SMALL_STATE(8838)] = 660681,
  [SMALL_STATE(8839)] = 660702,
  [SMALL_STATE(8840)] = 660735,
  [SMALL_STATE(8841)] = 660756,
  [SMALL_STATE(8842)] = 660777,
  [SMALL_STATE(8843)] = 660810,
  [SMALL_STATE(8844)] = 660843,
  [SMALL_STATE(8845)] = 660864,
  [SMALL_STATE(8846)] = 660897,
  [SMALL_STATE(8847)] = 660930,
  [SMALL_STATE(8848)] = 660963,
  [SMALL_STATE(8849)] = 660990,
  [SMALL_STATE(8850)] = 661011,
  [SMALL_STATE(8851)] = 661044,
  [SMALL_STATE(8852)] = 661065,
  [SMALL_STATE(8853)] = 661098,
  [SMALL_STATE(8854)] = 661131,
  [SMALL_STATE(8855)] = 661152,
  [SMALL_STATE(8856)] = 661173,
  [SMALL_STATE(8857)] = 661194,
  [SMALL_STATE(8858)] = 661215,
  [SMALL_STATE(8859)] = 661236,
  [SMALL_STATE(8860)] = 661257,
  [SMALL_STATE(8861)] = 661290,
  [SMALL_STATE(8862)] = 661323,
  [SMALL_STATE(8863)] = 661344,
  [SMALL_STATE(8864)] = 661377,
  [SMALL_STATE(8865)] = 661410,
  [SMALL_STATE(8866)] = 661443,
  [SMALL_STATE(8867)] = 661464,
  [SMALL_STATE(8868)] = 661485,
  [SMALL_STATE(8869)] = 661518,
  [SMALL_STATE(8870)] = 661539,
  [SMALL_STATE(8871)] = 661572,
  [SMALL_STATE(8872)] = 661593,
  [SMALL_STATE(8873)] = 661626,
  [SMALL_STATE(8874)] = 661647,
  [SMALL_STATE(8875)] = 661680,
  [SMALL_STATE(8876)] = 661713,
  [SMALL_STATE(8877)] = 661746,
  [SMALL_STATE(8878)] = 661779,
  [SMALL_STATE(8879)] = 661812,
  [SMALL_STATE(8880)] = 661833,
  [SMALL_STATE(8881)] = 661854,
  [SMALL_STATE(8882)] = 661887,
  [SMALL_STATE(8883)] = 661920,
  [SMALL_STATE(8884)] = 661953,
  [SMALL_STATE(8885)] = 661986,
  [SMALL_STATE(8886)] = 662007,
  [SMALL_STATE(8887)] = 662040,
  [SMALL_STATE(8888)] = 662061,
  [SMALL_STATE(8889)] = 662094,
  [SMALL_STATE(8890)] = 662127,
  [SMALL_STATE(8891)] = 662148,
  [SMALL_STATE(8892)] = 662181,
  [SMALL_STATE(8893)] = 662214,
  [SMALL_STATE(8894)] = 662235,
  [SMALL_STATE(8895)] = 662268,
  [SMALL_STATE(8896)] = 662301,
  [SMALL_STATE(8897)] = 662334,
  [SMALL_STATE(8898)] = 662367,
  [SMALL_STATE(8899)] = 662400,
  [SMALL_STATE(8900)] = 662433,
  [SMALL_STATE(8901)] = 662466,
  [SMALL_STATE(8902)] = 662487,
  [SMALL_STATE(8903)] = 662520,
  [SMALL_STATE(8904)] = 662553,
  [SMALL_STATE(8905)] = 662586,
  [SMALL_STATE(8906)] = 662619,
  [SMALL_STATE(8907)] = 662652,
  [SMALL_STATE(8908)] = 662673,
  [SMALL_STATE(8909)] = 662694,
  [SMALL_STATE(8910)] = 662727,
  [SMALL_STATE(8911)] = 662760,
  [SMALL_STATE(8912)] = 662793,
  [SMALL_STATE(8913)] = 662826,
  [SMALL_STATE(8914)] = 662859,
  [SMALL_STATE(8915)] = 662880,
  [SMALL_STATE(8916)] = 662913,
  [SMALL_STATE(8917)] = 662946,
  [SMALL_STATE(8918)] = 662967,
  [SMALL_STATE(8919)] = 663000,
  [SMALL_STATE(8920)] = 663033,
  [SMALL_STATE(8921)] = 663066,
  [SMALL_STATE(8922)] = 663099,
  [SMALL_STATE(8923)] = 663132,
  [SMALL_STATE(8924)] = 663156,
  [SMALL_STATE(8925)] = 663172,
  [SMALL_STATE(8926)] = 663192,
  [SMALL_STATE(8927)] = 663210,
  [SMALL_STATE(8928)] = 663230,
  [SMALL_STATE(8929)] = 663250,
  [SMALL_STATE(8930)] = 663266,
  [SMALL_STATE(8931)] = 663282,
  [SMALL_STATE(8932)] = 663302,
  [SMALL_STATE(8933)] = 663322,
  [SMALL_STATE(8934)] = 663342,
  [SMALL_STATE(8935)] = 663374,
  [SMALL_STATE(8936)] = 663394,
  [SMALL_STATE(8937)] = 663426,
  [SMALL_STATE(8938)] = 663442,
  [SMALL_STATE(8939)] = 663458,
  [SMALL_STATE(8940)] = 663474,
  [SMALL_STATE(8941)] = 663494,
  [SMALL_STATE(8942)] = 663510,
  [SMALL_STATE(8943)] = 663530,
  [SMALL_STATE(8944)] = 663546,
  [SMALL_STATE(8945)] = 663562,
  [SMALL_STATE(8946)] = 663578,
  [SMALL_STATE(8947)] = 663594,
  [SMALL_STATE(8948)] = 663610,
  [SMALL_STATE(8949)] = 663626,
  [SMALL_STATE(8950)] = 663642,
  [SMALL_STATE(8951)] = 663662,
  [SMALL_STATE(8952)] = 663678,
  [SMALL_STATE(8953)] = 663694,
  [SMALL_STATE(8954)] = 663720,
  [SMALL_STATE(8955)] = 663740,
  [SMALL_STATE(8956)] = 663756,
  [SMALL_STATE(8957)] = 663776,
  [SMALL_STATE(8958)] = 663792,
  [SMALL_STATE(8959)] = 663812,
  [SMALL_STATE(8960)] = 663828,
  [SMALL_STATE(8961)] = 663848,
  [SMALL_STATE(8962)] = 663864,
  [SMALL_STATE(8963)] = 663886,
  [SMALL_STATE(8964)] = 663904,
  [SMALL_STATE(8965)] = 663920,
  [SMALL_STATE(8966)] = 663942,
  [SMALL_STATE(8967)] = 663960,
  [SMALL_STATE(8968)] = 663980,
  [SMALL_STATE(8969)] = 663996,
  [SMALL_STATE(8970)] = 664016,
  [SMALL_STATE(8971)] = 664032,
  [SMALL_STATE(8972)] = 664048,
  [SMALL_STATE(8973)] = 664068,
  [SMALL_STATE(8974)] = 664084,
  [SMALL_STATE(8975)] = 664100,
  [SMALL_STATE(8976)] = 664120,
  [SMALL_STATE(8977)] = 664136,
  [SMALL_STATE(8978)] = 664156,
  [SMALL_STATE(8979)] = 664172,
  [SMALL_STATE(8980)] = 664204,
  [SMALL_STATE(8981)] = 664224,
  [SMALL_STATE(8982)] = 664240,
  [SMALL_STATE(8983)] = 664256,
  [SMALL_STATE(8984)] = 664280,
  [SMALL_STATE(8985)] = 664300,
  [SMALL_STATE(8986)] = 664320,
  [SMALL_STATE(8987)] = 664338,
  [SMALL_STATE(8988)] = 664354,
  [SMALL_STATE(8989)] = 664370,
  [SMALL_STATE(8990)] = 664386,
  [SMALL_STATE(8991)] = 664402,
  [SMALL_STATE(8992)] = 664434,
  [SMALL_STATE(8993)] = 664450,
  [SMALL_STATE(8994)] = 664468,
  [SMALL_STATE(8995)] = 664484,
  [SMALL_STATE(8996)] = 664500,
  [SMALL_STATE(8997)] = 664516,
  [SMALL_STATE(8998)] = 664532,
  [SMALL_STATE(8999)] = 664552,
  [SMALL_STATE(9000)] = 664568,
  [SMALL_STATE(9001)] = 664584,
  [SMALL_STATE(9002)] = 664600,
  [SMALL_STATE(9003)] = 664616,
  [SMALL_STATE(9004)] = 664632,
  [SMALL_STATE(9005)] = 664655,
  [SMALL_STATE(9006)] = 664678,
  [SMALL_STATE(9007)] = 664701,
  [SMALL_STATE(9008)] = 664724,
  [SMALL_STATE(9009)] = 664743,
  [SMALL_STATE(9010)] = 664762,
  [SMALL_STATE(9011)] = 664779,
  [SMALL_STATE(9012)] = 664802,
  [SMALL_STATE(9013)] = 664819,
  [SMALL_STATE(9014)] = 664842,
  [SMALL_STATE(9015)] = 664865,
  [SMALL_STATE(9016)] = 664888,
  [SMALL_STATE(9017)] = 664907,
  [SMALL_STATE(9018)] = 664924,
  [SMALL_STATE(9019)] = 664951,
  [SMALL_STATE(9020)] = 664974,
  [SMALL_STATE(9021)] = 664997,
  [SMALL_STATE(9022)] = 665016,
  [SMALL_STATE(9023)] = 665035,
  [SMALL_STATE(9024)] = 665054,
  [SMALL_STATE(9025)] = 665077,
  [SMALL_STATE(9026)] = 665100,
  [SMALL_STATE(9027)] = 665117,
  [SMALL_STATE(9028)] = 665142,
  [SMALL_STATE(9029)] = 665167,
  [SMALL_STATE(9030)] = 665184,
  [SMALL_STATE(9031)] = 665209,
  [SMALL_STATE(9032)] = 665234,
  [SMALL_STATE(9033)] = 665253,
  [SMALL_STATE(9034)] = 665276,
  [SMALL_STATE(9035)] = 665295,
  [SMALL_STATE(9036)] = 665314,
  [SMALL_STATE(9037)] = 665331,
  [SMALL_STATE(9038)] = 665358,
  [SMALL_STATE(9039)] = 665379,
  [SMALL_STATE(9040)] = 665398,
  [SMALL_STATE(9041)] = 665421,
  [SMALL_STATE(9042)] = 665440,
  [SMALL_STATE(9043)] = 665459,
  [SMALL_STATE(9044)] = 665476,
  [SMALL_STATE(9045)] = 665495,
  [SMALL_STATE(9046)] = 665521,
  [SMALL_STATE(9047)] = 665547,
  [SMALL_STATE(9048)] = 665573,
  [SMALL_STATE(9049)] = 665599,
  [SMALL_STATE(9050)] = 665617,
  [SMALL_STATE(9051)] = 665643,
  [SMALL_STATE(9052)] = 665669,
  [SMALL_STATE(9053)] = 665687,
  [SMALL_STATE(9054)] = 665713,
  [SMALL_STATE(9055)] = 665731,
  [SMALL_STATE(9056)] = 665757,
  [SMALL_STATE(9057)] = 665783,
  [SMALL_STATE(9058)] = 665809,
  [SMALL_STATE(9059)] = 665825,
  [SMALL_STATE(9060)] = 665849,
  [SMALL_STATE(9061)] = 665875,
  [SMALL_STATE(9062)] = 665901,
  [SMALL_STATE(9063)] = 665919,
  [SMALL_STATE(9064)] = 665945,
  [SMALL_STATE(9065)] = 665971,
  [SMALL_STATE(9066)] = 665997,
  [SMALL_STATE(9067)] = 666023,
  [SMALL_STATE(9068)] = 666043,
  [SMALL_STATE(9069)] = 666069,
  [SMALL_STATE(9070)] = 666095,
  [SMALL_STATE(9071)] = 666121,
  [SMALL_STATE(9072)] = 666139,
  [SMALL_STATE(9073)] = 666157,
  [SMALL_STATE(9074)] = 666183,
  [SMALL_STATE(9075)] = 666201,
  [SMALL_STATE(9076)] = 666227,
  [SMALL_STATE(9077)] = 666243,
  [SMALL_STATE(9078)] = 666269,
  [SMALL_STATE(9079)] = 666295,
  [SMALL_STATE(9080)] = 666321,
  [SMALL_STATE(9081)] = 666347,
  [SMALL_STATE(9082)] = 666373,
  [SMALL_STATE(9083)] = 666399,
  [SMALL_STATE(9084)] = 666425,
  [SMALL_STATE(9085)] = 666449,
  [SMALL_STATE(9086)] = 666475,
  [SMALL_STATE(9087)] = 666501,
  [SMALL_STATE(9088)] = 666515,
  [SMALL_STATE(9089)] = 666539,
  [SMALL_STATE(9090)] = 666565,
  [SMALL_STATE(9091)] = 666591,
  [SMALL_STATE(9092)] = 666613,
  [SMALL_STATE(9093)] = 666627,
  [SMALL_STATE(9094)] = 666651,
  [SMALL_STATE(9095)] = 666677,
  [SMALL_STATE(9096)] = 666703,
  [SMALL_STATE(9097)] = 666727,
  [SMALL_STATE(9098)] = 666753,
  [SMALL_STATE(9099)] = 666779,
  [SMALL_STATE(9100)] = 666797,
  [SMALL_STATE(9101)] = 666815,
  [SMALL_STATE(9102)] = 666841,
  [SMALL_STATE(9103)] = 666867,
  [SMALL_STATE(9104)] = 666891,
  [SMALL_STATE(9105)] = 666917,
  [SMALL_STATE(9106)] = 666933,
  [SMALL_STATE(9107)] = 666959,
  [SMALL_STATE(9108)] = 666985,
  [SMALL_STATE(9109)] = 667003,
  [SMALL_STATE(9110)] = 667029,
  [SMALL_STATE(9111)] = 667051,
  [SMALL_STATE(9112)] = 667077,
  [SMALL_STATE(9113)] = 667095,
  [SMALL_STATE(9114)] = 667121,
  [SMALL_STATE(9115)] = 667145,
  [SMALL_STATE(9116)] = 667169,
  [SMALL_STATE(9117)] = 667187,
  [SMALL_STATE(9118)] = 667211,
  [SMALL_STATE(9119)] = 667229,
  [SMALL_STATE(9120)] = 667255,
  [SMALL_STATE(9121)] = 667281,
  [SMALL_STATE(9122)] = 667295,
  [SMALL_STATE(9123)] = 667321,
  [SMALL_STATE(9124)] = 667345,
  [SMALL_STATE(9125)] = 667369,
  [SMALL_STATE(9126)] = 667385,
  [SMALL_STATE(9127)] = 667411,
  [SMALL_STATE(9128)] = 667437,
  [SMALL_STATE(9129)] = 667463,
  [SMALL_STATE(9130)] = 667481,
  [SMALL_STATE(9131)] = 667505,
  [SMALL_STATE(9132)] = 667531,
  [SMALL_STATE(9133)] = 667557,
  [SMALL_STATE(9134)] = 667583,
  [SMALL_STATE(9135)] = 667609,
  [SMALL_STATE(9136)] = 667623,
  [SMALL_STATE(9137)] = 667649,
  [SMALL_STATE(9138)] = 667663,
  [SMALL_STATE(9139)] = 667681,
  [SMALL_STATE(9140)] = 667699,
  [SMALL_STATE(9141)] = 667725,
  [SMALL_STATE(9142)] = 667742,
  [SMALL_STATE(9143)] = 667759,
  [SMALL_STATE(9144)] = 667776,
  [SMALL_STATE(9145)] = 667793,
  [SMALL_STATE(9146)] = 667816,
  [SMALL_STATE(9147)] = 667833,
  [SMALL_STATE(9148)] = 667850,
  [SMALL_STATE(9149)] = 667865,
  [SMALL_STATE(9150)] = 667878,
  [SMALL_STATE(9151)] = 667891,
  [SMALL_STATE(9152)] = 667908,
  [SMALL_STATE(9153)] = 667931,
  [SMALL_STATE(9154)] = 667948,
  [SMALL_STATE(9155)] = 667965,
  [SMALL_STATE(9156)] = 667988,
  [SMALL_STATE(9157)] = 668005,
  [SMALL_STATE(9158)] = 668020,
  [SMALL_STATE(9159)] = 668041,
  [SMALL_STATE(9160)] = 668062,
  [SMALL_STATE(9161)] = 668079,
  [SMALL_STATE(9162)] = 668096,
  [SMALL_STATE(9163)] = 668111,
  [SMALL_STATE(9164)] = 668128,
  [SMALL_STATE(9165)] = 668143,
  [SMALL_STATE(9166)] = 668158,
  [SMALL_STATE(9167)] = 668171,
  [SMALL_STATE(9168)] = 668186,
  [SMALL_STATE(9169)] = 668199,
  [SMALL_STATE(9170)] = 668216,
  [SMALL_STATE(9171)] = 668233,
  [SMALL_STATE(9172)] = 668256,
  [SMALL_STATE(9173)] = 668277,
  [SMALL_STATE(9174)] = 668290,
  [SMALL_STATE(9175)] = 668313,
  [SMALL_STATE(9176)] = 668336,
  [SMALL_STATE(9177)] = 668349,
  [SMALL_STATE(9178)] = 668362,
  [SMALL_STATE(9179)] = 668379,
  [SMALL_STATE(9180)] = 668396,
  [SMALL_STATE(9181)] = 668417,
  [SMALL_STATE(9182)] = 668434,
  [SMALL_STATE(9183)] = 668447,
  [SMALL_STATE(9184)] = 668468,
  [SMALL_STATE(9185)] = 668489,
  [SMALL_STATE(9186)] = 668511,
  [SMALL_STATE(9187)] = 668533,
  [SMALL_STATE(9188)] = 668555,
  [SMALL_STATE(9189)] = 668577,
  [SMALL_STATE(9190)] = 668599,
  [SMALL_STATE(9191)] = 668621,
  [SMALL_STATE(9192)] = 668643,
  [SMALL_STATE(9193)] = 668665,
  [SMALL_STATE(9194)] = 668687,
  [SMALL_STATE(9195)] = 668709,
  [SMALL_STATE(9196)] = 668731,
  [SMALL_STATE(9197)] = 668753,
  [SMALL_STATE(9198)] = 668775,
  [SMALL_STATE(9199)] = 668797,
  [SMALL_STATE(9200)] = 668819,
  [SMALL_STATE(9201)] = 668841,
  [SMALL_STATE(9202)] = 668863,
  [SMALL_STATE(9203)] = 668885,
  [SMALL_STATE(9204)] = 668907,
  [SMALL_STATE(9205)] = 668929,
  [SMALL_STATE(9206)] = 668951,
  [SMALL_STATE(9207)] = 668973,
  [SMALL_STATE(9208)] = 668989,
  [SMALL_STATE(9209)] = 669011,
  [SMALL_STATE(9210)] = 669033,
  [SMALL_STATE(9211)] = 669055,
  [SMALL_STATE(9212)] = 669077,
  [SMALL_STATE(9213)] = 669099,
  [SMALL_STATE(9214)] = 669121,
  [SMALL_STATE(9215)] = 669141,
  [SMALL_STATE(9216)] = 669163,
  [SMALL_STATE(9217)] = 669185,
  [SMALL_STATE(9218)] = 669207,
  [SMALL_STATE(9219)] = 669229,
  [SMALL_STATE(9220)] = 669251,
  [SMALL_STATE(9221)] = 669273,
  [SMALL_STATE(9222)] = 669295,
  [SMALL_STATE(9223)] = 669317,
  [SMALL_STATE(9224)] = 669339,
  [SMALL_STATE(9225)] = 669361,
  [SMALL_STATE(9226)] = 669383,
  [SMALL_STATE(9227)] = 669405,
  [SMALL_STATE(9228)] = 669427,
  [SMALL_STATE(9229)] = 669441,
  [SMALL_STATE(9230)] = 669457,
  [SMALL_STATE(9231)] = 669479,
  [SMALL_STATE(9232)] = 669501,
  [SMALL_STATE(9233)] = 669517,
  [SMALL_STATE(9234)] = 669539,
  [SMALL_STATE(9235)] = 669561,
  [SMALL_STATE(9236)] = 669583,
  [SMALL_STATE(9237)] = 669605,
  [SMALL_STATE(9238)] = 669627,
  [SMALL_STATE(9239)] = 669649,
  [SMALL_STATE(9240)] = 669671,
  [SMALL_STATE(9241)] = 669693,
  [SMALL_STATE(9242)] = 669715,
  [SMALL_STATE(9243)] = 669733,
  [SMALL_STATE(9244)] = 669755,
  [SMALL_STATE(9245)] = 669777,
  [SMALL_STATE(9246)] = 669799,
  [SMALL_STATE(9247)] = 669821,
  [SMALL_STATE(9248)] = 669843,
  [SMALL_STATE(9249)] = 669865,
  [SMALL_STATE(9250)] = 669887,
  [SMALL_STATE(9251)] = 669909,
  [SMALL_STATE(9252)] = 669925,
  [SMALL_STATE(9253)] = 669947,
  [SMALL_STATE(9254)] = 669969,
  [SMALL_STATE(9255)] = 669991,
  [SMALL_STATE(9256)] = 670013,
  [SMALL_STATE(9257)] = 670035,
  [SMALL_STATE(9258)] = 670057,
  [SMALL_STATE(9259)] = 670079,
  [SMALL_STATE(9260)] = 670101,
  [SMALL_STATE(9261)] = 670123,
  [SMALL_STATE(9262)] = 670145,
  [SMALL_STATE(9263)] = 670167,
  [SMALL_STATE(9264)] = 670183,
  [SMALL_STATE(9265)] = 670205,
  [SMALL_STATE(9266)] = 670227,
  [SMALL_STATE(9267)] = 670249,
  [SMALL_STATE(9268)] = 670263,
  [SMALL_STATE(9269)] = 670285,
  [SMALL_STATE(9270)] = 670307,
  [SMALL_STATE(9271)] = 670329,
  [SMALL_STATE(9272)] = 670351,
  [SMALL_STATE(9273)] = 670373,
  [SMALL_STATE(9274)] = 670395,
  [SMALL_STATE(9275)] = 670417,
  [SMALL_STATE(9276)] = 670439,
  [SMALL_STATE(9277)] = 670461,
  [SMALL_STATE(9278)] = 670483,
  [SMALL_STATE(9279)] = 670503,
  [SMALL_STATE(9280)] = 670525,
  [SMALL_STATE(9281)] = 670547,
  [SMALL_STATE(9282)] = 670569,
  [SMALL_STATE(9283)] = 670591,
  [SMALL_STATE(9284)] = 670611,
  [SMALL_STATE(9285)] = 670633,
  [SMALL_STATE(9286)] = 670655,
  [SMALL_STATE(9287)] = 670675,
  [SMALL_STATE(9288)] = 670697,
  [SMALL_STATE(9289)] = 670719,
  [SMALL_STATE(9290)] = 670741,
  [SMALL_STATE(9291)] = 670763,
  [SMALL_STATE(9292)] = 670785,
  [SMALL_STATE(9293)] = 670807,
  [SMALL_STATE(9294)] = 670827,
  [SMALL_STATE(9295)] = 670849,
  [SMALL_STATE(9296)] = 670871,
  [SMALL_STATE(9297)] = 670893,
  [SMALL_STATE(9298)] = 670915,
  [SMALL_STATE(9299)] = 670937,
  [SMALL_STATE(9300)] = 670955,
  [SMALL_STATE(9301)] = 670977,
  [SMALL_STATE(9302)] = 670999,
  [SMALL_STATE(9303)] = 671021,
  [SMALL_STATE(9304)] = 671043,
  [SMALL_STATE(9305)] = 671065,
  [SMALL_STATE(9306)] = 671087,
  [SMALL_STATE(9307)] = 671109,
  [SMALL_STATE(9308)] = 671131,
  [SMALL_STATE(9309)] = 671153,
  [SMALL_STATE(9310)] = 671175,
  [SMALL_STATE(9311)] = 671197,
  [SMALL_STATE(9312)] = 671217,
  [SMALL_STATE(9313)] = 671237,
  [SMALL_STATE(9314)] = 671259,
  [SMALL_STATE(9315)] = 671281,
  [SMALL_STATE(9316)] = 671301,
  [SMALL_STATE(9317)] = 671323,
  [SMALL_STATE(9318)] = 671341,
  [SMALL_STATE(9319)] = 671363,
  [SMALL_STATE(9320)] = 671385,
  [SMALL_STATE(9321)] = 671407,
  [SMALL_STATE(9322)] = 671429,
  [SMALL_STATE(9323)] = 671451,
  [SMALL_STATE(9324)] = 671471,
  [SMALL_STATE(9325)] = 671493,
  [SMALL_STATE(9326)] = 671515,
  [SMALL_STATE(9327)] = 671537,
  [SMALL_STATE(9328)] = 671559,
  [SMALL_STATE(9329)] = 671581,
  [SMALL_STATE(9330)] = 671603,
  [SMALL_STATE(9331)] = 671619,
  [SMALL_STATE(9332)] = 671641,
  [SMALL_STATE(9333)] = 671663,
  [SMALL_STATE(9334)] = 671685,
  [SMALL_STATE(9335)] = 671707,
  [SMALL_STATE(9336)] = 671729,
  [SMALL_STATE(9337)] = 671751,
  [SMALL_STATE(9338)] = 671773,
  [SMALL_STATE(9339)] = 671795,
  [SMALL_STATE(9340)] = 671815,
  [SMALL_STATE(9341)] = 671837,
  [SMALL_STATE(9342)] = 671859,
  [SMALL_STATE(9343)] = 671881,
  [SMALL_STATE(9344)] = 671903,
  [SMALL_STATE(9345)] = 671925,
  [SMALL_STATE(9346)] = 671945,
  [SMALL_STATE(9347)] = 671967,
  [SMALL_STATE(9348)] = 671989,
  [SMALL_STATE(9349)] = 672011,
  [SMALL_STATE(9350)] = 672033,
  [SMALL_STATE(9351)] = 672055,
  [SMALL_STATE(9352)] = 672069,
  [SMALL_STATE(9353)] = 672091,
  [SMALL_STATE(9354)] = 672113,
  [SMALL_STATE(9355)] = 672135,
  [SMALL_STATE(9356)] = 672157,
  [SMALL_STATE(9357)] = 672173,
  [SMALL_STATE(9358)] = 672195,
  [SMALL_STATE(9359)] = 672217,
  [SMALL_STATE(9360)] = 672239,
  [SMALL_STATE(9361)] = 672261,
  [SMALL_STATE(9362)] = 672283,
  [SMALL_STATE(9363)] = 672305,
  [SMALL_STATE(9364)] = 672327,
  [SMALL_STATE(9365)] = 672349,
  [SMALL_STATE(9366)] = 672371,
  [SMALL_STATE(9367)] = 672393,
  [SMALL_STATE(9368)] = 672415,
  [SMALL_STATE(9369)] = 672437,
  [SMALL_STATE(9370)] = 672459,
  [SMALL_STATE(9371)] = 672481,
  [SMALL_STATE(9372)] = 672503,
  [SMALL_STATE(9373)] = 672517,
  [SMALL_STATE(9374)] = 672539,
  [SMALL_STATE(9375)] = 672561,
  [SMALL_STATE(9376)] = 672583,
  [SMALL_STATE(9377)] = 672605,
  [SMALL_STATE(9378)] = 672627,
  [SMALL_STATE(9379)] = 672649,
  [SMALL_STATE(9380)] = 672671,
  [SMALL_STATE(9381)] = 672687,
  [SMALL_STATE(9382)] = 672709,
  [SMALL_STATE(9383)] = 672731,
  [SMALL_STATE(9384)] = 672753,
  [SMALL_STATE(9385)] = 672775,
  [SMALL_STATE(9386)] = 672797,
  [SMALL_STATE(9387)] = 672819,
  [SMALL_STATE(9388)] = 672841,
  [SMALL_STATE(9389)] = 672861,
  [SMALL_STATE(9390)] = 672883,
  [SMALL_STATE(9391)] = 672905,
  [SMALL_STATE(9392)] = 672927,
  [SMALL_STATE(9393)] = 672947,
  [SMALL_STATE(9394)] = 672969,
  [SMALL_STATE(9395)] = 672991,
  [SMALL_STATE(9396)] = 673013,
  [SMALL_STATE(9397)] = 673033,
  [SMALL_STATE(9398)] = 673053,
  [SMALL_STATE(9399)] = 673071,
  [SMALL_STATE(9400)] = 673085,
  [SMALL_STATE(9401)] = 673107,
  [SMALL_STATE(9402)] = 673129,
  [SMALL_STATE(9403)] = 673151,
  [SMALL_STATE(9404)] = 673173,
  [SMALL_STATE(9405)] = 673186,
  [SMALL_STATE(9406)] = 673197,
  [SMALL_STATE(9407)] = 673210,
  [SMALL_STATE(9408)] = 673225,
  [SMALL_STATE(9409)] = 673244,
  [SMALL_STATE(9410)] = 673261,
  [SMALL_STATE(9411)] = 673278,
  [SMALL_STATE(9412)] = 673297,
  [SMALL_STATE(9413)] = 673314,
  [SMALL_STATE(9414)] = 673329,
  [SMALL_STATE(9415)] = 673346,
  [SMALL_STATE(9416)] = 673357,
  [SMALL_STATE(9417)] = 673374,
  [SMALL_STATE(9418)] = 673391,
  [SMALL_STATE(9419)] = 673404,
  [SMALL_STATE(9420)] = 673419,
  [SMALL_STATE(9421)] = 673434,
  [SMALL_STATE(9422)] = 673451,
  [SMALL_STATE(9423)] = 673468,
  [SMALL_STATE(9424)] = 673481,
  [SMALL_STATE(9425)] = 673498,
  [SMALL_STATE(9426)] = 673515,
  [SMALL_STATE(9427)] = 673528,
  [SMALL_STATE(9428)] = 673543,
  [SMALL_STATE(9429)] = 673558,
  [SMALL_STATE(9430)] = 673573,
  [SMALL_STATE(9431)] = 673588,
  [SMALL_STATE(9432)] = 673599,
  [SMALL_STATE(9433)] = 673610,
  [SMALL_STATE(9434)] = 673625,
  [SMALL_STATE(9435)] = 673640,
  [SMALL_STATE(9436)] = 673655,
  [SMALL_STATE(9437)] = 673670,
  [SMALL_STATE(9438)] = 673685,
  [SMALL_STATE(9439)] = 673700,
  [SMALL_STATE(9440)] = 673715,
  [SMALL_STATE(9441)] = 673728,
  [SMALL_STATE(9442)] = 673745,
  [SMALL_STATE(9443)] = 673762,
  [SMALL_STATE(9444)] = 673779,
  [SMALL_STATE(9445)] = 673792,
  [SMALL_STATE(9446)] = 673805,
  [SMALL_STATE(9447)] = 673816,
  [SMALL_STATE(9448)] = 673833,
  [SMALL_STATE(9449)] = 673844,
  [SMALL_STATE(9450)] = 673861,
  [SMALL_STATE(9451)] = 673880,
  [SMALL_STATE(9452)] = 673899,
  [SMALL_STATE(9453)] = 673916,
  [SMALL_STATE(9454)] = 673931,
  [SMALL_STATE(9455)] = 673942,
  [SMALL_STATE(9456)] = 673957,
  [SMALL_STATE(9457)] = 673968,
  [SMALL_STATE(9458)] = 673983,
  [SMALL_STATE(9459)] = 673994,
  [SMALL_STATE(9460)] = 674005,
  [SMALL_STATE(9461)] = 674016,
  [SMALL_STATE(9462)] = 674029,
  [SMALL_STATE(9463)] = 674044,
  [SMALL_STATE(9464)] = 674061,
  [SMALL_STATE(9465)] = 674078,
  [SMALL_STATE(9466)] = 674089,
  [SMALL_STATE(9467)] = 674100,
  [SMALL_STATE(9468)] = 674111,
  [SMALL_STATE(9469)] = 674126,
  [SMALL_STATE(9470)] = 674137,
  [SMALL_STATE(9471)] = 674148,
  [SMALL_STATE(9472)] = 674159,
  [SMALL_STATE(9473)] = 674170,
  [SMALL_STATE(9474)] = 674183,
  [SMALL_STATE(9475)] = 674194,
  [SMALL_STATE(9476)] = 674205,
  [SMALL_STATE(9477)] = 674216,
  [SMALL_STATE(9478)] = 674231,
  [SMALL_STATE(9479)] = 674242,
  [SMALL_STATE(9480)] = 674253,
  [SMALL_STATE(9481)] = 674264,
  [SMALL_STATE(9482)] = 674275,
  [SMALL_STATE(9483)] = 674290,
  [SMALL_STATE(9484)] = 674305,
  [SMALL_STATE(9485)] = 674320,
  [SMALL_STATE(9486)] = 674335,
  [SMALL_STATE(9487)] = 674348,
  [SMALL_STATE(9488)] = 674365,
  [SMALL_STATE(9489)] = 674380,
  [SMALL_STATE(9490)] = 674395,
  [SMALL_STATE(9491)] = 674409,
  [SMALL_STATE(9492)] = 674423,
  [SMALL_STATE(9493)] = 674437,
  [SMALL_STATE(9494)] = 674451,
  [SMALL_STATE(9495)] = 674465,
  [SMALL_STATE(9496)] = 674479,
  [SMALL_STATE(9497)] = 674493,
  [SMALL_STATE(9498)] = 674507,
  [SMALL_STATE(9499)] = 674521,
  [SMALL_STATE(9500)] = 674535,
  [SMALL_STATE(9501)] = 674549,
  [SMALL_STATE(9502)] = 674563,
  [SMALL_STATE(9503)] = 674577,
  [SMALL_STATE(9504)] = 674591,
  [SMALL_STATE(9505)] = 674605,
  [SMALL_STATE(9506)] = 674619,
  [SMALL_STATE(9507)] = 674633,
  [SMALL_STATE(9508)] = 674647,
  [SMALL_STATE(9509)] = 674661,
  [SMALL_STATE(9510)] = 674675,
  [SMALL_STATE(9511)] = 674689,
  [SMALL_STATE(9512)] = 674703,
  [SMALL_STATE(9513)] = 674717,
  [SMALL_STATE(9514)] = 674731,
  [SMALL_STATE(9515)] = 674745,
  [SMALL_STATE(9516)] = 674759,
  [SMALL_STATE(9517)] = 674773,
  [SMALL_STATE(9518)] = 674787,
  [SMALL_STATE(9519)] = 674799,
  [SMALL_STATE(9520)] = 674813,
  [SMALL_STATE(9521)] = 674827,
  [SMALL_STATE(9522)] = 674839,
  [SMALL_STATE(9523)] = 674853,
  [SMALL_STATE(9524)] = 674867,
  [SMALL_STATE(9525)] = 674881,
  [SMALL_STATE(9526)] = 674895,
  [SMALL_STATE(9527)] = 674909,
  [SMALL_STATE(9528)] = 674921,
  [SMALL_STATE(9529)] = 674935,
  [SMALL_STATE(9530)] = 674949,
  [SMALL_STATE(9531)] = 674961,
  [SMALL_STATE(9532)] = 674975,
  [SMALL_STATE(9533)] = 674989,
  [SMALL_STATE(9534)] = 675003,
  [SMALL_STATE(9535)] = 675017,
  [SMALL_STATE(9536)] = 675031,
  [SMALL_STATE(9537)] = 675045,
  [SMALL_STATE(9538)] = 675057,
  [SMALL_STATE(9539)] = 675071,
  [SMALL_STATE(9540)] = 675085,
  [SMALL_STATE(9541)] = 675097,
  [SMALL_STATE(9542)] = 675111,
  [SMALL_STATE(9543)] = 675125,
  [SMALL_STATE(9544)] = 675139,
  [SMALL_STATE(9545)] = 675153,
  [SMALL_STATE(9546)] = 675167,
  [SMALL_STATE(9547)] = 675183,
  [SMALL_STATE(9548)] = 675197,
  [SMALL_STATE(9549)] = 675209,
  [SMALL_STATE(9550)] = 675223,
  [SMALL_STATE(9551)] = 675237,
  [SMALL_STATE(9552)] = 675251,
  [SMALL_STATE(9553)] = 675265,
  [SMALL_STATE(9554)] = 675279,
  [SMALL_STATE(9555)] = 675293,
  [SMALL_STATE(9556)] = 675307,
  [SMALL_STATE(9557)] = 675321,
  [SMALL_STATE(9558)] = 675335,
  [SMALL_STATE(9559)] = 675349,
  [SMALL_STATE(9560)] = 675361,
  [SMALL_STATE(9561)] = 675375,
  [SMALL_STATE(9562)] = 675389,
  [SMALL_STATE(9563)] = 675403,
  [SMALL_STATE(9564)] = 675417,
  [SMALL_STATE(9565)] = 675433,
  [SMALL_STATE(9566)] = 675447,
  [SMALL_STATE(9567)] = 675461,
  [SMALL_STATE(9568)] = 675475,
  [SMALL_STATE(9569)] = 675489,
  [SMALL_STATE(9570)] = 675505,
  [SMALL_STATE(9571)] = 675519,
  [SMALL_STATE(9572)] = 675531,
  [SMALL_STATE(9573)] = 675543,
  [SMALL_STATE(9574)] = 675557,
  [SMALL_STATE(9575)] = 675571,
  [SMALL_STATE(9576)] = 675585,
  [SMALL_STATE(9577)] = 675599,
  [SMALL_STATE(9578)] = 675613,
  [SMALL_STATE(9579)] = 675629,
  [SMALL_STATE(9580)] = 675643,
  [SMALL_STATE(9581)] = 675657,
  [SMALL_STATE(9582)] = 675669,
  [SMALL_STATE(9583)] = 675683,
  [SMALL_STATE(9584)] = 675697,
  [SMALL_STATE(9585)] = 675711,
  [SMALL_STATE(9586)] = 675725,
  [SMALL_STATE(9587)] = 675739,
  [SMALL_STATE(9588)] = 675753,
  [SMALL_STATE(9589)] = 675767,
  [SMALL_STATE(9590)] = 675781,
  [SMALL_STATE(9591)] = 675795,
  [SMALL_STATE(9592)] = 675809,
  [SMALL_STATE(9593)] = 675823,
  [SMALL_STATE(9594)] = 675837,
  [SMALL_STATE(9595)] = 675851,
  [SMALL_STATE(9596)] = 675865,
  [SMALL_STATE(9597)] = 675877,
  [SMALL_STATE(9598)] = 675891,
  [SMALL_STATE(9599)] = 675905,
  [SMALL_STATE(9600)] = 675917,
  [SMALL_STATE(9601)] = 675931,
  [SMALL_STATE(9602)] = 675945,
  [SMALL_STATE(9603)] = 675959,
  [SMALL_STATE(9604)] = 675973,
  [SMALL_STATE(9605)] = 675987,
  [SMALL_STATE(9606)] = 675999,
  [SMALL_STATE(9607)] = 676013,
  [SMALL_STATE(9608)] = 676025,
  [SMALL_STATE(9609)] = 676039,
  [SMALL_STATE(9610)] = 676053,
  [SMALL_STATE(9611)] = 676067,
  [SMALL_STATE(9612)] = 676081,
  [SMALL_STATE(9613)] = 676095,
  [SMALL_STATE(9614)] = 676109,
  [SMALL_STATE(9615)] = 676123,
  [SMALL_STATE(9616)] = 676137,
  [SMALL_STATE(9617)] = 676151,
  [SMALL_STATE(9618)] = 676167,
  [SMALL_STATE(9619)] = 676181,
  [SMALL_STATE(9620)] = 676195,
  [SMALL_STATE(9621)] = 676209,
  [SMALL_STATE(9622)] = 676221,
  [SMALL_STATE(9623)] = 676235,
  [SMALL_STATE(9624)] = 676249,
  [SMALL_STATE(9625)] = 676261,
  [SMALL_STATE(9626)] = 676275,
  [SMALL_STATE(9627)] = 676287,
  [SMALL_STATE(9628)] = 676301,
  [SMALL_STATE(9629)] = 676315,
  [SMALL_STATE(9630)] = 676329,
  [SMALL_STATE(9631)] = 676345,
  [SMALL_STATE(9632)] = 676361,
  [SMALL_STATE(9633)] = 676375,
  [SMALL_STATE(9634)] = 676389,
  [SMALL_STATE(9635)] = 676403,
  [SMALL_STATE(9636)] = 676415,
  [SMALL_STATE(9637)] = 676429,
  [SMALL_STATE(9638)] = 676443,
  [SMALL_STATE(9639)] = 676457,
  [SMALL_STATE(9640)] = 676471,
  [SMALL_STATE(9641)] = 676485,
  [SMALL_STATE(9642)] = 676497,
  [SMALL_STATE(9643)] = 676511,
  [SMALL_STATE(9644)] = 676525,
  [SMALL_STATE(9645)] = 676539,
  [SMALL_STATE(9646)] = 676555,
  [SMALL_STATE(9647)] = 676569,
  [SMALL_STATE(9648)] = 676583,
  [SMALL_STATE(9649)] = 676599,
  [SMALL_STATE(9650)] = 676613,
  [SMALL_STATE(9651)] = 676629,
  [SMALL_STATE(9652)] = 676641,
  [SMALL_STATE(9653)] = 676655,
  [SMALL_STATE(9654)] = 676669,
  [SMALL_STATE(9655)] = 676683,
  [SMALL_STATE(9656)] = 676695,
  [SMALL_STATE(9657)] = 676709,
  [SMALL_STATE(9658)] = 676723,
  [SMALL_STATE(9659)] = 676737,
  [SMALL_STATE(9660)] = 676751,
  [SMALL_STATE(9661)] = 676765,
  [SMALL_STATE(9662)] = 676779,
  [SMALL_STATE(9663)] = 676793,
  [SMALL_STATE(9664)] = 676807,
  [SMALL_STATE(9665)] = 676821,
  [SMALL_STATE(9666)] = 676835,
  [SMALL_STATE(9667)] = 676849,
  [SMALL_STATE(9668)] = 676865,
  [SMALL_STATE(9669)] = 676877,
  [SMALL_STATE(9670)] = 676891,
  [SMALL_STATE(9671)] = 676905,
  [SMALL_STATE(9672)] = 676919,
  [SMALL_STATE(9673)] = 676933,
  [SMALL_STATE(9674)] = 676945,
  [SMALL_STATE(9675)] = 676959,
  [SMALL_STATE(9676)] = 676973,
  [SMALL_STATE(9677)] = 676987,
  [SMALL_STATE(9678)] = 677001,
  [SMALL_STATE(9679)] = 677013,
  [SMALL_STATE(9680)] = 677027,
  [SMALL_STATE(9681)] = 677039,
  [SMALL_STATE(9682)] = 677053,
  [SMALL_STATE(9683)] = 677067,
  [SMALL_STATE(9684)] = 677081,
  [SMALL_STATE(9685)] = 677095,
  [SMALL_STATE(9686)] = 677107,
  [SMALL_STATE(9687)] = 677121,
  [SMALL_STATE(9688)] = 677133,
  [SMALL_STATE(9689)] = 677147,
  [SMALL_STATE(9690)] = 677161,
  [SMALL_STATE(9691)] = 677175,
  [SMALL_STATE(9692)] = 677189,
  [SMALL_STATE(9693)] = 677203,
  [SMALL_STATE(9694)] = 677213,
  [SMALL_STATE(9695)] = 677227,
  [SMALL_STATE(9696)] = 677238,
  [SMALL_STATE(9697)] = 677249,
  [SMALL_STATE(9698)] = 677260,
  [SMALL_STATE(9699)] = 677271,
  [SMALL_STATE(9700)] = 677282,
  [SMALL_STATE(9701)] = 677293,
  [SMALL_STATE(9702)] = 677304,
  [SMALL_STATE(9703)] = 677315,
  [SMALL_STATE(9704)] = 677326,
  [SMALL_STATE(9705)] = 677337,
  [SMALL_STATE(9706)] = 677348,
  [SMALL_STATE(9707)] = 677359,
  [SMALL_STATE(9708)] = 677370,
  [SMALL_STATE(9709)] = 677381,
  [SMALL_STATE(9710)] = 677392,
  [SMALL_STATE(9711)] = 677403,
  [SMALL_STATE(9712)] = 677414,
  [SMALL_STATE(9713)] = 677425,
  [SMALL_STATE(9714)] = 677436,
  [SMALL_STATE(9715)] = 677447,
  [SMALL_STATE(9716)] = 677458,
  [SMALL_STATE(9717)] = 677467,
  [SMALL_STATE(9718)] = 677478,
  [SMALL_STATE(9719)] = 677489,
  [SMALL_STATE(9720)] = 677500,
  [SMALL_STATE(9721)] = 677511,
  [SMALL_STATE(9722)] = 677522,
  [SMALL_STATE(9723)] = 677533,
  [SMALL_STATE(9724)] = 677544,
  [SMALL_STATE(9725)] = 677555,
  [SMALL_STATE(9726)] = 677566,
  [SMALL_STATE(9727)] = 677577,
  [SMALL_STATE(9728)] = 677588,
  [SMALL_STATE(9729)] = 677599,
  [SMALL_STATE(9730)] = 677610,
  [SMALL_STATE(9731)] = 677621,
  [SMALL_STATE(9732)] = 677632,
  [SMALL_STATE(9733)] = 677643,
  [SMALL_STATE(9734)] = 677654,
  [SMALL_STATE(9735)] = 677665,
  [SMALL_STATE(9736)] = 677676,
  [SMALL_STATE(9737)] = 677687,
  [SMALL_STATE(9738)] = 677698,
  [SMALL_STATE(9739)] = 677709,
  [SMALL_STATE(9740)] = 677720,
  [SMALL_STATE(9741)] = 677731,
  [SMALL_STATE(9742)] = 677742,
  [SMALL_STATE(9743)] = 677753,
  [SMALL_STATE(9744)] = 677764,
  [SMALL_STATE(9745)] = 677775,
  [SMALL_STATE(9746)] = 677786,
  [SMALL_STATE(9747)] = 677797,
  [SMALL_STATE(9748)] = 677808,
  [SMALL_STATE(9749)] = 677819,
  [SMALL_STATE(9750)] = 677830,
  [SMALL_STATE(9751)] = 677841,
  [SMALL_STATE(9752)] = 677852,
  [SMALL_STATE(9753)] = 677863,
  [SMALL_STATE(9754)] = 677874,
  [SMALL_STATE(9755)] = 677885,
  [SMALL_STATE(9756)] = 677896,
  [SMALL_STATE(9757)] = 677907,
  [SMALL_STATE(9758)] = 677918,
  [SMALL_STATE(9759)] = 677929,
  [SMALL_STATE(9760)] = 677940,
  [SMALL_STATE(9761)] = 677951,
  [SMALL_STATE(9762)] = 677962,
  [SMALL_STATE(9763)] = 677973,
  [SMALL_STATE(9764)] = 677982,
  [SMALL_STATE(9765)] = 677993,
  [SMALL_STATE(9766)] = 678004,
  [SMALL_STATE(9767)] = 678015,
  [SMALL_STATE(9768)] = 678026,
  [SMALL_STATE(9769)] = 678037,
  [SMALL_STATE(9770)] = 678048,
  [SMALL_STATE(9771)] = 678059,
  [SMALL_STATE(9772)] = 678070,
  [SMALL_STATE(9773)] = 678081,
  [SMALL_STATE(9774)] = 678092,
  [SMALL_STATE(9775)] = 678103,
  [SMALL_STATE(9776)] = 678114,
  [SMALL_STATE(9777)] = 678125,
  [SMALL_STATE(9778)] = 678136,
  [SMALL_STATE(9779)] = 678147,
  [SMALL_STATE(9780)] = 678158,
  [SMALL_STATE(9781)] = 678169,
  [SMALL_STATE(9782)] = 678180,
  [SMALL_STATE(9783)] = 678191,
  [SMALL_STATE(9784)] = 678202,
  [SMALL_STATE(9785)] = 678213,
  [SMALL_STATE(9786)] = 678224,
  [SMALL_STATE(9787)] = 678235,
  [SMALL_STATE(9788)] = 678246,
  [SMALL_STATE(9789)] = 678257,
  [SMALL_STATE(9790)] = 678268,
  [SMALL_STATE(9791)] = 678279,
  [SMALL_STATE(9792)] = 678290,
  [SMALL_STATE(9793)] = 678301,
  [SMALL_STATE(9794)] = 678312,
  [SMALL_STATE(9795)] = 678323,
  [SMALL_STATE(9796)] = 678334,
  [SMALL_STATE(9797)] = 678345,
  [SMALL_STATE(9798)] = 678356,
  [SMALL_STATE(9799)] = 678367,
  [SMALL_STATE(9800)] = 678378,
  [SMALL_STATE(9801)] = 678389,
  [SMALL_STATE(9802)] = 678400,
  [SMALL_STATE(9803)] = 678411,
  [SMALL_STATE(9804)] = 678422,
  [SMALL_STATE(9805)] = 678433,
  [SMALL_STATE(9806)] = 678444,
  [SMALL_STATE(9807)] = 678455,
  [SMALL_STATE(9808)] = 678466,
  [SMALL_STATE(9809)] = 678477,
  [SMALL_STATE(9810)] = 678488,
  [SMALL_STATE(9811)] = 678499,
  [SMALL_STATE(9812)] = 678510,
  [SMALL_STATE(9813)] = 678519,
  [SMALL_STATE(9814)] = 678530,
  [SMALL_STATE(9815)] = 678541,
  [SMALL_STATE(9816)] = 678552,
  [SMALL_STATE(9817)] = 678563,
  [SMALL_STATE(9818)] = 678574,
  [SMALL_STATE(9819)] = 678585,
  [SMALL_STATE(9820)] = 678596,
  [SMALL_STATE(9821)] = 678607,
  [SMALL_STATE(9822)] = 678618,
  [SMALL_STATE(9823)] = 678629,
  [SMALL_STATE(9824)] = 678640,
  [SMALL_STATE(9825)] = 678651,
  [SMALL_STATE(9826)] = 678662,
  [SMALL_STATE(9827)] = 678673,
  [SMALL_STATE(9828)] = 678684,
  [SMALL_STATE(9829)] = 678695,
  [SMALL_STATE(9830)] = 678706,
  [SMALL_STATE(9831)] = 678717,
  [SMALL_STATE(9832)] = 678728,
  [SMALL_STATE(9833)] = 678739,
  [SMALL_STATE(9834)] = 678750,
  [SMALL_STATE(9835)] = 678761,
  [SMALL_STATE(9836)] = 678772,
  [SMALL_STATE(9837)] = 678783,
  [SMALL_STATE(9838)] = 678794,
  [SMALL_STATE(9839)] = 678805,
  [SMALL_STATE(9840)] = 678816,
  [SMALL_STATE(9841)] = 678827,
  [SMALL_STATE(9842)] = 678838,
  [SMALL_STATE(9843)] = 678849,
  [SMALL_STATE(9844)] = 678860,
  [SMALL_STATE(9845)] = 678871,
  [SMALL_STATE(9846)] = 678882,
  [SMALL_STATE(9847)] = 678893,
  [SMALL_STATE(9848)] = 678904,
  [SMALL_STATE(9849)] = 678915,
  [SMALL_STATE(9850)] = 678926,
  [SMALL_STATE(9851)] = 678937,
  [SMALL_STATE(9852)] = 678948,
  [SMALL_STATE(9853)] = 678959,
  [SMALL_STATE(9854)] = 678970,
  [SMALL_STATE(9855)] = 678981,
  [SMALL_STATE(9856)] = 678992,
  [SMALL_STATE(9857)] = 679003,
  [SMALL_STATE(9858)] = 679014,
  [SMALL_STATE(9859)] = 679025,
  [SMALL_STATE(9860)] = 679036,
  [SMALL_STATE(9861)] = 679047,
  [SMALL_STATE(9862)] = 679058,
  [SMALL_STATE(9863)] = 679069,
  [SMALL_STATE(9864)] = 679080,
  [SMALL_STATE(9865)] = 679091,
  [SMALL_STATE(9866)] = 679102,
  [SMALL_STATE(9867)] = 679113,
  [SMALL_STATE(9868)] = 679124,
  [SMALL_STATE(9869)] = 679135,
  [SMALL_STATE(9870)] = 679146,
  [SMALL_STATE(9871)] = 679157,
  [SMALL_STATE(9872)] = 679168,
  [SMALL_STATE(9873)] = 679179,
  [SMALL_STATE(9874)] = 679190,
  [SMALL_STATE(9875)] = 679201,
  [SMALL_STATE(9876)] = 679212,
  [SMALL_STATE(9877)] = 679223,
  [SMALL_STATE(9878)] = 679234,
  [SMALL_STATE(9879)] = 679245,
  [SMALL_STATE(9880)] = 679256,
  [SMALL_STATE(9881)] = 679267,
  [SMALL_STATE(9882)] = 679278,
  [SMALL_STATE(9883)] = 679289,
  [SMALL_STATE(9884)] = 679300,
  [SMALL_STATE(9885)] = 679311,
  [SMALL_STATE(9886)] = 679322,
  [SMALL_STATE(9887)] = 679333,
  [SMALL_STATE(9888)] = 679344,
  [SMALL_STATE(9889)] = 679355,
  [SMALL_STATE(9890)] = 679366,
  [SMALL_STATE(9891)] = 679375,
  [SMALL_STATE(9892)] = 679386,
  [SMALL_STATE(9893)] = 679395,
  [SMALL_STATE(9894)] = 679406,
  [SMALL_STATE(9895)] = 679417,
  [SMALL_STATE(9896)] = 679428,
  [SMALL_STATE(9897)] = 679439,
  [SMALL_STATE(9898)] = 679450,
  [SMALL_STATE(9899)] = 679461,
  [SMALL_STATE(9900)] = 679472,
  [SMALL_STATE(9901)] = 679483,
  [SMALL_STATE(9902)] = 679494,
  [SMALL_STATE(9903)] = 679505,
  [SMALL_STATE(9904)] = 679516,
  [SMALL_STATE(9905)] = 679527,
  [SMALL_STATE(9906)] = 679538,
  [SMALL_STATE(9907)] = 679549,
  [SMALL_STATE(9908)] = 679560,
  [SMALL_STATE(9909)] = 679571,
  [SMALL_STATE(9910)] = 679582,
  [SMALL_STATE(9911)] = 679593,
  [SMALL_STATE(9912)] = 679604,
  [SMALL_STATE(9913)] = 679615,
  [SMALL_STATE(9914)] = 679626,
  [SMALL_STATE(9915)] = 679637,
  [SMALL_STATE(9916)] = 679648,
  [SMALL_STATE(9917)] = 679659,
  [SMALL_STATE(9918)] = 679670,
  [SMALL_STATE(9919)] = 679681,
  [SMALL_STATE(9920)] = 679692,
  [SMALL_STATE(9921)] = 679703,
  [SMALL_STATE(9922)] = 679714,
  [SMALL_STATE(9923)] = 679725,
  [SMALL_STATE(9924)] = 679736,
  [SMALL_STATE(9925)] = 679747,
  [SMALL_STATE(9926)] = 679758,
  [SMALL_STATE(9927)] = 679769,
  [SMALL_STATE(9928)] = 679782,
  [SMALL_STATE(9929)] = 679793,
  [SMALL_STATE(9930)] = 679804,
  [SMALL_STATE(9931)] = 679815,
  [SMALL_STATE(9932)] = 679826,
  [SMALL_STATE(9933)] = 679837,
  [SMALL_STATE(9934)] = 679848,
  [SMALL_STATE(9935)] = 679859,
  [SMALL_STATE(9936)] = 679870,
  [SMALL_STATE(9937)] = 679881,
  [SMALL_STATE(9938)] = 679890,
  [SMALL_STATE(9939)] = 679901,
  [SMALL_STATE(9940)] = 679912,
  [SMALL_STATE(9941)] = 679923,
  [SMALL_STATE(9942)] = 679934,
  [SMALL_STATE(9943)] = 679945,
  [SMALL_STATE(9944)] = 679956,
  [SMALL_STATE(9945)] = 679967,
  [SMALL_STATE(9946)] = 679978,
  [SMALL_STATE(9947)] = 679989,
  [SMALL_STATE(9948)] = 680000,
  [SMALL_STATE(9949)] = 680011,
  [SMALL_STATE(9950)] = 680022,
  [SMALL_STATE(9951)] = 680033,
  [SMALL_STATE(9952)] = 680044,
  [SMALL_STATE(9953)] = 680055,
  [SMALL_STATE(9954)] = 680066,
  [SMALL_STATE(9955)] = 680077,
  [SMALL_STATE(9956)] = 680088,
  [SMALL_STATE(9957)] = 680099,
  [SMALL_STATE(9958)] = 680110,
  [SMALL_STATE(9959)] = 680121,
  [SMALL_STATE(9960)] = 680132,
  [SMALL_STATE(9961)] = 680143,
  [SMALL_STATE(9962)] = 680154,
  [SMALL_STATE(9963)] = 680165,
  [SMALL_STATE(9964)] = 680176,
  [SMALL_STATE(9965)] = 680187,
  [SMALL_STATE(9966)] = 680198,
  [SMALL_STATE(9967)] = 680209,
  [SMALL_STATE(9968)] = 680220,
  [SMALL_STATE(9969)] = 680231,
  [SMALL_STATE(9970)] = 680242,
  [SMALL_STATE(9971)] = 680253,
  [SMALL_STATE(9972)] = 680264,
  [SMALL_STATE(9973)] = 680275,
  [SMALL_STATE(9974)] = 680286,
  [SMALL_STATE(9975)] = 680297,
  [SMALL_STATE(9976)] = 680308,
  [SMALL_STATE(9977)] = 680321,
  [SMALL_STATE(9978)] = 680330,
  [SMALL_STATE(9979)] = 680339,
  [SMALL_STATE(9980)] = 680350,
  [SMALL_STATE(9981)] = 680361,
  [SMALL_STATE(9982)] = 680372,
  [SMALL_STATE(9983)] = 680383,
  [SMALL_STATE(9984)] = 680394,
  [SMALL_STATE(9985)] = 680405,
  [SMALL_STATE(9986)] = 680416,
  [SMALL_STATE(9987)] = 680427,
  [SMALL_STATE(9988)] = 680436,
  [SMALL_STATE(9989)] = 680445,
  [SMALL_STATE(9990)] = 680456,
  [SMALL_STATE(9991)] = 680467,
  [SMALL_STATE(9992)] = 680478,
  [SMALL_STATE(9993)] = 680489,
  [SMALL_STATE(9994)] = 680500,
  [SMALL_STATE(9995)] = 680511,
  [SMALL_STATE(9996)] = 680522,
  [SMALL_STATE(9997)] = 680533,
  [SMALL_STATE(9998)] = 680544,
  [SMALL_STATE(9999)] = 680555,
  [SMALL_STATE(10000)] = 680566,
  [SMALL_STATE(10001)] = 680577,
  [SMALL_STATE(10002)] = 680588,
  [SMALL_STATE(10003)] = 680599,
  [SMALL_STATE(10004)] = 680610,
  [SMALL_STATE(10005)] = 680621,
  [SMALL_STATE(10006)] = 680632,
  [SMALL_STATE(10007)] = 680643,
  [SMALL_STATE(10008)] = 680654,
  [SMALL_STATE(10009)] = 680665,
  [SMALL_STATE(10010)] = 680676,
  [SMALL_STATE(10011)] = 680687,
  [SMALL_STATE(10012)] = 680698,
  [SMALL_STATE(10013)] = 680709,
  [SMALL_STATE(10014)] = 680720,
  [SMALL_STATE(10015)] = 680731,
  [SMALL_STATE(10016)] = 680742,
  [SMALL_STATE(10017)] = 680753,
  [SMALL_STATE(10018)] = 680764,
  [SMALL_STATE(10019)] = 680775,
  [SMALL_STATE(10020)] = 680786,
  [SMALL_STATE(10021)] = 680797,
  [SMALL_STATE(10022)] = 680808,
  [SMALL_STATE(10023)] = 680819,
  [SMALL_STATE(10024)] = 680830,
  [SMALL_STATE(10025)] = 680841,
  [SMALL_STATE(10026)] = 680852,
  [SMALL_STATE(10027)] = 680863,
  [SMALL_STATE(10028)] = 680874,
  [SMALL_STATE(10029)] = 680885,
  [SMALL_STATE(10030)] = 680896,
  [SMALL_STATE(10031)] = 680905,
  [SMALL_STATE(10032)] = 680916,
  [SMALL_STATE(10033)] = 680927,
  [SMALL_STATE(10034)] = 680938,
  [SMALL_STATE(10035)] = 680949,
  [SMALL_STATE(10036)] = 680960,
  [SMALL_STATE(10037)] = 680971,
  [SMALL_STATE(10038)] = 680982,
  [SMALL_STATE(10039)] = 680993,
  [SMALL_STATE(10040)] = 681004,
  [SMALL_STATE(10041)] = 681015,
  [SMALL_STATE(10042)] = 681026,
  [SMALL_STATE(10043)] = 681037,
  [SMALL_STATE(10044)] = 681048,
  [SMALL_STATE(10045)] = 681059,
  [SMALL_STATE(10046)] = 681070,
  [SMALL_STATE(10047)] = 681081,
  [SMALL_STATE(10048)] = 681092,
  [SMALL_STATE(10049)] = 681103,
  [SMALL_STATE(10050)] = 681114,
  [SMALL_STATE(10051)] = 681125,
  [SMALL_STATE(10052)] = 681138,
  [SMALL_STATE(10053)] = 681149,
  [SMALL_STATE(10054)] = 681160,
  [SMALL_STATE(10055)] = 681171,
  [SMALL_STATE(10056)] = 681182,
  [SMALL_STATE(10057)] = 681193,
  [SMALL_STATE(10058)] = 681204,
  [SMALL_STATE(10059)] = 681215,
  [SMALL_STATE(10060)] = 681226,
  [SMALL_STATE(10061)] = 681237,
  [SMALL_STATE(10062)] = 681248,
  [SMALL_STATE(10063)] = 681259,
  [SMALL_STATE(10064)] = 681270,
  [SMALL_STATE(10065)] = 681281,
  [SMALL_STATE(10066)] = 681292,
  [SMALL_STATE(10067)] = 681303,
  [SMALL_STATE(10068)] = 681314,
  [SMALL_STATE(10069)] = 681325,
  [SMALL_STATE(10070)] = 681336,
  [SMALL_STATE(10071)] = 681347,
  [SMALL_STATE(10072)] = 681358,
  [SMALL_STATE(10073)] = 681369,
  [SMALL_STATE(10074)] = 681382,
  [SMALL_STATE(10075)] = 681393,
  [SMALL_STATE(10076)] = 681404,
  [SMALL_STATE(10077)] = 681413,
  [SMALL_STATE(10078)] = 681424,
  [SMALL_STATE(10079)] = 681437,
  [SMALL_STATE(10080)] = 681448,
  [SMALL_STATE(10081)] = 681459,
  [SMALL_STATE(10082)] = 681470,
  [SMALL_STATE(10083)] = 681483,
  [SMALL_STATE(10084)] = 681492,
  [SMALL_STATE(10085)] = 681503,
  [SMALL_STATE(10086)] = 681514,
  [SMALL_STATE(10087)] = 681525,
  [SMALL_STATE(10088)] = 681534,
  [SMALL_STATE(10089)] = 681545,
  [SMALL_STATE(10090)] = 681556,
  [SMALL_STATE(10091)] = 681567,
  [SMALL_STATE(10092)] = 681578,
  [SMALL_STATE(10093)] = 681589,
  [SMALL_STATE(10094)] = 681600,
  [SMALL_STATE(10095)] = 681611,
  [SMALL_STATE(10096)] = 681622,
  [SMALL_STATE(10097)] = 681633,
  [SMALL_STATE(10098)] = 681644,
  [SMALL_STATE(10099)] = 681655,
  [SMALL_STATE(10100)] = 681666,
  [SMALL_STATE(10101)] = 681679,
  [SMALL_STATE(10102)] = 681692,
  [SMALL_STATE(10103)] = 681703,
  [SMALL_STATE(10104)] = 681712,
  [SMALL_STATE(10105)] = 681721,
  [SMALL_STATE(10106)] = 681730,
  [SMALL_STATE(10107)] = 681739,
  [SMALL_STATE(10108)] = 681750,
  [SMALL_STATE(10109)] = 681759,
  [SMALL_STATE(10110)] = 681770,
  [SMALL_STATE(10111)] = 681781,
  [SMALL_STATE(10112)] = 681792,
  [SMALL_STATE(10113)] = 681803,
  [SMALL_STATE(10114)] = 681814,
  [SMALL_STATE(10115)] = 681825,
  [SMALL_STATE(10116)] = 681834,
  [SMALL_STATE(10117)] = 681845,
  [SMALL_STATE(10118)] = 681856,
  [SMALL_STATE(10119)] = 681865,
  [SMALL_STATE(10120)] = 681876,
  [SMALL_STATE(10121)] = 681885,
  [SMALL_STATE(10122)] = 681896,
  [SMALL_STATE(10123)] = 681907,
  [SMALL_STATE(10124)] = 681916,
  [SMALL_STATE(10125)] = 681925,
  [SMALL_STATE(10126)] = 681934,
  [SMALL_STATE(10127)] = 681943,
  [SMALL_STATE(10128)] = 681952,
  [SMALL_STATE(10129)] = 681961,
  [SMALL_STATE(10130)] = 681970,
  [SMALL_STATE(10131)] = 681981,
  [SMALL_STATE(10132)] = 681992,
  [SMALL_STATE(10133)] = 682003,
  [SMALL_STATE(10134)] = 682014,
  [SMALL_STATE(10135)] = 682023,
  [SMALL_STATE(10136)] = 682034,
  [SMALL_STATE(10137)] = 682045,
  [SMALL_STATE(10138)] = 682056,
  [SMALL_STATE(10139)] = 682067,
  [SMALL_STATE(10140)] = 682076,
  [SMALL_STATE(10141)] = 682085,
  [SMALL_STATE(10142)] = 682094,
  [SMALL_STATE(10143)] = 682103,
  [SMALL_STATE(10144)] = 682112,
  [SMALL_STATE(10145)] = 682121,
  [SMALL_STATE(10146)] = 682132,
  [SMALL_STATE(10147)] = 682141,
  [SMALL_STATE(10148)] = 682152,
  [SMALL_STATE(10149)] = 682163,
  [SMALL_STATE(10150)] = 682174,
  [SMALL_STATE(10151)] = 682185,
  [SMALL_STATE(10152)] = 682194,
  [SMALL_STATE(10153)] = 682203,
  [SMALL_STATE(10154)] = 682212,
  [SMALL_STATE(10155)] = 682223,
  [SMALL_STATE(10156)] = 682232,
  [SMALL_STATE(10157)] = 682243,
  [SMALL_STATE(10158)] = 682252,
  [SMALL_STATE(10159)] = 682263,
  [SMALL_STATE(10160)] = 682272,
  [SMALL_STATE(10161)] = 682281,
  [SMALL_STATE(10162)] = 682292,
  [SMALL_STATE(10163)] = 682303,
  [SMALL_STATE(10164)] = 682314,
  [SMALL_STATE(10165)] = 682325,
  [SMALL_STATE(10166)] = 682336,
  [SMALL_STATE(10167)] = 682347,
  [SMALL_STATE(10168)] = 682356,
  [SMALL_STATE(10169)] = 682369,
  [SMALL_STATE(10170)] = 682380,
  [SMALL_STATE(10171)] = 682389,
  [SMALL_STATE(10172)] = 682398,
  [SMALL_STATE(10173)] = 682407,
  [SMALL_STATE(10174)] = 682418,
  [SMALL_STATE(10175)] = 682429,
  [SMALL_STATE(10176)] = 682440,
  [SMALL_STATE(10177)] = 682449,
  [SMALL_STATE(10178)] = 682460,
  [SMALL_STATE(10179)] = 682469,
  [SMALL_STATE(10180)] = 682480,
  [SMALL_STATE(10181)] = 682489,
  [SMALL_STATE(10182)] = 682500,
  [SMALL_STATE(10183)] = 682511,
  [SMALL_STATE(10184)] = 682520,
  [SMALL_STATE(10185)] = 682531,
  [SMALL_STATE(10186)] = 682542,
  [SMALL_STATE(10187)] = 682553,
  [SMALL_STATE(10188)] = 682564,
  [SMALL_STATE(10189)] = 682575,
  [SMALL_STATE(10190)] = 682584,
  [SMALL_STATE(10191)] = 682595,
  [SMALL_STATE(10192)] = 682606,
  [SMALL_STATE(10193)] = 682617,
  [SMALL_STATE(10194)] = 682628,
  [SMALL_STATE(10195)] = 682639,
  [SMALL_STATE(10196)] = 682650,
  [SMALL_STATE(10197)] = 682661,
  [SMALL_STATE(10198)] = 682672,
  [SMALL_STATE(10199)] = 682683,
  [SMALL_STATE(10200)] = 682694,
  [SMALL_STATE(10201)] = 682705,
  [SMALL_STATE(10202)] = 682714,
  [SMALL_STATE(10203)] = 682725,
  [SMALL_STATE(10204)] = 682734,
  [SMALL_STATE(10205)] = 682745,
  [SMALL_STATE(10206)] = 682756,
  [SMALL_STATE(10207)] = 682767,
  [SMALL_STATE(10208)] = 682778,
  [SMALL_STATE(10209)] = 682789,
  [SMALL_STATE(10210)] = 682800,
  [SMALL_STATE(10211)] = 682811,
  [SMALL_STATE(10212)] = 682822,
  [SMALL_STATE(10213)] = 682833,
  [SMALL_STATE(10214)] = 682844,
  [SMALL_STATE(10215)] = 682855,
  [SMALL_STATE(10216)] = 682866,
  [SMALL_STATE(10217)] = 682877,
  [SMALL_STATE(10218)] = 682888,
  [SMALL_STATE(10219)] = 682901,
  [SMALL_STATE(10220)] = 682912,
  [SMALL_STATE(10221)] = 682925,
  [SMALL_STATE(10222)] = 682936,
  [SMALL_STATE(10223)] = 682947,
  [SMALL_STATE(10224)] = 682958,
  [SMALL_STATE(10225)] = 682969,
  [SMALL_STATE(10226)] = 682980,
  [SMALL_STATE(10227)] = 682991,
  [SMALL_STATE(10228)] = 683002,
  [SMALL_STATE(10229)] = 683013,
  [SMALL_STATE(10230)] = 683024,
  [SMALL_STATE(10231)] = 683035,
  [SMALL_STATE(10232)] = 683046,
  [SMALL_STATE(10233)] = 683054,
  [SMALL_STATE(10234)] = 683062,
  [SMALL_STATE(10235)] = 683070,
  [SMALL_STATE(10236)] = 683078,
  [SMALL_STATE(10237)] = 683086,
  [SMALL_STATE(10238)] = 683094,
  [SMALL_STATE(10239)] = 683102,
  [SMALL_STATE(10240)] = 683110,
  [SMALL_STATE(10241)] = 683118,
  [SMALL_STATE(10242)] = 683126,
  [SMALL_STATE(10243)] = 683134,
  [SMALL_STATE(10244)] = 683142,
  [SMALL_STATE(10245)] = 683150,
  [SMALL_STATE(10246)] = 683158,
  [SMALL_STATE(10247)] = 683166,
  [SMALL_STATE(10248)] = 683174,
  [SMALL_STATE(10249)] = 683182,
  [SMALL_STATE(10250)] = 683190,
  [SMALL_STATE(10251)] = 683198,
  [SMALL_STATE(10252)] = 683206,
  [SMALL_STATE(10253)] = 683214,
  [SMALL_STATE(10254)] = 683222,
  [SMALL_STATE(10255)] = 683230,
  [SMALL_STATE(10256)] = 683238,
  [SMALL_STATE(10257)] = 683246,
  [SMALL_STATE(10258)] = 683254,
  [SMALL_STATE(10259)] = 683262,
  [SMALL_STATE(10260)] = 683270,
  [SMALL_STATE(10261)] = 683278,
  [SMALL_STATE(10262)] = 683286,
  [SMALL_STATE(10263)] = 683294,
  [SMALL_STATE(10264)] = 683302,
  [SMALL_STATE(10265)] = 683310,
  [SMALL_STATE(10266)] = 683318,
  [SMALL_STATE(10267)] = 683326,
  [SMALL_STATE(10268)] = 683334,
  [SMALL_STATE(10269)] = 683342,
  [SMALL_STATE(10270)] = 683350,
  [SMALL_STATE(10271)] = 683358,
  [SMALL_STATE(10272)] = 683366,
  [SMALL_STATE(10273)] = 683374,
  [SMALL_STATE(10274)] = 683382,
  [SMALL_STATE(10275)] = 683390,
  [SMALL_STATE(10276)] = 683398,
  [SMALL_STATE(10277)] = 683406,
  [SMALL_STATE(10278)] = 683414,
  [SMALL_STATE(10279)] = 683422,
  [SMALL_STATE(10280)] = 683430,
  [SMALL_STATE(10281)] = 683438,
  [SMALL_STATE(10282)] = 683446,
  [SMALL_STATE(10283)] = 683454,
  [SMALL_STATE(10284)] = 683462,
  [SMALL_STATE(10285)] = 683470,
  [SMALL_STATE(10286)] = 683478,
  [SMALL_STATE(10287)] = 683486,
  [SMALL_STATE(10288)] = 683494,
  [SMALL_STATE(10289)] = 683502,
  [SMALL_STATE(10290)] = 683510,
  [SMALL_STATE(10291)] = 683518,
  [SMALL_STATE(10292)] = 683526,
  [SMALL_STATE(10293)] = 683534,
  [SMALL_STATE(10294)] = 683542,
  [SMALL_STATE(10295)] = 683550,
  [SMALL_STATE(10296)] = 683558,
  [SMALL_STATE(10297)] = 683566,
  [SMALL_STATE(10298)] = 683574,
  [SMALL_STATE(10299)] = 683582,
  [SMALL_STATE(10300)] = 683590,
  [SMALL_STATE(10301)] = 683598,
  [SMALL_STATE(10302)] = 683606,
  [SMALL_STATE(10303)] = 683614,
  [SMALL_STATE(10304)] = 683622,
  [SMALL_STATE(10305)] = 683630,
  [SMALL_STATE(10306)] = 683638,
  [SMALL_STATE(10307)] = 683646,
  [SMALL_STATE(10308)] = 683654,
  [SMALL_STATE(10309)] = 683662,
  [SMALL_STATE(10310)] = 683670,
  [SMALL_STATE(10311)] = 683678,
  [SMALL_STATE(10312)] = 683686,
  [SMALL_STATE(10313)] = 683694,
  [SMALL_STATE(10314)] = 683702,
  [SMALL_STATE(10315)] = 683710,
  [SMALL_STATE(10316)] = 683718,
  [SMALL_STATE(10317)] = 683726,
  [SMALL_STATE(10318)] = 683734,
  [SMALL_STATE(10319)] = 683742,
  [SMALL_STATE(10320)] = 683750,
  [SMALL_STATE(10321)] = 683758,
  [SMALL_STATE(10322)] = 683766,
  [SMALL_STATE(10323)] = 683774,
  [SMALL_STATE(10324)] = 683782,
  [SMALL_STATE(10325)] = 683790,
  [SMALL_STATE(10326)] = 683798,
  [SMALL_STATE(10327)] = 683806,
  [SMALL_STATE(10328)] = 683814,
  [SMALL_STATE(10329)] = 683822,
  [SMALL_STATE(10330)] = 683830,
  [SMALL_STATE(10331)] = 683838,
  [SMALL_STATE(10332)] = 683846,
  [SMALL_STATE(10333)] = 683854,
  [SMALL_STATE(10334)] = 683862,
  [SMALL_STATE(10335)] = 683870,
  [SMALL_STATE(10336)] = 683878,
  [SMALL_STATE(10337)] = 683886,
  [SMALL_STATE(10338)] = 683894,
  [SMALL_STATE(10339)] = 683902,
  [SMALL_STATE(10340)] = 683910,
  [SMALL_STATE(10341)] = 683918,
  [SMALL_STATE(10342)] = 683926,
  [SMALL_STATE(10343)] = 683934,
  [SMALL_STATE(10344)] = 683942,
  [SMALL_STATE(10345)] = 683950,
  [SMALL_STATE(10346)] = 683958,
  [SMALL_STATE(10347)] = 683966,
  [SMALL_STATE(10348)] = 683974,
  [SMALL_STATE(10349)] = 683982,
  [SMALL_STATE(10350)] = 683990,
  [SMALL_STATE(10351)] = 683998,
  [SMALL_STATE(10352)] = 684006,
  [SMALL_STATE(10353)] = 684014,
  [SMALL_STATE(10354)] = 684022,
  [SMALL_STATE(10355)] = 684030,
  [SMALL_STATE(10356)] = 684038,
  [SMALL_STATE(10357)] = 684046,
  [SMALL_STATE(10358)] = 684054,
  [SMALL_STATE(10359)] = 684062,
  [SMALL_STATE(10360)] = 684070,
  [SMALL_STATE(10361)] = 684078,
  [SMALL_STATE(10362)] = 684086,
  [SMALL_STATE(10363)] = 684094,
  [SMALL_STATE(10364)] = 684102,
  [SMALL_STATE(10365)] = 684110,
  [SMALL_STATE(10366)] = 684118,
  [SMALL_STATE(10367)] = 684126,
  [SMALL_STATE(10368)] = 684134,
  [SMALL_STATE(10369)] = 684142,
  [SMALL_STATE(10370)] = 684150,
  [SMALL_STATE(10371)] = 684158,
  [SMALL_STATE(10372)] = 684166,
  [SMALL_STATE(10373)] = 684174,
  [SMALL_STATE(10374)] = 684182,
  [SMALL_STATE(10375)] = 684190,
  [SMALL_STATE(10376)] = 684198,
  [SMALL_STATE(10377)] = 684206,
  [SMALL_STATE(10378)] = 684214,
  [SMALL_STATE(10379)] = 684222,
  [SMALL_STATE(10380)] = 684230,
  [SMALL_STATE(10381)] = 684238,
  [SMALL_STATE(10382)] = 684246,
  [SMALL_STATE(10383)] = 684254,
  [SMALL_STATE(10384)] = 684262,
  [SMALL_STATE(10385)] = 684270,
  [SMALL_STATE(10386)] = 684278,
  [SMALL_STATE(10387)] = 684286,
  [SMALL_STATE(10388)] = 684294,
  [SMALL_STATE(10389)] = 684302,
  [SMALL_STATE(10390)] = 684310,
  [SMALL_STATE(10391)] = 684318,
  [SMALL_STATE(10392)] = 684326,
  [SMALL_STATE(10393)] = 684334,
  [SMALL_STATE(10394)] = 684342,
  [SMALL_STATE(10395)] = 684350,
  [SMALL_STATE(10396)] = 684358,
  [SMALL_STATE(10397)] = 684366,
  [SMALL_STATE(10398)] = 684374,
  [SMALL_STATE(10399)] = 684382,
  [SMALL_STATE(10400)] = 684390,
  [SMALL_STATE(10401)] = 684398,
  [SMALL_STATE(10402)] = 684406,
  [SMALL_STATE(10403)] = 684414,
  [SMALL_STATE(10404)] = 684422,
  [SMALL_STATE(10405)] = 684430,
  [SMALL_STATE(10406)] = 684438,
  [SMALL_STATE(10407)] = 684446,
  [SMALL_STATE(10408)] = 684454,
  [SMALL_STATE(10409)] = 684462,
  [SMALL_STATE(10410)] = 684470,
  [SMALL_STATE(10411)] = 684478,
  [SMALL_STATE(10412)] = 684486,
  [SMALL_STATE(10413)] = 684494,
  [SMALL_STATE(10414)] = 684502,
  [SMALL_STATE(10415)] = 684510,
  [SMALL_STATE(10416)] = 684518,
  [SMALL_STATE(10417)] = 684526,
  [SMALL_STATE(10418)] = 684534,
  [SMALL_STATE(10419)] = 684542,
  [SMALL_STATE(10420)] = 684550,
  [SMALL_STATE(10421)] = 684558,
  [SMALL_STATE(10422)] = 684566,
  [SMALL_STATE(10423)] = 684574,
  [SMALL_STATE(10424)] = 684582,
  [SMALL_STATE(10425)] = 684590,
  [SMALL_STATE(10426)] = 684598,
  [SMALL_STATE(10427)] = 684606,
  [SMALL_STATE(10428)] = 684614,
  [SMALL_STATE(10429)] = 684622,
  [SMALL_STATE(10430)] = 684630,
  [SMALL_STATE(10431)] = 684638,
  [SMALL_STATE(10432)] = 684646,
  [SMALL_STATE(10433)] = 684654,
  [SMALL_STATE(10434)] = 684662,
  [SMALL_STATE(10435)] = 684670,
  [SMALL_STATE(10436)] = 684678,
  [SMALL_STATE(10437)] = 684686,
  [SMALL_STATE(10438)] = 684694,
  [SMALL_STATE(10439)] = 684702,
  [SMALL_STATE(10440)] = 684710,
  [SMALL_STATE(10441)] = 684718,
  [SMALL_STATE(10442)] = 684726,
  [SMALL_STATE(10443)] = 684734,
  [SMALL_STATE(10444)] = 684742,
  [SMALL_STATE(10445)] = 684750,
  [SMALL_STATE(10446)] = 684758,
  [SMALL_STATE(10447)] = 684766,
  [SMALL_STATE(10448)] = 684774,
  [SMALL_STATE(10449)] = 684782,
  [SMALL_STATE(10450)] = 684790,
  [SMALL_STATE(10451)] = 684798,
  [SMALL_STATE(10452)] = 684806,
  [SMALL_STATE(10453)] = 684814,
  [SMALL_STATE(10454)] = 684822,
  [SMALL_STATE(10455)] = 684830,
  [SMALL_STATE(10456)] = 684838,
  [SMALL_STATE(10457)] = 684846,
  [SMALL_STATE(10458)] = 684854,
  [SMALL_STATE(10459)] = 684862,
  [SMALL_STATE(10460)] = 684870,
  [SMALL_STATE(10461)] = 684878,
  [SMALL_STATE(10462)] = 684886,
  [SMALL_STATE(10463)] = 684894,
  [SMALL_STATE(10464)] = 684902,
  [SMALL_STATE(10465)] = 684910,
  [SMALL_STATE(10466)] = 684918,
  [SMALL_STATE(10467)] = 684926,
  [SMALL_STATE(10468)] = 684934,
  [SMALL_STATE(10469)] = 684942,
  [SMALL_STATE(10470)] = 684950,
  [SMALL_STATE(10471)] = 684958,
  [SMALL_STATE(10472)] = 684966,
  [SMALL_STATE(10473)] = 684974,
  [SMALL_STATE(10474)] = 684982,
  [SMALL_STATE(10475)] = 684990,
  [SMALL_STATE(10476)] = 684998,
  [SMALL_STATE(10477)] = 685006,
  [SMALL_STATE(10478)] = 685014,
  [SMALL_STATE(10479)] = 685022,
  [SMALL_STATE(10480)] = 685030,
  [SMALL_STATE(10481)] = 685038,
  [SMALL_STATE(10482)] = 685046,
  [SMALL_STATE(10483)] = 685054,
  [SMALL_STATE(10484)] = 685062,
  [SMALL_STATE(10485)] = 685070,
  [SMALL_STATE(10486)] = 685078,
  [SMALL_STATE(10487)] = 685086,
  [SMALL_STATE(10488)] = 685094,
  [SMALL_STATE(10489)] = 685102,
  [SMALL_STATE(10490)] = 685110,
  [SMALL_STATE(10491)] = 685118,
  [SMALL_STATE(10492)] = 685126,
  [SMALL_STATE(10493)] = 685134,
  [SMALL_STATE(10494)] = 685142,
  [SMALL_STATE(10495)] = 685150,
  [SMALL_STATE(10496)] = 685158,
  [SMALL_STATE(10497)] = 685166,
  [SMALL_STATE(10498)] = 685174,
  [SMALL_STATE(10499)] = 685182,
  [SMALL_STATE(10500)] = 685190,
  [SMALL_STATE(10501)] = 685198,
  [SMALL_STATE(10502)] = 685206,
  [SMALL_STATE(10503)] = 685214,
  [SMALL_STATE(10504)] = 685222,
  [SMALL_STATE(10505)] = 685230,
  [SMALL_STATE(10506)] = 685238,
  [SMALL_STATE(10507)] = 685246,
  [SMALL_STATE(10508)] = 685254,
  [SMALL_STATE(10509)] = 685262,
  [SMALL_STATE(10510)] = 685270,
  [SMALL_STATE(10511)] = 685278,
  [SMALL_STATE(10512)] = 685286,
  [SMALL_STATE(10513)] = 685294,
  [SMALL_STATE(10514)] = 685302,
  [SMALL_STATE(10515)] = 685310,
  [SMALL_STATE(10516)] = 685318,
  [SMALL_STATE(10517)] = 685326,
  [SMALL_STATE(10518)] = 685334,
  [SMALL_STATE(10519)] = 685342,
  [SMALL_STATE(10520)] = 685350,
  [SMALL_STATE(10521)] = 685358,
  [SMALL_STATE(10522)] = 685366,
  [SMALL_STATE(10523)] = 685374,
  [SMALL_STATE(10524)] = 685382,
  [SMALL_STATE(10525)] = 685390,
  [SMALL_STATE(10526)] = 685398,
  [SMALL_STATE(10527)] = 685406,
  [SMALL_STATE(10528)] = 685414,
  [SMALL_STATE(10529)] = 685422,
  [SMALL_STATE(10530)] = 685430,
  [SMALL_STATE(10531)] = 685438,
  [SMALL_STATE(10532)] = 685446,
  [SMALL_STATE(10533)] = 685454,
  [SMALL_STATE(10534)] = 685462,
  [SMALL_STATE(10535)] = 685470,
  [SMALL_STATE(10536)] = 685478,
  [SMALL_STATE(10537)] = 685486,
  [SMALL_STATE(10538)] = 685494,
  [SMALL_STATE(10539)] = 685502,
  [SMALL_STATE(10540)] = 685510,
  [SMALL_STATE(10541)] = 685518,
  [SMALL_STATE(10542)] = 685526,
  [SMALL_STATE(10543)] = 685534,
  [SMALL_STATE(10544)] = 685542,
  [SMALL_STATE(10545)] = 685550,
  [SMALL_STATE(10546)] = 685558,
  [SMALL_STATE(10547)] = 685566,
  [SMALL_STATE(10548)] = 685574,
  [SMALL_STATE(10549)] = 685582,
  [SMALL_STATE(10550)] = 685590,
  [SMALL_STATE(10551)] = 685598,
  [SMALL_STATE(10552)] = 685606,
  [SMALL_STATE(10553)] = 685614,
  [SMALL_STATE(10554)] = 685622,
  [SMALL_STATE(10555)] = 685630,
  [SMALL_STATE(10556)] = 685638,
  [SMALL_STATE(10557)] = 685646,
  [SMALL_STATE(10558)] = 685654,
  [SMALL_STATE(10559)] = 685662,
  [SMALL_STATE(10560)] = 685670,
  [SMALL_STATE(10561)] = 685678,
  [SMALL_STATE(10562)] = 685686,
  [SMALL_STATE(10563)] = 685694,
  [SMALL_STATE(10564)] = 685702,
  [SMALL_STATE(10565)] = 685710,
  [SMALL_STATE(10566)] = 685718,
  [SMALL_STATE(10567)] = 685726,
  [SMALL_STATE(10568)] = 685734,
  [SMALL_STATE(10569)] = 685742,
  [SMALL_STATE(10570)] = 685750,
  [SMALL_STATE(10571)] = 685758,
  [SMALL_STATE(10572)] = 685766,
  [SMALL_STATE(10573)] = 685774,
  [SMALL_STATE(10574)] = 685782,
  [SMALL_STATE(10575)] = 685790,
  [SMALL_STATE(10576)] = 685798,
  [SMALL_STATE(10577)] = 685806,
  [SMALL_STATE(10578)] = 685814,
  [SMALL_STATE(10579)] = 685822,
  [SMALL_STATE(10580)] = 685830,
  [SMALL_STATE(10581)] = 685838,
  [SMALL_STATE(10582)] = 685846,
  [SMALL_STATE(10583)] = 685854,
  [SMALL_STATE(10584)] = 685862,
  [SMALL_STATE(10585)] = 685870,
  [SMALL_STATE(10586)] = 685878,
  [SMALL_STATE(10587)] = 685886,
  [SMALL_STATE(10588)] = 685894,
  [SMALL_STATE(10589)] = 685902,
  [SMALL_STATE(10590)] = 685910,
  [SMALL_STATE(10591)] = 685918,
  [SMALL_STATE(10592)] = 685926,
  [SMALL_STATE(10593)] = 685934,
  [SMALL_STATE(10594)] = 685942,
  [SMALL_STATE(10595)] = 685950,
  [SMALL_STATE(10596)] = 685958,
  [SMALL_STATE(10597)] = 685966,
  [SMALL_STATE(10598)] = 685974,
  [SMALL_STATE(10599)] = 685982,
  [SMALL_STATE(10600)] = 685990,
  [SMALL_STATE(10601)] = 685998,
  [SMALL_STATE(10602)] = 686006,
  [SMALL_STATE(10603)] = 686014,
  [SMALL_STATE(10604)] = 686022,
  [SMALL_STATE(10605)] = 686030,
  [SMALL_STATE(10606)] = 686038,
  [SMALL_STATE(10607)] = 686046,
  [SMALL_STATE(10608)] = 686054,
  [SMALL_STATE(10609)] = 686062,
  [SMALL_STATE(10610)] = 686070,
  [SMALL_STATE(10611)] = 686078,
  [SMALL_STATE(10612)] = 686086,
  [SMALL_STATE(10613)] = 686094,
  [SMALL_STATE(10614)] = 686102,
  [SMALL_STATE(10615)] = 686110,
  [SMALL_STATE(10616)] = 686118,
  [SMALL_STATE(10617)] = 686126,
  [SMALL_STATE(10618)] = 686134,
  [SMALL_STATE(10619)] = 686142,
  [SMALL_STATE(10620)] = 686150,
  [SMALL_STATE(10621)] = 686158,
  [SMALL_STATE(10622)] = 686166,
  [SMALL_STATE(10623)] = 686174,
  [SMALL_STATE(10624)] = 686182,
  [SMALL_STATE(10625)] = 686190,
  [SMALL_STATE(10626)] = 686198,
  [SMALL_STATE(10627)] = 686206,
  [SMALL_STATE(10628)] = 686214,
  [SMALL_STATE(10629)] = 686222,
  [SMALL_STATE(10630)] = 686230,
  [SMALL_STATE(10631)] = 686238,
  [SMALL_STATE(10632)] = 686246,
  [SMALL_STATE(10633)] = 686254,
  [SMALL_STATE(10634)] = 686262,
  [SMALL_STATE(10635)] = 686270,
  [SMALL_STATE(10636)] = 686278,
  [SMALL_STATE(10637)] = 686286,
  [SMALL_STATE(10638)] = 686294,
  [SMALL_STATE(10639)] = 686302,
  [SMALL_STATE(10640)] = 686310,
  [SMALL_STATE(10641)] = 686318,
  [SMALL_STATE(10642)] = 686326,
  [SMALL_STATE(10643)] = 686334,
  [SMALL_STATE(10644)] = 686342,
  [SMALL_STATE(10645)] = 686350,
  [SMALL_STATE(10646)] = 686358,
  [SMALL_STATE(10647)] = 686366,
  [SMALL_STATE(10648)] = 686374,
  [SMALL_STATE(10649)] = 686382,
  [SMALL_STATE(10650)] = 686390,
  [SMALL_STATE(10651)] = 686398,
  [SMALL_STATE(10652)] = 686406,
  [SMALL_STATE(10653)] = 686414,
  [SMALL_STATE(10654)] = 686422,
  [SMALL_STATE(10655)] = 686430,
  [SMALL_STATE(10656)] = 686438,
  [SMALL_STATE(10657)] = 686446,
  [SMALL_STATE(10658)] = 686454,
  [SMALL_STATE(10659)] = 686462,
  [SMALL_STATE(10660)] = 686470,
  [SMALL_STATE(10661)] = 686478,
  [SMALL_STATE(10662)] = 686486,
  [SMALL_STATE(10663)] = 686494,
  [SMALL_STATE(10664)] = 686502,
  [SMALL_STATE(10665)] = 686510,
  [SMALL_STATE(10666)] = 686518,
  [SMALL_STATE(10667)] = 686526,
  [SMALL_STATE(10668)] = 686534,
  [SMALL_STATE(10669)] = 686542,
  [SMALL_STATE(10670)] = 686550,
  [SMALL_STATE(10671)] = 686558,
  [SMALL_STATE(10672)] = 686566,
  [SMALL_STATE(10673)] = 686574,
  [SMALL_STATE(10674)] = 686582,
  [SMALL_STATE(10675)] = 686590,
  [SMALL_STATE(10676)] = 686598,
  [SMALL_STATE(10677)] = 686606,
  [SMALL_STATE(10678)] = 686614,
  [SMALL_STATE(10679)] = 686622,
  [SMALL_STATE(10680)] = 686630,
  [SMALL_STATE(10681)] = 686638,
  [SMALL_STATE(10682)] = 686646,
  [SMALL_STATE(10683)] = 686654,
  [SMALL_STATE(10684)] = 686662,
  [SMALL_STATE(10685)] = 686670,
  [SMALL_STATE(10686)] = 686678,
  [SMALL_STATE(10687)] = 686686,
  [SMALL_STATE(10688)] = 686694,
  [SMALL_STATE(10689)] = 686702,
  [SMALL_STATE(10690)] = 686710,
  [SMALL_STATE(10691)] = 686718,
  [SMALL_STATE(10692)] = 686726,
  [SMALL_STATE(10693)] = 686734,
  [SMALL_STATE(10694)] = 686742,
  [SMALL_STATE(10695)] = 686750,
  [SMALL_STATE(10696)] = 686758,
  [SMALL_STATE(10697)] = 686766,
  [SMALL_STATE(10698)] = 686774,
  [SMALL_STATE(10699)] = 686782,
  [SMALL_STATE(10700)] = 686790,
  [SMALL_STATE(10701)] = 686798,
  [SMALL_STATE(10702)] = 686806,
  [SMALL_STATE(10703)] = 686814,
  [SMALL_STATE(10704)] = 686822,
  [SMALL_STATE(10705)] = 686830,
  [SMALL_STATE(10706)] = 686838,
  [SMALL_STATE(10707)] = 686846,
  [SMALL_STATE(10708)] = 686854,
  [SMALL_STATE(10709)] = 686862,
  [SMALL_STATE(10710)] = 686870,
  [SMALL_STATE(10711)] = 686878,
  [SMALL_STATE(10712)] = 686886,
  [SMALL_STATE(10713)] = 686894,
  [SMALL_STATE(10714)] = 686902,
  [SMALL_STATE(10715)] = 686910,
  [SMALL_STATE(10716)] = 686918,
  [SMALL_STATE(10717)] = 686926,
  [SMALL_STATE(10718)] = 686934,
  [SMALL_STATE(10719)] = 686942,
  [SMALL_STATE(10720)] = 686950,
  [SMALL_STATE(10721)] = 686958,
  [SMALL_STATE(10722)] = 686966,
  [SMALL_STATE(10723)] = 686974,
  [SMALL_STATE(10724)] = 686982,
  [SMALL_STATE(10725)] = 686990,
  [SMALL_STATE(10726)] = 686998,
  [SMALL_STATE(10727)] = 687006,
  [SMALL_STATE(10728)] = 687014,
  [SMALL_STATE(10729)] = 687022,
  [SMALL_STATE(10730)] = 687030,
  [SMALL_STATE(10731)] = 687038,
  [SMALL_STATE(10732)] = 687046,
  [SMALL_STATE(10733)] = 687054,
  [SMALL_STATE(10734)] = 687062,
  [SMALL_STATE(10735)] = 687070,
  [SMALL_STATE(10736)] = 687078,
  [SMALL_STATE(10737)] = 687086,
  [SMALL_STATE(10738)] = 687094,
  [SMALL_STATE(10739)] = 687102,
  [SMALL_STATE(10740)] = 687110,
  [SMALL_STATE(10741)] = 687118,
  [SMALL_STATE(10742)] = 687126,
  [SMALL_STATE(10743)] = 687134,
  [SMALL_STATE(10744)] = 687142,
  [SMALL_STATE(10745)] = 687150,
  [SMALL_STATE(10746)] = 687158,
  [SMALL_STATE(10747)] = 687166,
  [SMALL_STATE(10748)] = 687174,
  [SMALL_STATE(10749)] = 687182,
  [SMALL_STATE(10750)] = 687190,
  [SMALL_STATE(10751)] = 687198,
  [SMALL_STATE(10752)] = 687206,
  [SMALL_STATE(10753)] = 687214,
  [SMALL_STATE(10754)] = 687222,
  [SMALL_STATE(10755)] = 687230,
  [SMALL_STATE(10756)] = 687238,
  [SMALL_STATE(10757)] = 687246,
  [SMALL_STATE(10758)] = 687254,
  [SMALL_STATE(10759)] = 687262,
  [SMALL_STATE(10760)] = 687270,
  [SMALL_STATE(10761)] = 687278,
  [SMALL_STATE(10762)] = 687286,
  [SMALL_STATE(10763)] = 687294,
  [SMALL_STATE(10764)] = 687302,
  [SMALL_STATE(10765)] = 687310,
  [SMALL_STATE(10766)] = 687318,
  [SMALL_STATE(10767)] = 687326,
  [SMALL_STATE(10768)] = 687334,
  [SMALL_STATE(10769)] = 687342,
  [SMALL_STATE(10770)] = 687350,
  [SMALL_STATE(10771)] = 687358,
  [SMALL_STATE(10772)] = 687366,
  [SMALL_STATE(10773)] = 687374,
  [SMALL_STATE(10774)] = 687382,
  [SMALL_STATE(10775)] = 687390,
  [SMALL_STATE(10776)] = 687398,
  [SMALL_STATE(10777)] = 687406,
  [SMALL_STATE(10778)] = 687414,
  [SMALL_STATE(10779)] = 687422,
  [SMALL_STATE(10780)] = 687430,
  [SMALL_STATE(10781)] = 687438,
  [SMALL_STATE(10782)] = 687446,
  [SMALL_STATE(10783)] = 687454,
  [SMALL_STATE(10784)] = 687462,
  [SMALL_STATE(10785)] = 687470,
  [SMALL_STATE(10786)] = 687478,
  [SMALL_STATE(10787)] = 687486,
  [SMALL_STATE(10788)] = 687494,
  [SMALL_STATE(10789)] = 687502,
  [SMALL_STATE(10790)] = 687510,
  [SMALL_STATE(10791)] = 687518,
  [SMALL_STATE(10792)] = 687526,
  [SMALL_STATE(10793)] = 687534,
  [SMALL_STATE(10794)] = 687542,
  [SMALL_STATE(10795)] = 687550,
  [SMALL_STATE(10796)] = 687558,
  [SMALL_STATE(10797)] = 687566,
  [SMALL_STATE(10798)] = 687574,
  [SMALL_STATE(10799)] = 687582,
  [SMALL_STATE(10800)] = 687590,
  [SMALL_STATE(10801)] = 687598,
  [SMALL_STATE(10802)] = 687606,
  [SMALL_STATE(10803)] = 687614,
  [SMALL_STATE(10804)] = 687622,
  [SMALL_STATE(10805)] = 687630,
  [SMALL_STATE(10806)] = 687638,
  [SMALL_STATE(10807)] = 687646,
  [SMALL_STATE(10808)] = 687654,
  [SMALL_STATE(10809)] = 687662,
  [SMALL_STATE(10810)] = 687670,
  [SMALL_STATE(10811)] = 687678,
  [SMALL_STATE(10812)] = 687686,
  [SMALL_STATE(10813)] = 687694,
  [SMALL_STATE(10814)] = 687702,
  [SMALL_STATE(10815)] = 687710,
  [SMALL_STATE(10816)] = 687718,
  [SMALL_STATE(10817)] = 687726,
  [SMALL_STATE(10818)] = 687734,
  [SMALL_STATE(10819)] = 687742,
  [SMALL_STATE(10820)] = 687750,
  [SMALL_STATE(10821)] = 687758,
  [SMALL_STATE(10822)] = 687766,
  [SMALL_STATE(10823)] = 687774,
  [SMALL_STATE(10824)] = 687782,
  [SMALL_STATE(10825)] = 687790,
  [SMALL_STATE(10826)] = 687798,
  [SMALL_STATE(10827)] = 687806,
  [SMALL_STATE(10828)] = 687814,
  [SMALL_STATE(10829)] = 687822,
  [SMALL_STATE(10830)] = 687830,
  [SMALL_STATE(10831)] = 687838,
  [SMALL_STATE(10832)] = 687846,
  [SMALL_STATE(10833)] = 687854,
  [SMALL_STATE(10834)] = 687862,
  [SMALL_STATE(10835)] = 687870,
  [SMALL_STATE(10836)] = 687878,
  [SMALL_STATE(10837)] = 687886,
  [SMALL_STATE(10838)] = 687894,
  [SMALL_STATE(10839)] = 687902,
  [SMALL_STATE(10840)] = 687910,
  [SMALL_STATE(10841)] = 687918,
  [SMALL_STATE(10842)] = 687926,
  [SMALL_STATE(10843)] = 687934,
  [SMALL_STATE(10844)] = 687942,
  [SMALL_STATE(10845)] = 687950,
  [SMALL_STATE(10846)] = 687958,
  [SMALL_STATE(10847)] = 687966,
  [SMALL_STATE(10848)] = 687974,
  [SMALL_STATE(10849)] = 687982,
  [SMALL_STATE(10850)] = 687990,
  [SMALL_STATE(10851)] = 687998,
  [SMALL_STATE(10852)] = 688006,
  [SMALL_STATE(10853)] = 688014,
  [SMALL_STATE(10854)] = 688022,
  [SMALL_STATE(10855)] = 688030,
  [SMALL_STATE(10856)] = 688038,
  [SMALL_STATE(10857)] = 688046,
  [SMALL_STATE(10858)] = 688054,
  [SMALL_STATE(10859)] = 688062,
  [SMALL_STATE(10860)] = 688070,
  [SMALL_STATE(10861)] = 688078,
  [SMALL_STATE(10862)] = 688086,
  [SMALL_STATE(10863)] = 688094,
  [SMALL_STATE(10864)] = 688102,
  [SMALL_STATE(10865)] = 688110,
  [SMALL_STATE(10866)] = 688118,
  [SMALL_STATE(10867)] = 688126,
  [SMALL_STATE(10868)] = 688134,
  [SMALL_STATE(10869)] = 688142,
  [SMALL_STATE(10870)] = 688150,
  [SMALL_STATE(10871)] = 688158,
  [SMALL_STATE(10872)] = 688166,
  [SMALL_STATE(10873)] = 688174,
  [SMALL_STATE(10874)] = 688182,
  [SMALL_STATE(10875)] = 688190,
  [SMALL_STATE(10876)] = 688198,
  [SMALL_STATE(10877)] = 688206,
  [SMALL_STATE(10878)] = 688214,
  [SMALL_STATE(10879)] = 688222,
  [SMALL_STATE(10880)] = 688230,
  [SMALL_STATE(10881)] = 688238,
  [SMALL_STATE(10882)] = 688246,
  [SMALL_STATE(10883)] = 688254,
  [SMALL_STATE(10884)] = 688262,
  [SMALL_STATE(10885)] = 688270,
  [SMALL_STATE(10886)] = 688278,
  [SMALL_STATE(10887)] = 688286,
  [SMALL_STATE(10888)] = 688294,
  [SMALL_STATE(10889)] = 688302,
  [SMALL_STATE(10890)] = 688310,
  [SMALL_STATE(10891)] = 688318,
  [SMALL_STATE(10892)] = 688326,
  [SMALL_STATE(10893)] = 688334,
  [SMALL_STATE(10894)] = 688342,
  [SMALL_STATE(10895)] = 688350,
  [SMALL_STATE(10896)] = 688358,
  [SMALL_STATE(10897)] = 688366,
  [SMALL_STATE(10898)] = 688374,
  [SMALL_STATE(10899)] = 688382,
  [SMALL_STATE(10900)] = 688390,
  [SMALL_STATE(10901)] = 688398,
  [SMALL_STATE(10902)] = 688406,
  [SMALL_STATE(10903)] = 688414,
  [SMALL_STATE(10904)] = 688422,
  [SMALL_STATE(10905)] = 688430,
  [SMALL_STATE(10906)] = 688438,
  [SMALL_STATE(10907)] = 688446,
  [SMALL_STATE(10908)] = 688454,
  [SMALL_STATE(10909)] = 688462,
  [SMALL_STATE(10910)] = 688470,
  [SMALL_STATE(10911)] = 688478,
  [SMALL_STATE(10912)] = 688486,
  [SMALL_STATE(10913)] = 688494,
  [SMALL_STATE(10914)] = 688502,
  [SMALL_STATE(10915)] = 688510,
  [SMALL_STATE(10916)] = 688518,
  [SMALL_STATE(10917)] = 688526,
  [SMALL_STATE(10918)] = 688534,
  [SMALL_STATE(10919)] = 688542,
  [SMALL_STATE(10920)] = 688550,
  [SMALL_STATE(10921)] = 688558,
  [SMALL_STATE(10922)] = 688566,
  [SMALL_STATE(10923)] = 688574,
  [SMALL_STATE(10924)] = 688582,
  [SMALL_STATE(10925)] = 688590,
  [SMALL_STATE(10926)] = 688598,
  [SMALL_STATE(10927)] = 688606,
  [SMALL_STATE(10928)] = 688614,
  [SMALL_STATE(10929)] = 688622,
  [SMALL_STATE(10930)] = 688630,
  [SMALL_STATE(10931)] = 688638,
  [SMALL_STATE(10932)] = 688646,
  [SMALL_STATE(10933)] = 688654,
  [SMALL_STATE(10934)] = 688662,
  [SMALL_STATE(10935)] = 688670,
  [SMALL_STATE(10936)] = 688678,
  [SMALL_STATE(10937)] = 688686,
  [SMALL_STATE(10938)] = 688694,
  [SMALL_STATE(10939)] = 688702,
  [SMALL_STATE(10940)] = 688710,
  [SMALL_STATE(10941)] = 688718,
  [SMALL_STATE(10942)] = 688726,
  [SMALL_STATE(10943)] = 688734,
  [SMALL_STATE(10944)] = 688742,
  [SMALL_STATE(10945)] = 688750,
  [SMALL_STATE(10946)] = 688758,
  [SMALL_STATE(10947)] = 688766,
  [SMALL_STATE(10948)] = 688774,
  [SMALL_STATE(10949)] = 688782,
  [SMALL_STATE(10950)] = 688790,
  [SMALL_STATE(10951)] = 688798,
  [SMALL_STATE(10952)] = 688806,
  [SMALL_STATE(10953)] = 688814,
  [SMALL_STATE(10954)] = 688822,
  [SMALL_STATE(10955)] = 688830,
  [SMALL_STATE(10956)] = 688838,
  [SMALL_STATE(10957)] = 688846,
  [SMALL_STATE(10958)] = 688854,
  [SMALL_STATE(10959)] = 688862,
  [SMALL_STATE(10960)] = 688870,
  [SMALL_STATE(10961)] = 688878,
  [SMALL_STATE(10962)] = 688886,
  [SMALL_STATE(10963)] = 688894,
  [SMALL_STATE(10964)] = 688902,
  [SMALL_STATE(10965)] = 688910,
  [SMALL_STATE(10966)] = 688918,
  [SMALL_STATE(10967)] = 688926,
  [SMALL_STATE(10968)] = 688934,
  [SMALL_STATE(10969)] = 688942,
  [SMALL_STATE(10970)] = 688950,
  [SMALL_STATE(10971)] = 688958,
  [SMALL_STATE(10972)] = 688966,
  [SMALL_STATE(10973)] = 688974,
  [SMALL_STATE(10974)] = 688982,
  [SMALL_STATE(10975)] = 688990,
  [SMALL_STATE(10976)] = 688998,
  [SMALL_STATE(10977)] = 689006,
  [SMALL_STATE(10978)] = 689014,
  [SMALL_STATE(10979)] = 689022,
  [SMALL_STATE(10980)] = 689030,
  [SMALL_STATE(10981)] = 689038,
  [SMALL_STATE(10982)] = 689046,
  [SMALL_STATE(10983)] = 689054,
  [SMALL_STATE(10984)] = 689062,
  [SMALL_STATE(10985)] = 689070,
  [SMALL_STATE(10986)] = 689078,
  [SMALL_STATE(10987)] = 689086,
  [SMALL_STATE(10988)] = 689094,
  [SMALL_STATE(10989)] = 689102,
  [SMALL_STATE(10990)] = 689110,
  [SMALL_STATE(10991)] = 689118,
  [SMALL_STATE(10992)] = 689126,
  [SMALL_STATE(10993)] = 689134,
  [SMALL_STATE(10994)] = 689142,
  [SMALL_STATE(10995)] = 689150,
  [SMALL_STATE(10996)] = 689158,
  [SMALL_STATE(10997)] = 689166,
  [SMALL_STATE(10998)] = 689174,
  [SMALL_STATE(10999)] = 689182,
  [SMALL_STATE(11000)] = 689190,
  [SMALL_STATE(11001)] = 689198,
  [SMALL_STATE(11002)] = 689206,
  [SMALL_STATE(11003)] = 689214,
  [SMALL_STATE(11004)] = 689222,
  [SMALL_STATE(11005)] = 689230,
  [SMALL_STATE(11006)] = 689238,
  [SMALL_STATE(11007)] = 689246,
  [SMALL_STATE(11008)] = 689254,
  [SMALL_STATE(11009)] = 689262,
  [SMALL_STATE(11010)] = 689270,
  [SMALL_STATE(11011)] = 689278,
  [SMALL_STATE(11012)] = 689286,
  [SMALL_STATE(11013)] = 689294,
  [SMALL_STATE(11014)] = 689302,
  [SMALL_STATE(11015)] = 689310,
  [SMALL_STATE(11016)] = 689318,
  [SMALL_STATE(11017)] = 689326,
  [SMALL_STATE(11018)] = 689334,
  [SMALL_STATE(11019)] = 689342,
  [SMALL_STATE(11020)] = 689350,
  [SMALL_STATE(11021)] = 689358,
  [SMALL_STATE(11022)] = 689366,
  [SMALL_STATE(11023)] = 689374,
  [SMALL_STATE(11024)] = 689382,
  [SMALL_STATE(11025)] = 689390,
  [SMALL_STATE(11026)] = 689398,
  [SMALL_STATE(11027)] = 689406,
  [SMALL_STATE(11028)] = 689414,
  [SMALL_STATE(11029)] = 689422,
  [SMALL_STATE(11030)] = 689430,
  [SMALL_STATE(11031)] = 689438,
  [SMALL_STATE(11032)] = 689446,
  [SMALL_STATE(11033)] = 689454,
  [SMALL_STATE(11034)] = 689462,
  [SMALL_STATE(11035)] = 689470,
  [SMALL_STATE(11036)] = 689478,
  [SMALL_STATE(11037)] = 689486,
  [SMALL_STATE(11038)] = 689494,
  [SMALL_STATE(11039)] = 689502,
  [SMALL_STATE(11040)] = 689510,
  [SMALL_STATE(11041)] = 689518,
  [SMALL_STATE(11042)] = 689526,
  [SMALL_STATE(11043)] = 689534,
  [SMALL_STATE(11044)] = 689542,
  [SMALL_STATE(11045)] = 689550,
  [SMALL_STATE(11046)] = 689558,
  [SMALL_STATE(11047)] = 689566,
  [SMALL_STATE(11048)] = 689574,
  [SMALL_STATE(11049)] = 689582,
  [SMALL_STATE(11050)] = 689590,
  [SMALL_STATE(11051)] = 689598,
  [SMALL_STATE(11052)] = 689606,
  [SMALL_STATE(11053)] = 689614,
  [SMALL_STATE(11054)] = 689622,
  [SMALL_STATE(11055)] = 689630,
  [SMALL_STATE(11056)] = 689638,
  [SMALL_STATE(11057)] = 689646,
  [SMALL_STATE(11058)] = 689654,
  [SMALL_STATE(11059)] = 689662,
  [SMALL_STATE(11060)] = 689670,
  [SMALL_STATE(11061)] = 689678,
  [SMALL_STATE(11062)] = 689686,
  [SMALL_STATE(11063)] = 689694,
  [SMALL_STATE(11064)] = 689702,
  [SMALL_STATE(11065)] = 689710,
  [SMALL_STATE(11066)] = 689718,
  [SMALL_STATE(11067)] = 689726,
  [SMALL_STATE(11068)] = 689734,
  [SMALL_STATE(11069)] = 689742,
  [SMALL_STATE(11070)] = 689750,
  [SMALL_STATE(11071)] = 689758,
  [SMALL_STATE(11072)] = 689766,
  [SMALL_STATE(11073)] = 689774,
  [SMALL_STATE(11074)] = 689782,
  [SMALL_STATE(11075)] = 689790,
  [SMALL_STATE(11076)] = 689798,
  [SMALL_STATE(11077)] = 689806,
  [SMALL_STATE(11078)] = 689814,
  [SMALL_STATE(11079)] = 689822,
  [SMALL_STATE(11080)] = 689830,
  [SMALL_STATE(11081)] = 689838,
  [SMALL_STATE(11082)] = 689846,
  [SMALL_STATE(11083)] = 689854,
  [SMALL_STATE(11084)] = 689862,
  [SMALL_STATE(11085)] = 689870,
  [SMALL_STATE(11086)] = 689878,
  [SMALL_STATE(11087)] = 689886,
  [SMALL_STATE(11088)] = 689894,
  [SMALL_STATE(11089)] = 689902,
  [SMALL_STATE(11090)] = 689910,
  [SMALL_STATE(11091)] = 689918,
  [SMALL_STATE(11092)] = 689926,
  [SMALL_STATE(11093)] = 689934,
  [SMALL_STATE(11094)] = 689942,
  [SMALL_STATE(11095)] = 689950,
  [SMALL_STATE(11096)] = 689958,
  [SMALL_STATE(11097)] = 689966,
  [SMALL_STATE(11098)] = 689974,
  [SMALL_STATE(11099)] = 689982,
  [SMALL_STATE(11100)] = 689990,
  [SMALL_STATE(11101)] = 689998,
  [SMALL_STATE(11102)] = 690006,
  [SMALL_STATE(11103)] = 690014,
  [SMALL_STATE(11104)] = 690022,
  [SMALL_STATE(11105)] = 690030,
  [SMALL_STATE(11106)] = 690038,
  [SMALL_STATE(11107)] = 690046,
  [SMALL_STATE(11108)] = 690054,
  [SMALL_STATE(11109)] = 690062,
  [SMALL_STATE(11110)] = 690070,
  [SMALL_STATE(11111)] = 690078,
  [SMALL_STATE(11112)] = 690086,
  [SMALL_STATE(11113)] = 690094,
  [SMALL_STATE(11114)] = 690102,
  [SMALL_STATE(11115)] = 690110,
  [SMALL_STATE(11116)] = 690118,
  [SMALL_STATE(11117)] = 690126,
  [SMALL_STATE(11118)] = 690134,
  [SMALL_STATE(11119)] = 690142,
  [SMALL_STATE(11120)] = 690150,
  [SMALL_STATE(11121)] = 690158,
  [SMALL_STATE(11122)] = 690166,
  [SMALL_STATE(11123)] = 690174,
  [SMALL_STATE(11124)] = 690182,
  [SMALL_STATE(11125)] = 690190,
  [SMALL_STATE(11126)] = 690198,
  [SMALL_STATE(11127)] = 690206,
  [SMALL_STATE(11128)] = 690214,
  [SMALL_STATE(11129)] = 690222,
  [SMALL_STATE(11130)] = 690230,
  [SMALL_STATE(11131)] = 690238,
  [SMALL_STATE(11132)] = 690246,
  [SMALL_STATE(11133)] = 690254,
  [SMALL_STATE(11134)] = 690262,
  [SMALL_STATE(11135)] = 690270,
  [SMALL_STATE(11136)] = 690278,
  [SMALL_STATE(11137)] = 690286,
  [SMALL_STATE(11138)] = 690294,
  [SMALL_STATE(11139)] = 690302,
  [SMALL_STATE(11140)] = 690310,
  [SMALL_STATE(11141)] = 690318,
  [SMALL_STATE(11142)] = 690326,
  [SMALL_STATE(11143)] = 690334,
  [SMALL_STATE(11144)] = 690342,
  [SMALL_STATE(11145)] = 690350,
  [SMALL_STATE(11146)] = 690358,
  [SMALL_STATE(11147)] = 690366,
  [SMALL_STATE(11148)] = 690374,
  [SMALL_STATE(11149)] = 690382,
  [SMALL_STATE(11150)] = 690390,
  [SMALL_STATE(11151)] = 690398,
  [SMALL_STATE(11152)] = 690406,
  [SMALL_STATE(11153)] = 690414,
  [SMALL_STATE(11154)] = 690422,
  [SMALL_STATE(11155)] = 690430,
  [SMALL_STATE(11156)] = 690438,
  [SMALL_STATE(11157)] = 690446,
  [SMALL_STATE(11158)] = 690454,
  [SMALL_STATE(11159)] = 690462,
  [SMALL_STATE(11160)] = 690470,
  [SMALL_STATE(11161)] = 690478,
  [SMALL_STATE(11162)] = 690486,
  [SMALL_STATE(11163)] = 690494,
  [SMALL_STATE(11164)] = 690502,
  [SMALL_STATE(11165)] = 690510,
  [SMALL_STATE(11166)] = 690518,
  [SMALL_STATE(11167)] = 690526,
  [SMALL_STATE(11168)] = 690534,
  [SMALL_STATE(11169)] = 690542,
  [SMALL_STATE(11170)] = 690550,
  [SMALL_STATE(11171)] = 690558,
  [SMALL_STATE(11172)] = 690566,
  [SMALL_STATE(11173)] = 690574,
  [SMALL_STATE(11174)] = 690582,
  [SMALL_STATE(11175)] = 690590,
  [SMALL_STATE(11176)] = 690598,
  [SMALL_STATE(11177)] = 690606,
  [SMALL_STATE(11178)] = 690614,
  [SMALL_STATE(11179)] = 690622,
  [SMALL_STATE(11180)] = 690630,
  [SMALL_STATE(11181)] = 690638,
  [SMALL_STATE(11182)] = 690646,
  [SMALL_STATE(11183)] = 690654,
  [SMALL_STATE(11184)] = 690662,
  [SMALL_STATE(11185)] = 690670,
  [SMALL_STATE(11186)] = 690678,
  [SMALL_STATE(11187)] = 690686,
  [SMALL_STATE(11188)] = 690694,
  [SMALL_STATE(11189)] = 690702,
  [SMALL_STATE(11190)] = 690710,
  [SMALL_STATE(11191)] = 690718,
  [SMALL_STATE(11192)] = 690726,
  [SMALL_STATE(11193)] = 690734,
  [SMALL_STATE(11194)] = 690742,
  [SMALL_STATE(11195)] = 690750,
  [SMALL_STATE(11196)] = 690758,
  [SMALL_STATE(11197)] = 690766,
  [SMALL_STATE(11198)] = 690774,
  [SMALL_STATE(11199)] = 690782,
  [SMALL_STATE(11200)] = 690790,
  [SMALL_STATE(11201)] = 690798,
  [SMALL_STATE(11202)] = 690806,
  [SMALL_STATE(11203)] = 690814,
  [SMALL_STATE(11204)] = 690822,
  [SMALL_STATE(11205)] = 690830,
  [SMALL_STATE(11206)] = 690838,
  [SMALL_STATE(11207)] = 690846,
  [SMALL_STATE(11208)] = 690854,
  [SMALL_STATE(11209)] = 690862,
  [SMALL_STATE(11210)] = 690870,
  [SMALL_STATE(11211)] = 690878,
  [SMALL_STATE(11212)] = 690886,
  [SMALL_STATE(11213)] = 690894,
  [SMALL_STATE(11214)] = 690902,
  [SMALL_STATE(11215)] = 690910,
  [SMALL_STATE(11216)] = 690918,
  [SMALL_STATE(11217)] = 690926,
  [SMALL_STATE(11218)] = 690934,
  [SMALL_STATE(11219)] = 690942,
  [SMALL_STATE(11220)] = 690950,
  [SMALL_STATE(11221)] = 690958,
  [SMALL_STATE(11222)] = 690966,
  [SMALL_STATE(11223)] = 690974,
  [SMALL_STATE(11224)] = 690982,
  [SMALL_STATE(11225)] = 690990,
  [SMALL_STATE(11226)] = 690998,
  [SMALL_STATE(11227)] = 691006,
  [SMALL_STATE(11228)] = 691014,
  [SMALL_STATE(11229)] = 691022,
  [SMALL_STATE(11230)] = 691030,
  [SMALL_STATE(11231)] = 691038,
  [SMALL_STATE(11232)] = 691046,
  [SMALL_STATE(11233)] = 691054,
  [SMALL_STATE(11234)] = 691062,
  [SMALL_STATE(11235)] = 691070,
  [SMALL_STATE(11236)] = 691078,
  [SMALL_STATE(11237)] = 691086,
  [SMALL_STATE(11238)] = 691094,
  [SMALL_STATE(11239)] = 691102,
  [SMALL_STATE(11240)] = 691110,
  [SMALL_STATE(11241)] = 691118,
  [SMALL_STATE(11242)] = 691126,
  [SMALL_STATE(11243)] = 691134,
  [SMALL_STATE(11244)] = 691142,
  [SMALL_STATE(11245)] = 691150,
  [SMALL_STATE(11246)] = 691158,
  [SMALL_STATE(11247)] = 691166,
  [SMALL_STATE(11248)] = 691174,
  [SMALL_STATE(11249)] = 691182,
  [SMALL_STATE(11250)] = 691190,
  [SMALL_STATE(11251)] = 691198,
  [SMALL_STATE(11252)] = 691206,
  [SMALL_STATE(11253)] = 691214,
  [SMALL_STATE(11254)] = 691222,
  [SMALL_STATE(11255)] = 691230,
  [SMALL_STATE(11256)] = 691238,
  [SMALL_STATE(11257)] = 691246,
  [SMALL_STATE(11258)] = 691254,
  [SMALL_STATE(11259)] = 691262,
  [SMALL_STATE(11260)] = 691270,
  [SMALL_STATE(11261)] = 691278,
  [SMALL_STATE(11262)] = 691286,
  [SMALL_STATE(11263)] = 691294,
  [SMALL_STATE(11264)] = 691302,
  [SMALL_STATE(11265)] = 691310,
  [SMALL_STATE(11266)] = 691318,
  [SMALL_STATE(11267)] = 691326,
  [SMALL_STATE(11268)] = 691334,
  [SMALL_STATE(11269)] = 691342,
  [SMALL_STATE(11270)] = 691350,
  [SMALL_STATE(11271)] = 691358,
  [SMALL_STATE(11272)] = 691366,
  [SMALL_STATE(11273)] = 691374,
  [SMALL_STATE(11274)] = 691382,
  [SMALL_STATE(11275)] = 691390,
  [SMALL_STATE(11276)] = 691398,
  [SMALL_STATE(11277)] = 691406,
  [SMALL_STATE(11278)] = 691414,
  [SMALL_STATE(11279)] = 691422,
  [SMALL_STATE(11280)] = 691430,
  [SMALL_STATE(11281)] = 691438,
  [SMALL_STATE(11282)] = 691446,
  [SMALL_STATE(11283)] = 691454,
  [SMALL_STATE(11284)] = 691462,
  [SMALL_STATE(11285)] = 691470,
  [SMALL_STATE(11286)] = 691478,
  [SMALL_STATE(11287)] = 691486,
  [SMALL_STATE(11288)] = 691494,
  [SMALL_STATE(11289)] = 691502,
  [SMALL_STATE(11290)] = 691510,
  [SMALL_STATE(11291)] = 691518,
  [SMALL_STATE(11292)] = 691526,
  [SMALL_STATE(11293)] = 691534,
  [SMALL_STATE(11294)] = 691542,
  [SMALL_STATE(11295)] = 691550,
  [SMALL_STATE(11296)] = 691558,
  [SMALL_STATE(11297)] = 691566,
  [SMALL_STATE(11298)] = 691574,
  [SMALL_STATE(11299)] = 691582,
  [SMALL_STATE(11300)] = 691590,
  [SMALL_STATE(11301)] = 691598,
  [SMALL_STATE(11302)] = 691606,
  [SMALL_STATE(11303)] = 691614,
  [SMALL_STATE(11304)] = 691622,
  [SMALL_STATE(11305)] = 691630,
  [SMALL_STATE(11306)] = 691638,
  [SMALL_STATE(11307)] = 691646,
  [SMALL_STATE(11308)] = 691654,
  [SMALL_STATE(11309)] = 691662,
  [SMALL_STATE(11310)] = 691670,
  [SMALL_STATE(11311)] = 691678,
  [SMALL_STATE(11312)] = 691686,
  [SMALL_STATE(11313)] = 691694,
  [SMALL_STATE(11314)] = 691702,
  [SMALL_STATE(11315)] = 691710,
  [SMALL_STATE(11316)] = 691718,
  [SMALL_STATE(11317)] = 691726,
  [SMALL_STATE(11318)] = 691734,
  [SMALL_STATE(11319)] = 691742,
  [SMALL_STATE(11320)] = 691750,
  [SMALL_STATE(11321)] = 691758,
  [SMALL_STATE(11322)] = 691766,
  [SMALL_STATE(11323)] = 691774,
  [SMALL_STATE(11324)] = 691782,
  [SMALL_STATE(11325)] = 691790,
  [SMALL_STATE(11326)] = 691798,
  [SMALL_STATE(11327)] = 691806,
  [SMALL_STATE(11328)] = 691814,
  [SMALL_STATE(11329)] = 691822,
  [SMALL_STATE(11330)] = 691830,
  [SMALL_STATE(11331)] = 691838,
  [SMALL_STATE(11332)] = 691846,
  [SMALL_STATE(11333)] = 691854,
  [SMALL_STATE(11334)] = 691862,
  [SMALL_STATE(11335)] = 691870,
  [SMALL_STATE(11336)] = 691878,
  [SMALL_STATE(11337)] = 691886,
  [SMALL_STATE(11338)] = 691894,
  [SMALL_STATE(11339)] = 691902,
  [SMALL_STATE(11340)] = 691910,
  [SMALL_STATE(11341)] = 691918,
  [SMALL_STATE(11342)] = 691926,
  [SMALL_STATE(11343)] = 691934,
  [SMALL_STATE(11344)] = 691942,
  [SMALL_STATE(11345)] = 691950,
  [SMALL_STATE(11346)] = 691958,
  [SMALL_STATE(11347)] = 691966,
  [SMALL_STATE(11348)] = 691974,
  [SMALL_STATE(11349)] = 691982,
  [SMALL_STATE(11350)] = 691990,
  [SMALL_STATE(11351)] = 691998,
  [SMALL_STATE(11352)] = 692006,
  [SMALL_STATE(11353)] = 692014,
  [SMALL_STATE(11354)] = 692022,
  [SMALL_STATE(11355)] = 692030,
  [SMALL_STATE(11356)] = 692038,
  [SMALL_STATE(11357)] = 692046,
  [SMALL_STATE(11358)] = 692054,
  [SMALL_STATE(11359)] = 692062,
  [SMALL_STATE(11360)] = 692070,
  [SMALL_STATE(11361)] = 692078,
  [SMALL_STATE(11362)] = 692086,
  [SMALL_STATE(11363)] = 692094,
  [SMALL_STATE(11364)] = 692102,
  [SMALL_STATE(11365)] = 692110,
  [SMALL_STATE(11366)] = 692118,
  [SMALL_STATE(11367)] = 692126,
  [SMALL_STATE(11368)] = 692134,
  [SMALL_STATE(11369)] = 692142,
  [SMALL_STATE(11370)] = 692150,
  [SMALL_STATE(11371)] = 692158,
  [SMALL_STATE(11372)] = 692166,
  [SMALL_STATE(11373)] = 692174,
  [SMALL_STATE(11374)] = 692182,
  [SMALL_STATE(11375)] = 692190,
  [SMALL_STATE(11376)] = 692198,
  [SMALL_STATE(11377)] = 692206,
  [SMALL_STATE(11378)] = 692214,
  [SMALL_STATE(11379)] = 692222,
  [SMALL_STATE(11380)] = 692230,
  [SMALL_STATE(11381)] = 692238,
  [SMALL_STATE(11382)] = 692246,
  [SMALL_STATE(11383)] = 692254,
  [SMALL_STATE(11384)] = 692262,
  [SMALL_STATE(11385)] = 692270,
  [SMALL_STATE(11386)] = 692278,
  [SMALL_STATE(11387)] = 692286,
  [SMALL_STATE(11388)] = 692294,
  [SMALL_STATE(11389)] = 692302,
  [SMALL_STATE(11390)] = 692310,
  [SMALL_STATE(11391)] = 692318,
  [SMALL_STATE(11392)] = 692326,
  [SMALL_STATE(11393)] = 692334,
  [SMALL_STATE(11394)] = 692342,
  [SMALL_STATE(11395)] = 692350,
  [SMALL_STATE(11396)] = 692358,
  [SMALL_STATE(11397)] = 692366,
  [SMALL_STATE(11398)] = 692374,
  [SMALL_STATE(11399)] = 692382,
  [SMALL_STATE(11400)] = 692390,
  [SMALL_STATE(11401)] = 692398,
  [SMALL_STATE(11402)] = 692406,
  [SMALL_STATE(11403)] = 692414,
  [SMALL_STATE(11404)] = 692422,
  [SMALL_STATE(11405)] = 692430,
  [SMALL_STATE(11406)] = 692438,
  [SMALL_STATE(11407)] = 692446,
  [SMALL_STATE(11408)] = 692454,
  [SMALL_STATE(11409)] = 692462,
  [SMALL_STATE(11410)] = 692470,
  [SMALL_STATE(11411)] = 692478,
  [SMALL_STATE(11412)] = 692486,
  [SMALL_STATE(11413)] = 692494,
  [SMALL_STATE(11414)] = 692502,
  [SMALL_STATE(11415)] = 692510,
  [SMALL_STATE(11416)] = 692518,
  [SMALL_STATE(11417)] = 692526,
  [SMALL_STATE(11418)] = 692534,
  [SMALL_STATE(11419)] = 692542,
  [SMALL_STATE(11420)] = 692550,
  [SMALL_STATE(11421)] = 692558,
  [SMALL_STATE(11422)] = 692566,
  [SMALL_STATE(11423)] = 692574,
  [SMALL_STATE(11424)] = 692582,
  [SMALL_STATE(11425)] = 692590,
  [SMALL_STATE(11426)] = 692598,
  [SMALL_STATE(11427)] = 692606,
  [SMALL_STATE(11428)] = 692614,
  [SMALL_STATE(11429)] = 692622,
  [SMALL_STATE(11430)] = 692630,
  [SMALL_STATE(11431)] = 692638,
  [SMALL_STATE(11432)] = 692646,
  [SMALL_STATE(11433)] = 692654,
  [SMALL_STATE(11434)] = 692662,
  [SMALL_STATE(11435)] = 692670,
  [SMALL_STATE(11436)] = 692678,
  [SMALL_STATE(11437)] = 692686,
  [SMALL_STATE(11438)] = 692694,
  [SMALL_STATE(11439)] = 692702,
  [SMALL_STATE(11440)] = 692710,
  [SMALL_STATE(11441)] = 692718,
  [SMALL_STATE(11442)] = 692726,
  [SMALL_STATE(11443)] = 692734,
  [SMALL_STATE(11444)] = 692742,
  [SMALL_STATE(11445)] = 692750,
  [SMALL_STATE(11446)] = 692758,
  [SMALL_STATE(11447)] = 692766,
  [SMALL_STATE(11448)] = 692774,
  [SMALL_STATE(11449)] = 692782,
  [SMALL_STATE(11450)] = 692790,
  [SMALL_STATE(11451)] = 692798,
  [SMALL_STATE(11452)] = 692806,
  [SMALL_STATE(11453)] = 692814,
  [SMALL_STATE(11454)] = 692822,
  [SMALL_STATE(11455)] = 692830,
  [SMALL_STATE(11456)] = 692838,
  [SMALL_STATE(11457)] = 692846,
  [SMALL_STATE(11458)] = 692854,
  [SMALL_STATE(11459)] = 692862,
  [SMALL_STATE(11460)] = 692870,
  [SMALL_STATE(11461)] = 692878,
  [SMALL_STATE(11462)] = 692886,
  [SMALL_STATE(11463)] = 692894,
  [SMALL_STATE(11464)] = 692902,
  [SMALL_STATE(11465)] = 692910,
  [SMALL_STATE(11466)] = 692918,
  [SMALL_STATE(11467)] = 692926,
  [SMALL_STATE(11468)] = 692934,
  [SMALL_STATE(11469)] = 692942,
  [SMALL_STATE(11470)] = 692950,
  [SMALL_STATE(11471)] = 692958,
  [SMALL_STATE(11472)] = 692966,
  [SMALL_STATE(11473)] = 692974,
  [SMALL_STATE(11474)] = 692982,
  [SMALL_STATE(11475)] = 692990,
  [SMALL_STATE(11476)] = 692998,
  [SMALL_STATE(11477)] = 693006,
  [SMALL_STATE(11478)] = 693014,
  [SMALL_STATE(11479)] = 693022,
  [SMALL_STATE(11480)] = 693030,
  [SMALL_STATE(11481)] = 693038,
  [SMALL_STATE(11482)] = 693046,
  [SMALL_STATE(11483)] = 693054,
  [SMALL_STATE(11484)] = 693062,
  [SMALL_STATE(11485)] = 693070,
  [SMALL_STATE(11486)] = 693078,
  [SMALL_STATE(11487)] = 693086,
  [SMALL_STATE(11488)] = 693094,
  [SMALL_STATE(11489)] = 693102,
  [SMALL_STATE(11490)] = 693110,
  [SMALL_STATE(11491)] = 693118,
  [SMALL_STATE(11492)] = 693126,
  [SMALL_STATE(11493)] = 693134,
  [SMALL_STATE(11494)] = 693142,
  [SMALL_STATE(11495)] = 693150,
  [SMALL_STATE(11496)] = 693158,
  [SMALL_STATE(11497)] = 693166,
  [SMALL_STATE(11498)] = 693174,
  [SMALL_STATE(11499)] = 693182,
  [SMALL_STATE(11500)] = 693190,
  [SMALL_STATE(11501)] = 693198,
  [SMALL_STATE(11502)] = 693206,
  [SMALL_STATE(11503)] = 693214,
  [SMALL_STATE(11504)] = 693222,
  [SMALL_STATE(11505)] = 693230,
  [SMALL_STATE(11506)] = 693238,
  [SMALL_STATE(11507)] = 693246,
  [SMALL_STATE(11508)] = 693254,
  [SMALL_STATE(11509)] = 693262,
  [SMALL_STATE(11510)] = 693270,
  [SMALL_STATE(11511)] = 693278,
  [SMALL_STATE(11512)] = 693286,
  [SMALL_STATE(11513)] = 693294,
  [SMALL_STATE(11514)] = 693302,
  [SMALL_STATE(11515)] = 693310,
  [SMALL_STATE(11516)] = 693318,
  [SMALL_STATE(11517)] = 693326,
  [SMALL_STATE(11518)] = 693334,
  [SMALL_STATE(11519)] = 693342,
  [SMALL_STATE(11520)] = 693350,
  [SMALL_STATE(11521)] = 693358,
  [SMALL_STATE(11522)] = 693366,
  [SMALL_STATE(11523)] = 693376,
  [SMALL_STATE(11524)] = 693384,
  [SMALL_STATE(11525)] = 693392,
  [SMALL_STATE(11526)] = 693400,
  [SMALL_STATE(11527)] = 693408,
  [SMALL_STATE(11528)] = 693416,
  [SMALL_STATE(11529)] = 693424,
  [SMALL_STATE(11530)] = 693432,
  [SMALL_STATE(11531)] = 693440,
  [SMALL_STATE(11532)] = 693448,
  [SMALL_STATE(11533)] = 693456,
  [SMALL_STATE(11534)] = 693464,
  [SMALL_STATE(11535)] = 693472,
  [SMALL_STATE(11536)] = 693480,
  [SMALL_STATE(11537)] = 693488,
  [SMALL_STATE(11538)] = 693496,
  [SMALL_STATE(11539)] = 693504,
  [SMALL_STATE(11540)] = 693512,
  [SMALL_STATE(11541)] = 693520,
  [SMALL_STATE(11542)] = 693528,
  [SMALL_STATE(11543)] = 693536,
  [SMALL_STATE(11544)] = 693544,
  [SMALL_STATE(11545)] = 693552,
  [SMALL_STATE(11546)] = 693560,
  [SMALL_STATE(11547)] = 693568,
  [SMALL_STATE(11548)] = 693576,
  [SMALL_STATE(11549)] = 693584,
  [SMALL_STATE(11550)] = 693592,
  [SMALL_STATE(11551)] = 693600,
  [SMALL_STATE(11552)] = 693608,
  [SMALL_STATE(11553)] = 693616,
  [SMALL_STATE(11554)] = 693624,
  [SMALL_STATE(11555)] = 693632,
  [SMALL_STATE(11556)] = 693640,
  [SMALL_STATE(11557)] = 693648,
  [SMALL_STATE(11558)] = 693656,
  [SMALL_STATE(11559)] = 693664,
  [SMALL_STATE(11560)] = 693672,
  [SMALL_STATE(11561)] = 693680,
  [SMALL_STATE(11562)] = 693688,
  [SMALL_STATE(11563)] = 693696,
  [SMALL_STATE(11564)] = 693704,
  [SMALL_STATE(11565)] = 693712,
  [SMALL_STATE(11566)] = 693720,
  [SMALL_STATE(11567)] = 693728,
  [SMALL_STATE(11568)] = 693736,
  [SMALL_STATE(11569)] = 693744,
  [SMALL_STATE(11570)] = 693752,
  [SMALL_STATE(11571)] = 693760,
  [SMALL_STATE(11572)] = 693768,
  [SMALL_STATE(11573)] = 693776,
  [SMALL_STATE(11574)] = 693784,
  [SMALL_STATE(11575)] = 693792,
  [SMALL_STATE(11576)] = 693800,
  [SMALL_STATE(11577)] = 693808,
  [SMALL_STATE(11578)] = 693816,
  [SMALL_STATE(11579)] = 693824,
  [SMALL_STATE(11580)] = 693832,
  [SMALL_STATE(11581)] = 693840,
  [SMALL_STATE(11582)] = 693848,
  [SMALL_STATE(11583)] = 693856,
  [SMALL_STATE(11584)] = 693864,
  [SMALL_STATE(11585)] = 693872,
  [SMALL_STATE(11586)] = 693880,
  [SMALL_STATE(11587)] = 693888,
  [SMALL_STATE(11588)] = 693896,
  [SMALL_STATE(11589)] = 693904,
  [SMALL_STATE(11590)] = 693912,
  [SMALL_STATE(11591)] = 693920,
  [SMALL_STATE(11592)] = 693928,
  [SMALL_STATE(11593)] = 693936,
  [SMALL_STATE(11594)] = 693944,
  [SMALL_STATE(11595)] = 693952,
  [SMALL_STATE(11596)] = 693960,
  [SMALL_STATE(11597)] = 693968,
  [SMALL_STATE(11598)] = 693976,
  [SMALL_STATE(11599)] = 693984,
  [SMALL_STATE(11600)] = 693992,
  [SMALL_STATE(11601)] = 694000,
  [SMALL_STATE(11602)] = 694008,
  [SMALL_STATE(11603)] = 694016,
  [SMALL_STATE(11604)] = 694024,
  [SMALL_STATE(11605)] = 694032,
  [SMALL_STATE(11606)] = 694040,
  [SMALL_STATE(11607)] = 694048,
  [SMALL_STATE(11608)] = 694056,
  [SMALL_STATE(11609)] = 694064,
  [SMALL_STATE(11610)] = 694072,
  [SMALL_STATE(11611)] = 694080,
  [SMALL_STATE(11612)] = 694088,
  [SMALL_STATE(11613)] = 694096,
  [SMALL_STATE(11614)] = 694104,
  [SMALL_STATE(11615)] = 694112,
  [SMALL_STATE(11616)] = 694120,
  [SMALL_STATE(11617)] = 694128,
  [SMALL_STATE(11618)] = 694136,
  [SMALL_STATE(11619)] = 694144,
  [SMALL_STATE(11620)] = 694152,
  [SMALL_STATE(11621)] = 694160,
  [SMALL_STATE(11622)] = 694168,
  [SMALL_STATE(11623)] = 694176,
  [SMALL_STATE(11624)] = 694184,
  [SMALL_STATE(11625)] = 694192,
  [SMALL_STATE(11626)] = 694200,
  [SMALL_STATE(11627)] = 694208,
  [SMALL_STATE(11628)] = 694216,
  [SMALL_STATE(11629)] = 694224,
  [SMALL_STATE(11630)] = 694232,
  [SMALL_STATE(11631)] = 694240,
  [SMALL_STATE(11632)] = 694248,
  [SMALL_STATE(11633)] = 694256,
  [SMALL_STATE(11634)] = 694264,
  [SMALL_STATE(11635)] = 694272,
  [SMALL_STATE(11636)] = 694280,
  [SMALL_STATE(11637)] = 694288,
  [SMALL_STATE(11638)] = 694296,
  [SMALL_STATE(11639)] = 694304,
  [SMALL_STATE(11640)] = 694312,
  [SMALL_STATE(11641)] = 694320,
  [SMALL_STATE(11642)] = 694328,
  [SMALL_STATE(11643)] = 694336,
  [SMALL_STATE(11644)] = 694344,
  [SMALL_STATE(11645)] = 694352,
  [SMALL_STATE(11646)] = 694360,
  [SMALL_STATE(11647)] = 694368,
  [SMALL_STATE(11648)] = 694376,
  [SMALL_STATE(11649)] = 694384,
  [SMALL_STATE(11650)] = 694392,
  [SMALL_STATE(11651)] = 694400,
  [SMALL_STATE(11652)] = 694408,
  [SMALL_STATE(11653)] = 694416,
  [SMALL_STATE(11654)] = 694424,
  [SMALL_STATE(11655)] = 694432,
  [SMALL_STATE(11656)] = 694440,
  [SMALL_STATE(11657)] = 694448,
  [SMALL_STATE(11658)] = 694456,
  [SMALL_STATE(11659)] = 694464,
  [SMALL_STATE(11660)] = 694472,
  [SMALL_STATE(11661)] = 694480,
  [SMALL_STATE(11662)] = 694488,
  [SMALL_STATE(11663)] = 694496,
  [SMALL_STATE(11664)] = 694504,
  [SMALL_STATE(11665)] = 694512,
  [SMALL_STATE(11666)] = 694520,
  [SMALL_STATE(11667)] = 694528,
  [SMALL_STATE(11668)] = 694536,
  [SMALL_STATE(11669)] = 694544,
  [SMALL_STATE(11670)] = 694552,
  [SMALL_STATE(11671)] = 694560,
  [SMALL_STATE(11672)] = 694568,
  [SMALL_STATE(11673)] = 694576,
  [SMALL_STATE(11674)] = 694584,
  [SMALL_STATE(11675)] = 694592,
  [SMALL_STATE(11676)] = 694600,
  [SMALL_STATE(11677)] = 694608,
  [SMALL_STATE(11678)] = 694616,
  [SMALL_STATE(11679)] = 694624,
  [SMALL_STATE(11680)] = 694632,
  [SMALL_STATE(11681)] = 694640,
  [SMALL_STATE(11682)] = 694648,
  [SMALL_STATE(11683)] = 694656,
  [SMALL_STATE(11684)] = 694664,
  [SMALL_STATE(11685)] = 694672,
  [SMALL_STATE(11686)] = 694680,
  [SMALL_STATE(11687)] = 694688,
  [SMALL_STATE(11688)] = 694696,
  [SMALL_STATE(11689)] = 694704,
  [SMALL_STATE(11690)] = 694712,
  [SMALL_STATE(11691)] = 694720,
  [SMALL_STATE(11692)] = 694728,
  [SMALL_STATE(11693)] = 694736,
  [SMALL_STATE(11694)] = 694744,
  [SMALL_STATE(11695)] = 694752,
  [SMALL_STATE(11696)] = 694760,
  [SMALL_STATE(11697)] = 694768,
  [SMALL_STATE(11698)] = 694776,
  [SMALL_STATE(11699)] = 694784,
  [SMALL_STATE(11700)] = 694792,
  [SMALL_STATE(11701)] = 694800,
  [SMALL_STATE(11702)] = 694808,
  [SMALL_STATE(11703)] = 694816,
  [SMALL_STATE(11704)] = 694824,
  [SMALL_STATE(11705)] = 694832,
  [SMALL_STATE(11706)] = 694840,
  [SMALL_STATE(11707)] = 694848,
  [SMALL_STATE(11708)] = 694856,
  [SMALL_STATE(11709)] = 694864,
  [SMALL_STATE(11710)] = 694872,
  [SMALL_STATE(11711)] = 694880,
  [SMALL_STATE(11712)] = 694888,
  [SMALL_STATE(11713)] = 694896,
  [SMALL_STATE(11714)] = 694904,
  [SMALL_STATE(11715)] = 694912,
  [SMALL_STATE(11716)] = 694920,
  [SMALL_STATE(11717)] = 694928,
  [SMALL_STATE(11718)] = 694936,
  [SMALL_STATE(11719)] = 694944,
  [SMALL_STATE(11720)] = 694952,
  [SMALL_STATE(11721)] = 694960,
  [SMALL_STATE(11722)] = 694968,
  [SMALL_STATE(11723)] = 694976,
  [SMALL_STATE(11724)] = 694984,
  [SMALL_STATE(11725)] = 694992,
  [SMALL_STATE(11726)] = 695000,
  [SMALL_STATE(11727)] = 695008,
  [SMALL_STATE(11728)] = 695016,
  [SMALL_STATE(11729)] = 695024,
  [SMALL_STATE(11730)] = 695032,
  [SMALL_STATE(11731)] = 695040,
  [SMALL_STATE(11732)] = 695048,
  [SMALL_STATE(11733)] = 695056,
  [SMALL_STATE(11734)] = 695064,
  [SMALL_STATE(11735)] = 695072,
  [SMALL_STATE(11736)] = 695080,
  [SMALL_STATE(11737)] = 695088,
  [SMALL_STATE(11738)] = 695096,
  [SMALL_STATE(11739)] = 695104,
  [SMALL_STATE(11740)] = 695112,
  [SMALL_STATE(11741)] = 695120,
  [SMALL_STATE(11742)] = 695128,
  [SMALL_STATE(11743)] = 695136,
  [SMALL_STATE(11744)] = 695144,
  [SMALL_STATE(11745)] = 695152,
  [SMALL_STATE(11746)] = 695160,
  [SMALL_STATE(11747)] = 695168,
  [SMALL_STATE(11748)] = 695176,
  [SMALL_STATE(11749)] = 695184,
  [SMALL_STATE(11750)] = 695192,
  [SMALL_STATE(11751)] = 695200,
  [SMALL_STATE(11752)] = 695208,
  [SMALL_STATE(11753)] = 695216,
  [SMALL_STATE(11754)] = 695224,
  [SMALL_STATE(11755)] = 695232,
  [SMALL_STATE(11756)] = 695240,
  [SMALL_STATE(11757)] = 695248,
  [SMALL_STATE(11758)] = 695256,
  [SMALL_STATE(11759)] = 695264,
  [SMALL_STATE(11760)] = 695272,
  [SMALL_STATE(11761)] = 695280,
  [SMALL_STATE(11762)] = 695288,
  [SMALL_STATE(11763)] = 695296,
  [SMALL_STATE(11764)] = 695304,
  [SMALL_STATE(11765)] = 695312,
  [SMALL_STATE(11766)] = 695320,
  [SMALL_STATE(11767)] = 695328,
  [SMALL_STATE(11768)] = 695336,
  [SMALL_STATE(11769)] = 695344,
  [SMALL_STATE(11770)] = 695352,
  [SMALL_STATE(11771)] = 695360,
  [SMALL_STATE(11772)] = 695368,
  [SMALL_STATE(11773)] = 695376,
  [SMALL_STATE(11774)] = 695384,
  [SMALL_STATE(11775)] = 695392,
  [SMALL_STATE(11776)] = 695400,
  [SMALL_STATE(11777)] = 695408,
  [SMALL_STATE(11778)] = 695416,
  [SMALL_STATE(11779)] = 695424,
  [SMALL_STATE(11780)] = 695432,
  [SMALL_STATE(11781)] = 695440,
  [SMALL_STATE(11782)] = 695448,
  [SMALL_STATE(11783)] = 695456,
  [SMALL_STATE(11784)] = 695464,
  [SMALL_STATE(11785)] = 695472,
  [SMALL_STATE(11786)] = 695480,
  [SMALL_STATE(11787)] = 695488,
  [SMALL_STATE(11788)] = 695496,
  [SMALL_STATE(11789)] = 695504,
  [SMALL_STATE(11790)] = 695512,
  [SMALL_STATE(11791)] = 695520,
  [SMALL_STATE(11792)] = 695528,
  [SMALL_STATE(11793)] = 695536,
  [SMALL_STATE(11794)] = 695544,
  [SMALL_STATE(11795)] = 695552,
  [SMALL_STATE(11796)] = 695560,
  [SMALL_STATE(11797)] = 695568,
  [SMALL_STATE(11798)] = 695576,
  [SMALL_STATE(11799)] = 695584,
  [SMALL_STATE(11800)] = 695592,
  [SMALL_STATE(11801)] = 695600,
  [SMALL_STATE(11802)] = 695608,
  [SMALL_STATE(11803)] = 695616,
  [SMALL_STATE(11804)] = 695624,
  [SMALL_STATE(11805)] = 695632,
  [SMALL_STATE(11806)] = 695640,
  [SMALL_STATE(11807)] = 695648,
  [SMALL_STATE(11808)] = 695656,
  [SMALL_STATE(11809)] = 695664,
  [SMALL_STATE(11810)] = 695672,
  [SMALL_STATE(11811)] = 695680,
  [SMALL_STATE(11812)] = 695688,
  [SMALL_STATE(11813)] = 695696,
  [SMALL_STATE(11814)] = 695704,
  [SMALL_STATE(11815)] = 695712,
  [SMALL_STATE(11816)] = 695720,
  [SMALL_STATE(11817)] = 695728,
  [SMALL_STATE(11818)] = 695736,
  [SMALL_STATE(11819)] = 695744,
  [SMALL_STATE(11820)] = 695752,
  [SMALL_STATE(11821)] = 695760,
  [SMALL_STATE(11822)] = 695768,
  [SMALL_STATE(11823)] = 695776,
  [SMALL_STATE(11824)] = 695784,
  [SMALL_STATE(11825)] = 695792,
  [SMALL_STATE(11826)] = 695800,
  [SMALL_STATE(11827)] = 695808,
  [SMALL_STATE(11828)] = 695816,
  [SMALL_STATE(11829)] = 695824,
  [SMALL_STATE(11830)] = 695832,
  [SMALL_STATE(11831)] = 695840,
  [SMALL_STATE(11832)] = 695848,
  [SMALL_STATE(11833)] = 695856,
  [SMALL_STATE(11834)] = 695864,
  [SMALL_STATE(11835)] = 695872,
  [SMALL_STATE(11836)] = 695880,
  [SMALL_STATE(11837)] = 695888,
  [SMALL_STATE(11838)] = 695896,
  [SMALL_STATE(11839)] = 695904,
  [SMALL_STATE(11840)] = 695912,
  [SMALL_STATE(11841)] = 695920,
  [SMALL_STATE(11842)] = 695928,
  [SMALL_STATE(11843)] = 695936,
  [SMALL_STATE(11844)] = 695944,
  [SMALL_STATE(11845)] = 695952,
  [SMALL_STATE(11846)] = 695960,
  [SMALL_STATE(11847)] = 695968,
  [SMALL_STATE(11848)] = 695976,
  [SMALL_STATE(11849)] = 695984,
  [SMALL_STATE(11850)] = 695992,
  [SMALL_STATE(11851)] = 696000,
  [SMALL_STATE(11852)] = 696008,
  [SMALL_STATE(11853)] = 696016,
  [SMALL_STATE(11854)] = 696024,
  [SMALL_STATE(11855)] = 696032,
  [SMALL_STATE(11856)] = 696040,
  [SMALL_STATE(11857)] = 696048,
  [SMALL_STATE(11858)] = 696056,
  [SMALL_STATE(11859)] = 696064,
  [SMALL_STATE(11860)] = 696072,
  [SMALL_STATE(11861)] = 696080,
  [SMALL_STATE(11862)] = 696088,
  [SMALL_STATE(11863)] = 696096,
  [SMALL_STATE(11864)] = 696104,
  [SMALL_STATE(11865)] = 696112,
  [SMALL_STATE(11866)] = 696120,
  [SMALL_STATE(11867)] = 696128,
  [SMALL_STATE(11868)] = 696136,
  [SMALL_STATE(11869)] = 696144,
  [SMALL_STATE(11870)] = 696152,
  [SMALL_STATE(11871)] = 696160,
  [SMALL_STATE(11872)] = 696168,
  [SMALL_STATE(11873)] = 696176,
  [SMALL_STATE(11874)] = 696184,
  [SMALL_STATE(11875)] = 696192,
  [SMALL_STATE(11876)] = 696200,
  [SMALL_STATE(11877)] = 696208,
  [SMALL_STATE(11878)] = 696216,
  [SMALL_STATE(11879)] = 696224,
  [SMALL_STATE(11880)] = 696232,
  [SMALL_STATE(11881)] = 696240,
  [SMALL_STATE(11882)] = 696248,
  [SMALL_STATE(11883)] = 696256,
  [SMALL_STATE(11884)] = 696264,
  [SMALL_STATE(11885)] = 696272,
  [SMALL_STATE(11886)] = 696280,
  [SMALL_STATE(11887)] = 696288,
  [SMALL_STATE(11888)] = 696296,
  [SMALL_STATE(11889)] = 696304,
  [SMALL_STATE(11890)] = 696312,
  [SMALL_STATE(11891)] = 696320,
  [SMALL_STATE(11892)] = 696328,
  [SMALL_STATE(11893)] = 696336,
  [SMALL_STATE(11894)] = 696344,
  [SMALL_STATE(11895)] = 696352,
  [SMALL_STATE(11896)] = 696360,
  [SMALL_STATE(11897)] = 696368,
  [SMALL_STATE(11898)] = 696376,
  [SMALL_STATE(11899)] = 696384,
  [SMALL_STATE(11900)] = 696392,
  [SMALL_STATE(11901)] = 696400,
  [SMALL_STATE(11902)] = 696408,
  [SMALL_STATE(11903)] = 696416,
  [SMALL_STATE(11904)] = 696424,
  [SMALL_STATE(11905)] = 696432,
  [SMALL_STATE(11906)] = 696440,
  [SMALL_STATE(11907)] = 696448,
  [SMALL_STATE(11908)] = 696456,
  [SMALL_STATE(11909)] = 696464,
  [SMALL_STATE(11910)] = 696472,
  [SMALL_STATE(11911)] = 696480,
  [SMALL_STATE(11912)] = 696488,
  [SMALL_STATE(11913)] = 696496,
  [SMALL_STATE(11914)] = 696504,
  [SMALL_STATE(11915)] = 696512,
  [SMALL_STATE(11916)] = 696520,
  [SMALL_STATE(11917)] = 696528,
  [SMALL_STATE(11918)] = 696536,
  [SMALL_STATE(11919)] = 696544,
  [SMALL_STATE(11920)] = 696552,
  [SMALL_STATE(11921)] = 696560,
  [SMALL_STATE(11922)] = 696568,
  [SMALL_STATE(11923)] = 696576,
  [SMALL_STATE(11924)] = 696584,
  [SMALL_STATE(11925)] = 696592,
  [SMALL_STATE(11926)] = 696600,
  [SMALL_STATE(11927)] = 696608,
  [SMALL_STATE(11928)] = 696616,
  [SMALL_STATE(11929)] = 696624,
  [SMALL_STATE(11930)] = 696632,
  [SMALL_STATE(11931)] = 696640,
  [SMALL_STATE(11932)] = 696648,
  [SMALL_STATE(11933)] = 696656,
  [SMALL_STATE(11934)] = 696664,
  [SMALL_STATE(11935)] = 696672,
  [SMALL_STATE(11936)] = 696680,
  [SMALL_STATE(11937)] = 696688,
  [SMALL_STATE(11938)] = 696696,
  [SMALL_STATE(11939)] = 696704,
  [SMALL_STATE(11940)] = 696712,
  [SMALL_STATE(11941)] = 696720,
  [SMALL_STATE(11942)] = 696728,
  [SMALL_STATE(11943)] = 696736,
  [SMALL_STATE(11944)] = 696744,
  [SMALL_STATE(11945)] = 696752,
  [SMALL_STATE(11946)] = 696760,
  [SMALL_STATE(11947)] = 696768,
  [SMALL_STATE(11948)] = 696776,
  [SMALL_STATE(11949)] = 696784,
  [SMALL_STATE(11950)] = 696792,
  [SMALL_STATE(11951)] = 696800,
  [SMALL_STATE(11952)] = 696808,
  [SMALL_STATE(11953)] = 696816,
  [SMALL_STATE(11954)] = 696824,
  [SMALL_STATE(11955)] = 696832,
  [SMALL_STATE(11956)] = 696840,
  [SMALL_STATE(11957)] = 696848,
  [SMALL_STATE(11958)] = 696856,
  [SMALL_STATE(11959)] = 696864,
  [SMALL_STATE(11960)] = 696872,
  [SMALL_STATE(11961)] = 696880,
  [SMALL_STATE(11962)] = 696888,
  [SMALL_STATE(11963)] = 696896,
  [SMALL_STATE(11964)] = 696904,
  [SMALL_STATE(11965)] = 696912,
  [SMALL_STATE(11966)] = 696920,
  [SMALL_STATE(11967)] = 696928,
  [SMALL_STATE(11968)] = 696936,
  [SMALL_STATE(11969)] = 696944,
  [SMALL_STATE(11970)] = 696952,
  [SMALL_STATE(11971)] = 696960,
  [SMALL_STATE(11972)] = 696968,
  [SMALL_STATE(11973)] = 696976,
  [SMALL_STATE(11974)] = 696984,
  [SMALL_STATE(11975)] = 696992,
  [SMALL_STATE(11976)] = 697000,
  [SMALL_STATE(11977)] = 697008,
  [SMALL_STATE(11978)] = 697016,
  [SMALL_STATE(11979)] = 697024,
  [SMALL_STATE(11980)] = 697032,
  [SMALL_STATE(11981)] = 697040,
  [SMALL_STATE(11982)] = 697048,
  [SMALL_STATE(11983)] = 697056,
  [SMALL_STATE(11984)] = 697064,
  [SMALL_STATE(11985)] = 697072,
  [SMALL_STATE(11986)] = 697080,
  [SMALL_STATE(11987)] = 697088,
  [SMALL_STATE(11988)] = 697096,
  [SMALL_STATE(11989)] = 697104,
  [SMALL_STATE(11990)] = 697112,
  [SMALL_STATE(11991)] = 697120,
  [SMALL_STATE(11992)] = 697128,
  [SMALL_STATE(11993)] = 697136,
  [SMALL_STATE(11994)] = 697144,
  [SMALL_STATE(11995)] = 697152,
  [SMALL_STATE(11996)] = 697160,
  [SMALL_STATE(11997)] = 697168,
  [SMALL_STATE(11998)] = 697176,
  [SMALL_STATE(11999)] = 697184,
  [SMALL_STATE(12000)] = 697192,
  [SMALL_STATE(12001)] = 697200,
  [SMALL_STATE(12002)] = 697208,
  [SMALL_STATE(12003)] = 697216,
  [SMALL_STATE(12004)] = 697224,
  [SMALL_STATE(12005)] = 697232,
  [SMALL_STATE(12006)] = 697240,
  [SMALL_STATE(12007)] = 697248,
  [SMALL_STATE(12008)] = 697256,
  [SMALL_STATE(12009)] = 697264,
  [SMALL_STATE(12010)] = 697272,
  [SMALL_STATE(12011)] = 697280,
  [SMALL_STATE(12012)] = 697288,
  [SMALL_STATE(12013)] = 697296,
  [SMALL_STATE(12014)] = 697304,
  [SMALL_STATE(12015)] = 697312,
  [SMALL_STATE(12016)] = 697320,
  [SMALL_STATE(12017)] = 697328,
  [SMALL_STATE(12018)] = 697336,
  [SMALL_STATE(12019)] = 697344,
  [SMALL_STATE(12020)] = 697352,
  [SMALL_STATE(12021)] = 697360,
  [SMALL_STATE(12022)] = 697368,
  [SMALL_STATE(12023)] = 697376,
  [SMALL_STATE(12024)] = 697384,
  [SMALL_STATE(12025)] = 697392,
  [SMALL_STATE(12026)] = 697400,
  [SMALL_STATE(12027)] = 697408,
  [SMALL_STATE(12028)] = 697416,
  [SMALL_STATE(12029)] = 697424,
  [SMALL_STATE(12030)] = 697432,
  [SMALL_STATE(12031)] = 697440,
  [SMALL_STATE(12032)] = 697448,
  [SMALL_STATE(12033)] = 697456,
  [SMALL_STATE(12034)] = 697464,
  [SMALL_STATE(12035)] = 697472,
  [SMALL_STATE(12036)] = 697480,
  [SMALL_STATE(12037)] = 697488,
  [SMALL_STATE(12038)] = 697496,
  [SMALL_STATE(12039)] = 697504,
  [SMALL_STATE(12040)] = 697512,
  [SMALL_STATE(12041)] = 697520,
  [SMALL_STATE(12042)] = 697528,
  [SMALL_STATE(12043)] = 697536,
  [SMALL_STATE(12044)] = 697544,
  [SMALL_STATE(12045)] = 697552,
  [SMALL_STATE(12046)] = 697560,
  [SMALL_STATE(12047)] = 697568,
  [SMALL_STATE(12048)] = 697576,
  [SMALL_STATE(12049)] = 697584,
  [SMALL_STATE(12050)] = 697592,
  [SMALL_STATE(12051)] = 697600,
  [SMALL_STATE(12052)] = 697608,
  [SMALL_STATE(12053)] = 697616,
  [SMALL_STATE(12054)] = 697624,
  [SMALL_STATE(12055)] = 697632,
  [SMALL_STATE(12056)] = 697640,
  [SMALL_STATE(12057)] = 697648,
  [SMALL_STATE(12058)] = 697656,
  [SMALL_STATE(12059)] = 697664,
  [SMALL_STATE(12060)] = 697672,
  [SMALL_STATE(12061)] = 697680,
  [SMALL_STATE(12062)] = 697688,
  [SMALL_STATE(12063)] = 697696,
  [SMALL_STATE(12064)] = 697704,
  [SMALL_STATE(12065)] = 697712,
  [SMALL_STATE(12066)] = 697720,
  [SMALL_STATE(12067)] = 697728,
  [SMALL_STATE(12068)] = 697736,
  [SMALL_STATE(12069)] = 697744,
  [SMALL_STATE(12070)] = 697752,
  [SMALL_STATE(12071)] = 697760,
  [SMALL_STATE(12072)] = 697768,
  [SMALL_STATE(12073)] = 697776,
  [SMALL_STATE(12074)] = 697784,
  [SMALL_STATE(12075)] = 697792,
  [SMALL_STATE(12076)] = 697800,
  [SMALL_STATE(12077)] = 697808,
  [SMALL_STATE(12078)] = 697816,
  [SMALL_STATE(12079)] = 697824,
  [SMALL_STATE(12080)] = 697832,
  [SMALL_STATE(12081)] = 697840,
  [SMALL_STATE(12082)] = 697848,
  [SMALL_STATE(12083)] = 697856,
  [SMALL_STATE(12084)] = 697864,
  [SMALL_STATE(12085)] = 697872,
  [SMALL_STATE(12086)] = 697880,
  [SMALL_STATE(12087)] = 697888,
  [SMALL_STATE(12088)] = 697896,
  [SMALL_STATE(12089)] = 697904,
  [SMALL_STATE(12090)] = 697912,
  [SMALL_STATE(12091)] = 697920,
  [SMALL_STATE(12092)] = 697928,
  [SMALL_STATE(12093)] = 697936,
  [SMALL_STATE(12094)] = 697944,
  [SMALL_STATE(12095)] = 697952,
  [SMALL_STATE(12096)] = 697960,
  [SMALL_STATE(12097)] = 697968,
  [SMALL_STATE(12098)] = 697976,
  [SMALL_STATE(12099)] = 697984,
  [SMALL_STATE(12100)] = 697992,
  [SMALL_STATE(12101)] = 698000,
  [SMALL_STATE(12102)] = 698008,
  [SMALL_STATE(12103)] = 698016,
  [SMALL_STATE(12104)] = 698024,
  [SMALL_STATE(12105)] = 698032,
  [SMALL_STATE(12106)] = 698040,
  [SMALL_STATE(12107)] = 698048,
  [SMALL_STATE(12108)] = 698056,
  [SMALL_STATE(12109)] = 698064,
  [SMALL_STATE(12110)] = 698072,
  [SMALL_STATE(12111)] = 698080,
  [SMALL_STATE(12112)] = 698088,
  [SMALL_STATE(12113)] = 698096,
  [SMALL_STATE(12114)] = 698104,
  [SMALL_STATE(12115)] = 698112,
  [SMALL_STATE(12116)] = 698120,
  [SMALL_STATE(12117)] = 698128,
  [SMALL_STATE(12118)] = 698136,
  [SMALL_STATE(12119)] = 698144,
  [SMALL_STATE(12120)] = 698152,
  [SMALL_STATE(12121)] = 698160,
  [SMALL_STATE(12122)] = 698168,
  [SMALL_STATE(12123)] = 698176,
  [SMALL_STATE(12124)] = 698184,
  [SMALL_STATE(12125)] = 698192,
  [SMALL_STATE(12126)] = 698200,
  [SMALL_STATE(12127)] = 698208,
  [SMALL_STATE(12128)] = 698216,
  [SMALL_STATE(12129)] = 698224,
  [SMALL_STATE(12130)] = 698232,
  [SMALL_STATE(12131)] = 698240,
  [SMALL_STATE(12132)] = 698248,
  [SMALL_STATE(12133)] = 698256,
  [SMALL_STATE(12134)] = 698264,
  [SMALL_STATE(12135)] = 698272,
  [SMALL_STATE(12136)] = 698280,
  [SMALL_STATE(12137)] = 698288,
  [SMALL_STATE(12138)] = 698296,
  [SMALL_STATE(12139)] = 698304,
  [SMALL_STATE(12140)] = 698312,
  [SMALL_STATE(12141)] = 698320,
  [SMALL_STATE(12142)] = 698328,
  [SMALL_STATE(12143)] = 698336,
  [SMALL_STATE(12144)] = 698344,
  [SMALL_STATE(12145)] = 698352,
  [SMALL_STATE(12146)] = 698360,
  [SMALL_STATE(12147)] = 698370,
  [SMALL_STATE(12148)] = 698378,
  [SMALL_STATE(12149)] = 698386,
  [SMALL_STATE(12150)] = 698394,
  [SMALL_STATE(12151)] = 698402,
  [SMALL_STATE(12152)] = 698410,
  [SMALL_STATE(12153)] = 698418,
  [SMALL_STATE(12154)] = 698426,
  [SMALL_STATE(12155)] = 698434,
  [SMALL_STATE(12156)] = 698442,
  [SMALL_STATE(12157)] = 698450,
  [SMALL_STATE(12158)] = 698458,
  [SMALL_STATE(12159)] = 698466,
  [SMALL_STATE(12160)] = 698474,
  [SMALL_STATE(12161)] = 698482,
  [SMALL_STATE(12162)] = 698490,
  [SMALL_STATE(12163)] = 698498,
  [SMALL_STATE(12164)] = 698506,
  [SMALL_STATE(12165)] = 698514,
  [SMALL_STATE(12166)] = 698522,
  [SMALL_STATE(12167)] = 698530,
  [SMALL_STATE(12168)] = 698538,
  [SMALL_STATE(12169)] = 698546,
  [SMALL_STATE(12170)] = 698554,
  [SMALL_STATE(12171)] = 698562,
  [SMALL_STATE(12172)] = 698572,
  [SMALL_STATE(12173)] = 698580,
  [SMALL_STATE(12174)] = 698588,
  [SMALL_STATE(12175)] = 698598,
  [SMALL_STATE(12176)] = 698606,
  [SMALL_STATE(12177)] = 698614,
  [SMALL_STATE(12178)] = 698622,
  [SMALL_STATE(12179)] = 698630,
  [SMALL_STATE(12180)] = 698638,
  [SMALL_STATE(12181)] = 698646,
  [SMALL_STATE(12182)] = 698654,
  [SMALL_STATE(12183)] = 698662,
  [SMALL_STATE(12184)] = 698670,
  [SMALL_STATE(12185)] = 698680,
  [SMALL_STATE(12186)] = 698688,
  [SMALL_STATE(12187)] = 698696,
  [SMALL_STATE(12188)] = 698704,
  [SMALL_STATE(12189)] = 698712,
  [SMALL_STATE(12190)] = 698720,
  [SMALL_STATE(12191)] = 698728,
  [SMALL_STATE(12192)] = 698736,
  [SMALL_STATE(12193)] = 698744,
  [SMALL_STATE(12194)] = 698752,
  [SMALL_STATE(12195)] = 698760,
  [SMALL_STATE(12196)] = 698768,
  [SMALL_STATE(12197)] = 698776,
  [SMALL_STATE(12198)] = 698784,
  [SMALL_STATE(12199)] = 698792,
  [SMALL_STATE(12200)] = 698800,
  [SMALL_STATE(12201)] = 698808,
  [SMALL_STATE(12202)] = 698816,
  [SMALL_STATE(12203)] = 698824,
  [SMALL_STATE(12204)] = 698832,
  [SMALL_STATE(12205)] = 698840,
  [SMALL_STATE(12206)] = 698848,
  [SMALL_STATE(12207)] = 698856,
  [SMALL_STATE(12208)] = 698864,
  [SMALL_STATE(12209)] = 698872,
  [SMALL_STATE(12210)] = 698880,
  [SMALL_STATE(12211)] = 698888,
  [SMALL_STATE(12212)] = 698896,
  [SMALL_STATE(12213)] = 698904,
  [SMALL_STATE(12214)] = 698912,
  [SMALL_STATE(12215)] = 698920,
  [SMALL_STATE(12216)] = 698928,
  [SMALL_STATE(12217)] = 698936,
  [SMALL_STATE(12218)] = 698944,
  [SMALL_STATE(12219)] = 698952,
  [SMALL_STATE(12220)] = 698960,
  [SMALL_STATE(12221)] = 698968,
  [SMALL_STATE(12222)] = 698976,
  [SMALL_STATE(12223)] = 698984,
  [SMALL_STATE(12224)] = 698992,
  [SMALL_STATE(12225)] = 699000,
  [SMALL_STATE(12226)] = 699008,
  [SMALL_STATE(12227)] = 699016,
  [SMALL_STATE(12228)] = 699024,
  [SMALL_STATE(12229)] = 699032,
  [SMALL_STATE(12230)] = 699040,
  [SMALL_STATE(12231)] = 699048,
  [SMALL_STATE(12232)] = 699056,
  [SMALL_STATE(12233)] = 699064,
  [SMALL_STATE(12234)] = 699072,
  [SMALL_STATE(12235)] = 699080,
  [SMALL_STATE(12236)] = 699088,
  [SMALL_STATE(12237)] = 699096,
  [SMALL_STATE(12238)] = 699104,
  [SMALL_STATE(12239)] = 699112,
  [SMALL_STATE(12240)] = 699120,
  [SMALL_STATE(12241)] = 699128,
  [SMALL_STATE(12242)] = 699136,
  [SMALL_STATE(12243)] = 699144,
  [SMALL_STATE(12244)] = 699154,
  [SMALL_STATE(12245)] = 699162,
  [SMALL_STATE(12246)] = 699170,
  [SMALL_STATE(12247)] = 699178,
  [SMALL_STATE(12248)] = 699186,
  [SMALL_STATE(12249)] = 699196,
  [SMALL_STATE(12250)] = 699204,
  [SMALL_STATE(12251)] = 699212,
  [SMALL_STATE(12252)] = 699220,
  [SMALL_STATE(12253)] = 699228,
  [SMALL_STATE(12254)] = 699236,
  [SMALL_STATE(12255)] = 699244,
  [SMALL_STATE(12256)] = 699252,
  [SMALL_STATE(12257)] = 699260,
  [SMALL_STATE(12258)] = 699268,
  [SMALL_STATE(12259)] = 699278,
  [SMALL_STATE(12260)] = 699286,
  [SMALL_STATE(12261)] = 699294,
  [SMALL_STATE(12262)] = 699302,
  [SMALL_STATE(12263)] = 699310,
  [SMALL_STATE(12264)] = 699320,
  [SMALL_STATE(12265)] = 699328,
  [SMALL_STATE(12266)] = 699336,
  [SMALL_STATE(12267)] = 699344,
  [SMALL_STATE(12268)] = 699352,
  [SMALL_STATE(12269)] = 699360,
  [SMALL_STATE(12270)] = 699368,
  [SMALL_STATE(12271)] = 699376,
  [SMALL_STATE(12272)] = 699384,
  [SMALL_STATE(12273)] = 699392,
  [SMALL_STATE(12274)] = 699400,
  [SMALL_STATE(12275)] = 699408,
  [SMALL_STATE(12276)] = 699416,
  [SMALL_STATE(12277)] = 699424,
  [SMALL_STATE(12278)] = 699432,
  [SMALL_STATE(12279)] = 699440,
  [SMALL_STATE(12280)] = 699448,
  [SMALL_STATE(12281)] = 699456,
  [SMALL_STATE(12282)] = 699464,
  [SMALL_STATE(12283)] = 699472,
  [SMALL_STATE(12284)] = 699480,
  [SMALL_STATE(12285)] = 699488,
  [SMALL_STATE(12286)] = 699496,
  [SMALL_STATE(12287)] = 699504,
  [SMALL_STATE(12288)] = 699512,
  [SMALL_STATE(12289)] = 699520,
  [SMALL_STATE(12290)] = 699528,
  [SMALL_STATE(12291)] = 699536,
  [SMALL_STATE(12292)] = 699544,
  [SMALL_STATE(12293)] = 699552,
  [SMALL_STATE(12294)] = 699560,
  [SMALL_STATE(12295)] = 699568,
  [SMALL_STATE(12296)] = 699576,
  [SMALL_STATE(12297)] = 699584,
  [SMALL_STATE(12298)] = 699592,
  [SMALL_STATE(12299)] = 699600,
  [SMALL_STATE(12300)] = 699608,
  [SMALL_STATE(12301)] = 699616,
  [SMALL_STATE(12302)] = 699624,
  [SMALL_STATE(12303)] = 699632,
  [SMALL_STATE(12304)] = 699640,
  [SMALL_STATE(12305)] = 699648,
  [SMALL_STATE(12306)] = 699656,
  [SMALL_STATE(12307)] = 699664,
  [SMALL_STATE(12308)] = 699672,
  [SMALL_STATE(12309)] = 699680,
  [SMALL_STATE(12310)] = 699688,
  [SMALL_STATE(12311)] = 699696,
  [SMALL_STATE(12312)] = 699704,
  [SMALL_STATE(12313)] = 699712,
  [SMALL_STATE(12314)] = 699720,
  [SMALL_STATE(12315)] = 699728,
  [SMALL_STATE(12316)] = 699736,
  [SMALL_STATE(12317)] = 699744,
  [SMALL_STATE(12318)] = 699752,
  [SMALL_STATE(12319)] = 699760,
  [SMALL_STATE(12320)] = 699768,
  [SMALL_STATE(12321)] = 699776,
  [SMALL_STATE(12322)] = 699784,
  [SMALL_STATE(12323)] = 699792,
  [SMALL_STATE(12324)] = 699800,
  [SMALL_STATE(12325)] = 699808,
  [SMALL_STATE(12326)] = 699816,
  [SMALL_STATE(12327)] = 699824,
  [SMALL_STATE(12328)] = 699832,
  [SMALL_STATE(12329)] = 699840,
  [SMALL_STATE(12330)] = 699848,
  [SMALL_STATE(12331)] = 699856,
  [SMALL_STATE(12332)] = 699864,
  [SMALL_STATE(12333)] = 699874,
  [SMALL_STATE(12334)] = 699882,
  [SMALL_STATE(12335)] = 699892,
  [SMALL_STATE(12336)] = 699900,
  [SMALL_STATE(12337)] = 699908,
  [SMALL_STATE(12338)] = 699916,
  [SMALL_STATE(12339)] = 699924,
  [SMALL_STATE(12340)] = 699932,
  [SMALL_STATE(12341)] = 699940,
  [SMALL_STATE(12342)] = 699948,
  [SMALL_STATE(12343)] = 699956,
  [SMALL_STATE(12344)] = 699964,
  [SMALL_STATE(12345)] = 699972,
  [SMALL_STATE(12346)] = 699980,
  [SMALL_STATE(12347)] = 699988,
  [SMALL_STATE(12348)] = 699996,
  [SMALL_STATE(12349)] = 700004,
  [SMALL_STATE(12350)] = 700012,
  [SMALL_STATE(12351)] = 700020,
  [SMALL_STATE(12352)] = 700028,
  [SMALL_STATE(12353)] = 700036,
  [SMALL_STATE(12354)] = 700044,
  [SMALL_STATE(12355)] = 700052,
  [SMALL_STATE(12356)] = 700060,
  [SMALL_STATE(12357)] = 700068,
  [SMALL_STATE(12358)] = 700076,
  [SMALL_STATE(12359)] = 700084,
  [SMALL_STATE(12360)] = 700092,
  [SMALL_STATE(12361)] = 700100,
  [SMALL_STATE(12362)] = 700108,
  [SMALL_STATE(12363)] = 700116,
  [SMALL_STATE(12364)] = 700124,
  [SMALL_STATE(12365)] = 700132,
  [SMALL_STATE(12366)] = 700140,
  [SMALL_STATE(12367)] = 700148,
  [SMALL_STATE(12368)] = 700156,
  [SMALL_STATE(12369)] = 700164,
  [SMALL_STATE(12370)] = 700172,
  [SMALL_STATE(12371)] = 700180,
  [SMALL_STATE(12372)] = 700188,
  [SMALL_STATE(12373)] = 700196,
  [SMALL_STATE(12374)] = 700204,
  [SMALL_STATE(12375)] = 700212,
  [SMALL_STATE(12376)] = 700220,
  [SMALL_STATE(12377)] = 700228,
  [SMALL_STATE(12378)] = 700236,
  [SMALL_STATE(12379)] = 700244,
  [SMALL_STATE(12380)] = 700252,
  [SMALL_STATE(12381)] = 700260,
  [SMALL_STATE(12382)] = 700268,
  [SMALL_STATE(12383)] = 700276,
  [SMALL_STATE(12384)] = 700284,
  [SMALL_STATE(12385)] = 700292,
  [SMALL_STATE(12386)] = 700300,
  [SMALL_STATE(12387)] = 700308,
  [SMALL_STATE(12388)] = 700316,
  [SMALL_STATE(12389)] = 700324,
  [SMALL_STATE(12390)] = 700334,
  [SMALL_STATE(12391)] = 700342,
  [SMALL_STATE(12392)] = 700350,
  [SMALL_STATE(12393)] = 700358,
  [SMALL_STATE(12394)] = 700366,
  [SMALL_STATE(12395)] = 700374,
  [SMALL_STATE(12396)] = 700382,
  [SMALL_STATE(12397)] = 700390,
  [SMALL_STATE(12398)] = 700398,
  [SMALL_STATE(12399)] = 700406,
  [SMALL_STATE(12400)] = 700416,
  [SMALL_STATE(12401)] = 700424,
  [SMALL_STATE(12402)] = 700432,
  [SMALL_STATE(12403)] = 700440,
  [SMALL_STATE(12404)] = 700448,
  [SMALL_STATE(12405)] = 700456,
  [SMALL_STATE(12406)] = 700464,
  [SMALL_STATE(12407)] = 700472,
  [SMALL_STATE(12408)] = 700480,
  [SMALL_STATE(12409)] = 700490,
  [SMALL_STATE(12410)] = 700498,
  [SMALL_STATE(12411)] = 700506,
  [SMALL_STATE(12412)] = 700514,
  [SMALL_STATE(12413)] = 700522,
  [SMALL_STATE(12414)] = 700530,
  [SMALL_STATE(12415)] = 700538,
  [SMALL_STATE(12416)] = 700546,
  [SMALL_STATE(12417)] = 700554,
  [SMALL_STATE(12418)] = 700564,
  [SMALL_STATE(12419)] = 700572,
  [SMALL_STATE(12420)] = 700580,
  [SMALL_STATE(12421)] = 700588,
  [SMALL_STATE(12422)] = 700596,
  [SMALL_STATE(12423)] = 700604,
  [SMALL_STATE(12424)] = 700612,
  [SMALL_STATE(12425)] = 700620,
  [SMALL_STATE(12426)] = 700628,
  [SMALL_STATE(12427)] = 700638,
  [SMALL_STATE(12428)] = 700646,
  [SMALL_STATE(12429)] = 700654,
  [SMALL_STATE(12430)] = 700662,
  [SMALL_STATE(12431)] = 700670,
  [SMALL_STATE(12432)] = 700678,
  [SMALL_STATE(12433)] = 700686,
  [SMALL_STATE(12434)] = 700694,
  [SMALL_STATE(12435)] = 700702,
  [SMALL_STATE(12436)] = 700712,
  [SMALL_STATE(12437)] = 700720,
  [SMALL_STATE(12438)] = 700728,
  [SMALL_STATE(12439)] = 700736,
  [SMALL_STATE(12440)] = 700744,
  [SMALL_STATE(12441)] = 700752,
  [SMALL_STATE(12442)] = 700760,
  [SMALL_STATE(12443)] = 700768,
  [SMALL_STATE(12444)] = 700776,
  [SMALL_STATE(12445)] = 700786,
  [SMALL_STATE(12446)] = 700794,
  [SMALL_STATE(12447)] = 700802,
  [SMALL_STATE(12448)] = 700810,
  [SMALL_STATE(12449)] = 700818,
  [SMALL_STATE(12450)] = 700826,
  [SMALL_STATE(12451)] = 700834,
  [SMALL_STATE(12452)] = 700842,
  [SMALL_STATE(12453)] = 700850,
  [SMALL_STATE(12454)] = 700860,
  [SMALL_STATE(12455)] = 700868,
  [SMALL_STATE(12456)] = 700876,
  [SMALL_STATE(12457)] = 700884,
  [SMALL_STATE(12458)] = 700892,
  [SMALL_STATE(12459)] = 700900,
  [SMALL_STATE(12460)] = 700908,
  [SMALL_STATE(12461)] = 700916,
  [SMALL_STATE(12462)] = 700924,
  [SMALL_STATE(12463)] = 700934,
  [SMALL_STATE(12464)] = 700942,
  [SMALL_STATE(12465)] = 700950,
  [SMALL_STATE(12466)] = 700958,
  [SMALL_STATE(12467)] = 700966,
  [SMALL_STATE(12468)] = 700974,
  [SMALL_STATE(12469)] = 700982,
  [SMALL_STATE(12470)] = 700990,
  [SMALL_STATE(12471)] = 700998,
  [SMALL_STATE(12472)] = 701008,
  [SMALL_STATE(12473)] = 701016,
  [SMALL_STATE(12474)] = 701024,
  [SMALL_STATE(12475)] = 701032,
  [SMALL_STATE(12476)] = 701040,
  [SMALL_STATE(12477)] = 701048,
  [SMALL_STATE(12478)] = 701056,
  [SMALL_STATE(12479)] = 701064,
  [SMALL_STATE(12480)] = 701072,
  [SMALL_STATE(12481)] = 701082,
  [SMALL_STATE(12482)] = 701090,
  [SMALL_STATE(12483)] = 701098,
  [SMALL_STATE(12484)] = 701106,
  [SMALL_STATE(12485)] = 701114,
  [SMALL_STATE(12486)] = 701122,
  [SMALL_STATE(12487)] = 701130,
  [SMALL_STATE(12488)] = 701138,
  [SMALL_STATE(12489)] = 701146,
  [SMALL_STATE(12490)] = 701156,
  [SMALL_STATE(12491)] = 701164,
  [SMALL_STATE(12492)] = 701172,
  [SMALL_STATE(12493)] = 701180,
  [SMALL_STATE(12494)] = 701188,
  [SMALL_STATE(12495)] = 701196,
  [SMALL_STATE(12496)] = 701204,
  [SMALL_STATE(12497)] = 701212,
  [SMALL_STATE(12498)] = 701220,
  [SMALL_STATE(12499)] = 701230,
  [SMALL_STATE(12500)] = 701238,
  [SMALL_STATE(12501)] = 701246,
  [SMALL_STATE(12502)] = 701254,
  [SMALL_STATE(12503)] = 701262,
  [SMALL_STATE(12504)] = 701270,
  [SMALL_STATE(12505)] = 701278,
  [SMALL_STATE(12506)] = 701286,
  [SMALL_STATE(12507)] = 701294,
  [SMALL_STATE(12508)] = 701304,
  [SMALL_STATE(12509)] = 701312,
  [SMALL_STATE(12510)] = 701320,
  [SMALL_STATE(12511)] = 701328,
  [SMALL_STATE(12512)] = 701336,
  [SMALL_STATE(12513)] = 701344,
  [SMALL_STATE(12514)] = 701352,
  [SMALL_STATE(12515)] = 701360,
  [SMALL_STATE(12516)] = 701368,
  [SMALL_STATE(12517)] = 701378,
  [SMALL_STATE(12518)] = 701386,
  [SMALL_STATE(12519)] = 701394,
  [SMALL_STATE(12520)] = 701402,
  [SMALL_STATE(12521)] = 701410,
  [SMALL_STATE(12522)] = 701418,
  [SMALL_STATE(12523)] = 701426,
  [SMALL_STATE(12524)] = 701434,
  [SMALL_STATE(12525)] = 701442,
  [SMALL_STATE(12526)] = 701452,
  [SMALL_STATE(12527)] = 701460,
  [SMALL_STATE(12528)] = 701468,
  [SMALL_STATE(12529)] = 701476,
  [SMALL_STATE(12530)] = 701484,
  [SMALL_STATE(12531)] = 701492,
  [SMALL_STATE(12532)] = 701500,
  [SMALL_STATE(12533)] = 701508,
  [SMALL_STATE(12534)] = 701516,
  [SMALL_STATE(12535)] = 701526,
  [SMALL_STATE(12536)] = 701534,
  [SMALL_STATE(12537)] = 701542,
  [SMALL_STATE(12538)] = 701550,
  [SMALL_STATE(12539)] = 701558,
  [SMALL_STATE(12540)] = 701566,
  [SMALL_STATE(12541)] = 701574,
  [SMALL_STATE(12542)] = 701582,
  [SMALL_STATE(12543)] = 701590,
  [SMALL_STATE(12544)] = 701600,
  [SMALL_STATE(12545)] = 701608,
  [SMALL_STATE(12546)] = 701616,
  [SMALL_STATE(12547)] = 701624,
  [SMALL_STATE(12548)] = 701632,
  [SMALL_STATE(12549)] = 701640,
  [SMALL_STATE(12550)] = 701648,
  [SMALL_STATE(12551)] = 701656,
  [SMALL_STATE(12552)] = 701664,
  [SMALL_STATE(12553)] = 701674,
  [SMALL_STATE(12554)] = 701682,
  [SMALL_STATE(12555)] = 701690,
  [SMALL_STATE(12556)] = 701698,
  [SMALL_STATE(12557)] = 701706,
  [SMALL_STATE(12558)] = 701714,
  [SMALL_STATE(12559)] = 701722,
  [SMALL_STATE(12560)] = 701730,
  [SMALL_STATE(12561)] = 701738,
  [SMALL_STATE(12562)] = 701748,
  [SMALL_STATE(12563)] = 701756,
  [SMALL_STATE(12564)] = 701764,
  [SMALL_STATE(12565)] = 701772,
  [SMALL_STATE(12566)] = 701780,
  [SMALL_STATE(12567)] = 701788,
  [SMALL_STATE(12568)] = 701796,
  [SMALL_STATE(12569)] = 701804,
  [SMALL_STATE(12570)] = 701812,
  [SMALL_STATE(12571)] = 701822,
  [SMALL_STATE(12572)] = 701830,
  [SMALL_STATE(12573)] = 701838,
  [SMALL_STATE(12574)] = 701846,
  [SMALL_STATE(12575)] = 701854,
  [SMALL_STATE(12576)] = 701862,
  [SMALL_STATE(12577)] = 701870,
  [SMALL_STATE(12578)] = 701878,
  [SMALL_STATE(12579)] = 701886,
  [SMALL_STATE(12580)] = 701896,
  [SMALL_STATE(12581)] = 701904,
  [SMALL_STATE(12582)] = 701912,
  [SMALL_STATE(12583)] = 701920,
  [SMALL_STATE(12584)] = 701928,
  [SMALL_STATE(12585)] = 701936,
  [SMALL_STATE(12586)] = 701944,
  [SMALL_STATE(12587)] = 701952,
  [SMALL_STATE(12588)] = 701960,
  [SMALL_STATE(12589)] = 701970,
  [SMALL_STATE(12590)] = 701978,
  [SMALL_STATE(12591)] = 701986,
  [SMALL_STATE(12592)] = 701994,
  [SMALL_STATE(12593)] = 702002,
  [SMALL_STATE(12594)] = 702010,
  [SMALL_STATE(12595)] = 702020,
  [SMALL_STATE(12596)] = 702028,
  [SMALL_STATE(12597)] = 702036,
  [SMALL_STATE(12598)] = 702044,
  [SMALL_STATE(12599)] = 702052,
  [SMALL_STATE(12600)] = 702060,
  [SMALL_STATE(12601)] = 702070,
  [SMALL_STATE(12602)] = 702078,
  [SMALL_STATE(12603)] = 702086,
  [SMALL_STATE(12604)] = 702094,
  [SMALL_STATE(12605)] = 702102,
  [SMALL_STATE(12606)] = 702110,
  [SMALL_STATE(12607)] = 702120,
  [SMALL_STATE(12608)] = 702128,
  [SMALL_STATE(12609)] = 702136,
  [SMALL_STATE(12610)] = 702144,
  [SMALL_STATE(12611)] = 702152,
  [SMALL_STATE(12612)] = 702160,
  [SMALL_STATE(12613)] = 702170,
  [SMALL_STATE(12614)] = 702178,
  [SMALL_STATE(12615)] = 702186,
  [SMALL_STATE(12616)] = 702194,
  [SMALL_STATE(12617)] = 702202,
  [SMALL_STATE(12618)] = 702210,
  [SMALL_STATE(12619)] = 702220,
  [SMALL_STATE(12620)] = 702228,
  [SMALL_STATE(12621)] = 702236,
  [SMALL_STATE(12622)] = 702244,
  [SMALL_STATE(12623)] = 702252,
  [SMALL_STATE(12624)] = 702260,
  [SMALL_STATE(12625)] = 702270,
  [SMALL_STATE(12626)] = 702278,
  [SMALL_STATE(12627)] = 702286,
  [SMALL_STATE(12628)] = 702294,
  [SMALL_STATE(12629)] = 702302,
  [SMALL_STATE(12630)] = 702310,
  [SMALL_STATE(12631)] = 702320,
  [SMALL_STATE(12632)] = 702328,
  [SMALL_STATE(12633)] = 702336,
  [SMALL_STATE(12634)] = 702344,
  [SMALL_STATE(12635)] = 702352,
  [SMALL_STATE(12636)] = 702360,
  [SMALL_STATE(12637)] = 702370,
  [SMALL_STATE(12638)] = 702378,
  [SMALL_STATE(12639)] = 702386,
  [SMALL_STATE(12640)] = 702394,
  [SMALL_STATE(12641)] = 702402,
  [SMALL_STATE(12642)] = 702410,
  [SMALL_STATE(12643)] = 702420,
  [SMALL_STATE(12644)] = 702428,
  [SMALL_STATE(12645)] = 702436,
  [SMALL_STATE(12646)] = 702444,
  [SMALL_STATE(12647)] = 702452,
  [SMALL_STATE(12648)] = 702460,
  [SMALL_STATE(12649)] = 702470,
  [SMALL_STATE(12650)] = 702478,
  [SMALL_STATE(12651)] = 702486,
  [SMALL_STATE(12652)] = 702494,
  [SMALL_STATE(12653)] = 702502,
  [SMALL_STATE(12654)] = 702510,
  [SMALL_STATE(12655)] = 702520,
  [SMALL_STATE(12656)] = 702528,
  [SMALL_STATE(12657)] = 702536,
  [SMALL_STATE(12658)] = 702544,
  [SMALL_STATE(12659)] = 702552,
  [SMALL_STATE(12660)] = 702560,
  [SMALL_STATE(12661)] = 702570,
  [SMALL_STATE(12662)] = 702578,
  [SMALL_STATE(12663)] = 702586,
  [SMALL_STATE(12664)] = 702594,
  [SMALL_STATE(12665)] = 702602,
  [SMALL_STATE(12666)] = 702610,
  [SMALL_STATE(12667)] = 702620,
  [SMALL_STATE(12668)] = 702628,
  [SMALL_STATE(12669)] = 702636,
  [SMALL_STATE(12670)] = 702644,
  [SMALL_STATE(12671)] = 702652,
  [SMALL_STATE(12672)] = 702660,
  [SMALL_STATE(12673)] = 702670,
  [SMALL_STATE(12674)] = 702678,
  [SMALL_STATE(12675)] = 702686,
  [SMALL_STATE(12676)] = 702694,
  [SMALL_STATE(12677)] = 702702,
  [SMALL_STATE(12678)] = 702710,
  [SMALL_STATE(12679)] = 702720,
  [SMALL_STATE(12680)] = 702728,
  [SMALL_STATE(12681)] = 702736,
  [SMALL_STATE(12682)] = 702744,
  [SMALL_STATE(12683)] = 702752,
  [SMALL_STATE(12684)] = 702760,
  [SMALL_STATE(12685)] = 702770,
  [SMALL_STATE(12686)] = 702778,
  [SMALL_STATE(12687)] = 702786,
  [SMALL_STATE(12688)] = 702794,
  [SMALL_STATE(12689)] = 702802,
  [SMALL_STATE(12690)] = 702810,
  [SMALL_STATE(12691)] = 702820,
  [SMALL_STATE(12692)] = 702828,
  [SMALL_STATE(12693)] = 702836,
  [SMALL_STATE(12694)] = 702844,
  [SMALL_STATE(12695)] = 702852,
  [SMALL_STATE(12696)] = 702860,
  [SMALL_STATE(12697)] = 702870,
  [SMALL_STATE(12698)] = 702878,
  [SMALL_STATE(12699)] = 702886,
  [SMALL_STATE(12700)] = 702894,
  [SMALL_STATE(12701)] = 702902,
  [SMALL_STATE(12702)] = 702910,
  [SMALL_STATE(12703)] = 702920,
  [SMALL_STATE(12704)] = 702928,
  [SMALL_STATE(12705)] = 702936,
  [SMALL_STATE(12706)] = 702944,
  [SMALL_STATE(12707)] = 702952,
  [SMALL_STATE(12708)] = 702960,
  [SMALL_STATE(12709)] = 702970,
  [SMALL_STATE(12710)] = 702978,
  [SMALL_STATE(12711)] = 702986,
  [SMALL_STATE(12712)] = 702994,
  [SMALL_STATE(12713)] = 703002,
  [SMALL_STATE(12714)] = 703010,
  [SMALL_STATE(12715)] = 703020,
  [SMALL_STATE(12716)] = 703028,
  [SMALL_STATE(12717)] = 703036,
  [SMALL_STATE(12718)] = 703044,
  [SMALL_STATE(12719)] = 703052,
  [SMALL_STATE(12720)] = 703060,
  [SMALL_STATE(12721)] = 703068,
  [SMALL_STATE(12722)] = 703076,
  [SMALL_STATE(12723)] = 703084,
  [SMALL_STATE(12724)] = 703092,
  [SMALL_STATE(12725)] = 703100,
  [SMALL_STATE(12726)] = 703108,
  [SMALL_STATE(12727)] = 703116,
  [SMALL_STATE(12728)] = 703124,
  [SMALL_STATE(12729)] = 703132,
  [SMALL_STATE(12730)] = 703140,
  [SMALL_STATE(12731)] = 703148,
  [SMALL_STATE(12732)] = 703156,
  [SMALL_STATE(12733)] = 703164,
  [SMALL_STATE(12734)] = 703172,
  [SMALL_STATE(12735)] = 703180,
  [SMALL_STATE(12736)] = 703188,
  [SMALL_STATE(12737)] = 703196,
  [SMALL_STATE(12738)] = 703204,
  [SMALL_STATE(12739)] = 703212,
  [SMALL_STATE(12740)] = 703220,
  [SMALL_STATE(12741)] = 703228,
  [SMALL_STATE(12742)] = 703236,
  [SMALL_STATE(12743)] = 703244,
  [SMALL_STATE(12744)] = 703252,
  [SMALL_STATE(12745)] = 703260,
  [SMALL_STATE(12746)] = 703268,
  [SMALL_STATE(12747)] = 703276,
  [SMALL_STATE(12748)] = 703284,
  [SMALL_STATE(12749)] = 703292,
  [SMALL_STATE(12750)] = 703300,
  [SMALL_STATE(12751)] = 703310,
  [SMALL_STATE(12752)] = 703318,
  [SMALL_STATE(12753)] = 703326,
  [SMALL_STATE(12754)] = 703334,
  [SMALL_STATE(12755)] = 703342,
  [SMALL_STATE(12756)] = 703350,
  [SMALL_STATE(12757)] = 703358,
  [SMALL_STATE(12758)] = 703366,
  [SMALL_STATE(12759)] = 703374,
  [SMALL_STATE(12760)] = 703382,
  [SMALL_STATE(12761)] = 703390,
  [SMALL_STATE(12762)] = 703398,
  [SMALL_STATE(12763)] = 703406,
  [SMALL_STATE(12764)] = 703414,
  [SMALL_STATE(12765)] = 703422,
  [SMALL_STATE(12766)] = 703430,
  [SMALL_STATE(12767)] = 703438,
  [SMALL_STATE(12768)] = 703446,
  [SMALL_STATE(12769)] = 703454,
  [SMALL_STATE(12770)] = 703462,
  [SMALL_STATE(12771)] = 703470,
  [SMALL_STATE(12772)] = 703478,
  [SMALL_STATE(12773)] = 703486,
  [SMALL_STATE(12774)] = 703494,
  [SMALL_STATE(12775)] = 703502,
  [SMALL_STATE(12776)] = 703510,
  [SMALL_STATE(12777)] = 703518,
  [SMALL_STATE(12778)] = 703526,
  [SMALL_STATE(12779)] = 703534,
  [SMALL_STATE(12780)] = 703542,
  [SMALL_STATE(12781)] = 703550,
  [SMALL_STATE(12782)] = 703558,
  [SMALL_STATE(12783)] = 703566,
  [SMALL_STATE(12784)] = 703574,
  [SMALL_STATE(12785)] = 703582,
  [SMALL_STATE(12786)] = 703590,
  [SMALL_STATE(12787)] = 703598,
  [SMALL_STATE(12788)] = 703606,
  [SMALL_STATE(12789)] = 703614,
  [SMALL_STATE(12790)] = 703622,
  [SMALL_STATE(12791)] = 703630,
  [SMALL_STATE(12792)] = 703638,
  [SMALL_STATE(12793)] = 703646,
  [SMALL_STATE(12794)] = 703654,
  [SMALL_STATE(12795)] = 703662,
  [SMALL_STATE(12796)] = 703670,
  [SMALL_STATE(12797)] = 703678,
  [SMALL_STATE(12798)] = 703686,
  [SMALL_STATE(12799)] = 703696,
  [SMALL_STATE(12800)] = 703704,
  [SMALL_STATE(12801)] = 703712,
  [SMALL_STATE(12802)] = 703720,
  [SMALL_STATE(12803)] = 703730,
  [SMALL_STATE(12804)] = 703740,
  [SMALL_STATE(12805)] = 703748,
  [SMALL_STATE(12806)] = 703756,
  [SMALL_STATE(12807)] = 703764,
  [SMALL_STATE(12808)] = 703772,
  [SMALL_STATE(12809)] = 703780,
  [SMALL_STATE(12810)] = 703788,
  [SMALL_STATE(12811)] = 703796,
  [SMALL_STATE(12812)] = 703804,
  [SMALL_STATE(12813)] = 703812,
  [SMALL_STATE(12814)] = 703820,
  [SMALL_STATE(12815)] = 703828,
  [SMALL_STATE(12816)] = 703836,
  [SMALL_STATE(12817)] = 703844,
};

static const TSParseActionEntry ts_parse_actions[] = {
  [0] = {.entry = {.count = 0, .reusable = false}},
  [1] = {.entry = {.count = 1, .reusable = false}}, RECOVER(),
  [3] = {.entry = {.count = 1, .reusable = true}}, SHIFT_EXTRA(),
  [5] = {.entry = {.count = 1, .reusable = false}}, SHIFT_EXTRA(),
  [7] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_source_file, 0),
  [9] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4363),
  [11] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8288),
  [13] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8114),
  [15] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8114),
  [17] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4608),
  [19] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10066),
  [21] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9420),
  [23] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9463),
  [25] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10220),
  [27] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10218),
  [29] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7112),
  [31] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10206),
  [33] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9438),
  [35] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9427),
  [37] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9488),
  [39] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9484),
  [41] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9482),
  [43] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9453),
  [45] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9468),
  [47] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9124),
  [49] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9442),
  [51] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1346),
  [53] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1338),
  [55] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1337),
  [57] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12794),
  [59] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12803),
  [61] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1298),
  [63] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12802),
  [65] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9667),
  [67] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10168),
  [69] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4606),
  [71] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6315),
  [73] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9031),
  [75] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12798),
  [77] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6310),
  [79] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1455),
  [81] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1456),
  [83] = {.entry = {.count = 1, .reusable = false}}, SHIFT(85),
  [85] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12797),
  [87] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4602),
  [89] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3912),
  [91] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9616),
  [93] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12263),
  [95] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12262),
  [97] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12260),
  [99] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11579),
  [101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10129),
  [103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10146),
  [105] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4202),
  [107] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8343),
  [109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8146),
  [111] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8146),
  [113] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4327),
  [115] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9416),
  [117] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10101),
  [119] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6984),
  [121] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9849),
  [123] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9088),
  [125] = {.entry = {.count = 1, .reusable = false}}, SHIFT(974),
  [127] = {.entry = {.count = 1, .reusable = false}}, SHIFT(991),
  [129] = {.entry = {.count = 1, .reusable = false}}, SHIFT(992),
  [131] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9671),
  [133] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12750),
  [135] = {.entry = {.count = 1, .reusable = false}}, SHIFT(900),
  [137] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12332),
  [139] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9578),
  [141] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10100),
  [143] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4413),
  [145] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6312),
  [147] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12435),
  [149] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6262),
  [151] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2581),
  [153] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2585),
  [155] = {.entry = {.count = 1, .reusable = false}}, SHIFT(109),
  [157] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4390),
  [159] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3894),
  [161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(158),
  [163] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9637),
  [165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(219),
  [167] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9689),
  [169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(181),
  [171] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9643),
  [173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(180),
  [175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10167),
  [177] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9492),
  [179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(256),
  [181] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9491),
  [183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(259),
  [185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(192),
  [187] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9661),
  [189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(185),
  [191] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9528),
  [193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(176),
  [195] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9622),
  [197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(174),
  [199] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9542),
  [201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(193),
  [203] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9612),
  [205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(168),
  [207] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9684),
  [209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(190),
  [211] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9683),
  [213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(197),
  [215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9987),
  [217] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_source_file, 1),
  [219] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9508),
  [221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(205),
  [223] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9532),
  [225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12082),
  [227] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9681),
  [229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(151),
  [231] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9575),
  [233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(214),
  [235] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9603),
  [237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(159),
  [239] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9609),
  [241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(207),
  [243] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9535),
  [245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(154),
  [247] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9562),
  [249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(134),
  [251] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9588),
  [253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(157),
  [255] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9639),
  [257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(212),
  [259] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9659),
  [261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(202),
  [263] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9526),
  [265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(226),
  [267] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9625),
  [269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(222),
  [271] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(4363),
  [274] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(8288),
  [277] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(8114),
  [280] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(8114),
  [283] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(4608),
  [286] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(10066),
  [289] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(9420),
  [292] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(9463),
  [295] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(10220),
  [298] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(10218),
  [301] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(7112),
  [304] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(10206),
  [307] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(9438),
  [310] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(9427),
  [313] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(9488),
  [316] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(9484),
  [319] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(9482),
  [322] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(9453),
  [325] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(9468),
  [328] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(9124),
  [331] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(9442),
  [334] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(1346),
  [337] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(1338),
  [340] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(1337),
  [343] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(11579),
  [346] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(12803),
  [349] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(1298),
  [352] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(12802),
  [355] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(9667),
  [358] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(10168),
  [361] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(4606),
  [364] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(6315),
  [367] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(9031),
  [370] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(12798),
  [373] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(6310),
  [376] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(1455),
  [379] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(1456),
  [382] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(85),
  [385] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(12797),
  [388] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(4602),
  [391] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(3912),
  [394] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2),
  [396] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9644),
  [398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(144),
  [400] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9567),
  [402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(119),
  [404] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(12794),
  [407] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9601),
  [409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(241),
  [411] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9551),
  [413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(182),
  [415] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9498),
  [417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(132),
  [419] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9510),
  [421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(141),
  [423] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9613),
  [425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(232),
  [427] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9580),
  [429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(127),
  [431] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9600),
  [433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(229),
  [435] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9517),
  [437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(171),
  [439] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9690),
  [441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(187),
  [443] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9574),
  [445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(243),
  [447] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9490),
  [449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(239),
  [451] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9577),
  [453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(237),
  [455] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9531),
  [457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(252),
  [459] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9566),
  [461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(245),
  [463] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9604),
  [465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(122),
  [467] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9554),
  [469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(242),
  [471] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9543),
  [473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(254),
  [475] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9664),
  [477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(129),
  [479] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9544),
  [481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(128),
  [483] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9519),
  [485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(250),
  [487] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9660),
  [489] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9669),
  [491] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9674),
  [493] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9568),
  [495] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9576),
  [497] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9592),
  [499] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9500),
  [501] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9494),
  [503] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9547),
  [505] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9539),
  [507] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9658),
  [509] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9628),
  [511] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9514),
  [513] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9513),
  [515] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9523),
  [517] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9502),
  [519] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9653),
  [521] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9682),
  [523] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9594),
  [525] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9636),
  [527] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9507),
  [529] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9529),
  [531] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9538),
  [533] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9503),
  [535] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9679),
  [537] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9640),
  [539] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9550),
  [541] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9501),
  [543] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9579),
  [545] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9672),
  [547] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9536),
  [549] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9606),
  [551] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9593),
  [553] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9524),
  [555] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9560),
  [557] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9565),
  [559] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(11515),
  [562] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9497),
  [564] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9595),
  [566] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9515),
  [568] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9642),
  [570] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9692),
  [572] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9610),
  [574] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9615),
  [576] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9512),
  [578] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9533),
  [580] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9584),
  [582] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9608),
  [584] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9691),
  [586] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9632),
  [588] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9549),
  [590] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9654),
  [592] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9534),
  [594] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9541),
  [596] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9676),
  [598] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9493),
  [600] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9675),
  [602] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9629),
  [604] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9656),
  [606] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9665),
  [608] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9694),
  [610] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9652),
  [612] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9573),
  [614] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9509),
  [616] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9611),
  [618] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9598),
  [620] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9516),
  [622] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9511),
  [624] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9688),
  [626] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9563),
  [628] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9591),
  [630] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9646),
  [632] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9586),
  [634] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9627),
  [636] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9520),
  [638] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9618),
  [640] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9638),
  [642] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9677),
  [644] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9602),
  [646] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9597),
  [648] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9614),
  [650] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9557),
  [652] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9657),
  [654] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9633),
  [656] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9582),
  [658] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9634),
  [660] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9556),
  [662] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9499),
  [664] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9552),
  [666] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9522),
  [668] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9663),
  [670] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9561),
  [672] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9525),
  [674] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9545),
  [676] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9496),
  [678] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9495),
  [680] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4829),
  [682] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8495),
  [684] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2460),
  [686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8064),
  [688] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8064),
  [690] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5056),
  [692] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6934),
  [694] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1003),
  [696] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1000),
  [698] = {.entry = {.count = 1, .reusable = false}}, SHIFT(999),
  [700] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12483),
  [702] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1092),
  [704] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8677),
  [706] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4902),
  [708] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6337),
  [710] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10672),
  [712] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9028),
  [714] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12507),
  [716] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6259),
  [718] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1755),
  [720] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1747),
  [722] = {.entry = {.count = 1, .reusable = false}}, SHIFT(84),
  [724] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12391),
  [726] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5020),
  [728] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3939),
  [730] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9176),
  [732] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8663),
  [734] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4791),
  [736] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8456),
  [738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8156),
  [740] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8156),
  [742] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5102),
  [744] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6863),
  [746] = {.entry = {.count = 1, .reusable = false}}, SHIFT(566),
  [748] = {.entry = {.count = 1, .reusable = false}}, SHIFT(515),
  [750] = {.entry = {.count = 1, .reusable = false}}, SHIFT(505),
  [752] = {.entry = {.count = 1, .reusable = false}}, SHIFT(498),
  [754] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5001),
  [756] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6334),
  [758] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9414),
  [760] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9030),
  [762] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12489),
  [764] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6194),
  [766] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1466),
  [768] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1485),
  [770] = {.entry = {.count = 1, .reusable = false}}, SHIFT(96),
  [772] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5085),
  [774] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3929),
  [776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8946),
  [778] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_do_repeat1, 2), SHIFT_REPEAT(4791),
  [781] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_do_repeat1, 2), SHIFT_REPEAT(8456),
  [784] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_do_repeat1, 2), SHIFT_REPEAT(8156),
  [787] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_do_repeat1, 2), SHIFT_REPEAT(8156),
  [790] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_do_repeat1, 2), SHIFT_REPEAT(5102),
  [793] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_do_repeat1, 2), SHIFT_REPEAT(6863),
  [796] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_do_repeat1, 2), SHIFT_REPEAT(566),
  [799] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_do_repeat1, 2), SHIFT_REPEAT(515),
  [802] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_do_repeat1, 2), SHIFT_REPEAT(505),
  [805] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_do_repeat1, 2), SHIFT_REPEAT(498),
  [808] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_do_repeat1, 2), SHIFT_REPEAT(5001),
  [811] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_do_repeat1, 2), SHIFT_REPEAT(6334),
  [814] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_do_repeat1, 2), SHIFT_REPEAT(9414),
  [817] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_do_repeat1, 2), SHIFT_REPEAT(9030),
  [820] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_do_repeat1, 2), SHIFT_REPEAT(12489),
  [823] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_do_repeat1, 2), SHIFT_REPEAT(6194),
  [826] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_do_repeat1, 2), SHIFT_REPEAT(1466),
  [829] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_do_repeat1, 2), SHIFT_REPEAT(1485),
  [832] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_do_repeat1, 2), SHIFT_REPEAT(96),
  [835] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_do_repeat1, 2), SHIFT_REPEAT(12797),
  [838] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_do_repeat1, 2), SHIFT_REPEAT(5085),
  [841] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_do_repeat1, 2), SHIFT_REPEAT(3929),
  [844] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_do_repeat1, 2),
  [846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8973),
  [848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9469),
  [850] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4754),
  [852] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8369),
  [854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8152),
  [856] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8152),
  [858] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5168),
  [860] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7056),
  [862] = {.entry = {.count = 1, .reusable = false}}, SHIFT(328),
  [864] = {.entry = {.count = 1, .reusable = false}}, SHIFT(324),
  [866] = {.entry = {.count = 1, .reusable = false}}, SHIFT(322),
  [868] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4043),
  [870] = {.entry = {.count = 1, .reusable = false}}, SHIFT(350),
  [872] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5116),
  [874] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6366),
  [876] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12548),
  [878] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12462),
  [880] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6286),
  [882] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2055),
  [884] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2054),
  [886] = {.entry = {.count = 1, .reusable = false}}, SHIFT(113),
  [888] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12336),
  [890] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5152),
  [892] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3942),
  [894] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4822),
  [896] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8396),
  [898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8031),
  [900] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8031),
  [902] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4920),
  [904] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7057),
  [906] = {.entry = {.count = 1, .reusable = false}}, SHIFT(432),
  [908] = {.entry = {.count = 1, .reusable = false}}, SHIFT(438),
  [910] = {.entry = {.count = 1, .reusable = false}}, SHIFT(439),
  [912] = {.entry = {.count = 1, .reusable = false}}, SHIFT(442),
  [914] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4640),
  [916] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5192),
  [918] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6360),
  [920] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12471),
  [922] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6297),
  [924] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1854),
  [926] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1853),
  [928] = {.entry = {.count = 1, .reusable = false}}, SHIFT(99),
  [930] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5051),
  [932] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3941),
  [934] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4832),
  [936] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5163),
  [938] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4803),
  [940] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4560),
  [942] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8355),
  [944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8054),
  [946] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8054),
  [948] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4742),
  [950] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7005),
  [952] = {.entry = {.count = 1, .reusable = false}}, SHIFT(341),
  [954] = {.entry = {.count = 1, .reusable = false}}, SHIFT(340),
  [956] = {.entry = {.count = 1, .reusable = false}}, SHIFT(336),
  [958] = {.entry = {.count = 1, .reusable = false}}, SHIFT(335),
  [960] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4770),
  [962] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6382),
  [964] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12453),
  [966] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6304),
  [968] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2189),
  [970] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2187),
  [972] = {.entry = {.count = 1, .reusable = false}}, SHIFT(104),
  [974] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4757),
  [976] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3926),
  [978] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4843),
  [980] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8345),
  [982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8095),
  [984] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8095),
  [986] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9172),
  [988] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12444),
  [990] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6272),
  [992] = {.entry = {.count = 1, .reusable = false}}, SHIFT(56),
  [994] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5178),
  [996] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4737),
  [998] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4746),
  [1000] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4081),
  [1002] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4990),
  [1004] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5288),
  [1006] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5494),
  [1008] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5506),
  [1010] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4055),
  [1012] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4345),
  [1014] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4061),
  [1016] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4343),
  [1018] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5338),
  [1020] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5337),
  [1022] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4489),
  [1024] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4492),
  [1026] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4036),
  [1028] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4009),
  [1030] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4801),
  [1032] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4110),
  [1034] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4109),
  [1036] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5175),
  [1038] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4195),
  [1040] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4155),
  [1042] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4478),
  [1044] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4471),
  [1046] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5174),
  [1048] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5107),
  [1050] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5098),
  [1052] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4538),
  [1054] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4175),
  [1056] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4545),
  [1058] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4176),
  [1060] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5482),
  [1062] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5493),
  [1064] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4973),
  [1066] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4974),
  [1068] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4266),
  [1070] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4265),
  [1072] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5136),
  [1074] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5240),
  [1076] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5138),
  [1078] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4763),
  [1080] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4762),
  [1082] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5253),
  [1084] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5015),
  [1086] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5014),
  [1088] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4687),
  [1090] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4686),
  [1092] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4461),
  [1094] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5659),
  [1096] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5660),
  [1098] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4730),
  [1100] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4468),
  [1102] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_record_declarations_block_repeat1, 2),
  [1104] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_record_declarations_block_repeat1, 2),
  [1106] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_record_declarations_block_repeat1, 2), SHIFT_REPEAT(12151),
  [1109] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_record_declarations_block_repeat1, 2), SHIFT_REPEAT(12263),
  [1112] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_record_declarations_block_repeat1, 2), SHIFT_REPEAT(12262),
  [1115] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_record_declarations_block_repeat1, 2), SHIFT_REPEAT(12260),
  [1118] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4731),
  [1120] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5328),
  [1122] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4716),
  [1124] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5329),
  [1126] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4715),
  [1128] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4183),
  [1130] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4145),
  [1132] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4150),
  [1134] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4182),
  [1136] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5592),
  [1138] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5576),
  [1140] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5206),
  [1142] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4378),
  [1144] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4381),
  [1146] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5434),
  [1148] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5443),
  [1150] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5207),
  [1152] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4398),
  [1154] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4399),
  [1156] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5712),
  [1158] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5696),
  [1160] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4623),
  [1162] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4624),
  [1164] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4641),
  [1166] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4701),
  [1168] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8315),
  [1170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8091),
  [1172] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8091),
  [1174] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5246),
  [1176] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6994),
  [1178] = {.entry = {.count = 1, .reusable = false}}, SHIFT(516),
  [1180] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4500),
  [1182] = {.entry = {.count = 1, .reusable = false}}, SHIFT(462),
  [1184] = {.entry = {.count = 1, .reusable = false}}, SHIFT(472),
  [1186] = {.entry = {.count = 1, .reusable = false}}, SHIFT(477),
  [1188] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5221),
  [1190] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6325),
  [1192] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12334),
  [1194] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6165),
  [1196] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1657),
  [1198] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1658),
  [1200] = {.entry = {.count = 1, .reusable = false}}, SHIFT(105),
  [1202] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5243),
  [1204] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3931),
  [1206] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5055),
  [1208] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8302),
  [1210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8104),
  [1212] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8104),
  [1214] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5664),
  [1216] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7061),
  [1218] = {.entry = {.count = 1, .reusable = false}}, SHIFT(510),
  [1220] = {.entry = {.count = 1, .reusable = false}}, SHIFT(509),
  [1222] = {.entry = {.count = 1, .reusable = false}}, SHIFT(508),
  [1224] = {.entry = {.count = 1, .reusable = false}}, SHIFT(507),
  [1226] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5523),
  [1228] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6431),
  [1230] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12408),
  [1232] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6204),
  [1234] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1952),
  [1236] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1953),
  [1238] = {.entry = {.count = 1, .reusable = false}}, SHIFT(72),
  [1240] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5626),
  [1242] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3952),
  [1244] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5225),
  [1246] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8275),
  [1248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8148),
  [1250] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8148),
  [1252] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5436),
  [1254] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7076),
  [1256] = {.entry = {.count = 1, .reusable = false}}, SHIFT(594),
  [1258] = {.entry = {.count = 1, .reusable = false}}, SHIFT(587),
  [1260] = {.entry = {.count = 1, .reusable = false}}, SHIFT(583),
  [1262] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6003),
  [1264] = {.entry = {.count = 1, .reusable = false}}, SHIFT(582),
  [1266] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5504),
  [1268] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6632),
  [1270] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12399),
  [1272] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6168),
  [1274] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1791),
  [1276] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1796),
  [1278] = {.entry = {.count = 1, .reusable = false}}, SHIFT(90),
  [1280] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5440),
  [1282] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3959),
  [1284] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8268),
  [1286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8077),
  [1288] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8077),
  [1290] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12389),
  [1292] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6303),
  [1294] = {.entry = {.count = 1, .reusable = false}}, SHIFT(101),
  [1296] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5248),
  [1298] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5360),
  [1300] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5037),
  [1302] = {.entry = {.count = 1, .reusable = false}}, SHIFT(68),
  [1304] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5365),
  [1306] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7159),
  [1308] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7802),
  [1310] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5371),
  [1312] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5250),
  [1314] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5906),
  [1316] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7473),
  [1318] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7510),
  [1320] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5373),
  [1322] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7290),
  [1324] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4299),
  [1326] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11704),
  [1328] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7269),
  [1330] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4295),
  [1332] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8838),
  [1334] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7200),
  [1336] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6954),
  [1338] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7270),
  [1340] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7197),
  [1342] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7841),
  [1344] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5789),
  [1346] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7275),
  [1348] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4501),
  [1350] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5738),
  [1352] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7215),
  [1354] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7214),
  [1356] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7409),
  [1358] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4938),
  [1360] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7424),
  [1362] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6810),
  [1364] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5923),
  [1366] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6545),
  [1368] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6546),
  [1370] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7580),
  [1372] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7304),
  [1374] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7303),
  [1376] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5922),
  [1378] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5581),
  [1380] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5036),
  [1382] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7439),
  [1384] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5583),
  [1386] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7774),
  [1388] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7158),
  [1390] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4834),
  [1392] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7407),
  [1394] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7570),
  [1396] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5904),
  [1398] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6063),
  [1400] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7408),
  [1402] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4838),
  [1404] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7441),
  [1406] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5766),
  [1408] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5768),
  [1410] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7356),
  [1412] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7355),
  [1414] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5972),
  [1416] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5780),
  [1418] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5781),
  [1420] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7528),
  [1422] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7527),
  [1424] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5984),
  [1426] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5983),
  [1428] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7670),
  [1430] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7696),
  [1432] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7765),
  [1434] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5798),
  [1436] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5799),
  [1438] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7314),
  [1440] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7313),
  [1442] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7844),
  [1444] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6185),
  [1446] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7703),
  [1448] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5820),
  [1450] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6184),
  [1452] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5821),
  [1454] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6793),
  [1456] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6828),
  [1458] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6794),
  [1460] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7440),
  [1462] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6245),
  [1464] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7436),
  [1466] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5943),
  [1468] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7706),
  [1470] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5399),
  [1472] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5400),
  [1474] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5473),
  [1476] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7816),
  [1478] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7576),
  [1480] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5474),
  [1482] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7723),
  [1484] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5262),
  [1486] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5426),
  [1488] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7254),
  [1490] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5428),
  [1492] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5266),
  [1494] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7728),
  [1496] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7131),
  [1498] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7720),
  [1500] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7596),
  [1502] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7466),
  [1504] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7578),
  [1506] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4250),
  [1508] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4248),
  [1510] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4586),
  [1512] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6792),
  [1514] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4588),
  [1516] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5534),
  [1518] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6922),
  [1520] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4268),
  [1522] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4324),
  [1524] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4874),
  [1526] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4286),
  [1528] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4212),
  [1530] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7806),
  [1532] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7693),
  [1534] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6085),
  [1536] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4210),
  [1538] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7321),
  [1540] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6399),
  [1542] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7322),
  [1544] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6401),
  [1546] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7804),
  [1548] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7736),
  [1550] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7742),
  [1552] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4339),
  [1554] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5929),
  [1556] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4340),
  [1558] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5930),
  [1560] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7494),
  [1562] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5531),
  [1564] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7557),
  [1566] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7467),
  [1568] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6009),
  [1570] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6046),
  [1572] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4328),
  [1574] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6045),
  [1576] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7647),
  [1578] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7645),
  [1580] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7668),
  [1582] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7546),
  [1584] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6033),
  [1586] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7548),
  [1588] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4862),
  [1590] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7508),
  [1592] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8763),
  [1594] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6127),
  [1596] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5052),
  [1598] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6034),
  [1600] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6133),
  [1602] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6086),
  [1604] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5554),
  [1606] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7604),
  [1608] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5555),
  [1610] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6292),
  [1612] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7685),
  [1614] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5198),
  [1616] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7178),
  [1618] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7204),
  [1620] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7177),
  [1622] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5419),
  [1624] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5421),
  [1626] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7172),
  [1628] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6942),
  [1630] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5954),
  [1632] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5953),
  [1634] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7813),
  [1636] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6943),
  [1638] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7506),
  [1640] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7537),
  [1642] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5317),
  [1644] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7382),
  [1646] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7458),
  [1648] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5316),
  [1650] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5640),
  [1652] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5644),
  [1654] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5083),
  [1656] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7457),
  [1658] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5067),
  [1660] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4222),
  [1662] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4936),
  [1664] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5465),
  [1666] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5464),
  [1668] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4935),
  [1670] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5449),
  [1672] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5450),
  [1674] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5897),
  [1676] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6574),
  [1678] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5895),
  [1680] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4652),
  [1682] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4654),
  [1684] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7390),
  [1686] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7100),
  [1688] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7419),
  [1690] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7165),
  [1692] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7559),
  [1694] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6156),
  [1696] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7505),
  [1698] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7583),
  [1700] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6154),
  [1702] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7099),
  [1704] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7167),
  [1706] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7704),
  [1708] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6902),
  [1710] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6901),
  [1712] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6849),
  [1714] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6847),
  [1716] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7619),
  [1718] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6806),
  [1720] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11887),
  [1722] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6103),
  [1724] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5700),
  [1726] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5701),
  [1728] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7399),
  [1730] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5679),
  [1732] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6227),
  [1734] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6228),
  [1736] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4535),
  [1738] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4534),
  [1740] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5669),
  [1742] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4674),
  [1744] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4882),
  [1746] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4673),
  [1748] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7128),
  [1750] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5129),
  [1752] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5126),
  [1754] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4185),
  [1756] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4788),
  [1758] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6716),
  [1760] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4790),
  [1762] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5578),
  [1764] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4521),
  [1766] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4079),
  [1768] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4076),
  [1770] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4883),
  [1772] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5491),
  [1774] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4418),
  [1776] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5764),
  [1778] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5763),
  [1780] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7241),
  [1782] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6027),
  [1784] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7240),
  [1786] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4940),
  [1788] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5855),
  [1790] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5732),
  [1792] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7697),
  [1794] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5731),
  [1796] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7253),
  [1798] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7684),
  [1800] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7070),
  [1802] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5868),
  [1804] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4844),
  [1806] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4582),
  [1808] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4848),
  [1810] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4452),
  [1812] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7584),
  [1814] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4451),
  [1816] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7071),
  [1818] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5294),
  [1820] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5293),
  [1822] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6098),
  [1824] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4313),
  [1826] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5621),
  [1828] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5623),
  [1830] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6718),
  [1832] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4583),
  [1834] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4314),
  [1836] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6211),
  [1838] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6170),
  [1840] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5807),
  [1842] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5808),
  [1844] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5856),
  [1846] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5857),
  [1848] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4959),
  [1850] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4957),
  [1852] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7729),
  [1854] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5649),
  [1856] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5665),
  [1858] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7598),
  [1860] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6562),
  [1862] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6129),
  [1864] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6128),
  [1866] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4140),
  [1868] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8379),
  [1870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8032),
  [1872] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8032),
  [1874] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4263),
  [1876] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7046),
  [1878] = {.entry = {.count = 1, .reusable = false}}, SHIFT(471),
  [1880] = {.entry = {.count = 1, .reusable = false}}, SHIFT(468),
  [1882] = {.entry = {.count = 1, .reusable = false}}, SHIFT(464),
  [1884] = {.entry = {.count = 1, .reusable = false}}, SHIFT(463),
  [1886] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4350),
  [1888] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6497),
  [1890] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12696),
  [1892] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6205),
  [1894] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2091),
  [1896] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2081),
  [1898] = {.entry = {.count = 1, .reusable = false}}, SHIFT(74),
  [1900] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4401),
  [1902] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3900),
  [1904] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4789),
  [1906] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8431),
  [1908] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2553),
  [1910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8153),
  [1912] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8153),
  [1914] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4679),
  [1916] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6893),
  [1918] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1197),
  [1920] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1199),
  [1922] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1202),
  [1924] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1203),
  [1926] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6520),
  [1928] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12630),
  [1930] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6028),
  [1932] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2262),
  [1934] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2267),
  [1936] = {.entry = {.count = 1, .reusable = false}}, SHIFT(94),
  [1938] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4634),
  [1940] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3947),
  [1942] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5222),
  [1944] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8321),
  [1946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8062),
  [1948] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8062),
  [1950] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5490),
  [1952] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6929),
  [1954] = {.entry = {.count = 1, .reusable = false}}, SHIFT(453),
  [1956] = {.entry = {.count = 1, .reusable = false}}, SHIFT(452),
  [1958] = {.entry = {.count = 1, .reusable = false}}, SHIFT(451),
  [1960] = {.entry = {.count = 1, .reusable = false}}, SHIFT(450),
  [1962] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5532),
  [1964] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6414),
  [1966] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12417),
  [1968] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6215),
  [1970] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2305),
  [1972] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2312),
  [1974] = {.entry = {.count = 1, .reusable = false}}, SHIFT(70),
  [1976] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5505),
  [1978] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3965),
  [1980] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4743),
  [1982] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8483),
  [1984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8039),
  [1986] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8039),
  [1988] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5185),
  [1990] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6913),
  [1992] = {.entry = {.count = 1, .reusable = false}}, SHIFT(454),
  [1994] = {.entry = {.count = 1, .reusable = false}}, SHIFT(430),
  [1996] = {.entry = {.count = 1, .reusable = false}}, SHIFT(415),
  [1998] = {.entry = {.count = 1, .reusable = false}}, SHIFT(414),
  [2000] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5065),
  [2002] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6694),
  [2004] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12561),
  [2006] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6242),
  [2008] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2334),
  [2010] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2335),
  [2012] = {.entry = {.count = 1, .reusable = false}}, SHIFT(108),
  [2014] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5141),
  [2016] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3943),
  [2018] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4815),
  [2020] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8463),
  [2022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8033),
  [2024] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8033),
  [2026] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5183),
  [2028] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6927),
  [2030] = {.entry = {.count = 1, .reusable = false}}, SHIFT(398),
  [2032] = {.entry = {.count = 1, .reusable = false}}, SHIFT(404),
  [2034] = {.entry = {.count = 1, .reusable = false}}, SHIFT(406),
  [2036] = {.entry = {.count = 1, .reusable = false}}, SHIFT(413),
  [2038] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5011),
  [2040] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6637),
  [2042] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12588),
  [2044] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6269),
  [2046] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2407),
  [2048] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2409),
  [2050] = {.entry = {.count = 1, .reusable = false}}, SHIFT(78),
  [2052] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5076),
  [2054] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3945),
  [2056] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5216),
  [2058] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8334),
  [2060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8089),
  [2062] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8089),
  [2064] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5503),
  [2066] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6858),
  [2068] = {.entry = {.count = 1, .reusable = false}}, SHIFT(384),
  [2070] = {.entry = {.count = 1, .reusable = false}}, SHIFT(383),
  [2072] = {.entry = {.count = 1, .reusable = false}}, SHIFT(379),
  [2074] = {.entry = {.count = 1, .reusable = false}}, SHIFT(371),
  [2076] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5535),
  [2078] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6395),
  [2080] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12426),
  [2082] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6246),
  [2084] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2456),
  [2086] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2457),
  [2088] = {.entry = {.count = 1, .reusable = false}}, SHIFT(82),
  [2090] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5527),
  [2092] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3966),
  [2094] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5006),
  [2096] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8428),
  [2098] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1489),
  [2100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8075),
  [2102] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8075),
  [2104] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5453),
  [2106] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6967),
  [2108] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1126),
  [2110] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1116),
  [2112] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1107),
  [2114] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1106),
  [2116] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5366),
  [2118] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6434),
  [2120] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12636),
  [2122] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6136),
  [2124] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2575),
  [2126] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2577),
  [2128] = {.entry = {.count = 1, .reusable = false}}, SHIFT(97),
  [2130] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5408),
  [2132] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3956),
  [2134] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5002),
  [2136] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8460),
  [2138] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1614),
  [2140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8040),
  [2142] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8040),
  [2144] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5627),
  [2146] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7034),
  [2148] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1333),
  [2150] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1332),
  [2152] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1331),
  [2154] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1330),
  [2156] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5602),
  [2158] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6569),
  [2160] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12594),
  [2162] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6307),
  [2164] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1500),
  [2166] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1493),
  [2168] = {.entry = {.count = 1, .reusable = false}}, SHIFT(112),
  [2170] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5610),
  [2172] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3953),
  [2174] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4416),
  [2176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8044),
  [2178] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8044),
  [2180] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4531),
  [2182] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6982),
  [2184] = {.entry = {.count = 1, .reusable = false}}, SHIFT(418),
  [2186] = {.entry = {.count = 1, .reusable = false}}, SHIFT(419),
  [2188] = {.entry = {.count = 1, .reusable = false}}, SHIFT(420),
  [2190] = {.entry = {.count = 1, .reusable = false}}, SHIFT(422),
  [2192] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4565),
  [2194] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6400),
  [2196] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6183),
  [2198] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2655),
  [2200] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2656),
  [2202] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4558),
  [2204] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3906),
  [2206] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4499),
  [2208] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8402),
  [2210] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2163),
  [2212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8035),
  [2214] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8035),
  [2216] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4858),
  [2218] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6975),
  [2220] = {.entry = {.count = 1, .reusable = false}}, SHIFT(764),
  [2222] = {.entry = {.count = 1, .reusable = false}}, SHIFT(745),
  [2224] = {.entry = {.count = 1, .reusable = false}}, SHIFT(737),
  [2226] = {.entry = {.count = 1, .reusable = false}}, SHIFT(720),
  [2228] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4720),
  [2230] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6571),
  [2232] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12666),
  [2234] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6189),
  [2236] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2634),
  [2238] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2635),
  [2240] = {.entry = {.count = 1, .reusable = false}}, SHIFT(91),
  [2242] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4771),
  [2244] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3924),
  [2246] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4101),
  [2248] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4153),
  [2250] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7050),
  [2252] = {.entry = {.count = 1, .reusable = false}}, SHIFT(561),
  [2254] = {.entry = {.count = 1, .reusable = false}}, SHIFT(560),
  [2256] = {.entry = {.count = 1, .reusable = false}}, SHIFT(558),
  [2258] = {.entry = {.count = 1, .reusable = false}}, SHIFT(554),
  [2260] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4138),
  [2262] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6385),
  [2264] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1647),
  [2266] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1616),
  [2268] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4204),
  [2270] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3883),
  [2272] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4823),
  [2274] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5053),
  [2276] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6935),
  [2278] = {.entry = {.count = 1, .reusable = false}}, SHIFT(540),
  [2280] = {.entry = {.count = 1, .reusable = false}}, SHIFT(533),
  [2282] = {.entry = {.count = 1, .reusable = false}}, SHIFT(492),
  [2284] = {.entry = {.count = 1, .reusable = false}}, SHIFT(490),
  [2286] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4918),
  [2288] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6463),
  [2290] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2413),
  [2292] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2416),
  [2294] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5063),
  [2296] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3946),
  [2298] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4768),
  [2300] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8476),
  [2302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8138),
  [2304] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8138),
  [2306] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5347),
  [2308] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6916),
  [2310] = {.entry = {.count = 1, .reusable = false}}, SHIFT(343),
  [2312] = {.entry = {.count = 1, .reusable = false}}, SHIFT(344),
  [2314] = {.entry = {.count = 1, .reusable = false}}, SHIFT(345),
  [2316] = {.entry = {.count = 1, .reusable = false}}, SHIFT(346),
  [2318] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5058),
  [2320] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6790),
  [2322] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12570),
  [2324] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6142),
  [2326] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2345),
  [2328] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2346),
  [2330] = {.entry = {.count = 1, .reusable = false}}, SHIFT(66),
  [2332] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5148),
  [2334] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3930),
  [2336] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4709),
  [2338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8079),
  [2340] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8079),
  [2342] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5285),
  [2344] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6243),
  [2346] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4096),
  [2348] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8372),
  [2350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8119),
  [2352] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8119),
  [2354] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4192),
  [2356] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7060),
  [2358] = {.entry = {.count = 1, .reusable = false}}, SHIFT(445),
  [2360] = {.entry = {.count = 1, .reusable = false}}, SHIFT(436),
  [2362] = {.entry = {.count = 1, .reusable = false}}, SHIFT(433),
  [2364] = {.entry = {.count = 1, .reusable = false}}, SHIFT(431),
  [2366] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4224),
  [2368] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6430),
  [2370] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12702),
  [2372] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6102),
  [2374] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2060),
  [2376] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2037),
  [2378] = {.entry = {.count = 1, .reusable = false}}, SHIFT(69),
  [2380] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4141),
  [2382] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3885),
  [2384] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4470),
  [2386] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8518),
  [2388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8139),
  [2390] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8139),
  [2392] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4896),
  [2394] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6940),
  [2396] = {.entry = {.count = 1, .reusable = false}}, SHIFT(327),
  [2398] = {.entry = {.count = 1, .reusable = false}}, SHIFT(326),
  [2400] = {.entry = {.count = 1, .reusable = false}}, SHIFT(325),
  [2402] = {.entry = {.count = 1, .reusable = false}}, SHIFT(321),
  [2404] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4903),
  [2406] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6456),
  [2408] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12516),
  [2410] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6186),
  [2412] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1406),
  [2414] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1431),
  [2416] = {.entry = {.count = 1, .reusable = false}}, SHIFT(88),
  [2418] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4871),
  [2420] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3920),
  [2422] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5028),
  [2424] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8423),
  [2426] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2007),
  [2428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8125),
  [2430] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8125),
  [2432] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5423),
  [2434] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6968),
  [2436] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1037),
  [2438] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1036),
  [2440] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1033),
  [2442] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1032),
  [2444] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5359),
  [2446] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6453),
  [2448] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12642),
  [2450] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6163),
  [2452] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2578),
  [2454] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2588),
  [2456] = {.entry = {.count = 1, .reusable = false}}, SHIFT(86),
  [2458] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5402),
  [2460] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3957),
  [2462] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4027),
  [2464] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4052),
  [2466] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6950),
  [2468] = {.entry = {.count = 1, .reusable = false}}, SHIFT(337),
  [2470] = {.entry = {.count = 1, .reusable = false}}, SHIFT(338),
  [2472] = {.entry = {.count = 1, .reusable = false}}, SHIFT(339),
  [2474] = {.entry = {.count = 1, .reusable = false}}, SHIFT(342),
  [2476] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4107),
  [2478] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6317),
  [2480] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2481),
  [2482] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2477),
  [2484] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4090),
  [2486] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3851),
  [2488] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4968),
  [2490] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8497),
  [2492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8096),
  [2494] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8096),
  [2496] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5698),
  [2498] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7055),
  [2500] = {.entry = {.count = 1, .reusable = false}}, SHIFT(611),
  [2502] = {.entry = {.count = 1, .reusable = false}}, SHIFT(609),
  [2504] = {.entry = {.count = 1, .reusable = false}}, SHIFT(608),
  [2506] = {.entry = {.count = 1, .reusable = false}}, SHIFT(606),
  [2508] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5671),
  [2510] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6725),
  [2512] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12543),
  [2514] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6012),
  [2516] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2043),
  [2518] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2070),
  [2520] = {.entry = {.count = 1, .reusable = false}}, SHIFT(73),
  [2522] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5688),
  [2524] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3971),
  [2526] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4406),
  [2528] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8398),
  [2530] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1938),
  [2532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8066),
  [2534] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8066),
  [2536] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4473),
  [2538] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6976),
  [2540] = {.entry = {.count = 1, .reusable = false}}, SHIFT(614),
  [2542] = {.entry = {.count = 1, .reusable = false}}, SHIFT(676),
  [2544] = {.entry = {.count = 1, .reusable = false}}, SHIFT(675),
  [2546] = {.entry = {.count = 1, .reusable = false}}, SHIFT(671),
  [2548] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4561),
  [2550] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6578),
  [2552] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12672),
  [2554] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6197),
  [2556] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2636),
  [2558] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2638),
  [2560] = {.entry = {.count = 1, .reusable = false}}, SHIFT(62),
  [2562] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4524),
  [2564] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3908),
  [2566] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5130),
  [2568] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8412),
  [2570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8111),
  [2572] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8111),
  [2574] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5590),
  [2576] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7004),
  [2578] = {.entry = {.count = 1, .reusable = false}}, SHIFT(543),
  [2580] = {.entry = {.count = 1, .reusable = false}}, SHIFT(549),
  [2582] = {.entry = {.count = 1, .reusable = false}}, SHIFT(550),
  [2584] = {.entry = {.count = 1, .reusable = false}}, SHIFT(551),
  [2586] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5710),
  [2588] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6350),
  [2590] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12480),
  [2592] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6305),
  [2594] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2123),
  [2596] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2126),
  [2598] = {.entry = {.count = 1, .reusable = false}}, SHIFT(98),
  [2600] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5608),
  [2602] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3970),
  [2604] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2651),
  [2606] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4630),
  [2608] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5087),
  [2610] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6470),
  [2612] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3936),
  [2614] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4485),
  [2616] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8414),
  [2618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8093),
  [2620] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8093),
  [2622] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4784),
  [2624] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6946),
  [2626] = {.entry = {.count = 1, .reusable = false}}, SHIFT(405),
  [2628] = {.entry = {.count = 1, .reusable = false}}, SHIFT(403),
  [2630] = {.entry = {.count = 1, .reusable = false}}, SHIFT(402),
  [2632] = {.entry = {.count = 1, .reusable = false}}, SHIFT(391),
  [2634] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4910),
  [2636] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6410),
  [2638] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12654),
  [2640] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6062),
  [2642] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2439),
  [2644] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2459),
  [2646] = {.entry = {.count = 1, .reusable = false}}, SHIFT(107),
  [2648] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4824),
  [2650] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3914),
  [2652] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4607),
  [2654] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8470),
  [2656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8132),
  [2658] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8132),
  [2660] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4735),
  [2662] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6880),
  [2664] = {.entry = {.count = 1, .reusable = false}}, SHIFT(547),
  [2666] = {.entry = {.count = 1, .reusable = false}}, SHIFT(542),
  [2668] = {.entry = {.count = 1, .reusable = false}}, SHIFT(541),
  [2670] = {.entry = {.count = 1, .reusable = false}}, SHIFT(532),
  [2672] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4647),
  [2674] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6451),
  [2676] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12579),
  [2678] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6207),
  [2680] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2144),
  [2682] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2159),
  [2684] = {.entry = {.count = 1, .reusable = false}}, SHIFT(83),
  [2686] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4707),
  [2688] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3923),
  [2690] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4010),
  [2692] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8368),
  [2694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8133),
  [2696] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8133),
  [2698] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4103),
  [2700] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7068),
  [2702] = {.entry = {.count = 1, .reusable = false}}, SHIFT(396),
  [2704] = {.entry = {.count = 1, .reusable = false}}, SHIFT(395),
  [2706] = {.entry = {.count = 1, .reusable = false}}, SHIFT(392),
  [2708] = {.entry = {.count = 1, .reusable = false}}, SHIFT(390),
  [2710] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4123),
  [2712] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6362),
  [2714] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12708),
  [2716] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6090),
  [2718] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2024),
  [2720] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2019),
  [2722] = {.entry = {.count = 1, .reusable = false}}, SHIFT(64),
  [2724] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4074),
  [2726] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3820),
  [2728] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4562),
  [2730] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8384),
  [2732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8061),
  [2734] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8061),
  [2736] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4682),
  [2738] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7044),
  [2740] = {.entry = {.count = 1, .reusable = false}}, SHIFT(495),
  [2742] = {.entry = {.count = 1, .reusable = false}}, SHIFT(491),
  [2744] = {.entry = {.count = 1, .reusable = false}}, SHIFT(489),
  [2746] = {.entry = {.count = 1, .reusable = false}}, SHIFT(487),
  [2748] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4774),
  [2750] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6597),
  [2752] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12690),
  [2754] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6295),
  [2756] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2105),
  [2758] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2103),
  [2760] = {.entry = {.count = 1, .reusable = false}}, SHIFT(75),
  [2762] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4708),
  [2764] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3918),
  [2766] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4993),
  [2768] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1522),
  [2770] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5668),
  [2772] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7075),
  [2774] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1378),
  [2776] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1376),
  [2778] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1374),
  [2780] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1373),
  [2782] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5603),
  [2784] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6533),
  [2786] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1555),
  [2788] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1554),
  [2790] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5612),
  [2792] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3967),
  [2794] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8490),
  [2796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8041),
  [2798] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8041),
  [2800] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12552),
  [2802] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6077),
  [2804] = {.entry = {.count = 1, .reusable = false}}, SHIFT(81),
  [2806] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5546),
  [2808] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2185),
  [2810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8081),
  [2812] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8081),
  [2814] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5981),
  [2816] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6881),
  [2818] = {.entry = {.count = 1, .reusable = false}}, SHIFT(781),
  [2820] = {.entry = {.count = 1, .reusable = false}}, SHIFT(778),
  [2822] = {.entry = {.count = 1, .reusable = false}}, SHIFT(777),
  [2824] = {.entry = {.count = 1, .reusable = false}}, SHIFT(776),
  [2826] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5945),
  [2828] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6720),
  [2830] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6241),
  [2832] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2160),
  [2834] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2161),
  [2836] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5971),
  [2838] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3991),
  [2840] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4530),
  [2842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8053),
  [2844] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8053),
  [2846] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4766),
  [2848] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6990),
  [2850] = {.entry = {.count = 1, .reusable = false}}, SHIFT(466),
  [2852] = {.entry = {.count = 1, .reusable = false}}, SHIFT(467),
  [2854] = {.entry = {.count = 1, .reusable = false}}, SHIFT(469),
  [2856] = {.entry = {.count = 1, .reusable = false}}, SHIFT(470),
  [2858] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4681),
  [2860] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6462),
  [2862] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6011),
  [2864] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2600),
  [2866] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2599),
  [2868] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4719),
  [2870] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3919),
  [2872] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4734),
  [2874] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5287),
  [2876] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6894),
  [2878] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1364),
  [2880] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1329),
  [2882] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1320),
  [2884] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1318),
  [2886] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5078),
  [2888] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6433),
  [2890] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2289),
  [2892] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2290),
  [2894] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5350),
  [2896] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3948),
  [2898] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4040),
  [2900] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8489),
  [2902] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1742),
  [2904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8094),
  [2906] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8094),
  [2908] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4206),
  [2910] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6919),
  [2912] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1110),
  [2914] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1105),
  [2916] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1093),
  [2918] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1216),
  [2920] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4174),
  [2922] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6372),
  [2924] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12498),
  [2926] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6178),
  [2928] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2067),
  [2930] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2050),
  [2932] = {.entry = {.count = 1, .reusable = false}}, SHIFT(106),
  [2934] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4231),
  [2936] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3889),
  [2938] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5409),
  [2940] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8418),
  [2942] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2453),
  [2944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8126),
  [2946] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8126),
  [2948] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5838),
  [2950] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6965),
  [2952] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1385),
  [2954] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1335),
  [2956] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1293),
  [2958] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1276),
  [2960] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5747),
  [2962] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6416),
  [2964] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12648),
  [2966] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6113),
  [2968] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2545),
  [2970] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2546),
  [2972] = {.entry = {.count = 1, .reusable = false}}, SHIFT(111),
  [2974] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5791),
  [2976] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3987),
  [2978] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4283),
  [2980] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8511),
  [2982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8117),
  [2984] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8117),
  [2986] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4463),
  [2988] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6941),
  [2990] = {.entry = {.count = 1, .reusable = false}}, SHIFT(493),
  [2992] = {.entry = {.count = 1, .reusable = false}}, SHIFT(506),
  [2994] = {.entry = {.count = 1, .reusable = false}}, SHIFT(511),
  [2996] = {.entry = {.count = 1, .reusable = false}}, SHIFT(512),
  [2998] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4425),
  [3000] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6641),
  [3002] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12525),
  [3004] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6112),
  [3006] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1526),
  [3008] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1527),
  [3010] = {.entry = {.count = 1, .reusable = false}}, SHIFT(63),
  [3012] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4437),
  [3014] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3905),
  [3016] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4663),
  [3018] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8388),
  [3020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8127),
  [3022] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8127),
  [3024] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5333),
  [3026] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7036),
  [3028] = {.entry = {.count = 1, .reusable = false}}, SHIFT(528),
  [3030] = {.entry = {.count = 1, .reusable = false}}, SHIFT(526),
  [3032] = {.entry = {.count = 1, .reusable = false}}, SHIFT(525),
  [3034] = {.entry = {.count = 1, .reusable = false}}, SHIFT(524),
  [3036] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5197),
  [3038] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6693),
  [3040] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12684),
  [3042] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6268),
  [3044] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2208),
  [3046] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2201),
  [3048] = {.entry = {.count = 1, .reusable = false}}, SHIFT(100),
  [3050] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5306),
  [3052] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3935),
  [3054] = {.entry = {.count = 1, .reusable = false}}, SHIFT(93),
  [3056] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5818),
  [3058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8123),
  [3060] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8123),
  [3062] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6714),
  [3064] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6908),
  [3066] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1230),
  [3068] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1228),
  [3070] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1222),
  [3072] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1336),
  [3074] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4575),
  [3076] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6158),
  [3078] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6420),
  [3080] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6082),
  [3082] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2288),
  [3084] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2284),
  [3086] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6710),
  [3088] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4031),
  [3090] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4147),
  [3092] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8393),
  [3094] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1820),
  [3096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8099),
  [3098] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8099),
  [3100] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4285),
  [3102] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6977),
  [3104] = {.entry = {.count = 1, .reusable = false}}, SHIFT(668),
  [3106] = {.entry = {.count = 1, .reusable = false}}, SHIFT(665),
  [3108] = {.entry = {.count = 1, .reusable = false}}, SHIFT(651),
  [3110] = {.entry = {.count = 1, .reusable = false}}, SHIFT(644),
  [3112] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4373),
  [3114] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6589),
  [3116] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12678),
  [3118] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6250),
  [3120] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2642),
  [3122] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2643),
  [3124] = {.entry = {.count = 1, .reusable = false}}, SHIFT(89),
  [3126] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4404),
  [3128] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3902),
  [3130] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4325),
  [3132] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8363),
  [3134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8076),
  [3136] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8076),
  [3138] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4496),
  [3140] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7093),
  [3142] = {.entry = {.count = 1, .reusable = false}}, SHIFT(377),
  [3144] = {.entry = {.count = 1, .reusable = false}}, SHIFT(376),
  [3146] = {.entry = {.count = 1, .reusable = false}}, SHIFT(374),
  [3148] = {.entry = {.count = 1, .reusable = false}}, SHIFT(372),
  [3150] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4419),
  [3152] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6442),
  [3154] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12714),
  [3156] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6029),
  [3158] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1977),
  [3160] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1971),
  [3162] = {.entry = {.count = 1, .reusable = false}}, SHIFT(71),
  [3164] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4454),
  [3166] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3907),
  [3168] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4891),
  [3170] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8409),
  [3172] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2310),
  [3174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8051),
  [3176] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8051),
  [3178] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4921),
  [3180] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6964),
  [3182] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1371),
  [3184] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1392),
  [3186] = {.entry = {.count = 1, .reusable = false}}, SHIFT(687),
  [3188] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1268),
  [3190] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5070),
  [3192] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6408),
  [3194] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12660),
  [3196] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6071),
  [3198] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2543),
  [3200] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2544),
  [3202] = {.entry = {.count = 1, .reusable = false}}, SHIFT(102),
  [3204] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4982),
  [3206] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3928),
  [3208] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5181),
  [3210] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5582),
  [3212] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6896),
  [3214] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1237),
  [3216] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1249),
  [3218] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1250),
  [3220] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1251),
  [3222] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5444),
  [3224] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6359),
  [3226] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1965),
  [3228] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1958),
  [3230] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5540),
  [3232] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3974),
  [3234] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5193),
  [3236] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1692),
  [3238] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5375),
  [3240] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6978),
  [3242] = {.entry = {.count = 1, .reusable = false}}, SHIFT(620),
  [3244] = {.entry = {.count = 1, .reusable = false}}, SHIFT(621),
  [3246] = {.entry = {.count = 1, .reusable = false}}, SHIFT(624),
  [3248] = {.entry = {.count = 1, .reusable = false}}, SHIFT(627),
  [3250] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5415),
  [3252] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6594),
  [3254] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2645),
  [3256] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2646),
  [3258] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5370),
  [3260] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3961),
  [3262] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3994),
  [3264] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8451),
  [3266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8143),
  [3268] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8143),
  [3270] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4012),
  [3272] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6957),
  [3274] = {.entry = {.count = 1, .reusable = false}}, SHIFT(368),
  [3276] = {.entry = {.count = 1, .reusable = false}}, SHIFT(369),
  [3278] = {.entry = {.count = 1, .reusable = false}}, SHIFT(370),
  [3280] = {.entry = {.count = 1, .reusable = false}}, SHIFT(373),
  [3282] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4033),
  [3284] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6341),
  [3286] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12606),
  [3288] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6001),
  [3290] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2489),
  [3292] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2491),
  [3294] = {.entry = {.count = 1, .reusable = false}}, SHIFT(114),
  [3296] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4026),
  [3298] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3755),
  [3300] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4028),
  [3302] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4049),
  [3304] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6877),
  [3306] = {.entry = {.count = 1, .reusable = false}}, SHIFT(353),
  [3308] = {.entry = {.count = 1, .reusable = false}}, SHIFT(355),
  [3310] = {.entry = {.count = 1, .reusable = false}}, SHIFT(356),
  [3312] = {.entry = {.count = 1, .reusable = false}}, SHIFT(358),
  [3314] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4089),
  [3316] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6394),
  [3318] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2102),
  [3320] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2104),
  [3322] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4041),
  [3324] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3787),
  [3326] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4563),
  [3328] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1678),
  [3330] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4649),
  [3332] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7042),
  [3334] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1121),
  [3336] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1122),
  [3338] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1124),
  [3340] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1125),
  [3342] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4767),
  [3344] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6447),
  [3346] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2172),
  [3348] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2153),
  [3350] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4699),
  [3352] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3917),
  [3354] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4120),
  [3356] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4177),
  [3358] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7031),
  [3360] = {.entry = {.count = 1, .reusable = false}}, SHIFT(548),
  [3362] = {.entry = {.count = 1, .reusable = false}}, SHIFT(546),
  [3364] = {.entry = {.count = 1, .reusable = false}}, SHIFT(545),
  [3366] = {.entry = {.count = 1, .reusable = false}}, SHIFT(544),
  [3368] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4238),
  [3370] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6785),
  [3372] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2216),
  [3374] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2215),
  [3376] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4219),
  [3378] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3884),
  [3380] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4911),
  [3382] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4939),
  [3384] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6924),
  [3386] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1097),
  [3388] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1101),
  [3390] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1102),
  [3392] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1104),
  [3394] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5047),
  [3396] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6513),
  [3398] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2337),
  [3400] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2336),
  [3402] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4923),
  [3404] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3937),
  [3406] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4075),
  [3408] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8435),
  [3410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8038),
  [3412] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8038),
  [3414] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4162),
  [3416] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7065),
  [3418] = {.entry = {.count = 1, .reusable = false}}, SHIFT(412),
  [3420] = {.entry = {.count = 1, .reusable = false}}, SHIFT(411),
  [3422] = {.entry = {.count = 1, .reusable = false}}, SHIFT(408),
  [3424] = {.entry = {.count = 1, .reusable = false}}, SHIFT(407),
  [3426] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4241),
  [3428] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6314),
  [3430] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12624),
  [3432] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6078),
  [3434] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2036),
  [3436] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2032),
  [3438] = {.entry = {.count = 1, .reusable = false}}, SHIFT(115),
  [3440] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4143),
  [3442] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3890),
  [3444] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4835),
  [3446] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8455),
  [3448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8072),
  [3450] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8072),
  [3452] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5000),
  [3454] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6914),
  [3456] = {.entry = {.count = 1, .reusable = false}}, SHIFT(500),
  [3458] = {.entry = {.count = 1, .reusable = false}}, SHIFT(499),
  [3460] = {.entry = {.count = 1, .reusable = false}}, SHIFT(497),
  [3462] = {.entry = {.count = 1, .reusable = false}}, SHIFT(496),
  [3464] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5170),
  [3466] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6687),
  [3468] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12600),
  [3470] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6220),
  [3472] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1668),
  [3474] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1685),
  [3476] = {.entry = {.count = 1, .reusable = false}}, SHIFT(110),
  [3478] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5080),
  [3480] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3950),
  [3482] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4223),
  [3484] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8504),
  [3486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8140),
  [3488] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8140),
  [3490] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4385),
  [3492] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6986),
  [3494] = {.entry = {.count = 1, .reusable = false}}, SHIFT(570),
  [3496] = {.entry = {.count = 1, .reusable = false}}, SHIFT(569),
  [3498] = {.entry = {.count = 1, .reusable = false}}, SHIFT(568),
  [3500] = {.entry = {.count = 1, .reusable = false}}, SHIFT(567),
  [3502] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4257),
  [3504] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6506),
  [3506] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12534),
  [3508] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6061),
  [3510] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2225),
  [3512] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2224),
  [3514] = {.entry = {.count = 1, .reusable = false}}, SHIFT(80),
  [3516] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4335),
  [3518] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3899),
  [3520] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5103),
  [3522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8058),
  [3524] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8058),
  [3526] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5538),
  [3528] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6921),
  [3530] = {.entry = {.count = 1, .reusable = false}}, SHIFT(895),
  [3532] = {.entry = {.count = 1, .reusable = false}}, SHIFT(909),
  [3534] = {.entry = {.count = 1, .reusable = false}}, SHIFT(926),
  [3536] = {.entry = {.count = 1, .reusable = false}}, SHIFT(961),
  [3538] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5511),
  [3540] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6348),
  [3542] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6031),
  [3544] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2385),
  [3546] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2403),
  [3548] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5514),
  [3550] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3958),
  [3552] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1949),
  [3554] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4875),
  [3556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8092),
  [3558] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8092),
  [3560] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5079),
  [3562] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6900),
  [3564] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1019),
  [3566] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1133),
  [3568] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1132),
  [3570] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1087),
  [3572] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6415),
  [3574] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6025),
  [3576] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2316),
  [3578] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2317),
  [3580] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5182),
  [3582] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3932),
  [3584] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4215),
  [3586] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4403),
  [3588] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7028),
  [3590] = {.entry = {.count = 1, .reusable = false}}, SHIFT(581),
  [3592] = {.entry = {.count = 1, .reusable = false}}, SHIFT(578),
  [3594] = {.entry = {.count = 1, .reusable = false}}, SHIFT(576),
  [3596] = {.entry = {.count = 1, .reusable = false}}, SHIFT(575),
  [3598] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4259),
  [3600] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6764),
  [3602] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2233),
  [3604] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2228),
  [3606] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4357),
  [3608] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3901),
  [3610] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4645),
  [3612] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1572),
  [3614] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5242),
  [3616] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7008),
  [3618] = {.entry = {.count = 1, .reusable = false}}, SHIFT(848),
  [3620] = {.entry = {.count = 1, .reusable = false}}, SHIFT(849),
  [3622] = {.entry = {.count = 1, .reusable = false}}, SHIFT(851),
  [3624] = {.entry = {.count = 1, .reusable = false}}, SHIFT(853),
  [3626] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5355),
  [3628] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6732),
  [3630] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2425),
  [3632] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2415),
  [3634] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5307),
  [3636] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3940),
  [3638] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4922),
  [3640] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1641),
  [3642] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5681),
  [3644] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7063),
  [3646] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1182),
  [3648] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1185),
  [3650] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1190),
  [3652] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1194),
  [3654] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5605),
  [3656] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6339),
  [3658] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2094),
  [3660] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2089),
  [3662] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5667),
  [3664] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3962),
  [3666] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4409),
  [3668] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1400),
  [3670] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4584),
  [3672] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7013),
  [3674] = {.entry = {.count = 1, .reusable = false}}, SHIFT(885),
  [3676] = {.entry = {.count = 1, .reusable = false}}, SHIFT(887),
  [3678] = {.entry = {.count = 1, .reusable = false}}, SHIFT(892),
  [3680] = {.entry = {.count = 1, .reusable = false}}, SHIFT(893),
  [3682] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4622),
  [3684] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6755),
  [3686] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2401),
  [3688] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2400),
  [3690] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4604),
  [3692] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3903),
  [3694] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4388),
  [3696] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8446),
  [3698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8124),
  [3700] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8124),
  [3702] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4459),
  [3704] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6861),
  [3706] = {.entry = {.count = 1, .reusable = false}}, SHIFT(444),
  [3708] = {.entry = {.count = 1, .reusable = false}}, SHIFT(437),
  [3710] = {.entry = {.count = 1, .reusable = false}}, SHIFT(435),
  [3712] = {.entry = {.count = 1, .reusable = false}}, SHIFT(434),
  [3714] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4591),
  [3716] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6617),
  [3718] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12612),
  [3720] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6114),
  [3722] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1897),
  [3724] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1899),
  [3726] = {.entry = {.count = 1, .reusable = false}}, SHIFT(103),
  [3728] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4553),
  [3730] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3913),
  [3732] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4030),
  [3734] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2021),
  [3736] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4070),
  [3738] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6871),
  [3740] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1246),
  [3742] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1245),
  [3744] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1243),
  [3746] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1241),
  [3748] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4105),
  [3750] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6649),
  [3752] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1770),
  [3754] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1781),
  [3756] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4094),
  [3758] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3853),
  [3760] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4358),
  [3762] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4613),
  [3764] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7026),
  [3766] = {.entry = {.count = 1, .reusable = false}}, SHIFT(598),
  [3768] = {.entry = {.count = 1, .reusable = false}}, SHIFT(597),
  [3770] = {.entry = {.count = 1, .reusable = false}}, SHIFT(596),
  [3772] = {.entry = {.count = 1, .reusable = false}}, SHIFT(595),
  [3774] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4590),
  [3776] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6705),
  [3778] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2285),
  [3780] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2240),
  [3782] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4610),
  [3784] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3910),
  [3786] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4159),
  [3788] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1464),
  [3790] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4282),
  [3792] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7014),
  [3794] = {.entry = {.count = 1, .reusable = false}}, SHIFT(899),
  [3796] = {.entry = {.count = 1, .reusable = false}}, SHIFT(903),
  [3798] = {.entry = {.count = 1, .reusable = false}}, SHIFT(904),
  [3800] = {.entry = {.count = 1, .reusable = false}}, SHIFT(907),
  [3802] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4412),
  [3804] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6758),
  [3806] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2399),
  [3808] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2390),
  [3810] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4362),
  [3812] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3895),
  [3814] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4148),
  [3816] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8442),
  [3818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8085),
  [3820] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8085),
  [3822] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4273),
  [3824] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6864),
  [3826] = {.entry = {.count = 1, .reusable = false}}, SHIFT(382),
  [3828] = {.entry = {.count = 1, .reusable = false}}, SHIFT(381),
  [3830] = {.entry = {.count = 1, .reusable = false}}, SHIFT(380),
  [3832] = {.entry = {.count = 1, .reusable = false}}, SHIFT(378),
  [3834] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4281),
  [3836] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6528),
  [3838] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12618),
  [3840] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6097),
  [3842] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1837),
  [3844] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1991),
  [3846] = {.entry = {.count = 1, .reusable = false}}, SHIFT(67),
  [3848] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4414),
  [3850] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3898),
  [3852] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4612),
  [3854] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4643),
  [3856] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7017),
  [3858] = {.entry = {.count = 1, .reusable = false}}, SHIFT(602),
  [3860] = {.entry = {.count = 1, .reusable = false}}, SHIFT(603),
  [3862] = {.entry = {.count = 1, .reusable = false}}, SHIFT(612),
  [3864] = {.entry = {.count = 1, .reusable = false}}, SHIFT(320),
  [3866] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4629),
  [3868] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6646),
  [3870] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2374),
  [3872] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2561),
  [3874] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4628),
  [3876] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3927),
  [3878] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4071),
  [3880] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1543),
  [3882] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4218),
  [3884] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7015),
  [3886] = {.entry = {.count = 1, .reusable = false}}, SHIFT(908),
  [3888] = {.entry = {.count = 1, .reusable = false}}, SHIFT(912),
  [3890] = {.entry = {.count = 1, .reusable = false}}, SHIFT(927),
  [3892] = {.entry = {.count = 1, .reusable = false}}, SHIFT(928),
  [3894] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4173),
  [3896] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6769),
  [3898] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2387),
  [3900] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2382),
  [3902] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4169),
  [3904] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3893),
  [3906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8086),
  [3908] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8086),
  [3910] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6054),
  [3912] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4620),
  [3914] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4728),
  [3916] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6993),
  [3918] = {.entry = {.count = 1, .reusable = false}}, SHIFT(518),
  [3920] = {.entry = {.count = 1, .reusable = false}}, SHIFT(520),
  [3922] = {.entry = {.count = 1, .reusable = false}}, SHIFT(521),
  [3924] = {.entry = {.count = 1, .reusable = false}}, SHIFT(523),
  [3926] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4667),
  [3928] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6524),
  [3930] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2570),
  [3932] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2568),
  [3934] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4651),
  [3936] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3922),
  [3938] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4700),
  [3940] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5201),
  [3942] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7001),
  [3944] = {.entry = {.count = 1, .reusable = false}}, SHIFT(552),
  [3946] = {.entry = {.count = 1, .reusable = false}}, SHIFT(555),
  [3948] = {.entry = {.count = 1, .reusable = false}}, SHIFT(557),
  [3950] = {.entry = {.count = 1, .reusable = false}}, SHIFT(564),
  [3952] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5335),
  [3954] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6586),
  [3956] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2548),
  [3958] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2547),
  [3960] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5228),
  [3962] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3949),
  [3964] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4353),
  [3966] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5729),
  [3968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8142),
  [3970] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8142),
  [3972] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6169),
  [3974] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6875),
  [3976] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1015),
  [3978] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8681),
  [3980] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1058),
  [3982] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1112),
  [3984] = {.entry = {.count = 1, .reusable = false}}, SHIFT(826),
  [3986] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5772),
  [3988] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6648),
  [3990] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6123),
  [3992] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1618),
  [3994] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1536),
  [3996] = {.entry = {.count = 1, .reusable = false}}, SHIFT(61),
  [3998] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6267),
  [4000] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4001),
  [4002] = {.entry = {.count = 1, .reusable = false}}, SHIFT(30),
  [4004] = {.entry = {.count = 1, .reusable = false}}, SHIFT(15),
  [4006] = {.entry = {.count = 1, .reusable = false}}, SHIFT(58),
  [4008] = {.entry = {.count = 1, .reusable = false}}, SHIFT(22),
  [4010] = {.entry = {.count = 1, .reusable = false}}, SHIFT(47),
  [4012] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__lambda_clauses_repeat1, 2), SHIFT_REPEAT(5546),
  [4015] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__lambda_clauses_repeat1, 2), SHIFT_REPEAT(8490),
  [4018] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__lambda_clauses_repeat1, 2), SHIFT_REPEAT(2185),
  [4021] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__lambda_clauses_repeat1, 2), SHIFT_REPEAT(8081),
  [4024] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__lambda_clauses_repeat1, 2), SHIFT_REPEAT(8081),
  [4027] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__lambda_clauses_repeat1, 2), SHIFT_REPEAT(5981),
  [4030] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__lambda_clauses_repeat1, 2), SHIFT_REPEAT(6881),
  [4033] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__lambda_clauses_repeat1, 2), SHIFT_REPEAT(781),
  [4036] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__lambda_clauses_repeat1, 2), SHIFT_REPEAT(778),
  [4039] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__lambda_clauses_repeat1, 2), SHIFT_REPEAT(777),
  [4042] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__lambda_clauses_repeat1, 2), SHIFT_REPEAT(12483),
  [4045] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__lambda_clauses_repeat1, 2), SHIFT_REPEAT(776),
  [4048] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__lambda_clauses_repeat1, 2), SHIFT_REPEAT(5945),
  [4051] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__lambda_clauses_repeat1, 2), SHIFT_REPEAT(6720),
  [4054] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__lambda_clauses_repeat1, 2), SHIFT_REPEAT(12552),
  [4057] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__lambda_clauses_repeat1, 2), SHIFT_REPEAT(6241),
  [4060] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__lambda_clauses_repeat1, 2), SHIFT_REPEAT(2160),
  [4063] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__lambda_clauses_repeat1, 2), SHIFT_REPEAT(2161),
  [4066] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__lambda_clauses_repeat1, 2), SHIFT_REPEAT(81),
  [4069] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__lambda_clauses_repeat1, 2), SHIFT_REPEAT(12336),
  [4072] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__lambda_clauses_repeat1, 2), SHIFT_REPEAT(5971),
  [4075] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__lambda_clauses_repeat1, 2), SHIFT_REPEAT(3991),
  [4078] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8661),
  [4080] = {.entry = {.count = 1, .reusable = false}}, SHIFT(46),
  [4082] = {.entry = {.count = 1, .reusable = false}}, SHIFT(35),
  [4084] = {.entry = {.count = 1, .reusable = false}}, SHIFT(45),
  [4086] = {.entry = {.count = 1, .reusable = false}}, SHIFT(54),
  [4088] = {.entry = {.count = 1, .reusable = false}}, SHIFT(50),
  [4090] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14),
  [4092] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9177),
  [4094] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17),
  [4096] = {.entry = {.count = 1, .reusable = false}}, SHIFT(37),
  [4098] = {.entry = {.count = 1, .reusable = false}}, SHIFT(21),
  [4100] = {.entry = {.count = 1, .reusable = false}}, SHIFT(41),
  [4102] = {.entry = {.count = 1, .reusable = false}}, SHIFT(28),
  [4104] = {.entry = {.count = 1, .reusable = false}}, SHIFT(44),
  [4106] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19),
  [4108] = {.entry = {.count = 1, .reusable = false}}, SHIFT(34),
  [4110] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10),
  [4112] = {.entry = {.count = 1, .reusable = false}}, SHIFT(42),
  [4114] = {.entry = {.count = 1, .reusable = false}}, SHIFT(53),
  [4116] = {.entry = {.count = 1, .reusable = false}}, SHIFT(20),
  [4118] = {.entry = {.count = 1, .reusable = false}}, SHIFT(36),
  [4120] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11),
  [4122] = {.entry = {.count = 1, .reusable = false}}, SHIFT(16),
  [4124] = {.entry = {.count = 1, .reusable = false}}, SHIFT(59),
  [4126] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13),
  [4128] = {.entry = {.count = 1, .reusable = false}}, SHIFT(27),
  [4130] = {.entry = {.count = 1, .reusable = false}}, SHIFT(33),
  [4132] = {.entry = {.count = 1, .reusable = false}}, SHIFT(38),
  [4134] = {.entry = {.count = 1, .reusable = false}}, SHIFT(23),
  [4136] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9),
  [4138] = {.entry = {.count = 1, .reusable = false}}, SHIFT(32),
  [4140] = {.entry = {.count = 1, .reusable = false}}, SHIFT(24),
  [4142] = {.entry = {.count = 1, .reusable = false}}, SHIFT(48),
  [4144] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8),
  [4146] = {.entry = {.count = 1, .reusable = false}}, SHIFT(55),
  [4148] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18),
  [4150] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12),
  [4152] = {.entry = {.count = 1, .reusable = false}}, SHIFT(40),
  [4154] = {.entry = {.count = 1, .reusable = false}}, SHIFT(31),
  [4156] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6),
  [4158] = {.entry = {.count = 1, .reusable = false}}, SHIFT(49),
  [4160] = {.entry = {.count = 1, .reusable = false}}, SHIFT(29),
  [4162] = {.entry = {.count = 1, .reusable = false}}, SHIFT(43),
  [4164] = {.entry = {.count = 1, .reusable = false}}, SHIFT(57),
  [4166] = {.entry = {.count = 1, .reusable = false}}, SHIFT(25),
  [4168] = {.entry = {.count = 1, .reusable = false}}, SHIFT(26),
  [4170] = {.entry = {.count = 1, .reusable = false}}, SHIFT(39),
  [4172] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7),
  [4174] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5),
  [4176] = {.entry = {.count = 1, .reusable = false}}, SHIFT(52),
  [4178] = {.entry = {.count = 1, .reusable = false}}, SHIFT(60),
  [4180] = {.entry = {.count = 1, .reusable = false}}, SHIFT(51),
  [4182] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5745),
  [4184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8067),
  [4186] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8067),
  [4188] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6565),
  [4190] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6898),
  [4192] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1391),
  [4194] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1386),
  [4196] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1383),
  [4198] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1118),
  [4200] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6234),
  [4202] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6468),
  [4204] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6017),
  [4206] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2449),
  [4208] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2450),
  [4210] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6519),
  [4212] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4022),
  [4214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8047),
  [4216] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8047),
  [4218] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6306),
  [4220] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5938),
  [4222] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5837),
  [4224] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6066),
  [4226] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1907),
  [4228] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1089),
  [4230] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1088),
  [4232] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1086),
  [4234] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1085),
  [4236] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6733),
  [4238] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6899),
  [4240] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2),
  [4242] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2658),
  [4244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10176),
  [4246] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2079),
  [4248] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5604),
  [4250] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5976),
  [4252] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6870),
  [4254] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1048),
  [4256] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1047),
  [4258] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1046),
  [4260] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1045),
  [4262] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5978),
  [4264] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6369),
  [4266] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2009),
  [4268] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1983),
  [4270] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5973),
  [4272] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3975),
  [4274] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7049),
  [4276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10183),
  [4278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10157),
  [4280] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6906),
  [4282] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1495),
  [4284] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1783),
  [4286] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2596),
  [4288] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2479),
  [4290] = {.entry = {.count = 1, .reusable = false}}, SHIFT(921),
  [4292] = {.entry = {.count = 1, .reusable = false}}, SHIFT(929),
  [4294] = {.entry = {.count = 1, .reusable = false}}, SHIFT(932),
  [4296] = {.entry = {.count = 1, .reusable = false}}, SHIFT(934),
  [4298] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6614),
  [4300] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1578),
  [4302] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1481),
  [4304] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2071),
  [4306] = {.entry = {.count = 1, .reusable = false}}, SHIFT(652),
  [4308] = {.entry = {.count = 1, .reusable = false}}, SHIFT(648),
  [4310] = {.entry = {.count = 1, .reusable = false}}, SHIFT(645),
  [4312] = {.entry = {.count = 1, .reusable = false}}, SHIFT(642),
  [4314] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6662),
  [4316] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1586),
  [4318] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2292),
  [4320] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1020),
  [4322] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1025),
  [4324] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1026),
  [4326] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1029),
  [4328] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6711),
  [4330] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2297),
  [4332] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1890),
  [4334] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2282),
  [4336] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1234),
  [4338] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1235),
  [4340] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1238),
  [4342] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1239),
  [4344] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6754),
  [4346] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1545),
  [4348] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2632),
  [4350] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2169),
  [4352] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1732),
  [4354] = {.entry = {.count = 1, .reusable = false}}, SHIFT(872),
  [4356] = {.entry = {.count = 1, .reusable = false}}, SHIFT(874),
  [4358] = {.entry = {.count = 1, .reusable = false}}, SHIFT(875),
  [4360] = {.entry = {.count = 1, .reusable = false}}, SHIFT(876),
  [4362] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6741),
  [4364] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2064),
  [4366] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1667),
  [4368] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1357),
  [4370] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1358),
  [4372] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1359),
  [4374] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1360),
  [4376] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6625),
  [4378] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2469),
  [4380] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1514),
  [4382] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1815),
  [4384] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1706),
  [4386] = {.entry = {.count = 1, .reusable = false}}, SHIFT(733),
  [4388] = {.entry = {.count = 1, .reusable = false}}, SHIFT(735),
  [4390] = {.entry = {.count = 1, .reusable = false}}, SHIFT(738),
  [4392] = {.entry = {.count = 1, .reusable = false}}, SHIFT(740),
  [4394] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6651),
  [4396] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1011),
  [4398] = {.entry = {.count = 1, .reusable = false}}, SHIFT(973),
  [4400] = {.entry = {.count = 1, .reusable = false}}, SHIFT(972),
  [4402] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1384),
  [4404] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6351),
  [4406] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2331),
  [4408] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2598),
  [4410] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2445),
  [4412] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1083),
  [4414] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1084),
  [4416] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1095),
  [4418] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1096),
  [4420] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6483),
  [4422] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1986),
  [4424] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1395),
  [4426] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1394),
  [4428] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1366),
  [4430] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1198),
  [4432] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6702),
  [4434] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2143),
  [4436] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2204),
  [4438] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2152),
  [4440] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2199),
  [4442] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1734),
  [4444] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1322),
  [4446] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1325),
  [4448] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1326),
  [4450] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1327),
  [4452] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6664),
  [4454] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2376),
  [4456] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1533),
  [4458] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1413),
  [4460] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1937),
  [4462] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2139),
  [4464] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1071),
  [4466] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1072),
  [4468] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1073),
  [4470] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1075),
  [4472] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6490),
  [4474] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2461),
  [4476] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1765),
  [4478] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2280),
  [4480] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1590),
  [4482] = {.entry = {.count = 1, .reusable = false}}, SHIFT(752),
  [4484] = {.entry = {.count = 1, .reusable = false}}, SHIFT(753),
  [4486] = {.entry = {.count = 1, .reusable = false}}, SHIFT(754),
  [4488] = {.entry = {.count = 1, .reusable = false}}, SHIFT(755),
  [4490] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6663),
  [4492] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1976),
  [4494] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1461),
  [4496] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1828),
  [4498] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1673),
  [4500] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1557),
  [4502] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1697),
  [4504] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1518),
  [4506] = {.entry = {.count = 1, .reusable = false}}, SHIFT(906),
  [4508] = {.entry = {.count = 1, .reusable = false}}, SHIFT(916),
  [4510] = {.entry = {.count = 1, .reusable = false}}, SHIFT(923),
  [4512] = {.entry = {.count = 1, .reusable = false}}, SHIFT(925),
  [4514] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6600),
  [4516] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1471),
  [4518] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2259),
  [4520] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1736),
  [4522] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1831),
  [4524] = {.entry = {.count = 1, .reusable = false}}, SHIFT(894),
  [4526] = {.entry = {.count = 1, .reusable = false}}, SHIFT(890),
  [4528] = {.entry = {.count = 1, .reusable = false}}, SHIFT(889),
  [4530] = {.entry = {.count = 1, .reusable = false}}, SHIFT(763),
  [4532] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6529),
  [4534] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2434),
  [4536] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2347),
  [4538] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1646),
  [4540] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1081),
  [4542] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1063),
  [4544] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1056),
  [4546] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1382),
  [4548] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6661),
  [4550] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2380),
  [4552] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1226),
  [4554] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1227),
  [4556] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1229),
  [4558] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1232),
  [4560] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6757),
  [4562] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1870),
  [4564] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2120),
  [4566] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1540),
  [4568] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1479),
  [4570] = {.entry = {.count = 1, .reusable = false}}, SHIFT(746),
  [4572] = {.entry = {.count = 1, .reusable = false}}, SHIFT(744),
  [4574] = {.entry = {.count = 1, .reusable = false}}, SHIFT(743),
  [4576] = {.entry = {.count = 1, .reusable = false}}, SHIFT(742),
  [4578] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6706),
  [4580] = {.entry = {.count = 1, .reusable = false}}, SHIFT(729),
  [4582] = {.entry = {.count = 1, .reusable = false}}, SHIFT(731),
  [4584] = {.entry = {.count = 1, .reusable = false}}, SHIFT(732),
  [4586] = {.entry = {.count = 1, .reusable = false}}, SHIFT(734),
  [4588] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6633),
  [4590] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1769),
  [4592] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1537),
  [4594] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1339),
  [4596] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1340),
  [4598] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1361),
  [4600] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1362),
  [4602] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6438),
  [4604] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2156),
  [4606] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1255),
  [4608] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1256),
  [4610] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1257),
  [4612] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1258),
  [4614] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6743),
  [4616] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1812),
  [4618] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2586),
  [4620] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1108),
  [4622] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1109),
  [4624] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1111),
  [4626] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1113),
  [4628] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6455),
  [4630] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1665),
  [4632] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1807),
  [4634] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2470),
  [4636] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2263),
  [4638] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1681),
  [4640] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2448),
  [4642] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1669),
  [4644] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1470),
  [4646] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2029),
  [4648] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1714),
  [4650] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1979),
  [4652] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1598),
  [4654] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1967),
  [4656] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2328),
  [4658] = {.entry = {.count = 1, .reusable = false}}, SHIFT(940),
  [4660] = {.entry = {.count = 1, .reusable = false}}, SHIFT(944),
  [4662] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1030),
  [4664] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1041),
  [4666] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6367),
  [4668] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1482),
  [4670] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2611),
  [4672] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1948),
  [4674] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2326),
  [4676] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1653),
  [4678] = {.entry = {.count = 1, .reusable = false}}, SHIFT(865),
  [4680] = {.entry = {.count = 1, .reusable = false}}, SHIFT(867),
  [4682] = {.entry = {.count = 1, .reusable = false}}, SHIFT(869),
  [4684] = {.entry = {.count = 1, .reusable = false}}, SHIFT(870),
  [4686] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6735),
  [4688] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2151),
  [4690] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1848),
  [4692] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1814),
  [4694] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1314),
  [4696] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1316),
  [4698] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1317),
  [4700] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1319),
  [4702] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6671),
  [4704] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1475),
  [4706] = {.entry = {.count = 1, .reusable = false}}, SHIFT(782),
  [4708] = {.entry = {.count = 1, .reusable = false}}, SHIFT(787),
  [4710] = {.entry = {.count = 1, .reusable = false}}, SHIFT(788),
  [4712] = {.entry = {.count = 1, .reusable = false}}, SHIFT(790),
  [4714] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6677),
  [4716] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2027),
  [4718] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1611),
  [4720] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1642),
  [4722] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2613),
  [4724] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1165),
  [4726] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1169),
  [4728] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1171),
  [4730] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1173),
  [4732] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6568),
  [4734] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1917),
  [4736] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2398),
  [4738] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1181),
  [4740] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1204),
  [4742] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1231),
  [4744] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1244),
  [4746] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6332),
  [4748] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1892),
  [4750] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1302),
  [4752] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1303),
  [4754] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1305),
  [4756] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1306),
  [4758] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6681),
  [4760] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2066),
  [4762] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1269),
  [4764] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1270),
  [4766] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1271),
  [4768] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1272),
  [4770] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6717),
  [4772] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2486),
  [4774] = {.entry = {.count = 1, .reusable = false}}, SHIFT(635),
  [4776] = {.entry = {.count = 1, .reusable = false}}, SHIFT(913),
  [4778] = {.entry = {.count = 1, .reusable = false}}, SHIFT(625),
  [4780] = {.entry = {.count = 1, .reusable = false}}, SHIFT(623),
  [4782] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6349),
  [4784] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1731),
  [4786] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2467),
  [4788] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1215),
  [4790] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1217),
  [4792] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1218),
  [4794] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1219),
  [4796] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6762),
  [4798] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1459),
  [4800] = {.entry = {.count = 1, .reusable = false}}, SHIFT(803),
  [4802] = {.entry = {.count = 1, .reusable = false}}, SHIFT(807),
  [4804] = {.entry = {.count = 1, .reusable = false}}, SHIFT(808),
  [4806] = {.entry = {.count = 1, .reusable = false}}, SHIFT(809),
  [4808] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6698),
  [4810] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1623),
  [4812] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2538),
  [4814] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2540),
  [4816] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1189),
  [4818] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1201),
  [4820] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1207),
  [4822] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1208),
  [4824] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6771),
  [4826] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1610),
  [4828] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1671),
  [4830] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1368),
  [4832] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1354),
  [4834] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1323),
  [4836] = {.entry = {.count = 1, .reusable = false}}, SHIFT(963),
  [4838] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6445),
  [4840] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2657),
  [4842] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1274),
  [4844] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1393),
  [4846] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1273),
  [4848] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1253),
  [4850] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6336),
  [4852] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2171),
  [4854] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1031),
  [4856] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1018),
  [4858] = {.entry = {.count = 1, .reusable = false}}, SHIFT(884),
  [4860] = {.entry = {.count = 1, .reusable = false}}, SHIFT(615),
  [4862] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6472),
  [4864] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1805),
  [4866] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2616),
  [4868] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1947),
  [4870] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1809),
  [4872] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1057),
  [4874] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1060),
  [4876] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1061),
  [4878] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1062),
  [4880] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6508),
  [4882] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1982),
  [4884] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1282),
  [4886] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1289),
  [4888] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1294),
  [4890] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1295),
  [4892] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6700),
  [4894] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1931),
  [4896] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1538),
  [4898] = {.entry = {.count = 1, .reusable = false}}, SHIFT(832),
  [4900] = {.entry = {.count = 1, .reusable = false}}, SHIFT(833),
  [4902] = {.entry = {.count = 1, .reusable = false}}, SHIFT(835),
  [4904] = {.entry = {.count = 1, .reusable = false}}, SHIFT(837),
  [4906] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6712),
  [4908] = {.entry = {.count = 1, .reusable = false}}, SHIFT(911),
  [4910] = {.entry = {.count = 1, .reusable = false}}, SHIFT(914),
  [4912] = {.entry = {.count = 1, .reusable = false}}, SHIFT(917),
  [4914] = {.entry = {.count = 1, .reusable = false}}, SHIFT(774),
  [4916] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6413),
  [4918] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1599),
  [4920] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1427),
  [4922] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1835),
  [4924] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5682),
  [4926] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5899),
  [4928] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7040),
  [4930] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1114),
  [4932] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1115),
  [4934] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1117),
  [4936] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1119),
  [4938] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5806),
  [4940] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6450),
  [4942] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2174),
  [4944] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2173),
  [4946] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5865),
  [4948] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3988),
  [4950] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4087),
  [4952] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4254),
  [4954] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7011),
  [4956] = {.entry = {.count = 1, .reusable = false}}, SHIFT(877),
  [4958] = {.entry = {.count = 1, .reusable = false}}, SHIFT(880),
  [4960] = {.entry = {.count = 1, .reusable = false}}, SHIFT(881),
  [4962] = {.entry = {.count = 1, .reusable = false}}, SHIFT(882),
  [4964] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4152),
  [4966] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6747),
  [4968] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2411),
  [4970] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2408),
  [4972] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4217),
  [4974] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3886),
  [4976] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5834),
  [4978] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6161),
  [4980] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7023),
  [4982] = {.entry = {.count = 1, .reusable = false}}, SHIFT(996),
  [4984] = {.entry = {.count = 1, .reusable = false}}, SHIFT(997),
  [4986] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1001),
  [4988] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1004),
  [4990] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6164),
  [4992] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6691),
  [4994] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2329),
  [4996] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2322),
  [4998] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6160),
  [5000] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3997),
  [5002] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5642),
  [5004] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5804),
  [5006] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7064),
  [5008] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1348),
  [5010] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1349),
  [5012] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1350),
  [5014] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1351),
  [5016] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5993),
  [5018] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6638),
  [5020] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1898),
  [5022] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1889),
  [5024] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5902),
  [5026] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3976),
  [5028] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5074),
  [5030] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5405),
  [5032] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6971),
  [5034] = {.entry = {.count = 1, .reusable = false}}, SHIFT(879),
  [5036] = {.entry = {.count = 1, .reusable = false}}, SHIFT(878),
  [5038] = {.entry = {.count = 1, .reusable = false}}, SHIFT(840),
  [5040] = {.entry = {.count = 1, .reusable = false}}, SHIFT(839),
  [5042] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5379),
  [5044] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6554),
  [5046] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2608),
  [5048] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2614),
  [5050] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5389),
  [5052] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3960),
  [5054] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4375),
  [5056] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4455),
  [5058] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7109),
  [5060] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1307),
  [5062] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1310),
  [5064] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1312),
  [5066] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1313),
  [5068] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4462),
  [5070] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6678),
  [5072] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1929),
  [5074] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1924),
  [5076] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4436),
  [5078] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3909),
  [5080] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1644),
  [5082] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5268),
  [5084] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5587),
  [5086] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6883),
  [5088] = {.entry = {.count = 1, .reusable = false}}, SHIFT(719),
  [5090] = {.entry = {.count = 1, .reusable = false}}, SHIFT(715),
  [5092] = {.entry = {.count = 1, .reusable = false}}, SHIFT(712),
  [5094] = {.entry = {.count = 1, .reusable = false}}, SHIFT(709),
  [5096] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5541),
  [5098] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6674),
  [5100] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2192),
  [5102] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2193),
  [5104] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5545),
  [5106] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3964),
  [5108] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2246),
  [5110] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2283),
  [5112] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5995),
  [5114] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6007),
  [5116] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6867),
  [5118] = {.entry = {.count = 1, .reusable = false}}, SHIFT(618),
  [5120] = {.entry = {.count = 1, .reusable = false}}, SHIFT(617),
  [5122] = {.entry = {.count = 1, .reusable = false}}, SHIFT(616),
  [5124] = {.entry = {.count = 1, .reusable = false}}, SHIFT(968),
  [5126] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6190),
  [5128] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6316),
  [5130] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1579),
  [5132] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1582),
  [5134] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6024),
  [5136] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3995),
  [5138] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1620),
  [5140] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5484),
  [5142] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5795),
  [5144] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7002),
  [5146] = {.entry = {.count = 1, .reusable = false}}, SHIFT(792),
  [5148] = {.entry = {.count = 1, .reusable = false}}, SHIFT(793),
  [5150] = {.entry = {.count = 1, .reusable = false}}, SHIFT(794),
  [5152] = {.entry = {.count = 1, .reusable = false}}, SHIFT(795),
  [5154] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5913),
  [5156] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6686),
  [5158] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2535),
  [5160] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2531),
  [5162] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5846),
  [5164] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3983),
  [5166] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5577),
  [5168] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5926),
  [5170] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7019),
  [5172] = {.entry = {.count = 1, .reusable = false}}, SHIFT(951),
  [5174] = {.entry = {.count = 1, .reusable = false}}, SHIFT(953),
  [5176] = {.entry = {.count = 1, .reusable = false}}, SHIFT(955),
  [5178] = {.entry = {.count = 1, .reusable = false}}, SHIFT(957),
  [5180] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5957),
  [5182] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6784),
  [5184] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2366),
  [5186] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2365),
  [5188] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5961),
  [5190] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3979),
  [5192] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5403),
  [5194] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5736),
  [5196] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6987),
  [5198] = {.entry = {.count = 1, .reusable = false}}, SHIFT(666),
  [5200] = {.entry = {.count = 1, .reusable = false}}, SHIFT(669),
  [5202] = {.entry = {.count = 1, .reusable = false}}, SHIFT(673),
  [5204] = {.entry = {.count = 1, .reusable = false}}, SHIFT(677),
  [5206] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5844),
  [5208] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6619),
  [5210] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2640),
  [5212] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2604),
  [5214] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5753),
  [5216] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3980),
  [5218] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5815),
  [5220] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2154),
  [5222] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6188),
  [5224] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6973),
  [5226] = {.entry = {.count = 1, .reusable = false}}, SHIFT(802),
  [5228] = {.entry = {.count = 1, .reusable = false}}, SHIFT(805),
  [5230] = {.entry = {.count = 1, .reusable = false}}, SHIFT(806),
  [5232] = {.entry = {.count = 1, .reusable = false}}, SHIFT(811),
  [5234] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6110),
  [5236] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6751),
  [5238] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2353),
  [5240] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2369),
  [5242] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6159),
  [5244] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3992),
  [5246] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5289),
  [5248] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5472),
  [5250] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7039),
  [5252] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1098),
  [5254] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1099),
  [5256] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1100),
  [5258] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1103),
  [5260] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5438),
  [5262] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6479),
  [5264] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2176),
  [5266] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2175),
  [5268] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5446),
  [5270] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3969),
  [5272] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1621),
  [5274] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2295),
  [5276] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1684),
  [5278] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5432),
  [5280] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5778),
  [5282] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6999),
  [5284] = {.entry = {.count = 1, .reusable = false}}, SHIFT(765),
  [5286] = {.entry = {.count = 1, .reusable = false}}, SHIFT(767),
  [5288] = {.entry = {.count = 1, .reusable = false}}, SHIFT(768),
  [5290] = {.entry = {.count = 1, .reusable = false}}, SHIFT(769),
  [5292] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5876),
  [5294] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6666),
  [5296] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2559),
  [5298] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2557),
  [5300] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5796),
  [5302] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3981),
  [5304] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2135),
  [5306] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5628),
  [5308] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5853),
  [5310] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7062),
  [5312] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1352),
  [5314] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1353),
  [5316] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1355),
  [5318] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1356),
  [5320] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5968),
  [5322] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6628),
  [5324] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1888),
  [5326] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1886),
  [5328] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5908),
  [5330] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3978),
  [5332] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4431),
  [5334] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4840),
  [5336] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7098),
  [5338] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1296),
  [5340] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1297),
  [5342] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1300),
  [5344] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1301),
  [5346] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4856),
  [5348] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6683),
  [5350] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1942),
  [5352] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1940),
  [5354] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4869),
  [5356] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3925),
  [5358] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1757),
  [5360] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4915),
  [5362] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4980),
  [5364] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6960),
  [5366] = {.entry = {.count = 1, .reusable = false}}, SHIFT(622),
  [5368] = {.entry = {.count = 1, .reusable = false}}, SHIFT(646),
  [5370] = {.entry = {.count = 1, .reusable = false}}, SHIFT(683),
  [5372] = {.entry = {.count = 1, .reusable = false}}, SHIFT(710),
  [5374] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5005),
  [5376] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6364),
  [5378] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2497),
  [5380] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2502),
  [5382] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4925),
  [5384] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3944),
  [5386] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1845),
  [5388] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1549),
  [5390] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5946),
  [5392] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6060),
  [5394] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6897),
  [5396] = {.entry = {.count = 1, .reusable = false}}, SHIFT(728),
  [5398] = {.entry = {.count = 1, .reusable = false}}, SHIFT(784),
  [5400] = {.entry = {.count = 1, .reusable = false}}, SHIFT(785),
  [5402] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1265),
  [5404] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6282),
  [5406] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6564),
  [5408] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2429),
  [5410] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2435),
  [5412] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6101),
  [5414] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4006),
  [5416] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5144),
  [5418] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5364),
  [5420] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6979),
  [5422] = {.entry = {.count = 1, .reusable = false}}, SHIFT(631),
  [5424] = {.entry = {.count = 1, .reusable = false}}, SHIFT(634),
  [5426] = {.entry = {.count = 1, .reusable = false}}, SHIFT(637),
  [5428] = {.entry = {.count = 1, .reusable = false}}, SHIFT(641),
  [5430] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5418),
  [5432] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6601),
  [5434] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2647),
  [5436] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2648),
  [5438] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5374),
  [5440] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3954),
  [5442] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5251),
  [5444] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5635),
  [5446] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6856),
  [5448] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1077),
  [5450] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1078),
  [5452] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1079),
  [5454] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1080),
  [5456] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5686),
  [5458] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6485),
  [5460] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2183),
  [5462] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2180),
  [5464] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5684),
  [5466] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3972),
  [5468] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4275),
  [5470] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4527),
  [5472] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7018),
  [5474] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1196),
  [5476] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1193),
  [5478] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1192),
  [5480] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1191),
  [5482] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4601),
  [5484] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6682),
  [5486] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1993),
  [5488] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1995),
  [5490] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4567),
  [5492] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3911),
  [5494] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5980),
  [5496] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6050),
  [5498] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7021),
  [5500] = {.entry = {.count = 1, .reusable = false}}, SHIFT(969),
  [5502] = {.entry = {.count = 1, .reusable = false}}, SHIFT(970),
  [5504] = {.entry = {.count = 1, .reusable = false}}, SHIFT(971),
  [5506] = {.entry = {.count = 1, .reusable = false}}, SHIFT(975),
  [5508] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6070),
  [5510] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6783),
  [5512] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2355),
  [5514] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2339),
  [5516] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6016),
  [5518] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4000),
  [5520] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2421),
  [5522] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4683),
  [5524] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5319),
  [5526] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7038),
  [5528] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1064),
  [5530] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1065),
  [5532] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1068),
  [5534] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1070),
  [5536] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5194),
  [5538] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6499),
  [5540] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2218),
  [5542] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2184),
  [5544] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5302),
  [5546] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3951),
  [5548] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5947),
  [5550] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6059),
  [5552] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6890),
  [5554] = {.entry = {.count = 1, .reusable = false}}, SHIFT(984),
  [5556] = {.entry = {.count = 1, .reusable = false}}, SHIFT(988),
  [5558] = {.entry = {.count = 1, .reusable = false}}, SHIFT(994),
  [5560] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1002),
  [5562] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6091),
  [5564] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6570),
  [5566] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2219),
  [5568] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2245),
  [5570] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6056),
  [5572] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4007),
  [5574] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4161),
  [5576] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4307),
  [5578] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7086),
  [5580] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1328),
  [5582] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1334),
  [5584] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1341),
  [5586] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1342),
  [5588] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4256),
  [5590] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6660),
  [5592] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1919),
  [5594] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1912),
  [5596] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4361),
  [5598] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3897),
  [5600] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5685),
  [5602] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5937),
  [5604] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5750),
  [5606] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6214),
  [5608] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7084),
  [5610] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1184),
  [5612] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1186),
  [5614] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1187),
  [5616] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1188),
  [5618] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6225),
  [5620] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6777),
  [5622] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2008),
  [5624] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2006),
  [5626] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6247),
  [5628] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4002),
  [5630] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4986),
  [5632] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5727),
  [5634] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7096),
  [5636] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1277),
  [5638] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1279),
  [5640] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1280),
  [5642] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1281),
  [5644] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5641),
  [5646] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6713),
  [5648] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1968),
  [5650] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1946),
  [5652] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5711),
  [5654] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3963),
  [5656] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5885),
  [5658] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6053),
  [5660] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7110),
  [5662] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1387),
  [5664] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1388),
  [5666] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1389),
  [5668] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1390),
  [5670] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6018),
  [5672] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6496),
  [5674] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1762),
  [5676] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1758),
  [5678] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6068),
  [5680] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4005),
  [5682] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5471),
  [5684] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5925),
  [5686] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6991),
  [5688] = {.entry = {.count = 1, .reusable = false}}, SHIFT(694),
  [5690] = {.entry = {.count = 1, .reusable = false}}, SHIFT(700),
  [5692] = {.entry = {.count = 1, .reusable = false}}, SHIFT(706),
  [5694] = {.entry = {.count = 1, .reusable = false}}, SHIFT(708),
  [5696] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5832),
  [5698] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6631),
  [5700] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2584),
  [5702] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2583),
  [5704] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5874),
  [5706] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3984),
  [5708] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5349),
  [5710] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5550),
  [5712] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7024),
  [5714] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1008),
  [5716] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1009),
  [5718] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1012),
  [5720] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1014),
  [5722] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5633),
  [5724] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6623),
  [5726] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2318),
  [5728] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2291),
  [5730] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5589),
  [5732] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3968),
  [5734] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5420),
  [5736] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5752),
  [5738] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6995),
  [5740] = {.entry = {.count = 1, .reusable = false}}, SHIFT(747),
  [5742] = {.entry = {.count = 1, .reusable = false}}, SHIFT(748),
  [5744] = {.entry = {.count = 1, .reusable = false}}, SHIFT(750),
  [5746] = {.entry = {.count = 1, .reusable = false}}, SHIFT(751),
  [5748] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5873),
  [5750] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6657),
  [5752] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2563),
  [5754] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2639),
  [5756] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5793),
  [5758] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3989),
  [5760] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5547),
  [5762] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5965),
  [5764] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7089),
  [5766] = {.entry = {.count = 1, .reusable = false}}, SHIFT(761),
  [5768] = {.entry = {.count = 1, .reusable = false}}, SHIFT(758),
  [5770] = {.entry = {.count = 1, .reusable = false}}, SHIFT(801),
  [5772] = {.entry = {.count = 1, .reusable = false}}, SHIFT(834),
  [5774] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5917),
  [5776] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6361),
  [5778] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1501),
  [5780] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1490),
  [5782] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5994),
  [5784] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3985),
  [5786] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1774),
  [5788] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4678),
  [5790] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5235),
  [5792] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6885),
  [5794] = {.entry = {.count = 1, .reusable = false}}, SHIFT(619),
  [5796] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1005),
  [5798] = {.entry = {.count = 1, .reusable = false}}, SHIFT(630),
  [5800] = {.entry = {.count = 1, .reusable = false}}, SHIFT(632),
  [5802] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5187),
  [5804] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6630),
  [5806] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2202),
  [5808] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2205),
  [5810] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5273),
  [5812] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3938),
  [5814] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4439),
  [5816] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4868),
  [5818] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7012),
  [5820] = {.entry = {.count = 1, .reusable = false}}, SHIFT(910),
  [5822] = {.entry = {.count = 1, .reusable = false}}, SHIFT(902),
  [5824] = {.entry = {.count = 1, .reusable = false}}, SHIFT(901),
  [5826] = {.entry = {.count = 1, .reusable = false}}, SHIFT(990),
  [5828] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4907),
  [5830] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6387),
  [5832] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1605),
  [5834] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1606),
  [5836] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4899),
  [5838] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3915),
  [5840] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1846),
  [5842] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1910),
  [5844] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1858),
  [5846] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5912),
  [5848] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6100),
  [5850] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6949),
  [5852] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1205),
  [5854] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1183),
  [5856] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1172),
  [5858] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1321),
  [5860] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6255),
  [5862] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6577),
  [5864] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1823),
  [5866] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1777),
  [5868] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6229),
  [5870] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3999),
  [5872] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4474),
  [5874] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4785),
  [5876] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7088),
  [5878] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1220),
  [5880] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1221),
  [5882] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1223),
  [5884] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1224),
  [5886] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4890),
  [5888] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6759),
  [5890] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2001),
  [5892] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1999),
  [5894] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4814),
  [5896] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3916),
  [5898] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5970),
  [5900] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6089),
  [5902] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7103),
  [5904] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1007),
  [5906] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1010),
  [5908] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1016),
  [5910] = {.entry = {.count = 1, .reusable = false}}, SHIFT(920),
  [5912] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6147),
  [5914] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6454),
  [5916] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1913),
  [5918] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1914),
  [5920] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6015),
  [5922] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3996),
  [5924] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2587),
  [5926] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5331),
  [5928] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5454),
  [5930] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7007),
  [5932] = {.entry = {.count = 1, .reusable = false}}, SHIFT(841),
  [5934] = {.entry = {.count = 1, .reusable = false}}, SHIFT(843),
  [5936] = {.entry = {.count = 1, .reusable = false}}, SHIFT(845),
  [5938] = {.entry = {.count = 1, .reusable = false}}, SHIFT(846),
  [5940] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5543),
  [5942] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6727),
  [5944] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2443),
  [5946] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2441),
  [5948] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5487),
  [5950] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3955),
  [5952] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5907),
  [5954] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6217),
  [5956] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7087),
  [5958] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1343),
  [5960] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1344),
  [5962] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1345),
  [5964] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1347),
  [5966] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6014),
  [5968] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6659),
  [5970] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1909),
  [5972] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1906),
  [5974] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6109),
  [5976] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3998),
  [5978] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5716),
  [5980] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5767),
  [5982] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7091),
  [5984] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1259),
  [5986] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1260),
  [5988] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1261),
  [5990] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1262),
  [5992] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5884),
  [5994] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6724),
  [5996] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1990),
  [5998] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1989),
  [6000] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5878),
  [6002] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3986),
  [6004] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2406),
  [6006] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4432),
  [6008] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4870),
  [6010] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6962),
  [6012] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1200),
  [6014] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1213),
  [6016] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1236),
  [6018] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1247),
  [6020] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4842),
  [6022] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6381),
  [6024] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2506),
  [6026] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2514),
  [6028] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4894),
  [6030] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3921),
  [6032] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5509),
  [6034] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5914),
  [6036] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6948),
  [6038] = {.entry = {.count = 1, .reusable = false}}, SHIFT(789),
  [6040] = {.entry = {.count = 1, .reusable = false}}, SHIFT(760),
  [6042] = {.entry = {.count = 1, .reusable = false}}, SHIFT(633),
  [6044] = {.entry = {.count = 1, .reusable = false}}, SHIFT(726),
  [6046] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5839),
  [6048] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6318),
  [6050] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2478),
  [6052] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2480),
  [6054] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5881),
  [6056] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3990),
  [6058] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4249),
  [6060] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4349),
  [6062] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6969),
  [6064] = {.entry = {.count = 1, .reusable = false}}, SHIFT(967),
  [6066] = {.entry = {.count = 1, .reusable = false}}, SHIFT(966),
  [6068] = {.entry = {.count = 1, .reusable = false}}, SHIFT(952),
  [6070] = {.entry = {.count = 1, .reusable = false}}, SHIFT(949),
  [6072] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4407),
  [6074] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6493),
  [6076] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2593),
  [6078] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2594),
  [6080] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4309),
  [6082] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3896),
  [6084] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1487),
  [6086] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4274),
  [6088] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4523),
  [6090] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7090),
  [6092] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1240),
  [6094] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1248),
  [6096] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1252),
  [6098] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1254),
  [6100] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4430),
  [6102] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6750),
  [6104] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1998),
  [6106] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1992),
  [6108] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4494),
  [6110] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3904),
  [6112] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5486),
  [6114] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5817),
  [6116] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7003),
  [6118] = {.entry = {.count = 1, .reusable = false}}, SHIFT(810),
  [6120] = {.entry = {.count = 1, .reusable = false}}, SHIFT(812),
  [6122] = {.entry = {.count = 1, .reusable = false}}, SHIFT(813),
  [6124] = {.entry = {.count = 1, .reusable = false}}, SHIFT(814),
  [6126] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5915),
  [6128] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6707),
  [6130] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2521),
  [6132] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2520),
  [6134] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5858),
  [6136] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3977),
  [6138] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4817),
  [6140] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5134),
  [6142] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7029),
  [6144] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1209),
  [6146] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1210),
  [6148] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1212),
  [6150] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1214),
  [6152] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5004),
  [6154] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6768),
  [6156] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2005),
  [6158] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2004),
  [6160] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5073),
  [6162] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3934),
  [6164] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1484),
  [6166] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4836),
  [6168] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4966),
  [6170] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7059),
  [6172] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1363),
  [6174] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1365),
  [6176] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1367),
  [6178] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1369),
  [6180] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5106),
  [6182] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6620),
  [6184] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1902),
  [6186] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1851),
  [6188] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4991),
  [6190] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3933),
  [6192] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1419),
  [6194] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2200),
  [6196] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2115),
  [6198] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5075),
  [6200] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5697),
  [6202] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7074),
  [6204] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1176),
  [6206] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1177),
  [6208] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1178),
  [6210] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1179),
  [6212] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5715),
  [6214] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6602),
  [6216] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2016),
  [6218] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2011),
  [6220] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5714),
  [6222] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3973),
  [6224] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_SetN, 1),
  [6226] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_SetN, 1),
  [6228] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6023),
  [6230] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6766),
  [6232] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6021),
  [6234] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6667),
  [6236] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(5864),
  [6239] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__atoms, 2),
  [6241] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__atoms, 2),
  [6243] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(6162),
  [6246] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(6988),
  [6249] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(1136),
  [6252] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(1137),
  [6255] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(1138),
  [6258] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(1141),
  [6261] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(6057),
  [6264] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(6444),
  [6267] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(2272),
  [6270] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(2266),
  [6273] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(6115),
  [6276] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(4008),
  [6279] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(6119),
  [6282] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(6549),
  [6285] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(6549),
  [6288] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(6953),
  [6291] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(701),
  [6294] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(699),
  [6297] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(698),
  [6300] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(696),
  [6303] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(6424),
  [6306] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(6338),
  [6309] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(2483),
  [6312] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(2484),
  [6315] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(6509),
  [6318] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(6509),
  [6321] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(4013),
  [6324] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__qid, 1, .production_id = 1),
  [6326] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__qid, 1, .production_id = 1),
  [6328] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6409),
  [6330] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6119),
  [6332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6549),
  [6334] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6549),
  [6336] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__expr2_without_let, 2),
  [6338] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6953),
  [6340] = {.entry = {.count = 1, .reusable = false}}, SHIFT(701),
  [6342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(699),
  [6344] = {.entry = {.count = 1, .reusable = false}}, SHIFT(698),
  [6346] = {.entry = {.count = 1, .reusable = false}}, SHIFT(696),
  [6348] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6424),
  [6350] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6338),
  [6352] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3361),
  [6354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2483),
  [6356] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2484),
  [6358] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6509),
  [6360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6509),
  [6362] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4013),
  [6364] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__expr2_without_let, 2),
  [6366] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(6266),
  [6369] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(6407),
  [6372] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(6970),
  [6375] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(943),
  [6378] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(938),
  [6381] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(937),
  [6384] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(935),
  [6387] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(6321),
  [6390] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(6521),
  [6393] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(2482),
  [6396] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(2607),
  [6399] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(6357),
  [6402] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(4023),
  [6405] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5864),
  [6407] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6162),
  [6409] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6988),
  [6411] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1136),
  [6413] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1137),
  [6415] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1138),
  [6417] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1141),
  [6419] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6057),
  [6421] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6444),
  [6423] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2272),
  [6425] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2266),
  [6427] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6115),
  [6429] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4008),
  [6431] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__atom_curly, 2),
  [6433] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__atom_curly, 2),
  [6435] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6642),
  [6437] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(6494),
  [6440] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(6851),
  [6443] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(6851),
  [6446] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7067),
  [6449] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(1158),
  [6452] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(1160),
  [6455] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(1161),
  [6458] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(1162),
  [6461] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(6819),
  [6464] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(6501),
  [6467] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(2030),
  [6470] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(2186),
  [6473] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(6836),
  [6476] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(6836),
  [6479] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(4042),
  [6482] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__atom_no_curly, 1),
  [6484] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__atom_no_curly, 1),
  [6486] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__atoms, 1),
  [6488] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__atoms, 1),
  [6490] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__expr2_without_let, 1),
  [6492] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__expr2_without_let, 1),
  [6494] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__expr_or_attr, 3),
  [6496] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__expr_or_attr, 3),
  [6498] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_assignments, 5),
  [6500] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_assignments, 5),
  [6502] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6494),
  [6504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6851),
  [6506] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6851),
  [6508] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7067),
  [6510] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1158),
  [6512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1160),
  [6514] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1161),
  [6516] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1162),
  [6518] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6819),
  [6520] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6501),
  [6522] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3503),
  [6524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2030),
  [6526] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2186),
  [6528] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6836),
  [6530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6836),
  [6532] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4042),
  [6534] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6480),
  [6536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6796),
  [6538] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6796),
  [6540] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6876),
  [6542] = {.entry = {.count = 1, .reusable = false}}, SHIFT(822),
  [6544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(819),
  [6546] = {.entry = {.count = 1, .reusable = false}}, SHIFT(818),
  [6548] = {.entry = {.count = 1, .reusable = false}}, SHIFT(815),
  [6550] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6798),
  [6552] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6778),
  [6554] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3648),
  [6556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2096),
  [6558] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2101),
  [6560] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6833),
  [6562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6833),
  [6564] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4051),
  [6566] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_assignments, 4),
  [6568] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_assignments, 4),
  [6570] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_assignments, 4),
  [6572] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_assignments, 4),
  [6574] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(6622),
  [6577] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(6809),
  [6580] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(6809),
  [6583] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(6886),
  [6586] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(692),
  [6589] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(725),
  [6592] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(749),
  [6595] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(1168),
  [6598] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(6822),
  [6601] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(6772),
  [6604] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(2268),
  [6607] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(1613),
  [6610] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(6818),
  [6613] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(6818),
  [6616] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(4048),
  [6619] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6266),
  [6621] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6407),
  [6623] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6970),
  [6625] = {.entry = {.count = 1, .reusable = false}}, SHIFT(943),
  [6627] = {.entry = {.count = 1, .reusable = false}}, SHIFT(938),
  [6629] = {.entry = {.count = 1, .reusable = false}}, SHIFT(937),
  [6631] = {.entry = {.count = 1, .reusable = false}}, SHIFT(935),
  [6633] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6321),
  [6635] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6521),
  [6637] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2482),
  [6639] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2607),
  [6641] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6357),
  [6643] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4023),
  [6645] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__atom_curly, 3),
  [6647] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__atom_curly, 3),
  [6649] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__atom_no_curly, 3),
  [6651] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__atom_no_curly, 3),
  [6653] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_literal, 1),
  [6655] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_literal, 1),
  [6657] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6435),
  [6659] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6760),
  [6661] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(6480),
  [6664] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(6796),
  [6667] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(6796),
  [6670] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(6876),
  [6673] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(822),
  [6676] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(819),
  [6679] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(818),
  [6682] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(815),
  [6685] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(6798),
  [6688] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(6778),
  [6691] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(2096),
  [6694] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(2101),
  [6697] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(6833),
  [6700] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(6833),
  [6703] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(4051),
  [6706] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6753),
  [6708] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_atom, 1),
  [6710] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_atom, 1),
  [6712] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_SetN, 2),
  [6714] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_SetN, 2),
  [6716] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6622),
  [6718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6809),
  [6720] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6809),
  [6722] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6886),
  [6724] = {.entry = {.count = 1, .reusable = false}}, SHIFT(692),
  [6726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(725),
  [6728] = {.entry = {.count = 1, .reusable = false}}, SHIFT(749),
  [6730] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1168),
  [6732] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6822),
  [6734] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6772),
  [6736] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3703),
  [6738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2268),
  [6740] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1613),
  [6742] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6818),
  [6744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6818),
  [6746] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4048),
  [6748] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__atom_no_curly, 2),
  [6750] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__atom_no_curly, 2),
  [6752] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_assignments, 3),
  [6754] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_assignments, 3),
  [6756] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__with_exprs_repeat1, 2), SHIFT_REPEAT(7824),
  [6759] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__with_exprs_repeat1, 2),
  [6761] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__with_exprs_repeat1, 2),
  [6763] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__with_exprs_repeat1, 2), SHIFT_REPEAT(7830),
  [6766] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__with_exprs_repeat1, 2), SHIFT_REPEAT(7053),
  [6769] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__with_exprs_repeat1, 2), SHIFT_REPEAT(674),
  [6772] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__with_exprs_repeat1, 2), SHIFT_REPEAT(667),
  [6775] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__with_exprs_repeat1, 2), SHIFT_REPEAT(664),
  [6778] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__with_exprs_repeat1, 2), SHIFT_REPEAT(798),
  [6781] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__with_exprs_repeat1, 2), SHIFT_REPEAT(7839),
  [6784] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__with_exprs_repeat1, 2), SHIFT_REPEAT(6511),
  [6787] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__with_exprs_repeat1, 2), SHIFT_REPEAT(1878),
  [6790] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__with_exprs_repeat1, 2), SHIFT_REPEAT(1887),
  [6793] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__with_exprs_repeat1, 2), SHIFT_REPEAT(7832),
  [6796] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__with_exprs_repeat1, 2), SHIFT_REPEAT(6131),
  [6799] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(6495),
  [6802] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(6826),
  [6805] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7016),
  [6808] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(821),
  [6811] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(817),
  [6814] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(816),
  [6817] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(891),
  [6820] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(6854),
  [6823] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(6449),
  [6826] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(1702),
  [6829] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(1707),
  [6832] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(6839),
  [6835] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(4059),
  [6838] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6487),
  [6840] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6848),
  [6842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7066),
  [6844] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7066),
  [6846] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6963),
  [6848] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1291),
  [6850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1292),
  [6852] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1311),
  [6854] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1315),
  [6856] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6903),
  [6858] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6405),
  [6860] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3486),
  [6862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2541),
  [6864] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2542),
  [6866] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7104),
  [6868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7104),
  [6870] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4251),
  [6872] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7132),
  [6874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7256),
  [6876] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7256),
  [6878] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6983),
  [6880] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9150),
  [6882] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12564),
  [6884] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1287),
  [6886] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12492),
  [6888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1286),
  [6890] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1285),
  [6892] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1284),
  [6894] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7257),
  [6896] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6604),
  [6898] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_open, 2),
  [6900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1401),
  [6902] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1465),
  [6904] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7211),
  [6906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7211),
  [6908] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4554),
  [6910] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_open, 2),
  [6912] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7115),
  [6914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7266),
  [6916] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7266),
  [6918] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7058),
  [6920] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9087),
  [6922] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10676),
  [6924] = {.entry = {.count = 1, .reusable = false}}, SHIFT(650),
  [6926] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10675),
  [6928] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module_assignment, 2),
  [6930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(657),
  [6932] = {.entry = {.count = 1, .reusable = false}}, SHIFT(661),
  [6934] = {.entry = {.count = 1, .reusable = false}}, SHIFT(662),
  [6936] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_assignment, 2),
  [6938] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7183),
  [6940] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6573),
  [6942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2167),
  [6944] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2168),
  [6946] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7246),
  [6948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7246),
  [6950] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4420),
  [6952] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6495),
  [6954] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6826),
  [6956] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7016),
  [6958] = {.entry = {.count = 1, .reusable = false}}, SHIFT(821),
  [6960] = {.entry = {.count = 1, .reusable = false}}, SHIFT(817),
  [6962] = {.entry = {.count = 1, .reusable = false}}, SHIFT(816),
  [6964] = {.entry = {.count = 1, .reusable = false}}, SHIFT(891),
  [6966] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6854),
  [6968] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6449),
  [6970] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1702),
  [6972] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1707),
  [6974] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6839),
  [6976] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4059),
  [6978] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(6848),
  [6981] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7066),
  [6984] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7066),
  [6987] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(6963),
  [6990] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(1291),
  [6993] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(1292),
  [6996] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(1311),
  [6999] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(1315),
  [7002] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(6903),
  [7005] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(6405),
  [7008] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(2541),
  [7011] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(2542),
  [7014] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7104),
  [7017] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7104),
  [7020] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(4251),
  [7023] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module_assignment, 1),
  [7025] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_assignment, 1),
  [7027] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6838),
  [7029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6933),
  [7031] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6933),
  [7033] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7030),
  [7035] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1042),
  [7037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1043),
  [7039] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1044),
  [7041] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1051),
  [7043] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6895),
  [7045] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6585),
  [7047] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3658),
  [7049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2373),
  [7051] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2217),
  [7053] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7081),
  [7055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7081),
  [7057] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4124),
  [7059] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_open, 3),
  [7061] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_open, 3),
  [7063] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6643),
  [7065] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6802),
  [7067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6945),
  [7069] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6945),
  [7071] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7037),
  [7073] = {.entry = {.count = 1, .reusable = false}}, SHIFT(896),
  [7075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(897),
  [7077] = {.entry = {.count = 1, .reusable = false}}, SHIFT(898),
  [7079] = {.entry = {.count = 1, .reusable = false}}, SHIFT(659),
  [7081] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6887),
  [7083] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6626),
  [7085] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3432),
  [7087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2107),
  [7089] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2108),
  [7091] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6920),
  [7093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6920),
  [7095] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4242),
  [7097] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6627),
  [7099] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6837),
  [7101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6865),
  [7103] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6865),
  [7105] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7047),
  [7107] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1153),
  [7109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1155),
  [7111] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1156),
  [7113] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1157),
  [7115] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7041),
  [7117] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6421),
  [7119] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3371),
  [7121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2063),
  [7123] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2061),
  [7125] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7054),
  [7127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7054),
  [7129] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4208),
  [7131] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(6838),
  [7134] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(6933),
  [7137] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(6933),
  [7140] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7030),
  [7143] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(1042),
  [7146] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(1043),
  [7149] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(1044),
  [7152] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(1051),
  [7155] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(6895),
  [7158] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(6585),
  [7161] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(2373),
  [7164] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(2217),
  [7167] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7081),
  [7170] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7081),
  [7173] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(4124),
  [7176] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6584),
  [7178] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(6837),
  [7181] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(6865),
  [7184] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(6865),
  [7187] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7047),
  [7190] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(1153),
  [7193] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(1155),
  [7196] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(1156),
  [7199] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(1157),
  [7202] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7041),
  [7205] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(6421),
  [7208] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(2063),
  [7211] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(2061),
  [7214] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7054),
  [7217] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7054),
  [7220] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(4208),
  [7223] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(6852),
  [7226] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7094),
  [7229] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(6966),
  [7232] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(1163),
  [7235] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(1147),
  [7238] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(1146),
  [7241] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(1128),
  [7244] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(6797),
  [7247] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(6422),
  [7250] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(2573),
  [7253] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(2574),
  [7256] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(6801),
  [7259] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(4179),
  [7262] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6615),
  [7264] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6616),
  [7266] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6461),
  [7268] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(6802),
  [7271] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(6945),
  [7274] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(6945),
  [7277] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7037),
  [7280] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(896),
  [7283] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(897),
  [7286] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(898),
  [7289] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(659),
  [7292] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(6887),
  [7295] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(6626),
  [7298] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(2107),
  [7301] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(2108),
  [7304] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(6920),
  [7307] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(6920),
  [7310] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(4242),
  [7313] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6598),
  [7315] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6418),
  [7317] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6329),
  [7319] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7048),
  [7322] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7161),
  [7325] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7161),
  [7328] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7045),
  [7331] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(1134),
  [7334] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(1144),
  [7337] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(1148),
  [7340] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(1150),
  [7343] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7121),
  [7346] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(6432),
  [7349] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(2098),
  [7352] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(2092),
  [7355] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7137),
  [7358] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7137),
  [7361] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(4277),
  [7364] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6944),
  [7366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7144),
  [7368] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7144),
  [7370] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6889),
  [7372] = {.entry = {.count = 1, .reusable = false}}, SHIFT(688),
  [7374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(690),
  [7376] = {.entry = {.count = 1, .reusable = false}}, SHIFT(628),
  [7378] = {.entry = {.count = 1, .reusable = false}}, SHIFT(714),
  [7380] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7134),
  [7382] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6618),
  [7384] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3621),
  [7386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2207),
  [7388] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2210),
  [7390] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7140),
  [7392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7140),
  [7394] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4297),
  [7396] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7048),
  [7398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7161),
  [7400] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7161),
  [7402] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7045),
  [7404] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1134),
  [7406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1144),
  [7408] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1148),
  [7410] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1150),
  [7412] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7121),
  [7414] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6432),
  [7416] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3456),
  [7418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2098),
  [7420] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2092),
  [7422] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7137),
  [7424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7137),
  [7426] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4277),
  [7428] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6703),
  [7430] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6739),
  [7432] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7052),
  [7434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7173),
  [7436] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7173),
  [7438] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7027),
  [7440] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1028),
  [7442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1035),
  [7444] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1039),
  [7446] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1040),
  [7448] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7114),
  [7450] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6606),
  [7452] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3587),
  [7454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2236),
  [7456] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2235),
  [7458] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7141),
  [7460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7141),
  [7462] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4315),
  [7464] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7097),
  [7467] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7130),
  [7470] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7130),
  [7473] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(6961),
  [7476] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(857),
  [7479] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(888),
  [7482] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(905),
  [7485] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(1206),
  [7488] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7139),
  [7491] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(6374),
  [7494] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(2504),
  [7497] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(2505),
  [7500] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7117),
  [7503] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7117),
  [7506] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(4308),
  [7509] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6852),
  [7511] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7094),
  [7513] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6966),
  [7515] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1163),
  [7517] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1147),
  [7519] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1146),
  [7521] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1128),
  [7523] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6797),
  [7525] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6422),
  [7527] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2573),
  [7529] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2574),
  [7531] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6801),
  [7533] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4179),
  [7535] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7097),
  [7537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7130),
  [7539] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7130),
  [7541] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6961),
  [7543] = {.entry = {.count = 1, .reusable = false}}, SHIFT(857),
  [7545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(888),
  [7547] = {.entry = {.count = 1, .reusable = false}}, SHIFT(905),
  [7549] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1206),
  [7551] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7139),
  [7553] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6374),
  [7555] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3633),
  [7557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2504),
  [7559] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2505),
  [7561] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7117),
  [7563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7117),
  [7565] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4308),
  [7567] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(6944),
  [7570] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7144),
  [7573] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7144),
  [7576] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(6889),
  [7579] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(688),
  [7582] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(690),
  [7585] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(628),
  [7588] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(714),
  [7591] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7134),
  [7594] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(6618),
  [7597] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(2207),
  [7600] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(2210),
  [7603] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7140),
  [7606] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7140),
  [7609] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(4297),
  [7612] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6780),
  [7614] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7052),
  [7617] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7173),
  [7620] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7173),
  [7623] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7027),
  [7626] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(1028),
  [7629] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(1035),
  [7632] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(1039),
  [7635] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(1040),
  [7638] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7114),
  [7641] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(6606),
  [7644] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(2236),
  [7647] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(2235),
  [7650] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7141),
  [7653] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7141),
  [7656] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(4315),
  [7659] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6370),
  [7661] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6375),
  [7663] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7207),
  [7665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7291),
  [7667] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7291),
  [7669] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6952),
  [7671] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1299),
  [7673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1304),
  [7675] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1308),
  [7677] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1180),
  [7679] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7413),
  [7681] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6411),
  [7683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2436),
  [7685] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2432),
  [7687] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7366),
  [7689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7366),
  [7691] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4745),
  [7693] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7259),
  [7695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7461),
  [7697] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7461),
  [7699] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6892),
  [7701] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1069),
  [7703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1082),
  [7705] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1090),
  [7707] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1091),
  [7709] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7433),
  [7711] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6553),
  [7713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2254),
  [7715] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2255),
  [7717] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7421),
  [7719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7421),
  [7721] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4740),
  [7723] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6320),
  [7725] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module_application, 1),
  [7727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(850),
  [7729] = {.entry = {.count = 1, .reusable = false}}, SHIFT(852),
  [7731] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_application, 1),
  [7733] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module_application, 2),
  [7735] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_application, 2),
  [7737] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6729),
  [7739] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6425),
  [7741] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6443),
  [7743] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7133),
  [7746] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7249),
  [7749] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7249),
  [7752] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7092),
  [7755] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(1263),
  [7758] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(1264),
  [7761] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(1266),
  [7764] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(1267),
  [7767] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7203),
  [7770] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(6719),
  [7773] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(1984),
  [7776] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(1980),
  [7779] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7225),
  [7782] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7225),
  [7785] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(4498),
  [7788] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6417),
  [7790] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7142),
  [7793] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7206),
  [7796] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7206),
  [7799] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7025),
  [7802] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(1021),
  [7805] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(1023),
  [7808] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(1024),
  [7811] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(1027),
  [7814] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7265),
  [7817] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(6613),
  [7820] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(2287),
  [7823] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(2286),
  [7826] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7181),
  [7829] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7181),
  [7832] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(4570),
  [7835] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7143),
  [7838] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7209),
  [7841] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7209),
  [7844] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(6884),
  [7847] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(682),
  [7850] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(681),
  [7853] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(679),
  [7856] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(678),
  [7859] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7260),
  [7862] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(6650),
  [7865] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(2194),
  [7868] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(2196),
  [7871] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7228),
  [7874] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7228),
  [7877] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(4519),
  [7880] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7118),
  [7882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7267),
  [7884] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7267),
  [7886] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6958),
  [7888] = {.entry = {.count = 1, .reusable = false}}, SHIFT(695),
  [7890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(693),
  [7892] = {.entry = {.count = 1, .reusable = false}}, SHIFT(670),
  [7894] = {.entry = {.count = 1, .reusable = false}}, SHIFT(643),
  [7896] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7222),
  [7898] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6353),
  [7900] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3469),
  [7902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2495),
  [7904] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2496),
  [7906] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7272),
  [7908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7272),
  [7910] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4438),
  [7912] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6343),
  [7914] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7133),
  [7916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7249),
  [7918] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7249),
  [7920] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7092),
  [7922] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1263),
  [7924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1264),
  [7926] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1266),
  [7928] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1267),
  [7930] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7203),
  [7932] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6719),
  [7934] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3668),
  [7936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1984),
  [7938] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1980),
  [7940] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7225),
  [7942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7225),
  [7944] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4498),
  [7946] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6328),
  [7948] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6748),
  [7950] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7118),
  [7953] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7267),
  [7956] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7267),
  [7959] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(6958),
  [7962] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(695),
  [7965] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(693),
  [7968] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(670),
  [7971] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(643),
  [7974] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7222),
  [7977] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(6353),
  [7980] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(2495),
  [7983] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(2496),
  [7986] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7272),
  [7989] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7272),
  [7992] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(4438),
  [7995] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7142),
  [7997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7206),
  [7999] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7206),
  [8001] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7025),
  [8003] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1021),
  [8005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1023),
  [8007] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1024),
  [8009] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1027),
  [8011] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7265),
  [8013] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6613),
  [8015] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3661),
  [8017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2287),
  [8019] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2286),
  [8021] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7181),
  [8023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7181),
  [8025] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4570),
  [8027] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6786),
  [8029] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7160),
  [8032] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7202),
  [8035] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7202),
  [8038] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(6981),
  [8041] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(655),
  [8044] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(658),
  [8047] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(660),
  [8050] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(663),
  [8053] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7237),
  [8056] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(6607),
  [8059] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(2653),
  [8062] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(2654),
  [8065] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7182),
  [8068] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7182),
  [8071] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(4568),
  [8074] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7132),
  [8077] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7256),
  [8080] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7256),
  [8083] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(6983),
  [8086] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(1287),
  [8089] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(1286),
  [8092] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(1285),
  [8095] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(1284),
  [8098] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7257),
  [8101] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(6604),
  [8104] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(1401),
  [8107] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(1465),
  [8110] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7211),
  [8113] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7211),
  [8116] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(4554),
  [8119] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6404),
  [8121] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6709),
  [8123] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7143),
  [8125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7209),
  [8127] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7209),
  [8129] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6884),
  [8131] = {.entry = {.count = 1, .reusable = false}}, SHIFT(682),
  [8133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(681),
  [8135] = {.entry = {.count = 1, .reusable = false}}, SHIFT(679),
  [8137] = {.entry = {.count = 1, .reusable = false}}, SHIFT(678),
  [8139] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7260),
  [8141] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6650),
  [8143] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3543),
  [8145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2194),
  [8147] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2196),
  [8149] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7228),
  [8151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7228),
  [8153] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4519),
  [8155] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7115),
  [8158] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7266),
  [8161] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7266),
  [8164] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7058),
  [8167] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(650),
  [8170] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(657),
  [8173] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(661),
  [8176] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(662),
  [8179] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7183),
  [8182] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(6573),
  [8185] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(2167),
  [8188] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(2168),
  [8191] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7246),
  [8194] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7246),
  [8197] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(4420),
  [8200] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6465),
  [8202] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7235),
  [8205] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7333),
  [8208] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7333),
  [8211] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(6989),
  [8214] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(684),
  [8217] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(685),
  [8220] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(686),
  [8223] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(691),
  [8226] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7347),
  [8229] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(6624),
  [8232] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(2609),
  [8235] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(2602),
  [8238] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7387),
  [8241] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7387),
  [8244] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(4680),
  [8247] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7230),
  [8249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7319),
  [8251] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7319),
  [8253] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6938),
  [8255] = {.entry = {.count = 1, .reusable = false}}, SHIFT(930),
  [8257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(931),
  [8259] = {.entry = {.count = 1, .reusable = false}}, SHIFT(933),
  [8261] = {.entry = {.count = 1, .reusable = false}}, SHIFT(936),
  [8263] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7342),
  [8265] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6773),
  [8267] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3691),
  [8269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2381),
  [8271] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2377),
  [8273] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7394),
  [8275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7394),
  [8277] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4644),
  [8279] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7288),
  [8282] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7448),
  [8285] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7448),
  [8288] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7006),
  [8291] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(824),
  [8294] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(827),
  [8297] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(830),
  [8300] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(831),
  [8303] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7393),
  [8306] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(6722),
  [8309] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(2493),
  [8312] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(2490),
  [8315] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7338),
  [8318] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7338),
  [8321] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(4648),
  [8324] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7230),
  [8327] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7319),
  [8330] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7319),
  [8333] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(6938),
  [8336] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(930),
  [8339] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(931),
  [8342] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(933),
  [8345] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(936),
  [8348] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7342),
  [8351] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(6773),
  [8354] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(2381),
  [8357] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(2377),
  [8360] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7394),
  [8363] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7394),
  [8366] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(4644),
  [8369] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7244),
  [8371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7302),
  [8373] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7302),
  [8375] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7043),
  [8377] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1127),
  [8379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1129),
  [8381] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1130),
  [8383] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1131),
  [8385] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7358),
  [8387] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6437),
  [8389] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3512),
  [8391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2138),
  [8393] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2136),
  [8395] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7349),
  [8397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7349),
  [8399] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4818),
  [8401] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6655),
  [8403] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6345),
  [8405] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7288),
  [8407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7448),
  [8409] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7448),
  [8411] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7006),
  [8413] = {.entry = {.count = 1, .reusable = false}}, SHIFT(824),
  [8415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(827),
  [8417] = {.entry = {.count = 1, .reusable = false}}, SHIFT(830),
  [8419] = {.entry = {.count = 1, .reusable = false}}, SHIFT(831),
  [8421] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7393),
  [8423] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6722),
  [8425] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3599),
  [8427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2493),
  [8429] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2490),
  [8431] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7338),
  [8433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7338),
  [8435] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4648),
  [8437] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6441),
  [8439] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7235),
  [8441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7333),
  [8443] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7333),
  [8445] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6989),
  [8447] = {.entry = {.count = 1, .reusable = false}}, SHIFT(684),
  [8449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(685),
  [8451] = {.entry = {.count = 1, .reusable = false}}, SHIFT(686),
  [8453] = {.entry = {.count = 1, .reusable = false}}, SHIFT(691),
  [8455] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7347),
  [8457] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6624),
  [8459] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3484),
  [8461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2609),
  [8463] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2602),
  [8465] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7387),
  [8467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7387),
  [8469] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4680),
  [8471] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7263),
  [8474] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7445),
  [8477] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7445),
  [8480] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(6910),
  [8483] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(828),
  [8486] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(823),
  [8489] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(739),
  [8492] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(711),
  [8495] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7334),
  [8498] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(6403),
  [8501] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(2319),
  [8504] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(2324),
  [8507] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7395),
  [8510] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7395),
  [8513] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(4813),
  [8516] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7160),
  [8518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7202),
  [8520] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7202),
  [8522] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6981),
  [8524] = {.entry = {.count = 1, .reusable = false}}, SHIFT(655),
  [8526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(658),
  [8528] = {.entry = {.count = 1, .reusable = false}}, SHIFT(660),
  [8530] = {.entry = {.count = 1, .reusable = false}}, SHIFT(663),
  [8532] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7237),
  [8534] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6607),
  [8536] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3593),
  [8538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2653),
  [8540] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2654),
  [8542] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7182),
  [8544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7182),
  [8546] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4568),
  [8548] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6459),
  [8550] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7259),
  [8553] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7461),
  [8556] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7461),
  [8559] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(6892),
  [8562] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(1069),
  [8565] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(1082),
  [8568] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(1090),
  [8571] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(1091),
  [8574] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7433),
  [8577] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(6553),
  [8580] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(2254),
  [8583] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(2255),
  [8586] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7421),
  [8589] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7421),
  [8592] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(4740),
  [8595] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6688),
  [8597] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7250),
  [8599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7405),
  [8601] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7405),
  [8603] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6992),
  [8605] = {.entry = {.count = 1, .reusable = false}}, SHIFT(721),
  [8607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(724),
  [8609] = {.entry = {.count = 1, .reusable = false}}, SHIFT(727),
  [8611] = {.entry = {.count = 1, .reusable = false}}, SHIFT(730),
  [8613] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7412),
  [8615] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6639),
  [8617] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3430),
  [8619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2579),
  [8621] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2576),
  [8623] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7443),
  [8625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7443),
  [8627] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4646),
  [8629] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6474),
  [8631] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6383),
  [8633] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7244),
  [8636] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7302),
  [8639] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7302),
  [8642] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7043),
  [8645] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(1127),
  [8648] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(1129),
  [8651] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(1130),
  [8654] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(1131),
  [8657] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7358),
  [8660] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(6437),
  [8663] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(2138),
  [8666] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(2136),
  [8669] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7349),
  [8672] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7349),
  [8675] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(4818),
  [8678] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7223),
  [8681] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7353),
  [8684] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7353),
  [8687] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(6882),
  [8690] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(762),
  [8693] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(759),
  [8696] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(757),
  [8699] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(756),
  [8702] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7411),
  [8705] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(6685),
  [8708] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(2190),
  [8711] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(2191),
  [8714] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7402),
  [8717] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7402),
  [8720] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(4676),
  [8723] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7210),
  [8726] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7309),
  [8729] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7309),
  [8732] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(6879),
  [8735] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(800),
  [8738] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(799),
  [8741] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(797),
  [8744] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(796),
  [8747] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7447),
  [8750] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(6740),
  [8753] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(2111),
  [8756] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(2112),
  [8759] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7370),
  [8762] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7370),
  [8765] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(4688),
  [8768] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6514),
  [8770] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7274),
  [8773] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7306),
  [8776] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7306),
  [8779] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7032),
  [8782] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(703),
  [8785] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(704),
  [8788] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(705),
  [8791] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(707),
  [8794] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7300),
  [8797] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(6692),
  [8800] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(2258),
  [8803] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(2261),
  [8806] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7397),
  [8809] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7397),
  [8812] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(4912),
  [8815] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7223),
  [8817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7353),
  [8819] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7353),
  [8821] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6882),
  [8823] = {.entry = {.count = 1, .reusable = false}}, SHIFT(762),
  [8825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(759),
  [8827] = {.entry = {.count = 1, .reusable = false}}, SHIFT(757),
  [8829] = {.entry = {.count = 1, .reusable = false}}, SHIFT(756),
  [8831] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7411),
  [8833] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6685),
  [8835] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3376),
  [8837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2190),
  [8839] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2191),
  [8841] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7402),
  [8843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7402),
  [8845] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4676),
  [8847] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6605),
  [8849] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6590),
  [8851] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6566),
  [8853] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7207),
  [8856] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7291),
  [8859] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7291),
  [8862] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(6952),
  [8865] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(1299),
  [8868] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(1304),
  [8871] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(1308),
  [8874] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(1180),
  [8877] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7413),
  [8880] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(6411),
  [8883] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(2436),
  [8886] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(2432),
  [8889] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7366),
  [8892] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7366),
  [8895] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(4745),
  [8898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1067),
  [8900] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1066),
  [8902] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3490),
  [8904] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7250),
  [8907] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7405),
  [8910] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7405),
  [8913] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(6992),
  [8916] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(721),
  [8919] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(724),
  [8922] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(727),
  [8925] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(730),
  [8928] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7412),
  [8931] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(6639),
  [8934] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(2579),
  [8937] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(2576),
  [8940] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7443),
  [8943] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7443),
  [8946] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(4646),
  [8949] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6723),
  [8951] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6498),
  [8953] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6556),
  [8955] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7343),
  [8957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7497),
  [8959] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7497),
  [8961] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7020),
  [8963] = {.entry = {.count = 1, .reusable = false}}, SHIFT(958),
  [8965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(960),
  [8967] = {.entry = {.count = 1, .reusable = false}}, SHIFT(962),
  [8969] = {.entry = {.count = 1, .reusable = false}}, SHIFT(965),
  [8971] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7566),
  [8973] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6789),
  [8975] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3366),
  [8977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2361),
  [8979] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2358),
  [8981] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7545),
  [8983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7545),
  [8985] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5308),
  [8987] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6603),
  [8989] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6481),
  [8991] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6478),
  [8993] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7274),
  [8995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7306),
  [8997] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7306),
  [8999] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7032),
  [9001] = {.entry = {.count = 1, .reusable = false}}, SHIFT(703),
  [9003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(704),
  [9005] = {.entry = {.count = 1, .reusable = false}}, SHIFT(705),
  [9007] = {.entry = {.count = 1, .reusable = false}}, SHIFT(707),
  [9009] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7300),
  [9011] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6692),
  [9013] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3481),
  [9015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2258),
  [9017] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2261),
  [9019] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7397),
  [9021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7397),
  [9023] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4912),
  [9025] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6665),
  [9027] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6488),
  [9029] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7210),
  [9031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7309),
  [9033] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7309),
  [9035] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6879),
  [9037] = {.entry = {.count = 1, .reusable = false}}, SHIFT(800),
  [9039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(799),
  [9041] = {.entry = {.count = 1, .reusable = false}}, SHIFT(797),
  [9043] = {.entry = {.count = 1, .reusable = false}}, SHIFT(796),
  [9045] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7447),
  [9047] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6740),
  [9049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2111),
  [9051] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2112),
  [9053] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7370),
  [9055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7370),
  [9057] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4688),
  [9059] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6684),
  [9061] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6634),
  [9063] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7351),
  [9066] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7590),
  [9069] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7590),
  [9072] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(6888),
  [9075] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(1377),
  [9078] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(1380),
  [9081] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(1381),
  [9084] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(1309),
  [9087] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7662),
  [9090] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(6384),
  [9093] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(1750),
  [9096] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(1749),
  [9099] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7626),
  [9102] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7626),
  [9105] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(5143),
  [9108] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6476),
  [9110] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3662),
  [9112] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6593),
  [9114] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7460),
  [9117] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7606),
  [9120] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7606),
  [9123] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(6918),
  [9126] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(702),
  [9129] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(716),
  [9132] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(717),
  [9135] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(722),
  [9138] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7500),
  [9141] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(6363),
  [9144] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(2383),
  [9147] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(2384),
  [9150] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7491),
  [9153] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7491),
  [9156] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(5057),
  [9159] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7315),
  [9161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7571),
  [9163] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7571),
  [9165] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6868),
  [9167] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1143),
  [9169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1142),
  [9171] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1140),
  [9173] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1139),
  [9175] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7564),
  [9177] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6765),
  [9179] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3693),
  [9181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1996),
  [9183] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1997),
  [9185] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7649),
  [9187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7649),
  [9189] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5188),
  [9191] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6560),
  [9193] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6504),
  [9195] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7403),
  [9198] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7667),
  [9201] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7667),
  [9204] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(6912),
  [9207] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(978),
  [9210] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(980),
  [9213] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(982),
  [9216] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(983),
  [9219] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7471),
  [9222] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(6609),
  [9225] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(2649),
  [9228] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(2650),
  [9231] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7621),
  [9234] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7621),
  [9237] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(4971),
  [9240] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7401),
  [9242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7469),
  [9244] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7469),
  [9246] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6972),
  [9248] = {.entry = {.count = 1, .reusable = false}}, SHIFT(864),
  [9250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(866),
  [9252] = {.entry = {.count = 1, .reusable = false}}, SHIFT(868),
  [9254] = {.entry = {.count = 1, .reusable = false}}, SHIFT(871),
  [9256] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7478),
  [9258] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6612),
  [9260] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3425),
  [9262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2473),
  [9264] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2498),
  [9266] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7615),
  [9268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7615),
  [9270] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4932),
  [9272] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3578),
  [9274] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6544),
  [9276] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7401),
  [9279] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7469),
  [9282] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7469),
  [9285] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(6972),
  [9288] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(864),
  [9291] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(866),
  [9294] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(868),
  [9297] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(871),
  [9300] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7478),
  [9303] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(6612),
  [9306] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(2473),
  [9309] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(2498),
  [9312] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7615),
  [9315] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7615),
  [9318] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(4932),
  [9321] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7263),
  [9323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7445),
  [9325] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7445),
  [9327] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6910),
  [9329] = {.entry = {.count = 1, .reusable = false}}, SHIFT(828),
  [9331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(823),
  [9333] = {.entry = {.count = 1, .reusable = false}}, SHIFT(739),
  [9335] = {.entry = {.count = 1, .reusable = false}}, SHIFT(711),
  [9337] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7334),
  [9339] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6403),
  [9341] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3672),
  [9343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2319),
  [9345] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2324),
  [9347] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7395),
  [9349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7395),
  [9351] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4813),
  [9353] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7315),
  [9356] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7571),
  [9359] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7571),
  [9362] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(6868),
  [9365] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(1143),
  [9368] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(1142),
  [9371] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(1140),
  [9374] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(1139),
  [9377] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7564),
  [9380] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(6765),
  [9383] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(1996),
  [9386] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(1997),
  [9389] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7649),
  [9392] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7649),
  [9395] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(5188),
  [9398] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7364),
  [9400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7501),
  [9402] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7501),
  [9404] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6915),
  [9406] = {.entry = {.count = 1, .reusable = false}}, SHIFT(636),
  [9408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(638),
  [9410] = {.entry = {.count = 1, .reusable = false}}, SHIFT(639),
  [9412] = {.entry = {.count = 1, .reusable = false}}, SHIFT(640),
  [9414] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7636),
  [9416] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6373),
  [9418] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3449),
  [9420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2341),
  [9422] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2342),
  [9424] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7569),
  [9426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7569),
  [9428] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5062),
  [9430] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7296),
  [9433] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7631),
  [9436] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7631),
  [9439] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(6872),
  [9442] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(981),
  [9445] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(979),
  [9448] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(977),
  [9451] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(976),
  [9454] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7523),
  [9457] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(6460),
  [9460] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(2053),
  [9463] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(2056),
  [9466] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7518),
  [9469] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7518),
  [9472] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(5205),
  [9475] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7346),
  [9477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7552),
  [9479] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7552),
  [9481] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6923),
  [9483] = {.entry = {.count = 1, .reusable = false}}, SHIFT(964),
  [9485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1022),
  [9487] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1120),
  [9489] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1135),
  [9491] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7530),
  [9493] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6319),
  [9495] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3391),
  [9497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2404),
  [9499] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2405),
  [9501] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7592),
  [9503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7592),
  [9505] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5044),
  [9507] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7318),
  [9509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7573),
  [9511] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7573),
  [9513] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6932),
  [9515] = {.entry = {.count = 1, .reusable = false}}, SHIFT(844),
  [9517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(854),
  [9519] = {.entry = {.count = 1, .reusable = false}}, SHIFT(863),
  [9521] = {.entry = {.count = 1, .reusable = false}}, SHIFT(873),
  [9523] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7544),
  [9525] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6327),
  [9527] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3660),
  [9529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2410),
  [9531] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2412),
  [9533] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7629),
  [9535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7629),
  [9537] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4996),
  [9539] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7311),
  [9541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7600),
  [9543] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7600),
  [9545] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6947),
  [9547] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1013),
  [9549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1152),
  [9551] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1166),
  [9553] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1167),
  [9555] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7642),
  [9557] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6324),
  [9559] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3636),
  [9561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2471),
  [9563] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2348),
  [9565] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7637),
  [9567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7637),
  [9569] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4975),
  [9571] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6611),
  [9573] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6518),
  [9575] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3515),
  [9577] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3517),
  [9579] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6505),
  [9581] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6679),
  [9583] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6466),
  [9585] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6484),
  [9587] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7327),
  [9590] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7499),
  [9593] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7499),
  [9596] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7035),
  [9599] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(1052),
  [9602] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(1053),
  [9605] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(1054),
  [9608] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(1055),
  [9611] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7581),
  [9614] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(6582),
  [9617] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(2214),
  [9620] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(2209),
  [9623] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7628),
  [9626] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7628),
  [9629] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(5140),
  [9632] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6731),
  [9634] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6673),
  [9636] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7460),
  [9638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7606),
  [9640] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7606),
  [9642] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6918),
  [9644] = {.entry = {.count = 1, .reusable = false}}, SHIFT(702),
  [9646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(716),
  [9648] = {.entry = {.count = 1, .reusable = false}}, SHIFT(717),
  [9650] = {.entry = {.count = 1, .reusable = false}}, SHIFT(722),
  [9652] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7500),
  [9654] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6363),
  [9656] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3369),
  [9658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2383),
  [9660] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2384),
  [9662] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7491),
  [9664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7491),
  [9666] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5057),
  [9668] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7343),
  [9671] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7497),
  [9674] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7497),
  [9677] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7020),
  [9680] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(958),
  [9683] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(960),
  [9686] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(962),
  [9689] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(965),
  [9692] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7566),
  [9695] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(6789),
  [9698] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(2361),
  [9701] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(2358),
  [9704] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7545),
  [9707] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7545),
  [9710] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(5308),
  [9713] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7364),
  [9716] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7501),
  [9719] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7501),
  [9722] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(6915),
  [9725] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(636),
  [9728] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(638),
  [9731] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(639),
  [9734] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(640),
  [9737] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7636),
  [9740] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(6373),
  [9743] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(2341),
  [9746] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(2342),
  [9749] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7569),
  [9752] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7569),
  [9755] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(5062),
  [9758] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7403),
  [9760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7667),
  [9762] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7667),
  [9764] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6912),
  [9766] = {.entry = {.count = 1, .reusable = false}}, SHIFT(978),
  [9768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(980),
  [9770] = {.entry = {.count = 1, .reusable = false}}, SHIFT(982),
  [9772] = {.entry = {.count = 1, .reusable = false}}, SHIFT(983),
  [9774] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7471),
  [9776] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6609),
  [9778] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3514),
  [9780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2649),
  [9782] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2650),
  [9784] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7621),
  [9786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7621),
  [9788] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4971),
  [9790] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6588),
  [9792] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7308),
  [9794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7536),
  [9796] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7536),
  [9798] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7000),
  [9800] = {.entry = {.count = 1, .reusable = false}}, SHIFT(770),
  [9802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(771),
  [9804] = {.entry = {.count = 1, .reusable = false}}, SHIFT(772),
  [9806] = {.entry = {.count = 1, .reusable = false}}, SHIFT(773),
  [9808] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7540),
  [9810] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6675),
  [9812] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3359),
  [9814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2556),
  [9816] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2552),
  [9818] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7472),
  [9820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7472),
  [9822] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5351),
  [9824] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7346),
  [9827] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7552),
  [9830] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7552),
  [9833] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(6923),
  [9836] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(964),
  [9839] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(1022),
  [9842] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(1120),
  [9845] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(1135),
  [9848] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7530),
  [9851] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(6319),
  [9854] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(2404),
  [9857] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(2405),
  [9860] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7592),
  [9863] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7592),
  [9866] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(5044),
  [9869] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7332),
  [9872] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7488),
  [9875] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7488),
  [9878] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7022),
  [9881] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(986),
  [9884] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(987),
  [9887] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(989),
  [9890] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(993),
  [9893] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7574),
  [9896] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(6767),
  [9899] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(2338),
  [9902] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(2330),
  [9905] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7611),
  [9908] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7611),
  [9911] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(5301),
  [9914] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6347),
  [9916] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7318),
  [9919] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7573),
  [9922] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7573),
  [9925] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(6932),
  [9928] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(844),
  [9931] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(854),
  [9934] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(863),
  [9937] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(873),
  [9940] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7544),
  [9943] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(6327),
  [9946] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(2410),
  [9949] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(2412),
  [9952] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7629),
  [9955] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7629),
  [9958] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(4996),
  [9961] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7311),
  [9964] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7600),
  [9967] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7600),
  [9970] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(6947),
  [9973] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(1013),
  [9976] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(1152),
  [9979] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(1166),
  [9982] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(1167),
  [9985] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7642),
  [9988] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(6324),
  [9991] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(2471),
  [9994] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(2348),
  [9997] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7637),
  [10000] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7637),
  [10003] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(4975),
  [10006] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7332),
  [10008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7488),
  [10010] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7488),
  [10012] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7022),
  [10014] = {.entry = {.count = 1, .reusable = false}}, SHIFT(986),
  [10016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(987),
  [10018] = {.entry = {.count = 1, .reusable = false}}, SHIFT(989),
  [10020] = {.entry = {.count = 1, .reusable = false}}, SHIFT(993),
  [10022] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7574),
  [10024] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6767),
  [10026] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3455),
  [10028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2338),
  [10030] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2330),
  [10032] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7611),
  [10034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7611),
  [10036] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5301),
  [10038] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7327),
  [10040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7499),
  [10042] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7499),
  [10044] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7035),
  [10046] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1052),
  [10048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1053),
  [10050] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1054),
  [10052] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1055),
  [10054] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7581),
  [10056] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6582),
  [10058] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3616),
  [10060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2214),
  [10062] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2209),
  [10064] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7628),
  [10066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7628),
  [10068] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5140),
  [10070] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6458),
  [10072] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6379),
  [10074] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7308),
  [10077] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7536),
  [10080] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7536),
  [10083] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7000),
  [10086] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(770),
  [10089] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(771),
  [10092] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(772),
  [10095] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(773),
  [10098] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7540),
  [10101] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(6675),
  [10104] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(2556),
  [10107] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(2552),
  [10110] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7472),
  [10113] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7472),
  [10116] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(5351),
  [10119] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7782),
  [10121] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2119),
  [10123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7815),
  [10125] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7815),
  [10127] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6985),
  [10129] = {.entry = {.count = 1, .reusable = false}}, SHIFT(862),
  [10131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(859),
  [10133] = {.entry = {.count = 1, .reusable = false}}, SHIFT(842),
  [10135] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1050),
  [10137] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7823),
  [10139] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6371),
  [10141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1676),
  [10143] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1675),
  [10145] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7825),
  [10147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7825),
  [10149] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5996),
  [10151] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6523),
  [10153] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1893),
  [10155] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7464),
  [10158] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7735),
  [10161] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7735),
  [10164] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(6974),
  [10167] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(791),
  [10170] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(783),
  [10173] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(780),
  [10176] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(779),
  [10179] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7771),
  [10182] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(6561),
  [10185] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(2615),
  [10188] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(2623),
  [10191] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7797),
  [10194] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7797),
  [10197] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(5396),
  [10200] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1622),
  [10202] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2247),
  [10204] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1955),
  [10206] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7542),
  [10208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7724),
  [10210] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7724),
  [10212] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6857),
  [10214] = {.entry = {.count = 1, .reusable = false}}, SHIFT(941),
  [10216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(942),
  [10218] = {.entry = {.count = 1, .reusable = false}}, SHIFT(945),
  [10220] = {.entry = {.count = 1, .reusable = false}}, SHIFT(948),
  [10222] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7671),
  [10224] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6779),
  [10226] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3613),
  [10228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2372),
  [10230] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2368),
  [10232] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7766),
  [10234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7766),
  [10236] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5630),
  [10238] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6356),
  [10240] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7542),
  [10243] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7724),
  [10246] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7724),
  [10249] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(6857),
  [10252] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(941),
  [10255] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(942),
  [10258] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(945),
  [10261] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(948),
  [10264] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7671),
  [10267] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(6779),
  [10270] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(2372),
  [10273] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(2368),
  [10276] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7766),
  [10279] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7766),
  [10282] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(5630),
  [10285] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6477),
  [10287] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2630),
  [10289] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7646),
  [10291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7764),
  [10293] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7764),
  [10295] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7095),
  [10297] = {.entry = {.count = 1, .reusable = false}}, SHIFT(741),
  [10299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(713),
  [10301] = {.entry = {.count = 1, .reusable = false}}, SHIFT(766),
  [10303] = {.entry = {.count = 1, .reusable = false}}, SHIFT(629),
  [10305] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7772),
  [10307] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6696),
  [10309] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3589),
  [10311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1741),
  [10313] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1743),
  [10315] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7677),
  [10317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7677),
  [10319] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5609),
  [10321] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6647),
  [10323] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2357),
  [10325] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1588),
  [10327] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2438),
  [10329] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6668),
  [10331] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2052),
  [10333] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6330),
  [10335] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1473),
  [10337] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7492),
  [10339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7709),
  [10341] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7709),
  [10343] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6874),
  [10345] = {.entry = {.count = 1, .reusable = false}}, SHIFT(861),
  [10347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(860),
  [10349] = {.entry = {.count = 1, .reusable = false}}, SHIFT(858),
  [10351] = {.entry = {.count = 1, .reusable = false}}, SHIFT(855),
  [10353] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7762),
  [10355] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6654),
  [10357] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3363),
  [10359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2093),
  [10361] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2095),
  [10363] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7674),
  [10365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7674),
  [10367] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5551),
  [10369] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1506),
  [10371] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6322),
  [10373] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2278),
  [10375] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2447),
  [10377] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1957),
  [10379] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7464),
  [10381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7735),
  [10383] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7735),
  [10385] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6974),
  [10387] = {.entry = {.count = 1, .reusable = false}}, SHIFT(791),
  [10389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(783),
  [10391] = {.entry = {.count = 1, .reusable = false}}, SHIFT(780),
  [10393] = {.entry = {.count = 1, .reusable = false}}, SHIFT(779),
  [10395] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7771),
  [10397] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6561),
  [10399] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3670),
  [10401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2615),
  [10403] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2623),
  [10405] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7797),
  [10407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7797),
  [10409] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5396),
  [10411] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6701),
  [10413] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1680),
  [10415] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7465),
  [10418] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7681),
  [10421] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7681),
  [10424] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(6869),
  [10427] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(804),
  [10430] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(820),
  [10433] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(825),
  [10436] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(836),
  [10439] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7767),
  [10442] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(6587),
  [10445] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(2211),
  [10448] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(2212),
  [10451] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7722),
  [10454] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7722),
  [10457] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(5539),
  [10460] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1457),
  [10462] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2526),
  [10464] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6376),
  [10466] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6652),
  [10468] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6526),
  [10470] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1876),
  [10472] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7643),
  [10475] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7701),
  [10478] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7701),
  [10481] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(6873),
  [10484] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(924),
  [10487] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(922),
  [10490] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(919),
  [10493] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(915),
  [10496] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7691),
  [10499] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(6558),
  [10502] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(2069),
  [10505] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(2073),
  [10508] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7776),
  [10511] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7776),
  [10514] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(5585),
  [10517] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2597),
  [10519] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7465),
  [10521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7681),
  [10523] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7681),
  [10525] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6869),
  [10527] = {.entry = {.count = 1, .reusable = false}}, SHIFT(804),
  [10529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(820),
  [10531] = {.entry = {.count = 1, .reusable = false}}, SHIFT(825),
  [10533] = {.entry = {.count = 1, .reusable = false}}, SHIFT(836),
  [10535] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7767),
  [10537] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6587),
  [10539] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3502),
  [10541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2211),
  [10543] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2212),
  [10545] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7722),
  [10547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7722),
  [10549] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5539),
  [10551] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6653),
  [10553] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7640),
  [10556] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7719),
  [10559] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7719),
  [10562] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(6928),
  [10565] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(1278),
  [10568] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(1283),
  [10571] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(1288),
  [10574] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(1290),
  [10577] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7763),
  [10580] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(6464),
  [10583] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(1896),
  [10586] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(1895),
  [10589] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7773),
  [10592] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7773),
  [10595] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(5611),
  [10598] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1405),
  [10600] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7351),
  [10602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7590),
  [10604] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7590),
  [10606] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6888),
  [10608] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1377),
  [10610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1380),
  [10612] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1381),
  [10614] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1309),
  [10616] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7662),
  [10618] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6384),
  [10620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1750),
  [10622] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1749),
  [10624] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7626),
  [10626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7626),
  [10628] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5143),
  [10630] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6428),
  [10632] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1689),
  [10634] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7646),
  [10637] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7764),
  [10640] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7764),
  [10643] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7095),
  [10646] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(741),
  [10649] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(713),
  [10652] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(766),
  [10655] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(629),
  [10658] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7772),
  [10661] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(6696),
  [10664] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(1741),
  [10667] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(1743),
  [10670] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7677),
  [10673] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7677),
  [10676] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(5609),
  [10679] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7643),
  [10681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7701),
  [10683] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7701),
  [10685] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6873),
  [10687] = {.entry = {.count = 1, .reusable = false}}, SHIFT(924),
  [10689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(922),
  [10691] = {.entry = {.count = 1, .reusable = false}}, SHIFT(919),
  [10693] = {.entry = {.count = 1, .reusable = false}}, SHIFT(915),
  [10695] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7691),
  [10697] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6558),
  [10699] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3487),
  [10701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2069),
  [10703] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2073),
  [10705] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7776),
  [10707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7776),
  [10709] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5585),
  [10711] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2618),
  [10713] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1654),
  [10715] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1748),
  [10717] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1793),
  [10719] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7296),
  [10721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7631),
  [10723] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7631),
  [10725] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6872),
  [10727] = {.entry = {.count = 1, .reusable = false}}, SHIFT(981),
  [10729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(979),
  [10731] = {.entry = {.count = 1, .reusable = false}}, SHIFT(977),
  [10733] = {.entry = {.count = 1, .reusable = false}}, SHIFT(976),
  [10735] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7523),
  [10737] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6460),
  [10739] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3667),
  [10741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2053),
  [10743] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2056),
  [10745] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7518),
  [10747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7518),
  [10749] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5205),
  [10751] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7492),
  [10754] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7709),
  [10757] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7709),
  [10760] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(6874),
  [10763] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(861),
  [10766] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(860),
  [10769] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(858),
  [10772] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(855),
  [10775] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7762),
  [10778] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(6654),
  [10781] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(2093),
  [10784] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(2095),
  [10787] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7674),
  [10790] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7674),
  [10793] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(5551),
  [10796] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6563),
  [10798] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7601),
  [10801] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7798),
  [10804] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7798),
  [10807] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(6891),
  [10810] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(939),
  [10813] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(956),
  [10816] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(959),
  [10819] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(786),
  [10822] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7758),
  [10825] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(6412),
  [10828] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(2590),
  [10831] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(2591),
  [10834] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7738),
  [10837] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7738),
  [10840] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(5730),
  [10843] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7640),
  [10845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7719),
  [10847] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7719),
  [10849] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6928),
  [10851] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1278),
  [10853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1283),
  [10855] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1288),
  [10857] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1290),
  [10859] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7763),
  [10861] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6464),
  [10863] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3513),
  [10865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1896),
  [10867] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1895),
  [10869] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7773),
  [10871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7773),
  [10873] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5611),
  [10875] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6530),
  [10877] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2122),
  [10879] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2508),
  [10881] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7663),
  [10884] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7699),
  [10887] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7699),
  [10890] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(6959),
  [10893] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(1151),
  [10896] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(1164),
  [10899] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(1195),
  [10902] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(1017),
  [10905] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7752),
  [10908] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(6629),
  [10911] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(2273),
  [10914] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(2274),
  [10917] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7801),
  [10920] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7801),
  [10923] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(5694),
  [10926] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7639),
  [10929] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7737),
  [10932] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7737),
  [10935] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(6956),
  [10938] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(1370),
  [10941] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(1372),
  [10944] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(1379),
  [10947] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(847),
  [10950] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7768),
  [10953] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(6331),
  [10956] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(1417),
  [10959] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(1407),
  [10962] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7688),
  [10965] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7688),
  [10968] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(5591),
  [10971] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2206),
  [10973] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6775),
  [10975] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__expr_or_attr, 1),
  [10977] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__expr_or_attr, 1),
  [10979] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9412),
  [10981] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6742),
  [10983] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1715),
  [10985] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7601),
  [10987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7798),
  [10989] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7798),
  [10991] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6891),
  [10993] = {.entry = {.count = 1, .reusable = false}}, SHIFT(939),
  [10995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(956),
  [10997] = {.entry = {.count = 1, .reusable = false}}, SHIFT(959),
  [10999] = {.entry = {.count = 1, .reusable = false}}, SHIFT(786),
  [11001] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7758),
  [11003] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6412),
  [11005] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3575),
  [11007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2590),
  [11009] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2591),
  [11011] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7738),
  [11013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7738),
  [11015] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5730),
  [11017] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6669),
  [11019] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7663),
  [11021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7699),
  [11023] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7699),
  [11025] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6959),
  [11027] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1151),
  [11029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1164),
  [11031] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1195),
  [11033] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1017),
  [11035] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7752),
  [11037] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6629),
  [11039] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3478),
  [11041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2273),
  [11043] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2274),
  [11045] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7801),
  [11047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7801),
  [11049] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5694),
  [11051] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7639),
  [11053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7737),
  [11055] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7737),
  [11057] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6956),
  [11059] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1370),
  [11061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1372),
  [11063] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1379),
  [11065] = {.entry = {.count = 1, .reusable = false}}, SHIFT(847),
  [11067] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7768),
  [11069] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6331),
  [11071] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3382),
  [11073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1417),
  [11075] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1407),
  [11077] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7688),
  [11079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7688),
  [11081] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5591),
  [11083] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1932),
  [11085] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2354),
  [11087] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6500),
  [11089] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3652),
  [11091] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2182),
  [11093] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1799),
  [11095] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2031),
  [11097] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6689),
  [11099] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2181),
  [11101] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3520),
  [11103] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3392),
  [11105] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6515),
  [11107] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1643),
  [11109] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1560),
  [11111] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2058),
  [11113] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6690),
  [11115] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1826),
  [11117] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1486),
  [11119] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6340),
  [11121] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1816),
  [11123] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1635),
  [11125] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6377),
  [11127] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6342),
  [11129] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6579),
  [11131] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9173),
  [11133] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8664),
  [11135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8832),
  [11137] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8832),
  [11139] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6860),
  [11141] = {.entry = {.count = 1, .reusable = false}}, SHIFT(653),
  [11143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(654),
  [11145] = {.entry = {.count = 1, .reusable = false}}, SHIFT(656),
  [11147] = {.entry = {.count = 1, .reusable = false}}, SHIFT(995),
  [11149] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8908),
  [11151] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6583),
  [11153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1478),
  [11155] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1477),
  [11157] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8835),
  [11159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8835),
  [11161] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5429),
  [11163] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6595),
  [11165] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6522),
  [11167] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6721),
  [11169] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6744),
  [11171] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7782),
  [11174] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7815),
  [11177] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7815),
  [11180] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(6985),
  [11183] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(862),
  [11186] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(859),
  [11189] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(842),
  [11192] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(1050),
  [11195] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7823),
  [11198] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(6371),
  [11201] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(1676),
  [11204] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(1675),
  [11207] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7825),
  [11210] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7825),
  [11213] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(5996),
  [11216] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6448),
  [11218] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6708),
  [11220] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6774),
  [11222] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6469),
  [11224] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6486),
  [11226] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6676),
  [11228] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6699),
  [11230] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6525),
  [11232] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6354),
  [11234] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6763),
  [11236] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3508),
  [11238] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6510),
  [11240] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6507),
  [11242] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6658),
  [11244] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7824),
  [11246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7830),
  [11248] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7830),
  [11250] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7053),
  [11252] = {.entry = {.count = 1, .reusable = false}}, SHIFT(674),
  [11254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(667),
  [11256] = {.entry = {.count = 1, .reusable = false}}, SHIFT(664),
  [11258] = {.entry = {.count = 1, .reusable = false}}, SHIFT(798),
  [11260] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7839),
  [11262] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6511),
  [11264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1878),
  [11266] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1887),
  [11268] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7832),
  [11270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7832),
  [11272] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6131),
  [11274] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6503),
  [11276] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attributes, 1),
  [11278] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attributes, 1),
  [11280] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6406),
  [11282] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__modal_arg_ids_repeat1, 2),
  [11284] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__modal_arg_ids_repeat1, 2),
  [11286] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__modal_arg_ids_repeat1, 2), SHIFT_REPEAT(9028),
  [11289] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9409),
  [11291] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6489),
  [11293] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6599),
  [11295] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6726),
  [11297] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6559),
  [11299] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7824),
  [11302] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7830),
  [11305] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7830),
  [11308] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7053),
  [11311] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(674),
  [11314] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(667),
  [11317] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(664),
  [11320] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(798),
  [11323] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7839),
  [11326] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(6511),
  [11329] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(1878),
  [11332] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(1887),
  [11335] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7832),
  [11338] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(7832),
  [11341] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__atoms, 2), SHIFT_REPEAT(6131),
  [11344] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6592),
  [11346] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6636),
  [11348] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6672),
  [11350] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6452),
  [11352] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6737),
  [11354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6419),
  [11356] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__lambda_clauses_repeat1, 2),
  [11358] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__lambda_clauses_repeat1, 2),
  [11360] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_do_repeat1, 2),
  [11362] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6313),
  [11364] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__modal_arg_ids_repeat1, 2), SHIFT_REPEAT(9031),
  [11367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4327),
  [11369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(991),
  [11371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2581),
  [11373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4390),
  [11375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6407),
  [11377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(938),
  [11379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2482),
  [11381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6357),
  [11383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4162),
  [11385] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1123),
  [11387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(401),
  [11389] = {.entry = {.count = 1, .reusable = false}}, SHIFT(400),
  [11391] = {.entry = {.count = 1, .reusable = false}}, SHIFT(399),
  [11393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2036),
  [11395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4143),
  [11397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4608),
  [11399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1338),
  [11401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1455),
  [11403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4602),
  [11405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6007),
  [11407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(617),
  [11409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1579),
  [11411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6024),
  [11413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4052),
  [11415] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1145),
  [11417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(349),
  [11419] = {.entry = {.count = 1, .reusable = false}}, SHIFT(319),
  [11421] = {.entry = {.count = 1, .reusable = false}}, SHIFT(351),
  [11423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2481),
  [11425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4090),
  [11427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5914),
  [11429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(760),
  [11431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2478),
  [11433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5881),
  [11435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4349),
  [11437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(966),
  [11439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2593),
  [11441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4309),
  [11443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5423),
  [11445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1036),
  [11447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2578),
  [11449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5402),
  [11451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5246),
  [11453] = {.entry = {.count = 1, .reusable = false}}, SHIFT(946),
  [11455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(488),
  [11457] = {.entry = {.count = 1, .reusable = false}}, SHIFT(486),
  [11459] = {.entry = {.count = 1, .reusable = false}}, SHIFT(485),
  [11461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1657),
  [11463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5243),
  [11465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4273),
  [11467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(944),
  [11469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1837),
  [11471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4414),
  [11473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5453),
  [11475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1116),
  [11477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2575),
  [11479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5408),
  [11481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4153),
  [11483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1204),
  [11485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1647),
  [11487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4204),
  [11489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5102),
  [11491] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1059),
  [11493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(427),
  [11495] = {.entry = {.count = 1, .reusable = false}}, SHIFT(417),
  [11497] = {.entry = {.count = 1, .reusable = false}}, SHIFT(416),
  [11499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1466),
  [11501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5085),
  [11503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7094),
  [11505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1147),
  [11507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2573),
  [11509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6801),
  [11511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5000),
  [11513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1393),
  [11515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1668),
  [11517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5080),
  [11519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5056),
  [11521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1000),
  [11523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1755),
  [11525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5020),
  [11527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5681),
  [11529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1185),
  [11531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2094),
  [11533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5667),
  [11535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5550),
  [11537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1009),
  [11539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2318),
  [11541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5589),
  [11543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4012),
  [11545] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1149),
  [11547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(393),
  [11549] = {.entry = {.count = 1, .reusable = false}}, SHIFT(394),
  [11551] = {.entry = {.count = 1, .reusable = false}}, SHIFT(397),
  [11553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2489),
  [11555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4026),
  [11557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5838),
  [11559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1335),
  [11561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2545),
  [11563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5791),
  [11565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4613),
  [11567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1201),
  [11569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2285),
  [11571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4610),
  [11573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4870),
  [11575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1213),
  [11577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2506),
  [11579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4894),
  [11581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4921),
  [11583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1392),
  [11585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2543),
  [11587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4982),
  [11589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5538),
  [11591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(909),
  [11593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2385),
  [11595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5514),
  [11597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4459),
  [11599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(913),
  [11601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1897),
  [11603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4553),
  [11605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5590),
  [11607] = {.entry = {.count = 1, .reusable = false}}, SHIFT(689),
  [11609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(584),
  [11611] = {.entry = {.count = 1, .reusable = false}}, SHIFT(588),
  [11613] = {.entry = {.count = 1, .reusable = false}}, SHIFT(590),
  [11615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2123),
  [11617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5608),
  [11619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5436),
  [11621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(973),
  [11623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1791),
  [11625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5440),
  [11627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6188),
  [11629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(805),
  [11631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2353),
  [11633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6159),
  [11635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5698),
  [11637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(916),
  [11639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2043),
  [11641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5688),
  [11643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5582),
  [11645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1249),
  [11647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1965),
  [11649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5540),
  [11651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4920),
  [11653] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1006),
  [11655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(457),
  [11657] = {.entry = {.count = 1, .reusable = false}}, SHIFT(459),
  [11659] = {.entry = {.count = 1, .reusable = false}}, SHIFT(460),
  [11661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1854),
  [11663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5051),
  [11665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5965),
  [11667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(758),
  [11669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1501),
  [11671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5994),
  [11673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4103),
  [11675] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1154),
  [11677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(388),
  [11679] = {.entry = {.count = 1, .reusable = false}}, SHIFT(386),
  [11681] = {.entry = {.count = 1, .reusable = false}}, SHIFT(385),
  [11683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2024),
  [11685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4074),
  [11687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4980),
  [11689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(646),
  [11691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2497),
  [11693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4925),
  [11695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5168),
  [11697] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1375),
  [11699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(329),
  [11701] = {.entry = {.count = 1, .reusable = false}}, SHIFT(330),
  [11703] = {.entry = {.count = 1, .reusable = false}}, SHIFT(331),
  [11705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2055),
  [11707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5152),
  [11709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5976),
  [11711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1047),
  [11713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2009),
  [11715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5973),
  [11717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4403),
  [11719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1217),
  [11721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2233),
  [11723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4357),
  [11725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4206),
  [11727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1105),
  [11729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2067),
  [11731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4231),
  [11733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4385),
  [11735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1227),
  [11737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2225),
  [11739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4335),
  [11741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5405),
  [11743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(878),
  [11745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2608),
  [11747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5389),
  [11749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5736),
  [11751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(669),
  [11753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2640),
  [11755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5753),
  [11757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4742),
  [11759] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1324),
  [11761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(334),
  [11763] = {.entry = {.count = 1, .reusable = false}}, SHIFT(333),
  [11765] = {.entry = {.count = 1, .reusable = false}}, SHIFT(332),
  [11767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2189),
  [11769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4757),
  [11771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4858),
  [11773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(745),
  [11775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2634),
  [11777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4771),
  [11779] = {.entry = {.count = 1, .reusable = false}}, SHIFT(838),
  [11781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(538),
  [11783] = {.entry = {.count = 1, .reusable = false}}, SHIFT(536),
  [11785] = {.entry = {.count = 1, .reusable = false}}, SHIFT(535),
  [11787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4868),
  [11789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(902),
  [11791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1605),
  [11793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4899),
  [11795] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10226),
  [11797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11890),
  [11799] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11890),
  [11801] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6911),
  [11803] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1170),
  [11805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1174),
  [11807] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1175),
  [11809] = {.entry = {.count = 1, .reusable = false}}, SHIFT(647),
  [11811] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9399),
  [11813] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6393),
  [11815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2619),
  [11817] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2610),
  [11819] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11863),
  [11821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11863),
  [11823] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6788),
  [11825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4049),
  [11827] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1049),
  [11829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(446),
  [11831] = {.entry = {.count = 1, .reusable = false}}, SHIFT(448),
  [11833] = {.entry = {.count = 1, .reusable = false}}, SHIFT(449),
  [11835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2102),
  [11837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4041),
  [11839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5503),
  [11841] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1233),
  [11843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(352),
  [11845] = {.entry = {.count = 1, .reusable = false}}, SHIFT(348),
  [11847] = {.entry = {.count = 1, .reusable = false}}, SHIFT(347),
  [11849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2456),
  [11851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5527),
  [11853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4531),
  [11855] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1034),
  [11857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(440),
  [11859] = {.entry = {.count = 1, .reusable = false}}, SHIFT(441),
  [11861] = {.entry = {.count = 1, .reusable = false}}, SHIFT(443),
  [11863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2655),
  [11865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4558),
  [11867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4473),
  [11869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(676),
  [11871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2636),
  [11873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4524),
  [11875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6161),
  [11877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(997),
  [11879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2329),
  [11881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6160),
  [11883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(874),
  [11885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4784),
  [11887] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1159),
  [11889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(387),
  [11891] = {.entry = {.count = 1, .reusable = false}}, SHIFT(375),
  [11893] = {.entry = {.count = 1, .reusable = false}}, SHIFT(323),
  [11895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2439),
  [11897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4824),
  [11899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5664),
  [11901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(914),
  [11903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1952),
  [11905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5626),
  [11907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5490),
  [11909] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1038),
  [11911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(429),
  [11913] = {.entry = {.count = 1, .reusable = false}}, SHIFT(428),
  [11915] = {.entry = {.count = 1, .reusable = false}}, SHIFT(426),
  [11917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2305),
  [11919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5505),
  [11921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5079),
  [11923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1133),
  [11925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2316),
  [11927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5182),
  [11929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4496),
  [11931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1358),
  [11933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1977),
  [11935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4454),
  [11937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4285),
  [11939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(665),
  [11941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2642),
  [11943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4404),
  [11945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6714),
  [11947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1228),
  [11949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2288),
  [11951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6710),
  [11953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6826),
  [11955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(817),
  [11957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1702),
  [11959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6839),
  [11961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4527),
  [11963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1193),
  [11965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1993),
  [11967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4567),
  [11969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5364),
  [11971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(634),
  [11973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2647),
  [11975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5374),
  [11977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4192),
  [11979] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1074),
  [11981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(424),
  [11983] = {.entry = {.count = 1, .reusable = false}}, SHIFT(423),
  [11985] = {.entry = {.count = 1, .reusable = false}}, SHIFT(421),
  [11987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2060),
  [11989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4141),
  [11991] = {.entry = {.count = 1, .reusable = false}}, SHIFT(918),
  [11993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(503),
  [11995] = {.entry = {.count = 1, .reusable = false}}, SHIFT(502),
  [11997] = {.entry = {.count = 1, .reusable = false}}, SHIFT(501),
  [11999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5287),
  [12001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1329),
  [12003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2289),
  [12005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5350),
  [12007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(867),
  [12009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1340),
  [12011] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1211),
  [12013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(367),
  [12015] = {.entry = {.count = 1, .reusable = false}}, SHIFT(366),
  [12017] = {.entry = {.count = 1, .reusable = false}}, SHIFT(365),
  [12019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4463),
  [12021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(648),
  [12023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1526),
  [12025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4437),
  [12027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6162),
  [12029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1137),
  [12031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2272),
  [12033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6115),
  [12035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1354),
  [12037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4649),
  [12039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1122),
  [12041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2172),
  [12043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4699),
  [12045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5899),
  [12047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1115),
  [12049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2174),
  [12051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5865),
  [12053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4735),
  [12055] = {.entry = {.count = 1, .reusable = false}}, SHIFT(856),
  [12057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(531),
  [12059] = {.entry = {.count = 1, .reusable = false}}, SHIFT(514),
  [12061] = {.entry = {.count = 1, .reusable = false}}, SHIFT(504),
  [12063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2144),
  [12065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4707),
  [12067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6050),
  [12069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(970),
  [12071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2355),
  [12073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6016),
  [12075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6089),
  [12077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1010),
  [12079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1913),
  [12081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6015),
  [12083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5201),
  [12085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1109),
  [12087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2548),
  [12089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5228),
  [12091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4896),
  [12093] = {.entry = {.count = 1, .reusable = false}}, SHIFT(697),
  [12095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(613),
  [12097] = {.entry = {.count = 1, .reusable = false}}, SHIFT(599),
  [12099] = {.entry = {.count = 1, .reusable = false}}, SHIFT(565),
  [12101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1406),
  [12103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4871),
  [12105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4939),
  [12107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1101),
  [12109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2337),
  [12111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4923),
  [12113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(744),
  [12115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4177),
  [12117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1235),
  [12119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2216),
  [12121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4219),
  [12123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4766),
  [12125] = {.entry = {.count = 1, .reusable = false}}, SHIFT(985),
  [12127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(473),
  [12129] = {.entry = {.count = 1, .reusable = false}}, SHIFT(474),
  [12131] = {.entry = {.count = 1, .reusable = false}}, SHIFT(475),
  [12133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2600),
  [12135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4719),
  [12137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5053),
  [12139] = {.entry = {.count = 1, .reusable = false}}, SHIFT(950),
  [12141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(476),
  [12143] = {.entry = {.count = 1, .reusable = false}}, SHIFT(465),
  [12145] = {.entry = {.count = 1, .reusable = false}}, SHIFT(458),
  [12147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2413),
  [12149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5063),
  [12151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1060),
  [12153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1025),
  [12155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6565),
  [12157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1386),
  [12159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2449),
  [12161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6519),
  [12163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5926),
  [12165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(953),
  [12167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2366),
  [12169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5961),
  [12171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4679),
  [12173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1199),
  [12175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2262),
  [12177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4634),
  [12179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1018),
  [12181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(833),
  [12183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5727),
  [12185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1279),
  [12187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1968),
  [12189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5711),
  [12191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5333),
  [12193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1256),
  [12195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2208),
  [12197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5306),
  [12199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5472),
  [12201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1099),
  [12203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2176),
  [12205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5446),
  [12207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6770),
  [12209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5242),
  [12211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(849),
  [12213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2425),
  [12215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5307),
  [12217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4728),
  [12219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1084),
  [12221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2570),
  [12223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4651),
  [12225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(807),
  [12227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5635),
  [12229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1078),
  [12231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2183),
  [12233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5684),
  [12235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5319),
  [12237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1065),
  [12239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2218),
  [12241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5302),
  [12243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1072),
  [12245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6640),
  [12247] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6423),
  [12249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6053),
  [12251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1388),
  [12253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1762),
  [12255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6068),
  [12257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4263),
  [12259] = {.entry = {.count = 1, .reusable = false}}, SHIFT(998),
  [12261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(461),
  [12263] = {.entry = {.count = 1, .reusable = false}}, SHIFT(456),
  [12265] = {.entry = {.count = 1, .reusable = false}}, SHIFT(455),
  [12267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2091),
  [12269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4401),
  [12271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4643),
  [12273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1169),
  [12275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2374),
  [12277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4628),
  [12279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(929),
  [12281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5183),
  [12283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(787),
  [12285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2407),
  [12287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5076),
  [12289] = {.entry = {.count = 1, .reusable = false}}, SHIFT(775),
  [12291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(559),
  [12293] = {.entry = {.count = 1, .reusable = false}}, SHIFT(556),
  [12295] = {.entry = {.count = 1, .reusable = false}}, SHIFT(553),
  [12297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6169),
  [12299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1058),
  [12301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1618),
  [12303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6267),
  [12305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1088),
  [12307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5925),
  [12309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(700),
  [12311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2584),
  [12313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5874),
  [12315] = {.entry = {.count = 1, .reusable = false}}, SHIFT(883),
  [12317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(527),
  [12319] = {.entry = {.count = 1, .reusable = false}}, SHIFT(529),
  [12321] = {.entry = {.count = 1, .reusable = false}}, SHIFT(530),
  [12323] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1242),
  [12325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(361),
  [12327] = {.entry = {.count = 1, .reusable = false}}, SHIFT(360),
  [12329] = {.entry = {.count = 1, .reusable = false}}, SHIFT(357),
  [12331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(890),
  [12333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5375),
  [12335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(621),
  [12337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2645),
  [12339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5370),
  [12341] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_catchall_pragma, 3),
  [12343] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_catchall_pragma, 3),
  [12345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5668),
  [12347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1376),
  [12349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1555),
  [12351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5612),
  [12353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5347),
  [12355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(753),
  [12357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2345),
  [12359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5148),
  [12361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6100),
  [12363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1183),
  [12365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1823),
  [12367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6229),
  [12369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5185),
  [12371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(735),
  [12373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2334),
  [12375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5141),
  [12377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6060),
  [12379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(784),
  [12381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2429),
  [12383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6101),
  [12385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5627),
  [12387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1332),
  [12389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1500),
  [12391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5610),
  [12393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6059),
  [12395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(988),
  [12397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2219),
  [12399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6056),
  [12401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5752),
  [12403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(748),
  [12405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2563),
  [12407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5793),
  [12409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4254),
  [12411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(880),
  [12413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2411),
  [12415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4217),
  [12417] = {.entry = {.count = 1, .reusable = false}}, SHIFT(723),
  [12419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(577),
  [12421] = {.entry = {.count = 1, .reusable = false}}, SHIFT(579),
  [12423] = {.entry = {.count = 1, .reusable = false}}, SHIFT(580),
  [12425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4682),
  [12427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1270),
  [12429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2105),
  [12431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4708),
  [12433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5778),
  [12435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(767),
  [12437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2559),
  [12439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5796),
  [12441] = {.entry = {.count = 1, .reusable = false}}, SHIFT(947),
  [12443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(484),
  [12445] = {.entry = {.count = 1, .reusable = false}}, SHIFT(483),
  [12447] = {.entry = {.count = 1, .reusable = false}}, SHIFT(482),
  [12449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1289),
  [12451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5697),
  [12453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1177),
  [12455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2016),
  [12457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5714),
  [12459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(731),
  [12461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1303),
  [12463] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1076),
  [12465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(425),
  [12467] = {.entry = {.count = 1, .reusable = false}}, SHIFT(410),
  [12469] = {.entry = {.count = 1, .reusable = false}}, SHIFT(409),
  [12471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4966),
  [12473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1365),
  [12475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1902),
  [12477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4991),
  [12479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6534),
  [12481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1316),
  [12483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5853),
  [12485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1353),
  [12487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1888),
  [12489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5908),
  [12491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5235),
  [12493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1005),
  [12495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2202),
  [12497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5273),
  [12499] = {.entry = {.count = 1, .reusable = false}}, SHIFT(736),
  [12501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(571),
  [12503] = {.entry = {.count = 1, .reusable = false}}, SHIFT(563),
  [12505] = {.entry = {.count = 1, .reusable = false}}, SHIFT(562),
  [12507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1063),
  [12509] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1094),
  [12511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(447),
  [12513] = {.entry = {.count = 1, .reusable = false}}, SHIFT(480),
  [12515] = {.entry = {.count = 1, .reusable = false}}, SHIFT(494),
  [12517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5804),
  [12519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1349),
  [12521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1898),
  [12523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5902),
  [12525] = {.entry = {.count = 1, .reusable = false}}, SHIFT(649),
  [12527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(600),
  [12529] = {.entry = {.count = 1, .reusable = false}}, SHIFT(601),
  [12531] = {.entry = {.count = 1, .reusable = false}}, SHIFT(604),
  [12533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1325),
  [12535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4218),
  [12537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(912),
  [12539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2387),
  [12541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4169),
  [12543] = {.entry = {.count = 1, .reusable = false}}, SHIFT(626),
  [12545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(610),
  [12547] = {.entry = {.count = 1, .reusable = false}}, SHIFT(607),
  [12549] = {.entry = {.count = 1, .reusable = false}}, SHIFT(605),
  [12551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4070),
  [12553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1245),
  [12555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1770),
  [12557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4094),
  [12559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4840),
  [12561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1297),
  [12563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1942),
  [12565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4869),
  [12567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6214),
  [12569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1186),
  [12571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2008),
  [12573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6247),
  [12575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6217),
  [12577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1344),
  [12579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1909),
  [12581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6109),
  [12583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4307),
  [12585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1334),
  [12587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1919),
  [12589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4361),
  [12591] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attribute, 2),
  [12593] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute, 2),
  [12595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5587),
  [12597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(715),
  [12599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2192),
  [12601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5545),
  [12603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4455),
  [12605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1310),
  [12607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1929),
  [12609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4436),
  [12611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5134),
  [12613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1210),
  [12615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2005),
  [12617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5073),
  [12619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5795),
  [12621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(793),
  [12623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2535),
  [12625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5846),
  [12627] = {.entry = {.count = 1, .reusable = false}}, SHIFT(954),
  [12629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(481),
  [12631] = {.entry = {.count = 1, .reusable = false}}, SHIFT(479),
  [12633] = {.entry = {.count = 1, .reusable = false}}, SHIFT(478),
  [12635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4785),
  [12637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1221),
  [12639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2001),
  [12641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4814),
  [12643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5454),
  [12645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(843),
  [12647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2443),
  [12649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5487),
  [12651] = {.entry = {.count = 1, .reusable = false}}, SHIFT(886),
  [12653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(522),
  [12655] = {.entry = {.count = 1, .reusable = false}}, SHIFT(519),
  [12657] = {.entry = {.count = 1, .reusable = false}}, SHIFT(517),
  [12659] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1225),
  [12661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(364),
  [12663] = {.entry = {.count = 1, .reusable = false}}, SHIFT(363),
  [12665] = {.entry = {.count = 1, .reusable = false}}, SHIFT(362),
  [12667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1394),
  [12669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4282),
  [12671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(903),
  [12673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2399),
  [12675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4362),
  [12677] = {.entry = {.count = 1, .reusable = false}}, SHIFT(672),
  [12679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(593),
  [12681] = {.entry = {.count = 1, .reusable = false}}, SHIFT(592),
  [12683] = {.entry = {.count = 1, .reusable = false}}, SHIFT(591),
  [12685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5817),
  [12687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(812),
  [12689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2521),
  [12691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5858),
  [12693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5981),
  [12695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(778),
  [12697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2160),
  [12699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5971),
  [12701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4584),
  [12703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(887),
  [12705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2401),
  [12707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4604),
  [12709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5767),
  [12711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1260),
  [12713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1990),
  [12715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5878),
  [12717] = {.entry = {.count = 1, .reusable = false}}, SHIFT(680),
  [12719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(589),
  [12721] = {.entry = {.count = 1, .reusable = false}}, SHIFT(586),
  [12723] = {.entry = {.count = 1, .reusable = false}}, SHIFT(585),
  [12725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4523),
  [12727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1248),
  [12729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1998),
  [12731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4494),
  [12733] = {.entry = {.count = 1, .reusable = false}}, SHIFT(718),
  [12735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(574),
  [12737] = {.entry = {.count = 1, .reusable = false}}, SHIFT(573),
  [12739] = {.entry = {.count = 1, .reusable = false}}, SHIFT(572),
  [12741] = {.entry = {.count = 1, .reusable = false}}, SHIFT(829),
  [12743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(539),
  [12745] = {.entry = {.count = 1, .reusable = false}}, SHIFT(537),
  [12747] = {.entry = {.count = 1, .reusable = false}}, SHIFT(534),
  [12749] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1275),
  [12751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(389),
  [12753] = {.entry = {.count = 1, .reusable = false}}, SHIFT(354),
  [12755] = {.entry = {.count = 1, .reusable = false}}, SHIFT(359),
  [12757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6730),
  [12759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6610),
  [12761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6429),
  [12763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6352),
  [12765] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6335),
  [12767] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8739),
  [12769] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8817),
  [12771] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8738),
  [12773] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8847),
  [12775] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8877),
  [12777] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8795),
  [12779] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8916),
  [12781] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8910),
  [12783] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8729),
  [12785] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8870),
  [12787] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8826),
  [12789] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8791),
  [12791] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8796),
  [12793] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8766),
  [12795] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8742),
  [12797] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8783),
  [12799] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8715),
  [12801] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8704),
  [12803] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8755),
  [12805] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8691),
  [12807] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8731),
  [12809] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8842),
  [12811] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8794),
  [12813] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8830),
  [12815] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8875),
  [12817] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8807),
  [12819] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8818),
  [12821] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8899),
  [12823] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8812),
  [12825] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8845),
  [12827] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8756),
  [12829] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8697),
  [12831] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8710),
  [12833] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8915),
  [12835] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8881),
  [12837] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8776),
  [12839] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8717),
  [12841] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8721),
  [12843] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8762),
  [12845] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8722),
  [12847] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8751),
  [12849] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8793),
  [12851] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8735),
  [12853] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8708),
  [12855] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8745),
  [12857] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8770),
  [12859] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8782),
  [12861] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8737),
  [12863] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8798),
  [12865] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8823),
  [12867] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8802),
  [12869] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8884),
  [12871] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8825),
  [12873] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8727),
  [12875] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8878),
  [12877] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8728),
  [12879] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8895),
  [12881] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8714),
  [12883] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8723),
  [12885] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8713),
  [12887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6656),
  [12889] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8909),
  [12891] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8918),
  [12893] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8902),
  [12895] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8824),
  [12897] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8853),
  [12899] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8758),
  [12901] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8822),
  [12903] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8888),
  [12905] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8808),
  [12907] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8789),
  [12909] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8892),
  [12911] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8767),
  [12913] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8752),
  [12915] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8741),
  [12917] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8724),
  [12919] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8698),
  [12921] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8787),
  [12923] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8699),
  [12925] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8785),
  [12927] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8833),
  [12929] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8695),
  [12931] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8707),
  [12933] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8720),
  [12935] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8778),
  [12937] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8773),
  [12939] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8733),
  [12941] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8746),
  [12943] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8757),
  [12945] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8771),
  [12947] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8786),
  [12949] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8801),
  [12951] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8816),
  [12953] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8831),
  [12955] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8734),
  [12957] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8747),
  [12959] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8843),
  [12961] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8744),
  [12963] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8846),
  [12965] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8690),
  [12967] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8861),
  [12969] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8876),
  [12971] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8891),
  [12973] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8906),
  [12975] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8921),
  [12977] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8703),
  [12979] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8905),
  [12981] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8894),
  [12983] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8882),
  [12985] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8872),
  [12987] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8852),
  [12989] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8837),
  [12991] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8913),
  [12993] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8781),
  [12995] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8815),
  [12997] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8803),
  [12999] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8788),
  [13001] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8775),
  [13003] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8700),
  [13005] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8761),
  [13007] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8740),
  [13009] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8726),
  [13011] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8692),
  [13013] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8702),
  [13015] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8689),
  [13017] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8860),
  [13019] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8889),
  [13021] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8900),
  [13023] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8922),
  [13025] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8868),
  [13027] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8829),
  [13029] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8814),
  [13031] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8800),
  [13033] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8780),
  [13035] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8759),
  [13037] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8811),
  [13039] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8730),
  [13041] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8706),
  [13043] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8736),
  [13045] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8760),
  [13047] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8813),
  [13049] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8904),
  [13051] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8712),
  [13053] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8765),
  [13055] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8718),
  [13057] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8764),
  [13059] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8797),
  [13061] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8694),
  [13063] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8709),
  [13065] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8725),
  [13067] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8732),
  [13069] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8743),
  [13071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6596),
  [13073] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8696),
  [13075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6344),
  [13077] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8705),
  [13079] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8716),
  [13081] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8790),
  [13083] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8806),
  [13085] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8774),
  [13087] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8883),
  [13089] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8749),
  [13091] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8693),
  [13093] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8886),
  [13095] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8863),
  [13097] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8897),
  [13099] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8754),
  [13101] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8777),
  [13103] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8784),
  [13105] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8792),
  [13107] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8779),
  [13109] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8810),
  [13111] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8799),
  [13113] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8903),
  [13115] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8898),
  [13117] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8820),
  [13119] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8864),
  [13121] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8839),
  [13123] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8850),
  [13125] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8865),
  [13127] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8896),
  [13129] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8920),
  [13131] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8874),
  [13133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6365),
  [13135] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8919),
  [13137] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8911),
  [13139] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8912),
  [13141] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8772),
  [13143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6346),
  [13145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6398),
  [13147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6697),
  [13149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6776),
  [13151] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1756),
  [13153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6326),
  [13155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6680),
  [13157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6436),
  [13159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6635),
  [13161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6738),
  [13163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6695),
  [13165] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2426),
  [13167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6516),
  [13169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6492),
  [13171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6581),
  [13173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6531),
  [13175] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module_name, 1),
  [13177] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_name, 1),
  [13179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6621),
  [13181] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import, 2),
  [13183] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import, 2),
  [13185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6576),
  [13187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6323),
  [13189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6787),
  [13191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6608),
  [13193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6644),
  [13195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6467),
  [13197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6471),
  [13199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6491),
  [13201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6473),
  [13203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6440),
  [13205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6457),
  [13207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6512),
  [13209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6446),
  [13211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6550),
  [13213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6378),
  [13215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6439),
  [13217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6535),
  [13219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6380),
  [13221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6645),
  [13223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6781),
  [13225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6475),
  [13227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6572),
  [13229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6761),
  [13231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6580),
  [13233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6728),
  [13235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6704),
  [13237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6311),
  [13239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9030),
  [13241] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__modal_arg_ids_repeat1, 2), SHIFT_REPEAT(9030),
  [13244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6358),
  [13246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6368),
  [13248] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_typed_binding, 5),
  [13250] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_typed_binding, 5),
  [13252] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_untyped_binding, 4),
  [13254] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_untyped_binding, 4),
  [13256] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__signature_block_repeat1, 2), SHIFT_REPEAT(9116),
  [13259] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__signature_block_repeat1, 2), SHIFT_REPEAT(8222),
  [13262] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__signature_block_repeat1, 2), SHIFT_REPEAT(9857),
  [13265] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__signature_block_repeat1, 2), SHIFT_REPEAT(9184),
  [13268] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__signature_block_repeat1, 2), SHIFT_REPEAT(9158),
  [13271] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__signature_block_repeat1, 2), SHIFT_REPEAT(9159),
  [13274] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__signature_block_repeat1, 2), SHIFT_REPEAT(9340),
  [13277] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__signature_block_repeat1, 2), SHIFT_REPEAT(9340),
  [13280] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__signature_block_repeat1, 2), SHIFT_REPEAT(9027),
  [13283] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__signature_block_repeat1, 2),
  [13285] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_untyped_binding, 1),
  [13287] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_untyped_binding, 1),
  [13289] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_typed_binding, 3),
  [13291] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_typed_binding, 3),
  [13293] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_typed_binding, 6),
  [13295] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_typed_binding, 6),
  [13297] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_bid, 1, .production_id = 4),
  [13299] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_bid, 1, .production_id = 4),
  [13301] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_typed_binding, 4),
  [13303] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_typed_binding, 4),
  [13305] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9116),
  [13307] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8222),
  [13309] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9857),
  [13311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9184),
  [13313] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9158),
  [13315] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9159),
  [13317] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9340),
  [13319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9340),
  [13321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9027),
  [13323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9978),
  [13325] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__lambda_bindings_repeat1, 1),
  [13327] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__lambda_bindings, 2),
  [13329] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__lambda_bindings_repeat1, 1),
  [13331] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__lambda_bindings, 2),
  [13333] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__lambda_bindings, 1),
  [13335] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__lambda_bindings, 1),
  [13337] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_untyped_binding, 2),
  [13339] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_untyped_binding, 2),
  [13341] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_untyped_binding, 3),
  [13343] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_untyped_binding, 3),
  [13345] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8914),
  [13347] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2424),
  [13349] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12580),
  [13351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2827),
  [13353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3109),
  [13355] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3111),
  [13357] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3110),
  [13359] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9109),
  [13361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9109),
  [13363] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8748),
  [13365] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1744),
  [13367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2826),
  [13369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3116),
  [13371] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3114),
  [13373] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3099),
  [13375] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9086),
  [13377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9086),
  [13379] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1966),
  [13381] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1821),
  [13383] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1695),
  [13385] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1775),
  [13387] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2603),
  [13389] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2455),
  [13391] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2532),
  [13393] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1782),
  [13395] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1575),
  [13397] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1941),
  [13399] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2256),
  [13401] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2558),
  [13403] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1939),
  [13405] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1724),
  [13407] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1631),
  [13409] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1634),
  [13411] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2454),
  [13413] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1491),
  [13415] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1472),
  [13417] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1645),
  [13419] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1677),
  [13421] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2462),
  [13423] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2371),
  [13425] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2652),
  [13427] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2128),
  [13429] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1523),
  [13431] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2090),
  [13433] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1661),
  [13435] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2311),
  [13437] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1542),
  [13439] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2165),
  [13441] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1601),
  [13443] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1883),
  [13445] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1950),
  [13447] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2458),
  [13449] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2309),
  [13451] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2188),
  [13453] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2059),
  [13455] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2500),
  [13457] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2499),
  [13459] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1738),
  [13461] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2020),
  [13463] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1462),
  [13465] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1396),
  [13467] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2158),
  [13469] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2038),
  [13471] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1822),
  [13473] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1801),
  [13475] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2605),
  [13477] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1608),
  [13479] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8300),
  [13481] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2595),
  [13483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2756),
  [13485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2962),
  [13487] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2958),
  [13489] = {.entry = {.count = 1, .reusable = false}}, SHIFT(315),
  [13491] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9082),
  [13493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9082),
  [13495] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7939),
  [13497] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2010),
  [13499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2733),
  [13501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3013),
  [13503] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3012),
  [13505] = {.entry = {.count = 1, .reusable = false}}, SHIFT(268),
  [13507] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9075),
  [13509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9075),
  [13511] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8468),
  [13513] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2244),
  [13515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2682),
  [13517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3076),
  [13519] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3073),
  [13521] = {.entry = {.count = 1, .reusable = false}}, SHIFT(289),
  [13523] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9050),
  [13525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9050),
  [13527] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8036),
  [13529] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1672),
  [13531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2670),
  [13533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3001),
  [13535] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3046),
  [13537] = {.entry = {.count = 1, .reusable = false}}, SHIFT(313),
  [13539] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9055),
  [13541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9055),
  [13543] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7918),
  [13545] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2391),
  [13547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2666),
  [13549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2834),
  [13551] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2928),
  [13553] = {.entry = {.count = 1, .reusable = false}}, SHIFT(264),
  [13555] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9102),
  [13557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9102),
  [13559] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8179),
  [13561] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1885),
  [13563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2765),
  [13565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2947),
  [13567] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2948),
  [13569] = {.entry = {.count = 1, .reusable = false}}, SHIFT(280),
  [13571] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9111),
  [13573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9111),
  [13575] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8475),
  [13577] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2437),
  [13579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2752),
  [13581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2972),
  [13583] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2968),
  [13585] = {.entry = {.count = 1, .reusable = false}}, SHIFT(272),
  [13587] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9048),
  [13589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9048),
  [13591] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1787),
  [13593] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__typed_untyped_bindings, 2), SHIFT_REPEAT(8887),
  [13596] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__typed_untyped_bindings, 2),
  [13598] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__typed_untyped_bindings, 2), SHIFT_REPEAT(2830),
  [13601] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__typed_untyped_bindings, 2), SHIFT_REPEAT(3107),
  [13604] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__typed_untyped_bindings, 2), SHIFT_REPEAT(3108),
  [13607] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__typed_untyped_bindings, 2), SHIFT_REPEAT(3113),
  [13610] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__typed_untyped_bindings, 2), SHIFT_REPEAT(9113),
  [13613] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__typed_untyped_bindings, 2), SHIFT_REPEAT(9113),
  [13616] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8135),
  [13618] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2076),
  [13620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2810),
  [13622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2874),
  [13624] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2872),
  [13626] = {.entry = {.count = 1, .reusable = false}}, SHIFT(294),
  [13628] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9122),
  [13630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9122),
  [13632] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8271),
  [13634] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2002),
  [13636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2747),
  [13638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2982),
  [13640] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2989),
  [13642] = {.entry = {.count = 1, .reusable = false}}, SHIFT(291),
  [13644] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9047),
  [13646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9047),
  [13648] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8160),
  [13650] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1674),
  [13652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2823),
  [13654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2852),
  [13656] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2851),
  [13658] = {.entry = {.count = 1, .reusable = false}}, SHIFT(270),
  [13660] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9104),
  [13662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9104),
  [13664] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8190),
  [13666] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1994),
  [13668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2769),
  [13670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2944),
  [13672] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2946),
  [13674] = {.entry = {.count = 1, .reusable = false}}, SHIFT(269),
  [13676] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9128),
  [13678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9128),
  [13680] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8239),
  [13682] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1525),
  [13684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2759),
  [13686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2956),
  [13688] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2955),
  [13690] = {.entry = {.count = 1, .reusable = false}}, SHIFT(303),
  [13692] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9089),
  [13694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9089),
  [13696] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8514),
  [13698] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1825),
  [13700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2732),
  [13702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3009),
  [13704] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3006),
  [13706] = {.entry = {.count = 1, .reusable = false}}, SHIFT(273),
  [13708] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9131),
  [13710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9131),
  [13712] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8205),
  [13714] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1987),
  [13716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2694),
  [13718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3065),
  [13720] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3066),
  [13722] = {.entry = {.count = 1, .reusable = false}}, SHIFT(271),
  [13724] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9051),
  [13726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9051),
  [13728] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8572),
  [13730] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1550),
  [13732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2720),
  [13734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3026),
  [13736] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3030),
  [13738] = {.entry = {.count = 1, .reusable = false}}, SHIFT(310),
  [13740] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9134),
  [13742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9134),
  [13744] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__typed_untyped_bindings, 2), SHIFT_REPEAT(8748),
  [13747] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__typed_untyped_bindings, 2), SHIFT_REPEAT(2826),
  [13750] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__typed_untyped_bindings, 2), SHIFT_REPEAT(3116),
  [13753] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__typed_untyped_bindings, 2), SHIFT_REPEAT(3114),
  [13756] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__typed_untyped_bindings, 2), SHIFT_REPEAT(3099),
  [13759] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__typed_untyped_bindings, 2), SHIFT_REPEAT(9086),
  [13762] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__typed_untyped_bindings, 2), SHIFT_REPEAT(9086),
  [13765] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8216),
  [13767] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1513),
  [13769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2704),
  [13771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3059),
  [13773] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3060),
  [13775] = {.entry = {.count = 1, .reusable = false}}, SHIFT(306),
  [13777] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9101),
  [13779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9101),
  [13781] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7987),
  [13783] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1693),
  [13785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2799),
  [13787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2905),
  [13789] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2894),
  [13791] = {.entry = {.count = 1, .reusable = false}}, SHIFT(292),
  [13793] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9046),
  [13795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9046),
  [13797] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8630),
  [13799] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1859),
  [13801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2668),
  [13803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2853),
  [13805] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2869),
  [13807] = {.entry = {.count = 1, .reusable = false}}, SHIFT(286),
  [13809] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9061),
  [13811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9061),
  [13813] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__typed_untyped_bindings, 2), SHIFT_REPEAT(8914),
  [13816] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__typed_untyped_bindings, 2), SHIFT_REPEAT(2827),
  [13819] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__typed_untyped_bindings, 2), SHIFT_REPEAT(3109),
  [13822] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__typed_untyped_bindings, 2), SHIFT_REPEAT(3111),
  [13825] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__typed_untyped_bindings, 2), SHIFT_REPEAT(3110),
  [13828] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__typed_untyped_bindings, 2), SHIFT_REPEAT(9109),
  [13831] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__typed_untyped_bindings, 2), SHIFT_REPEAT(9109),
  [13834] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8477),
  [13836] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2569),
  [13838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2708),
  [13840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3051),
  [13842] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3058),
  [13844] = {.entry = {.count = 1, .reusable = false}}, SHIFT(284),
  [13846] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9060),
  [13848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9060),
  [13850] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8927),
  [13852] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1708),
  [13854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2791),
  [13856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2915),
  [13858] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2917),
  [13860] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2889),
  [13862] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9065),
  [13864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9065),
  [13866] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8404),
  [13868] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1414),
  [13870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2771),
  [13872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2939),
  [13874] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2938),
  [13876] = {.entry = {.count = 1, .reusable = false}}, SHIFT(300),
  [13878] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9045),
  [13880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9045),
  [13882] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8056),
  [13884] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2264),
  [13886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2703),
  [13888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3063),
  [13890] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3064),
  [13892] = {.entry = {.count = 1, .reusable = false}}, SHIFT(260),
  [13894] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9070),
  [13896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9070),
  [13898] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8390),
  [13900] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2229),
  [13902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2734),
  [13904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3007),
  [13906] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3002),
  [13908] = {.entry = {.count = 1, .reusable = false}}, SHIFT(285),
  [13910] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9083),
  [13912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9083),
  [13914] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1463),
  [13916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2699),
  [13918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3068),
  [13920] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3071),
  [13922] = {.entry = {.count = 1, .reusable = false}}, SHIFT(305),
  [13924] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8521),
  [13926] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1568),
  [13928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2726),
  [13930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3023),
  [13932] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3028),
  [13934] = {.entry = {.count = 1, .reusable = false}}, SHIFT(262),
  [13936] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9106),
  [13938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9106),
  [13940] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1628),
  [13942] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9439),
  [13944] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7970),
  [13946] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2485),
  [13948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2740),
  [13950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2997),
  [13952] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2998),
  [13954] = {.entry = {.count = 1, .reusable = false}}, SHIFT(263),
  [13956] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9090),
  [13958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9090),
  [13960] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2296),
  [13962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2768),
  [13964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2935),
  [13966] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2934),
  [13968] = {.entry = {.count = 1, .reusable = false}}, SHIFT(295),
  [13970] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1627),
  [13972] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8887),
  [13974] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9293),
  [13976] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9433),
  [13978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2830),
  [13980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3107),
  [13982] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3108),
  [13984] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3113),
  [13986] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9113),
  [13988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9113),
  [13990] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8589),
  [13992] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1423),
  [13994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2679),
  [13996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3096),
  [13998] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3095),
  [14000] = {.entry = {.count = 1, .reusable = false}}, SHIFT(307),
  [14002] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9119),
  [14004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9119),
  [14006] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2560),
  [14008] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8242),
  [14010] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1905),
  [14012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2697),
  [14014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2844),
  [14016] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2838),
  [14018] = {.entry = {.count = 1, .reusable = false}}, SHIFT(261),
  [14020] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9073),
  [14022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9073),
  [14024] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8252),
  [14026] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1745),
  [14028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2781),
  [14030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2919),
  [14032] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2918),
  [14034] = {.entry = {.count = 1, .reusable = false}}, SHIFT(265),
  [14036] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9120),
  [14038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9120),
  [14040] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7861),
  [14042] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1604),
  [14044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2669),
  [14046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2882),
  [14048] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2873),
  [14050] = {.entry = {.count = 1, .reusable = false}}, SHIFT(304),
  [14052] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9095),
  [14054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9095),
  [14056] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1397),
  [14058] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8544),
  [14060] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1725),
  [14062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2778),
  [14064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2926),
  [14066] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2925),
  [14068] = {.entry = {.count = 1, .reusable = false}}, SHIFT(282),
  [14070] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9126),
  [14072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9126),
  [14074] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1754),
  [14076] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9455),
  [14078] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7927),
  [14080] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1792),
  [14082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2766),
  [14084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2951),
  [14086] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2952),
  [14088] = {.entry = {.count = 1, .reusable = false}}, SHIFT(283),
  [14090] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9057),
  [14092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9057),
  [14094] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8605),
  [14096] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1701),
  [14098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2758),
  [14100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2960),
  [14102] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2961),
  [14104] = {.entry = {.count = 1, .reusable = false}}, SHIFT(297),
  [14106] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9097),
  [14108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9097),
  [14110] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1753),
  [14112] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8617),
  [14114] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2517),
  [14116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2745),
  [14118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2876),
  [14120] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2878),
  [14122] = {.entry = {.count = 1, .reusable = false}}, SHIFT(312),
  [14124] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9063),
  [14126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9063),
  [14128] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2430),
  [14130] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7915),
  [14132] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1615),
  [14134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2806),
  [14136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2884),
  [14138] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2836),
  [14140] = {.entry = {.count = 1, .reusable = false}}, SHIFT(290),
  [14142] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9080),
  [14144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9080),
  [14146] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9397),
  [14148] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9477),
  [14150] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8097),
  [14152] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1503),
  [14154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2801),
  [14156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2966),
  [14158] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2890),
  [14160] = {.entry = {.count = 1, .reusable = false}}, SHIFT(293),
  [14162] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9140),
  [14164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9140),
  [14166] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7908),
  [14168] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2131),
  [14170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2777),
  [14172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2921),
  [14174] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2906),
  [14176] = {.entry = {.count = 1, .reusable = false}}, SHIFT(277),
  [14178] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9069),
  [14180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9069),
  [14182] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8625),
  [14184] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1723),
  [14186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2757),
  [14188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2959),
  [14190] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2967),
  [14192] = {.entry = {.count = 1, .reusable = false}}, SHIFT(309),
  [14194] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9078),
  [14196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9078),
  [14198] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8100),
  [14200] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2551),
  [14202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2822),
  [14204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2870),
  [14206] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2871),
  [14208] = {.entry = {.count = 1, .reusable = false}}, SHIFT(278),
  [14210] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9077),
  [14212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9077),
  [14214] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8351),
  [14216] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1480),
  [14218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2808),
  [14220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2880),
  [14222] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2881),
  [14224] = {.entry = {.count = 1, .reusable = false}}, SHIFT(298),
  [14226] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9066),
  [14228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9066),
  [14230] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8545),
  [14232] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1612),
  [14234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2727),
  [14236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3024),
  [14238] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3025),
  [14240] = {.entry = {.count = 1, .reusable = false}}, SHIFT(311),
  [14242] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9098),
  [14244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9098),
  [14246] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8353),
  [14248] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1900),
  [14250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2707),
  [14252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3048),
  [14254] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3045),
  [14256] = {.entry = {.count = 1, .reusable = false}}, SHIFT(274),
  [14258] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9081),
  [14260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9081),
  [14262] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9214),
  [14264] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8272),
  [14266] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2116),
  [14268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2688),
  [14270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3075),
  [14272] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3074),
  [14274] = {.entry = {.count = 1, .reusable = false}}, SHIFT(302),
  [14276] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9064),
  [14278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9064),
  [14280] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7866),
  [14282] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2275),
  [14284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2824),
  [14286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2841),
  [14288] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2907),
  [14290] = {.entry = {.count = 1, .reusable = false}}, SHIFT(279),
  [14292] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9136),
  [14294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9136),
  [14296] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8266),
  [14298] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2003),
  [14300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2687),
  [14302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3080),
  [14304] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3081),
  [14306] = {.entry = {.count = 1, .reusable = false}}, SHIFT(276),
  [14308] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9079),
  [14310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9079),
  [14312] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8204),
  [14314] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1436),
  [14316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2709),
  [14318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3038),
  [14320] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3037),
  [14322] = {.entry = {.count = 1, .reusable = false}}, SHIFT(301),
  [14324] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9053),
  [14326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9053),
  [14328] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7971),
  [14330] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1639),
  [14332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2788),
  [14334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2914),
  [14336] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2916),
  [14338] = {.entry = {.count = 1, .reusable = false}}, SHIFT(275),
  [14340] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9132),
  [14342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9132),
  [14344] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2179),
  [14346] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7851),
  [14348] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2621),
  [14350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2698),
  [14352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3033),
  [14354] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3032),
  [14356] = {.entry = {.count = 1, .reusable = false}}, SHIFT(281),
  [14358] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9068),
  [14360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9068),
  [14362] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7863),
  [14364] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2042),
  [14366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2715),
  [14368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2883),
  [14370] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2898),
  [14372] = {.entry = {.count = 1, .reusable = false}}, SHIFT(287),
  [14374] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9094),
  [14376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9094),
  [14378] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8563),
  [14380] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2014),
  [14382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2712),
  [14384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3044),
  [14386] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3042),
  [14388] = {.entry = {.count = 1, .reusable = false}}, SHIFT(314),
  [14390] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9107),
  [14392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9107),
  [14394] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2476),
  [14396] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8311),
  [14398] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1597),
  [14400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2816),
  [14402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2856),
  [14404] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2855),
  [14406] = {.entry = {.count = 1, .reusable = false}}, SHIFT(296),
  [14408] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9085),
  [14410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9085),
  [14412] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2166),
  [14414] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2507),
  [14416] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9396),
  [14418] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8277),
  [14420] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2343),
  [14422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2739),
  [14424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3004),
  [14426] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3005),
  [14428] = {.entry = {.count = 1, .reusable = false}}, SHIFT(308),
  [14430] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9056),
  [14432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9056),
  [14434] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9323),
  [14436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2831),
  [14438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3102),
  [14440] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3117),
  [14442] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3118),
  [14444] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__typed_untyped_bindings, 2), SHIFT_REPEAT(8931),
  [14447] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__typed_untyped_bindings, 2), SHIFT_REPEAT(2829),
  [14450] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__typed_untyped_bindings, 2), SHIFT_REPEAT(3101),
  [14453] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__typed_untyped_bindings, 2), SHIFT_REPEAT(3106),
  [14456] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__typed_untyped_bindings, 2), SHIFT_REPEAT(3112),
  [14459] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__typed_untyped_bindings, 2), SHIFT_REPEAT(9127),
  [14462] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__typed_untyped_bindings, 2), SHIFT_REPEAT(9127),
  [14465] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9388),
  [14467] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9345),
  [14469] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9392),
  [14471] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__typed_untyped_bindings, 2), SHIFT_REPEAT(8927),
  [14474] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__typed_untyped_bindings, 2), SHIFT_REPEAT(2831),
  [14477] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__typed_untyped_bindings, 2), SHIFT_REPEAT(3102),
  [14480] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__typed_untyped_bindings, 2), SHIFT_REPEAT(3117),
  [14483] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__typed_untyped_bindings, 2), SHIFT_REPEAT(3118),
  [14486] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__typed_untyped_bindings, 2), SHIFT_REPEAT(9065),
  [14489] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__typed_untyped_bindings, 2), SHIFT_REPEAT(9065),
  [14492] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8931),
  [14494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2829),
  [14496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3101),
  [14498] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3106),
  [14500] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3112),
  [14502] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9127),
  [14504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9127),
  [14506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2763),
  [14508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2943),
  [14510] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2941),
  [14512] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2930),
  [14514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2741),
  [14516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2994),
  [14518] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2986),
  [14520] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2983),
  [14522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2821),
  [14524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2840),
  [14526] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2842),
  [14528] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2843),
  [14530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2760),
  [14532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2975),
  [14534] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2978),
  [14536] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2981),
  [14538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2815),
  [14540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2875),
  [14542] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2877),
  [14544] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2879),
  [14546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2736),
  [14548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3008),
  [14550] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3010),
  [14552] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3011),
  [14554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2796),
  [14556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2904),
  [14558] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2903),
  [14560] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2902),
  [14562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2735),
  [14564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3015),
  [14566] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3016),
  [14568] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3019),
  [14570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2820),
  [14572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2868),
  [14574] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2863),
  [14576] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2859),
  [14578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2748),
  [14580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2839),
  [14582] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2837),
  [14584] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2892),
  [14586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2813),
  [14588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2867),
  [14590] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2864),
  [14592] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2861),
  [14594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2779),
  [14596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2929),
  [14598] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2937),
  [14600] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2953),
  [14602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2776),
  [14604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2923),
  [14606] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2922),
  [14608] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2920),
  [14610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2721),
  [14612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3031),
  [14614] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3035),
  [14616] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3036),
  [14618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2673),
  [14620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2900),
  [14622] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2908),
  [14624] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2965),
  [14626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2685),
  [14628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3086),
  [14630] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3087),
  [14632] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3089),
  [14634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2774),
  [14636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2932),
  [14638] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2933),
  [14640] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2936),
  [14642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2706),
  [14644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3054),
  [14646] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3055),
  [14648] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3056),
  [14650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2718),
  [14652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3034),
  [14654] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3039),
  [14656] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3050),
  [14658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2700),
  [14660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2931),
  [14662] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2832),
  [14664] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2927),
  [14666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2683),
  [14668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3084),
  [14670] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3082),
  [14672] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3078),
  [14674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2807),
  [14676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2885),
  [14678] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2887),
  [14680] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2888),
  [14682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2702),
  [14684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3061),
  [14686] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3057),
  [14688] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3049),
  [14690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2803),
  [14692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2901),
  [14694] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2909),
  [14696] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2910),
  [14698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2761),
  [14700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2957),
  [14702] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2954),
  [14704] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2950),
  [14706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2764),
  [14708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2945),
  [14710] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2942),
  [14712] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2940),
  [14714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2713),
  [14716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3047),
  [14718] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3052),
  [14720] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3053),
  [14722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2690),
  [14724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3077),
  [14726] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3079),
  [14728] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3083),
  [14730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2818),
  [14732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2849),
  [14734] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2846),
  [14736] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2845),
  [14738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2661),
  [14740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2980),
  [14742] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2979),
  [14744] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2971),
  [14746] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__lambda_bindings_repeat1, 2), SHIFT_REPEAT(9009),
  [14749] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__lambda_bindings_repeat1, 2), SHIFT_REPEAT(2828),
  [14752] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__lambda_bindings_repeat1, 2), SHIFT_REPEAT(3120),
  [14755] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__lambda_bindings_repeat1, 2), SHIFT_REPEAT(3105),
  [14758] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__lambda_bindings_repeat1, 2), SHIFT_REPEAT(3103),
  [14761] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__lambda_bindings_repeat1, 2), SHIFT_REPEAT(9133),
  [14764] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__lambda_bindings_repeat1, 2), SHIFT_REPEAT(9133),
  [14767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2719),
  [14769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3029),
  [14771] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3027),
  [14773] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3022),
  [14775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2751),
  [14777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2969),
  [14779] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2833),
  [14781] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2963),
  [14783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2686),
  [14785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2847),
  [14787] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2848),
  [14789] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2850),
  [14791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2689),
  [14793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3070),
  [14795] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3069),
  [14797] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3067),
  [14799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2770),
  [14801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2924),
  [14803] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2913),
  [14805] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2912),
  [14807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2681),
  [14809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3090),
  [14811] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3091),
  [14813] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3092),
  [14815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2746),
  [14817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2985),
  [14819] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2991),
  [14821] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3003),
  [14823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2762),
  [14825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2964),
  [14827] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2895),
  [14829] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2987),
  [14831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2802),
  [14833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2896),
  [14835] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2886),
  [14837] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2835),
  [14839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2767),
  [14841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2949),
  [14843] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3062),
  [14845] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2973),
  [14847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2729),
  [14849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3021),
  [14851] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3000),
  [14853] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2995),
  [14855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2817),
  [14857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2866),
  [14859] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2865),
  [14861] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2862),
  [14863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2711),
  [14865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3043),
  [14867] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3041),
  [14869] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3040),
  [14871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2737),
  [14873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2999),
  [14875] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2992),
  [14877] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2990),
  [14879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2691),
  [14881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3072),
  [14883] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3085),
  [14885] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3088),
  [14887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2675),
  [14889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2984),
  [14891] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2988),
  [14893] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2993),
  [14895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2805),
  [14897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2891),
  [14899] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2893),
  [14901] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2897),
  [14903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2755),
  [14905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2974),
  [14907] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2976),
  [14909] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2977),
  [14911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2662),
  [14913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2860),
  [14915] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2899),
  [14917] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3098),
  [14919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2731),
  [14921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3017),
  [14923] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3018),
  [14925] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3020),
  [14927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2678),
  [14929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3097),
  [14931] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3094),
  [14933] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3093),
  [14935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2665),
  [14937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2854),
  [14939] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2857),
  [14941] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2858),
  [14943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2742),
  [14945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2996),
  [14947] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2911),
  [14949] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3014),
  [14951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1944),
  [14953] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_extended_or_absurd, 2),
  [14955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1459),
  [14957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3104),
  [14959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3115),
  [14961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3119),
  [14963] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3100),
  [14965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9414),
  [14967] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__arg_ids, 2), SHIFT_REPEAT(9116),
  [14970] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__arg_ids, 2),
  [14972] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__arg_ids, 2), SHIFT_REPEAT(9184),
  [14975] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__arg_ids, 2), SHIFT_REPEAT(9158),
  [14978] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__arg_ids, 2), SHIFT_REPEAT(9159),
  [14981] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__arg_ids, 2), SHIFT_REPEAT(9340),
  [14984] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__arg_ids, 2), SHIFT_REPEAT(9340),
  [14987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1982),
  [14989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1537),
  [14991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1809),
  [14993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1479),
  [14995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2451),
  [14997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2071),
  [14999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1671),
  [15001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1892),
  [15003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2616),
  [15005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1646),
  [15007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1986),
  [15009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1814),
  [15011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1518),
  [15013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1848),
  [15015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2398),
  [15017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2204),
  [15019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2657),
  [15021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1734),
  [15023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2486),
  [15025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2328),
  [15027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1686),
  [15029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2479),
  [15031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2171),
  [15033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1967),
  [15035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1831),
  [15037] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__modal_arg_ids, 1),
  [15039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1706),
  [15041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1590),
  [15043] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__lambda_bindings, 3),
  [15045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1667),
  [15047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6591),
  [15049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2066),
  [15051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1538),
  [15053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1653),
  [15055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1721),
  [15057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1475),
  [15059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1807),
  [15061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1907),
  [15063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2156),
  [15065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1931),
  [15067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1642),
  [15069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2613),
  [15071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2467),
  [15073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2292),
  [15075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2282),
  [15077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2540),
  [15079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2380),
  [15081] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__modal_arg_ids, 2),
  [15083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2445),
  [15085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2586),
  [15087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2139),
  [15089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1732),
  [15091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2027),
  [15093] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7138),
  [15095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4539),
  [15097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6152),
  [15099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4726),
  [15101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6830),
  [15103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5655),
  [15105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7307),
  [15107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4337),
  [15109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4139),
  [15111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4671),
  [15113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4944),
  [15115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7102),
  [15117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4880),
  [15119] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__signature_block_repeat1, 2),
  [15121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4638),
  [15123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5236),
  [15125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4063),
  [15127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7837),
  [15129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4190),
  [15131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6396),
  [15133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5022),
  [15135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4692),
  [15137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5297),
  [15139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6931),
  [15141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4457),
  [15143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7325),
  [15145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6825),
  [15147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5693),
  [15149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5086),
  [15151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5461),
  [15153] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_data_name, 1, .production_id = 3),
  [15155] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_data_name, 1, .production_id = 3),
  [15157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5397),
  [15159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4580),
  [15161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7437),
  [15163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4850),
  [15165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7073),
  [15167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7174),
  [15169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4207),
  [15171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5497),
  [15173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5046),
  [15175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7595),
  [15177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6859),
  [15179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5986),
  [15181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4269),
  [15183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7751),
  [15185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7251),
  [15187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5340),
  [15189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7299),
  [15191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4240),
  [15193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5508),
  [15195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5647),
  [15197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4288),
  [15199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4888),
  [15201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7740),
  [15203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6907),
  [15205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4376),
  [15207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7513),
  [15209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4830),
  [15211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4330),
  [15213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4171),
  [15215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11880),
  [15217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7126),
  [15219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1751),
  [15221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4127),
  [15223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7323),
  [15225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7455),
  [15227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4503),
  [15229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7377),
  [15231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4394),
  [15233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5619),
  [15235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4592),
  [15237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6736),
  [15239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5892),
  [15241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5314),
  [15243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7679),
  [15245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5032),
  [15247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5271),
  [15249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4301),
  [15251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6125),
  [15253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6179),
  [15255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7179),
  [15257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4235),
  [15259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6555),
  [15261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6845),
  [15263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7484),
  [15265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5638),
  [15267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7169),
  [15269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4749),
  [15271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7549),
  [15273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6288),
  [15275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4113),
  [15277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5441),
  [15279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5367),
  [15281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5848),
  [15283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5274),
  [15285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7280),
  [15287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5158),
  [15289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4083),
  [15291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5703),
  [15293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7665),
  [15295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5573),
  [15297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5094),
  [15299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7650),
  [15301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4656),
  [15303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5525),
  [15305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6232),
  [15307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4619),
  [15309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5381),
  [15311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4931),
  [15313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5476),
  [15315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2344),
  [15317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4977),
  [15319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6813),
  [15321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4037),
  [15323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5452),
  [15325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5120),
  [15327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6041),
  [15329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7543),
  [15331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7198),
  [15333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7430),
  [15335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7194),
  [15337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7785),
  [15339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7607),
  [15341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1798),
  [15343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4793),
  [15345] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__typed_bindings, 2),
  [15347] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__typed_bindings, 2), SHIFT_REPEAT(3104),
  [15350] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__typed_bindings, 2), SHIFT_REPEAT(3115),
  [15353] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__typed_bindings, 2), SHIFT_REPEAT(3119),
  [15356] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__typed_bindings, 2), SHIFT_REPEAT(3100),
  [15359] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__typed_bindings, 2), SHIFT_REPEAT(9414),
  [15362] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__typed_bindings, 2), SHIFT_REPEAT(9414),
  [15365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6542),
  [15367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7561),
  [15369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6105),
  [15371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7779),
  [15373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5958),
  [15375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5559),
  [15377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7217),
  [15379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4547),
  [15381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5416),
  [15383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5823),
  [15385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4516),
  [15387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7360),
  [15389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7818),
  [15391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7808),
  [15393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5740),
  [15395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8849),
  [15397] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lhs_decl, 1, .production_id = 2),
  [15399] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lhs_defn, 1),
  [15401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2534),
  [15403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3629),
  [15405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5760),
  [15407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5801),
  [15409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4078),
  [15411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5932),
  [15413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7373),
  [15415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5677),
  [15417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5979),
  [15419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7264),
  [15421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6135),
  [15423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7714),
  [15425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5209),
  [15427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5726),
  [15429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5258),
  [15431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4758),
  [15433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4487),
  [15435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7591),
  [15437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6083),
  [15439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7524),
  [15441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4952),
  [15443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5171),
  [15445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5860),
  [15447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7760),
  [15449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7470),
  [15451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5920),
  [15453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7710),
  [15455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5783),
  [15457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5124),
  [15459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4482),
  [15461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5811),
  [15463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6199),
  [15465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7156),
  [15467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6042),
  [15469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5901),
  [15471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4317),
  [15473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5325),
  [15475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5770),
  [15477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7415),
  [15479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4805),
  [15481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6013),
  [15483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6079),
  [15485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4448),
  [15487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5594),
  [15489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5574),
  [15491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4347),
  [15493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2125),
  [15495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7622),
  [15497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4857),
  [15499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7800),
  [15501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4710),
  [15503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7517),
  [15505] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__modal_arg_ids_repeat1, 2), SHIFT_REPEAT(9027),
  [15508] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_extended_or_absurd, 4),
  [15510] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expr, 1),
  [15512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2252),
  [15514] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_clause_absurd, 2),
  [15516] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_let, 3),
  [15518] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9169),
  [15520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9662),
  [15522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9278),
  [15524] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9283),
  [15526] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9286),
  [15528] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_hole_names_repeat1, 2), SHIFT_REPEAT(9169),
  [15531] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_hole_names_repeat1, 2),
  [15533] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_hole_names_repeat1, 2), SHIFT_REPEAT(9662),
  [15536] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_hole_names_repeat1, 2), SHIFT_REPEAT(9278),
  [15539] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_hole_names_repeat1, 2), SHIFT_REPEAT(9283),
  [15542] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_hole_names_repeat1, 2), SHIFT_REPEAT(9286),
  [15545] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_clause, 4),
  [15547] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_let, 6),
  [15549] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__expr2_without_let, 4),
  [15551] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expr, 3),
  [15553] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_let, 4),
  [15555] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_clause, 3),
  [15557] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_do, 4),
  [15559] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_let, 5),
  [15561] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__let_body, 2),
  [15563] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expr, 4),
  [15565] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_forall, 4),
  [15567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1619),
  [15569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3544),
  [15571] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__with_exprs, 1),
  [15573] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_clause, 2),
  [15575] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda, 4),
  [15577] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__lambda_clauses, 2),
  [15579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6174),
  [15581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1819),
  [15583] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_hole_names, 1),
  [15585] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__import_directives, 2), SHIFT_REPEAT(9087),
  [15588] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__import_directives, 2), SHIFT_REPEAT(10676),
  [15591] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__import_directives, 2),
  [15593] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__import_directives, 2), SHIFT_REPEAT(10675),
  [15596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2164),
  [15598] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__lambda_clauses, 1),
  [15600] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_extended_or_absurd, 3),
  [15602] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_clause_absurd, 1),
  [15604] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__with_exprs, 2),
  [15606] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__application, 2),
  [15608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1881),
  [15610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9150),
  [15612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12564),
  [15614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12492),
  [15616] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_macro, 5, .production_id = 6),
  [15618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9087),
  [15620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10676),
  [15622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10675),
  [15624] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_assignment, 3),
  [15626] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_macro, 5, .production_id = 8),
  [15628] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_module_macro_repeat1, 2), SHIFT_REPEAT(9150),
  [15631] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_module_macro_repeat1, 2), SHIFT_REPEAT(12564),
  [15634] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_module_macro_repeat1, 2), SHIFT_REPEAT(12492),
  [15637] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_module_macro_repeat1, 2),
  [15639] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_macro, 7, .production_id = 8),
  [15641] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_macro, 6, .production_id = 6),
  [15643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2051),
  [15645] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__record_assignments_repeat1, 2), SHIFT_REPEAT(7227),
  [15648] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__record_assignments_repeat1, 2), SHIFT_REPEAT(7183),
  [15651] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_macro, 6, .production_id = 8),
  [15653] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_macro, 4, .production_id = 6),
  [15655] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9049),
  [15657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1663),
  [15659] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9054),
  [15661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9054),
  [15663] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6482),
  [15665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1806),
  [15667] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6527),
  [15669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6527),
  [15671] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7829),
  [15673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1411),
  [15675] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7827),
  [15677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7827),
  [15679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1593),
  [15681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1936),
  [15683] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__import_directives, 2), SHIFT_REPEAT(9150),
  [15686] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__import_directives, 2), SHIFT_REPEAT(12564),
  [15689] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__import_directives, 2), SHIFT_REPEAT(12492),
  [15692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2367),
  [15694] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lhs_decl, 2, .production_id = 2),
  [15696] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lhs_defn, 2),
  [15698] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_open, 4),
  [15700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1659),
  [15702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3822),
  [15704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3453),
  [15706] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3467),
  [15708] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3559),
  [15710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3798),
  [15712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3521),
  [15714] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3402),
  [15716] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3556),
  [15718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3808),
  [15720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3647),
  [15722] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3645),
  [15724] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3643),
  [15726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3862),
  [15728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3468),
  [15730] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3501),
  [15732] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3582),
  [15734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3860),
  [15736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3373),
  [15738] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3630),
  [15740] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3358),
  [15742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3791),
  [15744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3625),
  [15746] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3626),
  [15748] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3627),
  [15750] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__arg_id, 3),
  [15752] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__arg_id, 3),
  [15754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3824),
  [15756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3619),
  [15758] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3620),
  [15760] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3622),
  [15762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3799),
  [15764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3649),
  [15766] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3642),
  [15768] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3640),
  [15770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3806),
  [15772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3694),
  [15774] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3695),
  [15776] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3696),
  [15778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3794),
  [15780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3384),
  [15782] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3398),
  [15784] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3414),
  [15786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2549),
  [15788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9553),
  [15790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9436),
  [15792] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function, 2),
  [15794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3863),
  [15796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3580),
  [15798] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3646),
  [15800] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3612),
  [15802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3809),
  [15804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3537),
  [15806] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3536),
  [15808] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3534),
  [15810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3805),
  [15812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3524),
  [15814] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3526),
  [15816] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3533),
  [15818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3858),
  [15820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3644),
  [15822] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3671),
  [15824] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3673),
  [15826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3770),
  [15828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3541),
  [15830] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3527),
  [15832] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3500),
  [15834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3815),
  [15836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3635),
  [15838] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3355),
  [15840] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3367),
  [15842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3868),
  [15844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3677),
  [15846] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3674),
  [15848] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3666),
  [15850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3788),
  [15852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3623),
  [15854] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3609),
  [15856] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3608),
  [15858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3877),
  [15860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3396),
  [15862] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3397),
  [15864] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3406),
  [15866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2488),
  [15868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2308),
  [15870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3839),
  [15872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3388),
  [15874] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3389),
  [15876] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3421),
  [15878] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__arg_id, 4),
  [15880] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__arg_id, 4),
  [15882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3790),
  [15884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3698),
  [15886] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3704),
  [15888] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3632),
  [15890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3765),
  [15892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3605),
  [15894] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3602),
  [15896] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3595),
  [15898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3812),
  [15900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3395),
  [15902] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3400),
  [15904] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3401),
  [15906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3856),
  [15908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3408),
  [15910] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3438),
  [15912] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3437),
  [15914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3879),
  [15916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3522),
  [15918] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3570),
  [15920] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3597),
  [15922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3792),
  [15924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3572),
  [15926] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3579),
  [15928] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3586),
  [15930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3789),
  [15932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3413),
  [15934] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3418),
  [15936] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3419),
  [15938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3872),
  [15940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3492),
  [15942] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3491),
  [15944] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3459),
  [15946] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function, 1),
  [15948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3784),
  [15950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3470),
  [15952] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3452),
  [15954] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3448),
  [15956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3865),
  [15958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3379),
  [15960] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3407),
  [15962] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3403),
  [15964] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_directive, 1),
  [15966] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9590),
  [15968] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9425),
  [15970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3779),
  [15972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3699),
  [15974] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3702),
  [15976] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3700),
  [15978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3867),
  [15980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3535),
  [15982] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3519),
  [15984] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3516),
  [15986] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rewrite_equations, 2),
  [15988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2550),
  [15990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3778),
  [15992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3558),
  [15994] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3583),
  [15996] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3585),
  [15998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3816),
  [16000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3454),
  [16002] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3424),
  [16004] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3370),
  [16006] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9457),
  [16008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9052),
  [16010] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9927),
  [16012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9927),
  [16014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3869),
  [16016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3601),
  [16018] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3604),
  [16020] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3607),
  [16022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3831),
  [16024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3422),
  [16026] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3415),
  [16028] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3399),
  [16030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1963),
  [16032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1779),
  [16034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3819),
  [16036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3417),
  [16038] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3411),
  [16040] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3352),
  [16042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3866),
  [16044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3499),
  [16046] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3530),
  [16048] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3510),
  [16050] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__maybe_dotted_ids, 2), SHIFT_REPEAT(9457),
  [16053] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__maybe_dotted_ids, 2),
  [16055] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__maybe_dotted_ids, 2), SHIFT_REPEAT(9927),
  [16058] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__maybe_dotted_ids, 2), SHIFT_REPEAT(9927),
  [16061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3832),
  [16063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3479),
  [16065] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3475),
  [16067] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3472),
  [16069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3852),
  [16071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3577),
  [16073] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3574),
  [16075] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3489),
  [16077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3861),
  [16079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3461),
  [16081] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3465),
  [16083] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3466),
  [16085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2530),
  [16087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3882),
  [16089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3431),
  [16091] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3493),
  [16093] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3697),
  [16095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3845),
  [16097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3675),
  [16099] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3664),
  [16101] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3663),
  [16103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2606),
  [16105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3881),
  [16107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3547),
  [16109] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3548),
  [16111] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3552),
  [16113] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__maybe_dotted_ids, 2), SHIFT_REPEAT(9483),
  [16116] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__maybe_dotted_ids, 2),
  [16118] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__maybe_dotted_ids, 2), SHIFT_REPEAT(10073),
  [16121] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__maybe_dotted_ids, 2), SHIFT_REPEAT(10073),
  [16124] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__field_name, 1, .production_id = 5),
  [16126] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__field_name, 1, .production_id = 5),
  [16128] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9489),
  [16130] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10051),
  [16132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10051),
  [16134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2452),
  [16136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3777),
  [16138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3348),
  [16140] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3445),
  [16142] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3440),
  [16144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3833),
  [16146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3654),
  [16148] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3683),
  [16150] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3687),
  [16152] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_directive, 3),
  [16154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3841),
  [16156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3568),
  [16158] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3565),
  [16160] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3564),
  [16162] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__maybe_dotted_ids, 2), SHIFT_REPEAT(9489),
  [16165] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__maybe_dotted_ids, 2), SHIFT_REPEAT(10051),
  [16168] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__maybe_dotted_ids, 2), SHIFT_REPEAT(10051),
  [16171] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9589),
  [16173] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9410),
  [16175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3843),
  [16177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3628),
  [16179] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3383),
  [16181] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3420),
  [16183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3880),
  [16185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3443),
  [16187] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3442),
  [16189] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3441),
  [16191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3840),
  [16193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3360),
  [16195] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3362),
  [16197] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3368),
  [16199] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__maybe_dotted_id, 2),
  [16201] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__maybe_dotted_id, 2),
  [16203] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9483),
  [16205] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9052),
  [16207] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10073),
  [16209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10073),
  [16211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3836),
  [16213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3529),
  [16215] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3532),
  [16217] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3540),
  [16219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3835),
  [16221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3584),
  [16223] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3590),
  [16225] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3631),
  [16227] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9009),
  [16229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3821),
  [16231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3460),
  [16233] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3462),
  [16235] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3464),
  [16237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3774),
  [16239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3659),
  [16241] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3641),
  [16243] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3634),
  [16245] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_directive, 4),
  [16247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3766),
  [16249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3511),
  [16251] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3409),
  [16253] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3405),
  [16255] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_directive, 5),
  [16257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2132),
  [16259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3827),
  [16261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3365),
  [16263] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3350),
  [16265] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3638),
  [16267] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_hole_name, 3),
  [16269] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_hole_name, 3),
  [16271] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_hole_name, 5),
  [16273] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_hole_name, 5),
  [16275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1469),
  [16277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1679),
  [16279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1617),
  [16281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1488),
  [16283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1404),
  [16285] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lhs_decl, 3, .production_id = 2),
  [16287] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lhs_defn, 3),
  [16289] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_expressions, 2),
  [16291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1746),
  [16293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1638),
  [16295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2601),
  [16297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2644),
  [16299] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type_signature_block_repeat1, 2), SHIFT_REPEAT(10194),
  [16302] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__type_signature_block_repeat1, 2),
  [16304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1564),
  [16306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1824),
  [16308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1558),
  [16310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2057),
  [16312] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_hole_name, 1),
  [16314] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_hole_name, 1),
  [16316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1603),
  [16318] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10194),
  [16320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10124),
  [16322] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9452),
  [16324] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_application, 4),
  [16326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2487),
  [16328] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__simple_top_hole, 6),
  [16330] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__simple_top_hole, 6),
  [16332] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9430),
  [16334] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_infix, 3),
  [16336] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_infix, 3),
  [16338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2133),
  [16340] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_infix_repeat1, 2), SHIFT_REPEAT(9430),
  [16343] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_infix_repeat1, 2),
  [16345] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_infix_repeat1, 2),
  [16347] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12272),
  [16349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5114),
  [16351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7429),
  [16353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5219),
  [16355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5091),
  [16357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5998),
  [16359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7515),
  [16361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7486),
  [16363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7080),
  [16365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7509),
  [16367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5939),
  [16369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5026),
  [16371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7344),
  [16373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7243),
  [16375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4697),
  [16377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4666),
  [16379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4512),
  [16381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5787),
  [16383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4575),
  [16385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6284),
  [16387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7658),
  [16389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6051),
  [16391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4967),
  [16393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1737),
  [16395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7481),
  [16397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4497),
  [16399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4296),
  [16401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7340),
  [16403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5776),
  [16405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7150),
  [16407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5501),
  [16409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4660),
  [16411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5196),
  [16413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7153),
  [16415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4722),
  [16417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5650),
  [16419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6816),
  [16421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6548),
  [16423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6037),
  [16425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4691),
  [16427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6172),
  [16429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4913),
  [16431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4353),
  [16433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1637),
  [16435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5517),
  [16437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5887),
  [16439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1918),
  [16441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7292),
  [16443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8867),
  [16445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4305),
  [16447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5841),
  [16449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7539),
  [16451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5882),
  [16453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4927),
  [16455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4379),
  [16457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4739),
  [16459] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9686),
  [16461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4230),
  [16463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7384),
  [16465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4280),
  [16467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4543),
  [16469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5744),
  [16471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7716),
  [16473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5569),
  [16475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6145),
  [16477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2440),
  [16479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5524),
  [16481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4551),
  [16483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4441),
  [16485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7834),
  [16487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6019),
  [16489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4098),
  [16491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4134),
  [16493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7617),
  [16495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5556),
  [16497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7188),
  [16499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4476),
  [16501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2177),
  [16503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5565),
  [16505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5467),
  [16507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7220),
  [16509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5614),
  [16511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4800),
  [16513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7821),
  [16515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5721),
  [16517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5385),
  [16519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7625),
  [16521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7180),
  [16523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5304),
  [16525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7396),
  [16527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7233),
  [16529] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10086),
  [16531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9587),
  [16533] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9587),
  [16535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6116),
  [16537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4854),
  [16539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5814),
  [16541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7790),
  [16543] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10092),
  [16545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5963),
  [16547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6538),
  [16549] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10093),
  [16551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9583),
  [16553] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9583),
  [16555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5362),
  [16557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5109),
  [16559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4615),
  [16561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5456),
  [16563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4199),
  [16565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4864),
  [16567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7789),
  [16569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5100),
  [16571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6065),
  [16573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5690),
  [16575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7610),
  [16577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4597),
  [16579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7330),
  [16581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4809),
  [16583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7657),
  [16585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7148),
  [16587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4443),
  [16589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6239),
  [16591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4509),
  [16593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5889),
  [16595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5598),
  [16597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4322),
  [16599] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12168),
  [16601] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12170),
  [16603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7673),
  [16605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5261),
  [16607] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12172),
  [16609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6925),
  [16611] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function, 3),
  [16613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4820),
  [16615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4389),
  [16617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5706),
  [16619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7367),
  [16621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6998),
  [16623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6752),
  [16625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4985),
  [16627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5042),
  [16629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6192),
  [16631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7689),
  [16633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5828),
  [16635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1660),
  [16637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7810),
  [16639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4106),
  [16641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6834),
  [16643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4368),
  [16645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7733),
  [16647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7532),
  [16649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5673),
  [16651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7743),
  [16653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9506),
  [16655] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9505),
  [16657] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9504),
  [16659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5662),
  [16661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7122),
  [16663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4632),
  [16665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5391),
  [16667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7294),
  [16669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7757),
  [16671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4118),
  [16673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7010),
  [16675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6389),
  [16677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5835),
  [16679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7451),
  [16681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5631),
  [16683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6139),
  [16685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1517),
  [16687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5154),
  [16689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6093),
  [16691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5871),
  [16693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4332),
  [16695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7281),
  [16697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5755),
  [16699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7051),
  [16701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4196),
  [16703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7589),
  [16705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7284),
  [16707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4019),
  [16709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6841),
  [16711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4239),
  [16713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6808),
  [16715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4165),
  [16717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5411),
  [16719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7567),
  [16721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5481),
  [16723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4752),
  [16725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4947),
  [16727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5279),
  [16729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7554),
  [16731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1476),
  [16733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7792),
  [16735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11874),
  [16737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5151),
  [16739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4132),
  [16741] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9619),
  [16743] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12248),
  [16745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9121),
  [16747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5310),
  [16749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5425),
  [16751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5231),
  [16753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5029),
  [16755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9166),
  [16757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5990),
  [16759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5321),
  [16761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4886),
  [16763] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_infix_repeat1, 2), SHIFT_REPEAT(9686),
  [16766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7371),
  [16768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4102),
  [16770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5344),
  [16772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6144),
  [16774] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12242),
  [16776] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12243),
  [16778] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9432),
  [16780] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10083),
  [16782] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10201),
  [16784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3870),
  [16786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3496),
  [16788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3495),
  [16790] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3494),
  [16792] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8834),
  [16794] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8257),
  [16796] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1778),
  [16798] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_where, 3),
  [16800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(194),
  [16802] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instance, 1),
  [16804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9074),
  [16806] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9074),
  [16808] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_mutual, 1),
  [16810] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_data, 5),
  [16812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12580),
  [16814] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_signature, 5, .production_id = 7),
  [16816] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__binding_ids_and_absurds, 3),
  [16818] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module, 3, .production_id = 6),
  [16820] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_signature, 4, .production_id = 7),
  [16822] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_data, 6),
  [16824] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_where, 1),
  [16826] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generalize, 1),
  [16828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7877),
  [16830] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_data, 3),
  [16832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12263),
  [16834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12130),
  [16836] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10203),
  [16838] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_record_constructor_instance_repeat1, 2), SHIFT_REPEAT(12263),
  [16841] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_record_constructor_instance_repeat1, 2),
  [16843] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__binding_ids_and_absurds, 1),
  [16845] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rhs_defn, 2),
  [16847] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__field_names, 2), SHIFT_REPEAT(10194),
  [16850] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__field_names, 2),
  [16852] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rhs_decl, 2),
  [16854] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__field_names, 2), SHIFT_REPEAT(9457),
  [16857] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__field_names, 2),
  [16859] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9451),
  [16861] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_syntax, 5),
  [16863] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_syntax, 5),
  [16865] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_syntax_repeat1, 2), SHIFT_REPEAT(9451),
  [16868] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_syntax_repeat1, 2),
  [16870] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_syntax_repeat1, 2),
  [16872] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_postulate, 1),
  [16874] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_data, 4),
  [16876] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__field_names, 2), SHIFT_REPEAT(9483),
  [16879] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_primitive, 1),
  [16881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9339),
  [16883] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module, 4, .production_id = 6),
  [16885] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_macro, 1),
  [16887] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_private, 1),
  [16889] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__field_names, 2), SHIFT_REPEAT(9489),
  [16892] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract, 1),
  [16894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2469),
  [16896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3263),
  [16898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2152),
  [16900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3244),
  [16902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1461),
  [16904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3340),
  [16906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2029),
  [16908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3238),
  [16910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1731),
  [16912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3315),
  [16914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3186),
  [16916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3182),
  [16918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2079),
  [16920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3242),
  [16922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2331),
  [16924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3293),
  [16926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2470),
  [16928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3283),
  [16930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1533),
  [16932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3170),
  [16934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1669),
  [16936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3235),
  [16938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1665),
  [16940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3219),
  [16942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3166),
  [16944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1514),
  [16946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3171),
  [16948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1673),
  [16950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3188),
  [16952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3212),
  [16954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3206),
  [16956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1471),
  [16958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3198),
  [16960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3248),
  [16962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1545),
  [16964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3282),
  [16966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3159),
  [16968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1979),
  [16970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3254),
  [16972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1937),
  [16974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3320),
  [16976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3290),
  [16978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2297),
  [16980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3154),
  [16982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2199),
  [16984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3245),
  [16986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3139),
  [16988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1812),
  [16990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3225),
  [16992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3128),
  [16994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1470),
  [16996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3334),
  [16998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3167),
  [17000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3332),
  [17002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3143),
  [17004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3236),
  [17006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3123),
  [17008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3264),
  [17010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3234),
  [17012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2326),
  [17014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3345),
  [17016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3256),
  [17018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11522),
  [17020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1815),
  [17022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3207),
  [17024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3322),
  [17026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3240),
  [17028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3329),
  [17030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1736),
  [17032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3196),
  [17034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3173),
  [17036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3318),
  [17038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1890),
  [17040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3140),
  [17042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1783),
  [17044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3131),
  [17046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1598),
  [17048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3346),
  [17050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3325),
  [17052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3292),
  [17054] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9693),
  [17056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2611),
  [17058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3286),
  [17060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9137),
  [17062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9648),
  [17064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3249),
  [17066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3317),
  [17068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9135),
  [17070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2448),
  [17072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3231),
  [17074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3323),
  [17076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1714),
  [17078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3298),
  [17080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1586),
  [17082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3269),
  [17084] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9631),
  [17086] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1709),
  [17088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2632),
  [17090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3277),
  [17092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3145),
  [17094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3330),
  [17096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3237),
  [17098] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2475),
  [17100] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__comma_import_names_repeat1, 2),
  [17102] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__comma_import_names_repeat1, 2), SHIFT_REPEAT(9645),
  [17105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9428),
  [17107] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_data_signature, 4),
  [17109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3324),
  [17111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3223),
  [17113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3137),
  [17115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3194),
  [17117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2538),
  [17119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3310),
  [17121] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9569),
  [17123] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2565),
  [17125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3215),
  [17127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3273),
  [17129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2100),
  [17131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3304),
  [17133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3153),
  [17135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3152),
  [17137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2598),
  [17139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3289),
  [17141] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8985),
  [17143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3160),
  [17145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3204),
  [17147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3161),
  [17149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1976),
  [17151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3179),
  [17153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1540),
  [17155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3267),
  [17157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3294),
  [17159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3314),
  [17161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2461),
  [17163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3268),
  [17165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2658),
  [17167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3127),
  [17169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3185),
  [17171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3232),
  [17173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3155),
  [17175] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__expr2, 1),
  [17177] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__expr2_stmt, 1),
  [17179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3189),
  [17181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3181),
  [17183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3209),
  [17185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1697),
  [17187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3230),
  [17189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3265),
  [17191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3192),
  [17193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2064),
  [17195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3191),
  [17197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3149),
  [17199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3220),
  [17201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4),
  [17203] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__field_assignments_repeat1, 2), SHIFT_REPEAT(11535),
  [17206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3157),
  [17208] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__comma_import_names, 1),
  [17210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9645),
  [17212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9168),
  [17214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12174),
  [17216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3228),
  [17218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1904),
  [17220] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__do_stmt, 1),
  [17222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12171),
  [17224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2376),
  [17226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3169),
  [17228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3251),
  [17230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3239),
  [17232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3333),
  [17234] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9650),
  [17236] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__ids, 2), SHIFT_REPEAT(9631),
  [17239] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__ids, 2),
  [17241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3312),
  [17243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3250),
  [17245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3122),
  [17247] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_let_in_do, 3),
  [17249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3252),
  [17251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2280),
  [17253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3177),
  [17255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3270),
  [17257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2169),
  [17259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3147),
  [17261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3150),
  [17263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9435),
  [17265] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_data_signature, 5),
  [17267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3261),
  [17269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3297),
  [17271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3208),
  [17273] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10103),
  [17275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3341),
  [17277] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__comma_import_names, 2),
  [17279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9182),
  [17281] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_syntax_repeat1, 2), SHIFT_REPEAT(9650),
  [17284] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_let_in_do, 4),
  [17286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3126),
  [17288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3224),
  [17290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3217),
  [17292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3257),
  [17294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3303),
  [17296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3146),
  [17298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2151),
  [17300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3260),
  [17302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3241),
  [17304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3305),
  [17306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9585),
  [17308] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9585),
  [17310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3258),
  [17312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3272),
  [17314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3284),
  [17316] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_import_directive_repeat1, 2),
  [17318] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_import_directive_repeat1, 2), SHIFT_REPEAT(9648),
  [17321] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9564),
  [17323] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1585),
  [17325] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_let_in_do, 5),
  [17327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3328),
  [17329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3187),
  [17331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3280),
  [17333] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_let_in_do, 6),
  [17335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3338),
  [17337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3180),
  [17339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3141),
  [17341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3175),
  [17343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1828),
  [17345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3184),
  [17347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1834),
  [17349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3296),
  [17351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1948),
  [17353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3335),
  [17355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3321),
  [17357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3142),
  [17359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3183),
  [17361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3255),
  [17363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3342),
  [17365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3347),
  [17367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3336),
  [17369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3253),
  [17371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1430),
  [17373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8609),
  [17375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1438),
  [17377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8607),
  [17379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1437),
  [17381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1435),
  [17383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1432),
  [17385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1850),
  [17387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7874),
  [17389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2241),
  [17391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1429),
  [17393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2250),
  [17395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1544),
  [17397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8305),
  [17399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1546),
  [17401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1547),
  [17403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1773),
  [17405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8137),
  [17407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1776),
  [17409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1780),
  [17411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1551),
  [17413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8303),
  [17415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1552),
  [17417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1553),
  [17419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2414),
  [17421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2420),
  [17423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1803),
  [17425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8141),
  [17427] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record, 3, .production_id = 7),
  [17429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1625),
  [17431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8295),
  [17433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1626),
  [17435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1633),
  [17437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1636),
  [17439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2083),
  [17441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2035),
  [17443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1640),
  [17445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8293),
  [17447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1861),
  [17449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1655),
  [17451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1804),
  [17453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1810),
  [17455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1696),
  [17457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1827),
  [17459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2564),
  [17461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1541),
  [17463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8335),
  [17465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1577),
  [17467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10041),
  [17469] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__record_assignments, 1),
  [17471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2510),
  [17473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1583),
  [17475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2271),
  [17477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1849),
  [17479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8620),
  [17481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1855),
  [17483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1600),
  [17485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8338),
  [17487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1857),
  [17489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1602),
  [17491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1607),
  [17493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2109),
  [17495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8579),
  [17497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1864),
  [17499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8621),
  [17501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1865),
  [17503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1529),
  [17505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1868),
  [17507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1410),
  [17509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1624),
  [17511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1420),
  [17513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1425),
  [17515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1682),
  [17517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8322),
  [17519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2062),
  [17521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8599),
  [17523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1683),
  [17525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2077),
  [17527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1687),
  [17529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2082),
  [17531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1492),
  [17533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1521),
  [17535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1548),
  [17537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1535),
  [17539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1690),
  [17541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8323),
  [17543] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unquote_decl, 3),
  [17545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2085),
  [17547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8601),
  [17549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1717),
  [17551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7942),
  [17553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2117),
  [17555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2118),
  [17557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1730),
  [17559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1716),
  [17561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1844),
  [17563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1691),
  [17565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2555),
  [17567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2243),
  [17569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7880),
  [17571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2248),
  [17573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2249),
  [17575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2402),
  [17577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1700),
  [17579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1434),
  [17581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2253),
  [17583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7883),
  [17585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2265),
  [17587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1448),
  [17589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2270),
  [17591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2197),
  [17593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1784),
  [17595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8203),
  [17597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2536),
  [17599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1710),
  [17601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2087),
  [17603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1903),
  [17605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8448),
  [17607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1908),
  [17609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1911),
  [17611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1785),
  [17613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1915),
  [17615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1800),
  [17617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1786),
  [17619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2417),
  [17621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8250),
  [17623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2418),
  [17625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2419),
  [17627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1789),
  [17629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8157),
  [17631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1790),
  [17633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1817),
  [17635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1587),
  [17637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1703),
  [17639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7943),
  [17641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1656),
  [17643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1649),
  [17645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1927),
  [17647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8461),
  [17649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1454),
  [17651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2422),
  [17653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8244),
  [17655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2423),
  [17657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2427),
  [17659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1416),
  [17661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1609),
  [17663] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_stmt, 1),
  [17665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1496),
  [17667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1688),
  [17669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1502),
  [17671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1928),
  [17673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1934),
  [17675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1945),
  [17677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7887),
  [17679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1559),
  [17681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1951),
  [17683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1591),
  [17685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2537),
  [17687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9042),
  [17689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2554),
  [17691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2562),
  [17693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1956),
  [17695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1713),
  [17697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2567),
  [17699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9008),
  [17701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2580),
  [17703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1960),
  [17705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7882),
  [17707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1961),
  [17709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1962),
  [17711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2582),
  [17713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1439),
  [17715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1788),
  [17717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1630),
  [17719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2072),
  [17721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8585),
  [17723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1652),
  [17725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2074),
  [17727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1856),
  [17729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2501),
  [17731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8218),
  [17733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2075),
  [17735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2379),
  [17737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2099),
  [17739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2370),
  [17741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1867),
  [17743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1818),
  [17745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2622),
  [17747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8582),
  [17749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2269),
  [17751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8217),
  [17753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10145),
  [17755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1443),
  [17757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8711),
  [17759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1959),
  [17761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2178),
  [17763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2230),
  [17765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2012),
  [17767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2110),
  [17769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2018),
  [17771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2141),
  [17773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1964),
  [17775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2048),
  [17777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2149),
  [17779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1802),
  [17781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2251),
  [17783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8571),
  [17785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2238),
  [17787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2080),
  [17789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2260),
  [17791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2277),
  [17793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2313),
  [17795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2113),
  [17797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1969),
  [17799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8493),
  [17801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1970),
  [17803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1972),
  [17805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2325),
  [17807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1468),
  [17809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8107),
  [17811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1452),
  [17813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2299),
  [17815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8570),
  [17817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1974),
  [17819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8496),
  [17821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1975),
  [17823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2301),
  [17825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1988),
  [17827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1433),
  [17829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2302),
  [17831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2298),
  [17833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2033),
  [17835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8109),
  [17837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2428),
  [17839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2034),
  [17841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2237),
  [17843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2352),
  [17845] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_where, 2),
  [17847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2464),
  [17849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2509),
  [17851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8932),
  [17853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2511),
  [17855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2566),
  [17857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2512),
  [17859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2624),
  [17861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1421),
  [17863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8005),
  [17865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2515),
  [17867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8933),
  [17869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1570),
  [17871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7902),
  [17873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1569),
  [17875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1422),
  [17877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1424),
  [17879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2516),
  [17881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2518),
  [17883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2513),
  [17885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2519),
  [17887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1451),
  [17889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8001),
  [17891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2097),
  [17893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8520),
  [17895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2114),
  [17897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2121),
  [17899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1453),
  [17901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1458),
  [17903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2364),
  [17905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2637),
  [17907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8583),
  [17909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2631),
  [17911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1567),
  [17913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2629),
  [17915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2627),
  [17917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2626),
  [17919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2127),
  [17921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8522),
  [17923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2129),
  [17925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2130),
  [17927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2375),
  [17929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2628),
  [17931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2620),
  [17933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2359),
  [17935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2533),
  [17937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8562),
  [17939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1440),
  [17941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1494),
  [17943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8543),
  [17945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1563),
  [17947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7911),
  [17949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1519),
  [17951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2307),
  [17953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1562),
  [17955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2300),
  [17957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1520),
  [17959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1556),
  [17961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2529),
  [17963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2528),
  [17965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1528),
  [17967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8550),
  [17969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1530),
  [17971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2525),
  [17973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8560),
  [17975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1532),
  [17977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2524),
  [17979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2523),
  [17981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2276),
  [17983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8236),
  [17985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2527),
  [17987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2279),
  [17989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2294),
  [17991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2522),
  [17993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2397),
  [17995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8373),
  [17997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2145),
  [17999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2124),
  [18001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2396),
  [18003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2303),
  [18005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8225),
  [18007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2304),
  [18009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2306),
  [18011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2000),
  [18013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1973),
  [18015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1752),
  [18017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8191),
  [18019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1935),
  [18021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2395),
  [18023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1771),
  [18025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1772),
  [18027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2389),
  [18029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8391),
  [18031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2388),
  [18033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2394),
  [18035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2386),
  [18037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1916),
  [18039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1811),
  [18041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1847),
  [18043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8189),
  [18045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2025),
  [18047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2444),
  [18049] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__type_signature_block_repeat1, 2),
  [18051] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_primitive, 2),
  [18053] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__signature_block, 3),
  [18055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1722),
  [18057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1705),
  [18059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2349),
  [18061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8184),
  [18063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2350),
  [18065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2356),
  [18067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2222),
  [18069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2198),
  [18071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1571),
  [18073] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declaration_block, 3),
  [18075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2360),
  [18077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8182),
  [18079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1566),
  [18081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2362),
  [18083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2226),
  [18085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8857),
  [18087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2363),
  [18089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2227),
  [18091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1531),
  [18093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2503),
  [18095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8419),
  [18097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2494),
  [18099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1508),
  [18101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2492),
  [18103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2223),
  [18105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2221),
  [18107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8859),
  [18109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2332),
  [18111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8420),
  [18113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2321),
  [18115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2320),
  [18117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2220),
  [18119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2213),
  [18121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2045),
  [18123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1447),
  [18125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2039),
  [18127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2049),
  [18129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8879),
  [18131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1412),
  [18133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2047),
  [18135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2046),
  [18137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1565),
  [18139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1441),
  [18141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1629),
  [18143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2195),
  [18145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8306),
  [18147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2641),
  [18149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8507),
  [18151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2633),
  [18153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2625),
  [18155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2140),
  [18157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2044),
  [18159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8880),
  [18161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2088),
  [18163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2041),
  [18165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2040),
  [18167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2589),
  [18169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8505),
  [18171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2572),
  [18173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2571),
  [18175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1877),
  [18177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1866),
  [18179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1524),
  [18181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8387),
  [18183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1739),
  [18185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1510),
  [18187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1728),
  [18189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7895),
  [18191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1884),
  [18193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8954),
  [18195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1764),
  [18197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1880),
  [18199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1879),
  [18201] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__record_assignments_repeat1, 2),
  [18203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2086),
  [18205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8301),
  [18207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2084),
  [18209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1712),
  [18211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2068),
  [18213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1509),
  [18215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1842),
  [18217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1920),
  [18219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1925),
  [18221] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__record_assignments, 2),
  [18223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1873),
  [18225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8940),
  [18227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1872),
  [18229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1901),
  [18231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8427),
  [18233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1840),
  [18235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1829),
  [18237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2468),
  [18239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8262),
  [18241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2466),
  [18243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2465),
  [18245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1869),
  [18247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12258),
  [18249] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__field_assignments, 1),
  [18251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1507),
  [18253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8386),
  [18255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1505),
  [18257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1504),
  [18259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1740),
  [18261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2442),
  [18263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8263),
  [18265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1729),
  [18267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2433),
  [18269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2431),
  [18271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1797),
  [18273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8432),
  [18275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1795),
  [18277] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record, 4, .production_id = 7),
  [18279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1759),
  [18281] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9450),
  [18283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1726),
  [18285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7898),
  [18287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1720),
  [18289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1719),
  [18291] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9630),
  [18293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1727),
  [18295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9315),
  [18297] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__simple_hole, 1),
  [18299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1718),
  [18301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1428),
  [18303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8439),
  [18305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1426),
  [18307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1418),
  [18309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9312),
  [18311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9311),
  [18313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1445),
  [18315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8187),
  [18317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1398),
  [18319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8441),
  [18321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2351),
  [18323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8165),
  [18325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2340),
  [18327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2333),
  [18329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1399),
  [18331] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8719),
  [18333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1403),
  [18335] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pattern, 4),
  [18337] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unquote_decl, 4),
  [18339] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__application_stmt, 2),
  [18341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1415),
  [18343] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__with_exprs_stmt, 2),
  [18345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2323),
  [18347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8166),
  [18349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2315),
  [18351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2314),
  [18353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1444),
  [18355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1446),
  [18357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8769),
  [18359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1450),
  [18361] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function, 4),
  [18363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1409),
  [18365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8188),
  [18367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1408),
  [18369] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_postulate, 2),
  [18371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1402),
  [18373] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module, 5, .production_id = 6),
  [18375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1497),
  [18377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8458),
  [18379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1498),
  [18381] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_macro, 2),
  [18383] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_signature_block, 3),
  [18385] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_private, 2),
  [18387] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_assignment, 3, .production_id = 5),
  [18389] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record, 5, .production_id = 7),
  [18391] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_declarations_block, 3),
  [18393] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__field_assignments, 2),
  [18395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1511),
  [18397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8464),
  [18399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1512),
  [18401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1515),
  [18403] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract, 2),
  [18405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2257),
  [18407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8122),
  [18409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2242),
  [18411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2239),
  [18413] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_mutual, 2),
  [18415] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generalize, 2),
  [18417] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pattern, 5),
  [18419] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_stmt, 3),
  [18421] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_where, 4),
  [18423] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_integer, 1),
  [18425] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_declarations_block, 4),
  [18427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2234),
  [18429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8121),
  [18431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2232),
  [18433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2231),
  [18435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1449),
  [18437] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record, 6, .production_id = 7),
  [18439] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__import_name, 2),
  [18441] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instance, 2),
  [18443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1561),
  [18445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7857),
  [18447] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_fields, 2),
  [18449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1576),
  [18451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1584),
  [18453] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_stmt, 4),
  [18455] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_data, 7),
  [18457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1592),
  [18459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7846),
  [18461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1595),
  [18463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1573),
  [18465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7950),
  [18467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1574),
  [18469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1596),
  [18471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1581),
  [18473] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_declarations_block, 5),
  [18475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1843),
  [18477] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_renaming, 3),
  [18479] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__simple_hole, 4),
  [18481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2162),
  [18483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8535),
  [18485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2157),
  [18487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2150),
  [18489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1632),
  [18491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7947),
  [18493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1648),
  [18495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8045),
  [18497] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_renaming, 4),
  [18499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1650),
  [18501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1651),
  [18503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1580),
  [18505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2148),
  [18507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8536),
  [18509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2147),
  [18511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2146),
  [18513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1664),
  [18515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1499),
  [18517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1698),
  [18519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8037),
  [18521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1699),
  [18523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1442),
  [18525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1760),
  [18527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7899),
  [18529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1761),
  [18531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1763),
  [18533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1863),
  [18535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8011),
  [18537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1833),
  [18539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7869),
  [18541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1943),
  [18543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8084),
  [18545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1766),
  [18547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7892),
  [18549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1860),
  [18551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1862),
  [18553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1767),
  [18555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1694),
  [18557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1768),
  [18559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2026),
  [18561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7930),
  [18563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2023),
  [18565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2022),
  [18567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1930),
  [18569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1926),
  [18571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1871),
  [18573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8004),
  [18575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1923),
  [18577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8090),
  [18579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1922),
  [18581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2017),
  [18583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7928),
  [18585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2015),
  [18587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1921),
  [18589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2013),
  [18591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6782),
  [18593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1894),
  [18595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1875),
  [18597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1832),
  [18599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1841),
  [18601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1874),
  [18603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5313),
  [18605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8907),
  [18607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7953),
  [18609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6835),
  [18611] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9316),
  [18613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7961),
  [18615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6832),
  [18617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6831),
  [18619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7843),
  [18621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4428),
  [18623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8057),
  [18625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8055),
  [18627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8052),
  [18629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4889),
  [18631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7952),
  [18633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8049),
  [18635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4885),
  [18637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1670),
  [18639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4626),
  [18641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6824),
  [18643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4884),
  [18645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7951),
  [18647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1534),
  [18649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4901),
  [18651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7850),
  [18653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7845),
  [18655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7836),
  [18657] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9215),
  [18659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5708),
  [18661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7828),
  [18663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7852),
  [18665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4440),
  [18667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7933),
  [18669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7287),
  [18671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7833),
  [18673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7929),
  [18675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7849),
  [18677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4450),
  [18679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4456),
  [18681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4867),
  [18683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7925),
  [18685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5010),
  [18687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7924),
  [18689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8473),
  [18691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8472),
  [18693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6842),
  [18695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5692),
  [18697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8471),
  [18699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4855),
  [18701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11702),
  [18703] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9202),
  [18705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5691),
  [18707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1483),
  [18709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8469),
  [18711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8530),
  [18713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4853),
  [18715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4851),
  [18717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4427),
  [18719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5689),
  [18721] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9252),
  [18723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4225),
  [18725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8529),
  [18727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1981),
  [18729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8467),
  [18731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8466),
  [18733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8527),
  [18735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8459),
  [18737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5041),
  [18739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8526),
  [18741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7831),
  [18743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8457),
  [18745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5043),
  [18747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7286),
  [18749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5045),
  [18751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4837),
  [18753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6426),
  [18755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8447),
  [18757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7282),
  [18759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2078),
  [18761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8131),
  [18763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8444),
  [18765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7279),
  [18767] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9382),
  [18769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8134),
  [18771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8136),
  [18773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8482),
  [18775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4237),
  [18777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8116),
  [18779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8438),
  [18781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4244),
  [18783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4246),
  [18785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5060),
  [18787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6517),
  [18789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9062),
  [18791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7298),
  [18793] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9220),
  [18795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8276),
  [18797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7297),
  [18799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8281),
  [18801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7295),
  [18803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8161),
  [18805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8283),
  [18807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6756),
  [18809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2203),
  [18811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1594),
  [18813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7310),
  [18815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8162),
  [18817] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9265),
  [18819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8158),
  [18821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8181),
  [18823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8286),
  [18825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6749),
  [18827] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9400),
  [18829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6745),
  [18831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8159),
  [18833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4191),
  [18835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6257),
  [18837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8434),
  [18839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8433),
  [18841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5687),
  [18843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6176),
  [18845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6175),
  [18847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6173),
  [18849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8429),
  [18851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6536),
  [18853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8260),
  [18855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6171),
  [18857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8258),
  [18859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8426),
  [18861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6551),
  [18863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8255),
  [18865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6552),
  [18867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6746),
  [18869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2617),
  [18871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5077),
  [18873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8253),
  [18875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8180),
  [18877] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9376),
  [18879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6287),
  [18881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4930),
  [18883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7232),
  [18885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7485),
  [18887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8183),
  [18889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6283),
  [18891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7507),
  [18893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8185),
  [18895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6285),
  [18897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8509),
  [18899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1467),
  [18901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7525),
  [18903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6814),
  [18905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6567),
  [18907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8510),
  [18909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6820),
  [18911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8512),
  [18913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8546),
  [18915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8547),
  [18917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1516),
  [18919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8513),
  [18921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7385),
  [18923] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9357),
  [18925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8548),
  [18927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5040),
  [18929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7664),
  [18931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7661),
  [18933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8549),
  [18935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5092),
  [18937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7660),
  [18939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5093),
  [18941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6253),
  [18943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6252),
  [18945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8224),
  [18947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7940),
  [18949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7654),
  [18951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8228),
  [18953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7983),
  [18955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8240),
  [18957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7496),
  [18959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8241),
  [18961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7993),
  [18963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6817),
  [18965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6151),
  [18967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2392),
  [18969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4929),
  [18971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7967),
  [18973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6815),
  [18975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8249),
  [18977] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9325),
  [18979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5104),
  [18981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4928),
  [18983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7708),
  [18985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8246),
  [18987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8144),
  [18989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8149),
  [18991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4926),
  [18993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8247),
  [18995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8248),
  [18997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8042),
  [18999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6187),
  [19001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7809),
  [19003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5849),
  [19005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8150),
  [19007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6132),
  [19009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6333),
  [19011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6108),
  [19013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6807),
  [19015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6106),
  [19017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6150),
  [19019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2659),
  [19021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6149),
  [19023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2393),
  [19025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10078),
  [19027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8211),
  [19029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8212),
  [19031] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9298),
  [19033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9412),
  [19035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9411),
  [19037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9385),
  [19039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6148),
  [19041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8213),
  [19043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7777),
  [19045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8525),
  [19047] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9389),
  [19049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6143),
  [19051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8214),
  [19053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7799),
  [19055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8528),
  [19057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7811),
  [19059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8531),
  [19061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6099),
  [19063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7711),
  [19065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2474),
  [19067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9022),
  [19069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9023),
  [19071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8533),
  [19073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2472),
  [19075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7533),
  [19077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5676),
  [19079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9034),
  [19081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6094),
  [19083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4998),
  [19085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5910),
  [19087] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9270),
  [19089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5905),
  [19091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4946),
  [19093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4948),
  [19095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4950),
  [19097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9041),
  [19099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6092),
  [19101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6088),
  [19103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7718),
  [19105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5622),
  [19107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4949),
  [19109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8227),
  [19111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8229),
  [19113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6107),
  [19115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5675),
  [19117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5880),
  [19119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5866),
  [19121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5861),
  [19123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8230),
  [19125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7741),
  [19127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5862),
  [19129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4369),
  [19131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5674),
  [19133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2327),
  [19135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8231),
  [19137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8484),
  [19139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7732),
  [19141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6002),
  [19143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6055),
  [19145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5672),
  [19147] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9189),
  [19149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6030),
  [19151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5833),
  [19153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5825),
  [19155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7864),
  [19157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7865),
  [19159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5974),
  [19161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4434),
  [19163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7870),
  [19165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5599),
  [19167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4859),
  [19169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8452),
  [19171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6191),
  [19173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6193),
  [19175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6196),
  [19177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6195),
  [19179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7872),
  [19181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5597),
  [19183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5595),
  [19185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7676),
  [19187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7694),
  [19189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4872),
  [19191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8440),
  [19193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2170),
  [19195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8616),
  [19197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8615),
  [19199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4323),
  [19201] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9248),
  [19203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4321),
  [19205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4319),
  [19207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4320),
  [19209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8613),
  [19211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6064),
  [19213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5709),
  [19215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8608),
  [19217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6069),
  [19219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8422),
  [19221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6076),
  [19223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5586),
  [19225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8279),
  [19227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4442),
  [19229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8626),
  [19231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8624),
  [19233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4444),
  [19235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4446),
  [19237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1954),
  [19239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4445),
  [19241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8623),
  [19243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7781),
  [19245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4447),
  [19247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7616),
  [19249] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9256),
  [19251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4866),
  [19253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4863),
  [19255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8622),
  [19257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7791),
  [19259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7795),
  [19261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6074),
  [19263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7678),
  [19265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4861),
  [19267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8278),
  [19269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5992),
  [19271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4514),
  [19273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7224),
  [19275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5572),
  [19277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5571),
  [19279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8282),
  [19281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6020),
  [19283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5720),
  [19285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5722),
  [19287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5724),
  [19289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1830),
  [19291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8285),
  [19293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6005),
  [19295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5723),
  [19297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6006),
  [19299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7794),
  [19301] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9282),
  [19303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5735),
  [19305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5748),
  [19307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5570),
  [19309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8290),
  [19311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8291),
  [19313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8413),
  [19315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4475),
  [19317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4477),
  [19319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8294),
  [19321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7715),
  [19323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4480),
  [19325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4479),
  [19327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8296),
  [19329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7717),
  [19331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4481),
  [19333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7669),
  [19335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6008),
  [19337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7826),
  [19339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5568),
  [19341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8411),
  [19343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1704),
  [19345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7231),
  [19347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8614),
  [19349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8612),
  [19351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7234),
  [19353] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9296),
  [19355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7238),
  [19357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7236),
  [19359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8611),
  [19361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5997),
  [19363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4816),
  [19365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8408),
  [19367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5754),
  [19369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8610),
  [19371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5999),
  [19373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5756),
  [19375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7744),
  [19377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5758),
  [19379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7820),
  [19381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7634),
  [19383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5757),
  [19385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8324),
  [19387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8326),
  [19389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1589),
  [19391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5071),
  [19393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8406),
  [19395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8329),
  [19397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7822),
  [19399] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9309),
  [19401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4511),
  [19403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4513),
  [19405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4515),
  [19407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8332),
  [19409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7608),
  [19411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4117),
  [19413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7819),
  [19415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5951),
  [19417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7842),
  [19419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8313),
  [19421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8314),
  [19423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6251),
  [19425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4953),
  [19427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7748),
  [19429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4802),
  [19431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8316),
  [19433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7612),
  [19435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4797),
  [19437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1474),
  [19439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4794),
  [19441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4795),
  [19443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5717),
  [19445] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9335),
  [19447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8318),
  [19449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7609),
  [19451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7755),
  [19453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7814),
  [19455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5054),
  [19457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8237),
  [19459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8235),
  [19461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5105),
  [19463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5111),
  [19465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5119),
  [19467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5115),
  [19469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1460),
  [19471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8234),
  [19473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4987),
  [19475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4066),
  [19477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7695),
  [19479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8113),
  [19481] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9358),
  [19483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6240),
  [19485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6238),
  [19487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8232),
  [19489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4984),
  [19491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6235),
  [19493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4979),
  [19495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7587),
  [19497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5149),
  [19499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6236),
  [19501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7875),
  [19503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7867),
  [19505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6853),
  [19507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1539),
  [19509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7775),
  [19511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8106),
  [19513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5707),
  [19515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7881),
  [19517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5705),
  [19519] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9381),
  [19521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5153),
  [19523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5357),
  [19525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5704),
  [19527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8598),
  [19529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7873),
  [19531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5155),
  [19533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4146),
  [19535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5156),
  [19537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4981),
  [19539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4760),
  [19541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8103),
  [19543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4119),
  [19545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8597),
  [19547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1662),
  [19549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4115),
  [19551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4116),
  [19553] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9355),
  [19555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8595),
  [19557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4753),
  [19559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4142),
  [19561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8591),
  [19563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4751),
  [19565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8102),
  [19567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4750),
  [19569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5172),
  [19571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7361),
  [19573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8588),
  [19575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6840),
  [19577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1735),
  [19579] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9227),
  [19581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8586),
  [19583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6843),
  [19585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6821),
  [19587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6844),
  [19589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8584),
  [19591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7369),
  [19593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7111),
  [19595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6111),
  [19597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8578),
  [19599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6122),
  [19601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1808),
  [19603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7372),
  [19605] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9221),
  [19607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4133),
  [19609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7374),
  [19611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4741),
  [19613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11858),
  [19615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4131),
  [19617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4129),
  [19619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8958),
  [19621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8956),
  [19623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4130),
  [19625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1933),
  [19627] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9188),
  [19629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4417),
  [19631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8950),
  [19633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11870),
  [19635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6118),
  [19637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8942),
  [19639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11875),
  [19641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4163),
  [19643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11879),
  [19645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7388),
  [19647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4166),
  [19649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2028),
  [19651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4415),
  [19653] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9203),
  [19655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4168),
  [19657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8593),
  [19659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8592),
  [19661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4167),
  [19663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7135),
  [19665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8628),
  [19667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4383),
  [19669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8587),
  [19671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6117),
  [19673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2142),
  [19675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8000),
  [19677] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9222),
  [19679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6937),
  [19681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7106),
  [19683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8377),
  [19685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4351),
  [19687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5637),
  [19689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4333),
  [19691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8805),
  [19693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5530),
  [19695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6862),
  [19697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8567),
  [19699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6909),
  [19701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2293),
  [19703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8566),
  [19705] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9324),
  [19707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4714),
  [19709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6000),
  [19711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8565),
  [19713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5526),
  [19715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8003),
  [19717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4289),
  [19719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4279),
  [19721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8564),
  [19723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5522),
  [19725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4272),
  [19727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2446),
  [19729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5518),
  [19731] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9369),
  [19733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4326),
  [19735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5515),
  [19737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4276),
  [19739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8374),
  [19741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8375),
  [19743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7352),
  [19745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8012),
  [19747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2592),
  [19749] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9326),
  [19751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7155),
  [19753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8854),
  [19755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5502),
  [19757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7147),
  [19759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7175),
  [19761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7176),
  [19763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8383),
  [19765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5500),
  [19767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5498),
  [19769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5499),
  [19771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6917),
  [19773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4704),
  [19775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2612),
  [19777] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9280),
  [19779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8827),
  [19781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8828),
  [19783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8014),
  [19785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8840),
  [19787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6866),
  [19789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4698),
  [19791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4696),
  [19793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4693),
  [19795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2539),
  [19797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4694),
  [19799] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9254),
  [19801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8844),
  [19803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6926),
  [19805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6930),
  [19807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5489),
  [19809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6800),
  [19811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5863),
  [19813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8851),
  [19815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2463),
  [19817] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9395),
  [19819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5654),
  [19821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4137),
  [19823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7901),
  [19825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7345),
  [19827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7444),
  [19829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8858),
  [19831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5648),
  [19833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7427),
  [19835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7428),
  [19837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8862),
  [19839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5651),
  [19841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5653),
  [19843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5445),
  [19845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2378),
  [19847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6951),
  [19849] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9333),
  [19851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5617),
  [19853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4136),
  [19855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8977),
  [19857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8975),
  [19859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4661),
  [19861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4659),
  [19863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4657),
  [19865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2281),
  [19867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8972),
  [19869] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9255),
  [19871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5468),
  [19873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4658),
  [19875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5670),
  [19877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8969),
  [19879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5463),
  [19881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4135),
  [19883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5528),
  [19885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5652),
  [19887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5460),
  [19889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7909),
  [19891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5886),
  [19893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2155),
  [19895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5888),
  [19897] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9297),
  [19899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5891),
  [19901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7900),
  [19903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5890),
  [19905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5295),
  [19907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7912),
  [19909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5230),
  [19911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4128),
  [19913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7903),
  [19915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2065),
  [19917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9474),
  [19919] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9361),
  [19921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5455),
  [19923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5457),
  [19925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5459),
  [19927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7896),
  [19929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5232),
  [19931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5458),
  [19933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5233),
  [19935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5435),
  [19937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5234),
  [19939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3723),
  [19941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5305),
  [19943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7904),
  [19945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1978),
  [19947] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9346),
  [19949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5663),
  [19951] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12034),
  [19953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5658),
  [19955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8901),
  [19957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2426),
  [19959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5656),
  [19961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5615),
  [19963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7633),
  [19965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1891),
  [19967] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9225),
  [19969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7905),
  [19971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8893),
  [19973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5309),
  [19975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8890),
  [19977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5311),
  [19979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8924),
  [19981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5312),
  [19983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7454),
  [19985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4220),
  [19987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8873),
  [19989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1813),
  [19991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8866),
  [19993] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9193),
  [19995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5533),
  [19997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5636),
  [19999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5320),
  [20001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5322),
  [20003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5229),
  [20005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8856),
  [20007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5249),
  [20009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8855),
  [20011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5323),
  [20013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3639),
  [20015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7085),
  [20017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5634),
  [20019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1733),
  [20021] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9204),
  [20023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7558),
  [20025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7553),
  [20027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7463),
  [20029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7547),
  [20031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4318),
  [20033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5632),
  [20035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8367),
  [20037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4197),
  [20039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4125),
  [20041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4193),
  [20043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4194),
  [20045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1666),
  [20047] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9239),
  [20049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4348),
  [20051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5629),
  [20053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8366),
  [20055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7033),
  [20057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7009),
  [20059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6996),
  [20061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6997),
  [20063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7120),
  [20065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8365),
  [20067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4367),
  [20069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4370),
  [20071] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9403),
  [20073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4374),
  [20075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4372),
  [20077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4609),
  [20079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8364),
  [20081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4387),
  [20083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4391),
  [20085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4393),
  [20087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4392),
  [20089] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9337),
  [20091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7196),
  [20093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7786),
  [20095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5618),
  [20097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7146),
  [20099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7149),
  [20101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7166),
  [20103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7164),
  [20105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5600),
  [20107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5616),
  [20109] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9249),
  [20111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4618),
  [20113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4614),
  [20115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4616),
  [20117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7750),
  [20119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4617),
  [20121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6167),
  [20123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8195),
  [20125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7185),
  [20127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7187),
  [20129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7191),
  [20131] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9313),
  [20133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7190),
  [20135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7613),
  [20137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5613),
  [20139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8198),
  [20141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5567),
  [20143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5564),
  [20145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5561),
  [20147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5562),
  [20149] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9279),
  [20151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6004),
  [20153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8201),
  [20155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6146),
  [20157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6141),
  [20159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6138),
  [20161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6140),
  [20163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7551),
  [20165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8202),
  [20167] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9258),
  [20169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7541),
  [20171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7522),
  [20173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7520),
  [20175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7521),
  [20177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5966),
  [20179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6067),
  [20181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7248),
  [20183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7247),
  [20185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6036),
  [20187] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9354),
  [20189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6038),
  [20191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6040),
  [20193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6039),
  [20195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7753),
  [20197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7245),
  [20199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7941),
  [20201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7483),
  [20203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7480),
  [20205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7526),
  [20207] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9268),
  [20209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7476),
  [20211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4627),
  [20213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7242),
  [20215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5940),
  [20217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5936),
  [20219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5934),
  [20221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5935),
  [20223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7398),
  [20225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7979),
  [20227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7793),
  [20229] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9197),
  [20231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7788),
  [20233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7787),
  [20235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4605),
  [20237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4160),
  [20239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7986),
  [20241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8013),
  [20243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4631),
  [20245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4635),
  [20247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4637),
  [20249] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9195),
  [20251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4636),
  [20253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4364),
  [20255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4213),
  [20257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7335),
  [20259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7329),
  [20261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7326),
  [20263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7328),
  [20265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7380),
  [20267] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9332),
  [20269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5023),
  [20271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5024),
  [20273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4198),
  [20275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4200),
  [20277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4203),
  [20279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4201),
  [20281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4205),
  [20283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5025),
  [20285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7921),
  [20287] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9209),
  [20289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4298),
  [20291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4294),
  [20293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4290),
  [20295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4292),
  [20297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5348),
  [20299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5027),
  [20301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7926),
  [20303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4598),
  [20305] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9240),
  [20307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4595),
  [20309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4593),
  [20311] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9246),
  [20313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4594),
  [20315] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9259),
  [20317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5488),
  [20319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7931),
  [20321] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9284),
  [20323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4229),
  [20325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4232),
  [20327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4221),
  [20329] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9303),
  [20331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4234),
  [20333] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9328),
  [20335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7293),
  [20337] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9347),
  [20339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7932),
  [20341] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9370),
  [20343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5280),
  [20345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5278),
  [20347] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9401),
  [20349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5276),
  [20351] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9211),
  [20353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5277),
  [20355] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9219),
  [20357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5869),
  [20359] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9393),
  [20361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5606),
  [20363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4122),
  [20365] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9321),
  [20367] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9260),
  [20369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5483),
  [20371] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9266),
  [20373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5479),
  [20375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5477),
  [20377] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9314),
  [20379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5478),
  [20381] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9213),
  [20383] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9338),
  [20385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5850),
  [20387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4045),
  [20389] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9205),
  [20391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4111),
  [20393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7858),
  [20395] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9353),
  [20397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5824),
  [20399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7414),
  [20401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7316),
  [20403] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9199),
  [20405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7422),
  [20407] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9275),
  [20409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5220),
  [20411] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9295),
  [20413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5829),
  [20415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5827),
  [20417] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9186),
  [20419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5826),
  [20421] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9402),
  [20423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7391),
  [20425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7477),
  [20427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4099),
  [20429] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9336),
  [20431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7868),
  [20433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5816),
  [20435] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9217),
  [20437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5813),
  [20439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5803),
  [20441] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9190),
  [20443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5809),
  [20445] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9230),
  [20447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5802),
  [20449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7871),
  [20451] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9374),
  [20453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5135),
  [20455] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9383),
  [20457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5218),
  [20459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5212),
  [20461] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9365),
  [20463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5213),
  [20465] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9185),
  [20467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5794),
  [20469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7884),
  [20471] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9302),
  [20473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7482),
  [20475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7490),
  [20477] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9273),
  [20479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7556),
  [20481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7498),
  [20483] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9308),
  [20485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4653),
  [20487] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9257),
  [20489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5607),
  [20491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4490),
  [20493] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9285),
  [20495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4491),
  [20497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5788),
  [20499] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9367),
  [20501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5786),
  [20503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5784),
  [20505] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9366),
  [20507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5785),
  [20509] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9390),
  [20511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7435),
  [20513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4495),
  [20515] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9342),
  [20517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8080),
  [20519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4507),
  [20521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5777),
  [20523] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9226),
  [20525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5775),
  [20527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5773),
  [20529] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9192),
  [20531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5774),
  [20533] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9206),
  [20535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5851),
  [20537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8078),
  [20539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8069),
  [20541] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9236),
  [20543] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9363),
  [20545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4690),
  [20547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4695),
  [20549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4703),
  [20551] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9387),
  [20553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4702),
  [20555] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9373),
  [20557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4717),
  [20559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8065),
  [20561] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9360),
  [20563] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9350),
  [20565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7462),
  [20567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7423),
  [20569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7417),
  [20571] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9344),
  [20573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7418),
  [20575] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9331),
  [20577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5918),
  [20579] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9318),
  [20581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7208),
  [20583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4352),
  [20585] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9307),
  [20587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4354),
  [20589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5877),
  [20591] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9235),
  [20593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5911),
  [20595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5919),
  [20597] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9287),
  [20599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5376),
  [20601] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9272),
  [20603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5771),
  [20605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4359),
  [20607] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9261),
  [20609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4384),
  [20611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4727),
  [20613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4744),
  [20615] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9253),
  [20617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4755),
  [20619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9026),
  [20621] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9247),
  [20623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4748),
  [20625] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9244),
  [20627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4559),
  [20629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5090),
  [20631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4540),
  [20633] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9241),
  [20635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4541),
  [20637] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9238),
  [20639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7386),
  [20641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7383),
  [20643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7375),
  [20645] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9233),
  [20647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7378),
  [20649] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9224),
  [20651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7205),
  [20653] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9212),
  [20655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4542),
  [20657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4544),
  [20659] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9201),
  [20661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5746),
  [20663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5743),
  [20665] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9191),
  [20667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5741),
  [20669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5742),
  [20671] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9187),
  [20673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5377),
  [20675] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9281),
  [20677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4085),
  [20679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7599),
  [20681] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9329),
  [20683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7605),
  [20685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4552),
  [20687] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9276),
  [20689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4550),
  [20691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4548),
  [20693] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9375),
  [20695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4549),
  [20697] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9378),
  [20699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5372),
  [20701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7614),
  [20703] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9243),
  [20705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7618),
  [20707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7184),
  [20709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7189),
  [20711] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9300),
  [20713] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_constructor_instance, 4),
  [20715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7193),
  [20717] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9210),
  [20719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7192),
  [20721] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9291),
  [20723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9179),
  [20725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4405),
  [20727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4556),
  [20729] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9301),
  [20731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5959),
  [20733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5960),
  [20735] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9343),
  [20737] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10180),
  [20739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5386),
  [20741] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9294),
  [20743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5384),
  [20745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9670),
  [20747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5382),
  [20749] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9194),
  [20751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10178),
  [20753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5383),
  [20755] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9208),
  [20757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4526),
  [20759] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9223),
  [20761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5962),
  [20763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5964),
  [20765] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9237),
  [20767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5363),
  [20769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5683),
  [20771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9142),
  [20773] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9250),
  [20775] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10172),
  [20777] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9264),
  [20779] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12138),
  [20781] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9274),
  [20783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4306),
  [20785] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9289),
  [20787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5378),
  [20789] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10170),
  [20791] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9304),
  [20793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12146),
  [20795] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9319),
  [20797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4811),
  [20799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4267),
  [20801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7653),
  [20803] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9334),
  [20805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7655),
  [20807] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9349),
  [20809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6388),
  [20811] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_constructor, 2),
  [20813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4304),
  [20815] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9364),
  [20817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4302),
  [20819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4303),
  [20821] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9379),
  [20823] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_signature, 4),
  [20825] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9394),
  [20827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7796),
  [20829] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9386),
  [20831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7656),
  [20833] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_do_where, 2),
  [20835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7659),
  [20837] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9341),
  [20839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4510),
  [20841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4508),
  [20843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4504),
  [20845] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9290),
  [20847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4505),
  [20849] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9231),
  [20851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5388),
  [20853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4569),
  [20855] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9216),
  [20857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7682),
  [20859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9029),
  [20861] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9196),
  [20863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7683),
  [20865] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9198),
  [20867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4819),
  [20869] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9218),
  [20871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12184),
  [20873] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12186),
  [20875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4821),
  [20877] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9245),
  [20879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4828),
  [20881] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10152),
  [20883] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9322),
  [20885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4827),
  [20887] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_signature, 3),
  [20889] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9371),
  [20891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6355),
  [20893] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9384),
  [20895] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__field_assignments_repeat1, 2),
  [20897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2970),
  [20899] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_eta, 1),
  [20901] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9368),
  [20903] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_induction, 1),
  [20905] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12199),
  [20907] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9348),
  [20909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7687),
  [20911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7702),
  [20913] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9320),
  [20915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7807),
  [20917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7783),
  [20919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1756),
  [20921] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9306),
  [20923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7769),
  [20925] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9288),
  [20927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7780),
  [20929] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9269),
  [20931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4291),
  [20933] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_signature, 3),
  [20935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7644),
  [20937] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9200),
  [20939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7745),
  [20941] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9362),
  [20943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5390),
  [20945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5392),
  [20947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5394),
  [20949] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9277),
  [20951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5393),
  [20953] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9262),
  [20955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5395),
  [20957] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9271),
  [20959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6532),
  [20961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7754),
  [20963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7759),
  [20965] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9292),
  [20967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7083),
  [20969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6390),
  [20971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6392),
  [20973] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9305),
  [20975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6391),
  [20977] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9310),
  [20979] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__do_stmt, 2),
  [20981] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9327),
  [20983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5406),
  [20985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5975),
  [20987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6799),
  [20989] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9352),
  [20991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6803),
  [20993] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9359),
  [20995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4331),
  [20997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4270),
  [20999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4336),
  [21001] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9377),
  [21003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4334),
  [21005] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8151),
  [21007] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10699),
  [21009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9141),
  [21011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(318),
  [21013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5790),
  [21015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6804),
  [21017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6811),
  [21019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7761),
  [21021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5410),
  [21023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5412),
  [21025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5414),
  [21027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5413),
  [21029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4983),
  [21031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7630),
  [21033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4068),
  [21035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2137),
  [21037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2134),
  [21039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2106),
  [21041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4086),
  [21043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9012),
  [21045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5424),
  [21047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5427),
  [21049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5439),
  [21051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5437),
  [21053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4725),
  [21055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4082),
  [21057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4104),
  [21059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7113),
  [21061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7108),
  [21063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7105),
  [21065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7107),
  [21067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4571),
  [21069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4892),
  [21071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7778),
  [21073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1794),
  [21075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7336),
  [21077] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10534),
  [21079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7337),
  [21081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(316),
  [21083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5840),
  [21085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5843),
  [21087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5847),
  [21089] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10446),
  [21091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5845),
  [21093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7116),
  [21095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7339),
  [21097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7341),
  [21099] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10352),
  [21101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4970),
  [21103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4965),
  [21105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4955),
  [21107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4963),
  [21109] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10264),
  [21111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4951),
  [21113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7680),
  [21115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4724),
  [21117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7082),
  [21119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7079),
  [21121] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10274),
  [21123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7077),
  [21125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7078),
  [21127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7271),
  [21129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4020),
  [21131] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10337),
  [21133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4723),
  [21135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4721),
  [21137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4846),
  [21139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4906),
  [21141] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_signature, 2),
  [21143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4897),
  [21145] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10392),
  [21147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1985),
  [21149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4905),
  [21151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4015),
  [21153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6827),
  [21155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5987),
  [21157] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10447),
  [21159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5988),
  [21161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7119),
  [21163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7123),
  [21165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7125),
  [21167] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10500),
  [21169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9419),
  [21171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7124),
  [21173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8981),
  [21175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6502),
  [21177] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10553),
  [21179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5989),
  [21181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5991),
  [21183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5021),
  [21185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5030),
  [21187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5082),
  [21189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5031),
  [21191] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10606),
  [21193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12302),
  [21195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4097),
  [21197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4100),
  [21199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7362),
  [21201] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10659),
  [21203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7363),
  [21205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9408),
  [21207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7283),
  [21209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7289),
  [21211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7278),
  [21213] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10712),
  [21215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7277),
  [21217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6177),
  [21219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5879),
  [21221] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10765),
  [21223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7365),
  [21225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7368),
  [21227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4016),
  [21229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4706),
  [21231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4025),
  [21233] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10817),
  [21235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4024),
  [21237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1882),
  [21239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7638),
  [21241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7381),
  [21243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5563),
  [21245] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10865),
  [21247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5560),
  [21249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10082),
  [21251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6537),
  [21253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6539),
  [21255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6541),
  [21257] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10913),
  [21259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6540),
  [21261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1839),
  [21263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4826),
  [21265] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10961),
  [21267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1838),
  [21269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5557),
  [21271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5552),
  [21273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1836),
  [21275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9409),
  [21277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4114),
  [21279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4095),
  [21281] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11009),
  [21283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4091),
  [21285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9043),
  [21287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4092),
  [21289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5061),
  [21291] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11053),
  [21293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5544),
  [21295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7218),
  [21297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9391),
  [21299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7219),
  [21301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5883),
  [21303] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11088),
  [21305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5894),
  [21307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5900),
  [21309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9976),
  [21311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5896),
  [21313] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11123),
  [21315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2),
  [21317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7635),
  [21319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7186),
  [21321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4576),
  [21323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7221),
  [21325] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11158),
  [21327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7627),
  [21329] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9234),
  [21331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7503),
  [21333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7623),
  [21335] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11188),
  [21337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7624),
  [21339] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11210),
  [21341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5068),
  [21343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5969),
  [21345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5259),
  [21347] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11232),
  [21349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5334),
  [21351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4810),
  [21353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4808),
  [21355] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11254),
  [21357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4806),
  [21359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4807),
  [21361] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11276),
  [21363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7597),
  [21365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5260),
  [21367] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11298),
  [21369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5263),
  [21371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1852),
  [21373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5113),
  [21375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5118),
  [21377] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11320),
  [21379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5123),
  [21381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8701),
  [21383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5122),
  [21385] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12386),
  [21387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5513),
  [21389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7404),
  [21391] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11342),
  [21393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7154),
  [21395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7152),
  [21397] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11364),
  [21399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7651),
  [21401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7588),
  [21403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7585),
  [21405] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11386),
  [21407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7586),
  [21409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7487),
  [21411] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11408),
  [21413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7151),
  [21415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7145),
  [21417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5150),
  [21419] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11430),
  [21421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5159),
  [21423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5169),
  [21425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5165),
  [21427] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11452),
  [21429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5146),
  [21431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7563),
  [21433] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11474),
  [21435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7721),
  [21437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7727),
  [21439] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11496),
  [21441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7568),
  [21443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7565),
  [21445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7562),
  [21447] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11518),
  [21449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7572),
  [21451] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11540),
  [21453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7730),
  [21455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7747),
  [21457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5516),
  [21459] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11562),
  [21461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5519),
  [21463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5521),
  [21465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5520),
  [21467] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11584),
  [21469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5184),
  [21471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7229),
  [21473] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11605),
  [21475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6044),
  [21477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6048),
  [21479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7514),
  [21481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7519),
  [21483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7529),
  [21485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7632),
  [21487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7392),
  [21489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6049),
  [21491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6052),
  [21493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5189),
  [21495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5211),
  [21497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5265),
  [21499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5215),
  [21501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5186),
  [21503] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8934),
  [21505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5282),
  [21507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7453),
  [21509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7534),
  [21511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7531),
  [21513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7516),
  [21515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7495),
  [21517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4578),
  [21519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1711),
  [21521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5269),
  [21523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4577),
  [21525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5345),
  [21527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5343),
  [21529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5341),
  [21531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4579),
  [21533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5342),
  [21535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4633),
  [21537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7425),
  [21539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7357),
  [21541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7432),
  [21543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7431),
  [21545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7416),
  [21547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5101),
  [21549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5097),
  [21551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5088),
  [21553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5095),
  [21555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6058),
  [21557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3549),
  [21559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5324),
  [21561] = {.entry = {.count = 1, .reusable = true}},  ACCEPT_INPUT(),
  [21563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(317),
  [21565] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12764),
  [21567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5300),
  [21569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5298),
  [21571] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8074),
  [21573] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8991),
  [21575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5299),
  [21577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7734),
  [21579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4665),
  [21581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4668),
  [21583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4670),
  [21585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4669),
  [21587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7136),
  [21589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7449),
  [21591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7452),
};

enum ts_external_scanner_symbol_identifiers {
  ts_external_token__newline = 0,
  ts_external_token__indent = 1,
  ts_external_token__dedent = 2,
};

static const TSSymbol ts_external_scanner_symbol_map[EXTERNAL_TOKEN_COUNT] = {
  [ts_external_token__newline] = sym__newline,
  [ts_external_token__indent] = sym__indent,
  [ts_external_token__dedent] = sym__dedent,
};

static const bool ts_external_scanner_states[6][EXTERNAL_TOKEN_COUNT] = {
  [1] = {
    [ts_external_token__newline] = true,
    [ts_external_token__indent] = true,
    [ts_external_token__dedent] = true,
  },
  [2] = {
    [ts_external_token__dedent] = true,
  },
  [3] = {
    [ts_external_token__indent] = true,
  },
  [4] = {
    [ts_external_token__newline] = true,
  },
  [5] = {
    [ts_external_token__newline] = true,
    [ts_external_token__indent] = true,
  },
};

#ifdef __cplusplus
extern "C" {
#endif
void *tree_sitter_agda_external_scanner_create(void);
void tree_sitter_agda_external_scanner_destroy(void *);
bool tree_sitter_agda_external_scanner_scan(void *, TSLexer *, const bool *);
unsigned tree_sitter_agda_external_scanner_serialize(void *, char *);
void tree_sitter_agda_external_scanner_deserialize(void *, const char *, unsigned);

#ifdef _WIN32
#define extern __declspec(dllexport)
#endif

extern const TSLanguage *tree_sitter_agda(void) {
  static const TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .state_count = STATE_COUNT,
    .large_state_count = LARGE_STATE_COUNT,
    .production_id_count = PRODUCTION_ID_COUNT,
    .field_count = FIELD_COUNT,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .parse_table = &ts_parse_table[0][0],
    .small_parse_table = ts_small_parse_table,
    .small_parse_table_map = ts_small_parse_table_map,
    .parse_actions = ts_parse_actions,
    .symbol_names = ts_symbol_names,
    .symbol_metadata = ts_symbol_metadata,
    .public_symbol_map = ts_symbol_map,
    .alias_map = ts_non_terminal_alias_map,
    .alias_sequences = &ts_alias_sequences[0][0],
    .lex_modes = ts_lex_modes,
    .lex_fn = ts_lex,
    .keyword_lex_fn = ts_lex_keywords,
    .keyword_capture_token = sym_id,
    .external_scanner = {
      &ts_external_scanner_states[0][0],
      ts_external_scanner_symbol_map,
      tree_sitter_agda_external_scanner_create,
      tree_sitter_agda_external_scanner_destroy,
      tree_sitter_agda_external_scanner_scan,
      tree_sitter_agda_external_scanner_serialize,
      tree_sitter_agda_external_scanner_deserialize,
    },
    .primary_state_ids = ts_primary_state_ids,
  };
  return &language;
}
#ifdef __cplusplus
}
#endif
